(function(){function Lexer(options){this.tokens=[],this.tokens.links={},this.options=options||marked.defaults,this.rules=block.normal,this.options.gfm&&(this.options.tables?this.rules=block.tables:this.rules=block.gfm)}function InlineLexer(links,options){if(this.options=options||marked.defaults,this.links=links,this.rules=inline.normal,this.renderer=this.options.renderer||new Renderer,this.renderer.options=this.options,!this.links)throw new Error("Tokens array requires a `links` property.");this.options.gfm?this.options.breaks?this.rules=inline.breaks:this.rules=inline.gfm:this.options.pedantic&&(this.rules=inline.pedantic)}function Renderer(options){this.options=options||{}}function Parser(options){this.tokens=[],this.token=null,this.options=options||marked.defaults,this.options.renderer=this.options.renderer||new Renderer,this.renderer=this.options.renderer,this.renderer.options=this.options}function escape(html,encode){return html.replace(encode?/&/g:/&(?!#?\w+;)/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;")}function unescape(html){return html.replace(/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/g,function(_,n){return n=n.toLowerCase(),"colon"===n?":":"#"===n.charAt(0)?"x"===n.charAt(1)?String.fromCharCode(parseInt(n.substring(2),16)):String.fromCharCode(+n.substring(1)):""})}function replace(regex,opt){return regex=regex.source,opt=opt||"",function self(name,val){return name?(val=val.source||val,val=val.replace(/(^|[^\[])\^/g,"$1"),regex=regex.replace(name,val),self):new RegExp(regex,opt)}}function noop(){}function merge(obj){for(var target,key,i=1;i<arguments.length;i++){target=arguments[i];for(key in target)Object.prototype.hasOwnProperty.call(target,key)&&(obj[key]=target[key])}return obj}function marked(src,opt,callback){if(callback||"function"==typeof opt){callback||(callback=opt,opt=null),opt=merge({},marked.defaults,opt||{});var tokens,pending,highlight=opt.highlight,i=0;try{tokens=Lexer.lex(src,opt)}catch(e){return callback(e)}pending=tokens.length;var done=function(err){if(err)return opt.highlight=highlight,callback(err);var out;try{out=Parser.parse(tokens,opt)}catch(e){err=e}return opt.highlight=highlight,err?callback(err):callback(null,out)};if(!highlight||highlight.length<3)return done();if(delete opt.highlight,!pending)return done();for(;i<tokens.length;i++)!function(token){return"code"!==token.type?--pending||done():highlight(token.text,token.lang,function(err,code){return err?done(err):null==code||code===token.text?--pending||done():(token.text=code,token.escaped=!0,void(--pending||done()))})}(tokens[i])}else try{return opt&&(opt=merge({},marked.defaults,opt)),Parser.parse(Lexer.lex(src,opt),opt)}catch(e){if(e.message+="\nPlease report this to https://github.com/chjj/marked.",(opt||marked.defaults).silent)return"<p>An error occured:</p><pre>"+escape(e.message+"",!0)+"</pre>";throw e}}var block={newline:/^\n+/,code:/^( {4}[^\n]+\n*)+/,fences:noop,hr:/^( *[-*_]){3,} *(?:\n+|$)/,heading:/^ *(#{1,6}) *([^\n]+?) *#* *(?:\n+|$)/,nptable:noop,lheading:/^([^\n]+)\n *(=|-){2,} *(?:\n+|$)/,blockquote:/^( *>[^\n]+(\n(?!def)[^\n]+)*\n*)+/,list:/^( *)(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?!\1bull )\n*|\s*$)/,html:/^ *(?:comment *(?:\n|\s*$)|closed *(?:\n{2,}|\s*$)|closing *(?:\n{2,}|\s*$))/,def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +["(]([^\n]+)[")])? *(?:\n+|$)/,table:noop,paragraph:/^((?:[^\n]+\n?(?!hr|heading|lheading|blockquote|tag|def))+)\n*/,text:/^[^\n]+/};block.bullet=/(?:[*+-]|\d+\.)/,block.item=/^( *)(bull) [^\n]*(?:\n(?!\1bull )[^\n]*)*/,block.item=replace(block.item,"gm")(/bull/g,block.bullet)(),block.list=replace(block.list)(/bull/g,block.bullet)("hr","\\n+(?=\\1?(?:[-*_] *){3,}(?:\\n+|$))")("def","\\n+(?="+block.def.source+")")(),block.blockquote=replace(block.blockquote)("def",block.def)(),block._tag="(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:/|[^\\w\\s@]*@)\\b",block.html=replace(block.html)("comment",/<!--[\s\S]*?-->/)("closed",/<(tag)[\s\S]+?<\/\1>/)("closing",/<tag(?:"[^"]*"|'[^']*'|[^'">])*?>/)(/tag/g,block._tag)(),block.paragraph=replace(block.paragraph)("hr",block.hr)("heading",block.heading)("lheading",block.lheading)("blockquote",block.blockquote)("tag","<"+block._tag)("def",block.def)(),block.normal=merge({},block),block.gfm=merge({},block.normal,{fences:/^ *(`{3,}|~{3,})[ \.]*(\S+)? *\n([\s\S]*?)\s*\1 *(?:\n+|$)/,paragraph:/^/,heading:/^ *(#{1,6}) +([^\n]+?) *#* *(?:\n+|$)/}),block.gfm.paragraph=replace(block.paragraph)("(?!","(?!"+block.gfm.fences.source.replace("\\1","\\2")+"|"+block.list.source.replace("\\1","\\3")+"|")(),block.tables=merge({},block.gfm,{nptable:/^ *(\S.*\|.*)\n *([-:]+ *\|[-| :]*)\n((?:.*\|.*(?:\n|$))*)\n*/,table:/^ *\|(.+)\n *\|( *[-:]+[-| :]*)\n((?: *\|.*(?:\n|$))*)\n*/}),Lexer.rules=block,Lexer.lex=function(src,options){var lexer=new Lexer(options);return lexer.lex(src)},Lexer.prototype.lex=function(src){return src=src.replace(/\r\n|\r/g,"\n").replace(/\t/g,"    ").replace(/\u00a0/g," ").replace(/\u2424/g,"\n"),this.token(src,!0)},Lexer.prototype.token=function(src,top,bq){for(var next,loose,cap,bull,b,item,space,i,l,src=src.replace(/^ +$/gm,"");src;)if((cap=this.rules.newline.exec(src))&&(src=src.substring(cap[0].length),cap[0].length>1&&this.tokens.push({type:"space"})),cap=this.rules.code.exec(src))src=src.substring(cap[0].length),cap=cap[0].replace(/^ {4}/gm,""),this.tokens.push({type:"code",text:this.options.pedantic?cap:cap.replace(/\n+$/,"")});else if(cap=this.rules.fences.exec(src))src=src.substring(cap[0].length),this.tokens.push({type:"code",lang:cap[2],text:cap[3]||""});else if(cap=this.rules.heading.exec(src))src=src.substring(cap[0].length),this.tokens.push({type:"heading",depth:cap[1].length,text:cap[2]});else if(top&&(cap=this.rules.nptable.exec(src))){for(src=src.substring(cap[0].length),item={type:"table",header:cap[1].replace(/^ *| *\| *$/g,"").split(/ *\| */),align:cap[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:cap[3].replace(/\n$/,"").split("\n")},i=0;i<item.align.length;i++)/^ *-+: *$/.test(item.align[i])?item.align[i]="right":/^ *:-+: *$/.test(item.align[i])?item.align[i]="center":/^ *:-+ *$/.test(item.align[i])?item.align[i]="left":item.align[i]=null;for(i=0;i<item.cells.length;i++)item.cells[i]=item.cells[i].split(/ *\| */);this.tokens.push(item)}else if(cap=this.rules.lheading.exec(src))src=src.substring(cap[0].length),this.tokens.push({type:"heading",depth:"="===cap[2]?1:2,text:cap[1]});else if(cap=this.rules.hr.exec(src))src=src.substring(cap[0].length),this.tokens.push({type:"hr"});else if(cap=this.rules.blockquote.exec(src))src=src.substring(cap[0].length),this.tokens.push({type:"blockquote_start"}),cap=cap[0].replace(/^ *> ?/gm,""),this.token(cap,top,!0),this.tokens.push({type:"blockquote_end"});else if(cap=this.rules.list.exec(src)){for(src=src.substring(cap[0].length),bull=cap[2],this.tokens.push({type:"list_start",ordered:bull.length>1}),cap=cap[0].match(this.rules.item),next=!1,l=cap.length,i=0;i<l;i++)item=cap[i],space=item.length,item=item.replace(/^ *([*+-]|\d+\.) +/,""),~item.indexOf("\n ")&&(space-=item.length,item=this.options.pedantic?item.replace(/^ {1,4}/gm,""):item.replace(new RegExp("^ {1,"+space+"}","gm"),"")),this.options.smartLists&&i!==l-1&&(b=block.bullet.exec(cap[i+1])[0],bull===b||bull.length>1&&b.length>1||(src=cap.slice(i+1).join("\n")+src,i=l-1)),loose=next||/\n\n(?!\s*$)/.test(item),i!==l-1&&(next="\n"===item.charAt(item.length-1),loose||(loose=next)),this.tokens.push({type:loose?"loose_item_start":"list_item_start"}),this.token(item,!1,bq),this.tokens.push({type:"list_item_end"});this.tokens.push({type:"list_end"})}else if(cap=this.rules.html.exec(src))src=src.substring(cap[0].length),this.tokens.push({type:this.options.sanitize?"paragraph":"html",pre:!this.options.sanitizer&&("pre"===cap[1]||"script"===cap[1]||"style"===cap[1]),text:cap[0]});else if(!bq&&top&&(cap=this.rules.def.exec(src)))src=src.substring(cap[0].length),this.tokens.links[cap[1].toLowerCase()]={href:cap[2],title:cap[3]};else if(top&&(cap=this.rules.table.exec(src))){for(src=src.substring(cap[0].length),item={type:"table",header:cap[1].replace(/^ *| *\| *$/g,"").split(/ *\| */),align:cap[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:cap[3].replace(/(?: *\| *)?\n$/,"").split("\n")},i=0;i<item.align.length;i++)/^ *-+: *$/.test(item.align[i])?item.align[i]="right":/^ *:-+: *$/.test(item.align[i])?item.align[i]="center":/^ *:-+ *$/.test(item.align[i])?item.align[i]="left":item.align[i]=null;for(i=0;i<item.cells.length;i++)item.cells[i]=item.cells[i].replace(/^ *\| *| *\| *$/g,"").split(/ *\| */);this.tokens.push(item)}else if(top&&(cap=this.rules.paragraph.exec(src)))src=src.substring(cap[0].length),this.tokens.push({type:"paragraph",text:"\n"===cap[1].charAt(cap[1].length-1)?cap[1].slice(0,-1):cap[1]});else if(cap=this.rules.text.exec(src))src=src.substring(cap[0].length),this.tokens.push({type:"text",text:cap[0]});else if(src)throw new Error("Infinite loop on byte: "+src.charCodeAt(0));return this.tokens};var inline={escape:/^\\([\\`*{}\[\]()#+\-.!_>])/,autolink:/^<([^ >]+(@|:\/)[^ >]+)>/,url:noop,tag:/^<!--[\s\S]*?-->|^<\/?\w+(?:"[^"]*"|'[^']*'|[^'">])*?>/,link:/^!?\[(inside)\]\(href\)/,reflink:/^!?\[(inside)\]\s*\[([^\]]*)\]/,nolink:/^!?\[((?:\[[^\]]*\]|[^\[\]])*)\]/,strong:/^__([\s\S]+?)__(?!_)|^\*\*([\s\S]+?)\*\*(?!\*)/,em:/^\b_((?:[^_]|__)+?)_\b|^\*((?:\*\*|[\s\S])+?)\*(?!\*)/,code:/^(`+)\s*([\s\S]*?[^`])\s*\1(?!`)/,br:/^ {2,}\n(?!\s*$)/,del:noop,text:/^[\s\S]+?(?=[\\<!\[_*`]| {2,}\n|$)/};inline._inside=/(?:\[[^\]]*\]|[^\[\]]|\](?=[^\[]*\]))*/,inline._href=/\s*<?([\s\S]*?)>?(?:\s+['"]([\s\S]*?)['"])?\s*/,inline.link=replace(inline.link)("inside",inline._inside)("href",inline._href)(),inline.reflink=replace(inline.reflink)("inside",inline._inside)(),inline.normal=merge({},inline),inline.pedantic=merge({},inline.normal,{strong:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,em:/^_(?=\S)([\s\S]*?\S)_(?!_)|^\*(?=\S)([\s\S]*?\S)\*(?!\*)/}),inline.gfm=merge({},inline.normal,{escape:replace(inline.escape)("])","~|])")(),url:/^(https?:\/\/[^\s<]+[^<.,:;"')\]\s])/,del:/^~~(?=\S)([\s\S]*?\S)~~/,text:replace(inline.text)("]|","~]|")("|","|https?://|")()}),inline.breaks=merge({},inline.gfm,{br:replace(inline.br)("{2,}","*")(),text:replace(inline.gfm.text)("{2,}","*")()}),InlineLexer.rules=inline,InlineLexer.output=function(src,links,options){var inline=new InlineLexer(links,options);return inline.output(src)},InlineLexer.prototype.output=function(src){for(var link,text,href,cap,out="";src;)if(cap=this.rules.escape.exec(src))src=src.substring(cap[0].length),out+=cap[1];else if(cap=this.rules.autolink.exec(src))src=src.substring(cap[0].length),"@"===cap[2]?(text=":"===cap[1].charAt(6)?this.mangle(cap[1].substring(7)):this.mangle(cap[1]),href=this.mangle("mailto:")+text):(text=escape(cap[1]),href=text),out+=this.renderer.link(href,null,text);else if(this.inLink||!(cap=this.rules.url.exec(src))){if(cap=this.rules.tag.exec(src))!this.inLink&&/^<a /i.test(cap[0])?this.inLink=!0:this.inLink&&/^<\/a>/i.test(cap[0])&&(this.inLink=!1),src=src.substring(cap[0].length),out+=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(cap[0]):escape(cap[0]):cap[0];else if(cap=this.rules.link.exec(src))src=src.substring(cap[0].length),this.inLink=!0,out+=this.outputLink(cap,{href:cap[2],title:cap[3]}),this.inLink=!1;else if((cap=this.rules.reflink.exec(src))||(cap=this.rules.nolink.exec(src))){if(src=src.substring(cap[0].length),link=(cap[2]||cap[1]).replace(/\s+/g," "),link=this.links[link.toLowerCase()],!link||!link.href){out+=cap[0].charAt(0),src=cap[0].substring(1)+src;continue}this.inLink=!0,out+=this.outputLink(cap,link),this.inLink=!1}else if(cap=this.rules.strong.exec(src))src=src.substring(cap[0].length),out+=this.renderer.strong(this.output(cap[2]||cap[1]));else if(cap=this.rules.em.exec(src))src=src.substring(cap[0].length),out+=this.renderer.em(this.output(cap[2]||cap[1]));else if(cap=this.rules.code.exec(src))src=src.substring(cap[0].length),out+=this.renderer.codespan(escape(cap[2],!0));else if(cap=this.rules.br.exec(src))src=src.substring(cap[0].length),out+=this.renderer.br();else if(cap=this.rules.del.exec(src))src=src.substring(cap[0].length),out+=this.renderer.del(this.output(cap[1]));else if(cap=this.rules.text.exec(src))src=src.substring(cap[0].length),out+=this.renderer.text(escape(this.smartypants(cap[0])));else if(src)throw new Error("Infinite loop on byte: "+src.charCodeAt(0))}else src=src.substring(cap[0].length),text=escape(cap[1]),href=text,out+=this.renderer.link(href,null,text);return out},InlineLexer.prototype.outputLink=function(cap,link){var href=escape(link.href),title=link.title?escape(link.title):null;return"!"!==cap[0].charAt(0)?this.renderer.link(href,title,this.output(cap[1])):this.renderer.image(href,title,escape(cap[1]))},InlineLexer.prototype.smartypants=function(text){return this.options.smartypants?text.replace(/---/g,"—").replace(/--/g,"–").replace(/(^|[-\u2014\/(\[{"\s])'/g,"$1‘").replace(/'/g,"’").replace(/(^|[-\u2014\/(\[{\u2018\s])"/g,"$1“").replace(/"/g,"”").replace(/\.{3}/g,"…"):text},InlineLexer.prototype.mangle=function(text){if(!this.options.mangle)return text;for(var ch,out="",l=text.length,i=0;i<l;i++)ch=text.charCodeAt(i),Math.random()>.5&&(ch="x"+ch.toString(16)),out+="&#"+ch+";";return out},Renderer.prototype.code=function(code,lang,escaped){if(this.options.highlight){var out=this.options.highlight(code,lang);null!=out&&out!==code&&(escaped=!0,code=out)}return lang?'<pre><code class="'+this.options.langPrefix+escape(lang,!0)+'">'+(escaped?code:escape(code,!0))+"\n</code></pre>\n":"<pre><code>"+(escaped?code:escape(code,!0))+"\n</code></pre>"},Renderer.prototype.blockquote=function(quote){return"<blockquote>\n"+quote+"</blockquote>\n"},Renderer.prototype.html=function(html){return html},Renderer.prototype.heading=function(text,level,raw){return"<h"+level+' id="'+this.options.headerPrefix+raw.toLowerCase().replace(/[^\w]+/g,"-")+'">'+text+"</h"+level+">\n"},Renderer.prototype.hr=function(){return this.options.xhtml?"<hr/>\n":"<hr>\n"},Renderer.prototype.list=function(body,ordered){var type=ordered?"ol":"ul";return"<"+type+">\n"+body+"</"+type+">\n"},Renderer.prototype.listitem=function(text){return"<li>"+text+"</li>\n"},Renderer.prototype.paragraph=function(text){return"<p>"+text+"</p>\n"},Renderer.prototype.table=function(header,body){return"<table>\n<thead>\n"+header+"</thead>\n<tbody>\n"+body+"</tbody>\n</table>\n"},Renderer.prototype.tablerow=function(content){return"<tr>\n"+content+"</tr>\n"},Renderer.prototype.tablecell=function(content,flags){var type=flags.header?"th":"td",tag=flags.align?"<"+type+' style="text-align:'+flags.align+'">':"<"+type+">";return tag+content+"</"+type+">\n"},Renderer.prototype.strong=function(text){return"<strong>"+text+"</strong>"},Renderer.prototype.em=function(text){return"<em>"+text+"</em>"},Renderer.prototype.codespan=function(text){return"<code>"+text+"</code>"},Renderer.prototype.br=function(){return this.options.xhtml?"<br/>":"<br>"},Renderer.prototype.del=function(text){return"<del>"+text+"</del>"},Renderer.prototype.link=function(href,title,text){if(this.options.sanitize){try{var prot=decodeURIComponent(unescape(href)).replace(/[^\w:]/g,"").toLowerCase()}catch(e){return""}if(0===prot.indexOf("javascript:")||0===prot.indexOf("vbscript:"))return""}var out='<a href="'+href+'"';return title&&(out+=' title="'+title+'"'),out+=">"+text+"</a>"},Renderer.prototype.image=function(href,title,text){var out='<img src="'+href+'" alt="'+text+'"';return title&&(out+=' title="'+title+'"'),out+=this.options.xhtml?"/>":">"},Renderer.prototype.text=function(text){return text},Parser.parse=function(src,options,renderer){var parser=new Parser(options,renderer);return parser.parse(src)},Parser.prototype.parse=function(src){this.inline=new InlineLexer(src.links,this.options,this.renderer),this.tokens=src.reverse();for(var out="";this.next();)out+=this.tok();return out},Parser.prototype.next=function(){return this.token=this.tokens.pop()},Parser.prototype.peek=function(){return this.tokens[this.tokens.length-1]||0},Parser.prototype.parseText=function(){for(var body=this.token.text;"text"===this.peek().type;)body+="\n"+this.next().text;return this.inline.output(body)},Parser.prototype.tok=function(){switch(this.token.type){case"space":return"";case"hr":return this.renderer.hr();case"heading":return this.renderer.heading(this.inline.output(this.token.text),this.token.depth,this.token.text);case"code":return this.renderer.code(this.token.text,this.token.lang,this.token.escaped);case"table":var i,row,cell,flags,j,header="",body="";for(cell="",i=0;i<this.token.header.length;i++)flags={header:!0,align:this.token.align[i]},cell+=this.renderer.tablecell(this.inline.output(this.token.header[i]),{header:!0,align:this.token.align[i]});for(header+=this.renderer.tablerow(cell),i=0;i<this.token.cells.length;i++){for(row=this.token.cells[i],cell="",j=0;j<row.length;j++)cell+=this.renderer.tablecell(this.inline.output(row[j]),{header:!1,align:this.token.align[j]});body+=this.renderer.tablerow(cell)}return this.renderer.table(header,body);case"blockquote_start":for(var body="";"blockquote_end"!==this.next().type;)body+=this.tok();return this.renderer.blockquote(body);case"list_start":for(var body="",ordered=this.token.ordered;"list_end"!==this.next().type;)body+=this.tok();return this.renderer.list(body,ordered);case"list_item_start":for(var body="";"list_item_end"!==this.next().type;)body+="text"===this.token.type?this.parseText():this.tok();return this.renderer.listitem(body);case"loose_item_start":for(var body="";"list_item_end"!==this.next().type;)body+=this.tok();return this.renderer.listitem(body);case"html":var html=this.token.pre||this.options.pedantic?this.token.text:this.inline.output(this.token.text);return this.renderer.html(html);case"paragraph":return this.renderer.paragraph(this.inline.output(this.token.text));case"text":return this.renderer.paragraph(this.parseText())}},noop.exec=noop,marked.options=marked.setOptions=function(opt){return merge(marked.defaults,opt),marked},marked.defaults={gfm:!0,tables:!0,breaks:!1,pedantic:!1,sanitize:!1,sanitizer:null,mangle:!0,smartLists:!1,silent:!1,highlight:null,langPrefix:"lang-",smartypants:!1,headerPrefix:"",renderer:new Renderer,xhtml:!1},marked.Parser=Parser,marked.parser=Parser.parse,marked.Renderer=Renderer,marked.Lexer=Lexer,marked.lexer=Lexer.lex,marked.InlineLexer=InlineLexer,marked.inlineLexer=InlineLexer.output,marked.parse=marked,"undefined"!=typeof module&&"object"==typeof exports?module.exports=marked:"function"==typeof define&&define.amd?define(function(){return marked}):this.marked=marked}).call(function(){return this||("undefined"!=typeof window?window:global)}()),function(root,factory){"object"==typeof exports&&"object"==typeof module?module.exports=factory(require("fs")):"function"==typeof define&&define.amd?define(["fs"],factory):"object"==typeof exports?exports.Parser=factory(require("fs")):(root.RAML=root.RAML||{},root.RAML.Parser=factory(root.fs))}(this,function(__WEBPACK_EXTERNAL_MODULE_44__){return function(modules){function __webpack_require__(moduleId){if(installedModules[moduleId])return installedModules[moduleId].exports;var module=installedModules[moduleId]={exports:{},id:moduleId,loaded:!1};return modules[moduleId].call(module.exports,module,module.exports,__webpack_require__),module.loaded=!0,module.exports}var installedModules={};return __webpack_require__.m=modules,__webpack_require__.c=installedModules,__webpack_require__.p="",__webpack_require__(0)}([function(module,exports,__webpack_require__){"use strict";function loadApiSync(apiPath,arg1,arg2){return apiLoader.loadApi(apiPath,arg1,arg2).getOrElse(null)}function loadRAMLSync(ramlPath,arg1,arg2){return apiLoader.loadApi(ramlPath,arg1,arg2).getOrElse(null)}function optionsForContent(content,arg2){return{fsResolver:{content:function(pathStr){return pathStr==path.resolve("/","#local.raml").replace(/\\/,"/")?content:arg2&&arg2.fsResolver?arg2.fsResolver.content(pathStr):void 0},contentAsync:function(pathStr){return pathStr==path.resolve("/","#local.raml").replace(/\\/,"/")?Promise.resolve(content):arg2&&arg2.fsResolver?arg2.fsResolver.contentAsync(pathStr):void 0}},httpResolver:arg2?arg2.httpResolver:null,rejectOnErrors:!!arg2&&arg2.rejectOnErrors,attributeDefaults:!arg2||arg2.attributeDefaults}}function parseRAMLSync(content,arg2){return apiLoader.loadApi("/#local.raml",[],optionsForContent(content,arg2)).getOrElse(null)}function parseRAML(content,arg2){return apiLoader.loadApiAsync("/#local.raml",[],optionsForContent(content,arg2))}function loadApi(apiPath,arg1,arg2){return apiLoader.loadApiAsync(apiPath,arg1,arg2)}function loadRAML(ramlPath,arg1,arg2){return apiLoader.loadRAMLAsync(ramlPath,arg1,arg2)}function getLanguageElementByRuntimeType(runtimeType){return apiLoader.getLanguageElementByRuntimeType(runtimeType)}function isFragment(node){return exports.api10.isFragment(node)}function asFragment(node){return exports.api10.asFragment(node)}var apiLoader=__webpack_require__(9),path=__webpack_require__(15),PromiseConstructor=__webpack_require__(35);exports.api10=__webpack_require__(12),exports.api08=__webpack_require__(13),exports.loadApiSync=loadApiSync,exports.loadRAMLSync=loadRAMLSync,exports.parseRAMLSync=parseRAMLSync,exports.parseRAML=parseRAML,exports.loadApi=loadApi,exports.loadRAML=loadRAML,exports.getLanguageElementByRuntimeType=getLanguageElementByRuntimeType,exports.isFragment=isFragment,exports.asFragment=asFragment,exports.hl=__webpack_require__(10),exports.ll=__webpack_require__(11),exports.search=__webpack_require__(1),exports.stubs=__webpack_require__(2),exports.utils=__webpack_require__(3),exports.project=__webpack_require__(4),exports.universeHelpers=__webpack_require__(14),exports.ds=__webpack_require__(36),exports.schema=__webpack_require__(5),exports.universes=exports.ds.universesInfo,exports.parser=__webpack_require__(6),exports.expander=__webpack_require__(7),exports.wrapperHelper=__webpack_require__(8),"undefined"==typeof Promise&&"undefined"!=typeof window&&(window.Promise=PromiseConstructor)},function(module,exports,__webpack_require__){"use strict";function determineCompletionKind(text,offset){return search.determineCompletionKind(text,offset)}function enumValues(c,n){return search.enumValues(c,n)}function globalDeclarations(n){return search.globalDeclarations(n)}function qName(n,p){return hlimpl.qName(n,p)}function subTypesWithLocals(t,n){return search.subTypesWithLocals(t,n)}function nodesDeclaringType(t,n){return search.nodesDeclaringType(t,n)}function isExampleNodeContent(n){return search.isExampleNodeContent(n)}function findExampleContentType(n){return search.findExampleContentType(n)}function parseDocumentationContent(n,t){return search.parseDocumentationContent(n,t)}function parseStructuredExample(exampleNode,type){return search.parseStructuredExample(exampleNode,type)}function isExampleNode(node){return search.isExampleNode(node)}function referenceTargets(p0,c){return search.referenceTargets(p0,c)}function findUsages(unit,offset){return search.findUsages(unit,offset)}function findDeclaration(unit,offset,nodePart){return search.findDeclaration(unit,offset,nodePart)}var search=__webpack_require__(23),hlimpl=__webpack_require__(16);!function(LocationKind){LocationKind[LocationKind.VALUE_COMPLETION=0]="VALUE_COMPLETION",LocationKind[LocationKind.KEY_COMPLETION=1]="KEY_COMPLETION",LocationKind[LocationKind.PATH_COMPLETION=2]="PATH_COMPLETION",LocationKind[LocationKind.DIRECTIVE_COMPLETION=3]="DIRECTIVE_COMPLETION",LocationKind[LocationKind.VERSION_COMPLETION=4]="VERSION_COMPLETION",LocationKind[LocationKind.ANNOTATION_COMPLETION=5]="ANNOTATION_COMPLETION",LocationKind[LocationKind.SEQUENCE_KEY_COPLETION=6]="SEQUENCE_KEY_COPLETION",LocationKind[LocationKind.INCOMMENT=7]="INCOMMENT"}(exports.LocationKind||(exports.LocationKind={}));exports.LocationKind;exports.determineCompletionKind=determineCompletionKind,exports.enumValues=enumValues,exports.globalDeclarations=globalDeclarations,exports.qName=qName,exports.subTypesWithLocals=subTypesWithLocals,exports.nodesDeclaringType=nodesDeclaringType,exports.isExampleNodeContent=isExampleNodeContent,exports.findExampleContentType=findExampleContentType,exports.parseDocumentationContent=parseDocumentationContent,exports.parseStructuredExample=parseStructuredExample,exports.isExampleNode=isExampleNode,exports.referenceTargets=referenceTargets,exports.findUsages=findUsages,exports.findDeclaration=findDeclaration},function(module,exports,__webpack_require__){"use strict";function createStubNode(t,p,key,unit){return void 0===key&&(key=null),stubs.createStubNode(t,p,key,unit)}function createStub(parent,property,key){return stubs.createStub(parent,property,key)}function createStubNoParentPatch(parent,property,key){return stubs.createStub0(parent,property,key)}function createResourceStub(parent,key){return stubs.createResourceStub(parent,key)}function createMethodStub(parent,key){return stubs.createMethodStub(parent,key)}function createResponseStub(parent,key){return stubs.createResponseStub(parent,key)}function createBodyStub(parent,key){return stubs.createBodyStub(parent,key)}function createUriParameterStub(parent,key){return stubs.createUriParameterStub(parent,key)}function createQueryParameterStub(parent,key){return stubs.createQueryParameterStub(parent,key)}function createASTPropImpl(node,parent,_def,_prop,fk){return void 0===fk&&(fk=!1),new hlimpl.ASTPropImpl(node,parent,_def,_prop,fk)}function createASTNodeImpl(node,parent,_def,_prop){return new hlimpl.ASTNodeImpl(node,parent,_def,_prop)}function createVirtualASTPropImpl(node,parent,_def,_prop){return new VirtualAttr(node,parent,_def,_prop)}function createVirtualNodeImpl(node,parent,_def,_prop){return new VirtualNode(node,parent,_def,_prop)}function createMapping(name,value){return jsyaml.createMapping(name,value)}function createMap(){return jsyaml.createMap([])}function createAttr(_property,val){return stubs.createAttr(_property,val)}var __extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},hlimpl=__webpack_require__(16),jsyaml=__webpack_require__(27),stubs=__webpack_require__(17);exports.createStubNode=createStubNode,exports.createStub=createStub,exports.createStubNoParentPatch=createStubNoParentPatch,exports.createResourceStub=createResourceStub,exports.createMethodStub=createMethodStub,exports.createResponseStub=createResponseStub,exports.createBodyStub=createBodyStub,exports.createUriParameterStub=createUriParameterStub,exports.createQueryParameterStub=createQueryParameterStub,exports.createASTPropImpl=createASTPropImpl,exports.createASTNodeImpl=createASTNodeImpl,exports.createVirtualASTPropImpl=createVirtualASTPropImpl,exports.createVirtualNodeImpl=createVirtualNodeImpl;var VirtualAttr=function(_super){function VirtualAttr(){_super.apply(this,arguments)}return __extends(VirtualAttr,_super),VirtualAttr.prototype.value=function(){return""},VirtualAttr}(hlimpl.ASTPropImpl),VirtualNode=function(_super){function VirtualNode(){_super.apply(this,arguments)}return __extends(VirtualNode,_super),VirtualNode.prototype.value=function(){return""},VirtualNode}(hlimpl.ASTNodeImpl);exports.createMapping=createMapping,exports.createMap=createMap,exports.createAttr=createAttr},function(module,exports,__webpack_require__){"use strict";function hasAsyncRequests(){return rs.hasAsyncRequests()}function addLoadCallback(x){rs.addLoadCallback(x)}function getTransformerNames(){return expander.getTransformNames()}function getFragmentDefenitionName(node){return hlimpl.getFragmentDefenitionName(node)}function genStructuredValue(name,parent,pr){if(pr.range()instanceof defs.ReferenceType){var mockNode=(pr.range(),jsyaml.createNode(name));return new hlimpl.StructuredValue(mockNode,parent,pr)}return name}function parseUrl(u){return(new linter.UrlParameterNameValidator).parseUrl(u)}var rs=__webpack_require__(28),hlimpl=__webpack_require__(16),defs=__webpack_require__(36),jsyaml=__webpack_require__(27),expander=__webpack_require__(24),linter=__webpack_require__(25),builder=__webpack_require__(26);exports.hasAsyncRequests=hasAsyncRequests,exports.addLoadCallback=addLoadCallback,exports.getTransformerNames=getTransformerNames,exports.updateType=function(node){var type=builder.doDescrimination(node);null==type&&node.property()&&(type=node.property().range()),type&&node.patchType(type)},exports.getFragmentDefenitionName=getFragmentDefenitionName,exports.genStructuredValue=genStructuredValue,exports.parseUrl=parseUrl},function(module,exports,__webpack_require__){"use strict";function createProject(path,r,h){return new limpl.Project(path,r,h)}var limpl=__webpack_require__(27);exports.createProject=createProject},function(module,exports,__webpack_require__){"use strict";function createSchema(c,u){return su.createSchema(c,new contentprovider.ContentProvider(u))}function getXMLSchema(c){return su.getXMLSchema(c)}function getJSONSchema(c,u){return su.getJSONSchema(c,new contentprovider.ContentProvider(u))}function completeReference(includePath,includeReference,content){return refResolvers.completeReference(includePath,includeReference,content)}function getIncludePath(p){return refResolvers.getIncludePath(p)}function getIncludeReference(p){return refResolvers.getIncludeReference(p)}function createSchemaModelGenerator(){return new schemaGenImpl.SchemaToModelGenerator}function createModelToSchemaGenerator(){return new schemaGenImpl.ModelToSchemaGenerator}var def=__webpack_require__(36),refResolvers=__webpack_require__(29),schemaGenImpl=__webpack_require__(18),contentprovider=__webpack_require__(30),su=def.getSchemaUtils();exports.createSchema=createSchema,exports.getXMLSchema=getXMLSchema,exports.getJSONSchema=getJSONSchema,exports.completeReference=completeReference,exports.getIncludePath=getIncludePath,exports.getIncludeReference=getIncludeReference,exports.createSchemaModelGenerator=createSchemaModelGenerator,exports.createModelToSchemaGenerator=createModelToSchemaGenerator},function(module,exports,__webpack_require__){"use strict";exports.modify=__webpack_require__(19)},function(module,exports,__webpack_require__){"use strict";function expandTraitsAndResourceTypes(api){return ex.expandTraitsAndResourceTypes(api)}var ex=__webpack_require__(24);exports.expandTraitsAndResourceTypes=expandTraitsAndResourceTypes},function(module,exports,__webpack_require__){"use strict";function completeRelativeUri(res){return wh.completeRelativeUri(res)}var wh=__webpack_require__(32);exports.completeRelativeUri=completeRelativeUri},function(module,exports,__webpack_require__){"use strict";function loadApi(apiPath,arg1,arg2){var api=loadRAMLInternal(apiPath,arg1,arg2);return new Opt(api)}function loadRAML(ramlPath,arg1,arg2){var result=loadRAMLInternal(ramlPath,arg1,arg2);return new Opt(result)}function loadRAMLInternal(apiPath,arg1,arg2){var gotArray=Array.isArray(arg1),extensionsAndOverlays=gotArray?arg1:null,options=gotArray?arg2:arg1;options=options||{};var project=getProject(apiPath,options),pr=apiPath.indexOf("://"),unitName=pr!=-1&&pr<6?apiPath:path.basename(apiPath),unit=project.unit(unitName);arg2&&!extensionsAndOverlays&&(extensionsAndOverlays=null);var api;if(unit)if(extensionsAndOverlays&&extensionsAndOverlays.length>0){var extensionUnits=[];extensionsAndOverlays.forEach(function(currentPath){if(!currentPath||0==currentPath.trim().length)throw new Error("Extensions and overlays list should contain legal file paths")}),extensionsAndOverlays.forEach(function(unitPath){extensionUnits.push(project.unit(path.basename(unitPath)))}),extensionUnits.forEach(function(extensionUnit){return toApi(extensionUnit,options)}),api=toApi(expander.mergeAPIs(unit,extensionUnits,hlimpl.OverlayMergeMode.MERGE),options);
}else api=toApi(unit,options),api.highLevel().setMergeMode(hlimpl.OverlayMergeMode.MERGE);if(!unit)throw new Error("Can not resolve :"+apiPath);if(options.rejectOnErrors&&api&&api.errors().filter(function(x){return!x.isWarning}).length)throw toError(api);return null!=options.attributeDefaults&&api?api.setAttributeDefaults(options.attributeDefaults):api&&api.setAttributeDefaults(!0),api}function loadApiAsync(apiPath,arg1,arg2){var ramlPromise=loadRAMLAsync(apiPath,arg1,arg2);return ramlPromise.then(function(loadedRaml){return loadedRaml})}function loadRAMLAsync(ramlPath,arg1,arg2){var gotArray=Array.isArray(arg1),extensionsAndOverlays=gotArray?arg1:null,options=gotArray?arg2:arg1;options=options||{};var project=getProject(ramlPath,options),pr=ramlPath.indexOf("://"),unitName=pr!=-1&&pr<6?ramlPath:path.basename(ramlPath);return arg2&&!extensionsAndOverlays&&(extensionsAndOverlays=null),extensionsAndOverlays&&0!=extensionsAndOverlays.length?(extensionsAndOverlays.forEach(function(currentPath){if(!currentPath||0==currentPath.trim().length)throw new Error("Extensions and overlays list should contain legal file paths")}),fetchAndLoadApiAsync(project,unitName,options).then(function(masterApi){var apiPromises=[];return extensionsAndOverlays.forEach(function(extensionUnitPath){apiPromises.push(fetchAndLoadApiAsync(project,path.basename(extensionUnitPath),options))}),Promise.all(apiPromises).then(function(apis){var overlayUnits=[];apis.forEach(function(currentApi){return overlayUnits.push(currentApi.highLevel().lowLevel().unit())});var result=expander.mergeAPIs(masterApi.highLevel().lowLevel().unit(),overlayUnits,hlimpl.OverlayMergeMode.MERGE);return null!=options.attributeDefaults&&result?result.setAttributeDefaults(options.attributeDefaults):result&&result.setAttributeDefaults(!0),result}).then(function(mergedHighLevel){return toApi(mergedHighLevel,options)})})):fetchAndLoadApiAsync(project,unitName,options).then(function(masterApi){return masterApi.highLevel().setMergeMode(hlimpl.OverlayMergeMode.MERGE),null!=options.attributeDefaults&&masterApi?masterApi.setAttributeDefaults(options.attributeDefaults):masterApi&&masterApi.setAttributeDefaults(!0),masterApi})}function getLanguageElementByRuntimeType(runtimeType){if(null==runtimeType)return null;var highLevelNode=runtimeType.getAdapter(ramlServices.RAMLService).getDeclaringNode();return null==highLevelNode?null:highLevelNode.wrapperNode()}function fetchAndLoadApiAsync(project,unitName,options){return llimpl.fetchIncludesAndMasterAsync(project,unitName).then(function(x){try{var api=toApi(x,options);return options.rejectOnErrors&&api&&api.errors().filter(function(x){return!x.isWarning}).length?Promise.reject(toError(api)):api}catch(err){return Promise.reject(err)}})}function getProject(apiPath,options){options=options||{};var includeResolver=options.fsResolver,httpResolver=options.httpResolver,projectRoot=path.dirname(apiPath),project=new jsyaml.Project(projectRoot,includeResolver,httpResolver);return project}function toApi(unitOrHighlevel,options,checkApisOverlays){if(void 0===checkApisOverlays&&(checkApisOverlays=!1),!unitOrHighlevel)return null;var unit=null,highLevel=null;unitOrHighlevel.isRAMLUnit?unit=unitOrHighlevel:(highLevel=unitOrHighlevel,unit=highLevel.lowLevel().unit());var api,contents=unit.contents(),ramlFirstLine=hlimpl.ramlFirstLine(contents);if(!ramlFirstLine)throw new Error("Invalid first line. A RAML document is expected to start with '#%RAML <version> <?fragment type>'.");var typeName,ramlVersion,verStr=ramlFirstLine[1];ramlFirstLine[2];if("0.8"==verStr?ramlVersion="RAML08":"1.0"==verStr&&(ramlVersion="RAML10"),!ramlVersion)throw new Error("Unknown version of RAML expected to see one of '#%RAML 0.8' or '#%RAML 1.0'");if("RAML08"==ramlVersion&&checkApisOverlays)throw new Error("Extensions and overlays are not supported in RAML 0.8.");var universe=universeProvider(ramlVersion);universe.type(typeName);return highLevel||(highLevel=hlimpl.fromUnit(unit)),api=highLevel.wrapperNode()}function toError(api){var error=new Error("Api contains errors.");return error.parserErrors=api.errors(),error}function loadApis1(projectRoot,cacheChildren,expandTraitsAndResourceTypes){void 0===cacheChildren&&(cacheChildren=!1),void 0===expandTraitsAndResourceTypes&&(expandTraitsAndResourceTypes=!0);var universe=universeProvider("RAML10"),apiType=universe.type(universeDef.Universe10.Api.name),p=new jsyaml.Project(projectRoot),result=[];return p.units().forEach(function(x){var lowLevel=x.ast();cacheChildren&&(lowLevel=llimpl.toChildCachingNode(lowLevel));var api=new RamlWrapper1Impl.ApiImpl(new hlimpl.ASTNodeImpl(lowLevel,null,apiType,null));expandTraitsAndResourceTypes&&(api=expander.expandTraitsAndResourceTypes(api)),result.push(api)}),result}var RamlWrapper1Impl=__webpack_require__(20),path=__webpack_require__(15),Opt=__webpack_require__(21),jsyaml=__webpack_require__(27),hlimpl=__webpack_require__(16),llimpl=__webpack_require__(27),expander=__webpack_require__(24),universeDef=__webpack_require__(22),ramlServices=__webpack_require__(33),universeProvider=__webpack_require__(34);exports.loadApi=loadApi,exports.loadRAML=loadRAML,exports.loadApiAsync=loadApiAsync,exports.loadRAMLAsync=loadRAMLAsync,exports.getLanguageElementByRuntimeType=getLanguageElementByRuntimeType,exports.toError=toError,exports.loadApis1=loadApis1},function(module,exports,__webpack_require__){"use strict";function isParseResult(object){return object.asElement&&object.getKind&&object.asAttr&&object.lowLevel}!function(NodeKind){NodeKind[NodeKind.BASIC=0]="BASIC",NodeKind[NodeKind.NODE=1]="NODE",NodeKind[NodeKind.ATTRIBUTE=2]="ATTRIBUTE"}(exports.NodeKind||(exports.NodeKind={}));exports.NodeKind;!function(RAMLVersion){RAMLVersion[RAMLVersion.RAML10=0]="RAML10",RAMLVersion[RAMLVersion.RAML08=1]="RAML08"}(exports.RAMLVersion||(exports.RAMLVersion={}));exports.RAMLVersion;exports.isParseResult=isParseResult,function(IssueCode){IssueCode[IssueCode.UNRESOLVED_REFERENCE=0]="UNRESOLVED_REFERENCE",IssueCode[IssueCode.YAML_ERROR=1]="YAML_ERROR",IssueCode[IssueCode.UNKNOWN_NODE=2]="UNKNOWN_NODE",IssueCode[IssueCode.MISSING_REQUIRED_PROPERTY=3]="MISSING_REQUIRED_PROPERTY",IssueCode[IssueCode.PROPERTY_EXPECT_TO_HAVE_SINGLE_VALUE=4]="PROPERTY_EXPECT_TO_HAVE_SINGLE_VALUE",IssueCode[IssueCode.KEY_SHOULD_BE_UNIQUE_INTHISCONTEXT=5]="KEY_SHOULD_BE_UNIQUE_INTHISCONTEXT",IssueCode[IssueCode.UNABLE_TO_RESOLVE_INCLUDE_FILE=6]="UNABLE_TO_RESOLVE_INCLUDE_FILE",IssueCode[IssueCode.INVALID_VALUE_SCHEMA=7]="INVALID_VALUE_SCHEMA",IssueCode[IssueCode.MISSED_CONTEXT_REQUIREMENT=8]="MISSED_CONTEXT_REQUIREMENT",IssueCode[IssueCode.NODE_HAS_VALUE=9]="NODE_HAS_VALUE",IssueCode[IssueCode.ONLY_OVERRIDE_ALLOWED=10]="ONLY_OVERRIDE_ALLOWED",IssueCode[IssueCode.ILLEGAL_PROPERTY_VALUE=11]="ILLEGAL_PROPERTY_VALUE",IssueCode[IssueCode.ILLEGAL_PROPERTY=12]="ILLEGAL_PROPERTY",IssueCode[IssueCode.INVALID_PROPERTY=13]="INVALID_PROPERTY"}(exports.IssueCode||(exports.IssueCode={}));exports.IssueCode},function(module,exports,__webpack_require__){"use strict";function setAttr(t,value){return new ASTChangeCommand(CommandKind.CHANGE_VALUE,t,value,(-1))}function setAttrStructured(t,value){return new ASTChangeCommand(CommandKind.CHANGE_VALUE,t,value.lowLevel(),(-1))}function setKey(t,value){return new ASTChangeCommand(CommandKind.CHANGE_KEY,t,value,(-1))}function removeNode(t,child){return new ASTChangeCommand(CommandKind.REMOVE_CHILD,t,child,(-1))}function insertNode(t,child,insertAfter,toSeq){void 0===insertAfter&&(insertAfter=null),void 0===toSeq&&(toSeq=!1);var s=new ASTChangeCommand(CommandKind.ADD_CHILD,t,child,(-1));return s.insertionPoint=insertAfter,s.toSeq=toSeq,s}function initRamlFile(root,newroot){return new ASTChangeCommand(CommandKind.INIT_RAML_FILE,root,newroot,(-1))}function buildPath(reference,unitPath,rootPath){if(path.isAbsolute(reference)){var e=path.extname(unitPath);".xsd"!=e&&(reference=reference.substr(1),unitPath=toAbsolutePath(rootPath,path.basename(unitPath)))}return isWebPath(reference)||path.isAbsolute(reference)?reference:isWebPath(unitPath)||path.isAbsolute(unitPath)?toAbsolutePath(path.dirname(unitPath),reference):toAbsolutePath(path.dirname(toAbsolutePath(rootPath,unitPath)),reference)}function toAbsolutePath(context,reference){if(isWebPath(reference))return reference;var apath;if(isWebPath(context)){var rp=util.stringEndsWith(context,"/")?context:context+"/";apath=URL.resolve(rp,reference).replace(/\\/g,"/")}else apath=path.resolve(context,reference).replace(/\\/g,"/");return apath}function isWebPath(reference){return null!=reference&&(util.stringStartsWith(reference,"http://")||util.stringStartsWith(reference,"https://"))}function isLowLevelNode(object){return object.start&&object.end&&object.unit&&object.key&&object.value&&object.children&&object.includePath}var path=__webpack_require__(15),URL=__webpack_require__(37),util=__webpack_require__(31),ASTDelta=function(){function ASTDelta(){}return ASTDelta}();exports.ASTDelta=ASTDelta,function(CommandKind){CommandKind[CommandKind.ADD_CHILD=0]="ADD_CHILD",CommandKind[CommandKind.REMOVE_CHILD=1]="REMOVE_CHILD",CommandKind[CommandKind.MOVE_CHILD=2]="MOVE_CHILD",CommandKind[CommandKind.CHANGE_KEY=3]="CHANGE_KEY",CommandKind[CommandKind.CHANGE_VALUE=4]="CHANGE_VALUE",CommandKind[CommandKind.INIT_RAML_FILE=5]="INIT_RAML_FILE"}(exports.CommandKind||(exports.CommandKind={}));var CommandKind=exports.CommandKind,TextChangeCommand=function(){function TextChangeCommand(offset,replacementLength,text,unit,target){void 0===target&&(target=null),this.offset=offset,this.replacementLength=replacementLength,this.text=text,this.unit=unit,this.target=target}return TextChangeCommand}();exports.TextChangeCommand=TextChangeCommand;var CompositeCommand=function(){function CompositeCommand(){this.commands=[]}return CompositeCommand}();exports.CompositeCommand=CompositeCommand,function(InsertionPointType){InsertionPointType[InsertionPointType.NONE=0]="NONE",InsertionPointType[InsertionPointType.START=1]="START",InsertionPointType[InsertionPointType.END=2]="END",InsertionPointType[InsertionPointType.POINT=3]="POINT"}(exports.InsertionPointType||(exports.InsertionPointType={}));var ASTChangeCommand=(exports.InsertionPointType,function(){function ASTChangeCommand(kind,target,value,position){this.toSeq=!1,this.kind=kind,this.target=target,this.value=value,this.position=position}return ASTChangeCommand}());exports.ASTChangeCommand=ASTChangeCommand,exports.setAttr=setAttr,exports.setAttrStructured=setAttrStructured,exports.setKey=setKey,exports.removeNode=removeNode,exports.insertNode=insertNode,exports.initRamlFile=initRamlFile;var LineMapperImpl=function(){function LineMapperImpl(content,absPath){this.content=content,this.absPath=absPath}return LineMapperImpl.prototype.position=function(_pos){var pos=_pos;this.initMapping();for(var i=0;i<this.mapping.length;i++){var lineLength=this.mapping[i];if(pos<lineLength)return{line:i,column:pos,position:_pos};pos-=lineLength}if(0==pos)return{line:this.mapping.length-1,column:this.mapping[this.mapping.length-1],position:this.content.length};if(1==pos)return{line:this.mapping.length-1,column:this.mapping[this.mapping.length-1]-1,position:_pos-1};throw new Error("Character position exceeds text length: "+_pos+" > + "+this.content.length+".\nUnit path: "+this.absPath)},LineMapperImpl.prototype.initMapping=function(){if(null==this.mapping){if(null==this.content)throw new Error("Line Mapper has been given null content"+(null!=this.absPath?". Path: "+this.absPath:" and null path."));this.mapping=[];for(var ind=0,l=this.content.length,i=0;i<l;i++)"\r"==this.content.charAt(i)?i<l-1&&"\n"==this.content.charAt(i+1)?(this.mapping.push(i-ind+2),ind=i+2,i++):(this.mapping.push(i-ind+1),ind=i+1):"\n"==this.content.charAt(i)&&(this.mapping.push(i-ind+1),ind=i+1);this.mapping.push(l-ind)}},LineMapperImpl}();exports.LineMapperImpl=LineMapperImpl,exports.buildPath=buildPath,exports.toAbsolutePath=toAbsolutePath,exports.isWebPath=isWebPath,exports.isLowLevelNode=isLowLevelNode},function(module,exports,__webpack_require__){"use strict";function isApi(node){return"Api"==node.kind()&&"RAML10"==node.RAMLVersion()}function isLibraryBase(node){return"LibraryBase"==node.kind()&&"RAML10"==node.RAMLVersion()}function isAnnotable(node){return"Annotable"==node.kind()&&"RAML10"==node.RAMLVersion()}function isAnnotationRef(node){return"AnnotationRef"==node.kind()&&"RAML10"==node.RAMLVersion()}function isReference(node){return"Reference"==node.kind()&&"RAML10"==node.RAMLVersion()}function isValueType(node){return"ValueType"==node.kind()&&"RAML10"==node.RAMLVersion()}function isStringType(node){return"StringType"==node.kind()&&"RAML10"==node.RAMLVersion()}function isUriTemplate(node){return"UriTemplate"==node.kind()&&"RAML10"==node.RAMLVersion()}function isRelativeUriString(node){return"RelativeUriString"==node.kind()&&"RAML10"==node.RAMLVersion()}function isFullUriTemplateString(node){return"FullUriTemplateString"==node.kind()&&"RAML10"==node.RAMLVersion()}function isStatusCodeString(node){return"StatusCodeString"==node.kind()&&"RAML10"==node.RAMLVersion()}function isFixedUriString(node){return"FixedUriString"==node.kind()&&"RAML10"==node.RAMLVersion()}function isContentType(node){return"ContentType"==node.kind()&&"RAML10"==node.RAMLVersion()}function isMarkdownString(node){return"MarkdownString"==node.kind()&&"RAML10"==node.RAMLVersion()}function isSchemaString(node){return"SchemaString"==node.kind()&&"RAML10"==node.RAMLVersion()}function isMimeType(node){return"MimeType"==node.kind()&&"RAML10"==node.RAMLVersion()}function isAnyType(node){return"AnyType"==node.kind()&&"RAML10"==node.RAMLVersion()}function isNumberType(node){return"NumberType"==node.kind()&&"RAML10"==node.RAMLVersion()}function isIntegerType(node){return"IntegerType"==node.kind()&&"RAML10"==node.RAMLVersion()}function isNullType(node){return"NullType"==node.kind()&&"RAML10"==node.RAMLVersion()}function isTimeOnlyType(node){return"TimeOnlyType"==node.kind()&&"RAML10"==node.RAMLVersion()}function isDateOnlyType(node){return"DateOnlyType"==node.kind()&&"RAML10"==node.RAMLVersion()}function isDateTimeOnlyType(node){return"DateTimeOnlyType"==node.kind()&&"RAML10"==node.RAMLVersion()}function isDateTimeType(node){return"DateTimeType"==node.kind()&&"RAML10"==node.RAMLVersion()}function isFileType(node){return"FileType"==node.kind()&&"RAML10"==node.RAMLVersion()}function isBooleanType(node){return"BooleanType"==node.kind()&&"RAML10"==node.RAMLVersion()}function isAnnotationTarget(node){return"AnnotationTarget"==node.kind()&&"RAML10"==node.RAMLVersion()}function isTraitRef(node){return"TraitRef"==node.kind()&&"RAML10"==node.RAMLVersion()}function isTrait(node){return"Trait"==node.kind()&&"RAML10"==node.RAMLVersion()}function isMethodBase(node){return"MethodBase"==node.kind()&&"RAML10"==node.RAMLVersion()}function isOperation(node){return"Operation"==node.kind()&&"RAML10"==node.RAMLVersion()}function isTypeDeclaration(node){return"TypeDeclaration"==node.kind()&&"RAML10"==node.RAMLVersion()}function isModelLocation(node){return"ModelLocation"==node.kind()&&"RAML10"==node.RAMLVersion()}function isLocationKind(node){return"LocationKind"==node.kind()&&"RAML10"==node.RAMLVersion()}function isExampleSpec(node){return"ExampleSpec"==node.kind()&&"RAML10"==node.RAMLVersion()}function isUsesDeclaration(node){return"UsesDeclaration"==node.kind()&&"RAML10"==node.RAMLVersion()}function isXMLFacetInfo(node){return"XMLFacetInfo"==node.kind()&&"RAML10"==node.RAMLVersion()}function isArrayTypeDeclaration(node){return"ArrayTypeDeclaration"==node.kind()&&"RAML10"==node.RAMLVersion()}function isUnionTypeDeclaration(node){return"UnionTypeDeclaration"==node.kind()&&"RAML10"==node.RAMLVersion()}function isObjectTypeDeclaration(node){return"ObjectTypeDeclaration"==node.kind()&&"RAML10"==node.RAMLVersion()}function isStringTypeDeclaration(node){return"StringTypeDeclaration"==node.kind()&&"RAML10"==node.RAMLVersion()}function isBooleanTypeDeclaration(node){return"BooleanTypeDeclaration"==node.kind()&&"RAML10"==node.RAMLVersion()}function isNumberTypeDeclaration(node){return"NumberTypeDeclaration"==node.kind()&&"RAML10"==node.RAMLVersion()}function isIntegerTypeDeclaration(node){return"IntegerTypeDeclaration"==node.kind()&&"RAML10"==node.RAMLVersion()}function isDateOnlyTypeDeclaration(node){return"DateOnlyTypeDeclaration"==node.kind()&&"RAML10"==node.RAMLVersion()}function isTimeOnlyTypeDeclaration(node){return"TimeOnlyTypeDeclaration"==node.kind()&&"RAML10"==node.RAMLVersion()}function isDateTimeOnlyTypeDeclaration(node){return"DateTimeOnlyTypeDeclaration"==node.kind()&&"RAML10"==node.RAMLVersion()}function isDateTimeTypeDeclaration(node){return"DateTimeTypeDeclaration"==node.kind()&&"RAML10"==node.RAMLVersion()}function isDateTypeDeclaration(node){return"DateTypeDeclaration"==node.kind()&&"RAML10"==node.RAMLVersion()}function isFileTypeDeclaration(node){return"FileTypeDeclaration"==node.kind()&&"RAML10"==node.RAMLVersion()}function isResponse(node){return"Response"==node.kind()&&"RAML10"==node.RAMLVersion()}function isSecuritySchemePart(node){return"SecuritySchemePart"==node.kind()&&"RAML10"==node.RAMLVersion()}function isSecuritySchemeRef(node){return"SecuritySchemeRef"==node.kind()&&"RAML10"==node.RAMLVersion()}function isAbstractSecurityScheme(node){return"AbstractSecurityScheme"==node.kind()&&"RAML10"==node.RAMLVersion()}function isSecuritySchemeSettings(node){return"SecuritySchemeSettings"==node.kind()&&"RAML10"==node.RAMLVersion()}function isOAuth1SecuritySchemeSettings(node){return"OAuth1SecuritySchemeSettings"==node.kind()&&"RAML10"==node.RAMLVersion()}function isOAuth2SecuritySchemeSettings(node){return"OAuth2SecuritySchemeSettings"==node.kind()&&"RAML10"==node.RAMLVersion()}function isOAuth2SecurityScheme(node){return"OAuth2SecurityScheme"==node.kind()&&"RAML10"==node.RAMLVersion()}function isOAuth1SecurityScheme(node){return"OAuth1SecurityScheme"==node.kind()&&"RAML10"==node.RAMLVersion()}function isPassThroughSecurityScheme(node){return"PassThroughSecurityScheme"==node.kind()&&"RAML10"==node.RAMLVersion()}function isBasicSecurityScheme(node){return"BasicSecurityScheme"==node.kind()&&"RAML10"==node.RAMLVersion()}function isDigestSecurityScheme(node){return"DigestSecurityScheme"==node.kind()&&"RAML10"==node.RAMLVersion()}function isCustomSecurityScheme(node){return"CustomSecurityScheme"==node.kind()&&"RAML10"==node.RAMLVersion()}function isMethod(node){return"Method"==node.kind()&&"RAML10"==node.RAMLVersion()}function isResourceTypeRef(node){return"ResourceTypeRef"==node.kind()&&"RAML10"==node.RAMLVersion()}function isResourceType(node){return"ResourceType"==node.kind()&&"RAML10"==node.RAMLVersion()}function isResourceBase(node){return"ResourceBase"==node.kind()&&"RAML10"==node.RAMLVersion()}function isResource(node){return"Resource"==node.kind()&&"RAML10"==node.RAMLVersion()}function isDocumentationItem(node){return"DocumentationItem"==node.kind()&&"RAML10"==node.RAMLVersion()}function isLibrary(node){return"Library"==node.kind()&&"RAML10"==node.RAMLVersion()}function isOverlay(node){return"Overlay"==node.kind()&&"RAML10"==node.RAMLVersion()}function isExtension(node){return"Extension"==node.kind()&&"RAML10"==node.RAMLVersion()}function isFragment(node){return null==node.highLevel().parent()}function asFragment(node){return isFragment(node)?node:null}exports.isApi=isApi,exports.isLibraryBase=isLibraryBase,exports.isAnnotable=isAnnotable,exports.isAnnotationRef=isAnnotationRef,exports.isReference=isReference,exports.isValueType=isValueType,exports.isStringType=isStringType,exports.isUriTemplate=isUriTemplate,exports.isRelativeUriString=isRelativeUriString,exports.isFullUriTemplateString=isFullUriTemplateString,exports.isStatusCodeString=isStatusCodeString,exports.isFixedUriString=isFixedUriString,exports.isContentType=isContentType,exports.isMarkdownString=isMarkdownString,exports.isSchemaString=isSchemaString,exports.isMimeType=isMimeType,exports.isAnyType=isAnyType,exports.isNumberType=isNumberType,exports.isIntegerType=isIntegerType,exports.isNullType=isNullType,exports.isTimeOnlyType=isTimeOnlyType,exports.isDateOnlyType=isDateOnlyType,exports.isDateTimeOnlyType=isDateTimeOnlyType,exports.isDateTimeType=isDateTimeType,exports.isFileType=isFileType,exports.isBooleanType=isBooleanType,exports.isAnnotationTarget=isAnnotationTarget,exports.isTraitRef=isTraitRef,exports.isTrait=isTrait,exports.isMethodBase=isMethodBase,exports.isOperation=isOperation,exports.isTypeDeclaration=isTypeDeclaration,exports.isModelLocation=isModelLocation,exports.isLocationKind=isLocationKind,exports.isExampleSpec=isExampleSpec,exports.isUsesDeclaration=isUsesDeclaration,exports.isXMLFacetInfo=isXMLFacetInfo,exports.isArrayTypeDeclaration=isArrayTypeDeclaration,exports.isUnionTypeDeclaration=isUnionTypeDeclaration,exports.isObjectTypeDeclaration=isObjectTypeDeclaration,exports.isStringTypeDeclaration=isStringTypeDeclaration,exports.isBooleanTypeDeclaration=isBooleanTypeDeclaration,exports.isNumberTypeDeclaration=isNumberTypeDeclaration,exports.isIntegerTypeDeclaration=isIntegerTypeDeclaration,exports.isDateOnlyTypeDeclaration=isDateOnlyTypeDeclaration,exports.isTimeOnlyTypeDeclaration=isTimeOnlyTypeDeclaration,exports.isDateTimeOnlyTypeDeclaration=isDateTimeOnlyTypeDeclaration,exports.isDateTimeTypeDeclaration=isDateTimeTypeDeclaration,exports.isDateTypeDeclaration=isDateTypeDeclaration,exports.isFileTypeDeclaration=isFileTypeDeclaration,exports.isResponse=isResponse,exports.isSecuritySchemePart=isSecuritySchemePart,exports.isSecuritySchemeRef=isSecuritySchemeRef,exports.isAbstractSecurityScheme=isAbstractSecurityScheme,exports.isSecuritySchemeSettings=isSecuritySchemeSettings,exports.isOAuth1SecuritySchemeSettings=isOAuth1SecuritySchemeSettings,exports.isOAuth2SecuritySchemeSettings=isOAuth2SecuritySchemeSettings,exports.isOAuth2SecurityScheme=isOAuth2SecurityScheme,exports.isOAuth1SecurityScheme=isOAuth1SecurityScheme,exports.isPassThroughSecurityScheme=isPassThroughSecurityScheme,exports.isBasicSecurityScheme=isBasicSecurityScheme,exports.isDigestSecurityScheme=isDigestSecurityScheme,exports.isCustomSecurityScheme=isCustomSecurityScheme,exports.isMethod=isMethod,exports.isResourceTypeRef=isResourceTypeRef,exports.isResourceType=isResourceType,exports.isResourceBase=isResourceBase,exports.isResource=isResource,exports.isDocumentationItem=isDocumentationItem,exports.isLibrary=isLibrary,exports.isOverlay=isOverlay,exports.isExtension=isExtension,exports.isFragment=isFragment,exports.asFragment=asFragment},function(module,exports,__webpack_require__){"use strict";function isApi(node){return"Api"==node.kind()&&"RAML08"==node.RAMLVersion()}function isFullUriTemplateString(node){return"FullUriTemplateString"==node.kind()&&"RAML08"==node.RAMLVersion()}function isUriTemplate(node){return"UriTemplate"==node.kind()&&"RAML08"==node.RAMLVersion()}function isStringType(node){return"StringType"==node.kind()&&"RAML08"==node.RAMLVersion()}function isValueType(node){return"ValueType"==node.kind()&&"RAML08"==node.RAMLVersion()}function isAnyType(node){return"AnyType"==node.kind()&&"RAML08"==node.RAMLVersion()}function isNumberType(node){return"NumberType"==node.kind()&&"RAML08"==node.RAMLVersion()}function isBooleanType(node){return"BooleanType"==node.kind()&&"RAML08"==node.RAMLVersion()}function isReference(node){return"Reference"==node.kind()&&"RAML08"==node.RAMLVersion()}function isResourceTypeRef(node){return"ResourceTypeRef"==node.kind()&&"RAML08"==node.RAMLVersion()}function isResourceType(node){return"ResourceType"==node.kind()&&"RAML08"==node.RAMLVersion()}function isMethod(node){return"Method"==node.kind()&&"RAML08"==node.RAMLVersion()}function isMethodBase(node){return"MethodBase"==node.kind()&&"RAML08"==node.RAMLVersion()}function isResponse(node){return"Response"==node.kind()&&"RAML08"==node.RAMLVersion()}function isStatusCodeString(node){return"StatusCodeString"==node.kind()&&"RAML08"==node.RAMLVersion()}function isParameter(node){return"Parameter"==node.kind()&&"RAML08"==node.RAMLVersion()}function isParameterLocation(node){return"ParameterLocation"==node.kind()&&"RAML08"==node.RAMLVersion()}function isMarkdownString(node){return"MarkdownString"==node.kind()&&"RAML08"==node.RAMLVersion()}function isStringTypeDeclaration(node){return"StringTypeDeclaration"==node.kind()&&"RAML08"==node.RAMLVersion()}function isBooleanTypeDeclaration(node){return"BooleanTypeDeclaration"==node.kind()&&"RAML08"==node.RAMLVersion()}function isNumberTypeDeclaration(node){return"NumberTypeDeclaration"==node.kind()&&"RAML08"==node.RAMLVersion()}function isIntegerTypeDeclaration(node){return"IntegerTypeDeclaration"==node.kind()&&"RAML08"==node.RAMLVersion()}function isDateTypeDeclaration(node){return"DateTypeDeclaration"==node.kind()&&"RAML08"==node.RAMLVersion()}function isFileTypeDeclaration(node){return"FileTypeDeclaration"==node.kind()&&"RAML08"==node.RAMLVersion()}function isBodyLike(node){return"BodyLike"==node.kind()&&"RAML08"==node.RAMLVersion()}function isSchemaString(node){return"SchemaString"==node.kind()&&"RAML08"==node.RAMLVersion()}function isJSonSchemaString(node){return"JSonSchemaString"==node.kind()&&"RAML08"==node.RAMLVersion()}function isXMLSchemaString(node){return"XMLSchemaString"==node.kind()&&"RAML08"==node.RAMLVersion()}function isExampleString(node){return"ExampleString"==node.kind()&&"RAML08"==node.RAMLVersion()}function isJSONExample(node){return"JSONExample"==node.kind()&&"RAML08"==node.RAMLVersion()}function isXMLExample(node){return"XMLExample"==node.kind()&&"RAML08"==node.RAMLVersion()}function isXMLBody(node){return"XMLBody"==node.kind()&&"RAML08"==node.RAMLVersion()}function isJSONBody(node){return"JSONBody"==node.kind()&&"RAML08"==node.RAMLVersion()}function isSecuritySchemeRef(node){return"SecuritySchemeRef"==node.kind()&&"RAML08"==node.RAMLVersion()}function isAbstractSecurityScheme(node){return"AbstractSecurityScheme"==node.kind()&&"RAML08"==node.RAMLVersion()}function isSecuritySchemePart(node){return"SecuritySchemePart"==node.kind()&&"RAML08"==node.RAMLVersion()}function isTraitRef(node){return"TraitRef"==node.kind()&&"RAML08"==node.RAMLVersion()}function isTrait(node){return"Trait"==node.kind()&&"RAML08"==node.RAMLVersion()}function isSecuritySchemeSettings(node){return"SecuritySchemeSettings"==node.kind()&&"RAML08"==node.RAMLVersion()}function isOAuth1SecuritySchemeSettings(node){return"OAuth1SecuritySchemeSettings"==node.kind()&&"RAML08"==node.RAMLVersion()}function isFixedUri(node){return"FixedUri"==node.kind()&&"RAML08"==node.RAMLVersion()}function isOAuth2SecuritySchemeSettings(node){return"OAuth2SecuritySchemeSettings"==node.kind()&&"RAML08"==node.RAMLVersion()}function isOAuth2SecurityScheme(node){return"OAuth2SecurityScheme"==node.kind()&&"RAML08"==node.RAMLVersion()}function isOAuth1SecurityScheme(node){return"OAuth1SecurityScheme"==node.kind()&&"RAML08"==node.RAMLVersion()}function isBasicSecurityScheme(node){return"BasicSecurityScheme"==node.kind()&&"RAML08"==node.RAMLVersion()}function isDigestSecurityScheme(node){return"DigestSecurityScheme"==node.kind()&&"RAML08"==node.RAMLVersion()}function isCustomSecurityScheme(node){return"CustomSecurityScheme"==node.kind()&&"RAML08"==node.RAMLVersion()}function isMimeType(node){return"MimeType"==node.kind()&&"RAML08"==node.RAMLVersion()}function isRelativeUriString(node){return"RelativeUriString"==node.kind()&&"RAML08"==node.RAMLVersion()}function isGlobalSchema(node){return"GlobalSchema"==node.kind()&&"RAML08"==node.RAMLVersion()}function isRAMLSimpleElement(node){return"RAMLSimpleElement"==node.kind()&&"RAML08"==node.RAMLVersion()}function isDocumentationItem(node){return"DocumentationItem"==node.kind()&&"RAML08"==node.RAMLVersion()}function isResource(node){return"Resource"==node.kind()&&"RAML08"==node.RAMLVersion()}exports.isApi=isApi,exports.isFullUriTemplateString=isFullUriTemplateString,exports.isUriTemplate=isUriTemplate,exports.isStringType=isStringType,exports.isValueType=isValueType,exports.isAnyType=isAnyType,exports.isNumberType=isNumberType,exports.isBooleanType=isBooleanType,exports.isReference=isReference,exports.isResourceTypeRef=isResourceTypeRef,exports.isResourceType=isResourceType,exports.isMethod=isMethod,exports.isMethodBase=isMethodBase,exports.isResponse=isResponse,exports.isStatusCodeString=isStatusCodeString,exports.isParameter=isParameter,exports.isParameterLocation=isParameterLocation,exports.isMarkdownString=isMarkdownString,exports.isStringTypeDeclaration=isStringTypeDeclaration,exports.isBooleanTypeDeclaration=isBooleanTypeDeclaration,exports.isNumberTypeDeclaration=isNumberTypeDeclaration,exports.isIntegerTypeDeclaration=isIntegerTypeDeclaration,exports.isDateTypeDeclaration=isDateTypeDeclaration,exports.isFileTypeDeclaration=isFileTypeDeclaration,exports.isBodyLike=isBodyLike,exports.isSchemaString=isSchemaString,exports.isJSonSchemaString=isJSonSchemaString,exports.isXMLSchemaString=isXMLSchemaString,exports.isExampleString=isExampleString,exports.isJSONExample=isJSONExample,exports.isXMLExample=isXMLExample,exports.isXMLBody=isXMLBody,exports.isJSONBody=isJSONBody,exports.isSecuritySchemeRef=isSecuritySchemeRef,exports.isAbstractSecurityScheme=isAbstractSecurityScheme,exports.isSecuritySchemePart=isSecuritySchemePart,exports.isTraitRef=isTraitRef,exports.isTrait=isTrait,exports.isSecuritySchemeSettings=isSecuritySchemeSettings,exports.isOAuth1SecuritySchemeSettings=isOAuth1SecuritySchemeSettings,exports.isFixedUri=isFixedUri,exports.isOAuth2SecuritySchemeSettings=isOAuth2SecuritySchemeSettings,exports.isOAuth2SecurityScheme=isOAuth2SecurityScheme,exports.isOAuth1SecurityScheme=isOAuth1SecurityScheme,exports.isBasicSecurityScheme=isBasicSecurityScheme,exports.isDigestSecurityScheme=isDigestSecurityScheme,exports.isCustomSecurityScheme=isCustomSecurityScheme,exports.isMimeType=isMimeType,exports.isRelativeUriString=isRelativeUriString,exports.isGlobalSchema=isGlobalSchema,exports.isRAMLSimpleElement=isRAMLSimpleElement,exports.isDocumentationItem=isDocumentationItem,exports.isResource=isResource},function(module,exports,__webpack_require__){"use strict";function isDocumentationProperty(p){return p.nameId()===universe.Universe10.Api.properties.documentation.name||p.nameId()===universe.Universe08.Api.properties.documentation.name}function isUsagePropertyName(name){return name===universe.Universe10.Trait.properties.usage.name||name===universe.Universe08.Trait.properties.usage.name||name===universe.Universe10.ResourceType.properties.usage.name||name===universe.Universe08.ResourceType.properties.usage.name||name===universe.Universe10.Library.properties.usage.name||name===universe.Universe10.Overlay.properties.usage.name||name===universe.Universe10.Extension.properties.usage.name}function isUsageProperty(p){return isUsagePropertyName(p.nameId())}function isMasterRefProperty(p){return p.nameId()==universe.Universe10.Overlay.properties.extends.name||p.nameId()==universe.Universe10.Extension.properties.extends.name}function isDescriptionPropertyName(name){return name===universe.Universe10.TypeDeclaration.properties.description.name||"description"===name}function isDescriptionProperty(p){return isDescriptionPropertyName(p.nameId())}function isRequiredPropertyName(name){return name===universe.Universe10.TypeDeclaration.properties.required.name||name===universe.Universe08.Parameter.properties.required.name||"required"===name}function isDisplayNamePropertyName(name){return name===universe.Universe10.TypeDeclaration.properties.displayName.name||"displayName"===name}function isDisplayNameProperty(p){return isDisplayNamePropertyName(p.nameId())}function isRequiredProperty(p){return isRequiredPropertyName(p.nameId())}function isTitlePropertyName(name){return name===universe.Universe10.Api.properties.title.name||name===universe.Universe08.Api.properties.title.name||name===universe.Universe10.DocumentationItem.properties.title.name||name===universe.Universe08.DocumentationItem.properties.title.name||name===universe.Universe10.Overlay.properties.title.name||name===universe.Universe10.Extension.properties.title.name;
}function isTitleProperty(p){return isTitlePropertyName(p.nameId())}function isHeadersProperty(p){return isHeadersPropertyName(p.nameId())}function isHeadersPropertyName(name){return name===universe.Universe08.MethodBase.properties.headers.name||name===universe.Universe08.Response.properties.headers.name||name===universe.Universe08.SecuritySchemePart.properties.headers.name||name===universe.Universe10.MethodBase.properties.headers.name||name===universe.Universe10.Response.properties.headers.name}function isFormParametersProperty(p){return isFormParametersPropertyName(p.nameId())}function isFormParametersPropertyName(name){return name===universe.Universe08.BodyLike.properties.formParameters.name}function isQueryParametersProperty(p){return isQueryParametersPropertyName(p.nameId())}function isQueryParametersPropertyName(name){return name===universe.Universe08.MethodBase.properties.queryParameters.name||name===universe.Universe08.SecuritySchemePart.properties.queryParameters.name||name===universe.Universe10.MethodBase.properties.queryParameters.name}function isAnnotationsProperty(p){return p.nameId()===universe.Universe10.Api.properties.annotations.name||p.nameId()===universe.Universe10.TypeDeclaration.properties.annotations.name||p.nameId()===universe.Universe10.Response.properties.annotations.name}function isAnnotationProperty(p){return p.nameId()===universe.Universe10.AnnotationRef.properties.annotation.name}function isIsProperty(p){return p.nameId()===universe.Universe10.MethodBase.properties.is.name||p.nameId()===universe.Universe08.Method.properties.is.name||p.nameId()===universe.Universe10.ResourceBase.properties.is.name||p.nameId()===universe.Universe08.ResourceType.properties.is.name||p.nameId()===universe.Universe08.Resource.properties.is.name}function isSecuredByProperty(p){return p.nameId()===universe.Universe10.Api.properties.securedBy.name||p.nameId()===universe.Universe08.Api.properties.securedBy.name||p.nameId()===universe.Universe10.MethodBase.properties.securedBy.name||p.nameId()===universe.Universe08.MethodBase.properties.securedBy.name||p.nameId()===universe.Universe08.ResourceType.properties.securedBy.name||p.nameId()===universe.Universe08.Resource.properties.securedBy.name||p.nameId()===universe.Universe10.ResourceBase.properties.securedBy.name}function isSecuritySchemesProperty(p){return p.nameId()===universe.Universe10.LibraryBase.properties.securitySchemes.name||p.nameId()===universe.Universe08.Api.properties.securitySchemes.name}function isSecuritySchemeProperty(p){return p.nameId()===universe.Universe10.SecuritySchemeRef.properties.securityScheme.name||p.nameId()===universe.Universe08.SecuritySchemeRef.properties.securityScheme.name}function isTypeProperty(p){return p.nameId()===universe.Universe10.AbstractSecurityScheme.properties.type.name||p.nameId()===universe.Universe08.AbstractSecurityScheme.properties.type.name||p.nameId()===universe.Universe08.ResourceType.properties.type.name||p.nameId()===universe.Universe08.Resource.properties.type.name||p.nameId()===universe.Universe08.Parameter.properties.type.name||p.nameId()===universe.Universe10.ResourceBase.properties.type.name||p.nameId()===universe.Universe10.TypeDeclaration.properties.type.name}function isPropertiesProperty(p){return p.nameId()===universe.Universe10.ObjectTypeDeclaration.properties.properties.name}function isResponsesProperty(p){return p.nameId()===universe.Universe10.MethodBase.properties.responses.name||p.nameId()===universe.Universe08.MethodBase.properties.responses.name}function isProtocolsProperty(p){return p.nameId()===universe.Universe10.Api.properties.protocols.name||p.nameId()===universe.Universe08.Api.properties.protocols.name||p.nameId()===universe.Universe10.MethodBase.properties.protocols.name}function isNameProperty(p){return p.nameId()===universe.Universe10.TypeDeclaration.properties.name.name||p.nameId()===universe.Universe10.TypeDeclaration.properties.name.name||p.nameId()===universe.Universe08.AbstractSecurityScheme.properties.name.name||p.nameId()===universe.Universe10.AbstractSecurityScheme.properties.name.name||p.nameId()===universe.Universe08.Trait.properties.name.name||p.nameId()===universe.Universe10.Trait.properties.name.name||"name"===p.nameId()}function isBodyProperty(p){return p.nameId()===universe.Universe10.MethodBase.properties.body.name||p.nameId()===universe.Universe08.MethodBase.properties.body.name||p.nameId()===universe.Universe10.Response.properties.body.name||p.nameId()===universe.Universe08.Response.properties.body.name}function isDefaultValue(p){return p.nameId()===universe.Universe10.TypeDeclaration.properties.default.name||p.nameId()===universe.Universe08.Parameter.properties.default.name}function isSchemaProperty(p){return p.nameId()===universe.Universe08.BodyLike.properties.schema.name||p.nameId()===universe.Universe08.XMLBody.properties.schema.name||p.nameId()===universe.Universe08.JSONBody.properties.schema.name||p.nameId()===universe.Universe10.TypeDeclaration.properties.schema.name}function isTraitsProperty(p){return p.nameId()===universe.Universe08.Api.properties.traits.name||p.nameId()===universe.Universe10.LibraryBase.properties.traits.name}function isTraitProperty(p){return p.nameId()===universe.Universe08.TraitRef.properties.trait.name||p.nameId()===universe.Universe10.TraitRef.properties.trait.name}function isResourceTypesProperty(p){return p.nameId()===universe.Universe08.Api.properties.resourceTypes.name||p.nameId()===universe.Universe10.LibraryBase.properties.resourceTypes.name}function isResourceTypeProperty(p){return p.nameId()===universe.Universe08.ResourceTypeRef.properties.resourceType.name||p.nameId()===universe.Universe10.ResourceTypeRef.properties.resourceType.name}function isFacetsProperty(p){return p.nameId()===universe.Universe10.TypeDeclaration.properties.facets.name}function isSchemasProperty(p){return p.nameId()===universe.Universe08.Api.properties.schemas.name||p.nameId()===universe.Universe10.LibraryBase.properties.schemas.name}function isResourcesProperty(p){return p.nameId()===universe.Universe10.Api.properties.resources.name||p.nameId()===universe.Universe08.Api.properties.resources.name||p.nameId()===universe.Universe10.Resource.properties.resources.name||p.nameId()===universe.Universe08.Resource.properties.resources.name}function isMethodsProperty(p){return p.nameId()===universe.Universe10.ResourceBase.properties.methods.name||p.nameId()===universe.Universe08.Resource.properties.methods.name||p.nameId()===universe.Universe08.ResourceType.properties.methods.name}function isTypesProperty(p){return p.nameId()===universe.Universe10.LibraryBase.properties.types.name}function isExampleProperty(p){return p.nameId()===universe.Universe10.TypeDeclaration.properties.example.name||"example"===p.nameId()}function isEnumProperty(p){return p.nameId()===universe.Universe10.StringTypeDeclaration.properties.enum.name||p.nameId()===universe.Universe10.NumberTypeDeclaration.properties.enum.name||p.nameId()===universe.Universe08.StringTypeDeclaration.properties.enum.name}function isExamplesProperty(p){return p.nameId()===universe.Universe10.TypeDeclaration.properties.example.name||p.nameId()===universe.Universe10.TypeDeclaration.properties.examples.name}function isValueProperty(p){return p.nameId()===universe.Universe08.GlobalSchema.properties.value.name}function isUriParametersProperty(p){return p.nameId()===universe.Universe08.Api.properties.uriParameters.name||p.nameId()===universe.Universe08.ResourceType.properties.uriParameters.name||p.nameId()===universe.Universe08.Resource.properties.uriParameters.name||p.nameId()===universe.Universe10.ResourceBase.properties.uriParameters.name}function isBaseUriParametersProperty(p){return p.nameId()===universe.Universe08.Resource.properties.baseUriParameters.name||p.nameId()===universe.Universe08.Api.properties.baseUriParameters.name||p.nameId()===universe.Universe10.Api.properties.baseUriParameters.name}function isRAMLVersionProperty(p){return p.nameId()===universe.Universe08.Api.properties.RAMLVersion.name||p.nameId()===universe.Universe10.Api.properties.RAMLVersion.name}function isUsesProperty(p){return p.nameId()===universe.Universe10.FragmentDeclaration.properties.uses.name}function isAnnotationTypesProperty(p){return p.nameId()===universe.Universe10.LibraryBase.properties.annotationTypes.name}function isMethodType(type){return type.key()==universe.Universe10.Method||type.key()==universe.Universe08.Method}function isApiType(type){return type.key()==universe.Universe10.Api||type.key()==universe.Universe08.Api}function isBooleanTypeType(type){return type.key()==universe.Universe10.BooleanType||type.key()==universe.Universe08.BooleanType}function isMarkdownStringType(type){return type.key()==universe.Universe10.MarkdownString||type.key()==universe.Universe08.MarkdownString}function isResourceType(type){return type.key()==universe.Universe10.Resource||type.key()==universe.Universe08.Resource}function isTraitType(type){return type.key()==universe.Universe10.Trait||type.key()==universe.Universe08.Trait}function isTraitRefType(type){return type.key()==universe.Universe10.TraitRef||type.key()==universe.Universe08.TraitRef}function isResourceTypeRefType(type){return type.key()==universe.Universe10.ResourceTypeRef||type.key()==universe.Universe08.ResourceTypeRef}function isGlobalSchemaType(type){return type.key()==universe.Universe08.GlobalSchema}function isSecuritySchemaType(type){return type.key()==universe.Universe10.AbstractSecurityScheme||type.key()==universe.Universe08.AbstractSecurityScheme}function isSecuritySchemeRefType(type){return type.key()==universe.Universe10.SecuritySchemeRef||type.key()==universe.Universe08.SecuritySchemeRef}function isTypeDeclarationType(type){return type.key()==universe.Universe10.TypeDeclaration}function isResponseType(type){return type.key()==universe.Universe10.Response||type.key()==universe.Universe08.Response}function isBodyLikeType(type){return type.key()==universe.Universe08.BodyLike}function isOverlayType(type){return type.key()==universe.Universe10.Overlay}function isAnnotationTypeType(type){return!1}function isResourceTypeType(type){return type.key()==universe.Universe10.ResourceType||type.key()==universe.Universe08.ResourceType}function isSchemaStringType(type){return type.key()==universe.Universe10.SchemaString||type.key()==universe.Universe08.SchemaString}function isMethodBaseType(type){return type.key()==universe.Universe10.MethodBase||type.key()==universe.Universe08.MethodBase}function isLibraryType(type){return type.key()==universe.Universe10.Library}function isStringTypeType(type){return type.key()==universe.Universe10.StringType||type.key()==universe.Universe08.StringType}function isExampleSpecType(type){return type.key()==universe.Universe10.ExampleSpec}function isExtensionType(type){return type.key()==universe.Universe10.Extension}function isTypeDeclarationTypeOrDescendant(type){return type.isAssignableFrom(universe.Universe10.TypeDeclaration.name)}function isDocumentationType(type){return type.key()==universe.Universe10.DocumentationItem||type.key()==universe.Universe08.DocumentationItem}function isAnnotationRefTypeOrDescendant(type){return type.isAssignableFrom(universe.Universe10.AnnotationRef.name)}function isApiSibling(type){return type.isAssignableFrom(universe.Universe10.Api.name)||type.isAssignableFrom(universe.Universe08.Api.name)}function isLibraryBaseSibling(type){return type.isAssignableFrom(universe.Universe10.LibraryBase.name)}function isResourceBaseSibling(type){return type.isAssignableFrom(universe.Universe10.ResourceBase.name)||type.isAssignableFrom(universe.Universe08.Resource.name)}function isObjectTypeDeclarationSibling(type){return type.isAssignableFrom(universe.Universe10.ObjectTypeDeclaration.name)}function isTypeDeclarationSibling(type){return type.isAssignableFrom(universe.Universe10.TypeDeclaration.name)}function isMethodBaseSibling(type){return type.isAssignableFrom(universe.Universe10.MethodBase.name)||type.isAssignableFrom(universe.Universe08.MethodBase.name)}function isSecuritySchemePartType(type){return type.key()==universe.Universe10.SecuritySchemePart||type.key()==universe.Universe08.SecuritySchemePart}function isMediaTypeProperty(p){return p.nameId()===universe.Universe08.Api.properties.mediaType.name||p.nameId()===universe.Universe10.Api.properties.mediaType.name}function isRAML08Type(type){return"RAML08"==type.universe().version()}function isRAML10Type(type){return"RAML10"==type.universe().version()}function isRAML08Node(node){return isRAML08Type(node.definition())}function isRAML08Attribute(node){return isRAML08Type(node.definition())}function isRAML10Node(node){return isRAML10Type(node.definition())}function isRAML10Attribute(node){return isRAML10Type(node.definition())}var universe=__webpack_require__(22);exports.isDocumentationProperty=isDocumentationProperty,exports.isUsagePropertyName=isUsagePropertyName,exports.isUsageProperty=isUsageProperty,exports.isMasterRefProperty=isMasterRefProperty,exports.isDescriptionPropertyName=isDescriptionPropertyName,exports.isDescriptionProperty=isDescriptionProperty,exports.isRequiredPropertyName=isRequiredPropertyName,exports.isDisplayNamePropertyName=isDisplayNamePropertyName,exports.isDisplayNameProperty=isDisplayNameProperty,exports.isRequiredProperty=isRequiredProperty,exports.isTitlePropertyName=isTitlePropertyName,exports.isTitleProperty=isTitleProperty,exports.isHeadersProperty=isHeadersProperty,exports.isHeadersPropertyName=isHeadersPropertyName,exports.isFormParametersProperty=isFormParametersProperty,exports.isFormParametersPropertyName=isFormParametersPropertyName,exports.isQueryParametersProperty=isQueryParametersProperty,exports.isQueryParametersPropertyName=isQueryParametersPropertyName,exports.isAnnotationsProperty=isAnnotationsProperty,exports.isAnnotationProperty=isAnnotationProperty,exports.isIsProperty=isIsProperty,exports.isSecuredByProperty=isSecuredByProperty,exports.isSecuritySchemesProperty=isSecuritySchemesProperty,exports.isSecuritySchemeProperty=isSecuritySchemeProperty,exports.isTypeProperty=isTypeProperty,exports.isPropertiesProperty=isPropertiesProperty,exports.isResponsesProperty=isResponsesProperty,exports.isProtocolsProperty=isProtocolsProperty,exports.isNameProperty=isNameProperty,exports.isBodyProperty=isBodyProperty,exports.isDefaultValue=isDefaultValue,exports.isSchemaProperty=isSchemaProperty,exports.isTraitsProperty=isTraitsProperty,exports.isTraitProperty=isTraitProperty,exports.isResourceTypesProperty=isResourceTypesProperty,exports.isResourceTypeProperty=isResourceTypeProperty,exports.isFacetsProperty=isFacetsProperty,exports.isSchemasProperty=isSchemasProperty,exports.isResourcesProperty=isResourcesProperty,exports.isMethodsProperty=isMethodsProperty,exports.isTypesProperty=isTypesProperty,exports.isExampleProperty=isExampleProperty,exports.isEnumProperty=isEnumProperty,exports.isExamplesProperty=isExamplesProperty,exports.isValueProperty=isValueProperty,exports.isUriParametersProperty=isUriParametersProperty,exports.isBaseUriParametersProperty=isBaseUriParametersProperty,exports.isRAMLVersionProperty=isRAMLVersionProperty,exports.isUsesProperty=isUsesProperty,exports.isAnnotationTypesProperty=isAnnotationTypesProperty,exports.isMethodType=isMethodType,exports.isApiType=isApiType,exports.isBooleanTypeType=isBooleanTypeType,exports.isMarkdownStringType=isMarkdownStringType,exports.isResourceType=isResourceType,exports.isTraitType=isTraitType,exports.isTraitRefType=isTraitRefType,exports.isResourceTypeRefType=isResourceTypeRefType,exports.isGlobalSchemaType=isGlobalSchemaType,exports.isSecuritySchemaType=isSecuritySchemaType,exports.isSecuritySchemeRefType=isSecuritySchemeRefType,exports.isTypeDeclarationType=isTypeDeclarationType,exports.isResponseType=isResponseType,exports.isBodyLikeType=isBodyLikeType,exports.isOverlayType=isOverlayType,exports.isAnnotationTypeType=isAnnotationTypeType,exports.isResourceTypeType=isResourceTypeType,exports.isSchemaStringType=isSchemaStringType,exports.isMethodBaseType=isMethodBaseType,exports.isLibraryType=isLibraryType,exports.isStringTypeType=isStringTypeType,exports.isExampleSpecType=isExampleSpecType,exports.isExtensionType=isExtensionType,exports.isTypeDeclarationTypeOrDescendant=isTypeDeclarationTypeOrDescendant,exports.isDocumentationType=isDocumentationType,exports.isAnnotationRefTypeOrDescendant=isAnnotationRefTypeOrDescendant,exports.isApiSibling=isApiSibling,exports.isLibraryBaseSibling=isLibraryBaseSibling,exports.isResourceBaseSibling=isResourceBaseSibling,exports.isObjectTypeDeclarationSibling=isObjectTypeDeclarationSibling,exports.isTypeDeclarationSibling=isTypeDeclarationSibling,exports.isMethodBaseSibling=isMethodBaseSibling,exports.isSecuritySchemePartType=isSecuritySchemePartType,exports.isMediaTypeProperty=isMediaTypeProperty,exports.isRAML08Type=isRAML08Type,exports.isRAML10Type=isRAML10Type,exports.isRAML08Node=isRAML08Node,exports.isRAML08Attribute=isRAML08Attribute,exports.isRAML10Node=isRAML10Node,exports.isRAML10Attribute=isRAML10Attribute},function(module,exports,__webpack_require__){(function(process){function normalizeArray(parts,allowAboveRoot){for(var up=0,i=parts.length-1;i>=0;i--){var last=parts[i];"."===last?parts.splice(i,1):".."===last?(parts.splice(i,1),up++):up&&(parts.splice(i,1),up--)}if(allowAboveRoot)for(;up--;up)parts.unshift("..");return parts}function filter(xs,f){if(xs.filter)return xs.filter(f);for(var res=[],i=0;i<xs.length;i++)f(xs[i],i,xs)&&res.push(xs[i]);return res}var splitPathRe=/^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/,splitPath=function(filename){return splitPathRe.exec(filename).slice(1)};exports.resolve=function(){for(var resolvedPath="",resolvedAbsolute=!1,i=arguments.length-1;i>=-1&&!resolvedAbsolute;i--){var path=i>=0?arguments[i]:process.cwd();if("string"!=typeof path)throw new TypeError("Arguments to path.resolve must be strings");path&&(resolvedPath=path+"/"+resolvedPath,resolvedAbsolute="/"===path.charAt(0))}return resolvedPath=normalizeArray(filter(resolvedPath.split("/"),function(p){return!!p}),!resolvedAbsolute).join("/"),(resolvedAbsolute?"/":"")+resolvedPath||"."},exports.normalize=function(path){var isAbsolute=exports.isAbsolute(path),trailingSlash="/"===substr(path,-1);return path=normalizeArray(filter(path.split("/"),function(p){return!!p}),!isAbsolute).join("/"),path||isAbsolute||(path="."),path&&trailingSlash&&(path+="/"),(isAbsolute?"/":"")+path},exports.isAbsolute=function(path){return"/"===path.charAt(0)},exports.join=function(){var paths=Array.prototype.slice.call(arguments,0);return exports.normalize(filter(paths,function(p,index){if("string"!=typeof p)throw new TypeError("Arguments to path.join must be strings");return p}).join("/"))},exports.relative=function(from,to){function trim(arr){for(var start=0;start<arr.length&&""===arr[start];start++);for(var end=arr.length-1;end>=0&&""===arr[end];end--);return start>end?[]:arr.slice(start,end-start+1)}from=exports.resolve(from).substr(1),to=exports.resolve(to).substr(1);for(var fromParts=trim(from.split("/")),toParts=trim(to.split("/")),length=Math.min(fromParts.length,toParts.length),samePartsLength=length,i=0;i<length;i++)if(fromParts[i]!==toParts[i]){samePartsLength=i;break}for(var outputParts=[],i=samePartsLength;i<fromParts.length;i++)outputParts.push("..");return outputParts=outputParts.concat(toParts.slice(samePartsLength)),outputParts.join("/")},exports.sep="/",exports.delimiter=":",exports.dirname=function(path){var result=splitPath(path),root=result[0],dir=result[1];return root||dir?(dir&&(dir=dir.substr(0,dir.length-1)),root+dir):"."},exports.basename=function(path,ext){var f=splitPath(path)[2];return ext&&f.substr(-1*ext.length)===ext&&(f=f.substr(0,f.length-ext.length)),f},exports.extname=function(path){return splitPath(path)[3]};var substr="b"==="ab".substr(-1)?function(str,start,len){return str.substr(start,len)}:function(str,start,len){return start<0&&(start=str.length+start),str.substr(start,len)}}).call(exports,__webpack_require__(59))},function(module,exports,__webpack_require__){"use strict";function qName(x,context){var nm=x.name();if(context.lowLevel()instanceof proxy.LowLevelProxyNode){if(x.lowLevel()instanceof proxy.LowLevelProxyNode)return nm;var rootUnit=context.root().lowLevel().unit(),resolver=rootUnit.project().namespaceResolver(),unit=x.lowLevel().unit(),ns=resolver.resolveNamespace(rootUnit,unit);if(null!=ns)return ns+"."+nm}if(x.lowLevel().unit()!=context.lowLevel().unit())for(var root=context;;){if(root.lowLevel().includePath()||null==root.parent()){root.unitMap||(root.unitMap={},root.asElement().elements().forEach(function(x){if(x.definition().key()==universes.Universe10.UsesDeclaration){var mm=x.attr("value");if(mm){var unit=x.root().lowLevel().unit().resolve(mm.value());if(null!=unit){var key=x.attr("key");key&&(root.unitMap[unit.absolutePath()]=key.value())}}}}));var prefix=root.unitMap[x.lowLevel().unit().absolutePath()];if(prefix)return prefix+"."+nm}if(!root.parent())break;root=root.parent()}return nm}function ramlFirstLine(content){return content.match(/^\s*#%RAML\s+(\d\.\d)\s*(\w*)\s*$/m)}function getFragmentDefenitionName(highLevelNode){var contents=highLevelNode.lowLevel()&&highLevelNode.lowLevel().unit()&&highLevelNode.lowLevel().unit().contents();return null==contents?null:getDefinitionSystemType(contents,highLevelNode.lowLevel()).ptype}function fromUnit(l){if(null==l)return null;var contents=l.contents(),ast=l.ast(),__ret=getDefinitionSystemType(contents,ast),ptype=__ret.ptype,localUniverse=__ret.localUniverse,apiType=localUniverse.type(ptype);apiType||(apiType=localUniverse.type("Api"));var api=new ASTNodeImpl(ast,null,apiType,null);return api.setUniverse(localUniverse),api.children(),api}function createBasicValidationAcceptor(errors){var q={accept:function(c){errors.push(c)},begin:function(){},end:function(){},acceptUnique:function(issue){for(var _i=0,errors_1=errors;_i<errors_1.length;_i++){var e=errors_1[_i];if(e.start==issue.start&&e.message==issue.message)return}this.accept(issue)}};return q}var __extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},defs=__webpack_require__(36),hl=__webpack_require__(10),_=__webpack_require__(61),proxy=__webpack_require__(38),def=defs,builder=__webpack_require__(26),search=__webpack_require__(23),mutators=__webpack_require__(39),linter=__webpack_require__(25),expander=__webpack_require__(24),typeBuilder=__webpack_require__(40),universes=__webpack_require__(22),jsyaml=__webpack_require__(27),textutil=__webpack_require__(41),services=def,yaml=__webpack_require__(70),wrapperHelper=__webpack_require__(32),factory10=__webpack_require__(42),factory08=__webpack_require__(43),universeHelpers=__webpack_require__(14),resourceRegistry=__webpack_require__(28),rTypes=defs.rt,contentprovider=__webpack_require__(30);exports.qName=qName;var BasicASTNode=function(){function BasicASTNode(_node,_parent){this._node=_node,this._parent=_parent,this._implicit=!1,this.values={},_node&&_node.setHighLevelParseResult(this)}return BasicASTNode.prototype.getKind=function(){return hl.NodeKind.BASIC},BasicASTNode.prototype.asAttr=function(){return null},BasicASTNode.prototype.asElement=function(){return null},BasicASTNode.prototype.hashkey=function(){return this._hashkey||(this._hashkey=this.parent()?this.parent().hashkey()+"/"+this.name():this.name()),this._hashkey},BasicASTNode.prototype.root=function(){return this.parent()?this.parent().root():this},BasicASTNode.prototype.version=function(){return""},BasicASTNode.prototype.getLowLevelStart=function(){return this.lowLevel().kind()===jsyaml.Kind.SCALAR?this.lowLevel().start():this.lowLevel().keyStart()},BasicASTNode.prototype.getLowLevelEnd=function(){return this.lowLevel().kind()===jsyaml.Kind.SCALAR?this.lowLevel().end():this.lowLevel().keyEnd()},BasicASTNode.prototype.isSameNode=function(n){return!(!n||n.lowLevel().actual()!=this.lowLevel().actual())},BasicASTNode.prototype.checkContextValue=function(name,value,thisObj){var vl=this.computedValue(name);return!(!vl||vl.indexOf(value)==-1)||(value==vl||"false"==value)},BasicASTNode.prototype.printDetails=function(indent){return(indent?indent:"")+"Unkown\n"},BasicASTNode.prototype.testSerialize=function(indent){return(indent?indent:"")+"Unkown\n"},BasicASTNode.prototype.errors=function(){var errors=[],q=createBasicValidationAcceptor(errors);return this.validate(q),errors},BasicASTNode.prototype.markCh=function(){for(var n=this.lowLevel();n instanceof proxy.LowLevelProxyNode;)n=n.originalNode();return n=n._node?n._node:n,!!n.markCh||void(n.markCh=1)},BasicASTNode.prototype.unmarkCh=function(){for(var n=this.lowLevel();n instanceof proxy.LowLevelProxyNode;)n=n.originalNode();n=n._node?n._node:n,delete n.markCh},BasicASTNode.prototype.validate=function(v){linter.validate(this,v)},BasicASTNode.prototype.allowRecursive=function(){return!1},BasicASTNode.prototype.setComputed=function(name,v){this.values[name]=v},BasicASTNode.prototype.computedValue=function(name){var vl=this.values[name];return!vl&&this.parent()?this.parent().computedValue(name):vl},BasicASTNode.prototype.lowLevel=function(){return this._node},BasicASTNode.prototype.name=function(){var c=this.lowLevel().key();return c?c:""},BasicASTNode.prototype.optional=function(){var llNode=this.lowLevel(),ownValue=llNode.optional();if(null!=llNode.key())return ownValue;var p=this.property();if(!p||!p.isMultiValue())return ownValue;for(var llParent=llNode.parent();llParent&&null==llParent.highLevelNode();){if(llParent.kind()==yaml.Kind.MAPPING)return llParent.optional();llParent=llParent.parent()}return ownValue},BasicASTNode.prototype.parent=function(){return this._parent},BasicASTNode.prototype.setParent=function(parent){this._parent=parent},BasicASTNode.prototype.isElement=function(){return!1},BasicASTNode.prototype.directChildren=function(){return this.children()},BasicASTNode.prototype.children=function(){return[]},BasicASTNode.prototype.isAttached=function(){return null!=this.parent()},BasicASTNode.prototype.isImplicit=function(){return this._implicit},BasicASTNode.prototype.isAttr=function(){return!1},BasicASTNode.prototype.isUnknown=function(){return!0},BasicASTNode.prototype.id=function(){var _this=this;if(this.cachedId)return this.cachedId;if(this._parent){var parentId=this.parent().id();parentId+="."+this.name();var sameName=this.parent().directChildren().filter(function(x){return x.name()==_this.name()});if(sameName.length>1){var ind=sameName.indexOf(this);parentId+="["+ind+"]"}return this.cachedId=parentId,parentId}return this.cachedId="",this.cachedId},BasicASTNode.prototype.localId=function(){return this.name()},BasicASTNode.prototype.fullLocalId=function(){var _this=this;if(this.cachedFullId)return this.cachedFullId;if(this._parent){var result="."+this.name(),sameName=this.parent().directChildren().filter(function(x){return x.name()==_this.name()});if(sameName.length>1){var ind=sameName.indexOf(this);result+="["+ind+"]"}return this.cachedFullId=result,result}return this.cachedFullId=this.localId(),this.cachedFullId},BasicASTNode.prototype.property=function(){return null},BasicASTNode}();exports.BasicASTNode=BasicASTNode;var StructuredValue=function(){function StructuredValue(node,_parent,_pr,kv){void 0===kv&&(kv=null),this.node=node,this._parent=_parent,this.kv=kv,this._pr=_pr}return StructuredValue.prototype.valueName=function(){var res=null;return this.kv&&(res=this.kv),res=this.node.key(),this._pr&&this._pr.isAnnotation()&&res&&"("==res.charAt(0)&&(res=res.substring(1,res.length-1)),res},StructuredValue.prototype.children=function(){return this.node.children().map(function(x){return new StructuredValue(x,null,null)})},StructuredValue.prototype.lowLevel=function(){return this.node},StructuredValue.prototype.toHighLevel=function(parent){if(!parent&&this._parent&&(parent=this._parent),this._hl)return this._hl;var vn=this.valueName(),cands=search.referenceTargets(this._pr,parent).filter(function(x){return qName(x,parent)==vn});if(cands&&cands[0]){var tp=cands[0].localType(),node=new ASTNodeImpl(this.node,parent,tp,this._pr);return this._pr&&this._pr.childRestrictions().forEach(function(y){node.setComputed(y.name,y.value)}),this._hl=node,node}return null},StructuredValue.prototype.toHighLevel2=function(parent){!parent&&this._parent&&(parent=this._parent);var vn=this.valueName(),cands=search.referenceTargets(this._pr,parent).filter(function(x){return qName(x,parent)==vn});if(cands&&cands[0]){var tp=cands[0].localType(),node=new ASTNodeImpl(this.node,parent,tp,this._pr);return this._pr&&this._pr.childRestrictions().forEach(function(y){node.setComputed(y.name,y.value)}),node}if(this._pr.range()){var node=new ASTNodeImpl(this.node.parent(),parent,this._pr.range(),this._pr);return this._pr&&this._pr.childRestrictions().forEach(function(y){node.setComputed(y.name,y.value)}),node}return null},StructuredValue}();exports.StructuredValue=StructuredValue;var ASTPropImpl=function(_super){function ASTPropImpl(node,parent,_def,_prop,fromKey){void 0===fromKey&&(fromKey=!1),_super.call(this,node,parent),this._def=_def,this._prop=_prop,this.fromKey=fromKey}return __extends(ASTPropImpl,_super),ASTPropImpl.prototype.definition=function(){return this._def},ASTPropImpl.prototype.asAttr=function(){return this},ASTPropImpl.prototype.errors=function(){var errors=[],q=createBasicValidationAcceptor(errors);return this.parent().validate(q),errors},ASTPropImpl.prototype.isString=function(){return!(!this._def||this._def.key()!==universes.Universe08.StringType&&this._def.key()!=universes.Universe10.StringType)},ASTPropImpl.prototype.isAnnotatedScalar=function(){return!this.property().isAnnotation()&&!this.property().isKey()&&this.lowLevel().isAnnotatedScalar()},ASTPropImpl.prototype.annotations=function(){var ch=this.lowLevel().children(),annotations=[],u=this.definition().universe().type(universes.Universe10.Annotable.name);if(!u)return annotations;for(var pr=u.property("annotations"),i=0;i<ch.length;i++){var child=ch[i],key=child.key();if(null!=key&&"("==key[0]&&")"==key[key.length-1]){var attr=new ASTPropImpl(child,this.parent(),pr.range(),pr);annotations.push(attr)}}return annotations},ASTPropImpl.prototype.getKind=function(){return hl.NodeKind.ATTRIBUTE},ASTPropImpl.prototype.owningWrapper=function(){return{node:this.parent().wrapperNode(),property:this.name()}},ASTPropImpl.prototype.patchType=function(t){this._def=t},ASTPropImpl.prototype.findReferenceDeclaration=function(){var _this=this,targets=search.referenceTargets(this.property(),this.parent()),vl=this.value();if(vl instanceof StructuredValue)var st=vl,nm=st.valueName();else var nm=""+vl;var t=_.find(targets,function(x){return qName(x,_this.parent())==nm});return t},ASTPropImpl.prototype.findReferencedValue=function(){var c=this.findReferenceDeclaration();if(c){var vl=c.attr("value"),ck=c.definition().key();if(ck===universes.Universe08.GlobalSchema){if(vl){var actualValue=vl.value();if(actualValue){var rf=linter.isValid(this._def,this.parent(),actualValue,vl.property());return rf}}return null}}return c},ASTPropImpl.prototype.isElement=function(){return!1},ASTPropImpl.prototype.property=function(){return this._prop},ASTPropImpl.prototype.convertMultivalueToString=function(value){for(var gap=0,pos=2;" "==value[pos];)gap++,pos++;var lines=textutil.splitOnLines(value);return lines=lines.map(function(line){return line.substring(gap,line.length)}),lines.join("")},ASTPropImpl.prototype.overrideValue=function(value){this._value=value},ASTPropImpl.prototype.value=function(){return this._value?this._value:(this._value=this.calcValue(),this._value)},ASTPropImpl.prototype.calcValue=function(){if(this._computed)return this.computedValue(this.property().nameId());if(this.fromKey){var parent=this.parent(),definition=parent.definition();if("RAML08"==definition.universe().version())return this._node.key();
if(universeHelpers.isNameProperty(this.property())&&definition.isAssignableFrom(universes.Universe10.TypeDeclaration.name)){var requiredAttr=parent.attr("required");if(requiredAttr&&null!=requiredAttr.value())return this._node.optional()?this._node.key()+"?":this._node.key()}return this._node.key()}if(this.property().isAnnotation()&&this._node.key()&&"annotations"!=this._node.key())return new StructuredValue(this._node,this.parent(),this._prop);var isString=null!=this.property()&&!(null==this.parent()||null==this.parent().definition()||universeHelpers.isTypeProperty(this.property())&&universeHelpers.isTypeDeclarationSibling(this.parent().definition()))&&universeHelpers.isStringTypeType(this.property().range()),actualValue=this._node.value(isString);if(this.property().isSelfNode()&&(!actualValue||actualValue instanceof jsyaml.ASTNode)&&(actualValue=this._node,0==actualValue.children().length&&(actualValue=null)),actualValue instanceof jsyaml.ASTNode||actualValue instanceof proxy.LowLevelProxyNode){var isAnnotatedScalar=!1;if(this.property().range().hasStructure()||this._node.isAnnotatedScalar()&&this._node.children().forEach(function(x){"value"===x.key()&&(actualValue=x.value(isString),isAnnotatedScalar=!0)}),!isAnnotatedScalar)return this._sval?this._sval:(this._sval=new StructuredValue(actualValue,this.parent(),this._prop),this._sval)}if("string"==typeof actualValue&&textutil.isMultiLineValue(actualValue)){var res=this.convertMultivalueToString(actualValue);return res}return null==actualValue&&this._node.children().length>0&&this.property()&&universeHelpers.isTypeProperty(this.property())&&this.parent()&&universeHelpers.isTypeDeclarationSibling(this.parent().definition())?new StructuredValue(this._node,this.parent(),this._prop):actualValue},ASTPropImpl.prototype.name=function(){return this._prop.nameId()},ASTPropImpl.prototype.printDetails=function(indent){var className=this.definition().nameId(),definitionClassName=this.property().range().nameId(),result=(indent?indent:"")+(this.name()+" : "+className+"["+definitionClassName+"]  =  "+this.value())+(this.property().isKey()&&this.optional()?"?":"")+"\n";if(this.value()instanceof StructuredValue){var structuredHighLevel=this.value().toHighLevel();structuredHighLevel&&structuredHighLevel.printDetails&&(result+=structuredHighLevel.printDetails(indent+"\t"))}return result},ASTPropImpl.prototype.testSerialize=function(indent){var className=this.definition().nameId(),result=(indent?indent:"")+(this.name()+" : "+className+"  =  "+this.value())+"\n";if(this.value()instanceof StructuredValue){var structuredHighLevel=this.value().toHighLevel();if(structuredHighLevel&&structuredHighLevel.testSerialize)result+=structuredHighLevel.testSerialize((indent?indent:"")+"  ");else{var lowLevel=this.value().lowLevel(),dumpObject=lowLevel.dumpToObject(),dump=JSON.stringify(dumpObject),indentedDump="",dumpLines=dump.split("\n");dumpLines.forEach(function(dumpLine){return indentedDump+=(indent?indent:"")+"  "+dumpLine+"\n"}),result+=indentedDump+"\n"}}return result},ASTPropImpl.prototype.isAttr=function(){return!0},ASTPropImpl.prototype.isUnknown=function(){return!1},ASTPropImpl.prototype.setValue=function(value){mutators.setValue(this,value),this._value=null},ASTPropImpl.prototype.setKey=function(value){mutators.setKey(this,value),this._value=null},ASTPropImpl.prototype.children=function(){return[]},ASTPropImpl.prototype.addStringValue=function(value){mutators.addStringValue(this,value),this._value=null},ASTPropImpl.prototype.addStructuredValue=function(sv){mutators.addStructuredValue(this,sv),this._value=null},ASTPropImpl.prototype.addValue=function(value){if(!this.property().isMultiValue())throw new Error("setValue(string) only apply to multi-values properties");"string"==typeof value?this.addStringValue(value):this.addStructuredValue(value),this._value=null},ASTPropImpl.prototype.isEmbedded=function(){var keyname=this.lowLevel().asMapping().key.value;return this.property().canBeValue()&&keyname!=this.property().nameId()},ASTPropImpl.prototype.remove=function(){mutators.removeAttr(this)},ASTPropImpl.prototype.setValues=function(values){mutators.setValues(this,values),this._value=null},ASTPropImpl.prototype.isEmpty=function(){if(!this.property().isMultiValue())throw new Error("isEmpty() only apply to multi-values attributes");var node=this.parent(),attrs=(node.lowLevel(),node.attributes(this.name()));if(0==attrs.length)return!0;if(1==attrs.length){var anode=attrs[0].lowLevel();return!(!anode.isMapping()||null!=anode.value())}return!1},ASTPropImpl.prototype.isFromKey=function(){return this.fromKey},ASTPropImpl}(BasicASTNode);exports.ASTPropImpl=ASTPropImpl;var nodeBuilder=new builder.BasicNodeBuilder;!function(OverlayMergeMode){OverlayMergeMode[OverlayMergeMode.MERGE=0]="MERGE",OverlayMergeMode[OverlayMergeMode.AGGREGATE=1]="AGGREGATE"}(exports.OverlayMergeMode||(exports.OverlayMergeMode={}));var OverlayMergeMode=exports.OverlayMergeMode,LowLevelWrapperForTypeSystem=function(_super){function LowLevelWrapperForTypeSystem(_node,_highLevelRoot){_super.call(this),this._node=_node,this._highLevelRoot=_highLevelRoot;var v=_highLevelRoot.root(),mst=v.getMaster();if(mst&&this._node===_highLevelRoot.lowLevel()){var master=_highLevelRoot.getMasterCounterPart();master&&(this._toMerge=new LowLevelWrapperForTypeSystem(master.lowLevel(),master))}}return __extends(LowLevelWrapperForTypeSystem,_super),LowLevelWrapperForTypeSystem.prototype.contentProvider=function(){var root=this._node&&this._node.includeBaseUnit()&&(this._node.includePath&&this._node.includePath()?this._node.includeBaseUnit().resolve(this._node.includePath()):this._node.includeBaseUnit());return new contentprovider.ContentProvider(root)},LowLevelWrapperForTypeSystem.prototype.key=function(){var vl=this._node.key();return this._node.optional()&&(vl+="?"),vl},LowLevelWrapperForTypeSystem.prototype.value=function(){var vk=this._node.valueKind();if(vk===yaml.Kind.SEQ)return this.children().map(function(x){return x.value()});if(vk===yaml.Kind.MAP||vk===yaml.Kind.ANCHOR_REF){var vl=this._node.dumpToObject(!1);return vl[this.key()]}if(this._node.kind()==yaml.Kind.MAP){var vl=this._node.dumpToObject(!1);return vl}if(vk===yaml.Kind.INCLUDE_REF){var resolved=null,includePath=this._node.includePath();try{resolved=this._node.unit().resolve(includePath)}catch(e){}if(null!=resolved&&resolved.isRAMLUnit()){var includedAST=resolved.ast(),includedWrapper=new LowLevelWrapperForTypeSystem(includedAST,resolved.highLevel().asElement());return includedAST.kind()==yaml.Kind.SEQ?includedWrapper.children().map(function(x){return x.value()}):includedWrapper.value()}}var val=this._node.value();return val},LowLevelWrapperForTypeSystem.prototype.children=function(){var _this=this;if(this._children)return this._children;"uses"!=this.key()||this._node.parent().parent()?this._children=this._node.children().map(function(x){return new LowLevelWrapperForTypeSystem(x,_this._highLevelRoot)}):this._children=this._node.children().map(function(x){return new UsesNodeWrapperFoTypeSystem(x,_this._highLevelRoot)}),this.childByKey={};for(var i=0;i<this._children.length;i++){var c=this._children[i];this.childByKey[c.key()]=c}if(this._toMerge)for(var mrg=this._toMerge.children(),i=0;i<mrg.length;i++){var c=mrg[i],existing=this.childByKey[c.key()];existing?existing._toMerge=c:(this._children.push(c),this.childByKey[c.key()]=c)}return this._children},LowLevelWrapperForTypeSystem.prototype.childWithKey=function(k){return this._children||this.children(),this.childByKey[k]},LowLevelWrapperForTypeSystem.prototype.kind=function(){var vk=this._node.valueKind();if(vk==yaml.Kind.MAPPING||null===vk)return rTypes.NodeKind.MAP;if(vk==yaml.Kind.MAP)return rTypes.NodeKind.MAP;var knd=this._node.kind();return knd==yaml.Kind.MAP?rTypes.NodeKind.MAP:vk==yaml.Kind.SEQ?rTypes.NodeKind.ARRAY:vk==yaml.Kind.INCLUDE_REF&&this._node.children().length>0?rTypes.NodeKind.MAP:rTypes.NodeKind.SCALAR},LowLevelWrapperForTypeSystem.prototype.getSource=function(){if(!this._node)return null;var highLevelNode=this._node.highLevelNode();if(!highLevelNode){var position=this._node.start(),result=search.deepFindNode(this._highLevelRoot,position,position,!0,!1);return result&&(this._node.setHighLevelParseResult(result),result instanceof ASTNodeImpl&&this._node.setHighLevelNode(result)),result}return highLevelNode},LowLevelWrapperForTypeSystem.prototype.node=function(){return this._node},LowLevelWrapperForTypeSystem}(defs.SourceProvider);exports.LowLevelWrapperForTypeSystem=LowLevelWrapperForTypeSystem;var UsesNodeWrapperFoTypeSystem=function(_super){function UsesNodeWrapperFoTypeSystem(){_super.apply(this,arguments)}return __extends(UsesNodeWrapperFoTypeSystem,_super),UsesNodeWrapperFoTypeSystem.prototype.children=function(){var s=this._node.unit().resolve(this.value());return s&&s.isRAMLUnit()?new LowLevelWrapperForTypeSystem(s.ast(),this._highLevelRoot).children():[]},UsesNodeWrapperFoTypeSystem.prototype.anchor=function(){return this._node.actual()},UsesNodeWrapperFoTypeSystem.prototype.childWithKey=function(k){for(var mm=this.children(),i=0;i<mm.length;i++)if(mm[i].key()==k)return mm[i];return null},UsesNodeWrapperFoTypeSystem}(LowLevelWrapperForTypeSystem);exports.UsesNodeWrapperFoTypeSystem=UsesNodeWrapperFoTypeSystem;var ASTNodeImpl=function(_super){function ASTNodeImpl(node,parent,_def,_prop){_super.call(this,node,parent),this._def=_def,this._prop=_prop,this._expanded=!1,this._allowQuestion=!1,this._subTypesCache=null,this._auxChecked=!1,this.overlayMergeMode=OverlayMergeMode.MERGE,node&&node.setHighLevelNode(this),node instanceof proxy.LowLevelProxyNode&&(this._expanded=!0)}return __extends(ASTNodeImpl,_super),ASTNodeImpl.prototype.createIssue=function(error){return linter.toIssue(error,this)},ASTNodeImpl.prototype.validate=function(v){var k=this.definition().key();if((k==universes.Universe10.Api||k==universes.Universe08.Api||k==universes.Universe10.Extension)&&!this.isExpanded()){var nm=expander.expandTraitsAndResourceTypes(this.wrapperNode()),hlnode=nm.highLevel();return hlnode.resetChildren(),hlnode.children(),hlnode._expanded=!0,hlnode.clearTypesCache(),void hlnode.validate(v)}k!=universes.Universe10.Overlay&&k!=universes.Universe10.Extension||this.clearTypesCache(),linter.validate(this,v)},ASTNodeImpl.prototype.clearTypesCache=function(){this._types=null;var c=this.lowLevel().actual();c.types=null},ASTNodeImpl.prototype.types=function(){var _this=this;if(!this._types){if(this.parent()&&this.definition().key()!==universes.Universe10.Library)return this.parent().types();var c=this.lowLevel().actual();if(c.types)return c.types;this._types=rTypes.parseFromAST(new LowLevelWrapperForTypeSystem(this.lowLevel(),this)),this._types.types().forEach(function(x){var convertedType=typeBuilder.convertType(_this,x);convertedType.putExtra(defs.USER_DEFINED_EXTRA,!0)}),c.types=this._types}return this._types},ASTNodeImpl.prototype.setTypes=function(t){this._types=t},ASTNodeImpl.prototype.parsedType=function(){if(!this._ptype){if(this.property()&&this.property().nameId()==universes.Universe10.MethodBase.properties.body.name){var isParametrizedType=this.isParametrizedType();this._ptype=rTypes.parseTypeFromAST(this.name(),new LowLevelWrapperForTypeSystem(this.lowLevel(),this),this.types(),!0,!1,!1,isParametrizedType)}else{var annotation=this.property()&&this.property().nameId()==universes.Universe10.LibraryBase.properties.annotationTypes.name,tl=!this.property()||this.property().nameId()==universes.Universe10.LibraryBase.properties.types.name||this.property().nameId()==universes.Universe10.LibraryBase.properties.schemas.name;if(!annotation&&null==this.parent()){var localUniverse=this.universe();localUniverse&&localUniverse.getOriginalTopLevelText()&&"AnnotationTypeDeclaration"==localUniverse.getOriginalTopLevelText()&&(annotation=!0)}this._ptype=rTypes.parseTypeFromAST(this.name(),new LowLevelWrapperForTypeSystem(this.lowLevel(),this),this.types(),!1,annotation,tl)}this.property()&&universeHelpers.isTypesProperty(this.property())&&this.parent()&&universeHelpers.isApiType(this.parent().definition())&&this._ptype.putExtra&&this._ptype.putExtra(defs.DEFINED_IN_TYPES_EXTRA,!0);var potentialHasExtra=this._ptype;potentialHasExtra.putExtra(defs.USER_DEFINED_EXTRA,!0),this._ptype.putExtra(defs.SOURCE_EXTRA,this)}return this._ptype},ASTNodeImpl.prototype.isParametrizedType=function(){var isParametrizedType=!1,typeAttr=this.attr(universes.Universe10.TypeDeclaration.properties.type.name);if(typeAttr){var typeAttrValue=typeAttr.value();if("string"==typeof typeAttrValue&&typeAttrValue.indexOf("<<")>=0)for(var parent=this.parent();null!=parent;){if(universeHelpers.isResourceTypeType(parent.definition())||universeHelpers.isTraitType(parent.definition())){isParametrizedType=!0;break}parent=parent.parent()}}return isParametrizedType},ASTNodeImpl.prototype.localType=function(){return typeBuilder.typeFromNode(this)},ASTNodeImpl.prototype.patchProp=function(pr){this._prop=pr},ASTNodeImpl.prototype.getKind=function(){return hl.NodeKind.NODE},ASTNodeImpl.prototype.wrapperNode=function(){if(!this._wrapperNode){if(universeHelpers.isExampleSpecType(this.definition())){var typeYamlNode=yaml.newMap([yaml.newMapping(yaml.newScalar("example"),this.lowLevel().actual())]),typesNode=yaml.newMapping(yaml.newScalar("types"),yaml.newMap([yaml.newMapping(yaml.newScalar("__AUX_TYPE__"),typeYamlNode)])),yamlNode=yaml.newMap([typesNode]),llNode=new jsyaml.ASTNode(yamlNode,this.lowLevel().unit(),null,null,null),types=rTypes.parseFromAST(new LowLevelWrapperForTypeSystem(llNode,this)),nominal=rTypes.toNominal(types.types()[0],function(x){return null}),spec=wrapperHelper.examplesFromNominal(nominal,this,!0,!1);return spec[0]}this.children(),this._wrapperNode=this.buildWrapperNode()}return this._wrapperNode},ASTNodeImpl.prototype.asElement=function(){return this},ASTNodeImpl.prototype.buildWrapperNode=function(){var ramlVersion=this.definition().universe().version();return"RAML10"==ramlVersion?factory10.buildWrapperNode(this):"RAML08"==ramlVersion?factory08.buildWrapperNode(this):null},ASTNodeImpl.prototype.propertiesAllowedToUse=function(){var _this=this;return this.definition().allProperties().filter(function(x){return _this.isAllowedToUse(x)})},ASTNodeImpl.prototype.isAllowedToUse=function(p){var _this=this,ok=!0;return!p.getAdapter(services.RAMLPropertyService).isSystem()&&(p.getContextRequirements().forEach(function(y){if(y.name.indexOf("(")!=-1)return!0;var vl=_this.computedValue(y.name);vl?ok=ok&&vl==y.value:y.value&&(ok=!1)}),ok)},ASTNodeImpl.prototype.allowRecursive=function(){return!!this.definition().getAdapter(services.RAMLService).isUserDefined()},ASTNodeImpl.prototype.setWrapperNode=function(node){this._wrapperNode=node},ASTNodeImpl.prototype.setAssociatedType=function(d){this._associatedDef=d},ASTNodeImpl.prototype.associatedType=function(){return this._associatedDef},ASTNodeImpl.prototype.knownIds=function(){return this.isAuxilary(),this._knownIds?this._knownIds:{}},ASTNodeImpl.prototype.findById=function(id){var _this=this,currentRoot=this.root();if(currentRoot!=this)return currentRoot.findById(id);if(!this._knownIds){this._knownIds={};var all=search.allChildren(this);all.forEach(function(x){return _this._knownIds[x.id()]=x})}if(this.isAuxilary()){if(!this._slaveIds){this._slaveIds={};var all=search.allChildren(this);all.forEach(function(x){return _this._slaveIds[x.id()]=x})}var nodeIndexedInSlave=this._slaveIds[id];if(nodeIndexedInSlave)return nodeIndexedInSlave}return this._knownIds[id]},ASTNodeImpl.prototype.isAuxilary=function(){if(this._isAux)return!0;if(this._auxChecked)return!1;this._auxChecked=!0;var masterApi=this.getMaster();return!!masterApi&&(this._isAux=!0,this.initilizeKnownIDs(masterApi),!0)},ASTNodeImpl.prototype.initilizeKnownIDs=function(api){var _this=this;this._knownIds={};var allChildren=search.allChildren(api);allChildren.forEach(function(x){return _this._knownIds[x.id()]=x}),this._knownIds[""]=api},ASTNodeImpl.prototype.getMaster=function(){return this.masterApi?this.masterApi:this.calculateMasterByRef()},ASTNodeImpl.prototype.overrideMaster=function(master){this.masterApi=master,this.resetAuxilaryState()},ASTNodeImpl.prototype.setMergeMode=function(mergeMode){this.overlayMergeMode=mergeMode,this.resetAuxilaryState()},ASTNodeImpl.prototype.getMergeMode=function(){return this.overlayMergeMode},ASTNodeImpl.prototype.calculateMasterByRef=function(){var unit=this.lowLevel().unit();if(!unit)return null;var masterReferenceNode=unit.getMasterReferenceNode();if(!masterReferenceNode||!masterReferenceNode.value())return null;var lc=this.lowLevel();if(lc.master)return lc.master;var masterPath=masterReferenceNode.value(),masterUnit=this.lowLevel().unit().project().resolve(this.lowLevel().unit().path(),masterPath);if(!masterUnit)return null;var result=masterUnit.expandedHighLevel();return result.setMergeMode(this.overlayMergeMode),lc.master=result,result},ASTNodeImpl.prototype.resetAuxilaryState=function(){this._isAux=!1,this._auxChecked=!1,this._knownIds=null,this.clearChildrenCache()},ASTNodeImpl.prototype.printDetails=function(indent){var result="";indent||(indent="");var classname=this.definition().nameId(),definitionClasName=this.property()?this.property().range().nameId():"",parentPropertyName=this.property()?this.property().nameId():"";return result+=indent+classname+"["+definitionClasName+"] <--- "+parentPropertyName+"\n",this.children().forEach(function(child){result+=child.printDetails(indent+"\t")}),result},ASTNodeImpl.prototype.testSerialize=function(indent){var result="";indent||(indent="");var classname=this.definition().nameId(),parentPropertyName=this.property()?this.property().nameId():"";return result+=indent+classname+" <-- "+parentPropertyName+"\n",this.children().forEach(function(child){child.testSerialize&&(result+=child.testSerialize(indent+"  "))}),result},ASTNodeImpl.prototype.getExtractedChildren=function(){var r=this.root();if(r.isAuxilary()){if(r._knownIds){var i=r._knownIds[this.id()];if(i){var v=i.children();return v}}return[]}return[]},ASTNodeImpl.prototype.getMasterCounterPart=function(){var r=this.root();if(r.isAuxilary()){if(r._knownIds){var i=r._knownIds[this.id()];return i}return null}return null},ASTNodeImpl.prototype.getExtractedLowLevelChildren=function(n){var r=this.root();if(r.isAuxilary()){if(r._knownLowLevelIds){var i=r._knownLowLevelIds[this.id()];if(i)return i.children()}return[]}return[]},ASTNodeImpl.prototype.allowsQuestion=function(){return this._allowQuestion||this.definition().getAdapter(services.RAMLService).getAllowQuestion()},ASTNodeImpl.prototype.findReferences=function(){var _this=this,rs=[];search.refFinder(this.root(),this,rs),rs.length>1&&(rs=rs.filter(function(x){return x!=_this&&x.parent()!=_this}));var filteredReferences=[];return rs.forEach(function(ref){_.find(filteredReferences,function(existing){return existing==ref})||filteredReferences.push(ref)}),filteredReferences},ASTNodeImpl.prototype.setNamePatch=function(s){this._patchedName=s},ASTNodeImpl.prototype.isNamePatch=function(){return this._patchedName},ASTNodeImpl.prototype.name=function(){if(this._patchedName)return this._patchedName;var ka=_.find(this.directChildren(),function(x){return x.property()&&x.property().getAdapter(services.RAMLPropertyService).isKey()});if(ka&&ka instanceof ASTPropImpl){var c=null,defClass=this.definition(),ramlVersion=defClass.universe().version();if(defClass&&"RAML10"==ramlVersion&&ka.isFromKey()){var key=this._node.key();c=this._node.optional()?key+"?":key}else c=ka.value();return c}return _super.prototype.name.call(this)},ASTNodeImpl.prototype.findElementAtOffset=function(n){return this._findNode(this,n,n)},ASTNodeImpl.prototype.isElement=function(){return!0},ASTNodeImpl.prototype.universe=function(){return this._universe?this._universe:this.definition().universe()},ASTNodeImpl.prototype.setUniverse=function(u){this._universe=u},ASTNodeImpl.prototype._findNode=function(n,offset,end){var _this=this;if(null==n)return null;if(n.lowLevel()&&n.lowLevel().start()<=offset&&n.lowLevel().end()>=end){var res=n;return n.elements().forEach(function(x){if(x.lowLevel().unit()==n.lowLevel().unit()){var m=_this._findNode(x,offset,end);m&&(res=m)}}),res}return null},ASTNodeImpl.prototype.isStub=function(){return!this.lowLevel().unit()||this.lowLevel().unit().isStubUnit()},ASTNodeImpl.prototype.add=function(node){mutators.addToNode(this,node)},ASTNodeImpl.prototype.remove=function(node){mutators.removeNodeFrom(this,node)},ASTNodeImpl.prototype.dump=function(flavor){return this._node.dump()},ASTNodeImpl.prototype.patchType=function(d){this._def=d;this._associatedDef;this._associatedDef=null,this._children=null,this._mergedChildren=null},ASTNodeImpl.prototype.children=function(){var lowLevel=this.lowLevel();return lowLevel&&lowLevel.isValueInclude&&lowLevel.isValueInclude()&&resourceRegistry.isWaitingFor(lowLevel.includePath())?(this._children=null,[]):this._children?this._mergedChildren?this._mergedChildren:(this._mergedChildren=this.mergeChildren(this._children,this.getExtractedChildren()),this._mergedChildren):this._node?(this._children=nodeBuilder.process(this,this._node.children()),this._children=this._children.filter(function(x){return null!=x}),this.mergeChildren(this._children,this.getExtractedChildren())):[]},ASTNodeImpl.prototype.mergeChildren=function(originalChildren,masterChildren){var _this=this,root=this.root();if(root.overlayMergeMode==OverlayMergeMode.AGGREGATE)return originalChildren.concat(masterChildren);if(root.overlayMergeMode==OverlayMergeMode.MERGE){var result=[];return originalChildren.forEach(function(originalChild){var masterCounterpart=_.find(masterChildren,function(masterChild){return masterChild.fullLocalId()==originalChild.fullLocalId()});masterCounterpart?_this.mergeChild(result,originalChild,masterCounterpart):result.push(originalChild)}),masterChildren.forEach(function(masterChild){var originalCounterpart=_.find(originalChildren,function(originalChild){return masterChild.fullLocalId()==originalChild.fullLocalId()});originalCounterpart||result.push(masterChild)}),result}return null},ASTNodeImpl.prototype.mergeLowLevelChildren=function(originalChildren,masterChildren){var _this=this,root=this.root();if(root.overlayMergeMode==OverlayMergeMode.AGGREGATE)return originalChildren.concat(masterChildren);if(root.overlayMergeMode==OverlayMergeMode.MERGE){var result=[];return originalChildren.forEach(function(originalChild){var masterCounterpart=_.find(masterChildren,function(masterChild){return masterChild.key()==originalChild.key()});masterCounterpart?_this.mergeLowLevelChild(result,originalChild,masterCounterpart):result.push(originalChild)}),masterChildren.forEach(function(masterChild){var originalCounterpart=_.find(originalChildren,function(originalChild){return masterChild.key()==originalChild.key()});originalCounterpart||result.push(masterChild)}),result}return null},ASTNodeImpl.prototype.mergeLowLevelChild=function(result,originalChild,masterChild){return originalChild.kind()!=masterChild.kind()?(result.push(originalChild),void result.push(masterChild)):void result.push(originalChild)},ASTNodeImpl.prototype.mergeChild=function(result,originalChild,masterChild){return originalChild.getKind()!=masterChild.getKind()?(result.push(originalChild),void result.push(masterChild)):originalChild.getKind()==hl.NodeKind.NODE?void result.push(originalChild):originalChild.getKind()==hl.NodeKind.ATTRIBUTE?void result.push(originalChild):originalChild.getKind()==hl.NodeKind.BASIC?(result.push(originalChild),void result.push(masterChild)):void 0},ASTNodeImpl.prototype.directChildren=function(){return this._children?this._children:this._node?(this._children=nodeBuilder.process(this,this._node.children()),this._children):[]},ASTNodeImpl.prototype.resetChildren=function(){this._children=null,this._mergedChildren=null},ASTNodeImpl.prototype.isEmptyRamlFile=function(){var llroot=this.lowLevel().root();return llroot.isScalar()},ASTNodeImpl.prototype.initRamlFile=function(){mutators.initEmptyRAMLFile(this)},ASTNodeImpl.prototype.createAttr=function(n,v){mutators.createAttr(this,n,v)},ASTNodeImpl.prototype.isAttr=function(){return!1},ASTNodeImpl.prototype.isUnknown=function(){return!1},ASTNodeImpl.prototype.value=function(){return this._node.value()},ASTNodeImpl.prototype.valuesOf=function(propName){var pr=this._def.property(propName);return null!=pr?this.elements().filter(function(x){return x.property()==pr}):[]},ASTNodeImpl.prototype.attr=function(n){return _.find(this.attrs(),function(y){return y.name()==n})},ASTNodeImpl.prototype.attrOrCreate=function(name){var a=this.attr(name);return a||this.createAttr(name,""),this.attr(name)},ASTNodeImpl.prototype.attrValue=function(n){var a=this.attr(n);return a?a.value():null},ASTNodeImpl.prototype.attributes=function(n){return _.filter(this.attrs(),function(y){return y.name()==n})},ASTNodeImpl.prototype.attrs=function(){var rs=this.children().filter(function(x){return x.isAttr()});if(this._patchedName){var kp=_.find(this.definition().allProperties(),function(x){return x.getAdapter(services.RAMLPropertyService).isKey()});if(kp){var mm=new ASTPropImpl(this.lowLevel(),this,kp.range(),kp,(!0));return mm._value=this._patchedName,[mm].concat(rs)}}return rs},ASTNodeImpl.prototype.elements=function(){return this.children().filter(function(x){return!x.isAttr()&&!x.isUnknown()})},ASTNodeImpl.prototype.element=function(n){var r=this.elementsOfKind(n);return r.length>0?r[0]:null},ASTNodeImpl.prototype.elementsOfKind=function(n){var r=this.elements().filter(function(x){return x.property().nameId()==n});return r},ASTNodeImpl.prototype.definition=function(){return this._def},ASTNodeImpl.prototype.property=function(){return this._prop},ASTNodeImpl.prototype.isExpanded=function(){return this._expanded},ASTNodeImpl.prototype.copy=function(){return new ASTNodeImpl(this.lowLevel().copy(),this.parent(),this.definition(),this.property())},ASTNodeImpl.prototype.clearChildrenCache=function(){this._children=null,this._mergedChildren=null},ASTNodeImpl.prototype.optionalProperties=function(){var def=this.definition();if(null==def)return[];var result=[],map={},children=this.lowLevel().children();children.forEach(function(x){x.optional()&&(map[x.key()]=!0)});var props=def.allProperties();return props.forEach(function(x){var prop=x;map[prop.nameId()]&&result.push(prop.nameId())}),result},ASTNodeImpl}(BasicASTNode);exports.ASTNodeImpl=ASTNodeImpl,exports.universeProvider=__webpack_require__(34);var getDefinitionSystemType=function(contents,ast){var rfl=ramlFirstLine(contents),spec=rfl&&rfl[1]||"",ptype=rfl&&rfl.length>2&&rfl[2]||"Api",originalPType=rfl&&rfl.length>2&&rfl[2],localUniverse="1.0"==spec?new def.Universe(null,"RAML10",exports.universeProvider("RAML10"),"RAML10"):new def.Universe(null,"RAML08",exports.universeProvider("RAML08"));return"API"==ptype?ptype="Api":"NamedExample"==ptype?ptype="ExampleSpec":"DataType"==ptype?ptype="TypeDeclaration":"SecurityScheme"==ptype?ptype="AbstractSecurityScheme":"AnnotationTypeDeclaration"==ptype&&(ptype="TypeDeclaration"),localUniverse.setOriginalTopLevelText(originalPType),localUniverse.setTopLevel(ptype),localUniverse.setTypedVersion(spec),{ptype:ptype,localUniverse:localUniverse}};exports.ramlFirstLine=ramlFirstLine,exports.getFragmentDefenitionName=getFragmentDefenitionName,exports.fromUnit=fromUnit,exports.createBasicValidationAcceptor=createBasicValidationAcceptor},function(module,exports,__webpack_require__){"use strict";function createStub0(parent,property,key){var p=parent.definition().property(property);if(!p)return null;var nc=p.range(),node=createStubNode(nc,p,key);return node}function genStructuredValue(type,name,mappings,parent){var map=yaml.newMap(mappings.map(function(mapping){return yaml.newMapping(yaml.newScalar(mapping.key),yaml.newScalar(mapping.value))})),node=new jsyaml.ASTNode(map,parent?parent.lowLevel().unit():null,parent?parent.lowLevel():null,null,null);return new hlimpl.StructuredValue(node,parent,parent?parent.definition().property(type):null,name)}function createStub(parent,property,key){var p=parent.definition().property(property);if(!p)return null;var nc=p.range(),su=parent.lowLevel().unit().stub(),node=createStubNode(nc,p,key,su);return node.isInEdit=!0,node.lowLevel()._unit=su,node._parent=parent.copy(),node._parent.lowLevel()._unit=su,node}function createResourceStub(parent,key){return createStub(parent,"resources",key)}function createMethodStub(parent,key){return createStub(parent,"methods",key)}function createResponseStub(parent,key){return createStub(parent,"responses",key)}function createBodyStub(parent,key){return createStub(parent,"body",key)}function createUriParameterStub(parent,key){return createStub(parent,"uriParameters",key)}function createQueryParameterStub(parent,key){return createStub(parent,"queryParameters",key)}function createAttr(_property,val){var lowLevel=jsyaml.createMapping(_property.nameId(),val),nm=new hlimpl.ASTPropImpl(lowLevel,null,_property.range(),_property);return nm}function createStubNode(t,p,key,unit){void 0===key&&(key=null);var lowLevel=jsyaml.createNode(key?key:"key"),nm=new hlimpl.ASTNodeImpl(lowLevel,null,t,p);return lowLevel.unit()||(lowLevel._unit=unit),nm.children(),nm}var jsyaml=__webpack_require__(27),hlimpl=__webpack_require__(16),yaml=__webpack_require__(70);exports.createStub0=createStub0,exports.genStructuredValue=genStructuredValue,exports.createStub=createStub,exports.createResourceStub=createResourceStub,exports.createMethodStub=createMethodStub,exports.createResponseStub=createResponseStub,exports.createBodyStub=createBodyStub,exports.createUriParameterStub=createUriParameterStub,exports.createQueryParameterStub=createQueryParameterStub,exports.createAttr=createAttr,exports.createStubNode=createStubNode},function(module,exports,__webpack_require__){"use strict";var _=__webpack_require__(61),textutil=__webpack_require__(41),wrapper=__webpack_require__(20),SchemaToModelGenerator=function(){function SchemaToModelGenerator(){}return SchemaToModelGenerator.prototype.generateText=function(schema){var _this=this,obj=JSON.parse(schema),items=obj.items;if(!items)return"";var text="",itemsArray=items instanceof Array?items:[items];return text+="types:\n",itemsArray.forEach(function(e){text+="  - "+e.title+":\n",text+=_this.generateObj(e,3)}),text},SchemaToModelGenerator.prototype.generateObj=function(e,lev){var text="";if(text+=textutil.indent(lev,"type: "+e.type)+"\n",e.properties){text+=textutil.indent(lev,"properties:\n");for(var name in e.properties){var p=e.properties[name];text+=textutil.indent(lev+1,name+":\n"),text+="object"==p.type?this.generateObj(p,lev+2):textutil.indent(lev+2,"type: "+p.type)+"\n"}return text}},SchemaToModelGenerator.prototype.generateTo=function(api,schema,title){var _this=this,obj=JSON.parse(schema),items=obj.items;if(items){var itemsArray=items instanceof Array?items:[items],types=[];return itemsArray.forEach(function(e){var type=new wrapper.ObjectTypeDeclarationImpl(e.title);_this.generateObjTo(type,e),new wrapper.BasicSecuritySchemeImpl(api).addToProp(type,"types"),types.push(e.title)}),types}obj.title&&(title=obj.title);var type=new wrapper.ObjectTypeDeclarationImpl(title);return this.generateObjTo(type,obj),new wrapper.BasicSecuritySchemeImpl(api).addToProp(type,"types"),[title]},SchemaToModelGenerator.prototype.generateObjTo=function(type,e){if(type.setType(e.type),e.properties)for(var name in e.properties){var p=e.properties[name],field=this.makeTypeField(name,p);"array"==p.type,type.addToProp(field,"properties")}},SchemaToModelGenerator.prototype.makeTypeField=function(name,p){var field=this.makeType(name,p.type);if(p.type&&field.setType(p.type),"number"==p.type){var n=field;void 0!=p.minimum&&n.setMinimum(p.minimum),void 0!=p.maximum&&n.setMaximum(p.maximum)}if("array"==p.type){var itype=p.items.type;field.setType(itype+"[]");var a=field;void 0!=p.minItems&&a.setMinItems(p.minItems),void 0!=p.maxItems&&a.setMaxItems(p.maxItems),
void 0!=p.uniqueItems&&a.setUniqueItems(p.uniqueItems)}return"object"==p.type&&this.generateObjTo(field,p),field},SchemaToModelGenerator.prototype.makeType=function(name,type){return"number"==type?new wrapper.NumberTypeDeclarationImpl(name):"string"==type?new wrapper.StringTypeDeclarationImpl(name):"array"==type?new wrapper.ArrayTypeDeclarationImpl(name):new wrapper.ObjectTypeDeclarationImpl(name)},SchemaToModelGenerator.prototype.generateItemsTo=function(a,obj){var items=obj.items;if(items){var itemsArray=items instanceof Array?items:[items];itemsArray.forEach(function(item){})}},SchemaToModelGenerator}();exports.SchemaToModelGenerator=SchemaToModelGenerator;var ModelToSchemaGenerator=function(){function ModelToSchemaGenerator(){}return ModelToSchemaGenerator.prototype.generateSchema=function(node){var obj=this.generateType(node);return obj.$schema="http://json-schema.org/draft-04/schema#",obj},ModelToSchemaGenerator.prototype.isSimpleType=function(name){return"string"==name||"number"==name||"boolean"==name||"object"==name},ModelToSchemaGenerator.prototype.generateType=function(type){var typelist=this.allTypes(type),obj={};obj.title=type.attrValue("name");if(type.attrValue("type")){var types=type.attributes("type"),inherited=!1,simple=!1;for(var i in types){var typevalue=types[i].value(),ll=types[i].lowLevel();if(obj.type="",ll.isValueInclude()){var schema=JSON.parse(typevalue);obj.type="object",obj.properties=schema.properties}else if(this.isSimpleType(typevalue)){if(obj.type=typevalue,simple=!0,inherited)throw new Error("couldn't mix user defined and basic types in inheritance")}else{var t=this.resolveType(type,typevalue);if(t){var ppp=this.generateTypeExp(typevalue,typelist);if(obj.properties?_.extend(obj.properties,ppp.properties):obj.properties=ppp.properties,obj.type="object",inherited=!0,simple)throw new Error("couldn't mix user defined and basic types in inheritance")}else{var ppp=this.generateTypeExp(typevalue,typelist);obj.type="object",inherited=!0,ppp.anyOf&&(obj.anyOf=ppp.anyOf)}}}}else obj.type="object";var ownProps=this.generateProperties(type);return obj.properties?_.extend(obj.properties,ownProps):obj.properties=ownProps,obj},ModelToSchemaGenerator.prototype.makeUnion=function(typelist,types){var _this=this,anyof=[];return typelist.forEach(function(t){t=t.trim(),types[t]?anyof.push({type:"object",properties:_this.generateType(types[t]).properties}):anyof.push({type:t})}),anyof},ModelToSchemaGenerator.prototype.generateTypeExp=function(type,types){var obj={};if(textutil.endsWith(type,"[]"))obj.type="array",obj.items={type:type.substring(0,type.length-2)};else if(type.indexOf("|")>0){var typelist=type.split("|");obj.anyOf=this.makeUnion(typelist,types)}else if(types[type]){var schema=this.generateType(types[type]);obj.type="object",obj.properties=schema.properties}else obj.type=type;return obj},ModelToSchemaGenerator.prototype.allTypes=function(node){var api=node.root(),modelTypes=api.elementsOfKind("types"),types={};return modelTypes.forEach(function(type){types[type.name()]=type}),types},ModelToSchemaGenerator.prototype.resolveType=function(node,name){var types=this.allTypes(node);return types[name]},ModelToSchemaGenerator.prototype.generateProperty=function(node,optional){var _this=this,types=this.allTypes(node),obj={},props=node.definition().allProperties();props.forEach(function(p){if("name"!=p.nameId()){var value=node.attrValue(p.nameId());if(null!=value&&void 0!=value&&"undefined"!=value)if("type"==p.nameId()){var t=_this.generateTypeExp(value,types);_.extend(obj,t)}else if("enum"==p.nameId()){var values=node.attributes("enum"),arr=values.map(function(a){return a.value()});obj.enum=arr}else obj[p.nameId()]=value}}),optional&&(obj.required=!1);var properties=(node.elements(),this.generateProperties(node));return Object.getOwnPropertyNames(properties).length>0&&(obj.properties=properties),obj},ModelToSchemaGenerator.prototype.generateProperties=function(node){var _this=this,props={},elements=node.elements(),empty=!0;return elements.forEach(function(p){var name=p.attrValue("name");if("string"==typeof name){name=name.trim();var optional=p.optional();props[name]=_this.generateProperty(p,optional),empty=!1}}),props},ModelToSchemaGenerator}();exports.ModelToSchemaGenerator=ModelToSchemaGenerator},function(module,exports,__webpack_require__){"use strict";function createTypeDeclaration(typeName){return new parser10impl.TypeDeclarationImpl(typeName)}function createObjectTypeDeclaration(typeName){return new parser10impl.ObjectTypeDeclarationImpl(typeName)}function setTypeDeclarationSchema(type,schema){type.setSchema(schema)}function setTypeDeclarationExample(type,example){var examplePropName=(defSys.getUniverse("RAML10").type(defSys.universesInfo.Universe10.ExampleSpec.name),defSys.universesInfo.Universe10.TypeDeclaration.properties.example.name),hlParent=type.highLevel(),llParent=hlParent.lowLevel(),exampleNodes=hlParent.children().filter(function(x){return x.lowLevel().key()==examplePropName}),llNode=jsyaml.createNode(examplePropName);ll.setAttr(llNode,example),exampleNodes.length>0&&(ll.removeNode(llParent,exampleNodes[0].lowLevel()),exampleNodes[0]._node=llNode,ll.insertNode(llParent,llNode)),hlParent.createAttr&&hlParent.createAttr(examplePropName,example)}function addChild(parent,child){parent.add(child)}var parser10impl=__webpack_require__(20),defSys=__webpack_require__(36),jsyaml=__webpack_require__(27),ll=__webpack_require__(11);exports.createTypeDeclaration=createTypeDeclaration,exports.createObjectTypeDeclaration=createObjectTypeDeclaration,exports.setTypeDeclarationSchema=setTypeDeclarationSchema,exports.setTypeDeclarationExample=setTypeDeclarationExample,exports.addChild=addChild},function(module,exports,__webpack_require__){"use strict";function createApi(key){var universe=def.getUniverse("RAML10"),nc=universe.type("Api"),node=stubs.createStubNode(nc,null,key);return node}function createLibraryBase(key){var universe=def.getUniverse("RAML10"),nc=universe.type("LibraryBase"),node=stubs.createStubNode(nc,null,key);return node}function createFragmentDeclaration(key){var universe=def.getUniverse("RAML10"),nc=universe.type("FragmentDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createTrait(key){var universe=def.getUniverse("RAML10"),nc=universe.type("Trait"),node=stubs.createStubNode(nc,null,key);return node}function createMethodBase(key){var universe=def.getUniverse("RAML10"),nc=universe.type("MethodBase"),node=stubs.createStubNode(nc,null,key);return node}function createOperation(key){var universe=def.getUniverse("RAML10"),nc=universe.type("Operation"),node=stubs.createStubNode(nc,null,key);return node}function createTypeDeclaration(key){var universe=def.getUniverse("RAML10"),nc=universe.type("TypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createUsesDeclaration(key){var universe=def.getUniverse("RAML10"),nc=universe.type("UsesDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createXMLFacetInfo(key){var universe=def.getUniverse("RAML10"),nc=universe.type("XMLFacetInfo"),node=stubs.createStubNode(nc,null,key);return node}function createArrayTypeDeclaration(key){var universe=def.getUniverse("RAML10"),nc=universe.type("ArrayTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createUnionTypeDeclaration(key){var universe=def.getUniverse("RAML10"),nc=universe.type("UnionTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createObjectTypeDeclaration(key){var universe=def.getUniverse("RAML10"),nc=universe.type("ObjectTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createStringTypeDeclaration(key){var universe=def.getUniverse("RAML10"),nc=universe.type("StringTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createBooleanTypeDeclaration(key){var universe=def.getUniverse("RAML10"),nc=universe.type("BooleanTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createNumberTypeDeclaration(key){var universe=def.getUniverse("RAML10"),nc=universe.type("NumberTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createIntegerTypeDeclaration(key){var universe=def.getUniverse("RAML10"),nc=universe.type("IntegerTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createDateOnlyTypeDeclaration(key){var universe=def.getUniverse("RAML10"),nc=universe.type("DateOnlyTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createTimeOnlyTypeDeclaration(key){var universe=def.getUniverse("RAML10"),nc=universe.type("TimeOnlyTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createDateTimeOnlyTypeDeclaration(key){var universe=def.getUniverse("RAML10"),nc=universe.type("DateTimeOnlyTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createDateTimeTypeDeclaration(key){var universe=def.getUniverse("RAML10"),nc=universe.type("DateTimeTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createDateTypeDeclaration(key){var universe=def.getUniverse("RAML10"),nc=universe.type("DateTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createFileTypeDeclaration(key){var universe=def.getUniverse("RAML10"),nc=universe.type("FileTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createResponse(key){var universe=def.getUniverse("RAML10"),nc=universe.type("Response"),node=stubs.createStubNode(nc,null,key);return node}function createSecuritySchemePart(key){var universe=def.getUniverse("RAML10"),nc=universe.type("SecuritySchemePart"),node=stubs.createStubNode(nc,null,key);return node}function createAbstractSecurityScheme(key){var universe=def.getUniverse("RAML10"),nc=universe.type("AbstractSecurityScheme"),node=stubs.createStubNode(nc,null,key);return node}function createSecuritySchemeSettings(key){var universe=def.getUniverse("RAML10"),nc=universe.type("SecuritySchemeSettings"),node=stubs.createStubNode(nc,null,key);return node}function createOAuth1SecuritySchemeSettings(key){var universe=def.getUniverse("RAML10"),nc=universe.type("OAuth1SecuritySchemeSettings"),node=stubs.createStubNode(nc,null,key);return node}function createOAuth2SecuritySchemeSettings(key){var universe=def.getUniverse("RAML10"),nc=universe.type("OAuth2SecuritySchemeSettings"),node=stubs.createStubNode(nc,null,key);return node}function createOAuth2SecurityScheme(key){var universe=def.getUniverse("RAML10"),nc=universe.type("OAuth2SecurityScheme"),node=stubs.createStubNode(nc,null,key);return node}function createOAuth1SecurityScheme(key){var universe=def.getUniverse("RAML10"),nc=universe.type("OAuth1SecurityScheme"),node=stubs.createStubNode(nc,null,key);return node}function createPassThroughSecurityScheme(key){var universe=def.getUniverse("RAML10"),nc=universe.type("PassThroughSecurityScheme"),node=stubs.createStubNode(nc,null,key);return node}function createBasicSecurityScheme(key){var universe=def.getUniverse("RAML10"),nc=universe.type("BasicSecurityScheme"),node=stubs.createStubNode(nc,null,key);return node}function createDigestSecurityScheme(key){var universe=def.getUniverse("RAML10"),nc=universe.type("DigestSecurityScheme"),node=stubs.createStubNode(nc,null,key);return node}function createCustomSecurityScheme(key){var universe=def.getUniverse("RAML10"),nc=universe.type("CustomSecurityScheme"),node=stubs.createStubNode(nc,null,key);return node}function createMethod(key){var universe=def.getUniverse("RAML10"),nc=universe.type("Method"),node=stubs.createStubNode(nc,null,key);return node}function createResourceType(key){var universe=def.getUniverse("RAML10"),nc=universe.type("ResourceType"),node=stubs.createStubNode(nc,null,key);return node}function createResourceBase(key){var universe=def.getUniverse("RAML10"),nc=universe.type("ResourceBase"),node=stubs.createStubNode(nc,null,key);return node}function createResource(key){var universe=def.getUniverse("RAML10"),nc=universe.type("Resource"),node=stubs.createStubNode(nc,null,key);return node}function createDocumentationItem(key){var universe=def.getUniverse("RAML10"),nc=universe.type("DocumentationItem"),node=stubs.createStubNode(nc,null,key);return node}function createLibrary(key){var universe=def.getUniverse("RAML10"),nc=universe.type("Library"),node=stubs.createStubNode(nc,null,key);return node}function createOverlay(key){var universe=def.getUniverse("RAML10"),nc=universe.type("Overlay"),node=stubs.createStubNode(nc,null,key);return node}function createExtension(key){var universe=def.getUniverse("RAML10"),nc=universe.type("Extension"),node=stubs.createStubNode(nc,null,key);return node}function loadApiSync(apiPath,arg1,arg2){return apiLoader.loadApi(apiPath,arg1,arg2).getOrElse(null)}function loadRAMLSync(ramlPath,arg1,arg2){return apiLoader.loadApi(ramlPath,arg1,arg2).getOrElse(null)}function loadApi(apiPath,arg1,arg2){return apiLoader.loadApiAsync(apiPath,arg1,arg2)}function loadRAML(ramlPath,arg1,arg2){return apiLoader.loadRAMLAsync(ramlPath,arg1,arg2)}function getLanguageElementByRuntimeType(runtimeType){return apiLoader.getLanguageElementByRuntimeType(runtimeType)}var __extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},stubs=__webpack_require__(17),def=__webpack_require__(36),core=__webpack_require__(45),apiLoader=__webpack_require__(9),helper=__webpack_require__(32),AnnotableImpl=function(_super){function AnnotableImpl(){_super.apply(this,arguments)}return __extends(AnnotableImpl,_super),AnnotableImpl.prototype.annotations=function(){return _super.prototype.attributes.call(this,"annotations",function(attr){return new AnnotationRefImpl(attr)})},AnnotableImpl.prototype.wrapperClassName=function(){return"AnnotableImpl"},AnnotableImpl.prototype.kind=function(){return"Annotable"},AnnotableImpl.prototype.RAMLVersion=function(){return"RAML10"},AnnotableImpl.prototype.scalarsAnnotations=function(){return new AnnotableScalarsAnnotationsImpl(this.highLevel())},AnnotableImpl}(core.BasicNodeImpl);exports.AnnotableImpl=AnnotableImpl;var ValueTypeImpl=function(_super){function ValueTypeImpl(){_super.apply(this,arguments)}return __extends(ValueTypeImpl,_super),ValueTypeImpl.prototype.wrapperClassName=function(){return"ValueTypeImpl"},ValueTypeImpl.prototype.kind=function(){return"ValueType"},ValueTypeImpl.prototype.RAMLVersion=function(){return"undefined"},ValueTypeImpl.prototype.value=function(){return this.attr.value()},ValueTypeImpl}(core.AttributeNodeImpl);exports.ValueTypeImpl=ValueTypeImpl;var StringTypeImpl=function(_super){function StringTypeImpl(){_super.apply(this,arguments)}return __extends(StringTypeImpl,_super),StringTypeImpl.prototype.wrapperClassName=function(){return"StringTypeImpl"},StringTypeImpl.prototype.kind=function(){return"StringType"},StringTypeImpl.prototype.RAMLVersion=function(){return"RAML10"},StringTypeImpl.prototype.value=function(){return this.attr.value()},StringTypeImpl}(ValueTypeImpl);exports.StringTypeImpl=StringTypeImpl;var UriTemplateImpl=function(_super){function UriTemplateImpl(){_super.apply(this,arguments)}return __extends(UriTemplateImpl,_super),UriTemplateImpl.prototype.wrapperClassName=function(){return"UriTemplateImpl"},UriTemplateImpl.prototype.kind=function(){return"UriTemplate"},UriTemplateImpl.prototype.RAMLVersion=function(){return"RAML10"},UriTemplateImpl}(StringTypeImpl);exports.UriTemplateImpl=UriTemplateImpl;var RelativeUriStringImpl=function(_super){function RelativeUriStringImpl(){_super.apply(this,arguments)}return __extends(RelativeUriStringImpl,_super),RelativeUriStringImpl.prototype.wrapperClassName=function(){return"RelativeUriStringImpl"},RelativeUriStringImpl.prototype.kind=function(){return"RelativeUriString"},RelativeUriStringImpl.prototype.RAMLVersion=function(){return"RAML10"},RelativeUriStringImpl}(UriTemplateImpl);exports.RelativeUriStringImpl=RelativeUriStringImpl;var FullUriTemplateStringImpl=function(_super){function FullUriTemplateStringImpl(){_super.apply(this,arguments)}return __extends(FullUriTemplateStringImpl,_super),FullUriTemplateStringImpl.prototype.wrapperClassName=function(){return"FullUriTemplateStringImpl"},FullUriTemplateStringImpl.prototype.kind=function(){return"FullUriTemplateString"},FullUriTemplateStringImpl.prototype.RAMLVersion=function(){return"RAML10"},FullUriTemplateStringImpl}(UriTemplateImpl);exports.FullUriTemplateStringImpl=FullUriTemplateStringImpl;var StatusCodeStringImpl=function(_super){function StatusCodeStringImpl(){_super.apply(this,arguments)}return __extends(StatusCodeStringImpl,_super),StatusCodeStringImpl.prototype.wrapperClassName=function(){return"StatusCodeStringImpl"},StatusCodeStringImpl.prototype.kind=function(){return"StatusCodeString"},StatusCodeStringImpl.prototype.RAMLVersion=function(){return"RAML10"},StatusCodeStringImpl}(StringTypeImpl);exports.StatusCodeStringImpl=StatusCodeStringImpl;var FixedUriStringImpl=function(_super){function FixedUriStringImpl(){_super.apply(this,arguments)}return __extends(FixedUriStringImpl,_super),FixedUriStringImpl.prototype.wrapperClassName=function(){return"FixedUriStringImpl"},FixedUriStringImpl.prototype.kind=function(){return"FixedUriString"},FixedUriStringImpl.prototype.RAMLVersion=function(){return"RAML10"},FixedUriStringImpl}(StringTypeImpl);exports.FixedUriStringImpl=FixedUriStringImpl;var ContentTypeImpl=function(_super){function ContentTypeImpl(){_super.apply(this,arguments)}return __extends(ContentTypeImpl,_super),ContentTypeImpl.prototype.wrapperClassName=function(){return"ContentTypeImpl"},ContentTypeImpl.prototype.kind=function(){return"ContentType"},ContentTypeImpl.prototype.RAMLVersion=function(){return"RAML10"},ContentTypeImpl}(StringTypeImpl);exports.ContentTypeImpl=ContentTypeImpl;var MarkdownStringImpl=function(_super){function MarkdownStringImpl(){_super.apply(this,arguments)}return __extends(MarkdownStringImpl,_super),MarkdownStringImpl.prototype.wrapperClassName=function(){return"MarkdownStringImpl"},MarkdownStringImpl.prototype.kind=function(){return"MarkdownString"},MarkdownStringImpl.prototype.RAMLVersion=function(){return"RAML10"},MarkdownStringImpl}(StringTypeImpl);exports.MarkdownStringImpl=MarkdownStringImpl;var SchemaStringImpl=function(_super){function SchemaStringImpl(){_super.apply(this,arguments)}return __extends(SchemaStringImpl,_super),SchemaStringImpl.prototype.wrapperClassName=function(){return"SchemaStringImpl"},SchemaStringImpl.prototype.kind=function(){return"SchemaString"},SchemaStringImpl.prototype.RAMLVersion=function(){return"RAML10"},SchemaStringImpl}(StringTypeImpl);exports.SchemaStringImpl=SchemaStringImpl;var MimeTypeImpl=function(_super){function MimeTypeImpl(){_super.apply(this,arguments)}return __extends(MimeTypeImpl,_super),MimeTypeImpl.prototype.wrapperClassName=function(){return"MimeTypeImpl"},MimeTypeImpl.prototype.kind=function(){return"MimeType"},MimeTypeImpl.prototype.RAMLVersion=function(){return"RAML10"},MimeTypeImpl}(StringTypeImpl);exports.MimeTypeImpl=MimeTypeImpl;var AnyTypeImpl=function(_super){function AnyTypeImpl(){_super.apply(this,arguments)}return __extends(AnyTypeImpl,_super),AnyTypeImpl.prototype.wrapperClassName=function(){return"AnyTypeImpl"},AnyTypeImpl.prototype.kind=function(){return"AnyType"},AnyTypeImpl.prototype.RAMLVersion=function(){return"RAML10"},AnyTypeImpl}(ValueTypeImpl);exports.AnyTypeImpl=AnyTypeImpl;var NumberTypeImpl=function(_super){function NumberTypeImpl(){_super.apply(this,arguments)}return __extends(NumberTypeImpl,_super),NumberTypeImpl.prototype.wrapperClassName=function(){return"NumberTypeImpl"},NumberTypeImpl.prototype.kind=function(){return"NumberType"},NumberTypeImpl.prototype.RAMLVersion=function(){return"RAML10"},NumberTypeImpl.prototype.value=function(){return this.attr.value()},NumberTypeImpl}(ValueTypeImpl);exports.NumberTypeImpl=NumberTypeImpl;var IntegerTypeImpl=function(_super){function IntegerTypeImpl(){_super.apply(this,arguments)}return __extends(IntegerTypeImpl,_super),IntegerTypeImpl.prototype.wrapperClassName=function(){return"IntegerTypeImpl"},IntegerTypeImpl.prototype.kind=function(){return"IntegerType"},IntegerTypeImpl.prototype.RAMLVersion=function(){return"RAML10"},IntegerTypeImpl}(ValueTypeImpl);exports.IntegerTypeImpl=IntegerTypeImpl;var NullTypeImpl=function(_super){function NullTypeImpl(){_super.apply(this,arguments)}return __extends(NullTypeImpl,_super),NullTypeImpl.prototype.wrapperClassName=function(){return"NullTypeImpl"},NullTypeImpl.prototype.kind=function(){return"NullType"},NullTypeImpl.prototype.RAMLVersion=function(){return"RAML10"},NullTypeImpl}(ValueTypeImpl);exports.NullTypeImpl=NullTypeImpl;var TimeOnlyTypeImpl=function(_super){function TimeOnlyTypeImpl(){_super.apply(this,arguments)}return __extends(TimeOnlyTypeImpl,_super),TimeOnlyTypeImpl.prototype.wrapperClassName=function(){return"TimeOnlyTypeImpl"},TimeOnlyTypeImpl.prototype.kind=function(){return"TimeOnlyType"},TimeOnlyTypeImpl.prototype.RAMLVersion=function(){return"RAML10"},TimeOnlyTypeImpl}(ValueTypeImpl);exports.TimeOnlyTypeImpl=TimeOnlyTypeImpl;var DateOnlyTypeImpl=function(_super){function DateOnlyTypeImpl(){_super.apply(this,arguments)}return __extends(DateOnlyTypeImpl,_super),DateOnlyTypeImpl.prototype.wrapperClassName=function(){return"DateOnlyTypeImpl"},DateOnlyTypeImpl.prototype.kind=function(){return"DateOnlyType"},DateOnlyTypeImpl.prototype.RAMLVersion=function(){return"RAML10"},DateOnlyTypeImpl}(ValueTypeImpl);exports.DateOnlyTypeImpl=DateOnlyTypeImpl;var DateTimeOnlyTypeImpl=function(_super){function DateTimeOnlyTypeImpl(){_super.apply(this,arguments)}return __extends(DateTimeOnlyTypeImpl,_super),DateTimeOnlyTypeImpl.prototype.wrapperClassName=function(){return"DateTimeOnlyTypeImpl"},DateTimeOnlyTypeImpl.prototype.kind=function(){return"DateTimeOnlyType"},DateTimeOnlyTypeImpl.prototype.RAMLVersion=function(){return"RAML10"},DateTimeOnlyTypeImpl}(ValueTypeImpl);exports.DateTimeOnlyTypeImpl=DateTimeOnlyTypeImpl;var DateTimeTypeImpl=function(_super){function DateTimeTypeImpl(){_super.apply(this,arguments)}return __extends(DateTimeTypeImpl,_super),DateTimeTypeImpl.prototype.wrapperClassName=function(){return"DateTimeTypeImpl"},DateTimeTypeImpl.prototype.kind=function(){return"DateTimeType"},DateTimeTypeImpl.prototype.RAMLVersion=function(){return"RAML10"},DateTimeTypeImpl}(ValueTypeImpl);exports.DateTimeTypeImpl=DateTimeTypeImpl;var FileTypeImpl=function(_super){function FileTypeImpl(){_super.apply(this,arguments)}return __extends(FileTypeImpl,_super),FileTypeImpl.prototype.wrapperClassName=function(){return"FileTypeImpl"},FileTypeImpl.prototype.kind=function(){return"FileType"},FileTypeImpl.prototype.RAMLVersion=function(){return"RAML10"},FileTypeImpl}(ValueTypeImpl);exports.FileTypeImpl=FileTypeImpl;var BooleanTypeImpl=function(_super){function BooleanTypeImpl(){_super.apply(this,arguments)}return __extends(BooleanTypeImpl,_super),BooleanTypeImpl.prototype.wrapperClassName=function(){return"BooleanTypeImpl"},BooleanTypeImpl.prototype.kind=function(){return"BooleanType"},BooleanTypeImpl.prototype.RAMLVersion=function(){return"RAML10"},BooleanTypeImpl.prototype.value=function(){return this.attr.value()},BooleanTypeImpl}(ValueTypeImpl);exports.BooleanTypeImpl=BooleanTypeImpl;var AnnotationTargetImpl=function(_super){function AnnotationTargetImpl(){_super.apply(this,arguments)}return __extends(AnnotationTargetImpl,_super),AnnotationTargetImpl.prototype.wrapperClassName=function(){return"AnnotationTargetImpl"},AnnotationTargetImpl.prototype.kind=function(){return"AnnotationTarget"},AnnotationTargetImpl.prototype.RAMLVersion=function(){return"RAML10"},AnnotationTargetImpl}(ValueTypeImpl);exports.AnnotationTargetImpl=AnnotationTargetImpl;var ReferenceImpl=function(_super){function ReferenceImpl(){_super.apply(this,arguments)}return __extends(ReferenceImpl,_super),ReferenceImpl.prototype.wrapperClassName=function(){return"ReferenceImpl"},ReferenceImpl.prototype.kind=function(){return"Reference"},ReferenceImpl.prototype.RAMLVersion=function(){return"RAML10"},ReferenceImpl.prototype.value=function(){return core.toStructuredValue(this.attr)},ReferenceImpl.prototype.structuredValue=function(){return helper.structuredValue(this)},ReferenceImpl.prototype.name=function(){return helper.referenceName(this)},ReferenceImpl}(core.AttributeNodeImpl);exports.ReferenceImpl=ReferenceImpl;var TraitRefImpl=function(_super){function TraitRefImpl(){_super.apply(this,arguments)}return __extends(TraitRefImpl,_super),TraitRefImpl.prototype.wrapperClassName=function(){return"TraitRefImpl"},TraitRefImpl.prototype.kind=function(){return"TraitRef"},TraitRefImpl.prototype.RAMLVersion=function(){return"RAML10"},TraitRefImpl.prototype.trait=function(){return helper.referencedTrait(this)},TraitRefImpl}(ReferenceImpl);exports.TraitRefImpl=TraitRefImpl;var OperationImpl=function(_super){function OperationImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createOperation(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(OperationImpl,_super),OperationImpl.prototype.queryParameters=function(){return _super.prototype.elements.call(this,"queryParameters")},OperationImpl.prototype.headers=function(){return _super.prototype.elements.call(this,"headers")},OperationImpl.prototype.queryString=function(){return _super.prototype.element.call(this,"queryString")},OperationImpl.prototype.responses=function(){return _super.prototype.elements.call(this,"responses")},OperationImpl.prototype.wrapperClassName=function(){return"OperationImpl"},OperationImpl.prototype.kind=function(){return"Operation"},OperationImpl.prototype.RAMLVersion=function(){return"RAML10"},OperationImpl}(AnnotableImpl);exports.OperationImpl=OperationImpl;var TypeDeclarationImpl=function(_super){function TypeDeclarationImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(TypeDeclarationImpl,_super),TypeDeclarationImpl.prototype.name=function(){return _super.prototype.attribute.call(this,"name",this.toString)},TypeDeclarationImpl.prototype.setName=function(param){return this.highLevel().attrOrCreate("name").setValue(""+param),this},TypeDeclarationImpl.prototype.displayName=function(){return _super.prototype.attribute.call(this,"displayName",this.toString)},TypeDeclarationImpl.prototype.setDisplayName=function(param){return this.highLevel().attrOrCreate("displayName").setValue(""+param),this},TypeDeclarationImpl.prototype.facets=function(){return _super.prototype.elements.call(this,"facets")},TypeDeclarationImpl.prototype.schema_original=function(){return _super.prototype.attributes.call(this,"schema",this.toString)},TypeDeclarationImpl.prototype.setSchema=function(param){return this.highLevel().attrOrCreate("schema").setValue(""+param),this},TypeDeclarationImpl.prototype.type_original=function(){return _super.prototype.attributes.call(this,"type",this.toString)},TypeDeclarationImpl.prototype.setType=function(param){return this.highLevel().attrOrCreate("type").setValue(""+param),this},TypeDeclarationImpl.prototype.location=function(){return _super.prototype.attribute.call(this,"location",function(attr){return new ModelLocationImpl(attr)})},TypeDeclarationImpl.prototype.locationKind=function(){return _super.prototype.attribute.call(this,"locationKind",function(attr){return new LocationKindImpl(attr)})},TypeDeclarationImpl.prototype.default=function(){return _super.prototype.attribute.call(this,"default",this.toAny)},TypeDeclarationImpl.prototype.setDefault=function(param){return this.highLevel().attrOrCreate("default").setValue(""+param),this},TypeDeclarationImpl.prototype.example_original=function(){return _super.prototype.element.call(this,"example")},TypeDeclarationImpl.prototype.examples_original=function(){return _super.prototype.elements.call(this,"examples")},TypeDeclarationImpl.prototype.required=function(){return _super.prototype.attribute.call(this,"required",this.toBoolean)},TypeDeclarationImpl.prototype.setRequired=function(param){return this.highLevel().attrOrCreate("required").setValue(""+param),this},TypeDeclarationImpl.prototype.description=function(){return _super.prototype.attribute.call(this,"description",function(attr){return new MarkdownStringImpl(attr)})},TypeDeclarationImpl.prototype.xml=function(){return _super.prototype.element.call(this,"xml")},TypeDeclarationImpl.prototype.allowedTargets=function(){return _super.prototype.attributes.call(this,"allowedTargets",function(attr){return new AnnotationTargetImpl(attr)})},TypeDeclarationImpl.prototype.isAnnotation=function(){return _super.prototype.attribute.call(this,"isAnnotation",this.toBoolean)},TypeDeclarationImpl.prototype.setIsAnnotation=function(param){return this.highLevel().attrOrCreate("isAnnotation").setValue(""+param),this},TypeDeclarationImpl.prototype.annotations=function(){return _super.prototype.attributes.call(this,"annotations",function(attr){return new AnnotationRefImpl(attr)})},TypeDeclarationImpl.prototype.uses=function(){return _super.prototype.elements.call(this,"uses")},TypeDeclarationImpl.prototype.wrapperClassName=function(){return"TypeDeclarationImpl"},TypeDeclarationImpl.prototype.kind=function(){return"TypeDeclaration"},TypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML10"},TypeDeclarationImpl.prototype.runtimeType=function(){return helper.runtimeType(this)},TypeDeclarationImpl.prototype.validateInstance=function(value){return helper.validateInstance(this,value)},TypeDeclarationImpl.prototype.validateInstanceWithDetailedStatuses=function(value){return helper.validateInstanceWithDetailedStatuses(this,value)},TypeDeclarationImpl.prototype.example=function(){return helper.getTypeExample(this)},TypeDeclarationImpl.prototype.examples=function(){return helper.getTypeExamples(this)},TypeDeclarationImpl.prototype.fixedFacets=function(){return helper.typeFixedFacets(this)},TypeDeclarationImpl.prototype.type=function(){return helper.typeValue(this)},TypeDeclarationImpl.prototype.schema=function(){return helper.schemaValue(this)},TypeDeclarationImpl.prototype.structuredType=function(){return helper.typeStructuredValue(this)},TypeDeclarationImpl.prototype.parametrizedProperties=function(){return helper.getTemplateParametrizedProperties(this)},TypeDeclarationImpl.prototype.scalarsAnnotations=function(){return new TypeDeclarationScalarsAnnotationsImpl(this.highLevel())},TypeDeclarationImpl}(AnnotableImpl);exports.TypeDeclarationImpl=TypeDeclarationImpl;var ModelLocationImpl=function(){function ModelLocationImpl(attr){this.attr=attr}return ModelLocationImpl.prototype.wrapperClassName=function(){return"ModelLocationImpl"},ModelLocationImpl.prototype.kind=function(){return"ModelLocation"},ModelLocationImpl.prototype.RAMLVersion=function(){return"RAML10"},ModelLocationImpl}();exports.ModelLocationImpl=ModelLocationImpl;var LocationKindImpl=function(){function LocationKindImpl(attr){this.attr=attr}return LocationKindImpl.prototype.wrapperClassName=function(){return"LocationKindImpl"},LocationKindImpl.prototype.kind=function(){return"LocationKind"},LocationKindImpl.prototype.RAMLVersion=function(){return"RAML10"},LocationKindImpl}();exports.LocationKindImpl=LocationKindImpl;var UsesDeclarationImpl=function(_super){function UsesDeclarationImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createUsesDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(UsesDeclarationImpl,_super),UsesDeclarationImpl.prototype.key=function(){return _super.prototype.attribute.call(this,"key",this.toString)},UsesDeclarationImpl.prototype.setKey=function(param){return this.highLevel().attrOrCreate("key").setValue(""+param),
this},UsesDeclarationImpl.prototype.value=function(){return _super.prototype.attribute.call(this,"value",this.toString)},UsesDeclarationImpl.prototype.setValue=function(param){return this.highLevel().attrOrCreate("value").setValue(""+param),this},UsesDeclarationImpl.prototype.wrapperClassName=function(){return"UsesDeclarationImpl"},UsesDeclarationImpl.prototype.kind=function(){return"UsesDeclaration"},UsesDeclarationImpl.prototype.RAMLVersion=function(){return"RAML10"},UsesDeclarationImpl.prototype.ast=function(){return helper.referencedNode(this)},UsesDeclarationImpl.prototype.scalarsAnnotations=function(){return new UsesDeclarationScalarsAnnotationsImpl(this.highLevel())},UsesDeclarationImpl}(AnnotableImpl);exports.UsesDeclarationImpl=UsesDeclarationImpl;var AnnotableScalarsAnnotationsImpl=function(){function AnnotableScalarsAnnotationsImpl(node){this.node=node}return AnnotableScalarsAnnotationsImpl.prototype.annotations=function(){var attrs=this.node.attributes("annotations");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},AnnotableScalarsAnnotationsImpl}();exports.AnnotableScalarsAnnotationsImpl=AnnotableScalarsAnnotationsImpl;var UsesDeclarationScalarsAnnotationsImpl=function(_super){function UsesDeclarationScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(UsesDeclarationScalarsAnnotationsImpl,_super),UsesDeclarationScalarsAnnotationsImpl.prototype.value=function(){var attr=this.node.attr("value");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},UsesDeclarationScalarsAnnotationsImpl}(AnnotableScalarsAnnotationsImpl);exports.UsesDeclarationScalarsAnnotationsImpl=UsesDeclarationScalarsAnnotationsImpl;var XMLFacetInfoImpl=function(_super){function XMLFacetInfoImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createXMLFacetInfo(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(XMLFacetInfoImpl,_super),XMLFacetInfoImpl.prototype.attribute=function(){return _super.prototype.attribute.call(this,"attribute",this.toBoolean)},XMLFacetInfoImpl.prototype.setAttribute=function(param){return this.highLevel().attrOrCreate("attribute").setValue(""+param),this},XMLFacetInfoImpl.prototype.wrapped=function(){return _super.prototype.attribute.call(this,"wrapped",this.toBoolean)},XMLFacetInfoImpl.prototype.setWrapped=function(param){return this.highLevel().attrOrCreate("wrapped").setValue(""+param),this},XMLFacetInfoImpl.prototype.name=function(){return _super.prototype.attribute.call(this,"name",this.toString)},XMLFacetInfoImpl.prototype.setName=function(param){return this.highLevel().attrOrCreate("name").setValue(""+param),this},XMLFacetInfoImpl.prototype.namespace=function(){return _super.prototype.attribute.call(this,"namespace",this.toString)},XMLFacetInfoImpl.prototype.setNamespace=function(param){return this.highLevel().attrOrCreate("namespace").setValue(""+param),this},XMLFacetInfoImpl.prototype.prefix=function(){return _super.prototype.attribute.call(this,"prefix",this.toString)},XMLFacetInfoImpl.prototype.setPrefix=function(param){return this.highLevel().attrOrCreate("prefix").setValue(""+param),this},XMLFacetInfoImpl.prototype.wrapperClassName=function(){return"XMLFacetInfoImpl"},XMLFacetInfoImpl.prototype.kind=function(){return"XMLFacetInfo"},XMLFacetInfoImpl.prototype.RAMLVersion=function(){return"RAML10"},XMLFacetInfoImpl.prototype.scalarsAnnotations=function(){return new XMLFacetInfoScalarsAnnotationsImpl(this.highLevel())},XMLFacetInfoImpl}(AnnotableImpl);exports.XMLFacetInfoImpl=XMLFacetInfoImpl;var XMLFacetInfoScalarsAnnotationsImpl=function(_super){function XMLFacetInfoScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(XMLFacetInfoScalarsAnnotationsImpl,_super),XMLFacetInfoScalarsAnnotationsImpl.prototype.attribute=function(){var attr=this.node.attr("attribute");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},XMLFacetInfoScalarsAnnotationsImpl.prototype.wrapped=function(){var attr=this.node.attr("wrapped");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},XMLFacetInfoScalarsAnnotationsImpl.prototype.name=function(){var attr=this.node.attr("name");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},XMLFacetInfoScalarsAnnotationsImpl.prototype.namespace=function(){var attr=this.node.attr("namespace");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},XMLFacetInfoScalarsAnnotationsImpl.prototype.prefix=function(){var attr=this.node.attr("prefix");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},XMLFacetInfoScalarsAnnotationsImpl}(AnnotableScalarsAnnotationsImpl);exports.XMLFacetInfoScalarsAnnotationsImpl=XMLFacetInfoScalarsAnnotationsImpl;var ArrayTypeDeclarationImpl=function(_super){function ArrayTypeDeclarationImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createArrayTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(ArrayTypeDeclarationImpl,_super),ArrayTypeDeclarationImpl.prototype.uniqueItems=function(){return _super.prototype.attribute.call(this,"uniqueItems",this.toBoolean)},ArrayTypeDeclarationImpl.prototype.setUniqueItems=function(param){return this.highLevel().attrOrCreate("uniqueItems").setValue(""+param),this},ArrayTypeDeclarationImpl.prototype.items_original=function(){return _super.prototype.element.call(this,"items")},ArrayTypeDeclarationImpl.prototype.minItems=function(){return _super.prototype.attribute.call(this,"minItems",this.toNumber)},ArrayTypeDeclarationImpl.prototype.setMinItems=function(param){return this.highLevel().attrOrCreate("minItems").setValue(""+param),this},ArrayTypeDeclarationImpl.prototype.maxItems=function(){return _super.prototype.attribute.call(this,"maxItems",this.toNumber)},ArrayTypeDeclarationImpl.prototype.setMaxItems=function(param){return this.highLevel().attrOrCreate("maxItems").setValue(""+param),this},ArrayTypeDeclarationImpl.prototype.wrapperClassName=function(){return"ArrayTypeDeclarationImpl"},ArrayTypeDeclarationImpl.prototype.kind=function(){return"ArrayTypeDeclaration"},ArrayTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML10"},ArrayTypeDeclarationImpl.prototype.items=function(){return helper.getItems(this)},ArrayTypeDeclarationImpl.prototype.findComponentTypeDeclaration=function(){return helper.findComponentTypeDeclaration(this)},ArrayTypeDeclarationImpl.prototype.scalarsAnnotations=function(){return new ArrayTypeDeclarationScalarsAnnotationsImpl(this.highLevel())},ArrayTypeDeclarationImpl}(TypeDeclarationImpl);exports.ArrayTypeDeclarationImpl=ArrayTypeDeclarationImpl;var TypeDeclarationScalarsAnnotationsImpl=function(_super){function TypeDeclarationScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(TypeDeclarationScalarsAnnotationsImpl,_super),TypeDeclarationScalarsAnnotationsImpl.prototype.displayName=function(){var attr=this.node.attr("displayName");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},TypeDeclarationScalarsAnnotationsImpl.prototype.schema=function(){var attrs=this.node.attributes("schema");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},TypeDeclarationScalarsAnnotationsImpl.prototype.type=function(){var attrs=this.node.attributes("type");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},TypeDeclarationScalarsAnnotationsImpl.prototype.location=function(){var attr=this.node.attr("location");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},TypeDeclarationScalarsAnnotationsImpl.prototype.locationKind=function(){var attr=this.node.attr("locationKind");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},TypeDeclarationScalarsAnnotationsImpl.prototype.default=function(){var attr=this.node.attr("default");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},TypeDeclarationScalarsAnnotationsImpl.prototype.required=function(){var attr=this.node.attr("required");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},TypeDeclarationScalarsAnnotationsImpl.prototype.description=function(){var attr=this.node.attr("description");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},TypeDeclarationScalarsAnnotationsImpl.prototype.allowedTargets=function(){var attrs=this.node.attributes("allowedTargets");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},TypeDeclarationScalarsAnnotationsImpl.prototype.isAnnotation=function(){var attr=this.node.attr("isAnnotation");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},TypeDeclarationScalarsAnnotationsImpl.prototype.annotations=function(){var attrs=this.node.attributes("annotations");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},TypeDeclarationScalarsAnnotationsImpl}(AnnotableScalarsAnnotationsImpl);exports.TypeDeclarationScalarsAnnotationsImpl=TypeDeclarationScalarsAnnotationsImpl;var ArrayTypeDeclarationScalarsAnnotationsImpl=function(_super){function ArrayTypeDeclarationScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(ArrayTypeDeclarationScalarsAnnotationsImpl,_super),ArrayTypeDeclarationScalarsAnnotationsImpl.prototype.uniqueItems=function(){var attr=this.node.attr("uniqueItems");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ArrayTypeDeclarationScalarsAnnotationsImpl.prototype.minItems=function(){var attr=this.node.attr("minItems");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ArrayTypeDeclarationScalarsAnnotationsImpl.prototype.maxItems=function(){var attr=this.node.attr("maxItems");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ArrayTypeDeclarationScalarsAnnotationsImpl}(TypeDeclarationScalarsAnnotationsImpl);exports.ArrayTypeDeclarationScalarsAnnotationsImpl=ArrayTypeDeclarationScalarsAnnotationsImpl;var UnionTypeDeclarationImpl=function(_super){function UnionTypeDeclarationImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createUnionTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(UnionTypeDeclarationImpl,_super),UnionTypeDeclarationImpl.prototype.wrapperClassName=function(){return"UnionTypeDeclarationImpl"},UnionTypeDeclarationImpl.prototype.kind=function(){return"UnionTypeDeclaration"},UnionTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML10"},UnionTypeDeclarationImpl}(TypeDeclarationImpl);exports.UnionTypeDeclarationImpl=UnionTypeDeclarationImpl;var ObjectTypeDeclarationImpl=function(_super){function ObjectTypeDeclarationImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createObjectTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(ObjectTypeDeclarationImpl,_super),ObjectTypeDeclarationImpl.prototype.properties=function(){return _super.prototype.elements.call(this,"properties")},ObjectTypeDeclarationImpl.prototype.minProperties=function(){return _super.prototype.attribute.call(this,"minProperties",this.toNumber)},ObjectTypeDeclarationImpl.prototype.setMinProperties=function(param){return this.highLevel().attrOrCreate("minProperties").setValue(""+param),this},ObjectTypeDeclarationImpl.prototype.maxProperties=function(){return _super.prototype.attribute.call(this,"maxProperties",this.toNumber)},ObjectTypeDeclarationImpl.prototype.setMaxProperties=function(param){return this.highLevel().attrOrCreate("maxProperties").setValue(""+param),this},ObjectTypeDeclarationImpl.prototype.additionalProperties=function(){return _super.prototype.attribute.call(this,"additionalProperties",this.toBoolean)},ObjectTypeDeclarationImpl.prototype.setAdditionalProperties=function(param){return this.highLevel().attrOrCreate("additionalProperties").setValue(""+param),this},ObjectTypeDeclarationImpl.prototype.discriminator=function(){return _super.prototype.attribute.call(this,"discriminator",this.toString)},ObjectTypeDeclarationImpl.prototype.setDiscriminator=function(param){return this.highLevel().attrOrCreate("discriminator").setValue(""+param),this},ObjectTypeDeclarationImpl.prototype.discriminatorValue=function(){return _super.prototype.attribute.call(this,"discriminatorValue",this.toString)},ObjectTypeDeclarationImpl.prototype.setDiscriminatorValue=function(param){return this.highLevel().attrOrCreate("discriminatorValue").setValue(""+param),this},ObjectTypeDeclarationImpl.prototype.wrapperClassName=function(){return"ObjectTypeDeclarationImpl"},ObjectTypeDeclarationImpl.prototype.kind=function(){return"ObjectTypeDeclaration"},ObjectTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML10"},ObjectTypeDeclarationImpl.prototype.scalarsAnnotations=function(){return new ObjectTypeDeclarationScalarsAnnotationsImpl(this.highLevel())},ObjectTypeDeclarationImpl}(TypeDeclarationImpl);exports.ObjectTypeDeclarationImpl=ObjectTypeDeclarationImpl;var ObjectTypeDeclarationScalarsAnnotationsImpl=function(_super){function ObjectTypeDeclarationScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(ObjectTypeDeclarationScalarsAnnotationsImpl,_super),ObjectTypeDeclarationScalarsAnnotationsImpl.prototype.minProperties=function(){var attr=this.node.attr("minProperties");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ObjectTypeDeclarationScalarsAnnotationsImpl.prototype.maxProperties=function(){var attr=this.node.attr("maxProperties");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ObjectTypeDeclarationScalarsAnnotationsImpl.prototype.additionalProperties=function(){var attr=this.node.attr("additionalProperties");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ObjectTypeDeclarationScalarsAnnotationsImpl.prototype.discriminator=function(){var attr=this.node.attr("discriminator");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ObjectTypeDeclarationScalarsAnnotationsImpl.prototype.discriminatorValue=function(){var attr=this.node.attr("discriminatorValue");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ObjectTypeDeclarationScalarsAnnotationsImpl}(TypeDeclarationScalarsAnnotationsImpl);exports.ObjectTypeDeclarationScalarsAnnotationsImpl=ObjectTypeDeclarationScalarsAnnotationsImpl;var StringTypeDeclarationImpl=function(_super){function StringTypeDeclarationImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createStringTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(StringTypeDeclarationImpl,_super),StringTypeDeclarationImpl.prototype.pattern=function(){return _super.prototype.attribute.call(this,"pattern",this.toString)},StringTypeDeclarationImpl.prototype.setPattern=function(param){return this.highLevel().attrOrCreate("pattern").setValue(""+param),this},StringTypeDeclarationImpl.prototype.minLength=function(){return _super.prototype.attribute.call(this,"minLength",this.toNumber)},StringTypeDeclarationImpl.prototype.setMinLength=function(param){return this.highLevel().attrOrCreate("minLength").setValue(""+param),this},StringTypeDeclarationImpl.prototype.maxLength=function(){return _super.prototype.attribute.call(this,"maxLength",this.toNumber)},StringTypeDeclarationImpl.prototype.setMaxLength=function(param){return this.highLevel().attrOrCreate("maxLength").setValue(""+param),this},StringTypeDeclarationImpl.prototype.enum=function(){return _super.prototype.attributes.call(this,"enum",this.toString)},StringTypeDeclarationImpl.prototype.setEnum=function(param){return this.highLevel().attrOrCreate("enum").setValue(""+param),this},StringTypeDeclarationImpl.prototype.wrapperClassName=function(){return"StringTypeDeclarationImpl"},StringTypeDeclarationImpl.prototype.kind=function(){return"StringTypeDeclaration"},StringTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML10"},StringTypeDeclarationImpl.prototype.scalarsAnnotations=function(){return new StringTypeDeclarationScalarsAnnotationsImpl(this.highLevel())},StringTypeDeclarationImpl}(TypeDeclarationImpl);exports.StringTypeDeclarationImpl=StringTypeDeclarationImpl;var StringTypeDeclarationScalarsAnnotationsImpl=function(_super){function StringTypeDeclarationScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(StringTypeDeclarationScalarsAnnotationsImpl,_super),StringTypeDeclarationScalarsAnnotationsImpl.prototype.pattern=function(){var attr=this.node.attr("pattern");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},StringTypeDeclarationScalarsAnnotationsImpl.prototype.minLength=function(){var attr=this.node.attr("minLength");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},StringTypeDeclarationScalarsAnnotationsImpl.prototype.maxLength=function(){var attr=this.node.attr("maxLength");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},StringTypeDeclarationScalarsAnnotationsImpl.prototype.enum=function(){var attrs=this.node.attributes("enum");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},StringTypeDeclarationScalarsAnnotationsImpl}(TypeDeclarationScalarsAnnotationsImpl);exports.StringTypeDeclarationScalarsAnnotationsImpl=StringTypeDeclarationScalarsAnnotationsImpl;var BooleanTypeDeclarationImpl=function(_super){function BooleanTypeDeclarationImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createBooleanTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(BooleanTypeDeclarationImpl,_super),BooleanTypeDeclarationImpl.prototype.wrapperClassName=function(){return"BooleanTypeDeclarationImpl"},BooleanTypeDeclarationImpl.prototype.kind=function(){return"BooleanTypeDeclaration"},BooleanTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML10"},BooleanTypeDeclarationImpl}(TypeDeclarationImpl);exports.BooleanTypeDeclarationImpl=BooleanTypeDeclarationImpl;var NumberTypeDeclarationImpl=function(_super){function NumberTypeDeclarationImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createNumberTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(NumberTypeDeclarationImpl,_super),NumberTypeDeclarationImpl.prototype.minimum=function(){return _super.prototype.attribute.call(this,"minimum",this.toNumber)},NumberTypeDeclarationImpl.prototype.setMinimum=function(param){return this.highLevel().attrOrCreate("minimum").setValue(""+param),this},NumberTypeDeclarationImpl.prototype.maximum=function(){return _super.prototype.attribute.call(this,"maximum",this.toNumber)},NumberTypeDeclarationImpl.prototype.setMaximum=function(param){return this.highLevel().attrOrCreate("maximum").setValue(""+param),this},NumberTypeDeclarationImpl.prototype.enum=function(){return _super.prototype.attributes.call(this,"enum",this.toString)},NumberTypeDeclarationImpl.prototype.setEnum=function(param){return this.highLevel().attrOrCreate("enum").setValue(""+param),this},NumberTypeDeclarationImpl.prototype.format=function(){return _super.prototype.attribute.call(this,"format",this.toString)},NumberTypeDeclarationImpl.prototype.setFormat=function(param){return this.highLevel().attrOrCreate("format").setValue(""+param),this},NumberTypeDeclarationImpl.prototype.multipleOf=function(){return _super.prototype.attribute.call(this,"multipleOf",this.toNumber)},NumberTypeDeclarationImpl.prototype.setMultipleOf=function(param){return this.highLevel().attrOrCreate("multipleOf").setValue(""+param),this},NumberTypeDeclarationImpl.prototype.wrapperClassName=function(){return"NumberTypeDeclarationImpl"},NumberTypeDeclarationImpl.prototype.kind=function(){return"NumberTypeDeclaration"},NumberTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML10"},NumberTypeDeclarationImpl.prototype.scalarsAnnotations=function(){return new NumberTypeDeclarationScalarsAnnotationsImpl(this.highLevel())},NumberTypeDeclarationImpl}(TypeDeclarationImpl);exports.NumberTypeDeclarationImpl=NumberTypeDeclarationImpl;var IntegerTypeDeclarationImpl=function(_super){function IntegerTypeDeclarationImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createIntegerTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(IntegerTypeDeclarationImpl,_super),IntegerTypeDeclarationImpl.prototype.format=function(){return _super.prototype.attribute.call(this,"format",this.toString)},IntegerTypeDeclarationImpl.prototype.setFormat=function(param){return this.highLevel().attrOrCreate("format").setValue(""+param),this},IntegerTypeDeclarationImpl.prototype.wrapperClassName=function(){return"IntegerTypeDeclarationImpl"},IntegerTypeDeclarationImpl.prototype.kind=function(){return"IntegerTypeDeclaration"},IntegerTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML10"},IntegerTypeDeclarationImpl.prototype.scalarsAnnotations=function(){return new IntegerTypeDeclarationScalarsAnnotationsImpl(this.highLevel())},IntegerTypeDeclarationImpl}(NumberTypeDeclarationImpl);exports.IntegerTypeDeclarationImpl=IntegerTypeDeclarationImpl;var NumberTypeDeclarationScalarsAnnotationsImpl=function(_super){function NumberTypeDeclarationScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(NumberTypeDeclarationScalarsAnnotationsImpl,_super),NumberTypeDeclarationScalarsAnnotationsImpl.prototype.minimum=function(){var attr=this.node.attr("minimum");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},NumberTypeDeclarationScalarsAnnotationsImpl.prototype.maximum=function(){var attr=this.node.attr("maximum");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},NumberTypeDeclarationScalarsAnnotationsImpl.prototype.enum=function(){var attrs=this.node.attributes("enum");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},NumberTypeDeclarationScalarsAnnotationsImpl.prototype.format=function(){var attr=this.node.attr("format");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},NumberTypeDeclarationScalarsAnnotationsImpl.prototype.multipleOf=function(){var attr=this.node.attr("multipleOf");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},NumberTypeDeclarationScalarsAnnotationsImpl}(TypeDeclarationScalarsAnnotationsImpl);exports.NumberTypeDeclarationScalarsAnnotationsImpl=NumberTypeDeclarationScalarsAnnotationsImpl;var IntegerTypeDeclarationScalarsAnnotationsImpl=function(_super){function IntegerTypeDeclarationScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(IntegerTypeDeclarationScalarsAnnotationsImpl,_super),IntegerTypeDeclarationScalarsAnnotationsImpl.prototype.format=function(){var attr=this.node.attr("format");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},IntegerTypeDeclarationScalarsAnnotationsImpl}(NumberTypeDeclarationScalarsAnnotationsImpl);exports.IntegerTypeDeclarationScalarsAnnotationsImpl=IntegerTypeDeclarationScalarsAnnotationsImpl;var DateOnlyTypeDeclarationImpl=function(_super){function DateOnlyTypeDeclarationImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createDateOnlyTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(DateOnlyTypeDeclarationImpl,_super),DateOnlyTypeDeclarationImpl.prototype.wrapperClassName=function(){return"DateOnlyTypeDeclarationImpl"},DateOnlyTypeDeclarationImpl.prototype.kind=function(){return"DateOnlyTypeDeclaration"},DateOnlyTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML10"},DateOnlyTypeDeclarationImpl}(TypeDeclarationImpl);exports.DateOnlyTypeDeclarationImpl=DateOnlyTypeDeclarationImpl;var TimeOnlyTypeDeclarationImpl=function(_super){function TimeOnlyTypeDeclarationImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createTimeOnlyTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(TimeOnlyTypeDeclarationImpl,_super),TimeOnlyTypeDeclarationImpl.prototype.wrapperClassName=function(){return"TimeOnlyTypeDeclarationImpl"},TimeOnlyTypeDeclarationImpl.prototype.kind=function(){return"TimeOnlyTypeDeclaration"},TimeOnlyTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML10"},TimeOnlyTypeDeclarationImpl}(TypeDeclarationImpl);exports.TimeOnlyTypeDeclarationImpl=TimeOnlyTypeDeclarationImpl;var DateTimeOnlyTypeDeclarationImpl=function(_super){function DateTimeOnlyTypeDeclarationImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createDateTimeOnlyTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(DateTimeOnlyTypeDeclarationImpl,_super),DateTimeOnlyTypeDeclarationImpl.prototype.wrapperClassName=function(){return"DateTimeOnlyTypeDeclarationImpl"},DateTimeOnlyTypeDeclarationImpl.prototype.kind=function(){return"DateTimeOnlyTypeDeclaration"},DateTimeOnlyTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML10"},DateTimeOnlyTypeDeclarationImpl}(TypeDeclarationImpl);exports.DateTimeOnlyTypeDeclarationImpl=DateTimeOnlyTypeDeclarationImpl;var DateTimeTypeDeclarationImpl=function(_super){function DateTimeTypeDeclarationImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createDateTimeTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(DateTimeTypeDeclarationImpl,_super),DateTimeTypeDeclarationImpl.prototype.format=function(){return _super.prototype.attribute.call(this,"format",this.toString)},DateTimeTypeDeclarationImpl.prototype.setFormat=function(param){return this.highLevel().attrOrCreate("format").setValue(""+param),this},DateTimeTypeDeclarationImpl.prototype.wrapperClassName=function(){return"DateTimeTypeDeclarationImpl"},DateTimeTypeDeclarationImpl.prototype.kind=function(){return"DateTimeTypeDeclaration"},DateTimeTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML10"},DateTimeTypeDeclarationImpl.prototype.scalarsAnnotations=function(){return new DateTimeTypeDeclarationScalarsAnnotationsImpl(this.highLevel())},DateTimeTypeDeclarationImpl}(TypeDeclarationImpl);exports.DateTimeTypeDeclarationImpl=DateTimeTypeDeclarationImpl;var DateTimeTypeDeclarationScalarsAnnotationsImpl=function(_super){function DateTimeTypeDeclarationScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(DateTimeTypeDeclarationScalarsAnnotationsImpl,_super),DateTimeTypeDeclarationScalarsAnnotationsImpl.prototype.format=function(){var attr=this.node.attr("format");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},DateTimeTypeDeclarationScalarsAnnotationsImpl}(TypeDeclarationScalarsAnnotationsImpl);exports.DateTimeTypeDeclarationScalarsAnnotationsImpl=DateTimeTypeDeclarationScalarsAnnotationsImpl;var DateTypeDeclarationImpl=function(_super){function DateTypeDeclarationImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createDateTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(DateTypeDeclarationImpl,_super),DateTypeDeclarationImpl.prototype.wrapperClassName=function(){return"DateTypeDeclarationImpl"},DateTypeDeclarationImpl.prototype.kind=function(){return"DateTypeDeclaration"},DateTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML10"},DateTypeDeclarationImpl}(TypeDeclarationImpl);exports.DateTypeDeclarationImpl=DateTypeDeclarationImpl;var FileTypeDeclarationImpl=function(_super){function FileTypeDeclarationImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createFileTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(FileTypeDeclarationImpl,_super),FileTypeDeclarationImpl.prototype.fileTypes=function(){return _super.prototype.attributes.call(this,"fileTypes",function(attr){
return new ContentTypeImpl(attr)})},FileTypeDeclarationImpl.prototype.minLength=function(){return _super.prototype.attribute.call(this,"minLength",this.toNumber)},FileTypeDeclarationImpl.prototype.setMinLength=function(param){return this.highLevel().attrOrCreate("minLength").setValue(""+param),this},FileTypeDeclarationImpl.prototype.maxLength=function(){return _super.prototype.attribute.call(this,"maxLength",this.toNumber)},FileTypeDeclarationImpl.prototype.setMaxLength=function(param){return this.highLevel().attrOrCreate("maxLength").setValue(""+param),this},FileTypeDeclarationImpl.prototype.wrapperClassName=function(){return"FileTypeDeclarationImpl"},FileTypeDeclarationImpl.prototype.kind=function(){return"FileTypeDeclaration"},FileTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML10"},FileTypeDeclarationImpl.prototype.scalarsAnnotations=function(){return new FileTypeDeclarationScalarsAnnotationsImpl(this.highLevel())},FileTypeDeclarationImpl}(TypeDeclarationImpl);exports.FileTypeDeclarationImpl=FileTypeDeclarationImpl;var FileTypeDeclarationScalarsAnnotationsImpl=function(_super){function FileTypeDeclarationScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(FileTypeDeclarationScalarsAnnotationsImpl,_super),FileTypeDeclarationScalarsAnnotationsImpl.prototype.fileTypes=function(){var attrs=this.node.attributes("fileTypes");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},FileTypeDeclarationScalarsAnnotationsImpl.prototype.minLength=function(){var attr=this.node.attr("minLength");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},FileTypeDeclarationScalarsAnnotationsImpl.prototype.maxLength=function(){var attr=this.node.attr("maxLength");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},FileTypeDeclarationScalarsAnnotationsImpl}(TypeDeclarationScalarsAnnotationsImpl);exports.FileTypeDeclarationScalarsAnnotationsImpl=FileTypeDeclarationScalarsAnnotationsImpl;var ResponseImpl=function(_super){function ResponseImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createResponse(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(ResponseImpl,_super),ResponseImpl.prototype.code=function(){return _super.prototype.attribute.call(this,"code",function(attr){return new StatusCodeStringImpl(attr)})},ResponseImpl.prototype.headers=function(){return _super.prototype.elements.call(this,"headers")},ResponseImpl.prototype.body=function(){return _super.prototype.elements.call(this,"body")},ResponseImpl.prototype.description=function(){return _super.prototype.attribute.call(this,"description",function(attr){return new MarkdownStringImpl(attr)})},ResponseImpl.prototype.annotations=function(){return _super.prototype.attributes.call(this,"annotations",function(attr){return new AnnotationRefImpl(attr)})},ResponseImpl.prototype.wrapperClassName=function(){return"ResponseImpl"},ResponseImpl.prototype.kind=function(){return"Response"},ResponseImpl.prototype.RAMLVersion=function(){return"RAML10"},ResponseImpl.prototype.isOkRange=function(){return helper.isOkRange(this)},ResponseImpl.prototype.scalarsAnnotations=function(){return new ResponseScalarsAnnotationsImpl(this.highLevel())},ResponseImpl}(AnnotableImpl);exports.ResponseImpl=ResponseImpl;var ResponseScalarsAnnotationsImpl=function(_super){function ResponseScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(ResponseScalarsAnnotationsImpl,_super),ResponseScalarsAnnotationsImpl.prototype.description=function(){var attr=this.node.attr("description");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ResponseScalarsAnnotationsImpl.prototype.annotations=function(){var attrs=this.node.attributes("annotations");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},ResponseScalarsAnnotationsImpl}(AnnotableScalarsAnnotationsImpl);exports.ResponseScalarsAnnotationsImpl=ResponseScalarsAnnotationsImpl;var SecuritySchemePartImpl=function(_super){function SecuritySchemePartImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createSecuritySchemePart(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(SecuritySchemePartImpl,_super),SecuritySchemePartImpl.prototype.annotations=function(){return _super.prototype.attributes.call(this,"annotations",function(attr){return new AnnotationRefImpl(attr)})},SecuritySchemePartImpl.prototype.wrapperClassName=function(){return"SecuritySchemePartImpl"},SecuritySchemePartImpl.prototype.kind=function(){return"SecuritySchemePart"},SecuritySchemePartImpl.prototype.RAMLVersion=function(){return"RAML10"},SecuritySchemePartImpl.prototype.scalarsAnnotations=function(){return new SecuritySchemePartScalarsAnnotationsImpl(this.highLevel())},SecuritySchemePartImpl}(OperationImpl);exports.SecuritySchemePartImpl=SecuritySchemePartImpl;var SecuritySchemePartScalarsAnnotationsImpl=function(_super){function SecuritySchemePartScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(SecuritySchemePartScalarsAnnotationsImpl,_super),SecuritySchemePartScalarsAnnotationsImpl.prototype.annotations=function(){var attrs=this.node.attributes("annotations");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},SecuritySchemePartScalarsAnnotationsImpl}(AnnotableScalarsAnnotationsImpl);exports.SecuritySchemePartScalarsAnnotationsImpl=SecuritySchemePartScalarsAnnotationsImpl;var MethodBaseImpl=function(_super){function MethodBaseImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createMethodBase(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(MethodBaseImpl,_super),MethodBaseImpl.prototype.body=function(){return _super.prototype.elements.call(this,"body")},MethodBaseImpl.prototype.protocols=function(){return _super.prototype.attributes.call(this,"protocols",this.toString)},MethodBaseImpl.prototype.setProtocols=function(param){return this.highLevel().attrOrCreate("protocols").setValue(""+param),this},MethodBaseImpl.prototype.is=function(){return _super.prototype.attributes.call(this,"is",function(attr){return new TraitRefImpl(attr)})},MethodBaseImpl.prototype.securedBy=function(){return _super.prototype.attributes.call(this,"securedBy",function(attr){return new SecuritySchemeRefImpl(attr)})},MethodBaseImpl.prototype.description=function(){return _super.prototype.attribute.call(this,"description",function(attr){return new MarkdownStringImpl(attr)})},MethodBaseImpl.prototype.displayName=function(){return _super.prototype.attribute.call(this,"displayName",this.toString)},MethodBaseImpl.prototype.setDisplayName=function(param){return this.highLevel().attrOrCreate("displayName").setValue(""+param),this},MethodBaseImpl.prototype.wrapperClassName=function(){return"MethodBaseImpl"},MethodBaseImpl.prototype.kind=function(){return"MethodBase"},MethodBaseImpl.prototype.RAMLVersion=function(){return"RAML10"},MethodBaseImpl.prototype.scalarsAnnotations=function(){return new MethodBaseScalarsAnnotationsImpl(this.highLevel())},MethodBaseImpl}(OperationImpl);exports.MethodBaseImpl=MethodBaseImpl;var SecuritySchemeRefImpl=function(_super){function SecuritySchemeRefImpl(){_super.apply(this,arguments)}return __extends(SecuritySchemeRefImpl,_super),SecuritySchemeRefImpl.prototype.wrapperClassName=function(){return"SecuritySchemeRefImpl"},SecuritySchemeRefImpl.prototype.kind=function(){return"SecuritySchemeRef"},SecuritySchemeRefImpl.prototype.RAMLVersion=function(){return"RAML10"},SecuritySchemeRefImpl.prototype.securitySchemeName=function(){return helper.securitySchemeName(this)},SecuritySchemeRefImpl.prototype.securityScheme=function(){return helper.securityScheme(this)},SecuritySchemeRefImpl}(ReferenceImpl);exports.SecuritySchemeRefImpl=SecuritySchemeRefImpl;var AbstractSecuritySchemeImpl=function(_super){function AbstractSecuritySchemeImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createAbstractSecurityScheme(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(AbstractSecuritySchemeImpl,_super),AbstractSecuritySchemeImpl.prototype.name=function(){return _super.prototype.attribute.call(this,"name",this.toString)},AbstractSecuritySchemeImpl.prototype.setName=function(param){return this.highLevel().attrOrCreate("name").setValue(""+param),this},AbstractSecuritySchemeImpl.prototype.type=function(){return _super.prototype.attribute.call(this,"type",this.toString)},AbstractSecuritySchemeImpl.prototype.setType=function(param){return this.highLevel().attrOrCreate("type").setValue(""+param),this},AbstractSecuritySchemeImpl.prototype.description=function(){return _super.prototype.attribute.call(this,"description",function(attr){return new MarkdownStringImpl(attr)})},AbstractSecuritySchemeImpl.prototype.describedBy=function(){return _super.prototype.element.call(this,"describedBy")},AbstractSecuritySchemeImpl.prototype.displayName=function(){return _super.prototype.attribute.call(this,"displayName",this.toString)},AbstractSecuritySchemeImpl.prototype.setDisplayName=function(param){return this.highLevel().attrOrCreate("displayName").setValue(""+param),this},AbstractSecuritySchemeImpl.prototype.settings=function(){return _super.prototype.element.call(this,"settings")},AbstractSecuritySchemeImpl.prototype.wrapperClassName=function(){return"AbstractSecuritySchemeImpl"},AbstractSecuritySchemeImpl.prototype.kind=function(){return"AbstractSecurityScheme"},AbstractSecuritySchemeImpl.prototype.RAMLVersion=function(){return"RAML10"},AbstractSecuritySchemeImpl.prototype.scalarsAnnotations=function(){return new AbstractSecuritySchemeScalarsAnnotationsImpl(this.highLevel())},AbstractSecuritySchemeImpl}(AnnotableImpl);exports.AbstractSecuritySchemeImpl=AbstractSecuritySchemeImpl;var SecuritySchemeSettingsImpl=function(_super){function SecuritySchemeSettingsImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createSecuritySchemeSettings(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(SecuritySchemeSettingsImpl,_super),SecuritySchemeSettingsImpl.prototype.wrapperClassName=function(){return"SecuritySchemeSettingsImpl"},SecuritySchemeSettingsImpl.prototype.kind=function(){return"SecuritySchemeSettings"},SecuritySchemeSettingsImpl.prototype.RAMLVersion=function(){return"RAML10"},SecuritySchemeSettingsImpl}(AnnotableImpl);exports.SecuritySchemeSettingsImpl=SecuritySchemeSettingsImpl;var OAuth1SecuritySchemeSettingsImpl=function(_super){function OAuth1SecuritySchemeSettingsImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createOAuth1SecuritySchemeSettings(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(OAuth1SecuritySchemeSettingsImpl,_super),OAuth1SecuritySchemeSettingsImpl.prototype.requestTokenUri=function(){return _super.prototype.attribute.call(this,"requestTokenUri",function(attr){return new FixedUriStringImpl(attr)})},OAuth1SecuritySchemeSettingsImpl.prototype.authorizationUri=function(){return _super.prototype.attribute.call(this,"authorizationUri",function(attr){return new FixedUriStringImpl(attr)})},OAuth1SecuritySchemeSettingsImpl.prototype.tokenCredentialsUri=function(){return _super.prototype.attribute.call(this,"tokenCredentialsUri",function(attr){return new FixedUriStringImpl(attr)})},OAuth1SecuritySchemeSettingsImpl.prototype.signatures=function(){return _super.prototype.attributes.call(this,"signatures",this.toString)},OAuth1SecuritySchemeSettingsImpl.prototype.setSignatures=function(param){return this.highLevel().attrOrCreate("signatures").setValue(""+param),this},OAuth1SecuritySchemeSettingsImpl.prototype.wrapperClassName=function(){return"OAuth1SecuritySchemeSettingsImpl"},OAuth1SecuritySchemeSettingsImpl.prototype.kind=function(){return"OAuth1SecuritySchemeSettings"},OAuth1SecuritySchemeSettingsImpl.prototype.RAMLVersion=function(){return"RAML10"},OAuth1SecuritySchemeSettingsImpl.prototype.scalarsAnnotations=function(){return new OAuth1SecuritySchemeSettingsScalarsAnnotationsImpl(this.highLevel())},OAuth1SecuritySchemeSettingsImpl}(SecuritySchemeSettingsImpl);exports.OAuth1SecuritySchemeSettingsImpl=OAuth1SecuritySchemeSettingsImpl;var OAuth1SecuritySchemeSettingsScalarsAnnotationsImpl=function(_super){function OAuth1SecuritySchemeSettingsScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(OAuth1SecuritySchemeSettingsScalarsAnnotationsImpl,_super),OAuth1SecuritySchemeSettingsScalarsAnnotationsImpl.prototype.requestTokenUri=function(){var attr=this.node.attr("requestTokenUri");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},OAuth1SecuritySchemeSettingsScalarsAnnotationsImpl.prototype.authorizationUri=function(){var attr=this.node.attr("authorizationUri");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},OAuth1SecuritySchemeSettingsScalarsAnnotationsImpl.prototype.tokenCredentialsUri=function(){var attr=this.node.attr("tokenCredentialsUri");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},OAuth1SecuritySchemeSettingsScalarsAnnotationsImpl.prototype.signatures=function(){var attrs=this.node.attributes("signatures");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},OAuth1SecuritySchemeSettingsScalarsAnnotationsImpl}(AnnotableScalarsAnnotationsImpl);exports.OAuth1SecuritySchemeSettingsScalarsAnnotationsImpl=OAuth1SecuritySchemeSettingsScalarsAnnotationsImpl;var OAuth2SecuritySchemeSettingsImpl=function(_super){function OAuth2SecuritySchemeSettingsImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createOAuth2SecuritySchemeSettings(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(OAuth2SecuritySchemeSettingsImpl,_super),OAuth2SecuritySchemeSettingsImpl.prototype.accessTokenUri=function(){return _super.prototype.attribute.call(this,"accessTokenUri",function(attr){return new FixedUriStringImpl(attr)})},OAuth2SecuritySchemeSettingsImpl.prototype.authorizationUri=function(){return _super.prototype.attribute.call(this,"authorizationUri",function(attr){return new FixedUriStringImpl(attr)})},OAuth2SecuritySchemeSettingsImpl.prototype.authorizationGrants=function(){return _super.prototype.attributes.call(this,"authorizationGrants",this.toString)},OAuth2SecuritySchemeSettingsImpl.prototype.setAuthorizationGrants=function(param){return this.highLevel().attrOrCreate("authorizationGrants").setValue(""+param),this},OAuth2SecuritySchemeSettingsImpl.prototype.scopes=function(){return _super.prototype.attributes.call(this,"scopes",this.toString)},OAuth2SecuritySchemeSettingsImpl.prototype.setScopes=function(param){return this.highLevel().attrOrCreate("scopes").setValue(""+param),this},OAuth2SecuritySchemeSettingsImpl.prototype.wrapperClassName=function(){return"OAuth2SecuritySchemeSettingsImpl"},OAuth2SecuritySchemeSettingsImpl.prototype.kind=function(){return"OAuth2SecuritySchemeSettings"},OAuth2SecuritySchemeSettingsImpl.prototype.RAMLVersion=function(){return"RAML10"},OAuth2SecuritySchemeSettingsImpl.prototype.scalarsAnnotations=function(){return new OAuth2SecuritySchemeSettingsScalarsAnnotationsImpl(this.highLevel())},OAuth2SecuritySchemeSettingsImpl}(SecuritySchemeSettingsImpl);exports.OAuth2SecuritySchemeSettingsImpl=OAuth2SecuritySchemeSettingsImpl;var OAuth2SecuritySchemeSettingsScalarsAnnotationsImpl=function(_super){function OAuth2SecuritySchemeSettingsScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(OAuth2SecuritySchemeSettingsScalarsAnnotationsImpl,_super),OAuth2SecuritySchemeSettingsScalarsAnnotationsImpl.prototype.accessTokenUri=function(){var attr=this.node.attr("accessTokenUri");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},OAuth2SecuritySchemeSettingsScalarsAnnotationsImpl.prototype.authorizationUri=function(){var attr=this.node.attr("authorizationUri");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},OAuth2SecuritySchemeSettingsScalarsAnnotationsImpl.prototype.authorizationGrants=function(){var attrs=this.node.attributes("authorizationGrants");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},OAuth2SecuritySchemeSettingsScalarsAnnotationsImpl.prototype.scopes=function(){var attrs=this.node.attributes("scopes");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},OAuth2SecuritySchemeSettingsScalarsAnnotationsImpl}(AnnotableScalarsAnnotationsImpl);exports.OAuth2SecuritySchemeSettingsScalarsAnnotationsImpl=OAuth2SecuritySchemeSettingsScalarsAnnotationsImpl;var OAuth2SecuritySchemeImpl=function(_super){function OAuth2SecuritySchemeImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createOAuth2SecurityScheme(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(OAuth2SecuritySchemeImpl,_super),OAuth2SecuritySchemeImpl.prototype.settings=function(){return _super.prototype.element.call(this,"settings")},OAuth2SecuritySchemeImpl.prototype.wrapperClassName=function(){return"OAuth2SecuritySchemeImpl"},OAuth2SecuritySchemeImpl.prototype.kind=function(){return"OAuth2SecurityScheme"},OAuth2SecuritySchemeImpl.prototype.RAMLVersion=function(){return"RAML10"},OAuth2SecuritySchemeImpl}(AbstractSecuritySchemeImpl);exports.OAuth2SecuritySchemeImpl=OAuth2SecuritySchemeImpl;var OAuth1SecuritySchemeImpl=function(_super){function OAuth1SecuritySchemeImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createOAuth1SecurityScheme(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(OAuth1SecuritySchemeImpl,_super),OAuth1SecuritySchemeImpl.prototype.settings=function(){return _super.prototype.element.call(this,"settings")},OAuth1SecuritySchemeImpl.prototype.wrapperClassName=function(){return"OAuth1SecuritySchemeImpl"},OAuth1SecuritySchemeImpl.prototype.kind=function(){return"OAuth1SecurityScheme"},OAuth1SecuritySchemeImpl.prototype.RAMLVersion=function(){return"RAML10"},OAuth1SecuritySchemeImpl}(AbstractSecuritySchemeImpl);exports.OAuth1SecuritySchemeImpl=OAuth1SecuritySchemeImpl;var PassThroughSecuritySchemeImpl=function(_super){function PassThroughSecuritySchemeImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createPassThroughSecurityScheme(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(PassThroughSecuritySchemeImpl,_super),PassThroughSecuritySchemeImpl.prototype.settings=function(){return _super.prototype.element.call(this,"settings")},PassThroughSecuritySchemeImpl.prototype.wrapperClassName=function(){return"PassThroughSecuritySchemeImpl"},PassThroughSecuritySchemeImpl.prototype.kind=function(){return"PassThroughSecurityScheme"},PassThroughSecuritySchemeImpl.prototype.RAMLVersion=function(){return"RAML10"},PassThroughSecuritySchemeImpl}(AbstractSecuritySchemeImpl);exports.PassThroughSecuritySchemeImpl=PassThroughSecuritySchemeImpl;var BasicSecuritySchemeImpl=function(_super){function BasicSecuritySchemeImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createBasicSecurityScheme(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(BasicSecuritySchemeImpl,_super),BasicSecuritySchemeImpl.prototype.wrapperClassName=function(){return"BasicSecuritySchemeImpl"},BasicSecuritySchemeImpl.prototype.kind=function(){return"BasicSecurityScheme"},BasicSecuritySchemeImpl.prototype.RAMLVersion=function(){return"RAML10"},BasicSecuritySchemeImpl}(AbstractSecuritySchemeImpl);exports.BasicSecuritySchemeImpl=BasicSecuritySchemeImpl;var DigestSecuritySchemeImpl=function(_super){function DigestSecuritySchemeImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createDigestSecurityScheme(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(DigestSecuritySchemeImpl,_super),DigestSecuritySchemeImpl.prototype.wrapperClassName=function(){return"DigestSecuritySchemeImpl"},DigestSecuritySchemeImpl.prototype.kind=function(){return"DigestSecurityScheme"},DigestSecuritySchemeImpl.prototype.RAMLVersion=function(){return"RAML10"},DigestSecuritySchemeImpl}(AbstractSecuritySchemeImpl);exports.DigestSecuritySchemeImpl=DigestSecuritySchemeImpl;var CustomSecuritySchemeImpl=function(_super){function CustomSecuritySchemeImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createCustomSecurityScheme(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(CustomSecuritySchemeImpl,_super),CustomSecuritySchemeImpl.prototype.wrapperClassName=function(){return"CustomSecuritySchemeImpl"},CustomSecuritySchemeImpl.prototype.kind=function(){return"CustomSecurityScheme"},CustomSecuritySchemeImpl.prototype.RAMLVersion=function(){return"RAML10"},CustomSecuritySchemeImpl}(AbstractSecuritySchemeImpl);exports.CustomSecuritySchemeImpl=CustomSecuritySchemeImpl;var AbstractSecuritySchemeScalarsAnnotationsImpl=function(_super){function AbstractSecuritySchemeScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(AbstractSecuritySchemeScalarsAnnotationsImpl,_super),AbstractSecuritySchemeScalarsAnnotationsImpl.prototype.type=function(){var attr=this.node.attr("type");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},AbstractSecuritySchemeScalarsAnnotationsImpl.prototype.description=function(){var attr=this.node.attr("description");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},AbstractSecuritySchemeScalarsAnnotationsImpl.prototype.displayName=function(){var attr=this.node.attr("displayName");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},AbstractSecuritySchemeScalarsAnnotationsImpl}(AnnotableScalarsAnnotationsImpl);exports.AbstractSecuritySchemeScalarsAnnotationsImpl=AbstractSecuritySchemeScalarsAnnotationsImpl;var MethodImpl=function(_super){function MethodImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createMethod(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(MethodImpl,_super),MethodImpl.prototype.method=function(){return _super.prototype.attribute.call(this,"method",this.toString)},MethodImpl.prototype.setMethod=function(param){return this.highLevel().attrOrCreate("method").setValue(""+param),this},MethodImpl.prototype.displayName=function(){return _super.prototype.attribute.call(this,"displayName",this.toString)},MethodImpl.prototype.setDisplayName=function(param){return this.highLevel().attrOrCreate("displayName").setValue(""+param),this},MethodImpl.prototype.wrapperClassName=function(){return"MethodImpl"},MethodImpl.prototype.kind=function(){return"Method"},MethodImpl.prototype.RAMLVersion=function(){return"RAML10"},MethodImpl.prototype.parentResource=function(){return helper.parentResource(this)},MethodImpl.prototype.ownerApi=function(){return helper.ownerApi(this)},MethodImpl.prototype.methodId=function(){return helper.methodId(this)},MethodImpl.prototype.allSecuredBy=function(){return helper.allSecuredBy(this)},MethodImpl.prototype.parametrizedProperties=function(){return helper.getTemplateParametrizedProperties(this)},MethodImpl.prototype.scalarsAnnotations=function(){return new MethodScalarsAnnotationsImpl(this.highLevel())},MethodImpl}(MethodBaseImpl);exports.MethodImpl=MethodImpl;var MethodBaseScalarsAnnotationsImpl=function(_super){function MethodBaseScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(MethodBaseScalarsAnnotationsImpl,_super),MethodBaseScalarsAnnotationsImpl.prototype.protocols=function(){var attrs=this.node.attributes("protocols");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},MethodBaseScalarsAnnotationsImpl.prototype.is=function(){var attrs=this.node.attributes("is");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},MethodBaseScalarsAnnotationsImpl.prototype.securedBy=function(){var attrs=this.node.attributes("securedBy");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},MethodBaseScalarsAnnotationsImpl.prototype.description=function(){var attr=this.node.attr("description");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},MethodBaseScalarsAnnotationsImpl.prototype.displayName=function(){var attr=this.node.attr("displayName");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},MethodBaseScalarsAnnotationsImpl}(AnnotableScalarsAnnotationsImpl);exports.MethodBaseScalarsAnnotationsImpl=MethodBaseScalarsAnnotationsImpl;var MethodScalarsAnnotationsImpl=function(_super){function MethodScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(MethodScalarsAnnotationsImpl,_super),MethodScalarsAnnotationsImpl.prototype.displayName=function(){var attr=this.node.attr("displayName");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},MethodScalarsAnnotationsImpl}(MethodBaseScalarsAnnotationsImpl);exports.MethodScalarsAnnotationsImpl=MethodScalarsAnnotationsImpl;var TraitImpl=function(_super){function TraitImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createTrait(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(TraitImpl,_super),TraitImpl.prototype.name=function(){return _super.prototype.attribute.call(this,"name",this.toString)},TraitImpl.prototype.setName=function(param){return this.highLevel().attrOrCreate("name").setValue(""+param),this},TraitImpl.prototype.usage=function(){return _super.prototype.attribute.call(this,"usage",this.toString)},TraitImpl.prototype.setUsage=function(param){return this.highLevel().attrOrCreate("usage").setValue(""+param),this},TraitImpl.prototype.displayName=function(){return _super.prototype.attribute.call(this,"displayName",this.toString)},TraitImpl.prototype.setDisplayName=function(param){return this.highLevel().attrOrCreate("displayName").setValue(""+param),this},TraitImpl.prototype.uses=function(){return _super.prototype.elements.call(this,"uses")},TraitImpl.prototype.wrapperClassName=function(){return"TraitImpl"},TraitImpl.prototype.kind=function(){return"Trait"},TraitImpl.prototype.RAMLVersion=function(){return"RAML10"},TraitImpl.prototype.parametrizedProperties=function(){return helper.getTemplateParametrizedProperties(this)},TraitImpl.prototype.scalarsAnnotations=function(){return new TraitScalarsAnnotationsImpl(this.highLevel())},TraitImpl}(MethodBaseImpl);exports.TraitImpl=TraitImpl;var TraitScalarsAnnotationsImpl=function(_super){function TraitScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(TraitScalarsAnnotationsImpl,_super),TraitScalarsAnnotationsImpl.prototype.usage=function(){var attr=this.node.attr("usage");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},TraitScalarsAnnotationsImpl.prototype.displayName=function(){var attr=this.node.attr("displayName");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},TraitScalarsAnnotationsImpl}(MethodBaseScalarsAnnotationsImpl);exports.TraitScalarsAnnotationsImpl=TraitScalarsAnnotationsImpl;var ResourceTypeRefImpl=function(_super){function ResourceTypeRefImpl(){_super.apply(this,arguments)}return __extends(ResourceTypeRefImpl,_super),ResourceTypeRefImpl.prototype.wrapperClassName=function(){return"ResourceTypeRefImpl"},ResourceTypeRefImpl.prototype.kind=function(){return"ResourceTypeRef"},ResourceTypeRefImpl.prototype.RAMLVersion=function(){return"RAML10"},ResourceTypeRefImpl.prototype.resourceType=function(){return helper.referencedResourceType(this)},ResourceTypeRefImpl}(ReferenceImpl);exports.ResourceTypeRefImpl=ResourceTypeRefImpl;var ResourceBaseImpl=function(_super){function ResourceBaseImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createResourceBase(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(ResourceBaseImpl,_super),ResourceBaseImpl.prototype.methods=function(){return _super.prototype.elements.call(this,"methods")},ResourceBaseImpl.prototype.is=function(){return _super.prototype.attributes.call(this,"is",function(attr){return new TraitRefImpl(attr)})},ResourceBaseImpl.prototype.type=function(){return _super.prototype.attribute.call(this,"type",function(attr){return new ResourceTypeRefImpl(attr)})},ResourceBaseImpl.prototype.description=function(){return _super.prototype.attribute.call(this,"description",function(attr){return new MarkdownStringImpl(attr)})},ResourceBaseImpl.prototype.securedBy=function(){return _super.prototype.attributes.call(this,"securedBy",function(attr){return new SecuritySchemeRefImpl(attr)})},ResourceBaseImpl.prototype.uriParameters_original=function(){return _super.prototype.elements.call(this,"uriParameters")},ResourceBaseImpl.prototype.wrapperClassName=function(){return"ResourceBaseImpl"},ResourceBaseImpl.prototype.kind=function(){return"ResourceBase"},ResourceBaseImpl.prototype.RAMLVersion=function(){return"RAML10"},ResourceBaseImpl.prototype.uriParameters=function(){
return helper.uriParametersPrimary(this)},ResourceBaseImpl.prototype.allUriParameters=function(){return helper.uriParameters(this)},ResourceBaseImpl.prototype.allSecuredBy=function(){return helper.allSecuredBy(this)},ResourceBaseImpl.prototype.scalarsAnnotations=function(){return new ResourceBaseScalarsAnnotationsImpl(this.highLevel())},ResourceBaseImpl}(AnnotableImpl);exports.ResourceBaseImpl=ResourceBaseImpl;var ResourceImpl=function(_super){function ResourceImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createResource(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(ResourceImpl,_super),ResourceImpl.prototype.relativeUri=function(){return _super.prototype.attribute.call(this,"relativeUri",function(attr){return new RelativeUriStringImpl(attr)})},ResourceImpl.prototype.displayName=function(){return _super.prototype.attribute.call(this,"displayName",this.toString)},ResourceImpl.prototype.setDisplayName=function(param){return this.highLevel().attrOrCreate("displayName").setValue(""+param),this},ResourceImpl.prototype.resources=function(){return _super.prototype.elements.call(this,"resources")},ResourceImpl.prototype.description=function(){return _super.prototype.attribute.call(this,"description",function(attr){return new MarkdownStringImpl(attr)})},ResourceImpl.prototype.annotations=function(){return _super.prototype.attributes.call(this,"annotations",function(attr){return new AnnotationRefImpl(attr)})},ResourceImpl.prototype.wrapperClassName=function(){return"ResourceImpl"},ResourceImpl.prototype.kind=function(){return"Resource"},ResourceImpl.prototype.RAMLVersion=function(){return"RAML10"},ResourceImpl.prototype.completeRelativeUri=function(){return helper.completeRelativeUri(this)},ResourceImpl.prototype.absoluteUri=function(){return helper.absoluteUri(this)},ResourceImpl.prototype.parentResource=function(){return helper.parent(this)},ResourceImpl.prototype.childResource=function(relPath){return helper.childResource(this,relPath)},ResourceImpl.prototype.childMethod=function(method){return helper.childMethod(this,method)},ResourceImpl.prototype.ownerApi=function(){return helper.ownerApi(this)},ResourceImpl.prototype.absoluteUriParameters=function(){return helper.absoluteUriParameters(this)},ResourceImpl.prototype.scalarsAnnotations=function(){return new ResourceScalarsAnnotationsImpl(this.highLevel())},ResourceImpl}(ResourceBaseImpl);exports.ResourceImpl=ResourceImpl;var ResourceBaseScalarsAnnotationsImpl=function(_super){function ResourceBaseScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(ResourceBaseScalarsAnnotationsImpl,_super),ResourceBaseScalarsAnnotationsImpl.prototype.is=function(){var attrs=this.node.attributes("is");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},ResourceBaseScalarsAnnotationsImpl.prototype.type=function(){var attr=this.node.attr("type");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ResourceBaseScalarsAnnotationsImpl.prototype.description=function(){var attr=this.node.attr("description");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ResourceBaseScalarsAnnotationsImpl.prototype.securedBy=function(){var attrs=this.node.attributes("securedBy");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},ResourceBaseScalarsAnnotationsImpl}(AnnotableScalarsAnnotationsImpl);exports.ResourceBaseScalarsAnnotationsImpl=ResourceBaseScalarsAnnotationsImpl;var ResourceScalarsAnnotationsImpl=function(_super){function ResourceScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(ResourceScalarsAnnotationsImpl,_super),ResourceScalarsAnnotationsImpl.prototype.displayName=function(){var attr=this.node.attr("displayName");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ResourceScalarsAnnotationsImpl.prototype.description=function(){var attr=this.node.attr("description");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ResourceScalarsAnnotationsImpl.prototype.annotations=function(){var attrs=this.node.attributes("annotations");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},ResourceScalarsAnnotationsImpl}(ResourceBaseScalarsAnnotationsImpl);exports.ResourceScalarsAnnotationsImpl=ResourceScalarsAnnotationsImpl;var ResourceTypeImpl=function(_super){function ResourceTypeImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createResourceType(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(ResourceTypeImpl,_super),ResourceTypeImpl.prototype.displayName=function(){return _super.prototype.attribute.call(this,"displayName",this.toString)},ResourceTypeImpl.prototype.setDisplayName=function(param){return this.highLevel().attrOrCreate("displayName").setValue(""+param),this},ResourceTypeImpl.prototype.name=function(){return _super.prototype.attribute.call(this,"name",this.toString)},ResourceTypeImpl.prototype.setName=function(param){return this.highLevel().attrOrCreate("name").setValue(""+param),this},ResourceTypeImpl.prototype.usage=function(){return _super.prototype.attribute.call(this,"usage",this.toString)},ResourceTypeImpl.prototype.setUsage=function(param){return this.highLevel().attrOrCreate("usage").setValue(""+param),this},ResourceTypeImpl.prototype.uses=function(){return _super.prototype.elements.call(this,"uses")},ResourceTypeImpl.prototype.wrapperClassName=function(){return"ResourceTypeImpl"},ResourceTypeImpl.prototype.kind=function(){return"ResourceType"},ResourceTypeImpl.prototype.RAMLVersion=function(){return"RAML10"},ResourceTypeImpl.prototype.parametrizedProperties=function(){return helper.getTemplateParametrizedProperties(this)},ResourceTypeImpl.prototype.scalarsAnnotations=function(){return new ResourceTypeScalarsAnnotationsImpl(this.highLevel())},ResourceTypeImpl}(ResourceBaseImpl);exports.ResourceTypeImpl=ResourceTypeImpl;var ResourceTypeScalarsAnnotationsImpl=function(_super){function ResourceTypeScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(ResourceTypeScalarsAnnotationsImpl,_super),ResourceTypeScalarsAnnotationsImpl.prototype.displayName=function(){var attr=this.node.attr("displayName");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ResourceTypeScalarsAnnotationsImpl.prototype.usage=function(){var attr=this.node.attr("usage");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ResourceTypeScalarsAnnotationsImpl}(ResourceBaseScalarsAnnotationsImpl);exports.ResourceTypeScalarsAnnotationsImpl=ResourceTypeScalarsAnnotationsImpl;var AnnotationRefImpl=function(_super){function AnnotationRefImpl(){_super.apply(this,arguments)}return __extends(AnnotationRefImpl,_super),AnnotationRefImpl.prototype.wrapperClassName=function(){return"AnnotationRefImpl"},AnnotationRefImpl.prototype.kind=function(){return"AnnotationRef"},AnnotationRefImpl.prototype.RAMLVersion=function(){return"RAML10"},AnnotationRefImpl.prototype.annotation=function(){return helper.referencedAnnotation(this)},AnnotationRefImpl}(ReferenceImpl);exports.AnnotationRefImpl=AnnotationRefImpl;var DocumentationItemImpl=function(_super){function DocumentationItemImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createDocumentationItem(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(DocumentationItemImpl,_super),DocumentationItemImpl.prototype.title=function(){return _super.prototype.attribute.call(this,"title",this.toString)},DocumentationItemImpl.prototype.setTitle=function(param){return this.highLevel().attrOrCreate("title").setValue(""+param),this},DocumentationItemImpl.prototype.content=function(){return _super.prototype.attribute.call(this,"content",function(attr){return new MarkdownStringImpl(attr)})},DocumentationItemImpl.prototype.uses=function(){return _super.prototype.elements.call(this,"uses")},DocumentationItemImpl.prototype.wrapperClassName=function(){return"DocumentationItemImpl"},DocumentationItemImpl.prototype.kind=function(){return"DocumentationItem"},DocumentationItemImpl.prototype.RAMLVersion=function(){return"RAML10"},DocumentationItemImpl.prototype.scalarsAnnotations=function(){return new DocumentationItemScalarsAnnotationsImpl(this.highLevel())},DocumentationItemImpl}(AnnotableImpl);exports.DocumentationItemImpl=DocumentationItemImpl;var DocumentationItemScalarsAnnotationsImpl=function(_super){function DocumentationItemScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(DocumentationItemScalarsAnnotationsImpl,_super),DocumentationItemScalarsAnnotationsImpl.prototype.title=function(){var attr=this.node.attr("title");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},DocumentationItemScalarsAnnotationsImpl.prototype.content=function(){var attr=this.node.attr("content");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},DocumentationItemScalarsAnnotationsImpl}(AnnotableScalarsAnnotationsImpl);exports.DocumentationItemScalarsAnnotationsImpl=DocumentationItemScalarsAnnotationsImpl;var FragmentDeclarationImpl=function(_super){function FragmentDeclarationImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createFragmentDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(FragmentDeclarationImpl,_super),FragmentDeclarationImpl.prototype.uses=function(){return _super.prototype.elements.call(this,"uses")},FragmentDeclarationImpl.prototype.wrapperClassName=function(){return"FragmentDeclarationImpl"},FragmentDeclarationImpl.prototype.kind=function(){return"FragmentDeclaration"},FragmentDeclarationImpl.prototype.RAMLVersion=function(){return"RAML10"},FragmentDeclarationImpl}(AnnotableImpl);exports.FragmentDeclarationImpl=FragmentDeclarationImpl;var LibraryBaseImpl=function(_super){function LibraryBaseImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createLibraryBase(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(LibraryBaseImpl,_super),LibraryBaseImpl.prototype.schemas=function(){return _super.prototype.elements.call(this,"schemas")},LibraryBaseImpl.prototype.types=function(){return _super.prototype.elements.call(this,"types")},LibraryBaseImpl.prototype.traits_original=function(){return _super.prototype.elements.call(this,"traits")},LibraryBaseImpl.prototype.resourceTypes_original=function(){return _super.prototype.elements.call(this,"resourceTypes")},LibraryBaseImpl.prototype.annotationTypes=function(){return _super.prototype.elements.call(this,"annotationTypes")},LibraryBaseImpl.prototype.securitySchemes=function(){return _super.prototype.elements.call(this,"securitySchemes")},LibraryBaseImpl.prototype.wrapperClassName=function(){return"LibraryBaseImpl"},LibraryBaseImpl.prototype.kind=function(){return"LibraryBase"},LibraryBaseImpl.prototype.RAMLVersion=function(){return"RAML10"},LibraryBaseImpl.prototype.traits=function(){return helper.traitsPrimary(this)},LibraryBaseImpl.prototype.allTraits=function(){return helper.allTraits(this)},LibraryBaseImpl.prototype.resourceTypes=function(){return helper.resourceTypesPrimary(this)},LibraryBaseImpl.prototype.allResourceTypes=function(){return helper.allResourceTypes(this)},LibraryBaseImpl}(FragmentDeclarationImpl);exports.LibraryBaseImpl=LibraryBaseImpl;var LibraryImpl=function(_super){function LibraryImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createLibrary(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(LibraryImpl,_super),LibraryImpl.prototype.usage=function(){return _super.prototype.attribute.call(this,"usage",this.toString)},LibraryImpl.prototype.setUsage=function(param){return this.highLevel().attrOrCreate("usage").setValue(""+param),this},LibraryImpl.prototype.name=function(){return _super.prototype.attribute.call(this,"name",this.toString)},LibraryImpl.prototype.setName=function(param){return this.highLevel().attrOrCreate("name").setValue(""+param),this},LibraryImpl.prototype.wrapperClassName=function(){return"LibraryImpl"},LibraryImpl.prototype.kind=function(){return"Library"},LibraryImpl.prototype.RAMLVersion=function(){return"RAML10"},LibraryImpl.prototype.scalarsAnnotations=function(){return new LibraryScalarsAnnotationsImpl(this.highLevel())},LibraryImpl}(LibraryBaseImpl);exports.LibraryImpl=LibraryImpl;var LibraryScalarsAnnotationsImpl=function(_super){function LibraryScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(LibraryScalarsAnnotationsImpl,_super),LibraryScalarsAnnotationsImpl.prototype.usage=function(){var attr=this.node.attr("usage");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},LibraryScalarsAnnotationsImpl}(AnnotableScalarsAnnotationsImpl);exports.LibraryScalarsAnnotationsImpl=LibraryScalarsAnnotationsImpl;var ApiImpl=function(_super){function ApiImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createApi(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(ApiImpl,_super),ApiImpl.prototype.title=function(){return _super.prototype.attribute.call(this,"title",this.toString)},ApiImpl.prototype.setTitle=function(param){return this.highLevel().attrOrCreate("title").setValue(""+param),this},ApiImpl.prototype.description=function(){return _super.prototype.attribute.call(this,"description",function(attr){return new MarkdownStringImpl(attr)})},ApiImpl.prototype.version=function(){return _super.prototype.attribute.call(this,"version",this.toString)},ApiImpl.prototype.setVersion=function(param){return this.highLevel().attrOrCreate("version").setValue(""+param),this},ApiImpl.prototype.baseUri=function(){return _super.prototype.attribute.call(this,"baseUri",function(attr){return new FullUriTemplateStringImpl(attr)})},ApiImpl.prototype.baseUriParameters_original=function(){return _super.prototype.elements.call(this,"baseUriParameters")},ApiImpl.prototype.protocols=function(){return _super.prototype.attributes.call(this,"protocols",this.toString)},ApiImpl.prototype.setProtocols=function(param){return this.highLevel().attrOrCreate("protocols").setValue(""+param),this},ApiImpl.prototype.mediaType=function(){return _super.prototype.attributes.call(this,"mediaType",function(attr){return new MimeTypeImpl(attr)})},ApiImpl.prototype.securedBy=function(){return _super.prototype.attributes.call(this,"securedBy",function(attr){return new SecuritySchemeRefImpl(attr)})},ApiImpl.prototype.resources=function(){return _super.prototype.elements.call(this,"resources")},ApiImpl.prototype.documentation=function(){return _super.prototype.elements.call(this,"documentation")},ApiImpl.prototype.annotations=function(){return _super.prototype.attributes.call(this,"annotations",function(attr){return new AnnotationRefImpl(attr)})},ApiImpl.prototype.wrapperClassName=function(){return"ApiImpl"},ApiImpl.prototype.kind=function(){return"Api"},ApiImpl.prototype.RAMLVersion_original=function(){return"RAML10"},ApiImpl.prototype.expand=function(){return helper.expandTraitsAndResourceTypes(this)},ApiImpl.prototype.childResource=function(relPath){return helper.childResource(this,relPath)},ApiImpl.prototype.allResources=function(){return helper.allResources(this)},ApiImpl.prototype.baseUriParameters=function(){return helper.baseUriParametersPrimary(this)},ApiImpl.prototype.allBaseUriParameters=function(){return helper.baseUriParameters(this)},ApiImpl.prototype.allProtocols=function(){return helper.allProtocols(this)},ApiImpl.prototype.RAMLVersion=function(){return helper.RAMLVersion(this)},ApiImpl.prototype.scalarsAnnotations=function(){return new ApiScalarsAnnotationsImpl(this.highLevel())},ApiImpl}(LibraryBaseImpl);exports.ApiImpl=ApiImpl;var OverlayImpl=function(_super){function OverlayImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createOverlay(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(OverlayImpl,_super),OverlayImpl.prototype.usage=function(){return _super.prototype.attribute.call(this,"usage",this.toString)},OverlayImpl.prototype.setUsage=function(param){return this.highLevel().attrOrCreate("usage").setValue(""+param),this},OverlayImpl.prototype.extends=function(){return _super.prototype.attribute.call(this,"extends",this.toString)},OverlayImpl.prototype.setExtends=function(param){return this.highLevel().attrOrCreate("extends").setValue(""+param),this},OverlayImpl.prototype.title=function(){return _super.prototype.attribute.call(this,"title",this.toString)},OverlayImpl.prototype.setTitle=function(param){return this.highLevel().attrOrCreate("title").setValue(""+param),this},OverlayImpl.prototype.wrapperClassName=function(){return"OverlayImpl"},OverlayImpl.prototype.kind=function(){return"Overlay"},OverlayImpl.prototype.RAMLVersion=function(){return"RAML10"},OverlayImpl.prototype.scalarsAnnotations=function(){return new OverlayScalarsAnnotationsImpl(this.highLevel())},OverlayImpl}(ApiImpl);exports.OverlayImpl=OverlayImpl;var ApiScalarsAnnotationsImpl=function(_super){function ApiScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(ApiScalarsAnnotationsImpl,_super),ApiScalarsAnnotationsImpl.prototype.title=function(){var attr=this.node.attr("title");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ApiScalarsAnnotationsImpl.prototype.description=function(){var attr=this.node.attr("description");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ApiScalarsAnnotationsImpl.prototype.version=function(){var attr=this.node.attr("version");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ApiScalarsAnnotationsImpl.prototype.baseUri=function(){var attr=this.node.attr("baseUri");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ApiScalarsAnnotationsImpl.prototype.protocols=function(){var attrs=this.node.attributes("protocols");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},ApiScalarsAnnotationsImpl.prototype.mediaType=function(){var attrs=this.node.attributes("mediaType");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},ApiScalarsAnnotationsImpl.prototype.securedBy=function(){var attrs=this.node.attributes("securedBy");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},ApiScalarsAnnotationsImpl.prototype.annotations=function(){var attrs=this.node.attributes("annotations");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},ApiScalarsAnnotationsImpl}(AnnotableScalarsAnnotationsImpl);exports.ApiScalarsAnnotationsImpl=ApiScalarsAnnotationsImpl;var OverlayScalarsAnnotationsImpl=function(_super){function OverlayScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(OverlayScalarsAnnotationsImpl,_super),OverlayScalarsAnnotationsImpl.prototype.usage=function(){var attr=this.node.attr("usage");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},OverlayScalarsAnnotationsImpl.prototype.extends=function(){var attr=this.node.attr("extends");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},OverlayScalarsAnnotationsImpl.prototype.title=function(){var attr=this.node.attr("title");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},OverlayScalarsAnnotationsImpl}(ApiScalarsAnnotationsImpl);exports.OverlayScalarsAnnotationsImpl=OverlayScalarsAnnotationsImpl;var ExtensionImpl=function(_super){function ExtensionImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createExtension(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(ExtensionImpl,_super),ExtensionImpl.prototype.usage=function(){return _super.prototype.attribute.call(this,"usage",this.toString)},ExtensionImpl.prototype.setUsage=function(param){return this.highLevel().attrOrCreate("usage").setValue(""+param),this},ExtensionImpl.prototype.extends=function(){return _super.prototype.attribute.call(this,"extends",this.toString)},ExtensionImpl.prototype.setExtends=function(param){return this.highLevel().attrOrCreate("extends").setValue(""+param),this},ExtensionImpl.prototype.title=function(){return _super.prototype.attribute.call(this,"title",this.toString)},ExtensionImpl.prototype.setTitle=function(param){return this.highLevel().attrOrCreate("title").setValue(""+param),this},ExtensionImpl.prototype.wrapperClassName=function(){return"ExtensionImpl"},ExtensionImpl.prototype.kind=function(){return"Extension"},ExtensionImpl.prototype.RAMLVersion=function(){return"RAML10"},ExtensionImpl.prototype.scalarsAnnotations=function(){return new ExtensionScalarsAnnotationsImpl(this.highLevel())},ExtensionImpl}(ApiImpl);exports.ExtensionImpl=ExtensionImpl;var ExtensionScalarsAnnotationsImpl=function(_super){function ExtensionScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(ExtensionScalarsAnnotationsImpl,_super),ExtensionScalarsAnnotationsImpl.prototype.usage=function(){var attr=this.node.attr("usage");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ExtensionScalarsAnnotationsImpl.prototype.extends=function(){var attr=this.node.attr("extends");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ExtensionScalarsAnnotationsImpl.prototype.title=function(){var attr=this.node.attr("title");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ExtensionScalarsAnnotationsImpl}(ApiScalarsAnnotationsImpl);exports.ExtensionScalarsAnnotationsImpl=ExtensionScalarsAnnotationsImpl,exports.loadApiSync=loadApiSync,exports.loadRAMLSync=loadRAMLSync,exports.loadApi=loadApi,exports.loadRAML=loadRAML,exports.getLanguageElementByRuntimeType=getLanguageElementByRuntimeType},function(module,exports,__webpack_require__){"use strict";var globalEmptyOpt,invariant=__webpack_require__(67),exists=function(v){return null!=v},Opt=function(){function Opt(_value){var _this=this;this._value=_value,this._isDefined=!1,this._isEmpty=!0,this._arr=void 0,this.getOrThrow=function(){return invariant(_this._isDefined,"Opt is empty. Use `Opt#getOrElse` or check `Opt#isDefined`."),_this._value},this.value=function(){return _this._value},this.isDefined=function(){return _this._isDefined},this.isEmpty=function(){return _this._isEmpty},this.toArray=function(){return _this._arr||(_this._arr=_this._isDefined?[_this._value]:[])},this.getOrElse=function(v){return _this._isDefined?_this._value:v},this.getOrElseF=function(v){return _this._isDefined?_this._value:v()},this.map=function(f){return _this._isEmpty?Opt.empty():new Opt(f(_this._value))},this.flatMap=function(f){return _this.map(f).getOrElse(Opt.empty())},this.equals=function(other){return invariant(other instanceof Opt,"Expected other to be an `Opt`, but got `%s`",typeof other),_this._isDefined===other.isDefined()&&_this._value===other.value()},exists(this._value)&&(this._isDefined=!0,this._isEmpty=!1)}return Opt.prototype.forEach=function(fn){this.isDefined()&&fn(this._value)},Opt.empty=function(){return globalEmptyOpt||(globalEmptyOpt=new Opt)},Opt}();module.exports=Opt},function(module,exports,__webpack_require__){"use strict";var ramlDs=__webpack_require__(36);module.exports=ramlDs.universesInfo},function(module,exports,__webpack_require__){"use strict";function globalDeclarations(h){for(var result=[],visitedUnits={};null!=h.parent();)h.lowLevel().includePath()&&(result=result.concat(findDeclarations(h,visitedUnits))),h=h.parent();return result=result.concat(findDeclarations(h,visitedUnits))}function getUserDefinedPropertySource(property){var result=property.node();if(result&&hl.isParseResult(result))return result;var sourceProvider=sourceFinder.getNominalPropertySource2(property);return sourceProvider?sourceProvider.getSource():null}function findDeclarations(h,visitedUnits,rs){void 0===visitedUnits&&(visitedUnits={}),void 0===rs&&(rs=[]);var aPath=h.lowLevel().unit().absolutePath();if(visitedUnits[aPath]=!0,!(h instanceof hlimpl.ASTNodeImpl))return rs;var skipAll=!1;return h.elements().forEach(function(x){if(x.definition().key()==universes.Universe10.UsesDeclaration){if(skipAll)return;var mm=x.attr("value");if(mm){var unit=x.root().lowLevel().unit().resolve(mm.value());if(unit&&resourceRegistry.isWaitingFor(unit.absolutePath()))return void(skipAll=!0);null!=unit&&unit.isRAMLUnit()&&!visitedUnits[unit.absolutePath()]&&unit.highLevel().isElement()&&findDeclarations(unit.highLevel().asElement(),visitedUnits,rs)}}else rs.push(x)}),rs}function getIndent2(offset,text){for(var spaces="",i=offset-1;i>=0;i--){var c=text.charAt(i);if(" "==c||"\t"==c)spaces?spaces+=c:spaces=c;else if("\r"==c||"\n"==c)return spaces}}function deepFindNode(n,offset,end,goToOtherUnits,returnAttrs){if(void 0===goToOtherUnits&&(goToOtherUnits=!0),void 0===returnAttrs&&(returnAttrs=!0),null==n)return null;if(n.lowLevel()&&n.lowLevel().start()<=offset&&n.lowLevel().end()>=end){if(n instanceof hlimpl.ASTNodeImpl){for(var hn=n,all=goToOtherUnits?hn.children():hn.directChildren(),i=0;i<all.length;i++)if(goToOtherUnits||all[i].lowLevel().unit()==n.lowLevel().unit()){var node=deepFindNode(all[i],offset,end,goToOtherUnits);if(node)return!returnAttrs&&node instanceof hlimpl.ASTPropImpl&&(node=node.parent()),node}return n}if(n instanceof hlimpl.ASTPropImpl){var attr=n;if(!attr.property().isKey()){var vl=attr.value();if(vl instanceof hlimpl.StructuredValue){var st=vl,hl=st.toHighLevel2();if(hl&&!goToOtherUnits&&hl.lowLevel().unit()!=n.lowLevel().unit())return null;var node=deepFindNode(hl,offset,end,goToOtherUnits);if(node)return!returnAttrs&&node instanceof hlimpl.ASTPropImpl&&(node=node.parent()),node}return returnAttrs?attr:attr.parent()}return null}return null}return null}function getValueAt(text,offset){for(var sp=-1,i=offset-1;i>=0;i--){var c=text.charAt(i);if("\r"==c||"\n"==c||" "==c||"\t"==c||'"'==c||"'"==c||":"==c){sp=i+1;break}}for(var ep=-1,i=offset;i<text.length;i++){var c=text.charAt(i);if("\r"==c||"\n"==c||" "==c||"\t"==c||'"'==c||"'"==c||":"==c){ep=i;break}}return sp!=-1&&ep!=-1?text.substring(sp,ep):""}function extractName(cleaned,offset){for(var txt="",i=offset;i>=0;i--){var c=cleaned[i];if(" "==c||"\r"==c||"\n"==c||"|"==c||"["==c||"]"==c||":"==c||"("==c||")"==c)break;txt=c+txt}for(var i=offset+1;i<cleaned.length;i++){var c=cleaned[i];if(" "==c||"\r"==c||"\n"==c||"|"==c||"["==c||"]"==c||":"==c||"("==c||")"==c)break;txt+=c}return txt}function findUsages(unit,offset){var decl=findDeclaration(unit,offset);if(decl){if(decl instanceof hlimpl.ASTNodeImpl){var hnode=decl;return{node:hnode,results:hnode.findReferences()}}decl instanceof hlimpl.ASTPropImpl}var node=deepFindNode(hlimpl.fromUnit(unit),offset,offset,!1);if(node instanceof hlimpl.ASTNodeImpl)return{node:node,results:node.findReferences()};if(node instanceof hlimpl.ASTPropImpl){var prop=node;if(prop.property().canBeValue())return{node:prop.parent(),results:prop.parent().findReferences()}}return{node:null,results:[]}}function referenceTargets(p0,c){var p=p0;if(p.getAdapter(ramlServices.RAMLPropertyService).isTypeExpr()){var definitionNodes=globalDeclarations(c).filter(function(node){var nc=node.definition().key();return nc===universes.Universe08.GlobalSchema||node.definition().isAssignableFrom(universes.Universe10.TypeDeclaration.name)});return definitionNodes}if(p.getAdapter(ramlServices.RAMLPropertyService).isDescriminating()){var subTypes=nodesDeclaringType(p.range(),c);return subTypes}if(p.isReference()){var rt=p.referencesTo(),subTypes=nodesDeclaringType(rt,c);return subTypes}if(p.range().hasValueTypeInHierarchy()){var vt=p.range().getAdapter(ramlServices.RAMLService);if(vt.globallyDeclaredBy().length>0){var definitionNodes=globalDeclarations(c).filter(function(z){return null!=_.find(vt.globallyDeclaredBy(),function(x){return x==z.definition()})});return definitionNodes}}return[]}function enumValues(p,c){if(c){var rs=[];if(p.getAdapter(ramlServices.RAMLPropertyService).isTypeExpr()){var definitionNodes=globalDeclarations(c).filter(function(node){var nc=node.definition().key();return nc===universes.Universe08.GlobalSchema||node.definition().isAssignableFrom(universes.Universe10.TypeDeclaration.name)});rs=definitionNodes.map(function(x){return hlimpl.qName(x,c)});var de=c.definition().universe().type(universes.Universe10.TypeDeclaration.name);if(de){var subTypes=de.allSubTypes();rs=rs.concat(subTypes.map(function(x){return x.getAdapter(ramlServices.RAMLService).descriminatorValue()}))}return rs}var rangeKey=p.range().key();if((rangeKey==universes.Universe08.SchemaString||rangeKey==universes.Universe10.SchemaString)&&"RAML10"==p.range().universe().version()&&p.range().hasValueTypeInHierarchy()){var definitionNodes=globalDeclarations(c).filter(function(node){return node.definition().isAssignableFrom(universes.Universe10.TypeDeclaration.name)});rs=definitionNodes.map(function(x){return hlimpl.qName(x,c)})}if(p.getAdapter(ramlServices.RAMLPropertyService).isDescriminating()){var subTypes=subTypesWithLocals(p.domain(),c);rs=rs.concat(subTypes.map(function(x){return x.getAdapter(ramlServices.RAMLService).descriminatorValue();
}))}else if(p.isReference())rs=nodesDeclaringType(p.referencesTo(),c).map(function(x){return hlimpl.qName(x,c)});else if(p.range().hasValueTypeInHierarchy()){var vt=p.range().getAdapter(ramlServices.RAMLService);if(vt.globallyDeclaredBy().length>0){var definitionNodes=globalDeclarations(c).filter(function(z){return null!=_.find(vt.globallyDeclaredBy(),function(x){return x==z.definition()})});rs=rs.concat(definitionNodes.map(function(x){return hlimpl.qName(x,c)}))}}return p.isAllowNull()&&rs.push("null"),p.enumOptions()&&(rs=rs.concat(p.enumOptions())),rs}return p.enumOptions()&&"string"==typeof p.enumOptions()?[p.enumOptions()+""]:p.enumOptions()}function getLibraryName(node){return node.isElement()&&node.asElement().definition().key()!=universes.Universe10.Library?null:node.asElement().attrValue("name")}function findDeclarationByNode(node,nodePart){var unit=node.lowLevel().unit();if(!unit)return null;var start=node.lowLevel().start(),end=node.lowLevel().end();if(nodePart&&nodePart==LocationKind.KEY_COMPLETION?(start=node.lowLevel().keyStart(),end=node.lowLevel().keyEnd()):nodePart&&nodePart==LocationKind.VALUE_COMPLETION&&(start=node.lowLevel().valueStart(),end=node.lowLevel().valueEnd()),start==-1||end==-1)return null;var offset=Math.floor((start+end)/2);return findDeclaration(unit,offset,nodePart)}function findDeclaration(unit,offset,nodePart){var node=deepFindNode(hlimpl.fromUnit(unit),offset,offset,!1),result=null;if(node.isElement()&&node.asElement().definition().isAssignableFrom(universes.Universe10.TypeDeclaration.name)&&node.asElement().directChildren().forEach(function(x){if(x.isUnknown()&&x.getLowLevelStart()<offset&&x.getLowLevelEnd()>offset){var tp=node.asElement().localType();tp.allFacets().forEach(function(f){if(f.nameId()==x.lowLevel().key()&&f instanceof def.UserDefinedProp){var up=getUserDefinedPropertySource(f);result=up}})}}),!node.property())return node;if("example"==node.property().nameId()){node.parent().localType();node.lowLevel().children().forEach(function(y){"example"==y.key()&&y.children().forEach(function(x){if(x.start()<offset&&x.end()>offset){var tp=node.parent().asElement().localType();tp.allProperties().forEach(function(f){if(f.nameId()==x.key()&&f instanceof def.UserDefinedProp){var up=getUserDefinedPropertySource(f);result=up}})}})})}if(result)return result;var kind=null!=nodePart?nodePart:determineCompletionKind(unit.contents(),offset);if(kind==LocationKind.VALUE_COMPLETION){var hlnode=node;if(node instanceof hlimpl.ASTPropImpl){var attr=node;if(attr&&attr.value()){if(!(attr.value()instanceof hlimpl.StructuredValue))return searchInTheValue(offset,unit.contents(),attr,hlnode);var sval=attr.value(),hlvalue=sval.toHighLevel();if(hlvalue){var newAttr=_.find(hlvalue.attrs(),function(x){return x.lowLevel().start()<offset&&x.lowLevel().end()>=offset});if(newAttr)return searchInTheValue(offset,unit.contents(),newAttr,hlvalue,attr.property())}}}else{var nodeProperty=hlnode.property();if(nodeProperty)return searchInTheValue(offset,unit.contents(),null,hlnode,nodeProperty)}}if(kind==LocationKind.KEY_COMPLETION||kind==LocationKind.SEQUENCE_KEY_COPLETION){var hlnode=node,pp=node.property();if(pp instanceof defs.UserDefinedProp){var up=pp;return getUserDefinedPropertySource(up)}if(node instanceof hlimpl.ASTNodeImpl&&hlnode.definition()instanceof defs.UserDefinedClass){var uc=hlnode.definition();return uc.isAssignableFrom("TypeDeclaration")?node:uc.getAdapter(ramlServices.RAMLService).getDeclaringNode()}if(node instanceof hlimpl.ASTPropImpl){var pr=node;if(isExampleNodeContent(pr)){var contentType=findExampleContentType(pr);if(contentType){var documentationRoot=parseDocumentationContent(pr,contentType);if(documentationRoot){var node=deepFindNode(documentationRoot,offset,offset);if(pp=node.property(),pp instanceof defs.UserDefinedProp){var up=pp;return getUserDefinedPropertySource(up)}if(node instanceof hlimpl.ASTNodeImpl&&hlnode.definition()instanceof defs.UserDefinedClass){var uc=hlnode.definition();return uc.getAdapter(ramlServices.RAMLService).getDeclaringNode()}}}}}}if(kind==LocationKind.PATH_COMPLETION){var inclpath=getValueAt(unit.contents(),offset);if(inclpath){var ap=unit.resolve(inclpath);return ap}}}function findExampleContentType(node){var potentialTypeNode=null;if(node.isElement()?potentialTypeNode=node:node.isAttr()&&(potentialTypeNode=node.parent()),!potentialTypeNode.definition().isAssignableFrom(universes.Universe10.TypeDeclaration.name)){var parent=potentialTypeNode.parent();if(!parent)return null;if(parent.definition().isAssignableFrom(universes.Universe10.TypeDeclaration.name))potentialTypeNode=parent;else{if(parent=parent.parent(),null==parent)return null;if(!parent.definition().isAssignableFrom(universes.Universe10.TypeDeclaration.name))return null;potentialTypeNode=parent}}return potentialTypeNode.localType()}function parseDocumentationContent(attribute,type){return attribute.value()instanceof hlimpl.StructuredValue?new hlimpl.ASTNodeImpl(attribute.value().lowLevel(),attribute.parent(),type,attribute.property()):null}function parseStructuredExample(exampleNode,type){return new hlimpl.ASTNodeImpl(exampleNode.lowLevel(),exampleNode,type,exampleNode.property())}function isExampleNode(node){return node.definition().key()==universes.Universe10.ExampleSpec}function isExampleNodeContent(node){var typeExampleName10=universes.Universe10.TypeDeclaration.properties.example.name,objectName10=universes.Universe10.ObjectTypeDeclaration.name;if(!(node instanceof hlimpl.ASTPropImpl))return!1;var property=node,parent=property.parent(),parentProperty=parent&&parent.property();parentProperty&&parentProperty.nameId();return!!(typeExampleName10===property.name()&&property.isString()&&parent instanceof hlimpl.ASTNodeImpl&&parent.definition().isAssignableFrom(objectName10))}function determineCompletionKind(text,offset){for(var hasIn=!1,hasSeq=!1,canBeAnnotation=!1,i=offset-1;i>=0;i--){var c=text.charAt(i);if("("==c)canBeAnnotation=!0;else{if(canBeAnnotation){if("\r"==c||"\n"==c){for(var hasClosing=!1,j=offset-1;j<text.length;j++){var ch=text[j];if(")"==ch&&(hasClosing=!0),"\r"==ch||"\n"==ch)break;if(":"==ch){canBeAnnotation=!1;break}}if(canBeAnnotation&&hasClosing)return LocationKind.ANNOTATION_COMPLETION;break}if(" "==c||"\t"==c)continue;break}if("\r"==c||"\n"==c)break;if(":"==c)break}}for(var i=offset-1;i>=0;i--){var c=text.charAt(i);if("#"==c){if(0==i)return LocationKind.VERSION_COMPLETION;for(var j=i-1;j>=0;j--){var currentChar=text.charAt(j);if("\r"==currentChar||"\n"==currentChar)break;if("!"==currentChar&&text.indexOf("!include",j)==j)return LocationKind.PATH_COMPLETION}return LocationKind.INCOMMENT}if(":"==c)return hasIn?LocationKind.DIRECTIVE_COMPLETION:LocationKind.VALUE_COMPLETION;if("\r"==c||"\n"==c){for(var insideOfMultiline=!1,ind=getIndent2(offset,text),a=i;a>0;a--){if(c=text.charAt(a),":"==c){if(insideOfMultiline){var ll=getIndent2(a,text);if(ll.length<ind.length)return LocationKind.VALUE_COMPLETION}break}"|"!=c?("\r"!=c&&"\n"!=c||(insideOfMultiline=!1)," "!=c&&"\t"!=c&&(insideOfMultiline=!1)):insideOfMultiline=!0}return hasSeq?LocationKind.SEQUENCE_KEY_COPLETION:LocationKind.KEY_COMPLETION}if("-"==c&&(hasSeq=!0),"!"==c){if(text.indexOf("!include",i)==i)return LocationKind.PATH_COMPLETION;text.indexOf("!i",i)==i&&(hasIn=!0)}}}function resolveReference(point,path){if(!path)return null;for(var sp=path.split("/"),result=point,i=0;i<sp.length;i++)if("#"!=sp[i]){if(result=_.find(result.children(),function(x){return x.key()==sp[i]}),!result)return null}else result=point.unit().ast();return result}function subTypesWithLocals(range,parentNode){if(null==range)return[];var name=range.nameId();parentNode=exports.declRoot(parentNode);var actual=parentNode;if(actual._subTypesCache){var cached=actual._subTypesCache[name];if(cached)return cached}else actual._subTypesCache={};var result=range.allSubTypes();if(range.getAdapter(ramlServices.RAMLService).getRuntimeExtenders().length>0&&parentNode){var decls=globalDeclarations(parentNode),extenders=range.getAdapter(ramlServices.RAMLService).getRuntimeExtenders();parentNode.root();extenders.forEach(function(x){var definitionNodes=decls.filter(function(z){var def=z.definition().allSuperTypes();def.push(z.definition());var rr=z.definition()==x||null!=_.find(def,function(d){return d==x})||null!=_.find(def,function(d){return d==range});return rr});result=result.concat(definitionNodes.map(function(x){return x.localType()}))})}return result=_.unique(result),actual._subTypesCache[name]=result,result}function subTypesWithName(tname,parentNode,backup){parentNode=exports.declRoot(parentNode);var decls=globalDeclarations(parentNode),declNode=_.find(decls,function(x){return hlimpl.qName(x,parentNode)==tname&&x.property()&&x.property().nameId()==universes.Universe10.LibraryBase.properties.types.name});return declNode.localType()}function schemasWithName(tname,parentNode,backup){parentNode=exports.declRoot(parentNode);var decls=globalDeclarations(parentNode),declNode=_.find(decls,function(x){return hlimpl.qName(x,parentNode)==tname&&x.property()&&x.property().nameId()==universes.Universe10.LibraryBase.properties.schemas.name});return declNode.localType()}function nodesDeclaringType(range,n){var result=[],extenders=[range].concat(range.getAdapter(ramlServices.RAMLService).getRuntimeExtenders());if(n){var root=n;extenders.forEach(function(x){var definitionNodes=globalDeclarations(root).filter(function(z){return z.definition().isAssignableFrom(x.nameId())});result=result.concat(definitionNodes)})}var isElementType=!range.hasValueTypeInHierarchy();if(isElementType&&range.getAdapter(ramlServices.RAMLService).isInlinedTemplates()&&n){var root=n,definitionNodes=globalDeclarations(root).filter(function(z){return z.definition()==range});result=result.concat(definitionNodes)}else{var root=n,q={};range.allSubTypes().forEach(function(x){return q[x.nameId()]=!0}),q[range.nameId()]=!0;var definitionNodes=globalDeclarations(root).filter(function(z){return q[z.definition().nameId()]});result=result.concat(definitionNodes)}return result}function findAllSubTypes(p,n){var range=p.range();return subTypesWithLocals(range,n)}function possibleNodes(p,c){if(c){if(p.isDescriminator()){var range=p.range(),extenders=range.getAdapter(ramlServices.RAMLService).getRuntimeExtenders();if(extenders.length>0&&c){var result=[];return extenders.forEach(function(x){var definitionNodes=globalDeclarations(c).filter(function(z){return z.definition()==x});result=result.concat(definitionNodes)}),result}return[]}if(p.isReference())return nodesDeclaringType(p.referencesTo(),c);if(p.range().hasValueTypeInHierarchy()){var vt=p.range().getAdapter(ramlServices.RAMLService);if(vt.globallyDeclaredBy&&vt.globallyDeclaredBy().length>0){var definitionNodes=globalDeclarations(c).filter(function(z){return null!=_.find(vt.globallyDeclaredBy(),function(x){return x==z.definition()})});return definitionNodes}}}return[]}function allChildren(node){var res=[];return gather(node,res),res}function gather(node,result){node.children().forEach(function(x){result.push(x),gather(x,result)})}function refFinder(root,node,result){root.elements().forEach(function(x){refFinder(x,node,result);x.definition()}),root.attrs().forEach(function(a){var pr=a.property(),vl=a.value();if(pr instanceof defs.UserDefinedProp){var up=pr.node();up==node?result.push(a):up.lowLevel().start()==node.lowLevel().start()&&up.lowLevel().unit()==node.lowLevel().unit()&&result.push(a)}if(isExampleNodeContent(a)){var contentType=findExampleContentType(a);if(contentType){var documentationRoot=parseDocumentationContent(a,contentType);documentationRoot&&refFinder(documentationRoot,node,result)}}else if(pr.getAdapter(ramlServices.RAMLPropertyService).isTypeExpr()&&"string"==typeof vl){var tpa=root.localType();testUsage(tpa,a,node,result);var libraryName=getLibraryName(node);if(libraryName&&vl.indexOf(libraryName)!=-1){var referencingLibrary=getLibraryDefiningNode(a);referencingLibrary&&referencingLibrary.lowLevel().start()==node.lowLevel().start()&&result.push(a)}}if(pr.isReference()||pr.isDescriminator())if("string"==typeof vl){var pn=possibleNodes(pr,root);_.find(pn,function(x){return x.name()==vl&&x==node})&&result.push(a);var libraryName=getLibraryName(node);if(libraryName&&vl.indexOf(libraryName)!=-1){var referencingLibrary=getLibraryDefiningNode(a);referencingLibrary&&referencingLibrary.lowLevel().start()==node.lowLevel().start()&&result.push(a)}}else{var st=vl;if(st){var vn=st.valueName(),pn=possibleNodes(pr,root);_.find(pn,function(x){return x.name()==vn&&x==node})&&result.push(a);var hnode=st.toHighLevel();hnode&&refFinder(hnode,node,result);var libraryName=getLibraryName(node);if(libraryName&&vn.indexOf(libraryName)!=-1){var referencingLibrary=getLibraryDefiningNode(hnode);referencingLibrary&&referencingLibrary.lowLevel().start()==node.lowLevel().start()&&result.push(a)}}}else{var pn=possibleNodes(pr,root);_.find(pn,function(x){return x.name()==vl&&x==node})&&result.push(a)}})}function getLibraryDefiningNode(nodeToCheck){if(!nodeToCheck.lowLevel)return null;var lowLevelNode=nodeToCheck.lowLevel();if(!lowLevelNode)return null;if(lowLevelNode.key()){var offset=Math.floor((lowLevelNode.keyEnd()+lowLevelNode.keyStart())/2),result=getLibraryDefiningNodeByOffset(lowLevelNode.unit(),offset);if(result)return result}if(lowLevelNode.value()){var offset=Math.floor((lowLevelNode.valueEnd()+lowLevelNode.valueStart())/2),result=getLibraryDefiningNodeByOffset(lowLevelNode.unit(),offset);if(result)return result}return null}function getLibraryDefiningNodeByOffset(unit,offset){var declaration=findDeclaration(unit,offset);if(declaration&&declaration.isElement&&declaration.isElement())for(var declarationNode=declaration.asElement(),parent=declarationNode;parent;){if(parent.definition().key()==universes.Universe10.Library)return parent;parent=parent.parent()}return null}var defs=__webpack_require__(36),hl=__webpack_require__(10),_=__webpack_require__(61),def=__webpack_require__(36),hlimpl=__webpack_require__(16),universes=__webpack_require__(22),ramlServices=def,sourceFinder=__webpack_require__(46),resourceRegistry=__webpack_require__(28);exports.declRoot=function(h){for(var declRoot=h;;){if(declRoot.definition().key()==universes.Universe10.Library)break;var np=declRoot.parent();if(!np)break;declRoot=np}return declRoot},exports.globalDeclarations=globalDeclarations,exports.findDeclarations=findDeclarations,exports.deepFindNode=deepFindNode,exports.extractName=extractName;var searchInTheValue=function(offset,content,attr,hlnode,p){void 0===p&&(p=attr.property());var targets=referenceTargets(p,hlnode),txt=extractName(content,offset),t=_.find(targets,function(x){return hlimpl.qName(x,hlnode)==txt});if(t)return t;if(p instanceof defs.UserDefinedProp){var up=p;return getUserDefinedPropertySource(up)}return null};exports.findUsages=findUsages,exports.referenceTargets=referenceTargets,exports.enumValues=enumValues,exports.findDeclarationByNode=findDeclarationByNode,exports.findDeclaration=findDeclaration,exports.findExampleContentType=findExampleContentType,exports.parseDocumentationContent=parseDocumentationContent,exports.parseStructuredExample=parseStructuredExample,exports.isExampleNode=isExampleNode,exports.isExampleNodeContent=isExampleNodeContent,exports.determineCompletionKind=determineCompletionKind,function(LocationKind){LocationKind[LocationKind.VALUE_COMPLETION=0]="VALUE_COMPLETION",LocationKind[LocationKind.KEY_COMPLETION=1]="KEY_COMPLETION",LocationKind[LocationKind.PATH_COMPLETION=2]="PATH_COMPLETION",LocationKind[LocationKind.DIRECTIVE_COMPLETION=3]="DIRECTIVE_COMPLETION",LocationKind[LocationKind.VERSION_COMPLETION=4]="VERSION_COMPLETION",LocationKind[LocationKind.ANNOTATION_COMPLETION=5]="ANNOTATION_COMPLETION",LocationKind[LocationKind.SEQUENCE_KEY_COPLETION=6]="SEQUENCE_KEY_COPLETION",LocationKind[LocationKind.INCOMMENT=7]="INCOMMENT"}(exports.LocationKind||(exports.LocationKind={}));var LocationKind=exports.LocationKind;exports.resolveReference=resolveReference,exports.subTypesWithLocals=subTypesWithLocals,exports.subTypesWithName=subTypesWithName,exports.schemasWithName=schemasWithName,exports.nodesDeclaringType=nodesDeclaringType,exports.findAllSubTypes=findAllSubTypes,exports.allChildren=allChildren;var testUsage=function(ck,x,node,result){var tp=ck.getAdapter(ramlServices.RAMLService).getDeclaringNode();if(tp&&node.isSameNode(tp))return void result.push(x);if(ck.isArray()&&testUsage(ck.array().componentType(),x,node,result),ck.isUnion()){var uni=ck.union();testUsage(uni.leftType(),x,node,result),testUsage(uni.rightType(),x,node,result)}ck.superTypes().some(function(x){return x.nameId()==node.name()})&&result.push(x)};exports.refFinder=refFinder},function(module,exports,__webpack_require__){"use strict";function expandTraitsAndResourceTypes(api){return api instanceof RamlWrapperImpl.ApiImpl||api instanceof RamlWrapper08Impl.ApiImpl?(new TraitsAndResourceTypesExpander).expandTraitsAndResourceTypes(api):null}function mergeAPIs(masterUnit,extensionsAndOverlays,mergeMode){var masterApi=hlimpl.fromUnit(masterUnit);if(!masterApi)throw new Error("couldn't load api from "+masterUnit.absolutePath());if(!extensionsAndOverlays||0==extensionsAndOverlays.length)return masterApi;for(var highLevelNodes=[],i=0;i<extensionsAndOverlays.length;i++){var unit=extensionsAndOverlays[i],hlNode=hlimpl.fromUnit(unit);if(!hlNode)throw new Error("couldn't load api from "+unit.absolutePath());highLevelNodes.push(hlNode)}var lastExtensionOrOverlay=mergeHighLevelNodes(masterApi,highLevelNodes,mergeMode);return lastExtensionOrOverlay}function mergeHighLevelNodes(masterApi,highLevelNodes,mergeMode){var currentMaster=masterApi;return highLevelNodes.forEach(function(currentApi){currentApi.overrideMaster(currentMaster),currentApi.setMergeMode(mergeMode),currentMaster=currentApi}),currentMaster}function toUnits1(nodes){for(var result=[],_i=0,nodes_1=nodes;_i<nodes_1.length;_i++){var n=nodes_1[_i];toUnits2(result,n,!0)}return result}function toUnits2(chainStart,node,append){void 0===append&&(append=!1);var result=append?chainStart:chainStart.concat([]),unit=node.lowLevel().unit();if(null==unit)return result;if(0==result.length)result.push(unit);else{var prevPath=result[result.length-1].absolutePath();unit.absolutePath()!=prevPath&&result.push(unit)}return result}function toUnits(node){for(var nodes=[];node;)nodes.push(node),node=node.parent();return toUnits1(nodes)}function getTransformNames(){return transformers.map(function(transformer){return transformer.name})}function getTransformerForOccurence(occurence){for(var result,i=0;i<transformers.length;i++)if(occurence.match(transformers[i].regexp)){result=transformers[i].transformer;break}return result}var __extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},hl=__webpack_require__(10),hlimpl=__webpack_require__(16),yaml=__webpack_require__(70),util=__webpack_require__(31),proxy=__webpack_require__(38),RamlWrapperImpl=__webpack_require__(20),RamlWrapper08Impl=__webpack_require__(47),wrapperHelper=__webpack_require__(32),wrapperHelper08=__webpack_require__(48),pluralize=__webpack_require__(72),universeDef=__webpack_require__(22),_=__webpack_require__(61),referencePatcher=__webpack_require__(49),changeCase=__webpack_require__(71);exports.expandTraitsAndResourceTypes=expandTraitsAndResourceTypes,exports.mergeAPIs=mergeAPIs;var TraitsAndResourceTypesExpander=function(){function TraitsAndResourceTypesExpander(){}return TraitsAndResourceTypesExpander.prototype.expandTraitsAndResourceTypes=function(api){var _this=this;if(api.definition().key()==universeDef.Universe10.Overlay)return api;this.ramlVersion=api.highLevel().definition().universe().version();var isRAML1=api instanceof RamlWrapperImpl.ApiImpl;this.globalTraits="RAML10"==this.ramlVersion?wrapperHelper.allTraits(api):wrapperHelper08.allTraits(api),this.globalResourceTypes="RAML10"==this.ramlVersion?wrapperHelper.allResourceTypes(api):wrapperHelper08.allResourceTypes(api);var unit=api.highLevel().lowLevel().unit(),hasFragments=unit.project().namespaceResolver().hasFragments(unit),hasTemplates=0!=this.globalTraits.length||0!=this.globalResourceTypes.length;if(!hasTemplates&&!hasFragments)return api;var hlNode=this.createHighLevelNode(api.highLevel()),result=hlNode.wrapperNode();result.setAttributeDefaults(api.getDefaultsCalculator().isEnabled()),this.traitMap={},this.resourceTypeMap={},result.highLevel().setMergeMode(api.highLevel().getMergeMode());var resources=result.resources();return resources.forEach(function(x){return _this.processResource(x)}),isRAML1&&(new referencePatcher.ReferencePatcher).process(hlNode),result},TraitsAndResourceTypesExpander.prototype.getTemplate=function(name,context,cache,globalList){var unitPath=context.lowLevel().unit().path(),unitCache=cache[unitPath];unitCache||(unitCache={},cache[unitPath]=unitCache);var val=unitCache[name];return void 0!==val?val:(val=null,val=_.find(globalList,function(x){return hlimpl.qName(x.highLevel(),context)==name}),val||(val=null),unitCache[name]=val,val)},TraitsAndResourceTypesExpander.prototype.createHighLevelNode=function(_api,merge){void 0===merge&&(merge=!0);for(var api=_api,highLevelNodes=[],node=api;node;){var llNode=node.lowLevel(),topComposite=new proxy.LowLevelCompositeNode(llNode,null,null,this.ramlVersion),nodeType=node.definition(),newNode=new hlimpl.ASTNodeImpl(topComposite,null,nodeType,null);if(highLevelNodes.push(newNode),!merge)break;node=node.getMaster()}var masterApi=highLevelNodes.pop();highLevelNodes=highLevelNodes.reverse();var mergeMode=api.getMergeMode();return mergeHighLevelNodes(masterApi,highLevelNodes,mergeMode)},TraitsAndResourceTypesExpander.prototype.processResource=function(resource){var _this=this,resourceData=this.collectResourceData(resource,resource),resourceLowLevel=resource.highLevel().lowLevel();resourceData.filter(function(x){return null!=x.resourceType}).forEach(function(x){var resourceTypeLowLevel=x.resourceType.node.highLevel().lowLevel(),resourceTypeTransformer=x.resourceType.transformer;resourceTypeTransformer.owner=resource,resourceLowLevel.adopt(resourceTypeLowLevel,resourceTypeTransformer)});var methods=resource.methods();methods.forEach(function(m){var methodLowLevel=m.highLevel().lowLevel(),name=m.method(),allTraits=[];resourceData.forEach(function(x){var methodTraits=x.methodTraits[name];methodTraits&&(allTraits=allTraits.concat(methodTraits),methodTraits.forEach(function(x){var traitLowLevel=x.node.highLevel().lowLevel(),traitTransformer=x.transformer;traitTransformer.owner=m,methodLowLevel.adopt(traitLowLevel,traitTransformer)}));var resourceTraits=x.traits;resourceTraits&&(allTraits=allTraits.concat(resourceTraits),resourceTraits.forEach(function(x){var traitLowLevel=x.node.highLevel().lowLevel(),traitTransformer=x.transformer;traitTransformer.owner=m,methodLowLevel.adopt(traitLowLevel,traitTransformer)}))})});var resources=resource.resources();resources.forEach(function(x){return _this.processResource(x)})},TraitsAndResourceTypesExpander.prototype.collectResourceData=function(original,obj,arr,transformer,nodesChain,occuredResourceTypes){var _this=this;void 0===arr&&(arr=[]),void 0===nodesChain&&(nodesChain=[]),void 0===occuredResourceTypes&&(occuredResourceTypes={}),nodesChain=nodesChain.concat([obj.highLevel()]);var ownTraits=this.extractTraits(obj,transformer,nodesChain),methodTraitsMap={},methods=obj.methods();methods.forEach(function(x){var methodTraits=_this.extractTraits(x,transformer,nodesChain);methodTraits&&methodTraits.length>0&&(methodTraitsMap[x.method()]=methodTraits)});var rtData,rtRef=obj.type();if(null!=rtRef){var units=toUnits1(nodesChain);rtData=this.readGenerictData(original,rtRef,obj.highLevel(),this.resourceTypeMap,this.globalResourceTypes,"resource type",transformer,units)}var result={resourceType:rtData,traits:ownTraits,methodTraits:methodTraitsMap};if(arr.push(result),rtData){var rt=rtData.node,qName=hlimpl.qName(rt.highLevel(),original.highLevel());occuredResourceTypes[qName]?result.resourceType=null:(occuredResourceTypes[qName]=!0,this.collectResourceData(original,rt,arr,rtData.transformer,nodesChain,occuredResourceTypes))}return arr},TraitsAndResourceTypesExpander.prototype.extractTraits=function(obj,_transformer,nodesChain,occuredTraits){var _this=this;void 0===occuredTraits&&(occuredTraits={}),nodesChain=nodesChain.concat([obj.highLevel()]);for(var arr=[],i=-1;i<arr.length;i++){var gd=i<0?null:arr[i],_obj=gd?gd.node:obj,units=gd?gd.unitsChain:toUnits1(nodesChain),transformer=gd?gd.transformer:_transformer;_obj.is&&_obj.is().forEach(function(x){var unitsChain=toUnits2(units,x.highLevel()),traitData=_this.readGenerictData(obj,x,_obj.highLevel(),_this.traitMap,_this.globalTraits,"trait",transformer,unitsChain);if(traitData){var name=traitData.name;occuredTraits[name]=!0,arr.push(traitData)}})}return arr},TraitsAndResourceTypesExpander.prototype.readGenerictData=function(r,obj,context,cache,globalList,template,transformer,unitsChain){void 0===unitsChain&&(unitsChain=[]);var value=obj.value();if("string"==typeof value){transformer&&(value=transformer.transform(value).value);var node=this.getTemplate(value,context,cache,globalList);if(node)return{name:value,transformer:null,parentTransformer:transformer,node:node,ref:obj,unitsChain:unitsChain}}else if(value instanceof hlimpl.StructuredValue){var sv=value,name=sv.valueName();transformer&&(name=transformer.transform(name).value);var scalarParams={},structuredParams={},node=this.getTemplate(name,context,cache,globalList);if(node){"RAML08"==this.ramlVersion?sv.children().forEach(function(x){return scalarParams[x.valueName()]=x.lowLevel().value()}):sv.children().forEach(function(x){var llNode=x.lowLevel();llNode.valueKind()==yaml.Kind.SCALAR?scalarParams[x.valueName()]=llNode.value():structuredParams[x.valueName()]=llNode});var ds=new DefaultTransformer(r,null,unitsChain);Object.keys(scalarParams).forEach(function(x){var q=ds.transform(scalarParams[x]);q&&"object"!=typeof q&&(scalarParams[x]=q)});var valTransformer=new ValueTransformer(template,name,unitsChain,scalarParams,structuredParams,transformer),resourceTypeTransformer=new DefaultTransformer(null,valTransformer,unitsChain);return{name:name,transformer:resourceTypeTransformer,parentTransformer:transformer,node:node,ref:obj,unitsChain:unitsChain}}}return null},TraitsAndResourceTypesExpander.prototype.appendTraitReferences=function(m,traits){if(0!=traits.length){var traitsData=traits.map(function(x){return{node:x.ref.highLevel().lowLevel(),transformer:x.parentTransformer}});referencePatcher.patchMethodIs(m.highLevel(),traitsData)}},TraitsAndResourceTypesExpander}();exports.TraitsAndResourceTypesExpander=TraitsAndResourceTypesExpander,exports.toUnits=toUnits;var TransformMatches=function(){function TransformMatches(name,transformer){this.name=name,this.regexp=new RegExp(TransformMatches.leftTransformRegexp.source+name+TransformMatches.rightTransformRegexp.source),this.transformer=transformer}return TransformMatches.leftTransformRegexp=/\|\s*!\s*/,TransformMatches.rightTransformRegexp=/\s*$/,TransformMatches}(),transformers=[new TransformMatches("singularize",function(arg){return pluralize.singular(arg)}),new TransformMatches("pluralize",function(arg){return pluralize.plural(arg)}),new TransformMatches("uppercase",function(arg){return arg?arg.toUpperCase():arg}),new TransformMatches("lowercase",function(arg){return arg?arg.toLowerCase():arg}),new TransformMatches("lowercamelcase",function(arg){return arg?changeCase.camelCase(arg):arg}),new TransformMatches("uppercamelcase",function(arg){if(!arg)return arg;var lowerCamelCase=changeCase.camelCase(arg);return lowerCamelCase[0].toUpperCase()+lowerCamelCase.substring(1,lowerCamelCase.length)}),new TransformMatches("lowerunderscorecase",function(arg){if(!arg)return arg;var snakeCase=changeCase.snake(arg);return snakeCase.toLowerCase()}),new TransformMatches("upperunderscorecase",function(arg){if(!arg)return arg;var snakeCase=changeCase.snake(arg);return snakeCase.toUpperCase()}),new TransformMatches("lowerhyphencase",function(arg){if(!arg)return arg;var paramCase=changeCase.param(arg);return paramCase.toLowerCase()}),new TransformMatches("upperhyphencase",function(arg){if(!arg)return arg;var paramCase=changeCase.param(arg);return paramCase.toUpperCase()})];exports.getTransformNames=getTransformNames,exports.getTransformerForOccurence=getTransformerForOccurence;var TransformationBuffer=function(){function TransformationBuffer(){this.buf=null}return TransformationBuffer.prototype.append=function(value){""!==value&&(null!=this.buf?null!=value&&("string"!=typeof this.buf&&(this.buf=""+this.buf),this.buf+=value):""!==value&&(this.buf=value))},TransformationBuffer.prototype.value=function(){return null!=this.buf?this.buf:""},TransformationBuffer}(),ValueTransformer=function(){function ValueTransformer(templateKind,templateName,unitsChain,params,structuredParams,vDelegate){this.templateKind=templateKind,this.templateName=templateName,this.unitsChain=unitsChain,this.params=params,this.structuredParams=structuredParams,this.vDelegate=vDelegate}return ValueTransformer.prototype.transform=function(obj,toString,doBreak,callback){var undefParams={},errors=[];if("string"==typeof obj){if(this.structuredParams&&util.stringStartsWith(obj,"<<")&&util.stringEndsWith(obj,">>")){var paramName=obj.substring(2,obj.length-2),structuredValue=this.structuredParams[paramName];if(null!=structuredValue)return{value:structuredValue.value(toString),errors:errors}}for(var str=obj,buf=new TransformationBuffer,prev=0,i=str.indexOf("<<");i>=0;i=str.indexOf("<<",prev)){buf.append(str.substring(prev,i));var i0=i;if(i+="<<".length,prev=this.paramUpperBound(str,i),prev==-1)break;var paramOccurence=str.substring(i,prev);prev+=">>".length;var val,paramName,originalString=str.substring(i0,prev),transformer=getTransformerForOccurence(paramOccurence);if(transformer){var ind=paramOccurence.lastIndexOf("|");paramName=paramOccurence.substring(0,ind).trim(),val=this.params[paramName],val&&"string"==typeof val&&val.indexOf("<<")>=0&&this.vDelegate&&(val=this.vDelegate.transform(val,toString,doBreak,callback).value),val&&(val=transformer(val))}else paramName=paramOccurence.trim(),val=this.params[paramName],val&&"string"==typeof val&&val.indexOf("<<")>=0&&this.vDelegate&&(val=this.vDelegate.transform(val,toString,doBreak,callback).value);null!==val&&void 0!==val||(undefParams[paramName]=!0,val=originalString),buf.append(val)}var upArr=Object.keys(undefParams);if(upArr.length>0){var errStr=upArr.join(", ").trim(),message="Undefined "+this.templateKind+" parameter"+(upArr.length>1?"s":"")+": "+errStr,error={code:hl.IssueCode.MISSING_REQUIRED_PROPERTY,isWarning:!1,message:message,node:null,start:-1,end:-1,path:null};errors.push(error)}return buf.append(str.substring(prev,str.length)),{value:buf.value(),errors:errors}}return{value:obj,errors:errors}},ValueTransformer.prototype.paramUpperBound=function(str,pos){for(var count=0,i=pos;i<str.length;i++)if(util.stringStartsWith(str,"<<",i))count++,i++;else if(util.stringStartsWith(str,">>",i)){if(0==count)return i;count--,i++}return str.length},ValueTransformer.prototype.children=function(node){var substitution=this.substitutionNode(node);return substitution?substitution.children():null},ValueTransformer.prototype.valueKind=function(node){var substitution=this.substitutionNode(node);return substitution?substitution.valueKind():null},ValueTransformer.prototype.substitutionNode=function(node){var paramName=this.paramName(node);return paramName&&this.structuredParams[paramName]},ValueTransformer.prototype.paramName=function(node){var paramName=null;if(node.valueKind()==yaml.Kind.SCALAR){var val=(""+node.value()).trim();util.stringStartsWith(val,"<<")&&util.stringEndsWith(val,">>")&&(paramName=val.substring(2,val.length-2))}return paramName},ValueTransformer;
}();exports.ValueTransformer=ValueTransformer;var DefaultTransformer=function(_super){function DefaultTransformer(owner,delegate,unitsChain){_super.call(this,null!=delegate?delegate.templateKind:"",null!=delegate?delegate.templateName:"",unitsChain),this.owner=owner,this.delegate=delegate}return __extends(DefaultTransformer,_super),DefaultTransformer.prototype.transform=function(obj,toString,doContinue,callback){if(null==obj||null!=doContinue&&!doContinue())return{value:obj,errors:[]};var ownResult={value:obj,errors:[]},gotDefaultParam=!1;defaultParameters.forEach(function(x){return gotDefaultParam=gotDefaultParam||obj.toString().indexOf("<<"+x)>=0}),gotDefaultParam&&(this.initParams(),ownResult=_super.prototype.transform.call(this,obj,toString,doContinue,callback));var result=null!=this.delegate?this.delegate.transform(ownResult.value,toString,doContinue,callback):ownResult.value;return null!=doContinue&&doContinue()&&null!=callback&&(result.value=callback(result.value,this)),result},DefaultTransformer.prototype.initParams=function(){for(var methodName,resourcePathName,resourcePath="",ll=this.owner.highLevel().lowLevel(),node=ll instanceof proxy.LowLevelProxyNode?ll.originalNode().originalNode():ll,last=null;node;){var key=node.key();if(null!=key)if(util.stringStartsWith(key,"/")){if(!resourcePathName)for(var arr=key.split("/"),i=arr.length-1;i>=0;i--){var seg=arr[i];if(seg.indexOf("{")==-1){resourcePathName=arr[i];break}seg.length>0&&(last=seg)}resourcePath=key+resourcePath}else methodName=key;node=node.parent()}resourcePathName||last&&(resourcePathName=""),this.params={resourcePath:resourcePath,resourcePathName:resourcePathName},methodName&&(this.params.methodName=methodName)},DefaultTransformer.prototype.children=function(node){return null!=this.delegate?this.delegate.children(node):null},DefaultTransformer.prototype.valueKind=function(node){return null!=this.delegate?this.delegate.valueKind(node):null},DefaultTransformer}(ValueTransformer);exports.DefaultTransformer=DefaultTransformer;var defaultParameters=["resourcePath","resourcePathName","methodName"]},function(module,exports,__webpack_require__){(function(process){"use strict";function evalInSandbox(code,thisArg,args){return new loophole.Function(code).call(thisArg,args)}function checkPropertyQuard(n,v){var pr=n.property();return pr&&pr.getContextRequirements().forEach(function(x){n.checkContextValue(x.name,x.value,x.value)||v.accept(createIssue(hl.IssueCode.MISSED_CONTEXT_REQUIREMENT,x.name+" should be "+x.value+" to use property "+pr.nameId(),n))}),pr}function lintNode(astNode,acceptor){var fsEnabled;try{fsEnabled=astNode.lowLevel().unit().project().fsEnabled()}catch(exception){fsEnabled=!0}if(fsEnabled&&"undefined"!=typeof fs&&fs){for(var fsMethods=["exists","readFile","writeFile","readdir","existsSync","readFileSync","writeFileSync","readdirSync"],i=(Object.keys(fs),0);i<fsMethods.length;i++)if(!fs[fsMethods[i]])return;var ps=astNode.lowLevel().unit().absolutePath(),dr=path.dirname(ps),customLinter=path.resolve(dr,"raml-lint.js");lintWithFile(customLinter,acceptor,astNode);var dir=path.resolve(dr,".raml");if(fs.existsSync(dir)){var st=fs.statSync(dir);if(st.isDirectory()){var files=fs.readdirSync(dir);files.forEach(function(x){x.indexOf("-lint.js")!=-1&&lintWithFile(path.resolve(dir,x),acceptor,astNode)})}}}}function isTypeOrSchema(d){return d.nameId()==universes.Universe10.TypeDeclaration.properties.type.name||d.nameId()==universes.Universe10.TypeDeclaration.properties.schema.name}function isDefaultValueProp(d){return!!checkIfDomainIsUserDefined(d)&&d.nameId()==universes.Universe10.TypeDeclaration.properties.default.name}function isExampleProp(d){return!!checkIfDomainIsUserDefined(d)&&d.nameId()==universes.Universe10.TypeDeclaration.properties.example.name}function checkIfDomainIsUserDefined(d){return!!d.domain()&&!d.domain().getAdapter(services.RAMLService).isUserDefined()}function isSecuredBy(d){return!!checkIfDomainIsUserDefined(d)&&d.nameId()==universes.Universe08.MethodBase.properties.securedBy.name}function typeOfContainingTemplate(h){for(var declRoot=h;;){if(declRoot.definition().getAdapter(services.RAMLService).isInlinedTemplates())return declRoot.definition().nameId();var np=declRoot.parent();if(!np)break;declRoot=np}return null}function restrictUnknownNodeError(node){var parentNode=node.parent(),issue=null,parentDef=parentNode.definition();if(parentNode&&parentDef instanceof def.UserDefinedClass){var parentProperty=parentNode.property();if(universeHelpers.isIsProperty(parentProperty)||universeHelpers.isTypeProperty(parentProperty)){var paramName=node.name();issue=null!=exports.RESERVED_TEMPLATE_PARAMETERS[paramName]?createIssue(hl.IssueCode.INVALID_PROPERTY,"Invalid parameter name: "+paramName+" is reserved",node):createIssue(hl.IssueCode.UNKNOWN_NODE,"Unused parameter: "+paramName,node)}}if(!issue){var propName=node.name(),universe08=universeProvider("RAML08"),isRAML08=parentDef.universe().version()==universe08.version();if(isRAML08){var parameterTypeName=universes.Universe08.Parameter.name;universes.Universe10.TypeDeclaration.name;if(isRAML08&&parentDef.isAssignableFrom(parameterTypeName)){for(var possibleDefs=universe08.type(parameterTypeName).allSubTypes().filter(function(x){return null!=universes.Universe08[x.nameId()].properties[propName]}),possibleDefsMap={},i=0;i<possibleDefs.length;i++){var x=possibleDefs[i];if(!possibleDefsMap[x.nameId()]){var valueRequirements=x.valueRequirements();if(valueRequirements&&0!=valueRequirements.length){var typeRquirements=valueRequirements.filter(function(x){return"type"==x.name}).map(function(x){return x.value});if(0!=typeRquirements.length){var runtimeName=typeRquirements[0];possibleDefsMap[x.nameId()]=runtimeName,x.allSubTypes().forEach(function(y){return possibleDefs.push(y)})}}}}var runtimeNames=Object.keys(possibleDefsMap).map(function(x){return possibleDefsMap[x]}).sort();if(runtimeNames.length>0){var namesStr=runtimeNames.map(function(x,i){var x1="'"+x+"'";return i==runtimeNames.length-1?x1:i==runtimeNames.length-2?x1+" or ":x1+", "}).join(""),message="Property '"+propName+"' can only be used if type is "+namesStr;issue=createIssue(hl.IssueCode.ILLEGAL_PROPERTY,message,node)}}}}return issue}function validateBasic(node,v,requiredOnly){void 0===requiredOnly&&(requiredOnly=!1);var parentNode=node.parent(),llValue=node.lowLevel().value();if(node.lowLevel()){if(node.lowLevel().keyKind()==yaml.Kind.MAP&&v.accept(createIssue(hl.IssueCode.UNKNOWN_NODE,"Node key can not be map",node)),node.lowLevel().keyKind()==yaml.Kind.SEQ&&null==llValue){var isPattern=!1;node.isElement()&&node.asElement().definition().isAssignableFrom(universes.Universe10.TypeDeclaration.name)&&(isPattern=!0),isPattern||v.accept(createIssue(hl.IssueCode.UNKNOWN_NODE,"Node key can not be sequence",node))}null==parentNode&&node.lowLevel().errors().forEach(function(x){var ps=x.mark?x.mark.position:0,em={code:hl.IssueCode.YAML_ERROR,message:x.message,node:null,start:ps,end:ps+1,isWarning:!1,path:node.lowLevel().unit()==node.root().lowLevel().unit()?null:node.lowLevel().unit().path(),unit:node.lowLevel().unit()};v.accept(em)})}if(node.isUnknown()){if(node.name().indexOf("<<")!=-1&&null!=typeOfContainingTemplate(parentNode))return void(new TraitVariablesValidator).validateName(node,v);if(node.needSequence&&v.accept(createIssue(hl.IssueCode.UNKNOWN_NODE,"node: "+node.name()+" should be wrapped in sequence",node)),node.needMap)return void v.accept(createIssue(hl.IssueCode.UNKNOWN_NODE,(node.knownProperty?node.knownProperty.nameId():"")+" should be a map in RAML 1.0",node));if(node.unresolvedRef&&v.accept(createIssue(hl.IssueCode.UNKNOWN_NODE,"reference: "+llValue+" can not be resolved",node)),node.knownProperty){if(0==node.lowLevel().includeErrors().length){if(typeOfContainingTemplate(parentNode)&&util.startsWith(llValue,"<<")&&util.endsWith(llValue,">>"))return;if("body"==node.name()&&node.computedValue("mediaType"))return;"~"!=node.lowLevel().value()&&v.accept(createIssue(hl.IssueCode.UNKNOWN_NODE,"property "+node.name()+" can not have scalar value",node))}}else{var issue=restrictUnknownNodeError(node);issue||(issue=createIssue(hl.IssueCode.UNKNOWN_NODE,"Unknown node: "+node.name(),node)),v.accept(issue)}}if(node.markCh()&&!node.allowRecursive()){if(!node.property())return;return void v.accept(createIssue(hl.IssueCode.UNKNOWN_NODE,"Recursive definition: "+node.name(),node))}if(node.definition&&node.definition().isAssignableFrom(universes.Universe10.Operation.name)){var queryStringNode=node.element(universes.Universe10.Operation.properties.queryString.name),queryParamsNode=node.lowLevel&&_.find(node.lowLevel().children(),function(child){return child.key&&child.key()===universes.Universe10.Operation.properties.queryParameters.name});queryStringNode&&queryParamsNode&&(v.accept(createIssue(hl.IssueCode.UNKNOWN_NODE,universes.Universe10.Operation.properties.queryParameters.name+" already specified.",queryStringNode)),v.accept(createLLIssue(hl.IssueCode.UNKNOWN_NODE,universes.Universe10.Operation.properties.queryString.name+" already specified.",queryParamsNode,node)))}try{var isOverlay=node.definition&&node.definition()&&node.definition().key()===universes.Universe10.Overlay,children=isOverlay?node.children():node.directChildren();children.filter(function(child){return!requiredOnly||child.property&&child.property()&&child.property().isRequired()}).forEach(function(x){return x&&x.errorMessage?void v.accept(createIssue(hl.IssueCode.UNKNOWN_NODE,x.errorMessage,x.name()?x:node)):void x.validate(v)})}finally{node.unmarkCh()}}function hasTemplateArgs(node){var vl=node.value();if("string"==typeof vl&&vl.indexOf("<<")!=-1)return!0;for(var x=node.children(),i=0;i<x.length;i++)if(hasTemplateArgs(x[i]))return!0;return!1}function validate(node,v){if(!node.parent())try{validateIncludes(node,v)}finally{cleanupIncludesFlag(node,v)}if(node.isAttr())(new CompositePropertyValidator).validate(node,v);else if(node.isElement()){if(node.invalidSequence){var pName=node.property().nameId(),msg=changeCase.sentenceCase(pluralize.singular(pName));msg="In RAML 1.0 "+msg+" is not allowed to have sequence as definition",v.acceptUnique(createLLIssue(hl.IssueCode.UNKNOWN_NODE,msg,node.lowLevel().parent().parent(),node,!1))}var highLevelNode=node.asElement();if(universeHelpers.isExampleSpecType(highLevelNode.definition())){var hlChildren=highLevelNode.children();if(0==hlChildren.length)return void validateBasic(node,v,!0);var content=hlChildren.filter(function(x){var propName=x.lowLevel().key();return!propName||("("!=propName.charAt(0)||")"!=propName.charAt(propName.length-1))&&null==highLevelNode.definition().property(propName)});if(content.length>0)return void validateBasic(node,v,!0)}if(highLevelNode.definition().isAnnotationType()||highLevelNode.property()&&"annotations"==highLevelNode.property().nameId())return void(new FixedFacetsValidator).validate(highLevelNode,v);if(highLevelNode.definition().isAssignableFrom(universes.Universe10.UsesDeclaration.name)){var vn=highLevelNode.attr(universes.Universe10.UsesDeclaration.properties.value.name);if(vn&&vn.value()){var rs=highLevelNode.lowLevel().unit().resolve(vn.value());if(rs){if(!resourceRegistry.isWaitingFor(vn.value())){var issues=[];if(rs.highLevel().validate(hlimpl.createBasicValidationAcceptor(issues)),issues.length>0){var brand=createIssue(hl.IssueCode.UNRESOLVED_REFERENCE,"Issues in the used library:"+vn.value(),highLevelNode,!1);issues.forEach(function(x){x.unit=rs,x.path=rs.absolutePath()}),brand.extras=issues,v.accept(brand)}}}else v.accept(createIssue(hl.IssueCode.UNRESOLVED_REFERENCE,"Can not resolve library from path:"+vn.value(),highLevelNode,!1))}}if(highLevelNode.definition().isAssignableFrom(universes.Universe10.TypeDeclaration.name)){if(typeOfContainingTemplate(highLevelNode)&&hasTemplateArgs(highLevelNode.lowLevel()))return;return highLevelNode.attrs().forEach(function(a){var range=a.property().range().key();if(range==universes.Universe08.RelativeUriString||range==universes.Universe10.RelativeUriString)return void(new UriValidator).validate(a,v);if(range==universes.Universe08.FullUriTemplateString||range==universes.Universe10.FullUriTemplateString)return void(new UriValidator).validate(a,v);if(a.property().getAdapter(services.RAMLPropertyService).isKey()){var nameId=node.property()&&node.property().nameId();if(nameId==universes.Universe08.Resource.properties.uriParameters.name||nameId==universes.Universe08.Resource.properties.baseUriParameters.name)return;if(highLevelNode.property()&&highLevelNode.property().nameId()==universes.Universe10.MethodBase.properties.body.name)return void(new MediaTypeValidator).validate(a,v)}}),highLevelNode.parent()&&!highLevelNode.parent().parent()&&rtypes.builtInTypes().get(highLevelNode.name())&&v.accept(createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,"redefining a built in type:"+highLevelNode.name(),highLevelNode)),(new RecurrentOverlayValidator).validate(highLevelNode,v),(new RecurrentValidateChildrenKeys).validate(highLevelNode,v),(new NodeSpecificValidator).validate(highLevelNode,v),void(new TypeDeclarationValidator).validate(highLevelNode,v)}if(highLevelNode.definition().isAssignableFrom(universes.Universe10.LibraryBase.name)){var vv,hasSchemas=!1,hasTypes=!1;highLevelNode.lowLevel().children().forEach(function(x){"schemas"==x.key()&&(hasSchemas=!0,vv=x),"types"==x.key()&&(hasTypes=!0)}),hasSchemas&&hasTypes&&v.accept(localLowLevelError(vv,highLevelNode,hl.IssueCode.ILLEGAL_PROPERTY_VALUE,!1,"types and schemas are mutually exclusive",!1))}var hasRequireds=highLevelNode.definition().requiredProperties()&&highLevelNode.definition().requiredProperties().length>0,isAllowAny=highLevelNode.definition().getAdapter(services.RAMLService).getAllowAny();isAllowAny?hasRequireds&&validateBasic(node,v,!0):validateBasic(node,v),(new UriParametersValidator).validate(highLevelNode,v),(new CompositeNodeValidator).validate(highLevelNode,v),(new TemplateCyclesDetector).validate(highLevelNode,v)}else validateBasic(node,v);(new OptionalPropertiesValidator).validate(node,v)}function cleanupIncludesFlag(node,v){var val=node.lowLevel().actual();delete val._inc,node.children().forEach(function(x){return cleanupIncludesFlag(x,v)})}function validateIncludes(node,v){var llNode=node.lowLevel(),val=llNode.actual();if(!val._inc){if(node.isElement()){var vl=node.name();"string"==typeof vl&&null!=vl&&vl.indexOf(" ")!=-1&&v.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"Keys should not have spaces '"+vl+"'",node,!0))}if(val._inc=!0,llNode){llNode.includeErrors().forEach(function(x){var isWarn=!1;node.lowLevel().hasInnerIncludeError()&&(isWarn=!0);var em=createIssue(hl.IssueCode.UNABLE_TO_RESOLVE_INCLUDE_FILE,x,node,isWarn);v.accept(em)});var includePath=llNode.includePath();if(null!=includePath&&!path.isAbsolute(includePath)&&!ll.isWebPath(includePath)){var unitPath=llNode.unit().absolutePath(),exceeding=calculateExceeding(path.dirname(unitPath),includePath);if(exceeding>0){var em=createIssue(hl.IssueCode.UNABLE_TO_RESOLVE_INCLUDE_FILE,"Resolved include path exceeds file system root",node,!0);v.accept(em)}}}node.children().forEach(function(x){return validateIncludes(x,v)})}}function calculateExceeding(rootPath,relativePath){for(var rootSegments=actualSegments(rootPath),relativeSegments=actualSegments(relativePath),count=rootSegments.length,result=0,_i=0,relativeSegments_1=relativeSegments;_i<relativeSegments_1.length;_i++){var segment=relativeSegments_1[_i];".."==segment?(count--,count<0&&(result=Math.min(count,result))):count++}return-1*result}function isValid(t,h,value,p,attr){return t.hasArrayInHierarchy()?isValidArray(t,h,value,p,attr):!t.hasValueTypeInHierarchy()||isValidValueType(t,h,value,p,attr)}function isValidArray(t,h,v,p,attr){return!t.arrayInHierarchy().componentType()||isValid(t.arrayInHierarchy().componentType(),h,v,p)}function isValidValueType(t,h,v,p,attr){try{if(t.key()==universes.Universe10.AnnotationRef){var targets=search.referenceTargets(p,h),actualAnnotation=_.find(targets,function(x){return hlimpl.qName(x,h)==v});if(null!=actualAnnotation){var attrs=actualAnnotation.attributes("allowedTargets");if(attrs){var aVals=attrs.map(function(x){return x.value()});if(aVals.length>0){var found=!1,tps=h.definition().allSuperTypes();tps=tps.concat([h.definition()]);var tpNames=tps.map(function(x){return x.nameId()});if(aVals.forEach(function(x){"API"==x&&(x="Api"),"NamedExample"==x&&(x="ExampleSpec"),"SecurityScheme"==x&&(x="AbstractSecurityScheme"),"SecuritySchemeSettings"==x&&(x="SecuritySchemeSettings"),_.find(tpNames,function(y){return y==x})?found=!0:("Parameter"==x&&h.computedValue("location")&&(found=!0),"Field"==x&&h.computedValue("field")&&(found=!0))}),!found)return new Error("annotation "+v+" can not be placed at this location, allowed targets are:"+aVals)}}}return tm}if(t.key()==universes.Universe08.SchemaString||t.key()==universes.Universe10.SchemaString){var tm=su.createSchema(v,contentProvider(h.lowLevel()));return tm instanceof Error&&(tm.canBeRef=!0),tm}if(t.key()==universes.Universe08.StatusCodeString||t.key()==universes.Universe10.StatusCodeString){var err=validateResponseString(v);if(null!=err)return err}if(t.key()==universes.Universe08.BooleanType||t.isAssignableFrom(universes.Universe10.BooleanType.name)){if("true"!==v&&"false"!==v&&v!==!0&&v!==!1)return new Error("'true' or 'false' is expected here");if(attr){var stringValue=attr.lowLevel().value(!0);if("true"!==stringValue&&"false"!==stringValue)return new Error("'true' or 'false' is expected here")}}if(t.key()==universes.Universe08.NumberType||t.isAssignableFrom(universes.Universe10.NumberType.name)){var q=parseFloat(v);if(isNaN(q))return new Error("the value of "+p.nameId()+" must be a number")}if((t.key()==universes.Universe08.StringType||t.isAssignableFrom(universes.Universe10.StringType.name))&&null===v&&h&&p){var highLevelProperty=h.attr(p.nameId());if(highLevelProperty){var lowLevelChildren=highLevelProperty.lowLevel().children();if(lowLevelChildren&&lowLevelChildren.length>0)return new Error(p.nameId()+" must be a string")}}return!0}catch(e){return e.canBeRef=!0,e}}function getHumanReadableNodeName(astNode){if(!astNode)return null;if(astNode.isElement()){var element=astNode,definition=element.definition();if(definition&&exports.typeToName.hasOwnProperty(definition.nameId()))return exports.typeToName[definition.nameId()];if(definition.isAssignableFrom(universes.Universe10.TypeDeclaration.name)||definition.isAssignableFrom(universes.Universe08.Parameter.name)){if(element.property()&&exports.parameterPropertyToName.hasOwnProperty(element.property().nameId()))return exports.parameterPropertyToName[element.property().nameId()];if(element.property()&&element.parent()&&element.property().nameId()==universes.Universe10.LibraryBase.properties.types.name&&element.parent().definition()&&element.parent().definition().isAssignableFrom(universes.Universe10.LibraryBase.name))return"type";if(element.property()&&element.parent()&&element.property().nameId()==universes.Universe10.LibraryBase.properties.securitySchemes.name&&element.parent().definition()&&element.parent().definition().isAssignableFrom(universes.Universe10.LibraryBase.name))return"security scheme"}}return null}function isValidPropertyValue(pr,vl,c){var node=search.declRoot(c);node._cach||(node._cach={});var id=pr.id();if(pr.domain()&&(id+=pr.domain().nameId()),id){var cached=node._cach[id];if(cached)return null!=cached[vl]}var vls=search.enumValues(pr,c),mm={};return vls.forEach(function(x){return mm[x]=1}),pr.id()&&(node._cach[id]=mm),null!=mm[vl]}function checkReference(pr,astNode,vl,cb){if(checkTraitReference(pr,astNode,cb),checkResourceTypeReference(pr,astNode,cb),vl&&("null"!=vl||!pr.isAllowNull())){var adapter=pr.getAdapter(services.RAMLPropertyService),valid=isValidPropertyValue(pr,vl,astNode.parent());if(valid||astNode.lowLevel().unit().absolutePath()===astNode.parent().lowLevel().unit().absolutePath()||(valid=isValidPropertyValue(pr,vl,hlimpl.fromUnit(astNode.lowLevel().unit()))),!valid){if("string"==typeof vl&&0==vl.indexOf("x-")&&pr.nameId()==universes.Universe10.TypeDeclaration.properties.type.name)return!0;var expected=adapter.isReference&&adapter.isReference()&&adapter.referencesTo&&adapter.referencesTo()&&adapter.referencesTo().nameId&&adapter.referencesTo().nameId(),referencedToName=exports.typeToName[expected]||nameForNonReference(astNode),message=referencedToName?"Unrecognized "+referencedToName+" '"+vl+"'.":"Unresolved reference: "+vl,spesializedMessage=specializeReferenceError(message,pr,astNode);return cb.accept(createIssue(hl.IssueCode.UNRESOLVED_REFERENCE,spesializedMessage,astNode,pr.range().key()===universes.Universe08.SchemaString)),!0}if(isDuplicateSibling(astNode)&&universeHelpers.isTraitRefType(astNode.definition())){var message="Duplicate trait reference '"+vl+"'.",spesializedMessage=specializeReferenceError(message,pr,astNode);return cb.accept(createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,spesializedMessage,astNode)),!0}return!1}}function isDuplicateSibling(attr){var siblingName,ramlVersion=attr.property().domain().universe().version();if(siblingName="RAML10"==ramlVersion?stringify(json.serialize(attr.lowLevel())):attr.value()&&attr.value().valueName&&attr.value().valueName(),!siblingName)return!1;var parent=attr.parent&&attr.parent();if(!parent)return!1;var propertyName=attr.name&&attr.name();if(!propertyName)return!1;var siblings=parent.attributes&&parent.attributes(propertyName);if(!siblings)return!1;if(0===siblings.length)return!1;var count=0;return siblings.forEach(function(sibling){var name;"RAML10"==ramlVersion?siblingName=stringify(json.serialize(sibling.lowLevel())):name=sibling.value&&sibling.value()&&sibling.value().valueName&&sibling.value().valueName(),name===siblingName&&count++}),count>1}function checkTraitReference(property,astNode,acceptor){if(universeHelpers.isIsProperty(property)){var lowLevel=astNode.lowLevel();if(null!=lowLevel){var isMappingNode=null,lowLevelParent=lowLevel.parent(),lowLevelParentParent=null!=lowLevelParent?lowLevelParent.parent():null;if(lowLevel.kind()==yaml.Kind.MAPPING&&lowLevel.key()&&"is"==lowLevel.key()?isMappingNode=lowLevel:null!=lowLevelParent&&lowLevelParent.kind()==yaml.Kind.MAPPING&&lowLevelParent.key()&&"is"==lowLevelParent.key()?isMappingNode=lowLevelParent:null!=lowLevelParentParent&&lowLevelParentParent.kind()==yaml.Kind.MAPPING&&lowLevelParentParent.key()&&"is"==lowLevelParentParent.key()&&(isMappingNode=lowLevelParentParent),null!=isMappingNode){null==isMappingNode.value()||isMappingNode.children()&&0!=isMappingNode.children().length||acceptor.accept(createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,"property 'is' must be an array",astNode));var illegalChildFound=!1;isMappingNode.children().forEach(function(child){child.kind()!=yaml.Kind.SCALAR&&child.kind()!=yaml.Kind.MAP&&(illegalChildFound=!0)}),illegalChildFound&&acceptor.accept(createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,"property 'is' must be an array",astNode))}}}}function checkResourceTypeReference(property,astNode,acceptor){if(universeHelpers.isTypeProperty(property)&&universeHelpers.isResourceTypeRefType(astNode.definition())){var lowLevel=astNode.lowLevel();null==astNode.value()&&lowLevel&&lowLevel.children()&&0==lowLevel.children().length?lowLevel.kind()==yaml.Kind.MAPPING&&null!=lowLevel.valueKind()&&acceptor.accept(createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,"resource type name must be provided",astNode)):null==astNode.value()&&lowLevel&&lowLevel.children()&&lowLevel.children().length>1&&acceptor.accept(createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,"a resource or resourceType can inherit from a single resourceType",astNode))}}function specializeReferenceError(originalMessage,property,astNode){return"type"==property.nameId()&&"RAML08"==property.domain().universe().version()&&property.domain().isAssignableFrom(universes.Universe08.Parameter.name)?"type can be either of: string, number, integer, file, date or boolean":null!=astNode.parent()&&universeHelpers.isSecuritySchemaType(astNode.parent().definition())?originalMessage+" Allowed values are:OAuth 1.0,OAuth 2.0,Basic Authentication,DigestSecurityScheme Authentication,x-{other}":originalMessage}function nameForNonReference(astNode){var propertyName=astNode&&astNode.lowLevel()&&astNode.lowLevel().key();if(propertyName===universes.Universe10.AbstractSecurityScheme.properties.type.name){var domain=astNode.parent()&&astNode.parent().definition()&&astNode.parent().definition().nameId();if(domain===universes.Universe10.AbstractSecurityScheme.name)return"security scheme type"}else if(propertyName===universes.Universe08.BodyLike.properties.schema.name){var domain=astNode.parent()&&astNode.parent().definition()&&astNode.parent().definition().nameId();if(domain===universes.Universe08.BodyLike.name)return"schema"}}function mapPath(node,e){var src=e.getValidationPath();return findElementAtPath(node,src)}function extractLowLevelNode(e){var pn=e.getExtra(rtypes.SOURCE_EXTRA);return pn instanceof hlimpl.LowLevelWrapperForTypeSystem?pn.node():null}function findElementAtPath(n,p){if(!p)return n;for(var chld=n.children(),i=0;i<chld.length;i++)if(chld[i].name()===p.name)return findElementAtPath(chld[i],p.child);if(!n.lowLevel())return n;for(var lchld=n.lowLevel().children(),i=0;i<lchld.length;i++)if(lchld[i].key()===p.name){var nn=new hlimpl.BasicASTNode(lchld[i],n);return findElementAtPath(nn,p.child)}if(!isNaN(p.name)&&lchld[p.name]){var node=lchld[p.name],nn=new hlimpl.BasicASTNode(node,n);return findElementAtPath(nn,p.child)}return n}function contentProvider(lowLevel){var root=lowLevel&&lowLevel.includeBaseUnit()&&(lowLevel.includePath&&lowLevel.includePath()?lowLevel.includeBaseUnit().resolve(lowLevel.includePath()):lowLevel.includeBaseUnit());return new contentprovider.ContentProvider(root)}function isJson(s){return s.indexOf("json")!=-1}function isXML(s){return s.indexOf("xml")!=-1}function getMediaType(node){var vl=getMediaType2(node);if("body"==vl){var rootMedia=node.root().attr("mediaType");return rootMedia?rootMedia.value():null}return vl}function getMediaType2(node){if(node.parent()){var pc=node.parent().definition();if(pc.key()==universes.Universe08.BodyLike)return node.parent().name();if(node.parent().parent()){var ppc=node.parent().parent().definition().key();if(ppc==universes.Universe08.Response||ppc==universes.Universe10.Response)return node.parent().property().nameId()==universes.Universe08.Response.properties.headers.name?null:node.parent().name();if(ppc==universes.Universe08.Method||ppc==universes.Universe10.Method)return node.parent().property().nameId()==universes.Universe10.MethodBase.properties.queryParameters.name||node.parent().property().nameId()==universes.Universe10.MethodBase.properties.headers.name?null:node.parent().name()}}return null}function toIssue(error,node){return createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,error.getMessage(),mapPath(node,error),error.isWarning())}function createIssue(c,message,node,w){void 0===w&&(w=!1);var original=null,pr=null;if(node.lowLevel()instanceof proxy.LowLevelProxyNode)for(var proxyNode=node.lowLevel();!proxyNode.primaryNode();)original||(original=localError(node,c,w,message,!0,pr)),node=node.parent(),proxyNode=node.lowLevel();if(node&&(pr=node.property(),node.lowLevel().unit()!=node.root().lowLevel().unit())){original=localError(node,c,w,message,!0,pr);for(node.lowLevel().unit();node.lowLevel().unit()!=node.root().lowLevel().unit();)pr=node.property(),node=node.parent()}original&&node.property()&&node.property().nameId()==universes.Universe10.FragmentDeclaration.properties.uses.name&&null!=node.parent()&&(pr=node.property(),node=node.parent());var error=localError(node,c,w,message,!1,pr);return original&&error.extras.push(original),error}function createLLIssue(issueCode,message,node,rootCalculationAnchor,isWarning){void 0===isWarning&&(isWarning=!1);var original=null;if(node&&rootCalculationAnchor.lowLevel().unit()!=rootCalculationAnchor.root().lowLevel().unit()){original=localLowLevelError(node,rootCalculationAnchor,issueCode,isWarning,message,!0);var v=rootCalculationAnchor.lowLevel().unit();for(v&&(message=message+" "+v.path());rootCalculationAnchor.lowLevel().unit()!=rootCalculationAnchor.root().lowLevel().unit();)rootCalculationAnchor=rootCalculationAnchor.parent()}original&&rootCalculationAnchor.property()&&rootCalculationAnchor.property().nameId()==universes.Universe10.FragmentDeclaration.properties.uses.name&&null!=rootCalculationAnchor.parent()&&(rootCalculationAnchor=rootCalculationAnchor.parent());var error=localLowLevelError(node,rootCalculationAnchor,issueCode,isWarning,message,!1);return original&&error.extras.push(original),error}function validateResponseString(v){if(3!=v.length)return new Error("Status code should be 3 digits number.");for(var i=0;i<v.length;i++){var c=v[i];if(!_.find(["0","1","2","3","4","5","6","7","8","9"],function(x){return x==c}))return new Error("Status code should be 3 digits number.")}return null}var jsyaml=__webpack_require__(27),json=__webpack_require__(50),stringify=__webpack_require__(62),proxy=__webpack_require__(38),hl=__webpack_require__(10),ll=__webpack_require__(11),_=__webpack_require__(61),yaml=__webpack_require__(70),def=__webpack_require__(36),hlimpl=__webpack_require__(16),path=__webpack_require__(15),fs=__webpack_require__(44),universes=__webpack_require__(22),universeHelpers=__webpack_require__(14),universeProvider=__webpack_require__(34),services=def,OverloadingValidator=__webpack_require__(51),expander=__webpack_require__(24),search=__webpack_require__(23),rtypes=def.rt,util=__webpack_require__(41),contentprovider=__webpack_require__(30),resourceRegistry=__webpack_require__(28),su=def.getSchemaUtils(),mediaTypeParser=__webpack_require__(63),xmlutil=__webpack_require__(52),changeCase=__webpack_require__(71),pluralize=__webpack_require__(72),LinterSettings=function(){function LinterSettings(){this.validateNotStrictExamples=!0}return LinterSettings}(),settings=new LinterSettings,loophole=__webpack_require__(78);exports.RESERVED_TEMPLATE_PARAMETERS={resourcePathName:'Part of the resource path following the rightmost "/"',methodName:"Method name",resourcePath:"Path of the resource"};var lintWithFile=function(customLinter,acceptor,astNode){if(fs.existsSync(customLinter))try{var content=fs.readFileSync(customLinter).toString(),factr=new LinterExtensionsImpl(acceptor);evalInSandbox(content,factr,null),factr.visit(astNode)}catch(e){console.log("Error in custom linter"),console.log(e)}},LinterExtensionsImpl=function(){function LinterExtensionsImpl(acceptor){this.acceptor=acceptor,this.nodes={}}return LinterExtensionsImpl.prototype.error=function(w,message){this.acceptor.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,message,w.highLevel()))},LinterExtensionsImpl.prototype.errorOnProperty=function(w,property,message){var pr=w.highLevel().attr(property);this.acceptor.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,message,pr))},LinterExtensionsImpl.prototype.warningOnProperty=function(w,property,message){var pr=w.highLevel().attr(property);this.acceptor.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,message,pr,!0))},LinterExtensionsImpl.prototype.warning=function(w,message){this.acceptor.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,message,w.highLevel(),!0))},LinterExtensionsImpl.prototype.registerRule=function(nodeType,rule){var q=this.nodes[nodeType];q||(q=[],this.nodes[nodeType]=q),q.push(rule)},LinterExtensionsImpl.prototype.visit=function(h){var _this=this,nd=h.definition();this.process(nd,h),nd.allSuperTypes().forEach(function(x){return _this.process(x,h)}),h.elements().forEach(function(y){return _this.visit(y)})},LinterExtensionsImpl.prototype.process=function(d,h){var _this=this;if(d instanceof def.NodeClass&&!d.getAdapter(services.RAMLService).getDeclaringNode()){var rules=this.nodes[d.nameId()];rules&&rules.forEach(function(x){return x(h.wrapperNode(),_this)})}},LinterExtensionsImpl;
}();(function(){function StackNode(){}return StackNode.prototype.toString=function(){return this.prev?this.value+"."+this.prev.toString():this.value},StackNode.prototype.last=function(){return this.prev?this.prev.last():this},StackNode})();exports.validateBasic=validateBasic,exports.validate=validate;var actualSegments=function(rootPath){rootPath=rootPath.replace(/\\/g,"/").trim(),rootPath.length>1&&":"==rootPath.charAt(1)&&/^win/.test(process.platform)&&(rootPath=rootPath.substring(2));var segments=rootPath.split("/");return 0==segments[0].length&&(segments=segments.slice(1)),segments.length>0&&0==segments[segments.length-1].length&&(segments=segments.slice(0,segments.length-1)),segments},validateRegexp=function(cleanedValue,v,node){try{new RegExp(cleanedValue)}catch(Error){v.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"Illegal pattern "+cleanedValue,node))}},TraitVariablesValidator=function(){function TraitVariablesValidator(){}return TraitVariablesValidator.prototype.validateName=function(node,acceptor){var name=node.name();if(name){var start=node.lowLevel().keyStart();this.check(name,start,node,acceptor)}},TraitVariablesValidator.prototype.validateValue=function(node,acceptor){var value=node.value();if("string"==typeof value){var start=node.lowLevel().valueStart();this.check(value,start,node,acceptor)}},TraitVariablesValidator.prototype.hasTraitOrResourceTypeParent=function(node){for(var parent=node.parent();null!=parent;){if(!parent.definition())return!1;if(universeHelpers.isTraitType(parent.definition())||universeHelpers.isResourceTypeType(parent.definition()))return!0;parent=parent.parent()}return!1},TraitVariablesValidator.prototype.check=function(str,start,node,acceptor){if(!this.hasTraitOrResourceTypeParent(node))return[];for(var errors=[],prev=0,i=str.indexOf("<<");i>=0;i=str.indexOf("<<",prev)){i+="<<".length,prev=str.indexOf(">>",i);var paramOccurence=str.substring(i,prev),ind=paramOccurence.lastIndexOf("|"),paramName=ind>=0?paramOccurence.substring(0,ind):paramOccurence;if(0==paramName.trim().length){var msg="Trait or resource type parameter name must contain non whitespace characters",issue=createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,msg,node,!1);issue.start=start+i,issue.end=start+prev,acceptor.accept(issue)}if(ind!=-1){ind++;var transformerName=paramOccurence.substring(ind).trim(),functionNames=expander.getTransformNames();if(!_.find(functionNames,function(functionName){return transformerName===functionName||transformerName==="!"+functionName})){var msg="Unknown function applied to parameter: "+transformerName,issue=createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,msg,node,!1);issue.start=start+ind,issue.end=start+prev,acceptor.accept(issue)}}prev+=">>".length}return errors},TraitVariablesValidator}(),MethodBodyValidator=function(){function MethodBodyValidator(){}return MethodBodyValidator.prototype.validate=function(node,validationAcceptor){var methodNode=node.parent();if(methodNode&&(methodNode.definition().isAssignableFrom(universes.Universe08.Method.name)||methodNode.definition().isAssignableFrom(universes.Universe10.Method.name))){var hasBody=_.find(methodNode.lowLevel()&&methodNode.lowLevel().children()||[],function(child){var keyValue=child.key();return keyValue&&(universes.Universe08.MethodBase.properties.body.name===keyValue||universes.Universe10.MethodBase.properties.body.name===keyValue)});hasBody&&_.find(MethodBodyValidator.methodsWithoutRequestBody,function(methodDisabled){return methodNode.name()===methodDisabled})&&validationAcceptor.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,'Request body is disabled for "'+methodNode.name()+'" method.',methodNode))}},MethodBodyValidator.methodsWithoutRequestBody=["trace"],MethodBodyValidator}(),CompositePropertyValidator=function(){function CompositePropertyValidator(){}return CompositePropertyValidator.prototype.validate=function(node,v){var pr=checkPropertyQuard(node,v),vl=node.value();if(!node.property().range().hasStructure()){if(vl instanceof hlimpl.StructuredValue&&!node.property().isSelfNode()){if(isTypeOrSchema(node.property())&&node.property().domain().key()==universes.Universe08.BodyLike){var newNode=new hlimpl.ASTNodeImpl(node.lowLevel(),node.parent(),node.parent().definition().universe().type(universes.Universe08.BodyLike.name),node.property());return void newNode.validate(v)}if("RAML10"==node.parent().definition().universe().version()&&null!=typeOfContainingTemplate(node.parent()))return;v.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"Scalar is expected here",node))}else{var vk=node.lowLevel().valueKind();if(node.lowLevel().valueKind()!=yaml.Kind.INCLUDE_REF&&!node.property().getAdapter(services.RAMLPropertyService).isKey()&&!node.property().isMultiValue()){var k=node.property().range().key();k!=universes.Universe08.StringType&&k!=universes.Universe08.MarkdownString&&k!=universes.Universe08.MimeType||vk!=yaml.Kind.SEQ&&vk!=yaml.Kind.MAPPING&&vk!=yaml.Kind.MAP&&(!node.property().isRequired()&&"mediaType"!=node.property().nameId()||null!=vk&&void 0!==vk)||node.property().domain().getAdapter(services.RAMLService).isInlinedTemplates()||v.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"property '"+node.name()+"' must be a string",node))}}if(node.isAnnotatedScalar()){var fvl=new FixedFacetsValidator;node.annotations().forEach(function(x){var vl=x.value(),highLevel=vl.toHighLevel();highLevel?fvl.validate(highLevel,v):v.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"unknown annotation "+vl.valueName(),x))})}}var refName;if("string"==typeof vl?refName=vl:vl instanceof hlimpl.StructuredValue&&(refName=vl.valueName()),!(refName&&refName.indexOf("<<")!=-1&&refName.indexOf(">>")>refName.indexOf("<<")&&((new TraitVariablesValidator).validateValue(node,v),null!=typeOfContainingTemplate(node.parent())))){if((new MethodBodyValidator).validate(node,v),node.property().range().key()==universes.Universe08.MimeType||node.property().range().key()==universes.Universe10.MimeType||node.property().nameId()==universes.Universe10.TypeDeclaration.properties.name.name&&node.parent().property().nameId()==universes.Universe10.MethodBase.properties.body.name)return void(new MediaTypeValidator).validate(node,v);if(isExampleProp(node.property())||isDefaultValueProp(node.property())){if("RAML08"==node.definition().universe().version()){node.lowLevel().value();if(node.lowLevel().children().length>0){var valName=isExampleProp(node.property())?"example":"default value";v.accept(createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,valName+" should be a string",node,!1))}}(new ExampleAndDefaultValueValidator).validate(node,v)}if(isSecuredBy(node.property())){if("RAML08"==node.definition().universe().version()){var np=node.lowLevel().parent(),ysc=yaml.Kind.SEQ,msg="`securedBy` should be a list in RAML08";node.lowLevel()instanceof proxy.LowLevelProxyNode?np.valueKind()!=ysc&&v.accept(createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,msg,node,!1)):np.kind()!=ysc&&v.accept(createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,msg,node,!1))}(new ExampleAndDefaultValueValidator).validate(node,v)}if(node.property().nameId()==universes.Universe10.TypeDeclaration.properties.name.name){var nameId=node.parent().property()&&node.parent().property().nameId();if(nameId==universes.Universe08.Resource.properties.uriParameters.name||nameId==universes.Universe08.Resource.properties.baseUriParameters.name)return}var range=node.property().range().key();if(range==universes.Universe08.RelativeUriString||range==universes.Universe10.RelativeUriString)return void(new UriValidator).validate(node,v);if(range==universes.Universe08.FullUriTemplateString||range==universes.Universe10.FullUriTemplateString)return void(new UriValidator).validate(node,v);if("pattern"==node.name()&&universes.Universe10.StringType==node.definition().key()&&node.parent().definition().isAssignableFrom("StringTypeDeclaration")&&validateRegexp(node.value(),v,node),"name"==node.name()&&universes.Universe10.StringType==node.definition().key()&&"string"==typeof node.value()&&0==node.value().indexOf("[")&&node.value().lastIndexOf("]")==node.value().length-1&&node.parent()instanceof hlimpl.ASTNodeImpl&&universes.Universe10.ObjectTypeDeclaration.properties.properties.name==node.parent().property().nameId()&&node.parent().parent()instanceof hlimpl.ASTNodeImpl&&universes.Universe10.ObjectTypeDeclaration==node.parent().parent().definition().key()){var cleanedValue=node.value().substr(1,node.value().length-2);validateRegexp(cleanedValue,v,node)}pr.isReference()||pr.isDescriminator()?(new DescriminatorOrReferenceValidator).validate(node,v):(new NormalValidator).validate(node,v)}},CompositePropertyValidator}();exports.isValid=isValid;var NormalValidator=function(){function NormalValidator(){}return NormalValidator.prototype.validate=function(node,cb){var vl=node.value(),pr=node.property(),range=pr.range(),dnode=range.getAdapter(services.RAMLService).getDeclaringNode();if(dnode&&range.isUserDefined()){var rof=dnode.parsedType(),dp=node.parent().lowLevel().dumpToObject(),tempVal=dp[node.parent().name()],isVal=pr.canBeValue(),val=isVal||null===tempVal||void 0===tempVal?tempVal:tempVal[pr.nameId()],validateObject=rof.validate(val,!0);validateObject.isOk()||validateObject.getErrors().forEach(function(e){return cb.accept(createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,e.getMessage(),node,!1))})}var v=cb;if(node.lowLevel().keyKind()!=yaml.Kind.SEQ)var validation=isValid(pr.range(),node.parent(),vl,pr,node);else validation=!0;if(validation instanceof Error&&!validation.canBeRef)return v.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,validation.message,node)),void(validation=null);if(!validation||validation instanceof Error)if("value"!=pr.nameId()){if(!checkReference(pr,node,vl,v)){if((pr.nameId()==universes.Universe10.TypeDeclaration.properties.schema.name||universes.Universe10.TypeDeclaration.properties.type.name)&&vl&&vl.trim()&&(pr.domain().key()==universes.Universe08.BodyLike||pr.domain().key()==universes.Universe10.TypeDeclaration)){var testSchema=vl.trim().charAt(0);if("{"!=testSchema&&"<"!=testSchema)return}var decl=node.findReferencedValue();if(decl instanceof Error&&v.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,decl.message,node)),!decl){if(vl&&pr.nameId()==universes.Universe10.TypeDeclaration.properties.schema.name){var z=vl.trim();if("{"!=z.charAt(0)&&"<"!=z.charAt(0)&&(vl.indexOf("|")!=-1||vl.indexOf("[]")!=-1||vl.indexOf("(")!=-1))return}if(validation instanceof Error&&vl)return v.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,validation.message,node)),void(validation=null);if(node.property().isRequired()&&null==node.value())v.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"Empty value is not allowed here",node));else{var ck=node.lowLevel().valueKind();ck!=yaml.Kind.MAP&&ck!=yaml.Kind.SEQ&&ck!=yaml.Kind.MAPPING||v.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"Empty value is not allowed here",node))}}}}else{var vl=node.value(),message="Invalid value schema:"+vl;validation instanceof Error&&(message=validation.message),v.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,message,node,pr.range().key()==universes.Universe08.SchemaString))}var values=pr.enumOptions();if(values){if("string"!=typeof vl)return;"string"==typeof values?values!=vl&&(vl&&0==vl.indexOf("x-")&&pr.nameId()==universes.Universe08.AbstractSecurityScheme.properties.type.name||v.accept(createIssue(hl.IssueCode.UNRESOLVED_REFERENCE,"Invalid value:"+vl+" allowed values are:"+values,node))):values.length>0&&(_.find(values,function(x){return x==vl})||vl&&0==vl.indexOf("x-")&&pr.nameId()==universes.Universe08.AbstractSecurityScheme.properties.type.name||v.accept(createIssue(hl.IssueCode.UNRESOLVED_REFERENCE,"Invalid value:"+vl+" allowed values are:"+values.join(","),node)))}},NormalValidator}(),UriValidator=function(){function UriValidator(){}return UriValidator.prototype.validate=function(node,cb){try{var values=(new UrlParameterNameValidator).parseUrl(node.value());if(values.some(function(x){return"version"==x})&&"baseUri"==node.property().nameId()){var version=node.root().attr("version");version||cb.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"missing version",node,!1))}values.some(function(x){return 0==x.length})&&cb.accept(createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,"URI parameter must have name specified",node,!1))}catch(e){cb.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,e.message,node,!1))}},UriValidator}(),MediaTypeValidator=function(){function MediaTypeValidator(){}return MediaTypeValidator.prototype.validate=function(node,cb){try{var v=node.value();if(!v)return;if("*/*"==v)return;if(v.indexOf("/*")==v.length-2&&(v=v.substring(0,v.length-2)+"/xxx"),node.parent()&&node.parent().parent()&&node.parent().parent().definition().isAssignableFrom(universes.Universe10.Trait.name)&&v.indexOf("<<")>=0)return;if("body"==v&&node.parent().parent()){var ppc=node.parent().parent().definition().key();(ppc===universes.Universe08.Response||ppc===universes.Universe10.Response||node.parent().parent().definition().isAssignableFrom(universes.Universe10.MethodBase.name))&&(v=node.parent().computedValue("mediaType"))}var res=mediaTypeParser.parse(v);res.type.match(/[\w\d][\w\d!#\$&\-\^_+\.]*/)||cb.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"Invalid media type '"+res.type+"'",node))}catch(e){cb.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,""+e.message,node))}(node.value()&&"multipart/form-data"==node.value()||"application/x-www-form-urlencoded"==node.value())&&node.parent()&&node.parent().parent()&&node.parent().parent().property()&&node.parent().parent().property().nameId()==universes.Universe10.MethodBase.properties.responses.name&&cb.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"Form related media types can not be used in responses",node,!0))},MediaTypeValidator}(),UrlParameterNameValidator=function(){function UrlParameterNameValidator(){}return UrlParameterNameValidator.prototype.checkBaseUri=function(node,c,vl,v){var bu=c.root().attr("baseUri");if(bu){var tnv=bu.value();try{var pNames=this.parseUrl(tnv);_.find(pNames,function(x){return x==vl})||v.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"Unused url parameter",node))}catch(e){}}else v.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"Unused url parameter",node))},UrlParameterNameValidator.prototype.parseUrl=function(value){for(var result=[],temp="",inPar=!1,count=0,a=0;a<value.length;a++){var c=value[a];"{"!=c?"}"!=c?inPar&&(temp+=c):(count--,inPar=!1,result.push(temp),temp=""):(count++,inPar=!0)}if(count>0)throw new Error("Invalid resource name: unmatched '{'");if(count<0)throw new Error("Invalid resource name: unmatched '}'");return result},UrlParameterNameValidator.prototype.validate=function(node,cb){var vl=node.value();if(node.parent().property().nameId()==universes.Universe10.Api.properties.baseUri.name){var c=node.parent().parent();return void this.checkBaseUri(node,c,vl,cb)}var c=node.parent().parent(),tn=c.name();if(c.definition().key()===universes.Universe10.Api||c.definition().key()===universes.Universe08.Api)return void this.checkBaseUri(node,c,vl,cb);if(c.definition().key()!=universes.Universe10.ResourceType&&c.definition().key()!=universes.Universe08.ResourceType)try{var pNames=this.parseUrl(tn),foundInLocalParameters=_.find(pNames,function(x){return x==vl});if(!foundInLocalParameters){var baseUri=node.root().attr(universes.Universe10.Api.properties.baseUri.name);if(baseUri&&node.name()===universes.Universe08.Api.properties.baseUriParameters.name){var baseUriValue=baseUri.value();if(baseUriValue&&(pNames=this.parseUrl(baseUriValue),pNames&&pNames.length>0&&_.find(pNames,function(x){return x==vl})))return}cb.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"Unused url parameter '"+vl+"'",node))}}catch(e){}},UrlParameterNameValidator}();exports.UrlParameterNameValidator=UrlParameterNameValidator,exports.typeToName={},exports.typeToName[universes.Universe08.Trait.name]="trait",exports.typeToName[universes.Universe08.ResourceType.name]="resource type",exports.typeToName[universes.Universe10.Trait.name]="trait",exports.typeToName[universes.Universe10.ResourceType.name]="resource type",exports.typeToName[universes.Universe10.AbstractSecurityScheme.name]="security scheme",exports.typeToName[universes.Universe10.Method.name]="method",exports.typeToName[universes.Universe08.Method.name]="method",exports.typeToName[universes.Universe10.Resource.name]="resource",exports.typeToName[universes.Universe08.Resource.name]="resource",exports.typeToName[universes.Universe10.Api.name]="api",exports.typeToName[universes.Universe08.Api.name]="api",exports.typeToName[universes.Universe10.Response.name]="response",exports.typeToName[universes.Universe08.Response.name]="response",exports.typeToName[universes.Universe08.BodyLike.name]="body",exports.parameterPropertyToName={},exports.parameterPropertyToName[universes.Universe08.MethodBase.properties.headers.name]="header",exports.parameterPropertyToName[universes.Universe08.MethodBase.properties.queryParameters.name]="query parameter",exports.parameterPropertyToName[universes.Universe08.Api.properties.uriParameters.name]="uri parameter",exports.parameterPropertyToName[universes.Universe08.Api.properties.baseUriParameters.name]="base uri parameter",exports.parameterPropertyToName[universes.Universe08.BodyLike.properties.formParameters.name]="form parameter",exports.parameterPropertyToName[universes.Universe10.MethodBase.properties.headers.name]="header",exports.parameterPropertyToName[universes.Universe10.MethodBase.properties.queryParameters.name]="query parameter",exports.parameterPropertyToName[universes.Universe10.ResourceBase.properties.uriParameters.name]="uri parameter",exports.parameterPropertyToName[universes.Universe10.Api.properties.baseUriParameters.name]="base uri parameter",exports.parameterPropertyToName[universes.Universe10.MethodBase.properties.body.name]="body",exports.getHumanReadableNodeName=getHumanReadableNodeName;var DescriminatorOrReferenceValidator=function(){function DescriminatorOrReferenceValidator(){}return DescriminatorOrReferenceValidator.prototype.validate=function(node,cb){var vl=node.value(),valueKey=vl,pr=node.property();if("string"==typeof vl){if(checkReference(pr,node,vl,cb),pr.range()instanceof def.ReferenceType){var mockNode=(pr.range(),jsyaml.createNode(""+vl,node.lowLevel().parent()));mockNode._actualNode().startPosition=node.lowLevel().valueStart(),mockNode._actualNode().endPosition=node.lowLevel().valueEnd();var stv=new hlimpl.StructuredValue(mockNode,node.parent(),node.property()),hn=stv.toHighLevel();hn&&hn.validate(cb)}}else if(null!=vl){var st=vl;if(st){valueKey=st.valueName();var vn=st.valueName();if(!checkReference(pr,node,vn,cb)){var hnode=st.toHighLevel();hnode&&hnode.validate(cb)}}else valueKey=null}else node.definition().isAssignableFrom(universes.Universe10.Reference.name)&&checkReference(pr,node,null,cb);if(valueKey){var validation=isValid(pr.range(),node.parent(),valueKey,pr);validation instanceof Error&&(cb.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,validation.message,node)),validation=null)}},DescriminatorOrReferenceValidator}(),RAMLVersionAndFragmentValidator=function(){function RAMLVersionAndFragmentValidator(){}return RAMLVersionAndFragmentValidator.prototype.validate=function(node,v){var u=node.universe(),tv=u.getTypedVersion();if(tv){if("0.8"!==tv&&"1.0"!==tv){var i=createIssue(hl.IssueCode.NODE_HAS_VALUE,"Unknown version of RAML expected to see one of '#%RAML 0.8' or '#%RAML 1.0'",node);v.accept(i)}var tl=u.getOriginalTopLevelText();if(tl)if(tl!=node.definition().nameId()){if("Api"==node.definition().nameId()){var i=createIssue(hl.IssueCode.NODE_HAS_VALUE,"Unknown top level type:"+tl,node);v.accept(i)}}else if("Api"==u.getOriginalTopLevelText()){var i=createIssue(hl.IssueCode.NODE_HAS_VALUE,"Redundant fragment name:"+tl,node);v.accept(i)}}},RAMLVersionAndFragmentValidator}(),RequiredPropertiesAndContextRequirementsValidator=function(){function RequiredPropertiesAndContextRequirementsValidator(){}return RequiredPropertiesAndContextRequirementsValidator.prototype.validate=function(node,v){var _this=this;node.definition().getAdapter(services.RAMLService).getContextRequirements().forEach(function(x){if(!node.checkContextValue(x.name,x.value,x.value)){var message=x.name+(" should be "+x.value+" to use type "+node.definition().nameId());"location"==x.name&&"ParameterLocation.FORM"==x.value&&(message="file type can be only used in web forms"),v.accept(createIssue(hl.IssueCode.MISSED_CONTEXT_REQUIREMENT,message,node))}});var t,isInlinedTemplate=node.definition().getAdapter(services.RAMLService).isInlinedTemplates();if(isInlinedTemplate){for(var paramsMap={},_i=0,_a=node.lowLevel().children();_i<_a.length;_i++){var ch=_a[_i];paramsMap[ch.key()]=ch.value(!0)}for(var templateKind=node.definition().isAssignableFrom(universes.Universe10.Trait.name)?"trait":"resource type",unitsChain=expander.toUnits(node),vt=new expander.ValueTransformer(templateKind,node.definition().nameId(),unitsChain,paramsMap),parent=node.parent(),def=parent?parent.definition():node.definition();null!=parent&&!universeHelpers.isResourceType(def)&&!universeHelpers.isMethodType(def);)parent=parent.parent();t=new expander.DefaultTransformer(parent,vt,unitsChain)}node.definition().requiredProperties().forEach(function(x){if(isInlinedTemplate){var paths=x.getAdapter(services.RAMLPropertyService).meta("templatePaths");if(paths){for(var parent=node.parent(),hasSufficientChild=!1,_i=0,paths_1=paths;_i<paths_1.length;_i++){var path=paths_1[_i];if(path=path.map(function(x){return t.transform(x).value}),_this.checkPathSufficiency(parent.lowLevel(),path,parent)){hasSufficientChild=!0;break}}if(!hasSufficientChild)return}}var r=x.range();if(r.hasArrayInHierarchy()&&(r=r.arrayInHierarchy().componentType()),r.hasValueTypeInHierarchy()){var nm=node.attr(x.nameId()),gotValue=!1;if(null!=nm&&(nm.lowLevel().kind()==yaml.Kind.SCALAR||nm.lowLevel().valueKind()==yaml.Kind.SCALAR||nm.lowLevel().kind()==yaml.Kind.INCLUDE_REF||nm.lowLevel().valueKind()==yaml.Kind.INCLUDE_REF||null===nm.lowLevel().valueKind()&&!isInlinedTemplate?gotValue=!0:0!=nm.lowLevel().children().length&&(gotValue=!0)),!gotValue){var msg="Missing required property "+x.nameId();isInlinedTemplate&&(msg="value was not provided for parameter: "+x.nameId());var i=createIssue(hl.IssueCode.MISSING_REQUIRED_PROPERTY,msg,node);v.accept(i)}}else{var el=node.elementsOfKind(x.nameId());if(!el||0==el.length){var i=createIssue(hl.IssueCode.MISSING_REQUIRED_PROPERTY,"Missing required property "+x.nameId(),node);v.accept(i)}}})},RequiredPropertiesAndContextRequirementsValidator.prototype.checkPathSufficiency=function(node,path,hlParent){if(null==hlParent||null==hlParent.definition())return!1;var definition=hlParent.definition();if(universeHelpers.isResourceTypeType(definition)||universeHelpers.isTraitType(definition))return!0;if(0==path.length)return!1;if(null==node)return!1;var segment=path[0];if(null==segment)return!1;if("/"==segment)return this.checkPathSufficiency(node,path.slice(1),hlParent);if(0==segment.length)return!0;var children=node.children().filter(function(x){return x.key()==segment});0==children.length&&path.indexOf("/")<0;var lowLevel=children[0];if(lowLevel instanceof proxy.LowLevelCompositeNode&&(lowLevel=lowLevel.primaryNode()),null==lowLevel)return path.indexOf("/")<0;if("type"==lowLevel.key())return!0;if(1==path.length)return null==lowLevel||null==lowLevel.value();var path1=path.slice(1);return this.checkPathSufficiency(lowLevel,path1,hlParent)},RequiredPropertiesAndContextRequirementsValidator}(),ScalarQuoteValidator=function(){function ScalarQuoteValidator(){}return ScalarQuoteValidator.prototype.validate=function(node,v){var r=node.lowLevel().unit();node.lowLevel().visit(function(x){if(x.unit()!=r)return!1;if(x.value()&&x._node&&x._node.value&&x._node.value.doubleQuoted){var ind=(x.value()+"").indexOf(":"),nl=(x.value()+"").indexOf("\n");if(ind!=-1&&nl!=-1&&(!x.includePath()||0==x.includePath().length)){var i=createIssue(hl.IssueCode.NODE_HAS_VALUE,'Suspicious double quoted multiline scalar, it is likely that you forgot closing " '+x.value(),node,!0);i.start=x._node.value.startPosition,i.end=x._node.value.endPosition,i.start==i.end&&i.end++,v.accept(i)}}return!0})},ScalarQuoteValidator}(),FixedFacetsValidator=function(){function FixedFacetsValidator(){}return FixedFacetsValidator.prototype.validate=function(node,v){var nc=node.definition(),dnode=nc.getAdapter(services.RAMLService).getDeclaringNode();if(dnode){var rof=dnode.parsedType(),dp=node.lowLevel().dumpToObject(!0);dp&&(dp=dp[Object.keys(dp)[0]]);var validateObject=rof.validate(dp,!1,!1);validateObject.isOk()||validateObject.getErrors().forEach(function(e){return v.accept(createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,e.getMessage(),mapPath(node,e),!1))})}},FixedFacetsValidator}(),TypeDeclarationValidator=function(){function TypeDeclarationValidator(){}return TypeDeclarationValidator.prototype.validate=function(node,v){var rof=(node.definition(),node.parsedType()),validateObject=rof.validateType(node.types().getAnnotationTypeRegistry());if(!validateObject.isOk())for(var _i=0,_a=validateObject.getErrors();_i<_a.length;_i++){var issue,e=_a[_i],n=extractLowLevelNode(e);issue=n?createLLIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,e.getMessage(),n,mapPath(node,e),e.isWarning()):createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,e.getMessage(),mapPath(node,e),e.isWarning()),v.accept(issue)}var examplesLowLevel=node.lowLevel()&&node.lowLevel().find&&node.lowLevel().find("examples");examplesLowLevel&&examplesLowLevel.valueKind&&examplesLowLevel.valueKind()===yaml.Kind.SEQ&&(issue=createLLIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,"map is expected here.",examplesLowLevel,node,!1),v.accept(issue))},TypeDeclarationValidator}(),CompositeNodeValidator=function(){function CompositeNodeValidator(){}return CompositeNodeValidator.prototype.validate=function(node,acceptor){if(!node.definition().isAnnotationType()){if(node.lowLevel().keyKind()==yaml.Kind.SEQ){var isPattern=node.definition().isAssignableFrom(universes.Universe10.TypeDeclaration.name);isPattern||acceptor.accept(createIssue(hl.IssueCode.UNKNOWN_NODE,"Node key can not be sequence",node))}if(node.definition().key()==universes.Universe08.GlobalSchema&&node.lowLevel().valueKind()!=yaml.Kind.SCALAR){var isString=!1;if(node.lowLevel().valueKind()==yaml.Kind.ANCHOR_REF||node.lowLevel().valueKind()==yaml.Kind.INCLUDE_REF){var vl=node.lowLevel().value();"string"==typeof vl&&(isString=!0)}isString||acceptor.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"schema "+node.name()+" must be a string",node))}node.parent()||((new RAMLVersionAndFragmentValidator).validate(node,acceptor),node.definition().key()!=universes.Universe08.Api&&node.definition().key()!=universes.Universe10.Api||(new OverloadingValidator).validateApi(node.wrapperNode(),acceptor),(new ScalarQuoteValidator).validate(node,acceptor),lintNode(node,acceptor)),(new OverlayNodesValidator).validate(node,acceptor);var nc=node.definition();if(nc.key()==universes.Universe08.BodyLike&&node.lowLevel().children().map(function(x){return x.key()}).some(function(x){return"formParameters"===x}))if(node.parent()&&node.parent().definition().key()==universes.Universe08.Response){var i=createIssue(hl.IssueCode.NODE_HAS_VALUE,"form parameters can not be used in response",node);acceptor.accept(i)}else if(node.lowLevel().children().map(function(x){return x.key()}).some(function(x){return"schema"===x||"example"===x})){var i=createIssue(hl.IssueCode.NODE_HAS_VALUE,"formParameters cannot be used together with the example or schema properties",node);acceptor.accept(i)}if(nc.key()==universes.Universe10.OAuth2SecuritySchemeSettings){var requireUrl=!1;if(node.attributes("authorizationGrants").forEach(function(x){var vl=x.value();if("authorization_code"===vl||"implicit"===vl)requireUrl=!0;else if("password"!==vl&&"client_credentials"!==vl&&vl&&"string"==typeof vl&&vl.indexOf("://")==-1&&vl.indexOf(":")==-1){var i=createIssue(hl.IssueCode.NODE_HAS_VALUE,"authorizationGrants should be one of authorization_code,implicit,password,client_credentials or to be an abolute URI",x);acceptor.accept(i)}}),requireUrl&&!node.attr("authorizationUri")){var i=createIssue(hl.IssueCode.NODE_HAS_VALUE,"authorizationUri is required when `authorization_code` or `implicit` grant type are used ",node);acceptor.accept(i)}}if(node.definition().isAssignableFrom(universes.Universe08.Parameter.name)||node.definition().isAssignableFrom(universes.Universe10.TypeDeclaration.name)){var vls=node.attributes("enum").map(function(x){return x.value()});if(vls.length!=_.uniq(vls).length){var i=createIssue(hl.IssueCode.NODE_HAS_VALUE,"enum contains duplicated values",node);acceptor.accept(i)}if(node.definition().isAssignableFrom(universes.Universe08.NumberTypeDeclaration.name)||node.definition().isAssignableFrom(universes.Universe10.NumberTypeDeclaration.name)){var isInteger=node.definition().isAssignableFrom(universes.Universe08.IntegerTypeDeclaration.name)||node.definition().isAssignableFrom(universes.Universe10.IntegerTypeDeclaration.name);node.attributes("enum").forEach(function(attribute){var value=isInteger?parseInt(attribute.value()):parseFloat(attribute.value()),isValid=isInteger?!isNaN(value)&&attribute.value().indexOf(".")===-1:!isNaN(value);if(!isValid){var issue=createIssue(hl.IssueCode.NODE_HAS_VALUE,(isInteger?"Integer":"Number")+" is expected",attribute);acceptor.accept(issue)}})}}universeHelpers.isResourceTypeType(node.definition())&&null==node.value()&&"null"===node.lowLevel().value(!0)&&acceptor.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"Resource type can not be null",node)),checkPropertyQuard(node,acceptor);var nodeValue=node.value();if(("string"==typeof nodeValue||"number"==typeof nodeValue||"boolean"==typeof nodeValue)&&!node.definition().getAdapter(services.RAMLService).allowValue()&&node.parent()&&"~"!=nodeValue){var i=createIssue(hl.IssueCode.NODE_HAS_VALUE,"node "+node.name()+" can not be a scalar",node);acceptor.accept(i)}(new RequiredPropertiesAndContextRequirementsValidator).validate(node,acceptor),(new ValidateChildrenKeys).validate(node,acceptor),(new NodeSpecificValidator).validate(node,acceptor)}},CompositeNodeValidator}(),BaseUriParameterValidator=function(){function BaseUriParameterValidator(){}return BaseUriParameterValidator.prototype.validate=function(node,acceptor){var nameAttributeValue=node.attrValue(universes.Universe10.TypeDeclaration.properties.name.name);"version"==nameAttributeValue&&acceptor.accept(createIssue(hl.IssueCode.ILLEGAL_PROPERTY,"version parameter not allowed here",node))},BaseUriParameterValidator}(),NodeSpecificValidatorRegistryEntry=function(){function NodeSpecificValidatorRegistryEntry(definitions,propertyName,validator,assignableFrom){void 0===assignableFrom&&(assignableFrom=!1),this.definitions=definitions,this.propertyName=propertyName,this.assignableFrom=assignableFrom,this.validator=validator}return NodeSpecificValidatorRegistryEntry.prototype.validate=function(node,acceptor){var nodeDefinition=node.definition();if(null!=nodeDefinition){var definitionMatched=!1;if(definitionMatched=this.assignableFrom?this.definitions.some(function(currentDefinition){return nodeDefinition.isAssignableFrom(currentDefinition.name)}):this.definitions.some(function(currentDefinition){return currentDefinition===nodeDefinition})){if(null!=this.propertyName){if(null==node.property())return;if(node.property().nameId()!=this.propertyName)return}this.validator.validate(node,acceptor)}}},NodeSpecificValidatorRegistryEntry}(),NodeSpecificValidator=function(){function NodeSpecificValidator(){}return NodeSpecificValidator.createRegistry=function(){var result=[];return NodeSpecificValidator.registerValidator(result,[universes.Universe10.TypeDeclaration,universes.Universe08.Parameter],universes.Universe10.Api.properties.baseUriParameters.name,new BaseUriParameterValidator,!0),
result},NodeSpecificValidator.registerValidator=function(listToAddTo,definitions,propertyName,validator,assignableFrom){void 0===assignableFrom&&(assignableFrom=!1);var entry=new NodeSpecificValidatorRegistryEntry(definitions,propertyName,validator,assignableFrom);listToAddTo.push(entry)},NodeSpecificValidator.prototype.validate=function(node,acceptor){NodeSpecificValidator.entries.forEach(function(entry){return entry.validate(node,acceptor)})},NodeSpecificValidator.entries=NodeSpecificValidator.createRegistry(),NodeSpecificValidator}(),OverlayNodesValidator=function(){function OverlayNodesValidator(){}return OverlayNodesValidator.prototype.allowsAnyChildren=function(node,root){var property=node.property(),definition=node.definition();return!(!universeHelpers.isAnnotationTypeType(definition)&&!universeHelpers.isTypeDeclarationTypeOrDescendant(definition)||!universeHelpers.isAnnotationTypesProperty(property))||(!(node.parent()!=root||!universeHelpers.isTypesProperty(property)||!universeHelpers.isTypeDeclarationTypeOrDescendant(definition))||(!(!universeHelpers.isSchemasProperty(property)||!universeHelpers.isTypeDeclarationTypeOrDescendant(definition))||(!(node.parent()!=root||!universeHelpers.isDocumentationProperty(property)||!universeHelpers.isDocumentationType(definition))||(!!universeHelpers.isAnnotationsProperty(property)||(!!universeHelpers.isUsesProperty(property)||!!universeHelpers.isExamplesProperty(property))))))},OverlayNodesValidator.prototype.nodeAllowedDueToParent=function(node,root){for(var currentNode=node;currentNode!=root&&null!=currentNode;){if(this.allowsAnyChildren(currentNode,root))return!0;currentNode=currentNode.parent()}return!1},OverlayNodesValidator.prototype.validate=function(node,v){var root=node.root();node.property(),node.definition();if(universeHelpers.isOverlayType(root.definition())){if(node==root)return void this.validateProperties(node,v);if(!this.nodeAllowedDueToParent(node,root)){var overrides=root.knownIds();if(overrides){var override=overrides.hasOwnProperty(node.id());return override?void this.validateProperties(node,v):void v.accept(createIssue(hl.IssueCode.ONLY_OVERRIDE_ALLOWED,"The '"+node.id()+"' node does not match any node of the master api.",node))}}}},OverlayNodesValidator.prototype.validateProperties=function(node,acceptor){node.attrs().forEach(function(attribute){if(!(attribute.property().getAdapter(services.RAMLPropertyService).isKey()||attribute.parent()!=node||attribute.isElement()||universeHelpers.isTitlePropertyName(attribute.name())||universeHelpers.isDescriptionPropertyName(attribute.name())||universeHelpers.isDisplayNamePropertyName(attribute.name())||universeHelpers.isUsagePropertyName(attribute.name())||universeHelpers.isExampleProperty(attribute.property())||universeHelpers.isMasterRefProperty(attribute.property())||universeHelpers.isAnnotationsProperty(attribute.property())||universeHelpers.isUsesProperty(attribute.property()))){var message="Property "+attribute.name()+" is not allowed to be overriden or added in overlays";acceptor.accept(createIssue(hl.IssueCode.ONLY_OVERRIDE_ALLOWED,message,attribute))}})},OverlayNodesValidator}(),RecurrentOverlayValidator=function(){function RecurrentOverlayValidator(){}return RecurrentOverlayValidator.prototype.validate=function(node,v){var _this=this,z=new OverlayNodesValidator;z.validate(node,v),node.directChildren().forEach(function(x){x.isElement()&&_this.validate(x.asElement(),v)})},RecurrentOverlayValidator}(),RecurrentValidateChildrenKeys=function(){function RecurrentValidateChildrenKeys(){}return RecurrentValidateChildrenKeys.prototype.val=function(node,v,p){var _this=this;if(node.kind()==yaml.Kind.MAP||node.kind()==yaml.Kind.MAPPING){var ms={};node.children().forEach(function(x){var c=x.key();if(c){if(ms.hasOwnProperty(c)){var issue=createIssue(hl.IssueCode.KEY_SHOULD_BE_UNIQUE_INTHISCONTEXT,"keys should be unique",p,!1);x.unit()==p.lowLevel().unit()&&(issue.start=x.keyStart(),issue.end=x.keyEnd()),v.accept(issue)}ms[c]=1}})}node.children().forEach(function(x){_this.val(x,v,p)})},RecurrentValidateChildrenKeys.prototype.validate=function(node,v){this.val(node.lowLevel(),v,node)},RecurrentValidateChildrenKeys}(),ValidateChildrenKeys=function(){function ValidateChildrenKeys(){}return ValidateChildrenKeys.prototype.validate=function(node,acceptor){this.validateChildElements(node,acceptor);var lowLevelChildren=node.lowLevel().children(),keyToLowLevelChildren=_.groupBy(lowLevelChildren.filter(function(x){return null!=x.key()}),function(x){return x.key()});this.validateChildAttributes(node,keyToLowLevelChildren,acceptor),this.validateUnrecognizedLowLevelChildren(node,keyToLowLevelChildren,acceptor)},ValidateChildrenKeys.prototype.validateChildElements=function(node,acceptor){var keyToElements={},childElements=node.directChildren().filter(function(x){return x.isElement()});childElements.forEach(function(childNode){var childElement=childNode;if(!childElement._computed&&childElement.name()){var elementKey=childElement.name()+childElement.property().nameId();keyToElements.hasOwnProperty(elementKey)?childElement.isNamePatch()||keyToElements[elementKey].push(childElement):keyToElements[elementKey]=[childElement]}}),Object.keys(keyToElements).forEach(function(key){var childElements=keyToElements[key];!childElements||childElements.length<2||childElements.forEach(function(childElement){var message="",humanReadableName=getHumanReadableNodeName(childElement);if(humanReadableName)var capitalized=humanReadableName.charAt(0).toUpperCase()+humanReadableName.slice(1),message=capitalized+" '"+childElement.name()+"' already exists";else message=childElement.name()+" already exists in this context";var issue=createIssue(hl.IssueCode.KEY_SHOULD_BE_UNIQUE_INTHISCONTEXT,message,childElement);acceptor.accept(issue)})})},ValidateChildrenKeys.prototype.validateChildAttributes=function(node,keyToLowLevelChildren,acceptor){var highLevelAttributes=this.getHighLevelAttributes(node),nameToHighLevelAttributes=_.groupBy(highLevelAttributes,function(x){return x.name()}),allowsAnyAndHasRequireds=this.allowsAnyAndHasRequireds(node);Object.keys(nameToHighLevelAttributes).forEach(function(attributeName){if(!(nameToHighLevelAttributes[attributeName].length<2)){var isUnknown=nameToHighLevelAttributes[attributeName][0].isUnknown(),isMultiValue=!isUnknown&&nameToHighLevelAttributes[attributeName][0].property().isMultiValue();isMultiValue&&(node.definition().isAssignableFrom(universes.Universe08.SecuritySchemeSettings.name)||node.definition().isAssignableFrom(universes.Universe10.SecuritySchemeSettings.name))&&(isMultiValue=keyToLowLevelChildren[attributeName]&&1===keyToLowLevelChildren[attributeName].length),(isUnknown&&allowsAnyAndHasRequireds||!isMultiValue||isMultiValue&&null!=keyToLowLevelChildren[attributeName]&&keyToLowLevelChildren[attributeName].length>1)&&nameToHighLevelAttributes[attributeName].forEach(function(attribute){var message="property already used: '"+(attribute.property()?attribute.property().nameId():attribute.name())+"'",humanReadableParent=getHumanReadableNodeName(attribute.parent());if(humanReadableParent){var capitalizedParent=humanReadableParent.charAt(0).toUpperCase()+humanReadableParent.slice(1);message=capitalizedParent+" "+message}var issue=createIssue(hl.IssueCode.PROPERTY_EXPECT_TO_HAVE_SINGLE_VALUE,message,attribute);acceptor.accept(issue)})}})},ValidateChildrenKeys.prototype.validateUnrecognizedLowLevelChildren=function(node,keyToLowLevelChildren,acceptor){var highLevelChildren=node.directChildren(),nameToHighLevelChildren=_.groupBy(highLevelChildren,function(x){return x.name()});Object.keys(keyToLowLevelChildren).forEach(function(lowLevelChildKey){if(lowLevelChildKey&&keyToLowLevelChildren[lowLevelChildKey].length>1&&!nameToHighLevelChildren[lowLevelChildKey]){if(node.definition().isAssignableFrom(universes.Universe10.ObjectTypeDeclaration.name))return;var message="property already used: '"+lowLevelChildKey+"'",humanReadableNode=getHumanReadableNodeName(node);if(humanReadableNode){var capitalizedParent=humanReadableNode.charAt(0).toUpperCase()+humanReadableNode.slice(1);message=capitalizedParent+" "+message}keyToLowLevelChildren[lowLevelChildKey].forEach(function(lowLevelChild){var i=createLLIssue(hl.IssueCode.PROPERTY_EXPECT_TO_HAVE_SINGLE_VALUE,message,lowLevelChild,node);i.start=lowLevelChild.keyStart(),i.end=lowLevelChild.keyEnd(),acceptor.accept(i)})}})},ValidateChildrenKeys.prototype.filterMultiValueAnnotations=function(node,keyToLowLevelChildren,acceptor){this.getHighLevelAttributes(node);Object.keys(keyToLowLevelChildren).forEach(function(lowLevelChildKey){"("!==lowLevelChildKey.charAt(0)||keyToLowLevelChildren[lowLevelChildKey].length<2})},ValidateChildrenKeys.prototype.getHighLevelAttributes=function(node){var allowsAnyAndHasRequireds=this.allowsAnyAndHasRequireds(node);return node.directChildren().filter(function(x){return x.isAttr()||allowsAnyAndHasRequireds})},ValidateChildrenKeys.prototype.allowsAnyAndHasRequireds=function(node){var requireds=node.definition().requiredProperties(),hasRequireds=requireds&&requireds.length>0,ramlService=node.definition().getAdapter(services.RAMLService),isAllowAny=ramlService&&ramlService.getAllowAny(),anyExceptRequireds=isAllowAny&&hasRequireds;return anyExceptRequireds},ValidateChildrenKeys}(),ExampleAndDefaultValueValidator=function(){function ExampleAndDefaultValueValidator(){}return ExampleAndDefaultValueValidator.prototype.validate=function(node,cb){var strictValidation=this.isStrict(node);if(strictValidation||settings.validateNotStrictExamples){var pObj=this.parseObject(node,cb,strictValidation);if(pObj){var schema=this.aquireSchema(node);schema&&schema.validate(pObj,cb,strictValidation)}}},ExampleAndDefaultValueValidator.prototype.isExampleNode=function(node){return this.isSingleExampleNode(node)||this.isExampleNodeInMultipleDecl(node)},ExampleAndDefaultValueValidator.prototype.isSingleExampleNode=function(node){return node.name()==universes.Universe10.TypeDeclaration.properties.example.name},ExampleAndDefaultValueValidator.prototype.isExampleNodeInMultipleDecl=function(node){var parent=node.parent();return!!parent&&universeHelpers.isExampleSpecType(parent.definition())},ExampleAndDefaultValueValidator.prototype.findParentSchemaOrTypeAttribute=function(node){var attribute=node.parent().attr(universes.Universe10.TypeDeclaration.properties.schema.name);return attribute?attribute:(attribute=node.parent().attr(universes.Universe10.TypeDeclaration.properties.type.name))?attribute:node.parent()?(attribute=node.parent().parent().attr(universes.Universe10.TypeDeclaration.properties.schema.name))?attribute:(attribute=node.parent().parent().attr(universes.Universe10.TypeDeclaration.properties.type.name),attribute?attribute:null):null},ExampleAndDefaultValueValidator.prototype.aquireSchema=function(node){var sp=node.parent().definition().isAssignableFrom(universes.Universe10.TypeDeclaration.name);if(this.isExampleNode(node)){var sampleRoot=node;if(this.isExampleNodeInMultipleDecl(node)&&(sampleRoot=node.parent()),sampleRoot.parent()&&(sampleRoot.parent().definition().isAssignableFrom(universes.Universe10.TypeDeclaration.name)&&null===sampleRoot.parent().parent()?sp=!1:sampleRoot.parent().property().nameId()==universes.Universe10.LibraryBase.properties.types.name&&(sp=!1),sampleRoot.parent().parent())){var ppc=sampleRoot.parent().parent().definition().key();ppc!=universes.Universe08.Method&&ppc!=universes.Universe10.Method||sampleRoot.parent().property().nameId()==universes.Universe10.MethodBase.properties.queryParameters.name||(sp=!0),ppc!=universes.Universe08.Response&&ppc!=universes.Universe10.Response||(sp=!0)}}if(node.parent().definition().key()==universes.Universe08.BodyLike||sp){var sa=this.findParentSchemaOrTypeAttribute(node);if(sa){var val=sa.value();if(val instanceof hlimpl.StructuredValue)return null;var strVal=(""+val).trim(),so=null;if("{"==strVal.charAt(0))try{so=su.getJSONSchema(strVal,contentProvider(sa.lowLevel()))}catch(e){return null}if("<"==strVal.charAt(0))try{so=su.getXMLSchema(strVal)}catch(e){return null}if(so)return{validate:function(pObje,cb,strict){try{if(pObje.__$validated)return;if(so instanceof Error)return void cb.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,so.message,node,!strict));so.validateObject(pObje)}catch(e){var illegalRequiredMessageStart="Cannot assign to read only property '__$validated' of ";if(e.message&&0==e.message.indexOf(illegalRequiredMessageStart)){var propertyName=e.message.substr(illegalRequiredMessageStart.length,e.message.length-illegalRequiredMessageStart.length),patchedErrorMessage="Invalid JSON schema. Potentially, required array containing value "+propertyName+" has invalid location";return void cb.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,patchedErrorMessage,sa,!strict))}if("Object.keys called on non-object"==e.message)return;return void cb.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"Example does not conform to schema:"+e.message,node,!strict))}}};if(strVal.length>0){var nodeParent=node.parent(),grandParent=nodeParent&&nodeParent.parent(),owner=nodeParent&&nodeParent.definition()&&nodeParent.definition().isAssignableFrom(universes.Universe10.ObjectTypeDeclaration.name)&&nodeParent;if(owner=owner||grandParent&&grandParent.definition()&&grandParent.definition().isAssignableFrom(universes.Universe10.ObjectTypeDeclaration.name)&&grandParent)return this.typeValidator(owner,node)}}}return this.getSchemaFromModel(node)},ExampleAndDefaultValueValidator.prototype.getSchemaFromModel=function(node){var p=node.parent();return this.typeValidator(p,node)},ExampleAndDefaultValueValidator.prototype.typeValidator=function(p,node){var newVar={validate:function(pObje,cb,strict){var pt=p.parsedType();if(pt&&!pt.isUnknown()){"number"==typeof pObje&&pt.isString()&&(pObje=""+pObje),"boolean"==typeof pObje&&pt.isString()&&(pObje=""+pObje),pt.getExtra("repeat")&&(pObje=[pObje]);var validateObject=pt.validate(pObje,!1);validateObject.isOk()||validateObject.getErrors().forEach(function(e){return cb.accept(createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,e.getMessage(),node,!strict))})}}};return newVar},ExampleAndDefaultValueValidator.prototype.toObject=function(h,v,cb){var res=v.lowLevel().dumpToObject(!0);return this.testDublication(h,v.lowLevel(),cb),res.example?res.example:res.content?res.content:void 0},ExampleAndDefaultValueValidator.prototype.testDublication=function(h,v,cb){var _this=this,map={};v.children().forEach(function(x){x.key()&&(map[x.key()]&&cb.accept(createIssue(hl.IssueCode.KEY_SHOULD_BE_UNIQUE_INTHISCONTEXT,"Keys should be unique",new hlimpl.BasicASTNode(x,h.parent()))),map[x.key()]=x),_this.testDublication(h,x,cb)})},ExampleAndDefaultValueValidator.prototype.parseObject=function(node,cb,strictValidation){var pObj=null,vl=node.value(),mediaType=getMediaType(node);if(vl instanceof hlimpl.StructuredValue)pObj=this.toObject(node,vl,cb);else if(mediaType){if(isJson(mediaType))try{pObj=JSON.parse(vl)}catch(e){return void cb.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"Can not parse JSON:"+e.message,node,!strictValidation))}if(isXML(mediaType))try{pObj=xmlutil(vl)}catch(e){return void cb.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"Can not parse XML:"+e.message,node,!strictValidation))}}else try{if(!(vl&&vl.length>0)||"["!=vl.trim().charAt(0)&&"{"!=vl.trim().charAt(0)&&"<"!=vl.trim().charAt(0)){if("true"==vl)return!0;if("false"==vl)return!1;var n=parseFloat(vl);return isNaN(n)?vl:n}pObj=JSON.parse(vl)}catch(e){if(0!=vl.trim().indexOf("<"))return vl;try{pObj=xmlutil(vl)}catch(e){return void cb.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"Can not parse XML:"+e.message,node,!strictValidation))}}return pObj},ExampleAndDefaultValueValidator.prototype.isStrict=function(node){if(universeHelpers.isDefaultValue(node.property()))return!0;if(universeHelpers.isExampleProperty(node.property())&&"RAML08"==node.parent().definition().universe().version())return!1;var strictValidation=!1,strict=node.parent().attr("strict");return strict&&"true"==strict.value()&&(strictValidation=!0),strictValidation},ExampleAndDefaultValueValidator}();exports.ExampleAndDefaultValueValidator=ExampleAndDefaultValueValidator;var toReadableName=function(template,toLowerCase,pluralize_){var templateName=changeCase.sentence(template);return toLowerCase||(templateName=changeCase.ucFirst(templateName)),pluralize_&&(templateName=pluralize.plural(templateName)),templateName},OptionalPropertiesValidator=function(){function OptionalPropertiesValidator(){}return OptionalPropertiesValidator.prototype.validate=function(node,v){if(node.isAttr()){if(!node.optional())return;var attr=node,prop=attr.property();if(prop.isMultiValue()||prop.range().isArray())return;if(!prop.isFromParentKey()){var template=typeOfContainingTemplate(attr.parent());if(template&&prop.isValueProperty()){var templateNamePlural=toReadableName(template,!0,!0),message="Optional scalar properties are not allowed in "+templateNamePlural+" and their descendants: "+attr.name()+"?",issue=createIssue(hl.IssueCode.INVALID_PROPERTY,message,attr,!1);v.accept(issue)}}}else if(node.isElement()){var aNode=node,prop=aNode.property(),allowsQuestion=aNode.allowsQuestion();if(!allowsQuestion){var propName=prop?toReadableName(prop.nameId(),!0,!0):"API root";aNode.optionalProperties().forEach(function(x){aNode.children().forEach(function(y){var message="Optional properties are not allowed in "+propName+": "+y.lowLevel().key()+"?",issue=createIssue(hl.IssueCode.INVALID_PROPERTY,message,node,!1);v.accept(issue)})})}var def=node.asElement().definition();if(node.optional()&&"RAML10"==def.universe().version()){var prop=node.property(),isParam=universeHelpers.isQueryParametersProperty(prop)||universeHelpers.isUriParametersProperty(prop)||universeHelpers.isHeadersProperty(prop);if(!(universeHelpers.isMethodType(def)||universeHelpers.isTypeDeclarationType(def)&&isParam)){var issue=createIssue(hl.IssueCode.MISSED_CONTEXT_REQUIREMENT,"Only method nodes can be optional",node,!1);v.accept(issue)}}}},OptionalPropertiesValidator}(),UriParametersValidator=function(){function UriParametersValidator(){}return UriParametersValidator.prototype.validate=function(node,v){var def=node.definition(),baseUriPropName=universes.Universe10.Api.properties.baseUri.name,baseUriParamsPropName=universes.Universe10.Api.properties.baseUriParameters.name,uriPropName=universes.Universe10.Resource.properties.relativeUri.name,uriParamsPropName=universes.Universe10.ResourceBase.properties.uriParameters.name;if(universeHelpers.isApiSibling(def))this.inspectParameters(node,v,baseUriPropName,baseUriParamsPropName);else if(universeHelpers.isResourceType(def)){var rootNode=node.root();this.inspectParameters(node,v,baseUriPropName,baseUriParamsPropName,rootNode),this.inspectParameters(node,v,uriPropName,uriParamsPropName)}else if(universeHelpers.isResourceTypeType(def)){var rootNode=node.root();this.inspectParameters(node,v,baseUriPropName,baseUriParamsPropName,rootNode)}},UriParametersValidator.prototype.inspectParameters=function(node,v,uriPropName,paramsPropName,rootNode){rootNode=rootNode||node;var uriValue="",uriAttr=rootNode.attr(uriPropName);uriAttr&&(uriValue=uriAttr.value(),uriValue||(uriValue=""));var paramElements=node.elementsOfKind(paramsPropName);paramElements.forEach(function(x){var nameAttr=x.attr(universes.Universe10.TypeDeclaration.properties.name.name);if(nameAttr){var name=nameAttr.value();if(null!=name&&uriValue.indexOf("{"+name+"}")<0){if(universeHelpers.isResourceTypeType(node.definition())&&name.indexOf("<<")>=0)return;var propNameReadable=pluralize.singular(changeCase.sentence(paramsPropName)),message=changeCase.ucFirst(propNameReadable)+" unused",issue=createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,message,x,!0);v.accept(issue)}}})},UriParametersValidator}(),TemplateCyclesDetector=function(){function TemplateCyclesDetector(){this.nameProperty=universes.Universe10.ResourceType.properties.name.name}return TemplateCyclesDetector.prototype.validate=function(node,v){var definition=node.definition();if(universeHelpers.isLibraryBaseSibling(definition)||universeHelpers.isApiType(definition)){var typeProp=(universes.Universe10.LibraryBase.properties.resourceTypes.name,universes.Universe10.ResourceBase.properties.type.name),isProp=(universes.Universe10.LibraryBase.properties.traits.name,universes.Universe10.MethodBase.properties.is.name),allResourceTypes=search.globalDeclarations(node).filter(function(x){return universeHelpers.isResourceTypeType(x.definition())}),alltraits=search.globalDeclarations(node).filter(function(x){return universeHelpers.isTraitType(x.definition())});this.checkCycles(allResourceTypes,typeProp,v),this.checkCycles(alltraits,isProp,v)}},TemplateCyclesDetector.prototype.checkCycles=function(templates,propName,v){var _this=this,templatesMap={};templates.forEach(function(x){var name=_this.templateName(x);templatesMap[name]=x});var templatesWithCycle={};templates.forEach(function(template){var name=_this.templateName(template);templatesWithCycle[name]||_this.findCyclesInDefinition(template,propName,templatesMap).forEach(function(cycle){cycle.forEach(function(x){return templatesWithCycle[x]=!0}),cycle=cycle.reverse();var message=toReadableName(template.definition().nameId())+" definition contains cycle: "+cycle.join(" -> "),issue=createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,message,template,!1);v.accept(issue)})})},TemplateCyclesDetector.prototype.templateName=function(node){var nameAttribute=node.attr(this.nameProperty);return nameAttribute?nameAttribute.value():null},TemplateCyclesDetector.prototype.findCyclesInDefinition=function(node,propName,templatesMap,occuredTemplates){void 0===occuredTemplates&&(occuredTemplates={});var name=this.templateName(node);if(occuredTemplates[name])return[[name]];var nextOccuredTemplates={};Object.keys(occuredTemplates).forEach(function(x){return nextOccuredTemplates[x]=occuredTemplates[x]}),nextOccuredTemplates[name]=!0;for(var occuredCycles=[],templatesRefs=node.attributes(propName),i=0;i<templatesRefs.length;i++){var ref=templatesRefs[i],val=ref.value();if(val){var refName="string"==typeof val?val:val.valueName(),template=templatesMap[refName];if(null!=template){var newCycles=this.findCyclesInDefinition(template,propName,templatesMap,nextOccuredTemplates);newCycles.forEach(function(x){return occuredCycles.push(x)})}}}return occuredCycles.forEach(function(x){return x.push(name)}),occuredCycles},TemplateCyclesDetector}();exports.isJson=isJson,exports.isXML=isXML,exports.getMediaType=getMediaType;var localError=function(node,c,w,message,p,prop,positionsSource){var llNode=positionsSource?positionsSource:node.lowLevel(),contents=llNode.unit()&&llNode.unit().contents(),contentLength=contents&&contents.length,st=llNode.start(),et=llNode.end();if(contentLength&&contentLength<et&&(et=contentLength-1),llNode.key()&&llNode.keyStart()){var ks=llNode.keyStart();ks>0&&(st=ks);var ke=llNode.keyEnd();ke>0&&(et=ke)}if(et<st&&(et=st+1,node.isElement())){var definition=node.definition();universeHelpers.isApiType(definition)&&(st=0==contentLength?0:contentLength-1,et=st)}if(prop&&!prop.getAdapter(services.RAMLPropertyService).isMerged()&&null==node.parent()){var nm=_.find(llNode.children(),function(x){return x.key()==prop.nameId()});if(nm){var ks=nm.keyStart(),ke=nm.keyEnd();ks>0&&ke>ks&&(st=ks,et=ke)}}return{code:c,isWarning:w,message:message,node:node,start:st,end:et,path:p?llNode.unit()?llNode.unit().path():"":null,extras:[],unit:node?llNode.unit():null}},localLowLevelError=function(node,highLevelAnchor,issueCode,isWarning,message,path){var contents=node.unit()&&node.unit().contents(),contentLength=contents&&contents.length,st=node.start(),et=node.end();if(contentLength&&contentLength>=et&&(et=contentLength-1),node.key()&&node.keyStart()){var ks=node.keyStart();ks>0&&(st=ks);var ke=node.keyEnd();ke>0&&(et=ke)}return{code:issueCode,isWarning:isWarning,message:message,node:highLevelAnchor,start:st,end:et,path:path?node.unit()?node.unit().path():"":null,extras:[],unit:node?node.unit():null}};exports.toIssue=toIssue,exports.createIssue=createIssue,exports.createLLIssue=createLLIssue,exports.validateResponseString=validateResponseString}).call(exports,__webpack_require__(59))},function(module,exports,__webpack_require__){"use strict";function getAllOptions(c,deep){if(void 0===deep&&(deep=0),deep>20)return[];try{var result=[],tp=c.leftType();tp&&result.push(tp);var r=c.rightType();if(r)if(r.hasUnionInHierarchy()){var options=getAllOptions(r.unionInHierarchy(),deep+1);result=result.concat(options)}else result.push(r);return result}finally{}}function getBaseType(node,expression){if(!expression)return node.definition().universe().type(universes.Universe10.StringTypeDeclaration.name);var pt=node.parsedType();return pt.isString()?node.definition().universe().type(universes.Universe10.StringTypeDeclaration.name):pt.isNumber()?pt.isInteger()?node.definition().universe().type(universes.Universe10.IntegerTypeDeclaration.name):node.definition().universe().type(universes.Universe10.NumberTypeDeclaration.name):pt.isBoolean()?node.definition().universe().type(universes.Universe10.BooleanTypeDeclaration.name):pt.isObject()?node.definition().universe().type(universes.Universe10.ObjectTypeDeclaration.name):pt.isArray()?node.definition().universe().type(universes.Universe10.ArrayTypeDeclaration.name):pt.isFile()?node.definition().universe().type(universes.Universe10.FileTypeDeclaration.name):pt.isDateTime()?node.definition().universe().type(universes.Universe10.DateTimeTypeDeclaration.name):pt.isDateTimeOnly()?node.definition().universe().type(universes.Universe10.DateTimeOnlyTypeDeclaration.name):pt.isDateOnly()?node.definition().universe().type(universes.Universe10.DateOnlyTypeDeclaration.name):pt.isTimeOnly()?node.definition().universe().type(universes.Universe10.TimeOnlyTypeDeclaration.name):pt.isUnion()?node.definition().universe().type(universes.Universe10.UnionTypeDeclaration.name):node.definition().universe().type(universes.Universe10.TypeDeclaration.name)}function transform(u){return function(x){var m=u.type(x);if(!m){new defs.UserDefinedClass("",u,null,"","")}return m}}function findFacetInTypeNode(typeNode,facetName){var typeNodeElement=typeNode.asElement();if(null==typeNodeElement)return null;var facets=typeNodeElement.elementsOfKind(universes.Universe10.TypeDeclaration.properties.facets.name);return null==facets||0==facets.length?null:_.find(facets,function(facet){return facetName==facet.attrValue(universes.Universe10.TypeDeclaration.properties.name.name)})}function findFacetDeclaration(facet){var owner=facet.owner();if(null==owner)return null;var facetName=facet.facetName();if(!facetName)return null;var ownerSource=owner.getExtra(ramlTypes.SOURCE_EXTRA);return null==ownerSource?null:def.isSourceProvider(ownerSource)||hl.isParseResult(ownerSource)?{getSource:function(){if(def.isSourceProvider(ownerSource)){var resolvedSource=ownerSource.getSource();if(resolvedSource&&hl.isParseResult(resolvedSource))return findFacetInTypeNode(resolvedSource,facetName)}else if(hl.isParseResult(ownerSource))return findFacetInTypeNode(ownerSource,facetName);return null}}:null}function patchTypeWithFacets(originalType,nodeReferencingType,parentOfReferencingNode){if(null==originalType)return null;var patchedType=new defs.NodeClass(nodeReferencingType.name(),nodeReferencingType.definition().universe(),"",""),parsedRType=nodeReferencingType.parsedType();return parsedRType.allFacets().forEach(function(facet){if(facet.kind()==defs.tsInterfaces.MetaInformationKind.FacetDeclaration){var propertySource=findFacetDeclaration(facet),facetBasedProperty=null;null!=propertySource?(facetBasedProperty=new defs.UserDefinedProp(facet.facetName(),null),facetBasedProperty.setSourceProvider(propertySource)):facetBasedProperty=new defs.Property(facet.facetName(),""),facetBasedProperty.withRange(parentOfReferencingNode.definition().universe().type("StringType")),facetBasedProperty.withDomain(patchedType),facetBasedProperty.withGroupName(facet.facetName()),facetBasedProperty.withRequired(!1),facet.value(),ramlTypes.setPropertyConstructor(function(x){var v=new defs.Property(x,"");return v.unmerge(),v}),facetBasedProperty.withRange(ramlTypes.toNominal(facet.value(),transform(nodeReferencingType.definition().universe())))}}),patchedType._superTypes.push(originalType),patchedType}function desc1(p,parent,x){var tp=x.attr("type");if(tp){var baseType=getBaseType(x,tp.value()),patchedType=patchTypeWithFacets(baseType,x,parent);return patchedType&&0==patchedType.superTypes().length&&patchedType._superTypes.push(x.definition().universe().type(universes.Universe10.TypeDeclaration.name)),patchedType}var propertiesName=universes.Universe10.ObjectTypeDeclaration.properties.properties.name;if(p){if("body"==p.nameId()||_.find(x.lowLevel().children(),function(x){return x.key()===propertiesName}))return x.definition().universe().type(universes.Universe10.ObjectTypeDeclaration.name)}else if(!parent&&x.lowLevel()&&_.find(x.lowLevel().children(),function(x){return x.key()===propertiesName}))return x.definition().universe().type(universes.Universe10.ObjectTypeDeclaration.name);return x.definition().universe().type(universes.Universe10.StringTypeDeclaration.name)}function doDescrimination(node){try{var nodeDefenitionName=node.definition().nameId(),isApi=nodeDefenitionName===universes.Universe10.Api.name||nodeDefenitionName===universes.Universe08.Api.name;if(!isApi&&!node.property()&&!node.parent()&&node.definition().nameId()===hlimpl.getFragmentDefenitionName(node)){if(node.property()&&node.property().nameId()===universes.Universe10.LibraryBase.properties.annotationTypes.name)return descriminate(null,null,node);var result=null,subTypes=node.definition().allSubTypes();return subTypes.forEach(function(subType){!result&&match(subType,node,null)&&(result=subType)}),result}}catch(exception){}return descriminate(node.property(),node.parent(),node)}function descriminate(p,parent,x){var n=x.lowLevel();p&&p.nameId()==universes.Universe10.FragmentDeclaration.properties.uses.name&&p.range().nameId()==universes.Universe10.Library.name;var range=p?p.range().nameId():x.definition().nameId();if(n._node&&n._node.descriminate)return null;n._node&&(n._node.descriminate=1);try{if(range==universes.Universe10.TypeDeclaration.name){var res=desc1(p,parent,x);if(p||!p&&!parent&&x.lowLevel()){if(p&&null!=res&&(p.nameId()==universes.Universe10.MethodBase.properties.body.name||p.nameId()==universes.Universe10.Response.properties.headers.name||p.nameId()==universes.Universe10.MethodBase.properties.queryParameters.name)){var ares=new defs.UserDefinedClass(x.lowLevel().key(),res.universe(),x,x.lowLevel().unit()?x.lowLevel().unit().path():"","");return ares._superTypes.push(res),ares}if(null!=res&&universeHelpers.isAnnotationTypeType(x.definition())){var annotationType=descriminateAnnotationType(res),ares=new defs.UserDefinedClass(x.lowLevel().key(),res.universe(),x,x.lowLevel().unit()?x.lowLevel().unit().path():"","");return ares._superTypes.push(annotationType),ares._superTypes.push(res),ares}}if(res)return res}var rt=null;if(p&&parent){var types=search.findAllSubTypes(p,parent);return types.length>0&&types.forEach(function(y){rt||match(y,x,rt)&&(rt=y)}),rt}}finally{n._node&&delete n._node.descriminate}}function descriminateAnnotationType(type){for(var candidate,arr=[type].concat(type.allSuperTypes()),i=0;i<arr.length;i++){var t=arr[i];if(!t.isUserDefined()){if(t.isUnion()){var ut=t,lt=ut.leftType(),lat=(ut.leftType(),descriminateAnnotationType(lt)),rat=descriminateAnnotationType(lt);if(lat.isAssignableFrom(rat.nameId())&&(null==candidate||lat.isAssignableFrom(candidate.nameId()))){candidate=lat;continue}if(rat.isAssignableFrom(lat.nameId())&&(null==candidate||rat.isAssignableFrom(candidate.nameId()))){candidate=rat;continue}candidate=type.universe().type(universes.Universe10.UnionTypeDeclaration.name);break}if(t.isArray()){candidate=type.universe().type(universes.Universe10.ArrayTypeDeclaration.name);
break}for(var subTypes=t.subTypes(),j=0;j<subTypes.length;j++){var st=subTypes[j];st.isAssignableFrom(universes.Universe10.TypeDeclaration.name)&&(null==candidate?candidate=st:st.isAssignableFrom(candidate.nameId())&&(candidate=st))}}}return null!=candidate?candidate:type.universe().type(universes.Universe10.TypeDeclaration.name)}function match(t,r,alreadyFound){if(r.isAttr()||r.isUnknown())return!1;var el=r,hasSuperType=_.find(t.superTypes(),function(x){var dp=_.find(x.allProperties(),function(x){return x.isDescriminator()});if(dp){var a=el.attr(dp.nameId());if(a&&a.value()==t.nameId())return!0}return!1});if(hasSuperType)return!0;if(0==t.valueRequirements().length)return!1;var matches=!0;return t.valueRequirements().forEach(function(x){var a=el.attr(x.name);if(a)if(a.value()==x.value);else if(t.getAdapter(services.RAMLService).getConsumesRefs()){var vl=a.value(),allSubs=[];t.superTypes().forEach(function(x){return x.allSubTypes().forEach(function(y){allSubs.push(y)})});var allSubNames=[];_.unique(allSubs).forEach(function(x){allSubNames.push(x.nameId()),x.valueRequirements().forEach(function(y){allSubNames.push(y.value)}),x.getAdapter(services.RAMLService).getAliases().forEach(function(y){return allSubNames.push(y)})}),_.find(allSubNames,function(x){return x==vl})&&(matches=!1)}else matches=!1;else{var m=t.getAdapter(services.RAMLService).getDefining(),ms=!1;if(m.forEach(function(x){el.lowLevel().children().forEach(function(y){y.key()==x&&(ms=!0)})}),ms)return void(matches=!0);if(alreadyFound)matches=!1;else{var pr=t.property(x.name);pr&&pr.defaultValue()==x.value||(matches=!1)}}}),matches}var defs=__webpack_require__(36),hl=__webpack_require__(10),yaml=__webpack_require__(70),_=__webpack_require__(61),def=defs,hlimpl=__webpack_require__(16),proxy=__webpack_require__(38),search=__webpack_require__(23),universes=__webpack_require__(22),universeHelpers=__webpack_require__(14),services=defs,ramlTypes=defs.rt,KeyMatcher=function(){function KeyMatcher(_props){this._props=_props,this.parentValue=_.find(_props,function(x){return x.isFromParentValue()}),this.parentKey=_.find(_props,function(x){return x.isFromParentKey()}),this.canBeValue=_.find(_props,function(x){return x.canBeValue()})}return KeyMatcher.prototype.add=function(p){this._props.push(p)},KeyMatcher.prototype.match=function(key){var _this=this,_res=null,lastPref="";return this._props.forEach(function(p){p.getAdapter(services.RAMLPropertyService).isSystem()||p!=_this.parentValue&&p!=_this.parentKey&&p.matchKey(key)&&(null!=p.keyPrefix()?p.keyPrefix().length>=lastPref.length&&(lastPref=p.keyPrefix(),_res=p):(_res=p,lastPref=p.nameId()))}),_res},KeyMatcher}(),ad=0,BasicNodeBuilder=function(){function BasicNodeBuilder(){this.shouldDescriminate=!1}return BasicNodeBuilder.prototype.process=function(node,childrenToAdopt){var _this=this,nn=node.lowLevel(),cv=node;cv._mergedChildren=null;var cha=nn._node?nn._node:nn;try{if(cha.currentChildren)return cha.currentChildren;if(!node.definition())return;if(null==node.parent()&&!this.shouldDescriminate){this.shouldDescriminate=!0;try{var children=this.process(node,childrenToAdopt),ts=node;ts._children=children;var t=doDescrimination(node);t&&ts.patchType(t);var children=this.process(node,childrenToAdopt);ts._children=children}finally{this.shouldDescriminate=!1}}if(node.definition().hasUnionInHierarchy()&&node.parent()&&node.property().nameId()==universes.Universe10.LibraryBase.properties.annotations.name){var optins=getAllOptions(node.definition().unionInHierarchy()),actualResult=null,bestResult=null,bestType=null,bestCount=1e3,llnode=node;if(optins.forEach(function(x){if(!actualResult&&!x.hasUnionInHierarchy()){llnode.patchType(x);if(0==ad){ad++;try{for(var result=_this.process(node,childrenToAdopt),uc=0,i=0;i<result.length;i++)result[i].isUnknown()&&uc++;0==uc&&(actualResult=result),bestCount>uc&&(bestCount=uc,bestResult=result,bestType=x)}finally{ad--}}}}),actualResult)return llnode.patchType(bestType),actualResult;bestResult&&llnode.patchType(bestType)}var km=new KeyMatcher(node.definition().allProperties());if(null==node.parent()||node.lowLevel().includePath()){var u=node.definition().universe();"RAML10"==u.version()&&(node.definition().property("uses")||u.type("FragmentDeclaration").allProperties().forEach(function(x){return km.add(x)}))}var aNode=node,allowsQuestion=aNode._allowQuestion||node.definition().getAdapter(services.RAMLService).getAllowQuestion(),res=[];if(km.parentKey){if(node.lowLevel().key()){var keyAttr=new hlimpl.ASTPropImpl(node.lowLevel(),node,km.parentKey.range(),km.parentKey,(!0));res.push(keyAttr);var isDefaultMediaType=node.property()&&universeHelpers.isBodyProperty(node.property())&&node.lowLevel().key()==node.property().nameId();if(isDefaultMediaType){var isInsideTraitOrResourceType=isInTtraitOrResourceType(aNode);!isInsideTraitOrResourceType&&aNode._computedKey&&keyAttr.overrideValue(aNode._computedKey)}}if(node.lowLevel().valueKind()===yaml.Kind.SEQ){var error=new hlimpl.BasicASTNode(node.lowLevel(),aNode);return error.errorMessage=""+node.definition().nameId()+" definition should be a map",res.push(error),res}}if(null!=node.lowLevel().value(!0))if(km.parentValue)res.push(new hlimpl.ASTPropImpl(node.lowLevel(),node,km.parentValue.range(),km.parentValue));else if(km.canBeValue){var s=node.lowLevel().value();null==s&&(s=node.lowLevel().value(!0)),"string"==typeof s&&s.trim().length>0&&res.push(new hlimpl.ASTPropImpl(node.lowLevel(),node,km.canBeValue.range(),km.canBeValue))}if(aNode._children=res,aNode.definition().getAdapter(services.RAMLService).isUserDefined())res=this.processChildren(childrenToAdopt,aNode,res,allowsQuestion,km);else if(aNode.definition().key()==universes.Universe08.Api||aNode.definition().key()==universes.Universe10.Api){var uses=childrenToAdopt.filter(function(x){return"uses"==x.key()});res=this.processChildren(uses,aNode,res,allowsQuestion,km);var types=childrenToAdopt.filter(function(x){return"types"==x.key()});res=this.processChildren(types,aNode,res,allowsQuestion,km);var other=childrenToAdopt.filter(function(x){return"types"!=x.key()&&"uses"!=x.key()});res=this.processChildren(other,aNode,res,allowsQuestion,km)}else res=this.processChildren(childrenToAdopt,aNode,res,allowsQuestion,km);return aNode._children=res,res}finally{}},BasicNodeBuilder.prototype.isTypeDeclarationShortcut=function(node,property){var isTypeDeclarationType=universeHelpers.isTypeProperty(property),isTypeDeclaration=node.definition()&&universeHelpers.isTypeDeclarationTypeOrDescendant(node.definition());return!!(isTypeDeclaration&&isTypeDeclarationType&&node.lowLevel()&&node.lowLevel().valueKind()===yaml.Kind.SEQ)},BasicNodeBuilder.prototype.processChildren=function(childrenToAdopt,aNode,res,allowsQuestion,km){var _this=this,typeDeclarationName=universes.Universe10.TypeDeclaration.name,typePropertyName=universes.Universe10.TypeDeclaration.properties.type.name;return aNode.definition()&&aNode.definition().isAssignableFrom(typeDeclarationName)&&aNode.lowLevel()&&km.canBeValue&&km.canBeValue.nameId()===typePropertyName&&aNode.lowLevel()._node&&aNode.lowLevel()._node.value&&aNode.lowLevel()._node.value.kind===yaml.Kind.SEQ?(childrenToAdopt.forEach(function(child){var property=new hlimpl.ASTPropImpl(child,aNode,km.canBeValue.range(),km.canBeValue);res.push(property)}),res):(childrenToAdopt.forEach(function(x){if(km.canBeValue&&_this.isTypeDeclarationShortcut(aNode,km.canBeValue))return void res.push(new hlimpl.ASTPropImpl(x,aNode,km.canBeValue.range(),km.canBeValue));var key=x.key(),p=null!=key?km.match(key):null;if(null!=p){var range=p.range();if(p.isAnnotation()&&"annotations"!=key){var pi=new hlimpl.ASTPropImpl(x,aNode,range,p);return void res.push(pi)}var um=!1,multyValue=p.isMultiValue();if(range.isArray()?(multyValue=!0,range=range.array().componentType(),um=!0):range.hasArrayInHierarchy()&&(multyValue=!0,um=!0),range.hasValueTypeInHierarchy()){var ch=x.children(),seq=x.valueKind()==yaml.Kind.SEQ;if((seq&&ch.length>0||ch.length>1)&&multyValue)if(ch.length>1&&universeHelpers.isTypeDeclarationSibling(aNode.definition())&&universeHelpers.isTypeProperty(p)&&x.valueKind()!=yaml.Kind.SEQ){var pi=new hlimpl.ASTPropImpl(x,aNode,range,p);res.push(pi),aNode.setComputed(p.nameId(),pi)}else{var values=[];ch.forEach(function(y){var pi=new hlimpl.ASTPropImpl(y,aNode,range,p);res.push(pi),values.push(y.value())}),p.isInherited()&&aNode.setComputed(p.nameId(),values)}else{p.isInherited()&&aNode.setComputed(p.nameId(),x.value());var attrNode=new hlimpl.ASTPropImpl(x,aNode,range,p);if(seq||x.valueKind()==yaml.Kind.MAP){var rng=p.range().nameId();p.getAdapter(services.RAMLPropertyService).isExampleProperty()||("StringType"==rng&&(rng="string"),"NumberType"==rng&&(rng="number"),"BooleanType"==rng&&(rng="boolean"),"string"!=rng&&"number"!=rng&&"boolean"!=rng||x.isAnnotatedScalar()||(attrNode.errorMessage="property '"+p.groupName()+"' must be a "+rng,0==x.children().length&&"enum"==p.groupName()&&(attrNode.errorMessage="enum is empty",x.valueKind()==yaml.Kind.MAP&&(attrNode.errorMessage="the value of enum must be an array"))))}res.push(attrNode)}return}var rs=[];if(aNode._children=res,null!=x.value()&&("string"==typeof x.value()||"boolean"==typeof x.value()||"number"==typeof x.value())&&(""+x.value()).trim().length>0){var c=p.range();if(!c.allProperties().some(function(x){var srv=x;return!!srv&&(srv.canBeValue()&&srv.isFromParentValue())})){var bnode=new hlimpl.BasicASTNode(x,aNode);bnode.getLowLevelEnd=function(){return-1},bnode.getLowLevelStart=function(){return-1},bnode.knownProperty=p,res.push(bnode)}}if(p.isMerged()){var node=new hlimpl.ASTNodeImpl(x,aNode,range,p);node._allowQuestion=allowsQuestion,rs.push(node)}else if(multyValue)if(p.getAdapter(services.RAMLPropertyService).isEmbedMap()){var chld=x.children(),newChld=[],hasSequenceComposition=!1;if(chld.forEach(function(n){n.kind()==yaml.Kind.INCLUDE_REF&&"RAML08"==aNode.universe().version()?n.children().forEach(function(y){var node=new hlimpl.ASTNodeImpl(y,aNode,range,p);node._allowQuestion=allowsQuestion,rs.push(node),hasSequenceComposition=!0}):newChld.push(n)}),chld=newChld,0==chld.length){if(p.range().key()==universes.Universe08.ResourceType&&!hasSequenceComposition){var error=new hlimpl.BasicASTNode(x,aNode);error.errorMessage="property: '"+p.nameId()+"' must be a map",res.push(error)}if(x.valueKind()==yaml.Kind.SCALAR&&p.range().key()==universes.Universe08.AbstractSecurityScheme){var error=new hlimpl.BasicASTNode(x.parent(),aNode);error.errorMessage="property: '"+p.nameId()+"' must be a map",res.push(error)}}var exit=!1;chld.forEach(function(y){if(!exit){var cld=y.children();if(y.key()||1!=cld.length)if("RAML10"==aNode.universe().version()){var node=new hlimpl.ASTNodeImpl(y,aNode,range,p);node._allowQuestion=allowsQuestion,rs.push(node)}else{var bnode=new hlimpl.BasicASTNode(y,aNode);res.push(bnode),y.key()&&(bnode.needSequence=!0)}else if("RAML10"!=aNode.universe().version()||aNode.parent()){var node=new hlimpl.ASTNodeImpl(cld[0],aNode,range,p);node._allowQuestion=allowsQuestion,rs.push(node)}else{var bnode=new hlimpl.BasicASTNode(x,aNode);res.push(bnode),bnode.needMap=!0,bnode.knownProperty=p,exit=!0}}})}else{var filter={},inherited=[];if(range instanceof defs.NodeClass){var nc=range;nc.getAdapter(services.RAMLService).getCanInherit().length>0&&nc.getAdapter(services.RAMLService).getCanInherit().forEach(function(v){for(var originalValue=aNode.computedValue(v),actualValue=Array.isArray(originalValue)?originalValue:[originalValue],pos=0;pos<actualValue.length;pos++){var vl=actualValue[pos];if(vl&&p.nameId()==universes.Universe10.Response.properties.body.name){var exists=_.find(x.children(),function(x){return x.key()==vl}),pc=aNode.parent().definition().key(),node=new hlimpl.ASTNodeImpl(x,aNode,range,p);node._computedKey=vl,pc!=universes.Universe10.MethodBase&&pc!=universes.Universe08.MethodBase||node.setComputed("form","true");var isInsideTraitOrResourceType=isInTtraitOrResourceType(aNode),t=descriminate(p,aNode,node);t&&(isInsideTraitOrResourceType||t.setName(vl),node.patchType(t));var ch=node.children();node._children=ch.filter(function(x){return!x.isUnknown()}),node._allowQuestion=allowsQuestion,exists||inherited.push(node),node.children().forEach(function(x){if(x.property().getAdapter(services.RAMLPropertyService).isKey()){var atr=x;return void(atr._computed=!0)}if(x.isElement()&&(x.property().getAdapter(services.RAMLPropertyService).isMerged()||(filter[x.property().nameId()]=!0)),x.property().isAnnotation()){var atr=x,vl=atr.value(),strVal="";strVal=vl instanceof hlimpl.StructuredValue?vl.valueName():""+vl,filter["("+strVal+")"]=!0}else filter[x.name()]=!0});var ap=node.definition().allProperties();ap.forEach(function(p){p.getAdapter(services.RAMLPropertyService).isKey()||p.getAdapter(services.RAMLPropertyService).isSystem()||node.lowLevel().children().some(function(x){return x.key()==p.nameId()})&&(filter[p.nameId()]=!0)}),node._computed=!0}}})}var parsed=[];if(0==x.children().length&&x.valueKind()==yaml.Kind.SEQ&&p.range().key()==universes.Universe08.Parameter){var error=new hlimpl.BasicASTNode(x,aNode);error.errorMessage="property: '"+p.nameId()+"' must be a map",res.push(error)}if("documentation"===p.nameId()&&x.valueKind()!==yaml.Kind.SEQ){if(!aNode.definition().getAdapter(services.RAMLService).isUserDefined()){var error=new hlimpl.BasicASTNode(x,aNode);error.errorMessage="property: '"+p.nameId()+"' should be a sequence",res.push(error)}}else x.children().forEach(function(y){if(!filter[y.key()])if(y.valueKind()==yaml.Kind.SEQ){var isRaml1="RAML10"==aNode.definition().universe().version();if(y.children().forEach(function(z){var node=new hlimpl.ASTNodeImpl(z,aNode,range,p);node._allowQuestion=allowsQuestion,node.setNamePatch(y.key()),isRaml1&&(node.invalidSequence=!0),parsed.push(node)}),0==y.children().length){var error=new hlimpl.BasicASTNode(y,aNode);p.range().key()==universes.Universe08.Parameter?error.errorMessage="named parameter needs at least one type":error.errorMessage="node should have at least one member value",res.push(error)}}else{var node=new hlimpl.ASTNodeImpl(y,aNode,range,p),dc=p.domain().key();"body"!=p.nameId()||dc!=universes.Universe08.MethodBase&&dc!=universes.Universe10.MethodBase||node.setComputed("form","true"),node._allowQuestion=allowsQuestion,parsed.push(node)}});parsed.length>0?parsed.forEach(function(x){return rs.push(x)}):inherited.forEach(function(x){return rs.push(x)})}else rs.push(new hlimpl.ASTNodeImpl(x,aNode,range,p));aNode._children=aNode._children.concat(rs),res=res.concat(rs),rs.forEach(function(x){var rt=descriminate(p,aNode,x);rt&&rt!=x.definition()&&x.patchType(rt),x._associatedDef=null,p.childRestrictions().forEach(function(y){x.setComputed(y.name,y.value)});x.definition()})}else x instanceof proxy.LowLevelCompositeNode&&null==x.primaryNode()||res.push(new hlimpl.BasicASTNode(x,aNode))}),res)},BasicNodeBuilder}();exports.BasicNodeBuilder=BasicNodeBuilder,exports.doDescrimination=doDescrimination;var isInTtraitOrResourceType=function(aNode){for(var isInsideTraitOrResourceType=!1,parent_=aNode;parent_;){var pDef=parent_.definition();if(universeHelpers.isTraitType(pDef)||universeHelpers.isResourceTypeType(pDef)){isInsideTraitOrResourceType=!0;break}parent_=parent_.parent()}return isInsideTraitOrResourceType}},function(module,exports,__webpack_require__){"use strict";function buildXHR(){return new XMLHttpRequestWrapper}function copyNode(n){if(null==n)return null;switch(n.kind){case yaml.Kind.SCALAR:return{errors:[],startPosition:n.startPosition,endPosition:n.endPosition,value:n.value,kind:yaml.Kind.SCALAR,parent:n.parent};case yaml.Kind.MAPPING:var map=n;return{errors:[],key:copyNode(map.key),value:copyNode(map.value),startPosition:map.startPosition,endPosition:map.endPosition,kind:yaml.Kind.MAPPING,parent:map.parent};case yaml.Kind.MAP:var ymap=n;return{errors:[],startPosition:n.startPosition,endPosition:n.endPosition,mappings:ymap.mappings.map(function(x){return copyNode(x)}),kind:yaml.Kind.MAP,parent:ymap.parent}}return n}function splitOnLines(text){var lines=text.match(/^.*((\r\n|\n|\r)|$)/gm);return lines}function stripIndent(text,indent){for(var lines=splitOnLines(text),rs=[],i=0;i<lines.length;i++)0==i?rs.push(lines[0]):rs.push(lines[i].substring(indent.length));return rs.join("")}function indent(line){for(var rs="",i=0;i<line.length;i++){var c=line[i];if("\r"!=c&&"\n"!=c){if(" "!=c&&"\t"!=c)break;rs+=c}}return rs}function breaksTheLine(oc,textCommand){var oldText=oc.substr(textCommand.offset,textCommand.replacementLength);return oldText.indexOf("\n")!=-1||(textCommand.text.indexOf("\n")!=-1||void 0)}function tryParseScalar(q){if("null"==q)q=null;else if("~"==q)q=null;else if("true"==q)q=!0;else if("false"==q)q=!1;else{var vl=parseFloat(q);isNaN(vl)||(""+q).match("^[-+]?[0-9]*\\.?[0-9]+$")&&(q=vl)}return q}function createNode(key,parent){var node=yaml.newMapping(yaml.newScalar(key),yaml.newMap());return new ASTNode(node,null,parent,null,null)}function createMap(mappings){var node=yaml.newMap(mappings);return new ASTNode(node,null,null,null,null)}function createScalar(value){var node=yaml.newScalar(value);return new ASTNode(node,null,null,null,null)}function createSeq(sn,parent,unit){return new ASTNode(sn,unit,parent,null,null)}function createSeqNode(key){var node=yaml.newMapping(yaml.newScalar(key),yaml.newItems());return new ASTNode(node,null,null,null,null)}function createMapNode(key){var node=yaml.newMapping(yaml.newScalar(key),yaml.newMap());return new ASTNode(node,null,null,null,null)}function createMapping(key,v){var node=yaml.newMapping(yaml.newScalar(key),yaml.newScalar(v));return new ASTNode(node,null,null,null,null)}function toChildCachingNode(node){if(!(node instanceof ASTNode))return null;var astNode=node,result=new ASTNode(astNode.yamlNode(),astNode.unit(),null,null,null,(!0));return result._errors=astNode._errors,result}function toIncludingNode(node){if(!(node instanceof ASTNode))return null;var astNode=node,result=new ASTNode(astNode.yamlNode(),astNode.unit(),null,null,null,(!1));return result._errors=astNode._errors,result}function getDefinitionForLowLevelNode(node){var hl=node.highLevelNode();if(hl)return hl.definition();var parent=node.parent();if(!parent)return null;var key=node.key();if(!key)return null;var parentDef=parent.nodeDefinition();if(!parentDef)return null;if(!parentDef.property)return null;var prop=parentDef.property(key);return prop?prop.range():null}function fetchMasterReference(unit,map,errors,lMap){if(unit.isOverlayOrExtension()){var masterReferenceNode=unit.getMasterReferenceNode();if(masterReferenceNode){var masterReferenceText=masterReferenceNode.value();if(masterReferenceText){var unitPath=path.dirname(unit.absolutePath()),absIncludePath=lowlevel.toAbsolutePath(unitPath,masterReferenceText);if(!map[absIncludePath]){if(errors[absIncludePath])return void masterReferenceNode.errors().push(new Error(errors[masterReferenceText]));var arr=lMap[absIncludePath];arr||(arr=[],lMap[absIncludePath]=arr),arr.push(masterReferenceNode)}}}}}function fetchIncludesAndMasterAsync(project,apiPath){var map={},errors={},units=[],processUnits=function(ind){for(var refs=[],lMap={};ind<units.length;){var unit=units[ind],unitPath=unit.absolutePath();fetchMasterReference(unit,map,errors,lMap);var includeNodes=unit.getIncludeNodes();includeNodes.forEach(function(x){var ip=x.includePath(),includeReference=refResolvers.getIncludeReference(ip);if(includeReference)return void refs.push(project.resolveAsync(unit.absolutePath(),ip));if(ip){var absIncludePath=lowlevel.buildPath(ip,unitPath,project.getRootPath());if(!map[absIncludePath]){if(errors[absIncludePath]&&x.errors)return void x.errors().push(new Error(errors[ip]));var arr=lMap[absIncludePath];arr||(arr=[],lMap[absIncludePath]=arr),arr.push(x)}}}),ind++}var unitPaths=Object.keys(lMap);if(0==refs.length&&0==unitPaths.length)return Promise.resolve();var promises=refs;return unitPaths.forEach(function(unitPath){promises.push(project.unitAsync(unitPath,!0).then(function(x){map[x.absolutePath()]||(map[x.absolutePath()]=!0,units.push(x))},function(x){var innerError=project.pathToUnit[unitPath];lMap[unitPath].forEach(function(node){innerError||node.errors&&node.errors().push(new Error(x))}),errors[unitPath]=x,project.failedUnits[unitPath]=x,innerError&&(x.inner=!0)}))}),Promise.all(promises).then(function(x){return processUnits(ind)})};return project.unitAsync(apiPath).then(function(x){return units.push(x),map[x.absolutePath()]=!0,processUnits(0)}).then(function(x){return units.length>0?units[0]:null})}var lowlevel=__webpack_require__(11),path=__webpack_require__(15),fs=__webpack_require__(44),yaml=__webpack_require__(70),_=__webpack_require__(61),textutil=__webpack_require__(41),hli=__webpack_require__(16),services=__webpack_require__(33),rr=__webpack_require__(28),util=__webpack_require__(31),refResolvers=__webpack_require__(29),schemes=__webpack_require__(53),universes=__webpack_require__(22),expander=__webpack_require__(24),namespaceResolver=__webpack_require__(54),Error=yaml.YAMLException;exports.Kind={SCALAR:yaml.Kind.SCALAR};var MarkupIndentingBuffer=function(){function MarkupIndentingBuffer(indent){this.text="",this.indent=indent}return MarkupIndentingBuffer.prototype.isLastNL=function(){return this.text.length>0&&"\n"==this.text[this.text.length-1]},MarkupIndentingBuffer.prototype.addWithIndent=function(lev,s){this.isLastNL()&&(this.text+=textutil.indent(lev),this.text+=this.indent),this.text+=s},MarkupIndentingBuffer.prototype.addChar=function(ch){this.isLastNL()&&(this.text+=this.indent),this.text+=ch},MarkupIndentingBuffer.prototype.append=function(s){for(var i=0;i<s.length;i++)this.addChar(s[i])},MarkupIndentingBuffer}();exports.MarkupIndentingBuffer=MarkupIndentingBuffer;var CompilationUnit=function(){function CompilationUnit(_path,_content,_tl,_project,_apath){this._path=_path,this._content=_content,this._tl=_tl,this._project=_project,this._apath=_apath,this._path=null!=this._path?this._path.replace(/\\/g,"/"):null}return CompilationUnit.prototype.highLevel=function(){return this._hl?this._hl:(this._hl=hli.fromUnit(this),this._hl)},CompilationUnit.prototype.isStubUnit=function(){return this.stu},CompilationUnit.prototype.resolveAsync=function(p){var unit=this._project.resolveAsync(this._path,p);return unit},CompilationUnit.prototype.getIncludeNodes=function(){var ast=this.ast(),arr=[];return null==ast?[]:(ast.gatherIncludes(arr),ast.children().forEach(function(x){"uses"==x.key()&&x.children().forEach(function(y){arr.push({includePath:function(){return y.value()}})})}),arr)},CompilationUnit.prototype.cloneToProject=function(p){var newUnit=new CompilationUnit(this._path,this._content,this._tl,p,this._apath);return newUnit},CompilationUnit.prototype.clone=function(){var newUnit=new CompilationUnit(this._path,this._content,this._tl,this.project(),this._apath);return newUnit},CompilationUnit.prototype.stub=function(){var newUnit=new CompilationUnit(this._path,this._content,this._tl,this.project(),this._apath);return newUnit.stu=!0,newUnit},CompilationUnit.prototype.isDirty=function(){return!1},CompilationUnit.prototype.expandedHighLevel=function(){if(this.expanded)return this.expanded;var result=this.highLevel().asElement(),nm=expander.expandTraitsAndResourceTypes(result.wrapperNode()),hlnode=nm.highLevel();return hlnode._expanded=!0,this.expanded=hlnode,hlnode},CompilationUnit.prototype.absolutePath=function(){return this._apath},CompilationUnit.prototype.isRAMLUnit=function(){var en=path.extname(this._path);return".raml"==en||".yaml"==en||".yml"==en},CompilationUnit.prototype.contents=function(){return this._content},CompilationUnit.prototype.resolve=function(p){"string"!=typeof p&&(p=""+p);var unit=this._project.resolve(this._path,p);return unit},CompilationUnit.prototype.path=function(){return this._path},CompilationUnit.prototype.lexerErrors=function(){return null==this.errors&&this.ast(),this.errors},CompilationUnit.prototype.ast=function(){var _this=this;if(this._node)return this._node;try{var result=yaml.load(this._content,{});return this.errors=result.errors,this.errors.forEach(function(x){x.mark&&(x.mark.filePath=_this.absolutePath())}),this._node=new ASTNode(result,this,null,null,null),this._node._errors=this.errors,this._node}catch(e){return this.errors=[],this.errors.push(new Error(e.message)),this._node=null,this._node}},CompilationUnit.prototype.isTopLevel=function(){return this._tl},CompilationUnit.prototype.updateContent=function(n){this._content=n,this.errors=null,this._node=null,this._lineMapper=null},CompilationUnit.prototype.updateContentSafe=function(n){this._content=n,this._lineMapper=null,this._hl=null},CompilationUnit.prototype.project=function(){return this._project},CompilationUnit.prototype.lineMapper=function(){return null==this._lineMapper&&(this._lineMapper=new lowlevel.LineMapperImpl(this.contents(),this.absolutePath())),this._lineMapper},CompilationUnit.prototype.isOverlayOrExtension=function(){for(var contents=this.contents(),spec="",ptype=null,num=0,pt=0,n=0;n<contents.length;n++){var c=contents.charAt(n);if("\r"==c||"\n"==c){spec?ptype=contents.substring(pt,n).trim():spec=contents.substring(0,n).trim();break}" "==c&&(num++,spec||2!=num||(spec=contents.substring(0,n),pt=n))}return"Extension"==ptype||"Overlay"==ptype},CompilationUnit.prototype.getMasterReferenceNode=function(){return _.find(this.ast().children(),function(x){return x.key()==universes.Universe10.Overlay.properties.extends.name})},CompilationUnit}();exports.CompilationUnit=CompilationUnit;var XhrSync=__webpack_require__(60).XMLHttpRequest,XhrAsync=__webpack_require__(60).XMLHttpRequest,XMLHttpRequestWrapper=function(){function XMLHttpRequestWrapper(){}return XMLHttpRequestWrapper.prototype.open=function(method,url,async){this.xhr=async?new XhrAsync:new XhrSync,this.async=async,this.xhr.open(method,url,async)},XMLHttpRequestWrapper.prototype.setRequestHeader=function(name,value){this.xhr.setRequestHeader(name,value)},XMLHttpRequestWrapper.prototype.getResponseHeader=function(name){return this.xhr.getResponseHeader(name)},XMLHttpRequestWrapper.prototype.getAllResponseHeaders=function(){return this.xhr.getAllResponseHeaders()},XMLHttpRequestWrapper.prototype.send=function(content){var _this=this;this.xhr.onload=function(){return _this.onResponse(!1)},this.xhr.onerror=function(){return _this.onResponse(!0)},this.xhr.send(content)},XMLHttpRequestWrapper.prototype.onResponse=function(isError){return this.statusText=this.xhr.statusText,this.responseText=this.xhr.responseText,this.responseType=this.xhr.responseType,this.status=this.xhr.status,isError&&this.onerror?void this.onerror():void(this.onload&&this.onload())},XMLHttpRequestWrapper}();exports.XMLHttpRequestWrapper=XMLHttpRequestWrapper,exports.buildXHR=buildXHR;var SimpleExecutor=function(){function SimpleExecutor(){}return SimpleExecutor.prototype.execute=function(req,doAppendParams){void 0===doAppendParams&&(doAppendParams=!0);var xhr=buildXHR(),url=req.url;doAppendParams&&(url=this.appendParams(req,req.url)),xhr.open(req.method,url,!1),this.doRequest(req,xhr);var status=xhr.status;if(status>300&&status<400){var locHeader=xhr.getResponseHeader("location");if(locHeader)return req.url=locHeader,this.execute(req,!1)}var response={status:status,statusText:xhr.statusText,headers:xhr.getAllResponseHeaders().split("\n").map(function(x){var ind=x.indexOf(":");return{name:x.substring(0,ind).trim(),value:x.substring(ind+1).trim()}}),content:{text:xhr.responseText,mimeType:xhr.responseType}};return response},SimpleExecutor.prototype.appendParams=function(req,url){var gotQueryParams=req.queryString&&req.queryString.length>0;if(gotQueryParams){url+="?";var arr=[];gotQueryParams&&(arr=arr.concat(req.queryString.map(function(q){return encodeURIComponent(q.name)+"="+encodeURIComponent(q.value)}))),url+=arr.join("&")}return url},SimpleExecutor.prototype.log=function(varName,value){},SimpleExecutor.prototype.executeAsync=function(req,doAppendParams){void 0===doAppendParams&&(doAppendParams=!0);var xhr=buildXHR(),url=req.url;doAppendParams&&(url=this.appendParams(req,req.url));var outer=this;return new Promise(function(resolve,reject){xhr.open(req.method,url,!0),xhr.onload=function(){var status=xhr.status,response={status:status,statusText:xhr.statusText,headers:xhr.getAllResponseHeaders().split("\n").map(function(x){var ind=x.indexOf(":");return{name:x.substring(0,ind).trim(),value:x.substring(ind+1).trim()}}),content:{text:xhr.responseText,mimeType:xhr.responseType}};resolve(response)},xhr.onerror=function(){reject(new Error("Network Error"))},outer.doRequest(req,xhr)})},SimpleExecutor.prototype.doRequest=function(req,xhr){if(req.headers&&req.headers.forEach(function(x){return xhr.setRequestHeader(x.name,x.value)}),req.postData)if(req.postData.params){var body=req.postData.params.map(function(p){return encodeURIComponent(p.name)+"="+encodeURIComponent(p.value)}).join("&");xhr.send(body)}else xhr.send(req.postData.text);else xhr.send()},SimpleExecutor}();exports.SimpleExecutor=SimpleExecutor;var HTTPResolverImpl=function(){function HTTPResolverImpl(){this.executor=new SimpleExecutor}return HTTPResolverImpl.prototype.getResource=function(url){if("undefined"!=typeof atom&&null!=atom){var cached=rr.get(url);if(cached)return cached;rr.addNotify(url);try{var resultWithCallback={content:""};return this.getResourceAsync(url).then(function(x){try{x.errorMessage?rr.set(url,{content:null,errorMessage:null}):(x.errorMessage=null,rr.set(url,x))}finally{resultWithCallback.callback&&resultWithCallback.callback(rr.get(url)),rr.removeNotity(url)}},function(e){rr.set(url,{content:null,errorMessage:null}),resultWithCallback.callback&&resultWithCallback.callback(rr.get(url)),rr.removeNotity(url)}),resultWithCallback}catch(e){console.log("Error"),console.log(e)}}var response=this.executor.execute({method:"get",url:url});if(!response)throw new Error("Unable to execute GET "+url);var result=this.toResponse(response,url);return result},HTTPResolverImpl.prototype.getResourceAsync=function(url){var _this=this;return this.executor.executeAsync({method:"get",url:url}).then(function(x){if(!x)return Promise.reject(new Error("Unable to execute GET "+url));var result=_this.toResponse(x,url);return result},function(x){return Promise.reject(new Error("Unable to execute GET "+url))})},HTTPResolverImpl.prototype.toResponse=function(response,url){var msg=null;response.status>=400&&(msg="GET "+url+"\nreturned error: "+response.status,response.statusText&&(msg+=" "+response.statusText));var content=null;response.content&&response.content.text&&(content=response.content.text);var result={content:content,errorMessage:msg};return result},HTTPResolverImpl}();exports.HTTPResolverImpl=HTTPResolverImpl;var FSResolverImpl=function(){function FSResolverImpl(){}return FSResolverImpl.prototype.content=function(path){if("string"!=typeof path&&(path=""+path),!fs.existsSync(path))return null;try{return fs.readFileSync(path).toString()}catch(e){return null}},FSResolverImpl.prototype.list=function(path){return fs.readdirSync(path)},FSResolverImpl.prototype.contentAsync=function(path){return new Promise(function(resolve,reject){fs.readFile(path,function(err,data){if(null!=err)return reject(err);var content=data.toString();resolve(content)})})},FSResolverImpl.prototype.listAsync=function(path){return new Promise(function(reject,resolve){fs.readdir(path,function(err,files){return null!=err?reject(err):void resolve(files)})})},FSResolverImpl}();exports.FSResolverImpl=FSResolverImpl;var innerShift=function(offset,yaNode,shift){if(yaNode&&(yaNode.startPosition>=offset&&(yaNode.startPosition+=shift),yaNode.endPosition>offset&&(yaNode.endPosition+=shift),yaNode.kind==yaml.Kind.MAPPING)){var m=yaNode;innerShift(offset,m.key,shift),innerShift(offset,m.value,shift)}},leadingIndent=function(node,text){for(var leading="",pos=node.start()-1;pos>0;){var ch=text[pos];if(" "!=ch&&"-"!=ch)break;leading=" "+leading,pos--}return leading},Project=function(){
function Project(rootPath,resolver,_httpResolver){this.rootPath=rootPath,this.resolver=resolver,this._httpResolver=_httpResolver,this.listeners=[],this.tlisteners=[],this.pathToUnit={},this.failedUnits={},this._fsEnabled=!0,this._namespaceResolver=new namespaceResolver.NamespaceResolver,null==this.resolver?this.resolver=new FSResolverImpl:this._fsEnabled=!1,null==this._httpResolver&&(this._httpResolver=new HTTPResolverImpl)}return Project.prototype.getRootPath=function(){return this.rootPath},Project.prototype.fsEnabled=function(){return this._fsEnabled},Project.prototype.cloneWithResolver=function(newResolver,httpResolver){void 0===httpResolver&&(httpResolver=null);var newProject=new Project(this.rootPath,newResolver,httpResolver?httpResolver:this._httpResolver);for(var unitPath in this.pathToUnit)newProject.pathToUnit[unitPath]=this.pathToUnit[unitPath].cloneToProject(newProject);return newProject},Project.prototype.setCachedUnitContent=function(pth,cnt,tl){void 0===tl&&(tl=!0);var relPath=pth,apath=lowlevel.toAbsolutePath(this.rootPath,pth),unit=new CompilationUnit(relPath,cnt,tl,this,apath);return this.pathToUnit[apath]=unit,unit},Project.prototype.resolveAsync=function(unitPath,pathInUnit){var _this=this;if(!pathInUnit)return Promise.reject(new Error("Unit path is null"));var includeReference=refResolvers.getIncludeReference(pathInUnit),oldPath=pathInUnit;includeReference&&(pathInUnit=includeReference.getIncludePath());var absPath=lowlevel.buildPath(pathInUnit,unitPath,this.rootPath);if(includeReference){var result,refPath=lowlevel.toAbsolutePath(path.dirname(lowlevel.toAbsolutePath(this.rootPath,unitPath)),includeReference.encodedName());this.pathToUnit[absPath]?Promise.resolve(result).then(function(unit){return _this.pathToUnit[refPath]=new CompilationUnit(includeReference.encodedName(),refResolvers.resolveContents(oldPath,_this.pathToUnit[absPath].contents()),(!1),_this,refPath),_this.pathToUnit[refPath]}):this.unitAsync(absPath,!0).then(function(unit){return _this.pathToUnit[absPath]=unit,_this.pathToUnit[refPath]=new CompilationUnit(includeReference.encodedName(),refResolvers.resolveContents(oldPath,_this.pathToUnit[absPath].contents()),(!1),_this,refPath),_this.pathToUnit[refPath]})}return this.unitAsync(absPath,!0)},Project.prototype.resolve=function(unitPath,pathInUnit){if(!pathInUnit)return null;pathInUnit=pathInUnit.replace(/\\/g,"/");var includeReference=refResolvers.getIncludeReference(pathInUnit),oldPath=pathInUnit;includeReference&&(pathInUnit=includeReference.getIncludePath());var absPath=lowlevel.buildPath(pathInUnit,unitPath,this.rootPath);if(includeReference){this.pathToUnit[absPath]||(this.pathToUnit[absPath]=this.unit(absPath,!0));var wrappedUnit=this.pathToUnit[absPath],refPath=lowlevel.toAbsolutePath(path.dirname(lowlevel.toAbsolutePath(this.rootPath,unitPath)),includeReference.encodedName());return this.pathToUnit[refPath]?this.pathToUnit[refPath]:(this.pathToUnit[refPath]=new CompilationUnit(includeReference.encodedName(),refResolvers.resolveContents(oldPath,wrappedUnit&&wrappedUnit.contents()),(!1),this,refPath),this.pathToUnit[refPath])}return this.unit(absPath,!0)},Project.prototype.units=function(){var _this=this;if(!this.resolver.list)throw new Error("Provided FSResolver is unable to list files. Please, use ExtendedFSResolver.");var names=this.resolver.list(this.rootPath).filter(function(x){return".raml"==path.extname(x)});return names.map(function(x){return _this.unit(x)}).filter(function(y){return y.isTopLevel()})},Project.prototype.unitsAsync=function(){var _this=this;return this.resolver.listAsync?this.resolver.listAsync(this.rootPath).then(function(x){var promises=x.filter(function(x){return".raml"==path.extname(x)}).map(function(x){return _this.unitAsync(x).then(function(x){return x.isTopLevel()?x:null},function(x){return null})});return Promise.all(promises).then(function(arr){return arr.filter(function(x){return null!=x})})}):Promise.reject(new Error("Provided FSResolver is unable to list files. Please, use ExtendedFSResolver."))},Project.prototype.lexerErrors=function(){var results=[];return this.units().forEach(function(x){results=results.concat(x.lexerErrors())}),results},Project.prototype.deleteUnit=function(p,absolute){void 0===absolute&&(absolute=!1);var apath=null;apath=lowlevel.isWebPath(p)?p:absolute?p:lowlevel.toAbsolutePath(this.rootPath,p),delete this.pathToUnit[apath]},Project.prototype.unit=function(p,absolute){if(void 0===absolute&&(absolute=!1),absolute||lowlevel.isWebPath(p)){if(null!=this.failedUnits[p]&&!this.failedUnits[p].inner)return null}else{var ap=lowlevel.toAbsolutePath(this.rootPath,p);if(this.failedUnits[ap]&&!this.failedUnits[p].inner)return null}var response,cnt=null,apath=p;if(lowlevel.isWebPath(p)){if(this.pathToUnit[apath])return this.pathToUnit[apath];if(this._httpResolver){if(response=this._httpResolver.getResource(p),response&&response.errorMessage)throw new Error(response.errorMessage);cnt=response?response.content:null}else response=(new HTTPResolverImpl).getResource(apath),cnt=response?response.content:null}else{"/"!=p.charAt(0)||absolute||(p=p.substr(1));var apath=lowlevel.toAbsolutePath(this.rootPath,p);if(this.pathToUnit[apath])return this.pathToUnit[apath];if(lowlevel.isWebPath(apath))if(this._httpResolver){var resp=this._httpResolver.getResource(apath);if(resp&&resp.errorMessage)throw new Error(resp.errorMessage);cnt=resp?resp.content:null}else{var resourceResponse=(new HTTPResolverImpl).getResource(apath);cnt=resourceResponse?resourceResponse.content:null}else cnt=this.resolver.content(apath)}if(null==cnt)return null;var tl=util.stringStartsWith(cnt,"#%RAML"),relPath=lowlevel.isWebPath(this.rootPath)==lowlevel.isWebPath(apath)?path.relative(this.rootPath,apath):apath,unit=new CompilationUnit(relPath,cnt,tl,this,apath);return this.pathToUnit[apath]=unit,response&&(response.callback=function(contentHolder){unit.updateContent(contentHolder&&contentHolder.content)}),unit},Project.prototype.unitAsync=function(p,absolute){var _this=this;void 0===absolute&&(absolute=!1);var cnt=null,apath=p;if(lowlevel.isWebPath(p)){if(this.pathToUnit[apath])return Promise.resolve(this.pathToUnit[apath]);if(this._httpResolver){var resp=this._httpResolver.getResourceAsync(apath);cnt=resp.then(function(x){return x.errorMessage?Promise.reject(new Error(x.errorMessage)):x.content})}else cnt=(new HTTPResolverImpl).getResourceAsync(apath)}else{if("/"!=p.charAt(0)||absolute||(p=p.substr(1)),apath=absolute?p:lowlevel.toAbsolutePath(this.rootPath,p),this.pathToUnit[apath])return Promise.resolve(this.pathToUnit[apath]);if(lowlevel.isWebPath(apath))if(this._httpResolver){var resp=this._httpResolver.getResourceAsync(apath);cnt=resp.then(function(x){return x.errorMessage?Promise.reject(new Error(x.errorMessage)):x.content})}else cnt=(new HTTPResolverImpl).getResourceAsync(apath);else cnt=this.resolver.contentAsync(apath)}if(null==cnt)return Promise.resolve(null);var relPath=lowlevel.isWebPath(this.rootPath)==lowlevel.isWebPath(apath)?path.relative(this.rootPath,apath):apath;return cnt.then(function(x){if(null==x)return Promise.reject(new Error("Can note resolve "+apath));var tl=util.stringStartsWith(x,"#%RAML"),unit=new CompilationUnit(relPath,x,tl,_this,apath);return _this.pathToUnit[apath]=unit,unit},function(err){return"object"==typeof err&&err instanceof Error?Promise.reject(err):Promise.reject(new Error(err.toString()))}).then(function(unit){return unit.isRAMLUnit()?unit:schemes.isScheme(unit.contents())?schemes.startDownloadingReferencesAsync(unit.contents(),unit):unit})},Project.prototype.visualizeNewlines=function(s){for(var res="",i=0;i<s.length;i++){var ch=s[i];"\r"==ch&&(ch="\\r"),"\n"==ch&&(ch="\\n"),res+=ch}return res},Project.prototype.indent=function(node){var text=node.unit().contents();if(node==node.root())return"";var leading=leadingIndent(node,text),dmp=splitOnLines(node.dump());if(dmp.length>1&&dmp[1].trim().length>0){var extra=indent(dmp[1]);return leading+extra}return leading+"  "},Project.prototype.startIndent=function(node){node.unit().contents();if(node==node.root())return"";var dmp=splitOnLines(node.dump());if(dmp.length>0){console.log("FIRST: "+dmp[0]);var extra=indent(dmp[0]);return extra+"  "}return""},Project.prototype.canWriteInOneLine=function(node){return!1},Project.prototype.isOneLine=function(node){return node.text().indexOf("\n")<0},Project.prototype.recalcPositionsUp=function(target){for(var np=target;np;)np.recalcEndPositionFromChilds(),np=np.parent()},Project.prototype.add2=function(target,node,toSeq,ipoint,json){void 0===json&&(json=!1);var unit=target.unit(),point=(target.root(),null);if(ipoint&&(ipoint instanceof ASTNode&&(point=ipoint),ipoint instanceof InsertionPoint&&(point=ipoint.point)),target.isValueInclude()){var childs=target.children();if(0==childs.length)throw new Error("not implemented: insert into empty include ref");var parent=childs[0].parent();return void this.add2(parent,node,toSeq,point,json)}var unitText=(new textutil.TextRange(unit.contents(),node.start(),node.end()),new textutil.TextRange(unit.contents(),target.start(),target.end()),target.unit().contents());target.valueKind()==yaml.Kind.SEQ&&(target=createSeq(target.valueAsSeq(),target,target.unit()));var json=this.isJson(target),originalIndent=json?"":this.indent(target.isSeq()?target.parent():target),xindent=originalIndent,indentLength=originalIndent.length,isTargetSeq=target.isSeq()||target.isMapping()&&(target.isValueSeq()||target.isValueScalar()||!target.asMapping().value);toSeq=toSeq,toSeq&&(json||isTargetSeq&&(xindent+="  ",indentLength+=2));var buf=new MarkupIndentingBuffer(xindent);node.markupNode(buf,node._actualNode(),0,json);var text=buf.text;if(toSeq){var trimText=textutil.trimEnd(text),trimLen=text.length-trimText.length;if(trimLen>0){var textlen=text.length;text=text.substring(0,textlen-trimLen),node.shiftNodes(textlen-trimLen,-trimLen)}}toSeq&&!json?(node.highLevelNode(),target.isMapping(),text=target.isSeq()||target.isMapping()&&(target.isValueSeq()||target.isValueScalar()||!target.asMapping().value)?originalIndent+"- "+text:originalIndent+text):text=originalIndent+text;var pos=target.end();if(point)point!=target?pos=point.end():json&&toSeq||(pos=target.keyEnd()+1,pos=new textutil.TextRange(unitText,pos,pos).extendAnyUntilNewLines().endpos());else if(json&&toSeq){var seq=target.asSeq();seq&&(pos=seq.items.length>0?seq.items[seq.items.length-1].endPosition:seq.endPosition-1)}else if(ipoint&&ipoint instanceof InsertionPoint){var ip=ipoint;ip.type==InsertionPointType.START&&(pos=target.keyEnd()+1,pos=new textutil.TextRange(unitText,pos,pos).extendAnyUntilNewLines().endpos())}var insertionRange=new textutil.TextRange(unitText,0,pos);if(pos=insertionRange.extendToNewlines().reduceSpaces().endpos(),json&&target.isSeq()){var seq=target.asSeq();seq.items.length>0&&(text=", "+text,indentLength+=2)}else pos>0&&"\n"!=unitText[pos-1]&&(text="\n"+text,indentLength++);var suffixLen=0;toSeq&&!json&&(text+="\n",suffixLen++);var newtext=unitText.substring(0,pos)+text+unitText.substring(pos,unitText.length),cu=unit;if(cu.updateContentSafe(newtext),this.executeReplace(new textutil.TextRange(unitText,pos,pos),text,cu),target.root().shiftNodes(pos,indentLength+(node.end()-node.start())+suffixLen),point){for(var childs=target.children(),index=-1,i=0;i<childs.length;i++){var x=childs[i];if(x.start()==point.start()&&x.end()==point.end()){index=i;break}}index>=0?target.addChild(node,index+1):target.addChild(node)}else target.addChild(node);node.shiftNodes(0,pos+indentLength),this.recalcPositionsUp(target),node.setUnit(target.unit()),node.visit(function(n){var node=n;return node.setUnit(target.unit()),!0})},Project.prototype.isJsonMap=function(node){if(!node.isMap())return!1;var text=node.text().trim();return text.length>=2&&"{"==text[0]&&"}"==text[text.length-1]},Project.prototype.isJsonSeq=function(node){if(!node.isSeq())return!1;var text=node.text().trim();return text.length>=2&&"["==text[0]&&"]"==text[text.length-1]},Project.prototype.isJson=function(node){return this.isJsonMap(node)||this.isJsonSeq(node)},Project.prototype.remove=function(unit,target,node){var parent=node.parent();if(node._oldText=node.dump(),this.isOneLine(node)&&node.isMapping()&&node.parent().isMap()){var mapnode=node.parent();if(1==mapnode.asMap().mappings.length&&null!=mapnode.parent())return void this.remove(unit,mapnode.parent(),mapnode)}if(this.isOneLine(node)&&node.isScalar()&&node.parent().isSeq()){var seqnode=node.parent(),seqn=seqnode.asSeq();if(1==seqn.items.length)return void this.remove(unit,seqnode.parent(),seqnode)}if(target.isMapping()&&node.isSeq()){var map=target.parent();return void this.remove(unit,map,target)}var range=new textutil.TextRange(unit.contents(),node.start(),node.end()),originalStartPos=(new textutil.TextRange(unit.contents(),target.start(),target.end()),new textutil.TextRange(unit.contents(),parent.start(),parent.end()),range.startpos());if(target.isSeq()){var seq=node.isSeq()?node:node.parentOfKind(yaml.Kind.SEQ);range=seq&&this.isJson(seq)?range.extendSpaces().extendCharIfAny(",").extendSpaces():range.extendToStartOfLine().extendAnyUntilNewLines().extendToNewlines()}target.isMap()&&(range=range.trimEnd().extendAnyUntilNewLines().extendToNewlines(),range=range.extendToStartOfLine().extendUntilNewlinesBack()),target.kind()==yaml.Kind.MAPPING&&(this.isJson(node)&&this.isOneLine(node)||(range=range.extendSpacesUntilNewLines(),range=range.extendToNewlines(),range=range.extendToStartOfLine().extendUntilNewlinesBack())),node.isSeq()&&(range=range.reduceSpaces());var cu=unit;cu.updateContentSafe(range.remove()),this.executeReplace(range,"",cu),node.parent().removeChild(node);var shift=-range.len();target.root().shiftNodes(originalStartPos,shift),this.recalcPositionsUp(target)},Project.prototype.changeKey=function(unit,attr,newval){var range=new textutil.TextRange(attr.unit().contents(),attr.keyStart(),attr.keyEnd());if(attr.kind()==yaml.Kind.MAPPING){var sc=attr._actualNode().key;sc.value=newval,sc.endPosition=sc.startPosition+newval.length}var cu=unit;this.executeReplace(range,newval,cu);var shift=newval.length-range.len();attr.root().shiftNodes(range.startpos(),shift,attr),this.recalcPositionsUp(attr)},Project.prototype.executeReplace=function(r,txt,unit){var command=new lowlevel.TextChangeCommand(r.startpos(),r.endpos()-r.startpos(),txt,unit);unit.project();try{this.tlisteners.forEach(function(x){return x(command)})}catch(e){return!1}var newtext=r.replace(txt);return unit.updateContentSafe(newtext),!0},Project.prototype.changeValue=function(unit,attr,newval){var newNodeText,range=new textutil.TextRange(attr.unit().contents(),attr.start(),attr.end()),prefix=0,delta=0,replacer=null,mapping=null;if(attr.kind()==yaml.Kind.SCALAR){if("string"!=typeof newval)throw new Error("not implemented");attr.asScalar().value=newval,newNodeText=newval}else if(attr.kind()==yaml.Kind.MAPPING){if(mapping=attr.asMapping(),attr.isValueInclude()){var inc=attr.valueAsInclude(),includeString=inc.value,includePath=includeString,resolved=attr.unit().resolve(includePath);if(null==resolved)return void console.log("attr.setValue: couldn't resolve: "+includePath);if(resolved.isRAMLUnit())return;return void(refResolvers.getIncludeReference(includeString)||resolved.updateContent(newval))}if(range=mapping.value?range.withStart(attr.valueStart()).withEnd(attr.valueEnd()):range.withStart(attr.keyEnd()+1).withEnd(attr.keyEnd()+1),range=range.reduceNewlinesEnd(),null==newval)newNodeText="",mapping.value=null;else if("string"==typeof newval||null==newval){var newstr=newval,ind=this.indent(attr);if(newstr&&textutil.isMultiLine(newstr)&&(newstr=""+textutil.makeMutiLine(newstr,ind.length/2)),newNodeText=newstr,mapping.value){if(mapping.value.kind==yaml.Kind.SEQ){console.log("seq value");mapping.value.items[0];throw"assign value!!!"}if(mapping.value.kind==yaml.Kind.SCALAR){var sc=mapping.value,oldtext=sc.value||"";sc.value=newstr,mapping.value.endPosition=mapping.value.startPosition+newstr.length,mapping.endPosition=mapping.value.endPosition,delta+=newstr.length-oldtext.length}}else if(console.log("no value"),mapping.value=yaml.newScalar(newstr),mapping.value.startPosition=attr.keyEnd()+1,mapping.value.endPosition=mapping.value.startPosition+newstr.length,mapping.endPosition=mapping.value.endPosition,unit.contents().length>attr.keyEnd()+1){var vlPos=attr.keyEnd()+1;":"==unit.contents()[vlPos-1]&&(newNodeText=" "+newNodeText,mapping.value.startPosition++,mapping.value.endPosition++,mapping.endPosition++,delta++)}}else{var n=newval;if(n.isMapping())newval=createMap([n.asMapping()]),n=newval;else if(!n.isMap())throw new Error("only MAP/MAPPING nodes allowed as values");var buf=new MarkupIndentingBuffer("");n.markupNode(buf,n._actualNode(),0,!0),newNodeText=""+buf.text,n.shiftNodes(0,range.startpos()+delta),replacer=n}}else console.log("Unsupported change value case: "+attr.kindName());var cu=unit;this.executeReplace(range,newNodeText,cu);var shift=newNodeText.length-range.len();attr.root().shiftNodes(range.endpos()+prefix,shift,attr),replacer&&(mapping.value=replacer._actualNode()),this.recalcPositionsUp(attr)},Project.prototype.initWithRoot=function(root,newroot){var shift=root.end();newroot.markup(!1),newroot._actualNode().startPosition=shift,newroot._actualNode().endPosition=shift,newroot.setUnit(root.unit())},Project.prototype.execute=function(cmd){var _this=this;cmd.commands.forEach(function(x){switch(x.kind){case lowlevel.CommandKind.CHANGE_VALUE:var attr=x.target,curval=attr.value();curval||(curval="");var newval=x.value;if(console.log("set value: "+typeof curval+" ==> "+typeof newval),"string"!=typeof curval&&"number"!=typeof curval&&"boolean"!=typeof curval||"string"!=typeof newval)if("string"!=typeof curval&&"number"!=typeof curval&&"boolean"!=typeof curval||"string"==typeof newval)if("string"!=typeof curval&&"string"==typeof newval){var newstr=x.value;if(curval.kind()!=yaml.Kind.MAPPING)throw new Error("unsupported case: attribute value conversion: "+typeof curval+" ==> "+typeof newval+" not supported");textutil.isMultiLine(newstr)?(attr.children().forEach(function(n){_this.remove(attr.unit(),attr,n)}),_this.changeValue(attr.unit(),attr,newstr)):_this.changeKey(attr.unit(),curval,newstr)}else{if("string"==typeof curval||"string"==typeof newval)throw new Error("shouldn't be this case: attribute value conversion "+typeof curval+" ==> "+typeof newval+" not supported");var newvalnode=newval;if(newvalnode.isMapping()&&(newval=createMap([newvalnode.asMapping()])),curval==newval)break;var node=newval;node.asMap();attr.children().forEach(function(n){_this.remove(attr.unit(),attr,n)}),node.children().forEach(function(m){}),_this.changeValue(attr.unit(),attr,newval)}else _this.changeValue(attr.unit(),attr,newval);else curval!=newval&&_this.changeValue(attr.unit(),attr,newval);return;case lowlevel.CommandKind.CHANGE_KEY:var attr=x.target;return void _this.changeKey(attr.unit(),attr,x.value);case lowlevel.CommandKind.ADD_CHILD:var attr=x.target,newValueNode=x.value;return void _this.add2(attr,newValueNode,x.toSeq,x.insertionPoint);case lowlevel.CommandKind.REMOVE_CHILD:var target=x.target,node=x.value;return void _this.remove(target.unit(),target,node);case lowlevel.CommandKind.INIT_RAML_FILE:var root=x.target,newroot=x.value;return void _this.initWithRoot(root,newroot);default:return void console.log("UNSUPPORTED COMMAND: "+lowlevel.CommandKind[x.kind])}})},Project.prototype.replaceYamlNode=function(target,newNodeContent,offset,shift,unit){var newYamlNode=yaml.load(newNodeContent,{});this.updatePositions(target.start(),newYamlNode),target.root().shiftNodes(offset,shift);var targetParent=target.parent(),targetYamlNode=target._actualNode(),parent=targetYamlNode.parent;if(newYamlNode.parent=parent,targetParent&&targetParent.kind()==yaml.Kind.MAP){var targetParentMapNode=targetParent._actualNode();targetParentMapNode.mappings=targetParentMapNode.mappings.map(function(x){return x!=targetYamlNode?x:newYamlNode})}target.updateFrom(newYamlNode),this.recalcPositionsUp(target)},Project.prototype.executeTextChange2=function(textCommand){var cu=textCommand.unit,unitText=cu.contents(),target=textCommand.target;if(target){var cnt=unitText.substring(target.start(),target.end());unitText=unitText.substr(0,textCommand.offset)+textCommand.text+unitText.substr(textCommand.offset+textCommand.replacementLength);var newNodeContent=cnt.substr(0,textCommand.offset-target.start())+textCommand.text+cnt.substr(textCommand.offset-target.start()+textCommand.replacementLength);if(cu.updateContentSafe(unitText),textCommand.offset>target.start())try{var shift=textCommand.text.length-textCommand.replacementLength,offset=textCommand.offset;target.unit().project().replaceYamlNode(target,newNodeContent,offset,shift,textCommand.unit)}catch(e){console.log("New node contents (causes error below): \n"+newNodeContent),console.log("Reparse error: "+e.stack)}}else unitText=unitText.substr(0,textCommand.offset)+textCommand.text+unitText.substr(textCommand.offset+textCommand.replacementLength);cu.updateContent(unitText),this.listeners.forEach(function(x){x(null)}),this.tlisteners.forEach(function(x){x(textCommand)})},Project.prototype.executeTextChange=function(textCommand){(new Date).getTime();try{var oc=textCommand.unit.contents(),target=textCommand.target;null==target&&(target=this.findNode(textCommand.unit.ast(),textCommand.offset,textCommand.offset+textCommand.replacementLength));var cu=textCommand.unit;if(target){var cnt=oc.substring(target.start(),target.end()),original=oc;oc=oc.substr(0,textCommand.offset)+textCommand.text+oc.substr(textCommand.offset+textCommand.replacementLength);var newNodeContent=cnt.substr(0,textCommand.offset-target.start())+textCommand.text+cnt.substr(textCommand.offset-target.start()+textCommand.replacementLength);cu.updateContentSafe(oc);breaksTheLine(original,textCommand);if(textCommand.offset>target.start())try{var newYamlNode=yaml.load(newNodeContent,{});this.updatePositions(target.start(),newYamlNode);var shift=textCommand.text.length-textCommand.replacementLength;if(textCommand.unit.ast().shiftNodes(textCommand.offset,shift),null!=newYamlNode&&newYamlNode.kind==yaml.Kind.MAP){var actualResult=newYamlNode.mappings[0],targetYamlNode=target._actualNode(),parent=targetYamlNode.parent,cmd=new lowlevel.ASTDelta,unit=textCommand.unit;if(cmd.commands=[new lowlevel.ASTChangeCommand(lowlevel.CommandKind.CHANGE_VALUE,new ASTNode(copyNode(targetYamlNode),unit,null,null,null),new ASTNode(actualResult,unit,null,null,null),0)],parent&&parent.kind==yaml.Kind.MAP){var map=parent;map.mappings=map.mappings.map(function(x){return x!=targetYamlNode?x:actualResult})}return actualResult.parent=parent,this.recalcPositionsUp(target),target.updateFrom(actualResult),this.listeners.forEach(function(x){x(cmd)}),void this.tlisteners.forEach(function(x){x(textCommand)})}}catch(e){console.log("New node contents (causes error below): \n"+newNodeContent),console.log("Reparse error: "+e.stack)}}else oc=oc.substr(0,textCommand.offset)+textCommand.text+oc.substr(textCommand.offset+textCommand.replacementLength);(new Date).getTime();cu.updateContent(oc),this.listeners.forEach(function(x){x(null)}),this.tlisteners.forEach(function(x){x(textCommand)})}finally{(new Date).getTime()}},Project.prototype.updatePositions=function(offset,n){var _this=this;if(null!=n)switch(n.startPosition==-1?n.startPosition=offset:n.startPosition=offset+n.startPosition,n.endPosition=offset+n.endPosition,n.kind){case yaml.Kind.MAP:var m=n;m.mappings.forEach(function(x){return _this.updatePositions(offset,x)});break;case yaml.Kind.MAPPING:var ma=n;this.updatePositions(offset,ma.key),this.updatePositions(offset,ma.value);break;case yaml.Kind.SCALAR:break;case yaml.Kind.SEQ:var s=n;s.items.forEach(function(x){return _this.updatePositions(offset,x)})}},Project.prototype.findNode=function(n,offset,end){var _this=this;if(null==n)return null;var node=n;if(n.start()<=offset&&n.end()>=end){var res=n;return node.directChildren().forEach(function(x){var m=_this.findNode(x,offset,end);m&&(res=m)}),res}return null},Project.prototype.addTextChangeListener=function(listener){this.tlisteners.push(listener)},Project.prototype.removeTextChangeListener=function(listener){this.tlisteners=this.tlisteners.filter(function(x){return x!=listener})},Project.prototype.addListener=function(listener){this.listeners.push(listener)},Project.prototype.removeListener=function(listener){this.listeners=this.listeners.filter(function(x){return x!=listener})},Project.prototype.namespaceResolver=function(){return this._namespaceResolver},Project}();exports.Project=Project;var ASTNode=function(){function ASTNode(_node,_unit,_parent,_anchor,_include,cacheChildren,_includesContents){void 0===cacheChildren&&(cacheChildren=!1),void 0===_includesContents&&(_includesContents=!1),this._node=_node,this._unit=_unit,this._parent=_parent,this._anchor=_anchor,this._include=_include,this.cacheChildren=cacheChildren,this._includesContents=_includesContents,this._errors=[],null==_node&&console.log("null")}return ASTNode.prototype.actual=function(){return this._node},ASTNode.prototype.yamlNode=function(){return this._node},ASTNode.prototype.includesContents=function(){return this._includesContents},ASTNode.prototype.setIncludesContents=function(includesContents){this._includesContents=includesContents},ASTNode.prototype.gatherIncludes=function(s,inc,anc,inOneMemberMap){var _this=this;if(void 0===s&&(s=[]),void 0===inc&&(inc=null),void 0===anc&&(anc=null),void 0===inOneMemberMap&&(inOneMemberMap=!0),null!=this._node){var kind=this._node.kind;if(kind!=yaml.Kind.SCALAR)if(kind==yaml.Kind.MAP){var map=this._node;1!=map.mappings.length||inOneMemberMap?map.mappings.map(function(x){return new ASTNode(x,_this._unit,_this,anc?anc:_this._anchor,inc?inc:_this._include,_this.cacheChildren)}).forEach(function(x){return x.gatherIncludes(s)}):new ASTNode(map.mappings[0].value,this._unit,this,inc,anc,this.cacheChildren).gatherIncludes(s)}else if(kind==yaml.Kind.MAPPING){var mapping=this._node;null==mapping.value||new ASTNode(mapping.value,this._unit,this,anc?anc:this._anchor,inc?inc:this._include,this.cacheChildren).gatherIncludes(s)}else if(kind==yaml.Kind.SEQ){var seq=this._node;seq.items.filter(function(x){return null!=x}).map(function(x){return new ASTNode(x,_this._unit,_this,anc?anc:_this._anchor,inc?inc:_this._include,_this.cacheChildren)}).forEach(function(x){return x.gatherIncludes(s)})}else kind==yaml.Kind.INCLUDE_REF&&this._unit&&s.push(this);else if(schemes.isScheme(this._node.value)){var references=schemes.getReferences(this._node.value,this.unit());references.forEach(function(reference){var includeNode=yaml.newScalar(reference);includeNode.kind=yaml.Kind.INCLUDE_REF;var includeAST=new ASTNode(includeNode,_this.unit(),null,null,null);s.push(includeAST)})}}},ASTNode.prototype.setHighLevelParseResult=function(highLevelParseResult){this._highLevelParseResult=highLevelParseResult},ASTNode.prototype.highLevelParseResult=function(){return this._highLevelParseResult},ASTNode.prototype.setHighLevelNode=function(highLevel){this._highLevelNode=highLevel},ASTNode.prototype.highLevelNode=function(){return this._highLevelNode},ASTNode.prototype.start=function(){return this._node.startPosition},ASTNode.prototype.errors=function(){return this._errors},ASTNode.prototype.addIncludeError=function(error){this._errors.push(error),this._node.includeErrors||(this._node.includeErrors=[]),this._node.includeErrors.push(error)},ASTNode.prototype.parent=function(){return this._parent},ASTNode.prototype.recalcEndPositionFromChilds=function(){var first=(this.children(),this.children()[0]),last=this.children()[this.children().length-1];if(this.isMapping()){var mapping=this.asMapping();if(mapping.value)if(mapping.value.kind==yaml.Kind.MAP){var map=mapping.value;map.startPosition<0&&first&&(map.startPosition=first.start()),last&&(this._node.endPosition=last._node.endPosition),this._node.endPosition=Math.max(this._node.endPosition,mapping.value.endPosition)}else if(mapping.value.kind==yaml.Kind.SEQ){var seq=mapping.value;if(seq.startPosition<0&&seq.items.length>0){var pos=seq.items[0].startPosition,range=new textutil.TextRange(this.unit().contents(),pos,pos);range=range.extendSpacesBack().extendCharIfAnyBack("-"),seq.startPosition=range.startpos()}if(seq.items.length>0){var ilast=seq.items[seq.items.length-1];this._node.endPosition=Math.max(this._node.endPosition,seq.endPosition,ilast.endPosition),seq.endPosition=Math.max(this._node.endPosition,seq.endPosition,ilast.endPosition)}}else mapping.value.kind==yaml.Kind.SCALAR||last&&(this._node.endPosition=last._node.endPosition)}else last&&(this._node.endPosition=last._node.endPosition)},ASTNode.prototype.isValueLocal=function(){if(this._node.kind==yaml.Kind.MAPPING){var knd=this._node.value.kind;return knd!=yaml.Kind.INCLUDE_REF&&knd!=yaml.Kind.ANCHOR_REF}return!0},ASTNode.prototype.keyStart=function(){return this._node.kind==yaml.Kind.MAPPING?this._node.key.startPosition:-1},ASTNode.prototype.keyEnd=function(){return this._node.kind==yaml.Kind.MAPPING?this._node.key.endPosition:-1},ASTNode.prototype.valueStart=function(){if(this._node.kind==yaml.Kind.MAPPING){var mapping=this.asMapping();return mapping.value?mapping.value.startPosition:mapping.endPosition}return-1},ASTNode.prototype.valueEnd=function(){if(this._node.kind==yaml.Kind.MAPPING){var mapping=this.asMapping();return mapping.value?mapping.value.endPosition:mapping.endPosition}return-1},ASTNode.prototype.end=function(){return this._node.endPosition},ASTNode.prototype.dump=function(){if(this._oldText)return this._oldText;if(this._unit&&this._node.startPosition>0&&this._node.endPosition>0){var originalText=this._unit.contents().substring(this._node.startPosition,this._node.endPosition);return originalText=stripIndent(originalText,leadingIndent(this,this._unit.contents()))}return yaml.dump(this.dumpToObject(),{})},ASTNode.prototype.dumpToObject=function(full){return void 0===full&&(full=!1),this.dumpNode(this._node,full)},ASTNode.prototype.dumpNode=function(n,full){var _this=this;if(void 0===full&&(full=!1),!n)return null;if(n.kind==yaml.Kind.INCLUDE_REF){if(this._unit){var s=n,includePath=s.value,resolved=null;try{resolved=this._unit.resolve(includePath)}catch(Error){}if(null==resolved)return null;if(resolved.isRAMLUnit()&&this.canInclude(resolved)){var ast=resolved.ast();if(ast)return ast.dumpToObject(full)}}return null}if(n.kind==yaml.Kind.SEQ){var seq=n,arr=[];return seq.items.forEach(function(x){return arr.push(_this.dumpNode(x,full))}),arr}if(n.kind==yaml.Kind.ANCHOR_REF){var aref=n;return this.dumpNode(aref.value,full)}if(n.kind==yaml.Kind.MAPPING){var c=n,v={},val=c.value,mm=this.dumpNode(val,full);return v[""+this.dumpNode(c.key,full)]=mm,v}if(n.kind==yaml.Kind.SCALAR){var s=n,q=s.value;return s.plainScalar&&(q=tryParseScalar(q)),q}if(n.kind==yaml.Kind.MAP){var map=n,res={};return map.mappings&&map.mappings.forEach(function(x){var ms=_this.dumpNode(x.value,full);null==ms&&(ms=full?"!$$$novalue":ms),res[_this.dumpNode(x.key,full)+""]=ms}),res}},ASTNode.prototype.keyKind=function(){return this._node.key?this._node.key.kind:null},ASTNode.prototype._actualNode=function(){return this._node},ASTNode.prototype.execute=function(cmd){this.unit()?this.unit().project().execute(cmd):cmd.commands.forEach(function(x){switch(x.kind){case lowlevel.CommandKind.CHANGE_VALUE:var attr=x.target,newValue=x.value,va=attr._actualNode();attr.start();return void(va.kind==yaml.Kind.MAPPING&&(va.value=yaml.newScalar(""+newValue)));case lowlevel.CommandKind.CHANGE_KEY:var attr=x.target,newValue=x.value,va=attr._actualNode();if(va.kind==yaml.Kind.MAPPING){var sc=va.key;sc.value=newValue}return}})},ASTNode.prototype.updateFrom=function(n){this._node=n},ASTNode.prototype.isAnnotatedScalar=function(){if(this.kind()==yaml.Kind.MAPPING&&this.unit()&&this.valueKind()==yaml.Kind.MAP&&this._node.value.mappings){var isScalar=this._node.value.mappings.length>0;
return this._node.value.mappings.forEach(function(x){"value"!==x.key.value&&(x.key.value&&"("==x.key.value.charAt(0)&&")"==x.key.value.charAt(x.key.value.length-1)||(isScalar=!1))}),isScalar}return!1},ASTNode.prototype.value=function(toString){if(!this._node)return"";if(this._node.kind==yaml.Kind.SCALAR){if("~"===this._node.value&&null===this._node.valueObject)return toString?"null":null;if(!toString&&""+this._node.valueObject===this._node.value)return this._node.valueObject;var q=this._node.value;return toString||this._node.plainScalar&&(q=tryParseScalar(q)),q}if(this._node.kind==yaml.Kind.ANCHOR_REF){var ref=this._node;return new ASTNode(ref.value,this._unit,this,null,null).value(toString)}if(this._node.kind==yaml.Kind.MAPPING){var map=this._node;if(null==map.value)return null;if(this.isAnnotatedScalar())for(var child=new ASTNode(map.value,this._unit,this,null,null),ch=child.children(),i=0;i<ch.length;i++)if("value"===ch[i].key())return ch[i].value();return new ASTNode(map.value,this._unit,this,null,null).value(toString)}if(this._node.kind==yaml.Kind.INCLUDE_REF){var includeString=this._node.value,includePath=includeString,resolved=null;try{resolved=this._unit.resolve(includePath)}catch(Error){return"can not resolve "+includePath+" due to: "+Error.message}if(null==resolved)return"can not resolve "+includePath;if(resolved.isRAMLUnit()){var ast=resolved.ast();return ast?ast.value():"can not resolve "+includePath+" due to: file is empty"}var text=resolved.contents();return textutil.isMultiLineValue(text)&&(text=textutil.fromMutiLine(text)),text}if(this._node.kind==yaml.Kind.MAP){var amap=this._node;if(1==amap.mappings.length)return new ASTNode(amap.mappings[0],this._unit,this,null,null)}if(this._node.kind==yaml.Kind.SEQ){var aseq=this._node;if(1==aseq.items.length)return new ASTNode(aseq.items[0],this._unit,this,null,null).value(toString)}return null},ASTNode.prototype.printDetails=function(indent){var result="";indent||(indent="");var typeName=this.kindName();return this.kind()==yaml.Kind.SCALAR?result+=indent+"["+typeName+"] "+this.value()+"\n":this.kind()==yaml.Kind.MAPPING&&this._node.value&&this._node.value.kind==yaml.Kind.SCALAR?result+=indent+"["+typeName+"] "+this.key()+" = "+this.value()+"\n":this.kind()==yaml.Kind.MAPPING?(result+=indent+"["+typeName+"] "+this.key()+" = :\n",this.children().forEach(function(child){result+=child.printDetails(indent+"\t")})):(result+=indent+"["+typeName+"] :\n",this.children().forEach(function(child){result+=child.printDetails(indent+"\t")})),result},ASTNode.prototype.visit=function(v){this.children().forEach(function(x){v(x)&&x.visit(v)})},ASTNode.prototype.rawKey=function(){if(!this._node)return"";if(this._node.kind==yaml.Kind.MAPPING){var map=this._node;if(map.key.kind==yaml.Kind.SEQ){var items=map.key,mn="[";return items.items.forEach(function(x){return mn+=x.value}),mn+"]"}return map.key.value}if(this._node.kind==yaml.Kind.INCLUDE_REF){var m=this.children();if(1==m.length)return m[0].key()}return null},ASTNode.prototype.key=function(){var key=this.rawKey();return null!=key&&util.stringEndsWith(key,"?")&&(key=key.substring(0,key.length-1)),key},ASTNode.prototype.optional=function(){var key=this.rawKey();return null!=key&&util.stringEndsWith(key,"?")},ASTNode.prototype.addChild=function(n,pos){void 0===pos&&(pos=-1);var node=n;if(node._parent=this,this._oldText=null,this.isMap()){var map=this.asMap();null!=map.mappings&&void 0!=map.mappings||(map.mappings=[]),pos>=0?map.mappings.splice(pos,0,node.asMapping()):map.mappings.push(node.asMapping())}else if(this.isMapping()){var mapping=this.asMapping(),val=mapping.value;if(!mapping.value&&node.isMap())return void(mapping.value=node._actualNode());if(mapping.value&&mapping.value.kind==yaml.Kind.SCALAR&&(mapping.value=null,val=null),val||(val=node.isScalar()||node.highLevelNode()&&node.highLevelNode().property().getAdapter(services.RAMLPropertyParserService).isEmbedMap()?yaml.newSeq():yaml.newMap(),mapping.value=val),val.kind==yaml.Kind.MAP){var map=val;null!=map.mappings&&void 0!=map.mappings||(map.mappings=[]),node.isScalar(),pos>=0?map.mappings.splice(pos,0,node.asMapping()):map.mappings.push(node.asMapping())}else{if(val.kind!=yaml.Kind.SEQ)throw new Error("Insert into mapping with "+yaml.Kind[mapping.value.kind]+" value not supported");var seq=val;pos>=0?seq.items.splice(pos,0,node._actualNode()):seq.items.push(node._actualNode())}}else{if(!this.isSeq())throw new Error("Insert into "+this.kindName()+" not supported");var seq=this.asSeq();pos>=0?seq.items.splice(pos,0,node._actualNode()):seq.items.push(node._actualNode())}},ASTNode.prototype.removeChild=function(n){this._oldText=null;var ynode,index,node=n;if(this.kind()==yaml.Kind.SEQ){var seq=this.asSeq();ynode=node._node,index=seq.items.indexOf(ynode),index>-1&&seq.items.splice(index,1)}else if(this.kind()==yaml.Kind.MAP){var map=this.asMap();ynode=node.asMapping(),index=map.mappings.indexOf(ynode),index>-1&&map.mappings.splice(index,1)}else{if(this.kind()!=yaml.Kind.MAPPING)throw new Error("Delete from "+yaml.Kind[this.kind()]+" unsupported");var mapping=this.asMapping();if(node._actualNode()==mapping.value)mapping.value=null;else{var map=mapping.value;ynode=node.asMapping(),map&&map.mappings&&(index=map.mappings.indexOf(ynode),index>-1&&map.mappings.splice(index,1))}}},ASTNode.prototype.hasInnerIncludeError=function(){return this.innerIncludeErrors},ASTNode.prototype.includeErrors=function(){if(this._node.kind==yaml.Kind.MAPPING){var mapping=this._node;if(null==mapping.value)return[];var node=new ASTNode(mapping.value,this._unit,this,this._anchor,this._include),res=node.includeErrors();return this.innerIncludeErrors=node.hasInnerIncludeError(),res}var rs=[];if(this._node.kind==yaml.Kind.INCLUDE_REF){var mapping=this._node;if(null==mapping.value)return[];var includePath=this.includePath(),resolved=null;try{resolved=this._unit.resolve(includePath)}catch(Error){this.innerIncludeErrors=Error.inner;var s="Can not resolve "+includePath+" due to: "+Error.message;return rs.push(s),rs}var innerIncludeErrors=this._node.includeErrors;if(innerIncludeErrors&&innerIncludeErrors.length>0)return this.innerIncludeErrors=!0,rs=innerIncludeErrors.map(function(innerError){return"object"==typeof innerError&&innerError instanceof Error?innerError.message:innerError.toString()});if(null==resolved)return rs.push("Can not resolve "+includePath),rs;if(resolved.isRAMLUnit()){var ast=resolved.ast();if(ast)return[];rs.push(""+includePath+" can not be parsed")}}return rs},ASTNode.prototype.children=function(inc,anc,inOneMemberMap){var _this=this;if(void 0===inc&&(inc=null),void 0===anc&&(anc=null),void 0===inOneMemberMap&&(inOneMemberMap=!0),null==this._node)return[];if(this.cacheChildren&&this._children)return this._children;var result,kind=this._node.kind;if(kind==yaml.Kind.SCALAR)result=[];else if(kind==yaml.Kind.MAP){var map=this._node;result=1!=map.mappings.length||inOneMemberMap?map.mappings.map(function(x){return new ASTNode(x,_this._unit,_this,anc?anc:_this._anchor,inc?inc:_this._include,_this.cacheChildren)}):new ASTNode(map.mappings[0].value,this._unit,this,inc,anc,this.cacheChildren).children(null,null,!0)}else if(kind==yaml.Kind.MAPPING){var mapping=this._node;if(null==mapping.value)result=[];else{var proxy=new ASTNode(mapping.value,this._unit,this,anc?anc:this._anchor,inc?inc:this._include,this.cacheChildren);result=proxy.children(),proxy.includesContents()&&this.setIncludesContents(!0)}}else if(kind==yaml.Kind.SEQ){var seq=this._node;result=seq.items.filter(function(x){return null!=x}).map(function(x){return new ASTNode(x,_this._unit,_this,anc?anc:_this._anchor,inc?inc:_this._include,_this.cacheChildren)})}else if(kind==yaml.Kind.INCLUDE_REF){if(this._unit){var includePath=this.includePath(),resolved=null;try{resolved=this._unit.resolve(includePath)}catch(Error){}if(null==resolved)result=[];else if(resolved.isRAMLUnit()&&this.canInclude(resolved)){var ast=resolved.ast();ast&&(this.cacheChildren&&(ast=toChildCachingNode(ast)),result=resolved.ast().children(this,null),this.setIncludesContents(!0))}}result||(result=[])}else{if(kind!=yaml.Kind.ANCHOR_REF)throw new Error("Should never happen; kind : "+yaml.Kind[this._node.kind]);var ref=this._node;result=new ASTNode(ref.value,this._unit,this,null,null,this.cacheChildren).children()}return this.cacheChildren&&(this._children=result),result},ASTNode.prototype.canInclude=function(unit){for(var includedFrom=this.includedFrom();null!=includedFrom;){if(includedFrom.unit().absolutePath()==unit.absolutePath())return!1;includedFrom=includedFrom.includedFrom()}return!0},ASTNode.prototype.directChildren=function(inc,anc,inOneMemberMap){var _this=this;if(void 0===inc&&(inc=null),void 0===anc&&(anc=null),void 0===inOneMemberMap&&(inOneMemberMap=!0),this._node){switch(this._node.kind){case yaml.Kind.SCALAR:return[];case yaml.Kind.MAP:var map=this._node;return 1!=map.mappings.length||inOneMemberMap?map.mappings.map(function(x){return new ASTNode(x,_this._unit,_this,anc?anc:_this._anchor,inc?inc:_this._include)}):new ASTNode(map.mappings[0].value,this._unit,this,inc,anc).directChildren(null,null,!0);case yaml.Kind.MAPPING:var mapping=this._node;return null==mapping.value?[]:new ASTNode(mapping.value,this._unit,this,anc?anc:this._anchor,inc?inc:this._include).directChildren();case yaml.Kind.SEQ:var seq=this._node;return seq.items.filter(function(x){return null!=x}).map(function(x){return new ASTNode(x,_this._unit,_this,anc?anc:_this._anchor,inc?inc:_this._include)});case yaml.Kind.INCLUDE_REF:return[];case yaml.Kind.ANCHOR_REF:return[]}throw new Error("Should never happen; kind : "+yaml.Kind[this._node.kind])}return[]},ASTNode.prototype.anchorId=function(){return this._node.anchorId},ASTNode.prototype.unit=function(){return this._unit},ASTNode.prototype.includeBaseUnit=function(){return this._unit},ASTNode.prototype.setUnit=function(unit){this._unit=unit},ASTNode.prototype.includePath=function(){var includeString=this.getIncludeString();return includeString?includeString:null},ASTNode.prototype.includeReference=function(){var includeString=this.getIncludeString();return includeString?refResolvers.getIncludeReference(includeString):null},ASTNode.prototype.getIncludeString=function(){if(this._node.kind==yaml.Kind.INCLUDE_REF){var includePath=this._node.value;return includePath}if(this._node.kind==yaml.Kind.MAPPING){var mapping=this._node;return null==mapping.value?null:new ASTNode(mapping.value,this._unit,this,null,null).getIncludeString()}return null},ASTNode.prototype.anchoredFrom=function(){return this._anchor},ASTNode.prototype.includedFrom=function(){return this._include},ASTNode.prototype.kind=function(){return this._actualNode().kind},ASTNode.prototype.valueKind=function(){if(this._node.kind!=yaml.Kind.MAPPING)return null;var map=this._node;return map.value?map.value.kind:null},ASTNode.prototype.valueKindName=function(){var kind=this.valueKind();return void 0!=kind?yaml.Kind[kind]:null},ASTNode.prototype.kindName=function(){return yaml.Kind[this.kind()]},ASTNode.prototype.indent=function(lev,str){void 0===str&&(str="");for(var leading="",i=0;i<lev;i++)leading+="  ";return leading+str},ASTNode.prototype.replaceNewlines=function(s,rep){void 0===rep&&(rep=null);for(var res="",i=0;i<s.length;i++){var ch=s[i];"\r"==ch&&(ch=null==rep?"\\r":rep),"\n"==ch&&(ch=null==rep?"\\n":rep),res+=ch}return res},ASTNode.prototype.shortText=function(unittext,maxlen){void 0===maxlen&&(maxlen=50);var elen=this.end()-this.start(),len=elen,unit=this.unit();!unittext&&unit&&(unittext=unit.contents());var text;if(unittext){var s=unittext;text=s?s.substring(this.start(),this.end()):"[no-text]"}else text="[no-unit]";return text="["+this.start()+".."+this.end()+"] "+elen+" // "+text+" //",len<elen&&(text+="..."),text=this.replaceNewlines(text)},ASTNode.prototype.nodeShortText=function(node,unittext,maxlen){void 0===maxlen&&(maxlen=50);var elen=node.endPosition-node.startPosition,len=elen,unit=this.unit();!unittext&&unit&&(unittext=unit.contents());var text;if(unittext){var s=unittext;text=s?s.substring(node.startPosition,node.endPosition):"[no-text]"}else text="[no-unit]";return text="["+node.startPosition+".."+node.endPosition+"] "+elen+" // "+text+" //",len<elen&&(text+="..."),text=this.replaceNewlines(text)},ASTNode.prototype.show=function(message,lev,text){void 0===message&&(message=null),void 0===lev&&(lev=0),void 0===text&&(text=null),message&&0==lev&&console.log(message);var children=this.children(),desc=this.kindName(),val=this._actualNode().value;this.kind()==yaml.Kind.MAPPING&&(desc+="["+this._actualNode().key.value+"]"),desc+=val?"/"+yaml.Kind[val.kind]:"",0==children.length?(console.log(this.indent(lev)+desc+" // "+this.shortText(text)),this.isMapping()&&this.asMapping().value&&console.log(this.indent(lev+1)+"// "+this.valueKindName()+": "+this.nodeShortText(this.asMapping().value,text))):(console.log(this.indent(lev)+desc+" { // "+this.shortText(text)),this.isMapping()&&this.asMapping().value&&console.log(this.indent(lev+1)+"// "+this.valueKindName()+": "+this.nodeShortText(this.asMapping().value,text)),children.forEach(function(node){var n=node;n.show(null,lev+1,text)}),console.log(this.indent(lev)+"}"))},ASTNode.prototype.showParents=function(message,lev){void 0===lev&&(lev=0),message&&0==lev&&console.log(message);var depth=0;if(this.parent()){var n=this.parent();depth=n.showParents(null,lev+1)}var desc=this.kindName(),val=this._actualNode().value;return desc+=val?"/"+yaml.Kind[val.kind]:"/null",console.log(this.indent(depth)+desc+" // "+this.shortText(null)),depth+1},ASTNode.prototype.inlined=function(kind){return kind==yaml.Kind.SCALAR||kind==yaml.Kind.INCLUDE_REF},ASTNode.prototype.markupNode=function(xbuf,node,lev,json){void 0===json&&(json=!1);var start=xbuf.text.length;switch(node.kind){case yaml.Kind.MAP:json&&xbuf.append("{");for(var mappings=node.mappings,i=0;i<mappings.length;i++)json&&i>0&&xbuf.append(", "),this.markupNode(xbuf,mappings[i],lev,json);json&&xbuf.append("}");break;case yaml.Kind.SEQ:for(var items=node.items,i=0;i<items.length;i++)xbuf.append(this.indent(lev,"- ")),this.markupNode(xbuf,items[i],lev+1,json);break;case yaml.Kind.MAPPING:var mapping=node,val=mapping.value;if(json){if(!val){xbuf.append("\n");break}if(xbuf.append(mapping.key.value),xbuf.append(": "),val.kind==yaml.Kind.SCALAR){var sc=val;xbuf.append(sc.value)}else{if(val.kind!=yaml.Kind.MAP)throw new Error("markup not implemented: "+yaml.Kind[val.kind]);this.markupNode(xbuf,mapping.value,lev+1,json)}break}if(xbuf.addWithIndent(lev,mapping.key.value+":"),!val){xbuf.append("\n");break}if(val.kind==yaml.Kind.SCALAR)var sc=val;mapping.value?(xbuf.append(this.inlined(mapping.value.kind)?" ":"\n"),this.markupNode(xbuf,mapping.value,lev+1,json)):xbuf.append("\n");break;case yaml.Kind.SCALAR:var sc=node;if(textutil.isMultiLine(sc.value)){xbuf.append("|\n");for(var lines=splitOnLines(sc.value),i=0;i<lines.length;i++)xbuf.append(this.indent(lev,lines[i]));xbuf.append("\n")}else xbuf.append(sc.value+"\n");break;case yaml.Kind.INCLUDE_REF:var ref=node;xbuf.append("!include "+ref.value+"\n");break;default:throw new Error("Unknown node kind: "+yaml.Kind[node.kind])}for(;start<xbuf.text.length&&" "==xbuf.text[start];)start++;node.startPosition=start,node.endPosition=xbuf.text.length},ASTNode.prototype.markup=function(json){void 0===json&&(json=!1);var buf=new MarkupIndentingBuffer("");return this.markupNode(buf,this._actualNode(),0,json),buf.text},ASTNode.prototype.root=function(){for(var node=this;node.parent();){var p=node.parent();node=p}return node},ASTNode.prototype.parentOfKind=function(kind){for(var p=this.parent();p;){if(p.kind()==kind)return p;p=p.parent()}return null},ASTNode.prototype.find=function(name){var found=null;return this.directChildren().forEach(function(y){y.key()&&y.key()==name&&(found||(found=y))}),found},ASTNode.prototype.shiftNodes=function(offset,shift,exclude){if(this.directChildren().forEach(function(x){if(exclude&&exclude.start()==x.start()&&exclude.end()==x.end());else{x.shiftNodes(offset,shift,exclude)}}),exclude&&exclude.start()==this.start()&&exclude.end()==this.end());else{var yaNode=this._actualNode();yaNode&&innerShift(offset,yaNode,shift)}return null},ASTNode.prototype.isMap=function(){return this.kind()==yaml.Kind.MAP},ASTNode.prototype.isMapping=function(){return this.kind()==yaml.Kind.MAPPING},ASTNode.prototype.isSeq=function(){return this.kind()==yaml.Kind.SEQ},ASTNode.prototype.isScalar=function(){return this.kind()==yaml.Kind.SCALAR},ASTNode.prototype.asMap=function(){if(!this.isMap())throw new Error("map expected instead of "+this.kindName());return this._actualNode()},ASTNode.prototype.asMapping=function(){if(!this.isMapping())throw new Error("maping expected instead of "+this.kindName());return this._actualNode()},ASTNode.prototype.asSeq=function(){if(!this.isSeq())throw new Error("seq expected instead of "+this.kindName());return this._actualNode()},ASTNode.prototype.asScalar=function(){if(!this.isScalar())throw new Error("scalar expected instead of "+this.kindName());return this._actualNode()},ASTNode.prototype.isValueSeq=function(){return this.valueKind()==yaml.Kind.SEQ},ASTNode.prototype.isValueMap=function(){return this.valueKind()==yaml.Kind.MAP},ASTNode.prototype.isValueInclude=function(){return this.valueKind()==yaml.Kind.INCLUDE_REF},ASTNode.prototype.isValueScalar=function(){return this.valueKind()==yaml.Kind.SCALAR},ASTNode.prototype.valueAsSeq=function(){if(!this.isMapping())throw new Error("mapping expected instead of "+this.kindName());if(this.valueKind()!=yaml.Kind.SEQ)throw new Error("mappng/seq expected instead of mapping/"+this.kindName());return this.asMapping().value},ASTNode.prototype.valueAsMap=function(){if(!this.isMapping())throw new Error("mapping expected instead of "+this.kindName());if(this.valueKind()!=yaml.Kind.MAP)throw new Error("mappng/map expected instead of mapping/"+this.kindName());return this.asMapping().value},ASTNode.prototype.valueAsScalar=function(){if(!this.isMapping())throw new Error("mapping expected instead of "+this.kindName());if(this.valueKind()!=yaml.Kind.SCALAR)throw new Error("mappng/scalar expected instead of mapping/"+this.kindName());return this.asMapping().value},ASTNode.prototype.valueAsInclude=function(){if(!this.isMapping())throw new Error("mapping expected instead of "+this.kindName());if(this.valueKind()!=yaml.Kind.INCLUDE_REF)throw new Error("mappng/include expected instead of mapping/"+this.kindName());return this.asMapping().value},ASTNode.prototype.text=function(unitText){if(void 0===unitText&&(unitText=null),!unitText){if(!this.unit())return"[no-text]";unitText=this.unit().contents()}return unitText.substring(this.start(),this.end())},ASTNode.prototype.copy=function(){var yn=copyNode(this._actualNode());return new ASTNode(yn,this._unit,this._parent,this._anchor,this._include,this._includesContents)},ASTNode.prototype.nodeDefinition=function(){return getDefinitionForLowLevelNode(this)},ASTNode}();exports.ASTNode=ASTNode,function(InsertionPointType){InsertionPointType[InsertionPointType.NONE=0]="NONE",InsertionPointType[InsertionPointType.START=1]="START",InsertionPointType[InsertionPointType.END=2]="END",InsertionPointType[InsertionPointType.POINT=3]="POINT"}(exports.InsertionPointType||(exports.InsertionPointType={}));var InsertionPointType=exports.InsertionPointType,InsertionPoint=function(){function InsertionPoint(type,point){void 0===point&&(point=null),this.type=type,this.point=point}return InsertionPoint.after=function(point){return new InsertionPoint(InsertionPointType.POINT,point)},InsertionPoint.atStart=function(){return new InsertionPoint(InsertionPointType.START)},InsertionPoint.atEnd=function(){return new InsertionPoint(InsertionPointType.END)},InsertionPoint.node=function(){return new InsertionPoint(InsertionPointType.NONE)},InsertionPoint.prototype.show=function(msg){msg?(console.log(msg),console.log("  insertion point type: "+InsertionPointType[this.type])):console.log("insertion point type: "+InsertionPointType[this.type]),this.type==InsertionPointType.POINT&&this.point&&this.point.show()},InsertionPoint}();exports.InsertionPoint=InsertionPoint,exports.createNode=createNode,exports.createMap=createMap,exports.createScalar=createScalar,exports.createSeq=createSeq,exports.createSeqNode=createSeqNode,exports.createMapNode=createMapNode,exports.createMapping=createMapping,exports.toChildCachingNode=toChildCachingNode,exports.toIncludingNode=toIncludingNode,exports.getDefinitionForLowLevelNode=getDefinitionForLowLevelNode,exports.fetchIncludesAndMasterAsync=fetchIncludesAndMasterAsync},function(module,exports,__webpack_require__){"use strict";function hasAsyncRequests(){return Object.keys(notifies).length>0}function addLoadCallback(listener){nlisteners.push(listener)}function addNotify(url){notifies[url]=!0}function removeNotity(url){delete notifies[url],nlisteners.forEach(function(x){return x(url)})}function isWaitingFor(url){return!!notifies[url]}function set(url,content){globalCache.set(url,content)}function get(url){return globalCache.get(url)}__webpack_require__(64);__webpack_require__(65),__webpack_require__(74);var lru=__webpack_require__(73),globalCache=lru(50);exports.hasAsyncRequests=hasAsyncRequests,exports.addLoadCallback=addLoadCallback;var nlisteners=[],notifies={};exports.addNotify=addNotify,exports.removeNotity=removeNotity,exports.isWaitingFor=isWaitingFor,exports.set=set,exports.get=get},function(module,exports,__webpack_require__){"use strict";function getIncludePath(includeString){if(!includeString)return includeString;var index=includeString.indexOf("#");return index==-1?includeString:includeString.substring(0,index)}function getIncludeReference(includeString){if(!includeString)return null;"string"!=typeof includeString&&(includeString=""+includeString);var index=includeString.indexOf("#");if(index==-1)return null;var referenceString=index==includeString.length-1?"":includeString.substring(index+1,includeString.length),segments=referenceString.split("/");return 0==segments.length?null:(""==segments[0].trim()&&segments.splice(0,1),new IncludeReferenceImpl(referenceString,getIncludePath(includeString),segments))}function getIncludeReferenceResolvers(){return[new JSONResolver,new XMLResolver]}function resolveContents(includeString,content){if(!includeString)return content;var reference=getIncludeReference(includeString);if(!reference)return content;var includePath=getIncludePath(includeString);return resolve(includePath,reference,content).content}function resolve(includePath,includeReference,content){var resolver=_.find(getIncludeReferenceResolvers(),function(currentResolver){return currentResolver.isApplicable(includePath,content)});return resolver?resolver.resolveReference(content,includeReference):{content:content,validation:[]}}function completeReference(includePath,includeReference,content){if(!content)return[];var resolver=_.find(getIncludeReferenceResolvers(),function(currentResolver){return currentResolver.isApplicable(includePath,content)});return resolver?resolver.completeReference(content,includeReference):[]}function endsWith(input,ends){return!!input&&(!!ends&&input.lastIndexOf(ends)===input.length-ends.length)}function elementChildrenByName(parent,tagName){for(var elements=parent.getElementsByTagName(tagName),result=[],i=0;i<elements.length;i++){var child=elements[i];child.parentNode===parent&&result.push(child)}return result}var _=__webpack_require__(61),DOMParser=__webpack_require__(75).DOMParser,base64=__webpack_require__(66);exports.getIncludePath=getIncludePath,exports.getIncludeReference=getIncludeReference,exports.getIncludeReferenceResolvers=getIncludeReferenceResolvers,exports.resolveContents=resolveContents,exports.resolve=resolve,exports.completeReference=completeReference;var IncludeReferenceImpl=function(){function IncludeReferenceImpl(originalString,includePath,segments){this.includePath=includePath,this.segments=segments,this.originalString=originalString}return IncludeReferenceImpl.prototype.getIncludePath=function(){return this.includePath},IncludeReferenceImpl.prototype.getFragments=function(){return this.segments},IncludeReferenceImpl.prototype.asString=function(){return this.originalString},IncludeReferenceImpl.prototype.encodedName=function(withExtention){return void 0===withExtention&&(withExtention=!0),base64(this.includePath+"/"+this.asString())+(withExtention?this.includePath.substring(this.includePath.lastIndexOf(".")):"")},IncludeReferenceImpl}(),JSONResolver=function(){function JSONResolver(){}return JSONResolver.prototype.isApplicable=function(includePath,content){return includePath&&(endsWith(includePath.trim(),".js")||endsWith(includePath.trim(),".json"))},JSONResolver.prototype.resolveReference=function(content,reference){try{var resultJson={};return resultJson.$ref=reference.getIncludePath()+"#"+reference.asString(),{content:JSON.stringify(resultJson,null,2),validation:[]}}catch(Error){console.log(Error)}return{content:content,validation:[]}},JSONResolver.prototype.completeReference=function(content,reference){try{var jsonRoot=JSON.parse(content),fragments=reference.getFragments();if(!fragments||0==fragments.length)return this.getChildren(jsonRoot);for(var currentJSON=jsonRoot,emptyPrefixCompletion=reference.asString().lastIndexOf("/")==reference.asString().length-1,i=(emptyPrefixCompletion?fragments.length:fragments.length-1,0);i<fragments.length-1;i++){var fragment=fragments[i];if(currentJSON=this.findChild(currentJSON,fragment),!currentJSON)return[]}if(emptyPrefixCompletion)return this.getChildren(currentJSON);var lastPrefix=fragments[fragments.length-1],result=[];return this.getChildren(currentJSON).forEach(function(child){0==child.indexOf(lastPrefix)&&result.push(child)}),result}catch(Error){console.log(Error)}return[]},JSONResolver.prototype.findChild=function(jsonObject,fragment){var decoded=fragment.replace("~1","/");return decoded=fragment.replace("~0","~"),jsonObject[decoded]},JSONResolver.prototype.getChildren=function(jsonObject){return Object.keys(jsonObject)},JSONResolver}(),XMLResolver=function(){function XMLResolver(){}return XMLResolver.prototype.isApplicable=function(includePath,content){return includePath&&(endsWith(includePath.trim(),".xml")||endsWith(includePath.trim(),".xsd"))},XMLResolver.prototype.resolveReference=function(content,reference){try{var doc=(new DOMParser).parseFromString(content),requestedName=reference.asString(),uniqueName=reference.encodedName(!1),schema=elementChildrenByName(doc,"xs:schema")[0],elements=elementChildrenByName(schema,"xs:element"),types=elementChildrenByName(schema,"xs:complexType"),canBeElement=_.find(elements,function(element){return element.getAttribute("name")===requestedName}),canBeType=canBeElement?_.find(types,function(type){return type.getAttribute("name")===canBeElement.getAttribute("type")}):_.find(types,function(type){return type.getAttribute("name")===requestedName}),element=doc.createElement("xs:element");return element.setAttribute("name",uniqueName),canBeType&&element.setAttribute("type",canBeType.getAttribute("name")),canBeElement&&element.setAttribute("originalname",canBeElement.getAttribute("name")),element.setAttribute("requestedname",requestedName),element.setAttribute("extraelement","true"),schema.appendChild(element),{content:doc.toString(),validation:[]}}catch(throwable){console.log(throwable)}return{content:content,validation:[]}},XMLResolver.prototype.completeReference=function(content,reference){try{var doc=(new DOMParser).parseFromString(content),result=[],schema=elementChildrenByName(doc,"xs:schema")[0],elements=elementChildrenByName(schema,"xs:element"),types=elementChildrenByName(schema,"xs:complexType");elements.forEach(function(element){return result.push(element.getAttribute("name"))}),types.forEach(function(type){return result.push(type.getAttribute("name"))});var emptyPrefixCompletion=0===reference.asString().trim().length;return emptyPrefixCompletion?result:result.filter(function(value){return 0===value.indexOf(reference.asString())})}catch(exception){return[]}},XMLResolver}()},function(module,exports,__webpack_require__){"use strict";function isWebPath(str){return ll.isWebPath(str)}var path=__webpack_require__(15),ll=__webpack_require__(11),resourceRegistry=__webpack_require__(28),ContentProvider=function(){function ContentProvider(unit){this.unit=unit}return ContentProvider.prototype.contextPath=function(){if(!this.unit)return"";var rootPath=this.unit.absolutePath();return rootPath||""},ContentProvider.prototype.normalizePath=function(url){if(!url)return url;var result;if(isWebPath(url)){var prefix=0===url.toLowerCase().indexOf("https")?"https://":"http://";result=prefix+path.normalize(url.substring(prefix.length)).replace(/\\/g,"/")}else result=path.normalize(url).replace(/\\/g,"/");return result},ContentProvider.prototype.content=function(reference){var normalized=this.normalizePath(reference),unitPath=this.toRelativeIfNeeded(normalized),unit=this.unit.resolve(unitPath);return unit?unit.contents()||"":""},ContentProvider.prototype.contentAsync=function(reference){var normaized=this.normalizePath(reference),unitPath=this.toRelativeIfNeeded(normaized),unitPromise=this.unit.resolveAsync(unitPath);if(!unitPromise)return Promise.resolve("");var result=unitPromise.then(function(unit){return unit&&unit.contents()||""});return result},ContentProvider.prototype.toRelativeIfNeeded=function(normaized){var unitPath=normaized;return path.isAbsolute(normaized)&&!isWebPath(normaized)&&(unitPath=path.relative(path.dirname(this.unit.absolutePath()),normaized)),unitPath},ContentProvider.prototype.hasAsyncRequests=function(){return resourceRegistry.hasAsyncRequests()},ContentProvider.prototype.resolvePath=function(context,relativePath){return ll.buildPath(relativePath,context,this.unit.project().getRootPath())},ContentProvider.prototype.isAbsolutePath=function(uri){return!!uri&&(!!isWebPath(uri)||path.isAbsolute(uri))},ContentProvider.prototype.promiseResolve=function(arg){return Promise.resolve(arg)},ContentProvider}();exports.ContentProvider=ContentProvider},function(module,exports,__webpack_require__){"use strict";function flattenArrayOfObjects(x){var res={};return x.forEach(function(v){return Object.keys(v).forEach(function(k){return res[k]=v[k]})}),res}function find(xs,f){return new Opt(_.find(xs||[],f))}function toTuples(map){return Object.keys(map).map(function(k){return[k,map[k]]})}function fromTuples(tuples){var obj={};return tuples.forEach(function(x){return obj[x[0]]=x[1]}),obj}function tap(v,f){return f(v),v}function kv(obj,iter){"object"==typeof obj&&Object.keys(obj).forEach(function(k){return iter(k,obj[k])})}function indexed(objects,key,delKey){void 0===delKey&&(delKey=!1);var obj={};return objects.forEach(function(original){var copy=exports.shallowCopy(original);delKey&&delete copy[key],obj[original[key]]=copy}),obj}function stringEndsWith(str,search){var dif=str.length-search.length;return dif>=0&&str.lastIndexOf(search)===dif}function stringStartsWith(str,search,ind){return void 0===ind&&(ind=0),str.length-search.length>=ind&&str.substring(ind,ind+search.length)===search}function lazypropkeyfilter(k){return"_"==k[k.length-1]}function lazyprop(obj,key,func){var result,ready=!1;obj[key]=function(){return ready||(ready=!0,result=func.apply(obj)),result}}function lazyprops(obj,keyfilter){void 0===keyfilter&&(keyfilter=lazypropkeyfilter);for(var k in obj)keyfilter(k)&&exports.ifInstanceOf(obj[k],Function,function(vf){return 0===vf.length?lazyprop(obj,k,vf):null})}function iff(v,f){void 0!==v&&f(v)}function isRAMLUrl(str){return"string"==typeof str&&""!=str&&stringEndsWith(str,".raml")}function getAllRequiredExternalModulesFromCode(code){for(var match,mods=[],r1=new RegExp("require\\('([^']+)'\\)","gi");match=r1.exec(code);)mods.push(match[1]);for(var r2=new RegExp('require\\("([^"]+)"\\)',"gi");match=r2.exec(code);)mods.push(match[1]);return mods=_.unique(mods).filter(function(x){return""!=x;
}),mods.sort(),mods}function isEssential(arg){return"undefined"!=typeof arg&&null!=arg}function firstToUpper(q){return 0==q.length?q:q.charAt(0).toUpperCase()+q.substr(1)}function updateObject(source,target,addNewFields){void 0===addNewFields&&(addNewFields=!1);var keySet=Object.keys(target);if(addNewFields){var map={};keySet.forEach(function(x){return map[x]=!0}),Object.keys(source).forEach(function(x){return map[x]=!0}),keySet=Object.keys(map)}keySet.forEach(function(x){var value=source[x];value instanceof Object?(target[x]||(target[x]={}),updateObject(value,target[x],!0)):void 0!=value&&(target[x]=source[x])})}function replaceMap(str,map){return Object.keys(map).forEach(function(x){return str=replace(str,x,map[x])}),str}function replace(str,x,r){for(var result="",prev=0,i=str.indexOf(x);i<str.length&&i>=0;i=str.indexOf(x,prev))result+=str.substring(prev,i),result+=r,prev=i+x.length;return result+=str.substring(prev,str.length)}var _=__webpack_require__(61),Opt=__webpack_require__(21);exports.defined=function(x){return null!==x&&void 0!==x},exports.flattenArrayOfObjects=flattenArrayOfObjects,exports.find=find,exports.isInstance=function(v,C){return v instanceof C?[v]:[]},exports.ifInstanceOf=function(v,C,f){return v instanceof C?f(v):null},exports.toTuples=toTuples,exports.fromTuples=fromTuples,exports.collectInstancesOf=function(xs,C){return tap([],function(res){return xs.forEach(function(v){return exports.ifInstanceOf(v,C,function(x){return res.push(x)})})})},exports.collectInstancesOfInMap=function(map,C){return Object.keys(map).map(function(k){return[k,map[k]]}).filter(function(x){return x[1]instanceof C}).map(function(x){return x})},exports.asArray=function(v){return exports.defined(v)?v instanceof Array?v:[v]:[]},exports.shallowCopy=function(obj){return tap({},function(copy){return Object.keys(obj).forEach(function(k){return copy[k]=obj[k]})})},exports.flatMap=function(xs,f){return exports.flatten(xs.map(f))},exports.flatten=function(xss){return Array.prototype.concat.apply([],xss)},exports.takeWhile=function(xs,f){return tap([],function(res){for(var i=0;i<xs.length&&f(xs[i]);i++)res.push(xs[i])})},exports.tap=tap,exports.kv=kv,exports.indexed=indexed,exports.stringEndsWith=stringEndsWith,exports.stringStartsWith=stringStartsWith,exports.lazypropkeyfilter=lazypropkeyfilter,exports.lazyprops=lazyprops,exports.iff=iff,exports.isRAMLUrl=isRAMLUrl,exports.getAllRequiredExternalModulesFromCode=getAllRequiredExternalModulesFromCode,exports.serial=function(){var i=0;return function(){return i++}}(),exports.isEssential=isEssential,exports.firstToUpper=firstToUpper,exports.updateObject=updateObject,exports.replaceMap=replaceMap,exports.replace=replace},function(module,exports,__webpack_require__){"use strict";function resolveType(p){return p.highLevel().localType()}function runtimeType(p){return p.highLevel().localType()}function load(pth){var m=new ll.Project(path.dirname(pth)),unit=m.unit(path.basename(pth));return unit&&unit.isRAMLUnit()?hlimpl.fromUnit(unit).wrapperNode():null}function completeRelativeUri(res){var uri="",parent=res;do res=parent,uri=res.relativeUri().value()+uri,parent=res.parent();while(parent.definition().key().name==universes.Universe10.Resource.name);return uri}function expandTraitsAndResourceTypes(api){var lowLevelNode=api.highLevel().lowLevel();return lowLevelNode instanceof lowLevelProxy.LowLevelProxyNode?api:expander.expandTraitsAndResourceTypes(api)}function absoluteUri(res){var uri="",parent=res;do res=parent,uri=res.relativeUri().value()+uri,parent=res.parent();while(parent.definition().key().name==universes.Universe10.Resource.name);uri=uri.replace(/\/\//g,"/");var buri=parent.baseUri(),base=buri?buri.value():"";return base=base?base:"",util.stringEndsWith(base,"/")&&(uri=uri.substring(1)),uri=base+uri}function validateInstance(res,value){return res.runtimeType().validate(value).map(function(x){return x.getMessage()})}function validateInstanceWithDetailedStatuses(res,value){return res.runtimeType().validate(value)}function traitsPrimary(a){return allTraits(a)}function allTraits(a){return findTemplates(a,function(d){return universeHelpers.isTraitType(d)})}function resourceTypesPrimary(a){return allResourceTypes(a)}function allResourceTypes(a){return findTemplates(a,function(d){return universeHelpers.isResourceTypeType(d)})}function findTemplates(a,filter){var arr=search.globalDeclarations(a.highLevel()).filter(function(x){return filter(x.definition())}),ll=a.highLevel().lowLevel(),nodePath=ll.includePath();nodePath||(nodePath=ll.unit().path());var isProxy=a.highLevel().lowLevel()instanceof proxy.LowLevelProxyNode,exp=isProxy?new expander.TraitsAndResourceTypesExpander:null,topLevelArr=arr.map(function(x){var topLevelNode,p=x.lowLevel().unit().path();return isProxy&&(x.lowLevel()instanceof proxy.LowLevelProxyNode||(x=exp.createHighLevelNode(x,!1)),(new referencePatcher.ReferencePatcher).process(x,a.highLevel(),!0,!0)),p!=nodePath?(topLevelNode=factory.buildWrapperNode(x,!1),topLevelNode.meta().setCalculated()):topLevelNode=x.wrapperNode(),topLevelNode});return topLevelArr}function relativeUriSegments(res){var result=[],parent=res;do res=parent,result.push(res.relativeUri().value()),parent=res.parent();while(parent.definition().key().name==universes.Universe10.Resource.name);return result.reverse()}function parentResource(method){return method.parent()instanceof RamlWrapperImpl.ResourceImpl?method.parent():null}function parent(resource){var parent=resource.parent();return parent.definition().key().name==universes.Universe10.Resource.name?parent:null}function childResource(container,relPath){if(null==container)return null;var resources=container.resources();return resources?(resources=resources.filter(function(x){return x.relativeUri().value()==relPath}),0==resources.length?null:resources[0]):null}function getResource(container,path){if(!container)return null;for(var res=null,i=0;i<path.length;i++){if(res=childResource(container,path[i]),!res)return null;container=res}return res}function childMethod(resource,method){return resource?resource.methods().filter(function(x){return x.method()==method}):null}function getMethod(container,path,method){var resource=getResource(container,path);return resource?childMethod(resource,method):null}function isApi(obj){return universeHelpers.isApiSibling(obj.definition())}function ownerApi(method){for(var obj=method;!isApi(obj);)obj=obj.parent();return obj}function methodId(method){var parent=method.parent();if(parent instanceof RamlWrapperImpl.ResourceImpl)return completeRelativeUri(parent)+" "+method.method().toLowerCase();if(parent instanceof RamlWrapperImpl.ResourceTypeImpl)return parent.name()+" "+method.method().toLowerCase();throw new Error("Method is supposed to be owned by Resource or ResourceType.\nHere the method is owned by "+method.definition().key().name)}function isOkRange(response){var str=response.code().value(),err=linter.validateResponseString(str);if(null!=err)return!1;try{if(parseInt(str.charAt(0))<4)return!0}catch(e){}return!1}function allResources(api){var resources=[],visitor=function(res){resources.push(res),res.resources().forEach(function(x){return visitor(x)})};return api.resources().forEach(function(x){return visitor(x)}),resources}function matchUri(apiRootRelativeUri,resource){for(var allParameters={};null!=resource;)uriParameters(resource).forEach(function(x){return allParameters[x.name()]=new ParamWrapper(x)}),resource=parent(resource);var result=ramlPathMatch.ramlPathMatch(completeRelativeUri(resource),allParameters,{})(apiRootRelativeUri);return result?new Opt(Object.keys(result.params).map(function(x){return new ParamValue(x,result.params[x])})):Opt.empty()}function uriParametersPrimary(resource){return uriParameters(resource)}function uriParameters(resource){var params=resource.uriParameters_original();if(!(resource instanceof RamlWrapperImpl.ResourceImpl))return params;var uri=resource.relativeUri().value(),propName=universes.Universe10.ResourceBase.properties.uriParameters.name;return extractParams(params,uri,resource,propName)}function baseUriParametersPrimary(api){return baseUriParameters(api)}function baseUriParameters(api){var uri=api.baseUri()?api.baseUri().value():"",params=api.baseUriParameters_original(),propName=universes.Universe10.Api.properties.baseUriParameters.name;return extractParams(params,uri,api,propName)}function absoluteUriParameters(res){var params=[],parent=res;do res=parent,params=uriParameters(res).concat(params),parent=res.parent();while(parent.definition().key().name==universes.Universe10.Resource.name);var api=parent;api.baseUriParameters();return params=baseUriParameters(api).concat(params)}function protocolsPrimary(api){return allProtocols(api)}function allProtocols(api){return api.protocols().map(function(x){return x.toUpperCase()})}function securedByPrimary(resourceOrMethod){return allSecuredBy(resourceOrMethod)}function allSecuredBy(resourceOrMethod){return resourceOrMethod.securedBy()}function securitySchemeName(schemeReference){var highLevel=schemeReference.highLevel();if(!highLevel)return"";var attributeValue=highLevel.value();return attributeValue?attributeValue.toString():""}function securityScheme(schemeReference){var highLevel=schemeReference.highLevel();if(!highLevel)return null;var declaration=search.findDeclarationByNode(highLevel,search.LocationKind.VALUE_COMPLETION);if(!declaration)return null;if(!declaration.getKind||declaration.getKind()!=hl.NodeKind.NODE)return null;var result=declaration.wrapperNode();return result instanceof RamlWrapperImpl.AbstractSecuritySchemeImpl?result:null}function RAMLVersion(api){return api.highLevel().definition().universe().version()}function structuredValue(reference){var llNode=reference.value().lowLevel(),type=null,hlNode=llNode.highLevelParseResult();if(hlNode){var types=null,isAnnotations=!1;if(hlNode.isAttr()?(isAnnotations=universeHelpers.isAnnotationsProperty(hlNode.property()),types=hlNode.parent().types()):hlNode.isElement()&&(types=hlNode.asElement().types()),types){var refName=reference.name(),fromLib=refName.indexOf(".")>=0;if(fromLib){var reg=isAnnotations?types.getAnnotationTypeRegistry():types.getTypeRegistry();type=reg.get(refName)}else type=isAnnotations?types.getAnnotationType(refName):types.getType(refName)}}return new core.TypeInstanceImpl(llNode,type)}function referenceName(reference){var val=reference.highLevel().value();return"string"==typeof val||null==val?val:val.valueName()}function referencedTrait(ref){return referencedObject(ref)}function referencedAnnotation(ref){return referencedObject(ref)}function referencedResourceType(ref){return referencedObject(ref)}function referencedObject(ref){var attr=ref.highLevel(),parent=attr.parent(),vn=ref.name(),cands=search.referenceTargets(attr.property(),parent).filter(function(x){return hlimpl.qName(x,parent)==vn});return 0==cands.length?null:cands[0].wrapperNode()}function examplesFromNominal(runtimeDefinition,hlParent,isSingle,patchHL){void 0===patchHL&&(patchHL=!0);var llParent=hlParent.lowLevel(),property=hlParent.definition().property(isSingle?"example":"examples"),universe=defs.getUniverse("RAML10"),definition=universe.type(universeDef.Universe10.ExampleSpec.name),expandables=runtimeDefinition.examples().filter(function(x){return!x.isEmpty()&&x.isSingle()==isSingle});return expandables.map(function(x){var obj=x.asJSON(),key=x.isSingle()?"example":null,jsonNode=new json.AstNode(llParent.unit(),obj,llParent,null,key),hlNode=patchHL?new hlimpl.ASTNodeImpl(jsonNode,hlParent,definition,property):hlParent,wrapperAnnotations=[],annotations=x.annotations();if(annotations)for(var aProp=universe.type("Annotable").property("annotations"),_i=0,_a=Object.keys(annotations);_i<_a.length;_i++){var aName=_a[_i],aObj=annotations[aName],aJson=new json.AstNode(llParent.unit(),aObj,jsonNode,null,"("+aName+")"),aHlNode=new hlimpl.ASTPropImpl(aJson,hlNode,aProp.range(),aProp),wAnnotation=new RamlWrapperImpl.AnnotationRefImpl(aHlNode);wrapperAnnotations.push(wAnnotation)}return new ExampleSpecImpl(hlNode,x,wrapperAnnotations)})}function getExpandableExamples(node,isSingle){void 0===isSingle&&(isSingle=!1);var runtimeDefinition=node.runtimeDefinition();if(!runtimeDefinition)return[];var hlParent=node.highLevel();return examplesFromNominal(runtimeDefinition,hlParent,isSingle)}function getTypeExample(td){var examples=getExpandableExamples(td,!0);return examples.length>0?examples[0]:null}function getTypeExamples(td){return getExpandableExamples(td)}function typeFixedFacets(td){var rDef=td.runtimeDefinition(),obj=rDef.getFixedFacets(),keys=Object.keys(obj);if(td.kind()!=universeDef.Universe10.UnionTypeDeclaration.name)for(var _i=0,keys_1=keys;_i<keys_1.length;_i++){var key=keys_1[_i];null==rDef.facet(key)&&delete obj[key]}if(0==Object.keys(obj).length)return null;var node=new json.AstNode(null,obj);return new core.TypeInstanceImpl(node)}function typeValue(typeDeclaration){var attrs=typeDeclaration.highLevel().attributes(defs.universesInfo.Universe10.TypeDeclaration.properties.type.name),structuredAttrs=attrs.filter(function(x){return x.value()instanceof hlimpl.StructuredValue});if(0==structuredAttrs.length)return typeDeclaration.type_original().map(function(x){return null===x||"NULL"===x||"Null"===x?"string":x});var nullify=!1,values=attrs.map(function(x){var val=x.value();return null==val?null:"string"==typeof val?val:(val instanceof hlimpl.StructuredValue&&(nullify=!0),val.toString())});return nullify?null:values}function schemaValue(typeDeclaration){var nullify=!1,attrs=typeDeclaration.highLevel().attributes(defs.universesInfo.Universe10.TypeDeclaration.properties.schema.name);if(nullify)return null;var structuredAttrs=attrs.filter(function(x){return x.value()instanceof hlimpl.StructuredValue});if(0==structuredAttrs.length)return typeDeclaration.schema_original();var values=attrs.map(function(x){var val=x.value();return"string"==typeof val?val:(val instanceof hlimpl.StructuredValue&&(nullify=!0),val.toString())});return nullify?null:values}function typeStructuredValue(typeDeclaration){var attrs=typeDeclaration.highLevel().attributes(defs.universesInfo.Universe10.TypeDeclaration.properties.type.name);attrs=attrs.concat(typeDeclaration.highLevel().attributes(defs.universesInfo.Universe10.TypeDeclaration.properties.schema.name));for(var values=attrs.map(function(x){return x.value()}),_i=0,values_1=values;_i<values_1.length;_i++){var val=values_1[_i];if(val instanceof hlimpl.StructuredValue){var typeInstance=new core.TypeInstanceImpl(val.lowLevel());return typeInstance}}return null}function referencedNode(usesDecl){var ref=usesDecl.value(),unit=usesDecl.highLevel().lowLevel().unit().resolve(ref),hlNode=unit.highLevel(),hlElement=hlNode.asElement();if(hlElement){var wrapperNode=hlElement.wrapperNode();return RamlWrapper.isLibrary(wrapperNode)?(wrapperNode.setAttributeDefaults(usesDecl.attributeDefaults()),wrapperNode):null}return null}function getItems(arrayTypeDecl){return arrayTypeDecl.items_original()}function findComponentTypeDeclBySearch(arrayTypeDecl){var typeHighLevel=arrayTypeDecl.highLevel();if(!typeHighLevel)return null;var attrType=typeHighLevel.attr(universes.Universe10.TypeDeclaration.properties.type.name);if(null==attrType)return null;var attrTypeLowLevel=attrType.lowLevel();if(null==attrTypeLowLevel)return null;var attrTypeValue=attrType.value();if(!attrTypeValue||"string"!=typeof attrTypeValue)return null;var offset=attrTypeLowLevel.end()-attrTypeValue.length+1,unit=attrType.lowLevel().unit();if(!unit)return null;var declaration=search.findDeclaration(unit,offset);return declaration&&declaration.getKind&&declaration.getKind()==hl.NodeKind.NODE&&universeHelpers.isTypeDeclarationSibling(declaration.definition())?declaration.wrapperNode():null}function findComponentTypeDeclByRuntimeType(arrayTypeDecl){var runtimeType=arrayTypeDecl.runtimeType();if(!runtimeType)return null;if(!runtimeType.isArray()||!runtimeType.componentType)return null;var runtimeArrayType=runtimeType,componentType=runtimeArrayType.componentType();if(!componentType)return null;var componentTypeHLSourceProvider=sourceFinder.getNominalTypeSource(componentType);if(!componentTypeHLSourceProvider)return null;var componentTypeSource=componentTypeHLSourceProvider.getSource();if(!componentTypeSource)return null;if(!componentTypeSource.isElement())return null;if(!universeHelpers.isTypeDeclarationSibling(componentTypeSource.definition()))return null;var basicNodeSource=componentTypeSource.wrapperNode();return basicNodeSource}function findComponentTypeDeclaration(arrayTypeDecl){var original=arrayTypeDecl.items_original();if(original)return original;var foundByRuntimeType=findComponentTypeDeclByRuntimeType(arrayTypeDecl);return foundByRuntimeType?foundByRuntimeType:findComponentTypeDeclBySearch(arrayTypeDecl)}function extractParams(params,uri,owner,propName){var ownerHl=owner.highLevel(),definition=ownerHl.definition(),prop=definition.property(propName);if(!uri)return[];var describedParams={};params.forEach(function(x){var arr=describedParams[x.name()];arr||(arr=[],describedParams[x.name()]=arr),arr.push(x)});for(var allParams=[],prev=0,mentionedParams={},i=uri.indexOf("{");i>=0&&(prev=uri.indexOf("}",++i),!(prev<0));i=uri.indexOf("{",prev)){var paramName=uri.substring(i,prev);if(mentionedParams[paramName]=!0,describedParams[paramName])describedParams[paramName].forEach(function(x){return allParams.push(x)});else{var universe=definition.universe(),nc=universe.type(universeDef.Universe10.StringTypeDeclaration.name),node=stubs.createStubNode(nc,null,paramName),uriParameter=factory.buildWrapperNode(node),hlNode=uriParameter.highLevel();hlNode.setParent(ownerHl),uriParameter.meta().setCalculated(),uriParameter.setName(paramName),hlNode.patchProp(prop),allParams.push(uriParameter)}}return Object.keys(describedParams).filter(function(x){return!mentionedParams[x]}).forEach(function(x){return describedParams[x].forEach(function(y){return allParams.push(y)})}),allParams}function getTemplateParametrizedProperties(node){if(node.kind()==universeDef.Universe10.Method.name||universeHelpers.isTypeDeclarationSibling(node.definition())){for(var isInsideTemplate=!1,parent=node.highLevel().parent();null!=parent;){var pDef=parent.definition();if(universeHelpers.isResourceTypeType(pDef)||universeHelpers.isTraitType(pDef)){isInsideTemplate=!0;break}parent=parent.parent()}if(!isInsideTemplate)return null}var highLevelNode=node.highLevel();if(null==highLevelNode)return null;var lowLevelNode=highLevelNode.lowLevel();if(null==lowLevelNode)return null;var children=lowLevelNode.children().filter(function(x){var key=x.key();return!!key&&(("("!=key.charAt(0)||")"!=key.charAt(key.length-1))&&key.indexOf("<<")>=0)});if(0==children.length)return null;var result=new core.TypeInstanceImpl(children);return result}var __extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},RamlWrapper=__webpack_require__(12),RamlWrapperImpl=__webpack_require__(20),factory=__webpack_require__(42),core=__webpack_require__(45),ramlPathMatch=__webpack_require__(55),hl=__webpack_require__(10),hlimpl=__webpack_require__(16),linter=__webpack_require__(25),stubs=__webpack_require__(17),defs=__webpack_require__(36),universeDef=__webpack_require__(22),universes=__webpack_require__(22),Opt=__webpack_require__(21),util=__webpack_require__(31),expander=__webpack_require__(24),proxy=__webpack_require__(38),referencePatcher=__webpack_require__(49),lowLevelProxy=__webpack_require__(38),search=__webpack_require__(23),ll=__webpack_require__(27),json=__webpack_require__(50),path=__webpack_require__(15),universeHelpers=__webpack_require__(14),sourceFinder=__webpack_require__(46);exports.resolveType=resolveType,exports.runtimeType=runtimeType,exports.load=load,exports.completeRelativeUri=completeRelativeUri,exports.expandTraitsAndResourceTypes=expandTraitsAndResourceTypes,exports.absoluteUri=absoluteUri,exports.validateInstance=validateInstance,exports.validateInstanceWithDetailedStatuses=validateInstanceWithDetailedStatuses,exports.traitsPrimary=traitsPrimary,exports.allTraits=allTraits,exports.resourceTypesPrimary=resourceTypesPrimary,exports.allResourceTypes=allResourceTypes,exports.relativeUriSegments=relativeUriSegments,exports.parentResource=parentResource,exports.parent=parent,exports.childResource=childResource,exports.getResource=getResource,exports.childMethod=childMethod,exports.getMethod=getMethod,exports.ownerApi=ownerApi,exports.methodId=methodId,exports.isOkRange=isOkRange,exports.allResources=allResources,exports.matchUri=matchUri;exports.uriParametersPrimary=uriParametersPrimary,exports.uriParameters=uriParameters,exports.baseUriParametersPrimary=baseUriParametersPrimary,exports.baseUriParameters=baseUriParameters,exports.absoluteUriParameters=absoluteUriParameters,exports.protocolsPrimary=protocolsPrimary,exports.allProtocols=allProtocols,exports.securedByPrimary=securedByPrimary,exports.allSecuredBy=allSecuredBy,exports.securitySchemeName=securitySchemeName,exports.securityScheme=securityScheme,exports.RAMLVersion=RAMLVersion,exports.structuredValue=structuredValue,exports.referenceName=referenceName,exports.referencedTrait=referencedTrait,exports.referencedAnnotation=referencedAnnotation,exports.referencedResourceType=referencedResourceType,exports.examplesFromNominal=examplesFromNominal,exports.getTypeExample=getTypeExample,exports.getTypeExamples=getTypeExamples,exports.typeFixedFacets=typeFixedFacets,exports.typeValue=typeValue,exports.schemaValue=schemaValue,exports.typeStructuredValue=typeStructuredValue,exports.referencedNode=referencedNode,exports.getItems=getItems,exports.findComponentTypeDeclaration=findComponentTypeDeclaration,exports.getTemplateParametrizedProperties=getTemplateParametrizedProperties;var SchemaDef=function(){function SchemaDef(_content,_name){this._content=_content,this._name=_name}return SchemaDef.prototype.name=function(){return this._name},SchemaDef.prototype.content=function(){return this._content},SchemaDef}();exports.SchemaDef=SchemaDef;var ParamValue=function(){function ParamValue(key,value){this.key=key,this.value=value}return ParamValue}();exports.ParamValue=ParamValue;var ParamWrapper=function(){function ParamWrapper(_param){this._param=_param,this.description=_param.description()?_param.description().value():this.description,this.displayName=_param.displayName(),this.type=_param.type().length>0?_param.type()[0]:"string",this.example=_param.example(),this.required=_param.required(),this.default=_param.default()}return ParamWrapper}(),ExampleSpecImpl=function(_super){function ExampleSpecImpl(hlNode,expandable,_annotations){_super.call(this,hlNode),this.expandable=expandable,this._annotations=_annotations}return __extends(ExampleSpecImpl,_super),ExampleSpecImpl.prototype.value=function(){return this.expandable.asString()},ExampleSpecImpl.prototype.structuredValue=function(){var obj;obj=this.expandable.isJSONString()||this.expandable.isYAML()?this.expandable.asJSON():this.expandable.original();var llParent=this._node.lowLevel(),key=this.expandable.isSingle()?"example":null,jsonNode=new json.AstNode(llParent.unit(),obj,llParent,null,key);return new core.TypeInstanceImpl(jsonNode)},ExampleSpecImpl.prototype.strict=function(){return this.expandable.strict()},ExampleSpecImpl.prototype.description=function(){var descriptionValue=this.expandable.description();if(null==descriptionValue&&null!==descriptionValue)return null;var attr=stubs.createAttr(this._node.definition().property(universeDef.Universe10.ExampleSpec.properties.description.name),descriptionValue),result=new RamlWrapperImpl.MarkdownStringImpl(attr);return result},ExampleSpecImpl.prototype.name=function(){return this.expandable.name()},ExampleSpecImpl.prototype.displayName=function(){return this.expandable.displayName()},ExampleSpecImpl.prototype.annotations=function(){return this._annotations},ExampleSpecImpl.prototype.scalarsAnnotations=function(){return{}},ExampleSpecImpl.prototype.uses=function(){return _super.prototype.elements.call(this,"uses")},ExampleSpecImpl}(core.BasicNodeImpl);exports.ExampleSpecImpl=ExampleSpecImpl},function(module,exports,__webpack_require__){"use strict";var serv=__webpack_require__(36);module.exports=serv},function(module,exports,__webpack_require__){"use strict";var ramlDS=__webpack_require__(36);module.exports=ramlDS.getUniverse},function(module,exports,__webpack_require__){!function(root){function noop(){}function bind(fn,thisArg){return function(){fn.apply(thisArg,arguments)}}function Promise(fn){if("object"!=typeof this)throw new TypeError("Promises must be constructed via new");if("function"!=typeof fn)throw new TypeError("not a function");this._state=0,this._handled=!1,this._value=void 0,this._deferreds=[],doResolve(fn,this)}function handle(self,deferred){for(;3===self._state;)self=self._value;return 0===self._state?void self._deferreds.push(deferred):(self._handled=!0,void asap(function(){var cb=1===self._state?deferred.onFulfilled:deferred.onRejected;if(null===cb)return void(1===self._state?resolve:reject)(deferred.promise,self._value);var ret;try{ret=cb(self._value)}catch(e){return void reject(deferred.promise,e)}resolve(deferred.promise,ret)}))}function resolve(self,newValue){try{if(newValue===self)throw new TypeError("A promise cannot be resolved with itself.");if(newValue&&("object"==typeof newValue||"function"==typeof newValue)){var then=newValue.then;if(newValue instanceof Promise)return self._state=3,self._value=newValue,void finale(self);if("function"==typeof then)return void doResolve(bind(then,newValue),self)}self._state=1,self._value=newValue,finale(self)}catch(e){reject(self,e)}}function reject(self,newValue){self._state=2,self._value=newValue,finale(self)}function finale(self){2===self._state&&0===self._deferreds.length&&asap(function(){self._handled||onUnhandledRejection(self._value)},1);for(var i=0,len=self._deferreds.length;i<len;i++)handle(self,self._deferreds[i]);self._deferreds=null}function Handler(onFulfilled,onRejected,promise){this.onFulfilled="function"==typeof onFulfilled?onFulfilled:null,this.onRejected="function"==typeof onRejected?onRejected:null,this.promise=promise}function doResolve(fn,self){var done=!1;try{fn(function(value){done||(done=!0,resolve(self,value))},function(reason){done||(done=!0,reject(self,reason))})}catch(ex){if(done)return;done=!0,reject(self,ex)}}var setTimeoutFunc=setTimeout,asap="function"==typeof setImmediate&&setImmediate||function(fn){setTimeoutFunc(fn,1)},onUnhandledRejection=function(err){"undefined"!=typeof console&&console&&console.warn("Possible Unhandled Promise Rejection:",err)};Promise.prototype.catch=function(onRejected){return this.then(null,onRejected)},Promise.prototype.then=function(onFulfilled,onRejected){var prom=new Promise(noop);return handle(this,new Handler(onFulfilled,onRejected,prom)),prom},Promise.all=function(arr){var args=Array.prototype.slice.call(arr);return new Promise(function(resolve,reject){function res(i,val){try{if(val&&("object"==typeof val||"function"==typeof val)){var then=val.then;if("function"==typeof then)return void then.call(val,function(val){res(i,val)},reject)}args[i]=val,0===--remaining&&resolve(args)}catch(ex){reject(ex)}}if(0===args.length)return resolve([]);for(var remaining=args.length,i=0;i<args.length;i++)res(i,args[i])})},Promise.resolve=function(value){return value&&"object"==typeof value&&value.constructor===Promise?value:new Promise(function(resolve){resolve(value)})},Promise.reject=function(value){return new Promise(function(resolve,reject){reject(value)})},Promise.race=function(values){return new Promise(function(resolve,reject){for(var i=0,len=values.length;i<len;i++)values[i].then(resolve,reject)})},Promise._setImmediateFn=function(fn){asap=fn},Promise._setUnhandledRejectionFn=function(fn){onUnhandledRejection=fn},"undefined"!=typeof module&&module.exports?module.exports=Promise:root.Promise||(root.Promise=Promise)}(this)},function(module,exports,__webpack_require__){"use strict";function getSchemaUtils(){return exports.rt.getSchemaUtils()}function registerAdapters(a){a.isUnion?a.addAdapter(new RAMLService(a)):a.range&&a.addAdapter(new RAMLPropertyService(a))}function isSourceProvider(object){return object.getSource&&"function"==typeof object.getSource}function prop(name,desc,domain,range,custom){var prop=new Property(name,desc);return prop.withDomain(domain,custom).withRange(range)}var __extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)};exports.rt=__webpack_require__(84);var typeSystem=exports.rt.nominalTypes;exports.getSchemaUtils=getSchemaUtils,exports.TOP_LEVEL_EXTRA=exports.rt.TOP_LEVEL_EXTRA,exports.DEFINED_IN_TYPES_EXTRA=exports.rt.DEFINED_IN_TYPES_EXTRA,exports.USER_DEFINED_EXTRA=exports.rt.USER_DEFINED_EXTRA,exports.SOURCE_EXTRA=exports.rt.SOURCE_EXTRA,exports.tsInterfaces=exports.rt.tsInterfaces,exports.injector={inject:function(a){registerAdapters(a)}},typeSystem.registerInjector(exports.injector);var AbstractType=function(_super){function AbstractType(){_super.apply(this,arguments)}return __extends(AbstractType,_super),AbstractType}(typeSystem.AbstractType);exports.AbstractType=AbstractType;var ValueType=function(_super){function ValueType(){_super.apply(this,arguments)}return __extends(ValueType,_super),ValueType}(typeSystem.ValueType);exports.ValueType=ValueType;var SourceProvider=function(){function SourceProvider(){}return SourceProvider.prototype.getSource=function(){return null},SourceProvider}();exports.SourceProvider=SourceProvider,exports.isSourceProvider=isSourceProvider;var EnumType=function(_super){function EnumType(){_super.apply(this,arguments),this.values=[]}return __extends(EnumType,_super),EnumType}(ValueType);exports.EnumType=EnumType;var ReferenceType=function(_super){function ReferenceType(name,path,referenceTo,_universe){_super.call(this,name,_universe,path),this.referenceTo=referenceTo}return __extends(ReferenceType,_super),ReferenceType.prototype.getReferencedType=function(){return this.universe().type(this.referenceTo)},ReferenceType.prototype.hasStructure=function(){return!0},ReferenceType}(ValueType);exports.ReferenceType=ReferenceType;var NodeClass=function(_super){function NodeClass(_name,universe,path,_description){void 0===_description&&(_description=""),_super.call(this,_name,universe,path)}return __extends(NodeClass,_super),NodeClass.prototype.allProperties=function(v){return void 0===v&&(v={}),_super.prototype.allProperties.call(this,v)},NodeClass}(typeSystem.StructuredType);exports.NodeClass=NodeClass;var UserDefinedClass=function(_super){function UserDefinedClass(name,universe,hl,path,description){_super.call(this,name,universe,path,description),this.getAdapter(RAMLService).setDeclaringNode(hl)}return __extends(UserDefinedClass,_super),UserDefinedClass.prototype.key=function(){return null},UserDefinedClass.prototype.isUserDefined=function(){return!0},UserDefinedClass.prototype.typeId=function(){var rs=this.nameId(),node=this.getAdapter(RAMLService).getDeclaringNode();if(node){rs+=node.lowLevel().start();var unit=node.lowLevel().unit();unit&&(rs+=unit.absolutePath())}return rs},UserDefinedClass.prototype.hasValueTypeInHierarchy=function(){return!!this._value||(this.isAssignableFrom("ObjectTypeDeclaration"),!1)},UserDefinedClass.prototype.isGenuineUserDefinedType=function(){return null!=this.genuineUserDefinedType()},UserDefinedClass.prototype.genuineUserDefinedType=function(){var declaringNode=this.getAdapter(RAMLService).getDeclaringNode();return declaringNode?this:null},UserDefinedClass}(NodeClass);exports.UserDefinedClass=UserDefinedClass;var AnnotationType=function(_super){function AnnotationType(){_super.apply(this,arguments)}return __extends(AnnotationType,_super),AnnotationType.prototype.allProperties=function(ps){
void 0===ps&&(ps={});var rs=this.superTypes()[0].allProperties();if(0==rs.length){var node=this.getAdapter(RAMLService).getDeclaringNode(),up=new UserDefinedProp("value",node);up.withDomain(this),up.withCanBeValue(),up.withRequired(!1);this.superTypes()[0];rs=[],up.withRange(up.node().asElement().definition().universe().type("string")),rs.push(up)}return rs},AnnotationType.prototype.isAnnotationType=function(){return!0},AnnotationType}(UserDefinedClass);exports.AnnotationType=AnnotationType;var Universe=function(_super){function Universe(dec,name,_parent,v){void 0===name&&(name=""),void 0===_parent&&(_parent=null),void 0===v&&(v="RAML08"),_super.call(this,name),this._parent=_parent,this._classes=[],this._uversion="RAML08",this.aMap={},this.matchedObjects=dec,this._uversion=v}return __extends(Universe,_super),Universe.prototype.matched=function(){return this.matchedObjects?this.matchedObjects:this._parent?this._parent.matched():void 0},Universe.prototype.setTopLevel=function(t){this._topLevel=t},Universe.prototype.getTopLevel=function(){return this._topLevel},Universe.prototype.setOriginalTopLevelText=function(t){this._originalTopLevelText=t},Universe.prototype.getOriginalTopLevelText=function(){return this._originalTopLevelText},Universe.prototype.setTypedVersion=function(tv){this._typedVersion=tv},Universe.prototype.getTypedVersion=function(){return this._typedVersion},Universe.prototype.version=function(){return this._uversion},Universe.prototype.setUniverseVersion=function(version){this._uversion=version},Universe.prototype.types=function(){var result=[].concat(this._classes);return null!=this._parent&&(result=result.concat(this._parent.types())),result},Universe.prototype.type=function(name){if(this.aMap[name])return this.aMap[name];for(var tp,i=0;i<this._classes.length;i++)if(this._classes[i].nameId()==name){tp=this._classes[i];break}if(null==tp&&this._parent){var tp=this._parent.type(name);if(tp instanceof AbstractType){var at=tp;at._universe=this}}return tp},Universe.prototype.register=function(t){return this._classes.push(t),t instanceof NodeClass&&this._classes.forEach(function(x){if(x instanceof NodeClass){var nc=x;nc.getAdapter(RAMLService).getExtendedType()==t&&t.getAdapter(RAMLService).getRuntimeExtenders().push(x)}}),this},Universe.prototype.registerAlias=function(a,t){this.aMap[a]=t},Universe.prototype.unregister=function(t){this._classes=this._classes.filter(function(x){return x!=t});var st=t.superTypes();return st.forEach(function(x){var a=x;a._superTypes=a._superTypes.filter(function(x){return x!=t})}),st=t.subTypes(),st.forEach(function(x){var a=x;a._subTypes=a._subTypes.filter(function(x){return x!=t})}),this},Universe.prototype.registerSuperClass=function(t0,t1){var a0=t0,a1=t1;a0._superTypes.push(t1),a1._subTypes.push(t0)},Universe}(typeSystem.Described);exports.Universe=Universe,exports.prop=prop;var ChildValueConstraint=function(){function ChildValueConstraint(name,value){this.name=name,this.value=value}return ChildValueConstraint}();exports.ChildValueConstraint=ChildValueConstraint;var Property=function(_super){function Property(){_super.apply(this,arguments),this._isFromParentValue=!1,this._isFromParentKey=!1,this._key=!1,this._declaresFields=!1,this._describes=null,this._canBeDuplicator=!1,this._allowsNull=!1,this._canBeValue=!1,this._isInherited=!1,this._selfNode=!1,this._noDirectParse=!1,this._contextReq=[],this.determinesChildValues=[]}return __extends(Property,_super),Property.prototype.isPrimitive=function(){return this.range().isValueType()&&!(this.range()instanceof ReferenceType)},Property.prototype.withNoDirectParse=function(){this._noDirectParse=!0},Property.prototype.isNoDirectParse=function(){return this._noDirectParse},Property.prototype.withSelfNode=function(){this._selfNode=!0},Property.prototype.isSelfNode=function(){return this._selfNode},Property.prototype.matchKey=function(k){return null!=this._groupName?this.isAnnotation()?"("==k.charAt(0)&&")"==k.charAt(k.length-1):this._groupName==k:_super.prototype.matchKey.call(this,k)},Property.prototype.valueDocProvider=function(){return this._vprovider},Property.prototype.setValueDocProvider=function(v){return this._vprovider=v,this},Property.prototype.suggester=function(){return this._suggester},Property.prototype.setValueSuggester=function(s){this._suggester=s},Property.prototype.enumOptions=function(){return this._enumOptions&&"string"==typeof this._enumOptions?[this._enumOptions+""]:this._enumOptions},Property.prototype.getOftenKeys=function(){return this._oftenKeys},Property.prototype.withOftenKeys=function(keys){return this._oftenKeys=keys,this},Property.prototype.withCanBeValue=function(){return this._canBeValue=!0,this},Property.prototype.withInherited=function(w){this._isInherited=w},Property.prototype.isInherited=function(){return this._isInherited},Property.prototype.isAllowNull=function(){return this._allowsNull},Property.prototype.withAllowNull=function(){this._allowsNull=!0},Property.prototype.getCanBeDuplicator=function(){return this._canBeDuplicator},Property.prototype.canBeValue=function(){return this._canBeValue},Property.prototype.setCanBeDuplicator=function(){return this._canBeDuplicator=!0,!0},Property.prototype.inheritedContextValue=function(){return this._inheritsValueFromContext},Property.prototype.withInheritedContextValue=function(v){return this._inheritsValueFromContext=v,this},Property.prototype.withContextRequirement=function(name,value){this._contextReq.push({name:name,value:value})},Property.prototype.getContextRequirements=function(){return this._contextReq},Property.prototype.withDescribes=function(a){return this._describes=a,this},Property.prototype.describesAnnotation=function(){return null!=this._describes},Property.prototype.describedAnnotation=function(){return this._describes},Property.prototype.isReference=function(){return this.range()instanceof ReferenceType},Property.prototype.referencesTo=function(){return this.range().getReferencedType()},Property.prototype.newInstanceName=function(){return this._newInstanceName?this._newInstanceName:this.range().nameId()},Property.prototype.withThisPropertyDeclaresFields=function(b){return void 0===b&&(b=!0),this._declaresFields=b,this},Property.prototype.isThisPropertyDeclaresTypeFields=function(){return this._declaresFields},Property.prototype.withNewInstanceName=function(name){return this._newInstanceName=name,this},Property.prototype.addChildValueConstraint=function(c){this.determinesChildValues.push(c)},Property.prototype.getChildValueConstraints=function(){return this.determinesChildValues},Property.prototype.childRestrictions=function(){return this.determinesChildValues},Property.prototype.id=function(){return this._id?this._id:this._groupName?this.domain().getAdapter(RAMLService).getDeclaringNode()?null:(this._id=this._groupName+this.domain().nameId(),this._id):null},Property.prototype.isAnnotation=function(){return"annotations"==this._groupName&&this.domain()&&!this.domain().isUserDefined()},Property.prototype.withFromParentValue=function(v){return void 0===v&&(v=!0),this._isFromParentValue=v,this},Property.prototype.withFromParentKey=function(v){return void 0===v&&(v=!0),this._isFromParentKey=v,this},Property.prototype.isFromParentKey=function(){return this._isFromParentKey},Property.prototype.isFromParentValue=function(){return this._isFromParentValue},Property.prototype.withGroupName=function(gname){return this._groupName=gname,this},Property.prototype.unmerge=function(){return this._groupName=this.nameId(),this},Property.prototype.merge=function(){return this._groupName=null,this},Property.prototype.withKey=function(isKey){return this._key=isKey,this},Property.prototype.isKey=function(){return this._key},Property.prototype.isMerged=function(){return null==this._groupName},Property.prototype.groupName=function(){return this._groupName},Property.prototype.key=function(){return null},Property}(typeSystem.Property);exports.Property=Property;var UserDefinedProp=function(_super){function UserDefinedProp(name,source){_super.call(this,name),this._node=source}return __extends(UserDefinedProp,_super),UserDefinedProp.prototype.withDisplayName=function(name){this._displayName=name},UserDefinedProp.prototype.getDisplayName=function(){return this._displayName},UserDefinedProp.prototype.node=function(){return this._node||null==this.sourceProvider||(this._node=this.sourceProvider.getSource()),this._node},UserDefinedProp.prototype.setSourceProvider=function(sourceProvider){this.sourceProvider=sourceProvider},UserDefinedProp}(Property);exports.UserDefinedProp=UserDefinedProp;var RAMLPropertyDocumentationService=function(){function RAMLPropertyDocumentationService(){}return RAMLPropertyDocumentationService.prototype.setDocTableName=function(val){this._documentationTableName=val},RAMLPropertyDocumentationService.prototype.docTableName=function(){return this._documentationTableName},RAMLPropertyDocumentationService.prototype.setHidden=function(val){this._isHidden=val},RAMLPropertyDocumentationService.prototype.isHidden=function(){return this._isHidden},RAMLPropertyDocumentationService.prototype.setMarkdownDescription=function(val){this._markdownDescription=val},RAMLPropertyDocumentationService.prototype.markdownDescription=function(){return this._markdownDescription},RAMLPropertyDocumentationService.prototype.setValueDescription=function(val){this._valueDescription=val},RAMLPropertyDocumentationService.prototype.valueDescription=function(){return this._valueDescription},RAMLPropertyDocumentationService}();exports.RAMLPropertyDocumentationService=RAMLPropertyDocumentationService;var RAMLPropertyParserService=function(_super){function RAMLPropertyParserService(){_super.apply(this,arguments)}return __extends(RAMLPropertyParserService,_super),RAMLPropertyParserService.prototype.isSystem=function(){return this._isSystemProperty},RAMLPropertyParserService.prototype.withSystem=function(s){return this._isSystemProperty=s,this},RAMLPropertyParserService.prototype.isEmbedMap=function(){return this._isEmbededMap},RAMLPropertyParserService.prototype.withEmbedMap=function(){return this._isEmbededMap=!0,this},RAMLPropertyParserService}(RAMLPropertyDocumentationService);exports.RAMLPropertyParserService=RAMLPropertyParserService;var RAMLPropertyService=function(_super){function RAMLPropertyService(_property){if(_super.call(this),this._property=_property,this._meta={},!_property)throw new Error;_super.call(this)}return __extends(RAMLPropertyService,_super),RAMLPropertyService.prototype.valueDocProvider=function(){return this._property.valueDocProvider()},RAMLPropertyService.prototype.withPropertyGrammarType=function(pt){this._propertyGrammarType=pt},RAMLPropertyService.prototype.getPropertyGrammarType=function(){return this._propertyGrammarType},RAMLPropertyService.prototype.id=function(){return this._property.nameId()},RAMLPropertyService.prototype.range=function(){return this._property.range()},RAMLPropertyService.prototype.domain=function(){return this._property.domain()},RAMLPropertyService.prototype.isAllowNull=function(){return this._property.isAllowNull()},RAMLPropertyService.prototype.referencesTo=function(){return this._property.referencesTo()},RAMLPropertyService.prototype.isReference=function(){return this._property.isReference()},RAMLPropertyService.prototype.nameId=function(){return this._property.nameId()},RAMLPropertyService.prototype.priority=function(){return this.isKey()?128:this.isReference()?64:this.isTypeExpr()?32:"example"==this.nameId()?0:-1024},RAMLPropertyService.prototype.isKey=function(){return this._property instanceof Property&&this._property.isKey()},RAMLPropertyService.prototype.isMerged=function(){return this._property instanceof Property&&this._property.isMerged()},RAMLPropertyService.prototype.isTypeExpr=function(){return this.texpr},RAMLPropertyService.prototype.isExampleProperty=function(){return this.example},RAMLPropertyService.prototype.setExample=function(e){this.example=e},RAMLPropertyService.prototype.setTypeExpression=function(e){this.texpr=e},RAMLPropertyService.prototype.isDescriminating=function(){return this._property.isDescriminator()},RAMLPropertyService.prototype.putMeta=function(key,value){this._meta[key]=value},RAMLPropertyService.prototype.meta=function(key){return this._meta[key]},RAMLPropertyService}(RAMLPropertyParserService);exports.RAMLPropertyService=RAMLPropertyService;var RAMLService=function(){function RAMLService(d){this._allowsOptionalProperties=!1,this._possibleInterfaces=[],this._canInherit=[],this._declaredBy=[],this._aliases=[],this._defining=[],this._runtimeExtenders=[],this._declaresType=null,this._isTemplate=!1,this._contextRequirements=[],this._type=d}return RAMLService.prototype.withAllowQuestion=function(){this._allowsOptionalProperties=!0},RAMLService.prototype.getAllowQuestion=function(){return this._allowsOptionalProperties},RAMLService.prototype.withCanInherit=function(clazz){this._canInherit.push(clazz)},RAMLService.prototype.getReferenceIs=function(){return this._referenceIs},RAMLService.prototype.withReferenceIs=function(fname){this._referenceIs=fname},RAMLService.prototype.descriminatorValue=function(){return 0==this.valueRequirements().length?this.nameId():this.valueRequirements()[0].value},RAMLService.prototype.getCanInherit=function(){return this._canInherit},RAMLService.prototype.withAllowAny=function(){this._allowsAnyChildren=!0},RAMLService.prototype.getAllowAny=function(){return this._allowsAnyChildren||this._type.isExternal()},RAMLService.prototype.globallyDeclaredBy=function(){return this._declaredBy},RAMLService.prototype.setGloballyDeclaredBy=function(c){this._declaredBy.push(c)},RAMLService.prototype.setDeclaringNode=function(n){this._node=n},RAMLService.prototype.nameId=function(){return this._type.nameId()},RAMLService.prototype.universe=function(){return this._type.universe()},RAMLService.prototype.isAssignableFrom=function(name){return this._type.isAssignableFrom(name)},RAMLService.prototype.setConsumesRefs=function(b){this._consumesRef=b},RAMLService.prototype.definingPropertyIsEnough=function(v){this._defining.push(v)},RAMLService.prototype.getDefining=function(){return this._defining},RAMLService.prototype.getConsumesRefs=function(){return this._consumesRef},RAMLService.prototype.addAlias=function(al){this._aliases.push(al)},RAMLService.prototype.getAliases=function(){return this._aliases},RAMLService.prototype.valueRequirements=function(){return this._type.valueRequirements()},RAMLService.prototype.isAnnotation=function(){return this._annotationChecked?this._isAnnotation:(this._annotationChecked=!0,this._isAnnotation=this._type.allSuperTypes().some(function(x){return x.key()&&"AnnotationRef"==x.key().name}),this._isAnnotation)},RAMLService.prototype.allowValue=function(){return this._allowsValueSet?this._allowsValue:this._type.allProperties().some(function(x){return x.isFromParentValue()||x.canBeValue()})?(this._allowsValue=!0,this._allowsValueSet=!0,!0):(this._allowsValueSet=!0,!1)},RAMLService.prototype.key=function(){return this._type.key()},RAMLService.prototype.getRepresentationOf=function(){return this._representationOf},RAMLService.prototype.getPath=function(){return""},RAMLService.prototype.isDeclaration=function(){return!!this._isTemplate||(!!this._convertsToGlobal||(!!this._declaresType||!(!this.key()||"Library"!==this.key().name)))},RAMLService.prototype.isGlobalDeclaration=function(){return!!this._actuallyExports||(!!this._isTemplate||!!this._declaresType)},RAMLService.prototype.isTypeSystemMember=function(){return null!=this._declaresType},RAMLService.prototype.getExtendedType=function(){return this.universe().type(this._declaresType)},RAMLService.prototype.setInlinedTemplates=function(b){return this._isTemplate=b,this},RAMLService.prototype.getRuntimeExtenders=function(){return this._runtimeExtenders},RAMLService.prototype.isInlinedTemplates=function(){return this._isTemplate},RAMLService.prototype.setExtendedTypeName=function(name){this._declaresType=name;var tp=this.universe().type(name);if(tp instanceof NodeClass){var nc=tp;nc.getAdapter(RAMLService)._runtimeExtenders.push(this._type)}},RAMLService.prototype.getKeyProp=function(){for(var c=this._type.allProperties(),i=0;i<c.length;i++)if(c[i].getAdapter(RAMLPropertyService).isKey())return c[i];return null},RAMLService.prototype.withActuallyExports=function(pname){this._actuallyExports=pname},RAMLService.prototype.withConvertsToGlobal=function(pname){this._convertsToGlobal=pname},RAMLService.prototype.getConvertsToGlobal=function(){return this._convertsToGlobal},RAMLService.prototype.getActuallyExports=function(){return this._actuallyExports},RAMLService.prototype.isUserDefined=function(){return this._type instanceof NodeClass?this._type.isUserDefined():this._type instanceof AbstractType&&this._type.isUserDefined()},RAMLService.prototype.withContextRequirement=function(name,value){this._contextRequirements.push({name:name,value:value})},RAMLService.prototype.getContextRequirements=function(){return this._contextRequirements},RAMLService.prototype.findMembersDeterminer=function(){for(var c=this._type.allProperties(),i=0;i<c.length;i++)if(c[i].isThisPropertyDeclaresTypeFields())return c[i];return null},RAMLService.prototype.getDeclaringNode=function(){if(this._node)return this._node;if(this._type){var sourceNode=this._type.getExtra(exports.SOURCE_EXTRA);return sourceNode?sourceNode instanceof SourceProvider||sourceNode.getSource&&"function"==typeof sourceNode.getSource?sourceNode.getSource():sourceNode:null}return null},RAMLService.prototype.registerSupertypes=function(classNames){var _this=this,universe=this._type.universe();classNames.forEach(function(x){var supertype=universe.type(x);supertype&&_this._type.addSuperType(supertype)})},RAMLService.prototype.registerPossibleInterfaces=function(classNames){for(var universe=this._type.universe(),_i=0,classNames_1=classNames;_i<classNames_1.length;_i++){var x=classNames_1[_i],supertype=universe.type(x);if(!supertype)return;this._possibleInterfaces.push(supertype)}},RAMLService.prototype.possibleInterfaces=function(){return this._possibleInterfaces},RAMLService}();exports.RAMLService=RAMLService;var universes={},ramlDS=__webpack_require__(56),jsonDefinitions=ramlDS.universeDumps,ts2def=__webpack_require__(57),unDesc=__webpack_require__(58);exports.universesInfo=unDesc,exports.getUniverse=function(){var x=function(key){if(universes[key])return universes[key];var src=jsonDefinitions[key],universe=ts2def.toDefSystem(src,"RAML08"==key?unDesc.Universe08:unDesc.Universe10);return universe&&(universe.setUniverseVersion(key),universes[key]=universe),universe};return x.availableUniverses=function(){return Object.keys(jsonDefinitions)},x}()},function(module,exports,__webpack_require__){function Url(){this.protocol=null,this.slashes=null,this.auth=null,this.host=null,this.port=null,this.hostname=null,this.hash=null,this.search=null,this.query=null,this.pathname=null,this.path=null,this.href=null}function urlParse(url,parseQueryString,slashesDenoteHost){if(url&&isObject(url)&&url instanceof Url)return url;var u=new Url;return u.parse(url,parseQueryString,slashesDenoteHost),u}function urlFormat(obj){return isString(obj)&&(obj=urlParse(obj)),obj instanceof Url?obj.format():Url.prototype.format.call(obj)}function urlResolve(source,relative){return urlParse(source,!1,!0).resolve(relative)}function urlResolveObject(source,relative){return source?urlParse(source,!1,!0).resolveObject(relative):relative}function isString(arg){return"string"==typeof arg}function isObject(arg){return"object"==typeof arg&&null!==arg}function isNull(arg){return null===arg}function isNullOrUndefined(arg){return null==arg}var punycode=__webpack_require__(81);exports.parse=urlParse,exports.resolve=urlResolve,exports.resolveObject=urlResolveObject,exports.format=urlFormat,exports.Url=Url;var protocolPattern=/^([a-z0-9.+-]+:)/i,portPattern=/:[0-9]*$/,delims=["<",">",'"',"`"," ","\r","\n","\t"],unwise=["{","}","|","\\","^","`"].concat(delims),autoEscape=["'"].concat(unwise),nonHostChars=["%","/","?",";","#"].concat(autoEscape),hostEndingChars=["/","?","#"],hostnameMaxLen=255,hostnamePartPattern=/^[a-z0-9A-Z_-]{0,63}$/,hostnamePartStart=/^([a-z0-9A-Z_-]{0,63})(.*)$/,unsafeProtocol={javascript:!0,"javascript:":!0},hostlessProtocol={javascript:!0,"javascript:":!0},slashedProtocol={http:!0,https:!0,ftp:!0,gopher:!0,file:!0,"http:":!0,"https:":!0,"ftp:":!0,"gopher:":!0,"file:":!0},querystring=__webpack_require__(80);Url.prototype.parse=function(url,parseQueryString,slashesDenoteHost){if(!isString(url))throw new TypeError("Parameter 'url' must be a string, not "+typeof url);var rest=url;rest=rest.trim();var proto=protocolPattern.exec(rest);if(proto){proto=proto[0];var lowerProto=proto.toLowerCase();this.protocol=lowerProto,rest=rest.substr(proto.length)}if(slashesDenoteHost||proto||rest.match(/^\/\/[^@\/]+@[^@\/]+/)){var slashes="//"===rest.substr(0,2);!slashes||proto&&hostlessProtocol[proto]||(rest=rest.substr(2),this.slashes=!0)}if(!hostlessProtocol[proto]&&(slashes||proto&&!slashedProtocol[proto])){for(var hostEnd=-1,i=0;i<hostEndingChars.length;i++){var hec=rest.indexOf(hostEndingChars[i]);hec!==-1&&(hostEnd===-1||hec<hostEnd)&&(hostEnd=hec)}var auth,atSign;atSign=hostEnd===-1?rest.lastIndexOf("@"):rest.lastIndexOf("@",hostEnd),atSign!==-1&&(auth=rest.slice(0,atSign),rest=rest.slice(atSign+1),this.auth=decodeURIComponent(auth)),hostEnd=-1;for(var i=0;i<nonHostChars.length;i++){var hec=rest.indexOf(nonHostChars[i]);hec!==-1&&(hostEnd===-1||hec<hostEnd)&&(hostEnd=hec)}hostEnd===-1&&(hostEnd=rest.length),this.host=rest.slice(0,hostEnd),rest=rest.slice(hostEnd),this.parseHost(),this.hostname=this.hostname||"";var ipv6Hostname="["===this.hostname[0]&&"]"===this.hostname[this.hostname.length-1];if(!ipv6Hostname)for(var hostparts=this.hostname.split(/\./),i=0,l=hostparts.length;i<l;i++){var part=hostparts[i];if(part&&!part.match(hostnamePartPattern)){for(var newpart="",j=0,k=part.length;j<k;j++)newpart+=part.charCodeAt(j)>127?"x":part[j];if(!newpart.match(hostnamePartPattern)){var validParts=hostparts.slice(0,i),notHost=hostparts.slice(i+1),bit=part.match(hostnamePartStart);bit&&(validParts.push(bit[1]),notHost.unshift(bit[2])),notHost.length&&(rest="/"+notHost.join(".")+rest),this.hostname=validParts.join(".");break}}}if(this.hostname.length>hostnameMaxLen?this.hostname="":this.hostname=this.hostname.toLowerCase(),!ipv6Hostname){for(var domainArray=this.hostname.split("."),newOut=[],i=0;i<domainArray.length;++i){var s=domainArray[i];newOut.push(s.match(/[^A-Za-z0-9_-]/)?"xn--"+punycode.encode(s):s)}this.hostname=newOut.join(".")}var p=this.port?":"+this.port:"",h=this.hostname||"";this.host=h+p,this.href+=this.host,ipv6Hostname&&(this.hostname=this.hostname.substr(1,this.hostname.length-2),"/"!==rest[0]&&(rest="/"+rest))}if(!unsafeProtocol[lowerProto])for(var i=0,l=autoEscape.length;i<l;i++){var ae=autoEscape[i],esc=encodeURIComponent(ae);esc===ae&&(esc=escape(ae)),rest=rest.split(ae).join(esc)}var hash=rest.indexOf("#");hash!==-1&&(this.hash=rest.substr(hash),rest=rest.slice(0,hash));var qm=rest.indexOf("?");if(qm!==-1?(this.search=rest.substr(qm),this.query=rest.substr(qm+1),parseQueryString&&(this.query=querystring.parse(this.query)),rest=rest.slice(0,qm)):parseQueryString&&(this.search="",this.query={}),rest&&(this.pathname=rest),slashedProtocol[lowerProto]&&this.hostname&&!this.pathname&&(this.pathname="/"),this.pathname||this.search){var p=this.pathname||"",s=this.search||"";this.path=p+s}return this.href=this.format(),this},Url.prototype.format=function(){var auth=this.auth||"";auth&&(auth=encodeURIComponent(auth),auth=auth.replace(/%3A/i,":"),auth+="@");var protocol=this.protocol||"",pathname=this.pathname||"",hash=this.hash||"",host=!1,query="";this.host?host=auth+this.host:this.hostname&&(host=auth+(this.hostname.indexOf(":")===-1?this.hostname:"["+this.hostname+"]"),this.port&&(host+=":"+this.port)),this.query&&isObject(this.query)&&Object.keys(this.query).length&&(query=querystring.stringify(this.query));var search=this.search||query&&"?"+query||"";return protocol&&":"!==protocol.substr(-1)&&(protocol+=":"),this.slashes||(!protocol||slashedProtocol[protocol])&&host!==!1?(host="//"+(host||""),pathname&&"/"!==pathname.charAt(0)&&(pathname="/"+pathname)):host||(host=""),hash&&"#"!==hash.charAt(0)&&(hash="#"+hash),search&&"?"!==search.charAt(0)&&(search="?"+search),pathname=pathname.replace(/[?#]/g,function(match){return encodeURIComponent(match)}),search=search.replace("#","%23"),protocol+host+pathname+search+hash},Url.prototype.resolve=function(relative){return this.resolveObject(urlParse(relative,!1,!0)).format()},Url.prototype.resolveObject=function(relative){if(isString(relative)){var rel=new Url;rel.parse(relative,!1,!0),relative=rel}var result=new Url;if(Object.keys(this).forEach(function(k){result[k]=this[k]},this),result.hash=relative.hash,""===relative.href)return result.href=result.format(),result;if(relative.slashes&&!relative.protocol)return Object.keys(relative).forEach(function(k){"protocol"!==k&&(result[k]=relative[k])}),slashedProtocol[result.protocol]&&result.hostname&&!result.pathname&&(result.path=result.pathname="/"),result.href=result.format(),result;if(relative.protocol&&relative.protocol!==result.protocol){if(!slashedProtocol[relative.protocol])return Object.keys(relative).forEach(function(k){result[k]=relative[k]}),result.href=result.format(),result;if(result.protocol=relative.protocol,relative.host||hostlessProtocol[relative.protocol])result.pathname=relative.pathname;else{for(var relPath=(relative.pathname||"").split("/");relPath.length&&!(relative.host=relPath.shift()););relative.host||(relative.host=""),relative.hostname||(relative.hostname=""),""!==relPath[0]&&relPath.unshift(""),relPath.length<2&&relPath.unshift(""),result.pathname=relPath.join("/")}if(result.search=relative.search,result.query=relative.query,result.host=relative.host||"",result.auth=relative.auth,result.hostname=relative.hostname||relative.host,result.port=relative.port,result.pathname||result.search){var p=result.pathname||"",s=result.search||"";result.path=p+s}return result.slashes=result.slashes||relative.slashes,result.href=result.format(),result}var isSourceAbs=result.pathname&&"/"===result.pathname.charAt(0),isRelAbs=relative.host||relative.pathname&&"/"===relative.pathname.charAt(0),mustEndAbs=isRelAbs||isSourceAbs||result.host&&relative.pathname,removeAllDots=mustEndAbs,srcPath=result.pathname&&result.pathname.split("/")||[],relPath=relative.pathname&&relative.pathname.split("/")||[],psychotic=result.protocol&&!slashedProtocol[result.protocol];if(psychotic&&(result.hostname="",result.port=null,result.host&&(""===srcPath[0]?srcPath[0]=result.host:srcPath.unshift(result.host)),result.host="",relative.protocol&&(relative.hostname=null,relative.port=null,relative.host&&(""===relPath[0]?relPath[0]=relative.host:relPath.unshift(relative.host)),relative.host=null),mustEndAbs=mustEndAbs&&(""===relPath[0]||""===srcPath[0])),isRelAbs)result.host=relative.host||""===relative.host?relative.host:result.host,result.hostname=relative.hostname||""===relative.hostname?relative.hostname:result.hostname,result.search=relative.search,result.query=relative.query,srcPath=relPath;else if(relPath.length)srcPath||(srcPath=[]),srcPath.pop(),srcPath=srcPath.concat(relPath),result.search=relative.search,result.query=relative.query;else if(!isNullOrUndefined(relative.search)){if(psychotic){result.hostname=result.host=srcPath.shift();var authInHost=!!(result.host&&result.host.indexOf("@")>0)&&result.host.split("@");authInHost&&(result.auth=authInHost.shift(),result.host=result.hostname=authInHost.shift())}return result.search=relative.search,result.query=relative.query,isNull(result.pathname)&&isNull(result.search)||(result.path=(result.pathname?result.pathname:"")+(result.search?result.search:"")),result.href=result.format(),result}if(!srcPath.length)return result.pathname=null,result.search?result.path="/"+result.search:result.path=null,result.href=result.format(),result;for(var last=srcPath.slice(-1)[0],hasTrailingSlash=(result.host||relative.host)&&("."===last||".."===last)||""===last,up=0,i=srcPath.length;i>=0;i--)last=srcPath[i],"."==last?srcPath.splice(i,1):".."===last?(srcPath.splice(i,1),up++):up&&(srcPath.splice(i,1),up--);if(!mustEndAbs&&!removeAllDots)for(;up--;up)srcPath.unshift("..");!mustEndAbs||""===srcPath[0]||srcPath[0]&&"/"===srcPath[0].charAt(0)||srcPath.unshift(""),hasTrailingSlash&&"/"!==srcPath.join("/").substr(-1)&&srcPath.push("");var isAbsolute=""===srcPath[0]||srcPath[0]&&"/"===srcPath[0].charAt(0);if(psychotic){result.hostname=result.host=isAbsolute?"":srcPath.length?srcPath.shift():"";var authInHost=!!(result.host&&result.host.indexOf("@")>0)&&result.host.split("@");authInHost&&(result.auth=authInHost.shift(),result.host=result.hostname=authInHost.shift())}return mustEndAbs=mustEndAbs||result.host&&srcPath.length,mustEndAbs&&!isAbsolute&&srcPath.unshift(""),srcPath.length?result.pathname=srcPath.join("/"):(result.pathname=null,result.path=null),isNull(result.pathname)&&isNull(result.search)||(result.path=(result.pathname?result.pathname:"")+(result.search?result.search:"")),result.auth=relative.auth||result.auth,result.slashes=result.slashes||relative.slashes,result.href=result.format(),result},Url.prototype.parseHost=function(){var host=this.host,port=portPattern.exec(host);port&&(port=port[0],":"!==port&&(this.port=port.substr(1)),host=host.substr(0,host.length-port.length)),host&&(this.hostname=host)}},function(module,exports,__webpack_require__){"use strict";var __extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},yaml=__webpack_require__(70),json=__webpack_require__(50),stringify=__webpack_require__(62),impl=__webpack_require__(27),util=__webpack_require__(31),universes=__webpack_require__(22),def=__webpack_require__(36),universeHelpers=__webpack_require__(14),_=__webpack_require__(61),LowLevelProxyNode=function(){function LowLevelProxyNode(_parent,_transformer,ramlVersion){this._parent=_parent,this._transformer=_transformer,this.ramlVersion=ramlVersion}return LowLevelProxyNode.prototype.hasInnerIncludeError=function(){return this._originalNode.hasInnerIncludeError()},LowLevelProxyNode.prototype.keyKind=function(){return this._originalNode.keyKind()},LowLevelProxyNode.prototype.primaryNode=function(){return null},LowLevelProxyNode.prototype.isAnnotatedScalar=function(){return this._originalNode.isAnnotatedScalar()},LowLevelProxyNode.prototype.actual=function(){return this._originalNode?this._originalNode.actual():this},LowLevelProxyNode.prototype.transformer=function(){return this._transformer},LowLevelProxyNode.prototype.originalNode=function(){return this._originalNode},LowLevelProxyNode.prototype.start=function(){return this._originalNode.start()},LowLevelProxyNode.prototype.end=function(){return this._originalNode.end()},LowLevelProxyNode.prototype.value=function(toString){throw new Error("The method must be overridden")},LowLevelProxyNode.prototype.includeErrors=function(){return this._originalNode.includeErrors()},LowLevelProxyNode.prototype.includePath=function(){return this._originalNode.includePath()},LowLevelProxyNode.prototype.includeReference=function(){return this._originalNode.includeReference()},LowLevelProxyNode.prototype.setKeyOverride=function(_key){this._keyOverride=_key},LowLevelProxyNode.prototype.setValueOverride=function(value){this._valueOverride=value},LowLevelProxyNode.prototype.key=function(){return this._keyOverride?this._keyOverride:this._originalNode.key()},LowLevelProxyNode.prototype.optional=function(){return this.originalNode().optional()},LowLevelProxyNode.prototype.children=function(){throw new Error("The method must be overridden")},LowLevelProxyNode.prototype.parent=function(){return this._parent;
},LowLevelProxyNode.prototype.unit=function(){return this._originalNode.unit()},LowLevelProxyNode.prototype.includeBaseUnit=function(){return this._originalNode.unit()},LowLevelProxyNode.prototype.anchorId=function(){return this._originalNode.anchorId()},LowLevelProxyNode.prototype.errors=function(){return this._originalNode.errors()},LowLevelProxyNode.prototype.anchoredFrom=function(){return this._originalNode.anchoredFrom()},LowLevelProxyNode.prototype.includedFrom=function(){return this._originalNode.includedFrom()},LowLevelProxyNode.prototype.visit=function(v){v(this)&&this.children().forEach(function(x){return x.visit(v)})},LowLevelProxyNode.prototype.addChild=function(n){},LowLevelProxyNode.prototype.execute=function(cmd){},LowLevelProxyNode.prototype.dump=function(){return null},LowLevelProxyNode.prototype.dumpToObject=function(){var serialized=json.serialize(this);if(this.kind()==yaml.Kind.MAPPING){var obj={};return obj[this.key()]=serialized,obj}return serialized},LowLevelProxyNode.prototype.keyStart=function(){return this._originalNode.keyStart()},LowLevelProxyNode.prototype.keyEnd=function(){return this._originalNode.keyEnd()},LowLevelProxyNode.prototype.valueStart=function(){return this._originalNode.valueStart()},LowLevelProxyNode.prototype.valueEnd=function(){return this._originalNode.valueEnd()},LowLevelProxyNode.prototype.isValueLocal=function(){return this._originalNode.isValueLocal()},LowLevelProxyNode.prototype.kind=function(){return this._originalNode.kind()},LowLevelProxyNode.prototype.valueKind=function(){return this._originalNode.valueKind()},LowLevelProxyNode.prototype.show=function(msg){this._originalNode.show(msg)},LowLevelProxyNode.prototype.setHighLevelParseResult=function(highLevelParseResult){this._highLevelParseResult=highLevelParseResult},LowLevelProxyNode.prototype.highLevelParseResult=function(){return this._highLevelParseResult},LowLevelProxyNode.prototype.setHighLevelNode=function(highLevel){this._highLevelNode=highLevel},LowLevelProxyNode.prototype.highLevelNode=function(){return this._highLevelNode?this._highLevelNode:this._originalNode.highLevelNode()},LowLevelProxyNode.prototype.text=function(unitText){throw new Error("not implemented")},LowLevelProxyNode.prototype.copy=function(){throw new Error("not implemented")},LowLevelProxyNode.prototype.markup=function(json){throw new Error("not implemented")},LowLevelProxyNode.prototype.nodeDefinition=function(){return impl.getDefinitionForLowLevelNode(this)},LowLevelProxyNode.prototype.includesContents=function(){return this._originalNode.includesContents()},LowLevelProxyNode}();exports.LowLevelProxyNode=LowLevelProxyNode;var LowLevelCompositeNode=function(_super){function LowLevelCompositeNode(node,parent,transformer,ramlVersion,isPrimary){void 0===isPrimary&&(isPrimary=!0),_super.call(this,parent,transformer,ramlVersion),this.isPrimary=isPrimary,this._adoptedNodes=[],this._preserveAnnotations=!1;var originalParent=this.parent()?this.parent().originalNode():null;node instanceof LowLevelValueTransformingNode?this._originalNode=node:this._originalNode=new LowLevelValueTransformingNode(node,originalParent,transformer,this.ramlVersion),this._adoptedNodes.push(this._originalNode)}return __extends(LowLevelCompositeNode,_super),LowLevelCompositeNode.prototype.adoptedNodes=function(){return this._adoptedNodes},LowLevelCompositeNode.prototype.primaryNode=function(){return this.isPrimary?this._originalNode:null},LowLevelCompositeNode.prototype.parent=function(){return this._parent},LowLevelCompositeNode.prototype.adopt=function(node,transformer){transformer||(transformer=this._transformer);var originalParent=this.parent()?this.parent().originalNode():null,tNode=new LowLevelValueTransformingNode(node,originalParent,transformer,this.ramlVersion);this._adoptedNodes.push(tNode),this._children&&this._children.forEach(function(x){return x._parent=null}),this._children=null,this.highLevelNode()&&this.highLevelNode().resetChildren()},LowLevelCompositeNode.prototype.value=function(toString){if(this._valueOverride)return this._valueOverride;var val,valuableNodes=this._adoptedNodes.filter(function(x){return null!=x.value()});return val=valuableNodes.length>0?valuableNodes[0].value(toString):this._originalNode.value(toString),val instanceof LowLevelValueTransformingNode&&(this._valueOverride=val),val},LowLevelCompositeNode.prototype.children=function(){var _this=this;if(this._children)return this._children;for(var result=[],canBeMap=!1,canBeSeq=!1,_i=0,_a=this._adoptedNodes;_i<_a.length;_i++){var x=_a[_i],adoptedNodeChildren=x.children();adoptedNodeChildren&&adoptedNodeChildren.length>0&&(canBeSeq=!0,adoptedNodeChildren[0].key()&&this.originalNode().valueKind()!=yaml.Kind.SEQ&&(canBeMap=!0))}if(canBeMap)result=this.collectChildrenWithKeys();else if(canBeSeq){result=this.collectChildrenWithKeys();var map={};this._adoptedNodes.forEach(function(x){return x.children().filter(function(y){return!y.key()}).forEach(function(y){var isPrimary=x==_this.primaryNode(),key=_this.buildKey(y);if(isPrimary||!map[key]){map[key]=!0;var transformer=x.transformer()?x.transformer():_this.transformer(),ch=y instanceof LowLevelValueTransformingNode?y.originalNode():y;result.push(new LowLevelCompositeNode(ch,_this,transformer,_this.ramlVersion,isPrimary))}})})}else result=[];return this._children=result,result},LowLevelCompositeNode.prototype.buildKey=function(y){var obj=json.serialize(y),def=this.nodeDefinition();if(def&&(def.key()==universes.Universe08.TraitRef||def.key()==universes.Universe08.ResourceTypeRef||def.key()==universes.Universe10.TraitRef||def.key()==universes.Universe10.ResourceTypeRef)&&"object"==typeof obj){var keys=Object.keys(obj);keys.length>0&&(obj=keys[0])}return stringify(obj)},LowLevelCompositeNode.prototype.collectChildrenWithKeys=function(){for(var _this=this,result=[],m={},_i=0,_a=this._adoptedNodes;_i<_a.length;_i++)for(var x=_a[_i],isPrimary=x==this.primaryNode(),_b=0,_c=x.children();_b<_c.length;_b++){var y=_c[_b],key=y.originalNode().key();if(key&&x.transformer()){var isAnnotation=null!=key&&(this._preserveAnnotations||this.isResource())&&util.stringStartsWith(key,"(")&&util.stringEndsWith(key,")");isAnnotation||(key=x.transformer().transform(key).value)}if(!this.skipKey(key,isPrimary)&&key){var arr=m[key];arr||(arr=[],m[key]=arr),arr.push({node:y.originalNode(),transformer:x.transformer(),isPrimary:isPrimary})}}var ramlVersion=this.unit().highLevel().root().definition().universe().version(),isResource=this.key()&&"/"==this.key()[0],methodType=def.getUniverse("RAML10").type(universes.Universe10.Method.name),options=methodType.property(universes.Universe10.Method.properties.method.name).enumOptions();return Object.keys(m).forEach(function(key){var arr=m[key],allOptional=!0,hasPrimaryChildren=!1,isMethod=options.indexOf(key)>=0;if(arr.forEach(function(x){var isOpt=x.node.optional()&&("RAML10"!=ramlVersion||isResource&&isMethod);allOptional=allOptional&&isOpt,hasPrimaryChildren=hasPrimaryChildren||x.isPrimary}),hasPrimaryChildren){var primaryChildren=[];arr.filter(function(x){return x.isPrimary}).forEach(function(x){var tr=x.transformer?x.transformer:_this.transformer();primaryChildren.push(new LowLevelCompositeNode(x.node,_this,tr,_this.ramlVersion,(!0)))});var primaryChild=primaryChildren[0];arr.filter(function(x){return!x.isPrimary}).forEach(function(x){primaryChild.adopt(x.node,x.transformer)}),primaryChildren.forEach(function(x){return result.push(x)})}else if(!allOptional){for(var tr=arr[0].transformer?arr[0].transformer:_this.transformer(),primaryChild=new LowLevelCompositeNode(arr[0].node,_this,tr,_this.ramlVersion,(!1)),i=1;i<arr.length;i++)primaryChild.adopt(arr[i].node,arr[i].transformer);result.push(primaryChild)}}),result},LowLevelCompositeNode.prototype.isResource=function(){return this.highLevelNode()&&universeHelpers.isResourceType(this.highLevelNode().definition())},LowLevelCompositeNode.prototype.skipKey=function(key,isPrimary){if(isPrimary)return!1;if("RAML08"!=this.ramlVersion)return!1;universes.Universe08.Method,universes.Universe08.Resource;return!1},LowLevelCompositeNode.prototype.valueKind=function(){if(this._originalNode.kind()!=yaml.Kind.MAPPING)return null;for(var i=0;i<this._adoptedNodes.length;i++){var node=this._adoptedNodes[i],yamlNode=node.originalNode().actual();if(yamlNode&&null!=yamlNode.value)return node.valueKind()}return null},LowLevelCompositeNode.prototype.includePath=function(){for(var i=0;i<this._adoptedNodes.length;i++){var node=this._adoptedNodes[i],includePath=node.includePath();if(null!=includePath)return includePath}return null},LowLevelCompositeNode.prototype.includeBaseUnit=function(){for(var i=0;i<this._adoptedNodes.length;i++){var node=this._adoptedNodes[i],includePath=node.includePath();if(null!=includePath)return node.unit()}return _super.prototype.includeBaseUnit.call(this)},LowLevelCompositeNode.prototype.includeReference=function(){for(var i=0;i<this._adoptedNodes.length;i++){var node=this._adoptedNodes[i];if(null!=node.value())return node.includeReference()}return null},LowLevelCompositeNode.prototype.optional=function(){return _.all(this._adoptedNodes,function(x){return x.optional()})},LowLevelCompositeNode.prototype.replaceChild=function(oldNode,newNode,isPrimary,transformer){void 0===isPrimary&&(isPrimary=!1),void 0===transformer&&(transformer=null),this._children||(this._children=[]);var newCNode=new LowLevelCompositeNode(newNode,this,null,this.ramlVersion);if(null==oldNode)return this._children.push(newCNode),newCNode;var ind=this._children.indexOf(oldNode);return ind>=0?this._children[ind]=newCNode:this._children.push(newCNode),newCNode},LowLevelCompositeNode.prototype.removeChild=function(oldNode){if(this._children&&null!=oldNode){var ind=this._children.indexOf(oldNode);if(ind>=0){for(var i=ind;i<this._children.length-1;i++)this._children[i]=this._children[i+1];this._children.pop()}}},LowLevelCompositeNode.prototype.setChildren=function(nodes){var _this=this;return null==nodes?void(this._children=null):void(this._children=nodes.map(function(x){return x instanceof LowLevelCompositeNode?x:new LowLevelCompositeNode(x,_this,null,_this.ramlVersion)}))},LowLevelCompositeNode.prototype.preserveAnnotations=function(){if(!this._preserveAnnotations){if(void 0===this.isInsideResource&&(this.isInsideResource=!1,!this.isResource()))for(var parent=this._parent;parent;){if(parent.isResource()){this.isInsideResource=!0;break}parent=parent.parent()}this.isInsideResource&&(this._preserveAnnotations=!0,this._children=null)}},LowLevelCompositeNode.prototype.filterChildren=function(){this.children();var map={},filtered=[];this._children.forEach(function(x){if(null!=x.key())return void filtered.push(x);var key=JSON.stringify(json.serialize(x));map[key]||(map[key]=!0,filtered.push(x))}),this._children=filtered},LowLevelCompositeNode}(LowLevelProxyNode);exports.LowLevelCompositeNode=LowLevelCompositeNode;var LowLevelValueTransformingNode=function(_super){function LowLevelValueTransformingNode(node,parent,transformer,ramlVersion){_super.call(this,parent,transformer,ramlVersion),this._originalNode=node}return __extends(LowLevelValueTransformingNode,_super),LowLevelValueTransformingNode.prototype.value=function(toString){var val=this.originalNode().value(toString),t=this.transformer();if(t){var transformationResult=t.transform(val,toString);val=transformationResult.value}return val&&"object"==typeof val?new LowLevelValueTransformingNode(val,this._parent,this._transformer,this.ramlVersion):val},LowLevelValueTransformingNode.prototype.children=function(){var _this=this,childNodes=null,originalNode=this.originalNode();if(null!=this._transformer){var substitution=this._transformer.children(originalNode);null!=substitution&&(childNodes=substitution)}return null==childNodes&&(childNodes=originalNode.children()),childNodes.map(function(x){return new LowLevelValueTransformingNode(x,_this,_this._transformer,_this.ramlVersion)})},LowLevelValueTransformingNode.prototype.valueKind=function(){var kind=this._transformer&&this._transformer.valueKind(this.originalNode());return null!=kind?kind:_super.prototype.valueKind.call(this)},LowLevelValueTransformingNode.prototype.parent=function(){return this._parent},LowLevelValueTransformingNode.prototype.key=function(){var key=_super.prototype.key.call(this);return null!=this.transformer()?this.transformer().transform(key).value:key},LowLevelValueTransformingNode}(LowLevelProxyNode);exports.LowLevelValueTransformingNode=LowLevelValueTransformingNode},function(module,exports,__webpack_require__){"use strict";function findLastAttributeIndex(n){for(var last=-1,children=n.lowLevel().children(),i=0;i<children.length;i++){var node=children[i];if(node.isMapping()){var name=node.asMapping().key.value,property=n.definition().property(name);property&&(property.isFromParentValue()||property.range().hasValueTypeInHierarchy())&&(last=i)}}return last}function findInsertionPointLowLevel(node,llnode,property,attr){var insertionPoint=null,embed=property&&property.getAdapter(services.RAMLPropertyService).isEmbedMap();if(embed&&_.find(node.lowLevel().children(),function(x){return x.key()==property.nameId()})&&(embed=!1),attr||embed){var last=findLastAttribute(node);insertionPoint=last?last:jsyaml.InsertionPoint.atStart()}return insertionPoint}function findInsertionPoint(where,node){where.isStub()||where.clearChildrenCache();var ch=where.children(),embed=node.property()&&node.property().getAdapter(services.RAMLPropertyService).isEmbedMap();embed&&_.find(where.lowLevel().children(),function(x){return x.key()==node.property().nameId()})&&(embed=!1);if(!node.isAttr()&&!embed||universeHelpers.isMethodType(where.definition())&&node.property&&universeHelpers.isIsProperty(node.property())){var pname=node.property().nameId(),cls=where.definition(),pindex=(cls.allProperties(),cls.propertyIndex(pname));if(pindex<0)return null;for(var llchilds=where.lowLevel().children(),i=0;i<llchilds.length;i++){var llch=llchilds[i];if(llch.isMapping()){var cpnme=llch.asMapping().key.value,pi=cls.propertyIndex(cpnme);if(pi>pindex){var lastok=i-1;return lastok<0?null:(console.log("insert to node: "+lastok),llchilds[lastok])}}}return null}for(var toRet=null,i=0;i<ch.length&&ch[i].isAttr();i++)toRet=ch[i].lowLevel();return null==toRet&&(toRet=where.lowLevel()),toRet}function removeNodeFrom(source,node){if(source.isStub()){if(node instanceof hlimpl.ASTNodeImpl){var cm=node;if(cm.isInEdit)return}if(!source._children)return;return void(source._children=source._children.filter(function(x){return x!=node}))}var command=new ll.CompositeCommand;if(node instanceof hlimpl.ASTNodeImpl){var aNode=node;aNode.property().getAdapter(services.RAMLPropertyService).isMerged()?command.commands.push(ll.removeNode(source.lowLevel(),aNode.lowLevel())):1==source.elementsOfKind(aNode.property().nameId()).length?command.commands.push(ll.removeNode(source.lowLevel(),aNode.lowLevel().parent().parent())):command.commands.push(ll.removeNode(source.lowLevel(),aNode.lowLevel()))}else command.commands.push(ll.removeNode(source.lowLevel(),node.lowLevel()));source.lowLevel().execute(command)}function initEmptyRAMLFile(node){var command=(node.lowLevel().root(),new ll.CompositeCommand),newroot=jsyaml.createMap([]);command.commands.push(ll.initRamlFile(node.lowLevel(),newroot)),node.lowLevel().execute(command);var root=node.root();root._node=newroot,root.clearChildrenCache()}function setValue(node,value){if(value!=node.value()){var c=new ll.CompositeCommand;if("string"==typeof value){var val=value;node.property().isFromParentKey()||node.property().isAnnotation()?(node.property().isAnnotation()&&(val="("+val+")"),c.commands.push(ll.setKey(node.lowLevel(),val))):val&&0!=val.length||node.isEmbedded()?(val||(val=""),c.commands.push(ll.setAttr(node.lowLevel(),val))):(c.commands.push(ll.removeNode(node.lowLevel().parent(),node.lowLevel())),node.parent().clearChildrenCache())}else{if(node.property().isFromParentKey())throw new Error("couldn't set structured value to a key: "+node.property().nameId());var sval=value;c.commands.push(ll.setAttrStructured(node.lowLevel(),sval))}node.lowLevel().execute(c)}}function addStringValue(attr,value){var sc=jsyaml.createScalar(value),target=attr.lowLevel();target.isScalar()?target=target.parent():target.isMapping();var command=new ll.CompositeCommand;command.commands.push(ll.insertNode(target,sc,null,!0)),attr.lowLevel().execute(command),attr.parent().clearChildrenCache()}function addStructuredValue(attr,sv){var target=attr.lowLevel();if(target.isScalar())target=target.parent();else if(target.isMapping()){attr.lowLevel()}var command=new ll.CompositeCommand;command.commands.push(ll.insertNode(target,sv.lowLevel(),null,!0)),attr.lowLevel().execute(command),attr.parent().clearChildrenCache()}function removeAttr(attr){var llparent=attr.lowLevel().parent();if(!attr.property().isMultiValue()&&attr.isEmbedded())attr.setValue("");else{var command=new ll.CompositeCommand;command.commands.push(ll.removeNode(llparent,attr.lowLevel())),attr.lowLevel().execute(command),attr.parent().clearChildrenCache()}}function setValues(attr,values){if(!attr.property().isMultiValue())throw new Error("setValue(string[]) only apply to multi-values properties");var node=attr.parent();if(node&&isTypeShortcut(node)){var command=new ll.CompositeCommand;return command.commands.push(ll.setAttr(node.lowLevel(),values[0])),void node.lowLevel().execute(command)}if(attr.isEmpty());else{var attrs=(node.lowLevel(),node.attributes(attr.name()));attrs.forEach(function(attr){return attr.remove()})}1==values.length&&attr.property().isDescriminator()?node.attrOrCreate(attr.name()).setValue(values[0]):values.forEach(function(val){return node.attrOrCreate(attr.name()).addValue(val)})}function setKey(node,value){if(value!=node.name()){var c=new ll.CompositeCommand;c.commands.push(ll.setKey(node.lowLevel(),value)),node.lowLevel().execute(c)}}function isTypeShortcut(node){return!!(node.definition()&&node.definition().isAssignableFrom(universes.Universe10.TypeDeclaration.name)&&node.lowLevel()&&node.lowLevel().valueKind()===yaml.Kind.SCALAR)}function createAttr(node,n,v){var mapping=jsyaml.createMapping(n,v);if(node.definition()&&node.definition().isAssignableFrom(universes.Universe10.TypeDeclaration.name)&&node.lowLevel()&&(node.lowLevel().valueKind()===yaml.Kind.SCALAR||!node.lowLevel()._node.value)){var typePropertyName=n,typeMapping=jsyaml.createMapping(typePropertyName,node.lowLevel().value()),command=new ll.CompositeCommand;command.commands.push(ll.setAttr(node.lowLevel(),"")),node.lowLevel().execute(command),command=new ll.CompositeCommand;var insertionPoint=findInsertionPointLowLevel(node,typeMapping,node.definition().property(typePropertyName),!0);command.commands.push(ll.insertNode(node.lowLevel(),typeMapping,insertionPoint)),node.lowLevel().execute(command),node.resetChildren();var attribute=node.attr(typePropertyName)&&node.attr(typePropertyName).lowLevel();if(attribute)return command=new ll.CompositeCommand,command.commands.push(ll.setAttr(attribute,v)),attribute.execute(command),void node.clearChildrenCache()}if(node.isStub()){var insertionIndex=findLastAttributeIndex(node);node.lowLevel().addChild(mapping,insertionIndex+1)}else{node.isEmptyRamlFile()&&node.initRamlFile();var command=new ll.CompositeCommand,insertionPoint=findInsertionPointLowLevel(node,mapping,node.definition().property(n),!0);command.commands.push(ll.insertNode(node.lowLevel(),mapping,insertionPoint)),node.lowLevel().execute(command)}node.clearChildrenCache()}function findLastAttribute(node){var childs=node.lowLevel().children(),index=findLastAttributeIndex(node);return index<0?null:childs[index]}function addToNode(target,node){!target.isStub()&&target.isEmptyRamlFile()&&target.initRamlFile();var llnode=node.lowLevel();if(target._children||(target._children=[]),!node.property()){var an=node,allProps=target.definition().allProperties(),cp=null;if(allProps.forEach(function(x){var r=x.range();r==an.definition()&&(cp=x);var isOk=_.find(an.definition().allSuperTypes(),function(x){return x==r});isOk&&(cp=x)}),!cp)throw new Error("Unable to find correct child");an.patchProp(cp)}var insertionPoint=findInsertionPoint(target,node),command=new ll.CompositeCommand,insertionTarget=null;if(node.property().getAdapter(services.RAMLPropertyService).isMerged()||node.property().range().hasValueTypeInHierarchy())command.commands.push(ll.insertNode(target.lowLevel(),node.lowLevel(),insertionPoint)),insertionTarget=target.lowLevel();else{var name=node.property().nameId(),target2=target.lowLevel(),found=target.lowLevel().find(name);if(insertionTarget=found,found){var isEmptyTypes=null===found.value()&&found.key&&found.key()===universes.Universe10.Api.properties.types.name,needSeq=!isEmptyTypes&&node.property().getAdapter(services.RAMLPropertyService).isEmbedMap();command.commands.push(ll.insertNode(found,node.lowLevel(),insertionPoint,needSeq))}else{var nn=null;if(node.property().getAdapter(services.RAMLPropertyService).isEmbedMap()){var v10="RAML10"==target.definition().universe().version();nn=llnode.isValueMap()&&v10?jsyaml.createMapNode(name):jsyaml.createSeqNode(name),nn.addChild(node.lowLevel())}else nn=jsyaml.createNode(name),nn.addChild(node.lowLevel());command.commands.push(ll.insertNode(target2,nn,insertionPoint)),insertionTarget=target2}}if(target.isStub()){var insertionIndex=findLastAttributeIndex(target);return insertionIndex<0?target._children.push(node):target._children.splice(insertionIndex,0,node),void command.commands.forEach(function(x){return insertionTarget.addChild(x.value)})}target.lowLevel().execute(command),target._children.push(node),node.setParent(target)}var jsyaml=__webpack_require__(27),defs=__webpack_require__(36),ll=__webpack_require__(11),_=__webpack_require__(61),yaml=__webpack_require__(70),hlimpl=__webpack_require__(16),universes=__webpack_require__(22),universeHelpers=__webpack_require__(14),services=defs;exports.removeNodeFrom=removeNodeFrom,exports.initEmptyRAMLFile=initEmptyRAMLFile,exports.setValue=setValue,exports.addStringValue=addStringValue,exports.addStructuredValue=addStructuredValue,exports.removeAttr=removeAttr,exports.setValues=setValues,exports.setKey=setKey,exports.createAttr=createAttr,exports.addToNode=addToNode},function(module,exports,__webpack_require__){"use strict";function templateFields(node,d){var u=node.root().definition().universe(),key=node.lowLevel().key();if(key&&handleValue(key,d,null,!0,u),node.children().forEach(function(x){return templateFields(x,d)}),node instanceof hlimpl.ASTPropImpl){var prop=node,v=prop.value();if("string"==typeof v){var strV=v;handleValue(strV,d,prop,!1,u)}else node.lowLevel().visit(function(x){if(x.value()){var strV=x.value()+"";handleValue(strV,d,prop,!0,u)}return!0})}else if(node instanceof hlimpl.BasicASTNode){var v=node.lowLevel().value();if("string"==typeof v){var strV=v;handleValue(strV,d,null,!1,u)}else node.lowLevel().visit(function(x){if(x.value()){var strV=x.value()+"";handleValue(strV,d,null,!0,u)}return!0})}}function fillParamPaths(node,paramPaths,path){void 0===path&&(path=[]),node.optional()&&(path=path.concat("/"));var v=node.value();if("string"==typeof v)for(var strV=v,__ret=extractUsedParamNames(strV),parameterUsages=__ret.parameterUsages,_i=0,parameterUsages_2=parameterUsages;_i<parameterUsages_2.length;_i++){var pu=parameterUsages_2[_i],paths=paramPaths[pu];null==paths&&(paths=[],paramPaths[pu]=paths),paths.push(path)}else for(var _a=0,_b=node.children();_a<_b.length;_a++){var ch=_b[_a];fillParamPaths(ch,paramPaths,path.concat(ch.key()))}}function fillTemplateType(result,node){var usages={},paramPaths={};templateFields(node,usages),fillParamPaths(node.lowLevel(),paramPaths);for(var _i=0,_a=Object.keys(paramPaths);_i<_a.length;_i++){var pu=_a[_i];paramPaths[pu]=_.unique(paramPaths[pu])}result.getAdapter(services.RAMLService).setInlinedTemplates(!0),Object.keys(usages).forEach(function(x){var propSource=null;usages[x].length>0&&(propSource=usages[x][0].attr);var prop=new defs.UserDefinedProp(x,propSource);prop.withDomain(result);var paths=paramPaths[x];prop.getAdapter(services.RAMLPropertyService).putMeta("templatePaths",paths);var defaultType;if("RAML10"==node.definition().universe().version()){var hasString=usages[x].filter(function(y){return universeHelpers.isStringTypeType(y.tp)}).length>0;defaultType=hasString?universes.Universe10.StringType.name:universes.Universe10.AnyType.name}else defaultType=universes.Universe08.StringType.name;var tp=_.unique(usages[x].map(function(x){return x.tp})).filter(function(x){return x&&x.nameId()!=defaultType});prop.withRange(1==tp.length?tp[0]:node.definition().universe().type(defaultType)),prop.withRequired(!0),1==tp.length&&"RAML10"==node.definition().universe().version()&&tp[0].key()==universes.Universe10.SchemaString&&prop.getAdapter(services.RAMLPropertyService).setTypeExpression(!0),prop.unmerge()});var keyProp=new defs.UserDefinedProp("____key",node);return keyProp.withDomain(result),keyProp.withKey(!0),keyProp.withFromParentKey(!0),keyProp.withRange(node.definition().universe().type(universes.Universe08.StringType.name)),result}function fillReferenceType(result,def){"RAML08"==def.universe().version()&&result.getAdapter(services.RAMLService).withAllowAny();var p=def.property(def.getAdapter(services.RAMLService).getReferenceIs());return p&&p.range().properties().forEach(function(x){var prop=new defs.Property(x.nameId());prop.unmerge(),prop.withDomain(result),prop.withRange(x.range()),prop.withMultiValue(x.isMultiValue())}),result}function typeFromNode(node){if(!node)return null;if(node.associatedType())return node.associatedType();var u=node.lowLevel().unit(),upath=u?u.path():"";ramlTypes.setPropertyConstructor(function(x){var propertySource=null,rs=node.elementsOfKind("properties").filter(function(y){return y.name()==x});rs&&(propertySource=rs[0]);var v=new defs.UserDefinedProp(x,propertySource);return v.unmerge(),v});try{var def=node.definition();if(node.property()&&node.property().nameId()==universes.Universe10.LibraryBase.properties.annotationTypes.name){var result=new AnnotationType(node.name(),node.definition().universe(),node,upath,""),st=getSimpleType(node);result._superTypes.push(st),0==node.elementsOfKind(universes.Universe10.ObjectTypeDeclaration.properties.properties.name).length&&result.getAdapter(services.RAMLService).withAllowAny();var extType=def.getAdapter(services.RAMLService).getExtendedType();return extType&&result._superTypes.push(extType),result}var result=new defs.UserDefinedClass(node.name(),node.definition().universe(),node,upath,"");if(node.setAssociatedType(result),def.getAdapter(services.RAMLService).isInlinedTemplates())return fillTemplateType(result,node);if(def.getAdapter(services.RAMLService).getReferenceIs())return fillReferenceType(result,def);var rs=getSimpleType(node);rs.getAdapter(services.RAMLService).setDeclaringNode(node),node.setAssociatedType(rs)}finally{ramlTypes.setPropertyConstructor(null)}return rs}function getSimpleType(node){return ramlTypes.toNominal(node.parsedType(),function(x){var m=node.definition().universe().type(x);if(!m){new defs.UserDefinedClass("",node.definition().universe(),node,"","")}return m})}function transform(u){return function(x){var m=u.type(x);if(!m){new defs.UserDefinedClass("",u,null,"","")}return m}}function convertType(root,t){var node=_.find(root.elementsOfKind("types"),function(x){return x.name()==t.name()});node&&ramlTypes.setPropertyConstructor(function(x){var rs=node.elementsOfKind("properties").filter(function(y){return y.name()==x}),propertySource=null;if(rs&&rs.length>0)propertySource=rs[0];else{var rs=node.elementsOfKind("facets").filter(function(y){return y.name()==x});rs&&rs.length>0&&(propertySource=rs[0])}var v=new defs.UserDefinedProp(x,propertySource);return v.unmerge(),v});var u=transform(root.definition().universe());return ramlTypes.toNominal(t,u)}var __extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},defs=__webpack_require__(36),ramlTypes=defs.rt,_=__webpack_require__(61),universes=__webpack_require__(22),hlimpl=__webpack_require__(16),services=defs,linter=__webpack_require__(25),universeHelpers=__webpack_require__(14);ramlTypes.setPropertyConstructor(function(x){var v=new defs.Property(x);return v.unmerge(),v});var extractUsedParamNames=function(strV){for(var parameterUsages=[],ps=0;;){var pos=strV.indexOf("<<",ps);if(pos==-1)break;var end=strV.indexOf(">>",pos),isFull=0==pos&&end==strV.length-2,parameterUsage=strV.substring(pos+2,end);ps=pos+2;var directiveIndex=parameterUsage.indexOf("|");directiveIndex!=-1&&(parameterUsage=parameterUsage.substring(0,directiveIndex)),parameterUsage=parameterUsage.trim(),parameterUsages.push(parameterUsage)}return{parameterUsages:parameterUsages,isFull:isFull}},handleValue=function(strV,d,prop,allwaysString,u){var __ret=extractUsedParamNames(strV),parameterUsages=__ret.parameterUsages,isFull=__ret.isFull,r=prop?prop.property().range():null;prop&&(prop.property().nameId()!=universes.Universe10.TypeDeclaration.properties.type.name&&prop.property().nameId()!=universes.Universe10.TypeDeclaration.properties.schema.name||prop.property().domain().key()==universes.Universe10.TypeDeclaration&&(r=u.type(universes.Universe10.SchemaString.name))),!isFull||allwaysString?r=u.type(universes.Universe10.StringType.name):null==r&&"RAML10"==u.version()&&(r=u.type(universes.Universe10.AnyType.name));for(var _i=0,parameterUsages_1=parameterUsages;_i<parameterUsages_1.length;_i++){var parameterUsage=parameterUsages_1[_i];if(null==linter.RESERVED_TEMPLATE_PARAMETERS[parameterUsage]){var q=d[parameterUsage];q?q.push({tp:r,attr:prop}):d[parameterUsage]=[{tp:r,attr:prop}]}}},AnnotationType=function(_super){function AnnotationType(){_super.apply(this,arguments)}return __extends(AnnotationType,_super),AnnotationType.prototype.allProperties=function(ps){void 0===ps&&(ps={});var rs=this.superTypes()[0].allProperties();if(1==rs.length&&"annotations"==rs[0].nameId()){var propertyNode=this.getAdapter(defs.RAMLService).getDeclaringNode(),property=new defs.UserDefinedProp("value",propertyNode);property.withDomain(this),property.withCanBeValue(),property.withRequired(!1);this.superTypes()[0];rs=[],property.withRange(property.node().asElement().definition().universe().type("string")),rs.push(property)}return rs},AnnotationType.prototype.isAnnotationType=function(){return!0},AnnotationType}(defs.UserDefinedClass);exports.typeFromNode=typeFromNode,exports.convertType=convertType},function(module,exports,__webpack_require__){"use strict";function isMultiLine(s){return s&&s.indexOf("\n")>=0}function isMultiLineValue(s){return isMultiLine(s)&&s.length>2&&"|"==s[0]&&("\n"==s[1]||"\r"==s[1]||"\n"==s[2])}function makeMutiLine(s,lev){var xbuf="";if(isMultiLine(s)){xbuf+="|\n";for(var lines=splitOnLines(s),i=0;i<lines.length;i++)xbuf+=indent(lev,lines[i])}else xbuf+=s;return xbuf}function fromMutiLine(s){if(!isMultiLineValue(s))return s;for(var res=null,lines=splitOnLines(s),i=1;i<lines.length;i++){var line=lines[i],str=line.substring(2);res?res+=str:res=str}return res}function trimStart(s){if(!s)return s;for(var pos=0;pos<s.length;){var ch=s[pos];if("\r"!=ch&&"\n"!=ch&&" "!=ch&&"\t"!=ch)break;pos++}return s.substring(pos,s.length)}function indent(lev,str){void 0===str&&(str="");for(var leading="",i=0;i<lev;i++)leading+="  ";return leading+str}function print(lev,str){void 0===str&&(str=""),console.log(indent(lev,str))}function replaceNewlines(s,rep){void 0===rep&&(rep=null);for(var res="",i=0;i<s.length;i++){var ch=s[i];"\r"==ch&&(ch=null==rep?"\\r":rep),"\n"==ch&&(ch=null==rep?"\\n":rep),res+=ch}return res}function trimEnd(s){for(var pos=s.length;pos>0;){var ch=s[pos-1];if(" "!=ch&&"\t"!=ch&&"\r"!=ch&&"\n"!=ch)break;pos--}return s.substring(0,pos)}function trim(s){return trimStart(trimEnd(s))}function splitOnLines(text){
var lines=text.match(/^.*((\r\n|\n|\r)|$)/gm);return lines}function startsWith(s,suffix){if(!s||!suffix||s.length<suffix.length)return!1;for(var i=0;i<suffix.length;i++)if(s[i]!=suffix[i])return!1;return!0}function endsWith(s,suffix){if(!s||!suffix||s.length<suffix.length)return!1;for(var i=0;i<suffix.length;i++)if(s[s.length-1-i]!=suffix[suffix.length-1-i])return!1;return!0}function capitalize(s){return s.charAt(0).toUpperCase()+s.slice(1)}exports.isMultiLine=isMultiLine,exports.isMultiLineValue=isMultiLineValue,exports.makeMutiLine=makeMutiLine,exports.fromMutiLine=fromMutiLine,exports.trimStart=trimStart,exports.indent=indent,exports.print=print,exports.replaceNewlines=replaceNewlines,exports.trimEnd=trimEnd,exports.trim=trim,exports.splitOnLines=splitOnLines,exports.startsWith=startsWith,exports.endsWith=endsWith,exports.capitalize=capitalize;var TextRange=function(){function TextRange(contents,start,end){this.contents=contents,this.start=start,this.end=end}return TextRange.prototype.text=function(){return this.contents.substring(this.start,this.end)},TextRange.prototype.startpos=function(){return this.start},TextRange.prototype.endpos=function(){return this.end},TextRange.prototype.len=function(){return this.end-this.start},TextRange.prototype.unitText=function(){return this.contents},TextRange.prototype.withStart=function(start){return new TextRange(this.contents,start,this.end)},TextRange.prototype.withEnd=function(end){return new TextRange(this.contents,this.start,end)},TextRange.prototype.sub=function(start,end){return this.contents.substring(start,end)},TextRange.prototype.trimStart=function(){for(var pos=this.start;pos<this.contents.length-1;){var ch=this.contents[pos];if(" "!=ch&&"\t"!=ch)break;pos++}return new TextRange(this.contents,pos,this.end)},TextRange.prototype.trimEnd=function(){for(var pos=this.end;pos>0;){var ch=this.contents[pos-1];if(" "!=ch&&"\t"!=ch)break;pos--}return new TextRange(this.contents,this.start,pos)},TextRange.prototype.extendToStartOfLine=function(){for(var pos=this.start;pos>0;){var prevchar=this.contents[pos-1];if("\r"==prevchar||"\n"==prevchar)break;pos--}return new TextRange(this.contents,pos,this.end)},TextRange.prototype.extendAnyUntilNewLines=function(){var pos=this.end;if(pos>0){var last=this.contents[pos-1];if("\n"==last)return this}for(;pos<this.contents.length-1;){var nextchar=this.contents[pos];if("\r"==nextchar||"\n"==nextchar)break;pos++}return new TextRange(this.contents,this.start,pos)},TextRange.prototype.extendSpacesUntilNewLines=function(){var pos=this.end;if(pos>0){var last=this.contents[pos-1];if("\n"==last)return this}for(;pos<this.contents.length-1;){var nextchar=this.contents[pos];if(" "!=nextchar||"\r"==nextchar||"\n"==nextchar)break;pos++}return new TextRange(this.contents,this.start,pos)},TextRange.prototype.extendSpaces=function(){for(var pos=this.end;pos<this.contents.length-1;){var nextchar=this.contents[pos];if(" "!=nextchar)break;pos++}return new TextRange(this.contents,this.start,pos)},TextRange.prototype.extendSpacesBack=function(){for(var pos=this.start;pos>0;){var nextchar=this.contents[pos-1];if(" "!=nextchar)break;pos--}return new TextRange(this.contents,pos,this.end)},TextRange.prototype.extendCharIfAny=function(ch){var pos=this.end;return pos<this.contents.length-1&&this.contents[pos]==ch&&pos++,new TextRange(this.contents,this.start,pos)},TextRange.prototype.extendCharIfAnyBack=function(ch){var pos=this.start;return pos>0&&this.contents[pos-1]==ch&&pos--,new TextRange(this.contents,pos,this.end)},TextRange.prototype.extendToNewlines=function(){var pos=this.end;if(pos>0){var last=this.contents[pos-1];if("\n"==last)return this}for(;pos<this.contents.length-1;){var nextchar=this.contents[pos];if("\r"!=nextchar&&"\n"!=nextchar)break;pos++}return new TextRange(this.contents,this.start,pos)},TextRange.prototype.extendUntilNewlinesBack=function(){for(var pos=this.start;pos>0;){var nextchar=this.contents[pos-1];if("\r"==nextchar||"\n"==nextchar)break;pos--}return new TextRange(this.contents,pos,this.end)},TextRange.prototype.reduceNewlinesEnd=function(){for(var pos=this.end;pos>this.start;){var last=this.contents[pos-1];if("\r"!=last&&"\n"!=last)break;pos--}return new TextRange(this.contents,this.start,pos)},TextRange.prototype.reduceSpaces=function(){for(var pos=this.end;pos>this.start;){var last=this.contents[pos-1];if(" "!=last)break;pos--}return new TextRange(this.contents,this.start,pos)},TextRange.prototype.replace=function(text){return this.sub(0,this.start)+text+this.sub(this.end,this.unitText().length)},TextRange.prototype.remove=function(){return this.sub(0,this.start)+this.sub(this.end,this.unitText().length)},TextRange}();exports.TextRange=TextRange},function(module,exports,__webpack_require__){"use strict";function getWrapperConstructor(definition){return definition.isBuiltIn()?classMap[definition.nameId()]:null}function buildWrapperNode(node,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0);var definition=node.definition(),wrapperConstructor=(definition.nameId(),getWrapperConstructor(definition));if(!wrapperConstructor){for(var priorities=determineSuperclassesPriorities(definition),superTypes=definition.allSuperTypes().sort(function(x,y){return priorities[x.nameId()]-priorities[y.nameId()]}),wr=null,i=0;i<superTypes.length;i++){var superTypeName=superTypes[i].nameId();if(wrapperConstructor=getWrapperConstructor(superTypes[i]),"DataElement"!=superTypeName){if("hl.BasicNode"!=superTypeName&&wrapperConstructor)break}else wr=superTypeName}wrapperConstructor||(wr=superTypeName)}return wrapperConstructor||(wrapperConstructor=classMap["hl.BasicNode"]),wrapperConstructor(node,setAsTopLevel)}function determineSuperclassesPriorities(td,priorities,path){void 0===priorities&&(priorities={}),void 0===path&&(path={});var typeName=td.nameId();if(!path[typeName]){path[typeName]=!0;var rank=null!=priorities[typeName]&&priorities[typeName]+1||0,superTypes=td.superTypes();return superTypes.forEach(function(x){var name=x.nameId(),r=priorities[name];(null==r||rank>r)&&(priorities[name]=rank,determineSuperclassesPriorities(x,priorities,path))}),delete path[typeName],priorities}}var RamlWrapper=__webpack_require__(20);exports.buildWrapperNode=buildWrapperNode;var classMap={AbstractSecurityScheme:function(x,y){return new RamlWrapper.AbstractSecuritySchemeImpl(x,y)},Annotable:function(x,y){return new RamlWrapper.AnnotableImpl(x,y)},AnnotationRef:function(x){return new RamlWrapper.AnnotationRefImpl(x)},AnnotationTarget:function(x){return new RamlWrapper.AnnotationTargetImpl(x)},AnyType:function(x){return new RamlWrapper.AnyTypeImpl(x)},Api:function(x,y){return new RamlWrapper.ApiImpl(x,y)},ArrayTypeDeclaration:function(x,y){return new RamlWrapper.ArrayTypeDeclarationImpl(x,y)},BasicSecurityScheme:function(x,y){return new RamlWrapper.BasicSecuritySchemeImpl(x,y)},BooleanType:function(x){return new RamlWrapper.BooleanTypeImpl(x)},BooleanTypeDeclaration:function(x,y){return new RamlWrapper.BooleanTypeDeclarationImpl(x,y)},ContentType:function(x){return new RamlWrapper.ContentTypeImpl(x)},CustomSecurityScheme:function(x,y){return new RamlWrapper.CustomSecuritySchemeImpl(x,y)},DateOnlyType:function(x){return new RamlWrapper.DateOnlyTypeImpl(x)},DateOnlyTypeDeclaration:function(x,y){return new RamlWrapper.DateOnlyTypeDeclarationImpl(x,y)},DateTimeOnlyType:function(x){return new RamlWrapper.DateTimeOnlyTypeImpl(x)},DateTimeOnlyTypeDeclaration:function(x,y){return new RamlWrapper.DateTimeOnlyTypeDeclarationImpl(x,y)},DateTimeType:function(x){return new RamlWrapper.DateTimeTypeImpl(x)},DateTimeTypeDeclaration:function(x,y){return new RamlWrapper.DateTimeTypeDeclarationImpl(x,y)},DateTypeDeclaration:function(x,y){return new RamlWrapper.DateTypeDeclarationImpl(x,y)},DigestSecurityScheme:function(x,y){return new RamlWrapper.DigestSecuritySchemeImpl(x,y)},DocumentationItem:function(x,y){return new RamlWrapper.DocumentationItemImpl(x,y)},Extension:function(x,y){return new RamlWrapper.ExtensionImpl(x,y)},FileType:function(x){return new RamlWrapper.FileTypeImpl(x)},FileTypeDeclaration:function(x,y){return new RamlWrapper.FileTypeDeclarationImpl(x,y)},FixedUriString:function(x){return new RamlWrapper.FixedUriStringImpl(x)},FragmentDeclaration:function(x,y){return new RamlWrapper.FragmentDeclarationImpl(x,y)},FullUriTemplateString:function(x){return new RamlWrapper.FullUriTemplateStringImpl(x)},IntegerType:function(x){return new RamlWrapper.IntegerTypeImpl(x)},IntegerTypeDeclaration:function(x,y){return new RamlWrapper.IntegerTypeDeclarationImpl(x,y)},Library:function(x,y){return new RamlWrapper.LibraryImpl(x,y)},LibraryBase:function(x,y){return new RamlWrapper.LibraryBaseImpl(x,y)},LocationKind:function(x){return new RamlWrapper.LocationKindImpl(x)},MarkdownString:function(x){return new RamlWrapper.MarkdownStringImpl(x)},Method:function(x,y){return new RamlWrapper.MethodImpl(x,y)},MethodBase:function(x,y){return new RamlWrapper.MethodBaseImpl(x,y)},MimeType:function(x){return new RamlWrapper.MimeTypeImpl(x)},ModelLocation:function(x){return new RamlWrapper.ModelLocationImpl(x)},NullType:function(x){return new RamlWrapper.NullTypeImpl(x)},NumberType:function(x){return new RamlWrapper.NumberTypeImpl(x)},NumberTypeDeclaration:function(x,y){return new RamlWrapper.NumberTypeDeclarationImpl(x,y)},OAuth1SecurityScheme:function(x,y){return new RamlWrapper.OAuth1SecuritySchemeImpl(x,y)},OAuth1SecuritySchemeSettings:function(x,y){return new RamlWrapper.OAuth1SecuritySchemeSettingsImpl(x,y)},OAuth2SecurityScheme:function(x,y){return new RamlWrapper.OAuth2SecuritySchemeImpl(x,y)},OAuth2SecuritySchemeSettings:function(x,y){return new RamlWrapper.OAuth2SecuritySchemeSettingsImpl(x,y)},ObjectTypeDeclaration:function(x,y){return new RamlWrapper.ObjectTypeDeclarationImpl(x,y)},Operation:function(x,y){return new RamlWrapper.OperationImpl(x,y)},Overlay:function(x,y){return new RamlWrapper.OverlayImpl(x,y)},PassThroughSecurityScheme:function(x,y){return new RamlWrapper.PassThroughSecuritySchemeImpl(x,y)},Reference:function(x){return new RamlWrapper.ReferenceImpl(x)},RelativeUriString:function(x){return new RamlWrapper.RelativeUriStringImpl(x)},Resource:function(x,y){return new RamlWrapper.ResourceImpl(x,y)},ResourceBase:function(x,y){return new RamlWrapper.ResourceBaseImpl(x,y)},ResourceType:function(x,y){return new RamlWrapper.ResourceTypeImpl(x,y)},ResourceTypeRef:function(x){return new RamlWrapper.ResourceTypeRefImpl(x)},Response:function(x,y){return new RamlWrapper.ResponseImpl(x,y)},SchemaString:function(x){return new RamlWrapper.SchemaStringImpl(x)},SecuritySchemePart:function(x,y){return new RamlWrapper.SecuritySchemePartImpl(x,y)},SecuritySchemeRef:function(x){return new RamlWrapper.SecuritySchemeRefImpl(x)},SecuritySchemeSettings:function(x,y){return new RamlWrapper.SecuritySchemeSettingsImpl(x,y)},StatusCodeString:function(x){return new RamlWrapper.StatusCodeStringImpl(x)},StringType:function(x){return new RamlWrapper.StringTypeImpl(x)},StringTypeDeclaration:function(x,y){return new RamlWrapper.StringTypeDeclarationImpl(x,y)},TimeOnlyType:function(x){return new RamlWrapper.TimeOnlyTypeImpl(x)},TimeOnlyTypeDeclaration:function(x,y){return new RamlWrapper.TimeOnlyTypeDeclarationImpl(x,y)},Trait:function(x,y){return new RamlWrapper.TraitImpl(x,y)},TraitRef:function(x){return new RamlWrapper.TraitRefImpl(x)},TypeDeclaration:function(x,y){return new RamlWrapper.TypeDeclarationImpl(x,y)},UnionTypeDeclaration:function(x,y){return new RamlWrapper.UnionTypeDeclarationImpl(x,y)},UriTemplate:function(x){return new RamlWrapper.UriTemplateImpl(x)},UsesDeclaration:function(x,y){return new RamlWrapper.UsesDeclarationImpl(x,y)},ValueType:function(x){return new RamlWrapper.ValueTypeImpl(x)},XMLFacetInfo:function(x,y){return new RamlWrapper.XMLFacetInfoImpl(x,y)}}},function(module,exports,__webpack_require__){"use strict";function getWrapperConstructor(definition){return definition.isBuiltIn()?classMap[definition.nameId()]:null}function buildWrapperNode(node,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0);var definition=node.definition(),wrapperConstructor=(definition.nameId(),getWrapperConstructor(definition));if(!wrapperConstructor){for(var priorities=determineSuperclassesPriorities(definition),superTypes=definition.allSuperTypes().sort(function(x,y){return priorities[x.nameId()]-priorities[y.nameId()]}),wr=null,i=0;i<superTypes.length;i++){var superTypeName=superTypes[i].nameId();if(wrapperConstructor=getWrapperConstructor(superTypes[i]),"DataElement"!=superTypeName){if("hl.BasicNode"!=superTypeName&&wrapperConstructor)break}else wr=superTypeName}wrapperConstructor||(wr=superTypeName)}return wrapperConstructor||(wrapperConstructor=classMap["hl.BasicNode"]),wrapperConstructor(node,setAsTopLevel)}function determineSuperclassesPriorities(td,priorities,path){void 0===priorities&&(priorities={}),void 0===path&&(path={});var typeName=td.nameId();if(!path[typeName]){path[typeName]=!0;var rank=null!=priorities[typeName]&&priorities[typeName]+1||0,superTypes=td.superTypes();return superTypes.forEach(function(x){var name=x.nameId(),r=priorities[name];(null==r||rank>r)&&(priorities[name]=rank,determineSuperclassesPriorities(x,priorities,path))}),delete path[typeName],priorities}}var RamlWrapper=__webpack_require__(47);exports.buildWrapperNode=buildWrapperNode;var classMap={AbstractSecurityScheme:function(x,y){return new RamlWrapper.AbstractSecuritySchemeImpl(x,y)},AnyType:function(x){return new RamlWrapper.AnyTypeImpl(x)},Api:function(x,y){return new RamlWrapper.ApiImpl(x,y)},BasicSecurityScheme:function(x,y){return new RamlWrapper.BasicSecuritySchemeImpl(x,y)},BodyLike:function(x,y){return new RamlWrapper.BodyLikeImpl(x,y)},BooleanType:function(x){return new RamlWrapper.BooleanTypeImpl(x)},BooleanTypeDeclaration:function(x,y){return new RamlWrapper.BooleanTypeDeclarationImpl(x,y)},CustomSecurityScheme:function(x,y){return new RamlWrapper.CustomSecuritySchemeImpl(x,y)},DateTypeDeclaration:function(x,y){return new RamlWrapper.DateTypeDeclarationImpl(x,y)},DigestSecurityScheme:function(x,y){return new RamlWrapper.DigestSecuritySchemeImpl(x,y)},DocumentationItem:function(x,y){return new RamlWrapper.DocumentationItemImpl(x,y)},ExampleString:function(x){return new RamlWrapper.ExampleStringImpl(x)},FileTypeDeclaration:function(x,y){return new RamlWrapper.FileTypeDeclarationImpl(x,y)},FixedUri:function(x){return new RamlWrapper.FixedUriImpl(x)},FullUriTemplateString:function(x){return new RamlWrapper.FullUriTemplateStringImpl(x)},GlobalSchema:function(x,y){return new RamlWrapper.GlobalSchemaImpl(x,y)},IntegerTypeDeclaration:function(x,y){return new RamlWrapper.IntegerTypeDeclarationImpl(x,y)},JSONBody:function(x,y){return new RamlWrapper.JSONBodyImpl(x,y)},JSONExample:function(x){return new RamlWrapper.JSONExampleImpl(x)},JSonSchemaString:function(x){return new RamlWrapper.JSonSchemaStringImpl(x)},MarkdownString:function(x){return new RamlWrapper.MarkdownStringImpl(x)},Method:function(x,y){return new RamlWrapper.MethodImpl(x,y)},MethodBase:function(x,y){return new RamlWrapper.MethodBaseImpl(x,y)},MimeType:function(x){return new RamlWrapper.MimeTypeImpl(x)},NumberType:function(x){return new RamlWrapper.NumberTypeImpl(x)},NumberTypeDeclaration:function(x,y){return new RamlWrapper.NumberTypeDeclarationImpl(x,y)},OAuth1SecurityScheme:function(x,y){return new RamlWrapper.OAuth1SecuritySchemeImpl(x,y)},OAuth1SecuritySchemeSettings:function(x,y){return new RamlWrapper.OAuth1SecuritySchemeSettingsImpl(x,y)},OAuth2SecurityScheme:function(x,y){return new RamlWrapper.OAuth2SecuritySchemeImpl(x,y)},OAuth2SecuritySchemeSettings:function(x,y){return new RamlWrapper.OAuth2SecuritySchemeSettingsImpl(x,y)},Parameter:function(x,y){return new RamlWrapper.ParameterImpl(x,y)},ParameterLocation:function(x){return new RamlWrapper.ParameterLocationImpl(x)},RAMLSimpleElement:function(x,y){return new RamlWrapper.RAMLSimpleElementImpl(x,y)},Reference:function(x){return new RamlWrapper.ReferenceImpl(x)},RelativeUriString:function(x){return new RamlWrapper.RelativeUriStringImpl(x)},Resource:function(x,y){return new RamlWrapper.ResourceImpl(x,y)},ResourceType:function(x,y){return new RamlWrapper.ResourceTypeImpl(x,y)},ResourceTypeRef:function(x){return new RamlWrapper.ResourceTypeRefImpl(x)},Response:function(x,y){return new RamlWrapper.ResponseImpl(x,y)},SchemaString:function(x){return new RamlWrapper.SchemaStringImpl(x)},SecuritySchemePart:function(x,y){return new RamlWrapper.SecuritySchemePartImpl(x,y)},SecuritySchemeRef:function(x){return new RamlWrapper.SecuritySchemeRefImpl(x)},SecuritySchemeSettings:function(x,y){return new RamlWrapper.SecuritySchemeSettingsImpl(x,y)},StatusCodeString:function(x){return new RamlWrapper.StatusCodeStringImpl(x)},StringType:function(x){return new RamlWrapper.StringTypeImpl(x)},StringTypeDeclaration:function(x,y){return new RamlWrapper.StringTypeDeclarationImpl(x,y)},Trait:function(x,y){return new RamlWrapper.TraitImpl(x,y)},TraitRef:function(x){return new RamlWrapper.TraitRefImpl(x)},UriTemplate:function(x){return new RamlWrapper.UriTemplateImpl(x)},ValueType:function(x){return new RamlWrapper.ValueTypeImpl(x)},XMLBody:function(x,y){return new RamlWrapper.XMLBodyImpl(x,y)},XMLExample:function(x){return new RamlWrapper.XMLExampleImpl(x)},XMLSchemaString:function(x){return new RamlWrapper.XMLSchemaStringImpl(x)}}},function(module,exports,__webpack_require__){module.exports=__WEBPACK_EXTERNAL_MODULE_44__},function(module,exports,__webpack_require__){"use strict";function toStructuredValue(node){var value=node.value();if("string"==typeof value||null==value){var mockNode=jsyaml.createNode(value);mockNode._actualNode().startPosition=node.lowLevel().valueStart(),mockNode._actualNode().endPosition=node.lowLevel().valueEnd();var stv=new hlImpl.StructuredValue(mockNode,node.parent(),node.property());return stv}return value}function fillElementMeta(node){var meta=node._meta;meta.resetPrimitiveValuesMeta();var highLevelNode=node.highLevel();return highLevelNode.definition().allProperties().forEach(function(p){var name=p.nameId(),attrs=highLevelNode.attributes(name),gotValue=!1,optional=!1;if(attrs.forEach(function(a){gotValue=gotValue||null!=a.value(),optional=optional||a.optional()}),!gotValue){var calculator=node.getDefaultsCalculator(),defVal=calculator.attributeDefaultIfEnabled(highLevelNode,p);if(null!=defVal){var insertionKind=calculator.insertionKind(highLevelNode,p);insertionKind==defaultCalculator.InsertionKind.CALCULATED?meta.registerCalculatedValue(name):insertionKind==defaultCalculator.InsertionKind.BY_DEFAULT&&meta.registerInsertedAsDefaultValue(name)}}}),meta}function attributesToValues(attrs,constr){return constr?attrs.map(function(x){return constr(x)}):attrs.map(function(x){return x.value()})}var __extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},hlImpl=__webpack_require__(16),jsyaml=__webpack_require__(27),defaultCalculator=(__webpack_require__(36),__webpack_require__(68)),search=__webpack_require__(23),universeHelpers=__webpack_require__(14),tckDumper=__webpack_require__(69),yaml=__webpack_require__(70),BasicNodeImpl=function(){function BasicNodeImpl(_node,setAsWrapper){void 0===setAsWrapper&&(setAsWrapper=!0),this._node=_node,this._meta=new NodeMetadataImpl((!1),(!1),universeHelpers.isMethodType(this.highLevel().definition())&&this.optional()),setAsWrapper&&_node.setWrapperNode(this)}return BasicNodeImpl.prototype.wrapperClassName=function(){return"BasicNodeImpl"},BasicNodeImpl.prototype.kind=function(){return"BasicNode"},BasicNodeImpl.prototype.parent=function(){var parent=this._node.parent();return parent?parent.wrapperNode():null},BasicNodeImpl.prototype.highLevel=function(){return this._node},BasicNodeImpl.prototype.attributes=function(name,constr){var attrs=this._node.attributes(name);if(!attrs||0==attrs.length){var defaultValue=this.getDefaultsCalculator().attributeDefaultIfEnabled(this._node,this._node.definition().property(name));return null==defaultValue?[]:Array.isArray(defaultValue)?defaultValue:[defaultValue]}return attributesToValues(attrs,constr)},BasicNodeImpl.prototype.attribute=function(name,constr){var attr=this._node.attr(name);if(constr&&constr!=this.toString&&constr!=this.toBoolean&&constr!=this.toNumber&&constr!=this.toAny)return null==attr?null:constr(attr);var attributeValue=attr?attr.value():null;return null==attributeValue&&(attributeValue=this.getDefaultsCalculator().attributeDefaultIfEnabled(this._node,this._node.definition().property(name))),null==attributeValue?null:constr?constr(attributeValue):attributeValue},BasicNodeImpl.prototype.elements=function(name){var elements=this._node.elementsOfKind(name);return elements?elements.map(function(x){return x.wrapperNode()}):null},BasicNodeImpl.prototype.element=function(name){var element=this._node.element(name);return element?element.wrapperNode():null},BasicNodeImpl.prototype.add=function(node){this.highLevel().add(node.highLevel())},BasicNodeImpl.prototype.addToProp=function(node,prop){var hl=node.highLevel(),pr=this.highLevel().definition().property(prop);hl._prop=pr,this.highLevel().add(hl)},BasicNodeImpl.prototype.remove=function(node){this.highLevel().remove(node.highLevel())},BasicNodeImpl.prototype.dump=function(){return this.highLevel().dump("yaml")},BasicNodeImpl.prototype.toString=function(arg){var obj;return obj=arg.lowLevel&&arg.property?arg.value():arg,null!=obj?obj.toString():obj},BasicNodeImpl.prototype.toAny=function(arg){return arg},BasicNodeImpl.prototype.toBoolean=function(arg){var obj;return obj=arg.lowLevel&&arg.property?arg.value():arg,null!=obj?"true"==obj.toString():obj},BasicNodeImpl.prototype.toNumber=function(arg){var obj;if(obj=arg.lowLevel&&arg.property?arg.value():arg,!obj)return obj;try{var nValue=parseFloat(obj.toString());return nValue}catch(e){}return Number.MAX_VALUE},BasicNodeImpl.prototype.errors=function(){var _this=this,issues=[],highLevelErrors=this._node.errors();null!=highLevelErrors&&(issues=issues.concat(highLevelErrors));var lineMapper=this._node.lowLevel().unit().lineMapper(),result=issues.map(function(x){var startPoint=null;try{startPoint=x.node.lowLevel().unit().lineMapper().position(x.start)}catch(e){console.warn(e);try{startPoint=lineMapper.position(x.start)}catch(e1){console.warn(e1)}}var endPoint=null;try{endPoint=lineMapper.position(x.end)}catch(e){console.warn(e)}var path;return path=x.path?x.path:x.node?x.node.lowLevel().unit().path():search.declRoot(_this.highLevel()).lowLevel().unit().path(),{code:x.code,message:x.message,path:path,start:x.start,end:x.end,line:startPoint?startPoint.errorMessage?null:startPoint.line:null,column:startPoint?startPoint.errorMessage?null:startPoint.column:null,range:[startPoint,endPoint],isWarning:x.isWarning}});return result},BasicNodeImpl.prototype.definition=function(){return this.highLevel().definition()},BasicNodeImpl.prototype.runtimeDefinition=function(){return universeHelpers.isTypeDeclarationSibling(this.highLevel().definition())?this.highLevel().localType():null},BasicNodeImpl.prototype.toJSON=function(serializeOptions){var oldDefaults=defaultAttributeDefaultsValue;defaultAttributeDefaultsValue=this.attributeDefaults();try{return new tckDumper.TCKDumper(serializeOptions).dump(this)}finally{defaultAttributeDefaultsValue=oldDefaults}},BasicNodeImpl.prototype.optional=function(){var highLevel=this.highLevel();return null!=highLevel&&highLevel.optional()},BasicNodeImpl.prototype.optionalProperties=function(){return this.highLevel()?this.highLevel().optionalProperties():[]},BasicNodeImpl.prototype.getDefaultsCalculator=function(){return this.defaultsCalculator?this.defaultsCalculator:(this.parent()&&(this.defaultsCalculator=this.parent().getDefaultsCalculator()),this.defaultsCalculator||(this.defaultsCalculator=new defaultCalculator.AttributeDefaultsCalculator(defaultAttributeDefaultsValue)),this.defaultsCalculator)},BasicNodeImpl.prototype.setAttributeDefaults=function(attributeDefaults){this.defaultsCalculator=new defaultCalculator.AttributeDefaultsCalculator(attributeDefaults)},BasicNodeImpl.prototype.attributeDefaults=function(){return this.getDefaultsCalculator()&&this.getDefaultsCalculator().isEnabled()},BasicNodeImpl.prototype.meta=function(){return fillElementMeta(this)},BasicNodeImpl.prototype.RAMLVersion=function(){return this.highLevel().definition().universe().version()},BasicNodeImpl}();exports.BasicNodeImpl=BasicNodeImpl;var defaultAttributeDefaultsValue=!0,AttributeNodeImpl=function(){function AttributeNodeImpl(attr){this._meta=new ValueMetadataImpl,this.attr=attr}return AttributeNodeImpl.prototype.highLevel=function(){return this.attr},AttributeNodeImpl.prototype.wrapperClassName=function(){return"AttributeNodeImpl"},AttributeNodeImpl.prototype.kind=function(){return"AttributeNode"},AttributeNodeImpl.prototype.optional=function(){var highLevel=this.highLevel();return null!=highLevel&&highLevel.optional()},AttributeNodeImpl.prototype.meta=function(){return this._meta},AttributeNodeImpl.prototype.RAMLVersion=function(){return this.highLevel().definition().universe().version()},AttributeNodeImpl.prototype.parent=function(){var parent=this.attr.parent();return parent?parent.wrapperNode():null},AttributeNodeImpl.prototype.toJSON=function(serializeOptions){return new tckDumper.TCKDumper(serializeOptions).dump(this)},AttributeNodeImpl}();exports.AttributeNodeImpl=AttributeNodeImpl,exports.toStructuredValue=toStructuredValue;var TypeInstanceImpl=function(){function TypeInstanceImpl(nodes,type){this.type=type,Array.isArray(nodes)?this.children=nodes:this.node=nodes}return TypeInstanceImpl.prototype.properties=function(){return this.isArray()?[]:this.getChildren().map(function(x){return new TypeInstancePropertyImpl(x)})},TypeInstanceImpl.prototype.getChildren=function(){return this.node&&this.node.children()||this.children},TypeInstanceImpl.prototype.value=function(){return this.node&&this.node.value()},TypeInstanceImpl.prototype.isScalar=function(){return!!this.node&&(0==this.node.children().length&&(!this.type||this.type.isScalar()))},TypeInstanceImpl.prototype.toJSON=function(){return(new tckDumper.TCKDumper).serializeTypeInstance(this)},TypeInstanceImpl.prototype.isArray=function(){return!!this.node&&(this.type?this.type.isArray():this.node&&this.node.valueKind()==yaml.Kind.SEQ)},TypeInstanceImpl.prototype.items=function(){return this.isArray()?this.node.children().map(function(x){return new TypeInstanceImpl(x)}):null},TypeInstanceImpl}();exports.TypeInstanceImpl=TypeInstanceImpl;var TypeInstancePropertyImpl=function(){function TypeInstancePropertyImpl(node){this.node=node}return TypeInstancePropertyImpl.prototype.name=function(){return this.node.optional()?this.node.key()+"?":this.node.key()},TypeInstancePropertyImpl.prototype.value=function(){if(this.isArray()){var children=this.node.children();return children.length>0?new TypeInstanceImpl(children[0]):null}return new TypeInstanceImpl(this.node)},TypeInstancePropertyImpl.prototype.values=function(){return this.isArray()?this.node.children().map(function(x){return new TypeInstanceImpl(x)}):[new TypeInstanceImpl(this.node)]},TypeInstancePropertyImpl.prototype.isArray=function(){var children=this.node.children();if(children.length>0&&null==children[0].key())return!0;var hl=this.node.highLevelNode();if(hl){var prop=hl.property();if(prop){var range=prop.range();if(range)return range.isArray()}}return this.node.valueKind()==yaml.Kind.SEQ},TypeInstancePropertyImpl}();exports.TypeInstancePropertyImpl=TypeInstancePropertyImpl;var ValueMetadataImpl=function(){function ValueMetadataImpl(_insertedAsDefault,_calculated,_optional){void 0===_insertedAsDefault&&(_insertedAsDefault=!1),void 0===_calculated&&(_calculated=!1),void 0===_optional&&(_optional=!1),this._insertedAsDefault=_insertedAsDefault,this._calculated=_calculated,this._optional=_optional}return ValueMetadataImpl.prototype.calculated=function(){return this._calculated},ValueMetadataImpl.prototype.insertedAsDefault=function(){return this._insertedAsDefault},ValueMetadataImpl.prototype.setCalculated=function(){this._calculated=!0},ValueMetadataImpl.prototype.setInsertedAsDefault=function(){this._insertedAsDefault=!0},ValueMetadataImpl.prototype.setOptional=function(){this._optional=!0},ValueMetadataImpl.prototype.optional=function(){return this._optional},ValueMetadataImpl.prototype.isDefault=function(){return!(this._insertedAsDefault||this._calculated||this._optional)},ValueMetadataImpl.prototype.toJSON=function(){var obj={};return this._calculated&&(obj.calculated=!0),this._insertedAsDefault&&(obj.insertedAsDefault=!0),this._optional&&(obj.optional=!0),obj},ValueMetadataImpl}();exports.ValueMetadataImpl=ValueMetadataImpl;var NodeMetadataImpl=function(_super){function NodeMetadataImpl(){_super.apply(this,arguments),this.valuesMeta={}}return __extends(NodeMetadataImpl,_super),NodeMetadataImpl.prototype.primitiveValuesMeta=function(){return this.valuesMeta},NodeMetadataImpl.prototype.registerInsertedAsDefaultValue=function(propName){var pMeta=this.valuesMeta[propName];null==pMeta?this.valuesMeta[propName]=new ValueMetadataImpl((!0)):pMeta.setInsertedAsDefault()},NodeMetadataImpl.prototype.registerCalculatedValue=function(propName){var pMeta=this.valuesMeta[propName];null==pMeta?this.valuesMeta[propName]=new ValueMetadataImpl((!1),(!0)):pMeta.setCalculated()},NodeMetadataImpl.prototype.registerOptionalValue=function(propName){var pMeta=this.valuesMeta[propName];null==pMeta?this.valuesMeta[propName]=new ValueMetadataImpl((!1),(!1),(!0)):pMeta.setOptional()},NodeMetadataImpl.prototype.resetPrimitiveValuesMeta=function(){this.valuesMeta={}},NodeMetadataImpl.prototype.isDefault=function(){return!!_super.prototype.isDefault.call(this)&&0==Object.keys(this.valuesMeta).length},NodeMetadataImpl.prototype.toJSON=function(){var _this=this,obj=_super.prototype.toJSON.call(this),valuesObj={},propKeys=Object.keys(this.valuesMeta);return propKeys.length>0&&(propKeys.forEach(function(x){var childMeta=_this.valuesMeta[x].toJSON();Object.keys(childMeta).length>0&&(valuesObj[x]=childMeta)}),obj.primitiveValuesMeta=valuesObj),obj},NodeMetadataImpl}(ValueMetadataImpl);exports.NodeMetadataImpl=NodeMetadataImpl,exports.fillElementMeta=fillElementMeta,exports.attributesToValues=attributesToValues},function(module,exports,__webpack_require__){"use strict";function getExtraProviderSource(extraProvider){var sourceExtra=extraProvider.getExtra(ramlTypes.SOURCE_EXTRA);return null==sourceExtra?null:def.isSourceProvider(sourceExtra)?sourceExtra:lowLevel.isLowLevelNode(sourceExtra)?{getSource:function(){return sourceExtra.highLevelNode()}}:hl.isParseResult(sourceExtra)?{getSource:function(){return sourceExtra}}:null}function getRTypeSource(rType){return getExtraProviderSource(rType)}function findRTypeByNominal(nominalType){var adapters=nominalType.getAdapters();return adapters?_.find(adapters,function(adapter){return def.rt.isParsedType(adapter)}):null}function getNominalTypeSource(nominalType){if(!nominalType)return null;var sourceExtra=nominalType.getExtra(ramlTypes.SOURCE_EXTRA);if(sourceExtra)return getExtraProviderSource(nominalType);var rType=findRTypeByNominal(nominalType);return rType?getRTypeSource(rType):null}function getNominalPropertySource(type,name){var typeSource=getNominalTypeSource(type);return typeSource?{getSource:function(){var typeNode=typeSource.getSource(),typeNodeElement=typeNode.asElement();if(null==typeNodeElement)return null;var propertyElements=typeNodeElement.elementsOfKind(universes.Universe10.ObjectTypeDeclaration.properties.properties.name);return null==propertyElements||0==propertyElements.length?null:_.find(propertyElements,function(propertyElement){return name==propertyElement.attrValue(universes.Universe10.TypeDeclaration.properties.name.name)})}}:null}function getNominalPropertySource2(property){return getNominalPropertySource(property.domain(),property.nameId());
}var def=__webpack_require__(36),ramlTypes=def.rt,hl=__webpack_require__(10),lowLevel=__webpack_require__(11),universes=__webpack_require__(22),_=__webpack_require__(61);exports.getExtraProviderSource=getExtraProviderSource,exports.getRTypeSource=getRTypeSource,exports.findRTypeByNominal=findRTypeByNominal,exports.getNominalTypeSource=getNominalTypeSource,exports.getNominalPropertySource=getNominalPropertySource,exports.getNominalPropertySource2=getNominalPropertySource2},function(module,exports,__webpack_require__){"use strict";function createMethod(key){var universe=def.getUniverse("RAML08"),nc=universe.type("Method"),node=stubs.createStubNode(nc,null,key);return node}function createStringTypeDeclaration(key){var universe=def.getUniverse("RAML08"),nc=universe.type("StringTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createBooleanTypeDeclaration(key){var universe=def.getUniverse("RAML08"),nc=universe.type("BooleanTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createNumberTypeDeclaration(key){var universe=def.getUniverse("RAML08"),nc=universe.type("NumberTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createIntegerTypeDeclaration(key){var universe=def.getUniverse("RAML08"),nc=universe.type("IntegerTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createDateTypeDeclaration(key){var universe=def.getUniverse("RAML08"),nc=universe.type("DateTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createFileTypeDeclaration(key){var universe=def.getUniverse("RAML08"),nc=universe.type("FileTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createXMLBody(key){var universe=def.getUniverse("RAML08"),nc=universe.type("XMLBody"),node=stubs.createStubNode(nc,null,key);return node}function createJSONBody(key){var universe=def.getUniverse("RAML08"),nc=universe.type("JSONBody"),node=stubs.createStubNode(nc,null,key);return node}function createSecuritySchemePart(key){var universe=def.getUniverse("RAML08"),nc=universe.type("SecuritySchemePart"),node=stubs.createStubNode(nc,null,key);return node}function createTrait(key){var universe=def.getUniverse("RAML08"),nc=universe.type("Trait"),node=stubs.createStubNode(nc,null,key);return node}function createOAuth1SecuritySchemeSettings(key){var universe=def.getUniverse("RAML08"),nc=universe.type("OAuth1SecuritySchemeSettings"),node=stubs.createStubNode(nc,null,key);return node}function createOAuth2SecuritySchemeSettings(key){var universe=def.getUniverse("RAML08"),nc=universe.type("OAuth2SecuritySchemeSettings"),node=stubs.createStubNode(nc,null,key);return node}function createOAuth2SecurityScheme(key){var universe=def.getUniverse("RAML08"),nc=universe.type("OAuth2SecurityScheme"),node=stubs.createStubNode(nc,null,key);return node}function createOAuth1SecurityScheme(key){var universe=def.getUniverse("RAML08"),nc=universe.type("OAuth1SecurityScheme"),node=stubs.createStubNode(nc,null,key);return node}function createBasicSecurityScheme(key){var universe=def.getUniverse("RAML08"),nc=universe.type("BasicSecurityScheme"),node=stubs.createStubNode(nc,null,key);return node}function createDigestSecurityScheme(key){var universe=def.getUniverse("RAML08"),nc=universe.type("DigestSecurityScheme"),node=stubs.createStubNode(nc,null,key);return node}function createCustomSecurityScheme(key){var universe=def.getUniverse("RAML08"),nc=universe.type("CustomSecurityScheme"),node=stubs.createStubNode(nc,null,key);return node}function createGlobalSchema(key){var universe=def.getUniverse("RAML08"),nc=universe.type("GlobalSchema"),node=stubs.createStubNode(nc,null,key);return node}function createDocumentationItem(key){var universe=def.getUniverse("RAML08"),nc=universe.type("DocumentationItem"),node=stubs.createStubNode(nc,null,key);return node}function loadApiSync(apiPath,arg1,arg2){return apiLoader.loadApi(apiPath,arg1,arg2).getOrElse(null)}function loadRAMLSync(ramlPath,arg1,arg2){return apiLoader.loadApi(ramlPath,arg1,arg2).getOrElse(null)}function loadApi(apiPath,arg1,arg2){return apiLoader.loadApiAsync(apiPath,arg1,arg2)}function loadRAML(ramlPath,arg1,arg2){return apiLoader.loadRAMLAsync(ramlPath,arg1,arg2)}function getLanguageElementByRuntimeType(runtimeType){return apiLoader.getLanguageElementByRuntimeType(runtimeType)}var __extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},stubs=__webpack_require__(17),def=__webpack_require__(36),core=__webpack_require__(45),apiLoader=__webpack_require__(9),helper=__webpack_require__(48),ApiImpl=function(_super){function ApiImpl(){_super.apply(this,arguments)}return __extends(ApiImpl,_super),ApiImpl.prototype.title=function(){return _super.prototype.attribute.call(this,"title",this.toString)},ApiImpl.prototype.setTitle=function(param){return this.highLevel().attrOrCreate("title").setValue(""+param),this},ApiImpl.prototype.version=function(){return _super.prototype.attribute.call(this,"version",this.toString)},ApiImpl.prototype.setVersion=function(param){return this.highLevel().attrOrCreate("version").setValue(""+param),this},ApiImpl.prototype.baseUri=function(){return _super.prototype.attribute.call(this,"baseUri",function(attr){return new FullUriTemplateStringImpl(attr)})},ApiImpl.prototype.baseUriParameters_original=function(){return _super.prototype.elements.call(this,"baseUriParameters")},ApiImpl.prototype.uriParameters=function(){return _super.prototype.elements.call(this,"uriParameters")},ApiImpl.prototype.protocols=function(){return _super.prototype.attributes.call(this,"protocols",this.toString)},ApiImpl.prototype.setProtocols=function(param){return this.highLevel().attrOrCreate("protocols").setValue(""+param),this},ApiImpl.prototype.mediaType=function(){return _super.prototype.attribute.call(this,"mediaType",function(attr){return new MimeTypeImpl(attr)})},ApiImpl.prototype.schemas=function(){return _super.prototype.elements.call(this,"schemas")},ApiImpl.prototype.traits_original=function(){return _super.prototype.elements.call(this,"traits")},ApiImpl.prototype.securedBy=function(){return _super.prototype.attributes.call(this,"securedBy",function(attr){return new SecuritySchemeRefImpl(attr)})},ApiImpl.prototype.securitySchemes=function(){return _super.prototype.elements.call(this,"securitySchemes")},ApiImpl.prototype.resourceTypes_original=function(){return _super.prototype.elements.call(this,"resourceTypes")},ApiImpl.prototype.resources=function(){return _super.prototype.elements.call(this,"resources")},ApiImpl.prototype.documentation=function(){return _super.prototype.elements.call(this,"documentation")},ApiImpl.prototype.wrapperClassName=function(){return"ApiImpl"},ApiImpl.prototype.kind=function(){return"Api"},ApiImpl.prototype.RAMLVersion_original=function(){return"RAML08"},ApiImpl.prototype.expand=function(){return helper.expandTraitsAndResourceTypes(this)},ApiImpl.prototype.traits=function(){return helper.traitsPrimary(this)},ApiImpl.prototype.allTraits=function(){return helper.allTraits(this)},ApiImpl.prototype.resourceTypes=function(){return helper.resourceTypesPrimary(this)},ApiImpl.prototype.allResourceTypes=function(){return helper.allResourceTypes(this)},ApiImpl.prototype.childResource=function(relPath){return helper.childResource(this,relPath)},ApiImpl.prototype.allResources=function(){return helper.allResources(this)},ApiImpl.prototype.baseUriParameters=function(){return helper.baseUriParametersPrimary(this)},ApiImpl.prototype.allBaseUriParameters=function(){return helper.baseUriParameters(this)},ApiImpl.prototype.allProtocols=function(){return helper.allProtocols(this)},ApiImpl.prototype.RAMLVersion=function(){return helper.RAMLVersion(this)},ApiImpl}(core.BasicNodeImpl);exports.ApiImpl=ApiImpl;var ValueTypeImpl=function(_super){function ValueTypeImpl(){_super.apply(this,arguments)}return __extends(ValueTypeImpl,_super),ValueTypeImpl.prototype.wrapperClassName=function(){return"ValueTypeImpl"},ValueTypeImpl.prototype.kind=function(){return"ValueType"},ValueTypeImpl.prototype.RAMLVersion=function(){return"undefined"},ValueTypeImpl.prototype.value=function(){return this.attr.value()},ValueTypeImpl}(core.AttributeNodeImpl);exports.ValueTypeImpl=ValueTypeImpl;var AnyTypeImpl=function(_super){function AnyTypeImpl(){_super.apply(this,arguments)}return __extends(AnyTypeImpl,_super),AnyTypeImpl.prototype.wrapperClassName=function(){return"AnyTypeImpl"},AnyTypeImpl.prototype.kind=function(){return"AnyType"},AnyTypeImpl.prototype.RAMLVersion=function(){return"RAML08"},AnyTypeImpl}(ValueTypeImpl);exports.AnyTypeImpl=AnyTypeImpl;var NumberTypeImpl=function(_super){function NumberTypeImpl(){_super.apply(this,arguments)}return __extends(NumberTypeImpl,_super),NumberTypeImpl.prototype.wrapperClassName=function(){return"NumberTypeImpl"},NumberTypeImpl.prototype.kind=function(){return"NumberType"},NumberTypeImpl.prototype.RAMLVersion=function(){return"RAML08"},NumberTypeImpl.prototype.value=function(){return this.attr.value()},NumberTypeImpl}(ValueTypeImpl);exports.NumberTypeImpl=NumberTypeImpl;var BooleanTypeImpl=function(_super){function BooleanTypeImpl(){_super.apply(this,arguments)}return __extends(BooleanTypeImpl,_super),BooleanTypeImpl.prototype.wrapperClassName=function(){return"BooleanTypeImpl"},BooleanTypeImpl.prototype.kind=function(){return"BooleanType"},BooleanTypeImpl.prototype.RAMLVersion=function(){return"RAML08"},BooleanTypeImpl.prototype.value=function(){return this.attr.value()},BooleanTypeImpl}(ValueTypeImpl);exports.BooleanTypeImpl=BooleanTypeImpl;var ReferenceImpl=function(_super){function ReferenceImpl(){_super.apply(this,arguments)}return __extends(ReferenceImpl,_super),ReferenceImpl.prototype.wrapperClassName=function(){return"ReferenceImpl"},ReferenceImpl.prototype.kind=function(){return"Reference"},ReferenceImpl.prototype.RAMLVersion=function(){return"RAML08"},ReferenceImpl.prototype.value=function(){return core.toStructuredValue(this.attr)},ReferenceImpl.prototype.structuredValue=function(){return helper.structuredValue(this)},ReferenceImpl.prototype.name=function(){return helper.referenceName(this)},ReferenceImpl}(core.AttributeNodeImpl);exports.ReferenceImpl=ReferenceImpl;var ResourceTypeRefImpl=function(_super){function ResourceTypeRefImpl(){_super.apply(this,arguments)}return __extends(ResourceTypeRefImpl,_super),ResourceTypeRefImpl.prototype.wrapperClassName=function(){return"ResourceTypeRefImpl"},ResourceTypeRefImpl.prototype.kind=function(){return"ResourceTypeRef"},ResourceTypeRefImpl.prototype.RAMLVersion=function(){return"RAML08"},ResourceTypeRefImpl.prototype.resourceType=function(){return helper.referencedResourceType(this)},ResourceTypeRefImpl}(ReferenceImpl);exports.ResourceTypeRefImpl=ResourceTypeRefImpl;var ResourceTypeImpl=function(_super){function ResourceTypeImpl(){_super.apply(this,arguments)}return __extends(ResourceTypeImpl,_super),ResourceTypeImpl.prototype.name=function(){return _super.prototype.attribute.call(this,"name",this.toString)},ResourceTypeImpl.prototype.setName=function(param){return this.highLevel().attrOrCreate("name").setValue(""+param),this},ResourceTypeImpl.prototype.usage=function(){return _super.prototype.attribute.call(this,"usage",this.toString)},ResourceTypeImpl.prototype.setUsage=function(param){return this.highLevel().attrOrCreate("usage").setValue(""+param),this},ResourceTypeImpl.prototype.methods=function(){return _super.prototype.elements.call(this,"methods")},ResourceTypeImpl.prototype.is=function(){return _super.prototype.attributes.call(this,"is",function(attr){return new TraitRefImpl(attr)})},ResourceTypeImpl.prototype.type=function(){return _super.prototype.attribute.call(this,"type",function(attr){return new ResourceTypeRefImpl(attr)})},ResourceTypeImpl.prototype.securedBy=function(){return _super.prototype.attributes.call(this,"securedBy",function(attr){return new SecuritySchemeRefImpl(attr)})},ResourceTypeImpl.prototype.uriParameters=function(){return _super.prototype.elements.call(this,"uriParameters")},ResourceTypeImpl.prototype.displayName=function(){return _super.prototype.attribute.call(this,"displayName",this.toString)},ResourceTypeImpl.prototype.setDisplayName=function(param){return this.highLevel().attrOrCreate("displayName").setValue(""+param),this},ResourceTypeImpl.prototype.baseUriParameters=function(){return _super.prototype.elements.call(this,"baseUriParameters")},ResourceTypeImpl.prototype.description=function(){return _super.prototype.attribute.call(this,"description",function(attr){return new MarkdownStringImpl(attr)})},ResourceTypeImpl.prototype.wrapperClassName=function(){return"ResourceTypeImpl"},ResourceTypeImpl.prototype.kind=function(){return"ResourceType"},ResourceTypeImpl.prototype.RAMLVersion=function(){return"RAML08"},ResourceTypeImpl.prototype.parametrizedProperties=function(){return helper.getTemplateParametrizedProperties(this)},ResourceTypeImpl}(core.BasicNodeImpl);exports.ResourceTypeImpl=ResourceTypeImpl;var MethodBaseImpl=function(_super){function MethodBaseImpl(){_super.apply(this,arguments)}return __extends(MethodBaseImpl,_super),MethodBaseImpl.prototype.responses=function(){return _super.prototype.elements.call(this,"responses")},MethodBaseImpl.prototype.body=function(){return _super.prototype.elements.call(this,"body")},MethodBaseImpl.prototype.protocols=function(){return _super.prototype.attributes.call(this,"protocols",this.toString)},MethodBaseImpl.prototype.setProtocols=function(param){return this.highLevel().attrOrCreate("protocols").setValue(""+param),this},MethodBaseImpl.prototype.securedBy=function(){return _super.prototype.attributes.call(this,"securedBy",function(attr){return new SecuritySchemeRefImpl(attr)})},MethodBaseImpl.prototype.baseUriParameters=function(){return _super.prototype.elements.call(this,"baseUriParameters")},MethodBaseImpl.prototype.queryParameters=function(){return _super.prototype.elements.call(this,"queryParameters")},MethodBaseImpl.prototype.headers=function(){return _super.prototype.elements.call(this,"headers")},MethodBaseImpl.prototype.description=function(){return _super.prototype.attribute.call(this,"description",function(attr){return new MarkdownStringImpl(attr)})},MethodBaseImpl.prototype.wrapperClassName=function(){return"MethodBaseImpl"},MethodBaseImpl.prototype.kind=function(){return"MethodBase"},MethodBaseImpl.prototype.RAMLVersion=function(){return"RAML08"},MethodBaseImpl}(core.BasicNodeImpl);exports.MethodBaseImpl=MethodBaseImpl;var ResponseImpl=function(_super){function ResponseImpl(){_super.apply(this,arguments)}return __extends(ResponseImpl,_super),ResponseImpl.prototype.code=function(){return _super.prototype.attribute.call(this,"code",function(attr){return new StatusCodeStringImpl(attr)})},ResponseImpl.prototype.headers=function(){return _super.prototype.elements.call(this,"headers")},ResponseImpl.prototype.body=function(){return _super.prototype.elements.call(this,"body")},ResponseImpl.prototype.description=function(){return _super.prototype.attribute.call(this,"description",function(attr){return new MarkdownStringImpl(attr)})},ResponseImpl.prototype.wrapperClassName=function(){return"ResponseImpl"},ResponseImpl.prototype.kind=function(){return"Response"},ResponseImpl.prototype.RAMLVersion=function(){return"RAML08"},ResponseImpl.prototype.isOkRange=function(){return helper.isOkRange(this)},ResponseImpl}(core.BasicNodeImpl);exports.ResponseImpl=ResponseImpl;var StringTypeImpl=function(_super){function StringTypeImpl(){_super.apply(this,arguments)}return __extends(StringTypeImpl,_super),StringTypeImpl.prototype.wrapperClassName=function(){return"StringTypeImpl"},StringTypeImpl.prototype.kind=function(){return"StringType"},StringTypeImpl.prototype.RAMLVersion=function(){return"RAML08"},StringTypeImpl.prototype.value=function(){return this.attr.value()},StringTypeImpl}(ValueTypeImpl);exports.StringTypeImpl=StringTypeImpl;var StatusCodeStringImpl=function(_super){function StatusCodeStringImpl(){_super.apply(this,arguments)}return __extends(StatusCodeStringImpl,_super),StatusCodeStringImpl.prototype.wrapperClassName=function(){return"StatusCodeStringImpl"},StatusCodeStringImpl.prototype.kind=function(){return"StatusCodeString"},StatusCodeStringImpl.prototype.RAMLVersion=function(){return"RAML08"},StatusCodeStringImpl}(StringTypeImpl);exports.StatusCodeStringImpl=StatusCodeStringImpl;var ParameterImpl=function(_super){function ParameterImpl(){_super.apply(this,arguments)}return __extends(ParameterImpl,_super),ParameterImpl.prototype.name=function(){return _super.prototype.attribute.call(this,"name",this.toString)},ParameterImpl.prototype.setName=function(param){return this.highLevel().attrOrCreate("name").setValue(""+param),this},ParameterImpl.prototype.displayName=function(){return _super.prototype.attribute.call(this,"displayName",this.toString)},ParameterImpl.prototype.setDisplayName=function(param){return this.highLevel().attrOrCreate("displayName").setValue(""+param),this},ParameterImpl.prototype.type=function(){return _super.prototype.attribute.call(this,"type",this.toString)},ParameterImpl.prototype.setType=function(param){return this.highLevel().attrOrCreate("type").setValue(""+param),this},ParameterImpl.prototype.location=function(){return _super.prototype.attribute.call(this,"location",function(attr){return new ParameterLocationImpl(attr)})},ParameterImpl.prototype.required=function(){return _super.prototype.attribute.call(this,"required",this.toBoolean)},ParameterImpl.prototype.setRequired=function(param){return this.highLevel().attrOrCreate("required").setValue(""+param),this},ParameterImpl.prototype.default=function(){return _super.prototype.attribute.call(this,"default",this.toAny)},ParameterImpl.prototype.setDefault=function(param){return this.highLevel().attrOrCreate("default").setValue(""+param),this},ParameterImpl.prototype.example=function(){return _super.prototype.attribute.call(this,"example",this.toString)},ParameterImpl.prototype.setExample=function(param){return this.highLevel().attrOrCreate("example").setValue(""+param),this},ParameterImpl.prototype.repeat=function(){return _super.prototype.attribute.call(this,"repeat",this.toBoolean)},ParameterImpl.prototype.setRepeat=function(param){return this.highLevel().attrOrCreate("repeat").setValue(""+param),this},ParameterImpl.prototype.description=function(){return _super.prototype.attribute.call(this,"description",function(attr){return new MarkdownStringImpl(attr)})},ParameterImpl.prototype.wrapperClassName=function(){return"ParameterImpl"},ParameterImpl.prototype.kind=function(){return"Parameter"},ParameterImpl.prototype.RAMLVersion=function(){return"RAML08"},ParameterImpl}(core.BasicNodeImpl);exports.ParameterImpl=ParameterImpl;var ParameterLocationImpl=function(){function ParameterLocationImpl(attr){this.attr=attr}return ParameterLocationImpl.prototype.wrapperClassName=function(){return"ParameterLocationImpl"},ParameterLocationImpl.prototype.kind=function(){return"ParameterLocation"},ParameterLocationImpl.prototype.RAMLVersion=function(){return"RAML08"},ParameterLocationImpl}();exports.ParameterLocationImpl=ParameterLocationImpl;var MarkdownStringImpl=function(_super){function MarkdownStringImpl(){_super.apply(this,arguments)}return __extends(MarkdownStringImpl,_super),MarkdownStringImpl.prototype.wrapperClassName=function(){return"MarkdownStringImpl"},MarkdownStringImpl.prototype.kind=function(){return"MarkdownString"},MarkdownStringImpl.prototype.RAMLVersion=function(){return"RAML08"},MarkdownStringImpl}(StringTypeImpl);exports.MarkdownStringImpl=MarkdownStringImpl;var StringTypeDeclarationImpl=function(_super){function StringTypeDeclarationImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createStringTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(StringTypeDeclarationImpl,_super),StringTypeDeclarationImpl.prototype.pattern=function(){return _super.prototype.attribute.call(this,"pattern",this.toString)},StringTypeDeclarationImpl.prototype.setPattern=function(param){return this.highLevel().attrOrCreate("pattern").setValue(""+param),this},StringTypeDeclarationImpl.prototype.enum=function(){return _super.prototype.attributes.call(this,"enum",this.toString)},StringTypeDeclarationImpl.prototype.setEnum=function(param){return this.highLevel().attrOrCreate("enum").setValue(""+param),this},StringTypeDeclarationImpl.prototype.minLength=function(){return _super.prototype.attribute.call(this,"minLength",this.toNumber)},StringTypeDeclarationImpl.prototype.setMinLength=function(param){return this.highLevel().attrOrCreate("minLength").setValue(""+param),this},StringTypeDeclarationImpl.prototype.maxLength=function(){return _super.prototype.attribute.call(this,"maxLength",this.toNumber)},StringTypeDeclarationImpl.prototype.setMaxLength=function(param){return this.highLevel().attrOrCreate("maxLength").setValue(""+param),this},StringTypeDeclarationImpl.prototype.wrapperClassName=function(){return"StringTypeDeclarationImpl"},StringTypeDeclarationImpl.prototype.kind=function(){return"StringTypeDeclaration"},StringTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML08"},StringTypeDeclarationImpl}(ParameterImpl);exports.StringTypeDeclarationImpl=StringTypeDeclarationImpl;var BooleanTypeDeclarationImpl=function(_super){function BooleanTypeDeclarationImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createBooleanTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(BooleanTypeDeclarationImpl,_super),BooleanTypeDeclarationImpl.prototype.wrapperClassName=function(){return"BooleanTypeDeclarationImpl"},BooleanTypeDeclarationImpl.prototype.kind=function(){return"BooleanTypeDeclaration"},BooleanTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML08"},BooleanTypeDeclarationImpl}(ParameterImpl);exports.BooleanTypeDeclarationImpl=BooleanTypeDeclarationImpl;var NumberTypeDeclarationImpl=function(_super){function NumberTypeDeclarationImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createNumberTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(NumberTypeDeclarationImpl,_super),NumberTypeDeclarationImpl.prototype.minimum=function(){return _super.prototype.attribute.call(this,"minimum",this.toNumber)},NumberTypeDeclarationImpl.prototype.setMinimum=function(param){return this.highLevel().attrOrCreate("minimum").setValue(""+param),this},NumberTypeDeclarationImpl.prototype.maximum=function(){return _super.prototype.attribute.call(this,"maximum",this.toNumber)},NumberTypeDeclarationImpl.prototype.setMaximum=function(param){return this.highLevel().attrOrCreate("maximum").setValue(""+param),this},NumberTypeDeclarationImpl.prototype.wrapperClassName=function(){return"NumberTypeDeclarationImpl"},NumberTypeDeclarationImpl.prototype.kind=function(){return"NumberTypeDeclaration"},NumberTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML08"},NumberTypeDeclarationImpl}(ParameterImpl);exports.NumberTypeDeclarationImpl=NumberTypeDeclarationImpl;var IntegerTypeDeclarationImpl=function(_super){function IntegerTypeDeclarationImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createIntegerTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(IntegerTypeDeclarationImpl,_super),IntegerTypeDeclarationImpl.prototype.wrapperClassName=function(){return"IntegerTypeDeclarationImpl"},IntegerTypeDeclarationImpl.prototype.kind=function(){return"IntegerTypeDeclaration"},IntegerTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML08"},IntegerTypeDeclarationImpl}(NumberTypeDeclarationImpl);exports.IntegerTypeDeclarationImpl=IntegerTypeDeclarationImpl;var DateTypeDeclarationImpl=function(_super){function DateTypeDeclarationImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createDateTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(DateTypeDeclarationImpl,_super),DateTypeDeclarationImpl.prototype.wrapperClassName=function(){return"DateTypeDeclarationImpl"},DateTypeDeclarationImpl.prototype.kind=function(){return"DateTypeDeclaration"},DateTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML08"},DateTypeDeclarationImpl}(ParameterImpl);exports.DateTypeDeclarationImpl=DateTypeDeclarationImpl;var FileTypeDeclarationImpl=function(_super){function FileTypeDeclarationImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createFileTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(FileTypeDeclarationImpl,_super),FileTypeDeclarationImpl.prototype.wrapperClassName=function(){return"FileTypeDeclarationImpl"},FileTypeDeclarationImpl.prototype.kind=function(){return"FileTypeDeclaration"},FileTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML08"},FileTypeDeclarationImpl}(ParameterImpl);exports.FileTypeDeclarationImpl=FileTypeDeclarationImpl;var BodyLikeImpl=function(_super){function BodyLikeImpl(){_super.apply(this,arguments)}return __extends(BodyLikeImpl,_super),BodyLikeImpl.prototype.name=function(){return _super.prototype.attribute.call(this,"name",this.toString)},BodyLikeImpl.prototype.setName=function(param){return this.highLevel().attrOrCreate("name").setValue(""+param),this},BodyLikeImpl.prototype.schema=function(){return _super.prototype.attribute.call(this,"schema",function(attr){return new SchemaStringImpl(attr)})},BodyLikeImpl.prototype.example=function(){return _super.prototype.attribute.call(this,"example",function(attr){return new ExampleStringImpl(attr)})},BodyLikeImpl.prototype.formParameters=function(){return _super.prototype.elements.call(this,"formParameters")},BodyLikeImpl.prototype.description=function(){return _super.prototype.attribute.call(this,"description",function(attr){return new MarkdownStringImpl(attr)})},BodyLikeImpl.prototype.wrapperClassName=function(){return"BodyLikeImpl"},BodyLikeImpl.prototype.kind=function(){return"BodyLike"},BodyLikeImpl.prototype.RAMLVersion=function(){return"RAML08"},BodyLikeImpl.prototype.schemaContent=function(){return helper.schemaContent(this)},BodyLikeImpl}(core.BasicNodeImpl);exports.BodyLikeImpl=BodyLikeImpl;var SchemaStringImpl=function(_super){function SchemaStringImpl(){_super.apply(this,arguments)}return __extends(SchemaStringImpl,_super),SchemaStringImpl.prototype.wrapperClassName=function(){return"SchemaStringImpl"},SchemaStringImpl.prototype.kind=function(){return"SchemaString"},SchemaStringImpl.prototype.RAMLVersion=function(){return"RAML08"},SchemaStringImpl}(StringTypeImpl);exports.SchemaStringImpl=SchemaStringImpl;var JSonSchemaStringImpl=function(_super){function JSonSchemaStringImpl(){_super.apply(this,arguments)}return __extends(JSonSchemaStringImpl,_super),JSonSchemaStringImpl.prototype.wrapperClassName=function(){return"JSonSchemaStringImpl"},JSonSchemaStringImpl.prototype.kind=function(){return"JSonSchemaString"},JSonSchemaStringImpl.prototype.RAMLVersion=function(){return"RAML08"},JSonSchemaStringImpl}(SchemaStringImpl);exports.JSonSchemaStringImpl=JSonSchemaStringImpl;var XMLSchemaStringImpl=function(_super){function XMLSchemaStringImpl(){_super.apply(this,arguments)}return __extends(XMLSchemaStringImpl,_super),XMLSchemaStringImpl.prototype.wrapperClassName=function(){return"XMLSchemaStringImpl"},XMLSchemaStringImpl.prototype.kind=function(){return"XMLSchemaString"},XMLSchemaStringImpl.prototype.RAMLVersion=function(){return"RAML08"},XMLSchemaStringImpl}(SchemaStringImpl);exports.XMLSchemaStringImpl=XMLSchemaStringImpl;var ExampleStringImpl=function(_super){function ExampleStringImpl(){_super.apply(this,arguments)}return __extends(ExampleStringImpl,_super),ExampleStringImpl.prototype.wrapperClassName=function(){return"ExampleStringImpl"},ExampleStringImpl.prototype.kind=function(){return"ExampleString"},ExampleStringImpl.prototype.RAMLVersion=function(){return"RAML08"},ExampleStringImpl}(StringTypeImpl);exports.ExampleStringImpl=ExampleStringImpl;var JSONExampleImpl=function(_super){function JSONExampleImpl(){_super.apply(this,arguments)}return __extends(JSONExampleImpl,_super),JSONExampleImpl.prototype.wrapperClassName=function(){return"JSONExampleImpl"},JSONExampleImpl.prototype.kind=function(){return"JSONExample"},JSONExampleImpl.prototype.RAMLVersion=function(){return"RAML08"},JSONExampleImpl}(ExampleStringImpl);exports.JSONExampleImpl=JSONExampleImpl;var XMLExampleImpl=function(_super){function XMLExampleImpl(){_super.apply(this,arguments)}return __extends(XMLExampleImpl,_super),XMLExampleImpl.prototype.wrapperClassName=function(){return"XMLExampleImpl"},XMLExampleImpl.prototype.kind=function(){return"XMLExample"},XMLExampleImpl.prototype.RAMLVersion=function(){return"RAML08"},XMLExampleImpl}(ExampleStringImpl);exports.XMLExampleImpl=XMLExampleImpl;var XMLBodyImpl=function(_super){function XMLBodyImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createXMLBody(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(XMLBodyImpl,_super),XMLBodyImpl.prototype.schema=function(){return _super.prototype.attribute.call(this,"schema",function(attr){return new XMLSchemaStringImpl(attr)})},XMLBodyImpl.prototype.wrapperClassName=function(){return"XMLBodyImpl"},XMLBodyImpl.prototype.kind=function(){return"XMLBody"},XMLBodyImpl.prototype.RAMLVersion=function(){return"RAML08"},XMLBodyImpl}(BodyLikeImpl);exports.XMLBodyImpl=XMLBodyImpl;var JSONBodyImpl=function(_super){function JSONBodyImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createJSONBody(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(JSONBodyImpl,_super),JSONBodyImpl.prototype.schema=function(){return _super.prototype.attribute.call(this,"schema",function(attr){return new JSonSchemaStringImpl(attr)})},JSONBodyImpl.prototype.wrapperClassName=function(){return"JSONBodyImpl"},JSONBodyImpl.prototype.kind=function(){return"JSONBody"},JSONBodyImpl.prototype.RAMLVersion=function(){return"RAML08"},JSONBodyImpl}(BodyLikeImpl);exports.JSONBodyImpl=JSONBodyImpl;var SecuritySchemeRefImpl=function(_super){function SecuritySchemeRefImpl(){_super.apply(this,arguments)}return __extends(SecuritySchemeRefImpl,_super),SecuritySchemeRefImpl.prototype.wrapperClassName=function(){return"SecuritySchemeRefImpl"},SecuritySchemeRefImpl.prototype.kind=function(){return"SecuritySchemeRef"},SecuritySchemeRefImpl.prototype.RAMLVersion=function(){return"RAML08"},SecuritySchemeRefImpl.prototype.securitySchemeName=function(){return helper.securitySchemeName(this)},SecuritySchemeRefImpl.prototype.securityScheme=function(){return helper.securityScheme(this)},SecuritySchemeRefImpl}(ReferenceImpl);exports.SecuritySchemeRefImpl=SecuritySchemeRefImpl;var AbstractSecuritySchemeImpl=function(_super){function AbstractSecuritySchemeImpl(){_super.apply(this,arguments)}return __extends(AbstractSecuritySchemeImpl,_super),AbstractSecuritySchemeImpl.prototype.name=function(){return _super.prototype.attribute.call(this,"name",this.toString)},AbstractSecuritySchemeImpl.prototype.setName=function(param){return this.highLevel().attrOrCreate("name").setValue(""+param),this},AbstractSecuritySchemeImpl.prototype.type=function(){return _super.prototype.attribute.call(this,"type",this.toString)},AbstractSecuritySchemeImpl.prototype.setType=function(param){return this.highLevel().attrOrCreate("type").setValue(""+param),this},AbstractSecuritySchemeImpl.prototype.description=function(){
return _super.prototype.attribute.call(this,"description",function(attr){return new MarkdownStringImpl(attr)})},AbstractSecuritySchemeImpl.prototype.describedBy=function(){return _super.prototype.element.call(this,"describedBy")},AbstractSecuritySchemeImpl.prototype.settings=function(){return _super.prototype.element.call(this,"settings")},AbstractSecuritySchemeImpl.prototype.wrapperClassName=function(){return"AbstractSecuritySchemeImpl"},AbstractSecuritySchemeImpl.prototype.kind=function(){return"AbstractSecurityScheme"},AbstractSecuritySchemeImpl.prototype.RAMLVersion=function(){return"RAML08"},AbstractSecuritySchemeImpl}(core.BasicNodeImpl);exports.AbstractSecuritySchemeImpl=AbstractSecuritySchemeImpl;var SecuritySchemePartImpl=function(_super){function SecuritySchemePartImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createSecuritySchemePart(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(SecuritySchemePartImpl,_super),SecuritySchemePartImpl.prototype.displayName=function(){return _super.prototype.attribute.call(this,"displayName",this.toString)},SecuritySchemePartImpl.prototype.setDisplayName=function(param){return this.highLevel().attrOrCreate("displayName").setValue(""+param),this},SecuritySchemePartImpl.prototype.is=function(){return _super.prototype.attributes.call(this,"is",function(attr){return new TraitRefImpl(attr)})},SecuritySchemePartImpl.prototype.headers=function(){return _super.prototype.elements.call(this,"headers")},SecuritySchemePartImpl.prototype.queryParameters=function(){return _super.prototype.elements.call(this,"queryParameters")},SecuritySchemePartImpl.prototype.responses=function(){return _super.prototype.elements.call(this,"responses")},SecuritySchemePartImpl.prototype.description=function(){return _super.prototype.attribute.call(this,"description",function(attr){return new MarkdownStringImpl(attr)})},SecuritySchemePartImpl.prototype.wrapperClassName=function(){return"SecuritySchemePartImpl"},SecuritySchemePartImpl.prototype.kind=function(){return"SecuritySchemePart"},SecuritySchemePartImpl.prototype.RAMLVersion=function(){return"RAML08"},SecuritySchemePartImpl}(MethodBaseImpl);exports.SecuritySchemePartImpl=SecuritySchemePartImpl;var TraitRefImpl=function(_super){function TraitRefImpl(){_super.apply(this,arguments)}return __extends(TraitRefImpl,_super),TraitRefImpl.prototype.wrapperClassName=function(){return"TraitRefImpl"},TraitRefImpl.prototype.kind=function(){return"TraitRef"},TraitRefImpl.prototype.RAMLVersion=function(){return"RAML08"},TraitRefImpl.prototype.trait=function(){return helper.referencedTrait(this)},TraitRefImpl}(ReferenceImpl);exports.TraitRefImpl=TraitRefImpl;var TraitImpl=function(_super){function TraitImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createTrait(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(TraitImpl,_super),TraitImpl.prototype.name=function(){return _super.prototype.attribute.call(this,"name",this.toString)},TraitImpl.prototype.setName=function(param){return this.highLevel().attrOrCreate("name").setValue(""+param),this},TraitImpl.prototype.usage=function(){return _super.prototype.attribute.call(this,"usage",this.toString)},TraitImpl.prototype.setUsage=function(param){return this.highLevel().attrOrCreate("usage").setValue(""+param),this},TraitImpl.prototype.displayName=function(){return _super.prototype.attribute.call(this,"displayName",this.toString)},TraitImpl.prototype.setDisplayName=function(param){return this.highLevel().attrOrCreate("displayName").setValue(""+param),this},TraitImpl.prototype.wrapperClassName=function(){return"TraitImpl"},TraitImpl.prototype.kind=function(){return"Trait"},TraitImpl.prototype.RAMLVersion=function(){return"RAML08"},TraitImpl.prototype.parametrizedProperties=function(){return helper.getTemplateParametrizedProperties(this)},TraitImpl}(MethodBaseImpl);exports.TraitImpl=TraitImpl;var SecuritySchemeSettingsImpl=function(_super){function SecuritySchemeSettingsImpl(){_super.apply(this,arguments)}return __extends(SecuritySchemeSettingsImpl,_super),SecuritySchemeSettingsImpl.prototype.wrapperClassName=function(){return"SecuritySchemeSettingsImpl"},SecuritySchemeSettingsImpl.prototype.kind=function(){return"SecuritySchemeSettings"},SecuritySchemeSettingsImpl.prototype.RAMLVersion=function(){return"RAML08"},SecuritySchemeSettingsImpl}(core.BasicNodeImpl);exports.SecuritySchemeSettingsImpl=SecuritySchemeSettingsImpl;var OAuth1SecuritySchemeSettingsImpl=function(_super){function OAuth1SecuritySchemeSettingsImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createOAuth1SecuritySchemeSettings(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(OAuth1SecuritySchemeSettingsImpl,_super),OAuth1SecuritySchemeSettingsImpl.prototype.requestTokenUri=function(){return _super.prototype.attribute.call(this,"requestTokenUri",function(attr){return new FixedUriImpl(attr)})},OAuth1SecuritySchemeSettingsImpl.prototype.authorizationUri=function(){return _super.prototype.attribute.call(this,"authorizationUri",function(attr){return new FixedUriImpl(attr)})},OAuth1SecuritySchemeSettingsImpl.prototype.tokenCredentialsUri=function(){return _super.prototype.attribute.call(this,"tokenCredentialsUri",function(attr){return new FixedUriImpl(attr)})},OAuth1SecuritySchemeSettingsImpl.prototype.wrapperClassName=function(){return"OAuth1SecuritySchemeSettingsImpl"},OAuth1SecuritySchemeSettingsImpl.prototype.kind=function(){return"OAuth1SecuritySchemeSettings"},OAuth1SecuritySchemeSettingsImpl.prototype.RAMLVersion=function(){return"RAML08"},OAuth1SecuritySchemeSettingsImpl}(SecuritySchemeSettingsImpl);exports.OAuth1SecuritySchemeSettingsImpl=OAuth1SecuritySchemeSettingsImpl;var FixedUriImpl=function(_super){function FixedUriImpl(){_super.apply(this,arguments)}return __extends(FixedUriImpl,_super),FixedUriImpl.prototype.wrapperClassName=function(){return"FixedUriImpl"},FixedUriImpl.prototype.kind=function(){return"FixedUri"},FixedUriImpl.prototype.RAMLVersion=function(){return"RAML08"},FixedUriImpl}(StringTypeImpl);exports.FixedUriImpl=FixedUriImpl;var OAuth2SecuritySchemeSettingsImpl=function(_super){function OAuth2SecuritySchemeSettingsImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createOAuth2SecuritySchemeSettings(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(OAuth2SecuritySchemeSettingsImpl,_super),OAuth2SecuritySchemeSettingsImpl.prototype.accessTokenUri=function(){return _super.prototype.attribute.call(this,"accessTokenUri",function(attr){return new FixedUriImpl(attr)})},OAuth2SecuritySchemeSettingsImpl.prototype.authorizationUri=function(){return _super.prototype.attribute.call(this,"authorizationUri",function(attr){return new FixedUriImpl(attr)})},OAuth2SecuritySchemeSettingsImpl.prototype.authorizationGrants=function(){return _super.prototype.attributes.call(this,"authorizationGrants",this.toString)},OAuth2SecuritySchemeSettingsImpl.prototype.setAuthorizationGrants=function(param){return this.highLevel().attrOrCreate("authorizationGrants").setValue(""+param),this},OAuth2SecuritySchemeSettingsImpl.prototype.scopes=function(){return _super.prototype.attributes.call(this,"scopes",this.toString)},OAuth2SecuritySchemeSettingsImpl.prototype.setScopes=function(param){return this.highLevel().attrOrCreate("scopes").setValue(""+param),this},OAuth2SecuritySchemeSettingsImpl.prototype.wrapperClassName=function(){return"OAuth2SecuritySchemeSettingsImpl"},OAuth2SecuritySchemeSettingsImpl.prototype.kind=function(){return"OAuth2SecuritySchemeSettings"},OAuth2SecuritySchemeSettingsImpl.prototype.RAMLVersion=function(){return"RAML08"},OAuth2SecuritySchemeSettingsImpl}(SecuritySchemeSettingsImpl);exports.OAuth2SecuritySchemeSettingsImpl=OAuth2SecuritySchemeSettingsImpl;var OAuth2SecuritySchemeImpl=function(_super){function OAuth2SecuritySchemeImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createOAuth2SecurityScheme(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(OAuth2SecuritySchemeImpl,_super),OAuth2SecuritySchemeImpl.prototype.settings=function(){return _super.prototype.element.call(this,"settings")},OAuth2SecuritySchemeImpl.prototype.wrapperClassName=function(){return"OAuth2SecuritySchemeImpl"},OAuth2SecuritySchemeImpl.prototype.kind=function(){return"OAuth2SecurityScheme"},OAuth2SecuritySchemeImpl.prototype.RAMLVersion=function(){return"RAML08"},OAuth2SecuritySchemeImpl}(AbstractSecuritySchemeImpl);exports.OAuth2SecuritySchemeImpl=OAuth2SecuritySchemeImpl;var OAuth1SecuritySchemeImpl=function(_super){function OAuth1SecuritySchemeImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createOAuth1SecurityScheme(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(OAuth1SecuritySchemeImpl,_super),OAuth1SecuritySchemeImpl.prototype.settings=function(){return _super.prototype.element.call(this,"settings")},OAuth1SecuritySchemeImpl.prototype.wrapperClassName=function(){return"OAuth1SecuritySchemeImpl"},OAuth1SecuritySchemeImpl.prototype.kind=function(){return"OAuth1SecurityScheme"},OAuth1SecuritySchemeImpl.prototype.RAMLVersion=function(){return"RAML08"},OAuth1SecuritySchemeImpl}(AbstractSecuritySchemeImpl);exports.OAuth1SecuritySchemeImpl=OAuth1SecuritySchemeImpl;var BasicSecuritySchemeImpl=function(_super){function BasicSecuritySchemeImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createBasicSecurityScheme(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(BasicSecuritySchemeImpl,_super),BasicSecuritySchemeImpl.prototype.wrapperClassName=function(){return"BasicSecuritySchemeImpl"},BasicSecuritySchemeImpl.prototype.kind=function(){return"BasicSecurityScheme"},BasicSecuritySchemeImpl.prototype.RAMLVersion=function(){return"RAML08"},BasicSecuritySchemeImpl}(AbstractSecuritySchemeImpl);exports.BasicSecuritySchemeImpl=BasicSecuritySchemeImpl;var DigestSecuritySchemeImpl=function(_super){function DigestSecuritySchemeImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createDigestSecurityScheme(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(DigestSecuritySchemeImpl,_super),DigestSecuritySchemeImpl.prototype.wrapperClassName=function(){return"DigestSecuritySchemeImpl"},DigestSecuritySchemeImpl.prototype.kind=function(){return"DigestSecurityScheme"},DigestSecuritySchemeImpl.prototype.RAMLVersion=function(){return"RAML08"},DigestSecuritySchemeImpl}(AbstractSecuritySchemeImpl);exports.DigestSecuritySchemeImpl=DigestSecuritySchemeImpl;var CustomSecuritySchemeImpl=function(_super){function CustomSecuritySchemeImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createCustomSecurityScheme(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(CustomSecuritySchemeImpl,_super),CustomSecuritySchemeImpl.prototype.wrapperClassName=function(){return"CustomSecuritySchemeImpl"},CustomSecuritySchemeImpl.prototype.kind=function(){return"CustomSecurityScheme"},CustomSecuritySchemeImpl.prototype.RAMLVersion=function(){return"RAML08"},CustomSecuritySchemeImpl}(AbstractSecuritySchemeImpl);exports.CustomSecuritySchemeImpl=CustomSecuritySchemeImpl;var MethodImpl=function(_super){function MethodImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createMethod(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(MethodImpl,_super),MethodImpl.prototype.method=function(){return _super.prototype.attribute.call(this,"method",this.toString)},MethodImpl.prototype.setMethod=function(param){return this.highLevel().attrOrCreate("method").setValue(""+param),this},MethodImpl.prototype.is=function(){return _super.prototype.attributes.call(this,"is",function(attr){return new TraitRefImpl(attr)})},MethodImpl.prototype.wrapperClassName=function(){return"MethodImpl"},MethodImpl.prototype.kind=function(){return"Method"},MethodImpl.prototype.RAMLVersion=function(){return"RAML08"},MethodImpl.prototype.parentResource=function(){return helper.parentResource(this)},MethodImpl.prototype.ownerApi=function(){return helper.ownerApi(this)},MethodImpl.prototype.methodId=function(){return helper.methodId(this)},MethodImpl.prototype.allSecuredBy=function(){return helper.allSecuredBy(this)},MethodImpl}(MethodBaseImpl);exports.MethodImpl=MethodImpl;var MimeTypeImpl=function(_super){function MimeTypeImpl(){_super.apply(this,arguments)}return __extends(MimeTypeImpl,_super),MimeTypeImpl.prototype.wrapperClassName=function(){return"MimeTypeImpl"},MimeTypeImpl.prototype.kind=function(){return"MimeType"},MimeTypeImpl.prototype.RAMLVersion=function(){return"RAML08"},MimeTypeImpl}(StringTypeImpl);exports.MimeTypeImpl=MimeTypeImpl;var UriTemplateImpl=function(_super){function UriTemplateImpl(){_super.apply(this,arguments)}return __extends(UriTemplateImpl,_super),UriTemplateImpl.prototype.wrapperClassName=function(){return"UriTemplateImpl"},UriTemplateImpl.prototype.kind=function(){return"UriTemplate"},UriTemplateImpl.prototype.RAMLVersion=function(){return"RAML08"},UriTemplateImpl}(StringTypeImpl);exports.UriTemplateImpl=UriTemplateImpl;var RelativeUriStringImpl=function(_super){function RelativeUriStringImpl(){_super.apply(this,arguments)}return __extends(RelativeUriStringImpl,_super),RelativeUriStringImpl.prototype.wrapperClassName=function(){return"RelativeUriStringImpl"},RelativeUriStringImpl.prototype.kind=function(){return"RelativeUriString"},RelativeUriStringImpl.prototype.RAMLVersion=function(){return"RAML08"},RelativeUriStringImpl}(UriTemplateImpl);exports.RelativeUriStringImpl=RelativeUriStringImpl;var FullUriTemplateStringImpl=function(_super){function FullUriTemplateStringImpl(){_super.apply(this,arguments)}return __extends(FullUriTemplateStringImpl,_super),FullUriTemplateStringImpl.prototype.wrapperClassName=function(){return"FullUriTemplateStringImpl"},FullUriTemplateStringImpl.prototype.kind=function(){return"FullUriTemplateString"},FullUriTemplateStringImpl.prototype.RAMLVersion=function(){return"RAML08"},FullUriTemplateStringImpl}(UriTemplateImpl);exports.FullUriTemplateStringImpl=FullUriTemplateStringImpl;var RAMLSimpleElementImpl=function(_super){function RAMLSimpleElementImpl(){_super.apply(this,arguments)}return __extends(RAMLSimpleElementImpl,_super),RAMLSimpleElementImpl.prototype.wrapperClassName=function(){return"RAMLSimpleElementImpl"},RAMLSimpleElementImpl.prototype.kind=function(){return"RAMLSimpleElement"},RAMLSimpleElementImpl.prototype.RAMLVersion=function(){return"RAML08"},RAMLSimpleElementImpl}(core.BasicNodeImpl);exports.RAMLSimpleElementImpl=RAMLSimpleElementImpl;var DocumentationItemImpl=function(_super){function DocumentationItemImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createDocumentationItem(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(DocumentationItemImpl,_super),DocumentationItemImpl.prototype.title=function(){return _super.prototype.attribute.call(this,"title",this.toString)},DocumentationItemImpl.prototype.setTitle=function(param){return this.highLevel().attrOrCreate("title").setValue(""+param),this},DocumentationItemImpl.prototype.content=function(){return _super.prototype.attribute.call(this,"content",function(attr){return new MarkdownStringImpl(attr)})},DocumentationItemImpl.prototype.wrapperClassName=function(){return"DocumentationItemImpl"},DocumentationItemImpl.prototype.kind=function(){return"DocumentationItem"},DocumentationItemImpl.prototype.RAMLVersion=function(){return"RAML08"},DocumentationItemImpl}(RAMLSimpleElementImpl);exports.DocumentationItemImpl=DocumentationItemImpl;var GlobalSchemaImpl=function(_super){function GlobalSchemaImpl(nodeOrKey,setAsTopLevel){_super.call(this,"string"==typeof nodeOrKey?createGlobalSchema(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(GlobalSchemaImpl,_super),GlobalSchemaImpl.prototype.key=function(){return _super.prototype.attribute.call(this,"key",this.toString)},GlobalSchemaImpl.prototype.setKey=function(param){return this.highLevel().attrOrCreate("key").setValue(""+param),this},GlobalSchemaImpl.prototype.value=function(){return _super.prototype.attribute.call(this,"value",function(attr){return new SchemaStringImpl(attr)})},GlobalSchemaImpl.prototype.wrapperClassName=function(){return"GlobalSchemaImpl"},GlobalSchemaImpl.prototype.kind=function(){return"GlobalSchema"},GlobalSchemaImpl.prototype.RAMLVersion=function(){return"RAML08"},GlobalSchemaImpl}(RAMLSimpleElementImpl);exports.GlobalSchemaImpl=GlobalSchemaImpl;var ResourceImpl=function(_super){function ResourceImpl(){_super.apply(this,arguments)}return __extends(ResourceImpl,_super),ResourceImpl.prototype.relativeUri=function(){return _super.prototype.attribute.call(this,"relativeUri",function(attr){return new RelativeUriStringImpl(attr)})},ResourceImpl.prototype.type=function(){return _super.prototype.attribute.call(this,"type",function(attr){return new ResourceTypeRefImpl(attr)})},ResourceImpl.prototype.is=function(){return _super.prototype.attributes.call(this,"is",function(attr){return new TraitRefImpl(attr)})},ResourceImpl.prototype.securedBy=function(){return _super.prototype.attributes.call(this,"securedBy",function(attr){return new SecuritySchemeRefImpl(attr)})},ResourceImpl.prototype.uriParameters_original=function(){return _super.prototype.elements.call(this,"uriParameters")},ResourceImpl.prototype.methods=function(){return _super.prototype.elements.call(this,"methods")},ResourceImpl.prototype.resources=function(){return _super.prototype.elements.call(this,"resources")},ResourceImpl.prototype.displayName=function(){return _super.prototype.attribute.call(this,"displayName",this.toString)},ResourceImpl.prototype.setDisplayName=function(param){return this.highLevel().attrOrCreate("displayName").setValue(""+param),this},ResourceImpl.prototype.baseUriParameters=function(){return _super.prototype.elements.call(this,"baseUriParameters")},ResourceImpl.prototype.description=function(){return _super.prototype.attribute.call(this,"description",function(attr){return new MarkdownStringImpl(attr)})},ResourceImpl.prototype.wrapperClassName=function(){return"ResourceImpl"},ResourceImpl.prototype.kind=function(){return"Resource"},ResourceImpl.prototype.RAMLVersion=function(){return"RAML08"},ResourceImpl.prototype.completeRelativeUri=function(){return helper.completeRelativeUri(this)},ResourceImpl.prototype.absoluteUri=function(){return helper.absoluteUri(this)},ResourceImpl.prototype.parentResource=function(){return helper.parent(this)},ResourceImpl.prototype.childResource=function(relPath){return helper.childResource(this,relPath)},ResourceImpl.prototype.childMethod=function(method){return helper.childMethod(this,method)},ResourceImpl.prototype.ownerApi=function(){return helper.ownerApi(this)},ResourceImpl.prototype.uriParameters=function(){return helper.uriParametersPrimary(this)},ResourceImpl.prototype.allUriParameters=function(){return helper.uriParameters(this)},ResourceImpl.prototype.absoluteUriParameters=function(){return helper.absoluteUriParameters(this)},ResourceImpl.prototype.allSecuredBy=function(){return helper.allSecuredBy(this)},ResourceImpl}(core.BasicNodeImpl);exports.ResourceImpl=ResourceImpl,exports.loadApiSync=loadApiSync,exports.loadRAMLSync=loadRAMLSync,exports.loadApi=loadApi,exports.loadRAML=loadRAML,exports.getLanguageElementByRuntimeType=getLanguageElementByRuntimeType},function(module,exports,__webpack_require__){"use strict";function load(pth){var m=new ll.Project(path.dirname(pth)),unit=m.unit(path.basename(pth));return unit&&unit.isRAMLUnit()?hlimpl.fromUnit(unit).wrapperNode():null}function expandTraitsAndResourceTypes(api){var lowLevelNode=api.highLevel().lowLevel();return lowLevelNode instanceof lowLevelProxy.LowLevelProxyNode?api:expander.expandTraitsAndResourceTypes(api)}function completeRelativeUri(res){var uri="",parent=res;do res=parent,uri=res.relativeUri().value()+uri,parent=res.parent();while(parent.definition().key().name==universes.Universe08.Resource.name);return uri}function absoluteUri(res){var uri="",parent=res;do res=parent,uri=res.relativeUri().value()+uri,parent=res.parent();while(parent.definition().key().name==universes.Universe08.Resource.name);uri=uri.replace(/\/\//g,"/");var buri=parent.baseUri(),base=buri?buri.value():"";return base=base?base:"",util.stringEndsWith(base,"/")&&(uri=uri.substring(1)),uri=base+uri}function qName(c){return hlimpl.qName(c.highLevel(),c.highLevel().root())}function traitsPrimary(a){return allTraits(a)}function allTraits(a){return findTemplates(a,function(d){return universeHelpers.isTraitType(d)})}function resourceTypesPrimary(a){return allResourceTypes(a)}function allResourceTypes(a){return findTemplates(a,function(d){return universeHelpers.isResourceTypeType(d)})}function findTemplates(a,filter){var arr=search.globalDeclarations(a.highLevel()).filter(function(x){return filter(x.definition())}),ll=a.highLevel().lowLevel(),nodePath=ll.includePath();nodePath||(nodePath=ll.unit().path());var topLevelArr=arr.map(function(x){var topLevelNode,p=x.lowLevel().unit().path();return p!=nodePath?(topLevelNode=factory.buildWrapperNode(x,!1),topLevelNode.meta().setCalculated()):topLevelNode=x.wrapperNode(),topLevelNode});return topLevelArr}function relativeUriSegments(res){var result=[],parent=res;do res=parent,result.push(res.relativeUri().value()),parent=res.parent();while(parent.definition().key().name==universes.Universe08.Resource.name);return result.reverse()}function parentResource(method){return method.parent()instanceof RamlWrapperImpl.ResourceImpl?method.parent():null}function parent(resource){var parent=resource.parent();return parent.definition().key().name==universes.Universe08.Resource.name,null}function childResource(container,relPath){if(null==container)return null;var resources=container.resources();return resources?(resources=resources.filter(function(x){return x.relativeUri().value()==relPath}),0==resources.length?null:resources[0]):null}function getResource(container,path){if(!container)return null;for(var res=null,i=0;i<path.length;i++){if(res=childResource(container,path[i]),!res)return null;container=res}return res}function childMethod(resource,method){return resource?resource.methods().filter(function(x){return x.method()==method}):null}function getMethod(container,path,method){var resource=getResource(container,path);return null==resource?null:childMethod(resource,method)}function isApi(obj){return obj.definition().key().name==universes.Universe08.Api.name}function ownerApi(method){for(var obj=method;!isApi(obj);)obj=obj.parent();return obj}function methodId(method){var parent=method.parent();if(parent instanceof RamlWrapperImpl.ResourceImpl)return completeRelativeUri(parent)+" "+method.method().toLowerCase();if(parent instanceof RamlWrapperImpl.ResourceTypeImpl)return parent.name()+" "+method.method().toLowerCase();throw new Error("Method is supposed to be owned by Resource or ResourceType.\nHere the method is owned by "+method.definition().key().name)}function isOkRange(response){var str=response.code().value(),err=linter.validateResponseString(str);if(null!=err)return!1;try{if(parseInt(str.charAt(0))<4)return!0}catch(e){}return!1}function allResources(api){var resources=[],visitor=function(res){resources.push(res),res.resources().forEach(function(x){return visitor(x)})};return api.resources().forEach(function(x){return visitor(x)}),resources}function uriParametersPrimary(resource){return uriParameters(resource)}function uriParameters(resource){var uri=resource.relativeUri().value(),params=resource.uriParameters_original(),propName=universes.Universe08.Resource.properties.uriParameters.name;return extractParams(params,uri,resource,propName)}function baseUriParametersPrimary(api){return baseUriParameters(api)}function baseUriParameters(api){var uri=api.baseUri()?api.baseUri().value():"",params=api.baseUriParameters_original(),propName=universes.Universe08.Api.properties.baseUriParameters.name;return extractParams(params,uri,api,propName)}function absoluteUriParameters(res){var params=[],parent=res;do res=parent,params=uriParameters(res).concat(params),parent=res.parent();while(parent.definition().key().name==universes.Universe10.Resource.name);var api=parent;api.baseUriParameters();return params=baseUriParameters(api).concat(params)}function protocolsPrimary(api){return allProtocols(api)}function allProtocols(api){return api.protocols().map(function(x){return x.toUpperCase()})}function securedByPrimary(resourceOrMethod){return allSecuredBy(resourceOrMethod)}function allSecuredBy(resourceOrMethod){return resourceOrMethod.securedBy()}function securitySchemeName(schemeReference){var highLevel=schemeReference.highLevel();if(!highLevel)return"";var attributeValue=highLevel.value();return attributeValue?attributeValue.toString():""}function securityScheme(schemeReference){var highLevel=schemeReference.highLevel();if(!highLevel)return null;var declaration=search.findDeclarationByNode(highLevel,search.LocationKind.VALUE_COMPLETION);if(!declaration)return null;if(!declaration.getKind||declaration.getKind()!=hl.NodeKind.NODE)return null;var result=declaration.wrapperNode();return result instanceof RamlWrapperImpl.AbstractSecuritySchemeImpl?result:null}function RAMLVersion(api){return api.highLevel().definition().universe().version()}function structuredValue(reference){var hl=reference.value().lowLevel();return new core.TypeInstanceImpl(hl)}function referenceName(reference){var val=reference.highLevel().value();return"string"==typeof val||null==val?val:val.valueName()}function referencedTrait(ref){return referencedObject(ref)}function referencedResourceType(ref){return referencedObject(ref)}function referencedObject(ref){var attr=ref.highLevel(),parent=attr.parent(),vn=ref.name(),cands=search.referenceTargets(attr.property(),parent).filter(function(x){return hlimpl.qName(x,parent)==vn});return 0==cands.length?null:cands[0].wrapperNode()}function extractParams(params,uri,owner,propName){var ownerHl=owner.highLevel(),prop=ownerHl.definition().property(propName);if(!uri)return[];var describedParams={};params.forEach(function(x){var arr=describedParams[x.name()];arr||(arr=[],describedParams[x.name()]=arr),arr.push(x)});for(var allParams=[],prev=0,mentionedParams={},i=uri.indexOf("{");i>=0;i=uri.indexOf("{",prev)){prev=uri.indexOf("}",++i);var paramName=uri.substring(i,prev);if(mentionedParams[paramName]=!0,describedParams[paramName])describedParams[paramName].forEach(function(x){return allParams.push(x)});else{var uriParameter=new RamlWrapperImpl.StringTypeDeclarationImpl(paramName);uriParameter.setName(paramName);var hlNode=uriParameter.highLevel();hlNode.setParent(ownerHl),uriParameter.meta().setCalculated(),hlNode.patchProp(prop),allParams.push(uriParameter)}}return Object.keys(describedParams).filter(function(x){return!mentionedParams[x]}).forEach(function(x){return describedParams[x].forEach(function(y){return allParams.push(y)})}),allParams}function schemaContent(bodyDeclaration){var schemaDecl=bodyDeclaration.schema();if(null==schemaDecl)return null;var schemaString=schemaDecl.value();if(!schemaString)return null;var schemaAttribute=bodyDeclaration.highLevel().attr(universes.Universe08.BodyLike.properties.schema.name);if(!schemaAttribute)return schemaString;var declaration=search.findDeclarationByNode(schemaAttribute,search.LocationKind.VALUE_COMPLETION);if(!declaration)return schemaString;if(!declaration.getKind||declaration.getKind()!=hl.NodeKind.NODE)return schemaString;if(declaration.definition().key()!=universes.Universe08.GlobalSchema)return schemaString;var valueAttribute=declaration.attr(universes.Universe08.GlobalSchema.properties.value.name);return null==valueAttribute?null:valueAttribute.value()}function getTemplateParametrizedProperties(node){var highLevelNode=node.highLevel();if(null==highLevelNode)return null;var lowLevelNode=highLevelNode.lowLevel();if(null==lowLevelNode)return null;var children=lowLevelNode.children().filter(function(x){return x.key().indexOf("<<")>=0});if(0==children.length)return null;var result=new core.TypeInstanceImpl(children);return result}var RamlWrapperImpl=__webpack_require__(47),factory=__webpack_require__(43),core=__webpack_require__(45),hl=__webpack_require__(10),hlimpl=__webpack_require__(16),universes=__webpack_require__(22),expander=__webpack_require__(24),lowLevelProxy=__webpack_require__(38),linter=__webpack_require__(25),util=__webpack_require__(31),search=__webpack_require__(23),universeHelpers=__webpack_require__(14),ll=__webpack_require__(27),path=__webpack_require__(15);exports.load=load,exports.expandTraitsAndResourceTypes=expandTraitsAndResourceTypes,exports.completeRelativeUri=completeRelativeUri,exports.absoluteUri=absoluteUri,exports.qName=qName,exports.traitsPrimary=traitsPrimary,exports.allTraits=allTraits,exports.resourceTypesPrimary=resourceTypesPrimary,exports.allResourceTypes=allResourceTypes,exports.relativeUriSegments=relativeUriSegments,exports.parentResource=parentResource,exports.parent=parent,exports.childResource=childResource,exports.getResource=getResource,exports.childMethod=childMethod,exports.getMethod=getMethod,exports.ownerApi=ownerApi,exports.methodId=methodId,exports.isOkRange=isOkRange,exports.allResources=allResources;exports.uriParametersPrimary=uriParametersPrimary,exports.uriParameters=uriParameters,exports.baseUriParametersPrimary=baseUriParametersPrimary,exports.baseUriParameters=baseUriParameters,exports.absoluteUriParameters=absoluteUriParameters,exports.protocolsPrimary=protocolsPrimary,exports.allProtocols=allProtocols,exports.securedByPrimary=securedByPrimary,exports.allSecuredBy=allSecuredBy,exports.securitySchemeName=securitySchemeName,exports.securityScheme=securityScheme,exports.RAMLVersion=RAMLVersion,exports.structuredValue=structuredValue,exports.referenceName=referenceName,exports.referencedTrait=referencedTrait,exports.referencedResourceType=referencedResourceType,exports.schemaContent=schemaContent,exports.getTemplateParametrizedProperties=getTemplateParametrizedProperties},function(module,exports,__webpack_require__){"use strict";function escapeTemplateParameters(str){if(null==str||"string"!=typeof str)return{status:ParametersEscapingStatus.NOT_REQUIRED};for(var resultingString="",map={},prev=0,i=str.indexOf("<<");i>=0;i=str.indexOf("<<",prev)){if(resultingString+=str.substring(prev,i),prev=str.indexOf(">>",i),prev<0)return{status:ParametersEscapingStatus.ERROR};prev+=">>".length;var paramStr=str.substring(i,prev),substitution=PARAM_OCCURENCE_STR+i+PARAM_OCCURENCE_STR;map[substitution]=paramStr,resultingString+=substitution}return 0==resultingString.length?{status:ParametersEscapingStatus.NOT_REQUIRED}:(resultingString+=str.substring(prev,str.length),{resultingString:resultingString,substitutions:map,status:ParametersEscapingStatus.OK})}function unescapeTemplateParameters(str,substitutions){if(null==str)return{status:ParametersEscapingStatus.NOT_REQUIRED};for(var resultingString="",prev=0,i=str.indexOf(PARAM_OCCURENCE_STR);i>=0;i=str.indexOf(PARAM_OCCURENCE_STR,prev)){if(prev=str.indexOf(PARAM_OCCURENCE_STR,i+1),prev+=PARAM_OCCURENCE_STR.length,prev<0)return{status:ParametersEscapingStatus.ERROR};var substitution=str.substring(i,prev),originalParamOccurence=substitutions[substitution];if(null==originalParamOccurence)return{status:ParametersEscapingStatus.ERROR};resultingString+=originalParamOccurence;
}return 0==resultingString.length?{status:ParametersEscapingStatus.NOT_REQUIRED}:(resultingString+=str.substring(prev,str.length),{resultingString:resultingString,substitutions:substitutions,status:ParametersEscapingStatus.OK})}function checkExpression(value){for(var gotExpression=!1,i=0;i<value.length;i++){var ch=value.charAt(i);if("|"==ch||"("==ch||"["==ch){gotExpression=!0;break}}return gotExpression}function patchMethodIs(node,traits){var llMethod=node.lowLevel(),ramlVersion=node.definition().universe().version(),originalLlMethod=toOriginal(llMethod),isPropertyName=universeDef.Universe10.MethodBase.properties.is.name,isNode=_.find(llMethod.children(),function(x){return x.key()==isPropertyName});if(null==isNode){var newLLIsNode=new jsyaml.ASTNode(yaml.newMapping(yaml.newScalar(isPropertyName),yaml.newItems()),originalLlMethod.unit(),originalLlMethod,null,null);isNode=llMethod.replaceChild(null,newLLIsNode)}var originalIsNode=_.find(originalLlMethod.children(),function(x){return x.key()==isPropertyName}),childrenToPreserve=null!=originalIsNode?originalIsNode.children():[],newTraits=childrenToPreserve.concat(traits.map(function(x){var llChNode=prepareTraitRefNode(x.node,isNode),cNode=new proxy.LowLevelCompositeNode(llChNode,isNode,x.transformer,ramlVersion);return cNode}));return isNode.setChildren(newTraits),isNode.filterChildren(),isNode}function prepareTraitRefNode(llNode,llParent){llParent=toOriginal(llParent),llNode=toOriginal(llNode);var yNode=llNode.actual();llNode.key()==universeDef.Universe10.MethodBase.properties.is.name&&(yNode=llNode.yamlNode().value),yNode.kind==yaml.Kind.SEQ&&(yNode=yNode.items[0]);var result=new jsyaml.ASTNode(yNode,llNode.unit(),llParent,null,null);return result}function toOriginal(node){for(var i=0;i<2&&node instanceof proxy.LowLevelProxyNode;i++)node=node.originalNode();return node}var hlimpl=__webpack_require__(16),yaml=__webpack_require__(70),jsyaml=__webpack_require__(27),proxy=__webpack_require__(38),universeDef=__webpack_require__(22),_=__webpack_require__(61),universeHelpers=__webpack_require__(14),namespaceResolver=__webpack_require__(54),def=__webpack_require__(36),typeExpressions=def.rt.typeExpressions,ReferencePatcher=function(){function ReferencePatcher(){}return ReferencePatcher.prototype.process=function(hlNode,rootNode,removeUses,patchNodeName){void 0===rootNode&&(rootNode=hlNode),void 0===removeUses&&(removeUses=!1),void 0===patchNodeName&&(patchNodeName=!1);var resolver=hlNode.lowLevel().unit().project().namespaceResolver();this.patchReferences(hlNode,rootNode,resolver),patchNodeName&&this.patchNodeName(hlNode,rootNode.lowLevel().unit(),resolver),removeUses?this.removeUses(hlNode.lowLevel()):this.patchUses(hlNode.lowLevel(),resolver),this.resetTypes(hlNode),hlNode.resetChildren()},ReferencePatcher.prototype.patchReferences=function(node,rootNode,resolver,units){void 0===rootNode&&(rootNode=node),void 0===resolver&&(resolver=new namespaceResolver.NamespaceResolver),void 0===units&&(units=[rootNode.lowLevel().unit()]);var isNode;if(null!=node.definition().property(universeDef.Universe10.TypeDeclaration.properties.annotations.name)){var cNode=node.lowLevel(),isPropertyName=universeDef.Universe10.MethodBase.properties.is.name,traitNodes=node.attributes(isPropertyName);cNode.preserveAnnotations(),node.resetChildren(),0!=traitNodes.length&&(isNode=patchMethodIs(node,traitNodes.map(function(x){return x.lowLevel()}).map(function(x){return{node:x,transformer:x.transformer()}})))}for(var attrs=node.attrs(),_i=0,attrs_1=attrs;_i<attrs_1.length;_i++){var attr=attrs_1[_i],appended=this.appendUnitIfNeeded(attr,units);this.patchReferenceAttr(attr,rootNode,resolver,units),this.popUnitIfNeeded(units,appended)}if(universeHelpers.isTypeDeclarationSibling(node.definition())){var appended=this.appendUnitIfNeeded(node,units);this.patchType(node,rootNode,resolver,units),this.popUnitIfNeeded(units,appended)}for(var childNodes=node.elements(),_a=0,childNodes_1=childNodes;_a<childNodes_1.length;_a++){var ch=childNodes_1[_a],appended=this.appendUnitIfNeeded(ch,units);this.patchReferences(ch,rootNode,resolver,units),this.popUnitIfNeeded(units,appended)}isNode&&isNode.filterChildren()},ReferencePatcher.prototype.patchReferenceAttr=function(attr,rootNode,resolver,units){var property=attr.property();if(property.range().isAssignableFrom(universeDef.Universe10.Reference.name)){var value=attr.value();if(null!=value){var llNode=attr.lowLevel(),transformer=llNode.transformer(),isAnnotation=universeHelpers.isAnnotationsProperty(property);if("string"==typeof value){var stringToPatch=value;if(null!=transformer){var actualNode=toOriginal(llNode);stringToPatch=actualNode.value()}isAnnotation&&(stringToPatch=stringToPatch.substring(1,stringToPatch.length-1));var newValue=this.patchTypeName(stringToPatch,rootNode.lowLevel().unit(),units,resolver,transformer,isAnnotation);null!=newValue&&(isAnnotation&&(newValue="("+newValue+")"),attr.lowLevel().setValueOverride(newValue))}else{var sValue=value,key=sValue.lowLevel().key(),stringToPatch=key;if(null!=transformer){var actualNode=toOriginal(sValue.lowLevel());stringToPatch=actualNode.key()}if(null!=key){isAnnotation&&(stringToPatch=stringToPatch.substring(1,stringToPatch.length-1));var newValue=this.patchTypeName(stringToPatch,rootNode.lowLevel().unit(),units,resolver,transformer,isAnnotation);null!=newValue&&(isAnnotation&&(newValue="("+newValue+")"),sValue.lowLevel().setKeyOverride(newValue))}}}}},ReferencePatcher.prototype.patchType=function(node,rootNode,resolver,units){var _this=this;if(!node.localType().isExternal())for(var rootUnit=rootNode.lowLevel().unit(),rootPath=rootUnit.absolutePath(),typeAttributes=node.attributes(universeDef.Universe10.TypeDeclaration.properties.type.name),_i=0,typeAttributes_1=typeAttributes;_i<typeAttributes_1.length;_i++){var typeAttr=typeAttributes_1[_i],localUnit=typeAttr.lowLevel().unit(),localPath=localUnit.absolutePath();if(localPath!=rootPath){var value=typeAttr.value();if("string"==typeof value){var gotExpression=checkExpression(value),llNode=typeAttr.lowLevel(),transformer=llNode.transformer(),stringToPatch=value,escapeData={status:ParametersEscapingStatus.NOT_REQUIRED},additionalUnits=transformer?transformer.unitsChain:null;if(null!=transformer||value.indexOf("<<")>=0){var actualNode=toOriginal(llNode),actualValue=actualNode.value();escapeData=escapeTemplateParameters(actualValue),escapeData.status==ParametersEscapingStatus.OK?stringToPatch=gotExpression?escapeData.resultingString:actualValue:transformer=null}var appendedAdditional;if(additionalUnits){appendedAdditional=[];for(var _a=0,additionalUnits_1=additionalUnits;_a<additionalUnits_1.length;_a++){var u=additionalUnits_1[_a];appendedAdditional.push(this.appendUnitIfNeeded(u,units))}}var newValue,appendedAttrUnit=this.appendUnitIfNeeded(typeAttr,units);if(gotExpression){var expressionPatchFailed=!1,expr=typeExpressions.parse(stringToPatch),gotPatch=!1;typeExpressions.visit(expr,function(x){if("name"==x.type){var unescaped,lit=x,typeName=lit.value,unescapeData={status:ParametersEscapingStatus.NOT_REQUIRED};if(escapeData.status==ParametersEscapingStatus.OK)if(unescaped=escapeData.substitutions[typeName],null==unescaped){if(unescapeData=unescapeTemplateParameters(typeName,escapeData.substitutions),unescapeData.status==ParametersEscapingStatus.OK)typeName=unescapeData.resultingString;else if(unescapeData.status==ParametersEscapingStatus.ERROR)return void(expressionPatchFailed=!0)}else typeName=unescaped;if(null==transformer&&(null!=unescaped||unescapeData.status==ParametersEscapingStatus.OK))return void(lit.value=typeName);var patched=_this.patchTypeName(typeName,rootUnit,units,resolver,transformer);null!=patched&&(lit.value=patched,gotPatch=!0)}}),newValue=gotPatch&&!expressionPatchFailed?typeExpressions.serializeToString(expr):value}else escapeData.status==ParametersEscapingStatus.OK&&null==transformer||(newValue=this.patchTypeName(stringToPatch,rootUnit,units,resolver,transformer));if(null!=newValue&&(typeAttr.lowLevel().setValueOverride(newValue),typeAttr.overrideValue(null)),this.popUnitIfNeeded(units,appendedAttrUnit),appendedAdditional)for(var _b=0,_c=appendedAdditional.reverse();_b<_c.length;_b++){var ap=_c[_b];this.popUnitIfNeeded(units,ap)}}else{var llTypeNode=_.find(node.lowLevel().children(),function(x){return"type"==x.key()});if(llTypeNode){var def=node.definition().universe().type(universeDef.Universe10.TypeDeclaration.name),newNode=new hlimpl.ASTNodeImpl(llTypeNode,null,def,null),appended=this.appendUnitIfNeeded(newNode,units);this.patchReferences(newNode,rootNode,resolver,units),this.popUnitIfNeeded(units,appended)}}}}},ReferencePatcher.prototype.patchTypeName=function(stringToPatch,rootUnit,units,resolver,transformer,isAnnotation){var _this=this;void 0===isAnnotation&&(isAnnotation=!1);var newValue;if(transformer&&stringToPatch&&stringToPatch.indexOf("<<")>=0){var doContinue=!0,types=rootUnit.highLevel().types();newValue=transformer.transform(stringToPatch,!0,function(){return doContinue},function(val,tr){var newVal=_this.patchValue(val,rootUnit,resolver,tr.unitsChain);return null==newVal&&(newVal=val),isAnnotation?null!=types.getAnnotationType(newVal)&&(doContinue=!1):null!=types.getType(newVal)&&(doContinue=!1),newVal}).value}return void 0===newValue&&(newValue=this.patchValue(stringToPatch,rootUnit,resolver,units)),newValue},ReferencePatcher.prototype.patchNodeName=function(hlNode,rootUnit,resolver){var llNode=hlNode.lowLevel(),key=llNode.key(),patched=this.patchValue(key,rootUnit,resolver,[llNode.unit()]);null!=patched&&llNode.setKeyOverride(patched)},ReferencePatcher.prototype.patchValue=function(value,rootUnit,resolver,units){var referencedUnit,plainName,ind=value.lastIndexOf(".");if(ind>=0){var oldNS=value.substring(0,ind);plainName=value.substring(ind+1);for(var i=units.length;i>0;i--){var localUnit=units[i-1],nsMap=resolver.nsMap(localUnit);if(null!=nsMap){var info=nsMap[oldNS];if(null!=info&&(referencedUnit=info.unit,null!=referencedUnit))break}}}else{if(null!=def.rt.builtInTypes().get(value))return null;plainName=value,referencedUnit=units[units.length-1]}var newNS=resolver.resolveNamespace(rootUnit,referencedUnit);if(null==newNS)return null;var newValue=newNS+"."+plainName;return newValue},ReferencePatcher.prototype.patchUses=function(node,resolver){if(node instanceof proxy.LowLevelCompositeNode){var unit=node.unit(),extendedUnitMap=resolver.expandedPathMap(unit);if(null!=extendedUnitMap){var unitMap=resolver.pathMap(unit);unitMap||(unitMap={});for(var cNode=node,originalChildren=node.children(),usesNodes=originalChildren.filter(function(x){return x.key()==universeDef.Universe10.FragmentDeclaration.properties.uses.name}),oNode=toOriginal(node),yamlNode=oNode;yamlNode instanceof proxy.LowLevelProxyNode;)yamlNode=yamlNode.originalNode();var usesInfos=Object.keys(unitMap).map(function(x){return extendedUnitMap[x]}),extendedUsesInfos=Object.keys(extendedUnitMap).map(function(x){return extendedUnitMap[x]}).filter(function(x){return!unitMap[x.absolutePath()]}),u=node.unit(),newUses=(u.absolutePath(),jsyaml.createMapNode("uses"));newUses._parent=yamlNode,newUses.setUnit(yamlNode.unit());for(var _i=0,_a=usesInfos.concat(extendedUsesInfos);_i<_a.length;_i++){var ui=_a[_i],ip=(ui.absolutePath(),ui.includePath),mapping=jsyaml.createMapping(ui.namespace(),ip);mapping.setUnit(yamlNode.unit()),newUses.addChild(mapping)}for(usesNodes.length>0?cNode.replaceChild(usesNodes[0],newUses):cNode.replaceChild(null,newUses);node instanceof proxy.LowLevelProxyNode;)node=node.originalNode()}}},ReferencePatcher.prototype.removeUses=function(node){if(node instanceof proxy.LowLevelCompositeNode){var cNode=node,originalChildren=node.children(),usesNodes=originalChildren.filter(function(x){return x.key()==universeDef.Universe10.FragmentDeclaration.properties.uses.name});usesNodes.length>0&&cNode.removeChild(usesNodes[0])}},ReferencePatcher.prototype.resetTypes=function(hlNode){for(var _i=0,_a=hlNode.elements();_i<_a.length;_i++){var ch=_a[_i];this.resetTypes(ch)}delete hlNode.lowLevel().actual().types,delete hlNode._ptype,delete hlNode._types,hlNode.setAssociatedType(null)},ReferencePatcher.prototype.appendUnitIfNeeded=function(node,units){if(node instanceof jsyaml.CompilationUnit){var unit=node;return unit.absolutePath()!=units[units.length-1].absolutePath()&&(units.push(unit),!0)}var originalNode=toOriginal(node.lowLevel()),originalUnit=originalNode.unit();if(originalNode.valueKind()==yaml.Kind.INCLUDE_REF){var ref=originalNode.includePath(),includedUnit=originalUnit.resolve(ref);return units.push(includedUnit),!0}return originalUnit.absolutePath()!=units[units.length-1].absolutePath()&&(units.push(originalUnit),!0)},ReferencePatcher.prototype.popUnitIfNeeded=function(units,appended){appended&&units.pop()},ReferencePatcher}();exports.ReferencePatcher=ReferencePatcher;var ParametersEscapingStatus;!function(ParametersEscapingStatus){ParametersEscapingStatus[ParametersEscapingStatus.OK=0]="OK",ParametersEscapingStatus[ParametersEscapingStatus.NOT_REQUIRED=1]="NOT_REQUIRED",ParametersEscapingStatus[ParametersEscapingStatus.ERROR=2]="ERROR"}(ParametersEscapingStatus||(ParametersEscapingStatus={}));var PARAM_OCCURENCE_STR="__P_A_R_A_M_E_T_E_R__";exports.patchMethodIs=patchMethodIs,exports.prepareTraitRefNode=prepareTraitRefNode},function(module,exports,__webpack_require__){"use strict";function serialize(node,options){if(void 0===options&&(options={}),0==node.children().length)return node.value();if(node.children()[0].key()){var obj={};if(node.children().forEach(function(x){obj[escapeKey(x.key(),options)]=serialize(x,options)}),options&&options.writeErrors){var errors=collectErrors(node);null!=errors&&errors.length>0&&(obj.__$errors__=errors)}return obj}var arr=[];return node.children().forEach(function(x){arr.push(serialize(x,options))}),arr}function collectErrors(node){var errors=[].concat(node.errors());return node.children().forEach(function(ch){var children=ch.children();return 0==children.length?void ch.errors().forEach(function(e){return errors.push(e)}):void(children[0].key()||children.forEach(function(x){0==x.children().length&&x.errors().forEach(function(e){return errors.push(e)})}))}),errors}function escapeKey(key,options){return options&&key&&options.escapeNumericKeys&&0==key.replace(/\d/g,"").trim().length?"__$EscapedKey$__"+key:key}function unescapeKey(key,options){return key?(options=options||{},options.escapeNumericKeys&&util.stringStartsWith(key,"__$EscapedKey$__")&&0==key.substring("__$EscapedKey$__".length).replace(/\d/g,"").trim().length?key.substring("__$EscapedKey$__".length):key):key}var yaml=__webpack_require__(70),lowlevel=__webpack_require__(11),hlimpl=__webpack_require__(16),util=__webpack_require__(31),llImpl=__webpack_require__(27),Error=yaml.YAMLException,CompilationUnit=function(){function CompilationUnit(_absolutePath,_path,_content,_project,_isTopoLevel,serializeOptions){void 0===serializeOptions&&(serializeOptions={}),this._absolutePath=_absolutePath,this._path=_path,this._content=_content,this._project=_project,this._isTopoLevel=_isTopoLevel,this.serializeOptions=serializeOptions,this._node=new AstNode(this,JSON.parse(this._content),null,serializeOptions)}return CompilationUnit.prototype.highLevel=function(){return hlimpl.fromUnit(this)},CompilationUnit.prototype.absolutePath=function(){return this._absolutePath},CompilationUnit.prototype.clone=function(){return null},CompilationUnit.prototype.contents=function(){return this._content},CompilationUnit.prototype.lexerErrors=function(){return[]},CompilationUnit.prototype.path=function(){return this._content},CompilationUnit.prototype.isTopLevel=function(){return this._isTopoLevel},CompilationUnit.prototype.ast=function(){return this._node},CompilationUnit.prototype.expandedHighLevel=function(){return this.highLevel()},CompilationUnit.prototype.isDirty=function(){return!0},CompilationUnit.prototype.getIncludeNodes=function(){return[]},CompilationUnit.prototype.resolveAsync=function(p){return null},CompilationUnit.prototype.isRAMLUnit=function(){return!0},CompilationUnit.prototype.project=function(){return this._project},CompilationUnit.prototype.updateContent=function(newContent){},CompilationUnit.prototype.ramlVersion=function(){throw new Error("not implemented")},CompilationUnit.prototype.lineMapper=function(){return new lowlevel.LineMapperImpl(this.contents(),this.absolutePath())},CompilationUnit.prototype.resolve=function(p){return null},CompilationUnit.prototype.isOverlayOrExtension=function(){return!1},CompilationUnit.prototype.getMasterReferenceNode=function(){return null},CompilationUnit}();exports.CompilationUnit=CompilationUnit;var AstNode=function(){function AstNode(_unit,_object,_parent,options,_key){var _this=this;void 0===options&&(options={}),this._unit=_unit,this._object=_object,this._parent=_parent,this.options=options,this._key=_key,this._isOptional=!1,this._object instanceof Object&&Object.keys(this._object).forEach(function(x){var u=unescapeKey(x,_this.options);if(u!=x){var val=_this._object[x];delete _this._object[x],_this._object[u]=val}}),this._key&&util.stringEndsWith(this._key,"?")&&(this._isOptional=!0,this._key=this._key.substring(0,this._key.length-1))}return AstNode.prototype.keyKind=function(){return null},AstNode.prototype.isAnnotatedScalar=function(){return!1},AstNode.prototype.hasInnerIncludeError=function(){return!1},AstNode.prototype.start=function(){return-1},AstNode.prototype.end=function(){return-1},AstNode.prototype.value=function(){return this._object},AstNode.prototype.actual=function(){return this._object},AstNode.prototype.includeErrors=function(){return[]},AstNode.prototype.includePath=function(){return null},AstNode.prototype.includeReference=function(){return null},AstNode.prototype.key=function(){return this._key},AstNode.prototype.optional=function(){return this._isOptional},AstNode.prototype.children=function(){var _this=this;return this._object?Array.isArray(this._object)?this._object.map(function(x){return new AstNode(_this._unit,x,_this,_this.options)}):this._object instanceof Object?Object.keys(this._object).map(function(x){return new AstNode(_this._unit,_this._object[x],_this,_this.options,x)}):[]:[]},AstNode.prototype.parent=function(){return this._parent},AstNode.prototype.unit=function(){return this._unit},AstNode.prototype.includeBaseUnit=function(){return this._unit},AstNode.prototype.anchorId=function(){return null},AstNode.prototype.errors=function(){return[]},AstNode.prototype.anchoredFrom=function(){return this},AstNode.prototype.includedFrom=function(){return this},AstNode.prototype.visit=function(v){v(this)&&this.children().forEach(function(x){return x.visit(v)})},AstNode.prototype.dumpToObject=function(){return this._object},AstNode.prototype.addChild=function(n){},AstNode.prototype.execute=function(cmd){},AstNode.prototype.dump=function(){return JSON.stringify(this._object)},AstNode.prototype.keyStart=function(){return-1},AstNode.prototype.keyEnd=function(){return-1},AstNode.prototype.valueStart=function(){return-1},AstNode.prototype.valueEnd=function(){return-1},AstNode.prototype.isValueLocal=function(){return!0},AstNode.prototype.kind=function(){return Array.isArray(this._object)?yaml.Kind.SEQ:this._object instanceof Object?yaml.Kind.MAP:yaml.Kind.SCALAR},AstNode.prototype.valueKind=function(){if(!this._object)return null;var valType=typeof this._object;return Array.isArray(this._object)?yaml.Kind.SEQ:"object"==valType?yaml.Kind.MAP:"string"==valType||"number"==valType||"boolean"==valType?yaml.Kind.SCALAR:null},AstNode.prototype.show=function(msg){},AstNode.prototype.setHighLevelParseResult=function(highLevelParseResult){this._highLevelParseResult=highLevelParseResult},AstNode.prototype.highLevelParseResult=function(){return this._highLevelParseResult},AstNode.prototype.setHighLevelNode=function(highLevel){this._highLevelNode=highLevel},AstNode.prototype.highLevelNode=function(){return this._highLevelNode},AstNode.prototype.text=function(unitText){throw new Error("not implemented")},AstNode.prototype.copy=function(){throw new Error("not implemented")},AstNode.prototype.markup=function(json){throw new Error("not implemented")},AstNode.prototype.nodeDefinition=function(){return llImpl.getDefinitionForLowLevelNode(this)},AstNode.prototype.includesContents=function(){return!1},AstNode}();exports.AstNode=AstNode,exports.serialize=serialize},function(module,exports,__webpack_require__){"use strict";var hl=__webpack_require__(10),linter=__webpack_require__(25),OverloadingValidator=function(){function OverloadingValidator(){this.uriToResources={},this.conflictingUriToResources={}}return OverloadingValidator.prototype.validateApi=function(api,acceptor){var _this=this,resources=api.resources();resources.forEach(function(resource){_this.acceptResource(resource);var subResources=resource.resources();subResources.forEach(function(subResource){return _this.acceptResource(subResource)})});for(var uri in this.conflictingUriToResources){var resources=this.conflictingUriToResources[uri];if(resources.length>1){var idToSimilarResources={};resources.forEach(function(resource){var highLevel=resource.highLevel(),complexId="";null!=highLevel.parent()&&(complexId+=highLevel.parent().id()+"."),complexId+=highLevel.localId();var resourcesWithId=idToSimilarResources[complexId];null==resourcesWithId&&(resourcesWithId=[],idToSimilarResources[complexId]=resourcesWithId),resourcesWithId.push(resource)});var ids=Object.keys(idToSimilarResources);ids.length>1&&resources.forEach(function(resource){acceptor.accept(linter.createIssue(hl.IssueCode.KEY_SHOULD_BE_UNIQUE_INTHISCONTEXT,"Resources share same URI",resource.highLevel(),!1))})}}},OverloadingValidator.prototype.acceptResource=function(resource){var uri=resource.absoluteUri(),resources=this.uriToResources[uri];resources||(resources=[],this.uriToResources[uri]=resources),resources.push(resource),resources.length>1&&(this.conflictingUriToResources[uri]=resources)},OverloadingValidator}();module.exports=OverloadingValidator},function(module,exports,__webpack_require__){"use strict";function xmlToJson(xml){var obj={};if(1==xml.nodeType){if(xml.attributes.length>0)for(var j=0;j<xml.attributes.length;j++){var attribute=xml.attributes.item(j);obj["@"+attribute.nodeName]=attribute.nodeValue}}else 3==xml.nodeType&&(obj=xml.nodeValue);if(xml.hasChildNodes())for(var i=0;i<xml.childNodes.length;i++){var item=xml.childNodes.item(i),nodeName=item.nodeName;if(void 0!=nodeName)if("undefined"==typeof obj[nodeName])obj[nodeName]=xmlToJson(item);else{if("undefined"==typeof obj[nodeName].push){var old=obj[nodeName];obj[nodeName]=[],obj[nodeName].push(old)}obj[nodeName].push(xmlToJson(item))}}return obj}function cleanupText(j){if("object"==typeof j)for(var p in j)if("object"==typeof j[p]){for(var k in j[p])if("#text"==k){var txt=j[p]["#text"];"string"!=typeof txt&&(txt=txt.join("")),txt=txt.trim(),0==txt.length&&delete j[p]["#text"]}cleanupText(j[p])}return j}function cleanupJson(j){if("object"==typeof j)for(var p in j)if("object"==typeof j[p]){var keys=Object.keys(j[p]);1==keys.length&&"#text"==keys[0]&&(j[p]=j[p]["#text"]),cleanupJson(j[p])}return j}function parseXML(value){var v=new DomParser.DOMParser;if(!value||0==value.trim().indexOf("<<"))return null;var parsed=v.parseFromString(value);return cleanupJson(cleanupText(xmlToJson(parsed)))}var DomParser=__webpack_require__(75);module.exports=parseXML},function(module,exports,__webpack_require__){"use strict";function isScheme(content){try{var schemeObject=JSON.parse(content);return schemeObject.$schema}catch(exception){return!1}}function startDownloadingReferencesAsync(schemaContent,unit){var schemaObject=su.getJSONSchema(schemaContent,new contentprovider.ContentProvider(unit)),missedReferences=schemaObject.getMissingReferences([]).map(function(reference){return schemaObject.contentAsync(reference)});if(0===missedReferences.length)return Promise.resolve(unit);var allReferences=Promise.all(missedReferences),result=getRefs(allReferences,schemaObject);return result.then(function(){return unit})}function getReferences(schemaContent,unit){var schemaObject=su.getJSONSchema(schemaContent,new contentprovider.ContentProvider(unit));return schemaObject.getMissingReferences([],!0)}function getRefs(promise,schemaObject){return promise.then(function(references){if(references.length>0){var missedRefs=schemaObject.getMissingReferences(references);if(0===missedRefs.length)return[];var promises=[];return missedRefs.forEach(function(ref){promises.push(schemaObject.contentAsync(ref))}),getRefs(Promise.all(promises.concat(references)),schemaObject)}return Promise.resolve([])})}var contentprovider=__webpack_require__(30),def=__webpack_require__(36),su=def.getSchemaUtils();exports.isScheme=isScheme,exports.startDownloadingReferencesAsync=startDownloadingReferencesAsync,exports.getReferences=getReferences},function(module,exports,__webpack_require__){"use strict";var ll=__webpack_require__(11),path=__webpack_require__(15),universes=__webpack_require__(22),universeHelpers=__webpack_require__(14),resourceRegistry=__webpack_require__(28),NamespaceResolver=function(){function NamespaceResolver(){this.expandedAbsToNsMap={},this.byPathMap={},this.byNsMap={},this._hasFragments={}}return NamespaceResolver.prototype.resolveNamespace=function(from,to){if(null==to)return null;var toPath=to.absolutePath(),unitMap=this.expandedPathMap(from);if(!unitMap)return null;var usesInfo=unitMap[toPath];return null!=usesInfo?usesInfo.namespace():null},NamespaceResolver.prototype.expandedPathMap=function(unit){var fromPath=unit.absolutePath(),unitMap=this.expandedAbsToNsMap[fromPath];return void 0===unitMap&&(unitMap=this.calculateExpandedNamespaces(unit),0==Object.keys(unitMap).length&&(unitMap=null),this.expandedAbsToNsMap[fromPath]=unitMap),unitMap},NamespaceResolver.prototype.calculateExpandedNamespaces=function(_unit){for(var _this=this,rootPath=path.dirname(_unit.absolutePath()),result={},usesInfoArray=[];_unit;){usesInfoArray.push(new UsesInfo([],_unit,""));var u=_unit;_unit=null;var hlNode=u.highLevel();if(hlNode.isElement()){var hlElem=hlNode.asElement(),definition=hlElem.definition();if(universeHelpers.isOverlayType(definition)||universeHelpers.isExtensionType(definition)){var eValue=hlElem.attr(universes.Universe10.Extension.properties.extends.name).value();_unit=u.resolve(eValue),_unit&&resourceRegistry.isWaitingFor(_unit.absolutePath())&&(_unit=null)}}}for(var i=0;i<usesInfoArray.length;i++){var visited={},info=usesInfoArray[i],unit=info.unit,hlPR=unit.highLevel();if(hlPR.isElement()){var steps=info.steps()+1,visit=function(x){var children=x.children();if(null==x.parent()){var nodeUnit=x.unit(),localPath=nodeUnit.absolutePath();if(visited[localPath])return;visited[localPath]=!0,localPath!=unit.absolutePath()&&(_this._hasFragments[unit.absolutePath()]=!0);var map=_this.pathMap(nodeUnit);if(map)for(var _i=0,_a=Object.keys(map);_i<_a.length;_i++){var absPath=_a[_i],childInfo=map[absPath],segments=info.namespaceSegments.concat(childInfo.namespaceSegments),existing=result[absPath];if(existing){if(existing.steps()<steps)continue;if(existing.steps()==steps&&_this.lexLessEq(existing.namespaceSegments,segments))continue}var includePath,childInclude=childInfo.includePath;includePath=path.isAbsolute(info.includePath)||ll.isWebPath(info.includePath)?childInfo.absolutePath():path.isAbsolute(childInclude)||ll.isWebPath(childInclude)?childInfo.absolutePath():path.relative(rootPath,childInfo.absolutePath()),includePath=includePath.replace(/\\/g,"/");var ui=new UsesInfo(segments,childInfo.unit,includePath);result[absPath]=ui,usesInfoArray.push(ui)}}children.forEach(function(y){y.includedFrom()&&(y=y.parent()),visit(y)}),null==x.parent()&&(visited[x.unit().absolutePath()]=!1)};visit(unit.ast())}}for(var namespaces={},_i=0,_a=Object.keys(result);_i<_a.length;_i++){for(var key=_a[_i],info=result[key],ns=info.namespace(),i=0;namespaces[ns];)ns=info.namespace()+i++;ns!=info.namespace()&&(info.namespaceSegments=ns.split(".")),namespaces[ns]=!0}return result},NamespaceResolver.prototype.pathMap=function(unit){var fromPath=unit.absolutePath(),unitMap=this.byPathMap[fromPath];return void 0===unitMap&&(unitMap=this.calculateNamespaces(unit),0==Object.keys(unitMap).length&&(unitMap=null),this.byPathMap[fromPath]=unitMap),unitMap},NamespaceResolver.prototype.nsMap=function(unit){var fromPath=unit.absolutePath(),unitMap=this.byNsMap[fromPath];if(void 0===unitMap){var map=this.pathMap(unit);if(null==map)unitMap=null;else{unitMap={};for(var _i=0,_a=Object.keys(map);_i<_a.length;_i++){var aPath=_a[_i],info=map[aPath];unitMap[info.namespace()]=info}}this.byNsMap[fromPath]=unitMap}return unitMap},NamespaceResolver.prototype.calculateNamespaces=function(unit){var rootPath=path.dirname(unit.absolutePath()),result={},rootNode=unit.ast(),usesNodes=rootNode.children().filter(function(x){return x.key()==universes.Universe10.FragmentDeclaration.properties.uses.name});if(rootNode.actual()&&rootNode.actual().usesNode&&(usesNodes=[rootNode.actual().usesNode]),0==usesNodes.length)return result;for(var usesDeclarationNodes=[],_i=0,usesNodes_1=usesNodes;_i<usesNodes_1.length;_i++){var un=usesNodes_1[_i];usesDeclarationNodes=usesDeclarationNodes.concat(un.children())}if(0==usesDeclarationNodes.length)return result;for(var _a=0,usesDeclarationNodes_1=usesDeclarationNodes;_a<usesDeclarationNodes_1.length;_a++){var un=usesDeclarationNodes_1[_a],key=un.key(),value=un.value(),libUnit=unit.resolve(value);if(null!=libUnit){var includePath,segments=[key],absPath=libUnit.absolutePath();includePath=path.isAbsolute(value)||ll.isWebPath(value)?libUnit.absolutePath():path.relative(rootPath,libUnit.absolutePath()),includePath=includePath.replace(/\\/g,"/");var ui=new UsesInfo(segments,libUnit,includePath);result[absPath]=ui}}var hlNode=unit.highLevel();if(hlNode.isElement()){var hlElem=hlNode.asElement(),definition=hlElem.definition();if(universeHelpers.isOverlayType(definition)||universeHelpers.isExtensionType(definition)){var extendedUnit,eValue=hlElem.attr(universes.Universe10.Extension.properties.extends.name).value();try{extendedUnit=unit.resolve(eValue)}catch(e){}if(extendedUnit){var m=this.pathMap(extendedUnit);if(m)for(var _b=0,_c=Object.keys(m);_b<_c.length;_b++){var k=_c[_b];result[k]=m[k]}}}}return result},NamespaceResolver.prototype.lexLessEq=function(a,b){if(a.length>b.length)return!1;if(a.length<b.length)return!0;for(var i=0;i<a.length;i++){var seg_a=a[i],seg_b=b[i];if(seg_a<seg_b)return!0;if(seg_a>seg_b)return!1}return!0},NamespaceResolver.prototype.hasFragments=function(unit){return this.calculateExpandedNamespaces(unit),!!this._hasFragments[unit.absolutePath()]},NamespaceResolver}();exports.NamespaceResolver=NamespaceResolver;var UsesInfo=function(){function UsesInfo(namespaceSegments,unit,includePath){this.namespaceSegments=namespaceSegments,this.unit=unit,this.includePath=includePath}return UsesInfo.prototype.steps=function(){return this.namespaceSegments.length},UsesInfo.prototype.namespace=function(){return this.namespaceSegments.join(".")},UsesInfo.prototype.absolutePath=function(){return this.unit.absolutePath()},UsesInfo}();exports.UsesInfo=UsesInfo},function(module,exports,__webpack_require__){"use strict";function toRegExp(path,parameters,keys,options){var end=options.end!==!1,strict=options.strict,flags="";options.sensitive||(flags+="i");var route=path.replace(REGEXP_REPLACE,function(match,prefix,key,escape){if(escape)return"\\"+escape;keys.push({name:key,prefix:prefix||"/"}),prefix=prefix?"\\"+prefix:"";var param=parameters[key],capture=param&&REGEXP_MATCH[param.type]||"[^"+(prefix||"\\/")+"]+",optional=param&&param.required===!1;return Array.isArray(param.enum)&&param.enum.length&&(capture="(?:"+param.enum.map(function(value){return String(value).replace(ESCAPE_CHARACTERS,"\\$1")}).join("|")+")"),prefix+"("+capture+")"+(optional?"?":"")}),endsWithSlash="/"===path.charAt(path.length-1);return strict||(route=(endsWithSlash?route.slice(0,-2):route)+"(?:\\/(?=$))?"),
route+=end?"$":strict&&endsWithSlash?"":"(?=\\/|$)",new RegExp("^"+route+(end?"$":""),flags)}function decodeParam(param){try{return decodeURIComponent(param)}catch(_){var err=new Error('Failed to decode param "'+param+'"');throw err.status=400,err}}function ramlPathMatch(path,parameters,options){if(options=options||{},"/"===path&&options.end===!1)return truth;parameters=parameters||{};var keys=[],re=toRegExp(path,parameters,keys,options),sanitize=ramlSanitize.sanitize()(parameters),validate=ramlValidate.validate()(parameters);return function(pathname){var m=re.exec(pathname);if(!m)return!1;if(parameters.mediaTypeExtension&&m.length>1&&!m[m.length-1]){var beforeLast=m[m.length-2],ind=beforeLast.lastIndexOf(".");ind>=0&&(m[m.length-2]=beforeLast.substring(0,ind),m[m.length-1]=beforeLast.substring(ind))}for(var path=m[0],params={},i=1;i<m.length;i++){var key=keys[i-1],param=m[i];params[key.name]=null==param?param:decodeParam(param)}return params=sanitize(params),!!validate(params).valid&&{path:path,params:params}}}function truth(path){return{path:"",params:{}}}var ramlSanitize=__webpack_require__(76),ramlValidate=__webpack_require__(77),REGEXP_MATCH={number:"[-+]?\\d+(?:\\.\\d+)?",integer:"[-+]?\\d+",date:"(?:Mon|Tue|Wed|Thu|Fri|Sat|Sun), \\d{2} (?:Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec) \\d{4} (?:[0-1]\\d|2[0-3]):[0-5]\\d:[0-5]\\d GMT",boolean:"(?:true|false)"},ESCAPE_CHARACTERS=/([.*+?=^!:${}()|[\]\/\\])/g,REGEXP_REPLACE=new RegExp(["([.\\/])?\\{([^}]+)\\}",ESCAPE_CHARACTERS.source].join("|"),"g");exports.ramlPathMatch=ramlPathMatch},function(module,exports,__webpack_require__){"use strict";function toModule(arr){var main=arr[0],map={};return arr.forEach(function(x){return map[x.name]=x}),arr.forEach(function(x){var imports=x.imports;Object.keys(imports).forEach(function(y){var name=imports[y];imports[y]=map[name]})}),main}exports.universeDumps={RAML08:toModule(__webpack_require__(89)),RAML10:toModule(__webpack_require__(90))}},function(module,exports,__webpack_require__){"use strict";function toDefSystem(ts,q){var u=new def.Universe(q,""),c={};return processModule(ts,u,{},c),Object.keys(c).forEach(function(x){registerClasses(c[x],u)}),Object.keys(c).forEach(function(x){registerHierarchy(c[x],u)}),Object.keys(c).forEach(function(x){registerEverything(c[x],u)}),u.types().forEach(function(x){if(x instanceof def.NodeClass){var cl=x;if(cl.properties().forEach(function(y){var t=y.range(),ap=y;t.hasValueTypeInHierarchy()||t.properties().forEach(function(p0){if(p0.getAdapter(services.RAMLPropertyService).isKey()){var kp=p0.keyPrefix();kp&&(ap.withKeyRestriction(kp),ap.merge());var eo=p0.enumOptions();eo&&(ap.withEnumOptions(eo),ap.merge())}})}),cl.getAdapter(services.RAMLService).isGlobalDeclaration()){if(cl.getAdapter(services.RAMLService).getActuallyExports()&&"$self"!=cl.getAdapter(services.RAMLService).getActuallyExports()){var tp=cl.property(cl.getAdapter(services.RAMLService).getActuallyExports()).range();if(tp.hasValueTypeInHierarchy()){var vt=tp.getAdapter(services.RAMLService);vt.setGloballyDeclaredBy(cl)}}if(cl.getAdapter(services.RAMLService).getConvertsToGlobal()){var tp=u.type(cl.getAdapter(services.RAMLService).getConvertsToGlobal());if(tp.hasValueTypeInHierarchy()){var vt=tp.getAdapter(services.RAMLService);vt.setGloballyDeclaredBy(cl)}}}}}),u}function createProp(x,clazz,t,custom,annotations){var p=def.prop(x.name(),"",clazz,t,custom);x.isMultiValue()&&p.withMultiValue(!0),p.unmerge(),t||console.log(x.name()+":"+clazz.nameId()+" has undefined type"),t.hasValueTypeInHierarchy()||t.properties().forEach(function(p0){if(p0.getAdapter(services.RAMLPropertyService).isKey()){var kp=p0.keyPrefix();kp&&(p.withKeyRestriction(kp),p.merge());var eo=p0.enumOptions();eo&&(p.withEnumOptions(eo),p.merge())}}),processAnnotations(x,p,annotations)}var __extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},tsModel=__webpack_require__(91),def=__webpack_require__(36),_=__webpack_require__(88),aHandlers=__webpack_require__(79),services=def,FieldWrapper=function(){function FieldWrapper(_field,_clazz){this._field=_field,this._clazz=_clazz}return FieldWrapper.prototype.name=function(){return this._field.name},FieldWrapper.prototype.range=function(){return this._clazz.getModule().typeFor(this._field.type,this._clazz)},FieldWrapper.prototype.isMultiValue=function(){return this._field.type.typeKind==tsModel.TypeKind.ARRAY},FieldWrapper.prototype.isKey=function(){return null!=_.find(this._field.annotations,function(x){return"MetaModel.key"==x.name})},FieldWrapper.prototype.isSimpleValue=function(){return null!=_.find(this._field.annotations,function(x){return"MetaModel.value"==x.name})},FieldWrapper.prototype.annotations=function(){return this._field.annotations},FieldWrapper}(),FieldConstraint=function(){function FieldConstraint(_field,_clazz){this._field=_field,this._clazz=_clazz}return FieldConstraint.prototype.name=function(){return this._field.name},FieldConstraint.prototype.value=function(){return this._field.valueConstraint},FieldConstraint}(),ClassWrapper=function(){function ClassWrapper(_clazz,mw){this._clazz=_clazz,this.mw=mw}return ClassWrapper.prototype.typeMeta=function(){return this._clazz.annotations},ClassWrapper.prototype.path=function(){return this.mw.path()},ClassWrapper.prototype.getModule=function(){return this.mw},ClassWrapper.prototype.typeArgs=function(){return this._clazz.typeParameters},ClassWrapper.prototype.typConstraints=function(){var _this=this;return this._clazz.typeParameterConstraint.map(function(x){return x?_this.mw.classForName(x):null})},ClassWrapper.prototype.methods=function(){return this._clazz.methods},ClassWrapper.prototype.name=function(){return this._clazz.name},ClassWrapper.prototype.members=function(){var _this=this;return this._clazz.fields.filter(function(x){return null==x.valueConstraint}).map(function(x){return new FieldWrapper(x,_this)})},ClassWrapper.prototype.constraints=function(){var _this=this;return this._clazz.fields.filter(function(x){return null!=x.valueConstraint}).map(function(x){return new FieldConstraint(x,_this)})},ClassWrapper.prototype.isSubTypeOf=function(of){if(this==of)return!0;var _res=!1;return this.getAllSuperTypes().forEach(function(x){_res||(_res=_res||x.isSubTypeOf(of))}),_res},ClassWrapper.prototype.getExtendsClauses=function(){return this._clazz.extends},ClassWrapper.prototype.getSuperTypes=function(){var _this=this,result=[];return this._clazz.extends.forEach(function(x){var tp=_this.mw.classForName(x.typeName);tp&&result.push(tp)}),result},ClassWrapper.prototype.getAllSuperTypes=function(){var _this=this,result=[];return this._clazz.extends.forEach(function(x){var tp=_this.mw.classForName(x.typeName);if(tp){var mm=tp.getAllSuperTypes();result.push(tp),result.concat(mm)}}),_.unique(result)},ClassWrapper.prototype.annotationOverridings=function(){return this._clazz.annotationOverridings},ClassWrapper}(),AbstractSimpleWrapper=function(){function AbstractSimpleWrapper(){}return AbstractSimpleWrapper.prototype.members=function(){return[]},AbstractSimpleWrapper.prototype.methods=function(){return[]},AbstractSimpleWrapper.prototype.isSubTypeOf=function(of){return!1},AbstractSimpleWrapper.prototype.getSuperTypes=function(){return[]},AbstractSimpleWrapper.prototype.getAllSuperTypes=function(){return[]},AbstractSimpleWrapper.prototype.name=function(){return null},AbstractSimpleWrapper.prototype.constraints=function(){return[]},AbstractSimpleWrapper.prototype.typeMeta=function(){return[]},AbstractSimpleWrapper.prototype.getModule=function(){throw new Error("Not implemented")},AbstractSimpleWrapper.prototype.annotationOverridings=function(){return{}},AbstractSimpleWrapper}(),EnumWrapper=function(_super){function EnumWrapper(_clazz,mw){_super.call(this),this._clazz=_clazz,this.mw=mw}return __extends(EnumWrapper,_super),EnumWrapper.prototype.getModule=function(){return this.mw},EnumWrapper.prototype.values=function(){return this._clazz.members},EnumWrapper.prototype.name=function(){return this._clazz.name},EnumWrapper}(AbstractSimpleWrapper),UnionWrapper=function(_super){function UnionWrapper(_clazz,mw){_super.call(this),this._clazz=_clazz,this.mw=mw}return __extends(UnionWrapper,_super),UnionWrapper.prototype.elements=function(){return this._clazz},UnionWrapper.prototype.name=function(){return this._clazz.map(function(x){return x.name()}).join("|")},UnionWrapper}(AbstractSimpleWrapper),ModuleWrapper=function(){function ModuleWrapper(_univers){var _this=this;this._univers=_univers,this.name2Class={},this.namespaceToMod={},this._classes=[],_univers.classes.forEach(function(x){var c=new ClassWrapper(x,_this);_this._classes.push(c),_this.name2Class[x.name]=c,x.moduleName&&(_this.name2Class[x.moduleName+"."+x.name]=c)}),_univers.enumDeclarations.forEach(function(x){var c=new EnumWrapper(x,_this);_this._classes.push(c),_this.name2Class[x.name]=c})}return ModuleWrapper.prototype.typeFor=function(t,ow){var _this=this;switch(t.typeKind){case tsModel.TypeKind.BASIC:var bt=t,typeName=bt.typeName;"string"==typeName&&(typeName="StringType"),"number"==typeName&&(typeName="NumberType"),"boolean"==typeName&&(typeName="BooleanType"),"any"==typeName&&(typeName="AnyType");var ti=_.indexOf(ow.typeArgs(),typeName);if(ti!=-1){var cnst=ow.typConstraints()[ti];return cnst?cnst:this.classForName("ValueType")}return this.classForName(typeName);case tsModel.TypeKind.UNION:var ut=t;return new UnionWrapper(ut.options.map(function(x){return _this.typeFor(x,ow)}),this);case tsModel.TypeKind.ARRAY:var at=t;return this.typeFor(at.base,ow)}return null},ModuleWrapper.prototype.path=function(){return this._univers.name},ModuleWrapper.prototype.classForName=function(name,stack){var _this=this;if(void 0===stack&&(stack={}),!name)return null;var result=this.name2Class[name];if(!result&&!stack[this.path()]){stack[this.path()]=this;var nmsp=name.indexOf(".");if(nmsp!=-1){var actualMod=this.namespaceToMod[name.substring(0,nmsp)];if(!actualMod)throw new Error;return actualMod.classForName(name.substring(nmsp+1),stack)}Object.keys(this.namespaceToMod).forEach(function(x){if("MetaModel"!=x){var nm=_this.namespaceToMod[x].classForName(name,stack);nm&&(result=nm)}})}return result},ModuleWrapper.prototype.classes=function(){return this._classes},ModuleWrapper}(),wrapperToType=function(range,u){if(range){var rangeType;if(range instanceof UnionWrapper){throw new Error("Union type support was removed from definition system")}return rangeType=u.type(range.name())}},registerClasses=function(m,u){var valueType=m.classForName("ValueType");m.classes().forEach(function(x){if(x instanceof EnumWrapper){var et=new def.EnumType(x.name(),u,x.getModule().path());return et.values=x.values(),void u.register(et)}if(x.isSubTypeOf(valueType)){var st=x.getAllSuperTypes();st.push(x);var refTo=null;if(st.forEach(function(t){var cs=t.getExtendsClauses();cs.forEach(function(z){if(z.typeKind==tsModel.TypeKind.BASIC){var bas=z;if("Reference"==bas.basicName){var of=bas.typeArguments[0];refTo=of.typeName;var di=refTo.indexOf(".");di!=-1&&(refTo=refTo.substring(di+1))}}})}),refTo){var ref=new def.ReferenceType(x.name(),x.getModule().path(),refTo,u);ref.setBuiltIn(!0),u.register(ref)}else{var vt=new def.ValueType(x.name(),u,x.getModule().path());vt.setBuiltIn(!0),u.register(vt)}}else{var gt=new def.NodeClass(x.name(),u,x.getModule().path());gt.setBuiltIn(!0),u.register(gt)}})},registerHierarchy=function(m,u){m.classes().forEach(function(x){x.getSuperTypes().forEach(function(y){var tp0=u.type(x.name()),tp1=u.type(y.name());if(!tp0||!tp1){var tp0=u.type(x.name()),tp1=u.type(y.name());throw new Error}u.registerSuperClass(tp0,tp1)})})},registerEverything=function(m,u){m.classes().forEach(function(x){var tp=u.type(x.name());x.typeMeta().forEach(function(a){var rangeType=wrapperToType(x,u);aHandlers.handleTypeAnnotation(a,rangeType)}),x.members().forEach(function(x){var range=x.range(),rangeType=wrapperToType(range,u);null==rangeType&&console.log(range+":"+x.name());var custom=x.annotations().map(function(y){return y.name}).indexOf("MetaModel.customHandling")>=0;createProp(x,tp,rangeType,custom)}),Object.keys(x.annotationOverridings()).forEach(function(fName){var arr=[].concat(x.annotationOverridings()[fName]),map={};arr.forEach(function(ann){return map[ann.name]=!0});for(var targetField,stArr=x.getSuperTypes(),stMap={},i=0;i<stArr.length;i++){var st=stArr[i];if(!stMap[st.name()]){stMap[st.name()]=!0,st.getSuperTypes().forEach(function(sst){return stArr.push(sst)});var arr1=st.annotationOverridings()[fName];if(arr1)arr1.filter(function(ann){return!map[ann.name]}).forEach(function(ann){map[ann.name]=!0,arr.push(ann)});else for(var stFields=st.members(),j=0;j<stFields.length;j++){var stField=stFields[j];if(stField.name()==fName){targetField=stField;break}}if(targetField){var arr2=targetField.annotations();arr2.filter(function(ann){return!map[ann.name]}).forEach(function(ann){map[ann.name]=!0,arr.push(ann)});break}}}if(targetField){var range=targetField.range(),rangeType=wrapperToType(range,u);null==rangeType&&console.log(range+":"+x.name()),createProp(targetField,tp,rangeType,!1,arr)}}),x.methods().forEach(function(x){}),x.constraints().forEach(function(x){if(x.value().isCallConstraint)throw new Error;var mm=x.value();tp.addRequirement(x.name(),""+mm.value)})}),u.types().forEach(function(x){var at=x;at.getAdapter(services.RAMLService).getAliases().forEach(function(y){return u.registerAlias(y,at)})})},processModule=function(ts,u,used,declared){if(ts.name.indexOf("metamodel.ts")==-1){if(declared[ts.name])return declared[ts.name];var m=new ModuleWrapper(ts);return used[ts.name]=m,declared[ts.name]=m,Object.keys(ts.imports).forEach(function(x){var pMod=ts.imports[x];if(used[pMod.name])return void(m.namespaceToMod[x]=used[pMod.name]);var vMod=processModule(pMod,u,used,declared);m.namespaceToMod[x]=vMod}),used[ts.name]=null,m}};exports.toDefSystem=toDefSystem;var processAnnotations=function(x,p,annotations){annotations||(annotations=x.annotations()),annotations.forEach(function(x){var nm=x.name.substring(x.name.lastIndexOf(".")+1);aHandlers.annotationHandlers[nm]||console.log("Can not find handler for:"),aHandlers.annotationHandlers[nm](x,p)})}},function(module,exports,__webpack_require__){"use strict";var Universes={Universe08:{GlobalSchema:{name:"GlobalSchema",properties:{key:{name:"key",range:"StringType",domain:"GlobalSchema"},value:{name:"value",range:"SchemaString",domain:"GlobalSchema"}}},Api:{name:"Api",properties:{title:{name:"title",range:"StringType",domain:"Api"},version:{name:"version",range:"StringType",domain:"Api"},baseUri:{name:"baseUri",range:"FullUriTemplateString",domain:"Api"},baseUriParameters:{name:"baseUriParameters",range:"Parameter",domain:"Api"},uriParameters:{name:"uriParameters",range:"Parameter",domain:"Api"},protocols:{name:"protocols",range:"StringType",domain:"Api"},mediaType:{name:"mediaType",range:"MimeType",domain:"Api"},schemas:{name:"schemas",range:"GlobalSchema",domain:"Api"},traits:{name:"traits",range:"Trait",domain:"Api"},securedBy:{name:"securedBy",range:"SecuritySchemeRef",domain:"Api"},securitySchemes:{name:"securitySchemes",range:"AbstractSecurityScheme",domain:"Api"},resourceTypes:{name:"resourceTypes",range:"ResourceType",domain:"Api"},resources:{name:"resources",range:"Resource",domain:"Api"},documentation:{name:"documentation",range:"DocumentationItem",domain:"Api"},RAMLVersion:{name:"RAMLVersion"}}},DocumentationItem:{name:"DocumentationItem",properties:{title:{name:"title",range:"StringType",domain:"DocumentationItem"},content:{name:"content",range:"MarkdownString",domain:"DocumentationItem"}}},ValueType:{name:"ValueType",properties:{}},StringType:{name:"StringType",properties:{}},AnyType:{name:"AnyType",properties:{}},NumberType:{name:"NumberType",properties:{}},BooleanType:{name:"BooleanType",properties:{}},Referencable:{name:"Referencable",properties:{}},Reference:{name:"Reference",properties:{structuredValue:{name:"structuredValue"},name:{name:"name"}}},DeclaresDynamicType:{name:"DeclaresDynamicType",properties:{}},UriTemplate:{name:"UriTemplate",properties:{}},RelativeUriString:{name:"RelativeUriString",properties:{}},FullUriTemplateString:{name:"FullUriTemplateString",properties:{}},FixedUri:{name:"FixedUri",properties:{}},MarkdownString:{name:"MarkdownString",properties:{}},SchemaString:{name:"SchemaString",properties:{}},JSonSchemaString:{name:"JSonSchemaString",properties:{}},XMLSchemaString:{name:"XMLSchemaString",properties:{}},ExampleString:{name:"ExampleString",properties:{}},StatusCodeString:{name:"StatusCodeString",properties:{}},JSONExample:{name:"JSONExample",properties:{}},XMLExample:{name:"XMLExample",properties:{}},TypeInstance:{name:"TypeInstance",properties:{properties:{name:"properties",range:"TypeInstanceProperty",domain:"TypeInstance"},isScalar:{name:"isScalar",range:"BooleanType",domain:"TypeInstance"},value:{name:"value",range:"AnyType",domain:"TypeInstance"}}},TypeInstanceProperty:{name:"TypeInstanceProperty",properties:{name:{name:"name",range:"StringType",domain:"TypeInstanceProperty"},value:{name:"value",range:"TypeInstance",domain:"TypeInstanceProperty"},values:{name:"values",range:"TypeInstance",domain:"TypeInstanceProperty"},isArray:{name:"isArray",range:"BooleanType",domain:"TypeInstanceProperty"}}},RAMLSimpleElement:{name:"RAMLSimpleElement",properties:{}},Parameter:{name:"Parameter",properties:{name:{name:"name",range:"StringType",domain:"Parameter"},displayName:{name:"displayName",range:"StringType",domain:"Parameter"},type:{name:"type",range:"StringType",domain:"Parameter"},location:{name:"location",range:"ParameterLocation",domain:"Parameter"},required:{name:"required",range:"BooleanType",domain:"Parameter"},default:{name:"default",range:"AnyType",domain:"Parameter"},example:{name:"example",range:"StringType",domain:"Parameter"},repeat:{name:"repeat",range:"BooleanType",domain:"Parameter"},description:{name:"description",range:"MarkdownString",domain:"Parameter"}}},StringTypeDeclaration:{name:"StringTypeDeclaration",properties:{name:{name:"name",range:"StringType",domain:"Parameter"},displayName:{name:"displayName",range:"StringType",domain:"Parameter"},type:{name:"type",range:"StringType",domain:"Parameter"},location:{name:"location",range:"ParameterLocation",domain:"Parameter"},required:{name:"required",range:"BooleanType",domain:"Parameter"},default:{name:"default",range:"AnyType",domain:"Parameter"},example:{name:"example",range:"StringType",domain:"Parameter"},repeat:{name:"repeat",range:"BooleanType",domain:"Parameter"},description:{name:"description",range:"MarkdownString",domain:"Parameter"},pattern:{name:"pattern",range:"StringType",domain:"StringTypeDeclaration"},enum:{name:"enum",range:"StringType",domain:"StringTypeDeclaration"},minLength:{name:"minLength",range:"NumberType",domain:"StringTypeDeclaration"},maxLength:{name:"maxLength",range:"NumberType",domain:"StringTypeDeclaration"}}},BooleanTypeDeclaration:{name:"BooleanTypeDeclaration",properties:{name:{name:"name",range:"StringType",domain:"Parameter"},displayName:{name:"displayName",range:"StringType",domain:"Parameter"},type:{name:"type",range:"StringType",domain:"Parameter"},location:{name:"location",range:"ParameterLocation",domain:"Parameter"},required:{name:"required",range:"BooleanType",domain:"Parameter"},default:{name:"default",range:"AnyType",domain:"Parameter"},example:{name:"example",range:"StringType",domain:"Parameter"},repeat:{name:"repeat",range:"BooleanType",domain:"Parameter"},description:{name:"description",range:"MarkdownString",domain:"Parameter"}}},NumberTypeDeclaration:{name:"NumberTypeDeclaration",properties:{name:{name:"name",range:"StringType",domain:"Parameter"},displayName:{name:"displayName",range:"StringType",domain:"Parameter"},type:{name:"type",range:"StringType",domain:"Parameter"},location:{name:"location",range:"ParameterLocation",domain:"Parameter"},required:{name:"required",range:"BooleanType",domain:"Parameter"},default:{name:"default",range:"AnyType",domain:"Parameter"},example:{name:"example",range:"StringType",domain:"Parameter"},repeat:{name:"repeat",range:"BooleanType",domain:"Parameter"},description:{name:"description",range:"MarkdownString",domain:"Parameter"},minimum:{name:"minimum",range:"NumberType",domain:"NumberTypeDeclaration"},maximum:{name:"maximum",range:"NumberType",domain:"NumberTypeDeclaration"}}},IntegerTypeDeclaration:{name:"IntegerTypeDeclaration",properties:{name:{name:"name",range:"StringType",domain:"Parameter"},displayName:{name:"displayName",range:"StringType",domain:"Parameter"},type:{name:"type",range:"StringType",domain:"Parameter"},location:{name:"location",range:"ParameterLocation",domain:"Parameter"},required:{name:"required",range:"BooleanType",domain:"Parameter"},default:{name:"default",range:"AnyType",domain:"Parameter"},example:{name:"example",range:"StringType",domain:"Parameter"},repeat:{name:"repeat",range:"BooleanType",domain:"Parameter"},description:{name:"description",range:"MarkdownString",domain:"Parameter"},minimum:{name:"minimum",range:"NumberType",domain:"NumberTypeDeclaration"},maximum:{name:"maximum",range:"NumberType",domain:"NumberTypeDeclaration"}}},DateTypeDeclaration:{name:"DateTypeDeclaration",properties:{name:{name:"name",range:"StringType",domain:"Parameter"},displayName:{name:"displayName",range:"StringType",domain:"Parameter"},type:{name:"type",range:"StringType",domain:"Parameter"},location:{name:"location",range:"ParameterLocation",domain:"Parameter"},required:{name:"required",range:"BooleanType",domain:"Parameter"},default:{name:"default",range:"AnyType",domain:"Parameter"},example:{name:"example",range:"StringType",domain:"Parameter"},repeat:{name:"repeat",range:"BooleanType",domain:"Parameter"},description:{name:"description",range:"MarkdownString",domain:"Parameter"}}},FileTypeDeclaration:{name:"FileTypeDeclaration",properties:{name:{name:"name",range:"StringType",domain:"Parameter"},displayName:{name:"displayName",range:"StringType",domain:"Parameter"},type:{name:"type",range:"StringType",domain:"Parameter"},location:{name:"location",range:"ParameterLocation",domain:"Parameter"},required:{name:"required",range:"BooleanType",domain:"Parameter"},default:{name:"default",range:"AnyType",domain:"Parameter"},example:{name:"example",range:"StringType",domain:"Parameter"},repeat:{name:"repeat",range:"BooleanType",domain:"Parameter"},description:{name:"description",range:"MarkdownString",domain:"Parameter"}}},ParameterLocation:{name:"ParameterLocation",properties:{}},MimeType:{name:"MimeType",properties:{}},BodyLike:{name:"BodyLike",properties:{name:{name:"name",range:"StringType",domain:"BodyLike"},schema:{name:"schema",range:"SchemaString",domain:"BodyLike"},example:{name:"example",range:"ExampleString",domain:"BodyLike"},formParameters:{name:"formParameters",range:"Parameter",domain:"BodyLike"},description:{name:"description",range:"MarkdownString",domain:"BodyLike"},schemaContent:{name:"schemaContent"}}},XMLBody:{name:"XMLBody",properties:{name:{name:"name",range:"StringType",domain:"BodyLike"},schema:{name:"schema",range:"XMLSchemaString",domain:"XMLBody"},example:{name:"example",range:"ExampleString",domain:"BodyLike"},formParameters:{name:"formParameters",range:"Parameter",domain:"BodyLike"},description:{name:"description",range:"MarkdownString",domain:"BodyLike"}}},JSONBody:{name:"JSONBody",properties:{name:{name:"name",range:"StringType",domain:"BodyLike"},schema:{name:"schema",range:"JSonSchemaString",domain:"JSONBody"},example:{name:"example",range:"ExampleString",domain:"BodyLike"},formParameters:{name:"formParameters",range:"Parameter",domain:"BodyLike"},description:{name:"description",range:"MarkdownString",domain:"BodyLike"}}},Response:{name:"Response",properties:{code:{name:"code",range:"StatusCodeString",domain:"Response"},headers:{name:"headers",range:"Parameter",domain:"Response"},body:{name:"body",range:"BodyLike",domain:"Response"},description:{name:"description",range:"MarkdownString",domain:"Response"}}},Resource:{name:"Resource",properties:{relativeUri:{name:"relativeUri",range:"RelativeUriString",domain:"Resource"},type:{name:"type",range:"ResourceTypeRef",domain:"Resource"},is:{name:"is",range:"TraitRef",domain:"Resource"},securedBy:{name:"securedBy",range:"SecuritySchemeRef",domain:"Resource"},uriParameters:{name:"uriParameters",range:"Parameter",domain:"Resource"},methods:{name:"methods",range:"Method",domain:"Resource"},resources:{name:"resources",range:"Resource",domain:"Resource"},displayName:{name:"displayName",range:"StringType",domain:"Resource"},baseUriParameters:{name:"baseUriParameters",range:"Parameter",domain:"Resource"},description:{name:"description",range:"MarkdownString",domain:"Resource"}}},ResourceTypeRef:{name:"ResourceTypeRef",properties:{resourceType:{name:"resourceType"}}},ResourceType:{name:"ResourceType",properties:{name:{name:"name",range:"StringType",domain:"ResourceType"},usage:{name:"usage",range:"StringType",domain:"ResourceType"},methods:{name:"methods",range:"Method",domain:"ResourceType"},is:{name:"is",range:"TraitRef",domain:"ResourceType"},type:{name:"type",range:"ResourceTypeRef",domain:"ResourceType"},securedBy:{name:"securedBy",range:"SecuritySchemeRef",domain:"ResourceType"},uriParameters:{name:"uriParameters",range:"Parameter",domain:"ResourceType"},displayName:{name:"displayName",range:"StringType",domain:"ResourceType"},baseUriParameters:{name:"baseUriParameters",range:"Parameter",domain:"ResourceType"},description:{name:"description",range:"MarkdownString",domain:"ResourceType"},parametrizedProperties:{name:"parametrizedProperties"}}},MethodBase:{name:"MethodBase",properties:{responses:{name:"responses",range:"Response",domain:"MethodBase"},body:{name:"body",range:"BodyLike",domain:"MethodBase"},protocols:{name:"protocols",range:"StringType",domain:"MethodBase"},securedBy:{name:"securedBy",range:"SecuritySchemeRef",domain:"MethodBase"},baseUriParameters:{name:"baseUriParameters",range:"Parameter",domain:"MethodBase"},queryParameters:{name:"queryParameters",range:"Parameter",domain:"MethodBase"},headers:{name:"headers",range:"Parameter",domain:"MethodBase"},description:{name:"description",range:"MarkdownString",domain:"MethodBase"}}},Method:{name:"Method",properties:{responses:{name:"responses",range:"Response",domain:"MethodBase"},body:{name:"body",range:"BodyLike",domain:"MethodBase"},protocols:{name:"protocols",range:"StringType",domain:"MethodBase"},securedBy:{name:"securedBy",range:"SecuritySchemeRef",domain:"MethodBase"},baseUriParameters:{name:"baseUriParameters",range:"Parameter",domain:"MethodBase"},queryParameters:{name:"queryParameters",range:"Parameter",domain:"MethodBase"},headers:{name:"headers",range:"Parameter",domain:"MethodBase"},description:{name:"description",range:"MarkdownString",domain:"MethodBase"},method:{name:"method",range:"StringType",domain:"Method"},is:{name:"is",range:"TraitRef",domain:"Method"}}},Trait:{name:"Trait",properties:{responses:{name:"responses",range:"Response",domain:"MethodBase"},body:{name:"body",range:"BodyLike",domain:"MethodBase"},protocols:{name:"protocols",range:"StringType",domain:"MethodBase"},securedBy:{name:"securedBy",range:"SecuritySchemeRef",domain:"MethodBase"},baseUriParameters:{name:"baseUriParameters",range:"Parameter",domain:"MethodBase"},queryParameters:{name:"queryParameters",range:"Parameter",domain:"MethodBase"},headers:{name:"headers",range:"Parameter",domain:"MethodBase"},description:{name:"description",range:"MarkdownString",domain:"MethodBase"},name:{name:"name",range:"StringType",domain:"Trait"},usage:{name:"usage",range:"StringType",domain:"Trait"},displayName:{name:"displayName",range:"StringType",domain:"Trait"},parametrizedProperties:{name:"parametrizedProperties"}}},TraitRef:{name:"TraitRef",properties:{trait:{name:"trait"}}},SecuritySchemePart:{name:"SecuritySchemePart",properties:{responses:{name:"responses",range:"Response",domain:"SecuritySchemePart"},body:{name:"body",range:"BodyLike",domain:"MethodBase"},protocols:{name:"protocols",range:"StringType",domain:"MethodBase"},securedBy:{name:"securedBy",range:"SecuritySchemeRef",domain:"MethodBase"},baseUriParameters:{name:"baseUriParameters",range:"Parameter",domain:"MethodBase"},queryParameters:{name:"queryParameters",range:"Parameter",domain:"SecuritySchemePart"},headers:{name:"headers",range:"Parameter",domain:"SecuritySchemePart"},description:{name:"description",range:"MarkdownString",domain:"SecuritySchemePart"},displayName:{name:"displayName",range:"StringType",domain:"SecuritySchemePart"},is:{name:"is",range:"TraitRef",domain:"SecuritySchemePart"}}},SecuritySchemeSettings:{name:"SecuritySchemeSettings",properties:{}},AbstractSecurityScheme:{name:"AbstractSecurityScheme",properties:{name:{name:"name",range:"StringType",domain:"AbstractSecurityScheme"},type:{name:"type",range:"StringType",domain:"AbstractSecurityScheme"},description:{name:"description",range:"MarkdownString",domain:"AbstractSecurityScheme"},describedBy:{name:"describedBy",range:"SecuritySchemePart",domain:"AbstractSecurityScheme"},settings:{name:"settings",range:"SecuritySchemeSettings",domain:"AbstractSecurityScheme"}}},SecuritySchemeRef:{name:"SecuritySchemeRef",properties:{securitySchemeName:{name:"securitySchemeName"},securityScheme:{name:"securityScheme"}}},OAuth1SecuritySchemeSettings:{name:"OAuth1SecuritySchemeSettings",properties:{requestTokenUri:{name:"requestTokenUri",range:"FixedUri",domain:"OAuth1SecuritySchemeSettings"},authorizationUri:{name:"authorizationUri",range:"FixedUri",domain:"OAuth1SecuritySchemeSettings"},tokenCredentialsUri:{name:"tokenCredentialsUri",range:"FixedUri",domain:"OAuth1SecuritySchemeSettings"}}},OAuth2SecuritySchemeSettings:{name:"OAuth2SecuritySchemeSettings",properties:{accessTokenUri:{name:"accessTokenUri",range:"FixedUri",domain:"OAuth2SecuritySchemeSettings"},authorizationUri:{name:"authorizationUri",range:"FixedUri",domain:"OAuth2SecuritySchemeSettings"},authorizationGrants:{name:"authorizationGrants",range:"StringType",domain:"OAuth2SecuritySchemeSettings"},scopes:{name:"scopes",range:"StringType",domain:"OAuth2SecuritySchemeSettings"}}},OAuth2SecurityScheme:{name:"OAuth2SecurityScheme",properties:{name:{name:"name",range:"StringType",domain:"AbstractSecurityScheme"},type:{name:"type",range:"StringType",domain:"AbstractSecurityScheme"},description:{name:"description",range:"MarkdownString",domain:"AbstractSecurityScheme"},describedBy:{name:"describedBy",range:"SecuritySchemePart",domain:"AbstractSecurityScheme"},settings:{name:"settings",range:"OAuth2SecuritySchemeSettings",domain:"OAuth2SecurityScheme"}}},OAuth1SecurityScheme:{name:"OAuth1SecurityScheme",properties:{name:{name:"name",range:"StringType",domain:"AbstractSecurityScheme"},type:{name:"type",range:"StringType",domain:"AbstractSecurityScheme"},description:{name:"description",range:"MarkdownString",domain:"AbstractSecurityScheme"},describedBy:{name:"describedBy",range:"SecuritySchemePart",domain:"AbstractSecurityScheme"},settings:{name:"settings",range:"OAuth1SecuritySchemeSettings",domain:"OAuth1SecurityScheme"}}},BasicSecurityScheme:{name:"BasicSecurityScheme",properties:{name:{name:"name",range:"StringType",domain:"AbstractSecurityScheme"},type:{name:"type",range:"StringType",domain:"AbstractSecurityScheme"},description:{name:"description",range:"MarkdownString",domain:"AbstractSecurityScheme"},describedBy:{name:"describedBy",range:"SecuritySchemePart",domain:"AbstractSecurityScheme"},settings:{name:"settings",range:"SecuritySchemeSettings",domain:"AbstractSecurityScheme"}}},DigestSecurityScheme:{name:"DigestSecurityScheme",properties:{name:{name:"name",range:"StringType",domain:"AbstractSecurityScheme"},type:{name:"type",range:"StringType",domain:"AbstractSecurityScheme"},description:{name:"description",range:"MarkdownString",domain:"AbstractSecurityScheme"
},describedBy:{name:"describedBy",range:"SecuritySchemePart",domain:"AbstractSecurityScheme"},settings:{name:"settings",range:"SecuritySchemeSettings",domain:"AbstractSecurityScheme"}}},CustomSecurityScheme:{name:"CustomSecurityScheme",properties:{name:{name:"name",range:"StringType",domain:"AbstractSecurityScheme"},type:{name:"type",range:"StringType",domain:"AbstractSecurityScheme"},description:{name:"description",range:"MarkdownString",domain:"AbstractSecurityScheme"},describedBy:{name:"describedBy",range:"SecuritySchemePart",domain:"AbstractSecurityScheme"},settings:{name:"settings",range:"SecuritySchemeSettings",domain:"AbstractSecurityScheme"}}}},Universe10:{Library:{name:"Library",properties:{annotations:{name:"annotations"},uses:{name:"uses"},schemas:{name:"schemas"},types:{name:"types"},traits:{name:"traits"},resourceTypes:{name:"resourceTypes"},annotationTypes:{name:"annotationTypes"},securitySchemes:{name:"securitySchemes"},usage:{name:"usage"},name:{name:"name"}}},LibraryBase:{name:"LibraryBase",properties:{annotations:{name:"annotations"},uses:{name:"uses"},schemas:{name:"schemas"},types:{name:"types"},traits:{name:"traits"},resourceTypes:{name:"resourceTypes"},annotationTypes:{name:"annotationTypes"},securitySchemes:{name:"securitySchemes"}}},Api:{name:"Api",properties:{annotations:{name:"annotations"},uses:{name:"uses"},schemas:{name:"schemas"},types:{name:"types"},traits:{name:"traits"},resourceTypes:{name:"resourceTypes"},annotationTypes:{name:"annotationTypes"},securitySchemes:{name:"securitySchemes"},title:{name:"title"},description:{name:"description"},version:{name:"version"},baseUri:{name:"baseUri"},baseUriParameters:{name:"baseUriParameters"},protocols:{name:"protocols"},mediaType:{name:"mediaType"},securedBy:{name:"securedBy"},resources:{name:"resources"},documentation:{name:"documentation"},RAMLVersion:{name:"RAMLVersion",range:"StringType",domain:"Api"}}},Overlay:{name:"Overlay",properties:{annotations:{name:"annotations"},uses:{name:"uses"},schemas:{name:"schemas"},types:{name:"types"},traits:{name:"traits"},resourceTypes:{name:"resourceTypes"},annotationTypes:{name:"annotationTypes"},securitySchemes:{name:"securitySchemes"},title:{name:"title"},description:{name:"description"},version:{name:"version"},baseUri:{name:"baseUri"},baseUriParameters:{name:"baseUriParameters"},protocols:{name:"protocols"},mediaType:{name:"mediaType"},securedBy:{name:"securedBy"},resources:{name:"resources"},documentation:{name:"documentation"},usage:{name:"usage"},extends:{name:"extends"}}},Extension:{name:"Extension",properties:{annotations:{name:"annotations"},uses:{name:"uses"},schemas:{name:"schemas"},types:{name:"types"},traits:{name:"traits"},resourceTypes:{name:"resourceTypes"},annotationTypes:{name:"annotationTypes"},securitySchemes:{name:"securitySchemes"},title:{name:"title"},description:{name:"description"},version:{name:"version"},baseUri:{name:"baseUri"},baseUriParameters:{name:"baseUriParameters"},protocols:{name:"protocols"},mediaType:{name:"mediaType"},securedBy:{name:"securedBy"},resources:{name:"resources"},documentation:{name:"documentation"},usage:{name:"usage"},extends:{name:"extends"}}},UsesDeclaration:{name:"UsesDeclaration",properties:{annotations:{name:"annotations"},key:{name:"key"},value:{name:"value"}}},FragmentDeclaration:{name:"FragmentDeclaration",properties:{annotations:{name:"annotations"},uses:{name:"uses"}}},DocumentationItem:{name:"DocumentationItem",properties:{annotations:{name:"annotations"},title:{name:"title"},content:{name:"content"}}},ValueType:{name:"ValueType",properties:{annotations:{name:"annotations"}}},StringType:{name:"StringType",properties:{annotations:{name:"annotations"}}},AnyType:{name:"AnyType",properties:{annotations:{name:"annotations"}}},NumberType:{name:"NumberType",properties:{annotations:{name:"annotations"}}},IntegerType:{name:"IntegerType",properties:{annotations:{name:"annotations"}}},NullType:{name:"NullType",properties:{annotations:{name:"annotations"}}},TimeOnlyType:{name:"TimeOnlyType",properties:{annotations:{name:"annotations"}}},DateOnlyType:{name:"DateOnlyType",properties:{annotations:{name:"annotations"}}},DateTimeOnlyType:{name:"DateTimeOnlyType",properties:{annotations:{name:"annotations"}}},DateTimeType:{name:"DateTimeType",properties:{annotations:{name:"annotations"}}},FileType:{name:"FileType",properties:{annotations:{name:"annotations"}}},BooleanType:{name:"BooleanType",properties:{annotations:{name:"annotations"}}},Reference:{name:"Reference",properties:{annotations:{name:"annotations"},structuredValue:{name:"structuredValue",range:"TypeInstance",domain:"Reference"},name:{name:"name",range:"StringType",domain:"Reference"}}},UriTemplate:{name:"UriTemplate",properties:{annotations:{name:"annotations"}}},StatusCodeString:{name:"StatusCodeString",properties:{annotations:{name:"annotations"}}},RelativeUriString:{name:"RelativeUriString",properties:{annotations:{name:"annotations"}}},FullUriTemplateString:{name:"FullUriTemplateString",properties:{annotations:{name:"annotations"}}},FixedUriString:{name:"FixedUriString",properties:{annotations:{name:"annotations"}}},ContentType:{name:"ContentType",properties:{annotations:{name:"annotations"}}},MarkdownString:{name:"MarkdownString",properties:{annotations:{name:"annotations"}}},SchemaString:{name:"SchemaString",properties:{annotations:{name:"annotations"}}},ExampleSpec:{name:"ExampleSpec",properties:{annotations:{name:"annotations"},value:{name:"value"},strict:{name:"strict"},name:{name:"name"},displayName:{name:"displayName"},description:{name:"description"},structuredValue:{name:"structuredValue",range:"TypeInstance",domain:"ExampleSpec"}}},TypeDeclaration:{name:"TypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},default:{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"},fixedFacets:{name:"fixedFacets",range:"TypeInstance",domain:"TypeDeclaration"},structuredType:{name:"structuredType",range:"TypeInstance",domain:"TypeDeclaration"},parametrizedProperties:{name:"parametrizedProperties",range:"TypeInstance",domain:"TypeDeclaration"}}},XMLFacetInfo:{name:"XMLFacetInfo",properties:{annotations:{name:"annotations"},attribute:{name:"attribute"},wrapped:{name:"wrapped"},name:{name:"name"},namespace:{name:"namespace"},prefix:{name:"prefix"}}},ArrayTypeDeclaration:{name:"ArrayTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},default:{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"},uniqueItems:{name:"uniqueItems"},items:{name:"items"},minItems:{name:"minItems"},maxItems:{name:"maxItems"}}},UnionTypeDeclaration:{name:"UnionTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},default:{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"}}},ObjectTypeDeclaration:{name:"ObjectTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},default:{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"},properties:{name:"properties"},minProperties:{name:"minProperties"},maxProperties:{name:"maxProperties"},additionalProperties:{name:"additionalProperties"},discriminator:{name:"discriminator"},discriminatorValue:{name:"discriminatorValue"}}},StringTypeDeclaration:{name:"StringTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},default:{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"},pattern:{name:"pattern"},minLength:{name:"minLength"},maxLength:{name:"maxLength"},enum:{name:"enum"}}},BooleanTypeDeclaration:{name:"BooleanTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},default:{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"}}},NumberTypeDeclaration:{name:"NumberTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},default:{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"},minimum:{name:"minimum"},maximum:{name:"maximum"},enum:{name:"enum"},format:{name:"format"},multipleOf:{name:"multipleOf"}}},IntegerTypeDeclaration:{name:"IntegerTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},default:{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"},minimum:{name:"minimum"},maximum:{name:"maximum"},enum:{name:"enum"},format:{name:"format"},multipleOf:{name:"multipleOf"}}},DateOnlyTypeDeclaration:{name:"DateOnlyTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},default:{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"}}},TimeOnlyTypeDeclaration:{name:"TimeOnlyTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},default:{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"}}},DateTimeOnlyTypeDeclaration:{name:"DateTimeOnlyTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},default:{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"}}},DateTimeTypeDeclaration:{name:"DateTimeTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},default:{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"},format:{name:"format"}}},DateTypeDeclaration:{name:"DateTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},default:{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"}}},TypeInstance:{name:"TypeInstance",properties:{properties:{name:"properties"},isScalar:{name:"isScalar"},value:{name:"value"},isArray:{name:"isArray"},items:{name:"items"}}},TypeInstanceProperty:{name:"TypeInstanceProperty",properties:{name:{name:"name"},value:{name:"value"},values:{name:"values"},isArray:{name:"isArray"}}},ModelLocation:{name:"ModelLocation",properties:{}},LocationKind:{name:"LocationKind",properties:{}},MimeType:{name:"MimeType",properties:{annotations:{name:"annotations"}}},Response:{name:"Response",properties:{annotations:{name:"annotations"},code:{name:"code"},headers:{name:"headers"},body:{name:"body"},description:{name:"description"}}},Annotable:{name:"Annotable",properties:{annotations:{name:"annotations"}}},AnnotationRef:{name:"AnnotationRef",properties:{annotations:{name:"annotations"},annotation:{name:"annotation",range:"TypeDeclaration",domain:"AnnotationRef"}}},AnnotationTarget:{name:"AnnotationTarget",properties:{annotations:{name:"annotations"}}},TraitRef:{name:"TraitRef",properties:{annotations:{name:"annotations"},trait:{name:"trait",range:"Trait",domain:"TraitRef"}}},Trait:{name:"Trait",properties:{annotations:{name:"annotations"},queryParameters:{name:"queryParameters"},headers:{name:"headers"},queryString:{name:"queryString"},responses:{name:"responses"},body:{name:"body"},protocols:{name:"protocols"},is:{name:"is"},securedBy:{name:"securedBy"},description:{name:"description"},displayName:{name:"displayName"},name:{name:"name"},usage:{name:"usage"},parametrizedProperties:{name:"parametrizedProperties",range:"TypeInstance",domain:"Trait"}}},MethodBase:{name:"MethodBase",properties:{annotations:{name:"annotations"},queryParameters:{name:"queryParameters"},headers:{name:"headers"},queryString:{name:"queryString"},responses:{name:"responses"},body:{name:"body"},protocols:{name:"protocols"},is:{name:"is"},securedBy:{name:"securedBy"},description:{name:"description"},displayName:{name:"displayName"}}},Method:{name:"Method",properties:{annotations:{name:"annotations"},queryParameters:{name:"queryParameters"},headers:{name:"headers"},queryString:{name:"queryString"},responses:{name:"responses"},body:{name:"body"},protocols:{name:"protocols"},is:{name:"is"},securedBy:{name:"securedBy"},description:{name:"description"},displayName:{name:"displayName"},method:{name:"method"},parametrizedProperties:{name:"parametrizedProperties",range:"TypeInstance",domain:"Method"}}},Operation:{name:"Operation",properties:{annotations:{name:"annotations"},queryParameters:{name:"queryParameters"},headers:{name:"headers"},queryString:{name:"queryString"},responses:{name:"responses"}}},SecuritySchemePart:{name:"SecuritySchemePart",properties:{annotations:{name:"annotations"},queryParameters:{name:"queryParameters"},headers:{name:"headers"},queryString:{name:"queryString"},responses:{name:"responses"}}},SecuritySchemeSettings:{name:"SecuritySchemeSettings",properties:{annotations:{name:"annotations"}}},OAuth1SecuritySchemeSettings:{name:"OAuth1SecuritySchemeSettings",properties:{annotations:{name:"annotations"},requestTokenUri:{name:"requestTokenUri"},authorizationUri:{name:"authorizationUri"},tokenCredentialsUri:{name:"tokenCredentialsUri"},signatures:{name:"signatures"}}},OAuth2SecuritySchemeSettings:{name:"OAuth2SecuritySchemeSettings",properties:{annotations:{name:"annotations"},accessTokenUri:{name:"accessTokenUri"},authorizationUri:{name:"authorizationUri"},authorizationGrants:{name:"authorizationGrants"},scopes:{name:"scopes"}}},SecuritySchemeRef:{name:"SecuritySchemeRef",properties:{annotations:{name:"annotations"},securitySchemeName:{name:"securitySchemeName",range:"StringType",domain:"SecuritySchemeRef"},securityScheme:{name:"securityScheme",range:"AbstractSecurityScheme",domain:"SecuritySchemeRef"}}},AbstractSecurityScheme:{name:"AbstractSecurityScheme",properties:{annotations:{name:"annotations"},name:{name:"name"},type:{name:"type"},description:{name:"description"},describedBy:{name:"describedBy"},displayName:{name:"displayName"},settings:{name:"settings"}}},OAuth2SecurityScheme:{name:"OAuth2SecurityScheme",properties:{annotations:{name:"annotations"},name:{name:"name"},type:{name:"type"},description:{name:"description"},describedBy:{name:"describedBy"},displayName:{name:"displayName"},settings:{name:"settings"}}},OAuth1SecurityScheme:{name:"OAuth1SecurityScheme",properties:{annotations:{name:"annotations"},name:{name:"name"},type:{name:"type"},description:{name:"description"},describedBy:{name:"describedBy"},displayName:{name:"displayName"},settings:{name:"settings"}}},PassThroughSecurityScheme:{name:"PassThroughSecurityScheme",properties:{annotations:{name:"annotations"},name:{name:"name"},type:{name:"type"},description:{name:"description"},describedBy:{name:"describedBy"},displayName:{name:"displayName"},settings:{name:"settings"}}},BasicSecurityScheme:{name:"BasicSecurityScheme",properties:{annotations:{name:"annotations"},name:{name:"name"},type:{name:"type"},description:{name:"description"},describedBy:{name:"describedBy"},displayName:{name:"displayName"},settings:{name:"settings"}}},DigestSecurityScheme:{name:"DigestSecurityScheme",properties:{annotations:{name:"annotations"},name:{name:"name"},type:{name:"type"},description:{name:"description"},describedBy:{name:"describedBy"},displayName:{name:"displayName"},settings:{name:"settings"}}},CustomSecurityScheme:{name:"CustomSecurityScheme",properties:{annotations:{name:"annotations"},name:{name:"name"},type:{name:"type"},description:{name:"description"},describedBy:{name:"describedBy"},displayName:{name:"displayName"},settings:{name:"settings"}}},ResourceTypeRef:{name:"ResourceTypeRef",properties:{annotations:{name:"annotations"},resourceType:{name:"resourceType",range:"ResourceType",domain:"ResourceTypeRef"}}},ResourceType:{name:"ResourceType",properties:{annotations:{name:"annotations"},methods:{name:"methods"},is:{name:"is"},type:{name:"type"},description:{name:"description"},securedBy:{name:"securedBy"},uriParameters:{name:"uriParameters"},displayName:{name:"displayName"},name:{name:"name"},usage:{name:"usage"},parametrizedProperties:{name:"parametrizedProperties",range:"TypeInstance",domain:"ResourceType"}}},ResourceBase:{name:"ResourceBase",properties:{annotations:{name:"annotations"},methods:{name:"methods"},is:{name:"is"},type:{name:"type"},description:{name:"description"},securedBy:{name:"securedBy"},uriParameters:{name:"uriParameters"}}},Resource:{name:"Resource",properties:{annotations:{name:"annotations"},methods:{name:"methods"},is:{name:"is"},type:{name:"type"},description:{name:"description"},securedBy:{name:"securedBy"},uriParameters:{name:"uriParameters"},relativeUri:{name:"relativeUri"},displayName:{name:"displayName"},resources:{name:"resources"}}},FileTypeDeclaration:{name:"FileTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},default:{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"},fileTypes:{name:"fileTypes"},minLength:{name:"minLength"},maxLength:{name:"maxLength"}}}}};module.exports=Universes},function(module,exports,__webpack_require__){function drainQueue(){if(!draining){draining=!0;for(var currentQueue,len=queue.length;len;){currentQueue=queue,queue=[];for(var i=-1;++i<len;)currentQueue[i]();len=queue.length}draining=!1}}function noop(){}var process=module.exports={},queue=[],draining=!1;process.nextTick=function(fun){queue.push(fun),draining||setTimeout(drainQueue,0)},process.title="browser",process.browser=!0,process.env={},process.argv=[],process.version="",process.versions={},process.on=noop,process.addListener=noop,process.once=noop,process.off=noop,process.removeListener=noop,process.removeAllListeners=noop,process.emit=noop,process.binding=function(name){throw new Error("process.binding is not supported")},process.cwd=function(){return"/"},process.chdir=function(dir){throw new Error("process.chdir is not supported")},process.umask=function(){return 0}},function(module,exports,__webpack_require__){exports.XMLHttpRequest=XMLHttpRequest},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__;(function(){function createReduce(dir){function iterator(obj,iteratee,memo,keys,index,length){for(;index>=0&&index<length;index+=dir){var currentKey=keys?keys[index]:index;memo=iteratee(memo,obj[currentKey],currentKey,obj)}return memo}return function(obj,iteratee,memo,context){iteratee=optimizeCb(iteratee,context,4);var keys=!isArrayLike(obj)&&_.keys(obj),length=(keys||obj).length,index=dir>0?0:length-1;return arguments.length<3&&(memo=obj[keys?keys[index]:index],index+=dir),iterator(obj,iteratee,memo,keys,index,length)}}function createPredicateIndexFinder(dir){return function(array,predicate,context){predicate=cb(predicate,context);for(var length=getLength(array),index=dir>0?0:length-1;index>=0&&index<length;index+=dir)if(predicate(array[index],index,array))return index;return-1}}function createIndexFinder(dir,predicateFind,sortedIndex){return function(array,item,idx){var i=0,length=getLength(array);if("number"==typeof idx)dir>0?i=idx>=0?idx:Math.max(idx+length,i):length=idx>=0?Math.min(idx+1,length):idx+length+1;else if(sortedIndex&&idx&&length)return idx=sortedIndex(array,item),array[idx]===item?idx:-1;if(item!==item)return idx=predicateFind(slice.call(array,i,length),_.isNaN),idx>=0?idx+i:-1;for(idx=dir>0?i:length-1;idx>=0&&idx<length;idx+=dir)if(array[idx]===item)return idx;return-1}}function collectNonEnumProps(obj,keys){var nonEnumIdx=nonEnumerableProps.length,constructor=obj.constructor,proto=_.isFunction(constructor)&&constructor.prototype||ObjProto,prop="constructor";for(_.has(obj,prop)&&!_.contains(keys,prop)&&keys.push(prop);nonEnumIdx--;)prop=nonEnumerableProps[nonEnumIdx],prop in obj&&obj[prop]!==proto[prop]&&!_.contains(keys,prop)&&keys.push(prop)}var root=this,previousUnderscore=root._,ArrayProto=Array.prototype,ObjProto=Object.prototype,FuncProto=Function.prototype,push=ArrayProto.push,slice=ArrayProto.slice,toString=ObjProto.toString,hasOwnProperty=ObjProto.hasOwnProperty,nativeIsArray=Array.isArray,nativeKeys=Object.keys,nativeBind=FuncProto.bind,nativeCreate=Object.create,Ctor=function(){},_=function(obj){return obj instanceof _?obj:this instanceof _?void(this._wrapped=obj):new _(obj)};"undefined"!=typeof module&&module.exports&&(exports=module.exports=_),exports._=_,_.VERSION="1.8.3";var optimizeCb=function(func,context,argCount){if(void 0===context)return func;switch(null==argCount?3:argCount){case 1:return function(value){return func.call(context,value)};case 2:return function(value,other){return func.call(context,value,other)};case 3:return function(value,index,collection){return func.call(context,value,index,collection)};case 4:return function(accumulator,value,index,collection){return func.call(context,accumulator,value,index,collection)}}return function(){return func.apply(context,arguments)}},cb=function(value,context,argCount){return null==value?_.identity:_.isFunction(value)?optimizeCb(value,context,argCount):_.isObject(value)?_.matcher(value):_.property(value)};_.iteratee=function(value,context){return cb(value,context,1/0)};var createAssigner=function(keysFunc,undefinedOnly){return function(obj){var length=arguments.length;if(length<2||null==obj)return obj;for(var index=1;index<length;index++)for(var source=arguments[index],keys=keysFunc(source),l=keys.length,i=0;i<l;i++){var key=keys[i];undefinedOnly&&void 0!==obj[key]||(obj[key]=source[key])}return obj}},baseCreate=function(prototype){if(!_.isObject(prototype))return{};if(nativeCreate)return nativeCreate(prototype);Ctor.prototype=prototype;var result=new Ctor;return Ctor.prototype=null,result},property=function(key){return function(obj){return null==obj?void 0:obj[key]}},MAX_ARRAY_INDEX=Math.pow(2,53)-1,getLength=property("length"),isArrayLike=function(collection){var length=getLength(collection);return"number"==typeof length&&length>=0&&length<=MAX_ARRAY_INDEX};_.each=_.forEach=function(obj,iteratee,context){iteratee=optimizeCb(iteratee,context);var i,length;if(isArrayLike(obj))for(i=0,length=obj.length;i<length;i++)iteratee(obj[i],i,obj);else{var keys=_.keys(obj);for(i=0,length=keys.length;i<length;i++)iteratee(obj[keys[i]],keys[i],obj)}return obj},_.map=_.collect=function(obj,iteratee,context){iteratee=cb(iteratee,context);for(var keys=!isArrayLike(obj)&&_.keys(obj),length=(keys||obj).length,results=Array(length),index=0;index<length;index++){var currentKey=keys?keys[index]:index;results[index]=iteratee(obj[currentKey],currentKey,obj)}return results},_.reduce=_.foldl=_.inject=createReduce(1),_.reduceRight=_.foldr=createReduce(-1),_.find=_.detect=function(obj,predicate,context){var key;if(key=isArrayLike(obj)?_.findIndex(obj,predicate,context):_.findKey(obj,predicate,context),void 0!==key&&key!==-1)return obj[key]},_.filter=_.select=function(obj,predicate,context){var results=[];return predicate=cb(predicate,context),_.each(obj,function(value,index,list){predicate(value,index,list)&&results.push(value)}),results},_.reject=function(obj,predicate,context){return _.filter(obj,_.negate(cb(predicate)),context)},_.every=_.all=function(obj,predicate,context){predicate=cb(predicate,context);for(var keys=!isArrayLike(obj)&&_.keys(obj),length=(keys||obj).length,index=0;index<length;index++){var currentKey=keys?keys[index]:index;if(!predicate(obj[currentKey],currentKey,obj))return!1}return!0},_.some=_.any=function(obj,predicate,context){predicate=cb(predicate,context);for(var keys=!isArrayLike(obj)&&_.keys(obj),length=(keys||obj).length,index=0;index<length;index++){var currentKey=keys?keys[index]:index;if(predicate(obj[currentKey],currentKey,obj))return!0}return!1},_.contains=_.includes=_.include=function(obj,item,fromIndex,guard){return isArrayLike(obj)||(obj=_.values(obj)),("number"!=typeof fromIndex||guard)&&(fromIndex=0),_.indexOf(obj,item,fromIndex)>=0},_.invoke=function(obj,method){var args=slice.call(arguments,2),isFunc=_.isFunction(method);return _.map(obj,function(value){var func=isFunc?method:value[method];return null==func?func:func.apply(value,args)})},_.pluck=function(obj,key){return _.map(obj,_.property(key))},_.where=function(obj,attrs){return _.filter(obj,_.matcher(attrs))},_.findWhere=function(obj,attrs){return _.find(obj,_.matcher(attrs))},_.max=function(obj,iteratee,context){var value,computed,result=-(1/0),lastComputed=-(1/0);if(null==iteratee&&null!=obj){obj=isArrayLike(obj)?obj:_.values(obj);for(var i=0,length=obj.length;i<length;i++)value=obj[i],value>result&&(result=value)}else iteratee=cb(iteratee,context),_.each(obj,function(value,index,list){computed=iteratee(value,index,list),(computed>lastComputed||computed===-(1/0)&&result===-(1/0))&&(result=value,lastComputed=computed)});return result},_.min=function(obj,iteratee,context){var value,computed,result=1/0,lastComputed=1/0;if(null==iteratee&&null!=obj){obj=isArrayLike(obj)?obj:_.values(obj);for(var i=0,length=obj.length;i<length;i++)value=obj[i],value<result&&(result=value)}else iteratee=cb(iteratee,context),_.each(obj,function(value,index,list){computed=iteratee(value,index,list),(computed<lastComputed||computed===1/0&&result===1/0)&&(result=value,lastComputed=computed)});return result},_.shuffle=function(obj){for(var rand,set=isArrayLike(obj)?obj:_.values(obj),length=set.length,shuffled=Array(length),index=0;index<length;index++)rand=_.random(0,index),rand!==index&&(shuffled[index]=shuffled[rand]),shuffled[rand]=set[index];return shuffled},_.sample=function(obj,n,guard){return null==n||guard?(isArrayLike(obj)||(obj=_.values(obj)),obj[_.random(obj.length-1)]):_.shuffle(obj).slice(0,Math.max(0,n))},_.sortBy=function(obj,iteratee,context){return iteratee=cb(iteratee,context),_.pluck(_.map(obj,function(value,index,list){return{value:value,index:index,criteria:iteratee(value,index,list)}}).sort(function(left,right){var a=left.criteria,b=right.criteria;if(a!==b){if(a>b||void 0===a)return 1;if(a<b||void 0===b)return-1}return left.index-right.index}),"value")};var group=function(behavior){return function(obj,iteratee,context){var result={};return iteratee=cb(iteratee,context),_.each(obj,function(value,index){var key=iteratee(value,index,obj);behavior(result,value,key)}),result}};_.groupBy=group(function(result,value,key){_.has(result,key)?result[key].push(value):result[key]=[value]}),_.indexBy=group(function(result,value,key){result[key]=value}),_.countBy=group(function(result,value,key){_.has(result,key)?result[key]++:result[key]=1}),_.toArray=function(obj){return obj?_.isArray(obj)?slice.call(obj):isArrayLike(obj)?_.map(obj,_.identity):_.values(obj):[]},_.size=function(obj){return null==obj?0:isArrayLike(obj)?obj.length:_.keys(obj).length},_.partition=function(obj,predicate,context){predicate=cb(predicate,context);var pass=[],fail=[];return _.each(obj,function(value,key,obj){(predicate(value,key,obj)?pass:fail).push(value)}),[pass,fail]},_.first=_.head=_.take=function(array,n,guard){if(null!=array)return null==n||guard?array[0]:_.initial(array,array.length-n)},_.initial=function(array,n,guard){return slice.call(array,0,Math.max(0,array.length-(null==n||guard?1:n)))},_.last=function(array,n,guard){if(null!=array)return null==n||guard?array[array.length-1]:_.rest(array,Math.max(0,array.length-n))},_.rest=_.tail=_.drop=function(array,n,guard){return slice.call(array,null==n||guard?1:n)},_.compact=function(array){return _.filter(array,_.identity)};var flatten=function(input,shallow,strict,startIndex){for(var output=[],idx=0,i=startIndex||0,length=getLength(input);i<length;i++){var value=input[i];if(isArrayLike(value)&&(_.isArray(value)||_.isArguments(value))){shallow||(value=flatten(value,shallow,strict));var j=0,len=value.length;for(output.length+=len;j<len;)output[idx++]=value[j++]}else strict||(output[idx++]=value)}return output};_.flatten=function(array,shallow){return flatten(array,shallow,!1)},_.without=function(array){return _.difference(array,slice.call(arguments,1))},_.uniq=_.unique=function(array,isSorted,iteratee,context){_.isBoolean(isSorted)||(context=iteratee,iteratee=isSorted,isSorted=!1),null!=iteratee&&(iteratee=cb(iteratee,context));for(var result=[],seen=[],i=0,length=getLength(array);i<length;i++){var value=array[i],computed=iteratee?iteratee(value,i,array):value;
isSorted?(i&&seen===computed||result.push(value),seen=computed):iteratee?_.contains(seen,computed)||(seen.push(computed),result.push(value)):_.contains(result,value)||result.push(value)}return result},_.union=function(){return _.uniq(flatten(arguments,!0,!0))},_.intersection=function(array){for(var result=[],argsLength=arguments.length,i=0,length=getLength(array);i<length;i++){var item=array[i];if(!_.contains(result,item)){for(var j=1;j<argsLength&&_.contains(arguments[j],item);j++);j===argsLength&&result.push(item)}}return result},_.difference=function(array){var rest=flatten(arguments,!0,!0,1);return _.filter(array,function(value){return!_.contains(rest,value)})},_.zip=function(){return _.unzip(arguments)},_.unzip=function(array){for(var length=array&&_.max(array,getLength).length||0,result=Array(length),index=0;index<length;index++)result[index]=_.pluck(array,index);return result},_.object=function(list,values){for(var result={},i=0,length=getLength(list);i<length;i++)values?result[list[i]]=values[i]:result[list[i][0]]=list[i][1];return result},_.findIndex=createPredicateIndexFinder(1),_.findLastIndex=createPredicateIndexFinder(-1),_.sortedIndex=function(array,obj,iteratee,context){iteratee=cb(iteratee,context,1);for(var value=iteratee(obj),low=0,high=getLength(array);low<high;){var mid=Math.floor((low+high)/2);iteratee(array[mid])<value?low=mid+1:high=mid}return low},_.indexOf=createIndexFinder(1,_.findIndex,_.sortedIndex),_.lastIndexOf=createIndexFinder(-1,_.findLastIndex),_.range=function(start,stop,step){null==stop&&(stop=start||0,start=0),step=step||1;for(var length=Math.max(Math.ceil((stop-start)/step),0),range=Array(length),idx=0;idx<length;idx++,start+=step)range[idx]=start;return range};var executeBound=function(sourceFunc,boundFunc,context,callingContext,args){if(!(callingContext instanceof boundFunc))return sourceFunc.apply(context,args);var self=baseCreate(sourceFunc.prototype),result=sourceFunc.apply(self,args);return _.isObject(result)?result:self};_.bind=function(func,context){if(nativeBind&&func.bind===nativeBind)return nativeBind.apply(func,slice.call(arguments,1));if(!_.isFunction(func))throw new TypeError("Bind must be called on a function");var args=slice.call(arguments,2),bound=function(){return executeBound(func,bound,context,this,args.concat(slice.call(arguments)))};return bound},_.partial=function(func){var boundArgs=slice.call(arguments,1),bound=function(){for(var position=0,length=boundArgs.length,args=Array(length),i=0;i<length;i++)args[i]=boundArgs[i]===_?arguments[position++]:boundArgs[i];for(;position<arguments.length;)args.push(arguments[position++]);return executeBound(func,bound,this,this,args)};return bound},_.bindAll=function(obj){var i,key,length=arguments.length;if(length<=1)throw new Error("bindAll must be passed function names");for(i=1;i<length;i++)key=arguments[i],obj[key]=_.bind(obj[key],obj);return obj},_.memoize=function(func,hasher){var memoize=function(key){var cache=memoize.cache,address=""+(hasher?hasher.apply(this,arguments):key);return _.has(cache,address)||(cache[address]=func.apply(this,arguments)),cache[address]};return memoize.cache={},memoize},_.delay=function(func,wait){var args=slice.call(arguments,2);return setTimeout(function(){return func.apply(null,args)},wait)},_.defer=_.partial(_.delay,_,1),_.throttle=function(func,wait,options){var context,args,result,timeout=null,previous=0;options||(options={});var later=function(){previous=options.leading===!1?0:_.now(),timeout=null,result=func.apply(context,args),timeout||(context=args=null)};return function(){var now=_.now();previous||options.leading!==!1||(previous=now);var remaining=wait-(now-previous);return context=this,args=arguments,remaining<=0||remaining>wait?(timeout&&(clearTimeout(timeout),timeout=null),previous=now,result=func.apply(context,args),timeout||(context=args=null)):timeout||options.trailing===!1||(timeout=setTimeout(later,remaining)),result}},_.debounce=function(func,wait,immediate){var timeout,args,context,timestamp,result,later=function(){var last=_.now()-timestamp;last<wait&&last>=0?timeout=setTimeout(later,wait-last):(timeout=null,immediate||(result=func.apply(context,args),timeout||(context=args=null)))};return function(){context=this,args=arguments,timestamp=_.now();var callNow=immediate&&!timeout;return timeout||(timeout=setTimeout(later,wait)),callNow&&(result=func.apply(context,args),context=args=null),result}},_.wrap=function(func,wrapper){return _.partial(wrapper,func)},_.negate=function(predicate){return function(){return!predicate.apply(this,arguments)}},_.compose=function(){var args=arguments,start=args.length-1;return function(){for(var i=start,result=args[start].apply(this,arguments);i--;)result=args[i].call(this,result);return result}},_.after=function(times,func){return function(){if(--times<1)return func.apply(this,arguments)}},_.before=function(times,func){var memo;return function(){return--times>0&&(memo=func.apply(this,arguments)),times<=1&&(func=null),memo}},_.once=_.partial(_.before,2);var hasEnumBug=!{toString:null}.propertyIsEnumerable("toString"),nonEnumerableProps=["valueOf","isPrototypeOf","toString","propertyIsEnumerable","hasOwnProperty","toLocaleString"];_.keys=function(obj){if(!_.isObject(obj))return[];if(nativeKeys)return nativeKeys(obj);var keys=[];for(var key in obj)_.has(obj,key)&&keys.push(key);return hasEnumBug&&collectNonEnumProps(obj,keys),keys},_.allKeys=function(obj){if(!_.isObject(obj))return[];var keys=[];for(var key in obj)keys.push(key);return hasEnumBug&&collectNonEnumProps(obj,keys),keys},_.values=function(obj){for(var keys=_.keys(obj),length=keys.length,values=Array(length),i=0;i<length;i++)values[i]=obj[keys[i]];return values},_.mapObject=function(obj,iteratee,context){iteratee=cb(iteratee,context);for(var currentKey,keys=_.keys(obj),length=keys.length,results={},index=0;index<length;index++)currentKey=keys[index],results[currentKey]=iteratee(obj[currentKey],currentKey,obj);return results},_.pairs=function(obj){for(var keys=_.keys(obj),length=keys.length,pairs=Array(length),i=0;i<length;i++)pairs[i]=[keys[i],obj[keys[i]]];return pairs},_.invert=function(obj){for(var result={},keys=_.keys(obj),i=0,length=keys.length;i<length;i++)result[obj[keys[i]]]=keys[i];return result},_.functions=_.methods=function(obj){var names=[];for(var key in obj)_.isFunction(obj[key])&&names.push(key);return names.sort()},_.extend=createAssigner(_.allKeys),_.extendOwn=_.assign=createAssigner(_.keys),_.findKey=function(obj,predicate,context){predicate=cb(predicate,context);for(var key,keys=_.keys(obj),i=0,length=keys.length;i<length;i++)if(key=keys[i],predicate(obj[key],key,obj))return key},_.pick=function(object,oiteratee,context){var iteratee,keys,result={},obj=object;if(null==obj)return result;_.isFunction(oiteratee)?(keys=_.allKeys(obj),iteratee=optimizeCb(oiteratee,context)):(keys=flatten(arguments,!1,!1,1),iteratee=function(value,key,obj){return key in obj},obj=Object(obj));for(var i=0,length=keys.length;i<length;i++){var key=keys[i],value=obj[key];iteratee(value,key,obj)&&(result[key]=value)}return result},_.omit=function(obj,iteratee,context){if(_.isFunction(iteratee))iteratee=_.negate(iteratee);else{var keys=_.map(flatten(arguments,!1,!1,1),String);iteratee=function(value,key){return!_.contains(keys,key)}}return _.pick(obj,iteratee,context)},_.defaults=createAssigner(_.allKeys,!0),_.create=function(prototype,props){var result=baseCreate(prototype);return props&&_.extendOwn(result,props),result},_.clone=function(obj){return _.isObject(obj)?_.isArray(obj)?obj.slice():_.extend({},obj):obj},_.tap=function(obj,interceptor){return interceptor(obj),obj},_.isMatch=function(object,attrs){var keys=_.keys(attrs),length=keys.length;if(null==object)return!length;for(var obj=Object(object),i=0;i<length;i++){var key=keys[i];if(attrs[key]!==obj[key]||!(key in obj))return!1}return!0};var eq=function(a,b,aStack,bStack){if(a===b)return 0!==a||1/a===1/b;if(null==a||null==b)return a===b;a instanceof _&&(a=a._wrapped),b instanceof _&&(b=b._wrapped);var className=toString.call(a);if(className!==toString.call(b))return!1;switch(className){case"[object RegExp]":case"[object String]":return""+a==""+b;case"[object Number]":return+a!==+a?+b!==+b:0===+a?1/+a===1/b:+a===+b;case"[object Date]":case"[object Boolean]":return+a===+b}var areArrays="[object Array]"===className;if(!areArrays){if("object"!=typeof a||"object"!=typeof b)return!1;var aCtor=a.constructor,bCtor=b.constructor;if(aCtor!==bCtor&&!(_.isFunction(aCtor)&&aCtor instanceof aCtor&&_.isFunction(bCtor)&&bCtor instanceof bCtor)&&"constructor"in a&&"constructor"in b)return!1}aStack=aStack||[],bStack=bStack||[];for(var length=aStack.length;length--;)if(aStack[length]===a)return bStack[length]===b;if(aStack.push(a),bStack.push(b),areArrays){if(length=a.length,length!==b.length)return!1;for(;length--;)if(!eq(a[length],b[length],aStack,bStack))return!1}else{var key,keys=_.keys(a);if(length=keys.length,_.keys(b).length!==length)return!1;for(;length--;)if(key=keys[length],!_.has(b,key)||!eq(a[key],b[key],aStack,bStack))return!1}return aStack.pop(),bStack.pop(),!0};_.isEqual=function(a,b){return eq(a,b)},_.isEmpty=function(obj){return null==obj||(isArrayLike(obj)&&(_.isArray(obj)||_.isString(obj)||_.isArguments(obj))?0===obj.length:0===_.keys(obj).length)},_.isElement=function(obj){return!(!obj||1!==obj.nodeType)},_.isArray=nativeIsArray||function(obj){return"[object Array]"===toString.call(obj)},_.isObject=function(obj){var type=typeof obj;return"function"===type||"object"===type&&!!obj},_.each(["Arguments","Function","String","Number","Date","RegExp","Error"],function(name){_["is"+name]=function(obj){return toString.call(obj)==="[object "+name+"]"}}),_.isArguments(arguments)||(_.isArguments=function(obj){return _.has(obj,"callee")}),"function"!=typeof/./&&"object"!=typeof Int8Array&&(_.isFunction=function(obj){return"function"==typeof obj||!1}),_.isFinite=function(obj){return isFinite(obj)&&!isNaN(parseFloat(obj))},_.isNaN=function(obj){return _.isNumber(obj)&&obj!==+obj},_.isBoolean=function(obj){return obj===!0||obj===!1||"[object Boolean]"===toString.call(obj)},_.isNull=function(obj){return null===obj},_.isUndefined=function(obj){return void 0===obj},_.has=function(obj,key){return null!=obj&&hasOwnProperty.call(obj,key)},_.noConflict=function(){return root._=previousUnderscore,this},_.identity=function(value){return value},_.constant=function(value){return function(){return value}},_.noop=function(){},_.property=property,_.propertyOf=function(obj){return null==obj?function(){}:function(key){return obj[key]}},_.matcher=_.matches=function(attrs){return attrs=_.extendOwn({},attrs),function(obj){return _.isMatch(obj,attrs)}},_.times=function(n,iteratee,context){var accum=Array(Math.max(0,n));iteratee=optimizeCb(iteratee,context,1);for(var i=0;i<n;i++)accum[i]=iteratee(i);return accum},_.random=function(min,max){return null==max&&(max=min,min=0),min+Math.floor(Math.random()*(max-min+1))},_.now=Date.now||function(){return(new Date).getTime()};var escapeMap={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#x27;","`":"&#x60;"},unescapeMap=_.invert(escapeMap),createEscaper=function(map){var escaper=function(match){return map[match]},source="(?:"+_.keys(map).join("|")+")",testRegexp=RegExp(source),replaceRegexp=RegExp(source,"g");return function(string){return string=null==string?"":""+string,testRegexp.test(string)?string.replace(replaceRegexp,escaper):string}};_.escape=createEscaper(escapeMap),_.unescape=createEscaper(unescapeMap),_.result=function(object,property,fallback){var value=null==object?void 0:object[property];return void 0===value&&(value=fallback),_.isFunction(value)?value.call(object):value};var idCounter=0;_.uniqueId=function(prefix){var id=++idCounter+"";return prefix?prefix+id:id},_.templateSettings={evaluate:/<%([\s\S]+?)%>/g,interpolate:/<%=([\s\S]+?)%>/g,escape:/<%-([\s\S]+?)%>/g};var noMatch=/(.)^/,escapes={"'":"'","\\":"\\","\r":"r","\n":"n","\u2028":"u2028","\u2029":"u2029"},escaper=/\\|'|\r|\n|\u2028|\u2029/g,escapeChar=function(match){return"\\"+escapes[match]};_.template=function(text,settings,oldSettings){!settings&&oldSettings&&(settings=oldSettings),settings=_.defaults({},settings,_.templateSettings);var matcher=RegExp([(settings.escape||noMatch).source,(settings.interpolate||noMatch).source,(settings.evaluate||noMatch).source].join("|")+"|$","g"),index=0,source="__p+='";text.replace(matcher,function(match,escape,interpolate,evaluate,offset){return source+=text.slice(index,offset).replace(escaper,escapeChar),index=offset+match.length,escape?source+="'+\n((__t=("+escape+"))==null?'':_.escape(__t))+\n'":interpolate?source+="'+\n((__t=("+interpolate+"))==null?'':__t)+\n'":evaluate&&(source+="';\n"+evaluate+"\n__p+='"),match}),source+="';\n",settings.variable||(source="with(obj||{}){\n"+source+"}\n"),source="var __t,__p='',__j=Array.prototype.join,print=function(){__p+=__j.call(arguments,'');};\n"+source+"return __p;\n";try{var render=new Function(settings.variable||"obj","_",source)}catch(e){throw e.source=source,e}var template=function(data){return render.call(this,data,_)},argument=settings.variable||"obj";return template.source="function("+argument+"){\n"+source+"}",template},_.chain=function(obj){var instance=_(obj);return instance._chain=!0,instance};var result=function(instance,obj){return instance._chain?_(obj).chain():obj};_.mixin=function(obj){_.each(_.functions(obj),function(name){var func=_[name]=obj[name];_.prototype[name]=function(){var args=[this._wrapped];return push.apply(args,arguments),result(this,func.apply(_,args))}})},_.mixin(_),_.each(["pop","push","reverse","shift","sort","splice","unshift"],function(name){var method=ArrayProto[name];_.prototype[name]=function(){var obj=this._wrapped;return method.apply(obj,arguments),"shift"!==name&&"splice"!==name||0!==obj.length||delete obj[0],result(this,obj)}}),_.each(["concat","join","slice"],function(name){var method=ArrayProto[name];_.prototype[name]=function(){return result(this,method.apply(this._wrapped,arguments))}}),_.prototype.value=function(){return this._wrapped},_.prototype.valueOf=_.prototype.toJSON=_.prototype.value,_.prototype.toString=function(){return""+this._wrapped},__WEBPACK_AMD_DEFINE_ARRAY__=[],__WEBPACK_AMD_DEFINE_RESULT__=function(){return _}.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__),!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__))}).call(this)},function(module,exports,__webpack_require__){var json="undefined"!=typeof JSON?JSON:__webpack_require__(95);module.exports=function(obj,opts){opts||(opts={}),"function"==typeof opts&&(opts={cmp:opts});var space=opts.space||"";"number"==typeof space&&(space=Array(space+1).join(" "));var cycles="boolean"==typeof opts.cycles&&opts.cycles,replacer=opts.replacer||function(key,value){return value},cmp=opts.cmp&&function(f){return function(node){return function(a,b){var aobj={key:a,value:node[a]},bobj={key:b,value:node[b]};return f(aobj,bobj)}}}(opts.cmp),seen=[];return function stringify(parent,key,node,level){var indent=space?"\n"+new Array(level+1).join(space):"",colonSeparator=space?": ":":";if(node&&node.toJSON&&"function"==typeof node.toJSON&&(node=node.toJSON()),node=replacer.call(parent,key,node),void 0!==node){if("object"!=typeof node||null===node)return json.stringify(node);if(isArray(node)){for(var out=[],i=0;i<node.length;i++){var item=stringify(node,i,node[i],level+1)||json.stringify(null);out.push(indent+space+item)}return"["+out.join(",")+indent+"]"}if(seen.indexOf(node)!==-1){if(cycles)return json.stringify("__cycle__");throw new TypeError("Converting circular structure to JSON")}seen.push(node);for(var keys=objectKeys(node).sort(cmp&&cmp(node)),out=[],i=0;i<keys.length;i++){var key=keys[i],value=stringify(node,key,node[key],level+1);if(value){var keyValue=json.stringify(key)+colonSeparator+value;out.push(indent+space+keyValue)}}return seen.splice(seen.indexOf(node),1),"{"+out.join(",")+indent+"}"}}({"":obj},"",obj,0)};var isArray=Array.isArray||function(x){return"[object Array]"==={}.toString.call(x)},objectKeys=Object.keys||function(obj){var has=Object.prototype.hasOwnProperty||function(){return!0},keys=[];for(var key in obj)has.call(obj,key)&&keys.push(key);return keys}},function(module,exports,__webpack_require__){function format(obj){if(!obj||"object"!=typeof obj)throw new TypeError("argument obj is required");var parameters=obj.parameters,subtype=obj.subtype,suffix=obj.suffix,type=obj.type;if(!type||!typeNameRegExp.test(type))throw new TypeError("invalid type");if(!subtype||!subtypeNameRegExp.test(subtype))throw new TypeError("invalid subtype");var string=type+"/"+subtype;if(suffix){if(!typeNameRegExp.test(suffix))throw new TypeError("invalid suffix");string+="+"+suffix}if(parameters&&"object"==typeof parameters)for(var param,params=Object.keys(parameters).sort(),i=0;i<params.length;i++){if(param=params[i],!tokenRegExp.test(param))throw new TypeError("invalid parameter name");string+="; "+param+"="+qstring(parameters[param])}return string}function parse(string){if(!string)throw new TypeError("argument string is required");if("object"==typeof string&&(string=getcontenttype(string)),"string"!=typeof string)throw new TypeError("argument string is required to be a string");var key,match,value,index=string.indexOf(";"),type=index!==-1?string.substr(0,index):string,obj=splitType(type),params={};for(paramRegExp.lastIndex=index;match=paramRegExp.exec(string);){if(match.index!==index)throw new TypeError("invalid parameter format");index+=match[0].length,key=match[1].toLowerCase(),value=match[2],'"'===value[0]&&(value=value.substr(1,value.length-2).replace(qescRegExp,"$1")),params[key]=value}if(index!==-1&&index!==string.length)throw new TypeError("invalid parameter format");return obj.parameters=params,obj}function getcontenttype(obj){return"function"==typeof obj.getHeader?obj.getHeader("content-type"):"object"==typeof obj.headers?obj.headers&&obj.headers["content-type"]:void 0}function qstring(val){var str=String(val);if(tokenRegExp.test(str))return str;if(str.length>0&&!textRegExp.test(str))throw new TypeError("invalid parameter value");return'"'+str.replace(quoteRegExp,"\\$1")+'"'}function splitType(string){var match=typeRegExp.exec(string.toLowerCase());if(!match)throw new TypeError("invalid media type");var suffix,type=match[1],subtype=match[2],index=subtype.lastIndexOf("+");index!==-1&&(suffix=subtype.substr(index+1),subtype=subtype.substr(0,index));var obj={type:type,subtype:subtype,suffix:suffix};return obj}var paramRegExp=/; *([!#$%&'\*\+\-\.0-9A-Z\^_`a-z\|~]+) *= *("(?:[ !\u0023-\u005b\u005d-\u007e\u0080-\u00ff]|\\[\u0020-\u007e])*"|[!#$%&'\*\+\-\.0-9A-Z\^_`a-z\|~]+) */g,textRegExp=/^[\u0020-\u007e\u0080-\u00ff]+$/,tokenRegExp=/^[!#$%&'\*\+\-\.0-9A-Z\^_`a-z\|~]+$/,qescRegExp=/\\([\u0000-\u007f])/g,quoteRegExp=/([\\"])/g,subtypeNameRegExp=/^[A-Za-z0-9][A-Za-z0-9!#$&^_.-]{0,126}$/,typeNameRegExp=/^[A-Za-z0-9][A-Za-z0-9!#$&^_-]{0,126}$/,typeRegExp=/^ *([A-Za-z0-9][A-Za-z0-9!#$&^_-]{0,126})\/([A-Za-z0-9][A-Za-z0-9!#$&^_.+-]{0,126}) *$/;exports.format=format,exports.parse=parse},function(module,exports,__webpack_require__){"use strict";function Response(statusCode,headers,body,url){if("number"!=typeof statusCode)throw new TypeError("statusCode must be a number but was "+typeof statusCode);if(null===headers)throw new TypeError("headers cannot be null");if("object"!=typeof headers)throw new TypeError("headers must be an object but was "+typeof headers);this.statusCode=statusCode,this.headers={};for(var key in headers)this.headers[key.toLowerCase()]=headers[key];this.body=body,this.url=url}module.exports=Response,Response.prototype.getBody=function(encoding){if(this.statusCode>=300){var err=new Error("Server responded with status code "+this.statusCode+":\n"+this.body.toString());throw err.statusCode=this.statusCode,err.headers=this.headers,err.body=this.body,err.url=this.url,err}return encoding?this.body.toString(encoding):this.body}},function(module,exports,__webpack_require__){(function(Buffer){function ConcatStream(opts,cb){if(!(this instanceof ConcatStream))return new ConcatStream(opts,cb);"function"==typeof opts&&(cb=opts,opts={}),opts||(opts={});var encoding=opts.encoding,shouldInferEncoding=!1;encoding?(encoding=String(encoding).toLowerCase(),"u8"!==encoding&&"uint8"!==encoding||(encoding="uint8array")):shouldInferEncoding=!0,Writable.call(this,{objectMode:!0}),this.encoding=encoding,this.shouldInferEncoding=shouldInferEncoding,cb&&this.on("finish",function(){cb(this.getBody())}),this.body=[]}function isArrayish(arr){return/Array\]$/.test(Object.prototype.toString.call(arr))}function stringConcat(parts){for(var strings=[],i=0;i<parts.length;i++){var p=parts[i];"string"==typeof p?strings.push(p):Buffer.isBuffer(p)?strings.push(p):strings.push(Buffer(p))}return Buffer.isBuffer(parts[0])?(strings=Buffer.concat(strings),strings=strings.toString("utf8")):strings=strings.join(""),strings}function bufferConcat(parts){for(var bufs=[],i=0;i<parts.length;i++){var p=parts[i];Buffer.isBuffer(p)?bufs.push(p):"string"==typeof p||isArrayish(p)||p&&"function"==typeof p.subarray?bufs.push(Buffer(p)):bufs.push(Buffer(String(p)))}return Buffer.concat(bufs)}function arrayConcat(parts){for(var res=[],i=0;i<parts.length;i++)res.push.apply(res,parts[i]);return res}function u8Concat(parts){for(var len=0,i=0;i<parts.length;i++)"string"==typeof parts[i]&&(parts[i]=Buffer(parts[i])),len+=parts[i].length;for(var u8=new U8(len),i=0,offset=0;i<parts.length;i++)for(var part=parts[i],j=0;j<part.length;j++)u8[offset++]=part[j];return u8}var Writable=__webpack_require__(102).Writable,inherits=__webpack_require__(115);if("undefined"==typeof Uint8Array)var U8=__webpack_require__(96).Uint8Array;else var U8=Uint8Array;module.exports=ConcatStream,inherits(ConcatStream,Writable),ConcatStream.prototype._write=function(chunk,enc,next){this.body.push(chunk),next()},ConcatStream.prototype.inferEncoding=function(buff){var firstBuffer=void 0===buff?this.body[0]:buff;return Buffer.isBuffer(firstBuffer)?"buffer":"undefined"!=typeof Uint8Array&&firstBuffer instanceof Uint8Array?"uint8array":Array.isArray(firstBuffer)?"array":"string"==typeof firstBuffer?"string":"[object Object]"===Object.prototype.toString.call(firstBuffer)?"object":"buffer"},ConcatStream.prototype.getBody=function(){return this.encoding||0!==this.body.length?(this.shouldInferEncoding&&(this.encoding=this.inferEncoding()),"array"===this.encoding?arrayConcat(this.body):"string"===this.encoding?stringConcat(this.body):"buffer"===this.encoding?bufferConcat(this.body):"uint8array"===this.encoding?u8Concat(this.body):this.body):[]};Array.isArray||function(arr){return"[object Array]"==Object.prototype.toString.call(arr)}}).call(exports,__webpack_require__(92).Buffer)},function(module,exports,__webpack_require__){(function(Buffer){function fromBase64(base64string){return base64string.replace(/=/g,"").replace(/\+/g,"-").replace(/\//g,"_")}function toBase64(base64UrlString){Buffer.isBuffer(base64UrlString)&&(base64UrlString=base64UrlString.toString());var b64str=padString(base64UrlString).replace(/\-/g,"+").replace(/_/g,"/");return b64str}function padString(string){var segmentLength=4,stringLength=string.length,diff=string.length%segmentLength;if(!diff)return string;var position=stringLength,padLength=segmentLength-diff,paddedStringLength=stringLength+padLength,buffer=Buffer(paddedStringLength);for(buffer.write(string);padLength--;)buffer.write("=",position++);return buffer.toString()}function decodeBase64Url(base64UrlString,encoding){return Buffer(toBase64(base64UrlString),"base64").toString(encoding)}function base64url(stringOrBuffer,encoding){return fromBase64(Buffer(stringOrBuffer,encoding).toString("base64"))}function toBuffer(base64string){return Buffer(toBase64(base64string),"base64")}base64url.toBase64=toBase64,base64url.fromBase64=fromBase64,base64url.decode=decodeBase64Url,base64url.encode=base64url,base64url.toBuffer=toBuffer,module.exports=base64url}).call(exports,__webpack_require__(92).Buffer)},function(module,exports,__webpack_require__){(function(process){"use strict";var invariant=function(condition,format,a,b,c,d,e,f){if("production"!==process.env.NODE_ENV&&void 0===format)throw new Error("invariant requires an error message argument");if(!condition){var error;if(void 0===format)error=new Error("Minified exception occurred; use the non-minified dev environment for the full error message and additional helpful warnings.");else{var args=[a,b,c,d,e,f],argIndex=0;error=new Error(format.replace(/%s/g,function(){return args[argIndex++]})),error.name="Invariant Violation"}throw error.framesToPop=1,error}};module.exports=invariant}).call(exports,__webpack_require__(59))},function(module,exports,__webpack_require__){"use strict";var def=__webpack_require__(36),universes=__webpack_require__(22),universeHelpers=__webpack_require__(14),services=def,search=__webpack_require__(23),AttributeDefaultsCalculator=function(){function AttributeDefaultsCalculator(enabled){this.enabled=enabled,this.valueCalculators=[new RequiredPropertyCalculator,new TypePropertyCalculator,new DisplayNamePropertyCalculator,new MediaTypeCalculator,new SecuredByPropertyCalculator,new ProtocolsPropertyCalculator,new VersionParamEnumCalculator]}return AttributeDefaultsCalculator.prototype.attributeDefaultIfEnabled=function(node,attributeProperty){return this.enabled?this.getAttributeDefault(node,attributeProperty):null},AttributeDefaultsCalculator.prototype.getAttributeDefault=function(node,attributeProperty){if(!node||!attributeProperty)return null;try{return this.getAttributeDefault2(attributeProperty,node)}catch(Error){return console.log(Error),null}},AttributeDefaultsCalculator.prototype.getWrapperAttributeDefault=function(wrapperNode,attributeName){var highLevelNode=wrapperNode.highLevel();if(null==highLevelNode)return null;var property=highLevelNode.definition().property(attributeName);return null==property?null:this.getAttributeDefault(highLevelNode,property)},AttributeDefaultsCalculator.prototype.getAttributeDefault2=function(attributeProperty,node){for(var i=0;i<this.valueCalculators.length;i++){var calculator=this.valueCalculators[i];if(calculator.matches(attributeProperty,node)){var value=calculator.calculate(attributeProperty,node);if(null!=value)return value}}return null!=attributeProperty.defaultValue()?attributeProperty.defaultValue():null},AttributeDefaultsCalculator.prototype.isEnabled=function(){return this.enabled},AttributeDefaultsCalculator.prototype.insertionKind=function(node,attributeProperty){for(var i=0;i<this.valueCalculators.length;i++){var calculator=this.valueCalculators[i];if(calculator.matches(attributeProperty,node))return calculator.kind()}return null!=attributeProperty.defaultValue()?InsertionKind.BY_DEFAULT:null},AttributeDefaultsCalculator}();exports.AttributeDefaultsCalculator=AttributeDefaultsCalculator,function(InsertionKind){InsertionKind[InsertionKind.CALCULATED=0]="CALCULATED",InsertionKind[InsertionKind.BY_DEFAULT=1]="BY_DEFAULT"}(exports.InsertionKind||(exports.InsertionKind={}));var InsertionKind=exports.InsertionKind,MediaTypeCalculator=function(){function MediaTypeCalculator(){}return MediaTypeCalculator.prototype.calculate=function(attributeProperty,node){var root=search.declRoot(node);if(root&&universeHelpers.isApiSibling(root.definition())){var defaultMediaTypeAttr=root.attr(universes.Universe10.Api.properties.mediaType.name);if(defaultMediaTypeAttr)return defaultMediaTypeAttr.value()}return null},MediaTypeCalculator.prototype.matches=function(attributeProperty,node){if(!universeHelpers.isNameProperty(attributeProperty))return!1;var nodeDefinition=node.definition();if(!nodeDefinition)return!1;if(!universeHelpers.isBodyLikeType(nodeDefinition)&&!universeHelpers.isTypeDeclarationSibling(nodeDefinition))return!1;var parentNode=node.parent();if(null==parentNode)return!1;var parentDefinition=parentNode.definition();if(null==parentDefinition)return!1;if(!universeHelpers.isResponseType(parentDefinition)&&!universeHelpers.isMethodBaseSibling(parentDefinition))return!1;for(var ancestor=parentNode;ancestor;){var aDef=ancestor.definition();if(universeHelpers.isTraitType(aDef))return!1;if(universeHelpers.isResourceTypeType(aDef))return!1;ancestor=ancestor.parent()}return!0},MediaTypeCalculator.prototype.kind=function(){return InsertionKind.CALCULATED},MediaTypeCalculator}(),DisplayNamePropertyCalculator=function(){function DisplayNamePropertyCalculator(){}return DisplayNamePropertyCalculator.prototype.calculate=function(attributeProperty,node){var nodeDefinition=node.definition();if(null==nodeDefinition)return null;var adapter=nodeDefinition.getAdapter(services.RAMLService),keyProperty=adapter.getKeyProp();if(null!=keyProperty){var attributeValue=node.attrValue(keyProperty.nameId());return null!=attributeValue?attributeValue:new AttributeDefaultsCalculator((!0)).getAttributeDefault(node,keyProperty)}return null},DisplayNamePropertyCalculator.prototype.matches=function(attributeProperty,node){var nodeDefinition=node.definition();return null!=nodeDefinition&&((universeHelpers.isTypeDeclarationSibling(nodeDefinition)||nodeDefinition.isAssignableFrom(universes.Universe08.Parameter.name)||universeHelpers.isResourceType(nodeDefinition))&&universeHelpers.isDisplayNameProperty(attributeProperty))},DisplayNamePropertyCalculator.prototype.kind=function(){return InsertionKind.CALCULATED},DisplayNamePropertyCalculator}(),TypePropertyCalculator=function(){function TypePropertyCalculator(){}return TypePropertyCalculator.prototype.calculate=function(attributeProperty,node){return"object"},TypePropertyCalculator.prototype.matches=function(attributeProperty,node){return universeHelpers.isTypeProperty(attributeProperty)&&null!=node.definition()&&universeHelpers.isObjectTypeDeclarationSibling(node.definition())},TypePropertyCalculator.prototype.kind=function(){return InsertionKind.BY_DEFAULT},TypePropertyCalculator}(),RequiredPropertyCalculator=function(){function RequiredPropertyCalculator(){}return RequiredPropertyCalculator.prototype.calculate=function(attributeProperty,node){var nodeDefinition=node.definition(),nodeProperty=node.property();if(null==nodeDefinition)return null;var adapter=nodeDefinition.getAdapter(services.RAMLService),keyProperty=adapter.getKeyProp();if(null!=keyProperty){var attribute=node.attr(keyProperty.nameId());if(null!=attribute&&attribute.optional())return!1}if(null!=nodeProperty){if(universeHelpers.isHeadersProperty(nodeProperty)||universeHelpers.isFormParametersProperty(nodeProperty)||universeHelpers.isQueryParametersProperty(nodeProperty))return"RAML08"!=attributeProperty.domain().universe().version();if(universeHelpers.isUriParametersProperty(nodeProperty)||universeHelpers.isBaseUriParametersProperty(nodeProperty))return!0}return null!=attributeProperty.defaultValue()?attributeProperty.defaultValue():null},RequiredPropertyCalculator.prototype.matches=function(attributeProperty,node){return universeHelpers.isRequiredProperty(attributeProperty)},RequiredPropertyCalculator.prototype.kind=function(){return InsertionKind.BY_DEFAULT},RequiredPropertyCalculator}(),SecuredByPropertyCalculator=function(){function SecuredByPropertyCalculator(){}return SecuredByPropertyCalculator.prototype.calculate=function(attributeProperty,node){if(universeHelpers.isApiSibling(node.definition()))return null;var values,definition=node.definition();if(universeHelpers.isMethodType(definition)){var resource=node.parent();resource&&(values=resource.wrapperNode().securedBy())}if(!values||0==values.length){for(;null!=node&&!universeHelpers.isApiSibling(node.definition());)node=node.parent();node&&(values=node.wrapperNode().securedBy())}return values&&values.length>0?values:null},SecuredByPropertyCalculator.prototype.matches=function(attributeProperty,node){var nodeDefinition=node.definition();return null!=nodeDefinition&&universeHelpers.isSecuredByProperty(attributeProperty)},SecuredByPropertyCalculator.prototype.kind=function(){
return InsertionKind.CALCULATED},SecuredByPropertyCalculator}(),ProtocolsPropertyCalculator=function(){function ProtocolsPropertyCalculator(){}return ProtocolsPropertyCalculator.prototype.calculate=function(attributeProperty,node){for(;null!=node&&!universeHelpers.isApiSibling(node.definition());)node=node.parent();var result,baseUriAttr=node.attr(universes.Universe10.Api.properties.baseUri.name);if(baseUriAttr){var baseUri=baseUriAttr.value();if(baseUri){var ind=baseUri.indexOf("://");ind>=0&&(result=[baseUri.substring(0,ind).toUpperCase()]),result||(result=["HTTP"])}}return result},ProtocolsPropertyCalculator.prototype.matches=function(attributeProperty,node){if(!universeHelpers.isProtocolsProperty(attributeProperty))return!1;var nodeDefinition=node.definition(),hasAppropriateLocation=!1;if(universeHelpers.isApiSibling(nodeDefinition))hasAppropriateLocation=!0;else if(universeHelpers.isResourceType(nodeDefinition))hasAppropriateLocation=!0;else if(universeHelpers.isMethodType(nodeDefinition)){var parentNode=node.parent();hasAppropriateLocation=parentNode&&universeHelpers.isResourceType(parentNode.definition())}return hasAppropriateLocation},ProtocolsPropertyCalculator.prototype.kind=function(){return InsertionKind.CALCULATED},ProtocolsPropertyCalculator}(),VersionParamEnumCalculator=function(){function VersionParamEnumCalculator(){}return VersionParamEnumCalculator.prototype.calculate=function(attributeProperty,node){for(;null!=node&&!universeHelpers.isApiSibling(node.definition());)node=node.parent();var versionAttr=node.attr(universes.Universe10.Api.properties.version.name);if(versionAttr){var versionValue=versionAttr.value();if(versionValue&&versionValue.trim())return[versionValue]}return null},VersionParamEnumCalculator.prototype.matches=function(attributeProperty,node){if(!universeHelpers.isEnumProperty(attributeProperty))return!1;var nodeProperty=node.property();if(!nodeProperty)return!1;if(!universeHelpers.isBaseUriParametersProperty(nodeProperty))return!1;var nameAttr=node.attr(universes.Universe10.TypeDeclaration.properties.name.name),paramName=nameAttr&&nameAttr.value();return"version"==paramName},VersionParamEnumCalculator.prototype.kind=function(){return InsertionKind.CALCULATED},VersionParamEnumCalculator}()},function(module,exports,__webpack_require__){"use strict";function dump(node,serializeMeta){return void 0===serializeMeta&&(serializeMeta=!0),new TCKDumper({rootNodeDetails:!0,serializeMetadata:serializeMeta}).dump(node)}var __extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},universe=__webpack_require__(22),core=__webpack_require__(45),def=__webpack_require__(36),hlImpl=__webpack_require__(16),builder=__webpack_require__(26),universeHelpers=__webpack_require__(14),universes=__webpack_require__(22),RamlWrapper10=__webpack_require__(12);exports.dump=dump;var TCKDumper=function(){function TCKDumper(options){this.options=options,this.nodeTransformers=[new ResourcesTransformer,new TypeExampleTransformer,new TypesTransformer,new SecuritySchemesTransformer,new AnnotationTypesTransformer,new TemplateParametrizedPropertiesTransformer,new TraitsTransformer,new ResourceTypesTransformer,new SchemasTransformer,new ProtocolsToUpperCaseTransformer,new ResourceTypeMethodsToMapTransformer,new ReferencesTransformer],this.nodePropertyTransformers=[new ParametersTransformer,new PropertiesTransformer,new ResponsesTransformer,new BodiesTransformer,new AnnotationsTransformer,new FacetsTransformer,new OneElementArrayTransformer],this.ignore=new CompositeObjectPropertyMatcher([new BasicObjectPropertyMatcher(universeHelpers.isResponseType,universeHelpers.isDisplayNameProperty),new BasicObjectPropertyMatcher(universeHelpers.isApiSibling,universeHelpers.isDisplayNameProperty),new BasicObjectPropertyMatcher(universeHelpers.isAnnotationRefTypeOrDescendant,universeHelpers.isAnnotationProperty),new BasicObjectPropertyMatcher(universeHelpers.isSecuritySchemeRefType,universeHelpers.isSecuritySchemeProperty),new BasicObjectPropertyMatcher(universeHelpers.isTraitRefType,universeHelpers.isTraitProperty),new BasicObjectPropertyMatcher(universeHelpers.isResourceTypeRefType,universeHelpers.isResourceTypeProperty),new BasicObjectPropertyMatcher(universeHelpers.isApiSibling,universeHelpers.isRAMLVersionProperty)]),this.missingProperties=new PropertiesData,this.options=this.options||{},null==this.options.serializeMetadata&&(this.options.serializeMetadata=!0)}return TCKDumper.prototype.printMissingProperties=function(){return this.missingProperties.print()},TCKDumper.prototype.dump=function(node){var highLevelNode=node.highLevel(),highLevelParent=highLevelNode&&highLevelNode.parent(),rootNodeDetails=!highLevelParent&&this.options.rootNodeDetails;return this.dumpInternal(node,rootNodeDetails)},TCKDumper.prototype.dumpInternal=function(node,rootNodeDetails){var _this=this;if(void 0===rootNodeDetails&&(rootNodeDetails=!1),null==node)return null;if(node instanceof core.BasicNodeImpl){var props={},basicNode=node,definition=basicNode.highLevel().definition();definition.allProperties().filter(function(x){return!_this.ignore.match(basicNode.definition(),x)}).forEach(function(x){props[x.nameId()]=x}),definition.allCustomProperties().filter(function(x){return!_this.ignore.match(basicNode.definition(),x)}).forEach(function(x){props[x.nameId()]=x});var obj=this.dumpProperties(props,node);if(props.schema&&this.options.dumpSchemaContents&&props.schema.range().key()==universes.Universe08.SchemaString){var schemas=basicNode.highLevel().root().elementsOfKind("schemas");schemas.forEach(function(x){if(x.name()==obj.schema){var vl=x.attr("value");vl&&(obj.schema=vl.value(),obj.schemaContent=vl.value())}})}if(this.serializeScalarsAnnotations(obj,basicNode,props),this.serializeMeta(obj,basicNode),this.canBeFragment(node)&&RamlWrapper10.isFragment(node)){var fragment=RamlWrapper10.asFragment(node),uses=fragment.uses();uses.length>0&&(obj.uses=uses.map(function(x){return x.toJSON()}))}this.nodeTransformers.forEach(function(x){x.match(node,node.highLevel().property())&&(obj=x.transform(obj))});var result={};if(rootNodeDetails){if(definition){var ramlVersion=definition.universe().version();result.ramlVersion=ramlVersion,result.type=definition.nameId()}result.specification=obj,result.errors=this.dumpErrors(basicNode.errors())}else result=obj;return result}if(node instanceof core.AttributeNodeImpl){var props={},attrNode=node,definition=attrNode.highLevel().definition();definition.allCustomProperties().filter(function(x){return!_this.ignore.match(attrNode.highLevel().property().range(),x)}).forEach(function(x){props[x.nameId()]=x});var isValueType=attrNode.highLevel().property().range().isValueType();if(isValueType&&attrNode.value){var val=attrNode.value();if("number"==typeof val||"string"==typeof val||"boolean"==typeof val)return val}var obj=this.dumpProperties(props,node);return this.nodeTransformers.forEach(function(x){x.match(node,node.highLevel().property())&&(obj=x.transform(obj))}),this.serializeScalarsAnnotations(obj,node,props),this.serializeMeta(obj,attrNode),obj}return node instanceof core.TypeInstanceImpl?this.serializeTypeInstance(node):node instanceof core.TypeInstancePropertyImpl?this.serializeTypeInstanceProperty(node):node},TCKDumper.prototype.canBeFragment=function(node){var definition=node.definition(),arr=[definition].concat(definition.allSubTypes()),arr1=arr.filter(function(x){return x.getAdapter(def.RAMLService).possibleInterfaces().filter(function(y){return y.nameId()==def.universesInfo.Universe10.FragmentDeclaration.name}).length>0});return arr1.length>0},TCKDumper.prototype.dumpErrors=function(errors){return errors.map(function(x){var eObj={code:x.code,message:x.message,path:x.path,line:x.line,column:x.column,position:x.start,range:x.range};return x.isWarning===!0&&(eObj.isWarning=!0),eObj}).sort(function(x,y){return x.path!=y.path?x.path.localeCompare(y.path):x.position!=y.position?x.position-y.position:x.code-y.code})},TCKDumper.prototype.dumpProperties=function(props,node){var _this=this,obj={};return Object.keys(props).forEach(function(propName){if(!node[propName])return void _this.missingProperties.addProperty(props[propName],node.kind());var property=props[propName],value=node[propName]();if(value&&"structuredType"==propName&&"object"==typeof value){value=null;var highLevelNode=node.highLevel(),a=highLevelNode.lowLevel();a.children().forEach(function(x){if("type"==x.key()||"schema"==x.key()){var td=highLevelNode.definition().universe().type(universe.Universe10.TypeDeclaration.name),hasType=highLevelNode.definition().universe().type(universe.Universe10.LibraryBase.name),tNode=new hlImpl.ASTNodeImpl(x,highLevelNode,td,hasType.property(universe.Universe10.LibraryBase.properties.types.name));tNode.patchType(builder.doDescrimination(tNode)),value=dump(tNode.wrapperNode()),propName=x.key()}})}if((value||"type"!=propName)&&(value||"schema"!=propName)){if(node.definition&&universeHelpers.isTypeDeclarationSibling(node.definition())&&universeHelpers.isTypeProperty(property)){var schemaValue=node[universe.Universe10.TypeDeclaration.properties.schema.name]();if(null!=schemaValue&&(!Array.isArray(schemaValue)||0!=schemaValue.length))return;var highLevelNode=node.highLevel(),a=highLevelNode.lowLevel(),hasSchema=!1;if(a.children().forEach(function(x){if("schema"==x.key())return void(hasSchema=!0)}),hasSchema)return}if(Array.isArray(value)){for(var propertyValue=[],_i=0,value_1=value;_i<value_1.length;_i++){var val=value_1[_i],dumped=_this.dumpInternal(val);"examples"===propName&&_this.options&&_this.options.dumpXMLRepresentationOfExamples&&val.expandable&&val.expandable._owner&&(dumped.asXMLString=val.expandable.asXMLString()),propertyValue.push(dumped)}if(0==propertyValue.length&&node instanceof core.BasicNodeImpl&&!_this.isDefined(node,propName))return;for(var _a=0,_b=_this.nodePropertyTransformers;_a<_b.length;_a++){var x=_b[_a];x.match(node,property)&&(propertyValue=x.transform(propertyValue))}obj[propName]=propertyValue}else{var val=_this.dumpInternal(value);if(null==val&&node instanceof core.BasicNodeImpl&&!_this.isDefined(node,propName))return;node instanceof core.BasicNodeImpl&&_this.nodePropertyTransformers.forEach(function(x){x.match(node,property)&&(val=x.transform(val))}),obj[propName]=val,"example"===propName&&_this.options&&_this.options.dumpXMLRepresentationOfExamples&&value.expandable&&value.expandable._owner&&(val.asXMLString=value.expandable.asXMLString())}}}),obj},TCKDumper.prototype.serializeScalarsAnnotations=function(obj,node,props){var _this=this;if(node.scalarsAnnotations){for(var val={},accessor=node.scalarsAnnotations(),_i=0,_a=Object.keys(props);_i<_a.length;_i++){var propName=_a[_i];if(accessor[propName]){var arr=accessor[propName]();if(arr.length>0)if(Array.isArray(arr[0])){var arr1=[];arr.forEach(function(x,i){arr1.push(x.map(function(y){return _this.dumpInternal(y)}))}),arr1.filter(function(x){return x.length>0}).length>0&&(val[propName]=arr1)}else val[propName]=arr.map(function(x){return _this.dumpInternal(x)})}}Object.keys(val).length>0&&(obj.scalarsAnnotations=val)}},TCKDumper.prototype.serializeMeta=function(obj,node){if(this.options.serializeMetadata){var meta=node.meta();meta.isDefault()||(obj.__METADATA__=meta.toJSON())}},TCKDumper.prototype.serializeTypeInstance=function(inst){var _this=this;if(inst.isScalar())return inst.value();if(inst.isArray())return inst.items().map(function(x){return _this.serializeTypeInstance(x)});var props=inst.properties();if(0==props.length)return null;var obj={};return props.forEach(function(x){return obj[x.name()]=_this.serializeTypeInstanceProperty(x)}),obj},TCKDumper.prototype.serializeTypeInstanceProperty=function(prop){var _this=this;if(prop.isArray()){var values=prop.values(),arr=[];return values.forEach(function(x){return arr.push(_this.serializeTypeInstance(x))}),arr}return this.serializeTypeInstance(prop.value())},TCKDumper.prototype.isDefined=function(node,name){var hl=node.highLevel();return hl.elementsOfKind(name).length>0||hl.attributes(name).length>0},TCKDumper}();exports.TCKDumper=TCKDumper;var BasicObjectPropertyMatcher=function(){function BasicObjectPropertyMatcher(typeMatcher,propMatcher){this.typeMatcher=typeMatcher,this.propMatcher=propMatcher}return BasicObjectPropertyMatcher.prototype.match=function(td,prop){return(null==td||this.typeMatcher(td))&&(null==prop||this.propMatcher(prop))},BasicObjectPropertyMatcher}(),CompositeObjectPropertyMatcher=function(){function CompositeObjectPropertyMatcher(matchers){this.matchers=matchers}return CompositeObjectPropertyMatcher.prototype.match=function(td,prop){for(var l=this.matchers.length,i=0;i<l;i++)if(this.matchers[i].match(td,prop))return!0;return!1},CompositeObjectPropertyMatcher}(),ArrayToMapTransformer=function(){function ArrayToMapTransformer(matcher,propName){this.matcher=matcher,this.propName=propName}return ArrayToMapTransformer.prototype.match=function(node,prop){return this.matcher.match(node.definition(),prop)},ArrayToMapTransformer.prototype.transform=function(value){var _this=this;if(Array.isArray(value)&&value.length>0&&value[0][this.propName]){var obj={};return value.forEach(function(x){var key=x[_this.propName],previous=obj[key];previous?Array.isArray(previous)?previous.push(x):obj[key]=[previous,x]:obj[key]=x}),obj}return value},ArrayToMapTransformer}(),ArrayToMappingsArrayTransformer=function(){function ArrayToMappingsArrayTransformer(matcher,propName){this.matcher=matcher,this.propName=propName}return ArrayToMappingsArrayTransformer.prototype.match=function(node,prop){return this.matcher.match(node.definition?node.definition():null,prop)},ArrayToMappingsArrayTransformer.prototype.transform=function(value){if(Array.isArray(value))return value;var obj={};return obj[value[this.propName]]=value,obj},ArrayToMappingsArrayTransformer}(),ParametersTransformer=function(_super){function ParametersTransformer(){_super.call(this,new CompositeObjectPropertyMatcher([new BasicObjectPropertyMatcher(universeHelpers.isApiSibling,universeHelpers.isBaseUriParametersProperty),new BasicObjectPropertyMatcher(universeHelpers.isResourceBaseSibling,universeHelpers.isUriParametersProperty),new BasicObjectPropertyMatcher(universeHelpers.isResourceBaseSibling,universeHelpers.isQueryParametersProperty),new BasicObjectPropertyMatcher(universeHelpers.isTraitType,universeHelpers.isQueryParametersProperty),new BasicObjectPropertyMatcher(universeHelpers.isMethodType,universeHelpers.isQueryParametersProperty),new BasicObjectPropertyMatcher(universeHelpers.isSecuritySchemePartType,universeHelpers.isQueryParametersProperty),new BasicObjectPropertyMatcher(universeHelpers.isTraitType,universeHelpers.isHeadersProperty),new BasicObjectPropertyMatcher(universeHelpers.isMethodType,universeHelpers.isHeadersProperty),new BasicObjectPropertyMatcher(universeHelpers.isSecuritySchemePartType,universeHelpers.isHeadersProperty),new BasicObjectPropertyMatcher(universeHelpers.isBodyLikeType,universeHelpers.isFormParametersProperty)]),"name")}return __extends(ParametersTransformer,_super),ParametersTransformer}(ArrayToMapTransformer),TypesTransformer=function(_super){function TypesTransformer(){_super.call(this,new CompositeObjectPropertyMatcher([new BasicObjectPropertyMatcher(universeHelpers.isLibraryBaseSibling,universeHelpers.isTypesProperty),new BasicObjectPropertyMatcher(function(x){return universeHelpers.isLibraryBaseSibling(x)&&universeHelpers.isRAML10Type(x)},universeHelpers.isSchemasProperty)]),"name")}return __extends(TypesTransformer,_super),TypesTransformer.prototype.match=function(node,prop){return null!=node.parent()&&this.matcher.match(node.parent().definition(),prop)},TypesTransformer}(ArrayToMappingsArrayTransformer),PropertiesTransformer=(function(_super){function UsesTransformer(){_super.call(this,new CompositeObjectPropertyMatcher([new BasicObjectPropertyMatcher(universeHelpers.isLibraryBaseSibling,universeHelpers.isUsesProperty)]),"name")}return __extends(UsesTransformer,_super),UsesTransformer}(ArrayToMapTransformer),function(_super){function PropertiesTransformer(){_super.call(this,new CompositeObjectPropertyMatcher([new BasicObjectPropertyMatcher(universeHelpers.isObjectTypeDeclarationSibling,universeHelpers.isPropertiesProperty)]),"name")}return __extends(PropertiesTransformer,_super),PropertiesTransformer}(ArrayToMapTransformer)),ResponsesTransformer=function(_super){function ResponsesTransformer(){_super.call(this,new CompositeObjectPropertyMatcher([new BasicObjectPropertyMatcher(universeHelpers.isMethodBaseSibling,universeHelpers.isResponsesProperty)]),"code")}return __extends(ResponsesTransformer,_super),ResponsesTransformer}(ArrayToMapTransformer),AnnotationsTransformer=function(_super){function AnnotationsTransformer(){_super.call(this,new CompositeObjectPropertyMatcher([new BasicObjectPropertyMatcher(function(x){return!0},universeHelpers.isAnnotationsProperty)]),"name")}return __extends(AnnotationsTransformer,_super),AnnotationsTransformer}(ArrayToMapTransformer),BodiesTransformer=function(_super){function BodiesTransformer(){_super.call(this,new CompositeObjectPropertyMatcher([new BasicObjectPropertyMatcher(universeHelpers.isResponseType,universeHelpers.isBodyProperty),new BasicObjectPropertyMatcher(universeHelpers.isMethodBaseSibling,universeHelpers.isBodyProperty)]),"name")}return __extends(BodiesTransformer,_super),BodiesTransformer}(ArrayToMapTransformer),TraitsTransformer=function(_super){function TraitsTransformer(){_super.call(this,new CompositeObjectPropertyMatcher([new BasicObjectPropertyMatcher(universeHelpers.isTraitType,universeHelpers.isTraitsProperty)]),"name")}return __extends(TraitsTransformer,_super),TraitsTransformer}(ArrayToMappingsArrayTransformer),ResourceTypesTransformer=function(_super){function ResourceTypesTransformer(){_super.call(this,new CompositeObjectPropertyMatcher([new BasicObjectPropertyMatcher(universeHelpers.isResourceTypeType,universeHelpers.isResourceTypesProperty)]),"name")}return __extends(ResourceTypesTransformer,_super),ResourceTypesTransformer.prototype.transform=function(value){var methodsPropertyName=universes.Universe10.ResourceBase.properties.methods.name;if(Array.isArray(value))return value;var methods=value[methodsPropertyName];return methods&&methods.forEach(function(m){var keys=Object.keys(m);if(keys.length>0){var methodName=keys[0];value[methodName]=m[methodName]}}),delete value[methodsPropertyName],_super.prototype.transform.call(this,value)},ResourceTypesTransformer}(ArrayToMappingsArrayTransformer),FacetsTransformer=function(_super){function FacetsTransformer(){_super.call(this,new CompositeObjectPropertyMatcher([new BasicObjectPropertyMatcher(universeHelpers.isTypeDeclarationSibling,universeHelpers.isFacetsProperty)]),"name")}return __extends(FacetsTransformer,_super),FacetsTransformer}(ArrayToMapTransformer),SecuritySchemesTransformer=function(_super){function SecuritySchemesTransformer(){_super.call(this,null,"name")}return __extends(SecuritySchemesTransformer,_super),SecuritySchemesTransformer.prototype.match=function(node,prop){return null!=prop&&universeHelpers.isSecuritySchemesProperty(prop)},SecuritySchemesTransformer}(ArrayToMappingsArrayTransformer),AnnotationTypesTransformer=function(_super){function AnnotationTypesTransformer(){_super.call(this,new CompositeObjectPropertyMatcher([new BasicObjectPropertyMatcher(universeHelpers.isLibraryBaseSibling,universeHelpers.isAnnotationTypesProperty)]),"name")}return __extends(AnnotationTypesTransformer,_super),AnnotationTypesTransformer.prototype.match=function(node,prop){return null!=node.parent()&&this.matcher.match(node.parent().definition(),prop)},AnnotationTypesTransformer}(ArrayToMappingsArrayTransformer),ResourceTypeMethodsToMapTransformer=function(_super){function ResourceTypeMethodsToMapTransformer(){_super.call(this,null,"method")}return __extends(ResourceTypeMethodsToMapTransformer,_super),ResourceTypeMethodsToMapTransformer.prototype.match=function(node,prop){return null!=node.parent()&&universeHelpers.isResourceTypeType(node.parent().definition())&&universeHelpers.isMethodsProperty(prop)},ResourceTypeMethodsToMapTransformer}(ArrayToMappingsArrayTransformer),exampleNameProp=universe.Universe10.ExampleSpec.properties.name.name,exampleContentProp=universe.Universe10.ExampleSpec.properties.value.name,exampleStructuredContentProp="structuredContent",TypeExampleTransformer=(function(){function ExamplesTransformer(){}return ExamplesTransformer.prototype.match=function(node,prop){return universeHelpers.isExampleSpecType(node.definition())},ExamplesTransformer.prototype.transform=function(value){var _this=this;if(Array.isArray(value)&&value.length>0){if(value[0][exampleNameProp]){var obj={};return value.forEach(function(x){return obj[x[exampleNameProp]]=_this.getActualExample(x)}),obj}var arr=value.map(function(x){return _this.getActualExample(x)});return arr}return value},ExamplesTransformer.prototype.getActualExample=function(exampleSpecObj){return exampleSpecObj[exampleStructuredContentProp]?exampleSpecObj[exampleStructuredContentProp]:exampleSpecObj[exampleContentProp]},ExamplesTransformer}(),function(){function TypeExampleTransformer(){}return TypeExampleTransformer.prototype.match=function(node,prop){return node.definition&&universeHelpers.isTypeDeclarationSibling(node.definition())},TypeExampleTransformer.prototype.transform=function(value){var isArray=Array.isArray(value),arr=isArray?value:[value];return arr.forEach(function(x){var structuredExample=x.example;structuredExample&&(x.example=structuredExample.structuredValue,x.structuredExample=structuredExample)}),isArray?arr:arr[0]},TypeExampleTransformer}()),SchemasTransformer=function(){function SchemasTransformer(){this.matcher=new BasicObjectPropertyMatcher(function(x){return universeHelpers.isApiType(x)&&universeHelpers.isRAML08Type(x)},universeHelpers.isSchemasProperty)}return SchemasTransformer.prototype.match=function(node,prop){return null!=node.parent()&&this.matcher.match(node.parent().definition(),prop)},SchemasTransformer.prototype.transform=function(value){if(Array.isArray(value))return value;var obj={};return obj[value.key]=value.value,obj},SchemasTransformer.prototype.getActualExample=function(exampleSpecObj){return exampleSpecObj[exampleStructuredContentProp]?exampleSpecObj[exampleStructuredContentProp]:exampleSpecObj[exampleContentProp]},SchemasTransformer}(),ProtocolsToUpperCaseTransformer=function(){function ProtocolsToUpperCaseTransformer(){}return ProtocolsToUpperCaseTransformer.prototype.match=function(node,prop){return null!=prop&&universeHelpers.isProtocolsProperty(prop)},ProtocolsToUpperCaseTransformer.prototype.transform=function(value){return"string"==typeof value?value.toUpperCase():Array.isArray(value)?value.map(function(x){return x.toUpperCase()}):value},ProtocolsToUpperCaseTransformer}(),OneElementArrayTransformer=function(){function OneElementArrayTransformer(){this.usecases=new CompositeObjectPropertyMatcher([new BasicObjectPropertyMatcher(universeHelpers.isApiSibling,universeHelpers.isMediaTypeProperty)])}return OneElementArrayTransformer.prototype.match=function(node,prop){return this.usecases.match(node.definition(),prop)},OneElementArrayTransformer.prototype.transform=function(value){return Array.isArray(value)&&1==value.length?value[0]:value},OneElementArrayTransformer}(),ResourcesTransformer=function(){function ResourcesTransformer(){}return ResourcesTransformer.prototype.match=function(node,prop){return null!=prop&&universeHelpers.isResourcesProperty(prop)},ResourcesTransformer.prototype.transform=function(value){if(Array.isArray(value))return value;var relUri=value[universes.Universe10.Resource.properties.relativeUri.name];if(relUri){for(var segments=relUri.trim().split("/");segments.length>0&&0==segments[0].length;)segments.shift();value.relativeUriPathSegments=segments}return value},ResourcesTransformer}(),TemplateParametrizedPropertiesTransformer=function(){function TemplateParametrizedPropertiesTransformer(){}return TemplateParametrizedPropertiesTransformer.prototype.match=function(node,prop){var hlNode=node.highLevel();if(!hlNode)return!1;var d=hlNode.definition();return!!d&&(universeHelpers.isResourceTypeType(d)||universeHelpers.isTraitType(d)||universeHelpers.isMethodType(d)||universeHelpers.isTypeDeclarationSibling(d))},TemplateParametrizedPropertiesTransformer.prototype.transform=function(value){if(Array.isArray(value))return value;var propName=universe.Universe10.Trait.properties.parametrizedProperties.name,parametrizedProps=value[propName];return parametrizedProps&&(Object.keys(parametrizedProps).forEach(function(y){value[y]=parametrizedProps[y]}),delete value[propName]),value},TemplateParametrizedPropertiesTransformer}(),ReferencesTransformer=function(){function ReferencesTransformer(){}return ReferencesTransformer.prototype.match=function(node,prop){return null!=prop&&(universeHelpers.isSecuredByProperty(prop)||universeHelpers.isIsProperty(prop)||null!=node.parent()&&(universeHelpers.isResourceType(node.parent().highLevel().definition())||universeHelpers.isResourceTypeType(node.parent().highLevel().definition()))&&universeHelpers.isTypeProperty(prop))},ReferencesTransformer.prototype.transform=function(value){return value?Array.isArray(value)?value:this.toSimpleValue(value):null},ReferencesTransformer.prototype.toSimpleValue=function(x){var name=x.name,params=x.structuredValue;if(params){var obj={};return obj[name]=params,obj}return name},ReferencesTransformer}(),PropertiesData=function(){function PropertiesData(){this.map={}}return PropertiesData.prototype.addProperty=function(prop,wrapperKind){var data=this.map[wrapperKind];data||(data=new TypePropertiesData(wrapperKind),this.map[wrapperKind]=data),data.addProperty(prop)},PropertiesData.prototype.print=function(){var _this=this;return Object.keys(this.map).map(function(x){return _this.map[x].print()}).join("\n")+"\n"},PropertiesData}(),TypePropertiesData=function(){function TypePropertiesData(typeName){this.typeName=typeName,this.map={}}return TypePropertiesData.prototype.addProperty=function(prop){var name=prop.domain().nameId(),data=this.map[name];data||(data=new TypePropertiesData2(name),this.map[name]=data),data.addProperty(prop)},TypePropertiesData.prototype.print=function(){var _this=this;return this.typeName+":\n"+Object.keys(this.map).map(function(x){return"    "+_this.map[x].print()}).join("\n")},TypePropertiesData}(),TypePropertiesData2=function(){function TypePropertiesData2(typeName){this.typeName=typeName,this.map={}}return TypePropertiesData2.prototype.addProperty=function(prop){var name=prop.nameId();this.map[name]=prop},TypePropertiesData2.prototype.print=function(){return this.typeName+": "+Object.keys(this.map).sort().join(", ")},TypePropertiesData2}()},function(module,exports,__webpack_require__){"use strict";function newMapping(key,value){var end=value?value.endPosition:key.endPosition+1,node={key:key,value:value,startPosition:key.startPosition,endPosition:end,kind:Kind.MAPPING,parent:null,errors:[]};return node}function newAnchorRef(key,start,end,value){return{errors:[],referencesAnchor:key,value:value,startPosition:start,endPosition:end,kind:Kind.ANCHOR_REF,parent:null}}function newScalar(v){return void 0===v&&(v=""),{errors:[],startPosition:-1,endPosition:-1,value:v,kind:Kind.SCALAR,parent:null,doubleQuoted:!1}}function newItems(){return{errors:[],startPosition:-1,endPosition:-1,items:[],kind:Kind.SEQ,parent:null}}function newSeq(){return newItems()}function newMap(mappings){return{errors:[],startPosition:-1,endPosition:-1,mappings:mappings?mappings:[],kind:Kind.MAP,parent:null}}var loader=__webpack_require__(82),dumper=__webpack_require__(83),YAMLException=function(){function YAMLException(reason,mark){void 0===mark&&(mark=null),this.name="YAMLException",this.reason=reason,this.mark=mark,this.message=this.toString(!1)}return YAMLException.prototype.toString=function(compact){void 0===compact&&(compact=!1);var result;return result="JS-YAML: "+(this.reason||"(unknown reason)"),!compact&&this.mark&&(result+=" "+this.mark.toString()),result},YAMLException}();exports.YAMLException=YAMLException,function(Kind){Kind[Kind.SCALAR=0]="SCALAR",Kind[Kind.MAPPING=1]="MAPPING",Kind[Kind.MAP=2]="MAP",Kind[Kind.SEQ=3]="SEQ",Kind[Kind.ANCHOR_REF=4]="ANCHOR_REF",Kind[Kind.INCLUDE_REF=5]="INCLUDE_REF"}(exports.Kind||(exports.Kind={}));var Kind=exports.Kind;exports.newMapping=newMapping,exports.newAnchorRef=newAnchorRef,exports.newScalar=newScalar,exports.newItems=newItems,exports.newSeq=newSeq,exports.newMap=newMap,exports.load=loader.load,exports.loadAll=loader.loadAll,exports.safeLoad=loader.safeLoad,exports.dump=dumper.dump,exports.safeDump=dumper.safeDump},function(module,exports,__webpack_require__){exports.dot=exports.dotCase=__webpack_require__(119),exports.swap=exports.swapCase=__webpack_require__(118),exports.path=exports.pathCase=__webpack_require__(120),exports.upper=exports.upperCase=__webpack_require__(121),exports.lower=exports.lowerCase=__webpack_require__(124),exports.camel=exports.camelCase=__webpack_require__(123),exports.snake=exports.snakeCase=__webpack_require__(125),exports.title=exports.titleCase=__webpack_require__(122),exports.param=exports.paramCase=__webpack_require__(127),exports.pascal=exports.pascalCase=__webpack_require__(126),exports.constant=exports.constantCase=__webpack_require__(130),exports.sentence=exports.sentenceCase=__webpack_require__(128),exports.isUpper=exports.isUpperCase=__webpack_require__(131),exports.isLower=exports.isLowerCase=__webpack_require__(129),exports.ucFirst=exports.upperCaseFirst=__webpack_require__(132),exports.lcFirst=exports.lowerCaseFirst=__webpack_require__(133)},function(module,exports,__webpack_require__){!function(root,pluralize){module.exports=pluralize()}(this,function(){function toTitleCase(str){return str.charAt(0).toUpperCase()+str.substr(1).toLowerCase()}function sanitizeRule(rule){return"string"==typeof rule?new RegExp("^"+rule+"$","i"):rule}function restoreCase(word,token){return word===word.toUpperCase()?token.toUpperCase():word[0]===word[0].toUpperCase()?toTitleCase(token):token.toLowerCase()}function interpolate(str,args){return str.replace(/\$(\d{1,2})/g,function(match,index){return args[index]||""})}function sanitizeWord(token,word,collection){if(!token.length||uncountables.hasOwnProperty(token))return word;for(var len=collection.length;len--;){var rule=collection[len];if(rule[0].test(word))return word.replace(rule[0],function(match,index,word){var result=interpolate(rule[1],arguments);return""===match?restoreCase(word[index-1],result):restoreCase(match,result)})}return word}function replaceWord(replaceMap,keepMap,rules){return function(word){var token=word.toLowerCase();return keepMap.hasOwnProperty(token)?restoreCase(word,token):replaceMap.hasOwnProperty(token)?restoreCase(word,replaceMap[token]):sanitizeWord(token,word,rules)}}function pluralize(word,count,inclusive){var pluralized=1===count?pluralize.singular(word):pluralize.plural(word);return(inclusive?count+" ":"")+pluralized}var pluralRules=[],singularRules=[],uncountables={},irregularPlurals={},irregularSingles={};return pluralize.plural=replaceWord(irregularSingles,irregularPlurals,pluralRules),pluralize.singular=replaceWord(irregularPlurals,irregularSingles,singularRules),pluralize.addPluralRule=function(rule,replacement){pluralRules.push([sanitizeRule(rule),replacement])},pluralize.addSingularRule=function(rule,replacement){singularRules.push([sanitizeRule(rule),replacement])},pluralize.addUncountableRule=function(word){return"string"==typeof word?void(uncountables[word.toLowerCase()]=!0):(pluralize.addPluralRule(word,"$0"),void pluralize.addSingularRule(word,"$0"))},pluralize.addIrregularRule=function(single,plural){plural=plural.toLowerCase(),single=single.toLowerCase(),irregularSingles[single]=plural,irregularPlurals[plural]=single;
},[["I","we"],["me","us"],["he","they"],["she","they"],["them","them"],["myself","ourselves"],["yourself","yourselves"],["itself","themselves"],["herself","themselves"],["himself","themselves"],["themself","themselves"],["is","are"],["this","these"],["that","those"],["echo","echoes"],["dingo","dingoes"],["volcano","volcanoes"],["tornado","tornadoes"],["torpedo","torpedoes"],["genus","genera"],["viscus","viscera"],["stigma","stigmata"],["stoma","stomata"],["dogma","dogmata"],["lemma","lemmata"],["schema","schemata"],["anathema","anathemata"],["ox","oxen"],["axe","axes"],["die","dice"],["yes","yeses"],["foot","feet"],["eave","eaves"],["goose","geese"],["tooth","teeth"],["quiz","quizzes"],["human","humans"],["proof","proofs"],["carve","carves"],["valve","valves"],["thief","thieves"],["genie","genies"],["groove","grooves"],["pickaxe","pickaxes"],["whiskey","whiskies"]].forEach(function(rule){return pluralize.addIrregularRule(rule[0],rule[1])}),[[/s?$/i,"s"],[/([^aeiou]ese)$/i,"$1"],[/(ax|test)is$/i,"$1es"],[/(alias|[^aou]us|tlas|gas|ris)$/i,"$1es"],[/(e[mn]u)s?$/i,"$1s"],[/([^l]ias|[aeiou]las|[emjzr]as|[iu]am)$/i,"$1"],[/(alumn|syllab|octop|vir|radi|nucle|fung|cact|stimul|termin|bacill|foc|uter|loc|strat)(?:us|i)$/i,"$1i"],[/(alumn|alg|vertebr)(?:a|ae)$/i,"$1ae"],[/(seraph|cherub)(?:im)?$/i,"$1im"],[/(her|at|gr)o$/i,"$1oes"],[/(agend|addend|millenni|dat|extrem|bacteri|desiderat|strat|candelabr|errat|ov|symposi|curricul|automat|quor)(?:a|um)$/i,"$1a"],[/(apheli|hyperbat|periheli|asyndet|noumen|phenomen|criteri|organ|prolegomen|hedr|automat)(?:a|on)$/i,"$1a"],[/sis$/i,"ses"],[/(?:(kni|wi|li)fe|(ar|l|ea|eo|oa|hoo)f)$/i,"$1$2ves"],[/([^aeiouy]|qu)y$/i,"$1ies"],[/([^ch][ieo][ln])ey$/i,"$1ies"],[/(x|ch|ss|sh|zz)$/i,"$1es"],[/(matr|cod|mur|sil|vert|ind|append)(?:ix|ex)$/i,"$1ices"],[/(m|l)(?:ice|ouse)$/i,"$1ice"],[/(pe)(?:rson|ople)$/i,"$1ople"],[/(child)(?:ren)?$/i,"$1ren"],[/eaux$/i,"$0"],[/m[ae]n$/i,"men"],["thou","you"]].forEach(function(rule){return pluralize.addPluralRule(rule[0],rule[1])}),[[/s$/i,""],[/(ss)$/i,"$1"],[/((a)naly|(b)a|(d)iagno|(p)arenthe|(p)rogno|(s)ynop|(t)he)(?:sis|ses)$/i,"$1sis"],[/(^analy)(?:sis|ses)$/i,"$1sis"],[/(wi|kni|(?:after|half|high|low|mid|non|night|[^\w]|^)li)ves$/i,"$1fe"],[/(ar|(?:wo|[ae])l|[eo][ao])ves$/i,"$1f"],[/([^aeiouy]|qu)ies$/i,"$1y"],[/(^[pl]|zomb|^(?:neck)?t|[aeo][lt]|cut)ies$/i,"$1ie"],[/(\b(?:mon|smil))ies$/i,"$1ey"],[/(m|l)ice$/i,"$1ouse"],[/(seraph|cherub)im$/i,"$1"],[/(x|ch|ss|sh|zz|tto|go|cho|alias|[^aou]us|tlas|gas|(?:her|at|gr)o|ris)(?:es)?$/i,"$1"],[/(e[mn]u)s?$/i,"$1"],[/(movie|twelve)s$/i,"$1"],[/(cris|test|diagnos)(?:is|es)$/i,"$1is"],[/(alumn|syllab|octop|vir|radi|nucle|fung|cact|stimul|termin|bacill|foc|uter|loc|strat)(?:us|i)$/i,"$1us"],[/(agend|addend|millenni|dat|extrem|bacteri|desiderat|strat|candelabr|errat|ov|symposi|curricul|quor)a$/i,"$1um"],[/(apheli|hyperbat|periheli|asyndet|noumen|phenomen|criteri|organ|prolegomen|hedr|automat)a$/i,"$1on"],[/(alumn|alg|vertebr)ae$/i,"$1a"],[/(cod|mur|sil|vert|ind)ices$/i,"$1ex"],[/(matr|append)ices$/i,"$1ix"],[/(pe)(rson|ople)$/i,"$1rson"],[/(child)ren$/i,"$1"],[/(eau)x?$/i,"$1"],[/men$/i,"man"]].forEach(function(rule){return pluralize.addSingularRule(rule[0],rule[1])}),["advice","agenda","bison","bream","buffalo","carp","chassis","cod","cooperation","corps","digestion","debris","diabetes","energy","equipment","elk","excretion","expertise","flounder","gallows","garbage","graffiti","headquarters","health","herpes","highjinks","homework","information","jeans","justice","kudos","labour","machinery","mackerel","media","mews","moose","news","pike","plankton","pliers","pollution","premises","rain","rice","salmon","scissors","series","sewage","shambles","shrimp","species","staff","swine","trout","tuna","whiting","wildebeest","wildlife","you",/pox$/i,/ois$/i,/deer$/i,/fish$/i,/sheep$/i,/measles$/i,/[^aeiou]ese$/i].forEach(pluralize.addUncountableRule),pluralize})},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_FACTORY__,__WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__;!function(root,factory){"use strict";"object"==typeof module&&"object"==typeof module.exports?module.exports=factory():(__WEBPACK_AMD_DEFINE_ARRAY__=[],__WEBPACK_AMD_DEFINE_FACTORY__=factory,__WEBPACK_AMD_DEFINE_RESULT__="function"==typeof __WEBPACK_AMD_DEFINE_FACTORY__?__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__):__WEBPACK_AMD_DEFINE_FACTORY__,!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__)))}("object"==typeof window?window:this,function(){"use strict";function CacheState(capacity){this.capacity=capacity>0?+capacity:Number.MAX_VALUE,this.data=Object.create?Object.create(null):{},this.hash=Object.create?Object.create(null):{},this.linkedList={length:0,head:null,end:null}}function LRUCache(capacity){return this instanceof LRUCache?void(this._LRUCacheState=new CacheState(capacity)):new LRUCache(capacity)}function refresh(linkedList,entry){entry!==linkedList.head&&(linkedList.end?linkedList.end===entry&&(linkedList.end=entry.n):linkedList.end=entry,link(entry.n,entry.p),link(entry,linkedList.head),linkedList.head=entry,linkedList.head.n=null)}function link(nextEntry,prevEntry){nextEntry!==prevEntry&&(nextEntry&&(nextEntry.p=prevEntry),prevEntry&&(prevEntry.n=nextEntry))}var proto=LRUCache.prototype;return proto.get=function(key){var state=this._LRUCacheState,lruEntry=state.hash[key];if(lruEntry)return refresh(state.linkedList,lruEntry),state.data[key]},proto.set=function(key,value){var state=this._LRUCacheState,lruEntry=state.hash[key];return void 0===value?this:(lruEntry||(state.hash[key]={key:key},state.linkedList.length+=1,lruEntry=state.hash[key]),refresh(state.linkedList,lruEntry),state.data[key]=value,state.linkedList.length>state.capacity&&this.remove(state.linkedList.end.key),this)},proto.update=function(key,parseFn){this._LRUCacheState;if(this.has(key)){var data=this.get(key);this.set(key,parseFn(data))}return this},proto.remove=function(key){var state=this._LRUCacheState,lruEntry=state.hash[key];return lruEntry?(lruEntry===state.linkedList.head&&(state.linkedList.head=lruEntry.p),lruEntry===state.linkedList.end&&(state.linkedList.end=lruEntry.n),link(lruEntry.n,lruEntry.p),delete state.hash[key],delete state.data[key],state.linkedList.length-=1,this):this},proto.removeAll=function(){return this._LRUCacheState=new CacheState(this._LRUCacheState.capacity),this},proto.info=function(){var state=this._LRUCacheState;return{capacity:state.capacity,length:state.linkedList.length}},proto.keys=function(){for(var state=this._LRUCacheState,keys=[],lruEntry=state.linkedList.head;lruEntry;)keys.push(lruEntry.key),lruEntry=lruEntry.p;return keys},proto.has=function(key){return!!this._LRUCacheState.hash[key]},proto.staleKey=function(){return this._LRUCacheState.linkedList.end&&this._LRUCacheState.linkedList.end.key},proto.popStale=function(){var staleKey=this.staleKey();if(!staleKey)return null;var stale=[staleKey,this._LRUCacheState.data[staleKey]];return this.remove(staleKey),stale},LRUCache.NAME="LRUCache",LRUCache.VERSION="v0.2.0",LRUCache})},function(module,exports,__webpack_require__){"use strict";function doRequest(method,url,options,callback){var result=new Promise(function(resolve,reject){function attempt(n){doRequest(method,url,{qs:options.qs,headers:options.headers,timeout:options.timeout}).nodeify(function(err,res){var retry=err||res.statusCode>=400;if("function"==typeof options.retry&&(retry=options.retry(err,res,n+1)),n>=(5|options.maxRetries)&&(retry=!1),retry){var delay=options.retryDelay;"function"==typeof options.retryDelay&&(delay=options.retryDelay(err,res,n+1)),delay=delay||200,setTimeout(function(){attempt(n+1)},delay)}else err?reject(err):resolve(res)})}var xhr=new window.XMLHttpRequest;if("string"!=typeof method)throw new TypeError("The method must be a string.");if("string"!=typeof url)throw new TypeError("The URL/path must be a string.");if("function"==typeof options&&(callback=options,options={}),null!==options&&void 0!==options||(options={}),"object"!=typeof options)throw new TypeError("Options must be an object (or null).");if("function"!=typeof callback&&(callback=void 0),method=method.toUpperCase(),options.headers=options.headers||{},options.retry&&"GET"===method)return attempt(0);var match,crossDomain=!(!(match=/^([\w-]+:)?\/\/([^\/]+)/.exec(url))||match[2]==window.location.host);if(crossDomain||(options.headers["X-Requested-With"]="XMLHttpRequest"),options.qs&&(url=handleQs(url,options.qs)),options.json&&(options.body=JSON.stringify(options.json),options.headers["Content-Type"]="application/json"),options.timeout){xhr.timeout=options.timeout;var start=Date.now();xhr.ontimeout=function(){var duration=Date.now()-start,err=new Error("Request timed out after "+duration+"ms");err.timeout=!0,err.duration=duration,reject(err)}}xhr.onreadystatechange=function(){if(4===xhr.readyState){var headers={};xhr.getAllResponseHeaders().split("\r\n").forEach(function(header){var h=header.split(":");h.length>1&&(headers[h[0].toLowerCase()]=h.slice(1).join(":").trim())});var res=new Response(xhr.status,headers,xhr.responseText);res.url=url,resolve(res)}},xhr.open(method,url,!0);for(var name in options.headers)xhr.setRequestHeader(name,options.headers[name]);xhr.send(options.body?options.body:null)});return result.getBody=function(){return result.then(function(res){return res.getBody()})},result.nodeify(callback)}var Promise=__webpack_require__(114),Response=__webpack_require__(64),handleQs=__webpack_require__(87);module.exports=doRequest},function(module,exports,__webpack_require__){function DOMParser(options){this.options=options||{locator:{}}}function buildErrorHandler(errorImpl,domBuilder,locator){function build(key){var fn=errorImpl[key];!fn&&isCallback&&(fn=2==errorImpl.length?function(msg){errorImpl(key,msg)}:errorImpl),errorHandler[key]=fn&&function(msg){fn("[xmldom "+key+"]\t"+msg+_locator(locator))}||function(){}}if(!errorImpl){if(domBuilder instanceof DOMHandler)return domBuilder;errorImpl=domBuilder}var errorHandler={},isCallback=errorImpl instanceof Function;return locator=locator||{},build("warning"),build("error"),build("fatalError"),errorHandler}function DOMHandler(){this.cdata=!1}function position(locator,node){node.lineNumber=locator.lineNumber,node.columnNumber=locator.columnNumber}function _locator(l){if(l)return"\n@"+(l.systemId||"")+"#[line:"+l.lineNumber+",col:"+l.columnNumber+"]"}function _toString(chars,start,length){return"string"==typeof chars?chars.substr(start,length):chars.length>=start+length||start?new java.lang.String(chars,start,length)+"":chars}function appendElement(hander,node){hander.currentElement?hander.currentElement.appendChild(node):hander.document.appendChild(node)}DOMParser.prototype.parseFromString=function(source,mimeType){var options=this.options,sax=new XMLReader,domBuilder=options.domBuilder||new DOMHandler,errorHandler=options.errorHandler,locator=options.locator,defaultNSMap=options.xmlns||{},entityMap={lt:"<",gt:">",amp:"&",quot:'"',apos:"'"};return locator&&domBuilder.setDocumentLocator(locator),sax.errorHandler=buildErrorHandler(errorHandler,domBuilder,locator),sax.domBuilder=options.domBuilder||domBuilder,/\/x?html?$/.test(mimeType)&&(entityMap.nbsp=" ",entityMap.copy="©",defaultNSMap[""]="http://www.w3.org/1999/xhtml"),defaultNSMap.xml=defaultNSMap.xml||"http://www.w3.org/XML/1998/namespace",source?sax.parse(source,defaultNSMap,entityMap):sax.errorHandler.error("invalid document source"),domBuilder.document},DOMHandler.prototype={startDocument:function(){this.document=(new DOMImplementation).createDocument(null,null,null),this.locator&&(this.document.documentURI=this.locator.systemId)},startElement:function(namespaceURI,localName,qName,attrs){var doc=this.document,el=doc.createElementNS(namespaceURI,qName||localName),len=attrs.length;appendElement(this,el),this.currentElement=el,this.locator&&position(this.locator,el);for(var i=0;i<len;i++){var namespaceURI=attrs.getURI(i),value=attrs.getValue(i),qName=attrs.getQName(i),attr=doc.createAttributeNS(namespaceURI,qName);attr.getOffset&&position(attr.getOffset(1),attr),attr.value=attr.nodeValue=value,el.setAttributeNode(attr)}},endElement:function(namespaceURI,localName,qName){var current=this.currentElement;current.tagName;this.currentElement=current.parentNode},startPrefixMapping:function(prefix,uri){},endPrefixMapping:function(prefix){},processingInstruction:function(target,data){var ins=this.document.createProcessingInstruction(target,data);this.locator&&position(this.locator,ins),appendElement(this,ins)},ignorableWhitespace:function(ch,start,length){},characters:function(chars,start,length){if(chars=_toString.apply(this,arguments),this.currentElement&&chars){if(this.cdata){var charNode=this.document.createCDATASection(chars);this.currentElement.appendChild(charNode)}else{var charNode=this.document.createTextNode(chars);this.currentElement.appendChild(charNode)}this.locator&&position(this.locator,charNode)}},skippedEntity:function(name){},endDocument:function(){this.document.normalize()},setDocumentLocator:function(locator){(this.locator=locator)&&(locator.lineNumber=0)},comment:function(chars,start,length){chars=_toString.apply(this,arguments);var comm=this.document.createComment(chars);this.locator&&position(this.locator,comm),appendElement(this,comm)},startCDATA:function(){this.cdata=!0},endCDATA:function(){this.cdata=!1},startDTD:function(name,publicId,systemId){var impl=this.document.implementation;if(impl&&impl.createDocumentType){var dt=impl.createDocumentType(name,publicId,systemId);this.locator&&position(this.locator,dt),appendElement(this,dt)}},warning:function(error){console.warn("[xmldom warning]\t"+error,_locator(this.locator))},error:function(error){console.error("[xmldom error]\t"+error,_locator(this.locator))},fatalError:function(error){throw console.error("[xmldom fatalError]\t"+error,_locator(this.locator)),error}},"endDTD,startEntity,endEntity,attributeDecl,elementDecl,externalEntityDecl,internalEntityDecl,resolveEntity,getExternalSubset,notationDecl,unparsedEntityDecl".replace(/\w+/g,function(key){DOMHandler.prototype[key]=function(){return null}});var XMLReader=__webpack_require__(85).XMLReader,DOMImplementation=exports.DOMImplementation=__webpack_require__(86).DOMImplementation;exports.XMLSerializer=__webpack_require__(86).XMLSerializer,exports.DOMParser=DOMParser},function(module,exports,__webpack_require__){"use strict";function isEmpty(value){return null==value}function toString(value){return isEmpty(value)?"":String(value)}function toBoolean(value){return[0,!1,"","0","false"].indexOf(value)===-1}function toNumber(value){return isFinite(value)?Number(value):null}function toInteger(value){return value%1===0?Number(value):null}function toDate(value){return isNaN(Date.parse(value))?null:new Date(value)}function toSanitization(parameter,rules,types){var parameters=Array.isArray(parameter)?parameter:[parameter],sanitizations=parameters.map(function(parameter){function sanitize(value,key,src){for(var i=0;i<fns.length;i++){var fn=fns[i],value=fn(value,key,src);if(null!=value)return value}return null}var fns=[],typeSanitization=types[parameter.type];return"function"==typeof typeSanitization&&fns.push(typeSanitization),Object.keys(parameter).filter(function(key){return"type"!==key&&"repeat"!==key&&"default"!==key}).forEach(function(key){var fn=rules[key];"function"==typeof fn&&fns.push(fn(parameter[key],key))}),function(value,key,src){if(isEmpty(value))return null!=parameter.default?sanitize(parameter.default,key,src):parameter.repeat&&!parameter.required?[]:value;if(parameter.repeat){var values=Array.isArray(value)?value:[value];return values=values.map(function(value){return sanitize(value,key,src)}),values.some(isEmpty)?null:value}if(Array.isArray(value)){if(value.length>1)return null;value=value[0]}return sanitize(value,key,src)}});return function(value,key,src){for(var i=0;i<sanitizations.length;i++){var sanitization=sanitizations[i],result=sanitization(value,key,src);if(null!=result)return result}return value}}function sanitize(){function rule(parameter){return toSanitization(parameter,RULES,TYPES)}var s,RULES={},TYPES={string:toString,number:toNumber,integer:toInteger,boolean:toBoolean,date:toDate},sanitize=function(parameterMap){if(!parameterMap)return function(){return{}};var sanitizations={};return Object.keys(parameterMap).forEach(function(key){sanitizations[key]=sanitize.rule(parameterMap[key])}),function(src){src=src||{};var dest={};return Object.keys(sanitizations).forEach(function(key){var value=src[key],fn=sanitizations[key];Object.prototype.hasOwnProperty.call(src,key)&&(dest[key]=fn(value,key,src))}),dest}};return s=sanitize,s.rule=rule,s.TYPES=TYPES,s.RULES=RULES,s}exports.sanitize=sanitize},function(module,exports,__webpack_require__){(function(Buffer){"use strict";function isDateType(check){return"[object Date]"===_toString.call(check)&&!isNaN(check.getTime())}function isBooleanType(check){return"boolean"==typeof check}function isStringType(check){return"string"==typeof check}function isIntegerType(check){return"number"==typeof check&&check%1===0}function isNumberType(check){return"number"==typeof check&&isFinite(check)}function isMinimum(min){return function(check){return check>=min}}function isMaximum(max){return function(check){return check<=max}}function isMinimumLength(min){return function(check){return Buffer.byteLength(check)>=min}}function isMaximumLength(max){return function(check){return Buffer.byteLength(check)<=max}}function isEnum(values){return values&&0!=values.length?function(check){return values.indexOf(check)>-1}:function(check){return!0}}function isPattern(pattern){var regexp="string"==typeof pattern?new RegExp(pattern):pattern;return regexp.test.bind(regexp)}function toValidationResult(valid,key,value,rule,attr){return{valid:valid,rule:rule,attr:attr,value:value,key:key}}function toValidationFunction(parameter,rules){var validations=[];return Object.keys(parameter).forEach(function(name){var rule=rules[name];if(rule){var value=parameter[name];validations.push([name,rule(value,name),value])}}),function(value,key,src){for(var i=0;i<validations.length;i++){var validation=validations[i],name=validation[0],fn=validation[1],attr=validation[2],valid=fn(value,key,src);if(!valid)return toValidationResult(!1,key,value,name,attr)}return toValidationResult(!0,key,value)}}function toValidation(parameter,rules,types){var parameters=Array.isArray(parameter)?parameter:[parameter],isOptional=!parameters.length,simpleValidations=[],repeatValidations=[];return parameters.forEach(function(parameter){var validation=[parameter.type||"string",toValidationFunction(parameter,rules)];parameter.required||(isOptional=!0),parameter.repeat?repeatValidations.push(validation):simpleValidations.push(validation)}),function(value,key,src){if(null==value)return toValidationResult(isOptional,key,value,"required",!isOptional);var isArray=Array.isArray(value),values=isArray?value:[value],validations=isArray?repeatValidations:simpleValidations;if(!validations.length)return toValidationResult(!1,key,value,"repeat",!isArray);var response=null,originalValue=value;return validations.some(function(validation){var isValidType=values.every(function(value){var paramType=validation[0],isValidType=types[paramType]&&types[paramType](value,key,src);return isValidType||(response=toValidationResult(!1,key,originalValue,"type",paramType)),isValidType});return!!isValidType&&(values.every(function(value){var fn=validation[1];return response=fn(value,key),response.valid}),!0)}),response}}function validate(){function rule(parameter){return toValidation(parameter,RULES,TYPES)}var v,TYPES={date:isDateType,number:isNumberType,integer:isIntegerType,boolean:isBooleanType,string:isStringType},RULES={minimum:isMinimum,maximum:isMaximum,minLength:isMinimumLength,maxLength:isMaximumLength,enum:isEnum,pattern:isPattern},validate=function(parameterMap){if(!parameterMap)return function(check){return{valid:!0,errors:[]}};var validations={};return Object.keys(parameterMap).forEach(function(key){validations[key]=rule(parameterMap[key])}),function(src){src=src||{};var errors=Object.keys(validations).map(function(param){var value=src[param],fn=validations[param];return fn(value,param,src)}).filter(function(result){return!result.valid});return{valid:0===errors.length,errors:errors}}};return v=validate,v.rule=rule,v.TYPES=TYPES,v.RULES=RULES,v}var _toString=Object.prototype.toString;exports.validate=validate}).call(exports,__webpack_require__(92).Buffer)},function(module,exports,__webpack_require__){(function(global){(function(){var vm,__slice=[].slice;vm=__webpack_require__(101),exports.allowUnsafeEval=function(fn){var previousEval;previousEval=global.eval;try{return global.eval=function(source){return vm.runInThisContext(source)},fn()}finally{global.eval=previousEval}},exports.allowUnsafeNewFunction=function(fn){var previousFunction;previousFunction=global.Function;try{return global.Function=exports.Function,fn()}finally{global.Function=previousFunction}},exports.Function=function(){var body,paramList,paramLists,params,_i,_j,_len;for(paramLists=2<=arguments.length?__slice.call(arguments,0,_i=arguments.length-1):(_i=0,[]),body=arguments[_i++],params=[],_j=0,_len=paramLists.length;_j<_len;_j++)paramList=paramLists[_j],"string"==typeof paramList&&(paramList=paramList.split(/\s*,\s*/)),params.push.apply(params,paramList);return vm.runInThisContext("(function("+params.join(", ")+") {\n  "+body+"\n})")},exports.Function.prototype=global.Function.prototype}).call(this)}).call(exports,function(){return this}())},function(module,exports,__webpack_require__){"use strict";function handleTypeAnnotation(a,rangeType){"MetaModel.declaresSubTypeOf"==a.name&&rangeType.getAdapter(services.RAMLService).setExtendedTypeName(a.arguments[0]),"MetaModel.nameAtRuntime"==a.name&&rangeType.setNameAtRuntime(a.arguments[0]),"MetaModel.description"==a.name&&rangeType.withDescription(a.arguments[0]),"MetaModel.inlinedTemplates"==a.name&&rangeType.getAdapter(services.RAMLService).setInlinedTemplates(!0),"MetaModel.requireValue"==a.name&&rangeType.getAdapter(services.RAMLService).withContextRequirement(""+a.arguments[0],""+a.arguments[1]),"MetaModel.referenceIs"==a.name&&rangeType.getAdapter(services.RAMLService).withReferenceIs(""+a.arguments[0]),"MetaModel.actuallyExports"==a.name&&rangeType.getAdapter(services.RAMLService).withActuallyExports(""+a.arguments[0]),"MetaModel.convertsToGlobalOfType"==a.name&&rangeType.getAdapter(services.RAMLService).withConvertsToGlobal(""+a.arguments[0]),"MetaModel.allowAny"==a.name&&rangeType.getAdapter(services.RAMLService).withAllowAny(),"MetaModel.allowQuestion"==a.name&&rangeType.getAdapter(services.RAMLService).withAllowQuestion(),"MetaModel.alias"==a.name&&rangeType.getAdapter(services.RAMLService).addAlias(""+a.arguments[0]),"MetaModel.consumesRefs"==a.name&&rangeType.getAdapter(services.RAMLService).setConsumesRefs(!0),"MetaModel.canInherit"==a.name&&rangeType.getAdapter(services.RAMLService).withCanInherit(""+a.arguments[0]),"MetaModel.definingPropertyIsEnough"==a.name&&rangeType.getAdapter(services.RAMLService).definingPropertyIsEnough(""+a.arguments[0]),"MetaModel.customHandling"==a.name&&rangeType.setCustom(!0),"MetaModel.superclasses"==a.name&&rangeType.getAdapter(services.RAMLService).registerSupertypes(a.arguments[0]),"MetaModel.possibleInterfaces"==a.name&&rangeType.getAdapter(services.RAMLService).registerPossibleInterfaces(a.arguments[0])}function recordAnnotation(p,a){exports.annotationHandlers[a.name](a,p)}var def=__webpack_require__(36),khttp=__webpack_require__(134),_=__webpack_require__(88),services=def;exports.handleTypeAnnotation=handleTypeAnnotation,exports.annotationHandlers={key:function(a,f){f.withFromParentKey(),f.withKey(!0)},value:function(a,f){f.withFromParentValue()},canBeValue:function(a,f){f.withCanBeValue()},unmerged:function(a,f){f.unmerge()},startFrom:function(a,f){f.withKeyRestriction(a.arguments[0]),f.merge()},oneOf:function(a,f){f.withEnumOptions(a.arguments[0])},oftenKeys:function(a,f){f.withOftenKeys(a.arguments[0])},embeddedInMaps:function(a,f){f.getAdapter(services.RAMLPropertyParserService).withEmbedMap()},system:function(a,f){f.getAdapter(services.RAMLPropertyParserService).withSystem(!0)},required:function(a,f){"false"!=a.arguments[0]&&a.arguments[0]!==!1&&f.withRequired(!0)},noDirectParse:function(a,f){"false"!=a.arguments[0]&&a.arguments[0]!==!1&&f.withNoDirectParse()},setsContextValue:function(a,f){f.addChildValueConstraint(new def.ChildValueConstraint(""+a.arguments[0],""+a.arguments[1]))},defaultValue:function(a,f){f.setDefaultVal(""+a.arguments[0])},defaultIntegerValue:function(a,f){f.setDefaultIntegerVal(a.arguments[0])},defaultBooleanValue:function(a,f){f.setDefaultBooleanVal(a.arguments[0])},facetId:function(a,f){"minItems"==a.arguments[0]&&f.setFacetValidator(function(x,f){if(x instanceof Array){var length=Number.parseInt(""+f.value());if(length>x.length)return"array should contain at least "+f.value()+" items"}return null}),"enum"==a.arguments[0]&&f.setFacetValidator(function(x,f){var validateAgainst=x+"",array=f;try{if(!array.some(function(x){return x==validateAgainst}))return"value should be one of :"+array.join(",")}catch(e){return}return null}),"maxItems"==a.arguments[0]&&f.setFacetValidator(function(x,f){if(x instanceof Array){var length=Number.parseInt(""+f);if(length<x.length)return"array should contain not more then "+f.value()+" items"}return null}),"minProperties"==a.arguments[0]&&f.setFacetValidator(function(x,f){if(x instanceof Object){var length=Number.parseInt(""+f);if(length>Object.keys(x).length)return"object should contain at least "+f.value()+" properties"}return null}),"maxProperties"==a.arguments[0]&&f.setFacetValidator(function(x,f){if(x instanceof Object){var length=Number.parseInt(""+f);if(length<Object.keys(x).length)return"object should contain not more then "+f.value()+" properties"}return null}),"uniqueItems"==a.arguments[0]&&f.setFacetValidator(function(x,f){if(f instanceof Array){var length=_.unique(f).length;if(length<f.length)return"array should contain only unique items"}return null}),"minLength"==a.arguments[0]&&f.setFacetValidator(function(x,f){if("number"!=typeof x&&"boolean"!=typeof x||(x=""+x),"string"==typeof x){var length=Number.parseInt(""+f);if(length>x.length)return"string length should be at least "+length}return null}),"maxLength"==a.arguments[0]&&f.setFacetValidator(function(x,f){if("number"!=typeof x&&"boolean"!=typeof x||(x=""+x),"string"==typeof x){var length=Number.parseInt(""+f);if(length<x.length)return"string length should be not more then "+length}return null}),"minimum"==a.arguments[0]&&f.setFacetValidator(function(x,f){if("string"==typeof x&&(x=parseFloat(x)),"number"==typeof x){var length=parseFloat(f);if(length>x)return"value should be not less then "+length}return null}),"maximum"==a.arguments[0]&&f.setFacetValidator(function(x,f){if("string"==typeof x&&(x=parseFloat(x)),"number"==typeof x){var length=parseFloat(f);if(length<x)return"value should be not more then "+length}return null}),"pattern"==a.arguments[0]&&f.setFacetValidator(function(x,f){if("number"!=typeof x&&"boolean"!=typeof x||(x=""+x),"string"==typeof x){var regExp=new RegExp(f);if(!regExp.test(x))return"string should match to "+f}return null})},extraMetaKey:function(a,f){"statusCodes"==a.arguments[0]&&(f.withOftenKeys(khttp.statusCodes.filter(function(statusCode){return statusCode.code.indexOf("x")<0}).map(function(x){return x.code})),f.setValueDocProvider(function(name){var s=_.find(khttp.statusCodes,function(x){return x.code==name});return s?name+":"+s.description:null})),"headers"==a.arguments[0]&&(f.setValueSuggester(function(x){if(x.property()){var c=x.property().getChildValueConstraints();if(_.find(c,function(x){return"location"==x.name&&"Params.ParameterLocation.HEADERS"==x.value}))return khttp.headers.map(function(x){return x.header});if(x.property()&&"headers"==x.property().nameId())return khttp.headers.map(function(x){return x.header})}return null}),f.setValueDocProvider(function(name){var s=_.find(khttp.headers,function(x){return x.header==name});return s?name+":"+s.description:null})),"methods"==a.arguments[0]&&f.setValueDocProvider(function(name){var s=_.find(khttp.methods,function(x){return x.method==name.toUpperCase()});return s?name+":"+s.description:null})},requireValue:function(a,f){f.withContextRequirement(""+a.arguments[0],""+a.arguments[1])},allowMultiple:function(a,f){f.withMultiValue(!0)},constraint:function(a,f){},newInstanceName:function(a,f){f.withNewInstanceName(""+a.arguments[0])},declaringFields:function(a,f){f.withThisPropertyDeclaresFields()},describesAnnotation:function(a,f){f.withDescribes(a.arguments[0])},allowNull:function(a,f){f.withAllowNull()},descriminatingProperty:function(a,f){f.withDescriminating(!0)},description:function(a,f){f.withDescription(""+a.arguments[0])},inherited:function(a,f){f.withInherited(!0)},selfNode:function(a,f){f.withSelfNode()},grammarTokenKind:function(a,f){f.getAdapter(services.RAMLPropertyService).withPropertyGrammarType(""+a.arguments[0])},canInherit:function(a,f){f.withInheritedContextValue(""+a.arguments[0])},canBeDuplicator:function(a,f){f.setCanBeDuplicator()},example:function(a,f){f.getAdapter(services.RAMLPropertyService).setExample(!0)},typeExpression:function(a,f){f.getAdapter(services.RAMLPropertyService).setTypeExpression(!0)},hide:function(a,f){0==a.arguments.length?f.getAdapter(services.RAMLPropertyDocumentationService).setHidden(!0):f.getAdapter(services.RAMLPropertyDocumentationService).setHidden(a.arguments[0])},documentationTableLabel:function(a,f){f.getAdapter(services.RAMLPropertyDocumentationService).setDocTableName(""+a.arguments[0])},markdownDescription:function(a,f){f.getAdapter(services.RAMLPropertyDocumentationService).setMarkdownDescription(""+a.arguments[0])},valueDescription:function(a,f){f.getAdapter(services.RAMLPropertyDocumentationService).setValueDescription(null!=a.arguments[0]?""+a.arguments[0]:null)},customHandling:function(a,f){}},exports.recordAnnotation=recordAnnotation},function(module,exports,__webpack_require__){"use strict";exports.decode=exports.parse=__webpack_require__(93),exports.encode=exports.stringify=__webpack_require__(94)},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_RESULT__;(function(module,global){!function(root){function error(type){throw RangeError(errors[type])}function map(array,fn){for(var length=array.length,result=[];length--;)result[length]=fn(array[length]);return result}function mapDomain(string,fn){var parts=string.split("@"),result="";parts.length>1&&(result=parts[0]+"@",string=parts[1]),string=string.replace(regexSeparators,".");var labels=string.split("."),encoded=map(labels,fn).join(".");return result+encoded}function ucs2decode(string){for(var value,extra,output=[],counter=0,length=string.length;counter<length;)value=string.charCodeAt(counter++),value>=55296&&value<=56319&&counter<length?(extra=string.charCodeAt(counter++),56320==(64512&extra)?output.push(((1023&value)<<10)+(1023&extra)+65536):(output.push(value),counter--)):output.push(value);return output}function ucs2encode(array){return map(array,function(value){var output="";return value>65535&&(value-=65536,output+=stringFromCharCode(value>>>10&1023|55296),value=56320|1023&value),output+=stringFromCharCode(value)}).join("")}function basicToDigit(codePoint){return codePoint-48<10?codePoint-22:codePoint-65<26?codePoint-65:codePoint-97<26?codePoint-97:base}function digitToBasic(digit,flag){return digit+22+75*(digit<26)-((0!=flag)<<5)}function adapt(delta,numPoints,firstTime){var k=0;for(delta=firstTime?floor(delta/damp):delta>>1,delta+=floor(delta/numPoints);delta>baseMinusTMin*tMax>>1;k+=base)delta=floor(delta/baseMinusTMin);return floor(k+(baseMinusTMin+1)*delta/(delta+skew))}function decode(input){var out,basic,j,index,oldi,w,k,digit,t,baseMinusT,output=[],inputLength=input.length,i=0,n=initialN,bias=initialBias;
for(basic=input.lastIndexOf(delimiter),basic<0&&(basic=0),j=0;j<basic;++j)input.charCodeAt(j)>=128&&error("not-basic"),output.push(input.charCodeAt(j));for(index=basic>0?basic+1:0;index<inputLength;){for(oldi=i,w=1,k=base;index>=inputLength&&error("invalid-input"),digit=basicToDigit(input.charCodeAt(index++)),(digit>=base||digit>floor((maxInt-i)/w))&&error("overflow"),i+=digit*w,t=k<=bias?tMin:k>=bias+tMax?tMax:k-bias,!(digit<t);k+=base)baseMinusT=base-t,w>floor(maxInt/baseMinusT)&&error("overflow"),w*=baseMinusT;out=output.length+1,bias=adapt(i-oldi,out,0==oldi),floor(i/out)>maxInt-n&&error("overflow"),n+=floor(i/out),i%=out,output.splice(i++,0,n)}return ucs2encode(output)}function encode(input){var n,delta,handledCPCount,basicLength,bias,j,m,q,k,t,currentValue,inputLength,handledCPCountPlusOne,baseMinusT,qMinusT,output=[];for(input=ucs2decode(input),inputLength=input.length,n=initialN,delta=0,bias=initialBias,j=0;j<inputLength;++j)currentValue=input[j],currentValue<128&&output.push(stringFromCharCode(currentValue));for(handledCPCount=basicLength=output.length,basicLength&&output.push(delimiter);handledCPCount<inputLength;){for(m=maxInt,j=0;j<inputLength;++j)currentValue=input[j],currentValue>=n&&currentValue<m&&(m=currentValue);for(handledCPCountPlusOne=handledCPCount+1,m-n>floor((maxInt-delta)/handledCPCountPlusOne)&&error("overflow"),delta+=(m-n)*handledCPCountPlusOne,n=m,j=0;j<inputLength;++j)if(currentValue=input[j],currentValue<n&&++delta>maxInt&&error("overflow"),currentValue==n){for(q=delta,k=base;t=k<=bias?tMin:k>=bias+tMax?tMax:k-bias,!(q<t);k+=base)qMinusT=q-t,baseMinusT=base-t,output.push(stringFromCharCode(digitToBasic(t+qMinusT%baseMinusT,0))),q=floor(qMinusT/baseMinusT);output.push(stringFromCharCode(digitToBasic(q,0))),bias=adapt(delta,handledCPCountPlusOne,handledCPCount==basicLength),delta=0,++handledCPCount}++delta,++n}return output.join("")}function toUnicode(input){return mapDomain(input,function(string){return regexPunycode.test(string)?decode(string.slice(4).toLowerCase()):string})}function toASCII(input){return mapDomain(input,function(string){return regexNonASCII.test(string)?"xn--"+encode(string):string})}var freeGlobal=("object"==typeof exports&&exports&&!exports.nodeType&&exports,"object"==typeof module&&module&&!module.nodeType&&module,"object"==typeof global&&global);freeGlobal.global!==freeGlobal&&freeGlobal.window!==freeGlobal&&freeGlobal.self!==freeGlobal||(root=freeGlobal);var punycode,maxInt=2147483647,base=36,tMin=1,tMax=26,skew=38,damp=700,initialBias=72,initialN=128,delimiter="-",regexPunycode=/^xn--/,regexNonASCII=/[^\x20-\x7E]/,regexSeparators=/[\x2E\u3002\uFF0E\uFF61]/g,errors={overflow:"Overflow: input needs wider integers to process","not-basic":"Illegal input >= 0x80 (not a basic code point)","invalid-input":"Invalid input"},baseMinusTMin=base-tMin,floor=Math.floor,stringFromCharCode=String.fromCharCode;punycode={version:"1.3.2",ucs2:{decode:ucs2decode,encode:ucs2encode},decode:decode,encode:encode,toASCII:toASCII,toUnicode:toUnicode},__WEBPACK_AMD_DEFINE_RESULT__=function(){return punycode}.call(exports,__webpack_require__,exports,module),!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__))}(this)}).call(exports,__webpack_require__(138)(module),function(){return this}())},function(module,exports,__webpack_require__){"use strict";function is_EOL(c){return 10===c||13===c}function is_WHITE_SPACE(c){return 9===c||32===c}function is_WS_OR_EOL(c){return 9===c||32===c||10===c||13===c}function is_FLOW_INDICATOR(c){return 44===c||91===c||93===c||123===c||125===c}function fromHexCode(c){var lc;return 48<=c&&c<=57?c-48:(lc=32|c,97<=lc&&lc<=102?lc-97+10:-1)}function escapedHexLen(c){return 120===c?2:117===c?4:85===c?8:0}function fromDecimalCode(c){return 48<=c&&c<=57?c-48:-1}function simpleEscapeSequence(c){return 48===c?"\0":97===c?"":98===c?"\b":116===c?"\t":9===c?"\t":110===c?"\n":118===c?"\v":102===c?"\f":114===c?"\r":101===c?"":32===c?" ":34===c?'"':47===c?"/":92===c?"\\":78===c?"":95===c?" ":76===c?"\u2028":80===c?"\u2029":""}function charFromCodepoint(c){return c<=65535?String.fromCharCode(c):String.fromCharCode((c-65536>>10)+55296,(c-65536&1023)+56320)}function generateError(state,message){return new YAMLException(message,new Mark(state.filename,state.input,state.position,state.line-1,state.position-state.lineStart))}function throwError(state,message){var error=generateError(state,message),hash=error.message+error.mark.position;state.errorMap[hash]||(state.errors.push(error),state.errorMap[hash]=1);for(var or=state.position;;){if(state.position>=state.input.length-1)return;var c=state.input.charAt(state.position);if("\n"==c)return state.position--,void(state.position==or&&(state.position+=1));if("\r"==c)return state.position--,void(state.position==or&&(state.position+=1));state.position++}}function throwWarning(state,message){var error=generateError(state,message);state.onWarning&&state.onWarning.call(null,error)}function captureSegment(state,start,end,checkJson){var _position,_length,_character,_result,scalar=state.result;if(scalar.startPosition==-1&&(scalar.startPosition=start),start<=end){if(_result=state.input.slice(start,end),checkJson)for(_position=0,_length=_result.length;_position<_length;_position+=1)_character=_result.charCodeAt(_position),9===_character||32<=_character&&_character<=1114111||throwError(state,"expected valid JSON character");scalar.value+=_result,scalar.endPosition=end}}function storeMappingPair(state,_result,keyTag,keyNode,valueNode){if(null!=keyNode){if(null===_result&&(_result={startPosition:keyNode.startPosition,endPosition:valueNode.endPosition,parent:null,errors:[],mappings:[],kind:ast.Kind.MAP}),"tag:yaml.org,2002:merge"===keyTag)throw new Error("Should not happen");var mapping=ast.newMapping(keyNode,valueNode);return mapping.parent=_result,keyNode.parent=mapping,null!=valueNode&&(valueNode.parent=mapping),_result.mappings.push(mapping),_result.endPosition=valueNode?valueNode.endPosition:keyNode.endPosition+1,_result}}function readLineBreak(state){var ch;ch=state.input.charCodeAt(state.position),10===ch?state.position++:13===ch?(state.position++,10===state.input.charCodeAt(state.position)&&state.position++):throwError(state,"a line break is expected"),state.line+=1,state.lineStart=state.position}function skipSeparationSpace(state,allowComments,checkIndent){for(var lineBreaks=0,ch=state.input.charCodeAt(state.position);0!==ch;){for(;is_WHITE_SPACE(ch);)ch=state.input.charCodeAt(++state.position);if(allowComments&&35===ch)do ch=state.input.charCodeAt(++state.position);while(10!==ch&&13!==ch&&0!==ch);if(!is_EOL(ch))break;for(readLineBreak(state),ch=state.input.charCodeAt(state.position),lineBreaks++,state.lineIndent=0;32===ch;)state.lineIndent++,ch=state.input.charCodeAt(++state.position)}return-1!==checkIndent&&0!==lineBreaks&&state.lineIndent<checkIndent&&throwWarning(state,"deficient indentation"),lineBreaks}function testDocumentSeparator(state){var ch,_position=state.position;return ch=state.input.charCodeAt(_position),!(45!==ch&&46!==ch||state.input.charCodeAt(_position+1)!==ch||state.input.charCodeAt(_position+2)!==ch||(_position+=3,ch=state.input.charCodeAt(_position),0!==ch&&!is_WS_OR_EOL(ch)))}function writeFoldedLines(state,scalar,count){1===count?scalar.value+=" ":count>1&&(scalar.value+=common.repeat("\n",count-1))}function readPlainScalar(state,nodeIndent,withinFlowCollection){var preceding,following,captureStart,captureEnd,hasPendingContent,_line,_lineStart,_lineIndent,ch,_kind=state.kind,_result=state.result,state_result=ast.newScalar();if(state_result.plainScalar=!0,state.result=state_result,ch=state.input.charCodeAt(state.position),is_WS_OR_EOL(ch)||is_FLOW_INDICATOR(ch)||35===ch||38===ch||42===ch||33===ch||124===ch||62===ch||39===ch||34===ch||37===ch||64===ch||96===ch)return!1;if((63===ch||45===ch)&&(following=state.input.charCodeAt(state.position+1),is_WS_OR_EOL(following)||withinFlowCollection&&is_FLOW_INDICATOR(following)))return!1;for(state.kind="scalar",captureStart=captureEnd=state.position,hasPendingContent=!1;0!==ch;){if(58===ch){if(following=state.input.charCodeAt(state.position+1),is_WS_OR_EOL(following)||withinFlowCollection&&is_FLOW_INDICATOR(following))break}else if(35===ch){if(preceding=state.input.charCodeAt(state.position-1),is_WS_OR_EOL(preceding))break}else{if(state.position===state.lineStart&&testDocumentSeparator(state)||withinFlowCollection&&is_FLOW_INDICATOR(ch))break;if(is_EOL(ch)){if(_line=state.line,_lineStart=state.lineStart,_lineIndent=state.lineIndent,skipSeparationSpace(state,!1,-1),state.lineIndent>=nodeIndent){hasPendingContent=!0,ch=state.input.charCodeAt(state.position);continue}state.position=captureEnd,state.line=_line,state.lineStart=_lineStart,state.lineIndent=_lineIndent;break}}if(hasPendingContent&&(captureSegment(state,captureStart,captureEnd,!1),writeFoldedLines(state,state_result,state.line-_line),captureStart=captureEnd=state.position,hasPendingContent=!1),is_WHITE_SPACE(ch)||(captureEnd=state.position+1),ch=state.input.charCodeAt(++state.position),state.position>=state.input.length)return!1}return captureSegment(state,captureStart,captureEnd,!1),state.result.startPosition!=-1||(state.kind=_kind,state.result=_result,!1)}function readSingleQuotedScalar(state,nodeIndent){var ch,captureStart,captureEnd;if(ch=state.input.charCodeAt(state.position),39!==ch)return!1;var scalar=ast.newScalar();for(state.kind="scalar",state.result=scalar,scalar.startPosition=state.position,state.position++,captureStart=captureEnd=state.position;0!==(ch=state.input.charCodeAt(state.position));)if(39===ch){if(captureSegment(state,captureStart,state.position,!0),ch=state.input.charCodeAt(++state.position),scalar.endPosition=state.position,39!==ch)return!0;captureStart=captureEnd=state.position,state.position++}else is_EOL(ch)?(captureSegment(state,captureStart,captureEnd,!0),writeFoldedLines(state,scalar,skipSeparationSpace(state,!1,nodeIndent)),captureStart=captureEnd=state.position):state.position===state.lineStart&&testDocumentSeparator(state)?throwError(state,"unexpected end of the document within a single quoted scalar"):(state.position++,captureEnd=state.position,scalar.endPosition=state.position);throwError(state,"unexpected end of the stream within a single quoted scalar")}function readDoubleQuotedScalar(state,nodeIndent){var captureStart,captureEnd,hexLength,hexResult,tmp,ch;if(ch=state.input.charCodeAt(state.position),34!==ch)return!1;state.kind="scalar";var scalar=ast.newScalar();for(scalar.doubleQuoted=!0,state.result=scalar,scalar.startPosition=state.position,state.position++,captureStart=captureEnd=state.position;0!==(ch=state.input.charCodeAt(state.position));){if(34===ch)return captureSegment(state,captureStart,state.position,!0),state.position++,scalar.endPosition=state.position,!0;if(92===ch){if(captureSegment(state,captureStart,state.position,!0),ch=state.input.charCodeAt(++state.position),is_EOL(ch))skipSeparationSpace(state,!1,nodeIndent);else if(ch<256&&simpleEscapeCheck[ch])scalar.value+=simpleEscapeMap[ch],state.position++;else if((tmp=escapedHexLen(ch))>0){for(hexLength=tmp,hexResult=0;hexLength>0;hexLength--)ch=state.input.charCodeAt(++state.position),(tmp=fromHexCode(ch))>=0?hexResult=(hexResult<<4)+tmp:throwError(state,"expected hexadecimal character");scalar.value+=charFromCodepoint(hexResult),state.position++}else throwError(state,"unknown escape sequence");captureStart=captureEnd=state.position}else is_EOL(ch)?(captureSegment(state,captureStart,captureEnd,!0),writeFoldedLines(state,scalar,skipSeparationSpace(state,!1,nodeIndent)),captureStart=captureEnd=state.position):state.position===state.lineStart&&testDocumentSeparator(state)?throwError(state,"unexpected end of the document within a double quoted scalar"):(state.position++,captureEnd=state.position)}throwError(state,"unexpected end of the stream within a double quoted scalar")}function readFlowCollection(state,nodeIndent){var _line,_result,following,terminator,isPair,isExplicitPair,isMapping,keyNode,keyTag,valueNode,ch,readNext=!0,_tag=state.tag,_anchor=state.anchor;if(ch=state.input.charCodeAt(state.position),91===ch)terminator=93,isMapping=!1,_result=ast.newItems(),_result.startPosition=state.position;else{if(123!==ch)return!1;terminator=125,isMapping=!0,_result=ast.newMap(),_result.startPosition=state.position}for(null!==state.anchor&&(_result.anchorId=state.anchor,state.anchorMap[state.anchor]=_result),ch=state.input.charCodeAt(++state.position);0!==ch;){if(skipSeparationSpace(state,!0,nodeIndent),ch=state.input.charCodeAt(state.position),ch===terminator)return state.position++,state.tag=_tag,state.anchor=_anchor,state.kind=isMapping?"mapping":"sequence",state.result=_result,_result.endPosition=state.position,!0;if(!readNext){var p=state.position;throwError(state,"missed comma between flow collection entries"),state.position=p+1}if(keyTag=keyNode=valueNode=null,isPair=isExplicitPair=!1,63===ch&&(following=state.input.charCodeAt(state.position+1),is_WS_OR_EOL(following)&&(isPair=isExplicitPair=!0,state.position++,skipSeparationSpace(state,!0,nodeIndent))),_line=state.line,composeNode(state,nodeIndent,CONTEXT_FLOW_IN,!1,!0),keyTag=state.tag,keyNode=state.result,skipSeparationSpace(state,!0,nodeIndent),ch=state.input.charCodeAt(state.position),!isExplicitPair&&state.line!==_line||58!==ch||(isPair=!0,ch=state.input.charCodeAt(++state.position),skipSeparationSpace(state,!0,nodeIndent),composeNode(state,nodeIndent,CONTEXT_FLOW_IN,!1,!0),valueNode=state.result),isMapping)storeMappingPair(state,_result,keyTag,keyNode,valueNode);else if(isPair){var mp=storeMappingPair(state,null,keyTag,keyNode,valueNode);mp.parent=_result,_result.items.push(mp)}else keyNode.parent=_result,_result.items.push(keyNode);_result.endPosition=state.position+1,skipSeparationSpace(state,!0,nodeIndent),ch=state.input.charCodeAt(state.position),44===ch?(readNext=!0,ch=state.input.charCodeAt(++state.position)):readNext=!1}throwError(state,"unexpected end of the stream within a flow collection")}function readBlockScalar(state,nodeIndent){var captureStart,folding,tmp,ch,chomping=CHOMPING_CLIP,detectedIndent=!1,textIndent=nodeIndent,emptyLines=0,atMoreIndented=!1;if(ch=state.input.charCodeAt(state.position),124===ch)folding=!1;else{if(62!==ch)return!1;folding=!0}var sc=ast.newScalar();for(state.kind="scalar",state.result=sc,sc.startPosition=state.position;0!==ch;)if(ch=state.input.charCodeAt(++state.position),43===ch||45===ch)CHOMPING_CLIP===chomping?chomping=43===ch?CHOMPING_KEEP:CHOMPING_STRIP:throwError(state,"repeat of a chomping mode identifier");else{if(!((tmp=fromDecimalCode(ch))>=0))break;0===tmp?throwError(state,"bad explicit indentation width of a block scalar; it cannot be less than one"):detectedIndent?throwError(state,"repeat of an indentation width identifier"):(textIndent=nodeIndent+tmp-1,detectedIndent=!0)}if(is_WHITE_SPACE(ch)){do ch=state.input.charCodeAt(++state.position);while(is_WHITE_SPACE(ch));if(35===ch)do ch=state.input.charCodeAt(++state.position);while(!is_EOL(ch)&&0!==ch)}for(;0!==ch;){for(readLineBreak(state),state.lineIndent=0,ch=state.input.charCodeAt(state.position);(!detectedIndent||state.lineIndent<textIndent)&&32===ch;)state.lineIndent++,ch=state.input.charCodeAt(++state.position);if(!detectedIndent&&state.lineIndent>textIndent&&(textIndent=state.lineIndent),is_EOL(ch))emptyLines++;else{if(state.lineIndent<textIndent){chomping===CHOMPING_KEEP?sc.value+=common.repeat("\n",emptyLines):chomping===CHOMPING_CLIP&&detectedIndent&&(sc.value+="\n");break}for(folding?is_WHITE_SPACE(ch)?(atMoreIndented=!0,sc.value+=common.repeat("\n",emptyLines+1)):atMoreIndented?(atMoreIndented=!1,sc.value+=common.repeat("\n",emptyLines+1)):0===emptyLines?detectedIndent&&(sc.value+=" "):sc.value+=common.repeat("\n",emptyLines):detectedIndent&&(sc.value+=common.repeat("\n",emptyLines+1)),detectedIndent=!0,emptyLines=0,captureStart=state.position;!is_EOL(ch)&&0!==ch;)ch=state.input.charCodeAt(++state.position);captureSegment(state,captureStart,state.position,!1)}}sc.endPosition=state.position;for(var i=state.position-1,needMinus=!1;;){var c=state.input[i];if("\r"==c||"\n"==c){needMinus&&i--;break}if(" "!=c&&"\t"!=c)break;i--}return sc.endPosition=i,!0}function readBlockSequence(state,nodeIndent){var _line,following,ch,_tag=state.tag,_anchor=state.anchor,_result=ast.newItems(),detected=!1;for(null!==state.anchor&&(_result.anchorId=state.anchor,state.anchorMap[state.anchor]=_result),_result.startPosition=state.position,ch=state.input.charCodeAt(state.position);0!==ch&&45===ch&&(following=state.input.charCodeAt(state.position+1),is_WS_OR_EOL(following));)if(detected=!0,state.position++,skipSeparationSpace(state,!0,-1)&&state.lineIndent<=nodeIndent)_result.items.push(null),ch=state.input.charCodeAt(state.position);else if(_line=state.line,composeNode(state,nodeIndent,CONTEXT_BLOCK_IN,!1,!0),state.result.parent=_result,_result.items.push(state.result),skipSeparationSpace(state,!0,-1),ch=state.input.charCodeAt(state.position),(state.line===_line||state.lineIndent>nodeIndent)&&0!==ch)throwError(state,"bad indentation of a sequence entry");else if(state.lineIndent<nodeIndent)break;return _result.endPosition=state.position,!!detected&&(state.tag=_tag,state.anchor=_anchor,state.kind="sequence",state.result=_result,_result.endPosition=state.position,!0)}function readBlockMapping(state,nodeIndent,flowIndent){var following,allowCompact,_line,ch,_tag=state.tag,_anchor=state.anchor,_result=ast.newMap(),keyTag=null,keyNode=null,valueNode=null,atExplicitKey=!1,detected=!1;for(_result.startPosition=state.position,null!==state.anchor&&(_result.anchorId=state.anchor,state.anchorMap[state.anchor]=_result),ch=state.input.charCodeAt(state.position);0!==ch;){if(following=state.input.charCodeAt(state.position+1),_line=state.line,63!==ch&&58!==ch||!is_WS_OR_EOL(following)){if(!composeNode(state,flowIndent,CONTEXT_FLOW_OUT,!1,!0))break;if(state.line===_line){for(ch=state.input.charCodeAt(state.position);is_WHITE_SPACE(ch);)ch=state.input.charCodeAt(++state.position);if(58===ch)ch=state.input.charCodeAt(++state.position),is_WS_OR_EOL(ch)||throwError(state,"a whitespace character is expected after the key-value separator within a block mapping"),atExplicitKey&&(storeMappingPair(state,_result,keyTag,keyNode,null),keyTag=keyNode=valueNode=null),detected=!0,atExplicitKey=!1,allowCompact=!1,keyTag=state.tag,keyNode=state.result;else{if(!detected)return state.tag=_tag,state.anchor=_anchor,!0;throwError(state,"can not read an implicit mapping pair; a colon is missed")}}else{if(!detected)return state.tag=_tag,state.anchor=_anchor,!0;for(throwError(state,"can not read a block mapping entry; a multiline key may not be an implicit key");state.position>0;)if(ch=state.input.charCodeAt(--state.position),is_EOL(ch)){state.position++;break}}}else 63===ch?(atExplicitKey&&(storeMappingPair(state,_result,keyTag,keyNode,null),keyTag=keyNode=valueNode=null),detected=!0,atExplicitKey=!0,allowCompact=!0):atExplicitKey?(atExplicitKey=!1,allowCompact=!0):throwError(state,"incomplete explicit mapping pair; a key node is missed"),state.position+=1,ch=following;if((state.line===_line||state.lineIndent>nodeIndent)&&(composeNode(state,nodeIndent,CONTEXT_BLOCK_OUT,!0,allowCompact)&&(atExplicitKey?keyNode=state.result:valueNode=state.result),atExplicitKey||(storeMappingPair(state,_result,keyTag,keyNode,valueNode),keyTag=keyNode=valueNode=null),skipSeparationSpace(state,!0,-1),ch=state.input.charCodeAt(state.position)),state.lineIndent>nodeIndent&&0!==ch)throwError(state,"bad indentation of a mapping entry");else if(state.lineIndent<nodeIndent)break}return atExplicitKey&&storeMappingPair(state,_result,keyTag,keyNode,null),detected&&(state.tag=_tag,state.anchor=_anchor,state.kind="mapping",state.result=_result),detected}function readTagProperty(state){var _position,tagHandle,tagName,ch,isVerbatim=!1,isNamed=!1;if(ch=state.input.charCodeAt(state.position),33!==ch)return!1;if(null!==state.tag&&throwError(state,"duplication of a tag property"),ch=state.input.charCodeAt(++state.position),60===ch?(isVerbatim=!0,ch=state.input.charCodeAt(++state.position)):33===ch?(isNamed=!0,tagHandle="!!",ch=state.input.charCodeAt(++state.position)):tagHandle="!",_position=state.position,isVerbatim){do ch=state.input.charCodeAt(++state.position);while(0!==ch&&62!==ch);state.position<state.length?(tagName=state.input.slice(_position,state.position),ch=state.input.charCodeAt(++state.position)):throwError(state,"unexpected end of the stream within a verbatim tag")}else{for(;0!==ch&&!is_WS_OR_EOL(ch);)33===ch&&(isNamed?throwError(state,"tag suffix cannot contain exclamation marks"):(tagHandle=state.input.slice(_position-1,state.position+1),PATTERN_TAG_HANDLE.test(tagHandle)||throwError(state,"named tag handle cannot contain such characters"),isNamed=!0,_position=state.position+1)),ch=state.input.charCodeAt(++state.position);tagName=state.input.slice(_position,state.position),PATTERN_FLOW_INDICATORS.test(tagName)&&throwError(state,"tag suffix cannot contain flow indicator characters")}return tagName&&!PATTERN_TAG_URI.test(tagName)&&throwError(state,"tag name cannot contain such characters: "+tagName),isVerbatim?state.tag=tagName:_hasOwnProperty.call(state.tagMap,tagHandle)?state.tag=state.tagMap[tagHandle]+tagName:"!"===tagHandle?state.tag="!"+tagName:"!!"===tagHandle?state.tag="tag:yaml.org,2002:"+tagName:throwError(state,'undeclared tag handle "'+tagHandle+'"'),!0}function readAnchorProperty(state){var _position,ch;if(ch=state.input.charCodeAt(state.position),38!==ch)return!1;for(null!==state.anchor&&throwError(state,"duplication of an anchor property"),ch=state.input.charCodeAt(++state.position),_position=state.position;0!==ch&&!is_WS_OR_EOL(ch)&&!is_FLOW_INDICATOR(ch);)ch=state.input.charCodeAt(++state.position);return state.position===_position&&throwError(state,"name of an anchor node must contain at least one character"),state.anchor=state.input.slice(_position,state.position),!0}function readAlias(state){var _position,alias,ch;state.length,state.input;if(ch=state.input.charCodeAt(state.position),42!==ch)return!1;for(ch=state.input.charCodeAt(++state.position),_position=state.position;0!==ch&&!is_WS_OR_EOL(ch)&&!is_FLOW_INDICATOR(ch);)ch=state.input.charCodeAt(++state.position);return state.position<=_position&&(throwError(state,"name of an alias node must contain at least one character"),state.position=_position+1),alias=state.input.slice(_position,state.position),state.anchorMap.hasOwnProperty(alias)||(throwError(state,'unidentified alias "'+alias+'"'),state.position<=_position&&(state.position=_position+1)),state.result=ast.newAnchorRef(alias,_position,state.position,state.anchorMap[alias]),skipSeparationSpace(state,!0,-1),!0}function composeNode(state,parentIndent,nodeContext,allowToSeek,allowCompact){var allowBlockStyles,allowBlockScalars,allowBlockCollections,typeIndex,typeQuantity,type,flowIndent,blockIndent,indentStatus=1,atNewLine=!1,hasContent=!1;if(state.tag=null,state.anchor=null,state.kind=null,state.result=null,allowBlockStyles=allowBlockScalars=allowBlockCollections=CONTEXT_BLOCK_OUT===nodeContext||CONTEXT_BLOCK_IN===nodeContext,allowToSeek&&skipSeparationSpace(state,!0,-1)&&(atNewLine=!0,state.lineIndent>parentIndent?indentStatus=1:state.lineIndent===parentIndent?indentStatus=0:state.lineIndent<parentIndent&&(indentStatus=-1)),1===indentStatus)for(;readTagProperty(state)||readAnchorProperty(state);)skipSeparationSpace(state,!0,-1)?(atNewLine=!0,allowBlockCollections=allowBlockStyles,state.lineIndent>parentIndent?indentStatus=1:state.lineIndent===parentIndent?indentStatus=0:state.lineIndent<parentIndent&&(indentStatus=-1)):allowBlockCollections=!1;if(allowBlockCollections&&(allowBlockCollections=atNewLine||allowCompact),1!==indentStatus&&CONTEXT_BLOCK_OUT!==nodeContext||(flowIndent=CONTEXT_FLOW_IN===nodeContext||CONTEXT_FLOW_OUT===nodeContext?parentIndent:parentIndent+1,blockIndent=state.position-state.lineStart,1===indentStatus?allowBlockCollections&&(readBlockSequence(state,blockIndent)||readBlockMapping(state,blockIndent,flowIndent))||readFlowCollection(state,flowIndent)?hasContent=!0:(allowBlockScalars&&readBlockScalar(state,flowIndent)||readSingleQuotedScalar(state,flowIndent)||readDoubleQuotedScalar(state,flowIndent)?hasContent=!0:readAlias(state)?(hasContent=!0,null===state.tag&&null===state.anchor||throwError(state,"alias node should not have any properties")):readPlainScalar(state,flowIndent,CONTEXT_FLOW_IN===nodeContext)&&(hasContent=!0,null===state.tag&&(state.tag="?")),null!==state.anchor&&(state.anchorMap[state.anchor]=state.result,state.result.anchorId=state.anchor)):0===indentStatus&&(hasContent=allowBlockCollections&&readBlockSequence(state,blockIndent))),null!==state.tag&&"!"!==state.tag)if("!include"==state.tag)state.result||(state.result=ast.newScalar(),state.result.startPosition=state.position,state.result.endPosition=state.position,throwError(state,"!include without value")),state.result.kind=ast.Kind.INCLUDE_REF;else if("?"===state.tag)for(typeIndex=0,typeQuantity=state.implicitTypes.length;typeIndex<typeQuantity;typeIndex+=1){type=state.implicitTypes[typeIndex];var vl=state.result.value;if(type.resolve(vl)){state.result.valueObject=type.construct(state.result.value),state.tag=type.tag,null!==state.anchor&&(state.result.anchorId=state.anchor,state.anchorMap[state.anchor]=state.result);break}}else _hasOwnProperty.call(state.typeMap,state.tag)?(type=state.typeMap[state.tag],null!==state.result&&type.kind!==state.kind&&throwError(state,"unacceptable node kind for !<"+state.tag+'> tag; it should be "'+type.kind+'", not "'+state.kind+'"'),type.resolve(state.result)?(state.result=type.construct(state.result),null!==state.anchor&&(state.result.anchorId=state.anchor,state.anchorMap[state.anchor]=state.result)):throwError(state,"cannot resolve a node with !<"+state.tag+"> explicit tag")):throwWarning(state,"unknown tag !<"+state.tag+">");return null!==state.tag||null!==state.anchor||hasContent}function readDocument(state){var _position,directiveName,directiveArgs,ch,documentStart=state.position,hasDirectives=!1;for(state.version=null,state.checkLineBreaks=state.legacy,state.tagMap={},state.anchorMap={};0!==(ch=state.input.charCodeAt(state.position))&&(skipSeparationSpace(state,!0,-1),ch=state.input.charCodeAt(state.position),!(state.lineIndent>0||37!==ch));){for(hasDirectives=!0,ch=state.input.charCodeAt(++state.position),_position=state.position;0!==ch&&!is_WS_OR_EOL(ch);)ch=state.input.charCodeAt(++state.position);for(directiveName=state.input.slice(_position,state.position),directiveArgs=[],directiveName.length<1&&throwError(state,"directive name must not be less than one character in length");0!==ch;){for(;is_WHITE_SPACE(ch);)ch=state.input.charCodeAt(++state.position);if(35===ch){do ch=state.input.charCodeAt(++state.position);while(0!==ch&&!is_EOL(ch));break}if(is_EOL(ch))break;for(_position=state.position;0!==ch&&!is_WS_OR_EOL(ch);)ch=state.input.charCodeAt(++state.position);directiveArgs.push(state.input.slice(_position,state.position))}0!==ch&&readLineBreak(state),_hasOwnProperty.call(directiveHandlers,directiveName)?directiveHandlers[directiveName](state,directiveName,directiveArgs):(throwWarning(state,'unknown document directive "'+directiveName+'"'),state.position++)}return skipSeparationSpace(state,!0,-1),0===state.lineIndent&&45===state.input.charCodeAt(state.position)&&45===state.input.charCodeAt(state.position+1)&&45===state.input.charCodeAt(state.position+2)?(state.position+=3,skipSeparationSpace(state,!0,-1)):hasDirectives&&throwError(state,"directives end mark is expected"),composeNode(state,state.lineIndent-1,CONTEXT_BLOCK_OUT,!1,!0),skipSeparationSpace(state,!0,-1),state.checkLineBreaks&&PATTERN_NON_ASCII_LINE_BREAKS.test(state.input.slice(documentStart,state.position))&&throwWarning(state,"non-ASCII line breaks are interpreted as content"),state.documents.push(state.result),state.position===state.lineStart&&testDocumentSeparator(state)?void(46===state.input.charCodeAt(state.position)&&(state.position+=3,skipSeparationSpace(state,!0,-1))):void(state.position<state.length-1&&throwError(state,"end of the stream or a document separator is expected"))}function loadDocuments(input,options){input=String(input),options=options||{},0!==input.length&&(10!==input.charCodeAt(input.length-1)&&13!==input.charCodeAt(input.length-1)&&(input+="\n"),65279===input.charCodeAt(0)&&(input=input.slice(1)));var state=new State(input,options);for(PATTERN_NON_PRINTABLE.test(state.input)&&throwError(state,"the stream contains non-printable characters"),state.input+="\0";32===state.input.charCodeAt(state.position);)state.lineIndent+=1,state.position+=1;for(;state.position<state.length-1;){var q=state.position;if(readDocument(state),state.position<=q)for(;state.position<state.length-1;state.position++){var c=state.input.charAt(state.position);if("\n"==c)break}}return state.documents.forEach(function(x){return x.errors=state.errors}),state.documents}function loadAll(input,iterator,options){var index,length,documents=loadDocuments(input,options);for(index=0,length=documents.length;index<length;index+=1)iterator(documents[index])}function load(input,options){var documents=loadDocuments(input,options);if(0!==documents.length){if(1===documents.length){var result=documents[0];return result.endPosition=input.length,result.startPosition>result.endPosition&&(result.startPosition=result.endPosition),result}var e=new YAMLException("expected a single document in the stream, but found more");return e.mark=new Mark("","",0,0,0),e.mark.position=documents[0].endPosition,documents[0].errors.push(e),documents[0]}}function safeLoadAll(input,output,options){loadAll(input,output,common.extend({schema:DEFAULT_SAFE_SCHEMA},options))}function safeLoad(input,options){return load(input,common.extend({schema:DEFAULT_SAFE_SCHEMA},options))}for(var ast=__webpack_require__(99),common=__webpack_require__(97),YAMLException=__webpack_require__(98),Mark=__webpack_require__(100),DEFAULT_SAFE_SCHEMA=__webpack_require__(117),DEFAULT_FULL_SCHEMA=__webpack_require__(116),_hasOwnProperty=Object.prototype.hasOwnProperty,CONTEXT_FLOW_IN=1,CONTEXT_FLOW_OUT=2,CONTEXT_BLOCK_IN=3,CONTEXT_BLOCK_OUT=4,CHOMPING_CLIP=1,CHOMPING_STRIP=2,CHOMPING_KEEP=3,PATTERN_NON_PRINTABLE=/[\x00-\x08\x0B\x0C\x0E-\x1F\x7F-\x84\x86-\x9F\uD800-\uDFFF\uFFFE\uFFFF]/,PATTERN_NON_ASCII_LINE_BREAKS=/[\x85\u2028\u2029]/,PATTERN_FLOW_INDICATORS=/[,\[\]\{\}]/,PATTERN_TAG_HANDLE=/^(?:!|!!|![a-z\-]+!)$/i,PATTERN_TAG_URI=/^(?:!|[^,\[\]\{\}])(?:%[0-9a-f]{2}|[0-9a-z\-#;\/\?:@&=\+\$,_\.!~\*'\(\)\[\]])*$/i,simpleEscapeCheck=new Array(256),simpleEscapeMap=new Array(256),i=0;i<256;i++)simpleEscapeCheck[i]=simpleEscapeSequence(i)?1:0,simpleEscapeMap[i]=simpleEscapeSequence(i);var State=function(){function State(input,options){this.errorMap={},this.errors=[],this.input=input,this.filename=options.filename||null,this.schema=options.schema||DEFAULT_FULL_SCHEMA,this.onWarning=options.onWarning||null,this.legacy=options.legacy||!1,this.implicitTypes=this.schema.compiledImplicit,this.typeMap=this.schema.compiledTypeMap,this.length=input.length,this.position=0,this.line=0,this.lineStart=0,this.lineIndent=0,this.documents=[]}return State}(),directiveHandlers={YAML:function(state,name,args){var match,major,minor;null!==state.version&&throwError(state,"duplication of %YAML directive"),1!==args.length&&throwError(state,"YAML directive accepts exactly one argument"),match=/^([0-9]+)\.([0-9]+)$/.exec(args[0]),null===match&&throwError(state,"ill-formed argument of the YAML directive"),major=parseInt(match[1],10),minor=parseInt(match[2],10),1!==major&&throwError(state,"found incompatible YAML document (version 1.2 is required)"),state.version=args[0],state.checkLineBreaks=minor<2,2!==minor&&throwError(state,"found incompatible YAML document (version 1.2 is required)")},TAG:function(state,name,args){var handle,prefix;2!==args.length&&throwError(state,"TAG directive accepts exactly two arguments"),
handle=args[0],prefix=args[1],PATTERN_TAG_HANDLE.test(handle)||throwError(state,"ill-formed tag handle (first argument) of the TAG directive"),_hasOwnProperty.call(state.tagMap,handle)&&throwError(state,'there is a previously declared suffix for "'+handle+'" tag handle'),PATTERN_TAG_URI.test(prefix)||throwError(state,"ill-formed tag prefix (second argument) of the TAG directive"),state.tagMap[handle]=prefix}};exports.loadAll=loadAll,exports.load=load,exports.safeLoadAll=safeLoadAll,exports.safeLoad=safeLoad,module.exports.loadAll=loadAll,module.exports.load=load,module.exports.safeLoadAll=safeLoadAll,module.exports.safeLoad=safeLoad},function(module,exports,__webpack_require__){"use strict";function compileStyleMap(schema,map){var result,keys,index,length,tag,style,type;if(null===map)return{};for(result={},keys=Object.keys(map),index=0,length=keys.length;index<length;index+=1)tag=keys[index],style=String(map[tag]),"!!"===tag.slice(0,2)&&(tag="tag:yaml.org,2002:"+tag.slice(2)),type=schema.compiledTypeMap[tag],type&&_hasOwnProperty.call(type.styleAliases,style)&&(style=type.styleAliases[style]),result[tag]=style;return result}function encodeHex(character){var string,handle,length;if(string=character.toString(16).toUpperCase(),character<=255)handle="x",length=2;else if(character<=65535)handle="u",length=4;else{if(!(character<=4294967295))throw new YAMLException("code point within a string may not be greater than 0xFFFFFFFF");handle="U",length=8}return"\\"+handle+common.repeat("0",length-string.length)+string}function State(options){this.schema=options.schema||DEFAULT_FULL_SCHEMA,this.indent=Math.max(1,options.indent||2),this.skipInvalid=options.skipInvalid||!1,this.flowLevel=common.isNothing(options.flowLevel)?-1:options.flowLevel,this.styleMap=compileStyleMap(this.schema,options.styles||null),this.implicitTypes=this.schema.compiledImplicit,this.explicitTypes=this.schema.compiledExplicit,this.tag=null,this.result="",this.duplicates=[],this.usedDuplicates=null}function indentString(string,spaces){for(var line,ind=common.repeat(" ",spaces),position=0,next=-1,result="",length=string.length;position<length;)next=string.indexOf("\n",position),next===-1?(line=string.slice(position),position=length):(line=string.slice(position,next+1),position=next+1),line.length&&"\n"!==line&&(result+=ind),result+=line;return result}function generateNextLine(state,level){return"\n"+common.repeat(" ",state.indent*level)}function testImplicitResolving(state,str){var index,length,type;for(index=0,length=state.implicitTypes.length;index<length;index+=1)if(type=state.implicitTypes[index],type.resolve(str))return!0;return!1}function StringBuilder(source){this.source=source,this.result="",this.checkpoint=0}function writeScalar(state,object,level){var simple,first,spaceWrap,folded,literal,single,double,sawLineFeed,linePosition,longestLine,indent,max,character,position,escapeSeq,hexEsc,previous,lineLength,modifier,trailingLineBreaks,result;if(0===object.length)return void(state.dump="''");if(0==object.indexOf("!include"))return void(state.dump=""+object);if(0==object.indexOf("!$$$novalue"))return void(state.dump="");if(-1!==DEPRECATED_BOOLEANS_SYNTAX.indexOf(object))return void(state.dump="'"+object+"'");for(simple=!0,first=object.length?object.charCodeAt(0):0,spaceWrap=CHAR_SPACE===first||CHAR_SPACE===object.charCodeAt(object.length-1),CHAR_MINUS!==first&&CHAR_QUESTION!==first&&CHAR_COMMERCIAL_AT!==first&&CHAR_GRAVE_ACCENT!==first||(simple=!1),spaceWrap?(simple=!1,folded=!1,literal=!1):(folded=!0,literal=!0),single=!0,double=new StringBuilder(object),sawLineFeed=!1,linePosition=0,longestLine=0,indent=state.indent*level,max=80,indent<40?max-=indent:max=40,position=0;position<object.length;position++){if(character=object.charCodeAt(position),simple){if(simpleChar(character))continue;simple=!1}single&&character===CHAR_SINGLE_QUOTE&&(single=!1),escapeSeq=ESCAPE_SEQUENCES[character],hexEsc=needsHexEscape(character),(escapeSeq||hexEsc)&&(character!==CHAR_LINE_FEED&&character!==CHAR_DOUBLE_QUOTE&&character!==CHAR_SINGLE_QUOTE?(folded=!1,literal=!1):character===CHAR_LINE_FEED&&(sawLineFeed=!0,single=!1,position>0&&(previous=object.charCodeAt(position-1),previous===CHAR_SPACE&&(literal=!1,folded=!1)),folded&&(lineLength=position-linePosition,linePosition=position,lineLength>longestLine&&(longestLine=lineLength))),character!==CHAR_DOUBLE_QUOTE&&(single=!1),double.takeUpTo(position),double.escapeChar())}if(simple&&testImplicitResolving(state,object)&&(simple=!1),modifier="",(folded||literal)&&(trailingLineBreaks=0,object.charCodeAt(object.length-1)===CHAR_LINE_FEED&&(trailingLineBreaks+=1,object.charCodeAt(object.length-2)===CHAR_LINE_FEED&&(trailingLineBreaks+=1)),0===trailingLineBreaks?modifier="-":2===trailingLineBreaks&&(modifier="+")),literal&&longestLine<max&&(folded=!1),sawLineFeed||(literal=!1),simple)state.dump=object;else if(single)state.dump="'"+object+"'";else if(folded)result=fold(object,max),state.dump=">"+modifier+"\n"+indentString(result,indent);else if(literal)modifier||(object=object.replace(/\n$/,"")),state.dump="|"+modifier+"\n"+indentString(object,indent);else{if(!double)throw new Error("Failed to dump scalar value");double.finish(),state.dump='"'+double.result+'"'}}function fold(object,max){var newLine,result="",position=0,length=object.length,trailing=/\n+$/.exec(object);for(trailing&&(length=trailing.index+1);position<length;)newLine=object.indexOf("\n",position),newLine>length||newLine===-1?(result&&(result+="\n\n"),result+=foldLine(object.slice(position,length),max),position=length):(result&&(result+="\n\n"),result+=foldLine(object.slice(position,newLine),max),position=newLine+1);return trailing&&"\n"!==trailing[0]&&(result+=trailing[0]),result}function foldLine(line,max){if(""===line)return line;for(var index,foldEnd,folded,foldRe=/[^\s] [^\s]/g,result="",prevMatch=0,foldStart=0,match=foldRe.exec(line);match;)index=match.index,index-foldStart>max&&(foldEnd=prevMatch!==foldStart?prevMatch:index,result&&(result+="\n"),folded=line.slice(foldStart,foldEnd),result+=folded,foldStart=foldEnd+1),prevMatch=index+1,match=foldRe.exec(line);return result&&(result+="\n"),result+=foldStart!==prevMatch&&line.length-foldStart>max?line.slice(foldStart,prevMatch)+"\n"+line.slice(prevMatch+1):line.slice(foldStart)}function simpleChar(character){return CHAR_TAB!==character&&CHAR_LINE_FEED!==character&&CHAR_CARRIAGE_RETURN!==character&&CHAR_COMMA!==character&&CHAR_LEFT_SQUARE_BRACKET!==character&&CHAR_RIGHT_SQUARE_BRACKET!==character&&CHAR_LEFT_CURLY_BRACKET!==character&&CHAR_RIGHT_CURLY_BRACKET!==character&&CHAR_SHARP!==character&&CHAR_AMPERSAND!==character&&CHAR_ASTERISK!==character&&CHAR_EXCLAMATION!==character&&CHAR_VERTICAL_LINE!==character&&CHAR_GREATER_THAN!==character&&CHAR_SINGLE_QUOTE!==character&&CHAR_DOUBLE_QUOTE!==character&&CHAR_PERCENT!==character&&CHAR_COLON!==character&&!ESCAPE_SEQUENCES[character]&&!needsHexEscape(character)}function needsHexEscape(character){return!(32<=character&&character<=126||133===character||160<=character&&character<=55295||57344<=character&&character<=65533||65536<=character&&character<=1114111)}function writeFlowSequence(state,level,object){var index,length,_result="",_tag=state.tag;for(index=0,length=object.length;index<length;index+=1)writeNode(state,level,object[index],!1,!1)&&(0!==index&&(_result+=", "),_result+=state.dump);state.tag=_tag,state.dump="["+_result+"]"}function writeBlockSequence(state,level,object,compact){var index,length,_result="",_tag=state.tag;for(index=0,length=object.length;index<length;index+=1)writeNode(state,level+1,object[index],!0,!0)&&(compact&&0===index||(_result+=generateNextLine(state,level)),_result+="- "+state.dump);state.tag=_tag,state.dump=_result||"[]"}function writeFlowMapping(state,level,object){var index,length,objectKey,objectValue,pairBuffer,_result="",_tag=state.tag,objectKeyList=Object.keys(object);for(index=0,length=objectKeyList.length;index<length;index+=1)pairBuffer="",0!==index&&(pairBuffer+=", "),objectKey=objectKeyList[index],objectValue=object[objectKey],writeNode(state,level,objectKey,!1,!1)&&(state.dump.length>1024&&(pairBuffer+="? "),pairBuffer+=state.dump+": ",writeNode(state,level,objectValue,!1,!1)&&(pairBuffer+=state.dump,_result+=pairBuffer));state.tag=_tag,state.dump="{"+_result+"}"}function writeBlockMapping(state,level,object,compact){var index,length,objectKey,objectValue,explicitPair,pairBuffer,_result="",_tag=state.tag,objectKeyList=Object.keys(object);for(index=0,length=objectKeyList.length;index<length;index+=1)pairBuffer="",compact&&0===index||(pairBuffer+=generateNextLine(state,level)),objectKey=objectKeyList[index],objectValue=object[objectKey],writeNode(state,level+1,objectKey,!0,!0)&&(explicitPair=null!==state.tag&&"?"!==state.tag||state.dump&&state.dump.length>1024,explicitPair&&(pairBuffer+=state.dump&&CHAR_LINE_FEED===state.dump.charCodeAt(0)?"?":"? "),pairBuffer+=state.dump,explicitPair&&(pairBuffer+=generateNextLine(state,level)),writeNode(state,level+1,objectValue,!0,explicitPair)&&(pairBuffer+=state.dump&&CHAR_LINE_FEED===state.dump.charCodeAt(0)?":":": ",pairBuffer+=state.dump,_result+=pairBuffer));state.tag=_tag,state.dump=_result||"{}"}function detectType(state,object,explicit){var _result,typeList,index,length,type,style;for(typeList=explicit?state.explicitTypes:state.implicitTypes,index=0,length=typeList.length;index<length;index+=1)if(type=typeList[index],(type.instanceOf||type.predicate)&&(!type.instanceOf||"object"==typeof object&&object instanceof type.instanceOf)&&(!type.predicate||type.predicate(object))){if(state.tag=explicit?type.tag:"?",type.represent){if(style=state.styleMap[type.tag]||type.defaultStyle,"[object Function]"===_toString.call(type.represent))_result=type.represent(object,style);else{if(!_hasOwnProperty.call(type.represent,style))throw new YAMLException("!<"+type.tag+'> tag resolver accepts not "'+style+'" style');_result=type.represent[style](object,style)}state.dump=_result}return!0}return!1}function writeNode(state,level,object,block,compact){state.tag=null,state.dump=object,detectType(state,object,!1)||detectType(state,object,!0);var type=_toString.call(state.dump);block&&(block=0>state.flowLevel||state.flowLevel>level),(null!==state.tag&&"?"!==state.tag||2!==state.indent&&level>0)&&(compact=!1);var duplicateIndex,duplicate,objectOrArray="[object Object]"===type||"[object Array]"===type;if(objectOrArray&&(duplicateIndex=state.duplicates.indexOf(object),duplicate=duplicateIndex!==-1),duplicate&&state.usedDuplicates[duplicateIndex])state.dump="*ref_"+duplicateIndex;else{if(objectOrArray&&duplicate&&!state.usedDuplicates[duplicateIndex]&&(state.usedDuplicates[duplicateIndex]=!0),"[object Object]"===type)block&&0!==Object.keys(state.dump).length?(writeBlockMapping(state,level,state.dump,compact),duplicate&&(state.dump="&ref_"+duplicateIndex+(0===level?"\n":"")+state.dump)):(writeFlowMapping(state,level,state.dump),duplicate&&(state.dump="&ref_"+duplicateIndex+" "+state.dump));else if("[object Array]"===type)block&&0!==state.dump.length?(writeBlockSequence(state,level,state.dump,compact),duplicate&&(state.dump="&ref_"+duplicateIndex+(0===level?"\n":"")+state.dump)):(writeFlowSequence(state,level,state.dump),duplicate&&(state.dump="&ref_"+duplicateIndex+" "+state.dump));else{if("[object String]"!==type){if(state.skipInvalid)return!1;throw new YAMLException("unacceptable kind of an object to dump "+type)}"?"!==state.tag&&writeScalar(state,state.dump,level)}null!==state.tag&&"?"!==state.tag&&(state.dump="!<"+state.tag+"> "+state.dump)}return!0}function getDuplicateReferences(object,state){var index,length,objects=[],duplicatesIndexes=[];for(inspectNode(object,objects,duplicatesIndexes),index=0,length=duplicatesIndexes.length;index<length;index+=1)state.duplicates.push(objects[duplicatesIndexes[index]]);state.usedDuplicates=new Array(length)}function inspectNode(object,objects,duplicatesIndexes){var objectKeyList,index,length;_toString.call(object);if(null!==object&&"object"==typeof object)if(index=objects.indexOf(object),-1!==index)-1===duplicatesIndexes.indexOf(index)&&duplicatesIndexes.push(index);else if(objects.push(object),Array.isArray(object))for(index=0,length=object.length;index<length;index+=1)inspectNode(object[index],objects,duplicatesIndexes);else for(objectKeyList=Object.keys(object),index=0,length=objectKeyList.length;index<length;index+=1)inspectNode(object[objectKeyList[index]],objects,duplicatesIndexes)}function dump(input,options){options=options||{};var state=new State(options);return getDuplicateReferences(input,state),writeNode(state,0,input,!0,!0)?state.dump+"\n":""}function safeDump(input,options){return dump(input,common.extend({schema:DEFAULT_SAFE_SCHEMA},options))}var common=__webpack_require__(97),YAMLException=__webpack_require__(98),DEFAULT_FULL_SCHEMA=__webpack_require__(116),DEFAULT_SAFE_SCHEMA=__webpack_require__(117),_toString=Object.prototype.toString,_hasOwnProperty=Object.prototype.hasOwnProperty,CHAR_TAB=9,CHAR_LINE_FEED=10,CHAR_CARRIAGE_RETURN=13,CHAR_SPACE=32,CHAR_EXCLAMATION=33,CHAR_DOUBLE_QUOTE=34,CHAR_SHARP=35,CHAR_PERCENT=37,CHAR_AMPERSAND=38,CHAR_SINGLE_QUOTE=39,CHAR_ASTERISK=42,CHAR_COMMA=44,CHAR_MINUS=45,CHAR_COLON=58,CHAR_GREATER_THAN=62,CHAR_QUESTION=63,CHAR_COMMERCIAL_AT=64,CHAR_LEFT_SQUARE_BRACKET=91,CHAR_RIGHT_SQUARE_BRACKET=93,CHAR_GRAVE_ACCENT=96,CHAR_LEFT_CURLY_BRACKET=123,CHAR_VERTICAL_LINE=124,CHAR_RIGHT_CURLY_BRACKET=125,ESCAPE_SEQUENCES={};ESCAPE_SEQUENCES[0]="\\0",ESCAPE_SEQUENCES[7]="\\a",ESCAPE_SEQUENCES[8]="\\b",ESCAPE_SEQUENCES[9]="\\t",ESCAPE_SEQUENCES[10]="\\n",ESCAPE_SEQUENCES[11]="\\v",ESCAPE_SEQUENCES[12]="\\f",ESCAPE_SEQUENCES[13]="\\r",ESCAPE_SEQUENCES[27]="\\e",ESCAPE_SEQUENCES[34]='\\"',ESCAPE_SEQUENCES[92]="\\\\",ESCAPE_SEQUENCES[133]="\\N",ESCAPE_SEQUENCES[160]="\\_",ESCAPE_SEQUENCES[8232]="\\L",ESCAPE_SEQUENCES[8233]="\\P";var DEPRECATED_BOOLEANS_SYNTAX=["y","Y","yes","Yes","YES","on","On","ON","n","N","no","No","NO","off","Off","OFF"];StringBuilder.prototype.takeUpTo=function(position){var er;if(position<this.checkpoint)throw er=new Error("position should be > checkpoint"),er.position=position,er.checkpoint=this.checkpoint,er;return this.result+=this.source.slice(this.checkpoint,position),this.checkpoint=position,this},StringBuilder.prototype.escapeChar=function(){var character,esc;return character=this.source.charCodeAt(this.checkpoint),esc=ESCAPE_SEQUENCES[character]||encodeHex(character),this.result+=esc,this.checkpoint+=1,this},StringBuilder.prototype.finish=function(){this.source.length>this.checkpoint&&this.takeUpTo(this.source.length)},exports.dump=dump,exports.safeDump=safeDump},function(module,exports,__webpack_require__){"use strict";function getSchemaUtils(){return schemaUtil}function isParsedType(object){return object instanceof ts.AbstractType}function loadTypeCollection(data,registry){return void 0===registry&&(registry=ts.builtInRegistry()),tc.parseJSONTypeCollection(data,registry)}function loadType(data){return tc.parseJSON(null,data,ts.builtInRegistry())}function parse(data){return data.types||data.annotationTypes?tc.parseJSONTypeCollection(data):tc.parseJSON(null,data)}function parseType(data,collection){return tc.parseJSON(null,data,collection?collection.getTypeRegistry():ts.builtInRegistry())}function parseFromAST(data){return tc.parseTypeCollection(data,ts.builtInRegistry())}function parseTypeFromAST(name,data,collection,defaultsToAny,annotation,global,ignoreTypeAttr){return void 0===defaultsToAny&&(defaultsToAny=!1),void 0===annotation&&(annotation=!1),void 0===global&&(global=!0),void 0===ignoreTypeAttr&&(ignoreTypeAttr=!1),tc.parse(name,data,collection?collection.getTypeRegistry():ts.builtInRegistry(),defaultsToAny,annotation,global,ignoreTypeAttr)}function dump(ts){return tc.storeAsJSON(ts)}function validate(i,t,autoClose){void 0===autoClose&&(autoClose=!1),ts.autoCloseFlag=autoClose;try{return t.validate(i,autoClose)}finally{ts.autoCloseFlag=!1}}function validateTypeDefinition(t,collection){return t.validateType(collection.getAnnotationTypeRegistry())}function performAC(i,t){return t.ac(i)}function checkACStatus(t){return t.canDoAc()}function builtInFacets(){return fr.getInstance().allPrototypes()}function builtInTypes(){return ts.builtInRegistry()}function derive(name){for(var types=[],_i=1;_i<arguments.length;_i++)types[_i-1]=arguments[_i];return ts.derive(name,types)}function unify(name){for(var types=[],_i=1;_i<arguments.length;_i++)types[_i-1]=arguments[_i];return ts.union(name,types)}function setPropertyConstructor(c){nm.setPropertyConstructor(c)}function toNominal(t,bt){return nm.toNominal(t,bt)}var ts=__webpack_require__(103);exports.tsInterfaces=__webpack_require__(104);var tc=__webpack_require__(105),fr=__webpack_require__(106),restrictions_1=__webpack_require__(107),metainfo_1=__webpack_require__(108),metainfo_2=__webpack_require__(108),metainfo_3=__webpack_require__(108),nm=__webpack_require__(109);exports.nominalTypes=__webpack_require__(110),exports.nominalInterfaces=__webpack_require__(111),exports.typeExpressions=__webpack_require__(112);var schemaUtil=__webpack_require__(113);exports.TOP_LEVEL_EXTRA=exports.tsInterfaces.TOP_LEVEL_EXTRA,exports.DEFINED_IN_TYPES_EXTRA=exports.tsInterfaces.DEFINED_IN_TYPES_EXTRA,exports.USER_DEFINED_EXTRA=exports.tsInterfaces.USER_DEFINED_EXTRA,exports.SOURCE_EXTRA=exports.tsInterfaces.SOURCE_EXTRA,exports.getSchemaUtils=getSchemaUtils,exports.isParsedType=isParsedType,exports.loadTypeCollection=loadTypeCollection,exports.loadType=loadType,exports.parse=parse,exports.parseType=parseType,function(NodeKind){NodeKind[NodeKind.SCALAR=0]="SCALAR",NodeKind[NodeKind.ARRAY=1]="ARRAY",NodeKind[NodeKind.MAP=2]="MAP"}(exports.NodeKind||(exports.NodeKind={}));exports.NodeKind;exports.parseFromAST=parseFromAST,exports.parseTypeFromAST=parseTypeFromAST,exports.dump=dump,exports.validate=validate,exports.validateTypeDefinition=validateTypeDefinition,exports.performAC=performAC,exports.checkACStatus=checkACStatus,exports.builtInFacets=builtInFacets,exports.builtInTypes=builtInTypes,exports.derive=derive,exports.unify=unify;var TypeConstructor=function(){function TypeConstructor(target){this.target=target}return TypeConstructor.prototype.addProperty=function(name,type,optional){return this.target.declareProperty(name,type,optional),this},TypeConstructor.prototype.closeType=function(){return this.target.addMeta(new restrictions_1.KnownPropertyRestriction((!1))),this},TypeConstructor.prototype.annotate=function(name,value){return this.target.addMeta(new metainfo_1.Annotation(name,value)),this},TypeConstructor.prototype.customFacet=function(name,value){return this.target.addMeta(new metainfo_2.CustomFacet(name,value)),this},TypeConstructor.prototype.customFacetDeclaration=function(name,value,optional){return void 0===optional&&(optional=!0),this.target.addMeta(new metainfo_3.FacetDeclaration(name,value,optional)),this},TypeConstructor.prototype.addSimpleFacet=function(name,value){return this.target.addMeta(fr.getInstance().buildFacet(name,value)),this},TypeConstructor.prototype.getResult=function(){return this.target},TypeConstructor}();exports.TypeConstructor=TypeConstructor,exports.setPropertyConstructor=setPropertyConstructor,exports.toNominal=toNominal},function(module,exports,__webpack_require__){function XMLReader(){}function parse(source,defaultNSMapCopy,entityMap,domBuilder,errorHandler){function fixedFromCharCode(code){if(code>65535){code-=65536;var surrogate1=55296+(code>>10),surrogate2=56320+(1023&code);return String.fromCharCode(surrogate1,surrogate2)}return String.fromCharCode(code)}function entityReplacer(a){var k=a.slice(1,-1);return k in entityMap?entityMap[k]:"#"===k.charAt(0)?fixedFromCharCode(parseInt(k.substr(1).replace("x","0x"))):(errorHandler.error("entity not found:"+a),a)}function appendText(end){if(end>start){var xt=source.substring(start,end).replace(/&#?\w+;/g,entityReplacer);locator&&position(start),domBuilder.characters(xt,0,end-start),start=end}}function position(p,m){for(;p>=lineEnd&&(m=linePattern.exec(source));)lineStart=m.index,lineEnd=lineStart+m[0].length,locator.lineNumber++;locator.columnNumber=p-lineStart+1}for(var lineStart=0,lineEnd=0,linePattern=/.+(?:\r\n?|\n)|.*$/g,locator=domBuilder.locator,parseStack=[{currentNSMap:defaultNSMapCopy}],closeMap={},start=0;;){try{var tagStart=source.indexOf("<",start);if(tagStart<0){if(!source.substr(start).match(/^\s*$/)){var doc=domBuilder.document,text=doc.createTextNode(source.substr(start));doc.appendChild(text),domBuilder.currentElement=text}return}switch(tagStart>start&&appendText(tagStart),source.charAt(tagStart+1)){case"/":var end=source.indexOf(">",tagStart+3),tagName=source.substring(tagStart+2,end),config=parseStack.pop(),localNSMap=config.localNSMap;if(config.tagName!=tagName&&errorHandler.fatalError("end tag name: "+tagName+" is not match the current start tagName:"+config.tagName),domBuilder.endElement(config.uri,config.localName,tagName),localNSMap)for(var prefix in localNSMap)domBuilder.endPrefixMapping(prefix);end++;break;case"?":locator&&position(tagStart),end=parseInstruction(source,tagStart,domBuilder);break;case"!":locator&&position(tagStart),end=parseDCC(source,tagStart,domBuilder,errorHandler);break;default:locator&&position(tagStart);var el=new ElementAttributes,end=parseElementStartPart(source,tagStart,el,entityReplacer,errorHandler),len=el.length;if(locator){if(len)for(var i=0;i<len;i++){var a=el[i];position(a.offset),a.offset=copyLocator(locator,{})}position(end)}!el.closed&&fixSelfClosed(source,end,el.tagName,closeMap)&&(el.closed=!0,entityMap.nbsp||errorHandler.warning("unclosed xml attribute")),appendElement(el,domBuilder,parseStack),"http://www.w3.org/1999/xhtml"!==el.uri||el.closed?end++:end=parseHtmlSpecialContent(source,end,el.tagName,entityReplacer,domBuilder)}}catch(e){errorHandler.error("element parse error: "+e),end=-1}end>start?start=end:appendText(Math.max(tagStart,start)+1)}}function copyLocator(f,t){return t.lineNumber=f.lineNumber,t.columnNumber=f.columnNumber,t}function parseElementStartPart(source,start,el,entityReplacer,errorHandler){for(var attrName,value,p=++start,s=S_TAG;;){var c=source.charAt(p);switch(c){case"=":if(s===S_ATTR)attrName=source.slice(start,p),s=S_EQ;else{if(s!==S_ATTR_S)throw new Error("attribute equal must after attrName");s=S_EQ}break;case"'":case'"':if(s===S_EQ){if(start=p+1,p=source.indexOf(c,start),!(p>0))throw new Error("attribute value no end '"+c+"' match");value=source.slice(start,p).replace(/&#?\w+;/g,entityReplacer),el.add(attrName,value,start-1),s=S_E}else{if(s!=S_V)throw new Error('attribute value must after "="');value=source.slice(start,p).replace(/&#?\w+;/g,entityReplacer),el.add(attrName,value,start),errorHandler.warning('attribute "'+attrName+'" missed start quot('+c+")!!"),start=p+1,s=S_E}break;case"/":switch(s){case S_TAG:el.setTagName(source.slice(start,p));case S_E:case S_S:case S_C:s=S_C,el.closed=!0;case S_V:case S_ATTR:case S_ATTR_S:break;default:throw new Error("attribute invalid close char('/')")}break;case"":errorHandler.error("unexpected end of input");case">":switch(s){case S_TAG:el.setTagName(source.slice(start,p));case S_E:case S_S:case S_C:break;case S_V:case S_ATTR:value=source.slice(start,p),"/"===value.slice(-1)&&(el.closed=!0,value=value.slice(0,-1));case S_ATTR_S:s===S_ATTR_S&&(value=attrName),s==S_V?(errorHandler.warning('attribute "'+value+'" missed quot(")!!'),el.add(attrName,value.replace(/&#?\w+;/g,entityReplacer),start)):(errorHandler.warning('attribute "'+value+'" missed value!! "'+value+'" instead!!'),el.add(value,value,start));break;case S_EQ:throw new Error("attribute value missed!!")}return p;case"":c=" ";default:if(c<=" ")switch(s){case S_TAG:el.setTagName(source.slice(start,p)),s=S_S;break;case S_ATTR:attrName=source.slice(start,p),s=S_ATTR_S;break;case S_V:var value=source.slice(start,p).replace(/&#?\w+;/g,entityReplacer);errorHandler.warning('attribute "'+value+'" missed quot(")!!'),el.add(attrName,value,start);case S_E:s=S_S}else switch(s){case S_ATTR_S:errorHandler.warning('attribute "'+attrName+'" missed value!! "'+attrName+'" instead!!'),el.add(attrName,attrName,start),start=p,s=S_ATTR;break;case S_E:errorHandler.warning('attribute space is required"'+attrName+'"!!');case S_S:s=S_ATTR,start=p;break;case S_EQ:s=S_V,start=p;break;case S_C:throw new Error("elements closed character '/' and '>' must be connected to")}}p++}}function appendElement(el,domBuilder,parseStack){for(var tagName=el.tagName,localNSMap=null,currentNSMap=parseStack[parseStack.length-1].currentNSMap,i=el.length;i--;){var a=el[i],qName=a.qName,value=a.value,nsp=qName.indexOf(":");if(nsp>0)var prefix=a.prefix=qName.slice(0,nsp),localName=qName.slice(nsp+1),nsPrefix="xmlns"===prefix&&localName;else localName=qName,prefix=null,nsPrefix="xmlns"===qName&&"";a.localName=localName,nsPrefix!==!1&&(null==localNSMap&&(localNSMap={},_copy(currentNSMap,currentNSMap={})),currentNSMap[nsPrefix]=localNSMap[nsPrefix]=value,a.uri="http://www.w3.org/2000/xmlns/",domBuilder.startPrefixMapping(nsPrefix,value))}for(var i=el.length;i--;){a=el[i];var prefix=a.prefix;prefix&&("xml"===prefix&&(a.uri="http://www.w3.org/XML/1998/namespace"),"xmlns"!==prefix&&(a.uri=currentNSMap[prefix]))}var nsp=tagName.indexOf(":");nsp>0?(prefix=el.prefix=tagName.slice(0,nsp),localName=el.localName=tagName.slice(nsp+1)):(prefix=null,localName=el.localName=tagName);var ns=el.uri=currentNSMap[prefix||""];if(domBuilder.startElement(ns,localName,tagName,el),el.closed){if(domBuilder.endElement(ns,localName,tagName),localNSMap)for(prefix in localNSMap)domBuilder.endPrefixMapping(prefix)}else el.currentNSMap=currentNSMap,el.localNSMap=localNSMap,parseStack.push(el)}function parseHtmlSpecialContent(source,elStartEnd,tagName,entityReplacer,domBuilder){if(/^(?:script|textarea)$/i.test(tagName)){var elEndStart=source.indexOf("</"+tagName+">",elStartEnd),text=source.substring(elStartEnd+1,elEndStart);if(/[&<]/.test(text))return/^script$/i.test(tagName)?(domBuilder.characters(text,0,text.length),elEndStart):(text=text.replace(/&#?\w+;/g,entityReplacer),domBuilder.characters(text,0,text.length),elEndStart)}return elStartEnd+1}function fixSelfClosed(source,elStartEnd,tagName,closeMap){var pos=closeMap[tagName];return null==pos&&(pos=closeMap[tagName]=source.lastIndexOf("</"+tagName+">")),pos<elStartEnd}function _copy(source,target){for(var n in source)target[n]=source[n]}function parseDCC(source,start,domBuilder,errorHandler){var next=source.charAt(start+2);switch(next){case"-":if("-"===source.charAt(start+3)){var end=source.indexOf("-->",start+4);return end>start?(domBuilder.comment(source,start+4,end-start-4),end+3):(errorHandler.error("Unclosed comment"),-1)}return-1;default:if("CDATA["==source.substr(start+3,6)){var end=source.indexOf("]]>",start+9);return domBuilder.startCDATA(),domBuilder.characters(source,start+9,end-start-9),domBuilder.endCDATA(),end+3}var matchs=split(source,start),len=matchs.length;if(len>1&&/!doctype/i.test(matchs[0][0])){var name=matchs[1][0],pubid=len>3&&/^public$/i.test(matchs[2][0])&&matchs[3][0],sysid=len>4&&matchs[4][0],lastMatch=matchs[len-1];return domBuilder.startDTD(name,pubid&&pubid.replace(/^(['"])(.*?)\1$/,"$2"),sysid&&sysid.replace(/^(['"])(.*?)\1$/,"$2")),domBuilder.endDTD(),lastMatch.index+lastMatch[0].length}}return-1}function parseInstruction(source,start,domBuilder){var end=source.indexOf("?>",start);if(end){var match=source.substring(start,end).match(/^<\?(\S*)\s*([\s\S]*?)\s*$/);if(match){match[0].length;return domBuilder.processingInstruction(match[1],match[2]),end+2}return-1}return-1}function ElementAttributes(source){}function _set_proto_(thiz,parent){return thiz.__proto__=parent,thiz}function split(source,start){var match,buf=[],reg=/'[^']+'|"[^"]+"|[^\s<>\/=]+=?|(\/?\s*>|<)/g;for(reg.lastIndex=start,reg.exec(source);match=reg.exec(source);)if(buf.push(match),match[1])return buf}var nameStartChar=/[A-Z_a-z\xC0-\xD6\xD8-\xF6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD]/,nameChar=new RegExp("[\\-\\.0-9"+nameStartChar.source.slice(1,-1)+"·̀-ͯ\\u203F-⁀]"),tagNamePattern=new RegExp("^"+nameStartChar.source+nameChar.source+"*(?::"+nameStartChar.source+nameChar.source+"*)?$"),S_TAG=0,S_ATTR=1,S_ATTR_S=2,S_EQ=3,S_V=4,S_E=5,S_S=6,S_C=7;XMLReader.prototype={parse:function(source,defaultNSMap,entityMap){var domBuilder=this.domBuilder;domBuilder.startDocument(),_copy(defaultNSMap,defaultNSMap={}),parse(source,defaultNSMap,entityMap,domBuilder,this.errorHandler),domBuilder.endDocument()}},ElementAttributes.prototype={setTagName:function(tagName){if(!tagNamePattern.test(tagName))throw new Error("invalid tagName:"+tagName);this.tagName=tagName},add:function(qName,value,offset){if(!tagNamePattern.test(qName))throw new Error("invalid attribute:"+qName);this[this.length++]={qName:qName,value:value,offset:offset}},length:0,getLocalName:function(i){return this[i].localName},getOffset:function(i){return this[i].offset},getQName:function(i){return this[i].qName},getURI:function(i){return this[i].uri},getValue:function(i){return this[i].value}},_set_proto_({},_set_proto_.prototype)instanceof _set_proto_||(_set_proto_=function(thiz,parent){function p(){}p.prototype=parent,p=new p;for(parent in thiz)p[parent]=thiz[parent];return p}),exports.XMLReader=XMLReader},function(module,exports,__webpack_require__){function copy(src,dest){for(var p in src)dest[p]=src[p]}function _extends(Class,Super){function t(){}var pt=Class.prototype;if(Object.create){var ppt=Object.create(Super.prototype);pt.__proto__=ppt}pt instanceof Super||(t.prototype=Super.prototype,t=new t,copy(pt,t),Class.prototype=pt=t),pt.constructor!=Class&&("function"!=typeof Class&&console.error("unknow Class:"+Class),pt.constructor=Class)}function DOMException(code,message){if(message instanceof Error)var error=message;else error=this,Error.call(this,ExceptionMessage[code]),this.message=ExceptionMessage[code],Error.captureStackTrace&&Error.captureStackTrace(this,DOMException);return error.code=code,message&&(this.message=this.message+": "+message),error}function NodeList(){}function LiveNodeList(node,refresh){this._node=node,this._refresh=refresh,_updateLiveList(this)}function _updateLiveList(list){var inc=list._node._inc||list._node.ownerDocument._inc;if(list._inc!=inc){var ls=list._refresh(list._node);__set__(list,"length",ls.length),copy(ls,list),list._inc=inc}}function NamedNodeMap(){}function _findNodeIndex(list,node){for(var i=list.length;i--;)if(list[i]===node)return i}function _addNamedNode(el,list,newAttr,oldAttr){if(oldAttr?list[_findNodeIndex(list,oldAttr)]=newAttr:list[list.length++]=newAttr,el){newAttr.ownerElement=el;var doc=el.ownerDocument;doc&&(oldAttr&&_onRemoveAttribute(doc,el,oldAttr),_onAddAttribute(doc,el,newAttr))}}function _removeNamedNode(el,list,attr){var i=_findNodeIndex(list,attr);if(!(i>=0))throw DOMException(NOT_FOUND_ERR,new Error);for(var lastIndex=list.length-1;i<lastIndex;)list[i]=list[++i];if(list.length=lastIndex,el){var doc=el.ownerDocument;doc&&(_onRemoveAttribute(doc,el,attr),attr.ownerElement=null)}}function DOMImplementation(features){if(this._features={},features)for(var feature in features)this._features=features[feature]}function Node(){}function _xmlEncoder(c){return"<"==c&&"&lt;"||">"==c&&"&gt;"||"&"==c&&"&amp;"||'"'==c&&"&quot;"||"&#"+c.charCodeAt()+";"}function _visitNode(node,callback){if(callback(node))return!0;if(node=node.firstChild)do if(_visitNode(node,callback))return!0;while(node=node.nextSibling)}function Document(){}function _onAddAttribute(doc,el,newAttr){doc&&doc._inc++;var ns=newAttr.namespaceURI;"http://www.w3.org/2000/xmlns/"==ns&&(el._nsMap[newAttr.prefix?newAttr.localName:""]=newAttr.value)}function _onRemoveAttribute(doc,el,newAttr,remove){doc&&doc._inc++;var ns=newAttr.namespaceURI;"http://www.w3.org/2000/xmlns/"==ns&&delete el._nsMap[newAttr.prefix?newAttr.localName:""]}function _onUpdateChild(doc,el,newChild){if(doc&&doc._inc){
doc._inc++;var cs=el.childNodes;if(newChild)cs[cs.length++]=newChild;else{for(var child=el.firstChild,i=0;child;)cs[i++]=child,child=child.nextSibling;cs.length=i}}}function _removeChild(parentNode,child){var previous=child.previousSibling,next=child.nextSibling;return previous?previous.nextSibling=next:parentNode.firstChild=next,next?next.previousSibling=previous:parentNode.lastChild=previous,_onUpdateChild(parentNode.ownerDocument,parentNode),child}function _insertBefore(parentNode,newChild,nextChild){var cp=newChild.parentNode;if(cp&&cp.removeChild(newChild),newChild.nodeType===DOCUMENT_FRAGMENT_NODE){var newFirst=newChild.firstChild;if(null==newFirst)return newChild;var newLast=newChild.lastChild}else newFirst=newLast=newChild;var pre=nextChild?nextChild.previousSibling:parentNode.lastChild;newFirst.previousSibling=pre,newLast.nextSibling=nextChild,pre?pre.nextSibling=newFirst:parentNode.firstChild=newFirst,null==nextChild?parentNode.lastChild=newLast:nextChild.previousSibling=newLast;do newFirst.parentNode=parentNode;while(newFirst!==newLast&&(newFirst=newFirst.nextSibling));return _onUpdateChild(parentNode.ownerDocument||parentNode,parentNode),newChild.nodeType==DOCUMENT_FRAGMENT_NODE&&(newChild.firstChild=newChild.lastChild=null),newChild}function _appendSingleChild(parentNode,newChild){var cp=newChild.parentNode;if(cp){var pre=parentNode.lastChild;cp.removeChild(newChild);var pre=parentNode.lastChild}var pre=parentNode.lastChild;return newChild.parentNode=parentNode,newChild.previousSibling=pre,newChild.nextSibling=null,pre?pre.nextSibling=newChild:parentNode.firstChild=newChild,parentNode.lastChild=newChild,_onUpdateChild(parentNode.ownerDocument,parentNode,newChild),newChild}function Element(){this._nsMap={}}function Attr(){}function CharacterData(){}function Text(){}function Comment(){}function CDATASection(){}function DocumentType(){}function Notation(){}function Entity(){}function EntityReference(){}function DocumentFragment(){}function ProcessingInstruction(){}function XMLSerializer(){}function serializeToString(node,buf,attributeSorter,isHTML){switch(node.nodeType){case ELEMENT_NODE:var attrs=node.attributes,len=attrs.length,child=node.firstChild,nodeName=node.tagName;isHTML=htmlns===node.namespaceURI||isHTML,buf.push("<",nodeName),attributeSorter&&buf.sort.apply(attrs,attributeSorter);for(var i=0;i<len;i++)serializeToString(attrs.item(i),buf,attributeSorter,isHTML);if(child||isHTML&&!/^(?:meta|link|img|br|hr|input|button)$/i.test(nodeName)){if(buf.push(">"),isHTML&&/^script$/i.test(nodeName))child&&buf.push(child.data);else for(;child;)serializeToString(child,buf,attributeSorter,isHTML),child=child.nextSibling;buf.push("</",nodeName,">")}else buf.push("/>");return;case DOCUMENT_NODE:case DOCUMENT_FRAGMENT_NODE:for(var child=node.firstChild;child;)serializeToString(child,buf,attributeSorter,isHTML),child=child.nextSibling;return;case ATTRIBUTE_NODE:return buf.push(" ",node.name,'="',node.value.replace(/[<&"]/g,_xmlEncoder),'"');case TEXT_NODE:return buf.push(node.data.replace(/[<&]/g,_xmlEncoder));case CDATA_SECTION_NODE:return buf.push("<![CDATA[",node.data,"]]>");case COMMENT_NODE:return buf.push("<!--",node.data,"-->");case DOCUMENT_TYPE_NODE:var pubid=node.publicId,sysid=node.systemId;if(buf.push("<!DOCTYPE ",node.name),pubid)buf.push(' PUBLIC "',pubid),sysid&&"."!=sysid&&buf.push('" "',sysid),buf.push('">');else if(sysid&&"."!=sysid)buf.push(' SYSTEM "',sysid,'">');else{var sub=node.internalSubset;sub&&buf.push(" [",sub,"]"),buf.push(">")}return;case PROCESSING_INSTRUCTION_NODE:return buf.push("<?",node.target," ",node.data,"?>");case ENTITY_REFERENCE_NODE:return buf.push("&",node.nodeName,";");default:buf.push("??",node.nodeName)}}function importNode(doc,node,deep){var node2;switch(node.nodeType){case ELEMENT_NODE:node2=node.cloneNode(!1),node2.ownerDocument=doc;case DOCUMENT_FRAGMENT_NODE:break;case ATTRIBUTE_NODE:deep=!0}if(node2||(node2=node.cloneNode(!1)),node2.ownerDocument=doc,node2.parentNode=null,deep)for(var child=node.firstChild;child;)node2.appendChild(importNode(doc,child,deep)),child=child.nextSibling;return node2}function cloneNode(doc,node,deep){var node2=new node.constructor;for(var n in node){var v=node[n];"object"!=typeof v&&v!=node2[n]&&(node2[n]=v)}switch(node.childNodes&&(node2.childNodes=new NodeList),node2.ownerDocument=doc,node2.nodeType){case ELEMENT_NODE:var attrs=node.attributes,attrs2=node2.attributes=new NamedNodeMap,len=attrs.length;attrs2._ownerElement=node2;for(var i=0;i<len;i++)node2.setAttributeNode(cloneNode(doc,attrs.item(i),!0));break;case ATTRIBUTE_NODE:deep=!0}if(deep)for(var child=node.firstChild;child;)node2.appendChild(cloneNode(doc,child,deep)),child=child.nextSibling;return node2}function __set__(object,key,value){object[key]=value}function getTextContent(node){switch(node.nodeType){case 1:case 11:var buf=[];for(node=node.firstChild;node;)7!==node.nodeType&&8!==node.nodeType&&buf.push(getTextContent(node)),node=node.nextSibling;return buf.join("");default:return node.nodeValue}}var htmlns="http://www.w3.org/1999/xhtml",NodeType={},ELEMENT_NODE=NodeType.ELEMENT_NODE=1,ATTRIBUTE_NODE=NodeType.ATTRIBUTE_NODE=2,TEXT_NODE=NodeType.TEXT_NODE=3,CDATA_SECTION_NODE=NodeType.CDATA_SECTION_NODE=4,ENTITY_REFERENCE_NODE=NodeType.ENTITY_REFERENCE_NODE=5,ENTITY_NODE=NodeType.ENTITY_NODE=6,PROCESSING_INSTRUCTION_NODE=NodeType.PROCESSING_INSTRUCTION_NODE=7,COMMENT_NODE=NodeType.COMMENT_NODE=8,DOCUMENT_NODE=NodeType.DOCUMENT_NODE=9,DOCUMENT_TYPE_NODE=NodeType.DOCUMENT_TYPE_NODE=10,DOCUMENT_FRAGMENT_NODE=NodeType.DOCUMENT_FRAGMENT_NODE=11,NOTATION_NODE=NodeType.NOTATION_NODE=12,ExceptionCode={},ExceptionMessage={},NOT_FOUND_ERR=(ExceptionCode.INDEX_SIZE_ERR=(ExceptionMessage[1]="Index size error",1),ExceptionCode.DOMSTRING_SIZE_ERR=(ExceptionMessage[2]="DOMString size error",2),ExceptionCode.HIERARCHY_REQUEST_ERR=(ExceptionMessage[3]="Hierarchy request error",3),ExceptionCode.WRONG_DOCUMENT_ERR=(ExceptionMessage[4]="Wrong document",4),ExceptionCode.INVALID_CHARACTER_ERR=(ExceptionMessage[5]="Invalid character",5),ExceptionCode.NO_DATA_ALLOWED_ERR=(ExceptionMessage[6]="No data allowed",6),ExceptionCode.NO_MODIFICATION_ALLOWED_ERR=(ExceptionMessage[7]="No modification allowed",7),ExceptionCode.NOT_FOUND_ERR=(ExceptionMessage[8]="Not found",8)),INUSE_ATTRIBUTE_ERR=(ExceptionCode.NOT_SUPPORTED_ERR=(ExceptionMessage[9]="Not supported",9),ExceptionCode.INUSE_ATTRIBUTE_ERR=(ExceptionMessage[10]="Attribute in use",10));ExceptionCode.INVALID_STATE_ERR=(ExceptionMessage[11]="Invalid state",11),ExceptionCode.SYNTAX_ERR=(ExceptionMessage[12]="Syntax error",12),ExceptionCode.INVALID_MODIFICATION_ERR=(ExceptionMessage[13]="Invalid modification",13),ExceptionCode.NAMESPACE_ERR=(ExceptionMessage[14]="Invalid namespace",14),ExceptionCode.INVALID_ACCESS_ERR=(ExceptionMessage[15]="Invalid access",15);DOMException.prototype=Error.prototype,copy(ExceptionCode,DOMException),NodeList.prototype={length:0,item:function(index){return this[index]||null},toString:function(){for(var buf=[],i=0;i<this.length;i++)serializeToString(this[i],buf);return buf.join("")}},LiveNodeList.prototype.item=function(i){return _updateLiveList(this),this[i]},_extends(LiveNodeList,NodeList),NamedNodeMap.prototype={length:0,item:NodeList.prototype.item,getNamedItem:function(key){for(var i=this.length;i--;){var attr=this[i];if(attr.nodeName==key)return attr}},setNamedItem:function(attr){var el=attr.ownerElement;if(el&&el!=this._ownerElement)throw new DOMException(INUSE_ATTRIBUTE_ERR);var oldAttr=this.getNamedItem(attr.nodeName);return _addNamedNode(this._ownerElement,this,attr,oldAttr),oldAttr},setNamedItemNS:function(attr){var oldAttr,el=attr.ownerElement;if(el&&el!=this._ownerElement)throw new DOMException(INUSE_ATTRIBUTE_ERR);return oldAttr=this.getNamedItemNS(attr.namespaceURI,attr.localName),_addNamedNode(this._ownerElement,this,attr,oldAttr),oldAttr},removeNamedItem:function(key){var attr=this.getNamedItem(key);return _removeNamedNode(this._ownerElement,this,attr),attr},removeNamedItemNS:function(namespaceURI,localName){var attr=this.getNamedItemNS(namespaceURI,localName);return _removeNamedNode(this._ownerElement,this,attr),attr},getNamedItemNS:function(namespaceURI,localName){for(var i=this.length;i--;){var node=this[i];if(node.localName==localName&&node.namespaceURI==namespaceURI)return node}return null}},DOMImplementation.prototype={hasFeature:function(feature,version){var versions=this._features[feature.toLowerCase()];return!(!versions||version&&!(version in versions))},createDocument:function(namespaceURI,qualifiedName,doctype){var doc=new Document;if(doc.implementation=this,doc.childNodes=new NodeList,doc.doctype=doctype,doctype&&doc.appendChild(doctype),qualifiedName){var root=doc.createElementNS(namespaceURI,qualifiedName);doc.appendChild(root)}return doc},createDocumentType:function(qualifiedName,publicId,systemId){var node=new DocumentType;return node.name=qualifiedName,node.nodeName=qualifiedName,node.publicId=publicId,node.systemId=systemId,node}},Node.prototype={firstChild:null,lastChild:null,previousSibling:null,nextSibling:null,attributes:null,parentNode:null,childNodes:null,ownerDocument:null,nodeValue:null,namespaceURI:null,prefix:null,localName:null,insertBefore:function(newChild,refChild){return _insertBefore(this,newChild,refChild)},replaceChild:function(newChild,oldChild){this.insertBefore(newChild,oldChild),oldChild&&this.removeChild(oldChild)},removeChild:function(oldChild){return _removeChild(this,oldChild)},appendChild:function(newChild){return this.insertBefore(newChild,null)},hasChildNodes:function(){return null!=this.firstChild},cloneNode:function(deep){return cloneNode(this.ownerDocument||this,this,deep)},normalize:function(){for(var child=this.firstChild;child;){var next=child.nextSibling;next&&next.nodeType==TEXT_NODE&&child.nodeType==TEXT_NODE?(this.removeChild(next),child.appendData(next.data)):(child.normalize(),child=next)}},isSupported:function(feature,version){return this.ownerDocument.implementation.hasFeature(feature,version)},hasAttributes:function(){return this.attributes.length>0},lookupPrefix:function(namespaceURI){for(var el=this;el;){var map=el._nsMap;if(map)for(var n in map)if(map[n]==namespaceURI)return n;el=2==el.nodeType?el.ownerDocument:el.parentNode}return null},lookupNamespaceURI:function(prefix){for(var el=this;el;){var map=el._nsMap;if(map&&prefix in map)return map[prefix];el=2==el.nodeType?el.ownerDocument:el.parentNode}return null},isDefaultNamespace:function(namespaceURI){var prefix=this.lookupPrefix(namespaceURI);return null==prefix}},copy(NodeType,Node),copy(NodeType,Node.prototype),Document.prototype={nodeName:"#document",nodeType:DOCUMENT_NODE,doctype:null,documentElement:null,_inc:1,insertBefore:function(newChild,refChild){if(newChild.nodeType==DOCUMENT_FRAGMENT_NODE){for(var child=newChild.firstChild;child;){var next=child.nextSibling;this.insertBefore(child,refChild),child=next}return newChild}return null==this.documentElement&&1==newChild.nodeType&&(this.documentElement=newChild),_insertBefore(this,newChild,refChild),newChild.ownerDocument=this,newChild},removeChild:function(oldChild){return this.documentElement==oldChild&&(this.documentElement=null),_removeChild(this,oldChild)},importNode:function(importedNode,deep){return importNode(this,importedNode,deep)},getElementById:function(id){var rtv=null;return _visitNode(this.documentElement,function(node){if(1==node.nodeType&&node.getAttribute("id")==id)return rtv=node,!0}),rtv},createElement:function(tagName){var node=new Element;node.ownerDocument=this,node.nodeName=tagName,node.tagName=tagName,node.childNodes=new NodeList;var attrs=node.attributes=new NamedNodeMap;return attrs._ownerElement=node,node},createDocumentFragment:function(){var node=new DocumentFragment;return node.ownerDocument=this,node.childNodes=new NodeList,node},createTextNode:function(data){var node=new Text;return node.ownerDocument=this,node.appendData(data),node},createComment:function(data){var node=new Comment;return node.ownerDocument=this,node.appendData(data),node},createCDATASection:function(data){var node=new CDATASection;return node.ownerDocument=this,node.appendData(data),node},createProcessingInstruction:function(target,data){var node=new ProcessingInstruction;return node.ownerDocument=this,node.tagName=node.target=target,node.nodeValue=node.data=data,node},createAttribute:function(name){var node=new Attr;return node.ownerDocument=this,node.name=name,node.nodeName=name,node.localName=name,node.specified=!0,node},createEntityReference:function(name){var node=new EntityReference;return node.ownerDocument=this,node.nodeName=name,node},createElementNS:function(namespaceURI,qualifiedName){var node=new Element,pl=qualifiedName.split(":"),attrs=node.attributes=new NamedNodeMap;return node.childNodes=new NodeList,node.ownerDocument=this,node.nodeName=qualifiedName,node.tagName=qualifiedName,node.namespaceURI=namespaceURI,2==pl.length?(node.prefix=pl[0],node.localName=pl[1]):node.localName=qualifiedName,attrs._ownerElement=node,node},createAttributeNS:function(namespaceURI,qualifiedName){var node=new Attr,pl=qualifiedName.split(":");return node.ownerDocument=this,node.nodeName=qualifiedName,node.name=qualifiedName,node.namespaceURI=namespaceURI,node.specified=!0,2==pl.length?(node.prefix=pl[0],node.localName=pl[1]):node.localName=qualifiedName,node}},_extends(Document,Node),Element.prototype={nodeType:ELEMENT_NODE,hasAttribute:function(name){return null!=this.getAttributeNode(name)},getAttribute:function(name){var attr=this.getAttributeNode(name);return attr&&attr.value||""},getAttributeNode:function(name){return this.attributes.getNamedItem(name)},setAttribute:function(name,value){var attr=this.ownerDocument.createAttribute(name);attr.value=attr.nodeValue=""+value,this.setAttributeNode(attr)},removeAttribute:function(name){var attr=this.getAttributeNode(name);attr&&this.removeAttributeNode(attr)},appendChild:function(newChild){return newChild.nodeType===DOCUMENT_FRAGMENT_NODE?this.insertBefore(newChild,null):_appendSingleChild(this,newChild)},setAttributeNode:function(newAttr){return this.attributes.setNamedItem(newAttr)},setAttributeNodeNS:function(newAttr){return this.attributes.setNamedItemNS(newAttr)},removeAttributeNode:function(oldAttr){return this.attributes.removeNamedItem(oldAttr.nodeName)},removeAttributeNS:function(namespaceURI,localName){var old=this.getAttributeNodeNS(namespaceURI,localName);old&&this.removeAttributeNode(old)},hasAttributeNS:function(namespaceURI,localName){return null!=this.getAttributeNodeNS(namespaceURI,localName)},getAttributeNS:function(namespaceURI,localName){var attr=this.getAttributeNodeNS(namespaceURI,localName);return attr&&attr.value||""},setAttributeNS:function(namespaceURI,qualifiedName,value){var attr=this.ownerDocument.createAttributeNS(namespaceURI,qualifiedName);attr.value=attr.nodeValue=""+value,this.setAttributeNode(attr)},getAttributeNodeNS:function(namespaceURI,localName){return this.attributes.getNamedItemNS(namespaceURI,localName)},getElementsByTagName:function(tagName){return new LiveNodeList(this,function(base){var ls=[];return _visitNode(base,function(node){node===base||node.nodeType!=ELEMENT_NODE||"*"!==tagName&&node.tagName!=tagName||ls.push(node)}),ls})},getElementsByTagNameNS:function(namespaceURI,localName){return new LiveNodeList(this,function(base){var ls=[];return _visitNode(base,function(node){node===base||node.nodeType!==ELEMENT_NODE||"*"!==namespaceURI&&node.namespaceURI!==namespaceURI||"*"!==localName&&node.localName!=localName||ls.push(node)}),ls})}},Document.prototype.getElementsByTagName=Element.prototype.getElementsByTagName,Document.prototype.getElementsByTagNameNS=Element.prototype.getElementsByTagNameNS,_extends(Element,Node),Attr.prototype.nodeType=ATTRIBUTE_NODE,_extends(Attr,Node),CharacterData.prototype={data:"",substringData:function(offset,count){return this.data.substring(offset,offset+count)},appendData:function(text){text=this.data+text,this.nodeValue=this.data=text,this.length=text.length},insertData:function(offset,text){this.replaceData(offset,0,text)},appendChild:function(newChild){throw new Error(ExceptionMessage[3])},deleteData:function(offset,count){this.replaceData(offset,count,"")},replaceData:function(offset,count,text){var start=this.data.substring(0,offset),end=this.data.substring(offset+count);text=start+text+end,this.nodeValue=this.data=text,this.length=text.length}},_extends(CharacterData,Node),Text.prototype={nodeName:"#text",nodeType:TEXT_NODE,splitText:function(offset){var text=this.data,newText=text.substring(offset);text=text.substring(0,offset),this.data=this.nodeValue=text,this.length=text.length;var newNode=this.ownerDocument.createTextNode(newText);return this.parentNode&&this.parentNode.insertBefore(newNode,this.nextSibling),newNode}},_extends(Text,CharacterData),Comment.prototype={nodeName:"#comment",nodeType:COMMENT_NODE},_extends(Comment,CharacterData),CDATASection.prototype={nodeName:"#cdata-section",nodeType:CDATA_SECTION_NODE},_extends(CDATASection,CharacterData),DocumentType.prototype.nodeType=DOCUMENT_TYPE_NODE,_extends(DocumentType,Node),Notation.prototype.nodeType=NOTATION_NODE,_extends(Notation,Node),Entity.prototype.nodeType=ENTITY_NODE,_extends(Entity,Node),EntityReference.prototype.nodeType=ENTITY_REFERENCE_NODE,_extends(EntityReference,Node),DocumentFragment.prototype.nodeName="#document-fragment",DocumentFragment.prototype.nodeType=DOCUMENT_FRAGMENT_NODE,_extends(DocumentFragment,Node),ProcessingInstruction.prototype.nodeType=PROCESSING_INSTRUCTION_NODE,_extends(ProcessingInstruction,Node),XMLSerializer.prototype.serializeToString=function(node,attributeSorter){return node.toString(attributeSorter)},Node.prototype.toString=function(attributeSorter){var buf=[];return serializeToString(this,buf,attributeSorter),buf.join("")};try{Object.defineProperty&&(Object.defineProperty(LiveNodeList.prototype,"length",{get:function(){return _updateLiveList(this),this.$$length}}),Object.defineProperty(Node.prototype,"textContent",{get:function(){return getTextContent(this)},set:function(data){switch(this.nodeType){case 1:case 11:for(;this.firstChild;)this.removeChild(this.firstChild);(data||String(data))&&this.appendChild(this.ownerDocument.createTextNode(data));break;default:this.data=data,this.value=value,this.nodeValue=data}}}),__set__=function(object,key,value){object["$$"+key]=value})}catch(e){}exports.DOMImplementation=DOMImplementation,exports.XMLSerializer=XMLSerializer},function(module,exports,__webpack_require__){"use strict";function handleQs(url,query){url=url.split("?");var start=url[0],qs=(url[1]||"").split("#")[0],end=url[1]&&url[1].split("#").length>1?"#"+url[1].split("#")[1]:"",baseQs=parse(qs);for(var i in query)baseQs[i]=query[i];return qs=stringify(baseQs),""!==qs&&(qs="?"+qs),start+qs+end}var parse=__webpack_require__(166).parse,stringify=__webpack_require__(166).stringify;module.exports=handleQs},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__;(function(){function createReduce(dir){function iterator(obj,iteratee,memo,keys,index,length){for(;index>=0&&index<length;index+=dir){var currentKey=keys?keys[index]:index;memo=iteratee(memo,obj[currentKey],currentKey,obj)}return memo}return function(obj,iteratee,memo,context){iteratee=optimizeCb(iteratee,context,4);var keys=!isArrayLike(obj)&&_.keys(obj),length=(keys||obj).length,index=dir>0?0:length-1;return arguments.length<3&&(memo=obj[keys?keys[index]:index],index+=dir),iterator(obj,iteratee,memo,keys,index,length)}}function createPredicateIndexFinder(dir){return function(array,predicate,context){predicate=cb(predicate,context);for(var length=getLength(array),index=dir>0?0:length-1;index>=0&&index<length;index+=dir)if(predicate(array[index],index,array))return index;return-1}}function createIndexFinder(dir,predicateFind,sortedIndex){return function(array,item,idx){var i=0,length=getLength(array);if("number"==typeof idx)dir>0?i=idx>=0?idx:Math.max(idx+length,i):length=idx>=0?Math.min(idx+1,length):idx+length+1;else if(sortedIndex&&idx&&length)return idx=sortedIndex(array,item),array[idx]===item?idx:-1;if(item!==item)return idx=predicateFind(slice.call(array,i,length),_.isNaN),idx>=0?idx+i:-1;for(idx=dir>0?i:length-1;idx>=0&&idx<length;idx+=dir)if(array[idx]===item)return idx;return-1}}function collectNonEnumProps(obj,keys){var nonEnumIdx=nonEnumerableProps.length,constructor=obj.constructor,proto=_.isFunction(constructor)&&constructor.prototype||ObjProto,prop="constructor";for(_.has(obj,prop)&&!_.contains(keys,prop)&&keys.push(prop);nonEnumIdx--;)prop=nonEnumerableProps[nonEnumIdx],prop in obj&&obj[prop]!==proto[prop]&&!_.contains(keys,prop)&&keys.push(prop)}var root=this,previousUnderscore=root._,ArrayProto=Array.prototype,ObjProto=Object.prototype,FuncProto=Function.prototype,push=ArrayProto.push,slice=ArrayProto.slice,toString=ObjProto.toString,hasOwnProperty=ObjProto.hasOwnProperty,nativeIsArray=Array.isArray,nativeKeys=Object.keys,nativeBind=FuncProto.bind,nativeCreate=Object.create,Ctor=function(){},_=function(obj){return obj instanceof _?obj:this instanceof _?void(this._wrapped=obj):new _(obj)};"undefined"!=typeof module&&module.exports&&(exports=module.exports=_),exports._=_,_.VERSION="1.8.3";var optimizeCb=function(func,context,argCount){if(void 0===context)return func;switch(null==argCount?3:argCount){case 1:return function(value){return func.call(context,value)};case 2:return function(value,other){return func.call(context,value,other)};case 3:return function(value,index,collection){return func.call(context,value,index,collection)};case 4:return function(accumulator,value,index,collection){return func.call(context,accumulator,value,index,collection)}}return function(){return func.apply(context,arguments)}},cb=function(value,context,argCount){return null==value?_.identity:_.isFunction(value)?optimizeCb(value,context,argCount):_.isObject(value)?_.matcher(value):_.property(value)};_.iteratee=function(value,context){return cb(value,context,1/0)};var createAssigner=function(keysFunc,undefinedOnly){return function(obj){var length=arguments.length;if(length<2||null==obj)return obj;for(var index=1;index<length;index++)for(var source=arguments[index],keys=keysFunc(source),l=keys.length,i=0;i<l;i++){var key=keys[i];undefinedOnly&&void 0!==obj[key]||(obj[key]=source[key])}return obj}},baseCreate=function(prototype){if(!_.isObject(prototype))return{};if(nativeCreate)return nativeCreate(prototype);Ctor.prototype=prototype;var result=new Ctor;return Ctor.prototype=null,result},property=function(key){return function(obj){return null==obj?void 0:obj[key]}},MAX_ARRAY_INDEX=Math.pow(2,53)-1,getLength=property("length"),isArrayLike=function(collection){var length=getLength(collection);return"number"==typeof length&&length>=0&&length<=MAX_ARRAY_INDEX};_.each=_.forEach=function(obj,iteratee,context){iteratee=optimizeCb(iteratee,context);var i,length;if(isArrayLike(obj))for(i=0,length=obj.length;i<length;i++)iteratee(obj[i],i,obj);else{var keys=_.keys(obj);for(i=0,length=keys.length;i<length;i++)iteratee(obj[keys[i]],keys[i],obj)}return obj},_.map=_.collect=function(obj,iteratee,context){iteratee=cb(iteratee,context);for(var keys=!isArrayLike(obj)&&_.keys(obj),length=(keys||obj).length,results=Array(length),index=0;index<length;index++){var currentKey=keys?keys[index]:index;results[index]=iteratee(obj[currentKey],currentKey,obj)}return results},_.reduce=_.foldl=_.inject=createReduce(1),_.reduceRight=_.foldr=createReduce(-1),_.find=_.detect=function(obj,predicate,context){var key;if(key=isArrayLike(obj)?_.findIndex(obj,predicate,context):_.findKey(obj,predicate,context),void 0!==key&&key!==-1)return obj[key]},_.filter=_.select=function(obj,predicate,context){var results=[];return predicate=cb(predicate,context),_.each(obj,function(value,index,list){predicate(value,index,list)&&results.push(value)}),results},_.reject=function(obj,predicate,context){return _.filter(obj,_.negate(cb(predicate)),context)},_.every=_.all=function(obj,predicate,context){predicate=cb(predicate,context);for(var keys=!isArrayLike(obj)&&_.keys(obj),length=(keys||obj).length,index=0;index<length;index++){var currentKey=keys?keys[index]:index;if(!predicate(obj[currentKey],currentKey,obj))return!1}return!0},_.some=_.any=function(obj,predicate,context){predicate=cb(predicate,context);for(var keys=!isArrayLike(obj)&&_.keys(obj),length=(keys||obj).length,index=0;index<length;index++){var currentKey=keys?keys[index]:index;if(predicate(obj[currentKey],currentKey,obj))return!0}return!1},_.contains=_.includes=_.include=function(obj,item,fromIndex,guard){return isArrayLike(obj)||(obj=_.values(obj)),("number"!=typeof fromIndex||guard)&&(fromIndex=0),_.indexOf(obj,item,fromIndex)>=0},_.invoke=function(obj,method){var args=slice.call(arguments,2),isFunc=_.isFunction(method);return _.map(obj,function(value){var func=isFunc?method:value[method];return null==func?func:func.apply(value,args)})},_.pluck=function(obj,key){return _.map(obj,_.property(key))},_.where=function(obj,attrs){return _.filter(obj,_.matcher(attrs))},_.findWhere=function(obj,attrs){return _.find(obj,_.matcher(attrs))},_.max=function(obj,iteratee,context){var value,computed,result=-(1/0),lastComputed=-(1/0);if(null==iteratee&&null!=obj){obj=isArrayLike(obj)?obj:_.values(obj);for(var i=0,length=obj.length;i<length;i++)value=obj[i],value>result&&(result=value)}else iteratee=cb(iteratee,context),_.each(obj,function(value,index,list){computed=iteratee(value,index,list),(computed>lastComputed||computed===-(1/0)&&result===-(1/0))&&(result=value,lastComputed=computed)});return result},_.min=function(obj,iteratee,context){var value,computed,result=1/0,lastComputed=1/0;if(null==iteratee&&null!=obj){obj=isArrayLike(obj)?obj:_.values(obj);for(var i=0,length=obj.length;i<length;i++)value=obj[i],value<result&&(result=value)}else iteratee=cb(iteratee,context),_.each(obj,function(value,index,list){computed=iteratee(value,index,list),(computed<lastComputed||computed===1/0&&result===1/0)&&(result=value,lastComputed=computed)});return result},_.shuffle=function(obj){for(var rand,set=isArrayLike(obj)?obj:_.values(obj),length=set.length,shuffled=Array(length),index=0;index<length;index++)rand=_.random(0,index),rand!==index&&(shuffled[index]=shuffled[rand]),shuffled[rand]=set[index];return shuffled},_.sample=function(obj,n,guard){return null==n||guard?(isArrayLike(obj)||(obj=_.values(obj)),obj[_.random(obj.length-1)]):_.shuffle(obj).slice(0,Math.max(0,n))},_.sortBy=function(obj,iteratee,context){return iteratee=cb(iteratee,context),_.pluck(_.map(obj,function(value,index,list){return{value:value,index:index,criteria:iteratee(value,index,list)}}).sort(function(left,right){var a=left.criteria,b=right.criteria;if(a!==b){if(a>b||void 0===a)return 1;if(a<b||void 0===b)return-1}return left.index-right.index}),"value")};var group=function(behavior){return function(obj,iteratee,context){var result={};return iteratee=cb(iteratee,context),_.each(obj,function(value,index){var key=iteratee(value,index,obj);behavior(result,value,key)}),result}};_.groupBy=group(function(result,value,key){_.has(result,key)?result[key].push(value):result[key]=[value]}),_.indexBy=group(function(result,value,key){result[key]=value}),_.countBy=group(function(result,value,key){_.has(result,key)?result[key]++:result[key]=1}),_.toArray=function(obj){return obj?_.isArray(obj)?slice.call(obj):isArrayLike(obj)?_.map(obj,_.identity):_.values(obj):[]},_.size=function(obj){return null==obj?0:isArrayLike(obj)?obj.length:_.keys(obj).length},_.partition=function(obj,predicate,context){predicate=cb(predicate,context);var pass=[],fail=[];return _.each(obj,function(value,key,obj){(predicate(value,key,obj)?pass:fail).push(value)}),[pass,fail]},_.first=_.head=_.take=function(array,n,guard){if(null!=array)return null==n||guard?array[0]:_.initial(array,array.length-n)},_.initial=function(array,n,guard){return slice.call(array,0,Math.max(0,array.length-(null==n||guard?1:n)))},_.last=function(array,n,guard){if(null!=array)return null==n||guard?array[array.length-1]:_.rest(array,Math.max(0,array.length-n))},_.rest=_.tail=_.drop=function(array,n,guard){return slice.call(array,null==n||guard?1:n)},_.compact=function(array){return _.filter(array,_.identity)};var flatten=function(input,shallow,strict,startIndex){for(var output=[],idx=0,i=startIndex||0,length=getLength(input);i<length;i++){var value=input[i];if(isArrayLike(value)&&(_.isArray(value)||_.isArguments(value))){shallow||(value=flatten(value,shallow,strict));var j=0,len=value.length;for(output.length+=len;j<len;)output[idx++]=value[j++]}else strict||(output[idx++]=value)}return output};_.flatten=function(array,shallow){return flatten(array,shallow,!1)},_.without=function(array){return _.difference(array,slice.call(arguments,1))},_.uniq=_.unique=function(array,isSorted,iteratee,context){_.isBoolean(isSorted)||(context=iteratee,iteratee=isSorted,isSorted=!1),null!=iteratee&&(iteratee=cb(iteratee,context));for(var result=[],seen=[],i=0,length=getLength(array);i<length;i++){var value=array[i],computed=iteratee?iteratee(value,i,array):value;isSorted?(i&&seen===computed||result.push(value),seen=computed):iteratee?_.contains(seen,computed)||(seen.push(computed),result.push(value)):_.contains(result,value)||result.push(value)}return result},_.union=function(){return _.uniq(flatten(arguments,!0,!0))},_.intersection=function(array){for(var result=[],argsLength=arguments.length,i=0,length=getLength(array);i<length;i++){var item=array[i];if(!_.contains(result,item)){for(var j=1;j<argsLength&&_.contains(arguments[j],item);j++);j===argsLength&&result.push(item)}}return result},_.difference=function(array){var rest=flatten(arguments,!0,!0,1);return _.filter(array,function(value){return!_.contains(rest,value)})},_.zip=function(){return _.unzip(arguments)},_.unzip=function(array){for(var length=array&&_.max(array,getLength).length||0,result=Array(length),index=0;index<length;index++)result[index]=_.pluck(array,index);return result},_.object=function(list,values){for(var result={},i=0,length=getLength(list);i<length;i++)values?result[list[i]]=values[i]:result[list[i][0]]=list[i][1];return result},_.findIndex=createPredicateIndexFinder(1),_.findLastIndex=createPredicateIndexFinder(-1),_.sortedIndex=function(array,obj,iteratee,context){iteratee=cb(iteratee,context,1);for(var value=iteratee(obj),low=0,high=getLength(array);low<high;){var mid=Math.floor((low+high)/2);iteratee(array[mid])<value?low=mid+1:high=mid}return low},_.indexOf=createIndexFinder(1,_.findIndex,_.sortedIndex),_.lastIndexOf=createIndexFinder(-1,_.findLastIndex),_.range=function(start,stop,step){null==stop&&(stop=start||0,start=0),step=step||1;for(var length=Math.max(Math.ceil((stop-start)/step),0),range=Array(length),idx=0;idx<length;idx++,start+=step)range[idx]=start;return range};var executeBound=function(sourceFunc,boundFunc,context,callingContext,args){if(!(callingContext instanceof boundFunc))return sourceFunc.apply(context,args);var self=baseCreate(sourceFunc.prototype),result=sourceFunc.apply(self,args);return _.isObject(result)?result:self};_.bind=function(func,context){if(nativeBind&&func.bind===nativeBind)return nativeBind.apply(func,slice.call(arguments,1));if(!_.isFunction(func))throw new TypeError("Bind must be called on a function");var args=slice.call(arguments,2),bound=function(){return executeBound(func,bound,context,this,args.concat(slice.call(arguments)))};return bound},_.partial=function(func){var boundArgs=slice.call(arguments,1),bound=function(){for(var position=0,length=boundArgs.length,args=Array(length),i=0;i<length;i++)args[i]=boundArgs[i]===_?arguments[position++]:boundArgs[i];for(;position<arguments.length;)args.push(arguments[position++]);return executeBound(func,bound,this,this,args)};return bound},_.bindAll=function(obj){var i,key,length=arguments.length;if(length<=1)throw new Error("bindAll must be passed function names");
for(i=1;i<length;i++)key=arguments[i],obj[key]=_.bind(obj[key],obj);return obj},_.memoize=function(func,hasher){var memoize=function(key){var cache=memoize.cache,address=""+(hasher?hasher.apply(this,arguments):key);return _.has(cache,address)||(cache[address]=func.apply(this,arguments)),cache[address]};return memoize.cache={},memoize},_.delay=function(func,wait){var args=slice.call(arguments,2);return setTimeout(function(){return func.apply(null,args)},wait)},_.defer=_.partial(_.delay,_,1),_.throttle=function(func,wait,options){var context,args,result,timeout=null,previous=0;options||(options={});var later=function(){previous=options.leading===!1?0:_.now(),timeout=null,result=func.apply(context,args),timeout||(context=args=null)};return function(){var now=_.now();previous||options.leading!==!1||(previous=now);var remaining=wait-(now-previous);return context=this,args=arguments,remaining<=0||remaining>wait?(timeout&&(clearTimeout(timeout),timeout=null),previous=now,result=func.apply(context,args),timeout||(context=args=null)):timeout||options.trailing===!1||(timeout=setTimeout(later,remaining)),result}},_.debounce=function(func,wait,immediate){var timeout,args,context,timestamp,result,later=function(){var last=_.now()-timestamp;last<wait&&last>=0?timeout=setTimeout(later,wait-last):(timeout=null,immediate||(result=func.apply(context,args),timeout||(context=args=null)))};return function(){context=this,args=arguments,timestamp=_.now();var callNow=immediate&&!timeout;return timeout||(timeout=setTimeout(later,wait)),callNow&&(result=func.apply(context,args),context=args=null),result}},_.wrap=function(func,wrapper){return _.partial(wrapper,func)},_.negate=function(predicate){return function(){return!predicate.apply(this,arguments)}},_.compose=function(){var args=arguments,start=args.length-1;return function(){for(var i=start,result=args[start].apply(this,arguments);i--;)result=args[i].call(this,result);return result}},_.after=function(times,func){return function(){if(--times<1)return func.apply(this,arguments)}},_.before=function(times,func){var memo;return function(){return--times>0&&(memo=func.apply(this,arguments)),times<=1&&(func=null),memo}},_.once=_.partial(_.before,2);var hasEnumBug=!{toString:null}.propertyIsEnumerable("toString"),nonEnumerableProps=["valueOf","isPrototypeOf","toString","propertyIsEnumerable","hasOwnProperty","toLocaleString"];_.keys=function(obj){if(!_.isObject(obj))return[];if(nativeKeys)return nativeKeys(obj);var keys=[];for(var key in obj)_.has(obj,key)&&keys.push(key);return hasEnumBug&&collectNonEnumProps(obj,keys),keys},_.allKeys=function(obj){if(!_.isObject(obj))return[];var keys=[];for(var key in obj)keys.push(key);return hasEnumBug&&collectNonEnumProps(obj,keys),keys},_.values=function(obj){for(var keys=_.keys(obj),length=keys.length,values=Array(length),i=0;i<length;i++)values[i]=obj[keys[i]];return values},_.mapObject=function(obj,iteratee,context){iteratee=cb(iteratee,context);for(var currentKey,keys=_.keys(obj),length=keys.length,results={},index=0;index<length;index++)currentKey=keys[index],results[currentKey]=iteratee(obj[currentKey],currentKey,obj);return results},_.pairs=function(obj){for(var keys=_.keys(obj),length=keys.length,pairs=Array(length),i=0;i<length;i++)pairs[i]=[keys[i],obj[keys[i]]];return pairs},_.invert=function(obj){for(var result={},keys=_.keys(obj),i=0,length=keys.length;i<length;i++)result[obj[keys[i]]]=keys[i];return result},_.functions=_.methods=function(obj){var names=[];for(var key in obj)_.isFunction(obj[key])&&names.push(key);return names.sort()},_.extend=createAssigner(_.allKeys),_.extendOwn=_.assign=createAssigner(_.keys),_.findKey=function(obj,predicate,context){predicate=cb(predicate,context);for(var key,keys=_.keys(obj),i=0,length=keys.length;i<length;i++)if(key=keys[i],predicate(obj[key],key,obj))return key},_.pick=function(object,oiteratee,context){var iteratee,keys,result={},obj=object;if(null==obj)return result;_.isFunction(oiteratee)?(keys=_.allKeys(obj),iteratee=optimizeCb(oiteratee,context)):(keys=flatten(arguments,!1,!1,1),iteratee=function(value,key,obj){return key in obj},obj=Object(obj));for(var i=0,length=keys.length;i<length;i++){var key=keys[i],value=obj[key];iteratee(value,key,obj)&&(result[key]=value)}return result},_.omit=function(obj,iteratee,context){if(_.isFunction(iteratee))iteratee=_.negate(iteratee);else{var keys=_.map(flatten(arguments,!1,!1,1),String);iteratee=function(value,key){return!_.contains(keys,key)}}return _.pick(obj,iteratee,context)},_.defaults=createAssigner(_.allKeys,!0),_.create=function(prototype,props){var result=baseCreate(prototype);return props&&_.extendOwn(result,props),result},_.clone=function(obj){return _.isObject(obj)?_.isArray(obj)?obj.slice():_.extend({},obj):obj},_.tap=function(obj,interceptor){return interceptor(obj),obj},_.isMatch=function(object,attrs){var keys=_.keys(attrs),length=keys.length;if(null==object)return!length;for(var obj=Object(object),i=0;i<length;i++){var key=keys[i];if(attrs[key]!==obj[key]||!(key in obj))return!1}return!0};var eq=function(a,b,aStack,bStack){if(a===b)return 0!==a||1/a===1/b;if(null==a||null==b)return a===b;a instanceof _&&(a=a._wrapped),b instanceof _&&(b=b._wrapped);var className=toString.call(a);if(className!==toString.call(b))return!1;switch(className){case"[object RegExp]":case"[object String]":return""+a==""+b;case"[object Number]":return+a!==+a?+b!==+b:0===+a?1/+a===1/b:+a===+b;case"[object Date]":case"[object Boolean]":return+a===+b}var areArrays="[object Array]"===className;if(!areArrays){if("object"!=typeof a||"object"!=typeof b)return!1;var aCtor=a.constructor,bCtor=b.constructor;if(aCtor!==bCtor&&!(_.isFunction(aCtor)&&aCtor instanceof aCtor&&_.isFunction(bCtor)&&bCtor instanceof bCtor)&&"constructor"in a&&"constructor"in b)return!1}aStack=aStack||[],bStack=bStack||[];for(var length=aStack.length;length--;)if(aStack[length]===a)return bStack[length]===b;if(aStack.push(a),bStack.push(b),areArrays){if(length=a.length,length!==b.length)return!1;for(;length--;)if(!eq(a[length],b[length],aStack,bStack))return!1}else{var key,keys=_.keys(a);if(length=keys.length,_.keys(b).length!==length)return!1;for(;length--;)if(key=keys[length],!_.has(b,key)||!eq(a[key],b[key],aStack,bStack))return!1}return aStack.pop(),bStack.pop(),!0};_.isEqual=function(a,b){return eq(a,b)},_.isEmpty=function(obj){return null==obj||(isArrayLike(obj)&&(_.isArray(obj)||_.isString(obj)||_.isArguments(obj))?0===obj.length:0===_.keys(obj).length)},_.isElement=function(obj){return!(!obj||1!==obj.nodeType)},_.isArray=nativeIsArray||function(obj){return"[object Array]"===toString.call(obj)},_.isObject=function(obj){var type=typeof obj;return"function"===type||"object"===type&&!!obj},_.each(["Arguments","Function","String","Number","Date","RegExp","Error"],function(name){_["is"+name]=function(obj){return toString.call(obj)==="[object "+name+"]"}}),_.isArguments(arguments)||(_.isArguments=function(obj){return _.has(obj,"callee")}),"function"!=typeof/./&&"object"!=typeof Int8Array&&(_.isFunction=function(obj){return"function"==typeof obj||!1}),_.isFinite=function(obj){return isFinite(obj)&&!isNaN(parseFloat(obj))},_.isNaN=function(obj){return _.isNumber(obj)&&obj!==+obj},_.isBoolean=function(obj){return obj===!0||obj===!1||"[object Boolean]"===toString.call(obj)},_.isNull=function(obj){return null===obj},_.isUndefined=function(obj){return void 0===obj},_.has=function(obj,key){return null!=obj&&hasOwnProperty.call(obj,key)},_.noConflict=function(){return root._=previousUnderscore,this},_.identity=function(value){return value},_.constant=function(value){return function(){return value}},_.noop=function(){},_.property=property,_.propertyOf=function(obj){return null==obj?function(){}:function(key){return obj[key]}},_.matcher=_.matches=function(attrs){return attrs=_.extendOwn({},attrs),function(obj){return _.isMatch(obj,attrs)}},_.times=function(n,iteratee,context){var accum=Array(Math.max(0,n));iteratee=optimizeCb(iteratee,context,1);for(var i=0;i<n;i++)accum[i]=iteratee(i);return accum},_.random=function(min,max){return null==max&&(max=min,min=0),min+Math.floor(Math.random()*(max-min+1))},_.now=Date.now||function(){return(new Date).getTime()};var escapeMap={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#x27;","`":"&#x60;"},unescapeMap=_.invert(escapeMap),createEscaper=function(map){var escaper=function(match){return map[match]},source="(?:"+_.keys(map).join("|")+")",testRegexp=RegExp(source),replaceRegexp=RegExp(source,"g");return function(string){return string=null==string?"":""+string,testRegexp.test(string)?string.replace(replaceRegexp,escaper):string}};_.escape=createEscaper(escapeMap),_.unescape=createEscaper(unescapeMap),_.result=function(object,property,fallback){var value=null==object?void 0:object[property];return void 0===value&&(value=fallback),_.isFunction(value)?value.call(object):value};var idCounter=0;_.uniqueId=function(prefix){var id=++idCounter+"";return prefix?prefix+id:id},_.templateSettings={evaluate:/<%([\s\S]+?)%>/g,interpolate:/<%=([\s\S]+?)%>/g,escape:/<%-([\s\S]+?)%>/g};var noMatch=/(.)^/,escapes={"'":"'","\\":"\\","\r":"r","\n":"n","\u2028":"u2028","\u2029":"u2029"},escaper=/\\|'|\r|\n|\u2028|\u2029/g,escapeChar=function(match){return"\\"+escapes[match]};_.template=function(text,settings,oldSettings){!settings&&oldSettings&&(settings=oldSettings),settings=_.defaults({},settings,_.templateSettings);var matcher=RegExp([(settings.escape||noMatch).source,(settings.interpolate||noMatch).source,(settings.evaluate||noMatch).source].join("|")+"|$","g"),index=0,source="__p+='";text.replace(matcher,function(match,escape,interpolate,evaluate,offset){return source+=text.slice(index,offset).replace(escaper,escapeChar),index=offset+match.length,escape?source+="'+\n((__t=("+escape+"))==null?'':_.escape(__t))+\n'":interpolate?source+="'+\n((__t=("+interpolate+"))==null?'':__t)+\n'":evaluate&&(source+="';\n"+evaluate+"\n__p+='"),match}),source+="';\n",settings.variable||(source="with(obj||{}){\n"+source+"}\n"),source="var __t,__p='',__j=Array.prototype.join,print=function(){__p+=__j.call(arguments,'');};\n"+source+"return __p;\n";try{var render=new Function(settings.variable||"obj","_",source)}catch(e){throw e.source=source,e}var template=function(data){return render.call(this,data,_)},argument=settings.variable||"obj";return template.source="function("+argument+"){\n"+source+"}",template},_.chain=function(obj){var instance=_(obj);return instance._chain=!0,instance};var result=function(instance,obj){return instance._chain?_(obj).chain():obj};_.mixin=function(obj){_.each(_.functions(obj),function(name){var func=_[name]=obj[name];_.prototype[name]=function(){var args=[this._wrapped];return push.apply(args,arguments),result(this,func.apply(_,args))}})},_.mixin(_),_.each(["pop","push","reverse","shift","sort","splice","unshift"],function(name){var method=ArrayProto[name];_.prototype[name]=function(){var obj=this._wrapped;return method.apply(obj,arguments),"shift"!==name&&"splice"!==name||0!==obj.length||delete obj[0],result(this,obj)}}),_.each(["concat","join","slice"],function(name){var method=ArrayProto[name];_.prototype[name]=function(){return result(this,method.apply(this._wrapped,arguments))}}),_.prototype.value=function(){return this._wrapped},_.prototype.valueOf=_.prototype.toJSON=_.prototype.value,_.prototype.toString=function(){return""+this._wrapped},__WEBPACK_AMD_DEFINE_ARRAY__=[],__WEBPACK_AMD_DEFINE_RESULT__=function(){return _}.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__),!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__))}).call(this)},function(module,exports,__webpack_require__){module.exports=[{classes:[{name:"GlobalSchema",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[{typeName:"Referencable",nameSpace:"",basicName:"Referencable",typeKind:0,typeArguments:[{typeName:"Sys.SchemaString",nameSpace:"Sys",basicName:"SchemaString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"}],fields:[{name:"key",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["Name of the global schema, used to refer on schema content"]}],valueConstraint:null,optional:!1},{name:"value",type:{typeName:"Sys.SchemaString",nameSpace:"Sys",basicName:"SchemaString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},annotations:[{name:"MetaModel.description",arguments:["Content of the schema"]},{name:"MetaModel.value",arguments:[]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.actuallyExports",arguments:["value"]},{name:"MetaModel.description",arguments:["Content of the schema"]}],extends:[{typeName:"RAMLSimpleElement",nameSpace:"",basicName:"RAMLSimpleElement",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"}],moduleName:"RAMLSpec",annotationOverridings:{}},{name:"Api",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"title",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The title property is a short plain text description of the RESTful API. The value SHOULD be suitable for use as a title for the contained user documentation."]}],valueConstraint:null,optional:!1},{name:"version",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["If the RAML API definition is targeted to a specific API version, the API definition MUST contain a version property. The version property is OPTIONAL and should not be used if: The API itself is not versioned. The API definition does not change between versions. The API architect can decide whether a change to user documentation elements, but no change to the API's resources, constitutes a version change. The API architect MAY use any versioning scheme so long as version numbers retain the same format. For example, 'v3', 'v3.0', and 'V3' are all allowed, but are not considered to be equal."]}],valueConstraint:null,optional:!1},{name:"baseUri",type:{typeName:"Sys.FullUriTemplateString",nameSpace:"Sys",basicName:"FullUriTemplateString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},annotations:[{name:"MetaModel.description",arguments:["(Optional during development; Required after implementation) A RESTful API's resources are defined relative to the API's base URI. The use of the baseUri field is OPTIONAL to allow describing APIs that have not yet been implemented. After the API is implemented (even a mock implementation) and can be accessed at a service endpoint, the API definition MUST contain a baseUri property. The baseUri property's value MUST conform to the URI specification RFC2396 or a Level 1 Template URI as defined in RFC6570. The baseUri property SHOULD only be used as a reference value."]}],valueConstraint:null,optional:!1},{name:"baseUriParameters",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["location","Params.ParameterLocation.BURI"]},{name:"MetaModel.description",arguments:["Base uri parameters are named parameters which described template parameters in the base uri"]}],valueConstraint:null,optional:!1},{name:"uriParameters",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["location","Params.ParameterLocation.BURI"]},{name:"MetaModel.description",arguments:["URI parameters can be further defined by using the uriParameters property. The use of uriParameters is OPTIONAL. The uriParameters property MUST be a map in which each key MUST be the name of the URI parameter as defined in the baseUri property. The uriParameters CANNOT contain a key named version because it is a reserved URI parameter name. The value of the uriParameters property is itself a map that specifies  the property's attributes as named parameters"]}],valueConstraint:null,optional:!1},{name:"protocols",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.oneOf",arguments:[["HTTP","HTTPS"]]},{name:"MetaModel.description",arguments:["A RESTful API can be reached HTTP, HTTPS, or both. The protocols property MAY be used to specify the protocols that an API supports. If the protocols property is not specified, the protocol specified at the baseUri property is used. The protocols property MUST be an array of strings, of values `HTTP` and/or `HTTPS`."]}],valueConstraint:null,optional:!1},{name:"mediaType",type:{typeName:"Bodies.MimeType",nameSpace:"Bodies",basicName:"MimeType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},annotations:[{name:"MetaModel.oftenKeys",arguments:[["application/json","application/xml","application/x-www-form-urlencoded","multipart/formdata"]]},{name:"MetaModel.description",arguments:["(Optional) The media types returned by API responses, and expected from API requests that accept a body, MAY be defaulted by specifying the mediaType property. This property is specified at the root level of the API definition. The property's value MAY be a single string with a valid media type described in the specification."]},{name:"MetaModel.inherited",arguments:[]}],valueConstraint:null,optional:!1},{name:"schemas",type:{base:{typeName:"GlobalSchema",nameSpace:"",basicName:"GlobalSchema",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.description",arguments:["To better achieve consistency and simplicity, the API definition SHOULD include an OPTIONAL schemas property in the root section. The schemas property specifies collections of schemas that could be used anywhere in the API definition. The value of the schemas property is an array of maps; in each map, the keys are the schema name, and the values are schema definitions. The schema definitions MAY be included inline or by using the RAML !include user-defined data type."]}],valueConstraint:null,optional:!1},{name:"traits",type:{base:{typeName:"Methods.Trait",nameSpace:"Methods",basicName:"Trait",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.description",arguments:["Declarations of traits used in this API"]}],valueConstraint:null,optional:!1},{name:"securedBy",type:{base:{typeName:"Security.SecuritySchemeRef",nameSpace:"Security",basicName:"SecuritySchemeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},typeKind:1},annotations:[{name:"MetaModel.allowNull",arguments:[]},{name:"MetaModel.description",arguments:["A list of the security schemes to apply to all methods, these must be defined in the securitySchemes declaration."]}],valueConstraint:null,optional:!1},{name:"securitySchemes",type:{base:{typeName:"Security.AbstractSecurityScheme",nameSpace:"Security",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.description",arguments:["Security schemes that can be applied using securedBy"]}],valueConstraint:null,optional:!1},{name:"resourceTypes",type:{base:{typeName:"Resources.ResourceType",nameSpace:"Resources",basicName:"ResourceType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.description",arguments:["Declaration of resource types used in this API"]}],valueConstraint:null,optional:!1},{name:"resources",type:{base:{typeName:"Resources.Resource",nameSpace:"Resources",basicName:"Resource",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},typeKind:1},annotations:[{name:"MetaModel.newInstanceName",arguments:["New Resource"]},{name:"MetaModel.description",arguments:["Resources are identified by their relative URI, which MUST begin with a slash (/). A resource defined as a root-level property is called a top-level resource. Its property's key is the resource's URI relative to the baseUri. A resource defined as a child property of another resource is called a nested resource, and its property's key is its URI relative to its parent resource's URI. Every property whose key begins with a slash (/), and is either at the root of the API definition or is the child property of a resource property, is a resource property. The key of a resource, i.e. its relative URI, MAY consist of multiple URI path fragments separated by slashes; e.g. `/bom/items` may indicate the collection of items in a bill of materials as a single resource. However, if the individual URI path fragments are themselves resources, the API definition SHOULD use nested resources to describe this structure; e.g. if `/bom` is itself a resource then `/items` should be a nested resource of `/bom`, while `/bom/items` should not be used."]}],valueConstraint:null,optional:!1},{name:"documentation",type:{base:{typeName:"DocumentationItem",nameSpace:"",basicName:"DocumentationItem",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["The API definition can include a variety of documents that serve as a user guides and reference documentation for the API. Such documents can clarify how the API works or provide business context. Documentation-generators MUST include all the sections in an API definition's documentation property in the documentation output, and they MUST preserve the order in which the documentation is declared. To add user documentation to the API, include the documentation property at the root of the API definition. The documentation property MUST be an array of documents. Each document MUST contain title and content attributes, both of which are REQUIRED. If the documentation property is specified, it MUST include at least one document. Documentation-generators MUST process the content field as if it was defined using Markdown."]}],valueConstraint:null,optional:!1},{name:"RAMLVersion",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns AST node of security scheme, this reference refers to, or null."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[],moduleName:"RAMLSpec",annotationOverridings:{}},{name:"DocumentationItem",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"title",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["title of documentation section"]},{name:"MetaModel.required",arguments:[]}],valueConstraint:null,optional:!1},{name:"content",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},annotations:[{name:"MetaModel.description",arguments:["Content of documentation section"]},{name:"MetaModel.required",arguments:[]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"RAMLSimpleElement",nameSpace:"",basicName:"RAMLSimpleElement",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"}],moduleName:"RAMLSpec",annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts",Params:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/common.ts",Bodies:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts",Resources:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts",Methods:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts",Security:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},{classes:[{name:"SpecPartMetaData",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!0,annotations:[],extends:[],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts"},{classes:[{name:"ValueType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[],extends:[],moduleName:null,annotationOverridings:{}},{name:"StringType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["string"]}],extends:[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"AnyType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["any"]}],extends:[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"NumberType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["number"]}],extends:[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"BooleanType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["boolean"]}],extends:[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"Referencable",methods:[],typeParameters:["T"],typeParameterConstraint:[null],implements:[],fields:[],isInterface:!0,annotations:[],extends:[],moduleName:null,annotationOverridings:{}},{name:"Reference",methods:[],typeParameters:["T"],typeParameterConstraint:[null],implements:[],fields:[{name:"structuredValue",type:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns a structured object if the reference point to one."]}],valueConstraint:null,optional:!1},{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns name of referenced object"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"DeclaresDynamicType",methods:[],typeParameters:["T"],typeParameterConstraint:[null],implements:[],fields:[],isInterface:!0,annotations:[],extends:[{typeName:"Referencable",nameSpace:"",basicName:"Referencable",typeKind:0,typeArguments:[{typeName:"T",nameSpace:"",basicName:"T",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"UriTemplate",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This type currently serves both for absolute and relative urls"]}],extends:[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"RelativeUriString",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This  type describes relative uri templates"]}],extends:[{typeName:"UriTemplate",nameSpace:"",basicName:"UriTemplate",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"FullUriTemplateString",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This  type describes absolute uri templates"]}],extends:[{typeName:"UriTemplate",nameSpace:"",basicName:"UriTemplate",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"FixedUri",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{
name:"MetaModel.description",arguments:["This  type describes fixed uris"]}],extends:[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"MarkdownString",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.innerType",arguments:["markdown"]},{name:"MetaModel.description",arguments:["Mardown string is a string which can contain markdown as an extension this markdown should support links with RAML Pointers since 1.0"]}],extends:[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"SchemaString",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Schema at this moment only two subtypes are supported (json schema and xsd)"]}],extends:[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"JSonSchemaString",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.functionalDescriminator",arguments:["this.mediaType&&this.mediaType.isJSON()"]},{name:"MetaModel.description",arguments:["JSON schema"]}],extends:[{typeName:"SchemaString",nameSpace:"",basicName:"SchemaString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"XMLSchemaString",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.innerType",arguments:["xml"]},{name:"MetaModel.description",arguments:["XSD schema"]}],extends:[{typeName:"SchemaString",nameSpace:"",basicName:"SchemaString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"ExampleString",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[],extends:[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"StatusCodeString",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[],extends:[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"JSONExample",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.functionalDescriminator",arguments:["this.mediaType.isJSON()"]}],extends:[{typeName:"ExampleString",nameSpace:"",basicName:"ExampleString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"XMLExample",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.functionalDescriminator",arguments:["this.mediaType.isXML()"]}],extends:[{typeName:"ExampleString",nameSpace:"",basicName:"ExampleString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"TypeInstance",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"properties",type:{base:{typeName:"TypeInstanceProperty",nameSpace:"",basicName:"TypeInstanceProperty",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Array of instance properties"]}],valueConstraint:null,optional:!1},{name:"isScalar",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Whether the type is scalar"]}],valueConstraint:null,optional:!1},{name:"value",type:{typeName:"any",nameSpace:"",basicName:"any",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["For instances of scalar types returns scalar value"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.customHandling",arguments:[]}],extends:[],moduleName:null,annotationOverridings:{}},{name:"TypeInstanceProperty",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Property name"]}],valueConstraint:null,optional:!1},{name:"value",type:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"},annotations:[{name:"MetaModel.description",arguments:["Property value"]}],valueConstraint:null,optional:!1},{name:"values",type:{base:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Array of values if property value is array"]}],valueConstraint:null,optional:!1},{name:"isArray",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Whether property has array as value"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.customHandling",arguments:[]}],extends:[],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/common.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"},{classes:[{name:"RAMLSimpleElement",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[],extends:[],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/common.ts"},{classes:[{name:"Parameter",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["name of the parameter"]},{name:"MetaModel.extraMetaKey",arguments:["headers"]}],valueConstraint:null,optional:!1},{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["An alternate, human-friendly name for the parameter"]}],valueConstraint:null,optional:!1},{name:"type",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.defaultValue",arguments:["string"]},{name:"MetaModel.descriminatingProperty",arguments:[]},{name:"MetaModel.description",arguments:["The type attribute specifies the primitive type of the parameter's resolved value. API clients MUST return/throw an error if the parameter's resolved value does not match the specified type. If type is not specified, it defaults to string."]},{name:"MetaModel.canBeDuplicator",arguments:[]}],valueConstraint:null,optional:!1},{name:"location",type:{typeName:"ParameterLocation",nameSpace:"",basicName:"ParameterLocation",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"},annotations:[{name:"MetaModel.system",arguments:[]},{name:"MetaModel.description",arguments:["Location of the parameter (can not be edited by user)"]}],valueConstraint:null,optional:!1},{name:"required",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Set to true if parameter is required"]},{name:"MetaModel.defaultBooleanValue",arguments:[!0]}],valueConstraint:null,optional:!1},{name:"default",type:{typeName:"any",nameSpace:"",basicName:"any",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The default attribute specifies the default value to use for the property if the property is omitted or its value is not specified. This SHOULD NOT be interpreted as a requirement for the client to send the default attribute's value if there is no other value to send. Instead, the default attribute's value is the value the server uses if the client does not send a value."]}],valueConstraint:null,optional:!1},{name:"example",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["(Optional) The example attribute shows an example value for the property. This can be used, e.g., by documentation generators to generate sample values for the property."]}],valueConstraint:null,optional:!1},{name:"repeat",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The repeat attribute specifies that the parameter can be repeated. If the parameter can be used multiple times, the repeat parameter value MUST be set to 'true'. Otherwise, the default value is 'false' and the parameter may not be repeated."]},{name:"MetaModel.defaultBooleanValue",arguments:[!1]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"},annotations:[{name:"MetaModel.description",arguments:["The description attribute describes the intended use or meaning of the $self. This value MAY be formatted using Markdown."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[],moduleName:null,annotationOverridings:{}},{name:"StringTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"string"},optional:!1},{name:"pattern",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type string) The pattern attribute is a regular expression that a parameter of type string MUST match. Regular expressions MUST follow the regular expression specification from ECMA 262/Perl 5. The pattern MAY be enclosed in double quotes for readability and clarity."]}],valueConstraint:null,optional:!1},{name:"enum",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type string) The enum attribute provides an enumeration of the parameter's valid values. This MUST be an array. If the enum attribute is defined, API clients and servers MUST verify that a parameter's value matches a value in the enum array. If there is no matching value, the clients and servers MUST treat this as an error."]}],valueConstraint:null,optional:!1},{name:"minLength",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type string) The minLength attribute specifies the parameter value's minimum number of characters."]}],valueConstraint:null,optional:!1},{name:"maxLength",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type string) The maxLength attribute specifies the parameter value's maximum number of characters."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value must be a string"]}],extends:[{typeName:"Parameter",nameSpace:"",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"}],moduleName:null,annotationOverridings:{}},{name:"BooleanTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"boolean"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value must be a boolean"]}],extends:[{typeName:"Parameter",nameSpace:"",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"}],moduleName:null,annotationOverridings:{}},{name:"NumberTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"number"},optional:!1},{name:"minimum",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type number or integer) The minimum attribute specifies the parameter's minimum value."]}],valueConstraint:null,optional:!1},{name:"maximum",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type number or integer) The maximum attribute specifies the parameter's maximum value."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value MUST be a number. Indicate floating point numbers as defined by YAML."]}],extends:[{typeName:"Parameter",nameSpace:"",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"}],moduleName:null,annotationOverridings:{}},{name:"IntegerTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"integer"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value MUST be a integer."]}],extends:[{typeName:"NumberTypeDeclaration",nameSpace:"",basicName:"NumberTypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"}],moduleName:null,annotationOverridings:{}},{name:"DateTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"date"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value MUST be a string representation of a date as defined in RFC2616 Section 3.3. "]}],extends:[{typeName:"Parameter",nameSpace:"",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"}],moduleName:null,annotationOverridings:{}},{name:"FileTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"file"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.requireValue",arguments:["location","ParameterLocation.FORM"]},{name:"MetaModel.description",arguments:["(Applicable only to Form properties) Value is a file. Client generators SHOULD use this type to handle file uploads correctly."]}],extends:[{typeName:"Parameter",nameSpace:"",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"}],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[{name:"ParameterLocation",members:["QUERY","HEADERS","URI","FORM","BURI"]}],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/common.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"},{classes:[{name:"MimeType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This sub type of the string represents mime types"]}],extends:[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"}],moduleName:null,annotationOverridings:{}},{name:"BodyLike",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["Mime type of the request or response body"]},{name:"MetaModel.canInherit",arguments:["mediaType"]},{name:"MetaModel.oftenKeys",arguments:[["application/json","application/xml","application/x-www-form-urlencoded","multipart/form-data"]]}],valueConstraint:null,optional:!1},{name:"schema",type:{typeName:"Sys.SchemaString",nameSpace:"Sys",basicName:"SchemaString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},annotations:[{name:"MetaModel.requireValue",arguments:["this.name.isForm()","false"]},{name:"MetaModel.description",arguments:["The structure of a request or response body MAY be further specified by the schema property under the appropriate media type. The schema key CANNOT be specified if a body's media type is application/x-www-form-urlencoded or multipart/form-data. All parsers of RAML MUST be able to interpret JSON Schema and XML Schema. Schema MAY be declared inline or in an external file. However, if the schema is sufficiently large so as to make it difficult for a person to read the API definition, or the schema is reused across multiple APIs or across multiple miles in the same API, the !include user-defined data type SHOULD be used instead of including the content inline. Alternatively, the value of the schema field MAY be the name of a schema specified in the root-level schemas property, or it MAY be declared in an external file and included by using the by using the RAML !include user-defined data type."]}],valueConstraint:null,optional:!1},{name:"example",type:{typeName:"Sys.ExampleString",nameSpace:"Sys",basicName:"ExampleString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},annotations:[{name:"MetaModel.description",arguments:["Documentation generators MUST use body properties' example attributes to generate example invocations."]}],valueConstraint:null,optional:!1},{name:"formParameters",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["location","Params.ParameterLocation.FORM"]},{name:"MetaModel.description",arguments:["Web forms REQUIRE special encoding and custom declaration. If the API's media type is either application/x-www-form-urlencoded or multipart/form-data, the formParameters property MUST specify the name-value pairs that the API is expecting. The formParameters property is a map in which the key is the name of the web form parameter, and the value is itself a map the specifies the web form parameter's attributes."]}],valueConstraint:null,optional:!1},{name:"schemaContent",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns schema content for the cases when schema is inlined, when schema is included, and when schema is a reference."]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},annotations:[{name:"MetaModel.description",arguments:["Human readable description of the body"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.canInherit",arguments:["mediaType"]}],extends:[],moduleName:null,annotationOverridings:{}},{name:"XMLBody",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"schema",type:{typeName:"Sys.XMLSchemaString",nameSpace:"Sys",basicName:"XMLSchemaString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},annotations:[{name:"MetaModel.description",arguments:["XSD Schema"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.functionalDescriminator",arguments:["this.mime.isXML()"]},{name:"MetaModel.description",arguments:["Needed to set connection between xml related mime types and xsd schema"]}],extends:[{typeName:"BodyLike",nameSpace:"",basicName:"BodyLike",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"}],moduleName:null,annotationOverridings:{}},{name:"JSONBody",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"schema",type:{typeName:"Sys.JSonSchemaString",nameSpace:"Sys",basicName:"JSonSchemaString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},annotations:[{name:"MetaModel.description",arguments:["JSON Schema"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.functionalDescriminator",arguments:["this.mime.isJSON()"]},{name:"MetaModel.description",arguments:["Needed to set connection between json related mime types and json schema"]}],extends:[{typeName:"BodyLike",nameSpace:"",basicName:"BodyLike",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"}],moduleName:null,annotationOverridings:{}},{name:"Response",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"code",type:{typeName:"Sys.StatusCodeString",nameSpace:"Sys",basicName:"StatusCodeString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.extraMetaKey",arguments:["statusCodes"]},{name:"MetaModel.description",arguments:["Responses MUST be a map of one or more HTTP status codes, where each status code itself is a map that describes that status code."]}],valueConstraint:null,optional:!1},{name:"headers",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["location","Params.ParameterLocation.HEADERS"]},{name:"MetaModel.newInstanceName",arguments:["New Header"]},{name:"MetaModel.description",arguments:["An API's methods may support custom header values in responses. The custom, non-standard HTTP headers MUST be specified by the headers property. API's may include the the placeholder token {?} in a header name to indicate that any number of headers that conform to the specified format can be sent in responses. This is particularly useful for APIs that allow HTTP headers that conform to some naming convention to send arbitrary, custom data."]}],valueConstraint:null,optional:!1},{name:"body",type:{base:{typeName:"BodyLike",nameSpace:"",basicName:"BodyLike",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},typeKind:1},annotations:[{name:"MetaModel.newInstanceName",arguments:["New Body"]},{name:"MetaModel.description",arguments:["Each response MAY contain a body property, which conforms to the same structure as request body properties (see Body). Responses that can return more than one response code MAY therefore have multiple bodies defined. For APIs without a priori knowledge of the response types for their responses, `*/*` MAY be used to indicate that responses that do not matching other defined data types MUST be accepted. Processing applications MUST match the most descriptive media type first if `*/*` is used."]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},annotations:[{name:"MetaModel.description",arguments:["The description attribute describes the intended use or meaning of the $self. This value MAY be formatted using Markdown."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts",Params:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/common.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},{classes:[{name:"Resource",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"relativeUri",type:{typeName:"Sys.RelativeUriString",nameSpace:"Sys",basicName:"RelativeUriString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.startFrom",arguments:["/"]},{name:"MetaModel.description",arguments:["Relative URL of this resource from the parent resource"]}],valueConstraint:null,optional:!1},{name:"type",type:{typeName:"ResourceTypeRef",nameSpace:"",basicName:"ResourceTypeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},annotations:[{name:"MetaModel.description",arguments:["Instantiation of applyed resource type"]}],valueConstraint:null,optional:!1},{name:"is",type:{base:{typeName:"TraitRef",nameSpace:"",basicName:"TraitRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Instantiation of applyed traits"]}],valueConstraint:null,optional:!1},{name:"securedBy",type:{base:{typeName:"SecuritySchemeRef",nameSpace:"",basicName:"SecuritySchemeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.allowNull",arguments:[]},{name:"MetaModel.description",arguments:["securityScheme may also be applied to a resource by using the securedBy key, which is equivalent to applying the securityScheme to all methods that may be declared, explicitly or implicitly, by defining the resourceTypes or traits property for that resource. To indicate that the method may be called without applying any securityScheme, the method may be annotated with the null securityScheme."]}],valueConstraint:null,optional:!1},{name:"uriParameters",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.setsContextValue",arguments:["location","Params.ParameterLocation.URI"]},{name:"MetaModel.description",arguments:["Uri parameters of this resource"]}],valueConstraint:null,optional:!1},{name:"methods",type:{base:{typeName:"Methods.Method",nameSpace:"Methods",basicName:"Method",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.newInstanceName",arguments:["New Method"]},{name:"MetaModel.description",arguments:["Methods that can be called on this resource"]}],valueConstraint:null,optional:!1},{name:"resources",type:{base:{typeName:"Resource",nameSpace:"",basicName:"Resource",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.newInstanceName",arguments:["New Resource"]},{name:"MetaModel.description",arguments:["Children resources"]}],valueConstraint:null,optional:!1},{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{
name:"MetaModel.description",arguments:["An alternate, human-friendly name for the resource"]}],valueConstraint:null,optional:!1},{name:"baseUriParameters",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.setsContextValue",arguments:["location","Params.ParameterLocation.BURI"]},{name:"MetaModel.description",arguments:["A resource or a method can override a base URI template's values. This is useful to restrict or change the default or parameter selection in the base URI. The baseUriParameters property MAY be used to override any or all parameters defined at the root level baseUriParameters property, as well as base URI parameters not specified at the root level."]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},annotations:[{name:"MetaModel.description",arguments:["The description attribute describes the intended use or meaning of the $self. This value MAY be formatted using Markdown."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[],moduleName:null,annotationOverridings:{}},{name:"ResourceTypeRef",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"resourceType",type:{typeName:"ResourceType",nameSpace:"",basicName:"ResourceType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns referenced resource type"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"Reference",nameSpace:"",basicName:"Reference",typeKind:0,typeArguments:[{typeName:"ResourceType",nameSpace:"",basicName:"ResourceType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"}],moduleName:null,annotationOverridings:{}},{name:"ResourceType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[{typeName:"DeclaresDynamicType",nameSpace:"",basicName:"DeclaresDynamicType",typeKind:0,typeArguments:[{typeName:"ResourceType",nameSpace:"",basicName:"ResourceType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"}],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["Name of the resource type"]}],valueConstraint:null,optional:!1},{name:"usage",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Instructions on how and when the resource type should be used."]}],valueConstraint:null,optional:!1},{name:"methods",type:{base:{typeName:"Methods.Method",nameSpace:"Methods",basicName:"Method",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Methods that are part of this resource type definition"]}],valueConstraint:null,optional:!1},{name:"is",type:{base:{typeName:"Security.TraitRef",nameSpace:"Security",basicName:"TraitRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Instantiation of applyed traits"]}],valueConstraint:null,optional:!1},{name:"type",type:{typeName:"ResourceTypeRef",nameSpace:"",basicName:"ResourceTypeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},annotations:[{name:"MetaModel.description",arguments:["Instantiation of applyed resource type"]}],valueConstraint:null,optional:!1},{name:"securedBy",type:{base:{typeName:"Security.SecuritySchemeRef",nameSpace:"Security",basicName:"SecuritySchemeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.allowNull",arguments:[]},{name:"MetaModel.description",arguments:["securityScheme may also be applied to a resource by using the securedBy key, which is equivalent to applying the securityScheme to all methods that may be declared, explicitly or implicitly, by defining the resourceTypes or traits property for that resource. To indicate that the method may be called without applying any securityScheme, the method may be annotated with the null securityScheme."]}],valueConstraint:null,optional:!1},{name:"uriParameters",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["location","Params.ParameterLocation.URI"]},{name:"MetaModel.description",arguments:["Uri parameters of this resource"]}],valueConstraint:null,optional:!1},{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["An alternate, human-friendly name for the resource type"]}],valueConstraint:null,optional:!1},{name:"baseUriParameters",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.setsContextValue",arguments:["location","Params.ParameterLocation.BURI"]},{name:"MetaModel.description",arguments:["A resource or a method can override a base URI template's values. This is useful to restrict or change the default or parameter selection in the base URI. The baseUriParameters property MAY be used to override any or all parameters defined at the root level baseUriParameters property, as well as base URI parameters not specified at the root level."]}],valueConstraint:null,optional:!1},{name:"parametrizedProperties",type:{typeName:"Sys.TypeInstance",nameSpace:"Sys",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns object representation of parametrized properties of the resource type"]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},annotations:[{name:"MetaModel.description",arguments:["The description attribute describes the intended use or meaning of the $self. This value MAY be formatted using Markdown."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.inlinedTemplates",arguments:[]},{name:"MetaModel.allowQuestion",arguments:[]}],extends:[],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts",Params:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts",Bodies:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/common.ts",Methods:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts",Security:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},{classes:[{name:"MethodBase",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"responses",type:{base:{typeName:"Bodies.Response",nameSpace:"Bodies",basicName:"Response",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.newInstanceName",arguments:["New Response"]},{name:"MetaModel.description",arguments:["Resource methods MAY have one or more responses. Responses MAY be described using the description property, and MAY include example attributes or schema properties."]}],valueConstraint:null,optional:!1},{name:"body",type:{base:{typeName:"Bodies.BodyLike",nameSpace:"Bodies",basicName:"BodyLike",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.newInstanceName",arguments:["New Body"]},{name:"MetaModel.description",arguments:["Some method verbs expect the resource to be sent as a request body. For example, to create a resource, the request must include the details of the resource to create. Resources CAN have alternate representations. For example, an API might support both JSON and XML representations. A method's body is defined in the body property as a hashmap, in which the key MUST be a valid media type."]}],valueConstraint:null,optional:!1},{name:"protocols",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.oneOf",arguments:[["HTTP","HTTPS"]]},{name:"MetaModel.description",arguments:["A method can override an API's protocols value for that single method by setting a different value for the fields."]}],valueConstraint:null,optional:!1},{name:"securedBy",type:{base:{typeName:"SecuritySchemeRef",nameSpace:"",basicName:"SecuritySchemeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.allowNull",arguments:[]},{name:"MetaModel.description",arguments:["A list of the security schemas to apply, these must be defined in the securitySchemes declaration. To indicate that the method may be called without applying any securityScheme, the method may be annotated with the null securityScheme. Security schemas may also be applied to a resource with securedBy, which is equivalent to applying the security schemas to all methods that may be declared, explicitly or implicitly, by defining the resourceTypes or traits property for that resource."]}],valueConstraint:null,optional:!1},{name:"baseUriParameters",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.setsContextValue",arguments:["location","Params.ParameterLocation.BURI"]},{name:"MetaModel.description",arguments:["A resource or a method can override a base URI template's values. This is useful to restrict or change the default or parameter selection in the base URI. The baseUriParameters property MAY be used to override any or all parameters defined at the root level baseUriParameters property, as well as base URI parameters not specified at the root level."]}],valueConstraint:null,optional:!1},{name:"queryParameters",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["location","ParameterLocation.QUERY"]},{name:"MetaModel.newInstanceName",arguments:["New query parameter"]},{name:"MetaModel.description",arguments:["An APIs resources MAY be filtered (to return a subset of results) or altered (such as transforming a response body from JSON to XML format) by the use of query strings. If the resource or its method supports a query string, the query string MUST be defined by the queryParameters property"]}],valueConstraint:null,optional:!1},{name:"headers",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["location","ParameterLocation.HEADERS"]},{name:"MetaModel.description",arguments:["Headers that allowed at this position"]},{name:"MetaModel.newInstanceName",arguments:["New Header"]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},annotations:[],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Method object allows description of http methods"]}],extends:[],moduleName:null,annotationOverridings:{}},{name:"Method",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"method",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.extraMetaKey",arguments:["methods"]},{name:"MetaModel.oneOf",arguments:[["get","put","post","delete","patch","options","head","trace","connect"]]},{name:"MetaModel.description",arguments:["Method that can be called"]}],valueConstraint:null,optional:!1},{name:"is",type:{base:{typeName:"TraitRef",nameSpace:"",basicName:"TraitRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Instantiation of applyed traits"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"MethodBase",nameSpace:"",basicName:"MethodBase",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"}],moduleName:null,annotationOverridings:{}},{name:"Trait",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[{typeName:"DeclaresDynamicType",nameSpace:"",basicName:"DeclaresDynamicType",typeKind:0,typeArguments:[{typeName:"Trait",nameSpace:"",basicName:"Trait",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"}],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["Name of the trait"]}],valueConstraint:null,optional:!1},{name:"usage",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Instructions on how and when the trait should be used."]}],valueConstraint:null,optional:!1},{name:"parametrizedProperties",type:{typeName:"Sys.TypeInstance",nameSpace:"Sys",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns object representation of parametrized properties of the trait"]}],valueConstraint:null,optional:!1},{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["An alternate, human-friendly name for the trait"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.inlinedTemplates",arguments:[]},{name:"MetaModel.allowQuestion",arguments:[]}],extends:[{typeName:"MethodBase",nameSpace:"",basicName:"MethodBase",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"}],moduleName:null,annotationOverridings:{}},{name:"TraitRef",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"trait",type:{typeName:"Trait",nameSpace:"",basicName:"Trait",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns referenced trait"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"Reference",nameSpace:"",basicName:"Reference",typeKind:0,typeArguments:[{typeName:"Trait",nameSpace:"",basicName:"Trait",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"}],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts",Params:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts",Bodies:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/common.ts",Security:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},{classes:[{name:"SecuritySchemePart",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["An alternate, human-friendly name for the security scheme part"]}],valueConstraint:null,optional:!1},{name:"is",type:{base:{typeName:"TraitRef",nameSpace:"",basicName:"TraitRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Instantiation of applyed traits"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"MethodBase",nameSpace:"",basicName:"MethodBase",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],moduleName:null,annotationOverridings:{headers:[{name:"MetaModel.markdownDescription",arguments:["Optional array of headers, documenting the possible headers that could be accepted."]},{name:"MetaModel.valueDescription",arguments:["Object whose property names are the request header names and whose values describe the values."]}],queryParameters:[{name:"MetaModel.markdownDescription",arguments:["Query parameters, used by the schema in order to authorize the request. Mutually exclusive with queryString."]},{name:"MetaModel.valueDescription",arguments:["Object whose property names are the query parameter names and whose values describe the values."]}],queryString:[{name:"MetaModel.description",arguments:["Specifies the query string, used by the schema in order to authorize the request. Mutually exclusive with queryParameters."]},{name:"MetaModel.valueDescription",arguments:["Type name or type declaration"]}],responses:[{name:"MetaModel.description",arguments:["Optional array of responses, describing the possible responses that could be sent."]}],description:[{name:"MetaModel.description",arguments:["A longer, human-friendly description of the security scheme part"]},{name:"MetaModel.valueDescription",arguments:["Markdown string"]}]}},{name:"SecuritySchemeSettings",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.allowAny",arguments:[]}],extends:[],moduleName:null,annotationOverridings:{}},{name:"AbstractSecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[{typeName:"Referencable",nameSpace:"",basicName:"Referencable",typeKind:0,typeArguments:[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.startFrom",arguments:[""]},{name:"MetaModel.hide",arguments:[]},{name:"MetaModel.description",arguments:["Name of the security scheme"]}],valueConstraint:null,optional:!1},{name:"type",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.oneOf",arguments:[["OAuth 1.0","OAuth 2.0","Basic Authentication","DigestSecurityScheme Authentication","x-{other}"]]},{name:"MetaModel.descriminatingProperty",arguments:[]},{name:"MetaModel.description",arguments:["The securitySchemes property MUST be used to specify an API's security mechanisms, including the required settings and the authentication methods that the API supports. one authentication method is allowed if the API supports them."]},{name:"MetaModel.valueDescription",arguments:["string<br><br>The value MUST be one of<br>* OAuth 1.0,<br>* OAuth 2.0, <br>* BasicSecurityScheme Authentication<br>* DigestSecurityScheme Authentication<br>* x-&lt;other&gt;"]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[{name:"MetaModel.description",arguments:["The description attribute MAY be used to describe a security schemes property."]}],valueConstraint:null,optional:!1},{name:"describedBy",type:{typeName:"SecuritySchemePart",nameSpace:"",basicName:"SecuritySchemePart",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[{name:"MetaModel.description",arguments:["A description of the request components related to Security that are determined by the scheme: the headers, query parameters or responses. As a best practice, even for standard security schemes, API designers SHOULD describe these properties of security schemes. Including the security scheme description completes an API documentation."]}],valueConstraint:null,optional:!1},{name:"settings",type:{typeName:"SecuritySchemeSettings",nameSpace:"",basicName:"SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[{name:"MetaModel.description",arguments:["The settings attribute MAY be used to provide security scheme-specific information. The required attributes vary depending on the type of security scheme is being declared. It describes the minimum set of properties which any processing application MUST provide and validate if it chooses to implement the security scheme. Processing applications MAY choose to recognize other properties for things such as token lifetime, preferred cryptographic algorithms, and more."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security schema definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],extends:[],moduleName:null,annotationOverridings:{}},{name:"SecuritySchemeRef",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"securitySchemeName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns the name of security scheme, this reference refers to."]}],valueConstraint:null,optional:!1},{name:"securityScheme",type:{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns AST node of security scheme, this reference refers to, or null."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.allowAny",arguments:[]}],extends:[{typeName:"Reference",nameSpace:"",basicName:"Reference",typeKind:0,typeArguments:[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"OAuth1SecuritySchemeSettings",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"requestTokenUri",type:{typeName:"Sys.FixedUri",nameSpace:"Sys",basicName:"FixedUri",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The URI of the Temporary Credential Request endpoint as defined in RFC5849 Section 2.1"]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1},{name:"authorizationUri",type:{typeName:"Sys.FixedUri",nameSpace:"Sys",basicName:"FixedUri",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The URI of the Resource Owner Authorization endpoint as defined in RFC5849 Section 2.2"]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1},{name:"tokenCredentialsUri",type:{typeName:"Sys.FixedUri",nameSpace:"Sys",basicName:"FixedUri",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The URI of the Token Request endpoint as defined in RFC5849 Section 2.3"]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.allowAny",arguments:[]},{name:"MetaModel.functionalDescriminator",arguments:["$parent.type=='OAuth 1.0'"]}],extends:[{typeName:"SecuritySchemeSettings",nameSpace:"",basicName:"SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"OAuth2SecuritySchemeSettings",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"accessTokenUri",type:{typeName:"Sys.FixedUri",nameSpace:"Sys",basicName:"FixedUri",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The URI of the Token Endpoint as defined in RFC6749 Section 3.2. Not required forby implicit grant type."]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1},{name:"authorizationUri",type:{typeName:"Sys.FixedUri",nameSpace:"Sys",basicName:"FixedUri",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The URI of the Authorization Endpoint as defined in RFC6749 Section 3.1. Required forby authorization_code and implicit grant types."]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1},{name:"authorizationGrants",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["A list of the Authorization grants supported by the API as defined in RFC6749 Sections 4.1, 4.2, 4.3 and 4.4, can be any of: authorization_code, password, client_credentials, implicit, or refresh_token."]},{name:"MetaModel.markdownDescription",arguments:["A list of the Authorization grants supported by the API as defined in RFC6749 Sections 4.1, 4.2, 4.3 and 4.4, can be any of:<br>* authorization_code<br>* password<br>* client_credentials <br>* implicit<br>* refresh_token."]}],valueConstraint:null,optional:!1},{name:"scopes",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["A list of scopes supported by the security scheme as defined in RFC6749 Section 3.3"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.allowAny",arguments:[]}],extends:[{typeName:"SecuritySchemeSettings",nameSpace:"",basicName:"SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"
}],moduleName:null,annotationOverridings:{}},{name:"OAuth2SecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"OAuth 2.0"},optional:!1},{name:"settings",type:{typeName:"OAuth2SecuritySchemeSettings",nameSpace:"",basicName:"OAuth2SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security schema definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],extends:[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"OAuth1SecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"OAuth 1.0"},optional:!1},{name:"settings",type:{typeName:"OAuth1SecuritySchemeSettings",nameSpace:"",basicName:"OAuth1SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security schema definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],extends:[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"BasicSecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"Basic Authentication"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security schema definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],extends:[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"DigestSecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"Digest Authentication"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security schema definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],extends:[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"CustomSecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"x-{other}"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security schema definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],extends:[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts",Params:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts",Bodies:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/common.ts",Methods:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}]},function(module,exports,__webpack_require__){module.exports=[{classes:[{name:"Library",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"usage",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["contains description of why library exist"]}],valueConstraint:null,optional:!1},{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["Namespace which the library is imported under"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"LibraryBase",nameSpace:"",basicName:"LibraryBase",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"}],moduleName:null,annotationOverridings:{}},{name:"LibraryBase",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"schemas",type:{base:{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.description",arguments:['Alias for the equivalent "types" property, for compatibility with RAML 0.8. Deprecated - API definitions should use the "types" property, as the "schemas" alias for that property name may be removed in a future RAML version. The "types" property allows for XML and JSON schemas.']}],valueConstraint:null,optional:!1},{name:"types",type:{base:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.setsContextValue",arguments:["locationKind","DataModel.LocationKind.MODELS"]},{name:"MetaModel.description",arguments:["Declarations of (data) types for use within this API"]},{name:"MetaModel.markdownDescription",arguments:["Declarations of (data) types for use within this API."]},{name:"MetaModel.valueDescription",arguments:["An object whose properties map type names to type declarations; or an array of such objects"]}],valueConstraint:null,optional:!1},{name:"traits",type:{base:{typeName:"Methods.Trait",nameSpace:"Methods",basicName:"Trait",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.description",arguments:["Declarations of traits used in this API"]},{name:"MetaModel.description",arguments:["Declarations of traits for use within this API"]},{name:"MetaModel.markdownDescription",arguments:["Declarations of traits for use within this API."]},{name:"MetaModel.valueDescription",arguments:["An object whose properties map trait names to trait declarations; or an array of such objects"]}],valueConstraint:null,optional:!1},{name:"resourceTypes",type:{base:{typeName:"Resources.ResourceType",nameSpace:"Resources",basicName:"ResourceType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.description",arguments:["Declaration of resource types used in this API"]},{name:"MetaModel.description",arguments:["Declarations of resource types for use within this API"]},{name:"MetaModel.markdownDescription",arguments:["Declarations of resource types for use within this API."]},{name:"MetaModel.valueDescription",arguments:["An object whose properties map resource type names to resource type declarations; or an array of such objects"]}],valueConstraint:null,optional:!1},{name:"annotationTypes",type:{base:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["decls","true"]},{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.description",arguments:["Declarations of annotation types for use by annotations"]},{name:"MetaModel.markdownDescription",arguments:["Declarations of annotation types for use by annotations."]},{name:"MetaModel.valueDescription",arguments:["An object whose properties map annotation type names to annotation type declarations; or an array of such objects"]}],valueConstraint:null,optional:!1},{name:"securitySchemes",type:{base:{typeName:"Security.AbstractSecurityScheme",nameSpace:"Security",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.description",arguments:["Security schemas declarations"]},{name:"MetaModel.description",arguments:["Declarations of security schemes for use within this API."]},{name:"MetaModel.markdownDescription",arguments:["Declarations of security schemes for use within this API."]},{name:"MetaModel.valueDescription",arguments:["An object whose properties map security scheme names to security scheme declarations; or an array of such objects"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.internalClass",arguments:[]}],extends:[{typeName:"FragmentDeclaration",nameSpace:"",basicName:"FragmentDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"}],moduleName:null,annotationOverridings:{}},{name:"Api",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"title",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["Short plain-text label for the API"]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},annotations:[{name:"MetaModel.description",arguments:["A longer, human-friendly description of the API"]}],valueConstraint:null,optional:!1},{name:"version",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The version of the API, e.g. 'v1'"]}],valueConstraint:null,optional:!1},{name:"baseUri",type:{typeName:"Sys.FullUriTemplateString",nameSpace:"Sys",basicName:"FullUriTemplateString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},annotations:[{name:"MetaModel.description",arguments:["A URI that's to be used as the base of all the resources' URIs. Often used as the base of the URL of each resource, containing the location of the API. Can be a template URI."]}],valueConstraint:null,optional:!1},{name:"baseUriParameters",type:{base:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["location","DataModel.ModelLocation.BURI"]},{name:"MetaModel.setsContextValue",arguments:["locationKind","DataModel.LocationKind.APISTRUCTURE"]},{name:"MetaModel.description",arguments:["Named parameters used in the baseUri (template)"]}],valueConstraint:null,optional:!1},{name:"protocols",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.oneOf",arguments:[["HTTP","HTTPS"]]},{name:"MetaModel.description",arguments:["The protocols supported by the API"]},{name:"MetaModel.valueDescription",arguments:['Array of strings, with each being "HTTP" or "HTTPS", case-insensitive']}],valueConstraint:null,optional:!1},{name:"mediaType",type:{base:{typeName:"Bodies.MimeType",nameSpace:"Bodies",basicName:"MimeType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.oftenKeys",arguments:[["application/json","application/xml","application/x-www-form-urlencoded","multipart/form-data"]]},{name:"MetaModel.description",arguments:['The default media type to use for request and response bodies (payloads), e.g. "application/json"']},{name:"MetaModel.inherited",arguments:[]},{name:"MetaModel.valueDescription",arguments:["Media type string"]}],valueConstraint:null,optional:!1},{name:"securedBy",type:{base:{typeName:"Security.SecuritySchemeRef",nameSpace:"Security",basicName:"SecuritySchemeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["The security schemes that apply to every resource and method in the API"]}],valueConstraint:null,optional:!1},{name:"resources",type:{base:{typeName:"Resources.Resource",nameSpace:"Resources",basicName:"Resource",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.documentationTableLabel",arguments:["/&lt;relativeUri&gt;"]},{name:"MetaModel.newInstanceName",arguments:["New Resource"]},{name:"MetaModel.description",arguments:["The resources of the API, identified as relative URIs that begin with a slash (/). Every property whose key begins with a slash (/), and is either at the root of the API definition or is the child property of a resource property, is a resource property, e.g.: /users, /{groupId}, etc"]}],valueConstraint:null,optional:!1},{name:"documentation",type:{base:{typeName:"DocumentationItem",nameSpace:"",basicName:"DocumentationItem",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Additional overall documentation for the API"]}],valueConstraint:null,optional:!1},{name:"RAMLVersion",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:['Returns RAML version. "RAML10" string is returned for RAML 1.0. "RAML08" string is returned for RAML 0.8.']}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"LibraryBase",nameSpace:"",basicName:"LibraryBase",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"}],moduleName:null,annotationOverridings:{annotations:[{name:"MetaModel.markdownDescription",arguments:['Annotations to be applied to this API. Annotations are any property whose key begins with "(" and ends with ")" and whose name (the part between the beginning and ending parentheses) is a declared annotation name.']}]}},{name:"Overlay",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"usage",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["contains description of why overlay exist"]}],valueConstraint:null,optional:!1},{name:"extends",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["Location of a valid RAML API definition (or overlay or extension), the overlay is applied to."]}],valueConstraint:null,optional:!1},{name:"title",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Short plain-text label for the API"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"Api",nameSpace:"",basicName:"Api",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"}],moduleName:null,annotationOverridings:{}},{name:"Extension",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"usage",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["contains description of why extension exist"]}],valueConstraint:null,optional:!1},{name:"extends",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["Location of a valid RAML API definition (or overlay or extension), the extension is applied to"]}],valueConstraint:null,optional:!1},{name:"title",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Short plain-text label for the API"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"Api",nameSpace:"",basicName:"Api",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"}],moduleName:null,annotationOverridings:{}},{name:"UsesDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"key",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["Name prefix (without dot) used to refer imported declarations"]}],valueConstraint:null,optional:!1},{name:"value",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Content of the schema"]},{name:"MetaModel.canBeValue",arguments:[]},{name:"MetaModel.value",arguments:[]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"}],moduleName:null,annotationOverridings:{}},{name:"FragmentDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"uses",type:{base:{typeName:"UsesDeclaration",nameSpace:"",basicName:"UsesDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"}],moduleName:null,annotationOverridings:{}},{name:"DocumentationItem",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"title",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Title of documentation section"]},{name:"MetaModel.required",arguments:[]}],valueConstraint:null,optional:!1},{name:"content",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},annotations:[{name:"MetaModel.description",arguments:["Content of documentation section"]},{name:"MetaModel.required",arguments:[]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.possibleInterfaces",arguments:[["FragmentDeclaration"]]}],extends:[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"}],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts",Methods:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts",Resources:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts",Decls:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/declarations.ts",Params:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/parameters.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/common.ts",Bodies:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts",DataModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts",Security:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},{classes:[{name:"SpecPartMetaData",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!0,annotations:[],extends:[],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts"},{classes:[{name:"ValueType",methods:[{returnType:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},name:"value",start:170,end:210,text:"\n\n  value():string {\n    return null\n  }",arguments:[]}],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[],extends:[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"StringType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["string"]},{name:"MetaModel.alias",arguments:["string"]}],extends:[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"AnyType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["any"]},{name:"MetaModel.alias",arguments:["any"]}],extends:[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"NumberType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["number"]},{name:"MetaModel.alias",arguments:["number"]}],extends:[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"IntegerType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["integer"]},{name:"MetaModel.alias",arguments:["integer"]}],extends:[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"NullType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["null"]},{name:"MetaModel.alias",arguments:["null"]}],extends:[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"TimeOnlyType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["time-only"]},{name:"MetaModel.alias",arguments:["time-only"]}],extends:[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"DateOnlyType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["date-only"]},{name:"MetaModel.alias",arguments:["date-only"]}],extends:[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"DateTimeOnlyType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["datetime-only"]},{name:"MetaModel.alias",arguments:["datetime-only"]}],extends:[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"DateTimeType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["datetime"]},{name:"MetaModel.alias",arguments:["datetime"]}],extends:[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"FileType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["file"]},{name:"MetaModel.alias",arguments:["file"]}],extends:[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"BooleanType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["boolean"]},{name:"MetaModel.alias",arguments:["boolean"]}],extends:[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"Reference",methods:[],typeParameters:["T"],typeParameterConstraint:[null],implements:[],fields:[{name:"structuredValue",type:{typeName:"DataModel.TypeInstance",nameSpace:"DataModel",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns a structured object if the reference point to one."]}],valueConstraint:null,optional:!1},{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns name of referenced object"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"UriTemplate",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This type currently serves both for absolute and relative urls"]}],extends:[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"StatusCodeString",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[],extends:[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"RelativeUriString",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This  type describes relative uri templates"]}],extends:[{typeName:"UriTemplate",
nameSpace:"",basicName:"UriTemplate",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"FullUriTemplateString",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This  type describes absolute uri templates"]}],extends:[{typeName:"UriTemplate",nameSpace:"",basicName:"UriTemplate",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"FixedUriString",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This  type describes fixed uris"]}],extends:[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"ContentType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[],extends:[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"MarkdownString",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.innerType",arguments:["markdown"]},{name:"MetaModel.description",arguments:["[GitHub Flavored Markdown](https://help.github.com/articles/github-flavored-markdown/)"]}],extends:[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"SchemaString",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Schema at this moment only two subtypes are supported (json schema and xsd)"]},{name:"MetaModel.alias",arguments:["schema"]}],extends:[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",DataModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/common.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"},{classes:[{name:"ExampleSpec",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"value",type:{typeName:"any",nameSpace:"",basicName:"any",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.example",arguments:[]},{name:"MetaModel.selfNode",arguments:[]},{name:"MetaModel.description",arguments:["String representation of example"]},{name:"MetaModel.required",arguments:[]},{name:"MetaModel.valueDescription",arguments:["* Valid value for this type<br>* String representing the serialized version of a valid value"]}],valueConstraint:null,optional:!1},{name:"structuredValue",type:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns object representation of example, if possible"]}],valueConstraint:null,optional:!1},{name:"strict",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["By default, examples are validated against any type declaration. Set this to false to allow examples that need not validate."]}],valueConstraint:null,optional:!1},{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.hide",arguments:[]},{name:"MetaModel.description",arguments:["Example identifier, if specified"]}],valueConstraint:null,optional:!1},{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["An alternate, human-friendly name for the example"]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.description",arguments:["A longer, human-friendly description of the example"]},{name:"MetaModel.valueDescription",arguments:["markdown string"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.possibleInterfaces",arguments:[["FragmentDeclaration"]]}],extends:[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{annotations:[{name:"MetaModel.markdownDescription",arguments:['Annotations to be applied to this example. Annotations are any property whose key begins with "(" and ends with ")" and whose name (the part between the beginning and ending parentheses) is a declared annotation name.']}]}},{name:"TypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["name of the parameter"]},{name:"MetaModel.extraMetaKey",arguments:["headers"]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1},{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The displayName attribute specifies the type display name. It is a friendly name used only for  display or documentation purposes. If displayName is not specified, it defaults to the element's key (the name of the property itself)."]}],valueConstraint:null,optional:!1},{name:"facets",type:{base:{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},typeKind:1},annotations:[{name:"MetaModel.declaringFields",arguments:[]},{name:"MetaModel.description",arguments:["When extending from a type you can define new facets (which can then be set to concrete values by subtypes)."]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1},{name:"fixedFacets",type:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns facets fixed by the type. Value is an object with properties named after facets fixed. Value of each property is a value of the corresponding facet."]}],valueConstraint:null,optional:!1},{name:"schema",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.typeExpression",arguments:[]},{name:"MetaModel.allowMultiple",arguments:[]},{name:"MetaModel.description",arguments:['Alias for the equivalent "type" property, for compatibility with RAML 0.8. Deprecated - API definitions should use the "type" property, as the "schema" alias for that property name may be removed in a future RAML version. The "type" property allows for XML and JSON schemas.']},{name:"MetaModel.valueDescription",arguments:["Single string denoting the base type or type expression"]}],valueConstraint:null,optional:!1},{name:"type",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.typeExpression",arguments:[]},{name:"MetaModel.allowMultiple",arguments:[]},{name:"MetaModel.canBeValue",arguments:[]},{name:"MetaModel.defaultValue",arguments:["string"]},{name:"MetaModel.descriminatingProperty",arguments:[]},{name:"MetaModel.description",arguments:["A base type which the current type extends, or more generally a type expression."]},{name:"MetaModel.valueDescription",arguments:["string denoting the base type or type expression"]}],valueConstraint:null,optional:!1},{name:"structuredType",type:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.typeExpression",arguments:[]},{name:"MetaModel.description",arguments:["Inlined supertype definition."]},{name:"MetaModel.valueDescription",arguments:["Inlined supertype definition"]}],valueConstraint:null,optional:!1},{name:"location",type:{typeName:"ModelLocation",nameSpace:"",basicName:"ModelLocation",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.system",arguments:[]},{name:"MetaModel.description",arguments:["Location of the parameter (can not be edited by user)"]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1},{name:"locationKind",type:{typeName:"LocationKind",nameSpace:"",basicName:"LocationKind",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.system",arguments:[]},{name:"MetaModel.description",arguments:["Kind of location"]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1},{name:"default",type:{typeName:"any",nameSpace:"",basicName:"any",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Provides default value for a property"]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1},{name:"example",type:{typeName:"ExampleSpec",nameSpace:"",basicName:"ExampleSpec",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.example",arguments:[]},{name:"MetaModel.selfNode",arguments:[]},{name:"MetaModel.description",arguments:["An example of this type instance represented as string or yaml map/sequence. This can be used, e.g., by documentation generators to generate sample values for an object of this type. Cannot be present if the examples property is present."]},{name:"MetaModel.valueDescription",arguments:["* Valid value for this type<br>* String representing the serialized version of a valid value"]}],valueConstraint:null,optional:!1},{name:"examples",type:{base:{typeName:"ExampleSpec",nameSpace:"",basicName:"ExampleSpec",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},typeKind:1},annotations:[{name:"MetaModel.example",arguments:[]},{name:"MetaModel.selfNode",arguments:[]},{name:"MetaModel.description",arguments:["An example of this type instance represented as string. This can be used, e.g., by documentation generators to generate sample values for an object of this type. Cannot be present if the example property is present."]},{name:"MetaModel.valueDescription",arguments:["* Valid value for this type<br>* String representing the serialized version of a valid value"]}],valueConstraint:null,optional:!1},{name:"required",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.requireValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.description",arguments:["Sets if property is optional or not"]},{name:"MetaModel.describesAnnotation",arguments:["required"]},{name:"MetaModel.hide",arguments:[]},{name:"MetaModel.defaultBooleanValue",arguments:[!0]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.description",arguments:["A longer, human-friendly description of the type"]},{name:"MetaModel.valueDescription",arguments:["markdown string"]}],valueConstraint:null,optional:!1},{name:"xml",type:{typeName:"XMLFacetInfo",nameSpace:"",basicName:"XMLFacetInfo",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[],valueConstraint:null,optional:!1},{name:"allowedTargets",type:{base:{typeName:"AnnotationTarget",nameSpace:"",basicName:"AnnotationTarget",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},typeKind:1},annotations:[{name:"MetaModel.oneOf",arguments:[["API","DocumentationItem","Resource","Method","Response","RequestBody","ResponseBody","TypeDeclaration","NamedExample","ResourceType","Trait","SecurityScheme","SecuritySchemeSettings","AnnotationTypeDeclaration","Library","Overlay","Extension","Scalar"]]},{name:"MetaModel.description",arguments:["Restrictions on where annotations of this type can be applied. If this property is specified, annotations of this type may only be applied on a property corresponding to one of the target names specified as the value of this property."]},{name:"MetaModel.valueDescription",arguments:["An array, or single, of names allowed target nodes."]}],valueConstraint:null,optional:!1},{name:"isAnnotation",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Whether the type represents annotation"]}],valueConstraint:null,optional:!1},{name:"parametrizedProperties",type:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["For types defined in traits or resource types returns object representation of parametrized properties"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.convertsToGlobalOfType",arguments:["SchemaString"]},{name:"MetaModel.canInherit",arguments:["mediaType"]},{name:"MetaModel.possibleInterfaces",arguments:[["FragmentDeclaration"]]}],extends:[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{annotations:[{name:"MetaModel.markdownDescription",arguments:['Annotations to be applied to this type. Annotations are any property whose key begins with "(" and ends with ")" and whose name (the part between the beginning and ending parentheses) is a declared annotation name.']}]}},{name:"XMLFacetInfo",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"attribute",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["If attribute is set to true, a type instance should be serialized as an XML attribute. It can only be true for scalar types."]}],valueConstraint:null,optional:!1},{name:"wrapped",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["If wrapped is set to true, a type instance should be wrapped in its own XML element. It can not be true for scalar types and it can not be true at the same moment when attribute is true."]}],valueConstraint:null,optional:!1},{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Allows to override the name of the XML element or XML attribute in it's XML representation."]}],valueConstraint:null,optional:!1},{name:"namespace",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Allows to configure the name of the XML namespace."]}],valueConstraint:null,optional:!1},{name:"prefix",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Allows to configure the prefix which will be used during serialization to XML."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"ArrayTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"array"},optional:!1},{name:"uniqueItems",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["uniqueItems"]},{name:"MetaModel.description",arguments:["Should items in array be unique"]}],valueConstraint:null,optional:!1},{name:"items",type:{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.description",arguments:["Array component type."]},{name:"MetaModel.valueDescription",arguments:["Inline type declaration or type name."]}],valueConstraint:null,optional:!1},{name:"minItems",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["minItems"]},{name:"MetaModel.description",arguments:["Minimum amount of items in array"]},{name:"MetaModel.valueDescription",arguments:["integer ( >= 0 ). Defaults to 0"]}],valueConstraint:null,optional:!1},{name:"maxItems",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["maxItems"]},{name:"MetaModel.description",arguments:["Maximum amount of items in array"]},{name:"MetaModel.valueDescription",arguments:["integer ( >= 0 ). Defaults to undefined."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.convertsToGlobalOfType",arguments:["SchemaString"]},{name:"MetaModel.alias",arguments:["array"]},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],extends:[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"UnionTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"union"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.convertsToGlobalOfType",arguments:["SchemaString"]},{name:"MetaModel.requireValue",arguments:["locationKind","LocationKind.MODELS"]},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],extends:[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"ObjectTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[{name:"MetaModel.hide",arguments:[]}],valueConstraint:{isCallConstraint:!1,value:"object"},optional:!1},{name:"properties",type:{base:{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.description",arguments:["The properties that instances of this type may or must have."]},{name:"MetaModel.valueDescription",arguments:["An object whose keys are the properties' names and whose values are property declarations."]}],valueConstraint:null,optional:!1},{name:"minProperties",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["minProperties"]},{name:"MetaModel.description",arguments:["The minimum number of properties allowed for instances of this type."]}],valueConstraint:null,optional:!1},{name:"maxProperties",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["maxProperties"]},{name:"MetaModel.description",arguments:["The maximum number of properties allowed for instances of this type."]}],valueConstraint:null,optional:!1},{name:"additionalProperties",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["A Boolean that indicates if an object instance has additional properties."]}],valueConstraint:null,optional:!1},{name:"discriminator",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Type property name to be used as discriminator, or boolean"]}],valueConstraint:null,optional:!1},{name:"discriminatorValue",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The value of discriminator for the type."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.definingPropertyIsEnough",arguments:["properties"]},{name:"MetaModel.setsContextValue",arguments:["field","true"]},{name:"MetaModel.convertsToGlobalOfType",arguments:["SchemaString"]},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],extends:[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"StringTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"string"},optional:!1},{name:"pattern",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["pattern"]},{name:"MetaModel.description",arguments:["Regular expression that this string should path"]},{name:"MetaModel.valueDescription",arguments:["regexp"]}],valueConstraint:null,optional:!1},{name:"minLength",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["minLength"]},{name:"MetaModel.description",arguments:["Minimum length of the string"]}],valueConstraint:null,optional:!1},{name:"maxLength",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["maxLength"]},{name:"MetaModel.description",arguments:["Maximum length of the string"]}],valueConstraint:null,optional:!1},{name:"enum",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.facetId",arguments:["enum"]},{name:"MetaModel.describesAnnotation",arguments:["oneOf"]},{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type string) The enum attribute provides an enumeration of the parameter's valid values. This MUST be an array. If the enum attribute is defined, API clients and servers MUST verify that a parameter's value matches a value in the enum array. If there is no matching value, the clients and servers MUST treat this as an error."]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value must be a string"]},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],extends:[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"BooleanTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"boolean"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value must be a boolean"]},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],extends:[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"NumberTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"number"},optional:!1},{name:"minimum",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["minimum"]},{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type number or integer) The minimum attribute specifies the parameter's minimum value."]}],valueConstraint:null,optional:!1},{name:"maximum",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["maximum"]},{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type number or integer) The maximum attribute specifies the parameter's maximum value."]}],valueConstraint:null,optional:!1},{name:"enum",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.facetId",arguments:["enum"]},{name:"MetaModel.describesAnnotation",arguments:["oneOf"]},{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type string) The enum attribute provides an enumeration of the parameter's valid values. This MUST be an array. If the enum attribute is defined, API clients and servers MUST verify that a parameter's value matches a value in the enum array. If there is no matching value, the clients and servers MUST treat this as an error."]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1},{name:"format",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.oneOf",arguments:[["int32","int64","int","long","float","double","int16","int8"]]},{name:"MetaModel.description",arguments:["Value format"]}],valueConstraint:null,optional:!1},{name:"multipleOf",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:['A numeric instance is valid against "multipleOf" if the result of the division of the instance by this keyword\'s value is an integer.']}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value MUST be a number. Indicate floating point numbers as defined by YAML."]},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],extends:[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"IntegerTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"integer"},optional:!1},{name:"format",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.oneOf",arguments:[["int32","int64","int","long","int16","int8"]]},{name:"MetaModel.description",arguments:["Value format"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value MUST be a integer."]},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],extends:[{typeName:"NumberTypeDeclaration",nameSpace:"",basicName:"NumberTypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"DateOnlyTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"date-only"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:['the "full-date" notation of RFC3339, namely yyyy-mm-dd (no implications about time or timezone-offset)']},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],extends:[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"TimeOnlyTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"time-only"
},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:['the "partial-time" notation of RFC3339, namely hh:mm:ss[.ff...] (no implications about date or timezone-offset)']},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],extends:[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"DateTimeOnlyTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"datetime-only"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:['combined date-only and time-only with a separator of "T", namely yyyy-mm-ddThh:mm:ss[.ff...] (no implications about timezone-offset)']},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],extends:[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"DateTimeTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"datetime"},optional:!1},{name:"format",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.oneOf",arguments:[["rfc3339","rfc2616"]]},{name:"MetaModel.description",arguments:["Format used for this date time rfc3339 or rfc2616"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:['a timestamp, either in the "date-time" notation of RFC3339, if format is omitted or is set to rfc3339, or in the format defined in RFC2616, if format is set to rfc2616.']},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],extends:[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"DateTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"date"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value MUST be a string representation of a date as defined in RFC2616 Section 3.3, or according to specified date format"]},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],extends:[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"TypeInstance",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"properties",type:{base:{typeName:"TypeInstanceProperty",nameSpace:"",basicName:"TypeInstanceProperty",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Array of instance properties"]}],valueConstraint:null,optional:!1},{name:"isScalar",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Whether the type is scalar"]}],valueConstraint:null,optional:!1},{name:"value",type:{typeName:"any",nameSpace:"",basicName:"any",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["For instances of scalar types returns scalar value"]}],valueConstraint:null,optional:!1},{name:"isArray",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Indicates whether the instance is array"]}],valueConstraint:null,optional:!1},{name:"items",type:{base:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Returns components of array instances"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.customHandling",arguments:[]}],extends:[],moduleName:null,annotationOverridings:{}},{name:"TypeInstanceProperty",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Property name"]}],valueConstraint:null,optional:!1},{name:"value",type:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.description",arguments:["Property value"]}],valueConstraint:null,optional:!1},{name:"values",type:{base:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Array of values if property value is array"]}],valueConstraint:null,optional:!1},{name:"isArray",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Whether property has array as value"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.customHandling",arguments:[]}],extends:[],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[{name:"ModelLocation",members:["QUERY","HEADERS","URI","FORM","BURI","ANNOTATION","MODEL","SECURITYSCHEMATYPE"]},{name:"LocationKind",members:["APISTRUCTURE","DECLARATIONS","MODELS"]}],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts",Bodies:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/common.ts",Declarations:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/declarations.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},{classes:[{name:"MimeType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This sub type of the string represents mime types"]}],extends:[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts"}],moduleName:null,annotationOverridings:{}},{name:"Response",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"code",type:{typeName:"Sys.StatusCodeString",nameSpace:"Sys",basicName:"StatusCodeString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts"},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.extraMetaKey",arguments:["statusCodes"]},{name:"MetaModel.description",arguments:["Responses MUST be a map of one or more HTTP status codes, where each status code itself is a map that describes that status code."]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1},{name:"headers",type:{base:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.setsContextValue",arguments:["location","DataModel.ModelLocation.HEADERS"]},{name:"MetaModel.setsContextValue",arguments:["locationKind","DataModel.LocationKind.APISTRUCTURE"]},{name:"MetaModel.newInstanceName",arguments:["New Header"]},{name:"MetaModel.description",arguments:["Detailed information about any response headers returned by this method"]},{name:"MetaModel.valueDescription",arguments:["Object whose property names are the response header names and whose values describe the values."]}],valueConstraint:null,optional:!1},{name:"body",type:{base:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts"},typeKind:1},annotations:[{name:"MetaModel.newInstanceName",arguments:["New Body"]},{name:"MetaModel.description",arguments:["The body of the response: a body declaration"]},{name:"MetaModel.valueDescription",arguments:["Object whose properties are either<br>* Media types and whose values are type objects describing the request body for that media type, or<br>* a type object describing the request body for the default media type specified in the root mediaType property."]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts"},annotations:[{name:"MetaModel.description",arguments:["A longer, human-friendly description of the response"]},{name:"MetaModel.valueDescription",arguments:["Markdown string"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts"}],moduleName:null,annotationOverridings:{displayName:[{name:"MetaModel.description",arguments:["An alternate, human-friendly name for the response"]}],annotations:[{name:"MetaModel.markdownDescription",arguments:['Annotations to be applied to this response. Annotations are any property whose key begins with "(" and ends with ")" and whose name (the part between the beginning and ending parentheses) is a declared annotation name.']}]}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts",DataModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/common.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts"},{classes:[{name:"Annotable",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"annotations",type:{base:{typeName:"Decls.AnnotationRef",nameSpace:"Decls",basicName:"AnnotationRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/common.ts"},typeKind:1},annotations:[{name:"MetaModel.noDirectParse",arguments:[]},{name:"MetaModel.setsContextValue",arguments:["locationKind","datamodel.LocationKind.APISTRUCTURE"]},{name:"MetaModel.setsContextValue",arguments:["location","datamodel.ModelLocation.ANNOTATION"]},{name:"MetaModel.description",arguments:["Most of RAML model elements may have attached annotations decribing additional meta data about this element"]},{name:"MetaModel.documentationTableLabel",arguments:["(&lt;annotationName&gt;)"]},{name:"MetaModel.valueDescription",arguments:["A value corresponding to the declared type of this annotation."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts",Decls:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/declarations.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/common.ts"},{classes:[{name:"AnnotationRef",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"annotation",type:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/declarations.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns referenced annotation"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Annotations allow you to attach information to your API"]},{name:"MetaModel.tags",arguments:[["annotations"]]}],extends:[{typeName:"Reference",nameSpace:"",basicName:"Reference",typeKind:0,typeArguments:[{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/declarations.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/declarations.ts"}],moduleName:null,annotationOverridings:{}},{name:"AnnotationTarget",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Elements to which this Annotation can be applied (enum)"]},{name:"MetaModel.tags",arguments:[["annotations"]]}],extends:[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/declarations.ts"}],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts",DataModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/common.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/declarations.ts"},{classes:[{name:"TraitRef",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"trait",type:{typeName:"Trait",nameSpace:"",basicName:"Trait",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns referenced trait"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"Reference",nameSpace:"",basicName:"Reference",typeKind:0,typeArguments:[{typeName:"Trait",nameSpace:"",basicName:"Trait",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"}],moduleName:null,annotationOverridings:{}},{name:"Trait",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["Name of the trait"]}],valueConstraint:null,optional:!1},{name:"usage",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Instructions on how and when the trait should be used."]}],valueConstraint:null,optional:!1},{name:"parametrizedProperties",type:{typeName:"DataModel.TypeInstance",nameSpace:"DataModel",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns object representation of parametrized properties of the trait"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.inlinedTemplates",arguments:[]},{name:"MetaModel.allowQuestion",arguments:[]},{name:"MetaModel.possibleInterfaces",arguments:[["FragmentDeclaration"]]}],extends:[{typeName:"MethodBase",nameSpace:"",basicName:"MethodBase",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"}],moduleName:null,annotationOverridings:{displayName:[{name:"MetaModel.description",arguments:["The displayName attribute specifies the trait display name. It is a friendly name used only for  display or documentation purposes. If displayName is not specified, it defaults to the element's key (the name of the property itself)."]}]}},{name:"MethodBase",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"body",type:{base:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.newInstanceName",arguments:["New Body"]},{name:"MetaModel.description",arguments:["Some method verbs expect the resource to be sent as a request body. For example, to create a resource, the request must include the details of the resource to create. Resources CAN have alternate representations. For example, an API might support both JSON and XML representations. A method's body is defined in the body property as a hashmap, in which the key MUST be a valid media type."]}],valueConstraint:null,optional:!1},{name:"protocols",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.oneOf",arguments:[["HTTP","HTTPS"]]},{name:"MetaModel.description",arguments:["A method can override the protocols specified in the resource or at the API root, by employing this property."]},{name:"MetaModel.valueDescription",arguments:["array of strings of value HTTP or HTTPS, or a single string of such kind, case-insensitive"]}],valueConstraint:null,optional:!1},{name:"is",type:{base:{typeName:"TraitRef",nameSpace:"",basicName:"TraitRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Instantiation of applyed traits"]}],valueConstraint:null,optional:!1},{name:"securedBy",type:{base:{typeName:"Security.SecuritySchemeRef",nameSpace:"Security",basicName:"SecuritySchemeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.allowNull",arguments:[]},{name:"MetaModel.description",arguments:["securityScheme may also be applied to a resource by using the securedBy key, which is equivalent to applying the securityScheme to all methods that may be declared, explicitly or implicitly, by defining the resourceTypes or traits property for that resource. To indicate that the method may be called without applying any securityScheme, the method may be annotated with the null securityScheme."]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},annotations:[],valueConstraint:null,optional:!1},{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"Operation",nameSpace:"",basicName:"Operation",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"}],moduleName:null,annotationOverridings:{}},{name:"Method",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"method",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.extraMetaKey",arguments:["methods"]},{name:"MetaModel.oneOf",arguments:[["get","put","post","delete","options","head","patch"]]},{name:"MetaModel.description",arguments:["Method that can be called"]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1},{name:"parametrizedProperties",type:{typeName:"DataModel.TypeInstance",nameSpace:"DataModel",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["For types defined in resource types returns object representation of parametrized properties"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"MethodBase",nameSpace:"",basicName:"MethodBase",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"}],moduleName:null,annotationOverridings:{displayName:[{name:"MetaModel.description",arguments:["The displayName attribute specifies the method display name. It is a friendly name used only for  display or documentation purposes. If displayName is not specified, it defaults to the element's key (the name of the property itself)."]}]}},{name:"Operation",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"queryParameters",type:{base:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.setsContextValue",arguments:["location","DataModel.ModelLocation.QUERY"]},{name:"MetaModel.setsContextValue",arguments:["locationKind","DataModel.LocationKind.APISTRUCTURE"]},{name:"MetaModel.newInstanceName",arguments:["New query parameter"]},{name:"MetaModel.description",arguments:["An APIs resources MAY be filtered (to return a subset of results) or altered (such as transforming  a response body from JSON to XML format) by the use of query strings. If the resource or its method supports a query string, the query string MUST be defined by the queryParameters property"]}],valueConstraint:null,optional:!1},{name:"headers",type:{base:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.setsContextValue",arguments:["location","DataModel.ModelLocation.HEADERS"]},{name:"MetaModel.setsContextValue",arguments:["locationKind","DataModel.LocationKind.APISTRUCTURE"]},{name:"MetaModel.description",arguments:["Headers that allowed at this position"]},{name:"MetaModel.newInstanceName",arguments:["New Header"]}],valueConstraint:null,optional:!1},{name:"queryString",type:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},annotations:[{name:"MetaModel.description",arguments:["Specifies the query string needed by this method. Mutually exclusive with queryParameters."]}],valueConstraint:null,optional:!1},{name:"responses",type:{base:{typeName:"Bodies.Response",nameSpace:"Bodies",basicName:"Response",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["response","true"]},{name:"MetaModel.newInstanceName",arguments:["New Response"]},{name:"MetaModel.description",arguments:["Information about the expected responses to a request"]},{name:"MetaModel.valueDescription",arguments:["An object whose keys are the HTTP status codes of the responses and whose values describe the responses."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"}],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts",Bodies:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts",DataModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts",Security:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},{classes:[{name:"SecuritySchemePart",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[],extends:[{typeName:"Operation",nameSpace:"",basicName:"Operation",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{annotations:[{name:"MetaModel.description",arguments:['Annotations to be applied to this security scheme part. Annotations are any property whose key begins with "(" and ends with ")" and whose name (the part between the beginning and ending parentheses) is a declared annotation name.']}]}},{name:"SecuritySchemeSettings",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.allowAny",arguments:[]}],extends:[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"OAuth1SecuritySchemeSettings",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"requestTokenUri",type:{typeName:"Sys.FixedUriString",nameSpace:"Sys",basicName:"FixedUriString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The URI of the Temporary Credential Request endpoint as defined in RFC5849 Section 2.1"]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1},{name:"authorizationUri",type:{typeName:"Sys.FixedUriString",nameSpace:"Sys",basicName:"FixedUriString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The URI of the Resource Owner Authorization endpoint as defined in RFC5849 Section 2.2"]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1},{name:"tokenCredentialsUri",type:{typeName:"Sys.FixedUriString",nameSpace:"Sys",basicName:"FixedUriString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The URI of the Token Request endpoint as defined in RFC5849 Section 2.3"]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1},{name:"signatures",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.oneOf",arguments:[["HMAC-SHA1","RSA-SHA1","PLAINTEXT"]]},{name:"MetaModel.hide",arguments:[]},{name:"MetaModel.description",arguments:["List of the signature methods used by the server. Available methods: HMAC-SHA1, RSA-SHA1, PLAINTEXT"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.allowAny",arguments:[]},{name:"MetaModel.functionalDescriminator",arguments:["$parent.type=='OAuth 1.0'"]}],extends:[{typeName:"SecuritySchemeSettings",nameSpace:"",basicName:"SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"OAuth2SecuritySchemeSettings",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"accessTokenUri",type:{typeName:"Sys.FixedUriString",nameSpace:"Sys",basicName:"FixedUriString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The URI of the Token Endpoint as defined in RFC6749 Section 3.2. Not required forby implicit grant type."]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1},{name:"authorizationUri",type:{typeName:"Sys.FixedUriString",nameSpace:"Sys",basicName:"FixedUriString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[{name:"MetaModel.description",arguments:["The URI of the Authorization Endpoint as defined in RFC6749 Section 3.1. Required forby authorization_code and implicit grant types."]
},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1},{name:"authorizationGrants",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.oftenKeys",arguments:[["authorization_code","password","client_credentials","implicit"]]},{name:"MetaModel.description",arguments:["A list of the Authorization grants supported by the API as defined in RFC6749 Sections 4.1, 4.2, 4.3 and 4.4, can be any of: authorization_code, password, client_credentials, implicit, or any absolute url."]},{name:"MetaModel.markdownDescription",arguments:["A list of the Authorization grants supported by the API as defined in RFC6749 Sections 4.1, 4.2, 4.3 and 4.4, can be any of:<br>* authorization_code<br>* password<br>* client_credentials<br>* implicit <br>*  or any absolute url."]}],valueConstraint:null,optional:!1},{name:"scopes",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["A list of scopes supported by the security scheme as defined in RFC6749 Section 3.3"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.allowAny",arguments:[]}],extends:[{typeName:"SecuritySchemeSettings",nameSpace:"",basicName:"SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"SecuritySchemeRef",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"securitySchemeName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns the name of security scheme, this reference refers to."]}],valueConstraint:null,optional:!1},{name:"securityScheme",type:{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns AST node of security scheme, this reference refers to, or null."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"Reference",nameSpace:"",basicName:"Reference",typeKind:0,typeArguments:[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"AbstractSecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.startFrom",arguments:[""]},{name:"MetaModel.hide",arguments:[]},{name:"MetaModel.description",arguments:["Name of the security scheme"]}],valueConstraint:null,optional:!1},{name:"type",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.oneOf",arguments:[["OAuth 1.0","OAuth 2.0","Basic Authentication","Digest Authentication","Pass Through","x-{other}"]]},{name:"MetaModel.descriminatingProperty",arguments:[]},{name:"MetaModel.description",arguments:["The securitySchemes property MUST be used to specify an API's security mechanisms, including the required settings and the authentication methods that the API supports. one authentication method is allowed if the API supports them."]},{name:"MetaModel.valueDescription",arguments:["string<br><br>The value MUST be one of<br>* OAuth 1.0,<br>* OAuth 2.0,<br>* BasicSecurityScheme Authentication<br>* DigestSecurityScheme Authentication<br>* Pass Through<br>* x-&lt;other&gt;"]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[{name:"MetaModel.description",arguments:["The description attribute MAY be used to describe a security schemes property."]},{name:"MetaModel.description",arguments:["The description MAY be used to describe a securityScheme."]}],valueConstraint:null,optional:!1},{name:"describedBy",type:{typeName:"SecuritySchemePart",nameSpace:"",basicName:"SecuritySchemePart",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[{name:"MetaModel.description",arguments:["A description of the request components related to Security that are determined by the scheme: the headers, query parameters or responses. As a best practice, even for standard security schemes, API designers SHOULD describe these properties of security schemes. Including the security scheme description completes an API documentation."]}],valueConstraint:null,optional:!1},{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The displayName attribute specifies the security scheme display name. It is a friendly name used only for  display or documentation purposes. If displayName is not specified, it defaults to the element's key (the name of the property itself)."]}],valueConstraint:null,optional:!1},{name:"settings",type:{typeName:"SecuritySchemeSettings",nameSpace:"",basicName:"SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[{name:"MetaModel.description",arguments:["The settings attribute MAY be used to provide security scheme-specific information. The required attributes vary depending on the type of security scheme is being declared. It describes the minimum set of properties which any processing application MUST provide and validate if it chooses to implement the security scheme. Processing applications MAY choose to recognize other properties for things such as token lifetime, preferred cryptographic algorithms, and more."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security scheme definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],extends:[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"OAuth2SecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"OAuth 2.0"},optional:!1},{name:"settings",type:{typeName:"OAuth2SecuritySchemeSettings",nameSpace:"",basicName:"OAuth2SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security scheme definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],extends:[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"OAuth1SecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"OAuth 1.0"},optional:!1},{name:"settings",type:{typeName:"OAuth1SecuritySchemeSettings",nameSpace:"",basicName:"OAuth1SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security scheme definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],extends:[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"PassThroughSecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"Pass Through"},optional:!1},{name:"settings",type:{typeName:"SecuritySchemeSettings",nameSpace:"",basicName:"SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security scheme definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],extends:[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"BasicSecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"Basic Authentication"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security scheme definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],extends:[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"DigestSecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"Digest Authentication"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security scheme definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],extends:[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"CustomSecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"x-{other}"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security scheme definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],extends:[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts",Methods:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},{classes:[{name:"ResourceTypeRef",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"resourceType",type:{typeName:"ResourceType",nameSpace:"",basicName:"ResourceType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns referenced resource type"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"Reference",nameSpace:"",basicName:"Reference",typeKind:0,typeArguments:[{typeName:"ResourceType",nameSpace:"",basicName:"ResourceType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"}],moduleName:null,annotationOverridings:{}},{name:"ResourceType",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The displayName attribute specifies the resource type display name. It is a friendly name used only for  display or documentation purposes. If displayName is not specified, it defaults to the element's key (the name of the property itself)."]}],valueConstraint:null,optional:!1},{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["Name of the resource type"]}],valueConstraint:null,optional:!1},{name:"usage",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Instructions on how and when the resource type should be used."]}],valueConstraint:null,optional:!1},{name:"parametrizedProperties",type:{typeName:"DataModel.TypeInstance",nameSpace:"DataModel",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns object representation of parametrized properties of the resource type"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.inlinedTemplates",arguments:[]},{name:"MetaModel.allowQuestion",arguments:[]},{name:"MetaModel.possibleInterfaces",arguments:[["FragmentDeclaration"]]}],extends:[{typeName:"ResourceBase",nameSpace:"",basicName:"ResourceBase",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"}],moduleName:null,annotationOverridings:{}},{name:"ResourceBase",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"methods",type:{base:{typeName:"Methods.Method",nameSpace:"Methods",basicName:"Method",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Methods that are part of this resource type definition"]},{name:"MetaModel.markdownDescription",arguments:["The methods available on this resource."]},{name:"MetaModel.documentationTableLabel",arguments:["get?<br>patch?<br>put?<br>post?<br>delete?<br>options?<br>head?"]},{name:"MetaModel.valueDescription",arguments:["Object describing the method"]}],valueConstraint:null,optional:!1},{name:"is",type:{base:{typeName:"Methods.TraitRef",nameSpace:"Methods",basicName:"TraitRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["A list of the traits to apply to all methods declared (implicitly or explicitly) for this resource. Individual methods may override this declaration"]},{name:"MetaModel.valueDescription",arguments:["array, which can contain each of the following elements:<br>* name of unparametrized trait <br>* a key-value pair with trait name as key and a map of trait parameters as value<br>* inline trait declaration <br><br>(or a single element of any above kind)"]}],valueConstraint:null,optional:!1},{name:"type",type:{typeName:"ResourceTypeRef",nameSpace:"",basicName:"ResourceTypeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},annotations:[{name:"MetaModel.description",arguments:["The resource type which this resource inherits."]},{name:"MetaModel.valueDescription",arguments:["one of the following elements:<br>* name of unparametrized resource type<br>* a key-value pair with resource type name as key and a map of its parameters as value<br>* inline resource type declaration"]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},annotations:[],valueConstraint:null,optional:!1},{name:"securedBy",type:{base:{typeName:"Security.SecuritySchemeRef",nameSpace:"Security",basicName:"SecuritySchemeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.allowNull",arguments:[]},{name:"MetaModel.description",arguments:["The security schemes that apply to all methods declared (implicitly or explicitly) for this resource."]},{name:"MetaModel.valueDescription",arguments:["array of security scheme names or a single security scheme name"]}],valueConstraint:null,optional:!1},{name:"uriParameters",type:{base:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["location","DataModel.ModelLocation.URI"]},{name:"MetaModel.setsContextValue",arguments:["locationKind","DataModel.LocationKind.APISTRUCTURE"]},{name:"MetaModel.setsContextValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.description",arguments:["Detailed information about any URI parameters of this resource"]},{name:"MetaModel.valueDescription",arguments:["object whose property names are the URI parameter names and whose values describe the values"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"}],moduleName:null,annotationOverridings:{}},{name:"Resource",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"relativeUri",type:{typeName:"Sys.RelativeUriString",nameSpace:"Sys",basicName:"RelativeUriString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.startFrom",arguments:["/"]},{name:"MetaModel.description",arguments:["Relative URL of this resource from the parent resource"]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1},{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The displayName attribute specifies the resource display name. It is a friendly name used only for  display or documentation purposes. If displayName is not specified, it defaults to the element's key (the name of the property itself)."]}],valueConstraint:null,optional:!1},{name:"resources",type:{base:{typeName:"Resource",nameSpace:"",basicName:"Resource",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.newInstanceName",arguments:["New Resource"]},{name:"MetaModel.description",arguments:['A nested resource is identified as any property whose name begins with a slash ("/") and is therefore treated as a relative URI.']},{name:"MetaModel.documentationTableLabel",arguments:["/&lt;relativeUri&gt;"]},{name:"MetaModel.valueDescription",arguments:["object describing the nested resource"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],extends:[{typeName:"ResourceBase",nameSpace:"",basicName:"ResourceBase",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"}],moduleName:null,annotationOverridings:{description:[{name:"MetaModel.description",arguments:["A longer, human-friendly description of the resource."]},{name:"MetaModel.valueDescription",arguments:["Markdown string"]}],annotations:[{name:"MetaModel.markdownDescription",arguments:['Annotations to be applied to this resource. Annotations are any property whose key begins with "(" and ends with ")" and whose name (the part between the beginning and ending parentheses) is a declared annotation name.']}]}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts",DataModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts",Security:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts",Methods:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},{classes:[{name:"FileTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"file"},optional:!1},{name:"fileTypes",type:{base:{typeName:"Sys.ContentType",nameSpace:"Sys",basicName:"ContentType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/parameters.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["It should also include a new property: fileTypes, which should be a list of valid content-type strings for the file. The file type */* should be a valid value."]}],valueConstraint:null,optional:!1},{name:"minLength",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The minLength attribute specifies the parameter value's minimum number of bytes."]}],valueConstraint:null,optional:!1},{name:"maxLength",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The maxLength attribute specifies the parameter value's maximum number of bytes."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["(Applicable only to Form properties) Value is a file. Client generators SHOULD use this type to handle file uploads correctly."]}],extends:[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/parameters.ts"}],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts",DataModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/parameters.ts"}]},function(module,exports,__webpack_require__){"use strict";function parse(content){return ts.createSourceFile("sample.ts",content,ts.ScriptTarget.ES3,!0)}function classDecl(name,isInteface){return{name:name,methods:[],typeParameters:[],typeParameterConstraint:[],implements:[],fields:[],isInterface:isInteface,annotations:[],extends:[],moduleName:null,annotationOverridings:{}}}function parseStruct(content,modules,mpth){var mod=parse(content),module={classes:[],aliases:[],enumDeclarations:[],imports:{},name:mpth};modules[mpth]=module;var currentModule=null;return exports.tsm.Matching.visit(mod,function(x){if(x.kind==ts.SyntaxKind.ModuleDeclaration){var cmod=x;currentModule=cmod.name.text}if(x.kind==ts.SyntaxKind.ImportEqualsDeclaration){var imp=x,namespace=imp.name.text;if("RamlWrapper"==namespace)return;var path=imp.moduleReference,literal=path.expression,importPath=literal.text,absPath=fsUtil.resolve(fsUtil.dirname(mpth)+"/",importPath)+".ts";if(!fsUtil.existsSync(absPath))throw new Error("Path "+importPath+" resolve to "+absPath+"do not exists");if(!modules[absPath]){var cnt=fsUtil.readFileSync(absPath);parseStruct(cnt,modules,absPath)}module.imports[namespace]=modules[absPath]}if(x.kind==ts.SyntaxKind.TypeAliasDeclaration){var u=x;if(u.name){var aliasName=u.name.text,type=buildType(u.type,mpth);module.aliases.push({name:aliasName,type:type})}}if(x.kind==ts.SyntaxKind.EnumDeclaration){var e=x,members=[];e.members&&e.members.forEach(function(y){members.push(y.name.text)}),e.name&&module.enumDeclarations.push({name:e.name.text,members:members})}var isInterface=x.kind==ts.SyntaxKind.InterfaceDeclaration,isClass=x.kind==ts.SyntaxKind.ClassDeclaration;if(isInterface||isClass){var c=x;if(c){var fields={},clazz=classDecl(c.name.text,isInterface);return clazz.moduleName=currentModule,module.classes.push(clazz),c.members.forEach(function(x){if(x.kind==ts.SyntaxKind.MethodDeclaration){var md=x,method=buildMethod(md,content,mpth);clazz.methods.push(method)}var field=fld.doMatch(x);if(field){var f=buildField(field,mpth);if("$"==f.name)clazz.annotations=f.annotations;else if("$"!=f.name.charAt(0)||"$ref"==f.name)fields[f.name]=f,clazz.fields.push(f);else{var targetField=f.name.substr(1),of=fields[targetField];if(of)of.annotations=f.annotations;else if("$$"!=f.name){var overridings=clazz.annotationOverridings[targetField];overridings||(overridings=[]),clazz.annotationOverridings[targetField]=overridings.concat(f.annotations)}}}}),c.typeParameters&&c.typeParameters.forEach(function(x){clazz.typeParameters.push(x.name.text),null==x.constraint?clazz.typeParameterConstraint.push(null):clazz.typeParameterConstraint.push(x.constraint.typeName.text)}),c.heritageClauses&&c.heritageClauses.forEach(function(x){x.types.forEach(function(y){if(x.token==ts.SyntaxKind.ExtendsKeyword)clazz.extends.push(buildType(y,mpth));else{if(x.token!=ts.SyntaxKind.ImplementsKeyword)throw new Error("Unknown token class heritage");clazz.implements.push(buildType(y,mpth))}})}),exports.tsm.Matching.SKIP}}}),module}function buildField(f,path){return{name:f.name.text,type:buildType(f.type,path),annotations:"$"==f.name.text.charAt(0)?buildInitializer(f.initializer):[],valueConstraint:"$"!=f.name.text.charAt(0)?buildConstraint(f.initializer):null,optional:null!=f.questionToken}}function buildMethod(md,content,path){var aliasName=md.name.text,text=content.substring(md.pos,md.end),params=[];md.parameters.forEach(function(x){params.push(buildParameter(x,content,path))});var method={returnType:buildType(md.type,path),name:aliasName,start:md.pos,end:md.end,text:text,arguments:params};return method}function buildParameter(f,content,path){var text=content.substring(f.pos,f.end);return{name:f.name.text,start:f.pos,end:f.end,text:text,type:buildType(f.type,path)}}function buildConstraint(e){return null==e?null:e.kind==ts.SyntaxKind.CallExpression?{isCallConstraint:!0,value:buildAnnotation(e)}:{isCallConstraint:!1,value:parseArg(e)}}function buildInitializer(i){if(null==i)return[];if(i.kind==ts.SyntaxKind.ArrayLiteralExpression){var arr=i,annotations=[];return arr.elements.forEach(function(x){annotations.push(buildAnnotation(x))}),annotations}throw new Error("Only Array Literals supported now")}function buildAnnotation(e){if(e.kind==ts.SyntaxKind.CallExpression){var call=e,name=parseName(call.expression),a={name:name,arguments:[]};return call.arguments.forEach(function(x){a.arguments.push(parseArg(x))}),a}throw new Error("Only call expressions may be annotations")}function parseArg(n){if(n.kind==ts.SyntaxKind.StringLiteral){var l=n;return l.text}if(n.kind==ts.SyntaxKind.NoSubstitutionTemplateLiteral){var ls=n;return ls.text}if(n.kind==ts.SyntaxKind.ArrayLiteralExpression){var arr=n,annotations=[];return arr.elements.forEach(function(x){annotations.push(parseArg(x))}),annotations}if(n.kind==ts.SyntaxKind.TrueKeyword)return!0;if(n.kind==ts.SyntaxKind.PropertyAccessExpression){var pa=n;return parseArg(pa.expression)+"."+parseArg(pa.name)}if(n.kind==ts.SyntaxKind.Identifier){var ident=n;return ident.text}if(n.kind==ts.SyntaxKind.FalseKeyword)return!1;if(n.kind==ts.SyntaxKind.NumericLiteral){var nl=n;return Number(nl.text)}if(n.kind==ts.SyntaxKind.BinaryExpression){var bin=n;if(bin.operatorToken.kind=ts.SyntaxKind.PlusToken)return parseArg(bin.left)+parseArg(bin.right)}throw new Error("Unknown value in annotation")}function parseName(n){if(n.kind==ts.SyntaxKind.Identifier)return n.text;if(n.kind==ts.SyntaxKind.PropertyAccessExpression){var m=n;return parseName(m.expression)+"."+parseName(m.name)}throw new Error("Only simple identifiers are supported now")}function basicType(n,path){var namespaceIndex=n.indexOf("."),namespace=namespaceIndex!=-1?n.substring(0,namespaceIndex):"",basicName=namespaceIndex!=-1?n.substring(namespaceIndex+1):n;return{typeName:n,nameSpace:namespace,basicName:basicName,typeKind:TypeKind.BASIC,typeArguments:[],modulePath:path}}function arrayType(b){return{base:b,typeKind:TypeKind.ARRAY}}function unionType(b){return{options:b,typeKind:TypeKind.UNION}}function buildType(t,path){if(null==t)return null;if(t.kind==ts.SyntaxKind.StringKeyword)return basicType("string",null);
if(t.kind==ts.SyntaxKind.NumberKeyword)return basicType("number",null);if(t.kind==ts.SyntaxKind.BooleanKeyword)return basicType("boolean",null);if(t.kind==ts.SyntaxKind.AnyKeyword)return basicType("any",null);if(t.kind==ts.SyntaxKind.TypeReference){var tr=t,res=basicType(parseQualified(tr.typeName),path);return tr.typeArguments&&tr.typeArguments.forEach(function(x){res.typeArguments.push(buildType(x,path))}),res}if(t.kind==ts.SyntaxKind.ArrayType){var q=t;return arrayType(buildType(q.elementType,path))}if(t.kind==ts.SyntaxKind.UnionType){var ut=t;return unionType(ut.types.map(function(x){return buildType(x,path)}))}if(t.kind==ts.SyntaxKind.ExpressionWithTypeArguments){var tra=t,res=basicType(parseQualified2(tra.expression),path);return tra.typeArguments&&tra.typeArguments.forEach(function(x){res.typeArguments.push(buildType(x,path))}),res}throw new Error("Case not supported"+t.kind)}function parseQualified2(n){return n.name?n.name.text:n.text}function parseQualified(n){if(n.kind==ts.SyntaxKind.Identifier)return n.text;var q=n;return parseQualified(q.left)+"."+parseQualified(q.right)}var ts=__webpack_require__(170);exports.tsm=__webpack_require__(135),exports.helperMethodExtractor=__webpack_require__(136);var fsUtil=__webpack_require__(137),EnumDeclaration=function(){function EnumDeclaration(){}return EnumDeclaration}();exports.EnumDeclaration=EnumDeclaration,function(TypeKind){TypeKind[TypeKind.BASIC=0]="BASIC",TypeKind[TypeKind.ARRAY=1]="ARRAY",TypeKind[TypeKind.UNION=2]="UNION"}(exports.TypeKind||(exports.TypeKind={}));var TypeKind=exports.TypeKind,fld=exports.tsm.Matching.field();exports.classDecl=classDecl,exports.parseStruct=parseStruct,exports.buildType=buildType},function(module,exports,__webpack_require__){(function(Buffer,global){"use strict";function typedArraySupport(){function Bar(){}try{var arr=new Uint8Array(1);return arr.foo=function(){return 42},arr.constructor=Bar,42===arr.foo()&&arr.constructor===Bar&&"function"==typeof arr.subarray&&0===arr.subarray(1,1).byteLength}catch(e){return!1}}function kMaxLength(){return Buffer.TYPED_ARRAY_SUPPORT?2147483647:1073741823}function Buffer(arg){return this instanceof Buffer?(Buffer.TYPED_ARRAY_SUPPORT||(this.length=0,this.parent=void 0),"number"==typeof arg?fromNumber(this,arg):"string"==typeof arg?fromString(this,arg,arguments.length>1?arguments[1]:"utf8"):fromObject(this,arg)):arguments.length>1?new Buffer(arg,arguments[1]):new Buffer(arg)}function fromNumber(that,length){if(that=allocate(that,length<0?0:0|checked(length)),!Buffer.TYPED_ARRAY_SUPPORT)for(var i=0;i<length;i++)that[i]=0;return that}function fromString(that,string,encoding){"string"==typeof encoding&&""!==encoding||(encoding="utf8");var length=0|byteLength(string,encoding);return that=allocate(that,length),that.write(string,encoding),that}function fromObject(that,object){if(Buffer.isBuffer(object))return fromBuffer(that,object);if(isArray(object))return fromArray(that,object);if(null==object)throw new TypeError("must start with number, buffer, array or string");if("undefined"!=typeof ArrayBuffer){if(object.buffer instanceof ArrayBuffer)return fromTypedArray(that,object);if(object instanceof ArrayBuffer)return fromArrayBuffer(that,object)}return object.length?fromArrayLike(that,object):fromJsonObject(that,object)}function fromBuffer(that,buffer){var length=0|checked(buffer.length);return that=allocate(that,length),buffer.copy(that,0,0,length),that}function fromArray(that,array){var length=0|checked(array.length);that=allocate(that,length);for(var i=0;i<length;i+=1)that[i]=255&array[i];return that}function fromTypedArray(that,array){var length=0|checked(array.length);that=allocate(that,length);for(var i=0;i<length;i+=1)that[i]=255&array[i];return that}function fromArrayBuffer(that,array){return Buffer.TYPED_ARRAY_SUPPORT?(array.byteLength,that=Buffer._augment(new Uint8Array(array))):that=fromTypedArray(that,new Uint8Array(array)),that}function fromArrayLike(that,array){var length=0|checked(array.length);that=allocate(that,length);for(var i=0;i<length;i+=1)that[i]=255&array[i];return that}function fromJsonObject(that,object){var array,length=0;"Buffer"===object.type&&isArray(object.data)&&(array=object.data,length=0|checked(array.length)),that=allocate(that,length);for(var i=0;i<length;i+=1)that[i]=255&array[i];return that}function allocate(that,length){Buffer.TYPED_ARRAY_SUPPORT?(that=Buffer._augment(new Uint8Array(length)),that.__proto__=Buffer.prototype):(that.length=length,that._isBuffer=!0);var fromPool=0!==length&&length<=Buffer.poolSize>>>1;return fromPool&&(that.parent=rootParent),that}function checked(length){if(length>=kMaxLength())throw new RangeError("Attempt to allocate Buffer larger than maximum size: 0x"+kMaxLength().toString(16)+" bytes");return 0|length}function SlowBuffer(subject,encoding){if(!(this instanceof SlowBuffer))return new SlowBuffer(subject,encoding);var buf=new Buffer(subject,encoding);return delete buf.parent,buf}function byteLength(string,encoding){"string"!=typeof string&&(string=""+string);var len=string.length;if(0===len)return 0;for(var loweredCase=!1;;)switch(encoding){case"ascii":case"binary":case"raw":case"raws":return len;case"utf8":case"utf-8":return utf8ToBytes(string).length;case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return 2*len;case"hex":return len>>>1;case"base64":return base64ToBytes(string).length;default:if(loweredCase)return utf8ToBytes(string).length;encoding=(""+encoding).toLowerCase(),loweredCase=!0}}function slowToString(encoding,start,end){var loweredCase=!1;if(start=0|start,end=void 0===end||end===1/0?this.length:0|end,encoding||(encoding="utf8"),start<0&&(start=0),end>this.length&&(end=this.length),end<=start)return"";for(;;)switch(encoding){case"hex":return hexSlice(this,start,end);case"utf8":case"utf-8":return utf8Slice(this,start,end);case"ascii":return asciiSlice(this,start,end);case"binary":return binarySlice(this,start,end);case"base64":return base64Slice(this,start,end);case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return utf16leSlice(this,start,end);default:if(loweredCase)throw new TypeError("Unknown encoding: "+encoding);encoding=(encoding+"").toLowerCase(),loweredCase=!0}}function hexWrite(buf,string,offset,length){offset=Number(offset)||0;var remaining=buf.length-offset;length?(length=Number(length),length>remaining&&(length=remaining)):length=remaining;var strLen=string.length;if(strLen%2!==0)throw new Error("Invalid hex string");length>strLen/2&&(length=strLen/2);for(var i=0;i<length;i++){var parsed=parseInt(string.substr(2*i,2),16);if(isNaN(parsed))throw new Error("Invalid hex string");buf[offset+i]=parsed}return i}function utf8Write(buf,string,offset,length){return blitBuffer(utf8ToBytes(string,buf.length-offset),buf,offset,length)}function asciiWrite(buf,string,offset,length){return blitBuffer(asciiToBytes(string),buf,offset,length)}function binaryWrite(buf,string,offset,length){return asciiWrite(buf,string,offset,length)}function base64Write(buf,string,offset,length){return blitBuffer(base64ToBytes(string),buf,offset,length)}function ucs2Write(buf,string,offset,length){return blitBuffer(utf16leToBytes(string,buf.length-offset),buf,offset,length)}function base64Slice(buf,start,end){return 0===start&&end===buf.length?base64.fromByteArray(buf):base64.fromByteArray(buf.slice(start,end))}function utf8Slice(buf,start,end){end=Math.min(buf.length,end);for(var res=[],i=start;i<end;){var firstByte=buf[i],codePoint=null,bytesPerSequence=firstByte>239?4:firstByte>223?3:firstByte>191?2:1;if(i+bytesPerSequence<=end){var secondByte,thirdByte,fourthByte,tempCodePoint;switch(bytesPerSequence){case 1:firstByte<128&&(codePoint=firstByte);break;case 2:secondByte=buf[i+1],128===(192&secondByte)&&(tempCodePoint=(31&firstByte)<<6|63&secondByte,tempCodePoint>127&&(codePoint=tempCodePoint));break;case 3:secondByte=buf[i+1],thirdByte=buf[i+2],128===(192&secondByte)&&128===(192&thirdByte)&&(tempCodePoint=(15&firstByte)<<12|(63&secondByte)<<6|63&thirdByte,tempCodePoint>2047&&(tempCodePoint<55296||tempCodePoint>57343)&&(codePoint=tempCodePoint));break;case 4:secondByte=buf[i+1],thirdByte=buf[i+2],fourthByte=buf[i+3],128===(192&secondByte)&&128===(192&thirdByte)&&128===(192&fourthByte)&&(tempCodePoint=(15&firstByte)<<18|(63&secondByte)<<12|(63&thirdByte)<<6|63&fourthByte,tempCodePoint>65535&&tempCodePoint<1114112&&(codePoint=tempCodePoint))}}null===codePoint?(codePoint=65533,bytesPerSequence=1):codePoint>65535&&(codePoint-=65536,res.push(codePoint>>>10&1023|55296),codePoint=56320|1023&codePoint),res.push(codePoint),i+=bytesPerSequence}return decodeCodePointsArray(res)}function decodeCodePointsArray(codePoints){var len=codePoints.length;if(len<=MAX_ARGUMENTS_LENGTH)return String.fromCharCode.apply(String,codePoints);for(var res="",i=0;i<len;)res+=String.fromCharCode.apply(String,codePoints.slice(i,i+=MAX_ARGUMENTS_LENGTH));return res}function asciiSlice(buf,start,end){var ret="";end=Math.min(buf.length,end);for(var i=start;i<end;i++)ret+=String.fromCharCode(127&buf[i]);return ret}function binarySlice(buf,start,end){var ret="";end=Math.min(buf.length,end);for(var i=start;i<end;i++)ret+=String.fromCharCode(buf[i]);return ret}function hexSlice(buf,start,end){var len=buf.length;(!start||start<0)&&(start=0),(!end||end<0||end>len)&&(end=len);for(var out="",i=start;i<end;i++)out+=toHex(buf[i]);return out}function utf16leSlice(buf,start,end){for(var bytes=buf.slice(start,end),res="",i=0;i<bytes.length;i+=2)res+=String.fromCharCode(bytes[i]+256*bytes[i+1]);return res}function checkOffset(offset,ext,length){if(offset%1!==0||offset<0)throw new RangeError("offset is not uint");if(offset+ext>length)throw new RangeError("Trying to access beyond buffer length")}function checkInt(buf,value,offset,ext,max,min){if(!Buffer.isBuffer(buf))throw new TypeError("buffer must be a Buffer instance");if(value>max||value<min)throw new RangeError("value is out of bounds");if(offset+ext>buf.length)throw new RangeError("index out of range")}function objectWriteUInt16(buf,value,offset,littleEndian){value<0&&(value=65535+value+1);for(var i=0,j=Math.min(buf.length-offset,2);i<j;i++)buf[offset+i]=(value&255<<8*(littleEndian?i:1-i))>>>8*(littleEndian?i:1-i)}function objectWriteUInt32(buf,value,offset,littleEndian){value<0&&(value=4294967295+value+1);for(var i=0,j=Math.min(buf.length-offset,4);i<j;i++)buf[offset+i]=value>>>8*(littleEndian?i:3-i)&255}function checkIEEE754(buf,value,offset,ext,max,min){if(value>max||value<min)throw new RangeError("value is out of bounds");if(offset+ext>buf.length)throw new RangeError("index out of range");if(offset<0)throw new RangeError("index out of range")}function writeFloat(buf,value,offset,littleEndian,noAssert){return noAssert||checkIEEE754(buf,value,offset,4,3.4028234663852886e38,-3.4028234663852886e38),ieee754.write(buf,value,offset,littleEndian,23,4),offset+4}function writeDouble(buf,value,offset,littleEndian,noAssert){return noAssert||checkIEEE754(buf,value,offset,8,1.7976931348623157e308,-1.7976931348623157e308),ieee754.write(buf,value,offset,littleEndian,52,8),offset+8}function base64clean(str){if(str=stringtrim(str).replace(INVALID_BASE64_RE,""),str.length<2)return"";for(;str.length%4!==0;)str+="=";return str}function stringtrim(str){return str.trim?str.trim():str.replace(/^\s+|\s+$/g,"")}function toHex(n){return n<16?"0"+n.toString(16):n.toString(16)}function utf8ToBytes(string,units){units=units||1/0;for(var codePoint,length=string.length,leadSurrogate=null,bytes=[],i=0;i<length;i++){if(codePoint=string.charCodeAt(i),codePoint>55295&&codePoint<57344){if(!leadSurrogate){if(codePoint>56319){(units-=3)>-1&&bytes.push(239,191,189);continue}if(i+1===length){(units-=3)>-1&&bytes.push(239,191,189);continue}leadSurrogate=codePoint;continue}if(codePoint<56320){(units-=3)>-1&&bytes.push(239,191,189),leadSurrogate=codePoint;continue}codePoint=(leadSurrogate-55296<<10|codePoint-56320)+65536}else leadSurrogate&&(units-=3)>-1&&bytes.push(239,191,189);if(leadSurrogate=null,codePoint<128){if((units-=1)<0)break;bytes.push(codePoint)}else if(codePoint<2048){if((units-=2)<0)break;bytes.push(codePoint>>6|192,63&codePoint|128)}else if(codePoint<65536){if((units-=3)<0)break;bytes.push(codePoint>>12|224,codePoint>>6&63|128,63&codePoint|128)}else{if(!(codePoint<1114112))throw new Error("Invalid code point");if((units-=4)<0)break;bytes.push(codePoint>>18|240,codePoint>>12&63|128,codePoint>>6&63|128,63&codePoint|128)}}return bytes}function asciiToBytes(str){for(var byteArray=[],i=0;i<str.length;i++)byteArray.push(255&str.charCodeAt(i));return byteArray}function utf16leToBytes(str,units){for(var c,hi,lo,byteArray=[],i=0;i<str.length&&!((units-=2)<0);i++)c=str.charCodeAt(i),hi=c>>8,lo=c%256,byteArray.push(lo),byteArray.push(hi);return byteArray}function base64ToBytes(str){return base64.toByteArray(base64clean(str))}function blitBuffer(src,dst,offset,length){for(var i=0;i<length&&!(i+offset>=dst.length||i>=src.length);i++)dst[i+offset]=src[i];return i}var base64=__webpack_require__(174),ieee754=__webpack_require__(167),isArray=__webpack_require__(168);exports.Buffer=Buffer,exports.SlowBuffer=SlowBuffer,exports.INSPECT_MAX_BYTES=50,Buffer.poolSize=8192;var rootParent={};Buffer.TYPED_ARRAY_SUPPORT=void 0!==global.TYPED_ARRAY_SUPPORT?global.TYPED_ARRAY_SUPPORT:typedArraySupport(),Buffer.TYPED_ARRAY_SUPPORT?(Buffer.prototype.__proto__=Uint8Array.prototype,Buffer.__proto__=Uint8Array):(Buffer.prototype.length=void 0,Buffer.prototype.parent=void 0),Buffer.isBuffer=function(b){return!(null==b||!b._isBuffer)},Buffer.compare=function(a,b){if(!Buffer.isBuffer(a)||!Buffer.isBuffer(b))throw new TypeError("Arguments must be Buffers");if(a===b)return 0;for(var x=a.length,y=b.length,i=0,len=Math.min(x,y);i<len&&a[i]===b[i];)++i;return i!==len&&(x=a[i],y=b[i]),x<y?-1:y<x?1:0},Buffer.isEncoding=function(encoding){switch(String(encoding).toLowerCase()){case"hex":case"utf8":case"utf-8":case"ascii":case"binary":case"base64":case"raw":case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return!0;default:return!1}},Buffer.concat=function(list,length){if(!isArray(list))throw new TypeError("list argument must be an Array of Buffers.");if(0===list.length)return new Buffer(0);var i;if(void 0===length)for(length=0,i=0;i<list.length;i++)length+=list[i].length;var buf=new Buffer(length),pos=0;for(i=0;i<list.length;i++){var item=list[i];item.copy(buf,pos),pos+=item.length}return buf},Buffer.byteLength=byteLength,Buffer.prototype.toString=function(){var length=0|this.length;return 0===length?"":0===arguments.length?utf8Slice(this,0,length):slowToString.apply(this,arguments)},Buffer.prototype.equals=function(b){if(!Buffer.isBuffer(b))throw new TypeError("Argument must be a Buffer");return this===b||0===Buffer.compare(this,b)},Buffer.prototype.inspect=function(){var str="",max=exports.INSPECT_MAX_BYTES;return this.length>0&&(str=this.toString("hex",0,max).match(/.{2}/g).join(" "),this.length>max&&(str+=" ... ")),"<Buffer "+str+">"},Buffer.prototype.compare=function(b){if(!Buffer.isBuffer(b))throw new TypeError("Argument must be a Buffer");return this===b?0:Buffer.compare(this,b)},Buffer.prototype.indexOf=function(val,byteOffset){function arrayIndexOf(arr,val,byteOffset){for(var foundIndex=-1,i=0;byteOffset+i<arr.length;i++)if(arr[byteOffset+i]===val[foundIndex===-1?0:i-foundIndex]){if(foundIndex===-1&&(foundIndex=i),i-foundIndex+1===val.length)return byteOffset+foundIndex}else foundIndex=-1;return-1}if(byteOffset>2147483647?byteOffset=2147483647:byteOffset<-2147483648&&(byteOffset=-2147483648),byteOffset>>=0,0===this.length)return-1;if(byteOffset>=this.length)return-1;if(byteOffset<0&&(byteOffset=Math.max(this.length+byteOffset,0)),"string"==typeof val)return 0===val.length?-1:String.prototype.indexOf.call(this,val,byteOffset);if(Buffer.isBuffer(val))return arrayIndexOf(this,val,byteOffset);if("number"==typeof val)return Buffer.TYPED_ARRAY_SUPPORT&&"function"===Uint8Array.prototype.indexOf?Uint8Array.prototype.indexOf.call(this,val,byteOffset):arrayIndexOf(this,[val],byteOffset);throw new TypeError("val must be string, number or Buffer")},Buffer.prototype.get=function(offset){return console.log(".get() is deprecated. Access using array indexes instead."),this.readUInt8(offset)},Buffer.prototype.set=function(v,offset){return console.log(".set() is deprecated. Access using array indexes instead."),this.writeUInt8(v,offset)},Buffer.prototype.write=function(string,offset,length,encoding){if(void 0===offset)encoding="utf8",length=this.length,offset=0;else if(void 0===length&&"string"==typeof offset)encoding=offset,length=this.length,offset=0;else if(isFinite(offset))offset=0|offset,isFinite(length)?(length=0|length,void 0===encoding&&(encoding="utf8")):(encoding=length,length=void 0);else{var swap=encoding;encoding=offset,offset=0|length,length=swap}var remaining=this.length-offset;if((void 0===length||length>remaining)&&(length=remaining),string.length>0&&(length<0||offset<0)||offset>this.length)throw new RangeError("attempt to write outside buffer bounds");encoding||(encoding="utf8");for(var loweredCase=!1;;)switch(encoding){case"hex":return hexWrite(this,string,offset,length);case"utf8":case"utf-8":return utf8Write(this,string,offset,length);case"ascii":return asciiWrite(this,string,offset,length);case"binary":return binaryWrite(this,string,offset,length);case"base64":return base64Write(this,string,offset,length);case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return ucs2Write(this,string,offset,length);default:if(loweredCase)throw new TypeError("Unknown encoding: "+encoding);encoding=(""+encoding).toLowerCase(),loweredCase=!0}},Buffer.prototype.toJSON=function(){return{type:"Buffer",data:Array.prototype.slice.call(this._arr||this,0)}};var MAX_ARGUMENTS_LENGTH=4096;Buffer.prototype.slice=function(start,end){var len=this.length;start=~~start,end=void 0===end?len:~~end,start<0?(start+=len,start<0&&(start=0)):start>len&&(start=len),end<0?(end+=len,end<0&&(end=0)):end>len&&(end=len),end<start&&(end=start);var newBuf;if(Buffer.TYPED_ARRAY_SUPPORT)newBuf=Buffer._augment(this.subarray(start,end));else{var sliceLen=end-start;newBuf=new Buffer(sliceLen,(void 0));for(var i=0;i<sliceLen;i++)newBuf[i]=this[i+start]}return newBuf.length&&(newBuf.parent=this.parent||this),newBuf},Buffer.prototype.readUIntLE=function(offset,byteLength,noAssert){offset=0|offset,byteLength=0|byteLength,noAssert||checkOffset(offset,byteLength,this.length);for(var val=this[offset],mul=1,i=0;++i<byteLength&&(mul*=256);)val+=this[offset+i]*mul;return val},Buffer.prototype.readUIntBE=function(offset,byteLength,noAssert){offset=0|offset,byteLength=0|byteLength,noAssert||checkOffset(offset,byteLength,this.length);for(var val=this[offset+--byteLength],mul=1;byteLength>0&&(mul*=256);)val+=this[offset+--byteLength]*mul;return val},Buffer.prototype.readUInt8=function(offset,noAssert){return noAssert||checkOffset(offset,1,this.length),this[offset]},Buffer.prototype.readUInt16LE=function(offset,noAssert){return noAssert||checkOffset(offset,2,this.length),this[offset]|this[offset+1]<<8},Buffer.prototype.readUInt16BE=function(offset,noAssert){return noAssert||checkOffset(offset,2,this.length),this[offset]<<8|this[offset+1]},Buffer.prototype.readUInt32LE=function(offset,noAssert){return noAssert||checkOffset(offset,4,this.length),(this[offset]|this[offset+1]<<8|this[offset+2]<<16)+16777216*this[offset+3]},Buffer.prototype.readUInt32BE=function(offset,noAssert){return noAssert||checkOffset(offset,4,this.length),16777216*this[offset]+(this[offset+1]<<16|this[offset+2]<<8|this[offset+3])},Buffer.prototype.readIntLE=function(offset,byteLength,noAssert){offset=0|offset,byteLength=0|byteLength,noAssert||checkOffset(offset,byteLength,this.length);for(var val=this[offset],mul=1,i=0;++i<byteLength&&(mul*=256);)val+=this[offset+i]*mul;return mul*=128,val>=mul&&(val-=Math.pow(2,8*byteLength)),val},Buffer.prototype.readIntBE=function(offset,byteLength,noAssert){offset=0|offset,byteLength=0|byteLength,noAssert||checkOffset(offset,byteLength,this.length);for(var i=byteLength,mul=1,val=this[offset+--i];i>0&&(mul*=256);)val+=this[offset+--i]*mul;return mul*=128,val>=mul&&(val-=Math.pow(2,8*byteLength)),val},Buffer.prototype.readInt8=function(offset,noAssert){return noAssert||checkOffset(offset,1,this.length),128&this[offset]?(255-this[offset]+1)*-1:this[offset]},Buffer.prototype.readInt16LE=function(offset,noAssert){noAssert||checkOffset(offset,2,this.length);var val=this[offset]|this[offset+1]<<8;return 32768&val?4294901760|val:val},Buffer.prototype.readInt16BE=function(offset,noAssert){noAssert||checkOffset(offset,2,this.length);var val=this[offset+1]|this[offset]<<8;return 32768&val?4294901760|val:val},Buffer.prototype.readInt32LE=function(offset,noAssert){return noAssert||checkOffset(offset,4,this.length),this[offset]|this[offset+1]<<8|this[offset+2]<<16|this[offset+3]<<24},Buffer.prototype.readInt32BE=function(offset,noAssert){return noAssert||checkOffset(offset,4,this.length),this[offset]<<24|this[offset+1]<<16|this[offset+2]<<8|this[offset+3]},Buffer.prototype.readFloatLE=function(offset,noAssert){return noAssert||checkOffset(offset,4,this.length),ieee754.read(this,offset,!0,23,4)},Buffer.prototype.readFloatBE=function(offset,noAssert){return noAssert||checkOffset(offset,4,this.length),ieee754.read(this,offset,!1,23,4)},Buffer.prototype.readDoubleLE=function(offset,noAssert){return noAssert||checkOffset(offset,8,this.length),ieee754.read(this,offset,!0,52,8)},Buffer.prototype.readDoubleBE=function(offset,noAssert){return noAssert||checkOffset(offset,8,this.length),ieee754.read(this,offset,!1,52,8)},Buffer.prototype.writeUIntLE=function(value,offset,byteLength,noAssert){value=+value,offset=0|offset,byteLength=0|byteLength,noAssert||checkInt(this,value,offset,byteLength,Math.pow(2,8*byteLength),0);var mul=1,i=0;for(this[offset]=255&value;++i<byteLength&&(mul*=256);)this[offset+i]=value/mul&255;return offset+byteLength},Buffer.prototype.writeUIntBE=function(value,offset,byteLength,noAssert){value=+value,offset=0|offset,byteLength=0|byteLength,noAssert||checkInt(this,value,offset,byteLength,Math.pow(2,8*byteLength),0);var i=byteLength-1,mul=1;for(this[offset+i]=255&value;--i>=0&&(mul*=256);)this[offset+i]=value/mul&255;return offset+byteLength},Buffer.prototype.writeUInt8=function(value,offset,noAssert){return value=+value,offset=0|offset,noAssert||checkInt(this,value,offset,1,255,0),Buffer.TYPED_ARRAY_SUPPORT||(value=Math.floor(value)),this[offset]=255&value,offset+1},Buffer.prototype.writeUInt16LE=function(value,offset,noAssert){return value=+value,offset=0|offset,noAssert||checkInt(this,value,offset,2,65535,0),Buffer.TYPED_ARRAY_SUPPORT?(this[offset]=255&value,this[offset+1]=value>>>8):objectWriteUInt16(this,value,offset,!0),offset+2},Buffer.prototype.writeUInt16BE=function(value,offset,noAssert){return value=+value,offset=0|offset,noAssert||checkInt(this,value,offset,2,65535,0),Buffer.TYPED_ARRAY_SUPPORT?(this[offset]=value>>>8,this[offset+1]=255&value):objectWriteUInt16(this,value,offset,!1),offset+2},Buffer.prototype.writeUInt32LE=function(value,offset,noAssert){return value=+value,offset=0|offset,noAssert||checkInt(this,value,offset,4,4294967295,0),Buffer.TYPED_ARRAY_SUPPORT?(this[offset+3]=value>>>24,this[offset+2]=value>>>16,this[offset+1]=value>>>8,this[offset]=255&value):objectWriteUInt32(this,value,offset,!0),offset+4},Buffer.prototype.writeUInt32BE=function(value,offset,noAssert){return value=+value,offset=0|offset,noAssert||checkInt(this,value,offset,4,4294967295,0),Buffer.TYPED_ARRAY_SUPPORT?(this[offset]=value>>>24,this[offset+1]=value>>>16,this[offset+2]=value>>>8,this[offset+3]=255&value):objectWriteUInt32(this,value,offset,!1),offset+4},Buffer.prototype.writeIntLE=function(value,offset,byteLength,noAssert){if(value=+value,offset=0|offset,!noAssert){var limit=Math.pow(2,8*byteLength-1);checkInt(this,value,offset,byteLength,limit-1,-limit)}var i=0,mul=1,sub=value<0?1:0;for(this[offset]=255&value;++i<byteLength&&(mul*=256);)this[offset+i]=(value/mul>>0)-sub&255;return offset+byteLength},Buffer.prototype.writeIntBE=function(value,offset,byteLength,noAssert){if(value=+value,offset=0|offset,!noAssert){var limit=Math.pow(2,8*byteLength-1);checkInt(this,value,offset,byteLength,limit-1,-limit)}var i=byteLength-1,mul=1,sub=value<0?1:0;for(this[offset+i]=255&value;--i>=0&&(mul*=256);)this[offset+i]=(value/mul>>0)-sub&255;return offset+byteLength},Buffer.prototype.writeInt8=function(value,offset,noAssert){return value=+value,offset=0|offset,noAssert||checkInt(this,value,offset,1,127,-128),Buffer.TYPED_ARRAY_SUPPORT||(value=Math.floor(value)),value<0&&(value=255+value+1),this[offset]=255&value,offset+1},Buffer.prototype.writeInt16LE=function(value,offset,noAssert){return value=+value,offset=0|offset,noAssert||checkInt(this,value,offset,2,32767,-32768),Buffer.TYPED_ARRAY_SUPPORT?(this[offset]=255&value,this[offset+1]=value>>>8):objectWriteUInt16(this,value,offset,!0),offset+2},Buffer.prototype.writeInt16BE=function(value,offset,noAssert){return value=+value,offset=0|offset,noAssert||checkInt(this,value,offset,2,32767,-32768),Buffer.TYPED_ARRAY_SUPPORT?(this[offset]=value>>>8,this[offset+1]=255&value):objectWriteUInt16(this,value,offset,!1),offset+2},Buffer.prototype.writeInt32LE=function(value,offset,noAssert){return value=+value,offset=0|offset,noAssert||checkInt(this,value,offset,4,2147483647,-2147483648),Buffer.TYPED_ARRAY_SUPPORT?(this[offset]=255&value,this[offset+1]=value>>>8,this[offset+2]=value>>>16,this[offset+3]=value>>>24):objectWriteUInt32(this,value,offset,!0),offset+4},Buffer.prototype.writeInt32BE=function(value,offset,noAssert){return value=+value,offset=0|offset,noAssert||checkInt(this,value,offset,4,2147483647,-2147483648),value<0&&(value=4294967295+value+1),Buffer.TYPED_ARRAY_SUPPORT?(this[offset]=value>>>24,this[offset+1]=value>>>16,this[offset+2]=value>>>8,this[offset+3]=255&value):objectWriteUInt32(this,value,offset,!1),offset+4},Buffer.prototype.writeFloatLE=function(value,offset,noAssert){return writeFloat(this,value,offset,!0,noAssert)},Buffer.prototype.writeFloatBE=function(value,offset,noAssert){return writeFloat(this,value,offset,!1,noAssert)},Buffer.prototype.writeDoubleLE=function(value,offset,noAssert){return writeDouble(this,value,offset,!0,noAssert)},Buffer.prototype.writeDoubleBE=function(value,offset,noAssert){return writeDouble(this,value,offset,!1,noAssert)},Buffer.prototype.copy=function(target,targetStart,start,end){if(start||(start=0),end||0===end||(end=this.length),targetStart>=target.length&&(targetStart=target.length),targetStart||(targetStart=0),end>0&&end<start&&(end=start),end===start)return 0;if(0===target.length||0===this.length)return 0;if(targetStart<0)throw new RangeError("targetStart out of bounds");if(start<0||start>=this.length)throw new RangeError("sourceStart out of bounds");if(end<0)throw new RangeError("sourceEnd out of bounds");end>this.length&&(end=this.length),target.length-targetStart<end-start&&(end=target.length-targetStart+start);var i,len=end-start;if(this===target&&start<targetStart&&targetStart<end)for(i=len-1;i>=0;i--)target[i+targetStart]=this[i+start];else if(len<1e3||!Buffer.TYPED_ARRAY_SUPPORT)for(i=0;i<len;i++)target[i+targetStart]=this[i+start];else target._set(this.subarray(start,start+len),targetStart);return len},Buffer.prototype.fill=function(value,start,end){if(value||(value=0),start||(start=0),end||(end=this.length),end<start)throw new RangeError("end < start");if(end!==start&&0!==this.length){if(start<0||start>=this.length)throw new RangeError("start out of bounds");if(end<0||end>this.length)throw new RangeError("end out of bounds");var i;if("number"==typeof value)for(i=start;i<end;i++)this[i]=value;else{var bytes=utf8ToBytes(value.toString()),len=bytes.length;for(i=start;i<end;i++)this[i]=bytes[i%len]}return this}},Buffer.prototype.toArrayBuffer=function(){if("undefined"!=typeof Uint8Array){if(Buffer.TYPED_ARRAY_SUPPORT)return new Buffer(this).buffer;for(var buf=new Uint8Array(this.length),i=0,len=buf.length;i<len;i+=1)buf[i]=this[i];return buf.buffer}throw new TypeError("Buffer.toArrayBuffer not supported in this browser")};var BP=Buffer.prototype;Buffer._augment=function(arr){return arr.constructor=Buffer,arr._isBuffer=!0,arr._set=arr.set,arr.get=BP.get,arr.set=BP.set,arr.write=BP.write,arr.toString=BP.toString,arr.toLocaleString=BP.toString,arr.toJSON=BP.toJSON,arr.equals=BP.equals,arr.compare=BP.compare,arr.indexOf=BP.indexOf,arr.copy=BP.copy,arr.slice=BP.slice,arr.readUIntLE=BP.readUIntLE,arr.readUIntBE=BP.readUIntBE,arr.readUInt8=BP.readUInt8,arr.readUInt16LE=BP.readUInt16LE,arr.readUInt16BE=BP.readUInt16BE,arr.readUInt32LE=BP.readUInt32LE,arr.readUInt32BE=BP.readUInt32BE,arr.readIntLE=BP.readIntLE,arr.readIntBE=BP.readIntBE,arr.readInt8=BP.readInt8,arr.readInt16LE=BP.readInt16LE,arr.readInt16BE=BP.readInt16BE,arr.readInt32LE=BP.readInt32LE,arr.readInt32BE=BP.readInt32BE,arr.readFloatLE=BP.readFloatLE,arr.readFloatBE=BP.readFloatBE,arr.readDoubleLE=BP.readDoubleLE,arr.readDoubleBE=BP.readDoubleBE,arr.writeUInt8=BP.writeUInt8,arr.writeUIntLE=BP.writeUIntLE,arr.writeUIntBE=BP.writeUIntBE,arr.writeUInt16LE=BP.writeUInt16LE,arr.writeUInt16BE=BP.writeUInt16BE,arr.writeUInt32LE=BP.writeUInt32LE,arr.writeUInt32BE=BP.writeUInt32BE,arr.writeIntLE=BP.writeIntLE,arr.writeIntBE=BP.writeIntBE,arr.writeInt8=BP.writeInt8,arr.writeInt16LE=BP.writeInt16LE,arr.writeInt16BE=BP.writeInt16BE,arr.writeInt32LE=BP.writeInt32LE,arr.writeInt32BE=BP.writeInt32BE,arr.writeFloatLE=BP.writeFloatLE,arr.writeFloatBE=BP.writeFloatBE,arr.writeDoubleLE=BP.writeDoubleLE,arr.writeDoubleBE=BP.writeDoubleBE,arr.fill=BP.fill,arr.inspect=BP.inspect,arr.toArrayBuffer=BP.toArrayBuffer,arr};var INVALID_BASE64_RE=/[^+\/0-9A-Za-z-_]/g}).call(exports,__webpack_require__(92).Buffer,function(){return this}())},function(module,exports,__webpack_require__){"use strict";function hasOwnProperty(obj,prop){return Object.prototype.hasOwnProperty.call(obj,prop)}module.exports=function(qs,sep,eq,options){sep=sep||"&",eq=eq||"=";var obj={};if("string"!=typeof qs||0===qs.length)return obj;var regexp=/\+/g;qs=qs.split(sep);var maxKeys=1e3;options&&"number"==typeof options.maxKeys&&(maxKeys=options.maxKeys);var len=qs.length;maxKeys>0&&len>maxKeys&&(len=maxKeys);for(var i=0;i<len;++i){var kstr,vstr,k,v,x=qs[i].replace(regexp,"%20"),idx=x.indexOf(eq);idx>=0?(kstr=x.substr(0,idx),vstr=x.substr(idx+1)):(kstr=x,vstr=""),k=decodeURIComponent(kstr),v=decodeURIComponent(vstr),hasOwnProperty(obj,k)?Array.isArray(obj[k])?obj[k].push(v):obj[k]=[obj[k],v]:obj[k]=v}return obj}},function(module,exports,__webpack_require__){"use strict";var stringifyPrimitive=function(v){switch(typeof v){case"string":return v;case"boolean":return v?"true":"false";case"number":return isFinite(v)?v:"";default:return""}};module.exports=function(obj,sep,eq,name){return sep=sep||"&",eq=eq||"=",null===obj&&(obj=void 0),"object"==typeof obj?Object.keys(obj).map(function(k){var ks=encodeURIComponent(stringifyPrimitive(k))+eq;return Array.isArray(obj[k])?obj[k].map(function(v){return ks+encodeURIComponent(stringifyPrimitive(v))}).join(sep):ks+encodeURIComponent(stringifyPrimitive(obj[k]))}).join(sep):name?encodeURIComponent(stringifyPrimitive(name))+eq+encodeURIComponent(stringifyPrimitive(obj)):""}},function(module,exports,__webpack_require__){exports.parse=__webpack_require__(145),exports.stringify=__webpack_require__(146)},function(module,exports,__webpack_require__){function configureProperties(obj){if(getOwnPropNames&&defineProp){var i,props=getOwnPropNames(obj);for(i=0;i<props.length;i+=1)defineProp(obj,props[i],{value:obj[props[i]],writable:!1,enumerable:!1,configurable:!1})}}function makeArrayAccessors(obj){function makeArrayAccessor(index){defineProp(obj,index,{get:function(){return obj._getter(index)},set:function(v){obj._setter(index,v)},enumerable:!0,configurable:!1})}if(defineProp){if(obj.length>MAX_ARRAY_LENGTH)throw new RangeError("Array too large for polyfill");var i;for(i=0;i<obj.length;i+=1)makeArrayAccessor(i);
}}function as_signed(value,bits){var s=32-bits;return value<<s>>s}function as_unsigned(value,bits){var s=32-bits;return value<<s>>>s}function packI8(n){return[255&n]}function unpackI8(bytes){return as_signed(bytes[0],8)}function packU8(n){return[255&n]}function unpackU8(bytes){return as_unsigned(bytes[0],8)}function packU8Clamped(n){return n=round(Number(n)),[n<0?0:n>255?255:255&n]}function packI16(n){return[n>>8&255,255&n]}function unpackI16(bytes){return as_signed(bytes[0]<<8|bytes[1],16)}function packU16(n){return[n>>8&255,255&n]}function unpackU16(bytes){return as_unsigned(bytes[0]<<8|bytes[1],16)}function packI32(n){return[n>>24&255,n>>16&255,n>>8&255,255&n]}function unpackI32(bytes){return as_signed(bytes[0]<<24|bytes[1]<<16|bytes[2]<<8|bytes[3],32)}function packU32(n){return[n>>24&255,n>>16&255,n>>8&255,255&n]}function unpackU32(bytes){return as_unsigned(bytes[0]<<24|bytes[1]<<16|bytes[2]<<8|bytes[3],32)}function packIEEE754(v,ebits,fbits){function roundToEven(n){var w=floor(n),f=n-w;return f<.5?w:f>.5?w+1:w%2?w+1:w}var s,e,f,i,bits,str,bytes,bias=(1<<ebits-1)-1;for(v!==v?(e=(1<<ebits)-1,f=pow(2,fbits-1),s=0):v===1/0||v===-(1/0)?(e=(1<<ebits)-1,f=0,s=v<0?1:0):0===v?(e=0,f=0,s=1/v===-(1/0)?1:0):(s=v<0,v=abs(v),v>=pow(2,1-bias)?(e=min(floor(log(v)/LN2),1023),f=roundToEven(v/pow(2,e)*pow(2,fbits)),f/pow(2,fbits)>=2&&(e+=1,f=1),e>bias?(e=(1<<ebits)-1,f=0):(e+=bias,f-=pow(2,fbits))):(e=0,f=roundToEven(v/pow(2,1-bias-fbits)))),bits=[],i=fbits;i;i-=1)bits.push(f%2?1:0),f=floor(f/2);for(i=ebits;i;i-=1)bits.push(e%2?1:0),e=floor(e/2);for(bits.push(s?1:0),bits.reverse(),str=bits.join(""),bytes=[];str.length;)bytes.push(parseInt(str.substring(0,8),2)),str=str.substring(8);return bytes}function unpackIEEE754(bytes,ebits,fbits){var i,j,b,str,bias,s,e,f,bits=[];for(i=bytes.length;i;i-=1)for(b=bytes[i-1],j=8;j;j-=1)bits.push(b%2?1:0),b>>=1;return bits.reverse(),str=bits.join(""),bias=(1<<ebits-1)-1,s=parseInt(str.substring(0,1),2)?-1:1,e=parseInt(str.substring(1,1+ebits),2),f=parseInt(str.substring(1+ebits),2),e===(1<<ebits)-1?0!==f?NaN:s*(1/0):e>0?s*pow(2,e-bias)*(1+f/pow(2,fbits)):0!==f?s*pow(2,-(bias-1))*(f/pow(2,fbits)):s<0?-0:0}function unpackF64(b){return unpackIEEE754(b,11,52)}function packF64(v){return packIEEE754(v,11,52)}function unpackF32(b){return unpackIEEE754(b,8,23)}function packF32(v){return packIEEE754(v,8,23)}var defineProp,undefined=void 0,MAX_ARRAY_LENGTH=1e5,ECMAScript=function(){var opts=Object.prototype.toString,ophop=Object.prototype.hasOwnProperty;return{Class:function(v){return opts.call(v).replace(/^\[object *|\]$/g,"")},HasProperty:function(o,p){return p in o},HasOwnProperty:function(o,p){return ophop.call(o,p)},IsCallable:function(o){return"function"==typeof o},ToInt32:function(v){return v>>0},ToUint32:function(v){return v>>>0}}}(),LN2=Math.LN2,abs=Math.abs,floor=Math.floor,log=Math.log,min=Math.min,pow=Math.pow,round=Math.round;defineProp=Object.defineProperty&&function(){try{return Object.defineProperty({},"x",{}),!0}catch(e){return!1}}()?Object.defineProperty:function(o,p,desc){if(!o===Object(o))throw new TypeError("Object.defineProperty called on non-object");return ECMAScript.HasProperty(desc,"get")&&Object.prototype.__defineGetter__&&Object.prototype.__defineGetter__.call(o,p,desc.get),ECMAScript.HasProperty(desc,"set")&&Object.prototype.__defineSetter__&&Object.prototype.__defineSetter__.call(o,p,desc.set),ECMAScript.HasProperty(desc,"value")&&(o[p]=desc.value),o};var getOwnPropNames=Object.getOwnPropertyNames||function(o){if(o!==Object(o))throw new TypeError("Object.getOwnPropertyNames called on non-object");var p,props=[];for(p in o)ECMAScript.HasOwnProperty(o,p)&&props.push(p);return props};!function(){function makeConstructor(bytesPerElement,pack,unpack){var ctor;return ctor=function(buffer,byteOffset,length){var array,sequence,i,s;if(arguments.length&&"number"!=typeof arguments[0])if("object"==typeof arguments[0]&&arguments[0].constructor===ctor)for(array=arguments[0],this.length=array.length,this.byteLength=this.length*this.BYTES_PER_ELEMENT,this.buffer=new ArrayBuffer(this.byteLength),this.byteOffset=0,i=0;i<this.length;i+=1)this._setter(i,array._getter(i));else if("object"!=typeof arguments[0]||(arguments[0]instanceof ArrayBuffer||"ArrayBuffer"===ECMAScript.Class(arguments[0]))){if("object"!=typeof arguments[0]||!(arguments[0]instanceof ArrayBuffer||"ArrayBuffer"===ECMAScript.Class(arguments[0])))throw new TypeError("Unexpected argument type(s)");if(this.buffer=buffer,this.byteOffset=ECMAScript.ToUint32(byteOffset),this.byteOffset>this.buffer.byteLength)throw new RangeError("byteOffset out of range");if(this.byteOffset%this.BYTES_PER_ELEMENT)throw new RangeError("ArrayBuffer length minus the byteOffset is not a multiple of the element size.");if(arguments.length<3){if(this.byteLength=this.buffer.byteLength-this.byteOffset,this.byteLength%this.BYTES_PER_ELEMENT)throw new RangeError("length of buffer minus byteOffset not a multiple of the element size");this.length=this.byteLength/this.BYTES_PER_ELEMENT}else this.length=ECMAScript.ToUint32(length),this.byteLength=this.length*this.BYTES_PER_ELEMENT;if(this.byteOffset+this.byteLength>this.buffer.byteLength)throw new RangeError("byteOffset and length reference an area beyond the end of the buffer")}else for(sequence=arguments[0],this.length=ECMAScript.ToUint32(sequence.length),this.byteLength=this.length*this.BYTES_PER_ELEMENT,this.buffer=new ArrayBuffer(this.byteLength),this.byteOffset=0,i=0;i<this.length;i+=1)s=sequence[i],this._setter(i,Number(s));else{if(this.length=ECMAScript.ToInt32(arguments[0]),length<0)throw new RangeError("ArrayBufferView size is not a small enough positive integer");this.byteLength=this.length*this.BYTES_PER_ELEMENT,this.buffer=new ArrayBuffer(this.byteLength),this.byteOffset=0}this.constructor=ctor,configureProperties(this),makeArrayAccessors(this)},ctor.prototype=new ArrayBufferView,ctor.prototype.BYTES_PER_ELEMENT=bytesPerElement,ctor.prototype._pack=pack,ctor.prototype._unpack=unpack,ctor.BYTES_PER_ELEMENT=bytesPerElement,ctor.prototype._getter=function(index){if(arguments.length<1)throw new SyntaxError("Not enough arguments");if(index=ECMAScript.ToUint32(index),index>=this.length)return undefined;var i,o,bytes=[];for(i=0,o=this.byteOffset+index*this.BYTES_PER_ELEMENT;i<this.BYTES_PER_ELEMENT;i+=1,o+=1)bytes.push(this.buffer._bytes[o]);return this._unpack(bytes)},ctor.prototype.get=ctor.prototype._getter,ctor.prototype._setter=function(index,value){if(arguments.length<2)throw new SyntaxError("Not enough arguments");if(index=ECMAScript.ToUint32(index),index>=this.length)return undefined;var i,o,bytes=this._pack(value);for(i=0,o=this.byteOffset+index*this.BYTES_PER_ELEMENT;i<this.BYTES_PER_ELEMENT;i+=1,o+=1)this.buffer._bytes[o]=bytes[i]},ctor.prototype.set=function(index,value){if(arguments.length<1)throw new SyntaxError("Not enough arguments");var array,sequence,offset,len,i,s,d,byteOffset,byteLength,tmp;if("object"==typeof arguments[0]&&arguments[0].constructor===this.constructor){if(array=arguments[0],offset=ECMAScript.ToUint32(arguments[1]),offset+array.length>this.length)throw new RangeError("Offset plus length of array is out of range");if(byteOffset=this.byteOffset+offset*this.BYTES_PER_ELEMENT,byteLength=array.length*this.BYTES_PER_ELEMENT,array.buffer===this.buffer){for(tmp=[],i=0,s=array.byteOffset;i<byteLength;i+=1,s+=1)tmp[i]=array.buffer._bytes[s];for(i=0,d=byteOffset;i<byteLength;i+=1,d+=1)this.buffer._bytes[d]=tmp[i]}else for(i=0,s=array.byteOffset,d=byteOffset;i<byteLength;i+=1,s+=1,d+=1)this.buffer._bytes[d]=array.buffer._bytes[s]}else{if("object"!=typeof arguments[0]||"undefined"==typeof arguments[0].length)throw new TypeError("Unexpected argument type(s)");if(sequence=arguments[0],len=ECMAScript.ToUint32(sequence.length),offset=ECMAScript.ToUint32(arguments[1]),offset+len>this.length)throw new RangeError("Offset plus length of array is out of range");for(i=0;i<len;i+=1)s=sequence[i],this._setter(offset+i,Number(s))}},ctor.prototype.subarray=function(start,end){function clamp(v,min,max){return v<min?min:v>max?max:v}start=ECMAScript.ToInt32(start),end=ECMAScript.ToInt32(end),arguments.length<1&&(start=0),arguments.length<2&&(end=this.length),start<0&&(start=this.length+start),end<0&&(end=this.length+end),start=clamp(start,0,this.length),end=clamp(end,0,this.length);var len=end-start;return len<0&&(len=0),new this.constructor(this.buffer,this.byteOffset+start*this.BYTES_PER_ELEMENT,len)},ctor}var ArrayBuffer=function(length){if(length=ECMAScript.ToInt32(length),length<0)throw new RangeError("ArrayBuffer size is not a small enough positive integer");this.byteLength=length,this._bytes=[],this._bytes.length=length;var i;for(i=0;i<this.byteLength;i+=1)this._bytes[i]=0;configureProperties(this)};exports.ArrayBuffer=exports.ArrayBuffer||ArrayBuffer;var ArrayBufferView=function(){},Int8Array=makeConstructor(1,packI8,unpackI8),Uint8Array=makeConstructor(1,packU8,unpackU8),Uint8ClampedArray=makeConstructor(1,packU8Clamped,unpackU8),Int16Array=makeConstructor(2,packI16,unpackI16),Uint16Array=makeConstructor(2,packU16,unpackU16),Int32Array=makeConstructor(4,packI32,unpackI32),Uint32Array=makeConstructor(4,packU32,unpackU32),Float32Array=makeConstructor(4,packF32,unpackF32),Float64Array=makeConstructor(8,packF64,unpackF64);exports.Int8Array=exports.Int8Array||Int8Array,exports.Uint8Array=exports.Uint8Array||Uint8Array,exports.Uint8ClampedArray=exports.Uint8ClampedArray||Uint8ClampedArray,exports.Int16Array=exports.Int16Array||Int16Array,exports.Uint16Array=exports.Uint16Array||Uint16Array,exports.Int32Array=exports.Int32Array||Int32Array,exports.Uint32Array=exports.Uint32Array||Uint32Array,exports.Float32Array=exports.Float32Array||Float32Array,exports.Float64Array=exports.Float64Array||Float64Array}(),function(){function r(array,index){return ECMAScript.IsCallable(array.get)?array.get(index):array[index]}function makeGetter(arrayType){return function(byteOffset,littleEndian){if(byteOffset=ECMAScript.ToUint32(byteOffset),byteOffset+arrayType.BYTES_PER_ELEMENT>this.byteLength)throw new RangeError("Array index out of range");byteOffset+=this.byteOffset;var i,uint8Array=new exports.Uint8Array(this.buffer,byteOffset,arrayType.BYTES_PER_ELEMENT),bytes=[];for(i=0;i<arrayType.BYTES_PER_ELEMENT;i+=1)bytes.push(r(uint8Array,i));return Boolean(littleEndian)===Boolean(IS_BIG_ENDIAN)&&bytes.reverse(),r(new arrayType(new exports.Uint8Array(bytes).buffer),0)}}function makeSetter(arrayType){return function(byteOffset,value,littleEndian){if(byteOffset=ECMAScript.ToUint32(byteOffset),byteOffset+arrayType.BYTES_PER_ELEMENT>this.byteLength)throw new RangeError("Array index out of range");var i,byteView,typeArray=new arrayType([value]),byteArray=new exports.Uint8Array(typeArray.buffer),bytes=[];for(i=0;i<arrayType.BYTES_PER_ELEMENT;i+=1)bytes.push(r(byteArray,i));Boolean(littleEndian)===Boolean(IS_BIG_ENDIAN)&&bytes.reverse(),byteView=new exports.Uint8Array(this.buffer,byteOffset,arrayType.BYTES_PER_ELEMENT),byteView.set(bytes)}}var IS_BIG_ENDIAN=function(){var u16array=new exports.Uint16Array([4660]),u8array=new exports.Uint8Array(u16array.buffer);return 18===r(u8array,0)}(),DataView=function(buffer,byteOffset,byteLength){if(0===arguments.length)buffer=new exports.ArrayBuffer(0);else if(!(buffer instanceof exports.ArrayBuffer||"ArrayBuffer"===ECMAScript.Class(buffer)))throw new TypeError("TypeError");if(this.buffer=buffer||new exports.ArrayBuffer(0),this.byteOffset=ECMAScript.ToUint32(byteOffset),this.byteOffset>this.buffer.byteLength)throw new RangeError("byteOffset out of range");if(arguments.length<3?this.byteLength=this.buffer.byteLength-this.byteOffset:this.byteLength=ECMAScript.ToUint32(byteLength),this.byteOffset+this.byteLength>this.buffer.byteLength)throw new RangeError("byteOffset and length reference an area beyond the end of the buffer");configureProperties(this)};DataView.prototype.getUint8=makeGetter(exports.Uint8Array),DataView.prototype.getInt8=makeGetter(exports.Int8Array),DataView.prototype.getUint16=makeGetter(exports.Uint16Array),DataView.prototype.getInt16=makeGetter(exports.Int16Array),DataView.prototype.getUint32=makeGetter(exports.Uint32Array),DataView.prototype.getInt32=makeGetter(exports.Int32Array),DataView.prototype.getFloat32=makeGetter(exports.Float32Array),DataView.prototype.getFloat64=makeGetter(exports.Float64Array),DataView.prototype.setUint8=makeSetter(exports.Uint8Array),DataView.prototype.setInt8=makeSetter(exports.Int8Array),DataView.prototype.setUint16=makeSetter(exports.Uint16Array),DataView.prototype.setInt16=makeSetter(exports.Int16Array),DataView.prototype.setUint32=makeSetter(exports.Uint32Array),DataView.prototype.setInt32=makeSetter(exports.Int32Array),DataView.prototype.setFloat32=makeSetter(exports.Float32Array),DataView.prototype.setFloat64=makeSetter(exports.Float64Array),exports.DataView=exports.DataView||DataView}()},function(module,exports,__webpack_require__){"use strict";function isNothing(subject){return"undefined"==typeof subject||null===subject}function isObject(subject){return"object"==typeof subject&&null!==subject}function toArray(sequence){return Array.isArray(sequence)?sequence:isNothing(sequence)?[]:[sequence]}function extend(target,source){var index,length,key,sourceKeys;if(source)for(sourceKeys=Object.keys(source),index=0,length=sourceKeys.length;index<length;index+=1)key=sourceKeys[index],target[key]=source[key];return target}function repeat(string,count){var cycle,result="";for(cycle=0;cycle<count;cycle+=1)result+=string;return result}function isNegativeZero(number){return 0===number&&Number.NEGATIVE_INFINITY===1/number}exports.isNothing=isNothing,exports.isObject=isObject,exports.toArray=toArray,exports.extend=extend,exports.repeat=repeat,exports.isNegativeZero=isNegativeZero},function(module,exports,__webpack_require__){"use strict";var YAMLException=function(){function YAMLException(reason,mark){void 0===mark&&(mark=null),this.name="YAMLException",this.reason=reason,this.mark=mark,this.message=this.toString(!1)}return YAMLException.prototype.toString=function(compact){void 0===compact&&(compact=!1);var result;return result="JS-YAML: "+(this.reason||"(unknown reason)"),!compact&&this.mark&&(result+=" "+this.mark.toString()),result},YAMLException}();module.exports=YAMLException},function(module,exports,__webpack_require__){"use strict";function newMapping(key,value){var end=value?value.endPosition:key.endPosition+1,node={key:key,value:value,startPosition:key.startPosition,endPosition:end,kind:Kind.MAPPING,parent:null,errors:[]};return node}function newAnchorRef(key,start,end,value){return{errors:[],referencesAnchor:key,value:value,startPosition:start,endPosition:end,kind:Kind.ANCHOR_REF,parent:null}}function newScalar(v){return void 0===v&&(v=""),{errors:[],startPosition:-1,endPosition:-1,value:v,kind:Kind.SCALAR,parent:null,doubleQuoted:!1}}function newItems(){return{errors:[],startPosition:-1,endPosition:-1,items:[],kind:Kind.SEQ,parent:null}}function newSeq(){return newItems()}function newMap(mappings){return{errors:[],startPosition:-1,endPosition:-1,mappings:mappings?mappings:[],kind:Kind.MAP,parent:null}}!function(Kind){Kind[Kind.SCALAR=0]="SCALAR",Kind[Kind.MAPPING=1]="MAPPING",Kind[Kind.MAP=2]="MAP",Kind[Kind.SEQ=3]="SEQ",Kind[Kind.ANCHOR_REF=4]="ANCHOR_REF",Kind[Kind.INCLUDE_REF=5]="INCLUDE_REF"}(exports.Kind||(exports.Kind={}));var Kind=exports.Kind;exports.newMapping=newMapping,exports.newAnchorRef=newAnchorRef,exports.newScalar=newScalar,exports.newItems=newItems,exports.newSeq=newSeq,exports.newMap=newMap},function(module,exports,__webpack_require__){"use strict";var common=__webpack_require__(97),Mark=function(){function Mark(name,buffer,position,line,column){this.name=name,this.buffer=buffer,this.position=position,this.line=line,this.column=column}return Mark.prototype.getSnippet=function(indent,maxLength){void 0===indent&&(indent=0),void 0===maxLength&&(maxLength=75);var head,start,tail,end,snippet;if(!this.buffer)return null;for(indent=indent||4,maxLength=maxLength||75,head="",start=this.position;start>0&&-1==="\0\r\n\u2028\u2029".indexOf(this.buffer.charAt(start-1));)if(start-=1,this.position-start>maxLength/2-1){head=" ... ",start+=5;break}for(tail="",end=this.position;end<this.buffer.length&&-1==="\0\r\n\u2028\u2029".indexOf(this.buffer.charAt(end));)if(end+=1,end-this.position>maxLength/2-1){tail=" ... ",end-=5;break}return snippet=this.buffer.slice(start,end),common.repeat(" ",indent)+head+snippet+tail+"\n"+common.repeat(" ",indent+this.position-start+head.length)+"^"},Mark.prototype.toString=function(compact){void 0===compact&&(compact=!0);var snippet,where="";return this.name&&(where+='in "'+this.name+'" '),where+="at line "+(this.line+1)+", column "+(this.column+1),compact||(snippet=this.getSnippet(),snippet&&(where+=":\n"+snippet)),where},Mark}();module.exports=Mark},function(module,exports,__webpack_require__){function Context(){}var indexOf=__webpack_require__(171),Object_keys=function(obj){if(Object.keys)return Object.keys(obj);var res=[];for(var key in obj)res.push(key);return res},forEach=function(xs,fn){if(xs.forEach)return xs.forEach(fn);for(var i=0;i<xs.length;i++)fn(xs[i],i,xs)},defineProp=function(){try{return Object.defineProperty({},"_",{}),function(obj,name,value){Object.defineProperty(obj,name,{writable:!0,enumerable:!1,configurable:!0,value:value})}}catch(e){return function(obj,name,value){obj[name]=value}}}(),globals=["Array","Boolean","Date","Error","EvalError","Function","Infinity","JSON","Math","NaN","Number","Object","RangeError","ReferenceError","RegExp","String","SyntaxError","TypeError","URIError","decodeURI","decodeURIComponent","encodeURI","encodeURIComponent","escape","eval","isFinite","isNaN","parseFloat","parseInt","undefined","unescape"];Context.prototype={};var Script=exports.Script=function(code){return this instanceof Script?void(this.code=code):new Script(code)};Script.prototype.runInContext=function(context){if(!(context instanceof Context))throw new TypeError("needs a 'context' argument.");var iframe=document.createElement("iframe");iframe.style||(iframe.style={}),iframe.style.display="none",document.body.appendChild(iframe);var win=iframe.contentWindow,wEval=win.eval,wExecScript=win.execScript;!wEval&&wExecScript&&(wExecScript.call(win,"null"),wEval=win.eval),forEach(Object_keys(context),function(key){win[key]=context[key]}),forEach(globals,function(key){context[key]&&(win[key]=context[key])});var winKeys=Object_keys(win),res=wEval.call(win,this.code);return forEach(Object_keys(win),function(key){(key in context||indexOf(winKeys,key)===-1)&&(context[key]=win[key])}),forEach(globals,function(key){key in context||defineProp(context,key,win[key])}),document.body.removeChild(iframe),res},Script.prototype.runInThisContext=function(){return eval(this.code)},Script.prototype.runInNewContext=function(context){var ctx=Script.createContext(context),res=this.runInContext(ctx);return forEach(Object_keys(ctx),function(key){context[key]=ctx[key]}),res},forEach(Object_keys(Script.prototype),function(name){exports[name]=Script[name]=function(code){var s=Script(code);return s[name].apply(s,[].slice.call(arguments,1))}}),exports.createScript=function(code){return exports.Script(code)},exports.createContext=Script.createContext=function(context){var copy=new Context;return"object"==typeof context&&forEach(Object_keys(context),function(key){copy[key]=context[key]}),copy}},function(module,exports,__webpack_require__){var Stream=function(){try{return __webpack_require__(169)}catch(_){}}();exports=module.exports=__webpack_require__(149),exports.Stream=Stream||exports,exports.Readable=exports,exports.Writable=__webpack_require__(150),exports.Duplex=__webpack_require__(151),exports.Transform=__webpack_require__(152),exports.PassThrough=__webpack_require__(153)},function(module,exports,__webpack_require__){"use strict";function ok(){return new Status(Status.OK,Status.OK,"",null)}function error(message,source,takeNodeFromSource){return void 0===takeNodeFromSource&&(takeNodeFromSource=!1),new Status(Status.ERROR,0,message,source,takeNodeFromSource)}function builtInRegistry(){return registry}function union(name,t){return new UnionType(name,t)}function intersect(name,t){return new IntersectionType(name,t)}function derive(name,t){var r=new InheritedType(name);return t.forEach(function(x){return r.addSuper(x)}),r.isSubTypeOf(exports.NIL)&&(r.nullable=!0),r}function deriveObjectType(name){return derive(name,[exports.OBJECT])}function select(obj,t0,t1){if(t0.isScalar()&&t1.isScalar()){if(t0.allSubTypes().indexOf(t1)!=-1)return t0;if(t1.allSubTypes().indexOf(t0)!=-1)return t1}var d0=t0.oneMeta(metaInfo.Discriminator),d1=t1.oneMeta(metaInfo.Discriminator);if(d0&&d1&&d0.property===d1.property){var v0=t0.descValue(),v1=t1.descValue();if(v0!==v1){var val=obj[d0.property];if(val===v0)return t0;if(val===v1)return t1}}return null}function is_int(value){return parseFloat(value)==parseInt(value)&&!isNaN(value)}function typePath(t){for(var arr=[];null!=t;){if(null!=t.name()){arr.push(t.name());break}if(!(t instanceof InheritedType))break;var contextMeta=t.contextMeta();if(null==contextMeta)break;arr.push(contextMeta.path()),t=contextMeta._owner}return arr.reverse()}var __extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},_=__webpack_require__(182),su=__webpack_require__(113),tsInterfaces=__webpack_require__(104),Status=function(){function Status(severity,code,message,source,takeNodeFromSource){void 0===takeNodeFromSource&&(takeNodeFromSource=!1),this.takeNodeFromSource=takeNodeFromSource,this.subStatus=[],this.severity=severity,this.code=code,this.message=message,this.source=source}return Status.prototype.getValidationPath=function(){return this.vp},Status.prototype.getValidationPathAsString=function(){if(!this.vp)return"";for(var s="",c=this.vp;c;)s+=c.name,c.child&&(s+="/"),c=c.child;return s},Status.prototype.patchPath=function(p){if(p){for(var c=p,r=null,cp=null;c;)if(r){var news={name:c.name};cp.child=news,c=c.child,cp=news}else r={name:c.name},cp=r,c=c.child,cp=r;return r}return null},Status.prototype.setValidationPath=function(c){var _this=this;if(this.vp){c=this.patchPath(c);for(var m=c;m.child;)m=m.child;m.child=this.vp,this.vp=c}else this.vp=c;this.subStatus.forEach(function(x){x.setValidationPath(_this.vp)})},Status.prototype.addSubStatus=function(st,pathName){void 0===pathName&&(pathName=null),pathName&&st.setValidationPath({name:pathName}),this.subStatus.push(st),this.severity<st.severity&&(this.severity=st.severity,this.message=st.message)},Status.prototype.getErrors=function(){if(this.isError()||this.isWarning()){if(this.subStatus.length>0){var rs=[];return this.subStatus.forEach(function(x){return rs=rs.concat(x.getErrors())}),rs}return[this]}return[]},Status.prototype.getSubStatuses=function(){return this.subStatus},Status.prototype.getSeverity=function(){return this.severity},Status.prototype.getMessage=function(){return this.message},Status.prototype.setMessage=function(message){this.message=message},Status.prototype.getSource=function(){return this.source},Status.prototype.isWarning=function(){return this.severity==Status.WARNING},Status.prototype.isError=function(){return this.severity==Status.ERROR},Status.prototype.isOk=function(){return this.severity===Status.OK},Status.prototype.setSource=function(s){this.source=s},Status.prototype.toString=function(){return this.isOk()?"OK":this.message},Status.prototype.getExtra=function(name){return this.takeNodeFromSource&&name==tsInterfaces.SOURCE_EXTRA&&this.source instanceof TypeInformation?this.source.node():null},Status.prototype.putExtra=function(name,value){},Status.CODE_CONFLICTING_TYPE_KIND=4,Status.ERROR=3,Status.INFO=1,Status.OK=0,Status.WARNING=2,Status}();exports.Status=Status,exports.ok=ok,exports.SCHEMA_AND_TYPE=tsInterfaces.SCHEMA_AND_TYPE_EXTRA,exports.GLOBAL=tsInterfaces.GLOBAL_EXTRA,exports.TOPLEVEL=tsInterfaces.TOP_LEVEL_EXTRA,exports.SOURCE_EXTRA=tsInterfaces.SOURCE_EXTRA,exports.error=error;var TypeInformation=function(){function TypeInformation(_inheritable){this._inheritable=_inheritable}return TypeInformation.prototype.node=function(){return this._node},TypeInformation.prototype.setNode=function(node){this._node=node},TypeInformation.prototype.owner=function(){return this._owner},TypeInformation.prototype.isInheritable=function(){return this._inheritable},TypeInformation.prototype.validateSelf=function(registry){return ok()},TypeInformation}();exports.TypeInformation=TypeInformation;var stack=null,Constraint=function(_super){function Constraint(){_super.call(this,!0)}return __extends(Constraint,_super),Constraint.prototype.intersect=function(t0,t1){var nm=t0.id()+""+t1.id();if(Constraint.intersections.hasOwnProperty(nm))return Constraint.intersections[nm];var is=intersect(nm,[t0,t1]);return Constraint.intersections[nm]=is,is},Constraint.prototype.release=function(t){delete Constraint.intersections[t.name()]},Constraint.prototype.nothing=function(c,message){return void 0===message&&(message="Conflicting restrictions"),new NothingRestrictionWithLocation(stack,message,c)},Constraint.prototype.composeWith=function(r){return null},Constraint.prototype.preoptimize=function(){null===stack&&(stack=new RestrictionStackEntry(null,null,"top")),stack=stack.push(this);try{return this.innerOptimize()}finally{stack=stack.pop()}},Constraint.prototype.innerOptimize=function(){return this},Constraint.prototype.tryCompose=function(r){null===stack&&(stack=new RestrictionStackEntry(null,null,"top")),stack=stack.push(this);try{return this.composeWith(r)}finally{stack=stack.pop()}},Constraint.prototype.kind=function(){return tsInterfaces.MetaInformationKind.Constraint},Constraint.prototype.conflictMessage=function(otherPath,otherValue){return null},Constraint.intersections={},Constraint}(TypeInformation);exports.Constraint=Constraint;var restr=__webpack_require__(107),metaInfo=__webpack_require__(108),fr=__webpack_require__(106),restrictions_1=__webpack_require__(107),metainfo_1=__webpack_require__(108),metainfo_2=__webpack_require__(108),restrictions_2=__webpack_require__(107),restrictions_3=__webpack_require__(107),exO=__webpack_require__(139),metainfo_3=__webpack_require__(108),restrictions_4=__webpack_require__(107),restrictions_5=__webpack_require__(107);exports.autoCloseFlag=!1;var TypeRegistry=function(){function TypeRegistry(_parent){void 0===_parent&&(_parent=null),this._parent=_parent,this._types={},this.typeList=[]}return TypeRegistry.prototype.put=function(alias,t){this._types[alias]=t},TypeRegistry.prototype.addType=function(t){t.isAnonymous()||(this._types[t.name()]=t,this.typeList.push(t))},TypeRegistry.prototype.get=function(name){return this._types.hasOwnProperty(name)?this._types[name]:null!=this._parent?this._parent.get(name):null},TypeRegistry.prototype.types=function(){return this.typeList},TypeRegistry}();exports.TypeRegistry=TypeRegistry;var PropertyCyclesValidator=function(){function PropertyCyclesValidator(){}return PropertyCyclesValidator.prototype.getInfos=function(t){if(t.getExtra("PInfos"))return t.getExtra("PInfos");var m={};return t.meta().forEach(function(x){if(x instanceof restr.HasProperty){var id=x.value();m[id]={name:id,type:null}}}),t.meta().forEach(function(x){if(x instanceof restr.PropertyIs){var id=x.propertyName();m[id]&&(m[id].type=x.value())}}),t.putExtra("PInfos",m),m},PropertyCyclesValidator.prototype.validate=function(t,visited){var _this=this,i=this.getInfos(t),result=!1;return Object.keys(i).forEach(function(x){result=result||_this.validateInfo(i[x],visited)}),result},PropertyCyclesValidator.prototype.validateInfo=function(t,visited){var _this=this;if(visited.some(function(y){return y==t}))return!0;if(t.type instanceof UnionType){var ut=t.type,passing=!0;return ut.options().forEach(function(o){_this.validate(o,[t].concat(visited))||(passing=!1)}),passing}return t.type.isArray()?void 0:this.validate(t.type,[t].concat(visited))},PropertyCyclesValidator.prototype.validateType=function(t){var _this=this,i=this.getInfos(t),result=[];return Object.keys(i).forEach(function(x){_this.validateInfo(i[x],[])&&result.push(x)}),result},PropertyCyclesValidator}(),RestrictionsConflict=function(_super){function RestrictionsConflict(_conflicting,_stack,source){_super.call(this,Status.ERROR,0,null,source),this._conflicting=_conflicting,this._stack=_stack;var conflictingMessage=null;if(null!=_stack&&_stack.getRestriction()instanceof restr.MinMaxRestriction){var mmr=_stack.getRestriction();conflictingMessage=_conflicting.conflictMessage(mmr.facetPath(),mmr.value())}null==conflictingMessage&&(conflictingMessage=_conflicting+" and "+(null!=_stack?_stack.getRestriction().toString():""));var typeInfo="";source instanceof AbstractType&&(typeInfo="in type '"+typePath(source)+"'"),this.message="Restrictions conflict "+typeInfo+": "+conflictingMessage}return __extends(RestrictionsConflict,_super),RestrictionsConflict.prototype.getConflictDescription=function(){var rs="";return rs+="Restrictions coflict:\n",rs+=this._stack.getRestriction()+" conflicts with "+this._conflicting+"\n",rs+="at\n",rs+=this._stack.pop()},RestrictionsConflict.prototype.getConflicting=function(){return this._conflicting},RestrictionsConflict.prototype.getStack=function(){return this._stack},RestrictionsConflict.prototype.toRestriction=function(){return new NothingRestrictionWithLocation(this._stack,this.message,this._conflicting)},RestrictionsConflict}(Status);exports.RestrictionsConflict=RestrictionsConflict;var globalId=0;exports.VALIDATED_TYPE=null;var AbstractType=function(){function AbstractType(_name){this._name=_name,this.metaInfo=[],this._subTypes=[],this.innerid=globalId++,this.extras={},this._locked=!1}return AbstractType.prototype.getExtra=function(name){return this.extras[name]},AbstractType.prototype.putExtra=function(name,v){this.extras[name]=v},AbstractType.prototype.id=function(){return this.innerid},AbstractType.prototype.knownProperties=function(){return this.metaOfType(restrictions_5.MatchesProperty)},AbstractType.prototype.lock=function(){this._locked=!0},AbstractType.prototype.isLocked=function(){return this._locked},AbstractType.prototype.allFacets=function(){return this.meta()},AbstractType.prototype.declaredFacets=function(){return this.declaredMeta()},AbstractType.prototype.isSubTypeOf=function(t){return t===exports.ANY||this===t||this.superTypes().some(function(x){return x.isSubTypeOf(t)})},AbstractType.prototype.isSuperTypeOf=function(t){return this===t||this.allSubTypes().indexOf(t)!=-1},AbstractType.prototype.addMeta=function(info){this.metaInfo.push(info),info._owner=this},AbstractType.prototype.name=function(){return this._name},AbstractType.prototype.label=function(){return this._name},AbstractType.prototype.subTypes=function(){return this._subTypes},AbstractType.prototype.superTypes=function(){return[]},AbstractType.prototype.validateType=function(tr){var _this=this;void 0===tr&&(tr=builtInRegistry());var rs=new Status(Status.OK,0,"",this);if(this.validateHierarchy(rs),this.getExtra(tsInterfaces.PARSE_ERROR)&&rs.addSubStatus(this.getExtra(tsInterfaces.PARSE_ERROR)),rs.isOk()){if(rs.addSubStatus(this.checkConfluent()),this.isExternal()){var allS=this.allSuperTypes(),mma=allS.filter(function(x){return x instanceof ExternalType});this instanceof ExternalType&&mma.push(this),mma.forEach(function(x){if(x.isJSON())try{su.getJSONSchema(x.schema(),x.getContentProvider&&x.getContentProvider())}catch(e){rs.addSubStatus(new Status(Status.ERROR,0,e.message,_this))}})}rs.isOk()&&this.superTypes().forEach(function(x){x.isAnonymous()&&rs.addSubStatus(x.validateType(tr))})}if(this.getExtra(exports.SCHEMA_AND_TYPE)&&rs.addSubStatus(new Status(Status.ERROR,0,"schema and type are mutually exclusive",this)),rs.isOk()&&this.validateMeta(tr).getErrors().forEach(function(x){return rs.addSubStatus(x);
}),this.isObject()){var required={};this.restrictions().forEach(function(x){x.owner()!=_this&&x instanceof restr.HasProperty&&(required[x.value()]=!0)}),this.declaredMeta().forEach(function(x){x instanceof restr.HasProperty&&delete required[x.value()]}),this.declaredMeta().forEach(function(x){if(x instanceof restr.PropertyIs){var pr=x;required.hasOwnProperty(pr.propertyName())&&rs.addSubStatus(new Status(Status.ERROR,0,"Can not override required property:"+pr.propertyName()+" to be optional",_this))}});var propertyCycles=(new PropertyCyclesValidator).validateType(this);propertyCycles.length>0&&propertyCycles.forEach(function(p){var st=new Status(Status.ERROR,0,p+"has cyclic dependency",_this);st.setValidationPath({name:p}),rs.addSubStatus(st)})}return rs},AbstractType.prototype.validateHierarchy=function(rs){var _this=this;if(this.isAnonymous()||this.getExtra(tsInterfaces.TOP_LEVEL_EXTRA)&&builtInRegistry().get(this.name())&&rs.addSubStatus(new Status(Status.ERROR,0,"redefining builtin type:"+this.name(),this)),this.isSubTypeOf(exports.RECURRENT)&&rs.addSubStatus(new Status(Status.ERROR,0,"recurrent type definition",this),"type"),this.isSubTypeOf(exports.UNKNOWN)&&rs.addSubStatus(new Status(Status.ERROR,0,"inheriting from unknown type",this),"type"),this.isUnion()){var tf=this.typeFamily();tf.some(function(x){return x.isSubTypeOf(exports.RECURRENT)})&&rs.addSubStatus(new Status(Status.ERROR,0,"recurrent type as an option of union type",this),"type"),tf.some(function(x){return x.isSubTypeOf(exports.UNKNOWN)})&&rs.addSubStatus(new Status(Status.ERROR,0,"unknown type as an option of union type",this),"type")}if(this.isArray()){var fs_1=this.familyWithArray(),ps=this.getExtra(tsInterfaces.HAS_ITEMS)?"items":"type";fs_1.indexOf(this)!=-1||fs_1.some(function(x){return x===exports.RECURRENT})?rs.addSubStatus(new Status(Status.ERROR,0,"recurrent array type definition",this),ps):fs_1.some(function(x){return x===exports.UNKNOWN})&&rs.addSubStatus(new Status(Status.ERROR,0,"referring to unknown type "+this.oneMeta(restrictions_3.ComponentShouldBeOfType).value().name()+" as an array component type",this),ps)}var supers=this.superTypes(),hasExternal=!1,hasNotExternal=!1;if(supers.length>1&&supers.forEach(function(x){x.isExternal()?hasExternal=!0:hasNotExternal=!0}),hasExternal&&hasNotExternal&&rs.addSubStatus(new Status(Status.ERROR,0,"It is not allowed to mix RAML types with externals",this),"type"),this instanceof UnionType){var ut=this;ut.options().forEach(function(x){x.isExternal()&&rs.addSubStatus(new Status(Status.ERROR,0,"It is not allowed to mix RAML types with externals",_this),"type")})}if(this.isExternal()&&this.getExtra(tsInterfaces.HAS_FACETS)){var fs=new Status(Status.ERROR,0,"External types can not declare facet '"+this.getExtra(tsInterfaces.HAS_FACETS)+"'",this);fs.setValidationPath({name:this.getExtra(tsInterfaces.HAS_FACETS)}),rs.addSubStatus(fs)}},AbstractType.prototype.familyWithArray=function(){var ts=this.allSuperTypes(),mn=this.oneMeta(restrictions_3.ComponentShouldBeOfType);if(mn){var at=mn.value();ts=ts.concat(at.familyWithArray())}return ts},AbstractType.prototype.validateMeta=function(tr){var rs=new Status(Status.OK,0,"",this);return this.declaredMeta().forEach(function(x){x.validateSelf(tr).getErrors().forEach(function(y){return rs.addSubStatus(y)})}),this.validateFacets(rs),rs},AbstractType.prototype.validateFacets=function(rs){var _this=this,fds={},super_facets={},rfds={};this.meta().forEach(function(x){if(x instanceof metainfo_1.FacetDeclaration){var fd=x;fds[fd.actualName()]=fd,fd.isOptional()||fd.owner()!==_this&&(rfds[fd.actualName()]=fd),fd.owner()!=_this&&(super_facets[fd.actualName()]=fd)}}),this.declaredMeta().forEach(function(x){if(x instanceof metainfo_1.FacetDeclaration){var fd=x;if(fd.owner()==_this){var an=fd.actualName();super_facets.hasOwnProperty(an)&&rs.addSubStatus(new Status(Status.ERROR,0,"facet :"+an+" can not be overriden",_this));var fp=fr.getInstance().facetPrototypeWithName(an);(fp&&fp.isApplicable(_this)||"type"==an||"properties"==fd.facetName()||"schema"==an||"facets"==an||"uses"==an)&&rs.addSubStatus(new Status(Status.ERROR,0,"built-in facet :"+an+" can not be overriden",_this)),"("==an.charAt(0)&&rs.addSubStatus(new Status(Status.ERROR,0,"facet :"+an+" can not start from '('",_this))}}});var knownPropertySet={};this.meta().forEach(function(x){x instanceof restrictions_2.PropertyIs&&(knownPropertySet[x.propId()]=!0)}),this.meta().forEach(function(x){if(x instanceof metainfo_2.CustomFacet){var cd=x;if(fds.hasOwnProperty(cd.facetName())){var ft=fds[cd.facetName()].value();rs.addSubStatus(ft.validateDirect(cd.value(),!1,!1)),delete rfds[cd.facetName()]}else{var msg=_this.isExternal()?"'"+cd.facetName()+"' facet is prohibited for external types":"specifying unknown facet:"+cd.facetName();rs.addSubStatus(new Status(Status.ERROR,0,msg,cd,(!0)))}}if(x instanceof restrictions_4.MapPropertyIs){var mm=x;Object.keys(knownPropertySet).forEach(function(c){try{if(c.match(mm.regexpValue())){var regexpText="/"+mm.regexpValue().toString()+"/";rs.addSubStatus(new Status(Status.WARNING,0,"pattern property '"+regexpText+"' conflicts with property: "+c,_this))}}catch(e){}})}}),Object.getOwnPropertyNames(rfds).length>0&&rs.addSubStatus(new Status(Status.ERROR,0,"missing required facets:"+Object.keys(rfds).join(","),this))},AbstractType.prototype.allSuperTypes=function(){var rs=[];return this.fillSuperTypes(rs),rs},AbstractType.prototype.fillSuperTypes=function(r){this.superTypes().forEach(function(x){_.contains(r,x)||(r.push(x),x.fillSuperTypes(r))})},AbstractType.prototype.allSubTypes=function(){var rs=[];return this.fillSubTypes(rs),rs},AbstractType.prototype.fillSubTypes=function(r){this.subTypes().forEach(function(x){_.contains(r,x)||(r.push(x),x.fillSubTypes(r))})},AbstractType.prototype.inherit=function(name){var rs=new InheritedType(name);return rs.addSuper(this),rs},AbstractType.prototype.isAnonymous=function(){return!this._name||0===this._name.length},AbstractType.prototype.isEmpty=function(){return!(this.metaInfo.length>1)&&0==this.metaInfo.filter(function(x){return!(x instanceof metainfo_3.NotScalar)}).length},AbstractType.prototype.isArray=function(){return this===exports.ARRAY||this.allSuperTypes().indexOf(exports.ARRAY)!=-1},AbstractType.prototype.propertySet=function(){var rs=[];return this.meta().forEach(function(x){if(x instanceof restrictions_2.PropertyIs){var p=x;rs.push(p.propertyName())}}),_.uniq(rs)},AbstractType.prototype.checkConfluent=function(){if(this.computeConfluent)return ok();this.computeConfluent=!0;try{var os=restr.optimize(this.restrictions()),ns=_.find(os,function(x){return x instanceof NothingRestriction});if(ns){var lstack=null,another=null;if(ns instanceof NothingRestrictionWithLocation){var nswl=ns;lstack=nswl.getStack(),another=nswl.another()}var status=new RestrictionsConflict(another,lstack,this);return status}return ok()}finally{this.computeConfluent=!1}},AbstractType.prototype.isObject=function(){return this==exports.OBJECT||this.allSuperTypes().indexOf(exports.OBJECT)!=-1},AbstractType.prototype.isExternal=function(){return this==exports.EXTERNAL||this.allSuperTypes().indexOf(exports.EXTERNAL)!=-1},AbstractType.prototype.isBoolean=function(){return this==exports.BOOLEAN||this.allSuperTypes().indexOf(exports.BOOLEAN)!=-1},AbstractType.prototype.isString=function(){return this==exports.STRING||this.allSuperTypes().indexOf(exports.STRING)!=-1},AbstractType.prototype.isNumber=function(){return this==exports.NUMBER||this.allSuperTypes().indexOf(exports.NUMBER)!=-1},AbstractType.prototype.isFile=function(){return this==exports.FILE||this.allSuperTypes().indexOf(exports.FILE)!=-1},AbstractType.prototype.isScalar=function(){return this==exports.SCALAR||this.allSuperTypes().indexOf(exports.SCALAR)!=-1},AbstractType.prototype.isDateTime=function(){return this==exports.DATETIME||this.allSuperTypes().indexOf(exports.DATETIME)!=-1},AbstractType.prototype.isDateOnly=function(){return this==exports.DATE_ONLY||this.allSuperTypes().indexOf(exports.DATE_ONLY)!=-1},AbstractType.prototype.isTimeOnly=function(){return this==exports.TIME_ONLY||this.allSuperTypes().indexOf(exports.TIME_ONLY)!=-1},AbstractType.prototype.isInteger=function(){return this==exports.INTEGER||this.allSuperTypes().indexOf(exports.INTEGER)!=-1},AbstractType.prototype.isDateTimeOnly=function(){return this==exports.DATETIME_ONLY||this.allSuperTypes().indexOf(exports.DATETIME_ONLY)!=-1},AbstractType.prototype.isUnknown=function(){return this==exports.UNKNOWN||this.allSuperTypes().indexOf(exports.UNKNOWN)!=-1},AbstractType.prototype.isRecurrent=function(){return this==exports.RECURRENT||this.allSuperTypes().indexOf(exports.RECURRENT)!=-1},AbstractType.prototype.isBuiltin=function(){return this.metaInfo.indexOf(BUILT_IN)!=-1},AbstractType.prototype.exampleObject=function(){return exO.example(this)},AbstractType.prototype.isPolymorphic=function(){return this.meta().some(function(x){return x instanceof Polymorphic})},AbstractType.prototype.restrictions=function(forValidation){if(void 0===forValidation&&(forValidation=!1),this.isUnion()){var rs=[];return this.superTypes().forEach(function(x){rs=rs.concat(x.restrictions())}),rs=rs.concat(this.meta().filter(function(x){return x instanceof Constraint}))}var result=[],generic=null;return this.meta().forEach(function(x){if(x instanceof Constraint){if(x instanceof GenericTypeOf&&forValidation){if(generic)return;generic=x}result.push(x)}}),result},AbstractType.prototype.customFacets=function(){return this.declaredMeta().filter(function(x){return x instanceof metaInfo.CustomFacet})},AbstractType.prototype.allCustomFacets=function(){return this.meta().filter(function(x){return x instanceof metaInfo.CustomFacet})},AbstractType.prototype.isUnion=function(){var rs=!1;return!this.isBuiltin()&&(this.allSuperTypes().forEach(function(x){return rs=rs||x instanceof UnionType}),rs)},AbstractType.prototype.meta=function(){return[].concat(this.metaInfo)},AbstractType.prototype.validateDirect=function(i,autoClose,nullAllowed,path){var _this=this;void 0===autoClose&&(autoClose=!1),void 0===nullAllowed&&(nullAllowed=!0),void 0===path&&(path=null);var prevValidated=exports.VALIDATED_TYPE;try{exports.VALIDATED_TYPE=this;var result=new Status(Status.OK,0,"",this);if(!(nullAllowed||null!==i&&void 0!==i||this.nullable))return error("object is expected",this);if(this.restrictions(!0).forEach(function(x){return result.addSubStatus(x.check(i,path))}),(autoClose||exports.autoCloseFlag)&&this.isObject()&&!this.oneMeta(restrictions_1.KnownPropertyRestriction)){var cp=new restrictions_1.KnownPropertyRestriction((!1));cp.patchOwner(this),cp.check(i).getErrors().forEach(function(x){var rs=new Status(Status.WARNING,0,x.getMessage(),_this);rs.setValidationPath(x.getValidationPath()),result.addSubStatus(rs)})}}finally{exports.VALIDATED_TYPE=prevValidated}return result},AbstractType.prototype.validate=function(i,autoClose,nullAllowed){void 0===autoClose&&(autoClose=!1),void 0===nullAllowed&&(nullAllowed=!0);var g=exports.autoCloseFlag;if(!(nullAllowed||null!==i&&void 0!==i||this.nullable))return error("Null or undefined value is not allowed",this);autoClose&&(exports.autoCloseFlag=!0);try{for(var _i=0,_a=this.subTypes();_i<_a.length;_i++){var subType=_a[_i],vr=subType.validateDirect(i,autoClose||g);if(vr.isOk())return vr}return this.validateDirect(i,autoClose||g)}finally{exports.autoCloseFlag=g}},AbstractType.prototype.declareMapProperty=function(name,type){return null!=type&&this.addMeta(new restr.MapPropertyIs(name,type)),type},AbstractType.prototype.closeUnknownProperties=function(){this.addMeta(new restrictions_1.KnownPropertyRestriction((!1)))},AbstractType.prototype.canDoAc=function(){for(var tf=_.uniq(this.typeFamily()),s=new Status(Status.OK,0,"",this),i=0;i<tf.length;i++)for(var j=0;j<tf.length;j++)if(i!=j){var t0=tf[i],t1=tf[j],ed=this.emptyIntersectionOrDiscriminator(t0,t1);s.addSubStatus(ed)}return s},AbstractType.prototype.emptyIntersectionOrDiscriminator=function(t0,t1){if(t1===t0)return ok();if(t1.isScalar()&&t0.isScalar())return ok();var it=intersect("",[t0,t1]),innerCheckConfluent=it.checkConfluent();return innerCheckConfluent.isOk()?this.checkDiscriminator(t0,t1):ok()},AbstractType.prototype.checkDiscriminator=function(t1,t2){var found=new Status(Status.ERROR,0,"can not discriminate types "+t1.name()+" and "+t2.name()+" without discriminator",this),oneMeta=t1.oneMeta(metaInfo.Discriminator),anotherMeta=t2.oneMeta(metaInfo.Discriminator);if(null!=oneMeta&&null!=anotherMeta&&oneMeta.value()===anotherMeta.value()){var d1=t1.name(),d2=t2.name(),dv1=t1.oneMeta(metaInfo.DiscriminatorValue);null!=dv1&&(d1=dv1.value());var dv2=t2.oneMeta(metaInfo.DiscriminatorValue);if(null!=dv2&&(d2=dv2.value()),d1!==d2)return ok();found=new Status(Status.ERROR,0,"types"+t1.name()+" and "+t2.name()+" have same discriminator value",this)}return found},AbstractType.prototype.ac=function(obj){if(!this.isPolymorphic()&&!this.isUnion())return this;if(this.isBuiltin())return this;var tf=_.uniq(this.typeFamily());if(0==tf.length)return exports.NOTHING;if(this.isScalar())return this.isNumber()?"number"==typeof obj?this:exports.NOTHING:this.isString()?"string"==typeof obj?this:exports.NOTHING:this.isBoolean()?"boolean"==typeof obj?this:exports.NOTHING:this;if(1===tf.length)return tf[0];var options=[];tf.forEach(function(x){var ds=x.validateDirect(obj,!0);ds.isOk()&&options.push(x)});var t=this.discriminate(obj,options);return t?t:exports.NOTHING},AbstractType.prototype.declareProperty=function(name,t,optional){return optional||this.addMeta(new restr.HasProperty(name)),null!=t&&this.addMeta(new restr.PropertyIs(name,t)),this},AbstractType.prototype.discriminate=function(obj,opt){for(var newOpts=[].concat(opt),opts=[].concat(opt);newOpts.length>1;){var found=!1;l2:for(var i=0;i<opts.length;i++)for(var j=0;j<opts.length;j++){var t0=opts[i],t1=opts[j];if(t0!=t1){var nt=select(obj,t0,t1);if(nt===t0){opts=opts.filter(function(x){return x!=t1}),found=!0;break l2}if(nt===t1){opts=opts.filter(function(x){return x!=t0}),found=!0;break l2}opts=opts.filter(function(x){return x!=t0&&x!=t1}),found=!0;break l2}}newOpts=opts}return 1==newOpts.length?newOpts[0]:null},AbstractType.prototype.oneMeta=function(clazz){return _.find(this.meta(),function(x){return x instanceof clazz})},AbstractType.prototype.metaOfType=function(clazz){return this.meta().filter(function(x){return x instanceof clazz})},AbstractType.prototype.declaredMeta=function(){return this.metaInfo},AbstractType.prototype.descValue=function(){var dv=this.oneMeta(metaInfo.DiscriminatorValue);return dv?dv.value():this.name()},AbstractType.prototype.isAbstractOrInternal=function(){return this.metaInfo.some(function(x){return x instanceof Abstract||x instanceof Internal})},AbstractType.prototype.typeFamily=function(){if(this.isUnion()){var res=[];return this.allSuperTypes().forEach(function(x){if(x instanceof UnionType)for(var opts=x.allOptions(),i=0;i<opts.length;i++)res=res.concat(opts[i].typeFamily())}),_.unique(res)}var rs=[];return this.isAbstractOrInternal()||rs.push(this),this.allSubTypes().forEach(function(x){x.isAbstractOrInternal()||rs.push(x)}),_.unique(rs)},AbstractType}();exports.AbstractType=AbstractType;var Modifier=function(_super){function Modifier(){_super.apply(this,arguments)}return __extends(Modifier,_super),Modifier.prototype.requiredType=function(){return exports.ANY},Modifier.prototype.kind=function(){return tsInterfaces.MetaInformationKind.Modifier},Modifier}(TypeInformation);exports.Modifier=Modifier;var Polymorphic=function(_super){function Polymorphic(){_super.call(this,!0)}return __extends(Polymorphic,_super),Polymorphic.prototype.facetName=function(){return"polymorphic"},Polymorphic.prototype.value=function(){return!0},Polymorphic}(Modifier);exports.Polymorphic=Polymorphic;var Abstract=function(_super){function Abstract(){_super.call(this,!1)}return __extends(Abstract,_super),Abstract.prototype.value=function(){return!0},Abstract.prototype.facetName=function(){return"abstract"},Abstract}(Modifier);exports.Abstract=Abstract;var Internal=function(_super){function Internal(){_super.call(this,!1)}return __extends(Internal,_super),Internal.prototype.facetName=function(){return"abstract"},Internal.prototype.value=function(){return!0},Internal}(Modifier);exports.Internal=Internal;var BuiltIn=function(_super){function BuiltIn(){_super.call(this,!1)}return __extends(BuiltIn,_super),BuiltIn.prototype.facetName=function(){return"builtIn"},BuiltIn.prototype.value=function(){return!0},BuiltIn}(Modifier),BUILT_IN=new BuiltIn,RootType=function(_super){function RootType(){_super.apply(this,arguments)}return __extends(RootType,_super),RootType.prototype.kind=function(){return"root"},RootType}(AbstractType);exports.RootType=RootType;var InheritedType=function(_super){function InheritedType(){_super.apply(this,arguments),this._superTypes=[]}return __extends(InheritedType,_super),InheritedType.prototype.superTypes=function(){return this._superTypes},InheritedType.prototype.knownProperties=function(){var vs=this.metaOfType(restrictions_5.MatchesProperty);return this.superTypes().forEach(function(x){vs=vs.concat(x.knownProperties())}),vs},InheritedType.prototype.kind=function(){return"inherited"},InheritedType.prototype.meta=function(){var _this=this,rs=_super.prototype.meta.call(this),hasKp=!1;return this.superTypes().forEach(function(x){x.meta().forEach(function(m){if(m instanceof restrictions_1.KnownPropertyRestriction){if(hasKp)return;var kp=new restrictions_1.KnownPropertyRestriction((!1));return kp.patchOwner(_this),void rs.push(kp)}m.isInheritable()&&rs.push(m)})}),rs},InheritedType.prototype.addSuper=function(t){this._superTypes.push(t),t.isLocked()||t._subTypes.push(this),t.nullable&&(this.nullable=!0)},InheritedType.prototype.label=function(){var cmp=this.metaOfType(restrictions_3.ComponentShouldBeOfType);return cmp.length>0?cmp[0].value().label()+"[]":_super.prototype.label.call(this)},InheritedType.prototype.contextMeta=function(){return this._contextMeta},InheritedType.prototype.setContextMeta=function(contextMeta){this._contextMeta=contextMeta},InheritedType}(AbstractType);exports.InheritedType=InheritedType;var DerivedType=function(_super){function DerivedType(name,_options){_super.call(this,name),this._options=_options}return __extends(DerivedType,_super),DerivedType.prototype.allOptions=function(){var _this=this,rs=[];return this._options.forEach(function(x){x.kind()==_this.kind()?rs=rs.concat(x.allOptions()):rs.push(x)}),_.unique(rs)},DerivedType.prototype.options=function(){return this._options},DerivedType}(AbstractType);exports.DerivedType=DerivedType;var UnionType=function(_super){function UnionType(name,_options){var _this=this;_super.call(this,name,_options),this.options().forEach(function(x){x.nullable&&(_this.nullable=!0)})}return __extends(UnionType,_super),UnionType.prototype.kind=function(){return"union"},UnionType.prototype.isSubTypeOf=function(t){var isSubType=!0;return this.allOptions().forEach(function(x){x.isSubTypeOf(t)||(isSubType=!1)}),isSubType},UnionType.prototype.validate=function(i){return this.validateDirect(i)},UnionType.prototype.typeFamily=function(){var res=[];return this.allOptions().forEach(function(x){res=res.concat(x.typeFamily())}),res},UnionType.prototype.knownProperties=function(){var vs=this.metaOfType(restrictions_5.MatchesProperty);return this.options().forEach(function(x){vs=vs.concat(x.knownProperties())}),vs},UnionType.prototype.validateDirect=function(i,autoClose){void 0===autoClose&&(autoClose=!1);var result=new Status(Status.OK,0,"",this);return this.restrictions().forEach(function(x){return result.addSubStatus(x.check(i,null))}),result},UnionType.prototype.isUnion=function(){return!0},UnionType.prototype.restrictions=function(){return[new OrRestriction(this.allOptions().map(function(x){return new AndRestriction(x.restrictions())}),"Union type options do not pass validation","Union type option does not pass validation")]},UnionType.prototype.label=function(){return this.options().map(function(x){return x.label()}).join("|")},UnionType}(DerivedType);exports.UnionType=UnionType;var IntersectionType=function(_super){function IntersectionType(){_super.apply(this,arguments)}return __extends(IntersectionType,_super),IntersectionType.prototype.kind=function(){return"intersection"},IntersectionType.prototype.restrictions=function(){var rs=[];return this.allOptions().forEach(function(x){return rs=rs.concat(x.restrictions())}),[new AndRestriction(rs)]},IntersectionType.prototype.label=function(){return this.options().map(function(x){return x.label()}).join("&")},IntersectionType}(DerivedType);exports.IntersectionType=IntersectionType;var registry=new TypeRegistry;exports.builtInRegistry=builtInRegistry,exports.union=union,exports.intersect=intersect,exports.derive=derive,exports.deriveObjectType=deriveObjectType;var NothingRestriction=function(_super){function NothingRestriction(){_super.apply(this,arguments)}return __extends(NothingRestriction,_super),NothingRestriction.prototype.check=function(i){return null===i||void 0===i?ok():error("nothing ",this)},NothingRestriction.prototype.requiredType=function(){return exports.ANY},NothingRestriction.prototype.facetName=function(){return"nothing"},NothingRestriction.prototype.value=function(){return"!!!"},NothingRestriction}(Constraint);exports.NothingRestriction=NothingRestriction;var RestrictionStackEntry=function(){function RestrictionStackEntry(_previous,_restriction,id){this._previous=_previous,this._restriction=_restriction,this.id=id}return RestrictionStackEntry.prototype.getRestriction=function(){return this._restriction},RestrictionStackEntry.prototype.pop=function(){return this._previous},RestrictionStackEntry.prototype.push=function(r){return new RestrictionStackEntry(this,r,r.toString())},RestrictionStackEntry}();exports.RestrictionStackEntry=RestrictionStackEntry;var NothingRestrictionWithLocation=function(_super){function NothingRestrictionWithLocation(_entry,_message,_another){_super.call(this),this._entry=_entry,this._message=_message,this._another=_another}return __extends(NothingRestrictionWithLocation,_super),NothingRestrictionWithLocation.prototype.getMessage=function(){return this._message},NothingRestrictionWithLocation.prototype.getStack=function(){return this._entry},NothingRestrictionWithLocation.prototype.another=function(){return this._another},NothingRestrictionWithLocation}(NothingRestriction);exports.NothingRestrictionWithLocation=NothingRestrictionWithLocation;var GenericTypeOf=function(_super){function GenericTypeOf(){_super.apply(this,arguments)}return __extends(GenericTypeOf,_super),GenericTypeOf}(Constraint);exports.GenericTypeOf=GenericTypeOf;var TypeOfRestriction=function(_super){function TypeOfRestriction(val){_super.call(this),this.val=val}return __extends(TypeOfRestriction,_super),TypeOfRestriction.prototype.check=function(i){var to=typeof i;return null===i||void 0===i?ok():(Array.isArray(i)&&(to="array"),to===this.val?ok():error(this.val+" is expected",this))},TypeOfRestriction.prototype.value=function(){return this.val},TypeOfRestriction.prototype.requiredType=function(){return exports.ANY},TypeOfRestriction.prototype.facetName=function(){return"typeOf"},TypeOfRestriction.prototype.composeWith=function(r){if(r instanceof TypeOfRestriction){var to=r;return to.val==this.val?this:this.nothing(r)}return null},TypeOfRestriction.prototype.toString=function(){return"should be of type "+this.val},TypeOfRestriction}(GenericTypeOf);exports.TypeOfRestriction=TypeOfRestriction;var IntegerRestriction=function(_super){function IntegerRestriction(){_super.call(this)}return __extends(IntegerRestriction,_super),IntegerRestriction.prototype.check=function(i){return"number"==typeof i&&is_int(i)?ok():error("integer is expected",this)},IntegerRestriction.prototype.requiredType=function(){return exports.ANY},IntegerRestriction.prototype.value=function(){return!0},IntegerRestriction.prototype.facetName=function(){return"should be integer"},IntegerRestriction}(GenericTypeOf);exports.IntegerRestriction=IntegerRestriction;var NullRestriction=function(_super){function NullRestriction(){_super.call(this)}return __extends(NullRestriction,_super),NullRestriction.prototype.check=function(i){return null===i||void 0==i||"null"===i?ok():error("null is expected",this)},NullRestriction.prototype.requiredType=function(){return exports.ANY},NullRestriction.prototype.value=function(){return!0},NullRestriction.prototype.facetName=function(){return"should be null"},NullRestriction}(GenericTypeOf);exports.NullRestriction=NullRestriction;var ScalarRestriction=function(_super){function ScalarRestriction(){_super.call(this)}return __extends(ScalarRestriction,_super),ScalarRestriction.prototype.check=function(i){return i?"number"==typeof i||"boolean"==typeof i||"string"==typeof i?ok():error("scalar is expected",this):ok()},ScalarRestriction.prototype.requiredType=function(){return exports.ANY},ScalarRestriction.prototype.facetName=function(){return"should be scalar"},ScalarRestriction.prototype.value=function(){return!0},ScalarRestriction}(GenericTypeOf);exports.ScalarRestriction=ScalarRestriction;var OrRestriction=function(_super){function OrRestriction(val,_extraMessage,_extraOptionMessage){_super.call(this),this.val=val,this._extraMessage=_extraMessage,this._extraOptionMessage=_extraOptionMessage}return __extends(OrRestriction,_super),OrRestriction.prototype.check=function(i,p){for(var _this=this,cs=new Status(Status.OK,0,"",this),results=[],j=0;j<this.val.length;j++){var m=this.val[j].check(i,p);if(m.isOk())return ok();results.push(m)}if(results.length>0){for(var _i=0,results_1=results;_i<results_1.length;_i++){var r=results_1[_i],ownerName=null,src=r.getSource();if(src instanceof TypeInformation){var owner=src.owner();owner&&(ownerName=owner.label())}r.getErrors().forEach(function(x){var msg=x.getMessage();ownerName&&(msg=ownerName+": "+msg),_this._extraOptionMessage&&(msg=_this._extraOptionMessage+" ("+msg+")"),x.setMessage(msg),cs.addSubStatus(x)})}this._extraMessage&&cs.addSubStatus(error(this._extraMessage,this))}return cs},OrRestriction.prototype.value=function(){return this.val.map(function(x){return x.value()})},OrRestriction.prototype.requiredType=function(){return exports.ANY},OrRestriction.prototype.facetName=function(){return"or"},OrRestriction}(Constraint);exports.OrRestriction=OrRestriction;var AndRestriction=function(_super){function AndRestriction(val){_super.call(this),this.val=val}return __extends(AndRestriction,_super),AndRestriction.prototype.value=function(){return this.val.map(function(x){return x.value()})},AndRestriction.prototype.options=function(){return this.val},AndRestriction.prototype.check=function(i,p){for(var j=0;j<this.val.length;j++){var st=this.val[j].check(i,p);if(!st.isOk())return st}return ok()},AndRestriction.prototype.requiredType=function(){return exports.ANY},AndRestriction.prototype.facetName=function(){return"and"},AndRestriction}(Constraint);exports.AndRestriction=AndRestriction,exports.ANY=new RootType("any"),exports.SCALAR=exports.ANY.inherit("scalar"),exports.OBJECT=exports.ANY.inherit("object"),exports.ARRAY=exports.ANY.inherit("array"),exports.NIL=exports.ANY.inherit("nil"),exports.EXTERNAL=exports.ANY.inherit("external"),exports.NUMBER=exports.SCALAR.inherit("number"),exports.INTEGER=exports.NUMBER.inherit("integer"),exports.BOOLEAN=exports.SCALAR.inherit("boolean"),exports.STRING=exports.SCALAR.inherit("string"),exports.DATE_ONLY=exports.SCALAR.inherit("date-only"),exports.TIME_ONLY=exports.SCALAR.inherit("time-only"),exports.DATETIME_ONLY=exports.SCALAR.inherit("datetime-only"),exports.DATETIME=exports.SCALAR.inherit("datetime"),exports.FILE=exports.SCALAR.inherit("file"),exports.NOTHING=new RootType("nothing"),exports.UNION=exports.ANY.inherit("union"),exports.UNKNOWN=exports.NOTHING.inherit("unknown"),exports.RECURRENT=exports.NOTHING.inherit("recurrent"),exports.ANY.addMeta(BUILT_IN),exports.NIL.addMeta(BUILT_IN),exports.UNION.addMeta(BUILT_IN),exports.SCALAR.addMeta(BUILT_IN),exports.OBJECT.addMeta(BUILT_IN),exports.ARRAY.addMeta(BUILT_IN),exports.NUMBER.addMeta(BUILT_IN),exports.INTEGER.addMeta(BUILT_IN),exports.BOOLEAN.addMeta(BUILT_IN),exports.STRING.addMeta(BUILT_IN),exports.EXTERNAL.addMeta(BUILT_IN),exports.UNKNOWN.addMeta(BUILT_IN),exports.RECURRENT.addMeta(BUILT_IN),exports.DATE_ONLY.addMeta(BUILT_IN),exports.TIME_ONLY.addMeta(BUILT_IN),exports.DATETIME_ONLY.addMeta(BUILT_IN),exports.DATETIME.addMeta(BUILT_IN),exports.FILE.addMeta(BUILT_IN),exports.UNKNOWN.addMeta(BUILT_IN),exports.UNKNOWN.lock(),exports.RECURRENT.addMeta(BUILT_IN),exports.RECURRENT.lock(),exports.EXTERNAL.lock(),exports.UNION.lock(),registry.addType(exports.ANY),registry.addType(exports.SCALAR),registry.addType(exports.OBJECT),registry.addType(exports.ARRAY),registry.addType(exports.NUMBER),registry.addType(exports.INTEGER),registry.addType(exports.BOOLEAN),registry.addType(exports.NIL),registry.addType(exports.STRING),registry.addType(exports.DATE_ONLY),registry.addType(exports.TIME_ONLY),registry.addType(exports.DATETIME_ONLY),registry.addType(exports.DATETIME),registry.addType(exports.FILE),exports.NOTHING.addMeta(new NothingRestriction),exports.NUMBER.addMeta(new TypeOfRestriction("number")),exports.NUMBER.addMeta(new metainfo_1.FacetDeclaration("format",exports.STRING,(!0))),exports.BOOLEAN.addMeta(new TypeOfRestriction("boolean")),exports.OBJECT.addMeta(new TypeOfRestriction("object")),exports.ARRAY.addMeta(new TypeOfRestriction("array")),exports.STRING.addMeta(new TypeOfRestriction("string")),exports.INTEGER.addMeta(new IntegerRestriction),exports.NIL.addMeta(new NullRestriction);var dt=__webpack_require__(140);exports.DATE_ONLY.addMeta(new dt.DateOnlyR),exports.TIME_ONLY.addMeta(new dt.TimeOnlyR),exports.DATETIME_ONLY.addMeta(new dt.DateTimeOnlyR),exports.DATETIME.addMeta(new dt.DateTimeR),exports.FILE.addMeta(new TypeOfRestriction("string"));var arrayOfString=exports.ARRAY.inherit("");arrayOfString.addMeta(new restrictions_3.ComponentShouldBeOfType(exports.STRING)),exports.FILE.addMeta(new metainfo_1.FacetDeclaration("fileTypes",arrayOfString,(!0))),exports.FILE.addMeta(new metainfo_1.FacetDeclaration("minLength",exports.INTEGER,(!0))),exports.FILE.addMeta(new metainfo_1.FacetDeclaration("maxLength",exports.INTEGER,(!0))),exports.DATETIME.addMeta(new metainfo_1.FacetDeclaration("format",exports.STRING,(!0))),exports.NIL.nullable=!0,exports.SCALAR.addMeta(new ScalarRestriction),registry.types().forEach(function(x){return x.lock()});var ExternalType=function(_super){function ExternalType(name,_content,json,provider){_super.call(this,name),this._content=_content,this.json=json,this.provider=provider,this.addMeta(new restr.MatchToSchema(_content,provider)),this.addSuper(exports.EXTERNAL)}return __extends(ExternalType,_super),ExternalType.prototype.getContentProvider=function(){return this.provider},ExternalType.prototype.setContentProvider=function(provider){this.provider=provider},ExternalType.prototype.kind=function(){return"external"},ExternalType.prototype.isJSON=function(){return this.json},ExternalType.prototype.schema=function(){return this._content},ExternalType}(InheritedType);exports.ExternalType=ExternalType,exports.typePath=typePath},function(module,exports,__webpack_require__){"use strict";exports.REPEAT="repeat",exports.PARSE_ERROR="parseError",exports.TOP_LEVEL_EXTRA="topLevel",exports.DEFINED_IN_TYPES_EXTRA="definedInTypes",exports.USER_DEFINED_EXTRA="USER_DEFINED",exports.SOURCE_EXTRA="SOURCE",exports.SCHEMA_AND_TYPE_EXTRA="SCHEMA",exports.GLOBAL_EXTRA="GLOBAL",exports.HAS_FACETS="HAS_FACETS",exports.HAS_ITEMS="HAS_ITEMS",function(MetaInformationKind){MetaInformationKind[MetaInformationKind.Description=0]="Description",MetaInformationKind[MetaInformationKind.NotScalar=1]="NotScalar",MetaInformationKind[MetaInformationKind.DisplayName=2]="DisplayName",MetaInformationKind[MetaInformationKind.Usage=3]="Usage",
MetaInformationKind[MetaInformationKind.Annotation=4]="Annotation",MetaInformationKind[MetaInformationKind.FacetDeclaration=5]="FacetDeclaration",MetaInformationKind[MetaInformationKind.CustomFacet=6]="CustomFacet",MetaInformationKind[MetaInformationKind.Example=7]="Example",MetaInformationKind[MetaInformationKind.Required=8]="Required",MetaInformationKind[MetaInformationKind.AllowedTargets=9]="AllowedTargets",MetaInformationKind[MetaInformationKind.Examples=10]="Examples",MetaInformationKind[MetaInformationKind.XMLInfo=11]="XMLInfo",MetaInformationKind[MetaInformationKind.Default=12]="Default",MetaInformationKind[MetaInformationKind.Constraint=13]="Constraint",MetaInformationKind[MetaInformationKind.Modifier=14]="Modifier",MetaInformationKind[MetaInformationKind.Discriminator=15]="Discriminator",MetaInformationKind[MetaInformationKind.DiscriminatorValue=16]="DiscriminatorValue"}(exports.MetaInformationKind||(exports.MetaInformationKind={}));exports.MetaInformationKind},function(module,exports,__webpack_require__){"use strict";function parseJSON(name,n,r,provider){return void 0===r&&(r=ts.builtInRegistry()),parse(name,new JSObjectNode(null,n,(!1),provider),r)}function parseJSONTypeCollection(n,r,provider){return void 0===r&&(r=ts.builtInRegistry()),parseTypeCollection(new JSObjectNode(null,n,(!1),provider),r)}function endsWithQuestionMark(p){return"?"==p.charAt(p.length-1)}function parseTypes(n,tr){void 0===tr&&(tr=ts.builtInRegistry());var provider=n.provider&&n.provider();return parseTypeCollection(new JSObjectNode(null,n,(!1),provider),tr)}function transformToArray(n){return new WrapArrayNode(n)}function parseTypeCollection(n,tr){var result=new TypeCollection;if(n.anchor){if(n.anchor().__$$)return n.anchor().__$$;n.anchor().__$$=result}var uses=n.childWithKey("uses");uses&&uses.kind()===NodeKind.ARRAY&&(uses=transformToArray(uses)),uses&&uses.kind()===NodeKind.MAP&&uses.children().forEach(function(c){result.addLibrary(c.key(),parseTypeCollection(c,tr))});var tpes=n.childWithKey("types");tpes&&tpes.kind()===NodeKind.ARRAY&&(tpes=transformToArray(tpes));var schemas=n.childWithKey("schemas");schemas&&schemas.kind()===NodeKind.ARRAY&&(schemas=transformToArray(schemas));var reg=new AccumulatingRegistry(tpes,schemas,tr,result);tpes&&tpes.kind()!==NodeKind.SCALAR&&tpes.children().forEach(function(x){reg.get(x.key())}),schemas&&schemas.kind()!==NodeKind.SCALAR&&schemas.children().forEach(function(x){reg.get(x.key())}),reg.types().forEach(function(x){return result.add(x)});var tpes=n.childWithKey("annotationTypes");return tpes&&tpes.kind()===NodeKind.ARRAY&&(tpes=transformToArray(tpes)),null!=tpes&&tpes.kind()===NodeKind.MAP&&tpes.children().forEach(function(x){result.addAnnotationType(parse(x.key(),x,reg,!1,!0,!1))}),result}function parsePropertyBean(n,tr){var result=new PropertyBean,hasRequiredFacet=!1,rs=n.childWithKey("required");if(rs){var rsValue=rs.value();"boolean"==typeof rsValue&&(hasRequiredFacet=!0),rsValue===!1&&(result.optional=!0,result.id=n.key())}var name=n.key();return!hasRequiredFacet&&endsWithQuestionMark(n.key())&&(name=name.substr(0,name.length-1),result.optional=!0),0==name.length||"/.*/"===name?result.additonal=!0:"/"==name.charAt(0)&&"/"==name.charAt(name.length-1)&&(name=name.substring(1,name.length-1),result.regExp=!0),result.type=parse(null,n,tr,!1,!1,!1),result.id=name,result}function toProto(type){var result=new TypeProto;result.name=type.name(),result.superTypes=type.superTypes().map(function(x){return typeToSignature(x)}),result.annotations=[],result.customFacets=[],result.facetDeclarations=[],result.basicFacets=[],result.properties=[];var pmap={};return type.declaredMeta().forEach(function(x){if(x instanceof meta.Annotation)result.annotations.push(x);else if(x instanceof meta.CustomFacet)result.customFacets.push(x);else if(x instanceof meta.NotScalar)result.notAScalar=!0;else if(x instanceof metainfo_1.FacetDeclaration)result.facetDeclarations.push(x);else if(x instanceof rs.HasProperty)if(pmap.hasOwnProperty(x.value()))pmap[x.value()].optional=!1;else{var pbean=new PropertyBean;pbean.optional=!1,pbean.id=x.value(),pbean.type=ts.ANY,pmap[x.value()]=pbean}else if(x instanceof rs.AdditionalPropertyIs){var pbean=new PropertyBean;pbean.optional=!1,pbean.id="/.*/",pbean.additonal=!0,pbean.type=x.value(),pmap["/.*/"]=pbean}else if(x instanceof rs.MapPropertyIs){var pbean=new PropertyBean;pbean.optional=!1,pbean.id=x.regexpValue(),pbean.regExp=!0,pbean.type=x.value(),pmap[x.regexpValue()]=pbean}else if(x instanceof rs.PropertyIs)if(pmap.hasOwnProperty(x.propertyName()))pmap[x.propertyName()].type=x.value();else{var pbean=new PropertyBean;pbean.optional=!0,pbean.id=x.propertyName(),pbean.type=x.value(),pmap[x.propertyName()]=pbean}else x instanceof rs.KnownPropertyRestriction?result.additionalProperties=x.value():result.basicFacets.push(x)}),Object.keys(pmap).forEach(function(x){return result.properties.push(pmap[x])}),result}function storeAsJSON(ts){return ts instanceof typesystem_1.AbstractType?toProto(ts).toJSON():storeTypeCollection(ts)}function storeTypeCollection(tc){var res={},types={};tc.types().forEach(function(x){types[x.name()]=storeAsJSON(x)}),Object.keys(types).length>0&&(res.types=types);var types={};return tc.annotationTypes().forEach(function(x){types[x.name()]=storeAsJSON(x)}),Object.keys(types).length>0&&(res.annotationTypes=types),res}function typeToSignature(t){if(t.isAnonymous()){if(t.isArray()){var ci=t.oneMeta(rs.ComponentShouldBeOfType);if(ci){var vl=ci.value();return vl.isAnonymous()&&vl.isUnion()?"("+typeToSignature(vl)+")[]":typeToSignature(vl)+"[]"}}return t.isUnion()?t.options().map(function(x){return typeToSignature(x)}).join(" | "):t.superTypes().map(function(x){return typeToSignature(x)}).join(" , ")}return t.name()}function parse(name,n,r,defaultsToAny,annotation,global,ignoreTypeAttr){void 0===r&&(r=ts.builtInRegistry()),void 0===defaultsToAny&&(defaultsToAny=!1),void 0===annotation&&(annotation=!1),void 0===global&&(global=!0),void 0===ignoreTypeAttr&&(ignoreTypeAttr=!1);var provider=n.contentProvider?n.contentProvider():null;if(n.kind()==NodeKind.SCALAR){var sp,valString=n.value();if(sp=null==valString||"Null"==valString||"NULL"==valString?ts.STRING:typeExpressions.parseToType(""+valString,r,provider),null==name)return sp;var res=ts.derive(name,[sp]);return r instanceof AccumulatingRegistry&&(r.addType(res),res.putExtra(tsInterfaces.TOP_LEVEL_EXTRA,!0)),res}if(n.kind()==NodeKind.ARRAY){var supers=[];n.children().forEach(function(x){supers.push(typeExpressions.parseToType(""+x.value(),r,provider))});var res=ts.derive(name,supers);return r instanceof AccumulatingRegistry&&(r.addType(res),res.putExtra(tsInterfaces.TOP_LEVEL_EXTRA,!0)),res}var superTypes=[],tp=n.childWithKey("type"),shAndType=!1;if(tp?n.childWithKey("schema")&&(shAndType=!0):tp=n.childWithKey("schema"),!tp||ignoreTypeAttr)superTypes=defaultsToAny?n.childWithKey("properties")?[ts.OBJECT]:[ts.ANY]:n.childWithKey("properties")?[ts.OBJECT]:[ts.STRING];else if(tp.kind()==NodeKind.SCALAR){var valString=tp.value();superTypes=null==valString||"Null"==valString||"NULL"==valString?[ts.STRING]:[typeExpressions.parseToType(""+valString,r,provider)]}else tp.kind()==NodeKind.ARRAY?superTypes=tp.children().map(function(x){return x.value()}).map(function(y){return typeExpressions.parseToType(""+y,r,provider)}):tp.kind()==NodeKind.MAP&&(superTypes=[parse("",tp,r,!1,!1,!1)]);var result=ts.derive(name,superTypes),actualResult=result;r instanceof AccumulatingRegistry&&(r.addType(actualResult),actualResult.putExtra(tsInterfaces.TOP_LEVEL_EXTRA,!0));var hasfacetsOrOtherStuffDoesNotAllowedInExternals=null;if(n.children().forEach(function(x){var key=x.key();if(key&&"type"!==key&&"uses"!==key&&"schema"!==key&&("properties"!=key&&"additionalProperties"!=key||!result.isSubTypeOf(ts.OBJECT))){if("items"==key&&result.isSubTypeOf(ts.ARRAY)){var tp=parse(null,x,r,!1,!1,!1);return actualResult.addMeta(new restrictions_1.ComponentShouldBeOfType(tp)),void actualResult.putExtra(tsInterfaces.HAS_ITEMS,!0)}if("facets"===key)return void(hasfacetsOrOtherStuffDoesNotAllowedInExternals=key);if("default"!=key&&"xml"!=key&&"required"!=key||(hasfacetsOrOtherStuffDoesNotAllowedInExternals=key),"("==key.charAt(0)&&")"==key.charAt(key.length-1))return void result.addMeta(new meta.Annotation(key.substr(1,key.length-2),x.value()));var vl=facetR.getInstance().buildFacet(key,x.value());if(vl)vl.setNode(x),result.addMeta(vl);else if(annotation&&"allowedTargets"===key)result.addMeta(new meta.AllowedTargets(x.value()));else{var customFacet=new meta.CustomFacet(key,x.value());customFacet.setNode(x),result.addMeta(customFacet)}}}),result.isSubTypeOf(ts.OBJECT)){var props=n.childWithKey("properties"),hasProps=!1;if(props)if(props.kind()==NodeKind.MAP)props.children().forEach(function(x){hasProps=!0,parsePropertyBean(x,r).add(result)});else{var err=new ts.Status(ts.Status.ERROR,2,"properties should be a map",actualResult);err.setValidationPath({name:"properties"}),result.putExtra(tsInterfaces.PARSE_ERROR,err)}var ap=n.childWithKey("additionalProperties");ap&&result.addMeta(new restrictions_2.KnownPropertyRestriction(ap.value()))}var props=n.childWithKey("facets");if(props)if(props.kind()==NodeKind.MAP)props.children().forEach(function(x){var bean=parsePropertyBean(x,r);result.addMeta(new meta.FacetDeclaration(bean.id,bean.type,bean.optional))});else{var err=new ts.Status(ts.Status.ERROR,2,"facets should be a map",actualResult);err.setValidationPath({name:"facets"}),result.putExtra(tsInterfaces.PARSE_ERROR,err)}return result.isAnonymous()&&result.isEmpty()&&1==result.superTypes().length?result.superTypes()[0]:(n.kind()!=NodeKind.SCALAR&&result.addMeta(new meta.NotScalar),shAndType&&actualResult.putExtra(ts.SCHEMA_AND_TYPE,!0),actualResult.putExtra(ts.GLOBAL,global),actualResult.putExtra(ts.SOURCE_EXTRA,n),actualResult.putExtra(tsInterfaces.HAS_FACETS,hasfacetsOrOtherStuffDoesNotAllowedInExternals),actualResult)}var __extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},ts=__webpack_require__(103),tsInterfaces=__webpack_require__(104),rs=__webpack_require__(107),typesystem_1=__webpack_require__(103),typeExpressions=__webpack_require__(141),facetR=__webpack_require__(106),meta=__webpack_require__(108),metainfo_1=__webpack_require__(108),typesystem_2=__webpack_require__(103),restrictions_1=__webpack_require__(107),restrictions_2=__webpack_require__(107);!function(NodeKind){NodeKind[NodeKind.SCALAR=0]="SCALAR",NodeKind[NodeKind.ARRAY=1]="ARRAY",NodeKind[NodeKind.MAP=2]="MAP"}(exports.NodeKind||(exports.NodeKind={}));var NodeKind=exports.NodeKind,JSObjectNode=function(){function JSObjectNode(_key,obj,inArr,provider){void 0===inArr&&(inArr=!1),this._key=_key,this.obj=obj,this.inArr=inArr,this.provider=provider}return JSObjectNode.prototype.value=function(){return this.obj},JSObjectNode.prototype.key=function(){if(!this._key&&this.kind()===NodeKind.MAP&&this.inArr){var l=Object.keys(this.obj);if(1===l.length)return l[0]}return this._key},JSObjectNode.prototype.childWithKey=function(k){return null==this.obj?null:this.obj.hasOwnProperty(k)?new JSObjectNode(k,this.obj[k],(!1),this.contentProvider()):null},JSObjectNode.prototype.children=function(){var _this=this;return Array.isArray(this.obj)?this.obj.map(function(x){return new JSObjectNode(null,x,(!0),_this.contentProvider())}):this.obj&&"object"==typeof this.obj?Object.keys(this.obj).map(function(x){return new JSObjectNode(x,_this.obj[x],(!1),_this.provider)}):[]},JSObjectNode.prototype.kind=function(){return this.obj?Array.isArray(this.obj)?NodeKind.ARRAY:"object"==typeof this.obj?NodeKind.MAP:NodeKind.SCALAR:NodeKind.SCALAR},JSObjectNode.prototype.contentProvider=function(){return this.provider},JSObjectNode}();exports.parseJSON=parseJSON,exports.parseJSONTypeCollection=parseJSONTypeCollection;var PropertyBean=function(){function PropertyBean(){}return PropertyBean.prototype.add=function(t){this.optional||this.additonal||this.regExp||this.type.isSubTypeOf(ts.NIL)||t.addMeta(new rs.HasProperty(this.id));var matchesPropertyFacet;matchesPropertyFacet=this.additonal?new rs.AdditionalPropertyIs(this.type):this.regExp?new rs.MapPropertyIs(this.id,this.type):new rs.PropertyIs(this.id,this.type,this.optional),null!=matchesPropertyFacet&&(t.addMeta(matchesPropertyFacet),this.type instanceof ts.InheritedType&&null==this.type.name()&&this.type.setContextMeta(matchesPropertyFacet))},PropertyBean}();exports.PropertyBean=PropertyBean;var TypeCollection=function(){function TypeCollection(){this._types=[],this._typeMap={},this.uses={},this._annotationTypes=[],this._annotationTypeMap={}}return TypeCollection.prototype.library=function(n){return this.uses[n]},TypeCollection.prototype.addLibrary=function(n,t){this.uses[n]=t},TypeCollection.prototype.add=function(t){this._types.push(t),this._typeMap[t.name()]=t},TypeCollection.prototype.getType=function(name){return this._typeMap.hasOwnProperty(name)?this._typeMap[name]:null},TypeCollection.prototype.addAnnotationType=function(t){this._annotationTypes.push(t),this._annotationTypeMap[t.name()]=t},TypeCollection.prototype.getAnnotationType=function(name){return this._annotationTypeMap.hasOwnProperty(name)?this._annotationTypeMap[name]:null},TypeCollection.prototype.types=function(){return this._types},TypeCollection.prototype.annotationTypes=function(){return this._annotationTypes},TypeCollection.prototype.getAnnotationTypeRegistry=function(){var _this=this,r=new typesystem_2.TypeRegistry(ts.builtInRegistry());return this.annotationTypes().forEach(function(x){return r.addType(x)}),Object.keys(this.uses).forEach(function(x){_this.uses[x].annotationTypes().forEach(function(y){return r.put(x+"."+y.name(),y)})}),r},TypeCollection.prototype.getTypeRegistry=function(){var _this=this,r=new typesystem_2.TypeRegistry(ts.builtInRegistry());return this.types().forEach(function(x){return r.addType(x)}),Object.keys(this.uses).forEach(function(x){_this.uses[x].types().forEach(function(y){return r.put(x+"."+y.name(),y)})}),r},TypeCollection}();exports.TypeCollection=TypeCollection;var AccumulatingRegistry=function(_super){function AccumulatingRegistry(toParse,schemas,ts,_c){_super.call(this,ts),this.toParse=toParse,this.schemas=schemas,this._c=_c,this.parsing={}}return __extends(AccumulatingRegistry,_super),AccumulatingRegistry.prototype.get=function(name){var result=_super.prototype.get.call(this,name);if(!result){var chld=this.toParse?this.toParse.childWithKey(name):null;if(chld||(chld=this.schemas?this.schemas.childWithKey(name):null),chld){if(this.parsing[name])return ts.derive(name,[ts.RECURRENT]);this.parsing[name]=!0;try{var tp=parse(name,chld,this)}finally{delete this.parsing[name]}return tp}var dt=name.indexOf(".");if(dt!=-1){var ln=name.substring(0,dt),tn=name.substr(dt+1),lib=this._c.library(ln);if(lib){var t=lib.getType(tn);if(t)return t}}}return result},AccumulatingRegistry}(ts.TypeRegistry);exports.AccumulatingRegistry=AccumulatingRegistry,exports.parseTypes=parseTypes;var WrapArrayNode=function(){function WrapArrayNode(n){this.n=n}return WrapArrayNode.prototype.key=function(){return null},WrapArrayNode.prototype.value=function(){return null},WrapArrayNode.prototype.childWithKey=function(k){for(var r=this.children(),i=0;i<r.length;i++)if(r[i].key()==k)return r[i];return null},WrapArrayNode.prototype.children=function(){return this.n.children().map(function(x){var c=x.children();return 1==c.length?c[0]:x})},WrapArrayNode.prototype.kind=function(){return NodeKind.MAP},WrapArrayNode}();exports.parseTypeCollection=parseTypeCollection,exports.parsePropertyBean=parsePropertyBean;var TypeProto=function(){function TypeProto(){}return TypeProto.prototype.toJSON=function(){var result={};if(this.superTypes&&this.superTypes.length>0&&(1==this.superTypes.length?result.type=this.superTypes[0]:result.type=this.superTypes),this.customFacets&&this.customFacets.forEach(function(x){return result[x.facetName()]=x.value()}),this.annotations&&this.annotations.forEach(function(x){return result["("+x.facetName()+")"]=x.value()}),this.facetDeclarations&&this.facetDeclarations.length>0){var facets={};this.facetDeclarations.forEach(function(x){var nm=x.facetName();x.isOptional()&&(nm+="?");var vl=null;vl=x.type().isAnonymous()?x.type().isEmpty()?typeToSignature(x.type()):toProto(x.type()).toJSON():typeToSignature(x.type()),facets[nm]=vl}),result.facets=facets}if(this.properties&&this.properties.length>0){var properties={};this.properties.forEach(function(x){var nm=x.id;x.optional&&(nm+="?"),x.additonal&&(nm="/.*/"),x.regExp&&(nm="/"+nm+"/");var vl=null;vl=x.type.isAnonymous()?x.type.isEmpty()?typeToSignature(x.type):toProto(x.type).toJSON():typeToSignature(x.type),properties[nm]=vl}),result.properties=properties}return this.basicFacets&&this.basicFacets.forEach(function(x){result[x.facetName()]=x.value()}),1==Object.keys(result).length&&!this.notAScalar&&result.type?result.type:(void 0!==this.additionalProperties&&(result.additionalProperties=this.additionalProperties),result)},TypeProto}();exports.TypeProto=TypeProto,exports.toProto=toProto,exports.storeAsJSON=storeAsJSON,exports.parse=parse},function(module,exports,__webpack_require__){"use strict";function getInstance(){return instance?instance:instance=new Registry}var ts=__webpack_require__(103),ms=__webpack_require__(108),typesystem_1=__webpack_require__(103),restrictions_1=__webpack_require__(107),metainfo_1=__webpack_require__(108),metainfo_2=__webpack_require__(108),metainfo_3=__webpack_require__(108),metainfo_4=__webpack_require__(108),restrictions_2=__webpack_require__(107),FacetPrototype=function(){function FacetPrototype(_construct,_constructWithValue){this._construct=_construct,this._constructWithValue=_constructWithValue}return FacetPrototype.prototype.isSimple=function(){return null!=this._constructWithValue},FacetPrototype.prototype.newInstance=function(){return this._construct()},FacetPrototype.prototype.createWithValue=function(v){return this._constructWithValue(v)},FacetPrototype.prototype.isApplicable=function(t){return t.isSubTypeOf(this.newInstance().requiredType())},FacetPrototype.prototype.isInheritable=function(){return this.newInstance().isInheritable()},FacetPrototype.prototype.isConstraint=function(){return this.newInstance()instanceof ts.Constraint},FacetPrototype.prototype.isMeta=function(){return!this.isConstraint()},FacetPrototype.prototype.name=function(){return this.newInstance().facetName()},FacetPrototype}();exports.FacetPrototype=FacetPrototype;var Registry=function(){function Registry(){var _this=this;this.constraints=[new FacetPrototype(function(){return new restrictions_1.MinProperties(1)},function(x){return new restrictions_1.MinProperties(x)}),new FacetPrototype(function(){return new restrictions_1.MaxProperties(1)},function(x){return new restrictions_1.MaxProperties(x)}),new FacetPrototype(function(){return new restrictions_1.MinItems(1)},function(x){return new restrictions_1.MinItems(x)}),new FacetPrototype(function(){return new restrictions_1.MaxItems(1)},function(x){return new restrictions_1.MaxItems(x)}),new FacetPrototype(function(){return new restrictions_1.MinLength(1)},function(x){return new restrictions_1.MinLength(x)}),new FacetPrototype(function(){return new restrictions_1.MaxLength(1)},function(x){return new restrictions_1.MaxLength(x)}),new FacetPrototype(function(){return new restrictions_1.Minimum(1)},function(x){return new restrictions_1.Minimum(x)}),new FacetPrototype(function(){return new restrictions_2.MultipleOf(1)},function(x){return new restrictions_2.MultipleOf(x)}),new FacetPrototype(function(){return new restrictions_1.Maximum(1)},function(x){return new restrictions_1.Maximum(x)}),new FacetPrototype(function(){return new restrictions_1.Enum([""])},function(x){return new restrictions_1.Enum(x)}),new FacetPrototype(function(){return new restrictions_1.Pattern(".")},function(x){return new restrictions_1.Pattern(x)}),new FacetPrototype(function(){return new restrictions_1.PropertyIs("x",ts.ANY)},null),new FacetPrototype(function(){return new restrictions_1.AdditionalPropertyIs(ts.ANY)},null),new FacetPrototype(function(){return new restrictions_1.MapPropertyIs(".",ts.ANY)},null),new FacetPrototype(function(){return new restrictions_1.HasProperty("x")},null),new FacetPrototype(function(){return new restrictions_1.UniqueItems((!0))},function(x){return new restrictions_1.UniqueItems(x)}),new FacetPrototype(function(){return new restrictions_1.ComponentShouldBeOfType(ts.ANY)},null),new FacetPrototype(function(){return new restrictions_1.KnownPropertyRestriction((!1))},function(x){return new restrictions_1.KnownPropertyRestriction(x)})],this.meta=[new FacetPrototype(function(){return new ms.Discriminator("kind")},function(x){return new ms.Discriminator(x)}),new FacetPrototype(function(){return new ms.DiscriminatorValue("x")},function(x){return new ms.DiscriminatorValue(x)}),new FacetPrototype(function(){return new metainfo_1.Default("")},function(x){return new metainfo_1.Default(x)}),new FacetPrototype(function(){return new metainfo_4.Usage("")},function(x){return new metainfo_4.Usage(x)}),new FacetPrototype(function(){return new metainfo_1.Example("")},function(x){return new metainfo_1.Example(x)}),new FacetPrototype(function(){return new metainfo_3.Required((!0))},function(x){return new metainfo_3.Required(x)}),new FacetPrototype(function(){return new ms.Examples({})},function(x){return new ms.Examples(x)}),new FacetPrototype(function(){return new metainfo_1.Description("")},function(x){return new metainfo_1.Description(x)}),new FacetPrototype(function(){return new metainfo_1.DisplayName("")},function(x){return new metainfo_1.DisplayName(x)}),new FacetPrototype(function(){return new typesystem_1.Abstract},function(x){return new typesystem_1.Abstract}),new FacetPrototype(function(){return new typesystem_1.Polymorphic},function(x){return new typesystem_1.Polymorphic}),new FacetPrototype(function(){return new metainfo_2.XMLInfo({})},function(x){return new metainfo_2.XMLInfo(x)})],this.known={},this.allPrototypes().forEach(function(x){return _this.known[x.name()]=x})}return Registry.prototype.allPrototypes=function(){return this.meta.concat(this.constraints)},Registry.prototype.buildFacet=function(n,value){return this.known.hasOwnProperty(n)&&this.known[n].isSimple()?this.known[n].createWithValue(value):null},Registry.prototype.facetPrototypeWithName=function(n){return this.known.hasOwnProperty(n)?this.known[n]:null},Registry.prototype.applyableTo=function(t){return this.allPrototypes().filter(function(x){return x.isApplicable(t)})},Registry.prototype.allMeta=function(){return this.allPrototypes().filter(function(x){return x.isMeta()})},Registry}();exports.Registry=Registry;var instance;exports.getInstance=getInstance},function(module,exports,__webpack_require__){"use strict";function is_int(value){return parseFloat(value)==parseInt(value)&&!isNaN(value)}function optimize(r){r=r.map(function(x){return x.preoptimize()});var optimized=[];r.forEach(function(x){if(x instanceof typesystem_1.AndRestriction){var ar=x;ar.options().forEach(function(y){optimized.push(y)})}else optimized.push(x)});for(var transformed=!0;transformed;){transformed=!1;for(var i=0;i<optimized.length;i++){for(var j=0;j<optimized.length;j++){var rs0=optimized[i],rs1=optimized[j];if(rs0!==rs1){var compose=rs0.tryCompose(rs1);if(compose){var newOptimized=optimized.filter(function(x){return x!==rs0&&x!==rs1});newOptimized.push(compose),transformed=!0,optimized=newOptimized;break}}}if(transformed)break}}return optimized}var __extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},ts=__webpack_require__(103),su=__webpack_require__(113),_=__webpack_require__(182),typesystem_1=__webpack_require__(103),typesystem_2=__webpack_require__(103),MatchesProperty=function(_super){function MatchesProperty(_type){_super.call(this),this._type=_type}return __extends(MatchesProperty,_super),MatchesProperty.prototype.matches=function(s){return!1},MatchesProperty.prototype.check=function(i,p){throw new Error("Should be never called")},MatchesProperty.prototype.patchPath=function(p){if(p){for(var c=p,r=null,cp=null;c;)if(r){var news={name:c.name};cp.child=news,c=c.child,cp=news}else r={name:c.name},cp=r;return r.child={name:this.propId()},r}return{name:this.propId()}},MatchesProperty.prototype.validateProp=function(i,n,t,q){var vl=i[n],st=t.validate(vl,!1,!1);if(!st.isOk()){if(t.isUnknown()||t.isRecurrent()){var s=new typesystem_2.Status(typesystem_2.Status.ERROR,0,"Validating instance against unknown type:"+t.name(),this);return s.setValidationPath(this.patchPath(q)),s}var s=new typesystem_2.Status(typesystem_2.Status.OK,0,"",this);return st.getErrors().forEach(function(x){return s.addSubStatus(x)}),s.setValidationPath(this.patchPath(q)),s}return ts.ok()},MatchesProperty.prototype.validateSelf=function(registry){if(this._type.isExternal()){var p=new typesystem_2.Status(typesystem_2.Status.ERROR,0,"It is not allowed to use external types in property definitions",this);return p.setValidationPath({name:this.propId()}),p}if(this._type.isSubTypeOf(ts.UNKNOWN)||this._type.isSubTypeOf(ts.RECURRENT)){var p=new typesystem_2.Status(typesystem_2.Status.ERROR,0,"property "+this.propId()+" refers to unknown type "+this._type.name(),this);return p.setValidationPath({name:this.propId(),child:{name:"type"}}),p}if(this._type.isAnonymous()){var st=this._type.validateType(registry);if(!st.isOk()){var p=new typesystem_2.Status(typesystem_2.Status.ERROR,0,"property "+this.propId()+" range type has error:"+st.getMessage(),this);return st.getErrors().forEach(function(y){p.addSubStatus(y)}),p.setValidationPath({name:this.propId()}),p}return st}if(this._type.isUnion()){var ui=_.find(this._type.typeFamily(),function(x){return x.isSubTypeOf(ts.UNKNOWN)});if(ui){var p=new typesystem_2.Status(typesystem_2.Status.ERROR,0,"property "+this.propId()+" refers to unknown type "+ui.name(),this);return p.setValidationPath({name:this.propId()}),p}}return ts.ok()},MatchesProperty}(ts.Constraint);exports.MatchesProperty=MatchesProperty;var MatchToSchema=function(_super){function MatchToSchema(_value,provider){_super.call(this),this._value=_value,this.provider=provider}return __extends(MatchToSchema,_super),MatchToSchema.prototype.value=function(){return this._value},MatchToSchema.prototype.check=function(i){var so=null,strVal=this.value();if("{"==strVal.charAt(0))try{so=su.getJSONSchema(strVal,this.provider)}catch(e){return new ts.Status(ts.Status.ERROR,0,"Incorrect schema :"+e.message,this)}if("<"==strVal.charAt(0))try{so=su.getXMLSchema(strVal,this.provider)}catch(e){return ts.ok()}if(so)try{so.validateObject(i)}catch(e){return"!_PERF_!"==e.message?new ts.Status(ts.Status.WARNING,0,"Unable to validate example against schema (xmllint)",this):"Cannot assign to read only property '__$validated' of object"==e.message?ts.ok():"Object.keys called on non-object"==e.message?ts.ok():"Maximum call stack size exceeded"==e.message?new ts.Status(ts.Status.ERROR,0,"JSON schema contains circular references",this):new ts.Status(ts.Status.ERROR,0,"Example does not conform to schema:"+e.message,this)}return ts.ok()},MatchToSchema.prototype.facetName=function(){return"schema"},MatchToSchema.prototype.requiredType=function(){return ts.EXTERNAL},MatchToSchema}(ts.Constraint);exports.MatchToSchema=MatchToSchema;var KnownPropertyRestriction=function(_super){function KnownPropertyRestriction(_value){_super.call(this),this._value=_value}return __extends(KnownPropertyRestriction,_super),KnownPropertyRestriction.prototype.facetName=function(){return"closed"},KnownPropertyRestriction.prototype.requiredType=function(){return ts.OBJECT},KnownPropertyRestriction.prototype.value=function(){return this._value},KnownPropertyRestriction.prototype.patchOwner=function(t){this._owner=t},KnownPropertyRestriction.prototype.check=function(i){var _this=this;if(this._value===!1&&i&&"object"==typeof i&&!Array.isArray(i)){var nm={};Object.getOwnPropertyNames(i).forEach(function(n){return nm[n]=!0});var mp=this.owner().knownProperties();if(Object.getOwnPropertyNames(i).forEach(function(p){mp.forEach(function(v){v.matches(p)&&delete nm[p]})}),Object.keys(nm).length>0&&mp.length>0){var s=new ts.Status(ts.Status.OK,0,"",this);return Object.keys(nm).forEach(function(x){var err=ts.error("Unknown property:"+x,_this);err.setValidationPath({name:x}),s.addSubStatus(err)}),s}}return ts.ok()},KnownPropertyRestriction.prototype.composeWith=function(restriction){if(!this._value)return null;if(restriction instanceof KnownPropertyRestriction){var mm=restriction;if(_.isEqual(this.owner().propertySet(),mm.owner().propertySet()))return mm}if(restriction instanceof HasProperty){var ps=restriction,name=ps.value(),allowedPropertySet=this.owner().propertySet();if(allowedPropertySet.indexOf(name)==-1)return this.nothing(ps)}},KnownPropertyRestriction}(ts.Constraint);exports.KnownPropertyRestriction=KnownPropertyRestriction;var HasProperty=function(_super){function HasProperty(name){_super.call(this),this.name=name}return __extends(HasProperty,_super),HasProperty.prototype.check=function(i){return i&&"object"==typeof i&&!Array.isArray(i)?i.hasOwnProperty(this.name)?ts.ok():ts.error("Required property: "+this.name+" is missed",this):ts.ok()},HasProperty.prototype.requiredType=function(){return ts.OBJECT},HasProperty.prototype.facetName=function(){return"hasProperty"},HasProperty.prototype.value=function(){return this.name},HasProperty.prototype.composeWith=function(r){if(r instanceof HasProperty){var hp=r;if(hp.name===this.name)return this}return null},HasProperty}(ts.Constraint);exports.HasProperty=HasProperty;var PropertyIs=function(_super){function PropertyIs(name,type,optional){void 0===optional&&(optional=!1),_super.call(this,type),this.name=name,this.type=type,this.optional=optional}return __extends(PropertyIs,_super),PropertyIs.prototype.matches=function(s){return s===this.name},PropertyIs.prototype.path=function(){return this.name},PropertyIs.prototype.check=function(i,p){if(i&&"object"==typeof i&&i.hasOwnProperty(this.name)){var st=this.validateProp(i,this.name,this.type,p);return!st.isOk()&&this.optional&&null==i[this.name]?ts.ok():st}return ts.ok()},PropertyIs.prototype.requiredType=function(){return ts.OBJECT},PropertyIs.prototype.propId=function(){return this.name},PropertyIs.prototype.propertyName=function(){return this.name},PropertyIs.prototype.facetName=function(){return"propertyIs"},PropertyIs.prototype.value=function(){return this.type},PropertyIs.prototype.composeWith=function(t){if(t instanceof PropertyIs){var pi=t;if(pi.name===this.name){if(this.type.typeFamily().indexOf(pi.type)!=-1)return pi;if(pi.type.typeFamily().indexOf(this.type)!=-1)return this;var intersectionType=this.intersect(this.type,pi.type);try{var is=intersectionType.checkConfluent();if(!is.isOk()){var rc=is;return rc.toRestriction()}return new PropertyIs(this.name,intersectionType)}finally{this.release(intersectionType)}}}return null},PropertyIs}(MatchesProperty);exports.PropertyIs=PropertyIs;var MapPropertyIs=function(_super){function MapPropertyIs(regexp,type){_super.call(this,type),this.regexp=regexp,this.type=type}return __extends(MapPropertyIs,_super),MapPropertyIs.prototype.path=function(){return"/"+this.regexp+"/"},MapPropertyIs.prototype.matches=function(s){return!!s.match(this.regexp)},MapPropertyIs.prototype.requiredType=function(){return ts.OBJECT},MapPropertyIs.prototype.propId=function(){return"["+this.regexp+"]"},MapPropertyIs.prototype.facetName=function(){return"mapPropertyIs"},MapPropertyIs.prototype.value=function(){return this.type},MapPropertyIs.prototype.regexpValue=function(){return this.regexp},MapPropertyIs.prototype.validateSelf=function(t){
var m=this.checkValue();return m?new typesystem_2.Status(typesystem_2.Status.ERROR,0,m,this):_super.prototype.validateSelf.call(this,t)},MapPropertyIs.prototype.checkValue=function(){try{new RegExp(this.regexp)}catch(e){return e.message}return null},MapPropertyIs.prototype.composeWith=function(t){if(t instanceof MapPropertyIs){var pi=t;if(pi.regexp===this.regexp){if(this.type.typeFamily().indexOf(pi.type)!=-1)return pi;if(pi.type.typeFamily().indexOf(this.type)!=-1)return this;var intersectionType=this.intersect(this.type,pi.type);try{var is=intersectionType.checkConfluent();if(!is.isOk()){var rc=is;return rc.toRestriction()}return new MapPropertyIs(this.regexp,intersectionType)}finally{this.release(intersectionType)}}}return null},MapPropertyIs.prototype.check=function(i,p){var _this=this;if(i&&"object"==typeof i){var rs=new ts.Status(ts.Status.OK,0,"",this);return Object.getOwnPropertyNames(i).forEach(function(n){if(n.match(_this.regexp)){var stat=_this.validateProp(i,n,_this.type,p);stat.isOk()||rs.addSubStatus(stat)}}),rs}return ts.ok()},MapPropertyIs}(MatchesProperty);exports.MapPropertyIs=MapPropertyIs;var AdditionalPropertyIs=function(_super){function AdditionalPropertyIs(type){_super.call(this,type),this.type=type}return __extends(AdditionalPropertyIs,_super),AdditionalPropertyIs.prototype.path=function(){return this.facetName()},AdditionalPropertyIs.prototype.matches=function(s){return!0},AdditionalPropertyIs.prototype.requiredType=function(){return ts.OBJECT},AdditionalPropertyIs.prototype.propId=function(){return"[]"},AdditionalPropertyIs.prototype.facetName=function(){return"additionalProperties"},AdditionalPropertyIs.prototype.value=function(){return this.type},AdditionalPropertyIs.prototype.match=function(n){for(var all=this.owner().metaOfType(PropertyIs),map=this.owner().metaOfType(MapPropertyIs),i=0;i<all.length;i++)if(all[i].matches(n))return!0;for(var i=0;i<map.length;i++)if(map[i].matches(n))return!0;return!1},AdditionalPropertyIs.prototype.composeWith=function(t){if(t instanceof AdditionalPropertyIs){var pi=t;if(this.type.typeFamily().indexOf(pi.type)!=-1)return pi;if(pi.type.typeFamily().indexOf(this.type)!=-1)return this;var intersectionType=this.intersect(this.type,pi.type);try{var is=intersectionType.checkConfluent();if(!is.isOk()){var rc=is;return rc.toRestriction()}return new AdditionalPropertyIs(intersectionType)}finally{this.release(intersectionType)}}return null},AdditionalPropertyIs.prototype.check=function(i,p){var _this=this,t=this.type,res=new ts.Status(ts.Status.OK,0,"",this);return i&&"object"==typeof i&&Object.getOwnPropertyNames(i).forEach(function(n){if(!_this.match(n)){var stat=_this.validateProp(i,n,t,p);stat.isOk()||res.addSubStatus(stat)}}),res},AdditionalPropertyIs}(MatchesProperty);exports.AdditionalPropertyIs=AdditionalPropertyIs;var FacetRestriction=function(_super){function FacetRestriction(){_super.apply(this,arguments)}return __extends(FacetRestriction,_super),FacetRestriction.prototype.validateSelf=function(registry){var ownerIsCorrect=!1;if(this.requiredType().isUnion())for(var family=this.requiredType().typeFamily(),_i=0,family_1=family;_i<family_1.length;_i++){var tp=family_1[_i];if(this.owner().isSubTypeOf(tp)){ownerIsCorrect=!0;break}}else ownerIsCorrect=this.owner().isSubTypeOf(this.requiredType());if(!ownerIsCorrect){var rs=ts.error(this.facetName()+" facet can only be used with "+this.requiredType().name()+" types",this);return rs.setValidationPath({name:this.facetName()}),rs}var m=this.checkValue();if(m){var rs=ts.error(m,this,!0);return rs.setValidationPath({name:this.facetName()}),rs}return ts.ok()},FacetRestriction}(ts.Constraint);exports.FacetRestriction=FacetRestriction;var MinMaxRestriction=function(_super){function MinMaxRestriction(_facetName,_value,_max,_opposite,_requiredType,_isInt){_super.call(this),this._facetName=_facetName,this._value=_value,this._max=_max,this._opposite=_opposite,this._requiredType=_requiredType,this._isInt=_isInt}return __extends(MinMaxRestriction,_super),MinMaxRestriction.prototype.facetName=function(){return this._facetName},MinMaxRestriction.prototype.isIntConstraint=function(){return this._isInt},MinMaxRestriction.prototype.isMax=function(){return this._max},MinMaxRestriction.prototype.value=function(){return this._value},MinMaxRestriction.prototype.check=function(i){var o=this.extractValue(i);if("number"==typeof o)if(this.isMax()){if(this.value()<o)return this.createError()}else if(this.value()>o)return this.createError();return ts.ok()},MinMaxRestriction.prototype.createError=function(){return ts.error(this.toString(),this)},MinMaxRestriction.prototype.minValue=function(){return this._isInt?0:Number.NEGATIVE_INFINITY},MinMaxRestriction.prototype.requiredType=function(){return this._requiredType},MinMaxRestriction.prototype.checkValue=function(){return"number"!=typeof this._value?this.facetName()+" should be a number":this.isIntConstraint()&&!is_int(this.value())?this.facetName()+" should be a integer":this.value()<this.minValue()?this.facetName()+" should be at least "+this.minValue():void 0},MinMaxRestriction.prototype.composeWith=function(t){if(t instanceof MinMaxRestriction){var mx=t;if(mx.facetName()==this.facetName()&&mx.isMax()==this.isMax())return this.isMax()?this.value()<mx.value()?mx:this:this.value()>mx.value()?mx:this;if(mx.facetName()===this._opposite)if(this.isMax()){if(mx.value()>this.value())return this.nothing(t)}else if(mx.value()<this.value())return this.nothing(t)}return null},MinMaxRestriction.prototype.facetPath=function(){var arr=[this.facetName()],owner=this._owner;if(null!=owner&&owner instanceof ts.InheritedType){var it=owner;arr=ts.typePath(it).concat(arr)}return arr.join(".")},MinMaxRestriction.prototype.toString=function(){return"'"+this.facetPath()+"="+this.value()+"' i.e. "+this.textMessagePart()+" "+this.value()},MinMaxRestriction.prototype.conflictMessage=function(otherPath,otherValue){var arr=this.isMax()?["less","higher"]:["higher","less"];return"['"+this.facetPath()+"="+this.value()+"' is "+arr[0]+" than '"+otherPath+"="+otherValue+"'. The "+this._opposite+" cannot be "+arr[1]+" than the "+this.facetName()+".]"},MinMaxRestriction}(FacetRestriction);exports.MinMaxRestriction=MinMaxRestriction;var MultipleOf=function(_super){function MultipleOf(_value){_super.call(this),this._value=_value}return __extends(MultipleOf,_super),MultipleOf.prototype.value=function(){return this._value},MultipleOf.prototype.check=function(o){if("number"==typeof o){var q=o/this.value();if(!is_int(q))return new ts.Status(ts.Status.ERROR,0,"result of division of "+o+" on "+this.value()+" should be integer",this)}return ts.ok()},MultipleOf.prototype.composeWith=function(t){return null},MultipleOf.prototype.facetName=function(){return"multipleOf"},MultipleOf.prototype.checkValue=function(){return"number"!=typeof this._value?this.facetName()+" should be a number":null},MultipleOf.prototype.requiredType=function(){return ts.NUMBER},MultipleOf}(FacetRestriction);exports.MultipleOf=MultipleOf;var Maximum=function(_super){function Maximum(val){_super.call(this,"maximum",val,!0,"minimum",ts.NUMBER,!1)}return __extends(Maximum,_super),Maximum.prototype.extractValue=function(i){return i},Maximum.prototype.textMessagePart=function(){return"value should not be more than"},Maximum}(MinMaxRestriction);exports.Maximum=Maximum;var Minimum=function(_super){function Minimum(val){_super.call(this,"minimum",val,!1,"maximum",ts.NUMBER,!1)}return __extends(Minimum,_super),Minimum.prototype.extractValue=function(i){return i},Minimum.prototype.textMessagePart=function(){return"value should not be less than"},Minimum}(MinMaxRestriction);exports.Minimum=Minimum;var MaxItems=function(_super){function MaxItems(val){_super.call(this,"maxItems",val,!0,"minItems",ts.ARRAY,!0)}return __extends(MaxItems,_super),MaxItems.prototype.extractValue=function(i){if(Array.isArray(i))return i.length},MaxItems.prototype.textMessagePart=function(){return"array items count should not be more than"},MaxItems}(MinMaxRestriction);exports.MaxItems=MaxItems;var MinItems=function(_super){function MinItems(val){_super.call(this,"minItems",val,!1,"maxItems",ts.ARRAY,!0)}return __extends(MinItems,_super),MinItems.prototype.extractValue=function(i){if(Array.isArray(i))return i.length},MinItems.prototype.textMessagePart=function(){return"array items count should not be less than"},MinItems}(MinMaxRestriction);exports.MinItems=MinItems;var MaxLength=function(_super){function MaxLength(val){_super.call(this,"maxLength",val,!0,"minLength",new ts.UnionType("string and file",[ts.STRING,ts.FILE]),!0)}return __extends(MaxLength,_super),MaxLength.prototype.extractValue=function(i){return"string"==typeof i?i.length:0},MaxLength.prototype.textMessagePart=function(){return"string length should not be more than"},MaxLength}(MinMaxRestriction);exports.MaxLength=MaxLength;var MinLength=function(_super){function MinLength(val){_super.call(this,"minLength",val,!1,"maxLength",new ts.UnionType("string and file",[ts.STRING,ts.FILE]),!0)}return __extends(MinLength,_super),MinLength.prototype.extractValue=function(i){return"string"==typeof i?i.length:0},MinLength.prototype.textMessagePart=function(){return"string length should not be less than"},MinLength}(MinMaxRestriction);exports.MinLength=MinLength;var MaxProperties=function(_super){function MaxProperties(val){_super.call(this,"maxProperties",val,!0,"minProperties",ts.OBJECT,!0)}return __extends(MaxProperties,_super),MaxProperties.prototype.extractValue=function(i){return Object.keys(i).length},MaxProperties.prototype.textMessagePart=function(){return"object properties count should not be more than"},MaxProperties}(MinMaxRestriction);exports.MaxProperties=MaxProperties;var MinProperties=function(_super){function MinProperties(val){_super.call(this,"minProperties",val,!1,"maxProperties",ts.OBJECT,!0)}return __extends(MinProperties,_super),MinProperties.prototype.extractValue=function(i){return Object.keys(i).length},MinProperties.prototype.textMessagePart=function(){return"object properties count should not be less than"},MinProperties}(MinMaxRestriction);exports.MinProperties=MinProperties;var UniqueItems=function(_super){function UniqueItems(_value){_super.call(this),this._value=_value}return __extends(UniqueItems,_super),UniqueItems.prototype.facetName=function(){return"uniqueItems"},UniqueItems.prototype.requiredType=function(){return ts.ARRAY},UniqueItems.prototype.check=function(i){if(Array.isArray(i)){var r=i;if(_.unique(r).length!=r.length)return ts.error(this.toString(),this)}return ts.ok()},UniqueItems.prototype.composeWith=function(r){if(r instanceof UniqueItems){var mm=r;if(mm._value==this._value)return this}return null},UniqueItems.prototype.value=function(){return this._value},UniqueItems.prototype.checkValue=function(){return null},UniqueItems.prototype.toString=function(){return"items should be unique"},UniqueItems}(FacetRestriction);exports.UniqueItems=UniqueItems;var ComponentShouldBeOfType=function(_super){function ComponentShouldBeOfType(type){_super.call(this),this.type=type}return __extends(ComponentShouldBeOfType,_super),ComponentShouldBeOfType.prototype.facetName=function(){return"items"},ComponentShouldBeOfType.prototype.requiredType=function(){return ts.ARRAY},ComponentShouldBeOfType.prototype.toString=function(){return"items should be of type "+this.type},ComponentShouldBeOfType.prototype.check=function(i){var rs=new ts.Status(ts.Status.OK,0,"",this);if(Array.isArray(i))for(var ar=i,j=0;j<ar.length;j++){var ss=this.type.validate(ar[j],!1);if(!ss.isOk()){var t=this.type;if(t.isUnknown()||t.isRecurrent()){var s=new typesystem_2.Status(typesystem_2.Status.ERROR,0,"array instance is validated against unknown type:"+t.name(),this);return s}}ss.setValidationPath({name:""+j}),rs.addSubStatus(ss)}return rs},ComponentShouldBeOfType.prototype.validateSelf=function(registry){if(this.type.isAnonymous()){var st=this.type.validateType(registry);return st.isOk()?st:new typesystem_2.Status(typesystem_2.Status.ERROR,0,"component type has error:"+st.getMessage(),this)}if(this.type.isExternal()){var p=new typesystem_2.Status(typesystem_2.Status.ERROR,0,"It is not allowed to use external types in component type definitions",this);return p}if(this.type.isSubTypeOf(ts.UNKNOWN)||this.type.isSubTypeOf(ts.RECURRENT))return new typesystem_2.Status(typesystem_2.Status.ERROR,0,"component refers to unknown type "+this.type.name(),this);if(this.type.isUnion()){var ui=_.find(this.type.typeFamily(),function(x){return x.isSubTypeOf(ts.UNKNOWN)});if(ui)return new typesystem_2.Status(typesystem_2.Status.ERROR,0,"component refers to unknown type "+ui.name(),this)}return ts.ok()},ComponentShouldBeOfType.prototype.composeWith=function(t){if(t instanceof ComponentShouldBeOfType){var pi=t;if(this.type.typeFamily().indexOf(pi.type)!=-1)return pi;if(pi.type.typeFamily().indexOf(this.type)!=-1)return this;var intersectionType=this.intersect(this.type,pi.type);try{var is=intersectionType.checkConfluent();if(!is.isOk()){var rc=is;return rc.toRestriction()}return new ComponentShouldBeOfType(intersectionType)}finally{this.release(intersectionType)}}return null},ComponentShouldBeOfType.prototype.checkValue=function(){return null},ComponentShouldBeOfType.prototype.value=function(){return this.type},ComponentShouldBeOfType}(FacetRestriction);exports.ComponentShouldBeOfType=ComponentShouldBeOfType;var Pattern=function(_super){function Pattern(_value){_super.call(this),this._value=_value}return __extends(Pattern,_super),Pattern.prototype.facetName=function(){return"pattern"},Pattern.prototype.requiredType=function(){return ts.STRING},Pattern.prototype.check=function(i){if("string"==typeof i){var st=i;try{var matches=st.match(this._value),gotMatch=!1;if(matches)for(var _i=0,matches_1=matches;_i<matches_1.length;_i++){var m=matches_1[_i];if(m.length==st.length){gotMatch=!0;break}}if(!gotMatch)return new ts.Status(ts.Status.ERROR,0,"string should match to "+this.value(),this)}catch(e){}}return ts.ok()},Pattern.prototype.composeWith=function(r){if(r instanceof Pattern){var v=r;return v._value===this._value?this:this.nothing(r,"pattern restrictions can not be composed at one type")}return null},Pattern.prototype.value=function(){return this._value},Pattern.prototype.checkValue=function(){try{new RegExp(this._value)}catch(e){return e.message}return null},Pattern.prototype.toString=function(){return"should pass reg exp:"+this.value},Pattern}(FacetRestriction);exports.Pattern=Pattern;var Enum=function(_super){function Enum(_value){_super.call(this),this._value=_value}return __extends(Enum,_super),Enum.prototype.facetName=function(){return"enum"},Enum.prototype.requiredType=function(){return ts.SCALAR},Enum.prototype.check=function(i){if(!this.checkStatus){var opts=this.value();if(Array.isArray(opts)||(opts=[opts]),!opts.some(function(x){return x==i}))return ts.error(this.toString(),this)}return ts.ok()},Enum.prototype.composeWith=function(r){if(r instanceof Enum){var v=r,sss=_.intersection(this._value,v._value);return 0==sss.length?this.nothing(r):new Enum(sss)}return null},Enum.prototype.value=function(){return this._value},Enum.prototype.checkValue=function(){var _this=this;if(!this.owner().isSubTypeOf(this.requiredType()))return"enum facet can only be used with: "+this.requiredType().name();if(!Array.isArray(this._value))return"enum facet value must be defined by array";var result=null;this.checkStatus=!0;try{this._value.forEach(function(x){var res=_this.owner().validate(x);res.isOk()||(result=res.getMessage())})}finally{this.checkStatus=!1}return result},Enum.prototype.toString=function(){return"value should be one of:"+this._value},Enum}(FacetRestriction);exports.Enum=Enum,exports.optimize=optimize},function(module,exports,__webpack_require__){"use strict";function serializeToXml(value,type){return xmlio.serializeToXML(value,type)}function parseExampleIfNeeded(val,type){if("string"==typeof val&&(type.isObject()||type.isArray()||type.isExternal()||type.isUnion())){var exampleString=val,firstChar=exampleString.trim().charAt(0);if("{"==firstChar||"["==firstChar)try{return JSON.parse(exampleString)}catch(e){if(type.isObject()||type.isArray()){var c=new typesystem_1.Status(typesystem_1.Status.ERROR,0,"Can not parse JSON example:"+e.message,this);return c}}if("<"==firstChar)try{var jsonFromXml=xmlio.readObject(exampleString,type),errors=xmlio.getXmlErrors(jsonFromXml);if(errors){var error=new typesystem_1.Status(typesystem_1.Status.ERROR,0,"Invalid XML.",{});return errors.forEach(function(child){return error.addSubStatus(child)}),error}return jsonFromXml}catch(e){}}return type.getExtra(tsInterfaces.REPEAT)&&(val=[val]),val}function examplesPatchPath(example,noVal,x){noVal?example.setValidationPath({name:"examples",child:{name:x}}):example.setValidationPath({name:"examples",child:{name:x,child:{name:"value"}}})}var __extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},ts=__webpack_require__(103),typesystem_1=__webpack_require__(103),restrictions_1=__webpack_require__(107),_=__webpack_require__(182),xmlio=__webpack_require__(143),tsInterfaces=__webpack_require__(104),MetaInfo=function(_super){function MetaInfo(_name,_value,inhertitable){void 0===inhertitable&&(inhertitable=!1),_super.call(this,inhertitable),this._name=_name,this._value=_value}return __extends(MetaInfo,_super),MetaInfo.prototype.value=function(){return this._value},MetaInfo.prototype.requiredType=function(){return ts.ANY},MetaInfo.prototype.facetName=function(){return this._name},MetaInfo.prototype.kind=function(){return null},MetaInfo}(ts.TypeInformation);exports.MetaInfo=MetaInfo;var Description=function(_super){function Description(value){_super.call(this,"description",value)}return __extends(Description,_super),Description.prototype.kind=function(){return tsInterfaces.MetaInformationKind.Description},Description}(MetaInfo);exports.Description=Description;var NotScalar=function(_super){function NotScalar(){_super.call(this,"notScalar",!0)}return __extends(NotScalar,_super),NotScalar.prototype.kind=function(){return tsInterfaces.MetaInformationKind.NotScalar},NotScalar}(MetaInfo);exports.NotScalar=NotScalar;var DisplayName=function(_super){function DisplayName(value){_super.call(this,"displayName",value)}return __extends(DisplayName,_super),DisplayName.prototype.kind=function(){return tsInterfaces.MetaInformationKind.DisplayName},DisplayName}(MetaInfo);exports.DisplayName=DisplayName;var Usage=function(_super){function Usage(value){_super.call(this,"usage",value)}return __extends(Usage,_super),Usage.prototype.kind=function(){return tsInterfaces.MetaInformationKind.Usage},Usage}(MetaInfo);exports.Usage=Usage;var Annotation=function(_super){function Annotation(name,value){_super.call(this,name,value)}return __extends(Annotation,_super),Annotation.prototype.validateSelf=function(registry){var tp=registry.get(this.facetName());if(!tp)return new typesystem_1.Status(typesystem_1.Status.ERROR,0,"using unknown annotation type:"+this.facetName(),this);var q=this.value();q||tp.isString()&&(q="");var valOwner=tp.validateDirect(q,!0,!1);if(!valOwner.isOk()){var res=new typesystem_1.Status(typesystem_1.Status.OK,0,"invalid annotation value"+valOwner.getMessage(),this);return res.addSubStatus(valOwner),res}return ts.ok()},Annotation.prototype.kind=function(){return tsInterfaces.MetaInformationKind.Annotation},Annotation}(MetaInfo);exports.Annotation=Annotation;var FacetDeclaration=function(_super){function FacetDeclaration(name,_type,optional){_super.call(this,name,_type,!0),this.name=name,this._type=_type,this.optional=optional}return __extends(FacetDeclaration,_super),FacetDeclaration.prototype.actualName=function(){return"?"==this.name.charAt(this.name.length-1)?this.name.substr(0,this.name.length-1):this.name},FacetDeclaration.prototype.isOptional=function(){return this.optional},FacetDeclaration.prototype.type=function(){return this._type},FacetDeclaration.prototype.kind=function(){return tsInterfaces.MetaInformationKind.FacetDeclaration},FacetDeclaration}(MetaInfo);exports.FacetDeclaration=FacetDeclaration;var CustomFacet=function(_super){function CustomFacet(name,value){_super.call(this,name,value,!0)}return __extends(CustomFacet,_super),CustomFacet.prototype.kind=function(){return tsInterfaces.MetaInformationKind.CustomFacet},CustomFacet}(MetaInfo);exports.CustomFacet=CustomFacet;var Example=function(_super){function Example(value){_super.call(this,"example",value)}return __extends(Example,_super),Example.prototype.validateSelf=function(registry){var val=this.value(),isVal=!1;if("object"==typeof val&&val&&val.value){if(val.strict===!1)return ts.ok();if(val.strict&&"boolean"!=typeof val.strict){var s=new typesystem_1.Status(typesystem_1.Status.ERROR,0,"strict should be boolean",this);return s.setValidationPath({name:"example",child:{name:"strict"}}),s}val=val.value,isVal=!0}var rr=parseExampleIfNeeded(val,this.owner());if(rr instanceof ts.Status)return rr.setValidationPath({name:"example"}),rr;var valOwner=this.owner().validateDirect(rr,!0,!1);if(!valOwner.isOk()){"string"==typeof this.value();var c=new typesystem_1.Status(typesystem_1.Status.ERROR,0,"using invalid `example`:"+valOwner.getMessage(),this);return valOwner.getErrors().forEach(function(x){c.addSubStatus(x),isVal?x.setValidationPath({name:"example",child:{name:"value"}}):x.setValidationPath({name:"example"})}),c}return ts.ok()},Example.prototype.example=function(){var val=this.value();return"object"==typeof val&&val&&val.value&&(val=val.value),parseExampleIfNeeded(val,this.owner())},Example.prototype.asXMLString=function(){var value=this.value();if("string"==typeof value&&0===value.trim().indexOf("<"))return value;var parsedValue=parseExampleIfNeeded(value,this.owner());return serializeToXml(parsedValue,this.owner())},Example.prototype.kind=function(){return tsInterfaces.MetaInformationKind.Example},Example}(MetaInfo);exports.Example=Example;var Required=function(_super){function Required(value){_super.call(this,"required",value)}return __extends(Required,_super),Required.prototype.validateSelf=function(registry){return"boolean"!=typeof this.value()?new typesystem_1.Status(typesystem_1.Status.ERROR,0,"value of required facet should be boolean",this):ts.ok()},Required.prototype.kind=function(){return tsInterfaces.MetaInformationKind.Required},Required}(MetaInfo);exports.Required=Required;var AllowedTargets=function(_super){function AllowedTargets(value){_super.call(this,"allowedTargets",value)}return __extends(AllowedTargets,_super),AllowedTargets.prototype.validateSelf=function(registry){return ts.ok()},AllowedTargets.prototype.kind=function(){return tsInterfaces.MetaInformationKind.AllowedTargets},AllowedTargets}(MetaInfo);exports.AllowedTargets=AllowedTargets;var Examples=function(_super){function Examples(value){_super.call(this,"examples",value)}return __extends(Examples,_super),Examples.prototype.examples=function(){var _this=this,v=this.value(),result=[];return Object.keys(v).forEach(function(x){if("object"==typeof v[x]&&v[x]){var val=v[x].value;val||(val=v[x]);var example=parseExampleIfNeeded(val,_this.owner());result.push(example)}}),result},Examples.prototype.asXMLStrings=function(){var _this=this,value=this.value(),result={};return Object.keys(value).forEach(function(key){var childValue=value[key];if("string"==typeof childValue&&0===childValue.trim().indexOf("<"))return void(result[key]=childValue);var parsedValue=parseExampleIfNeeded(childValue,_this.owner());result[key]=serializeToXml(parsedValue,_this.owner())}),result},Examples.prototype.validateSelf=function(registry){var _this=this;if("object"==typeof this.value()){var rs=new typesystem_1.Status(typesystem_1.Status.OK,0,"",this),v=this.value();return v&&Object.keys(v).forEach(function(x){if(v[x]){var val=v[x].value,noVal=!val;if(noVal)val=v[x];else{if(v[x].strict===!1)return;if(v[x].strict&&"boolean"!=typeof v[x].strict){var s=new typesystem_1.Status(typesystem_1.Status.ERROR,0,"strict should be boolean",_this);return s.setValidationPath({name:x,child:{name:"strict",child:{name:"strict"}}}),s}}var example=parseExampleIfNeeded(val,_this.owner());if(example instanceof ts.Status)return examplesPatchPath(example,noVal,x),void rs.addSubStatus(example);var res=_this.owner().validateDirect(example,!0,!1);res.getErrors().forEach(function(ex){rs.addSubStatus(ex),examplesPatchPath(ex,noVal,x)}),"object"==typeof v[x]&&v[x].value&&Object.keys(v[x]).forEach(function(key){if("("==key.charAt(0)&&")"==key.charAt(key.length-1)){var a=new Annotation(key.substring(1,key.length-1),v[x][key]);rs.addSubStatus(a.validateSelf(registry))}})}}),rs}return new typesystem_1.Status(typesystem_1.Status.ERROR,0,"examples should be a map",this)},Examples.prototype.kind=function(){return tsInterfaces.MetaInformationKind.Examples},Examples}(MetaInfo);exports.Examples=Examples;var XMLInfo=function(_super){function XMLInfo(o){_super.call(this,"xml",o)}return __extends(XMLInfo,_super),XMLInfo.prototype.kind=function(){return tsInterfaces.MetaInformationKind.XMLInfo},XMLInfo}(MetaInfo);exports.XMLInfo=XMLInfo;var Default=function(_super){function Default(value){_super.call(this,"default",value)}return __extends(Default,_super),Default.prototype.validateSelf=function(registry){var valOwner=this.owner().validateDirect(this.value(),!0);return valOwner.isOk()?ts.ok():new typesystem_1.Status(typesystem_1.Status.ERROR,0,"using invalid `defaultValue`:"+valOwner.getMessage(),this)},Default.prototype.kind=function(){return tsInterfaces.MetaInformationKind.Default},Default}(MetaInfo);exports.Default=Default;var Discriminator=function(_super){function Discriminator(property){_super.call(this,!0),this.property=property}return __extends(Discriminator,_super),Discriminator.prototype.requiredType=function(){return ts.OBJECT},Discriminator.prototype.value=function(){return this.property},Discriminator.prototype.facetName=function(){return"discriminator"},Discriminator.prototype.validateSelf=function(registry){var _this=this;if(!this.owner().isSubTypeOf(ts.OBJECT))return new typesystem_1.Status(typesystem_1.Status.ERROR,0,"you only can use `discriminator` with object types",this);if(this.owner().getExtra(ts.GLOBAL)===!1)return new typesystem_1.Status(typesystem_1.Status.ERROR,0,"you only can use `discriminator` with top level type definitions",this);var prop=_.find(this.owner().meta(),function(x){return x instanceof restrictions_1.PropertyIs&&x.propertyName()==_this.value()});return prop?prop.value().isScalar()?ts.ok():new typesystem_1.Status(typesystem_1.Status.ERROR,0,"It is only allowed to use scalar properties as discriminators",this):new typesystem_1.Status(typesystem_1.Status.ERROR,0,"Using unknown property '"+this.value()+"' as discriminator",this,(!0))},Discriminator.prototype.kind=function(){return tsInterfaces.MetaInformationKind.Discriminator},Discriminator}(ts.TypeInformation);exports.Discriminator=Discriminator;var DiscriminatorValue=function(_super){function DiscriminatorValue(_value){_super.call(this,!1),this._value=_value}return __extends(DiscriminatorValue,_super),DiscriminatorValue.prototype.facetName=function(){return"discriminatorValue"},DiscriminatorValue.prototype.validateSelf=function(registry){if(!this.owner().isSubTypeOf(ts.OBJECT))return new typesystem_1.Status(typesystem_1.Status.ERROR,0,"you only can use `discriminator` with object types",this);if(this.owner().getExtra(ts.GLOBAL)===!1)return new typesystem_1.Status(typesystem_1.Status.ERROR,0,"you only can use `discriminator` with top level type definitions",this);var ds=this.owner().oneMeta(Discriminator);if(!ds)return new typesystem_1.Status(typesystem_1.Status.ERROR,0,"you can not use `discriminatorValue` without declaring `discriminator`",this);var prop=_.find(this.owner().meta(),function(x){return x instanceof restrictions_1.PropertyIs&&x.propertyName()==ds.value()});if(prop){var sm=prop.value().validate(this.value());if(!sm.isOk())return new typesystem_1.Status(typesystem_1.Status.ERROR,0,"using invalid `disciminatorValue`:"+sm.getMessage(),this)}return ts.ok()},DiscriminatorValue.prototype.requiredType=function(){return ts.OBJECT},DiscriminatorValue.prototype.value=function(){return this._value},DiscriminatorValue.prototype.kind=function(){return tsInterfaces.MetaInformationKind.DiscriminatorValue},DiscriminatorValue}(ts.TypeInformation);exports.DiscriminatorValue=DiscriminatorValue},function(module,exports,__webpack_require__){"use strict";function setPropertyConstructor(p){pc=p}function toNominal(t,callback,customizer){void 0===customizer&&(customizer=null);var vs=null;if(t.getExtra(NOMINAL))return t.getExtra(NOMINAL);if(!t){var res=callback("any");res||(vs=new nt.StructuredType(t.name()))}if(t.isBuiltin()){var s="any"!=t.name()&&"array"!=t.name()?callback(t.name()):null;vs=s?s:t.isScalar()?new nt.ValueType(t.name(),null):new nt.StructuredType(t.name())}else if(t.isObject())vs=new nt.StructuredType(t.name(),null);else if(t.isArray()){var ar=new nt.Array(t.name(),null);vs=ar,t.putExtra(NOMINAL,vs);var cm=t.oneMeta(restrictions.ComponentShouldBeOfType),r=cm?cm.value():ts.ANY;ar.setComponent(toNominal(r,callback))}else if(t instanceof ts.UnionType){var ut=new nt.Union(t.name(),null);0==t.superTypes().length&&ut._superTypes.push(toNominal(ts.UNION,callback,customizer)),t.putExtra(NOMINAL,ut),t.options().forEach(function(x){if(null==ut.left)ut.left=toNominal(x,callback);else if(null==ut.right)ut.right=toNominal(x,callback);else{var nu=new nt.Union(t.name(),null);nu.left=ut.right,nu.right=toNominal(x,callback),ut.right=nu}}),vs=ut}else if(t.isScalar())vs=new nt.ValueType(t.name(),null);else if(t instanceof ts.ExternalType){var e=t,et=new nt.ExternalType(e.name());et.schemaString=e.schema(),vs=et}if(vs||(vs=new nt.StructuredType(t.name())),t.superTypes().forEach(function(x){var mn=toNominal(x,callback);x.isBuiltin()?vs._superTypes.push(mn):vs.addSuperType(mn)}),t.isEmpty()){if(t.isArray()&&1==t.superTypes().length&&t.superTypes()[0].isAnonymous()){var q=vs.superTypes()[0];q.setName(t.name()),q._subTypes=q._subTypes.filter(function(x){return x!=vs}),vs=q}if(t.isUnion()&&1==t.superTypes().length&&t.superTypes()[0].isAnonymous()){var q=vs.superTypes()[0];q.setName(t.name()),q._subTypes=q._subTypes.filter(function(x){return x!=vs}),vs=q}}t.putExtra(NOMINAL,vs);var proto=parse.toProto(t);proto.properties.forEach(function(x){var prop=pc?pc(x.id):new nt.Property(x.id);prop.withDomain(vs),prop.withRange(toNominal(x.type,callback)),x.optional||prop.withRequired(!0)}),proto.facetDeclarations.forEach(function(x){var prop=pc?pc(x.facetName()):new nt.Property(x.facetName());prop.withRange(toNominal(x.type(),callback)),vs.addFacet(prop)}),t.customFacets().forEach(function(x){vs.fixFacet(x.facetName(),x.value())});for(var basicFacets=t.metaOfType(restrictions.FacetRestriction),_i=0,basicFacets_1=basicFacets;_i<basicFacets_1.length;_i++){var x=basicFacets_1[_i];vs.fixFacet(x.facetName(),x.value())}return vs.addAdapter(t),t.isEmpty()&&vs.addAdapter(new nt.Empty),vs._validator=function(x){return t.validate(x,!1).getErrors()},t.isBuiltin()?vs.buildIn=!0:t.subTypes().forEach(function(x){toNominal(x,callback,customizer)}),vs}var pc,ts=__webpack_require__(103),nt=__webpack_require__(110),parse=__webpack_require__(105),restrictions=__webpack_require__(107),NOMINAL="nominal";exports.setPropertyConstructor=setPropertyConstructor,exports.toNominal=toNominal},function(module,exports,__webpack_require__){(function(global){"use strict";function registerInjector(i){global.extraInjectors.push(i)}var __extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},ti=__webpack_require__(111),tsInterfaces=__webpack_require__(104),_=__webpack_require__(142);global.extraInjectors=[],
exports.registerInjector=registerInjector;var Adaptable=function(){function Adaptable(){var _this=this;this.adapters=[],global.extraInjectors.forEach(function(x){return x.inject(_this)})}return Adaptable.prototype.addAdapter=function(q){this.adapters.push(q)},Adaptable.prototype.getAdapter=function(adapterType){var result=null;return this.adapters.forEach(function(x){x instanceof adapterType&&(result=x)}),result},Adaptable.prototype.getAdapters=function(){return this.adapters},Adaptable}();exports.Adaptable=Adaptable;var Described=function(_super){function Described(_name,_description){void 0===_description&&(_description=""),_super.call(this),this._name=_name,this._description=_description,this._tags=[],this._annotations=[]}return __extends(Described,_super),Described.prototype.nameId=function(){return this._name},Described.prototype.description=function(){return this._description},Described.prototype.addAnnotation=function(a){this._annotations.push(a)},Described.prototype.removeAnnotation=function(a){this._annotations=this._annotations.filter(function(x){return x!=a})},Described.prototype.annotations=function(){return[].concat(this._annotations)},Described.prototype.tags=function(){return this._tags},Described.prototype.withDescription=function(d){return this._description=d,this},Described.prototype.setName=function(name){this._name=name},Described}(Adaptable);exports.Described=Described;var Annotation=function(_super){function Annotation(type,parameters){_super.call(this,type.nameId()),this.type=type,this.parameters=parameters}return __extends(Annotation,_super),Annotation.prototype.parameterNames=function(){return Object.keys(this.parameters)},Annotation.prototype.parameter=function(name){return this.parameters[name]},Annotation.prototype.getType=function(){return this.type},Annotation}(Described);exports.Annotation=Annotation;var Empty=function(){function Empty(){}return Empty}();exports.Empty=Empty;var EmptyUniverse=function(){function EmptyUniverse(){}return EmptyUniverse.prototype.type=function(name){return null},EmptyUniverse.prototype.version=function(){return"Empty"},EmptyUniverse.prototype.types=function(){return[]},EmptyUniverse.prototype.matched=function(){return{}},EmptyUniverse}(),emptyUniverse=new EmptyUniverse,ebuilder=__webpack_require__(139),AbstractType=function(_super){function AbstractType(_name,_universe,_path){void 0===_universe&&(_universe=emptyUniverse),void 0===_path&&(_path=""),_super.call(this,_name),this._universe=_universe,this._path=_path,this._customProperties=[],this._facets=[],this._superTypes=[],this._subTypes=[],this._requirements=[],this.fixedFacets={},this.uc=!1}return __extends(AbstractType,_super),AbstractType.prototype.properties=function(){return[]},AbstractType.prototype.externalInHierarchy=function(){var x=this.allSuperTypes(),res=null;return x.forEach(function(y){y instanceof ExternalType&&(res=y)}),res},AbstractType.prototype.addFacet=function(q){this._facets.push(q)},AbstractType.prototype.validate=function(x){if(!this._validator)throw new Error("Validate can be used only on runtime types instances");return this._validator(x)},AbstractType.prototype.allFacets=function(ps){if(void 0===ps&&(ps={}),this._allFacets)return this._allFacets;if(ps[this.nameId()])return[];ps[this.typeId()]=this;var n={};return this.superTypes().length>0&&this.superTypes().forEach(function(x){x instanceof AbstractType&&x.allFacets(ps).forEach(function(y){return n[y.nameId()]=y})}),this._facets.forEach(function(x){return n[x.nameId()]=x}),this._allFacets=Object.keys(n).map(function(x){return n[x]}),this._allFacets},AbstractType.prototype.facets=function(){return[].concat(this._facets)},AbstractType.prototype.facet=function(name){return _.find(this.allFacets(),function(x){return x.nameId()==name})},AbstractType.prototype.typeId=function(){return this.nameId()},AbstractType.prototype.allProperties=function(ps){if(void 0===ps&&(ps={}),this._props)return this._props;if(ps[this.typeId()])return[];ps[this.typeId()]=this;var n={};this.superTypes().length>0&&this.superTypes().forEach(function(x){x instanceof AbstractType?x.allProperties(ps).forEach(function(y){return n[y.nameId()]=y}):x.allProperties().forEach(function(y){return n[y.nameId()]=y})});for(var x in this.getFixedFacets())delete n[x];return this.properties().forEach(function(x){return n[x.nameId()]=x}),this._props=Object.keys(n).map(function(x){return n[x]}),this._props},AbstractType.prototype.property=function(propName){return _.find(this.allProperties(),function(x){return x.nameId()==propName})},AbstractType.prototype.hasValueTypeInHierarchy=function(){return null!=_.find(this.allSuperTypes(),function(x){var mm=x;if(mm.uc)return!1;mm.uc=!0;try{return x.hasValueTypeInHierarchy()}finally{mm.uc=!1}})},AbstractType.prototype.isAnnotationType=function(){return!1},AbstractType.prototype.hasStructure=function(){return!1},AbstractType.prototype.key=function(){return this._key?this._key:this._universe&&(this._key=this.universe().matched()[this.nameId()],!this._key)?null:this._key},AbstractType.prototype.hasArrayInHierarchy=function(){var arr=null!=_.find(this.allSuperTypes(),function(x){return x instanceof Array});return arr},AbstractType.prototype.arrayInHierarchy=function(){var x=this.allSuperTypes(),res=null;return x.forEach(function(y){y instanceof Array&&(res=y)}),res},AbstractType.prototype.unionInHierarchy=function(){var x=this.allSuperTypes(),res=null;return x.forEach(function(y){y instanceof Union&&(res=y)}),res},AbstractType.prototype.hasExternalInHierarchy=function(){return null!=_.find(this.allSuperTypes(),function(x){var mm=x;if(mm.uc)return!1;mm.uc=!0;try{return x instanceof ExternalType}finally{mm.uc=!1}})},AbstractType.prototype.hasUnionInHierarchy=function(){return null!=_.find(this.allSuperTypes(),function(x){var mm=x;if(mm.uc)return!1;mm.uc=!0;try{return x.hasUnionInHierarchy()}finally{mm.uc=!1}})},AbstractType.prototype.fixFacet=function(name,v){this.fixedFacets[name]=v},AbstractType.prototype.getFixedFacets=function(){var mm={};for(var q in this.fixedFacets)mm[q]=this.fixedFacets[q];return this.contributeFacets(mm),mm},AbstractType.prototype.allFixedFacets=function(){if(this._af)return this._af;var sp=this.allSuperTypes();sp.push(this);var mm={};return sp.forEach(function(x){var ff=x.getFixedFacets();for(var key in Object.keys(ff))mm[key]=ff[key]}),this._af=mm,mm},AbstractType.prototype.contributeFacets=function(x){},AbstractType.prototype.getPath=function(){return this._path},AbstractType.prototype.setNameAtRuntime=function(name){this._nameAtRuntime=name},AbstractType.prototype.getNameAtRuntime=function(){return this._nameAtRuntime},AbstractType.prototype.universe=function(){return this._universe?this._universe:new EmptyUniverse},AbstractType.prototype.superTypes=function(){return[].concat(this._superTypes)},AbstractType.prototype.isAssignableFrom=function(typeName){if(this.nameId()==typeName)return!this.isUserDefined();for(var currentSuperTypes=this.allSuperTypes(),i=0;i<currentSuperTypes.length;i++)if(currentSuperTypes[i].nameId()==typeName)return!0;return!1},AbstractType.prototype.annotationType=function(){return null},AbstractType.prototype.subTypes=function(){return[].concat(this._subTypes)},AbstractType.prototype.allSubTypes=function(){var rs=[];return this.subTypes().forEach(function(x){rs.push(x),rs=rs.concat(x.allSubTypes())}),_.unique(rs)},AbstractType.prototype.allSuperTypes=function(){if(this._allSupers)return this._allSupers;var rs=[];return this.allSuperTypesRecurrent(this,{},rs),this._allSupers=_.unique(rs),this._allSupers},AbstractType.prototype.allSuperTypesRecurrent=function(t,m,result){var _this=this;t.superTypes().forEach(function(x){m[x.typeId()]||(result.push(x),m[x.typeId()]=x,_this.allSuperTypesRecurrent(x,m,result))})},AbstractType.prototype.addSuperType=function(q){q._subTypes.push(this),this._superTypes.push(q)},AbstractType.prototype.addRequirement=function(name,value){this._requirements.push(new ti.ValueRequirement(name,value))},AbstractType.prototype.valueRequirements=function(){return this._requirements},AbstractType.prototype.requiredProperties=function(){return this.allProperties().filter(function(x){return x.isRequired()})},AbstractType.prototype.printDetails=function(indent,settings){var _this=this;indent||(indent=""),settings||(settings={hideProperties:!1,hideSuperTypeProperties:!1,printStandardSuperclasses:!1});var standardIndent="  ",result="",className=this.getTypeClassName();result+=indent+this.nameId()+"["+className+"]\n";var properties=this.properties();properties&&properties.length>0&&!settings.hideProperties&&(result+=indent+standardIndent+"Properties:\n",properties.forEach(function(property){var propertyType="",propertyRange=property.range();propertyRange instanceof Described&&(propertyType+=propertyRange.nameId()),propertyRange instanceof AbstractType&&(propertyType+="[",propertyType+=propertyRange.getTypeClassName(),propertyType+="]"),result+=indent+standardIndent+standardIndent+property.nameId()+" : "+propertyType+"\n"}));var superTypes=this.superTypes(),filteredSuperTypes=superTypes;return superTypes&&!settings.printStandardSuperclasses&&(filteredSuperTypes=_.filter(superTypes,function(superType){var name=superType instanceof Described?superType.nameId():"",type=superType instanceof AbstractType?superType.getTypeClassName():"";return!_this.isStandardSuperclass(name,type)})),filteredSuperTypes&&filteredSuperTypes.length>0&&(result+=indent+standardIndent+"Super types:\n",filteredSuperTypes.forEach(function(superType){result+=superType.printDetails(indent+standardIndent+standardIndent,{hideProperties:settings.hideSuperTypeProperties,hideSuperTypeProperties:settings.hideSuperTypeProperties,printStandardSuperclasses:settings.printStandardSuperclasses})})),result},AbstractType.prototype.getTypeClassName=function(){return this.constructor.toString().match(/\w+/g)[1]},AbstractType.prototype.isStandardSuperclass=function(nameId,className){return"TypeDeclaration"===nameId&&"NodeClass"===className||("ObjectTypeDeclaration"===nameId&&"NodeClass"===className||"RAMLLanguageElement"===nameId&&"NodeClass"===className)},AbstractType.prototype.examples=function(){return ebuilder.exampleFromNominal(this)},AbstractType.prototype.isGenuineUserDefinedType=function(){return!this.buildIn&&(!!(this.properties()&&this.properties().length>0)||(!!(this.getFixedFacets()&&Object.keys(this.getFixedFacets()).length>0)||this.isTopLevel()&&this.nameId()&&this.nameId().length>0))},AbstractType.prototype.genuineUserDefinedTypeInHierarchy=function(){if(this.isGenuineUserDefinedType())return this;var result=null,allSuperTypes=this.allSuperTypes();return allSuperTypes.forEach(function(currentSuperType){!result&&currentSuperType.isGenuineUserDefinedType()&&(result=currentSuperType)}),result},AbstractType.prototype.hasGenuineUserDefinedTypeInHierarchy=function(){return null!=_.find(this.allSuperTypes(),function(x){var mm=x;if(mm.uc)return!1;mm.uc=!0;try{return x.isGenuineUserDefinedType()}finally{mm.uc=!1}})},AbstractType.prototype.customProperties=function(){return[].concat(this._customProperties)},AbstractType.prototype.allCustomProperties=function(){var props=[];return this.superTypes().forEach(function(x){return props=props.concat(x.allCustomProperties())}),props=props.concat(this.customProperties())},AbstractType.prototype.registerCustomProperty=function(p){if(p.domain()!=this)throw new Error("Should be already owned by this");if(this._customProperties.indexOf(p)!=-1)throw new Error("Already included");this._customProperties.push(p)},AbstractType.prototype.setCustom=function(val){this._isCustom=val},AbstractType.prototype.isCustom=function(){return this._isCustom},AbstractType.prototype.isUnion=function(){return!1},AbstractType.prototype.union=function(){return null},AbstractType.prototype.isExternal=function(){return!1},AbstractType.prototype.external=function(){return null},AbstractType.prototype.isArray=function(){return!1},AbstractType.prototype.isObject=function(){if("object"==this.nameId())return!0;for(var _i=0,_a=this.allSuperTypes();_i<_a.length;_i++){var t=_a[_i];if(t.isObject())return!0}return!1},AbstractType.prototype.array=function(){return null},AbstractType.prototype.isValueType=function(){return!1},AbstractType.prototype.kind=function(){var result=[];return this.isObject()&&result.push("object"),this.isArray()&&result.push("array"),this.isValueType()&&result.push("value"),this.isUnion()&&result.push("union"),this.isAnnotationType()&&result.push("annotation"),this.isExternal()&&result.push("external"),result},AbstractType.prototype.isBuiltIn=function(){return this.buildIn},AbstractType.prototype.setBuiltIn=function(builtIn){this.buildIn=builtIn},AbstractType.prototype.isTopLevel=function(){return!(!this.getExtra(tsInterfaces.DEFINED_IN_TYPES_EXTRA)&&!this.getExtra(tsInterfaces.TOP_LEVEL_EXTRA))},AbstractType.prototype.isUserDefined=function(){return this.getExtra(tsInterfaces.USER_DEFINED_EXTRA)&&!this.buildIn},AbstractType.prototype.putExtra=function(extraName,value){var extraAdapter=this.getExtraAdapter();extraAdapter&&extraAdapter.putExtra(extraName,value)},AbstractType.prototype.getExtra=function(name){var extraAdapter=this.getExtraAdapter();return extraAdapter?extraAdapter.getExtra(name):null},AbstractType.prototype.getExtraAdapter=function(){if(this.getAdapters()){var extraAdapter=_.find(this.getAdapters(),function(adapter){if(adapter.getExtra&&"function"==typeof adapter.getExtra&&adapter.putExtra&&"function"==typeof adapter.putExtra)return!0});return extraAdapter}return null},AbstractType}(Described);exports.AbstractType=AbstractType;var ValueType=function(_super){function ValueType(name,_universe,path,description){void 0===_universe&&(_universe=null),void 0===path&&(path=""),void 0===description&&(description=""),_super.call(this,name,_universe,path)}return __extends(ValueType,_super),ValueType.prototype.hasStructure=function(){return!1},ValueType.prototype.hasValueTypeInHierarchy=function(){return!0},ValueType.prototype.isValueType=function(){return!0},ValueType.prototype.isUnionType=function(){return!1},ValueType.prototype.isObject=function(){return!1},ValueType}(AbstractType);exports.ValueType=ValueType;var StructuredType=function(_super){function StructuredType(){_super.apply(this,arguments),this._properties=[]}return __extends(StructuredType,_super),StructuredType.prototype.hasStructure=function(){return!0},StructuredType.prototype.propertyIndex=function(name){for(var props=this.properties(),i=0;i<props.length;i++)if(props[i].nameId()==name)return i;return-1},StructuredType.prototype.addProperty=function(name,range){return new Property(name).withDomain(this).withRange(range)},StructuredType.prototype.allPropertyIndex=function(name){for(var props=this.allProperties(),i=0;i<props.length;i++)if(props[i].nameId()==name)return i;return-1},StructuredType.prototype.properties=function(){return[].concat(this._properties)},StructuredType.prototype.registerProperty=function(p){if(p.domain()!=this)throw new Error("Should be already owned by this");if(this._properties.indexOf(p)!=-1)throw new Error("Already included");this._properties.push(p)},StructuredType}(AbstractType);exports.StructuredType=StructuredType;var Property=function(_super){function Property(){_super.apply(this,arguments),this._keyShouldStartFrom=null,this._isRequired=!1,this._isMultiValue=!1,this._descriminates=!1,this._defaultBooleanValue=null,this._defaultIntegerValue=null}return __extends(Property,_super),Property.prototype.withMultiValue=function(v){return void 0===v&&(v=!0),this._isMultiValue=v,this},Property.prototype.withDescriminating=function(b){return this._descriminates=b,this},Property.prototype.withRequired=function(req){return this._isRequired=req,this},Property.prototype.isRequired=function(){return this._isRequired},Property.prototype.withKeyRestriction=function(keyShouldStartFrom){return this._keyShouldStartFrom=keyShouldStartFrom,this},Property.prototype.withDomain=function(d,custom){return void 0===custom&&(custom=!1),this._ownerClass=d,custom?d.registerCustomProperty(this):d.registerProperty(this),this},Property.prototype.setDefaultVal=function(s){return this._defaultValue=s,this},Property.prototype.setDefaultBooleanVal=function(s){return this._defaultBooleanValue=s,this},Property.prototype.setDefaultIntegerVal=function(s){return this._defaultIntegerValue=s,this},Property.prototype.defaultValue=function(){return null!=this._defaultValue?this._defaultValue:null!=this._defaultBooleanValue?this._defaultBooleanValue:null!=this._defaultIntegerValue?this._defaultIntegerValue:null},Property.prototype.isPrimitive=function(){return!1},Property.prototype.withRange=function(t){return this._nodeRange=t,this},Property.prototype.isValueProperty=function(){return this._nodeRange.hasValueTypeInHierarchy()},Property.prototype.enumOptions=function(){return this._enumOptions&&"string"==typeof this._enumOptions?[this._enumOptions+""]:this._enumOptions},Property.prototype.keyPrefix=function(){return this._keyShouldStartFrom},Property.prototype.withEnumOptions=function(op){return this._enumOptions=op,this},Property.prototype.withKeyRegexp=function(regexp){return this._keyRegexp=regexp,this},Property.prototype.getKeyRegexp=function(){return this._keyRegexp},Property.prototype.matchKey=function(k){if(null==k)return!1;if(null!=this._groupName)return this._groupName==k;if(null!=this._keyShouldStartFrom&&0==k.indexOf(this._keyShouldStartFrom))return!0;if(this._enumOptions&&this._enumOptions.indexOf(k)!=-1)return!0;if(this.getKeyRegexp())try{if(new RegExp(this.getKeyRegexp()).test(k))return!0}catch(Error){}return!1},Property.prototype.getFacetValidator=function(){return this.facetValidator},Property.prototype.setFacetValidator=function(f){this.facetValidator=f},Property.prototype.domain=function(){return this._ownerClass},Property.prototype.range=function(){return this._nodeRange},Property.prototype.isMultiValue=function(){return!(!this.range()||!this.range().hasArrayInHierarchy())||this._isMultiValue},Property.prototype.isDescriminator=function(){return this._descriminates},Property}(Described);exports.Property=Property;var Union=function(_super){function Union(){_super.apply(this,arguments)}return __extends(Union,_super),Union.prototype.key=function(){return null},Union.prototype.leftType=function(){return this.left},Union.prototype.rightType=function(){return this.right},Union.prototype.isUserDefined=function(){return!0},Union.prototype.unionInHierarchy=function(){return this},Union.prototype.union=function(){return this},Union.prototype.hasUnionInHierarchy=function(){return!0},Union.prototype.isUnion=function(){return!0},Union.prototype.isObject=function(){return this.leftType().isObject()&&this.rightType().isObject()},Union.prototype.hasArrayInHierarchy=function(){return this.left&&this.right?this.left.hasArrayInHierarchy()||this.right.hasArrayInHierarchy():this.left?this.left.hasArrayInHierarchy():this.right?this.right.hasArrayInHierarchy():void 0},Union}(AbstractType);exports.Union=Union;var Array=function(_super){function Array(){_super.apply(this,arguments)}return __extends(Array,_super),Array.prototype.hasArrayInHierarchy=function(){return!0},Array.prototype.isArray=function(){return!0},Array.prototype.isObject=function(){return!1},Array.prototype.arrayInHierarchy=function(){return this},Array.prototype.array=function(){return this},Array.prototype.isUserDefined=function(){return!0},Array.prototype.componentType=function(){return this.component},Array.prototype.setComponent=function(t){this.component=t},Array.prototype.key=function(){return null},Array}(AbstractType);exports.Array=Array;var ExternalType=function(_super){function ExternalType(){_super.apply(this,arguments)}return __extends(ExternalType,_super),ExternalType.prototype.externalInHierarchy=function(){return this},ExternalType.prototype.typeId=function(){return this.schemaString},ExternalType.prototype.schema=function(){return this.schemaString},ExternalType.prototype.isUserDefined=function(){return!0},ExternalType.prototype.hasExternalInHierarchy=function(){return!0},ExternalType.prototype.isExternal=function(){return!0},ExternalType.prototype.external=function(){return this},ExternalType}(StructuredType);exports.ExternalType=ExternalType}).call(exports,function(){return this}())},function(module,exports,__webpack_require__){"use strict";var ValueRequirement=function(){function ValueRequirement(name,value){this.name=name,this.value=value}return ValueRequirement}();exports.ValueRequirement=ValueRequirement},function(module,exports,__webpack_require__){"use strict";function visit(node,action){te.visit(node,action)}function serializeToString(node){return te.serializeToString(node)}function parse(str){return te.parse(str)}var te=__webpack_require__(141);exports.visit=visit,exports.serializeToString=serializeToString,exports.parse=parse},function(module,exports,__webpack_require__){(function(global){"use strict";function getJSONSchema(content,provider){var key=schemaKey(provider,content),rs=!!useLint&&globalCache.getValue(key);if(rs&&rs.provider)return rs;var res=new JSONSchemaObject(content,provider);return globalCache.setValue(key,res),res}function getXMLSchema(content,provider){var rs=(schemaKey(provider,content),!!useLint&&globalCache.getValue(content));if(rs)return rs;var res=new XMLSchemaObject(content);return useLint&&globalCache.setValue(content,res),res}function createSchema(content,provider){var key=schemaKey(provider,content),rs=!!useLint&&globalCache.getValue(key);if(rs)return rs;try{var res=new JSONSchemaObject(content,provider);return useLint&&globalCache.setValue(key,res),res}catch(e){try{var res=new XMLSchemaObject(content);return useLint&&globalCache.setValue(key,res),res}catch(e){return useLint&&globalCache.setValue(key,new Error("Can not parse schema")),null}}}function elementChildrenByName(parent,tagName){for(var elements=parent.getElementsByTagName(tagName),result=[],i=0;i<elements.length;i++){var child=elements[i];child.parentNode===parent&&result.push(child)}return result}var _=__webpack_require__(142),xmlValidator=__webpack_require__(144),DOMParser=__webpack_require__(181).DOMParser,ZSchema=__webpack_require__(190),ValidationResult=function(){function ValidationResult(){}return ValidationResult}();exports.ValidationResult=ValidationResult;var useLint=!0,ErrorsCache=function(){function ErrorsCache(){this.errors={}}return ErrorsCache.prototype.getValue=function(key){return this.errors[key]},ErrorsCache.prototype.setValue=function(key,value){this.errors[key]=value},ErrorsCache}(),globalCache=new ErrorsCache;global.cleanCache=function(){globalCache=new ErrorsCache};var DummyProvider=function(){function DummyProvider(){}return DummyProvider.prototype.contextPath=function(){return""},DummyProvider.prototype.normalizePath=function(url){return""},DummyProvider.prototype.content=function(reference){return""},DummyProvider.prototype.hasAsyncRequests=function(){return!1},DummyProvider.prototype.resolvePath=function(context,relativePath){return""},DummyProvider.prototype.isAbsolutePath=function(uri){return!1},DummyProvider.prototype.contentAsync=function(reference){var _this=this;return{then:function(arg){return arg(_this.content(reference))},resolve:function(){return null}}},DummyProvider.prototype.promiseResolve=function(arg){return{then:function(arg1){return arg1(arg)},resolve:function(){return null}}},DummyProvider}(),exampleKey=function(content,schema,contextPath){return"__EXAMPLE_"+content+schema+contextPath},JSONSchemaObject=function(){function JSONSchemaObject(schema,provider){if(this.schema=schema,this.provider=provider,provider?this.provider=provider:this.provider=new DummyProvider,!schema||0==schema.trim().length||"{"!=schema.trim().charAt(0))throw new Error("Invalid JSON schema content");var jsonSchemaObject;try{var jsonSchemaObject=JSON.parse(schema)}catch(err){throw new Error("It is not JSON schema(can not parse JSON:"+err.message+")")}if(jsonSchemaObject){try{var api=__webpack_require__(183);this.setupId(jsonSchemaObject,this.provider.contextPath());var schemaVer=""+jsonSchemaObject.$schema;schemaVer.indexOf("http://json-schema.org/draft-04/")==-1?jsonSchemaObject=api.v4(jsonSchemaObject):this.fixRequired(jsonSchemaObject)}catch(e){throw new Error("Can not parse schema"+schema)}delete jsonSchemaObject.$schema,this.jsonSchema=jsonSchemaObject}}return JSONSchemaObject.prototype.fixRequired=function(obj){},JSONSchemaObject.prototype.getType=function(){return"source.json"},JSONSchemaObject.prototype.validateObject=function(object){this.validate(JSON.stringify(object))},JSONSchemaObject.prototype.getMissingReferences=function(references,normalize){var _this=this;void 0===normalize&&(normalize=!1);var result=[],validator=new ZSchema;references.forEach(function(references){return validator.setRemoteReference(references.reference,references.content||{})});var schemaUrl=null;if(this.jsonSchema.id&&"string"==typeof this.jsonSchema.id){schemaUrl=this.jsonSchema.id;var innerPos=schemaUrl.indexOf("#");innerPos!=-1&&(schemaUrl=schemaUrl.substr(0,innerPos))}try{validator.validateSchema(this.jsonSchema)}catch(Error){return[]}var result=validator.getMissingRemoteReferences(),filteredReferences=[];return result&&(filteredReferences=_.filter(result,function(referenceUrl){return null==validator.cache[referenceUrl]&&referenceUrl!=schemaUrl})),normalize?filteredReferences.map(function(reference){return _this.provider.normalizePath(reference)}):filteredReferences},JSONSchemaObject.prototype.getSchemaPath=function(schema,normalize){if(void 0===normalize&&(normalize=!1),!schema)return"";if(!schema.id)return"";var id=schema.id.trim();if(id.lastIndexOf("#")!==id.length-1)return id;var result=id.substr(0,id.length-1);return normalize?this.provider.normalizePath(result):result},JSONSchemaObject.prototype.patchSchema=function(schema){var _this=this;if(!schema)return schema;if(!schema.id)return schema;var id=schema.id.trim();id.lastIndexOf("#")!==id.length-1&&(id+="#",schema.id=id);var currentPath=id.substr(0,id.length-1);if(!this.provider.isAbsolutePath(currentPath))return schema;currentPath=this.provider.normalizePath(currentPath);var refContainers=[];this.collectRefContainers(schema,refContainers),refContainers.forEach(function(refConatiner){var reference=refConatiner.$ref;if("string"==typeof reference&&0!==reference.indexOf("#")){reference.indexOf("#")===-1&&(reference+="#");var resolvedRef=_this.provider.resolvePath(currentPath,reference);refConatiner.$ref=resolvedRef}})},JSONSchemaObject.prototype.collectRefContainers=function(rootObject,refContainers){var _this=this;Object.keys(rootObject).forEach(function(key){return"$ref"===key?void refContainers.push(rootObject):void(rootObject[key]&&"object"==typeof rootObject[key]&&_this.collectRefContainers(rootObject[key],refContainers))})},JSONSchemaObject.prototype.validate=function(content,alreadyAccepted){var _this=this;void 0===alreadyAccepted&&(alreadyAccepted=[]);var key=exampleKey(content,this.schema,this.provider.contextPath()),error=globalCache.getValue(key);if(error){if(error instanceof Error)throw error}else{var validator=new ZSchema;alreadyAccepted.forEach(function(accepted){return validator.setRemoteReference(accepted.reference,accepted.content)}),validator.validate(JSON.parse(content),this.jsonSchema);var missingReferences=validator.getMissingRemoteReferences().filter(function(reference){return!_.find(alreadyAccepted,function(acceptedReference){return reference===acceptedReference.reference})});if(!missingReferences||0===missingReferences.length)return void this.acceptErrors(key,validator.getLastErrors(),!0);var acceptedReferences=[];missingReferences.forEach(function(reference){var remoteSchemeContent,result={reference:reference};try{var api=__webpack_require__(183),jsonObject=JSON.parse(_this.provider.content(reference));_this.setupId(jsonObject,_this.provider.normalizePath(reference)),remoteSchemeContent=api.v4(jsonObject),delete remoteSchemeContent.$schema,result.content=remoteSchemeContent}catch(exception){result.error=exception}finally{acceptedReferences.push(result)}}),this.provider.hasAsyncRequests()||(acceptedReferences.forEach(function(accepted){alreadyAccepted.push(accepted)}),this.validate(content,alreadyAccepted))}},JSONSchemaObject.prototype.setupId=function(json,path){if(path&&json){if(json.id)return json.id=json.id.trim(),void(json.id.indexOf("#")<0&&(json.id=json.id+"#"));json.id=path.replace(/\\/g,"/")+"#",this.patchSchema(json)}},JSONSchemaObject.prototype.acceptErrors=function(key,errors,throwImmediately){if(void 0===throwImmediately&&(throwImmediately=!1),errors&&errors.length>0){var res=new Error("Content is not valid according to schema:"+errors.map(function(x){return x.message+" "+x.params}).join(", "));if(res.errors=errors,globalCache.setValue(key,res),throwImmediately)throw res}else globalCache.setValue(key,1)},JSONSchemaObject.prototype.contentAsync=function(reference){var remoteSchemeContent,_this=this,api=__webpack_require__(183),contentPromise=this.provider.contentAsync(reference);if(!contentPromise)return this.provider.promiseResolve({reference:reference,content:null,error:new Error("Reference not found: "+reference)});var result=contentPromise.then(function(cnt){var content={reference:reference};try{var jsonObject=JSON.parse(cnt);_this.setupId(jsonObject,_this.provider.normalizePath(reference)),remoteSchemeContent=api.v4(jsonObject),delete remoteSchemeContent.$schema,content.content=remoteSchemeContent}catch(exception){content.error=exception}return content});return result},JSONSchemaObject}();exports.JSONSchemaObject=JSONSchemaObject;var MAX_EXAMPLES_TRESHOLD=10,XMLSchemaObject=function(){function XMLSchemaObject(schema){if(this.schema=schema,this.extraElementData=null,this.contentToResult={},"<"!=schema.charAt(0))throw new Error("Invalid JSON schema");this.schemaObj=new xmlValidator.XMLValidator(this.handleReferenceElement(schema))}return XMLSchemaObject.prototype.getType=function(){return"text.xml"},XMLSchemaObject.prototype.validateObject=function(object){if(this.extraElementData){var objectName=Object.keys(object)[0];if(!this.extraElementData.type&&!this.extraElementData.originalName)return void this.acceptErrors("key",[new Error('Referenced type "'+this.extraElementData.requestedName+'" is not match with "'+objectName+'" root node')],!0);if(this.extraElementData.originalName&&objectName!==this.extraElementData.originalName)return void this.acceptErrors("key",[new Error('Referenced type "'+this.extraElementData.requestedName+'" is not match with "'+objectName+'" root node')],!0);if(this.extraElementData.type){var root=object[objectName];delete object[objectName],object[this.extraElementData.name]=root}}this.validate(xmlValidator.jsonToXml(object))},XMLSchemaObject.prototype.validate=function(xml){try{var rs=this.contentToResult[xml];if(rs===!1)return;if(rs)throw rs;var validationErrors=this.schemaObj.validate(xml);this.acceptErrors("key",validationErrors,!0),this.contentToResult[xml]=!1,Object.keys(this.contentToResult).length>MAX_EXAMPLES_TRESHOLD&&(this.contentToResult={})}catch(e){throw this.contentToResult[xml]=e,e}},XMLSchemaObject.prototype.handleReferenceElement=function(content){var doc=(new DOMParser).parseFromString(content),schema=elementChildrenByName(doc,"xs:schema")[0],elements=elementChildrenByName(schema,"xs:element"),element=_.find(elements,function(element){return"true"===element.getAttribute("extraelement")});if(!element)return content;var extraElementData={};return extraElementData.name=element.getAttribute("name"),extraElementData.type=element.getAttribute("type"),extraElementData.originalName=element.getAttribute("originalname"),extraElementData.requestedName=element.getAttribute("requestedname"),extraElementData.type||schema.removeChild(element),element.removeAttribute("originalname"),element.removeAttribute("requestedname"),element.removeAttribute("extraelement"),this.extraElementData=extraElementData,doc.toString()},XMLSchemaObject.prototype.acceptErrors=function(key,errors,throwImmediately){
if(void 0===throwImmediately&&(throwImmediately=!1),errors&&errors.length>0){var res=new Error("Content is not valid according to schema:"+errors.map(function(x){return x.message}).join(", "));if(res.errors=errors,globalCache.setValue(key,res),throwImmediately)throw res}else;},XMLSchemaObject}();exports.XMLSchemaObject=XMLSchemaObject,exports.getJSONSchema=getJSONSchema;var schemaKey=function(provider,content){var contextPath="";provider&&(contextPath=provider.contextPath());var key="__SCHEMA_"+content+contextPath;return key};exports.getXMLSchema=getXMLSchema,exports.createSchema=createSchema}).call(exports,function(){return this}())},function(module,exports,__webpack_require__){"use strict";module.exports=__webpack_require__(154)},function(module,exports,__webpack_require__){"function"==typeof Object.create?module.exports=function(ctor,superCtor){ctor.super_=superCtor,ctor.prototype=Object.create(superCtor.prototype,{constructor:{value:ctor,enumerable:!1,writable:!0,configurable:!0}})}:module.exports=function(ctor,superCtor){ctor.super_=superCtor;var TempCtor=function(){};TempCtor.prototype=superCtor.prototype,ctor.prototype=new TempCtor,ctor.prototype.constructor=ctor}},function(module,exports,__webpack_require__){"use strict";var Schema=__webpack_require__(147),schema=new Schema({include:[__webpack_require__(117)],explicit:[__webpack_require__(161),__webpack_require__(162)]});Schema.DEFAULT=schema,module.exports=schema},function(module,exports,__webpack_require__){"use strict";var Schema=__webpack_require__(147),schema=new Schema({include:[__webpack_require__(148)],implicit:[__webpack_require__(155),__webpack_require__(156)],explicit:[__webpack_require__(157),__webpack_require__(158),__webpack_require__(159),__webpack_require__(160)]});module.exports=schema},function(module,exports,__webpack_require__){var upperCase=__webpack_require__(121),lowerCase=__webpack_require__(124);module.exports=function(str,locale){if(null==str)return"";for(var result="",i=0;i<str.length;i++){var c=str[i],u=upperCase(c,locale);result+=u===c?lowerCase(c,locale):u}return result}},function(module,exports,__webpack_require__){var sentenceCase=__webpack_require__(128);module.exports=function(string,locale){return sentenceCase(string,locale,".")}},function(module,exports,__webpack_require__){var sentenceCase=__webpack_require__(128);module.exports=function(string,locale){return sentenceCase(string,locale,"/")}},function(module,exports,__webpack_require__){var LANGUAGES={tr:{regexp:/[\u0069]/g,map:{i:"İ"}},az:{regexp:/[\u0069]/g,map:{i:"İ"}},lt:{regexp:/[\u0069\u006A\u012F]\u0307|\u0069\u0307[\u0300\u0301\u0303]/g,map:{"i̇":"I","j̇":"J","į̇":"Į","i̇̀":"Ì","i̇́":"Í","i̇̃":"Ĩ"}}};module.exports=function(str,locale){var lang=LANGUAGES[locale];return str=null==str?"":String(str),lang&&(str=str.replace(lang.regexp,function(m){return lang.map[m]})),str.toUpperCase()}},function(module,exports,__webpack_require__){var upperCase=__webpack_require__(121),sentenceCase=__webpack_require__(128);module.exports=function(str,locale){return sentenceCase(str,locale).replace(/^.| ./g,function(m){return upperCase(m,locale)})}},function(module,exports,__webpack_require__){var upperCase=__webpack_require__(121),sentenceCase=__webpack_require__(128);module.exports=function(string,locale,mergeNumbers){var result=sentenceCase(string,locale);return mergeNumbers||(result=result.replace(/(\d) (?=\d)/g,"$1_")),result.replace(/ (.)/g,function(m,$1){return upperCase($1,locale)})}},function(module,exports,__webpack_require__){var LANGUAGES={tr:{regexp:/\u0130|\u0049|\u0049\u0307/g,map:{"İ":"i",I:"ı","İ":"i"}},az:{regexp:/[\u0130]/g,map:{"İ":"i",I:"ı","İ":"i"}},lt:{regexp:/[\u0049\u004A\u012E\u00CC\u00CD\u0128]/g,map:{I:"i̇",J:"j̇","Į":"į̇","Ì":"i̇̀","Í":"i̇́","Ĩ":"i̇̃"}}};module.exports=function(str,locale){var lang=LANGUAGES[locale];return str=null==str?"":String(str),lang&&(str=str.replace(lang.regexp,function(m){return lang.map[m]})),str.toLowerCase()}},function(module,exports,__webpack_require__){var sentenceCase=__webpack_require__(128);module.exports=function(str,locale){return sentenceCase(str,locale,"_")}},function(module,exports,__webpack_require__){var camelCase=__webpack_require__(123),upperCaseFirst=__webpack_require__(132);module.exports=function(string,locale){return upperCaseFirst(camelCase(string,locale),locale)}},function(module,exports,__webpack_require__){var sentenceCase=__webpack_require__(128);module.exports=function(string,locale){return sentenceCase(string,locale,"-")}},function(module,exports,__webpack_require__){var lowerCase=__webpack_require__(124),NON_WORD_REGEXP=__webpack_require__(163),CAMEL_CASE_REGEXP=__webpack_require__(164),TRAILING_DIGIT_REGEXP=__webpack_require__(165);module.exports=function(str,locale,replacement){function replace(match,index,string){return 0===index||index===string.length-match.length?"":replacement}return null==str?"":(replacement=replacement||" ",str=String(str).replace(CAMEL_CASE_REGEXP,"$1 $2").replace(TRAILING_DIGIT_REGEXP,"$1 $2").replace(NON_WORD_REGEXP,replace),lowerCase(str,locale))}},function(module,exports,__webpack_require__){var lowerCase=__webpack_require__(124);module.exports=function(string,locale){return lowerCase(string,locale)===string}},function(module,exports,__webpack_require__){var upperCase=__webpack_require__(121),snakeCase=__webpack_require__(125);module.exports=function(string,locale){return upperCase(snakeCase(string,locale),locale)}},function(module,exports,__webpack_require__){var upperCase=__webpack_require__(121);module.exports=function(string,locale){return upperCase(string,locale)===string}},function(module,exports,__webpack_require__){var upperCase=__webpack_require__(121);module.exports=function(str,locale){return null==str?"":(str=String(str),upperCase(str.charAt(0),locale)+str.substr(1))}},function(module,exports,__webpack_require__){var lowerCase=__webpack_require__(124);module.exports=function(str,locale){return null==str?"":(str=String(str),lowerCase(str.charAt(0),locale)+str.substr(1))}},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_RESULT__;__WEBPACK_AMD_DEFINE_RESULT__=function(){"use strict";var statusCodes=__webpack_require__(175),statusCodesToPhrases={},statusPhrasesToCodes={},methods=__webpack_require__(176),headers=__webpack_require__(177),relations=__webpack_require__(178);return statusCodes.forEach(function(item){var phrase,code=parseInt(item.code,10);code.toString()===item.code&&(phrase=item.phrase.toUpperCase().replace(/[^A-Z]/g,"_"),statusCodesToPhrases[code]=item.phrase,statusPhrasesToCodes[phrase]=item.code)}),{statusCodes:statusCodes,statusCodesToPhrases:statusCodesToPhrases,statusPhrasesToCodes:statusPhrasesToCodes,methods:methods,headers:headers,relations:relations}}.call(exports,__webpack_require__,exports,module),!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__))},function(module,exports,__webpack_require__){"use strict";var Matching,__extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},ts=__webpack_require__(170);!function(Matching){function visit(n,cb){var r0=cb(n);if(r0)return r0==Matching.SKIP?null:r0;var r=ts.forEachChild(n,function(x){var r=visit(x,cb);if(r)return r});return r}function memberFromExp(objMatcher,tr){void 0===tr&&(tr=function(x){return!0});for(var array=objMatcher.split("."),result=null,a=0;a<array.length;a++){var arg=array[a],ci=arg.indexOf("(*)"),isCall=!1;ci!=-1&&(arg=arg.substr(0,ci),isCall=!0),result=null==result?"*"==arg?anyNode():ident(arg):new MemberExpressionMatcher(result,"*"==arg?anyNode():ident(arg),tr),isCall&&(result=new CallExpressionMatcher(result,tr))}return result}function ident(name){return new SimpleIdentMatcher(name)}function anyNode(){return new TrueMatcher}function call(calleeMatcher,tr){return void 0===tr&&(tr=function(x){return!0}),new CallExpressionMatcher(calleeMatcher,tr)}function exprStmt(eM,tr){return void 0===tr&&(tr=function(x){return!0}),new ExpressionStatementMatcher(eM,tr)}function assign(left,right,tr){return void 0===tr&&(tr=function(x){return!0}),new AssignmentExpressionMatcher(left,right,tr)}function varDecl(left,right,tr){return void 0===tr&&(tr=function(x){return!0}),new VariableDeclarationMatcher(left,right,tr)}function field(){return new FieldMatcher}function classDeclaration(){return new ClassDeclarationMatcher}var BasicMatcher=function(){function BasicMatcher(){}return BasicMatcher.prototype.match=function(node){throw new Error},BasicMatcher.prototype.nodeType=function(){throw new Error},BasicMatcher.prototype.doMatch=function(n){return n?this.nodeType()==n.kind?this.match(n):void 0:null},BasicMatcher}();Matching.BasicMatcher=BasicMatcher;var ClassDeclarationMatcher=function(_super){function ClassDeclarationMatcher(){_super.call(this)}return __extends(ClassDeclarationMatcher,_super),ClassDeclarationMatcher.prototype.match=function(node){return node},ClassDeclarationMatcher.prototype.nodeType=function(){return ts.SyntaxKind.ClassDeclaration},ClassDeclarationMatcher}(BasicMatcher);Matching.ClassDeclarationMatcher=ClassDeclarationMatcher;var FieldMatcher=function(_super){function FieldMatcher(){_super.apply(this,arguments)}return __extends(FieldMatcher,_super),FieldMatcher.prototype.match=function(node){return node},FieldMatcher.prototype.nodeType=function(){return ts.SyntaxKind.PropertyDeclaration},FieldMatcher}(BasicMatcher);Matching.FieldMatcher=FieldMatcher;var AssignmentExpressionMatcher=function(_super){function AssignmentExpressionMatcher(left,right,tr){_super.call(this),this.left=left,this.right=right,this.tr=tr}return __extends(AssignmentExpressionMatcher,_super),AssignmentExpressionMatcher.prototype.match=function(node){return node.operatorToken.kind==ts.SyntaxKind.EqualsToken&&this.left.doMatch(node.left)&&this.right.doMatch(node.right)?this.tr(node):null},AssignmentExpressionMatcher.prototype.nodeType=function(){return ts.SyntaxKind.BinaryExpression},AssignmentExpressionMatcher}(BasicMatcher);Matching.AssignmentExpressionMatcher=AssignmentExpressionMatcher;var VariableDeclarationMatcher=function(_super){function VariableDeclarationMatcher(left,right,tr){_super.call(this),this.left=left,this.right=right,this.tr=tr}return __extends(VariableDeclarationMatcher,_super),VariableDeclarationMatcher.prototype.match=function(node){if(this.left.doMatch(node.name)&&this.right.doMatch(node.initializer))return this.tr(node)},VariableDeclarationMatcher.prototype.nodeType=function(){return ts.SyntaxKind.VariableDeclaration},VariableDeclarationMatcher}(BasicMatcher);Matching.VariableDeclarationMatcher=VariableDeclarationMatcher;var ExpressionStatementMatcher=function(_super){function ExpressionStatementMatcher(expression,tr){_super.call(this),this.expression=expression,this.tr=tr}return __extends(ExpressionStatementMatcher,_super),ExpressionStatementMatcher.prototype.match=function(node){var exp=this.expression.doMatch(node.expression);if(exp){var v=this.tr(node.expression);return 1==v?exp:v}return null},ExpressionStatementMatcher.prototype.nodeType=function(){return ts.SyntaxKind.ExpressionStatement},ExpressionStatementMatcher}(BasicMatcher),SimpleIdentMatcher=function(_super){function SimpleIdentMatcher(val){_super.call(this),this.val=val}return __extends(SimpleIdentMatcher,_super),SimpleIdentMatcher.prototype.match=function(node){return node.text==this.val||null},SimpleIdentMatcher.prototype.nodeType=function(){return ts.SyntaxKind.Identifier},SimpleIdentMatcher}(BasicMatcher),TrueMatcher=function(){function TrueMatcher(){}return TrueMatcher.prototype.doMatch=function(node){return!0},TrueMatcher.prototype.nodeType=function(){return null},TrueMatcher}(),CallExpressionMatcher=function(_super){function CallExpressionMatcher(calleeMatcher,tr){_super.call(this),this.calleeMatcher=calleeMatcher,this.tr=tr}return __extends(CallExpressionMatcher,_super),CallExpressionMatcher.prototype.match=function(node){return this.calleeMatcher.doMatch(node.expression)?this.tr(node):null},CallExpressionMatcher.prototype.nodeType=function(){return ts.SyntaxKind.CallExpression},CallExpressionMatcher}(BasicMatcher);Matching.SKIP={},Matching.visit=visit;var PathNode=function(){function PathNode(name,_base){this._base=_base,this.arguments=null,this.name=name}return PathNode}();Matching.PathNode=PathNode;var CallPath=function(){function CallPath(base,_baseNode){this._baseNode=_baseNode,this.path=[],this.base=base}return CallPath.prototype.start=function(){return this._baseNode.pos},CallPath.prototype.startLocation=function(){return this._baseNode.getSourceFile().getLineAndCharacterOfPosition(this.start())},CallPath.prototype.endLocation=function(){return this._baseNode.getSourceFile().getLineAndCharacterOfPosition(this.end())},CallPath.prototype.end=function(){var ce=this.path[this.path.length-1]._callExpression;return ce?ce.end:this.start()},CallPath.prototype.toString=function(){return this.path.map(function(x){return x.name}).join(".")},CallPath}();Matching.CallPath=CallPath;var MemberExpressionMatcher=function(_super){function MemberExpressionMatcher(objectMatcher,propertyMatcher,tr){_super.call(this),this.objectMatcher=objectMatcher,this.propertyMatcher=propertyMatcher,this.tr=tr}return __extends(MemberExpressionMatcher,_super),MemberExpressionMatcher.prototype.match=function(node){return this.objectMatcher.doMatch(node.expression)&&this.propertyMatcher.doMatch(node.name)?this.tr(node):null},MemberExpressionMatcher.prototype.nodeType=function(){return ts.SyntaxKind.PropertyAccessExpression},MemberExpressionMatcher}(BasicMatcher);Matching.memberFromExp=memberFromExp;var CallBaseMatcher=function(){function CallBaseMatcher(rootMatcher){this.rootMatcher=rootMatcher}return CallBaseMatcher.prototype.doMatch=function(node){if(node.kind==ts.SyntaxKind.CallExpression){var call=node,res=this.doMatch(call.expression);if(res)return res.path.length>0&&null==res.path[res.path.length-1].arguments?(res.path[res.path.length-1].arguments=call.arguments,res.path[res.path.length-1]._callExpression=call,res):null}else if(node.kind==ts.SyntaxKind.PropertyAccessExpression){var me=node,v=this.doMatch(me.expression);if(v)return me.name.kind==ts.SyntaxKind.Identifier?(v.path.push(new PathNode(me.name.text,me.name)),v):null}else if(node.kind==ts.SyntaxKind.Identifier){var id=node;if(this.rootMatcher.doMatch(id))return new CallPath(id.text,id)}return null},CallBaseMatcher.prototype.nodeType=function(){return null},CallBaseMatcher}();Matching.CallBaseMatcher=CallBaseMatcher,Matching.ident=ident,Matching.anyNode=anyNode,Matching.call=call,Matching.exprStmt=exprStmt,Matching.assign=assign,Matching.varDecl=varDecl,Matching.field=field,Matching.classDeclaration=classDeclaration}(Matching=exports.Matching||(exports.Matching={}))},function(module,exports,__webpack_require__){"use strict";function getHelperMethods(srcPath){var result=[],content=fs.readFileSync(path.resolve(srcPath)).toString(),mod=ts.createSourceFile("sample.ts",content,ts.ScriptTarget.ES3,!0);return tsm.Matching.visit(mod,function(x){var node=x;if(node.kind==ts.SyntaxKind.FunctionDeclaration){var meta=getMeta(node,content);if(!meta)return;var originalName=node.name.text,wrapperMethodName=originalName;meta.name?wrapperMethodName=meta.name:meta.name=originalName;var wrapperMethodName=meta.name?meta.name:originalName,args=node.parameters?node.parameters.map(function(a){return readArg(a,srcPath)}):[],returnType=(!!meta.override&&meta.override,tsStructureParser.buildType(node.type,srcPath));result.push(new HelperMethod(originalName,wrapperMethodName,returnType,args,meta))}}),result}function getMeta(node,content){var cRange=ts.getLeadingCommentRanges(content,node.pos);if(!cRange)return null;var comment=cRange.map(function(x){return content.substring(x.pos,x.end)}).join("\n"),ind=comment.indexOf("__$helperMethod__");if(ind<0)return null;ind+="__$helperMethod__".length;var indMeta=comment.indexOf("__$meta__");if(indMeta<0)return{comment:refineComment(comment.substring(ind))};var commentStr=refineComment(comment.substring(ind,indMeta)),indMetaObj=comment.indexOf("{",indMeta);if(indMetaObj<0)return{comment:commentStr};try{var meta=JSON.parse(refineComment(comment.substring(indMetaObj)));return meta.comment=commentStr.trim().length>0?commentStr:null,meta.override=meta.override||!1,meta.primary=meta.primary||!1,meta.deprecated=meta.deprecated||!1,meta}catch(e){console.log(e)}return{}}function readArg(node,srcPath){var name=node.name.text,type=tsStructureParser.buildType(node.type,srcPath);return{name:name,type:type}}function flatten(t,namespaces){if(t.typeKind==tsStructureParser.TypeKind.ARRAY)return namespaces?[]:[flatten(t.base)[0]+"[]"];if(t.typeKind==tsStructureParser.TypeKind.BASIC){var bt=t,str=bt.basicName,nameSpace=bt.nameSpace&&bt.nameSpace.trim();return null!=nameSpace&&nameSpace.length>0&&"RamlWrapper"!=nameSpace&&(str=nameSpace+"."+str),bt.typeArguments&&0!=bt.typeArguments.length&&(str+="<"+bt.typeArguments.map(function(x){return flatten(x)}).join(", ")+">"),namespaces?bt.nameSpace&&namespaces[bt.nameSpace]?[str]:[]:[str]}if(t.typeKind==tsStructureParser.TypeKind.UNION){var ut=t,result=[];return ut.options.forEach(function(x){return result=result.concat(flatten(x,namespaces))}),result}return[]}var ts=__webpack_require__(170),tsm=__webpack_require__(135),path=__webpack_require__(15),fs=__webpack_require__(44),tsStructureParser=__webpack_require__(91),ns={RamlWrapper:!0},HelperMethod=function(){function HelperMethod(originalName,wrapperMethodName,returnType,args,meta){this.originalName=originalName,this.wrapperMethodName=wrapperMethodName,this.returnType=returnType,this.args=args,this.meta=meta}return HelperMethod.prototype.targetWrappers=function(){var isValid=!0,result=[];return this.args.forEach(function(x){var arr=flatten(x.type,ns);if(0!=arr.length)return isValid&&0==result.length?void(result=result.concat(arr)):(result=[],void(isValid=!1))}),result},HelperMethod.prototype.callArgs=function(){return this.args.map(function(x){return 0==flatten(x.type,ns).length?x:{name:"this",type:null}})},HelperMethod}();exports.HelperMethod=HelperMethod,exports.getHelperMethods=getHelperMethods;var refineComment=function(comment){return comment.replace(/^\s*\/\*+/g,"").replace(/\*+\/\s*$/g,"").split("\n").map(function(x){return x.replace(/^\s*\/\//g,"").replace(/^\s*\* {0,1}/g,"")}).join("\n").trim()};exports.flatten=flatten},function(module,exports,__webpack_require__){"use strict";function resolve(p1,p2){return pth.resolve(p1,p2)}function readFileSync(p){return fs.readFileSync(p).toString()}function dirname(p){return pth.dirname(p)}function existsSync(p){return fs.existsSync(p)}var pth=__webpack_require__(15),fs=__webpack_require__(44);exports.resolve=resolve,exports.readFileSync=readFileSync,exports.dirname=dirname,exports.existsSync=existsSync},function(module,exports,__webpack_require__){module.exports=function(module){return module.webpackPolyfill||(module.deprecate=function(){},module.paths=[],module.children=[],module.webpackPolyfill=1),module}},function(module,exports,__webpack_require__){"use strict";function example(t){var ms=t.oneMeta(meta.Example);if(ms)return ms.example();if(t.getExtra(exCalcFlag))return null;t.putExtra(exCalcFlag,!0);try{var ms1=t.oneMeta(meta.Examples);if(ms1){var examples=ms1.examples();if(examples&&examples.length>0)return examples[0]}var d=t.oneMeta(meta.Default);if(d)return d.value();if(t.isObject()){var result={};return t.meta().forEach(function(x){if(x instanceof restrictions_2.PropertyIs){var p=x,ex=example(p.value());result[p.propertyName()]=ex}}),t.superTypes().forEach(function(x){if(x.oneMeta(meta.Example)||x.oneMeta(meta.Examples)){var ex=example(x);ex&&"object"==typeof ex&&Object.keys(ex).forEach(function(key){result[key]=ex[key]})}}),result}if(t.isArray()){var c=t.oneMeta(restrictions_1.ComponentShouldBeOfType),resultArray=[];return c&&resultArray.push(example(c.value())),resultArray}return t.isUnion()?example(t.typeFamily()[0]):t.isNumber()?1:!!t.isBoolean()||"some value"}finally{t.putExtra(exCalcFlag,!1)}}function exampleFromNominal(n){var tp=n.getAdapter(rt.InheritedType);if(tp){var result=[],ms1=tp.oneMeta(meta.Examples);if(ms1){var vl=ms1.value();if(vl&&"object"==typeof vl){var xmlValues;Object.keys(vl).forEach(function(key){var name=Array.isArray(vl)?null:key,exampleObj=vl[key],example=toExample({asXMLString:function(){return xmlValues||(xmlValues=ms1.asXMLStrings()),xmlValues[key]}},exampleObj,name);result.push(example)})}}var ms=tp.oneMeta(meta.Example);if(ms){var exampleV=ms.example();null!=exampleV&&result.push(toExample(ms,ms.value(),void 0,!0))}if(result.length>0)return result}return tp?[new Example(example(tp),(void 0),(void 0),(void 0),(!1),(void 0),(void 0),(!0))]:[]}var rt=__webpack_require__(103),meta=__webpack_require__(108),restrictions_1=__webpack_require__(107),restrictions_2=__webpack_require__(107),exCalcFlag="exampleCalculation";exports.example=example;var Example=function(){function Example(_value,_name,_displayName,_description,_strict,_annotations,_isSingle,_empty){void 0===_name&&(_name=void 0),void 0===_displayName&&(_displayName=void 0),void 0===_description&&(_description=void 0),void 0===_strict&&(_strict=!0),void 0===_annotations&&(_annotations=void 0),void 0===_isSingle&&(_isSingle=!1),void 0===_empty&&(_empty=!1),this._value=_value,this._name=_name,this._displayName=_displayName,this._description=_description,this._strict=_strict,this._annotations=_annotations,this._isSingle=_isSingle,this._empty=_empty}return Example.prototype.isEmpty=function(){return this._empty},Example.prototype.isJSONString=function(){return"string"==typeof this._value&&(0==(this._value+"").trim().indexOf("{")||0==(this._value+"").trim().indexOf("["))},Example.prototype.isXMLString=function(){return"string"==typeof this._value&&0==(this._value+"").trim().indexOf("<")},Example.prototype.asXMLString=function(){return this.isXMLString()?this._value:this._owner?this._owner.asXMLString():null},Example.prototype.isYAML=function(){return"string"!=typeof this._value||!(this.isJSONString()||this.isXMLString())},Example.prototype.asString=function(){return"string"==typeof this._value?""+this._value:this.expandAsString()},Example.prototype.asJSON=function(){if(this.isJSONString())try{return JSON.parse(this._value)}catch(e){return null}return this.isYAML()?this._value:this.expandAsString()},Example.prototype.original=function(){return this._value},Example.prototype.expandAsString=function(){return JSON.stringify(this.expandAsJSON(),null,2)},Example.prototype.expandAsJSON=function(){return this._value},Example.prototype.isSingle=function(){return this._isSingle},Example.prototype.strict=function(){return this._strict},Example.prototype.description=function(){return this._description},Example.prototype.displayName=function(){return this._displayName},Example.prototype.annotations=function(){return this._annotations},Example.prototype.name=function(){return this._name},Example}(),toExample=function(owner,exampleObj,name,isSingle){void 0===name&&(name=null),void 0===isSingle&&(isSingle=!1);var example;if(null!=exampleObj){var val=exampleObj.value;if(val){var displayName=exampleObj.displayName,description=exampleObj.description,strict=exampleObj.strict,aObj=null,annotationNames=Object.keys(exampleObj).filter(function(x){return"("==x.charAt(0)});if(annotationNames.length>0){aObj={};for(var _i=0,annotationNames_1=annotationNames;_i<annotationNames_1.length;_i++){var aName=annotationNames_1[_i],aVal=exampleObj[aName];aName=aName.substring(1,aName.length-1),aObj[aName]=aVal}}example=new Example(val,name,displayName,description,strict,aObj,isSingle)}else val=exampleObj,example=new Example(val,name,(void 0),(void 0),(!0),(void 0),isSingle)}return example&&(example._owner=owner),example};exports.exampleFromNominal=exampleFromNominal},function(module,exports,__webpack_require__){"use strict";function checkDate(dateStr){return date.isValid(dateStr,"YYYY-MM-DD")}function checkTime(time){return date.isValid("11 "+time.trim(),"YY HH:mm:ss")}var __extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},date=__webpack_require__(199),ts=__webpack_require__(103),DateOnlyR=function(_super){function DateOnlyR(){_super.apply(this,arguments)}return __extends(DateOnlyR,_super),DateOnlyR.prototype.check=function(value){return"string"==typeof value?checkDate(value)?ts.ok():new ts.Status(ts.Status.ERROR,0,"date-only should match to yyyy-mm-dd pattern",this):new ts.Status(ts.Status.ERROR,0,"date-only should be string matching to  yyyy-mm-dd pattern ",this)},DateOnlyR.prototype.requiredType=function(){return ts.STRING},DateOnlyR.prototype.value=function(){return!0},DateOnlyR.prototype.facetName=function(){return"should be date-only"},DateOnlyR}(ts.GenericTypeOf);exports.DateOnlyR=DateOnlyR;var TimeOnlyR=function(_super){function TimeOnlyR(){_super.apply(this,arguments)}return __extends(TimeOnlyR,_super),TimeOnlyR.prototype.check=function(value){if("string"==typeof value){var regexp=/^([0-9][0-9]:[0-9][0-9]:[0-9][0-9])(.[0-9]+)?$/,matches=value.match(regexp);if(!matches)return new ts.Status(ts.Status.ERROR,0,"time-only should match to hh:mm:ss[.ff...] pattern",this);var hhmmssTime=matches[1];return checkTime(hhmmssTime)?ts.ok():new ts.Status(ts.Status.ERROR,0,"time-only should match to hh:mm:ss[.ff...] pattern",this)}return new ts.Status(ts.Status.ERROR,0,"time-only should be string matching to  hh:mm:ss[.ff...] pattern ",this)},TimeOnlyR.prototype.requiredType=function(){return ts.STRING},TimeOnlyR.prototype.value=function(){return!0},TimeOnlyR.prototype.facetName=function(){return"should be time-only"},TimeOnlyR}(ts.GenericTypeOf);exports.TimeOnlyR=TimeOnlyR;var DateTimeOnlyR=function(_super){function DateTimeOnlyR(){_super.apply(this,arguments)}return __extends(DateTimeOnlyR,_super),DateTimeOnlyR.prototype.check=function(value){if("string"==typeof value){var regexp=/^(\d{4}-\d{2}-\d{2})T([0-9][0-9]:[0-9][0-9]:[0-9][0-9])(.[0-9]+)?$/,matches=value.match(regexp);if(!matches||matches.length<3)return new ts.Status(ts.Status.ERROR,0,"datetime-only should match to yyyy-mm-ddThh:mm:ss[.ff...] pattern",this);var date=matches[1],time=matches[2];return checkDate(date)&&checkTime(time)?ts.ok():new ts.Status(ts.Status.ERROR,0,"datetime-only should match to yyyy-mm-ddThh:mm:ss[.ff...] pattern",this)}return new ts.Status(ts.Status.ERROR,0,"datetime-only should be string matching to  yyyy-mm-ddThh:mm:ss[.ff...] pattern ",this)},DateTimeOnlyR.prototype.requiredType=function(){return ts.STRING},DateTimeOnlyR.prototype.value=function(){return!0},DateTimeOnlyR.prototype.facetName=function(){return"should be datetime-only"},DateTimeOnlyR}(ts.GenericTypeOf);exports.DateTimeOnlyR=DateTimeOnlyR;var r1=/(Mon|Tue|Wed|Thu|Fri|Sat|Sun)\,[ ]+\d{2}[ ]+(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)[ ]+\d{4}[ ]+\d{2}:\d{2}:\d{2}[ ]+GMT/,r2=/(Monday|Tuesday|Wednesday|Thursday|Friday|Saturday|Sunday)\,[ ]+\d{2}-(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)-\d{2}[ ]+\d{2}:\d{2}:\d{2}[ ]+GMT/,r3=/(Mon|Tue|Wed|Thu|Fri|Sat|Sun)\,[ ]+(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)[ ]+\d{1,2}[ ]+\d{2}:\d{2}:\d{2}[ ]+GMT/,r0=/^(\d{4}-\d{2}-\d{2})T(\d{2}:\d{2}:\d{2})(?:\.\d{1,3})?((?:[\+\-]\d{2}:\d{2})|Z)$/,DateTimeR=function(_super){function DateTimeR(){_super.apply(this,arguments)}return __extends(DateTimeR,_super),DateTimeR.prototype.check=function(value){var c=ts.VALIDATED_TYPE,rfc2616=!1;if(c.allCustomFacets().forEach(function(x){"format"==x.facetName()&&"rfc2616"===x.value()&&(rfc2616=!0)}),"string"==typeof value){if(!rfc2616){var rfc3339Matches=value.match(r0);if(!rfc3339Matches||rfc3339Matches.length<3)return new ts.Status(ts.Status.ERROR,0,"valid rfc3339 formatted string is expected",this);var date=rfc3339Matches[1],time=rfc3339Matches[2];return checkDate(date)&&checkTime(time)?ts.ok():new ts.Status(ts.Status.ERROR,0,"valid rfc3339 formatted string is expected",this)}return value.match(r1)||value.match(r2)||value.match(r3)?ts.ok():new ts.Status(ts.Status.ERROR,0,"valid rfc2616 formatted string is expected",this)}return new ts.Status(ts.Status.ERROR,0,"valid datetime formatted string is expected",this)},DateTimeR.prototype.requiredType=function(){return ts.STRING},DateTimeR.prototype.value=function(){return!0},DateTimeR.prototype.facetName=function(){return"should be datetime-only"},DateTimeR}(ts.GenericTypeOf);exports.DateTimeR=DateTimeR},function(module,exports,__webpack_require__){"use strict";function parseToType(val,t,contentProvider){void 0===contentProvider&&(contentProvider=null);try{var q=val.trim();if(q.length>0){var json="{"==q.charAt(0);if(json||"<"==q.charAt(0))return new ts.ExternalType("",q,json,contentProvider);var node=typeExpression.parse(val),result=parseNode(node,t);return result}return ts.derive(val,[ts.STRING])}catch(e){return ts.derive(val,[ts.UNKNOWN])}}function wrapArray(a,result){for(;a>0;){var nt=ts.derive("",[ts.ARRAY]);nt.addMeta(new restrictions_1.ComponentShouldBeOfType(result)),result=nt,a--}return result}function parseNode(node,t){if("union"==node.type){var ut=node;return ts.union("",[parseNode(ut.first,t),parseNode(ut.rest,t)])}if("parens"==node.type){var ps=node,rs=parseNode(ps.expr,t);return wrapArray(ps.arr,rs)}var lit=node;if("?"==lit.value.charAt(lit.value.length-1)){var result=t.get(lit.value.substr(0,lit.value.length-1));result||(result=ts.derive(lit.value,[ts.UNKNOWN])),result=ts.union(lit.value,[result,ts.NIL]);var a=lit.arr;return wrapArray(a,result)}var result=t.get(lit.value);result||(result=ts.derive(lit.value,[ts.UNKNOWN]));var a=lit.arr;return wrapArray(a,result)}function storeToString(t){if(t.isSubTypeOf(ts.ARRAY)){var cm=t.oneMeta(restrictions_1.ComponentShouldBeOfType);return cm?cm.value().isUnion()?"("+storeToString(cm.value())+")[]":storeToString(cm.value())+"[]":"array"}if(t instanceof ts.UnionType){var ut=t;return ut.options().map(function(x){return storeToString(x)}).join(" | ")}return t.isAnonymous()&&t.isEmpty()?t.superTypes().map(function(x){return storeToString(x)}).join(" , "):t.name()}function visit(node,action){if(action(node),"union"==node.type){var union=node;visit(union.first,action),visit(union.rest,action)}else if("parens"==node.type){var parens=node;visit(parens.expr,action)}}function serializeToString(node){var str,arr=0;if("name"==node.type){var literal=node;str=literal.value,arr=literal.arr}else if("union"==node.type){var union=node;str=serializeToString(union.first)+" | "+serializeToString(union.rest)}else if("parens"==node.type){var parens=node;str="("+serializeToString(parens.expr)+")",arr=parens.arr}for(;--arr>=0;)str+="[]";return str}function parse(str){return typeExpression.parse(str)}var typeExpression=__webpack_require__(173),ts=__webpack_require__(103),restrictions_1=__webpack_require__(107);exports.parseToType=parseToType,exports.storeToString=storeToString,exports.visit=visit,exports.serializeToString=serializeToString,exports.parse=parse},function(module,exports,__webpack_require__){"use strict";function find(t,it){return _.find(t,it)}function filter(t,it){return _.filter(t,it)}function unique(t){return _.unique(t)}var _=__webpack_require__(182);exports.find=find,exports.filter=filter,exports.unique=unique},function(module,exports,__webpack_require__){"use strict";function xmlOpen(tagname,attributes,level,newLine){void 0===level&&(level=0),void 0===newLine&&(newLine=!0);for(var result="<"+tagname,i=0;i<level;i++)result="    "+result;return attributes&&Object.keys(attributes).length>0&&Object.keys(attributes).forEach(function(key){"string"==typeof attributes[key]&&(result=result+" "+key+'="'+attributes[key]+'"')}),result=result+">"+(newLine?"\n":"")}function xmlClose(tagname,level){void 0===level&&(level=0);for(var result="</"+tagname,i=0;i<level&&i>-1;i++)result="    "+result;
var result=(level>-1?"\n":"")+result+">\n";return result}function serializeToXML(object,type){type=actualType(type);var expectedRootNodeName=rootXmlName(type),infos=getInfos(type),result=xmlOpen(expectedRootNodeName,getAttributesFromJson(object,infos)),valueWrapper={};if(valueWrapper[expectedRootNodeName]=object,type.isArray()){type.meta().filter(function(metaInfo){return metaInfo instanceof restrictions_1.ComponentShouldBeOfType})[0];result+=getArrayFromJson(valueWrapper,type,1,!0)}else result+=getElementsFromJson(object,infos,1);var result=result+xmlClose(expectedRootNodeName);return result}function getAttributesFromJson(node,infos){var nodeAttributes={},attributeInfos=_.filter(infos,function(info){return xmlDescriptor(info.value()).attribute});return attributeInfos.forEach(function(info){var key=info.propId(),xmlKey=xmlName(info);node[key]&&(nodeAttributes[xmlKey]=node[key].toString())}),nodeAttributes}function getElementFromJson(node,type,level){var jsonKey=Object.keys(node)[0],jsonValue=node[jsonKey],result=null;if(type.isScalar()){var infos=getInfos(type);result=xmlOpen(jsonKey,getAttributesFromJson(jsonValue,infos),level,!type.isScalar())+jsonValue.toString()}else{if(type.isUnion())return getElementFromJson(node,selectTypeFromJson(jsonValue,type),level);var infos=getInfos(type);result=xmlOpen(jsonKey,getAttributesFromJson(jsonValue,infos),level,!type.isScalar())+getElementsFromJson(jsonValue,infos,level+1)}return result+=xmlClose(jsonKey,type.isScalar()?-1:level)}function selectTypeFromJson(value,unionType){var canBeTypes=unionType.typeFamily(),results=[],result=null;return canBeTypes.forEach(function(type){var xmlValue=serializeToXML(value,type);if(xmlValue){var jsonValue=readObject(xmlValue,type);if(jsonValue){var errors=getXmlErrors(jsonValue);results.push({type:type,errors:errors&&errors.length||0})}}}),result=results.length>0?results[0]:{type:canBeTypes[0]},results.forEach(function(canBe){canBe.errors<result.errors&&(result=canBe)}),result.type}function getElementsFromJson(node,infos,level){var elementInfos=_.filter(infos,function(info){return!xmlDescriptor(info.value()).attribute}),result="";return elementInfos.forEach(function(info){var xmlKey=xmlName(info),key=info.propId(),value={};value[xmlKey]=node[key],result+=info.value().isArray()?getArrayFromJson(value,info.value(),level):node[key]||""===node[key]?getElementFromJson(value,info.value(),level):""}),result}function getArrayFromJson(values,type,level,rootNode){void 0===rootNode&&(rootNode=!1);var jsonKey=Object.keys(values)[0],jsonValue=values[jsonKey],descriptor=xmlDescriptor(type),isWrapped=rootNode||descriptor.wrapped,result="",componentType=arrayElementType(type),typeName=componentType&&componentType.name(),elementsLevel=level;return isWrapped&&!rootNode&&(result=xmlOpen(jsonKey,null,level),elementsLevel+=1),jsonValue&&isArray(jsonValue)&&jsonValue.forEach(function(item){var itemWrapper={};itemWrapper[isWrapped?typeName:jsonKey]=item,result+=getElementFromJson(itemWrapper,componentType,elementsLevel)}),isWrapped&&(result+=xmlClose(jsonKey,level)),result}function readObject(content,t){var result=null,opts={};return opts.explicitChildren=!1,opts.explicitArray=!1,opts.explicitRoot=isSchema(t)||!t.isExternal(),xml2js.parseString(content,opts,function(err,res){if(result=res,err)throw new Error}),result=isSchema(t)?result:postProcess(result,actualType(t))}function getXmlErrors(root){var errors=root[XML_ERRORS];return delete root[XML_ERRORS],errors&&0!==errors.length?errors.map(function(error){return new typesystem_1.Status(typesystem_1.Status.ERROR,0,error,{})}):null}function actualType(type){return type&&isBodyLike(type)&&type.superTypes()&&0!==type.superTypes().length?1===type.superTypes().length?type.superTypes()[0]:_.find(type.allSuperTypes(),function(superType){return"object"===superType.name()})||type:type}function isBodyLike(type){return!!type&&!!_.find(bodyNames,function(name){return type.name()===name})}function isSchema(t){return!!isXmlContent(t)||!!_.find(t.allSuperTypes(),function(supertype){return isXmlContent(supertype)})}function isXmlContent(t){return!(!t.isExternal()||!t._content||"string"!=typeof t._content||0!==t._content.trim().indexOf("<"))}function postProcess(result,type){var rootNodeName=Object.keys(result)[0],rootNode=result[rootNodeName],errors=[],expectedRootNodeName=rootXmlName(type);expectedRootNodeName!==rootNodeName&&errors.push('Unexpected root node "'+rootNodeName+'", "'+expectedRootNodeName+'" is expected.');var newJson;if(type.isArray()){var expectedAttributeNames=[],expectedElementNames=[],componentMeta=type.meta().filter(function(metaInfo){return metaInfo instanceof restrictions_1.ComponentShouldBeOfType})[0],typeName=componentMeta&&componentMeta.value().name();expectedElementNames.push(typeName),newJson=getArray(rootNode,type,errors,!0),fillExtras(rootNode,errors,expectedAttributeNames,expectedElementNames)}else newJson=buildJson(rootNode,type.isUnion()?selectFromUnion(rootNode,type):type,errors);return newJson[XML_ERRORS]=errors,newJson}function checkErrors(rootNode,actualType){var newJson,errors=[];newJson=buildJson(rootNode,actualType,errors);var validationErrors=actualType.validateDirect(newJson,!0,!1).getErrors();return errors.length+(validationErrors&&validationErrors.length)}function selectFromUnion(rootNode,union){var results=[];if(union.typeFamily().forEach(function(type){return results.push({type:type,errors:checkErrors(JSON.parse(JSON.stringify(rootNode)),type)})}),0===results.length)return union;var result=results[0];return results.forEach(function(oneOf){oneOf.errors<result.errors&&(result=oneOf)}),result.type}function buildJson(node,type,errors){var initialRoot={};if(!type)return node;if(type.isScalar())return toPrimitiveValue(type,node,errors);if(type.isUnion())return buildJson(node,selectFromUnion(node,type),errors);var infos=getInfos(type),expectedAttributeNames=[],expectedElementNames=[];return getAttributes(node,infos,expectedAttributeNames).forEach(function(attribute){return initialRoot[Object.keys(attribute)[0]]=attribute[Object.keys(attribute)[0]]}),getElements(node,infos,expectedElementNames,errors).forEach(function(element){return initialRoot[Object.keys(element)[0]]=element[Object.keys(element)[0]]}),fillExtras(node,errors,expectedAttributeNames,expectedElementNames),initialRoot}function fillExtras(node,errors,expectedAttributeNames,expectedElementNames,remove){if(void 0===remove&&(remove=!1),"object"==typeof node){node.$||(node.$={}),expectedAttributeNames.forEach(function(name){delete node.$[name]}),expectedElementNames.forEach(function(name){delete node[name]});var extraAttributes=Object.keys(node.$);delete node.$;var extraElements=Object.keys(node);extraAttributes.forEach(function(name){errors.push('Unexpected attribute "'+name+'".')}),extraElements.forEach(function(name){errors.push('Unexpected element "'+name+'".'),remove&&delete node[name]})}}function getInfos(type){return type.meta().filter(function(info){return info instanceof restrictions_1.PropertyIs}).map(function(info){return info})||[]}function getAttributes(node,infos,expectedNames){var nodeAttributes=node.$;if(!nodeAttributes)return[];var attributeInfos=_.filter(infos,function(info){return xmlDescriptor(info.value()).attribute});return attributeInfos.map(function(info){var attribute={},key=info.propId(),xmlKey=xmlName(info);expectedNames.push(xmlKey);var value=nodeAttributes[xmlKey];return attribute[key]=toPrimitiveValue(info.value(),value),null===attribute[key]?null:attribute}).filter(function(attribute){return attribute})}function getElements(node,infos,expectedNames,errors){var elementInfos=_.filter(infos,function(info){return!xmlDescriptor(info.value()).attribute});return elementInfos.map(function(info){var element={},key=(xmlDescriptor(info.value()),info.propId()),xmlKey=xmlName(info);expectedNames.push(xmlKey);var value=node[xmlKey];return info.value().isArray()?element[key]=getArray(node[xmlKey],info.value(),errors):element[key]=value||""===value?buildJson(value,info.value(),errors):null,null===element[key]?null:element}).filter(function(info){return info})}function getArray(values,type,errors,rootNode){void 0===rootNode&&(rootNode=!1);var descriptor=xmlDescriptor(type),isWrapped=rootNode||descriptor.wrapped,componentType=arrayElementType(type),typeName=componentType&&componentType.name();if(isWrapped){var valuesWrapper=values;values=values&&values[typeName],fillExtras(valuesWrapper,errors,[],[typeName],!0)}return values?(values=getArrayValues(values),values=isArray(values)?values.map(function(value){return buildJson(value,componentType,errors)}):"object"==typeof values&&values||[]):[]}function getArrayValues(preValues){return isArray(preValues)?preValues:"object"==typeof preValues?[preValues]:[]}function arrayElementType(arrayType){if(!arrayType||!arrayType.isArray())return null;var componentMetas=arrayType.meta().filter(function(metaInfo){return metaInfo instanceof restrictions_1.ComponentShouldBeOfType});return componentMetas&&componentMetas.length>0&&componentMetas[0].value()}function xmlName(property){var descriptor=xmlDescriptor(property.value()),ramlName=property.propId(),actualName=descriptor.name||ramlName;return descriptor.namespace&&(actualName=descriptor.namespace+":"+actualName),(descriptor.prefix||"")+actualName}function rootXmlName(type){var descriptor=xmlDescriptor(type),ramlName=type.name();""===ramlName&&type.isUnion()&&(ramlName="object");var actualName=descriptor.name||ramlName;return(descriptor.prefix||"")+actualName}function xmlDescriptor(type){var info=type.meta().filter(function(xmlInfo){return xmlInfo instanceof metainfo_1.XMLInfo}).map(function(xmlInfo){return xmlInfo})[0],result={attribute:!1,wrapped:!1,name:!1,namespace:!1,prefix:!1};if(!info)return result;var infoValue=info.value();return infoValue?(Object.keys(result).forEach(function(key){result[key]=infoValue[key]||result[key]}),result):result}function toPrimitiveValue(type,actual,errors){if(void 0===errors&&(errors=[]),"object"==typeof actual){var result=toPrimitiveValue(type,actual._);return delete actual._,fillExtras(actual,errors,[],[],!0),result}if(!actual&&""!==actual.trim())return null;if(type.isNumber()){var parsedValue=parseFloat(actual);if(!isNaN(parsedValue))return parsedValue}if(type.isBoolean()){if("true"===actual)return!0;if("false"===actual)return!1}return"string"==typeof actual?actual:null}function isArray(instance){return!!instance&&("object"==typeof instance&&"number"==typeof instance.length)}var xml2js=__webpack_require__(207),_=__webpack_require__(182),restrictions_1=__webpack_require__(107),metainfo_1=__webpack_require__(108),typesystem_1=__webpack_require__(103),XML_ERRORS="@unexpected_root_attributes_and_elements",bodyNames=["application/x-www-form-urlencoded","application/json","application/xml","multipart/form-data"];exports.serializeToXML=serializeToXML,exports.readObject=readObject,exports.getXmlErrors=getXmlErrors},function(module,exports,__webpack_require__){"use strict";function objectToXml(object){if(!object)return"";var nodeName=Object.keys(object)[0],root=object[nodeName];if(!root&&""!==root)return"";var result="<"+nodeName,attributes=root.$||{};return Object.keys(attributes).forEach(function(key){result=result+" "+key+'="'+attributes[key]+'"'}),result+=">","string"==typeof root?result+=root:Object.keys(root).forEach(function(key){if("$"!==key)if("object"!=typeof root[key]||root[key].length)if("string"!=typeof root[key]&&root[key]){if("array"==typeof root[key]||root[key].length)for(var children=root[key],i=0;i<children.length;i++){var member=children[i],child={};child[key]=member,result+=objectToXml(child)}}else{var child={};child[key]=root[key]||"",result+=objectToXml(child)}else{var child={};child[key]=root[key],result+=objectToXml(child)}}),result=result+"</"+nodeName+">"}function jsonToXml(jsonObject){var nodeName=jsonObject&&Object.keys(jsonObject)[0];if(nodeName){var root=jsonObject[nodeName];checkAttributes(root)}return objectToXml(jsonObject)}function checkAttributes(root){if(root&&"string"!=typeof root){var attributes=[];Object.keys(root).forEach(function(key){if(0===key.indexOf("@")){var attribute={key:key,value:root[key]};attributes.push(attribute)}else if(isArray(root[key])){var elements=root[key];elements.forEach(function(element){return checkAttributes(element)})}else"string"!=typeof root[key]&&checkAttributes(root[key])}),root.$||(root.$={});var newAttributes=root.$;attributes.forEach(function(attribute){delete root[attribute.key];var newKey=attribute.key.substring(1);newAttributes[newKey]=attribute.value})}}function isArray(instance){return!!instance&&("object"==typeof instance&&"number"==typeof instance.length)}var validator=__webpack_require__(200),XMLValidator=function(){function XMLValidator(schema){this.schema=schema}return XMLValidator.prototype.validate=function(xml){var result=validator.validateXML({xml:xml,schema:this.schema});return result&&result.errors&&result.errors.map(function(error){return new Error(error)})||[]},XMLValidator}();exports.XMLValidator=XMLValidator,exports.jsonToXml=jsonToXml},function(module,exports,__webpack_require__){var at,ch,text,value,escapee={'"':'"',"\\":"\\","/":"/",b:"\b",f:"\f",n:"\n",r:"\r",t:"\t"},error=function(m){throw{name:"SyntaxError",message:m,at:at,text:text}},next=function(c){return c&&c!==ch&&error("Expected '"+c+"' instead of '"+ch+"'"),ch=text.charAt(at),at+=1,ch},number=function(){var number,string="";for("-"===ch&&(string="-",next("-"));ch>="0"&&ch<="9";)string+=ch,next();if("."===ch)for(string+=".";next()&&ch>="0"&&ch<="9";)string+=ch;if("e"===ch||"E"===ch)for(string+=ch,next(),"-"!==ch&&"+"!==ch||(string+=ch,next());ch>="0"&&ch<="9";)string+=ch,next();return number=+string,isFinite(number)?number:void error("Bad number")},string=function(){var hex,i,uffff,string="";if('"'===ch)for(;next();){if('"'===ch)return next(),string;if("\\"===ch)if(next(),"u"===ch){for(uffff=0,i=0;i<4&&(hex=parseInt(next(),16),isFinite(hex));i+=1)uffff=16*uffff+hex;string+=String.fromCharCode(uffff)}else{if("string"!=typeof escapee[ch])break;string+=escapee[ch]}else string+=ch}error("Bad string")},white=function(){for(;ch&&ch<=" ";)next()},word=function(){switch(ch){case"t":return next("t"),next("r"),next("u"),next("e"),!0;case"f":return next("f"),next("a"),next("l"),next("s"),next("e"),!1;case"n":return next("n"),next("u"),next("l"),next("l"),null}error("Unexpected '"+ch+"'")},array=function(){var array=[];if("["===ch){if(next("["),white(),"]"===ch)return next("]"),array;for(;ch;){if(array.push(value()),white(),"]"===ch)return next("]"),array;next(","),white()}}error("Bad array")},object=function(){var key,object={};if("{"===ch){if(next("{"),white(),"}"===ch)return next("}"),object;for(;ch;){if(key=string(),white(),next(":"),Object.hasOwnProperty.call(object,key)&&error('Duplicate key "'+key+'"'),object[key]=value(),white(),"}"===ch)return next("}"),object;next(","),white()}}error("Bad object")};value=function(){switch(white(),ch){case"{":return object();case"[":return array();case'"':return string();case"-":return number();default:return ch>="0"&&ch<="9"?number():word()}},module.exports=function(source,reviver){var result;return text=source,at=0,ch=" ",result=value(),white(),ch&&error("Syntax error"),"function"==typeof reviver?function walk(holder,key){var k,v,value=holder[key];if(value&&"object"==typeof value)for(k in value)Object.prototype.hasOwnProperty.call(value,k)&&(v=walk(value,k),void 0!==v?value[k]=v:delete value[k]);return reviver.call(holder,key,value)}({"":result},""):result}},function(module,exports,__webpack_require__){function quote(string){return escapable.lastIndex=0,escapable.test(string)?'"'+string.replace(escapable,function(a){var c=meta[a];return"string"==typeof c?c:"\\u"+("0000"+a.charCodeAt(0).toString(16)).slice(-4)})+'"':'"'+string+'"'}function str(key,holder){var i,k,v,length,partial,mind=gap,value=holder[key];switch(value&&"object"==typeof value&&"function"==typeof value.toJSON&&(value=value.toJSON(key)),"function"==typeof rep&&(value=rep.call(holder,key,value)),typeof value){case"string":return quote(value);case"number":return isFinite(value)?String(value):"null";case"boolean":case"null":return String(value);case"object":if(!value)return"null";if(gap+=indent,partial=[],"[object Array]"===Object.prototype.toString.apply(value)){for(length=value.length,i=0;i<length;i+=1)partial[i]=str(i,value)||"null";return v=0===partial.length?"[]":gap?"[\n"+gap+partial.join(",\n"+gap)+"\n"+mind+"]":"["+partial.join(",")+"]",gap=mind,v}if(rep&&"object"==typeof rep)for(length=rep.length,i=0;i<length;i+=1)k=rep[i],"string"==typeof k&&(v=str(k,value),v&&partial.push(quote(k)+(gap?": ":":")+v));else for(k in value)Object.prototype.hasOwnProperty.call(value,k)&&(v=str(k,value),v&&partial.push(quote(k)+(gap?": ":":")+v));return v=0===partial.length?"{}":gap?"{\n"+gap+partial.join(",\n"+gap)+"\n"+mind+"}":"{"+partial.join(",")+"}",gap=mind,v}}var gap,indent,rep,escapable=/[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,meta={"\b":"\\b","\t":"\\t","\n":"\\n","\f":"\\f","\r":"\\r",'"':'\\"',"\\":"\\\\"};module.exports=function(value,replacer,space){var i;if(gap="",indent="","number"==typeof space)for(i=0;i<space;i+=1)indent+=" ";else"string"==typeof space&&(indent=space);if(rep=replacer,replacer&&"function"!=typeof replacer&&("object"!=typeof replacer||"number"!=typeof replacer.length))throw new Error("JSON.stringify");return str("",{"":value})}},function(module,exports,__webpack_require__){"use strict";function compileList(schema,name,result){var exclude=[];return schema.include.forEach(function(includedSchema){result=compileList(includedSchema,name,result)}),schema[name].forEach(function(currentType){result.forEach(function(previousType,previousIndex){previousType.tag===currentType.tag&&exclude.push(previousIndex)}),result.push(currentType)}),result.filter(function(type,index){return-1===exclude.indexOf(index)})}function compileMap(){function collectType(type){result[type.tag]=type}var index,length,result={};for(index=0,length=arguments.length;index<length;index+=1)arguments[index].forEach(collectType);return result}var common=__webpack_require__(97),YAMLException=__webpack_require__(98),Type=__webpack_require__(179),Schema=function(){function Schema(definition){this.include=definition.include||[],this.implicit=definition.implicit||[],this.explicit=definition.explicit||[],this.implicit.forEach(function(type){if(type.loadKind&&"scalar"!==type.loadKind)throw new YAMLException("There is a non-scalar type in the implicit list of a schema. Implicit resolving of such types is not supported.")}),this.compiledImplicit=compileList(this,"implicit",[]),this.compiledExplicit=compileList(this,"explicit",[]),this.compiledTypeMap=compileMap(this.compiledImplicit,this.compiledExplicit)}return Schema.DEFAULT=null,Schema.create=function(){var schemas,types;switch(arguments.length){case 1:schemas=Schema.DEFAULT,types=arguments[0];break;case 2:schemas=arguments[0],types=arguments[1];break;default:throw new YAMLException("Wrong number of arguments for Schema.create function")}if(schemas=common.toArray(schemas),types=common.toArray(types),!schemas.every(function(schema){return schema instanceof Schema}))throw new YAMLException("Specified list of super schemas (or a single Schema object) contains a non-Schema object.");if(!types.every(function(type){return type instanceof Type}))throw new YAMLException("Specified list of YAML types (or a single Type object) contains a non-Type object.");return new Schema({include:schemas,explicit:types})},Schema}();module.exports=Schema},function(module,exports,__webpack_require__){"use strict";var Schema=__webpack_require__(147);module.exports=new Schema({include:[__webpack_require__(180)]})},function(module,exports,__webpack_require__){(function(process){"use strict";function ReadableState(options,stream){Duplex=Duplex||__webpack_require__(151),options=options||{},this.objectMode=!!options.objectMode,stream instanceof Duplex&&(this.objectMode=this.objectMode||!!options.readableObjectMode);var hwm=options.highWaterMark,defaultHwm=this.objectMode?16:16384;this.highWaterMark=hwm||0===hwm?hwm:defaultHwm,this.highWaterMark=~~this.highWaterMark,this.buffer=[],this.length=0,this.pipes=null,this.pipesCount=0,this.flowing=null,this.ended=!1,this.endEmitted=!1,this.reading=!1,this.sync=!0,this.needReadable=!1,this.emittedReadable=!1,this.readableListening=!1,this.resumeScheduled=!1,this.defaultEncoding=options.defaultEncoding||"utf8",this.ranOut=!1,this.awaitDrain=0,this.readingMore=!1,this.decoder=null,this.encoding=null,options.encoding&&(StringDecoder||(StringDecoder=__webpack_require__(198).StringDecoder),this.decoder=new StringDecoder(options.encoding),this.encoding=options.encoding)}function Readable(options){return Duplex=Duplex||__webpack_require__(151),this instanceof Readable?(this._readableState=new ReadableState(options,this),this.readable=!0,options&&"function"==typeof options.read&&(this._read=options.read),void Stream.call(this)):new Readable(options)}function readableAddChunk(stream,state,chunk,encoding,addToFront){var er=chunkInvalid(state,chunk);if(er)stream.emit("error",er);else if(null===chunk)state.reading=!1,onEofChunk(stream,state);else if(state.objectMode||chunk&&chunk.length>0)if(state.ended&&!addToFront){var e=new Error("stream.push() after EOF");stream.emit("error",e)}else if(state.endEmitted&&addToFront){var e=new Error("stream.unshift() after end event");stream.emit("error",e)}else{var skipAdd;!state.decoder||addToFront||encoding||(chunk=state.decoder.write(chunk),skipAdd=!state.objectMode&&0===chunk.length),addToFront||(state.reading=!1),skipAdd||(state.flowing&&0===state.length&&!state.sync?(stream.emit("data",chunk),stream.read(0)):(state.length+=state.objectMode?1:chunk.length,addToFront?state.buffer.unshift(chunk):state.buffer.push(chunk),state.needReadable&&emitReadable(stream))),maybeReadMore(stream,state)}else addToFront||(state.reading=!1);return needMoreData(state)}function needMoreData(state){return!state.ended&&(state.needReadable||state.length<state.highWaterMark||0===state.length)}function computeNewHighWaterMark(n){return n>=MAX_HWM?n=MAX_HWM:(n--,n|=n>>>1,n|=n>>>2,n|=n>>>4,n|=n>>>8,n|=n>>>16,n++),n}function howMuchToRead(n,state){return 0===state.length&&state.ended?0:state.objectMode?0===n?0:1:null===n||isNaN(n)?state.flowing&&state.buffer.length?state.buffer[0].length:state.length:n<=0?0:(n>state.highWaterMark&&(state.highWaterMark=computeNewHighWaterMark(n)),n>state.length?state.ended?state.length:(state.needReadable=!0,0):n)}function chunkInvalid(state,chunk){var er=null;return Buffer.isBuffer(chunk)||"string"==typeof chunk||null===chunk||void 0===chunk||state.objectMode||(er=new TypeError("Invalid non-string/buffer chunk")),er}function onEofChunk(stream,state){if(!state.ended){if(state.decoder){var chunk=state.decoder.end();chunk&&chunk.length&&(state.buffer.push(chunk),state.length+=state.objectMode?1:chunk.length)}state.ended=!0,emitReadable(stream)}}function emitReadable(stream){var state=stream._readableState;state.needReadable=!1,state.emittedReadable||(debug("emitReadable",state.flowing),state.emittedReadable=!0,state.sync?processNextTick(emitReadable_,stream):emitReadable_(stream))}function emitReadable_(stream){debug("emit readable"),stream.emit("readable"),flow(stream)}function maybeReadMore(stream,state){state.readingMore||(state.readingMore=!0,processNextTick(maybeReadMore_,stream,state))}function maybeReadMore_(stream,state){for(var len=state.length;!state.reading&&!state.flowing&&!state.ended&&state.length<state.highWaterMark&&(debug("maybeReadMore read 0"),stream.read(0),len!==state.length);)len=state.length;state.readingMore=!1}function pipeOnDrain(src){return function(){var state=src._readableState;debug("pipeOnDrain",state.awaitDrain),state.awaitDrain&&state.awaitDrain--,0===state.awaitDrain&&EElistenerCount(src,"data")&&(state.flowing=!0,flow(src))}}function nReadingNextTick(self){debug("readable nexttick read 0"),self.read(0)}function resume(stream,state){state.resumeScheduled||(state.resumeScheduled=!0,processNextTick(resume_,stream,state))}function resume_(stream,state){state.reading||(debug("resume read 0"),stream.read(0)),state.resumeScheduled=!1,stream.emit("resume"),flow(stream),state.flowing&&!state.reading&&stream.read(0)}function flow(stream){var state=stream._readableState;if(debug("flow",state.flowing),state.flowing)do var chunk=stream.read();while(null!==chunk&&state.flowing)}function fromList(n,state){var ret,list=state.buffer,length=state.length,stringMode=!!state.decoder,objectMode=!!state.objectMode;if(0===list.length)return null;if(0===length)ret=null;else if(objectMode)ret=list.shift();else if(!n||n>=length)ret=stringMode?list.join(""):1===list.length?list[0]:Buffer.concat(list,length),list.length=0;else if(n<list[0].length){var buf=list[0];ret=buf.slice(0,n),list[0]=buf.slice(n)}else if(n===list[0].length)ret=list.shift();else{ret=stringMode?"":new Buffer(n);for(var c=0,i=0,l=list.length;i<l&&c<n;i++){var buf=list[0],cpy=Math.min(n-c,buf.length);stringMode?ret+=buf.slice(0,cpy):buf.copy(ret,c,0,cpy),cpy<buf.length?list[0]=buf.slice(cpy):list.shift(),c+=cpy}}return ret}function endReadable(stream){var state=stream._readableState;if(state.length>0)throw new Error("endReadable called on non-empty stream");state.endEmitted||(state.ended=!0,processNextTick(endReadableNT,state,stream))}function endReadableNT(state,stream){state.endEmitted||0!==state.length||(state.endEmitted=!0,stream.readable=!1,stream.emit("end"))}function forEach(xs,f){for(var i=0,l=xs.length;i<l;i++)f(xs[i],i)}function indexOf(xs,x){for(var i=0,l=xs.length;i<l;i++)if(xs[i]===x)return i;return-1}module.exports=Readable;var processNextTick=__webpack_require__(195),isArray=__webpack_require__(197),Buffer=__webpack_require__(92).Buffer;Readable.ReadableState=ReadableState;var Stream,EElistenerCount=(__webpack_require__(196),function(emitter,type){return emitter.listeners(type).length});!function(){try{Stream=__webpack_require__(169)}catch(_){}finally{Stream||(Stream=__webpack_require__(196).EventEmitter)}}();var Buffer=__webpack_require__(92).Buffer,util=__webpack_require__(210);util.inherits=__webpack_require__(115);var debugUtil=__webpack_require__(172),debug=void 0;debug=debugUtil&&debugUtil.debuglog?debugUtil.debuglog("stream"):function(){};var StringDecoder;util.inherits(Readable,Stream);var Duplex,Duplex;Readable.prototype.push=function(chunk,encoding){var state=this._readableState;return state.objectMode||"string"!=typeof chunk||(encoding=encoding||state.defaultEncoding,encoding!==state.encoding&&(chunk=new Buffer(chunk,encoding),encoding="")),readableAddChunk(this,state,chunk,encoding,!1)},Readable.prototype.unshift=function(chunk){var state=this._readableState;return readableAddChunk(this,state,chunk,"",!0)},Readable.prototype.isPaused=function(){return this._readableState.flowing===!1},Readable.prototype.setEncoding=function(enc){return StringDecoder||(StringDecoder=__webpack_require__(198).StringDecoder),this._readableState.decoder=new StringDecoder(enc),this._readableState.encoding=enc,this};var MAX_HWM=8388608;Readable.prototype.read=function(n){debug("read",n);var state=this._readableState,nOrig=n;if(("number"!=typeof n||n>0)&&(state.emittedReadable=!1),0===n&&state.needReadable&&(state.length>=state.highWaterMark||state.ended))return debug("read: emitReadable",state.length,state.ended),0===state.length&&state.ended?endReadable(this):emitReadable(this),null;if(n=howMuchToRead(n,state),0===n&&state.ended)return 0===state.length&&endReadable(this),null;var doRead=state.needReadable;debug("need readable",doRead),(0===state.length||state.length-n<state.highWaterMark)&&(doRead=!0,debug("length less than watermark",doRead)),(state.ended||state.reading)&&(doRead=!1,debug("reading or ended",doRead)),doRead&&(debug("do read"),state.reading=!0,state.sync=!0,0===state.length&&(state.needReadable=!0),this._read(state.highWaterMark),state.sync=!1),doRead&&!state.reading&&(n=howMuchToRead(nOrig,state));var ret;return ret=n>0?fromList(n,state):null,null===ret&&(state.needReadable=!0,n=0),state.length-=n,0!==state.length||state.ended||(state.needReadable=!0),nOrig!==n&&state.ended&&0===state.length&&endReadable(this),null!==ret&&this.emit("data",ret),ret},Readable.prototype._read=function(n){this.emit("error",new Error("not implemented"))},Readable.prototype.pipe=function(dest,pipeOpts){function onunpipe(readable){debug("onunpipe"),readable===src&&cleanup()}function onend(){debug("onend"),dest.end()}function cleanup(){debug("cleanup"),dest.removeListener("close",onclose),dest.removeListener("finish",onfinish),dest.removeListener("drain",ondrain),dest.removeListener("error",onerror),dest.removeListener("unpipe",onunpipe),src.removeListener("end",onend),src.removeListener("end",cleanup),src.removeListener("data",ondata),cleanedUp=!0,!state.awaitDrain||dest._writableState&&!dest._writableState.needDrain||ondrain()}function ondata(chunk){debug("ondata");var ret=dest.write(chunk);!1===ret&&(1!==state.pipesCount||state.pipes[0]!==dest||1!==src.listenerCount("data")||cleanedUp||(debug("false write response, pause",src._readableState.awaitDrain),src._readableState.awaitDrain++),src.pause())}function onerror(er){debug("onerror",er),unpipe(),dest.removeListener("error",onerror),0===EElistenerCount(dest,"error")&&dest.emit("error",er)}function onclose(){dest.removeListener("finish",onfinish),unpipe()}function onfinish(){debug("onfinish"),dest.removeListener("close",onclose),unpipe()}function unpipe(){debug("unpipe"),src.unpipe(dest)}var src=this,state=this._readableState;switch(state.pipesCount){case 0:state.pipes=dest;break;case 1:state.pipes=[state.pipes,dest];break;default:state.pipes.push(dest)}state.pipesCount+=1,debug("pipe count=%d opts=%j",state.pipesCount,pipeOpts);var doEnd=(!pipeOpts||pipeOpts.end!==!1)&&dest!==process.stdout&&dest!==process.stderr,endFn=doEnd?onend:cleanup;state.endEmitted?processNextTick(endFn):src.once("end",endFn),dest.on("unpipe",onunpipe);var ondrain=pipeOnDrain(src);dest.on("drain",ondrain);var cleanedUp=!1;return src.on("data",ondata),dest._events&&dest._events.error?isArray(dest._events.error)?dest._events.error.unshift(onerror):dest._events.error=[onerror,dest._events.error]:dest.on("error",onerror),dest.once("close",onclose),dest.once("finish",onfinish),dest.emit("pipe",src),state.flowing||(debug("pipe resume"),src.resume()),dest},Readable.prototype.unpipe=function(dest){var state=this._readableState;if(0===state.pipesCount)return this;if(1===state.pipesCount)return dest&&dest!==state.pipes?this:(dest||(dest=state.pipes),state.pipes=null,state.pipesCount=0,state.flowing=!1,dest&&dest.emit("unpipe",this),this);if(!dest){var dests=state.pipes,len=state.pipesCount;state.pipes=null,state.pipesCount=0,state.flowing=!1;for(var _i=0;_i<len;_i++)dests[_i].emit("unpipe",this);return this}var i=indexOf(state.pipes,dest);return i===-1?this:(state.pipes.splice(i,1),state.pipesCount-=1,1===state.pipesCount&&(state.pipes=state.pipes[0]),dest.emit("unpipe",this),this)},Readable.prototype.on=function(ev,fn){var res=Stream.prototype.on.call(this,ev,fn);if("data"===ev&&!1!==this._readableState.flowing&&this.resume(),"readable"===ev&&!this._readableState.endEmitted){var state=this._readableState;state.readableListening||(state.readableListening=!0,state.emittedReadable=!1,state.needReadable=!0,state.reading?state.length&&emitReadable(this,state):processNextTick(nReadingNextTick,this))}return res},Readable.prototype.addListener=Readable.prototype.on,Readable.prototype.resume=function(){var state=this._readableState;return state.flowing||(debug("resume"),state.flowing=!0,resume(this,state)),this},Readable.prototype.pause=function(){return debug("call pause flowing=%j",this._readableState.flowing),!1!==this._readableState.flowing&&(debug("pause"),this._readableState.flowing=!1,this.emit("pause")),
this},Readable.prototype.wrap=function(stream){var state=this._readableState,paused=!1,self=this;stream.on("end",function(){if(debug("wrapped end"),state.decoder&&!state.ended){var chunk=state.decoder.end();chunk&&chunk.length&&self.push(chunk)}self.push(null)}),stream.on("data",function(chunk){if(debug("wrapped data"),state.decoder&&(chunk=state.decoder.write(chunk)),(!state.objectMode||null!==chunk&&void 0!==chunk)&&(state.objectMode||chunk&&chunk.length)){var ret=self.push(chunk);ret||(paused=!0,stream.pause())}});for(var i in stream)void 0===this[i]&&"function"==typeof stream[i]&&(this[i]=function(method){return function(){return stream[method].apply(stream,arguments)}}(i));var events=["error","close","destroy","pause","resume"];return forEach(events,function(ev){stream.on(ev,self.emit.bind(self,ev))}),self._read=function(n){debug("wrapped _read",n),paused&&(paused=!1,stream.resume())},self},Readable._fromList=fromList}).call(exports,__webpack_require__(59))},function(module,exports,__webpack_require__){(function(process){"use strict";function nop(){}function WriteReq(chunk,encoding,cb){this.chunk=chunk,this.encoding=encoding,this.callback=cb,this.next=null}function WritableState(options,stream){Duplex=Duplex||__webpack_require__(151),options=options||{},this.objectMode=!!options.objectMode,stream instanceof Duplex&&(this.objectMode=this.objectMode||!!options.writableObjectMode);var hwm=options.highWaterMark,defaultHwm=this.objectMode?16:16384;this.highWaterMark=hwm||0===hwm?hwm:defaultHwm,this.highWaterMark=~~this.highWaterMark,this.needDrain=!1,this.ending=!1,this.ended=!1,this.finished=!1;var noDecode=options.decodeStrings===!1;this.decodeStrings=!noDecode,this.defaultEncoding=options.defaultEncoding||"utf8",this.length=0,this.writing=!1,this.corked=0,this.sync=!0,this.bufferProcessing=!1,this.onwrite=function(er){onwrite(stream,er)},this.writecb=null,this.writelen=0,this.bufferedRequest=null,this.lastBufferedRequest=null,this.pendingcb=0,this.prefinished=!1,this.errorEmitted=!1,this.bufferedRequestCount=0,this.corkedRequestsFree=new CorkedRequest(this),this.corkedRequestsFree.next=new CorkedRequest(this)}function Writable(options){return Duplex=Duplex||__webpack_require__(151),this instanceof Writable||this instanceof Duplex?(this._writableState=new WritableState(options,this),this.writable=!0,options&&("function"==typeof options.write&&(this._write=options.write),"function"==typeof options.writev&&(this._writev=options.writev)),void Stream.call(this)):new Writable(options)}function writeAfterEnd(stream,cb){var er=new Error("write after end");stream.emit("error",er),processNextTick(cb,er)}function validChunk(stream,state,chunk,cb){var valid=!0;if(!Buffer.isBuffer(chunk)&&"string"!=typeof chunk&&null!==chunk&&void 0!==chunk&&!state.objectMode){var er=new TypeError("Invalid non-string/buffer chunk");stream.emit("error",er),processNextTick(cb,er),valid=!1}return valid}function decodeChunk(state,chunk,encoding){return state.objectMode||state.decodeStrings===!1||"string"!=typeof chunk||(chunk=new Buffer(chunk,encoding)),chunk}function writeOrBuffer(stream,state,chunk,encoding,cb){chunk=decodeChunk(state,chunk,encoding),Buffer.isBuffer(chunk)&&(encoding="buffer");var len=state.objectMode?1:chunk.length;state.length+=len;var ret=state.length<state.highWaterMark;if(ret||(state.needDrain=!0),state.writing||state.corked){var last=state.lastBufferedRequest;state.lastBufferedRequest=new WriteReq(chunk,encoding,cb),last?last.next=state.lastBufferedRequest:state.bufferedRequest=state.lastBufferedRequest,state.bufferedRequestCount+=1}else doWrite(stream,state,!1,len,chunk,encoding,cb);return ret}function doWrite(stream,state,writev,len,chunk,encoding,cb){state.writelen=len,state.writecb=cb,state.writing=!0,state.sync=!0,writev?stream._writev(chunk,state.onwrite):stream._write(chunk,encoding,state.onwrite),state.sync=!1}function onwriteError(stream,state,sync,er,cb){--state.pendingcb,sync?processNextTick(cb,er):cb(er),stream._writableState.errorEmitted=!0,stream.emit("error",er)}function onwriteStateUpdate(state){state.writing=!1,state.writecb=null,state.length-=state.writelen,state.writelen=0}function onwrite(stream,er){var state=stream._writableState,sync=state.sync,cb=state.writecb;if(onwriteStateUpdate(state),er)onwriteError(stream,state,sync,er,cb);else{var finished=needFinish(state);finished||state.corked||state.bufferProcessing||!state.bufferedRequest||clearBuffer(stream,state),sync?asyncWrite(afterWrite,stream,state,finished,cb):afterWrite(stream,state,finished,cb)}}function afterWrite(stream,state,finished,cb){finished||onwriteDrain(stream,state),state.pendingcb--,cb(),finishMaybe(stream,state)}function onwriteDrain(stream,state){0===state.length&&state.needDrain&&(state.needDrain=!1,stream.emit("drain"))}function clearBuffer(stream,state){state.bufferProcessing=!0;var entry=state.bufferedRequest;if(stream._writev&&entry&&entry.next){var l=state.bufferedRequestCount,buffer=new Array(l),holder=state.corkedRequestsFree;holder.entry=entry;for(var count=0;entry;)buffer[count]=entry,entry=entry.next,count+=1;doWrite(stream,state,!0,state.length,buffer,"",holder.finish),state.pendingcb++,state.lastBufferedRequest=null,state.corkedRequestsFree=holder.next,holder.next=null}else{for(;entry;){var chunk=entry.chunk,encoding=entry.encoding,cb=entry.callback,len=state.objectMode?1:chunk.length;if(doWrite(stream,state,!1,len,chunk,encoding,cb),entry=entry.next,state.writing)break}null===entry&&(state.lastBufferedRequest=null)}state.bufferedRequestCount=0,state.bufferedRequest=entry,state.bufferProcessing=!1}function needFinish(state){return state.ending&&0===state.length&&null===state.bufferedRequest&&!state.finished&&!state.writing}function prefinish(stream,state){state.prefinished||(state.prefinished=!0,stream.emit("prefinish"))}function finishMaybe(stream,state){var need=needFinish(state);return need&&(0===state.pendingcb?(prefinish(stream,state),state.finished=!0,stream.emit("finish")):prefinish(stream,state)),need}function endWritable(stream,state,cb){state.ending=!0,finishMaybe(stream,state),cb&&(state.finished?processNextTick(cb):stream.once("finish",cb)),state.ended=!0,stream.writable=!1}function CorkedRequest(state){var _this=this;this.next=null,this.entry=null,this.finish=function(err){var entry=_this.entry;for(_this.entry=null;entry;){var cb=entry.callback;state.pendingcb--,cb(err),entry=entry.next}state.corkedRequestsFree?state.corkedRequestsFree.next=_this:state.corkedRequestsFree=_this}}module.exports=Writable;var processNextTick=__webpack_require__(195),asyncWrite=!process.browser&&["v0.10","v0.9."].indexOf(process.version.slice(0,5))>-1?setImmediate:processNextTick,Buffer=__webpack_require__(92).Buffer;Writable.WritableState=WritableState;var util=__webpack_require__(210);util.inherits=__webpack_require__(115);var Stream,internalUtil={deprecate:__webpack_require__(206)};!function(){try{Stream=__webpack_require__(169)}catch(_){}finally{Stream||(Stream=__webpack_require__(196).EventEmitter)}}();var Buffer=__webpack_require__(92).Buffer;util.inherits(Writable,Stream);var Duplex;WritableState.prototype.getBuffer=function(){for(var current=this.bufferedRequest,out=[];current;)out.push(current),current=current.next;return out},function(){try{Object.defineProperty(WritableState.prototype,"buffer",{get:internalUtil.deprecate(function(){return this.getBuffer()},"_writableState.buffer is deprecated. Use _writableState.getBuffer instead.")})}catch(_){}}();var Duplex;Writable.prototype.pipe=function(){this.emit("error",new Error("Cannot pipe. Not readable."))},Writable.prototype.write=function(chunk,encoding,cb){var state=this._writableState,ret=!1;return"function"==typeof encoding&&(cb=encoding,encoding=null),Buffer.isBuffer(chunk)?encoding="buffer":encoding||(encoding=state.defaultEncoding),"function"!=typeof cb&&(cb=nop),state.ended?writeAfterEnd(this,cb):validChunk(this,state,chunk,cb)&&(state.pendingcb++,ret=writeOrBuffer(this,state,chunk,encoding,cb)),ret},Writable.prototype.cork=function(){var state=this._writableState;state.corked++},Writable.prototype.uncork=function(){var state=this._writableState;state.corked&&(state.corked--,state.writing||state.corked||state.finished||state.bufferProcessing||!state.bufferedRequest||clearBuffer(this,state))},Writable.prototype.setDefaultEncoding=function(encoding){if("string"==typeof encoding&&(encoding=encoding.toLowerCase()),!(["hex","utf8","utf-8","ascii","binary","base64","ucs2","ucs-2","utf16le","utf-16le","raw"].indexOf((encoding+"").toLowerCase())>-1))throw new TypeError("Unknown encoding: "+encoding);this._writableState.defaultEncoding=encoding},Writable.prototype._write=function(chunk,encoding,cb){cb(new Error("not implemented"))},Writable.prototype._writev=null,Writable.prototype.end=function(chunk,encoding,cb){var state=this._writableState;"function"==typeof chunk?(cb=chunk,chunk=null,encoding=null):"function"==typeof encoding&&(cb=encoding,encoding=null),null!==chunk&&void 0!==chunk&&this.write(chunk,encoding),state.corked&&(state.corked=1,this.uncork()),state.ending||state.finished||endWritable(this,state,cb)}}).call(exports,__webpack_require__(59))},function(module,exports,__webpack_require__){"use strict";function Duplex(options){return this instanceof Duplex?(Readable.call(this,options),Writable.call(this,options),options&&options.readable===!1&&(this.readable=!1),options&&options.writable===!1&&(this.writable=!1),this.allowHalfOpen=!0,options&&options.allowHalfOpen===!1&&(this.allowHalfOpen=!1),void this.once("end",onend)):new Duplex(options)}function onend(){this.allowHalfOpen||this._writableState.ended||processNextTick(onEndNT,this)}function onEndNT(self){self.end()}var objectKeys=Object.keys||function(obj){var keys=[];for(var key in obj)keys.push(key);return keys};module.exports=Duplex;var processNextTick=__webpack_require__(195),util=__webpack_require__(210);util.inherits=__webpack_require__(115);var Readable=__webpack_require__(149),Writable=__webpack_require__(150);util.inherits(Duplex,Readable);for(var keys=objectKeys(Writable.prototype),v=0;v<keys.length;v++){var method=keys[v];Duplex.prototype[method]||(Duplex.prototype[method]=Writable.prototype[method])}},function(module,exports,__webpack_require__){"use strict";function TransformState(stream){this.afterTransform=function(er,data){return afterTransform(stream,er,data)},this.needTransform=!1,this.transforming=!1,this.writecb=null,this.writechunk=null,this.writeencoding=null}function afterTransform(stream,er,data){var ts=stream._transformState;ts.transforming=!1;var cb=ts.writecb;if(!cb)return stream.emit("error",new Error("no writecb in Transform class"));ts.writechunk=null,ts.writecb=null,null!==data&&void 0!==data&&stream.push(data),cb(er);var rs=stream._readableState;rs.reading=!1,(rs.needReadable||rs.length<rs.highWaterMark)&&stream._read(rs.highWaterMark)}function Transform(options){if(!(this instanceof Transform))return new Transform(options);Duplex.call(this,options),this._transformState=new TransformState(this);var stream=this;this._readableState.needReadable=!0,this._readableState.sync=!1,options&&("function"==typeof options.transform&&(this._transform=options.transform),"function"==typeof options.flush&&(this._flush=options.flush)),this.once("prefinish",function(){"function"==typeof this._flush?this._flush(function(er){done(stream,er)}):done(stream)})}function done(stream,er){if(er)return stream.emit("error",er);var ws=stream._writableState,ts=stream._transformState;if(ws.length)throw new Error("calling transform done when ws.length != 0");if(ts.transforming)throw new Error("calling transform done when still transforming");return stream.push(null)}module.exports=Transform;var Duplex=__webpack_require__(151),util=__webpack_require__(210);util.inherits=__webpack_require__(115),util.inherits(Transform,Duplex),Transform.prototype.push=function(chunk,encoding){return this._transformState.needTransform=!1,Duplex.prototype.push.call(this,chunk,encoding)},Transform.prototype._transform=function(chunk,encoding,cb){throw new Error("not implemented")},Transform.prototype._write=function(chunk,encoding,cb){var ts=this._transformState;if(ts.writecb=cb,ts.writechunk=chunk,ts.writeencoding=encoding,!ts.transforming){var rs=this._readableState;(ts.needTransform||rs.needReadable||rs.length<rs.highWaterMark)&&this._read(rs.highWaterMark)}},Transform.prototype._read=function(n){var ts=this._transformState;null!==ts.writechunk&&ts.writecb&&!ts.transforming?(ts.transforming=!0,this._transform(ts.writechunk,ts.writeencoding,ts.afterTransform)):ts.needTransform=!0}},function(module,exports,__webpack_require__){"use strict";function PassThrough(options){return this instanceof PassThrough?void Transform.call(this,options):new PassThrough(options)}module.exports=PassThrough;var Transform=__webpack_require__(152),util=__webpack_require__(210);util.inherits=__webpack_require__(115),util.inherits(PassThrough,Transform),PassThrough.prototype._transform=function(chunk,encoding,cb){cb(null,chunk)}},function(module,exports,__webpack_require__){"use strict";module.exports=__webpack_require__(184),__webpack_require__(185),__webpack_require__(186),__webpack_require__(187),__webpack_require__(188),__webpack_require__(189)},function(module,exports,__webpack_require__){"use strict";function resolveYamlTimestamp(data){if(null===data)return!1;var match;return match=YAML_TIMESTAMP_REGEXP.exec(data),null!==match}function constructYamlTimestamp(data){var match,year,month,day,hour,minute,second,tz_hour,tz_minute,date,fraction=0,delta=null;if(match=YAML_TIMESTAMP_REGEXP.exec(data),null===match)throw new Error("Date resolve error");if(year=+match[1],month=+match[2]-1,day=+match[3],!match[4])return new Date(Date.UTC(year,month,day));if(hour=+match[4],minute=+match[5],second=+match[6],match[7]){for(fraction=match[7].slice(0,3);fraction.length<3;)fraction+="0";fraction=+fraction}return match[9]&&(tz_hour=+match[10],tz_minute=+(match[11]||0),delta=6e4*(60*tz_hour+tz_minute),"-"===match[9]&&(delta=-delta)),date=new Date(Date.UTC(year,month,day,hour,minute,second,fraction)),delta&&date.setTime(date.getTime()-delta),date}function representYamlTimestamp(object){return object.toISOString()}var Type=__webpack_require__(179),YAML_TIMESTAMP_REGEXP=new RegExp("^([0-9][0-9][0-9][0-9])-([0-9][0-9]?)-([0-9][0-9]?)(?:(?:[Tt]|[ \\t]+)([0-9][0-9]?):([0-9][0-9]):([0-9][0-9])(?:\\.([0-9]*))?(?:[ \\t]*(Z|([-+])([0-9][0-9]?)(?::([0-9][0-9]))?))?)?$");module.exports=new Type("tag:yaml.org,2002:timestamp",{kind:"scalar",resolve:resolveYamlTimestamp,construct:constructYamlTimestamp,instanceOf:Date,represent:representYamlTimestamp})},function(module,exports,__webpack_require__){"use strict";function resolveYamlMerge(data){return"<<"===data||null===data}var Type=__webpack_require__(179);module.exports=new Type("tag:yaml.org,2002:merge",{kind:"scalar",resolve:resolveYamlMerge})},function(module,exports,__webpack_require__){"use strict";function resolveYamlBinary(data){if(null===data)return!1;var code,idx,bitlen=0,max=data.length,map=BASE64_MAP;for(idx=0;idx<max;idx++)if(code=map.indexOf(data.charAt(idx)),!(code>64)){if(code<0)return!1;bitlen+=6}return bitlen%8===0}function constructYamlBinary(data){var idx,tailbits,input=data.replace(/[\r\n=]/g,""),max=input.length,map=BASE64_MAP,bits=0,result=[];for(idx=0;idx<max;idx++)idx%4===0&&idx&&(result.push(bits>>16&255),result.push(bits>>8&255),result.push(255&bits)),bits=bits<<6|map.indexOf(input.charAt(idx));return tailbits=max%4*6,0===tailbits?(result.push(bits>>16&255),result.push(bits>>8&255),result.push(255&bits)):18===tailbits?(result.push(bits>>10&255),result.push(bits>>2&255)):12===tailbits&&result.push(bits>>4&255),NodeBuffer?new NodeBuffer(result):result}function representYamlBinary(object){var idx,tail,result="",bits=0,max=object.length,map=BASE64_MAP;for(idx=0;idx<max;idx++)idx%3===0&&idx&&(result+=map[bits>>18&63],result+=map[bits>>12&63],result+=map[bits>>6&63],result+=map[63&bits]),bits=(bits<<8)+object[idx];return tail=max%3,0===tail?(result+=map[bits>>18&63],result+=map[bits>>12&63],result+=map[bits>>6&63],result+=map[63&bits]):2===tail?(result+=map[bits>>10&63],result+=map[bits>>4&63],result+=map[bits<<2&63],result+=map[64]):1===tail&&(result+=map[bits>>2&63],result+=map[bits<<4&63],result+=map[64],result+=map[64]),result}function isBinary(object){return NodeBuffer&&NodeBuffer.isBuffer(object)}var NodeBuffer=__webpack_require__(92).Buffer,Type=__webpack_require__(179),BASE64_MAP="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=\n\r";module.exports=new Type("tag:yaml.org,2002:binary",{kind:"scalar",resolve:resolveYamlBinary,construct:constructYamlBinary,predicate:isBinary,represent:representYamlBinary})},function(module,exports,__webpack_require__){"use strict";function resolveYamlOmap(data){if(null===data)return!0;var index,length,pair,pairKey,pairHasKey,objectKeys=[],object=data;for(index=0,length=object.length;index<length;index+=1){if(pair=object[index],pairHasKey=!1,"[object Object]"!==_toString.call(pair))return!1;for(pairKey in pair)if(_hasOwnProperty.call(pair,pairKey)){if(pairHasKey)return!1;pairHasKey=!0}if(!pairHasKey)return!1;if(-1!==objectKeys.indexOf(pairKey))return!1;objectKeys.push(pairKey)}return!0}function constructYamlOmap(data){return null!==data?data:[]}var Type=__webpack_require__(179),_hasOwnProperty=Object.prototype.hasOwnProperty,_toString=Object.prototype.toString;module.exports=new Type("tag:yaml.org,2002:omap",{kind:"sequence",resolve:resolveYamlOmap,construct:constructYamlOmap})},function(module,exports,__webpack_require__){"use strict";function resolveYamlPairs(data){if(null===data)return!0;var index,length,pair,keys,result,object=data;for(result=new Array(object.length),index=0,length=object.length;index<length;index+=1){if(pair=object[index],"[object Object]"!==_toString.call(pair))return!1;if(keys=Object.keys(pair),1!==keys.length)return!1;result[index]=[keys[0],pair[keys[0]]]}return!0}function constructYamlPairs(data){if(null===data)return[];var index,length,pair,keys,result,object=data;for(result=new Array(object.length),index=0,length=object.length;index<length;index+=1)pair=object[index],keys=Object.keys(pair),result[index]=[keys[0],pair[keys[0]]];return result}var Type=__webpack_require__(179),_toString=Object.prototype.toString;module.exports=new Type("tag:yaml.org,2002:pairs",{kind:"sequence",resolve:resolveYamlPairs,construct:constructYamlPairs})},function(module,exports,__webpack_require__){"use strict";function resolveYamlSet(data){if(null===data)return!0;var key,object=data;for(key in object)if(_hasOwnProperty.call(object,key)&&null!==object[key])return!1;return!0}function constructYamlSet(data){return null!==data?data:{}}var Type=__webpack_require__(179),_hasOwnProperty=Object.prototype.hasOwnProperty;module.exports=new Type("tag:yaml.org,2002:set",{kind:"mapping",resolve:resolveYamlSet,construct:constructYamlSet})},function(module,exports,__webpack_require__){"use strict";function resolveJavascriptUndefined(){return!0}function constructJavascriptUndefined(){}function representJavascriptUndefined(){return""}function isUndefined(object){return"undefined"==typeof object}var Type=__webpack_require__(179);module.exports=new Type("tag:yaml.org,2002:js/undefined",{kind:"scalar",resolve:resolveJavascriptUndefined,construct:constructJavascriptUndefined,predicate:isUndefined,represent:representJavascriptUndefined})},function(module,exports,__webpack_require__){"use strict";function resolveJavascriptRegExp(data){if(null===data)return!1;if(0===data.length)return!1;var regexp=data,tail=/\/([gim]*)$/.exec(data),modifiers="";if("/"===regexp[0]){if(tail&&(modifiers=tail[1]),modifiers.length>3)return!1;if("/"!==regexp[regexp.length-modifiers.length-1])return!1;regexp=regexp.slice(1,regexp.length-modifiers.length-1)}try{new RegExp(regexp,modifiers);return!0}catch(error){return!1}}function constructJavascriptRegExp(data){var regexp=data,tail=/\/([gim]*)$/.exec(data),modifiers="";return"/"===regexp[0]&&(tail&&(modifiers=tail[1]),regexp=regexp.slice(1,regexp.length-modifiers.length-1)),new RegExp(regexp,modifiers)}function representJavascriptRegExp(object){var result="/"+object.source+"/";return object.global&&(result+="g"),object.multiline&&(result+="m"),object.ignoreCase&&(result+="i"),result}function isRegExp(object){return"[object RegExp]"===Object.prototype.toString.call(object)}var Type=__webpack_require__(179);module.exports=new Type("tag:yaml.org,2002:js/regexp",{kind:"scalar",resolve:resolveJavascriptRegExp,construct:constructJavascriptRegExp,predicate:isRegExp,represent:representJavascriptRegExp})},function(module,exports,__webpack_require__){module.exports=/[^\u0041-\u005A\u0061-\u007A\u00AA\u00B5\u00BA\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u0527\u0531-\u0556\u0559\u0561-\u0587\u05D0-\u05EA\u05F0-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u08A0\u08A2-\u08AC\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0977\u0979-\u097F\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C33\u0C35-\u0C39\u0C3D\u0C58\u0C59\u0C60\u0C61\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D60\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F4\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1877\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191C\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19C1-\u19C7\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1CE9-\u1CEC\u1CEE-\u1CF1\u1CF5\u1CF6\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2183\u2184\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005\u3006\u3031-\u3035\u303B\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FCC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA697\uA6A0-\uA6E5\uA717-\uA71F\uA722-\uA788\uA78B-\uA78E\uA790-\uA793\uA7A0-\uA7AA\uA7F8-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA80-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uABC0-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC\u0030-\u0039\u00B2\u00B3\u00B9\u00BC-\u00BE\u0660-\u0669\u06F0-\u06F9\u07C0-\u07C9\u0966-\u096F\u09E6-\u09EF\u09F4-\u09F9\u0A66-\u0A6F\u0AE6-\u0AEF\u0B66-\u0B6F\u0B72-\u0B77\u0BE6-\u0BF2\u0C66-\u0C6F\u0C78-\u0C7E\u0CE6-\u0CEF\u0D66-\u0D75\u0E50-\u0E59\u0ED0-\u0ED9\u0F20-\u0F33\u1040-\u1049\u1090-\u1099\u1369-\u137C\u16EE-\u16F0\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1946-\u194F\u19D0-\u19DA\u1A80-\u1A89\u1A90-\u1A99\u1B50-\u1B59\u1BB0-\u1BB9\u1C40-\u1C49\u1C50-\u1C59\u2070\u2074-\u2079\u2080-\u2089\u2150-\u2182\u2185-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2CFD\u3007\u3021-\u3029\u3038-\u303A\u3192-\u3195\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\uA620-\uA629\uA6E6-\uA6EF\uA830-\uA835\uA8D0-\uA8D9\uA900-\uA909\uA9D0-\uA9D9\uAA50-\uAA59\uABF0-\uABF9\uFF10-\uFF19]+/g},function(module,exports,__webpack_require__){module.exports=/([\u0061-\u007A\u00B5\u00DF-\u00F6\u00F8-\u00FF\u0101\u0103\u0105\u0107\u0109\u010B\u010D\u010F\u0111\u0113\u0115\u0117\u0119\u011B\u011D\u011F\u0121\u0123\u0125\u0127\u0129\u012B\u012D\u012F\u0131\u0133\u0135\u0137\u0138\u013A\u013C\u013E\u0140\u0142\u0144\u0146\u0148\u0149\u014B\u014D\u014F\u0151\u0153\u0155\u0157\u0159\u015B\u015D\u015F\u0161\u0163\u0165\u0167\u0169\u016B\u016D\u016F\u0171\u0173\u0175\u0177\u017A\u017C\u017E-\u0180\u0183\u0185\u0188\u018C\u018D\u0192\u0195\u0199-\u019B\u019E\u01A1\u01A3\u01A5\u01A8\u01AA\u01AB\u01AD\u01B0\u01B4\u01B6\u01B9\u01BA\u01BD-\u01BF\u01C6\u01C9\u01CC\u01CE\u01D0\u01D2\u01D4\u01D6\u01D8\u01DA\u01DC\u01DD\u01DF\u01E1\u01E3\u01E5\u01E7\u01E9\u01EB\u01ED\u01EF\u01F0\u01F3\u01F5\u01F9\u01FB\u01FD\u01FF\u0201\u0203\u0205\u0207\u0209\u020B\u020D\u020F\u0211\u0213\u0215\u0217\u0219\u021B\u021D\u021F\u0221\u0223\u0225\u0227\u0229\u022B\u022D\u022F\u0231\u0233-\u0239\u023C\u023F\u0240\u0242\u0247\u0249\u024B\u024D\u024F-\u0293\u0295-\u02AF\u0371\u0373\u0377\u037B-\u037D\u0390\u03AC-\u03CE\u03D0\u03D1\u03D5-\u03D7\u03D9\u03DB\u03DD\u03DF\u03E1\u03E3\u03E5\u03E7\u03E9\u03EB\u03ED\u03EF-\u03F3\u03F5\u03F8\u03FB\u03FC\u0430-\u045F\u0461\u0463\u0465\u0467\u0469\u046B\u046D\u046F\u0471\u0473\u0475\u0477\u0479\u047B\u047D\u047F\u0481\u048B\u048D\u048F\u0491\u0493\u0495\u0497\u0499\u049B\u049D\u049F\u04A1\u04A3\u04A5\u04A7\u04A9\u04AB\u04AD\u04AF\u04B1\u04B3\u04B5\u04B7\u04B9\u04BB\u04BD\u04BF\u04C2\u04C4\u04C6\u04C8\u04CA\u04CC\u04CE\u04CF\u04D1\u04D3\u04D5\u04D7\u04D9\u04DB\u04DD\u04DF\u04E1\u04E3\u04E5\u04E7\u04E9\u04EB\u04ED\u04EF\u04F1\u04F3\u04F5\u04F7\u04F9\u04FB\u04FD\u04FF\u0501\u0503\u0505\u0507\u0509\u050B\u050D\u050F\u0511\u0513\u0515\u0517\u0519\u051B\u051D\u051F\u0521\u0523\u0525\u0527\u0561-\u0587\u1D00-\u1D2B\u1D6B-\u1D77\u1D79-\u1D9A\u1E01\u1E03\u1E05\u1E07\u1E09\u1E0B\u1E0D\u1E0F\u1E11\u1E13\u1E15\u1E17\u1E19\u1E1B\u1E1D\u1E1F\u1E21\u1E23\u1E25\u1E27\u1E29\u1E2B\u1E2D\u1E2F\u1E31\u1E33\u1E35\u1E37\u1E39\u1E3B\u1E3D\u1E3F\u1E41\u1E43\u1E45\u1E47\u1E49\u1E4B\u1E4D\u1E4F\u1E51\u1E53\u1E55\u1E57\u1E59\u1E5B\u1E5D\u1E5F\u1E61\u1E63\u1E65\u1E67\u1E69\u1E6B\u1E6D\u1E6F\u1E71\u1E73\u1E75\u1E77\u1E79\u1E7B\u1E7D\u1E7F\u1E81\u1E83\u1E85\u1E87\u1E89\u1E8B\u1E8D\u1E8F\u1E91\u1E93\u1E95-\u1E9D\u1E9F\u1EA1\u1EA3\u1EA5\u1EA7\u1EA9\u1EAB\u1EAD\u1EAF\u1EB1\u1EB3\u1EB5\u1EB7\u1EB9\u1EBB\u1EBD\u1EBF\u1EC1\u1EC3\u1EC5\u1EC7\u1EC9\u1ECB\u1ECD\u1ECF\u1ED1\u1ED3\u1ED5\u1ED7\u1ED9\u1EDB\u1EDD\u1EDF\u1EE1\u1EE3\u1EE5\u1EE7\u1EE9\u1EEB\u1EED\u1EEF\u1EF1\u1EF3\u1EF5\u1EF7\u1EF9\u1EFB\u1EFD\u1EFF-\u1F07\u1F10-\u1F15\u1F20-\u1F27\u1F30-\u1F37\u1F40-\u1F45\u1F50-\u1F57\u1F60-\u1F67\u1F70-\u1F7D\u1F80-\u1F87\u1F90-\u1F97\u1FA0-\u1FA7\u1FB0-\u1FB4\u1FB6\u1FB7\u1FBE\u1FC2-\u1FC4\u1FC6\u1FC7\u1FD0-\u1FD3\u1FD6\u1FD7\u1FE0-\u1FE7\u1FF2-\u1FF4\u1FF6\u1FF7\u210A\u210E\u210F\u2113\u212F\u2134\u2139\u213C\u213D\u2146-\u2149\u214E\u2184\u2C30-\u2C5E\u2C61\u2C65\u2C66\u2C68\u2C6A\u2C6C\u2C71\u2C73\u2C74\u2C76-\u2C7B\u2C81\u2C83\u2C85\u2C87\u2C89\u2C8B\u2C8D\u2C8F\u2C91\u2C93\u2C95\u2C97\u2C99\u2C9B\u2C9D\u2C9F\u2CA1\u2CA3\u2CA5\u2CA7\u2CA9\u2CAB\u2CAD\u2CAF\u2CB1\u2CB3\u2CB5\u2CB7\u2CB9\u2CBB\u2CBD\u2CBF\u2CC1\u2CC3\u2CC5\u2CC7\u2CC9\u2CCB\u2CCD\u2CCF\u2CD1\u2CD3\u2CD5\u2CD7\u2CD9\u2CDB\u2CDD\u2CDF\u2CE1\u2CE3\u2CE4\u2CEC\u2CEE\u2CF3\u2D00-\u2D25\u2D27\u2D2D\uA641\uA643\uA645\uA647\uA649\uA64B\uA64D\uA64F\uA651\uA653\uA655\uA657\uA659\uA65B\uA65D\uA65F\uA661\uA663\uA665\uA667\uA669\uA66B\uA66D\uA681\uA683\uA685\uA687\uA689\uA68B\uA68D\uA68F\uA691\uA693\uA695\uA697\uA723\uA725\uA727\uA729\uA72B\uA72D\uA72F-\uA731\uA733\uA735\uA737\uA739\uA73B\uA73D\uA73F\uA741\uA743\uA745\uA747\uA749\uA74B\uA74D\uA74F\uA751\uA753\uA755\uA757\uA759\uA75B\uA75D\uA75F\uA761\uA763\uA765\uA767\uA769\uA76B\uA76D\uA76F\uA771-\uA778\uA77A\uA77C\uA77F\uA781\uA783\uA785\uA787\uA78C\uA78E\uA791\uA793\uA7A1\uA7A3\uA7A5\uA7A7\uA7A9\uA7FA\uFB00-\uFB06\uFB13-\uFB17\uFF41-\uFF5A])([\u0041-\u005A\u00C0-\u00D6\u00D8-\u00DE\u0100\u0102\u0104\u0106\u0108\u010A\u010C\u010E\u0110\u0112\u0114\u0116\u0118\u011A\u011C\u011E\u0120\u0122\u0124\u0126\u0128\u012A\u012C\u012E\u0130\u0132\u0134\u0136\u0139\u013B\u013D\u013F\u0141\u0143\u0145\u0147\u014A\u014C\u014E\u0150\u0152\u0154\u0156\u0158\u015A\u015C\u015E\u0160\u0162\u0164\u0166\u0168\u016A\u016C\u016E\u0170\u0172\u0174\u0176\u0178\u0179\u017B\u017D\u0181\u0182\u0184\u0186\u0187\u0189-\u018B\u018E-\u0191\u0193\u0194\u0196-\u0198\u019C\u019D\u019F\u01A0\u01A2\u01A4\u01A6\u01A7\u01A9\u01AC\u01AE\u01AF\u01B1-\u01B3\u01B5\u01B7\u01B8\u01BC\u01C4\u01C7\u01CA\u01CD\u01CF\u01D1\u01D3\u01D5\u01D7\u01D9\u01DB\u01DE\u01E0\u01E2\u01E4\u01E6\u01E8\u01EA\u01EC\u01EE\u01F1\u01F4\u01F6-\u01F8\u01FA\u01FC\u01FE\u0200\u0202\u0204\u0206\u0208\u020A\u020C\u020E\u0210\u0212\u0214\u0216\u0218\u021A\u021C\u021E\u0220\u0222\u0224\u0226\u0228\u022A\u022C\u022E\u0230\u0232\u023A\u023B\u023D\u023E\u0241\u0243-\u0246\u0248\u024A\u024C\u024E\u0370\u0372\u0376\u0386\u0388-\u038A\u038C\u038E\u038F\u0391-\u03A1\u03A3-\u03AB\u03CF\u03D2-\u03D4\u03D8\u03DA\u03DC\u03DE\u03E0\u03E2\u03E4\u03E6\u03E8\u03EA\u03EC\u03EE\u03F4\u03F7\u03F9\u03FA\u03FD-\u042F\u0460\u0462\u0464\u0466\u0468\u046A\u046C\u046E\u0470\u0472\u0474\u0476\u0478\u047A\u047C\u047E\u0480\u048A\u048C\u048E\u0490\u0492\u0494\u0496\u0498\u049A\u049C\u049E\u04A0\u04A2\u04A4\u04A6\u04A8\u04AA\u04AC\u04AE\u04B0\u04B2\u04B4\u04B6\u04B8\u04BA\u04BC\u04BE\u04C0\u04C1\u04C3\u04C5\u04C7\u04C9\u04CB\u04CD\u04D0\u04D2\u04D4\u04D6\u04D8\u04DA\u04DC\u04DE\u04E0\u04E2\u04E4\u04E6\u04E8\u04EA\u04EC\u04EE\u04F0\u04F2\u04F4\u04F6\u04F8\u04FA\u04FC\u04FE\u0500\u0502\u0504\u0506\u0508\u050A\u050C\u050E\u0510\u0512\u0514\u0516\u0518\u051A\u051C\u051E\u0520\u0522\u0524\u0526\u0531-\u0556\u10A0-\u10C5\u10C7\u10CD\u1E00\u1E02\u1E04\u1E06\u1E08\u1E0A\u1E0C\u1E0E\u1E10\u1E12\u1E14\u1E16\u1E18\u1E1A\u1E1C\u1E1E\u1E20\u1E22\u1E24\u1E26\u1E28\u1E2A\u1E2C\u1E2E\u1E30\u1E32\u1E34\u1E36\u1E38\u1E3A\u1E3C\u1E3E\u1E40\u1E42\u1E44\u1E46\u1E48\u1E4A\u1E4C\u1E4E\u1E50\u1E52\u1E54\u1E56\u1E58\u1E5A\u1E5C\u1E5E\u1E60\u1E62\u1E64\u1E66\u1E68\u1E6A\u1E6C\u1E6E\u1E70\u1E72\u1E74\u1E76\u1E78\u1E7A\u1E7C\u1E7E\u1E80\u1E82\u1E84\u1E86\u1E88\u1E8A\u1E8C\u1E8E\u1E90\u1E92\u1E94\u1E9E\u1EA0\u1EA2\u1EA4\u1EA6\u1EA8\u1EAA\u1EAC\u1EAE\u1EB0\u1EB2\u1EB4\u1EB6\u1EB8\u1EBA\u1EBC\u1EBE\u1EC0\u1EC2\u1EC4\u1EC6\u1EC8\u1ECA\u1ECC\u1ECE\u1ED0\u1ED2\u1ED4\u1ED6\u1ED8\u1EDA\u1EDC\u1EDE\u1EE0\u1EE2\u1EE4\u1EE6\u1EE8\u1EEA\u1EEC\u1EEE\u1EF0\u1EF2\u1EF4\u1EF6\u1EF8\u1EFA\u1EFC\u1EFE\u1F08-\u1F0F\u1F18-\u1F1D\u1F28-\u1F2F\u1F38-\u1F3F\u1F48-\u1F4D\u1F59\u1F5B\u1F5D\u1F5F\u1F68-\u1F6F\u1FB8-\u1FBB\u1FC8-\u1FCB\u1FD8-\u1FDB\u1FE8-\u1FEC\u1FF8-\u1FFB\u2102\u2107\u210B-\u210D\u2110-\u2112\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u2130-\u2133\u213E\u213F\u2145\u2183\u2C00-\u2C2E\u2C60\u2C62-\u2C64\u2C67\u2C69\u2C6B\u2C6D-\u2C70\u2C72\u2C75\u2C7E-\u2C80\u2C82\u2C84\u2C86\u2C88\u2C8A\u2C8C\u2C8E\u2C90\u2C92\u2C94\u2C96\u2C98\u2C9A\u2C9C\u2C9E\u2CA0\u2CA2\u2CA4\u2CA6\u2CA8\u2CAA\u2CAC\u2CAE\u2CB0\u2CB2\u2CB4\u2CB6\u2CB8\u2CBA\u2CBC\u2CBE\u2CC0\u2CC2\u2CC4\u2CC6\u2CC8\u2CCA\u2CCC\u2CCE\u2CD0\u2CD2\u2CD4\u2CD6\u2CD8\u2CDA\u2CDC\u2CDE\u2CE0\u2CE2\u2CEB\u2CED\u2CF2\uA640\uA642\uA644\uA646\uA648\uA64A\uA64C\uA64E\uA650\uA652\uA654\uA656\uA658\uA65A\uA65C\uA65E\uA660\uA662\uA664\uA666\uA668\uA66A\uA66C\uA680\uA682\uA684\uA686\uA688\uA68A\uA68C\uA68E\uA690\uA692\uA694\uA696\uA722\uA724\uA726\uA728\uA72A\uA72C\uA72E\uA732\uA734\uA736\uA738\uA73A\uA73C\uA73E\uA740\uA742\uA744\uA746\uA748\uA74A\uA74C\uA74E\uA750\uA752\uA754\uA756\uA758\uA75A\uA75C\uA75E\uA760\uA762\uA764\uA766\uA768\uA76A\uA76C\uA76E\uA779\uA77B\uA77D\uA77E\uA780\uA782\uA784\uA786\uA78B\uA78D\uA790\uA792\uA7A0\uA7A2\uA7A4\uA7A6\uA7A8\uA7AA\uFF21-\uFF3A\u0030-\u0039\u00B2\u00B3\u00B9\u00BC-\u00BE\u0660-\u0669\u06F0-\u06F9\u07C0-\u07C9\u0966-\u096F\u09E6-\u09EF\u09F4-\u09F9\u0A66-\u0A6F\u0AE6-\u0AEF\u0B66-\u0B6F\u0B72-\u0B77\u0BE6-\u0BF2\u0C66-\u0C6F\u0C78-\u0C7E\u0CE6-\u0CEF\u0D66-\u0D75\u0E50-\u0E59\u0ED0-\u0ED9\u0F20-\u0F33\u1040-\u1049\u1090-\u1099\u1369-\u137C\u16EE-\u16F0\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1946-\u194F\u19D0-\u19DA\u1A80-\u1A89\u1A90-\u1A99\u1B50-\u1B59\u1BB0-\u1BB9\u1C40-\u1C49\u1C50-\u1C59\u2070\u2074-\u2079\u2080-\u2089\u2150-\u2182\u2185-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2CFD\u3007\u3021-\u3029\u3038-\u303A\u3192-\u3195\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\uA620-\uA629\uA6E6-\uA6EF\uA830-\uA835\uA8D0-\uA8D9\uA900-\uA909\uA9D0-\uA9D9\uAA50-\uAA59\uABF0-\uABF9\uFF10-\uFF19])/g;
},function(module,exports,__webpack_require__){module.exports=/([\u0030-\u0039\u00B2\u00B3\u00B9\u00BC-\u00BE\u0660-\u0669\u06F0-\u06F9\u07C0-\u07C9\u0966-\u096F\u09E6-\u09EF\u09F4-\u09F9\u0A66-\u0A6F\u0AE6-\u0AEF\u0B66-\u0B6F\u0B72-\u0B77\u0BE6-\u0BF2\u0C66-\u0C6F\u0C78-\u0C7E\u0CE6-\u0CEF\u0D66-\u0D75\u0E50-\u0E59\u0ED0-\u0ED9\u0F20-\u0F33\u1040-\u1049\u1090-\u1099\u1369-\u137C\u16EE-\u16F0\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1946-\u194F\u19D0-\u19DA\u1A80-\u1A89\u1A90-\u1A99\u1B50-\u1B59\u1BB0-\u1BB9\u1C40-\u1C49\u1C50-\u1C59\u2070\u2074-\u2079\u2080-\u2089\u2150-\u2182\u2185-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2CFD\u3007\u3021-\u3029\u3038-\u303A\u3192-\u3195\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\uA620-\uA629\uA6E6-\uA6EF\uA830-\uA835\uA8D0-\uA8D9\uA900-\uA909\uA9D0-\uA9D9\uAA50-\uAA59\uABF0-\uABF9\uFF10-\uFF19])([^\u0030-\u0039\u00B2\u00B3\u00B9\u00BC-\u00BE\u0660-\u0669\u06F0-\u06F9\u07C0-\u07C9\u0966-\u096F\u09E6-\u09EF\u09F4-\u09F9\u0A66-\u0A6F\u0AE6-\u0AEF\u0B66-\u0B6F\u0B72-\u0B77\u0BE6-\u0BF2\u0C66-\u0C6F\u0C78-\u0C7E\u0CE6-\u0CEF\u0D66-\u0D75\u0E50-\u0E59\u0ED0-\u0ED9\u0F20-\u0F33\u1040-\u1049\u1090-\u1099\u1369-\u137C\u16EE-\u16F0\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1946-\u194F\u19D0-\u19DA\u1A80-\u1A89\u1A90-\u1A99\u1B50-\u1B59\u1BB0-\u1BB9\u1C40-\u1C49\u1C50-\u1C59\u2070\u2074-\u2079\u2080-\u2089\u2150-\u2182\u2185-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2CFD\u3007\u3021-\u3029\u3038-\u303A\u3192-\u3195\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\uA620-\uA629\uA6E6-\uA6EF\uA830-\uA835\uA8D0-\uA8D9\uA900-\uA909\uA9D0-\uA9D9\uAA50-\uAA59\uABF0-\uABF9\uFF10-\uFF19])/g},function(module,exports,__webpack_require__){"use strict";var Stringify=__webpack_require__(191),Parse=__webpack_require__(192);module.exports={stringify:Stringify,parse:Parse}},function(module,exports,__webpack_require__){exports.read=function(buffer,offset,isLE,mLen,nBytes){var e,m,eLen=8*nBytes-mLen-1,eMax=(1<<eLen)-1,eBias=eMax>>1,nBits=-7,i=isLE?nBytes-1:0,d=isLE?-1:1,s=buffer[offset+i];for(i+=d,e=s&(1<<-nBits)-1,s>>=-nBits,nBits+=eLen;nBits>0;e=256*e+buffer[offset+i],i+=d,nBits-=8);for(m=e&(1<<-nBits)-1,e>>=-nBits,nBits+=mLen;nBits>0;m=256*m+buffer[offset+i],i+=d,nBits-=8);if(0===e)e=1-eBias;else{if(e===eMax)return m?NaN:(s?-1:1)*(1/0);m+=Math.pow(2,mLen),e-=eBias}return(s?-1:1)*m*Math.pow(2,e-mLen)},exports.write=function(buffer,value,offset,isLE,mLen,nBytes){var e,m,c,eLen=8*nBytes-mLen-1,eMax=(1<<eLen)-1,eBias=eMax>>1,rt=23===mLen?Math.pow(2,-24)-Math.pow(2,-77):0,i=isLE?0:nBytes-1,d=isLE?1:-1,s=value<0||0===value&&1/value<0?1:0;for(value=Math.abs(value),isNaN(value)||value===1/0?(m=isNaN(value)?1:0,e=eMax):(e=Math.floor(Math.log(value)/Math.LN2),value*(c=Math.pow(2,-e))<1&&(e--,c*=2),value+=e+eBias>=1?rt/c:rt*Math.pow(2,1-eBias),value*c>=2&&(e++,c/=2),e+eBias>=eMax?(m=0,e=eMax):e+eBias>=1?(m=(value*c-1)*Math.pow(2,mLen),e+=eBias):(m=value*Math.pow(2,eBias-1)*Math.pow(2,mLen),e=0));mLen>=8;buffer[offset+i]=255&m,i+=d,m/=256,mLen-=8);for(e=e<<mLen|m,eLen+=mLen;eLen>0;buffer[offset+i]=255&e,i+=d,e/=256,eLen-=8);buffer[offset+i-d]|=128*s}},function(module,exports,__webpack_require__){var toString={}.toString;module.exports=Array.isArray||function(arr){return"[object Array]"==toString.call(arr)}},function(module,exports,__webpack_require__){function Stream(){EE.call(this)}module.exports=Stream;var EE=__webpack_require__(196).EventEmitter,inherits=__webpack_require__(225);inherits(Stream,EE),Stream.Readable=__webpack_require__(220),Stream.Writable=__webpack_require__(221),Stream.Duplex=__webpack_require__(222),Stream.Transform=__webpack_require__(223),Stream.PassThrough=__webpack_require__(224),Stream.Stream=Stream,Stream.prototype.pipe=function(dest,options){function ondata(chunk){dest.writable&&!1===dest.write(chunk)&&source.pause&&source.pause()}function ondrain(){source.readable&&source.resume&&source.resume()}function onend(){didOnEnd||(didOnEnd=!0,dest.end())}function onclose(){didOnEnd||(didOnEnd=!0,"function"==typeof dest.destroy&&dest.destroy())}function onerror(er){if(cleanup(),0===EE.listenerCount(this,"error"))throw er}function cleanup(){source.removeListener("data",ondata),dest.removeListener("drain",ondrain),source.removeListener("end",onend),source.removeListener("close",onclose),source.removeListener("error",onerror),dest.removeListener("error",onerror),source.removeListener("end",cleanup),source.removeListener("close",cleanup),dest.removeListener("close",cleanup)}var source=this;source.on("data",ondata),dest.on("drain",ondrain),dest._isStdio||options&&options.end===!1||(source.on("end",onend),source.on("close",onclose));var didOnEnd=!1;return source.on("error",onerror),dest.on("error",onerror),source.on("end",cleanup),source.on("close",cleanup),dest.on("close",cleanup),dest.emit("pipe",source),dest}},function(module,exports,__webpack_require__){(function(process,__filename,global,__dirname){var ts,__extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)};!function(ts){!function(SyntaxKind){SyntaxKind[SyntaxKind.Unknown=0]="Unknown",SyntaxKind[SyntaxKind.EndOfFileToken=1]="EndOfFileToken",SyntaxKind[SyntaxKind.SingleLineCommentTrivia=2]="SingleLineCommentTrivia",SyntaxKind[SyntaxKind.MultiLineCommentTrivia=3]="MultiLineCommentTrivia",SyntaxKind[SyntaxKind.NewLineTrivia=4]="NewLineTrivia",SyntaxKind[SyntaxKind.WhitespaceTrivia=5]="WhitespaceTrivia",SyntaxKind[SyntaxKind.ShebangTrivia=6]="ShebangTrivia",SyntaxKind[SyntaxKind.ConflictMarkerTrivia=7]="ConflictMarkerTrivia",SyntaxKind[SyntaxKind.NumericLiteral=8]="NumericLiteral",SyntaxKind[SyntaxKind.StringLiteral=9]="StringLiteral",SyntaxKind[SyntaxKind.RegularExpressionLiteral=10]="RegularExpressionLiteral",SyntaxKind[SyntaxKind.NoSubstitutionTemplateLiteral=11]="NoSubstitutionTemplateLiteral",SyntaxKind[SyntaxKind.TemplateHead=12]="TemplateHead",SyntaxKind[SyntaxKind.TemplateMiddle=13]="TemplateMiddle",SyntaxKind[SyntaxKind.TemplateTail=14]="TemplateTail",SyntaxKind[SyntaxKind.OpenBraceToken=15]="OpenBraceToken",SyntaxKind[SyntaxKind.CloseBraceToken=16]="CloseBraceToken",SyntaxKind[SyntaxKind.OpenParenToken=17]="OpenParenToken",SyntaxKind[SyntaxKind.CloseParenToken=18]="CloseParenToken",SyntaxKind[SyntaxKind.OpenBracketToken=19]="OpenBracketToken",SyntaxKind[SyntaxKind.CloseBracketToken=20]="CloseBracketToken",SyntaxKind[SyntaxKind.DotToken=21]="DotToken",SyntaxKind[SyntaxKind.DotDotDotToken=22]="DotDotDotToken",SyntaxKind[SyntaxKind.SemicolonToken=23]="SemicolonToken",SyntaxKind[SyntaxKind.CommaToken=24]="CommaToken",SyntaxKind[SyntaxKind.LessThanToken=25]="LessThanToken",SyntaxKind[SyntaxKind.LessThanSlashToken=26]="LessThanSlashToken",SyntaxKind[SyntaxKind.GreaterThanToken=27]="GreaterThanToken",SyntaxKind[SyntaxKind.LessThanEqualsToken=28]="LessThanEqualsToken",SyntaxKind[SyntaxKind.GreaterThanEqualsToken=29]="GreaterThanEqualsToken",SyntaxKind[SyntaxKind.EqualsEqualsToken=30]="EqualsEqualsToken",SyntaxKind[SyntaxKind.ExclamationEqualsToken=31]="ExclamationEqualsToken",SyntaxKind[SyntaxKind.EqualsEqualsEqualsToken=32]="EqualsEqualsEqualsToken",SyntaxKind[SyntaxKind.ExclamationEqualsEqualsToken=33]="ExclamationEqualsEqualsToken",SyntaxKind[SyntaxKind.EqualsGreaterThanToken=34]="EqualsGreaterThanToken",SyntaxKind[SyntaxKind.PlusToken=35]="PlusToken",SyntaxKind[SyntaxKind.MinusToken=36]="MinusToken",SyntaxKind[SyntaxKind.AsteriskToken=37]="AsteriskToken",SyntaxKind[SyntaxKind.AsteriskAsteriskToken=38]="AsteriskAsteriskToken",SyntaxKind[SyntaxKind.SlashToken=39]="SlashToken",SyntaxKind[SyntaxKind.PercentToken=40]="PercentToken",SyntaxKind[SyntaxKind.PlusPlusToken=41]="PlusPlusToken",SyntaxKind[SyntaxKind.MinusMinusToken=42]="MinusMinusToken",SyntaxKind[SyntaxKind.LessThanLessThanToken=43]="LessThanLessThanToken",SyntaxKind[SyntaxKind.GreaterThanGreaterThanToken=44]="GreaterThanGreaterThanToken",SyntaxKind[SyntaxKind.GreaterThanGreaterThanGreaterThanToken=45]="GreaterThanGreaterThanGreaterThanToken",SyntaxKind[SyntaxKind.AmpersandToken=46]="AmpersandToken",SyntaxKind[SyntaxKind.BarToken=47]="BarToken",SyntaxKind[SyntaxKind.CaretToken=48]="CaretToken",SyntaxKind[SyntaxKind.ExclamationToken=49]="ExclamationToken",SyntaxKind[SyntaxKind.TildeToken=50]="TildeToken",SyntaxKind[SyntaxKind.AmpersandAmpersandToken=51]="AmpersandAmpersandToken",SyntaxKind[SyntaxKind.BarBarToken=52]="BarBarToken",SyntaxKind[SyntaxKind.QuestionToken=53]="QuestionToken",SyntaxKind[SyntaxKind.ColonToken=54]="ColonToken",SyntaxKind[SyntaxKind.AtToken=55]="AtToken",SyntaxKind[SyntaxKind.EqualsToken=56]="EqualsToken",SyntaxKind[SyntaxKind.PlusEqualsToken=57]="PlusEqualsToken",SyntaxKind[SyntaxKind.MinusEqualsToken=58]="MinusEqualsToken",SyntaxKind[SyntaxKind.AsteriskEqualsToken=59]="AsteriskEqualsToken",SyntaxKind[SyntaxKind.AsteriskAsteriskEqualsToken=60]="AsteriskAsteriskEqualsToken",SyntaxKind[SyntaxKind.SlashEqualsToken=61]="SlashEqualsToken",SyntaxKind[SyntaxKind.PercentEqualsToken=62]="PercentEqualsToken",SyntaxKind[SyntaxKind.LessThanLessThanEqualsToken=63]="LessThanLessThanEqualsToken",SyntaxKind[SyntaxKind.GreaterThanGreaterThanEqualsToken=64]="GreaterThanGreaterThanEqualsToken",SyntaxKind[SyntaxKind.GreaterThanGreaterThanGreaterThanEqualsToken=65]="GreaterThanGreaterThanGreaterThanEqualsToken",SyntaxKind[SyntaxKind.AmpersandEqualsToken=66]="AmpersandEqualsToken",SyntaxKind[SyntaxKind.BarEqualsToken=67]="BarEqualsToken",SyntaxKind[SyntaxKind.CaretEqualsToken=68]="CaretEqualsToken",SyntaxKind[SyntaxKind.Identifier=69]="Identifier",SyntaxKind[SyntaxKind.BreakKeyword=70]="BreakKeyword",SyntaxKind[SyntaxKind.CaseKeyword=71]="CaseKeyword",SyntaxKind[SyntaxKind.CatchKeyword=72]="CatchKeyword",SyntaxKind[SyntaxKind.ClassKeyword=73]="ClassKeyword",SyntaxKind[SyntaxKind.ConstKeyword=74]="ConstKeyword",SyntaxKind[SyntaxKind.ContinueKeyword=75]="ContinueKeyword",SyntaxKind[SyntaxKind.DebuggerKeyword=76]="DebuggerKeyword",SyntaxKind[SyntaxKind.DefaultKeyword=77]="DefaultKeyword",SyntaxKind[SyntaxKind.DeleteKeyword=78]="DeleteKeyword",SyntaxKind[SyntaxKind.DoKeyword=79]="DoKeyword",SyntaxKind[SyntaxKind.ElseKeyword=80]="ElseKeyword",SyntaxKind[SyntaxKind.EnumKeyword=81]="EnumKeyword",SyntaxKind[SyntaxKind.ExportKeyword=82]="ExportKeyword",SyntaxKind[SyntaxKind.ExtendsKeyword=83]="ExtendsKeyword",SyntaxKind[SyntaxKind.FalseKeyword=84]="FalseKeyword",SyntaxKind[SyntaxKind.FinallyKeyword=85]="FinallyKeyword",SyntaxKind[SyntaxKind.ForKeyword=86]="ForKeyword",SyntaxKind[SyntaxKind.FunctionKeyword=87]="FunctionKeyword",SyntaxKind[SyntaxKind.IfKeyword=88]="IfKeyword",SyntaxKind[SyntaxKind.ImportKeyword=89]="ImportKeyword",SyntaxKind[SyntaxKind.InKeyword=90]="InKeyword",SyntaxKind[SyntaxKind.InstanceOfKeyword=91]="InstanceOfKeyword",SyntaxKind[SyntaxKind.NewKeyword=92]="NewKeyword",SyntaxKind[SyntaxKind.NullKeyword=93]="NullKeyword",SyntaxKind[SyntaxKind.ReturnKeyword=94]="ReturnKeyword",SyntaxKind[SyntaxKind.SuperKeyword=95]="SuperKeyword",SyntaxKind[SyntaxKind.SwitchKeyword=96]="SwitchKeyword",SyntaxKind[SyntaxKind.ThisKeyword=97]="ThisKeyword",SyntaxKind[SyntaxKind.ThrowKeyword=98]="ThrowKeyword",SyntaxKind[SyntaxKind.TrueKeyword=99]="TrueKeyword",SyntaxKind[SyntaxKind.TryKeyword=100]="TryKeyword",SyntaxKind[SyntaxKind.TypeOfKeyword=101]="TypeOfKeyword",SyntaxKind[SyntaxKind.VarKeyword=102]="VarKeyword",SyntaxKind[SyntaxKind.VoidKeyword=103]="VoidKeyword",SyntaxKind[SyntaxKind.WhileKeyword=104]="WhileKeyword",SyntaxKind[SyntaxKind.WithKeyword=105]="WithKeyword",SyntaxKind[SyntaxKind.ImplementsKeyword=106]="ImplementsKeyword",SyntaxKind[SyntaxKind.InterfaceKeyword=107]="InterfaceKeyword",SyntaxKind[SyntaxKind.LetKeyword=108]="LetKeyword",SyntaxKind[SyntaxKind.PackageKeyword=109]="PackageKeyword",SyntaxKind[SyntaxKind.PrivateKeyword=110]="PrivateKeyword",SyntaxKind[SyntaxKind.ProtectedKeyword=111]="ProtectedKeyword",SyntaxKind[SyntaxKind.PublicKeyword=112]="PublicKeyword",SyntaxKind[SyntaxKind.StaticKeyword=113]="StaticKeyword",SyntaxKind[SyntaxKind.YieldKeyword=114]="YieldKeyword",SyntaxKind[SyntaxKind.AbstractKeyword=115]="AbstractKeyword",SyntaxKind[SyntaxKind.AsKeyword=116]="AsKeyword",SyntaxKind[SyntaxKind.AnyKeyword=117]="AnyKeyword",SyntaxKind[SyntaxKind.AsyncKeyword=118]="AsyncKeyword",SyntaxKind[SyntaxKind.AwaitKeyword=119]="AwaitKeyword",SyntaxKind[SyntaxKind.BooleanKeyword=120]="BooleanKeyword",SyntaxKind[SyntaxKind.ConstructorKeyword=121]="ConstructorKeyword",SyntaxKind[SyntaxKind.DeclareKeyword=122]="DeclareKeyword",SyntaxKind[SyntaxKind.GetKeyword=123]="GetKeyword",SyntaxKind[SyntaxKind.IsKeyword=124]="IsKeyword",SyntaxKind[SyntaxKind.ModuleKeyword=125]="ModuleKeyword",SyntaxKind[SyntaxKind.NamespaceKeyword=126]="NamespaceKeyword",SyntaxKind[SyntaxKind.RequireKeyword=127]="RequireKeyword",SyntaxKind[SyntaxKind.NumberKeyword=128]="NumberKeyword",SyntaxKind[SyntaxKind.SetKeyword=129]="SetKeyword",SyntaxKind[SyntaxKind.StringKeyword=130]="StringKeyword",SyntaxKind[SyntaxKind.SymbolKeyword=131]="SymbolKeyword",SyntaxKind[SyntaxKind.TypeKeyword=132]="TypeKeyword",SyntaxKind[SyntaxKind.FromKeyword=133]="FromKeyword",SyntaxKind[SyntaxKind.GlobalKeyword=134]="GlobalKeyword",SyntaxKind[SyntaxKind.OfKeyword=135]="OfKeyword",SyntaxKind[SyntaxKind.QualifiedName=136]="QualifiedName",SyntaxKind[SyntaxKind.ComputedPropertyName=137]="ComputedPropertyName",SyntaxKind[SyntaxKind.TypeParameter=138]="TypeParameter",SyntaxKind[SyntaxKind.Parameter=139]="Parameter",SyntaxKind[SyntaxKind.Decorator=140]="Decorator",SyntaxKind[SyntaxKind.PropertySignature=141]="PropertySignature",SyntaxKind[SyntaxKind.PropertyDeclaration=142]="PropertyDeclaration",SyntaxKind[SyntaxKind.MethodSignature=143]="MethodSignature",SyntaxKind[SyntaxKind.MethodDeclaration=144]="MethodDeclaration",SyntaxKind[SyntaxKind.Constructor=145]="Constructor",SyntaxKind[SyntaxKind.GetAccessor=146]="GetAccessor",SyntaxKind[SyntaxKind.SetAccessor=147]="SetAccessor",SyntaxKind[SyntaxKind.CallSignature=148]="CallSignature",SyntaxKind[SyntaxKind.ConstructSignature=149]="ConstructSignature",SyntaxKind[SyntaxKind.IndexSignature=150]="IndexSignature",SyntaxKind[SyntaxKind.TypePredicate=151]="TypePredicate",SyntaxKind[SyntaxKind.TypeReference=152]="TypeReference",SyntaxKind[SyntaxKind.FunctionType=153]="FunctionType",SyntaxKind[SyntaxKind.ConstructorType=154]="ConstructorType",SyntaxKind[SyntaxKind.TypeQuery=155]="TypeQuery",SyntaxKind[SyntaxKind.TypeLiteral=156]="TypeLiteral",SyntaxKind[SyntaxKind.ArrayType=157]="ArrayType",SyntaxKind[SyntaxKind.TupleType=158]="TupleType",SyntaxKind[SyntaxKind.UnionType=159]="UnionType",SyntaxKind[SyntaxKind.IntersectionType=160]="IntersectionType",SyntaxKind[SyntaxKind.ParenthesizedType=161]="ParenthesizedType",SyntaxKind[SyntaxKind.ThisType=162]="ThisType",SyntaxKind[SyntaxKind.StringLiteralType=163]="StringLiteralType",SyntaxKind[SyntaxKind.ObjectBindingPattern=164]="ObjectBindingPattern",SyntaxKind[SyntaxKind.ArrayBindingPattern=165]="ArrayBindingPattern",SyntaxKind[SyntaxKind.BindingElement=166]="BindingElement",SyntaxKind[SyntaxKind.ArrayLiteralExpression=167]="ArrayLiteralExpression",SyntaxKind[SyntaxKind.ObjectLiteralExpression=168]="ObjectLiteralExpression",SyntaxKind[SyntaxKind.PropertyAccessExpression=169]="PropertyAccessExpression",SyntaxKind[SyntaxKind.ElementAccessExpression=170]="ElementAccessExpression",SyntaxKind[SyntaxKind.CallExpression=171]="CallExpression",SyntaxKind[SyntaxKind.NewExpression=172]="NewExpression",SyntaxKind[SyntaxKind.TaggedTemplateExpression=173]="TaggedTemplateExpression",SyntaxKind[SyntaxKind.TypeAssertionExpression=174]="TypeAssertionExpression",SyntaxKind[SyntaxKind.ParenthesizedExpression=175]="ParenthesizedExpression",SyntaxKind[SyntaxKind.FunctionExpression=176]="FunctionExpression",SyntaxKind[SyntaxKind.ArrowFunction=177]="ArrowFunction",SyntaxKind[SyntaxKind.DeleteExpression=178]="DeleteExpression",SyntaxKind[SyntaxKind.TypeOfExpression=179]="TypeOfExpression",SyntaxKind[SyntaxKind.VoidExpression=180]="VoidExpression",SyntaxKind[SyntaxKind.AwaitExpression=181]="AwaitExpression",SyntaxKind[SyntaxKind.PrefixUnaryExpression=182]="PrefixUnaryExpression",SyntaxKind[SyntaxKind.PostfixUnaryExpression=183]="PostfixUnaryExpression",SyntaxKind[SyntaxKind.BinaryExpression=184]="BinaryExpression",SyntaxKind[SyntaxKind.ConditionalExpression=185]="ConditionalExpression",SyntaxKind[SyntaxKind.TemplateExpression=186]="TemplateExpression",SyntaxKind[SyntaxKind.YieldExpression=187]="YieldExpression",SyntaxKind[SyntaxKind.SpreadElementExpression=188]="SpreadElementExpression",SyntaxKind[SyntaxKind.ClassExpression=189]="ClassExpression",SyntaxKind[SyntaxKind.OmittedExpression=190]="OmittedExpression",SyntaxKind[SyntaxKind.ExpressionWithTypeArguments=191]="ExpressionWithTypeArguments",SyntaxKind[SyntaxKind.AsExpression=192]="AsExpression",SyntaxKind[SyntaxKind.TemplateSpan=193]="TemplateSpan",SyntaxKind[SyntaxKind.SemicolonClassElement=194]="SemicolonClassElement",SyntaxKind[SyntaxKind.Block=195]="Block",SyntaxKind[SyntaxKind.VariableStatement=196]="VariableStatement",SyntaxKind[SyntaxKind.EmptyStatement=197]="EmptyStatement",SyntaxKind[SyntaxKind.ExpressionStatement=198]="ExpressionStatement",SyntaxKind[SyntaxKind.IfStatement=199]="IfStatement";SyntaxKind[SyntaxKind.DoStatement=200]="DoStatement";SyntaxKind[SyntaxKind.WhileStatement=201]="WhileStatement",SyntaxKind[SyntaxKind.ForStatement=202]="ForStatement",SyntaxKind[SyntaxKind.ForInStatement=203]="ForInStatement",SyntaxKind[SyntaxKind.ForOfStatement=204]="ForOfStatement",SyntaxKind[SyntaxKind.ContinueStatement=205]="ContinueStatement",SyntaxKind[SyntaxKind.BreakStatement=206]="BreakStatement",SyntaxKind[SyntaxKind.ReturnStatement=207]="ReturnStatement",SyntaxKind[SyntaxKind.WithStatement=208]="WithStatement",SyntaxKind[SyntaxKind.SwitchStatement=209]="SwitchStatement",SyntaxKind[SyntaxKind.LabeledStatement=210]="LabeledStatement",SyntaxKind[SyntaxKind.ThrowStatement=211]="ThrowStatement",SyntaxKind[SyntaxKind.TryStatement=212]="TryStatement",SyntaxKind[SyntaxKind.DebuggerStatement=213]="DebuggerStatement",SyntaxKind[SyntaxKind.VariableDeclaration=214]="VariableDeclaration",SyntaxKind[SyntaxKind.VariableDeclarationList=215]="VariableDeclarationList",SyntaxKind[SyntaxKind.FunctionDeclaration=216]="FunctionDeclaration",SyntaxKind[SyntaxKind.ClassDeclaration=217]="ClassDeclaration",SyntaxKind[SyntaxKind.InterfaceDeclaration=218]="InterfaceDeclaration",SyntaxKind[SyntaxKind.TypeAliasDeclaration=219]="TypeAliasDeclaration",SyntaxKind[SyntaxKind.EnumDeclaration=220]="EnumDeclaration",SyntaxKind[SyntaxKind.ModuleDeclaration=221]="ModuleDeclaration",SyntaxKind[SyntaxKind.ModuleBlock=222]="ModuleBlock",SyntaxKind[SyntaxKind.CaseBlock=223]="CaseBlock",SyntaxKind[SyntaxKind.ImportEqualsDeclaration=224]="ImportEqualsDeclaration",SyntaxKind[SyntaxKind.ImportDeclaration=225]="ImportDeclaration",SyntaxKind[SyntaxKind.ImportClause=226]="ImportClause",SyntaxKind[SyntaxKind.NamespaceImport=227]="NamespaceImport",SyntaxKind[SyntaxKind.NamedImports=228]="NamedImports",SyntaxKind[SyntaxKind.ImportSpecifier=229]="ImportSpecifier",SyntaxKind[SyntaxKind.ExportAssignment=230]="ExportAssignment",SyntaxKind[SyntaxKind.ExportDeclaration=231]="ExportDeclaration",SyntaxKind[SyntaxKind.NamedExports=232]="NamedExports",SyntaxKind[SyntaxKind.ExportSpecifier=233]="ExportSpecifier",SyntaxKind[SyntaxKind.MissingDeclaration=234]="MissingDeclaration",SyntaxKind[SyntaxKind.ExternalModuleReference=235]="ExternalModuleReference",SyntaxKind[SyntaxKind.JsxElement=236]="JsxElement",SyntaxKind[SyntaxKind.JsxSelfClosingElement=237]="JsxSelfClosingElement",SyntaxKind[SyntaxKind.JsxOpeningElement=238]="JsxOpeningElement",SyntaxKind[SyntaxKind.JsxText=239]="JsxText",SyntaxKind[SyntaxKind.JsxClosingElement=240]="JsxClosingElement",SyntaxKind[SyntaxKind.JsxAttribute=241]="JsxAttribute",SyntaxKind[SyntaxKind.JsxSpreadAttribute=242]="JsxSpreadAttribute",SyntaxKind[SyntaxKind.JsxExpression=243]="JsxExpression",SyntaxKind[SyntaxKind.CaseClause=244]="CaseClause",SyntaxKind[SyntaxKind.DefaultClause=245]="DefaultClause",SyntaxKind[SyntaxKind.HeritageClause=246]="HeritageClause",SyntaxKind[SyntaxKind.CatchClause=247]="CatchClause",SyntaxKind[SyntaxKind.PropertyAssignment=248]="PropertyAssignment",SyntaxKind[SyntaxKind.ShorthandPropertyAssignment=249]="ShorthandPropertyAssignment",SyntaxKind[SyntaxKind.EnumMember=250]="EnumMember",SyntaxKind[SyntaxKind.SourceFile=251]="SourceFile",SyntaxKind[SyntaxKind.JSDocTypeExpression=252]="JSDocTypeExpression",SyntaxKind[SyntaxKind.JSDocAllType=253]="JSDocAllType",SyntaxKind[SyntaxKind.JSDocUnknownType=254]="JSDocUnknownType",SyntaxKind[SyntaxKind.JSDocArrayType=255]="JSDocArrayType",SyntaxKind[SyntaxKind.JSDocUnionType=256]="JSDocUnionType",SyntaxKind[SyntaxKind.JSDocTupleType=257]="JSDocTupleType",SyntaxKind[SyntaxKind.JSDocNullableType=258]="JSDocNullableType",SyntaxKind[SyntaxKind.JSDocNonNullableType=259]="JSDocNonNullableType",SyntaxKind[SyntaxKind.JSDocRecordType=260]="JSDocRecordType",SyntaxKind[SyntaxKind.JSDocRecordMember=261]="JSDocRecordMember",SyntaxKind[SyntaxKind.JSDocTypeReference=262]="JSDocTypeReference",SyntaxKind[SyntaxKind.JSDocOptionalType=263]="JSDocOptionalType",SyntaxKind[SyntaxKind.JSDocFunctionType=264]="JSDocFunctionType",SyntaxKind[SyntaxKind.JSDocVariadicType=265]="JSDocVariadicType",SyntaxKind[SyntaxKind.JSDocConstructorType=266]="JSDocConstructorType",SyntaxKind[SyntaxKind.JSDocThisType=267]="JSDocThisType",SyntaxKind[SyntaxKind.JSDocComment=268]="JSDocComment",SyntaxKind[SyntaxKind.JSDocTag=269]="JSDocTag",SyntaxKind[SyntaxKind.JSDocParameterTag=270]="JSDocParameterTag",SyntaxKind[SyntaxKind.JSDocReturnTag=271]="JSDocReturnTag",SyntaxKind[SyntaxKind.JSDocTypeTag=272]="JSDocTypeTag",SyntaxKind[SyntaxKind.JSDocTemplateTag=273]="JSDocTemplateTag",SyntaxKind[SyntaxKind.SyntaxList=274]="SyntaxList",SyntaxKind[SyntaxKind.Count=275]="Count",SyntaxKind[SyntaxKind.FirstAssignment=56]="FirstAssignment",SyntaxKind[SyntaxKind.LastAssignment=68]="LastAssignment",SyntaxKind[SyntaxKind.FirstReservedWord=70]="FirstReservedWord",SyntaxKind[SyntaxKind.LastReservedWord=105]="LastReservedWord",SyntaxKind[SyntaxKind.FirstKeyword=70]="FirstKeyword",SyntaxKind[SyntaxKind.LastKeyword=135]="LastKeyword",SyntaxKind[SyntaxKind.FirstFutureReservedWord=106]="FirstFutureReservedWord",SyntaxKind[SyntaxKind.LastFutureReservedWord=114]="LastFutureReservedWord",SyntaxKind[SyntaxKind.FirstTypeNode=151]="FirstTypeNode",SyntaxKind[SyntaxKind.LastTypeNode=163]="LastTypeNode",SyntaxKind[SyntaxKind.FirstPunctuation=15]="FirstPunctuation",SyntaxKind[SyntaxKind.LastPunctuation=68]="LastPunctuation",SyntaxKind[SyntaxKind.FirstToken=0]="FirstToken",SyntaxKind[SyntaxKind.LastToken=135]="LastToken",SyntaxKind[SyntaxKind.FirstTriviaToken=2]="FirstTriviaToken",SyntaxKind[SyntaxKind.LastTriviaToken=7]="LastTriviaToken",SyntaxKind[SyntaxKind.FirstLiteralToken=8]="FirstLiteralToken",SyntaxKind[SyntaxKind.LastLiteralToken=11]="LastLiteralToken",SyntaxKind[SyntaxKind.FirstTemplateToken=11]="FirstTemplateToken",SyntaxKind[SyntaxKind.LastTemplateToken=14]="LastTemplateToken",SyntaxKind[SyntaxKind.FirstBinaryOperator=25]="FirstBinaryOperator",SyntaxKind[SyntaxKind.LastBinaryOperator=68]="LastBinaryOperator",SyntaxKind[SyntaxKind.FirstNode=136]="FirstNode"}(ts.SyntaxKind||(ts.SyntaxKind={}));ts.SyntaxKind;!function(NodeFlags){NodeFlags[NodeFlags.None=0]="None",NodeFlags[NodeFlags.Export=2]="Export",NodeFlags[NodeFlags.Ambient=4]="Ambient",NodeFlags[NodeFlags.Public=8]="Public",NodeFlags[NodeFlags.Private=16]="Private",NodeFlags[NodeFlags.Protected=32]="Protected",NodeFlags[NodeFlags.Static=64]="Static",NodeFlags[NodeFlags.Abstract=128]="Abstract",NodeFlags[NodeFlags.Async=256]="Async",NodeFlags[NodeFlags.Default=512]="Default",NodeFlags[NodeFlags.MultiLine=1024]="MultiLine",NodeFlags[NodeFlags.Synthetic=2048]="Synthetic",NodeFlags[NodeFlags.DeclarationFile=4096]="DeclarationFile",NodeFlags[NodeFlags.Let=8192]="Let",NodeFlags[NodeFlags.Const=16384]="Const",NodeFlags[NodeFlags.OctalLiteral=32768]="OctalLiteral",NodeFlags[NodeFlags.Namespace=65536]="Namespace",NodeFlags[NodeFlags.ExportContext=131072]="ExportContext",NodeFlags[NodeFlags.ContainsThis=262144]="ContainsThis",NodeFlags[NodeFlags.HasImplicitReturn=524288]="HasImplicitReturn",NodeFlags[NodeFlags.HasExplicitReturn=1048576]="HasExplicitReturn",NodeFlags[NodeFlags.GlobalAugmentation=2097152]="GlobalAugmentation",NodeFlags[NodeFlags.HasClassExtends=4194304]="HasClassExtends",NodeFlags[NodeFlags.HasDecorators=8388608]="HasDecorators",NodeFlags[NodeFlags.HasParamDecorators=16777216]="HasParamDecorators",NodeFlags[NodeFlags.HasAsyncFunctions=33554432]="HasAsyncFunctions",NodeFlags[NodeFlags.Modifier=1022]="Modifier",NodeFlags[NodeFlags.AccessibilityModifier=56]="AccessibilityModifier",NodeFlags[NodeFlags.BlockScoped=24576]="BlockScoped",NodeFlags[NodeFlags.ReachabilityCheckFlags=1572864]="ReachabilityCheckFlags",NodeFlags[NodeFlags.EmitHelperFlags=62914560]="EmitHelperFlags"}(ts.NodeFlags||(ts.NodeFlags={}));ts.NodeFlags;!function(ParserContextFlags){ParserContextFlags[ParserContextFlags.None=0]="None",ParserContextFlags[ParserContextFlags.DisallowIn=1]="DisallowIn",ParserContextFlags[ParserContextFlags.Yield=2]="Yield",ParserContextFlags[ParserContextFlags.Decorator=4]="Decorator",ParserContextFlags[ParserContextFlags.Await=8]="Await",ParserContextFlags[ParserContextFlags.ThisNodeHasError=16]="ThisNodeHasError",ParserContextFlags[ParserContextFlags.JavaScriptFile=32]="JavaScriptFile",ParserContextFlags[ParserContextFlags.ParserGeneratedFlags=31]="ParserGeneratedFlags",ParserContextFlags[ParserContextFlags.TypeExcludesFlags=10]="TypeExcludesFlags",ParserContextFlags[ParserContextFlags.ThisNodeOrAnySubNodesHasError=64]="ThisNodeOrAnySubNodesHasError",ParserContextFlags[ParserContextFlags.HasAggregatedChildData=128]="HasAggregatedChildData"}(ts.ParserContextFlags||(ts.ParserContextFlags={}));ts.ParserContextFlags;!function(JsxFlags){JsxFlags[JsxFlags.None=0]="None",JsxFlags[JsxFlags.IntrinsicNamedElement=1]="IntrinsicNamedElement",JsxFlags[JsxFlags.IntrinsicIndexedElement=2]="IntrinsicIndexedElement",JsxFlags[JsxFlags.ValueElement=4]="ValueElement",JsxFlags[JsxFlags.UnknownElement=16]="UnknownElement",JsxFlags[JsxFlags.IntrinsicElement=3]="IntrinsicElement"}(ts.JsxFlags||(ts.JsxFlags={}));ts.JsxFlags;!function(RelationComparisonResult){RelationComparisonResult[RelationComparisonResult.Succeeded=1]="Succeeded",RelationComparisonResult[RelationComparisonResult.Failed=2]="Failed",RelationComparisonResult[RelationComparisonResult.FailedAndReported=3]="FailedAndReported"}(ts.RelationComparisonResult||(ts.RelationComparisonResult={}));var OperationCanceledException=(ts.RelationComparisonResult,function(){function OperationCanceledException(){}return OperationCanceledException}());ts.OperationCanceledException=OperationCanceledException,function(ExitStatus){ExitStatus[ExitStatus.Success=0]="Success",ExitStatus[ExitStatus.DiagnosticsPresent_OutputsSkipped=1]="DiagnosticsPresent_OutputsSkipped",ExitStatus[ExitStatus.DiagnosticsPresent_OutputsGenerated=2]="DiagnosticsPresent_OutputsGenerated"}(ts.ExitStatus||(ts.ExitStatus={}));ts.ExitStatus;!function(TypeFormatFlags){TypeFormatFlags[TypeFormatFlags.None=0]="None",TypeFormatFlags[TypeFormatFlags.WriteArrayAsGenericType=1]="WriteArrayAsGenericType",TypeFormatFlags[TypeFormatFlags.UseTypeOfFunction=2]="UseTypeOfFunction",TypeFormatFlags[TypeFormatFlags.NoTruncation=4]="NoTruncation",TypeFormatFlags[TypeFormatFlags.WriteArrowStyleSignature=8]="WriteArrowStyleSignature",TypeFormatFlags[TypeFormatFlags.WriteOwnNameForAnyLike=16]="WriteOwnNameForAnyLike",TypeFormatFlags[TypeFormatFlags.WriteTypeArgumentsOfSignature=32]="WriteTypeArgumentsOfSignature",TypeFormatFlags[TypeFormatFlags.InElementType=64]="InElementType",TypeFormatFlags[TypeFormatFlags.UseFullyQualifiedType=128]="UseFullyQualifiedType"}(ts.TypeFormatFlags||(ts.TypeFormatFlags={}));ts.TypeFormatFlags;!function(SymbolFormatFlags){SymbolFormatFlags[SymbolFormatFlags.None=0]="None",SymbolFormatFlags[SymbolFormatFlags.WriteTypeParametersOrArguments=1]="WriteTypeParametersOrArguments",SymbolFormatFlags[SymbolFormatFlags.UseOnlyExternalAliasing=2]="UseOnlyExternalAliasing"}(ts.SymbolFormatFlags||(ts.SymbolFormatFlags={}));ts.SymbolFormatFlags;!function(SymbolAccessibility){SymbolAccessibility[SymbolAccessibility.Accessible=0]="Accessible",SymbolAccessibility[SymbolAccessibility.NotAccessible=1]="NotAccessible",SymbolAccessibility[SymbolAccessibility.CannotBeNamed=2]="CannotBeNamed"}(ts.SymbolAccessibility||(ts.SymbolAccessibility={}));ts.SymbolAccessibility;!function(TypePredicateKind){TypePredicateKind[TypePredicateKind.This=0]="This",TypePredicateKind[TypePredicateKind.Identifier=1]="Identifier"}(ts.TypePredicateKind||(ts.TypePredicateKind={}));ts.TypePredicateKind;!function(TypeReferenceSerializationKind){TypeReferenceSerializationKind[TypeReferenceSerializationKind.Unknown=0]="Unknown",TypeReferenceSerializationKind[TypeReferenceSerializationKind.TypeWithConstructSignatureAndValue=1]="TypeWithConstructSignatureAndValue",TypeReferenceSerializationKind[TypeReferenceSerializationKind.VoidType=2]="VoidType",TypeReferenceSerializationKind[TypeReferenceSerializationKind.NumberLikeType=3]="NumberLikeType",TypeReferenceSerializationKind[TypeReferenceSerializationKind.StringLikeType=4]="StringLikeType",TypeReferenceSerializationKind[TypeReferenceSerializationKind.BooleanType=5]="BooleanType",TypeReferenceSerializationKind[TypeReferenceSerializationKind.ArrayLikeType=6]="ArrayLikeType",TypeReferenceSerializationKind[TypeReferenceSerializationKind.ESSymbolType=7]="ESSymbolType",TypeReferenceSerializationKind[TypeReferenceSerializationKind.TypeWithCallSignature=8]="TypeWithCallSignature",TypeReferenceSerializationKind[TypeReferenceSerializationKind.ObjectType=9]="ObjectType"}(ts.TypeReferenceSerializationKind||(ts.TypeReferenceSerializationKind={}));ts.TypeReferenceSerializationKind;!function(SymbolFlags){SymbolFlags[SymbolFlags.None=0]="None",SymbolFlags[SymbolFlags.FunctionScopedVariable=1]="FunctionScopedVariable",SymbolFlags[SymbolFlags.BlockScopedVariable=2]="BlockScopedVariable",SymbolFlags[SymbolFlags.Property=4]="Property",SymbolFlags[SymbolFlags.EnumMember=8]="EnumMember",SymbolFlags[SymbolFlags.Function=16]="Function",SymbolFlags[SymbolFlags.Class=32]="Class",SymbolFlags[SymbolFlags.Interface=64]="Interface",SymbolFlags[SymbolFlags.ConstEnum=128]="ConstEnum",SymbolFlags[SymbolFlags.RegularEnum=256]="RegularEnum",SymbolFlags[SymbolFlags.ValueModule=512]="ValueModule",SymbolFlags[SymbolFlags.NamespaceModule=1024]="NamespaceModule",SymbolFlags[SymbolFlags.TypeLiteral=2048]="TypeLiteral",SymbolFlags[SymbolFlags.ObjectLiteral=4096]="ObjectLiteral",SymbolFlags[SymbolFlags.Method=8192]="Method",SymbolFlags[SymbolFlags.Constructor=16384]="Constructor",SymbolFlags[SymbolFlags.GetAccessor=32768]="GetAccessor",SymbolFlags[SymbolFlags.SetAccessor=65536]="SetAccessor",SymbolFlags[SymbolFlags.Signature=131072]="Signature",SymbolFlags[SymbolFlags.TypeParameter=262144]="TypeParameter",SymbolFlags[SymbolFlags.TypeAlias=524288]="TypeAlias",SymbolFlags[SymbolFlags.ExportValue=1048576]="ExportValue",SymbolFlags[SymbolFlags.ExportType=2097152]="ExportType",SymbolFlags[SymbolFlags.ExportNamespace=4194304]="ExportNamespace",SymbolFlags[SymbolFlags.Alias=8388608]="Alias",SymbolFlags[SymbolFlags.Instantiated=16777216]="Instantiated",SymbolFlags[SymbolFlags.Merged=33554432]="Merged",SymbolFlags[SymbolFlags.Transient=67108864]="Transient",SymbolFlags[SymbolFlags.Prototype=134217728]="Prototype",SymbolFlags[SymbolFlags.SyntheticProperty=268435456]="SyntheticProperty",SymbolFlags[SymbolFlags.Optional=536870912]="Optional",SymbolFlags[SymbolFlags.ExportStar=1073741824]="ExportStar",SymbolFlags[SymbolFlags.Enum=384]="Enum",SymbolFlags[SymbolFlags.Variable=3]="Variable",SymbolFlags[SymbolFlags.Value=107455]="Value",SymbolFlags[SymbolFlags.Type=793056]="Type",
SymbolFlags[SymbolFlags.Namespace=1536]="Namespace",SymbolFlags[SymbolFlags.Module=1536]="Module",SymbolFlags[SymbolFlags.Accessor=98304]="Accessor",SymbolFlags[SymbolFlags.FunctionScopedVariableExcludes=107454]="FunctionScopedVariableExcludes",SymbolFlags[SymbolFlags.BlockScopedVariableExcludes=107455]="BlockScopedVariableExcludes",SymbolFlags[SymbolFlags.ParameterExcludes=107455]="ParameterExcludes",SymbolFlags[SymbolFlags.PropertyExcludes=107455]="PropertyExcludes",SymbolFlags[SymbolFlags.EnumMemberExcludes=107455]="EnumMemberExcludes",SymbolFlags[SymbolFlags.FunctionExcludes=106927]="FunctionExcludes",SymbolFlags[SymbolFlags.ClassExcludes=899519]="ClassExcludes",SymbolFlags[SymbolFlags.InterfaceExcludes=792960]="InterfaceExcludes",SymbolFlags[SymbolFlags.RegularEnumExcludes=899327]="RegularEnumExcludes",SymbolFlags[SymbolFlags.ConstEnumExcludes=899967]="ConstEnumExcludes",SymbolFlags[SymbolFlags.ValueModuleExcludes=106639]="ValueModuleExcludes",SymbolFlags[SymbolFlags.NamespaceModuleExcludes=0]="NamespaceModuleExcludes",SymbolFlags[SymbolFlags.MethodExcludes=99263]="MethodExcludes",SymbolFlags[SymbolFlags.GetAccessorExcludes=41919]="GetAccessorExcludes",SymbolFlags[SymbolFlags.SetAccessorExcludes=74687]="SetAccessorExcludes",SymbolFlags[SymbolFlags.TypeParameterExcludes=530912]="TypeParameterExcludes",SymbolFlags[SymbolFlags.TypeAliasExcludes=793056]="TypeAliasExcludes",SymbolFlags[SymbolFlags.AliasExcludes=8388608]="AliasExcludes",SymbolFlags[SymbolFlags.ModuleMember=8914931]="ModuleMember",SymbolFlags[SymbolFlags.ExportHasLocal=944]="ExportHasLocal",SymbolFlags[SymbolFlags.HasExports=1952]="HasExports",SymbolFlags[SymbolFlags.HasMembers=6240]="HasMembers",SymbolFlags[SymbolFlags.BlockScoped=418]="BlockScoped",SymbolFlags[SymbolFlags.PropertyOrAccessor=98308]="PropertyOrAccessor",SymbolFlags[SymbolFlags.Export=7340032]="Export",SymbolFlags[SymbolFlags.Classifiable=788448]="Classifiable"}(ts.SymbolFlags||(ts.SymbolFlags={}));ts.SymbolFlags;!function(NodeCheckFlags){NodeCheckFlags[NodeCheckFlags.TypeChecked=1]="TypeChecked",NodeCheckFlags[NodeCheckFlags.LexicalThis=2]="LexicalThis",NodeCheckFlags[NodeCheckFlags.CaptureThis=4]="CaptureThis",NodeCheckFlags[NodeCheckFlags.SuperInstance=256]="SuperInstance",NodeCheckFlags[NodeCheckFlags.SuperStatic=512]="SuperStatic",NodeCheckFlags[NodeCheckFlags.ContextChecked=1024]="ContextChecked",NodeCheckFlags[NodeCheckFlags.AsyncMethodWithSuper=2048]="AsyncMethodWithSuper",NodeCheckFlags[NodeCheckFlags.AsyncMethodWithSuperBinding=4096]="AsyncMethodWithSuperBinding",NodeCheckFlags[NodeCheckFlags.CaptureArguments=8192]="CaptureArguments",NodeCheckFlags[NodeCheckFlags.EnumValuesComputed=16384]="EnumValuesComputed",NodeCheckFlags[NodeCheckFlags.LexicalModuleMergesWithClass=32768]="LexicalModuleMergesWithClass",NodeCheckFlags[NodeCheckFlags.LoopWithCapturedBlockScopedBinding=65536]="LoopWithCapturedBlockScopedBinding",NodeCheckFlags[NodeCheckFlags.CapturedBlockScopedBinding=131072]="CapturedBlockScopedBinding",NodeCheckFlags[NodeCheckFlags.BlockScopedBindingInLoop=262144]="BlockScopedBindingInLoop",NodeCheckFlags[NodeCheckFlags.ClassWithBodyScopedClassBinding=524288]="ClassWithBodyScopedClassBinding",NodeCheckFlags[NodeCheckFlags.BodyScopedClassBinding=1048576]="BodyScopedClassBinding",NodeCheckFlags[NodeCheckFlags.NeedsLoopOutParameter=2097152]="NeedsLoopOutParameter"}(ts.NodeCheckFlags||(ts.NodeCheckFlags={}));ts.NodeCheckFlags;!function(TypeFlags){TypeFlags[TypeFlags.Any=1]="Any",TypeFlags[TypeFlags.String=2]="String",TypeFlags[TypeFlags.Number=4]="Number",TypeFlags[TypeFlags.Boolean=8]="Boolean",TypeFlags[TypeFlags.Void=16]="Void",TypeFlags[TypeFlags.Undefined=32]="Undefined",TypeFlags[TypeFlags.Null=64]="Null",TypeFlags[TypeFlags.Enum=128]="Enum",TypeFlags[TypeFlags.StringLiteral=256]="StringLiteral",TypeFlags[TypeFlags.TypeParameter=512]="TypeParameter",TypeFlags[TypeFlags.Class=1024]="Class",TypeFlags[TypeFlags.Interface=2048]="Interface",TypeFlags[TypeFlags.Reference=4096]="Reference",TypeFlags[TypeFlags.Tuple=8192]="Tuple",TypeFlags[TypeFlags.Union=16384]="Union",TypeFlags[TypeFlags.Intersection=32768]="Intersection",TypeFlags[TypeFlags.Anonymous=65536]="Anonymous",TypeFlags[TypeFlags.Instantiated=131072]="Instantiated",TypeFlags[TypeFlags.FromSignature=262144]="FromSignature",TypeFlags[TypeFlags.ObjectLiteral=524288]="ObjectLiteral",TypeFlags[TypeFlags.FreshObjectLiteral=1048576]="FreshObjectLiteral",TypeFlags[TypeFlags.ContainsUndefinedOrNull=2097152]="ContainsUndefinedOrNull",TypeFlags[TypeFlags.ContainsObjectLiteral=4194304]="ContainsObjectLiteral",TypeFlags[TypeFlags.ContainsAnyFunctionType=8388608]="ContainsAnyFunctionType",TypeFlags[TypeFlags.ESSymbol=16777216]="ESSymbol",TypeFlags[TypeFlags.ThisType=33554432]="ThisType",TypeFlags[TypeFlags.ObjectLiteralPatternWithComputedProperties=67108864]="ObjectLiteralPatternWithComputedProperties",TypeFlags[TypeFlags.Intrinsic=16777343]="Intrinsic",TypeFlags[TypeFlags.Primitive=16777726]="Primitive",TypeFlags[TypeFlags.StringLike=258]="StringLike",TypeFlags[TypeFlags.NumberLike=132]="NumberLike",TypeFlags[TypeFlags.ObjectType=80896]="ObjectType",TypeFlags[TypeFlags.UnionOrIntersection=49152]="UnionOrIntersection",TypeFlags[TypeFlags.StructuredType=130048]="StructuredType",TypeFlags[TypeFlags.RequiresWidening=6291456]="RequiresWidening",TypeFlags[TypeFlags.PropagatingFlags=14680064]="PropagatingFlags"}(ts.TypeFlags||(ts.TypeFlags={}));ts.TypeFlags;!function(SignatureKind){SignatureKind[SignatureKind.Call=0]="Call",SignatureKind[SignatureKind.Construct=1]="Construct"}(ts.SignatureKind||(ts.SignatureKind={}));ts.SignatureKind;!function(IndexKind){IndexKind[IndexKind.String=0]="String",IndexKind[IndexKind.Number=1]="Number"}(ts.IndexKind||(ts.IndexKind={}));ts.IndexKind;!function(SpecialPropertyAssignmentKind){SpecialPropertyAssignmentKind[SpecialPropertyAssignmentKind.None=0]="None",SpecialPropertyAssignmentKind[SpecialPropertyAssignmentKind.ExportsProperty=1]="ExportsProperty",SpecialPropertyAssignmentKind[SpecialPropertyAssignmentKind.ModuleExports=2]="ModuleExports",SpecialPropertyAssignmentKind[SpecialPropertyAssignmentKind.PrototypeProperty=3]="PrototypeProperty",SpecialPropertyAssignmentKind[SpecialPropertyAssignmentKind.ThisProperty=4]="ThisProperty"}(ts.SpecialPropertyAssignmentKind||(ts.SpecialPropertyAssignmentKind={}));ts.SpecialPropertyAssignmentKind;!function(DiagnosticCategory){DiagnosticCategory[DiagnosticCategory.Warning=0]="Warning",DiagnosticCategory[DiagnosticCategory.Error=1]="Error",DiagnosticCategory[DiagnosticCategory.Message=2]="Message"}(ts.DiagnosticCategory||(ts.DiagnosticCategory={}));ts.DiagnosticCategory;!function(ModuleResolutionKind){ModuleResolutionKind[ModuleResolutionKind.Classic=1]="Classic",ModuleResolutionKind[ModuleResolutionKind.NodeJs=2]="NodeJs"}(ts.ModuleResolutionKind||(ts.ModuleResolutionKind={}));ts.ModuleResolutionKind;!function(ModuleKind){ModuleKind[ModuleKind.None=0]="None",ModuleKind[ModuleKind.CommonJS=1]="CommonJS",ModuleKind[ModuleKind.AMD=2]="AMD",ModuleKind[ModuleKind.UMD=3]="UMD",ModuleKind[ModuleKind.System=4]="System",ModuleKind[ModuleKind.ES6=5]="ES6",ModuleKind[ModuleKind.ES2015=5]="ES2015"}(ts.ModuleKind||(ts.ModuleKind={}));ts.ModuleKind;!function(JsxEmit){JsxEmit[JsxEmit.None=0]="None",JsxEmit[JsxEmit.Preserve=1]="Preserve",JsxEmit[JsxEmit.React=2]="React"}(ts.JsxEmit||(ts.JsxEmit={}));ts.JsxEmit;!function(NewLineKind){NewLineKind[NewLineKind.CarriageReturnLineFeed=0]="CarriageReturnLineFeed",NewLineKind[NewLineKind.LineFeed=1]="LineFeed"}(ts.NewLineKind||(ts.NewLineKind={}));ts.NewLineKind;!function(ScriptTarget){ScriptTarget[ScriptTarget.ES3=0]="ES3",ScriptTarget[ScriptTarget.ES5=1]="ES5",ScriptTarget[ScriptTarget.ES6=2]="ES6",ScriptTarget[ScriptTarget.ES2015=2]="ES2015",ScriptTarget[ScriptTarget.Latest=2]="Latest"}(ts.ScriptTarget||(ts.ScriptTarget={}));ts.ScriptTarget;!function(LanguageVariant){LanguageVariant[LanguageVariant.Standard=0]="Standard",LanguageVariant[LanguageVariant.JSX=1]="JSX"}(ts.LanguageVariant||(ts.LanguageVariant={}));ts.LanguageVariant;!function(DiagnosticStyle){DiagnosticStyle[DiagnosticStyle.Simple=0]="Simple",DiagnosticStyle[DiagnosticStyle.Pretty=1]="Pretty"}(ts.DiagnosticStyle||(ts.DiagnosticStyle={}));ts.DiagnosticStyle;!function(CharacterCodes){CharacterCodes[CharacterCodes.nullCharacter=0]="nullCharacter",CharacterCodes[CharacterCodes.maxAsciiCharacter=127]="maxAsciiCharacter",CharacterCodes[CharacterCodes.lineFeed=10]="lineFeed",CharacterCodes[CharacterCodes.carriageReturn=13]="carriageReturn",CharacterCodes[CharacterCodes.lineSeparator=8232]="lineSeparator",CharacterCodes[CharacterCodes.paragraphSeparator=8233]="paragraphSeparator",CharacterCodes[CharacterCodes.nextLine=133]="nextLine",CharacterCodes[CharacterCodes.space=32]="space",CharacterCodes[CharacterCodes.nonBreakingSpace=160]="nonBreakingSpace",CharacterCodes[CharacterCodes.enQuad=8192]="enQuad",CharacterCodes[CharacterCodes.emQuad=8193]="emQuad",CharacterCodes[CharacterCodes.enSpace=8194]="enSpace",CharacterCodes[CharacterCodes.emSpace=8195]="emSpace",CharacterCodes[CharacterCodes.threePerEmSpace=8196]="threePerEmSpace",CharacterCodes[CharacterCodes.fourPerEmSpace=8197]="fourPerEmSpace",CharacterCodes[CharacterCodes.sixPerEmSpace=8198]="sixPerEmSpace",CharacterCodes[CharacterCodes.figureSpace=8199]="figureSpace",CharacterCodes[CharacterCodes.punctuationSpace=8200]="punctuationSpace",CharacterCodes[CharacterCodes.thinSpace=8201]="thinSpace",CharacterCodes[CharacterCodes.hairSpace=8202]="hairSpace",CharacterCodes[CharacterCodes.zeroWidthSpace=8203]="zeroWidthSpace",CharacterCodes[CharacterCodes.narrowNoBreakSpace=8239]="narrowNoBreakSpace",CharacterCodes[CharacterCodes.ideographicSpace=12288]="ideographicSpace",CharacterCodes[CharacterCodes.mathematicalSpace=8287]="mathematicalSpace",CharacterCodes[CharacterCodes.ogham=5760]="ogham",CharacterCodes[CharacterCodes._=95]="_",CharacterCodes[CharacterCodes.$=36]="$",CharacterCodes[CharacterCodes._0=48]="_0",CharacterCodes[CharacterCodes._1=49]="_1",CharacterCodes[CharacterCodes._2=50]="_2",CharacterCodes[CharacterCodes._3=51]="_3",CharacterCodes[CharacterCodes._4=52]="_4",CharacterCodes[CharacterCodes._5=53]="_5",CharacterCodes[CharacterCodes._6=54]="_6",CharacterCodes[CharacterCodes._7=55]="_7",CharacterCodes[CharacterCodes._8=56]="_8",CharacterCodes[CharacterCodes._9=57]="_9",CharacterCodes[CharacterCodes.a=97]="a",CharacterCodes[CharacterCodes.b=98]="b",CharacterCodes[CharacterCodes.c=99]="c",CharacterCodes[CharacterCodes.d=100]="d",CharacterCodes[CharacterCodes.e=101]="e",CharacterCodes[CharacterCodes.f=102]="f",CharacterCodes[CharacterCodes.g=103]="g",CharacterCodes[CharacterCodes.h=104]="h",CharacterCodes[CharacterCodes.i=105]="i",CharacterCodes[CharacterCodes.j=106]="j",CharacterCodes[CharacterCodes.k=107]="k",CharacterCodes[CharacterCodes.l=108]="l",CharacterCodes[CharacterCodes.m=109]="m",CharacterCodes[CharacterCodes.n=110]="n",CharacterCodes[CharacterCodes.o=111]="o",CharacterCodes[CharacterCodes.p=112]="p",CharacterCodes[CharacterCodes.q=113]="q",CharacterCodes[CharacterCodes.r=114]="r",CharacterCodes[CharacterCodes.s=115]="s",CharacterCodes[CharacterCodes.t=116]="t",CharacterCodes[CharacterCodes.u=117]="u",CharacterCodes[CharacterCodes.v=118]="v",CharacterCodes[CharacterCodes.w=119]="w",CharacterCodes[CharacterCodes.x=120]="x",CharacterCodes[CharacterCodes.y=121]="y",CharacterCodes[CharacterCodes.z=122]="z",CharacterCodes[CharacterCodes.A=65]="A",CharacterCodes[CharacterCodes.B=66]="B",CharacterCodes[CharacterCodes.C=67]="C",CharacterCodes[CharacterCodes.D=68]="D",CharacterCodes[CharacterCodes.E=69]="E",CharacterCodes[CharacterCodes.F=70]="F",CharacterCodes[CharacterCodes.G=71]="G",CharacterCodes[CharacterCodes.H=72]="H",CharacterCodes[CharacterCodes.I=73]="I",CharacterCodes[CharacterCodes.J=74]="J",CharacterCodes[CharacterCodes.K=75]="K",CharacterCodes[CharacterCodes.L=76]="L",CharacterCodes[CharacterCodes.M=77]="M",CharacterCodes[CharacterCodes.N=78]="N",CharacterCodes[CharacterCodes.O=79]="O",CharacterCodes[CharacterCodes.P=80]="P",CharacterCodes[CharacterCodes.Q=81]="Q",CharacterCodes[CharacterCodes.R=82]="R",CharacterCodes[CharacterCodes.S=83]="S",CharacterCodes[CharacterCodes.T=84]="T",CharacterCodes[CharacterCodes.U=85]="U",CharacterCodes[CharacterCodes.V=86]="V",CharacterCodes[CharacterCodes.W=87]="W",CharacterCodes[CharacterCodes.X=88]="X",CharacterCodes[CharacterCodes.Y=89]="Y",CharacterCodes[CharacterCodes.Z=90]="Z",CharacterCodes[CharacterCodes.ampersand=38]="ampersand",CharacterCodes[CharacterCodes.asterisk=42]="asterisk",CharacterCodes[CharacterCodes.at=64]="at",CharacterCodes[CharacterCodes.backslash=92]="backslash",CharacterCodes[CharacterCodes.backtick=96]="backtick",CharacterCodes[CharacterCodes.bar=124]="bar",CharacterCodes[CharacterCodes.caret=94]="caret",CharacterCodes[CharacterCodes.closeBrace=125]="closeBrace",CharacterCodes[CharacterCodes.closeBracket=93]="closeBracket",CharacterCodes[CharacterCodes.closeParen=41]="closeParen",CharacterCodes[CharacterCodes.colon=58]="colon",CharacterCodes[CharacterCodes.comma=44]="comma",CharacterCodes[CharacterCodes.dot=46]="dot",CharacterCodes[CharacterCodes.doubleQuote=34]="doubleQuote",CharacterCodes[CharacterCodes.equals=61]="equals",CharacterCodes[CharacterCodes.exclamation=33]="exclamation",CharacterCodes[CharacterCodes.greaterThan=62]="greaterThan",CharacterCodes[CharacterCodes.hash=35]="hash",CharacterCodes[CharacterCodes.lessThan=60]="lessThan",CharacterCodes[CharacterCodes.minus=45]="minus",CharacterCodes[CharacterCodes.openBrace=123]="openBrace",CharacterCodes[CharacterCodes.openBracket=91]="openBracket",CharacterCodes[CharacterCodes.openParen=40]="openParen",CharacterCodes[CharacterCodes.percent=37]="percent",CharacterCodes[CharacterCodes.plus=43]="plus",CharacterCodes[CharacterCodes.question=63]="question",CharacterCodes[CharacterCodes.semicolon=59]="semicolon",CharacterCodes[CharacterCodes.singleQuote=39]="singleQuote",CharacterCodes[CharacterCodes.slash=47]="slash",CharacterCodes[CharacterCodes.tilde=126]="tilde",CharacterCodes[CharacterCodes.backspace=8]="backspace",CharacterCodes[CharacterCodes.formFeed=12]="formFeed",CharacterCodes[CharacterCodes.byteOrderMark=65279]="byteOrderMark",CharacterCodes[CharacterCodes.tab=9]="tab",CharacterCodes[CharacterCodes.verticalTab=11]="verticalTab"}(ts.CharacterCodes||(ts.CharacterCodes={}));ts.CharacterCodes}(ts||(ts={}));var ts;!function(ts){function createFileMap(keyMapper){function forEachValueInMap(f){for(var key in files)f(key,files[key])}function get(path){return files[toKey(path)]}function set(path,value){files[toKey(path)]=value}function contains(path){return hasProperty(files,toKey(path))}function remove(path){var key=toKey(path);delete files[key]}function clear(){files={}}function toKey(path){return keyMapper?keyMapper(path):path}var files={};return{get:get,set:set,contains:contains,remove:remove,forEachValue:forEachValueInMap,clear:clear}}function toPath(fileName,basePath,getCanonicalFileName){var nonCanonicalizedPath=isRootedDiskPath(fileName)?normalizePath(fileName):getNormalizedAbsolutePath(fileName,basePath);return getCanonicalFileName(nonCanonicalizedPath)}function forEach(array,callback){if(array)for(var i=0,len=array.length;i<len;i++){var result=callback(array[i],i);if(result)return result}}function contains(array,value){if(array)for(var _i=0,array_1=array;_i<array_1.length;_i++){var v=array_1[_i];if(v===value)return!0}return!1}function indexOf(array,value){if(array)for(var i=0,len=array.length;i<len;i++)if(array[i]===value)return i;return-1}function countWhere(array,predicate){var count=0;if(array)for(var _i=0,array_2=array;_i<array_2.length;_i++){var v=array_2[_i];predicate(v)&&count++}return count}function filter(array,f){var result;if(array){result=[];for(var _i=0,array_3=array;_i<array_3.length;_i++){var item=array_3[_i];f(item)&&result.push(item)}}return result}function map(array,f){var result;if(array){result=[];for(var _i=0,array_4=array;_i<array_4.length;_i++){var v=array_4[_i];result.push(f(v))}}return result}function concatenate(array1,array2){return array2&&array2.length?array1&&array1.length?array1.concat(array2):array2:array1}function deduplicate(array){var result;if(array){result=[];for(var _i=0,array_5=array;_i<array_5.length;_i++){var item=array_5[_i];contains(result,item)||result.push(item)}}return result}function sum(array,prop){for(var result=0,_i=0,array_6=array;_i<array_6.length;_i++){var v=array_6[_i];result+=v[prop]}return result}function addRange(to,from){if(to&&from)for(var _i=0,from_1=from;_i<from_1.length;_i++){var v=from_1[_i];to.push(v)}}function rangeEquals(array1,array2,pos,end){for(;pos<end;){if(array1[pos]!==array2[pos])return!1;pos++}return!0}function lastOrUndefined(array){if(0!==array.length)return array[array.length-1]}function binarySearch(array,value){for(var low=0,high=array.length-1;low<=high;){var middle=low+(high-low>>1),midValue=array[middle];if(midValue===value)return middle;midValue>value?high=middle-1:low=middle+1}return~low}function reduceLeft(array,f,initial){if(array){var count=array.length;if(count>0){var pos=0,result=arguments.length<=2?array[pos]:initial;for(pos++;pos<count;)result=f(result,array[pos]),pos++;return result}}return initial}function reduceRight(array,f,initial){if(array){var pos=array.length-1;if(pos>=0){var result=arguments.length<=2?array[pos]:initial;for(pos--;pos>=0;)result=f(result,array[pos]),pos--;return result}}return initial}function hasProperty(map,key){return hasOwnProperty.call(map,key)}function getProperty(map,key){return hasOwnProperty.call(map,key)?map[key]:void 0}function isEmpty(map){for(var id in map)if(hasProperty(map,id))return!1;return!0}function clone(object){var result={};for(var id in object)result[id]=object[id];return result}function extend(first,second){var result={};for(var id in first)result[id]=first[id];for(var id in second)hasProperty(result,id)||(result[id]=second[id]);return result}function forEachValue(map,callback){var result;for(var id in map)if(result=callback(map[id]))break;return result}function forEachKey(map,callback){var result;for(var id in map)if(result=callback(id))break;return result}function lookUp(map,key){return hasProperty(map,key)?map[key]:void 0}function copyMap(source,target){for(var p in source)target[p]=source[p]}function arrayToMap(array,makeKey){var result={};return forEach(array,function(value){result[makeKey(value)]=value}),result}function reduceProperties(map,callback,initial){var result=initial;if(map)for(var key in map)hasProperty(map,key)&&(result=callback(result,map[key],String(key)));return result}function isArray(value){return Array.isArray?Array.isArray(value):value instanceof Array}function memoize(callback){var value;return function(){return callback&&(value=callback(),callback=void 0),value}}function formatStringFromArgs(text,args,baseIndex){return baseIndex=baseIndex||0,text.replace(/{(\d+)}/g,function(match,index){return args[+index+baseIndex]})}function getLocaleSpecificMessage(message){return ts.localizedDiagnosticMessages&&ts.localizedDiagnosticMessages[message.key]?ts.localizedDiagnosticMessages[message.key]:message.message}function createFileDiagnostic(file,start,length,message){var end=start+length;Debug.assert(start>=0,"start must be non-negative, is "+start),Debug.assert(length>=0,"length must be non-negative, is "+length),file&&(Debug.assert(start<=file.text.length,"start must be within the bounds of the file. "+start+" > "+file.text.length),Debug.assert(end<=file.text.length,"end must be the bounds of the file. "+end+" > "+file.text.length));var text=getLocaleSpecificMessage(message);return arguments.length>4&&(text=formatStringFromArgs(text,arguments,4)),{file:file,start:start,length:length,messageText:text,category:message.category,code:message.code}}function createCompilerDiagnostic(message){var text=getLocaleSpecificMessage(message);return arguments.length>1&&(text=formatStringFromArgs(text,arguments,1)),{file:void 0,start:void 0,length:void 0,messageText:text,category:message.category,code:message.code}}function chainDiagnosticMessages(details,message){var text=getLocaleSpecificMessage(message);return arguments.length>2&&(text=formatStringFromArgs(text,arguments,2)),{messageText:text,category:message.category,code:message.code,next:details}}function concatenateDiagnosticMessageChains(headChain,tailChain){for(var lastChain=headChain;lastChain.next;)lastChain=lastChain.next;return lastChain.next=tailChain,headChain}function compareValues(a,b){return a===b?0:void 0===a?-1:void 0===b?1:a<b?-1:1}function getDiagnosticFileName(diagnostic){return diagnostic.file?diagnostic.file.fileName:void 0}function compareDiagnostics(d1,d2){return compareValues(getDiagnosticFileName(d1),getDiagnosticFileName(d2))||compareValues(d1.start,d2.start)||compareValues(d1.length,d2.length)||compareValues(d1.code,d2.code)||compareMessageText(d1.messageText,d2.messageText)||0}function compareMessageText(text1,text2){for(;text1&&text2;){var string1="string"==typeof text1?text1:text1.messageText,string2="string"==typeof text2?text2:text2.messageText,res=compareValues(string1,string2);if(res)return res;text1="string"==typeof text1?void 0:text1.next,text2="string"==typeof text2?void 0:text2.next}return text1||text2?text1?1:-1:0}function sortAndDeduplicateDiagnostics(diagnostics){return deduplicateSortedDiagnostics(diagnostics.sort(compareDiagnostics))}function deduplicateSortedDiagnostics(diagnostics){if(diagnostics.length<2)return diagnostics;for(var newDiagnostics=[diagnostics[0]],previousDiagnostic=diagnostics[0],i=1;i<diagnostics.length;i++){var currentDiagnostic=diagnostics[i],isDupe=0===compareDiagnostics(currentDiagnostic,previousDiagnostic);isDupe||(newDiagnostics.push(currentDiagnostic),previousDiagnostic=currentDiagnostic)}return newDiagnostics}function normalizeSlashes(path){return path.replace(/\\/g,"/")}function getRootLength(path){if(47===path.charCodeAt(0)){if(47!==path.charCodeAt(1))return 1;var p1=path.indexOf("/",2);if(p1<0)return 2;var p2=path.indexOf("/",p1+1);return p2<0?p1+1:p2+1}if(58===path.charCodeAt(1))return 47===path.charCodeAt(2)?3:2;if(0===path.lastIndexOf("file:///",0))return"file:///".length;var idx=path.indexOf("://");return idx!==-1?idx+"://".length:0}function getNormalizedParts(normalizedSlashedPath,rootLength){for(var parts=normalizedSlashedPath.substr(rootLength).split(ts.directorySeparator),normalized=[],_i=0,parts_1=parts;_i<parts_1.length;_i++){var part=parts_1[_i];"."!==part&&(".."===part&&normalized.length>0&&".."!==lastOrUndefined(normalized)?normalized.pop():part&&normalized.push(part))}return normalized}function normalizePath(path){path=normalizeSlashes(path);var rootLength=getRootLength(path),normalized=getNormalizedParts(path,rootLength);return path.substr(0,rootLength)+normalized.join(ts.directorySeparator)}function getDirectoryPath(path){return path.substr(0,Math.max(getRootLength(path),path.lastIndexOf(ts.directorySeparator)))}function isUrl(path){return path&&!isRootedDiskPath(path)&&path.indexOf("://")!==-1}function isRootedDiskPath(path){return 0!==getRootLength(path)}function normalizedPathComponents(path,rootLength){var normalizedParts=getNormalizedParts(path,rootLength);return[path.substr(0,rootLength)].concat(normalizedParts)}function getNormalizedPathComponents(path,currentDirectory){path=normalizeSlashes(path);var rootLength=getRootLength(path);return 0===rootLength&&(path=combinePaths(normalizeSlashes(currentDirectory),path),rootLength=getRootLength(path)),normalizedPathComponents(path,rootLength)}function getNormalizedAbsolutePath(fileName,currentDirectory){return getNormalizedPathFromPathComponents(getNormalizedPathComponents(fileName,currentDirectory))}function getNormalizedPathFromPathComponents(pathComponents){if(pathComponents&&pathComponents.length)return pathComponents[0]+pathComponents.slice(1).join(ts.directorySeparator)}function getNormalizedPathComponentsOfUrl(url){for(var urlLength=url.length,rootLength=url.indexOf("://")+"://".length;rootLength<urlLength&&47===url.charCodeAt(rootLength);)rootLength++;if(rootLength===urlLength)return[url];var indexOfNextSlash=url.indexOf(ts.directorySeparator,rootLength);return indexOfNextSlash!==-1?(rootLength=indexOfNextSlash+1,normalizedPathComponents(url,rootLength)):[url+ts.directorySeparator]}function getNormalizedPathOrUrlComponents(pathOrUrl,currentDirectory){return isUrl(pathOrUrl)?getNormalizedPathComponentsOfUrl(pathOrUrl):getNormalizedPathComponents(pathOrUrl,currentDirectory)}function getRelativePathToDirectoryOrUrl(directoryPathOrUrl,relativeOrAbsolutePath,currentDirectory,getCanonicalFileName,isAbsolutePathAnUrl){var pathComponents=getNormalizedPathOrUrlComponents(relativeOrAbsolutePath,currentDirectory),directoryComponents=getNormalizedPathOrUrlComponents(directoryPathOrUrl,currentDirectory);directoryComponents.length>1&&""===lastOrUndefined(directoryComponents)&&directoryComponents.length--;var joinStartIndex;for(joinStartIndex=0;joinStartIndex<pathComponents.length&&joinStartIndex<directoryComponents.length&&getCanonicalFileName(directoryComponents[joinStartIndex])===getCanonicalFileName(pathComponents[joinStartIndex]);joinStartIndex++);if(joinStartIndex){for(var relativePath="",relativePathComponents=pathComponents.slice(joinStartIndex,pathComponents.length);joinStartIndex<directoryComponents.length;joinStartIndex++)""!==directoryComponents[joinStartIndex]&&(relativePath=relativePath+".."+ts.directorySeparator);return relativePath+relativePathComponents.join(ts.directorySeparator)}var absolutePath=getNormalizedPathFromPathComponents(pathComponents);return isAbsolutePathAnUrl&&isRootedDiskPath(absolutePath)&&(absolutePath="file:///"+absolutePath),absolutePath}function getBaseFileName(path){if(void 0!==path){var i=path.lastIndexOf(ts.directorySeparator);return i<0?path:path.substring(i+1)}}function combinePaths(path1,path2){return path1&&path1.length?path2&&path2.length?0!==getRootLength(path2)?path2:path1.charAt(path1.length-1)===ts.directorySeparator?path1+path2:path1+ts.directorySeparator+path2:path1:path2}function fileExtensionIs(path,extension){var pathLen=path.length,extLen=extension.length;return pathLen>extLen&&path.substr(pathLen-extLen,extLen)===extension}function getSupportedExtensions(options){return options&&options.allowJs?allSupportedExtensions:ts.supportedTypeScriptExtensions}function isSupportedSourceFileName(fileName,compilerOptions){if(!fileName)return!1;for(var _i=0,_a=getSupportedExtensions(compilerOptions);_i<_a.length;_i++){var extension=_a[_i];if(fileExtensionIs(fileName,extension))return!0}return!1}function removeFileExtension(path){for(var _i=0,extensionsToRemove_1=extensionsToRemove;_i<extensionsToRemove_1.length;_i++){var ext=extensionsToRemove_1[_i];if(fileExtensionIs(path,ext))return path.substr(0,path.length-ext.length)}return path}function Symbol(flags,name){this.flags=flags,this.name=name,this.declarations=void 0}function Type(checker,flags){this.flags=flags}function Signature(checker){}function Node(kind,pos,end){this.kind=kind,this.pos=pos,this.end=end,this.flags=0,this.parent=void 0}function copyListRemovingItem(item,list){for(var copiedList=[],_i=0,list_1=list;_i<list_1.length;_i++){var e=list_1[_i];e!==item&&copiedList.push(e)}return copiedList}function createGetCanonicalFileName(useCaseSensitivefileNames){return useCaseSensitivefileNames?function(fileName){return fileName}:function(fileName){return fileName.toLowerCase()}}!function(Ternary){Ternary[Ternary.False=0]="False",Ternary[Ternary.Maybe=1]="Maybe",Ternary[Ternary.True=-1]="True"}(ts.Ternary||(ts.Ternary={}));ts.Ternary;ts.createFileMap=createFileMap,ts.toPath=toPath,function(Comparison){Comparison[Comparison.LessThan=-1]="LessThan",Comparison[Comparison.EqualTo=0]="EqualTo",Comparison[Comparison.GreaterThan=1]="GreaterThan"}(ts.Comparison||(ts.Comparison={}));ts.Comparison;ts.forEach=forEach,ts.contains=contains,ts.indexOf=indexOf,ts.countWhere=countWhere,ts.filter=filter,ts.map=map,ts.concatenate=concatenate,ts.deduplicate=deduplicate,ts.sum=sum,ts.addRange=addRange,ts.rangeEquals=rangeEquals,ts.lastOrUndefined=lastOrUndefined,ts.binarySearch=binarySearch,ts.reduceLeft=reduceLeft,ts.reduceRight=reduceRight;var hasOwnProperty=Object.prototype.hasOwnProperty;ts.hasProperty=hasProperty,ts.getProperty=getProperty,ts.isEmpty=isEmpty,ts.clone=clone,ts.extend=extend,ts.forEachValue=forEachValue,ts.forEachKey=forEachKey,ts.lookUp=lookUp,ts.copyMap=copyMap,ts.arrayToMap=arrayToMap,ts.reduceProperties=reduceProperties,ts.isArray=isArray,ts.memoize=memoize,ts.localizedDiagnosticMessages=void 0,ts.getLocaleSpecificMessage=getLocaleSpecificMessage,ts.createFileDiagnostic=createFileDiagnostic,ts.createCompilerDiagnostic=createCompilerDiagnostic,ts.chainDiagnosticMessages=chainDiagnosticMessages,ts.concatenateDiagnosticMessageChains=concatenateDiagnosticMessageChains,ts.compareValues=compareValues,ts.compareDiagnostics=compareDiagnostics,ts.sortAndDeduplicateDiagnostics=sortAndDeduplicateDiagnostics,ts.deduplicateSortedDiagnostics=deduplicateSortedDiagnostics,ts.normalizeSlashes=normalizeSlashes,ts.getRootLength=getRootLength,ts.directorySeparator="/",ts.normalizePath=normalizePath,ts.getDirectoryPath=getDirectoryPath,ts.isUrl=isUrl,ts.isRootedDiskPath=isRootedDiskPath,ts.getNormalizedPathComponents=getNormalizedPathComponents,ts.getNormalizedAbsolutePath=getNormalizedAbsolutePath,ts.getNormalizedPathFromPathComponents=getNormalizedPathFromPathComponents,ts.getRelativePathToDirectoryOrUrl=getRelativePathToDirectoryOrUrl,ts.getBaseFileName=getBaseFileName,ts.combinePaths=combinePaths,ts.fileExtensionIs=fileExtensionIs,ts.supportedTypeScriptExtensions=[".ts",".tsx",".d.ts"],ts.supportedJavascriptExtensions=[".js",".jsx"];var allSupportedExtensions=ts.supportedTypeScriptExtensions.concat(ts.supportedJavascriptExtensions);ts.getSupportedExtensions=getSupportedExtensions,ts.isSupportedSourceFileName=isSupportedSourceFileName;var extensionsToRemove=[".d.ts",".ts",".js",".tsx",".jsx"];ts.removeFileExtension=removeFileExtension,ts.objectAllocator={getNodeConstructor:function(){return Node},getSourceFileConstructor:function(){return Node},getSymbolConstructor:function(){return Symbol},getTypeConstructor:function(){return Type},getSignatureConstructor:function(){return Signature}},function(AssertionLevel){AssertionLevel[AssertionLevel.None=0]="None",AssertionLevel[AssertionLevel.Normal=1]="Normal",AssertionLevel[AssertionLevel.Aggressive=2]="Aggressive",AssertionLevel[AssertionLevel.VeryAggressive=3]="VeryAggressive"}(ts.AssertionLevel||(ts.AssertionLevel={}));var Debug;ts.AssertionLevel;!function(Debug){function shouldAssert(level){return currentAssertionLevel>=level}function assert(expression,message,verboseDebugInfo){if(!expression){var verboseDebugString="";throw verboseDebugInfo&&(verboseDebugString="\r\nVerbose Debug Information: "+verboseDebugInfo()),new Error("Debug Failure. False expression: "+(message||"")+verboseDebugString)}}function fail(message){Debug.assert(!1,message)}var currentAssertionLevel=0;Debug.shouldAssert=shouldAssert,Debug.assert=assert,Debug.fail=fail}(Debug=ts.Debug||(ts.Debug={})),ts.copyListRemovingItem=copyListRemovingItem,ts.createGetCanonicalFileName=createGetCanonicalFileName}(ts||(ts={}));var ts;!function(ts){ts.sys=function(){function getWScriptSystem(){function readFile(fileName,encoding){if(fso.FileExists(fileName)){fileStream.Open();try{if(encoding)fileStream.Charset=encoding,fileStream.LoadFromFile(fileName);else{fileStream.Charset="x-ansi",fileStream.LoadFromFile(fileName);var bom=fileStream.ReadText(2)||"";fileStream.Position=0,fileStream.Charset=bom.length>=2&&(255===bom.charCodeAt(0)&&254===bom.charCodeAt(1)||254===bom.charCodeAt(0)&&255===bom.charCodeAt(1))?"unicode":"utf-8"}return fileStream.ReadText()}catch(e){throw e}finally{fileStream.Close()}}}function writeFile(fileName,data,writeByteOrderMark){fileStream.Open(),binaryStream.Open();try{fileStream.Charset="utf-8",fileStream.WriteText(data),
writeByteOrderMark?fileStream.Position=0:fileStream.Position=3,fileStream.CopyTo(binaryStream),binaryStream.SaveToFile(fileName,2)}finally{binaryStream.Close(),fileStream.Close()}}function getCanonicalPath(path){return path.toLowerCase()}function getNames(collection){for(var result=[],e=new Enumerator(collection);!e.atEnd();e.moveNext())result.push(e.item().Name);return result.sort()}function readDirectory(path,extension,exclude){function visitDirectory(path){for(var folder=fso.GetFolder(path||"."),files=getNames(folder.files),_i=0,files_1=files;_i<files_1.length;_i++){var current=files_1[_i],name_1=ts.combinePaths(path,current);extension&&!ts.fileExtensionIs(name_1,extension)||ts.contains(exclude,getCanonicalPath(name_1))||result.push(name_1)}for(var subfolders=getNames(folder.subfolders),_a=0,subfolders_1=subfolders;_a<subfolders_1.length;_a++){var current=subfolders_1[_a],name_2=ts.combinePaths(path,current);ts.contains(exclude,getCanonicalPath(name_2))||visitDirectory(name_2)}}var result=[];return exclude=ts.map(exclude,function(s){return getCanonicalPath(ts.combinePaths(path,s))}),visitDirectory(path),result}var fso=new ActiveXObject("Scripting.FileSystemObject"),fileStream=new ActiveXObject("ADODB.Stream");fileStream.Type=2;var binaryStream=new ActiveXObject("ADODB.Stream");binaryStream.Type=1;for(var args=[],i=0;i<WScript.Arguments.length;i++)args[i]=WScript.Arguments.Item(i);return{args:args,newLine:"\r\n",useCaseSensitiveFileNames:!1,write:function(s){WScript.StdOut.Write(s)},readFile:readFile,writeFile:writeFile,resolvePath:function(path){return fso.GetAbsolutePathName(path)},fileExists:function(path){return fso.FileExists(path)},directoryExists:function(path){return fso.FolderExists(path)},createDirectory:function(directoryName){this.directoryExists(directoryName)||fso.CreateFolder(directoryName)},getExecutingFilePath:function(){return WScript.ScriptFullName},getCurrentDirectory:function(){return new ActiveXObject("WScript.Shell").CurrentDirectory},readDirectory:readDirectory,exit:function(exitCode){try{WScript.Quit(exitCode)}catch(e){}}}}function getNodeSystem(){function createPollingWatchedFileSet(interval,chunkSize){function getModifiedTime(fileName){return _fs.statSync(fileName).mtime}function poll(checkedIndex){var watchedFile=watchedFiles[checkedIndex];watchedFile&&_fs.stat(watchedFile.filePath,function(err,stats){err?watchedFile.callback(watchedFile.filePath):watchedFile.mtime.getTime()!==stats.mtime.getTime()&&(watchedFile.mtime=getModifiedTime(watchedFile.filePath),watchedFile.callback(watchedFile.filePath,0===watchedFile.mtime.getTime()))})}function startWatchTimer(){watchTimer=setInterval(function(){for(var count=0,nextToCheck=nextFileToCheck,firstCheck=-1;count<chunkSize&&nextToCheck!==firstCheck;)poll(nextToCheck),firstCheck<0&&(firstCheck=nextToCheck),nextToCheck++,nextToCheck===watchedFiles.length&&(nextToCheck=0),count++;nextFileToCheck=nextToCheck},interval)}function addFile(filePath,callback){var file={filePath:filePath,callback:callback,mtime:getModifiedTime(filePath)};return watchedFiles.push(file),1===watchedFiles.length&&startWatchTimer(),file}function removeFile(file){watchedFiles=ts.copyListRemovingItem(file,watchedFiles)}void 0===interval&&(interval=2500),void 0===chunkSize&&(chunkSize=30);var watchTimer,watchedFiles=[],nextFileToCheck=0;return{getModifiedTime:getModifiedTime,poll:poll,startWatchTimer:startWatchTimer,addFile:addFile,removeFile:removeFile}}function createWatchedFileSet(){function reduceDirWatcherRefCountForFile(filePath){var dirPath=ts.getDirectoryPath(filePath);if(dirWatchers.contains(dirPath)){var watcher=dirWatchers.get(dirPath);watcher.referenceCount-=1,watcher.referenceCount<=0&&(watcher.close(),dirWatchers.remove(dirPath))}}function addDirWatcher(dirPath){if(dirWatchers.contains(dirPath)){var watcher_1=dirWatchers.get(dirPath);return void(watcher_1.referenceCount+=1)}var watcher=_fs.watch(dirPath,{persistent:!0},function(eventName,relativeFileName){return fileEventHandler(eventName,relativeFileName,dirPath)});watcher.referenceCount=1,dirWatchers.set(dirPath,watcher)}function addFileWatcherCallback(filePath,callback){fileWatcherCallbacks.contains(filePath)?fileWatcherCallbacks.get(filePath).push(callback):fileWatcherCallbacks.set(filePath,[callback])}function addFile(filePath,callback){return addFileWatcherCallback(filePath,callback),addDirWatcher(ts.getDirectoryPath(filePath)),{filePath:filePath,callback:callback}}function removeFile(watchedFile){removeFileWatcherCallback(watchedFile.filePath,watchedFile.callback),reduceDirWatcherRefCountForFile(watchedFile.filePath)}function removeFileWatcherCallback(filePath,callback){if(fileWatcherCallbacks.contains(filePath)){var newCallbacks=ts.copyListRemovingItem(callback,fileWatcherCallbacks.get(filePath));0===newCallbacks.length?fileWatcherCallbacks.remove(filePath):fileWatcherCallbacks.set(filePath,newCallbacks)}}function fileEventHandler(eventName,relativeFileName,baseDirPath){var filePath="string"!=typeof relativeFileName?void 0:ts.toPath(relativeFileName,baseDirPath,ts.createGetCanonicalFileName(ts.sys.useCaseSensitiveFileNames));if(("change"===eventName||"rename"===eventName)&&fileWatcherCallbacks.contains(filePath))for(var _i=0,_a=fileWatcherCallbacks.get(filePath);_i<_a.length;_i++){var fileCallback=_a[_i];fileCallback(filePath)}}var dirWatchers=ts.createFileMap(),fileWatcherCallbacks=ts.createFileMap();return{addFile:addFile,removeFile:removeFile}}function isNode4OrLater(){return parseInt(process.version.charAt(1))>=4}function readFile(fileName,encoding){if(_fs.existsSync(fileName)){var buffer=_fs.readFileSync(fileName),len=buffer.length;if(len>=2&&254===buffer[0]&&255===buffer[1]){len&=-2;for(var i=0;i<len;i+=2){var temp=buffer[i];buffer[i]=buffer[i+1],buffer[i+1]=temp}return buffer.toString("utf16le",2)}return len>=2&&255===buffer[0]&&254===buffer[1]?buffer.toString("utf16le",2):len>=3&&239===buffer[0]&&187===buffer[1]&&191===buffer[2]?buffer.toString("utf8",3):buffer.toString("utf8")}}function writeFile(fileName,data,writeByteOrderMark){writeByteOrderMark&&(data="\ufeff"+data);var fd;try{fd=_fs.openSync(fileName,"w"),_fs.writeSync(fd,data,void 0,"utf8")}finally{void 0!==fd&&_fs.closeSync(fd)}}function getCanonicalPath(path){return useCaseSensitiveFileNames?path:path.toLowerCase()}function readDirectory(path,extension,exclude){function visitDirectory(path){for(var files=_fs.readdirSync(path||".").sort(),directories=[],_i=0,files_2=files;_i<files_2.length;_i++){var current=files_2[_i],name_3=ts.combinePaths(path,current);if(!ts.contains(exclude,getCanonicalPath(name_3))){var stat=_fs.statSync(name_3);stat.isFile()?extension&&!ts.fileExtensionIs(name_3,extension)||result.push(name_3):stat.isDirectory()&&directories.push(name_3)}}for(var _a=0,directories_1=directories;_a<directories_1.length;_a++){var current=directories_1[_a];visitDirectory(current)}}var result=[];return exclude=ts.map(exclude,function(s){return getCanonicalPath(ts.combinePaths(path,s))}),visitDirectory(path),result}var _fs=__webpack_require__(44),_path=__webpack_require__(193),_os=__webpack_require__(194),pollingWatchedFileSet=createPollingWatchedFileSet(),watchedFileSet=createWatchedFileSet(),platform=_os.platform(),useCaseSensitiveFileNames="win32"!==platform&&"win64"!==platform&&"darwin"!==platform;return{args:process.argv.slice(2),newLine:_os.EOL,useCaseSensitiveFileNames:useCaseSensitiveFileNames,write:function(s){process.stdout.write(s)},readFile:readFile,writeFile:writeFile,watchFile:function(filePath,callback){var watchSet=isNode4OrLater()?watchedFileSet:pollingWatchedFileSet,watchedFile=watchSet.addFile(filePath,callback);return{close:function(){return watchSet.removeFile(watchedFile)}}},watchDirectory:function(path,callback,recursive){var options;return options=!isNode4OrLater()||"win32"!==process.platform&&"darwin"!==process.platform?{persistent:!0}:{persistent:!0,recursive:!!recursive},_fs.watch(path,options,function(eventName,relativeFileName){"rename"===eventName&&callback(relativeFileName?ts.normalizePath(ts.combinePaths(path,relativeFileName)):relativeFileName)})},resolvePath:function(path){return _path.resolve(path)},fileExists:function(path){return _fs.existsSync(path)},directoryExists:function(path){return _fs.existsSync(path)&&_fs.statSync(path).isDirectory()},createDirectory:function(directoryName){this.directoryExists(directoryName)||_fs.mkdirSync(directoryName)},getExecutingFilePath:function(){return __filename},getCurrentDirectory:function(){return process.cwd()},readDirectory:readDirectory,getMemoryUsage:function(){return global.gc&&global.gc(),process.memoryUsage().heapUsed},exit:function(exitCode){process.exit(exitCode)}}}function getChakraSystem(){return{newLine:ChakraHost.newLine||"\r\n",args:ChakraHost.args,useCaseSensitiveFileNames:!!ChakraHost.useCaseSensitiveFileNames,write:ChakraHost.echo,readFile:function(path,encoding){return ChakraHost.readFile(path)},writeFile:function(path,data,writeByteOrderMark){writeByteOrderMark&&(data="\ufeff"+data),ChakraHost.writeFile(path,data)},resolvePath:ChakraHost.resolvePath,fileExists:ChakraHost.fileExists,directoryExists:ChakraHost.directoryExists,createDirectory:ChakraHost.createDirectory,getExecutingFilePath:function(){return ChakraHost.executingFile},getCurrentDirectory:function(){return ChakraHost.currentDirectory},readDirectory:ChakraHost.readDirectory,exit:ChakraHost.quit}}return"undefined"!=typeof WScript&&"function"==typeof ActiveXObject?getWScriptSystem():"undefined"!=typeof process&&process.nextTick&&!process.browser?getNodeSystem():"undefined"!=typeof ChakraHost?getChakraSystem():void 0}()}(ts||(ts={}));var ts;!function(ts){ts.Diagnostics={Unterminated_string_literal:{code:1002,category:ts.DiagnosticCategory.Error,key:"Unterminated_string_literal_1002",message:"Unterminated string literal."},Identifier_expected:{code:1003,category:ts.DiagnosticCategory.Error,key:"Identifier_expected_1003",message:"Identifier expected."},_0_expected:{code:1005,category:ts.DiagnosticCategory.Error,key:"_0_expected_1005",message:"'{0}' expected."},A_file_cannot_have_a_reference_to_itself:{code:1006,category:ts.DiagnosticCategory.Error,key:"A_file_cannot_have_a_reference_to_itself_1006",message:"A file cannot have a reference to itself."},Trailing_comma_not_allowed:{code:1009,category:ts.DiagnosticCategory.Error,key:"Trailing_comma_not_allowed_1009",message:"Trailing comma not allowed."},Asterisk_Slash_expected:{code:1010,category:ts.DiagnosticCategory.Error,key:"Asterisk_Slash_expected_1010",message:"'*/' expected."},Unexpected_token:{code:1012,category:ts.DiagnosticCategory.Error,key:"Unexpected_token_1012",message:"Unexpected token."},A_rest_parameter_must_be_last_in_a_parameter_list:{code:1014,category:ts.DiagnosticCategory.Error,key:"A_rest_parameter_must_be_last_in_a_parameter_list_1014",message:"A rest parameter must be last in a parameter list."},Parameter_cannot_have_question_mark_and_initializer:{code:1015,category:ts.DiagnosticCategory.Error,key:"Parameter_cannot_have_question_mark_and_initializer_1015",message:"Parameter cannot have question mark and initializer."},A_required_parameter_cannot_follow_an_optional_parameter:{code:1016,category:ts.DiagnosticCategory.Error,key:"A_required_parameter_cannot_follow_an_optional_parameter_1016",message:"A required parameter cannot follow an optional parameter."},An_index_signature_cannot_have_a_rest_parameter:{code:1017,category:ts.DiagnosticCategory.Error,key:"An_index_signature_cannot_have_a_rest_parameter_1017",message:"An index signature cannot have a rest parameter."},An_index_signature_parameter_cannot_have_an_accessibility_modifier:{code:1018,category:ts.DiagnosticCategory.Error,key:"An_index_signature_parameter_cannot_have_an_accessibility_modifier_1018",message:"An index signature parameter cannot have an accessibility modifier."},An_index_signature_parameter_cannot_have_a_question_mark:{code:1019,category:ts.DiagnosticCategory.Error,key:"An_index_signature_parameter_cannot_have_a_question_mark_1019",message:"An index signature parameter cannot have a question mark."},An_index_signature_parameter_cannot_have_an_initializer:{code:1020,category:ts.DiagnosticCategory.Error,key:"An_index_signature_parameter_cannot_have_an_initializer_1020",message:"An index signature parameter cannot have an initializer."},An_index_signature_must_have_a_type_annotation:{code:1021,category:ts.DiagnosticCategory.Error,key:"An_index_signature_must_have_a_type_annotation_1021",message:"An index signature must have a type annotation."},An_index_signature_parameter_must_have_a_type_annotation:{code:1022,category:ts.DiagnosticCategory.Error,key:"An_index_signature_parameter_must_have_a_type_annotation_1022",message:"An index signature parameter must have a type annotation."},An_index_signature_parameter_type_must_be_string_or_number:{code:1023,category:ts.DiagnosticCategory.Error,key:"An_index_signature_parameter_type_must_be_string_or_number_1023",message:"An index signature parameter type must be 'string' or 'number'."},Accessibility_modifier_already_seen:{code:1028,category:ts.DiagnosticCategory.Error,key:"Accessibility_modifier_already_seen_1028",message:"Accessibility modifier already seen."},_0_modifier_must_precede_1_modifier:{code:1029,category:ts.DiagnosticCategory.Error,key:"_0_modifier_must_precede_1_modifier_1029",message:"'{0}' modifier must precede '{1}' modifier."},_0_modifier_already_seen:{code:1030,category:ts.DiagnosticCategory.Error,key:"_0_modifier_already_seen_1030",message:"'{0}' modifier already seen."},_0_modifier_cannot_appear_on_a_class_element:{code:1031,category:ts.DiagnosticCategory.Error,key:"_0_modifier_cannot_appear_on_a_class_element_1031",message:"'{0}' modifier cannot appear on a class element."},super_must_be_followed_by_an_argument_list_or_member_access:{code:1034,category:ts.DiagnosticCategory.Error,key:"super_must_be_followed_by_an_argument_list_or_member_access_1034",message:"'super' must be followed by an argument list or member access."},Only_ambient_modules_can_use_quoted_names:{code:1035,category:ts.DiagnosticCategory.Error,key:"Only_ambient_modules_can_use_quoted_names_1035",message:"Only ambient modules can use quoted names."},Statements_are_not_allowed_in_ambient_contexts:{code:1036,category:ts.DiagnosticCategory.Error,key:"Statements_are_not_allowed_in_ambient_contexts_1036",message:"Statements are not allowed in ambient contexts."},A_declare_modifier_cannot_be_used_in_an_already_ambient_context:{code:1038,category:ts.DiagnosticCategory.Error,key:"A_declare_modifier_cannot_be_used_in_an_already_ambient_context_1038",message:"A 'declare' modifier cannot be used in an already ambient context."},Initializers_are_not_allowed_in_ambient_contexts:{code:1039,category:ts.DiagnosticCategory.Error,key:"Initializers_are_not_allowed_in_ambient_contexts_1039",message:"Initializers are not allowed in ambient contexts."},_0_modifier_cannot_be_used_in_an_ambient_context:{code:1040,category:ts.DiagnosticCategory.Error,key:"_0_modifier_cannot_be_used_in_an_ambient_context_1040",message:"'{0}' modifier cannot be used in an ambient context."},_0_modifier_cannot_be_used_with_a_class_declaration:{code:1041,category:ts.DiagnosticCategory.Error,key:"_0_modifier_cannot_be_used_with_a_class_declaration_1041",message:"'{0}' modifier cannot be used with a class declaration."},_0_modifier_cannot_be_used_here:{code:1042,category:ts.DiagnosticCategory.Error,key:"_0_modifier_cannot_be_used_here_1042",message:"'{0}' modifier cannot be used here."},_0_modifier_cannot_appear_on_a_data_property:{code:1043,category:ts.DiagnosticCategory.Error,key:"_0_modifier_cannot_appear_on_a_data_property_1043",message:"'{0}' modifier cannot appear on a data property."},_0_modifier_cannot_appear_on_a_module_element:{code:1044,category:ts.DiagnosticCategory.Error,key:"_0_modifier_cannot_appear_on_a_module_element_1044",message:"'{0}' modifier cannot appear on a module element."},A_0_modifier_cannot_be_used_with_an_interface_declaration:{code:1045,category:ts.DiagnosticCategory.Error,key:"A_0_modifier_cannot_be_used_with_an_interface_declaration_1045",message:"A '{0}' modifier cannot be used with an interface declaration."},A_declare_modifier_is_required_for_a_top_level_declaration_in_a_d_ts_file:{code:1046,category:ts.DiagnosticCategory.Error,key:"A_declare_modifier_is_required_for_a_top_level_declaration_in_a_d_ts_file_1046",message:"A 'declare' modifier is required for a top level declaration in a .d.ts file."},A_rest_parameter_cannot_be_optional:{code:1047,category:ts.DiagnosticCategory.Error,key:"A_rest_parameter_cannot_be_optional_1047",message:"A rest parameter cannot be optional."},A_rest_parameter_cannot_have_an_initializer:{code:1048,category:ts.DiagnosticCategory.Error,key:"A_rest_parameter_cannot_have_an_initializer_1048",message:"A rest parameter cannot have an initializer."},A_set_accessor_must_have_exactly_one_parameter:{code:1049,category:ts.DiagnosticCategory.Error,key:"A_set_accessor_must_have_exactly_one_parameter_1049",message:"A 'set' accessor must have exactly one parameter."},A_set_accessor_cannot_have_an_optional_parameter:{code:1051,category:ts.DiagnosticCategory.Error,key:"A_set_accessor_cannot_have_an_optional_parameter_1051",message:"A 'set' accessor cannot have an optional parameter."},A_set_accessor_parameter_cannot_have_an_initializer:{code:1052,category:ts.DiagnosticCategory.Error,key:"A_set_accessor_parameter_cannot_have_an_initializer_1052",message:"A 'set' accessor parameter cannot have an initializer."},A_set_accessor_cannot_have_rest_parameter:{code:1053,category:ts.DiagnosticCategory.Error,key:"A_set_accessor_cannot_have_rest_parameter_1053",message:"A 'set' accessor cannot have rest parameter."},A_get_accessor_cannot_have_parameters:{code:1054,category:ts.DiagnosticCategory.Error,key:"A_get_accessor_cannot_have_parameters_1054",message:"A 'get' accessor cannot have parameters."},Type_0_is_not_a_valid_async_function_return_type:{code:1055,category:ts.DiagnosticCategory.Error,key:"Type_0_is_not_a_valid_async_function_return_type_1055",message:"Type '{0}' is not a valid async function return type."},Accessors_are_only_available_when_targeting_ECMAScript_5_and_higher:{code:1056,category:ts.DiagnosticCategory.Error,key:"Accessors_are_only_available_when_targeting_ECMAScript_5_and_higher_1056",message:"Accessors are only available when targeting ECMAScript 5 and higher."},An_async_function_or_method_must_have_a_valid_awaitable_return_type:{code:1057,category:ts.DiagnosticCategory.Error,key:"An_async_function_or_method_must_have_a_valid_awaitable_return_type_1057",message:"An async function or method must have a valid awaitable return type."},Operand_for_await_does_not_have_a_valid_callable_then_member:{code:1058,category:ts.DiagnosticCategory.Error,key:"Operand_for_await_does_not_have_a_valid_callable_then_member_1058",message:"Operand for 'await' does not have a valid callable 'then' member."},Return_expression_in_async_function_does_not_have_a_valid_callable_then_member:{code:1059,category:ts.DiagnosticCategory.Error,key:"Return_expression_in_async_function_does_not_have_a_valid_callable_then_member_1059",message:"Return expression in async function does not have a valid callable 'then' member."},Expression_body_for_async_arrow_function_does_not_have_a_valid_callable_then_member:{code:1060,category:ts.DiagnosticCategory.Error,key:"Expression_body_for_async_arrow_function_does_not_have_a_valid_callable_then_member_1060",message:"Expression body for async arrow function does not have a valid callable 'then' member."},Enum_member_must_have_initializer:{code:1061,category:ts.DiagnosticCategory.Error,key:"Enum_member_must_have_initializer_1061",message:"Enum member must have initializer."},_0_is_referenced_directly_or_indirectly_in_the_fulfillment_callback_of_its_own_then_method:{code:1062,category:ts.DiagnosticCategory.Error,key:"_0_is_referenced_directly_or_indirectly_in_the_fulfillment_callback_of_its_own_then_method_1062",message:"{0} is referenced directly or indirectly in the fulfillment callback of its own 'then' method."},An_export_assignment_cannot_be_used_in_a_namespace:{code:1063,category:ts.DiagnosticCategory.Error,key:"An_export_assignment_cannot_be_used_in_a_namespace_1063",message:"An export assignment cannot be used in a namespace."},The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type:{code:1064,category:ts.DiagnosticCategory.Error,key:"The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type_1064",message:"The return type of an async function or method must be the global Promise<T> type."},In_ambient_enum_declarations_member_initializer_must_be_constant_expression:{code:1066,category:ts.DiagnosticCategory.Error,key:"In_ambient_enum_declarations_member_initializer_must_be_constant_expression_1066",message:"In ambient enum declarations member initializer must be constant expression."},Unexpected_token_A_constructor_method_accessor_or_property_was_expected:{code:1068,category:ts.DiagnosticCategory.Error,key:"Unexpected_token_A_constructor_method_accessor_or_property_was_expected_1068",message:"Unexpected token. A constructor, method, accessor, or property was expected."},A_0_modifier_cannot_be_used_with_an_import_declaration:{code:1079,category:ts.DiagnosticCategory.Error,key:"A_0_modifier_cannot_be_used_with_an_import_declaration_1079",message:"A '{0}' modifier cannot be used with an import declaration."},Invalid_reference_directive_syntax:{code:1084,category:ts.DiagnosticCategory.Error,key:"Invalid_reference_directive_syntax_1084",message:"Invalid 'reference' directive syntax."},Octal_literals_are_not_available_when_targeting_ECMAScript_5_and_higher:{code:1085,category:ts.DiagnosticCategory.Error,key:"Octal_literals_are_not_available_when_targeting_ECMAScript_5_and_higher_1085",message:"Octal literals are not available when targeting ECMAScript 5 and higher."},An_accessor_cannot_be_declared_in_an_ambient_context:{code:1086,category:ts.DiagnosticCategory.Error,key:"An_accessor_cannot_be_declared_in_an_ambient_context_1086",message:"An accessor cannot be declared in an ambient context."},_0_modifier_cannot_appear_on_a_constructor_declaration:{code:1089,category:ts.DiagnosticCategory.Error,key:"_0_modifier_cannot_appear_on_a_constructor_declaration_1089",message:"'{0}' modifier cannot appear on a constructor declaration."},_0_modifier_cannot_appear_on_a_parameter:{code:1090,category:ts.DiagnosticCategory.Error,key:"_0_modifier_cannot_appear_on_a_parameter_1090",message:"'{0}' modifier cannot appear on a parameter."},Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement:{code:1091,category:ts.DiagnosticCategory.Error,key:"Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement_1091",message:"Only a single variable declaration is allowed in a 'for...in' statement."},Type_parameters_cannot_appear_on_a_constructor_declaration:{code:1092,category:ts.DiagnosticCategory.Error,key:"Type_parameters_cannot_appear_on_a_constructor_declaration_1092",message:"Type parameters cannot appear on a constructor declaration."},Type_annotation_cannot_appear_on_a_constructor_declaration:{code:1093,category:ts.DiagnosticCategory.Error,key:"Type_annotation_cannot_appear_on_a_constructor_declaration_1093",message:"Type annotation cannot appear on a constructor declaration."},An_accessor_cannot_have_type_parameters:{code:1094,category:ts.DiagnosticCategory.Error,key:"An_accessor_cannot_have_type_parameters_1094",message:"An accessor cannot have type parameters."},A_set_accessor_cannot_have_a_return_type_annotation:{code:1095,category:ts.DiagnosticCategory.Error,key:"A_set_accessor_cannot_have_a_return_type_annotation_1095",message:"A 'set' accessor cannot have a return type annotation."},An_index_signature_must_have_exactly_one_parameter:{code:1096,category:ts.DiagnosticCategory.Error,key:"An_index_signature_must_have_exactly_one_parameter_1096",message:"An index signature must have exactly one parameter."},_0_list_cannot_be_empty:{code:1097,category:ts.DiagnosticCategory.Error,key:"_0_list_cannot_be_empty_1097",message:"'{0}' list cannot be empty."},Type_parameter_list_cannot_be_empty:{code:1098,category:ts.DiagnosticCategory.Error,key:"Type_parameter_list_cannot_be_empty_1098",message:"Type parameter list cannot be empty."},Type_argument_list_cannot_be_empty:{code:1099,category:ts.DiagnosticCategory.Error,key:"Type_argument_list_cannot_be_empty_1099",message:"Type argument list cannot be empty."},Invalid_use_of_0_in_strict_mode:{code:1100,category:ts.DiagnosticCategory.Error,key:"Invalid_use_of_0_in_strict_mode_1100",message:"Invalid use of '{0}' in strict mode."},with_statements_are_not_allowed_in_strict_mode:{code:1101,category:ts.DiagnosticCategory.Error,key:"with_statements_are_not_allowed_in_strict_mode_1101",message:"'with' statements are not allowed in strict mode."},delete_cannot_be_called_on_an_identifier_in_strict_mode:{code:1102,category:ts.DiagnosticCategory.Error,key:"delete_cannot_be_called_on_an_identifier_in_strict_mode_1102",message:"'delete' cannot be called on an identifier in strict mode."},A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement:{code:1104,category:ts.DiagnosticCategory.Error,key:"A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement_1104",message:"A 'continue' statement can only be used within an enclosing iteration statement."},A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement:{code:1105,category:ts.DiagnosticCategory.Error,key:"A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement_1105",message:"A 'break' statement can only be used within an enclosing iteration or switch statement."},Jump_target_cannot_cross_function_boundary:{code:1107,category:ts.DiagnosticCategory.Error,key:"Jump_target_cannot_cross_function_boundary_1107",message:"Jump target cannot cross function boundary."},A_return_statement_can_only_be_used_within_a_function_body:{code:1108,category:ts.DiagnosticCategory.Error,key:"A_return_statement_can_only_be_used_within_a_function_body_1108",message:"A 'return' statement can only be used within a function body."},Expression_expected:{code:1109,category:ts.DiagnosticCategory.Error,key:"Expression_expected_1109",message:"Expression expected."},Type_expected:{code:1110,category:ts.DiagnosticCategory.Error,key:"Type_expected_1110",message:"Type expected."},A_class_member_cannot_be_declared_optional:{code:1112,category:ts.DiagnosticCategory.Error,key:"A_class_member_cannot_be_declared_optional_1112",message:"A class member cannot be declared optional."},A_default_clause_cannot_appear_more_than_once_in_a_switch_statement:{code:1113,category:ts.DiagnosticCategory.Error,key:"A_default_clause_cannot_appear_more_than_once_in_a_switch_statement_1113",message:"A 'default' clause cannot appear more than once in a 'switch' statement."},Duplicate_label_0:{code:1114,category:ts.DiagnosticCategory.Error,key:"Duplicate_label_0_1114",message:"Duplicate label '{0}'"},A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement:{code:1115,category:ts.DiagnosticCategory.Error,key:"A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement_1115",message:"A 'continue' statement can only jump to a label of an enclosing iteration statement."},A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement:{code:1116,category:ts.DiagnosticCategory.Error,key:"A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement_1116",message:"A 'break' statement can only jump to a label of an enclosing statement."},An_object_literal_cannot_have_multiple_properties_with_the_same_name_in_strict_mode:{code:1117,category:ts.DiagnosticCategory.Error,key:"An_object_literal_cannot_have_multiple_properties_with_the_same_name_in_strict_mode_1117",message:"An object literal cannot have multiple properties with the same name in strict mode."},An_object_literal_cannot_have_multiple_get_Slashset_accessors_with_the_same_name:{code:1118,category:ts.DiagnosticCategory.Error,key:"An_object_literal_cannot_have_multiple_get_Slashset_accessors_with_the_same_name_1118",message:"An object literal cannot have multiple get/set accessors with the same name."},An_object_literal_cannot_have_property_and_accessor_with_the_same_name:{code:1119,category:ts.DiagnosticCategory.Error,key:"An_object_literal_cannot_have_property_and_accessor_with_the_same_name_1119",message:"An object literal cannot have property and accessor with the same name."},An_export_assignment_cannot_have_modifiers:{code:1120,category:ts.DiagnosticCategory.Error,key:"An_export_assignment_cannot_have_modifiers_1120",message:"An export assignment cannot have modifiers."},Octal_literals_are_not_allowed_in_strict_mode:{code:1121,category:ts.DiagnosticCategory.Error,key:"Octal_literals_are_not_allowed_in_strict_mode_1121",message:"Octal literals are not allowed in strict mode."},A_tuple_type_element_list_cannot_be_empty:{code:1122,category:ts.DiagnosticCategory.Error,key:"A_tuple_type_element_list_cannot_be_empty_1122",message:"A tuple type element list cannot be empty."},Variable_declaration_list_cannot_be_empty:{code:1123,category:ts.DiagnosticCategory.Error,key:"Variable_declaration_list_cannot_be_empty_1123",message:"Variable declaration list cannot be empty."},Digit_expected:{code:1124,category:ts.DiagnosticCategory.Error,key:"Digit_expected_1124",message:"Digit expected."},Hexadecimal_digit_expected:{code:1125,category:ts.DiagnosticCategory.Error,key:"Hexadecimal_digit_expected_1125",message:"Hexadecimal digit expected."},Unexpected_end_of_text:{code:1126,category:ts.DiagnosticCategory.Error,key:"Unexpected_end_of_text_1126",message:"Unexpected end of text."},Invalid_character:{code:1127,category:ts.DiagnosticCategory.Error,key:"Invalid_character_1127",message:"Invalid character."},Declaration_or_statement_expected:{code:1128,category:ts.DiagnosticCategory.Error,key:"Declaration_or_statement_expected_1128",message:"Declaration or statement expected."},Statement_expected:{code:1129,category:ts.DiagnosticCategory.Error,key:"Statement_expected_1129",message:"Statement expected."},case_or_default_expected:{code:1130,category:ts.DiagnosticCategory.Error,key:"case_or_default_expected_1130",message:"'case' or 'default' expected."},Property_or_signature_expected:{code:1131,category:ts.DiagnosticCategory.Error,key:"Property_or_signature_expected_1131",message:"Property or signature expected."},Enum_member_expected:{code:1132,category:ts.DiagnosticCategory.Error,key:"Enum_member_expected_1132",message:"Enum member expected."},Variable_declaration_expected:{code:1134,category:ts.DiagnosticCategory.Error,key:"Variable_declaration_expected_1134",message:"Variable declaration expected."},Argument_expression_expected:{code:1135,category:ts.DiagnosticCategory.Error,key:"Argument_expression_expected_1135",message:"Argument expression expected."},Property_assignment_expected:{code:1136,category:ts.DiagnosticCategory.Error,key:"Property_assignment_expected_1136",message:"Property assignment expected."},Expression_or_comma_expected:{code:1137,category:ts.DiagnosticCategory.Error,key:"Expression_or_comma_expected_1137",message:"Expression or comma expected."},Parameter_declaration_expected:{code:1138,category:ts.DiagnosticCategory.Error,key:"Parameter_declaration_expected_1138",message:"Parameter declaration expected."},Type_parameter_declaration_expected:{code:1139,category:ts.DiagnosticCategory.Error,key:"Type_parameter_declaration_expected_1139",message:"Type parameter declaration expected."},Type_argument_expected:{code:1140,category:ts.DiagnosticCategory.Error,key:"Type_argument_expected_1140",message:"Type argument expected."},String_literal_expected:{code:1141,category:ts.DiagnosticCategory.Error,key:"String_literal_expected_1141",message:"String literal expected."},Line_break_not_permitted_here:{code:1142,category:ts.DiagnosticCategory.Error,
key:"Line_break_not_permitted_here_1142",message:"Line break not permitted here."},or_expected:{code:1144,category:ts.DiagnosticCategory.Error,key:"or_expected_1144",message:"'{' or ';' expected."},Modifiers_not_permitted_on_index_signature_members:{code:1145,category:ts.DiagnosticCategory.Error,key:"Modifiers_not_permitted_on_index_signature_members_1145",message:"Modifiers not permitted on index signature members."},Declaration_expected:{code:1146,category:ts.DiagnosticCategory.Error,key:"Declaration_expected_1146",message:"Declaration expected."},Import_declarations_in_a_namespace_cannot_reference_a_module:{code:1147,category:ts.DiagnosticCategory.Error,key:"Import_declarations_in_a_namespace_cannot_reference_a_module_1147",message:"Import declarations in a namespace cannot reference a module."},Cannot_compile_modules_unless_the_module_flag_is_provided_with_a_valid_module_type_Consider_setting_the_module_compiler_option_in_a_tsconfig_json_file:{code:1148,category:ts.DiagnosticCategory.Error,key:"Cannot_compile_modules_unless_the_module_flag_is_provided_with_a_valid_module_type_Consider_setting__1148",message:"Cannot compile modules unless the '--module' flag is provided with a valid module type. Consider setting the 'module' compiler option in a 'tsconfig.json' file."},File_name_0_differs_from_already_included_file_name_1_only_in_casing:{code:1149,category:ts.DiagnosticCategory.Error,key:"File_name_0_differs_from_already_included_file_name_1_only_in_casing_1149",message:"File name '{0}' differs from already included file name '{1}' only in casing"},new_T_cannot_be_used_to_create_an_array_Use_new_Array_T_instead:{code:1150,category:ts.DiagnosticCategory.Error,key:"new_T_cannot_be_used_to_create_an_array_Use_new_Array_T_instead_1150",message:"'new T[]' cannot be used to create an array. Use 'new Array<T>()' instead."},const_declarations_must_be_initialized:{code:1155,category:ts.DiagnosticCategory.Error,key:"const_declarations_must_be_initialized_1155",message:"'const' declarations must be initialized"},const_declarations_can_only_be_declared_inside_a_block:{code:1156,category:ts.DiagnosticCategory.Error,key:"const_declarations_can_only_be_declared_inside_a_block_1156",message:"'const' declarations can only be declared inside a block."},let_declarations_can_only_be_declared_inside_a_block:{code:1157,category:ts.DiagnosticCategory.Error,key:"let_declarations_can_only_be_declared_inside_a_block_1157",message:"'let' declarations can only be declared inside a block."},Unterminated_template_literal:{code:1160,category:ts.DiagnosticCategory.Error,key:"Unterminated_template_literal_1160",message:"Unterminated template literal."},Unterminated_regular_expression_literal:{code:1161,category:ts.DiagnosticCategory.Error,key:"Unterminated_regular_expression_literal_1161",message:"Unterminated regular expression literal."},An_object_member_cannot_be_declared_optional:{code:1162,category:ts.DiagnosticCategory.Error,key:"An_object_member_cannot_be_declared_optional_1162",message:"An object member cannot be declared optional."},A_yield_expression_is_only_allowed_in_a_generator_body:{code:1163,category:ts.DiagnosticCategory.Error,key:"A_yield_expression_is_only_allowed_in_a_generator_body_1163",message:"A 'yield' expression is only allowed in a generator body."},Computed_property_names_are_not_allowed_in_enums:{code:1164,category:ts.DiagnosticCategory.Error,key:"Computed_property_names_are_not_allowed_in_enums_1164",message:"Computed property names are not allowed in enums."},A_computed_property_name_in_an_ambient_context_must_directly_refer_to_a_built_in_symbol:{code:1165,category:ts.DiagnosticCategory.Error,key:"A_computed_property_name_in_an_ambient_context_must_directly_refer_to_a_built_in_symbol_1165",message:"A computed property name in an ambient context must directly refer to a built-in symbol."},A_computed_property_name_in_a_class_property_declaration_must_directly_refer_to_a_built_in_symbol:{code:1166,category:ts.DiagnosticCategory.Error,key:"A_computed_property_name_in_a_class_property_declaration_must_directly_refer_to_a_built_in_symbol_1166",message:"A computed property name in a class property declaration must directly refer to a built-in symbol."},A_computed_property_name_in_a_method_overload_must_directly_refer_to_a_built_in_symbol:{code:1168,category:ts.DiagnosticCategory.Error,key:"A_computed_property_name_in_a_method_overload_must_directly_refer_to_a_built_in_symbol_1168",message:"A computed property name in a method overload must directly refer to a built-in symbol."},A_computed_property_name_in_an_interface_must_directly_refer_to_a_built_in_symbol:{code:1169,category:ts.DiagnosticCategory.Error,key:"A_computed_property_name_in_an_interface_must_directly_refer_to_a_built_in_symbol_1169",message:"A computed property name in an interface must directly refer to a built-in symbol."},A_computed_property_name_in_a_type_literal_must_directly_refer_to_a_built_in_symbol:{code:1170,category:ts.DiagnosticCategory.Error,key:"A_computed_property_name_in_a_type_literal_must_directly_refer_to_a_built_in_symbol_1170",message:"A computed property name in a type literal must directly refer to a built-in symbol."},A_comma_expression_is_not_allowed_in_a_computed_property_name:{code:1171,category:ts.DiagnosticCategory.Error,key:"A_comma_expression_is_not_allowed_in_a_computed_property_name_1171",message:"A comma expression is not allowed in a computed property name."},extends_clause_already_seen:{code:1172,category:ts.DiagnosticCategory.Error,key:"extends_clause_already_seen_1172",message:"'extends' clause already seen."},extends_clause_must_precede_implements_clause:{code:1173,category:ts.DiagnosticCategory.Error,key:"extends_clause_must_precede_implements_clause_1173",message:"'extends' clause must precede 'implements' clause."},Classes_can_only_extend_a_single_class:{code:1174,category:ts.DiagnosticCategory.Error,key:"Classes_can_only_extend_a_single_class_1174",message:"Classes can only extend a single class."},implements_clause_already_seen:{code:1175,category:ts.DiagnosticCategory.Error,key:"implements_clause_already_seen_1175",message:"'implements' clause already seen."},Interface_declaration_cannot_have_implements_clause:{code:1176,category:ts.DiagnosticCategory.Error,key:"Interface_declaration_cannot_have_implements_clause_1176",message:"Interface declaration cannot have 'implements' clause."},Binary_digit_expected:{code:1177,category:ts.DiagnosticCategory.Error,key:"Binary_digit_expected_1177",message:"Binary digit expected."},Octal_digit_expected:{code:1178,category:ts.DiagnosticCategory.Error,key:"Octal_digit_expected_1178",message:"Octal digit expected."},Unexpected_token_expected:{code:1179,category:ts.DiagnosticCategory.Error,key:"Unexpected_token_expected_1179",message:"Unexpected token. '{' expected."},Property_destructuring_pattern_expected:{code:1180,category:ts.DiagnosticCategory.Error,key:"Property_destructuring_pattern_expected_1180",message:"Property destructuring pattern expected."},Array_element_destructuring_pattern_expected:{code:1181,category:ts.DiagnosticCategory.Error,key:"Array_element_destructuring_pattern_expected_1181",message:"Array element destructuring pattern expected."},A_destructuring_declaration_must_have_an_initializer:{code:1182,category:ts.DiagnosticCategory.Error,key:"A_destructuring_declaration_must_have_an_initializer_1182",message:"A destructuring declaration must have an initializer."},An_implementation_cannot_be_declared_in_ambient_contexts:{code:1183,category:ts.DiagnosticCategory.Error,key:"An_implementation_cannot_be_declared_in_ambient_contexts_1183",message:"An implementation cannot be declared in ambient contexts."},Modifiers_cannot_appear_here:{code:1184,category:ts.DiagnosticCategory.Error,key:"Modifiers_cannot_appear_here_1184",message:"Modifiers cannot appear here."},Merge_conflict_marker_encountered:{code:1185,category:ts.DiagnosticCategory.Error,key:"Merge_conflict_marker_encountered_1185",message:"Merge conflict marker encountered."},A_rest_element_cannot_have_an_initializer:{code:1186,category:ts.DiagnosticCategory.Error,key:"A_rest_element_cannot_have_an_initializer_1186",message:"A rest element cannot have an initializer."},A_parameter_property_may_not_be_a_binding_pattern:{code:1187,category:ts.DiagnosticCategory.Error,key:"A_parameter_property_may_not_be_a_binding_pattern_1187",message:"A parameter property may not be a binding pattern."},Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement:{code:1188,category:ts.DiagnosticCategory.Error,key:"Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement_1188",message:"Only a single variable declaration is allowed in a 'for...of' statement."},The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer:{code:1189,category:ts.DiagnosticCategory.Error,key:"The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer_1189",message:"The variable declaration of a 'for...in' statement cannot have an initializer."},The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer:{code:1190,category:ts.DiagnosticCategory.Error,key:"The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer_1190",message:"The variable declaration of a 'for...of' statement cannot have an initializer."},An_import_declaration_cannot_have_modifiers:{code:1191,category:ts.DiagnosticCategory.Error,key:"An_import_declaration_cannot_have_modifiers_1191",message:"An import declaration cannot have modifiers."},Module_0_has_no_default_export:{code:1192,category:ts.DiagnosticCategory.Error,key:"Module_0_has_no_default_export_1192",message:"Module '{0}' has no default export."},An_export_declaration_cannot_have_modifiers:{code:1193,category:ts.DiagnosticCategory.Error,key:"An_export_declaration_cannot_have_modifiers_1193",message:"An export declaration cannot have modifiers."},Export_declarations_are_not_permitted_in_a_namespace:{code:1194,category:ts.DiagnosticCategory.Error,key:"Export_declarations_are_not_permitted_in_a_namespace_1194",message:"Export declarations are not permitted in a namespace."},Catch_clause_variable_name_must_be_an_identifier:{code:1195,category:ts.DiagnosticCategory.Error,key:"Catch_clause_variable_name_must_be_an_identifier_1195",message:"Catch clause variable name must be an identifier."},Catch_clause_variable_cannot_have_a_type_annotation:{code:1196,category:ts.DiagnosticCategory.Error,key:"Catch_clause_variable_cannot_have_a_type_annotation_1196",message:"Catch clause variable cannot have a type annotation."},Catch_clause_variable_cannot_have_an_initializer:{code:1197,category:ts.DiagnosticCategory.Error,key:"Catch_clause_variable_cannot_have_an_initializer_1197",message:"Catch clause variable cannot have an initializer."},An_extended_Unicode_escape_value_must_be_between_0x0_and_0x10FFFF_inclusive:{code:1198,category:ts.DiagnosticCategory.Error,key:"An_extended_Unicode_escape_value_must_be_between_0x0_and_0x10FFFF_inclusive_1198",message:"An extended Unicode escape value must be between 0x0 and 0x10FFFF inclusive."},Unterminated_Unicode_escape_sequence:{code:1199,category:ts.DiagnosticCategory.Error,key:"Unterminated_Unicode_escape_sequence_1199",message:"Unterminated Unicode escape sequence."},Line_terminator_not_permitted_before_arrow:{code:1200,category:ts.DiagnosticCategory.Error,key:"Line_terminator_not_permitted_before_arrow_1200",message:"Line terminator not permitted before arrow."},Import_assignment_cannot_be_used_when_targeting_ECMAScript_6_modules_Consider_using_import_Asterisk_as_ns_from_mod_import_a_from_mod_import_d_from_mod_or_another_module_format_instead:{code:1202,category:ts.DiagnosticCategory.Error,key:"Import_assignment_cannot_be_used_when_targeting_ECMAScript_6_modules_Consider_using_import_Asterisk__1202",message:"Import assignment cannot be used when targeting ECMAScript 6 modules. Consider using 'import * as ns from \"mod\"', 'import {a} from \"mod\"', 'import d from \"mod\"', or another module format instead."},Export_assignment_cannot_be_used_when_targeting_ECMAScript_6_modules_Consider_using_export_default_or_another_module_format_instead:{code:1203,category:ts.DiagnosticCategory.Error,key:"Export_assignment_cannot_be_used_when_targeting_ECMAScript_6_modules_Consider_using_export_default_o_1203",message:"Export assignment cannot be used when targeting ECMAScript 6 modules. Consider using 'export default' or another module format instead."},Cannot_compile_modules_into_es2015_when_targeting_ES5_or_lower:{code:1204,category:ts.DiagnosticCategory.Error,key:"Cannot_compile_modules_into_es2015_when_targeting_ES5_or_lower_1204",message:"Cannot compile modules into 'es2015' when targeting 'ES5' or lower."},Decorators_are_not_valid_here:{code:1206,category:ts.DiagnosticCategory.Error,key:"Decorators_are_not_valid_here_1206",message:"Decorators are not valid here."},Decorators_cannot_be_applied_to_multiple_get_Slashset_accessors_of_the_same_name:{code:1207,category:ts.DiagnosticCategory.Error,key:"Decorators_cannot_be_applied_to_multiple_get_Slashset_accessors_of_the_same_name_1207",message:"Decorators cannot be applied to multiple get/set accessors of the same name."},Cannot_compile_namespaces_when_the_isolatedModules_flag_is_provided:{code:1208,category:ts.DiagnosticCategory.Error,key:"Cannot_compile_namespaces_when_the_isolatedModules_flag_is_provided_1208",message:"Cannot compile namespaces when the '--isolatedModules' flag is provided."},Ambient_const_enums_are_not_allowed_when_the_isolatedModules_flag_is_provided:{code:1209,category:ts.DiagnosticCategory.Error,key:"Ambient_const_enums_are_not_allowed_when_the_isolatedModules_flag_is_provided_1209",message:"Ambient const enums are not allowed when the '--isolatedModules' flag is provided."},Invalid_use_of_0_Class_definitions_are_automatically_in_strict_mode:{code:1210,category:ts.DiagnosticCategory.Error,key:"Invalid_use_of_0_Class_definitions_are_automatically_in_strict_mode_1210",message:"Invalid use of '{0}'. Class definitions are automatically in strict mode."},A_class_declaration_without_the_default_modifier_must_have_a_name:{code:1211,category:ts.DiagnosticCategory.Error,key:"A_class_declaration_without_the_default_modifier_must_have_a_name_1211",message:"A class declaration without the 'default' modifier must have a name"},Identifier_expected_0_is_a_reserved_word_in_strict_mode:{code:1212,category:ts.DiagnosticCategory.Error,key:"Identifier_expected_0_is_a_reserved_word_in_strict_mode_1212",message:"Identifier expected. '{0}' is a reserved word in strict mode"},Identifier_expected_0_is_a_reserved_word_in_strict_mode_Class_definitions_are_automatically_in_strict_mode:{code:1213,category:ts.DiagnosticCategory.Error,key:"Identifier_expected_0_is_a_reserved_word_in_strict_mode_Class_definitions_are_automatically_in_stric_1213",message:"Identifier expected. '{0}' is a reserved word in strict mode. Class definitions are automatically in strict mode."},Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode:{code:1214,category:ts.DiagnosticCategory.Error,key:"Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode_1214",message:"Identifier expected. '{0}' is a reserved word in strict mode. Modules are automatically in strict mode."},Invalid_use_of_0_Modules_are_automatically_in_strict_mode:{code:1215,category:ts.DiagnosticCategory.Error,key:"Invalid_use_of_0_Modules_are_automatically_in_strict_mode_1215",message:"Invalid use of '{0}'. Modules are automatically in strict mode."},Export_assignment_is_not_supported_when_module_flag_is_system:{code:1218,category:ts.DiagnosticCategory.Error,key:"Export_assignment_is_not_supported_when_module_flag_is_system_1218",message:"Export assignment is not supported when '--module' flag is 'system'."},Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_the_experimentalDecorators_option_to_remove_this_warning:{code:1219,category:ts.DiagnosticCategory.Error,key:"Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_t_1219",message:"Experimental support for decorators is a feature that is subject to change in a future release. Set the 'experimentalDecorators' option to remove this warning."},Generators_are_only_available_when_targeting_ECMAScript_6_or_higher:{code:1220,category:ts.DiagnosticCategory.Error,key:"Generators_are_only_available_when_targeting_ECMAScript_6_or_higher_1220",message:"Generators are only available when targeting ECMAScript 6 or higher."},Generators_are_not_allowed_in_an_ambient_context:{code:1221,category:ts.DiagnosticCategory.Error,key:"Generators_are_not_allowed_in_an_ambient_context_1221",message:"Generators are not allowed in an ambient context."},An_overload_signature_cannot_be_declared_as_a_generator:{code:1222,category:ts.DiagnosticCategory.Error,key:"An_overload_signature_cannot_be_declared_as_a_generator_1222",message:"An overload signature cannot be declared as a generator."},_0_tag_already_specified:{code:1223,category:ts.DiagnosticCategory.Error,key:"_0_tag_already_specified_1223",message:"'{0}' tag already specified."},Signature_0_must_have_a_type_predicate:{code:1224,category:ts.DiagnosticCategory.Error,key:"Signature_0_must_have_a_type_predicate_1224",message:"Signature '{0}' must have a type predicate."},Cannot_find_parameter_0:{code:1225,category:ts.DiagnosticCategory.Error,key:"Cannot_find_parameter_0_1225",message:"Cannot find parameter '{0}'."},Type_predicate_0_is_not_assignable_to_1:{code:1226,category:ts.DiagnosticCategory.Error,key:"Type_predicate_0_is_not_assignable_to_1_1226",message:"Type predicate '{0}' is not assignable to '{1}'."},Parameter_0_is_not_in_the_same_position_as_parameter_1:{code:1227,category:ts.DiagnosticCategory.Error,key:"Parameter_0_is_not_in_the_same_position_as_parameter_1_1227",message:"Parameter '{0}' is not in the same position as parameter '{1}'."},A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods:{code:1228,category:ts.DiagnosticCategory.Error,key:"A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods_1228",message:"A type predicate is only allowed in return type position for functions and methods."},A_type_predicate_cannot_reference_a_rest_parameter:{code:1229,category:ts.DiagnosticCategory.Error,key:"A_type_predicate_cannot_reference_a_rest_parameter_1229",message:"A type predicate cannot reference a rest parameter."},A_type_predicate_cannot_reference_element_0_in_a_binding_pattern:{code:1230,category:ts.DiagnosticCategory.Error,key:"A_type_predicate_cannot_reference_element_0_in_a_binding_pattern_1230",message:"A type predicate cannot reference element '{0}' in a binding pattern."},An_export_assignment_can_only_be_used_in_a_module:{code:1231,category:ts.DiagnosticCategory.Error,key:"An_export_assignment_can_only_be_used_in_a_module_1231",message:"An export assignment can only be used in a module."},An_import_declaration_can_only_be_used_in_a_namespace_or_module:{code:1232,category:ts.DiagnosticCategory.Error,key:"An_import_declaration_can_only_be_used_in_a_namespace_or_module_1232",message:"An import declaration can only be used in a namespace or module."},An_export_declaration_can_only_be_used_in_a_module:{code:1233,category:ts.DiagnosticCategory.Error,key:"An_export_declaration_can_only_be_used_in_a_module_1233",message:"An export declaration can only be used in a module."},An_ambient_module_declaration_is_only_allowed_at_the_top_level_in_a_file:{code:1234,category:ts.DiagnosticCategory.Error,key:"An_ambient_module_declaration_is_only_allowed_at_the_top_level_in_a_file_1234",message:"An ambient module declaration is only allowed at the top level in a file."},A_namespace_declaration_is_only_allowed_in_a_namespace_or_module:{code:1235,category:ts.DiagnosticCategory.Error,key:"A_namespace_declaration_is_only_allowed_in_a_namespace_or_module_1235",message:"A namespace declaration is only allowed in a namespace or module."},The_return_type_of_a_property_decorator_function_must_be_either_void_or_any:{code:1236,category:ts.DiagnosticCategory.Error,key:"The_return_type_of_a_property_decorator_function_must_be_either_void_or_any_1236",message:"The return type of a property decorator function must be either 'void' or 'any'."},The_return_type_of_a_parameter_decorator_function_must_be_either_void_or_any:{code:1237,category:ts.DiagnosticCategory.Error,key:"The_return_type_of_a_parameter_decorator_function_must_be_either_void_or_any_1237",message:"The return type of a parameter decorator function must be either 'void' or 'any'."},Unable_to_resolve_signature_of_class_decorator_when_called_as_an_expression:{code:1238,category:ts.DiagnosticCategory.Error,key:"Unable_to_resolve_signature_of_class_decorator_when_called_as_an_expression_1238",message:"Unable to resolve signature of class decorator when called as an expression."},Unable_to_resolve_signature_of_parameter_decorator_when_called_as_an_expression:{code:1239,category:ts.DiagnosticCategory.Error,key:"Unable_to_resolve_signature_of_parameter_decorator_when_called_as_an_expression_1239",message:"Unable to resolve signature of parameter decorator when called as an expression."},Unable_to_resolve_signature_of_property_decorator_when_called_as_an_expression:{code:1240,category:ts.DiagnosticCategory.Error,key:"Unable_to_resolve_signature_of_property_decorator_when_called_as_an_expression_1240",message:"Unable to resolve signature of property decorator when called as an expression."},Unable_to_resolve_signature_of_method_decorator_when_called_as_an_expression:{code:1241,category:ts.DiagnosticCategory.Error,key:"Unable_to_resolve_signature_of_method_decorator_when_called_as_an_expression_1241",message:"Unable to resolve signature of method decorator when called as an expression."},abstract_modifier_can_only_appear_on_a_class_or_method_declaration:{code:1242,category:ts.DiagnosticCategory.Error,key:"abstract_modifier_can_only_appear_on_a_class_or_method_declaration_1242",message:"'abstract' modifier can only appear on a class or method declaration."},_0_modifier_cannot_be_used_with_1_modifier:{code:1243,category:ts.DiagnosticCategory.Error,key:"_0_modifier_cannot_be_used_with_1_modifier_1243",message:"'{0}' modifier cannot be used with '{1}' modifier."},Abstract_methods_can_only_appear_within_an_abstract_class:{code:1244,category:ts.DiagnosticCategory.Error,key:"Abstract_methods_can_only_appear_within_an_abstract_class_1244",message:"Abstract methods can only appear within an abstract class."},Method_0_cannot_have_an_implementation_because_it_is_marked_abstract:{code:1245,category:ts.DiagnosticCategory.Error,key:"Method_0_cannot_have_an_implementation_because_it_is_marked_abstract_1245",message:"Method '{0}' cannot have an implementation because it is marked abstract."},An_interface_property_cannot_have_an_initializer:{code:1246,category:ts.DiagnosticCategory.Error,key:"An_interface_property_cannot_have_an_initializer_1246",message:"An interface property cannot have an initializer."},A_type_literal_property_cannot_have_an_initializer:{code:1247,category:ts.DiagnosticCategory.Error,key:"A_type_literal_property_cannot_have_an_initializer_1247",message:"A type literal property cannot have an initializer."},A_class_member_cannot_have_the_0_keyword:{code:1248,category:ts.DiagnosticCategory.Error,key:"A_class_member_cannot_have_the_0_keyword_1248",message:"A class member cannot have the '{0}' keyword."},A_decorator_can_only_decorate_a_method_implementation_not_an_overload:{code:1249,category:ts.DiagnosticCategory.Error,key:"A_decorator_can_only_decorate_a_method_implementation_not_an_overload_1249",message:"A decorator can only decorate a method implementation, not an overload."},with_statements_are_not_allowed_in_an_async_function_block:{code:1300,category:ts.DiagnosticCategory.Error,key:"with_statements_are_not_allowed_in_an_async_function_block_1300",message:"'with' statements are not allowed in an async function block."},await_expression_is_only_allowed_within_an_async_function:{code:1308,category:ts.DiagnosticCategory.Error,key:"await_expression_is_only_allowed_within_an_async_function_1308",message:"'await' expression is only allowed within an async function."},Async_functions_are_only_available_when_targeting_ECMAScript_6_and_higher:{code:1311,category:ts.DiagnosticCategory.Error,key:"Async_functions_are_only_available_when_targeting_ECMAScript_6_and_higher_1311",message:"Async functions are only available when targeting ECMAScript 6 and higher."},can_only_be_used_in_an_object_literal_property_inside_a_destructuring_assignment:{code:1312,category:ts.DiagnosticCategory.Error,key:"can_only_be_used_in_an_object_literal_property_inside_a_destructuring_assignment_1312",message:"'=' can only be used in an object literal property inside a destructuring assignment."},The_body_of_an_if_statement_cannot_be_the_empty_statement:{code:1313,category:ts.DiagnosticCategory.Error,key:"The_body_of_an_if_statement_cannot_be_the_empty_statement_1313",message:"The body of an 'if' statement cannot be the empty statement."},Duplicate_identifier_0:{code:2300,category:ts.DiagnosticCategory.Error,key:"Duplicate_identifier_0_2300",message:"Duplicate identifier '{0}'."},Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor:{code:2301,category:ts.DiagnosticCategory.Error,key:"Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor_2301",message:"Initializer of instance member variable '{0}' cannot reference identifier '{1}' declared in the constructor."},Static_members_cannot_reference_class_type_parameters:{code:2302,category:ts.DiagnosticCategory.Error,key:"Static_members_cannot_reference_class_type_parameters_2302",message:"Static members cannot reference class type parameters."},Circular_definition_of_import_alias_0:{code:2303,category:ts.DiagnosticCategory.Error,key:"Circular_definition_of_import_alias_0_2303",message:"Circular definition of import alias '{0}'."},Cannot_find_name_0:{code:2304,category:ts.DiagnosticCategory.Error,key:"Cannot_find_name_0_2304",message:"Cannot find name '{0}'."},Module_0_has_no_exported_member_1:{code:2305,category:ts.DiagnosticCategory.Error,key:"Module_0_has_no_exported_member_1_2305",message:"Module '{0}' has no exported member '{1}'."},File_0_is_not_a_module:{code:2306,category:ts.DiagnosticCategory.Error,key:"File_0_is_not_a_module_2306",message:"File '{0}' is not a module."},Cannot_find_module_0:{code:2307,category:ts.DiagnosticCategory.Error,key:"Cannot_find_module_0_2307",message:"Cannot find module '{0}'."},Module_0_has_already_exported_a_member_named_1_Consider_explicitly_re_exporting_to_resolve_the_ambiguity:{code:2308,category:ts.DiagnosticCategory.Error,key:"Module_0_has_already_exported_a_member_named_1_Consider_explicitly_re_exporting_to_resolve_the_ambig_2308",message:"Module {0} has already exported a member named '{1}'. Consider explicitly re-exporting to resolve the ambiguity."},An_export_assignment_cannot_be_used_in_a_module_with_other_exported_elements:{code:2309,category:ts.DiagnosticCategory.Error,key:"An_export_assignment_cannot_be_used_in_a_module_with_other_exported_elements_2309",message:"An export assignment cannot be used in a module with other exported elements."},Type_0_recursively_references_itself_as_a_base_type:{code:2310,category:ts.DiagnosticCategory.Error,key:"Type_0_recursively_references_itself_as_a_base_type_2310",message:"Type '{0}' recursively references itself as a base type."},A_class_may_only_extend_another_class:{code:2311,category:ts.DiagnosticCategory.Error,key:"A_class_may_only_extend_another_class_2311",message:"A class may only extend another class."},An_interface_may_only_extend_a_class_or_another_interface:{code:2312,category:ts.DiagnosticCategory.Error,key:"An_interface_may_only_extend_a_class_or_another_interface_2312",message:"An interface may only extend a class or another interface."},Type_parameter_0_has_a_circular_constraint:{code:2313,category:ts.DiagnosticCategory.Error,key:"Type_parameter_0_has_a_circular_constraint_2313",message:"Type parameter '{0}' has a circular constraint."},Generic_type_0_requires_1_type_argument_s:{code:2314,category:ts.DiagnosticCategory.Error,key:"Generic_type_0_requires_1_type_argument_s_2314",message:"Generic type '{0}' requires {1} type argument(s)."},Type_0_is_not_generic:{code:2315,category:ts.DiagnosticCategory.Error,key:"Type_0_is_not_generic_2315",message:"Type '{0}' is not generic."},Global_type_0_must_be_a_class_or_interface_type:{code:2316,category:ts.DiagnosticCategory.Error,key:"Global_type_0_must_be_a_class_or_interface_type_2316",message:"Global type '{0}' must be a class or interface type."},Global_type_0_must_have_1_type_parameter_s:{code:2317,category:ts.DiagnosticCategory.Error,key:"Global_type_0_must_have_1_type_parameter_s_2317",message:"Global type '{0}' must have {1} type parameter(s)."},Cannot_find_global_type_0:{code:2318,category:ts.DiagnosticCategory.Error,key:"Cannot_find_global_type_0_2318",message:"Cannot find global type '{0}'."},Named_property_0_of_types_1_and_2_are_not_identical:{code:2319,category:ts.DiagnosticCategory.Error,key:"Named_property_0_of_types_1_and_2_are_not_identical_2319",message:"Named property '{0}' of types '{1}' and '{2}' are not identical."},Interface_0_cannot_simultaneously_extend_types_1_and_2:{code:2320,category:ts.DiagnosticCategory.Error,key:"Interface_0_cannot_simultaneously_extend_types_1_and_2_2320",message:"Interface '{0}' cannot simultaneously extend types '{1}' and '{2}'."},Excessive_stack_depth_comparing_types_0_and_1:{code:2321,category:ts.DiagnosticCategory.Error,key:"Excessive_stack_depth_comparing_types_0_and_1_2321",message:"Excessive stack depth comparing types '{0}' and '{1}'."},Type_0_is_not_assignable_to_type_1:{code:2322,category:ts.DiagnosticCategory.Error,key:"Type_0_is_not_assignable_to_type_1_2322",message:"Type '{0}' is not assignable to type '{1}'."},Cannot_redeclare_exported_variable_0:{code:2323,category:ts.DiagnosticCategory.Error,key:"Cannot_redeclare_exported_variable_0_2323",message:"Cannot redeclare exported variable '{0}'."},Property_0_is_missing_in_type_1:{code:2324,category:ts.DiagnosticCategory.Error,key:"Property_0_is_missing_in_type_1_2324",message:"Property '{0}' is missing in type '{1}'."},Property_0_is_private_in_type_1_but_not_in_type_2:{code:2325,category:ts.DiagnosticCategory.Error,key:"Property_0_is_private_in_type_1_but_not_in_type_2_2325",message:"Property '{0}' is private in type '{1}' but not in type '{2}'."},Types_of_property_0_are_incompatible:{code:2326,category:ts.DiagnosticCategory.Error,key:"Types_of_property_0_are_incompatible_2326",message:"Types of property '{0}' are incompatible."},Property_0_is_optional_in_type_1_but_required_in_type_2:{code:2327,category:ts.DiagnosticCategory.Error,key:"Property_0_is_optional_in_type_1_but_required_in_type_2_2327",message:"Property '{0}' is optional in type '{1}' but required in type '{2}'."},Types_of_parameters_0_and_1_are_incompatible:{code:2328,category:ts.DiagnosticCategory.Error,key:"Types_of_parameters_0_and_1_are_incompatible_2328",message:"Types of parameters '{0}' and '{1}' are incompatible."},Index_signature_is_missing_in_type_0:{code:2329,category:ts.DiagnosticCategory.Error,key:"Index_signature_is_missing_in_type_0_2329",message:"Index signature is missing in type '{0}'."},Index_signatures_are_incompatible:{code:2330,category:ts.DiagnosticCategory.Error,key:"Index_signatures_are_incompatible_2330",message:"Index signatures are incompatible."},this_cannot_be_referenced_in_a_module_or_namespace_body:{code:2331,category:ts.DiagnosticCategory.Error,key:"this_cannot_be_referenced_in_a_module_or_namespace_body_2331",message:"'this' cannot be referenced in a module or namespace body."},this_cannot_be_referenced_in_current_location:{code:2332,
category:ts.DiagnosticCategory.Error,key:"this_cannot_be_referenced_in_current_location_2332",message:"'this' cannot be referenced in current location."},this_cannot_be_referenced_in_constructor_arguments:{code:2333,category:ts.DiagnosticCategory.Error,key:"this_cannot_be_referenced_in_constructor_arguments_2333",message:"'this' cannot be referenced in constructor arguments."},this_cannot_be_referenced_in_a_static_property_initializer:{code:2334,category:ts.DiagnosticCategory.Error,key:"this_cannot_be_referenced_in_a_static_property_initializer_2334",message:"'this' cannot be referenced in a static property initializer."},super_can_only_be_referenced_in_a_derived_class:{code:2335,category:ts.DiagnosticCategory.Error,key:"super_can_only_be_referenced_in_a_derived_class_2335",message:"'super' can only be referenced in a derived class."},super_cannot_be_referenced_in_constructor_arguments:{code:2336,category:ts.DiagnosticCategory.Error,key:"super_cannot_be_referenced_in_constructor_arguments_2336",message:"'super' cannot be referenced in constructor arguments."},Super_calls_are_not_permitted_outside_constructors_or_in_nested_functions_inside_constructors:{code:2337,category:ts.DiagnosticCategory.Error,key:"Super_calls_are_not_permitted_outside_constructors_or_in_nested_functions_inside_constructors_2337",message:"Super calls are not permitted outside constructors or in nested functions inside constructors."},super_property_access_is_permitted_only_in_a_constructor_member_function_or_member_accessor_of_a_derived_class:{code:2338,category:ts.DiagnosticCategory.Error,key:"super_property_access_is_permitted_only_in_a_constructor_member_function_or_member_accessor_of_a_der_2338",message:"'super' property access is permitted only in a constructor, member function, or member accessor of a derived class."},Property_0_does_not_exist_on_type_1:{code:2339,category:ts.DiagnosticCategory.Error,key:"Property_0_does_not_exist_on_type_1_2339",message:"Property '{0}' does not exist on type '{1}'."},Only_public_and_protected_methods_of_the_base_class_are_accessible_via_the_super_keyword:{code:2340,category:ts.DiagnosticCategory.Error,key:"Only_public_and_protected_methods_of_the_base_class_are_accessible_via_the_super_keyword_2340",message:"Only public and protected methods of the base class are accessible via the 'super' keyword."},Property_0_is_private_and_only_accessible_within_class_1:{code:2341,category:ts.DiagnosticCategory.Error,key:"Property_0_is_private_and_only_accessible_within_class_1_2341",message:"Property '{0}' is private and only accessible within class '{1}'."},An_index_expression_argument_must_be_of_type_string_number_symbol_or_any:{code:2342,category:ts.DiagnosticCategory.Error,key:"An_index_expression_argument_must_be_of_type_string_number_symbol_or_any_2342",message:"An index expression argument must be of type 'string', 'number', 'symbol', or 'any'."},Type_0_does_not_satisfy_the_constraint_1:{code:2344,category:ts.DiagnosticCategory.Error,key:"Type_0_does_not_satisfy_the_constraint_1_2344",message:"Type '{0}' does not satisfy the constraint '{1}'."},Argument_of_type_0_is_not_assignable_to_parameter_of_type_1:{code:2345,category:ts.DiagnosticCategory.Error,key:"Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_2345",message:"Argument of type '{0}' is not assignable to parameter of type '{1}'."},Supplied_parameters_do_not_match_any_signature_of_call_target:{code:2346,category:ts.DiagnosticCategory.Error,key:"Supplied_parameters_do_not_match_any_signature_of_call_target_2346",message:"Supplied parameters do not match any signature of call target."},Untyped_function_calls_may_not_accept_type_arguments:{code:2347,category:ts.DiagnosticCategory.Error,key:"Untyped_function_calls_may_not_accept_type_arguments_2347",message:"Untyped function calls may not accept type arguments."},Value_of_type_0_is_not_callable_Did_you_mean_to_include_new:{code:2348,category:ts.DiagnosticCategory.Error,key:"Value_of_type_0_is_not_callable_Did_you_mean_to_include_new_2348",message:"Value of type '{0}' is not callable. Did you mean to include 'new'?"},Cannot_invoke_an_expression_whose_type_lacks_a_call_signature:{code:2349,category:ts.DiagnosticCategory.Error,key:"Cannot_invoke_an_expression_whose_type_lacks_a_call_signature_2349",message:"Cannot invoke an expression whose type lacks a call signature."},Only_a_void_function_can_be_called_with_the_new_keyword:{code:2350,category:ts.DiagnosticCategory.Error,key:"Only_a_void_function_can_be_called_with_the_new_keyword_2350",message:"Only a void function can be called with the 'new' keyword."},Cannot_use_new_with_an_expression_whose_type_lacks_a_call_or_construct_signature:{code:2351,category:ts.DiagnosticCategory.Error,key:"Cannot_use_new_with_an_expression_whose_type_lacks_a_call_or_construct_signature_2351",message:"Cannot use 'new' with an expression whose type lacks a call or construct signature."},Neither_type_0_nor_type_1_is_assignable_to_the_other:{code:2352,category:ts.DiagnosticCategory.Error,key:"Neither_type_0_nor_type_1_is_assignable_to_the_other_2352",message:"Neither type '{0}' nor type '{1}' is assignable to the other."},Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1:{code:2353,category:ts.DiagnosticCategory.Error,key:"Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1_2353",message:"Object literal may only specify known properties, and '{0}' does not exist in type '{1}'."},No_best_common_type_exists_among_return_expressions:{code:2354,category:ts.DiagnosticCategory.Error,key:"No_best_common_type_exists_among_return_expressions_2354",message:"No best common type exists among return expressions."},A_function_whose_declared_type_is_neither_void_nor_any_must_return_a_value:{code:2355,category:ts.DiagnosticCategory.Error,key:"A_function_whose_declared_type_is_neither_void_nor_any_must_return_a_value_2355",message:"A function whose declared type is neither 'void' nor 'any' must return a value."},An_arithmetic_operand_must_be_of_type_any_number_or_an_enum_type:{code:2356,category:ts.DiagnosticCategory.Error,key:"An_arithmetic_operand_must_be_of_type_any_number_or_an_enum_type_2356",message:"An arithmetic operand must be of type 'any', 'number' or an enum type."},The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_property_or_indexer:{code:2357,category:ts.DiagnosticCategory.Error,key:"The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_property_or_indexer_2357",message:"The operand of an increment or decrement operator must be a variable, property or indexer."},The_left_hand_side_of_an_instanceof_expression_must_be_of_type_any_an_object_type_or_a_type_parameter:{code:2358,category:ts.DiagnosticCategory.Error,key:"The_left_hand_side_of_an_instanceof_expression_must_be_of_type_any_an_object_type_or_a_type_paramete_2358",message:"The left-hand side of an 'instanceof' expression must be of type 'any', an object type or a type parameter."},The_right_hand_side_of_an_instanceof_expression_must_be_of_type_any_or_of_a_type_assignable_to_the_Function_interface_type:{code:2359,category:ts.DiagnosticCategory.Error,key:"The_right_hand_side_of_an_instanceof_expression_must_be_of_type_any_or_of_a_type_assignable_to_the_F_2359",message:"The right-hand side of an 'instanceof' expression must be of type 'any' or of a type assignable to the 'Function' interface type."},The_left_hand_side_of_an_in_expression_must_be_of_type_any_string_number_or_symbol:{code:2360,category:ts.DiagnosticCategory.Error,key:"The_left_hand_side_of_an_in_expression_must_be_of_type_any_string_number_or_symbol_2360",message:"The left-hand side of an 'in' expression must be of type 'any', 'string', 'number', or 'symbol'."},The_right_hand_side_of_an_in_expression_must_be_of_type_any_an_object_type_or_a_type_parameter:{code:2361,category:ts.DiagnosticCategory.Error,key:"The_right_hand_side_of_an_in_expression_must_be_of_type_any_an_object_type_or_a_type_parameter_2361",message:"The right-hand side of an 'in' expression must be of type 'any', an object type or a type parameter"},The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_or_an_enum_type:{code:2362,category:ts.DiagnosticCategory.Error,key:"The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_or_an_enum_type_2362",message:"The left-hand side of an arithmetic operation must be of type 'any', 'number' or an enum type."},The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_or_an_enum_type:{code:2363,category:ts.DiagnosticCategory.Error,key:"The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_or_an_enum_type_2363",message:"The right-hand side of an arithmetic operation must be of type 'any', 'number' or an enum type."},Invalid_left_hand_side_of_assignment_expression:{code:2364,category:ts.DiagnosticCategory.Error,key:"Invalid_left_hand_side_of_assignment_expression_2364",message:"Invalid left-hand side of assignment expression."},Operator_0_cannot_be_applied_to_types_1_and_2:{code:2365,category:ts.DiagnosticCategory.Error,key:"Operator_0_cannot_be_applied_to_types_1_and_2_2365",message:"Operator '{0}' cannot be applied to types '{1}' and '{2}'."},Type_parameter_name_cannot_be_0:{code:2368,category:ts.DiagnosticCategory.Error,key:"Type_parameter_name_cannot_be_0_2368",message:"Type parameter name cannot be '{0}'"},A_parameter_property_is_only_allowed_in_a_constructor_implementation:{code:2369,category:ts.DiagnosticCategory.Error,key:"A_parameter_property_is_only_allowed_in_a_constructor_implementation_2369",message:"A parameter property is only allowed in a constructor implementation."},A_rest_parameter_must_be_of_an_array_type:{code:2370,category:ts.DiagnosticCategory.Error,key:"A_rest_parameter_must_be_of_an_array_type_2370",message:"A rest parameter must be of an array type."},A_parameter_initializer_is_only_allowed_in_a_function_or_constructor_implementation:{code:2371,category:ts.DiagnosticCategory.Error,key:"A_parameter_initializer_is_only_allowed_in_a_function_or_constructor_implementation_2371",message:"A parameter initializer is only allowed in a function or constructor implementation."},Parameter_0_cannot_be_referenced_in_its_initializer:{code:2372,category:ts.DiagnosticCategory.Error,key:"Parameter_0_cannot_be_referenced_in_its_initializer_2372",message:"Parameter '{0}' cannot be referenced in its initializer."},Initializer_of_parameter_0_cannot_reference_identifier_1_declared_after_it:{code:2373,category:ts.DiagnosticCategory.Error,key:"Initializer_of_parameter_0_cannot_reference_identifier_1_declared_after_it_2373",message:"Initializer of parameter '{0}' cannot reference identifier '{1}' declared after it."},Duplicate_string_index_signature:{code:2374,category:ts.DiagnosticCategory.Error,key:"Duplicate_string_index_signature_2374",message:"Duplicate string index signature."},Duplicate_number_index_signature:{code:2375,category:ts.DiagnosticCategory.Error,key:"Duplicate_number_index_signature_2375",message:"Duplicate number index signature."},A_super_call_must_be_the_first_statement_in_the_constructor_when_a_class_contains_initialized_properties_or_has_parameter_properties:{code:2376,category:ts.DiagnosticCategory.Error,key:"A_super_call_must_be_the_first_statement_in_the_constructor_when_a_class_contains_initialized_proper_2376",message:"A 'super' call must be the first statement in the constructor when a class contains initialized properties or has parameter properties."},Constructors_for_derived_classes_must_contain_a_super_call:{code:2377,category:ts.DiagnosticCategory.Error,key:"Constructors_for_derived_classes_must_contain_a_super_call_2377",message:"Constructors for derived classes must contain a 'super' call."},A_get_accessor_must_return_a_value:{code:2378,category:ts.DiagnosticCategory.Error,key:"A_get_accessor_must_return_a_value_2378",message:"A 'get' accessor must return a value."},Getter_and_setter_accessors_do_not_agree_in_visibility:{code:2379,category:ts.DiagnosticCategory.Error,key:"Getter_and_setter_accessors_do_not_agree_in_visibility_2379",message:"Getter and setter accessors do not agree in visibility."},get_and_set_accessor_must_have_the_same_type:{code:2380,category:ts.DiagnosticCategory.Error,key:"get_and_set_accessor_must_have_the_same_type_2380",message:"'get' and 'set' accessor must have the same type."},A_signature_with_an_implementation_cannot_use_a_string_literal_type:{code:2381,category:ts.DiagnosticCategory.Error,key:"A_signature_with_an_implementation_cannot_use_a_string_literal_type_2381",message:"A signature with an implementation cannot use a string literal type."},Specialized_overload_signature_is_not_assignable_to_any_non_specialized_signature:{code:2382,category:ts.DiagnosticCategory.Error,key:"Specialized_overload_signature_is_not_assignable_to_any_non_specialized_signature_2382",message:"Specialized overload signature is not assignable to any non-specialized signature."},Overload_signatures_must_all_be_exported_or_not_exported:{code:2383,category:ts.DiagnosticCategory.Error,key:"Overload_signatures_must_all_be_exported_or_not_exported_2383",message:"Overload signatures must all be exported or not exported."},Overload_signatures_must_all_be_ambient_or_non_ambient:{code:2384,category:ts.DiagnosticCategory.Error,key:"Overload_signatures_must_all_be_ambient_or_non_ambient_2384",message:"Overload signatures must all be ambient or non-ambient."},Overload_signatures_must_all_be_public_private_or_protected:{code:2385,category:ts.DiagnosticCategory.Error,key:"Overload_signatures_must_all_be_public_private_or_protected_2385",message:"Overload signatures must all be public, private or protected."},Overload_signatures_must_all_be_optional_or_required:{code:2386,category:ts.DiagnosticCategory.Error,key:"Overload_signatures_must_all_be_optional_or_required_2386",message:"Overload signatures must all be optional or required."},Function_overload_must_be_static:{code:2387,category:ts.DiagnosticCategory.Error,key:"Function_overload_must_be_static_2387",message:"Function overload must be static."},Function_overload_must_not_be_static:{code:2388,category:ts.DiagnosticCategory.Error,key:"Function_overload_must_not_be_static_2388",message:"Function overload must not be static."},Function_implementation_name_must_be_0:{code:2389,category:ts.DiagnosticCategory.Error,key:"Function_implementation_name_must_be_0_2389",message:"Function implementation name must be '{0}'."},Constructor_implementation_is_missing:{code:2390,category:ts.DiagnosticCategory.Error,key:"Constructor_implementation_is_missing_2390",message:"Constructor implementation is missing."},Function_implementation_is_missing_or_not_immediately_following_the_declaration:{code:2391,category:ts.DiagnosticCategory.Error,key:"Function_implementation_is_missing_or_not_immediately_following_the_declaration_2391",message:"Function implementation is missing or not immediately following the declaration."},Multiple_constructor_implementations_are_not_allowed:{code:2392,category:ts.DiagnosticCategory.Error,key:"Multiple_constructor_implementations_are_not_allowed_2392",message:"Multiple constructor implementations are not allowed."},Duplicate_function_implementation:{code:2393,category:ts.DiagnosticCategory.Error,key:"Duplicate_function_implementation_2393",message:"Duplicate function implementation."},Overload_signature_is_not_compatible_with_function_implementation:{code:2394,category:ts.DiagnosticCategory.Error,key:"Overload_signature_is_not_compatible_with_function_implementation_2394",message:"Overload signature is not compatible with function implementation."},Individual_declarations_in_merged_declaration_0_must_be_all_exported_or_all_local:{code:2395,category:ts.DiagnosticCategory.Error,key:"Individual_declarations_in_merged_declaration_0_must_be_all_exported_or_all_local_2395",message:"Individual declarations in merged declaration '{0}' must be all exported or all local."},Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters:{code:2396,category:ts.DiagnosticCategory.Error,key:"Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters_2396",message:"Duplicate identifier 'arguments'. Compiler uses 'arguments' to initialize rest parameters."},Declaration_name_conflicts_with_built_in_global_identifier_0:{code:2397,category:ts.DiagnosticCategory.Error,key:"Declaration_name_conflicts_with_built_in_global_identifier_0_2397",message:"Declaration name conflicts with built-in global identifier '{0}'."},Duplicate_identifier_this_Compiler_uses_variable_declaration_this_to_capture_this_reference:{code:2399,category:ts.DiagnosticCategory.Error,key:"Duplicate_identifier_this_Compiler_uses_variable_declaration_this_to_capture_this_reference_2399",message:"Duplicate identifier '_this'. Compiler uses variable declaration '_this' to capture 'this' reference."},Expression_resolves_to_variable_declaration_this_that_compiler_uses_to_capture_this_reference:{code:2400,category:ts.DiagnosticCategory.Error,key:"Expression_resolves_to_variable_declaration_this_that_compiler_uses_to_capture_this_reference_2400",message:"Expression resolves to variable declaration '_this' that compiler uses to capture 'this' reference."},Duplicate_identifier_super_Compiler_uses_super_to_capture_base_class_reference:{code:2401,category:ts.DiagnosticCategory.Error,key:"Duplicate_identifier_super_Compiler_uses_super_to_capture_base_class_reference_2401",message:"Duplicate identifier '_super'. Compiler uses '_super' to capture base class reference."},Expression_resolves_to_super_that_compiler_uses_to_capture_base_class_reference:{code:2402,category:ts.DiagnosticCategory.Error,key:"Expression_resolves_to_super_that_compiler_uses_to_capture_base_class_reference_2402",message:"Expression resolves to '_super' that compiler uses to capture base class reference."},Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_type_2:{code:2403,category:ts.DiagnosticCategory.Error,key:"Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_t_2403",message:"Subsequent variable declarations must have the same type.  Variable '{0}' must be of type '{1}', but here has type '{2}'."},The_left_hand_side_of_a_for_in_statement_cannot_use_a_type_annotation:{code:2404,category:ts.DiagnosticCategory.Error,key:"The_left_hand_side_of_a_for_in_statement_cannot_use_a_type_annotation_2404",message:"The left-hand side of a 'for...in' statement cannot use a type annotation."},The_left_hand_side_of_a_for_in_statement_must_be_of_type_string_or_any:{code:2405,category:ts.DiagnosticCategory.Error,key:"The_left_hand_side_of_a_for_in_statement_must_be_of_type_string_or_any_2405",message:"The left-hand side of a 'for...in' statement must be of type 'string' or 'any'."},Invalid_left_hand_side_in_for_in_statement:{code:2406,category:ts.DiagnosticCategory.Error,key:"Invalid_left_hand_side_in_for_in_statement_2406",message:"Invalid left-hand side in 'for...in' statement."},The_right_hand_side_of_a_for_in_statement_must_be_of_type_any_an_object_type_or_a_type_parameter:{code:2407,category:ts.DiagnosticCategory.Error,key:"The_right_hand_side_of_a_for_in_statement_must_be_of_type_any_an_object_type_or_a_type_parameter_2407",message:"The right-hand side of a 'for...in' statement must be of type 'any', an object type or a type parameter."},Setters_cannot_return_a_value:{code:2408,category:ts.DiagnosticCategory.Error,key:"Setters_cannot_return_a_value_2408",message:"Setters cannot return a value."},Return_type_of_constructor_signature_must_be_assignable_to_the_instance_type_of_the_class:{code:2409,category:ts.DiagnosticCategory.Error,key:"Return_type_of_constructor_signature_must_be_assignable_to_the_instance_type_of_the_class_2409",message:"Return type of constructor signature must be assignable to the instance type of the class"},All_symbols_within_a_with_block_will_be_resolved_to_any:{code:2410,category:ts.DiagnosticCategory.Error,key:"All_symbols_within_a_with_block_will_be_resolved_to_any_2410",message:"All symbols within a 'with' block will be resolved to 'any'."},Property_0_of_type_1_is_not_assignable_to_string_index_type_2:{code:2411,category:ts.DiagnosticCategory.Error,key:"Property_0_of_type_1_is_not_assignable_to_string_index_type_2_2411",message:"Property '{0}' of type '{1}' is not assignable to string index type '{2}'."},Property_0_of_type_1_is_not_assignable_to_numeric_index_type_2:{code:2412,category:ts.DiagnosticCategory.Error,key:"Property_0_of_type_1_is_not_assignable_to_numeric_index_type_2_2412",message:"Property '{0}' of type '{1}' is not assignable to numeric index type '{2}'."},Numeric_index_type_0_is_not_assignable_to_string_index_type_1:{code:2413,category:ts.DiagnosticCategory.Error,key:"Numeric_index_type_0_is_not_assignable_to_string_index_type_1_2413",message:"Numeric index type '{0}' is not assignable to string index type '{1}'."},Class_name_cannot_be_0:{code:2414,category:ts.DiagnosticCategory.Error,key:"Class_name_cannot_be_0_2414",message:"Class name cannot be '{0}'"},Class_0_incorrectly_extends_base_class_1:{code:2415,category:ts.DiagnosticCategory.Error,key:"Class_0_incorrectly_extends_base_class_1_2415",message:"Class '{0}' incorrectly extends base class '{1}'."},Class_static_side_0_incorrectly_extends_base_class_static_side_1:{code:2417,category:ts.DiagnosticCategory.Error,key:"Class_static_side_0_incorrectly_extends_base_class_static_side_1_2417",message:"Class static side '{0}' incorrectly extends base class static side '{1}'."},Type_name_0_in_extends_clause_does_not_reference_constructor_function_for_0:{code:2419,category:ts.DiagnosticCategory.Error,key:"Type_name_0_in_extends_clause_does_not_reference_constructor_function_for_0_2419",message:"Type name '{0}' in extends clause does not reference constructor function for '{0}'."},Class_0_incorrectly_implements_interface_1:{code:2420,category:ts.DiagnosticCategory.Error,key:"Class_0_incorrectly_implements_interface_1_2420",message:"Class '{0}' incorrectly implements interface '{1}'."},A_class_may_only_implement_another_class_or_interface:{code:2422,category:ts.DiagnosticCategory.Error,key:"A_class_may_only_implement_another_class_or_interface_2422",message:"A class may only implement another class or interface."},Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_accessor:{code:2423,category:ts.DiagnosticCategory.Error,key:"Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_access_2423",message:"Class '{0}' defines instance member function '{1}', but extended class '{2}' defines it as instance member accessor."},Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_property:{code:2424,category:ts.DiagnosticCategory.Error,key:"Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_proper_2424",message:"Class '{0}' defines instance member function '{1}', but extended class '{2}' defines it as instance member property."},Class_0_defines_instance_member_property_1_but_extended_class_2_defines_it_as_instance_member_function:{code:2425,category:ts.DiagnosticCategory.Error,key:"Class_0_defines_instance_member_property_1_but_extended_class_2_defines_it_as_instance_member_functi_2425",message:"Class '{0}' defines instance member property '{1}', but extended class '{2}' defines it as instance member function."},Class_0_defines_instance_member_accessor_1_but_extended_class_2_defines_it_as_instance_member_function:{code:2426,category:ts.DiagnosticCategory.Error,key:"Class_0_defines_instance_member_accessor_1_but_extended_class_2_defines_it_as_instance_member_functi_2426",message:"Class '{0}' defines instance member accessor '{1}', but extended class '{2}' defines it as instance member function."},Interface_name_cannot_be_0:{code:2427,category:ts.DiagnosticCategory.Error,key:"Interface_name_cannot_be_0_2427",message:"Interface name cannot be '{0}'"},All_declarations_of_an_interface_must_have_identical_type_parameters:{code:2428,category:ts.DiagnosticCategory.Error,key:"All_declarations_of_an_interface_must_have_identical_type_parameters_2428",message:"All declarations of an interface must have identical type parameters."},Interface_0_incorrectly_extends_interface_1:{code:2430,category:ts.DiagnosticCategory.Error,key:"Interface_0_incorrectly_extends_interface_1_2430",message:"Interface '{0}' incorrectly extends interface '{1}'."},Enum_name_cannot_be_0:{code:2431,category:ts.DiagnosticCategory.Error,key:"Enum_name_cannot_be_0_2431",message:"Enum name cannot be '{0}'"},In_an_enum_with_multiple_declarations_only_one_declaration_can_omit_an_initializer_for_its_first_enum_element:{code:2432,category:ts.DiagnosticCategory.Error,key:"In_an_enum_with_multiple_declarations_only_one_declaration_can_omit_an_initializer_for_its_first_enu_2432",message:"In an enum with multiple declarations, only one declaration can omit an initializer for its first enum element."},A_namespace_declaration_cannot_be_in_a_different_file_from_a_class_or_function_with_which_it_is_merged:{code:2433,category:ts.DiagnosticCategory.Error,key:"A_namespace_declaration_cannot_be_in_a_different_file_from_a_class_or_function_with_which_it_is_merg_2433",message:"A namespace declaration cannot be in a different file from a class or function with which it is merged"},A_namespace_declaration_cannot_be_located_prior_to_a_class_or_function_with_which_it_is_merged:{code:2434,category:ts.DiagnosticCategory.Error,key:"A_namespace_declaration_cannot_be_located_prior_to_a_class_or_function_with_which_it_is_merged_2434",message:"A namespace declaration cannot be located prior to a class or function with which it is merged"},Ambient_modules_cannot_be_nested_in_other_modules_or_namespaces:{code:2435,category:ts.DiagnosticCategory.Error,key:"Ambient_modules_cannot_be_nested_in_other_modules_or_namespaces_2435",message:"Ambient modules cannot be nested in other modules or namespaces."},Ambient_module_declaration_cannot_specify_relative_module_name:{code:2436,category:ts.DiagnosticCategory.Error,key:"Ambient_module_declaration_cannot_specify_relative_module_name_2436",message:"Ambient module declaration cannot specify relative module name."},Module_0_is_hidden_by_a_local_declaration_with_the_same_name:{code:2437,category:ts.DiagnosticCategory.Error,key:"Module_0_is_hidden_by_a_local_declaration_with_the_same_name_2437",message:"Module '{0}' is hidden by a local declaration with the same name"},Import_name_cannot_be_0:{code:2438,category:ts.DiagnosticCategory.Error,key:"Import_name_cannot_be_0_2438",message:"Import name cannot be '{0}'"},Import_or_export_declaration_in_an_ambient_module_declaration_cannot_reference_module_through_relative_module_name:{code:2439,category:ts.DiagnosticCategory.Error,key:"Import_or_export_declaration_in_an_ambient_module_declaration_cannot_reference_module_through_relati_2439",message:"Import or export declaration in an ambient module declaration cannot reference module through relative module name."},Import_declaration_conflicts_with_local_declaration_of_0:{code:2440,category:ts.DiagnosticCategory.Error,key:"Import_declaration_conflicts_with_local_declaration_of_0_2440",message:"Import declaration conflicts with local declaration of '{0}'"},Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module:{code:2441,category:ts.DiagnosticCategory.Error,key:"Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_2441",message:"Duplicate identifier '{0}'. Compiler reserves name '{1}' in top level scope of a module."},Types_have_separate_declarations_of_a_private_property_0:{code:2442,category:ts.DiagnosticCategory.Error,key:"Types_have_separate_declarations_of_a_private_property_0_2442",message:"Types have separate declarations of a private property '{0}'."},Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2:{code:2443,category:ts.DiagnosticCategory.Error,key:"Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2_2443",message:"Property '{0}' is protected but type '{1}' is not a class derived from '{2}'."},Property_0_is_protected_in_type_1_but_public_in_type_2:{code:2444,category:ts.DiagnosticCategory.Error,key:"Property_0_is_protected_in_type_1_but_public_in_type_2_2444",message:"Property '{0}' is protected in type '{1}' but public in type '{2}'."},Property_0_is_protected_and_only_accessible_within_class_1_and_its_subclasses:{code:2445,category:ts.DiagnosticCategory.Error,key:"Property_0_is_protected_and_only_accessible_within_class_1_and_its_subclasses_2445",message:"Property '{0}' is protected and only accessible within class '{1}' and its subclasses."},Property_0_is_protected_and_only_accessible_through_an_instance_of_class_1:{code:2446,category:ts.DiagnosticCategory.Error,key:"Property_0_is_protected_and_only_accessible_through_an_instance_of_class_1_2446",message:"Property '{0}' is protected and only accessible through an instance of class '{1}'."},The_0_operator_is_not_allowed_for_boolean_types_Consider_using_1_instead:{code:2447,category:ts.DiagnosticCategory.Error,key:"The_0_operator_is_not_allowed_for_boolean_types_Consider_using_1_instead_2447",message:"The '{0}' operator is not allowed for boolean types. Consider using '{1}' instead."},Block_scoped_variable_0_used_before_its_declaration:{code:2448,category:ts.DiagnosticCategory.Error,key:"Block_scoped_variable_0_used_before_its_declaration_2448",message:"Block-scoped variable '{0}' used before its declaration."},The_operand_of_an_increment_or_decrement_operator_cannot_be_a_constant:{code:2449,category:ts.DiagnosticCategory.Error,key:"The_operand_of_an_increment_or_decrement_operator_cannot_be_a_constant_2449",message:"The operand of an increment or decrement operator cannot be a constant."},Left_hand_side_of_assignment_expression_cannot_be_a_constant:{code:2450,category:ts.DiagnosticCategory.Error,key:"Left_hand_side_of_assignment_expression_cannot_be_a_constant_2450",message:"Left-hand side of assignment expression cannot be a constant."},Cannot_redeclare_block_scoped_variable_0:{code:2451,category:ts.DiagnosticCategory.Error,key:"Cannot_redeclare_block_scoped_variable_0_2451",message:"Cannot redeclare block-scoped variable '{0}'."},An_enum_member_cannot_have_a_numeric_name:{code:2452,category:ts.DiagnosticCategory.Error,key:"An_enum_member_cannot_have_a_numeric_name_2452",message:"An enum member cannot have a numeric name."},The_type_argument_for_type_parameter_0_cannot_be_inferred_from_the_usage_Consider_specifying_the_type_arguments_explicitly:{code:2453,category:ts.DiagnosticCategory.Error,key:"The_type_argument_for_type_parameter_0_cannot_be_inferred_from_the_usage_Consider_specifying_the_typ_2453",message:"The type argument for type parameter '{0}' cannot be inferred from the usage. Consider specifying the type arguments explicitly."},Type_argument_candidate_1_is_not_a_valid_type_argument_because_it_is_not_a_supertype_of_candidate_0:{code:2455,category:ts.DiagnosticCategory.Error,key:"Type_argument_candidate_1_is_not_a_valid_type_argument_because_it_is_not_a_supertype_of_candidate_0_2455",message:"Type argument candidate '{1}' is not a valid type argument because it is not a supertype of candidate '{0}'."},Type_alias_0_circularly_references_itself:{code:2456,category:ts.DiagnosticCategory.Error,key:"Type_alias_0_circularly_references_itself_2456",message:"Type alias '{0}' circularly references itself."},Type_alias_name_cannot_be_0:{code:2457,category:ts.DiagnosticCategory.Error,key:"Type_alias_name_cannot_be_0_2457",message:"Type alias name cannot be '{0}'"},An_AMD_module_cannot_have_multiple_name_assignments:{code:2458,category:ts.DiagnosticCategory.Error,key:"An_AMD_module_cannot_have_multiple_name_assignments_2458",message:"An AMD module cannot have multiple name assignments."},Type_0_has_no_property_1_and_no_string_index_signature:{
code:2459,category:ts.DiagnosticCategory.Error,key:"Type_0_has_no_property_1_and_no_string_index_signature_2459",message:"Type '{0}' has no property '{1}' and no string index signature."},Type_0_has_no_property_1:{code:2460,category:ts.DiagnosticCategory.Error,key:"Type_0_has_no_property_1_2460",message:"Type '{0}' has no property '{1}'."},Type_0_is_not_an_array_type:{code:2461,category:ts.DiagnosticCategory.Error,key:"Type_0_is_not_an_array_type_2461",message:"Type '{0}' is not an array type."},A_rest_element_must_be_last_in_an_array_destructuring_pattern:{code:2462,category:ts.DiagnosticCategory.Error,key:"A_rest_element_must_be_last_in_an_array_destructuring_pattern_2462",message:"A rest element must be last in an array destructuring pattern"},A_binding_pattern_parameter_cannot_be_optional_in_an_implementation_signature:{code:2463,category:ts.DiagnosticCategory.Error,key:"A_binding_pattern_parameter_cannot_be_optional_in_an_implementation_signature_2463",message:"A binding pattern parameter cannot be optional in an implementation signature."},A_computed_property_name_must_be_of_type_string_number_symbol_or_any:{code:2464,category:ts.DiagnosticCategory.Error,key:"A_computed_property_name_must_be_of_type_string_number_symbol_or_any_2464",message:"A computed property name must be of type 'string', 'number', 'symbol', or 'any'."},this_cannot_be_referenced_in_a_computed_property_name:{code:2465,category:ts.DiagnosticCategory.Error,key:"this_cannot_be_referenced_in_a_computed_property_name_2465",message:"'this' cannot be referenced in a computed property name."},super_cannot_be_referenced_in_a_computed_property_name:{code:2466,category:ts.DiagnosticCategory.Error,key:"super_cannot_be_referenced_in_a_computed_property_name_2466",message:"'super' cannot be referenced in a computed property name."},A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type:{code:2467,category:ts.DiagnosticCategory.Error,key:"A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type_2467",message:"A computed property name cannot reference a type parameter from its containing type."},Cannot_find_global_value_0:{code:2468,category:ts.DiagnosticCategory.Error,key:"Cannot_find_global_value_0_2468",message:"Cannot find global value '{0}'."},The_0_operator_cannot_be_applied_to_type_symbol:{code:2469,category:ts.DiagnosticCategory.Error,key:"The_0_operator_cannot_be_applied_to_type_symbol_2469",message:"The '{0}' operator cannot be applied to type 'symbol'."},Symbol_reference_does_not_refer_to_the_global_Symbol_constructor_object:{code:2470,category:ts.DiagnosticCategory.Error,key:"Symbol_reference_does_not_refer_to_the_global_Symbol_constructor_object_2470",message:"'Symbol' reference does not refer to the global Symbol constructor object."},A_computed_property_name_of_the_form_0_must_be_of_type_symbol:{code:2471,category:ts.DiagnosticCategory.Error,key:"A_computed_property_name_of_the_form_0_must_be_of_type_symbol_2471",message:"A computed property name of the form '{0}' must be of type 'symbol'."},Spread_operator_in_new_expressions_is_only_available_when_targeting_ECMAScript_5_and_higher:{code:2472,category:ts.DiagnosticCategory.Error,key:"Spread_operator_in_new_expressions_is_only_available_when_targeting_ECMAScript_5_and_higher_2472",message:"Spread operator in 'new' expressions is only available when targeting ECMAScript 5 and higher."},Enum_declarations_must_all_be_const_or_non_const:{code:2473,category:ts.DiagnosticCategory.Error,key:"Enum_declarations_must_all_be_const_or_non_const_2473",message:"Enum declarations must all be const or non-const."},In_const_enum_declarations_member_initializer_must_be_constant_expression:{code:2474,category:ts.DiagnosticCategory.Error,key:"In_const_enum_declarations_member_initializer_must_be_constant_expression_2474",message:"In 'const' enum declarations member initializer must be constant expression."},const_enums_can_only_be_used_in_property_or_index_access_expressions_or_the_right_hand_side_of_an_import_declaration_or_export_assignment:{code:2475,category:ts.DiagnosticCategory.Error,key:"const_enums_can_only_be_used_in_property_or_index_access_expressions_or_the_right_hand_side_of_an_im_2475",message:"'const' enums can only be used in property or index access expressions or the right hand side of an import declaration or export assignment."},A_const_enum_member_can_only_be_accessed_using_a_string_literal:{code:2476,category:ts.DiagnosticCategory.Error,key:"A_const_enum_member_can_only_be_accessed_using_a_string_literal_2476",message:"A const enum member can only be accessed using a string literal."},const_enum_member_initializer_was_evaluated_to_a_non_finite_value:{code:2477,category:ts.DiagnosticCategory.Error,key:"const_enum_member_initializer_was_evaluated_to_a_non_finite_value_2477",message:"'const' enum member initializer was evaluated to a non-finite value."},const_enum_member_initializer_was_evaluated_to_disallowed_value_NaN:{code:2478,category:ts.DiagnosticCategory.Error,key:"const_enum_member_initializer_was_evaluated_to_disallowed_value_NaN_2478",message:"'const' enum member initializer was evaluated to disallowed value 'NaN'."},Property_0_does_not_exist_on_const_enum_1:{code:2479,category:ts.DiagnosticCategory.Error,key:"Property_0_does_not_exist_on_const_enum_1_2479",message:"Property '{0}' does not exist on 'const' enum '{1}'."},let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations:{code:2480,category:ts.DiagnosticCategory.Error,key:"let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations_2480",message:"'let' is not allowed to be used as a name in 'let' or 'const' declarations."},Cannot_initialize_outer_scoped_variable_0_in_the_same_scope_as_block_scoped_declaration_1:{code:2481,category:ts.DiagnosticCategory.Error,key:"Cannot_initialize_outer_scoped_variable_0_in_the_same_scope_as_block_scoped_declaration_1_2481",message:"Cannot initialize outer scoped variable '{0}' in the same scope as block scoped declaration '{1}'."},The_left_hand_side_of_a_for_of_statement_cannot_use_a_type_annotation:{code:2483,category:ts.DiagnosticCategory.Error,key:"The_left_hand_side_of_a_for_of_statement_cannot_use_a_type_annotation_2483",message:"The left-hand side of a 'for...of' statement cannot use a type annotation."},Export_declaration_conflicts_with_exported_declaration_of_0:{code:2484,category:ts.DiagnosticCategory.Error,key:"Export_declaration_conflicts_with_exported_declaration_of_0_2484",message:"Export declaration conflicts with exported declaration of '{0}'"},The_left_hand_side_of_a_for_of_statement_cannot_be_a_previously_defined_constant:{code:2485,category:ts.DiagnosticCategory.Error,key:"The_left_hand_side_of_a_for_of_statement_cannot_be_a_previously_defined_constant_2485",message:"The left-hand side of a 'for...of' statement cannot be a previously defined constant."},The_left_hand_side_of_a_for_in_statement_cannot_be_a_previously_defined_constant:{code:2486,category:ts.DiagnosticCategory.Error,key:"The_left_hand_side_of_a_for_in_statement_cannot_be_a_previously_defined_constant_2486",message:"The left-hand side of a 'for...in' statement cannot be a previously defined constant."},Invalid_left_hand_side_in_for_of_statement:{code:2487,category:ts.DiagnosticCategory.Error,key:"Invalid_left_hand_side_in_for_of_statement_2487",message:"Invalid left-hand side in 'for...of' statement."},Type_must_have_a_Symbol_iterator_method_that_returns_an_iterator:{code:2488,category:ts.DiagnosticCategory.Error,key:"Type_must_have_a_Symbol_iterator_method_that_returns_an_iterator_2488",message:"Type must have a '[Symbol.iterator]()' method that returns an iterator."},An_iterator_must_have_a_next_method:{code:2489,category:ts.DiagnosticCategory.Error,key:"An_iterator_must_have_a_next_method_2489",message:"An iterator must have a 'next()' method."},The_type_returned_by_the_next_method_of_an_iterator_must_have_a_value_property:{code:2490,category:ts.DiagnosticCategory.Error,key:"The_type_returned_by_the_next_method_of_an_iterator_must_have_a_value_property_2490",message:"The type returned by the 'next()' method of an iterator must have a 'value' property."},The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern:{code:2491,category:ts.DiagnosticCategory.Error,key:"The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern_2491",message:"The left-hand side of a 'for...in' statement cannot be a destructuring pattern."},Cannot_redeclare_identifier_0_in_catch_clause:{code:2492,category:ts.DiagnosticCategory.Error,key:"Cannot_redeclare_identifier_0_in_catch_clause_2492",message:"Cannot redeclare identifier '{0}' in catch clause"},Tuple_type_0_with_length_1_cannot_be_assigned_to_tuple_with_length_2:{code:2493,category:ts.DiagnosticCategory.Error,key:"Tuple_type_0_with_length_1_cannot_be_assigned_to_tuple_with_length_2_2493",message:"Tuple type '{0}' with length '{1}' cannot be assigned to tuple with length '{2}'."},Using_a_string_in_a_for_of_statement_is_only_supported_in_ECMAScript_5_and_higher:{code:2494,category:ts.DiagnosticCategory.Error,key:"Using_a_string_in_a_for_of_statement_is_only_supported_in_ECMAScript_5_and_higher_2494",message:"Using a string in a 'for...of' statement is only supported in ECMAScript 5 and higher."},Type_0_is_not_an_array_type_or_a_string_type:{code:2495,category:ts.DiagnosticCategory.Error,key:"Type_0_is_not_an_array_type_or_a_string_type_2495",message:"Type '{0}' is not an array type or a string type."},The_arguments_object_cannot_be_referenced_in_an_arrow_function_in_ES3_and_ES5_Consider_using_a_standard_function_expression:{code:2496,category:ts.DiagnosticCategory.Error,key:"The_arguments_object_cannot_be_referenced_in_an_arrow_function_in_ES3_and_ES5_Consider_using_a_stand_2496",message:"The 'arguments' object cannot be referenced in an arrow function in ES3 and ES5. Consider using a standard function expression."},Module_0_resolves_to_a_non_module_entity_and_cannot_be_imported_using_this_construct:{code:2497,category:ts.DiagnosticCategory.Error,key:"Module_0_resolves_to_a_non_module_entity_and_cannot_be_imported_using_this_construct_2497",message:"Module '{0}' resolves to a non-module entity and cannot be imported using this construct."},Module_0_uses_export_and_cannot_be_used_with_export_Asterisk:{code:2498,category:ts.DiagnosticCategory.Error,key:"Module_0_uses_export_and_cannot_be_used_with_export_Asterisk_2498",message:"Module '{0}' uses 'export =' and cannot be used with 'export *'."},An_interface_can_only_extend_an_identifier_Slashqualified_name_with_optional_type_arguments:{code:2499,category:ts.DiagnosticCategory.Error,key:"An_interface_can_only_extend_an_identifier_Slashqualified_name_with_optional_type_arguments_2499",message:"An interface can only extend an identifier/qualified-name with optional type arguments."},A_class_can_only_implement_an_identifier_Slashqualified_name_with_optional_type_arguments:{code:2500,category:ts.DiagnosticCategory.Error,key:"A_class_can_only_implement_an_identifier_Slashqualified_name_with_optional_type_arguments_2500",message:"A class can only implement an identifier/qualified-name with optional type arguments."},A_rest_element_cannot_contain_a_binding_pattern:{code:2501,category:ts.DiagnosticCategory.Error,key:"A_rest_element_cannot_contain_a_binding_pattern_2501",message:"A rest element cannot contain a binding pattern."},_0_is_referenced_directly_or_indirectly_in_its_own_type_annotation:{code:2502,category:ts.DiagnosticCategory.Error,key:"_0_is_referenced_directly_or_indirectly_in_its_own_type_annotation_2502",message:"'{0}' is referenced directly or indirectly in its own type annotation."},Cannot_find_namespace_0:{code:2503,category:ts.DiagnosticCategory.Error,key:"Cannot_find_namespace_0_2503",message:"Cannot find namespace '{0}'."},No_best_common_type_exists_among_yield_expressions:{code:2504,category:ts.DiagnosticCategory.Error,key:"No_best_common_type_exists_among_yield_expressions_2504",message:"No best common type exists among yield expressions."},A_generator_cannot_have_a_void_type_annotation:{code:2505,category:ts.DiagnosticCategory.Error,key:"A_generator_cannot_have_a_void_type_annotation_2505",message:"A generator cannot have a 'void' type annotation."},_0_is_referenced_directly_or_indirectly_in_its_own_base_expression:{code:2506,category:ts.DiagnosticCategory.Error,key:"_0_is_referenced_directly_or_indirectly_in_its_own_base_expression_2506",message:"'{0}' is referenced directly or indirectly in its own base expression."},Type_0_is_not_a_constructor_function_type:{code:2507,category:ts.DiagnosticCategory.Error,key:"Type_0_is_not_a_constructor_function_type_2507",message:"Type '{0}' is not a constructor function type."},No_base_constructor_has_the_specified_number_of_type_arguments:{code:2508,category:ts.DiagnosticCategory.Error,key:"No_base_constructor_has_the_specified_number_of_type_arguments_2508",message:"No base constructor has the specified number of type arguments."},Base_constructor_return_type_0_is_not_a_class_or_interface_type:{code:2509,category:ts.DiagnosticCategory.Error,key:"Base_constructor_return_type_0_is_not_a_class_or_interface_type_2509",message:"Base constructor return type '{0}' is not a class or interface type."},Base_constructors_must_all_have_the_same_return_type:{code:2510,category:ts.DiagnosticCategory.Error,key:"Base_constructors_must_all_have_the_same_return_type_2510",message:"Base constructors must all have the same return type."},Cannot_create_an_instance_of_the_abstract_class_0:{code:2511,category:ts.DiagnosticCategory.Error,key:"Cannot_create_an_instance_of_the_abstract_class_0_2511",message:"Cannot create an instance of the abstract class '{0}'."},Overload_signatures_must_all_be_abstract_or_not_abstract:{code:2512,category:ts.DiagnosticCategory.Error,key:"Overload_signatures_must_all_be_abstract_or_not_abstract_2512",message:"Overload signatures must all be abstract or not abstract."},Abstract_method_0_in_class_1_cannot_be_accessed_via_super_expression:{code:2513,category:ts.DiagnosticCategory.Error,key:"Abstract_method_0_in_class_1_cannot_be_accessed_via_super_expression_2513",message:"Abstract method '{0}' in class '{1}' cannot be accessed via super expression."},Classes_containing_abstract_methods_must_be_marked_abstract:{code:2514,category:ts.DiagnosticCategory.Error,key:"Classes_containing_abstract_methods_must_be_marked_abstract_2514",message:"Classes containing abstract methods must be marked abstract."},Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2:{code:2515,category:ts.DiagnosticCategory.Error,key:"Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2_2515",message:"Non-abstract class '{0}' does not implement inherited abstract member '{1}' from class '{2}'."},All_declarations_of_an_abstract_method_must_be_consecutive:{code:2516,category:ts.DiagnosticCategory.Error,key:"All_declarations_of_an_abstract_method_must_be_consecutive_2516",message:"All declarations of an abstract method must be consecutive."},Cannot_assign_an_abstract_constructor_type_to_a_non_abstract_constructor_type:{code:2517,category:ts.DiagnosticCategory.Error,key:"Cannot_assign_an_abstract_constructor_type_to_a_non_abstract_constructor_type_2517",message:"Cannot assign an abstract constructor type to a non-abstract constructor type."},A_this_based_type_guard_is_not_compatible_with_a_parameter_based_type_guard:{code:2518,category:ts.DiagnosticCategory.Error,key:"A_this_based_type_guard_is_not_compatible_with_a_parameter_based_type_guard_2518",message:"A 'this'-based type guard is not compatible with a parameter-based type guard."},Duplicate_identifier_0_Compiler_uses_declaration_1_to_support_async_functions:{code:2520,category:ts.DiagnosticCategory.Error,key:"Duplicate_identifier_0_Compiler_uses_declaration_1_to_support_async_functions_2520",message:"Duplicate identifier '{0}'. Compiler uses declaration '{1}' to support async functions."},Expression_resolves_to_variable_declaration_0_that_compiler_uses_to_support_async_functions:{code:2521,category:ts.DiagnosticCategory.Error,key:"Expression_resolves_to_variable_declaration_0_that_compiler_uses_to_support_async_functions_2521",message:"Expression resolves to variable declaration '{0}' that compiler uses to support async functions."},The_arguments_object_cannot_be_referenced_in_an_async_arrow_function_Consider_using_a_standard_async_function_expression:{code:2522,category:ts.DiagnosticCategory.Error,key:"The_arguments_object_cannot_be_referenced_in_an_async_arrow_function_Consider_using_a_standard_async_2522",message:"The 'arguments' object cannot be referenced in an async arrow function. Consider using a standard async function expression."},yield_expressions_cannot_be_used_in_a_parameter_initializer:{code:2523,category:ts.DiagnosticCategory.Error,key:"yield_expressions_cannot_be_used_in_a_parameter_initializer_2523",message:"'yield' expressions cannot be used in a parameter initializer."},await_expressions_cannot_be_used_in_a_parameter_initializer:{code:2524,category:ts.DiagnosticCategory.Error,key:"await_expressions_cannot_be_used_in_a_parameter_initializer_2524",message:"'await' expressions cannot be used in a parameter initializer."},Initializer_provides_no_value_for_this_binding_element_and_the_binding_element_has_no_default_value:{code:2525,category:ts.DiagnosticCategory.Error,key:"Initializer_provides_no_value_for_this_binding_element_and_the_binding_element_has_no_default_value_2525",message:"Initializer provides no value for this binding element and the binding element has no default value."},A_this_type_is_available_only_in_a_non_static_member_of_a_class_or_interface:{code:2526,category:ts.DiagnosticCategory.Error,key:"A_this_type_is_available_only_in_a_non_static_member_of_a_class_or_interface_2526",message:"A 'this' type is available only in a non-static member of a class or interface."},The_inferred_type_of_0_references_an_inaccessible_this_type_A_type_annotation_is_necessary:{code:2527,category:ts.DiagnosticCategory.Error,key:"The_inferred_type_of_0_references_an_inaccessible_this_type_A_type_annotation_is_necessary_2527",message:"The inferred type of '{0}' references an inaccessible 'this' type. A type annotation is necessary."},A_module_cannot_have_multiple_default_exports:{code:2528,category:ts.DiagnosticCategory.Error,key:"A_module_cannot_have_multiple_default_exports_2528",message:"A module cannot have multiple default exports."},Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_containing_async_functions:{code:2529,category:ts.DiagnosticCategory.Error,key:"Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_containing_async_func_2529",message:"Duplicate identifier '{0}'. Compiler reserves name '{1}' in top level scope of a module containing async functions."},JSX_element_attributes_type_0_may_not_be_a_union_type:{code:2600,category:ts.DiagnosticCategory.Error,key:"JSX_element_attributes_type_0_may_not_be_a_union_type_2600",message:"JSX element attributes type '{0}' may not be a union type."},The_return_type_of_a_JSX_element_constructor_must_return_an_object_type:{code:2601,category:ts.DiagnosticCategory.Error,key:"The_return_type_of_a_JSX_element_constructor_must_return_an_object_type_2601",message:"The return type of a JSX element constructor must return an object type."},JSX_element_implicitly_has_type_any_because_the_global_type_JSX_Element_does_not_exist:{code:2602,category:ts.DiagnosticCategory.Error,key:"JSX_element_implicitly_has_type_any_because_the_global_type_JSX_Element_does_not_exist_2602",message:"JSX element implicitly has type 'any' because the global type 'JSX.Element' does not exist."},Property_0_in_type_1_is_not_assignable_to_type_2:{code:2603,category:ts.DiagnosticCategory.Error,key:"Property_0_in_type_1_is_not_assignable_to_type_2_2603",message:"Property '{0}' in type '{1}' is not assignable to type '{2}'"},JSX_element_type_0_does_not_have_any_construct_or_call_signatures:{code:2604,category:ts.DiagnosticCategory.Error,key:"JSX_element_type_0_does_not_have_any_construct_or_call_signatures_2604",message:"JSX element type '{0}' does not have any construct or call signatures."},JSX_element_type_0_is_not_a_constructor_function_for_JSX_elements:{code:2605,category:ts.DiagnosticCategory.Error,key:"JSX_element_type_0_is_not_a_constructor_function_for_JSX_elements_2605",message:"JSX element type '{0}' is not a constructor function for JSX elements."},Property_0_of_JSX_spread_attribute_is_not_assignable_to_target_property:{code:2606,category:ts.DiagnosticCategory.Error,key:"Property_0_of_JSX_spread_attribute_is_not_assignable_to_target_property_2606",message:"Property '{0}' of JSX spread attribute is not assignable to target property."},JSX_element_class_does_not_support_attributes_because_it_does_not_have_a_0_property:{code:2607,category:ts.DiagnosticCategory.Error,key:"JSX_element_class_does_not_support_attributes_because_it_does_not_have_a_0_property_2607",message:"JSX element class does not support attributes because it does not have a '{0}' property"},The_global_type_JSX_0_may_not_have_more_than_one_property:{code:2608,category:ts.DiagnosticCategory.Error,key:"The_global_type_JSX_0_may_not_have_more_than_one_property_2608",message:"The global type 'JSX.{0}' may not have more than one property"},Cannot_emit_namespaced_JSX_elements_in_React:{code:2650,category:ts.DiagnosticCategory.Error,key:"Cannot_emit_namespaced_JSX_elements_in_React_2650",message:"Cannot emit namespaced JSX elements in React"},A_member_initializer_in_a_enum_declaration_cannot_reference_members_declared_after_it_including_members_defined_in_other_enums:{code:2651,category:ts.DiagnosticCategory.Error,key:"A_member_initializer_in_a_enum_declaration_cannot_reference_members_declared_after_it_including_memb_2651",message:"A member initializer in a enum declaration cannot reference members declared after it, including members defined in other enums."},Merged_declaration_0_cannot_include_a_default_export_declaration_Consider_adding_a_separate_export_default_0_declaration_instead:{code:2652,category:ts.DiagnosticCategory.Error,key:"Merged_declaration_0_cannot_include_a_default_export_declaration_Consider_adding_a_separate_export_d_2652",message:"Merged declaration '{0}' cannot include a default export declaration. Consider adding a separate 'export default {0}' declaration instead."},Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1:{code:2653,category:ts.DiagnosticCategory.Error,key:"Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1_2653",message:"Non-abstract class expression does not implement inherited abstract member '{0}' from class '{1}'."},Exported_external_package_typings_file_cannot_contain_tripleslash_references_Please_contact_the_package_author_to_update_the_package_definition:{code:2654,category:ts.DiagnosticCategory.Error,key:"Exported_external_package_typings_file_cannot_contain_tripleslash_references_Please_contact_the_pack_2654",message:"Exported external package typings file cannot contain tripleslash references. Please contact the package author to update the package definition."},Exported_external_package_typings_file_0_is_not_a_module_Please_contact_the_package_author_to_update_the_package_definition:{code:2656,category:ts.DiagnosticCategory.Error,key:"Exported_external_package_typings_file_0_is_not_a_module_Please_contact_the_package_author_to_update_2656",message:"Exported external package typings file '{0}' is not a module. Please contact the package author to update the package definition."},JSX_expressions_must_have_one_parent_element:{code:2657,category:ts.DiagnosticCategory.Error,key:"JSX_expressions_must_have_one_parent_element_2657",message:"JSX expressions must have one parent element"},Type_0_provides_no_match_for_the_signature_1:{code:2658,category:ts.DiagnosticCategory.Error,key:"Type_0_provides_no_match_for_the_signature_1_2658",message:"Type '{0}' provides no match for the signature '{1}'"},super_is_only_allowed_in_members_of_object_literal_expressions_when_option_target_is_ES2015_or_higher:{code:2659,category:ts.DiagnosticCategory.Error,key:"super_is_only_allowed_in_members_of_object_literal_expressions_when_option_target_is_ES2015_or_highe_2659",message:"'super' is only allowed in members of object literal expressions when option 'target' is 'ES2015' or higher."},super_can_only_be_referenced_in_members_of_derived_classes_or_object_literal_expressions:{code:2660,category:ts.DiagnosticCategory.Error,key:"super_can_only_be_referenced_in_members_of_derived_classes_or_object_literal_expressions_2660",message:"'super' can only be referenced in members of derived classes or object literal expressions."},Cannot_re_export_name_that_is_not_defined_in_the_module:{code:2661,category:ts.DiagnosticCategory.Error,key:"Cannot_re_export_name_that_is_not_defined_in_the_module_2661",message:"Cannot re-export name that is not defined in the module."},Cannot_find_name_0_Did_you_mean_the_static_member_1_0:{code:2662,category:ts.DiagnosticCategory.Error,key:"Cannot_find_name_0_Did_you_mean_the_static_member_1_0_2662",message:"Cannot find name '{0}'. Did you mean the static member '{1}.{0}'?"},Cannot_find_name_0_Did_you_mean_the_instance_member_this_0:{code:2663,category:ts.DiagnosticCategory.Error,key:"Cannot_find_name_0_Did_you_mean_the_instance_member_this_0_2663",message:"Cannot find name '{0}'. Did you mean the instance member 'this.{0}'?"},Invalid_module_name_in_augmentation_module_0_cannot_be_found:{code:2664,category:ts.DiagnosticCategory.Error,key:"Invalid_module_name_in_augmentation_module_0_cannot_be_found_2664",message:"Invalid module name in augmentation, module '{0}' cannot be found."},Module_augmentation_cannot_introduce_new_names_in_the_top_level_scope:{code:2665,category:ts.DiagnosticCategory.Error,key:"Module_augmentation_cannot_introduce_new_names_in_the_top_level_scope_2665",message:"Module augmentation cannot introduce new names in the top level scope."},Exports_and_export_assignments_are_not_permitted_in_module_augmentations:{code:2666,category:ts.DiagnosticCategory.Error,key:"Exports_and_export_assignments_are_not_permitted_in_module_augmentations_2666",message:"Exports and export assignments are not permitted in module augmentations."},Imports_are_not_permitted_in_module_augmentations_Consider_moving_them_to_the_enclosing_external_module:{code:2667,category:ts.DiagnosticCategory.Error,key:"Imports_are_not_permitted_in_module_augmentations_Consider_moving_them_to_the_enclosing_external_mod_2667",message:"Imports are not permitted in module augmentations. Consider moving them to the enclosing external module."},export_modifier_cannot_be_applied_to_ambient_modules_and_module_augmentations_since_they_are_always_visible:{code:2668,category:ts.DiagnosticCategory.Error,key:"export_modifier_cannot_be_applied_to_ambient_modules_and_module_augmentations_since_they_are_always__2668",message:"'export' modifier cannot be applied to ambient modules and module augmentations since they are always visible."},Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_declarations:{code:2669,category:ts.DiagnosticCategory.Error,key:"Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_2669",message:"Augmentations for the global scope can only be directly nested in external modules or ambient module declarations."},Augmentations_for_the_global_scope_should_have_declare_modifier_unless_they_appear_in_already_ambient_context:{code:2670,category:ts.DiagnosticCategory.Error,key:"Augmentations_for_the_global_scope_should_have_declare_modifier_unless_they_appear_in_already_ambien_2670",message:"Augmentations for the global scope should have 'declare' modifier unless they appear in already ambient context."},Cannot_augment_module_0_because_it_resolves_to_a_non_module_entity:{code:2671,category:ts.DiagnosticCategory.Error,key:"Cannot_augment_module_0_because_it_resolves_to_a_non_module_entity_2671",message:"Cannot augment module '{0}' because it resolves to a non-module entity."},Import_declaration_0_is_using_private_name_1:{code:4e3,category:ts.DiagnosticCategory.Error,key:"Import_declaration_0_is_using_private_name_1_4000",message:"Import declaration '{0}' is using private name '{1}'."},Type_parameter_0_of_exported_class_has_or_is_using_private_name_1:{code:4002,category:ts.DiagnosticCategory.Error,key:"Type_parameter_0_of_exported_class_has_or_is_using_private_name_1_4002",message:"Type parameter '{0}' of exported class has or is using private name '{1}'."},Type_parameter_0_of_exported_interface_has_or_is_using_private_name_1:{code:4004,category:ts.DiagnosticCategory.Error,key:"Type_parameter_0_of_exported_interface_has_or_is_using_private_name_1_4004",message:"Type parameter '{0}' of exported interface has or is using private name '{1}'."},Type_parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1:{code:4006,category:ts.DiagnosticCategory.Error,key:"Type_parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1_4006",message:"Type parameter '{0}' of constructor signature from exported interface has or is using private name '{1}'."},Type_parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1:{code:4008,category:ts.DiagnosticCategory.Error,key:"Type_parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1_4008",message:"Type parameter '{0}' of call signature from exported interface has or is using private name '{1}'."},Type_parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1:{code:4010,category:ts.DiagnosticCategory.Error,key:"Type_parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1_4010",message:"Type parameter '{0}' of public static method from exported class has or is using private name '{1}'."},Type_parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1:{code:4012,category:ts.DiagnosticCategory.Error,key:"Type_parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1_4012",message:"Type parameter '{0}' of public method from exported class has or is using private name '{1}'."},Type_parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1:{code:4014,category:ts.DiagnosticCategory.Error,key:"Type_parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1_4014",message:"Type parameter '{0}' of method from exported interface has or is using private name '{1}'."},Type_parameter_0_of_exported_function_has_or_is_using_private_name_1:{code:4016,category:ts.DiagnosticCategory.Error,key:"Type_parameter_0_of_exported_function_has_or_is_using_private_name_1_4016",message:"Type parameter '{0}' of exported function has or is using private name '{1}'."},Implements_clause_of_exported_class_0_has_or_is_using_private_name_1:{code:4019,category:ts.DiagnosticCategory.Error,key:"Implements_clause_of_exported_class_0_has_or_is_using_private_name_1_4019",message:"Implements clause of exported class '{0}' has or is using private name '{1}'."},Extends_clause_of_exported_class_0_has_or_is_using_private_name_1:{code:4020,category:ts.DiagnosticCategory.Error,key:"Extends_clause_of_exported_class_0_has_or_is_using_private_name_1_4020",message:"Extends clause of exported class '{0}' has or is using private name '{1}'."},Extends_clause_of_exported_interface_0_has_or_is_using_private_name_1:{code:4022,category:ts.DiagnosticCategory.Error,key:"Extends_clause_of_exported_interface_0_has_or_is_using_private_name_1_4022",message:"Extends clause of exported interface '{0}' has or is using private name '{1}'."},Exported_variable_0_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:{
code:4023,category:ts.DiagnosticCategory.Error,key:"Exported_variable_0_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4023",message:"Exported variable '{0}' has or is using name '{1}' from external module {2} but cannot be named."},Exported_variable_0_has_or_is_using_name_1_from_private_module_2:{code:4024,category:ts.DiagnosticCategory.Error,key:"Exported_variable_0_has_or_is_using_name_1_from_private_module_2_4024",message:"Exported variable '{0}' has or is using name '{1}' from private module '{2}'."},Exported_variable_0_has_or_is_using_private_name_1:{code:4025,category:ts.DiagnosticCategory.Error,key:"Exported_variable_0_has_or_is_using_private_name_1_4025",message:"Exported variable '{0}' has or is using private name '{1}'."},Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:{code:4026,category:ts.DiagnosticCategory.Error,key:"Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot__4026",message:"Public static property '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."},Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:{code:4027,category:ts.DiagnosticCategory.Error,key:"Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4027",message:"Public static property '{0}' of exported class has or is using name '{1}' from private module '{2}'."},Public_static_property_0_of_exported_class_has_or_is_using_private_name_1:{code:4028,category:ts.DiagnosticCategory.Error,key:"Public_static_property_0_of_exported_class_has_or_is_using_private_name_1_4028",message:"Public static property '{0}' of exported class has or is using private name '{1}'."},Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:{code:4029,category:ts.DiagnosticCategory.Error,key:"Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_name_4029",message:"Public property '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."},Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:{code:4030,category:ts.DiagnosticCategory.Error,key:"Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4030",message:"Public property '{0}' of exported class has or is using name '{1}' from private module '{2}'."},Public_property_0_of_exported_class_has_or_is_using_private_name_1:{code:4031,category:ts.DiagnosticCategory.Error,key:"Public_property_0_of_exported_class_has_or_is_using_private_name_1_4031",message:"Public property '{0}' of exported class has or is using private name '{1}'."},Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2:{code:4032,category:ts.DiagnosticCategory.Error,key:"Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2_4032",message:"Property '{0}' of exported interface has or is using name '{1}' from private module '{2}'."},Property_0_of_exported_interface_has_or_is_using_private_name_1:{code:4033,category:ts.DiagnosticCategory.Error,key:"Property_0_of_exported_interface_has_or_is_using_private_name_1_4033",message:"Property '{0}' of exported interface has or is using private name '{1}'."},Parameter_0_of_public_static_property_setter_from_exported_class_has_or_is_using_name_1_from_private_module_2:{code:4034,category:ts.DiagnosticCategory.Error,key:"Parameter_0_of_public_static_property_setter_from_exported_class_has_or_is_using_name_1_from_private_4034",message:"Parameter '{0}' of public static property setter from exported class has or is using name '{1}' from private module '{2}'."},Parameter_0_of_public_static_property_setter_from_exported_class_has_or_is_using_private_name_1:{code:4035,category:ts.DiagnosticCategory.Error,key:"Parameter_0_of_public_static_property_setter_from_exported_class_has_or_is_using_private_name_1_4035",message:"Parameter '{0}' of public static property setter from exported class has or is using private name '{1}'."},Parameter_0_of_public_property_setter_from_exported_class_has_or_is_using_name_1_from_private_module_2:{code:4036,category:ts.DiagnosticCategory.Error,key:"Parameter_0_of_public_property_setter_from_exported_class_has_or_is_using_name_1_from_private_module_4036",message:"Parameter '{0}' of public property setter from exported class has or is using name '{1}' from private module '{2}'."},Parameter_0_of_public_property_setter_from_exported_class_has_or_is_using_private_name_1:{code:4037,category:ts.DiagnosticCategory.Error,key:"Parameter_0_of_public_property_setter_from_exported_class_has_or_is_using_private_name_1_4037",message:"Parameter '{0}' of public property setter from exported class has or is using private name '{1}'."},Return_type_of_public_static_property_getter_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:{code:4038,category:ts.DiagnosticCategory.Error,key:"Return_type_of_public_static_property_getter_from_exported_class_has_or_is_using_name_0_from_externa_4038",message:"Return type of public static property getter from exported class has or is using name '{0}' from external module {1} but cannot be named."},Return_type_of_public_static_property_getter_from_exported_class_has_or_is_using_name_0_from_private_module_1:{code:4039,category:ts.DiagnosticCategory.Error,key:"Return_type_of_public_static_property_getter_from_exported_class_has_or_is_using_name_0_from_private_4039",message:"Return type of public static property getter from exported class has or is using name '{0}' from private module '{1}'."},Return_type_of_public_static_property_getter_from_exported_class_has_or_is_using_private_name_0:{code:4040,category:ts.DiagnosticCategory.Error,key:"Return_type_of_public_static_property_getter_from_exported_class_has_or_is_using_private_name_0_4040",message:"Return type of public static property getter from exported class has or is using private name '{0}'."},Return_type_of_public_property_getter_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:{code:4041,category:ts.DiagnosticCategory.Error,key:"Return_type_of_public_property_getter_from_exported_class_has_or_is_using_name_0_from_external_modul_4041",message:"Return type of public property getter from exported class has or is using name '{0}' from external module {1} but cannot be named."},Return_type_of_public_property_getter_from_exported_class_has_or_is_using_name_0_from_private_module_1:{code:4042,category:ts.DiagnosticCategory.Error,key:"Return_type_of_public_property_getter_from_exported_class_has_or_is_using_name_0_from_private_module_4042",message:"Return type of public property getter from exported class has or is using name '{0}' from private module '{1}'."},Return_type_of_public_property_getter_from_exported_class_has_or_is_using_private_name_0:{code:4043,category:ts.DiagnosticCategory.Error,key:"Return_type_of_public_property_getter_from_exported_class_has_or_is_using_private_name_0_4043",message:"Return type of public property getter from exported class has or is using private name '{0}'."},Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1:{code:4044,category:ts.DiagnosticCategory.Error,key:"Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_name_0_from_private_mod_4044",message:"Return type of constructor signature from exported interface has or is using name '{0}' from private module '{1}'."},Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_0:{code:4045,category:ts.DiagnosticCategory.Error,key:"Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_0_4045",message:"Return type of constructor signature from exported interface has or is using private name '{0}'."},Return_type_of_call_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1:{code:4046,category:ts.DiagnosticCategory.Error,key:"Return_type_of_call_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1_4046",message:"Return type of call signature from exported interface has or is using name '{0}' from private module '{1}'."},Return_type_of_call_signature_from_exported_interface_has_or_is_using_private_name_0:{code:4047,category:ts.DiagnosticCategory.Error,key:"Return_type_of_call_signature_from_exported_interface_has_or_is_using_private_name_0_4047",message:"Return type of call signature from exported interface has or is using private name '{0}'."},Return_type_of_index_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1:{code:4048,category:ts.DiagnosticCategory.Error,key:"Return_type_of_index_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1_4048",message:"Return type of index signature from exported interface has or is using name '{0}' from private module '{1}'."},Return_type_of_index_signature_from_exported_interface_has_or_is_using_private_name_0:{code:4049,category:ts.DiagnosticCategory.Error,key:"Return_type_of_index_signature_from_exported_interface_has_or_is_using_private_name_0_4049",message:"Return type of index signature from exported interface has or is using private name '{0}'."},Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:{code:4050,category:ts.DiagnosticCategory.Error,key:"Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_external_module__4050",message:"Return type of public static method from exported class has or is using name '{0}' from external module {1} but cannot be named."},Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_private_module_1:{code:4051,category:ts.DiagnosticCategory.Error,key:"Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_private_module_1_4051",message:"Return type of public static method from exported class has or is using name '{0}' from private module '{1}'."},Return_type_of_public_static_method_from_exported_class_has_or_is_using_private_name_0:{code:4052,category:ts.DiagnosticCategory.Error,key:"Return_type_of_public_static_method_from_exported_class_has_or_is_using_private_name_0_4052",message:"Return type of public static method from exported class has or is using private name '{0}'."},Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:{code:4053,category:ts.DiagnosticCategory.Error,key:"Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_c_4053",message:"Return type of public method from exported class has or is using name '{0}' from external module {1} but cannot be named."},Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_private_module_1:{code:4054,category:ts.DiagnosticCategory.Error,key:"Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_private_module_1_4054",message:"Return type of public method from exported class has or is using name '{0}' from private module '{1}'."},Return_type_of_public_method_from_exported_class_has_or_is_using_private_name_0:{code:4055,category:ts.DiagnosticCategory.Error,key:"Return_type_of_public_method_from_exported_class_has_or_is_using_private_name_0_4055",message:"Return type of public method from exported class has or is using private name '{0}'."},Return_type_of_method_from_exported_interface_has_or_is_using_name_0_from_private_module_1:{code:4056,category:ts.DiagnosticCategory.Error,key:"Return_type_of_method_from_exported_interface_has_or_is_using_name_0_from_private_module_1_4056",message:"Return type of method from exported interface has or is using name '{0}' from private module '{1}'."},Return_type_of_method_from_exported_interface_has_or_is_using_private_name_0:{code:4057,category:ts.DiagnosticCategory.Error,key:"Return_type_of_method_from_exported_interface_has_or_is_using_private_name_0_4057",message:"Return type of method from exported interface has or is using private name '{0}'."},Return_type_of_exported_function_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:{code:4058,category:ts.DiagnosticCategory.Error,key:"Return_type_of_exported_function_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named_4058",message:"Return type of exported function has or is using name '{0}' from external module {1} but cannot be named."},Return_type_of_exported_function_has_or_is_using_name_0_from_private_module_1:{code:4059,category:ts.DiagnosticCategory.Error,key:"Return_type_of_exported_function_has_or_is_using_name_0_from_private_module_1_4059",message:"Return type of exported function has or is using name '{0}' from private module '{1}'."},Return_type_of_exported_function_has_or_is_using_private_name_0:{code:4060,category:ts.DiagnosticCategory.Error,key:"Return_type_of_exported_function_has_or_is_using_private_name_0_4060",message:"Return type of exported function has or is using private name '{0}'."},Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:{code:4061,category:ts.DiagnosticCategory.Error,key:"Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_can_4061",message:"Parameter '{0}' of constructor from exported class has or is using name '{1}' from external module {2} but cannot be named."},Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_private_module_2:{code:4062,category:ts.DiagnosticCategory.Error,key:"Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_private_module_2_4062",message:"Parameter '{0}' of constructor from exported class has or is using name '{1}' from private module '{2}'."},Parameter_0_of_constructor_from_exported_class_has_or_is_using_private_name_1:{code:4063,category:ts.DiagnosticCategory.Error,key:"Parameter_0_of_constructor_from_exported_class_has_or_is_using_private_name_1_4063",message:"Parameter '{0}' of constructor from exported class has or is using private name '{1}'."},Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2:{code:4064,category:ts.DiagnosticCategory.Error,key:"Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_name_1_from_private_mod_4064",message:"Parameter '{0}' of constructor signature from exported interface has or is using name '{1}' from private module '{2}'."},Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1:{code:4065,category:ts.DiagnosticCategory.Error,key:"Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1_4065",message:"Parameter '{0}' of constructor signature from exported interface has or is using private name '{1}'."},Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2:{code:4066,category:ts.DiagnosticCategory.Error,key:"Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2_4066",message:"Parameter '{0}' of call signature from exported interface has or is using name '{1}' from private module '{2}'."},Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1:{code:4067,category:ts.DiagnosticCategory.Error,key:"Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1_4067",message:"Parameter '{0}' of call signature from exported interface has or is using private name '{1}'."},Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:{code:4068,category:ts.DiagnosticCategory.Error,key:"Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_external_module__4068",message:"Parameter '{0}' of public static method from exported class has or is using name '{1}' from external module {2} but cannot be named."},Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_private_module_2:{code:4069,category:ts.DiagnosticCategory.Error,key:"Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_private_module_2_4069",message:"Parameter '{0}' of public static method from exported class has or is using name '{1}' from private module '{2}'."},Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1:{code:4070,category:ts.DiagnosticCategory.Error,key:"Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1_4070",message:"Parameter '{0}' of public static method from exported class has or is using private name '{1}'."},Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:{code:4071,category:ts.DiagnosticCategory.Error,key:"Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_c_4071",message:"Parameter '{0}' of public method from exported class has or is using name '{1}' from external module {2} but cannot be named."},Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_private_module_2:{code:4072,category:ts.DiagnosticCategory.Error,key:"Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_private_module_2_4072",message:"Parameter '{0}' of public method from exported class has or is using name '{1}' from private module '{2}'."},Parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1:{code:4073,category:ts.DiagnosticCategory.Error,key:"Parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1_4073",message:"Parameter '{0}' of public method from exported class has or is using private name '{1}'."},Parameter_0_of_method_from_exported_interface_has_or_is_using_name_1_from_private_module_2:{code:4074,category:ts.DiagnosticCategory.Error,key:"Parameter_0_of_method_from_exported_interface_has_or_is_using_name_1_from_private_module_2_4074",message:"Parameter '{0}' of method from exported interface has or is using name '{1}' from private module '{2}'."},Parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1:{code:4075,category:ts.DiagnosticCategory.Error,key:"Parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1_4075",message:"Parameter '{0}' of method from exported interface has or is using private name '{1}'."},Parameter_0_of_exported_function_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:{code:4076,category:ts.DiagnosticCategory.Error,key:"Parameter_0_of_exported_function_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4076",message:"Parameter '{0}' of exported function has or is using name '{1}' from external module {2} but cannot be named."},Parameter_0_of_exported_function_has_or_is_using_name_1_from_private_module_2:{code:4077,category:ts.DiagnosticCategory.Error,key:"Parameter_0_of_exported_function_has_or_is_using_name_1_from_private_module_2_4077",message:"Parameter '{0}' of exported function has or is using name '{1}' from private module '{2}'."},Parameter_0_of_exported_function_has_or_is_using_private_name_1:{code:4078,category:ts.DiagnosticCategory.Error,key:"Parameter_0_of_exported_function_has_or_is_using_private_name_1_4078",message:"Parameter '{0}' of exported function has or is using private name '{1}'."},Exported_type_alias_0_has_or_is_using_private_name_1:{code:4081,category:ts.DiagnosticCategory.Error,key:"Exported_type_alias_0_has_or_is_using_private_name_1_4081",message:"Exported type alias '{0}' has or is using private name '{1}'."},Default_export_of_the_module_has_or_is_using_private_name_0:{code:4082,category:ts.DiagnosticCategory.Error,key:"Default_export_of_the_module_has_or_is_using_private_name_0_4082",message:"Default export of the module has or is using private name '{0}'."},The_current_host_does_not_support_the_0_option:{code:5001,category:ts.DiagnosticCategory.Error,key:"The_current_host_does_not_support_the_0_option_5001",message:"The current host does not support the '{0}' option."},Cannot_find_the_common_subdirectory_path_for_the_input_files:{code:5009,category:ts.DiagnosticCategory.Error,key:"Cannot_find_the_common_subdirectory_path_for_the_input_files_5009",message:"Cannot find the common subdirectory path for the input files."},Cannot_read_file_0_Colon_1:{code:5012,category:ts.DiagnosticCategory.Error,key:"Cannot_read_file_0_Colon_1_5012",message:"Cannot read file '{0}': {1}"},Unsupported_file_encoding:{code:5013,category:ts.DiagnosticCategory.Error,key:"Unsupported_file_encoding_5013",message:"Unsupported file encoding."},Failed_to_parse_file_0_Colon_1:{code:5014,category:ts.DiagnosticCategory.Error,key:"Failed_to_parse_file_0_Colon_1_5014",message:"Failed to parse file '{0}': {1}."},Unknown_compiler_option_0:{code:5023,category:ts.DiagnosticCategory.Error,key:"Unknown_compiler_option_0_5023",message:"Unknown compiler option '{0}'."},Compiler_option_0_requires_a_value_of_type_1:{code:5024,category:ts.DiagnosticCategory.Error,key:"Compiler_option_0_requires_a_value_of_type_1_5024",message:"Compiler option '{0}' requires a value of type {1}."},Could_not_write_file_0_Colon_1:{code:5033,category:ts.DiagnosticCategory.Error,key:"Could_not_write_file_0_Colon_1_5033",message:"Could not write file '{0}': {1}"},Option_project_cannot_be_mixed_with_source_files_on_a_command_line:{code:5042,category:ts.DiagnosticCategory.Error,key:"Option_project_cannot_be_mixed_with_source_files_on_a_command_line_5042",message:"Option 'project' cannot be mixed with source files on a command line."},Option_isolatedModules_can_only_be_used_when_either_option_module_is_provided_or_option_target_is_ES2015_or_higher:{code:5047,category:ts.DiagnosticCategory.Error,key:"Option_isolatedModules_can_only_be_used_when_either_option_module_is_provided_or_option_target_is_ES_5047",message:"Option 'isolatedModules' can only be used when either option '--module' is provided or option 'target' is 'ES2015' or higher."},Option_inlineSources_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided:{code:5051,category:ts.DiagnosticCategory.Error,key:"Option_inlineSources_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_prov_5051",message:"Option 'inlineSources' can only be used when either option '--inlineSourceMap' or option '--sourceMap' is provided."},Option_0_cannot_be_specified_without_specifying_option_1:{code:5052,category:ts.DiagnosticCategory.Error,key:"Option_0_cannot_be_specified_without_specifying_option_1_5052",message:"Option '{0}' cannot be specified without specifying option '{1}'."},Option_0_cannot_be_specified_with_option_1:{code:5053,category:ts.DiagnosticCategory.Error,key:"Option_0_cannot_be_specified_with_option_1_5053",message:"Option '{0}' cannot be specified with option '{1}'."},A_tsconfig_json_file_is_already_defined_at_Colon_0:{code:5054,category:ts.DiagnosticCategory.Error,key:"A_tsconfig_json_file_is_already_defined_at_Colon_0_5054",message:"A 'tsconfig.json' file is already defined at: '{0}'."},Cannot_write_file_0_because_it_would_overwrite_input_file:{code:5055,category:ts.DiagnosticCategory.Error,key:"Cannot_write_file_0_because_it_would_overwrite_input_file_5055",message:"Cannot write file '{0}' because it would overwrite input file."},Cannot_write_file_0_because_it_would_be_overwritten_by_multiple_input_files:{code:5056,category:ts.DiagnosticCategory.Error,key:"Cannot_write_file_0_because_it_would_be_overwritten_by_multiple_input_files_5056",message:"Cannot write file '{0}' because it would be overwritten by multiple input files."},Cannot_find_a_tsconfig_json_file_at_the_specified_directory_Colon_0:{code:5057,category:ts.DiagnosticCategory.Error,key:"Cannot_find_a_tsconfig_json_file_at_the_specified_directory_Colon_0_5057",message:"Cannot find a tsconfig.json file at the specified directory: '{0}'"},The_specified_path_does_not_exist_Colon_0:{code:5058,category:ts.DiagnosticCategory.Error,key:"The_specified_path_does_not_exist_Colon_0_5058",message:"The specified path does not exist: '{0}'"},Invalide_value_for_reactNamespace_0_is_not_a_valid_identifier:{code:5059,category:ts.DiagnosticCategory.Error,key:"Invalide_value_for_reactNamespace_0_is_not_a_valid_identifier_5059",message:"Invalide value for '--reactNamespace'. '{0}' is not a valid identifier."},Concatenate_and_emit_output_to_single_file:{code:6001,category:ts.DiagnosticCategory.Message,key:"Concatenate_and_emit_output_to_single_file_6001",message:"Concatenate and emit output to single file."},Generates_corresponding_d_ts_file:{code:6002,category:ts.DiagnosticCategory.Message,key:"Generates_corresponding_d_ts_file_6002",message:"Generates corresponding '.d.ts' file."},Specifies_the_location_where_debugger_should_locate_map_files_instead_of_generated_locations:{code:6003,category:ts.DiagnosticCategory.Message,key:"Specifies_the_location_where_debugger_should_locate_map_files_instead_of_generated_locations_6003",message:"Specifies the location where debugger should locate map files instead of generated locations."},Specifies_the_location_where_debugger_should_locate_TypeScript_files_instead_of_source_locations:{code:6004,category:ts.DiagnosticCategory.Message,key:"Specifies_the_location_where_debugger_should_locate_TypeScript_files_instead_of_source_locations_6004",message:"Specifies the location where debugger should locate TypeScript files instead of source locations."},Watch_input_files:{code:6005,category:ts.DiagnosticCategory.Message,key:"Watch_input_files_6005",message:"Watch input files."},Redirect_output_structure_to_the_directory:{code:6006,category:ts.DiagnosticCategory.Message,key:"Redirect_output_structure_to_the_directory_6006",message:"Redirect output structure to the directory."},Do_not_erase_const_enum_declarations_in_generated_code:{code:6007,category:ts.DiagnosticCategory.Message,key:"Do_not_erase_const_enum_declarations_in_generated_code_6007",message:"Do not erase const enum declarations in generated code."},Do_not_emit_outputs_if_any_errors_were_reported:{code:6008,category:ts.DiagnosticCategory.Message,key:"Do_not_emit_outputs_if_any_errors_were_reported_6008",message:"Do not emit outputs if any errors were reported."},Do_not_emit_comments_to_output:{code:6009,category:ts.DiagnosticCategory.Message,key:"Do_not_emit_comments_to_output_6009",message:"Do not emit comments to output."},Do_not_emit_outputs:{code:6010,category:ts.DiagnosticCategory.Message,key:"Do_not_emit_outputs_6010",message:"Do not emit outputs."},Allow_default_imports_from_modules_with_no_default_export_This_does_not_affect_code_emit_just_typechecking:{code:6011,category:ts.DiagnosticCategory.Message,key:"Allow_default_imports_from_modules_with_no_default_export_This_does_not_affect_code_emit_just_typech_6011",message:"Allow default imports from modules with no default export. This does not affect code emit, just typechecking."},Specify_ECMAScript_target_version_Colon_ES3_default_ES5_or_ES2015_experimental:{code:6015,category:ts.DiagnosticCategory.Message,key:"Specify_ECMAScript_target_version_Colon_ES3_default_ES5_or_ES2015_experimental_6015",message:"Specify ECMAScript target version: 'ES3' (default), 'ES5', or 'ES2015' (experimental)"},Specify_module_code_generation_Colon_commonjs_amd_system_umd_or_es2015:{code:6016,category:ts.DiagnosticCategory.Message,key:"Specify_module_code_generation_Colon_commonjs_amd_system_umd_or_es2015_6016",message:"Specify module code generation: 'commonjs', 'amd', 'system', 'umd' or 'es2015'"},Print_this_message:{code:6017,category:ts.DiagnosticCategory.Message,key:"Print_this_message_6017",message:"Print this message."},Print_the_compiler_s_version:{code:6019,category:ts.DiagnosticCategory.Message,key:"Print_the_compiler_s_version_6019",message:"Print the compiler's version."},Compile_the_project_in_the_given_directory:{code:6020,category:ts.DiagnosticCategory.Message,key:"Compile_the_project_in_the_given_directory_6020",message:"Compile the project in the given directory."},Syntax_Colon_0:{code:6023,category:ts.DiagnosticCategory.Message,key:"Syntax_Colon_0_6023",message:"Syntax: {0}"},options:{code:6024,category:ts.DiagnosticCategory.Message,key:"options_6024",message:"options"},file:{code:6025,category:ts.DiagnosticCategory.Message,key:"file_6025",message:"file"},Examples_Colon_0:{code:6026,category:ts.DiagnosticCategory.Message,key:"Examples_Colon_0_6026",message:"Examples: {0}"},Options_Colon:{code:6027,category:ts.DiagnosticCategory.Message,key:"Options_Colon_6027",message:"Options:"},Version_0:{code:6029,category:ts.DiagnosticCategory.Message,key:"Version_0_6029",message:"Version {0}"},Insert_command_line_options_and_files_from_a_file:{code:6030,category:ts.DiagnosticCategory.Message,key:"Insert_command_line_options_and_files_from_a_file_6030",message:"Insert command line options and files from a file."},File_change_detected_Starting_incremental_compilation:{code:6032,category:ts.DiagnosticCategory.Message,key:"File_change_detected_Starting_incremental_compilation_6032",message:"File change detected. Starting incremental compilation..."},KIND:{code:6034,category:ts.DiagnosticCategory.Message,key:"KIND_6034",message:"KIND"},FILE:{code:6035,category:ts.DiagnosticCategory.Message,key:"FILE_6035",message:"FILE"},VERSION:{code:6036,category:ts.DiagnosticCategory.Message,key:"VERSION_6036",message:"VERSION"},LOCATION:{code:6037,category:ts.DiagnosticCategory.Message,key:"LOCATION_6037",message:"LOCATION"},DIRECTORY:{code:6038,category:ts.DiagnosticCategory.Message,key:"DIRECTORY_6038",message:"DIRECTORY"},Compilation_complete_Watching_for_file_changes:{code:6042,category:ts.DiagnosticCategory.Message,key:"Compilation_complete_Watching_for_file_changes_6042",message:"Compilation complete. Watching for file changes."},Generates_corresponding_map_file:{code:6043,category:ts.DiagnosticCategory.Message,key:"Generates_corresponding_map_file_6043",message:"Generates corresponding '.map' file."},Compiler_option_0_expects_an_argument:{code:6044,category:ts.DiagnosticCategory.Error,key:"Compiler_option_0_expects_an_argument_6044",message:"Compiler option '{0}' expects an argument."},Unterminated_quoted_string_in_response_file_0:{code:6045,category:ts.DiagnosticCategory.Error,key:"Unterminated_quoted_string_in_response_file_0_6045",message:"Unterminated quoted string in response file '{0}'."},Argument_for_module_option_must_be_commonjs_amd_system_umd_es2015_or_none:{code:6046,category:ts.DiagnosticCategory.Error,key:"Argument_for_module_option_must_be_commonjs_amd_system_umd_es2015_or_none_6046",message:"Argument for '--module' option must be 'commonjs', 'amd', 'system', 'umd', 'es2015', or 'none'."},Argument_for_target_option_must_be_ES3_ES5_or_ES2015:{code:6047,category:ts.DiagnosticCategory.Error,key:"Argument_for_target_option_must_be_ES3_ES5_or_ES2015_6047",message:"Argument for '--target' option must be 'ES3', 'ES5', or 'ES2015'."},Locale_must_be_of_the_form_language_or_language_territory_For_example_0_or_1:{code:6048,category:ts.DiagnosticCategory.Error,key:"Locale_must_be_of_the_form_language_or_language_territory_For_example_0_or_1_6048",message:"Locale must be of the form <language> or <language>-<territory>. For example '{0}' or '{1}'."},Unsupported_locale_0:{code:6049,category:ts.DiagnosticCategory.Error,key:"Unsupported_locale_0_6049",message:"Unsupported locale '{0}'."},Unable_to_open_file_0:{code:6050,category:ts.DiagnosticCategory.Error,key:"Unable_to_open_file_0_6050",message:"Unable to open file '{0}'."},Corrupted_locale_file_0:{code:6051,category:ts.DiagnosticCategory.Error,key:"Corrupted_locale_file_0_6051",message:"Corrupted locale file {0}."},
Raise_error_on_expressions_and_declarations_with_an_implied_any_type:{code:6052,category:ts.DiagnosticCategory.Message,key:"Raise_error_on_expressions_and_declarations_with_an_implied_any_type_6052",message:"Raise error on expressions and declarations with an implied 'any' type."},File_0_not_found:{code:6053,category:ts.DiagnosticCategory.Error,key:"File_0_not_found_6053",message:"File '{0}' not found."},File_0_has_unsupported_extension_The_only_supported_extensions_are_1:{code:6054,category:ts.DiagnosticCategory.Error,key:"File_0_has_unsupported_extension_The_only_supported_extensions_are_1_6054",message:"File '{0}' has unsupported extension. The only supported extensions are {1}."},Suppress_noImplicitAny_errors_for_indexing_objects_lacking_index_signatures:{code:6055,category:ts.DiagnosticCategory.Message,key:"Suppress_noImplicitAny_errors_for_indexing_objects_lacking_index_signatures_6055",message:"Suppress noImplicitAny errors for indexing objects lacking index signatures."},Do_not_emit_declarations_for_code_that_has_an_internal_annotation:{code:6056,category:ts.DiagnosticCategory.Message,key:"Do_not_emit_declarations_for_code_that_has_an_internal_annotation_6056",message:"Do not emit declarations for code that has an '@internal' annotation."},Specifies_the_root_directory_of_input_files_Use_to_control_the_output_directory_structure_with_outDir:{code:6058,category:ts.DiagnosticCategory.Message,key:"Specifies_the_root_directory_of_input_files_Use_to_control_the_output_directory_structure_with_outDi_6058",message:"Specifies the root directory of input files. Use to control the output directory structure with --outDir."},File_0_is_not_under_rootDir_1_rootDir_is_expected_to_contain_all_source_files:{code:6059,category:ts.DiagnosticCategory.Error,key:"File_0_is_not_under_rootDir_1_rootDir_is_expected_to_contain_all_source_files_6059",message:"File '{0}' is not under 'rootDir' '{1}'. 'rootDir' is expected to contain all source files."},Specifies_the_end_of_line_sequence_to_be_used_when_emitting_files_Colon_CRLF_dos_or_LF_unix:{code:6060,category:ts.DiagnosticCategory.Message,key:"Specifies_the_end_of_line_sequence_to_be_used_when_emitting_files_Colon_CRLF_dos_or_LF_unix_6060",message:"Specifies the end of line sequence to be used when emitting files: 'CRLF' (dos) or 'LF' (unix)."},NEWLINE:{code:6061,category:ts.DiagnosticCategory.Message,key:"NEWLINE_6061",message:"NEWLINE"},Argument_for_newLine_option_must_be_CRLF_or_LF:{code:6062,category:ts.DiagnosticCategory.Error,key:"Argument_for_newLine_option_must_be_CRLF_or_LF_6062",message:"Argument for '--newLine' option must be 'CRLF' or 'LF'."},Argument_for_moduleResolution_option_must_be_node_or_classic:{code:6063,category:ts.DiagnosticCategory.Error,key:"Argument_for_moduleResolution_option_must_be_node_or_classic_6063",message:"Argument for '--moduleResolution' option must be 'node' or 'classic'."},Enables_experimental_support_for_ES7_decorators:{code:6065,category:ts.DiagnosticCategory.Message,key:"Enables_experimental_support_for_ES7_decorators_6065",message:"Enables experimental support for ES7 decorators."},Enables_experimental_support_for_emitting_type_metadata_for_decorators:{code:6066,category:ts.DiagnosticCategory.Message,key:"Enables_experimental_support_for_emitting_type_metadata_for_decorators_6066",message:"Enables experimental support for emitting type metadata for decorators."},Enables_experimental_support_for_ES7_async_functions:{code:6068,category:ts.DiagnosticCategory.Message,key:"Enables_experimental_support_for_ES7_async_functions_6068",message:"Enables experimental support for ES7 async functions."},Specifies_module_resolution_strategy_Colon_node_Node_js_or_classic_TypeScript_pre_1_6:{code:6069,category:ts.DiagnosticCategory.Message,key:"Specifies_module_resolution_strategy_Colon_node_Node_js_or_classic_TypeScript_pre_1_6_6069",message:"Specifies module resolution strategy: 'node' (Node.js) or 'classic' (TypeScript pre-1.6)."},Initializes_a_TypeScript_project_and_creates_a_tsconfig_json_file:{code:6070,category:ts.DiagnosticCategory.Message,key:"Initializes_a_TypeScript_project_and_creates_a_tsconfig_json_file_6070",message:"Initializes a TypeScript project and creates a tsconfig.json file."},Successfully_created_a_tsconfig_json_file:{code:6071,category:ts.DiagnosticCategory.Message,key:"Successfully_created_a_tsconfig_json_file_6071",message:"Successfully created a tsconfig.json file."},Suppress_excess_property_checks_for_object_literals:{code:6072,category:ts.DiagnosticCategory.Message,key:"Suppress_excess_property_checks_for_object_literals_6072",message:"Suppress excess property checks for object literals."},Stylize_errors_and_messages_using_color_and_context_experimental:{code:6073,category:ts.DiagnosticCategory.Message,key:"Stylize_errors_and_messages_using_color_and_context_experimental_6073",message:"Stylize errors and messages using color and context. (experimental)"},Do_not_report_errors_on_unused_labels:{code:6074,category:ts.DiagnosticCategory.Message,key:"Do_not_report_errors_on_unused_labels_6074",message:"Do not report errors on unused labels."},Report_error_when_not_all_code_paths_in_function_return_a_value:{code:6075,category:ts.DiagnosticCategory.Message,key:"Report_error_when_not_all_code_paths_in_function_return_a_value_6075",message:"Report error when not all code paths in function return a value."},Report_errors_for_fallthrough_cases_in_switch_statement:{code:6076,category:ts.DiagnosticCategory.Message,key:"Report_errors_for_fallthrough_cases_in_switch_statement_6076",message:"Report errors for fallthrough cases in switch statement."},Do_not_report_errors_on_unreachable_code:{code:6077,category:ts.DiagnosticCategory.Message,key:"Do_not_report_errors_on_unreachable_code_6077",message:"Do not report errors on unreachable code."},Disallow_inconsistently_cased_references_to_the_same_file:{code:6078,category:ts.DiagnosticCategory.Message,key:"Disallow_inconsistently_cased_references_to_the_same_file_6078",message:"Disallow inconsistently-cased references to the same file."},Specify_JSX_code_generation_Colon_preserve_or_react:{code:6080,category:ts.DiagnosticCategory.Message,key:"Specify_JSX_code_generation_Colon_preserve_or_react_6080",message:"Specify JSX code generation: 'preserve' or 'react'"},Argument_for_jsx_must_be_preserve_or_react:{code:6081,category:ts.DiagnosticCategory.Message,key:"Argument_for_jsx_must_be_preserve_or_react_6081",message:"Argument for '--jsx' must be 'preserve' or 'react'."},Only_amd_and_system_modules_are_supported_alongside_0:{code:6082,category:ts.DiagnosticCategory.Error,key:"Only_amd_and_system_modules_are_supported_alongside_0_6082",message:"Only 'amd' and 'system' modules are supported alongside --{0}."},Allow_javascript_files_to_be_compiled:{code:6083,category:ts.DiagnosticCategory.Message,key:"Allow_javascript_files_to_be_compiled_6083",message:"Allow javascript files to be compiled."},Specifies_the_object_invoked_for_createElement_and_spread_when_targeting_react_JSX_emit:{code:6084,category:ts.DiagnosticCategory.Message,key:"Specifies_the_object_invoked_for_createElement_and_spread_when_targeting_react_JSX_emit_6084",message:"Specifies the object invoked for createElement and __spread when targeting 'react' JSX emit"},Do_not_emit_use_strict_directives_in_module_output:{code:6112,category:ts.DiagnosticCategory.Message,key:"Do_not_emit_use_strict_directives_in_module_output_6112",message:"Do not emit 'use strict' directives in module output."},Variable_0_implicitly_has_an_1_type:{code:7005,category:ts.DiagnosticCategory.Error,key:"Variable_0_implicitly_has_an_1_type_7005",message:"Variable '{0}' implicitly has an '{1}' type."},Parameter_0_implicitly_has_an_1_type:{code:7006,category:ts.DiagnosticCategory.Error,key:"Parameter_0_implicitly_has_an_1_type_7006",message:"Parameter '{0}' implicitly has an '{1}' type."},Member_0_implicitly_has_an_1_type:{code:7008,category:ts.DiagnosticCategory.Error,key:"Member_0_implicitly_has_an_1_type_7008",message:"Member '{0}' implicitly has an '{1}' type."},new_expression_whose_target_lacks_a_construct_signature_implicitly_has_an_any_type:{code:7009,category:ts.DiagnosticCategory.Error,key:"new_expression_whose_target_lacks_a_construct_signature_implicitly_has_an_any_type_7009",message:"'new' expression, whose target lacks a construct signature, implicitly has an 'any' type."},_0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type:{code:7010,category:ts.DiagnosticCategory.Error,key:"_0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type_7010",message:"'{0}', which lacks return-type annotation, implicitly has an '{1}' return type."},Function_expression_which_lacks_return_type_annotation_implicitly_has_an_0_return_type:{code:7011,category:ts.DiagnosticCategory.Error,key:"Function_expression_which_lacks_return_type_annotation_implicitly_has_an_0_return_type_7011",message:"Function expression, which lacks return-type annotation, implicitly has an '{0}' return type."},Construct_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type:{code:7013,category:ts.DiagnosticCategory.Error,key:"Construct_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type_7013",message:"Construct signature, which lacks return-type annotation, implicitly has an 'any' return type."},Element_implicitly_has_an_any_type_because_index_expression_is_not_of_type_number:{code:7015,category:ts.DiagnosticCategory.Error,key:"Element_implicitly_has_an_any_type_because_index_expression_is_not_of_type_number_7015",message:"Element implicitly has an 'any' type because index expression is not of type 'number'."},Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_type_annotation:{code:7016,category:ts.DiagnosticCategory.Error,key:"Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_type_annotation_7016",message:"Property '{0}' implicitly has type 'any', because its 'set' accessor lacks a type annotation."},Index_signature_of_object_type_implicitly_has_an_any_type:{code:7017,category:ts.DiagnosticCategory.Error,key:"Index_signature_of_object_type_implicitly_has_an_any_type_7017",message:"Index signature of object type implicitly has an 'any' type."},Object_literal_s_property_0_implicitly_has_an_1_type:{code:7018,category:ts.DiagnosticCategory.Error,key:"Object_literal_s_property_0_implicitly_has_an_1_type_7018",message:"Object literal's property '{0}' implicitly has an '{1}' type."},Rest_parameter_0_implicitly_has_an_any_type:{code:7019,category:ts.DiagnosticCategory.Error,key:"Rest_parameter_0_implicitly_has_an_any_type_7019",message:"Rest parameter '{0}' implicitly has an 'any[]' type."},Call_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type:{code:7020,category:ts.DiagnosticCategory.Error,key:"Call_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type_7020",message:"Call signature, which lacks return-type annotation, implicitly has an 'any' return type."},_0_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_and_is_referenced_directly_or_indirectly_in_its_own_initializer:{code:7022,category:ts.DiagnosticCategory.Error,key:"_0_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_and_is_referenced_directly_or__7022",message:"'{0}' implicitly has type 'any' because it does not have a type annotation and is referenced directly or indirectly in its own initializer."},_0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions:{code:7023,category:ts.DiagnosticCategory.Error,key:"_0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_reference_7023",message:"'{0}' implicitly has return type 'any' because it does not have a return type annotation and is referenced directly or indirectly in one of its return expressions."},Function_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions:{code:7024,category:ts.DiagnosticCategory.Error,key:"Function_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_ref_7024",message:"Function implicitly has return type 'any' because it does not have a return type annotation and is referenced directly or indirectly in one of its return expressions."},Generator_implicitly_has_type_0_because_it_does_not_yield_any_values_Consider_supplying_a_return_type:{code:7025,category:ts.DiagnosticCategory.Error,key:"Generator_implicitly_has_type_0_because_it_does_not_yield_any_values_Consider_supplying_a_return_typ_7025",message:"Generator implicitly has type '{0}' because it does not yield any values. Consider supplying a return type."},JSX_element_implicitly_has_type_any_because_no_interface_JSX_0_exists:{code:7026,category:ts.DiagnosticCategory.Error,key:"JSX_element_implicitly_has_type_any_because_no_interface_JSX_0_exists_7026",message:"JSX element implicitly has type 'any' because no interface 'JSX.{0}' exists"},Unreachable_code_detected:{code:7027,category:ts.DiagnosticCategory.Error,key:"Unreachable_code_detected_7027",message:"Unreachable code detected."},Unused_label:{code:7028,category:ts.DiagnosticCategory.Error,key:"Unused_label_7028",message:"Unused label."},Fallthrough_case_in_switch:{code:7029,category:ts.DiagnosticCategory.Error,key:"Fallthrough_case_in_switch_7029",message:"Fallthrough case in switch."},Not_all_code_paths_return_a_value:{code:7030,category:ts.DiagnosticCategory.Error,key:"Not_all_code_paths_return_a_value_7030",message:"Not all code paths return a value."},You_cannot_rename_this_element:{code:8e3,category:ts.DiagnosticCategory.Error,key:"You_cannot_rename_this_element_8000",message:"You cannot rename this element."},You_cannot_rename_elements_that_are_defined_in_the_standard_TypeScript_library:{code:8001,category:ts.DiagnosticCategory.Error,key:"You_cannot_rename_elements_that_are_defined_in_the_standard_TypeScript_library_8001",message:"You cannot rename elements that are defined in the standard TypeScript library."},import_can_only_be_used_in_a_ts_file:{code:8002,category:ts.DiagnosticCategory.Error,key:"import_can_only_be_used_in_a_ts_file_8002",message:"'import ... =' can only be used in a .ts file."},export_can_only_be_used_in_a_ts_file:{code:8003,category:ts.DiagnosticCategory.Error,key:"export_can_only_be_used_in_a_ts_file_8003",message:"'export=' can only be used in a .ts file."},type_parameter_declarations_can_only_be_used_in_a_ts_file:{code:8004,category:ts.DiagnosticCategory.Error,key:"type_parameter_declarations_can_only_be_used_in_a_ts_file_8004",message:"'type parameter declarations' can only be used in a .ts file."},implements_clauses_can_only_be_used_in_a_ts_file:{code:8005,category:ts.DiagnosticCategory.Error,key:"implements_clauses_can_only_be_used_in_a_ts_file_8005",message:"'implements clauses' can only be used in a .ts file."},interface_declarations_can_only_be_used_in_a_ts_file:{code:8006,category:ts.DiagnosticCategory.Error,key:"interface_declarations_can_only_be_used_in_a_ts_file_8006",message:"'interface declarations' can only be used in a .ts file."},module_declarations_can_only_be_used_in_a_ts_file:{code:8007,category:ts.DiagnosticCategory.Error,key:"module_declarations_can_only_be_used_in_a_ts_file_8007",message:"'module declarations' can only be used in a .ts file."},type_aliases_can_only_be_used_in_a_ts_file:{code:8008,category:ts.DiagnosticCategory.Error,key:"type_aliases_can_only_be_used_in_a_ts_file_8008",message:"'type aliases' can only be used in a .ts file."},_0_can_only_be_used_in_a_ts_file:{code:8009,category:ts.DiagnosticCategory.Error,key:"_0_can_only_be_used_in_a_ts_file_8009",message:"'{0}' can only be used in a .ts file."},types_can_only_be_used_in_a_ts_file:{code:8010,category:ts.DiagnosticCategory.Error,key:"types_can_only_be_used_in_a_ts_file_8010",message:"'types' can only be used in a .ts file."},type_arguments_can_only_be_used_in_a_ts_file:{code:8011,category:ts.DiagnosticCategory.Error,key:"type_arguments_can_only_be_used_in_a_ts_file_8011",message:"'type arguments' can only be used in a .ts file."},parameter_modifiers_can_only_be_used_in_a_ts_file:{code:8012,category:ts.DiagnosticCategory.Error,key:"parameter_modifiers_can_only_be_used_in_a_ts_file_8012",message:"'parameter modifiers' can only be used in a .ts file."},property_declarations_can_only_be_used_in_a_ts_file:{code:8014,category:ts.DiagnosticCategory.Error,key:"property_declarations_can_only_be_used_in_a_ts_file_8014",message:"'property declarations' can only be used in a .ts file."},enum_declarations_can_only_be_used_in_a_ts_file:{code:8015,category:ts.DiagnosticCategory.Error,key:"enum_declarations_can_only_be_used_in_a_ts_file_8015",message:"'enum declarations' can only be used in a .ts file."},type_assertion_expressions_can_only_be_used_in_a_ts_file:{code:8016,category:ts.DiagnosticCategory.Error,key:"type_assertion_expressions_can_only_be_used_in_a_ts_file_8016",message:"'type assertion expressions' can only be used in a .ts file."},Only_identifiers_Slashqualified_names_with_optional_type_arguments_are_currently_supported_in_a_class_extends_clauses:{code:9002,category:ts.DiagnosticCategory.Error,key:"Only_identifiers_Slashqualified_names_with_optional_type_arguments_are_currently_supported_in_a_clas_9002",message:"Only identifiers/qualified-names with optional type arguments are currently supported in a class 'extends' clauses."},class_expressions_are_not_currently_supported:{code:9003,category:ts.DiagnosticCategory.Error,key:"class_expressions_are_not_currently_supported_9003",message:"'class' expressions are not currently supported."},JSX_attributes_must_only_be_assigned_a_non_empty_expression:{code:17e3,category:ts.DiagnosticCategory.Error,key:"JSX_attributes_must_only_be_assigned_a_non_empty_expression_17000",message:"JSX attributes must only be assigned a non-empty 'expression'."},JSX_elements_cannot_have_multiple_attributes_with_the_same_name:{code:17001,category:ts.DiagnosticCategory.Error,key:"JSX_elements_cannot_have_multiple_attributes_with_the_same_name_17001",message:"JSX elements cannot have multiple attributes with the same name."},Expected_corresponding_JSX_closing_tag_for_0:{code:17002,category:ts.DiagnosticCategory.Error,key:"Expected_corresponding_JSX_closing_tag_for_0_17002",message:"Expected corresponding JSX closing tag for '{0}'."},JSX_attribute_expected:{code:17003,category:ts.DiagnosticCategory.Error,key:"JSX_attribute_expected_17003",message:"JSX attribute expected."},Cannot_use_JSX_unless_the_jsx_flag_is_provided:{code:17004,category:ts.DiagnosticCategory.Error,key:"Cannot_use_JSX_unless_the_jsx_flag_is_provided_17004",message:"Cannot use JSX unless the '--jsx' flag is provided."},A_constructor_cannot_contain_a_super_call_when_its_class_extends_null:{code:17005,category:ts.DiagnosticCategory.Error,key:"A_constructor_cannot_contain_a_super_call_when_its_class_extends_null_17005",message:"A constructor cannot contain a 'super' call when its class extends 'null'"},An_unary_expression_with_the_0_operator_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses:{code:17006,category:ts.DiagnosticCategory.Error,key:"An_unary_expression_with_the_0_operator_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_ex_17006",message:"An unary expression with the '{0}' operator is not allowed in the left-hand side of an exponentiation expression. Consider enclosing the expression in parentheses."},A_type_assertion_expression_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses:{code:17007,category:ts.DiagnosticCategory.Error,key:"A_type_assertion_expression_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Con_17007",message:"A type assertion expression is not allowed in the left-hand side of an exponentiation expression. Consider enclosing the expression in parentheses."},JSX_element_0_has_no_corresponding_closing_tag:{code:17008,category:ts.DiagnosticCategory.Error,key:"JSX_element_0_has_no_corresponding_closing_tag_17008",message:"JSX element '{0}' has no corresponding closing tag."},super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class:{code:17009,category:ts.DiagnosticCategory.Error,key:"super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class_17009",message:"'super' must be called before accessing 'this' in the constructor of a derived class."}}}(ts||(ts={}));var ts;!function(ts){function tokenIsIdentifierOrKeyword(token){return token>=69}function lookupInUnicodeMap(code,map){if(code<map[0])return!1;for(var mid,lo=0,hi=map.length;lo+1<hi;){if(mid=lo+(hi-lo)/2,mid-=mid%2,map[mid]<=code&&code<=map[mid+1])return!0;code<map[mid]?hi=mid:lo=mid+2}return!1}function isUnicodeIdentifierStart(code,languageVersion){return languageVersion>=1?lookupInUnicodeMap(code,unicodeES5IdentifierStart):lookupInUnicodeMap(code,unicodeES3IdentifierStart)}function isUnicodeIdentifierPart(code,languageVersion){return languageVersion>=1?lookupInUnicodeMap(code,unicodeES5IdentifierPart):lookupInUnicodeMap(code,unicodeES3IdentifierPart)}function makeReverseMap(source){var result=[];for(var name_4 in source)source.hasOwnProperty(name_4)&&(result[source[name_4]]=name_4);return result}function tokenToString(t){return tokenStrings[t]}function stringToToken(s){return textToToken[s]}function computeLineStarts(text){for(var result=new Array,pos=0,lineStart=0;pos<text.length;){var ch=text.charCodeAt(pos);switch(pos++,ch){case 13:10===text.charCodeAt(pos)&&pos++;case 10:result.push(lineStart),lineStart=pos;break;default:ch>127&&isLineBreak(ch)&&(result.push(lineStart),lineStart=pos)}}return result.push(lineStart),result}function getPositionOfLineAndCharacter(sourceFile,line,character){return computePositionOfLineAndCharacter(getLineStarts(sourceFile),line,character)}function computePositionOfLineAndCharacter(lineStarts,line,character){return ts.Debug.assert(line>=0&&line<lineStarts.length),lineStarts[line]+character}function getLineStarts(sourceFile){return sourceFile.lineMap||(sourceFile.lineMap=computeLineStarts(sourceFile.text))}function computeLineAndCharacterOfPosition(lineStarts,position){var lineNumber=ts.binarySearch(lineStarts,position);return lineNumber<0&&(lineNumber=~lineNumber-1,ts.Debug.assert(lineNumber!==-1,"position cannot precede the beginning of the file")),{line:lineNumber,character:position-lineStarts[lineNumber]}}function getLineAndCharacterOfPosition(sourceFile,position){return computeLineAndCharacterOfPosition(getLineStarts(sourceFile),position)}function isWhiteSpace(ch){return 32===ch||9===ch||11===ch||12===ch||160===ch||133===ch||5760===ch||ch>=8192&&ch<=8203||8239===ch||8287===ch||12288===ch||65279===ch}function isLineBreak(ch){return 10===ch||13===ch||8232===ch||8233===ch}function isDigit(ch){return ch>=48&&ch<=57}function isOctalDigit(ch){return ch>=48&&ch<=55}function couldStartTrivia(text,pos){var ch=text.charCodeAt(pos);switch(ch){case 13:case 10:case 9:case 11:case 12:case 32:case 47:case 60:case 61:case 62:return!0;case 35:return 0===pos;default:return ch>127}}function skipTrivia(text,pos,stopAfterLineBreak){if(!(pos>=0))return pos;for(;;){var ch=text.charCodeAt(pos);switch(ch){case 13:10===text.charCodeAt(pos+1)&&pos++;case 10:if(pos++,stopAfterLineBreak)return pos;continue;case 9:case 11:case 12:case 32:pos++;continue;case 47:if(47===text.charCodeAt(pos+1)){for(pos+=2;pos<text.length&&!isLineBreak(text.charCodeAt(pos));)pos++;continue}if(42===text.charCodeAt(pos+1)){for(pos+=2;pos<text.length;){if(42===text.charCodeAt(pos)&&47===text.charCodeAt(pos+1)){pos+=2;break}pos++}continue}break;case 60:case 61:case 62:if(isConflictMarkerTrivia(text,pos)){pos=scanConflictMarkerTrivia(text,pos);continue}break;case 35:if(0===pos&&isShebangTrivia(text,pos)){pos=scanShebangTrivia(text,pos);continue}break;default:if(ch>127&&(isWhiteSpace(ch)||isLineBreak(ch))){pos++;continue}}return pos}}function isConflictMarkerTrivia(text,pos){if(ts.Debug.assert(pos>=0),0===pos||isLineBreak(text.charCodeAt(pos-1))){var ch=text.charCodeAt(pos);if(pos+mergeConflictMarkerLength<text.length){for(var i=0,n=mergeConflictMarkerLength;i<n;i++)if(text.charCodeAt(pos+i)!==ch)return!1;return 61===ch||32===text.charCodeAt(pos+mergeConflictMarkerLength)}}return!1}function scanConflictMarkerTrivia(text,pos,error){error&&error(ts.Diagnostics.Merge_conflict_marker_encountered,mergeConflictMarkerLength);var ch=text.charCodeAt(pos),len=text.length;if(60===ch||62===ch)for(;pos<len&&!isLineBreak(text.charCodeAt(pos));)pos++;else for(ts.Debug.assert(61===ch);pos<len;){var ch_1=text.charCodeAt(pos);if(62===ch_1&&isConflictMarkerTrivia(text,pos))break;pos++}return pos}function isShebangTrivia(text,pos){return ts.Debug.assert(0===pos),shebangTriviaRegex.test(text)}function scanShebangTrivia(text,pos){var shebang=shebangTriviaRegex.exec(text)[0];return pos+=shebang.length}function getCommentRanges(text,pos,trailing){for(var result,collecting=trailing||0===pos;pos<text.length;){var ch=text.charCodeAt(pos);switch(ch){case 13:10===text.charCodeAt(pos+1)&&pos++;case 10:if(pos++,trailing)return result;collecting=!0,result&&result.length&&(ts.lastOrUndefined(result).hasTrailingNewLine=!0);continue;case 9:case 11:case 12:case 32:pos++;continue;case 47:var nextChar=text.charCodeAt(pos+1),hasTrailingNewLine=!1;if(47===nextChar||42===nextChar){var kind=47===nextChar?2:3,startPos=pos;if(pos+=2,47===nextChar)for(;pos<text.length;){if(isLineBreak(text.charCodeAt(pos))){hasTrailingNewLine=!0;break}pos++}else for(;pos<text.length;){if(42===text.charCodeAt(pos)&&47===text.charCodeAt(pos+1)){pos+=2;break}pos++}collecting&&(result||(result=[]),result.push({pos:startPos,end:pos,hasTrailingNewLine:hasTrailingNewLine,kind:kind}));continue}break;default:if(ch>127&&(isWhiteSpace(ch)||isLineBreak(ch))){result&&result.length&&isLineBreak(ch)&&(ts.lastOrUndefined(result).hasTrailingNewLine=!0),pos++;continue}}return result}return result}function getLeadingCommentRanges(text,pos){return getCommentRanges(text,pos,!1)}function getTrailingCommentRanges(text,pos){return getCommentRanges(text,pos,!0)}function getShebang(text){return shebangTriviaRegex.test(text)?shebangTriviaRegex.exec(text)[0]:void 0}function isIdentifierStart(ch,languageVersion){return ch>=65&&ch<=90||ch>=97&&ch<=122||36===ch||95===ch||ch>127&&isUnicodeIdentifierStart(ch,languageVersion)}function isIdentifierPart(ch,languageVersion){return ch>=65&&ch<=90||ch>=97&&ch<=122||ch>=48&&ch<=57||36===ch||95===ch||ch>127&&isUnicodeIdentifierPart(ch,languageVersion)}function isIdentifier(name,languageVersion){if(!isIdentifierStart(name.charCodeAt(0),languageVersion))return!1;for(var i=1,n=name.length;i<n;i++)if(!isIdentifierPart(name.charCodeAt(i),languageVersion))return!1;return!0}function createScanner(languageVersion,skipTrivia,languageVariant,text,onError,start,length){function error(message,length){onError&&onError(message,length||0)}function scanNumber(){for(var start=pos;isDigit(text.charCodeAt(pos));)pos++;if(46===text.charCodeAt(pos))for(pos++;isDigit(text.charCodeAt(pos));)pos++;var end=pos;if(69===text.charCodeAt(pos)||101===text.charCodeAt(pos))if(pos++,43!==text.charCodeAt(pos)&&45!==text.charCodeAt(pos)||pos++,isDigit(text.charCodeAt(pos))){for(pos++;isDigit(text.charCodeAt(pos));)pos++;end=pos}else error(ts.Diagnostics.Digit_expected);return""+ +text.substring(start,end)}function scanOctalDigits(){for(var start=pos;isOctalDigit(text.charCodeAt(pos));)pos++;return+text.substring(start,pos)}function scanExactNumberOfHexDigits(count){return scanHexDigits(count,!1)}function scanMinimumNumberOfHexDigits(count){return scanHexDigits(count,!0)}function scanHexDigits(minCount,scanAsManyAsPossible){for(var digits=0,value=0;digits<minCount||scanAsManyAsPossible;){var ch=text.charCodeAt(pos);if(ch>=48&&ch<=57)value=16*value+ch-48;else if(ch>=65&&ch<=70)value=16*value+ch-65+10;else{if(!(ch>=97&&ch<=102))break;value=16*value+ch-97+10}pos++,digits++}return digits<minCount&&(value=-1),value}function scanString(){var quote=text.charCodeAt(pos);pos++;for(var result="",start=pos;;){if(pos>=end){result+=text.substring(start,pos),tokenIsUnterminated=!0,error(ts.Diagnostics.Unterminated_string_literal);break}var ch=text.charCodeAt(pos);if(ch===quote){result+=text.substring(start,pos),pos++;break}if(92!==ch){if(isLineBreak(ch)){result+=text.substring(start,pos),tokenIsUnterminated=!0,error(ts.Diagnostics.Unterminated_string_literal);break}pos++}else result+=text.substring(start,pos),result+=scanEscapeSequence(),start=pos}return result}function scanTemplateAndSetTokenValue(){var startedWithBacktick=96===text.charCodeAt(pos);pos++;for(var resultingToken,start=pos,contents="";;){if(pos>=end){contents+=text.substring(start,pos),tokenIsUnterminated=!0,error(ts.Diagnostics.Unterminated_template_literal),resultingToken=startedWithBacktick?11:14;break}var currChar=text.charCodeAt(pos);if(96===currChar){contents+=text.substring(start,pos),pos++,resultingToken=startedWithBacktick?11:14;break}if(36===currChar&&pos+1<end&&123===text.charCodeAt(pos+1)){contents+=text.substring(start,pos),pos+=2,resultingToken=startedWithBacktick?12:13;break}92!==currChar?13!==currChar?pos++:(contents+=text.substring(start,pos),pos++,pos<end&&10===text.charCodeAt(pos)&&pos++,contents+="\n",start=pos):(contents+=text.substring(start,pos),contents+=scanEscapeSequence(),start=pos)}return ts.Debug.assert(void 0!==resultingToken),tokenValue=contents,resultingToken}function scanEscapeSequence(){if(pos++,pos>=end)return error(ts.Diagnostics.Unexpected_end_of_text),"";var ch=text.charCodeAt(pos);switch(pos++,ch){case 48:return"\0";case 98:return"\b";case 116:return"\t";case 110:return"\n";case 118:return"\v";case 102:return"\f";case 114:return"\r";case 39:return"'";case 34:return'"';case 117:return pos<end&&123===text.charCodeAt(pos)?(hasExtendedUnicodeEscape=!0,pos++,scanExtendedUnicodeEscape()):scanHexadecimalEscape(4);case 120:return scanHexadecimalEscape(2);case 13:pos<end&&10===text.charCodeAt(pos)&&pos++;case 10:case 8232:case 8233:return"";default:return String.fromCharCode(ch)}}function scanHexadecimalEscape(numDigits){var escapedValue=scanExactNumberOfHexDigits(numDigits);return escapedValue>=0?String.fromCharCode(escapedValue):(error(ts.Diagnostics.Hexadecimal_digit_expected),"")}function scanExtendedUnicodeEscape(){var escapedValue=scanMinimumNumberOfHexDigits(1),isInvalidExtendedEscape=!1;return escapedValue<0?(error(ts.Diagnostics.Hexadecimal_digit_expected),isInvalidExtendedEscape=!0):escapedValue>1114111&&(error(ts.Diagnostics.An_extended_Unicode_escape_value_must_be_between_0x0_and_0x10FFFF_inclusive),isInvalidExtendedEscape=!0),pos>=end?(error(ts.Diagnostics.Unexpected_end_of_text),isInvalidExtendedEscape=!0):125===text.charCodeAt(pos)?pos++:(error(ts.Diagnostics.Unterminated_Unicode_escape_sequence),isInvalidExtendedEscape=!0),isInvalidExtendedEscape?"":utf16EncodeAsString(escapedValue)}function utf16EncodeAsString(codePoint){if(ts.Debug.assert(0<=codePoint&&codePoint<=1114111),codePoint<=65535)return String.fromCharCode(codePoint);var codeUnit1=Math.floor((codePoint-65536)/1024)+55296,codeUnit2=(codePoint-65536)%1024+56320;return String.fromCharCode(codeUnit1,codeUnit2)}function peekUnicodeEscape(){if(pos+5<end&&117===text.charCodeAt(pos+1)){var start_1=pos;pos+=2;var value=scanExactNumberOfHexDigits(4);return pos=start_1,value}return-1}function scanIdentifierParts(){for(var result="",start=pos;pos<end;){var ch=text.charCodeAt(pos);if(isIdentifierPart(ch,languageVersion))pos++;else{if(92!==ch)break;if(ch=peekUnicodeEscape(),!(ch>=0&&isIdentifierPart(ch,languageVersion)))break;result+=text.substring(start,pos),result+=String.fromCharCode(ch),pos+=6,start=pos}}return result+=text.substring(start,pos)}function getIdentifierToken(){
var len=tokenValue.length;if(len>=2&&len<=11){var ch=tokenValue.charCodeAt(0);if(ch>=97&&ch<=122&&hasOwnProperty.call(textToToken,tokenValue))return token=textToToken[tokenValue]}return token=69}function scanBinaryOrOctalDigits(base){ts.Debug.assert(2!==base||8!==base,"Expected either base 2 or base 8");for(var value=0,numberOfDigits=0;;){var ch=text.charCodeAt(pos),valueOfCh=ch-48;if(!isDigit(ch)||valueOfCh>=base)break;value=value*base+valueOfCh,pos++,numberOfDigits++}return 0===numberOfDigits?-1:value}function scan(){for(startPos=pos,hasExtendedUnicodeEscape=!1,precedingLineBreak=!1,tokenIsUnterminated=!1;;){if(tokenPos=pos,pos>=end)return token=1;var ch=text.charCodeAt(pos);if(35===ch&&0===pos&&isShebangTrivia(text,pos)){if(pos=scanShebangTrivia(text,pos),skipTrivia)continue;return token=6}switch(ch){case 10:case 13:if(precedingLineBreak=!0,skipTrivia){pos++;continue}return 13===ch&&pos+1<end&&10===text.charCodeAt(pos+1)?pos+=2:pos++,token=4;case 9:case 11:case 12:case 32:if(skipTrivia){pos++;continue}for(;pos<end&&isWhiteSpace(text.charCodeAt(pos));)pos++;return token=5;case 33:return 61===text.charCodeAt(pos+1)?61===text.charCodeAt(pos+2)?(pos+=3,token=33):(pos+=2,token=31):(pos++,token=49);case 34:case 39:return tokenValue=scanString(),token=9;case 96:return token=scanTemplateAndSetTokenValue();case 37:return 61===text.charCodeAt(pos+1)?(pos+=2,token=62):(pos++,token=40);case 38:return 38===text.charCodeAt(pos+1)?(pos+=2,token=51):61===text.charCodeAt(pos+1)?(pos+=2,token=66):(pos++,token=46);case 40:return pos++,token=17;case 41:return pos++,token=18;case 42:return 61===text.charCodeAt(pos+1)?(pos+=2,token=59):42===text.charCodeAt(pos+1)?61===text.charCodeAt(pos+2)?(pos+=3,token=60):(pos+=2,token=38):(pos++,token=37);case 43:return 43===text.charCodeAt(pos+1)?(pos+=2,token=41):61===text.charCodeAt(pos+1)?(pos+=2,token=57):(pos++,token=35);case 44:return pos++,token=24;case 45:return 45===text.charCodeAt(pos+1)?(pos+=2,token=42):61===text.charCodeAt(pos+1)?(pos+=2,token=58):(pos++,token=36);case 46:return isDigit(text.charCodeAt(pos+1))?(tokenValue=scanNumber(),token=8):46===text.charCodeAt(pos+1)&&46===text.charCodeAt(pos+2)?(pos+=3,token=22):(pos++,token=21);case 47:if(47===text.charCodeAt(pos+1)){for(pos+=2;pos<end&&!isLineBreak(text.charCodeAt(pos));)pos++;if(skipTrivia)continue;return token=2}if(42===text.charCodeAt(pos+1)){pos+=2;for(var commentClosed=!1;pos<end;){var ch_2=text.charCodeAt(pos);if(42===ch_2&&47===text.charCodeAt(pos+1)){pos+=2,commentClosed=!0;break}isLineBreak(ch_2)&&(precedingLineBreak=!0),pos++}if(commentClosed||error(ts.Diagnostics.Asterisk_Slash_expected),skipTrivia)continue;return tokenIsUnterminated=!commentClosed,token=3}return 61===text.charCodeAt(pos+1)?(pos+=2,token=61):(pos++,token=39);case 48:if(pos+2<end&&(88===text.charCodeAt(pos+1)||120===text.charCodeAt(pos+1))){pos+=2;var value=scanMinimumNumberOfHexDigits(1);return value<0&&(error(ts.Diagnostics.Hexadecimal_digit_expected),value=0),tokenValue=""+value,token=8}if(pos+2<end&&(66===text.charCodeAt(pos+1)||98===text.charCodeAt(pos+1))){pos+=2;var value=scanBinaryOrOctalDigits(2);return value<0&&(error(ts.Diagnostics.Binary_digit_expected),value=0),tokenValue=""+value,token=8}if(pos+2<end&&(79===text.charCodeAt(pos+1)||111===text.charCodeAt(pos+1))){pos+=2;var value=scanBinaryOrOctalDigits(8);return value<0&&(error(ts.Diagnostics.Octal_digit_expected),value=0),tokenValue=""+value,token=8}if(pos+1<end&&isOctalDigit(text.charCodeAt(pos+1)))return tokenValue=""+scanOctalDigits(),token=8;case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return tokenValue=scanNumber(),token=8;case 58:return pos++,token=54;case 59:return pos++,token=23;case 60:if(isConflictMarkerTrivia(text,pos)){if(pos=scanConflictMarkerTrivia(text,pos,error),skipTrivia)continue;return token=7}return 60===text.charCodeAt(pos+1)?61===text.charCodeAt(pos+2)?(pos+=3,token=63):(pos+=2,token=43):61===text.charCodeAt(pos+1)?(pos+=2,token=28):1===languageVariant&&47===text.charCodeAt(pos+1)&&42!==text.charCodeAt(pos+2)?(pos+=2,token=26):(pos++,token=25);case 61:if(isConflictMarkerTrivia(text,pos)){if(pos=scanConflictMarkerTrivia(text,pos,error),skipTrivia)continue;return token=7}return 61===text.charCodeAt(pos+1)?61===text.charCodeAt(pos+2)?(pos+=3,token=32):(pos+=2,token=30):62===text.charCodeAt(pos+1)?(pos+=2,token=34):(pos++,token=56);case 62:if(isConflictMarkerTrivia(text,pos)){if(pos=scanConflictMarkerTrivia(text,pos,error),skipTrivia)continue;return token=7}return pos++,token=27;case 63:return pos++,token=53;case 91:return pos++,token=19;case 93:return pos++,token=20;case 94:return 61===text.charCodeAt(pos+1)?(pos+=2,token=68):(pos++,token=48);case 123:return pos++,token=15;case 124:return 124===text.charCodeAt(pos+1)?(pos+=2,token=52):61===text.charCodeAt(pos+1)?(pos+=2,token=67):(pos++,token=47);case 125:return pos++,token=16;case 126:return pos++,token=50;case 64:return pos++,token=55;case 92:var cookedChar=peekUnicodeEscape();return cookedChar>=0&&isIdentifierStart(cookedChar,languageVersion)?(pos+=6,tokenValue=String.fromCharCode(cookedChar)+scanIdentifierParts(),token=getIdentifierToken()):(error(ts.Diagnostics.Invalid_character),pos++,token=0);default:if(isIdentifierStart(ch,languageVersion)){for(pos++;pos<end&&isIdentifierPart(ch=text.charCodeAt(pos),languageVersion);)pos++;return tokenValue=text.substring(tokenPos,pos),92===ch&&(tokenValue+=scanIdentifierParts()),token=getIdentifierToken()}if(isWhiteSpace(ch)){pos++;continue}if(isLineBreak(ch)){precedingLineBreak=!0,pos++;continue}return error(ts.Diagnostics.Invalid_character),pos++,token=0}}}function reScanGreaterToken(){if(27===token){if(62===text.charCodeAt(pos))return 62===text.charCodeAt(pos+1)?61===text.charCodeAt(pos+2)?(pos+=3,token=65):(pos+=2,token=45):61===text.charCodeAt(pos+1)?(pos+=2,token=64):(pos++,token=44);if(61===text.charCodeAt(pos))return pos++,token=29}return token}function reScanSlashToken(){if(39===token||61===token){for(var p=tokenPos+1,inEscape=!1,inCharacterClass=!1;;){if(p>=end){tokenIsUnterminated=!0,error(ts.Diagnostics.Unterminated_regular_expression_literal);break}var ch=text.charCodeAt(p);if(isLineBreak(ch)){tokenIsUnterminated=!0,error(ts.Diagnostics.Unterminated_regular_expression_literal);break}if(inEscape)inEscape=!1;else{if(47===ch&&!inCharacterClass){p++;break}91===ch?inCharacterClass=!0:92===ch?inEscape=!0:93===ch&&(inCharacterClass=!1)}p++}for(;p<end&&isIdentifierPart(text.charCodeAt(p),languageVersion);)p++;pos=p,tokenValue=text.substring(tokenPos,pos),token=10}return token}function reScanTemplateToken(){return ts.Debug.assert(16===token,"'reScanTemplateToken' should only be called on a '}'"),pos=tokenPos,token=scanTemplateAndSetTokenValue()}function reScanJsxToken(){return pos=tokenPos=startPos,token=scanJsxToken()}function scanJsxToken(){if(startPos=tokenPos=pos,pos>=end)return token=1;var char=text.charCodeAt(pos);if(60===char)return 47===text.charCodeAt(pos+1)?(pos+=2,token=26):(pos++,token=25);if(123===char)return pos++,token=15;for(;pos<end&&(pos++,char=text.charCodeAt(pos),123!==char&&60!==char););return token=239}function scanJsxIdentifier(){if(tokenIsIdentifierOrKeyword(token)){for(var firstCharPosition=pos;pos<end;){var ch=text.charCodeAt(pos);if(45!==ch&&(firstCharPosition===pos?!isIdentifierStart(ch,languageVersion):!isIdentifierPart(ch,languageVersion)))break;pos++}tokenValue+=text.substr(firstCharPosition,pos-firstCharPosition)}return token}function scanJSDocToken(){if(pos>=end)return token=1;startPos=pos;for(var ch=text.charCodeAt(pos);pos<end&&(ch=text.charCodeAt(pos),isWhiteSpace(ch));)pos++;switch(tokenPos=pos,ch){case 64:return pos+=1,token=55;case 10:case 13:return pos+=1,token=4;case 42:return pos+=1,token=37;case 123:return pos+=1,token=15;case 125:return pos+=1,token=16;case 91:return pos+=1,token=19;case 93:return pos+=1,token=20;case 61:return pos+=1,token=56;case 44:return pos+=1,token=24}if(isIdentifierStart(ch,2)){for(pos++;isIdentifierPart(text.charCodeAt(pos),2)&&pos<end;)pos++;return token=69}return pos+=1,token=0}function speculationHelper(callback,isLookahead){var savePos=pos,saveStartPos=startPos,saveTokenPos=tokenPos,saveToken=token,saveTokenValue=tokenValue,savePrecedingLineBreak=precedingLineBreak,result=callback();return result&&!isLookahead||(pos=savePos,startPos=saveStartPos,tokenPos=saveTokenPos,token=saveToken,tokenValue=saveTokenValue,precedingLineBreak=savePrecedingLineBreak),result}function scanRange(start,length,callback){var saveEnd=end,savePos=pos,saveStartPos=startPos,saveTokenPos=tokenPos,saveToken=token,savePrecedingLineBreak=precedingLineBreak,saveTokenValue=tokenValue,saveHasExtendedUnicodeEscape=hasExtendedUnicodeEscape,saveTokenIsUnterminated=tokenIsUnterminated;setText(text,start,length);var result=callback();return end=saveEnd,pos=savePos,startPos=saveStartPos,tokenPos=saveTokenPos,token=saveToken,precedingLineBreak=savePrecedingLineBreak,tokenValue=saveTokenValue,hasExtendedUnicodeEscape=saveHasExtendedUnicodeEscape,tokenIsUnterminated=saveTokenIsUnterminated,result}function lookAhead(callback){return speculationHelper(callback,!0)}function tryScan(callback){return speculationHelper(callback,!1)}function setText(newText,start,length){text=newText||"",end=void 0===length?text.length:start+length,setTextPos(start||0)}function setOnError(errorCallback){onError=errorCallback}function setScriptTarget(scriptTarget){languageVersion=scriptTarget}function setLanguageVariant(variant){languageVariant=variant}function setTextPos(textPos){ts.Debug.assert(textPos>=0),pos=textPos,startPos=textPos,tokenPos=textPos,token=0,precedingLineBreak=!1,tokenValue=void 0,hasExtendedUnicodeEscape=!1,tokenIsUnterminated=!1}void 0===languageVariant&&(languageVariant=0);var pos,end,startPos,tokenPos,token,tokenValue,precedingLineBreak,hasExtendedUnicodeEscape,tokenIsUnterminated;return setText(text,start,length),{getStartPos:function(){return startPos},getTextPos:function(){return pos},getToken:function(){return token},getTokenPos:function(){return tokenPos},getTokenText:function(){return text.substring(tokenPos,pos)},getTokenValue:function(){return tokenValue},hasExtendedUnicodeEscape:function(){return hasExtendedUnicodeEscape},hasPrecedingLineBreak:function(){return precedingLineBreak},isIdentifier:function(){return 69===token||token>105},isReservedWord:function(){return token>=70&&token<=105},isUnterminated:function(){return tokenIsUnterminated},reScanGreaterToken:reScanGreaterToken,reScanSlashToken:reScanSlashToken,reScanTemplateToken:reScanTemplateToken,scanJsxIdentifier:scanJsxIdentifier,reScanJsxToken:reScanJsxToken,scanJsxToken:scanJsxToken,scanJSDocToken:scanJSDocToken,scan:scan,setText:setText,setScriptTarget:setScriptTarget,setLanguageVariant:setLanguageVariant,setOnError:setOnError,setTextPos:setTextPos,tryScan:tryScan,lookAhead:lookAhead,scanRange:scanRange}}ts.tokenIsIdentifierOrKeyword=tokenIsIdentifierOrKeyword;var textToToken={abstract:115,any:117,as:116,boolean:120,break:70,case:71,catch:72,class:73,continue:75,const:74,constructor:121,debugger:76,declare:122,default:77,delete:78,do:79,else:80,enum:81,export:82,extends:83,false:84,finally:85,for:86,from:133,function:87,get:123,if:88,implements:106,import:89,in:90,instanceof:91,interface:107,is:124,let:108,module:125,namespace:126,new:92,null:93,number:128,package:109,private:110,protected:111,public:112,require:127,global:134,return:94,set:129,static:113,string:130,super:95,switch:96,symbol:131,this:97,throw:98,true:99,try:100,type:132,typeof:101,var:102,void:103,while:104,with:105,yield:114,async:118,await:119,of:135,"{":15,"}":16,"(":17,")":18,"[":19,"]":20,".":21,"...":22,";":23,",":24,"<":25,">":27,"<=":28,">=":29,"==":30,"!=":31,"===":32,"!==":33,"=>":34,"+":35,"-":36,"**":38,"*":37,"/":39,"%":40,"++":41,"--":42,"<<":43,"</":26,">>":44,">>>":45,"&":46,"|":47,"^":48,"!":49,"~":50,"&&":51,"||":52,"?":53,":":54,"=":56,"+=":57,"-=":58,"*=":59,"**=":60,"/=":61,"%=":62,"<<=":63,">>=":64,">>>=":65,"&=":66,"|=":67,"^=":68,"@":55},unicodeES3IdentifierStart=[170,170,181,181,186,186,192,214,216,246,248,543,546,563,592,685,688,696,699,705,720,721,736,740,750,750,890,890,902,902,904,906,908,908,910,929,931,974,976,983,986,1011,1024,1153,1164,1220,1223,1224,1227,1228,1232,1269,1272,1273,1329,1366,1369,1369,1377,1415,1488,1514,1520,1522,1569,1594,1600,1610,1649,1747,1749,1749,1765,1766,1786,1788,1808,1808,1810,1836,1920,1957,2309,2361,2365,2365,2384,2384,2392,2401,2437,2444,2447,2448,2451,2472,2474,2480,2482,2482,2486,2489,2524,2525,2527,2529,2544,2545,2565,2570,2575,2576,2579,2600,2602,2608,2610,2611,2613,2614,2616,2617,2649,2652,2654,2654,2674,2676,2693,2699,2701,2701,2703,2705,2707,2728,2730,2736,2738,2739,2741,2745,2749,2749,2768,2768,2784,2784,2821,2828,2831,2832,2835,2856,2858,2864,2866,2867,2870,2873,2877,2877,2908,2909,2911,2913,2949,2954,2958,2960,2962,2965,2969,2970,2972,2972,2974,2975,2979,2980,2984,2986,2990,2997,2999,3001,3077,3084,3086,3088,3090,3112,3114,3123,3125,3129,3168,3169,3205,3212,3214,3216,3218,3240,3242,3251,3253,3257,3294,3294,3296,3297,3333,3340,3342,3344,3346,3368,3370,3385,3424,3425,3461,3478,3482,3505,3507,3515,3517,3517,3520,3526,3585,3632,3634,3635,3648,3654,3713,3714,3716,3716,3719,3720,3722,3722,3725,3725,3732,3735,3737,3743,3745,3747,3749,3749,3751,3751,3754,3755,3757,3760,3762,3763,3773,3773,3776,3780,3782,3782,3804,3805,3840,3840,3904,3911,3913,3946,3976,3979,4096,4129,4131,4135,4137,4138,4176,4181,4256,4293,4304,4342,4352,4441,4447,4514,4520,4601,4608,4614,4616,4678,4680,4680,4682,4685,4688,4694,4696,4696,4698,4701,4704,4742,4744,4744,4746,4749,4752,4782,4784,4784,4786,4789,4792,4798,4800,4800,4802,4805,4808,4814,4816,4822,4824,4846,4848,4878,4880,4880,4882,4885,4888,4894,4896,4934,4936,4954,5024,5108,5121,5740,5743,5750,5761,5786,5792,5866,6016,6067,6176,6263,6272,6312,7680,7835,7840,7929,7936,7957,7960,7965,7968,8005,8008,8013,8016,8023,8025,8025,8027,8027,8029,8029,8031,8061,8064,8116,8118,8124,8126,8126,8130,8132,8134,8140,8144,8147,8150,8155,8160,8172,8178,8180,8182,8188,8319,8319,8450,8450,8455,8455,8458,8467,8469,8469,8473,8477,8484,8484,8486,8486,8488,8488,8490,8493,8495,8497,8499,8505,8544,8579,12293,12295,12321,12329,12337,12341,12344,12346,12353,12436,12445,12446,12449,12538,12540,12542,12549,12588,12593,12686,12704,12727,13312,19893,19968,40869,40960,42124,44032,55203,63744,64045,64256,64262,64275,64279,64285,64285,64287,64296,64298,64310,64312,64316,64318,64318,64320,64321,64323,64324,64326,64433,64467,64829,64848,64911,64914,64967,65008,65019,65136,65138,65140,65140,65142,65276,65313,65338,65345,65370,65382,65470,65474,65479,65482,65487,65490,65495,65498,65500],unicodeES3IdentifierPart=[170,170,181,181,186,186,192,214,216,246,248,543,546,563,592,685,688,696,699,705,720,721,736,740,750,750,768,846,864,866,890,890,902,902,904,906,908,908,910,929,931,974,976,983,986,1011,1024,1153,1155,1158,1164,1220,1223,1224,1227,1228,1232,1269,1272,1273,1329,1366,1369,1369,1377,1415,1425,1441,1443,1465,1467,1469,1471,1471,1473,1474,1476,1476,1488,1514,1520,1522,1569,1594,1600,1621,1632,1641,1648,1747,1749,1756,1759,1768,1770,1773,1776,1788,1808,1836,1840,1866,1920,1968,2305,2307,2309,2361,2364,2381,2384,2388,2392,2403,2406,2415,2433,2435,2437,2444,2447,2448,2451,2472,2474,2480,2482,2482,2486,2489,2492,2492,2494,2500,2503,2504,2507,2509,2519,2519,2524,2525,2527,2531,2534,2545,2562,2562,2565,2570,2575,2576,2579,2600,2602,2608,2610,2611,2613,2614,2616,2617,2620,2620,2622,2626,2631,2632,2635,2637,2649,2652,2654,2654,2662,2676,2689,2691,2693,2699,2701,2701,2703,2705,2707,2728,2730,2736,2738,2739,2741,2745,2748,2757,2759,2761,2763,2765,2768,2768,2784,2784,2790,2799,2817,2819,2821,2828,2831,2832,2835,2856,2858,2864,2866,2867,2870,2873,2876,2883,2887,2888,2891,2893,2902,2903,2908,2909,2911,2913,2918,2927,2946,2947,2949,2954,2958,2960,2962,2965,2969,2970,2972,2972,2974,2975,2979,2980,2984,2986,2990,2997,2999,3001,3006,3010,3014,3016,3018,3021,3031,3031,3047,3055,3073,3075,3077,3084,3086,3088,3090,3112,3114,3123,3125,3129,3134,3140,3142,3144,3146,3149,3157,3158,3168,3169,3174,3183,3202,3203,3205,3212,3214,3216,3218,3240,3242,3251,3253,3257,3262,3268,3270,3272,3274,3277,3285,3286,3294,3294,3296,3297,3302,3311,3330,3331,3333,3340,3342,3344,3346,3368,3370,3385,3390,3395,3398,3400,3402,3405,3415,3415,3424,3425,3430,3439,3458,3459,3461,3478,3482,3505,3507,3515,3517,3517,3520,3526,3530,3530,3535,3540,3542,3542,3544,3551,3570,3571,3585,3642,3648,3662,3664,3673,3713,3714,3716,3716,3719,3720,3722,3722,3725,3725,3732,3735,3737,3743,3745,3747,3749,3749,3751,3751,3754,3755,3757,3769,3771,3773,3776,3780,3782,3782,3784,3789,3792,3801,3804,3805,3840,3840,3864,3865,3872,3881,3893,3893,3895,3895,3897,3897,3902,3911,3913,3946,3953,3972,3974,3979,3984,3991,3993,4028,4038,4038,4096,4129,4131,4135,4137,4138,4140,4146,4150,4153,4160,4169,4176,4185,4256,4293,4304,4342,4352,4441,4447,4514,4520,4601,4608,4614,4616,4678,4680,4680,4682,4685,4688,4694,4696,4696,4698,4701,4704,4742,4744,4744,4746,4749,4752,4782,4784,4784,4786,4789,4792,4798,4800,4800,4802,4805,4808,4814,4816,4822,4824,4846,4848,4878,4880,4880,4882,4885,4888,4894,4896,4934,4936,4954,4969,4977,5024,5108,5121,5740,5743,5750,5761,5786,5792,5866,6016,6099,6112,6121,6160,6169,6176,6263,6272,6313,7680,7835,7840,7929,7936,7957,7960,7965,7968,8005,8008,8013,8016,8023,8025,8025,8027,8027,8029,8029,8031,8061,8064,8116,8118,8124,8126,8126,8130,8132,8134,8140,8144,8147,8150,8155,8160,8172,8178,8180,8182,8188,8255,8256,8319,8319,8400,8412,8417,8417,8450,8450,8455,8455,8458,8467,8469,8469,8473,8477,8484,8484,8486,8486,8488,8488,8490,8493,8495,8497,8499,8505,8544,8579,12293,12295,12321,12335,12337,12341,12344,12346,12353,12436,12441,12442,12445,12446,12449,12542,12549,12588,12593,12686,12704,12727,13312,19893,19968,40869,40960,42124,44032,55203,63744,64045,64256,64262,64275,64279,64285,64296,64298,64310,64312,64316,64318,64318,64320,64321,64323,64324,64326,64433,64467,64829,64848,64911,64914,64967,65008,65019,65056,65059,65075,65076,65101,65103,65136,65138,65140,65140,65142,65276,65296,65305,65313,65338,65343,65343,65345,65370,65381,65470,65474,65479,65482,65487,65490,65495,65498,65500],unicodeES5IdentifierStart=[170,170,181,181,186,186,192,214,216,246,248,705,710,721,736,740,748,748,750,750,880,884,886,887,890,893,902,902,904,906,908,908,910,929,931,1013,1015,1153,1162,1319,1329,1366,1369,1369,1377,1415,1488,1514,1520,1522,1568,1610,1646,1647,1649,1747,1749,1749,1765,1766,1774,1775,1786,1788,1791,1791,1808,1808,1810,1839,1869,1957,1969,1969,1994,2026,2036,2037,2042,2042,2048,2069,2074,2074,2084,2084,2088,2088,2112,2136,2208,2208,2210,2220,2308,2361,2365,2365,2384,2384,2392,2401,2417,2423,2425,2431,2437,2444,2447,2448,2451,2472,2474,2480,2482,2482,2486,2489,2493,2493,2510,2510,2524,2525,2527,2529,2544,2545,2565,2570,2575,2576,2579,2600,2602,2608,2610,2611,2613,2614,2616,2617,2649,2652,2654,2654,2674,2676,2693,2701,2703,2705,2707,2728,2730,2736,2738,2739,2741,2745,2749,2749,2768,2768,2784,2785,2821,2828,2831,2832,2835,2856,2858,2864,2866,2867,2869,2873,2877,2877,2908,2909,2911,2913,2929,2929,2947,2947,2949,2954,2958,2960,2962,2965,2969,2970,2972,2972,2974,2975,2979,2980,2984,2986,2990,3001,3024,3024,3077,3084,3086,3088,3090,3112,3114,3123,3125,3129,3133,3133,3160,3161,3168,3169,3205,3212,3214,3216,3218,3240,3242,3251,3253,3257,3261,3261,3294,3294,3296,3297,3313,3314,3333,3340,3342,3344,3346,3386,3389,3389,3406,3406,3424,3425,3450,3455,3461,3478,3482,3505,3507,3515,3517,3517,3520,3526,3585,3632,3634,3635,3648,3654,3713,3714,3716,3716,3719,3720,3722,3722,3725,3725,3732,3735,3737,3743,3745,3747,3749,3749,3751,3751,3754,3755,3757,3760,3762,3763,3773,3773,3776,3780,3782,3782,3804,3807,3840,3840,3904,3911,3913,3948,3976,3980,4096,4138,4159,4159,4176,4181,4186,4189,4193,4193,4197,4198,4206,4208,4213,4225,4238,4238,4256,4293,4295,4295,4301,4301,4304,4346,4348,4680,4682,4685,4688,4694,4696,4696,4698,4701,4704,4744,4746,4749,4752,4784,4786,4789,4792,4798,4800,4800,4802,4805,4808,4822,4824,4880,4882,4885,4888,4954,4992,5007,5024,5108,5121,5740,5743,5759,5761,5786,5792,5866,5870,5872,5888,5900,5902,5905,5920,5937,5952,5969,5984,5996,5998,6e3,6016,6067,6103,6103,6108,6108,6176,6263,6272,6312,6314,6314,6320,6389,6400,6428,6480,6509,6512,6516,6528,6571,6593,6599,6656,6678,6688,6740,6823,6823,6917,6963,6981,6987,7043,7072,7086,7087,7098,7141,7168,7203,7245,7247,7258,7293,7401,7404,7406,7409,7413,7414,7424,7615,7680,7957,7960,7965,7968,8005,8008,8013,8016,8023,8025,8025,8027,8027,8029,8029,8031,8061,8064,8116,8118,8124,8126,8126,8130,8132,8134,8140,8144,8147,8150,8155,8160,8172,8178,8180,8182,8188,8305,8305,8319,8319,8336,8348,8450,8450,8455,8455,8458,8467,8469,8469,8473,8477,8484,8484,8486,8486,8488,8488,8490,8493,8495,8505,8508,8511,8517,8521,8526,8526,8544,8584,11264,11310,11312,11358,11360,11492,11499,11502,11506,11507,11520,11557,11559,11559,11565,11565,11568,11623,11631,11631,11648,11670,11680,11686,11688,11694,11696,11702,11704,11710,11712,11718,11720,11726,11728,11734,11736,11742,11823,11823,12293,12295,12321,12329,12337,12341,12344,12348,12353,12438,12445,12447,12449,12538,12540,12543,12549,12589,12593,12686,12704,12730,12784,12799,13312,19893,19968,40908,40960,42124,42192,42237,42240,42508,42512,42527,42538,42539,42560,42606,42623,42647,42656,42735,42775,42783,42786,42888,42891,42894,42896,42899,42912,42922,43e3,43009,43011,43013,43015,43018,43020,43042,43072,43123,43138,43187,43250,43255,43259,43259,43274,43301,43312,43334,43360,43388,43396,43442,43471,43471,43520,43560,43584,43586,43588,43595,43616,43638,43642,43642,43648,43695,43697,43697,43701,43702,43705,43709,43712,43712,43714,43714,43739,43741,43744,43754,43762,43764,43777,43782,43785,43790,43793,43798,43808,43814,43816,43822,43968,44002,44032,55203,55216,55238,55243,55291,63744,64109,64112,64217,64256,64262,64275,64279,64285,64285,64287,64296,64298,64310,64312,64316,64318,64318,64320,64321,64323,64324,64326,64433,64467,64829,64848,64911,64914,64967,65008,65019,65136,65140,65142,65276,65313,65338,65345,65370,65382,65470,65474,65479,65482,65487,65490,65495,65498,65500],unicodeES5IdentifierPart=[170,170,181,181,186,186,192,214,216,246,248,705,710,721,736,740,748,748,750,750,768,884,886,887,890,893,902,902,904,906,908,908,910,929,931,1013,1015,1153,1155,1159,1162,1319,1329,1366,1369,1369,1377,1415,1425,1469,1471,1471,1473,1474,1476,1477,1479,1479,1488,1514,1520,1522,1552,1562,1568,1641,1646,1747,1749,1756,1759,1768,1770,1788,1791,1791,1808,1866,1869,1969,1984,2037,2042,2042,2048,2093,2112,2139,2208,2208,2210,2220,2276,2302,2304,2403,2406,2415,2417,2423,2425,2431,2433,2435,2437,2444,2447,2448,2451,2472,2474,2480,2482,2482,2486,2489,2492,2500,2503,2504,2507,2510,2519,2519,2524,2525,2527,2531,2534,2545,2561,2563,2565,2570,2575,2576,2579,2600,2602,2608,2610,2611,2613,2614,2616,2617,2620,2620,2622,2626,2631,2632,2635,2637,2641,2641,2649,2652,2654,2654,2662,2677,2689,2691,2693,2701,2703,2705,2707,2728,2730,2736,2738,2739,2741,2745,2748,2757,2759,2761,2763,2765,2768,2768,2784,2787,2790,2799,2817,2819,2821,2828,2831,2832,2835,2856,2858,2864,2866,2867,2869,2873,2876,2884,2887,2888,2891,2893,2902,2903,2908,2909,2911,2915,2918,2927,2929,2929,2946,2947,2949,2954,2958,2960,2962,2965,2969,2970,2972,2972,2974,2975,2979,2980,2984,2986,2990,3001,3006,3010,3014,3016,3018,3021,3024,3024,3031,3031,3046,3055,3073,3075,3077,3084,3086,3088,3090,3112,3114,3123,3125,3129,3133,3140,3142,3144,3146,3149,3157,3158,3160,3161,3168,3171,3174,3183,3202,3203,3205,3212,3214,3216,3218,3240,3242,3251,3253,3257,3260,3268,3270,3272,3274,3277,3285,3286,3294,3294,3296,3299,3302,3311,3313,3314,3330,3331,3333,3340,3342,3344,3346,3386,3389,3396,3398,3400,3402,3406,3415,3415,3424,3427,3430,3439,3450,3455,3458,3459,3461,3478,3482,3505,3507,3515,3517,3517,3520,3526,3530,3530,3535,3540,3542,3542,3544,3551,3570,3571,3585,3642,3648,3662,3664,3673,3713,3714,3716,3716,3719,3720,3722,3722,3725,3725,3732,3735,3737,3743,3745,3747,3749,3749,3751,3751,3754,3755,3757,3769,3771,3773,3776,3780,3782,3782,3784,3789,3792,3801,3804,3807,3840,3840,3864,3865,3872,3881,3893,3893,3895,3895,3897,3897,3902,3911,3913,3948,3953,3972,3974,3991,3993,4028,4038,4038,4096,4169,4176,4253,4256,4293,4295,4295,4301,4301,4304,4346,4348,4680,4682,4685,4688,4694,4696,4696,4698,4701,4704,4744,4746,4749,4752,4784,4786,4789,4792,4798,4800,4800,4802,4805,4808,4822,4824,4880,4882,4885,4888,4954,4957,4959,4992,5007,5024,5108,5121,5740,5743,5759,5761,5786,5792,5866,5870,5872,5888,5900,5902,5908,5920,5940,5952,5971,5984,5996,5998,6e3,6002,6003,6016,6099,6103,6103,6108,6109,6112,6121,6155,6157,6160,6169,6176,6263,6272,6314,6320,6389,6400,6428,6432,6443,6448,6459,6470,6509,6512,6516,6528,6571,6576,6601,6608,6617,6656,6683,6688,6750,6752,6780,6783,6793,6800,6809,6823,6823,6912,6987,6992,7001,7019,7027,7040,7155,7168,7223,7232,7241,7245,7293,7376,7378,7380,7414,7424,7654,7676,7957,7960,7965,7968,8005,8008,8013,8016,8023,8025,8025,8027,8027,8029,8029,8031,8061,8064,8116,8118,8124,8126,8126,8130,8132,8134,8140,8144,8147,8150,8155,8160,8172,8178,8180,8182,8188,8204,8205,8255,8256,8276,8276,8305,8305,8319,8319,8336,8348,8400,8412,8417,8417,8421,8432,8450,8450,8455,8455,8458,8467,8469,8469,8473,8477,8484,8484,8486,8486,8488,8488,8490,8493,8495,8505,8508,8511,8517,8521,8526,8526,8544,8584,11264,11310,11312,11358,11360,11492,11499,11507,11520,11557,11559,11559,11565,11565,11568,11623,11631,11631,11647,11670,11680,11686,11688,11694,11696,11702,11704,11710,11712,11718,11720,11726,11728,11734,11736,11742,11744,11775,11823,11823,12293,12295,12321,12335,12337,12341,12344,12348,12353,12438,12441,12442,12445,12447,12449,12538,12540,12543,12549,12589,12593,12686,12704,12730,12784,12799,13312,19893,19968,40908,40960,42124,42192,42237,42240,42508,42512,42539,42560,42607,42612,42621,42623,42647,42655,42737,42775,42783,42786,42888,42891,42894,42896,42899,42912,42922,43e3,43047,43072,43123,43136,43204,43216,43225,43232,43255,43259,43259,43264,43309,43312,43347,43360,43388,43392,43456,43471,43481,43520,43574,43584,43597,43600,43609,43616,43638,43642,43643,43648,43714,43739,43741,43744,43759,43762,43766,43777,43782,43785,43790,43793,43798,43808,43814,43816,43822,43968,44010,44012,44013,44016,44025,44032,55203,55216,55238,55243,55291,63744,64109,64112,64217,64256,64262,64275,64279,64285,64296,64298,64310,64312,64316,64318,64318,64320,64321,64323,64324,64326,64433,64467,64829,64848,64911,64914,64967,65008,65019,65024,65039,65056,65062,65075,65076,65101,65103,65136,65140,65142,65276,65296,65305,65313,65338,65343,65343,65345,65370,65382,65470,65474,65479,65482,65487,65490,65495,65498,65500];ts.isUnicodeIdentifierStart=isUnicodeIdentifierStart;var tokenStrings=makeReverseMap(textToToken);ts.tokenToString=tokenToString,ts.stringToToken=stringToToken,ts.computeLineStarts=computeLineStarts,ts.getPositionOfLineAndCharacter=getPositionOfLineAndCharacter,ts.computePositionOfLineAndCharacter=computePositionOfLineAndCharacter,ts.getLineStarts=getLineStarts,ts.computeLineAndCharacterOfPosition=computeLineAndCharacterOfPosition,ts.getLineAndCharacterOfPosition=getLineAndCharacterOfPosition;var hasOwnProperty=Object.prototype.hasOwnProperty;ts.isWhiteSpace=isWhiteSpace,ts.isLineBreak=isLineBreak,ts.isOctalDigit=isOctalDigit,ts.couldStartTrivia=couldStartTrivia,ts.skipTrivia=skipTrivia;var mergeConflictMarkerLength="<<<<<<<".length,shebangTriviaRegex=/^#!.*/;ts.getLeadingCommentRanges=getLeadingCommentRanges,ts.getTrailingCommentRanges=getTrailingCommentRanges,ts.getShebang=getShebang,ts.isIdentifierStart=isIdentifierStart,ts.isIdentifierPart=isIdentifierPart,ts.isIdentifier=isIdentifier,ts.createScanner=createScanner}(ts||(ts={}));var ts;!function(ts){function getDeclarationOfKind(symbol,kind){var declarations=symbol.declarations;if(declarations)for(var _i=0,declarations_1=declarations;_i<declarations_1.length;_i++){var declaration=declarations_1[_i];if(declaration.kind===kind)return declaration}}function getSingleLineStringWriter(){if(0===stringWriters.length){var str_1="",writeText=function(text){return str_1+=text};return{string:function(){return str_1},writeKeyword:writeText,writeOperator:writeText,writePunctuation:writeText,writeSpace:writeText,writeStringLiteral:writeText,writeParameter:writeText,writeSymbol:writeText,writeLine:function(){return str_1+=" "},increaseIndent:function(){},decreaseIndent:function(){},clear:function(){return str_1=""},trackSymbol:function(){},reportInaccessibleThisError:function(){}}}return stringWriters.pop()}function releaseStringWriter(writer){writer.clear(),stringWriters.push(writer)}function getFullWidth(node){return node.end-node.pos}function arrayIsEqualTo(array1,array2,equaler){if(!array1||!array2)return array1===array2;if(array1.length!==array2.length)return!1;for(var i=0;i<array1.length;i++){var equals=equaler?equaler(array1[i],array2[i]):array1[i]===array2[i];if(!equals)return!1}return!0}function hasResolvedModule(sourceFile,moduleNameText){return sourceFile.resolvedModules&&ts.hasProperty(sourceFile.resolvedModules,moduleNameText)}function getResolvedModule(sourceFile,moduleNameText){return hasResolvedModule(sourceFile,moduleNameText)?sourceFile.resolvedModules[moduleNameText]:void 0}function setResolvedModule(sourceFile,moduleNameText,resolvedModule){sourceFile.resolvedModules||(sourceFile.resolvedModules={}),sourceFile.resolvedModules[moduleNameText]=resolvedModule}function containsParseError(node){return aggregateChildData(node),0!==(64&node.parserContextFlags)}function aggregateChildData(node){if(!(128&node.parserContextFlags)){var thisNodeOrAnySubNodesHasError=0!==(16&node.parserContextFlags)||ts.forEachChild(node,containsParseError);thisNodeOrAnySubNodesHasError&&(node.parserContextFlags|=64),node.parserContextFlags|=128}}function getSourceFileOfNode(node){for(;node&&251!==node.kind;)node=node.parent;return node}function isStatementWithLocals(node){switch(node.kind){case 195:case 223:case 202:case 203:case 204:return!0}return!1}function getStartPositionOfLine(line,sourceFile){return ts.Debug.assert(line>=0),ts.getLineStarts(sourceFile)[line]}function nodePosToString(node){var file=getSourceFileOfNode(node),loc=ts.getLineAndCharacterOfPosition(file,node.pos);return file.fileName+"("+(loc.line+1)+","+(loc.character+1)+")"}function getStartPosOfNode(node){return node.pos}function nodeIsMissing(node){return!node||node.pos===node.end&&node.pos>=0&&1!==node.kind}function nodeIsPresent(node){return!nodeIsMissing(node)}function getTokenPosOfNode(node,sourceFile){return nodeIsMissing(node)?node.pos:ts.skipTrivia((sourceFile||getSourceFileOfNode(node)).text,node.pos)}function getNonDecoratorTokenPosOfNode(node,sourceFile){return nodeIsMissing(node)||!node.decorators?getTokenPosOfNode(node,sourceFile):ts.skipTrivia((sourceFile||getSourceFileOfNode(node)).text,node.decorators.end)}function getSourceTextOfNodeFromSourceFile(sourceFile,node,includeTrivia){if(void 0===includeTrivia&&(includeTrivia=!1),nodeIsMissing(node))return"";var text=sourceFile.text;return text.substring(includeTrivia?node.pos:ts.skipTrivia(text,node.pos),node.end)}function getTextOfNodeFromSourceText(sourceText,node){return nodeIsMissing(node)?"":sourceText.substring(ts.skipTrivia(sourceText,node.pos),node.end)}function getTextOfNode(node,includeTrivia){return void 0===includeTrivia&&(includeTrivia=!1),getSourceTextOfNodeFromSourceFile(getSourceFileOfNode(node),node,includeTrivia)}function escapeIdentifier(identifier){return identifier.length>=2&&95===identifier.charCodeAt(0)&&95===identifier.charCodeAt(1)?"_"+identifier:identifier}function unescapeIdentifier(identifier){return identifier.length>=3&&95===identifier.charCodeAt(0)&&95===identifier.charCodeAt(1)&&95===identifier.charCodeAt(2)?identifier.substr(1):identifier}function makeIdentifierFromModuleName(moduleName){return ts.getBaseFileName(moduleName).replace(/^(\d)/,"_$1").replace(/\W/g,"_")}function isBlockOrCatchScoped(declaration){return 0!==(24576&getCombinedNodeFlags(declaration))||isCatchClauseVariableDeclaration(declaration)}function isAmbientModule(node){return node&&221===node.kind&&(9===node.name.kind||isGlobalScopeAugmentation(node));
}function isBlockScopedContainerTopLevel(node){return 251===node.kind||221===node.kind||isFunctionLike(node)||isFunctionBlock(node)}function isGlobalScopeAugmentation(module){return!!(2097152&module.flags)}function isExternalModuleAugmentation(node){if(!node||!isAmbientModule(node))return!1;switch(node.parent.kind){case 251:return isExternalModule(node.parent);case 222:return isAmbientModule(node.parent.parent)&&!isExternalModule(node.parent.parent.parent)}return!1}function getEnclosingBlockScopeContainer(node){for(var current=node.parent;current;){if(isFunctionLike(current))return current;switch(current.kind){case 251:case 223:case 247:case 221:case 202:case 203:case 204:return current;case 195:if(!isFunctionLike(current.parent))return current}current=current.parent}}function isCatchClauseVariableDeclaration(declaration){return declaration&&214===declaration.kind&&declaration.parent&&247===declaration.parent.kind}function declarationNameToString(name){return 0===getFullWidth(name)?"(Missing)":getTextOfNode(name)}function createDiagnosticForNode(node,message,arg0,arg1,arg2){var sourceFile=getSourceFileOfNode(node),span=getErrorSpanForNode(sourceFile,node);return ts.createFileDiagnostic(sourceFile,span.start,span.length,message,arg0,arg1,arg2)}function createDiagnosticForNodeFromMessageChain(node,messageChain){var sourceFile=getSourceFileOfNode(node),span=getErrorSpanForNode(sourceFile,node);return{file:sourceFile,start:span.start,length:span.length,code:messageChain.code,category:messageChain.category,messageText:messageChain.next?messageChain:messageChain.messageText}}function getSpanOfTokenAtPosition(sourceFile,pos){var scanner=ts.createScanner(sourceFile.languageVersion,!0,sourceFile.languageVariant,sourceFile.text,void 0,pos);scanner.scan();var start=scanner.getTokenPos();return ts.createTextSpanFromBounds(start,scanner.getTextPos())}function getErrorSpanForNode(sourceFile,node){var errorNode=node;switch(node.kind){case 251:var pos_1=ts.skipTrivia(sourceFile.text,0,!1);return pos_1===sourceFile.text.length?ts.createTextSpan(0,0):getSpanOfTokenAtPosition(sourceFile,pos_1);case 214:case 166:case 217:case 189:case 218:case 221:case 220:case 250:case 216:case 176:case 144:case 219:errorNode=node.name}if(void 0===errorNode)return getSpanOfTokenAtPosition(sourceFile,node.pos);var pos=nodeIsMissing(errorNode)?errorNode.pos:ts.skipTrivia(sourceFile.text,errorNode.pos);return ts.createTextSpanFromBounds(pos,errorNode.end)}function isExternalModule(file){return void 0!==file.externalModuleIndicator}function isExternalOrCommonJsModule(file){return void 0!==(file.externalModuleIndicator||file.commonJsModuleIndicator)}function isDeclarationFile(file){return 0!==(4096&file.flags)}function isConstEnumDeclaration(node){return 220===node.kind&&isConst(node)}function walkUpBindingElementsAndPatterns(node){for(;node&&(166===node.kind||isBindingPattern(node));)node=node.parent;return node}function getCombinedNodeFlags(node){node=walkUpBindingElementsAndPatterns(node);var flags=node.flags;return 214===node.kind&&(node=node.parent),node&&215===node.kind&&(flags|=node.flags,node=node.parent),node&&196===node.kind&&(flags|=node.flags),flags}function isConst(node){return!!(16384&getCombinedNodeFlags(node))}function isLet(node){return!!(8192&getCombinedNodeFlags(node))}function isSuperCallExpression(n){return 171===n.kind&&95===n.expression.kind}function isPrologueDirective(node){return 198===node.kind&&9===node.expression.kind}function getLeadingCommentRangesOfNode(node,sourceFileOfNode){return ts.getLeadingCommentRanges(sourceFileOfNode.text,node.pos)}function getLeadingCommentRangesOfNodeFromText(node,text){return ts.getLeadingCommentRanges(text,node.pos)}function getJsDocComments(node,sourceFileOfNode){return getJsDocCommentsFromText(node,sourceFileOfNode.text)}function getJsDocCommentsFromText(node,text){function isJsDocComment(comment){return 42===text.charCodeAt(comment.pos+1)&&42===text.charCodeAt(comment.pos+2)&&47!==text.charCodeAt(comment.pos+3)}var commentRanges=139===node.kind||138===node.kind?ts.concatenate(ts.getTrailingCommentRanges(text,node.pos),ts.getLeadingCommentRanges(text,node.pos)):getLeadingCommentRangesOfNodeFromText(node,text);return ts.filter(commentRanges,isJsDocComment)}function isTypeNode(node){if(151<=node.kind&&node.kind<=163)return!0;switch(node.kind){case 117:case 128:case 130:case 120:case 131:return!0;case 103:return 180!==node.parent.kind;case 191:return!isExpressionWithTypeArgumentsInClassExtendsClause(node);case 69:136===node.parent.kind&&node.parent.right===node?node=node.parent:169===node.parent.kind&&node.parent.name===node&&(node=node.parent),ts.Debug.assert(69===node.kind||136===node.kind||169===node.kind,"'node' was expected to be a qualified name, identifier or property access in 'isTypeNode'.");case 136:case 169:case 97:var parent_1=node.parent;if(155===parent_1.kind)return!1;if(151<=parent_1.kind&&parent_1.kind<=163)return!0;switch(parent_1.kind){case 191:return!isExpressionWithTypeArgumentsInClassExtendsClause(parent_1);case 138:return node===parent_1.constraint;case 142:case 141:case 139:case 214:return node===parent_1.type;case 216:case 176:case 177:case 145:case 144:case 143:case 146:case 147:return node===parent_1.type;case 148:case 149:case 150:return node===parent_1.type;case 174:return node===parent_1.type;case 171:case 172:return parent_1.typeArguments&&ts.indexOf(parent_1.typeArguments,node)>=0;case 173:return!1}}return!1}function forEachReturnStatement(body,visitor){function traverse(node){switch(node.kind){case 207:return visitor(node);case 223:case 195:case 199:case 200:case 201:case 202:case 203:case 204:case 208:case 209:case 244:case 245:case 210:case 212:case 247:return ts.forEachChild(node,traverse)}}return traverse(body)}function forEachYieldExpression(body,visitor){function traverse(node){switch(node.kind){case 187:visitor(node);var operand=node.expression;operand&&traverse(operand);case 220:case 218:case 221:case 219:case 217:case 189:return;default:if(isFunctionLike(node)){var name_5=node.name;if(name_5&&137===name_5.kind)return void traverse(name_5.expression)}else isTypeNode(node)||ts.forEachChild(node,traverse)}}return traverse(body)}function isVariableLike(node){if(node)switch(node.kind){case 166:case 250:case 139:case 248:case 142:case 141:case 249:case 214:return!0}return!1}function isAccessor(node){return node&&(146===node.kind||147===node.kind)}function isClassLike(node){return node&&(217===node.kind||189===node.kind)}function isFunctionLike(node){return node&&isFunctionLikeKind(node.kind)}function isFunctionLikeKind(kind){switch(kind){case 145:case 176:case 216:case 177:case 144:case 143:case 146:case 147:case 148:case 149:case 150:case 153:case 154:return!0}}function introducesArgumentsExoticObject(node){switch(node.kind){case 144:case 143:case 145:case 146:case 147:case 216:case 176:return!0}return!1}function isIterationStatement(node,lookInLabeledStatements){switch(node.kind){case 202:case 203:case 204:case 200:case 201:return!0;case 210:return lookInLabeledStatements&&isIterationStatement(node.statement,lookInLabeledStatements)}return!1}function isFunctionBlock(node){return node&&195===node.kind&&isFunctionLike(node.parent)}function isObjectLiteralMethod(node){return node&&144===node.kind&&168===node.parent.kind}function isIdentifierTypePredicate(predicate){return predicate&&1===predicate.kind}function isThisTypePredicate(predicate){return predicate&&0===predicate.kind}function getContainingFunction(node){for(;;)if(node=node.parent,!node||isFunctionLike(node))return node}function getContainingClass(node){for(;;)if(node=node.parent,!node||isClassLike(node))return node}function getThisContainer(node,includeArrowFunctions){for(;;){if(node=node.parent,!node)return;switch(node.kind){case 137:if(isClassLike(node.parent.parent))return node;node=node.parent;break;case 140:139===node.parent.kind&&isClassElement(node.parent.parent)?node=node.parent.parent:isClassElement(node.parent)&&(node=node.parent);break;case 177:if(!includeArrowFunctions)continue;case 216:case 176:case 221:case 142:case 141:case 144:case 143:case 145:case 146:case 147:case 148:case 149:case 150:case 220:case 251:return node}}}function getSuperContainer(node,stopOnFunctions){for(;;){if(node=node.parent,!node)return node;switch(node.kind){case 137:node=node.parent;break;case 216:case 176:case 177:if(!stopOnFunctions)continue;case 142:case 141:case 144:case 143:case 145:case 146:case 147:return node;case 140:139===node.parent.kind&&isClassElement(node.parent.parent)?node=node.parent.parent:isClassElement(node.parent)&&(node=node.parent)}}}function isSuperPropertyOrElementAccess(node){return(169===node.kind||170===node.kind)&&95===node.expression.kind}function getEntityNameFromTypeNode(node){if(node)switch(node.kind){case 152:return node.typeName;case 191:return node.expression;case 69:case 136:return node}}function getInvokedExpression(node){return 173===node.kind?node.tag:node.expression}function nodeCanBeDecorated(node){switch(node.kind){case 217:return!0;case 142:return 217===node.parent.kind;case 146:case 147:case 144:return void 0!==node.body&&217===node.parent.kind;case 139:return void 0!==node.parent.body&&(145===node.parent.kind||144===node.parent.kind||147===node.parent.kind)&&217===node.parent.parent.kind}return!1}function nodeIsDecorated(node){return void 0!==node.decorators&&nodeCanBeDecorated(node)}function isPropertyAccessExpression(node){return 169===node.kind}function isElementAccessExpression(node){return 170===node.kind}function isExpression(node){switch(node.kind){case 95:case 93:case 99:case 84:case 10:case 167:case 168:case 169:case 170:case 171:case 172:case 173:case 192:case 174:case 175:case 176:case 189:case 177:case 180:case 178:case 179:case 182:case 183:case 184:case 185:case 188:case 186:case 11:case 190:case 236:case 237:case 187:case 181:return!0;case 136:for(;136===node.parent.kind;)node=node.parent;return 155===node.parent.kind;case 69:if(155===node.parent.kind)return!0;case 8:case 9:case 97:var parent_2=node.parent;switch(parent_2.kind){case 214:case 139:case 142:case 141:case 250:case 248:case 166:return parent_2.initializer===node;case 198:case 199:case 200:case 201:case 207:case 208:case 209:case 244:case 211:case 209:return parent_2.expression===node;case 202:var forStatement=parent_2;return forStatement.initializer===node&&215!==forStatement.initializer.kind||forStatement.condition===node||forStatement.incrementor===node;case 203:case 204:var forInStatement=parent_2;return forInStatement.initializer===node&&215!==forInStatement.initializer.kind||forInStatement.expression===node;case 174:case 192:return node===parent_2.expression;case 193:return node===parent_2.expression;case 137:return node===parent_2.expression;case 140:case 243:case 242:return!0;case 191:return parent_2.expression===node&&isExpressionWithTypeArgumentsInClassExtendsClause(parent_2);default:if(isExpression(parent_2))return!0}}return!1}function isExternalModuleNameRelative(moduleName){return"./"===moduleName.substr(0,2)||"../"===moduleName.substr(0,3)||".\\"===moduleName.substr(0,2)||"..\\"===moduleName.substr(0,3)}function isInstantiatedModule(node,preserveConstEnums){var moduleState=ts.getModuleInstanceState(node);return 1===moduleState||preserveConstEnums&&2===moduleState}function isExternalModuleImportEqualsDeclaration(node){return 224===node.kind&&235===node.moduleReference.kind}function getExternalModuleImportEqualsDeclarationExpression(node){return ts.Debug.assert(isExternalModuleImportEqualsDeclaration(node)),node.moduleReference.expression}function isInternalModuleImportEqualsDeclaration(node){return 224===node.kind&&235!==node.moduleReference.kind}function isSourceFileJavaScript(file){return isInJavaScriptFile(file)}function isInJavaScriptFile(node){return node&&!!(32&node.parserContextFlags)}function isRequireCall(expression,checkArgumentIsStringLiteral){var isRequire=171===expression.kind&&69===expression.expression.kind&&"require"===expression.expression.text&&1===expression.arguments.length;return isRequire&&(!checkArgumentIsStringLiteral||9===expression.arguments[0].kind)}function getSpecialPropertyAssignmentKind(expression){if(184!==expression.kind)return 0;var expr=expression;if(56!==expr.operatorToken.kind||169!==expr.left.kind)return 0;var lhs=expr.left;if(69===lhs.expression.kind){var lhsId=lhs.expression;if("exports"===lhsId.text)return 1;if("module"===lhsId.text&&"exports"===lhs.name.text)return 2}else{if(97===lhs.expression.kind)return 4;if(169===lhs.expression.kind){var innerPropertyAccess=lhs.expression;if(69===innerPropertyAccess.expression.kind&&"prototype"===innerPropertyAccess.name.text)return 3}}return 0}function getExternalModuleName(node){if(225===node.kind)return node.moduleSpecifier;if(224===node.kind){var reference=node.moduleReference;if(235===reference.kind)return reference.expression}return 231===node.kind?node.moduleSpecifier:221===node.kind&&9===node.name.kind?node.name:void 0}function hasQuestionToken(node){if(node)switch(node.kind){case 139:case 144:case 143:case 249:case 248:case 142:case 141:return void 0!==node.questionToken}return!1}function isJSDocConstructSignature(node){return 264===node.kind&&node.parameters.length>0&&266===node.parameters[0].type.kind}function getJSDocTag(node,kind,checkParentVariableStatement){if(node){var jsDocComment=getJSDocComment(node,checkParentVariableStatement);if(jsDocComment)for(var _i=0,_a=jsDocComment.tags;_i<_a.length;_i++){var tag=_a[_i];if(tag.kind===kind)return tag}}}function getJSDocComment(node,checkParentVariableStatement){if(node.jsDocComment)return node.jsDocComment;if(checkParentVariableStatement){var isInitializerOfVariableDeclarationInStatement=214===node.parent.kind&&node.parent.initializer===node&&196===node.parent.parent.parent.kind,variableStatementNode=isInitializerOfVariableDeclarationInStatement?node.parent.parent.parent:void 0;if(variableStatementNode)return variableStatementNode.jsDocComment;var parent_3=node.parent,isSourceOfAssignmentExpressionStatement=parent_3&&parent_3.parent&&184===parent_3.kind&&56===parent_3.operatorToken.kind&&198===parent_3.parent.kind;if(isSourceOfAssignmentExpressionStatement)return parent_3.parent.jsDocComment;var isPropertyAssignmentExpression=parent_3&&248===parent_3.kind;if(isPropertyAssignmentExpression)return parent_3.jsDocComment}}function getJSDocTypeTag(node){return getJSDocTag(node,272,!1)}function getJSDocReturnTag(node){return getJSDocTag(node,271,!0)}function getJSDocTemplateTag(node){return getJSDocTag(node,273,!1)}function getCorrespondingJSDocParameterTag(parameter){if(parameter.name&&69===parameter.name.kind){var parameterName=parameter.name.text,jsDocComment=getJSDocComment(parameter.parent,!0);if(jsDocComment)for(var _i=0,_a=jsDocComment.tags;_i<_a.length;_i++){var tag=_a[_i];if(270===tag.kind){var parameterTag=tag,name_6=parameterTag.preParameterName||parameterTag.postParameterName;if(name_6.text===parameterName)return parameterTag}}}}function hasRestParameter(s){return isRestParameter(ts.lastOrUndefined(s.parameters))}function isRestParameter(node){if(node){if(32&node.parserContextFlags){if(node.type&&265===node.type.kind)return!0;var paramTag=getCorrespondingJSDocParameterTag(node);if(paramTag&&paramTag.typeExpression)return 265===paramTag.typeExpression.type.kind}return void 0!==node.dotDotDotToken}return!1}function isLiteralKind(kind){return 8<=kind&&kind<=11}function isTextualLiteralKind(kind){return 9===kind||11===kind}function isTemplateLiteralKind(kind){return 11<=kind&&kind<=14}function isBindingPattern(node){return!!node&&(165===node.kind||164===node.kind)}function isNodeDescendentOf(node,ancestor){for(;node;){if(node===ancestor)return!0;node=node.parent}return!1}function isInAmbientContext(node){for(;node;){if(4100&node.flags)return!0;node=node.parent}return!1}function isDeclaration(node){switch(node.kind){case 177:case 166:case 217:case 189:case 145:case 220:case 250:case 233:case 216:case 176:case 146:case 226:case 224:case 229:case 218:case 144:case 143:case 221:case 227:case 139:case 248:case 142:case 141:case 147:case 249:case 219:case 138:case 214:return!0}return!1}function isStatement(n){switch(n.kind){case 206:case 205:case 213:case 200:case 198:case 197:case 203:case 204:case 202:case 199:case 210:case 207:case 209:case 211:case 212:case 196:case 201:case 208:case 230:return!0;default:return!1}}function isClassElement(n){switch(n.kind){case 145:case 142:case 144:case 146:case 147:case 143:case 150:return!0;default:return!1}}function isDeclarationName(name){if(69!==name.kind&&9!==name.kind&&8!==name.kind)return!1;var parent=name.parent;return!(229!==parent.kind&&233!==parent.kind||!parent.propertyName)||!!isDeclaration(parent)&&parent.name===name}function isIdentifierName(node){var parent=node.parent;switch(parent.kind){case 142:case 141:case 144:case 143:case 146:case 147:case 250:case 248:case 169:return parent.name===node;case 136:if(parent.right===node){for(;136===parent.kind;)parent=parent.parent;return 155===parent.kind}return!1;case 166:case 229:return parent.propertyName===node;case 233:return!0}return!1}function isAliasSymbolDeclaration(node){return 224===node.kind||226===node.kind&&!!node.name||227===node.kind||229===node.kind||233===node.kind||230===node.kind&&69===node.expression.kind}function getClassExtendsHeritageClauseElement(node){var heritageClause=getHeritageClause(node.heritageClauses,83);return heritageClause&&heritageClause.types.length>0?heritageClause.types[0]:void 0}function getClassImplementsHeritageClauseElements(node){var heritageClause=getHeritageClause(node.heritageClauses,106);return heritageClause?heritageClause.types:void 0}function getInterfaceBaseTypeNodes(node){var heritageClause=getHeritageClause(node.heritageClauses,83);return heritageClause?heritageClause.types:void 0}function getHeritageClause(clauses,kind){if(clauses)for(var _i=0,clauses_1=clauses;_i<clauses_1.length;_i++){var clause=clauses_1[_i];if(clause.token===kind)return clause}}function tryResolveScriptReference(host,sourceFile,reference){if(!host.getCompilerOptions().noResolve){var referenceFileName=ts.isRootedDiskPath(reference.fileName)?reference.fileName:ts.combinePaths(ts.getDirectoryPath(sourceFile.fileName),reference.fileName);return host.getSourceFile(referenceFileName)}}function getAncestor(node,kind){for(;node;){if(node.kind===kind)return node;node=node.parent}}function getFileReferenceFromReferencePath(comment,commentRange){var simpleReferenceRegEx=/^\/\/\/\s*<reference\s+/gim,isNoDefaultLibRegEx=/^(\/\/\/\s*<reference\s+no-default-lib\s*=\s*)('|")(.+?)\2\s*\/>/gim;if(simpleReferenceRegEx.test(comment)){if(isNoDefaultLibRegEx.test(comment))return{isNoDefaultLib:!0};var matchResult=ts.fullTripleSlashReferencePathRegEx.exec(comment);if(matchResult){var start=commentRange.pos,end=commentRange.end;return{fileReference:{pos:start,end:end,fileName:matchResult[3]},isNoDefaultLib:!1}}return{diagnosticMessage:ts.Diagnostics.Invalid_reference_directive_syntax,isNoDefaultLib:!1}}}function isKeyword(token){return 70<=token&&token<=135}function isTrivia(token){return 2<=token&&token<=7}function isAsyncFunctionLike(node){return isFunctionLike(node)&&0!==(256&node.flags)&&!isAccessor(node)}function isStringOrNumericLiteral(kind){return 9===kind||8===kind}function hasDynamicName(declaration){return declaration.name&&isDynamicName(declaration.name)}function isDynamicName(name){return 137===name.kind&&!isStringOrNumericLiteral(name.expression.kind)&&!isWellKnownSymbolSyntactically(name.expression)}function isWellKnownSymbolSyntactically(node){return isPropertyAccessExpression(node)&&isESSymbolIdentifier(node.expression)}function getPropertyNameForPropertyNameNode(name){if(69===name.kind||9===name.kind||8===name.kind)return name.text;if(137===name.kind){var nameExpression=name.expression;if(isWellKnownSymbolSyntactically(nameExpression)){var rightHandSideName=nameExpression.name.text;return getPropertyNameForKnownSymbolName(rightHandSideName)}}}function getPropertyNameForKnownSymbolName(symbolName){return"__@"+symbolName}function isESSymbolIdentifier(node){return 69===node.kind&&"Symbol"===node.text}function isModifierKind(token){switch(token){case 115:case 118:case 74:case 122:case 77:case 82:case 112:case 110:case 111:case 113:return!0}return!1}function isParameterDeclaration(node){var root=getRootDeclaration(node);return 139===root.kind}function getRootDeclaration(node){for(;166===node.kind;)node=node.parent.parent;return node}function nodeStartsNewLexicalEnvironment(n){return isFunctionLike(n)||221===n.kind||251===n.kind}function cloneNode(node,location,flags,parent){var clone=void 0!==location?ts.createNode(node.kind,location.pos,location.end):createSynthesizedNode(node.kind);for(var key in node)!clone.hasOwnProperty(key)&&node.hasOwnProperty(key)&&(clone[key]=node[key]);return void 0!==flags&&(clone.flags=flags),void 0!==parent&&(clone.parent=parent),clone}function cloneEntityName(node,parent){var clone=cloneNode(node,node,node.flags,parent);if(isQualifiedName(clone)){var left=clone.left,right=clone.right;clone.left=cloneEntityName(left,clone),clone.right=cloneNode(right,right,right.flags,parent)}return clone}function isQualifiedName(node){return 136===node.kind}function nodeIsSynthesized(node){return node.pos===-1}function createSynthesizedNode(kind,startsOnNewLine){var node=ts.createNode(kind,-1,-1);return node.startsOnNewLine=startsOnNewLine,node}function createSynthesizedNodeArray(){var array=[];return array.pos=-1,array.end=-1,array}function createDiagnosticCollection(){function getModificationCount(){return modificationCount}function reattachFileDiagnostics(newFile){if(ts.hasProperty(fileDiagnostics,newFile.fileName))for(var _i=0,_a=fileDiagnostics[newFile.fileName];_i<_a.length;_i++){var diagnostic=_a[_i];diagnostic.file=newFile}}function add(diagnostic){var diagnostics;diagnostic.file?(diagnostics=fileDiagnostics[diagnostic.file.fileName],diagnostics||(diagnostics=[],fileDiagnostics[diagnostic.file.fileName]=diagnostics)):diagnostics=nonFileDiagnostics,diagnostics.push(diagnostic),diagnosticsModified=!0,modificationCount++}function getGlobalDiagnostics(){return sortAndDeduplicate(),nonFileDiagnostics}function getDiagnostics(fileName){function pushDiagnostic(d){allDiagnostics.push(d)}if(sortAndDeduplicate(),fileName)return fileDiagnostics[fileName]||[];var allDiagnostics=[];ts.forEach(nonFileDiagnostics,pushDiagnostic);for(var key in fileDiagnostics)ts.hasProperty(fileDiagnostics,key)&&ts.forEach(fileDiagnostics[key],pushDiagnostic);return ts.sortAndDeduplicateDiagnostics(allDiagnostics)}function sortAndDeduplicate(){if(diagnosticsModified){diagnosticsModified=!1,nonFileDiagnostics=ts.sortAndDeduplicateDiagnostics(nonFileDiagnostics);for(var key in fileDiagnostics)ts.hasProperty(fileDiagnostics,key)&&(fileDiagnostics[key]=ts.sortAndDeduplicateDiagnostics(fileDiagnostics[key]))}}var nonFileDiagnostics=[],fileDiagnostics={},diagnosticsModified=!1,modificationCount=0;return{add:add,getGlobalDiagnostics:getGlobalDiagnostics,getDiagnostics:getDiagnostics,getModificationCount:getModificationCount,reattachFileDiagnostics:reattachFileDiagnostics}}function escapeString(s){function getReplacement(c){return escapedCharsMap[c]||get16BitUnicodeEscapeSequence(c.charCodeAt(0))}return s=escapedCharsRegExp.test(s)?s.replace(escapedCharsRegExp,getReplacement):s}function isIntrinsicJsxName(name){var ch=name.substr(0,1);return ch.toLowerCase()===ch}function get16BitUnicodeEscapeSequence(charCode){var hexCharCode=charCode.toString(16).toUpperCase(),paddedHexCode=("0000"+hexCharCode).slice(-4);return"\\u"+paddedHexCode}function escapeNonAsciiCharacters(s){return nonAsciiCharacters.test(s)?s.replace(nonAsciiCharacters,function(c){return get16BitUnicodeEscapeSequence(c.charCodeAt(0))}):s}function getIndentString(level){return void 0===indentStrings[level]&&(indentStrings[level]=getIndentString(level-1)+indentStrings[1]),indentStrings[level]}function getIndentSize(){return indentStrings[1].length}function createTextWriter(newLine){function write(s){s&&s.length&&(lineStart&&(output+=getIndentString(indent),lineStart=!1),output+=s)}function reset(){output="",indent=0,lineStart=!0,lineCount=0,linePos=0}function rawWrite(s){void 0!==s&&(lineStart&&(lineStart=!1),output+=s)}function writeLiteral(s){if(s&&s.length){write(s);var lineStartsOfS=ts.computeLineStarts(s);lineStartsOfS.length>1&&(lineCount=lineCount+lineStartsOfS.length-1,linePos=output.length-s.length+ts.lastOrUndefined(lineStartsOfS))}}function writeLine(){lineStart||(output+=newLine,lineCount++,linePos=output.length,lineStart=!0)}function writeTextOfNode(text,node){write(getTextOfNodeFromSourceText(text,node))}var output,indent,lineStart,lineCount,linePos;return reset(),{write:write,rawWrite:rawWrite,writeTextOfNode:writeTextOfNode,writeLiteral:writeLiteral,writeLine:writeLine,increaseIndent:function(){indent++},decreaseIndent:function(){indent--},getIndent:function(){return indent},getTextPos:function(){return output.length},getLine:function(){return lineCount+1},getColumn:function(){return lineStart?indent*getIndentSize()+1:output.length-linePos+1},getText:function(){return output},reset:reset}}function getExternalModuleNameFromPath(host,fileName){var getCanonicalFileName=function(f){return host.getCanonicalFileName(f)},dir=ts.toPath(host.getCommonSourceDirectory(),host.getCurrentDirectory(),getCanonicalFileName),filePath=ts.getNormalizedAbsolutePath(fileName,host.getCurrentDirectory()),relativePath=ts.getRelativePathToDirectoryOrUrl(dir,filePath,dir,getCanonicalFileName,!1);return ts.removeFileExtension(relativePath)}function getOwnEmitOutputFilePath(sourceFile,host,extension){var emitOutputFilePathWithoutExtension,compilerOptions=host.getCompilerOptions();return emitOutputFilePathWithoutExtension=compilerOptions.outDir?ts.removeFileExtension(getSourceFilePathInNewDir(sourceFile,host,compilerOptions.outDir)):ts.removeFileExtension(sourceFile.fileName),emitOutputFilePathWithoutExtension+extension}function getEmitScriptTarget(compilerOptions){return compilerOptions.target||0}function getEmitModuleKind(compilerOptions){return"number"==typeof compilerOptions.module?compilerOptions.module:2===getEmitScriptTarget(compilerOptions)?5:1}function forEachExpectedEmitFile(host,action,targetSourceFile){function onSingleFileEmit(host,sourceFile){var extension=".js";1===options.jsx&&(isSourceFileJavaScript(sourceFile)?ts.fileExtensionIs(sourceFile.fileName,".jsx")&&(extension=".jsx"):1===sourceFile.languageVariant&&(extension=".jsx"));var jsFilePath=getOwnEmitOutputFilePath(sourceFile,host,extension),emitFileNames={jsFilePath:jsFilePath,sourceMapFilePath:getSourceMapFilePath(jsFilePath,options),declarationFilePath:isSourceFileJavaScript(sourceFile)?void 0:getDeclarationEmitFilePath(jsFilePath,options)};action(emitFileNames,[sourceFile],!1)}function onBundledEmit(host){var bundledSources=ts.filter(host.getSourceFiles(),function(sourceFile){return!isDeclarationFile(sourceFile)&&(!isExternalModule(sourceFile)||getEmitModuleKind(options)&&isExternalModule(sourceFile))});if(bundledSources.length){var jsFilePath=options.outFile||options.out,emitFileNames={jsFilePath:jsFilePath,sourceMapFilePath:getSourceMapFilePath(jsFilePath,options),declarationFilePath:getDeclarationEmitFilePath(jsFilePath,options)};action(emitFileNames,bundledSources,!0)}}function getSourceMapFilePath(jsFilePath,options){return options.sourceMap?jsFilePath+".map":void 0}function getDeclarationEmitFilePath(jsFilePath,options){return options.declaration?ts.removeFileExtension(jsFilePath)+".d.ts":void 0}var options=host.getCompilerOptions();if(options.outFile||options.out)onBundledEmit(host);else for(var sourceFiles=void 0===targetSourceFile?host.getSourceFiles():[targetSourceFile],_i=0,sourceFiles_1=sourceFiles;_i<sourceFiles_1.length;_i++){var sourceFile=sourceFiles_1[_i];isDeclarationFile(sourceFile)||onSingleFileEmit(host,sourceFile)}}function getSourceFilePathInNewDir(sourceFile,host,newDirPath){var sourceFilePath=ts.getNormalizedAbsolutePath(sourceFile.fileName,host.getCurrentDirectory());return sourceFilePath=sourceFilePath.replace(host.getCommonSourceDirectory(),""),ts.combinePaths(newDirPath,sourceFilePath)}function writeFile(host,diagnostics,fileName,data,writeByteOrderMark){host.writeFile(fileName,data,writeByteOrderMark,function(hostErrorMessage){diagnostics.add(ts.createCompilerDiagnostic(ts.Diagnostics.Could_not_write_file_0_Colon_1,fileName,hostErrorMessage))})}function getLineOfLocalPosition(currentSourceFile,pos){return ts.getLineAndCharacterOfPosition(currentSourceFile,pos).line}function getLineOfLocalPositionFromLineMap(lineMap,pos){return ts.computeLineAndCharacterOfPosition(lineMap,pos).line}function getFirstConstructorWithBody(node){return ts.forEach(node.members,function(member){if(145===member.kind&&nodeIsPresent(member.body))return member})}function getSetAccessorTypeAnnotationNode(accessor){return accessor&&accessor.parameters.length>0&&accessor.parameters[0].type}function getAllAccessorDeclarations(declarations,accessor){var firstAccessor,secondAccessor,getAccessor,setAccessor;return hasDynamicName(accessor)?(firstAccessor=accessor,146===accessor.kind?getAccessor=accessor:147===accessor.kind?setAccessor=accessor:ts.Debug.fail("Accessor has wrong kind")):ts.forEach(declarations,function(member){if((146===member.kind||147===member.kind)&&(64&member.flags)===(64&accessor.flags)){var memberName=getPropertyNameForPropertyNameNode(member.name),accessorName=getPropertyNameForPropertyNameNode(accessor.name);memberName===accessorName&&(firstAccessor?secondAccessor||(secondAccessor=member):firstAccessor=member,146!==member.kind||getAccessor||(getAccessor=member),147!==member.kind||setAccessor||(setAccessor=member))}}),{firstAccessor:firstAccessor,secondAccessor:secondAccessor,getAccessor:getAccessor,setAccessor:setAccessor}}function emitNewLineBeforeLeadingComments(lineMap,writer,node,leadingComments){leadingComments&&leadingComments.length&&node.pos!==leadingComments[0].pos&&getLineOfLocalPositionFromLineMap(lineMap,node.pos)!==getLineOfLocalPositionFromLineMap(lineMap,leadingComments[0].pos)&&writer.writeLine()}function emitComments(text,lineMap,writer,comments,trailingSeparator,newLine,writeComment){var emitLeadingSpace=!trailingSeparator;ts.forEach(comments,function(comment){emitLeadingSpace&&(writer.write(" "),emitLeadingSpace=!1),writeComment(text,lineMap,writer,comment,newLine),comment.hasTrailingNewLine?writer.writeLine():trailingSeparator?writer.write(" "):emitLeadingSpace=!0})}function emitDetachedComments(text,lineMap,writer,writeComment,node,newLine,removeComments){function isPinnedComment(comment){return 42===text.charCodeAt(comment.pos+1)&&33===text.charCodeAt(comment.pos+2)}var leadingComments,currentDetachedCommentInfo;if(removeComments?0===node.pos&&(leadingComments=ts.filter(ts.getLeadingCommentRanges(text,node.pos),isPinnedComment)):leadingComments=ts.getLeadingCommentRanges(text,node.pos),leadingComments){for(var detachedComments=[],lastComment=void 0,_i=0,leadingComments_1=leadingComments;_i<leadingComments_1.length;_i++){var comment=leadingComments_1[_i];if(lastComment){var lastCommentLine=getLineOfLocalPositionFromLineMap(lineMap,lastComment.end),commentLine=getLineOfLocalPositionFromLineMap(lineMap,comment.pos);if(commentLine>=lastCommentLine+2)break}detachedComments.push(comment),lastComment=comment}if(detachedComments.length){var lastCommentLine=getLineOfLocalPositionFromLineMap(lineMap,ts.lastOrUndefined(detachedComments).end),nodeLine=getLineOfLocalPositionFromLineMap(lineMap,ts.skipTrivia(text,node.pos));nodeLine>=lastCommentLine+2&&(emitNewLineBeforeLeadingComments(lineMap,writer,node,leadingComments),emitComments(text,lineMap,writer,detachedComments,!0,newLine,writeComment),currentDetachedCommentInfo={nodePos:node.pos,detachedCommentEndPos:ts.lastOrUndefined(detachedComments).end})}}return currentDetachedCommentInfo}function writeCommentRange(text,lineMap,writer,comment,newLine){
if(42===text.charCodeAt(comment.pos+1))for(var firstCommentLineAndCharacter=ts.computeLineAndCharacterOfPosition(lineMap,comment.pos),lineCount=lineMap.length,firstCommentLineIndent=void 0,pos=comment.pos,currentLine=firstCommentLineAndCharacter.line;pos<comment.end;currentLine++){var nextLineStart=currentLine+1===lineCount?text.length+1:lineMap[currentLine+1];if(pos!==comment.pos){void 0===firstCommentLineIndent&&(firstCommentLineIndent=calculateIndent(text,lineMap[firstCommentLineAndCharacter.line],comment.pos));var currentWriterIndentSpacing=writer.getIndent()*getIndentSize(),spacesToEmit=currentWriterIndentSpacing-firstCommentLineIndent+calculateIndent(text,pos,nextLineStart);if(spacesToEmit>0){var numberOfSingleSpacesToEmit=spacesToEmit%getIndentSize(),indentSizeSpaceString=getIndentString((spacesToEmit-numberOfSingleSpacesToEmit)/getIndentSize());for(writer.rawWrite(indentSizeSpaceString);numberOfSingleSpacesToEmit;)writer.rawWrite(" "),numberOfSingleSpacesToEmit--}else writer.rawWrite("")}writeTrimmedCurrentLine(text,comment,writer,newLine,pos,nextLineStart),pos=nextLineStart}else writer.write(text.substring(comment.pos,comment.end))}function writeTrimmedCurrentLine(text,comment,writer,newLine,pos,nextLineStart){var end=Math.min(comment.end,nextLineStart-1),currentLineText=text.substring(pos,end).replace(/^\s+|\s+$/g,"");currentLineText?(writer.write(currentLineText),end!==comment.end&&writer.writeLine()):writer.writeLiteral(newLine)}function calculateIndent(text,pos,end){for(var currentLineIndent=0;pos<end&&ts.isWhiteSpace(text.charCodeAt(pos));pos++)9===text.charCodeAt(pos)?currentLineIndent+=getIndentSize()-currentLineIndent%getIndentSize():currentLineIndent++;return currentLineIndent}function modifierToFlag(token){switch(token){case 113:return 64;case 112:return 8;case 111:return 32;case 110:return 16;case 115:return 128;case 82:return 2;case 122:return 4;case 74:return 16384;case 77:return 512;case 118:return 256}return 0}function isLeftHandSideExpression(expr){if(expr)switch(expr.kind){case 169:case 170:case 172:case 171:case 236:case 237:case 173:case 167:case 175:case 168:case 189:case 176:case 69:case 10:case 8:case 9:case 11:case 186:case 84:case 93:case 97:case 99:case 95:return!0}return!1}function isAssignmentOperator(token){return token>=56&&token<=68}function isExpressionWithTypeArgumentsInClassExtendsClause(node){return 191===node.kind&&83===node.parent.token&&isClassLike(node.parent.parent)}function isSupportedExpressionWithTypeArguments(node){return isSupportedExpressionWithTypeArgumentsRest(node.expression)}function isSupportedExpressionWithTypeArgumentsRest(node){return 69===node.kind||!!isPropertyAccessExpression(node)&&isSupportedExpressionWithTypeArgumentsRest(node.expression)}function isRightSideOfQualifiedNameOrPropertyAccess(node){return 136===node.parent.kind&&node.parent.right===node||169===node.parent.kind&&node.parent.name===node}function isEmptyObjectLiteralOrArrayLiteral(expression){var kind=expression.kind;return 168===kind?0===expression.properties.length:167===kind&&0===expression.elements.length}function getLocalSymbolForExportDefault(symbol){return symbol&&symbol.valueDeclaration&&512&symbol.valueDeclaration.flags?symbol.valueDeclaration.localSymbol:void 0}function hasJavaScriptFileExtension(fileName){return ts.forEach(ts.supportedJavascriptExtensions,function(extension){return ts.fileExtensionIs(fileName,extension)})}function getExpandedCharCodes(input){for(var output=[],length=input.length,i=0;i<length;i++){var charCode=input.charCodeAt(i);charCode<128?output.push(charCode):charCode<2048?(output.push(charCode>>6|192),output.push(63&charCode|128)):charCode<65536?(output.push(charCode>>12|224),output.push(charCode>>6&63|128),output.push(63&charCode|128)):charCode<131072?(output.push(charCode>>18|240),output.push(charCode>>12&63|128),output.push(charCode>>6&63|128),output.push(63&charCode|128)):ts.Debug.assert(!1,"Unexpected code point")}return output}function stringifyFallback(value){return void 0===value?void 0:stringifyValue(value)}function stringifyValue(value){return"string"==typeof value?'"'+escapeString(value)+'"':"number"==typeof value?isFinite(value)?String(value):"null":"boolean"==typeof value?value?"true":"false":"object"==typeof value&&value?ts.isArray(value)?cycleCheck(stringifyArray,value):cycleCheck(stringifyObject,value):"null"}function cycleCheck(cb,value){ts.Debug.assert(!value.hasOwnProperty("__cycle"),"Converting circular structure to JSON"),value.__cycle=!0;var result=cb(value);return delete value.__cycle,result}function stringifyArray(value){return"["+ts.reduceLeft(value,stringifyElement,"")+"]"}function stringifyElement(memo,value){return(memo?memo+",":memo)+stringifyValue(value)}function stringifyObject(value){return"{"+ts.reduceProperties(value,stringifyProperty,"")+"}"}function stringifyProperty(memo,value,key){return void 0===value||"function"==typeof value||"__cycle"===key?memo:(memo?memo+",":memo)+('"'+escapeString(key)+'":'+stringifyValue(value))}function convertToBase64(input){for(var byte1,byte2,byte3,byte4,result="",charCodes=getExpandedCharCodes(input),i=0,length=charCodes.length;i<length;)byte1=charCodes[i]>>2,byte2=(3&charCodes[i])<<4|charCodes[i+1]>>4,byte3=(15&charCodes[i+1])<<2|charCodes[i+2]>>6,byte4=63&charCodes[i+2],i+1>=length?byte3=byte4=64:i+2>=length&&(byte4=64),result+=base64Digits.charAt(byte1)+base64Digits.charAt(byte2)+base64Digits.charAt(byte3)+base64Digits.charAt(byte4),i+=3;return result}function convertToRelativePath(absoluteOrRelativePath,basePath,getCanonicalFileName){return ts.isRootedDiskPath(absoluteOrRelativePath)?ts.getRelativePathToDirectoryOrUrl(basePath,absoluteOrRelativePath,basePath,getCanonicalFileName,!1):absoluteOrRelativePath}function getNewLineCharacter(options){return 0===options.newLine?carriageReturnLineFeed:1===options.newLine?lineFeed:ts.sys?ts.sys.newLine:carriageReturnLineFeed}ts.getDeclarationOfKind=getDeclarationOfKind;var stringWriters=[];ts.getSingleLineStringWriter=getSingleLineStringWriter,ts.releaseStringWriter=releaseStringWriter,ts.getFullWidth=getFullWidth,ts.arrayIsEqualTo=arrayIsEqualTo,ts.hasResolvedModule=hasResolvedModule,ts.getResolvedModule=getResolvedModule,ts.setResolvedModule=setResolvedModule,ts.containsParseError=containsParseError,ts.getSourceFileOfNode=getSourceFileOfNode,ts.isStatementWithLocals=isStatementWithLocals,ts.getStartPositionOfLine=getStartPositionOfLine,ts.nodePosToString=nodePosToString,ts.getStartPosOfNode=getStartPosOfNode,ts.nodeIsMissing=nodeIsMissing,ts.nodeIsPresent=nodeIsPresent,ts.getTokenPosOfNode=getTokenPosOfNode,ts.getNonDecoratorTokenPosOfNode=getNonDecoratorTokenPosOfNode,ts.getSourceTextOfNodeFromSourceFile=getSourceTextOfNodeFromSourceFile,ts.getTextOfNodeFromSourceText=getTextOfNodeFromSourceText,ts.getTextOfNode=getTextOfNode,ts.escapeIdentifier=escapeIdentifier,ts.unescapeIdentifier=unescapeIdentifier,ts.makeIdentifierFromModuleName=makeIdentifierFromModuleName,ts.isBlockOrCatchScoped=isBlockOrCatchScoped,ts.isAmbientModule=isAmbientModule,ts.isBlockScopedContainerTopLevel=isBlockScopedContainerTopLevel,ts.isGlobalScopeAugmentation=isGlobalScopeAugmentation,ts.isExternalModuleAugmentation=isExternalModuleAugmentation,ts.getEnclosingBlockScopeContainer=getEnclosingBlockScopeContainer,ts.isCatchClauseVariableDeclaration=isCatchClauseVariableDeclaration,ts.declarationNameToString=declarationNameToString,ts.createDiagnosticForNode=createDiagnosticForNode,ts.createDiagnosticForNodeFromMessageChain=createDiagnosticForNodeFromMessageChain,ts.getSpanOfTokenAtPosition=getSpanOfTokenAtPosition,ts.getErrorSpanForNode=getErrorSpanForNode,ts.isExternalModule=isExternalModule,ts.isExternalOrCommonJsModule=isExternalOrCommonJsModule,ts.isDeclarationFile=isDeclarationFile,ts.isConstEnumDeclaration=isConstEnumDeclaration,ts.getCombinedNodeFlags=getCombinedNodeFlags,ts.isConst=isConst,ts.isLet=isLet,ts.isSuperCallExpression=isSuperCallExpression,ts.isPrologueDirective=isPrologueDirective,ts.getLeadingCommentRangesOfNode=getLeadingCommentRangesOfNode,ts.getLeadingCommentRangesOfNodeFromText=getLeadingCommentRangesOfNodeFromText,ts.getJsDocComments=getJsDocComments,ts.getJsDocCommentsFromText=getJsDocCommentsFromText,ts.fullTripleSlashReferencePathRegEx=/^(\/\/\/\s*<reference\s+path\s*=\s*)('|")(.+?)\2.*?\/>/,ts.fullTripleSlashAMDReferencePathRegEx=/^(\/\/\/\s*<amd-dependency\s+path\s*=\s*)('|")(.+?)\2.*?\/>/,ts.isTypeNode=isTypeNode,ts.forEachReturnStatement=forEachReturnStatement,ts.forEachYieldExpression=forEachYieldExpression,ts.isVariableLike=isVariableLike,ts.isAccessor=isAccessor,ts.isClassLike=isClassLike,ts.isFunctionLike=isFunctionLike,ts.isFunctionLikeKind=isFunctionLikeKind,ts.introducesArgumentsExoticObject=introducesArgumentsExoticObject,ts.isIterationStatement=isIterationStatement,ts.isFunctionBlock=isFunctionBlock,ts.isObjectLiteralMethod=isObjectLiteralMethod,ts.isIdentifierTypePredicate=isIdentifierTypePredicate,ts.isThisTypePredicate=isThisTypePredicate,ts.getContainingFunction=getContainingFunction,ts.getContainingClass=getContainingClass,ts.getThisContainer=getThisContainer,ts.getSuperContainer=getSuperContainer,ts.isSuperPropertyOrElementAccess=isSuperPropertyOrElementAccess,ts.getEntityNameFromTypeNode=getEntityNameFromTypeNode,ts.getInvokedExpression=getInvokedExpression,ts.nodeCanBeDecorated=nodeCanBeDecorated,ts.nodeIsDecorated=nodeIsDecorated,ts.isPropertyAccessExpression=isPropertyAccessExpression,ts.isElementAccessExpression=isElementAccessExpression,ts.isExpression=isExpression,ts.isExternalModuleNameRelative=isExternalModuleNameRelative,ts.isInstantiatedModule=isInstantiatedModule,ts.isExternalModuleImportEqualsDeclaration=isExternalModuleImportEqualsDeclaration,ts.getExternalModuleImportEqualsDeclarationExpression=getExternalModuleImportEqualsDeclarationExpression,ts.isInternalModuleImportEqualsDeclaration=isInternalModuleImportEqualsDeclaration,ts.isSourceFileJavaScript=isSourceFileJavaScript,ts.isInJavaScriptFile=isInJavaScriptFile,ts.isRequireCall=isRequireCall,ts.getSpecialPropertyAssignmentKind=getSpecialPropertyAssignmentKind,ts.getExternalModuleName=getExternalModuleName,ts.hasQuestionToken=hasQuestionToken,ts.isJSDocConstructSignature=isJSDocConstructSignature,ts.getJSDocTypeTag=getJSDocTypeTag,ts.getJSDocReturnTag=getJSDocReturnTag,ts.getJSDocTemplateTag=getJSDocTemplateTag,ts.getCorrespondingJSDocParameterTag=getCorrespondingJSDocParameterTag,ts.hasRestParameter=hasRestParameter,ts.isRestParameter=isRestParameter,ts.isLiteralKind=isLiteralKind,ts.isTextualLiteralKind=isTextualLiteralKind,ts.isTemplateLiteralKind=isTemplateLiteralKind,ts.isBindingPattern=isBindingPattern,ts.isNodeDescendentOf=isNodeDescendentOf,ts.isInAmbientContext=isInAmbientContext,ts.isDeclaration=isDeclaration,ts.isStatement=isStatement,ts.isClassElement=isClassElement,ts.isDeclarationName=isDeclarationName,ts.isIdentifierName=isIdentifierName,ts.isAliasSymbolDeclaration=isAliasSymbolDeclaration,ts.getClassExtendsHeritageClauseElement=getClassExtendsHeritageClauseElement,ts.getClassImplementsHeritageClauseElements=getClassImplementsHeritageClauseElements,ts.getInterfaceBaseTypeNodes=getInterfaceBaseTypeNodes,ts.getHeritageClause=getHeritageClause,ts.tryResolveScriptReference=tryResolveScriptReference,ts.getAncestor=getAncestor,ts.getFileReferenceFromReferencePath=getFileReferenceFromReferencePath,ts.isKeyword=isKeyword,ts.isTrivia=isTrivia,ts.isAsyncFunctionLike=isAsyncFunctionLike,ts.isStringOrNumericLiteral=isStringOrNumericLiteral,ts.hasDynamicName=hasDynamicName,ts.isDynamicName=isDynamicName,ts.isWellKnownSymbolSyntactically=isWellKnownSymbolSyntactically,ts.getPropertyNameForPropertyNameNode=getPropertyNameForPropertyNameNode,ts.getPropertyNameForKnownSymbolName=getPropertyNameForKnownSymbolName,ts.isESSymbolIdentifier=isESSymbolIdentifier,ts.isModifierKind=isModifierKind,ts.isParameterDeclaration=isParameterDeclaration,ts.getRootDeclaration=getRootDeclaration,ts.nodeStartsNewLexicalEnvironment=nodeStartsNewLexicalEnvironment,ts.cloneNode=cloneNode,ts.cloneEntityName=cloneEntityName,ts.isQualifiedName=isQualifiedName,ts.nodeIsSynthesized=nodeIsSynthesized,ts.createSynthesizedNode=createSynthesizedNode,ts.createSynthesizedNodeArray=createSynthesizedNodeArray,ts.createDiagnosticCollection=createDiagnosticCollection;var escapedCharsRegExp=/[\\\"\u0000-\u001f\t\v\f\b\r\n\u2028\u2029\u0085]/g,escapedCharsMap={"\0":"\\0","\t":"\\t","\v":"\\v","\f":"\\f","\b":"\\b","\r":"\\r","\n":"\\n","\\":"\\\\",'"':'\\"',"\u2028":"\\u2028","\u2029":"\\u2029","":"\\u0085"};ts.escapeString=escapeString,ts.isIntrinsicJsxName=isIntrinsicJsxName;var nonAsciiCharacters=/[^\u0000-\u007F]/g;ts.escapeNonAsciiCharacters=escapeNonAsciiCharacters;var indentStrings=["","    "];ts.getIndentString=getIndentString,ts.getIndentSize=getIndentSize,ts.createTextWriter=createTextWriter,ts.getExternalModuleNameFromPath=getExternalModuleNameFromPath,ts.getOwnEmitOutputFilePath=getOwnEmitOutputFilePath,ts.getEmitScriptTarget=getEmitScriptTarget,ts.getEmitModuleKind=getEmitModuleKind,ts.forEachExpectedEmitFile=forEachExpectedEmitFile,ts.getSourceFilePathInNewDir=getSourceFilePathInNewDir,ts.writeFile=writeFile,ts.getLineOfLocalPosition=getLineOfLocalPosition,ts.getLineOfLocalPositionFromLineMap=getLineOfLocalPositionFromLineMap,ts.getFirstConstructorWithBody=getFirstConstructorWithBody,ts.getSetAccessorTypeAnnotationNode=getSetAccessorTypeAnnotationNode,ts.getAllAccessorDeclarations=getAllAccessorDeclarations,ts.emitNewLineBeforeLeadingComments=emitNewLineBeforeLeadingComments,ts.emitComments=emitComments,ts.emitDetachedComments=emitDetachedComments,ts.writeCommentRange=writeCommentRange,ts.modifierToFlag=modifierToFlag,ts.isLeftHandSideExpression=isLeftHandSideExpression,ts.isAssignmentOperator=isAssignmentOperator,ts.isExpressionWithTypeArgumentsInClassExtendsClause=isExpressionWithTypeArgumentsInClassExtendsClause,ts.isSupportedExpressionWithTypeArguments=isSupportedExpressionWithTypeArguments,ts.isRightSideOfQualifiedNameOrPropertyAccess=isRightSideOfQualifiedNameOrPropertyAccess,ts.isEmptyObjectLiteralOrArrayLiteral=isEmptyObjectLiteralOrArrayLiteral,ts.getLocalSymbolForExportDefault=getLocalSymbolForExportDefault,ts.hasJavaScriptFileExtension=hasJavaScriptFileExtension,ts.stringify="undefined"!=typeof JSON&&JSON.stringify?JSON.stringify:stringifyFallback;var base64Digits="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";ts.convertToBase64=convertToBase64,ts.convertToRelativePath=convertToRelativePath;var carriageReturnLineFeed="\r\n",lineFeed="\n";ts.getNewLineCharacter=getNewLineCharacter}(ts||(ts={}));var ts;!function(ts){function getDefaultLibFileName(options){return 2===options.target?"lib.es6.d.ts":"lib.d.ts"}function textSpanEnd(span){return span.start+span.length}function textSpanIsEmpty(span){return 0===span.length}function textSpanContainsPosition(span,position){return position>=span.start&&position<textSpanEnd(span)}function textSpanContainsTextSpan(span,other){return other.start>=span.start&&textSpanEnd(other)<=textSpanEnd(span)}function textSpanOverlapsWith(span,other){var overlapStart=Math.max(span.start,other.start),overlapEnd=Math.min(textSpanEnd(span),textSpanEnd(other));return overlapStart<overlapEnd}function textSpanOverlap(span1,span2){var overlapStart=Math.max(span1.start,span2.start),overlapEnd=Math.min(textSpanEnd(span1),textSpanEnd(span2));if(overlapStart<overlapEnd)return createTextSpanFromBounds(overlapStart,overlapEnd)}function textSpanIntersectsWithTextSpan(span,other){return other.start<=textSpanEnd(span)&&textSpanEnd(other)>=span.start}function textSpanIntersectsWith(span,start,length){var end=start+length;return start<=textSpanEnd(span)&&end>=span.start}function decodedTextSpanIntersectsWith(start1,length1,start2,length2){var end1=start1+length1,end2=start2+length2;return start2<=end1&&end2>=start1}function textSpanIntersectsWithPosition(span,position){return position<=textSpanEnd(span)&&position>=span.start}function textSpanIntersection(span1,span2){var intersectStart=Math.max(span1.start,span2.start),intersectEnd=Math.min(textSpanEnd(span1),textSpanEnd(span2));if(intersectStart<=intersectEnd)return createTextSpanFromBounds(intersectStart,intersectEnd)}function createTextSpan(start,length){if(start<0)throw new Error("start < 0");if(length<0)throw new Error("length < 0");return{start:start,length:length}}function createTextSpanFromBounds(start,end){return createTextSpan(start,end-start)}function textChangeRangeNewSpan(range){return createTextSpan(range.span.start,range.newLength)}function textChangeRangeIsUnchanged(range){return textSpanIsEmpty(range.span)&&0===range.newLength}function createTextChangeRange(span,newLength){if(newLength<0)throw new Error("newLength < 0");return{span:span,newLength:newLength}}function collapseTextChangeRangesAcrossMultipleVersions(changes){if(0===changes.length)return ts.unchangedTextChangeRange;if(1===changes.length)return changes[0];for(var change0=changes[0],oldStartN=change0.span.start,oldEndN=textSpanEnd(change0.span),newEndN=oldStartN+change0.newLength,i=1;i<changes.length;i++){var nextChange=changes[i],oldStart1=oldStartN,oldEnd1=oldEndN,newEnd1=newEndN,oldStart2=nextChange.span.start,oldEnd2=textSpanEnd(nextChange.span),newEnd2=oldStart2+nextChange.newLength;oldStartN=Math.min(oldStart1,oldStart2),oldEndN=Math.max(oldEnd1,oldEnd1+(oldEnd2-newEnd1)),newEndN=Math.max(newEnd2,newEnd2+(newEnd1-oldEnd2))}return createTextChangeRange(createTextSpanFromBounds(oldStartN,oldEndN),newEndN-oldStartN)}function getTypeParameterOwner(d){if(d&&138===d.kind)for(var current=d;current;current=current.parent)if(ts.isFunctionLike(current)||ts.isClassLike(current)||218===current.kind)return current}function isParameterPropertyDeclaration(node){return 56&node.flags&&145===node.parent.kind&&ts.isClassLike(node.parent.parent)}ts.getDefaultLibFileName=getDefaultLibFileName,ts.textSpanEnd=textSpanEnd,ts.textSpanIsEmpty=textSpanIsEmpty,ts.textSpanContainsPosition=textSpanContainsPosition,ts.textSpanContainsTextSpan=textSpanContainsTextSpan,ts.textSpanOverlapsWith=textSpanOverlapsWith,ts.textSpanOverlap=textSpanOverlap,ts.textSpanIntersectsWithTextSpan=textSpanIntersectsWithTextSpan,ts.textSpanIntersectsWith=textSpanIntersectsWith,ts.decodedTextSpanIntersectsWith=decodedTextSpanIntersectsWith,ts.textSpanIntersectsWithPosition=textSpanIntersectsWithPosition,ts.textSpanIntersection=textSpanIntersection,ts.createTextSpan=createTextSpan,ts.createTextSpanFromBounds=createTextSpanFromBounds,ts.textChangeRangeNewSpan=textChangeRangeNewSpan,ts.textChangeRangeIsUnchanged=textChangeRangeIsUnchanged,ts.createTextChangeRange=createTextChangeRange,ts.unchangedTextChangeRange=createTextChangeRange(createTextSpan(0,0),0),ts.collapseTextChangeRangesAcrossMultipleVersions=collapseTextChangeRangesAcrossMultipleVersions,ts.getTypeParameterOwner=getTypeParameterOwner,ts.isParameterPropertyDeclaration=isParameterPropertyDeclaration}(ts||(ts={}));var ts;!function(ts){function createNode(kind,pos,end){return 251===kind?new(SourceFileConstructor||(SourceFileConstructor=ts.objectAllocator.getSourceFileConstructor()))(kind,pos,end):new(NodeConstructor||(NodeConstructor=ts.objectAllocator.getNodeConstructor()))(kind,pos,end)}function visitNode(cbNode,node){if(node)return cbNode(node)}function visitNodeArray(cbNodes,nodes){if(nodes)return cbNodes(nodes)}function visitEachNode(cbNode,nodes){if(nodes)for(var _i=0,nodes_1=nodes;_i<nodes_1.length;_i++){var node=nodes_1[_i],result=cbNode(node);if(result)return result}}function forEachChild(node,cbNode,cbNodeArray){if(node){var visitNodes=cbNodeArray?visitNodeArray:visitEachNode,cbNodes=cbNodeArray||cbNode;switch(node.kind){case 136:return visitNode(cbNode,node.left)||visitNode(cbNode,node.right);case 138:return visitNode(cbNode,node.name)||visitNode(cbNode,node.constraint)||visitNode(cbNode,node.expression);case 249:return visitNodes(cbNodes,node.decorators)||visitNodes(cbNodes,node.modifiers)||visitNode(cbNode,node.name)||visitNode(cbNode,node.questionToken)||visitNode(cbNode,node.equalsToken)||visitNode(cbNode,node.objectAssignmentInitializer);case 139:case 142:case 141:case 248:case 214:case 166:return visitNodes(cbNodes,node.decorators)||visitNodes(cbNodes,node.modifiers)||visitNode(cbNode,node.propertyName)||visitNode(cbNode,node.dotDotDotToken)||visitNode(cbNode,node.name)||visitNode(cbNode,node.questionToken)||visitNode(cbNode,node.type)||visitNode(cbNode,node.initializer);case 153:case 154:case 148:case 149:case 150:return visitNodes(cbNodes,node.decorators)||visitNodes(cbNodes,node.modifiers)||visitNodes(cbNodes,node.typeParameters)||visitNodes(cbNodes,node.parameters)||visitNode(cbNode,node.type);case 144:case 143:case 145:case 146:case 147:case 176:case 216:case 177:return visitNodes(cbNodes,node.decorators)||visitNodes(cbNodes,node.modifiers)||visitNode(cbNode,node.asteriskToken)||visitNode(cbNode,node.name)||visitNode(cbNode,node.questionToken)||visitNodes(cbNodes,node.typeParameters)||visitNodes(cbNodes,node.parameters)||visitNode(cbNode,node.type)||visitNode(cbNode,node.equalsGreaterThanToken)||visitNode(cbNode,node.body);case 152:return visitNode(cbNode,node.typeName)||visitNodes(cbNodes,node.typeArguments);case 151:return visitNode(cbNode,node.parameterName)||visitNode(cbNode,node.type);case 155:return visitNode(cbNode,node.exprName);case 156:return visitNodes(cbNodes,node.members);case 157:return visitNode(cbNode,node.elementType);case 158:return visitNodes(cbNodes,node.elementTypes);case 159:case 160:return visitNodes(cbNodes,node.types);case 161:return visitNode(cbNode,node.type);case 164:case 165:return visitNodes(cbNodes,node.elements);case 167:return visitNodes(cbNodes,node.elements);case 168:return visitNodes(cbNodes,node.properties);case 169:return visitNode(cbNode,node.expression)||visitNode(cbNode,node.dotToken)||visitNode(cbNode,node.name);case 170:return visitNode(cbNode,node.expression)||visitNode(cbNode,node.argumentExpression);case 171:case 172:return visitNode(cbNode,node.expression)||visitNodes(cbNodes,node.typeArguments)||visitNodes(cbNodes,node.arguments);case 173:return visitNode(cbNode,node.tag)||visitNode(cbNode,node.template);case 174:return visitNode(cbNode,node.type)||visitNode(cbNode,node.expression);case 175:return visitNode(cbNode,node.expression);case 178:return visitNode(cbNode,node.expression);case 179:return visitNode(cbNode,node.expression);case 180:return visitNode(cbNode,node.expression);case 182:return visitNode(cbNode,node.operand);case 187:return visitNode(cbNode,node.asteriskToken)||visitNode(cbNode,node.expression);case 181:return visitNode(cbNode,node.expression);case 183:return visitNode(cbNode,node.operand);case 184:return visitNode(cbNode,node.left)||visitNode(cbNode,node.operatorToken)||visitNode(cbNode,node.right);case 192:return visitNode(cbNode,node.expression)||visitNode(cbNode,node.type);case 185:return visitNode(cbNode,node.condition)||visitNode(cbNode,node.questionToken)||visitNode(cbNode,node.whenTrue)||visitNode(cbNode,node.colonToken)||visitNode(cbNode,node.whenFalse);case 188:return visitNode(cbNode,node.expression);case 195:case 222:return visitNodes(cbNodes,node.statements);case 251:return visitNodes(cbNodes,node.statements)||visitNode(cbNode,node.endOfFileToken);case 196:return visitNodes(cbNodes,node.decorators)||visitNodes(cbNodes,node.modifiers)||visitNode(cbNode,node.declarationList);case 215:return visitNodes(cbNodes,node.declarations);case 198:return visitNode(cbNode,node.expression);case 199:return visitNode(cbNode,node.expression)||visitNode(cbNode,node.thenStatement)||visitNode(cbNode,node.elseStatement);case 200:return visitNode(cbNode,node.statement)||visitNode(cbNode,node.expression);case 201:return visitNode(cbNode,node.expression)||visitNode(cbNode,node.statement);case 202:return visitNode(cbNode,node.initializer)||visitNode(cbNode,node.condition)||visitNode(cbNode,node.incrementor)||visitNode(cbNode,node.statement);case 203:return visitNode(cbNode,node.initializer)||visitNode(cbNode,node.expression)||visitNode(cbNode,node.statement);case 204:return visitNode(cbNode,node.initializer)||visitNode(cbNode,node.expression)||visitNode(cbNode,node.statement);case 205:case 206:return visitNode(cbNode,node.label);case 207:return visitNode(cbNode,node.expression);case 208:return visitNode(cbNode,node.expression)||visitNode(cbNode,node.statement);case 209:return visitNode(cbNode,node.expression)||visitNode(cbNode,node.caseBlock);case 223:return visitNodes(cbNodes,node.clauses);case 244:return visitNode(cbNode,node.expression)||visitNodes(cbNodes,node.statements);case 245:return visitNodes(cbNodes,node.statements);case 210:return visitNode(cbNode,node.label)||visitNode(cbNode,node.statement);case 211:return visitNode(cbNode,node.expression);case 212:return visitNode(cbNode,node.tryBlock)||visitNode(cbNode,node.catchClause)||visitNode(cbNode,node.finallyBlock);case 247:return visitNode(cbNode,node.variableDeclaration)||visitNode(cbNode,node.block);case 140:return visitNode(cbNode,node.expression);case 217:case 189:return visitNodes(cbNodes,node.decorators)||visitNodes(cbNodes,node.modifiers)||visitNode(cbNode,node.name)||visitNodes(cbNodes,node.typeParameters)||visitNodes(cbNodes,node.heritageClauses)||visitNodes(cbNodes,node.members);case 218:return visitNodes(cbNodes,node.decorators)||visitNodes(cbNodes,node.modifiers)||visitNode(cbNode,node.name)||visitNodes(cbNodes,node.typeParameters)||visitNodes(cbNodes,node.heritageClauses)||visitNodes(cbNodes,node.members);case 219:return visitNodes(cbNodes,node.decorators)||visitNodes(cbNodes,node.modifiers)||visitNode(cbNode,node.name)||visitNodes(cbNodes,node.typeParameters)||visitNode(cbNode,node.type);case 220:return visitNodes(cbNodes,node.decorators)||visitNodes(cbNodes,node.modifiers)||visitNode(cbNode,node.name)||visitNodes(cbNodes,node.members);case 250:return visitNode(cbNode,node.name)||visitNode(cbNode,node.initializer);case 221:return visitNodes(cbNodes,node.decorators)||visitNodes(cbNodes,node.modifiers)||visitNode(cbNode,node.name)||visitNode(cbNode,node.body);case 224:return visitNodes(cbNodes,node.decorators)||visitNodes(cbNodes,node.modifiers)||visitNode(cbNode,node.name)||visitNode(cbNode,node.moduleReference);case 225:return visitNodes(cbNodes,node.decorators)||visitNodes(cbNodes,node.modifiers)||visitNode(cbNode,node.importClause)||visitNode(cbNode,node.moduleSpecifier);case 226:return visitNode(cbNode,node.name)||visitNode(cbNode,node.namedBindings);case 227:return visitNode(cbNode,node.name);case 228:case 232:return visitNodes(cbNodes,node.elements);case 231:return visitNodes(cbNodes,node.decorators)||visitNodes(cbNodes,node.modifiers)||visitNode(cbNode,node.exportClause)||visitNode(cbNode,node.moduleSpecifier);case 229:case 233:return visitNode(cbNode,node.propertyName)||visitNode(cbNode,node.name);case 230:return visitNodes(cbNodes,node.decorators)||visitNodes(cbNodes,node.modifiers)||visitNode(cbNode,node.expression);case 186:return visitNode(cbNode,node.head)||visitNodes(cbNodes,node.templateSpans);case 193:return visitNode(cbNode,node.expression)||visitNode(cbNode,node.literal);case 137:return visitNode(cbNode,node.expression);case 246:return visitNodes(cbNodes,node.types);case 191:return visitNode(cbNode,node.expression)||visitNodes(cbNodes,node.typeArguments);case 235:return visitNode(cbNode,node.expression);case 234:return visitNodes(cbNodes,node.decorators);case 236:return visitNode(cbNode,node.openingElement)||visitNodes(cbNodes,node.children)||visitNode(cbNode,node.closingElement);case 237:case 238:return visitNode(cbNode,node.tagName)||visitNodes(cbNodes,node.attributes);case 241:return visitNode(cbNode,node.name)||visitNode(cbNode,node.initializer);case 242:return visitNode(cbNode,node.expression);case 243:return visitNode(cbNode,node.expression);case 240:return visitNode(cbNode,node.tagName);case 252:return visitNode(cbNode,node.type);case 256:return visitNodes(cbNodes,node.types);case 257:return visitNodes(cbNodes,node.types);case 255:return visitNode(cbNode,node.elementType);case 259:return visitNode(cbNode,node.type);case 258:return visitNode(cbNode,node.type);case 260:return visitNodes(cbNodes,node.members);case 262:return visitNode(cbNode,node.name)||visitNodes(cbNodes,node.typeArguments);case 263:return visitNode(cbNode,node.type);case 264:return visitNodes(cbNodes,node.parameters)||visitNode(cbNode,node.type);case 265:return visitNode(cbNode,node.type);case 266:return visitNode(cbNode,node.type);case 267:return visitNode(cbNode,node.type);case 261:return visitNode(cbNode,node.name)||visitNode(cbNode,node.type);case 268:return visitNodes(cbNodes,node.tags);case 270:return visitNode(cbNode,node.preParameterName)||visitNode(cbNode,node.typeExpression)||visitNode(cbNode,node.postParameterName);case 271:return visitNode(cbNode,node.typeExpression);case 272:return visitNode(cbNode,node.typeExpression);case 273:return visitNodes(cbNodes,node.typeParameters)}}}function createSourceFile(fileName,sourceText,languageVersion,setParentNodes){void 0===setParentNodes&&(setParentNodes=!1);var start=(new Date).getTime(),result=Parser.parseSourceFile(fileName,sourceText,languageVersion,void 0,setParentNodes);return ts.parseTime+=(new Date).getTime()-start,result}function updateSourceFile(sourceFile,newText,textChangeRange,aggressiveChecks){return IncrementalParser.updateSourceFile(sourceFile,newText,textChangeRange,aggressiveChecks)}function parseIsolatedJSDocComment(content,start,length){return Parser.JSDocParser.parseIsolatedJSDocComment(content,start,length)}function parseJSDocTypeExpressionForTests(content,start,length){return Parser.JSDocParser.parseJSDocTypeExpressionForTests(content,start,length)}ts.parseTime=0;var NodeConstructor,SourceFileConstructor;ts.createNode=createNode,ts.forEachChild=forEachChild,ts.createSourceFile=createSourceFile,ts.updateSourceFile=updateSourceFile,ts.parseIsolatedJSDocComment=parseIsolatedJSDocComment,ts.parseJSDocTypeExpressionForTests=parseJSDocTypeExpressionForTests;var Parser;!function(Parser){function parseSourceFile(fileName,_sourceText,languageVersion,_syntaxCursor,setParentNodes){var isJavaScriptFile=ts.hasJavaScriptFileExtension(fileName)||0===_sourceText.lastIndexOf("// @language=javascript",0);initializeState(fileName,_sourceText,languageVersion,isJavaScriptFile,_syntaxCursor);var result=parseSourceFileWorker(fileName,languageVersion,setParentNodes);return clearState(),result}function getLanguageVariant(fileName){return ts.fileExtensionIs(fileName,".tsx")||ts.fileExtensionIs(fileName,".jsx")||ts.fileExtensionIs(fileName,".js")?1:0}function initializeState(fileName,_sourceText,languageVersion,isJavaScriptFile,_syntaxCursor){NodeConstructor=ts.objectAllocator.getNodeConstructor(),SourceFileConstructor=ts.objectAllocator.getSourceFileConstructor(),sourceText=_sourceText,syntaxCursor=_syntaxCursor,parseDiagnostics=[],parsingContext=0,identifiers={},identifierCount=0,nodeCount=0,contextFlags=isJavaScriptFile?32:0,parseErrorBeforeNextFinishedNode=!1,scanner.setText(sourceText),scanner.setOnError(scanError),scanner.setScriptTarget(languageVersion),scanner.setLanguageVariant(getLanguageVariant(fileName))}function clearState(){scanner.setText(""),scanner.setOnError(void 0),parseDiagnostics=void 0,sourceFile=void 0,identifiers=void 0,syntaxCursor=void 0,sourceText=void 0}function parseSourceFileWorker(fileName,languageVersion,setParentNodes){return sourceFile=createSourceFile(fileName,languageVersion),32&contextFlags&&(sourceFile.parserContextFlags=32),token=nextToken(),processReferenceComments(sourceFile),sourceFile.statements=parseList(0,parseStatement),ts.Debug.assert(1===token),sourceFile.endOfFileToken=parseTokenNode(),setExternalModuleIndicator(sourceFile),sourceFile.nodeCount=nodeCount,sourceFile.identifierCount=identifierCount,sourceFile.identifiers=identifiers,sourceFile.parseDiagnostics=parseDiagnostics,setParentNodes&&fixupParentReferences(sourceFile),sourceFile}function addJSDocComment(node){
if(32&contextFlags){var comments=ts.getLeadingCommentRangesOfNode(node,sourceFile);if(comments)for(var _i=0,comments_1=comments;_i<comments_1.length;_i++){var comment=comments_1[_i],jsDocComment=JSDocParser.parseJSDocComment(node,comment.pos,comment.end-comment.pos);jsDocComment&&(node.jsDocComment=jsDocComment)}}return node}function fixupParentReferences(sourceFile){function visitNode(n){if(n.parent!==parent){n.parent=parent;var saveParent=parent;parent=n,forEachChild(n,visitNode),parent=saveParent}}var parent=sourceFile;forEachChild(sourceFile,visitNode)}function createSourceFile(fileName,languageVersion){var sourceFile=new SourceFileConstructor(251,0,sourceText.length);return nodeCount++,sourceFile.text=sourceText,sourceFile.bindDiagnostics=[],sourceFile.languageVersion=languageVersion,sourceFile.fileName=ts.normalizePath(fileName),sourceFile.flags=ts.fileExtensionIs(sourceFile.fileName,".d.ts")?4096:0,sourceFile.languageVariant=getLanguageVariant(sourceFile.fileName),sourceFile}function setContextFlag(val,flag){val?contextFlags|=flag:contextFlags&=~flag}function setDisallowInContext(val){setContextFlag(val,1)}function setYieldContext(val){setContextFlag(val,2)}function setDecoratorContext(val){setContextFlag(val,4)}function setAwaitContext(val){setContextFlag(val,8)}function doOutsideOfContext(context,func){var contextFlagsToClear=context&contextFlags;if(contextFlagsToClear){setContextFlag(!1,contextFlagsToClear);var result=func();return setContextFlag(!0,contextFlagsToClear),result}return func()}function doInsideOfContext(context,func){var contextFlagsToSet=context&~contextFlags;if(contextFlagsToSet){setContextFlag(!0,contextFlagsToSet);var result=func();return setContextFlag(!1,contextFlagsToSet),result}return func()}function allowInAnd(func){return doOutsideOfContext(1,func)}function disallowInAnd(func){return doInsideOfContext(1,func)}function doInYieldContext(func){return doInsideOfContext(2,func)}function doInDecoratorContext(func){return doInsideOfContext(4,func)}function doInAwaitContext(func){return doInsideOfContext(8,func)}function doOutsideOfAwaitContext(func){return doOutsideOfContext(8,func)}function doInYieldAndAwaitContext(func){return doInsideOfContext(10,func)}function inContext(flags){return 0!==(contextFlags&flags)}function inYieldContext(){return inContext(2)}function inDisallowInContext(){return inContext(1)}function inDecoratorContext(){return inContext(4)}function inAwaitContext(){return inContext(8)}function parseErrorAtCurrentToken(message,arg0){var start=scanner.getTokenPos(),length=scanner.getTextPos()-start;parseErrorAtPosition(start,length,message,arg0)}function parseErrorAtPosition(start,length,message,arg0){var lastError=ts.lastOrUndefined(parseDiagnostics);lastError&&start===lastError.start||parseDiagnostics.push(ts.createFileDiagnostic(sourceFile,start,length,message,arg0)),parseErrorBeforeNextFinishedNode=!0}function scanError(message,length){var pos=scanner.getTextPos();parseErrorAtPosition(pos,length||0,message)}function getNodePos(){return scanner.getStartPos()}function getNodeEnd(){return scanner.getStartPos()}function nextToken(){return token=scanner.scan()}function reScanGreaterToken(){return token=scanner.reScanGreaterToken()}function reScanSlashToken(){return token=scanner.reScanSlashToken()}function reScanTemplateToken(){return token=scanner.reScanTemplateToken()}function scanJsxIdentifier(){return token=scanner.scanJsxIdentifier()}function scanJsxText(){return token=scanner.scanJsxToken()}function speculationHelper(callback,isLookAhead){var saveToken=token,saveParseDiagnosticsLength=parseDiagnostics.length,saveParseErrorBeforeNextFinishedNode=parseErrorBeforeNextFinishedNode,saveContextFlags=contextFlags,result=isLookAhead?scanner.lookAhead(callback):scanner.tryScan(callback);return ts.Debug.assert(saveContextFlags===contextFlags),result&&!isLookAhead||(token=saveToken,parseDiagnostics.length=saveParseDiagnosticsLength,parseErrorBeforeNextFinishedNode=saveParseErrorBeforeNextFinishedNode),result}function lookAhead(callback){return speculationHelper(callback,!0)}function tryParse(callback){return speculationHelper(callback,!1)}function isIdentifier(){return 69===token||(114!==token||!inYieldContext())&&((119!==token||!inAwaitContext())&&token>105)}function parseExpected(kind,diagnosticMessage,shouldAdvance){return void 0===shouldAdvance&&(shouldAdvance=!0),token===kind?(shouldAdvance&&nextToken(),!0):(diagnosticMessage?parseErrorAtCurrentToken(diagnosticMessage):parseErrorAtCurrentToken(ts.Diagnostics._0_expected,ts.tokenToString(kind)),!1)}function parseOptional(t){return token===t&&(nextToken(),!0)}function parseOptionalToken(t){if(token===t)return parseTokenNode()}function parseExpectedToken(t,reportAtCurrentPosition,diagnosticMessage,arg0){return parseOptionalToken(t)||createMissingNode(t,reportAtCurrentPosition,diagnosticMessage,arg0)}function parseTokenNode(){var node=createNode(token);return nextToken(),finishNode(node)}function canParseSemicolon(){return 23===token||(16===token||1===token||scanner.hasPrecedingLineBreak())}function parseSemicolon(){return canParseSemicolon()?(23===token&&nextToken(),!0):parseExpected(23)}function createNode(kind,pos){return nodeCount++,pos>=0||(pos=scanner.getStartPos()),new NodeConstructor(kind,pos,pos)}function finishNode(node,end){return node.end=void 0===end?scanner.getStartPos():end,contextFlags&&(node.parserContextFlags=contextFlags),parseErrorBeforeNextFinishedNode&&(parseErrorBeforeNextFinishedNode=!1,node.parserContextFlags|=16),node}function createMissingNode(kind,reportAtCurrentPosition,diagnosticMessage,arg0){reportAtCurrentPosition?parseErrorAtPosition(scanner.getStartPos(),0,diagnosticMessage,arg0):parseErrorAtCurrentToken(diagnosticMessage,arg0);var result=createNode(kind,scanner.getStartPos());return result.text="",finishNode(result)}function internIdentifier(text){return text=ts.escapeIdentifier(text),ts.hasProperty(identifiers,text)?identifiers[text]:identifiers[text]=text}function createIdentifier(isIdentifier,diagnosticMessage){if(identifierCount++,isIdentifier){var node=createNode(69);return 69!==token&&(node.originalKeywordKind=token),node.text=internIdentifier(scanner.getTokenValue()),nextToken(),finishNode(node)}return createMissingNode(69,!1,diagnosticMessage||ts.Diagnostics.Identifier_expected)}function parseIdentifier(diagnosticMessage){return createIdentifier(isIdentifier(),diagnosticMessage)}function parseIdentifierName(){return createIdentifier(ts.tokenIsIdentifierOrKeyword(token))}function isLiteralPropertyName(){return ts.tokenIsIdentifierOrKeyword(token)||9===token||8===token}function parsePropertyNameWorker(allowComputedPropertyNames){return 9===token||8===token?parseLiteralNode(!0):allowComputedPropertyNames&&19===token?parseComputedPropertyName():parseIdentifierName()}function parsePropertyName(){return parsePropertyNameWorker(!0)}function parseSimplePropertyName(){return parsePropertyNameWorker(!1)}function isSimplePropertyName(){return 9===token||8===token||ts.tokenIsIdentifierOrKeyword(token)}function parseComputedPropertyName(){var node=createNode(137);return parseExpected(19),node.expression=allowInAnd(parseExpression),parseExpected(20),finishNode(node)}function parseContextualModifier(t){return token===t&&tryParse(nextTokenCanFollowModifier)}function nextTokenIsOnSameLineAndCanFollowModifier(){return nextToken(),!scanner.hasPrecedingLineBreak()&&canFollowModifier()}function nextTokenCanFollowModifier(){return 74===token?81===nextToken():82===token?(nextToken(),77===token?lookAhead(nextTokenIsClassOrFunction):37!==token&&15!==token&&canFollowModifier()):77===token?nextTokenIsClassOrFunction():113===token?(nextToken(),canFollowModifier()):nextTokenIsOnSameLineAndCanFollowModifier()}function parseAnyContextualModifier(){return ts.isModifierKind(token)&&tryParse(nextTokenCanFollowModifier)}function canFollowModifier(){return 19===token||15===token||37===token||isLiteralPropertyName()}function nextTokenIsClassOrFunction(){return nextToken(),73===token||87===token}function isListElement(parsingContext,inErrorRecovery){var node=currentNode(parsingContext);if(node)return!0;switch(parsingContext){case 0:case 1:case 3:return!(23===token&&inErrorRecovery)&&isStartOfStatement();case 2:return 71===token||77===token;case 4:return isStartOfTypeMember();case 5:return lookAhead(isClassMemberStart)||23===token&&!inErrorRecovery;case 6:return 19===token||isLiteralPropertyName();case 12:return 19===token||37===token||isLiteralPropertyName();case 9:return 19===token||isLiteralPropertyName();case 7:return 15===token?lookAhead(isValidHeritageClauseObjectLiteral):inErrorRecovery?isIdentifier()&&!isHeritageClauseExtendsOrImplementsKeyword():isStartOfLeftHandSideExpression()&&!isHeritageClauseExtendsOrImplementsKeyword();case 8:return isIdentifierOrPattern();case 10:return 24===token||22===token||isIdentifierOrPattern();case 17:return isIdentifier();case 11:case 15:return 24===token||22===token||isStartOfExpression();case 16:return isStartOfParameter();case 18:case 19:return 24===token||isStartOfType();case 20:return isHeritageClause();case 21:return ts.tokenIsIdentifierOrKeyword(token);case 13:return ts.tokenIsIdentifierOrKeyword(token)||15===token;case 14:return!0;case 22:case 23:case 25:return JSDocParser.isJSDocType();case 24:return isSimplePropertyName()}ts.Debug.fail("Non-exhaustive case in 'isListElement'.")}function isValidHeritageClauseObjectLiteral(){if(ts.Debug.assert(15===token),16===nextToken()){var next=nextToken();return 24===next||15===next||83===next||106===next}return!0}function nextTokenIsIdentifier(){return nextToken(),isIdentifier()}function nextTokenIsIdentifierOrKeyword(){return nextToken(),ts.tokenIsIdentifierOrKeyword(token)}function isHeritageClauseExtendsOrImplementsKeyword(){return(106===token||83===token)&&lookAhead(nextTokenIsStartOfExpression)}function nextTokenIsStartOfExpression(){return nextToken(),isStartOfExpression()}function isListTerminator(kind){if(1===token)return!0;switch(kind){case 1:case 2:case 4:case 5:case 6:case 12:case 9:case 21:return 16===token;case 3:return 16===token||71===token||77===token;case 7:return 15===token||83===token||106===token;case 8:return isVariableDeclaratorListTerminator();case 17:return 27===token||17===token||15===token||83===token||106===token;case 11:return 18===token||23===token;case 15:case 19:case 10:return 20===token;case 16:return 18===token||20===token;case 18:return 27===token||17===token;case 20:return 15===token||16===token;case 13:return 27===token||39===token;case 14:return 25===token&&lookAhead(nextTokenIsSlash);case 22:return 18===token||54===token||16===token;case 23:return 27===token||16===token;case 25:return 20===token||16===token;case 24:return 16===token}}function isVariableDeclaratorListTerminator(){return!!canParseSemicolon()||(!!isInOrOfKeyword(token)||34===token)}function isInSomeParsingContext(){for(var kind=0;kind<26;kind++)if(parsingContext&1<<kind&&(isListElement(kind,!0)||isListTerminator(kind)))return!0;return!1}function parseList(kind,parseElement){var saveParsingContext=parsingContext;parsingContext|=1<<kind;var result=[];for(result.pos=getNodePos();!isListTerminator(kind);)if(isListElement(kind,!1)){var element=parseListElement(kind,parseElement);result.push(element)}else if(abortParsingListOrMoveToNextToken(kind))break;return result.end=getNodeEnd(),parsingContext=saveParsingContext,result}function parseListElement(parsingContext,parseElement){var node=currentNode(parsingContext);return node?consumeNode(node):parseElement()}function currentNode(parsingContext){if(!parseErrorBeforeNextFinishedNode&&syntaxCursor){var node=syntaxCursor.currentNode(scanner.getStartPos());if(!ts.nodeIsMissing(node)&&!node.intersectsChange&&!ts.containsParseError(node)){var nodeContextFlags=31&node.parserContextFlags;if(nodeContextFlags===contextFlags&&canReuseNode(node,parsingContext))return node}}}function consumeNode(node){return scanner.setTextPos(node.end),nextToken(),node}function canReuseNode(node,parsingContext){switch(parsingContext){case 5:return isReusableClassMember(node);case 2:return isReusableSwitchClause(node);case 0:case 1:case 3:return isReusableStatement(node);case 6:return isReusableEnumMember(node);case 4:return isReusableTypeMember(node);case 8:return isReusableVariableDeclaration(node);case 16:return isReusableParameter(node);case 20:case 17:case 19:case 18:case 11:case 12:case 7:case 13:case 14:}return!1}function isReusableClassMember(node){if(node)switch(node.kind){case 145:case 150:case 146:case 147:case 142:case 194:return!0;case 144:var methodDeclaration=node,nameIsConstructor=69===methodDeclaration.name.kind&&121===methodDeclaration.name.originalKeywordKind;return!nameIsConstructor}return!1}function isReusableSwitchClause(node){if(node)switch(node.kind){case 244:case 245:return!0}return!1}function isReusableStatement(node){if(node)switch(node.kind){case 216:case 196:case 195:case 199:case 198:case 211:case 207:case 209:case 206:case 205:case 203:case 204:case 202:case 201:case 208:case 197:case 212:case 210:case 200:case 213:case 225:case 224:case 231:case 230:case 221:case 217:case 218:case 220:case 219:return!0}return!1}function isReusableEnumMember(node){return 250===node.kind}function isReusableTypeMember(node){if(node)switch(node.kind){case 149:case 143:case 150:case 141:case 148:return!0}return!1}function isReusableVariableDeclaration(node){if(214!==node.kind)return!1;var variableDeclarator=node;return void 0===variableDeclarator.initializer}function isReusableParameter(node){if(139!==node.kind)return!1;var parameter=node;return void 0===parameter.initializer}function abortParsingListOrMoveToNextToken(kind){return parseErrorAtCurrentToken(parsingContextErrors(kind)),!!isInSomeParsingContext()||(nextToken(),!1)}function parsingContextErrors(context){switch(context){case 0:return ts.Diagnostics.Declaration_or_statement_expected;case 1:return ts.Diagnostics.Declaration_or_statement_expected;case 2:return ts.Diagnostics.case_or_default_expected;case 3:return ts.Diagnostics.Statement_expected;case 4:return ts.Diagnostics.Property_or_signature_expected;case 5:return ts.Diagnostics.Unexpected_token_A_constructor_method_accessor_or_property_was_expected;case 6:return ts.Diagnostics.Enum_member_expected;case 7:return ts.Diagnostics.Expression_expected;case 8:return ts.Diagnostics.Variable_declaration_expected;case 9:return ts.Diagnostics.Property_destructuring_pattern_expected;case 10:return ts.Diagnostics.Array_element_destructuring_pattern_expected;case 11:return ts.Diagnostics.Argument_expression_expected;case 12:return ts.Diagnostics.Property_assignment_expected;case 15:return ts.Diagnostics.Expression_or_comma_expected;case 16:return ts.Diagnostics.Parameter_declaration_expected;case 17:return ts.Diagnostics.Type_parameter_declaration_expected;case 18:return ts.Diagnostics.Type_argument_expected;case 19:return ts.Diagnostics.Type_expected;case 20:return ts.Diagnostics.Unexpected_token_expected;case 21:return ts.Diagnostics.Identifier_expected;case 13:return ts.Diagnostics.Identifier_expected;case 14:return ts.Diagnostics.Identifier_expected;case 22:return ts.Diagnostics.Parameter_declaration_expected;case 23:return ts.Diagnostics.Type_argument_expected;case 25:return ts.Diagnostics.Type_expected;case 24:return ts.Diagnostics.Property_assignment_expected}}function parseDelimitedList(kind,parseElement,considerSemicolonAsDelimeter){var saveParsingContext=parsingContext;parsingContext|=1<<kind;var result=[];result.pos=getNodePos();for(var commaStart=-1;;)if(isListElement(kind,!1)){if(result.push(parseListElement(kind,parseElement)),commaStart=scanner.getTokenPos(),parseOptional(24))continue;if(commaStart=-1,isListTerminator(kind))break;parseExpected(24),considerSemicolonAsDelimeter&&23===token&&!scanner.hasPrecedingLineBreak()&&nextToken()}else{if(isListTerminator(kind))break;if(abortParsingListOrMoveToNextToken(kind))break}return commaStart>=0&&(result.hasTrailingComma=!0),result.end=getNodeEnd(),parsingContext=saveParsingContext,result}function createMissingList(){var pos=getNodePos(),result=[];return result.pos=pos,result.end=pos,result}function parseBracketedList(kind,parseElement,open,close){if(parseExpected(open)){var result=parseDelimitedList(kind,parseElement);return parseExpected(close),result}return createMissingList()}function parseEntityName(allowReservedWords,diagnosticMessage){for(var entity=parseIdentifier(diagnosticMessage);parseOptional(21);){var node=createNode(136,entity.pos);node.left=entity,node.right=parseRightSideOfDot(allowReservedWords),entity=finishNode(node)}return entity}function parseRightSideOfDot(allowIdentifierNames){if(scanner.hasPrecedingLineBreak()&&ts.tokenIsIdentifierOrKeyword(token)){var matchesPattern=lookAhead(nextTokenIsIdentifierOrKeywordOnSameLine);if(matchesPattern)return createMissingNode(69,!0,ts.Diagnostics.Identifier_expected)}return allowIdentifierNames?parseIdentifierName():parseIdentifier()}function parseTemplateExpression(){var template=createNode(186);template.head=parseTemplateLiteralFragment(),ts.Debug.assert(12===template.head.kind,"Template head has wrong token kind");var templateSpans=[];templateSpans.pos=getNodePos();do templateSpans.push(parseTemplateSpan());while(13===ts.lastOrUndefined(templateSpans).literal.kind);return templateSpans.end=getNodeEnd(),template.templateSpans=templateSpans,finishNode(template)}function parseTemplateSpan(){var span=createNode(193);span.expression=allowInAnd(parseExpression);var literal;return 16===token?(reScanTemplateToken(),literal=parseTemplateLiteralFragment()):literal=parseExpectedToken(14,!1,ts.Diagnostics._0_expected,ts.tokenToString(16)),span.literal=literal,finishNode(span)}function parseStringLiteralTypeNode(){return parseLiteralLikeNode(163,!0)}function parseLiteralNode(internName){return parseLiteralLikeNode(token,internName)}function parseTemplateLiteralFragment(){return parseLiteralLikeNode(token,!1)}function parseLiteralLikeNode(kind,internName){var node=createNode(kind),text=scanner.getTokenValue();node.text=internName?internIdentifier(text):text,scanner.hasExtendedUnicodeEscape()&&(node.hasExtendedUnicodeEscape=!0),scanner.isUnterminated()&&(node.isUnterminated=!0);var tokenPos=scanner.getTokenPos();return nextToken(),finishNode(node),8===node.kind&&48===sourceText.charCodeAt(tokenPos)&&ts.isOctalDigit(sourceText.charCodeAt(tokenPos+1))&&(node.flags|=32768),node}function parseTypeReference(){var typeName=parseEntityName(!1,ts.Diagnostics.Type_expected),node=createNode(152,typeName.pos);return node.typeName=typeName,scanner.hasPrecedingLineBreak()||25!==token||(node.typeArguments=parseBracketedList(18,parseType,25,27)),finishNode(node)}function parseThisTypePredicate(lhs){nextToken();var node=createNode(151,lhs.pos);return node.parameterName=lhs,node.type=parseType(),finishNode(node)}function parseThisTypeNode(){var node=createNode(162);return nextToken(),finishNode(node)}function parseTypeQuery(){var node=createNode(155);return parseExpected(101),node.exprName=parseEntityName(!0),finishNode(node)}function parseTypeParameter(){var node=createNode(138);return node.name=parseIdentifier(),parseOptional(83)&&(isStartOfType()||!isStartOfExpression()?node.constraint=parseType():node.expression=parseUnaryExpressionOrHigher()),finishNode(node)}function parseTypeParameters(){if(25===token)return parseBracketedList(17,parseTypeParameter,25,27)}function parseParameterType(){if(parseOptional(54))return parseType()}function isStartOfParameter(){return 22===token||isIdentifierOrPattern()||ts.isModifierKind(token)||55===token}function setModifiers(node,modifiers){modifiers&&(node.flags|=modifiers.flags,node.modifiers=modifiers)}function parseParameter(){var node=createNode(139);return node.decorators=parseDecorators(),setModifiers(node,parseModifiers()),node.dotDotDotToken=parseOptionalToken(22),node.name=parseIdentifierOrPattern(),0===ts.getFullWidth(node.name)&&0===node.flags&&ts.isModifierKind(token)&&nextToken(),node.questionToken=parseOptionalToken(53),node.type=parseParameterType(),node.initializer=parseBindingElementInitializer(!0),addJSDocComment(finishNode(node))}function parseBindingElementInitializer(inParameter){return inParameter?parseParameterInitializer():parseNonParameterInitializer()}function parseParameterInitializer(){return parseInitializer(!0)}function fillSignature(returnToken,yieldContext,awaitContext,requireCompleteParameterList,signature){var returnTokenRequired=34===returnToken;signature.typeParameters=parseTypeParameters(),signature.parameters=parseParameterList(yieldContext,awaitContext,requireCompleteParameterList),returnTokenRequired?(parseExpected(returnToken),signature.type=parseTypeOrTypePredicate()):parseOptional(returnToken)&&(signature.type=parseTypeOrTypePredicate())}function parseParameterList(yieldContext,awaitContext,requireCompleteParameterList){if(parseExpected(17)){var savedYieldContext=inYieldContext(),savedAwaitContext=inAwaitContext();setYieldContext(yieldContext),setAwaitContext(awaitContext);var result=parseDelimitedList(16,parseParameter);if(setYieldContext(savedYieldContext),setAwaitContext(savedAwaitContext),!parseExpected(18)&&requireCompleteParameterList)return;return result}return requireCompleteParameterList?void 0:createMissingList()}function parseTypeMemberSemicolon(){parseOptional(24)||parseSemicolon()}function parseSignatureMember(kind){var node=createNode(kind);return 149===kind&&parseExpected(92),fillSignature(54,!1,!1,!1,node),parseTypeMemberSemicolon(),finishNode(node)}function isIndexSignature(){return 19===token&&lookAhead(isUnambiguouslyIndexSignature)}function isUnambiguouslyIndexSignature(){if(nextToken(),22===token||20===token)return!0;if(ts.isModifierKind(token)){if(nextToken(),isIdentifier())return!0}else{if(!isIdentifier())return!1;nextToken()}return 54===token||24===token||53===token&&(nextToken(),54===token||24===token||20===token)}function parseIndexSignatureDeclaration(fullStart,decorators,modifiers){var node=createNode(150,fullStart);return node.decorators=decorators,setModifiers(node,modifiers),node.parameters=parseBracketedList(16,parseParameter,19,20),node.type=parseTypeAnnotation(),parseTypeMemberSemicolon(),finishNode(node)}function parsePropertyOrMethodSignature(){var fullStart=scanner.getStartPos(),name=parsePropertyName(),questionToken=parseOptionalToken(53);if(17===token||25===token){var method=createNode(143,fullStart);return method.name=name,method.questionToken=questionToken,fillSignature(54,!1,!1,!1,method),parseTypeMemberSemicolon(),finishNode(method)}var property=createNode(141,fullStart);return property.name=name,property.questionToken=questionToken,property.type=parseTypeAnnotation(),56===token&&(property.initializer=parseNonParameterInitializer()),parseTypeMemberSemicolon(),finishNode(property)}function isStartOfTypeMember(){switch(token){case 17:case 25:case 19:return!0;default:if(ts.isModifierKind(token)){var result=lookAhead(isStartOfIndexSignatureDeclaration);if(result)return result}return isLiteralPropertyName()&&lookAhead(isTypeMemberWithLiteralPropertyName)}}function isStartOfIndexSignatureDeclaration(){for(;ts.isModifierKind(token);)nextToken();return isIndexSignature()}function isTypeMemberWithLiteralPropertyName(){return nextToken(),17===token||25===token||53===token||54===token||canParseSemicolon()}function parseTypeMember(){switch(token){case 17:case 25:return parseSignatureMember(148);case 19:return isIndexSignature()?parseIndexSignatureDeclaration(scanner.getStartPos(),void 0,void 0):parsePropertyOrMethodSignature();case 92:if(lookAhead(isStartOfConstructSignature))return parseSignatureMember(149);case 9:case 8:return parsePropertyOrMethodSignature();default:if(ts.isModifierKind(token)){var result=tryParse(parseIndexSignatureWithModifiers);if(result)return result}if(ts.tokenIsIdentifierOrKeyword(token))return parsePropertyOrMethodSignature()}}function parseIndexSignatureWithModifiers(){var fullStart=scanner.getStartPos(),decorators=parseDecorators(),modifiers=parseModifiers();return isIndexSignature()?parseIndexSignatureDeclaration(fullStart,decorators,modifiers):void 0}function isStartOfConstructSignature(){return nextToken(),17===token||25===token}function parseTypeLiteral(){var node=createNode(156);return node.members=parseObjectTypeMembers(),finishNode(node)}function parseObjectTypeMembers(){var members;return parseExpected(15)?(members=parseList(4,parseTypeMember),parseExpected(16)):members=createMissingList(),members}function parseTupleType(){var node=createNode(158);return node.elementTypes=parseBracketedList(19,parseType,19,20),finishNode(node)}function parseParenthesizedType(){var node=createNode(161);return parseExpected(17),node.type=parseType(),parseExpected(18),finishNode(node)}function parseFunctionOrConstructorType(kind){var node=createNode(kind);return 154===kind&&parseExpected(92),fillSignature(34,!1,!1,!1,node),finishNode(node)}function parseKeywordAndNoDot(){var node=parseTokenNode();return 21===token?void 0:node}function parseNonArrayType(){switch(token){case 117:case 130:case 128:case 120:case 131:var node=tryParse(parseKeywordAndNoDot);return node||parseTypeReference();case 9:return parseStringLiteralTypeNode();case 103:return parseTokenNode();case 97:var thisKeyword=parseThisTypeNode();return 124!==token||scanner.hasPrecedingLineBreak()?thisKeyword:parseThisTypePredicate(thisKeyword);case 101:return parseTypeQuery();case 15:return parseTypeLiteral();case 19:return parseTupleType();case 17:return parseParenthesizedType();default:return parseTypeReference()}}function isStartOfType(){switch(token){case 117:case 130:case 128:case 120:case 131:case 103:case 97:case 101:case 15:case 19:case 25:case 92:case 9:return!0;case 17:return lookAhead(isStartOfParenthesizedOrFunctionType);default:return isIdentifier()}}function isStartOfParenthesizedOrFunctionType(){return nextToken(),18===token||isStartOfParameter()||isStartOfType()}function parseArrayTypeOrHigher(){for(var type=parseNonArrayType();!scanner.hasPrecedingLineBreak()&&parseOptional(19);){parseExpected(20);var node=createNode(157,type.pos);node.elementType=type,type=finishNode(node)}return type}function parseUnionOrIntersectionType(kind,parseConstituentType,operator){var type=parseConstituentType();if(token===operator){var types=[type];for(types.pos=type.pos;parseOptional(operator);)types.push(parseConstituentType());types.end=getNodeEnd();var node=createNode(kind,type.pos);node.types=types,type=finishNode(node)}return type}function parseIntersectionTypeOrHigher(){return parseUnionOrIntersectionType(160,parseArrayTypeOrHigher,46)}function parseUnionTypeOrHigher(){return parseUnionOrIntersectionType(159,parseIntersectionTypeOrHigher,47)}function isStartOfFunctionType(){return 25===token||17===token&&lookAhead(isUnambiguouslyStartOfFunctionType)}function isUnambiguouslyStartOfFunctionType(){if(nextToken(),18===token||22===token)return!0;if(isIdentifier()||ts.isModifierKind(token)){if(nextToken(),54===token||24===token||53===token||56===token||isIdentifier()||ts.isModifierKind(token))return!0;if(18===token&&(nextToken(),34===token))return!0}return!1}function parseTypeOrTypePredicate(){var typePredicateVariable=isIdentifier()&&tryParse(parseTypePredicatePrefix),type=parseType();if(typePredicateVariable){var node=createNode(151,typePredicateVariable.pos);return node.parameterName=typePredicateVariable,node.type=type,finishNode(node)}return type}function parseTypePredicatePrefix(){var id=parseIdentifier();if(124===token&&!scanner.hasPrecedingLineBreak())return nextToken(),id}function parseType(){return doOutsideOfContext(10,parseTypeWorker)}function parseTypeWorker(){return isStartOfFunctionType()?parseFunctionOrConstructorType(153):92===token?parseFunctionOrConstructorType(154):parseUnionTypeOrHigher()}function parseTypeAnnotation(){return parseOptional(54)?parseType():void 0}function isStartOfLeftHandSideExpression(){switch(token){case 97:case 95:case 93:case 99:case 84:case 8:case 9:case 11:case 12:case 17:case 19:case 15:case 87:case 73:case 92:case 39:case 61:case 69:return!0;default:return isIdentifier()}}function isStartOfExpression(){if(isStartOfLeftHandSideExpression())return!0;switch(token){case 35:case 36:case 50:case 49:case 78:case 101:case 103:case 41:case 42:case 25:case 119:case 114:return!0;default:return!!isBinaryOperator()||isIdentifier()}}function isStartOfExpressionStatement(){return 15!==token&&87!==token&&73!==token&&55!==token&&isStartOfExpression()}function parseExpression(){var saveDecoratorContext=inDecoratorContext();saveDecoratorContext&&setDecoratorContext(!1);for(var operatorToken,expr=parseAssignmentExpressionOrHigher();operatorToken=parseOptionalToken(24);)expr=makeBinaryExpression(expr,operatorToken,parseAssignmentExpressionOrHigher());return saveDecoratorContext&&setDecoratorContext(!0),expr}function parseInitializer(inParameter){if(56===token||!(scanner.hasPrecedingLineBreak()||inParameter&&15===token)&&isStartOfExpression())return parseExpected(56),parseAssignmentExpressionOrHigher()}function parseAssignmentExpressionOrHigher(){if(isYieldExpression())return parseYieldExpression();var arrowExpression=tryParseParenthesizedArrowFunctionExpression();if(arrowExpression)return arrowExpression;var expr=parseBinaryExpressionOrHigher(0);return 69===expr.kind&&34===token?parseSimpleArrowFunctionExpression(expr):ts.isLeftHandSideExpression(expr)&&ts.isAssignmentOperator(reScanGreaterToken())?makeBinaryExpression(expr,parseTokenNode(),parseAssignmentExpressionOrHigher()):parseConditionalExpressionRest(expr)}function isYieldExpression(){return 114===token&&(!!inYieldContext()||lookAhead(nextTokenIsIdentifierOrKeywordOrNumberOnSameLine))}function nextTokenIsIdentifierOnSameLine(){return nextToken(),!scanner.hasPrecedingLineBreak()&&isIdentifier()}function parseYieldExpression(){var node=createNode(187);return nextToken(),scanner.hasPrecedingLineBreak()||37!==token&&!isStartOfExpression()?finishNode(node):(node.asteriskToken=parseOptionalToken(37),node.expression=parseAssignmentExpressionOrHigher(),finishNode(node))}function parseSimpleArrowFunctionExpression(identifier){ts.Debug.assert(34===token,"parseSimpleArrowFunctionExpression should only have been called if we had a =>");var node=createNode(177,identifier.pos),parameter=createNode(139,identifier.pos);return parameter.name=identifier,finishNode(parameter),node.parameters=[parameter],node.parameters.pos=parameter.pos,node.parameters.end=parameter.end,node.equalsGreaterThanToken=parseExpectedToken(34,!1,ts.Diagnostics._0_expected,"=>"),node.body=parseArrowFunctionExpressionBody(!1),finishNode(node)}function tryParseParenthesizedArrowFunctionExpression(){var triState=isParenthesizedArrowFunctionExpression();if(0!==triState){var arrowFunction=1===triState?parseParenthesizedArrowFunctionExpressionHead(!0):tryParse(parsePossibleParenthesizedArrowFunctionExpressionHead);if(arrowFunction){var isAsync=!!(256&arrowFunction.flags),lastToken=token;return arrowFunction.equalsGreaterThanToken=parseExpectedToken(34,!1,ts.Diagnostics._0_expected,"=>"),arrowFunction.body=34===lastToken||15===lastToken?parseArrowFunctionExpressionBody(isAsync):parseIdentifier(),finishNode(arrowFunction)}}}function isParenthesizedArrowFunctionExpression(){return 17===token||25===token||118===token?lookAhead(isParenthesizedArrowFunctionExpressionWorker):34===token?1:0}function isParenthesizedArrowFunctionExpressionWorker(){if(118===token){if(nextToken(),scanner.hasPrecedingLineBreak())return 0;if(17!==token&&25!==token)return 0}var first=token,second=nextToken();if(17===first){if(18===second){var third=nextToken();switch(third){case 34:case 54:case 15:return 1;default:return 0}}return 19===second||15===second?2:22===second?1:isIdentifier()?54===nextToken()?1:2:0}if(ts.Debug.assert(25===first),!isIdentifier())return 0;if(1===sourceFile.languageVariant){var isArrowFunctionInJsx=lookAhead(function(){var third=nextToken();if(83===third){var fourth=nextToken();switch(fourth){
case 56:case 27:return!1;default:return!0}}else if(24===third)return!0;return!1});return isArrowFunctionInJsx?1:0}return 2}function parsePossibleParenthesizedArrowFunctionExpressionHead(){return parseParenthesizedArrowFunctionExpressionHead(!1)}function parseParenthesizedArrowFunctionExpressionHead(allowAmbiguity){var node=createNode(177);setModifiers(node,parseModifiersForArrowFunction());var isAsync=!!(256&node.flags);if(fillSignature(54,!1,isAsync,!allowAmbiguity,node),node.parameters&&(allowAmbiguity||34===token||15===token))return node}function parseArrowFunctionExpressionBody(isAsync){return 15===token?parseFunctionBlock(!1,isAsync,!1):23!==token&&87!==token&&73!==token&&isStartOfStatement()&&!isStartOfExpressionStatement()?parseFunctionBlock(!1,isAsync,!0):isAsync?doInAwaitContext(parseAssignmentExpressionOrHigher):doOutsideOfAwaitContext(parseAssignmentExpressionOrHigher)}function parseConditionalExpressionRest(leftOperand){var questionToken=parseOptionalToken(53);if(!questionToken)return leftOperand;var node=createNode(185,leftOperand.pos);return node.condition=leftOperand,node.questionToken=questionToken,node.whenTrue=doOutsideOfContext(disallowInAndDecoratorContext,parseAssignmentExpressionOrHigher),node.colonToken=parseExpectedToken(54,!1,ts.Diagnostics._0_expected,ts.tokenToString(54)),node.whenFalse=parseAssignmentExpressionOrHigher(),finishNode(node)}function parseBinaryExpressionOrHigher(precedence){var leftOperand=parseUnaryExpressionOrHigher();return parseBinaryExpressionRest(precedence,leftOperand)}function isInOrOfKeyword(t){return 90===t||135===t}function parseBinaryExpressionRest(precedence,leftOperand){for(;;){reScanGreaterToken();var newPrecedence=getBinaryOperatorPrecedence(),consumeCurrentOperator=38===token?newPrecedence>=precedence:newPrecedence>precedence;if(!consumeCurrentOperator)break;if(90===token&&inDisallowInContext())break;if(116===token){if(scanner.hasPrecedingLineBreak())break;nextToken(),leftOperand=makeAsExpression(leftOperand,parseType())}else leftOperand=makeBinaryExpression(leftOperand,parseTokenNode(),parseBinaryExpressionOrHigher(newPrecedence))}return leftOperand}function isBinaryOperator(){return(!inDisallowInContext()||90!==token)&&getBinaryOperatorPrecedence()>0}function getBinaryOperatorPrecedence(){switch(token){case 52:return 1;case 51:return 2;case 47:return 3;case 48:return 4;case 46:return 5;case 30:case 31:case 32:case 33:return 6;case 25:case 27:case 28:case 29:case 91:case 90:case 116:return 7;case 43:case 44:case 45:return 8;case 35:case 36:return 9;case 37:case 39:case 40:return 10;case 38:return 11}return-1}function makeBinaryExpression(left,operatorToken,right){var node=createNode(184,left.pos);return node.left=left,node.operatorToken=operatorToken,node.right=right,finishNode(node)}function makeAsExpression(left,right){var node=createNode(192,left.pos);return node.expression=left,node.type=right,finishNode(node)}function parsePrefixUnaryExpression(){var node=createNode(182);return node.operator=token,nextToken(),node.operand=parseSimpleUnaryExpression(),finishNode(node)}function parseDeleteExpression(){var node=createNode(178);return nextToken(),node.expression=parseSimpleUnaryExpression(),finishNode(node)}function parseTypeOfExpression(){var node=createNode(179);return nextToken(),node.expression=parseSimpleUnaryExpression(),finishNode(node)}function parseVoidExpression(){var node=createNode(180);return nextToken(),node.expression=parseSimpleUnaryExpression(),finishNode(node)}function isAwaitExpression(){return 119===token&&(!!inAwaitContext()||lookAhead(nextTokenIsIdentifierOnSameLine))}function parseAwaitExpression(){var node=createNode(181);return nextToken(),node.expression=parseSimpleUnaryExpression(),finishNode(node)}function parseUnaryExpressionOrHigher(){if(isAwaitExpression())return parseAwaitExpression();if(isIncrementExpression()){var incrementExpression=parseIncrementExpression();return 38===token?parseBinaryExpressionRest(getBinaryOperatorPrecedence(),incrementExpression):incrementExpression}var unaryOperator=token,simpleUnaryExpression=parseSimpleUnaryExpression();if(38===token){var start=ts.skipTrivia(sourceText,simpleUnaryExpression.pos);174===simpleUnaryExpression.kind?parseErrorAtPosition(start,simpleUnaryExpression.end-start,ts.Diagnostics.A_type_assertion_expression_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses):parseErrorAtPosition(start,simpleUnaryExpression.end-start,ts.Diagnostics.An_unary_expression_with_the_0_operator_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses,ts.tokenToString(unaryOperator))}return simpleUnaryExpression}function parseSimpleUnaryExpression(){switch(token){case 35:case 36:case 50:case 49:return parsePrefixUnaryExpression();case 78:return parseDeleteExpression();case 101:return parseTypeOfExpression();case 103:return parseVoidExpression();case 25:return parseTypeAssertion();default:return parseIncrementExpression()}}function isIncrementExpression(){switch(token){case 35:case 36:case 50:case 49:case 78:case 101:case 103:return!1;case 25:if(1!==sourceFile.languageVariant)return!1;default:return!0}}function parseIncrementExpression(){if(41===token||42===token){var node=createNode(182);return node.operator=token,nextToken(),node.operand=parseLeftHandSideExpressionOrHigher(),finishNode(node)}if(1===sourceFile.languageVariant&&25===token&&lookAhead(nextTokenIsIdentifierOrKeyword))return parseJsxElementOrSelfClosingElement(!0);var expression=parseLeftHandSideExpressionOrHigher();if(ts.Debug.assert(ts.isLeftHandSideExpression(expression)),(41===token||42===token)&&!scanner.hasPrecedingLineBreak()){var node=createNode(183,expression.pos);return node.operand=expression,node.operator=token,nextToken(),finishNode(node)}return expression}function parseLeftHandSideExpressionOrHigher(){var expression=95===token?parseSuperExpression():parseMemberExpressionOrHigher();return parseCallExpressionRest(expression)}function parseMemberExpressionOrHigher(){var expression=parsePrimaryExpression();return parseMemberExpressionRest(expression)}function parseSuperExpression(){var expression=parseTokenNode();if(17===token||21===token||19===token)return expression;var node=createNode(169,expression.pos);return node.expression=expression,node.dotToken=parseExpectedToken(21,!1,ts.Diagnostics.super_must_be_followed_by_an_argument_list_or_member_access),node.name=parseRightSideOfDot(!0),finishNode(node)}function tagNamesAreEquivalent(lhs,rhs){return lhs.kind===rhs.kind&&(69===lhs.kind?lhs.text===rhs.text:lhs.right.text===rhs.right.text&&tagNamesAreEquivalent(lhs.left,rhs.left))}function parseJsxElementOrSelfClosingElement(inExpressionContext){var result,opening=parseJsxOpeningOrSelfClosingElement(inExpressionContext);if(238===opening.kind){var node=createNode(236,opening.pos);node.openingElement=opening,node.children=parseJsxChildren(node.openingElement.tagName),node.closingElement=parseJsxClosingElement(inExpressionContext),tagNamesAreEquivalent(node.openingElement.tagName,node.closingElement.tagName)||parseErrorAtPosition(node.closingElement.pos,node.closingElement.end-node.closingElement.pos,ts.Diagnostics.Expected_corresponding_JSX_closing_tag_for_0,ts.getTextOfNodeFromSourceText(sourceText,node.openingElement.tagName)),result=finishNode(node)}else ts.Debug.assert(237===opening.kind),result=opening;if(inExpressionContext&&25===token){var invalidElement=tryParse(function(){return parseJsxElementOrSelfClosingElement(!0)});if(invalidElement){parseErrorAtCurrentToken(ts.Diagnostics.JSX_expressions_must_have_one_parent_element);var badNode=createNode(184,result.pos);return badNode.end=invalidElement.end,badNode.left=result,badNode.right=invalidElement,badNode.operatorToken=createMissingNode(24,!1,void 0),badNode.operatorToken.pos=badNode.operatorToken.end=badNode.right.pos,badNode}}return result}function parseJsxText(){var node=createNode(239,scanner.getStartPos());return token=scanner.scanJsxToken(),finishNode(node)}function parseJsxChild(){switch(token){case 239:return parseJsxText();case 15:return parseJsxExpression(!1);case 25:return parseJsxElementOrSelfClosingElement(!1)}ts.Debug.fail("Unknown JSX child kind "+token)}function parseJsxChildren(openingTagName){var result=[];result.pos=scanner.getStartPos();var saveParsingContext=parsingContext;for(parsingContext|=16384;;){if(token=scanner.reScanJsxToken(),26===token)break;if(1===token){parseErrorAtPosition(openingTagName.pos,openingTagName.end-openingTagName.pos,ts.Diagnostics.JSX_element_0_has_no_corresponding_closing_tag,ts.getTextOfNodeFromSourceText(sourceText,openingTagName));break}result.push(parseJsxChild())}return result.end=scanner.getTokenPos(),parsingContext=saveParsingContext,result}function parseJsxOpeningOrSelfClosingElement(inExpressionContext){var fullStart=scanner.getStartPos();parseExpected(25);var node,tagName=parseJsxElementName(),attributes=parseList(13,parseJsxAttribute);return 27===token?(node=createNode(238,fullStart),scanJsxText()):(parseExpected(39),inExpressionContext?parseExpected(27):(parseExpected(27,void 0,!1),scanJsxText()),node=createNode(237,fullStart)),node.tagName=tagName,node.attributes=attributes,finishNode(node)}function parseJsxElementName(){scanJsxIdentifier();for(var elementName=parseIdentifierName();parseOptional(21);){scanJsxIdentifier();var node=createNode(136,elementName.pos);node.left=elementName,node.right=parseIdentifierName(),elementName=finishNode(node)}return elementName}function parseJsxExpression(inExpressionContext){var node=createNode(243);return parseExpected(15),16!==token&&(node.expression=parseAssignmentExpressionOrHigher()),inExpressionContext?parseExpected(16):(parseExpected(16,void 0,!1),scanJsxText()),finishNode(node)}function parseJsxAttribute(){if(15===token)return parseJsxSpreadAttribute();scanJsxIdentifier();var node=createNode(241);if(node.name=parseIdentifierName(),parseOptional(56))switch(token){case 9:node.initializer=parseLiteralNode();break;default:node.initializer=parseJsxExpression(!0)}return finishNode(node)}function parseJsxSpreadAttribute(){var node=createNode(242);return parseExpected(15),parseExpected(22),node.expression=parseExpression(),parseExpected(16),finishNode(node)}function parseJsxClosingElement(inExpressionContext){var node=createNode(240);return parseExpected(26),node.tagName=parseJsxElementName(),inExpressionContext?parseExpected(27):(parseExpected(27,void 0,!1),scanJsxText()),finishNode(node)}function parseTypeAssertion(){var node=createNode(174);return parseExpected(25),node.type=parseType(),parseExpected(27),node.expression=parseSimpleUnaryExpression(),finishNode(node)}function parseMemberExpressionRest(expression){for(;;){var dotToken=parseOptionalToken(21);if(dotToken){var propertyAccess=createNode(169,expression.pos);propertyAccess.expression=expression,propertyAccess.dotToken=dotToken,propertyAccess.name=parseRightSideOfDot(!0),expression=finishNode(propertyAccess)}else if(inDecoratorContext()||!parseOptional(19)){if(11!==token&&12!==token)return expression;var tagExpression=createNode(173,expression.pos);tagExpression.tag=expression,tagExpression.template=11===token?parseLiteralNode():parseTemplateExpression(),expression=finishNode(tagExpression)}else{var indexedAccess=createNode(170,expression.pos);if(indexedAccess.expression=expression,20!==token&&(indexedAccess.argumentExpression=allowInAnd(parseExpression),9===indexedAccess.argumentExpression.kind||8===indexedAccess.argumentExpression.kind)){var literal=indexedAccess.argumentExpression;literal.text=internIdentifier(literal.text)}parseExpected(20),expression=finishNode(indexedAccess)}}}function parseCallExpressionRest(expression){for(;;)if(expression=parseMemberExpressionRest(expression),25!==token){if(17!==token)return expression;var callExpr=createNode(171,expression.pos);callExpr.expression=expression,callExpr.arguments=parseArgumentList(),expression=finishNode(callExpr)}else{var typeArguments=tryParse(parseTypeArgumentsInExpression);if(!typeArguments)return expression;var callExpr=createNode(171,expression.pos);callExpr.expression=expression,callExpr.typeArguments=typeArguments,callExpr.arguments=parseArgumentList(),expression=finishNode(callExpr)}}function parseArgumentList(){parseExpected(17);var result=parseDelimitedList(11,parseArgumentExpression);return parseExpected(18),result}function parseTypeArgumentsInExpression(){if(parseOptional(25)){var typeArguments=parseDelimitedList(18,parseType);if(parseExpected(27))return typeArguments&&canFollowTypeArgumentsInExpression()?typeArguments:void 0}}function canFollowTypeArgumentsInExpression(){switch(token){case 17:case 21:case 18:case 20:case 54:case 23:case 53:case 30:case 32:case 31:case 33:case 51:case 52:case 48:case 46:case 47:case 16:case 1:return!0;case 24:case 15:default:return!1}}function parsePrimaryExpression(){switch(token){case 8:case 9:case 11:return parseLiteralNode();case 97:case 95:case 93:case 99:case 84:return parseTokenNode();case 17:return parseParenthesizedExpression();case 19:return parseArrayLiteralExpression();case 15:return parseObjectLiteralExpression();case 118:if(!lookAhead(nextTokenIsFunctionKeywordOnSameLine))break;return parseFunctionExpression();case 73:return parseClassExpression();case 87:return parseFunctionExpression();case 92:return parseNewExpression();case 39:case 61:if(10===reScanSlashToken())return parseLiteralNode();break;case 12:return parseTemplateExpression()}return parseIdentifier(ts.Diagnostics.Expression_expected)}function parseParenthesizedExpression(){var node=createNode(175);return parseExpected(17),node.expression=allowInAnd(parseExpression),parseExpected(18),finishNode(node)}function parseSpreadElement(){var node=createNode(188);return parseExpected(22),node.expression=parseAssignmentExpressionOrHigher(),finishNode(node)}function parseArgumentOrArrayLiteralElement(){return 22===token?parseSpreadElement():24===token?createNode(190):parseAssignmentExpressionOrHigher()}function parseArgumentExpression(){return doOutsideOfContext(disallowInAndDecoratorContext,parseArgumentOrArrayLiteralElement)}function parseArrayLiteralExpression(){var node=createNode(167);return parseExpected(19),scanner.hasPrecedingLineBreak()&&(node.flags|=1024),node.elements=parseDelimitedList(15,parseArgumentOrArrayLiteralElement),parseExpected(20),finishNode(node)}function tryParseAccessorDeclaration(fullStart,decorators,modifiers){return parseContextualModifier(123)?parseAccessorDeclaration(146,fullStart,decorators,modifiers):parseContextualModifier(129)?parseAccessorDeclaration(147,fullStart,decorators,modifiers):void 0}function parseObjectLiteralElement(){var fullStart=scanner.getStartPos(),decorators=parseDecorators(),modifiers=parseModifiers(),accessor=tryParseAccessorDeclaration(fullStart,decorators,modifiers);if(accessor)return accessor;var asteriskToken=parseOptionalToken(37),tokenIsIdentifier=isIdentifier(),propertyName=parsePropertyName(),questionToken=parseOptionalToken(53);if(asteriskToken||17===token||25===token)return parseMethodDeclaration(fullStart,decorators,modifiers,asteriskToken,propertyName,questionToken);var isShorthandPropertyAssignment=tokenIsIdentifier&&(24===token||16===token||56===token);if(isShorthandPropertyAssignment){var shorthandDeclaration=createNode(249,fullStart);shorthandDeclaration.name=propertyName,shorthandDeclaration.questionToken=questionToken;var equalsToken=parseOptionalToken(56);return equalsToken&&(shorthandDeclaration.equalsToken=equalsToken,shorthandDeclaration.objectAssignmentInitializer=allowInAnd(parseAssignmentExpressionOrHigher)),addJSDocComment(finishNode(shorthandDeclaration))}var propertyAssignment=createNode(248,fullStart);return propertyAssignment.modifiers=modifiers,propertyAssignment.name=propertyName,propertyAssignment.questionToken=questionToken,parseExpected(54),propertyAssignment.initializer=allowInAnd(parseAssignmentExpressionOrHigher),addJSDocComment(finishNode(propertyAssignment))}function parseObjectLiteralExpression(){var node=createNode(168);return parseExpected(15),scanner.hasPrecedingLineBreak()&&(node.flags|=1024),node.properties=parseDelimitedList(12,parseObjectLiteralElement,!0),parseExpected(16),finishNode(node)}function parseFunctionExpression(){var saveDecoratorContext=inDecoratorContext();saveDecoratorContext&&setDecoratorContext(!1);var node=createNode(176);setModifiers(node,parseModifiers()),parseExpected(87),node.asteriskToken=parseOptionalToken(37);var isGenerator=!!node.asteriskToken,isAsync=!!(256&node.flags);return node.name=isGenerator&&isAsync?doInYieldAndAwaitContext(parseOptionalIdentifier):isGenerator?doInYieldContext(parseOptionalIdentifier):isAsync?doInAwaitContext(parseOptionalIdentifier):parseOptionalIdentifier(),fillSignature(54,isGenerator,isAsync,!1,node),node.body=parseFunctionBlock(isGenerator,isAsync,!1),saveDecoratorContext&&setDecoratorContext(!0),addJSDocComment(finishNode(node))}function parseOptionalIdentifier(){return isIdentifier()?parseIdentifier():void 0}function parseNewExpression(){var node=createNode(172);return parseExpected(92),node.expression=parseMemberExpressionOrHigher(),node.typeArguments=tryParse(parseTypeArgumentsInExpression),(node.typeArguments||17===token)&&(node.arguments=parseArgumentList()),finishNode(node)}function parseBlock(ignoreMissingOpenBrace,diagnosticMessage){var node=createNode(195);return parseExpected(15,diagnosticMessage)||ignoreMissingOpenBrace?(node.statements=parseList(1,parseStatement),parseExpected(16)):node.statements=createMissingList(),finishNode(node)}function parseFunctionBlock(allowYield,allowAwait,ignoreMissingOpenBrace,diagnosticMessage){var savedYieldContext=inYieldContext();setYieldContext(allowYield);var savedAwaitContext=inAwaitContext();setAwaitContext(allowAwait);var saveDecoratorContext=inDecoratorContext();saveDecoratorContext&&setDecoratorContext(!1);var block=parseBlock(ignoreMissingOpenBrace,diagnosticMessage);return saveDecoratorContext&&setDecoratorContext(!0),setYieldContext(savedYieldContext),setAwaitContext(savedAwaitContext),block}function parseEmptyStatement(){var node=createNode(197);return parseExpected(23),finishNode(node)}function parseIfStatement(){var node=createNode(199);return parseExpected(88),parseExpected(17),node.expression=allowInAnd(parseExpression),parseExpected(18),node.thenStatement=parseStatement(),node.elseStatement=parseOptional(80)?parseStatement():void 0,finishNode(node)}function parseDoStatement(){var node=createNode(200);return parseExpected(79),node.statement=parseStatement(),parseExpected(104),parseExpected(17),node.expression=allowInAnd(parseExpression),parseExpected(18),parseOptional(23),finishNode(node)}function parseWhileStatement(){var node=createNode(201);return parseExpected(104),parseExpected(17),node.expression=allowInAnd(parseExpression),parseExpected(18),node.statement=parseStatement(),finishNode(node)}function parseForOrForInOrForOfStatement(){var pos=getNodePos();parseExpected(86),parseExpected(17);var initializer=void 0;23!==token&&(initializer=102===token||108===token||74===token?parseVariableDeclarationList(!0):disallowInAnd(parseExpression));var forOrForInOrForOfStatement;if(parseOptional(90)){var forInStatement=createNode(203,pos);forInStatement.initializer=initializer,forInStatement.expression=allowInAnd(parseExpression),parseExpected(18),forOrForInOrForOfStatement=forInStatement}else if(parseOptional(135)){var forOfStatement=createNode(204,pos);forOfStatement.initializer=initializer,forOfStatement.expression=allowInAnd(parseAssignmentExpressionOrHigher),parseExpected(18),forOrForInOrForOfStatement=forOfStatement}else{var forStatement=createNode(202,pos);forStatement.initializer=initializer,parseExpected(23),23!==token&&18!==token&&(forStatement.condition=allowInAnd(parseExpression)),parseExpected(23),18!==token&&(forStatement.incrementor=allowInAnd(parseExpression)),parseExpected(18),forOrForInOrForOfStatement=forStatement}return forOrForInOrForOfStatement.statement=parseStatement(),finishNode(forOrForInOrForOfStatement)}function parseBreakOrContinueStatement(kind){var node=createNode(kind);return parseExpected(206===kind?70:75),canParseSemicolon()||(node.label=parseIdentifier()),parseSemicolon(),finishNode(node)}function parseReturnStatement(){var node=createNode(207);return parseExpected(94),canParseSemicolon()||(node.expression=allowInAnd(parseExpression)),parseSemicolon(),finishNode(node)}function parseWithStatement(){var node=createNode(208);return parseExpected(105),parseExpected(17),node.expression=allowInAnd(parseExpression),parseExpected(18),node.statement=parseStatement(),finishNode(node)}function parseCaseClause(){var node=createNode(244);return parseExpected(71),node.expression=allowInAnd(parseExpression),parseExpected(54),node.statements=parseList(3,parseStatement),finishNode(node)}function parseDefaultClause(){var node=createNode(245);return parseExpected(77),parseExpected(54),node.statements=parseList(3,parseStatement),finishNode(node)}function parseCaseOrDefaultClause(){return 71===token?parseCaseClause():parseDefaultClause()}function parseSwitchStatement(){var node=createNode(209);parseExpected(96),parseExpected(17),node.expression=allowInAnd(parseExpression),parseExpected(18);var caseBlock=createNode(223,scanner.getStartPos());return parseExpected(15),caseBlock.clauses=parseList(2,parseCaseOrDefaultClause),parseExpected(16),node.caseBlock=finishNode(caseBlock),finishNode(node)}function parseThrowStatement(){var node=createNode(211);return parseExpected(98),node.expression=scanner.hasPrecedingLineBreak()?void 0:allowInAnd(parseExpression),parseSemicolon(),finishNode(node)}function parseTryStatement(){var node=createNode(212);return parseExpected(100),node.tryBlock=parseBlock(!1),node.catchClause=72===token?parseCatchClause():void 0,node.catchClause&&85!==token||(parseExpected(85),node.finallyBlock=parseBlock(!1)),finishNode(node)}function parseCatchClause(){var result=createNode(247);return parseExpected(72),parseExpected(17)&&(result.variableDeclaration=parseVariableDeclaration()),parseExpected(18),result.block=parseBlock(!1),finishNode(result)}function parseDebuggerStatement(){var node=createNode(213);return parseExpected(76),parseSemicolon(),finishNode(node)}function parseExpressionOrLabeledStatement(){var fullStart=scanner.getStartPos(),expression=allowInAnd(parseExpression);if(69===expression.kind&&parseOptional(54)){var labeledStatement=createNode(210,fullStart);return labeledStatement.label=expression,labeledStatement.statement=parseStatement(),addJSDocComment(finishNode(labeledStatement))}var expressionStatement=createNode(198,fullStart);return expressionStatement.expression=expression,parseSemicolon(),addJSDocComment(finishNode(expressionStatement))}function nextTokenIsIdentifierOrKeywordOnSameLine(){return nextToken(),ts.tokenIsIdentifierOrKeyword(token)&&!scanner.hasPrecedingLineBreak()}function nextTokenIsFunctionKeywordOnSameLine(){return nextToken(),87===token&&!scanner.hasPrecedingLineBreak()}function nextTokenIsIdentifierOrKeywordOrNumberOnSameLine(){return nextToken(),(ts.tokenIsIdentifierOrKeyword(token)||8===token)&&!scanner.hasPrecedingLineBreak()}function isDeclaration(){for(;;)switch(token){case 102:case 108:case 74:case 87:case 73:case 81:return!0;case 107:case 132:return nextTokenIsIdentifierOnSameLine();case 125:case 126:return nextTokenIsIdentifierOrStringLiteralOnSameLine();case 115:case 118:case 122:case 110:case 111:case 112:if(nextToken(),scanner.hasPrecedingLineBreak())return!1;continue;case 134:return 15===nextToken();case 89:return nextToken(),9===token||37===token||15===token||ts.tokenIsIdentifierOrKeyword(token);case 82:if(nextToken(),56===token||37===token||15===token||77===token)return!0;continue;case 113:nextToken();continue;default:return!1}}function isStartOfDeclaration(){return lookAhead(isDeclaration)}function isStartOfStatement(){switch(token){case 55:case 23:case 15:case 102:case 108:case 87:case 73:case 81:case 88:case 79:case 104:case 86:case 75:case 70:case 94:case 105:case 96:case 98:case 100:case 76:case 72:case 85:return!0;case 74:case 82:case 89:return isStartOfDeclaration();case 118:case 122:case 107:case 125:case 126:case 132:case 134:return!0;case 112:case 110:case 111:case 113:return isStartOfDeclaration()||!lookAhead(nextTokenIsIdentifierOrKeywordOnSameLine);default:return isStartOfExpression()}}function nextTokenIsIdentifierOrStartOfDestructuring(){return nextToken(),isIdentifier()||15===token||19===token}function isLetDeclaration(){return lookAhead(nextTokenIsIdentifierOrStartOfDestructuring)}function parseStatement(){switch(token){case 23:return parseEmptyStatement();case 15:return parseBlock(!1);case 102:return parseVariableStatement(scanner.getStartPos(),void 0,void 0);case 108:if(isLetDeclaration())return parseVariableStatement(scanner.getStartPos(),void 0,void 0);break;case 87:return parseFunctionDeclaration(scanner.getStartPos(),void 0,void 0);case 73:return parseClassDeclaration(scanner.getStartPos(),void 0,void 0);case 88:return parseIfStatement();case 79:return parseDoStatement();case 104:return parseWhileStatement();case 86:return parseForOrForInOrForOfStatement();case 75:return parseBreakOrContinueStatement(205);case 70:return parseBreakOrContinueStatement(206);case 94:return parseReturnStatement();case 105:return parseWithStatement();case 96:return parseSwitchStatement();case 98:return parseThrowStatement();case 100:case 72:case 85:return parseTryStatement();case 76:return parseDebuggerStatement();case 55:return parseDeclaration();case 118:case 107:case 132:case 125:case 126:case 122:case 74:case 81:case 82:case 89:case 110:case 111:case 112:case 115:case 113:case 134:if(isStartOfDeclaration())return parseDeclaration()}return parseExpressionOrLabeledStatement()}function parseDeclaration(){var fullStart=getNodePos(),decorators=parseDecorators(),modifiers=parseModifiers();switch(token){case 102:case 108:case 74:return parseVariableStatement(fullStart,decorators,modifiers);case 87:return parseFunctionDeclaration(fullStart,decorators,modifiers);case 73:return parseClassDeclaration(fullStart,decorators,modifiers);case 107:return parseInterfaceDeclaration(fullStart,decorators,modifiers);case 132:return parseTypeAliasDeclaration(fullStart,decorators,modifiers);case 81:return parseEnumDeclaration(fullStart,decorators,modifiers);case 134:case 125:case 126:return parseModuleDeclaration(fullStart,decorators,modifiers);case 89:return parseImportDeclarationOrImportEqualsDeclaration(fullStart,decorators,modifiers);case 82:return nextToken(),77===token||56===token?parseExportAssignment(fullStart,decorators,modifiers):parseExportDeclaration(fullStart,decorators,modifiers);default:if(decorators||modifiers){var node=createMissingNode(234,!0,ts.Diagnostics.Declaration_expected);return node.pos=fullStart,node.decorators=decorators,setModifiers(node,modifiers),finishNode(node)}}}function nextTokenIsIdentifierOrStringLiteralOnSameLine(){return nextToken(),!scanner.hasPrecedingLineBreak()&&(isIdentifier()||9===token)}function parseFunctionBlockOrSemicolon(isGenerator,isAsync,diagnosticMessage){return 15!==token&&canParseSemicolon()?void parseSemicolon():parseFunctionBlock(isGenerator,isAsync,!1,diagnosticMessage)}function parseArrayBindingElement(){if(24===token)return createNode(190);var node=createNode(166);return node.dotDotDotToken=parseOptionalToken(22),node.name=parseIdentifierOrPattern(),node.initializer=parseBindingElementInitializer(!1),finishNode(node)}function parseObjectBindingElement(){var node=createNode(166),tokenIsIdentifier=isIdentifier(),propertyName=parsePropertyName();return tokenIsIdentifier&&54!==token?node.name=propertyName:(parseExpected(54),node.propertyName=propertyName,node.name=parseIdentifierOrPattern()),node.initializer=parseBindingElementInitializer(!1),finishNode(node)}function parseObjectBindingPattern(){var node=createNode(164);return parseExpected(15),node.elements=parseDelimitedList(9,parseObjectBindingElement),parseExpected(16),finishNode(node)}function parseArrayBindingPattern(){var node=createNode(165);return parseExpected(19),node.elements=parseDelimitedList(10,parseArrayBindingElement),parseExpected(20),finishNode(node)}function isIdentifierOrPattern(){return 15===token||19===token||isIdentifier()}function parseIdentifierOrPattern(){return 19===token?parseArrayBindingPattern():15===token?parseObjectBindingPattern():parseIdentifier()}function parseVariableDeclaration(){var node=createNode(214);return node.name=parseIdentifierOrPattern(),node.type=parseTypeAnnotation(),isInOrOfKeyword(token)||(node.initializer=parseInitializer(!1)),finishNode(node)}function parseVariableDeclarationList(inForStatementInitializer){var node=createNode(215);switch(token){case 102:break;case 108:node.flags|=8192;break;case 74:node.flags|=16384;break;default:ts.Debug.fail()}if(nextToken(),135===token&&lookAhead(canFollowContextualOfKeyword))node.declarations=createMissingList();else{var savedDisallowIn=inDisallowInContext();setDisallowInContext(inForStatementInitializer),node.declarations=parseDelimitedList(8,parseVariableDeclaration),setDisallowInContext(savedDisallowIn)}return finishNode(node)}function canFollowContextualOfKeyword(){return nextTokenIsIdentifier()&&18===nextToken()}function parseVariableStatement(fullStart,decorators,modifiers){var node=createNode(196,fullStart);return node.decorators=decorators,setModifiers(node,modifiers),node.declarationList=parseVariableDeclarationList(!1),parseSemicolon(),addJSDocComment(finishNode(node))}function parseFunctionDeclaration(fullStart,decorators,modifiers){var node=createNode(216,fullStart);node.decorators=decorators,setModifiers(node,modifiers),parseExpected(87),node.asteriskToken=parseOptionalToken(37),node.name=512&node.flags?parseOptionalIdentifier():parseIdentifier();var isGenerator=!!node.asteriskToken,isAsync=!!(256&node.flags);return fillSignature(54,isGenerator,isAsync,!1,node),node.body=parseFunctionBlockOrSemicolon(isGenerator,isAsync,ts.Diagnostics.or_expected),addJSDocComment(finishNode(node))}function parseConstructorDeclaration(pos,decorators,modifiers){var node=createNode(145,pos);return node.decorators=decorators,setModifiers(node,modifiers),parseExpected(121),fillSignature(54,!1,!1,!1,node),node.body=parseFunctionBlockOrSemicolon(!1,!1,ts.Diagnostics.or_expected),addJSDocComment(finishNode(node))}function parseMethodDeclaration(fullStart,decorators,modifiers,asteriskToken,name,questionToken,diagnosticMessage){var method=createNode(144,fullStart);method.decorators=decorators,setModifiers(method,modifiers),method.asteriskToken=asteriskToken,method.name=name,method.questionToken=questionToken;var isGenerator=!!asteriskToken,isAsync=!!(256&method.flags);return fillSignature(54,isGenerator,isAsync,!1,method),method.body=parseFunctionBlockOrSemicolon(isGenerator,isAsync,diagnosticMessage),addJSDocComment(finishNode(method))}function parsePropertyDeclaration(fullStart,decorators,modifiers,name,questionToken){var property=createNode(142,fullStart);return property.decorators=decorators,setModifiers(property,modifiers),property.name=name,property.questionToken=questionToken,property.type=parseTypeAnnotation(),property.initializer=modifiers&&64&modifiers.flags?allowInAnd(parseNonParameterInitializer):doOutsideOfContext(3,parseNonParameterInitializer),parseSemicolon(),finishNode(property)}function parsePropertyOrMethodDeclaration(fullStart,decorators,modifiers){var asteriskToken=parseOptionalToken(37),name=parsePropertyName(),questionToken=parseOptionalToken(53);return asteriskToken||17===token||25===token?parseMethodDeclaration(fullStart,decorators,modifiers,asteriskToken,name,questionToken,ts.Diagnostics.or_expected):parsePropertyDeclaration(fullStart,decorators,modifiers,name,questionToken)}function parseNonParameterInitializer(){return parseInitializer(!1)}function parseAccessorDeclaration(kind,fullStart,decorators,modifiers){var node=createNode(kind,fullStart);
return node.decorators=decorators,setModifiers(node,modifiers),node.name=parsePropertyName(),fillSignature(54,!1,!1,!1,node),node.body=parseFunctionBlockOrSemicolon(!1,!1),finishNode(node)}function isClassMemberModifier(idToken){switch(idToken){case 112:case 110:case 111:case 113:return!0;default:return!1}}function isClassMemberStart(){var idToken;if(55===token)return!0;for(;ts.isModifierKind(token);){if(idToken=token,isClassMemberModifier(idToken))return!0;nextToken()}if(37===token)return!0;if(isLiteralPropertyName()&&(idToken=token,nextToken()),19===token)return!0;if(void 0!==idToken){if(!ts.isKeyword(idToken)||129===idToken||123===idToken)return!0;switch(token){case 17:case 25:case 54:case 56:case 53:return!0;default:return canParseSemicolon()}}return!1}function parseDecorators(){for(var decorators;;){var decoratorStart=getNodePos();if(!parseOptional(55))break;decorators||(decorators=[],decorators.pos=decoratorStart);var decorator=createNode(140,decoratorStart);decorator.expression=doInDecoratorContext(parseLeftHandSideExpressionOrHigher),decorators.push(finishNode(decorator))}return decorators&&(decorators.end=getNodeEnd()),decorators}function parseModifiers(permitInvalidConstAsModifier){for(var modifiers,flags=0;;){var modifierStart=scanner.getStartPos(),modifierKind=token;if(74===token&&permitInvalidConstAsModifier){if(!tryParse(nextTokenIsOnSameLineAndCanFollowModifier))break}else if(!parseAnyContextualModifier())break;modifiers||(modifiers=[],modifiers.pos=modifierStart),flags|=ts.modifierToFlag(modifierKind),modifiers.push(finishNode(createNode(modifierKind,modifierStart)))}return modifiers&&(modifiers.flags=flags,modifiers.end=scanner.getStartPos()),modifiers}function parseModifiersForArrowFunction(){var modifiers,flags=0;if(118===token){var modifierStart=scanner.getStartPos(),modifierKind=token;nextToken(),modifiers=[],modifiers.pos=modifierStart,flags|=ts.modifierToFlag(modifierKind),modifiers.push(finishNode(createNode(modifierKind,modifierStart))),modifiers.flags=flags,modifiers.end=scanner.getStartPos()}return modifiers}function parseClassElement(){if(23===token){var result=createNode(194);return nextToken(),finishNode(result)}var fullStart=getNodePos(),decorators=parseDecorators(),modifiers=parseModifiers(!0),accessor=tryParseAccessorDeclaration(fullStart,decorators,modifiers);if(accessor)return accessor;if(121===token)return parseConstructorDeclaration(fullStart,decorators,modifiers);if(isIndexSignature())return parseIndexSignatureDeclaration(fullStart,decorators,modifiers);if(ts.tokenIsIdentifierOrKeyword(token)||9===token||8===token||37===token||19===token)return parsePropertyOrMethodDeclaration(fullStart,decorators,modifiers);if(decorators||modifiers){var name_7=createMissingNode(69,!0,ts.Diagnostics.Declaration_expected);return parsePropertyDeclaration(fullStart,decorators,modifiers,name_7,void 0)}ts.Debug.fail("Should not have attempted to parse class member declaration.")}function parseClassExpression(){return parseClassDeclarationOrExpression(scanner.getStartPos(),void 0,void 0,189)}function parseClassDeclaration(fullStart,decorators,modifiers){return parseClassDeclarationOrExpression(fullStart,decorators,modifiers,217)}function parseClassDeclarationOrExpression(fullStart,decorators,modifiers,kind){var node=createNode(kind,fullStart);return node.decorators=decorators,setModifiers(node,modifiers),parseExpected(73),node.name=parseNameOfClassDeclarationOrExpression(),node.typeParameters=parseTypeParameters(),node.heritageClauses=parseHeritageClauses(!0),parseExpected(15)?(node.members=parseClassMembers(),parseExpected(16)):node.members=createMissingList(),finishNode(node)}function parseNameOfClassDeclarationOrExpression(){return isIdentifier()&&!isImplementsClause()?parseIdentifier():void 0}function isImplementsClause(){return 106===token&&lookAhead(nextTokenIsIdentifierOrKeyword)}function parseHeritageClauses(isClassHeritageClause){if(isHeritageClause())return parseList(20,parseHeritageClause)}function parseHeritageClause(){if(83===token||106===token){var node=createNode(246);return node.token=token,nextToken(),node.types=parseDelimitedList(7,parseExpressionWithTypeArguments),finishNode(node)}}function parseExpressionWithTypeArguments(){var node=createNode(191);return node.expression=parseLeftHandSideExpressionOrHigher(),25===token&&(node.typeArguments=parseBracketedList(18,parseType,25,27)),finishNode(node)}function isHeritageClause(){return 83===token||106===token}function parseClassMembers(){return parseList(5,parseClassElement)}function parseInterfaceDeclaration(fullStart,decorators,modifiers){var node=createNode(218,fullStart);return node.decorators=decorators,setModifiers(node,modifiers),parseExpected(107),node.name=parseIdentifier(),node.typeParameters=parseTypeParameters(),node.heritageClauses=parseHeritageClauses(!1),node.members=parseObjectTypeMembers(),finishNode(node)}function parseTypeAliasDeclaration(fullStart,decorators,modifiers){var node=createNode(219,fullStart);return node.decorators=decorators,setModifiers(node,modifiers),parseExpected(132),node.name=parseIdentifier(),node.typeParameters=parseTypeParameters(),parseExpected(56),node.type=parseType(),parseSemicolon(),finishNode(node)}function parseEnumMember(){var node=createNode(250,scanner.getStartPos());return node.name=parsePropertyName(),node.initializer=allowInAnd(parseNonParameterInitializer),finishNode(node)}function parseEnumDeclaration(fullStart,decorators,modifiers){var node=createNode(220,fullStart);return node.decorators=decorators,setModifiers(node,modifiers),parseExpected(81),node.name=parseIdentifier(),parseExpected(15)?(node.members=parseDelimitedList(6,parseEnumMember),parseExpected(16)):node.members=createMissingList(),finishNode(node)}function parseModuleBlock(){var node=createNode(222,scanner.getStartPos());return parseExpected(15)?(node.statements=parseList(1,parseStatement),parseExpected(16)):node.statements=createMissingList(),finishNode(node)}function parseModuleOrNamespaceDeclaration(fullStart,decorators,modifiers,flags){var node=createNode(221,fullStart),namespaceFlag=65536&flags;return node.decorators=decorators,setModifiers(node,modifiers),node.flags|=flags,node.name=parseIdentifier(),node.body=parseOptional(21)?parseModuleOrNamespaceDeclaration(getNodePos(),void 0,void 0,2|namespaceFlag):parseModuleBlock(),finishNode(node)}function parseAmbientExternalModuleDeclaration(fullStart,decorators,modifiers){var node=createNode(221,fullStart);return node.decorators=decorators,setModifiers(node,modifiers),134===token?(node.name=parseIdentifier(),node.flags|=2097152):node.name=parseLiteralNode(!0),node.body=parseModuleBlock(),finishNode(node)}function parseModuleDeclaration(fullStart,decorators,modifiers){var flags=modifiers?modifiers.flags:0;if(134===token)return parseAmbientExternalModuleDeclaration(fullStart,decorators,modifiers);if(parseOptional(126))flags|=65536;else if(parseExpected(125),9===token)return parseAmbientExternalModuleDeclaration(fullStart,decorators,modifiers);return parseModuleOrNamespaceDeclaration(fullStart,decorators,modifiers,flags)}function isExternalModuleReference(){return 127===token&&lookAhead(nextTokenIsOpenParen)}function nextTokenIsOpenParen(){return 17===nextToken()}function nextTokenIsSlash(){return 39===nextToken()}function parseImportDeclarationOrImportEqualsDeclaration(fullStart,decorators,modifiers){parseExpected(89);var identifier,afterImportPos=scanner.getStartPos();if(isIdentifier()&&(identifier=parseIdentifier(),24!==token&&133!==token)){var importEqualsDeclaration=createNode(224,fullStart);return importEqualsDeclaration.decorators=decorators,setModifiers(importEqualsDeclaration,modifiers),importEqualsDeclaration.name=identifier,parseExpected(56),importEqualsDeclaration.moduleReference=parseModuleReference(),parseSemicolon(),finishNode(importEqualsDeclaration)}var importDeclaration=createNode(225,fullStart);return importDeclaration.decorators=decorators,setModifiers(importDeclaration,modifiers),(identifier||37===token||15===token)&&(importDeclaration.importClause=parseImportClause(identifier,afterImportPos),parseExpected(133)),importDeclaration.moduleSpecifier=parseModuleSpecifier(),parseSemicolon(),finishNode(importDeclaration)}function parseImportClause(identifier,fullStart){var importClause=createNode(226,fullStart);return identifier&&(importClause.name=identifier),importClause.name&&!parseOptional(24)||(importClause.namedBindings=37===token?parseNamespaceImport():parseNamedImportsOrExports(228)),finishNode(importClause)}function parseModuleReference(){return isExternalModuleReference()?parseExternalModuleReference():parseEntityName(!1)}function parseExternalModuleReference(){var node=createNode(235);return parseExpected(127),parseExpected(17),node.expression=parseModuleSpecifier(),parseExpected(18),finishNode(node)}function parseModuleSpecifier(){if(9===token){var result=parseLiteralNode();return internIdentifier(result.text),result}return parseExpression()}function parseNamespaceImport(){var namespaceImport=createNode(227);return parseExpected(37),parseExpected(116),namespaceImport.name=parseIdentifier(),finishNode(namespaceImport)}function parseNamedImportsOrExports(kind){var node=createNode(kind);return node.elements=parseBracketedList(21,228===kind?parseImportSpecifier:parseExportSpecifier,15,16),finishNode(node)}function parseExportSpecifier(){return parseImportOrExportSpecifier(233)}function parseImportSpecifier(){return parseImportOrExportSpecifier(229)}function parseImportOrExportSpecifier(kind){var node=createNode(kind),checkIdentifierIsKeyword=ts.isKeyword(token)&&!isIdentifier(),checkIdentifierStart=scanner.getTokenPos(),checkIdentifierEnd=scanner.getTextPos(),identifierName=parseIdentifierName();return 116===token?(node.propertyName=identifierName,parseExpected(116),checkIdentifierIsKeyword=ts.isKeyword(token)&&!isIdentifier(),checkIdentifierStart=scanner.getTokenPos(),checkIdentifierEnd=scanner.getTextPos(),node.name=parseIdentifierName()):node.name=identifierName,229===kind&&checkIdentifierIsKeyword&&parseErrorAtPosition(checkIdentifierStart,checkIdentifierEnd-checkIdentifierStart,ts.Diagnostics.Identifier_expected),finishNode(node)}function parseExportDeclaration(fullStart,decorators,modifiers){var node=createNode(231,fullStart);return node.decorators=decorators,setModifiers(node,modifiers),parseOptional(37)?(parseExpected(133),node.moduleSpecifier=parseModuleSpecifier()):(node.exportClause=parseNamedImportsOrExports(232),(133===token||9===token&&!scanner.hasPrecedingLineBreak())&&(parseExpected(133),node.moduleSpecifier=parseModuleSpecifier())),parseSemicolon(),finishNode(node)}function parseExportAssignment(fullStart,decorators,modifiers){var node=createNode(230,fullStart);return node.decorators=decorators,setModifiers(node,modifiers),parseOptional(56)?node.isExportEquals=!0:parseExpected(77),node.expression=parseAssignmentExpressionOrHigher(),parseSemicolon(),finishNode(node)}function processReferenceComments(sourceFile){for(var amdModuleName,triviaScanner=ts.createScanner(sourceFile.languageVersion,!1,0,sourceText),referencedFiles=[],amdDependencies=[];;){var kind=triviaScanner.scan();if(2!==kind){if(ts.isTrivia(kind))continue;break}var range={pos:triviaScanner.getTokenPos(),end:triviaScanner.getTextPos(),kind:triviaScanner.getToken()},comment=sourceText.substring(range.pos,range.end),referencePathMatchResult=ts.getFileReferenceFromReferencePath(comment,range);if(referencePathMatchResult){var fileReference=referencePathMatchResult.fileReference;sourceFile.hasNoDefaultLib=referencePathMatchResult.isNoDefaultLib;var diagnosticMessage=referencePathMatchResult.diagnosticMessage;fileReference&&referencedFiles.push(fileReference),diagnosticMessage&&parseDiagnostics.push(ts.createFileDiagnostic(sourceFile,range.pos,range.end-range.pos,diagnosticMessage))}else{var amdModuleNameRegEx=/^\/\/\/\s*<amd-module\s+name\s*=\s*('|")(.+?)\1/gim,amdModuleNameMatchResult=amdModuleNameRegEx.exec(comment);amdModuleNameMatchResult&&(amdModuleName&&parseDiagnostics.push(ts.createFileDiagnostic(sourceFile,range.pos,range.end-range.pos,ts.Diagnostics.An_AMD_module_cannot_have_multiple_name_assignments)),amdModuleName=amdModuleNameMatchResult[2]);var amdDependencyRegEx=/^\/\/\/\s*<amd-dependency\s/gim,pathRegex=/\spath\s*=\s*('|")(.+?)\1/gim,nameRegex=/\sname\s*=\s*('|")(.+?)\1/gim,amdDependencyMatchResult=amdDependencyRegEx.exec(comment);if(amdDependencyMatchResult){var pathMatchResult=pathRegex.exec(comment),nameMatchResult=nameRegex.exec(comment);if(pathMatchResult){var amdDependency={path:pathMatchResult[2],name:nameMatchResult?nameMatchResult[2]:void 0};amdDependencies.push(amdDependency)}}}}sourceFile.referencedFiles=referencedFiles,sourceFile.amdDependencies=amdDependencies,sourceFile.moduleName=amdModuleName}function setExternalModuleIndicator(sourceFile){sourceFile.externalModuleIndicator=ts.forEach(sourceFile.statements,function(node){return 2&node.flags||224===node.kind&&235===node.moduleReference.kind||225===node.kind||230===node.kind||231===node.kind?node:void 0})}var NodeConstructor,SourceFileConstructor,sourceFile,parseDiagnostics,syntaxCursor,token,sourceText,nodeCount,identifiers,identifierCount,parsingContext,contextFlags,scanner=ts.createScanner(2,!0),disallowInAndDecoratorContext=5,parseErrorBeforeNextFinishedNode=!1;Parser.parseSourceFile=parseSourceFile,Parser.fixupParentReferences=fixupParentReferences;var ParsingContext;!function(ParsingContext){ParsingContext[ParsingContext.SourceElements=0]="SourceElements",ParsingContext[ParsingContext.BlockStatements=1]="BlockStatements",ParsingContext[ParsingContext.SwitchClauses=2]="SwitchClauses",ParsingContext[ParsingContext.SwitchClauseStatements=3]="SwitchClauseStatements",ParsingContext[ParsingContext.TypeMembers=4]="TypeMembers",ParsingContext[ParsingContext.ClassMembers=5]="ClassMembers",ParsingContext[ParsingContext.EnumMembers=6]="EnumMembers",ParsingContext[ParsingContext.HeritageClauseElement=7]="HeritageClauseElement",ParsingContext[ParsingContext.VariableDeclarations=8]="VariableDeclarations",ParsingContext[ParsingContext.ObjectBindingElements=9]="ObjectBindingElements",ParsingContext[ParsingContext.ArrayBindingElements=10]="ArrayBindingElements",ParsingContext[ParsingContext.ArgumentExpressions=11]="ArgumentExpressions",ParsingContext[ParsingContext.ObjectLiteralMembers=12]="ObjectLiteralMembers",ParsingContext[ParsingContext.JsxAttributes=13]="JsxAttributes",ParsingContext[ParsingContext.JsxChildren=14]="JsxChildren",ParsingContext[ParsingContext.ArrayLiteralMembers=15]="ArrayLiteralMembers",ParsingContext[ParsingContext.Parameters=16]="Parameters",ParsingContext[ParsingContext.TypeParameters=17]="TypeParameters",ParsingContext[ParsingContext.TypeArguments=18]="TypeArguments",ParsingContext[ParsingContext.TupleElementTypes=19]="TupleElementTypes",ParsingContext[ParsingContext.HeritageClauses=20]="HeritageClauses",ParsingContext[ParsingContext.ImportOrExportSpecifiers=21]="ImportOrExportSpecifiers",ParsingContext[ParsingContext.JSDocFunctionParameters=22]="JSDocFunctionParameters",ParsingContext[ParsingContext.JSDocTypeArguments=23]="JSDocTypeArguments",ParsingContext[ParsingContext.JSDocRecordMembers=24]="JSDocRecordMembers",ParsingContext[ParsingContext.JSDocTupleTypes=25]="JSDocTupleTypes",ParsingContext[ParsingContext.Count=26]="Count"}(ParsingContext||(ParsingContext={}));var Tristate;!function(Tristate){Tristate[Tristate.False=0]="False",Tristate[Tristate.True=1]="True",Tristate[Tristate.Unknown=2]="Unknown"}(Tristate||(Tristate={}));var JSDocParser;!function(JSDocParser){function isJSDocType(){switch(token){case 37:case 53:case 17:case 19:case 49:case 15:case 87:case 22:case 92:case 97:return!0}return ts.tokenIsIdentifierOrKeyword(token)}function parseJSDocTypeExpressionForTests(content,start,length){initializeState("file.js",content,2,!0,void 0),scanner.setText(content,start,length),token=scanner.scan();var jsDocTypeExpression=parseJSDocTypeExpression(),diagnostics=parseDiagnostics;return clearState(),jsDocTypeExpression?{jsDocTypeExpression:jsDocTypeExpression,diagnostics:diagnostics}:void 0}function parseJSDocTypeExpression(){var result=createNode(252,scanner.getTokenPos());return parseExpected(15),result.type=parseJSDocTopLevelType(),parseExpected(16),fixupParentReferences(result),finishNode(result)}function parseJSDocTopLevelType(){var type=parseJSDocType();if(47===token){var unionType=createNode(256,type.pos);unionType.types=parseJSDocTypeList(type),type=finishNode(unionType)}if(56===token){var optionalType=createNode(263,type.pos);nextToken(),optionalType.type=type,type=finishNode(optionalType)}return type}function parseJSDocType(){for(var type=parseBasicTypeExpression();;)if(19===token){var arrayType=createNode(255,type.pos);arrayType.elementType=type,nextToken(),parseExpected(20),type=finishNode(arrayType)}else if(53===token){var nullableType=createNode(258,type.pos);nullableType.type=type,nextToken(),type=finishNode(nullableType)}else{if(49!==token)break;var nonNullableType=createNode(259,type.pos);nonNullableType.type=type,nextToken(),type=finishNode(nonNullableType)}return type}function parseBasicTypeExpression(){switch(token){case 37:return parseJSDocAllType();case 53:return parseJSDocUnknownOrNullableType();case 17:return parseJSDocUnionType();case 19:return parseJSDocTupleType();case 49:return parseJSDocNonNullableType();case 15:return parseJSDocRecordType();case 87:return parseJSDocFunctionType();case 22:return parseJSDocVariadicType();case 92:return parseJSDocConstructorType();case 97:return parseJSDocThisType();case 117:case 130:case 128:case 120:case 131:case 103:return parseTokenNode()}return parseJSDocTypeReference()}function parseJSDocThisType(){var result=createNode(267);return nextToken(),parseExpected(54),result.type=parseJSDocType(),finishNode(result)}function parseJSDocConstructorType(){var result=createNode(266);return nextToken(),parseExpected(54),result.type=parseJSDocType(),finishNode(result)}function parseJSDocVariadicType(){var result=createNode(265);return nextToken(),result.type=parseJSDocType(),finishNode(result)}function parseJSDocFunctionType(){var result=createNode(264);return nextToken(),parseExpected(17),result.parameters=parseDelimitedList(22,parseJSDocParameter),checkForTrailingComma(result.parameters),parseExpected(18),54===token&&(nextToken(),result.type=parseJSDocType()),finishNode(result)}function parseJSDocParameter(){var parameter=createNode(139);return parameter.type=parseJSDocType(),parseOptional(56)&&(parameter.questionToken=createNode(56)),finishNode(parameter)}function parseJSDocTypeReference(){var result=createNode(262);if(result.name=parseSimplePropertyName(),25===token)result.typeArguments=parseTypeArguments();else for(;parseOptional(21);){if(25===token){result.typeArguments=parseTypeArguments();break}result.name=parseQualifiedName(result.name)}return finishNode(result)}function parseTypeArguments(){nextToken();var typeArguments=parseDelimitedList(23,parseJSDocType);return checkForTrailingComma(typeArguments),checkForEmptyTypeArgumentList(typeArguments),parseExpected(27),typeArguments}function checkForEmptyTypeArgumentList(typeArguments){if(0===parseDiagnostics.length&&typeArguments&&0===typeArguments.length){var start=typeArguments.pos-"<".length,end=ts.skipTrivia(sourceText,typeArguments.end)+">".length;return parseErrorAtPosition(start,end-start,ts.Diagnostics.Type_argument_list_cannot_be_empty)}}function parseQualifiedName(left){var result=createNode(136,left.pos);return result.left=left,result.right=parseIdentifierName(),finishNode(result)}function parseJSDocRecordType(){var result=createNode(260);return nextToken(),result.members=parseDelimitedList(24,parseJSDocRecordMember),checkForTrailingComma(result.members),parseExpected(16),finishNode(result)}function parseJSDocRecordMember(){var result=createNode(261);return result.name=parseSimplePropertyName(),54===token&&(nextToken(),result.type=parseJSDocType()),finishNode(result)}function parseJSDocNonNullableType(){var result=createNode(259);return nextToken(),result.type=parseJSDocType(),finishNode(result)}function parseJSDocTupleType(){var result=createNode(257);return nextToken(),result.types=parseDelimitedList(25,parseJSDocType),checkForTrailingComma(result.types),parseExpected(20),finishNode(result)}function checkForTrailingComma(list){if(0===parseDiagnostics.length&&list.hasTrailingComma){var start=list.end-",".length;parseErrorAtPosition(start,",".length,ts.Diagnostics.Trailing_comma_not_allowed)}}function parseJSDocUnionType(){var result=createNode(256);return nextToken(),result.types=parseJSDocTypeList(parseJSDocType()),parseExpected(18),finishNode(result)}function parseJSDocTypeList(firstType){ts.Debug.assert(!!firstType);var types=[];for(types.pos=firstType.pos,types.push(firstType);parseOptional(47);)types.push(parseJSDocType());return types.end=scanner.getStartPos(),types}function parseJSDocAllType(){var result=createNode(253);return nextToken(),finishNode(result)}function parseJSDocUnknownOrNullableType(){var pos=scanner.getStartPos();if(nextToken(),24===token||16===token||18===token||27===token||56===token||47===token){var result=createNode(254,pos);return finishNode(result)}var result=createNode(258,pos);return result.type=parseJSDocType(),finishNode(result)}function parseIsolatedJSDocComment(content,start,length){initializeState("file.js",content,2,!0,void 0),sourceFile={languageVariant:0,text:content};var jsDocComment=parseJSDocCommentWorker(start,length),diagnostics=parseDiagnostics;return clearState(),jsDocComment?{jsDocComment:jsDocComment,diagnostics:diagnostics}:void 0}function parseJSDocComment(parent,start,length){var saveToken=token,saveParseDiagnosticsLength=parseDiagnostics.length,saveParseErrorBeforeNextFinishedNode=parseErrorBeforeNextFinishedNode,comment=parseJSDocCommentWorker(start,length);return comment&&(comment.parent=parent),token=saveToken,parseDiagnostics.length=saveParseDiagnosticsLength,parseErrorBeforeNextFinishedNode=saveParseErrorBeforeNextFinishedNode,comment}function parseJSDocCommentWorker(start,length){function createJSDocComment(){if(tags){var result=createNode(268,start);return result.tags=tags,finishNode(result,end)}}function skipWhitespace(){for(;5===token||4===token;)nextJSDocToken()}function parseTag(){ts.Debug.assert(55===token);var atToken=createNode(55,scanner.getTokenPos());atToken.end=scanner.getTextPos(),nextJSDocToken();var tagName=parseJSDocIdentifier();if(tagName){var tag=handleTag(atToken,tagName)||handleUnknownTag(atToken,tagName);addTag(tag)}}function handleTag(atToken,tagName){if(tagName)switch(tagName.text){case"param":return handleParamTag(atToken,tagName);case"return":case"returns":return handleReturnTag(atToken,tagName);case"template":return handleTemplateTag(atToken,tagName);case"type":return handleTypeTag(atToken,tagName)}}function handleUnknownTag(atToken,tagName){var result=createNode(269,atToken.pos);return result.atToken=atToken,result.tagName=tagName,finishNode(result)}function addTag(tag){tag&&(tags||(tags=[],tags.pos=tag.pos),tags.push(tag),tags.end=tag.end)}function tryParseTypeExpression(){if(15===token){var typeExpression=parseJSDocTypeExpression();return typeExpression}}function handleParamTag(atToken,tagName){var typeExpression=tryParseTypeExpression();skipWhitespace();var name,isBracketed;if(parseOptionalToken(19)?(name=parseJSDocIdentifier(),isBracketed=!0,parseOptionalToken(56)&&parseExpression(),parseExpected(20)):69===token&&(name=parseJSDocIdentifier()),!name)return void parseErrorAtPosition(scanner.getStartPos(),0,ts.Diagnostics.Identifier_expected);var preName,postName;typeExpression?postName=name:preName=name,typeExpression||(typeExpression=tryParseTypeExpression());var result=createNode(270,atToken.pos);return result.atToken=atToken,result.tagName=tagName,result.preParameterName=preName,result.typeExpression=typeExpression,result.postParameterName=postName,result.isBracketed=isBracketed,finishNode(result)}function handleReturnTag(atToken,tagName){ts.forEach(tags,function(t){return 271===t.kind})&&parseErrorAtPosition(tagName.pos,scanner.getTokenPos()-tagName.pos,ts.Diagnostics._0_tag_already_specified,tagName.text);var result=createNode(271,atToken.pos);return result.atToken=atToken,result.tagName=tagName,result.typeExpression=tryParseTypeExpression(),finishNode(result)}function handleTypeTag(atToken,tagName){ts.forEach(tags,function(t){return 272===t.kind})&&parseErrorAtPosition(tagName.pos,scanner.getTokenPos()-tagName.pos,ts.Diagnostics._0_tag_already_specified,tagName.text);var result=createNode(272,atToken.pos);return result.atToken=atToken,result.tagName=tagName,result.typeExpression=tryParseTypeExpression(),finishNode(result)}function handleTemplateTag(atToken,tagName){ts.forEach(tags,function(t){return 273===t.kind})&&parseErrorAtPosition(tagName.pos,scanner.getTokenPos()-tagName.pos,ts.Diagnostics._0_tag_already_specified,tagName.text);var typeParameters=[];for(typeParameters.pos=scanner.getStartPos();;){var name_8=parseJSDocIdentifier();if(!name_8)return void parseErrorAtPosition(scanner.getStartPos(),0,ts.Diagnostics.Identifier_expected);var typeParameter=createNode(138,name_8.pos);if(typeParameter.name=name_8,finishNode(typeParameter),typeParameters.push(typeParameter),24!==token)break;nextJSDocToken()}var result=createNode(273,atToken.pos);return result.atToken=atToken,result.tagName=tagName,result.typeParameters=typeParameters,finishNode(result),typeParameters.end=result.end,result}function nextJSDocToken(){return token=scanner.scanJSDocToken()}function parseJSDocIdentifier(){if(69!==token)return void parseErrorAtCurrentToken(ts.Diagnostics.Identifier_expected);var pos=scanner.getTokenPos(),end=scanner.getTextPos(),result=createNode(69,pos);return result.text=content.substring(pos,end),finishNode(result,end),nextJSDocToken(),result}var content=sourceText;start=start||0;var end=void 0===length?content.length:start+length;length=end-start,ts.Debug.assert(start>=0),ts.Debug.assert(start<=end),ts.Debug.assert(end<=content.length);var tags,result;return 47===content.charCodeAt(start)&&42===content.charCodeAt(start+1)&&42===content.charCodeAt(start+2)&&42!==content.charCodeAt(start+3)&&scanner.scanRange(start+3,length-5,function(){var canParseTag=!0,seenAsterisk=!0;for(nextJSDocToken();1!==token;){switch(token){case 55:canParseTag&&parseTag(),seenAsterisk=!1;break;case 4:canParseTag=!0,seenAsterisk=!1;break;case 37:seenAsterisk&&(canParseTag=!1),seenAsterisk=!0;break;case 69:canParseTag=!1;break;case 1:}nextJSDocToken()}result=createJSDocComment()}),result}JSDocParser.isJSDocType=isJSDocType,JSDocParser.parseJSDocTypeExpressionForTests=parseJSDocTypeExpressionForTests,JSDocParser.parseJSDocTypeExpression=parseJSDocTypeExpression,JSDocParser.parseIsolatedJSDocComment=parseIsolatedJSDocComment,JSDocParser.parseJSDocComment=parseJSDocComment,JSDocParser.parseJSDocCommentWorker=parseJSDocCommentWorker}(JSDocParser=Parser.JSDocParser||(Parser.JSDocParser={}))}(Parser||(Parser={}));var IncrementalParser;!function(IncrementalParser){function updateSourceFile(sourceFile,newText,textChangeRange,aggressiveChecks){if(aggressiveChecks=aggressiveChecks||ts.Debug.shouldAssert(2),checkChangeRange(sourceFile,newText,textChangeRange,aggressiveChecks),ts.textChangeRangeIsUnchanged(textChangeRange))return sourceFile;if(0===sourceFile.statements.length)return Parser.parseSourceFile(sourceFile.fileName,newText,sourceFile.languageVersion,void 0,!0);var incrementalSourceFile=sourceFile;ts.Debug.assert(!incrementalSourceFile.hasBeenIncrementallyParsed),incrementalSourceFile.hasBeenIncrementallyParsed=!0;var oldText=sourceFile.text,syntaxCursor=createSyntaxCursor(sourceFile),changeRange=extendToAffectedRange(sourceFile,textChangeRange);checkChangeRange(sourceFile,newText,changeRange,aggressiveChecks),ts.Debug.assert(changeRange.span.start<=textChangeRange.span.start),ts.Debug.assert(ts.textSpanEnd(changeRange.span)===ts.textSpanEnd(textChangeRange.span)),ts.Debug.assert(ts.textSpanEnd(ts.textChangeRangeNewSpan(changeRange))===ts.textSpanEnd(ts.textChangeRangeNewSpan(textChangeRange)));var delta=ts.textChangeRangeNewSpan(changeRange).length-changeRange.span.length;updateTokenPositionsAndMarkElements(incrementalSourceFile,changeRange.span.start,ts.textSpanEnd(changeRange.span),ts.textSpanEnd(ts.textChangeRangeNewSpan(changeRange)),delta,oldText,newText,aggressiveChecks);var result=Parser.parseSourceFile(sourceFile.fileName,newText,sourceFile.languageVersion,syntaxCursor,!0);return result}function moveElementEntirelyPastChangeRange(element,isArray,delta,oldText,newText,aggressiveChecks){function visitNode(node){var text="";aggressiveChecks&&shouldCheckNode(node)&&(text=oldText.substring(node.pos,node.end)),node._children&&(node._children=void 0),node.jsDocComment&&(node.jsDocComment=void 0),node.pos+=delta,node.end+=delta,aggressiveChecks&&shouldCheckNode(node)&&ts.Debug.assert(text===newText.substring(node.pos,node.end)),forEachChild(node,visitNode,visitArray),checkNodePositions(node,aggressiveChecks)}function visitArray(array){array._children=void 0,array.pos+=delta,array.end+=delta;for(var _i=0,array_7=array;_i<array_7.length;_i++){var node=array_7[_i];visitNode(node)}}isArray?visitArray(element):visitNode(element)}function shouldCheckNode(node){switch(node.kind){case 9:case 8:case 69:return!0}return!1}function adjustIntersectingElement(element,changeStart,changeRangeOldEnd,changeRangeNewEnd,delta){ts.Debug.assert(element.end>=changeStart,"Adjusting an element that was entirely before the change range"),ts.Debug.assert(element.pos<=changeRangeOldEnd,"Adjusting an element that was entirely after the change range"),ts.Debug.assert(element.pos<=element.end),element.pos=Math.min(element.pos,changeRangeNewEnd),element.end>=changeRangeOldEnd?element.end+=delta:element.end=Math.min(element.end,changeRangeNewEnd),ts.Debug.assert(element.pos<=element.end),element.parent&&(ts.Debug.assert(element.pos>=element.parent.pos),ts.Debug.assert(element.end<=element.parent.end))}function checkNodePositions(node,aggressiveChecks){if(aggressiveChecks){var pos_2=node.pos;forEachChild(node,function(child){ts.Debug.assert(child.pos>=pos_2),pos_2=child.end}),ts.Debug.assert(pos_2<=node.end)}}function updateTokenPositionsAndMarkElements(sourceFile,changeStart,changeRangeOldEnd,changeRangeNewEnd,delta,oldText,newText,aggressiveChecks){function visitNode(child){if(ts.Debug.assert(child.pos<=child.end),child.pos>changeRangeOldEnd)return void moveElementEntirelyPastChangeRange(child,!1,delta,oldText,newText,aggressiveChecks);var fullEnd=child.end;return fullEnd>=changeStart?(child.intersectsChange=!0,child._children=void 0,adjustIntersectingElement(child,changeStart,changeRangeOldEnd,changeRangeNewEnd,delta),forEachChild(child,visitNode,visitArray),void checkNodePositions(child,aggressiveChecks)):void ts.Debug.assert(fullEnd<changeStart)}function visitArray(array){if(ts.Debug.assert(array.pos<=array.end),array.pos>changeRangeOldEnd)return void moveElementEntirelyPastChangeRange(array,!0,delta,oldText,newText,aggressiveChecks);var fullEnd=array.end;if(fullEnd>=changeStart){array.intersectsChange=!0,array._children=void 0,adjustIntersectingElement(array,changeStart,changeRangeOldEnd,changeRangeNewEnd,delta);for(var _i=0,array_8=array;_i<array_8.length;_i++){var node=array_8[_i];visitNode(node)}}else ts.Debug.assert(fullEnd<changeStart)}visitNode(sourceFile)}function extendToAffectedRange(sourceFile,changeRange){for(var maxLookahead=1,start=changeRange.span.start,i=0;start>0&&i<=maxLookahead;i++){var nearestNode=findNearestNodeStartingBeforeOrAtPosition(sourceFile,start);ts.Debug.assert(nearestNode.pos<=start);var position=nearestNode.pos;start=Math.max(0,position-1)}var finalSpan=ts.createTextSpanFromBounds(start,ts.textSpanEnd(changeRange.span)),finalLength=changeRange.newLength+(changeRange.span.start-start);return ts.createTextChangeRange(finalSpan,finalLength)}function findNearestNodeStartingBeforeOrAtPosition(sourceFile,position){
function getLastChild(node){for(;;){var lastChild=getLastChildWorker(node);if(!lastChild)return node;node=lastChild}}function getLastChildWorker(node){var last=void 0;return forEachChild(node,function(child){ts.nodeIsPresent(child)&&(last=child)}),last}function visit(child){if(!ts.nodeIsMissing(child))return child.pos<=position?(child.pos>=bestResult.pos&&(bestResult=child),position<child.end?(forEachChild(child,visit),!0):(ts.Debug.assert(child.end<=position),void(lastNodeEntirelyBeforePosition=child))):(ts.Debug.assert(child.pos>position),!0)}var lastNodeEntirelyBeforePosition,bestResult=sourceFile;if(forEachChild(sourceFile,visit),lastNodeEntirelyBeforePosition){var lastChildOfLastEntireNodeBeforePosition=getLastChild(lastNodeEntirelyBeforePosition);lastChildOfLastEntireNodeBeforePosition.pos>bestResult.pos&&(bestResult=lastChildOfLastEntireNodeBeforePosition)}return bestResult}function checkChangeRange(sourceFile,newText,textChangeRange,aggressiveChecks){var oldText=sourceFile.text;if(textChangeRange&&(ts.Debug.assert(oldText.length-textChangeRange.span.length+textChangeRange.newLength===newText.length),aggressiveChecks||ts.Debug.shouldAssert(3))){var oldTextPrefix=oldText.substr(0,textChangeRange.span.start),newTextPrefix=newText.substr(0,textChangeRange.span.start);ts.Debug.assert(oldTextPrefix===newTextPrefix);var oldTextSuffix=oldText.substring(ts.textSpanEnd(textChangeRange.span),oldText.length),newTextSuffix=newText.substring(ts.textSpanEnd(ts.textChangeRangeNewSpan(textChangeRange)),newText.length);ts.Debug.assert(oldTextSuffix===newTextSuffix)}}function createSyntaxCursor(sourceFile){function findHighestListElementThatStartsAtPosition(position){function visitNode(node){return position>=node.pos&&position<node.end&&(forEachChild(node,visitNode,visitArray),!0)}function visitArray(array){if(position>=array.pos&&position<array.end)for(var i=0,n=array.length;i<n;i++){var child=array[i];if(child){if(child.pos===position)return currentArray=array,currentArrayIndex=i,current=child,!0;if(child.pos<position&&position<child.end)return forEachChild(child,visitNode,visitArray),!0}}return!1}currentArray=void 0,currentArrayIndex=-1,current=void 0,forEachChild(sourceFile,visitNode,visitArray)}var currentArray=sourceFile.statements,currentArrayIndex=0;ts.Debug.assert(currentArrayIndex<currentArray.length);var current=currentArray[currentArrayIndex],lastQueriedPosition=-1;return{currentNode:function(position){return position!==lastQueriedPosition&&(current&&current.end===position&&currentArrayIndex<currentArray.length-1&&(currentArrayIndex++,current=currentArray[currentArrayIndex]),current&&current.pos===position||findHighestListElementThatStartsAtPosition(position)),lastQueriedPosition=position,ts.Debug.assert(!current||current.pos===position),current}}}IncrementalParser.updateSourceFile=updateSourceFile;var InvalidPosition;!function(InvalidPosition){InvalidPosition[InvalidPosition.Value=-1]="Value"}(InvalidPosition||(InvalidPosition={}))}(IncrementalParser||(IncrementalParser={}))}(ts||(ts={}));var ts;!function(ts){function or(state1,state2){return 2&(state1|state2)?2:state1&state2&8?8:4}function getModuleInstanceState(node){if(218===node.kind||219===node.kind)return 0;if(ts.isConstEnumDeclaration(node))return 2;if(225!==node.kind&&224!==node.kind||2&node.flags){if(222===node.kind){var state_1=0;return ts.forEachChild(node,function(n){switch(getModuleInstanceState(n)){case 0:return!1;case 2:return state_1=2,!1;case 1:return state_1=1,!0}}),state_1}return 221===node.kind?getModuleInstanceState(node.body):1}return 0}function bindSourceFile(file,options){var start=(new Date).getTime();binder(file,options),ts.bindTime+=(new Date).getTime()-start}function createBinder(){function bindSourceFile(f,opts){file=f,options=opts,inStrictMode=!!file.externalModuleIndicator,classifiableNames={},Symbol=ts.objectAllocator.getSymbolConstructor(),file.locals||(bind(file),file.symbolCount=symbolCount,file.classifiableNames=classifiableNames),file=void 0,options=void 0,parent=void 0,container=void 0,blockScopeContainer=void 0,lastContainer=void 0,seenThisKeyword=!1,hasExplicitReturn=!1,labelStack=void 0,labelIndexMap=void 0,implicitLabels=void 0,hasClassExtends=!1,hasAsyncFunctions=!1,hasDecorators=!1,hasParameterDecorators=!1}function createSymbol(flags,name){return symbolCount++,new Symbol(flags,name)}function addDeclarationToSymbol(symbol,node,symbolFlags){if(symbol.flags|=symbolFlags,node.symbol=symbol,symbol.declarations||(symbol.declarations=[]),symbol.declarations.push(node),1952&symbolFlags&&!symbol.exports&&(symbol.exports={}),6240&symbolFlags&&!symbol.members&&(symbol.members={}),107455&symbolFlags){var valueDeclaration=symbol.valueDeclaration;(!valueDeclaration||valueDeclaration.kind!==node.kind&&221===valueDeclaration.kind)&&(symbol.valueDeclaration=node)}}function getDeclarationName(node){if(node.name){if(ts.isAmbientModule(node))return ts.isGlobalScopeAugmentation(node)?"__global":'"'+node.name.text+'"';if(137===node.name.kind){var nameExpression=node.name.expression;return ts.isStringOrNumericLiteral(nameExpression.kind)?nameExpression.text:(ts.Debug.assert(ts.isWellKnownSymbolSyntactically(nameExpression)),ts.getPropertyNameForKnownSymbolName(nameExpression.name.text))}return node.name.text}switch(node.kind){case 145:return"__constructor";case 153:case 148:return"__call";case 154:case 149:return"__new";case 150:return"__index";case 231:return"__export";case 230:return node.isExportEquals?"export=":"default";case 184:switch(ts.getSpecialPropertyAssignmentKind(node)){case 2:return"export=";case 1:case 4:return node.left.name.text;case 3:return node.left.expression.name.text}ts.Debug.fail("Unknown binary declaration kind");break;case 216:case 217:return 512&node.flags?"default":void 0;case 264:return ts.isJSDocConstructSignature(node)?"__new":"__call";case 139:ts.Debug.assert(264===node.parent.kind);var functionType=node.parent,index=ts.indexOf(functionType.parameters,node);return"p"+index}}function getDisplayName(node){return node.name?ts.declarationNameToString(node.name):getDeclarationName(node)}function declareSymbol(symbolTable,parent,node,includes,excludes){ts.Debug.assert(!ts.hasDynamicName(node));var symbol,isDefaultExport=512&node.flags,name=isDefaultExport&&parent?"default":getDeclarationName(node);if(void 0!==name){if(symbol=ts.hasProperty(symbolTable,name)?symbolTable[name]:symbolTable[name]=createSymbol(0,name),name&&788448&includes&&(classifiableNames[name]=name),symbol.flags&excludes){node.name&&(node.name.parent=node);var message_1=2&symbol.flags?ts.Diagnostics.Cannot_redeclare_block_scoped_variable_0:ts.Diagnostics.Duplicate_identifier_0;ts.forEach(symbol.declarations,function(declaration){512&declaration.flags&&(message_1=ts.Diagnostics.A_module_cannot_have_multiple_default_exports)}),ts.forEach(symbol.declarations,function(declaration){file.bindDiagnostics.push(ts.createDiagnosticForNode(declaration.name||declaration,message_1,getDisplayName(declaration)))}),file.bindDiagnostics.push(ts.createDiagnosticForNode(node.name||node,message_1,getDisplayName(node))),symbol=createSymbol(0,name)}}else symbol=createSymbol(0,"__missing");return addDeclarationToSymbol(symbol,node,includes),symbol.parent=parent,symbol}function declareModuleMember(node,symbolFlags,symbolExcludes){var hasExportModifier=2&ts.getCombinedNodeFlags(node);if(8388608&symbolFlags)return 233===node.kind||224===node.kind&&hasExportModifier?declareSymbol(container.symbol.exports,container.symbol,node,symbolFlags,symbolExcludes):declareSymbol(container.locals,void 0,node,symbolFlags,symbolExcludes);if(!ts.isAmbientModule(node)&&(hasExportModifier||131072&container.flags)){var exportKind=(107455&symbolFlags?1048576:0)|(793056&symbolFlags?2097152:0)|(1536&symbolFlags?4194304:0),local=declareSymbol(container.locals,void 0,node,exportKind,symbolExcludes);return local.exportSymbol=declareSymbol(container.symbol.exports,container.symbol,node,symbolFlags,symbolExcludes),node.localSymbol=local,local}return declareSymbol(container.locals,void 0,node,symbolFlags,symbolExcludes)}function bindChildren(node){var saveParent=parent,saveContainer=container,savedBlockScopeContainer=blockScopeContainer;parent=node;var containerFlags=getContainerFlags(node);1&containerFlags?(container=blockScopeContainer=node,4&containerFlags&&(container.locals={}),addToContainerChain(container)):2&containerFlags&&(blockScopeContainer=node,blockScopeContainer.locals=void 0);var savedReachabilityState,savedLabelStack,savedLabels,savedImplicitLabels,savedHasExplicitReturn,kind=node.kind,flags=node.flags;flags&=-1572865,flags&=-62914561,218===kind&&(seenThisKeyword=!1);var saveState=251===kind||222===kind||ts.isFunctionLikeKind(kind);saveState&&(savedReachabilityState=currentReachabilityState,savedLabelStack=labelStack,savedLabels=labelIndexMap,savedImplicitLabels=implicitLabels,savedHasExplicitReturn=hasExplicitReturn,currentReachabilityState=2,hasExplicitReturn=!1,labelStack=labelIndexMap=implicitLabels=void 0),ts.isInJavaScriptFile(node)&&node.jsDocComment&&bind(node.jsDocComment),bindReachableStatement(node),2===currentReachabilityState&&ts.isFunctionLikeKind(kind)&&ts.nodeIsPresent(node.body)&&(flags|=524288,hasExplicitReturn&&(flags|=1048576)),218===kind&&(flags=seenThisKeyword?262144|flags:flags&-262145),251===kind&&(hasClassExtends&&(flags|=4194304),hasDecorators&&(flags|=8388608),hasParameterDecorators&&(flags|=16777216),hasAsyncFunctions&&(flags|=33554432)),node.flags=flags,saveState&&(hasExplicitReturn=savedHasExplicitReturn,currentReachabilityState=savedReachabilityState,labelStack=savedLabelStack,labelIndexMap=savedLabels,implicitLabels=savedImplicitLabels),container=saveContainer,parent=saveParent,blockScopeContainer=savedBlockScopeContainer}function bindReachableStatement(node){if(checkUnreachable(node))return void ts.forEachChild(node,bind);switch(node.kind){case 201:bindWhileStatement(node);break;case 200:bindDoStatement(node);break;case 202:bindForStatement(node);break;case 203:case 204:bindForInOrForOfStatement(node);break;case 199:bindIfStatement(node);break;case 207:case 211:bindReturnOrThrow(node);break;case 206:case 205:bindBreakOrContinueStatement(node);break;case 212:bindTryStatement(node);break;case 209:bindSwitchStatement(node);break;case 223:bindCaseBlock(node);break;case 210:bindLabeledStatement(node);break;default:ts.forEachChild(node,bind)}}function bindWhileStatement(n){var preWhileState=84===n.expression.kind?4:currentReachabilityState,postWhileState=99===n.expression.kind?4:currentReachabilityState;bind(n.expression),currentReachabilityState=preWhileState;var postWhileLabel=pushImplicitLabel();bind(n.statement),popImplicitLabel(postWhileLabel,postWhileState)}function bindDoStatement(n){var preDoState=currentReachabilityState,postDoLabel=pushImplicitLabel();bind(n.statement);var postDoState=99===n.expression.kind?4:preDoState;popImplicitLabel(postDoLabel,postDoState),bind(n.expression)}function bindForStatement(n){var preForState=currentReachabilityState,postForLabel=pushImplicitLabel();bind(n.initializer),bind(n.condition),bind(n.incrementor),bind(n.statement);var isInfiniteLoop=!n.condition||99===n.condition.kind,postForState=isInfiniteLoop?4:preForState;popImplicitLabel(postForLabel,postForState)}function bindForInOrForOfStatement(n){var preStatementState=currentReachabilityState,postStatementLabel=pushImplicitLabel();bind(n.initializer),bind(n.expression),bind(n.statement),popImplicitLabel(postStatementLabel,preStatementState)}function bindIfStatement(n){var ifTrueState=84===n.expression.kind?4:currentReachabilityState,ifFalseState=99===n.expression.kind?4:currentReachabilityState;if(currentReachabilityState=ifTrueState,bind(n.expression),bind(n.thenStatement),n.elseStatement){var preElseState=currentReachabilityState;currentReachabilityState=ifFalseState,bind(n.elseStatement),currentReachabilityState=or(currentReachabilityState,preElseState)}else currentReachabilityState=or(currentReachabilityState,ifFalseState)}function bindReturnOrThrow(n){bind(n.expression),207===n.kind&&(hasExplicitReturn=!0),currentReachabilityState=4}function bindBreakOrContinueStatement(n){bind(n.label);var isValidJump=jumpToLabel(n.label,206===n.kind?currentReachabilityState:4);isValidJump&&(currentReachabilityState=4)}function bindTryStatement(n){var preTryState=currentReachabilityState;bind(n.tryBlock);var postTryState=currentReachabilityState;currentReachabilityState=preTryState,bind(n.catchClause);var postCatchState=currentReachabilityState;currentReachabilityState=preTryState,bind(n.finallyBlock),currentReachabilityState=or(postTryState,postCatchState)}function bindSwitchStatement(n){var preSwitchState=currentReachabilityState,postSwitchLabel=pushImplicitLabel();bind(n.expression),bind(n.caseBlock);var hasDefault=ts.forEach(n.caseBlock.clauses,function(c){return 245===c.kind}),postSwitchState=hasDefault&&2!==currentReachabilityState?4:preSwitchState;popImplicitLabel(postSwitchLabel,postSwitchState)}function bindCaseBlock(n){for(var startState=currentReachabilityState,_i=0,_a=n.clauses;_i<_a.length;_i++){var clause=_a[_i];currentReachabilityState=startState,bind(clause),clause.statements.length&&2===currentReachabilityState&&options.noFallthroughCasesInSwitch&&errorOnFirstToken(clause,ts.Diagnostics.Fallthrough_case_in_switch)}}function bindLabeledStatement(n){bind(n.label);var ok=pushNamedLabel(n.label);bind(n.statement),ok&&popNamedLabel(n.label,currentReachabilityState)}function getContainerFlags(node){switch(node.kind){case 189:case 217:case 218:case 220:case 168:case 156:case 260:return 1;case 148:case 149:case 150:case 144:case 143:case 216:case 145:case 146:case 147:case 153:case 154:case 176:case 177:case 221:case 251:case 219:return 5;case 247:case 202:case 203:case 204:case 223:return 2;case 195:return ts.isFunctionLike(node.parent)?0:2}return 0}function addToContainerChain(next){lastContainer&&(lastContainer.nextContainer=next),lastContainer=next}function declareSymbolAndAddToSymbolTable(node,symbolFlags,symbolExcludes){declareSymbolAndAddToSymbolTableWorker(node,symbolFlags,symbolExcludes)}function declareSymbolAndAddToSymbolTableWorker(node,symbolFlags,symbolExcludes){switch(container.kind){case 221:return declareModuleMember(node,symbolFlags,symbolExcludes);case 251:return declareSourceFileMember(node,symbolFlags,symbolExcludes);case 189:case 217:return declareClassMember(node,symbolFlags,symbolExcludes);case 220:return declareSymbol(container.symbol.exports,container.symbol,node,symbolFlags,symbolExcludes);case 156:case 168:case 218:case 260:return declareSymbol(container.symbol.members,container.symbol,node,symbolFlags,symbolExcludes);case 153:case 154:case 148:case 149:case 150:case 144:case 143:case 145:case 146:case 147:case 216:case 176:case 177:case 264:case 219:return declareSymbol(container.locals,void 0,node,symbolFlags,symbolExcludes)}}function declareClassMember(node,symbolFlags,symbolExcludes){return 64&node.flags?declareSymbol(container.symbol.exports,container.symbol,node,symbolFlags,symbolExcludes):declareSymbol(container.symbol.members,container.symbol,node,symbolFlags,symbolExcludes)}function declareSourceFileMember(node,symbolFlags,symbolExcludes){return ts.isExternalModule(file)?declareModuleMember(node,symbolFlags,symbolExcludes):declareSymbol(file.locals,void 0,node,symbolFlags,symbolExcludes)}function hasExportDeclarations(node){var body=251===node.kind?node:node.body;if(251===body.kind||222===body.kind)for(var _i=0,_a=body.statements;_i<_a.length;_i++){var stat=_a[_i];if(231===stat.kind||230===stat.kind)return!0}return!1}function setExportContextFlag(node){ts.isInAmbientContext(node)&&!hasExportDeclarations(node)?node.flags|=131072:node.flags&=-131073}function bindModuleDeclaration(node){if(setExportContextFlag(node),ts.isAmbientModule(node))2&node.flags&&errorOnFirstToken(node,ts.Diagnostics.export_modifier_cannot_be_applied_to_ambient_modules_and_module_augmentations_since_they_are_always_visible),declareSymbolAndAddToSymbolTable(node,512,106639);else{var state=getModuleInstanceState(node);if(0===state)declareSymbolAndAddToSymbolTable(node,1024,0);else if(declareSymbolAndAddToSymbolTable(node,512,106639),304&node.symbol.flags)node.symbol.constEnumOnlyModule=!1;else{var currentModuleIsConstEnumOnly=2===state;void 0===node.symbol.constEnumOnlyModule?node.symbol.constEnumOnlyModule=currentModuleIsConstEnumOnly:node.symbol.constEnumOnlyModule=node.symbol.constEnumOnlyModule&&currentModuleIsConstEnumOnly}}}function bindFunctionOrConstructorType(node){var symbol=createSymbol(131072,getDeclarationName(node));addDeclarationToSymbol(symbol,node,131072);var typeLiteralSymbol=createSymbol(2048,"__type");addDeclarationToSymbol(typeLiteralSymbol,node,2048),typeLiteralSymbol.members=(_a={},_a[symbol.name]=symbol,_a);var _a}function bindObjectLiteralExpression(node){var ElementKind;if(function(ElementKind){ElementKind[ElementKind.Property=1]="Property",ElementKind[ElementKind.Accessor=2]="Accessor"}(ElementKind||(ElementKind={})),inStrictMode)for(var seen={},_i=0,_a=node.properties;_i<_a.length;_i++){var prop=_a[_i];if(69===prop.name.kind){var identifier=prop.name,currentKind=248===prop.kind||249===prop.kind||144===prop.kind?1:2,existingKind=seen[identifier.text];if(existingKind){if(1===currentKind&&1===existingKind){var span=ts.getErrorSpanForNode(file,identifier);file.bindDiagnostics.push(ts.createFileDiagnostic(file,span.start,span.length,ts.Diagnostics.An_object_literal_cannot_have_multiple_properties_with_the_same_name_in_strict_mode))}}else seen[identifier.text]=currentKind}}return bindAnonymousDeclaration(node,4096,"__object")}function bindAnonymousDeclaration(node,symbolFlags,name){var symbol=createSymbol(symbolFlags,name);addDeclarationToSymbol(symbol,node,symbolFlags)}function bindBlockScopedDeclaration(node,symbolFlags,symbolExcludes){switch(blockScopeContainer.kind){case 221:declareModuleMember(node,symbolFlags,symbolExcludes);break;case 251:if(ts.isExternalModule(container)){declareModuleMember(node,symbolFlags,symbolExcludes);break}default:blockScopeContainer.locals||(blockScopeContainer.locals={},addToContainerChain(blockScopeContainer)),declareSymbol(blockScopeContainer.locals,void 0,node,symbolFlags,symbolExcludes)}}function bindBlockScopedVariableDeclaration(node){bindBlockScopedDeclaration(node,2,107455)}function checkStrictModeIdentifier(node){inStrictMode&&node.originalKeywordKind>=106&&node.originalKeywordKind<=114&&!ts.isIdentifierName(node)&&(file.parseDiagnostics.length||file.bindDiagnostics.push(ts.createDiagnosticForNode(node,getStrictModeIdentifierMessage(node),ts.declarationNameToString(node))))}function getStrictModeIdentifierMessage(node){return ts.getContainingClass(node)?ts.Diagnostics.Identifier_expected_0_is_a_reserved_word_in_strict_mode_Class_definitions_are_automatically_in_strict_mode:file.externalModuleIndicator?ts.Diagnostics.Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode:ts.Diagnostics.Identifier_expected_0_is_a_reserved_word_in_strict_mode}function checkStrictModeBinaryExpression(node){inStrictMode&&ts.isLeftHandSideExpression(node.left)&&ts.isAssignmentOperator(node.operatorToken.kind)&&checkStrictModeEvalOrArguments(node,node.left)}function checkStrictModeCatchClause(node){inStrictMode&&node.variableDeclaration&&checkStrictModeEvalOrArguments(node,node.variableDeclaration.name)}function checkStrictModeDeleteExpression(node){if(inStrictMode&&69===node.expression.kind){var span=ts.getErrorSpanForNode(file,node.expression);file.bindDiagnostics.push(ts.createFileDiagnostic(file,span.start,span.length,ts.Diagnostics.delete_cannot_be_called_on_an_identifier_in_strict_mode))}}function isEvalOrArgumentsIdentifier(node){return 69===node.kind&&("eval"===node.text||"arguments"===node.text)}function checkStrictModeEvalOrArguments(contextNode,name){if(name&&69===name.kind){var identifier=name;if(isEvalOrArgumentsIdentifier(identifier)){var span=ts.getErrorSpanForNode(file,name);file.bindDiagnostics.push(ts.createFileDiagnostic(file,span.start,span.length,getStrictModeEvalOrArgumentsMessage(contextNode),identifier.text))}}}function getStrictModeEvalOrArgumentsMessage(node){return ts.getContainingClass(node)?ts.Diagnostics.Invalid_use_of_0_Class_definitions_are_automatically_in_strict_mode:file.externalModuleIndicator?ts.Diagnostics.Invalid_use_of_0_Modules_are_automatically_in_strict_mode:ts.Diagnostics.Invalid_use_of_0_in_strict_mode}function checkStrictModeFunctionName(node){inStrictMode&&checkStrictModeEvalOrArguments(node,node.name)}function checkStrictModeNumericLiteral(node){inStrictMode&&32768&node.flags&&file.bindDiagnostics.push(ts.createDiagnosticForNode(node,ts.Diagnostics.Octal_literals_are_not_allowed_in_strict_mode))}function checkStrictModePostfixUnaryExpression(node){inStrictMode&&checkStrictModeEvalOrArguments(node,node.operand)}function checkStrictModePrefixUnaryExpression(node){inStrictMode&&(41!==node.operator&&42!==node.operator||checkStrictModeEvalOrArguments(node,node.operand))}function checkStrictModeWithStatement(node){inStrictMode&&errorOnFirstToken(node,ts.Diagnostics.with_statements_are_not_allowed_in_strict_mode)}function errorOnFirstToken(node,message,arg0,arg1,arg2){var span=ts.getSpanOfTokenAtPosition(file,node.pos);file.bindDiagnostics.push(ts.createFileDiagnostic(file,span.start,span.length,message,arg0,arg1,arg2))}function getDestructuringParameterName(node){return"__"+ts.indexOf(node.parent.parameters,node)}function bind(node){if(node){node.parent=parent;var savedInStrictMode=inStrictMode;savedInStrictMode||updateStrictMode(node),bindWorker(node),bindChildren(node),inStrictMode=savedInStrictMode}}function updateStrictMode(node){switch(node.kind){case 251:case 222:return void updateStrictModeStatementList(node.statements);case 195:return void(ts.isFunctionLike(node.parent)&&updateStrictModeStatementList(node.statements));case 217:case 189:return void(inStrictMode=!0)}}function updateStrictModeStatementList(statements){for(var _i=0,statements_1=statements;_i<statements_1.length;_i++){var statement=statements_1[_i];if(!ts.isPrologueDirective(statement))return;if(isUseStrictPrologueDirective(statement))return void(inStrictMode=!0)}}function isUseStrictPrologueDirective(node){var nodeText=ts.getTextOfNodeFromSourceText(file.text,node.expression);return'"use strict"'===nodeText||"'use strict'"===nodeText}function bindWorker(node){switch(node.kind){case 69:return checkStrictModeIdentifier(node);case 184:if(ts.isInJavaScriptFile(node)){var specialKind=ts.getSpecialPropertyAssignmentKind(node);switch(specialKind){case 1:bindExportsPropertyAssignment(node);break;case 2:bindModuleExportsAssignment(node);break;case 3:bindPrototypePropertyAssignment(node);break;case 4:bindThisPropertyAssignment(node);break;case 0:break;default:ts.Debug.fail("Unknown special property assignment kind")}}return checkStrictModeBinaryExpression(node);case 247:return checkStrictModeCatchClause(node);case 178:return checkStrictModeDeleteExpression(node);case 8:return checkStrictModeNumericLiteral(node);case 183:return checkStrictModePostfixUnaryExpression(node);case 182:return checkStrictModePrefixUnaryExpression(node);case 208:return checkStrictModeWithStatement(node);case 162:return void(seenThisKeyword=!0);case 151:return checkTypePredicate(node);case 138:return declareSymbolAndAddToSymbolTable(node,262144,530912);case 139:return bindParameter(node);case 214:case 166:return bindVariableDeclarationOrBindingElement(node);case 142:case 141:case 261:return bindPropertyOrMethodOrAccessor(node,4|(node.questionToken?536870912:0),107455);case 248:case 249:return bindPropertyOrMethodOrAccessor(node,4,107455);case 250:return bindPropertyOrMethodOrAccessor(node,8,107455);case 148:case 149:case 150:return declareSymbolAndAddToSymbolTable(node,131072,0);case 144:case 143:return bindPropertyOrMethodOrAccessor(node,8192|(node.questionToken?536870912:0),ts.isObjectLiteralMethod(node)?107455:99263);case 216:return bindFunctionDeclaration(node);case 145:return declareSymbolAndAddToSymbolTable(node,16384,0);case 146:return bindPropertyOrMethodOrAccessor(node,32768,41919);case 147:return bindPropertyOrMethodOrAccessor(node,65536,74687);case 153:case 154:case 264:return bindFunctionOrConstructorType(node);case 156:case 260:return bindAnonymousDeclaration(node,2048,"__type");case 168:return bindObjectLiteralExpression(node);case 176:case 177:return bindFunctionExpression(node);case 171:ts.isInJavaScriptFile(node)&&bindCallExpression(node);break;case 189:case 217:return bindClassLikeDeclaration(node);case 218:return bindBlockScopedDeclaration(node,64,792960);case 219:return bindBlockScopedDeclaration(node,524288,793056);case 220:return bindEnumDeclaration(node);case 221:return bindModuleDeclaration(node);case 224:case 227:case 229:case 233:return declareSymbolAndAddToSymbolTable(node,8388608,8388608);case 226:return bindImportClause(node);case 231:return bindExportDeclaration(node);case 230:return bindExportAssignment(node);case 251:return bindSourceFileIfExternalModule()}}function checkTypePredicate(node){var parameterName=node.parameterName,type=node.type;parameterName&&69===parameterName.kind&&checkStrictModeIdentifier(parameterName),parameterName&&162===parameterName.kind&&(seenThisKeyword=!0),bind(type)}function bindSourceFileIfExternalModule(){setExportContextFlag(file),ts.isExternalModule(file)&&bindSourceFileAsExternalModule()}function bindSourceFileAsExternalModule(){bindAnonymousDeclaration(file,512,'"'+ts.removeFileExtension(file.fileName)+'"')}function bindExportAssignment(node){var boundExpression=230===node.kind?node.expression:node.right;container.symbol&&container.symbol.exports?69===boundExpression.kind&&230===node.kind?declareSymbol(container.symbol.exports,container.symbol,node,8388608,8496063):declareSymbol(container.symbol.exports,container.symbol,node,4,8496063):bindAnonymousDeclaration(node,8388608,getDeclarationName(node))}function bindExportDeclaration(node){container.symbol&&container.symbol.exports?node.exportClause||declareSymbol(container.symbol.exports,container.symbol,node,1073741824,0):bindAnonymousDeclaration(node,1073741824,getDeclarationName(node))}function bindImportClause(node){node.name&&declareSymbolAndAddToSymbolTable(node,8388608,8388608)}function setCommonJsModuleIndicator(node){file.commonJsModuleIndicator||(file.commonJsModuleIndicator=node,bindSourceFileAsExternalModule())}function bindExportsPropertyAssignment(node){setCommonJsModuleIndicator(node),declareSymbol(file.symbol.exports,file.symbol,node.left,7340036,0)}function bindModuleExportsAssignment(node){setCommonJsModuleIndicator(node),bindExportAssignment(node)}function bindThisPropertyAssignment(node){176!==container.kind&&216!==container.kind||(container.symbol.members=container.symbol.members||{},declareSymbol(container.symbol.members,container.symbol,node,4,107451))}function bindPrototypePropertyAssignment(node){var leftSideOfAssignment=node.left,classPrototype=leftSideOfAssignment.expression,constructorFunction=classPrototype.expression;leftSideOfAssignment.parent=node,constructorFunction.parent=classPrototype,classPrototype.parent=leftSideOfAssignment;var funcSymbol=container.locals[constructorFunction.text];funcSymbol&&16&funcSymbol.flags&&(funcSymbol.members||(funcSymbol.members={}),declareSymbol(funcSymbol.members,funcSymbol,leftSideOfAssignment,4,107455))}function bindCallExpression(node){!file.commonJsModuleIndicator&&ts.isRequireCall(node,!1)&&setCommonJsModuleIndicator(node)}function bindClassLikeDeclaration(node){if(ts.isDeclarationFile(file)||ts.isInAmbientContext(node)||(void 0!==ts.getClassExtendsHeritageClauseElement(node)&&(hasClassExtends=!0),ts.nodeIsDecorated(node)&&(hasDecorators=!0)),217===node.kind)bindBlockScopedDeclaration(node,32,899519);else{var bindingName=node.name?node.name.text:"__class";bindAnonymousDeclaration(node,32,bindingName),node.name&&(classifiableNames[node.name.text]=node.name.text)}var symbol=node.symbol,prototypeSymbol=createSymbol(134217732,"prototype");ts.hasProperty(symbol.exports,prototypeSymbol.name)&&(node.name&&(node.name.parent=node),file.bindDiagnostics.push(ts.createDiagnosticForNode(symbol.exports[prototypeSymbol.name].declarations[0],ts.Diagnostics.Duplicate_identifier_0,prototypeSymbol.name))),symbol.exports[prototypeSymbol.name]=prototypeSymbol,prototypeSymbol.parent=symbol}function bindEnumDeclaration(node){return ts.isConst(node)?bindBlockScopedDeclaration(node,128,899967):bindBlockScopedDeclaration(node,256,899327)}function bindVariableDeclarationOrBindingElement(node){inStrictMode&&checkStrictModeEvalOrArguments(node,node.name),ts.isBindingPattern(node.name)||(ts.isBlockOrCatchScoped(node)?bindBlockScopedVariableDeclaration(node):ts.isParameterDeclaration(node)?declareSymbolAndAddToSymbolTable(node,1,107455):declareSymbolAndAddToSymbolTable(node,1,107454))}function bindParameter(node){if(ts.isDeclarationFile(file)||ts.isInAmbientContext(node)||!ts.nodeIsDecorated(node)||(hasDecorators=!0,hasParameterDecorators=!0),inStrictMode&&checkStrictModeEvalOrArguments(node,node.name),ts.isBindingPattern(node.name)?bindAnonymousDeclaration(node,1,getDestructuringParameterName(node)):declareSymbolAndAddToSymbolTable(node,1,107455),ts.isParameterPropertyDeclaration(node)){var classDeclaration=node.parent.parent;declareSymbol(classDeclaration.symbol.members,classDeclaration.symbol,node,4,107455)}}function bindFunctionDeclaration(node){return ts.isDeclarationFile(file)||ts.isInAmbientContext(node)||ts.isAsyncFunctionLike(node)&&(hasAsyncFunctions=!0),checkStrictModeFunctionName(node),declareSymbolAndAddToSymbolTable(node,16,106927)}function bindFunctionExpression(node){ts.isDeclarationFile(file)||ts.isInAmbientContext(node)||ts.isAsyncFunctionLike(node)&&(hasAsyncFunctions=!0),checkStrictModeFunctionName(node);var bindingName=node.name?node.name.text:"__function";return bindAnonymousDeclaration(node,16,bindingName)}function bindPropertyOrMethodOrAccessor(node,symbolFlags,symbolExcludes){return ts.isDeclarationFile(file)||ts.isInAmbientContext(node)||(ts.isAsyncFunctionLike(node)&&(hasAsyncFunctions=!0),ts.nodeIsDecorated(node)&&(hasDecorators=!0)),ts.hasDynamicName(node)?bindAnonymousDeclaration(node,symbolFlags,"__computed"):declareSymbolAndAddToSymbolTable(node,symbolFlags,symbolExcludes)}function pushNamedLabel(name){return initializeReachabilityStateIfNecessary(),!ts.hasProperty(labelIndexMap,name.text)&&(labelIndexMap[name.text]=labelStack.push(1)-1,!0)}function pushImplicitLabel(){initializeReachabilityStateIfNecessary();var index=labelStack.push(1)-1;return implicitLabels.push(index),index}function popNamedLabel(label,outerState){var index=labelIndexMap[label.text];ts.Debug.assert(void 0!==index),ts.Debug.assert(labelStack.length==index+1),labelIndexMap[label.text]=void 0,setCurrentStateAtLabel(labelStack.pop(),outerState,label)}function popImplicitLabel(implicitLabelIndex,outerState){labelStack.length!==implicitLabelIndex+1&&ts.Debug.assert(!1,"Label stack: "+labelStack.length+", index:"+implicitLabelIndex);var i=implicitLabels.pop();implicitLabelIndex!==i&&ts.Debug.assert(!1,"i: "+i+", index: "+implicitLabelIndex),setCurrentStateAtLabel(labelStack.pop(),outerState,void 0)}function setCurrentStateAtLabel(innerMergedState,outerState,label){1===innerMergedState?(label&&!options.allowUnusedLabels&&file.bindDiagnostics.push(ts.createDiagnosticForNode(label,ts.Diagnostics.Unused_label)),currentReachabilityState=outerState):currentReachabilityState=or(innerMergedState,outerState)}function jumpToLabel(label,outerState){initializeReachabilityStateIfNecessary();var index=label?labelIndexMap[label.text]:ts.lastOrUndefined(implicitLabels);if(void 0===index)return!1;var stateAtLabel=labelStack[index];return labelStack[index]=1===stateAtLabel?outerState:or(stateAtLabel,outerState),!0}function checkUnreachable(node){function shouldReportErrorOnModuleDeclaration(node){var instanceState=getModuleInstanceState(node);
return 1===instanceState||2===instanceState&&options.preserveConstEnums}switch(currentReachabilityState){case 4:var reportError=ts.isStatement(node)&&197!==node.kind||217===node.kind||221===node.kind&&shouldReportErrorOnModuleDeclaration(node)||220===node.kind&&(!ts.isConstEnumDeclaration(node)||options.preserveConstEnums);if(reportError){currentReachabilityState=8;var reportUnreachableCode=!options.allowUnreachableCode&&!ts.isInAmbientContext(node)&&(196!==node.kind||24576&ts.getCombinedNodeFlags(node.declarationList)||ts.forEach(node.declarationList.declarations,function(d){return d.initializer}));reportUnreachableCode&&errorOnFirstToken(node,ts.Diagnostics.Unreachable_code_detected)}case 8:return!0;default:return!1}}function initializeReachabilityStateIfNecessary(){labelIndexMap||(currentReachabilityState=2,labelIndexMap={},labelStack=[],implicitLabels=[])}var file,options,parent,container,blockScopeContainer,lastContainer,seenThisKeyword,hasExplicitReturn,currentReachabilityState,labelStack,labelIndexMap,implicitLabels,hasClassExtends,hasAsyncFunctions,hasDecorators,hasParameterDecorators,inStrictMode,Symbol,classifiableNames,symbolCount=0;return bindSourceFile}ts.bindTime=0,function(ModuleInstanceState){ModuleInstanceState[ModuleInstanceState.NonInstantiated=0]="NonInstantiated",ModuleInstanceState[ModuleInstanceState.Instantiated=1]="Instantiated",ModuleInstanceState[ModuleInstanceState.ConstEnumOnly=2]="ConstEnumOnly"}(ts.ModuleInstanceState||(ts.ModuleInstanceState={}));var Reachability;ts.ModuleInstanceState;!function(Reachability){Reachability[Reachability.Unintialized=1]="Unintialized",Reachability[Reachability.Reachable=2]="Reachable",Reachability[Reachability.Unreachable=4]="Unreachable",Reachability[Reachability.ReportedUnreachable=8]="ReportedUnreachable"}(Reachability||(Reachability={})),ts.getModuleInstanceState=getModuleInstanceState;var ContainerFlags;!function(ContainerFlags){ContainerFlags[ContainerFlags.None=0]="None",ContainerFlags[ContainerFlags.IsContainer=1]="IsContainer",ContainerFlags[ContainerFlags.IsBlockScopedContainer=2]="IsBlockScopedContainer",ContainerFlags[ContainerFlags.HasLocals=4]="HasLocals",ContainerFlags[ContainerFlags.IsContainerWithLocals=5]="IsContainerWithLocals"}(ContainerFlags||(ContainerFlags={}));var binder=createBinder();ts.bindSourceFile=bindSourceFile}(ts||(ts={}));var ts;!function(ts){function getNodeId(node){return node.id||(node.id=nextNodeId,nextNodeId++),node.id}function getSymbolId(symbol){return symbol.id||(symbol.id=nextSymbolId,nextSymbolId++),symbol.id}function createTypeChecker(host,produceDiagnostics){function getEmitResolver(sourceFile,cancellationToken){return getDiagnostics(sourceFile,cancellationToken),emitResolver}function error(location,message,arg0,arg1,arg2){var diagnostic=location?ts.createDiagnosticForNode(location,message,arg0,arg1,arg2):ts.createCompilerDiagnostic(message,arg0,arg1,arg2);diagnostics.add(diagnostic)}function createSymbol(flags,name){return symbolCount++,new Symbol(flags,name)}function getExcludedSymbolFlags(flags){var result=0;return 2&flags&&(result|=107455),1&flags&&(result|=107454),4&flags&&(result|=107455),8&flags&&(result|=107455),16&flags&&(result|=106927),32&flags&&(result|=899519),64&flags&&(result|=792960),256&flags&&(result|=899327),128&flags&&(result|=899967),512&flags&&(result|=106639),8192&flags&&(result|=99263),32768&flags&&(result|=41919),65536&flags&&(result|=74687),262144&flags&&(result|=530912),524288&flags&&(result|=793056),8388608&flags&&(result|=8388608),result}function recordMergedSymbol(target,source){source.mergeId||(source.mergeId=nextMergeId,nextMergeId++),mergedSymbols[source.mergeId]=target}function cloneSymbol(symbol){var result=createSymbol(33554432|symbol.flags,symbol.name);return result.declarations=symbol.declarations.slice(0),result.parent=symbol.parent,symbol.valueDeclaration&&(result.valueDeclaration=symbol.valueDeclaration),symbol.constEnumOnlyModule&&(result.constEnumOnlyModule=!0),symbol.members&&(result.members=cloneSymbolTable(symbol.members)),symbol.exports&&(result.exports=cloneSymbolTable(symbol.exports)),recordMergedSymbol(result,symbol),result}function mergeSymbol(target,source){if(target.flags&getExcludedSymbolFlags(source.flags)){var message_2=2&target.flags||2&source.flags?ts.Diagnostics.Cannot_redeclare_block_scoped_variable_0:ts.Diagnostics.Duplicate_identifier_0;ts.forEach(source.declarations,function(node){error(node.name?node.name:node,message_2,symbolToString(source))}),ts.forEach(target.declarations,function(node){error(node.name?node.name:node,message_2,symbolToString(source))})}else 512&source.flags&&512&target.flags&&target.constEnumOnlyModule&&!source.constEnumOnlyModule&&(target.constEnumOnlyModule=!1),target.flags|=source.flags,source.valueDeclaration&&(!target.valueDeclaration||221===target.valueDeclaration.kind&&221!==source.valueDeclaration.kind)&&(target.valueDeclaration=source.valueDeclaration),ts.forEach(source.declarations,function(node){target.declarations.push(node)}),source.members&&(target.members||(target.members={}),mergeSymbolTable(target.members,source.members)),source.exports&&(target.exports||(target.exports={}),mergeSymbolTable(target.exports,source.exports)),recordMergedSymbol(target,source)}function cloneSymbolTable(symbolTable){var result={};for(var id in symbolTable)ts.hasProperty(symbolTable,id)&&(result[id]=symbolTable[id]);return result}function mergeSymbolTable(target,source){for(var id in source)if(ts.hasProperty(source,id))if(ts.hasProperty(target,id)){var symbol=target[id];33554432&symbol.flags||(target[id]=symbol=cloneSymbol(symbol)),mergeSymbol(symbol,source[id])}else target[id]=source[id]}function mergeModuleAugmentation(moduleName){var moduleAugmentation=moduleName.parent;if(moduleAugmentation.symbol.valueDeclaration!==moduleAugmentation)return void ts.Debug.assert(moduleAugmentation.symbol.declarations.length>1);if(ts.isGlobalScopeAugmentation(moduleAugmentation))mergeSymbolTable(globals,moduleAugmentation.symbol.exports);else{var mainModule=resolveExternalModuleNameWorker(moduleName,moduleName,ts.Diagnostics.Invalid_module_name_in_augmentation_module_0_cannot_be_found);if(!mainModule)return;mainModule=resolveExternalModuleSymbol(mainModule),1536&mainModule.flags?(mainModule=33554432&mainModule.flags?mainModule:cloneSymbol(mainModule),mergeSymbol(mainModule,moduleAugmentation.symbol)):error(moduleName,ts.Diagnostics.Cannot_augment_module_0_because_it_resolves_to_a_non_module_entity,moduleName.text)}}function addToSymbolTable(target,source,message){function addDeclarationDiagnostic(id,message){return function(declaration){return diagnostics.add(ts.createDiagnosticForNode(declaration,message,id))}}for(var id in source)ts.hasProperty(source,id)&&(ts.hasProperty(target,id)?ts.forEach(target[id].declarations,addDeclarationDiagnostic(id,message)):target[id]=source[id])}function getSymbolLinks(symbol){if(67108864&symbol.flags)return symbol;var id=getSymbolId(symbol);return symbolLinks[id]||(symbolLinks[id]={})}function getNodeLinks(node){var nodeId=getNodeId(node);return nodeLinks[nodeId]||(nodeLinks[nodeId]={})}function isGlobalSourceFile(node){return 251===node.kind&&!ts.isExternalOrCommonJsModule(node)}function getSymbol(symbols,name,meaning){if(meaning&&ts.hasProperty(symbols,name)){var symbol=symbols[name];if(ts.Debug.assert(0===(16777216&symbol.flags),"Should never get an instantiated symbol here."),symbol.flags&meaning)return symbol;if(8388608&symbol.flags){var target=resolveAlias(symbol);if(target===unknownSymbol||target.flags&meaning)return symbol}}}function getSymbolsOfParameterPropertyDeclaration(parameter,parameterName){var constructoDeclaration=parameter.parent,classDeclaration=parameter.parent.parent,parameterSymbol=getSymbol(constructoDeclaration.locals,parameterName,107455),propertySymbol=getSymbol(classDeclaration.symbol.members,parameterName,107455);return parameterSymbol&&propertySymbol?[parameterSymbol,propertySymbol]:void ts.Debug.fail("There should exist two symbols, one as property declaration and one as parameter declaration")}function isBlockScopedNameDeclaredBeforeUse(declaration,usage){function isImmediatelyUsedInInitializerOfBlockScopedVariable(declaration,usage){var container=ts.getEnclosingBlockScopeContainer(declaration);if(196===declaration.parent.parent.kind||202===declaration.parent.parent.kind)return isSameScopeDescendentOf(usage,declaration,container);if(204===declaration.parent.parent.kind||203===declaration.parent.parent.kind){var expression=declaration.parent.parent.expression;return isSameScopeDescendentOf(usage,expression,container)}}function isUsedInFunctionOrNonStaticProperty(declaration,usage){for(var container=ts.getEnclosingBlockScopeContainer(declaration),current=usage;current;){if(current===container)return!1;if(ts.isFunctionLike(current))return!0;var initializerOfNonStaticProperty=current.parent&&142===current.parent.kind&&0===(64&current.parent.flags)&&current.parent.initializer===current;if(initializerOfNonStaticProperty)return!0;current=current.parent}return!1}var declarationFile=ts.getSourceFileOfNode(declaration),useFile=ts.getSourceFileOfNode(usage);if(declarationFile!==useFile){if(modulekind||!compilerOptions.outFile&&!compilerOptions.out)return!0;var sourceFiles=host.getSourceFiles();return ts.indexOf(sourceFiles,declarationFile)<=ts.indexOf(sourceFiles,useFile)}return declaration.pos<=usage.pos?214!==declaration.kind||!isImmediatelyUsedInInitializerOfBlockScopedVariable(declaration,usage):isUsedInFunctionOrNonStaticProperty(declaration,usage)}function resolveName(location,name,meaning,nameNotFoundMessage,nameArg){var result,lastLocation,propertyWithInvalidInitializer,grandparent,errorLocation=location;loop:for(;location;){if(location.locals&&!isGlobalSourceFile(location)&&(result=getSymbol(location.locals,name,meaning))){var useResult=!0;if(ts.isFunctionLike(location)&&lastLocation&&lastLocation!==location.body&&(meaning&result.flags&793056&&268!==lastLocation.kind&&(useResult=!!(262144&result.flags)&&(lastLocation===location.type||139===lastLocation.kind||138===lastLocation.kind)),107455&meaning&&1&result.flags&&(useResult=139===lastLocation.kind||lastLocation===location.type&&139===result.valueDeclaration.kind)),useResult)break loop;result=void 0}switch(location.kind){case 251:if(!ts.isExternalOrCommonJsModule(location))break;case 221:var moduleExports=getSymbolOfNode(location).exports;if(251===location.kind||ts.isAmbientModule(location)){if(result=moduleExports.default){var localSymbol=ts.getLocalSymbolForExportDefault(result);if(localSymbol&&result.flags&meaning&&localSymbol.name===name)break loop;result=void 0}if(ts.hasProperty(moduleExports,name)&&8388608===moduleExports[name].flags&&ts.getDeclarationOfKind(moduleExports[name],233))break}if(result=getSymbol(moduleExports,name,8914931&meaning))break loop;break;case 220:if(result=getSymbol(getSymbolOfNode(location).exports,name,8&meaning))break loop;break;case 142:case 141:if(ts.isClassLike(location.parent)&&!(64&location.flags)){var ctor=findConstructorDeclaration(location.parent);ctor&&ctor.locals&&getSymbol(ctor.locals,name,107455&meaning)&&(propertyWithInvalidInitializer=location)}break;case 217:case 189:case 218:if(result=getSymbol(getSymbolOfNode(location).members,name,793056&meaning)){if(lastLocation&&64&lastLocation.flags)return void error(errorLocation,ts.Diagnostics.Static_members_cannot_reference_class_type_parameters);break loop}if(189===location.kind&&32&meaning){var className=location.name;if(className&&name===className.text){result=location.symbol;break loop}}break;case 137:if(grandparent=location.parent.parent,(ts.isClassLike(grandparent)||218===grandparent.kind)&&(result=getSymbol(getSymbolOfNode(grandparent).members,name,793056&meaning)))return void error(errorLocation,ts.Diagnostics.A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type);break;case 144:case 143:case 145:case 146:case 147:case 216:case 177:if(3&meaning&&"arguments"===name){result=argumentsSymbol;break loop}break;case 176:if(3&meaning&&"arguments"===name){result=argumentsSymbol;break loop}if(16&meaning){var functionName=location.name;if(functionName&&name===functionName.text){result=location.symbol;break loop}}break;case 140:location.parent&&139===location.parent.kind&&(location=location.parent),location.parent&&ts.isClassElement(location.parent)&&(location=location.parent)}lastLocation=location,location=location.parent}if(result||(result=getSymbol(globals,name,meaning)),!result)return void(nameNotFoundMessage&&(checkAndReportErrorForMissingPrefix(errorLocation,name,nameArg)||error(errorLocation,nameNotFoundMessage,"string"==typeof nameArg?nameArg:ts.declarationNameToString(nameArg))));if(nameNotFoundMessage){if(propertyWithInvalidInitializer){var propertyName=propertyWithInvalidInitializer.name;return void error(errorLocation,ts.Diagnostics.Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor,ts.declarationNameToString(propertyName),"string"==typeof nameArg?nameArg:ts.declarationNameToString(nameArg))}if(2&meaning){var exportOrLocalSymbol=getExportSymbolOfValueSymbolIfExported(result);2&exportOrLocalSymbol.flags&&checkResolvedBlockScopedVariable(exportOrLocalSymbol,errorLocation)}}return result}function checkAndReportErrorForMissingPrefix(errorLocation,name,nameArg){if(!errorLocation||69===errorLocation.kind&&isTypeReferenceIdentifier(errorLocation)||isInTypeQuery(errorLocation))return!1;for(var container=ts.getThisContainer(errorLocation,!0),location=container;location;){if(ts.isClassLike(location.parent)){var classSymbol=getSymbolOfNode(location.parent);if(!classSymbol)break;var constructorType=getTypeOfSymbol(classSymbol);if(getPropertyOfType(constructorType,name))return error(errorLocation,ts.Diagnostics.Cannot_find_name_0_Did_you_mean_the_static_member_1_0,"string"==typeof nameArg?nameArg:ts.declarationNameToString(nameArg),symbolToString(classSymbol)),!0;if(location===container&&!(64&location.flags)){var instanceType=getDeclaredTypeOfSymbol(classSymbol).thisType;if(getPropertyOfType(instanceType,name))return error(errorLocation,ts.Diagnostics.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0,"string"==typeof nameArg?nameArg:ts.declarationNameToString(nameArg)),!0}}location=location.parent}return!1}function checkResolvedBlockScopedVariable(result,errorLocation){ts.Debug.assert(0!==(2&result.flags));var declaration=ts.forEach(result.declarations,function(d){return ts.isBlockOrCatchScoped(d)?d:void 0});ts.Debug.assert(void 0!==declaration,"Block-scoped variable declaration is undefined"),isBlockScopedNameDeclaredBeforeUse(ts.getAncestor(declaration,214),errorLocation)||error(errorLocation,ts.Diagnostics.Block_scoped_variable_0_used_before_its_declaration,ts.declarationNameToString(declaration.name))}function isSameScopeDescendentOf(initial,parent,stopAt){if(!parent)return!1;for(var current=initial;current&&current!==stopAt&&!ts.isFunctionLike(current);current=current.parent)if(current===parent)return!0;return!1}function getAnyImportSyntax(node){if(ts.isAliasSymbolDeclaration(node)){if(224===node.kind)return node;for(;node&&225!==node.kind;)node=node.parent;return node}}function getDeclarationOfAliasSymbol(symbol){return ts.forEach(symbol.declarations,function(d){return ts.isAliasSymbolDeclaration(d)?d:void 0})}function getTargetOfImportEqualsDeclaration(node){return 235===node.moduleReference.kind?resolveExternalModuleSymbol(resolveExternalModuleName(node,ts.getExternalModuleImportEqualsDeclarationExpression(node))):getSymbolOfPartOfRightHandSideOfImportEquals(node.moduleReference,node)}function getTargetOfImportClause(node){var moduleSymbol=resolveExternalModuleName(node,node.parent.moduleSpecifier);if(moduleSymbol){var exportDefaultSymbol=resolveSymbol(moduleSymbol.exports.default);if(exportDefaultSymbol||allowSyntheticDefaultImports){if(!exportDefaultSymbol&&allowSyntheticDefaultImports)return resolveExternalModuleSymbol(moduleSymbol)||resolveSymbol(moduleSymbol)}else error(node.name,ts.Diagnostics.Module_0_has_no_default_export,symbolToString(moduleSymbol));return exportDefaultSymbol}}function getTargetOfNamespaceImport(node){var moduleSpecifier=node.parent.parent.moduleSpecifier;return resolveESModuleSymbol(resolveExternalModuleName(node,moduleSpecifier),moduleSpecifier)}function combineValueAndTypeSymbols(valueSymbol,typeSymbol){if(794592&valueSymbol.flags)return valueSymbol;var result=createSymbol(valueSymbol.flags|typeSymbol.flags,valueSymbol.name);return result.declarations=ts.concatenate(valueSymbol.declarations,typeSymbol.declarations),result.parent=valueSymbol.parent||typeSymbol.parent,valueSymbol.valueDeclaration&&(result.valueDeclaration=valueSymbol.valueDeclaration),typeSymbol.members&&(result.members=typeSymbol.members),valueSymbol.exports&&(result.exports=valueSymbol.exports),result}function getExportOfModule(symbol,name){if(1536&symbol.flags){var exports=getExportsOfSymbol(symbol);if(ts.hasProperty(exports,name))return resolveSymbol(exports[name])}}function getPropertyOfVariable(symbol,name){if(3&symbol.flags){var typeAnnotation=symbol.valueDeclaration.type;if(typeAnnotation)return resolveSymbol(getPropertyOfType(getTypeFromTypeNode(typeAnnotation),name))}}function getExternalModuleMember(node,specifier){var moduleSymbol=resolveExternalModuleName(node,node.moduleSpecifier),targetSymbol=resolveESModuleSymbol(moduleSymbol,node.moduleSpecifier);if(targetSymbol){var name_9=specifier.propertyName||specifier.name;if(name_9.text){var symbolFromModule=getExportOfModule(targetSymbol,name_9.text),symbolFromVariable=getPropertyOfVariable(targetSymbol,name_9.text),symbol=symbolFromModule&&symbolFromVariable?combineValueAndTypeSymbols(symbolFromVariable,symbolFromModule):symbolFromModule||symbolFromVariable;return symbol||error(name_9,ts.Diagnostics.Module_0_has_no_exported_member_1,getFullyQualifiedName(moduleSymbol),ts.declarationNameToString(name_9)),symbol}}}function getTargetOfImportSpecifier(node){return getExternalModuleMember(node.parent.parent.parent,node)}function getTargetOfExportSpecifier(node){return node.parent.parent.moduleSpecifier?getExternalModuleMember(node.parent.parent,node):resolveEntityName(node.propertyName||node.name,901119)}function getTargetOfExportAssignment(node){return resolveEntityName(node.expression,901119)}function getTargetOfAliasDeclaration(node){switch(node.kind){case 224:return getTargetOfImportEqualsDeclaration(node);case 226:return getTargetOfImportClause(node);case 227:return getTargetOfNamespaceImport(node);case 229:return getTargetOfImportSpecifier(node);case 233:return getTargetOfExportSpecifier(node);case 230:return getTargetOfExportAssignment(node)}}function resolveSymbol(symbol){return symbol&&8388608&symbol.flags&&!(901119&symbol.flags)?resolveAlias(symbol):symbol}function resolveAlias(symbol){ts.Debug.assert(0!==(8388608&symbol.flags),"Should only get Alias here.");var links=getSymbolLinks(symbol);if(links.target)links.target===resolvingSymbol&&(links.target=unknownSymbol);else{links.target=resolvingSymbol;var node=getDeclarationOfAliasSymbol(symbol),target=getTargetOfAliasDeclaration(node);links.target===resolvingSymbol?links.target=target||unknownSymbol:error(node,ts.Diagnostics.Circular_definition_of_import_alias_0,symbolToString(symbol))}return links.target}function markExportAsReferenced(node){var symbol=getSymbolOfNode(node),target=resolveAlias(symbol);if(target){var markAlias=target===unknownSymbol&&compilerOptions.isolatedModules||target!==unknownSymbol&&107455&target.flags&&!isConstEnumOrConstEnumOnlyModule(target);markAlias&&markAliasSymbolAsReferenced(symbol)}}function markAliasSymbolAsReferenced(symbol){var links=getSymbolLinks(symbol);if(!links.referenced){links.referenced=!0;var node=getDeclarationOfAliasSymbol(symbol);230===node.kind?checkExpressionCached(node.expression):233===node.kind?checkExpressionCached(node.propertyName||node.name):ts.isInternalModuleImportEqualsDeclaration(node)&&checkExpressionCached(node.moduleReference)}}function getSymbolOfPartOfRightHandSideOfImportEquals(entityName,importDeclaration){return importDeclaration||(importDeclaration=ts.getAncestor(entityName,224),ts.Debug.assert(void 0!==importDeclaration)),69===entityName.kind&&ts.isRightSideOfQualifiedNameOrPropertyAccess(entityName)&&(entityName=entityName.parent),69===entityName.kind||136===entityName.parent.kind?resolveEntityName(entityName,1536):(ts.Debug.assert(224===entityName.parent.kind),resolveEntityName(entityName,901119))}function getFullyQualifiedName(symbol){return symbol.parent?getFullyQualifiedName(symbol.parent)+"."+symbolToString(symbol):symbolToString(symbol)}function resolveEntityName(name,meaning,ignoreErrors){if(!ts.nodeIsMissing(name)){var symbol;if(69===name.kind){var message=1536===meaning?ts.Diagnostics.Cannot_find_namespace_0:ts.Diagnostics.Cannot_find_name_0;if(symbol=resolveName(name,name.text,meaning,ignoreErrors?void 0:message,name),!symbol)return}else if(136===name.kind||169===name.kind){var left=136===name.kind?name.left:name.expression,right=136===name.kind?name.right:name.name,namespace=resolveEntityName(left,1536,ignoreErrors);if(!namespace||namespace===unknownSymbol||ts.nodeIsMissing(right))return;if(symbol=getSymbol(getExportsOfSymbol(namespace),right.text,meaning),!symbol)return void(ignoreErrors||error(right,ts.Diagnostics.Module_0_has_no_exported_member_1,getFullyQualifiedName(namespace),ts.declarationNameToString(right)))}else ts.Debug.fail("Unknown entity name kind.");return ts.Debug.assert(0===(16777216&symbol.flags),"Should never get an instantiated symbol here."),symbol.flags&meaning?symbol:resolveAlias(symbol)}}function resolveExternalModuleName(location,moduleReferenceExpression){return resolveExternalModuleNameWorker(location,moduleReferenceExpression,ts.Diagnostics.Cannot_find_module_0)}function resolveExternalModuleNameWorker(location,moduleReferenceExpression,moduleNotFoundError){if(9===moduleReferenceExpression.kind){var moduleReferenceLiteral=moduleReferenceExpression,moduleName=ts.escapeIdentifier(moduleReferenceLiteral.text);if(void 0!==moduleName){var isRelative=ts.isExternalModuleNameRelative(moduleName);if(!isRelative){var symbol=getSymbol(globals,'"'+moduleName+'"',512);if(symbol)return getMergedSymbol(symbol)}var resolvedModule=ts.getResolvedModule(ts.getSourceFileOfNode(location),moduleReferenceLiteral.text),sourceFile=resolvedModule&&host.getSourceFile(resolvedModule.resolvedFileName);return sourceFile?sourceFile.symbol?getMergedSymbol(sourceFile.symbol):void(moduleNotFoundError&&error(moduleReferenceLiteral,ts.Diagnostics.File_0_is_not_a_module,sourceFile.fileName)):void(moduleNotFoundError&&error(moduleReferenceLiteral,moduleNotFoundError,moduleName))}}}function resolveExternalModuleSymbol(moduleSymbol){return moduleSymbol&&getMergedSymbol(resolveSymbol(moduleSymbol.exports["export="]))||moduleSymbol}function resolveESModuleSymbol(moduleSymbol,moduleReferenceExpression){var symbol=resolveExternalModuleSymbol(moduleSymbol);return!symbol||1539&symbol.flags||(error(moduleReferenceExpression,ts.Diagnostics.Module_0_resolves_to_a_non_module_entity_and_cannot_be_imported_using_this_construct,symbolToString(moduleSymbol)),symbol=void 0),symbol}function hasExportAssignmentSymbol(moduleSymbol){return void 0!==moduleSymbol.exports["export="]}function getExportsOfModuleAsArray(moduleSymbol){return symbolsToArray(getExportsOfModule(moduleSymbol))}function getExportsOfSymbol(symbol){return 1536&symbol.flags?getExportsOfModule(symbol):symbol.exports||emptySymbols}function getExportsOfModule(moduleSymbol){var links=getSymbolLinks(moduleSymbol);return links.resolvedExports||(links.resolvedExports=getExportsForModule(moduleSymbol))}function extendExportSymbols(target,source,lookupTable,exportNode){for(var id in source)"default"===id||ts.hasProperty(target,id)?lookupTable&&exportNode&&"default"!==id&&ts.hasProperty(target,id)&&resolveSymbol(target[id])!==resolveSymbol(source[id])&&(lookupTable[id].exportsWithDuplicate?lookupTable[id].exportsWithDuplicate.push(exportNode):lookupTable[id].exportsWithDuplicate=[exportNode]):(target[id]=source[id],lookupTable&&exportNode&&(lookupTable[id]={specifierText:ts.getTextOfNode(exportNode.moduleSpecifier)}))}function getExportsForModule(moduleSymbol){function visit(symbol){if(symbol&&1952&symbol.flags&&!ts.contains(visitedSymbols,symbol)){visitedSymbols.push(symbol);var symbols=cloneSymbolTable(symbol.exports),exportStars=symbol.exports.__export;if(exportStars){for(var nestedSymbols={},lookupTable={},_i=0,_a=exportStars.declarations;_i<_a.length;_i++){var node=_a[_i],resolvedModule=resolveExternalModuleName(node,node.moduleSpecifier),exportedSymbols=visit(resolvedModule);extendExportSymbols(nestedSymbols,exportedSymbols,lookupTable,node)}for(var id in lookupTable){var exportsWithDuplicate=lookupTable[id].exportsWithDuplicate;if("export="!==id&&exportsWithDuplicate&&exportsWithDuplicate.length&&!ts.hasProperty(symbols,id))for(var _b=0,exportsWithDuplicate_1=exportsWithDuplicate;_b<exportsWithDuplicate_1.length;_b++){var node=exportsWithDuplicate_1[_b];diagnostics.add(ts.createDiagnosticForNode(node,ts.Diagnostics.Module_0_has_already_exported_a_member_named_1_Consider_explicitly_re_exporting_to_resolve_the_ambiguity,lookupTable[id].specifierText,id))}}extendExportSymbols(symbols,nestedSymbols)}return symbols}}var visitedSymbols=[];return visit(moduleSymbol)||moduleSymbol.exports}function getMergedSymbol(symbol){var merged;return symbol&&symbol.mergeId&&(merged=mergedSymbols[symbol.mergeId])?merged:symbol}function getSymbolOfNode(node){return getMergedSymbol(node.symbol)}function getParentOfSymbol(symbol){return getMergedSymbol(symbol.parent)}function getExportSymbolOfValueSymbolIfExported(symbol){return symbol&&0!==(1048576&symbol.flags)?getMergedSymbol(symbol.exportSymbol):symbol}function symbolIsValue(symbol){return 16777216&symbol.flags?symbolIsValue(getSymbolLinks(symbol).target):!!(107455&symbol.flags)||!!(8388608&symbol.flags)&&0!==(107455&resolveAlias(symbol).flags)}function findConstructorDeclaration(node){for(var members=node.members,_i=0,members_1=members;_i<members_1.length;_i++){var member=members_1[_i];if(145===member.kind&&ts.nodeIsPresent(member.body))return member}}function createType(flags){var result=new Type(checker,flags);return result.id=typeCount,typeCount++,result}function createIntrinsicType(kind,intrinsicName){var type=createType(kind);return type.intrinsicName=intrinsicName,type}function createObjectType(kind,symbol){var type=createType(kind);return type.symbol=symbol,type}function isReservedMemberName(name){return 95===name.charCodeAt(0)&&95===name.charCodeAt(1)&&95!==name.charCodeAt(2)&&64!==name.charCodeAt(2)}function getNamedMembers(members){var result;for(var id in members)if(ts.hasProperty(members,id)&&!isReservedMemberName(id)){result||(result=[]);var symbol=members[id];symbolIsValue(symbol)&&result.push(symbol)}return result||emptyArray}function setObjectTypeMembers(type,members,callSignatures,constructSignatures,stringIndexType,numberIndexType){return type.members=members,type.properties=getNamedMembers(members),type.callSignatures=callSignatures,type.constructSignatures=constructSignatures,stringIndexType&&(type.stringIndexType=stringIndexType),numberIndexType&&(type.numberIndexType=numberIndexType),type}function createAnonymousType(symbol,members,callSignatures,constructSignatures,stringIndexType,numberIndexType){return setObjectTypeMembers(createObjectType(65536,symbol),members,callSignatures,constructSignatures,stringIndexType,numberIndexType)}function forEachSymbolTableInScope(enclosingDeclaration,callback){for(var result,location_1=enclosingDeclaration;location_1;location_1=location_1.parent){if(location_1.locals&&!isGlobalSourceFile(location_1)&&(result=callback(location_1.locals)))return result;switch(location_1.kind){case 251:if(!ts.isExternalOrCommonJsModule(location_1))break;case 221:if(result=callback(getSymbolOfNode(location_1).exports))return result;break;case 217:case 218:if(result=callback(getSymbolOfNode(location_1).members))return result}}return callback(globals)}function getQualifiedLeftMeaning(rightMeaning){return 107455===rightMeaning?107455:1536}function getAccessibleSymbolChain(symbol,enclosingDeclaration,meaning,useOnlyExternalAliasing){function getAccessibleSymbolChainFromSymbolTable(symbols){function canQualifySymbol(symbolFromSymbolTable,meaning){if(!needsQualification(symbolFromSymbolTable,enclosingDeclaration,meaning))return!0;var accessibleParent=getAccessibleSymbolChain(symbolFromSymbolTable.parent,enclosingDeclaration,getQualifiedLeftMeaning(meaning),useOnlyExternalAliasing);return!!accessibleParent}function isAccessible(symbolFromSymbolTable,resolvedAliasSymbol){if(symbol===(resolvedAliasSymbol||symbolFromSymbolTable))return!ts.forEach(symbolFromSymbolTable.declarations,hasExternalModuleSymbol)&&canQualifySymbol(symbolFromSymbolTable,meaning)}return isAccessible(ts.lookUp(symbols,symbol.name))?[symbol]:ts.forEachValue(symbols,function(symbolFromSymbolTable){if(8388608&symbolFromSymbolTable.flags&&"export="!==symbolFromSymbolTable.name&&!ts.getDeclarationOfKind(symbolFromSymbolTable,233)&&(!useOnlyExternalAliasing||ts.forEach(symbolFromSymbolTable.declarations,ts.isExternalModuleImportEqualsDeclaration))){var resolvedImportedSymbol=resolveAlias(symbolFromSymbolTable);if(isAccessible(symbolFromSymbolTable,resolveAlias(symbolFromSymbolTable)))return[symbolFromSymbolTable];var accessibleSymbolsFromExports=resolvedImportedSymbol.exports?getAccessibleSymbolChainFromSymbolTable(resolvedImportedSymbol.exports):void 0;if(accessibleSymbolsFromExports&&canQualifySymbol(symbolFromSymbolTable,getQualifiedLeftMeaning(meaning)))return[symbolFromSymbolTable].concat(accessibleSymbolsFromExports)}})}if(symbol)return forEachSymbolTableInScope(enclosingDeclaration,getAccessibleSymbolChainFromSymbolTable)}function needsQualification(symbol,enclosingDeclaration,meaning){var qualify=!1;return forEachSymbolTableInScope(enclosingDeclaration,function(symbolTable){if(!ts.hasProperty(symbolTable,symbol.name))return!1;var symbolFromSymbolTable=symbolTable[symbol.name];return symbolFromSymbolTable===symbol||(symbolFromSymbolTable=8388608&symbolFromSymbolTable.flags&&!ts.getDeclarationOfKind(symbolFromSymbolTable,233)?resolveAlias(symbolFromSymbolTable):symbolFromSymbolTable,!!(symbolFromSymbolTable.flags&meaning)&&(qualify=!0,!0))}),qualify}function isSymbolAccessible(symbol,enclosingDeclaration,meaning){function getExternalModuleContainer(declaration){for(;declaration;declaration=declaration.parent)if(hasExternalModuleSymbol(declaration))return getSymbolOfNode(declaration)}if(symbol&&enclosingDeclaration&&!(262144&symbol.flags)){for(var initialSymbol=symbol,meaningToLook=meaning;symbol;){var accessibleSymbolChain=getAccessibleSymbolChain(symbol,enclosingDeclaration,meaningToLook,!1);if(accessibleSymbolChain){var hasAccessibleDeclarations=hasVisibleDeclarations(accessibleSymbolChain[0]);return hasAccessibleDeclarations?hasAccessibleDeclarations:{accessibility:1,errorSymbolName:symbolToString(initialSymbol,enclosingDeclaration,meaning),errorModuleName:symbol!==initialSymbol?symbolToString(symbol,enclosingDeclaration,1536):void 0}}meaningToLook=getQualifiedLeftMeaning(meaning),symbol=getParentOfSymbol(symbol)}var symbolExternalModule=ts.forEach(initialSymbol.declarations,getExternalModuleContainer);if(symbolExternalModule){var enclosingExternalModule=getExternalModuleContainer(enclosingDeclaration);if(symbolExternalModule!==enclosingExternalModule)return{accessibility:2,errorSymbolName:symbolToString(initialSymbol,enclosingDeclaration,meaning),errorModuleName:symbolToString(symbolExternalModule)}}return{accessibility:1,errorSymbolName:symbolToString(initialSymbol,enclosingDeclaration,meaning)}}return{accessibility:0}}function hasExternalModuleSymbol(declaration){return ts.isAmbientModule(declaration)||251===declaration.kind&&ts.isExternalOrCommonJsModule(declaration);
}function hasVisibleDeclarations(symbol){function getIsDeclarationVisible(declaration){if(!isDeclarationVisible(declaration)){var anyImportSyntax=getAnyImportSyntax(declaration);return!(!anyImportSyntax||2&anyImportSyntax.flags||!isDeclarationVisible(anyImportSyntax.parent))&&(getNodeLinks(declaration).isVisible=!0,aliasesToMakeVisible?ts.contains(aliasesToMakeVisible,anyImportSyntax)||aliasesToMakeVisible.push(anyImportSyntax):aliasesToMakeVisible=[anyImportSyntax],!0)}return!0}var aliasesToMakeVisible;if(!ts.forEach(symbol.declarations,function(declaration){return!getIsDeclarationVisible(declaration)}))return{accessibility:0,aliasesToMakeVisible:aliasesToMakeVisible}}function isEntityNameVisible(entityName,enclosingDeclaration){var meaning;meaning=155===entityName.parent.kind?1156031:136===entityName.kind||169===entityName.kind||224===entityName.parent.kind?1536:793056;var firstIdentifier=getFirstIdentifier(entityName),symbol=resolveName(enclosingDeclaration,firstIdentifier.text,meaning,void 0,void 0);return symbol&&hasVisibleDeclarations(symbol)||{accessibility:1,errorSymbolName:ts.getTextOfNode(firstIdentifier),errorNode:firstIdentifier}}function writeKeyword(writer,kind){writer.writeKeyword(ts.tokenToString(kind))}function writePunctuation(writer,kind){writer.writePunctuation(ts.tokenToString(kind))}function writeSpace(writer){writer.writeSpace(" ")}function symbolToString(symbol,enclosingDeclaration,meaning){var writer=ts.getSingleLineStringWriter();getSymbolDisplayBuilder().buildSymbolDisplay(symbol,writer,enclosingDeclaration,meaning);var result=writer.string();return ts.releaseStringWriter(writer),result}function signatureToString(signature,enclosingDeclaration,flags,kind){var writer=ts.getSingleLineStringWriter();getSymbolDisplayBuilder().buildSignatureDisplay(signature,writer,enclosingDeclaration,flags,kind);var result=writer.string();return ts.releaseStringWriter(writer),result}function typeToString(type,enclosingDeclaration,flags){var writer=ts.getSingleLineStringWriter();getSymbolDisplayBuilder().buildTypeDisplay(type,writer,enclosingDeclaration,flags);var result=writer.string();ts.releaseStringWriter(writer);var maxLength=compilerOptions.noErrorTruncation||4&flags?void 0:100;return maxLength&&result.length>=maxLength&&(result=result.substr(0,maxLength-"...".length)+"..."),result}function typePredicateToString(typePredicate,enclosingDeclaration,flags){var writer=ts.getSingleLineStringWriter();getSymbolDisplayBuilder().buildTypePredicateDisplay(typePredicate,writer,enclosingDeclaration,flags);var result=writer.string();return ts.releaseStringWriter(writer),result}function getTypeAliasForTypeLiteral(type){if(type.symbol&&2048&type.symbol.flags){for(var node=type.symbol.declarations[0].parent;161===node.kind;)node=node.parent;if(219===node.kind)return getSymbolOfNode(node)}}function isTopLevelInExternalModuleAugmentation(node){return node&&node.parent&&222===node.parent.kind&&ts.isExternalModuleAugmentation(node.parent.parent)}function getSymbolDisplayBuilder(){function getNameOfSymbol(symbol){if(symbol.declarations&&symbol.declarations.length){var declaration=symbol.declarations[0];if(declaration.name)return ts.declarationNameToString(declaration.name);switch(declaration.kind){case 189:return"(Anonymous class)";case 176:case 177:return"(Anonymous function)"}}return symbol.name}function appendSymbolNameOnly(symbol,writer){writer.writeSymbol(getNameOfSymbol(symbol),symbol)}function buildSymbolDisplay(symbol,writer,enclosingDeclaration,meaning,flags,typeFlags){function appendParentTypeArgumentsAndSymbolName(symbol){parentSymbol&&(1&flags&&(16777216&symbol.flags?buildDisplayForTypeArgumentsAndDelimiters(getTypeParametersOfClassOrInterface(parentSymbol),symbol.mapper,writer,enclosingDeclaration):buildTypeParameterDisplayFromSymbol(parentSymbol,writer,enclosingDeclaration)),writePunctuation(writer,21)),parentSymbol=symbol,appendSymbolNameOnly(symbol,writer)}function walkSymbol(symbol,meaning){if(symbol){var accessibleSymbolChain=getAccessibleSymbolChain(symbol,enclosingDeclaration,meaning,!!(2&flags));if(accessibleSymbolChain&&!needsQualification(accessibleSymbolChain[0],enclosingDeclaration,1===accessibleSymbolChain.length?meaning:getQualifiedLeftMeaning(meaning))||walkSymbol(getParentOfSymbol(accessibleSymbolChain?accessibleSymbolChain[0]:symbol),getQualifiedLeftMeaning(meaning)),accessibleSymbolChain)for(var _i=0,accessibleSymbolChain_1=accessibleSymbolChain;_i<accessibleSymbolChain_1.length;_i++){var accessibleSymbol=accessibleSymbolChain_1[_i];appendParentTypeArgumentsAndSymbolName(accessibleSymbol)}else{if(!parentSymbol&&ts.forEach(symbol.declarations,hasExternalModuleSymbol))return;if(2048&symbol.flags||4096&symbol.flags)return;appendParentTypeArgumentsAndSymbolName(symbol)}}}var parentSymbol;writer.trackSymbol(symbol,enclosingDeclaration,meaning);var isTypeParameter=262144&symbol.flags,typeFormatFlag=128&typeFlags;return isTypeParameter||!enclosingDeclaration&&!typeFormatFlag?appendParentTypeArgumentsAndSymbolName(symbol):void walkSymbol(symbol,meaning)}function buildTypeDisplay(type,writer,enclosingDeclaration,globalFlags,symbolStack){function writeType(type,flags){16777343&type.flags?writer.writeKeyword(16&globalFlags||!isTypeAny(type)?type.intrinsicName:"any"):33554432&type.flags?(inObjectTypeLiteral&&writer.reportInaccessibleThisError(),writer.writeKeyword("this")):4096&type.flags?writeTypeReference(type,flags):3712&type.flags?buildSymbolDisplay(type.symbol,writer,enclosingDeclaration,793056,0,flags):8192&type.flags?writeTupleType(type):49152&type.flags?writeUnionOrIntersectionType(type,flags):65536&type.flags?writeAnonymousType(type,flags):256&type.flags?writer.writeStringLiteral('"'+ts.escapeString(type.text)+'"'):(writePunctuation(writer,15),writeSpace(writer),writePunctuation(writer,22),writeSpace(writer),writePunctuation(writer,16))}function writeTypeList(types,delimiter){for(var i=0;i<types.length;i++)i>0&&(24!==delimiter&&writeSpace(writer),writePunctuation(writer,delimiter),writeSpace(writer)),writeType(types[i],24===delimiter?0:64)}function writeSymbolTypeReference(symbol,typeArguments,pos,end,flags){if((32&symbol.flags||!isReservedMemberName(symbol.name))&&buildSymbolDisplay(symbol,writer,enclosingDeclaration,793056,0,flags),pos<end){for(writePunctuation(writer,25),writeType(typeArguments[pos],0),pos++;pos<end;)writePunctuation(writer,24),writeSpace(writer),writeType(typeArguments[pos],0),pos++;writePunctuation(writer,27)}}function writeTypeReference(type,flags){var typeArguments=type.typeArguments||emptyArray;if(type.target!==globalArrayType||1&flags){var outerTypeParameters=type.target.outerTypeParameters,i=0;if(outerTypeParameters)for(var length_1=outerTypeParameters.length;i<length_1;){var start=i,parent_4=getParentSymbolOfTypeParameter(outerTypeParameters[i]);do i++;while(i<length_1&&getParentSymbolOfTypeParameter(outerTypeParameters[i])===parent_4);ts.rangeEquals(outerTypeParameters,typeArguments,start,i)||(writeSymbolTypeReference(parent_4,typeArguments,start,i,flags),writePunctuation(writer,21))}var typeParameterCount=(type.target.typeParameters||emptyArray).length;writeSymbolTypeReference(type.symbol,typeArguments,i,typeParameterCount,flags)}else writeType(typeArguments[0],64),writePunctuation(writer,19),writePunctuation(writer,20)}function writeTupleType(type){writePunctuation(writer,19),writeTypeList(type.elementTypes,24),writePunctuation(writer,20)}function writeUnionOrIntersectionType(type,flags){64&flags&&writePunctuation(writer,17),writeTypeList(type.types,16384&type.flags?47:46),64&flags&&writePunctuation(writer,18)}function writeAnonymousType(type,flags){function shouldWriteTypeOfFunctionSymbol(){var isStaticMethodSymbol=!!(8192&symbol.flags&&ts.forEach(symbol.declarations,function(declaration){return 64&declaration.flags})),isNonLocalFunctionSymbol=!!(16&symbol.flags)&&(symbol.parent||ts.forEach(symbol.declarations,function(declaration){return 251===declaration.parent.kind||222===declaration.parent.kind}));if(isStaticMethodSymbol||isNonLocalFunctionSymbol)return!!(2&flags)||ts.contains(symbolStack,symbol)}var symbol=type.symbol;if(symbol)if(928&symbol.flags)writeTypeofSymbol(type,flags);else if(shouldWriteTypeOfFunctionSymbol())writeTypeofSymbol(type,flags);else if(ts.contains(symbolStack,symbol)){var typeAlias=getTypeAliasForTypeLiteral(type);typeAlias?buildSymbolDisplay(typeAlias,writer,enclosingDeclaration,793056,0,flags):writeKeyword(writer,117)}else symbolStack||(symbolStack=[]),symbolStack.push(symbol),writeLiteralType(type,flags),symbolStack.pop();else writeLiteralType(type,flags)}function writeTypeofSymbol(type,typeFormatFlags){writeKeyword(writer,101),writeSpace(writer),buildSymbolDisplay(type.symbol,writer,enclosingDeclaration,107455,0,typeFormatFlags)}function getIndexerParameterName(type,indexKind,fallbackName){var declaration=getIndexDeclarationOfSymbol(type.symbol,indexKind);return declaration?(ts.Debug.assert(0!==declaration.parameters.length),ts.declarationNameToString(declaration.parameters[0].name)):fallbackName}function writeLiteralType(type,flags){var resolved=resolveStructuredTypeMembers(type);if(!resolved.properties.length&&!resolved.stringIndexType&&!resolved.numberIndexType){if(!resolved.callSignatures.length&&!resolved.constructSignatures.length)return writePunctuation(writer,15),void writePunctuation(writer,16);if(1===resolved.callSignatures.length&&!resolved.constructSignatures.length)return 64&flags&&writePunctuation(writer,17),buildSignatureDisplay(resolved.callSignatures[0],writer,enclosingDeclaration,8|globalFlagsToPass,void 0,symbolStack),void(64&flags&&writePunctuation(writer,18));if(1===resolved.constructSignatures.length&&!resolved.callSignatures.length)return 64&flags&&writePunctuation(writer,17),writeKeyword(writer,92),writeSpace(writer),buildSignatureDisplay(resolved.constructSignatures[0],writer,enclosingDeclaration,8|globalFlagsToPass,void 0,symbolStack),void(64&flags&&writePunctuation(writer,18))}var saveInObjectTypeLiteral=inObjectTypeLiteral;inObjectTypeLiteral=!0,writePunctuation(writer,15),writer.writeLine(),writer.increaseIndent();for(var _i=0,_a=resolved.callSignatures;_i<_a.length;_i++){var signature=_a[_i];buildSignatureDisplay(signature,writer,enclosingDeclaration,globalFlagsToPass,void 0,symbolStack),writePunctuation(writer,23),writer.writeLine()}for(var _b=0,_c=resolved.constructSignatures;_b<_c.length;_b++){var signature=_c[_b];buildSignatureDisplay(signature,writer,enclosingDeclaration,globalFlagsToPass,1,symbolStack),writePunctuation(writer,23),writer.writeLine()}resolved.stringIndexType&&(writePunctuation(writer,19),writer.writeParameter(getIndexerParameterName(resolved,0,"x")),writePunctuation(writer,54),writeSpace(writer),writeKeyword(writer,130),writePunctuation(writer,20),writePunctuation(writer,54),writeSpace(writer),writeType(resolved.stringIndexType,0),writePunctuation(writer,23),writer.writeLine()),resolved.numberIndexType&&(writePunctuation(writer,19),writer.writeParameter(getIndexerParameterName(resolved,1,"x")),writePunctuation(writer,54),writeSpace(writer),writeKeyword(writer,128),writePunctuation(writer,20),writePunctuation(writer,54),writeSpace(writer),writeType(resolved.numberIndexType,0),writePunctuation(writer,23),writer.writeLine());for(var _d=0,_e=resolved.properties;_d<_e.length;_d++){var p=_e[_d],t=getTypeOfSymbol(p);if(8208&p.flags&&!getPropertiesOfObjectType(t).length)for(var signatures=getSignaturesOfType(t,0),_f=0,signatures_1=signatures;_f<signatures_1.length;_f++){var signature=signatures_1[_f];buildSymbolDisplay(p,writer),536870912&p.flags&&writePunctuation(writer,53),buildSignatureDisplay(signature,writer,enclosingDeclaration,globalFlagsToPass,void 0,symbolStack),writePunctuation(writer,23),writer.writeLine()}else buildSymbolDisplay(p,writer),536870912&p.flags&&writePunctuation(writer,53),writePunctuation(writer,54),writeSpace(writer),writeType(t,0),writePunctuation(writer,23),writer.writeLine()}writer.decreaseIndent(),writePunctuation(writer,16),inObjectTypeLiteral=saveInObjectTypeLiteral}var globalFlagsToPass=16&globalFlags,inObjectTypeLiteral=!1;return writeType(type,globalFlags)}function buildTypeParameterDisplayFromSymbol(symbol,writer,enclosingDeclaration,flags){var targetSymbol=getTargetSymbol(symbol);(32&targetSymbol.flags||64&targetSymbol.flags||524288&targetSymbol.flags)&&buildDisplayForTypeParametersAndDelimiters(getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol),writer,enclosingDeclaration,flags)}function buildTypeParameterDisplay(tp,writer,enclosingDeclaration,flags,symbolStack){appendSymbolNameOnly(tp.symbol,writer);var constraint=getConstraintOfTypeParameter(tp);constraint&&(writeSpace(writer),writeKeyword(writer,83),writeSpace(writer),buildTypeDisplay(constraint,writer,enclosingDeclaration,flags,symbolStack))}function buildParameterDisplay(p,writer,enclosingDeclaration,flags,symbolStack){var parameterNode=p.valueDeclaration;ts.isRestParameter(parameterNode)&&writePunctuation(writer,22),appendSymbolNameOnly(p,writer),isOptionalParameter(parameterNode)&&writePunctuation(writer,53),writePunctuation(writer,54),writeSpace(writer),buildTypeDisplay(getTypeOfSymbol(p),writer,enclosingDeclaration,flags,symbolStack)}function buildDisplayForTypeParametersAndDelimiters(typeParameters,writer,enclosingDeclaration,flags,symbolStack){if(typeParameters&&typeParameters.length){writePunctuation(writer,25);for(var i=0;i<typeParameters.length;i++)i>0&&(writePunctuation(writer,24),writeSpace(writer)),buildTypeParameterDisplay(typeParameters[i],writer,enclosingDeclaration,flags,symbolStack);writePunctuation(writer,27)}}function buildDisplayForTypeArgumentsAndDelimiters(typeParameters,mapper,writer,enclosingDeclaration,flags,symbolStack){if(typeParameters&&typeParameters.length){writePunctuation(writer,25);for(var i=0;i<typeParameters.length;i++)i>0&&(writePunctuation(writer,24),writeSpace(writer)),buildTypeDisplay(mapper(typeParameters[i]),writer,enclosingDeclaration,0);writePunctuation(writer,27)}}function buildDisplayForParametersAndDelimiters(parameters,writer,enclosingDeclaration,flags,symbolStack){writePunctuation(writer,17);for(var i=0;i<parameters.length;i++)i>0&&(writePunctuation(writer,24),writeSpace(writer)),buildParameterDisplay(parameters[i],writer,enclosingDeclaration,flags,symbolStack);writePunctuation(writer,18)}function buildTypePredicateDisplay(predicate,writer,enclosingDeclaration,flags,symbolStack){ts.isIdentifierTypePredicate(predicate)?writer.writeParameter(predicate.parameterName):writeKeyword(writer,97),writeSpace(writer),writeKeyword(writer,124),writeSpace(writer),buildTypeDisplay(predicate.type,writer,enclosingDeclaration,flags,symbolStack)}function buildReturnTypeDisplay(signature,writer,enclosingDeclaration,flags,symbolStack){if(8&flags?(writeSpace(writer),writePunctuation(writer,34)):writePunctuation(writer,54),writeSpace(writer),signature.typePredicate)buildTypePredicateDisplay(signature.typePredicate,writer,enclosingDeclaration,flags,symbolStack);else{var returnType=getReturnTypeOfSignature(signature);buildTypeDisplay(returnType,writer,enclosingDeclaration,flags,symbolStack)}}function buildSignatureDisplay(signature,writer,enclosingDeclaration,flags,kind,symbolStack){1===kind&&(writeKeyword(writer,92),writeSpace(writer)),signature.target&&32&flags?buildDisplayForTypeArgumentsAndDelimiters(signature.target.typeParameters,signature.mapper,writer,enclosingDeclaration):buildDisplayForTypeParametersAndDelimiters(signature.typeParameters,writer,enclosingDeclaration,flags,symbolStack),buildDisplayForParametersAndDelimiters(signature.parameters,writer,enclosingDeclaration,flags,symbolStack),buildReturnTypeDisplay(signature,writer,enclosingDeclaration,flags,symbolStack)}return _displayBuilder||(_displayBuilder={buildSymbolDisplay:buildSymbolDisplay,buildTypeDisplay:buildTypeDisplay,buildTypeParameterDisplay:buildTypeParameterDisplay,buildTypePredicateDisplay:buildTypePredicateDisplay,buildParameterDisplay:buildParameterDisplay,buildDisplayForParametersAndDelimiters:buildDisplayForParametersAndDelimiters,buildDisplayForTypeParametersAndDelimiters:buildDisplayForTypeParametersAndDelimiters,buildTypeParameterDisplayFromSymbol:buildTypeParameterDisplayFromSymbol,buildSignatureDisplay:buildSignatureDisplay,buildReturnTypeDisplay:buildReturnTypeDisplay})}function isDeclarationVisible(node){function determineIfDeclarationIsVisible(){switch(node.kind){case 166:return isDeclarationVisible(node.parent.parent);case 214:if(ts.isBindingPattern(node.name)&&!node.name.elements.length)return!1;case 221:case 217:case 218:case 219:case 216:case 220:case 224:if(ts.isExternalModuleAugmentation(node))return!0;var parent_5=getDeclarationContainer(node);return 2&ts.getCombinedNodeFlags(node)||224!==node.kind&&251!==parent_5.kind&&ts.isInAmbientContext(parent_5)?isDeclarationVisible(parent_5):isGlobalSourceFile(parent_5);case 142:case 141:case 146:case 147:case 144:case 143:if(48&node.flags)return!1;case 145:case 149:case 148:case 150:case 139:case 222:case 153:case 154:case 156:case 152:case 157:case 158:case 159:case 160:case 161:return isDeclarationVisible(node.parent);case 226:case 227:case 229:return!1;case 138:case 251:return!0;case 230:return!1;default:ts.Debug.fail("isDeclarationVisible unknown: SyntaxKind: "+node.kind)}}if(node){var links=getNodeLinks(node);return void 0===links.isVisible&&(links.isVisible=!!determineIfDeclarationIsVisible()),links.isVisible}return!1}function collectLinkedAliases(node){function buildVisibleNodeList(declarations){ts.forEach(declarations,function(declaration){getNodeLinks(declaration).isVisible=!0;var resultNode=getAnyImportSyntax(declaration)||declaration;if(ts.contains(result,resultNode)||result.push(resultNode),ts.isInternalModuleImportEqualsDeclaration(declaration)){var internalModuleReference=declaration.moduleReference,firstIdentifier=getFirstIdentifier(internalModuleReference),importSymbol=resolveName(declaration,firstIdentifier.text,901119,ts.Diagnostics.Cannot_find_name_0,firstIdentifier);importSymbol&&buildVisibleNodeList(importSymbol.declarations)}})}var exportSymbol;if(node.parent&&230===node.parent.kind)exportSymbol=resolveName(node.parent,node.text,9289727,ts.Diagnostics.Cannot_find_name_0,node);else if(233===node.parent.kind){var exportSpecifier=node.parent;exportSymbol=exportSpecifier.parent.parent.moduleSpecifier?getExternalModuleMember(exportSpecifier.parent.parent,exportSpecifier):resolveEntityName(exportSpecifier.propertyName||exportSpecifier.name,9289727)}var result=[];return exportSymbol&&buildVisibleNodeList(exportSymbol.declarations),result}function pushTypeResolution(target,propertyName){var resolutionCycleStartIndex=findResolutionCycleStartIndex(target,propertyName);if(resolutionCycleStartIndex>=0){for(var length_2=resolutionTargets.length,i=resolutionCycleStartIndex;i<length_2;i++)resolutionResults[i]=!1;return!1}return resolutionTargets.push(target),resolutionResults.push(!0),resolutionPropertyNames.push(propertyName),!0}function findResolutionCycleStartIndex(target,propertyName){for(var i=resolutionTargets.length-1;i>=0;i--){if(hasType(resolutionTargets[i],resolutionPropertyNames[i]))return-1;if(resolutionTargets[i]===target&&resolutionPropertyNames[i]===propertyName)return i}return-1}function hasType(target,propertyName){return 0===propertyName?getSymbolLinks(target).type:2===propertyName?getSymbolLinks(target).declaredType:1===propertyName?(ts.Debug.assert(!!(1024&target.flags)),target.resolvedBaseConstructorType):3===propertyName?target.resolvedReturnType:void ts.Debug.fail("Unhandled TypeSystemPropertyName "+propertyName)}function popTypeResolution(){return resolutionTargets.pop(),resolutionPropertyNames.pop(),resolutionResults.pop()}function getDeclarationContainer(node){for(node=ts.getRootDeclaration(node);node;)switch(node.kind){case 214:case 215:case 229:case 228:case 227:case 226:node=node.parent;break;default:return node.parent}}function getTypeOfPrototypeProperty(prototype){var classType=getDeclaredTypeOfSymbol(getParentOfSymbol(prototype));return classType.typeParameters?createTypeReference(classType,ts.map(classType.typeParameters,function(_){return anyType})):classType}function getTypeOfPropertyOfType(type,name){var prop=getPropertyOfType(type,name);return prop?getTypeOfSymbol(prop):void 0}function isTypeAny(type){return type&&0!==(1&type.flags)}function getTypeForBindingElementParent(node){var symbol=getSymbolOfNode(node);return symbol&&getSymbolLinks(symbol).type||getTypeForVariableLikeDeclaration(node)}function getTextOfPropertyName(name){switch(name.kind){case 69:return name.text;case 9:case 8:return name.text;case 137:if(ts.isStringOrNumericLiteral(name.expression.kind))return name.expression.text}}function isComputedNonLiteralName(name){return 137===name.kind&&!ts.isStringOrNumericLiteral(name.expression.kind)}function getTypeForBindingElement(declaration){var pattern=declaration.parent,parentType=getTypeForBindingElementParent(pattern.parent);if(parentType===unknownType)return unknownType;if(!parentType||isTypeAny(parentType))return declaration.initializer?checkExpressionCached(declaration.initializer):parentType;var type;if(164===pattern.kind){var name_10=declaration.propertyName||declaration.name;if(isComputedNonLiteralName(name_10))return anyType;var text=getTextOfPropertyName(name_10);if(type=getTypeOfPropertyOfType(parentType,text)||isNumericLiteralName(text)&&getIndexTypeOfType(parentType,1)||getIndexTypeOfType(parentType,0),!type)return error(name_10,ts.Diagnostics.Type_0_has_no_property_1_and_no_string_index_signature,typeToString(parentType),ts.declarationNameToString(name_10)),unknownType}else{var elementType=checkIteratedTypeOrElementType(parentType,pattern,!1);if(declaration.dotDotDotToken)type=createArrayType(elementType);else{var propName=""+ts.indexOf(pattern.elements,declaration);if(type=isTupleLikeType(parentType)?getTypeOfPropertyOfType(parentType,propName):elementType,!type)return isTupleType(parentType)?error(declaration,ts.Diagnostics.Tuple_type_0_with_length_1_cannot_be_assigned_to_tuple_with_length_2,typeToString(parentType),parentType.elementTypes.length,pattern.elements.length):error(declaration,ts.Diagnostics.Type_0_has_no_property_1,typeToString(parentType),propName),unknownType}}return type}function getTypeForVariableLikeDeclarationFromJSDocComment(declaration){var jsDocType=getJSDocTypeForVariableLikeDeclarationFromJSDocComment(declaration);if(jsDocType)return getTypeFromTypeNode(jsDocType)}function getJSDocTypeForVariableLikeDeclarationFromJSDocComment(declaration){var typeTag=ts.getJSDocTypeTag(declaration);if(typeTag&&typeTag.typeExpression)return typeTag.typeExpression.type;if(214===declaration.kind&&215===declaration.parent.kind&&196===declaration.parent.parent.kind){var annotation=ts.getJSDocTypeTag(declaration.parent.parent);if(annotation&&annotation.typeExpression)return annotation.typeExpression.type}else if(139===declaration.kind){var paramTag=ts.getCorrespondingJSDocParameterTag(declaration);if(paramTag&&paramTag.typeExpression)return paramTag.typeExpression.type}}function getTypeForVariableLikeDeclaration(declaration){if(32&declaration.parserContextFlags){var type=getTypeForVariableLikeDeclarationFromJSDocComment(declaration);if(type&&type!==unknownType)return type}if(203===declaration.parent.parent.kind)return stringType;if(204===declaration.parent.parent.kind)return checkRightHandSideOfForOf(declaration.parent.parent.expression)||anyType;if(ts.isBindingPattern(declaration.parent))return getTypeForBindingElement(declaration);if(declaration.type)return getTypeFromTypeNode(declaration.type);if(139===declaration.kind){var func=declaration.parent;if(147===func.kind&&!ts.hasDynamicName(func)){var getter=ts.getDeclarationOfKind(declaration.parent.symbol,146);if(getter)return getReturnTypeOfSignature(getSignatureFromDeclaration(getter))}var type=getContextuallyTypedParameterType(declaration);if(type)return type}return declaration.initializer?checkExpressionCached(declaration.initializer):249===declaration.kind?checkIdentifier(declaration.name):ts.isBindingPattern(declaration.name)?getTypeFromBindingPattern(declaration.name,!1):void 0}function getTypeFromBindingElement(element,includePatternInType){return element.initializer?getWidenedType(checkExpressionCached(element.initializer)):ts.isBindingPattern(element.name)?getTypeFromBindingPattern(element.name,includePatternInType):anyType}function getTypeFromObjectBindingPattern(pattern,includePatternInType){var members={},hasComputedProperties=!1;ts.forEach(pattern.elements,function(e){var name=e.propertyName||e.name;if(isComputedNonLiteralName(name))return void(hasComputedProperties=!0);var text=getTextOfPropertyName(name),flags=67108868|(e.initializer?536870912:0),symbol=createSymbol(flags,text);symbol.type=getTypeFromBindingElement(e,includePatternInType),symbol.bindingElement=e,members[symbol.name]=symbol});var result=createAnonymousType(void 0,members,emptyArray,emptyArray,void 0,void 0);return includePatternInType&&(result.pattern=pattern),hasComputedProperties&&(result.flags|=67108864),result}function getTypeFromArrayBindingPattern(pattern,includePatternInType){var elements=pattern.elements;if(0===elements.length||elements[elements.length-1].dotDotDotToken)return languageVersion>=2?createIterableType(anyType):anyArrayType;var elementTypes=ts.map(elements,function(e){return 190===e.kind?anyType:getTypeFromBindingElement(e,includePatternInType)});if(includePatternInType){var result=createNewTupleType(elementTypes);return result.pattern=pattern,result}return createTupleType(elementTypes)}function getTypeFromBindingPattern(pattern,includePatternInType){return 164===pattern.kind?getTypeFromObjectBindingPattern(pattern,includePatternInType):getTypeFromArrayBindingPattern(pattern,includePatternInType)}function getWidenedTypeForVariableLikeDeclaration(declaration,reportErrors){var type=getTypeForVariableLikeDeclaration(declaration);if(type)return reportErrors&&reportErrorsFromWidening(declaration,type),248===declaration.kind?type:getWidenedType(type);if(type=declaration.dotDotDotToken?anyArrayType:anyType,reportErrors&&compilerOptions.noImplicitAny){var root=ts.getRootDeclaration(declaration);isPrivateWithinAmbient(root)||139===root.kind&&isPrivateWithinAmbient(root.parent)||reportImplicitAnyError(declaration,type)}return type}function getTypeOfVariableOrParameterOrProperty(symbol){var links=getSymbolLinks(symbol);if(!links.type){if(134217728&symbol.flags)return links.type=getTypeOfPrototypeProperty(symbol);var declaration=symbol.valueDeclaration;if(247===declaration.parent.kind)return links.type=anyType;if(230===declaration.kind)return links.type=checkExpression(declaration.expression);if(184===declaration.kind)return links.type=getUnionType(ts.map(symbol.declarations,function(decl){return checkExpressionCached(decl.right)}));if(169===declaration.kind&&184===declaration.parent.kind)return links.type=checkExpressionCached(declaration.parent.right);if(!pushTypeResolution(symbol,0))return unknownType;var type=getWidenedTypeForVariableLikeDeclaration(declaration,!0);popTypeResolution()||(symbol.valueDeclaration.type?(type=unknownType,error(symbol.valueDeclaration,ts.Diagnostics._0_is_referenced_directly_or_indirectly_in_its_own_type_annotation,symbolToString(symbol))):(type=anyType,compilerOptions.noImplicitAny&&error(symbol.valueDeclaration,ts.Diagnostics._0_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_and_is_referenced_directly_or_indirectly_in_its_own_initializer,symbolToString(symbol)))),links.type=type}return links.type}function getAnnotatedAccessorType(accessor){if(accessor){if(146===accessor.kind)return accessor.type&&getTypeFromTypeNode(accessor.type);var setterTypeAnnotation=ts.getSetAccessorTypeAnnotationNode(accessor);return setterTypeAnnotation&&getTypeFromTypeNode(setterTypeAnnotation)}}function getTypeOfAccessors(symbol){var links=getSymbolLinks(symbol);if(!links.type){if(!pushTypeResolution(symbol,0))return unknownType;var getter=ts.getDeclarationOfKind(symbol,146),setter=ts.getDeclarationOfKind(symbol,147),type=void 0,getterReturnType=getAnnotatedAccessorType(getter);if(getterReturnType)type=getterReturnType;else{var setterParameterType=getAnnotatedAccessorType(setter);setterParameterType?type=setterParameterType:getter&&getter.body?type=getReturnTypeFromBody(getter):(compilerOptions.noImplicitAny&&error(setter,ts.Diagnostics.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_type_annotation,symbolToString(symbol)),type=anyType)}if(!popTypeResolution()&&(type=anyType,compilerOptions.noImplicitAny)){var getter_1=ts.getDeclarationOfKind(symbol,146);error(getter_1,ts.Diagnostics._0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions,symbolToString(symbol))}links.type=type}return links.type}function getTypeOfFuncClassEnumModule(symbol){var links=getSymbolLinks(symbol);return links.type||(links.type=createObjectType(65536,symbol)),links.type}function getTypeOfEnumMember(symbol){var links=getSymbolLinks(symbol);return links.type||(links.type=getDeclaredTypeOfEnum(getParentOfSymbol(symbol))),links.type}function getTypeOfAlias(symbol){var links=getSymbolLinks(symbol);if(!links.type){var targetSymbol=resolveAlias(symbol);links.type=107455&targetSymbol.flags?getTypeOfSymbol(targetSymbol):unknownType}return links.type}function getTypeOfInstantiatedSymbol(symbol){var links=getSymbolLinks(symbol);return links.type||(links.type=instantiateType(getTypeOfSymbol(links.target),links.mapper)),links.type}function getTypeOfSymbol(symbol){return 16777216&symbol.flags?getTypeOfInstantiatedSymbol(symbol):7&symbol.flags?getTypeOfVariableOrParameterOrProperty(symbol):9136&symbol.flags?getTypeOfFuncClassEnumModule(symbol):8&symbol.flags?getTypeOfEnumMember(symbol):98304&symbol.flags?getTypeOfAccessors(symbol):8388608&symbol.flags?getTypeOfAlias(symbol):unknownType}function getTargetType(type){return 4096&type.flags?type.target:type}function hasBaseType(type,checkBase){function check(type){var target=getTargetType(type);return target===checkBase||ts.forEach(getBaseTypes(target),check)}return check(type)}function appendTypeParameters(typeParameters,declarations){for(var _i=0,declarations_2=declarations;_i<declarations_2.length;_i++){var declaration=declarations_2[_i],tp=getDeclaredTypeOfTypeParameter(getSymbolOfNode(declaration));typeParameters?ts.contains(typeParameters,tp)||typeParameters.push(tp):typeParameters=[tp]}return typeParameters}function appendOuterTypeParameters(typeParameters,node){for(;;){if(node=node.parent,!node)return typeParameters;if(217===node.kind||189===node.kind||216===node.kind||176===node.kind||144===node.kind||177===node.kind){var declarations=node.typeParameters;if(declarations)return appendTypeParameters(appendOuterTypeParameters(typeParameters,node),declarations)}}}function getOuterTypeParametersOfClassOrInterface(symbol){var declaration=32&symbol.flags?symbol.valueDeclaration:ts.getDeclarationOfKind(symbol,218);return appendOuterTypeParameters(void 0,declaration)}function getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol){for(var result,_i=0,_a=symbol.declarations;_i<_a.length;_i++){var node=_a[_i];if(218===node.kind||217===node.kind||189===node.kind||219===node.kind){var declaration=node;declaration.typeParameters&&(result=appendTypeParameters(result,declaration.typeParameters))}}return result}function getTypeParametersOfClassOrInterface(symbol){return ts.concatenate(getOuterTypeParametersOfClassOrInterface(symbol),getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol))}function isConstructorType(type){return 80896&type.flags&&getSignaturesOfType(type,1).length>0}function getBaseTypeNodeOfClass(type){return ts.getClassExtendsHeritageClauseElement(type.symbol.valueDeclaration)}function getConstructorsForTypeArguments(type,typeArgumentNodes){var typeArgCount=typeArgumentNodes?typeArgumentNodes.length:0;return ts.filter(getSignaturesOfType(type,1),function(sig){
return(sig.typeParameters?sig.typeParameters.length:0)===typeArgCount})}function getInstantiatedConstructorsForTypeArguments(type,typeArgumentNodes){var signatures=getConstructorsForTypeArguments(type,typeArgumentNodes);if(typeArgumentNodes){var typeArguments_1=ts.map(typeArgumentNodes,getTypeFromTypeNode);signatures=ts.map(signatures,function(sig){return getSignatureInstantiation(sig,typeArguments_1)})}return signatures}function getBaseConstructorTypeOfClass(type){if(!type.resolvedBaseConstructorType){var baseTypeNode=getBaseTypeNodeOfClass(type);if(!baseTypeNode)return type.resolvedBaseConstructorType=undefinedType;if(!pushTypeResolution(type,1))return unknownType;var baseConstructorType=checkExpression(baseTypeNode.expression);if(80896&baseConstructorType.flags&&resolveStructuredTypeMembers(baseConstructorType),!popTypeResolution())return error(type.symbol.valueDeclaration,ts.Diagnostics._0_is_referenced_directly_or_indirectly_in_its_own_base_expression,symbolToString(type.symbol)),type.resolvedBaseConstructorType=unknownType;if(baseConstructorType!==unknownType&&baseConstructorType!==nullType&&!isConstructorType(baseConstructorType))return error(baseTypeNode.expression,ts.Diagnostics.Type_0_is_not_a_constructor_function_type,typeToString(baseConstructorType)),type.resolvedBaseConstructorType=unknownType;type.resolvedBaseConstructorType=baseConstructorType}return type.resolvedBaseConstructorType}function getBaseTypes(type){var isClass=32&type.symbol.flags,isInterface=64&type.symbol.flags;return type.resolvedBaseTypes||(isClass||isInterface||ts.Debug.fail("type must be class or interface"),isClass&&resolveBaseTypesOfClass(type),isInterface&&resolveBaseTypesOfInterface(type)),type.resolvedBaseTypes}function resolveBaseTypesOfClass(type){type.resolvedBaseTypes=type.resolvedBaseTypes||emptyArray;var baseConstructorType=getBaseConstructorTypeOfClass(type);if(80896&baseConstructorType.flags){var baseType,baseTypeNode=getBaseTypeNodeOfClass(type),originalBaseType=baseConstructorType&&baseConstructorType.symbol?getDeclaredTypeOfSymbol(baseConstructorType.symbol):void 0;if(baseConstructorType.symbol&&32&baseConstructorType.symbol.flags&&areAllOuterTypeParametersApplied(originalBaseType))baseType=getTypeFromClassOrInterfaceReference(baseTypeNode,baseConstructorType.symbol);else{var constructors=getInstantiatedConstructorsForTypeArguments(baseConstructorType,baseTypeNode.typeArguments);if(!constructors.length)return void error(baseTypeNode.expression,ts.Diagnostics.No_base_constructor_has_the_specified_number_of_type_arguments);baseType=getReturnTypeOfSignature(constructors[0])}if(baseType!==unknownType)return 3072&getTargetType(baseType).flags?type===baseType||hasBaseType(baseType,type)?void error(type.symbol.valueDeclaration,ts.Diagnostics.Type_0_recursively_references_itself_as_a_base_type,typeToString(type,void 0,1)):void(type.resolvedBaseTypes===emptyArray?type.resolvedBaseTypes=[baseType]:type.resolvedBaseTypes.push(baseType)):void error(baseTypeNode.expression,ts.Diagnostics.Base_constructor_return_type_0_is_not_a_class_or_interface_type,typeToString(baseType))}}function areAllOuterTypeParametersApplied(type){var outerTypeParameters=type.outerTypeParameters;if(outerTypeParameters){var last=outerTypeParameters.length-1,typeArguments=type.typeArguments;return outerTypeParameters[last].symbol!==typeArguments[last].symbol}return!0}function resolveBaseTypesOfInterface(type){type.resolvedBaseTypes=type.resolvedBaseTypes||emptyArray;for(var _i=0,_a=type.symbol.declarations;_i<_a.length;_i++){var declaration=_a[_i];if(218===declaration.kind&&ts.getInterfaceBaseTypeNodes(declaration))for(var _b=0,_c=ts.getInterfaceBaseTypeNodes(declaration);_b<_c.length;_b++){var node=_c[_b],baseType=getTypeFromTypeNode(node);baseType!==unknownType&&(3072&getTargetType(baseType).flags?type===baseType||hasBaseType(baseType,type)?error(declaration,ts.Diagnostics.Type_0_recursively_references_itself_as_a_base_type,typeToString(type,void 0,1)):type.resolvedBaseTypes===emptyArray?type.resolvedBaseTypes=[baseType]:type.resolvedBaseTypes.push(baseType):error(node,ts.Diagnostics.An_interface_may_only_extend_a_class_or_another_interface))}}}function isIndependentInterface(symbol){for(var _i=0,_a=symbol.declarations;_i<_a.length;_i++){var declaration=_a[_i];if(218===declaration.kind){if(262144&declaration.flags)return!1;var baseTypeNodes=ts.getInterfaceBaseTypeNodes(declaration);if(baseTypeNodes)for(var _b=0,baseTypeNodes_1=baseTypeNodes;_b<baseTypeNodes_1.length;_b++){var node=baseTypeNodes_1[_b];if(ts.isSupportedExpressionWithTypeArguments(node)){var baseSymbol=resolveEntityName(node.expression,793056,!0);if(!baseSymbol||!(64&baseSymbol.flags)||getDeclaredTypeOfClassOrInterface(baseSymbol).thisType)return!1}}}}return!0}function getDeclaredTypeOfClassOrInterface(symbol){var links=getSymbolLinks(symbol);if(!links.declaredType){var kind=32&symbol.flags?1024:2048,type=links.declaredType=createObjectType(kind,symbol),outerTypeParameters=getOuterTypeParametersOfClassOrInterface(symbol),localTypeParameters=getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol);(outerTypeParameters||localTypeParameters||1024===kind||!isIndependentInterface(symbol))&&(type.flags|=4096,type.typeParameters=ts.concatenate(outerTypeParameters,localTypeParameters),type.outerTypeParameters=outerTypeParameters,type.localTypeParameters=localTypeParameters,type.instantiations={},type.instantiations[getTypeListId(type.typeParameters)]=type,type.target=type,type.typeArguments=type.typeParameters,type.thisType=createType(33554944),type.thisType.symbol=symbol,type.thisType.constraint=type)}return links.declaredType}function getDeclaredTypeOfTypeAlias(symbol){var links=getSymbolLinks(symbol);if(!links.declaredType){if(!pushTypeResolution(symbol,2))return unknownType;var declaration=ts.getDeclarationOfKind(symbol,219),type=getTypeFromTypeNode(declaration.type);popTypeResolution()?(links.typeParameters=getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol),links.typeParameters&&(links.instantiations={},links.instantiations[getTypeListId(links.typeParameters)]=type)):(type=unknownType,error(declaration.name,ts.Diagnostics.Type_alias_0_circularly_references_itself,symbolToString(symbol))),links.declaredType=type}return links.declaredType}function getDeclaredTypeOfEnum(symbol){var links=getSymbolLinks(symbol);if(!links.declaredType){var type=createType(128);type.symbol=symbol,links.declaredType=type}return links.declaredType}function getDeclaredTypeOfTypeParameter(symbol){var links=getSymbolLinks(symbol);if(!links.declaredType){var type=createType(512);type.symbol=symbol,ts.getDeclarationOfKind(symbol,138).constraint||(type.constraint=noConstraintType),links.declaredType=type}return links.declaredType}function getDeclaredTypeOfAlias(symbol){var links=getSymbolLinks(symbol);return links.declaredType||(links.declaredType=getDeclaredTypeOfSymbol(resolveAlias(symbol))),links.declaredType}function getDeclaredTypeOfSymbol(symbol){return ts.Debug.assert(0===(16777216&symbol.flags)),96&symbol.flags?getDeclaredTypeOfClassOrInterface(symbol):524288&symbol.flags?getDeclaredTypeOfTypeAlias(symbol):384&symbol.flags?getDeclaredTypeOfEnum(symbol):262144&symbol.flags?getDeclaredTypeOfTypeParameter(symbol):8388608&symbol.flags?getDeclaredTypeOfAlias(symbol):unknownType}function isIndependentTypeReference(node){if(node.typeArguments)for(var _i=0,_a=node.typeArguments;_i<_a.length;_i++){var typeNode=_a[_i];if(!isIndependentType(typeNode))return!1}return!0}function isIndependentType(node){switch(node.kind){case 117:case 130:case 128:case 120:case 131:case 103:case 163:return!0;case 157:return isIndependentType(node.elementType);case 152:return isIndependentTypeReference(node)}return!1}function isIndependentVariableLikeDeclaration(node){return node.type&&isIndependentType(node.type)||!node.type&&!node.initializer}function isIndependentFunctionLikeDeclaration(node){if(!(145===node.kind||node.type&&isIndependentType(node.type)))return!1;for(var _i=0,_a=node.parameters;_i<_a.length;_i++){var parameter=_a[_i];if(!isIndependentVariableLikeDeclaration(parameter))return!1}return!0}function isIndependentMember(symbol){if(symbol.declarations&&1===symbol.declarations.length){var declaration=symbol.declarations[0];if(declaration)switch(declaration.kind){case 142:case 141:return isIndependentVariableLikeDeclaration(declaration);case 144:case 143:case 145:return isIndependentFunctionLikeDeclaration(declaration)}}return!1}function createSymbolTable(symbols){for(var result={},_i=0,symbols_1=symbols;_i<symbols_1.length;_i++){var symbol=symbols_1[_i];result[symbol.name]=symbol}return result}function createInstantiatedSymbolTable(symbols,mapper,mappingThisOnly){for(var result={},_i=0,symbols_2=symbols;_i<symbols_2.length;_i++){var symbol=symbols_2[_i];result[symbol.name]=mappingThisOnly&&isIndependentMember(symbol)?symbol:instantiateSymbol(symbol,mapper)}return result}function addInheritedMembers(symbols,baseSymbols){for(var _i=0,baseSymbols_1=baseSymbols;_i<baseSymbols_1.length;_i++){var s=baseSymbols_1[_i];ts.hasProperty(symbols,s.name)||(symbols[s.name]=s)}}function resolveDeclaredMembers(type){if(!type.declaredProperties){var symbol=type.symbol;type.declaredProperties=getNamedMembers(symbol.members),type.declaredCallSignatures=getSignaturesOfSymbol(symbol.members.__call),type.declaredConstructSignatures=getSignaturesOfSymbol(symbol.members.__new),type.declaredStringIndexType=getIndexTypeOfSymbol(symbol,0),type.declaredNumberIndexType=getIndexTypeOfSymbol(symbol,1)}return type}function getTypeWithThisArgument(type,thisArgument){return 4096&type.flags?createTypeReference(type.target,ts.concatenate(type.typeArguments,[thisArgument||type.target.thisType])):type}function resolveObjectTypeMembers(type,source,typeParameters,typeArguments){var mapper=identityMapper,members=source.symbol.members,callSignatures=source.declaredCallSignatures,constructSignatures=source.declaredConstructSignatures,stringIndexType=source.declaredStringIndexType,numberIndexType=source.declaredNumberIndexType;ts.rangeEquals(typeParameters,typeArguments,0,typeParameters.length)||(mapper=createTypeMapper(typeParameters,typeArguments),members=createInstantiatedSymbolTable(source.declaredProperties,mapper,1===typeParameters.length),callSignatures=instantiateList(source.declaredCallSignatures,mapper,instantiateSignature),constructSignatures=instantiateList(source.declaredConstructSignatures,mapper,instantiateSignature),stringIndexType=instantiateType(source.declaredStringIndexType,mapper),numberIndexType=instantiateType(source.declaredNumberIndexType,mapper));var baseTypes=getBaseTypes(source);if(baseTypes.length){members===source.symbol.members&&(members=createSymbolTable(source.declaredProperties));for(var thisArgument=ts.lastOrUndefined(typeArguments),_i=0,baseTypes_1=baseTypes;_i<baseTypes_1.length;_i++){var baseType=baseTypes_1[_i],instantiatedBaseType=thisArgument?getTypeWithThisArgument(instantiateType(baseType,mapper),thisArgument):baseType;addInheritedMembers(members,getPropertiesOfObjectType(instantiatedBaseType)),callSignatures=ts.concatenate(callSignatures,getSignaturesOfType(instantiatedBaseType,0)),constructSignatures=ts.concatenate(constructSignatures,getSignaturesOfType(instantiatedBaseType,1)),stringIndexType=stringIndexType||getIndexTypeOfType(instantiatedBaseType,0),numberIndexType=numberIndexType||getIndexTypeOfType(instantiatedBaseType,1)}}setObjectTypeMembers(type,members,callSignatures,constructSignatures,stringIndexType,numberIndexType)}function resolveClassOrInterfaceMembers(type){resolveObjectTypeMembers(type,resolveDeclaredMembers(type),emptyArray,emptyArray)}function resolveTypeReferenceMembers(type){var source=resolveDeclaredMembers(type.target),typeParameters=ts.concatenate(source.typeParameters,[source.thisType]),typeArguments=type.typeArguments&&type.typeArguments.length===typeParameters.length?type.typeArguments:ts.concatenate(type.typeArguments,[type]);resolveObjectTypeMembers(type,source,typeParameters,typeArguments)}function createSignature(declaration,typeParameters,parameters,resolvedReturnType,typePredicate,minArgumentCount,hasRestParameter,hasStringLiterals){var sig=new Signature(checker);return sig.declaration=declaration,sig.typeParameters=typeParameters,sig.parameters=parameters,sig.resolvedReturnType=resolvedReturnType,sig.typePredicate=typePredicate,sig.minArgumentCount=minArgumentCount,sig.hasRestParameter=hasRestParameter,sig.hasStringLiterals=hasStringLiterals,sig}function cloneSignature(sig){return createSignature(sig.declaration,sig.typeParameters,sig.parameters,sig.resolvedReturnType,sig.typePredicate,sig.minArgumentCount,sig.hasRestParameter,sig.hasStringLiterals)}function getDefaultConstructSignatures(classType){var baseConstructorType=getBaseConstructorTypeOfClass(classType),baseSignatures=getSignaturesOfType(baseConstructorType,1);if(0===baseSignatures.length)return[createSignature(void 0,classType.localTypeParameters,emptyArray,classType,void 0,0,!1,!1)];for(var baseTypeNode=getBaseTypeNodeOfClass(classType),typeArguments=ts.map(baseTypeNode.typeArguments,getTypeFromTypeNode),typeArgCount=typeArguments?typeArguments.length:0,result=[],_i=0,baseSignatures_1=baseSignatures;_i<baseSignatures_1.length;_i++){var baseSig=baseSignatures_1[_i],typeParamCount=baseSig.typeParameters?baseSig.typeParameters.length:0;if(typeParamCount===typeArgCount){var sig=typeParamCount?getSignatureInstantiation(baseSig,typeArguments):cloneSignature(baseSig);sig.typeParameters=classType.localTypeParameters,sig.resolvedReturnType=classType,result.push(sig)}}return result}function createTupleTypeMemberSymbols(memberTypes){for(var members={},i=0;i<memberTypes.length;i++){var symbol=createSymbol(67108868,""+i);symbol.type=memberTypes[i],members[i]=symbol}return members}function resolveTupleTypeMembers(type){var arrayElementType=getUnionType(type.elementTypes,!0),arrayType=resolveStructuredTypeMembers(createTypeFromGenericGlobalType(globalArrayType,[arrayElementType,type])),members=createTupleTypeMemberSymbols(type.elementTypes);addInheritedMembers(members,arrayType.properties),setObjectTypeMembers(type,members,arrayType.callSignatures,arrayType.constructSignatures,arrayType.stringIndexType,arrayType.numberIndexType)}function findMatchingSignature(signatureList,signature,partialMatch,ignoreReturnTypes){for(var _i=0,signatureList_1=signatureList;_i<signatureList_1.length;_i++){var s=signatureList_1[_i];if(compareSignaturesIdentical(s,signature,partialMatch,ignoreReturnTypes,compareTypesIdentical))return s}}function findMatchingSignatures(signatureLists,signature,listIndex){if(signature.typeParameters){if(listIndex>0)return;for(var i=1;i<signatureLists.length;i++)if(!findMatchingSignature(signatureLists[i],signature,!1,!1))return;return[signature]}for(var result=void 0,i=0;i<signatureLists.length;i++){var match=i===listIndex?signature:findMatchingSignature(signatureLists[i],signature,!0,!0);if(!match)return;ts.contains(result,match)||(result||(result=[])).push(match)}return result}function getUnionSignatures(types,kind){for(var signatureLists=ts.map(types,function(t){return getSignaturesOfType(t,kind)}),result=void 0,i=0;i<signatureLists.length;i++)for(var _i=0,_a=signatureLists[i];_i<_a.length;_i++){var signature=_a[_i];if(!result||!findMatchingSignature(result,signature,!1,!0)){var unionSignatures=findMatchingSignatures(signatureLists,signature,i);if(unionSignatures){var s=signature;unionSignatures.length>1&&(s=cloneSignature(signature),s.resolvedReturnType=void 0,s.unionSignatures=unionSignatures),(result||(result=[])).push(s)}}}return result||emptyArray}function getUnionIndexType(types,kind){for(var indexTypes=[],_i=0,types_1=types;_i<types_1.length;_i++){var type=types_1[_i],indexType=getIndexTypeOfType(type,kind);if(!indexType)return;indexTypes.push(indexType)}return getUnionType(indexTypes)}function resolveUnionTypeMembers(type){var callSignatures=getUnionSignatures(type.types,0),constructSignatures=getUnionSignatures(type.types,1),stringIndexType=getUnionIndexType(type.types,0),numberIndexType=getUnionIndexType(type.types,1);setObjectTypeMembers(type,emptySymbols,callSignatures,constructSignatures,stringIndexType,numberIndexType)}function intersectTypes(type1,type2){return type1?type2?getIntersectionType([type1,type2]):type1:type2}function resolveIntersectionTypeMembers(type){for(var callSignatures=emptyArray,constructSignatures=emptyArray,stringIndexType=void 0,numberIndexType=void 0,_i=0,_a=type.types;_i<_a.length;_i++){var t=_a[_i];callSignatures=ts.concatenate(callSignatures,getSignaturesOfType(t,0)),constructSignatures=ts.concatenate(constructSignatures,getSignaturesOfType(t,1)),stringIndexType=intersectTypes(stringIndexType,getIndexTypeOfType(t,0)),numberIndexType=intersectTypes(numberIndexType,getIndexTypeOfType(t,1))}setObjectTypeMembers(type,emptySymbols,callSignatures,constructSignatures,stringIndexType,numberIndexType)}function resolveAnonymousTypeMembers(type){var symbol=type.symbol;if(type.target){var members=createInstantiatedSymbolTable(getPropertiesOfObjectType(type.target),type.mapper,!1),callSignatures=instantiateList(getSignaturesOfType(type.target,0),type.mapper,instantiateSignature),constructSignatures=instantiateList(getSignaturesOfType(type.target,1),type.mapper,instantiateSignature),stringIndexType=instantiateType(getIndexTypeOfType(type.target,0),type.mapper),numberIndexType=instantiateType(getIndexTypeOfType(type.target,1),type.mapper);setObjectTypeMembers(type,members,callSignatures,constructSignatures,stringIndexType,numberIndexType)}else if(2048&symbol.flags){var members=symbol.members,callSignatures=getSignaturesOfSymbol(members.__call),constructSignatures=getSignaturesOfSymbol(members.__new),stringIndexType=getIndexTypeOfSymbol(symbol,0),numberIndexType=getIndexTypeOfSymbol(symbol,1);setObjectTypeMembers(type,members,callSignatures,constructSignatures,stringIndexType,numberIndexType)}else{var members=emptySymbols,constructSignatures=emptyArray;if(1952&symbol.flags&&(members=getExportsOfSymbol(symbol)),32&symbol.flags){var classType=getDeclaredTypeOfClassOrInterface(symbol);constructSignatures=getSignaturesOfSymbol(symbol.members.__constructor),constructSignatures.length||(constructSignatures=getDefaultConstructSignatures(classType));var baseConstructorType=getBaseConstructorTypeOfClass(classType);80896&baseConstructorType.flags&&(members=createSymbolTable(getNamedMembers(members)),addInheritedMembers(members,getPropertiesOfObjectType(baseConstructorType)))}var numberIndexType=384&symbol.flags?stringType:void 0;setObjectTypeMembers(type,members,emptyArray,constructSignatures,void 0,numberIndexType),8208&symbol.flags&&(type.callSignatures=getSignaturesOfSymbol(symbol))}}function resolveStructuredTypeMembers(type){return type.members||(4096&type.flags?resolveTypeReferenceMembers(type):3072&type.flags?resolveClassOrInterfaceMembers(type):65536&type.flags?resolveAnonymousTypeMembers(type):8192&type.flags?resolveTupleTypeMembers(type):16384&type.flags?resolveUnionTypeMembers(type):32768&type.flags&&resolveIntersectionTypeMembers(type)),type}function getPropertiesOfObjectType(type){return 80896&type.flags?resolveStructuredTypeMembers(type).properties:emptyArray}function getPropertyOfObjectType(type,name){if(80896&type.flags){var resolved=resolveStructuredTypeMembers(type);if(ts.hasProperty(resolved.members,name)){var symbol=resolved.members[name];if(symbolIsValue(symbol))return symbol}}}function getPropertiesOfUnionOrIntersectionType(type){for(var _i=0,_a=type.types;_i<_a.length;_i++){for(var current=_a[_i],_b=0,_c=getPropertiesOfType(current);_b<_c.length;_b++){var prop=_c[_b];getPropertyOfUnionOrIntersectionType(type,prop.name)}if(16384&type.flags)break}return type.resolvedProperties?symbolsToArray(type.resolvedProperties):emptyArray}function getPropertiesOfType(type){return type=getApparentType(type),49152&type.flags?getPropertiesOfUnionOrIntersectionType(type):getPropertiesOfObjectType(type)}function getApparentTypeOfTypeParameter(type){if(!type.resolvedApparentType){for(var constraintType=getConstraintOfTypeParameter(type);constraintType&&512&constraintType.flags;)constraintType=getConstraintOfTypeParameter(constraintType);type.resolvedApparentType=getTypeWithThisArgument(constraintType||emptyObjectType,type)}return type.resolvedApparentType}function getApparentType(type){return 512&type.flags&&(type=getApparentTypeOfTypeParameter(type)),258&type.flags?type=globalStringType:132&type.flags?type=globalNumberType:8&type.flags?type=globalBooleanType:16777216&type.flags&&(type=globalESSymbolType),type}function createUnionOrIntersectionProperty(containingType,name){for(var props,types=containingType.types,commonFlags=32768&containingType.flags?536870912:0,_i=0,types_2=types;_i<types_2.length;_i++){var current=types_2[_i],type=getApparentType(current);if(type!==unknownType){var prop=getPropertyOfType(type,name);if(!prop||48&getDeclarationFlagsFromSymbol(prop)){if(16384&containingType.flags)return}else commonFlags&=prop.flags,props?ts.contains(props,prop)||props.push(prop):props=[prop]}}if(props){if(1===props.length)return props[0];for(var propTypes=[],declarations=[],_a=0,props_1=props;_a<props_1.length;_a++){var prop=props_1[_a];prop.declarations&&ts.addRange(declarations,prop.declarations),propTypes.push(getTypeOfSymbol(prop))}var result=createSymbol(335544324|commonFlags,name);return result.containingType=containingType,result.declarations=declarations,result.type=16384&containingType.flags?getUnionType(propTypes):getIntersectionType(propTypes),result}}function getPropertyOfUnionOrIntersectionType(type,name){var properties=type.resolvedProperties||(type.resolvedProperties={});if(ts.hasProperty(properties,name))return properties[name];var property=createUnionOrIntersectionProperty(type,name);return property&&(properties[name]=property),property}function getPropertyOfType(type,name){if(type=getApparentType(type),80896&type.flags){var resolved=resolveStructuredTypeMembers(type);if(ts.hasProperty(resolved.members,name)){var symbol=resolved.members[name];if(symbolIsValue(symbol))return symbol}if(resolved===anyFunctionType||resolved.callSignatures.length||resolved.constructSignatures.length){var symbol=getPropertyOfObjectType(globalFunctionType,name);if(symbol)return symbol}return getPropertyOfObjectType(globalObjectType,name)}if(49152&type.flags)return getPropertyOfUnionOrIntersectionType(type,name)}function getSignaturesOfStructuredType(type,kind){if(130048&type.flags){var resolved=resolveStructuredTypeMembers(type);return 0===kind?resolved.callSignatures:resolved.constructSignatures}return emptyArray}function getSignaturesOfType(type,kind){return getSignaturesOfStructuredType(getApparentType(type),kind)}function getIndexTypeOfStructuredType(type,kind){if(130048&type.flags){var resolved=resolveStructuredTypeMembers(type);return 0===kind?resolved.stringIndexType:resolved.numberIndexType}}function getIndexTypeOfType(type,kind){return getIndexTypeOfStructuredType(getApparentType(type),kind)}function getTypeParametersFromJSDocTemplate(declaration){if(32&declaration.parserContextFlags){var templateTag=ts.getJSDocTemplateTag(declaration);if(templateTag)return getTypeParametersFromDeclaration(templateTag.typeParameters)}}function getTypeParametersFromDeclaration(typeParameterDeclarations){var result=[];return ts.forEach(typeParameterDeclarations,function(node){var tp=getDeclaredTypeOfTypeParameter(node.symbol);ts.contains(result,tp)||result.push(tp)}),result}function symbolsToArray(symbols){var result=[];for(var id in symbols)isReservedMemberName(id)||result.push(symbols[id]);return result}function isOptionalParameter(node){if(32&node.parserContextFlags){if(node.type&&263===node.type.kind)return!0;var paramTag=ts.getCorrespondingJSDocParameterTag(node);if(paramTag){if(paramTag.isBracketed)return!0;if(paramTag.typeExpression)return 263===paramTag.typeExpression.type.kind}}if(ts.hasQuestionToken(node))return!0;if(node.initializer){var signatureDeclaration=node.parent,signature=getSignatureFromDeclaration(signatureDeclaration),parameterIndex=ts.indexOf(signatureDeclaration.parameters,node);return ts.Debug.assert(parameterIndex>=0),parameterIndex>=signature.minArgumentCount}return!1}function createTypePredicateFromTypePredicateNode(node){if(69===node.parameterName.kind){var parameterName=node.parameterName;return{kind:1,parameterName:parameterName?parameterName.text:void 0,parameterIndex:parameterName?getTypePredicateParameterIndex(node.parent.parameters,parameterName):void 0,type:getTypeFromTypeNode(node.type)}}return{kind:0,type:getTypeFromTypeNode(node.type)}}function getSignatureFromDeclaration(declaration){var links=getNodeLinks(declaration);if(!links.resolvedSignature){for(var classType=145===declaration.kind?getDeclaredTypeOfClassOrInterface(getMergedSymbol(declaration.parent.symbol)):void 0,typeParameters=classType?classType.localTypeParameters:declaration.typeParameters?getTypeParametersFromDeclaration(declaration.typeParameters):getTypeParametersFromJSDocTemplate(declaration),parameters=[],hasStringLiterals=!1,minArgumentCount=-1,isJSConstructSignature=ts.isJSDocConstructSignature(declaration),returnType=void 0,typePredicate=void 0,i=isJSConstructSignature?1:0,n=declaration.parameters.length;i<n;i++){var param=declaration.parameters[i],paramSymbol=param.symbol;if(paramSymbol&&4&paramSymbol.flags&&!ts.isBindingPattern(param.name)){var resolvedSymbol=resolveName(param,paramSymbol.name,107455,void 0,void 0);paramSymbol=resolvedSymbol}parameters.push(paramSymbol),param.type&&163===param.type.kind&&(hasStringLiterals=!0),param.initializer||param.questionToken||param.dotDotDotToken?minArgumentCount<0&&(minArgumentCount=i):minArgumentCount=-1}if(minArgumentCount<0&&(minArgumentCount=declaration.parameters.length),isJSConstructSignature)minArgumentCount--,returnType=getTypeFromTypeNode(declaration.parameters[0].type);else if(classType)returnType=classType;else if(declaration.type)returnType=getTypeFromTypeNode(declaration.type),151===declaration.type.kind&&(typePredicate=createTypePredicateFromTypePredicateNode(declaration.type));else{if(32&declaration.parserContextFlags){var type=getReturnTypeFromJSDocComment(declaration);type&&type!==unknownType&&(returnType=type)}if(146===declaration.kind&&!ts.hasDynamicName(declaration)){var setter=ts.getDeclarationOfKind(declaration.symbol,147);returnType=getAnnotatedAccessorType(setter)}!returnType&&ts.nodeIsMissing(declaration.body)&&(returnType=anyType)}links.resolvedSignature=createSignature(declaration,typeParameters,parameters,returnType,typePredicate,minArgumentCount,ts.hasRestParameter(declaration),hasStringLiterals)}return links.resolvedSignature}function getSignaturesOfSymbol(symbol){if(!symbol)return emptyArray;for(var result=[],i=0,len=symbol.declarations.length;i<len;i++){var node=symbol.declarations[i];switch(node.kind){case 153:case 154:case 216:case 144:case 143:case 145:case 148:case 149:case 150:case 146:case 147:case 176:case 177:case 264:if(i>0&&node.body){var previous=symbol.declarations[i-1];if(node.parent===previous.parent&&node.kind===previous.kind&&node.pos===previous.end)break}result.push(getSignatureFromDeclaration(node))}}return result}function resolveExternalModuleTypeByLiteral(name){var moduleSym=resolveExternalModuleName(name,name);if(moduleSym){var resolvedModuleSymbol=resolveExternalModuleSymbol(moduleSym);if(resolvedModuleSymbol)return getTypeOfSymbol(resolvedModuleSymbol)}return anyType}function getReturnTypeOfSignature(signature){if(!signature.resolvedReturnType){if(!pushTypeResolution(signature,3))return unknownType;var type=void 0;if(type=signature.target?instantiateType(getReturnTypeOfSignature(signature.target),signature.mapper):signature.unionSignatures?getUnionType(ts.map(signature.unionSignatures,getReturnTypeOfSignature)):getReturnTypeFromBody(signature.declaration),!popTypeResolution()&&(type=anyType,compilerOptions.noImplicitAny)){var declaration=signature.declaration;declaration.name?error(declaration.name,ts.Diagnostics._0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions,ts.declarationNameToString(declaration.name)):error(declaration,ts.Diagnostics.Function_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions)}signature.resolvedReturnType=type}return signature.resolvedReturnType}function getRestTypeOfSignature(signature){if(signature.hasRestParameter){var type=getTypeOfSymbol(ts.lastOrUndefined(signature.parameters));if(4096&type.flags&&type.target===globalArrayType)return type.typeArguments[0]}return anyType}function getSignatureInstantiation(signature,typeArguments){return instantiateSignature(signature,createTypeMapper(signature.typeParameters,typeArguments),!0)}function getErasedSignature(signature){return signature.typeParameters?(signature.erasedSignatureCache||(signature.target?signature.erasedSignatureCache=instantiateSignature(getErasedSignature(signature.target),signature.mapper):signature.erasedSignatureCache=instantiateSignature(signature,createTypeEraser(signature.typeParameters),!0)),signature.erasedSignatureCache):signature}function getOrCreateTypeFromSignature(signature){if(!signature.isolatedSignatureType){var isConstructor=145===signature.declaration.kind||149===signature.declaration.kind,type=createObjectType(327680);type.members=emptySymbols,type.properties=emptyArray,type.callSignatures=isConstructor?emptyArray:[signature],type.constructSignatures=isConstructor?[signature]:emptyArray,signature.isolatedSignatureType=type}return signature.isolatedSignatureType}function getIndexSymbol(symbol){return symbol.members.__index}function getIndexDeclarationOfSymbol(symbol,kind){var syntaxKind=1===kind?128:130,indexSymbol=getIndexSymbol(symbol);if(indexSymbol)for(var _i=0,_a=indexSymbol.declarations;_i<_a.length;_i++){var decl=_a[_i],node=decl;if(1===node.parameters.length){var parameter=node.parameters[0];if(parameter&&parameter.type&&parameter.type.kind===syntaxKind)return node}}}function getIndexTypeOfSymbol(symbol,kind){var declaration=getIndexDeclarationOfSymbol(symbol,kind);return declaration?declaration.type?getTypeFromTypeNode(declaration.type):anyType:void 0}function getConstraintDeclaration(type){return ts.getDeclarationOfKind(type.symbol,138).constraint}function hasConstraintReferenceTo(type,target){for(var checked;type&&!(33554432&type.flags)&&512&type.flags&&!ts.contains(checked,type);){if(type===target)return!0;(checked||(checked=[])).push(type);var constraintDeclaration=getConstraintDeclaration(type);type=constraintDeclaration&&getTypeFromTypeNode(constraintDeclaration)}return!1}function getConstraintOfTypeParameter(typeParameter){if(!typeParameter.constraint)if(typeParameter.target){var targetConstraint=getConstraintOfTypeParameter(typeParameter.target);typeParameter.constraint=targetConstraint?instantiateType(targetConstraint,typeParameter.mapper):noConstraintType}else{var constraintDeclaration=getConstraintDeclaration(typeParameter),constraint=getTypeFromTypeNode(constraintDeclaration);hasConstraintReferenceTo(constraint,typeParameter)&&(error(constraintDeclaration,ts.Diagnostics.Type_parameter_0_has_a_circular_constraint,typeToString(typeParameter)),constraint=unknownType),typeParameter.constraint=constraint}return typeParameter.constraint===noConstraintType?void 0:typeParameter.constraint}function getParentSymbolOfTypeParameter(typeParameter){return getSymbolOfNode(ts.getDeclarationOfKind(typeParameter.symbol,138).parent)}function getTypeListId(types){if(types)switch(types.length){case 1:return""+types[0].id;case 2:return types[0].id+","+types[1].id;default:for(var result="",i=0;i<types.length;i++)i>0&&(result+=","),result+=types[i].id;return result}return""}function getPropagatingFlagsOfTypes(types){for(var result=0,_i=0,types_3=types;_i<types_3.length;_i++){
var type=types_3[_i];result|=type.flags}return 14680064&result}function createTypeReference(target,typeArguments){var id=getTypeListId(typeArguments),type=target.instantiations[id];if(!type){var flags=4096|(typeArguments?getPropagatingFlagsOfTypes(typeArguments):0);type=target.instantiations[id]=createObjectType(flags,target.symbol),type.target=target,type.typeArguments=typeArguments}return type}function getTypeFromClassOrInterfaceReference(node,symbol){var type=getDeclaredTypeOfSymbol(symbol),typeParameters=type.localTypeParameters;return typeParameters?node.typeArguments&&node.typeArguments.length===typeParameters.length?createTypeReference(type,ts.concatenate(type.outerTypeParameters,ts.map(node.typeArguments,getTypeFromTypeNode))):(error(node,ts.Diagnostics.Generic_type_0_requires_1_type_argument_s,typeToString(type,void 0,1),typeParameters.length),unknownType):node.typeArguments?(error(node,ts.Diagnostics.Type_0_is_not_generic,typeToString(type)),unknownType):type}function getTypeFromTypeAliasReference(node,symbol){var type=getDeclaredTypeOfSymbol(symbol),links=getSymbolLinks(symbol),typeParameters=links.typeParameters;if(typeParameters){if(!node.typeArguments||node.typeArguments.length!==typeParameters.length)return error(node,ts.Diagnostics.Generic_type_0_requires_1_type_argument_s,symbolToString(symbol),typeParameters.length),unknownType;var typeArguments=ts.map(node.typeArguments,getTypeFromTypeNode),id=getTypeListId(typeArguments);return links.instantiations[id]||(links.instantiations[id]=instantiateType(type,createTypeMapper(typeParameters,typeArguments)))}return node.typeArguments?(error(node,ts.Diagnostics.Type_0_is_not_generic,symbolToString(symbol)),unknownType):type}function getTypeFromNonGenericTypeReference(node,symbol){return node.typeArguments?(error(node,ts.Diagnostics.Type_0_is_not_generic,symbolToString(symbol)),unknownType):getDeclaredTypeOfSymbol(symbol)}function getTypeReferenceName(node){switch(node.kind){case 152:return node.typeName;case 262:return node.name;case 191:if(ts.isSupportedExpressionWithTypeArguments(node))return node.expression}}function resolveTypeReferenceName(node,typeReferenceName){return typeReferenceName?resolveEntityName(typeReferenceName,793056)||unknownSymbol:unknownSymbol}function getTypeReferenceType(node,symbol){return symbol===unknownSymbol?unknownType:96&symbol.flags?getTypeFromClassOrInterfaceReference(node,symbol):524288&symbol.flags?getTypeFromTypeAliasReference(node,symbol):107455&symbol.flags&&262===node.kind?getTypeOfSymbol(symbol):getTypeFromNonGenericTypeReference(node,symbol)}function getTypeFromTypeReference(node){var links=getNodeLinks(node);if(!links.resolvedType){var symbol=void 0,type=void 0;if(262===node.kind){var typeReferenceName=getTypeReferenceName(node);symbol=resolveTypeReferenceName(node,typeReferenceName),type=getTypeReferenceType(node,symbol),links.resolvedSymbol=symbol,links.resolvedType=type}else{var typeNameOrExpression=152===node.kind?node.typeName:ts.isSupportedExpressionWithTypeArguments(node)?node.expression:void 0;symbol=typeNameOrExpression&&resolveEntityName(typeNameOrExpression,793056)||unknownSymbol,type=symbol===unknownSymbol?unknownType:96&symbol.flags?getTypeFromClassOrInterfaceReference(node,symbol):524288&symbol.flags?getTypeFromTypeAliasReference(node,symbol):getTypeFromNonGenericTypeReference(node,symbol)}links.resolvedSymbol=symbol,links.resolvedType=type}return links.resolvedType}function getTypeFromTypeQueryNode(node){var links=getNodeLinks(node);return links.resolvedType||(links.resolvedType=getWidenedType(checkExpression(node.exprName))),links.resolvedType}function getTypeOfGlobalSymbol(symbol,arity){function getTypeDeclaration(symbol){for(var declarations=symbol.declarations,_i=0,declarations_3=declarations;_i<declarations_3.length;_i++){var declaration=declarations_3[_i];switch(declaration.kind){case 217:case 218:case 220:return declaration}}}if(!symbol)return arity?emptyGenericType:emptyObjectType;var type=getDeclaredTypeOfSymbol(symbol);return 80896&type.flags?(type.typeParameters?type.typeParameters.length:0)!==arity?(error(getTypeDeclaration(symbol),ts.Diagnostics.Global_type_0_must_have_1_type_parameter_s,symbol.name,arity),arity?emptyGenericType:emptyObjectType):type:(error(getTypeDeclaration(symbol),ts.Diagnostics.Global_type_0_must_be_a_class_or_interface_type,symbol.name),arity?emptyGenericType:emptyObjectType)}function getGlobalValueSymbol(name){return getGlobalSymbol(name,107455,ts.Diagnostics.Cannot_find_global_value_0)}function getGlobalTypeSymbol(name){return getGlobalSymbol(name,793056,ts.Diagnostics.Cannot_find_global_type_0)}function getGlobalSymbol(name,meaning,diagnostic){return resolveName(void 0,name,meaning,diagnostic,name)}function getGlobalType(name,arity){return void 0===arity&&(arity=0),getTypeOfGlobalSymbol(getGlobalTypeSymbol(name),arity)}function getExportedTypeFromNamespace(namespace,name){var namespaceSymbol=getGlobalSymbol(namespace,1536,void 0),typeSymbol=namespaceSymbol&&getSymbol(namespaceSymbol.exports,name,793056);return typeSymbol&&getDeclaredTypeOfSymbol(typeSymbol)}function getGlobalESSymbolConstructorSymbol(){return globalESSymbolConstructorSymbol||(globalESSymbolConstructorSymbol=getGlobalValueSymbol("Symbol"))}function createTypedPropertyDescriptorType(propertyType){var globalTypedPropertyDescriptorType=getGlobalTypedPropertyDescriptorType();return globalTypedPropertyDescriptorType!==emptyGenericType?createTypeReference(globalTypedPropertyDescriptorType,[propertyType]):emptyObjectType}function createTypeFromGenericGlobalType(genericGlobalType,typeArguments){return genericGlobalType!==emptyGenericType?createTypeReference(genericGlobalType,typeArguments):emptyObjectType}function createIterableType(elementType){return createTypeFromGenericGlobalType(globalIterableType,[elementType])}function createIterableIteratorType(elementType){return createTypeFromGenericGlobalType(globalIterableIteratorType,[elementType])}function createArrayType(elementType){return createTypeFromGenericGlobalType(globalArrayType,[elementType])}function getTypeFromArrayTypeNode(node){var links=getNodeLinks(node);return links.resolvedType||(links.resolvedType=createArrayType(getTypeFromTypeNode(node.elementType))),links.resolvedType}function createTupleType(elementTypes){var id=getTypeListId(elementTypes);return tupleTypes[id]||(tupleTypes[id]=createNewTupleType(elementTypes))}function createNewTupleType(elementTypes){var type=createObjectType(8192|getPropagatingFlagsOfTypes(elementTypes));return type.elementTypes=elementTypes,type}function getTypeFromTupleTypeNode(node){var links=getNodeLinks(node);return links.resolvedType||(links.resolvedType=createTupleType(ts.map(node.elementTypes,getTypeFromTypeNode))),links.resolvedType}function addTypeToSet(typeSet,type,typeSetKind){type.flags&typeSetKind?addTypesToSet(typeSet,type.types,typeSetKind):ts.contains(typeSet,type)||typeSet.push(type)}function addTypesToSet(typeSet,types,typeSetKind){for(var _i=0,types_4=types;_i<types_4.length;_i++){var type=types_4[_i];addTypeToSet(typeSet,type,typeSetKind)}}function isSubtypeOfAny(candidate,types){for(var i=0,len=types.length;i<len;i++)if(candidate!==types[i]&&isTypeSubtypeOf(candidate,types[i]))return!0;return!1}function removeSubtypes(types){for(var i=types.length;i>0;)i--,isSubtypeOfAny(types[i],types)&&types.splice(i,1)}function containsTypeAny(types){for(var _i=0,types_5=types;_i<types_5.length;_i++){var type=types_5[_i];if(isTypeAny(type))return!0}return!1}function removeAllButLast(types,typeToRemove){for(var i=types.length;i>0&&types.length>1;)i--,types[i]===typeToRemove&&types.splice(i,1)}function getUnionType(types,noSubtypeReduction){if(0===types.length)return emptyUnionType;var typeSet=[];if(addTypesToSet(typeSet,types,16384),containsTypeAny(typeSet))return anyType;if(noSubtypeReduction?(removeAllButLast(typeSet,undefinedType),removeAllButLast(typeSet,nullType)):removeSubtypes(typeSet),1===typeSet.length)return typeSet[0];var id=getTypeListId(typeSet),type=unionTypes[id];return type||(type=unionTypes[id]=createObjectType(16384|getPropagatingFlagsOfTypes(typeSet)),type.types=typeSet),type}function getTypeFromUnionTypeNode(node){var links=getNodeLinks(node);return links.resolvedType||(links.resolvedType=getUnionType(ts.map(node.types,getTypeFromTypeNode),!0)),links.resolvedType}function getIntersectionType(types){if(0===types.length)return emptyObjectType;var typeSet=[];if(addTypesToSet(typeSet,types,32768),containsTypeAny(typeSet))return anyType;if(1===typeSet.length)return typeSet[0];var id=getTypeListId(typeSet),type=intersectionTypes[id];return type||(type=intersectionTypes[id]=createObjectType(32768|getPropagatingFlagsOfTypes(typeSet)),type.types=typeSet),type}function getTypeFromIntersectionTypeNode(node){var links=getNodeLinks(node);return links.resolvedType||(links.resolvedType=getIntersectionType(ts.map(node.types,getTypeFromTypeNode))),links.resolvedType}function getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode(node){var links=getNodeLinks(node);return links.resolvedType||(links.resolvedType=createObjectType(65536,node.symbol)),links.resolvedType}function getStringLiteralTypeForText(text){if(ts.hasProperty(stringLiteralTypes,text))return stringLiteralTypes[text];var type=stringLiteralTypes[text]=createType(256);return type.text=text,type}function getTypeFromStringLiteralTypeNode(node){var links=getNodeLinks(node);return links.resolvedType||(links.resolvedType=getStringLiteralTypeForText(node.text)),links.resolvedType}function getTypeFromJSDocVariadicType(node){var links=getNodeLinks(node);if(!links.resolvedType){var type=getTypeFromTypeNode(node.type);links.resolvedType=type?createArrayType(type):unknownType}return links.resolvedType}function getTypeFromJSDocTupleType(node){var links=getNodeLinks(node);if(!links.resolvedType){var types=ts.map(node.types,getTypeFromTypeNode);links.resolvedType=createTupleType(types)}return links.resolvedType}function getThisType(node){var container=ts.getThisContainer(node,!1),parent=container&&container.parent;return!parent||!ts.isClassLike(parent)&&218!==parent.kind||64&container.flags||145===container.kind&&!ts.isNodeDescendentOf(node,container.body)?(error(node,ts.Diagnostics.A_this_type_is_available_only_in_a_non_static_member_of_a_class_or_interface),unknownType):getDeclaredTypeOfClassOrInterface(getSymbolOfNode(parent)).thisType}function getTypeFromThisTypeNode(node){var links=getNodeLinks(node);return links.resolvedType||(links.resolvedType=getThisType(node)),links.resolvedType}function getTypeFromTypeNode(node){switch(node.kind){case 117:case 253:case 254:return anyType;case 130:return stringType;case 128:return numberType;case 120:return booleanType;case 131:return esSymbolType;case 103:return voidType;case 162:return getTypeFromThisTypeNode(node);case 163:return getTypeFromStringLiteralTypeNode(node);case 152:case 262:return getTypeFromTypeReference(node);case 151:return booleanType;case 191:return getTypeFromTypeReference(node);case 155:return getTypeFromTypeQueryNode(node);case 157:case 255:return getTypeFromArrayTypeNode(node);case 158:return getTypeFromTupleTypeNode(node);case 159:case 256:return getTypeFromUnionTypeNode(node);case 160:return getTypeFromIntersectionTypeNode(node);case 161:case 258:case 259:case 266:case 267:case 263:return getTypeFromTypeNode(node.type);case 153:case 154:case 156:case 264:case 260:return getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode(node);case 69:case 136:var symbol=getSymbolAtLocation(node);return symbol&&getDeclaredTypeOfSymbol(symbol);case 257:return getTypeFromJSDocTupleType(node);case 265:return getTypeFromJSDocVariadicType(node);default:return unknownType}}function instantiateList(items,mapper,instantiator){if(items&&items.length){for(var result=[],_i=0,items_1=items;_i<items_1.length;_i++){var v=items_1[_i];result.push(instantiator(v,mapper))}return result}return items}function createUnaryTypeMapper(source,target){return function(t){return t===source?target:t}}function createBinaryTypeMapper(source1,target1,source2,target2){return function(t){return t===source1?target1:t===source2?target2:t}}function createTypeMapper(sources,targets){switch(sources.length){case 1:return createUnaryTypeMapper(sources[0],targets[0]);case 2:return createBinaryTypeMapper(sources[0],targets[0],sources[1],targets[1])}return function(t){for(var i=0;i<sources.length;i++)if(t===sources[i])return targets[i];return t}}function createUnaryTypeEraser(source){return function(t){return t===source?anyType:t}}function createBinaryTypeEraser(source1,source2){return function(t){return t===source1||t===source2?anyType:t}}function createTypeEraser(sources){switch(sources.length){case 1:return createUnaryTypeEraser(sources[0]);case 2:return createBinaryTypeEraser(sources[0],sources[1])}return function(t){for(var _i=0,sources_1=sources;_i<sources_1.length;_i++){var source=sources_1[_i];if(t===source)return anyType}return t}}function getInferenceMapper(context){if(!context.mapper){var mapper=function(t){for(var typeParameters=context.typeParameters,i=0;i<typeParameters.length;i++)if(t===typeParameters[i])return context.inferences[i].isFixed=!0,getInferredType(context,i);return t};mapper.context=context,context.mapper=mapper}return context.mapper}function identityMapper(type){return type}function combineTypeMappers(mapper1,mapper2){return function(t){return instantiateType(mapper1(t),mapper2)}}function cloneTypeParameter(typeParameter){var result=createType(512);return result.symbol=typeParameter.symbol,result.target=typeParameter,result}function cloneTypePredicate(predicate,mapper){return ts.isIdentifierTypePredicate(predicate)?{kind:1,parameterName:predicate.parameterName,parameterIndex:predicate.parameterIndex,type:instantiateType(predicate.type,mapper)}:{kind:0,type:instantiateType(predicate.type,mapper)}}function instantiateSignature(signature,mapper,eraseTypeParameters){var freshTypeParameters,freshTypePredicate;if(signature.typeParameters&&!eraseTypeParameters){freshTypeParameters=ts.map(signature.typeParameters,cloneTypeParameter),mapper=combineTypeMappers(createTypeMapper(signature.typeParameters,freshTypeParameters),mapper);for(var _i=0,freshTypeParameters_1=freshTypeParameters;_i<freshTypeParameters_1.length;_i++){var tp=freshTypeParameters_1[_i];tp.mapper=mapper}}signature.typePredicate&&(freshTypePredicate=cloneTypePredicate(signature.typePredicate,mapper));var result=createSignature(signature.declaration,freshTypeParameters,instantiateList(signature.parameters,mapper,instantiateSymbol),instantiateType(signature.resolvedReturnType,mapper),freshTypePredicate,signature.minArgumentCount,signature.hasRestParameter,signature.hasStringLiterals);return result.target=signature,result.mapper=mapper,result}function instantiateSymbol(symbol,mapper){if(16777216&symbol.flags){var links=getSymbolLinks(symbol);symbol=links.target,mapper=combineTypeMappers(links.mapper,mapper)}var result=createSymbol(83886080|symbol.flags,symbol.name);return result.declarations=symbol.declarations,result.parent=symbol.parent,result.target=symbol,result.mapper=mapper,symbol.valueDeclaration&&(result.valueDeclaration=symbol.valueDeclaration),result}function instantiateAnonymousType(type,mapper){if(mapper.instantiations){var cachedType=mapper.instantiations[type.id];if(cachedType)return cachedType}else mapper.instantiations=[];var result=createObjectType(196608,type.symbol);return result.target=type,result.mapper=mapper,mapper.instantiations[type.id]=result,result}function instantiateType(type,mapper){if(type&&mapper!==identityMapper){if(512&type.flags)return mapper(type);if(65536&type.flags)return type.symbol&&14384&type.symbol.flags?instantiateAnonymousType(type,mapper):type;if(4096&type.flags)return createTypeReference(type.target,instantiateList(type.typeArguments,mapper,instantiateType));if(8192&type.flags)return createTupleType(instantiateList(type.elementTypes,mapper,instantiateType));if(16384&type.flags)return getUnionType(instantiateList(type.types,mapper,instantiateType),!0);if(32768&type.flags)return getIntersectionType(instantiateList(type.types,mapper,instantiateType))}return type}function isContextSensitive(node){switch(ts.Debug.assert(144!==node.kind||ts.isObjectLiteralMethod(node)),node.kind){case 176:case 177:return isContextSensitiveFunctionLikeDeclaration(node);case 168:return ts.forEach(node.properties,isContextSensitive);case 167:return ts.forEach(node.elements,isContextSensitive);case 185:return isContextSensitive(node.whenTrue)||isContextSensitive(node.whenFalse);case 184:return 52===node.operatorToken.kind&&(isContextSensitive(node.left)||isContextSensitive(node.right));case 248:return isContextSensitive(node.initializer);case 144:case 143:return isContextSensitiveFunctionLikeDeclaration(node);case 175:return isContextSensitive(node.expression)}return!1}function isContextSensitiveFunctionLikeDeclaration(node){return!node.typeParameters&&node.parameters.length&&!ts.forEach(node.parameters,function(p){return p.type})}function getTypeWithoutSignatures(type){if(80896&type.flags){var resolved=resolveStructuredTypeMembers(type);if(resolved.constructSignatures.length){var result=createObjectType(65536,type.symbol);result.members=resolved.members,result.properties=resolved.properties,result.callSignatures=emptyArray,result.constructSignatures=emptyArray,type=result}}return type}function isTypeIdenticalTo(source,target){return checkTypeRelatedTo(source,target,identityRelation,void 0)}function compareTypesIdentical(source,target){return checkTypeRelatedTo(source,target,identityRelation,void 0)?-1:0}function compareTypesAssignable(source,target){return checkTypeRelatedTo(source,target,assignableRelation,void 0)?-1:0}function isTypeSubtypeOf(source,target){return checkTypeSubtypeOf(source,target,void 0)}function isTypeAssignableTo(source,target){return checkTypeAssignableTo(source,target,void 0)}function checkTypeSubtypeOf(source,target,errorNode,headMessage,containingMessageChain){return checkTypeRelatedTo(source,target,subtypeRelation,errorNode,headMessage,containingMessageChain)}function checkTypeAssignableTo(source,target,errorNode,headMessage,containingMessageChain){return checkTypeRelatedTo(source,target,assignableRelation,errorNode,headMessage,containingMessageChain)}function isSignatureAssignableTo(source,target,ignoreReturnTypes){return 0!==compareSignaturesRelated(source,target,ignoreReturnTypes,!1,void 0,compareTypesAssignable)}function compareSignaturesRelated(source,target,ignoreReturnTypes,reportErrors,errorReporter,compareTypes){if(source===target)return-1;if(!target.hasRestParameter&&source.minArgumentCount>target.parameters.length)return 0;source=getErasedSignature(source),target=getErasedSignature(target);for(var result=-1,sourceMax=getNumNonRestParameters(source),targetMax=getNumNonRestParameters(target),checkCount=getNumParametersToCheckForSignatureRelatability(source,sourceMax,target,targetMax),sourceParams=source.parameters,targetParams=target.parameters,i=0;i<checkCount;i++){var s=i<sourceMax?getTypeOfSymbol(sourceParams[i]):getRestTypeOfSignature(source),t=i<targetMax?getTypeOfSymbol(targetParams[i]):getRestTypeOfSignature(target),related=compareTypes(t,s,!1)||compareTypes(s,t,reportErrors);if(!related)return reportErrors&&errorReporter(ts.Diagnostics.Types_of_parameters_0_and_1_are_incompatible,sourceParams[i<sourceMax?i:sourceMax].name,targetParams[i<targetMax?i:targetMax].name),0;result&=related}if(!ignoreReturnTypes){var targetReturnType=getReturnTypeOfSignature(target);if(targetReturnType===voidType)return result;var sourceReturnType=getReturnTypeOfSignature(source);if(target.typePredicate){if(source.typePredicate)result&=compareTypePredicateRelatedTo(source.typePredicate,target.typePredicate,reportErrors,errorReporter,compareTypes);else if(ts.isIdentifierTypePredicate(target.typePredicate))return reportErrors&&errorReporter(ts.Diagnostics.Signature_0_must_have_a_type_predicate,signatureToString(source)),0}else result&=compareTypes(sourceReturnType,targetReturnType,reportErrors)}return result}function compareTypePredicateRelatedTo(source,target,reportErrors,errorReporter,compareTypes){if(source.kind!==target.kind)return reportErrors&&(errorReporter(ts.Diagnostics.A_this_based_type_guard_is_not_compatible_with_a_parameter_based_type_guard),errorReporter(ts.Diagnostics.Type_predicate_0_is_not_assignable_to_1,typePredicateToString(source),typePredicateToString(target))),0;if(1===source.kind){var sourceIdentifierPredicate=source,targetIdentifierPredicate=target;if(sourceIdentifierPredicate.parameterIndex!==targetIdentifierPredicate.parameterIndex)return reportErrors&&(errorReporter(ts.Diagnostics.Parameter_0_is_not_in_the_same_position_as_parameter_1,sourceIdentifierPredicate.parameterName,targetIdentifierPredicate.parameterName),errorReporter(ts.Diagnostics.Type_predicate_0_is_not_assignable_to_1,typePredicateToString(source),typePredicateToString(target))),0}var related=compareTypes(source.type,target.type,reportErrors);return 0===related&&reportErrors&&errorReporter(ts.Diagnostics.Type_predicate_0_is_not_assignable_to_1,typePredicateToString(source),typePredicateToString(target)),related}function isImplementationCompatibleWithOverload(implementation,overload){var erasedSource=getErasedSignature(implementation),erasedTarget=getErasedSignature(overload),sourceReturnType=getReturnTypeOfSignature(erasedSource),targetReturnType=getReturnTypeOfSignature(erasedTarget);return!(targetReturnType!==voidType&&!checkTypeRelatedTo(targetReturnType,sourceReturnType,assignableRelation,void 0)&&!checkTypeRelatedTo(sourceReturnType,targetReturnType,assignableRelation,void 0))&&isSignatureAssignableTo(erasedSource,erasedTarget,!0)}function getNumNonRestParameters(signature){var numParams=signature.parameters.length;return signature.hasRestParameter?numParams-1:numParams}function getNumParametersToCheckForSignatureRelatability(source,sourceNonRestParamCount,target,targetNonRestParamCount){return source.hasRestParameter===target.hasRestParameter?source.hasRestParameter?Math.max(sourceNonRestParamCount,targetNonRestParamCount)+1:Math.min(sourceNonRestParamCount,targetNonRestParamCount):source.hasRestParameter?targetNonRestParamCount:sourceNonRestParamCount}function checkTypeRelatedTo(source,target,relation,errorNode,headMessage,containingMessageChain){function reportError(message,arg0,arg1,arg2){ts.Debug.assert(!!errorNode),errorInfo=ts.chainDiagnosticMessages(errorInfo,message,arg0,arg1,arg2)}function reportRelationError(message,source,target){var sourceType=typeToString(source),targetType=typeToString(target);sourceType===targetType&&(sourceType=typeToString(source,void 0,128),targetType=typeToString(target,void 0,128)),reportError(message||ts.Diagnostics.Type_0_is_not_assignable_to_type_1,sourceType,targetType)}function isRelatedTo(source,target,reportErrors,headMessage){var result;if(source===target)return-1;if(relation===identityRelation)return isIdenticalTo(source,target);if(isTypeAny(target))return-1;if(source===undefinedType)return-1;if(source===nullType&&target!==undefinedType)return-1;if(128&source.flags&&target===numberType)return-1;if(128&source.flags&&128&target.flags&&(result=enumRelatedTo(source,target)))return result;if(256&source.flags&&target===stringType)return-1;if(relation===assignableRelation){if(isTypeAny(source))return-1;if(source===numberType&&128&target.flags)return-1}if(8&source.flags&&8&target.flags)return-1;if(1048576&source.flags){if(hasExcessProperties(source,target,reportErrors))return reportErrors&&reportRelationError(headMessage,source,target),0;49152&target.flags&&(source=getRegularTypeOfObjectLiteral(source))}var saveErrorInfo=errorInfo;if(16384&source.flags){if(result=eachTypeRelatedToType(source,target,reportErrors))return result}else if(32768&target.flags){if(result=typeRelatedToEachType(source,target,reportErrors))return result}else{if(32768&source.flags&&(result=someTypeRelatedToType(source,target,reportErrors&&!(16384&target.flags))))return result;if(16384&target.flags&&(result=typeRelatedToSomeType(source,target,reportErrors)))return result}if(512&source.flags){var constraint=getConstraintOfTypeParameter(source);(!constraint||1&constraint.flags)&&(constraint=emptyObjectType);var reportConstraintErrors=reportErrors&&constraint!==emptyObjectType;if(result=isRelatedTo(constraint,target,reportConstraintErrors))return errorInfo=saveErrorInfo,result}else{if(4096&source.flags&&4096&target.flags&&source.target===target.target&&(result=typeArgumentsRelatedTo(source,target,reportErrors)))return result;var apparentSource=getApparentType(source);if(113664&apparentSource.flags&&80896&target.flags){var reportStructuralErrors=reportErrors&&errorInfo===saveErrorInfo&&!(16777726&source.flags);if(result=objectTypeRelatedTo(apparentSource,source,target,reportStructuralErrors))return errorInfo=saveErrorInfo,result}}return reportErrors&&reportRelationError(headMessage,source,target),0}function isIdenticalTo(source,target){var result;return 80896&source.flags&&80896&target.flags?4096&source.flags&&4096&target.flags&&source.target===target.target&&(result=typeArgumentsRelatedTo(source,target,!1))?result:objectTypeRelatedTo(source,source,target,!1):(16384&source.flags&&16384&target.flags||32768&source.flags&&32768&target.flags)&&(result=eachTypeRelatedToSomeType(source,target))&&(result&=eachTypeRelatedToSomeType(target,source))?result:0}function isKnownProperty(type,name){if(80896&type.flags){var resolved=resolveStructuredTypeMembers(type);if(relation===assignableRelation&&(type===globalObjectType||0===resolved.properties.length)||resolved.stringIndexType||resolved.numberIndexType||getPropertyOfType(type,name))return!0}else if(49152&type.flags)for(var _i=0,_a=type.types;_i<_a.length;_i++){var t=_a[_i];if(isKnownProperty(t,name))return!0}return!1}function hasExcessProperties(source,target,reportErrors){if(!(67108864&target.flags)&&someConstituentTypeHasKind(target,80896))for(var _i=0,_a=getPropertiesOfObjectType(source);_i<_a.length;_i++){var prop=_a[_i];if(!isKnownProperty(target,prop.name))return reportErrors&&(ts.Debug.assert(!!errorNode),errorNode=prop.valueDeclaration,reportError(ts.Diagnostics.Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1,symbolToString(prop),typeToString(target))),!0}return!1}function eachTypeRelatedToSomeType(source,target){for(var result=-1,sourceTypes=source.types,_i=0,sourceTypes_1=sourceTypes;_i<sourceTypes_1.length;_i++){var sourceType=sourceTypes_1[_i],related=typeRelatedToSomeType(sourceType,target,!1);if(!related)return 0;result&=related}return result}function typeRelatedToSomeType(source,target,reportErrors){for(var targetTypes=target.types,i=0,len=targetTypes.length;i<len;i++){var related=isRelatedTo(source,targetTypes[i],reportErrors&&i===len-1);if(related)return related}return 0}function typeRelatedToEachType(source,target,reportErrors){for(var result=-1,targetTypes=target.types,_i=0,targetTypes_1=targetTypes;_i<targetTypes_1.length;_i++){var targetType=targetTypes_1[_i],related=isRelatedTo(source,targetType,reportErrors);if(!related)return 0;result&=related}return result}function someTypeRelatedToType(source,target,reportErrors){for(var sourceTypes=source.types,i=0,len=sourceTypes.length;i<len;i++){var related=isRelatedTo(sourceTypes[i],target,reportErrors&&i===len-1);if(related)return related}return 0}function eachTypeRelatedToType(source,target,reportErrors){for(var result=-1,sourceTypes=source.types,_i=0,sourceTypes_2=sourceTypes;_i<sourceTypes_2.length;_i++){var sourceType=sourceTypes_2[_i],related=isRelatedTo(sourceType,target,reportErrors);if(!related)return 0;result&=related}return result}function typeArgumentsRelatedTo(source,target,reportErrors){var sources=source.typeArguments||emptyArray,targets=target.typeArguments||emptyArray;if(sources.length!==targets.length&&relation===identityRelation)return 0;for(var length=sources.length<=targets.length?sources.length:targets.length,result=-1,i=0;i<length;i++){var related=isRelatedTo(sources[i],targets[i],reportErrors);if(!related)return 0;result&=related}return result}function objectTypeRelatedTo(source,originalSource,target,reportErrors){if(overflow)return 0;var id=relation!==identityRelation||source.id<target.id?source.id+","+target.id:target.id+","+source.id,related=relation[id];if(void 0!==related){if(!reportErrors||2!==related)return 1===related?-1:0;relation[id]=3}if(depth>0){for(var i=0;i<depth;i++)if(maybeStack[i][id])return 1;if(100===depth)return overflow=!0,0}else sourceStack=[],targetStack=[],maybeStack=[],expandingFlags=0;sourceStack[depth]=source,targetStack[depth]=target,maybeStack[depth]={},maybeStack[depth][id]=1,depth++;var saveExpandingFlags=expandingFlags;1&expandingFlags||!isDeeplyNestedGeneric(source,sourceStack,depth)||(expandingFlags|=1),2&expandingFlags||!isDeeplyNestedGeneric(target,targetStack,depth)||(expandingFlags|=2);var result;if(3===expandingFlags?result=1:(result=propertiesRelatedTo(source,target,reportErrors),result&&(result&=signaturesRelatedTo(source,target,0,reportErrors),result&&(result&=signaturesRelatedTo(source,target,1,reportErrors),result&&(result&=stringIndexTypesRelatedTo(source,originalSource,target,reportErrors),result&&(result&=numberIndexTypesRelatedTo(source,originalSource,target,reportErrors)))))),expandingFlags=saveExpandingFlags,depth--,result){var maybeCache=maybeStack[depth],destinationCache=result===-1||0===depth?relation:maybeStack[depth-1];ts.copyMap(maybeCache,destinationCache)}else relation[id]=reportErrors?3:2;return result}function propertiesRelatedTo(source,target,reportErrors){if(relation===identityRelation)return propertiesIdenticalTo(source,target);for(var result=-1,properties=getPropertiesOfObjectType(target),requireOptionalProperties=relation===subtypeRelation&&!(524288&source.flags),_i=0,properties_1=properties;_i<properties_1.length;_i++){var targetProp=properties_1[_i],sourceProp=getPropertyOfType(source,targetProp.name);if(sourceProp!==targetProp)if(sourceProp){if(!(134217728&targetProp.flags)){var sourcePropFlags=getDeclarationFlagsFromSymbol(sourceProp),targetPropFlags=getDeclarationFlagsFromSymbol(targetProp);if(16&sourcePropFlags||16&targetPropFlags){if(sourceProp.valueDeclaration!==targetProp.valueDeclaration)return reportErrors&&(16&sourcePropFlags&&16&targetPropFlags?reportError(ts.Diagnostics.Types_have_separate_declarations_of_a_private_property_0,symbolToString(targetProp)):reportError(ts.Diagnostics.Property_0_is_private_in_type_1_but_not_in_type_2,symbolToString(targetProp),typeToString(16&sourcePropFlags?source:target),typeToString(16&sourcePropFlags?target:source))),0}else if(32&targetPropFlags){var sourceDeclaredInClass=sourceProp.parent&&32&sourceProp.parent.flags,sourceClass=sourceDeclaredInClass?getDeclaredTypeOfSymbol(getParentOfSymbol(sourceProp)):void 0,targetClass=getDeclaredTypeOfSymbol(getParentOfSymbol(targetProp));if(!sourceClass||!hasBaseType(sourceClass,targetClass))return reportErrors&&reportError(ts.Diagnostics.Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2,symbolToString(targetProp),typeToString(sourceClass||source),typeToString(targetClass)),0}else if(32&sourcePropFlags)return reportErrors&&reportError(ts.Diagnostics.Property_0_is_protected_in_type_1_but_public_in_type_2,symbolToString(targetProp),typeToString(source),typeToString(target)),0;var related=isRelatedTo(getTypeOfSymbol(sourceProp),getTypeOfSymbol(targetProp),reportErrors);if(!related)return reportErrors&&reportError(ts.Diagnostics.Types_of_property_0_are_incompatible,symbolToString(targetProp)),0;if(result&=related,536870912&sourceProp.flags&&!(536870912&targetProp.flags))return reportErrors&&reportError(ts.Diagnostics.Property_0_is_optional_in_type_1_but_required_in_type_2,symbolToString(targetProp),typeToString(source),typeToString(target)),0}}else if(!(536870912&targetProp.flags)||requireOptionalProperties)return reportErrors&&reportError(ts.Diagnostics.Property_0_is_missing_in_type_1,symbolToString(targetProp),typeToString(source)),
0}return result}function propertiesIdenticalTo(source,target){if(!(80896&source.flags&&80896&target.flags))return 0;var sourceProperties=getPropertiesOfObjectType(source),targetProperties=getPropertiesOfObjectType(target);if(sourceProperties.length!==targetProperties.length)return 0;for(var result=-1,_i=0,sourceProperties_1=sourceProperties;_i<sourceProperties_1.length;_i++){var sourceProp=sourceProperties_1[_i],targetProp=getPropertyOfObjectType(target,sourceProp.name);if(!targetProp)return 0;var related=compareProperties(sourceProp,targetProp,isRelatedTo);if(!related)return 0;result&=related}return result}function signaturesRelatedTo(source,target,kind,reportErrors){if(relation===identityRelation)return signaturesIdenticalTo(source,target,kind);if(target===anyFunctionType||source===anyFunctionType)return-1;var sourceSignatures=getSignaturesOfType(source,kind),targetSignatures=getSignaturesOfType(target,kind);if(1===kind&&sourceSignatures.length&&targetSignatures.length&&isAbstractConstructorType(source)&&!isAbstractConstructorType(target))return reportErrors&&reportError(ts.Diagnostics.Cannot_assign_an_abstract_constructor_type_to_a_non_abstract_constructor_type),0;var result=-1,saveErrorInfo=errorInfo;outer:for(var _i=0,targetSignatures_1=targetSignatures;_i<targetSignatures_1.length;_i++){var t=targetSignatures_1[_i];if(!t.hasStringLiterals||262144&target.flags){for(var shouldElaborateErrors=reportErrors,_a=0,sourceSignatures_1=sourceSignatures;_a<sourceSignatures_1.length;_a++){var s=sourceSignatures_1[_a];if(!s.hasStringLiterals||262144&source.flags){var related=signatureRelatedTo(s,t,shouldElaborateErrors);if(related){result&=related,errorInfo=saveErrorInfo;continue outer}shouldElaborateErrors=!1}}return shouldElaborateErrors&&reportError(ts.Diagnostics.Type_0_provides_no_match_for_the_signature_1,typeToString(source),signatureToString(t,void 0,void 0,kind)),0}}return result}function signatureRelatedTo(source,target,reportErrors){return compareSignaturesRelated(source,target,!1,reportErrors,reportError,isRelatedTo)}function signaturesIdenticalTo(source,target,kind){var sourceSignatures=getSignaturesOfType(source,kind),targetSignatures=getSignaturesOfType(target,kind);if(sourceSignatures.length!==targetSignatures.length)return 0;for(var result=-1,i=0,len=sourceSignatures.length;i<len;i++){var related=compareSignaturesIdentical(sourceSignatures[i],targetSignatures[i],!1,!1,isRelatedTo);if(!related)return 0;result&=related}return result}function stringIndexTypesRelatedTo(source,originalSource,target,reportErrors){if(relation===identityRelation)return indexTypesIdenticalTo(0,source,target);var targetType=getIndexTypeOfType(target,0);if(targetType){if(1&targetType.flags&&!(16777726&originalSource.flags))return-1;var sourceType=getIndexTypeOfType(source,0);if(!sourceType)return reportErrors&&reportError(ts.Diagnostics.Index_signature_is_missing_in_type_0,typeToString(source)),0;var related=isRelatedTo(sourceType,targetType,reportErrors);return related?related:(reportErrors&&reportError(ts.Diagnostics.Index_signatures_are_incompatible),0)}return-1}function numberIndexTypesRelatedTo(source,originalSource,target,reportErrors){if(relation===identityRelation)return indexTypesIdenticalTo(1,source,target);var targetType=getIndexTypeOfType(target,1);if(targetType){if(1&targetType.flags&&!(16777726&originalSource.flags))return-1;var sourceStringType=getIndexTypeOfType(source,0),sourceNumberType=getIndexTypeOfType(source,1);if(!sourceStringType&&!sourceNumberType)return reportErrors&&reportError(ts.Diagnostics.Index_signature_is_missing_in_type_0,typeToString(source)),0;var related=void 0;return related=sourceStringType&&sourceNumberType?isRelatedTo(sourceStringType,targetType,!1)||isRelatedTo(sourceNumberType,targetType,reportErrors):isRelatedTo(sourceStringType||sourceNumberType,targetType,reportErrors),related?related:(reportErrors&&reportError(ts.Diagnostics.Index_signatures_are_incompatible),0)}return-1}function indexTypesIdenticalTo(indexKind,source,target){var targetType=getIndexTypeOfType(target,indexKind),sourceType=getIndexTypeOfType(source,indexKind);return sourceType||targetType?sourceType&&targetType?isRelatedTo(sourceType,targetType):0:-1}function enumRelatedTo(source,target){if(source.symbol.name!==target.symbol.name||128&source.symbol.flags||128&target.symbol.flags)return 0;for(var targetEnumType=getTypeOfSymbol(target.symbol),_i=0,_a=getPropertiesOfType(getTypeOfSymbol(source.symbol));_i<_a.length;_i++){var property=_a[_i];if(8&property.flags){var targetProperty=getPropertyOfType(targetEnumType,property.name);if(!(targetProperty&&8&targetProperty.flags))return reportError(ts.Diagnostics.Property_0_is_missing_in_type_1,property.name,typeToString(target,void 0,128)),0}}return-1}var errorInfo,sourceStack,targetStack,maybeStack,expandingFlags,depth=0,overflow=!1;ts.Debug.assert(relation!==identityRelation||!errorNode,"no error reporting in identity checking");var result=isRelatedTo(source,target,!!errorNode,headMessage);return overflow?error(errorNode,ts.Diagnostics.Excessive_stack_depth_comparing_types_0_and_1,typeToString(source),typeToString(target)):errorInfo&&(containingMessageChain&&(errorInfo=ts.concatenateDiagnosticMessageChains(containingMessageChain,errorInfo)),diagnostics.add(ts.createDiagnosticForNodeFromMessageChain(errorNode,errorInfo))),0!==result}function isAbstractConstructorType(type){if(65536&type.flags){var symbol=type.symbol;if(symbol&&32&symbol.flags){var declaration=getClassLikeDeclarationOfSymbol(symbol);if(declaration&&128&declaration.flags)return!0}}return!1}function isDeeplyNestedGeneric(type,stack,depth){if(135168&type.flags&&depth>=5)for(var symbol=type.symbol,count=0,i=0;i<depth;i++){var t=stack[i];if(135168&t.flags&&t.symbol===symbol&&(count++,count>=5))return!0}return!1}function isPropertyIdenticalTo(sourceProp,targetProp){return 0!==compareProperties(sourceProp,targetProp,compareTypesIdentical)}function compareProperties(sourceProp,targetProp,compareTypes){if(sourceProp===targetProp)return-1;var sourcePropAccessibility=48&getDeclarationFlagsFromSymbol(sourceProp),targetPropAccessibility=48&getDeclarationFlagsFromSymbol(targetProp);if(sourcePropAccessibility!==targetPropAccessibility)return 0;if(sourcePropAccessibility){if(getTargetSymbol(sourceProp)!==getTargetSymbol(targetProp))return 0}else if((536870912&sourceProp.flags)!==(536870912&targetProp.flags))return 0;return compareTypes(getTypeOfSymbol(sourceProp),getTypeOfSymbol(targetProp))}function isMatchingSignature(source,target,partialMatch){return source.parameters.length===target.parameters.length&&source.minArgumentCount===target.minArgumentCount&&source.hasRestParameter===target.hasRestParameter||!!(partialMatch&&source.minArgumentCount<=target.minArgumentCount&&(source.hasRestParameter&&!target.hasRestParameter||source.hasRestParameter===target.hasRestParameter&&source.parameters.length>=target.parameters.length))}function compareSignaturesIdentical(source,target,partialMatch,ignoreReturnTypes,compareTypes){if(source===target)return-1;if(!isMatchingSignature(source,target,partialMatch))return 0;if((source.typeParameters?source.typeParameters.length:0)!==(target.typeParameters?target.typeParameters.length:0))return 0;source=getErasedSignature(source),target=getErasedSignature(target);for(var result=-1,targetLen=target.parameters.length,i=0;i<targetLen;i++){var s=isRestParameterIndex(source,i)?getRestTypeOfSignature(source):getTypeOfSymbol(source.parameters[i]),t=isRestParameterIndex(target,i)?getRestTypeOfSignature(target):getTypeOfSymbol(target.parameters[i]),related=compareTypes(s,t);if(!related)return 0;result&=related}return ignoreReturnTypes||(result&=compareTypes(getReturnTypeOfSignature(source),getReturnTypeOfSignature(target))),result}function isRestParameterIndex(signature,parameterIndex){return signature.hasRestParameter&&parameterIndex>=signature.parameters.length-1}function isSupertypeOfEach(candidate,types){for(var _i=0,types_6=types;_i<types_6.length;_i++){var type=types_6[_i];if(candidate!==type&&!isTypeSubtypeOf(type,candidate))return!1}return!0}function getCommonSupertype(types){return ts.forEach(types,function(t){return isSupertypeOfEach(t,types)?t:void 0})}function reportNoCommonSupertypeError(types,errorLocation,errorMessageChainHead){for(var bestSupertype,bestSupertypeDownfallType,bestSupertypeScore=0,i=0;i<types.length;i++){for(var score=0,downfallType=void 0,j=0;j<types.length;j++)isTypeSubtypeOf(types[j],types[i])?score++:downfallType||(downfallType=types[j]);if(ts.Debug.assert(!!downfallType,"If there is no common supertype, each type should have a downfallType"),score>bestSupertypeScore&&(bestSupertype=types[i],bestSupertypeDownfallType=downfallType,bestSupertypeScore=score),bestSupertypeScore===types.length-1)break}checkTypeSubtypeOf(bestSupertypeDownfallType,bestSupertype,errorLocation,ts.Diagnostics.Type_argument_candidate_1_is_not_a_valid_type_argument_because_it_is_not_a_supertype_of_candidate_0,errorMessageChainHead)}function isArrayType(type){return 4096&type.flags&&type.target===globalArrayType}function isArrayLikeType(type){return!(96&type.flags)&&isTypeAssignableTo(type,anyArrayType)}function isTupleLikeType(type){return!!getPropertyOfType(type,"0")}function isStringLiteralType(type){return 256&type.flags}function isTupleType(type){return!!(8192&type.flags)}function getRegularTypeOfObjectLiteral(type){if(1048576&type.flags){var regularType=type.regularType;return regularType||(regularType=createType(type.flags&-1048577),regularType.symbol=type.symbol,regularType.members=type.members,regularType.properties=type.properties,regularType.callSignatures=type.callSignatures,regularType.constructSignatures=type.constructSignatures,regularType.stringIndexType=type.stringIndexType,regularType.numberIndexType=type.numberIndexType,type.regularType=regularType),regularType}return type}function getWidenedTypeOfObjectLiteral(type){var properties=getPropertiesOfObjectType(type),members={};ts.forEach(properties,function(p){var propType=getTypeOfSymbol(p),widenedType=getWidenedType(propType);if(propType!==widenedType){var symbol=createSymbol(67108864|p.flags,p.name);symbol.declarations=p.declarations,symbol.parent=p.parent,symbol.type=widenedType,symbol.target=p,p.valueDeclaration&&(symbol.valueDeclaration=p.valueDeclaration),p=symbol}members[p.name]=p});var stringIndexType=getIndexTypeOfType(type,0),numberIndexType=getIndexTypeOfType(type,1);return stringIndexType&&(stringIndexType=getWidenedType(stringIndexType)),numberIndexType&&(numberIndexType=getWidenedType(numberIndexType)),createAnonymousType(type.symbol,members,emptyArray,emptyArray,stringIndexType,numberIndexType)}function getWidenedType(type){if(6291456&type.flags){if(96&type.flags)return anyType;if(524288&type.flags)return getWidenedTypeOfObjectLiteral(type);if(16384&type.flags)return getUnionType(ts.map(type.types,getWidenedType),!0);if(isArrayType(type))return createArrayType(getWidenedType(type.typeArguments[0]));if(isTupleType(type))return createTupleType(ts.map(type.elementTypes,getWidenedType))}return type}function reportWideningErrorsInType(type){var errorReported=!1;if(16384&type.flags)for(var _i=0,_a=type.types;_i<_a.length;_i++){var t=_a[_i];reportWideningErrorsInType(t)&&(errorReported=!0)}if(isArrayType(type))return reportWideningErrorsInType(type.typeArguments[0]);if(isTupleType(type))for(var _b=0,_c=type.elementTypes;_b<_c.length;_b++){var t=_c[_b];reportWideningErrorsInType(t)&&(errorReported=!0)}if(524288&type.flags)for(var _d=0,_e=getPropertiesOfObjectType(type);_d<_e.length;_d++){var p=_e[_d],t=getTypeOfSymbol(p);2097152&t.flags&&(reportWideningErrorsInType(t)||error(p.valueDeclaration,ts.Diagnostics.Object_literal_s_property_0_implicitly_has_an_1_type,p.name,typeToString(getWidenedType(t))),errorReported=!0)}return errorReported}function reportImplicitAnyError(declaration,type){var diagnostic,typeAsString=typeToString(getWidenedType(type));switch(declaration.kind){case 142:case 141:diagnostic=ts.Diagnostics.Member_0_implicitly_has_an_1_type;break;case 139:diagnostic=declaration.dotDotDotToken?ts.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type:ts.Diagnostics.Parameter_0_implicitly_has_an_1_type;break;case 216:case 144:case 143:case 146:case 147:case 176:case 177:if(!declaration.name)return void error(declaration,ts.Diagnostics.Function_expression_which_lacks_return_type_annotation_implicitly_has_an_0_return_type,typeAsString);diagnostic=ts.Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type;break;default:diagnostic=ts.Diagnostics.Variable_0_implicitly_has_an_1_type}error(declaration,diagnostic,ts.declarationNameToString(declaration.name),typeAsString)}function reportErrorsFromWidening(declaration,type){produceDiagnostics&&compilerOptions.noImplicitAny&&2097152&type.flags&&(reportWideningErrorsInType(type)||reportImplicitAnyError(declaration,type))}function forEachMatchingParameterType(source,target,callback){var count,sourceMax=source.parameters.length,targetMax=target.parameters.length;source.hasRestParameter&&target.hasRestParameter?(count=sourceMax>targetMax?sourceMax:targetMax,sourceMax--,targetMax--):source.hasRestParameter?(sourceMax--,count=targetMax):target.hasRestParameter?(targetMax--,count=sourceMax):count=sourceMax<targetMax?sourceMax:targetMax;for(var i=0;i<count;i++){var s=i<sourceMax?getTypeOfSymbol(source.parameters[i]):getRestTypeOfSignature(source),t=i<targetMax?getTypeOfSymbol(target.parameters[i]):getRestTypeOfSignature(target);callback(s,t)}}function createInferenceContext(typeParameters,inferUnionTypes){var inferences=ts.map(typeParameters,createTypeInferencesObject);return{typeParameters:typeParameters,inferUnionTypes:inferUnionTypes,inferences:inferences,inferredTypes:new Array(typeParameters.length)}}function createTypeInferencesObject(){return{primary:void 0,secondary:void 0,isFixed:!1}}function inferTypes(context,source,target){function isInProcess(source,target){for(var i=0;i<depth;i++)if(source===sourceStack[i]&&target===targetStack[i])return!0;return!1}function inferFromTypes(source,target){if(16384&source.flags&&16384&target.flags||32768&source.flags&&32768&target.flags){for(var matchingTypes=void 0,_i=0,_a=target.types;_i<_a.length;_i++){var t=_a[_i];typeIdenticalToSomeType(t,source.types)&&((matchingTypes||(matchingTypes=[])).push(t),inferFromTypes(t,t))}matchingTypes&&(source=removeTypesFromUnionOrIntersection(source,matchingTypes),target=removeTypesFromUnionOrIntersection(target,matchingTypes))}if(512&target.flags){if(8388608&source.flags)return;for(var typeParameters=context.typeParameters,i=0;i<typeParameters.length;i++)if(target===typeParameters[i]){var inferences=context.inferences[i];if(!inferences.isFixed){var candidates=inferiority?inferences.secondary||(inferences.secondary=[]):inferences.primary||(inferences.primary=[]);ts.contains(candidates,source)||candidates.push(source)}return}}else if(4096&source.flags&&4096&target.flags&&source.target===target.target)for(var sourceTypes=source.typeArguments||emptyArray,targetTypes=target.typeArguments||emptyArray,count=sourceTypes.length<targetTypes.length?sourceTypes.length:targetTypes.length,i=0;i<count;i++)inferFromTypes(sourceTypes[i],targetTypes[i]);else if(8192&source.flags&&8192&target.flags&&source.elementTypes.length===target.elementTypes.length)for(var sourceTypes=source.elementTypes,targetTypes=target.elementTypes,i=0;i<sourceTypes.length;i++)inferFromTypes(sourceTypes[i],targetTypes[i]);else if(49152&target.flags){for(var targetTypes=target.types,typeParameterCount=0,typeParameter=void 0,_b=0,targetTypes_2=targetTypes;_b<targetTypes_2.length;_b++){var t=targetTypes_2[_b];512&t.flags&&ts.contains(context.typeParameters,t)?(typeParameter=t,typeParameterCount++):inferFromTypes(source,t)}16384&target.flags&&1===typeParameterCount&&(inferiority++,inferFromTypes(source,typeParameter),inferiority--)}else if(49152&source.flags)for(var sourceTypes=source.types,_c=0,sourceTypes_3=sourceTypes;_c<sourceTypes_3.length;_c++){var sourceType=sourceTypes_3[_c];inferFromTypes(sourceType,target)}else if(source=getApparentType(source),80896&source.flags&&(4096&target.flags&&target.typeArguments||8192&target.flags||65536&target.flags&&target.symbol&&10272&target.symbol.flags)){if(isInProcess(source,target))return;if(isDeeplyNestedGeneric(source,sourceStack,depth)&&isDeeplyNestedGeneric(target,targetStack,depth))return;0===depth&&(sourceStack=[],targetStack=[]),sourceStack[depth]=source,targetStack[depth]=target,depth++,inferFromProperties(source,target),inferFromSignatures(source,target,0),inferFromSignatures(source,target,1),inferFromIndexTypes(source,target,0,0),inferFromIndexTypes(source,target,1,1),inferFromIndexTypes(source,target,0,1),depth--}}function inferFromProperties(source,target){for(var properties=getPropertiesOfObjectType(target),_i=0,properties_2=properties;_i<properties_2.length;_i++){var targetProp=properties_2[_i],sourceProp=getPropertyOfObjectType(source,targetProp.name);sourceProp&&inferFromTypes(getTypeOfSymbol(sourceProp),getTypeOfSymbol(targetProp))}}function inferFromSignatures(source,target,kind){for(var sourceSignatures=getSignaturesOfType(source,kind),targetSignatures=getSignaturesOfType(target,kind),sourceLen=sourceSignatures.length,targetLen=targetSignatures.length,len=sourceLen<targetLen?sourceLen:targetLen,i=0;i<len;i++)inferFromSignature(getErasedSignature(sourceSignatures[sourceLen-len+i]),getErasedSignature(targetSignatures[targetLen-len+i]))}function inferFromSignature(source,target){forEachMatchingParameterType(source,target,inferFromTypes),source.typePredicate&&target.typePredicate&&source.typePredicate.kind===target.typePredicate.kind?inferFromTypes(source.typePredicate.type,target.typePredicate.type):inferFromTypes(getReturnTypeOfSignature(source),getReturnTypeOfSignature(target))}function inferFromIndexTypes(source,target,sourceKind,targetKind){var targetIndexType=getIndexTypeOfType(target,targetKind);if(targetIndexType){var sourceIndexType=getIndexTypeOfType(source,sourceKind);sourceIndexType&&inferFromTypes(sourceIndexType,targetIndexType)}}var sourceStack,targetStack,depth=0,inferiority=0;inferFromTypes(source,target)}function typeIdenticalToSomeType(type,types){for(var _i=0,types_7=types;_i<types_7.length;_i++){var t=types_7[_i];if(isTypeIdenticalTo(t,type))return!0}return!1}function removeTypesFromUnionOrIntersection(type,typesToRemove){for(var reducedTypes=[],_i=0,_a=type.types;_i<_a.length;_i++){var t=_a[_i];typeIdenticalToSomeType(t,typesToRemove)||reducedTypes.push(t)}return 16384&type.flags?getUnionType(reducedTypes,!0):getIntersectionType(reducedTypes)}function getInferenceCandidates(context,index){var inferences=context.inferences[index];return inferences.primary||inferences.secondary||emptyArray}function getInferredType(context,index){var inferenceSucceeded,inferredType=context.inferredTypes[index];if(!inferredType){var inferences=getInferenceCandidates(context,index);if(inferences.length){var unionOrSuperType=context.inferUnionTypes?getUnionType(inferences):getCommonSupertype(inferences);inferredType=unionOrSuperType?getWidenedType(unionOrSuperType):unknownType,inferenceSucceeded=!!unionOrSuperType}else inferredType=emptyObjectType,inferenceSucceeded=!0;if(context.inferredTypes[index]=inferredType,inferenceSucceeded){var constraint=getConstraintOfTypeParameter(context.typeParameters[index]);if(constraint){var instantiatedConstraint=instantiateType(constraint,getInferenceMapper(context));isTypeAssignableTo(inferredType,getTypeWithThisArgument(instantiatedConstraint,inferredType))||(context.inferredTypes[index]=inferredType=instantiatedConstraint)}}else(void 0===context.failedTypeParameterIndex||context.failedTypeParameterIndex>index)&&(context.failedTypeParameterIndex=index)}return inferredType}function getInferredTypes(context){for(var i=0;i<context.inferredTypes.length;i++)getInferredType(context,i);return context.inferredTypes}function getResolvedSymbol(node){var links=getNodeLinks(node);return links.resolvedSymbol||(links.resolvedSymbol=!ts.nodeIsMissing(node)&&resolveName(node,node.text,1156031,ts.Diagnostics.Cannot_find_name_0,node)||unknownSymbol),links.resolvedSymbol}function isInTypeQuery(node){for(;node;)switch(node.kind){case 155:return!0;case 69:case 136:node=node.parent;continue;default:return!1}ts.Debug.fail("should not get here")}function hasInitializer(node){return!!(node.initializer||ts.isBindingPattern(node.parent)&&hasInitializer(node.parent.parent))}function isVariableAssignedWithin(symbol,node){function isAssignedInBinaryExpression(node){if(node.operatorToken.kind>=56&&node.operatorToken.kind<=68){var n=skipParenthesizedNodes(node.left);if(69===n.kind&&getResolvedSymbol(n)===symbol)return!0}return ts.forEachChild(node,isAssignedIn)}function isAssignedInVariableDeclaration(node){return!(ts.isBindingPattern(node.name)||getSymbolOfNode(node)!==symbol||!hasInitializer(node))||ts.forEachChild(node,isAssignedIn)}function isAssignedIn(node){switch(node.kind){case 184:return isAssignedInBinaryExpression(node);case 214:case 166:return isAssignedInVariableDeclaration(node);case 164:case 165:case 167:case 168:case 169:case 170:case 171:case 172:case 174:case 192:case 175:case 182:case 178:case 181:case 179:case 180:case 183:case 187:case 185:case 188:case 195:case 196:case 198:case 199:case 200:case 201:case 202:case 203:case 204:case 207:case 208:case 209:case 244:case 245:case 210:case 211:case 212:case 247:case 236:case 237:case 241:case 242:case 238:case 243:return ts.forEachChild(node,isAssignedIn)}return!1}var links=getNodeLinks(node);if(links.assignmentChecks){var cachedResult=links.assignmentChecks[symbol.id];if(void 0!==cachedResult)return cachedResult}else links.assignmentChecks={};return links.assignmentChecks[symbol.id]=isAssignedIn(node)}function getNarrowedTypeOfSymbol(symbol,node){function narrowTypeByEquality(type,expr,assumeTrue){function filterUnion(type){return assumeTrue===!!(type.flags&flags)}if(179!==expr.left.kind||9!==expr.right.kind)return type;var left=expr.left,right=expr.right;if(69!==left.expression.kind||getResolvedSymbol(left.expression)!==symbol)return type;33===expr.operatorToken.kind&&(assumeTrue=!assumeTrue);var typeInfo=primitiveTypeInfo[right.text];if(typeInfo&&typeInfo.type===undefinedType)return type;var flags;return typeInfo?flags=typeInfo.flags:(assumeTrue=!assumeTrue,flags=16777614),16384&type.flags?getUnionType(ts.filter(type.types,filterUnion),!0):assumeTrue&&typeInfo&&isTypeSubtypeOf(typeInfo.type,type)?typeInfo.type:filterUnion(type)?type:emptyUnionType}function narrowTypeByAnd(type,expr,assumeTrue){return assumeTrue?narrowType(narrowType(type,expr.left,!0),expr.right,!0):getUnionType([narrowType(type,expr.left,!1),narrowType(type,expr.right,!1)])}function narrowTypeByOr(type,expr,assumeTrue){return assumeTrue?getUnionType([narrowType(type,expr.left,!0),narrowType(type,expr.right,!0)]):narrowType(narrowType(type,expr.left,!1),expr.right,!1)}function narrowTypeByInstanceof(type,expr,assumeTrue){if(isTypeAny(type)||69!==expr.left.kind||getResolvedSymbol(expr.left)!==symbol)return type;var rightType=checkExpression(expr.right);if(!isTypeSubtypeOf(rightType,globalFunctionType))return type;var targetType,prototypeProperty=getPropertyOfType(rightType,"prototype");if(prototypeProperty){var prototypePropertyType=getTypeOfSymbol(prototypeProperty);isTypeAny(prototypePropertyType)||(targetType=prototypePropertyType)}if(!targetType){var constructSignatures=void 0;2048&rightType.flags?constructSignatures=resolveDeclaredMembers(rightType).declaredConstructSignatures:65536&rightType.flags&&(constructSignatures=getSignaturesOfType(rightType,1)),constructSignatures&&constructSignatures.length&&(targetType=getUnionType(ts.map(constructSignatures,function(signature){return getReturnTypeOfSignature(getErasedSignature(signature))})))}return targetType?getNarrowedType(type,targetType,assumeTrue):type}function getNarrowedType(originalType,narrowedTypeCandidate,assumeTrue){if(!assumeTrue)return 16384&originalType.flags?getUnionType(ts.filter(originalType.types,function(t){return!isTypeSubtypeOf(t,narrowedTypeCandidate)})):originalType;if(16384&originalType.flags){var assignableConstituents=ts.filter(originalType.types,function(t){return isTypeAssignableTo(t,narrowedTypeCandidate)});if(assignableConstituents.length)return getUnionType(assignableConstituents)}return isTypeAssignableTo(narrowedTypeCandidate,originalType)?narrowedTypeCandidate:originalType}function narrowTypeByTypePredicate(type,callExpression,assumeTrue){if(1&type.flags)return type;var signature=getResolvedSignature(callExpression),predicate=signature.typePredicate;if(!predicate)return type;if(!ts.isIdentifierTypePredicate(predicate)){var invokedExpression=skipParenthesizedNodes(callExpression.expression);return narrowTypeByThisTypePredicate(type,predicate,invokedExpression,assumeTrue)}return callExpression.arguments[predicate.parameterIndex]&&getSymbolAtTypePredicatePosition(callExpression.arguments[predicate.parameterIndex])===symbol?getNarrowedType(type,predicate.type,assumeTrue):type}function narrowTypeByThisTypePredicate(type,predicate,invokedExpression,assumeTrue){if(170===invokedExpression.kind||169===invokedExpression.kind){var accessExpression=invokedExpression,possibleIdentifier=skipParenthesizedNodes(accessExpression.expression);if(69===possibleIdentifier.kind&&getSymbolAtTypePredicatePosition(possibleIdentifier)===symbol)return getNarrowedType(type,predicate.type,assumeTrue)}return type}function getSymbolAtTypePredicatePosition(expr){switch(expr=skipParenthesizedNodes(expr),expr.kind){case 69:case 169:return getSymbolOfEntityNameOrPropertyAccessExpression(expr)}}function narrowType(type,expr,assumeTrue){switch(expr.kind){case 171:return narrowTypeByTypePredicate(type,expr,assumeTrue);case 175:return narrowType(type,expr.expression,assumeTrue);case 184:var operator=expr.operatorToken.kind;if(32===operator||33===operator)return narrowTypeByEquality(type,expr,assumeTrue);if(51===operator)return narrowTypeByAnd(type,expr,assumeTrue);if(52===operator)return narrowTypeByOr(type,expr,assumeTrue);if(91===operator)return narrowTypeByInstanceof(type,expr,assumeTrue);break;case 182:if(49===expr.operator)return narrowType(type,expr.operand,!assumeTrue)}return type}var type=getTypeOfSymbol(symbol);if(node&&3&symbol.flags&&(isTypeAny(type)||97792&type.flags)){var declaration=ts.getDeclarationOfKind(symbol,214),top_1=declaration&&getDeclarationContainer(declaration),originalType=type,nodeStack=[];loop:for(;node.parent;){var child=node;switch(node=node.parent,node.kind){case 199:case 185:case 184:nodeStack.push({node:node,child:child});break;case 251:case 221:break loop}if(node===top_1)break}for(var nodes=void 0;nodes=nodeStack.pop();){var node_1=nodes.node,child=nodes.child;switch(node_1.kind){case 199:child!==node_1.expression&&(type=narrowType(type,node_1.expression,child===node_1.thenStatement));break;case 185:child!==node_1.condition&&(type=narrowType(type,node_1.condition,child===node_1.whenTrue));break;case 184:child===node_1.right&&(51===node_1.operatorToken.kind?type=narrowType(type,node_1.left,!0):52===node_1.operatorToken.kind&&(type=narrowType(type,node_1.left,!1)));break;default:ts.Debug.fail("Unreachable!")}type!==originalType&&isVariableAssignedWithin(symbol,node_1)&&(type=originalType)}type===emptyUnionType&&(type=originalType)}return type}function skipParenthesizedNodes(expression){for(;175===expression.kind;)expression=expression.expression;return expression}function checkIdentifier(node){var symbol=getResolvedSymbol(node);if(symbol===argumentsSymbol){var container=ts.getContainingFunction(node);177===container.kind&&languageVersion<2&&error(node,ts.Diagnostics.The_arguments_object_cannot_be_referenced_in_an_arrow_function_in_ES3_and_ES5_Consider_using_a_standard_function_expression),8&node.parserContextFlags&&(getNodeLinks(container).flags|=8192)}8388608&symbol.flags&&!isInTypeQuery(node)&&!isConstEnumOrConstEnumOnlyModule(resolveAlias(symbol))&&markAliasSymbolAsReferenced(symbol);var localOrExportSymbol=getExportSymbolOfValueSymbolIfExported(symbol);if(2===languageVersion&&32&localOrExportSymbol.flags&&217===localOrExportSymbol.valueDeclaration.kind&&ts.nodeIsDecorated(localOrExportSymbol.valueDeclaration))for(var container=ts.getContainingClass(node);void 0!==container;){if(container===localOrExportSymbol.valueDeclaration&&container.name!==node){getNodeLinks(container).flags|=524288,getNodeLinks(node).flags|=1048576;break}container=ts.getContainingClass(container)}return checkCollisionWithCapturedSuperVariable(node,node),checkCollisionWithCapturedThisVariable(node,node),checkNestedBlockScopedBinding(node,symbol),getNarrowedTypeOfSymbol(localOrExportSymbol,node)}function isInsideFunction(node,threshold){for(var current=node;current&&current!==threshold;){if(ts.isFunctionLike(current))return!0;current=current.parent}return!1}function checkNestedBlockScopedBinding(node,symbol){if(!(languageVersion>=2||0===(34&symbol.flags)||247===symbol.valueDeclaration.parent.kind)){for(var container=ts.getEnclosingBlockScopeContainer(symbol.valueDeclaration),usedInFunction=isInsideFunction(node.parent,container),current=container,containedInIterationStatement=!1;current&&!ts.nodeStartsNewLexicalEnvironment(current);){if(ts.isIterationStatement(current,!1)){containedInIterationStatement=!0;break}current=current.parent}containedInIterationStatement&&(usedInFunction&&(getNodeLinks(current).flags|=65536),202===container.kind&&ts.getAncestor(symbol.valueDeclaration,215).parent===container&&isAssignedInBodyOfForStatement(node,container)&&(getNodeLinks(symbol.valueDeclaration).flags|=2097152),getNodeLinks(symbol.valueDeclaration).flags|=262144),usedInFunction&&(getNodeLinks(symbol.valueDeclaration).flags|=131072)}}function isAssignedInBodyOfForStatement(node,container){for(var current=node;175===current.parent.kind;)current=current.parent;var isAssigned=!1;if(184===current.parent.kind&&(isAssigned=current.parent.left===current&&ts.isAssignmentOperator(current.parent.operatorToken.kind)),182===current.parent.kind||183===current.parent.kind){var expr=current.parent;isAssigned=41===expr.operator||42===expr.operator}if(!isAssigned)return!1;for(;current!==container;){if(current===container.statement)return!0;current=current.parent}return!1}function captureLexicalThis(node,container){if(getNodeLinks(node).flags|=2,142===container.kind||145===container.kind){var classNode=container.parent;getNodeLinks(classNode).flags|=4}else getNodeLinks(container).flags|=4}function findFirstSuperCall(n){if(ts.isSuperCallExpression(n))return n;if(!ts.isFunctionLike(n))return ts.forEachChild(n,findFirstSuperCall)}function getSuperCallInConstructor(constructor){var links=getNodeLinks(constructor);return void 0===links.hasSuperCall&&(links.superCall=findFirstSuperCall(constructor.body),links.hasSuperCall=!!links.superCall),links.superCall}function classDeclarationExtendsNull(classDecl){var classSymbol=getSymbolOfNode(classDecl),classInstanceType=getDeclaredTypeOfSymbol(classSymbol),baseConstructorType=getBaseConstructorTypeOfClass(classInstanceType);return baseConstructorType===nullType}function checkThisExpression(node){var container=ts.getThisContainer(node,!0),needToCaptureLexicalThis=!1;if(145===container.kind){var containingClassDecl=container.parent,baseTypeNode=ts.getClassExtendsHeritageClauseElement(containingClassDecl);if(baseTypeNode&&!classDeclarationExtendsNull(containingClassDecl)){var superCall=getSuperCallInConstructor(container);(!superCall||superCall.end>node.pos)&&error(node,ts.Diagnostics.super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class)}}switch(177===container.kind&&(container=ts.getThisContainer(container,!1),needToCaptureLexicalThis=languageVersion<2),container.kind){case 221:error(node,ts.Diagnostics.this_cannot_be_referenced_in_a_module_or_namespace_body);break;case 220:error(node,ts.Diagnostics.this_cannot_be_referenced_in_current_location);
break;case 145:isInConstructorArgumentInitializer(node,container)&&error(node,ts.Diagnostics.this_cannot_be_referenced_in_constructor_arguments);break;case 142:case 141:64&container.flags&&error(node,ts.Diagnostics.this_cannot_be_referenced_in_a_static_property_initializer);break;case 137:error(node,ts.Diagnostics.this_cannot_be_referenced_in_a_computed_property_name)}if(needToCaptureLexicalThis&&captureLexicalThis(node,container),ts.isClassLike(container.parent)){var symbol=getSymbolOfNode(container.parent);return 64&container.flags?getTypeOfSymbol(symbol):getDeclaredTypeOfSymbol(symbol).thisType}if(ts.isInJavaScriptFile(node)){var type=getTypeForThisExpressionFromJSDoc(container);if(type&&type!==unknownType)return type;if(176===container.kind&&3===ts.getSpecialPropertyAssignmentKind(container.parent)){var className=container.parent.left.expression.expression,classSymbol=checkExpression(className).symbol;if(classSymbol&&classSymbol.members&&16&classSymbol.flags)return getInferredClassType(classSymbol)}}return anyType}function getTypeForThisExpressionFromJSDoc(node){var typeTag=ts.getJSDocTypeTag(node);if(typeTag&&typeTag.typeExpression&&typeTag.typeExpression.type&&264===typeTag.typeExpression.type.kind){var jsDocFunctionType=typeTag.typeExpression.type;if(jsDocFunctionType.parameters.length>0&&267===jsDocFunctionType.parameters[0].type.kind)return getTypeFromTypeNode(jsDocFunctionType.parameters[0].type)}}function isInConstructorArgumentInitializer(node,constructorDecl){for(var n=node;n&&n!==constructorDecl;n=n.parent)if(139===n.kind)return!0;return!1}function checkSuperExpression(node){function isLegalUsageOfSuperExpression(container){return!!container&&(isCallExpression?145===container.kind:!(!ts.isClassLike(container.parent)&&168!==container.parent.kind)&&(64&container.flags?144===container.kind||143===container.kind||146===container.kind||147===container.kind:144===container.kind||143===container.kind||146===container.kind||147===container.kind||142===container.kind||141===container.kind||145===container.kind))}var isCallExpression=171===node.parent.kind&&node.parent.expression===node,container=ts.getSuperContainer(node,!0),needToCaptureLexicalThis=!1;if(!isCallExpression)for(;container&&177===container.kind;)container=ts.getSuperContainer(container,!0),needToCaptureLexicalThis=languageVersion<2;var canUseSuperExpression=isLegalUsageOfSuperExpression(container),nodeCheckFlag=0;if(!canUseSuperExpression){for(var current=node;current&&current!==container&&137!==current.kind;)current=current.parent;return current&&137===current.kind?error(node,ts.Diagnostics.super_cannot_be_referenced_in_a_computed_property_name):isCallExpression?error(node,ts.Diagnostics.Super_calls_are_not_permitted_outside_constructors_or_in_nested_functions_inside_constructors):container&&container.parent&&(ts.isClassLike(container.parent)||168===container.parent.kind)?error(node,ts.Diagnostics.super_property_access_is_permitted_only_in_a_constructor_member_function_or_member_accessor_of_a_derived_class):error(node,ts.Diagnostics.super_can_only_be_referenced_in_members_of_derived_classes_or_object_literal_expressions),unknownType}if(nodeCheckFlag=64&container.flags||isCallExpression?512:256,getNodeLinks(node).flags|=nodeCheckFlag,144===container.kind&&256&container.flags&&(ts.isSuperPropertyOrElementAccess(node.parent)&&isAssignmentTarget(node.parent)?getNodeLinks(container).flags|=4096:getNodeLinks(container).flags|=2048),needToCaptureLexicalThis&&captureLexicalThis(node.parent,container),168===container.parent.kind)return languageVersion<2?(error(node,ts.Diagnostics.super_is_only_allowed_in_members_of_object_literal_expressions_when_option_target_is_ES2015_or_higher),unknownType):anyType;var classLikeDeclaration=container.parent,classType=getDeclaredTypeOfSymbol(getSymbolOfNode(classLikeDeclaration)),baseClassType=classType&&getBaseTypes(classType)[0];return baseClassType?145===container.kind&&isInConstructorArgumentInitializer(node,container)?(error(node,ts.Diagnostics.super_cannot_be_referenced_in_constructor_arguments),unknownType):512===nodeCheckFlag?getBaseConstructorTypeOfClass(classType):baseClassType:(ts.getClassExtendsHeritageClauseElement(classLikeDeclaration)||error(node,ts.Diagnostics.super_can_only_be_referenced_in_a_derived_class),unknownType)}function getContextuallyTypedParameterType(parameter){var func=parameter.parent;if((isFunctionExpressionOrArrowFunction(func)||ts.isObjectLiteralMethod(func))&&isContextSensitive(func)){var contextualSignature=getContextualSignature(func);if(contextualSignature){var funcHasRestParameters=ts.hasRestParameter(func),len=func.parameters.length-(funcHasRestParameters?1:0),indexOfParameter=ts.indexOf(func.parameters,parameter);if(indexOfParameter<len)return getTypeAtPosition(contextualSignature,indexOfParameter);if(funcHasRestParameters&&indexOfParameter===func.parameters.length-1&&isRestParameterIndex(contextualSignature,func.parameters.length-1))return getTypeOfSymbol(ts.lastOrUndefined(contextualSignature.parameters))}}}function getContextualTypeForInitializerExpression(node){var declaration=node.parent;if(node===declaration.initializer){if(declaration.type)return getTypeFromTypeNode(declaration.type);if(139===declaration.kind){var type=getContextuallyTypedParameterType(declaration);if(type)return type}if(ts.isBindingPattern(declaration.name))return getTypeFromBindingPattern(declaration.name,!0)}}function getContextualTypeForReturnExpression(node){var func=ts.getContainingFunction(node);if(func&&!func.asteriskToken)return getContextualReturnType(func)}function getContextualTypeForYieldOperand(node){var func=ts.getContainingFunction(node);if(func){var contextualReturnType=getContextualReturnType(func);if(contextualReturnType)return node.asteriskToken?contextualReturnType:getElementTypeOfIterableIterator(contextualReturnType)}}function isInParameterInitializerBeforeContainingFunction(node){for(;node.parent&&!ts.isFunctionLike(node.parent);){if(139===node.parent.kind&&node.parent.initializer===node)return!0;node=node.parent}return!1}function getContextualReturnType(functionDecl){if(functionDecl.type||145===functionDecl.kind||146===functionDecl.kind&&ts.getSetAccessorTypeAnnotationNode(ts.getDeclarationOfKind(functionDecl.symbol,147)))return getReturnTypeOfSignature(getSignatureFromDeclaration(functionDecl));var signature=getContextualSignatureForFunctionLikeDeclaration(functionDecl);return signature?getReturnTypeOfSignature(signature):void 0}function getContextualTypeForArgument(callTarget,arg){var args=getEffectiveCallArguments(callTarget),argIndex=ts.indexOf(args,arg);if(argIndex>=0){var signature=getResolvedSignature(callTarget);return getTypeAtPosition(signature,argIndex)}}function getContextualTypeForSubstitutionExpression(template,substitutionExpression){if(173===template.parent.kind)return getContextualTypeForArgument(template.parent,substitutionExpression)}function getContextualTypeForBinaryOperand(node){var binaryExpression=node.parent,operator=binaryExpression.operatorToken.kind;if(operator>=56&&operator<=68){if(node===binaryExpression.right)return checkExpression(binaryExpression.left)}else{if(52===operator){var type=getContextualType(binaryExpression);return type||node!==binaryExpression.right||(type=checkExpression(binaryExpression.left)),type}if((51===operator||24===operator)&&node===binaryExpression.right)return getContextualType(binaryExpression)}}function applyToContextualType(type,mapper){if(!(16384&type.flags))return mapper(type);for(var mappedType,mappedTypes,types=type.types,_i=0,types_8=types;_i<types_8.length;_i++){var current=types_8[_i],t=mapper(current);t&&(mappedType?mappedTypes?mappedTypes.push(t):mappedTypes=[mappedType,t]:mappedType=t)}return mappedTypes?getUnionType(mappedTypes):mappedType}function getTypeOfPropertyOfContextualType(type,name){return applyToContextualType(type,function(t){var prop=130048&t.flags?getPropertyOfType(t,name):void 0;return prop?getTypeOfSymbol(prop):void 0})}function getIndexTypeOfContextualType(type,kind){return applyToContextualType(type,function(t){return getIndexTypeOfStructuredType(t,kind)})}function contextualTypeIsStringLiteralType(type){return!!(16384&type.flags?ts.forEach(type.types,isStringLiteralType):isStringLiteralType(type))}function contextualTypeIsTupleLikeType(type){return!!(16384&type.flags?ts.forEach(type.types,isTupleLikeType):isTupleLikeType(type))}function contextualTypeHasIndexSignature(type,kind){return!!(16384&type.flags?ts.forEach(type.types,function(t){return getIndexTypeOfStructuredType(t,kind)}):getIndexTypeOfStructuredType(type,kind))}function getContextualTypeForObjectLiteralMethod(node){if(ts.Debug.assert(ts.isObjectLiteralMethod(node)),!isInsideWithStatementBody(node))return getContextualTypeForObjectLiteralElement(node)}function getContextualTypeForObjectLiteralElement(element){var objectLiteral=element.parent,type=getApparentTypeOfContextualType(objectLiteral);if(type){if(!ts.hasDynamicName(element)){var symbolName=getSymbolOfNode(element).name,propertyType=getTypeOfPropertyOfContextualType(type,symbolName);if(propertyType)return propertyType}return isNumericName(element.name)&&getIndexTypeOfContextualType(type,1)||getIndexTypeOfContextualType(type,0)}}function getContextualTypeForElementExpression(node){var arrayLiteral=node.parent,type=getApparentTypeOfContextualType(arrayLiteral);if(type){var index=ts.indexOf(arrayLiteral.elements,node);return getTypeOfPropertyOfContextualType(type,""+index)||getIndexTypeOfContextualType(type,1)||(languageVersion>=2?getElementTypeOfIterable(type,void 0):void 0)}}function getContextualTypeForConditionalOperand(node){var conditional=node.parent;return node===conditional.whenTrue||node===conditional.whenFalse?getContextualType(conditional):void 0}function getContextualTypeForJsxAttribute(attribute){var kind=attribute.kind,jsxElement=attribute.parent,attrsType=getJsxElementAttributesType(jsxElement);if(241===attribute.kind){if(!attrsType||isTypeAny(attrsType))return;return getTypeOfPropertyOfType(attrsType,attribute.name.text)}return 242===attribute.kind?attrsType:void ts.Debug.fail("Expected JsxAttribute or JsxSpreadAttribute, got ts.SyntaxKind["+kind+"]")}function getApparentTypeOfContextualType(node){var type=getContextualType(node);return type&&getApparentType(type)}function getContextualType(node){if(!isInsideWithStatementBody(node)){if(node.contextualType)return node.contextualType;var parent=node.parent;switch(parent.kind){case 214:case 139:case 142:case 141:case 166:return getContextualTypeForInitializerExpression(node);case 177:case 207:return getContextualTypeForReturnExpression(node);case 187:return getContextualTypeForYieldOperand(parent);case 171:case 172:return getContextualTypeForArgument(parent,node);case 174:case 192:return getTypeFromTypeNode(parent.type);case 184:return getContextualTypeForBinaryOperand(node);case 248:return getContextualTypeForObjectLiteralElement(parent);case 167:return getContextualTypeForElementExpression(node);case 185:return getContextualTypeForConditionalOperand(node);case 193:return ts.Debug.assert(186===parent.parent.kind),getContextualTypeForSubstitutionExpression(parent.parent,node);case 175:return getContextualType(parent);case 243:return getContextualType(parent);case 241:case 242:return getContextualTypeForJsxAttribute(parent)}}}function getNonGenericSignature(type){var signatures=getSignaturesOfStructuredType(type,0);if(1===signatures.length){var signature=signatures[0];if(!signature.typeParameters)return signature}}function isFunctionExpressionOrArrowFunction(node){return 176===node.kind||177===node.kind}function getContextualSignatureForFunctionLikeDeclaration(node){return isFunctionExpressionOrArrowFunction(node)||ts.isObjectLiteralMethod(node)?getContextualSignature(node):void 0}function getContextualSignature(node){ts.Debug.assert(144!==node.kind||ts.isObjectLiteralMethod(node));var type=ts.isObjectLiteralMethod(node)?getContextualTypeForObjectLiteralMethod(node):getApparentTypeOfContextualType(node);if(type){if(!(16384&type.flags))return getNonGenericSignature(type);for(var signatureList,types=type.types,_i=0,types_9=types;_i<types_9.length;_i++){var current=types_9[_i],signature=getNonGenericSignature(current);if(signature)if(signatureList){if(!compareSignaturesIdentical(signatureList[0],signature,!1,!0,compareTypesIdentical))return;signatureList.push(signature)}else signatureList=[signature]}var result;return signatureList&&(result=cloneSignature(signatureList[0]),result.resolvedReturnType=void 0,result.unionSignatures=signatureList),result}}function isInferentialContext(mapper){return mapper&&mapper.context}function isAssignmentTarget(node){var parent=node.parent;return 184===parent.kind&&56===parent.operatorToken.kind&&parent.left===node||(248===parent.kind?isAssignmentTarget(parent.parent):167===parent.kind&&isAssignmentTarget(parent))}function checkSpreadElementExpression(node,contextualMapper){var arrayOrIterableType=checkExpressionCached(node.expression,contextualMapper);return checkIteratedTypeOrElementType(arrayOrIterableType,node.expression,!1)}function hasDefaultValue(node){return 166===node.kind&&!!node.initializer||184===node.kind&&56===node.operatorToken.kind}function checkArrayLiteral(node,contextualMapper){for(var elements=node.elements,hasSpreadElement=!1,elementTypes=[],inDestructuringPattern=isAssignmentTarget(node),_i=0,elements_1=elements;_i<elements_1.length;_i++){var e=elements_1[_i];if(inDestructuringPattern&&188===e.kind){var restArrayType=checkExpression(e.expression,contextualMapper),restElementType=getIndexTypeOfType(restArrayType,1)||(languageVersion>=2?getElementTypeOfIterable(restArrayType,void 0):void 0);restElementType&&elementTypes.push(restElementType)}else{var type=checkExpression(e,contextualMapper);elementTypes.push(type)}hasSpreadElement=hasSpreadElement||188===e.kind}if(!hasSpreadElement){if(inDestructuringPattern&&elementTypes.length){var type=createNewTupleType(elementTypes);return type.pattern=node,type}var contextualType=getApparentTypeOfContextualType(node);if(contextualType&&contextualTypeIsTupleLikeType(contextualType)){var pattern=contextualType.pattern;if(pattern&&(165===pattern.kind||167===pattern.kind))for(var patternElements=pattern.elements,i=elementTypes.length;i<patternElements.length;i++){var patternElement=patternElements[i];hasDefaultValue(patternElement)?elementTypes.push(contextualType.elementTypes[i]):(190!==patternElement.kind&&error(patternElement,ts.Diagnostics.Initializer_provides_no_value_for_this_binding_element_and_the_binding_element_has_no_default_value),elementTypes.push(unknownType))}if(elementTypes.length)return createTupleType(elementTypes)}}return createArrayType(elementTypes.length?getUnionType(elementTypes):undefinedType)}function isNumericName(name){return 137===name.kind?isNumericComputedName(name):isNumericLiteralName(name.text)}function isNumericComputedName(name){return isTypeAnyOrAllConstituentTypesHaveKind(checkComputedPropertyName(name),132)}function isTypeAnyOrAllConstituentTypesHaveKind(type,kind){return isTypeAny(type)||allConstituentTypesHaveKind(type,kind)}function isNumericLiteralName(name){return(+name).toString()===name}function checkComputedPropertyName(node){var links=getNodeLinks(node.expression);return links.resolvedType||(links.resolvedType=checkExpression(node.expression),isTypeAnyOrAllConstituentTypesHaveKind(links.resolvedType,16777606)?checkThatExpressionIsProperSymbolReference(node.expression,links.resolvedType,!0):error(node,ts.Diagnostics.A_computed_property_name_must_be_of_type_string_number_symbol_or_any)),links.resolvedType}function checkObjectLiteral(node,contextualMapper){function getIndexType(kind){if(contextualType&&contextualTypeHasIndexSignature(contextualType,kind)){for(var propTypes=[],i=0;i<propertiesArray.length;i++){var propertyDecl=node.properties[i];if(0===kind||isNumericName(propertyDecl.name)){var type=getTypeOfSymbol(propertiesArray[i]);ts.contains(propTypes,type)||propTypes.push(type)}}var result_1=propTypes.length?getUnionType(propTypes):undefinedType;return typeFlags|=result_1.flags,result_1}}var inDestructuringPattern=isAssignmentTarget(node);checkGrammarObjectLiteralExpression(node,inDestructuringPattern);for(var propertiesTable={},propertiesArray=[],contextualType=getApparentTypeOfContextualType(node),contextualTypeHasPattern=contextualType&&contextualType.pattern&&(164===contextualType.pattern.kind||168===contextualType.pattern.kind),typeFlags=0,patternWithComputedProperties=!1,_i=0,_a=node.properties;_i<_a.length;_i++){var memberDecl=_a[_i],member=memberDecl.symbol;if(248===memberDecl.kind||249===memberDecl.kind||ts.isObjectLiteralMethod(memberDecl)){var type=void 0;248===memberDecl.kind?type=checkPropertyAssignment(memberDecl,contextualMapper):144===memberDecl.kind?type=checkObjectLiteralMethod(memberDecl,contextualMapper):(ts.Debug.assert(249===memberDecl.kind),type=checkExpression(memberDecl.name,contextualMapper)),typeFlags|=type.flags;var prop=createSymbol(67108868|member.flags,member.name);if(inDestructuringPattern){var isOptional=248===memberDecl.kind&&hasDefaultValue(memberDecl.initializer)||249===memberDecl.kind&&memberDecl.objectAssignmentInitializer;isOptional&&(prop.flags|=536870912),ts.hasDynamicName(memberDecl)&&(patternWithComputedProperties=!0)}else if(contextualTypeHasPattern&&!(67108864&contextualType.flags)){var impliedProp=getPropertyOfType(contextualType,member.name);impliedProp?prop.flags|=536870912&impliedProp.flags:compilerOptions.suppressExcessPropertyErrors||error(memberDecl.name,ts.Diagnostics.Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1,symbolToString(member),typeToString(contextualType))}prop.declarations=member.declarations,prop.parent=member.parent,member.valueDeclaration&&(prop.valueDeclaration=member.valueDeclaration),prop.type=type,prop.target=member,member=prop}else ts.Debug.assert(146===memberDecl.kind||147===memberDecl.kind),checkAccessorDeclaration(memberDecl);ts.hasDynamicName(memberDecl)||(propertiesTable[member.name]=member),propertiesArray.push(member)}if(contextualTypeHasPattern)for(var _b=0,_c=getPropertiesOfType(contextualType);_b<_c.length;_b++){var prop=_c[_b];ts.hasProperty(propertiesTable,prop.name)||(536870912&prop.flags||error(prop.valueDeclaration||prop.bindingElement,ts.Diagnostics.Initializer_provides_no_value_for_this_binding_element_and_the_binding_element_has_no_default_value),propertiesTable[prop.name]=prop,propertiesArray.push(prop))}var stringIndexType=getIndexType(0),numberIndexType=getIndexType(1),result=createAnonymousType(node.symbol,propertiesTable,emptyArray,emptyArray,stringIndexType,numberIndexType),freshObjectLiteralFlag=compilerOptions.suppressExcessPropertyErrors?0:1048576;return result.flags|=4718592|freshObjectLiteralFlag|14680064&typeFlags|(patternWithComputedProperties?67108864:0),inDestructuringPattern&&(result.pattern=node),result}function checkJsxSelfClosingElement(node){return checkJsxOpeningLikeElement(node),jsxElementType||anyType}function checkJsxElement(node){checkJsxOpeningLikeElement(node.openingElement),getJsxElementTagSymbol(node.closingElement);for(var _i=0,_a=node.children;_i<_a.length;_i++){var child=_a[_i];switch(child.kind){case 243:checkJsxExpression(child);break;case 236:checkJsxElement(child);break;case 237:checkJsxSelfClosingElement(child)}}return jsxElementType||anyType}function isUnhyphenatedJsxName(name){return name.indexOf("-")<0}function isJsxIntrinsicIdentifier(tagName){return 136!==tagName.kind&&ts.isIntrinsicJsxName(tagName.text)}function checkJsxAttribute(node,elementAttributesType,nameTable){var correspondingPropType=void 0;if(elementAttributesType===emptyObjectType&&isUnhyphenatedJsxName(node.name.text))error(node.parent,ts.Diagnostics.JSX_element_class_does_not_support_attributes_because_it_does_not_have_a_0_property,getJsxElementPropertiesName());else if(elementAttributesType&&!isTypeAny(elementAttributesType)){var correspondingPropSymbol=getPropertyOfType(elementAttributesType,node.name.text);if(correspondingPropType=correspondingPropSymbol&&getTypeOfSymbol(correspondingPropSymbol),isUnhyphenatedJsxName(node.name.text)){var indexerType=getIndexTypeOfType(elementAttributesType,0);if(indexerType)correspondingPropType=indexerType;else if(!correspondingPropType)return error(node.name,ts.Diagnostics.Property_0_does_not_exist_on_type_1,node.name.text,typeToString(elementAttributesType)),unknownType}}var exprType;return exprType=node.initializer?checkExpression(node.initializer):booleanType,correspondingPropType&&checkTypeAssignableTo(exprType,correspondingPropType,node),nameTable[node.name.text]=!0,exprType}function checkJsxSpreadAttribute(node,elementAttributesType,nameTable){for(var type=checkExpression(node.expression),props=getPropertiesOfType(type),_i=0,props_2=props;_i<props_2.length;_i++){var prop=props_2[_i];if(!nameTable[prop.name]){var targetPropSym=getPropertyOfType(elementAttributesType,prop.name);if(targetPropSym){var msg=ts.chainDiagnosticMessages(void 0,ts.Diagnostics.Property_0_of_JSX_spread_attribute_is_not_assignable_to_target_property,prop.name);checkTypeAssignableTo(getTypeOfSymbol(prop),getTypeOfSymbol(targetPropSym),node,void 0,msg)}nameTable[prop.name]=!0}}return type}function getJsxType(name){return void 0===jsxTypes[name]?jsxTypes[name]=getExportedTypeFromNamespace(JsxNames.JSX,name)||unknownType:jsxTypes[name]}function getJsxElementTagSymbol(node){function lookupIntrinsicTag(node){var intrinsicElementsType=getJsxType(JsxNames.IntrinsicElements);if(intrinsicElementsType!==unknownType){var intrinsicProp=getPropertyOfType(intrinsicElementsType,node.tagName.text);if(intrinsicProp)return links.jsxFlags|=1,intrinsicProp;var indexSignatureType=getIndexTypeOfType(intrinsicElementsType,0);return indexSignatureType?(links.jsxFlags|=2,intrinsicElementsType.symbol):(error(node,ts.Diagnostics.Property_0_does_not_exist_on_type_1,node.tagName.text,"JSX."+JsxNames.IntrinsicElements),unknownSymbol)}return compilerOptions.noImplicitAny&&error(node,ts.Diagnostics.JSX_element_implicitly_has_type_any_because_no_interface_JSX_0_exists,JsxNames.IntrinsicElements),unknownSymbol}function lookupClassTag(node){var valueSymbol=resolveJsxTagName(node);return valueSymbol&&valueSymbol!==unknownSymbol&&(links.jsxFlags|=4,8388608&valueSymbol.flags&&markAliasSymbolAsReferenced(valueSymbol)),valueSymbol||unknownSymbol}function resolveJsxTagName(node){if(69===node.tagName.kind){var tag=node.tagName,sym=getResolvedSymbol(tag);return sym.exportSymbol||sym}return checkQualifiedName(node.tagName).symbol}var links=getNodeLinks(node);return links.resolvedSymbol||(isJsxIntrinsicIdentifier(node.tagName)?links.resolvedSymbol=lookupIntrinsicTag(node):links.resolvedSymbol=lookupClassTag(node)),links.resolvedSymbol}function getJsxElementInstanceType(node){ts.Debug.assert(!!(4&getNodeLinks(node).jsxFlags),"Should not call getJsxElementInstanceType on non-class Element");var classSymbol=getJsxElementTagSymbol(node);if(classSymbol===unknownSymbol)return anyType;var valueType=getTypeOfSymbol(classSymbol);if(isTypeAny(valueType))return anyType;var signatures=getSignaturesOfType(valueType,1);return 0===signatures.length&&(signatures=getSignaturesOfType(valueType,0),0===signatures.length)?(error(node.tagName,ts.Diagnostics.JSX_element_type_0_does_not_have_any_construct_or_call_signatures,ts.getTextOfNode(node.tagName)),unknownType):getUnionType(signatures.map(getReturnTypeOfSignature))}function getJsxElementPropertiesName(){var jsxNamespace=getGlobalSymbol(JsxNames.JSX,1536,void 0),attribsPropTypeSym=jsxNamespace&&getSymbol(jsxNamespace.exports,JsxNames.ElementAttributesPropertyNameContainer,793056),attribPropType=attribsPropTypeSym&&getDeclaredTypeOfSymbol(attribsPropTypeSym),attribProperties=attribPropType&&getPropertiesOfType(attribPropType);return attribProperties?0===attribProperties.length?"":1===attribProperties.length?attribProperties[0].name:void error(attribsPropTypeSym.declarations[0],ts.Diagnostics.The_global_type_JSX_0_may_not_have_more_than_one_property,JsxNames.ElementAttributesPropertyNameContainer):void 0}function getJsxElementAttributesType(node){var links=getNodeLinks(node);if(!links.resolvedJsxType){var sym=getJsxElementTagSymbol(node);if(4&links.jsxFlags){var elemInstanceType=getJsxElementInstanceType(node),elemClassType=getJsxGlobalElementClassType();if(!elemClassType||!isTypeAssignableTo(elemInstanceType,elemClassType)){var elemType=getTypeOfSymbol(sym),callSignatures=elemType&&getSignaturesOfType(elemType,0),callSignature=callSignatures&&callSignatures.length>0&&callSignatures[0],callReturnType=callSignature&&getReturnTypeOfSignature(callSignature),paramType=callReturnType&&(0===callSignature.parameters.length?emptyObjectType:getTypeOfSymbol(callSignature.parameters[0]));if(callReturnType&&isTypeAssignableTo(callReturnType,jsxElementType)){var intrinsicAttributes=getJsxType(JsxNames.IntrinsicAttributes);return intrinsicAttributes!==unknownType&&(paramType=intersectTypes(intrinsicAttributes,paramType)),links.resolvedJsxType=paramType}}if(elemClassType&&checkTypeRelatedTo(elemInstanceType,elemClassType,assignableRelation,node,ts.Diagnostics.JSX_element_type_0_is_not_a_constructor_function_for_JSX_elements),isTypeAny(elemInstanceType))return links.resolvedJsxType=elemInstanceType;var propsName=getJsxElementPropertiesName();if(void 0===propsName)return links.resolvedJsxType=anyType;if(""===propsName)return links.resolvedJsxType=elemInstanceType;var attributesType=getTypeOfPropertyOfType(elemInstanceType,propsName);if(attributesType){if(isTypeAny(attributesType)||attributesType===unknownType)return links.resolvedJsxType=attributesType;if(16384&attributesType.flags)return error(node.tagName,ts.Diagnostics.JSX_element_attributes_type_0_may_not_be_a_union_type,typeToString(attributesType)),links.resolvedJsxType=anyType;var apparentAttributesType=attributesType,intrinsicClassAttribs=getJsxType(JsxNames.IntrinsicClassAttributes);if(intrinsicClassAttribs!==unknownType){var typeParams=getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(intrinsicClassAttribs.symbol);typeParams?1===typeParams.length&&(apparentAttributesType=intersectTypes(createTypeReference(intrinsicClassAttribs,[elemInstanceType]),apparentAttributesType)):apparentAttributesType=intersectTypes(attributesType,intrinsicClassAttribs)}var intrinsicAttribs=getJsxType(JsxNames.IntrinsicAttributes);return intrinsicAttribs!==unknownType&&(apparentAttributesType=intersectTypes(intrinsicAttribs,apparentAttributesType)),links.resolvedJsxType=apparentAttributesType}return links.resolvedJsxType=emptyObjectType}return 1&links.jsxFlags?links.resolvedJsxType=getTypeOfSymbol(sym):2&links.jsxFlags?links.resolvedJsxType=getIndexTypeOfSymbol(sym,0):links.resolvedJsxType=anyType}return links.resolvedJsxType}function getJsxAttributePropertySymbol(attrib){var attributesType=getJsxElementAttributesType(attrib.parent),prop=getPropertyOfType(attributesType,attrib.name.text);return prop||unknownSymbol}function getJsxGlobalElementClassType(){return jsxElementClassType||(jsxElementClassType=getExportedTypeFromNamespace(JsxNames.JSX,JsxNames.ElementClass)),jsxElementClassType}function getJsxIntrinsicTagNames(){var intrinsics=getJsxType(JsxNames.IntrinsicElements);return intrinsics?getPropertiesOfType(intrinsics):emptyArray}function checkJsxPreconditions(errorNode){0===(compilerOptions.jsx||0)&&error(errorNode,ts.Diagnostics.Cannot_use_JSX_unless_the_jsx_flag_is_provided),void 0===jsxElementType&&compilerOptions.noImplicitAny&&error(errorNode,ts.Diagnostics.JSX_element_implicitly_has_type_any_because_the_global_type_JSX_Element_does_not_exist)}function checkJsxOpeningLikeElement(node){checkGrammarJsxElement(node),checkJsxPreconditions(node);var reactRefErr=2===compilerOptions.jsx?ts.Diagnostics.Cannot_find_name_0:void 0,reactNamespace=compilerOptions.reactNamespace?compilerOptions.reactNamespace:"React",reactSym=resolveName(node.tagName,reactNamespace,107455,reactRefErr,reactNamespace);reactSym&&(getSymbolLinks(reactSym).referenced=!0);for(var targetAttributesType=getJsxElementAttributesType(node),nameTable={},sawSpreadedAny=!1,i=node.attributes.length-1;i>=0;i--)if(241===node.attributes[i].kind)checkJsxAttribute(node.attributes[i],targetAttributesType,nameTable);else{ts.Debug.assert(242===node.attributes[i].kind);var spreadType=checkJsxSpreadAttribute(node.attributes[i],targetAttributesType,nameTable);isTypeAny(spreadType)&&(sawSpreadedAny=!0)}if(targetAttributesType&&!sawSpreadedAny)for(var targetProperties=getPropertiesOfType(targetAttributesType),i=0;i<targetProperties.length;i++)536870912&targetProperties[i].flags||void 0!==nameTable[targetProperties[i].name]||error(node,ts.Diagnostics.Property_0_is_missing_in_type_1,targetProperties[i].name,typeToString(targetAttributesType))}function checkJsxExpression(node){return node.expression?checkExpression(node.expression):unknownType}function getDeclarationKindFromSymbol(s){return s.valueDeclaration?s.valueDeclaration.kind:142}function getDeclarationFlagsFromSymbol(s){return s.valueDeclaration?ts.getCombinedNodeFlags(s.valueDeclaration):134217728&s.flags?72:0}function checkClassPropertyAccess(node,left,type,prop){var flags=getDeclarationFlagsFromSymbol(prop),declaringClass=getDeclaredTypeOfSymbol(getParentOfSymbol(prop));if(95===left.kind){var errorNode=169===node.kind?node.name:node.right;if(languageVersion<2&&144!==getDeclarationKindFromSymbol(prop))return error(errorNode,ts.Diagnostics.Only_public_and_protected_methods_of_the_base_class_are_accessible_via_the_super_keyword),!1;if(128&flags)return error(errorNode,ts.Diagnostics.Abstract_method_0_in_class_1_cannot_be_accessed_via_super_expression,symbolToString(prop),typeToString(declaringClass)),!1}if(!(48&flags))return!0;var enclosingClassDeclaration=ts.getContainingClass(node),enclosingClass=enclosingClassDeclaration?getDeclaredTypeOfSymbol(getSymbolOfNode(enclosingClassDeclaration)):void 0;return 16&flags?declaringClass===enclosingClass||(error(node,ts.Diagnostics.Property_0_is_private_and_only_accessible_within_class_1,symbolToString(prop),typeToString(declaringClass)),!1):95===left.kind||(enclosingClass&&hasBaseType(enclosingClass,declaringClass)?!!(64&flags)||(33554432&type.flags&&(type=getConstraintOfTypeParameter(type)),!!(3072&getTargetType(type).flags&&hasBaseType(type,enclosingClass))||(error(node,ts.Diagnostics.Property_0_is_protected_and_only_accessible_through_an_instance_of_class_1,symbolToString(prop),typeToString(enclosingClass)),!1)):(error(node,ts.Diagnostics.Property_0_is_protected_and_only_accessible_within_class_1_and_its_subclasses,symbolToString(prop),typeToString(declaringClass)),!1))}function checkPropertyAccessExpression(node){return checkPropertyAccessExpressionOrQualifiedName(node,node.expression,node.name)}function checkQualifiedName(node){return checkPropertyAccessExpressionOrQualifiedName(node,node.left,node.right)}function checkPropertyAccessExpressionOrQualifiedName(node,left,right){var type=checkExpression(left);if(isTypeAny(type))return type;var apparentType=getApparentType(getWidenedType(type));if(apparentType===unknownType)return unknownType;var prop=getPropertyOfType(apparentType,right.text);return prop?(getNodeLinks(node).resolvedSymbol=prop,prop.parent&&32&prop.parent.flags&&checkClassPropertyAccess(node,left,apparentType,prop),getTypeOfSymbol(prop)):(right.text&&error(right,ts.Diagnostics.Property_0_does_not_exist_on_type_1,ts.declarationNameToString(right),typeToString(33554432&type.flags?apparentType:type)),unknownType)}function isValidPropertyAccess(node,propertyName){var left=169===node.kind?node.expression:node.left,type=checkExpression(left);if(type!==unknownType&&!isTypeAny(type)){var prop=getPropertyOfType(getWidenedType(type),propertyName);if(prop&&prop.parent&&32&prop.parent.flags)return checkClassPropertyAccess(node,left,type,prop)}return!0}function getForInVariableSymbol(node){var initializer=node.initializer;if(215===initializer.kind){var variable=initializer.declarations[0];
if(variable&&!ts.isBindingPattern(variable.name))return getSymbolOfNode(variable)}else if(69===initializer.kind)return getResolvedSymbol(initializer)}function hasNumericPropertyNames(type){return getIndexTypeOfType(type,1)&&!getIndexTypeOfType(type,0)}function isForInVariableForNumericPropertyNames(expr){var e=skipParenthesizedNodes(expr);if(69===e.kind){var symbol=getResolvedSymbol(e);if(3&symbol.flags)for(var child=expr,node=expr.parent;node;){if(203===node.kind&&child===node.statement&&getForInVariableSymbol(node)===symbol&&hasNumericPropertyNames(checkExpression(node.expression)))return!0;child=node,node=node.parent}}return!1}function checkIndexedAccess(node){if(!node.argumentExpression){var sourceFile=ts.getSourceFileOfNode(node);if(172===node.parent.kind&&node.parent.expression===node){var start=ts.skipTrivia(sourceFile.text,node.expression.end),end=node.end;grammarErrorAtPos(sourceFile,start,end-start,ts.Diagnostics.new_T_cannot_be_used_to_create_an_array_Use_new_Array_T_instead)}else{var start=node.end-"]".length,end=node.end;grammarErrorAtPos(sourceFile,start,end-start,ts.Diagnostics.Expression_expected)}}var objectType=getApparentType(checkExpression(node.expression)),indexType=node.argumentExpression?checkExpression(node.argumentExpression):unknownType;if(objectType===unknownType)return unknownType;var isConstEnum=isConstEnumObjectType(objectType);if(isConstEnum&&(!node.argumentExpression||9!==node.argumentExpression.kind))return error(node.argumentExpression,ts.Diagnostics.A_const_enum_member_can_only_be_accessed_using_a_string_literal),unknownType;if(node.argumentExpression){var name_11=getPropertyNameForIndexedAccess(node.argumentExpression,indexType);if(void 0!==name_11){var prop=getPropertyOfType(objectType,name_11);if(prop)return getNodeLinks(node).resolvedSymbol=prop,getTypeOfSymbol(prop);if(isConstEnum)return error(node.argumentExpression,ts.Diagnostics.Property_0_does_not_exist_on_const_enum_1,name_11,symbolToString(objectType.symbol)),unknownType}}if(isTypeAnyOrAllConstituentTypesHaveKind(indexType,16777606)){if(isTypeAnyOrAllConstituentTypesHaveKind(indexType,132)||isForInVariableForNumericPropertyNames(node.argumentExpression)){var numberIndexType=getIndexTypeOfType(objectType,1);if(numberIndexType)return numberIndexType}var stringIndexType=getIndexTypeOfType(objectType,0);return stringIndexType?stringIndexType:(!compilerOptions.noImplicitAny||compilerOptions.suppressImplicitAnyIndexErrors||isTypeAny(objectType)||error(node,getIndexTypeOfType(objectType,1)?ts.Diagnostics.Element_implicitly_has_an_any_type_because_index_expression_is_not_of_type_number:ts.Diagnostics.Index_signature_of_object_type_implicitly_has_an_any_type),anyType)}return error(node,ts.Diagnostics.An_index_expression_argument_must_be_of_type_string_number_symbol_or_any),unknownType}function getPropertyNameForIndexedAccess(indexArgumentExpression,indexArgumentType){if(9===indexArgumentExpression.kind||8===indexArgumentExpression.kind)return indexArgumentExpression.text;if(170===indexArgumentExpression.kind||169===indexArgumentExpression.kind){var value=getConstantValue(indexArgumentExpression);if(void 0!==value)return value.toString()}if(checkThatExpressionIsProperSymbolReference(indexArgumentExpression,indexArgumentType,!1)){var rightHandSideName=indexArgumentExpression.name.text;return ts.getPropertyNameForKnownSymbolName(rightHandSideName)}}function checkThatExpressionIsProperSymbolReference(expression,expressionType,reportError){if(expressionType===unknownType)return!1;if(!ts.isWellKnownSymbolSyntactically(expression))return!1;if(0===(16777216&expressionType.flags))return reportError&&error(expression,ts.Diagnostics.A_computed_property_name_of_the_form_0_must_be_of_type_symbol,ts.getTextOfNode(expression)),!1;var leftHandSide=expression.expression,leftHandSideSymbol=getResolvedSymbol(leftHandSide);if(!leftHandSideSymbol)return!1;var globalESSymbol=getGlobalESSymbolConstructorSymbol();return!!globalESSymbol&&(leftHandSideSymbol===globalESSymbol||(reportError&&error(leftHandSide,ts.Diagnostics.Symbol_reference_does_not_refer_to_the_global_Symbol_constructor_object),!1))}function resolveUntypedCall(node){return 173===node.kind?checkExpression(node.template):140!==node.kind&&ts.forEach(node.arguments,function(argument){checkExpression(argument)}),anySignature}function resolveErrorCall(node){return resolveUntypedCall(node),unknownSignature}function reorderCandidates(signatures,result){var lastParent,lastSymbol,index,spliceIndex,cutoffIndex=0,specializedIndex=-1;ts.Debug.assert(!result.length);for(var _i=0,signatures_2=signatures;_i<signatures_2.length;_i++){var signature=signatures_2[_i],symbol=signature.declaration&&getSymbolOfNode(signature.declaration),parent_6=signature.declaration&&signature.declaration.parent;lastSymbol&&symbol!==lastSymbol?(index=cutoffIndex=result.length,lastParent=parent_6):lastParent&&parent_6===lastParent?index++:(lastParent=parent_6,index=cutoffIndex),lastSymbol=symbol,signature.hasStringLiterals?(specializedIndex++,spliceIndex=specializedIndex,cutoffIndex++):spliceIndex=index,result.splice(spliceIndex,0,signature)}}function getSpreadArgumentIndex(args){for(var i=0;i<args.length;i++){var arg=args[i];if(arg&&188===arg.kind)return i}return-1}function hasCorrectArity(node,args,signature){var adjustedArgCount,typeArguments,callIsIncomplete,isDecorator,spreadArgIndex=-1;if(173===node.kind){var tagExpression=node;if(adjustedArgCount=args.length,typeArguments=void 0,186===tagExpression.template.kind){var templateExpression=tagExpression.template,lastSpan=ts.lastOrUndefined(templateExpression.templateSpans);ts.Debug.assert(void 0!==lastSpan),callIsIncomplete=ts.nodeIsMissing(lastSpan.literal)||!!lastSpan.literal.isUnterminated}else{var templateLiteral=tagExpression.template;ts.Debug.assert(11===templateLiteral.kind),callIsIncomplete=!!templateLiteral.isUnterminated}}else if(140===node.kind)isDecorator=!0,typeArguments=void 0,adjustedArgCount=getEffectiveArgumentCount(node,void 0,signature);else{var callExpression=node;if(!callExpression.arguments)return ts.Debug.assert(172===callExpression.kind),0===signature.minArgumentCount;adjustedArgCount=callExpression.arguments.hasTrailingComma?args.length+1:args.length,callIsIncomplete=callExpression.arguments.end===callExpression.end,typeArguments=callExpression.typeArguments,spreadArgIndex=getSpreadArgumentIndex(args)}var hasRightNumberOfTypeArgs=!typeArguments||signature.typeParameters&&typeArguments.length===signature.typeParameters.length;if(!hasRightNumberOfTypeArgs)return!1;if(spreadArgIndex>=0)return isRestParameterIndex(signature,spreadArgIndex);if(!signature.hasRestParameter&&adjustedArgCount>signature.parameters.length)return!1;var hasEnoughArguments=adjustedArgCount>=signature.minArgumentCount;return callIsIncomplete||hasEnoughArguments}function getSingleCallSignature(type){if(80896&type.flags){var resolved=resolveStructuredTypeMembers(type);if(1===resolved.callSignatures.length&&0===resolved.constructSignatures.length&&0===resolved.properties.length&&!resolved.stringIndexType&&!resolved.numberIndexType)return resolved.callSignatures[0]}}function instantiateSignatureInContextOf(signature,contextualSignature,contextualMapper){var context=createInferenceContext(signature.typeParameters,!0);return forEachMatchingParameterType(contextualSignature,signature,function(source,target){inferTypes(context,instantiateType(source,contextualMapper),target)}),getSignatureInstantiation(signature,getInferredTypes(context))}function inferTypeArguments(node,signature,args,excludeArgument,context){for(var typeParameters=signature.typeParameters,inferenceMapper=getInferenceMapper(context),i=0;i<typeParameters.length;i++)context.inferences[i].isFixed||(context.inferredTypes[i]=void 0);void 0===context.failedTypeParameterIndex||context.inferences[context.failedTypeParameterIndex].isFixed||(context.failedTypeParameterIndex=void 0);for(var argCount=getEffectiveArgumentCount(node,args,signature),i=0;i<argCount;i++){var arg=getEffectiveArgument(node,args,i);if(void 0===arg||190!==arg.kind){var paramType=getTypeAtPosition(signature,i),argType=getEffectiveArgumentType(node,i,arg);if(void 0===argType){var mapper=excludeArgument&&void 0!==excludeArgument[i]?identityMapper:inferenceMapper;argType=checkExpressionWithContextualType(arg,paramType,mapper)}inferTypes(context,argType,paramType)}}if(excludeArgument)for(var i=0;i<argCount;i++)if(excludeArgument[i]===!1){var arg=args[i],paramType=getTypeAtPosition(signature,i);inferTypes(context,checkExpressionWithContextualType(arg,paramType,inferenceMapper),paramType)}getInferredTypes(context)}function checkTypeArguments(signature,typeArgumentNodes,typeArgumentTypes,reportErrors,headMessage){for(var mapper,typeParameters=signature.typeParameters,typeArgumentsAreAssignable=!0,i=0;i<typeParameters.length;i++)if(typeArgumentsAreAssignable){var constraint=getConstraintOfTypeParameter(typeParameters[i]);if(constraint){var errorInfo=void 0,typeArgumentHeadMessage=ts.Diagnostics.Type_0_does_not_satisfy_the_constraint_1;reportErrors&&headMessage&&(errorInfo=ts.chainDiagnosticMessages(errorInfo,typeArgumentHeadMessage),typeArgumentHeadMessage=headMessage),mapper||(mapper=createTypeMapper(typeParameters,typeArgumentTypes));var typeArgument=typeArgumentTypes[i];typeArgumentsAreAssignable=checkTypeAssignableTo(typeArgument,getTypeWithThisArgument(instantiateType(constraint,mapper),typeArgument),reportErrors?typeArgumentNodes[i]:void 0,typeArgumentHeadMessage,errorInfo)}}return typeArgumentsAreAssignable}function checkApplicableSignature(node,args,signature,relation,excludeArgument,reportErrors){for(var argCount=getEffectiveArgumentCount(node,args,signature),i=0;i<argCount;i++){var arg=getEffectiveArgument(node,args,i);if(void 0===arg||190!==arg.kind){var paramType=getTypeAtPosition(signature,i),argType=getEffectiveArgumentType(node,i,arg);void 0===argType&&(argType=9!==arg.kind||reportErrors?checkExpressionWithContextualType(arg,paramType,excludeArgument&&excludeArgument[i]?identityMapper:void 0):getStringLiteralTypeForText(arg.text));var errorNode=reportErrors?getEffectiveArgumentErrorNode(node,i,arg):void 0,headMessage=ts.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1;if(!checkTypeRelatedTo(argType,paramType,relation,errorNode,headMessage))return!1}}return!0}function getEffectiveCallArguments(node){var args;if(173===node.kind){var template=node.template;args=[void 0],186===template.kind&&ts.forEach(template.templateSpans,function(span){args.push(span.expression)})}else{if(140===node.kind)return;args=node.arguments||emptyArray}return args}function getEffectiveArgumentCount(node,args,signature){if(140!==node.kind)return args.length;switch(node.parent.kind){case 217:case 189:return 1;case 142:return 2;case 144:case 146:case 147:return 0===languageVersion?2:signature.parameters.length>=3?3:2;case 139:return 3}}function getEffectiveDecoratorFirstArgumentType(node){if(217===node.kind){var classSymbol=getSymbolOfNode(node);return getTypeOfSymbol(classSymbol)}if(139===node.kind&&(node=node.parent,145===node.kind)){var classSymbol=getSymbolOfNode(node);return getTypeOfSymbol(classSymbol)}return 142===node.kind||144===node.kind||146===node.kind||147===node.kind?getParentTypeOfClassElement(node):(ts.Debug.fail("Unsupported decorator target."),unknownType)}function getEffectiveDecoratorSecondArgumentType(node){if(217===node.kind)return ts.Debug.fail("Class decorators should not have a second synthetic argument."),unknownType;if(139===node.kind&&(node=node.parent,145===node.kind))return anyType;if(142===node.kind||144===node.kind||146===node.kind||147===node.kind){var element=node;switch(element.name.kind){case 69:case 8:case 9:return getStringLiteralTypeForText(element.name.text);case 137:var nameType=checkComputedPropertyName(element.name);return allConstituentTypesHaveKind(nameType,16777216)?nameType:stringType;default:return ts.Debug.fail("Unsupported property name."),unknownType}}return ts.Debug.fail("Unsupported decorator target."),unknownType}function getEffectiveDecoratorThirdArgumentType(node){if(217===node.kind)return ts.Debug.fail("Class decorators should not have a third synthetic argument."),unknownType;if(139===node.kind)return numberType;if(142===node.kind)return ts.Debug.fail("Property decorators should not have a third synthetic argument."),unknownType;if(144===node.kind||146===node.kind||147===node.kind){var propertyType=getTypeOfNode(node);return createTypedPropertyDescriptorType(propertyType)}return ts.Debug.fail("Unsupported decorator target."),unknownType}function getEffectiveDecoratorArgumentType(node,argIndex){return 0===argIndex?getEffectiveDecoratorFirstArgumentType(node.parent):1===argIndex?getEffectiveDecoratorSecondArgumentType(node.parent):2===argIndex?getEffectiveDecoratorThirdArgumentType(node.parent):(ts.Debug.fail("Decorators should not have a fourth synthetic argument."),unknownType)}function getEffectiveArgumentType(node,argIndex,arg){return 140===node.kind?getEffectiveDecoratorArgumentType(node,argIndex):0===argIndex&&173===node.kind?globalTemplateStringsArrayType:void 0}function getEffectiveArgument(node,args,argIndex){if(140!==node.kind&&(0!==argIndex||173!==node.kind))return args[argIndex]}function getEffectiveArgumentErrorNode(node,argIndex,arg){return 140===node.kind?node.expression:0===argIndex&&173===node.kind?node.template:arg}function resolveCall(node,signatures,candidatesOutArray,headMessage){function reportError(message,arg0,arg1,arg2){var errorInfo;errorInfo=ts.chainDiagnosticMessages(errorInfo,message,arg0,arg1,arg2),headMessage&&(errorInfo=ts.chainDiagnosticMessages(errorInfo,headMessage)),diagnostics.add(ts.createDiagnosticForNodeFromMessageChain(node,errorInfo))}function chooseOverload(candidates,relation){for(var _i=0,candidates_2=candidates;_i<candidates_2.length;_i++){var originalCandidate=candidates_2[_i];if(hasCorrectArity(node,args,originalCandidate)){for(var candidate=void 0,typeArgumentsAreValid=void 0,inferenceContext=originalCandidate.typeParameters?createInferenceContext(originalCandidate.typeParameters,!1):void 0;;){if(candidate=originalCandidate,candidate.typeParameters){var typeArgumentTypes=void 0;if(typeArguments?(typeArgumentTypes=ts.map(typeArguments,getTypeFromTypeNode),typeArgumentsAreValid=checkTypeArguments(candidate,typeArguments,typeArgumentTypes,!1)):(inferTypeArguments(node,candidate,args,excludeArgument,inferenceContext),typeArgumentsAreValid=void 0===inferenceContext.failedTypeParameterIndex,typeArgumentTypes=inferenceContext.inferredTypes),!typeArgumentsAreValid)break;candidate=getSignatureInstantiation(candidate,typeArgumentTypes)}if(!checkApplicableSignature(node,args,candidate,relation,excludeArgument,!1))break;var index=excludeArgument?ts.indexOf(excludeArgument,!0):-1;if(index<0)return candidate;excludeArgument[index]=!1}if(originalCandidate.typeParameters){var instantiatedCandidate=candidate;typeArgumentsAreValid?candidateForArgumentError=instantiatedCandidate:(candidateForTypeArgumentError=originalCandidate,typeArguments||(resultOfFailedInference=inferenceContext))}else ts.Debug.assert(originalCandidate===candidate),candidateForArgumentError=originalCandidate}}}var typeArguments,isTaggedTemplate=173===node.kind,isDecorator=140===node.kind;isTaggedTemplate||isDecorator||(typeArguments=node.typeArguments,95!==node.expression.kind&&ts.forEach(typeArguments,checkSourceElement));var candidates=candidatesOutArray||[];if(reorderCandidates(signatures,candidates),!candidates.length)return reportError(ts.Diagnostics.Supplied_parameters_do_not_match_any_signature_of_call_target),resolveErrorCall(node);var excludeArgument,args=getEffectiveCallArguments(node);if(!isDecorator)for(var i=isTaggedTemplate?1:0;i<args.length;i++)isContextSensitive(args[i])&&(excludeArgument||(excludeArgument=new Array(args.length)),excludeArgument[i]=!0);var candidateForArgumentError,candidateForTypeArgumentError,resultOfFailedInference,result;if(candidates.length>1&&(result=chooseOverload(candidates,subtypeRelation)),result||(candidateForArgumentError=void 0,candidateForTypeArgumentError=void 0,resultOfFailedInference=void 0,result=chooseOverload(candidates,assignableRelation)),result)return result;if(candidateForArgumentError)checkApplicableSignature(node,args,candidateForArgumentError,assignableRelation,void 0,!0);else if(candidateForTypeArgumentError)if(isTaggedTemplate||isDecorator||!typeArguments){ts.Debug.assert(resultOfFailedInference.failedTypeParameterIndex>=0);var failedTypeParameter=candidateForTypeArgumentError.typeParameters[resultOfFailedInference.failedTypeParameterIndex],inferenceCandidates=getInferenceCandidates(resultOfFailedInference,resultOfFailedInference.failedTypeParameterIndex),diagnosticChainHead=ts.chainDiagnosticMessages(void 0,ts.Diagnostics.The_type_argument_for_type_parameter_0_cannot_be_inferred_from_the_usage_Consider_specifying_the_type_arguments_explicitly,typeToString(failedTypeParameter));headMessage&&(diagnosticChainHead=ts.chainDiagnosticMessages(diagnosticChainHead,headMessage)),reportNoCommonSupertypeError(inferenceCandidates,node.expression||node.tag,diagnosticChainHead)}else{var typeArguments_2=node.typeArguments;checkTypeArguments(candidateForTypeArgumentError,typeArguments_2,ts.map(typeArguments_2,getTypeFromTypeNode),!0,headMessage)}else reportError(ts.Diagnostics.Supplied_parameters_do_not_match_any_signature_of_call_target);if(!produceDiagnostics)for(var _i=0,candidates_1=candidates;_i<candidates_1.length;_i++){var candidate=candidates_1[_i];if(hasCorrectArity(node,args,candidate))return candidate.typeParameters&&typeArguments&&(candidate=getSignatureInstantiation(candidate,ts.map(typeArguments,getTypeFromTypeNode))),candidate}return resolveErrorCall(node)}function resolveCallExpression(node,candidatesOutArray){if(95===node.expression.kind){var superType=checkSuperExpression(node.expression);if(superType!==unknownType){var baseTypeNode=ts.getClassExtendsHeritageClauseElement(ts.getContainingClass(node)),baseConstructors=getInstantiatedConstructorsForTypeArguments(superType,baseTypeNode.typeArguments);return resolveCall(node,baseConstructors,candidatesOutArray)}return resolveUntypedCall(node)}var funcType=checkExpression(node.expression),apparentType=getApparentType(funcType);if(apparentType===unknownType)return resolveErrorCall(node);var callSignatures=getSignaturesOfType(apparentType,0),constructSignatures=getSignaturesOfType(apparentType,1);return isTypeAny(funcType)||!(callSignatures.length||constructSignatures.length||16384&funcType.flags)&&isTypeAssignableTo(funcType,globalFunctionType)?(funcType!==unknownType&&node.typeArguments&&error(node,ts.Diagnostics.Untyped_function_calls_may_not_accept_type_arguments),resolveUntypedCall(node)):callSignatures.length?resolveCall(node,callSignatures,candidatesOutArray):(constructSignatures.length?error(node,ts.Diagnostics.Value_of_type_0_is_not_callable_Did_you_mean_to_include_new,typeToString(funcType)):error(node,ts.Diagnostics.Cannot_invoke_an_expression_whose_type_lacks_a_call_signature),resolveErrorCall(node))}function resolveNewExpression(node,candidatesOutArray){if(node.arguments&&languageVersion<1){var spreadIndex=getSpreadArgumentIndex(node.arguments);spreadIndex>=0&&error(node.arguments[spreadIndex],ts.Diagnostics.Spread_operator_in_new_expressions_is_only_available_when_targeting_ECMAScript_5_and_higher)}var expressionType=checkExpression(node.expression);if(expressionType=getApparentType(expressionType),expressionType===unknownType)return resolveErrorCall(node);var valueDecl=expressionType.symbol&&getClassLikeDeclarationOfSymbol(expressionType.symbol);if(valueDecl&&128&valueDecl.flags)return error(node,ts.Diagnostics.Cannot_create_an_instance_of_the_abstract_class_0,ts.declarationNameToString(valueDecl.name)),resolveErrorCall(node);if(isTypeAny(expressionType))return node.typeArguments&&error(node,ts.Diagnostics.Untyped_function_calls_may_not_accept_type_arguments),resolveUntypedCall(node);var constructSignatures=getSignaturesOfType(expressionType,1);if(constructSignatures.length)return resolveCall(node,constructSignatures,candidatesOutArray);var callSignatures=getSignaturesOfType(expressionType,0);if(callSignatures.length){var signature=resolveCall(node,callSignatures,candidatesOutArray);return getReturnTypeOfSignature(signature)!==voidType&&error(node,ts.Diagnostics.Only_a_void_function_can_be_called_with_the_new_keyword),signature}return error(node,ts.Diagnostics.Cannot_use_new_with_an_expression_whose_type_lacks_a_call_or_construct_signature),resolveErrorCall(node)}function resolveTaggedTemplateExpression(node,candidatesOutArray){var tagType=checkExpression(node.tag),apparentType=getApparentType(tagType);if(apparentType===unknownType)return resolveErrorCall(node);var callSignatures=getSignaturesOfType(apparentType,0);return isTypeAny(tagType)||!callSignatures.length&&!(16384&tagType.flags)&&isTypeAssignableTo(tagType,globalFunctionType)?resolveUntypedCall(node):callSignatures.length?resolveCall(node,callSignatures,candidatesOutArray):(error(node,ts.Diagnostics.Cannot_invoke_an_expression_whose_type_lacks_a_call_signature),resolveErrorCall(node))}function getDiagnosticHeadMessageForDecoratorResolution(node){switch(node.parent.kind){case 217:case 189:return ts.Diagnostics.Unable_to_resolve_signature_of_class_decorator_when_called_as_an_expression;case 139:return ts.Diagnostics.Unable_to_resolve_signature_of_parameter_decorator_when_called_as_an_expression;case 142:return ts.Diagnostics.Unable_to_resolve_signature_of_property_decorator_when_called_as_an_expression;case 144:case 146:case 147:return ts.Diagnostics.Unable_to_resolve_signature_of_method_decorator_when_called_as_an_expression}}function resolveDecorator(node,candidatesOutArray){var funcType=checkExpression(node.expression),apparentType=getApparentType(funcType);if(apparentType===unknownType)return resolveErrorCall(node);var callSignatures=getSignaturesOfType(apparentType,0);if(funcType===anyType||!callSignatures.length&&!(16384&funcType.flags)&&isTypeAssignableTo(funcType,globalFunctionType))return resolveUntypedCall(node);var headMessage=getDiagnosticHeadMessageForDecoratorResolution(node);if(!callSignatures.length){var errorInfo=void 0;return errorInfo=ts.chainDiagnosticMessages(errorInfo,ts.Diagnostics.Cannot_invoke_an_expression_whose_type_lacks_a_call_signature),errorInfo=ts.chainDiagnosticMessages(errorInfo,headMessage),diagnostics.add(ts.createDiagnosticForNodeFromMessageChain(node,errorInfo)),resolveErrorCall(node)}return resolveCall(node,callSignatures,candidatesOutArray,headMessage)}function getResolvedSignature(node,candidatesOutArray){var links=getNodeLinks(node);return links.resolvedSignature&&!candidatesOutArray||(links.resolvedSignature=anySignature,171===node.kind?links.resolvedSignature=resolveCallExpression(node,candidatesOutArray):172===node.kind?links.resolvedSignature=resolveNewExpression(node,candidatesOutArray):173===node.kind?links.resolvedSignature=resolveTaggedTemplateExpression(node,candidatesOutArray):140===node.kind?links.resolvedSignature=resolveDecorator(node,candidatesOutArray):ts.Debug.fail("Branch in 'getResolvedSignature' should be unreachable.")),links.resolvedSignature}function getInferredClassType(symbol){var links=getSymbolLinks(symbol);return links.inferredClassType||(links.inferredClassType=createAnonymousType(void 0,symbol.members,emptyArray,emptyArray,void 0,void 0)),links.inferredClassType}function checkCallExpression(node){checkGrammarTypeArguments(node,node.typeArguments)||checkGrammarArguments(node,node.arguments);var signature=getResolvedSignature(node);if(95===node.expression.kind)return voidType;if(172===node.kind){var declaration=signature.declaration;if(declaration&&145!==declaration.kind&&149!==declaration.kind&&154!==declaration.kind&&!ts.isJSDocConstructSignature(declaration)){var funcSymbol=checkExpression(node.expression).symbol;return funcSymbol&&funcSymbol.members&&16&funcSymbol.flags?getInferredClassType(funcSymbol):(compilerOptions.noImplicitAny&&error(node,ts.Diagnostics.new_expression_whose_target_lacks_a_construct_signature_implicitly_has_an_any_type),anyType)}}return ts.isInJavaScriptFile(node)&&ts.isRequireCall(node,!0)?resolveExternalModuleTypeByLiteral(node.arguments[0]):getReturnTypeOfSignature(signature)}function checkTaggedTemplateExpression(node){return getReturnTypeOfSignature(getResolvedSignature(node))}function checkAssertion(node){var exprType=getRegularTypeOfObjectLiteral(checkExpression(node.expression)),targetType=getTypeFromTypeNode(node.type);if(produceDiagnostics&&targetType!==unknownType){var widenedType=getWidenedType(exprType),bothAreStringLike=someConstituentTypeHasKind(targetType,258)&&someConstituentTypeHasKind(widenedType,258);bothAreStringLike||isTypeAssignableTo(targetType,widenedType)||checkTypeAssignableTo(exprType,targetType,node,ts.Diagnostics.Neither_type_0_nor_type_1_is_assignable_to_the_other)}return targetType}function getTypeAtPosition(signature,pos){return signature.hasRestParameter?pos<signature.parameters.length-1?getTypeOfSymbol(signature.parameters[pos]):getRestTypeOfSignature(signature):pos<signature.parameters.length?getTypeOfSymbol(signature.parameters[pos]):anyType}function assignContextualParameterTypes(signature,context,mapper){for(var len=signature.parameters.length-(signature.hasRestParameter?1:0),i=0;i<len;i++){var parameter=signature.parameters[i],contextualParameterType=getTypeAtPosition(context,i);assignTypeToParameterAndFixTypeParameters(parameter,contextualParameterType,mapper)}if(signature.hasRestParameter&&isRestParameterIndex(context,signature.parameters.length-1)){var parameter=ts.lastOrUndefined(signature.parameters),contextualParameterType=getTypeOfSymbol(ts.lastOrUndefined(context.parameters));assignTypeToParameterAndFixTypeParameters(parameter,contextualParameterType,mapper)}}function assignBindingElementTypes(node){if(ts.isBindingPattern(node.name))for(var _i=0,_a=node.name.elements;_i<_a.length;_i++){var element=_a[_i];190!==element.kind&&(69===element.name.kind&&(getSymbolLinks(getSymbolOfNode(element)).type=getTypeForBindingElement(element)),assignBindingElementTypes(element))}}function assignTypeToParameterAndFixTypeParameters(parameter,contextualType,mapper){var links=getSymbolLinks(parameter);links.type?isInferentialContext(mapper)&&inferTypes(mapper.context,links.type,instantiateType(contextualType,mapper)):(links.type=instantiateType(contextualType,mapper),assignBindingElementTypes(parameter.valueDeclaration))}function getReturnTypeFromJSDocComment(func){var returnTag=ts.getJSDocReturnTag(func);if(returnTag&&returnTag.typeExpression)return getTypeFromTypeNode(returnTag.typeExpression.type)}function createPromiseType(promisedType){var globalPromiseType=getGlobalPromiseType();return globalPromiseType!==emptyGenericType?(promisedType=getAwaitedType(promisedType),createTypeReference(globalPromiseType,[promisedType])):emptyObjectType}function getReturnTypeFromBody(func,contextualMapper){var contextualSignature=getContextualSignatureForFunctionLikeDeclaration(func);if(!func.body)return unknownType;var type,isAsync=ts.isAsyncFunctionLike(func);if(195!==func.body.kind)type=checkExpressionCached(func.body,contextualMapper),isAsync&&(type=checkAwaitedType(type,func,ts.Diagnostics.Return_expression_in_async_function_does_not_have_a_valid_callable_then_member));else{var types=void 0,funcIsGenerator=!!func.asteriskToken;if(funcIsGenerator){if(types=checkAndAggregateYieldOperandTypes(func.body,contextualMapper),0===types.length){var iterableIteratorAny=createIterableIteratorType(anyType);return compilerOptions.noImplicitAny&&error(func.asteriskToken,ts.Diagnostics.Generator_implicitly_has_type_0_because_it_does_not_yield_any_values_Consider_supplying_a_return_type,typeToString(iterableIteratorAny)),iterableIteratorAny}}else if(types=checkAndAggregateReturnExpressionTypes(func.body,contextualMapper,isAsync),0===types.length){if(isAsync){var promiseType=createPromiseType(voidType);return promiseType===emptyObjectType?(error(func,ts.Diagnostics.An_async_function_or_method_must_have_a_valid_awaitable_return_type),unknownType):promiseType}return voidType}if(type=contextualSignature?getUnionType(types):getCommonSupertype(types),!type)return funcIsGenerator?(error(func,ts.Diagnostics.No_best_common_type_exists_among_yield_expressions),createIterableIteratorType(unknownType)):(error(func,ts.Diagnostics.No_best_common_type_exists_among_return_expressions),getUnionType(types));funcIsGenerator&&(type=createIterableIteratorType(type))}contextualSignature||reportErrorsFromWidening(func,type);var widenedType=getWidenedType(type);if(isAsync){var promiseType=createPromiseType(widenedType);return promiseType===emptyObjectType?(error(func,ts.Diagnostics.An_async_function_or_method_must_have_a_valid_awaitable_return_type),unknownType):promiseType}return widenedType}function checkAndAggregateYieldOperandTypes(body,contextualMapper){var aggregatedTypes=[];return ts.forEachYieldExpression(body,function(yieldExpression){var expr=yieldExpression.expression;if(expr){var type=checkExpressionCached(expr,contextualMapper);yieldExpression.asteriskToken&&(type=checkElementTypeOfIterable(type,yieldExpression.expression)),ts.contains(aggregatedTypes,type)||aggregatedTypes.push(type)}}),aggregatedTypes}function checkAndAggregateReturnExpressionTypes(body,contextualMapper,isAsync){var aggregatedTypes=[];return ts.forEachReturnStatement(body,function(returnStatement){var expr=returnStatement.expression;if(expr){var type=checkExpressionCached(expr,contextualMapper);isAsync&&(type=checkAwaitedType(type,body.parent,ts.Diagnostics.Return_expression_in_async_function_does_not_have_a_valid_callable_then_member)),ts.contains(aggregatedTypes,type)||aggregatedTypes.push(type)}}),aggregatedTypes}function checkAllCodePathsInNonVoidFunctionReturnOrThrow(func,returnType){if(produceDiagnostics&&!(returnType===voidType||isTypeAny(returnType)||returnType&&16384&returnType.flags&&someConstituentTypeHasKind(returnType,17))&&!ts.nodeIsMissing(func.body)&&195===func.body.kind&&524288&func.flags){var hasExplicitReturn=1048576&func.flags;if(returnType&&!hasExplicitReturn)error(func.type,ts.Diagnostics.A_function_whose_declared_type_is_neither_void_nor_any_must_return_a_value);else if(compilerOptions.noImplicitReturns){if(!returnType){var inferredReturnType=hasExplicitReturn?getReturnTypeOfSignature(getSignatureFromDeclaration(func)):voidType;if(inferredReturnType===voidType||isTypeAny(inferredReturnType))return}error(func.type||func,ts.Diagnostics.Not_all_code_paths_return_a_value)}}}function checkFunctionExpressionOrObjectLiteralMethod(node,contextualMapper){ts.Debug.assert(144!==node.kind||ts.isObjectLiteralMethod(node));var hasGrammarError=checkGrammarFunctionLikeDeclaration(node);if(hasGrammarError||176!==node.kind||checkGrammarForGenerator(node),contextualMapper===identityMapper&&isContextSensitive(node))return checkNodeDeferred(node),anyFunctionType;var links=getNodeLinks(node),type=getTypeOfSymbol(node.symbol),contextSensitive=isContextSensitive(node),mightFixTypeParameters=contextSensitive&&isInferentialContext(contextualMapper);if(mightFixTypeParameters||!(1024&links.flags)){var contextualSignature=getContextualSignature(node),contextChecked=!!(1024&links.flags);if(mightFixTypeParameters||!contextChecked){if(links.flags|=1024,contextualSignature){var signature=getSignaturesOfType(type,0)[0];if(contextSensitive&&assignContextualParameterTypes(signature,contextualSignature,contextualMapper||identityMapper),mightFixTypeParameters||!node.type&&!signature.resolvedReturnType){var returnType=getReturnTypeFromBody(node,contextualMapper);signature.resolvedReturnType||(signature.resolvedReturnType=returnType)}}contextChecked||(checkSignatureDeclaration(node),checkNodeDeferred(node))}}return produceDiagnostics&&144!==node.kind&&143!==node.kind&&(checkCollisionWithCapturedSuperVariable(node,node.name),checkCollisionWithCapturedThisVariable(node,node.name)),
type}function checkFunctionExpressionOrObjectLiteralMethodDeferred(node){ts.Debug.assert(144!==node.kind||ts.isObjectLiteralMethod(node));var isAsync=ts.isAsyncFunctionLike(node),returnOrPromisedType=node.type&&(isAsync?checkAsyncFunctionReturnType(node):getTypeFromTypeNode(node.type));if(node.asteriskToken||checkAllCodePathsInNonVoidFunctionReturnOrThrow(node,returnOrPromisedType),node.body)if(node.type||getReturnTypeOfSignature(getSignatureFromDeclaration(node)),195===node.body.kind)checkSourceElement(node.body);else{var exprType=checkExpression(node.body);if(returnOrPromisedType)if(isAsync){var awaitedType=checkAwaitedType(exprType,node.body,ts.Diagnostics.Expression_body_for_async_arrow_function_does_not_have_a_valid_callable_then_member);checkTypeAssignableTo(awaitedType,returnOrPromisedType,node.body)}else checkTypeAssignableTo(exprType,returnOrPromisedType,node.body)}}function checkArithmeticOperandType(operand,type,diagnostic){return!!isTypeAnyOrAllConstituentTypesHaveKind(type,132)||(error(operand,diagnostic),!1)}function checkReferenceExpression(n,invalidReferenceMessage,constantVariableMessage){function findSymbol(n){var symbol=getNodeLinks(n).resolvedSymbol;return symbol&&getExportSymbolOfValueSymbolIfExported(symbol)}function isReferenceOrErrorExpression(n){switch(n.kind){case 69:var symbol=findSymbol(n);return!symbol||symbol===unknownSymbol||symbol===argumentsSymbol||0!==(3&symbol.flags);case 169:var symbol=findSymbol(n);return!symbol||symbol===unknownSymbol||0!==(symbol.flags&-9);case 170:return!0;case 175:return isReferenceOrErrorExpression(n.expression);default:return!1}}function isConstVariableReference(n){switch(n.kind){case 69:case 169:var symbol=findSymbol(n);return symbol&&0!==(3&symbol.flags)&&0!==(16384&getDeclarationFlagsFromSymbol(symbol));case 170:var index=n.argumentExpression,symbol=findSymbol(n.expression);if(symbol&&index&&9===index.kind){var name_12=index.text,prop=getPropertyOfType(getTypeOfSymbol(symbol),name_12);return prop&&0!==(3&prop.flags)&&0!==(16384&getDeclarationFlagsFromSymbol(prop))}return!1;case 175:return isConstVariableReference(n.expression);default:return!1}}return isReferenceOrErrorExpression(n)?!isConstVariableReference(n)||(error(n,constantVariableMessage),!1):(error(n,invalidReferenceMessage),!1)}function checkDeleteExpression(node){return checkExpression(node.expression),booleanType}function checkTypeOfExpression(node){return checkExpression(node.expression),stringType}function checkVoidExpression(node){return checkExpression(node.expression),undefinedType}function checkAwaitExpression(node){produceDiagnostics&&(8&node.parserContextFlags||grammarErrorOnFirstToken(node,ts.Diagnostics.await_expression_is_only_allowed_within_an_async_function),isInParameterInitializerBeforeContainingFunction(node)&&error(node,ts.Diagnostics.await_expressions_cannot_be_used_in_a_parameter_initializer));var operandType=checkExpression(node.expression);return checkAwaitedType(operandType,node)}function checkPrefixUnaryExpression(node){var operandType=checkExpression(node.operand);switch(node.operator){case 35:case 36:case 50:return someConstituentTypeHasKind(operandType,16777216)&&error(node.operand,ts.Diagnostics.The_0_operator_cannot_be_applied_to_type_symbol,ts.tokenToString(node.operator)),numberType;case 49:return booleanType;case 41:case 42:var ok=checkArithmeticOperandType(node.operand,operandType,ts.Diagnostics.An_arithmetic_operand_must_be_of_type_any_number_or_an_enum_type);return ok&&checkReferenceExpression(node.operand,ts.Diagnostics.The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_property_or_indexer,ts.Diagnostics.The_operand_of_an_increment_or_decrement_operator_cannot_be_a_constant),numberType}return unknownType}function checkPostfixUnaryExpression(node){var operandType=checkExpression(node.operand),ok=checkArithmeticOperandType(node.operand,operandType,ts.Diagnostics.An_arithmetic_operand_must_be_of_type_any_number_or_an_enum_type);return ok&&checkReferenceExpression(node.operand,ts.Diagnostics.The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_property_or_indexer,ts.Diagnostics.The_operand_of_an_increment_or_decrement_operator_cannot_be_a_constant),numberType}function someConstituentTypeHasKind(type,kind){if(type.flags&kind)return!0;if(49152&type.flags){for(var types=type.types,_i=0,types_10=types;_i<types_10.length;_i++){var current=types_10[_i];if(current.flags&kind)return!0}return!1}return!1}function allConstituentTypesHaveKind(type,kind){if(type.flags&kind)return!0;if(49152&type.flags){for(var types=type.types,_i=0,types_11=types;_i<types_11.length;_i++){var current=types_11[_i];if(!(current.flags&kind))return!1}return!0}return!1}function isConstEnumObjectType(type){return 80896&type.flags&&type.symbol&&isConstEnumSymbol(type.symbol)}function isConstEnumSymbol(symbol){return 0!==(128&symbol.flags)}function checkInstanceOfExpression(left,right,leftType,rightType){return allConstituentTypesHaveKind(leftType,16777726)&&error(left,ts.Diagnostics.The_left_hand_side_of_an_instanceof_expression_must_be_of_type_any_an_object_type_or_a_type_parameter),isTypeAny(rightType)||isTypeSubtypeOf(rightType,globalFunctionType)||error(right,ts.Diagnostics.The_right_hand_side_of_an_instanceof_expression_must_be_of_type_any_or_of_a_type_assignable_to_the_Function_interface_type),booleanType}function checkInExpression(left,right,leftType,rightType){return isTypeAnyOrAllConstituentTypesHaveKind(leftType,16777606)||error(left,ts.Diagnostics.The_left_hand_side_of_an_in_expression_must_be_of_type_any_string_number_or_symbol),isTypeAnyOrAllConstituentTypesHaveKind(rightType,81408)||error(right,ts.Diagnostics.The_right_hand_side_of_an_in_expression_must_be_of_type_any_an_object_type_or_a_type_parameter),booleanType}function checkObjectLiteralAssignment(node,sourceType,contextualMapper){for(var properties=node.properties,_i=0,properties_3=properties;_i<properties_3.length;_i++){var p=properties_3[_i];if(248===p.kind||249===p.kind){var name_13=p.name;if(137===name_13.kind&&checkComputedPropertyName(name_13),isComputedNonLiteralName(name_13))continue;var text=getTextOfPropertyName(name_13),type=isTypeAny(sourceType)?sourceType:getTypeOfPropertyOfType(sourceType,text)||isNumericLiteralName(text)&&getIndexTypeOfType(sourceType,1)||getIndexTypeOfType(sourceType,0);type?249===p.kind?checkDestructuringAssignment(p,type):checkDestructuringAssignment(p.initializer,type):error(name_13,ts.Diagnostics.Type_0_has_no_property_1_and_no_string_index_signature,typeToString(sourceType),ts.declarationNameToString(name_13))}else error(p,ts.Diagnostics.Property_assignment_expected)}return sourceType}function checkArrayLiteralAssignment(node,sourceType,contextualMapper){for(var elementType=checkIteratedTypeOrElementType(sourceType,node,!1)||unknownType,elements=node.elements,i=0;i<elements.length;i++){var e=elements[i];if(190!==e.kind)if(188!==e.kind){var propName=""+i,type=isTypeAny(sourceType)?sourceType:isTupleLikeType(sourceType)?getTypeOfPropertyOfType(sourceType,propName):elementType;type?checkDestructuringAssignment(e,type,contextualMapper):isTupleType(sourceType)?error(e,ts.Diagnostics.Tuple_type_0_with_length_1_cannot_be_assigned_to_tuple_with_length_2,typeToString(sourceType),sourceType.elementTypes.length,elements.length):error(e,ts.Diagnostics.Type_0_has_no_property_1,typeToString(sourceType),propName)}else if(i<elements.length-1)error(e,ts.Diagnostics.A_rest_element_must_be_last_in_an_array_destructuring_pattern);else{var restExpression=e.expression;184===restExpression.kind&&56===restExpression.operatorToken.kind?error(restExpression.operatorToken,ts.Diagnostics.A_rest_element_cannot_have_an_initializer):checkDestructuringAssignment(restExpression,createArrayType(elementType),contextualMapper)}}return sourceType}function checkDestructuringAssignment(exprOrAssignment,sourceType,contextualMapper){var target;if(249===exprOrAssignment.kind){var prop=exprOrAssignment;prop.objectAssignmentInitializer&&checkBinaryLikeExpression(prop.name,prop.equalsToken,prop.objectAssignmentInitializer,contextualMapper),target=exprOrAssignment.name}else target=exprOrAssignment;return 184===target.kind&&56===target.operatorToken.kind&&(checkBinaryExpression(target,contextualMapper),target=target.left),168===target.kind?checkObjectLiteralAssignment(target,sourceType,contextualMapper):167===target.kind?checkArrayLiteralAssignment(target,sourceType,contextualMapper):checkReferenceAssignment(target,sourceType,contextualMapper)}function checkReferenceAssignment(target,sourceType,contextualMapper){var targetType=checkExpression(target,contextualMapper);return checkReferenceExpression(target,ts.Diagnostics.Invalid_left_hand_side_of_assignment_expression,ts.Diagnostics.Left_hand_side_of_assignment_expression_cannot_be_a_constant)&&checkTypeAssignableTo(sourceType,targetType,target,void 0),sourceType}function checkBinaryExpression(node,contextualMapper){return checkBinaryLikeExpression(node.left,node.operatorToken,node.right,contextualMapper,node)}function checkBinaryLikeExpression(left,operatorToken,right,contextualMapper,errorNode){function checkForDisallowedESSymbolOperand(operator){var offendingSymbolOperand=someConstituentTypeHasKind(leftType,16777216)?left:someConstituentTypeHasKind(rightType,16777216)?right:void 0;return!offendingSymbolOperand||(error(offendingSymbolOperand,ts.Diagnostics.The_0_operator_cannot_be_applied_to_type_symbol,ts.tokenToString(operator)),!1)}function getSuggestedBooleanOperator(operator){switch(operator){case 47:case 67:return 52;case 48:case 68:return 33;case 46:case 66:return 51;default:return}}function checkAssignmentOperator(valueType){if(produceDiagnostics&&operator>=56&&operator<=68){var ok=checkReferenceExpression(left,ts.Diagnostics.Invalid_left_hand_side_of_assignment_expression,ts.Diagnostics.Left_hand_side_of_assignment_expression_cannot_be_a_constant);ok&&checkTypeAssignableTo(valueType,leftType,left,void 0)}}function reportOperatorError(){error(errorNode||operatorToken,ts.Diagnostics.Operator_0_cannot_be_applied_to_types_1_and_2,ts.tokenToString(operatorToken.kind),typeToString(leftType),typeToString(rightType))}var operator=operatorToken.kind;if(56===operator&&(168===left.kind||167===left.kind))return checkDestructuringAssignment(left,checkExpression(right,contextualMapper),contextualMapper);var leftType=checkExpression(left,contextualMapper),rightType=checkExpression(right,contextualMapper);switch(operator){case 37:case 38:case 59:case 60:case 39:case 61:case 40:case 62:case 36:case 58:case 43:case 63:case 44:case 64:case 45:case 65:case 47:case 67:case 48:case 68:case 46:case 66:96&leftType.flags&&(leftType=rightType),96&rightType.flags&&(rightType=leftType);var suggestedOperator=void 0;if(8&leftType.flags&&8&rightType.flags&&void 0!==(suggestedOperator=getSuggestedBooleanOperator(operatorToken.kind)))error(errorNode||operatorToken,ts.Diagnostics.The_0_operator_is_not_allowed_for_boolean_types_Consider_using_1_instead,ts.tokenToString(operatorToken.kind),ts.tokenToString(suggestedOperator));else{var leftOk=checkArithmeticOperandType(left,leftType,ts.Diagnostics.The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_or_an_enum_type),rightOk=checkArithmeticOperandType(right,rightType,ts.Diagnostics.The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_or_an_enum_type);leftOk&&rightOk&&checkAssignmentOperator(numberType)}return numberType;case 35:case 57:96&leftType.flags&&(leftType=rightType),96&rightType.flags&&(rightType=leftType);var resultType=void 0;if(allConstituentTypesHaveKind(leftType,132)&&allConstituentTypesHaveKind(rightType,132))resultType=numberType;else if(allConstituentTypesHaveKind(leftType,258)||allConstituentTypesHaveKind(rightType,258)?resultType=stringType:(isTypeAny(leftType)||isTypeAny(rightType))&&(resultType=leftType===unknownType||rightType===unknownType?unknownType:anyType),resultType&&!checkForDisallowedESSymbolOperand(operator))return resultType;return resultType?(57===operator&&checkAssignmentOperator(resultType),resultType):(reportOperatorError(),anyType);case 25:case 27:case 28:case 29:if(!checkForDisallowedESSymbolOperand(operator))return booleanType;case 30:case 31:case 32:case 33:return someConstituentTypeHasKind(leftType,258)&&someConstituentTypeHasKind(rightType,258)?booleanType:(isTypeAssignableTo(leftType,rightType)||isTypeAssignableTo(rightType,leftType)||reportOperatorError(),booleanType);case 91:return checkInstanceOfExpression(left,right,leftType,rightType);case 90:return checkInExpression(left,right,leftType,rightType);case 51:return rightType;case 52:return getUnionType([leftType,rightType]);case 56:return checkAssignmentOperator(rightType),getRegularTypeOfObjectLiteral(rightType);case 24:return rightType}}function isYieldExpressionInClass(node){for(var current=node,parent=node.parent;parent;){if(ts.isFunctionLike(parent)&&current===parent.body)return!1;if(ts.isClassLike(current))return!0;current=parent,parent=parent.parent}return!1}function checkYieldExpression(node){if(produceDiagnostics&&(2&node.parserContextFlags&&!isYieldExpressionInClass(node)||grammarErrorOnFirstToken(node,ts.Diagnostics.A_yield_expression_is_only_allowed_in_a_generator_body),isInParameterInitializerBeforeContainingFunction(node)&&error(node,ts.Diagnostics.yield_expressions_cannot_be_used_in_a_parameter_initializer)),node.expression){var func=ts.getContainingFunction(node);if(func&&func.asteriskToken){var expressionType=checkExpressionCached(node.expression,void 0),expressionElementType=void 0,nodeIsYieldStar=!!node.asteriskToken;if(nodeIsYieldStar&&(expressionElementType=checkElementTypeOfIterable(expressionType,node.expression)),func.type){var signatureElementType=getElementTypeOfIterableIterator(getTypeFromTypeNode(func.type))||anyType;nodeIsYieldStar?checkTypeAssignableTo(expressionElementType,signatureElementType,node.expression,void 0):checkTypeAssignableTo(expressionType,signatureElementType,node.expression,void 0)}}}return anyType}function checkConditionalExpression(node,contextualMapper){checkExpression(node.condition);var type1=checkExpression(node.whenTrue,contextualMapper),type2=checkExpression(node.whenFalse,contextualMapper);return getUnionType([type1,type2])}function checkStringLiteralExpression(node){var contextualType=getContextualType(node);return contextualType&&contextualTypeIsStringLiteralType(contextualType)?getStringLiteralTypeForText(node.text):stringType}function checkTemplateExpression(node){return ts.forEach(node.templateSpans,function(templateSpan){checkExpression(templateSpan.expression)}),stringType}function checkExpressionWithContextualType(node,contextualType,contextualMapper){var saveContextualType=node.contextualType;node.contextualType=contextualType;var result=checkExpression(node,contextualMapper);return node.contextualType=saveContextualType,result}function checkExpressionCached(node,contextualMapper){var links=getNodeLinks(node);return links.resolvedType||(links.resolvedType=checkExpression(node,contextualMapper)),links.resolvedType}function checkPropertyAssignment(node,contextualMapper){return 137===node.name.kind&&checkComputedPropertyName(node.name),checkExpression(node.initializer,contextualMapper)}function checkObjectLiteralMethod(node,contextualMapper){checkGrammarMethod(node),137===node.name.kind&&checkComputedPropertyName(node.name);var uninstantiatedType=checkFunctionExpressionOrObjectLiteralMethod(node,contextualMapper);return instantiateTypeWithSingleGenericCallSignature(node,uninstantiatedType,contextualMapper)}function instantiateTypeWithSingleGenericCallSignature(node,type,contextualMapper){if(isInferentialContext(contextualMapper)){var signature=getSingleCallSignature(type);if(signature&&signature.typeParameters){var contextualType=getApparentTypeOfContextualType(node);if(contextualType){var contextualSignature=getSingleCallSignature(contextualType);if(contextualSignature&&!contextualSignature.typeParameters)return getOrCreateTypeFromSignature(instantiateSignatureInContextOf(signature,contextualSignature,contextualMapper))}}}return type}function checkExpression(node,contextualMapper){var type;if(136===node.kind)type=checkQualifiedName(node);else{var uninstantiatedType=checkExpressionWorker(node,contextualMapper);type=instantiateTypeWithSingleGenericCallSignature(node,uninstantiatedType,contextualMapper)}if(isConstEnumObjectType(type)){var ok=169===node.parent.kind&&node.parent.expression===node||170===node.parent.kind&&node.parent.expression===node||(69===node.kind||136===node.kind)&&isInRightSideOfImportOrExportAssignment(node);ok||error(node,ts.Diagnostics.const_enums_can_only_be_used_in_property_or_index_access_expressions_or_the_right_hand_side_of_an_import_declaration_or_export_assignment)}return type}function checkNumericLiteral(node){return checkGrammarNumericLiteral(node),numberType}function checkExpressionWorker(node,contextualMapper){switch(node.kind){case 69:return checkIdentifier(node);case 97:return checkThisExpression(node);case 95:return checkSuperExpression(node);case 93:return nullType;case 99:case 84:return booleanType;case 8:return checkNumericLiteral(node);case 186:return checkTemplateExpression(node);case 9:return checkStringLiteralExpression(node);case 11:return stringType;case 10:return globalRegExpType;case 167:return checkArrayLiteral(node,contextualMapper);case 168:return checkObjectLiteral(node,contextualMapper);case 169:return checkPropertyAccessExpression(node);case 170:return checkIndexedAccess(node);case 171:case 172:return checkCallExpression(node);case 173:return checkTaggedTemplateExpression(node);case 175:return checkExpression(node.expression,contextualMapper);case 189:return checkClassExpression(node);case 176:case 177:return checkFunctionExpressionOrObjectLiteralMethod(node,contextualMapper);case 179:return checkTypeOfExpression(node);case 174:case 192:return checkAssertion(node);case 178:return checkDeleteExpression(node);case 180:return checkVoidExpression(node);case 181:return checkAwaitExpression(node);case 182:return checkPrefixUnaryExpression(node);case 183:return checkPostfixUnaryExpression(node);case 184:return checkBinaryExpression(node,contextualMapper);case 185:return checkConditionalExpression(node,contextualMapper);case 188:return checkSpreadElementExpression(node,contextualMapper);case 190:return undefinedType;case 187:return checkYieldExpression(node);case 243:return checkJsxExpression(node);case 236:return checkJsxElement(node);case 237:return checkJsxSelfClosingElement(node);case 238:ts.Debug.fail("Shouldn't ever directly check a JsxOpeningElement")}return unknownType}function checkTypeParameter(node){node.expression&&grammarErrorOnFirstToken(node.expression,ts.Diagnostics.Type_expected),checkSourceElement(node.constraint),getConstraintOfTypeParameter(getDeclaredTypeOfTypeParameter(getSymbolOfNode(node))),produceDiagnostics&&checkTypeNameIsReserved(node.name,ts.Diagnostics.Type_parameter_name_cannot_be_0)}function checkParameter(node){checkGrammarDecorators(node)||checkGrammarModifiers(node),checkVariableLikeDeclaration(node);var func=ts.getContainingFunction(node);56&node.flags&&(func=ts.getContainingFunction(node),145===func.kind&&ts.nodeIsPresent(func.body)||error(node,ts.Diagnostics.A_parameter_property_is_only_allowed_in_a_constructor_implementation)),node.questionToken&&ts.isBindingPattern(node.name)&&func.body&&error(node,ts.Diagnostics.A_binding_pattern_parameter_cannot_be_optional_in_an_implementation_signature),!node.dotDotDotToken||ts.isBindingPattern(node.name)||isArrayType(getTypeOfSymbol(node.symbol))||error(node,ts.Diagnostics.A_rest_parameter_must_be_of_an_array_type)}function isSyntacticallyValidGenerator(node){return!(!node.asteriskToken||!node.body)&&(144===node.kind||216===node.kind||176===node.kind)}function getTypePredicateParameterIndex(parameterList,parameter){if(parameterList)for(var i=0;i<parameterList.length;i++){var param=parameterList[i];if(69===param.name.kind&&param.name.text===parameter.text)return i}return-1}function checkTypePredicate(node){var parent=getTypePredicateParent(node);if(!parent)return void error(node,ts.Diagnostics.A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods);var typePredicate=getSignatureFromDeclaration(parent).typePredicate;if(typePredicate){var parameterName=node.parameterName;if(ts.isThisTypePredicate(typePredicate))getTypeFromThisTypeNode(parameterName);else if(typePredicate.parameterIndex>=0)parent.parameters[typePredicate.parameterIndex].dotDotDotToken?error(parameterName,ts.Diagnostics.A_type_predicate_cannot_reference_a_rest_parameter):checkTypeAssignableTo(typePredicate.type,getTypeOfNode(parent.parameters[typePredicate.parameterIndex]),node.type);else if(parameterName){for(var hasReportedError=!1,_i=0,_a=parent.parameters;_i<_a.length;_i++){var name_14=_a[_i].name;if(ts.isBindingPattern(name_14)&&checkIfTypePredicateVariableIsDeclaredInBindingPattern(name_14,parameterName,typePredicate.parameterName)){hasReportedError=!0;break}}hasReportedError||error(node.parameterName,ts.Diagnostics.Cannot_find_parameter_0,typePredicate.parameterName)}}}function getTypePredicateParent(node){switch(node.parent.kind){case 177:case 148:case 216:case 176:case 153:case 144:case 143:var parent_7=node.parent;if(node===parent_7.type)return parent_7}}function checkIfTypePredicateVariableIsDeclaredInBindingPattern(pattern,predicateVariableNode,predicateVariableName){for(var _i=0,_a=pattern.elements;_i<_a.length;_i++){var name_15=_a[_i].name;if(69===name_15.kind&&name_15.text===predicateVariableName)return error(predicateVariableNode,ts.Diagnostics.A_type_predicate_cannot_reference_element_0_in_a_binding_pattern,predicateVariableName),!0;if((165===name_15.kind||164===name_15.kind)&&checkIfTypePredicateVariableIsDeclaredInBindingPattern(name_15,predicateVariableNode,predicateVariableName))return!0}}function checkSignatureDeclaration(node){if(150===node.kind?checkGrammarIndexSignature(node):153!==node.kind&&216!==node.kind&&154!==node.kind&&148!==node.kind&&145!==node.kind&&149!==node.kind||checkGrammarFunctionLikeDeclaration(node),checkTypeParameters(node.typeParameters),ts.forEach(node.parameters,checkParameter),node.type&&checkSourceElement(node.type),produceDiagnostics){if(checkCollisionWithArgumentsInGeneratedCode(node),compilerOptions.noImplicitAny&&!node.type)switch(node.kind){case 149:error(node,ts.Diagnostics.Construct_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type);break;case 148:error(node,ts.Diagnostics.Call_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type)}if(node.type)if(languageVersion>=2&&isSyntacticallyValidGenerator(node)){var returnType=getTypeFromTypeNode(node.type);if(returnType===voidType)error(node.type,ts.Diagnostics.A_generator_cannot_have_a_void_type_annotation);else{var generatorElementType=getElementTypeOfIterableIterator(returnType)||anyType,iterableIteratorInstantiation=createIterableIteratorType(generatorElementType);checkTypeAssignableTo(iterableIteratorInstantiation,returnType,node.type)}}else ts.isAsyncFunctionLike(node)&&checkAsyncFunctionReturnType(node)}checkSpecializedSignatureDeclaration(node)}function checkTypeForDuplicateIndexSignatures(node){if(218===node.kind){var nodeSymbol=getSymbolOfNode(node);if(nodeSymbol.declarations.length>0&&nodeSymbol.declarations[0]!==node)return}var indexSymbol=getIndexSymbol(getSymbolOfNode(node));if(indexSymbol)for(var seenNumericIndexer=!1,seenStringIndexer=!1,_i=0,_a=indexSymbol.declarations;_i<_a.length;_i++){var decl=_a[_i],declaration=decl;if(1===declaration.parameters.length&&declaration.parameters[0].type)switch(declaration.parameters[0].type.kind){case 130:seenStringIndexer?error(declaration,ts.Diagnostics.Duplicate_string_index_signature):seenStringIndexer=!0;break;case 128:seenNumericIndexer?error(declaration,ts.Diagnostics.Duplicate_number_index_signature):seenNumericIndexer=!0}}}function checkPropertyDeclaration(node){checkGrammarDecorators(node)||checkGrammarModifiers(node)||checkGrammarProperty(node)||checkGrammarComputedPropertyName(node.name),checkVariableLikeDeclaration(node)}function checkMethodDeclaration(node){checkGrammarMethod(node)||checkGrammarComputedPropertyName(node.name),checkFunctionOrMethodDeclaration(node),128&node.flags&&node.body&&error(node,ts.Diagnostics.Method_0_cannot_have_an_implementation_because_it_is_marked_abstract,ts.declarationNameToString(node.name))}function checkConstructorDeclaration(node){function isInstancePropertyWithInitializer(n){return!(142!==n.kind||64&n.flags||!n.initializer)}checkSignatureDeclaration(node),checkGrammarConstructorTypeParameters(node)||checkGrammarConstructorTypeAnnotation(node),checkSourceElement(node.body);var symbol=getSymbolOfNode(node),firstDeclaration=ts.getDeclarationOfKind(symbol,node.kind);if(node===firstDeclaration&&checkFunctionOrConstructorSymbol(symbol),!ts.nodeIsMissing(node.body)&&produceDiagnostics){var containingClassDecl=node.parent;if(ts.getClassExtendsHeritageClauseElement(containingClassDecl)){var classExtendsNull=classDeclarationExtendsNull(containingClassDecl),superCall=getSuperCallInConstructor(node);if(superCall){classExtendsNull&&error(superCall,ts.Diagnostics.A_constructor_cannot_contain_a_super_call_when_its_class_extends_null);var superCallShouldBeFirst=ts.forEach(node.parent.members,isInstancePropertyWithInitializer)||ts.forEach(node.parameters,function(p){return 56&p.flags});if(superCallShouldBeFirst){for(var statements=node.body.statements,superCallStatement=void 0,_i=0,statements_2=statements;_i<statements_2.length;_i++){var statement=statements_2[_i];if(198===statement.kind&&ts.isSuperCallExpression(statement.expression)){superCallStatement=statement;break}if(!ts.isPrologueDirective(statement))break}superCallStatement||error(node,ts.Diagnostics.A_super_call_must_be_the_first_statement_in_the_constructor_when_a_class_contains_initialized_properties_or_has_parameter_properties)}}else classExtendsNull||error(node,ts.Diagnostics.Constructors_for_derived_classes_must_contain_a_super_call)}}}function checkAccessorDeclaration(node){if(produceDiagnostics){if(checkGrammarFunctionLikeDeclaration(node)||checkGrammarAccessor(node)||checkGrammarComputedPropertyName(node.name),checkDecorators(node),checkSignatureDeclaration(node),146===node.kind&&!ts.isInAmbientContext(node)&&ts.nodeIsPresent(node.body)&&524288&node.flags&&(1048576&node.flags?compilerOptions.noImplicitReturns&&error(node.name,ts.Diagnostics.Not_all_code_paths_return_a_value):error(node.name,ts.Diagnostics.A_get_accessor_must_return_a_value)),137===node.name.kind&&checkComputedPropertyName(node.name),!ts.hasDynamicName(node)){var otherKind=146===node.kind?147:146,otherAccessor=ts.getDeclarationOfKind(node.symbol,otherKind);if(otherAccessor){(56&node.flags)!==(56&otherAccessor.flags)&&error(node.name,ts.Diagnostics.Getter_and_setter_accessors_do_not_agree_in_visibility);var currentAccessorType=getAnnotatedAccessorType(node),otherAccessorType=getAnnotatedAccessorType(otherAccessor);currentAccessorType&&otherAccessorType&&(isTypeIdenticalTo(currentAccessorType,otherAccessorType)||error(node,ts.Diagnostics.get_and_set_accessor_must_have_the_same_type))}}getTypeOfAccessors(getSymbolOfNode(node))}168!==node.parent.kind?checkSourceElement(node.body):checkNodeDeferred(node)}function checkAccessorDeferred(node){checkSourceElement(node.body)}function checkMissingDeclaration(node){checkDecorators(node)}function checkTypeArgumentConstraints(typeParameters,typeArgumentNodes){for(var typeArguments,mapper,result=!0,i=0;i<typeParameters.length;i++){var constraint=getConstraintOfTypeParameter(typeParameters[i]);if(constraint){typeArguments||(typeArguments=ts.map(typeArgumentNodes,getTypeFromTypeNode),mapper=createTypeMapper(typeParameters,typeArguments));var typeArgument=typeArguments[i];result=result&&checkTypeAssignableTo(typeArgument,getTypeWithThisArgument(instantiateType(constraint,mapper),typeArgument),typeArgumentNodes[i],ts.Diagnostics.Type_0_does_not_satisfy_the_constraint_1)}}return result}function checkTypeReferenceNode(node){checkGrammarTypeArguments(node,node.typeArguments);var type=getTypeFromTypeReference(node);if(type!==unknownType&&node.typeArguments&&(ts.forEach(node.typeArguments,checkSourceElement),produceDiagnostics)){var symbol=getNodeLinks(node).resolvedSymbol,typeParameters=524288&symbol.flags?getSymbolLinks(symbol).typeParameters:type.target.localTypeParameters;checkTypeArgumentConstraints(typeParameters,node.typeArguments)}}function checkTypeQuery(node){getTypeFromTypeQueryNode(node)}function checkTypeLiteral(node){if(ts.forEach(node.members,checkSourceElement),produceDiagnostics){var type=getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode(node);checkIndexConstraints(type),checkTypeForDuplicateIndexSignatures(node)}}function checkArrayType(node){checkSourceElement(node.elementType)}function checkTupleType(node){var hasErrorFromDisallowedTrailingComma=checkGrammarForDisallowedTrailingComma(node.elementTypes);hasErrorFromDisallowedTrailingComma||0!==node.elementTypes.length||grammarErrorOnNode(node,ts.Diagnostics.A_tuple_type_element_list_cannot_be_empty),ts.forEach(node.elementTypes,checkSourceElement)}function checkUnionOrIntersectionType(node){ts.forEach(node.types,checkSourceElement)}function isPrivateWithinAmbient(node){return 16&node.flags&&ts.isInAmbientContext(node)}function checkSpecializedSignatureDeclaration(signatureDeclarationNode){if(produceDiagnostics){var signature=getSignatureFromDeclaration(signatureDeclarationNode);if(signature.hasStringLiterals){if(ts.nodeIsPresent(signatureDeclarationNode.body))return void error(signatureDeclarationNode,ts.Diagnostics.A_signature_with_an_implementation_cannot_use_a_string_literal_type);var signaturesToCheck;if(!signatureDeclarationNode.name&&signatureDeclarationNode.parent&&218===signatureDeclarationNode.parent.kind){ts.Debug.assert(148===signatureDeclarationNode.kind||149===signatureDeclarationNode.kind);var signatureKind=148===signatureDeclarationNode.kind?0:1,containingSymbol=getSymbolOfNode(signatureDeclarationNode.parent),containingType=getDeclaredTypeOfSymbol(containingSymbol);signaturesToCheck=getSignaturesOfType(containingType,signatureKind)}else signaturesToCheck=getSignaturesOfSymbol(getSymbolOfNode(signatureDeclarationNode));for(var _i=0,signaturesToCheck_1=signaturesToCheck;_i<signaturesToCheck_1.length;_i++){var otherSignature=signaturesToCheck_1[_i];if(!otherSignature.hasStringLiterals&&isSignatureAssignableTo(signature,otherSignature,!1))return}error(signatureDeclarationNode,ts.Diagnostics.Specialized_overload_signature_is_not_assignable_to_any_non_specialized_signature)}}}function getEffectiveDeclarationFlags(n,flagsToCheck){var flags=ts.getCombinedNodeFlags(n);return 218!==n.parent.kind&&217!==n.parent.kind&&189!==n.parent.kind&&ts.isInAmbientContext(n)&&(4&flags||(flags|=2),flags|=4),flags&flagsToCheck}function checkFunctionOrConstructorSymbol(symbol){function getCanonicalOverload(overloads,implementation){var implementationSharesContainerWithFirstOverload=void 0!==implementation&&implementation.parent===overloads[0].parent;return implementationSharesContainerWithFirstOverload?implementation:overloads[0]}function checkFlagAgreementBetweenOverloads(overloads,implementation,flagsToCheck,someOverloadFlags,allOverloadFlags){var someButNotAllOverloadFlags=someOverloadFlags^allOverloadFlags;if(0!==someButNotAllOverloadFlags){var canonicalFlags_1=getEffectiveDeclarationFlags(getCanonicalOverload(overloads,implementation),flagsToCheck);ts.forEach(overloads,function(o){var deviation=getEffectiveDeclarationFlags(o,flagsToCheck)^canonicalFlags_1;2&deviation?error(o.name,ts.Diagnostics.Overload_signatures_must_all_be_exported_or_not_exported):4&deviation?error(o.name,ts.Diagnostics.Overload_signatures_must_all_be_ambient_or_non_ambient):48&deviation?error(o.name,ts.Diagnostics.Overload_signatures_must_all_be_public_private_or_protected):128&deviation&&error(o.name,ts.Diagnostics.Overload_signatures_must_all_be_abstract_or_not_abstract);
})}}function checkQuestionTokenAgreementBetweenOverloads(overloads,implementation,someHaveQuestionToken,allHaveQuestionToken){if(someHaveQuestionToken!==allHaveQuestionToken){var canonicalHasQuestionToken_1=ts.hasQuestionToken(getCanonicalOverload(overloads,implementation));ts.forEach(overloads,function(o){var deviation=ts.hasQuestionToken(o)!==canonicalHasQuestionToken_1;deviation&&error(o.name,ts.Diagnostics.Overload_signatures_must_all_be_optional_or_required)})}}function reportImplementationExpectedError(node){if(!node.name||!ts.nodeIsMissing(node.name)){var seen=!1,subsequentNode=ts.forEachChild(node.parent,function(c){return seen?c:void(seen=c===node)});if(subsequentNode&&subsequentNode.pos===node.end&&subsequentNode.kind===node.kind){var errorNode_1=subsequentNode.name||subsequentNode;if(node.name&&subsequentNode.name&&node.name.text===subsequentNode.name.text){var reportError=(144===node.kind||143===node.kind)&&(64&node.flags)!==(64&subsequentNode.flags);if(reportError){var diagnostic=64&node.flags?ts.Diagnostics.Function_overload_must_be_static:ts.Diagnostics.Function_overload_must_not_be_static;error(errorNode_1,diagnostic)}return}if(ts.nodeIsPresent(subsequentNode.body))return void error(errorNode_1,ts.Diagnostics.Function_implementation_name_must_be_0,ts.declarationNameToString(node.name))}var errorNode=node.name||node;isConstructor?error(errorNode,ts.Diagnostics.Constructor_implementation_is_missing):128&node.flags?error(errorNode,ts.Diagnostics.All_declarations_of_an_abstract_method_must_be_consecutive):error(errorNode,ts.Diagnostics.Function_implementation_is_missing_or_not_immediately_following_the_declaration)}}if(produceDiagnostics){for(var bodyDeclaration,lastSeenNonAmbientDeclaration,previousDeclaration,flagsToCheck=182,someNodeFlags=0,allNodeFlags=flagsToCheck,someHaveQuestionToken=!1,allHaveQuestionToken=!0,hasOverloads=!1,declarations=symbol.declarations,isConstructor=0!==(16384&symbol.flags),isExportSymbolInsideModule=symbol.parent&&1536&symbol.parent.flags,duplicateFunctionDeclaration=!1,multipleConstructorImplementation=!1,_i=0,declarations_4=declarations;_i<declarations_4.length;_i++){var current=declarations_4[_i],node=current,inAmbientContext=ts.isInAmbientContext(node),inAmbientContextOrInterface=218===node.parent.kind||156===node.parent.kind||inAmbientContext;if(inAmbientContextOrInterface&&(previousDeclaration=void 0),216===node.kind||144===node.kind||143===node.kind||145===node.kind){var currentNodeFlags=getEffectiveDeclarationFlags(node,flagsToCheck);someNodeFlags|=currentNodeFlags,allNodeFlags&=currentNodeFlags,someHaveQuestionToken=someHaveQuestionToken||ts.hasQuestionToken(node),allHaveQuestionToken=allHaveQuestionToken&&ts.hasQuestionToken(node),ts.nodeIsPresent(node.body)&&bodyDeclaration?isConstructor?multipleConstructorImplementation=!0:duplicateFunctionDeclaration=!0:!isExportSymbolInsideModule&&previousDeclaration&&previousDeclaration.parent===node.parent&&previousDeclaration.end!==node.pos&&reportImplementationExpectedError(previousDeclaration),ts.nodeIsPresent(node.body)?bodyDeclaration||(bodyDeclaration=node):hasOverloads=!0,previousDeclaration=node,inAmbientContextOrInterface||(lastSeenNonAmbientDeclaration=node)}}if(multipleConstructorImplementation&&ts.forEach(declarations,function(declaration){error(declaration,ts.Diagnostics.Multiple_constructor_implementations_are_not_allowed)}),duplicateFunctionDeclaration&&ts.forEach(declarations,function(declaration){error(declaration.name,ts.Diagnostics.Duplicate_function_implementation)}),isExportSymbolInsideModule||!lastSeenNonAmbientDeclaration||lastSeenNonAmbientDeclaration.body||128&lastSeenNonAmbientDeclaration.flags||reportImplementationExpectedError(lastSeenNonAmbientDeclaration),hasOverloads&&(checkFlagAgreementBetweenOverloads(declarations,bodyDeclaration,flagsToCheck,someNodeFlags,allNodeFlags),checkQuestionTokenAgreementBetweenOverloads(declarations,bodyDeclaration,someHaveQuestionToken,allHaveQuestionToken),bodyDeclaration)){var signatures=getSignaturesOfSymbol(symbol),bodySignature=getSignatureFromDeclaration(bodyDeclaration);if(!bodySignature.hasStringLiterals)for(var _a=0,signatures_3=signatures;_a<signatures_3.length;_a++){var signature=signatures_3[_a];if(!signature.hasStringLiterals&&!isImplementationCompatibleWithOverload(bodySignature,signature)){error(signature.declaration,ts.Diagnostics.Overload_signature_is_not_compatible_with_function_implementation);break}}}}}function checkExportsOnMergedDeclarations(node){function getDeclarationSpaces(d){switch(d.kind){case 218:return 2097152;case 221:return ts.isAmbientModule(d)||0!==ts.getModuleInstanceState(d)?5242880:4194304;case 217:case 220:return 3145728;case 224:var result_2=0,target=resolveAlias(getSymbolOfNode(d));return ts.forEach(target.declarations,function(d){result_2|=getDeclarationSpaces(d)}),result_2;default:return 1048576}}if(produceDiagnostics){var symbol=node.localSymbol;if((symbol||(symbol=getSymbolOfNode(node),7340032&symbol.flags))&&ts.getDeclarationOfKind(symbol,node.kind)===node){for(var exportedDeclarationSpaces=0,nonExportedDeclarationSpaces=0,defaultExportedDeclarationSpaces=0,_i=0,_a=symbol.declarations;_i<_a.length;_i++){var d=_a[_i],declarationSpaces=getDeclarationSpaces(d),effectiveDeclarationFlags=getEffectiveDeclarationFlags(d,514);2&effectiveDeclarationFlags?512&effectiveDeclarationFlags?defaultExportedDeclarationSpaces|=declarationSpaces:exportedDeclarationSpaces|=declarationSpaces:nonExportedDeclarationSpaces|=declarationSpaces}var nonDefaultExportedDeclarationSpaces=exportedDeclarationSpaces|nonExportedDeclarationSpaces,commonDeclarationSpacesForExportsAndLocals=exportedDeclarationSpaces&nonExportedDeclarationSpaces,commonDeclarationSpacesForDefaultAndNonDefault=defaultExportedDeclarationSpaces&nonDefaultExportedDeclarationSpaces;if(commonDeclarationSpacesForExportsAndLocals||commonDeclarationSpacesForDefaultAndNonDefault)for(var _b=0,_c=symbol.declarations;_b<_c.length;_b++){var d=_c[_b],declarationSpaces=getDeclarationSpaces(d);declarationSpaces&commonDeclarationSpacesForDefaultAndNonDefault?error(d.name,ts.Diagnostics.Merged_declaration_0_cannot_include_a_default_export_declaration_Consider_adding_a_separate_export_default_0_declaration_instead,ts.declarationNameToString(d.name)):declarationSpaces&commonDeclarationSpacesForExportsAndLocals&&error(d.name,ts.Diagnostics.Individual_declarations_in_merged_declaration_0_must_be_all_exported_or_all_local,ts.declarationNameToString(d.name))}}}}function checkNonThenableType(type,location,message){return type=getWidenedType(type),!isTypeAny(type)&&isTypeAssignableTo(type,getGlobalThenableType())?(location&&(message||(message=ts.Diagnostics.Operand_for_await_does_not_have_a_valid_callable_then_member),error(location,message)),unknownType):type}function getPromisedType(promise){if(!(1&promise.flags)){if(4096&promise.flags&&promise.target===tryGetGlobalPromiseType())return promise.typeArguments[0];var globalPromiseLikeType=getInstantiatedGlobalPromiseLikeType();if(globalPromiseLikeType!==emptyObjectType&&isTypeAssignableTo(promise,globalPromiseLikeType)){var thenFunction=getTypeOfPropertyOfType(promise,"then");if(!(thenFunction&&1&thenFunction.flags)){var thenSignatures=thenFunction?getSignaturesOfType(thenFunction,0):emptyArray;if(0!==thenSignatures.length){var onfulfilledParameterType=getUnionType(ts.map(thenSignatures,getTypeOfFirstParameterOfSignature));if(!(1&onfulfilledParameterType.flags)){var onfulfilledParameterSignatures=getSignaturesOfType(onfulfilledParameterType,0);if(0!==onfulfilledParameterSignatures.length){var valueParameterType=getUnionType(ts.map(onfulfilledParameterSignatures,getTypeOfFirstParameterOfSignature));return valueParameterType}}}}}}}function getTypeOfFirstParameterOfSignature(signature){return getTypeAtPosition(signature,0)}function getAwaitedType(type){return checkAwaitedType(type,void 0,void 0)}function checkAwaitedType(type,location,message){function checkAwaitedTypeWorker(type){if(16384&type.flags){for(var types=[],_i=0,_a=type.types;_i<_a.length;_i++){var constituentType=_a[_i];types.push(checkAwaitedTypeWorker(constituentType))}return getUnionType(types)}var promisedType=getPromisedType(type);if(void 0===promisedType)return checkNonThenableType(type,location,message);if(type.id===promisedType.id||awaitedTypeStack.indexOf(promisedType.id)>=0)return location&&error(location,ts.Diagnostics._0_is_referenced_directly_or_indirectly_in_the_fulfillment_callback_of_its_own_then_method,symbolToString(type.symbol)),unknownType;awaitedTypeStack.push(type.id);var awaitedType=checkAwaitedTypeWorker(promisedType);return awaitedTypeStack.pop(),awaitedType}return checkAwaitedTypeWorker(type)}function checkCorrectPromiseType(returnType,location){if(returnType===unknownType)return unknownType;var globalPromiseType=getGlobalPromiseType();return globalPromiseType===emptyGenericType||globalPromiseType===getTargetType(returnType)?checkAwaitedType(returnType,location,ts.Diagnostics.An_async_function_or_method_must_have_a_valid_awaitable_return_type):(error(location,ts.Diagnostics.The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type),unknownType)}function checkAsyncFunctionReturnType(node){if(compilerOptions.noCustomAsyncPromise&&languageVersion>=2){var returnType=getTypeFromTypeNode(node.type);return checkCorrectPromiseType(returnType,node.type)}var globalPromiseConstructorLikeType=getGlobalPromiseConstructorLikeType();if(globalPromiseConstructorLikeType===emptyObjectType)return unknownType;var promiseType=getTypeFromTypeNode(node.type);if(promiseType===unknownType&&compilerOptions.isolatedModules)return unknownType;var promiseConstructor=getNodeLinks(node.type).resolvedSymbol;if(!promiseConstructor||!symbolIsValue(promiseConstructor)){var typeName=promiseConstructor?symbolToString(promiseConstructor):typeToString(promiseType);return error(node,ts.Diagnostics.Type_0_is_not_a_valid_async_function_return_type,typeName),unknownType}checkReturnTypeAnnotationAsExpression(node);var promiseConstructorType=getTypeOfSymbol(promiseConstructor);if(!checkTypeAssignableTo(promiseConstructorType,globalPromiseConstructorLikeType,node,ts.Diagnostics.Type_0_is_not_a_valid_async_function_return_type))return unknownType;var promiseName=ts.getEntityNameFromTypeNode(node.type),promiseNameOrNamespaceRoot=getFirstIdentifier(promiseName),rootSymbol=getSymbol(node.locals,promiseNameOrNamespaceRoot.text,107455);return rootSymbol?(error(rootSymbol.valueDeclaration,ts.Diagnostics.Duplicate_identifier_0_Compiler_uses_declaration_1_to_support_async_functions,promiseNameOrNamespaceRoot.text,getFullyQualifiedName(promiseConstructor)),unknownType):checkAwaitedType(promiseType,node,ts.Diagnostics.An_async_function_or_method_must_have_a_valid_awaitable_return_type)}function checkDecorator(node){var signature=getResolvedSignature(node),returnType=getReturnTypeOfSignature(signature);if(!(1&returnType.flags)){var expectedReturnType,errorInfo,headMessage=getDiagnosticHeadMessageForDecoratorResolution(node);switch(node.parent.kind){case 217:var classSymbol=getSymbolOfNode(node.parent),classConstructorType=getTypeOfSymbol(classSymbol);expectedReturnType=getUnionType([classConstructorType,voidType]);break;case 139:expectedReturnType=voidType,errorInfo=ts.chainDiagnosticMessages(errorInfo,ts.Diagnostics.The_return_type_of_a_parameter_decorator_function_must_be_either_void_or_any);break;case 142:expectedReturnType=voidType,errorInfo=ts.chainDiagnosticMessages(errorInfo,ts.Diagnostics.The_return_type_of_a_property_decorator_function_must_be_either_void_or_any);break;case 144:case 146:case 147:var methodType=getTypeOfNode(node.parent),descriptorType=createTypedPropertyDescriptorType(methodType);expectedReturnType=getUnionType([descriptorType,voidType])}checkTypeAssignableTo(returnType,expectedReturnType,node,headMessage,errorInfo)}}function checkTypeNodeAsExpression(node){if(node&&152===node.kind){var root=getFirstIdentifier(node.typeName),meaning=152===root.parent.kind?793056:1536,rootSymbol=resolveName(root,root.text,8388608|meaning,void 0,void 0);if(rootSymbol&&8388608&rootSymbol.flags){var aliasTarget=resolveAlias(rootSymbol);107455&aliasTarget.flags&&!isConstEnumOrConstEnumOnlyModule(resolveAlias(rootSymbol))&&markAliasSymbolAsReferenced(rootSymbol)}}}function checkTypeAnnotationAsExpression(node){checkTypeNodeAsExpression(node.type)}function checkReturnTypeAnnotationAsExpression(node){checkTypeNodeAsExpression(node.type)}function checkParameterTypeAnnotationsAsExpressions(node){for(var _i=0,_a=node.parameters;_i<_a.length;_i++){var parameter=_a[_i];checkTypeAnnotationAsExpression(parameter)}}function checkDecorators(node){if(node.decorators&&ts.nodeCanBeDecorated(node)){if(compilerOptions.experimentalDecorators||error(node,ts.Diagnostics.Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_the_experimentalDecorators_option_to_remove_this_warning),compilerOptions.emitDecoratorMetadata)switch(node.kind){case 217:var constructor=ts.getFirstConstructorWithBody(node);constructor&&checkParameterTypeAnnotationsAsExpressions(constructor);break;case 144:case 146:case 147:checkParameterTypeAnnotationsAsExpressions(node),checkReturnTypeAnnotationAsExpression(node);break;case 142:case 139:checkTypeAnnotationAsExpression(node)}ts.forEach(node.decorators,checkDecorator)}}function checkFunctionDeclaration(node){produceDiagnostics&&(checkFunctionOrMethodDeclaration(node)||checkGrammarForGenerator(node),checkCollisionWithCapturedSuperVariable(node,node.name),checkCollisionWithCapturedThisVariable(node,node.name),checkCollisionWithRequireExportsInGeneratedCode(node,node.name),checkCollisionWithGlobalPromiseInGeneratedCode(node,node.name))}function checkFunctionOrMethodDeclaration(node){checkDecorators(node),checkSignatureDeclaration(node);var isAsync=ts.isAsyncFunctionLike(node);if(node.name&&137===node.name.kind&&checkComputedPropertyName(node.name),!ts.hasDynamicName(node)){var symbol=getSymbolOfNode(node),localSymbol=node.localSymbol||symbol,firstDeclaration=ts.forEach(localSymbol.declarations,function(declaration){return declaration.kind!==node.kind||ts.isSourceFileJavaScript(ts.getSourceFileOfNode(declaration))?void 0:declaration});node===firstDeclaration&&checkFunctionOrConstructorSymbol(localSymbol),symbol.parent&&ts.getDeclarationOfKind(symbol,node.kind)===node&&checkFunctionOrConstructorSymbol(symbol)}if(checkSourceElement(node.body),!node.asteriskToken){var returnOrPromisedType=node.type&&(isAsync?checkAsyncFunctionReturnType(node):getTypeFromTypeNode(node.type));checkAllCodePathsInNonVoidFunctionReturnOrThrow(node,returnOrPromisedType)}produceDiagnostics&&!node.type&&(compilerOptions.noImplicitAny&&ts.nodeIsMissing(node.body)&&!isPrivateWithinAmbient(node)&&reportImplicitAnyError(node,anyType),node.asteriskToken&&ts.nodeIsPresent(node.body)&&getReturnTypeOfSignature(getSignatureFromDeclaration(node)))}function checkBlock(node){195===node.kind&&checkGrammarStatementInAmbientContext(node),ts.forEach(node.statements,checkSourceElement)}function checkCollisionWithArgumentsInGeneratedCode(node){!ts.hasRestParameter(node)||ts.isInAmbientContext(node)||ts.nodeIsMissing(node.body)||ts.forEach(node.parameters,function(p){p.name&&!ts.isBindingPattern(p.name)&&p.name.text===argumentsSymbol.name&&error(p,ts.Diagnostics.Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters)})}function needCollisionCheckForIdentifier(node,identifier,name){if(!identifier||identifier.text!==name)return!1;if(142===node.kind||141===node.kind||144===node.kind||143===node.kind||146===node.kind||147===node.kind)return!1;if(ts.isInAmbientContext(node))return!1;var root=ts.getRootDeclaration(node);return 139!==root.kind||!ts.nodeIsMissing(root.parent.body)}function checkCollisionWithCapturedThisVariable(node,name){needCollisionCheckForIdentifier(node,name,"_this")&&potentialThisCollisions.push(node)}function checkIfThisIsCapturedInEnclosingScope(node){for(var current=node;current;){if(4&getNodeCheckFlags(current)){var isDeclaration_1=69!==node.kind;return void(isDeclaration_1?error(node.name,ts.Diagnostics.Duplicate_identifier_this_Compiler_uses_variable_declaration_this_to_capture_this_reference):error(node,ts.Diagnostics.Expression_resolves_to_variable_declaration_this_that_compiler_uses_to_capture_this_reference))}current=current.parent}}function checkCollisionWithCapturedSuperVariable(node,name){if(needCollisionCheckForIdentifier(node,name,"_super")){var enclosingClass=ts.getContainingClass(node);if(enclosingClass&&!ts.isInAmbientContext(enclosingClass)&&ts.getClassExtendsHeritageClauseElement(enclosingClass)){var isDeclaration_2=69!==node.kind;isDeclaration_2?error(node,ts.Diagnostics.Duplicate_identifier_super_Compiler_uses_super_to_capture_base_class_reference):error(node,ts.Diagnostics.Expression_resolves_to_super_that_compiler_uses_to_capture_base_class_reference)}}}function checkCollisionWithRequireExportsInGeneratedCode(node,name){if((needCollisionCheckForIdentifier(node,name,"require")||needCollisionCheckForIdentifier(node,name,"exports"))&&(221!==node.kind||1===ts.getModuleInstanceState(node))){var parent=getDeclarationContainer(node);251===parent.kind&&ts.isExternalOrCommonJsModule(parent)&&error(name,ts.Diagnostics.Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module,ts.declarationNameToString(name),ts.declarationNameToString(name))}}function checkCollisionWithGlobalPromiseInGeneratedCode(node,name){if(compilerOptions.noCustomAsyncPromise&&needCollisionCheckForIdentifier(node,name,"Promise")&&(221!==node.kind||1===ts.getModuleInstanceState(node))){var parent=getDeclarationContainer(node);251===parent.kind&&ts.isExternalOrCommonJsModule(parent)&&33554432&parent.flags&&error(name,ts.Diagnostics.Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_containing_async_functions,ts.declarationNameToString(name),ts.declarationNameToString(name))}}function checkVarDeclaredNamesNotShadowed(node){if(0===(24576&ts.getCombinedNodeFlags(node))&&!ts.isParameterDeclaration(node)&&(214!==node.kind||node.initializer)){var symbol=getSymbolOfNode(node);if(1&symbol.flags){var localDeclarationSymbol=resolveName(node,node.name.text,3,void 0,void 0);if(localDeclarationSymbol&&localDeclarationSymbol!==symbol&&2&localDeclarationSymbol.flags&&24576&getDeclarationFlagsFromSymbol(localDeclarationSymbol)){var varDeclList=ts.getAncestor(localDeclarationSymbol.valueDeclaration,215),container=196===varDeclList.parent.kind&&varDeclList.parent.parent?varDeclList.parent.parent:void 0,namesShareScope=container&&(195===container.kind&&ts.isFunctionLike(container.parent)||222===container.kind||221===container.kind||251===container.kind);if(!namesShareScope){var name_16=symbolToString(localDeclarationSymbol);error(node,ts.Diagnostics.Cannot_initialize_outer_scoped_variable_0_in_the_same_scope_as_block_scoped_declaration_1,name_16,name_16)}}}}}function checkParameterInitializer(node){function visit(n){if(69===n.kind){var referencedSymbol=getNodeLinks(n).resolvedSymbol;if(referencedSymbol&&referencedSymbol!==unknownSymbol&&getSymbol(func.locals,referencedSymbol.name,107455)===referencedSymbol){if(139===referencedSymbol.valueDeclaration.kind){if(referencedSymbol.valueDeclaration===node)return void error(n,ts.Diagnostics.Parameter_0_cannot_be_referenced_in_its_initializer,ts.declarationNameToString(node.name));if(referencedSymbol.valueDeclaration.pos<node.pos)return}error(n,ts.Diagnostics.Initializer_of_parameter_0_cannot_reference_identifier_1_declared_after_it,ts.declarationNameToString(node.name),ts.declarationNameToString(n))}}else ts.forEachChild(n,visit)}if(139===ts.getRootDeclaration(node).kind){var func=ts.getContainingFunction(node);visit(node.initializer)}}function checkVariableLikeDeclaration(node){if(checkDecorators(node),checkSourceElement(node.type),137===node.name.kind&&(checkComputedPropertyName(node.name),node.initializer&&checkExpressionCached(node.initializer)),166===node.kind&&node.propertyName&&137===node.propertyName.kind&&checkComputedPropertyName(node.propertyName),ts.isBindingPattern(node.name)&&ts.forEach(node.name.elements,checkSourceElement),node.initializer&&139===ts.getRootDeclaration(node).kind&&ts.nodeIsMissing(ts.getContainingFunction(node).body))return void error(node,ts.Diagnostics.A_parameter_initializer_is_only_allowed_in_a_function_or_constructor_implementation);if(ts.isBindingPattern(node.name))return void(node.initializer&&203!==node.parent.parent.kind&&(checkTypeAssignableTo(checkExpressionCached(node.initializer),getWidenedTypeForVariableLikeDeclaration(node),node,void 0),checkParameterInitializer(node)));var symbol=getSymbolOfNode(node),type=getTypeOfVariableOrParameterOrProperty(symbol);if(node===symbol.valueDeclaration)node.initializer&&203!==node.parent.parent.kind&&(checkTypeAssignableTo(checkExpressionCached(node.initializer),type,node,void 0),checkParameterInitializer(node));else{var declarationType=getWidenedTypeForVariableLikeDeclaration(node);type===unknownType||declarationType===unknownType||isTypeIdenticalTo(type,declarationType)||error(node.name,ts.Diagnostics.Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_type_2,ts.declarationNameToString(node.name),typeToString(type),typeToString(declarationType)),node.initializer&&checkTypeAssignableTo(checkExpressionCached(node.initializer),declarationType,node,void 0)}142!==node.kind&&141!==node.kind&&(checkExportsOnMergedDeclarations(node),214!==node.kind&&166!==node.kind||checkVarDeclaredNamesNotShadowed(node),checkCollisionWithCapturedSuperVariable(node,node.name),checkCollisionWithCapturedThisVariable(node,node.name),checkCollisionWithRequireExportsInGeneratedCode(node,node.name),checkCollisionWithGlobalPromiseInGeneratedCode(node,node.name))}function checkVariableDeclaration(node){return checkGrammarVariableDeclaration(node),checkVariableLikeDeclaration(node)}function checkBindingElement(node){return checkGrammarBindingElement(node),checkVariableLikeDeclaration(node)}function checkVariableStatement(node){checkGrammarDecorators(node)||checkGrammarModifiers(node)||checkGrammarVariableDeclarationList(node.declarationList)||checkGrammarForDisallowedLetOrConstStatement(node),ts.forEach(node.declarationList.declarations,checkSourceElement)}function checkGrammarDisallowedModifiersOnObjectLiteralExpressionMethod(node){if(node.modifiers&&168===node.parent.kind){if(!ts.isAsyncFunctionLike(node))return grammarErrorOnFirstToken(node,ts.Diagnostics.Modifiers_cannot_appear_here);if(node.modifiers.length>1)return grammarErrorOnFirstToken(node,ts.Diagnostics.Modifiers_cannot_appear_here)}}function checkExpressionStatement(node){checkGrammarStatementInAmbientContext(node),checkExpression(node.expression)}function checkIfStatement(node){checkGrammarStatementInAmbientContext(node),checkExpression(node.expression),checkSourceElement(node.thenStatement),197===node.thenStatement.kind&&error(node.thenStatement,ts.Diagnostics.The_body_of_an_if_statement_cannot_be_the_empty_statement),checkSourceElement(node.elseStatement)}function checkDoStatement(node){checkGrammarStatementInAmbientContext(node),checkSourceElement(node.statement),checkExpression(node.expression)}function checkWhileStatement(node){checkGrammarStatementInAmbientContext(node),checkExpression(node.expression),checkSourceElement(node.statement)}function checkForStatement(node){checkGrammarStatementInAmbientContext(node)||node.initializer&&215===node.initializer.kind&&checkGrammarVariableDeclarationList(node.initializer),node.initializer&&(215===node.initializer.kind?ts.forEach(node.initializer.declarations,checkVariableDeclaration):checkExpression(node.initializer)),node.condition&&checkExpression(node.condition),node.incrementor&&checkExpression(node.incrementor),checkSourceElement(node.statement)}function checkForOfStatement(node){if(checkGrammarForInOrForOfStatement(node),215===node.initializer.kind)checkForInOrForOfVariableDeclaration(node);else{var varExpr=node.initializer,iteratedType=checkRightHandSideOfForOf(node.expression);if(167===varExpr.kind||168===varExpr.kind)checkDestructuringAssignment(varExpr,iteratedType||unknownType);else{var leftType=checkExpression(varExpr);checkReferenceExpression(varExpr,ts.Diagnostics.Invalid_left_hand_side_in_for_of_statement,ts.Diagnostics.The_left_hand_side_of_a_for_of_statement_cannot_be_a_previously_defined_constant),iteratedType&&checkTypeAssignableTo(iteratedType,leftType,varExpr,void 0)}}checkSourceElement(node.statement)}function checkForInStatement(node){if(checkGrammarForInOrForOfStatement(node),215===node.initializer.kind){var variable=node.initializer.declarations[0];variable&&ts.isBindingPattern(variable.name)&&error(variable.name,ts.Diagnostics.The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern),checkForInOrForOfVariableDeclaration(node)}else{var varExpr=node.initializer,leftType=checkExpression(varExpr);167===varExpr.kind||168===varExpr.kind?error(varExpr,ts.Diagnostics.The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern):isTypeAnyOrAllConstituentTypesHaveKind(leftType,258)?checkReferenceExpression(varExpr,ts.Diagnostics.Invalid_left_hand_side_in_for_in_statement,ts.Diagnostics.The_left_hand_side_of_a_for_in_statement_cannot_be_a_previously_defined_constant):error(varExpr,ts.Diagnostics.The_left_hand_side_of_a_for_in_statement_must_be_of_type_string_or_any)}var rightType=checkExpression(node.expression);isTypeAnyOrAllConstituentTypesHaveKind(rightType,81408)||error(node.expression,ts.Diagnostics.The_right_hand_side_of_a_for_in_statement_must_be_of_type_any_an_object_type_or_a_type_parameter),checkSourceElement(node.statement)}function checkForInOrForOfVariableDeclaration(iterationStatement){var variableDeclarationList=iterationStatement.initializer;if(variableDeclarationList.declarations.length>=1){var decl=variableDeclarationList.declarations[0];checkVariableDeclaration(decl)}}function checkRightHandSideOfForOf(rhsExpression){var expressionType=getTypeOfExpression(rhsExpression);return checkIteratedTypeOrElementType(expressionType,rhsExpression,!0)}function checkIteratedTypeOrElementType(inputType,errorNode,allowStringInput){if(isTypeAny(inputType))return inputType;if(languageVersion>=2)return checkElementTypeOfIterable(inputType,errorNode);if(allowStringInput)return checkElementTypeOfArrayOrString(inputType,errorNode);if(isArrayLikeType(inputType)){var indexType=getIndexTypeOfType(inputType,1);if(indexType)return indexType}return error(errorNode,ts.Diagnostics.Type_0_is_not_an_array_type,typeToString(inputType)),unknownType}function checkElementTypeOfIterable(iterable,errorNode){var elementType=getElementTypeOfIterable(iterable,errorNode);return errorNode&&elementType&&checkTypeAssignableTo(iterable,createIterableType(elementType),errorNode),elementType||anyType}function getElementTypeOfIterable(type,errorNode){if(!isTypeAny(type)){var typeAsIterable=type;if(!typeAsIterable.iterableElementType)if(4096&type.flags&&type.target===globalIterableType)typeAsIterable.iterableElementType=type.typeArguments[0];else{var iteratorFunction=getTypeOfPropertyOfType(type,ts.getPropertyNameForKnownSymbolName("iterator"));if(isTypeAny(iteratorFunction))return;var iteratorFunctionSignatures=iteratorFunction?getSignaturesOfType(iteratorFunction,0):emptyArray;if(0===iteratorFunctionSignatures.length)return void(errorNode&&error(errorNode,ts.Diagnostics.Type_must_have_a_Symbol_iterator_method_that_returns_an_iterator));typeAsIterable.iterableElementType=getElementTypeOfIterator(getUnionType(ts.map(iteratorFunctionSignatures,getReturnTypeOfSignature)),errorNode)}return typeAsIterable.iterableElementType}}function getElementTypeOfIterator(type,errorNode){if(!isTypeAny(type)){var typeAsIterator=type;if(!typeAsIterator.iteratorElementType)if(4096&type.flags&&type.target===globalIteratorType)typeAsIterator.iteratorElementType=type.typeArguments[0];else{var iteratorNextFunction=getTypeOfPropertyOfType(type,"next");if(isTypeAny(iteratorNextFunction))return;var iteratorNextFunctionSignatures=iteratorNextFunction?getSignaturesOfType(iteratorNextFunction,0):emptyArray;if(0===iteratorNextFunctionSignatures.length)return void(errorNode&&error(errorNode,ts.Diagnostics.An_iterator_must_have_a_next_method));var iteratorNextResult=getUnionType(ts.map(iteratorNextFunctionSignatures,getReturnTypeOfSignature));if(isTypeAny(iteratorNextResult))return;var iteratorNextValue=getTypeOfPropertyOfType(iteratorNextResult,"value");if(!iteratorNextValue)return void(errorNode&&error(errorNode,ts.Diagnostics.The_type_returned_by_the_next_method_of_an_iterator_must_have_a_value_property));typeAsIterator.iteratorElementType=iteratorNextValue}return typeAsIterator.iteratorElementType}}function getElementTypeOfIterableIterator(type){if(!isTypeAny(type))return 4096&type.flags&&type.target===globalIterableIteratorType?type.typeArguments[0]:getElementTypeOfIterable(type,void 0)||getElementTypeOfIterator(type,void 0)}function checkElementTypeOfArrayOrString(arrayOrStringType,errorNode){ts.Debug.assert(languageVersion<2);var arrayType=arrayOrStringType;16384&arrayOrStringType.flags?arrayType=getUnionType(ts.filter(arrayOrStringType.types,function(t){return!(258&t.flags)})):258&arrayOrStringType.flags&&(arrayType=emptyUnionType);var hasStringConstituent=arrayOrStringType!==arrayType,reportedError=!1;if(hasStringConstituent&&(languageVersion<1&&(error(errorNode,ts.Diagnostics.Using_a_string_in_a_for_of_statement_is_only_supported_in_ECMAScript_5_and_higher),reportedError=!0),arrayType===emptyObjectType))return stringType;if(!isArrayLikeType(arrayType)){if(!reportedError){var diagnostic=hasStringConstituent?ts.Diagnostics.Type_0_is_not_an_array_type:ts.Diagnostics.Type_0_is_not_an_array_type_or_a_string_type;error(errorNode,diagnostic,typeToString(arrayType))}return hasStringConstituent?stringType:unknownType}var arrayElementType=getIndexTypeOfType(arrayType,1)||unknownType;return hasStringConstituent?258&arrayElementType.flags?stringType:getUnionType([arrayElementType,stringType]):arrayElementType}function checkBreakOrContinueStatement(node){checkGrammarStatementInAmbientContext(node)||checkGrammarBreakOrContinueStatement(node)}function isGetAccessorWithAnnotatatedSetAccessor(node){return!(146!==node.kind||!ts.getSetAccessorTypeAnnotationNode(ts.getDeclarationOfKind(node.symbol,147)))}function checkReturnStatement(node){if(!checkGrammarStatementInAmbientContext(node)){var functionBlock=ts.getContainingFunction(node);functionBlock||grammarErrorOnFirstToken(node,ts.Diagnostics.A_return_statement_can_only_be_used_within_a_function_body)}if(node.expression){var func=ts.getContainingFunction(node);if(func){var signature=getSignatureFromDeclaration(func),returnType=getReturnTypeOfSignature(signature),exprType=checkExpressionCached(node.expression);if(func.asteriskToken)return;if(147===func.kind)error(node.expression,ts.Diagnostics.Setters_cannot_return_a_value);else if(145===func.kind)checkTypeAssignableTo(exprType,returnType,node.expression)||error(node.expression,ts.Diagnostics.Return_type_of_constructor_signature_must_be_assignable_to_the_instance_type_of_the_class);else if(func.type||isGetAccessorWithAnnotatatedSetAccessor(func))if(ts.isAsyncFunctionLike(func)){var promisedType=getPromisedType(returnType),awaitedType=checkAwaitedType(exprType,node.expression,ts.Diagnostics.Return_expression_in_async_function_does_not_have_a_valid_callable_then_member);promisedType&&checkTypeAssignableTo(awaitedType,promisedType,node.expression)}else checkTypeAssignableTo(exprType,returnType,node.expression)}}}function checkWithStatement(node){checkGrammarStatementInAmbientContext(node)||8&node.parserContextFlags&&grammarErrorOnFirstToken(node,ts.Diagnostics.with_statements_are_not_allowed_in_an_async_function_block),checkExpression(node.expression),error(node.expression,ts.Diagnostics.All_symbols_within_a_with_block_will_be_resolved_to_any);
}function checkSwitchStatement(node){checkGrammarStatementInAmbientContext(node);var firstDefaultClause,hasDuplicateDefaultClause=!1,expressionType=checkExpression(node.expression),expressionTypeIsStringLike=someConstituentTypeHasKind(expressionType,258);ts.forEach(node.caseBlock.clauses,function(clause){if(245===clause.kind&&!hasDuplicateDefaultClause)if(void 0===firstDefaultClause)firstDefaultClause=clause;else{var sourceFile=ts.getSourceFileOfNode(node),start=ts.skipTrivia(sourceFile.text,clause.pos),end=clause.statements.length>0?clause.statements[0].pos:clause.end;grammarErrorAtPos(sourceFile,start,end-start,ts.Diagnostics.A_default_clause_cannot_appear_more_than_once_in_a_switch_statement),hasDuplicateDefaultClause=!0}if(produceDiagnostics&&244===clause.kind){var caseClause=clause,caseType=checkExpression(caseClause.expression),expressionTypeIsAssignableToCaseType=expressionTypeIsStringLike&&someConstituentTypeHasKind(caseType,258)||isTypeAssignableTo(expressionType,caseType);expressionTypeIsAssignableToCaseType||checkTypeAssignableTo(caseType,expressionType,caseClause.expression,void 0)}ts.forEach(clause.statements,checkSourceElement)})}function checkLabeledStatement(node){if(!checkGrammarStatementInAmbientContext(node))for(var current=node.parent;current&&!ts.isFunctionLike(current);){if(210===current.kind&&current.label.text===node.label.text){var sourceFile=ts.getSourceFileOfNode(node);grammarErrorOnNode(node.label,ts.Diagnostics.Duplicate_label_0,ts.getTextOfNodeFromSourceText(sourceFile.text,node.label));break}current=current.parent}checkSourceElement(node.statement)}function checkThrowStatement(node){checkGrammarStatementInAmbientContext(node)||void 0===node.expression&&grammarErrorAfterFirstToken(node,ts.Diagnostics.Line_break_not_permitted_here),node.expression&&checkExpression(node.expression)}function checkTryStatement(node){checkGrammarStatementInAmbientContext(node),checkBlock(node.tryBlock);var catchClause=node.catchClause;if(catchClause){if(catchClause.variableDeclaration)if(69!==catchClause.variableDeclaration.name.kind)grammarErrorOnFirstToken(catchClause.variableDeclaration.name,ts.Diagnostics.Catch_clause_variable_name_must_be_an_identifier);else if(catchClause.variableDeclaration.type)grammarErrorOnFirstToken(catchClause.variableDeclaration.type,ts.Diagnostics.Catch_clause_variable_cannot_have_a_type_annotation);else if(catchClause.variableDeclaration.initializer)grammarErrorOnFirstToken(catchClause.variableDeclaration.initializer,ts.Diagnostics.Catch_clause_variable_cannot_have_an_initializer);else{var identifierName=catchClause.variableDeclaration.name.text,locals=catchClause.block.locals;if(locals&&ts.hasProperty(locals,identifierName)){var localSymbol=locals[identifierName];localSymbol&&0!==(2&localSymbol.flags)&&grammarErrorOnNode(localSymbol.valueDeclaration,ts.Diagnostics.Cannot_redeclare_identifier_0_in_catch_clause,identifierName)}}checkBlock(catchClause.block)}node.finallyBlock&&checkBlock(node.finallyBlock)}function checkIndexConstraints(type){function checkIndexConstraintForProperty(prop,propertyType,containingType,indexDeclaration,indexType,indexKind){if(indexType&&(1!==indexKind||isNumericName(prop.valueDeclaration.name))){var errorNode;if(137===prop.valueDeclaration.name.kind||prop.parent===containingType.symbol)errorNode=prop.valueDeclaration;else if(indexDeclaration)errorNode=indexDeclaration;else if(2048&containingType.flags){var someBaseClassHasBothPropertyAndIndexer=ts.forEach(getBaseTypes(containingType),function(base){return getPropertyOfObjectType(base,prop.name)&&getIndexTypeOfType(base,indexKind)});errorNode=someBaseClassHasBothPropertyAndIndexer?void 0:containingType.symbol.declarations[0]}if(errorNode&&!isTypeAssignableTo(propertyType,indexType)){var errorMessage=0===indexKind?ts.Diagnostics.Property_0_of_type_1_is_not_assignable_to_string_index_type_2:ts.Diagnostics.Property_0_of_type_1_is_not_assignable_to_numeric_index_type_2;error(errorNode,errorMessage,symbolToString(prop),typeToString(propertyType),typeToString(indexType))}}}var declaredNumberIndexer=getIndexDeclarationOfSymbol(type.symbol,1),declaredStringIndexer=getIndexDeclarationOfSymbol(type.symbol,0),stringIndexType=getIndexTypeOfType(type,0),numberIndexType=getIndexTypeOfType(type,1);if((stringIndexType||numberIndexType)&&(ts.forEach(getPropertiesOfObjectType(type),function(prop){var propType=getTypeOfSymbol(prop);checkIndexConstraintForProperty(prop,propType,type,declaredStringIndexer,stringIndexType,0),checkIndexConstraintForProperty(prop,propType,type,declaredNumberIndexer,numberIndexType,1)}),1024&type.flags&&ts.isClassLike(type.symbol.valueDeclaration)))for(var classDeclaration=type.symbol.valueDeclaration,_i=0,_a=classDeclaration.members;_i<_a.length;_i++){var member=_a[_i];if(!(64&member.flags)&&ts.hasDynamicName(member)){var propType=getTypeOfSymbol(member.symbol);checkIndexConstraintForProperty(member.symbol,propType,type,declaredStringIndexer,stringIndexType,0),checkIndexConstraintForProperty(member.symbol,propType,type,declaredNumberIndexer,numberIndexType,1)}}var errorNode;if(stringIndexType&&numberIndexType&&(errorNode=declaredNumberIndexer||declaredStringIndexer,!errorNode&&2048&type.flags)){var someBaseTypeHasBothIndexers=ts.forEach(getBaseTypes(type),function(base){return getIndexTypeOfType(base,0)&&getIndexTypeOfType(base,1)});errorNode=someBaseTypeHasBothIndexers?void 0:type.symbol.declarations[0]}errorNode&&!isTypeAssignableTo(numberIndexType,stringIndexType)&&error(errorNode,ts.Diagnostics.Numeric_index_type_0_is_not_assignable_to_string_index_type_1,typeToString(numberIndexType),typeToString(stringIndexType))}function checkTypeNameIsReserved(name,message){switch(name.text){case"any":case"number":case"boolean":case"string":case"symbol":case"void":error(name,message,name.text)}}function checkTypeParameters(typeParameterDeclarations){if(typeParameterDeclarations)for(var i=0,n=typeParameterDeclarations.length;i<n;i++){var node=typeParameterDeclarations[i];if(checkTypeParameter(node),produceDiagnostics)for(var j=0;j<i;j++)typeParameterDeclarations[j].symbol===node.symbol&&error(node.name,ts.Diagnostics.Duplicate_identifier_0,ts.declarationNameToString(node.name))}}function checkClassExpression(node){return checkClassLikeDeclaration(node),checkNodeDeferred(node),getTypeOfSymbol(getSymbolOfNode(node))}function checkClassExpressionDeferred(node){ts.forEach(node.members,checkSourceElement)}function checkClassDeclaration(node){node.name||512&node.flags||grammarErrorOnFirstToken(node,ts.Diagnostics.A_class_declaration_without_the_default_modifier_must_have_a_name),checkClassLikeDeclaration(node),ts.forEach(node.members,checkSourceElement)}function checkClassLikeDeclaration(node){checkGrammarClassDeclarationHeritageClauses(node),checkDecorators(node),node.name&&(checkTypeNameIsReserved(node.name,ts.Diagnostics.Class_name_cannot_be_0),checkCollisionWithCapturedThisVariable(node,node.name),checkCollisionWithRequireExportsInGeneratedCode(node,node.name),checkCollisionWithGlobalPromiseInGeneratedCode(node,node.name)),checkTypeParameters(node.typeParameters),checkExportsOnMergedDeclarations(node);var symbol=getSymbolOfNode(node),type=getDeclaredTypeOfSymbol(symbol),typeWithThis=getTypeWithThisArgument(type),staticType=getTypeOfSymbol(symbol),baseTypeNode=ts.getClassExtendsHeritageClauseElement(node);if(baseTypeNode){var baseTypes=getBaseTypes(type);if(baseTypes.length&&produceDiagnostics){var baseType_1=baseTypes[0],staticBaseType=getBaseConstructorTypeOfClass(type);if(checkSourceElement(baseTypeNode.expression),baseTypeNode.typeArguments){ts.forEach(baseTypeNode.typeArguments,checkSourceElement);for(var _i=0,_a=getConstructorsForTypeArguments(staticBaseType,baseTypeNode.typeArguments);_i<_a.length;_i++){var constructor=_a[_i];if(!checkTypeArgumentConstraints(constructor.typeParameters,baseTypeNode.typeArguments))break}}if(checkTypeAssignableTo(typeWithThis,getTypeWithThisArgument(baseType_1,type.thisType),node.name||node,ts.Diagnostics.Class_0_incorrectly_extends_base_class_1),checkTypeAssignableTo(staticType,getTypeWithoutSignatures(staticBaseType),node.name||node,ts.Diagnostics.Class_static_side_0_incorrectly_extends_base_class_static_side_1),!(staticBaseType.symbol&&32&staticBaseType.symbol.flags)){var constructors=getInstantiatedConstructorsForTypeArguments(staticBaseType,baseTypeNode.typeArguments);ts.forEach(constructors,function(sig){return getReturnTypeOfSignature(sig)!==baseType_1})&&error(baseTypeNode.expression,ts.Diagnostics.Base_constructors_must_all_have_the_same_return_type)}checkKindsOfPropertyMemberOverrides(type,baseType_1)}}var implementedTypeNodes=ts.getClassImplementsHeritageClauseElements(node);if(implementedTypeNodes)for(var _b=0,implementedTypeNodes_1=implementedTypeNodes;_b<implementedTypeNodes_1.length;_b++){var typeRefNode=implementedTypeNodes_1[_b];if(ts.isSupportedExpressionWithTypeArguments(typeRefNode)||error(typeRefNode.expression,ts.Diagnostics.A_class_can_only_implement_an_identifier_Slashqualified_name_with_optional_type_arguments),checkTypeReferenceNode(typeRefNode),produceDiagnostics){var t=getTypeFromTypeNode(typeRefNode);if(t!==unknownType){var declaredType=4096&t.flags?t.target:t;3072&declaredType.flags?checkTypeAssignableTo(typeWithThis,getTypeWithThisArgument(t,type.thisType),node.name||node,ts.Diagnostics.Class_0_incorrectly_implements_interface_1):error(typeRefNode,ts.Diagnostics.A_class_may_only_implement_another_class_or_interface)}}}produceDiagnostics&&(checkIndexConstraints(type),checkTypeForDuplicateIndexSignatures(node))}function getTargetSymbol(s){return 16777216&s.flags?getSymbolLinks(s).target:s}function getClassLikeDeclarationOfSymbol(symbol){return ts.forEach(symbol.declarations,function(d){return ts.isClassLike(d)?d:void 0})}function checkKindsOfPropertyMemberOverrides(type,baseType){for(var baseProperties=getPropertiesOfObjectType(baseType),_i=0,baseProperties_1=baseProperties;_i<baseProperties_1.length;_i++){var baseProperty=baseProperties_1[_i],base=getTargetSymbol(baseProperty);if(!(134217728&base.flags)){var derived=getTargetSymbol(getPropertyOfObjectType(type,base.name)),baseDeclarationFlags=getDeclarationFlagsFromSymbol(base);if(ts.Debug.assert(!!derived,"derived should point to something, even if it is the base class' declaration."),derived)if(derived===base){var derivedClassDecl=getClassLikeDeclarationOfSymbol(type.symbol);!(128&baseDeclarationFlags)||derivedClassDecl&&128&derivedClassDecl.flags||(189===derivedClassDecl.kind?error(derivedClassDecl,ts.Diagnostics.Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1,symbolToString(baseProperty),typeToString(baseType)):error(derivedClassDecl,ts.Diagnostics.Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2,typeToString(type),symbolToString(baseProperty),typeToString(baseType)))}else{var derivedDeclarationFlags=getDeclarationFlagsFromSymbol(derived);if(16&baseDeclarationFlags||16&derivedDeclarationFlags)continue;if((64&baseDeclarationFlags)!==(64&derivedDeclarationFlags))continue;if(base.flags&derived.flags&8192||98308&base.flags&&98308&derived.flags)continue;var errorMessage=void 0;8192&base.flags?98304&derived.flags?errorMessage=ts.Diagnostics.Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_accessor:(ts.Debug.assert(0!==(4&derived.flags)),errorMessage=ts.Diagnostics.Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_property):4&base.flags?(ts.Debug.assert(0!==(8192&derived.flags)),errorMessage=ts.Diagnostics.Class_0_defines_instance_member_property_1_but_extended_class_2_defines_it_as_instance_member_function):(ts.Debug.assert(0!==(98304&base.flags)),ts.Debug.assert(0!==(8192&derived.flags)),errorMessage=ts.Diagnostics.Class_0_defines_instance_member_accessor_1_but_extended_class_2_defines_it_as_instance_member_function),error(derived.valueDeclaration.name,errorMessage,typeToString(baseType),symbolToString(base),typeToString(type))}}}}function isAccessor(kind){return 146===kind||147===kind}function areTypeParametersIdentical(list1,list2){if(!list1&&!list2)return!0;if(!list1||!list2||list1.length!==list2.length)return!1;for(var i=0,len=list1.length;i<len;i++){var tp1=list1[i],tp2=list2[i];if(tp1.name.text!==tp2.name.text)return!1;if(tp1.constraint||tp2.constraint){if(!tp1.constraint||!tp2.constraint)return!1;if(!isTypeIdenticalTo(getTypeFromTypeNode(tp1.constraint),getTypeFromTypeNode(tp2.constraint)))return!1}}return!0}function checkInheritedPropertiesAreIdentical(type,typeNode){var baseTypes=getBaseTypes(type);if(baseTypes.length<2)return!0;var seen={};ts.forEach(resolveDeclaredMembers(type).declaredProperties,function(p){seen[p.name]={prop:p,containingType:type}});for(var ok=!0,_i=0,baseTypes_2=baseTypes;_i<baseTypes_2.length;_i++)for(var base=baseTypes_2[_i],properties=getPropertiesOfObjectType(getTypeWithThisArgument(base,type.thisType)),_a=0,properties_4=properties;_a<properties_4.length;_a++){var prop=properties_4[_a];if(ts.hasProperty(seen,prop.name)){var existing=seen[prop.name],isInheritedProperty=existing.containingType!==type;if(isInheritedProperty&&!isPropertyIdenticalTo(existing.prop,prop)){ok=!1;var typeName1=typeToString(existing.containingType),typeName2=typeToString(base),errorInfo=ts.chainDiagnosticMessages(void 0,ts.Diagnostics.Named_property_0_of_types_1_and_2_are_not_identical,symbolToString(prop),typeName1,typeName2);errorInfo=ts.chainDiagnosticMessages(errorInfo,ts.Diagnostics.Interface_0_cannot_simultaneously_extend_types_1_and_2,typeToString(type),typeName1,typeName2),diagnostics.add(ts.createDiagnosticForNodeFromMessageChain(typeNode,errorInfo))}}else seen[prop.name]={prop:prop,containingType:base}}return ok}function checkInterfaceDeclaration(node){if(checkGrammarDecorators(node)||checkGrammarModifiers(node)||checkGrammarInterfaceDeclaration(node),checkTypeParameters(node.typeParameters),produceDiagnostics){checkTypeNameIsReserved(node.name,ts.Diagnostics.Interface_name_cannot_be_0),checkExportsOnMergedDeclarations(node);var symbol=getSymbolOfNode(node),firstInterfaceDecl=ts.getDeclarationOfKind(symbol,218);if(symbol.declarations.length>1&&(node===firstInterfaceDecl||areTypeParametersIdentical(firstInterfaceDecl.typeParameters,node.typeParameters)||error(node.name,ts.Diagnostics.All_declarations_of_an_interface_must_have_identical_type_parameters)),node===firstInterfaceDecl){var type=getDeclaredTypeOfSymbol(symbol),typeWithThis=getTypeWithThisArgument(type);if(checkInheritedPropertiesAreIdentical(type,node.name)){for(var _i=0,_a=getBaseTypes(type);_i<_a.length;_i++){var baseType=_a[_i];checkTypeAssignableTo(typeWithThis,getTypeWithThisArgument(baseType,type.thisType),node.name,ts.Diagnostics.Interface_0_incorrectly_extends_interface_1)}checkIndexConstraints(type)}}}ts.forEach(ts.getInterfaceBaseTypeNodes(node),function(heritageElement){ts.isSupportedExpressionWithTypeArguments(heritageElement)||error(heritageElement.expression,ts.Diagnostics.An_interface_can_only_extend_an_identifier_Slashqualified_name_with_optional_type_arguments),checkTypeReferenceNode(heritageElement)}),ts.forEach(node.members,checkSourceElement),produceDiagnostics&&checkTypeForDuplicateIndexSignatures(node)}function checkTypeAliasDeclaration(node){checkGrammarDecorators(node)||checkGrammarModifiers(node),checkTypeNameIsReserved(node.name,ts.Diagnostics.Type_alias_name_cannot_be_0),checkSourceElement(node.type)}function computeEnumMemberValues(node){function computeConstantValueForEnumMemberInitializer(initializer,enumType,enumIsConst,ambient){function evalConstant(e){switch(e.kind){case 182:var value_1=evalConstant(e.operand);if(void 0===value_1)return;switch(e.operator){case 35:return value_1;case 36:return-value_1;case 50:return~value_1}return;case 184:var left=evalConstant(e.left);if(void 0===left)return;var right=evalConstant(e.right);if(void 0===right)return;switch(e.operatorToken.kind){case 47:return left|right;case 46:return left&right;case 44:return left>>right;case 45:return left>>>right;case 43:return left<<right;case 48:return left^right;case 37:return left*right;case 39:return left/right;case 35:return left+right;case 36:return left-right;case 40:return left%right}return;case 8:return+e.text;case 175:return evalConstant(e.expression);case 69:case 170:case 169:var enumType_1,member=initializer.parent,currentType=getTypeOfSymbol(getSymbolOfNode(member.parent)),propertyName=void 0;if(69===e.kind)enumType_1=currentType,propertyName=e.text;else{var expression=void 0;if(170===e.kind){if(void 0===e.argumentExpression||9!==e.argumentExpression.kind)return;expression=e.expression,propertyName=e.argumentExpression.text}else expression=e.expression,propertyName=e.name.text;for(var current=expression;current&&69!==current.kind;){if(169!==current.kind)return;current=current.expression}if(enumType_1=checkExpression(expression),!(enumType_1.symbol&&384&enumType_1.symbol.flags))return}if(void 0===propertyName)return;var property=getPropertyOfObjectType(enumType_1,propertyName);if(!(property&&8&property.flags))return;var propertyDecl=property.valueDeclaration;if(member===propertyDecl)return;return isBlockScopedNameDeclaredBeforeUse(propertyDecl,member)?getNodeLinks(propertyDecl).enumMemberValue:(reportError=!1,void error(e,ts.Diagnostics.A_member_initializer_in_a_enum_declaration_cannot_reference_members_declared_after_it_including_members_defined_in_other_enums))}}var reportError=!0,value=evalConstant(initializer);return reportError&&(void 0===value?enumIsConst?error(initializer,ts.Diagnostics.In_const_enum_declarations_member_initializer_must_be_constant_expression):ambient?error(initializer,ts.Diagnostics.In_ambient_enum_declarations_member_initializer_must_be_constant_expression):checkTypeAssignableTo(checkExpression(initializer),enumType,initializer,void 0):enumIsConst&&(isNaN(value)?error(initializer,ts.Diagnostics.const_enum_member_initializer_was_evaluated_to_disallowed_value_NaN):isFinite(value)||error(initializer,ts.Diagnostics.const_enum_member_initializer_was_evaluated_to_a_non_finite_value))),value}var nodeLinks=getNodeLinks(node);if(!(16384&nodeLinks.flags)){for(var enumSymbol=getSymbolOfNode(node),enumType=getDeclaredTypeOfSymbol(enumSymbol),autoValue=0,ambient=ts.isInAmbientContext(node),enumIsConst=ts.isConst(node),_i=0,_a=node.members;_i<_a.length;_i++){var member=_a[_i];if(isComputedNonLiteralName(member.name))error(member.name,ts.Diagnostics.Computed_property_names_are_not_allowed_in_enums);else{var text=getTextOfPropertyName(member.name);isNumericLiteralName(text)&&error(member.name,ts.Diagnostics.An_enum_member_cannot_have_a_numeric_name)}var previousEnumMemberIsNonConstant=void 0===autoValue,initializer=member.initializer;initializer?autoValue=computeConstantValueForEnumMemberInitializer(initializer,enumType,enumIsConst,ambient):ambient&&!enumIsConst?autoValue=void 0:previousEnumMemberIsNonConstant&&error(member.name,ts.Diagnostics.Enum_member_must_have_initializer),void 0!==autoValue&&(getNodeLinks(member).enumMemberValue=autoValue,autoValue++)}nodeLinks.flags|=16384}}function checkEnumDeclaration(node){if(produceDiagnostics){checkGrammarDecorators(node)||checkGrammarModifiers(node),checkTypeNameIsReserved(node.name,ts.Diagnostics.Enum_name_cannot_be_0),checkCollisionWithCapturedThisVariable(node,node.name),checkCollisionWithRequireExportsInGeneratedCode(node,node.name),checkCollisionWithGlobalPromiseInGeneratedCode(node,node.name),checkExportsOnMergedDeclarations(node),computeEnumMemberValues(node);var enumIsConst=ts.isConst(node);compilerOptions.isolatedModules&&enumIsConst&&ts.isInAmbientContext(node)&&error(node.name,ts.Diagnostics.Ambient_const_enums_are_not_allowed_when_the_isolatedModules_flag_is_provided);var enumSymbol=getSymbolOfNode(node),firstDeclaration=ts.getDeclarationOfKind(enumSymbol,node.kind);if(node===firstDeclaration){enumSymbol.declarations.length>1&&ts.forEach(enumSymbol.declarations,function(decl){ts.isConstEnumDeclaration(decl)!==enumIsConst&&error(decl.name,ts.Diagnostics.Enum_declarations_must_all_be_const_or_non_const)});var seenEnumMissingInitialInitializer_1=!1;ts.forEach(enumSymbol.declarations,function(declaration){if(220!==declaration.kind)return!1;var enumDeclaration=declaration;if(!enumDeclaration.members.length)return!1;var firstEnumMember=enumDeclaration.members[0];firstEnumMember.initializer||(seenEnumMissingInitialInitializer_1?error(firstEnumMember.name,ts.Diagnostics.In_an_enum_with_multiple_declarations_only_one_declaration_can_omit_an_initializer_for_its_first_enum_element):seenEnumMissingInitialInitializer_1=!0)})}}}function getFirstNonAmbientClassOrFunctionDeclaration(symbol){for(var declarations=symbol.declarations,_i=0,declarations_5=declarations;_i<declarations_5.length;_i++){var declaration=declarations_5[_i];if((217===declaration.kind||216===declaration.kind&&ts.nodeIsPresent(declaration.body))&&!ts.isInAmbientContext(declaration))return declaration}}function inSameLexicalScope(node1,node2){var container1=ts.getEnclosingBlockScopeContainer(node1),container2=ts.getEnclosingBlockScopeContainer(node2);return isGlobalSourceFile(container1)?isGlobalSourceFile(container2):!isGlobalSourceFile(container2)&&container1===container2}function checkModuleDeclaration(node){if(produceDiagnostics){var isGlobalAugmentation=ts.isGlobalScopeAugmentation(node),inAmbientContext=ts.isInAmbientContext(node);isGlobalAugmentation&&!inAmbientContext&&error(node.name,ts.Diagnostics.Augmentations_for_the_global_scope_should_have_declare_modifier_unless_they_appear_in_already_ambient_context);var isAmbientExternalModule=ts.isAmbientModule(node),contextErrorMessage=isAmbientExternalModule?ts.Diagnostics.An_ambient_module_declaration_is_only_allowed_at_the_top_level_in_a_file:ts.Diagnostics.A_namespace_declaration_is_only_allowed_in_a_namespace_or_module;if(checkGrammarModuleElementContext(node,contextErrorMessage))return;checkGrammarDecorators(node)||checkGrammarModifiers(node)||inAmbientContext||9!==node.name.kind||grammarErrorOnNode(node.name,ts.Diagnostics.Only_ambient_modules_can_use_quoted_names),checkCollisionWithCapturedThisVariable(node,node.name),checkCollisionWithRequireExportsInGeneratedCode(node,node.name),checkCollisionWithGlobalPromiseInGeneratedCode(node,node.name),checkExportsOnMergedDeclarations(node);var symbol=getSymbolOfNode(node);if(512&symbol.flags&&symbol.declarations.length>1&&!inAmbientContext&&ts.isInstantiatedModule(node,compilerOptions.preserveConstEnums||compilerOptions.isolatedModules)){var firstNonAmbientClassOrFunc=getFirstNonAmbientClassOrFunctionDeclaration(symbol);firstNonAmbientClassOrFunc&&(ts.getSourceFileOfNode(node)!==ts.getSourceFileOfNode(firstNonAmbientClassOrFunc)?error(node.name,ts.Diagnostics.A_namespace_declaration_cannot_be_in_a_different_file_from_a_class_or_function_with_which_it_is_merged):node.pos<firstNonAmbientClassOrFunc.pos&&error(node.name,ts.Diagnostics.A_namespace_declaration_cannot_be_located_prior_to_a_class_or_function_with_which_it_is_merged));var mergedClass=ts.getDeclarationOfKind(symbol,217);mergedClass&&inSameLexicalScope(node,mergedClass)&&(getNodeLinks(node).flags|=32768)}if(isAmbientExternalModule)if(ts.isExternalModuleAugmentation(node)){var checkBody=isGlobalAugmentation||33554432&getSymbolOfNode(node).flags;if(checkBody)for(var _i=0,_a=node.body.statements;_i<_a.length;_i++){var statement=_a[_i];checkModuleAugmentationElement(statement,isGlobalAugmentation)}}else isGlobalSourceFile(node.parent)?isGlobalAugmentation?error(node.name,ts.Diagnostics.Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_declarations):ts.isExternalModuleNameRelative(node.name.text)&&error(node.name,ts.Diagnostics.Ambient_module_declaration_cannot_specify_relative_module_name):isGlobalAugmentation?error(node.name,ts.Diagnostics.Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_declarations):error(node.name,ts.Diagnostics.Ambient_modules_cannot_be_nested_in_other_modules_or_namespaces)}checkSourceElement(node.body)}function checkModuleAugmentationElement(node,isGlobalAugmentation){switch(node.kind){case 196:for(var _i=0,_a=node.declarationList.declarations;_i<_a.length;_i++){var decl=_a[_i];checkModuleAugmentationElement(decl,isGlobalAugmentation)}break;case 230:case 231:grammarErrorOnFirstToken(node,ts.Diagnostics.Exports_and_export_assignments_are_not_permitted_in_module_augmentations);break;case 224:if(9!==node.moduleReference.kind){error(node.name,ts.Diagnostics.Module_augmentation_cannot_introduce_new_names_in_the_top_level_scope);break}case 225:grammarErrorOnFirstToken(node,ts.Diagnostics.Imports_are_not_permitted_in_module_augmentations_Consider_moving_them_to_the_enclosing_external_module);break;case 166:case 214:var name_17=node.name;if(ts.isBindingPattern(name_17)){for(var _b=0,_c=name_17.elements;_b<_c.length;_b++){var el=_c[_b];checkModuleAugmentationElement(el,isGlobalAugmentation)}break}case 217:case 220:case 216:case 218:case 221:case 219:var symbol=getSymbolOfNode(node);if(symbol){var reportError=!(33554432&symbol.flags);reportError||(reportError=isGlobalAugmentation?void 0!==symbol.parent:ts.isExternalModuleAugmentation(symbol.parent.valueDeclaration)),reportError&&error(node,ts.Diagnostics.Module_augmentation_cannot_introduce_new_names_in_the_top_level_scope)}}}function getFirstIdentifier(node){for(;;)if(136===node.kind)node=node.left;else{if(169!==node.kind)break;node=node.expression}return ts.Debug.assert(69===node.kind),node}function checkExternalImportOrExportDeclaration(node){var moduleName=ts.getExternalModuleName(node);if(!ts.nodeIsMissing(moduleName)&&9!==moduleName.kind)return error(moduleName,ts.Diagnostics.String_literal_expected),!1;var inAmbientExternalModule=222===node.parent.kind&&ts.isAmbientModule(node.parent.parent);return 251===node.parent.kind||inAmbientExternalModule?!(inAmbientExternalModule&&ts.isExternalModuleNameRelative(moduleName.text)&&!isTopLevelInExternalModuleAugmentation(node))||(error(node,ts.Diagnostics.Import_or_export_declaration_in_an_ambient_module_declaration_cannot_reference_module_through_relative_module_name),!1):(error(moduleName,231===node.kind?ts.Diagnostics.Export_declarations_are_not_permitted_in_a_namespace:ts.Diagnostics.Import_declarations_in_a_namespace_cannot_reference_a_module),!1)}function checkAliasSymbol(node){var symbol=getSymbolOfNode(node),target=resolveAlias(symbol);if(target!==unknownSymbol){var excludedMeanings=(107455&symbol.flags?107455:0)|(793056&symbol.flags?793056:0)|(1536&symbol.flags?1536:0);if(target.flags&excludedMeanings){var message=233===node.kind?ts.Diagnostics.Export_declaration_conflicts_with_exported_declaration_of_0:ts.Diagnostics.Import_declaration_conflicts_with_local_declaration_of_0;error(node,message,symbolToString(symbol))}}}function checkImportBinding(node){checkCollisionWithCapturedThisVariable(node,node.name),checkCollisionWithRequireExportsInGeneratedCode(node,node.name),checkCollisionWithGlobalPromiseInGeneratedCode(node,node.name),checkAliasSymbol(node)}function checkImportDeclaration(node){if(!checkGrammarModuleElementContext(node,ts.Diagnostics.An_import_declaration_can_only_be_used_in_a_namespace_or_module)&&(!checkGrammarDecorators(node)&&!checkGrammarModifiers(node)&&1022&node.flags&&grammarErrorOnFirstToken(node,ts.Diagnostics.An_import_declaration_cannot_have_modifiers),checkExternalImportOrExportDeclaration(node))){var importClause=node.importClause;importClause&&(importClause.name&&checkImportBinding(importClause),importClause.namedBindings&&(227===importClause.namedBindings.kind?checkImportBinding(importClause.namedBindings):ts.forEach(importClause.namedBindings.elements,checkImportBinding)))}}function checkImportEqualsDeclaration(node){if(!checkGrammarModuleElementContext(node,ts.Diagnostics.An_import_declaration_can_only_be_used_in_a_namespace_or_module)&&(checkGrammarDecorators(node)||checkGrammarModifiers(node),ts.isInternalModuleImportEqualsDeclaration(node)||checkExternalImportOrExportDeclaration(node)))if(checkImportBinding(node),2&node.flags&&markExportAsReferenced(node),ts.isInternalModuleImportEqualsDeclaration(node)){var target=resolveAlias(getSymbolOfNode(node));if(target!==unknownSymbol){if(107455&target.flags){var moduleName=getFirstIdentifier(node.moduleReference);1536&resolveEntityName(moduleName,108479).flags||error(moduleName,ts.Diagnostics.Module_0_is_hidden_by_a_local_declaration_with_the_same_name,ts.declarationNameToString(moduleName))}793056&target.flags&&checkTypeNameIsReserved(node.name,ts.Diagnostics.Import_name_cannot_be_0)}}else 5!==modulekind||ts.isInAmbientContext(node)||grammarErrorOnNode(node,ts.Diagnostics.Import_assignment_cannot_be_used_when_targeting_ECMAScript_6_modules_Consider_using_import_Asterisk_as_ns_from_mod_import_a_from_mod_import_d_from_mod_or_another_module_format_instead)}function checkExportDeclaration(node){if(!checkGrammarModuleElementContext(node,ts.Diagnostics.An_export_declaration_can_only_be_used_in_a_module)&&(!checkGrammarDecorators(node)&&!checkGrammarModifiers(node)&&1022&node.flags&&grammarErrorOnFirstToken(node,ts.Diagnostics.An_export_declaration_cannot_have_modifiers),!node.moduleSpecifier||checkExternalImportOrExportDeclaration(node)))if(node.exportClause){ts.forEach(node.exportClause.elements,checkExportSpecifier);var inAmbientExternalModule=222===node.parent.kind&&ts.isAmbientModule(node.parent.parent);251===node.parent.kind||inAmbientExternalModule||error(node,ts.Diagnostics.Export_declarations_are_not_permitted_in_a_namespace)}else{var moduleSymbol=resolveExternalModuleName(node,node.moduleSpecifier);moduleSymbol&&hasExportAssignmentSymbol(moduleSymbol)&&error(node.moduleSpecifier,ts.Diagnostics.Module_0_uses_export_and_cannot_be_used_with_export_Asterisk,symbolToString(moduleSymbol))}}function checkGrammarModuleElementContext(node,errorMessage){if(251!==node.parent.kind&&222!==node.parent.kind&&221!==node.parent.kind)return grammarErrorOnFirstToken(node,errorMessage)}function checkExportSpecifier(node){if(checkAliasSymbol(node),!node.parent.parent.moduleSpecifier){var exportedName=node.propertyName||node.name,symbol=resolveName(exportedName,exportedName.text,9289727,void 0,void 0);symbol&&(symbol===undefinedSymbol||isGlobalSourceFile(getDeclarationContainer(symbol.declarations[0])))?error(exportedName,ts.Diagnostics.Cannot_re_export_name_that_is_not_defined_in_the_module):markExportAsReferenced(node)}}function checkExportAssignment(node){if(!checkGrammarModuleElementContext(node,ts.Diagnostics.An_export_assignment_can_only_be_used_in_a_module)){var container=251===node.parent.kind?node.parent:node.parent.parent;if(221===container.kind&&!ts.isAmbientModule(container))return void error(node,ts.Diagnostics.An_export_assignment_cannot_be_used_in_a_namespace);!checkGrammarDecorators(node)&&!checkGrammarModifiers(node)&&1022&node.flags&&grammarErrorOnFirstToken(node,ts.Diagnostics.An_export_assignment_cannot_have_modifiers),69===node.expression.kind?markExportAsReferenced(node):checkExpressionCached(node.expression),checkExternalModuleExports(container),node.isExportEquals&&!ts.isInAmbientContext(node)&&(5===modulekind?grammarErrorOnNode(node,ts.Diagnostics.Export_assignment_cannot_be_used_when_targeting_ECMAScript_6_modules_Consider_using_export_default_or_another_module_format_instead):4===modulekind&&grammarErrorOnNode(node,ts.Diagnostics.Export_assignment_is_not_supported_when_module_flag_is_system))}}function hasExportedMembers(moduleSymbol){for(var id in moduleSymbol.exports)if("export="!==id)return!0;return!1}function checkExternalModuleExports(node){function isNotOverload(declaration){return 216!==declaration.kind||!!declaration.body}var moduleSymbol=getSymbolOfNode(node),links=getSymbolLinks(moduleSymbol);if(!links.exportsChecked){var exportEqualsSymbol=moduleSymbol.exports["export="];if(exportEqualsSymbol&&hasExportedMembers(moduleSymbol)){
var declaration=getDeclarationOfAliasSymbol(exportEqualsSymbol)||exportEqualsSymbol.valueDeclaration;isTopLevelInExternalModuleAugmentation(declaration)||error(declaration,ts.Diagnostics.An_export_assignment_cannot_be_used_in_a_module_with_other_exported_elements)}var exports=getExportsOfModule(moduleSymbol);for(var id in exports)if("__export"!==id){var _a=exports[id],declarations=_a.declarations,flags=_a.flags;if(!(1984&flags)&&(524288&flags?declarations.length-1:declarations.length)>1){var exportedDeclarations=ts.filter(declarations,isNotOverload);if(exportedDeclarations.length>1)for(var _i=0,exportedDeclarations_1=exportedDeclarations;_i<exportedDeclarations_1.length;_i++){var declaration=exportedDeclarations_1[_i];diagnostics.add(ts.createDiagnosticForNode(declaration,ts.Diagnostics.Cannot_redeclare_exported_variable_0,id))}}}links.exportsChecked=!0}}function checkSourceElement(node){if(node){var kind=node.kind;if(cancellationToken)switch(kind){case 221:case 217:case 218:case 216:cancellationToken.throwIfCancellationRequested()}switch(kind){case 138:return checkTypeParameter(node);case 139:return checkParameter(node);case 142:case 141:return checkPropertyDeclaration(node);case 153:case 154:case 148:case 149:return checkSignatureDeclaration(node);case 150:return checkSignatureDeclaration(node);case 144:case 143:return checkMethodDeclaration(node);case 145:return checkConstructorDeclaration(node);case 146:case 147:return checkAccessorDeclaration(node);case 152:return checkTypeReferenceNode(node);case 151:return checkTypePredicate(node);case 155:return checkTypeQuery(node);case 156:return checkTypeLiteral(node);case 157:return checkArrayType(node);case 158:return checkTupleType(node);case 159:case 160:return checkUnionOrIntersectionType(node);case 161:return checkSourceElement(node.type);case 216:return checkFunctionDeclaration(node);case 195:case 222:return checkBlock(node);case 196:return checkVariableStatement(node);case 198:return checkExpressionStatement(node);case 199:return checkIfStatement(node);case 200:return checkDoStatement(node);case 201:return checkWhileStatement(node);case 202:return checkForStatement(node);case 203:return checkForInStatement(node);case 204:return checkForOfStatement(node);case 205:case 206:return checkBreakOrContinueStatement(node);case 207:return checkReturnStatement(node);case 208:return checkWithStatement(node);case 209:return checkSwitchStatement(node);case 210:return checkLabeledStatement(node);case 211:return checkThrowStatement(node);case 212:return checkTryStatement(node);case 214:return checkVariableDeclaration(node);case 166:return checkBindingElement(node);case 217:return checkClassDeclaration(node);case 218:return checkInterfaceDeclaration(node);case 219:return checkTypeAliasDeclaration(node);case 220:return checkEnumDeclaration(node);case 221:return checkModuleDeclaration(node);case 225:return checkImportDeclaration(node);case 224:return checkImportEqualsDeclaration(node);case 231:return checkExportDeclaration(node);case 230:return checkExportAssignment(node);case 197:return void checkGrammarStatementInAmbientContext(node);case 213:return void checkGrammarStatementInAmbientContext(node);case 234:return checkMissingDeclaration(node)}}}function checkNodeDeferred(node){deferredNodes&&deferredNodes.push(node)}function checkDeferredNodes(){for(var _i=0,deferredNodes_1=deferredNodes;_i<deferredNodes_1.length;_i++){var node=deferredNodes_1[_i];switch(node.kind){case 176:case 177:case 144:case 143:checkFunctionExpressionOrObjectLiteralMethodDeferred(node);break;case 146:case 147:checkAccessorDeferred(node);break;case 189:checkClassExpressionDeferred(node)}}}function checkSourceFile(node){var start=(new Date).getTime();checkSourceFileWorker(node),ts.checkTime+=(new Date).getTime()-start}function checkSourceFileWorker(node){var links=getNodeLinks(node);if(!(1&links.flags)){if(compilerOptions.skipDefaultLibCheck&&node.hasNoDefaultLib)return;checkGrammarSourceFile(node),potentialThisCollisions.length=0,deferredNodes=[],ts.forEach(node.statements,checkSourceElement),checkDeferredNodes(),deferredNodes=void 0,ts.isExternalOrCommonJsModule(node)&&checkExternalModuleExports(node),potentialThisCollisions.length&&(ts.forEach(potentialThisCollisions,checkIfThisIsCapturedInEnclosingScope),potentialThisCollisions.length=0),links.flags|=1}}function getDiagnostics(sourceFile,ct){try{return cancellationToken=ct,getDiagnosticsWorker(sourceFile)}finally{cancellationToken=void 0}}function getDiagnosticsWorker(sourceFile){return throwIfNonDiagnosticsProducing(),sourceFile?(checkSourceFile(sourceFile),diagnostics.getDiagnostics(sourceFile.fileName)):(ts.forEach(host.getSourceFiles(),checkSourceFile),diagnostics.getDiagnostics())}function getGlobalDiagnostics(){return throwIfNonDiagnosticsProducing(),diagnostics.getGlobalDiagnostics()}function throwIfNonDiagnosticsProducing(){if(!produceDiagnostics)throw new Error("Trying to get diagnostics from a type checker that does not produce them.")}function isInsideWithStatementBody(node){if(node)for(;node.parent;){if(208===node.parent.kind&&node.parent.statement===node)return!0;node=node.parent}return!1}function getSymbolsInScope(location,meaning){function populateSymbols(){for(;location;){switch(location.locals&&!isGlobalSourceFile(location)&&copySymbols(location.locals,meaning),location.kind){case 251:if(!ts.isExternalOrCommonJsModule(location))break;case 221:copySymbols(getSymbolOfNode(location).exports,8914931&meaning);break;case 220:copySymbols(getSymbolOfNode(location).exports,8&meaning);break;case 189:var className=location.name;className&&copySymbol(location.symbol,meaning);case 217:case 218:64&memberFlags||copySymbols(getSymbolOfNode(location).members,793056&meaning);break;case 176:var funcName=location.name;funcName&&copySymbol(location.symbol,meaning)}ts.introducesArgumentsExoticObject(location)&&copySymbol(argumentsSymbol,meaning),memberFlags=location.flags,location=location.parent}copySymbols(globals,meaning)}function copySymbol(symbol,meaning){if(symbol.flags&meaning){var id=symbol.name;ts.hasProperty(symbols,id)||(symbols[id]=symbol)}}function copySymbols(source,meaning){if(meaning)for(var id in source){var symbol=source[id];copySymbol(symbol,meaning)}}var symbols={},memberFlags=0;return isInsideWithStatementBody(location)?[]:(populateSymbols(),symbolsToArray(symbols))}function isTypeDeclarationName(name){return 69===name.kind&&isTypeDeclaration(name.parent)&&name.parent.name===name}function isTypeDeclaration(node){switch(node.kind){case 138:case 217:case 218:case 219:case 220:return!0}}function isTypeReferenceIdentifier(entityName){for(var node=entityName;node.parent&&136===node.parent.kind;)node=node.parent;return node.parent&&152===node.parent.kind}function isHeritageClauseElementIdentifier(entityName){for(var node=entityName;node.parent&&169===node.parent.kind;)node=node.parent;return node.parent&&191===node.parent.kind}function getLeftSideOfImportEqualsOrExportAssignment(nodeOnRightSide){for(;136===nodeOnRightSide.parent.kind;)nodeOnRightSide=nodeOnRightSide.parent;return 224===nodeOnRightSide.parent.kind?nodeOnRightSide.parent.moduleReference===nodeOnRightSide&&nodeOnRightSide.parent:230===nodeOnRightSide.parent.kind?nodeOnRightSide.parent.expression===nodeOnRightSide&&nodeOnRightSide.parent:void 0}function isInRightSideOfImportOrExportAssignment(node){return void 0!==getLeftSideOfImportEqualsOrExportAssignment(node)}function getSymbolOfEntityNameOrPropertyAccessExpression(entityName){if(ts.isDeclarationName(entityName))return getSymbolOfNode(entityName.parent);if(ts.isInJavaScriptFile(entityName)&&169===entityName.parent.kind){var specialPropertyAssignmentKind=ts.getSpecialPropertyAssignmentKind(entityName.parent.parent);switch(specialPropertyAssignmentKind){case 1:case 3:return getSymbolOfNode(entityName.parent);case 4:case 2:return getSymbolOfNode(entityName.parent.parent)}}if(230===entityName.parent.kind)return resolveEntityName(entityName,9289727);if(169!==entityName.kind&&isInRightSideOfImportOrExportAssignment(entityName))return getSymbolOfPartOfRightHandSideOfImportEquals(entityName);if(ts.isRightSideOfQualifiedNameOrPropertyAccess(entityName)&&(entityName=entityName.parent),isHeritageClauseElementIdentifier(entityName)){var meaning=0;return 191===entityName.parent.kind?(meaning=793056,ts.isExpressionWithTypeArgumentsInClassExtendsClause(entityName.parent)&&(meaning|=107455)):meaning=1536,meaning|=8388608,resolveEntityName(entityName,meaning)}if(238===entityName.parent.kind||237===entityName.parent.kind||240===entityName.parent.kind)return getJsxElementTagSymbol(entityName.parent);if(ts.isExpression(entityName)){if(ts.nodeIsMissing(entityName))return;if(69===entityName.kind){var meaning=8496063;return resolveEntityName(entityName,meaning)}if(169===entityName.kind){var symbol=getNodeLinks(entityName).resolvedSymbol;return symbol||checkPropertyAccessExpression(entityName),getNodeLinks(entityName).resolvedSymbol}if(136===entityName.kind){var symbol=getNodeLinks(entityName).resolvedSymbol;return symbol||checkQualifiedName(entityName),getNodeLinks(entityName).resolvedSymbol}}else{if(isTypeReferenceIdentifier(entityName)){var meaning=152===entityName.parent.kind?793056:1536;return meaning|=8388608,resolveEntityName(entityName,meaning)}if(241===entityName.parent.kind)return getJsxAttributePropertySymbol(entityName.parent)}return 151===entityName.parent.kind?resolveEntityName(entityName,1):void 0}function getSymbolAtLocation(node){if(!isInsideWithStatementBody(node)){if(ts.isDeclarationName(node))return getSymbolOfNode(node.parent);if(69===node.kind){if(isInRightSideOfImportOrExportAssignment(node))return 230===node.parent.kind?getSymbolOfEntityNameOrPropertyAccessExpression(node):getSymbolOfPartOfRightHandSideOfImportEquals(node);if(166===node.parent.kind&&164===node.parent.parent.kind&&node===node.parent.propertyName){var typeOfPattern=getTypeOfNode(node.parent.parent),propertyDeclaration=typeOfPattern&&getPropertyOfType(typeOfPattern,node.text);if(propertyDeclaration)return propertyDeclaration}}switch(node.kind){case 69:case 169:case 136:return getSymbolOfEntityNameOrPropertyAccessExpression(node);case 97:case 95:var type=ts.isExpression(node)?checkExpression(node):getTypeFromTypeNode(node);return type.symbol;case 162:return getTypeFromTypeNode(node).symbol;case 121:var constructorDeclaration=node.parent;if(constructorDeclaration&&145===constructorDeclaration.kind)return constructorDeclaration.parent.symbol;return;case 9:if(ts.isExternalModuleImportEqualsDeclaration(node.parent.parent)&&ts.getExternalModuleImportEqualsDeclarationExpression(node.parent.parent)===node||(225===node.parent.kind||231===node.parent.kind)&&node.parent.moduleSpecifier===node)return resolveExternalModuleName(node,node);case 8:if(170===node.parent.kind&&node.parent.argumentExpression===node){var objectType=checkExpression(node.parent.expression);if(objectType===unknownType)return;var apparentType=getApparentType(objectType);if(apparentType===unknownType)return;return getPropertyOfType(apparentType,node.text)}}}}function getShorthandAssignmentValueSymbol(location){if(location&&249===location.kind)return resolveEntityName(location.name,8496063)}function getExportSpecifierLocalTargetSymbol(node){return node.parent.parent.moduleSpecifier?getExternalModuleMember(node.parent.parent,node):resolveEntityName(node.propertyName||node.name,9289727)}function getTypeOfNode(node){if(isInsideWithStatementBody(node))return unknownType;if(ts.isTypeNode(node))return getTypeFromTypeNode(node);if(ts.isExpression(node))return getTypeOfExpression(node);if(ts.isExpressionWithTypeArgumentsInClassExtendsClause(node))return getBaseTypes(getDeclaredTypeOfSymbol(getSymbolOfNode(node.parent.parent)))[0];if(isTypeDeclaration(node)){var symbol=getSymbolOfNode(node);return getDeclaredTypeOfSymbol(symbol)}if(isTypeDeclarationName(node)){var symbol=getSymbolAtLocation(node);return symbol&&getDeclaredTypeOfSymbol(symbol)}if(ts.isDeclaration(node)){var symbol=getSymbolOfNode(node);return getTypeOfSymbol(symbol)}if(ts.isDeclarationName(node)){var symbol=getSymbolAtLocation(node);return symbol&&getTypeOfSymbol(symbol)}if(ts.isBindingPattern(node))return getTypeForVariableLikeDeclaration(node.parent);if(isInRightSideOfImportOrExportAssignment(node)){var symbol=getSymbolAtLocation(node),declaredType=symbol&&getDeclaredTypeOfSymbol(symbol);return declaredType!==unknownType?declaredType:getTypeOfSymbol(symbol)}return unknownType}function getTypeOfExpression(expr){return ts.isRightSideOfQualifiedNameOrPropertyAccess(expr)&&(expr=expr.parent),checkExpression(expr)}function getParentTypeOfClassElement(node){var classSymbol=getSymbolOfNode(node.parent);return 64&node.flags?getTypeOfSymbol(classSymbol):getDeclaredTypeOfSymbol(classSymbol)}function getAugmentedPropertiesOfType(type){type=getApparentType(type);var propsByName=createSymbolTable(getPropertiesOfType(type));return(getSignaturesOfType(type,0).length||getSignaturesOfType(type,1).length)&&ts.forEach(getPropertiesOfType(globalFunctionType),function(p){ts.hasProperty(propsByName,p.name)||(propsByName[p.name]=p)}),getNamedMembers(propsByName)}function getRootSymbols(symbol){if(268435456&symbol.flags){var symbols_3=[],name_18=symbol.name;return ts.forEach(getSymbolLinks(symbol).containingType.types,function(t){var symbol=getPropertyOfType(t,name_18);symbol&&symbols_3.push(symbol)}),symbols_3}if(67108864&symbol.flags){var target=getSymbolLinks(symbol).target;if(target)return[target]}return[symbol]}function isArgumentsLocalBinding(node){return getReferencedValueSymbol(node)===argumentsSymbol}function moduleExportsSomeValue(moduleReferenceExpression){function isValue(s){return s=resolveSymbol(s),s&&!!(107455&s.flags)}var moduleSymbol=resolveExternalModuleName(moduleReferenceExpression.parent,moduleReferenceExpression);if(!moduleSymbol)return!0;var hasExportAssignment=hasExportAssignmentSymbol(moduleSymbol);moduleSymbol=resolveExternalModuleSymbol(moduleSymbol);var symbolLinks=getSymbolLinks(moduleSymbol);return void 0===symbolLinks.exportsSomeValue&&(symbolLinks.exportsSomeValue=hasExportAssignment?!!(107455&moduleSymbol.flags):ts.forEachValue(getExportsOfModule(moduleSymbol),isValue)),symbolLinks.exportsSomeValue}function getReferencedExportContainer(node){var symbol=getReferencedValueSymbol(node);if(symbol){if(1048576&symbol.flags){var exportSymbol=getMergedSymbol(symbol.exportSymbol);if(944&exportSymbol.flags)return;symbol=exportSymbol}var parentSymbol=getParentOfSymbol(symbol);if(parentSymbol){if(512&parentSymbol.flags&&251===parentSymbol.valueDeclaration.kind)return parentSymbol.valueDeclaration;for(var n=node.parent;n;n=n.parent)if((221===n.kind||220===n.kind)&&getSymbolOfNode(n)===parentSymbol)return n}}}function getReferencedImportDeclaration(node){var symbol=getReferencedValueSymbol(node);return symbol&&8388608&symbol.flags?getDeclarationOfAliasSymbol(symbol):void 0}function isSymbolOfDeclarationWithCollidingName(symbol){if(418&symbol.flags){var links=getSymbolLinks(symbol);if(void 0===links.isDeclaratonWithCollidingName){var container=ts.getEnclosingBlockScopeContainer(symbol.valueDeclaration);if(ts.isStatementWithLocals(container)){var nodeLinks_1=getNodeLinks(symbol.valueDeclaration);if(resolveName(container.parent,symbol.name,107455,void 0,void 0))links.isDeclaratonWithCollidingName=!0;else if(131072&nodeLinks_1.flags){var isDeclaredInLoop=262144&nodeLinks_1.flags,inLoopInitializer=ts.isIterationStatement(container,!1),inLoopBodyBlock=195===container.kind&&ts.isIterationStatement(container.parent,!1);links.isDeclaratonWithCollidingName=!(ts.isBlockScopedContainerTopLevel(container)||isDeclaredInLoop&&(inLoopInitializer||inLoopBodyBlock))}else links.isDeclaratonWithCollidingName=!1}}return links.isDeclaratonWithCollidingName}return!1}function getReferencedDeclarationWithCollidingName(node){var symbol=getReferencedValueSymbol(node);return symbol&&isSymbolOfDeclarationWithCollidingName(symbol)?symbol.valueDeclaration:void 0}function isDeclarationWithCollidingName(node){return isSymbolOfDeclarationWithCollidingName(getSymbolOfNode(node))}function isValueAliasDeclaration(node){switch(node.kind){case 224:case 226:case 227:case 229:case 233:return isAliasResolvedToValue(getSymbolOfNode(node));case 231:var exportClause=node.exportClause;return exportClause&&ts.forEach(exportClause.elements,isValueAliasDeclaration);case 230:return!node.expression||69!==node.expression.kind||isAliasResolvedToValue(getSymbolOfNode(node))}return!1}function isTopLevelValueImportEqualsWithEntityName(node){if(251!==node.parent.kind||!ts.isInternalModuleImportEqualsDeclaration(node))return!1;var isValue=isAliasResolvedToValue(getSymbolOfNode(node));return isValue&&node.moduleReference&&!ts.nodeIsMissing(node.moduleReference)}function isAliasResolvedToValue(symbol){var target=resolveAlias(symbol);return!(target!==unknownSymbol||!compilerOptions.isolatedModules)||target!==unknownSymbol&&target&&107455&target.flags&&(compilerOptions.preserveConstEnums||!isConstEnumOrConstEnumOnlyModule(target))}function isConstEnumOrConstEnumOnlyModule(s){return isConstEnumSymbol(s)||s.constEnumOnlyModule}function isReferencedAliasDeclaration(node,checkChildren){if(ts.isAliasSymbolDeclaration(node)){var symbol=getSymbolOfNode(node);if(getSymbolLinks(symbol).referenced)return!0}return!!checkChildren&&ts.forEachChild(node,function(node){return isReferencedAliasDeclaration(node,checkChildren)})}function isImplementationOfOverload(node){if(ts.nodeIsPresent(node.body)){var symbol=getSymbolOfNode(node),signaturesOfSymbol=getSignaturesOfSymbol(symbol);return signaturesOfSymbol.length>1||1===signaturesOfSymbol.length&&signaturesOfSymbol[0].declaration!==node}return!1}function getNodeCheckFlags(node){return getNodeLinks(node).flags}function getEnumMemberValue(node){return computeEnumMemberValues(node.parent),getNodeLinks(node).enumMemberValue}function getConstantValue(node){if(250===node.kind)return getEnumMemberValue(node);var symbol=getNodeLinks(node).resolvedSymbol;return symbol&&8&symbol.flags&&ts.isConstEnumDeclaration(symbol.valueDeclaration.parent)?getEnumMemberValue(symbol.valueDeclaration):void 0}function isFunctionType(type){return 80896&type.flags&&getSignaturesOfType(type,0).length>0}function getTypeReferenceSerializationKind(typeName){var valueSymbol=resolveEntityName(typeName,107455,!0),constructorType=valueSymbol?getTypeOfSymbol(valueSymbol):void 0;if(constructorType&&isConstructorType(constructorType))return ts.TypeReferenceSerializationKind.TypeWithConstructSignatureAndValue;var typeSymbol=resolveEntityName(typeName,793056,!0);if(!typeSymbol)return ts.TypeReferenceSerializationKind.ObjectType;var type=getDeclaredTypeOfSymbol(typeSymbol);return type===unknownType?ts.TypeReferenceSerializationKind.Unknown:1&type.flags?ts.TypeReferenceSerializationKind.ObjectType:allConstituentTypesHaveKind(type,16)?ts.TypeReferenceSerializationKind.VoidType:allConstituentTypesHaveKind(type,8)?ts.TypeReferenceSerializationKind.BooleanType:allConstituentTypesHaveKind(type,132)?ts.TypeReferenceSerializationKind.NumberLikeType:allConstituentTypesHaveKind(type,258)?ts.TypeReferenceSerializationKind.StringLikeType:allConstituentTypesHaveKind(type,8192)?ts.TypeReferenceSerializationKind.ArrayLikeType:allConstituentTypesHaveKind(type,16777216)?ts.TypeReferenceSerializationKind.ESSymbolType:isFunctionType(type)?ts.TypeReferenceSerializationKind.TypeWithCallSignature:isArrayType(type)?ts.TypeReferenceSerializationKind.ArrayLikeType:ts.TypeReferenceSerializationKind.ObjectType}function writeTypeOfDeclaration(declaration,enclosingDeclaration,flags,writer){var symbol=getSymbolOfNode(declaration),type=!symbol||133120&symbol.flags?unknownType:getTypeOfSymbol(symbol);getSymbolDisplayBuilder().buildTypeDisplay(type,writer,enclosingDeclaration,flags)}function writeReturnTypeOfSignatureDeclaration(signatureDeclaration,enclosingDeclaration,flags,writer){var signature=getSignatureFromDeclaration(signatureDeclaration);getSymbolDisplayBuilder().buildTypeDisplay(getReturnTypeOfSignature(signature),writer,enclosingDeclaration,flags)}function writeTypeOfExpression(expr,enclosingDeclaration,flags,writer){var type=getTypeOfExpression(expr);getSymbolDisplayBuilder().buildTypeDisplay(type,writer,enclosingDeclaration,flags)}function hasGlobalName(name){return ts.hasProperty(globals,name)}function getReferencedValueSymbol(reference){return getNodeLinks(reference).resolvedSymbol||resolveName(reference,reference.text,9544639,void 0,void 0)}function getReferencedValueDeclaration(reference){ts.Debug.assert(!ts.nodeIsSynthesized(reference));var symbol=getReferencedValueSymbol(reference);return symbol&&getExportSymbolOfValueSymbolIfExported(symbol).valueDeclaration}function createResolver(){return{getReferencedExportContainer:getReferencedExportContainer,getReferencedImportDeclaration:getReferencedImportDeclaration,getReferencedDeclarationWithCollidingName:getReferencedDeclarationWithCollidingName,isDeclarationWithCollidingName:isDeclarationWithCollidingName,isValueAliasDeclaration:isValueAliasDeclaration,hasGlobalName:hasGlobalName,isReferencedAliasDeclaration:isReferencedAliasDeclaration,getNodeCheckFlags:getNodeCheckFlags,isTopLevelValueImportEqualsWithEntityName:isTopLevelValueImportEqualsWithEntityName,isDeclarationVisible:isDeclarationVisible,isImplementationOfOverload:isImplementationOfOverload,writeTypeOfDeclaration:writeTypeOfDeclaration,writeReturnTypeOfSignatureDeclaration:writeReturnTypeOfSignatureDeclaration,writeTypeOfExpression:writeTypeOfExpression,isSymbolAccessible:isSymbolAccessible,isEntityNameVisible:isEntityNameVisible,getConstantValue:getConstantValue,collectLinkedAliases:collectLinkedAliases,getReferencedValueDeclaration:getReferencedValueDeclaration,getTypeReferenceSerializationKind:getTypeReferenceSerializationKind,isOptionalParameter:isOptionalParameter,moduleExportsSomeValue:moduleExportsSomeValue,isArgumentsLocalBinding:isArgumentsLocalBinding,getExternalModuleFileFromDeclaration:getExternalModuleFileFromDeclaration}}function getExternalModuleFileFromDeclaration(declaration){var specifier=ts.getExternalModuleName(declaration),moduleSymbol=resolveExternalModuleNameWorker(specifier,specifier,void 0);if(moduleSymbol)return ts.getDeclarationOfKind(moduleSymbol,251)}function initializeTypeChecker(){ts.forEach(host.getSourceFiles(),function(file){ts.bindSourceFile(file,compilerOptions)});var augmentations;if(ts.forEach(host.getSourceFiles(),function(file){ts.isExternalOrCommonJsModule(file)||mergeSymbolTable(globals,file.locals),file.moduleAugmentations.length&&(augmentations||(augmentations=[])).push(file.moduleAugmentations)}),augmentations)for(var _i=0,augmentations_1=augmentations;_i<augmentations_1.length;_i++)for(var list=augmentations_1[_i],_a=0,list_2=list;_a<list_2.length;_a++){var augmentation=list_2[_a];mergeModuleAugmentation(augmentation)}addToSymbolTable(globals,builtinGlobals,ts.Diagnostics.Declaration_name_conflicts_with_built_in_global_identifier_0),getSymbolLinks(undefinedSymbol).type=undefinedType,getSymbolLinks(argumentsSymbol).type=getGlobalType("IArguments"),getSymbolLinks(unknownSymbol).type=unknownType,globalArrayType=getGlobalType("Array",1),globalObjectType=getGlobalType("Object"),globalFunctionType=getGlobalType("Function"),globalStringType=getGlobalType("String"),globalNumberType=getGlobalType("Number"),globalBooleanType=getGlobalType("Boolean"),globalRegExpType=getGlobalType("RegExp"),jsxElementType=getExportedTypeFromNamespace("JSX",JsxNames.Element),getGlobalClassDecoratorType=ts.memoize(function(){return getGlobalType("ClassDecorator")}),getGlobalPropertyDecoratorType=ts.memoize(function(){return getGlobalType("PropertyDecorator")}),getGlobalMethodDecoratorType=ts.memoize(function(){return getGlobalType("MethodDecorator")}),getGlobalParameterDecoratorType=ts.memoize(function(){return getGlobalType("ParameterDecorator")}),getGlobalTypedPropertyDescriptorType=ts.memoize(function(){return getGlobalType("TypedPropertyDescriptor",1)}),getGlobalPromiseType=ts.memoize(function(){return getGlobalType("Promise",1)}),tryGetGlobalPromiseType=ts.memoize(function(){return getGlobalSymbol("Promise",793056,void 0)&&getGlobalPromiseType()}),getGlobalPromiseLikeType=ts.memoize(function(){return getGlobalType("PromiseLike",1)}),getInstantiatedGlobalPromiseLikeType=ts.memoize(createInstantiatedPromiseLikeType),getGlobalPromiseConstructorSymbol=ts.memoize(function(){return getGlobalValueSymbol("Promise")}),getGlobalPromiseConstructorLikeType=ts.memoize(function(){return getGlobalType("PromiseConstructorLike")}),getGlobalThenableType=ts.memoize(createThenableType),languageVersion>=2?(globalTemplateStringsArrayType=getGlobalType("TemplateStringsArray"),globalESSymbolType=getGlobalType("Symbol"),globalESSymbolConstructorSymbol=getGlobalValueSymbol("Symbol"),globalIterableType=getGlobalType("Iterable",1),globalIteratorType=getGlobalType("Iterator",1),globalIterableIteratorType=getGlobalType("IterableIterator",1)):(globalTemplateStringsArrayType=unknownType,globalESSymbolType=createAnonymousType(void 0,emptySymbols,emptyArray,emptyArray,void 0,void 0),globalESSymbolConstructorSymbol=void 0,globalIterableType=emptyGenericType,globalIteratorType=emptyGenericType,globalIterableIteratorType=emptyGenericType),anyArrayType=createArrayType(anyType)}function createInstantiatedPromiseLikeType(){var promiseLikeType=getGlobalPromiseLikeType();return promiseLikeType!==emptyGenericType?createTypeReference(promiseLikeType,[anyType]):emptyObjectType}function createThenableType(){var thenPropertySymbol=createSymbol(67108868,"then");getSymbolLinks(thenPropertySymbol).type=globalFunctionType;var thenableType=createObjectType(65536);return thenableType.properties=[thenPropertySymbol],thenableType.members=createSymbolTable(thenableType.properties),thenableType.callSignatures=[],thenableType.constructSignatures=[],thenableType}function checkGrammarDecorators(node){if(!node.decorators)return!1;if(!ts.nodeCanBeDecorated(node))return 144!==node.kind||ts.nodeIsPresent(node.body)?grammarErrorOnFirstToken(node,ts.Diagnostics.Decorators_are_not_valid_here):grammarErrorOnFirstToken(node,ts.Diagnostics.A_decorator_can_only_decorate_a_method_implementation_not_an_overload);if(146===node.kind||147===node.kind){var accessors=ts.getAllAccessorDeclarations(node.parent.members,node);if(accessors.firstAccessor.decorators&&node===accessors.secondAccessor)return grammarErrorOnFirstToken(node,ts.Diagnostics.Decorators_cannot_be_applied_to_multiple_get_Slashset_accessors_of_the_same_name)}return!1}function checkGrammarModifiers(node){switch(node.kind){case 146:case 147:case 145:case 142:case 141:case 144:case 143:case 150:case 221:case 225:case 224:case 231:case 230:case 139:break;case 216:if(node.modifiers&&(node.modifiers.length>1||118!==node.modifiers[0].kind)&&222!==node.parent.kind&&251!==node.parent.kind)return grammarErrorOnFirstToken(node,ts.Diagnostics.Modifiers_cannot_appear_here);break;case 217:case 218:case 196:case 219:if(node.modifiers&&222!==node.parent.kind&&251!==node.parent.kind)return grammarErrorOnFirstToken(node,ts.Diagnostics.Modifiers_cannot_appear_here);break;case 220:if(node.modifiers&&(node.modifiers.length>1||74!==node.modifiers[0].kind)&&222!==node.parent.kind&&251!==node.parent.kind)return grammarErrorOnFirstToken(node,ts.Diagnostics.Modifiers_cannot_appear_here);break;default:return!1}if(node.modifiers){for(var lastStatic,lastPrivate,lastProtected,lastDeclare,lastAsync,flags=0,_i=0,_a=node.modifiers;_i<_a.length;_i++){var modifier=_a[_i];switch(modifier.kind){case 74:if(220!==node.kind&&217===node.parent.kind)return grammarErrorOnNode(node,ts.Diagnostics.A_class_member_cannot_have_the_0_keyword,ts.tokenToString(74));break;case 112:case 111:case 110:var text=void 0;if(112===modifier.kind?text="public":111===modifier.kind?(text="protected",lastProtected=modifier):(text="private",lastPrivate=modifier),56&flags)return grammarErrorOnNode(modifier,ts.Diagnostics.Accessibility_modifier_already_seen);if(64&flags)return grammarErrorOnNode(modifier,ts.Diagnostics._0_modifier_must_precede_1_modifier,text,"static");if(256&flags)return grammarErrorOnNode(modifier,ts.Diagnostics._0_modifier_must_precede_1_modifier,text,"async");if(222===node.parent.kind||251===node.parent.kind)return grammarErrorOnNode(modifier,ts.Diagnostics._0_modifier_cannot_appear_on_a_module_element,text);if(128&flags)return 110===modifier.kind?grammarErrorOnNode(modifier,ts.Diagnostics._0_modifier_cannot_be_used_with_1_modifier,text,"abstract"):grammarErrorOnNode(modifier,ts.Diagnostics._0_modifier_must_precede_1_modifier,text,"abstract");flags|=ts.modifierToFlag(modifier.kind);break;case 113:if(64&flags)return grammarErrorOnNode(modifier,ts.Diagnostics._0_modifier_already_seen,"static");if(256&flags)return grammarErrorOnNode(modifier,ts.Diagnostics._0_modifier_must_precede_1_modifier,"static","async");if(222===node.parent.kind||251===node.parent.kind)return grammarErrorOnNode(modifier,ts.Diagnostics._0_modifier_cannot_appear_on_a_module_element,"static");if(139===node.kind)return grammarErrorOnNode(modifier,ts.Diagnostics._0_modifier_cannot_appear_on_a_parameter,"static");if(128&flags)return grammarErrorOnNode(modifier,ts.Diagnostics._0_modifier_cannot_be_used_with_1_modifier,"static","abstract");flags|=64,lastStatic=modifier;break;case 82:if(2&flags)return grammarErrorOnNode(modifier,ts.Diagnostics._0_modifier_already_seen,"export");if(4&flags)return grammarErrorOnNode(modifier,ts.Diagnostics._0_modifier_must_precede_1_modifier,"export","declare");if(128&flags)return grammarErrorOnNode(modifier,ts.Diagnostics._0_modifier_must_precede_1_modifier,"export","abstract");if(256&flags)return grammarErrorOnNode(modifier,ts.Diagnostics._0_modifier_must_precede_1_modifier,"export","async");if(217===node.parent.kind)return grammarErrorOnNode(modifier,ts.Diagnostics._0_modifier_cannot_appear_on_a_class_element,"export");if(139===node.kind)return grammarErrorOnNode(modifier,ts.Diagnostics._0_modifier_cannot_appear_on_a_parameter,"export");flags|=2;break;case 122:if(4&flags)return grammarErrorOnNode(modifier,ts.Diagnostics._0_modifier_already_seen,"declare");if(256&flags)return grammarErrorOnNode(modifier,ts.Diagnostics._0_modifier_cannot_be_used_in_an_ambient_context,"async");if(217===node.parent.kind)return grammarErrorOnNode(modifier,ts.Diagnostics._0_modifier_cannot_appear_on_a_class_element,"declare");if(139===node.kind)return grammarErrorOnNode(modifier,ts.Diagnostics._0_modifier_cannot_appear_on_a_parameter,"declare");if(ts.isInAmbientContext(node.parent)&&222===node.parent.kind)return grammarErrorOnNode(modifier,ts.Diagnostics.A_declare_modifier_cannot_be_used_in_an_already_ambient_context);flags|=4,lastDeclare=modifier;break;case 115:if(128&flags)return grammarErrorOnNode(modifier,ts.Diagnostics._0_modifier_already_seen,"abstract");if(217!==node.kind){if(144!==node.kind)return grammarErrorOnNode(modifier,ts.Diagnostics.abstract_modifier_can_only_appear_on_a_class_or_method_declaration);if(!(217===node.parent.kind&&128&node.parent.flags))return grammarErrorOnNode(modifier,ts.Diagnostics.Abstract_methods_can_only_appear_within_an_abstract_class);if(64&flags)return grammarErrorOnNode(modifier,ts.Diagnostics._0_modifier_cannot_be_used_with_1_modifier,"static","abstract");if(16&flags)return grammarErrorOnNode(modifier,ts.Diagnostics._0_modifier_cannot_be_used_with_1_modifier,"private","abstract")}flags|=128;break;case 118:if(256&flags)return grammarErrorOnNode(modifier,ts.Diagnostics._0_modifier_already_seen,"async");if(4&flags||ts.isInAmbientContext(node.parent))return grammarErrorOnNode(modifier,ts.Diagnostics._0_modifier_cannot_be_used_in_an_ambient_context,"async");if(139===node.kind)return grammarErrorOnNode(modifier,ts.Diagnostics._0_modifier_cannot_appear_on_a_parameter,"async");flags|=256,lastAsync=modifier}}if(145!==node.kind)return(225===node.kind||224===node.kind)&&4&flags?grammarErrorOnNode(lastDeclare,ts.Diagnostics.A_0_modifier_cannot_be_used_with_an_import_declaration,"declare"):139===node.kind&&56&flags&&ts.isBindingPattern(node.name)?grammarErrorOnNode(node,ts.Diagnostics.A_parameter_property_may_not_be_a_binding_pattern):256&flags?checkGrammarAsyncModifier(node,lastAsync):void 0;
if(64&flags)return grammarErrorOnNode(lastStatic,ts.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration,"static");if(128&flags)return grammarErrorOnNode(lastStatic,ts.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration,"abstract");if(32&flags)return grammarErrorOnNode(lastProtected,ts.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration,"protected");if(16&flags)return grammarErrorOnNode(lastPrivate,ts.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration,"private");if(256&flags)return grammarErrorOnNode(lastAsync,ts.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration,"async")}}function checkGrammarAsyncModifier(node,asyncModifier){if(languageVersion<2)return grammarErrorOnNode(asyncModifier,ts.Diagnostics.Async_functions_are_only_available_when_targeting_ECMAScript_6_and_higher);switch(node.kind){case 144:case 216:case 176:case 177:if(!node.asteriskToken)return!1}return grammarErrorOnNode(asyncModifier,ts.Diagnostics._0_modifier_cannot_be_used_here,"async")}function checkGrammarForDisallowedTrailingComma(list){if(list&&list.hasTrailingComma){var start=list.end-",".length,end=list.end,sourceFile=ts.getSourceFileOfNode(list[0]);return grammarErrorAtPos(sourceFile,start,end-start,ts.Diagnostics.Trailing_comma_not_allowed)}}function checkGrammarTypeParameterList(node,typeParameters,file){if(checkGrammarForDisallowedTrailingComma(typeParameters))return!0;if(typeParameters&&0===typeParameters.length){var start=typeParameters.pos-"<".length,end=ts.skipTrivia(file.text,typeParameters.end)+">".length;return grammarErrorAtPos(file,start,end-start,ts.Diagnostics.Type_parameter_list_cannot_be_empty)}}function checkGrammarParameterList(parameters){if(checkGrammarForDisallowedTrailingComma(parameters))return!0;for(var seenOptionalParameter=!1,parameterCount=parameters.length,i=0;i<parameterCount;i++){var parameter=parameters[i];if(parameter.dotDotDotToken){if(i!==parameterCount-1)return grammarErrorOnNode(parameter.dotDotDotToken,ts.Diagnostics.A_rest_parameter_must_be_last_in_a_parameter_list);if(ts.isBindingPattern(parameter.name))return grammarErrorOnNode(parameter.name,ts.Diagnostics.A_rest_element_cannot_contain_a_binding_pattern);if(parameter.questionToken)return grammarErrorOnNode(parameter.questionToken,ts.Diagnostics.A_rest_parameter_cannot_be_optional);if(parameter.initializer)return grammarErrorOnNode(parameter.name,ts.Diagnostics.A_rest_parameter_cannot_have_an_initializer)}else if(parameter.questionToken){if(seenOptionalParameter=!0,parameter.initializer)return grammarErrorOnNode(parameter.name,ts.Diagnostics.Parameter_cannot_have_question_mark_and_initializer)}else if(seenOptionalParameter&&!parameter.initializer)return grammarErrorOnNode(parameter.name,ts.Diagnostics.A_required_parameter_cannot_follow_an_optional_parameter)}}function checkGrammarFunctionLikeDeclaration(node){var file=ts.getSourceFileOfNode(node);return checkGrammarDecorators(node)||checkGrammarModifiers(node)||checkGrammarTypeParameterList(node,node.typeParameters,file)||checkGrammarParameterList(node.parameters)||checkGrammarArrowFunction(node,file)}function checkGrammarArrowFunction(node,file){if(177===node.kind){var arrowFunction=node,startLine=ts.getLineAndCharacterOfPosition(file,arrowFunction.equalsGreaterThanToken.pos).line,endLine=ts.getLineAndCharacterOfPosition(file,arrowFunction.equalsGreaterThanToken.end).line;if(startLine!==endLine)return grammarErrorOnNode(arrowFunction.equalsGreaterThanToken,ts.Diagnostics.Line_terminator_not_permitted_before_arrow)}return!1}function checkGrammarIndexSignatureParameters(node){var parameter=node.parameters[0];return 1!==node.parameters.length?parameter?grammarErrorOnNode(parameter.name,ts.Diagnostics.An_index_signature_must_have_exactly_one_parameter):grammarErrorOnNode(node,ts.Diagnostics.An_index_signature_must_have_exactly_one_parameter):parameter.dotDotDotToken?grammarErrorOnNode(parameter.dotDotDotToken,ts.Diagnostics.An_index_signature_cannot_have_a_rest_parameter):1022&parameter.flags?grammarErrorOnNode(parameter.name,ts.Diagnostics.An_index_signature_parameter_cannot_have_an_accessibility_modifier):parameter.questionToken?grammarErrorOnNode(parameter.questionToken,ts.Diagnostics.An_index_signature_parameter_cannot_have_a_question_mark):parameter.initializer?grammarErrorOnNode(parameter.name,ts.Diagnostics.An_index_signature_parameter_cannot_have_an_initializer):parameter.type?130!==parameter.type.kind&&128!==parameter.type.kind?grammarErrorOnNode(parameter.name,ts.Diagnostics.An_index_signature_parameter_type_must_be_string_or_number):node.type?void 0:grammarErrorOnNode(node,ts.Diagnostics.An_index_signature_must_have_a_type_annotation):grammarErrorOnNode(parameter.name,ts.Diagnostics.An_index_signature_parameter_must_have_a_type_annotation)}function checkGrammarForIndexSignatureModifier(node){1022&node.flags&&grammarErrorOnFirstToken(node,ts.Diagnostics.Modifiers_not_permitted_on_index_signature_members)}function checkGrammarIndexSignature(node){return checkGrammarDecorators(node)||checkGrammarModifiers(node)||checkGrammarIndexSignatureParameters(node)||checkGrammarForIndexSignatureModifier(node)}function checkGrammarForAtLeastOneTypeArgument(node,typeArguments){if(typeArguments&&0===typeArguments.length){var sourceFile=ts.getSourceFileOfNode(node),start=typeArguments.pos-"<".length,end=ts.skipTrivia(sourceFile.text,typeArguments.end)+">".length;return grammarErrorAtPos(sourceFile,start,end-start,ts.Diagnostics.Type_argument_list_cannot_be_empty)}}function checkGrammarTypeArguments(node,typeArguments){return checkGrammarForDisallowedTrailingComma(typeArguments)||checkGrammarForAtLeastOneTypeArgument(node,typeArguments)}function checkGrammarForOmittedArgument(node,args){if(args)for(var sourceFile=ts.getSourceFileOfNode(node),_i=0,args_1=args;_i<args_1.length;_i++){var arg=args_1[_i];if(190===arg.kind)return grammarErrorAtPos(sourceFile,arg.pos,0,ts.Diagnostics.Argument_expression_expected)}}function checkGrammarArguments(node,args){return checkGrammarForDisallowedTrailingComma(args)||checkGrammarForOmittedArgument(node,args)}function checkGrammarHeritageClause(node){var types=node.types;if(checkGrammarForDisallowedTrailingComma(types))return!0;if(types&&0===types.length){var listType=ts.tokenToString(node.token),sourceFile=ts.getSourceFileOfNode(node);return grammarErrorAtPos(sourceFile,types.pos,0,ts.Diagnostics._0_list_cannot_be_empty,listType)}}function checkGrammarClassDeclarationHeritageClauses(node){var seenExtendsClause=!1,seenImplementsClause=!1;if(!checkGrammarDecorators(node)&&!checkGrammarModifiers(node)&&node.heritageClauses)for(var _i=0,_a=node.heritageClauses;_i<_a.length;_i++){var heritageClause=_a[_i];if(83===heritageClause.token){if(seenExtendsClause)return grammarErrorOnFirstToken(heritageClause,ts.Diagnostics.extends_clause_already_seen);if(seenImplementsClause)return grammarErrorOnFirstToken(heritageClause,ts.Diagnostics.extends_clause_must_precede_implements_clause);if(heritageClause.types.length>1)return grammarErrorOnFirstToken(heritageClause.types[1],ts.Diagnostics.Classes_can_only_extend_a_single_class);seenExtendsClause=!0}else{if(ts.Debug.assert(106===heritageClause.token),seenImplementsClause)return grammarErrorOnFirstToken(heritageClause,ts.Diagnostics.implements_clause_already_seen);seenImplementsClause=!0}checkGrammarHeritageClause(heritageClause)}}function checkGrammarInterfaceDeclaration(node){var seenExtendsClause=!1;if(node.heritageClauses)for(var _i=0,_a=node.heritageClauses;_i<_a.length;_i++){var heritageClause=_a[_i];if(83!==heritageClause.token)return ts.Debug.assert(106===heritageClause.token),grammarErrorOnFirstToken(heritageClause,ts.Diagnostics.Interface_declaration_cannot_have_implements_clause);if(seenExtendsClause)return grammarErrorOnFirstToken(heritageClause,ts.Diagnostics.extends_clause_already_seen);seenExtendsClause=!0,checkGrammarHeritageClause(heritageClause)}return!1}function checkGrammarComputedPropertyName(node){if(137!==node.kind)return!1;var computedPropertyName=node;return 184===computedPropertyName.expression.kind&&24===computedPropertyName.expression.operatorToken.kind?grammarErrorOnNode(computedPropertyName.expression,ts.Diagnostics.A_comma_expression_is_not_allowed_in_a_computed_property_name):void 0}function checkGrammarForGenerator(node){if(node.asteriskToken){if(ts.Debug.assert(216===node.kind||176===node.kind||144===node.kind),ts.isInAmbientContext(node))return grammarErrorOnNode(node.asteriskToken,ts.Diagnostics.Generators_are_not_allowed_in_an_ambient_context);if(!node.body)return grammarErrorOnNode(node.asteriskToken,ts.Diagnostics.An_overload_signature_cannot_be_declared_as_a_generator);if(languageVersion<2)return grammarErrorOnNode(node.asteriskToken,ts.Diagnostics.Generators_are_only_available_when_targeting_ECMAScript_6_or_higher)}}function checkGrammarForInvalidQuestionMark(node,questionToken,message){if(questionToken)return grammarErrorOnNode(questionToken,message)}function checkGrammarObjectLiteralExpression(node,inDestructuring){for(var seen={},Property=1,GetAccessor=2,SetAccesor=4,GetOrSetAccessor=GetAccessor|SetAccesor,_loop_1=function(prop){var name_19=prop.name;if(190===prop.kind||137===name_19.kind)return checkGrammarComputedPropertyName(name_19),"continue";if(249===prop.kind&&!inDestructuring&&prop.objectAssignmentInitializer)return{value:grammarErrorOnNode(prop.equalsToken,ts.Diagnostics.can_only_be_used_in_an_object_literal_property_inside_a_destructuring_assignment)};ts.forEach(prop.modifiers,function(mod){118===mod.kind&&144===prop.kind||grammarErrorOnNode(mod,ts.Diagnostics._0_modifier_cannot_be_used_here,ts.getTextOfNode(mod))});var currentKind=void 0;if(248===prop.kind||249===prop.kind?(checkGrammarForInvalidQuestionMark(prop,prop.questionToken,ts.Diagnostics.An_object_member_cannot_be_declared_optional),8===name_19.kind&&checkGrammarNumericLiteral(name_19),currentKind=Property):144===prop.kind?currentKind=Property:146===prop.kind?currentKind=GetAccessor:147===prop.kind?currentKind=SetAccesor:ts.Debug.fail("Unexpected syntax kind:"+prop.kind),ts.hasProperty(seen,name_19.text)){var existingKind=seen[name_19.text];if(currentKind===Property&&existingKind===Property)return"continue";if(!(currentKind&GetOrSetAccessor&&existingKind&GetOrSetAccessor))return{value:grammarErrorOnNode(name_19,ts.Diagnostics.An_object_literal_cannot_have_property_and_accessor_with_the_same_name)};if(existingKind===GetOrSetAccessor||currentKind===existingKind)return{value:grammarErrorOnNode(name_19,ts.Diagnostics.An_object_literal_cannot_have_multiple_get_Slashset_accessors_with_the_same_name)};seen[name_19.text]=currentKind|existingKind}else seen[name_19.text]=currentKind},_i=0,_a=node.properties;_i<_a.length;_i++){var prop=_a[_i],state_2=_loop_1(prop);if("object"==typeof state_2)return state_2.value}}function checkGrammarJsxElement(node){for(var seen={},_i=0,_a=node.attributes;_i<_a.length;_i++){var attr=_a[_i];if(242!==attr.kind){var jsxAttr=attr,name_20=jsxAttr.name;if(ts.hasProperty(seen,name_20.text))return grammarErrorOnNode(name_20,ts.Diagnostics.JSX_elements_cannot_have_multiple_attributes_with_the_same_name);seen[name_20.text]=!0;var initializer=jsxAttr.initializer;if(initializer&&243===initializer.kind&&!initializer.expression)return grammarErrorOnNode(jsxAttr.initializer,ts.Diagnostics.JSX_attributes_must_only_be_assigned_a_non_empty_expression)}}}function checkGrammarForInOrForOfStatement(forInOrOfStatement){if(checkGrammarStatementInAmbientContext(forInOrOfStatement))return!0;if(215===forInOrOfStatement.initializer.kind){var variableList=forInOrOfStatement.initializer;if(!checkGrammarVariableDeclarationList(variableList)){var declarations=variableList.declarations;if(!declarations.length)return!1;if(declarations.length>1){var diagnostic=203===forInOrOfStatement.kind?ts.Diagnostics.Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement:ts.Diagnostics.Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement;return grammarErrorOnFirstToken(variableList.declarations[1],diagnostic)}var firstDeclaration=declarations[0];if(firstDeclaration.initializer){var diagnostic=203===forInOrOfStatement.kind?ts.Diagnostics.The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer:ts.Diagnostics.The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer;return grammarErrorOnNode(firstDeclaration.name,diagnostic)}if(firstDeclaration.type){var diagnostic=203===forInOrOfStatement.kind?ts.Diagnostics.The_left_hand_side_of_a_for_in_statement_cannot_use_a_type_annotation:ts.Diagnostics.The_left_hand_side_of_a_for_of_statement_cannot_use_a_type_annotation;return grammarErrorOnNode(firstDeclaration,diagnostic)}}}return!1}function checkGrammarAccessor(accessor){var kind=accessor.kind;if(languageVersion<1)return grammarErrorOnNode(accessor.name,ts.Diagnostics.Accessors_are_only_available_when_targeting_ECMAScript_5_and_higher);if(ts.isInAmbientContext(accessor))return grammarErrorOnNode(accessor.name,ts.Diagnostics.An_accessor_cannot_be_declared_in_an_ambient_context);if(void 0===accessor.body)return grammarErrorAtPos(ts.getSourceFileOfNode(accessor),accessor.end-1,";".length,ts.Diagnostics._0_expected,"{");if(accessor.typeParameters)return grammarErrorOnNode(accessor.name,ts.Diagnostics.An_accessor_cannot_have_type_parameters);if(146===kind&&accessor.parameters.length)return grammarErrorOnNode(accessor.name,ts.Diagnostics.A_get_accessor_cannot_have_parameters);if(147===kind){if(accessor.type)return grammarErrorOnNode(accessor.name,ts.Diagnostics.A_set_accessor_cannot_have_a_return_type_annotation);if(1!==accessor.parameters.length)return grammarErrorOnNode(accessor.name,ts.Diagnostics.A_set_accessor_must_have_exactly_one_parameter);var parameter=accessor.parameters[0];if(parameter.dotDotDotToken)return grammarErrorOnNode(parameter.dotDotDotToken,ts.Diagnostics.A_set_accessor_cannot_have_rest_parameter);if(1022&parameter.flags)return grammarErrorOnNode(accessor.name,ts.Diagnostics.A_parameter_property_is_only_allowed_in_a_constructor_implementation);if(parameter.questionToken)return grammarErrorOnNode(parameter.questionToken,ts.Diagnostics.A_set_accessor_cannot_have_an_optional_parameter);if(parameter.initializer)return grammarErrorOnNode(accessor.name,ts.Diagnostics.A_set_accessor_parameter_cannot_have_an_initializer)}}function checkGrammarForNonSymbolComputedProperty(node,message){if(ts.isDynamicName(node))return grammarErrorOnNode(node,message)}function checkGrammarMethod(node){if(checkGrammarDisallowedModifiersOnObjectLiteralExpressionMethod(node)||checkGrammarFunctionLikeDeclaration(node)||checkGrammarForGenerator(node))return!0;if(168===node.parent.kind){if(checkGrammarForInvalidQuestionMark(node,node.questionToken,ts.Diagnostics.A_class_member_cannot_be_declared_optional))return!0;if(void 0===node.body)return grammarErrorAtPos(ts.getSourceFileOfNode(node),node.end-1,";".length,ts.Diagnostics._0_expected,"{")}if(ts.isClassLike(node.parent)){if(checkGrammarForInvalidQuestionMark(node,node.questionToken,ts.Diagnostics.A_class_member_cannot_be_declared_optional))return!0;if(ts.isInAmbientContext(node))return checkGrammarForNonSymbolComputedProperty(node.name,ts.Diagnostics.A_computed_property_name_in_an_ambient_context_must_directly_refer_to_a_built_in_symbol);if(!node.body)return checkGrammarForNonSymbolComputedProperty(node.name,ts.Diagnostics.A_computed_property_name_in_a_method_overload_must_directly_refer_to_a_built_in_symbol)}else{if(218===node.parent.kind)return checkGrammarForNonSymbolComputedProperty(node.name,ts.Diagnostics.A_computed_property_name_in_an_interface_must_directly_refer_to_a_built_in_symbol);if(156===node.parent.kind)return checkGrammarForNonSymbolComputedProperty(node.name,ts.Diagnostics.A_computed_property_name_in_a_type_literal_must_directly_refer_to_a_built_in_symbol)}}function checkGrammarBreakOrContinueStatement(node){for(var current=node;current;){if(ts.isFunctionLike(current))return grammarErrorOnNode(node,ts.Diagnostics.Jump_target_cannot_cross_function_boundary);switch(current.kind){case 210:if(node.label&&current.label.text===node.label.text){var isMisplacedContinueLabel=205===node.kind&&!ts.isIterationStatement(current.statement,!0);return!!isMisplacedContinueLabel&&grammarErrorOnNode(node,ts.Diagnostics.A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement)}break;case 209:if(206===node.kind&&!node.label)return!1;break;default:if(ts.isIterationStatement(current,!1)&&!node.label)return!1}current=current.parent}if(node.label){var message=206===node.kind?ts.Diagnostics.A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement:ts.Diagnostics.A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement;return grammarErrorOnNode(node,message)}var message=206===node.kind?ts.Diagnostics.A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement:ts.Diagnostics.A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement;return grammarErrorOnNode(node,message)}function checkGrammarBindingElement(node){if(node.dotDotDotToken){var elements=node.parent.elements;if(node!==ts.lastOrUndefined(elements))return grammarErrorOnNode(node,ts.Diagnostics.A_rest_element_must_be_last_in_an_array_destructuring_pattern);if(165===node.name.kind||164===node.name.kind)return grammarErrorOnNode(node.name,ts.Diagnostics.A_rest_element_cannot_contain_a_binding_pattern);if(node.initializer)return grammarErrorAtPos(ts.getSourceFileOfNode(node),node.initializer.pos-1,1,ts.Diagnostics.A_rest_element_cannot_have_an_initializer)}}function checkGrammarVariableDeclaration(node){if(203!==node.parent.parent.kind&&204!==node.parent.parent.kind)if(ts.isInAmbientContext(node)){if(node.initializer){var equalsTokenLength="=".length;return grammarErrorAtPos(ts.getSourceFileOfNode(node),node.initializer.pos-equalsTokenLength,equalsTokenLength,ts.Diagnostics.Initializers_are_not_allowed_in_ambient_contexts)}}else if(!node.initializer){if(ts.isBindingPattern(node.name)&&!ts.isBindingPattern(node.parent))return grammarErrorOnNode(node,ts.Diagnostics.A_destructuring_declaration_must_have_an_initializer);if(ts.isConst(node))return grammarErrorOnNode(node,ts.Diagnostics.const_declarations_must_be_initialized)}var checkLetConstNames=ts.isLet(node)||ts.isConst(node);return checkLetConstNames&&checkGrammarNameInLetOrConstDeclarations(node.name)}function checkGrammarNameInLetOrConstDeclarations(name){if(69===name.kind){if(108===name.originalKeywordKind)return grammarErrorOnNode(name,ts.Diagnostics.let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations)}else for(var elements=name.elements,_i=0,elements_2=elements;_i<elements_2.length;_i++){var element=elements_2[_i];190!==element.kind&&checkGrammarNameInLetOrConstDeclarations(element.name)}}function checkGrammarVariableDeclarationList(declarationList){var declarations=declarationList.declarations;return!!checkGrammarForDisallowedTrailingComma(declarationList.declarations)||(declarationList.declarations.length?void 0:grammarErrorAtPos(ts.getSourceFileOfNode(declarationList),declarations.pos,declarations.end-declarations.pos,ts.Diagnostics.Variable_declaration_list_cannot_be_empty))}function allowLetAndConstDeclarations(parent){switch(parent.kind){case 199:case 200:case 201:case 208:case 202:case 203:case 204:return!1;case 210:return allowLetAndConstDeclarations(parent.parent)}return!0}function checkGrammarForDisallowedLetOrConstStatement(node){if(!allowLetAndConstDeclarations(node.parent)){if(ts.isLet(node.declarationList))return grammarErrorOnNode(node,ts.Diagnostics.let_declarations_can_only_be_declared_inside_a_block);if(ts.isConst(node.declarationList))return grammarErrorOnNode(node,ts.Diagnostics.const_declarations_can_only_be_declared_inside_a_block)}}function hasParseDiagnostics(sourceFile){return sourceFile.parseDiagnostics.length>0}function grammarErrorOnFirstToken(node,message,arg0,arg1,arg2){var sourceFile=ts.getSourceFileOfNode(node);if(!hasParseDiagnostics(sourceFile)){var span=ts.getSpanOfTokenAtPosition(sourceFile,node.pos);return diagnostics.add(ts.createFileDiagnostic(sourceFile,span.start,span.length,message,arg0,arg1,arg2)),!0}}function grammarErrorAtPos(sourceFile,start,length,message,arg0,arg1,arg2){if(!hasParseDiagnostics(sourceFile))return diagnostics.add(ts.createFileDiagnostic(sourceFile,start,length,message,arg0,arg1,arg2)),!0}function grammarErrorOnNode(node,message,arg0,arg1,arg2){var sourceFile=ts.getSourceFileOfNode(node);if(!hasParseDiagnostics(sourceFile))return diagnostics.add(ts.createDiagnosticForNode(node,message,arg0,arg1,arg2)),!0}function checkGrammarConstructorTypeParameters(node){if(node.typeParameters)return grammarErrorAtPos(ts.getSourceFileOfNode(node),node.typeParameters.pos,node.typeParameters.end-node.typeParameters.pos,ts.Diagnostics.Type_parameters_cannot_appear_on_a_constructor_declaration)}function checkGrammarConstructorTypeAnnotation(node){if(node.type)return grammarErrorOnNode(node.type,ts.Diagnostics.Type_annotation_cannot_appear_on_a_constructor_declaration)}function checkGrammarProperty(node){if(ts.isClassLike(node.parent)){if(checkGrammarForInvalidQuestionMark(node,node.questionToken,ts.Diagnostics.A_class_member_cannot_be_declared_optional)||checkGrammarForNonSymbolComputedProperty(node.name,ts.Diagnostics.A_computed_property_name_in_a_class_property_declaration_must_directly_refer_to_a_built_in_symbol))return!0}else if(218===node.parent.kind){if(checkGrammarForNonSymbolComputedProperty(node.name,ts.Diagnostics.A_computed_property_name_in_an_interface_must_directly_refer_to_a_built_in_symbol))return!0;if(node.initializer)return grammarErrorOnNode(node.initializer,ts.Diagnostics.An_interface_property_cannot_have_an_initializer)}else if(156===node.parent.kind){if(checkGrammarForNonSymbolComputedProperty(node.name,ts.Diagnostics.A_computed_property_name_in_a_type_literal_must_directly_refer_to_a_built_in_symbol))return!0;if(node.initializer)return grammarErrorOnNode(node.initializer,ts.Diagnostics.A_type_literal_property_cannot_have_an_initializer)}if(ts.isInAmbientContext(node)&&node.initializer)return grammarErrorOnFirstToken(node.initializer,ts.Diagnostics.Initializers_are_not_allowed_in_ambient_contexts)}function checkGrammarTopLevelElementForRequiredDeclareModifier(node){return!(218===node.kind||219===node.kind||225===node.kind||224===node.kind||231===node.kind||230===node.kind||4&node.flags||514&node.flags)&&grammarErrorOnFirstToken(node,ts.Diagnostics.A_declare_modifier_is_required_for_a_top_level_declaration_in_a_d_ts_file)}function checkGrammarTopLevelElementsForRequiredDeclareModifier(file){for(var _i=0,_a=file.statements;_i<_a.length;_i++){var decl=_a[_i];if((ts.isDeclaration(decl)||196===decl.kind)&&checkGrammarTopLevelElementForRequiredDeclareModifier(decl))return!0}}function checkGrammarSourceFile(node){return ts.isInAmbientContext(node)&&checkGrammarTopLevelElementsForRequiredDeclareModifier(node)}function checkGrammarStatementInAmbientContext(node){if(ts.isInAmbientContext(node)){if(isAccessor(node.parent.kind))return getNodeLinks(node).hasReportedStatementInAmbientContext=!0;var links=getNodeLinks(node);if(!links.hasReportedStatementInAmbientContext&&ts.isFunctionLike(node.parent))return getNodeLinks(node).hasReportedStatementInAmbientContext=grammarErrorOnFirstToken(node,ts.Diagnostics.An_implementation_cannot_be_declared_in_ambient_contexts);if(195===node.parent.kind||222===node.parent.kind||251===node.parent.kind){var links_1=getNodeLinks(node.parent);if(!links_1.hasReportedStatementInAmbientContext)return links_1.hasReportedStatementInAmbientContext=grammarErrorOnFirstToken(node,ts.Diagnostics.Statements_are_not_allowed_in_ambient_contexts)}}}function checkGrammarNumericLiteral(node){if(32768&node.flags&&languageVersion>=1)return grammarErrorOnNode(node,ts.Diagnostics.Octal_literals_are_not_available_when_targeting_ECMAScript_5_and_higher)}function grammarErrorAfterFirstToken(node,message,arg0,arg1,arg2){var sourceFile=ts.getSourceFileOfNode(node);if(!hasParseDiagnostics(sourceFile)){var span=ts.getSpanOfTokenAtPosition(sourceFile,node.pos);return diagnostics.add(ts.createFileDiagnostic(sourceFile,ts.textSpanEnd(span),0,message,arg0,arg1,arg2)),!0}}var cancellationToken,Symbol=ts.objectAllocator.getSymbolConstructor(),Type=ts.objectAllocator.getTypeConstructor(),Signature=ts.objectAllocator.getSignatureConstructor(),typeCount=0,symbolCount=0,emptyArray=[],emptySymbols={},compilerOptions=host.getCompilerOptions(),languageVersion=compilerOptions.target||0,modulekind=ts.getEmitModuleKind(compilerOptions),allowSyntheticDefaultImports="undefined"!=typeof compilerOptions.allowSyntheticDefaultImports?compilerOptions.allowSyntheticDefaultImports:4===modulekind,emitResolver=createResolver(),undefinedSymbol=createSymbol(67108868,"undefined");undefinedSymbol.declarations=[];var argumentsSymbol=createSymbol(67108868,"arguments"),checker={getNodeCount:function(){return ts.sum(host.getSourceFiles(),"nodeCount")},getIdentifierCount:function(){return ts.sum(host.getSourceFiles(),"identifierCount")},getSymbolCount:function(){return ts.sum(host.getSourceFiles(),"symbolCount")+symbolCount},getTypeCount:function(){return typeCount},isUndefinedSymbol:function(symbol){return symbol===undefinedSymbol},isArgumentsSymbol:function(symbol){return symbol===argumentsSymbol},isUnknownSymbol:function(symbol){return symbol===unknownSymbol},getDiagnostics:getDiagnostics,getGlobalDiagnostics:getGlobalDiagnostics,getTypeOfSymbolAtLocation:getNarrowedTypeOfSymbol,getSymbolsOfParameterPropertyDeclaration:getSymbolsOfParameterPropertyDeclaration,getDeclaredTypeOfSymbol:getDeclaredTypeOfSymbol,getPropertiesOfType:getPropertiesOfType,getPropertyOfType:getPropertyOfType,getSignaturesOfType:getSignaturesOfType,getIndexTypeOfType:getIndexTypeOfType,getBaseTypes:getBaseTypes,getReturnTypeOfSignature:getReturnTypeOfSignature,getSymbolsInScope:getSymbolsInScope,getSymbolAtLocation:getSymbolAtLocation,getShorthandAssignmentValueSymbol:getShorthandAssignmentValueSymbol,getExportSpecifierLocalTargetSymbol:getExportSpecifierLocalTargetSymbol,getTypeAtLocation:getTypeOfNode,typeToString:typeToString,getSymbolDisplayBuilder:getSymbolDisplayBuilder,symbolToString:symbolToString,getAugmentedPropertiesOfType:getAugmentedPropertiesOfType,getRootSymbols:getRootSymbols,getContextualType:getContextualType,getFullyQualifiedName:getFullyQualifiedName,getResolvedSignature:getResolvedSignature,getConstantValue:getConstantValue,isValidPropertyAccess:isValidPropertyAccess,getSignatureFromDeclaration:getSignatureFromDeclaration,isImplementationOfOverload:isImplementationOfOverload,getAliasedSymbol:resolveAlias,getEmitResolver:getEmitResolver,getExportsOfModule:getExportsOfModuleAsArray,getJsxElementAttributesType:getJsxElementAttributesType,getJsxIntrinsicTagNames:getJsxIntrinsicTagNames,isOptionalParameter:isOptionalParameter},unknownSymbol=createSymbol(67108868,"unknown"),resolvingSymbol=createSymbol(67108864,"__resolving__"),anyType=createIntrinsicType(1,"any"),stringType=createIntrinsicType(2,"string"),numberType=createIntrinsicType(4,"number"),booleanType=createIntrinsicType(8,"boolean"),esSymbolType=createIntrinsicType(16777216,"symbol"),voidType=createIntrinsicType(16,"void"),undefinedType=createIntrinsicType(2097184,"undefined"),nullType=createIntrinsicType(2097216,"null"),unknownType=createIntrinsicType(1,"unknown"),emptyObjectType=createAnonymousType(void 0,emptySymbols,emptyArray,emptyArray,void 0,void 0),emptyUnionType=emptyObjectType,emptyGenericType=createAnonymousType(void 0,emptySymbols,emptyArray,emptyArray,void 0,void 0);emptyGenericType.instantiations={};var anyFunctionType=createAnonymousType(void 0,emptySymbols,emptyArray,emptyArray,void 0,void 0);anyFunctionType.flags|=8388608;var globalESSymbolConstructorSymbol,getGlobalPromiseConstructorSymbol,globalObjectType,globalFunctionType,globalArrayType,globalStringType,globalNumberType,globalBooleanType,globalRegExpType,globalTemplateStringsArrayType,globalESSymbolType,globalIterableType,globalIteratorType,globalIterableIteratorType,anyArrayType,getGlobalClassDecoratorType,getGlobalParameterDecoratorType,getGlobalPropertyDecoratorType,getGlobalMethodDecoratorType,getGlobalTypedPropertyDescriptorType,getGlobalPromiseType,tryGetGlobalPromiseType,getGlobalPromiseLikeType,getInstantiatedGlobalPromiseLikeType,getGlobalPromiseConstructorLikeType,getGlobalThenableType,jsxElementClassType,deferredNodes,jsxElementType,_displayBuilder,TypeSystemPropertyName,noConstraintType=createAnonymousType(void 0,emptySymbols,emptyArray,emptyArray,void 0,void 0),anySignature=createSignature(void 0,void 0,emptyArray,anyType,void 0,0,!1,!1),unknownSignature=createSignature(void 0,void 0,emptyArray,unknownType,void 0,0,!1,!1),globals={},tupleTypes={},unionTypes={},intersectionTypes={},stringLiteralTypes={},resolutionTargets=[],resolutionResults=[],resolutionPropertyNames=[],mergedSymbols=[],symbolLinks=[],nodeLinks=[],potentialThisCollisions=[],awaitedTypeStack=[],diagnostics=ts.createDiagnosticCollection(),primitiveTypeInfo={string:{type:stringType,flags:258},number:{type:numberType,flags:132},boolean:{type:booleanType,flags:8},symbol:{type:esSymbolType,flags:16777216},undefined:{type:undefinedType,flags:2097152}},jsxTypes={},JsxNames={JSX:"JSX",IntrinsicElements:"IntrinsicElements",ElementClass:"ElementClass",ElementAttributesPropertyNameContainer:"ElementAttributesProperty",Element:"Element",IntrinsicAttributes:"IntrinsicAttributes",IntrinsicClassAttributes:"IntrinsicClassAttributes"},subtypeRelation={},assignableRelation={},identityRelation={};!function(TypeSystemPropertyName){TypeSystemPropertyName[TypeSystemPropertyName.Type=0]="Type",TypeSystemPropertyName[TypeSystemPropertyName.ResolvedBaseConstructorType=1]="ResolvedBaseConstructorType",TypeSystemPropertyName[TypeSystemPropertyName.DeclaredType=2]="DeclaredType",TypeSystemPropertyName[TypeSystemPropertyName.ResolvedReturnType=3]="ResolvedReturnType"}(TypeSystemPropertyName||(TypeSystemPropertyName={}));var builtinGlobals=(_a={},_a[undefinedSymbol.name]=undefinedSymbol,_a);return initializeTypeChecker(),checker;var _a}var nextSymbolId=1,nextNodeId=1,nextMergeId=1;ts.getNodeId=getNodeId,ts.checkTime=0,ts.getSymbolId=getSymbolId,ts.createTypeChecker=createTypeChecker}(ts||(ts={}));var ts;!function(ts){function getNullSourceMapWriter(){return void 0===nullSourceMapWriter&&(nullSourceMapWriter={getSourceMapData:function(){},setSourceFile:function(sourceFile){},emitStart:function(range){},emitEnd:function(range,stopOverridingSpan){},emitPos:function(pos){},changeEmitSourcePos:function(){},getText:function(){},getSourceMappingURL:function(){},initialize:function(filePath,sourceMapFilePath,sourceFiles,isBundledEmit){},reset:function(){}}),nullSourceMapWriter}function createSourceMapWriter(host,writer){function initialize(filePath,sourceMapFilePath,sourceFiles,isBundledEmit){sourceMapData&&reset(),currentSourceFile=void 0,sourceMapSourceIndex=-1,lastRecordedSourceMapSpan=void 0,lastEncodedSourceMapSpan=defaultLastEncodedSourceMapSpan,lastEncodedNameIndex=0,sourceMapData={sourceMapFilePath:sourceMapFilePath,jsSourceMappingURL:compilerOptions.inlineSourceMap?void 0:ts.getBaseFileName(ts.normalizeSlashes(sourceMapFilePath)),sourceMapFile:ts.getBaseFileName(ts.normalizeSlashes(filePath)),sourceMapSourceRoot:compilerOptions.sourceRoot||"",sourceMapSources:[],inputSourceFileNames:[],sourceMapNames:[],sourceMapMappings:"",sourceMapSourcesContent:compilerOptions.inlineSources?[]:void 0,sourceMapDecodedMappings:[]},sourceMapData.sourceMapSourceRoot=ts.normalizeSlashes(sourceMapData.sourceMapSourceRoot),sourceMapData.sourceMapSourceRoot.length&&47!==sourceMapData.sourceMapSourceRoot.charCodeAt(sourceMapData.sourceMapSourceRoot.length-1)&&(sourceMapData.sourceMapSourceRoot+=ts.directorySeparator),compilerOptions.mapRoot?(sourceMapDir=ts.normalizeSlashes(compilerOptions.mapRoot),
isBundledEmit||(ts.Debug.assert(1===sourceFiles.length),sourceMapDir=ts.getDirectoryPath(ts.getSourceFilePathInNewDir(sourceFiles[0],host,sourceMapDir))),ts.isRootedDiskPath(sourceMapDir)||ts.isUrl(sourceMapDir)?sourceMapData.jsSourceMappingURL=ts.combinePaths(sourceMapDir,sourceMapData.jsSourceMappingURL):(sourceMapDir=ts.combinePaths(host.getCommonSourceDirectory(),sourceMapDir),sourceMapData.jsSourceMappingURL=ts.getRelativePathToDirectoryOrUrl(ts.getDirectoryPath(ts.normalizePath(filePath)),ts.combinePaths(sourceMapDir,sourceMapData.jsSourceMappingURL),host.getCurrentDirectory(),host.getCanonicalFileName,!0))):sourceMapDir=ts.getDirectoryPath(ts.normalizePath(filePath))}function reset(){currentSourceFile=void 0,sourceMapDir=void 0,sourceMapSourceIndex=void 0,lastRecordedSourceMapSpan=void 0,lastEncodedSourceMapSpan=void 0,lastEncodedNameIndex=void 0,sourceMapData=void 0}function updateLastEncodedAndRecordedSpans(){if(modifyLastSourcePos){modifyLastSourcePos=!1,lastRecordedSourceMapSpan.emittedLine=lastEncodedSourceMapSpan.emittedLine,lastRecordedSourceMapSpan.emittedColumn=lastEncodedSourceMapSpan.emittedColumn,sourceMapData.sourceMapDecodedMappings.pop(),lastEncodedSourceMapSpan=sourceMapData.sourceMapDecodedMappings.length?sourceMapData.sourceMapDecodedMappings[sourceMapData.sourceMapDecodedMappings.length-1]:defaultLastEncodedSourceMapSpan;for(var sourceMapMappings=sourceMapData.sourceMapMappings,lenthToSet=sourceMapMappings.length-1;lenthToSet>=0;lenthToSet--){var currentChar=sourceMapMappings.charAt(lenthToSet);if(","===currentChar)break;if(";"===currentChar&&0!==lenthToSet&&";"!==sourceMapMappings.charAt(lenthToSet-1))break}sourceMapData.sourceMapMappings=sourceMapMappings.substr(0,Math.max(0,lenthToSet))}}function encodeLastRecordedSourceMapSpan(){if(lastRecordedSourceMapSpan&&lastRecordedSourceMapSpan!==lastEncodedSourceMapSpan){var prevEncodedEmittedColumn=lastEncodedSourceMapSpan.emittedColumn;if(lastEncodedSourceMapSpan.emittedLine===lastRecordedSourceMapSpan.emittedLine)sourceMapData.sourceMapMappings&&(sourceMapData.sourceMapMappings+=",");else{for(var encodedLine=lastEncodedSourceMapSpan.emittedLine;encodedLine<lastRecordedSourceMapSpan.emittedLine;encodedLine++)sourceMapData.sourceMapMappings+=";";prevEncodedEmittedColumn=1}sourceMapData.sourceMapMappings+=base64VLQFormatEncode(lastRecordedSourceMapSpan.emittedColumn-prevEncodedEmittedColumn),sourceMapData.sourceMapMappings+=base64VLQFormatEncode(lastRecordedSourceMapSpan.sourceIndex-lastEncodedSourceMapSpan.sourceIndex),sourceMapData.sourceMapMappings+=base64VLQFormatEncode(lastRecordedSourceMapSpan.sourceLine-lastEncodedSourceMapSpan.sourceLine),sourceMapData.sourceMapMappings+=base64VLQFormatEncode(lastRecordedSourceMapSpan.sourceColumn-lastEncodedSourceMapSpan.sourceColumn),lastRecordedSourceMapSpan.nameIndex>=0&&(ts.Debug.assert(!1,"We do not support name index right now, Make sure to update updateLastEncodedAndRecordedSpans when we start using this"),sourceMapData.sourceMapMappings+=base64VLQFormatEncode(lastRecordedSourceMapSpan.nameIndex-lastEncodedNameIndex),lastEncodedNameIndex=lastRecordedSourceMapSpan.nameIndex),lastEncodedSourceMapSpan=lastRecordedSourceMapSpan,sourceMapData.sourceMapDecodedMappings.push(lastEncodedSourceMapSpan)}}function emitPos(pos){if(pos!==-1){var sourceLinePos=ts.getLineAndCharacterOfPosition(currentSourceFile,pos);sourceLinePos.line++,sourceLinePos.character++;var emittedLine=writer.getLine(),emittedColumn=writer.getColumn();!lastRecordedSourceMapSpan||lastRecordedSourceMapSpan.emittedLine!==emittedLine||lastRecordedSourceMapSpan.emittedColumn!==emittedColumn||lastRecordedSourceMapSpan.sourceIndex===sourceMapSourceIndex&&(lastRecordedSourceMapSpan.sourceLine>sourceLinePos.line||lastRecordedSourceMapSpan.sourceLine===sourceLinePos.line&&lastRecordedSourceMapSpan.sourceColumn>sourceLinePos.character)?(encodeLastRecordedSourceMapSpan(),lastRecordedSourceMapSpan={emittedLine:emittedLine,emittedColumn:emittedColumn,sourceLine:sourceLinePos.line,sourceColumn:sourceLinePos.character,sourceIndex:sourceMapSourceIndex},stopOverridingSpan=!1):stopOverridingSpan||(lastRecordedSourceMapSpan.sourceLine=sourceLinePos.line,lastRecordedSourceMapSpan.sourceColumn=sourceLinePos.character,lastRecordedSourceMapSpan.sourceIndex=sourceMapSourceIndex),updateLastEncodedAndRecordedSpans()}}function getStartPos(range){var rangeHasDecorators=!!range.decorators;return range.pos!==-1?ts.skipTrivia(currentSourceFile.text,rangeHasDecorators?range.decorators.end:range.pos):-1}function emitStart(range){emitPos(getStartPos(range))}function emitEnd(range,stopOverridingEnd){emitPos(range.end),stopOverridingSpan=stopOverridingEnd}function changeEmitSourcePos(){ts.Debug.assert(!modifyLastSourcePos),modifyLastSourcePos=!0}function setSourceFile(sourceFile){currentSourceFile=sourceFile;var sourcesDirectoryPath=compilerOptions.sourceRoot?host.getCommonSourceDirectory():sourceMapDir,source=ts.getRelativePathToDirectoryOrUrl(sourcesDirectoryPath,currentSourceFile.fileName,host.getCurrentDirectory(),host.getCanonicalFileName,!0);sourceMapSourceIndex=ts.indexOf(sourceMapData.sourceMapSources,source),sourceMapSourceIndex===-1&&(sourceMapSourceIndex=sourceMapData.sourceMapSources.length,sourceMapData.sourceMapSources.push(source),sourceMapData.inputSourceFileNames.push(sourceFile.fileName),compilerOptions.inlineSources&&sourceMapData.sourceMapSourcesContent.push(sourceFile.text))}function getText(){return encodeLastRecordedSourceMapSpan(),ts.stringify({version:3,file:sourceMapData.sourceMapFile,sourceRoot:sourceMapData.sourceMapSourceRoot,sources:sourceMapData.sourceMapSources,names:sourceMapData.sourceMapNames,mappings:sourceMapData.sourceMapMappings,sourcesContent:sourceMapData.sourceMapSourcesContent})}function getSourceMappingURL(){if(compilerOptions.inlineSourceMap){var base64SourceMapText=ts.convertToBase64(getText());return sourceMapData.jsSourceMappingURL="data:application/json;base64,"+base64SourceMapText}return sourceMapData.jsSourceMappingURL}var currentSourceFile,sourceMapDir,sourceMapSourceIndex,lastRecordedSourceMapSpan,lastEncodedSourceMapSpan,lastEncodedNameIndex,sourceMapData,compilerOptions=host.getCompilerOptions(),stopOverridingSpan=!1,modifyLastSourcePos=!1;return{getSourceMapData:function(){return sourceMapData},setSourceFile:setSourceFile,emitPos:emitPos,emitStart:emitStart,emitEnd:emitEnd,changeEmitSourcePos:changeEmitSourcePos,getText:getText,getSourceMappingURL:getSourceMappingURL,initialize:initialize,reset:reset}}function base64FormatEncode(inValue){if(inValue<64)return base64Chars.charAt(inValue);throw TypeError(inValue+": not a 64 based value")}function base64VLQFormatEncode(inValue){inValue<0?inValue=(-inValue<<1)+1:inValue<<=1;var encodedStr="";do{var currentDigit=31&inValue;inValue>>=5,inValue>0&&(currentDigit=32|currentDigit),encodedStr+=base64FormatEncode(currentDigit)}while(inValue>0);return encodedStr}var nullSourceMapWriter,defaultLastEncodedSourceMapSpan={emittedLine:1,emittedColumn:1,sourceLine:1,sourceColumn:1,sourceIndex:0};ts.getNullSourceMapWriter=getNullSourceMapWriter,ts.createSourceMapWriter=createSourceMapWriter;var base64Chars="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"}(ts||(ts={}));var ts;!function(ts){function getDeclarationDiagnostics(host,resolver,targetSourceFile){function getDeclarationDiagnosticsFromFile(_a,sources,isBundledEmit){var declarationFilePath=_a.declarationFilePath;emitDeclarations(host,resolver,declarationDiagnostics,declarationFilePath,sources,isBundledEmit)}var declarationDiagnostics=ts.createDiagnosticCollection();return ts.forEachExpectedEmitFile(host,getDeclarationDiagnosticsFromFile,targetSourceFile),declarationDiagnostics.getDiagnostics(targetSourceFile?targetSourceFile.fileName:void 0)}function emitDeclarations(host,resolver,emitterDiagnostics,declarationFilePath,sourceFiles,isBundledEmit){function hasInternalAnnotation(range){var comment=currentText.substring(range.pos,range.end);return comment.indexOf("@internal")>=0}function stripInternal(node){if(node){var leadingCommentRanges=ts.getLeadingCommentRanges(currentText,node.pos);if(ts.forEach(leadingCommentRanges,hasInternalAnnotation))return;emitNode(node)}}function createAndSetNewTextWriterWithSymbolWriter(){var writer=ts.createTextWriter(newLine);return writer.trackSymbol=trackSymbol,writer.reportInaccessibleThisError=reportInaccessibleThisError,writer.writeKeyword=writer.write,writer.writeOperator=writer.write,writer.writePunctuation=writer.write,writer.writeSpace=writer.write,writer.writeStringLiteral=writer.writeLiteral,writer.writeParameter=writer.write,writer.writeSymbol=writer.write,setWriter(writer),writer}function setWriter(newWriter){writer=newWriter,write=newWriter.write,writeTextOfNode=newWriter.writeTextOfNode,writeLine=newWriter.writeLine,increaseIndent=newWriter.increaseIndent,decreaseIndent=newWriter.decreaseIndent}function writeAsynchronousModuleElements(nodes){var oldWriter=writer;ts.forEach(nodes,function(declaration){var nodeToCheck;214===declaration.kind?nodeToCheck=declaration.parent.parent:228===declaration.kind||229===declaration.kind||226===declaration.kind?ts.Debug.fail("We should be getting ImportDeclaration instead to write"):nodeToCheck=declaration;var moduleElementEmitInfo=ts.forEach(moduleElementDeclarationEmitInfo,function(declEmitInfo){return declEmitInfo.node===nodeToCheck?declEmitInfo:void 0});if(!moduleElementEmitInfo&&asynchronousSubModuleDeclarationEmitInfo&&(moduleElementEmitInfo=ts.forEach(asynchronousSubModuleDeclarationEmitInfo,function(declEmitInfo){return declEmitInfo.node===nodeToCheck?declEmitInfo:void 0})),moduleElementEmitInfo)if(225===moduleElementEmitInfo.node.kind)moduleElementEmitInfo.isVisible=!0;else{createAndSetNewTextWriterWithSymbolWriter();for(var declarationIndent=moduleElementEmitInfo.indent;declarationIndent;declarationIndent--)increaseIndent();221===nodeToCheck.kind&&(ts.Debug.assert(void 0===asynchronousSubModuleDeclarationEmitInfo),asynchronousSubModuleDeclarationEmitInfo=[]),writeModuleElement(nodeToCheck),221===nodeToCheck.kind&&(moduleElementEmitInfo.subModuleElementDeclarationEmitInfo=asynchronousSubModuleDeclarationEmitInfo,asynchronousSubModuleDeclarationEmitInfo=void 0),moduleElementEmitInfo.asynchronousOutput=writer.getText()}}),setWriter(oldWriter)}function handleSymbolAccessibilityError(symbolAccesibilityResult){if(0===symbolAccesibilityResult.accessibility)symbolAccesibilityResult&&symbolAccesibilityResult.aliasesToMakeVisible&&writeAsynchronousModuleElements(symbolAccesibilityResult.aliasesToMakeVisible);else{reportedDeclarationError=!0;var errorInfo=writer.getSymbolAccessibilityDiagnostic(symbolAccesibilityResult);errorInfo&&(errorInfo.typeName?emitterDiagnostics.add(ts.createDiagnosticForNode(symbolAccesibilityResult.errorNode||errorInfo.errorNode,errorInfo.diagnosticMessage,ts.getTextOfNodeFromSourceText(currentText,errorInfo.typeName),symbolAccesibilityResult.errorSymbolName,symbolAccesibilityResult.errorModuleName)):emitterDiagnostics.add(ts.createDiagnosticForNode(symbolAccesibilityResult.errorNode||errorInfo.errorNode,errorInfo.diagnosticMessage,symbolAccesibilityResult.errorSymbolName,symbolAccesibilityResult.errorModuleName)))}}function trackSymbol(symbol,enclosingDeclaration,meaning){handleSymbolAccessibilityError(resolver.isSymbolAccessible(symbol,enclosingDeclaration,meaning))}function reportInaccessibleThisError(){errorNameNode&&(reportedDeclarationError=!0,emitterDiagnostics.add(ts.createDiagnosticForNode(errorNameNode,ts.Diagnostics.The_inferred_type_of_0_references_an_inaccessible_this_type_A_type_annotation_is_necessary,ts.declarationNameToString(errorNameNode))))}function writeTypeOfDeclaration(declaration,type,getSymbolAccessibilityDiagnostic){writer.getSymbolAccessibilityDiagnostic=getSymbolAccessibilityDiagnostic,write(": "),type?emitType(type):(errorNameNode=declaration.name,resolver.writeTypeOfDeclaration(declaration,enclosingDeclaration,2,writer),errorNameNode=void 0)}function writeReturnTypeAtSignature(signature,getSymbolAccessibilityDiagnostic){writer.getSymbolAccessibilityDiagnostic=getSymbolAccessibilityDiagnostic,write(": "),signature.type?emitType(signature.type):(errorNameNode=signature.name,resolver.writeReturnTypeOfSignatureDeclaration(signature,enclosingDeclaration,2,writer),errorNameNode=void 0)}function emitLines(nodes){for(var _i=0,nodes_2=nodes;_i<nodes_2.length;_i++){var node=nodes_2[_i];emit(node)}}function emitSeparatedList(nodes,separator,eachNodeEmitFn,canEmitFn){for(var currentWriterPos=writer.getTextPos(),_i=0,nodes_3=nodes;_i<nodes_3.length;_i++){var node=nodes_3[_i];canEmitFn&&!canEmitFn(node)||(currentWriterPos!==writer.getTextPos()&&write(separator),currentWriterPos=writer.getTextPos(),eachNodeEmitFn(node))}}function emitCommaList(nodes,eachNodeEmitFn,canEmitFn){emitSeparatedList(nodes,", ",eachNodeEmitFn,canEmitFn)}function writeJsDocComments(declaration){if(declaration){var jsDocComments=ts.getJsDocCommentsFromText(declaration,currentText);ts.emitNewLineBeforeLeadingComments(currentLineMap,writer,declaration,jsDocComments),ts.emitComments(currentText,currentLineMap,writer,jsDocComments,!0,newLine,ts.writeCommentRange)}}function emitTypeWithNewGetSymbolAccessibilityDiagnostic(type,getSymbolAccessibilityDiagnostic){writer.getSymbolAccessibilityDiagnostic=getSymbolAccessibilityDiagnostic,emitType(type)}function emitType(type){function writeEntityName(entityName){if(69===entityName.kind)writeTextOfNode(currentText,entityName);else{var left=136===entityName.kind?entityName.left:entityName.expression,right=136===entityName.kind?entityName.right:entityName.name;writeEntityName(left),write("."),writeTextOfNode(currentText,right)}}function emitEntityName(entityName){var visibilityResult=resolver.isEntityNameVisible(entityName,224===entityName.parent.kind?entityName.parent:enclosingDeclaration);handleSymbolAccessibilityError(visibilityResult),writeEntityName(entityName)}function emitExpressionWithTypeArguments(node){ts.isSupportedExpressionWithTypeArguments(node)&&(ts.Debug.assert(69===node.expression.kind||169===node.expression.kind),emitEntityName(node.expression),node.typeArguments&&(write("<"),emitCommaList(node.typeArguments,emitType),write(">")))}function emitTypeReference(type){emitEntityName(type.typeName),type.typeArguments&&(write("<"),emitCommaList(type.typeArguments,emitType),write(">"))}function emitTypePredicate(type){writeTextOfNode(currentText,type.parameterName),write(" is "),emitType(type.type)}function emitTypeQuery(type){write("typeof "),emitEntityName(type.exprName)}function emitArrayType(type){emitType(type.elementType),write("[]")}function emitTupleType(type){write("["),emitCommaList(type.elementTypes,emitType),write("]")}function emitUnionType(type){emitSeparatedList(type.types," | ",emitType)}function emitIntersectionType(type){emitSeparatedList(type.types," & ",emitType)}function emitParenType(type){write("("),emitType(type.type),write(")")}function emitTypeLiteral(type){write("{"),type.members.length&&(writeLine(),increaseIndent(),emitLines(type.members),decreaseIndent()),write("}")}switch(type.kind){case 117:case 130:case 128:case 120:case 131:case 103:case 162:case 163:return writeTextOfNode(currentText,type);case 191:return emitExpressionWithTypeArguments(type);case 152:return emitTypeReference(type);case 155:return emitTypeQuery(type);case 157:return emitArrayType(type);case 158:return emitTupleType(type);case 159:return emitUnionType(type);case 160:return emitIntersectionType(type);case 161:return emitParenType(type);case 153:case 154:return emitSignatureDeclarationWithJsDocComments(type);case 156:return emitTypeLiteral(type);case 69:return emitEntityName(type);case 136:return emitEntityName(type);case 151:return emitTypePredicate(type)}}function emitSourceFile(node){currentText=node.text,currentLineMap=ts.getLineStarts(node),currentIdentifiers=node.identifiers,isCurrentFileExternalModule=ts.isExternalModule(node),enclosingDeclaration=node,ts.emitDetachedComments(currentText,currentLineMap,writer,ts.writeCommentRange,node,newLine,!0),emitLines(node.statements)}function getExportDefaultTempVariableName(){var baseName="_default";if(!ts.hasProperty(currentIdentifiers,baseName))return baseName;for(var count=0;;){count++;var name_21=baseName+"_"+count;if(!ts.hasProperty(currentIdentifiers,name_21))return name_21}}function emitExportAssignment(node){function getDefaultExportAccessibilityDiagnostic(diagnostic){return{diagnosticMessage:ts.Diagnostics.Default_export_of_the_module_has_or_is_using_private_name_0,errorNode:node}}if(69===node.expression.kind)write(node.isExportEquals?"export = ":"export default "),writeTextOfNode(currentText,node.expression);else{var tempVarName=getExportDefaultTempVariableName();write("declare var "),write(tempVarName),write(": "),writer.getSymbolAccessibilityDiagnostic=getDefaultExportAccessibilityDiagnostic,resolver.writeTypeOfExpression(node.expression,enclosingDeclaration,2,writer),write(";"),writeLine(),write(node.isExportEquals?"export = ":"export default "),write(tempVarName)}if(write(";"),writeLine(),69===node.expression.kind){var nodes=resolver.collectLinkedAliases(node.expression);writeAsynchronousModuleElements(nodes)}}function isModuleElementVisible(node){return resolver.isDeclarationVisible(node)}function emitModuleElement(node,isModuleElementVisible){if(isModuleElementVisible)writeModuleElement(node);else if(224===node.kind||251===node.parent.kind&&isCurrentFileExternalModule){var isVisible=void 0;if(asynchronousSubModuleDeclarationEmitInfo&&251!==node.parent.kind)asynchronousSubModuleDeclarationEmitInfo.push({node:node,outputPos:writer.getTextPos(),indent:writer.getIndent(),isVisible:isVisible});else{if(225===node.kind){var importDeclaration=node;importDeclaration.importClause&&(isVisible=importDeclaration.importClause.name&&resolver.isDeclarationVisible(importDeclaration.importClause)||isVisibleNamedBinding(importDeclaration.importClause.namedBindings))}moduleElementDeclarationEmitInfo.push({node:node,outputPos:writer.getTextPos(),indent:writer.getIndent(),isVisible:isVisible})}}}function writeModuleElement(node){switch(node.kind){case 216:return writeFunctionDeclaration(node);case 196:return writeVariableStatement(node);case 218:return writeInterfaceDeclaration(node);case 217:return writeClassDeclaration(node);case 219:return writeTypeAliasDeclaration(node);case 220:return writeEnumDeclaration(node);case 221:return writeModuleDeclaration(node);case 224:return writeImportEqualsDeclaration(node);case 225:return writeImportDeclaration(node);default:ts.Debug.fail("Unknown symbol kind")}}function emitModuleElementDeclarationFlags(node){251===node.parent.kind&&(2&node.flags&&write("export "),512&node.flags?write("default "):218===node.kind||noDeclare||write("declare "))}function emitClassMemberDeclarationFlags(node){16&node.flags?write("private "):32&node.flags&&write("protected "),64&node.flags&&write("static "),128&node.flags&&write("abstract ")}function writeImportEqualsDeclaration(node){function getImportEntityNameVisibilityError(symbolAccesibilityResult){return{diagnosticMessage:ts.Diagnostics.Import_declaration_0_is_using_private_name_1,errorNode:node,typeName:node.name}}emitJsDocComments(node),2&node.flags&&write("export "),write("import "),writeTextOfNode(currentText,node.name),write(" = "),ts.isInternalModuleImportEqualsDeclaration(node)?(emitTypeWithNewGetSymbolAccessibilityDiagnostic(node.moduleReference,getImportEntityNameVisibilityError),write(";")):(write("require("),emitExternalModuleSpecifier(node),write(");")),writer.writeLine()}function isVisibleNamedBinding(namedBindings){if(namedBindings)return 227===namedBindings.kind?resolver.isDeclarationVisible(namedBindings):ts.forEach(namedBindings.elements,function(namedImport){return resolver.isDeclarationVisible(namedImport)})}function writeImportDeclaration(node){if(emitJsDocComments(node),2&node.flags&&write("export "),write("import "),node.importClause){var currentWriterPos=writer.getTextPos();node.importClause.name&&resolver.isDeclarationVisible(node.importClause)&&writeTextOfNode(currentText,node.importClause.name),node.importClause.namedBindings&&isVisibleNamedBinding(node.importClause.namedBindings)&&(currentWriterPos!==writer.getTextPos()&&write(", "),227===node.importClause.namedBindings.kind?(write("* as "),writeTextOfNode(currentText,node.importClause.namedBindings.name)):(write("{ "),emitCommaList(node.importClause.namedBindings.elements,emitImportOrExportSpecifier,resolver.isDeclarationVisible),write(" }"))),write(" from ")}emitExternalModuleSpecifier(node),write(";"),writer.writeLine()}function emitExternalModuleSpecifier(parent){resultHasExternalModuleIndicator=resultHasExternalModuleIndicator||221!==parent.kind;var moduleSpecifier;if(224===parent.kind){var node=parent;moduleSpecifier=ts.getExternalModuleImportEqualsDeclarationExpression(node)}else if(221===parent.kind)moduleSpecifier=parent.name;else{var node=parent;moduleSpecifier=node.moduleSpecifier}if(9===moduleSpecifier.kind&&isBundledEmit&&(compilerOptions.out||compilerOptions.outFile)){var moduleName=ts.getExternalModuleNameFromDeclaration(host,resolver,parent);if(moduleName)return write('"'),write(moduleName),void write('"')}writeTextOfNode(currentText,moduleSpecifier)}function emitImportOrExportSpecifier(node){node.propertyName&&(writeTextOfNode(currentText,node.propertyName),write(" as ")),writeTextOfNode(currentText,node.name)}function emitExportSpecifier(node){emitImportOrExportSpecifier(node);var nodes=resolver.collectLinkedAliases(node.propertyName||node.name);writeAsynchronousModuleElements(nodes)}function emitExportDeclaration(node){emitJsDocComments(node),write("export "),node.exportClause?(write("{ "),emitCommaList(node.exportClause.elements,emitExportSpecifier),write(" }")):write("*"),node.moduleSpecifier&&(write(" from "),emitExternalModuleSpecifier(node)),write(";"),writer.writeLine()}function writeModuleDeclaration(node){for(emitJsDocComments(node),emitModuleElementDeclarationFlags(node),ts.isGlobalScopeAugmentation(node)?write("global "):(write(65536&node.flags?"namespace ":"module "),ts.isExternalModuleAugmentation(node)?emitExternalModuleSpecifier(node):writeTextOfNode(currentText,node.name));222!==node.body.kind;)node=node.body,write("."),writeTextOfNode(currentText,node.name);var prevEnclosingDeclaration=enclosingDeclaration;enclosingDeclaration=node,write(" {"),writeLine(),increaseIndent(),emitLines(node.body.statements),decreaseIndent(),write("}"),writeLine(),enclosingDeclaration=prevEnclosingDeclaration}function writeTypeAliasDeclaration(node){function getTypeAliasDeclarationVisibilityError(symbolAccesibilityResult){return{diagnosticMessage:ts.Diagnostics.Exported_type_alias_0_has_or_is_using_private_name_1,errorNode:node.type,typeName:node.name}}var prevEnclosingDeclaration=enclosingDeclaration;enclosingDeclaration=node,emitJsDocComments(node),emitModuleElementDeclarationFlags(node),write("type "),writeTextOfNode(currentText,node.name),emitTypeParameters(node.typeParameters),write(" = "),emitTypeWithNewGetSymbolAccessibilityDiagnostic(node.type,getTypeAliasDeclarationVisibilityError),write(";"),writeLine(),enclosingDeclaration=prevEnclosingDeclaration}function writeEnumDeclaration(node){emitJsDocComments(node),emitModuleElementDeclarationFlags(node),ts.isConst(node)&&write("const "),write("enum "),writeTextOfNode(currentText,node.name),write(" {"),writeLine(),increaseIndent(),emitLines(node.members),decreaseIndent(),write("}"),writeLine()}function emitEnumMemberDeclaration(node){emitJsDocComments(node),writeTextOfNode(currentText,node.name);var enumMemberValue=resolver.getConstantValue(node);void 0!==enumMemberValue&&(write(" = "),write(enumMemberValue.toString())),write(","),writeLine()}function isPrivateMethodTypeParameter(node){return 144===node.parent.kind&&16&node.parent.flags}function emitTypeParameters(typeParameters){function emitTypeParameter(node){function getTypeParameterConstraintVisibilityError(symbolAccesibilityResult){var diagnosticMessage;switch(node.parent.kind){case 217:diagnosticMessage=ts.Diagnostics.Type_parameter_0_of_exported_class_has_or_is_using_private_name_1;break;case 218:diagnosticMessage=ts.Diagnostics.Type_parameter_0_of_exported_interface_has_or_is_using_private_name_1;break;case 149:diagnosticMessage=ts.Diagnostics.Type_parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1;break;case 148:diagnosticMessage=ts.Diagnostics.Type_parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1;break;case 144:case 143:diagnosticMessage=64&node.parent.flags?ts.Diagnostics.Type_parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1:217===node.parent.parent.kind?ts.Diagnostics.Type_parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1:ts.Diagnostics.Type_parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1;break;case 216:diagnosticMessage=ts.Diagnostics.Type_parameter_0_of_exported_function_has_or_is_using_private_name_1;break;default:ts.Debug.fail("This is unknown parent for type parameter: "+node.parent.kind)}return{diagnosticMessage:diagnosticMessage,errorNode:node,typeName:node.name}}increaseIndent(),emitJsDocComments(node),decreaseIndent(),writeTextOfNode(currentText,node.name),node.constraint&&!isPrivateMethodTypeParameter(node)&&(write(" extends "),153===node.parent.kind||154===node.parent.kind||node.parent.parent&&156===node.parent.parent.kind?(ts.Debug.assert(144===node.parent.kind||143===node.parent.kind||153===node.parent.kind||154===node.parent.kind||148===node.parent.kind||149===node.parent.kind),emitType(node.constraint)):emitTypeWithNewGetSymbolAccessibilityDiagnostic(node.constraint,getTypeParameterConstraintVisibilityError))}typeParameters&&(write("<"),emitCommaList(typeParameters,emitTypeParameter),write(">"))}function emitHeritageClause(typeReferences,isImplementsList){function emitTypeOfTypeReference(node){function getHeritageClauseVisibilityError(symbolAccesibilityResult){var diagnosticMessage;return diagnosticMessage=217===node.parent.parent.kind?isImplementsList?ts.Diagnostics.Implements_clause_of_exported_class_0_has_or_is_using_private_name_1:ts.Diagnostics.Extends_clause_of_exported_class_0_has_or_is_using_private_name_1:ts.Diagnostics.Extends_clause_of_exported_interface_0_has_or_is_using_private_name_1,{diagnosticMessage:diagnosticMessage,errorNode:node,typeName:node.parent.parent.name}}ts.isSupportedExpressionWithTypeArguments(node)?emitTypeWithNewGetSymbolAccessibilityDiagnostic(node,getHeritageClauseVisibilityError):isImplementsList||93!==node.expression.kind||write("null")}typeReferences&&(write(isImplementsList?" implements ":" extends "),emitCommaList(typeReferences,emitTypeOfTypeReference))}function writeClassDeclaration(node){function emitParameterProperties(constructorDeclaration){constructorDeclaration&&ts.forEach(constructorDeclaration.parameters,function(param){56&param.flags&&emitPropertyDeclaration(param)})}emitJsDocComments(node),emitModuleElementDeclarationFlags(node),128&node.flags&&write("abstract "),write("class "),writeTextOfNode(currentText,node.name);var prevEnclosingDeclaration=enclosingDeclaration;enclosingDeclaration=node,emitTypeParameters(node.typeParameters);var baseTypeNode=ts.getClassExtendsHeritageClauseElement(node);baseTypeNode&&emitHeritageClause([baseTypeNode],!1),emitHeritageClause(ts.getClassImplementsHeritageClauseElements(node),!0),write(" {"),writeLine(),increaseIndent(),emitParameterProperties(ts.getFirstConstructorWithBody(node)),emitLines(node.members),decreaseIndent(),write("}"),writeLine(),enclosingDeclaration=prevEnclosingDeclaration}function writeInterfaceDeclaration(node){emitJsDocComments(node),emitModuleElementDeclarationFlags(node),write("interface "),writeTextOfNode(currentText,node.name);var prevEnclosingDeclaration=enclosingDeclaration;enclosingDeclaration=node,emitTypeParameters(node.typeParameters),emitHeritageClause(ts.getInterfaceBaseTypeNodes(node),!1),write(" {"),writeLine(),increaseIndent(),emitLines(node.members),decreaseIndent(),write("}"),writeLine(),enclosingDeclaration=prevEnclosingDeclaration}function emitPropertyDeclaration(node){ts.hasDynamicName(node)||(emitJsDocComments(node),emitClassMemberDeclarationFlags(node),emitVariableDeclaration(node),write(";"),writeLine())}function emitVariableDeclaration(node){function getVariableDeclarationTypeVisibilityDiagnosticMessage(symbolAccesibilityResult){return 214===node.kind?symbolAccesibilityResult.errorModuleName?2===symbolAccesibilityResult.accessibility?ts.Diagnostics.Exported_variable_0_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:ts.Diagnostics.Exported_variable_0_has_or_is_using_name_1_from_private_module_2:ts.Diagnostics.Exported_variable_0_has_or_is_using_private_name_1:142===node.kind||141===node.kind?64&node.flags?symbolAccesibilityResult.errorModuleName?2===symbolAccesibilityResult.accessibility?ts.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:ts.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:ts.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_private_name_1:217===node.parent.kind?symbolAccesibilityResult.errorModuleName?2===symbolAccesibilityResult.accessibility?ts.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:ts.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2:ts.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_private_name_1:symbolAccesibilityResult.errorModuleName?ts.Diagnostics.Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2:ts.Diagnostics.Property_0_of_exported_interface_has_or_is_using_private_name_1:void 0}function getVariableDeclarationTypeVisibilityError(symbolAccesibilityResult){var diagnosticMessage=getVariableDeclarationTypeVisibilityDiagnosticMessage(symbolAccesibilityResult);return void 0!==diagnosticMessage?{diagnosticMessage:diagnosticMessage,errorNode:node,typeName:node.name}:void 0}function emitBindingPattern(bindingPattern){for(var elements=[],_i=0,_a=bindingPattern.elements;_i<_a.length;_i++){var element=_a[_i];190!==element.kind&&elements.push(element)}emitCommaList(elements,emitBindingElement)}function emitBindingElement(bindingElement){function getBindingElementTypeVisibilityError(symbolAccesibilityResult){var diagnosticMessage=getVariableDeclarationTypeVisibilityDiagnosticMessage(symbolAccesibilityResult);return void 0!==diagnosticMessage?{diagnosticMessage:diagnosticMessage,errorNode:bindingElement,typeName:bindingElement.name}:void 0}bindingElement.name&&(ts.isBindingPattern(bindingElement.name)?emitBindingPattern(bindingElement.name):(writeTextOfNode(currentText,bindingElement.name),writeTypeOfDeclaration(bindingElement,void 0,getBindingElementTypeVisibilityError)))}(214!==node.kind||resolver.isDeclarationVisible(node))&&(ts.isBindingPattern(node.name)?emitBindingPattern(node.name):(writeTextOfNode(currentText,node.name),142!==node.kind&&141!==node.kind||!ts.hasQuestionToken(node)||write("?"),142!==node.kind&&141!==node.kind||156!==node.parent.kind?16&node.flags||writeTypeOfDeclaration(node,node.type,getVariableDeclarationTypeVisibilityError):emitTypeOfVariableDeclarationFromTypeLiteral(node)))}function emitTypeOfVariableDeclarationFromTypeLiteral(node){node.type&&(write(": "),emitType(node.type))}function isVariableStatementVisible(node){return ts.forEach(node.declarationList.declarations,function(varDeclaration){return resolver.isDeclarationVisible(varDeclaration)})}function writeVariableStatement(node){emitJsDocComments(node),emitModuleElementDeclarationFlags(node),write(ts.isLet(node.declarationList)?"let ":ts.isConst(node.declarationList)?"const ":"var "),emitCommaList(node.declarationList.declarations,emitVariableDeclaration,resolver.isDeclarationVisible),
write(";"),writeLine()}function emitAccessorDeclaration(node){function getTypeAnnotationFromAccessor(accessor){if(accessor)return 146===accessor.kind?accessor.type:accessor.parameters.length>0?accessor.parameters[0].type:void 0}function getAccessorDeclarationTypeVisibilityError(symbolAccesibilityResult){var diagnosticMessage;return 147===accessorWithTypeAnnotation.kind?(diagnosticMessage=64&accessorWithTypeAnnotation.parent.flags?symbolAccesibilityResult.errorModuleName?ts.Diagnostics.Parameter_0_of_public_static_property_setter_from_exported_class_has_or_is_using_name_1_from_private_module_2:ts.Diagnostics.Parameter_0_of_public_static_property_setter_from_exported_class_has_or_is_using_private_name_1:symbolAccesibilityResult.errorModuleName?ts.Diagnostics.Parameter_0_of_public_property_setter_from_exported_class_has_or_is_using_name_1_from_private_module_2:ts.Diagnostics.Parameter_0_of_public_property_setter_from_exported_class_has_or_is_using_private_name_1,{diagnosticMessage:diagnosticMessage,errorNode:accessorWithTypeAnnotation.parameters[0],typeName:accessorWithTypeAnnotation.name}):(diagnosticMessage=64&accessorWithTypeAnnotation.flags?symbolAccesibilityResult.errorModuleName?2===symbolAccesibilityResult.accessibility?ts.Diagnostics.Return_type_of_public_static_property_getter_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:ts.Diagnostics.Return_type_of_public_static_property_getter_from_exported_class_has_or_is_using_name_0_from_private_module_1:ts.Diagnostics.Return_type_of_public_static_property_getter_from_exported_class_has_or_is_using_private_name_0:symbolAccesibilityResult.errorModuleName?2===symbolAccesibilityResult.accessibility?ts.Diagnostics.Return_type_of_public_property_getter_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:ts.Diagnostics.Return_type_of_public_property_getter_from_exported_class_has_or_is_using_name_0_from_private_module_1:ts.Diagnostics.Return_type_of_public_property_getter_from_exported_class_has_or_is_using_private_name_0,{diagnosticMessage:diagnosticMessage,errorNode:accessorWithTypeAnnotation.name,typeName:void 0})}if(!ts.hasDynamicName(node)){var accessorWithTypeAnnotation,accessors=ts.getAllAccessorDeclarations(node.parent.members,node);if(node===accessors.firstAccessor){if(emitJsDocComments(accessors.getAccessor),emitJsDocComments(accessors.setAccessor),emitClassMemberDeclarationFlags(node),writeTextOfNode(currentText,node.name),!(16&node.flags)){accessorWithTypeAnnotation=node;var type=getTypeAnnotationFromAccessor(node);if(!type){var anotherAccessor=146===node.kind?accessors.setAccessor:accessors.getAccessor;type=getTypeAnnotationFromAccessor(anotherAccessor),type&&(accessorWithTypeAnnotation=anotherAccessor)}writeTypeOfDeclaration(node,type,getAccessorDeclarationTypeVisibilityError)}write(";"),writeLine()}}}function writeFunctionDeclaration(node){ts.hasDynamicName(node)||resolver.isImplementationOfOverload(node)||(emitJsDocComments(node),216===node.kind?emitModuleElementDeclarationFlags(node):144===node.kind&&emitClassMemberDeclarationFlags(node),216===node.kind?(write("function "),writeTextOfNode(currentText,node.name)):145===node.kind?write("constructor"):(writeTextOfNode(currentText,node.name),ts.hasQuestionToken(node)&&write("?")),emitSignatureDeclaration(node))}function emitSignatureDeclarationWithJsDocComments(node){emitJsDocComments(node),emitSignatureDeclaration(node)}function emitSignatureDeclaration(node){function getReturnTypeVisibilityError(symbolAccesibilityResult){var diagnosticMessage;switch(node.kind){case 149:diagnosticMessage=symbolAccesibilityResult.errorModuleName?ts.Diagnostics.Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1:ts.Diagnostics.Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_0;break;case 148:diagnosticMessage=symbolAccesibilityResult.errorModuleName?ts.Diagnostics.Return_type_of_call_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1:ts.Diagnostics.Return_type_of_call_signature_from_exported_interface_has_or_is_using_private_name_0;break;case 150:diagnosticMessage=symbolAccesibilityResult.errorModuleName?ts.Diagnostics.Return_type_of_index_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1:ts.Diagnostics.Return_type_of_index_signature_from_exported_interface_has_or_is_using_private_name_0;break;case 144:case 143:diagnosticMessage=64&node.flags?symbolAccesibilityResult.errorModuleName?2===symbolAccesibilityResult.accessibility?ts.Diagnostics.Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:ts.Diagnostics.Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_private_module_1:ts.Diagnostics.Return_type_of_public_static_method_from_exported_class_has_or_is_using_private_name_0:217===node.parent.kind?symbolAccesibilityResult.errorModuleName?2===symbolAccesibilityResult.accessibility?ts.Diagnostics.Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:ts.Diagnostics.Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_private_module_1:ts.Diagnostics.Return_type_of_public_method_from_exported_class_has_or_is_using_private_name_0:symbolAccesibilityResult.errorModuleName?ts.Diagnostics.Return_type_of_method_from_exported_interface_has_or_is_using_name_0_from_private_module_1:ts.Diagnostics.Return_type_of_method_from_exported_interface_has_or_is_using_private_name_0;break;case 216:diagnosticMessage=symbolAccesibilityResult.errorModuleName?2===symbolAccesibilityResult.accessibility?ts.Diagnostics.Return_type_of_exported_function_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named:ts.Diagnostics.Return_type_of_exported_function_has_or_is_using_name_0_from_private_module_1:ts.Diagnostics.Return_type_of_exported_function_has_or_is_using_private_name_0;break;default:ts.Debug.fail("This is unknown kind for signature: "+node.kind)}return{diagnosticMessage:diagnosticMessage,errorNode:node.name||node}}var prevEnclosingDeclaration=enclosingDeclaration;enclosingDeclaration=node,149!==node.kind&&154!==node.kind||write("new "),emitTypeParameters(node.typeParameters),write(150===node.kind?"[":"("),emitCommaList(node.parameters,emitParameterDeclaration),write(150===node.kind?"]":")");var isFunctionTypeOrConstructorType=153===node.kind||154===node.kind;isFunctionTypeOrConstructorType||156===node.parent.kind?node.type&&(write(isFunctionTypeOrConstructorType?" => ":": "),emitType(node.type)):145===node.kind||16&node.flags||writeReturnTypeAtSignature(node,getReturnTypeVisibilityError),enclosingDeclaration=prevEnclosingDeclaration,isFunctionTypeOrConstructorType||(write(";"),writeLine())}function emitParameterDeclaration(node){function getParameterDeclarationTypeVisibilityError(symbolAccesibilityResult){var diagnosticMessage=getParameterDeclarationTypeVisibilityDiagnosticMessage(symbolAccesibilityResult);return void 0!==diagnosticMessage?{diagnosticMessage:diagnosticMessage,errorNode:node,typeName:node.name}:void 0}function getParameterDeclarationTypeVisibilityDiagnosticMessage(symbolAccesibilityResult){switch(node.parent.kind){case 145:return symbolAccesibilityResult.errorModuleName?2===symbolAccesibilityResult.accessibility?ts.Diagnostics.Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:ts.Diagnostics.Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_private_module_2:ts.Diagnostics.Parameter_0_of_constructor_from_exported_class_has_or_is_using_private_name_1;case 149:return symbolAccesibilityResult.errorModuleName?ts.Diagnostics.Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2:ts.Diagnostics.Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1;case 148:return symbolAccesibilityResult.errorModuleName?ts.Diagnostics.Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2:ts.Diagnostics.Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1;case 144:case 143:return 64&node.parent.flags?symbolAccesibilityResult.errorModuleName?2===symbolAccesibilityResult.accessibility?ts.Diagnostics.Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:ts.Diagnostics.Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_private_module_2:ts.Diagnostics.Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1:217===node.parent.parent.kind?symbolAccesibilityResult.errorModuleName?2===symbolAccesibilityResult.accessibility?ts.Diagnostics.Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:ts.Diagnostics.Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_private_module_2:ts.Diagnostics.Parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1:symbolAccesibilityResult.errorModuleName?ts.Diagnostics.Parameter_0_of_method_from_exported_interface_has_or_is_using_name_1_from_private_module_2:ts.Diagnostics.Parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1;case 216:return symbolAccesibilityResult.errorModuleName?2===symbolAccesibilityResult.accessibility?ts.Diagnostics.Parameter_0_of_exported_function_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named:ts.Diagnostics.Parameter_0_of_exported_function_has_or_is_using_name_1_from_private_module_2:ts.Diagnostics.Parameter_0_of_exported_function_has_or_is_using_private_name_1;default:ts.Debug.fail("This is unknown parent for parameter: "+node.parent.kind)}}function emitBindingPattern(bindingPattern){if(164===bindingPattern.kind)write("{"),emitCommaList(bindingPattern.elements,emitBindingElement),write("}");else if(165===bindingPattern.kind){write("[");var elements=bindingPattern.elements;emitCommaList(elements,emitBindingElement),elements&&elements.hasTrailingComma&&write(", "),write("]")}}function emitBindingElement(bindingElement){190===bindingElement.kind?write(" "):166===bindingElement.kind&&(bindingElement.propertyName&&(writeTextOfNode(currentText,bindingElement.propertyName),write(": ")),bindingElement.name&&(ts.isBindingPattern(bindingElement.name)?emitBindingPattern(bindingElement.name):(ts.Debug.assert(69===bindingElement.name.kind),bindingElement.dotDotDotToken&&write("..."),writeTextOfNode(currentText,bindingElement.name))))}increaseIndent(),emitJsDocComments(node),node.dotDotDotToken&&write("..."),ts.isBindingPattern(node.name)?emitBindingPattern(node.name):writeTextOfNode(currentText,node.name),resolver.isOptionalParameter(node)&&write("?"),decreaseIndent(),153===node.parent.kind||154===node.parent.kind||156===node.parent.parent.kind?emitTypeOfVariableDeclarationFromTypeLiteral(node):16&node.parent.flags||writeTypeOfDeclaration(node,node.type,getParameterDeclarationTypeVisibilityError)}function emitNode(node){switch(node.kind){case 216:case 221:case 224:case 218:case 217:case 219:case 220:return emitModuleElement(node,isModuleElementVisible(node));case 196:return emitModuleElement(node,isVariableStatementVisible(node));case 225:return emitModuleElement(node,!node.importClause);case 231:return emitExportDeclaration(node);case 145:case 144:case 143:return writeFunctionDeclaration(node);case 149:case 148:case 150:return emitSignatureDeclarationWithJsDocComments(node);case 146:case 147:return emitAccessorDeclaration(node);case 142:case 141:return emitPropertyDeclaration(node);case 250:return emitEnumMemberDeclaration(node);case 230:return emitExportAssignment(node);case 251:return emitSourceFile(node)}}function writeReferencePath(referencedFile,addBundledFileReference){function getDeclFileName(emitFileNames,sourceFiles,isBundledEmit){isBundledEmit&&!addBundledFileReference||(ts.Debug.assert(!!emitFileNames.declarationFilePath||ts.isSourceFileJavaScript(referencedFile),"Declaration file is not present only for javascript files"),declFileName=emitFileNames.declarationFilePath||emitFileNames.jsFilePath,addedBundledEmitReference=isBundledEmit)}var declFileName,addedBundledEmitReference=!1;return ts.isDeclarationFile(referencedFile)?declFileName=referencedFile.fileName:ts.forEachExpectedEmitFile(host,getDeclFileName,referencedFile),declFileName&&(declFileName=ts.getRelativePathToDirectoryOrUrl(ts.getDirectoryPath(ts.normalizeSlashes(declarationFilePath)),declFileName,host.getCurrentDirectory(),host.getCanonicalFileName,!1),referencePathsOutput+='/// <reference path="'+declFileName+'" />'+newLine),addedBundledEmitReference}var write,writeLine,increaseIndent,decreaseIndent,writeTextOfNode,enclosingDeclaration,resultHasExternalModuleIndicator,currentText,currentLineMap,currentIdentifiers,isCurrentFileExternalModule,errorNameNode,noDeclare,asynchronousSubModuleDeclarationEmitInfo,newLine=host.getNewLine(),compilerOptions=host.getCompilerOptions(),writer=createAndSetNewTextWriterWithSymbolWriter(),reportedDeclarationError=!1,emitJsDocComments=compilerOptions.removeComments?function(declaration){}:writeJsDocComments,emit=compilerOptions.stripInternal?stripInternal:emitNode,moduleElementDeclarationEmitInfo=[],referencePathsOutput="",emittedReferencedFiles=[],addedGlobalFileReference=!1,allSourcesModuleElementDeclarationEmitInfo=[];return ts.forEach(sourceFiles,function(sourceFile){if(!ts.isSourceFileJavaScript(sourceFile)){if(compilerOptions.noResolve||ts.forEach(sourceFile.referencedFiles,function(fileReference){var referencedFile=ts.tryResolveScriptReference(host,sourceFile,fileReference);referencedFile&&!ts.contains(emittedReferencedFiles,referencedFile)&&(writeReferencePath(referencedFile,!isBundledEmit&&!addedGlobalFileReference)&&(addedGlobalFileReference=!0),emittedReferencedFiles.push(referencedFile))}),resultHasExternalModuleIndicator=!1,isBundledEmit&&ts.isExternalModule(sourceFile)?ts.isExternalModule(sourceFile)&&(noDeclare=!0,write('declare module "'+ts.getResolvedExternalModuleName(host,sourceFile)+'" {'),writeLine(),increaseIndent(),emitSourceFile(sourceFile),decreaseIndent(),write("}"),writeLine()):(noDeclare=!1,emitSourceFile(sourceFile)),moduleElementDeclarationEmitInfo.length){var oldWriter=writer;ts.forEach(moduleElementDeclarationEmitInfo,function(aliasEmitInfo){if(aliasEmitInfo.isVisible&&!aliasEmitInfo.asynchronousOutput){ts.Debug.assert(225===aliasEmitInfo.node.kind),createAndSetNewTextWriterWithSymbolWriter(),ts.Debug.assert(0===aliasEmitInfo.indent||1===aliasEmitInfo.indent&&isBundledEmit);for(var i=0;i<aliasEmitInfo.indent;i++)increaseIndent();writeImportDeclaration(aliasEmitInfo.node),aliasEmitInfo.asynchronousOutput=writer.getText();for(var i=0;i<aliasEmitInfo.indent;i++)decreaseIndent()}}),setWriter(oldWriter),allSourcesModuleElementDeclarationEmitInfo=allSourcesModuleElementDeclarationEmitInfo.concat(moduleElementDeclarationEmitInfo),moduleElementDeclarationEmitInfo=[]}!isBundledEmit&&ts.isExternalModule(sourceFile)&&sourceFile.moduleAugmentations.length&&!resultHasExternalModuleIndicator&&(write("export {};"),writeLine())}}),{reportedDeclarationError:reportedDeclarationError,moduleElementDeclarationEmitInfo:allSourcesModuleElementDeclarationEmitInfo,synchronousDeclarationOutput:writer.getText(),referencePathsOutput:referencePathsOutput}}function writeDeclarationFile(declarationFilePath,sourceFiles,isBundledEmit,host,resolver,emitterDiagnostics){function getDeclarationOutput(synchronousDeclarationOutput,moduleElementDeclarationEmitInfo){var appliedSyncOutputPos=0,declarationOutput="";return ts.forEach(moduleElementDeclarationEmitInfo,function(aliasEmitInfo){aliasEmitInfo.asynchronousOutput&&(declarationOutput+=synchronousDeclarationOutput.substring(appliedSyncOutputPos,aliasEmitInfo.outputPos),declarationOutput+=getDeclarationOutput(aliasEmitInfo.asynchronousOutput,aliasEmitInfo.subModuleElementDeclarationEmitInfo),appliedSyncOutputPos=aliasEmitInfo.outputPos)}),declarationOutput+=synchronousDeclarationOutput.substring(appliedSyncOutputPos)}var emitDeclarationResult=emitDeclarations(host,resolver,emitterDiagnostics,declarationFilePath,sourceFiles,isBundledEmit),emitSkipped=emitDeclarationResult.reportedDeclarationError||host.isEmitBlocked(declarationFilePath)||host.getCompilerOptions().noEmit;if(!emitSkipped){var declarationOutput=emitDeclarationResult.referencePathsOutput+getDeclarationOutput(emitDeclarationResult.synchronousDeclarationOutput,emitDeclarationResult.moduleElementDeclarationEmitInfo);ts.writeFile(host,emitterDiagnostics,declarationFilePath,declarationOutput,host.getCompilerOptions().emitBOM)}return emitSkipped}ts.getDeclarationDiagnostics=getDeclarationDiagnostics,ts.writeDeclarationFile=writeDeclarationFile}(ts||(ts={}));var ts;!function(ts){function getResolvedExternalModuleName(host,file){return file.moduleName||ts.getExternalModuleNameFromPath(host,file.fileName)}function getExternalModuleNameFromDeclaration(host,resolver,declaration){var file=resolver.getExternalModuleFileFromDeclaration(declaration);if(file&&!ts.isDeclarationFile(file))return getResolvedExternalModuleName(host,file)}function emitFiles(resolver,host,targetSourceFile){function isUniqueLocalName(name,container){for(var node=container;ts.isNodeDescendentOf(node,container);node=node.nextContainer)if(node.locals&&ts.hasProperty(node.locals,name)&&9544639&node.locals[name].flags)return!1;return!0}function setLabeledJump(state,isBreak,labelText,labelMarker){isBreak?(state.labeledNonLocalBreaks||(state.labeledNonLocalBreaks={}),state.labeledNonLocalBreaks[labelText]=labelMarker):(state.labeledNonLocalContinues||(state.labeledNonLocalContinues={}),state.labeledNonLocalContinues[labelText]=labelMarker)}function hoistVariableDeclarationFromLoop(state,declaration){function visit(node){if(69===node.kind)state.hoistedLocalVariables.push(node);else for(var _a=0,_b=node.elements;_a<_b.length;_a++){var element=_b[_a];visit(element.name)}}state.hoistedLocalVariables||(state.hoistedLocalVariables=[]),visit(declaration.name)}function createFileEmitter(){function doEmit(jsFilePath,sourceMapFilePath,sourceFiles,isBundledEmit){sourceMap.initialize(jsFilePath,sourceMapFilePath,sourceFiles,isBundledEmit),generatedNameSet={},nodeToGeneratedName=[],decoratedClassAliases=[],isOwnFileEmit=!isBundledEmit,isBundledEmit&&modulekind&&ts.forEach(sourceFiles,emitEmitHelpers),ts.forEach(sourceFiles,emitSourceFile),writeLine();var sourceMappingURL=sourceMap.getSourceMappingURL();sourceMappingURL&&write("//# sourceMappingURL="+sourceMappingURL),writeEmittedFiles(writer.getText(),jsFilePath,sourceMapFilePath,compilerOptions.emitBOM),sourceMap.reset(),writer.reset(),currentSourceFile=void 0,currentText=void 0,currentLineMap=void 0,exportFunctionForFile=void 0,contextObjectForFile=void 0,generatedNameSet=void 0,nodeToGeneratedName=void 0,decoratedClassAliases=void 0,computedPropertyNamesToGeneratedNames=void 0,convertedLoopState=void 0,extendsEmitted=!1,decorateEmitted=!1,paramEmitted=!1,awaiterEmitted=!1,tempFlags=0,tempVariables=void 0,tempParameters=void 0,externalImports=void 0,exportSpecifiers=void 0,exportEquals=void 0,hasExportStarsToExportValues=void 0,detachedCommentsInfo=void 0,sourceMapData=void 0,isEs6Module=!1,renamedDependencies=void 0,isCurrentFileExternalModule=!1}function emitSourceFile(sourceFile){currentSourceFile=sourceFile,currentText=sourceFile.text,currentLineMap=ts.getLineStarts(sourceFile),exportFunctionForFile=void 0,contextObjectForFile=void 0,isEs6Module=sourceFile.symbol&&sourceFile.symbol.exports&&!!sourceFile.symbol.exports.___esModule,renamedDependencies=sourceFile.renamedDependencies,currentFileIdentifiers=sourceFile.identifiers,isCurrentFileExternalModule=ts.isExternalModule(sourceFile),setSourceFile(sourceFile),emitNodeWithCommentsAndWithoutSourcemap(sourceFile)}function isUniqueName(name){return!resolver.hasGlobalName(name)&&!ts.hasProperty(currentFileIdentifiers,name)&&!ts.hasProperty(generatedNameSet,name)}function makeTempVariableName(flags){if(flags&&!(tempFlags&flags)){var name_22=268435456===flags?"_i":"_n";if(isUniqueName(name_22))return tempFlags|=flags,name_22}for(;;){var count=268435455&tempFlags;if(tempFlags++,8!==count&&13!==count){var name_23=count<26?"_"+String.fromCharCode(97+count):"_"+(count-26);if(isUniqueName(name_23))return name_23}}}function makeUniqueName(baseName){95!==baseName.charCodeAt(baseName.length-1)&&(baseName+="_");for(var i=1;;){var generatedName=baseName+i;if(isUniqueName(generatedName))return generatedNameSet[generatedName]=generatedName;i++}}function generateNameForModuleOrEnum(node){var name=node.name.text;return isUniqueLocalName(name,node)?name:makeUniqueName(name)}function generateNameForImportOrExportDeclaration(node){var expr=ts.getExternalModuleName(node),baseName=9===expr.kind?ts.escapeIdentifier(ts.makeIdentifierFromModuleName(expr.text)):"module";return makeUniqueName(baseName)}function generateNameForExportDefault(){return makeUniqueName("default")}function generateNameForClassExpression(){return makeUniqueName("class")}function generateNameForNode(node){switch(node.kind){case 69:return makeUniqueName(node.text);case 221:case 220:return generateNameForModuleOrEnum(node);case 225:case 231:return generateNameForImportOrExportDeclaration(node);case 216:case 217:case 230:return generateNameForExportDefault();case 189:return generateNameForClassExpression()}}function getGeneratedNameForNode(node){var id=ts.getNodeId(node);return nodeToGeneratedName[id]||(nodeToGeneratedName[id]=ts.unescapeIdentifier(generateNameForNode(node)))}function writeEmittedFiles(emitOutput,jsFilePath,sourceMapFilePath,writeByteOrderMark){compilerOptions.sourceMap&&!compilerOptions.inlineSourceMap&&ts.writeFile(host,emitterDiagnostics,sourceMapFilePath,sourceMap.getText(),!1),sourceMapDataList&&sourceMapDataList.push(sourceMap.getSourceMapData()),ts.writeFile(host,emitterDiagnostics,jsFilePath,emitOutput,writeByteOrderMark)}function createTempVariable(flags){var result=ts.createSynthesizedNode(69);return result.text=makeTempVariableName(flags),result}function recordTempDeclaration(name){tempVariables||(tempVariables=[]),tempVariables.push(name)}function createAndRecordTempVariable(flags){var temp=createTempVariable(flags);return recordTempDeclaration(temp),temp}function emitTempDeclarations(newLine){tempVariables&&(newLine?writeLine():write(" "),write("var "),emitCommaList(tempVariables),write(";"))}function emitToken(tokenKind,startPos,emitFn){var tokenStartPos=ts.skipTrivia(currentText,startPos);emitPos(tokenStartPos);var tokenString=ts.tokenToString(tokenKind);emitFn?emitFn():write(tokenString);var tokenEndPos=tokenStartPos+tokenString.length;return emitPos(tokenEndPos),tokenEndPos}function emitOptional(prefix,node){node&&(write(prefix),emit(node))}function emitParenthesizedIf(node,parenthesized){parenthesized&&write("("),emit(node),parenthesized&&write(")")}function emitLinePreservingList(parent,nodes,allowTrailingComma,spacesBetweenBraces){ts.Debug.assert(nodes.length>0),increaseIndent(),nodeStartPositionsAreOnSameLine(parent,nodes[0])?spacesBetweenBraces&&write(" "):writeLine();for(var i=0,n=nodes.length;i<n;i++)i&&(nodeEndIsOnSameLineAsNodeStart(nodes[i-1],nodes[i])?write(", "):(write(","),writeLine())),emit(nodes[i]);nodes.hasTrailingComma&&allowTrailingComma&&write(","),decreaseIndent(),nodeEndPositionsAreOnSameLine(parent,ts.lastOrUndefined(nodes))?spacesBetweenBraces&&write(" "):writeLine()}function emitList(nodes,start,count,multiLine,trailingComma,leadingComma,noTrailingNewLine,emitNode){emitNode||(emitNode=emit);for(var i=0;i<count;i++){multiLine?((i||leadingComma)&&write(","),writeLine()):(i||leadingComma)&&write(", ");var node=nodes[start+i];emitTrailingCommentsOfPosition(node.pos),emitNode(node),leadingComma=!0}return trailingComma&&write(","),multiLine&&!noTrailingNewLine&&writeLine(),count}function emitCommaList(nodes){nodes&&emitList(nodes,0,nodes.length,!1,!1)}function emitLines(nodes){emitLinesStartingAt(nodes,0)}function emitLinesStartingAt(nodes,startIndex){for(var i=startIndex;i<nodes.length;i++)writeLine(),emit(nodes[i])}function isBinaryOrOctalIntegerLiteral(node,text){if(8===node.kind&&text.length>1)switch(text.charCodeAt(1)){case 98:case 66:case 111:case 79:return!0}return!1}function emitLiteral(node){var text=getLiteralText(node);!compilerOptions.sourceMap&&!compilerOptions.inlineSourceMap||9!==node.kind&&!ts.isTemplateLiteralKind(node.kind)?write(languageVersion<2&&isBinaryOrOctalIntegerLiteral(node,text)?node.text:text):writer.writeLiteral(text)}function getLiteralText(node){if(languageVersion<2&&(ts.isTemplateLiteralKind(node.kind)||node.hasExtendedUnicodeEscape))return getQuotedEscapedLiteralText('"',node.text,'"');if(node.parent)return ts.getTextOfNodeFromSourceText(currentText,node);switch(node.kind){case 9:return getQuotedEscapedLiteralText('"',node.text,'"');case 11:return getQuotedEscapedLiteralText("`",node.text,"`");case 12:return getQuotedEscapedLiteralText("`",node.text,"${");case 13:return getQuotedEscapedLiteralText("}",node.text,"${");case 14:return getQuotedEscapedLiteralText("}",node.text,"`");case 8:return node.text}ts.Debug.fail("Literal kind '"+node.kind+"' not accounted for.")}function getQuotedEscapedLiteralText(leftQuote,text,rightQuote){return leftQuote+ts.escapeNonAsciiCharacters(ts.escapeString(text))+rightQuote}function emitDownlevelRawTemplateLiteral(node){var text=ts.getTextOfNodeFromSourceText(currentText,node),isLast=11===node.kind||14===node.kind;text=text.substring(1,text.length-(isLast?1:2)),text=text.replace(/\r\n?/g,"\n"),text=ts.escapeString(text),write('"'+text+'"')}function emitDownlevelTaggedTemplateArray(node,literalEmitter){write("["),11===node.template.kind?literalEmitter(node.template):(literalEmitter(node.template.head),ts.forEach(node.template.templateSpans,function(child){write(", "),literalEmitter(child.literal)})),write("]")}function emitDownlevelTaggedTemplate(node){var tempVariable=createAndRecordTempVariable(0);write("("),emit(tempVariable),write(" = "),emitDownlevelTaggedTemplateArray(node,emit),write(", "),emit(tempVariable),write(".raw = "),emitDownlevelTaggedTemplateArray(node,emitDownlevelRawTemplateLiteral),write(", "),emitParenthesizedIf(node.tag,needsParenthesisForPropertyAccessOrInvocation(node.tag)),write("("),emit(tempVariable),186===node.template.kind&&ts.forEach(node.template.templateSpans,function(templateSpan){write(", ");var needsParens=184===templateSpan.expression.kind&&24===templateSpan.expression.operatorToken.kind;emitParenthesizedIf(templateSpan.expression,needsParens)}),write("))")}function emitTemplateExpression(node){function shouldEmitTemplateHead(){return ts.Debug.assert(0!==node.templateSpans.length),0!==node.head.text.length||0===node.templateSpans[0].literal.text.length}function templateNeedsParens(template,parent){switch(parent.kind){case 171:case 172:return parent.expression===template;case 173:case 175:return!1;default:return comparePrecedenceToBinaryPlus(parent)!==-1}}function comparePrecedenceToBinaryPlus(expression){switch(expression.kind){case 184:switch(expression.operatorToken.kind){case 37:case 39:case 40:return 1;case 35:case 36:return 0;default:return-1}case 187:case 185:return-1;default:return 1}}if(languageVersion>=2)return void ts.forEachChild(node,emit);var emitOuterParens=ts.isExpression(node.parent)&&templateNeedsParens(node,node.parent);emitOuterParens&&write("(");var headEmitted=!1;shouldEmitTemplateHead()&&(emitLiteral(node.head),headEmitted=!0);for(var i=0,n=node.templateSpans.length;i<n;i++){var templateSpan=node.templateSpans[i],needsParens=175!==templateSpan.expression.kind&&1!==comparePrecedenceToBinaryPlus(templateSpan.expression);(i>0||headEmitted)&&write(" + "),emitParenthesizedIf(templateSpan.expression,needsParens),0!==templateSpan.literal.text.length&&(write(" + "),emitLiteral(templateSpan.literal))}emitOuterParens&&write(")")}function emitTemplateSpan(span){emit(span.expression),emit(span.literal)}function jsxEmitReact(node){function emitTagName(name){69===name.kind&&ts.isIntrinsicJsxName(name.text)?(write('"'),emit(name),write('"')):emit(name)}function emitAttributeName(name){/^[A-Za-z_]\w*$/.test(name.text)?emit(name):(write('"'),emit(name),write('"'))}function emitJsxAttribute(node){emitAttributeName(node.name),write(": "),node.initializer?emit(node.initializer):write("true")}function emitJsxElement(openingNode,children){var syntheticReactRef=ts.createSynthesizedNode(69);if(syntheticReactRef.text=compilerOptions.reactNamespace?compilerOptions.reactNamespace:"React",syntheticReactRef.parent=openingNode,emitLeadingComments(openingNode),emitExpressionIdentifier(syntheticReactRef),write(".createElement("),emitTagName(openingNode.tagName),write(", "),0===openingNode.attributes.length)write("null");else{var attrs=openingNode.attributes;if(ts.forEach(attrs,function(attr){return 242===attr.kind})){emitExpressionIdentifier(syntheticReactRef),write(".__spread(");for(var haveOpenedObjectLiteral=!1,i=0;i<attrs.length;i++)242===attrs[i].kind?(0===i&&write("{}, "),haveOpenedObjectLiteral&&(write("}"),haveOpenedObjectLiteral=!1),i>0&&write(", "),emit(attrs[i].expression)):(ts.Debug.assert(241===attrs[i].kind),haveOpenedObjectLiteral?write(", "):(haveOpenedObjectLiteral=!0,i>0&&write(", "),write("{")),emitJsxAttribute(attrs[i]));haveOpenedObjectLiteral&&write("}"),write(")")}else{write("{");for(var i=0,n=attrs.length;i<n;i++)i>0&&write(", "),emitJsxAttribute(attrs[i]);write("}")}}if(children)for(var i=0;i<children.length;i++)if(243!==children[i].kind||children[i].expression)if(239===children[i].kind){var text=getTextToEmit(children[i]);void 0!==text&&(write(', "'),write(text),write('"'))}else write(", "),emit(children[i]);write(")"),emitTrailingComments(openingNode)}236===node.kind?emitJsxElement(node.openingElement,node.children):(ts.Debug.assert(237===node.kind),emitJsxElement(node))}function jsxEmitPreserve(node){function emitJsxAttribute(node){emit(node.name),node.initializer&&(write("="),emit(node.initializer))}function emitJsxSpreadAttribute(node){write("{..."),emit(node.expression),write("}")}function emitAttributes(attribs){for(var i=0,n=attribs.length;i<n;i++)i>0&&write(" "),242===attribs[i].kind?emitJsxSpreadAttribute(attribs[i]):(ts.Debug.assert(241===attribs[i].kind),emitJsxAttribute(attribs[i]))}function emitJsxOpeningOrSelfClosingElement(node){write("<"),emit(node.tagName),(node.attributes.length>0||237===node.kind)&&write(" "),emitAttributes(node.attributes),write(237===node.kind?"/>":">")}function emitJsxClosingElement(node){write("</"),emit(node.tagName),write(">")}function emitJsxElement(node){emitJsxOpeningOrSelfClosingElement(node.openingElement);for(var i=0,n=node.children.length;i<n;i++)emit(node.children[i]);emitJsxClosingElement(node.closingElement)}236===node.kind?emitJsxElement(node):(ts.Debug.assert(237===node.kind),emitJsxOpeningOrSelfClosingElement(node))}function emitExpressionForPropertyName(node){if(ts.Debug.assert(166!==node.kind),9===node.kind)emitLiteral(node);else if(137===node.kind){if(ts.nodeIsDecorated(node.parent)){computedPropertyNamesToGeneratedNames||(computedPropertyNamesToGeneratedNames=[]);var generatedName=computedPropertyNamesToGeneratedNames[ts.getNodeId(node)];if(generatedName)return void write(generatedName);generatedName=createAndRecordTempVariable(0).text,computedPropertyNamesToGeneratedNames[ts.getNodeId(node)]=generatedName,write(generatedName),write(" = ")}emit(node.expression)}else write('"'),8===node.kind?write(node.text):writeTextOfNode(currentText,node),write('"')}function isExpressionIdentifier(node){var parent=node.parent;switch(parent.kind){case 167:case 192:case 184:case 171:case 244:case 137:case 185:case 140:case 178:case 200:case 170:case 230:
case 198:case 191:case 202:case 203:case 204:case 199:case 240:case 237:case 238:case 242:case 243:case 172:case 175:case 183:case 182:case 207:case 249:case 188:case 209:case 173:case 193:case 211:case 174:case 179:case 180:case 201:case 208:case 187:return!0;case 166:case 250:case 139:case 248:case 142:case 214:return parent.initializer===node;case 169:return parent.expression===node;case 177:case 176:return parent.body===node;case 224:return parent.moduleReference===node;case 136:return parent.left===node}return!1}function emitExpressionIdentifier(node){var container=resolver.getReferencedExportContainer(node);if(container)251===container.kind?5!==modulekind&&4!==modulekind&&write("exports."):(write(getGeneratedNameForNode(container)),write("."));else{if(5!==modulekind){var declaration=resolver.getReferencedImportDeclaration(node);if(declaration){if(226===declaration.kind)return write(getGeneratedNameForNode(declaration.parent)),void write(0===languageVersion?'["default"]':".default");if(229===declaration.kind){write(getGeneratedNameForNode(declaration.parent.parent.parent));var name_24=declaration.propertyName||declaration.name,identifier=ts.getTextOfNodeFromSourceText(currentText,name_24);return void(0===languageVersion&&"default"===identifier?write('["default"]'):(write("."),write(identifier)))}}}if(languageVersion<2){var declaration=resolver.getReferencedDeclarationWithCollidingName(node);if(declaration)return void write(getGeneratedNameForNode(declaration.name))}else if(1048576&resolver.getNodeCheckFlags(node)){var declaration=resolver.getReferencedValueDeclaration(node);if(declaration){var classAlias=decoratedClassAliases[ts.getNodeId(declaration)];if(void 0!==classAlias)return void write(classAlias)}}}ts.nodeIsSynthesized(node)?write(node.text):writeTextOfNode(currentText,node)}function isNameOfNestedBlockScopedRedeclarationOrCapturedBinding(node){if(languageVersion<2){var parent_8=node.parent;switch(parent_8.kind){case 166:case 217:case 220:case 214:return parent_8.name===node&&resolver.isDeclarationWithCollidingName(parent_8)}}return!1}function emitIdentifier(node){if(convertedLoopState&&"arguments"==node.text&&resolver.isArgumentsLocalBinding(node)){var name_25=convertedLoopState.argumentsName||(convertedLoopState.argumentsName=makeUniqueName("arguments"));return void write(name_25)}node.parent?isExpressionIdentifier(node)?emitExpressionIdentifier(node):isNameOfNestedBlockScopedRedeclarationOrCapturedBinding(node)?write(getGeneratedNameForNode(node)):ts.nodeIsSynthesized(node)?write(node.text):writeTextOfNode(currentText,node):write(node.text)}function emitThis(node){write(2&resolver.getNodeCheckFlags(node)?"_this":convertedLoopState?convertedLoopState.thisName||(convertedLoopState.thisName=makeUniqueName("this")):"this")}function emitSuper(node){if(languageVersion>=2)write("super");else{var flags=resolver.getNodeCheckFlags(node);write(256&flags?"_super.prototype":"_super")}}function emitObjectBindingPattern(node){write("{ ");var elements=node.elements;emitList(elements,0,elements.length,!1,elements.hasTrailingComma),write(" }")}function emitArrayBindingPattern(node){write("[");var elements=node.elements;emitList(elements,0,elements.length,!1,elements.hasTrailingComma),write("]")}function emitBindingElement(node){node.propertyName&&(emit(node.propertyName),write(": ")),node.dotDotDotToken&&write("..."),ts.isBindingPattern(node.name)?emit(node.name):emitModuleMemberName(node),emitOptional(" = ",node.initializer)}function emitSpreadElementExpression(node){write("..."),emit(node.expression)}function emitYieldExpression(node){write(ts.tokenToString(114)),node.asteriskToken&&write("*"),node.expression&&(write(" "),emit(node.expression))}function emitAwaitExpression(node){var needsParenthesis=needsParenthesisForAwaitExpressionAsYield(node);needsParenthesis&&write("("),write(ts.tokenToString(114)),write(" "),emit(node.expression),needsParenthesis&&write(")")}function needsParenthesisForAwaitExpressionAsYield(node){return 184===node.parent.kind&&!ts.isAssignmentOperator(node.parent.operatorToken.kind)||185===node.parent.kind&&node.parent.condition===node}function needsParenthesisForPropertyAccessOrInvocation(node){switch(node.kind){case 69:case 167:case 169:case 170:case 171:case 175:return!1}return!0}function emitListWithSpread(elements,needsUniqueCopy,multiLine,trailingComma,useConcat){for(var pos=0,group=0,length=elements.length;pos<length;){1===group&&useConcat?write(".concat("):group>0&&write(", ");var e=elements[pos];if(188===e.kind)e=e.expression,emitParenthesizedIf(e,0===group&&needsParenthesisForPropertyAccessOrInvocation(e)),pos++,pos===length&&0===group&&needsUniqueCopy&&167!==e.kind&&write(".slice()");else{for(var i=pos;i<length&&188!==elements[i].kind;)i++;write("["),multiLine&&increaseIndent(),emitList(elements,pos,i-pos,multiLine,trailingComma&&i===length),multiLine&&decreaseIndent(),write("]"),pos=i}group++}group>1&&useConcat&&write(")")}function isSpreadElementExpression(node){return 188===node.kind}function emitArrayLiteral(node){var elements=node.elements;0===elements.length?write("[]"):languageVersion>=2||!ts.forEach(elements,isSpreadElementExpression)?(write("["),emitLinePreservingList(node,node.elements,elements.hasTrailingComma,!1),write("]")):emitListWithSpread(elements,!0,0!==(1024&node.flags),elements.hasTrailingComma,!0)}function emitObjectLiteralBody(node,numElements){if(0===numElements)return void write("{}");if(write("{"),numElements>0){var properties=node.properties;if(numElements===properties.length)emitLinePreservingList(node,properties,languageVersion>=1,!0);else{var multiLine=0!==(1024&node.flags);multiLine?increaseIndent():write(" "),emitList(properties,0,numElements,multiLine,!1),multiLine?decreaseIndent():write(" ")}}write("}")}function emitDownlevelObjectLiteralWithComputedProperties(node,firstComputedPropertyIndex){function writeComma(){multiLine?(write(","),writeLine()):write(", ")}var multiLine=0!==(1024&node.flags),properties=node.properties;write("("),multiLine&&increaseIndent();var tempVar=createAndRecordTempVariable(0);emit(tempVar),write(" = "),emitObjectLiteralBody(node,firstComputedPropertyIndex);for(var i=firstComputedPropertyIndex,n=properties.length;i<n;i++){writeComma();var property=properties[i];if(emitStart(property),146===property.kind||147===property.kind){var accessors=ts.getAllAccessorDeclarations(node.properties,property);if(property!==accessors.firstAccessor)continue;write("Object.defineProperty("),emit(tempVar),write(", "),emitStart(node.name),emitExpressionForPropertyName(property.name),emitEnd(property.name),write(", {"),increaseIndent(),accessors.getAccessor&&(writeLine(),emitLeadingComments(accessors.getAccessor),write("get: "),emitStart(accessors.getAccessor),write("function "),emitSignatureAndBody(accessors.getAccessor),emitEnd(accessors.getAccessor),emitTrailingComments(accessors.getAccessor),write(",")),accessors.setAccessor&&(writeLine(),emitLeadingComments(accessors.setAccessor),write("set: "),emitStart(accessors.setAccessor),write("function "),emitSignatureAndBody(accessors.setAccessor),emitEnd(accessors.setAccessor),emitTrailingComments(accessors.setAccessor),write(",")),writeLine(),write("enumerable: true,"),writeLine(),write("configurable: true"),decreaseIndent(),writeLine(),write("})"),emitEnd(property)}else emitLeadingComments(property),emitStart(property.name),emit(tempVar),emitMemberAccessForPropertyName(property.name),emitEnd(property.name),write(" = "),248===property.kind?emit(property.initializer):249===property.kind?emitExpressionIdentifier(property.name):144===property.kind?emitFunctionDeclaration(property):ts.Debug.fail("ObjectLiteralElement type not accounted for: "+property.kind);emitEnd(property)}writeComma(),emit(tempVar),multiLine&&(decreaseIndent(),writeLine()),write(")")}function emitObjectLiteral(node){var properties=node.properties;if(languageVersion<2){for(var numProperties=properties.length,numInitialNonComputedProperties=numProperties,i=0,n=properties.length;i<n;i++)if(137===properties[i].name.kind){numInitialNonComputedProperties=i;break}var hasComputedProperty=numInitialNonComputedProperties!==properties.length;if(hasComputedProperty)return void emitDownlevelObjectLiteralWithComputedProperties(node,numInitialNonComputedProperties)}emitObjectLiteralBody(node,properties.length)}function createBinaryExpression(left,operator,right,startsOnNewLine){var result=ts.createSynthesizedNode(184,startsOnNewLine);return result.operatorToken=ts.createSynthesizedNode(operator),result.left=left,result.right=right,result}function createPropertyAccessExpression(expression,name){var result=ts.createSynthesizedNode(169);return result.expression=parenthesizeForAccess(expression),result.dotToken=ts.createSynthesizedNode(21),result.name=name,result}function createElementAccessExpression(expression,argumentExpression){var result=ts.createSynthesizedNode(170);return result.expression=parenthesizeForAccess(expression),result.argumentExpression=argumentExpression,result}function parenthesizeForAccess(expr){for(;174===expr.kind||192===expr.kind;)expr=expr.expression;if(ts.isLeftHandSideExpression(expr)&&172!==expr.kind&&8!==expr.kind)return expr;var node=ts.createSynthesizedNode(175);return node.expression=expr,node}function emitComputedPropertyName(node){write("["),emitExpressionForPropertyName(node),write("]")}function emitMethod(node){languageVersion>=2&&node.asteriskToken&&write("*"),emit(node.name),languageVersion<2&&write(": function "),emitSignatureAndBody(node)}function emitPropertyAssignment(node){emit(node.name),write(": "),emitTrailingCommentsOfPosition(node.initializer.pos),emit(node.initializer)}function isNamespaceExportReference(node){var container=resolver.getReferencedExportContainer(node);return container&&251!==container.kind}function emitShorthandPropertyAssignment(node){writeTextOfNode(currentText,node.name),(5!==modulekind||isNamespaceExportReference(node.name))&&(write(": "),emit(node.name)),languageVersion>=2&&node.objectAssignmentInitializer&&(write(" = "),emit(node.objectAssignmentInitializer))}function tryEmitConstantValue(node){var constantValue=tryGetConstEnumValue(node);if(void 0!==constantValue){if(write(constantValue.toString()),!compilerOptions.removeComments){var propertyName=169===node.kind?ts.declarationNameToString(node.name):ts.getTextOfNode(node.argumentExpression);write(" /* "+propertyName+" */")}return!0}return!1}function tryGetConstEnumValue(node){if(!compilerOptions.isolatedModules)return 169===node.kind||170===node.kind?resolver.getConstantValue(node):void 0}function indentIfOnDifferentLines(parent,node1,node2,valueToWriteWhenNotIndenting){var realNodesAreOnDifferentLines=!ts.nodeIsSynthesized(parent)&&!nodeEndIsOnSameLineAsNodeStart(node1,node2),synthesizedNodeIsOnDifferentLine=synthesizedNodeStartsOnNewLine(node2);return realNodesAreOnDifferentLines||synthesizedNodeIsOnDifferentLine?(increaseIndent(),writeLine(),!0):(valueToWriteWhenNotIndenting&&write(valueToWriteWhenNotIndenting),!1)}function emitPropertyAccess(node){if(!tryEmitConstantValue(node)){if(2===languageVersion&&95===node.expression.kind&&isInAsyncMethodWithSuperInES6(node)){var name_26=ts.createSynthesizedNode(9);return name_26.text=node.name.text,void emitSuperAccessInAsyncMethod(node.expression,name_26)}emit(node.expression);var indentedBeforeDot=indentIfOnDifferentLines(node,node.expression,node.dotToken),shouldEmitSpace=!1;if(!indentedBeforeDot)if(8===node.expression.kind){var text=ts.getTextOfNodeFromSourceText(currentText,node.expression);shouldEmitSpace=text.indexOf(ts.tokenToString(21))<0}else{var constantValue=tryGetConstEnumValue(node.expression);shouldEmitSpace=isFinite(constantValue)&&Math.floor(constantValue)===constantValue}write(shouldEmitSpace?" .":".");var indentedAfterDot=indentIfOnDifferentLines(node,node.dotToken,node.name);emit(node.name),decreaseIndentIf(indentedBeforeDot,indentedAfterDot)}}function emitQualifiedName(node){emit(node.left),write("."),emit(node.right)}function emitQualifiedNameAsExpression(node,useFallback){if(69===node.left.kind)emitEntityNameAsExpression(node.left,useFallback);else if(useFallback){var temp=createAndRecordTempVariable(0);write("("),emitNodeWithoutSourceMap(temp),write(" = "),emitEntityNameAsExpression(node.left,!0),write(") && "),emitNodeWithoutSourceMap(temp)}else emitEntityNameAsExpression(node.left,!1);write("."),emit(node.right)}function emitEntityNameAsExpression(node,useFallback){switch(node.kind){case 69:useFallback&&(write("typeof "),emitExpressionIdentifier(node),write(" !== 'undefined' && ")),emitExpressionIdentifier(node);break;case 136:emitQualifiedNameAsExpression(node,useFallback);break;default:emitNodeWithoutSourceMap(node)}}function emitIndexedAccess(node){if(!tryEmitConstantValue(node)){if(2===languageVersion&&95===node.expression.kind&&isInAsyncMethodWithSuperInES6(node))return void emitSuperAccessInAsyncMethod(node.expression,node.argumentExpression);emit(node.expression),write("["),emit(node.argumentExpression),write("]")}}function hasSpreadElement(elements){return ts.forEach(elements,function(e){return 188===e.kind})}function skipParentheses(node){for(;175===node.kind||174===node.kind||192===node.kind;)node=node.expression;return node}function emitCallTarget(node){if(69===node.kind||97===node.kind||95===node.kind)return emit(node),node;var temp=createAndRecordTempVariable(0);return write("("),emit(temp),write(" = "),emit(node),write(")"),temp}function emitCallWithSpread(node){var target,expr=skipParentheses(node.expression);169===expr.kind?(target=emitCallTarget(expr.expression),write("."),emit(expr.name)):170===expr.kind?(target=emitCallTarget(expr.expression),write("["),emit(expr.argumentExpression),write("]")):95===expr.kind?(target=expr,write("_super")):emit(node.expression),write(".apply("),target?95===target.kind?emitThis(target):emit(target):write("void 0"),write(", "),emitListWithSpread(node.arguments,!1,!1,!1,!0),write(")")}function isInAsyncMethodWithSuperInES6(node){if(2===languageVersion){var container=ts.getSuperContainer(node,!1);if(container&&6144&resolver.getNodeCheckFlags(container))return!0}return!1}function emitSuperAccessInAsyncMethod(superNode,argumentExpression){var container=ts.getSuperContainer(superNode,!1),isSuperBinding=4096&resolver.getNodeCheckFlags(container);write("_super("),emit(argumentExpression),write(isSuperBinding?").value":")")}function emitCallExpression(node){if(languageVersion<2&&hasSpreadElement(node.arguments))return void emitCallWithSpread(node);var expression=node.expression,superCall=!1,isAsyncMethodWithSuper=!1;95===expression.kind?(emitSuper(expression),superCall=!0):(superCall=ts.isSuperPropertyOrElementAccess(expression),isAsyncMethodWithSuper=superCall&&isInAsyncMethodWithSuperInES6(node),emit(expression)),superCall&&(languageVersion<2||isAsyncMethodWithSuper)?(write(".call("),emitThis(expression),node.arguments.length&&(write(", "),emitCommaList(node.arguments)),write(")")):(write("("),emitCommaList(node.arguments),write(")"))}function emitNewExpression(node){if(write("new "),1===languageVersion&&node.arguments&&hasSpreadElement(node.arguments)){write("(");var target=emitCallTarget(node.expression);write(".bind.apply("),emit(target),write(", [void 0].concat("),emitListWithSpread(node.arguments,!1,!1,!1,!1),write(")))"),write("()")}else emit(node.expression),node.arguments&&(write("("),emitCommaList(node.arguments),write(")"))}function emitTaggedTemplateExpression(node){languageVersion>=2?(emit(node.tag),write(" "),emit(node.template)):emitDownlevelTaggedTemplate(node)}function emitParenExpression(node){if(!ts.nodeIsSynthesized(node)&&177!==node.parent.kind&&(174===node.expression.kind||192===node.expression.kind)){for(var operand=node.expression.expression;174===operand.kind||192===operand.kind;)operand=operand.expression;if(!(182===operand.kind||180===operand.kind||179===operand.kind||178===operand.kind||183===operand.kind||172===operand.kind||171===operand.kind&&172===node.parent.kind||176===operand.kind&&171===node.parent.kind||8===operand.kind&&169===node.parent.kind))return void emit(operand)}write("("),emit(node.expression),write(")")}function emitDeleteExpression(node){write(ts.tokenToString(78)),write(" "),emit(node.expression)}function emitVoidExpression(node){write(ts.tokenToString(103)),write(" "),emit(node.expression)}function emitTypeOfExpression(node){write(ts.tokenToString(101)),write(" "),emit(node.expression)}function isNameOfExportedSourceLevelDeclarationInSystemExternalModule(node){if(!isCurrentFileSystemExternalModule()||69!==node.kind||ts.nodeIsSynthesized(node))return!1;var isVariableDeclarationOrBindingElement=node.parent&&(214===node.parent.kind||166===node.parent.kind),targetDeclaration=isVariableDeclarationOrBindingElement?node.parent:resolver.getReferencedValueDeclaration(node);return isSourceFileLevelDeclarationInSystemJsModule(targetDeclaration,!0)}function emitPrefixUnaryExpression(node){var exportChanged=(41===node.operator||42===node.operator)&&isNameOfExportedSourceLevelDeclarationInSystemExternalModule(node.operand);if(exportChanged&&(write(exportFunctionForFile+'("'),emitNodeWithoutSourceMap(node.operand),write('", ')),write(ts.tokenToString(node.operator)),182===node.operand.kind){var operand=node.operand;35!==node.operator||35!==operand.operator&&41!==operand.operator?36!==node.operator||36!==operand.operator&&42!==operand.operator||write(" "):write(" ")}emit(node.operand),exportChanged&&write(")")}function emitPostfixUnaryExpression(node){var exportChanged=isNameOfExportedSourceLevelDeclarationInSystemExternalModule(node.operand);exportChanged?(write("("+exportFunctionForFile+'("'),emitNodeWithoutSourceMap(node.operand),write('", '),write(ts.tokenToString(node.operator)),emit(node.operand),write(41===node.operator?") - 1)":") + 1)")):(emit(node.operand),write(ts.tokenToString(node.operator)))}function shouldHoistDeclarationInSystemJsModule(node){return isSourceFileLevelDeclarationInSystemJsModule(node,!1)}function isSourceFileLevelDeclarationInSystemJsModule(node,isExported){if(!node||!isCurrentFileSystemExternalModule())return!1;for(var current=ts.getRootDeclaration(node).parent;current;){if(251===current.kind)return!isExported||0!==(2&ts.getCombinedNodeFlags(node));if(ts.isDeclaration(current))return!1;current=current.parent}}function emitExponentiationOperator(node){var leftHandSideExpression=node.left;if(60===node.operatorToken.kind){var synthesizedLHS=void 0,shouldEmitParentheses=!1;if(ts.isElementAccessExpression(leftHandSideExpression)){shouldEmitParentheses=!0,write("("),synthesizedLHS=ts.createSynthesizedNode(170,!1);var identifier=emitTempVariableAssignment(leftHandSideExpression.expression,!1,!1);if(synthesizedLHS.expression=identifier,8!==leftHandSideExpression.argumentExpression.kind&&9!==leftHandSideExpression.argumentExpression.kind){var tempArgumentExpression=createAndRecordTempVariable(268435456);synthesizedLHS.argumentExpression=tempArgumentExpression,emitAssignment(tempArgumentExpression,leftHandSideExpression.argumentExpression,!0,leftHandSideExpression.expression)}else synthesizedLHS.argumentExpression=leftHandSideExpression.argumentExpression;write(", ")}else if(ts.isPropertyAccessExpression(leftHandSideExpression)){shouldEmitParentheses=!0,write("("),synthesizedLHS=ts.createSynthesizedNode(169,!1);var identifier=emitTempVariableAssignment(leftHandSideExpression.expression,!1,!1);synthesizedLHS.expression=identifier,synthesizedLHS.dotToken=leftHandSideExpression.dotToken,synthesizedLHS.name=leftHandSideExpression.name,write(", ")}emit(synthesizedLHS||leftHandSideExpression),write(" = "),write("Math.pow("),emit(synthesizedLHS||leftHandSideExpression),write(", "),emit(node.right),write(")"),shouldEmitParentheses&&write(")")}else write("Math.pow("),emit(leftHandSideExpression),write(", "),emit(node.right),write(")")}function emitBinaryExpression(node){if(languageVersion<2&&56===node.operatorToken.kind&&(168===node.left.kind||167===node.left.kind))emitDestructuring(node,198===node.parent.kind);else{var exportChanged=node.operatorToken.kind>=56&&node.operatorToken.kind<=68&&isNameOfExportedSourceLevelDeclarationInSystemExternalModule(node.left);if(exportChanged&&(write(exportFunctionForFile+'("'),emitNodeWithoutSourceMap(node.left),write('", ')),38===node.operatorToken.kind||60===node.operatorToken.kind)emitExponentiationOperator(node);else{emit(node.left);var indentedBeforeOperator=indentIfOnDifferentLines(node,node.left,node.operatorToken,24!==node.operatorToken.kind?" ":void 0);write(ts.tokenToString(node.operatorToken.kind));var indentedAfterOperator=indentIfOnDifferentLines(node,node.operatorToken,node.right," ");emit(node.right),decreaseIndentIf(indentedBeforeOperator,indentedAfterOperator)}exportChanged&&write(")")}}function synthesizedNodeStartsOnNewLine(node){return ts.nodeIsSynthesized(node)&&node.startsOnNewLine}function emitConditionalExpression(node){emit(node.condition);var indentedBeforeQuestion=indentIfOnDifferentLines(node,node.condition,node.questionToken," ");write("?");var indentedAfterQuestion=indentIfOnDifferentLines(node,node.questionToken,node.whenTrue," ");emit(node.whenTrue),decreaseIndentIf(indentedBeforeQuestion,indentedAfterQuestion);var indentedBeforeColon=indentIfOnDifferentLines(node,node.whenTrue,node.colonToken," ");write(":");var indentedAfterColon=indentIfOnDifferentLines(node,node.colonToken,node.whenFalse," ");emit(node.whenFalse),decreaseIndentIf(indentedBeforeColon,indentedAfterColon)}function decreaseIndentIf(value1,value2){value1&&decreaseIndent(),value2&&decreaseIndent()}function isSingleLineEmptyBlock(node){if(node&&195===node.kind){var block=node;return 0===block.statements.length&&nodeEndIsOnSameLineAsNodeStart(block,block)}}function emitBlock(node){return isSingleLineEmptyBlock(node)?(emitToken(15,node.pos),write(" "),void emitToken(16,node.statements.end)):(emitToken(15,node.pos),increaseIndent(),222===node.kind&&(ts.Debug.assert(221===node.parent.kind),emitCaptureThisForNodeIfNecessary(node.parent)),emitLines(node.statements),222===node.kind&&emitTempDeclarations(!0),decreaseIndent(),writeLine(),void emitToken(16,node.statements.end))}function emitEmbeddedStatement(node){195===node.kind?(write(" "),emit(node)):(increaseIndent(),writeLine(),emit(node),decreaseIndent())}function emitExpressionStatement(node){emitParenthesizedIf(node.expression,177===node.expression.kind),write(";")}function emitIfStatement(node){var endPos=emitToken(88,node.pos);write(" "),endPos=emitToken(17,endPos),emit(node.expression),emitToken(18,node.expression.end),emitEmbeddedStatement(node.thenStatement),node.elseStatement&&(writeLine(),emitToken(80,node.thenStatement.end),199===node.elseStatement.kind?(write(" "),emit(node.elseStatement)):emitEmbeddedStatement(node.elseStatement))}function emitDoStatement(node){emitLoop(node,emitDoStatementWorker)}function emitDoStatementWorker(node,loop){write("do"),loop?emitConvertedLoopCall(loop,!0):emitNormalLoopBody(node,!0),195===node.statement.kind?write(" "):writeLine(),write("while ("),emit(node.expression),write(");")}function emitWhileStatement(node){emitLoop(node,emitWhileStatementWorker)}function emitWhileStatementWorker(node,loop){write("while ("),emit(node.expression),write(")"),loop?emitConvertedLoopCall(loop,!0):emitNormalLoopBody(node,!0)}function tryEmitStartOfVariableDeclarationList(decl){if(shouldHoistVariable(decl,!0))return!1;if(convertedLoopState&&0===(24576&ts.getCombinedNodeFlags(decl))){for(var _a=0,_b=decl.declarations;_a<_b.length;_a++){var varDecl=_b[_a];hoistVariableDeclarationFromLoop(convertedLoopState,varDecl)}return!1}return emitStart(decl),write(decl&&languageVersion>=2?ts.isLet(decl)?"let ":ts.isConst(decl)?"const ":"var ":"var "),!0}function emitVariableDeclarationListSkippingUninitializedEntries(list){for(var started=!1,_a=0,_b=list.declarations;_a<_b.length;_a++){var decl=_b[_a];decl.initializer&&(started?write(", "):started=!0,emit(decl))}return started}function shouldConvertLoopBody(node){return languageVersion<2&&0!==(65536&resolver.getNodeCheckFlags(node))}function emitLoop(node,loopEmitter){var shouldConvert=shouldConvertLoopBody(node);if(shouldConvert){var loop=convertLoopBody(node);210===node.parent.kind&&emitLabelAndColon(node.parent),loopEmitter(node,loop)}else loopEmitter(node,void 0)}function convertLoopBody(node){function processVariableDeclaration(name){if(69===name.kind){var nameText=isNameOfNestedBlockScopedRedeclarationOrCapturedBinding(name)?getGeneratedNameForNode(name):name.text;if(loopParameters.push(nameText),2097152&resolver.getNodeCheckFlags(name.parent)){var reassignedVariable={originalName:name,outParamName:makeUniqueName("out_"+nameText)};(loopOutParameters||(loopOutParameters=[])).push(reassignedVariable)}}else for(var _a=0,_b=name.elements;_a<_b.length;_a++){var element=_b[_a];processVariableDeclaration(element.name)}}var loopInitializer,functionName=makeUniqueName("_loop");switch(node.kind){case 202:case 203:case 204:var initializer=node.initializer;initializer&&215===initializer.kind&&(loopInitializer=node.initializer)}var loopParameters,loopOutParameters;if(loopInitializer&&24576&ts.getCombinedNodeFlags(loopInitializer)){loopParameters=[];for(var _a=0,_b=loopInitializer.declarations;_a<_b.length;_a++){var varDeclaration=_b[_a];processVariableDeclaration(varDeclaration.name)}}var bodyIsBlock=195===node.statement.kind,paramList=loopParameters?loopParameters.join(", "):"";writeLine(),write("var "+functionName+" = function("+paramList+")");var convertedOuterLoopState=convertedLoopState;if(convertedLoopState={loopOutParameters:loopOutParameters},convertedOuterLoopState&&(convertedOuterLoopState.argumentsName&&(convertedLoopState.argumentsName=convertedOuterLoopState.argumentsName),convertedOuterLoopState.thisName&&(convertedLoopState.thisName=convertedOuterLoopState.thisName),convertedOuterLoopState.hoistedLocalVariables&&(convertedLoopState.hoistedLocalVariables=convertedOuterLoopState.hoistedLocalVariables)),write(" {"),writeLine(),increaseIndent(),bodyIsBlock?emitLines(node.statement.statements):emit(node.statement),writeLine(),copyLoopOutParameters(convertedLoopState,1,!0),decreaseIndent(),writeLine(),write("};"),writeLine(),loopOutParameters){write("var ");for(var i=0;i<loopOutParameters.length;i++)0!==i&&write(", "),write(loopOutParameters[i].outParamName);write(";"),writeLine()}if(convertedLoopState.argumentsName&&(convertedOuterLoopState?convertedOuterLoopState.argumentsName=convertedLoopState.argumentsName:(write("var "+convertedLoopState.argumentsName+" = arguments;"),writeLine())),convertedLoopState.thisName&&(convertedOuterLoopState?convertedOuterLoopState.thisName=convertedLoopState.thisName:(write("var "+convertedLoopState.thisName+" = this;"),writeLine())),convertedLoopState.hoistedLocalVariables)if(convertedOuterLoopState)convertedOuterLoopState.hoistedLocalVariables=convertedLoopState.hoistedLocalVariables;else{write("var ");for(var seen=void 0,_c=0,_d=convertedLoopState.hoistedLocalVariables;_c<_d.length;_c++){var id=_d[_c];seen?write(", "):seen={},ts.hasProperty(seen,id.text)||(emit(id),seen[id.text]=id.text)}write(";"),writeLine()}var currentLoopState=convertedLoopState;return convertedLoopState=convertedOuterLoopState,{functionName:functionName,paramList:paramList,state:currentLoopState}}function emitNormalLoopBody(node,emitAsEmbeddedStatement){var saveAllowedNonLabeledJumps;convertedLoopState&&(saveAllowedNonLabeledJumps=convertedLoopState.allowedNonLabeledJumps,convertedLoopState.allowedNonLabeledJumps=6),emitAsEmbeddedStatement?emitEmbeddedStatement(node.statement):195===node.statement.kind?emitLines(node.statement.statements):(writeLine(),emit(node.statement)),convertedLoopState&&(convertedLoopState.allowedNonLabeledJumps=saveAllowedNonLabeledJumps)}function copyLoopOutParameters(state,copyDirection,emitAsStatements){if(state.loopOutParameters)for(var _a=0,_b=state.loopOutParameters;_a<_b.length;_a++){var outParam=_b[_a];0===copyDirection?(emitIdentifier(outParam.originalName),write(" = "+outParam.outParamName)):(write(outParam.outParamName+" = "),emitIdentifier(outParam.originalName)),emitAsStatements?(write(";"),writeLine()):write(", ")}}function emitConvertedLoopCall(loop,emitAsBlock){function emitDispatchTableForLabeledJumps(loopResultVariable,currentLoop,outerLoop){(currentLoop.labeledNonLocalBreaks||currentLoop.labeledNonLocalContinues)&&(write("switch("+loopResultVariable+") {"),increaseIndent(),emitDispatchEntriesForLabeledJumps(currentLoop.labeledNonLocalBreaks,!0,loopResultVariable,outerLoop),emitDispatchEntriesForLabeledJumps(currentLoop.labeledNonLocalContinues,!1,loopResultVariable,outerLoop),decreaseIndent(),writeLine(),write("}"))}function emitDispatchEntriesForLabeledJumps(table,isBreak,loopResultVariable,outerLoop){if(table)for(var labelText in table){var labelMarker=table[labelText];writeLine(),write('case "'+labelMarker+'": '),!outerLoop||outerLoop.labels&&outerLoop.labels[labelText]?(write(isBreak?"break ":"continue "),write(labelText+";")):(setLabeledJump(outerLoop,isBreak,labelText,labelMarker),write("return "+loopResultVariable+";"))}}emitAsBlock&&(write(" {"),writeLine(),increaseIndent());var isSimpleLoop=!loop.state.nonLocalJumps&&!loop.state.labeledNonLocalBreaks&&!loop.state.labeledNonLocalContinues,loopResult=makeUniqueName("state");isSimpleLoop||write("var "+loopResult+" = "),write(loop.functionName+"("+loop.paramList+");"),writeLine(),copyLoopOutParameters(loop.state,0,!0),isSimpleLoop||(writeLine(),8&loop.state.nonLocalJumps&&(write("if (typeof "+loopResult+' === "object") '),convertedLoopState?(write("return "+loopResult+";"),convertedLoopState.nonLocalJumps|=8):write("return "+loopResult+".value;"),writeLine()),2&loop.state.nonLocalJumps&&(write("if ("+loopResult+' === "break") break;'),writeLine()),4&loop.state.nonLocalJumps&&(write("if ("+loopResult+' === "continue") continue;'),writeLine()),emitDispatchTableForLabeledJumps(loopResult,loop.state,convertedLoopState)),emitAsBlock&&(writeLine(),decreaseIndent(),write("}"))}function emitForStatement(node){emitLoop(node,emitForStatementWorker)}function emitForStatementWorker(node,loop){var endPos=emitToken(86,node.pos);if(write(" "),endPos=emitToken(17,endPos),node.initializer&&215===node.initializer.kind){var variableDeclarationList=node.initializer,startIsEmitted=tryEmitStartOfVariableDeclarationList(variableDeclarationList);startIsEmitted?emitCommaList(variableDeclarationList.declarations):emitVariableDeclarationListSkippingUninitializedEntries(variableDeclarationList)}else node.initializer&&emit(node.initializer);write(";"),emitOptional(" ",node.condition),write(";"),emitOptional(" ",node.incrementor),write(")"),loop?emitConvertedLoopCall(loop,!0):emitNormalLoopBody(node,!0)}function emitForInOrForOfStatement(node){languageVersion<2&&204===node.kind?emitLoop(node,emitDownLevelForOfStatementWorker):emitLoop(node,emitForInOrForOfStatementWorker)}function emitForInOrForOfStatementWorker(node,loop){var endPos=emitToken(86,node.pos);if(write(" "),endPos=emitToken(17,endPos),215===node.initializer.kind){var variableDeclarationList=node.initializer;variableDeclarationList.declarations.length>=1&&(tryEmitStartOfVariableDeclarationList(variableDeclarationList),emit(variableDeclarationList.declarations[0]))}else emit(node.initializer);write(203===node.kind?" in ":" of "),emit(node.expression),emitToken(18,node.expression.end),loop?emitConvertedLoopCall(loop,!0):emitNormalLoopBody(node,!0)}function emitDownLevelForOfStatementWorker(node,loop){var endPos=emitToken(86,node.pos);write(" "),endPos=emitToken(17,endPos);var counter=createTempVariable(268435456),rhsReference=ts.createSynthesizedNode(69);rhsReference.text=69===node.expression.kind?makeUniqueName(node.expression.text):makeTempVariableName(0),emitStart(node.expression),write("var "),emitNodeWithoutSourceMap(counter),write(" = 0"),emitEnd(node.expression),write(", "),emitStart(node.expression),emitNodeWithoutSourceMap(rhsReference),write(" = "),
emitNodeWithoutSourceMap(node.expression),emitEnd(node.expression),write("; "),emitStart(node.expression),emitNodeWithoutSourceMap(counter),write(" < "),emitNodeWithCommentsAndWithoutSourcemap(rhsReference),write(".length"),emitEnd(node.expression),write("; "),emitStart(node.expression),emitNodeWithoutSourceMap(counter),write("++"),emitEnd(node.expression),emitToken(18,node.expression.end),write(" {"),writeLine(),increaseIndent();var rhsIterationValue=createElementAccessExpression(rhsReference,counter);if(emitStart(node.initializer),215===node.initializer.kind){write("var ");var variableDeclarationList=node.initializer;if(variableDeclarationList.declarations.length>0){var declaration=variableDeclarationList.declarations[0];ts.isBindingPattern(declaration.name)?emitDestructuring(declaration,!1,rhsIterationValue):(emitNodeWithCommentsAndWithoutSourcemap(declaration),write(" = "),emitNodeWithoutSourceMap(rhsIterationValue))}else emitNodeWithoutSourceMap(createTempVariable(0)),write(" = "),emitNodeWithoutSourceMap(rhsIterationValue)}else{var assignmentExpression=createBinaryExpression(node.initializer,56,rhsIterationValue,!1);167===node.initializer.kind||168===node.initializer.kind?emitDestructuring(assignmentExpression,!0,void 0):emitNodeWithCommentsAndWithoutSourcemap(assignmentExpression)}emitEnd(node.initializer),write(";"),loop?(writeLine(),emitConvertedLoopCall(loop,!1)):emitNormalLoopBody(node,!1),writeLine(),decreaseIndent(),write("}")}function emitBreakOrContinueStatement(node){if(convertedLoopState){var jump=206===node.kind?2:4,canUseBreakOrContinue=node.label&&convertedLoopState.labels&&convertedLoopState.labels[node.label.text]||!node.label&&convertedLoopState.allowedNonLabeledJumps&jump;if(!canUseBreakOrContinue){if(write("return "),copyLoopOutParameters(convertedLoopState,1,!1),node.label){var labelMarker=void 0;206===node.kind?(labelMarker="break-"+node.label.text,setLabeledJump(convertedLoopState,!0,node.label.text,labelMarker)):(labelMarker="continue-"+node.label.text,setLabeledJump(convertedLoopState,!1,node.label.text,labelMarker)),write('"'+labelMarker+'";')}else 206===node.kind?(convertedLoopState.nonLocalJumps|=2,write('"break";')):(convertedLoopState.nonLocalJumps|=4,write('"continue";'));return}}emitToken(206===node.kind?70:75,node.pos),emitOptional(" ",node.label),write(";")}function emitReturnStatement(node){return convertedLoopState?(convertedLoopState.nonLocalJumps|=8,write("return { value: "),node.expression?emit(node.expression):write("void 0"),void write(" };")):(emitToken(94,node.pos),emitOptional(" ",node.expression),void write(";"))}function emitWithStatement(node){write("with ("),emit(node.expression),write(")"),emitEmbeddedStatement(node.statement)}function emitSwitchStatement(node){var endPos=emitToken(96,node.pos);write(" "),emitToken(17,endPos),emit(node.expression),endPos=emitToken(18,node.expression.end),write(" ");var saveAllowedNonLabeledJumps;convertedLoopState&&(saveAllowedNonLabeledJumps=convertedLoopState.allowedNonLabeledJumps,convertedLoopState.allowedNonLabeledJumps|=2),emitCaseBlock(node.caseBlock,endPos),convertedLoopState&&(convertedLoopState.allowedNonLabeledJumps=saveAllowedNonLabeledJumps)}function emitCaseBlock(node,startPos){emitToken(15,startPos),increaseIndent(),emitLines(node.clauses),decreaseIndent(),writeLine(),emitToken(16,node.clauses.end)}function nodeStartPositionsAreOnSameLine(node1,node2){return ts.getLineOfLocalPositionFromLineMap(currentLineMap,ts.skipTrivia(currentText,node1.pos))===ts.getLineOfLocalPositionFromLineMap(currentLineMap,ts.skipTrivia(currentText,node2.pos))}function nodeEndPositionsAreOnSameLine(node1,node2){return ts.getLineOfLocalPositionFromLineMap(currentLineMap,node1.end)===ts.getLineOfLocalPositionFromLineMap(currentLineMap,node2.end)}function nodeEndIsOnSameLineAsNodeStart(node1,node2){return ts.getLineOfLocalPositionFromLineMap(currentLineMap,node1.end)===ts.getLineOfLocalPositionFromLineMap(currentLineMap,ts.skipTrivia(currentText,node2.pos))}function emitCaseOrDefaultClause(node){244===node.kind?(write("case "),emit(node.expression),write(":")):write("default:"),1===node.statements.length&&nodeStartPositionsAreOnSameLine(node,node.statements[0])?(write(" "),emit(node.statements[0])):(increaseIndent(),emitLines(node.statements),decreaseIndent())}function emitThrowStatement(node){write("throw "),emit(node.expression),write(";")}function emitTryStatement(node){write("try "),emit(node.tryBlock),emit(node.catchClause),node.finallyBlock&&(writeLine(),write("finally "),emit(node.finallyBlock))}function emitCatchClause(node){writeLine();var endPos=emitToken(72,node.pos);write(" "),emitToken(17,endPos),emit(node.variableDeclaration),emitToken(18,node.variableDeclaration?node.variableDeclaration.end:endPos),write(" "),emitBlock(node.block)}function emitDebuggerStatement(node){emitToken(76,node.pos),write(";")}function emitLabelAndColon(node){emit(node.label),write(": ")}function emitLabeledStatement(node){ts.isIterationStatement(node.statement,!1)&&shouldConvertLoopBody(node.statement)||emitLabelAndColon(node),convertedLoopState&&(convertedLoopState.labels||(convertedLoopState.labels={}),convertedLoopState.labels[node.label.text]=node.label.text),emit(node.statement),convertedLoopState&&(convertedLoopState.labels[node.label.text]=void 0)}function getContainingModule(node){do node=node.parent;while(node&&221!==node.kind);return node}function emitContainingModuleName(node){var container=getContainingModule(node);write(container?getGeneratedNameForNode(container):"exports")}function emitModuleMemberName(node){if(emitStart(node.name),2&ts.getCombinedNodeFlags(node)){var container=getContainingModule(node);container?(write(getGeneratedNameForNode(container)),write(".")):5!==modulekind&&4!==modulekind&&write("exports.")}emitNodeWithCommentsAndWithoutSourcemap(node.name),emitEnd(node.name)}function createVoidZero(){var zero=ts.createSynthesizedNode(8);zero.text="0";var result=ts.createSynthesizedNode(180);return result.expression=zero,result}function emitEs6ExportDefaultCompat(node){251===node.parent.kind&&(ts.Debug.assert(!!(512&node.flags)||230===node.kind),1!==modulekind&&2!==modulekind&&3!==modulekind||isEs6Module||(0!==languageVersion?(write('Object.defineProperty(exports, "__esModule", { value: true });'),writeLine()):(write("exports.__esModule = true;"),writeLine())))}function emitExportMemberAssignment(node){2&node.flags&&(writeLine(),emitStart(node),4===modulekind&&node.parent===currentSourceFile?(write(exportFunctionForFile+'("'),512&node.flags?write("default"):emitNodeWithCommentsAndWithoutSourcemap(node.name),write('", '),emitDeclarationName(node),write(")")):(512&node.flags?(emitEs6ExportDefaultCompat(node),write(0===languageVersion?'exports["default"]':"exports.default")):emitModuleMemberName(node),write(" = "),emitDeclarationName(node)),emitEnd(node),write(";"))}function emitExportMemberAssignments(name){if(4!==modulekind&&!exportEquals&&exportSpecifiers&&ts.hasProperty(exportSpecifiers,name.text))for(var _a=0,_b=exportSpecifiers[name.text];_a<_b.length;_a++){var specifier=_b[_a];writeLine(),emitStart(specifier.name),emitContainingModuleName(specifier),write("."),emitNodeWithCommentsAndWithoutSourcemap(specifier.name),emitEnd(specifier.name),write(" = "),emitExpressionIdentifier(name),write(";")}}function emitExportSpecifierInSystemModule(specifier){ts.Debug.assert(4===modulekind),(resolver.getReferencedValueDeclaration(specifier.propertyName||specifier.name)||resolver.isValueAliasDeclaration(specifier))&&(writeLine(),emitStart(specifier.name),write(exportFunctionForFile+'("'),emitNodeWithCommentsAndWithoutSourcemap(specifier.name),write('", '),emitExpressionIdentifier(specifier.propertyName||specifier.name),write(")"),emitEnd(specifier.name),write(";"))}function emitAssignment(name,value,shouldEmitCommaBeforeAssignment,nodeForSourceMap){shouldEmitCommaBeforeAssignment&&write(", ");var exportChanged=isNameOfExportedSourceLevelDeclarationInSystemExternalModule(name);exportChanged&&(write(exportFunctionForFile+'("'),emitNodeWithCommentsAndWithoutSourcemap(name),write('", '));var isVariableDeclarationOrBindingElement=name.parent&&(214===name.parent.kind||166===name.parent.kind);emitStart(isFirstVariableDeclaration(nodeForSourceMap)?nodeForSourceMap.parent:nodeForSourceMap),withTemporaryNoSourceMap(function(){isVariableDeclarationOrBindingElement?emitModuleMemberName(name.parent):emit(name),write(" = "),emit(value)}),emitEnd(nodeForSourceMap,!0),exportChanged&&write(")")}function emitTempVariableAssignment(expression,canDefineTempVariablesInPlace,shouldEmitCommaBeforeAssignment,sourceMapNode){var identifier=createTempVariable(0);return canDefineTempVariablesInPlace||recordTempDeclaration(identifier),emitAssignment(identifier,expression,shouldEmitCommaBeforeAssignment,sourceMapNode||expression.parent),identifier}function isFirstVariableDeclaration(root){return 214===root.kind&&215===root.parent.kind&&root.parent.declarations[0]===root}function emitDestructuring(root,isAssignmentExpressionStatement,value){function ensureIdentifier(expr,reuseIdentifierExpressions,sourceMapNode){if(69===expr.kind&&reuseIdentifierExpressions)return expr;var identifier=emitTempVariableAssignment(expr,canDefineTempVariablesInPlace,emitCount>0,sourceMapNode);return emitCount++,identifier}function createDefaultValueCheck(value,defaultValue,sourceMapNode){value=ensureIdentifier(value,!0,sourceMapNode);var equals=ts.createSynthesizedNode(184);return equals.left=value,equals.operatorToken=ts.createSynthesizedNode(32),equals.right=createVoidZero(),createConditionalExpression(equals,defaultValue,value)}function createConditionalExpression(condition,whenTrue,whenFalse){var cond=ts.createSynthesizedNode(185);return cond.condition=condition,cond.questionToken=ts.createSynthesizedNode(53),cond.whenTrue=whenTrue,cond.colonToken=ts.createSynthesizedNode(54),cond.whenFalse=whenFalse,cond}function createNumericLiteral(value){var node=ts.createSynthesizedNode(8);return node.text=""+value,node}function createPropertyAccessForDestructuringProperty(object,propName){var index,nameIsComputed=137===propName.kind;return nameIsComputed?index=ensureIdentifier(propName.expression,!1,propName):(index=ts.createSynthesizedNode(propName.kind),index.text=ts.unescapeIdentifier(propName.text)),nameIsComputed||69!==index.kind?createElementAccessExpression(object,index):createPropertyAccessExpression(object,index)}function createSliceCall(value,sliceIndex){var call=ts.createSynthesizedNode(171),sliceIdentifier=ts.createSynthesizedNode(69);return sliceIdentifier.text="slice",call.expression=createPropertyAccessExpression(value,sliceIdentifier),call.arguments=ts.createSynthesizedNodeArray(),call.arguments[0]=createNumericLiteral(sliceIndex),call}function emitObjectLiteralAssignment(target,value,sourceMapNode){var properties=target.properties;1!==properties.length&&(value=ensureIdentifier(value,!0,sourceMapNode));for(var _a=0,properties_5=properties;_a<properties_5.length;_a++){var p=properties_5[_a];if(248===p.kind||249===p.kind){var propName=p.name,target_1=249===p.kind?p:p.initializer||propName;emitDestructuringAssignment(target_1,createPropertyAccessForDestructuringProperty(value,propName),p)}}}function emitArrayLiteralAssignment(target,value,sourceMapNode){var elements=target.elements;1!==elements.length&&(value=ensureIdentifier(value,!0,sourceMapNode));for(var i=0;i<elements.length;i++){var e=elements[i];190!==e.kind&&(188!==e.kind?emitDestructuringAssignment(e,createElementAccessExpression(value,createNumericLiteral(i)),e):i===elements.length-1&&emitDestructuringAssignment(e.expression,createSliceCall(value,i),e))}}function emitDestructuringAssignment(target,value,sourceMapNode){249===target.kind?(target.objectAssignmentInitializer&&(value=createDefaultValueCheck(value,target.objectAssignmentInitializer,sourceMapNode)),target=target.name):184===target.kind&&56===target.operatorToken.kind&&(value=createDefaultValueCheck(value,target.right,sourceMapNode),target=target.left),168===target.kind?emitObjectLiteralAssignment(target,value,sourceMapNode):167===target.kind?emitArrayLiteralAssignment(target,value,sourceMapNode):(emitAssignment(target,value,emitCount>0,sourceMapNode),emitCount++)}function emitAssignmentExpression(root){var target=root.left,value=root.right;ts.isEmptyObjectLiteralOrArrayLiteral(target)?emit(value):isAssignmentExpressionStatement?emitDestructuringAssignment(target,value,ts.nodeIsSynthesized(root)?target:root):(175!==root.parent.kind&&write("("),value=ensureIdentifier(value,!0,root),emitDestructuringAssignment(target,value,root),write(", "),emit(value),175!==root.parent.kind&&write(")"))}function emitBindingElement(target,value){if(target.initializer?value=value?createDefaultValueCheck(value,target.initializer,target):target.initializer:value||(value=createVoidZero()),ts.isBindingPattern(target.name)){var pattern=target.name,elements=pattern.elements,numElements=elements.length;1!==numElements&&(value=ensureIdentifier(value,0!==numElements,target));for(var i=0;i<numElements;i++){var element=elements[i];if(164===pattern.kind){var propName=element.propertyName||element.name;emitBindingElement(element,createPropertyAccessForDestructuringProperty(value,propName))}else 190!==element.kind&&(element.dotDotDotToken?i===numElements-1&&emitBindingElement(element,createSliceCall(value,i)):emitBindingElement(element,createElementAccessExpression(value,createNumericLiteral(i))))}}else emitAssignment(target.name,value,emitCount>0,target),emitCount++}var emitCount=0,canDefineTempVariablesInPlace=!1;if(214===root.kind){var isExported=2&ts.getCombinedNodeFlags(root),isSourceLevelForSystemModuleKind=shouldHoistDeclarationInSystemJsModule(root);canDefineTempVariablesInPlace=!isExported&&!isSourceLevelForSystemModuleKind}else 139===root.kind&&(canDefineTempVariablesInPlace=!0);184===root.kind?emitAssignmentExpression(root):(ts.Debug.assert(!isAssignmentExpressionStatement),isFirstVariableDeclaration(root)&&sourceMap.changeEmitSourcePos(),emitBindingElement(root,value))}function emitVariableDeclaration(node){if(ts.isBindingPattern(node.name))languageVersion<2?emitDestructuring(node,!1):(emit(node.name),emitOptional(" = ",node.initializer));else{var initializer=node.initializer;if(!initializer&&languageVersion<2&&69===node.name.kind){var container=ts.getEnclosingBlockScopeContainer(node),flags=resolver.getNodeCheckFlags(node),isCapturedInFunction=131072&flags,isDeclaredInLoop=262144&flags,emittedAsTopLevel=ts.isBlockScopedContainerTopLevel(container)||isCapturedInFunction&&isDeclaredInLoop&&195===container.kind&&ts.isIterationStatement(container.parent,!1),emittedAsNestedLetDeclaration=8192&ts.getCombinedNodeFlags(node)&&!emittedAsTopLevel,emitExplicitInitializer=emittedAsNestedLetDeclaration&&203!==container.kind&&204!==container.kind&&(!resolver.isDeclarationWithCollidingName(node)||isDeclaredInLoop&&!isCapturedInFunction&&!ts.isIterationStatement(container,!1));emitExplicitInitializer&&(initializer=createVoidZero())}var exportChanged=isNameOfExportedSourceLevelDeclarationInSystemExternalModule(node.name);exportChanged&&(write(exportFunctionForFile+'("'),emitNodeWithCommentsAndWithoutSourcemap(node.name),write('", ')),emitModuleMemberName(node),emitOptional(" = ",initializer),exportChanged&&write(")")}}function emitExportVariableAssignments(node){if(190!==node.kind){var name=node.name;69===name.kind?emitExportMemberAssignments(name):ts.isBindingPattern(name)&&ts.forEach(name.elements,emitExportVariableAssignments)}}function isES6ExportedDeclaration(node){return!!(2&node.flags)&&5===modulekind&&251===node.parent.kind}function emitVariableStatement(node){var startIsEmitted=!1;if(2&node.flags?isES6ExportedDeclaration(node)&&(write("export "),startIsEmitted=tryEmitStartOfVariableDeclarationList(node.declarationList)):startIsEmitted=tryEmitStartOfVariableDeclarationList(node.declarationList),startIsEmitted)emitCommaList(node.declarationList.declarations),write(";");else{var atLeastOneItem=emitVariableDeclarationListSkippingUninitializedEntries(node.declarationList);atLeastOneItem&&write(";")}5!==modulekind&&node.parent===currentSourceFile&&ts.forEach(node.declarationList.declarations,emitExportVariableAssignments)}function shouldEmitLeadingAndTrailingCommentsForVariableStatement(node){if(!(2&node.flags))return!0;if(isES6ExportedDeclaration(node))return!0;for(var _a=0,_b=node.declarationList.declarations;_a<_b.length;_a++){var declaration=_b[_a];if(declaration.initializer)return!0}return!1}function emitParameter(node){if(languageVersion<2)if(ts.isBindingPattern(node.name)){var name_27=createTempVariable(0);tempParameters||(tempParameters=[]),tempParameters.push(name_27),emit(name_27)}else emit(node.name);else node.dotDotDotToken&&write("..."),emit(node.name),emitOptional(" = ",node.initializer)}function emitDefaultValueAssignments(node){if(languageVersion<2){var tempIndex_1=0;ts.forEach(node.parameters,function(parameter){if(!parameter.dotDotDotToken){var paramName=parameter.name,initializer=parameter.initializer;if(ts.isBindingPattern(paramName)){var hasBindingElements=paramName.elements.length>0;(hasBindingElements||initializer)&&(writeLine(),write("var "),hasBindingElements?emitDestructuring(parameter,!1,tempParameters[tempIndex_1]):(emit(tempParameters[tempIndex_1]),write(" = "),emit(initializer)),write(";"),tempIndex_1++)}else initializer&&(writeLine(),emitStart(parameter),write("if ("),emitNodeWithoutSourceMap(paramName),write(" === void 0)"),emitEnd(parameter),write(" { "),emitStart(parameter),emitNodeWithCommentsAndWithoutSourcemap(paramName),write(" = "),emitNodeWithCommentsAndWithoutSourcemap(initializer),emitEnd(parameter),write("; }"))}})}}function emitRestParameter(node){if(languageVersion<2&&ts.hasRestParameter(node)){var restIndex=node.parameters.length-1,restParam=node.parameters[restIndex];if(ts.isBindingPattern(restParam.name))return;var tempName=createTempVariable(268435456).text;writeLine(),emitLeadingComments(restParam),emitStart(restParam),write("var "),emitNodeWithCommentsAndWithoutSourcemap(restParam.name),write(" = [];"),emitEnd(restParam),emitTrailingComments(restParam),writeLine(),write("for ("),emitStart(restParam),write("var "+tempName+" = "+restIndex+";"),emitEnd(restParam),write(" "),emitStart(restParam),write(tempName+" < arguments.length;"),emitEnd(restParam),write(" "),emitStart(restParam),write(tempName+"++"),emitEnd(restParam),write(") {"),increaseIndent(),writeLine(),emitStart(restParam),emitNodeWithCommentsAndWithoutSourcemap(restParam.name),write("["+tempName+" - "+restIndex+"] = arguments["+tempName+"];"),emitEnd(restParam),decreaseIndent(),writeLine(),write("}")}}function emitAccessor(node){write(146===node.kind?"get ":"set "),emit(node.name),emitSignatureAndBody(node)}function shouldEmitAsArrowFunction(node){return 177===node.kind&&languageVersion>=2}function emitDeclarationName(node){node.name?emitNodeWithCommentsAndWithoutSourcemap(node.name):write(getGeneratedNameForNode(node))}function shouldEmitFunctionName(node){return 176===node.kind?!!node.name:216===node.kind?!!node.name||5!==modulekind:void 0}function emitFunctionDeclaration(node){if(ts.nodeIsMissing(node.body))return emitCommentsOnNotEmittedNode(node);var kind=node.kind,parent=node.parent;144!==kind&&143!==kind&&parent&&248!==parent.kind&&171!==parent.kind&&167!==parent.kind&&emitLeadingComments(node),emitStart(node),shouldEmitAsArrowFunction(node)||(isES6ExportedDeclaration(node)&&(write("export "),512&node.flags&&write("default ")),write("function"),languageVersion>=2&&node.asteriskToken&&write("*"),write(" ")),shouldEmitFunctionName(node)&&emitDeclarationName(node),emitSignatureAndBody(node),5!==modulekind&&216===kind&&parent===currentSourceFile&&node.name&&emitExportMemberAssignments(node.name),emitEnd(node),144!==kind&&143!==kind&&emitTrailingComments(node)}function emitCaptureThisForNodeIfNecessary(node){4&resolver.getNodeCheckFlags(node)&&(writeLine(),emitStart(node),write("var _this = this;"),emitEnd(node))}function emitSignatureParameters(node){if(increaseIndent(),write("("),node){var parameters=node.parameters,omitCount=languageVersion<2&&ts.hasRestParameter(node)?1:0;emitList(parameters,0,parameters.length-omitCount,!1,!1)}write(")"),decreaseIndent()}function emitSignatureParametersForArrow(node){return 1===node.parameters.length&&node.pos===node.parameters[0].pos?void emit(node.parameters[0]):void emitSignatureParameters(node)}function emitAsyncFunctionBodyForES6(node){var promiseConstructor=ts.getEntityNameFromTypeNode(node.type),isArrowFunction=177===node.kind,hasLexicalArguments=0!==(8192&resolver.getNodeCheckFlags(node));isArrowFunction||(write(" {"),increaseIndent(),writeLine(),4096&resolver.getNodeCheckFlags(node)?(writeLines("\nconst _super = (function (geti, seti) {\n    const cache = Object.create(null);\n    return name => cache[name] || (cache[name] = { get value() { return geti(name); }, set value(v) { seti(name, v); } });\n})(name => super[name], (name, value) => super[name] = value);"),writeLine()):2048&resolver.getNodeCheckFlags(node)&&(write("const _super = name => super[name];"),writeLine()),write("return")),write(" __awaiter(this"),write(hasLexicalArguments?", arguments, ":", void 0, "),!promiseConstructor||compilerOptions.noCustomAsyncPromise&&languageVersion>=2?write("void 0"):emitEntityNameAsExpression(promiseConstructor,!1),write(", function* ()"),emitFunctionBody(node),write(")"),isArrowFunction||(write(";"),decreaseIndent(),writeLine(),write("}"))}function emitFunctionBody(node){node.body?195===node.body.kind?emitBlockFunctionBody(node,node.body):emitExpressionFunctionBody(node,node.body):write(" { }")}function emitSignatureAndBody(node){var saveConvertedLoopState=convertedLoopState,saveTempFlags=tempFlags,saveTempVariables=tempVariables,saveTempParameters=tempParameters;convertedLoopState=void 0,tempFlags=0,tempVariables=void 0,tempParameters=void 0,shouldEmitAsArrowFunction(node)?(emitSignatureParametersForArrow(node),write(" =>")):emitSignatureParameters(node);var isAsync=ts.isAsyncFunctionLike(node);isAsync?emitAsyncFunctionBodyForES6(node):emitFunctionBody(node),isES6ExportedDeclaration(node)||emitExportMemberAssignment(node),ts.Debug.assert(void 0===convertedLoopState),convertedLoopState=saveConvertedLoopState,tempFlags=saveTempFlags,tempVariables=saveTempVariables,tempParameters=saveTempParameters}function emitFunctionBodyPreamble(node){emitCaptureThisForNodeIfNecessary(node),emitDefaultValueAssignments(node),emitRestParameter(node)}function emitExpressionFunctionBody(node,body){if(languageVersion<2||256&node.flags)return void emitDownLevelExpressionFunctionBody(node,body);write(" ");for(var current=body;174===current.kind;)current=current.expression;emitParenthesizedIf(body,168===current.kind)}function emitDownLevelExpressionFunctionBody(node,body){write(" {"),increaseIndent();var outPos=writer.getTextPos();emitDetachedCommentsAndUpdateCommentsInfo(node.body),emitFunctionBodyPreamble(node);var preambleEmitted=writer.getTextPos()!==outPos;decreaseIndent(),!preambleEmitted&&nodeStartPositionsAreOnSameLine(node,body)?(write(" "),emitStart(body),write("return "),emit(body),emitEnd(body),write(";"),emitTempDeclarations(!1),write(" ")):(increaseIndent(),writeLine(),emitLeadingComments(node.body),emitStart(body),write("return "),emit(body),emitEnd(body),write(";"),emitTrailingComments(node.body),emitTempDeclarations(!0),decreaseIndent(),writeLine()),emitStart(node.body),write("}"),emitEnd(node.body)}function emitBlockFunctionBody(node,body){write(" {");var initialTextPos=writer.getTextPos();increaseIndent(),emitDetachedCommentsAndUpdateCommentsInfo(body.statements);var startIndex=emitDirectivePrologues(body.statements,!0);emitFunctionBodyPreamble(node),decreaseIndent();var preambleEmitted=writer.getTextPos()!==initialTextPos;if(!preambleEmitted&&nodeEndIsOnSameLineAsNodeStart(body,body)){for(var _a=0,_b=body.statements;_a<_b.length;_a++){var statement=_b[_a];write(" "),emit(statement)}emitTempDeclarations(!1),write(" "),emitLeadingCommentsOfPosition(body.statements.end)}else increaseIndent(),emitLinesStartingAt(body.statements,startIndex),emitTempDeclarations(!0),writeLine(),emitLeadingCommentsOfPosition(body.statements.end),decreaseIndent();emitToken(16,body.statements.end)}function getSuperCallAtGivenIndex(ctor,index){if(ctor.body){var statements=ctor.body.statements;if(statements&&!(index>=statements.length)){var statement=statements[index];return 198===statement.kind&&ts.isSuperCallExpression(statement.expression)?statement:void 0}}}function emitParameterPropertyAssignments(node){ts.forEach(node.parameters,function(param){56&param.flags&&(writeLine(),emitStart(param),emitStart(param.name),write("this."),emitNodeWithoutSourceMap(param.name),emitEnd(param.name),write(" = "),emit(param.name),write(";"),emitEnd(param))})}function emitMemberAccessForPropertyName(memberName){9===memberName.kind||8===memberName.kind?(write("["),emitNodeWithCommentsAndWithoutSourcemap(memberName),write("]")):137===memberName.kind?emitComputedPropertyName(memberName):(write("."),emitNodeWithCommentsAndWithoutSourcemap(memberName))}function getInitializedProperties(node,isStatic){for(var properties=[],_a=0,_b=node.members;_a<_b.length;_a++){var member=_b[_a];142===member.kind&&isStatic===(0!==(64&member.flags))&&member.initializer&&properties.push(member)}return properties}function emitPropertyDeclarations(node,properties){for(var _a=0,properties_6=properties;_a<properties_6.length;_a++){var property=properties_6[_a];emitPropertyDeclaration(node,property)}}function emitPropertyDeclaration(node,property,receiver,isExpression){writeLine(),emitLeadingComments(property),emitStart(property),emitStart(property.name),receiver?emit(receiver):64&property.flags?emitDeclarationName(node):write("this"),emitMemberAccessForPropertyName(property.name),emitEnd(property.name),write(" = "),emit(property.initializer),isExpression||write(";"),emitEnd(property),emitTrailingComments(property)}function emitMemberFunctionsForES5AndLower(node){ts.forEach(node.members,function(member){if(194===member.kind)writeLine(),write(";");else if(144===member.kind||143===node.kind){if(!member.body)return emitCommentsOnNotEmittedNode(member);writeLine(),emitLeadingComments(member),emitStart(member),emitStart(member.name),emitClassMemberPrefix(node,member),emitMemberAccessForPropertyName(member.name),emitEnd(member.name),write(" = "),emitFunctionDeclaration(member),emitEnd(member),write(";"),emitTrailingComments(member)}else if(146===member.kind||147===member.kind){var accessors=ts.getAllAccessorDeclarations(node.members,member);member===accessors.firstAccessor&&(writeLine(),emitStart(member),write("Object.defineProperty("),emitStart(member.name),emitClassMemberPrefix(node,member),write(", "),emitExpressionForPropertyName(member.name),emitEnd(member.name),write(", {"),increaseIndent(),accessors.getAccessor&&(writeLine(),emitLeadingComments(accessors.getAccessor),write("get: "),emitStart(accessors.getAccessor),write("function "),emitSignatureAndBody(accessors.getAccessor),emitEnd(accessors.getAccessor),emitTrailingComments(accessors.getAccessor),write(",")),accessors.setAccessor&&(writeLine(),emitLeadingComments(accessors.setAccessor),write("set: "),emitStart(accessors.setAccessor),write("function "),emitSignatureAndBody(accessors.setAccessor),emitEnd(accessors.setAccessor),emitTrailingComments(accessors.setAccessor),write(",")),writeLine(),write("enumerable: true,"),writeLine(),write("configurable: true"),decreaseIndent(),writeLine(),write("});"),emitEnd(member))}})}function emitMemberFunctionsForES6AndHigher(node){for(var _a=0,_b=node.members;_a<_b.length;_a++){var member=_b[_a];144!==member.kind&&143!==node.kind||member.body?144===member.kind||146===member.kind||147===member.kind?(writeLine(),emitLeadingComments(member),emitStart(member),64&member.flags&&write("static "),146===member.kind?write("get "):147===member.kind&&write("set "),member.asteriskToken&&write("*"),emit(member.name),emitSignatureAndBody(member),emitEnd(member),emitTrailingComments(member)):194===member.kind&&(writeLine(),write(";")):emitCommentsOnNotEmittedNode(member)}}function emitConstructor(node,baseTypeElement){var saveConvertedLoopState=convertedLoopState,saveTempFlags=tempFlags,saveTempVariables=tempVariables,saveTempParameters=tempParameters;convertedLoopState=void 0,tempFlags=0,tempVariables=void 0,tempParameters=void 0,emitConstructorWorker(node,baseTypeElement),ts.Debug.assert(void 0===convertedLoopState),convertedLoopState=saveConvertedLoopState,tempFlags=saveTempFlags,tempVariables=saveTempVariables,tempParameters=saveTempParameters}function emitConstructorWorker(node,baseTypeElement){var hasInstancePropertyWithInitializer=!1;ts.forEach(node.members,function(member){145!==member.kind||member.body||emitCommentsOnNotEmittedNode(member),142===member.kind&&member.initializer&&0===(64&member.flags)&&(hasInstancePropertyWithInitializer=!0)});var ctor=ts.getFirstConstructorWithBody(node);if(!(languageVersion>=2)||ctor||hasInstancePropertyWithInitializer){ctor&&emitLeadingComments(ctor),emitStart(ctor||node),languageVersion<2?(write("function "),emitDeclarationName(node),emitSignatureParameters(ctor)):(write("constructor"),ctor?emitSignatureParameters(ctor):write(baseTypeElement?"(...args)":"()"));var startIndex=0;write(" {"),increaseIndent(),ctor&&(startIndex=emitDirectivePrologues(ctor.body.statements,!0),emitDetachedCommentsAndUpdateCommentsInfo(ctor.body.statements)),emitCaptureThisForNodeIfNecessary(node);var superCall;if(ctor?(emitDefaultValueAssignments(ctor),emitRestParameter(ctor),baseTypeElement&&(superCall=getSuperCallAtGivenIndex(ctor,startIndex),superCall&&(writeLine(),emit(superCall))),emitParameterPropertyAssignments(ctor)):baseTypeElement&&(writeLine(),emitStart(baseTypeElement),write(languageVersion<2?"_super.apply(this, arguments);":"super(...args);"),emitEnd(baseTypeElement)),emitPropertyDeclarations(node,getInitializedProperties(node,!1)),ctor){var statements=ctor.body.statements;superCall&&(statements=statements.slice(1)),emitLinesStartingAt(statements,startIndex)}emitTempDeclarations(!0),writeLine(),ctor&&emitLeadingCommentsOfPosition(ctor.body.statements.end),decreaseIndent(),emitToken(16,ctor?ctor.body.statements.end:node.members.end),emitEnd(ctor||node),ctor&&emitTrailingComments(ctor)}}function emitClassExpression(node){return emitClassLikeDeclaration(node)}function emitClassDeclaration(node){return emitClassLikeDeclaration(node)}function emitClassLikeDeclaration(node){languageVersion<2?emitClassLikeDeclarationBelowES6(node):emitClassLikeDeclarationForES6AndHigher(node),5!==modulekind&&node.parent===currentSourceFile&&node.name&&emitExportMemberAssignments(node.name)}function emitClassLikeDeclarationForES6AndHigher(node){var decoratedClassAlias,thisNodeIsDecorated=ts.nodeIsDecorated(node);217===node.kind&&(thisNodeIsDecorated?(524288&resolver.getNodeCheckFlags(node)&&(decoratedClassAlias=ts.unescapeIdentifier(makeUniqueName(node.name?node.name.text:"default")),decoratedClassAliases[ts.getNodeId(node)]=decoratedClassAlias,write("let "+decoratedClassAlias+";"),writeLine()),!isES6ExportedDeclaration(node)||512&node.flags||write("export "),write("let "),emitDeclarationName(node),void 0!==decoratedClassAlias&&write(" = "+decoratedClassAlias),write(" = ")):isES6ExportedDeclaration(node)&&(write("export "),512&node.flags&&write("default ")));var tempVariable,staticProperties=getInitializedProperties(node,!0),isClassExpressionWithStaticProperties=staticProperties.length>0&&189===node.kind;isClassExpressionWithStaticProperties&&(tempVariable=createAndRecordTempVariable(0),write("("),increaseIndent(),emit(tempVariable),write(" = ")),write("class"),(node.name||512&node.flags&&(staticProperties.length>0||5!==modulekind)&&!thisNodeIsDecorated)&&(write(" "),emitDeclarationName(node));var baseTypeNode=ts.getClassExtendsHeritageClauseElement(node);if(baseTypeNode&&(write(" extends "),emit(baseTypeNode.expression)),
write(" {"),increaseIndent(),writeLine(),emitConstructor(node,baseTypeNode),emitMemberFunctionsForES6AndHigher(node),decreaseIndent(),writeLine(),emitToken(16,node.members.end),thisNodeIsDecorated&&(decoratedClassAliases[ts.getNodeId(node)]=void 0,write(";")),isClassExpressionWithStaticProperties){for(var _a=0,staticProperties_1=staticProperties;_a<staticProperties_1.length;_a++){var property=staticProperties_1[_a];write(","),writeLine(),emitPropertyDeclaration(node,property,tempVariable,!0)}write(","),writeLine(),emit(tempVariable),decreaseIndent(),write(")")}else writeLine(),emitPropertyDeclarations(node,staticProperties),emitDecoratorsOfClass(node,decoratedClassAlias);2&node.flags&&(5!==modulekind?emitExportMemberAssignment(node):512&node.flags?thisNodeIsDecorated&&(writeLine(),write("export default "),emitDeclarationName(node),write(";")):251!==node.parent.kind&&(writeLine(),emitStart(node),emitModuleMemberName(node),write(" = "),emitDeclarationName(node),emitEnd(node),write(";")))}function emitClassLikeDeclarationBelowES6(node){217===node.kind&&(shouldHoistDeclarationInSystemJsModule(node)||write("var "),emitDeclarationName(node),write(" = ")),write("(function (");var baseTypeNode=ts.getClassExtendsHeritageClauseElement(node);baseTypeNode&&write("_super"),write(") {");var saveTempFlags=tempFlags,saveTempVariables=tempVariables,saveTempParameters=tempParameters,saveComputedPropertyNamesToGeneratedNames=computedPropertyNamesToGeneratedNames,saveConvertedLoopState=convertedLoopState;convertedLoopState=void 0,tempFlags=0,tempVariables=void 0,tempParameters=void 0,computedPropertyNamesToGeneratedNames=void 0,increaseIndent(),baseTypeNode&&(writeLine(),emitStart(baseTypeNode),write("__extends("),emitDeclarationName(node),write(", _super);"),emitEnd(baseTypeNode)),writeLine(),emitConstructor(node,baseTypeNode),emitMemberFunctionsForES5AndLower(node),emitPropertyDeclarations(node,getInitializedProperties(node,!0)),writeLine(),emitDecoratorsOfClass(node,void 0),writeLine(),emitToken(16,node.members.end,function(){write("return "),emitDeclarationName(node)}),write(";"),emitTempDeclarations(!0),ts.Debug.assert(void 0===convertedLoopState),convertedLoopState=saveConvertedLoopState,tempFlags=saveTempFlags,tempVariables=saveTempVariables,tempParameters=saveTempParameters,computedPropertyNamesToGeneratedNames=saveComputedPropertyNamesToGeneratedNames,decreaseIndent(),writeLine(),emitToken(16,node.members.end),emitStart(node),write("("),baseTypeNode&&emit(baseTypeNode.expression),write("))"),217===node.kind&&write(";"),emitEnd(node),217===node.kind&&emitExportMemberAssignment(node)}function emitClassMemberPrefix(node,member){emitDeclarationName(node),64&member.flags||write(".prototype")}function emitDecoratorsOfClass(node,decoratedClassAlias){emitDecoratorsOfMembers(node,0),emitDecoratorsOfMembers(node,64),emitDecoratorsOfConstructor(node,decoratedClassAlias)}function emitDecoratorsOfConstructor(node,decoratedClassAlias){var decorators=node.decorators,constructor=ts.getFirstConstructorWithBody(node),firstParameterDecorator=constructor&&ts.forEach(constructor.parameters,function(parameter){return parameter.decorators});if(decorators||firstParameterDecorator){writeLine(),emitStart(node.decorators||firstParameterDecorator),emitDeclarationName(node),void 0!==decoratedClassAlias&&write(" = "+decoratedClassAlias),write(" = __decorate(["),increaseIndent(),writeLine();var decoratorCount=decorators?decorators.length:0,argumentsWritten=emitList(decorators,0,decoratorCount,!0,!1,!1,!0,function(decorator){return emit(decorator.expression)});firstParameterDecorator&&(argumentsWritten+=emitDecoratorsOfParameters(constructor,argumentsWritten>0)),emitSerializedTypeMetadata(node,argumentsWritten>=0),decreaseIndent(),writeLine(),write("], "),emitDeclarationName(node),write(")"),emitEnd(node.decorators||firstParameterDecorator),write(";"),writeLine()}}function emitDecoratorsOfMembers(node,staticFlag){for(var _a=0,_b=node.members;_a<_b.length;_a++){var member=_b[_a];if((64&member.flags)===staticFlag&&ts.nodeCanBeDecorated(member)){var decorators=void 0,functionLikeMember=void 0;if(ts.isAccessor(member)){var accessors=ts.getAllAccessorDeclarations(node.members,member);if(member!==accessors.firstAccessor)continue;decorators=accessors.firstAccessor.decorators,!decorators&&accessors.secondAccessor&&(decorators=accessors.secondAccessor.decorators),functionLikeMember=accessors.setAccessor}else decorators=member.decorators,144===member.kind&&(functionLikeMember=member);var firstParameterDecorator=functionLikeMember&&ts.forEach(functionLikeMember.parameters,function(parameter){return parameter.decorators});if(decorators||firstParameterDecorator){writeLine(),emitStart(decorators||firstParameterDecorator),write("__decorate(["),increaseIndent(),writeLine();var decoratorCount=decorators?decorators.length:0,argumentsWritten=emitList(decorators,0,decoratorCount,!0,!1,!1,!0,function(decorator){return emit(decorator.expression)});firstParameterDecorator&&(argumentsWritten+=emitDecoratorsOfParameters(functionLikeMember,argumentsWritten>0)),emitSerializedTypeMetadata(member,argumentsWritten>0),decreaseIndent(),writeLine(),write("], "),emitClassMemberPrefix(node,member),write(", "),emitExpressionForPropertyName(member.name),languageVersion>0&&write(142!==member.kind?", null":", void 0"),write(")"),emitEnd(decorators||firstParameterDecorator),write(";"),writeLine()}}}}function emitDecoratorsOfParameters(node,leadingComma){var argumentsWritten=0;if(node)for(var parameterIndex_1=0,_a=0,_b=node.parameters;_a<_b.length;_a++){var parameter=_b[_a];if(ts.nodeIsDecorated(parameter)){var decorators=parameter.decorators;argumentsWritten+=emitList(decorators,0,decorators.length,!0,!1,leadingComma,!0,function(decorator){write("__param("+parameterIndex_1+", "),emit(decorator.expression),write(")")}),leadingComma=!0}parameterIndex_1++}return argumentsWritten}function shouldEmitTypeMetadata(node){switch(node.kind){case 144:case 146:case 147:case 142:return!0}return!1}function shouldEmitReturnTypeMetadata(node){switch(node.kind){case 144:return!0}return!1}function shouldEmitParamTypesMetadata(node){switch(node.kind){case 217:case 144:case 147:return!0}return!1}function emitSerializedTypeOfNode(node){switch(node.kind){case 217:return void write("Function");case 142:return void emitSerializedTypeNode(node.type);case 139:return void emitSerializedTypeNode(node.type);case 146:return void emitSerializedTypeNode(node.type);case 147:return void emitSerializedTypeNode(ts.getSetAccessorTypeAnnotationNode(node))}return ts.isFunctionLike(node)?void write("Function"):void write("void 0")}function emitSerializedTypeNode(node){if(node)switch(node.kind){case 103:return void write("void 0");case 161:return void emitSerializedTypeNode(node.type);case 153:case 154:return void write("Function");case 157:case 158:return void write("Array");case 151:case 120:return void write("Boolean");case 130:case 163:return void write("String");case 128:return void write("Number");case 131:return void write("Symbol");case 152:return void emitSerializedTypeReferenceNode(node);case 155:case 156:case 159:case 160:case 117:case 162:break;default:ts.Debug.fail("Cannot serialize unexpected type node.")}write("Object")}function emitSerializedTypeReferenceNode(node){for(var location=node.parent;ts.isDeclaration(location)||ts.isTypeNode(location);)location=location.parent;var typeName=ts.cloneEntityName(node.typeName,location),result=resolver.getTypeReferenceSerializationKind(typeName);switch(result){case ts.TypeReferenceSerializationKind.Unknown:var temp=createAndRecordTempVariable(0);write("(typeof ("),emitNodeWithoutSourceMap(temp),write(" = "),emitEntityNameAsExpression(typeName,!0),write(") === 'function' && "),emitNodeWithoutSourceMap(temp),write(") || Object");break;case ts.TypeReferenceSerializationKind.TypeWithConstructSignatureAndValue:emitEntityNameAsExpression(typeName,!1);break;case ts.TypeReferenceSerializationKind.VoidType:write("void 0");break;case ts.TypeReferenceSerializationKind.BooleanType:write("Boolean");break;case ts.TypeReferenceSerializationKind.NumberLikeType:write("Number");break;case ts.TypeReferenceSerializationKind.StringLikeType:write("String");break;case ts.TypeReferenceSerializationKind.ArrayLikeType:write("Array");break;case ts.TypeReferenceSerializationKind.ESSymbolType:write(languageVersion<2?"typeof Symbol === 'function' ? Symbol : Object":"Symbol");break;case ts.TypeReferenceSerializationKind.TypeWithCallSignature:write("Function");break;case ts.TypeReferenceSerializationKind.ObjectType:write("Object")}}function emitSerializedParameterTypesOfNode(node){if(node){var valueDeclaration=void 0;if(217===node.kind?valueDeclaration=ts.getFirstConstructorWithBody(node):ts.isFunctionLike(node)&&ts.nodeIsPresent(node.body)&&(valueDeclaration=node),valueDeclaration){var parameters=valueDeclaration.parameters,parameterCount=parameters.length;if(parameterCount>0)for(var i=0;i<parameterCount;i++)if(i>0&&write(", "),parameters[i].dotDotDotToken){var parameterType=parameters[i].type;parameterType=157===parameterType.kind?parameterType.elementType:152===parameterType.kind&&parameterType.typeArguments&&1===parameterType.typeArguments.length?parameterType.typeArguments[0]:void 0,emitSerializedTypeNode(parameterType)}else emitSerializedTypeOfNode(parameters[i])}}}function emitSerializedReturnTypeOfNode(node){return node&&ts.isFunctionLike(node)&&node.type?void emitSerializedTypeNode(node.type):void write("void 0")}function emitSerializedTypeMetadata(node,writeComma){var argumentsWritten=0;return compilerOptions.emitDecoratorMetadata&&(shouldEmitTypeMetadata(node)&&(writeComma&&write(", "),writeLine(),write("__metadata('design:type', "),emitSerializedTypeOfNode(node),write(")"),argumentsWritten++),shouldEmitParamTypesMetadata(node)&&((writeComma||argumentsWritten)&&write(", "),writeLine(),write("__metadata('design:paramtypes', ["),emitSerializedParameterTypesOfNode(node),write("])"),argumentsWritten++),shouldEmitReturnTypeMetadata(node)&&((writeComma||argumentsWritten)&&write(", "),writeLine(),write("__metadata('design:returntype', "),emitSerializedReturnTypeOfNode(node),write(")"),argumentsWritten++)),argumentsWritten}function emitInterfaceDeclaration(node){emitCommentsOnNotEmittedNode(node)}function shouldEmitEnumDeclaration(node){var isConstEnum=ts.isConst(node);return!isConstEnum||compilerOptions.preserveConstEnums||compilerOptions.isolatedModules}function emitEnumDeclaration(node){if(shouldEmitEnumDeclaration(node)){if(!shouldHoistDeclarationInSystemJsModule(node)){var isES6ExportedEnum=isES6ExportedDeclaration(node);(!(2&node.flags)||isES6ExportedEnum&&isFirstDeclarationOfKind(node,node.symbol&&node.symbol.declarations,220))&&(emitStart(node),isES6ExportedEnum&&write("export "),write("var "),emit(node.name),emitEnd(node),write(";"))}writeLine(),emitStart(node),write("(function ("),emitStart(node.name),write(getGeneratedNameForNode(node)),emitEnd(node.name),write(") {"),increaseIndent(),emitLines(node.members),decreaseIndent(),writeLine(),emitToken(16,node.members.end),write(")("),emitModuleMemberName(node),write(" || ("),emitModuleMemberName(node),write(" = {}));"),emitEnd(node),!isES6ExportedDeclaration(node)&&2&node.flags&&!shouldHoistDeclarationInSystemJsModule(node)&&(writeLine(),emitStart(node),write("var "),emit(node.name),write(" = "),emitModuleMemberName(node),emitEnd(node),write(";")),5!==modulekind&&node.parent===currentSourceFile&&(4===modulekind&&2&node.flags&&(writeLine(),write(exportFunctionForFile+'("'),emitDeclarationName(node),write('", '),emitDeclarationName(node),write(");")),emitExportMemberAssignments(node.name))}}function emitEnumMember(node){var enumParent=node.parent;emitStart(node),write(getGeneratedNameForNode(enumParent)),write("["),write(getGeneratedNameForNode(enumParent)),write("["),emitExpressionForPropertyName(node.name),write("] = "),writeEnumMemberDeclarationValue(node),write("] = "),emitExpressionForPropertyName(node.name),emitEnd(node),write(";")}function writeEnumMemberDeclarationValue(member){var value=resolver.getConstantValue(member);return void 0!==value?void write(value.toString()):void(member.initializer?emit(member.initializer):write("undefined"))}function getInnerMostModuleDeclarationFromDottedModule(moduleDeclaration){if(221===moduleDeclaration.body.kind){var recursiveInnerModule=getInnerMostModuleDeclarationFromDottedModule(moduleDeclaration.body);return recursiveInnerModule||moduleDeclaration.body}}function shouldEmitModuleDeclaration(node){return ts.isInstantiatedModule(node,compilerOptions.preserveConstEnums||compilerOptions.isolatedModules)}function isModuleMergedWithES6Class(node){return 2===languageVersion&&!!(32768&resolver.getNodeCheckFlags(node))}function isFirstDeclarationOfKind(node,declarations,kind){return!ts.forEach(declarations,function(declaration){return declaration.kind===kind&&declaration.pos<node.pos})}function emitModuleDeclaration(node){var shouldEmit=shouldEmitModuleDeclaration(node);if(!shouldEmit)return emitCommentsOnNotEmittedNode(node);var hoistedInDeclarationScope=shouldHoistDeclarationInSystemJsModule(node),emitVarForModule=!hoistedInDeclarationScope&&!isModuleMergedWithES6Class(node);if(emitVarForModule){var isES6ExportedNamespace=isES6ExportedDeclaration(node);isES6ExportedNamespace&&!isFirstDeclarationOfKind(node,node.symbol&&node.symbol.declarations,221)||(emitStart(node),isES6ExportedNamespace&&write("export "),write("var "),emit(node.name),write(";"),emitEnd(node),writeLine())}if(emitStart(node),write("(function ("),emitStart(node.name),write(getGeneratedNameForNode(node)),emitEnd(node.name),write(") "),222===node.body.kind){var saveConvertedLoopState=convertedLoopState,saveTempFlags=tempFlags,saveTempVariables=tempVariables;convertedLoopState=void 0,tempFlags=0,tempVariables=void 0,emit(node.body),ts.Debug.assert(void 0===convertedLoopState),convertedLoopState=saveConvertedLoopState,tempFlags=saveTempFlags,tempVariables=saveTempVariables}else{write("{"),increaseIndent(),emitCaptureThisForNodeIfNecessary(node),writeLine(),emit(node.body),decreaseIndent(),writeLine();var moduleBlock=getInnerMostModuleDeclarationFromDottedModule(node).body;emitToken(16,moduleBlock.statements.end)}write(")("),2&node.flags&&!isES6ExportedDeclaration(node)&&(emit(node.name),write(" = ")),emitModuleMemberName(node),write(" || ("),emitModuleMemberName(node),write(" = {}));"),emitEnd(node),isES6ExportedDeclaration(node)||69!==node.name.kind||node.parent!==currentSourceFile||(4===modulekind&&2&node.flags&&(writeLine(),write(exportFunctionForFile+'("'),emitDeclarationName(node),write('", '),emitDeclarationName(node),write(");")),emitExportMemberAssignments(node.name))}function tryRenameExternalModule(moduleName){if(renamedDependencies&&ts.hasProperty(renamedDependencies,moduleName.text))return'"'+renamedDependencies[moduleName.text]+'"'}function emitRequire(moduleName){if(9===moduleName.kind){write("require(");var text=tryRenameExternalModule(moduleName);text?write(text):(emitStart(moduleName),emitLiteral(moduleName),emitEnd(moduleName)),emitToken(18,moduleName.end)}else write("require()")}function getNamespaceDeclarationNode(node){if(224===node.kind)return node;var importClause=node.importClause;return importClause&&importClause.namedBindings&&227===importClause.namedBindings.kind?importClause.namedBindings:void 0}function isDefaultImport(node){return 225===node.kind&&node.importClause&&!!node.importClause.name}function emitExportImportAssignments(node){ts.isAliasSymbolDeclaration(node)&&resolver.isValueAliasDeclaration(node)&&emitExportMemberAssignments(node.name),ts.forEachChild(node,emitExportImportAssignments)}function emitImportDeclaration(node){if(5!==modulekind)return emitExternalImportDeclaration(node);if(node.importClause){var shouldEmitDefaultBindings=resolver.isReferencedAliasDeclaration(node.importClause),shouldEmitNamedBindings=node.importClause.namedBindings&&resolver.isReferencedAliasDeclaration(node.importClause.namedBindings,!0);(shouldEmitDefaultBindings||shouldEmitNamedBindings)&&(write("import "),emitStart(node.importClause),shouldEmitDefaultBindings&&(emit(node.importClause.name),shouldEmitNamedBindings&&write(", ")),shouldEmitNamedBindings&&(emitLeadingComments(node.importClause.namedBindings),emitStart(node.importClause.namedBindings),227===node.importClause.namedBindings.kind?(write("* as "),emit(node.importClause.namedBindings.name)):(write("{ "),emitExportOrImportSpecifierList(node.importClause.namedBindings.elements,resolver.isReferencedAliasDeclaration),write(" }")),emitEnd(node.importClause.namedBindings),emitTrailingComments(node.importClause.namedBindings)),emitEnd(node.importClause),write(" from "),emit(node.moduleSpecifier),write(";"))}else write("import "),emit(node.moduleSpecifier),write(";")}function emitExternalImportDeclaration(node){if(ts.contains(externalImports,node)){var isExportedImport=224===node.kind&&0!==(2&node.flags),namespaceDeclaration=getNamespaceDeclarationNode(node),varOrConst=languageVersion<=1?"var ":"const ";if(2!==modulekind){if(emitLeadingComments(node),emitStart(node),namespaceDeclaration&&!isDefaultImport(node))isExportedImport||write(varOrConst),emitModuleMemberName(namespaceDeclaration),write(" = ");else{var isNakedImport=!node.importClause;isNakedImport||(write(varOrConst),write(getGeneratedNameForNode(node)),write(" = "))}emitRequire(ts.getExternalModuleName(node)),namespaceDeclaration&&isDefaultImport(node)&&(write(", "),emitModuleMemberName(namespaceDeclaration),write(" = "),write(getGeneratedNameForNode(node))),write(";"),emitEnd(node),emitExportImportAssignments(node),emitTrailingComments(node)}else isExportedImport?(emitModuleMemberName(namespaceDeclaration),write(" = "),emit(namespaceDeclaration.name),write(";")):namespaceDeclaration&&isDefaultImport(node)&&(write(varOrConst),emitModuleMemberName(namespaceDeclaration),write(" = "),write(getGeneratedNameForNode(node)),write(";")),emitExportImportAssignments(node)}}function emitImportEqualsDeclaration(node){if(ts.isExternalModuleImportEqualsDeclaration(node))return void emitExternalImportDeclaration(node);if(resolver.isReferencedAliasDeclaration(node)||!isCurrentFileExternalModule&&resolver.isTopLevelValueImportEqualsWithEntityName(node)){emitLeadingComments(node),emitStart(node);var variableDeclarationIsHoisted=shouldHoistVariable(node,!0),isExported=isSourceFileLevelDeclarationInSystemJsModule(node,!0);variableDeclarationIsHoisted||(ts.Debug.assert(!isExported),isES6ExportedDeclaration(node)?(write("export "),write("var ")):2&node.flags||write("var ")),isExported&&(write(exportFunctionForFile+'("'),emitNodeWithoutSourceMap(node.name),write('", ')),emitModuleMemberName(node),write(" = "),emit(node.moduleReference),isExported&&write(")"),write(";"),emitEnd(node),emitExportImportAssignments(node),emitTrailingComments(node)}}function emitExportDeclaration(node){if(ts.Debug.assert(4!==modulekind),5!==modulekind){if(node.moduleSpecifier&&(!node.exportClause||resolver.isValueAliasDeclaration(node))){emitStart(node);var generatedName=getGeneratedNameForNode(node);if(node.exportClause){2!==modulekind&&(write("var "),write(generatedName),write(" = "),emitRequire(ts.getExternalModuleName(node)),write(";"));for(var _a=0,_b=node.exportClause.elements;_a<_b.length;_a++){var specifier=_b[_a];resolver.isValueAliasDeclaration(specifier)&&(writeLine(),emitStart(specifier),emitContainingModuleName(specifier),write("."),emitNodeWithCommentsAndWithoutSourcemap(specifier.name),write(" = "),write(generatedName),write("."),emitNodeWithCommentsAndWithoutSourcemap(specifier.propertyName||specifier.name),write(";"),emitEnd(specifier))}}else hasExportStarsToExportValues&&resolver.moduleExportsSomeValue(node.moduleSpecifier)&&(writeLine(),write("__export("),2!==modulekind?emitRequire(ts.getExternalModuleName(node)):write(generatedName),write(");"));emitEnd(node)}}else node.exportClause&&!resolver.isValueAliasDeclaration(node)||(write("export "),node.exportClause?(write("{ "),emitExportOrImportSpecifierList(node.exportClause.elements,resolver.isValueAliasDeclaration),write(" }")):write("*"),node.moduleSpecifier&&(write(" from "),emit(node.moduleSpecifier)),write(";"))}function emitExportOrImportSpecifierList(specifiers,shouldEmit){ts.Debug.assert(5===modulekind);for(var needsComma=!1,_a=0,specifiers_1=specifiers;_a<specifiers_1.length;_a++){var specifier=specifiers_1[_a];shouldEmit(specifier)&&(needsComma&&write(", "),specifier.propertyName&&(emit(specifier.propertyName),write(" as ")),emit(specifier.name),needsComma=!0)}}function emitExportAssignment(node){if(!node.isExportEquals&&resolver.isValueAliasDeclaration(node))if(5===modulekind){writeLine(),emitStart(node),write("export default ");var expression=node.expression;emit(expression),216!==expression.kind&&217!==expression.kind&&write(";"),emitEnd(node)}else writeLine(),emitStart(node),4===modulekind?(write(exportFunctionForFile+'("default",'),emit(node.expression),write(")")):(emitEs6ExportDefaultCompat(node),emitContainingModuleName(node),write(0===languageVersion?'["default"] = ':".default = "),emit(node.expression)),write(";"),emitEnd(node)}function collectExternalModuleInfo(sourceFile){externalImports=[],exportSpecifiers={},exportEquals=void 0,hasExportStarsToExportValues=!1;for(var _a=0,_b=sourceFile.statements;_a<_b.length;_a++){var node=_b[_a];switch(node.kind){case 225:node.importClause&&!resolver.isReferencedAliasDeclaration(node.importClause,!0)||externalImports.push(node);break;case 224:235===node.moduleReference.kind&&resolver.isReferencedAliasDeclaration(node)&&externalImports.push(node);break;case 231:if(node.moduleSpecifier)node.exportClause?resolver.isValueAliasDeclaration(node)&&externalImports.push(node):resolver.moduleExportsSomeValue(node.moduleSpecifier)&&(externalImports.push(node),hasExportStarsToExportValues=!0);else for(var _c=0,_d=node.exportClause.elements;_c<_d.length;_c++){var specifier=_d[_c],name_28=(specifier.propertyName||specifier.name).text;(exportSpecifiers[name_28]||(exportSpecifiers[name_28]=[])).push(specifier)}break;case 230:node.isExportEquals&&!exportEquals&&(exportEquals=node)}}}function emitExportStarHelper(){hasExportStarsToExportValues&&(writeLine(),write("function __export(m) {"),increaseIndent(),writeLine(),write("for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];"),decreaseIndent(),writeLine(),write("}"))}function getLocalNameForExternalImport(node){var namespaceDeclaration=getNamespaceDeclarationNode(node);return namespaceDeclaration&&!isDefaultImport(node)?ts.getTextOfNodeFromSourceText(currentText,namespaceDeclaration.name):225===node.kind&&node.importClause?getGeneratedNameForNode(node):231===node.kind&&node.moduleSpecifier?getGeneratedNameForNode(node):void 0}function getExternalModuleNameText(importNode,emitRelativePathAsModuleName){if(emitRelativePathAsModuleName){var name_29=getExternalModuleNameFromDeclaration(host,resolver,importNode);if(name_29)return'"'+name_29+'"'}var moduleName=ts.getExternalModuleName(importNode);if(9===moduleName.kind)return tryRenameExternalModule(moduleName)||getLiteralText(moduleName)}function emitVariableDeclarationsForImports(){if(0!==externalImports.length){writeLine();for(var started=!1,_a=0,externalImports_1=externalImports;_a<externalImports_1.length;_a++){var importNode=externalImports_1[_a],skipNode=231===importNode.kind||225===importNode.kind&&!importNode.importClause;skipNode||(started?write(", "):(write("var "),started=!0),write(getLocalNameForExternalImport(importNode)))}started&&write(";")}}function emitLocalStorageForExportedNamesIfNecessary(exportedDeclarations){function emitExportStarFunction(localNames){var exportStarFunction=makeUniqueName("exportStar");return writeLine(),write("function "+exportStarFunction+"(m) {"),increaseIndent(),writeLine(),write("var exports = {};"),writeLine(),write("for(var n in m) {"),increaseIndent(),writeLine(),write('if (n !== "default"'),localNames&&write("&& !"+localNames+".hasOwnProperty(n)"),write(") exports[n] = m[n];"),decreaseIndent(),writeLine(),write("}"),writeLine(),write(exportFunctionForFile+"(exports);"),decreaseIndent(),writeLine(),write("}"),exportStarFunction}function writeExportedName(node){69!==node.kind&&512&node.flags||(started?write(","):started=!0,writeLine(),write("'"),69===node.kind?emitNodeWithCommentsAndWithoutSourcemap(node):emitDeclarationName(node),write("': true"))}if(hasExportStarsToExportValues){if(!exportedDeclarations&&ts.isEmpty(exportSpecifiers)){for(var hasExportDeclarationWithExportClause=!1,_a=0,externalImports_2=externalImports;_a<externalImports_2.length;_a++){var externalImport=externalImports_2[_a];if(231===externalImport.kind&&externalImport.exportClause){hasExportDeclarationWithExportClause=!0;break}}if(!hasExportDeclarationWithExportClause)return emitExportStarFunction(void 0)}var exportedNamesStorageRef=makeUniqueName("exportedNames");writeLine(),write("var "+exportedNamesStorageRef+" = {"),increaseIndent();var started=!1;if(exportedDeclarations)for(var i=0;i<exportedDeclarations.length;i++)writeExportedName(exportedDeclarations[i]);if(exportSpecifiers)for(var n in exportSpecifiers)for(var _b=0,_c=exportSpecifiers[n];_b<_c.length;_b++){var specifier=_c[_b];writeExportedName(specifier.name)}for(var _d=0,externalImports_3=externalImports;_d<externalImports_3.length;_d++){var externalImport=externalImports_3[_d];if(231===externalImport.kind){var exportDecl=externalImport;if(exportDecl.exportClause)for(var _e=0,_f=exportDecl.exportClause.elements;_e<_f.length;_e++){var element=_f[_e];writeExportedName(element.name||element.propertyName)}}}return decreaseIndent(),writeLine(),write("};"),emitExportStarFunction(exportedNamesStorageRef)}}function processTopLevelVariableAndFunctionDeclarations(node){function visit(node){if(!(4&node.flags)){if(216===node.kind)return hoistedFunctionDeclarations||(hoistedFunctionDeclarations=[]),void hoistedFunctionDeclarations.push(node);if(217===node.kind)return hoistedVars||(hoistedVars=[]),void hoistedVars.push(node);if(220===node.kind)return void(shouldEmitEnumDeclaration(node)&&(hoistedVars||(hoistedVars=[]),hoistedVars.push(node)));if(221===node.kind)return void(shouldEmitModuleDeclaration(node)&&(hoistedVars||(hoistedVars=[]),hoistedVars.push(node)));if(214!==node.kind&&166!==node.kind)return ts.isInternalModuleImportEqualsDeclaration(node)&&resolver.isValueAliasDeclaration(node)?(hoistedVars||(hoistedVars=[]),void hoistedVars.push(node.name)):ts.isBindingPattern(node)?void ts.forEach(node.elements,visit):void(ts.isDeclaration(node)||ts.forEachChild(node,visit));if(shouldHoistVariable(node,!1)){var name_31=node.name;69===name_31.kind?(hoistedVars||(hoistedVars=[]),hoistedVars.push(name_31)):ts.forEachChild(name_31,visit)}}}var hoistedVars,hoistedFunctionDeclarations,exportedDeclarations;if(visit(node),hoistedVars){writeLine(),write("var ");for(var seen={},i=0;i<hoistedVars.length;i++){var local=hoistedVars[i],name_30=69===local.kind?local:local.name;if(name_30){var text=ts.unescapeIdentifier(name_30.text);if(ts.hasProperty(seen,text))continue;seen[text]=text}0!==i&&write(", "),217===local.kind||221===local.kind||220===local.kind?emitDeclarationName(local):emit(local);var flags=ts.getCombinedNodeFlags(69===local.kind?local.parent:local);2&flags&&(exportedDeclarations||(exportedDeclarations=[]),exportedDeclarations.push(local))}write(";")}if(hoistedFunctionDeclarations)for(var _a=0,hoistedFunctionDeclarations_1=hoistedFunctionDeclarations;_a<hoistedFunctionDeclarations_1.length;_a++){var f=hoistedFunctionDeclarations_1[_a];writeLine(),emit(f),2&f.flags&&(exportedDeclarations||(exportedDeclarations=[]),exportedDeclarations.push(f))}return exportedDeclarations}function shouldHoistVariable(node,checkIfSourceFileLevelDecl){return!(checkIfSourceFileLevelDecl&&!shouldHoistDeclarationInSystemJsModule(node))&&(0===(24576&ts.getCombinedNodeFlags(node))||251===ts.getEnclosingBlockScopeContainer(node).kind)}function isCurrentFileSystemExternalModule(){return 4===modulekind&&isCurrentFileExternalModule}function emitSystemModuleBody(node,dependencyGroups,startIndex){emitVariableDeclarationsForImports(),writeLine();var exportedDeclarations=processTopLevelVariableAndFunctionDeclarations(node),exportStarFunction=emitLocalStorageForExportedNamesIfNecessary(exportedDeclarations);writeLine(),write("return {"),increaseIndent(),writeLine(),emitSetters(exportStarFunction,dependencyGroups),writeLine(),emitExecute(node,startIndex),decreaseIndent(),writeLine(),write("}"),emitTempDeclarations(!0)}function emitSetters(exportStarFunction,dependencyGroups){write("setters:[");for(var i=0;i<dependencyGroups.length;i++){0!==i&&write(","),writeLine(),increaseIndent();var group=dependencyGroups[i],parameterName=makeUniqueName(ts.forEach(group,getLocalNameForExternalImport)||"");write("function ("+parameterName+") {"),increaseIndent();for(var _a=0,group_1=group;_a<group_1.length;_a++){var entry=group_1[_a],importVariableName=getLocalNameForExternalImport(entry)||"";switch(entry.kind){case 225:if(!entry.importClause)break;case 224:ts.Debug.assert(""!==importVariableName),writeLine(),write(importVariableName+" = "+parameterName+";"),writeLine();break;case 231:if(ts.Debug.assert(""!==importVariableName),entry.exportClause){writeLine(),write(exportFunctionForFile+"({"),writeLine(),increaseIndent();for(var i_1=0,len=entry.exportClause.elements.length;i_1<len;i_1++){0!==i_1&&(write(","),writeLine());var e=entry.exportClause.elements[i_1];write('"'),emitNodeWithCommentsAndWithoutSourcemap(e.name),write('": '+parameterName+'["'),emitNodeWithCommentsAndWithoutSourcemap(e.propertyName||e.name),write('"]')}decreaseIndent(),writeLine(),write("});")}else writeLine(),write(exportStarFunction+"("+parameterName+");");writeLine()}}decreaseIndent(),write("}"),decreaseIndent()}write("],")}function emitExecute(node,startIndex){write("execute: function() {"),increaseIndent(),writeLine();for(var i=startIndex;i<node.statements.length;i++){var statement=node.statements[i];switch(statement.kind){case 216:case 225:continue;case 231:if(!statement.moduleSpecifier)for(var _a=0,_b=statement.exportClause.elements;_a<_b.length;_a++){var element=_b[_a];emitExportSpecifierInSystemModule(element)}continue;case 224:if(!ts.isInternalModuleImportEqualsDeclaration(statement))continue;default:writeLine(),emit(statement)}}decreaseIndent(),writeLine(),write("}")}function writeModuleName(node,emitRelativePathAsModuleName){var moduleName=node.moduleName;(moduleName||emitRelativePathAsModuleName&&(moduleName=getResolvedExternalModuleName(host,node)))&&write('"'+moduleName+'", ')}function emitSystemModule(node,emitRelativePathAsModuleName){collectExternalModuleInfo(node),ts.Debug.assert(!exportFunctionForFile),exportFunctionForFile=makeUniqueName("exports"),contextObjectForFile=makeUniqueName("context"),writeLine(),write("System.register("),writeModuleName(node,emitRelativePathAsModuleName),write("[");for(var groupIndices={},dependencyGroups=[],i=0;i<externalImports.length;i++){var text=getExternalModuleNameText(externalImports[i],emitRelativePathAsModuleName);if(void 0!==text){var key=text.substr(1,text.length-2);if(ts.hasProperty(groupIndices,key)){var groupIndex=groupIndices[key];dependencyGroups[groupIndex].push(externalImports[i])}else groupIndices[key]=dependencyGroups.length,dependencyGroups.push([externalImports[i]]),0!==i&&write(", "),write(text)}}write("], function("+exportFunctionForFile+", "+contextObjectForFile+") {"),writeLine(),increaseIndent();var startIndex=emitDirectivePrologues(node.statements,!0,!compilerOptions.noImplicitUseStrict);writeLine(),write("var __moduleName = "+contextObjectForFile+" && "+contextObjectForFile+".id;"),writeLine(),emitEmitHelpers(node),emitCaptureThisForNodeIfNecessary(node),emitSystemModuleBody(node,dependencyGroups,startIndex),decreaseIndent(),writeLine(),write("});")}function getAMDDependencyNames(node,includeNonAmdDependencies,emitRelativePathAsModuleName){for(var aliasedModuleNames=[],unaliasedModuleNames=[],importAliasNames=[],_a=0,_b=node.amdDependencies;_a<_b.length;_a++){
var amdDependency=_b[_a];amdDependency.name?(aliasedModuleNames.push('"'+amdDependency.path+'"'),importAliasNames.push(amdDependency.name)):unaliasedModuleNames.push('"'+amdDependency.path+'"')}for(var _c=0,externalImports_4=externalImports;_c<externalImports_4.length;_c++){var importNode=externalImports_4[_c],externalModuleName=getExternalModuleNameText(importNode,emitRelativePathAsModuleName),importAliasName=getLocalNameForExternalImport(importNode);includeNonAmdDependencies&&importAliasName?(aliasedModuleNames.push(externalModuleName),importAliasNames.push(importAliasName)):unaliasedModuleNames.push(externalModuleName)}return{aliasedModuleNames:aliasedModuleNames,unaliasedModuleNames:unaliasedModuleNames,importAliasNames:importAliasNames}}function emitAMDDependencies(node,includeNonAmdDependencies,emitRelativePathAsModuleName){var dependencyNames=getAMDDependencyNames(node,includeNonAmdDependencies,emitRelativePathAsModuleName);emitAMDDependencyList(dependencyNames),write(", "),emitAMDFactoryHeader(dependencyNames)}function emitAMDDependencyList(_a){var aliasedModuleNames=_a.aliasedModuleNames,unaliasedModuleNames=_a.unaliasedModuleNames;write('["require", "exports"'),aliasedModuleNames.length&&(write(", "),write(aliasedModuleNames.join(", "))),unaliasedModuleNames.length&&(write(", "),write(unaliasedModuleNames.join(", "))),write("]")}function emitAMDFactoryHeader(_a){var importAliasNames=_a.importAliasNames;write("function (require, exports"),importAliasNames.length&&(write(", "),write(importAliasNames.join(", "))),write(") {")}function emitAMDModule(node,emitRelativePathAsModuleName){emitEmitHelpers(node),collectExternalModuleInfo(node),writeLine(),write("define("),writeModuleName(node,emitRelativePathAsModuleName),emitAMDDependencies(node,!0,emitRelativePathAsModuleName),increaseIndent();var startIndex=emitDirectivePrologues(node.statements,!0,!compilerOptions.noImplicitUseStrict);emitExportStarHelper(),emitCaptureThisForNodeIfNecessary(node),emitLinesStartingAt(node.statements,startIndex),emitTempDeclarations(!0),emitExportEquals(!0),decreaseIndent(),writeLine(),write("});")}function emitCommonJSModule(node){var startIndex=emitDirectivePrologues(node.statements,!1,!compilerOptions.noImplicitUseStrict);emitEmitHelpers(node),collectExternalModuleInfo(node),emitExportStarHelper(),emitCaptureThisForNodeIfNecessary(node),emitLinesStartingAt(node.statements,startIndex),emitTempDeclarations(!0),emitExportEquals(!1)}function emitUMDModule(node){emitEmitHelpers(node),collectExternalModuleInfo(node);var dependencyNames=getAMDDependencyNames(node,!1);writeLines("(function (factory) {\n    if (typeof module === 'object' && typeof module.exports === 'object') {\n        var v = factory(require, exports); if (v !== undefined) module.exports = v;\n    }\n    else if (typeof define === 'function' && define.amd) {\n        define("),emitAMDDependencyList(dependencyNames),write(", factory);"),writeLines("    }\n})("),emitAMDFactoryHeader(dependencyNames),increaseIndent();var startIndex=emitDirectivePrologues(node.statements,!0,!compilerOptions.noImplicitUseStrict);emitExportStarHelper(),emitCaptureThisForNodeIfNecessary(node),emitLinesStartingAt(node.statements,startIndex),emitTempDeclarations(!0),emitExportEquals(!0),decreaseIndent(),writeLine(),write("});")}function emitES6Module(node){externalImports=void 0,exportSpecifiers=void 0,exportEquals=void 0,hasExportStarsToExportValues=!1;var startIndex=emitDirectivePrologues(node.statements,!1);emitEmitHelpers(node),emitCaptureThisForNodeIfNecessary(node),emitLinesStartingAt(node.statements,startIndex),emitTempDeclarations(!0)}function emitExportEquals(emitAsReturn){exportEquals&&resolver.isValueAliasDeclaration(exportEquals)&&(writeLine(),emitStart(exportEquals),write(emitAsReturn?"return ":"module.exports = "),emit(exportEquals.expression),write(";"),emitEnd(exportEquals))}function emitJsxElement(node){switch(compilerOptions.jsx){case 2:jsxEmitReact(node);break;case 1:default:jsxEmitPreserve(node)}}function trimReactWhitespaceAndApplyEntities(node){for(var result=void 0,text=ts.getTextOfNode(node,!0),firstNonWhitespace=0,lastNonWhitespace=-1,i=0;i<text.length;i++){var c=text.charCodeAt(i);if(ts.isLineBreak(c)){if(firstNonWhitespace!==-1&&lastNonWhitespace-firstNonWhitespace+1>0){var part=text.substr(firstNonWhitespace,lastNonWhitespace-firstNonWhitespace+1);result=(result?result+"\" + ' ' + \"":"")+ts.escapeString(part)}firstNonWhitespace=-1}else ts.isWhiteSpace(c)||(lastNonWhitespace=i,firstNonWhitespace===-1&&(firstNonWhitespace=i))}if(firstNonWhitespace!==-1){var part=text.substr(firstNonWhitespace);result=(result?result+"\" + ' ' + \"":"")+ts.escapeString(part)}return result&&(result=result.replace(/&(\w+);/g,function(s,m){if(void 0!==entities[m]){var ch=String.fromCharCode(entities[m]);return'"'===ch?'\\"':ch}return s})),result}function getTextToEmit(node){switch(compilerOptions.jsx){case 2:var text=trimReactWhitespaceAndApplyEntities(node);return void 0===text||0===text.length?void 0:text;case 1:default:return ts.getTextOfNode(node,!0)}}function emitJsxText(node){switch(compilerOptions.jsx){case 2:write('"'),write(trimReactWhitespaceAndApplyEntities(node)),write('"');break;case 1:default:writer.writeLiteral(ts.getTextOfNode(node,!0))}}function emitJsxExpression(node){if(node.expression)switch(compilerOptions.jsx){case 1:default:write("{"),emit(node.expression),write("}");break;case 2:emit(node.expression)}}function isUseStrictPrologue(node){return!!node.expression.text.match(/use strict/)}function ensureUseStrictPrologue(startWithNewLine,writeUseStrict){writeUseStrict&&(startWithNewLine&&writeLine(),write('"use strict";'))}function emitDirectivePrologues(statements,startWithNewLine,ensureUseStrict){for(var foundUseStrict=!1,i=0;i<statements.length;i++){if(!ts.isPrologueDirective(statements[i]))return ensureUseStrictPrologue(startWithNewLine||i>0,!foundUseStrict&&ensureUseStrict),i;isUseStrictPrologue(statements[i])&&(foundUseStrict=!0),(startWithNewLine||i>0)&&writeLine(),emit(statements[i])}return ensureUseStrictPrologue(startWithNewLine,!foundUseStrict&&ensureUseStrict),statements.length}function writeLines(text){for(var lines=text.split(/\r\n|\r|\n/g),i=0;i<lines.length;i++){var line=lines[i];line.length&&(writeLine(),write(line))}}function emitEmitHelpers(node){compilerOptions.noEmitHelpers||(languageVersion<2&&!extendsEmitted&&4194304&node.flags&&(writeLines(extendsHelper),extendsEmitted=!0),!decorateEmitted&&8388608&node.flags&&(writeLines(decorateHelper),compilerOptions.emitDecoratorMetadata&&writeLines(metadataHelper),decorateEmitted=!0),!paramEmitted&&16777216&node.flags&&(writeLines(paramHelper),paramEmitted=!0),!awaiterEmitted&&33554432&node.flags&&(writeLines(awaiterHelper),awaiterEmitted=!0))}function emitSourceFileNode(node){if(writeLine(),emitShebang(),emitDetachedCommentsAndUpdateCommentsInfo(node),ts.isExternalModule(node)||compilerOptions.isolatedModules)if(isOwnFileEmit||!ts.isExternalModule(node)&&compilerOptions.isolatedModules){var emitModule=moduleEmitDelegates[modulekind]||moduleEmitDelegates[1];emitModule(node)}else bundleEmitDelegates[modulekind](node,!0);else{var startIndex=emitDirectivePrologues(node.statements,!1);externalImports=void 0,exportSpecifiers=void 0,exportEquals=void 0,hasExportStarsToExportValues=!1,emitEmitHelpers(node),emitCaptureThisForNodeIfNecessary(node),emitLinesStartingAt(node.statements,startIndex),emitTempDeclarations(!0)}emitLeadingComments(node.endOfFileToken)}function emit(node){emitNodeConsideringCommentsOption(node,emitNodeWithSourceMap)}function emitNodeWithCommentsAndWithoutSourcemap(node){emitNodeConsideringCommentsOption(node,emitNodeWithoutSourceMap)}function emitNodeConsideringCommentsOption(node,emitNodeConsideringSourcemap){if(node){if(4&node.flags)return emitCommentsOnNotEmittedNode(node);if(isSpecializedCommentHandling(node))return emitNodeWithoutSourceMap(node);var emitComments_1=shouldEmitLeadingAndTrailingComments(node);emitComments_1&&emitLeadingComments(node),emitNodeConsideringSourcemap(node),emitComments_1&&emitTrailingComments(node)}}function emitNodeWithSourceMap(node){node&&(emitStart(node),emitNodeWithoutSourceMap(node),emitEnd(node))}function emitNodeWithoutSourceMap(node){node&&emitJavaScriptWorker(node)}function changeSourceMapEmit(writer){sourceMap=writer,emitStart=writer.emitStart,emitEnd=writer.emitEnd,emitPos=writer.emitPos,setSourceFile=writer.setSourceFile}function withTemporaryNoSourceMap(callback){var prevSourceMap=sourceMap;setSourceMapWriterEmit(ts.getNullSourceMapWriter()),callback(),setSourceMapWriterEmit(prevSourceMap)}function isSpecializedCommentHandling(node){switch(node.kind){case 218:case 216:case 225:case 224:case 219:case 230:return!0}}function shouldEmitLeadingAndTrailingComments(node){switch(node.kind){case 196:return shouldEmitLeadingAndTrailingCommentsForVariableStatement(node);case 221:return shouldEmitModuleDeclaration(node);case 220:return shouldEmitEnumDeclaration(node)}return ts.Debug.assert(!isSpecializedCommentHandling(node)),!(195!==node.kind&&node.parent&&177===node.parent.kind&&node.parent.body===node&&compilerOptions.target<=1)}function emitJavaScriptWorker(node){switch(node.kind){case 69:return emitIdentifier(node);case 139:return emitParameter(node);case 144:case 143:return emitMethod(node);case 146:case 147:return emitAccessor(node);case 97:return emitThis(node);case 95:return emitSuper(node);case 93:return write("null");case 99:return write("true");case 84:return write("false");case 8:case 9:case 10:case 11:case 12:case 13:case 14:return emitLiteral(node);case 186:return emitTemplateExpression(node);case 193:return emitTemplateSpan(node);case 236:case 237:return emitJsxElement(node);case 239:return emitJsxText(node);case 243:return emitJsxExpression(node);case 136:return emitQualifiedName(node);case 164:return emitObjectBindingPattern(node);case 165:return emitArrayBindingPattern(node);case 166:return emitBindingElement(node);case 167:return emitArrayLiteral(node);case 168:return emitObjectLiteral(node);case 248:return emitPropertyAssignment(node);case 249:return emitShorthandPropertyAssignment(node);case 137:return emitComputedPropertyName(node);case 169:return emitPropertyAccess(node);case 170:return emitIndexedAccess(node);case 171:return emitCallExpression(node);case 172:return emitNewExpression(node);case 173:return emitTaggedTemplateExpression(node);case 174:return emit(node.expression);case 192:return emit(node.expression);case 175:return emitParenExpression(node);case 216:case 176:case 177:return emitFunctionDeclaration(node);case 178:return emitDeleteExpression(node);case 179:return emitTypeOfExpression(node);case 180:return emitVoidExpression(node);case 181:return emitAwaitExpression(node);case 182:return emitPrefixUnaryExpression(node);case 183:return emitPostfixUnaryExpression(node);case 184:return emitBinaryExpression(node);case 185:return emitConditionalExpression(node);case 188:return emitSpreadElementExpression(node);case 187:return emitYieldExpression(node);case 190:return;case 195:case 222:return emitBlock(node);case 196:return emitVariableStatement(node);case 197:return write(";");case 198:return emitExpressionStatement(node);case 199:return emitIfStatement(node);case 200:return emitDoStatement(node);case 201:return emitWhileStatement(node);case 202:return emitForStatement(node);case 204:case 203:return emitForInOrForOfStatement(node);case 205:case 206:return emitBreakOrContinueStatement(node);case 207:return emitReturnStatement(node);case 208:return emitWithStatement(node);case 209:return emitSwitchStatement(node);case 244:case 245:return emitCaseOrDefaultClause(node);case 210:return emitLabeledStatement(node);case 211:return emitThrowStatement(node);case 212:return emitTryStatement(node);case 247:return emitCatchClause(node);case 213:return emitDebuggerStatement(node);case 214:return emitVariableDeclaration(node);case 189:return emitClassExpression(node);case 217:return emitClassDeclaration(node);case 218:return emitInterfaceDeclaration(node);case 220:return emitEnumDeclaration(node);case 250:return emitEnumMember(node);case 221:return emitModuleDeclaration(node);case 225:return emitImportDeclaration(node);case 224:return emitImportEqualsDeclaration(node);case 231:return emitExportDeclaration(node);case 230:return emitExportAssignment(node);case 251:return emitSourceFileNode(node)}}function hasDetachedComments(pos){return void 0!==detachedCommentsInfo&&ts.lastOrUndefined(detachedCommentsInfo).nodePos===pos}function getLeadingCommentsWithoutDetachedComments(){var leadingComments=ts.getLeadingCommentRanges(currentText,ts.lastOrUndefined(detachedCommentsInfo).detachedCommentEndPos);return detachedCommentsInfo.length-1?detachedCommentsInfo.pop():detachedCommentsInfo=void 0,leadingComments}function isTripleSlashComment(comment){if(47===currentText.charCodeAt(comment.pos+1)&&comment.pos+2<comment.end&&47===currentText.charCodeAt(comment.pos+2)){var textSubStr=currentText.substring(comment.pos,comment.end);return!(!textSubStr.match(ts.fullTripleSlashReferencePathRegEx)&&!textSubStr.match(ts.fullTripleSlashAMDReferencePathRegEx))}return!1}function getLeadingCommentsToEmit(node){if(node.parent&&(251===node.parent.kind||node.pos!==node.parent.pos))return hasDetachedComments(node.pos)?getLeadingCommentsWithoutDetachedComments():ts.getLeadingCommentRangesOfNodeFromText(node,currentText)}function getTrailingCommentsToEmit(node){if(node.parent&&(251===node.parent.kind||node.end!==node.parent.end))return ts.getTrailingCommentRanges(currentText,node.end)}function emitCommentsOnNotEmittedNode(node){emitLeadingCommentsWorker(node,!1)}function emitLeadingComments(node){return emitLeadingCommentsWorker(node,!0)}function emitLeadingCommentsWorker(node,isEmittedNode){if(!compilerOptions.removeComments){var leadingComments;isEmittedNode?leadingComments=getLeadingCommentsToEmit(node):0===node.pos&&(leadingComments=ts.filter(getLeadingCommentsToEmit(node),isTripleSlashComment)),ts.emitNewLineBeforeLeadingComments(currentLineMap,writer,node,leadingComments),ts.emitComments(currentText,currentLineMap,writer,leadingComments,!0,newLine,writeComment)}}function emitTrailingComments(node){if(!compilerOptions.removeComments){var trailingComments=getTrailingCommentsToEmit(node);ts.emitComments(currentText,currentLineMap,writer,trailingComments,!1,newLine,writeComment)}}function emitTrailingCommentsOfPosition(pos){if(!compilerOptions.removeComments){var trailingComments=ts.getTrailingCommentRanges(currentText,pos);ts.emitComments(currentText,currentLineMap,writer,trailingComments,!0,newLine,writeComment)}}function emitLeadingCommentsOfPositionWorker(pos){if(!compilerOptions.removeComments){var leadingComments;leadingComments=hasDetachedComments(pos)?getLeadingCommentsWithoutDetachedComments():ts.getLeadingCommentRanges(currentText,pos),ts.emitNewLineBeforeLeadingComments(currentLineMap,writer,{pos:pos,end:pos},leadingComments),ts.emitComments(currentText,currentLineMap,writer,leadingComments,!0,newLine,writeComment)}}function emitDetachedCommentsAndUpdateCommentsInfo(node){var currentDetachedCommentInfo=ts.emitDetachedComments(currentText,currentLineMap,writer,writeComment,node,newLine,compilerOptions.removeComments);currentDetachedCommentInfo&&(detachedCommentsInfo?detachedCommentsInfo.push(currentDetachedCommentInfo):detachedCommentsInfo=[currentDetachedCommentInfo])}function writeComment(text,lineMap,writer,comment,newLine){emitPos(comment.pos),ts.writeCommentRange(text,lineMap,writer,comment,newLine),emitPos(comment.end)}function emitShebang(){var shebang=ts.getShebang(currentText);shebang&&(write(shebang),writeLine())}var currentSourceFile,currentText,currentLineMap,currentFileIdentifiers,renamedDependencies,isEs6Module,isCurrentFileExternalModule,exportFunctionForFile,contextObjectForFile,generatedNameSet,nodeToGeneratedName,computedPropertyNamesToGeneratedNames,decoratedClassAliases,convertedLoopState,extendsEmitted,decorateEmitted,paramEmitted,awaiterEmitted,tempVariables,tempParameters,externalImports,exportSpecifiers,exportEquals,hasExportStarsToExportValues,detachedCommentsInfo,sourceMapData,isOwnFileEmit,writer=ts.createTextWriter(newLine),write=writer.write,writeTextOfNode=writer.writeTextOfNode,writeLine=writer.writeLine,increaseIndent=writer.increaseIndent,decreaseIndent=writer.decreaseIndent,sourceMap=compilerOptions.sourceMap||compilerOptions.inlineSourceMap?ts.createSourceMapWriter(host,writer):ts.getNullSourceMapWriter(),setSourceFile=sourceMap.setSourceFile,emitStart=sourceMap.emitStart,emitEnd=sourceMap.emitEnd,emitPos=sourceMap.emitPos,tempFlags=0,emitLeadingCommentsOfPosition=compilerOptions.removeComments?function(pos){}:emitLeadingCommentsOfPositionWorker,setSourceMapWriterEmit=compilerOptions.sourceMap||compilerOptions.inlineSourceMap?changeSourceMapEmit:function(writer){},moduleEmitDelegates=(_a={},_a[5]=emitES6Module,_a[2]=emitAMDModule,_a[4]=emitSystemModule,_a[3]=emitUMDModule,_a[1]=emitCommonJSModule,_a),bundleEmitDelegates=(_b={},_b[5]=function(){},_b[2]=emitAMDModule,_b[4]=emitSystemModule,_b[3]=function(){},_b[1]=function(){},_b);return doEmit;var _a,_b}function emitFile(_a,sourceFiles,isBundledEmit){var jsFilePath=_a.jsFilePath,sourceMapFilePath=_a.sourceMapFilePath,declarationFilePath=_a.declarationFilePath;host.isEmitBlocked(jsFilePath)||compilerOptions.noEmit?emitSkipped=!0:emitJavaScript(jsFilePath,sourceMapFilePath,sourceFiles,isBundledEmit),declarationFilePath&&(emitSkipped=ts.writeDeclarationFile(declarationFilePath,sourceFiles,isBundledEmit,host,resolver,emitterDiagnostics)||emitSkipped)}var extendsHelper="\nvar __extends = (this && this.__extends) || function (d, b) {\n    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];\n    function __() { this.constructor = d; }\n    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());\n};",decorateHelper='\nvar __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {\n    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;\n    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);\n    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;\n    return c > 3 && r && Object.defineProperty(target, key, r), r;\n};',metadataHelper='\nvar __metadata = (this && this.__metadata) || function (k, v) {\n    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);\n};',paramHelper="\nvar __param = (this && this.__param) || function (paramIndex, decorator) {\n    return function (target, key) { decorator(target, key, paramIndex); }\n};",awaiterHelper="\nvar __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {\n    return new (P || (P = Promise))(function (resolve, reject) {\n        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }\n        function rejected(value) { try { step(generator.throw(value)); } catch (e) { reject(e); } }\n        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }\n        step((generator = generator.apply(thisArg, _arguments)).next());\n    });\n};",compilerOptions=host.getCompilerOptions(),languageVersion=ts.getEmitScriptTarget(compilerOptions),modulekind=ts.getEmitModuleKind(compilerOptions),sourceMapDataList=compilerOptions.sourceMap||compilerOptions.inlineSourceMap?[]:void 0,emitterDiagnostics=ts.createDiagnosticCollection(),emitSkipped=!1,newLine=host.getNewLine(),emitJavaScript=createFileEmitter();return ts.forEachExpectedEmitFile(host,emitFile,targetSourceFile),{emitSkipped:emitSkipped,diagnostics:emitterDiagnostics.getDiagnostics(),sourceMaps:sourceMapDataList}}ts.getResolvedExternalModuleName=getResolvedExternalModuleName,ts.getExternalModuleNameFromDeclaration=getExternalModuleNameFromDeclaration;var Jump;!function(Jump){Jump[Jump.Break=2]="Break",Jump[Jump.Continue=4]="Continue",Jump[Jump.Return=8]="Return"}(Jump||(Jump={}));var TempFlags,entities={quot:34,amp:38,apos:39,lt:60,gt:62,nbsp:160,iexcl:161,cent:162,pound:163,curren:164,yen:165,brvbar:166,sect:167,uml:168,copy:169,ordf:170,laquo:171,not:172,shy:173,reg:174,macr:175,deg:176,plusmn:177,sup2:178,sup3:179,acute:180,micro:181,para:182,middot:183,cedil:184,sup1:185,ordm:186,raquo:187,frac14:188,frac12:189,frac34:190,iquest:191,Agrave:192,Aacute:193,Acirc:194,Atilde:195,Auml:196,Aring:197,AElig:198,Ccedil:199,Egrave:200,Eacute:201,Ecirc:202,Euml:203,Igrave:204,Iacute:205,Icirc:206,Iuml:207,ETH:208,Ntilde:209,Ograve:210,Oacute:211,Ocirc:212,Otilde:213,Ouml:214,times:215,Oslash:216,Ugrave:217,Uacute:218,Ucirc:219,Uuml:220,Yacute:221,THORN:222,szlig:223,agrave:224,aacute:225,acirc:226,atilde:227,auml:228,aring:229,aelig:230,ccedil:231,egrave:232,eacute:233,ecirc:234,euml:235,igrave:236,iacute:237,icirc:238,iuml:239,eth:240,ntilde:241,ograve:242,oacute:243,ocirc:244,otilde:245,ouml:246,divide:247,oslash:248,ugrave:249,uacute:250,ucirc:251,uuml:252,yacute:253,thorn:254,yuml:255,OElig:338,oelig:339,Scaron:352,scaron:353,Yuml:376,fnof:402,circ:710,tilde:732,Alpha:913,Beta:914,Gamma:915,Delta:916,Epsilon:917,Zeta:918,Eta:919,Theta:920,Iota:921,Kappa:922,Lambda:923,Mu:924,Nu:925,Xi:926,Omicron:927,Pi:928,Rho:929,Sigma:931,Tau:932,Upsilon:933,Phi:934,Chi:935,Psi:936,Omega:937,alpha:945,beta:946,gamma:947,delta:948,epsilon:949,zeta:950,eta:951,theta:952,iota:953,kappa:954,lambda:955,mu:956,nu:957,xi:958,omicron:959,pi:960,rho:961,sigmaf:962,sigma:963,tau:964,upsilon:965,phi:966,chi:967,psi:968,omega:969,thetasym:977,upsih:978,piv:982,ensp:8194,emsp:8195,thinsp:8201,zwnj:8204,zwj:8205,lrm:8206,rlm:8207,ndash:8211,mdash:8212,lsquo:8216,rsquo:8217,sbquo:8218,ldquo:8220,rdquo:8221,bdquo:8222,dagger:8224,Dagger:8225,bull:8226,hellip:8230,permil:8240,prime:8242,Prime:8243,lsaquo:8249,rsaquo:8250,oline:8254,frasl:8260,euro:8364,image:8465,weierp:8472,real:8476,trade:8482,alefsym:8501,larr:8592,uarr:8593,rarr:8594,darr:8595,harr:8596,crarr:8629,lArr:8656,uArr:8657,rArr:8658,dArr:8659,hArr:8660,forall:8704,part:8706,exist:8707,empty:8709,nabla:8711,isin:8712,notin:8713,ni:8715,prod:8719,sum:8721,minus:8722,lowast:8727,radic:8730,prop:8733,infin:8734,ang:8736,and:8743,or:8744,cap:8745,cup:8746,int:8747,there4:8756,sim:8764,cong:8773,asymp:8776,ne:8800,equiv:8801,le:8804,ge:8805,sub:8834,sup:8835,nsub:8836,sube:8838,supe:8839,oplus:8853,otimes:8855,perp:8869,sdot:8901,lceil:8968,rceil:8969,lfloor:8970,rfloor:8971,lang:9001,rang:9002,loz:9674,spades:9824,clubs:9827,hearts:9829,diams:9830};!function(TempFlags){TempFlags[TempFlags.Auto=0]="Auto",TempFlags[TempFlags.CountMask=268435455]="CountMask",TempFlags[TempFlags._i=268435456]="_i"}(TempFlags||(TempFlags={}));var CopyDirection;!function(CopyDirection){CopyDirection[CopyDirection.ToOriginal=0]="ToOriginal",CopyDirection[CopyDirection.ToOutParameter=1]="ToOutParameter"}(CopyDirection||(CopyDirection={})),ts.emitFiles=emitFiles}(ts||(ts={}));var ts;!function(ts){function findConfigFile(searchPath,fileExists){for(var fileName="tsconfig.json";;){if(fileExists(fileName))return fileName;var parentPath=ts.getDirectoryPath(searchPath);if(parentPath===searchPath)break;searchPath=parentPath,fileName="../"+fileName}}function resolveTripleslashReference(moduleName,containingFile){var basePath=ts.getDirectoryPath(containingFile),referencedFileName=ts.isRootedDiskPath(moduleName)?moduleName:ts.combinePaths(basePath,moduleName);return ts.normalizePath(referencedFileName)}function resolveModuleName(moduleName,containingFile,compilerOptions,host){var moduleResolution=void 0!==compilerOptions.moduleResolution?compilerOptions.moduleResolution:1===ts.getEmitModuleKind(compilerOptions)?2:1;switch(moduleResolution){case 2:return nodeModuleNameResolver(moduleName,containingFile,compilerOptions,host);case 1:return classicNameResolver(moduleName,containingFile,compilerOptions,host)}}function nodeModuleNameResolver(moduleName,containingFile,compilerOptions,host){var containingDirectory=ts.getDirectoryPath(containingFile),supportedExtensions=ts.getSupportedExtensions(compilerOptions);if(0!==ts.getRootLength(moduleName)||nameStartsWithDotSlashOrDotDotSlash(moduleName)){var failedLookupLocations=[],candidate=ts.normalizePath(ts.combinePaths(containingDirectory,moduleName)),resolvedFileName=loadNodeModuleFromFile(supportedExtensions,candidate,failedLookupLocations,!1,host);return resolvedFileName?{resolvedModule:{resolvedFileName:resolvedFileName},failedLookupLocations:failedLookupLocations}:(resolvedFileName=loadNodeModuleFromDirectory(supportedExtensions,candidate,failedLookupLocations,!1,host),resolvedFileName?{resolvedModule:{resolvedFileName:resolvedFileName},failedLookupLocations:failedLookupLocations}:{resolvedModule:void 0,failedLookupLocations:failedLookupLocations})}return loadModuleFromNodeModules(moduleName,containingDirectory,host)}function directoryProbablyExists(directoryName,host){return!host.directoryExists||host.directoryExists(directoryName)}function loadNodeModuleFromFile(extensions,candidate,failedLookupLocation,onlyRecordFailures,host){function tryLoad(ext){var fileName=ts.fileExtensionIs(candidate,ext)?candidate:candidate+ext;return!onlyRecordFailures&&host.fileExists(fileName)?fileName:void failedLookupLocation.push(fileName)}return ts.forEach(extensions,tryLoad)}function loadNodeModuleFromDirectory(extensions,candidate,failedLookupLocation,onlyRecordFailures,host){var packageJsonPath=ts.combinePaths(candidate,"package.json"),directoryExists=!onlyRecordFailures&&directoryProbablyExists(candidate,host);if(directoryExists&&host.fileExists(packageJsonPath)){var jsonContent=void 0;try{var jsonText=host.readFile(packageJsonPath);jsonContent=jsonText?JSON.parse(jsonText):{typings:void 0}}catch(e){jsonContent={typings:void 0}}if("string"==typeof jsonContent.typings){var path=ts.normalizePath(ts.combinePaths(candidate,jsonContent.typings)),result=loadNodeModuleFromFile(extensions,path,failedLookupLocation,!directoryProbablyExists(ts.getDirectoryPath(path),host),host);if(result)return result}}else failedLookupLocation.push(packageJsonPath);return loadNodeModuleFromFile(extensions,ts.combinePaths(candidate,"index"),failedLookupLocation,!directoryExists,host)}function loadModuleFromNodeModules(moduleName,directory,host){var failedLookupLocations=[];for(directory=ts.normalizeSlashes(directory);;){var baseName=ts.getBaseFileName(directory);if("node_modules"!==baseName){var nodeModulesFolder=ts.combinePaths(directory,"node_modules"),nodeModulesFolderExists=directoryProbablyExists(nodeModulesFolder,host),candidate=ts.normalizePath(ts.combinePaths(nodeModulesFolder,moduleName)),result=loadNodeModuleFromFile(ts.supportedTypeScriptExtensions,candidate,failedLookupLocations,!nodeModulesFolderExists,host);if(result)return{resolvedModule:{resolvedFileName:result,isExternalLibraryImport:!0},failedLookupLocations:failedLookupLocations};if(result=loadNodeModuleFromDirectory(ts.supportedTypeScriptExtensions,candidate,failedLookupLocations,!nodeModulesFolderExists,host))return{resolvedModule:{resolvedFileName:result,isExternalLibraryImport:!0},failedLookupLocations:failedLookupLocations}}var parentPath=ts.getDirectoryPath(directory);if(parentPath===directory)break;directory=parentPath}return{resolvedModule:void 0,failedLookupLocations:failedLookupLocations}}function nameStartsWithDotSlashOrDotDotSlash(name){var i=name.lastIndexOf("./",1);return 0===i||1===i&&46===name.charCodeAt(0)}function classicNameResolver(moduleName,containingFile,compilerOptions,host){if(moduleName.indexOf("!")!=-1)return{resolvedModule:void 0,failedLookupLocations:[]};for(var searchName,referencedSourceFile,searchPath=ts.getDirectoryPath(containingFile),failedLookupLocations=[],supportedExtensions=ts.getSupportedExtensions(compilerOptions);;){if(searchName=ts.normalizePath(ts.combinePaths(searchPath,moduleName)),referencedSourceFile=ts.forEach(supportedExtensions,function(extension){if(".tsx"!==extension||compilerOptions.jsx){var candidate=searchName+extension;return host.fileExists(candidate)?candidate:void failedLookupLocations.push(candidate)}}))break;var parentPath=ts.getDirectoryPath(searchPath);if(parentPath===searchPath)break;searchPath=parentPath}return referencedSourceFile?{resolvedModule:{resolvedFileName:referencedSourceFile},failedLookupLocations:failedLookupLocations}:{resolvedModule:void 0,failedLookupLocations:failedLookupLocations}}function createCompilerHost(options,setParentNodes){function getCanonicalFileName(fileName){return ts.sys.useCaseSensitiveFileNames?fileName:fileName.toLowerCase()}function getSourceFile(fileName,languageVersion,onError){var text;try{var start=(new Date).getTime();text=ts.sys.readFile(fileName,options.charset),ts.ioReadTime+=(new Date).getTime()-start}catch(e){onError&&onError(e.number===unsupportedFileEncodingErrorCode?ts.createCompilerDiagnostic(ts.Diagnostics.Unsupported_file_encoding).messageText:e.message),text=""}return void 0!==text?ts.createSourceFile(fileName,text,languageVersion,setParentNodes):void 0}function directoryExists(directoryPath){return!!ts.hasProperty(existingDirectories,directoryPath)||!!ts.sys.directoryExists(directoryPath)&&(existingDirectories[directoryPath]=!0,!0)}function ensureDirectoriesExist(directoryPath){if(directoryPath.length>ts.getRootLength(directoryPath)&&!directoryExists(directoryPath)){var parentDirectory=ts.getDirectoryPath(directoryPath);ensureDirectoriesExist(parentDirectory),ts.sys.createDirectory(directoryPath)}}function writeFile(fileName,data,writeByteOrderMark,onError){try{var start=(new Date).getTime();ensureDirectoriesExist(ts.getDirectoryPath(ts.normalizePath(fileName))),ts.sys.writeFile(fileName,data,writeByteOrderMark),ts.ioWriteTime+=(new Date).getTime()-start}catch(e){onError&&onError(e.message)}}var existingDirectories={},unsupportedFileEncodingErrorCode=-2147024809,newLine=ts.getNewLineCharacter(options);return{getSourceFile:getSourceFile,getDefaultLibFileName:function(options){return ts.combinePaths(ts.getDirectoryPath(ts.normalizePath(ts.sys.getExecutingFilePath())),ts.getDefaultLibFileName(options))},writeFile:writeFile,getCurrentDirectory:ts.memoize(function(){return ts.sys.getCurrentDirectory()}),useCaseSensitiveFileNames:function(){return ts.sys.useCaseSensitiveFileNames},getCanonicalFileName:getCanonicalFileName,getNewLine:function(){return newLine},fileExists:function(fileName){return ts.sys.fileExists(fileName)},readFile:function(fileName){return ts.sys.readFile(fileName)},directoryExists:function(directoryName){return ts.sys.directoryExists(directoryName)}}}function getPreEmitDiagnostics(program,sourceFile,cancellationToken){var diagnostics=program.getOptionsDiagnostics(cancellationToken).concat(program.getSyntacticDiagnostics(sourceFile,cancellationToken),program.getGlobalDiagnostics(cancellationToken),program.getSemanticDiagnostics(sourceFile,cancellationToken));return program.getCompilerOptions().declaration&&(diagnostics=diagnostics.concat(program.getDeclarationDiagnostics(sourceFile,cancellationToken))),ts.sortAndDeduplicateDiagnostics(diagnostics)}function flattenDiagnosticMessageText(messageText,newLine){if("string"==typeof messageText)return messageText;for(var diagnosticChain=messageText,result="",indent=0;diagnosticChain;){if(indent){result+=newLine;for(var i=0;i<indent;i++)result+="  "}result+=diagnosticChain.messageText,indent++,diagnosticChain=diagnosticChain.next}return result}function createProgram(rootNames,options,host,oldProgram){function getCommonSourceDirectory(){return"undefined"==typeof commonSourceDirectory&&(commonSourceDirectory=options.rootDir&&checkSourceFilesBelongToPath(files,options.rootDir)?ts.getNormalizedAbsolutePath(options.rootDir,currentDirectory):computeCommonSourceDirectory(files),
commonSourceDirectory&&commonSourceDirectory[commonSourceDirectory.length-1]!==ts.directorySeparator&&(commonSourceDirectory+=ts.directorySeparator)),commonSourceDirectory}function getClassifiableNames(){if(!classifiableNames){getTypeChecker(),classifiableNames={};for(var _i=0,files_3=files;_i<files_3.length;_i++){var sourceFile=files_3[_i];ts.copyMap(sourceFile.classifiableNames,classifiableNames)}}return classifiableNames}function tryReuseStructureFromOldProgram(){if(!oldProgram)return!1;ts.Debug.assert(!oldProgram.structureIsReused);var oldRootNames=oldProgram.getRootFileNames();if(!ts.arrayIsEqualTo(oldRootNames,rootNames))return!1;for(var newSourceFiles=[],filePaths=[],modifiedSourceFiles=[],_i=0,_a=oldProgram.getSourceFiles();_i<_a.length;_i++){var oldSourceFile=_a[_i],newSourceFile=host.getSourceFile(oldSourceFile.fileName,options.target);if(!newSourceFile)return!1;if(newSourceFile.path=oldSourceFile.path,filePaths.push(newSourceFile.path),oldSourceFile!==newSourceFile){if(oldSourceFile.hasNoDefaultLib!==newSourceFile.hasNoDefaultLib)return!1;if(!ts.arrayIsEqualTo(oldSourceFile.referencedFiles,newSourceFile.referencedFiles,fileReferenceIsEqualTo))return!1;if(collectExternalModuleReferences(newSourceFile),!ts.arrayIsEqualTo(oldSourceFile.imports,newSourceFile.imports,moduleNameIsEqualTo))return!1;if(!ts.arrayIsEqualTo(oldSourceFile.moduleAugmentations,newSourceFile.moduleAugmentations,moduleNameIsEqualTo))return!1;if(resolveModuleNamesWorker)for(var moduleNames=ts.map(ts.concatenate(newSourceFile.imports,newSourceFile.moduleAugmentations),getTextOfLiteral),resolutions=resolveModuleNamesWorker(moduleNames,ts.getNormalizedAbsolutePath(newSourceFile.fileName,currentDirectory)),i=0;i<moduleNames.length;i++){var newResolution=resolutions[i],oldResolution=ts.getResolvedModule(oldSourceFile,moduleNames[i]),resolutionChanged=oldResolution?!newResolution||oldResolution.resolvedFileName!==newResolution.resolvedFileName||!!oldResolution.isExternalLibraryImport!=!!newResolution.isExternalLibraryImport:newResolution;if(resolutionChanged)return!1}newSourceFile.resolvedModules=oldSourceFile.resolvedModules,modifiedSourceFiles.push(newSourceFile)}else newSourceFile=oldSourceFile;newSourceFiles.push(newSourceFile)}for(var i=0,len=newSourceFiles.length;i<len;i++)filesByName.set(filePaths[i],newSourceFiles[i]);files=newSourceFiles,fileProcessingDiagnostics=oldProgram.getFileProcessingDiagnostics();for(var _b=0,modifiedSourceFiles_1=modifiedSourceFiles;_b<modifiedSourceFiles_1.length;_b++){var modifiedFile=modifiedSourceFiles_1[_b];fileProcessingDiagnostics.reattachFileDiagnostics(modifiedFile)}return oldProgram.structureIsReused=!0,!0}function getEmitHost(writeFileCallback){return{getCanonicalFileName:getCanonicalFileName,getCommonSourceDirectory:program.getCommonSourceDirectory,getCompilerOptions:program.getCompilerOptions,getCurrentDirectory:function(){return currentDirectory},getNewLine:function(){return host.getNewLine()},getSourceFile:program.getSourceFile,getSourceFiles:program.getSourceFiles,writeFile:writeFileCallback||function(fileName,data,writeByteOrderMark,onError){return host.writeFile(fileName,data,writeByteOrderMark,onError)},isEmitBlocked:isEmitBlocked}}function getDiagnosticsProducingTypeChecker(){return diagnosticsProducingTypeChecker||(diagnosticsProducingTypeChecker=ts.createTypeChecker(program,!0))}function getTypeChecker(){return noDiagnosticsTypeChecker||(noDiagnosticsTypeChecker=ts.createTypeChecker(program,!1))}function emit(sourceFile,writeFileCallback,cancellationToken){var _this=this;return runWithCancellationToken(function(){return emitWorker(_this,sourceFile,writeFileCallback,cancellationToken)})}function isEmitBlocked(emitFileName){return hasEmitBlockingDiagnostics.contains(ts.toPath(emitFileName,currentDirectory,getCanonicalFileName))}function emitWorker(program,sourceFile,writeFileCallback,cancellationToken){if(options.noEmitOnError){var diagnostics=program.getOptionsDiagnostics(cancellationToken).concat(program.getSyntacticDiagnostics(sourceFile,cancellationToken),program.getGlobalDiagnostics(cancellationToken),program.getSemanticDiagnostics(sourceFile,cancellationToken)),declarationDiagnostics=[];if(0===diagnostics.length&&program.getCompilerOptions().declaration&&(declarationDiagnostics=program.getDeclarationDiagnostics(void 0,cancellationToken)),diagnostics.length>0||declarationDiagnostics.length>0)return{diagnostics:declarationDiagnostics,sourceMaps:void 0,emitSkipped:!0}}var emitResolver=getDiagnosticsProducingTypeChecker().getEmitResolver(options.outFile||options.out?void 0:sourceFile),start=(new Date).getTime(),emitResult=ts.emitFiles(emitResolver,getEmitHost(writeFileCallback),sourceFile);return ts.emitTime+=(new Date).getTime()-start,emitResult}function getSourceFile(fileName){return filesByName.get(ts.toPath(fileName,currentDirectory,getCanonicalFileName))}function getDiagnosticsHelper(sourceFile,getDiagnostics,cancellationToken){if(sourceFile)return getDiagnostics(sourceFile,cancellationToken);var allDiagnostics=[];return ts.forEach(program.getSourceFiles(),function(sourceFile){cancellationToken&&cancellationToken.throwIfCancellationRequested(),ts.addRange(allDiagnostics,getDiagnostics(sourceFile,cancellationToken))}),ts.sortAndDeduplicateDiagnostics(allDiagnostics)}function getSyntacticDiagnostics(sourceFile,cancellationToken){return getDiagnosticsHelper(sourceFile,getSyntacticDiagnosticsForFile,cancellationToken)}function getSemanticDiagnostics(sourceFile,cancellationToken){return getDiagnosticsHelper(sourceFile,getSemanticDiagnosticsForFile,cancellationToken)}function getDeclarationDiagnostics(sourceFile,cancellationToken){var options=program.getCompilerOptions();return!sourceFile||options.out||options.outFile?getDeclarationDiagnosticsWorker(sourceFile,cancellationToken):getDiagnosticsHelper(sourceFile,getDeclarationDiagnosticsForFile,cancellationToken)}function getSyntacticDiagnosticsForFile(sourceFile,cancellationToken){return sourceFile.parseDiagnostics}function runWithCancellationToken(func){try{return func()}catch(e){throw e instanceof ts.OperationCanceledException&&(noDiagnosticsTypeChecker=void 0,diagnosticsProducingTypeChecker=void 0),e}}function getSemanticDiagnosticsForFile(sourceFile,cancellationToken){return runWithCancellationToken(function(){var typeChecker=getDiagnosticsProducingTypeChecker();ts.Debug.assert(!!sourceFile.bindDiagnostics);var bindDiagnostics=sourceFile.bindDiagnostics,checkDiagnostics=ts.isSourceFileJavaScript(sourceFile)?getJavaScriptSemanticDiagnosticsForFile(sourceFile,cancellationToken):typeChecker.getDiagnostics(sourceFile,cancellationToken),fileProcessingDiagnosticsInFile=fileProcessingDiagnostics.getDiagnostics(sourceFile.fileName),programDiagnosticsInFile=programDiagnostics.getDiagnostics(sourceFile.fileName);return bindDiagnostics.concat(checkDiagnostics).concat(fileProcessingDiagnosticsInFile).concat(programDiagnosticsInFile)})}function getJavaScriptSemanticDiagnosticsForFile(sourceFile,cancellationToken){return runWithCancellationToken(function(){function walk(node){if(!node)return!1;switch(node.kind){case 224:return diagnostics.push(ts.createDiagnosticForNode(node,ts.Diagnostics.import_can_only_be_used_in_a_ts_file)),!0;case 230:if(node.isExportEquals)return diagnostics.push(ts.createDiagnosticForNode(node,ts.Diagnostics.export_can_only_be_used_in_a_ts_file)),!0;break;case 217:var classDeclaration=node;if(checkModifiers(classDeclaration.modifiers)||checkTypeParameters(classDeclaration.typeParameters))return!0;break;case 246:var heritageClause=node;if(106===heritageClause.token)return diagnostics.push(ts.createDiagnosticForNode(node,ts.Diagnostics.implements_clauses_can_only_be_used_in_a_ts_file)),!0;break;case 218:return diagnostics.push(ts.createDiagnosticForNode(node,ts.Diagnostics.interface_declarations_can_only_be_used_in_a_ts_file)),!0;case 221:return diagnostics.push(ts.createDiagnosticForNode(node,ts.Diagnostics.module_declarations_can_only_be_used_in_a_ts_file)),!0;case 219:return diagnostics.push(ts.createDiagnosticForNode(node,ts.Diagnostics.type_aliases_can_only_be_used_in_a_ts_file)),!0;case 144:case 143:case 145:case 146:case 147:case 176:case 216:case 177:case 216:var functionDeclaration=node;if(checkModifiers(functionDeclaration.modifiers)||checkTypeParameters(functionDeclaration.typeParameters)||checkTypeAnnotation(functionDeclaration.type))return!0;break;case 196:var variableStatement=node;if(checkModifiers(variableStatement.modifiers))return!0;break;case 214:var variableDeclaration=node;if(checkTypeAnnotation(variableDeclaration.type))return!0;break;case 171:case 172:var expression=node;if(expression.typeArguments&&expression.typeArguments.length>0){var start_2=expression.typeArguments.pos;return diagnostics.push(ts.createFileDiagnostic(sourceFile,start_2,expression.typeArguments.end-start_2,ts.Diagnostics.type_arguments_can_only_be_used_in_a_ts_file)),!0}break;case 139:var parameter=node;if(parameter.modifiers){var start_3=parameter.modifiers.pos;return diagnostics.push(ts.createFileDiagnostic(sourceFile,start_3,parameter.modifiers.end-start_3,ts.Diagnostics.parameter_modifiers_can_only_be_used_in_a_ts_file)),!0}if(parameter.questionToken)return diagnostics.push(ts.createDiagnosticForNode(parameter.questionToken,ts.Diagnostics._0_can_only_be_used_in_a_ts_file,"?")),!0;if(parameter.type)return diagnostics.push(ts.createDiagnosticForNode(parameter.type,ts.Diagnostics.types_can_only_be_used_in_a_ts_file)),!0;break;case 142:return diagnostics.push(ts.createDiagnosticForNode(node,ts.Diagnostics.property_declarations_can_only_be_used_in_a_ts_file)),!0;case 220:return diagnostics.push(ts.createDiagnosticForNode(node,ts.Diagnostics.enum_declarations_can_only_be_used_in_a_ts_file)),!0;case 174:var typeAssertionExpression=node;return diagnostics.push(ts.createDiagnosticForNode(typeAssertionExpression.type,ts.Diagnostics.type_assertion_expressions_can_only_be_used_in_a_ts_file)),!0;case 140:return options.experimentalDecorators||diagnostics.push(ts.createDiagnosticForNode(node,ts.Diagnostics.Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_the_experimentalDecorators_option_to_remove_this_warning)),!0}return ts.forEachChild(node,walk)}function checkTypeParameters(typeParameters){if(typeParameters){var start_4=typeParameters.pos;return diagnostics.push(ts.createFileDiagnostic(sourceFile,start_4,typeParameters.end-start_4,ts.Diagnostics.type_parameter_declarations_can_only_be_used_in_a_ts_file)),!0}return!1}function checkTypeAnnotation(type){return!!type&&(diagnostics.push(ts.createDiagnosticForNode(type,ts.Diagnostics.types_can_only_be_used_in_a_ts_file)),!0)}function checkModifiers(modifiers){if(modifiers)for(var _i=0,modifiers_1=modifiers;_i<modifiers_1.length;_i++){var modifier=modifiers_1[_i];switch(modifier.kind){case 112:case 110:case 111:case 122:return diagnostics.push(ts.createDiagnosticForNode(modifier,ts.Diagnostics._0_can_only_be_used_in_a_ts_file,ts.tokenToString(modifier.kind))),!0;case 113:case 82:case 74:case 77:case 115:}}return!1}var diagnostics=[];return walk(sourceFile),diagnostics})}function getDeclarationDiagnosticsWorker(sourceFile,cancellationToken){return runWithCancellationToken(function(){var resolver=getDiagnosticsProducingTypeChecker().getEmitResolver(sourceFile,cancellationToken),writeFile=function(){};return ts.getDeclarationDiagnostics(getEmitHost(writeFile),resolver,sourceFile)})}function getDeclarationDiagnosticsForFile(sourceFile,cancellationToken){return ts.isDeclarationFile(sourceFile)?[]:getDeclarationDiagnosticsWorker(sourceFile,cancellationToken)}function getOptionsDiagnostics(){var allDiagnostics=[];return ts.addRange(allDiagnostics,fileProcessingDiagnostics.getGlobalDiagnostics()),ts.addRange(allDiagnostics,programDiagnostics.getGlobalDiagnostics()),ts.sortAndDeduplicateDiagnostics(allDiagnostics)}function getGlobalDiagnostics(){var allDiagnostics=[];return ts.addRange(allDiagnostics,getDiagnosticsProducingTypeChecker().getGlobalDiagnostics()),ts.sortAndDeduplicateDiagnostics(allDiagnostics)}function hasExtension(fileName){return ts.getBaseFileName(fileName).indexOf(".")>=0}function processRootFile(fileName,isDefaultLib){processSourceFile(ts.normalizePath(fileName),isDefaultLib)}function fileReferenceIsEqualTo(a,b){return a.fileName===b.fileName}function moduleNameIsEqualTo(a,b){return a.text===b.text}function getTextOfLiteral(literal){return literal.text}function collectExternalModuleReferences(file){function collectModuleReferences(node,inAmbientModule){switch(node.kind){case 225:case 224:case 231:var moduleNameExpr=ts.getExternalModuleName(node);if(!moduleNameExpr||9!==moduleNameExpr.kind)break;if(!moduleNameExpr.text)break;inAmbientModule&&ts.isExternalModuleNameRelative(moduleNameExpr.text)||(imports||(imports=[])).push(moduleNameExpr);break;case 221:if(ts.isAmbientModule(node)&&(inAmbientModule||4&node.flags||ts.isDeclarationFile(file))){var moduleName=node.name;if(isExternalModuleFile||inAmbientModule&&!ts.isExternalModuleNameRelative(moduleName.text))(moduleAugmentations||(moduleAugmentations=[])).push(moduleName);else if(!inAmbientModule)for(var _i=0,_a=node.body.statements;_i<_a.length;_i++){var statement=_a[_i];collectModuleReferences(statement,!0)}}}}function collectRequireCalls(node){ts.isRequireCall(node,!0)?(imports||(imports=[])).push(node.arguments[0]):ts.forEachChild(node,collectRequireCalls)}if(!file.imports){for(var imports,moduleAugmentations,isJavaScriptFile=ts.isSourceFileJavaScript(file),isExternalModuleFile=ts.isExternalModule(file),_i=0,_a=file.statements;_i<_a.length;_i++){var node=_a[_i];collectModuleReferences(node,!1),isJavaScriptFile&&collectRequireCalls(node)}file.imports=imports||emptyArray,file.moduleAugmentations=moduleAugmentations||emptyArray}}function processSourceFile(fileName,isDefaultLib,refFile,refPos,refEnd){var diagnosticArgument,diagnostic;if(hasExtension(fileName))options.allowNonTsExtensions||ts.forEach(supportedExtensions,function(extension){return ts.fileExtensionIs(host.getCanonicalFileName(fileName),extension)})?findSourceFile(fileName,ts.toPath(fileName,currentDirectory,getCanonicalFileName),isDefaultLib,refFile,refPos,refEnd)?refFile&&host.getCanonicalFileName(fileName)===host.getCanonicalFileName(refFile.fileName)&&(diagnostic=ts.Diagnostics.A_file_cannot_have_a_reference_to_itself,diagnosticArgument=[fileName]):(diagnostic=ts.Diagnostics.File_0_not_found,diagnosticArgument=[fileName]):(diagnostic=ts.Diagnostics.File_0_has_unsupported_extension_The_only_supported_extensions_are_1,diagnosticArgument=[fileName,"'"+supportedExtensions.join("', '")+"'"]);else{var nonTsFile=options.allowNonTsExtensions&&findSourceFile(fileName,ts.toPath(fileName,currentDirectory,getCanonicalFileName),isDefaultLib,refFile,refPos,refEnd);nonTsFile||(options.allowNonTsExtensions?(diagnostic=ts.Diagnostics.File_0_not_found,diagnosticArgument=[fileName]):ts.forEach(supportedExtensions,function(extension){return findSourceFile(fileName+extension,ts.toPath(fileName+extension,currentDirectory,getCanonicalFileName),isDefaultLib,refFile,refPos,refEnd)})||(diagnostic=ts.Diagnostics.File_0_not_found,fileName+=".ts",diagnosticArgument=[fileName]))}diagnostic&&(void 0!==refFile&&void 0!==refEnd&&void 0!==refPos?fileProcessingDiagnostics.add(ts.createFileDiagnostic.apply(void 0,[refFile,refPos,refEnd-refPos,diagnostic].concat(diagnosticArgument))):fileProcessingDiagnostics.add(ts.createCompilerDiagnostic.apply(void 0,[diagnostic].concat(diagnosticArgument))))}function reportFileNamesDifferOnlyInCasingError(fileName,existingFileName,refFile,refPos,refEnd){void 0!==refFile&&void 0!==refPos&&void 0!==refEnd?fileProcessingDiagnostics.add(ts.createFileDiagnostic(refFile,refPos,refEnd-refPos,ts.Diagnostics.File_name_0_differs_from_already_included_file_name_1_only_in_casing,fileName,existingFileName)):fileProcessingDiagnostics.add(ts.createCompilerDiagnostic(ts.Diagnostics.File_name_0_differs_from_already_included_file_name_1_only_in_casing,fileName,existingFileName))}function findSourceFile(fileName,path,isDefaultLib,refFile,refPos,refEnd){if(filesByName.contains(path)){var file_1=filesByName.get(path);return file_1&&options.forceConsistentCasingInFileNames&&ts.getNormalizedAbsolutePath(file_1.fileName,currentDirectory)!==ts.getNormalizedAbsolutePath(fileName,currentDirectory)&&reportFileNamesDifferOnlyInCasingError(fileName,file_1.fileName,refFile,refPos,refEnd),file_1}var file=host.getSourceFile(fileName,options.target,function(hostErrorMessage){void 0!==refFile&&void 0!==refPos&&void 0!==refEnd?fileProcessingDiagnostics.add(ts.createFileDiagnostic(refFile,refPos,refEnd-refPos,ts.Diagnostics.Cannot_read_file_0_Colon_1,fileName,hostErrorMessage)):fileProcessingDiagnostics.add(ts.createCompilerDiagnostic(ts.Diagnostics.Cannot_read_file_0_Colon_1,fileName,hostErrorMessage))});if(filesByName.set(path,file),file){if(file.path=path,host.useCaseSensitiveFileNames()){var existingFile=filesByNameIgnoreCase.get(path);existingFile?reportFileNamesDifferOnlyInCasingError(fileName,existingFile.fileName,refFile,refPos,refEnd):filesByNameIgnoreCase.set(path,file)}skipDefaultLib=skipDefaultLib||file.hasNoDefaultLib;var basePath=ts.getDirectoryPath(fileName);options.noResolve||processReferencedFiles(file,basePath),processImportedModules(file,basePath),isDefaultLib?files.unshift(file):files.push(file)}return file}function processReferencedFiles(file,basePath){ts.forEach(file.referencedFiles,function(ref){var referencedFileName=resolveTripleslashReference(ref.fileName,file.fileName);processSourceFile(referencedFileName,!1,file,ref.pos,ref.end)})}function getCanonicalFileName(fileName){return host.getCanonicalFileName(fileName)}function processImportedModules(file,basePath){if(collectExternalModuleReferences(file),file.imports.length||file.moduleAugmentations.length){file.resolvedModules={};for(var moduleNames=ts.map(ts.concatenate(file.imports,file.moduleAugmentations),getTextOfLiteral),resolutions=resolveModuleNamesWorker(moduleNames,ts.getNormalizedAbsolutePath(file.fileName,currentDirectory)),i=0;i<moduleNames.length;i++){var resolution=resolutions[i];ts.setResolvedModule(file,moduleNames[i],resolution);var shouldAddFile=resolution&&!options.noResolve&&i<file.imports.length;if(shouldAddFile){var importedFile=findSourceFile(resolution.resolvedFileName,ts.toPath(resolution.resolvedFileName,currentDirectory,getCanonicalFileName),!1,file,ts.skipTrivia(file.text,file.imports[i].pos),file.imports[i].end);if(importedFile&&resolution.isExternalLibraryImport)if(!ts.isExternalModule(importedFile)&&importedFile.statements.length){var start_5=ts.getTokenPosOfNode(file.imports[i],file);fileProcessingDiagnostics.add(ts.createFileDiagnostic(file,start_5,file.imports[i].end-start_5,ts.Diagnostics.Exported_external_package_typings_file_0_is_not_a_module_Please_contact_the_package_author_to_update_the_package_definition,importedFile.fileName))}else if(importedFile.referencedFiles.length){var firstRef=importedFile.referencedFiles[0];fileProcessingDiagnostics.add(ts.createFileDiagnostic(importedFile,firstRef.pos,firstRef.end-firstRef.pos,ts.Diagnostics.Exported_external_package_typings_file_cannot_contain_tripleslash_references_Please_contact_the_package_author_to_update_the_package_definition))}}}}else file.resolvedModules=void 0}function computeCommonSourceDirectory(sourceFiles){var commonPathComponents,failed=ts.forEach(files,function(sourceFile){if(!ts.isDeclarationFile(sourceFile)){var sourcePathComponents=ts.getNormalizedPathComponents(sourceFile.fileName,currentDirectory);if(sourcePathComponents.pop(),!commonPathComponents)return void(commonPathComponents=sourcePathComponents);for(var i=0,n=Math.min(commonPathComponents.length,sourcePathComponents.length);i<n;i++)if(getCanonicalFileName(commonPathComponents[i])!==getCanonicalFileName(sourcePathComponents[i])){if(0===i)return!0;commonPathComponents.length=i;break}sourcePathComponents.length<commonPathComponents.length&&(commonPathComponents.length=sourcePathComponents.length)}});return failed?"":commonPathComponents?ts.getNormalizedPathFromPathComponents(commonPathComponents):currentDirectory}function checkSourceFilesBelongToPath(sourceFiles,rootDirectory){var allFilesBelongToPath=!0;if(sourceFiles)for(var absoluteRootDirectoryPath=host.getCanonicalFileName(ts.getNormalizedAbsolutePath(rootDirectory,currentDirectory)),_i=0,sourceFiles_2=sourceFiles;_i<sourceFiles_2.length;_i++){var sourceFile=sourceFiles_2[_i];if(!ts.isDeclarationFile(sourceFile)){var absoluteSourceFilePath=host.getCanonicalFileName(ts.getNormalizedAbsolutePath(sourceFile.fileName,currentDirectory));0!==absoluteSourceFilePath.indexOf(absoluteRootDirectoryPath)&&(programDiagnostics.add(ts.createCompilerDiagnostic(ts.Diagnostics.File_0_is_not_under_rootDir_1_rootDir_is_expected_to_contain_all_source_files,sourceFile.fileName,options.rootDir)),allFilesBelongToPath=!1)}}return allFilesBelongToPath}function verifyCompilerOptions(){function verifyEmitFilePath(emitFileName,emitFilesSeen){if(emitFileName){var emitFilePath=ts.toPath(emitFileName,currentDirectory,getCanonicalFileName);filesByName.contains(emitFilePath)&&createEmitBlockingDiagnostics(emitFileName,emitFilePath,ts.Diagnostics.Cannot_write_file_0_because_it_would_overwrite_input_file),emitFilesSeen.contains(emitFilePath)?createEmitBlockingDiagnostics(emitFileName,emitFilePath,ts.Diagnostics.Cannot_write_file_0_because_it_would_be_overwritten_by_multiple_input_files):emitFilesSeen.set(emitFilePath,!0)}}options.isolatedModules&&(options.declaration&&programDiagnostics.add(ts.createCompilerDiagnostic(ts.Diagnostics.Option_0_cannot_be_specified_with_option_1,"declaration","isolatedModules")),options.noEmitOnError&&programDiagnostics.add(ts.createCompilerDiagnostic(ts.Diagnostics.Option_0_cannot_be_specified_with_option_1,"noEmitOnError","isolatedModules")),options.out&&programDiagnostics.add(ts.createCompilerDiagnostic(ts.Diagnostics.Option_0_cannot_be_specified_with_option_1,"out","isolatedModules")),options.outFile&&programDiagnostics.add(ts.createCompilerDiagnostic(ts.Diagnostics.Option_0_cannot_be_specified_with_option_1,"outFile","isolatedModules"))),options.inlineSourceMap&&(options.sourceMap&&programDiagnostics.add(ts.createCompilerDiagnostic(ts.Diagnostics.Option_0_cannot_be_specified_with_option_1,"sourceMap","inlineSourceMap")),options.mapRoot&&programDiagnostics.add(ts.createCompilerDiagnostic(ts.Diagnostics.Option_0_cannot_be_specified_with_option_1,"mapRoot","inlineSourceMap"))),options.inlineSources&&(options.sourceMap||options.inlineSourceMap||programDiagnostics.add(ts.createCompilerDiagnostic(ts.Diagnostics.Option_inlineSources_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided)),options.sourceRoot&&programDiagnostics.add(ts.createCompilerDiagnostic(ts.Diagnostics.Option_0_cannot_be_specified_with_option_1,"sourceRoot","inlineSources"))),options.out&&options.outFile&&programDiagnostics.add(ts.createCompilerDiagnostic(ts.Diagnostics.Option_0_cannot_be_specified_with_option_1,"out","outFile")),options.sourceMap||!options.mapRoot&&!options.sourceRoot||(options.mapRoot&&programDiagnostics.add(ts.createCompilerDiagnostic(ts.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1,"mapRoot","sourceMap")),options.sourceRoot&&!options.inlineSourceMap&&programDiagnostics.add(ts.createCompilerDiagnostic(ts.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1,"sourceRoot","sourceMap")));var languageVersion=options.target||0,outFile=options.outFile||options.out,firstExternalModuleSourceFile=ts.forEach(files,function(f){return ts.isExternalModule(f)?f:void 0});if(options.isolatedModules){0===options.module&&languageVersion<2&&programDiagnostics.add(ts.createCompilerDiagnostic(ts.Diagnostics.Option_isolatedModules_can_only_be_used_when_either_option_module_is_provided_or_option_target_is_ES2015_or_higher));var firstNonExternalModuleSourceFile=ts.forEach(files,function(f){return ts.isExternalModule(f)||ts.isDeclarationFile(f)?void 0:f});if(firstNonExternalModuleSourceFile){var span=ts.getErrorSpanForNode(firstNonExternalModuleSourceFile,firstNonExternalModuleSourceFile);programDiagnostics.add(ts.createFileDiagnostic(firstNonExternalModuleSourceFile,span.start,span.length,ts.Diagnostics.Cannot_compile_namespaces_when_the_isolatedModules_flag_is_provided))}}else if(firstExternalModuleSourceFile&&languageVersion<2&&0===options.module){var span=ts.getErrorSpanForNode(firstExternalModuleSourceFile,firstExternalModuleSourceFile.externalModuleIndicator);programDiagnostics.add(ts.createFileDiagnostic(firstExternalModuleSourceFile,span.start,span.length,ts.Diagnostics.Cannot_compile_modules_unless_the_module_flag_is_provided_with_a_valid_module_type_Consider_setting_the_module_compiler_option_in_a_tsconfig_json_file))}if(5===options.module&&languageVersion<2&&programDiagnostics.add(ts.createCompilerDiagnostic(ts.Diagnostics.Cannot_compile_modules_into_es2015_when_targeting_ES5_or_lower)),outFile&&options.module&&2!==options.module&&4!==options.module&&programDiagnostics.add(ts.createCompilerDiagnostic(ts.Diagnostics.Only_amd_and_system_modules_are_supported_alongside_0,options.out?"out":"outFile")),options.outDir||options.sourceRoot||options.mapRoot){var dir=getCommonSourceDirectory();options.outDir&&""===dir&&ts.forEach(files,function(file){return ts.getRootLength(file.fileName)>1})&&programDiagnostics.add(ts.createCompilerDiagnostic(ts.Diagnostics.Cannot_find_the_common_subdirectory_path_for_the_input_files))}if(options.noEmit?(options.out&&programDiagnostics.add(ts.createCompilerDiagnostic(ts.Diagnostics.Option_0_cannot_be_specified_with_option_1,"noEmit","out")),options.outFile&&programDiagnostics.add(ts.createCompilerDiagnostic(ts.Diagnostics.Option_0_cannot_be_specified_with_option_1,"noEmit","outFile")),options.outDir&&programDiagnostics.add(ts.createCompilerDiagnostic(ts.Diagnostics.Option_0_cannot_be_specified_with_option_1,"noEmit","outDir")),options.declaration&&programDiagnostics.add(ts.createCompilerDiagnostic(ts.Diagnostics.Option_0_cannot_be_specified_with_option_1,"noEmit","declaration"))):options.allowJs&&options.declaration&&programDiagnostics.add(ts.createCompilerDiagnostic(ts.Diagnostics.Option_0_cannot_be_specified_with_option_1,"allowJs","declaration")),options.emitDecoratorMetadata&&!options.experimentalDecorators&&programDiagnostics.add(ts.createCompilerDiagnostic(ts.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1,"emitDecoratorMetadata","experimentalDecorators")),options.reactNamespace&&!ts.isIdentifier(options.reactNamespace,languageVersion)&&programDiagnostics.add(ts.createCompilerDiagnostic(ts.Diagnostics.Invalide_value_for_reactNamespace_0_is_not_a_valid_identifier,options.reactNamespace)),!options.noEmit&&!options.suppressOutputPathCheck){var emitHost=getEmitHost(),emitFilesSeen_1=ts.createFileMap(host.useCaseSensitiveFileNames()?void 0:function(key){return key.toLocaleLowerCase()});ts.forEachExpectedEmitFile(emitHost,function(emitFileNames,sourceFiles,isBundledEmit){verifyEmitFilePath(emitFileNames.jsFilePath,emitFilesSeen_1),verifyEmitFilePath(emitFileNames.declarationFilePath,emitFilesSeen_1)})}}function createEmitBlockingDiagnostics(emitFileName,emitFilePath,message){hasEmitBlockingDiagnostics.set(ts.toPath(emitFileName,currentDirectory,getCanonicalFileName),!0),programDiagnostics.add(ts.createCompilerDiagnostic(message,emitFileName))}var program,commonSourceDirectory,diagnosticsProducingTypeChecker,noDiagnosticsTypeChecker,classifiableNames,files=[],fileProcessingDiagnostics=ts.createDiagnosticCollection(),programDiagnostics=ts.createDiagnosticCollection(),skipDefaultLib=options.noLib,supportedExtensions=ts.getSupportedExtensions(options),start=(new Date).getTime();host=host||createCompilerHost(options);var hasEmitBlockingDiagnostics=ts.createFileMap(getCanonicalFileName),currentDirectory=host.getCurrentDirectory(),resolveModuleNamesWorker=host.resolveModuleNames?function(moduleNames,containingFile){return host.resolveModuleNames(moduleNames,containingFile)}:function(moduleNames,containingFile){for(var resolvedModuleNames=[],lookup={},_i=0,moduleNames_1=moduleNames;_i<moduleNames_1.length;_i++){var moduleName=moduleNames_1[_i],resolvedName=void 0;ts.hasProperty(lookup,moduleName)?resolvedName=lookup[moduleName]:(resolvedName=resolveModuleName(moduleName,containingFile,options,host).resolvedModule,lookup[moduleName]=resolvedName),resolvedModuleNames.push(resolvedName)}return resolvedModuleNames},filesByName=ts.createFileMap(),filesByNameIgnoreCase=host.useCaseSensitiveFileNames()?ts.createFileMap(function(fileName){return fileName.toLowerCase()}):void 0;if(oldProgram){var oldOptions=oldProgram.getCompilerOptions();oldOptions.module===options.module&&oldOptions.noResolve===options.noResolve&&oldOptions.target===options.target&&oldOptions.noLib===options.noLib&&oldOptions.jsx===options.jsx&&oldOptions.allowJs===options.allowJs||(oldProgram=void 0)}return tryReuseStructureFromOldProgram()||(ts.forEach(rootNames,function(name){return processRootFile(name,!1)}),skipDefaultLib||processRootFile(host.getDefaultLibFileName(options),!0)),oldProgram=void 0,program={getRootFileNames:function(){return rootNames},getSourceFile:getSourceFile,getSourceFiles:function(){return files},getCompilerOptions:function(){return options},getSyntacticDiagnostics:getSyntacticDiagnostics,getOptionsDiagnostics:getOptionsDiagnostics,getGlobalDiagnostics:getGlobalDiagnostics,getSemanticDiagnostics:getSemanticDiagnostics,getDeclarationDiagnostics:getDeclarationDiagnostics,getTypeChecker:getTypeChecker,getClassifiableNames:getClassifiableNames,getDiagnosticsProducingTypeChecker:getDiagnosticsProducingTypeChecker,getCommonSourceDirectory:getCommonSourceDirectory,emit:emit,getCurrentDirectory:function(){return currentDirectory},getNodeCount:function(){return getDiagnosticsProducingTypeChecker().getNodeCount()},getIdentifierCount:function(){return getDiagnosticsProducingTypeChecker().getIdentifierCount()},getSymbolCount:function(){return getDiagnosticsProducingTypeChecker().getSymbolCount()},getTypeCount:function(){return getDiagnosticsProducingTypeChecker().getTypeCount()},getFileProcessingDiagnostics:function(){return fileProcessingDiagnostics}},verifyCompilerOptions(),ts.programTime+=(new Date).getTime()-start,program}ts.programTime=0,ts.emitTime=0,ts.ioReadTime=0,ts.ioWriteTime=0;var emptyArray=[];ts.version="1.8.7",ts.findConfigFile=findConfigFile,ts.resolveTripleslashReference=resolveTripleslashReference,ts.resolveModuleName=resolveModuleName,ts.nodeModuleNameResolver=nodeModuleNameResolver,ts.directoryProbablyExists=directoryProbablyExists,ts.classicNameResolver=classicNameResolver,ts.defaultInitCompilerOptions={module:1,target:1,noImplicitAny:!1,sourceMap:!1},ts.createCompilerHost=createCompilerHost,ts.getPreEmitDiagnostics=getPreEmitDiagnostics,ts.flattenDiagnosticMessageText=flattenDiagnosticMessageText,ts.createProgram=createProgram}(ts||(ts={}));var ts;!function(ts){function getOptionNameMap(){if(optionNameMapCache)return optionNameMapCache;var optionNameMap={},shortOptionNames={};return ts.forEach(ts.optionDeclarations,function(option){optionNameMap[option.name.toLowerCase()]=option,option.shortName&&(shortOptionNames[option.shortName]=option.name)}),optionNameMapCache={optionNameMap:optionNameMap,shortOptionNames:shortOptionNames}}function parseCommandLine(commandLine,readFile){function parseStrings(args){for(var i=0;i<args.length;){var s=args[i];if(i++,64===s.charCodeAt(0))parseResponseFile(s.slice(1));else if(45===s.charCodeAt(0))if(s=s.slice(45===s.charCodeAt(1)?2:1).toLowerCase(),ts.hasProperty(shortOptionNames,s)&&(s=shortOptionNames[s]),ts.hasProperty(optionNameMap,s)){var opt=optionNameMap[s];switch(args[i]||"boolean"===opt.type||errors.push(ts.createCompilerDiagnostic(ts.Diagnostics.Compiler_option_0_expects_an_argument,opt.name)),opt.type){case"number":options[opt.name]=parseInt(args[i]),
i++;break;case"boolean":options[opt.name]=!0;break;case"string":options[opt.name]=args[i]||"",i++;break;default:var map_1=opt.type,key=(args[i]||"").toLowerCase();i++,ts.hasProperty(map_1,key)?options[opt.name]=map_1[key]:errors.push(ts.createCompilerDiagnostic(opt.error))}}else errors.push(ts.createCompilerDiagnostic(ts.Diagnostics.Unknown_compiler_option_0,s));else fileNames.push(s)}}function parseResponseFile(fileName){var text=readFile?readFile(fileName):ts.sys.readFile(fileName);if(!text)return void errors.push(ts.createCompilerDiagnostic(ts.Diagnostics.File_0_not_found,fileName));for(var args=[],pos=0;;){for(;pos<text.length&&text.charCodeAt(pos)<=32;)pos++;if(pos>=text.length)break;var start=pos;if(34===text.charCodeAt(start)){for(pos++;pos<text.length&&34!==text.charCodeAt(pos);)pos++;pos<text.length?(args.push(text.substring(start+1,pos)),pos++):errors.push(ts.createCompilerDiagnostic(ts.Diagnostics.Unterminated_quoted_string_in_response_file_0,fileName))}else{for(;text.charCodeAt(pos)>32;)pos++;args.push(text.substring(start,pos))}}parseStrings(args)}var options={},fileNames=[],errors=[],_a=getOptionNameMap(),optionNameMap=_a.optionNameMap,shortOptionNames=_a.shortOptionNames;return parseStrings(commandLine),{options:options,fileNames:fileNames,errors:errors}}function readConfigFile(fileName,readFile){var text="";try{text=readFile(fileName)}catch(e){return{error:ts.createCompilerDiagnostic(ts.Diagnostics.Cannot_read_file_0_Colon_1,fileName,e.message)}}return parseConfigFileTextToJson(fileName,text)}function parseConfigFileTextToJson(fileName,jsonText){try{var jsonTextWithoutComments=removeComments(jsonText);return{config:/\S/.test(jsonTextWithoutComments)?JSON.parse(jsonTextWithoutComments):{}}}catch(e){return{error:ts.createCompilerDiagnostic(ts.Diagnostics.Failed_to_parse_file_0_Colon_1,fileName,e.message)}}}function removeComments(jsonText){for(var token,output="",scanner=ts.createScanner(1,!1,0,jsonText);1!==(token=scanner.scan());)switch(token){case 2:case 3:output+=scanner.getTokenText().replace(/\S/g," ");break;default:output+=scanner.getTokenText()}return output}function parseJsonConfigFileContent(json,host,basePath,existingOptions,configFileName){function getFileNames(){var fileNames=[];if(ts.hasProperty(json,"files"))json.files instanceof Array?fileNames=ts.map(json.files,function(s){return ts.combinePaths(basePath,s)}):errors.push(ts.createCompilerDiagnostic(ts.Diagnostics.Compiler_option_0_requires_a_value_of_type_1,"files","Array"));else{var filesSeen={},exclude=[];if(json.exclude instanceof Array)exclude=json.exclude;else{exclude=["node_modules"];var outDir=json.compilerOptions&&json.compilerOptions.outDir;outDir&&exclude.push(outDir)}exclude=ts.map(exclude,ts.normalizeSlashes);var supportedExtensions=ts.getSupportedExtensions(options);ts.Debug.assert(ts.indexOf(supportedExtensions,".ts")<ts.indexOf(supportedExtensions,".d.ts"),"Changed priority of extensions to pick");for(var _i=0,supportedExtensions_1=supportedExtensions;_i<supportedExtensions_1.length;_i++)for(var extension=supportedExtensions_1[_i],filesInDirWithExtension=host.readDirectory(basePath,extension,exclude),_a=0,filesInDirWithExtension_1=filesInDirWithExtension;_a<filesInDirWithExtension_1.length;_a++){var fileName=filesInDirWithExtension_1[_a];if(!(".ts"===extension&&ts.fileExtensionIs(fileName,".d.ts")||/\.min\.js$/.test(fileName))){if(".d.ts"===extension||options.allowJs&&ts.contains(ts.supportedJavascriptExtensions,extension)){var baseName=fileName.substr(0,fileName.length-extension.length);if(ts.hasProperty(filesSeen,baseName+".ts")||ts.hasProperty(filesSeen,baseName+".tsx"))continue}filesSeen[fileName]=!0,fileNames.push(fileName)}}}return fileNames}void 0===existingOptions&&(existingOptions={});var _a=convertCompilerOptionsFromJson(json.compilerOptions,basePath,configFileName),optionsFromJsonConfigFile=_a.options,errors=_a.errors,options=ts.extend(existingOptions,optionsFromJsonConfigFile);return{options:options,fileNames:getFileNames(),errors:errors}}function convertCompilerOptionsFromJson(jsonOptions,basePath,configFileName){var options={},errors=[];if(configFileName&&"jsconfig.json"===ts.getBaseFileName(configFileName)&&(options.allowJs=!0),!jsonOptions)return{options:options,errors:errors};var optionNameMap=ts.arrayToMap(ts.optionDeclarations,function(opt){return opt.name});for(var id in jsonOptions)if(ts.hasProperty(optionNameMap,id)){var opt=optionNameMap[id],optType=opt.type,value=jsonOptions[id],expectedType="string"==typeof optType?optType:"string";if(typeof value===expectedType){if("string"!=typeof optType){var key=value.toLowerCase();ts.hasProperty(optType,key)?value=optType[key]:(errors.push(ts.createCompilerDiagnostic(opt.error)),value=0)}opt.isFilePath&&(value=ts.normalizePath(ts.combinePaths(basePath,value)),""===value&&(value=".")),options[opt.name]=value}else errors.push(ts.createCompilerDiagnostic(ts.Diagnostics.Compiler_option_0_requires_a_value_of_type_1,id,expectedType))}else errors.push(ts.createCompilerDiagnostic(ts.Diagnostics.Unknown_compiler_option_0,id));return{options:options,errors:errors}}ts.optionDeclarations=[{name:"charset",type:"string"},{name:"declaration",shortName:"d",type:"boolean",description:ts.Diagnostics.Generates_corresponding_d_ts_file},{name:"diagnostics",type:"boolean"},{name:"emitBOM",type:"boolean"},{name:"help",shortName:"h",type:"boolean",description:ts.Diagnostics.Print_this_message},{name:"init",type:"boolean",description:ts.Diagnostics.Initializes_a_TypeScript_project_and_creates_a_tsconfig_json_file},{name:"inlineSourceMap",type:"boolean"},{name:"inlineSources",type:"boolean"},{name:"jsx",type:{preserve:1,react:2},paramType:ts.Diagnostics.KIND,description:ts.Diagnostics.Specify_JSX_code_generation_Colon_preserve_or_react,error:ts.Diagnostics.Argument_for_jsx_must_be_preserve_or_react},{name:"reactNamespace",type:"string",description:ts.Diagnostics.Specifies_the_object_invoked_for_createElement_and_spread_when_targeting_react_JSX_emit},{name:"listFiles",type:"boolean"},{name:"locale",type:"string"},{name:"mapRoot",type:"string",isFilePath:!0,description:ts.Diagnostics.Specifies_the_location_where_debugger_should_locate_map_files_instead_of_generated_locations,paramType:ts.Diagnostics.LOCATION},{name:"module",shortName:"m",type:{none:0,commonjs:1,amd:2,system:4,umd:3,es6:5,es2015:5},description:ts.Diagnostics.Specify_module_code_generation_Colon_commonjs_amd_system_umd_or_es2015,paramType:ts.Diagnostics.KIND,error:ts.Diagnostics.Argument_for_module_option_must_be_commonjs_amd_system_umd_es2015_or_none},{name:"newLine",type:{crlf:0,lf:1},description:ts.Diagnostics.Specifies_the_end_of_line_sequence_to_be_used_when_emitting_files_Colon_CRLF_dos_or_LF_unix,paramType:ts.Diagnostics.NEWLINE,error:ts.Diagnostics.Argument_for_newLine_option_must_be_CRLF_or_LF},{name:"noEmit",type:"boolean",description:ts.Diagnostics.Do_not_emit_outputs},{name:"noEmitHelpers",type:"boolean"},{name:"noEmitOnError",type:"boolean",description:ts.Diagnostics.Do_not_emit_outputs_if_any_errors_were_reported},{name:"noImplicitAny",type:"boolean",description:ts.Diagnostics.Raise_error_on_expressions_and_declarations_with_an_implied_any_type},{name:"noLib",type:"boolean"},{name:"noResolve",type:"boolean"},{name:"skipDefaultLibCheck",type:"boolean"},{name:"out",type:"string",isFilePath:!1,paramType:ts.Diagnostics.FILE},{name:"outFile",type:"string",isFilePath:!0,description:ts.Diagnostics.Concatenate_and_emit_output_to_single_file,paramType:ts.Diagnostics.FILE},{name:"outDir",type:"string",isFilePath:!0,description:ts.Diagnostics.Redirect_output_structure_to_the_directory,paramType:ts.Diagnostics.DIRECTORY},{name:"preserveConstEnums",type:"boolean",description:ts.Diagnostics.Do_not_erase_const_enum_declarations_in_generated_code},{name:"pretty",paramType:ts.Diagnostics.KIND,description:ts.Diagnostics.Stylize_errors_and_messages_using_color_and_context_experimental,type:"boolean"},{name:"project",shortName:"p",type:"string",isFilePath:!0,description:ts.Diagnostics.Compile_the_project_in_the_given_directory,paramType:ts.Diagnostics.DIRECTORY},{name:"removeComments",type:"boolean",description:ts.Diagnostics.Do_not_emit_comments_to_output},{name:"rootDir",type:"string",isFilePath:!0,description:ts.Diagnostics.Specifies_the_root_directory_of_input_files_Use_to_control_the_output_directory_structure_with_outDir,paramType:ts.Diagnostics.LOCATION},{name:"isolatedModules",type:"boolean"},{name:"sourceMap",type:"boolean",description:ts.Diagnostics.Generates_corresponding_map_file},{name:"sourceRoot",type:"string",isFilePath:!0,description:ts.Diagnostics.Specifies_the_location_where_debugger_should_locate_TypeScript_files_instead_of_source_locations,paramType:ts.Diagnostics.LOCATION},{name:"suppressExcessPropertyErrors",type:"boolean",description:ts.Diagnostics.Suppress_excess_property_checks_for_object_literals,experimental:!0},{name:"suppressImplicitAnyIndexErrors",type:"boolean",description:ts.Diagnostics.Suppress_noImplicitAny_errors_for_indexing_objects_lacking_index_signatures},{name:"stripInternal",type:"boolean",description:ts.Diagnostics.Do_not_emit_declarations_for_code_that_has_an_internal_annotation,experimental:!0},{name:"target",shortName:"t",type:{es3:0,es5:1,es6:2,es2015:2},description:ts.Diagnostics.Specify_ECMAScript_target_version_Colon_ES3_default_ES5_or_ES2015_experimental,paramType:ts.Diagnostics.VERSION,error:ts.Diagnostics.Argument_for_target_option_must_be_ES3_ES5_or_ES2015},{name:"version",shortName:"v",type:"boolean",description:ts.Diagnostics.Print_the_compiler_s_version},{name:"watch",shortName:"w",type:"boolean",description:ts.Diagnostics.Watch_input_files},{name:"experimentalDecorators",type:"boolean",description:ts.Diagnostics.Enables_experimental_support_for_ES7_decorators},{name:"emitDecoratorMetadata",type:"boolean",experimental:!0,description:ts.Diagnostics.Enables_experimental_support_for_emitting_type_metadata_for_decorators},{name:"moduleResolution",type:{node:2,classic:1},description:ts.Diagnostics.Specifies_module_resolution_strategy_Colon_node_Node_js_or_classic_TypeScript_pre_1_6,error:ts.Diagnostics.Argument_for_moduleResolution_option_must_be_node_or_classic},{name:"allowUnusedLabels",type:"boolean",description:ts.Diagnostics.Do_not_report_errors_on_unused_labels},{name:"noImplicitReturns",type:"boolean",description:ts.Diagnostics.Report_error_when_not_all_code_paths_in_function_return_a_value},{name:"noFallthroughCasesInSwitch",type:"boolean",description:ts.Diagnostics.Report_errors_for_fallthrough_cases_in_switch_statement},{name:"allowUnreachableCode",type:"boolean",description:ts.Diagnostics.Do_not_report_errors_on_unreachable_code},{name:"forceConsistentCasingInFileNames",type:"boolean",description:ts.Diagnostics.Disallow_inconsistently_cased_references_to_the_same_file},{name:"allowSyntheticDefaultImports",type:"boolean",description:ts.Diagnostics.Allow_default_imports_from_modules_with_no_default_export_This_does_not_affect_code_emit_just_typechecking},{name:"allowJs",type:"boolean",description:ts.Diagnostics.Allow_javascript_files_to_be_compiled},{name:"noImplicitUseStrict",type:"boolean",description:ts.Diagnostics.Do_not_emit_use_strict_directives_in_module_output},{name:"noCustomAsyncPromise",type:"boolean",experimental:!0}];var optionNameMapCache;ts.getOptionNameMap=getOptionNameMap,ts.parseCommandLine=parseCommandLine,ts.readConfigFile=readConfigFile,ts.parseConfigFileTextToJson=parseConfigFileTextToJson,ts.parseJsonConfigFileContent=parseJsonConfigFileContent,ts.convertCompilerOptionsFromJson=convertCompilerOptionsFromJson}(ts||(ts={}));var ts;!function(ts){var OutliningElementsCollector;!function(OutliningElementsCollector){function collectElements(sourceFile){function addOutliningSpan(hintSpanNode,startElement,endElement,autoCollapse){if(hintSpanNode&&startElement&&endElement){var span={textSpan:ts.createTextSpanFromBounds(startElement.pos,endElement.end),hintSpan:ts.createTextSpanFromBounds(hintSpanNode.getStart(),hintSpanNode.end),bannerText:collapseText,autoCollapse:autoCollapse};elements.push(span)}}function addOutliningSpanComments(commentSpan,autoCollapse){if(commentSpan){var span={textSpan:ts.createTextSpanFromBounds(commentSpan.pos,commentSpan.end),hintSpan:ts.createTextSpanFromBounds(commentSpan.pos,commentSpan.end),bannerText:collapseText,autoCollapse:autoCollapse};elements.push(span)}}function addOutliningForLeadingCommentsForNode(n){var comments=ts.getLeadingCommentRangesOfNode(n,sourceFile);if(comments){for(var firstSingleLineCommentStart=-1,lastSingleLineCommentEnd=-1,isFirstSingleLineComment=!0,singleLineCommentCount=0,_i=0,comments_2=comments;_i<comments_2.length;_i++){var currentComment=comments_2[_i];2===currentComment.kind?(isFirstSingleLineComment&&(firstSingleLineCommentStart=currentComment.pos),isFirstSingleLineComment=!1,lastSingleLineCommentEnd=currentComment.end,singleLineCommentCount++):3===currentComment.kind&&(combineAndAddMultipleSingleLineComments(singleLineCommentCount,firstSingleLineCommentStart,lastSingleLineCommentEnd),addOutliningSpanComments(currentComment,!1),singleLineCommentCount=0,lastSingleLineCommentEnd=-1,isFirstSingleLineComment=!0)}combineAndAddMultipleSingleLineComments(singleLineCommentCount,firstSingleLineCommentStart,lastSingleLineCommentEnd)}}function combineAndAddMultipleSingleLineComments(count,start,end){if(count>1){var multipleSingleLineComments={pos:start,end:end,kind:2};addOutliningSpanComments(multipleSingleLineComments,!1)}}function autoCollapse(node){return ts.isFunctionBlock(node)&&177!==node.parent.kind}function walk(n){if(!(depth>maxDepth)){switch(ts.isDeclaration(n)&&addOutliningForLeadingCommentsForNode(n),n.kind){case 195:if(!ts.isFunctionBlock(n)){var parent_9=n.parent,openBrace=ts.findChildOfKind(n,15,sourceFile),closeBrace=ts.findChildOfKind(n,16,sourceFile);if(200===parent_9.kind||203===parent_9.kind||204===parent_9.kind||202===parent_9.kind||199===parent_9.kind||201===parent_9.kind||208===parent_9.kind||247===parent_9.kind){addOutliningSpan(parent_9,openBrace,closeBrace,autoCollapse(n));break}if(212===parent_9.kind){var tryStatement=parent_9;if(tryStatement.tryBlock===n){addOutliningSpan(parent_9,openBrace,closeBrace,autoCollapse(n));break}if(tryStatement.finallyBlock===n){var finallyKeyword=ts.findChildOfKind(tryStatement,85,sourceFile);if(finallyKeyword){addOutliningSpan(finallyKeyword,openBrace,closeBrace,autoCollapse(n));break}}}var span=ts.createTextSpanFromBounds(n.getStart(),n.end);elements.push({textSpan:span,hintSpan:span,bannerText:collapseText,autoCollapse:autoCollapse(n)});break}case 222:var openBrace=ts.findChildOfKind(n,15,sourceFile),closeBrace=ts.findChildOfKind(n,16,sourceFile);addOutliningSpan(n.parent,openBrace,closeBrace,autoCollapse(n));break;case 217:case 218:case 220:case 168:case 223:var openBrace=ts.findChildOfKind(n,15,sourceFile),closeBrace=ts.findChildOfKind(n,16,sourceFile);addOutliningSpan(n,openBrace,closeBrace,autoCollapse(n));break;case 167:var openBracket=ts.findChildOfKind(n,19,sourceFile),closeBracket=ts.findChildOfKind(n,20,sourceFile);addOutliningSpan(n,openBracket,closeBracket,autoCollapse(n))}depth++,ts.forEachChild(n,walk),depth--}}var elements=[],collapseText="...",depth=0,maxDepth=20;return walk(sourceFile),elements}OutliningElementsCollector.collectElements=collectElements}(OutliningElementsCollector=ts.OutliningElementsCollector||(ts.OutliningElementsCollector={}))}(ts||(ts={}));var ts;!function(ts){var NavigateTo;!function(NavigateTo){function getNavigateToItems(program,cancellationToken,searchValue,maxResultCount){function allMatchesAreCaseSensitive(matches){ts.Debug.assert(matches.length>0);for(var _i=0,matches_1=matches;_i<matches_1.length;_i++){var match=matches_1[_i];if(!match.isCaseSensitive)return!1}return!0}function getTextOfIdentifierOrLiteral(node){if(node&&(69===node.kind||9===node.kind||8===node.kind))return node.text}function tryAddSingleDeclarationName(declaration,containers){if(declaration&&declaration.name){var text=getTextOfIdentifierOrLiteral(declaration.name);if(void 0===text)return 137===declaration.name.kind&&tryAddComputedPropertyName(declaration.name.expression,containers,!0);containers.unshift(text)}return!0}function tryAddComputedPropertyName(expression,containers,includeLastPortion){var text=getTextOfIdentifierOrLiteral(expression);if(void 0!==text)return includeLastPortion&&containers.unshift(text),!0;if(169===expression.kind){var propertyAccess=expression;return includeLastPortion&&containers.unshift(propertyAccess.name.text),tryAddComputedPropertyName(propertyAccess.expression,containers,!0)}return!1}function getContainers(declaration){var containers=[];if(137!==declaration.name.kind||tryAddComputedPropertyName(declaration.name.expression,containers,!1)){for(declaration=ts.getContainerNode(declaration);declaration;){if(!tryAddSingleDeclarationName(declaration,containers))return;declaration=ts.getContainerNode(declaration)}return containers}}function bestMatchKind(matches){ts.Debug.assert(matches.length>0);for(var bestMatchKind=ts.PatternMatchKind.camelCase,_i=0,matches_2=matches;_i<matches_2.length;_i++){var match=matches_2[_i],kind=match.kind;kind<bestMatchKind&&(bestMatchKind=kind)}return bestMatchKind}function compareNavigateToItems(i1,i2){return i1.matchKind-i2.matchKind||i1.name.localeCompare(i2.name,void 0,baseSensitivity)||i1.name.localeCompare(i2.name)}function createNavigateToItem(rawItem){var declaration=rawItem.declaration,container=ts.getContainerNode(declaration);return{name:rawItem.name,kind:ts.getNodeKind(declaration),kindModifiers:ts.getNodeModifiers(declaration),matchKind:ts.PatternMatchKind[rawItem.matchKind],isCaseSensitive:rawItem.isCaseSensitive,fileName:rawItem.fileName,textSpan:ts.createTextSpanFromBounds(declaration.getStart(),declaration.getEnd()),containerName:container&&container.name?container.name.text:"",containerKind:container&&container.name?ts.getNodeKind(container):""}}var patternMatcher=ts.createPatternMatcher(searchValue),rawItems=[],baseSensitivity={sensitivity:"base"};ts.forEach(program.getSourceFiles(),function(sourceFile){cancellationToken.throwIfCancellationRequested();var nameToDeclarations=sourceFile.getNamedDeclarations();for(var name_32 in nameToDeclarations){var declarations=ts.getProperty(nameToDeclarations,name_32);if(declarations){var matches=patternMatcher.getMatchesForLastSegmentOfPattern(name_32);if(!matches)continue;for(var _i=0,declarations_6=declarations;_i<declarations_6.length;_i++){var declaration=declarations_6[_i];if(patternMatcher.patternContainsDots){var containers=getContainers(declaration);if(!containers)return;if(matches=patternMatcher.getMatches(containers,name_32),!matches)continue}var fileName=sourceFile.fileName,matchKind=bestMatchKind(matches);rawItems.push({name:name_32,fileName:fileName,matchKind:matchKind,isCaseSensitive:allMatchesAreCaseSensitive(matches),declaration:declaration})}}}}),rawItems.sort(compareNavigateToItems),void 0!==maxResultCount&&(rawItems=rawItems.slice(0,maxResultCount));var items=ts.map(rawItems,createNavigateToItem);return items}NavigateTo.getNavigateToItems=getNavigateToItems}(NavigateTo=ts.NavigateTo||(ts.NavigateTo={}))}(ts||(ts={}));var ts;!function(ts){var NavigationBar;!function(NavigationBar){function getNavigationBarItems(sourceFile,compilerOptions){function getIndent(node){for(var indent=hasGlobalNode?1:0,current=node.parent;current;){switch(current.kind){case 221:do current=current.parent;while(221===current.kind);case 217:case 220:case 218:case 216:indent++}current=current.parent}return indent}function getChildNodes(nodes){function visit(node){switch(node.kind){case 196:ts.forEach(node.declarationList.declarations,visit);break;case 164:case 165:ts.forEach(node.elements,visit);break;case 231:node.exportClause&&ts.forEach(node.exportClause.elements,visit);break;case 225:var importClause=node.importClause;importClause&&(importClause.name&&childNodes.push(importClause),importClause.namedBindings&&(227===importClause.namedBindings.kind?childNodes.push(importClause.namedBindings):ts.forEach(importClause.namedBindings.elements,visit)));break;case 166:case 214:if(ts.isBindingPattern(node.name)){visit(node.name);break}case 217:case 220:case 218:case 221:case 216:case 224:case 229:case 233:childNodes.push(node)}}var childNodes=[];return ts.forEach(nodes,visit),sortNodes(childNodes)}function getTopLevelNodes(node){var topLevelNodes=[];return topLevelNodes.push(node),addTopLevelNodes(node.statements,topLevelNodes),topLevelNodes}function sortNodes(nodes){return nodes.slice(0).sort(function(n1,n2){return n1.name&&n2.name?ts.getPropertyNameForPropertyNameNode(n1.name).localeCompare(ts.getPropertyNameForPropertyNameNode(n2.name)):n1.name?1:n2.name?-1:n1.kind-n2.kind})}function addTopLevelNodes(nodes,topLevelNodes){nodes=sortNodes(nodes);for(var _i=0,nodes_4=nodes;_i<nodes_4.length;_i++){var node=nodes_4[_i];switch(node.kind){case 217:case 220:case 218:topLevelNodes.push(node);break;case 221:var moduleDeclaration=node;topLevelNodes.push(node),addTopLevelNodes(getInnermostModule(moduleDeclaration).body.statements,topLevelNodes);break;case 216:var functionDeclaration=node;isTopLevelFunctionDeclaration(functionDeclaration)&&(topLevelNodes.push(node),addTopLevelNodes(functionDeclaration.body.statements,topLevelNodes))}}}function isTopLevelFunctionDeclaration(functionDeclaration){if(216===functionDeclaration.kind&&functionDeclaration.body&&195===functionDeclaration.body.kind){if(ts.forEach(functionDeclaration.body.statements,function(s){return 216===s.kind&&!isEmpty(s.name.text)}))return!0;if(!ts.isFunctionBlock(functionDeclaration.parent))return!0}return!1}function getItemsWorker(nodes,createItem){for(var items=[],keyToItem={},_i=0,nodes_5=nodes;_i<nodes_5.length;_i++){var child=nodes_5[_i],item=createItem(child);if(void 0!==item&&item.text.length>0){var key=item.text+"-"+item.kind+"-"+item.indent,itemWithSameName=keyToItem[key];itemWithSameName?merge(itemWithSameName,item):(keyToItem[key]=item,items.push(item))}}return items}function merge(target,source){if(ts.addRange(target.spans,source.spans),source.childItems){target.childItems||(target.childItems=[]);outer:for(var _i=0,_a=source.childItems;_i<_a.length;_i++){for(var sourceChild=_a[_i],_b=0,_c=target.childItems;_b<_c.length;_b++){var targetChild=_c[_b];if(targetChild.text===sourceChild.text&&targetChild.kind===sourceChild.kind){merge(targetChild,sourceChild);continue outer}}target.childItems.push(sourceChild)}}}function createChildItem(node){function createItem(node,name,scriptElementKind){return getNavigationBarItem(name,scriptElementKind,ts.getNodeModifiers(node),[getNodeSpan(node)])}switch(node.kind){case 139:if(ts.isBindingPattern(node.name))break;if(0===(1022&node.flags))return;return createItem(node,getTextOfNode(node.name),ts.ScriptElementKind.memberVariableElement);case 144:case 143:return createItem(node,getTextOfNode(node.name),ts.ScriptElementKind.memberFunctionElement);case 146:return createItem(node,getTextOfNode(node.name),ts.ScriptElementKind.memberGetAccessorElement);case 147:return createItem(node,getTextOfNode(node.name),ts.ScriptElementKind.memberSetAccessorElement);case 150:return createItem(node,"[]",ts.ScriptElementKind.indexSignatureElement);case 250:return createItem(node,getTextOfNode(node.name),ts.ScriptElementKind.memberVariableElement);case 148:return createItem(node,"()",ts.ScriptElementKind.callSignatureElement);case 149:return createItem(node,"new()",ts.ScriptElementKind.constructSignatureElement);case 142:case 141:return createItem(node,getTextOfNode(node.name),ts.ScriptElementKind.memberVariableElement);case 216:return createItem(node,getTextOfNode(node.name),ts.ScriptElementKind.functionElement);case 214:case 166:var name_33,variableDeclarationNode=void 0;if(166===node.kind){for(name_33=node.name,variableDeclarationNode=node;variableDeclarationNode&&214!==variableDeclarationNode.kind;)variableDeclarationNode=variableDeclarationNode.parent;ts.Debug.assert(void 0!==variableDeclarationNode)}else ts.Debug.assert(!ts.isBindingPattern(node.name)),variableDeclarationNode=node,name_33=node.name;return ts.isConst(variableDeclarationNode)?createItem(node,getTextOfNode(name_33),ts.ScriptElementKind.constElement):ts.isLet(variableDeclarationNode)?createItem(node,getTextOfNode(name_33),ts.ScriptElementKind.letElement):createItem(node,getTextOfNode(name_33),ts.ScriptElementKind.variableElement);case 145:return createItem(node,"constructor",ts.ScriptElementKind.constructorImplementationElement);case 233:case 229:case 224:case 226:case 227:return createItem(node,getTextOfNode(node.name),ts.ScriptElementKind.alias)}}function isEmpty(text){return!text||""===text.trim()}function getNavigationBarItem(text,kind,kindModifiers,spans,childItems,indent){if(void 0===childItems&&(childItems=[]),void 0===indent&&(indent=0),!isEmpty(text))return{text:text,kind:kind,kindModifiers:kindModifiers,spans:spans,childItems:childItems,indent:indent,bolded:!1,grayed:!1}}function createTopLevelItem(node){function getModuleName(moduleDeclaration){if(ts.isAmbientModule(moduleDeclaration))return getTextOfNode(moduleDeclaration.name);var result=[];for(result.push(moduleDeclaration.name.text);moduleDeclaration.body&&221===moduleDeclaration.body.kind;)moduleDeclaration=moduleDeclaration.body,result.push(moduleDeclaration.name.text);return result.join(".")}function createModuleItem(node){var moduleName=getModuleName(node),childItems=getItemsWorker(getChildNodes(getInnermostModule(node).body.statements),createChildItem);return getNavigationBarItem(moduleName,ts.ScriptElementKind.moduleElement,ts.getNodeModifiers(node),[getNodeSpan(node)],childItems,getIndent(node))}function createFunctionItem(node){if(node.body&&195===node.body.kind){var childItems=getItemsWorker(sortNodes(node.body.statements),createChildItem);return getNavigationBarItem(node.name?node.name.text:"default",ts.ScriptElementKind.functionElement,ts.getNodeModifiers(node),[getNodeSpan(node)],childItems,getIndent(node))}}function createSourceFileItem(node){var childItems=getItemsWorker(getChildNodes(node.statements),createChildItem);if(void 0!==childItems&&0!==childItems.length){hasGlobalNode=!0;var rootName=ts.isExternalModule(node)?'"'+ts.escapeString(ts.getBaseFileName(ts.removeFileExtension(ts.normalizePath(node.fileName))))+'"':"<global>";return getNavigationBarItem(rootName,ts.ScriptElementKind.moduleElement,ts.ScriptElementKindModifier.none,[getNodeSpan(node)],childItems)}}function createClassItem(node){var childItems;if(node.members){var constructor=ts.forEach(node.members,function(member){return 145===member.kind&&member}),nodes=removeDynamicallyNamedProperties(node);constructor&&ts.addRange(nodes,ts.filter(constructor.parameters,function(p){return!ts.isBindingPattern(p.name)})),childItems=getItemsWorker(sortNodes(nodes),createChildItem)}var nodeName=node.name?node.name.text:"default";return getNavigationBarItem(nodeName,ts.ScriptElementKind.classElement,ts.getNodeModifiers(node),[getNodeSpan(node)],childItems,getIndent(node))}function createEnumItem(node){var childItems=getItemsWorker(sortNodes(removeComputedProperties(node)),createChildItem);return getNavigationBarItem(node.name.text,ts.ScriptElementKind.enumElement,ts.getNodeModifiers(node),[getNodeSpan(node)],childItems,getIndent(node))}function createIterfaceItem(node){var childItems=getItemsWorker(sortNodes(removeDynamicallyNamedProperties(node)),createChildItem);return getNavigationBarItem(node.name.text,ts.ScriptElementKind.interfaceElement,ts.getNodeModifiers(node),[getNodeSpan(node)],childItems,getIndent(node))}switch(node.kind){case 251:return createSourceFileItem(node);case 217:return createClassItem(node);case 220:return createEnumItem(node);case 218:return createIterfaceItem(node);case 221:return createModuleItem(node);case 216:return createFunctionItem(node)}}function removeComputedProperties(node){return ts.filter(node.members,function(member){return void 0===member.name||137!==member.name.kind})}function removeDynamicallyNamedProperties(node){return ts.filter(node.members,function(member){return!ts.hasDynamicName(member)})}function getInnermostModule(node){for(;221===node.body.kind;)node=node.body;return node}function getNodeSpan(node){return 251===node.kind?ts.createTextSpanFromBounds(node.getFullStart(),node.getEnd()):ts.createTextSpanFromBounds(node.getStart(),node.getEnd())}function getTextOfNode(node){return ts.getTextOfNodeFromSourceText(sourceFile.text,node)}var hasGlobalNode=!1;return getItemsWorker(getTopLevelNodes(sourceFile),createTopLevelItem)}NavigationBar.getNavigationBarItems=getNavigationBarItems}(NavigationBar=ts.NavigationBar||(ts.NavigationBar={}))}(ts||(ts={}));var ts;!function(ts){function createPatternMatch(kind,punctuationStripped,isCaseSensitive,camelCaseWeight){return{kind:kind,punctuationStripped:punctuationStripped,isCaseSensitive:isCaseSensitive,camelCaseWeight:camelCaseWeight}}function createPatternMatcher(pattern){function skipMatch(candidate){return invalidPattern||!candidate}function getMatchesForLastSegmentOfPattern(candidate){if(!skipMatch(candidate))return matchSegment(candidate,ts.lastOrUndefined(dotSeparatedSegments))}function getMatches(candidateContainers,candidate){if(!skipMatch(candidate)){var candidateMatch=matchSegment(candidate,ts.lastOrUndefined(dotSeparatedSegments));if(candidateMatch&&(candidateContainers=candidateContainers||[],!(dotSeparatedSegments.length-1>candidateContainers.length))){for(var totalMatch=candidateMatch,i=dotSeparatedSegments.length-2,j=candidateContainers.length-1;i>=0;i-=1,j-=1){var segment=dotSeparatedSegments[i],containerName=candidateContainers[j],containerMatch=matchSegment(containerName,segment);if(!containerMatch)return;ts.addRange(totalMatch,containerMatch)}return totalMatch}}}function getWordSpans(word){return ts.hasProperty(stringToWordSpans,word)||(stringToWordSpans[word]=breakIntoWordSpans(word)),stringToWordSpans[word]}function matchTextChunk(candidate,chunk,punctuationStripped){var index=indexOfIgnoringCase(candidate,chunk.textLowerCase);if(0===index)return chunk.text.length===candidate.length?createPatternMatch(PatternMatchKind.exact,punctuationStripped,candidate===chunk.text):createPatternMatch(PatternMatchKind.prefix,punctuationStripped,startsWith(candidate,chunk.text));var isLowercase=chunk.isLowerCase;if(isLowercase){if(index>0)for(var wordSpans=getWordSpans(candidate),_i=0,wordSpans_1=wordSpans;_i<wordSpans_1.length;_i++){var span=wordSpans_1[_i];if(partStartsWith(candidate,span,chunk.text,!0))return createPatternMatch(PatternMatchKind.substring,punctuationStripped,partStartsWith(candidate,span,chunk.text,!1))}}else if(candidate.indexOf(chunk.text)>0)return createPatternMatch(PatternMatchKind.substring,punctuationStripped,!0);if(!isLowercase&&chunk.characterSpans.length>0){var candidateParts=getWordSpans(candidate),camelCaseWeight=tryCamelCaseMatch(candidate,candidateParts,chunk,!1);if(void 0!==camelCaseWeight)return createPatternMatch(PatternMatchKind.camelCase,punctuationStripped,!0,camelCaseWeight);if(camelCaseWeight=tryCamelCaseMatch(candidate,candidateParts,chunk,!0),void 0!==camelCaseWeight)return createPatternMatch(PatternMatchKind.camelCase,punctuationStripped,!1,camelCaseWeight)}return isLowercase&&chunk.text.length<candidate.length&&index>0&&isUpperCaseLetter(candidate.charCodeAt(index))?createPatternMatch(PatternMatchKind.substring,punctuationStripped,!1):void 0}function containsSpaceOrAsterisk(text){for(var i=0;i<text.length;i++){var ch=text.charCodeAt(i);if(32===ch||42===ch)return!0}return!1}function matchSegment(candidate,segment){if(!containsSpaceOrAsterisk(segment.totalTextChunk.text)){var match=matchTextChunk(candidate,segment.totalTextChunk,!1);if(match)return[match]}for(var subWordTextChunks=segment.subWordTextChunks,matches=void 0,_i=0,subWordTextChunks_1=subWordTextChunks;_i<subWordTextChunks_1.length;_i++){var subWordTextChunk=subWordTextChunks_1[_i],result=matchTextChunk(candidate,subWordTextChunk,!0);if(!result)return;
matches=matches||[],matches.push(result)}return matches}function partStartsWith(candidate,candidateSpan,pattern,ignoreCase,patternSpan){var patternPartStart=patternSpan?patternSpan.start:0,patternPartLength=patternSpan?patternSpan.length:pattern.length;if(patternPartLength>candidateSpan.length)return!1;if(ignoreCase)for(var i=0;i<patternPartLength;i++){var ch1=pattern.charCodeAt(patternPartStart+i),ch2=candidate.charCodeAt(candidateSpan.start+i);if(toLowerCase(ch1)!==toLowerCase(ch2))return!1}else for(var i=0;i<patternPartLength;i++){var ch1=pattern.charCodeAt(patternPartStart+i),ch2=candidate.charCodeAt(candidateSpan.start+i);if(ch1!==ch2)return!1}return!0}function tryCamelCaseMatch(candidate,candidateParts,chunk,ignoreCase){for(var chunkCharacterSpans=chunk.characterSpans,currentCandidate=0,currentChunkSpan=0,firstMatch=void 0,contiguous=void 0;;){if(currentChunkSpan===chunkCharacterSpans.length){var weight=0;return contiguous&&(weight+=1),0===firstMatch&&(weight+=2),weight}if(currentCandidate===candidateParts.length)return;for(var candidatePart=candidateParts[currentCandidate],gotOneMatchThisCandidate=!1;currentChunkSpan<chunkCharacterSpans.length;currentChunkSpan++){var chunkCharacterSpan=chunkCharacterSpans[currentChunkSpan];if(gotOneMatchThisCandidate&&(!isUpperCaseLetter(chunk.text.charCodeAt(chunkCharacterSpans[currentChunkSpan-1].start))||!isUpperCaseLetter(chunk.text.charCodeAt(chunkCharacterSpans[currentChunkSpan].start))))break;if(!partStartsWith(candidate,candidatePart,chunk.text,ignoreCase,chunkCharacterSpan))break;gotOneMatchThisCandidate=!0,firstMatch=void 0===firstMatch?currentCandidate:firstMatch,contiguous=void 0===contiguous||contiguous,candidatePart=ts.createTextSpan(candidatePart.start+chunkCharacterSpan.length,candidatePart.length-chunkCharacterSpan.length)}gotOneMatchThisCandidate||void 0===contiguous||(contiguous=!1),currentCandidate++}}var stringToWordSpans={};pattern=pattern.trim();var dotSeparatedSegments=pattern.split(".").map(function(p){return createSegment(p.trim())}),invalidPattern=0===dotSeparatedSegments.length||ts.forEach(dotSeparatedSegments,segmentIsInvalid);return{getMatches:getMatches,getMatchesForLastSegmentOfPattern:getMatchesForLastSegmentOfPattern,patternContainsDots:dotSeparatedSegments.length>1}}function createSegment(text){return{totalTextChunk:createTextChunk(text),subWordTextChunks:breakPatternIntoTextChunks(text)}}function segmentIsInvalid(segment){return 0===segment.subWordTextChunks.length}function isUpperCaseLetter(ch){if(ch>=65&&ch<=90)return!0;if(ch<127||!ts.isUnicodeIdentifierStart(ch,2))return!1;var str=String.fromCharCode(ch);return str===str.toUpperCase()}function isLowerCaseLetter(ch){if(ch>=97&&ch<=122)return!0;if(ch<127||!ts.isUnicodeIdentifierStart(ch,2))return!1;var str=String.fromCharCode(ch);return str===str.toLowerCase()}function startsWith(string,search){for(var i=0,n=search.length;i<n;i++)if(string.charCodeAt(i)!==search.charCodeAt(i))return!1;return!0}function indexOfIgnoringCase(string,value){for(var i=0,n=string.length-value.length;i<=n;i++)if(startsWithIgnoringCase(string,value,i))return i;return-1}function startsWithIgnoringCase(string,value,start){for(var i=0,n=value.length;i<n;i++){var ch1=toLowerCase(string.charCodeAt(i+start)),ch2=value.charCodeAt(i);if(ch1!==ch2)return!1}return!0}function toLowerCase(ch){return ch>=65&&ch<=90?97+(ch-65):ch<127?ch:String.fromCharCode(ch).toLowerCase().charCodeAt(0)}function isDigit(ch){return ch>=48&&ch<=57}function isWordChar(ch){return isUpperCaseLetter(ch)||isLowerCaseLetter(ch)||isDigit(ch)||95===ch||36===ch}function breakPatternIntoTextChunks(pattern){for(var result=[],wordStart=0,wordLength=0,i=0;i<pattern.length;i++){var ch=pattern.charCodeAt(i);isWordChar(ch)?(0===wordLength&&(wordStart=i),wordLength++):wordLength>0&&(result.push(createTextChunk(pattern.substr(wordStart,wordLength))),wordLength=0)}return wordLength>0&&result.push(createTextChunk(pattern.substr(wordStart,wordLength))),result}function createTextChunk(text){var textLowerCase=text.toLowerCase();return{text:text,textLowerCase:textLowerCase,isLowerCase:text===textLowerCase,characterSpans:breakIntoCharacterSpans(text)}}function breakIntoCharacterSpans(identifier){return breakIntoSpans(identifier,!1)}function breakIntoWordSpans(identifier){return breakIntoSpans(identifier,!0)}function breakIntoSpans(identifier,word){for(var result=[],wordStart=0,i=1,n=identifier.length;i<n;i++){var lastIsDigit=isDigit(identifier.charCodeAt(i-1)),currentIsDigit=isDigit(identifier.charCodeAt(i)),hasTransitionFromLowerToUpper=transitionFromLowerToUpper(identifier,word,i),hasTransitionFromUpperToLower=transitionFromUpperToLower(identifier,word,i,wordStart);(charIsPunctuation(identifier.charCodeAt(i-1))||charIsPunctuation(identifier.charCodeAt(i))||lastIsDigit!==currentIsDigit||hasTransitionFromLowerToUpper||hasTransitionFromUpperToLower)&&(isAllPunctuation(identifier,wordStart,i)||result.push(ts.createTextSpan(wordStart,i-wordStart)),wordStart=i)}return isAllPunctuation(identifier,wordStart,identifier.length)||result.push(ts.createTextSpan(wordStart,identifier.length-wordStart)),result}function charIsPunctuation(ch){switch(ch){case 33:case 34:case 35:case 37:case 38:case 39:case 40:case 41:case 42:case 44:case 45:case 46:case 47:case 58:case 59:case 63:case 64:case 91:case 92:case 93:case 95:case 123:case 125:return!0}return!1}function isAllPunctuation(identifier,start,end){for(var i=start;i<end;i++){var ch=identifier.charCodeAt(i);if(!charIsPunctuation(ch)||95===ch||36===ch)return!1}return!0}function transitionFromUpperToLower(identifier,word,index,wordStart){if(word&&index!==wordStart&&index+1<identifier.length){var currentIsUpper=isUpperCaseLetter(identifier.charCodeAt(index)),nextIsLower=isLowerCaseLetter(identifier.charCodeAt(index+1));if(currentIsUpper&&nextIsLower){for(var i=wordStart;i<index;i++)if(!isUpperCaseLetter(identifier.charCodeAt(i)))return!1;return!0}}return!1}function transitionFromLowerToUpper(identifier,word,index){var lastIsUpper=isUpperCaseLetter(identifier.charCodeAt(index-1)),currentIsUpper=isUpperCaseLetter(identifier.charCodeAt(index)),transition=word?currentIsUpper&&!lastIsUpper:currentIsUpper;return transition}!function(PatternMatchKind){PatternMatchKind[PatternMatchKind.exact=0]="exact",PatternMatchKind[PatternMatchKind.prefix=1]="prefix",PatternMatchKind[PatternMatchKind.substring=2]="substring",PatternMatchKind[PatternMatchKind.camelCase=3]="camelCase"}(ts.PatternMatchKind||(ts.PatternMatchKind={}));var PatternMatchKind=ts.PatternMatchKind;ts.createPatternMatcher=createPatternMatcher,ts.breakIntoCharacterSpans=breakIntoCharacterSpans,ts.breakIntoWordSpans=breakIntoWordSpans}(ts||(ts={}));var ts;!function(ts){var SignatureHelp;!function(SignatureHelp){function getSignatureHelpItems(program,sourceFile,position,cancellationToken){function createJavaScriptSignatureHelpItems(argumentInfo){if(171===argumentInfo.invocation.kind){var callExpression=argumentInfo.invocation,expression=callExpression.expression,name=69===expression.kind?expression:169===expression.kind?expression.name:void 0;if(name&&name.text)for(var typeChecker=program.getTypeChecker(),_i=0,_a=program.getSourceFiles();_i<_a.length;_i++){var sourceFile_1=_a[_i],nameToDeclarations=sourceFile_1.getNamedDeclarations(),declarations=ts.getProperty(nameToDeclarations,name.text);if(declarations)for(var _b=0,declarations_7=declarations;_b<declarations_7.length;_b++){var declaration=declarations_7[_b],symbol=declaration.symbol;if(symbol){var type=typeChecker.getTypeOfSymbolAtLocation(symbol,declaration);if(type){var callSignatures=type.getCallSignatures();if(callSignatures&&callSignatures.length)return createSignatureHelpItems(callSignatures,callSignatures[0],argumentInfo)}}}}}}function getImmediatelyContainingArgumentInfo(node){if(171===node.parent.kind||172===node.parent.kind){var callExpression=node.parent;if(25===node.kind||17===node.kind){var list=getChildListThatStartsWithOpenerToken(callExpression,node,sourceFile),isTypeArgList=callExpression.typeArguments&&callExpression.typeArguments.pos===list.pos;return ts.Debug.assert(void 0!==list),{kind:isTypeArgList?0:1,invocation:callExpression,argumentsSpan:getApplicableSpanForArguments(list),argumentIndex:0,argumentCount:getArgumentCount(list)}}var listItemInfo=ts.findListItemInfo(node);if(listItemInfo){var list=listItemInfo.list,isTypeArgList=callExpression.typeArguments&&callExpression.typeArguments.pos===list.pos,argumentIndex=getArgumentIndex(list,node),argumentCount=getArgumentCount(list);return ts.Debug.assert(0===argumentIndex||argumentIndex<argumentCount,"argumentCount < argumentIndex, "+argumentCount+" < "+argumentIndex),{kind:isTypeArgList?0:1,invocation:callExpression,argumentsSpan:getApplicableSpanForArguments(list),argumentIndex:argumentIndex,argumentCount:argumentCount}}}else if(11===node.kind&&173===node.parent.kind){if(ts.isInsideTemplateLiteral(node,position))return getArgumentListInfoForTemplate(node.parent,0)}else{if(12===node.kind&&173===node.parent.parent.kind){var templateExpression=node.parent,tagExpression=templateExpression.parent;ts.Debug.assert(186===templateExpression.kind);var argumentIndex=ts.isInsideTemplateLiteral(node,position)?0:1;return getArgumentListInfoForTemplate(tagExpression,argumentIndex)}if(193===node.parent.kind&&173===node.parent.parent.parent.kind){var templateSpan=node.parent,templateExpression=templateSpan.parent,tagExpression=templateExpression.parent;if(ts.Debug.assert(186===templateExpression.kind),14===node.kind&&!ts.isInsideTemplateLiteral(node,position))return;var spanIndex=templateExpression.templateSpans.indexOf(templateSpan),argumentIndex=getArgumentIndexForTemplatePiece(spanIndex,node);return getArgumentListInfoForTemplate(tagExpression,argumentIndex)}}}function getArgumentIndex(argumentsList,node){for(var argumentIndex=0,listChildren=argumentsList.getChildren(),_i=0,listChildren_1=listChildren;_i<listChildren_1.length;_i++){var child=listChildren_1[_i];if(child===node)break;24!==child.kind&&argumentIndex++}return argumentIndex}function getArgumentCount(argumentsList){var listChildren=argumentsList.getChildren(),argumentCount=ts.countWhere(listChildren,function(arg){return 24!==arg.kind});return listChildren.length>0&&24===ts.lastOrUndefined(listChildren).kind&&argumentCount++,argumentCount}function getArgumentIndexForTemplatePiece(spanIndex,node){return ts.Debug.assert(position>=node.getStart(),"Assumed 'position' could not occur before node."),ts.isTemplateLiteralKind(node.kind)?ts.isInsideTemplateLiteral(node,position)?0:spanIndex+2:spanIndex+1}function getArgumentListInfoForTemplate(tagExpression,argumentIndex){var argumentCount=11===tagExpression.template.kind?1:tagExpression.template.templateSpans.length+1;return ts.Debug.assert(0===argumentIndex||argumentIndex<argumentCount,"argumentCount < argumentIndex, "+argumentCount+" < "+argumentIndex),{kind:2,invocation:tagExpression,argumentsSpan:getApplicableSpanForTaggedTemplate(tagExpression),argumentIndex:argumentIndex,argumentCount:argumentCount}}function getApplicableSpanForArguments(argumentsList){var applicableSpanStart=argumentsList.getFullStart(),applicableSpanEnd=ts.skipTrivia(sourceFile.text,argumentsList.getEnd(),!1);return ts.createTextSpan(applicableSpanStart,applicableSpanEnd-applicableSpanStart)}function getApplicableSpanForTaggedTemplate(taggedTemplate){var template=taggedTemplate.template,applicableSpanStart=template.getStart(),applicableSpanEnd=template.getEnd();if(186===template.kind){var lastSpan=ts.lastOrUndefined(template.templateSpans);0===lastSpan.literal.getFullWidth()&&(applicableSpanEnd=ts.skipTrivia(sourceFile.text,applicableSpanEnd,!1))}return ts.createTextSpan(applicableSpanStart,applicableSpanEnd-applicableSpanStart)}function getContainingArgumentInfo(node){for(var n=node;251!==n.kind;n=n.parent){if(ts.isFunctionBlock(n))return;(n.pos<n.parent.pos||n.end>n.parent.end)&&ts.Debug.fail("Node of kind "+n.kind+" is not a subspan of its parent of kind "+n.parent.kind);var argumentInfo_1=getImmediatelyContainingArgumentInfo(n);if(argumentInfo_1)return argumentInfo_1}}function getChildListThatStartsWithOpenerToken(parent,openerToken,sourceFile){var children=parent.getChildren(sourceFile),indexOfOpenerToken=children.indexOf(openerToken);return ts.Debug.assert(indexOfOpenerToken>=0&&children.length>indexOfOpenerToken+1),children[indexOfOpenerToken+1]}function selectBestInvalidOverloadIndex(candidates,argumentCount){for(var maxParamsSignatureIndex=-1,maxParams=-1,i=0;i<candidates.length;i++){var candidate=candidates[i];if(candidate.hasRestParameter||candidate.parameters.length>=argumentCount)return i;candidate.parameters.length>maxParams&&(maxParams=candidate.parameters.length,maxParamsSignatureIndex=i)}return maxParamsSignatureIndex}function createSignatureHelpItems(candidates,bestSignature,argumentListInfo){function createSignatureHelpParameterForParameter(parameter){var displayParts=ts.mapToDisplayParts(function(writer){return typeChecker.getSymbolDisplayBuilder().buildParameterDisplay(parameter,writer,invocation)});return{name:parameter.name,documentation:parameter.getDocumentationComment(),displayParts:displayParts,isOptional:typeChecker.isOptionalParameter(parameter.valueDeclaration)}}function createSignatureHelpParameterForTypeParameter(typeParameter){var displayParts=ts.mapToDisplayParts(function(writer){return typeChecker.getSymbolDisplayBuilder().buildTypeParameterDisplay(typeParameter,writer,invocation)});return{name:typeParameter.symbol.name,documentation:emptyArray,displayParts:displayParts,isOptional:!1}}var applicableSpan=argumentListInfo.argumentsSpan,isTypeParameterList=0===argumentListInfo.kind,invocation=argumentListInfo.invocation,callTarget=ts.getInvokedExpression(invocation),callTargetSymbol=typeChecker.getSymbolAtLocation(callTarget),callTargetDisplayParts=callTargetSymbol&&ts.symbolToDisplayParts(typeChecker,callTargetSymbol,void 0,void 0),items=ts.map(candidates,function(candidateSignature){var signatureHelpParameters,prefixDisplayParts=[],suffixDisplayParts=[];if(callTargetDisplayParts&&ts.addRange(prefixDisplayParts,callTargetDisplayParts),isTypeParameterList){prefixDisplayParts.push(ts.punctuationPart(25));var typeParameters=candidateSignature.typeParameters;signatureHelpParameters=typeParameters&&typeParameters.length>0?ts.map(typeParameters,createSignatureHelpParameterForTypeParameter):emptyArray,suffixDisplayParts.push(ts.punctuationPart(27));var parameterParts=ts.mapToDisplayParts(function(writer){return typeChecker.getSymbolDisplayBuilder().buildDisplayForParametersAndDelimiters(candidateSignature.parameters,writer,invocation)});ts.addRange(suffixDisplayParts,parameterParts)}else{var typeParameterParts=ts.mapToDisplayParts(function(writer){return typeChecker.getSymbolDisplayBuilder().buildDisplayForTypeParametersAndDelimiters(candidateSignature.typeParameters,writer,invocation)});ts.addRange(prefixDisplayParts,typeParameterParts),prefixDisplayParts.push(ts.punctuationPart(17));var parameters=candidateSignature.parameters;signatureHelpParameters=parameters.length>0?ts.map(parameters,createSignatureHelpParameterForParameter):emptyArray,suffixDisplayParts.push(ts.punctuationPart(18))}var returnTypeParts=ts.mapToDisplayParts(function(writer){return typeChecker.getSymbolDisplayBuilder().buildReturnTypeDisplay(candidateSignature,writer,invocation)});return ts.addRange(suffixDisplayParts,returnTypeParts),{isVariadic:candidateSignature.hasRestParameter,prefixDisplayParts:prefixDisplayParts,suffixDisplayParts:suffixDisplayParts,separatorDisplayParts:[ts.punctuationPart(24),ts.spacePart()],parameters:signatureHelpParameters,documentation:candidateSignature.getDocumentationComment()}}),argumentIndex=argumentListInfo.argumentIndex,argumentCount=argumentListInfo.argumentCount,selectedItemIndex=candidates.indexOf(bestSignature);return selectedItemIndex<0&&(selectedItemIndex=selectBestInvalidOverloadIndex(candidates,argumentCount)),ts.Debug.assert(0===argumentIndex||argumentIndex<argumentCount,"argumentCount < argumentIndex, "+argumentCount+" < "+argumentIndex),{items:items,applicableSpan:applicableSpan,selectedItemIndex:selectedItemIndex,argumentIndex:argumentIndex,argumentCount:argumentCount}}var typeChecker=program.getTypeChecker(),startingToken=ts.findTokenOnLeftOfPosition(sourceFile,position);if(startingToken){var argumentInfo=getContainingArgumentInfo(startingToken);if(cancellationToken.throwIfCancellationRequested(),argumentInfo){var call=argumentInfo.invocation,candidates=[],resolvedSignature=typeChecker.getResolvedSignature(call,candidates);if(cancellationToken.throwIfCancellationRequested(),candidates.length)return createSignatureHelpItems(candidates,resolvedSignature,argumentInfo);if(ts.isSourceFileJavaScript(sourceFile))return createJavaScriptSignatureHelpItems(argumentInfo)}}}var ArgumentListKind,emptyArray=[];!function(ArgumentListKind){ArgumentListKind[ArgumentListKind.TypeArguments=0]="TypeArguments",ArgumentListKind[ArgumentListKind.CallArguments=1]="CallArguments",ArgumentListKind[ArgumentListKind.TaggedTemplateArguments=2]="TaggedTemplateArguments"}(ArgumentListKind||(ArgumentListKind={})),SignatureHelp.getSignatureHelpItems=getSignatureHelpItems}(SignatureHelp=ts.SignatureHelp||(ts.SignatureHelp={}))}(ts||(ts={}));var ts;!function(ts){function getEndLinePosition(line,sourceFile){ts.Debug.assert(line>=0);var lineStarts=sourceFile.getLineStarts(),lineIndex=line;if(lineIndex+1===lineStarts.length)return sourceFile.text.length-1;var start=lineStarts[lineIndex],pos=lineStarts[lineIndex+1]-1;for(ts.Debug.assert(ts.isLineBreak(sourceFile.text.charCodeAt(pos)));start<=pos&&ts.isLineBreak(sourceFile.text.charCodeAt(pos));)pos--;return pos}function getLineStartPositionForPosition(position,sourceFile){var lineStarts=sourceFile.getLineStarts(),line=sourceFile.getLineAndCharacterOfPosition(position).line;return lineStarts[line]}function rangeContainsRange(r1,r2){return startEndContainsRange(r1.pos,r1.end,r2)}function startEndContainsRange(start,end,range){return start<=range.pos&&end>=range.end}function rangeContainsStartEnd(range,start,end){return range.pos<=start&&range.end>=end}function rangeOverlapsWithStartEnd(r1,start,end){return startEndOverlapsWithStartEnd(r1.pos,r1.end,start,end)}function startEndOverlapsWithStartEnd(start1,end1,start2,end2){var start=Math.max(start1,start2),end=Math.min(end1,end2);return start<end}function positionBelongsToNode(candidate,position,sourceFile){return candidate.end>position||!isCompletedNode(candidate,sourceFile)}function isCompletedNode(n,sourceFile){if(ts.nodeIsMissing(n))return!1;switch(n.kind){case 217:case 218:case 220:case 168:case 164:case 156:case 195:case 222:case 223:return nodeEndsWith(n,16,sourceFile);case 247:return isCompletedNode(n.block,sourceFile);case 172:if(!n.arguments)return!0;case 171:case 175:case 161:return nodeEndsWith(n,18,sourceFile);case 153:case 154:return isCompletedNode(n.type,sourceFile);case 145:case 146:case 147:case 216:case 176:case 144:case 143:case 149:case 148:case 177:return n.body?isCompletedNode(n.body,sourceFile):n.type?isCompletedNode(n.type,sourceFile):hasChildOfKind(n,18,sourceFile);case 221:return n.body&&isCompletedNode(n.body,sourceFile);case 199:return n.elseStatement?isCompletedNode(n.elseStatement,sourceFile):isCompletedNode(n.thenStatement,sourceFile);case 198:return isCompletedNode(n.expression,sourceFile)||hasChildOfKind(n,23);case 167:case 165:case 170:case 137:case 158:return nodeEndsWith(n,20,sourceFile);case 150:return n.type?isCompletedNode(n.type,sourceFile):hasChildOfKind(n,20,sourceFile);case 244:case 245:return!1;case 202:case 203:case 204:case 201:return isCompletedNode(n.statement,sourceFile);case 200:var hasWhileKeyword=findChildOfKind(n,104,sourceFile);return hasWhileKeyword?nodeEndsWith(n,18,sourceFile):isCompletedNode(n.statement,sourceFile);case 155:return isCompletedNode(n.exprName,sourceFile);case 179:case 178:case 180:case 187:case 188:var unaryWordExpression=n;return isCompletedNode(unaryWordExpression.expression,sourceFile);case 173:return isCompletedNode(n.template,sourceFile);case 186:var lastSpan=ts.lastOrUndefined(n.templateSpans);return isCompletedNode(lastSpan,sourceFile);case 193:return ts.nodeIsPresent(n.literal);case 182:return isCompletedNode(n.operand,sourceFile);case 184:return isCompletedNode(n.right,sourceFile);case 185:return isCompletedNode(n.whenFalse,sourceFile);default:return!0}}function nodeEndsWith(n,expectedLastToken,sourceFile){var children=n.getChildren(sourceFile);if(children.length){var last=ts.lastOrUndefined(children);if(last.kind===expectedLastToken)return!0;if(23===last.kind&&1!==children.length)return children[children.length-2].kind===expectedLastToken}return!1}function findListItemInfo(node){var list=findContainingList(node);if(list){var children=list.getChildren(),listItemIndex=ts.indexOf(children,node);return{listItemIndex:listItemIndex,list:list}}}function hasChildOfKind(n,kind,sourceFile){return!!findChildOfKind(n,kind,sourceFile)}function findChildOfKind(n,kind,sourceFile){return ts.forEach(n.getChildren(sourceFile),function(c){return c.kind===kind&&c})}function findContainingList(node){var syntaxList=ts.forEach(node.parent.getChildren(),function(c){if(274===c.kind&&c.pos<=node.pos&&c.end>=node.end)return c});return ts.Debug.assert(!syntaxList||ts.contains(syntaxList.getChildren(),node)),syntaxList}function getTouchingWord(sourceFile,position){return getTouchingToken(sourceFile,position,function(n){return isWord(n.kind)})}function getTouchingPropertyName(sourceFile,position){return getTouchingToken(sourceFile,position,function(n){return isPropertyName(n.kind)})}function getTouchingToken(sourceFile,position,includeItemAtEndPosition){return getTokenAtPositionWorker(sourceFile,position,!1,includeItemAtEndPosition)}function getTokenAtPosition(sourceFile,position){return getTokenAtPositionWorker(sourceFile,position,!0,void 0)}function getTokenAtPositionWorker(sourceFile,position,allowPositionInLeadingTrivia,includeItemAtEndPosition){var current=sourceFile;outer:for(;;){if(isToken(current))return current;for(var i=0,n=current.getChildCount(sourceFile);i<n;i++){var child=current.getChildAt(i),start=allowPositionInLeadingTrivia?child.getFullStart():child.getStart(sourceFile);if(start<=position){var end=child.getEnd();if(position<end||position===end&&1===child.kind){current=child;continue outer}if(includeItemAtEndPosition&&end===position){var previousToken=findPrecedingToken(position,sourceFile,child);if(previousToken&&includeItemAtEndPosition(previousToken))return previousToken}}}return current}}function findTokenOnLeftOfPosition(file,position){var tokenAtPosition=getTokenAtPosition(file,position);return isToken(tokenAtPosition)&&position>tokenAtPosition.getStart(file)&&position<tokenAtPosition.getEnd()?tokenAtPosition:findPrecedingToken(position,file)}function findNextToken(previousToken,parent){function find(n){if(isToken(n)&&n.pos===previousToken.end)return n;for(var children=n.getChildren(),_i=0,children_1=children;_i<children_1.length;_i++){var child=children_1[_i],shouldDiveInChildNode=child.pos<=previousToken.pos&&child.end>previousToken.end||child.pos===previousToken.end;if(shouldDiveInChildNode&&nodeHasTokens(child))return find(child)}}return find(parent)}function findPrecedingToken(position,sourceFile,startNode){function findRightmostToken(n){if(isToken(n)||239===n.kind)return n;var children=n.getChildren(),candidate=findRightmostChildNodeWithTokens(children,children.length);return candidate&&findRightmostToken(candidate)}function find(n){if(isToken(n)||239===n.kind)return n;for(var children=n.getChildren(),i=0,len=children.length;i<len;i++){var child=children[i];if(position<child.end&&(nodeHasTokens(child)||239===child.kind)){var start=child.getStart(sourceFile),lookInPreviousChild=start>=position||239===child.kind&&start===child.end;if(lookInPreviousChild){var candidate=findRightmostChildNodeWithTokens(children,i);return candidate&&findRightmostToken(candidate)}return find(child)}}if(ts.Debug.assert(void 0!==startNode||251===n.kind),children.length){var candidate=findRightmostChildNodeWithTokens(children,children.length);return candidate&&findRightmostToken(candidate)}}function findRightmostChildNodeWithTokens(children,exclusiveStartPosition){for(var i=exclusiveStartPosition-1;i>=0;--i)if(nodeHasTokens(children[i]))return children[i]}return find(startNode||sourceFile)}function isInString(sourceFile,position){var token=getTokenAtPosition(sourceFile,position);return token&&(9===token.kind||163===token.kind)&&position>token.getStart()}function isInComment(sourceFile,position){return isInCommentHelper(sourceFile,position,void 0)}function isInCommentHelper(sourceFile,position,predicate){var token=getTokenAtPosition(sourceFile,position);if(token&&position<=token.getStart()){var commentRanges=ts.getLeadingCommentRanges(sourceFile.text,token.pos);return predicate?ts.forEach(commentRanges,function(c){return c.pos<position&&(2==c.kind?position<=c.end:position<c.end)&&predicate(c)}):ts.forEach(commentRanges,function(c){return c.pos<position&&(2==c.kind?position<=c.end:position<c.end)})}return!1}function hasDocComment(sourceFile,position){function jsDocPrefix(c){var text=sourceFile.text;return text.length>=c.pos+3&&"/"===text[c.pos]&&"*"===text[c.pos+1]&&"*"===text[c.pos+2]}var token=getTokenAtPosition(sourceFile,position),commentRanges=ts.getLeadingCommentRanges(sourceFile.text,token.pos);return ts.forEach(commentRanges,jsDocPrefix)}function getJsDocTagAtPosition(sourceFile,position){var node=ts.getTokenAtPosition(sourceFile,position);if(isToken(node))switch(node.kind){case 102:case 108:case 74:node=void 0===node.parent?void 0:node.parent.parent;break;default:node=node.parent}if(node){var jsDocComment=node.jsDocComment;if(jsDocComment)for(var _i=0,_a=jsDocComment.tags;_i<_a.length;_i++){var tag=_a[_i];if(tag.pos<=position&&position<=tag.end)return tag}}}function nodeHasTokens(n){return 0!==n.getWidth()}function getNodeModifiers(node){var flags=ts.getCombinedNodeFlags(node),result=[];return 16&flags&&result.push(ts.ScriptElementKindModifier.privateMemberModifier),32&flags&&result.push(ts.ScriptElementKindModifier.protectedMemberModifier),8&flags&&result.push(ts.ScriptElementKindModifier.publicMemberModifier),64&flags&&result.push(ts.ScriptElementKindModifier.staticModifier),128&flags&&result.push(ts.ScriptElementKindModifier.abstractModifier),2&flags&&result.push(ts.ScriptElementKindModifier.exportedModifier),ts.isInAmbientContext(node)&&result.push(ts.ScriptElementKindModifier.ambientModifier),result.length>0?result.join(","):ts.ScriptElementKindModifier.none}function getTypeArgumentOrTypeParameterList(node){return 152===node.kind||171===node.kind?node.typeArguments:ts.isFunctionLike(node)||217===node.kind||218===node.kind?node.typeParameters:void 0}function isToken(n){return n.kind>=0&&n.kind<=135}function isWord(kind){return 69===kind||ts.isKeyword(kind)}function isPropertyName(kind){return 9===kind||8===kind||isWord(kind)}function isComment(kind){return 2===kind||3===kind}function isStringOrRegularExpressionOrTemplateLiteral(kind){return!(9!==kind&&163!==kind&&10!==kind&&!ts.isTemplateLiteralKind(kind))}function isPunctuation(kind){return 15<=kind&&kind<=68}function isInsideTemplateLiteral(node,position){return ts.isTemplateLiteralKind(node.kind)&&node.getStart()<position&&position<node.getEnd()||!!node.isUnterminated&&position===node.getEnd()}function isAccessibilityModifier(kind){switch(kind){case 112:case 110:case 111:return!0}return!1}function compareDataObjects(dst,src){for(var e in dst)if("object"==typeof dst[e]){if(!compareDataObjects(dst[e],src[e]))return!1}else if("function"!=typeof dst[e]&&dst[e]!==src[e])return!1;return!0}function isArrayLiteralOrObjectLiteralDestructuringPattern(node){if(167===node.kind||168===node.kind){if(184===node.parent.kind&&node.parent.left===node&&56===node.parent.operatorToken.kind)return!0;if(204===node.parent.kind&&node.parent.initializer===node)return!0;if(isArrayLiteralOrObjectLiteralDestructuringPattern(248===node.parent.kind?node.parent.parent:node.parent))return!0}return!1}ts.getEndLinePosition=getEndLinePosition,ts.getLineStartPositionForPosition=getLineStartPositionForPosition,ts.rangeContainsRange=rangeContainsRange,ts.startEndContainsRange=startEndContainsRange,ts.rangeContainsStartEnd=rangeContainsStartEnd,ts.rangeOverlapsWithStartEnd=rangeOverlapsWithStartEnd,ts.startEndOverlapsWithStartEnd=startEndOverlapsWithStartEnd,ts.positionBelongsToNode=positionBelongsToNode,ts.isCompletedNode=isCompletedNode,ts.findListItemInfo=findListItemInfo,ts.hasChildOfKind=hasChildOfKind,ts.findChildOfKind=findChildOfKind,ts.findContainingList=findContainingList,ts.getTouchingWord=getTouchingWord,ts.getTouchingPropertyName=getTouchingPropertyName,ts.getTouchingToken=getTouchingToken,ts.getTokenAtPosition=getTokenAtPosition,ts.findTokenOnLeftOfPosition=findTokenOnLeftOfPosition,ts.findNextToken=findNextToken,ts.findPrecedingToken=findPrecedingToken,ts.isInString=isInString,ts.isInComment=isInComment,ts.isInCommentHelper=isInCommentHelper,ts.hasDocComment=hasDocComment,ts.getJsDocTagAtPosition=getJsDocTagAtPosition,ts.getNodeModifiers=getNodeModifiers,ts.getTypeArgumentOrTypeParameterList=getTypeArgumentOrTypeParameterList,ts.isToken=isToken,ts.isWord=isWord,ts.isComment=isComment,ts.isStringOrRegularExpressionOrTemplateLiteral=isStringOrRegularExpressionOrTemplateLiteral,ts.isPunctuation=isPunctuation,ts.isInsideTemplateLiteral=isInsideTemplateLiteral,ts.isAccessibilityModifier=isAccessibilityModifier,ts.compareDataObjects=compareDataObjects,ts.isArrayLiteralOrObjectLiteralDestructuringPattern=isArrayLiteralOrObjectLiteralDestructuringPattern}(ts||(ts={}));var ts;!function(ts){function isFirstDeclarationOfSymbolParameter(symbol){return symbol.declarations&&symbol.declarations.length>0&&139===symbol.declarations[0].kind}function getDisplayPartWriter(){function writeIndent(){if(lineStart){var indentString=ts.getIndentString(indent);indentString&&displayParts.push(displayPart(indentString,ts.SymbolDisplayPartKind.space)),lineStart=!1}}function writeKind(text,kind){writeIndent(),displayParts.push(displayPart(text,kind))}function writeSymbol(text,symbol){writeIndent(),displayParts.push(symbolPart(text,symbol))}function writeLine(){displayParts.push(lineBreakPart()),lineStart=!0}function resetWriter(){displayParts=[],lineStart=!0,indent=0}var displayParts,lineStart,indent;return resetWriter(),{displayParts:function(){return displayParts},writeKeyword:function(text){return writeKind(text,ts.SymbolDisplayPartKind.keyword)},writeOperator:function(text){return writeKind(text,ts.SymbolDisplayPartKind.operator)},writePunctuation:function(text){return writeKind(text,ts.SymbolDisplayPartKind.punctuation)},writeSpace:function(text){return writeKind(text,ts.SymbolDisplayPartKind.space)},writeStringLiteral:function(text){return writeKind(text,ts.SymbolDisplayPartKind.stringLiteral)},writeParameter:function(text){return writeKind(text,ts.SymbolDisplayPartKind.parameterName)},writeSymbol:writeSymbol,writeLine:writeLine,increaseIndent:function(){indent++},decreaseIndent:function(){indent--},clear:resetWriter,trackSymbol:function(){},reportInaccessibleThisError:function(){}}}function symbolPart(text,symbol){function displayPartKind(symbol){var flags=symbol.flags;return 3&flags?isFirstDeclarationOfSymbolParameter(symbol)?ts.SymbolDisplayPartKind.parameterName:ts.SymbolDisplayPartKind.localName:4&flags?ts.SymbolDisplayPartKind.propertyName:32768&flags?ts.SymbolDisplayPartKind.propertyName:65536&flags?ts.SymbolDisplayPartKind.propertyName:8&flags?ts.SymbolDisplayPartKind.enumMemberName:16&flags?ts.SymbolDisplayPartKind.functionName:32&flags?ts.SymbolDisplayPartKind.className:64&flags?ts.SymbolDisplayPartKind.interfaceName:384&flags?ts.SymbolDisplayPartKind.enumName:1536&flags?ts.SymbolDisplayPartKind.moduleName:8192&flags?ts.SymbolDisplayPartKind.methodName:262144&flags?ts.SymbolDisplayPartKind.typeParameterName:524288&flags?ts.SymbolDisplayPartKind.aliasName:8388608&flags?ts.SymbolDisplayPartKind.aliasName:ts.SymbolDisplayPartKind.text;
}return displayPart(text,displayPartKind(symbol),symbol)}function displayPart(text,kind,symbol){return{text:text,kind:ts.SymbolDisplayPartKind[kind]}}function spacePart(){return displayPart(" ",ts.SymbolDisplayPartKind.space)}function keywordPart(kind){return displayPart(ts.tokenToString(kind),ts.SymbolDisplayPartKind.keyword)}function punctuationPart(kind){return displayPart(ts.tokenToString(kind),ts.SymbolDisplayPartKind.punctuation)}function operatorPart(kind){return displayPart(ts.tokenToString(kind),ts.SymbolDisplayPartKind.operator)}function textOrKeywordPart(text){var kind=ts.stringToToken(text);return void 0===kind?textPart(text):keywordPart(kind)}function textPart(text){return displayPart(text,ts.SymbolDisplayPartKind.text)}function getNewLineOrDefaultFromHost(host){return host.getNewLine?host.getNewLine():carriageReturnLineFeed}function lineBreakPart(){return displayPart("\n",ts.SymbolDisplayPartKind.lineBreak)}function mapToDisplayParts(writeDisplayParts){writeDisplayParts(displayPartWriter);var result=displayPartWriter.displayParts();return displayPartWriter.clear(),result}function typeToDisplayParts(typechecker,type,enclosingDeclaration,flags){return mapToDisplayParts(function(writer){typechecker.getSymbolDisplayBuilder().buildTypeDisplay(type,writer,enclosingDeclaration,flags)})}function symbolToDisplayParts(typeChecker,symbol,enclosingDeclaration,meaning,flags){return mapToDisplayParts(function(writer){typeChecker.getSymbolDisplayBuilder().buildSymbolDisplay(symbol,writer,enclosingDeclaration,meaning,flags)})}function signatureToDisplayParts(typechecker,signature,enclosingDeclaration,flags){return mapToDisplayParts(function(writer){typechecker.getSymbolDisplayBuilder().buildSignatureDisplay(signature,writer,enclosingDeclaration,flags)})}function getDeclaredName(typeChecker,symbol,location){if(isImportOrExportSpecifierName(location))return location.getText();var localExportDefaultSymbol=ts.getLocalSymbolForExportDefault(symbol),name=typeChecker.symbolToString(localExportDefaultSymbol||symbol);return name}function isImportOrExportSpecifierName(location){return location.parent&&(229===location.parent.kind||233===location.parent.kind)&&location.parent.propertyName===location}function stripQuotes(name){var length=name.length;return length>=2&&name.charCodeAt(0)===name.charCodeAt(length-1)&&(34===name.charCodeAt(0)||39===name.charCodeAt(0))?name.substring(1,length-1):name}ts.isFirstDeclarationOfSymbolParameter=isFirstDeclarationOfSymbolParameter;var displayPartWriter=getDisplayPartWriter();ts.symbolPart=symbolPart,ts.displayPart=displayPart,ts.spacePart=spacePart,ts.keywordPart=keywordPart,ts.punctuationPart=punctuationPart,ts.operatorPart=operatorPart,ts.textOrKeywordPart=textOrKeywordPart,ts.textPart=textPart;var carriageReturnLineFeed="\r\n";ts.getNewLineOrDefaultFromHost=getNewLineOrDefaultFromHost,ts.lineBreakPart=lineBreakPart,ts.mapToDisplayParts=mapToDisplayParts,ts.typeToDisplayParts=typeToDisplayParts,ts.symbolToDisplayParts=symbolToDisplayParts,ts.signatureToDisplayParts=signatureToDisplayParts,ts.getDeclaredName=getDeclaredName,ts.isImportOrExportSpecifierName=isImportOrExportSpecifierName,ts.stripQuotes=stripQuotes}(ts||(ts={}));var ts;!function(ts){var formatting;!function(formatting){function getFormattingScanner(sourceFile,startPos,endPos){function advance(){ts.Debug.assert(void 0!==scanner),lastTokenInfo=void 0;var isStarted=scanner.getStartPos()!==startPos;isStarted&&(trailingTrivia?(ts.Debug.assert(0!==trailingTrivia.length),wasNewLine=4===ts.lastOrUndefined(trailingTrivia).kind):wasNewLine=!1),leadingTrivia=void 0,trailingTrivia=void 0,isStarted||scanner.scan();for(var pos=scanner.getStartPos();pos<endPos;){var t_1=scanner.getToken();if(!ts.isTrivia(t_1))break;scanner.scan();var item={pos:pos,end:scanner.getStartPos(),kind:t_1};pos=scanner.getStartPos(),leadingTrivia||(leadingTrivia=[]),leadingTrivia.push(item)}savedPos=scanner.getStartPos()}function shouldRescanGreaterThanToken(node){if(node)switch(node.kind){case 29:case 64:case 65:case 45:case 44:return!0}return!1}function shouldRescanJsxIdentifier(node){if(node.parent)switch(node.parent.kind){case 241:case 238:case 240:case 237:return 69===node.kind}return!1}function shouldRescanSlashToken(container){return 10===container.kind}function shouldRescanTemplateToken(container){return 13===container.kind||14===container.kind}function startsWithSlashToken(t){return 39===t||61===t}function readTokenInfo(n){if(ts.Debug.assert(void 0!==scanner),!isOnToken())return{leadingTrivia:leadingTrivia,trailingTrivia:void 0,token:void 0};var expectedScanAction=shouldRescanGreaterThanToken(n)?1:shouldRescanSlashToken(n)?2:shouldRescanTemplateToken(n)?3:shouldRescanJsxIdentifier(n)?4:0;if(lastTokenInfo&&expectedScanAction===lastScanAction)return fixTokenKind(lastTokenInfo,n);scanner.getStartPos()!==savedPos&&(ts.Debug.assert(void 0!==lastTokenInfo),scanner.setTextPos(savedPos),scanner.scan());var currentToken=scanner.getToken();1===expectedScanAction&&27===currentToken?(currentToken=scanner.reScanGreaterToken(),ts.Debug.assert(n.kind===currentToken),lastScanAction=1):2===expectedScanAction&&startsWithSlashToken(currentToken)?(currentToken=scanner.reScanSlashToken(),ts.Debug.assert(n.kind===currentToken),lastScanAction=2):3===expectedScanAction&&16===currentToken?(currentToken=scanner.reScanTemplateToken(),lastScanAction=3):4===expectedScanAction&&69===currentToken?(currentToken=scanner.scanJsxIdentifier(),lastScanAction=4):lastScanAction=0;var token={pos:scanner.getStartPos(),end:scanner.getTextPos(),kind:currentToken};for(trailingTrivia&&(trailingTrivia=void 0);scanner.getStartPos()<endPos&&(currentToken=scanner.scan(),ts.isTrivia(currentToken));){var trivia={pos:scanner.getStartPos(),end:scanner.getTextPos(),kind:currentToken};if(trailingTrivia||(trailingTrivia=[]),trailingTrivia.push(trivia),4===currentToken){scanner.scan();break}}return lastTokenInfo={leadingTrivia:leadingTrivia,trailingTrivia:trailingTrivia,token:token},fixTokenKind(lastTokenInfo,n)}function isOnToken(){ts.Debug.assert(void 0!==scanner);var current=lastTokenInfo&&lastTokenInfo.token.kind||scanner.getToken(),startPos=lastTokenInfo&&lastTokenInfo.token.pos||scanner.getStartPos();return startPos<endPos&&1!==current&&!ts.isTrivia(current)}function fixTokenKind(tokenInfo,container){return ts.isToken(container)&&tokenInfo.token.kind!==container.kind&&(tokenInfo.token.kind=container.kind),tokenInfo}ts.Debug.assert(void 0===scanner),scanner=1===sourceFile.languageVariant?jsxScanner:standardScanner,scanner.setText(sourceFile.text),scanner.setTextPos(startPos);var leadingTrivia,trailingTrivia,savedPos,lastScanAction,lastTokenInfo,wasNewLine=!0;return{advance:advance,readTokenInfo:readTokenInfo,isOnToken:isOnToken,getCurrentLeadingTrivia:function(){return leadingTrivia},lastTrailingTriviaWasNewLine:function(){return wasNewLine},close:function(){ts.Debug.assert(void 0!==scanner),lastTokenInfo=void 0,scanner.setText(void 0),scanner=void 0}}}var scanner,ScanAction,standardScanner=ts.createScanner(2,!1,0),jsxScanner=ts.createScanner(2,!1,1);!function(ScanAction){ScanAction[ScanAction.Scan=0]="Scan",ScanAction[ScanAction.RescanGreaterThanToken=1]="RescanGreaterThanToken",ScanAction[ScanAction.RescanSlashToken=2]="RescanSlashToken",ScanAction[ScanAction.RescanTemplateToken=3]="RescanTemplateToken",ScanAction[ScanAction.RescanJsxIdentifier=4]="RescanJsxIdentifier"}(ScanAction||(ScanAction={})),formatting.getFormattingScanner=getFormattingScanner}(formatting=ts.formatting||(ts.formatting={}))}(ts||(ts={}));var ts;!function(ts){var formatting;!function(formatting){var FormattingContext=function(){function FormattingContext(sourceFile,formattingRequestKind){this.sourceFile=sourceFile,this.formattingRequestKind=formattingRequestKind}return FormattingContext.prototype.updateContext=function(currentRange,currentTokenParent,nextRange,nextTokenParent,commonParent){ts.Debug.assert(void 0!==currentRange,"currentTokenSpan is null"),ts.Debug.assert(void 0!==currentTokenParent,"currentTokenParent is null"),ts.Debug.assert(void 0!==nextRange,"nextTokenSpan is null"),ts.Debug.assert(void 0!==nextTokenParent,"nextTokenParent is null"),ts.Debug.assert(void 0!==commonParent,"commonParent is null"),this.currentTokenSpan=currentRange,this.currentTokenParent=currentTokenParent,this.nextTokenSpan=nextRange,this.nextTokenParent=nextTokenParent,this.contextNode=commonParent,this.contextNodeAllOnSameLine=void 0,this.nextNodeAllOnSameLine=void 0,this.tokensAreOnSameLine=void 0,this.contextNodeBlockIsOnOneLine=void 0,this.nextNodeBlockIsOnOneLine=void 0},FormattingContext.prototype.ContextNodeAllOnSameLine=function(){return void 0===this.contextNodeAllOnSameLine&&(this.contextNodeAllOnSameLine=this.NodeIsOnOneLine(this.contextNode)),this.contextNodeAllOnSameLine},FormattingContext.prototype.NextNodeAllOnSameLine=function(){return void 0===this.nextNodeAllOnSameLine&&(this.nextNodeAllOnSameLine=this.NodeIsOnOneLine(this.nextTokenParent)),this.nextNodeAllOnSameLine},FormattingContext.prototype.TokensAreOnSameLine=function(){if(void 0===this.tokensAreOnSameLine){var startLine=this.sourceFile.getLineAndCharacterOfPosition(this.currentTokenSpan.pos).line,endLine=this.sourceFile.getLineAndCharacterOfPosition(this.nextTokenSpan.pos).line;this.tokensAreOnSameLine=startLine===endLine}return this.tokensAreOnSameLine},FormattingContext.prototype.ContextNodeBlockIsOnOneLine=function(){return void 0===this.contextNodeBlockIsOnOneLine&&(this.contextNodeBlockIsOnOneLine=this.BlockIsOnOneLine(this.contextNode)),this.contextNodeBlockIsOnOneLine},FormattingContext.prototype.NextNodeBlockIsOnOneLine=function(){return void 0===this.nextNodeBlockIsOnOneLine&&(this.nextNodeBlockIsOnOneLine=this.BlockIsOnOneLine(this.nextTokenParent)),this.nextNodeBlockIsOnOneLine},FormattingContext.prototype.NodeIsOnOneLine=function(node){var startLine=this.sourceFile.getLineAndCharacterOfPosition(node.getStart(this.sourceFile)).line,endLine=this.sourceFile.getLineAndCharacterOfPosition(node.getEnd()).line;return startLine===endLine},FormattingContext.prototype.BlockIsOnOneLine=function(node){var openBrace=ts.findChildOfKind(node,15,this.sourceFile),closeBrace=ts.findChildOfKind(node,16,this.sourceFile);if(openBrace&&closeBrace){var startLine=this.sourceFile.getLineAndCharacterOfPosition(openBrace.getEnd()).line,endLine=this.sourceFile.getLineAndCharacterOfPosition(closeBrace.getStart(this.sourceFile)).line;return startLine===endLine}return!1},FormattingContext}();formatting.FormattingContext=FormattingContext}(formatting=ts.formatting||(ts.formatting={}))}(ts||(ts={}));var ts;!function(ts){var formatting;!function(formatting){!function(FormattingRequestKind){FormattingRequestKind[FormattingRequestKind.FormatDocument=0]="FormatDocument",FormattingRequestKind[FormattingRequestKind.FormatSelection=1]="FormatSelection",FormattingRequestKind[FormattingRequestKind.FormatOnEnter=2]="FormatOnEnter",FormattingRequestKind[FormattingRequestKind.FormatOnSemicolon=3]="FormatOnSemicolon",FormattingRequestKind[FormattingRequestKind.FormatOnClosingCurlyBrace=4]="FormatOnClosingCurlyBrace"}(formatting.FormattingRequestKind||(formatting.FormattingRequestKind={}));formatting.FormattingRequestKind}(formatting=ts.formatting||(ts.formatting={}))}(ts||(ts={}));var ts;!function(ts){var formatting;!function(formatting){var Rule=function(){function Rule(Descriptor,Operation,Flag){void 0===Flag&&(Flag=0),this.Descriptor=Descriptor,this.Operation=Operation,this.Flag=Flag}return Rule.prototype.toString=function(){return"[desc="+this.Descriptor+",operation="+this.Operation+",flag="+this.Flag+"]"},Rule}();formatting.Rule=Rule}(formatting=ts.formatting||(ts.formatting={}))}(ts||(ts={}));var ts;!function(ts){var formatting;!function(formatting){!function(RuleAction){RuleAction[RuleAction.Ignore=1]="Ignore",RuleAction[RuleAction.Space=2]="Space",RuleAction[RuleAction.NewLine=4]="NewLine",RuleAction[RuleAction.Delete=8]="Delete"}(formatting.RuleAction||(formatting.RuleAction={}));formatting.RuleAction}(formatting=ts.formatting||(ts.formatting={}))}(ts||(ts={}));var ts;!function(ts){var formatting;!function(formatting){var RuleDescriptor=function(){function RuleDescriptor(LeftTokenRange,RightTokenRange){this.LeftTokenRange=LeftTokenRange,this.RightTokenRange=RightTokenRange}return RuleDescriptor.prototype.toString=function(){return"[leftRange="+this.LeftTokenRange+",rightRange="+this.RightTokenRange+"]"},RuleDescriptor.create1=function(left,right){return RuleDescriptor.create4(formatting.Shared.TokenRange.FromToken(left),formatting.Shared.TokenRange.FromToken(right))},RuleDescriptor.create2=function(left,right){return RuleDescriptor.create4(left,formatting.Shared.TokenRange.FromToken(right))},RuleDescriptor.create3=function(left,right){return RuleDescriptor.create4(formatting.Shared.TokenRange.FromToken(left),right)},RuleDescriptor.create4=function(left,right){return new RuleDescriptor(left,right)},RuleDescriptor}();formatting.RuleDescriptor=RuleDescriptor}(formatting=ts.formatting||(ts.formatting={}))}(ts||(ts={}));var ts;!function(ts){var formatting;!function(formatting){!function(RuleFlags){RuleFlags[RuleFlags.None=0]="None",RuleFlags[RuleFlags.CanDeleteNewLines=1]="CanDeleteNewLines"}(formatting.RuleFlags||(formatting.RuleFlags={}));formatting.RuleFlags}(formatting=ts.formatting||(ts.formatting={}))}(ts||(ts={}));var ts;!function(ts){var formatting;!function(formatting){var RuleOperation=function(){function RuleOperation(){this.Context=null,this.Action=null}return RuleOperation.prototype.toString=function(){return"[context="+this.Context+",action="+this.Action+"]"},RuleOperation.create1=function(action){return RuleOperation.create2(formatting.RuleOperationContext.Any,action)},RuleOperation.create2=function(context,action){var result=new RuleOperation;return result.Context=context,result.Action=action,result},RuleOperation}();formatting.RuleOperation=RuleOperation}(formatting=ts.formatting||(ts.formatting={}))}(ts||(ts={}));var ts;!function(ts){var formatting;!function(formatting){var RuleOperationContext=function(){function RuleOperationContext(){for(var funcs=[],_i=0;_i<arguments.length;_i++)funcs[_i-0]=arguments[_i];this.customContextChecks=funcs}return RuleOperationContext.prototype.IsAny=function(){return this===RuleOperationContext.Any},RuleOperationContext.prototype.InContext=function(context){if(this.IsAny())return!0;for(var _i=0,_a=this.customContextChecks;_i<_a.length;_i++){var check=_a[_i];if(!check(context))return!1}return!0},RuleOperationContext.Any=new RuleOperationContext,RuleOperationContext}();formatting.RuleOperationContext=RuleOperationContext}(formatting=ts.formatting||(ts.formatting={}))}(ts||(ts={}));var ts;!function(ts){var formatting;!function(formatting){var Rules=function(){function Rules(){this.IgnoreBeforeComment=new formatting.Rule(formatting.RuleDescriptor.create4(formatting.Shared.TokenRange.Any,formatting.Shared.TokenRange.Comments),formatting.RuleOperation.create1(1)),this.IgnoreAfterLineComment=new formatting.Rule(formatting.RuleDescriptor.create3(2,formatting.Shared.TokenRange.Any),formatting.RuleOperation.create1(1)),this.NoSpaceBeforeSemicolon=new formatting.Rule(formatting.RuleDescriptor.create2(formatting.Shared.TokenRange.Any,23),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),8)),this.NoSpaceBeforeColon=new formatting.Rule(formatting.RuleDescriptor.create2(formatting.Shared.TokenRange.Any,54),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsNotBinaryOpContext),8)),this.NoSpaceBeforeQuestionMark=new formatting.Rule(formatting.RuleDescriptor.create2(formatting.Shared.TokenRange.Any,53),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsNotBinaryOpContext),8)),this.SpaceAfterColon=new formatting.Rule(formatting.RuleDescriptor.create3(54,formatting.Shared.TokenRange.Any),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsNotBinaryOpContext),2)),this.SpaceAfterQuestionMarkInConditionalOperator=new formatting.Rule(formatting.RuleDescriptor.create3(53,formatting.Shared.TokenRange.Any),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsConditionalOperatorContext),2)),this.NoSpaceAfterQuestionMark=new formatting.Rule(formatting.RuleDescriptor.create3(53,formatting.Shared.TokenRange.Any),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),8)),this.SpaceAfterSemicolon=new formatting.Rule(formatting.RuleDescriptor.create3(23,formatting.Shared.TokenRange.Any),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),2)),this.SpaceAfterCloseBrace=new formatting.Rule(formatting.RuleDescriptor.create3(16,formatting.Shared.TokenRange.Any),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsAfterCodeBlockContext),2)),this.SpaceBetweenCloseBraceAndElse=new formatting.Rule(formatting.RuleDescriptor.create1(16,80),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),2)),this.SpaceBetweenCloseBraceAndWhile=new formatting.Rule(formatting.RuleDescriptor.create1(16,104),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),2)),this.NoSpaceAfterCloseBrace=new formatting.Rule(formatting.RuleDescriptor.create3(16,formatting.Shared.TokenRange.FromTokens([18,20,24,23])),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),8)),this.NoSpaceBeforeDot=new formatting.Rule(formatting.RuleDescriptor.create2(formatting.Shared.TokenRange.Any,21),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),8)),this.NoSpaceAfterDot=new formatting.Rule(formatting.RuleDescriptor.create3(21,formatting.Shared.TokenRange.Any),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),8)),this.NoSpaceBeforeOpenBracket=new formatting.Rule(formatting.RuleDescriptor.create2(formatting.Shared.TokenRange.Any,19),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),8)),this.NoSpaceAfterCloseBracket=new formatting.Rule(formatting.RuleDescriptor.create3(20,formatting.Shared.TokenRange.Any),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsNotBeforeBlockInFunctionDeclarationContext),8)),this.FunctionOpenBraceLeftTokenRange=formatting.Shared.TokenRange.AnyIncludingMultilineComments,this.SpaceBeforeOpenBraceInFunction=new formatting.Rule(formatting.RuleDescriptor.create2(this.FunctionOpenBraceLeftTokenRange,15),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsFunctionDeclContext,Rules.IsBeforeBlockContext,Rules.IsNotFormatOnEnter,Rules.IsSameLineTokenOrBeforeMultilineBlockContext),2),1),this.TypeScriptOpenBraceLeftTokenRange=formatting.Shared.TokenRange.FromTokens([69,3,73]),this.SpaceBeforeOpenBraceInTypeScriptDeclWithBlock=new formatting.Rule(formatting.RuleDescriptor.create2(this.TypeScriptOpenBraceLeftTokenRange,15),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsTypeScriptDeclWithBlockContext,Rules.IsNotFormatOnEnter,Rules.IsSameLineTokenOrBeforeMultilineBlockContext),2),1),this.ControlOpenBraceLeftTokenRange=formatting.Shared.TokenRange.FromTokens([18,3,79,100,85,80]),this.SpaceBeforeOpenBraceInControl=new formatting.Rule(formatting.RuleDescriptor.create2(this.ControlOpenBraceLeftTokenRange,15),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsControlDeclContext,Rules.IsNotFormatOnEnter,Rules.IsSameLineTokenOrBeforeMultilineBlockContext),2),1),this.SpaceAfterOpenBrace=new formatting.Rule(formatting.RuleDescriptor.create3(15,formatting.Shared.TokenRange.Any),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSingleLineBlockContext),2)),this.SpaceBeforeCloseBrace=new formatting.Rule(formatting.RuleDescriptor.create2(formatting.Shared.TokenRange.Any,16),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSingleLineBlockContext),2)),this.NoSpaceBetweenEmptyBraceBrackets=new formatting.Rule(formatting.RuleDescriptor.create1(15,16),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsObjectContext),8)),this.NewLineAfterOpenBraceInBlockContext=new formatting.Rule(formatting.RuleDescriptor.create3(15,formatting.Shared.TokenRange.Any),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsMultilineBlockContext),4)),this.NewLineBeforeCloseBraceInBlockContext=new formatting.Rule(formatting.RuleDescriptor.create2(formatting.Shared.TokenRange.AnyIncludingMultilineComments,16),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsMultilineBlockContext),4)),this.NoSpaceAfterUnaryPrefixOperator=new formatting.Rule(formatting.RuleDescriptor.create4(formatting.Shared.TokenRange.UnaryPrefixOperators,formatting.Shared.TokenRange.UnaryPrefixExpressions),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsNotBinaryOpContext),8)),this.NoSpaceAfterUnaryPreincrementOperator=new formatting.Rule(formatting.RuleDescriptor.create3(41,formatting.Shared.TokenRange.UnaryPreincrementExpressions),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),8)),this.NoSpaceAfterUnaryPredecrementOperator=new formatting.Rule(formatting.RuleDescriptor.create3(42,formatting.Shared.TokenRange.UnaryPredecrementExpressions),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),8)),this.NoSpaceBeforeUnaryPostincrementOperator=new formatting.Rule(formatting.RuleDescriptor.create2(formatting.Shared.TokenRange.UnaryPostincrementExpressions,41),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),8)),this.NoSpaceBeforeUnaryPostdecrementOperator=new formatting.Rule(formatting.RuleDescriptor.create2(formatting.Shared.TokenRange.UnaryPostdecrementExpressions,42),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),8)),this.SpaceAfterPostincrementWhenFollowedByAdd=new formatting.Rule(formatting.RuleDescriptor.create1(41,35),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsBinaryOpContext),2)),this.SpaceAfterAddWhenFollowedByUnaryPlus=new formatting.Rule(formatting.RuleDescriptor.create1(35,35),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsBinaryOpContext),2)),this.SpaceAfterAddWhenFollowedByPreincrement=new formatting.Rule(formatting.RuleDescriptor.create1(35,41),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsBinaryOpContext),2)),this.SpaceAfterPostdecrementWhenFollowedBySubtract=new formatting.Rule(formatting.RuleDescriptor.create1(42,36),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsBinaryOpContext),2)),this.SpaceAfterSubtractWhenFollowedByUnaryMinus=new formatting.Rule(formatting.RuleDescriptor.create1(36,36),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsBinaryOpContext),2)),this.SpaceAfterSubtractWhenFollowedByPredecrement=new formatting.Rule(formatting.RuleDescriptor.create1(36,42),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsBinaryOpContext),2)),this.NoSpaceBeforeComma=new formatting.Rule(formatting.RuleDescriptor.create2(formatting.Shared.TokenRange.Any,24),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),8)),this.SpaceAfterCertainKeywords=new formatting.Rule(formatting.RuleDescriptor.create4(formatting.Shared.TokenRange.FromTokens([102,98,92,78,94,101,119]),formatting.Shared.TokenRange.Any),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),2)),this.SpaceAfterLetConstInVariableDeclaration=new formatting.Rule(formatting.RuleDescriptor.create4(formatting.Shared.TokenRange.FromTokens([108,74]),formatting.Shared.TokenRange.Any),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsStartOfVariableDeclarationList),2)),this.NoSpaceBeforeOpenParenInFuncCall=new formatting.Rule(formatting.RuleDescriptor.create2(formatting.Shared.TokenRange.Any,17),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsFunctionCallOrNewContext,Rules.IsPreviousTokenNotComma),8)),this.SpaceAfterFunctionInFuncDecl=new formatting.Rule(formatting.RuleDescriptor.create3(87,formatting.Shared.TokenRange.Any),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsFunctionDeclContext),2)),this.NoSpaceBeforeOpenParenInFuncDecl=new formatting.Rule(formatting.RuleDescriptor.create2(formatting.Shared.TokenRange.Any,17),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsFunctionDeclContext),8)),this.SpaceAfterVoidOperator=new formatting.Rule(formatting.RuleDescriptor.create3(103,formatting.Shared.TokenRange.Any),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsVoidOpContext),2)),this.NoSpaceBetweenReturnAndSemicolon=new formatting.Rule(formatting.RuleDescriptor.create1(94,23),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),8)),this.SpaceBetweenStatements=new formatting.Rule(formatting.RuleDescriptor.create4(formatting.Shared.TokenRange.FromTokens([18,79,80,71]),formatting.Shared.TokenRange.Any),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsNotForContext),2)),this.SpaceAfterTryFinally=new formatting.Rule(formatting.RuleDescriptor.create2(formatting.Shared.TokenRange.FromTokens([100,85]),15),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),2)),this.SpaceAfterGetSetInMember=new formatting.Rule(formatting.RuleDescriptor.create2(formatting.Shared.TokenRange.FromTokens([123,129]),69),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsFunctionDeclContext),2)),this.SpaceBeforeBinaryKeywordOperator=new formatting.Rule(formatting.RuleDescriptor.create4(formatting.Shared.TokenRange.Any,formatting.Shared.TokenRange.BinaryKeywordOperators),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsBinaryOpContext),2)),this.SpaceAfterBinaryKeywordOperator=new formatting.Rule(formatting.RuleDescriptor.create4(formatting.Shared.TokenRange.BinaryKeywordOperators,formatting.Shared.TokenRange.Any),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsBinaryOpContext),2)),this.NoSpaceAfterConstructor=new formatting.Rule(formatting.RuleDescriptor.create1(121,17),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),8)),this.NoSpaceAfterModuleImport=new formatting.Rule(formatting.RuleDescriptor.create2(formatting.Shared.TokenRange.FromTokens([125,127]),17),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),8)),this.SpaceAfterCertainTypeScriptKeywords=new formatting.Rule(formatting.RuleDescriptor.create4(formatting.Shared.TokenRange.FromTokens([115,73,122,77,81,82,83,123,106,89,107,125,126,110,112,111,129,113,132]),formatting.Shared.TokenRange.Any),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),2)),this.SpaceBeforeCertainTypeScriptKeywords=new formatting.Rule(formatting.RuleDescriptor.create4(formatting.Shared.TokenRange.Any,formatting.Shared.TokenRange.FromTokens([83,106])),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),2)),this.SpaceAfterModuleName=new formatting.Rule(formatting.RuleDescriptor.create1(9,15),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsModuleDeclContext),2)),this.SpaceBeforeArrow=new formatting.Rule(formatting.RuleDescriptor.create2(formatting.Shared.TokenRange.Any,34),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),2)),this.SpaceAfterArrow=new formatting.Rule(formatting.RuleDescriptor.create3(34,formatting.Shared.TokenRange.Any),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),2)),this.NoSpaceAfterEllipsis=new formatting.Rule(formatting.RuleDescriptor.create1(22,69),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),8)),this.NoSpaceAfterOptionalParameters=new formatting.Rule(formatting.RuleDescriptor.create3(53,formatting.Shared.TokenRange.FromTokens([18,24])),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsNotBinaryOpContext),8)),this.NoSpaceBeforeOpenAngularBracket=new formatting.Rule(formatting.RuleDescriptor.create2(formatting.Shared.TokenRange.TypeNames,25),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsTypeArgumentOrParameterOrAssertionContext),8)),this.NoSpaceBetweenCloseParenAndAngularBracket=new formatting.Rule(formatting.RuleDescriptor.create1(18,25),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsTypeArgumentOrParameterOrAssertionContext),8)),this.NoSpaceAfterOpenAngularBracket=new formatting.Rule(formatting.RuleDescriptor.create3(25,formatting.Shared.TokenRange.Any),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsTypeArgumentOrParameterOrAssertionContext),8)),this.NoSpaceBeforeCloseAngularBracket=new formatting.Rule(formatting.RuleDescriptor.create2(formatting.Shared.TokenRange.Any,27),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsTypeArgumentOrParameterOrAssertionContext),8)),this.NoSpaceAfterCloseAngularBracket=new formatting.Rule(formatting.RuleDescriptor.create3(27,formatting.Shared.TokenRange.FromTokens([17,19,27,24])),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsTypeArgumentOrParameterOrAssertionContext),8)),this.NoSpaceAfterTypeAssertion=new formatting.Rule(formatting.RuleDescriptor.create3(27,formatting.Shared.TokenRange.Any),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsTypeAssertionContext),8)),this.NoSpaceBetweenEmptyInterfaceBraceBrackets=new formatting.Rule(formatting.RuleDescriptor.create1(15,16),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsObjectTypeContext),8)),this.SpaceBeforeAt=new formatting.Rule(formatting.RuleDescriptor.create2(formatting.Shared.TokenRange.Any,55),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),2)),this.NoSpaceAfterAt=new formatting.Rule(formatting.RuleDescriptor.create3(55,formatting.Shared.TokenRange.Any),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),8)),this.SpaceAfterDecorator=new formatting.Rule(formatting.RuleDescriptor.create4(formatting.Shared.TokenRange.Any,formatting.Shared.TokenRange.FromTokens([115,69,82,77,73,113,112,110,111,123,129,19,37])),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsEndOfDecoratorContextOnSameLine),2)),
this.NoSpaceBetweenFunctionKeywordAndStar=new formatting.Rule(formatting.RuleDescriptor.create1(87,37),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsFunctionDeclarationOrFunctionExpressionContext),8)),this.SpaceAfterStarInGeneratorDeclaration=new formatting.Rule(formatting.RuleDescriptor.create3(37,formatting.Shared.TokenRange.FromTokens([69,17])),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsFunctionDeclarationOrFunctionExpressionContext),2)),this.NoSpaceBetweenYieldKeywordAndStar=new formatting.Rule(formatting.RuleDescriptor.create1(114,37),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsYieldOrYieldStarWithOperand),8)),this.SpaceBetweenYieldOrYieldStarAndOperand=new formatting.Rule(formatting.RuleDescriptor.create4(formatting.Shared.TokenRange.FromTokens([114,37]),formatting.Shared.TokenRange.Any),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsYieldOrYieldStarWithOperand),2)),this.SpaceBetweenAsyncAndOpenParen=new formatting.Rule(formatting.RuleDescriptor.create1(118,17),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsArrowFunctionContext,Rules.IsSameLineTokenContext),2)),this.SpaceBetweenAsyncAndFunctionKeyword=new formatting.Rule(formatting.RuleDescriptor.create1(118,87),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),2)),this.NoSpaceBetweenTagAndTemplateString=new formatting.Rule(formatting.RuleDescriptor.create3(69,formatting.Shared.TokenRange.FromTokens([11,12])),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),8)),this.HighPriorityCommonRules=[this.IgnoreBeforeComment,this.IgnoreAfterLineComment,this.NoSpaceBeforeColon,this.SpaceAfterColon,this.NoSpaceBeforeQuestionMark,this.SpaceAfterQuestionMarkInConditionalOperator,this.NoSpaceAfterQuestionMark,this.NoSpaceBeforeDot,this.NoSpaceAfterDot,this.NoSpaceAfterUnaryPrefixOperator,this.NoSpaceAfterUnaryPreincrementOperator,this.NoSpaceAfterUnaryPredecrementOperator,this.NoSpaceBeforeUnaryPostincrementOperator,this.NoSpaceBeforeUnaryPostdecrementOperator,this.SpaceAfterPostincrementWhenFollowedByAdd,this.SpaceAfterAddWhenFollowedByUnaryPlus,this.SpaceAfterAddWhenFollowedByPreincrement,this.SpaceAfterPostdecrementWhenFollowedBySubtract,this.SpaceAfterSubtractWhenFollowedByUnaryMinus,this.SpaceAfterSubtractWhenFollowedByPredecrement,this.NoSpaceAfterCloseBrace,this.SpaceAfterOpenBrace,this.SpaceBeforeCloseBrace,this.NewLineBeforeCloseBraceInBlockContext,this.SpaceAfterCloseBrace,this.SpaceBetweenCloseBraceAndElse,this.SpaceBetweenCloseBraceAndWhile,this.NoSpaceBetweenEmptyBraceBrackets,this.NoSpaceBetweenFunctionKeywordAndStar,this.SpaceAfterStarInGeneratorDeclaration,this.SpaceAfterFunctionInFuncDecl,this.NewLineAfterOpenBraceInBlockContext,this.SpaceAfterGetSetInMember,this.NoSpaceBetweenYieldKeywordAndStar,this.SpaceBetweenYieldOrYieldStarAndOperand,this.NoSpaceBetweenReturnAndSemicolon,this.SpaceAfterCertainKeywords,this.SpaceAfterLetConstInVariableDeclaration,this.NoSpaceBeforeOpenParenInFuncCall,this.SpaceBeforeBinaryKeywordOperator,this.SpaceAfterBinaryKeywordOperator,this.SpaceAfterVoidOperator,this.SpaceBetweenAsyncAndOpenParen,this.SpaceBetweenAsyncAndFunctionKeyword,this.NoSpaceBetweenTagAndTemplateString,this.NoSpaceAfterConstructor,this.NoSpaceAfterModuleImport,this.SpaceAfterCertainTypeScriptKeywords,this.SpaceBeforeCertainTypeScriptKeywords,this.SpaceAfterModuleName,this.SpaceBeforeArrow,this.SpaceAfterArrow,this.NoSpaceAfterEllipsis,this.NoSpaceAfterOptionalParameters,this.NoSpaceBetweenEmptyInterfaceBraceBrackets,this.NoSpaceBeforeOpenAngularBracket,this.NoSpaceBetweenCloseParenAndAngularBracket,this.NoSpaceAfterOpenAngularBracket,this.NoSpaceBeforeCloseAngularBracket,this.NoSpaceAfterCloseAngularBracket,this.NoSpaceAfterTypeAssertion,this.SpaceBeforeAt,this.NoSpaceAfterAt,this.SpaceAfterDecorator],this.LowPriorityCommonRules=[this.NoSpaceBeforeSemicolon,this.SpaceBeforeOpenBraceInControl,this.SpaceBeforeOpenBraceInFunction,this.SpaceBeforeOpenBraceInTypeScriptDeclWithBlock,this.NoSpaceBeforeComma,this.NoSpaceBeforeOpenBracket,this.NoSpaceAfterCloseBracket,this.SpaceAfterSemicolon,this.NoSpaceBeforeOpenParenInFuncDecl,this.SpaceBetweenStatements,this.SpaceAfterTryFinally],this.SpaceAfterComma=new formatting.Rule(formatting.RuleDescriptor.create3(24,formatting.Shared.TokenRange.Any),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsNextTokenNotCloseBracket),2)),this.NoSpaceAfterComma=new formatting.Rule(formatting.RuleDescriptor.create3(24,formatting.Shared.TokenRange.Any),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),8)),this.SpaceBeforeBinaryOperator=new formatting.Rule(formatting.RuleDescriptor.create4(formatting.Shared.TokenRange.Any,formatting.Shared.TokenRange.BinaryOperators),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsBinaryOpContext),2)),this.SpaceAfterBinaryOperator=new formatting.Rule(formatting.RuleDescriptor.create4(formatting.Shared.TokenRange.BinaryOperators,formatting.Shared.TokenRange.Any),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsBinaryOpContext),2)),this.NoSpaceBeforeBinaryOperator=new formatting.Rule(formatting.RuleDescriptor.create4(formatting.Shared.TokenRange.Any,formatting.Shared.TokenRange.BinaryOperators),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsBinaryOpContext),8)),this.NoSpaceAfterBinaryOperator=new formatting.Rule(formatting.RuleDescriptor.create4(formatting.Shared.TokenRange.BinaryOperators,formatting.Shared.TokenRange.Any),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsBinaryOpContext),8)),this.SpaceAfterKeywordInControl=new formatting.Rule(formatting.RuleDescriptor.create2(formatting.Shared.TokenRange.Keywords,17),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsControlDeclContext),2)),this.NoSpaceAfterKeywordInControl=new formatting.Rule(formatting.RuleDescriptor.create2(formatting.Shared.TokenRange.Keywords,17),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsControlDeclContext),8)),this.NewLineBeforeOpenBraceInFunction=new formatting.Rule(formatting.RuleDescriptor.create2(this.FunctionOpenBraceLeftTokenRange,15),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsFunctionDeclContext,Rules.IsBeforeMultilineBlockContext),4),1),this.NewLineBeforeOpenBraceInTypeScriptDeclWithBlock=new formatting.Rule(formatting.RuleDescriptor.create2(this.TypeScriptOpenBraceLeftTokenRange,15),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsTypeScriptDeclWithBlockContext,Rules.IsBeforeMultilineBlockContext),4),1),this.NewLineBeforeOpenBraceInControl=new formatting.Rule(formatting.RuleDescriptor.create2(this.ControlOpenBraceLeftTokenRange,15),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsControlDeclContext,Rules.IsBeforeMultilineBlockContext),4),1),this.SpaceAfterSemicolonInFor=new formatting.Rule(formatting.RuleDescriptor.create3(23,formatting.Shared.TokenRange.Any),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsForContext),2)),this.NoSpaceAfterSemicolonInFor=new formatting.Rule(formatting.RuleDescriptor.create3(23,formatting.Shared.TokenRange.Any),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext,Rules.IsForContext),8)),this.SpaceAfterOpenParen=new formatting.Rule(formatting.RuleDescriptor.create3(17,formatting.Shared.TokenRange.Any),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),2)),this.SpaceBeforeCloseParen=new formatting.Rule(formatting.RuleDescriptor.create2(formatting.Shared.TokenRange.Any,18),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),2)),this.NoSpaceBetweenParens=new formatting.Rule(formatting.RuleDescriptor.create1(17,18),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),8)),this.NoSpaceAfterOpenParen=new formatting.Rule(formatting.RuleDescriptor.create3(17,formatting.Shared.TokenRange.Any),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),8)),this.NoSpaceBeforeCloseParen=new formatting.Rule(formatting.RuleDescriptor.create2(formatting.Shared.TokenRange.Any,18),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),8)),this.SpaceAfterOpenBracket=new formatting.Rule(formatting.RuleDescriptor.create3(19,formatting.Shared.TokenRange.Any),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),2)),this.SpaceBeforeCloseBracket=new formatting.Rule(formatting.RuleDescriptor.create2(formatting.Shared.TokenRange.Any,20),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),2)),this.NoSpaceBetweenBrackets=new formatting.Rule(formatting.RuleDescriptor.create1(19,20),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),8)),this.NoSpaceAfterOpenBracket=new formatting.Rule(formatting.RuleDescriptor.create3(19,formatting.Shared.TokenRange.Any),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),8)),this.NoSpaceBeforeCloseBracket=new formatting.Rule(formatting.RuleDescriptor.create2(formatting.Shared.TokenRange.Any,20),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),8)),this.NoSpaceAfterTemplateHeadAndMiddle=new formatting.Rule(formatting.RuleDescriptor.create4(formatting.Shared.TokenRange.FromTokens([12,13]),formatting.Shared.TokenRange.Any),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),8)),this.SpaceAfterTemplateHeadAndMiddle=new formatting.Rule(formatting.RuleDescriptor.create4(formatting.Shared.TokenRange.FromTokens([12,13]),formatting.Shared.TokenRange.Any),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),2)),this.NoSpaceBeforeTemplateMiddleAndTail=new formatting.Rule(formatting.RuleDescriptor.create4(formatting.Shared.TokenRange.Any,formatting.Shared.TokenRange.FromTokens([13,14])),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),8)),this.SpaceBeforeTemplateMiddleAndTail=new formatting.Rule(formatting.RuleDescriptor.create4(formatting.Shared.TokenRange.Any,formatting.Shared.TokenRange.FromTokens([13,14])),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsSameLineTokenContext),2)),this.SpaceAfterAnonymousFunctionKeyword=new formatting.Rule(formatting.RuleDescriptor.create1(87,17),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsFunctionDeclContext),2)),this.NoSpaceAfterAnonymousFunctionKeyword=new formatting.Rule(formatting.RuleDescriptor.create1(87,17),formatting.RuleOperation.create2(new formatting.RuleOperationContext(Rules.IsFunctionDeclContext),8))}return Rules.prototype.getRuleName=function(rule){var o=this;for(var name_34 in o)if(o[name_34]===rule)return name_34;throw new Error("Unknown rule")},Rules.IsForContext=function(context){return 202===context.contextNode.kind},Rules.IsNotForContext=function(context){return!Rules.IsForContext(context)},Rules.IsBinaryOpContext=function(context){switch(context.contextNode.kind){case 184:case 185:case 192:case 151:case 159:case 160:return!0;case 166:case 219:case 224:case 214:case 139:case 250:case 142:case 141:return 56===context.currentTokenSpan.kind||56===context.nextTokenSpan.kind;case 203:return 90===context.currentTokenSpan.kind||90===context.nextTokenSpan.kind;case 204:return 135===context.currentTokenSpan.kind||135===context.nextTokenSpan.kind}return!1},Rules.IsNotBinaryOpContext=function(context){return!Rules.IsBinaryOpContext(context)},Rules.IsConditionalOperatorContext=function(context){return 185===context.contextNode.kind},Rules.IsSameLineTokenOrBeforeMultilineBlockContext=function(context){return context.TokensAreOnSameLine()||Rules.IsBeforeMultilineBlockContext(context)},Rules.IsBeforeMultilineBlockContext=function(context){return Rules.IsBeforeBlockContext(context)&&!(context.NextNodeAllOnSameLine()||context.NextNodeBlockIsOnOneLine())},Rules.IsMultilineBlockContext=function(context){return Rules.IsBlockContext(context)&&!(context.ContextNodeAllOnSameLine()||context.ContextNodeBlockIsOnOneLine())},Rules.IsSingleLineBlockContext=function(context){return Rules.IsBlockContext(context)&&(context.ContextNodeAllOnSameLine()||context.ContextNodeBlockIsOnOneLine())},Rules.IsBlockContext=function(context){return Rules.NodeIsBlockContext(context.contextNode)},Rules.IsBeforeBlockContext=function(context){return Rules.NodeIsBlockContext(context.nextTokenParent)},Rules.NodeIsBlockContext=function(node){if(Rules.NodeIsTypeScriptDeclWithBlockContext(node))return!0;switch(node.kind){case 195:case 223:case 168:case 222:return!0}return!1},Rules.IsFunctionDeclContext=function(context){switch(context.contextNode.kind){case 216:case 144:case 143:case 146:case 147:case 148:case 176:case 145:case 177:case 218:return!0}return!1},Rules.IsFunctionDeclarationOrFunctionExpressionContext=function(context){return 216===context.contextNode.kind||176===context.contextNode.kind},Rules.IsTypeScriptDeclWithBlockContext=function(context){return Rules.NodeIsTypeScriptDeclWithBlockContext(context.contextNode)},Rules.NodeIsTypeScriptDeclWithBlockContext=function(node){switch(node.kind){case 217:case 189:case 218:case 220:case 156:case 221:return!0}return!1},Rules.IsAfterCodeBlockContext=function(context){switch(context.currentTokenParent.kind){case 217:case 221:case 220:case 195:case 247:case 222:case 209:return!0}return!1},Rules.IsControlDeclContext=function(context){switch(context.contextNode.kind){case 199:case 209:case 202:case 203:case 204:case 201:case 212:case 200:case 208:case 247:return!0;default:return!1}},Rules.IsObjectContext=function(context){return 168===context.contextNode.kind},Rules.IsFunctionCallContext=function(context){return 171===context.contextNode.kind},Rules.IsNewContext=function(context){return 172===context.contextNode.kind},Rules.IsFunctionCallOrNewContext=function(context){return Rules.IsFunctionCallContext(context)||Rules.IsNewContext(context)},Rules.IsPreviousTokenNotComma=function(context){return 24!==context.currentTokenSpan.kind},Rules.IsNextTokenNotCloseBracket=function(context){return 20!==context.nextTokenSpan.kind},Rules.IsArrowFunctionContext=function(context){return 177===context.contextNode.kind},Rules.IsSameLineTokenContext=function(context){return context.TokensAreOnSameLine()},Rules.IsNotBeforeBlockInFunctionDeclarationContext=function(context){return!Rules.IsFunctionDeclContext(context)&&!Rules.IsBeforeBlockContext(context)},Rules.IsEndOfDecoratorContextOnSameLine=function(context){return context.TokensAreOnSameLine()&&context.contextNode.decorators&&Rules.NodeIsInDecoratorContext(context.currentTokenParent)&&!Rules.NodeIsInDecoratorContext(context.nextTokenParent)},Rules.NodeIsInDecoratorContext=function(node){for(;ts.isExpression(node);)node=node.parent;return 140===node.kind},Rules.IsStartOfVariableDeclarationList=function(context){return 215===context.currentTokenParent.kind&&context.currentTokenParent.getStart(context.sourceFile)===context.currentTokenSpan.pos},Rules.IsNotFormatOnEnter=function(context){return 2!==context.formattingRequestKind},Rules.IsModuleDeclContext=function(context){return 221===context.contextNode.kind},Rules.IsObjectTypeContext=function(context){return 156===context.contextNode.kind},Rules.IsTypeArgumentOrParameterOrAssertion=function(token,parent){if(25!==token.kind&&27!==token.kind)return!1;switch(parent.kind){case 152:case 174:case 217:case 189:case 218:case 216:case 176:case 177:case 144:case 143:case 148:case 149:case 171:case 172:case 191:return!0;default:return!1}},Rules.IsTypeArgumentOrParameterOrAssertionContext=function(context){return Rules.IsTypeArgumentOrParameterOrAssertion(context.currentTokenSpan,context.currentTokenParent)||Rules.IsTypeArgumentOrParameterOrAssertion(context.nextTokenSpan,context.nextTokenParent)},Rules.IsTypeAssertionContext=function(context){return 174===context.contextNode.kind},Rules.IsVoidOpContext=function(context){return 103===context.currentTokenSpan.kind&&180===context.currentTokenParent.kind},Rules.IsYieldOrYieldStarWithOperand=function(context){return 187===context.contextNode.kind&&void 0!==context.contextNode.expression},Rules}();formatting.Rules=Rules}(formatting=ts.formatting||(ts.formatting={}))}(ts||(ts={}));var ts;!function(ts){var formatting;!function(formatting){var RulesMap=function(){function RulesMap(){this.map=[],this.mapRowLength=0}return RulesMap.create=function(rules){var result=new RulesMap;return result.Initialize(rules),result},RulesMap.prototype.Initialize=function(rules){this.mapRowLength=136,this.map=new Array(this.mapRowLength*this.mapRowLength);var rulesBucketConstructionStateList=new Array(this.map.length);return this.FillRules(rules,rulesBucketConstructionStateList),this.map},RulesMap.prototype.FillRules=function(rules,rulesBucketConstructionStateList){var _this=this;rules.forEach(function(rule){_this.FillRule(rule,rulesBucketConstructionStateList)})},RulesMap.prototype.GetRuleBucketIndex=function(row,column){var rulesBucketIndex=row*this.mapRowLength+column;return rulesBucketIndex},RulesMap.prototype.FillRule=function(rule,rulesBucketConstructionStateList){var _this=this,specificRule=rule.Descriptor.LeftTokenRange!==formatting.Shared.TokenRange.Any&&rule.Descriptor.RightTokenRange!==formatting.Shared.TokenRange.Any;rule.Descriptor.LeftTokenRange.GetTokens().forEach(function(left){rule.Descriptor.RightTokenRange.GetTokens().forEach(function(right){var rulesBucketIndex=_this.GetRuleBucketIndex(left,right),rulesBucket=_this.map[rulesBucketIndex];void 0===rulesBucket&&(rulesBucket=_this.map[rulesBucketIndex]=new RulesBucket),rulesBucket.AddRule(rule,specificRule,rulesBucketConstructionStateList,rulesBucketIndex)})})},RulesMap.prototype.GetRule=function(context){var bucketIndex=this.GetRuleBucketIndex(context.currentTokenSpan.kind,context.nextTokenSpan.kind),bucket=this.map[bucketIndex];if(null!=bucket)for(var _i=0,_a=bucket.Rules();_i<_a.length;_i++){var rule=_a[_i];if(rule.Operation.Context.InContext(context))return rule}return null},RulesMap}();formatting.RulesMap=RulesMap;var MaskBitSize=5,Mask=31;!function(RulesPosition){RulesPosition[RulesPosition.IgnoreRulesSpecific=0]="IgnoreRulesSpecific",RulesPosition[RulesPosition.IgnoreRulesAny=1*MaskBitSize]="IgnoreRulesAny",RulesPosition[RulesPosition.ContextRulesSpecific=2*MaskBitSize]="ContextRulesSpecific",RulesPosition[RulesPosition.ContextRulesAny=3*MaskBitSize]="ContextRulesAny",RulesPosition[RulesPosition.NoContextRulesSpecific=4*MaskBitSize]="NoContextRulesSpecific",RulesPosition[RulesPosition.NoContextRulesAny=5*MaskBitSize]="NoContextRulesAny"}(formatting.RulesPosition||(formatting.RulesPosition={}));var RulesPosition=formatting.RulesPosition,RulesBucketConstructionState=function(){function RulesBucketConstructionState(){this.rulesInsertionIndexBitmap=0}return RulesBucketConstructionState.prototype.GetInsertionIndex=function(maskPosition){for(var index=0,pos=0,indexBitmap=this.rulesInsertionIndexBitmap;pos<=maskPosition;)index+=indexBitmap&Mask,indexBitmap>>=MaskBitSize,pos+=MaskBitSize;return index},RulesBucketConstructionState.prototype.IncreaseInsertionIndex=function(maskPosition){var value=this.rulesInsertionIndexBitmap>>maskPosition&Mask;value++,ts.Debug.assert((value&Mask)===value,"Adding more rules into the sub-bucket than allowed. Maximum allowed is 32 rules.");var temp=this.rulesInsertionIndexBitmap&~(Mask<<maskPosition);temp|=value<<maskPosition,this.rulesInsertionIndexBitmap=temp},RulesBucketConstructionState}();formatting.RulesBucketConstructionState=RulesBucketConstructionState;var RulesBucket=function(){function RulesBucket(){this.rules=[]}return RulesBucket.prototype.Rules=function(){return this.rules},RulesBucket.prototype.AddRule=function(rule,specificTokens,constructionState,rulesBucketIndex){var position;position=1===rule.Operation.Action?specificTokens?RulesPosition.IgnoreRulesSpecific:RulesPosition.IgnoreRulesAny:rule.Operation.Context.IsAny()?specificTokens?RulesPosition.NoContextRulesSpecific:RulesPosition.NoContextRulesAny:specificTokens?RulesPosition.ContextRulesSpecific:RulesPosition.ContextRulesAny;var state=constructionState[rulesBucketIndex];void 0===state&&(state=constructionState[rulesBucketIndex]=new RulesBucketConstructionState);var index=state.GetInsertionIndex(position);this.rules.splice(index,0,rule),state.IncreaseInsertionIndex(position)},RulesBucket}();formatting.RulesBucket=RulesBucket}(formatting=ts.formatting||(ts.formatting={}))}(ts||(ts={}));var ts;!function(ts){var formatting;!function(formatting){var Shared;!function(Shared){var TokenRangeAccess=function(){function TokenRangeAccess(from,to,except){this.tokens=[];for(var token=from;token<=to;token++)ts.indexOf(except,token)<0&&this.tokens.push(token)}return TokenRangeAccess.prototype.GetTokens=function(){return this.tokens},TokenRangeAccess.prototype.Contains=function(token){return this.tokens.indexOf(token)>=0},TokenRangeAccess}();Shared.TokenRangeAccess=TokenRangeAccess;var TokenValuesAccess=function(){function TokenValuesAccess(tks){this.tokens=tks&&tks.length?tks:[]}return TokenValuesAccess.prototype.GetTokens=function(){return this.tokens},TokenValuesAccess.prototype.Contains=function(token){return this.tokens.indexOf(token)>=0},TokenValuesAccess}();Shared.TokenValuesAccess=TokenValuesAccess;var TokenSingleValueAccess=function(){function TokenSingleValueAccess(token){this.token=token}return TokenSingleValueAccess.prototype.GetTokens=function(){return[this.token]},TokenSingleValueAccess.prototype.Contains=function(tokenValue){return tokenValue===this.token},TokenSingleValueAccess}();Shared.TokenSingleValueAccess=TokenSingleValueAccess;var TokenAllAccess=function(){function TokenAllAccess(){}return TokenAllAccess.prototype.GetTokens=function(){for(var result=[],token=0;token<=135;token++)result.push(token);return result},TokenAllAccess.prototype.Contains=function(tokenValue){return!0},TokenAllAccess.prototype.toString=function(){return"[allTokens]"},TokenAllAccess}();Shared.TokenAllAccess=TokenAllAccess;var TokenRange=function(){function TokenRange(tokenAccess){this.tokenAccess=tokenAccess}return TokenRange.FromToken=function(token){return new TokenRange(new TokenSingleValueAccess(token))},TokenRange.FromTokens=function(tokens){return new TokenRange(new TokenValuesAccess(tokens))},TokenRange.FromRange=function(f,to,except){return void 0===except&&(except=[]),new TokenRange(new TokenRangeAccess(f,to,except))},TokenRange.AllTokens=function(){return new TokenRange(new TokenAllAccess)},TokenRange.prototype.GetTokens=function(){return this.tokenAccess.GetTokens()},TokenRange.prototype.Contains=function(token){return this.tokenAccess.Contains(token)},TokenRange.prototype.toString=function(){return this.tokenAccess.toString()},TokenRange.Any=TokenRange.AllTokens(),TokenRange.AnyIncludingMultilineComments=TokenRange.FromTokens(TokenRange.Any.GetTokens().concat([3])),TokenRange.Keywords=TokenRange.FromRange(70,135),TokenRange.BinaryOperators=TokenRange.FromRange(25,68),TokenRange.BinaryKeywordOperators=TokenRange.FromTokens([90,91,135,116,124]),TokenRange.UnaryPrefixOperators=TokenRange.FromTokens([41,42,50,49]),TokenRange.UnaryPrefixExpressions=TokenRange.FromTokens([8,69,17,19,15,97,92]),TokenRange.UnaryPreincrementExpressions=TokenRange.FromTokens([69,17,97,92]),TokenRange.UnaryPostincrementExpressions=TokenRange.FromTokens([69,18,20,92]),TokenRange.UnaryPredecrementExpressions=TokenRange.FromTokens([69,17,97,92]),TokenRange.UnaryPostdecrementExpressions=TokenRange.FromTokens([69,18,20,92]),TokenRange.Comments=TokenRange.FromTokens([2,3]),TokenRange.TypeNames=TokenRange.FromTokens([69,128,130,120,131,103,117]),TokenRange}();Shared.TokenRange=TokenRange}(Shared=formatting.Shared||(formatting.Shared={}))}(formatting=ts.formatting||(ts.formatting={}))}(ts||(ts={}));var ts;!function(ts){var formatting;!function(formatting){var RulesProvider=function(){function RulesProvider(){this.globalRules=new formatting.Rules}return RulesProvider.prototype.getRuleName=function(rule){return this.globalRules.getRuleName(rule)},RulesProvider.prototype.getRuleByName=function(name){return this.globalRules[name]},RulesProvider.prototype.getRulesMap=function(){return this.rulesMap},RulesProvider.prototype.ensureUpToDate=function(options){if(null==this.options||!ts.compareDataObjects(this.options,options)){var activeRules=this.createActiveRules(options),rulesMap=formatting.RulesMap.create(activeRules);this.activeRules=activeRules,this.rulesMap=rulesMap,this.options=ts.clone(options)}},RulesProvider.prototype.createActiveRules=function(options){var rules=this.globalRules.HighPriorityCommonRules.slice(0);return options.InsertSpaceAfterCommaDelimiter?rules.push(this.globalRules.SpaceAfterComma):rules.push(this.globalRules.NoSpaceAfterComma),options.InsertSpaceAfterFunctionKeywordForAnonymousFunctions?rules.push(this.globalRules.SpaceAfterAnonymousFunctionKeyword):rules.push(this.globalRules.NoSpaceAfterAnonymousFunctionKeyword),options.InsertSpaceAfterKeywordsInControlFlowStatements?rules.push(this.globalRules.SpaceAfterKeywordInControl):rules.push(this.globalRules.NoSpaceAfterKeywordInControl),options.InsertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis?(rules.push(this.globalRules.SpaceAfterOpenParen),rules.push(this.globalRules.SpaceBeforeCloseParen),rules.push(this.globalRules.NoSpaceBetweenParens)):(rules.push(this.globalRules.NoSpaceAfterOpenParen),rules.push(this.globalRules.NoSpaceBeforeCloseParen),rules.push(this.globalRules.NoSpaceBetweenParens)),options.InsertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets?(rules.push(this.globalRules.SpaceAfterOpenBracket),rules.push(this.globalRules.SpaceBeforeCloseBracket),rules.push(this.globalRules.NoSpaceBetweenBrackets)):(rules.push(this.globalRules.NoSpaceAfterOpenBracket),rules.push(this.globalRules.NoSpaceBeforeCloseBracket),rules.push(this.globalRules.NoSpaceBetweenBrackets)),options.InsertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces?(rules.push(this.globalRules.SpaceAfterTemplateHeadAndMiddle),rules.push(this.globalRules.SpaceBeforeTemplateMiddleAndTail)):(rules.push(this.globalRules.NoSpaceAfterTemplateHeadAndMiddle),rules.push(this.globalRules.NoSpaceBeforeTemplateMiddleAndTail)),options.InsertSpaceAfterSemicolonInForStatements?rules.push(this.globalRules.SpaceAfterSemicolonInFor):rules.push(this.globalRules.NoSpaceAfterSemicolonInFor),options.InsertSpaceBeforeAndAfterBinaryOperators?(rules.push(this.globalRules.SpaceBeforeBinaryOperator),rules.push(this.globalRules.SpaceAfterBinaryOperator)):(rules.push(this.globalRules.NoSpaceBeforeBinaryOperator),rules.push(this.globalRules.NoSpaceAfterBinaryOperator)),options.PlaceOpenBraceOnNewLineForControlBlocks&&rules.push(this.globalRules.NewLineBeforeOpenBraceInControl),options.PlaceOpenBraceOnNewLineForFunctions&&(rules.push(this.globalRules.NewLineBeforeOpenBraceInFunction),rules.push(this.globalRules.NewLineBeforeOpenBraceInTypeScriptDeclWithBlock)),rules=rules.concat(this.globalRules.LowPriorityCommonRules)},RulesProvider}();formatting.RulesProvider=RulesProvider}(formatting=ts.formatting||(ts.formatting={}))}(ts||(ts={}));var ts;!function(ts){var formatting;!function(formatting){function formatOnEnter(position,sourceFile,rulesProvider,options){var line=sourceFile.getLineAndCharacterOfPosition(position).line;if(0===line)return[];var span={pos:ts.getStartPositionOfLine(line-1,sourceFile),end:ts.getEndLinePosition(line,sourceFile)+1};return formatSpan(span,sourceFile,options,rulesProvider,2)}function formatOnSemicolon(position,sourceFile,rulesProvider,options){return formatOutermostParent(position,23,sourceFile,options,rulesProvider,3)}function formatOnClosingCurly(position,sourceFile,rulesProvider,options){return formatOutermostParent(position,16,sourceFile,options,rulesProvider,4)}function formatDocument(sourceFile,rulesProvider,options){var span={pos:0,end:sourceFile.text.length};return formatSpan(span,sourceFile,options,rulesProvider,0)}function formatSelection(start,end,sourceFile,rulesProvider,options){var span={pos:ts.getLineStartPositionForPosition(start,sourceFile),end:end};return formatSpan(span,sourceFile,options,rulesProvider,1)}function formatOutermostParent(position,expectedLastToken,sourceFile,options,rulesProvider,requestKind){var parent=findOutermostParent(position,expectedLastToken,sourceFile);if(!parent)return[];var span={pos:ts.getLineStartPositionForPosition(parent.getStart(sourceFile),sourceFile),end:parent.end};return formatSpan(span,sourceFile,options,rulesProvider,requestKind)}function findOutermostParent(position,expectedTokenKind,sourceFile){var precedingToken=ts.findPrecedingToken(position,sourceFile);if(precedingToken&&precedingToken.kind===expectedTokenKind&&position===precedingToken.getEnd()){for(var current=precedingToken;current&&current.parent&&current.parent.end===precedingToken.end&&!isListElement(current.parent,current);)current=current.parent;return current}}function isListElement(parent,node){switch(parent.kind){case 217:case 218:return ts.rangeContainsRange(parent.members,node);case 221:var body=parent.body;return body&&195===body.kind&&ts.rangeContainsRange(body.statements,node);case 251:case 195:case 222:return ts.rangeContainsRange(parent.statements,node);case 247:return ts.rangeContainsRange(parent.block.statements,node)}return!1}function findEnclosingNode(range,sourceFile){function find(n){var candidate=ts.forEachChild(n,function(c){return ts.startEndContainsRange(c.getStart(sourceFile),c.end,range)&&c});if(candidate){var result=find(candidate);if(result)return result}return n}return find(sourceFile)}function prepareRangeContainsErrorFunction(errors,originalRange){function rangeHasNoErrors(r){return!1}if(!errors.length)return rangeHasNoErrors;var sorted=errors.filter(function(d){return ts.rangeOverlapsWithStartEnd(originalRange,d.start,d.start+d.length)}).sort(function(e1,e2){return e1.start-e2.start});if(!sorted.length)return rangeHasNoErrors;var index=0;return function(r){for(;;){if(index>=sorted.length)return!1;var error=sorted[index];if(r.end<=error.start)return!1;if(ts.startEndOverlapsWithStartEnd(r.pos,r.end,error.start,error.start+error.length))return!0;index++}}}function getScanStartPosition(enclosingNode,originalRange,sourceFile){var start=enclosingNode.getStart(sourceFile);if(start===originalRange.pos&&enclosingNode.end===originalRange.end)return start;var precedingToken=ts.findPrecedingToken(originalRange.pos,sourceFile);return precedingToken?precedingToken.end>=originalRange.pos?enclosingNode.pos:precedingToken.end:enclosingNode.pos}function getOwnOrInheritedDelta(n,options,sourceFile){for(var child,previousLine=-1;n;){var line=sourceFile.getLineAndCharacterOfPosition(n.getStart(sourceFile)).line;if(previousLine!==-1&&line!==previousLine)break;if(formatting.SmartIndenter.shouldIndentChildNode(n,child))return options.IndentSize;previousLine=line,child=n,n=n.parent}return 0}function formatSpan(originalRange,sourceFile,options,rulesProvider,requestKind){function tryComputeIndentationForListItem(startPos,endPos,parentStartLine,range,inheritedIndentation){if(ts.rangeOverlapsWithStartEnd(range,startPos,endPos)||ts.rangeContainsStartEnd(range,startPos,endPos)){
if(inheritedIndentation!==-1)return inheritedIndentation}else{var startLine=sourceFile.getLineAndCharacterOfPosition(startPos).line,startLinePosition=ts.getLineStartPositionForPosition(startPos,sourceFile),column=formatting.SmartIndenter.findFirstNonWhitespaceColumn(startLinePosition,startPos,sourceFile,options);if(startLine!==parentStartLine||startPos===column)return column}return-1}function computeIndentation(node,startLine,inheritedIndentation,parent,parentDynamicIndentation,effectiveParentStartLine){var indentation=inheritedIndentation,delta=formatting.SmartIndenter.shouldIndentChildNode(node)?options.IndentSize:0;return effectiveParentStartLine===startLine?(indentation=startLine===lastIndentedLine?indentationOnLastIndentedLine:parentDynamicIndentation.getIndentation(),delta=Math.min(options.IndentSize,parentDynamicIndentation.getDelta(node)+delta)):indentation===-1&&(indentation=formatting.SmartIndenter.childStartsOnTheSameLineWithElseInIfStatement(parent,node,startLine,sourceFile)?parentDynamicIndentation.getIndentation():parentDynamicIndentation.getIndentation()+parentDynamicIndentation.getDelta(node)),{indentation:indentation,delta:delta}}function getFirstNonDecoratorTokenOfNode(node){if(node.modifiers&&node.modifiers.length)return node.modifiers[0].kind;switch(node.kind){case 217:return 73;case 218:return 107;case 216:return 87;case 220:return 220;case 146:return 123;case 147:return 129;case 144:if(node.asteriskToken)return 37;case 142:case 139:return node.name.kind}}function getDynamicIndentation(node,nodeStartLine,indentation,delta){function getEffectiveDelta(delta,child){return formatting.SmartIndenter.nodeWillIndentChild(node,child,!0)?delta:0}return{getIndentationForComment:function(kind,tokenIndentation,container){switch(kind){case 16:case 20:case 18:return indentation+getEffectiveDelta(delta,container)}return tokenIndentation!==-1?tokenIndentation:indentation},getIndentationForToken:function(line,kind,container){if(nodeStartLine!==line&&node.decorators&&kind===getFirstNonDecoratorTokenOfNode(node))return indentation;switch(kind){case 15:case 16:case 19:case 20:case 17:case 18:case 80:case 104:case 55:return indentation;default:return nodeStartLine!==line?indentation+getEffectiveDelta(delta,container):indentation}},getIndentation:function(){return indentation},getDelta:function(child){return getEffectiveDelta(delta,child)},recomputeIndentation:function(lineAdded){node.parent&&formatting.SmartIndenter.shouldIndentChildNode(node.parent,node)&&(lineAdded?indentation+=options.IndentSize:indentation-=options.IndentSize,delta=formatting.SmartIndenter.shouldIndentChildNode(node)?options.IndentSize:0)}}}function processNode(node,contextNode,nodeStartLine,undecoratedNodeStartLine,indentation,delta){function processChildNode(child,inheritedIndentation,parent,parentDynamicIndentation,parentStartLine,undecoratedParentStartLine,isListItem){var childStartPos=child.getStart(sourceFile),childStartLine=sourceFile.getLineAndCharacterOfPosition(childStartPos).line,undecoratedChildStartLine=childStartLine;child.decorators&&(undecoratedChildStartLine=sourceFile.getLineAndCharacterOfPosition(ts.getNonDecoratorTokenPosOfNode(child,sourceFile)).line);var childIndentationAmount=-1;if(isListItem&&(childIndentationAmount=tryComputeIndentationForListItem(childStartPos,child.end,parentStartLine,originalRange,inheritedIndentation),childIndentationAmount!==-1&&(inheritedIndentation=childIndentationAmount)),!ts.rangeOverlapsWithStartEnd(originalRange,child.pos,child.end))return inheritedIndentation;if(0===child.getFullWidth())return inheritedIndentation;for(;formattingScanner.isOnToken();){var tokenInfo=formattingScanner.readTokenInfo(node);if(tokenInfo.token.end>childStartPos)break;consumeTokenAndAdvanceScanner(tokenInfo,node,parentDynamicIndentation)}if(!formattingScanner.isOnToken())return inheritedIndentation;if(ts.isToken(child)){var tokenInfo=formattingScanner.readTokenInfo(child);return ts.Debug.assert(tokenInfo.token.end===child.end),consumeTokenAndAdvanceScanner(tokenInfo,node,parentDynamicIndentation,child),inheritedIndentation}var effectiveParentStartLine=140===child.kind?childStartLine:undecoratedParentStartLine,childIndentation=computeIndentation(child,childStartLine,childIndentationAmount,node,parentDynamicIndentation,effectiveParentStartLine);return processNode(child,childContextNode,childStartLine,undecoratedChildStartLine,childIndentation.indentation,childIndentation.delta),childContextNode=node,inheritedIndentation}function processChildNodes(nodes,parent,parentStartLine,parentDynamicIndentation){var listStartToken=getOpenTokenForList(parent,nodes),listEndToken=getCloseTokenForOpenToken(listStartToken),listDynamicIndentation=parentDynamicIndentation,startLine=parentStartLine;if(0!==listStartToken)for(;formattingScanner.isOnToken();){var tokenInfo=formattingScanner.readTokenInfo(parent);if(tokenInfo.token.end>nodes.pos)break;if(tokenInfo.token.kind===listStartToken){startLine=sourceFile.getLineAndCharacterOfPosition(tokenInfo.token.pos).line;var indentation_1=computeIndentation(tokenInfo.token,startLine,-1,parent,parentDynamicIndentation,parentStartLine);listDynamicIndentation=getDynamicIndentation(parent,parentStartLine,indentation_1.indentation,indentation_1.delta),consumeTokenAndAdvanceScanner(tokenInfo,parent,listDynamicIndentation)}else consumeTokenAndAdvanceScanner(tokenInfo,parent,parentDynamicIndentation)}for(var inheritedIndentation=-1,_i=0,nodes_6=nodes;_i<nodes_6.length;_i++){var child=nodes_6[_i];inheritedIndentation=processChildNode(child,inheritedIndentation,node,listDynamicIndentation,startLine,startLine,!0)}if(0!==listEndToken&&formattingScanner.isOnToken()){var tokenInfo=formattingScanner.readTokenInfo(parent);tokenInfo.token.kind===listEndToken&&ts.rangeContainsRange(parent,tokenInfo.token)&&consumeTokenAndAdvanceScanner(tokenInfo,parent,listDynamicIndentation)}}function consumeTokenAndAdvanceScanner(currentTokenInfo,parent,dynamicIndentation,container){ts.Debug.assert(ts.rangeContainsRange(parent,currentTokenInfo.token));var lastTriviaWasNewLine=formattingScanner.lastTrailingTriviaWasNewLine(),indentToken=!1;currentTokenInfo.leadingTrivia&&processTrivia(currentTokenInfo.leadingTrivia,parent,childContextNode,dynamicIndentation);var lineAdded,isTokenInRange=ts.rangeContainsRange(originalRange,currentTokenInfo.token),tokenStart=sourceFile.getLineAndCharacterOfPosition(currentTokenInfo.token.pos);if(isTokenInRange){var rangeHasError=rangeContainsError(currentTokenInfo.token),savePreviousRange=previousRange;if(lineAdded=processRange(currentTokenInfo.token,tokenStart,parent,childContextNode,dynamicIndentation),rangeHasError)indentToken=!1;else if(void 0!==lineAdded)indentToken=lineAdded;else{var prevEndLine=savePreviousRange&&sourceFile.getLineAndCharacterOfPosition(savePreviousRange.end).line;indentToken=lastTriviaWasNewLine&&tokenStart.line!==prevEndLine}}if(currentTokenInfo.trailingTrivia&&processTrivia(currentTokenInfo.trailingTrivia,parent,childContextNode,dynamicIndentation),indentToken){var tokenIndentation=isTokenInRange&&!rangeContainsError(currentTokenInfo.token)?dynamicIndentation.getIndentationForToken(tokenStart.line,currentTokenInfo.token.kind,container):-1;if(currentTokenInfo.leadingTrivia)for(var commentIndentation=dynamicIndentation.getIndentationForComment(currentTokenInfo.token.kind,tokenIndentation,container),indentNextTokenOrTrivia=!0,_i=0,_a=currentTokenInfo.leadingTrivia;_i<_a.length;_i++){var triviaItem=_a[_i];if(ts.rangeContainsRange(originalRange,triviaItem))switch(triviaItem.kind){case 3:indentMultilineComment(triviaItem,commentIndentation,!indentNextTokenOrTrivia),indentNextTokenOrTrivia=!1;break;case 2:indentNextTokenOrTrivia&&(insertIndentation(triviaItem.pos,commentIndentation,!1),indentNextTokenOrTrivia=!1);break;case 4:indentNextTokenOrTrivia=!0}}tokenIndentation!==-1&&(insertIndentation(currentTokenInfo.token.pos,tokenIndentation,lineAdded),lastIndentedLine=tokenStart.line,indentationOnLastIndentedLine=tokenIndentation)}formattingScanner.advance(),childContextNode=parent}if(ts.rangeOverlapsWithStartEnd(originalRange,node.getStart(sourceFile),node.getEnd())){var nodeDynamicIndentation=getDynamicIndentation(node,nodeStartLine,indentation,delta),childContextNode=contextNode;for(ts.forEachChild(node,function(child){processChildNode(child,-1,node,nodeDynamicIndentation,nodeStartLine,undecoratedNodeStartLine,!1)},function(nodes){processChildNodes(nodes,node,nodeStartLine,nodeDynamicIndentation)});formattingScanner.isOnToken();){var tokenInfo=formattingScanner.readTokenInfo(node);if(tokenInfo.token.end>node.end)break;consumeTokenAndAdvanceScanner(tokenInfo,node,nodeDynamicIndentation)}}}function processTrivia(trivia,parent,contextNode,dynamicIndentation){for(var _i=0,trivia_1=trivia;_i<trivia_1.length;_i++){var triviaItem=trivia_1[_i];if(ts.isComment(triviaItem.kind)&&ts.rangeContainsRange(originalRange,triviaItem)){var triviaItemStart=sourceFile.getLineAndCharacterOfPosition(triviaItem.pos);processRange(triviaItem,triviaItemStart,parent,contextNode,dynamicIndentation)}}}function processRange(range,rangeStart,parent,contextNode,dynamicIndentation){var lineAdded,rangeHasError=rangeContainsError(range);if(!rangeHasError&&!previousRangeHasError)if(previousRange)lineAdded=processPair(range,rangeStart.line,parent,previousRange,previousRangeStartLine,previousParent,contextNode,dynamicIndentation);else{var originalStart=sourceFile.getLineAndCharacterOfPosition(originalRange.pos);trimTrailingWhitespacesForLines(originalStart.line,rangeStart.line)}return previousRange=range,previousParent=parent,previousRangeStartLine=rangeStart.line,previousRangeHasError=rangeHasError,lineAdded}function processPair(currentItem,currentStartLine,currentParent,previousItem,previousStartLine,previousParent,contextNode,dynamicIndentation){formattingContext.updateContext(previousItem,previousParent,currentItem,currentParent,contextNode);var trimTrailingWhitespaces,lineAdded,rule=rulesProvider.getRulesMap().GetRule(formattingContext);return rule?(applyRuleEdits(rule,previousItem,previousStartLine,currentItem,currentStartLine),10&rule.Operation.Action&&currentStartLine!==previousStartLine?(lineAdded=!1,currentParent.getStart(sourceFile)===currentItem.pos&&dynamicIndentation.recomputeIndentation(!1)):4&rule.Operation.Action&&currentStartLine===previousStartLine&&(lineAdded=!0,currentParent.getStart(sourceFile)===currentItem.pos&&dynamicIndentation.recomputeIndentation(!0)),trimTrailingWhitespaces=!(8&rule.Operation.Action)&&1!==rule.Flag):trimTrailingWhitespaces=!0,currentStartLine!==previousStartLine&&trimTrailingWhitespaces&&trimTrailingWhitespacesForLines(previousStartLine,currentStartLine,previousItem),lineAdded}function insertIndentation(pos,indentation,lineAdded){var indentationString=getIndentationString(indentation,options);if(lineAdded)recordReplace(pos,0,indentationString);else{var tokenStart=sourceFile.getLineAndCharacterOfPosition(pos);if(indentation!==tokenStart.character){var startLinePosition=ts.getStartPositionOfLine(tokenStart.line,sourceFile);recordReplace(startLinePosition,tokenStart.character,indentationString)}}}function indentMultilineComment(commentRange,indentation,firstLineIsIndented){var parts,startLine=sourceFile.getLineAndCharacterOfPosition(commentRange.pos).line,endLine=sourceFile.getLineAndCharacterOfPosition(commentRange.end).line;if(startLine===endLine)return void(firstLineIsIndented||insertIndentation(commentRange.pos,indentation,!1));parts=[];for(var startPos=commentRange.pos,line=startLine;line<endLine;++line){var endOfLine=ts.getEndLinePosition(line,sourceFile);parts.push({pos:startPos,end:endOfLine}),startPos=ts.getStartPositionOfLine(line+1,sourceFile)}parts.push({pos:startPos,end:commentRange.end});var startLinePos=ts.getStartPositionOfLine(startLine,sourceFile),nonWhitespaceColumnInFirstPart=formatting.SmartIndenter.findFirstNonWhitespaceCharacterAndColumn(startLinePos,parts[0].pos,sourceFile,options);if(indentation!==nonWhitespaceColumnInFirstPart.column){var startIndex=0;firstLineIsIndented&&(startIndex=1,startLine++);for(var delta=indentation-nonWhitespaceColumnInFirstPart.column,i=startIndex,len=parts.length;i<len;++i,++startLine){var startLinePos_1=ts.getStartPositionOfLine(startLine,sourceFile),nonWhitespaceCharacterAndColumn=0===i?nonWhitespaceColumnInFirstPart:formatting.SmartIndenter.findFirstNonWhitespaceCharacterAndColumn(parts[i].pos,parts[i].end,sourceFile,options),newIndentation=nonWhitespaceCharacterAndColumn.column+delta;if(newIndentation>0){var indentationString=getIndentationString(newIndentation,options);recordReplace(startLinePos_1,nonWhitespaceCharacterAndColumn.character,indentationString)}else recordDelete(startLinePos_1,nonWhitespaceCharacterAndColumn.character)}}}function trimTrailingWhitespacesForLines(line1,line2,range){for(var line=line1;line<line2;++line){var lineStartPosition=ts.getStartPositionOfLine(line,sourceFile),lineEndPosition=ts.getEndLinePosition(line,sourceFile);if(!(range&&(ts.isComment(range.kind)||ts.isStringOrRegularExpressionOrTemplateLiteral(range.kind))&&range.pos<=lineEndPosition&&range.end>lineEndPosition)){var whitespaceStart=getTrailingWhitespaceStartPosition(lineStartPosition,lineEndPosition);whitespaceStart!==-1&&(ts.Debug.assert(whitespaceStart===lineStartPosition||!ts.isWhiteSpace(sourceFile.text.charCodeAt(whitespaceStart-1))),recordDelete(whitespaceStart,lineEndPosition+1-whitespaceStart))}}}function getTrailingWhitespaceStartPosition(start,end){for(var pos=end;pos>=start&&ts.isWhiteSpace(sourceFile.text.charCodeAt(pos));)pos--;return pos!==end?pos+1:-1}function trimTrailingWhitespacesForRemainingRange(){var startPosition=previousRange?previousRange.end:originalRange.pos,startLine=sourceFile.getLineAndCharacterOfPosition(startPosition).line,endLine=sourceFile.getLineAndCharacterOfPosition(originalRange.end).line;trimTrailingWhitespacesForLines(startLine,endLine+1,previousRange)}function newTextChange(start,len,newText){return{span:ts.createTextSpan(start,len),newText:newText}}function recordDelete(start,len){len&&edits.push(newTextChange(start,len,""))}function recordReplace(start,len,newText){(len||newText)&&edits.push(newTextChange(start,len,newText))}function applyRuleEdits(rule,previousRange,previousStartLine,currentRange,currentStartLine){switch(rule.Operation.Action){case 1:return;case 8:previousRange.end!==currentRange.pos&&recordDelete(previousRange.end,currentRange.pos-previousRange.end);break;case 4:if(1!==rule.Flag&&previousStartLine!==currentStartLine)return;var lineDelta=currentStartLine-previousStartLine;1!==lineDelta&&recordReplace(previousRange.end,currentRange.pos-previousRange.end,options.NewLineCharacter);break;case 2:if(1!==rule.Flag&&previousStartLine!==currentStartLine)return;var posDelta=currentRange.pos-previousRange.end;1===posDelta&&32===sourceFile.text.charCodeAt(previousRange.end)||recordReplace(previousRange.end,currentRange.pos-previousRange.end," ")}}var previousRangeHasError,previousRange,previousParent,previousRangeStartLine,lastIndentedLine,indentationOnLastIndentedLine,rangeContainsError=prepareRangeContainsErrorFunction(sourceFile.parseDiagnostics,originalRange),formattingContext=new formatting.FormattingContext(sourceFile,requestKind),enclosingNode=findEnclosingNode(originalRange,sourceFile),formattingScanner=formatting.getFormattingScanner(sourceFile,getScanStartPosition(enclosingNode,originalRange,sourceFile),originalRange.end),initialIndentation=formatting.SmartIndenter.getIndentationForNode(enclosingNode,originalRange,sourceFile,options),edits=[];if(formattingScanner.advance(),formattingScanner.isOnToken()){var startLine=sourceFile.getLineAndCharacterOfPosition(enclosingNode.getStart(sourceFile)).line,undecoratedStartLine=startLine;enclosingNode.decorators&&(undecoratedStartLine=sourceFile.getLineAndCharacterOfPosition(ts.getNonDecoratorTokenPosOfNode(enclosingNode,sourceFile)).line);var delta=getOwnOrInheritedDelta(enclosingNode,options,sourceFile);processNode(enclosingNode,enclosingNode,startLine,undecoratedStartLine,initialIndentation,delta)}if(!formattingScanner.isOnToken()){var leadingTrivia=formattingScanner.getCurrentLeadingTrivia();leadingTrivia&&(processTrivia(leadingTrivia,enclosingNode,enclosingNode,void 0),trimTrailingWhitespacesForRemainingRange())}return formattingScanner.close(),edits}function getOpenTokenForList(node,list){switch(node.kind){case 145:case 216:case 176:case 144:case 143:case 177:if(node.typeParameters===list)return 25;if(node.parameters===list)return 17;break;case 171:case 172:if(node.typeArguments===list)return 25;if(node.arguments===list)return 17;break;case 152:if(node.typeArguments===list)return 25}return 0}function getCloseTokenForOpenToken(kind){switch(kind){case 17:return 18;case 25:return 27}return 0}function getIndentationString(indentation,options){function repeat(value,count){for(var s="",i=0;i<count;++i)s+=value;return s}var resetInternedStrings=!internedSizes||internedSizes.tabSize!==options.TabSize||internedSizes.indentSize!==options.IndentSize;if(resetInternedStrings&&(internedSizes={tabSize:options.TabSize,indentSize:options.IndentSize},internedTabsIndentation=internedSpacesIndentation=void 0),options.ConvertTabsToSpaces){var spacesString=void 0,quotient=Math.floor(indentation/options.IndentSize),remainder=indentation%options.IndentSize;return internedSpacesIndentation||(internedSpacesIndentation=[]),void 0===internedSpacesIndentation[quotient]?(spacesString=repeat(" ",options.IndentSize*quotient),internedSpacesIndentation[quotient]=spacesString):spacesString=internedSpacesIndentation[quotient],remainder?spacesString+repeat(" ",remainder):spacesString}var tabs=Math.floor(indentation/options.TabSize),spaces=indentation-tabs*options.TabSize,tabString=void 0;return internedTabsIndentation||(internedTabsIndentation=[]),void 0===internedTabsIndentation[tabs]?internedTabsIndentation[tabs]=tabString=repeat("\t",tabs):tabString=internedTabsIndentation[tabs],spaces?tabString+repeat(" ",spaces):tabString}var Constants;!function(Constants){Constants[Constants.Unknown=-1]="Unknown"}(Constants||(Constants={})),formatting.formatOnEnter=formatOnEnter,formatting.formatOnSemicolon=formatOnSemicolon,formatting.formatOnClosingCurly=formatOnClosingCurly,formatting.formatDocument=formatDocument,formatting.formatSelection=formatSelection;var internedSizes,internedTabsIndentation,internedSpacesIndentation;formatting.getIndentationString=getIndentationString}(formatting=ts.formatting||(ts.formatting={}))}(ts||(ts={}));var ts;!function(ts){var formatting;!function(formatting){var SmartIndenter;!function(SmartIndenter){function getIndentation(position,sourceFile,options){if(position>sourceFile.text.length)return 0;if(options.IndentStyle===ts.IndentStyle.None)return 0;var precedingToken=ts.findPrecedingToken(position,sourceFile);if(!precedingToken)return 0;var precedingTokenIsLiteral=ts.isStringOrRegularExpressionOrTemplateLiteral(precedingToken.kind);if(precedingTokenIsLiteral&&precedingToken.getStart(sourceFile)<=position&&precedingToken.end>position)return 0;var lineAtPosition=sourceFile.getLineAndCharacterOfPosition(position).line;if(options.IndentStyle===ts.IndentStyle.Block){for(var current_1=position;current_1>0;){var char=sourceFile.text.charCodeAt(current_1);if(!ts.isWhiteSpace(char)&&!ts.isLineBreak(char))break;current_1--}var lineStart=ts.getLineStartPositionForPosition(current_1,sourceFile);return SmartIndenter.findFirstNonWhitespaceColumn(lineStart,current_1,sourceFile,options)}if(24===precedingToken.kind&&184!==precedingToken.parent.kind){var actualIndentation=getActualIndentationForListItemBeforeComma(precedingToken,sourceFile,options);if(actualIndentation!==-1)return actualIndentation}for(var previous,currentStart,indentationDelta,current=precedingToken;current;){if(ts.positionBelongsToNode(current,position,sourceFile)&&shouldIndentChildNode(current,previous)){currentStart=getStartLineAndCharacterForNode(current,sourceFile),indentationDelta=nextTokenIsCurlyBraceOnSameLineAsCursor(precedingToken,current,lineAtPosition,sourceFile)?0:lineAtPosition!==currentStart.line?options.IndentSize:0;break}var actualIndentation=getActualIndentationForListItem(current,sourceFile,options);if(actualIndentation!==-1)return actualIndentation;if(actualIndentation=getLineIndentationWhenExpressionIsInMultiLine(current,sourceFile,options),actualIndentation!==-1)return actualIndentation+options.IndentSize;previous=current,current=current.parent}return current?getIndentationForNodeWorker(current,currentStart,void 0,indentationDelta,sourceFile,options):0}function getIndentationForNode(n,ignoreActualIndentationRange,sourceFile,options){var start=sourceFile.getLineAndCharacterOfPosition(n.getStart(sourceFile));return getIndentationForNodeWorker(n,start,ignoreActualIndentationRange,0,sourceFile,options)}function getIndentationForNodeWorker(current,currentStart,ignoreActualIndentationRange,indentationDelta,sourceFile,options){for(var parentStart,parent=current.parent;parent;){var useActualIndentation=!0;if(ignoreActualIndentationRange){var start=current.getStart(sourceFile);useActualIndentation=start<ignoreActualIndentationRange.pos||start>ignoreActualIndentationRange.end}if(useActualIndentation){var actualIndentation=getActualIndentationForListItem(current,sourceFile,options);if(actualIndentation!==-1)return actualIndentation+indentationDelta}parentStart=getParentStart(parent,current,sourceFile);var parentAndChildShareLine=parentStart.line===currentStart.line||childStartsOnTheSameLineWithElseInIfStatement(parent,current,currentStart.line,sourceFile);if(useActualIndentation){var actualIndentation=getActualIndentationForNode(current,parent,currentStart,parentAndChildShareLine,sourceFile,options);if(actualIndentation!==-1)return actualIndentation+indentationDelta;if(actualIndentation=getLineIndentationWhenExpressionIsInMultiLine(current,sourceFile,options),actualIndentation!==-1)return actualIndentation+indentationDelta}shouldIndentChildNode(parent,current)&&!parentAndChildShareLine&&(indentationDelta+=options.IndentSize),current=parent,currentStart=parentStart,parent=current.parent}return indentationDelta}function getParentStart(parent,child,sourceFile){var containingList=getContainingList(child,sourceFile);return containingList?sourceFile.getLineAndCharacterOfPosition(containingList.pos):sourceFile.getLineAndCharacterOfPosition(parent.getStart(sourceFile))}function getActualIndentationForListItemBeforeComma(commaToken,sourceFile,options){var commaItemInfo=ts.findListItemInfo(commaToken);return commaItemInfo&&commaItemInfo.listItemIndex>0?deriveActualIndentationFromList(commaItemInfo.list.getChildren(),commaItemInfo.listItemIndex-1,sourceFile,options):-1}function getActualIndentationForNode(current,parent,currentLineAndChar,parentAndChildShareLine,sourceFile,options){var useActualIndentation=(ts.isDeclaration(current)||ts.isStatement(current))&&(251===parent.kind||!parentAndChildShareLine);return useActualIndentation?findColumnForFirstNonWhitespaceCharacterInLine(currentLineAndChar,sourceFile,options):-1}function nextTokenIsCurlyBraceOnSameLineAsCursor(precedingToken,current,lineAtPosition,sourceFile){var nextToken=ts.findNextToken(precedingToken,current);if(!nextToken)return!1;if(15===nextToken.kind)return!0;if(16===nextToken.kind){var nextTokenStartLine=getStartLineAndCharacterForNode(nextToken,sourceFile).line;return lineAtPosition===nextTokenStartLine}return!1}function getStartLineAndCharacterForNode(n,sourceFile){return sourceFile.getLineAndCharacterOfPosition(n.getStart(sourceFile))}function childStartsOnTheSameLineWithElseInIfStatement(parent,child,childStartLine,sourceFile){if(199===parent.kind&&parent.elseStatement===child){var elseKeyword=ts.findChildOfKind(parent,80,sourceFile);ts.Debug.assert(void 0!==elseKeyword);var elseKeywordStartLine=getStartLineAndCharacterForNode(elseKeyword,sourceFile).line;return elseKeywordStartLine===childStartLine}return!1}function getContainingList(node,sourceFile){if(node.parent)switch(node.parent.kind){case 152:if(node.parent.typeArguments&&ts.rangeContainsStartEnd(node.parent.typeArguments,node.getStart(sourceFile),node.getEnd()))return node.parent.typeArguments;break;case 168:return node.parent.properties;case 167:return node.parent.elements;case 216:case 176:case 177:case 144:case 143:case 148:case 149:var start=node.getStart(sourceFile);if(node.parent.typeParameters&&ts.rangeContainsStartEnd(node.parent.typeParameters,start,node.getEnd()))return node.parent.typeParameters;if(ts.rangeContainsStartEnd(node.parent.parameters,start,node.getEnd()))return node.parent.parameters;break;case 172:case 171:var start=node.getStart(sourceFile);if(node.parent.typeArguments&&ts.rangeContainsStartEnd(node.parent.typeArguments,start,node.getEnd()))return node.parent.typeArguments;if(node.parent.arguments&&ts.rangeContainsStartEnd(node.parent.arguments,start,node.getEnd()))return node.parent.arguments}}function getActualIndentationForListItem(node,sourceFile,options){function getActualIndentationFromList(list){var index=ts.indexOf(list,node);return index!==-1?deriveActualIndentationFromList(list,index,sourceFile,options):-1}var containingList=getContainingList(node,sourceFile);return containingList?getActualIndentationFromList(containingList):-1}function getLineIndentationWhenExpressionIsInMultiLine(node,sourceFile,options){function getStartingExpression(node){for(;;)switch(node.kind){case 171:case 172:case 169:case 170:node=node.expression;break;default:return node}}if(18===node.kind)return-1;if(node.parent&&(171===node.parent.kind||172===node.parent.kind)&&node.parent.expression!==node){var fullCallOrNewExpression=node.parent.expression,startingExpression=getStartingExpression(fullCallOrNewExpression);if(fullCallOrNewExpression===startingExpression)return-1;var fullCallOrNewExpressionEnd=sourceFile.getLineAndCharacterOfPosition(fullCallOrNewExpression.end),startingExpressionEnd=sourceFile.getLineAndCharacterOfPosition(startingExpression.end);return fullCallOrNewExpressionEnd.line===startingExpressionEnd.line?-1:findColumnForFirstNonWhitespaceCharacterInLine(fullCallOrNewExpressionEnd,sourceFile,options)}return-1}function deriveActualIndentationFromList(list,index,sourceFile,options){ts.Debug.assert(index>=0&&index<list.length);for(var node=list[index],lineAndCharacter=getStartLineAndCharacterForNode(node,sourceFile),i=index-1;i>=0;--i)if(24!==list[i].kind){var prevEndLine=sourceFile.getLineAndCharacterOfPosition(list[i].end).line;if(prevEndLine!==lineAndCharacter.line)return findColumnForFirstNonWhitespaceCharacterInLine(lineAndCharacter,sourceFile,options);lineAndCharacter=getStartLineAndCharacterForNode(list[i],sourceFile)}return-1}function findColumnForFirstNonWhitespaceCharacterInLine(lineAndCharacter,sourceFile,options){var lineStart=sourceFile.getPositionOfLineAndCharacter(lineAndCharacter.line,0);return findFirstNonWhitespaceColumn(lineStart,lineStart+lineAndCharacter.character,sourceFile,options)}function findFirstNonWhitespaceCharacterAndColumn(startPos,endPos,sourceFile,options){for(var character=0,column=0,pos=startPos;pos<endPos;++pos){var ch=sourceFile.text.charCodeAt(pos);if(!ts.isWhiteSpace(ch))break;9===ch?column+=options.TabSize+column%options.TabSize:column++,character++}return{column:column,character:character}}function findFirstNonWhitespaceColumn(startPos,endPos,sourceFile,options){return findFirstNonWhitespaceCharacterAndColumn(startPos,endPos,sourceFile,options).column}function nodeContentIsAlwaysIndented(kind){switch(kind){case 198:case 217:case 189:case 218:case 220:case 219:case 167:case 195:case 222:case 168:case 156:case 158:case 223:case 245:case 244:case 175:case 169:case 171:case 172:case 196:case 214:case 230:case 207:case 185:case 165:case 164:case 238:case 237:case 243:case 143:case 148:case 149:case 139:case 153:case 154:case 161:case 173:case 181:case 228:return!0}return!1}function nodeWillIndentChild(parent,child,indentByDefault){var childKind=child?child.kind:0;switch(parent.kind){case 200:case 201:case 203:case 204:case 202:case 199:case 216:case 176:case 144:case 177:case 145:case 146:case 147:return 195!==childKind;case 236:return 240!==childKind}return indentByDefault}function shouldIndentChildNode(parent,child){return nodeContentIsAlwaysIndented(parent.kind)||nodeWillIndentChild(parent,child,!1)}var Value;!function(Value){Value[Value.Unknown=-1]="Unknown"}(Value||(Value={})),SmartIndenter.getIndentation=getIndentation,SmartIndenter.getIndentationForNode=getIndentationForNode,SmartIndenter.childStartsOnTheSameLineWithElseInIfStatement=childStartsOnTheSameLineWithElseInIfStatement,SmartIndenter.findFirstNonWhitespaceCharacterAndColumn=findFirstNonWhitespaceCharacterAndColumn,SmartIndenter.findFirstNonWhitespaceColumn=findFirstNonWhitespaceColumn,SmartIndenter.nodeWillIndentChild=nodeWillIndentChild,SmartIndenter.shouldIndentChildNode=shouldIndentChildNode}(SmartIndenter=formatting.SmartIndenter||(formatting.SmartIndenter={}))}(formatting=ts.formatting||(ts.formatting={}))}(ts||(ts={}));var ts;!function(ts){function createNode(kind,pos,end,flags,parent){var node=new NodeObject(kind,pos,end);return node.flags=flags,node.parent=parent,node}function getJsDocCommentsFromDeclarations(declarations,name,canUseParsedParamTagComments){function getJsDocCommentsSeparatedByNewLines(){function getJsDocCommentTextRange(node,sourceFile){return ts.map(ts.getJsDocComments(node,sourceFile),function(jsDocComment){return{pos:jsDocComment.pos+"/*".length,end:jsDocComment.end-"*/".length}})}function consumeWhiteSpacesOnTheLine(pos,end,sourceFile,maxSpacesToRemove){for(void 0!==maxSpacesToRemove&&(end=Math.min(end,pos+maxSpacesToRemove));pos<end;pos++){var ch=sourceFile.text.charCodeAt(pos);if(!ts.isWhiteSpace(ch)||ts.isLineBreak(ch))return pos}return end}function consumeLineBreaks(pos,end,sourceFile){for(;pos<end&&ts.isLineBreak(sourceFile.text.charCodeAt(pos));)pos++;return pos}function isName(pos,end,sourceFile,name){return pos+name.length<end&&sourceFile.text.substr(pos,name.length)===name&&(ts.isWhiteSpace(sourceFile.text.charCodeAt(pos+name.length))||ts.isLineBreak(sourceFile.text.charCodeAt(pos+name.length)))}function isParamTag(pos,end,sourceFile){return isName(pos,end,sourceFile,paramTag)}function pushDocCommentLineText(docComments,text,blankLineCount){for(;blankLineCount;)blankLineCount--,docComments.push(ts.textPart(""));docComments.push(ts.textPart(text))}function getCleanedJsDocComment(pos,end,sourceFile){for(var spacesToRemoveAfterAsterisk,docComments=[],blankLineCount=0,isInParamTag=!1;pos<end;){var docCommentTextOfLine="";if(pos=consumeWhiteSpacesOnTheLine(pos,end,sourceFile),pos<end&&42===sourceFile.text.charCodeAt(pos)){var lineStartPos=pos+1;pos=consumeWhiteSpacesOnTheLine(pos+1,end,sourceFile,spacesToRemoveAfterAsterisk),void 0===spacesToRemoveAfterAsterisk&&pos<end&&!ts.isLineBreak(sourceFile.text.charCodeAt(pos))&&(spacesToRemoveAfterAsterisk=pos-lineStartPos)}else void 0===spacesToRemoveAfterAsterisk&&(spacesToRemoveAfterAsterisk=0);for(;pos<end&&!ts.isLineBreak(sourceFile.text.charCodeAt(pos));){var ch=sourceFile.text.charAt(pos);if("@"===ch){if(isParamTag(pos,end,sourceFile)){isInParamTag=!0,pos+=paramTag.length;continue}isInParamTag=!1}isInParamTag||(docCommentTextOfLine+=ch),pos++}pos=consumeLineBreaks(pos,end,sourceFile),docCommentTextOfLine?(pushDocCommentLineText(docComments,docCommentTextOfLine,blankLineCount),blankLineCount=0):!isInParamTag&&docComments.length&&blankLineCount++}return docComments}function getCleanedParamJsDocComment(pos,end,sourceFile){function consumeWhiteSpaces(pos){for(;pos<end&&ts.isWhiteSpace(sourceFile.text.charCodeAt(pos));)pos++;return pos}function setPosForParamHelpStringOnNextLine(firstLineParamHelpStringPos){if(pos=consumeLineBreaks(pos,end,sourceFile),!(pos>=end)){void 0===paramHelpStringMargin&&(paramHelpStringMargin=sourceFile.getLineAndCharacterOfPosition(firstLineParamHelpStringPos).character);var startOfLinePos=pos;if(pos=consumeWhiteSpacesOnTheLine(pos,end,sourceFile,paramHelpStringMargin),
!(pos>=end)){var consumedSpaces=pos-startOfLinePos;if(consumedSpaces<paramHelpStringMargin){var ch=sourceFile.text.charCodeAt(pos);42===ch&&(pos=consumeWhiteSpacesOnTheLine(pos+1,end,sourceFile,paramHelpStringMargin-consumedSpaces-1))}}}}for(var paramHelpStringMargin,paramDocComments=[];pos<end;){if(isParamTag(pos,end,sourceFile)){var blankLineCount=0,recordedParamTag=!1;if(pos=consumeWhiteSpaces(pos+paramTag.length),pos>=end)break;if(123===sourceFile.text.charCodeAt(pos)){pos++;for(var curlies=1;pos<end;pos++){var charCode=sourceFile.text.charCodeAt(pos);if(123!==charCode){if(125!==charCode){if(64===charCode)break}else if(curlies--,0===curlies){pos++;break}}else curlies++}if(pos=consumeWhiteSpaces(pos),pos>=end)break}if(isName(pos,end,sourceFile,name)){if(pos=consumeWhiteSpaces(pos+name.length),pos>=end)break;for(var paramHelpString="",firstLineParamHelpStringPos=pos;pos<end;){var ch=sourceFile.text.charCodeAt(pos);if(ts.isLineBreak(ch))paramHelpString?(pushDocCommentLineText(paramDocComments,paramHelpString,blankLineCount),paramHelpString="",blankLineCount=0,recordedParamTag=!0):recordedParamTag&&blankLineCount++,setPosForParamHelpStringOnNextLine(firstLineParamHelpStringPos);else{if(64===ch)break;paramHelpString+=sourceFile.text.charAt(pos),pos++}}paramHelpString&&pushDocCommentLineText(paramDocComments,paramHelpString,blankLineCount),paramHelpStringMargin=void 0}if(64===sourceFile.text.charCodeAt(pos))continue}pos++}return paramDocComments}var paramTag="@param",jsDocCommentParts=[];return ts.forEach(declarations,function(declaration,indexOfDeclaration){if(ts.indexOf(declarations,declaration)===indexOfDeclaration){var sourceFileOfDeclaration_1=ts.getSourceFileOfNode(declaration);if(canUseParsedParamTagComments&&139===declaration.kind&&ts.forEach(getJsDocCommentTextRange(declaration.parent,sourceFileOfDeclaration_1),function(jsDocCommentTextRange){var cleanedParamJsDocComment=getCleanedParamJsDocComment(jsDocCommentTextRange.pos,jsDocCommentTextRange.end,sourceFileOfDeclaration_1);cleanedParamJsDocComment&&ts.addRange(jsDocCommentParts,cleanedParamJsDocComment)}),221===declaration.kind&&221===declaration.body.kind)return;for(;221===declaration.kind&&221===declaration.parent.kind;)declaration=declaration.parent;ts.forEach(getJsDocCommentTextRange(214===declaration.kind?declaration.parent.parent:declaration,sourceFileOfDeclaration_1),function(jsDocCommentTextRange){var cleanedJsDocComment=getCleanedJsDocComment(jsDocCommentTextRange.pos,jsDocCommentTextRange.end,sourceFileOfDeclaration_1);cleanedJsDocComment&&ts.addRange(jsDocCommentParts,cleanedJsDocComment)})}}),jsDocCommentParts}var documentationComment=[],docComments=getJsDocCommentsSeparatedByNewLines();return ts.forEach(docComments,function(docComment){documentationComment.length&&documentationComment.push(ts.lineBreakPart()),documentationComment.push(docComment)}),documentationComment}function displayPartsToString(displayParts){return displayParts?ts.map(displayParts,function(displayPart){return displayPart.text}).join(""):""}function isLocalVariableOrFunction(symbol){return!symbol.parent&&ts.forEach(symbol.declarations,function(declaration){if(176===declaration.kind)return!0;if(214!==declaration.kind&&216!==declaration.kind)return!1;for(var parent_10=declaration.parent;!ts.isFunctionBlock(parent_10);parent_10=parent_10.parent)if(251===parent_10.kind||222===parent_10.kind)return!1;return!0})}function getDefaultCompilerOptions(){return{target:1,jsx:1}}function setSourceFileFields(sourceFile,scriptSnapshot,version){sourceFile.version=version,sourceFile.scriptSnapshot=scriptSnapshot}function transpileModule(input,transpileOptions){var options=transpileOptions.compilerOptions?ts.clone(transpileOptions.compilerOptions):getDefaultCompilerOptions();options.isolatedModules=!0,options.suppressOutputPathCheck=!0,options.allowNonTsExtensions=!0,options.noLib=!0,options.noResolve=!0;var inputFileName=transpileOptions.fileName||(options.jsx?"module.tsx":"module.ts"),sourceFile=ts.createSourceFile(inputFileName,input,options.target);transpileOptions.moduleName&&(sourceFile.moduleName=transpileOptions.moduleName),sourceFile.renamedDependencies=transpileOptions.renamedDependencies;var outputText,sourceMapText,diagnostics,newLine=ts.getNewLineCharacter(options),compilerHost={getSourceFile:function(fileName,target){return fileName===ts.normalizeSlashes(inputFileName)?sourceFile:void 0},writeFile:function(name,text,writeByteOrderMark){ts.fileExtensionIs(name,".map")?(ts.Debug.assert(void 0===sourceMapText,"Unexpected multiple source map outputs for the file '"+name+"'"),sourceMapText=text):(ts.Debug.assert(void 0===outputText,"Unexpected multiple outputs for the file: '"+name+"'"),outputText=text)},getDefaultLibFileName:function(){return"lib.d.ts"},useCaseSensitiveFileNames:function(){return!1},getCanonicalFileName:function(fileName){return fileName},getCurrentDirectory:function(){return""},getNewLine:function(){return newLine},fileExists:function(fileName){return fileName===inputFileName},readFile:function(fileName){return""},directoryExists:function(directoryExists){return!0}},program=ts.createProgram([inputFileName],options,compilerHost);return transpileOptions.reportDiagnostics&&(diagnostics=[],ts.addRange(diagnostics,program.getSyntacticDiagnostics(sourceFile)),ts.addRange(diagnostics,program.getOptionsDiagnostics())),program.emit(),ts.Debug.assert(void 0!==outputText,"Output generation failed"),{outputText:outputText,diagnostics:diagnostics,sourceMapText:sourceMapText}}function transpile(input,compilerOptions,fileName,diagnostics,moduleName){var output=transpileModule(input,{compilerOptions:compilerOptions,fileName:fileName,reportDiagnostics:!!diagnostics,moduleName:moduleName});return ts.addRange(diagnostics,output.diagnostics),output.outputText}function createLanguageServiceSourceFile(fileName,scriptSnapshot,scriptTarget,version,setNodeParents){var text=scriptSnapshot.getText(0,scriptSnapshot.getLength()),sourceFile=ts.createSourceFile(fileName,text,scriptTarget,setNodeParents);return setSourceFileFields(sourceFile,scriptSnapshot,version),sourceFile}function updateLanguageServiceSourceFile(sourceFile,scriptSnapshot,version,textChangeRange,aggressiveChecks){if(textChangeRange&&version!==sourceFile.version&&!ts.disableIncrementalParsing){var newText=void 0,prefix=0!==textChangeRange.span.start?sourceFile.text.substr(0,textChangeRange.span.start):"",suffix=ts.textSpanEnd(textChangeRange.span)!==sourceFile.text.length?sourceFile.text.substr(ts.textSpanEnd(textChangeRange.span)):"";if(0===textChangeRange.newLength)newText=prefix&&suffix?prefix+suffix:prefix||suffix;else{var changedText=scriptSnapshot.getText(textChangeRange.span.start,textChangeRange.span.start+textChangeRange.newLength);newText=prefix&&suffix?prefix+changedText+suffix:prefix?prefix+changedText:changedText+suffix}var newSourceFile=ts.updateSourceFile(sourceFile,newText,textChangeRange,aggressiveChecks);return setSourceFileFields(newSourceFile,scriptSnapshot,version),newSourceFile.nameTable=void 0,sourceFile!==newSourceFile&&sourceFile.scriptSnapshot&&(sourceFile.scriptSnapshot.dispose&&sourceFile.scriptSnapshot.dispose(),sourceFile.scriptSnapshot=void 0),newSourceFile}return createLanguageServiceSourceFile(sourceFile.fileName,scriptSnapshot,sourceFile.languageVersion,version,!0)}function createDocumentRegistry(useCaseSensitiveFileNames,currentDirectory){function getKeyFromCompilationSettings(settings){return"_"+settings.target+"|"+settings.module+"|"+settings.noResolve+"|"+settings.jsx+NaN+settings.allowJs}function getBucketForCompilationSettings(settings,createIfMissing){var key=getKeyFromCompilationSettings(settings),bucket=ts.lookUp(buckets,key);return!bucket&&createIfMissing&&(buckets[key]=bucket=ts.createFileMap()),bucket}function reportStats(){var bucketInfoArray=Object.keys(buckets).filter(function(name){return name&&"_"===name.charAt(0)}).map(function(name){var entries=ts.lookUp(buckets,name),sourceFiles=[];return entries.forEachValue(function(key,entry){sourceFiles.push({name:key,refCount:entry.languageServiceRefCount,references:entry.owners.slice(0)})}),sourceFiles.sort(function(x,y){return y.refCount-x.refCount}),{bucket:name,sourceFiles:sourceFiles}});return JSON.stringify(bucketInfoArray,void 0,2)}function acquireDocument(fileName,compilationSettings,scriptSnapshot,version){return acquireOrUpdateDocument(fileName,compilationSettings,scriptSnapshot,version,!0)}function updateDocument(fileName,compilationSettings,scriptSnapshot,version){return acquireOrUpdateDocument(fileName,compilationSettings,scriptSnapshot,version,!1)}function acquireOrUpdateDocument(fileName,compilationSettings,scriptSnapshot,version,acquiring){var bucket=getBucketForCompilationSettings(compilationSettings,!0),path=ts.toPath(fileName,currentDirectory,getCanonicalFileName),entry=bucket.get(path);if(entry)entry.sourceFile.version!==version&&(entry.sourceFile=updateLanguageServiceSourceFile(entry.sourceFile,scriptSnapshot,version,scriptSnapshot.getChangeRange(entry.sourceFile.scriptSnapshot)));else{ts.Debug.assert(acquiring,"How could we be trying to update a document that the registry doesn't have?");var sourceFile=createLanguageServiceSourceFile(fileName,scriptSnapshot,compilationSettings.target,version,!1);entry={sourceFile:sourceFile,languageServiceRefCount:0,owners:[]},bucket.set(path,entry)}return acquiring&&entry.languageServiceRefCount++,entry.sourceFile}function releaseDocument(fileName,compilationSettings){var bucket=getBucketForCompilationSettings(compilationSettings,!1);ts.Debug.assert(void 0!==bucket);var path=ts.toPath(fileName,currentDirectory,getCanonicalFileName),entry=bucket.get(path);entry.languageServiceRefCount--,ts.Debug.assert(entry.languageServiceRefCount>=0),0===entry.languageServiceRefCount&&bucket.remove(path)}void 0===currentDirectory&&(currentDirectory="");var buckets={},getCanonicalFileName=ts.createGetCanonicalFileName(!!useCaseSensitiveFileNames);return{acquireDocument:acquireDocument,updateDocument:updateDocument,releaseDocument:releaseDocument,reportStats:reportStats}}function preProcessFile(sourceText,readImportFiles,detectJavaScriptImports){function processTripleSlashDirectives(){var commentRanges=ts.getLeadingCommentRanges(sourceText,0);ts.forEach(commentRanges,function(commentRange){var comment=sourceText.substring(commentRange.pos,commentRange.end),referencePathMatchResult=ts.getFileReferenceFromReferencePath(comment,commentRange);if(referencePathMatchResult){isNoDefaultLib=referencePathMatchResult.isNoDefaultLib;var fileReference=referencePathMatchResult.fileReference;fileReference&&referencedFiles.push(fileReference)}})}function recordAmbientExternalModule(){ambientExternalModules||(ambientExternalModules=[]),ambientExternalModules.push(scanner.getTokenValue())}function recordModuleName(){var importPath=scanner.getTokenValue(),pos=scanner.getTokenPos();importedFiles.push({fileName:importPath,pos:pos,end:pos+importPath.length})}function tryConsumeDeclare(){var token=scanner.getToken();return 122===token&&(token=scanner.scan(),125===token&&(token=scanner.scan(),9===token&&recordAmbientExternalModule()),!0)}function tryConsumeImport(){var token=scanner.getToken();if(89===token){if(token=scanner.scan(),9===token)return recordModuleName(),!0;if(69===token||ts.isKeyword(token))if(token=scanner.scan(),133===token){if(token=scanner.scan(),9===token)return recordModuleName(),!0}else if(56===token){if(tryConsumeRequireCall(!0))return!0}else{if(24!==token)return!0;token=scanner.scan()}if(15===token){for(token=scanner.scan();16!==token&&1!==token;)token=scanner.scan();16===token&&(token=scanner.scan(),133===token&&(token=scanner.scan(),9===token&&recordModuleName()))}else 37===token&&(token=scanner.scan(),116===token&&(token=scanner.scan(),(69===token||ts.isKeyword(token))&&(token=scanner.scan(),133===token&&(token=scanner.scan(),9===token&&recordModuleName()))));return!0}return!1}function tryConsumeExport(){var token=scanner.getToken();if(82===token){if(token=scanner.scan(),15===token){for(token=scanner.scan();16!==token&&1!==token;)token=scanner.scan();16===token&&(token=scanner.scan(),133===token&&(token=scanner.scan(),9===token&&recordModuleName()))}else if(37===token)token=scanner.scan(),133===token&&(token=scanner.scan(),9===token&&recordModuleName());else if(89===token&&(token=scanner.scan(),(69===token||ts.isKeyword(token))&&(token=scanner.scan(),56===token&&tryConsumeRequireCall(!0))))return!0;return!0}return!1}function tryConsumeRequireCall(skipCurrentToken){var token=skipCurrentToken?scanner.scan():scanner.getToken();return 127===token&&(token=scanner.scan(),17===token&&(token=scanner.scan(),9===token&&recordModuleName()),!0)}function tryConsumeDefine(){var token=scanner.getToken();if(69===token&&"define"===scanner.getTokenValue()){if(token=scanner.scan(),17!==token)return!0;if(token=scanner.scan(),9===token){if(token=scanner.scan(),24!==token)return!0;token=scanner.scan()}if(19!==token)return!0;token=scanner.scan();for(var i=0;20!==token&&1!==token;)9===token&&(recordModuleName(),i++),token=scanner.scan();return!0}return!1}function processImports(){for(scanner.setText(sourceText),scanner.scan();;){if(1===scanner.getToken())break;tryConsumeDeclare()||tryConsumeImport()||tryConsumeExport()||detectJavaScriptImports&&(tryConsumeRequireCall(!1)||tryConsumeDefine())||scanner.scan()}scanner.setText(void 0)}void 0===readImportFiles&&(readImportFiles=!0),void 0===detectJavaScriptImports&&(detectJavaScriptImports=!1);var ambientExternalModules,referencedFiles=[],importedFiles=[],isNoDefaultLib=!1;return readImportFiles&&processImports(),processTripleSlashDirectives(),{referencedFiles:referencedFiles,importedFiles:importedFiles,isLibFile:isNoDefaultLib,ambientExternalModules:ambientExternalModules}}function getTargetLabel(referenceNode,labelName){for(;referenceNode;){if(210===referenceNode.kind&&referenceNode.label.text===labelName)return referenceNode.label;referenceNode=referenceNode.parent}}function isJumpStatementTarget(node){return 69===node.kind&&(206===node.parent.kind||205===node.parent.kind)&&node.parent.label===node}function isLabelOfLabeledStatement(node){return 69===node.kind&&210===node.parent.kind&&node.parent.label===node}function isLabeledBy(node,labelName){for(var owner=node.parent;210===owner.kind;owner=owner.parent)if(owner.label.text===labelName)return!0;return!1}function isLabelName(node){return isLabelOfLabeledStatement(node)||isJumpStatementTarget(node)}function isRightSideOfQualifiedName(node){return 136===node.parent.kind&&node.parent.right===node}function isRightSideOfPropertyAccess(node){return node&&node.parent&&169===node.parent.kind&&node.parent.name===node}function isCallExpressionTarget(node){return isRightSideOfPropertyAccess(node)&&(node=node.parent),node&&node.parent&&171===node.parent.kind&&node.parent.expression===node}function isNewExpressionTarget(node){return isRightSideOfPropertyAccess(node)&&(node=node.parent),node&&node.parent&&172===node.parent.kind&&node.parent.expression===node}function isNameOfModuleDeclaration(node){return 221===node.parent.kind&&node.parent.name===node}function isNameOfFunctionDeclaration(node){return 69===node.kind&&ts.isFunctionLike(node.parent)&&node.parent.name===node}function isNameOfPropertyAssignment(node){return!(69!==node.kind&&9!==node.kind&&8!==node.kind||248!==node.parent.kind&&249!==node.parent.kind||node.parent.name!==node)}function isLiteralNameOfPropertyDeclarationOrIndexAccess(node){if(9===node.kind||8===node.kind)switch(node.parent.kind){case 142:case 141:case 248:case 250:case 144:case 143:case 146:case 147:case 221:return node.parent.name===node;case 170:return node.parent.argumentExpression===node}return!1}function isNameOfExternalModuleImportOrDeclaration(node){return 9===node.kind&&(isNameOfModuleDeclaration(node)||ts.isExternalModuleImportEqualsDeclaration(node.parent.parent)&&ts.getExternalModuleImportEqualsDeclarationExpression(node.parent.parent)===node)}function isInsideComment(sourceFile,token,position){function isInsideCommentRange(comments){return ts.forEach(comments,function(comment){if(comment.pos<position&&position<comment.end)return!0;if(position===comment.end){var text=sourceFile.text,width=comment.end-comment.pos;return width<=2||47===text.charCodeAt(comment.pos+1)||!(47===text.charCodeAt(comment.end-1)&&42===text.charCodeAt(comment.end-2))}return!1})}return position<=token.getStart(sourceFile)&&(isInsideCommentRange(ts.getTrailingCommentRanges(sourceFile.text,token.getFullStart()))||isInsideCommentRange(ts.getLeadingCommentRanges(sourceFile.text,token.getFullStart())))}function getContainerNode(node){for(;;){if(node=node.parent,!node)return;switch(node.kind){case 251:case 144:case 143:case 216:case 176:case 146:case 147:case 217:case 218:case 220:case 221:return node}}}function getNodeKind(node){switch(node.kind){case 221:return ScriptElementKind.moduleElement;case 217:return ScriptElementKind.classElement;case 218:return ScriptElementKind.interfaceElement;case 219:return ScriptElementKind.typeElement;case 220:return ScriptElementKind.enumElement;case 214:return ts.isConst(node)?ScriptElementKind.constElement:ts.isLet(node)?ScriptElementKind.letElement:ScriptElementKind.variableElement;case 216:return ScriptElementKind.functionElement;case 146:return ScriptElementKind.memberGetAccessorElement;case 147:return ScriptElementKind.memberSetAccessorElement;case 144:case 143:return ScriptElementKind.memberFunctionElement;case 142:case 141:return ScriptElementKind.memberVariableElement;case 150:return ScriptElementKind.indexSignatureElement;case 149:return ScriptElementKind.constructSignatureElement;case 148:return ScriptElementKind.callSignatureElement;case 145:return ScriptElementKind.constructorImplementationElement;case 138:return ScriptElementKind.typeParameterElement;case 250:return ScriptElementKind.variableElement;case 139:return 56&node.flags?ScriptElementKind.memberVariableElement:ScriptElementKind.parameterElement;case 224:case 229:case 226:case 233:case 227:return ScriptElementKind.alias}return ScriptElementKind.unknown}function createLanguageService(host,documentRegistry){function log(message){host.log&&host.log(message)}function getValidSourceFile(fileName){var sourceFile=program.getSourceFile(fileName);if(!sourceFile)throw new Error("Could not find file: '"+fileName+"'.");return sourceFile}function getRuleProvider(options){return ruleProvider||(ruleProvider=new ts.formatting.RulesProvider),ruleProvider.ensureUpToDate(options),ruleProvider}function synchronizeHostData(){function getOrCreateSourceFile(fileName){ts.Debug.assert(void 0!==hostCache);var hostFileInformation=hostCache.getOrCreateEntry(fileName);if(hostFileInformation){if(!changesInCompilationSettingsAffectSyntax){var oldSourceFile=program&&program.getSourceFile(fileName);if(oldSourceFile)return documentRegistry.updateDocument(fileName,newSettings,hostFileInformation.scriptSnapshot,hostFileInformation.version)}return documentRegistry.acquireDocument(fileName,newSettings,hostFileInformation.scriptSnapshot,hostFileInformation.version)}}function sourceFileUpToDate(sourceFile){if(!sourceFile)return!1;var path=sourceFile.path||ts.toPath(sourceFile.fileName,currentDirectory,getCanonicalFileName);return sourceFile.version===hostCache.getVersion(path)}function programUpToDate(){if(!program)return!1;var rootFileNames=hostCache.getRootFileNames();if(program.getSourceFiles().length!==rootFileNames.length)return!1;for(var _i=0,rootFileNames_2=rootFileNames;_i<rootFileNames_2.length;_i++){var fileName=rootFileNames_2[_i];if(!sourceFileUpToDate(program.getSourceFile(fileName)))return!1}return ts.compareDataObjects(program.getCompilerOptions(),hostCache.compilationSettings())}if(host.getProjectVersion){var hostProjectVersion=host.getProjectVersion();if(hostProjectVersion){if(lastProjectVersion===hostProjectVersion)return;lastProjectVersion=hostProjectVersion}}var hostCache=new HostCache(host,getCanonicalFileName);if(!programUpToDate()){var oldSettings=program&&program.getCompilerOptions(),newSettings=hostCache.compilationSettings(),changesInCompilationSettingsAffectSyntax=oldSettings&&(oldSettings.target!==newSettings.target||oldSettings.module!==newSettings.module||oldSettings.noResolve!==newSettings.noResolve||oldSettings.jsx!==newSettings.jsx||oldSettings.allowJs!==newSettings.allowJs),compilerHost={getSourceFile:getOrCreateSourceFile,getCancellationToken:function(){return cancellationToken},getCanonicalFileName:getCanonicalFileName,useCaseSensitiveFileNames:function(){return useCaseSensitivefileNames},getNewLine:function(){return ts.getNewLineOrDefaultFromHost(host)},getDefaultLibFileName:function(options){return host.getDefaultLibFileName(options)},writeFile:function(fileName,data,writeByteOrderMark){},getCurrentDirectory:function(){return currentDirectory},fileExists:function(fileName){return ts.Debug.assert(!host.resolveModuleNames),void 0!==hostCache.getOrCreateEntry(fileName)},readFile:function(fileName){var entry=hostCache.getOrCreateEntry(fileName);return entry&&entry.scriptSnapshot.getText(0,entry.scriptSnapshot.getLength())},directoryExists:function(directoryName){return ts.Debug.assert(!host.resolveModuleNames),ts.directoryProbablyExists(directoryName,host)}};host.resolveModuleNames&&(compilerHost.resolveModuleNames=function(moduleNames,containingFile){return host.resolveModuleNames(moduleNames,containingFile)});var newProgram=ts.createProgram(hostCache.getRootFileNames(),newSettings,compilerHost,program);if(program)for(var oldSourceFiles=program.getSourceFiles(),_i=0,oldSourceFiles_1=oldSourceFiles;_i<oldSourceFiles_1.length;_i++){var oldSourceFile=oldSourceFiles_1[_i];newProgram.getSourceFile(oldSourceFile.fileName)&&!changesInCompilationSettingsAffectSyntax||documentRegistry.releaseDocument(oldSourceFile.fileName,oldSettings)}hostCache=void 0,program=newProgram,program.getTypeChecker()}}function getProgram(){return synchronizeHostData(),program}function cleanupSemanticCache(){}function dispose(){program&&ts.forEach(program.getSourceFiles(),function(f){return documentRegistry.releaseDocument(f.fileName,program.getCompilerOptions())})}function getSyntacticDiagnostics(fileName){return synchronizeHostData(),program.getSyntacticDiagnostics(getValidSourceFile(fileName),cancellationToken)}function getSemanticDiagnostics(fileName){synchronizeHostData();var targetSourceFile=getValidSourceFile(fileName),semanticDiagnostics=program.getSemanticDiagnostics(targetSourceFile,cancellationToken);if(!program.getCompilerOptions().declaration)return semanticDiagnostics;var declarationDiagnostics=program.getDeclarationDiagnostics(targetSourceFile,cancellationToken);return ts.concatenate(semanticDiagnostics,declarationDiagnostics)}function getCompilerOptionsDiagnostics(){return synchronizeHostData(),program.getOptionsDiagnostics(cancellationToken).concat(program.getGlobalDiagnostics(cancellationToken))}function getCompletionEntryDisplayNameForSymbol(symbol,target,performCharacterChecks,location){var displayName=ts.getDeclaredName(program.getTypeChecker(),symbol,location);if(displayName){var firstCharCode=displayName.charCodeAt(0);if(1536&symbol.flags&&(39===firstCharCode||34===firstCharCode))return}return getCompletionEntryDisplayName(displayName,target,performCharacterChecks)}function getCompletionEntryDisplayName(name,target,performCharacterChecks){if(name&&(name=ts.stripQuotes(name),name&&(!performCharacterChecks||ts.isIdentifier(name,target))))return name}function getCompletionData(fileName,position){function getTypeScriptMemberSymbols(){if(isMemberCompletion=!0,isNewIdentifierLocation=!1,69===node.kind||136===node.kind||169===node.kind){var symbol=typeChecker.getSymbolAtLocation(node);if(symbol&&8388608&symbol.flags&&(symbol=typeChecker.getAliasedSymbol(symbol)),symbol&&1952&symbol.flags){var exportedSymbols=typeChecker.getExportsOfModule(symbol);ts.forEach(exportedSymbols,function(symbol){typeChecker.isValidPropertyAccess(node.parent,symbol.name)&&symbols.push(symbol)})}}var type=typeChecker.getTypeAtLocation(node);addTypeProperties(type)}function addTypeProperties(type){if(type){for(var _i=0,_a=type.getApparentProperties();_i<_a.length;_i++){var symbol=_a[_i];typeChecker.isValidPropertyAccess(node.parent,symbol.name)&&symbols.push(symbol)}if(isJavaScriptFile&&16384&type.flags)for(var unionType=type,_b=0,_c=unionType.types;_b<_c.length;_b++){var elementType=_c[_b];addTypeProperties(elementType)}}}function tryGetGlobalSymbols(){var objectLikeContainer,namedImportsOrExports,jsxContainer;if(objectLikeContainer=tryGetObjectLikeCompletionContainer(contextToken))return tryGetObjectLikeCompletionSymbols(objectLikeContainer);if(namedImportsOrExports=tryGetNamedImportsOrExportsForCompletion(contextToken))return tryGetImportOrExportClauseCompletionSymbols(namedImportsOrExports);if(jsxContainer=tryGetContainingJsxElement(contextToken)){var attrsType=void 0;if((237===jsxContainer.kind||238===jsxContainer.kind)&&(attrsType=typeChecker.getJsxElementAttributesType(jsxContainer)))return symbols=filterJsxAttributes(typeChecker.getPropertiesOfType(attrsType),jsxContainer.attributes),isMemberCompletion=!0,isNewIdentifierLocation=!1,!0}isMemberCompletion=!1,isNewIdentifierLocation=isNewIdentifierDefinitionLocation(contextToken),previousToken!==contextToken&&ts.Debug.assert(!!previousToken,"Expected 'contextToken' to be defined when different from 'previousToken'.");var adjustedPosition=previousToken!==contextToken?previousToken.getStart():position,scopeNode=getScopeNode(contextToken,adjustedPosition,sourceFile)||sourceFile,symbolMeanings=9289727;return symbols=typeChecker.getSymbolsInScope(scopeNode,symbolMeanings),!0}function getScopeNode(initialToken,position,sourceFile){for(var scope=initialToken;scope&&!ts.positionBelongsToNode(scope,position,sourceFile);)scope=scope.parent;return scope}function isCompletionListBlocker(contextToken){var start=(new Date).getTime(),result=isInStringOrRegularExpressionOrTemplateLiteral(contextToken)||isSolelyIdentifierDefinitionLocation(contextToken)||isDotOfNumericLiteral(contextToken)||isInJsxText(contextToken);return log("getCompletionsAtPosition: isCompletionListBlocker: "+((new Date).getTime()-start)),result}function isInJsxText(contextToken){if(239===contextToken.kind)return!0;if(27===contextToken.kind&&contextToken.parent){if(238===contextToken.parent.kind)return!0;if(240===contextToken.parent.kind||237===contextToken.parent.kind)return contextToken.parent.parent&&236===contextToken.parent.parent.kind}return!1}function isNewIdentifierDefinitionLocation(previousToken){if(previousToken){var containingNodeKind=previousToken.parent.kind;switch(previousToken.kind){case 24:return 171===containingNodeKind||145===containingNodeKind||172===containingNodeKind||167===containingNodeKind||184===containingNodeKind||153===containingNodeKind;case 17:return 171===containingNodeKind||145===containingNodeKind||172===containingNodeKind||175===containingNodeKind||161===containingNodeKind;case 19:return 167===containingNodeKind||150===containingNodeKind||137===containingNodeKind;case 125:case 126:return!0;case 21:return 221===containingNodeKind;case 15:return 217===containingNodeKind;case 56:return 214===containingNodeKind||184===containingNodeKind;case 12:return 186===containingNodeKind;case 13:return 193===containingNodeKind;case 112:case 110:case 111:return 142===containingNodeKind}switch(previousToken.getText()){case"public":case"protected":case"private":return!0}}return!1}function isInStringOrRegularExpressionOrTemplateLiteral(contextToken){if(9===contextToken.kind||163===contextToken.kind||10===contextToken.kind||ts.isTemplateLiteralKind(contextToken.kind)){var start_7=contextToken.getStart(),end=contextToken.getEnd();if(start_7<position&&position<end)return!0;if(position===end)return!!contextToken.isUnterminated||10===contextToken.kind}return!1}function tryGetObjectLikeCompletionSymbols(objectLikeContainer){isMemberCompletion=!0;var typeForObject,existingMembers;if(168===objectLikeContainer.kind)isNewIdentifierLocation=!0,typeForObject=typeChecker.getContextualType(objectLikeContainer),existingMembers=objectLikeContainer.properties;else if(164===objectLikeContainer.kind){isNewIdentifierLocation=!1;var rootDeclaration=ts.getRootDeclaration(objectLikeContainer.parent);ts.isVariableLike(rootDeclaration)?(rootDeclaration.initializer||rootDeclaration.type)&&(typeForObject=typeChecker.getTypeAtLocation(objectLikeContainer),existingMembers=objectLikeContainer.elements):ts.Debug.fail("Root declaration is not variable-like.")}else ts.Debug.fail("Expected object literal or binding pattern, got "+objectLikeContainer.kind);if(!typeForObject)return!1;var typeMembers=typeChecker.getPropertiesOfType(typeForObject);return typeMembers&&typeMembers.length>0&&(symbols=filterObjectMembersList(typeMembers,existingMembers)),!0}function tryGetImportOrExportClauseCompletionSymbols(namedImportsOrExports){var declarationKind=228===namedImportsOrExports.kind?225:231,importOrExportDeclaration=ts.getAncestor(namedImportsOrExports,declarationKind),moduleSpecifier=importOrExportDeclaration.moduleSpecifier;if(!moduleSpecifier)return!1;isMemberCompletion=!0,isNewIdentifierLocation=!1;var exports,moduleSpecifierSymbol=typeChecker.getSymbolAtLocation(importOrExportDeclaration.moduleSpecifier);return moduleSpecifierSymbol&&(exports=typeChecker.getExportsOfModule(moduleSpecifierSymbol)),symbols=exports?filterNamedImportOrExportCompletionItems(exports,namedImportsOrExports.elements):emptyArray,!0}function tryGetObjectLikeCompletionContainer(contextToken){if(contextToken)switch(contextToken.kind){case 15:case 24:var parent_12=contextToken.parent;if(parent_12&&(168===parent_12.kind||164===parent_12.kind))return parent_12}}function tryGetNamedImportsOrExportsForCompletion(contextToken){if(contextToken)switch(contextToken.kind){case 15:case 24:switch(contextToken.parent.kind){case 228:case 232:return contextToken.parent}}}function tryGetContainingJsxElement(contextToken){if(contextToken){var parent_13=contextToken.parent;switch(contextToken.kind){case 26:case 39:case 69:case 241:case 242:if(parent_13&&(237===parent_13.kind||238===parent_13.kind))return parent_13;if(241===parent_13.kind)return parent_13.parent;break;case 9:if(parent_13&&(241===parent_13.kind||242===parent_13.kind))return parent_13.parent;break;case 16:if(parent_13&&243===parent_13.kind&&parent_13.parent&&241===parent_13.parent.kind)return parent_13.parent.parent;if(parent_13&&242===parent_13.kind)return parent_13.parent}}}function isFunction(kind){switch(kind){case 176:case 177:case 216:case 144:case 143:case 146:case 147:case 148:case 149:case 150:return!0}return!1}function isSolelyIdentifierDefinitionLocation(contextToken){var containingNodeKind=contextToken.parent.kind;switch(contextToken.kind){case 24:return 214===containingNodeKind||215===containingNodeKind||196===containingNodeKind||220===containingNodeKind||isFunction(containingNodeKind)||217===containingNodeKind||189===containingNodeKind||218===containingNodeKind||165===containingNodeKind||219===containingNodeKind;case 21:return 165===containingNodeKind;case 54:return 166===containingNodeKind;case 19:return 165===containingNodeKind;case 17:return 247===containingNodeKind||isFunction(containingNodeKind);case 15:return 220===containingNodeKind||218===containingNodeKind||156===containingNodeKind;case 23:return 141===containingNodeKind&&contextToken.parent&&contextToken.parent.parent&&(218===contextToken.parent.parent.kind||156===contextToken.parent.parent.kind);case 25:return 217===containingNodeKind||189===containingNodeKind||218===containingNodeKind||219===containingNodeKind||isFunction(containingNodeKind);case 113:return 142===containingNodeKind;case 22:return 139===containingNodeKind||contextToken.parent&&contextToken.parent.parent&&165===contextToken.parent.parent.kind;case 112:case 110:case 111:return 139===containingNodeKind;case 116:return 229===containingNodeKind||233===containingNodeKind||227===containingNodeKind;
case 73:case 81:case 107:case 87:case 102:case 123:case 129:case 89:case 108:case 74:case 114:case 132:return!0}switch(contextToken.getText()){case"abstract":case"async":case"class":case"const":case"declare":case"enum":case"function":case"interface":case"let":case"private":case"protected":case"public":case"static":case"var":case"yield":return!0}return!1}function isDotOfNumericLiteral(contextToken){if(8===contextToken.kind){var text=contextToken.getFullText();return"."===text.charAt(text.length-1)}return!1}function filterNamedImportOrExportCompletionItems(exportsOfModule,namedImportsOrExports){for(var exisingImportsOrExports={},_i=0,namedImportsOrExports_1=namedImportsOrExports;_i<namedImportsOrExports_1.length;_i++){var element=namedImportsOrExports_1[_i];if(!(element.getStart()<=position&&position<=element.getEnd())){var name_35=element.propertyName||element.name;exisingImportsOrExports[name_35.text]=!0}}return ts.isEmpty(exisingImportsOrExports)?exportsOfModule:ts.filter(exportsOfModule,function(e){return!ts.lookUp(exisingImportsOrExports,e.name)})}function filterObjectMembersList(contextualMemberSymbols,existingMembers){if(!existingMembers||0===existingMembers.length)return contextualMemberSymbols;for(var existingMemberNames={},_i=0,existingMembers_1=existingMembers;_i<existingMembers_1.length;_i++){var m=existingMembers_1[_i];if(!(248!==m.kind&&249!==m.kind&&166!==m.kind&&144!==m.kind||m.getStart()<=position&&position<=m.getEnd())){var existingName=void 0;166===m.kind&&m.propertyName?69===m.propertyName.kind&&(existingName=m.propertyName.text):existingName=m.name.text,existingMemberNames[existingName]=!0}}return ts.filter(contextualMemberSymbols,function(m){return!ts.lookUp(existingMemberNames,m.name)})}function filterJsxAttributes(symbols,attributes){for(var seenNames={},_i=0,attributes_1=attributes;_i<attributes_1.length;_i++){var attr=attributes_1[_i];attr.getStart()<=position&&position<=attr.getEnd()||241===attr.kind&&(seenNames[attr.name.text]=!0)}return ts.filter(symbols,function(a){return!ts.lookUp(seenNames,a.name)})}var typeChecker=program.getTypeChecker(),sourceFile=getValidSourceFile(fileName),isJavaScriptFile=ts.isSourceFileJavaScript(sourceFile),isJsDocTagName=!1,start=(new Date).getTime(),currentToken=ts.getTokenAtPosition(sourceFile,position);log("getCompletionData: Get current token: "+((new Date).getTime()-start)),start=(new Date).getTime();var insideComment=isInsideComment(sourceFile,currentToken,position);if(log("getCompletionData: Is inside comment: "+((new Date).getTime()-start)),insideComment){ts.hasDocComment(sourceFile,position)&&64===sourceFile.text.charCodeAt(position-1)&&(isJsDocTagName=!0);var insideJsDocTagExpression=!1,tag=ts.getJsDocTagAtPosition(sourceFile,position);if(tag)switch(tag.tagName.pos<=position&&position<=tag.tagName.end&&(isJsDocTagName=!0),tag.kind){case 272:case 270:case 271:var tagWithExpression=tag;tagWithExpression.typeExpression&&(insideJsDocTagExpression=tagWithExpression.typeExpression.pos<position&&position<tagWithExpression.typeExpression.end)}if(isJsDocTagName)return{symbols:void 0,isMemberCompletion:!1,isNewIdentifierLocation:!1,location:void 0,isRightOfDot:!1,isJsDocTagName:isJsDocTagName};if(!insideJsDocTagExpression)return void log("Returning an empty list because completion was inside a regular comment or plain text part of a JsDoc comment.")}start=(new Date).getTime();var previousToken=ts.findPrecedingToken(position,sourceFile);log("getCompletionData: Get previous token 1: "+((new Date).getTime()-start));var contextToken=previousToken;if(contextToken&&position<=contextToken.end&&ts.isWord(contextToken.kind)){var start_6=(new Date).getTime();contextToken=ts.findPrecedingToken(contextToken.getFullStart(),sourceFile),log("getCompletionData: Get previous token 2: "+((new Date).getTime()-start_6))}var node=currentToken,isRightOfDot=!1,isRightOfOpenTag=!1,isStartingCloseTag=!1,location=ts.getTouchingPropertyName(sourceFile,position);if(contextToken){if(isCompletionListBlocker(contextToken))return void log("Returning an empty list because completion was requested in an invalid position.");var parent_11=contextToken.parent,kind=contextToken.kind;if(21===kind)if(169===parent_11.kind)node=contextToken.parent.expression,isRightOfDot=!0;else{if(136!==parent_11.kind)return;node=contextToken.parent.left,isRightOfDot=!0}else 1===sourceFile.languageVariant&&(25===kind?(isRightOfOpenTag=!0,location=contextToken):39===kind&&240===contextToken.parent.kind&&(isStartingCloseTag=!0,location=contextToken))}var isMemberCompletion,isNewIdentifierLocation,semanticStart=(new Date).getTime(),symbols=[];if(isRightOfDot)getTypeScriptMemberSymbols();else if(isRightOfOpenTag){var tagSymbols=typeChecker.getJsxIntrinsicTagNames();symbols=tryGetGlobalSymbols()?tagSymbols.concat(symbols.filter(function(s){return!!(107455&s.flags)})):tagSymbols,isMemberCompletion=!0,isNewIdentifierLocation=!1}else if(isStartingCloseTag){var tagName=contextToken.parent.parent.openingElement.tagName,tagSymbol=typeChecker.getSymbolAtLocation(tagName);typeChecker.isUnknownSymbol(tagSymbol)||(symbols=[tagSymbol]),isMemberCompletion=!0,isNewIdentifierLocation=!1}else if(!tryGetGlobalSymbols())return;return log("getCompletionData: Semantic work: "+((new Date).getTime()-semanticStart)),{symbols:symbols,isMemberCompletion:isMemberCompletion,isNewIdentifierLocation:isNewIdentifierLocation,location:location,isRightOfDot:isRightOfDot||isRightOfOpenTag,isJsDocTagName:isJsDocTagName}}function getCompletionsAtPosition(fileName,position){function getJavaScriptCompletionEntries(sourceFile,position,uniqueNames){var entries=[],target=program.getCompilerOptions().target,nameTable=getNameTable(sourceFile);for(var name_36 in nameTable)if(nameTable[name_36]!==position&&!uniqueNames[name_36]){uniqueNames[name_36]=name_36;var displayName=getCompletionEntryDisplayName(name_36,target,!0);if(displayName){var entry={name:displayName,kind:ScriptElementKind.warning,kindModifiers:"",sortText:"1"};entries.push(entry)}}return entries}function getAllJsDocCompletionEntries(){return jsDocCompletionEntries||(jsDocCompletionEntries=ts.map(jsDocTagNames,function(tagName){return{name:tagName,kind:ScriptElementKind.keyword,kindModifiers:"",sortText:"0"}}))}function createCompletionEntry(symbol,location){var displayName=getCompletionEntryDisplayNameForSymbol(symbol,program.getCompilerOptions().target,!0,location);if(displayName)return{name:displayName,kind:getSymbolKind(symbol,location),kindModifiers:getSymbolModifiers(symbol),sortText:"0"}}function getCompletionEntriesFromSymbols(symbols,entries){var start=(new Date).getTime(),uniqueNames={};if(symbols)for(var _i=0,symbols_4=symbols;_i<symbols_4.length;_i++){var symbol=symbols_4[_i],entry=createCompletionEntry(symbol,location);if(entry){var id=ts.escapeIdentifier(entry.name);ts.lookUp(uniqueNames,id)||(entries.push(entry),uniqueNames[id]=id)}}return log("getCompletionsAtPosition: getCompletionEntriesFromSymbols: "+((new Date).getTime()-start)),uniqueNames}synchronizeHostData();var completionData=getCompletionData(fileName,position);if(completionData){var symbols=completionData.symbols,isMemberCompletion=completionData.isMemberCompletion,isNewIdentifierLocation=completionData.isNewIdentifierLocation,location=completionData.location,isJsDocTagName=completionData.isJsDocTagName;if(isJsDocTagName)return{isMemberCompletion:!1,isNewIdentifierLocation:!1,entries:getAllJsDocCompletionEntries()};var sourceFile=getValidSourceFile(fileName),entries=[];if(ts.isSourceFileJavaScript(sourceFile)){var uniqueNames=getCompletionEntriesFromSymbols(symbols,entries);ts.addRange(entries,getJavaScriptCompletionEntries(sourceFile,location.pos,uniqueNames))}else{if(!symbols||0===symbols.length){if(1!==sourceFile.languageVariant||!location.parent||240!==location.parent.kind)return;var tagName=location.parent.parent.openingElement.tagName;entries.push({name:tagName.text,kind:void 0,kindModifiers:void 0,sortText:"0"})}getCompletionEntriesFromSymbols(symbols,entries)}return isMemberCompletion||isJsDocTagName||ts.addRange(entries,keywordCompletions),{isMemberCompletion:isMemberCompletion,isNewIdentifierLocation:isNewIdentifierLocation,entries:entries}}}function getCompletionEntryDetails(fileName,position,entryName){synchronizeHostData();var completionData=getCompletionData(fileName,position);if(completionData){var symbols=completionData.symbols,location_2=completionData.location,target_2=program.getCompilerOptions().target,symbol=ts.forEach(symbols,function(s){return getCompletionEntryDisplayNameForSymbol(s,target_2,!1,location_2)===entryName?s:void 0});if(symbol){var _a=getSymbolDisplayPartsDocumentationAndSymbolKind(symbol,getValidSourceFile(fileName),location_2,location_2,7),displayParts=_a.displayParts,documentation=_a.documentation,symbolKind=_a.symbolKind;return{name:entryName,kindModifiers:getSymbolModifiers(symbol),kind:symbolKind,displayParts:displayParts,documentation:documentation}}}var keywordCompletion=ts.forEach(keywordCompletions,function(c){return c.name===entryName});if(keywordCompletion)return{name:entryName,kind:ScriptElementKind.keyword,kindModifiers:ScriptElementKindModifier.none,displayParts:[ts.displayPart(entryName,SymbolDisplayPartKind.keyword)],documentation:void 0}}function getSymbolKind(symbol,location){var flags=symbol.getFlags();if(32&flags)return ts.getDeclarationOfKind(symbol,189)?ScriptElementKind.localClassElement:ScriptElementKind.classElement;if(384&flags)return ScriptElementKind.enumElement;if(524288&flags)return ScriptElementKind.typeElement;if(64&flags)return ScriptElementKind.interfaceElement;if(262144&flags)return ScriptElementKind.typeParameterElement;var result=getSymbolKindOfConstructorPropertyMethodAccessorFunctionOrVar(symbol,flags,location);if(result===ScriptElementKind.unknown){if(262144&flags)return ScriptElementKind.typeParameterElement;if(8&flags)return ScriptElementKind.variableElement;if(8388608&flags)return ScriptElementKind.alias;if(1536&flags)return ScriptElementKind.moduleElement}return result}function getSymbolKindOfConstructorPropertyMethodAccessorFunctionOrVar(symbol,flags,location){var typeChecker=program.getTypeChecker();if(typeChecker.isUndefinedSymbol(symbol))return ScriptElementKind.variableElement;if(typeChecker.isArgumentsSymbol(symbol))return ScriptElementKind.localVariableElement;if(3&flags)return ts.isFirstDeclarationOfSymbolParameter(symbol)?ScriptElementKind.parameterElement:symbol.valueDeclaration&&ts.isConst(symbol.valueDeclaration)?ScriptElementKind.constElement:ts.forEach(symbol.declarations,ts.isLet)?ScriptElementKind.letElement:isLocalVariableOrFunction(symbol)?ScriptElementKind.localVariableElement:ScriptElementKind.variableElement;if(16&flags)return isLocalVariableOrFunction(symbol)?ScriptElementKind.localFunctionElement:ScriptElementKind.functionElement;if(32768&flags)return ScriptElementKind.memberGetAccessorElement;if(65536&flags)return ScriptElementKind.memberSetAccessorElement;if(8192&flags)return ScriptElementKind.memberFunctionElement;if(16384&flags)return ScriptElementKind.constructorImplementationElement;if(4&flags){if(268435456&flags){var unionPropertyKind=ts.forEach(typeChecker.getRootSymbols(symbol),function(rootSymbol){var rootSymbolFlags=rootSymbol.getFlags();return 98311&rootSymbolFlags?ScriptElementKind.memberVariableElement:void ts.Debug.assert(!!(8192&rootSymbolFlags))});if(!unionPropertyKind){var typeOfUnionProperty=typeChecker.getTypeOfSymbolAtLocation(symbol,location);return typeOfUnionProperty.getCallSignatures().length?ScriptElementKind.memberFunctionElement:ScriptElementKind.memberVariableElement}return unionPropertyKind}return ScriptElementKind.memberVariableElement}return ScriptElementKind.unknown}function getSymbolModifiers(symbol){return symbol&&symbol.declarations&&symbol.declarations.length>0?ts.getNodeModifiers(symbol.declarations[0]):ScriptElementKindModifier.none}function getSymbolDisplayPartsDocumentationAndSymbolKind(symbol,sourceFile,enclosingDeclaration,location,semanticMeaning){function addNewLineIfDisplayPartsExist(){displayParts.length&&displayParts.push(ts.lineBreakPart())}function addFullSymbolName(symbol,enclosingDeclaration){var fullSymbolDisplayParts=ts.symbolToDisplayParts(typeChecker,symbol,enclosingDeclaration||sourceFile,void 0,3);ts.addRange(displayParts,fullSymbolDisplayParts)}function addPrefixForAnyFunctionOrVar(symbol,symbolKind){addNewLineIfDisplayPartsExist(),symbolKind&&(pushTypePart(symbolKind),displayParts.push(ts.spacePart()),addFullSymbolName(symbol))}function pushTypePart(symbolKind){switch(symbolKind){case ScriptElementKind.variableElement:case ScriptElementKind.functionElement:case ScriptElementKind.letElement:case ScriptElementKind.constElement:case ScriptElementKind.constructorImplementationElement:return void displayParts.push(ts.textOrKeywordPart(symbolKind));default:return displayParts.push(ts.punctuationPart(17)),displayParts.push(ts.textOrKeywordPart(symbolKind)),void displayParts.push(ts.punctuationPart(18))}}function addSignatureDisplayParts(signature,allSignatures,flags){ts.addRange(displayParts,ts.signatureToDisplayParts(typeChecker,signature,enclosingDeclaration,32|flags)),allSignatures.length>1&&(displayParts.push(ts.spacePart()),displayParts.push(ts.punctuationPart(17)),displayParts.push(ts.operatorPart(35)),displayParts.push(ts.displayPart((allSignatures.length-1).toString(),SymbolDisplayPartKind.numericLiteral)),displayParts.push(ts.spacePart()),displayParts.push(ts.textPart(2===allSignatures.length?"overload":"overloads")),displayParts.push(ts.punctuationPart(18))),documentation=signature.getDocumentationComment()}function writeTypeParametersOfSymbol(symbol,enclosingDeclaration){var typeParameterParts=ts.mapToDisplayParts(function(writer){typeChecker.getSymbolDisplayBuilder().buildTypeParameterDisplayFromSymbol(symbol,writer,enclosingDeclaration)});ts.addRange(displayParts,typeParameterParts)}void 0===semanticMeaning&&(semanticMeaning=getMeaningFromLocation(location));var documentation,hasAddedSymbolInfo,type,typeChecker=program.getTypeChecker(),displayParts=[],symbolFlags=symbol.flags,symbolKind=getSymbolKindOfConstructorPropertyMethodAccessorFunctionOrVar(symbol,symbolFlags,location);if(symbolKind!==ScriptElementKind.unknown||32&symbolFlags||8388608&symbolFlags){symbolKind!==ScriptElementKind.memberGetAccessorElement&&symbolKind!==ScriptElementKind.memberSetAccessorElement||(symbolKind=ScriptElementKind.memberVariableElement);var signature=void 0;if(type=typeChecker.getTypeOfSymbolAtLocation(symbol,location)){if(location.parent&&169===location.parent.kind){var right=location.parent.name;(right===location||right&&0===right.getFullWidth())&&(location=location.parent)}var callExpression=void 0;if(171===location.kind||172===location.kind?callExpression=location:(isCallExpressionTarget(location)||isNewExpressionTarget(location))&&(callExpression=location.parent),callExpression){var candidateSignatures=[];signature=typeChecker.getResolvedSignature(callExpression,candidateSignatures),!signature&&candidateSignatures.length&&(signature=candidateSignatures[0]);var useConstructSignatures=172===callExpression.kind||95===callExpression.expression.kind,allSignatures=useConstructSignatures?type.getConstructSignatures():type.getCallSignatures();if(ts.contains(allSignatures,signature.target)||ts.contains(allSignatures,signature)||(signature=allSignatures.length?allSignatures[0]:void 0),signature){switch(useConstructSignatures&&32&symbolFlags?(symbolKind=ScriptElementKind.constructorImplementationElement,addPrefixForAnyFunctionOrVar(type.symbol,symbolKind)):8388608&symbolFlags?(symbolKind=ScriptElementKind.alias,pushTypePart(symbolKind),displayParts.push(ts.spacePart()),useConstructSignatures&&(displayParts.push(ts.keywordPart(92)),displayParts.push(ts.spacePart())),addFullSymbolName(symbol)):addPrefixForAnyFunctionOrVar(symbol,symbolKind),symbolKind){case ScriptElementKind.memberVariableElement:case ScriptElementKind.variableElement:case ScriptElementKind.constElement:case ScriptElementKind.letElement:case ScriptElementKind.parameterElement:case ScriptElementKind.localVariableElement:displayParts.push(ts.punctuationPart(54)),displayParts.push(ts.spacePart()),useConstructSignatures&&(displayParts.push(ts.keywordPart(92)),displayParts.push(ts.spacePart())),65536&type.flags||ts.addRange(displayParts,ts.symbolToDisplayParts(typeChecker,type.symbol,enclosingDeclaration,void 0,1)),addSignatureDisplayParts(signature,allSignatures,8);break;default:addSignatureDisplayParts(signature,allSignatures)}hasAddedSymbolInfo=!0}}else if(isNameOfFunctionDeclaration(location)&&!(98304&symbol.flags)||121===location.kind&&145===location.parent.kind){var functionDeclaration=location.parent,allSignatures=145===functionDeclaration.kind?type.getConstructSignatures():type.getCallSignatures();signature=typeChecker.isImplementationOfOverload(functionDeclaration)?allSignatures[0]:typeChecker.getSignatureFromDeclaration(functionDeclaration),145===functionDeclaration.kind?(symbolKind=ScriptElementKind.constructorImplementationElement,addPrefixForAnyFunctionOrVar(type.symbol,symbolKind)):addPrefixForAnyFunctionOrVar(148!==functionDeclaration.kind||2048&type.symbol.flags||4096&type.symbol.flags?symbol:type.symbol,symbolKind),addSignatureDisplayParts(signature,allSignatures),hasAddedSymbolInfo=!0}}}if(32&symbolFlags&&!hasAddedSymbolInfo&&(ts.getDeclarationOfKind(symbol,189)?pushTypePart(ScriptElementKind.localClassElement):displayParts.push(ts.keywordPart(73)),displayParts.push(ts.spacePart()),addFullSymbolName(symbol),writeTypeParametersOfSymbol(symbol,sourceFile)),64&symbolFlags&&2&semanticMeaning&&(addNewLineIfDisplayPartsExist(),displayParts.push(ts.keywordPart(107)),displayParts.push(ts.spacePart()),addFullSymbolName(symbol),writeTypeParametersOfSymbol(symbol,sourceFile)),524288&symbolFlags&&(addNewLineIfDisplayPartsExist(),displayParts.push(ts.keywordPart(132)),displayParts.push(ts.spacePart()),addFullSymbolName(symbol),writeTypeParametersOfSymbol(symbol,sourceFile),displayParts.push(ts.spacePart()),displayParts.push(ts.operatorPart(56)),displayParts.push(ts.spacePart()),ts.addRange(displayParts,ts.typeToDisplayParts(typeChecker,typeChecker.getDeclaredTypeOfSymbol(symbol),enclosingDeclaration))),384&symbolFlags&&(addNewLineIfDisplayPartsExist(),ts.forEach(symbol.declarations,ts.isConstEnumDeclaration)&&(displayParts.push(ts.keywordPart(74)),displayParts.push(ts.spacePart())),displayParts.push(ts.keywordPart(81)),displayParts.push(ts.spacePart()),addFullSymbolName(symbol)),1536&symbolFlags){addNewLineIfDisplayPartsExist();var declaration=ts.getDeclarationOfKind(symbol,221),isNamespace=declaration&&declaration.name&&69===declaration.name.kind;displayParts.push(ts.keywordPart(isNamespace?126:125)),displayParts.push(ts.spacePart()),addFullSymbolName(symbol)}if(262144&symbolFlags&&2&semanticMeaning)if(addNewLineIfDisplayPartsExist(),displayParts.push(ts.punctuationPart(17)),displayParts.push(ts.textPart("type parameter")),displayParts.push(ts.punctuationPart(18)),displayParts.push(ts.spacePart()),addFullSymbolName(symbol),displayParts.push(ts.spacePart()),displayParts.push(ts.keywordPart(90)),displayParts.push(ts.spacePart()),symbol.parent)addFullSymbolName(symbol.parent,enclosingDeclaration),writeTypeParametersOfSymbol(symbol.parent,enclosingDeclaration);else{var declaration=ts.getDeclarationOfKind(symbol,138);if(ts.Debug.assert(void 0!==declaration),declaration=declaration.parent)if(ts.isFunctionLikeKind(declaration.kind)){var signature=typeChecker.getSignatureFromDeclaration(declaration);149===declaration.kind?(displayParts.push(ts.keywordPart(92)),displayParts.push(ts.spacePart())):148!==declaration.kind&&declaration.name&&addFullSymbolName(declaration.symbol),ts.addRange(displayParts,ts.signatureToDisplayParts(typeChecker,signature,sourceFile,32))}else displayParts.push(ts.keywordPart(132)),displayParts.push(ts.spacePart()),addFullSymbolName(declaration.symbol),writeTypeParametersOfSymbol(declaration.symbol,sourceFile)}if(8&symbolFlags){addPrefixForAnyFunctionOrVar(symbol,"enum member");var declaration=symbol.declarations[0];if(250===declaration.kind){var constantValue=typeChecker.getConstantValue(declaration);void 0!==constantValue&&(displayParts.push(ts.spacePart()),displayParts.push(ts.operatorPart(56)),displayParts.push(ts.spacePart()),displayParts.push(ts.displayPart(constantValue.toString(),SymbolDisplayPartKind.numericLiteral)))}}if(8388608&symbolFlags&&(addNewLineIfDisplayPartsExist(),displayParts.push(ts.keywordPart(89)),displayParts.push(ts.spacePart()),addFullSymbolName(symbol),ts.forEach(symbol.declarations,function(declaration){if(224===declaration.kind){var importEqualsDeclaration=declaration;if(ts.isExternalModuleImportEqualsDeclaration(importEqualsDeclaration))displayParts.push(ts.spacePart()),displayParts.push(ts.operatorPart(56)),displayParts.push(ts.spacePart()),displayParts.push(ts.keywordPart(127)),displayParts.push(ts.punctuationPart(17)),displayParts.push(ts.displayPart(ts.getTextOfNode(ts.getExternalModuleImportEqualsDeclarationExpression(importEqualsDeclaration)),SymbolDisplayPartKind.stringLiteral)),displayParts.push(ts.punctuationPart(18));else{var internalAliasSymbol=typeChecker.getSymbolAtLocation(importEqualsDeclaration.moduleReference);internalAliasSymbol&&(displayParts.push(ts.spacePart()),displayParts.push(ts.operatorPart(56)),displayParts.push(ts.spacePart()),addFullSymbolName(internalAliasSymbol,enclosingDeclaration))}return!0}})),!hasAddedSymbolInfo)if(symbolKind!==ScriptElementKind.unknown){if(type)if(addPrefixForAnyFunctionOrVar(symbol,symbolKind),symbolKind===ScriptElementKind.memberVariableElement||3&symbolFlags||symbolKind===ScriptElementKind.localVariableElement)if(displayParts.push(ts.punctuationPart(54)),displayParts.push(ts.spacePart()),type.symbol&&262144&type.symbol.flags){var typeParameterParts=ts.mapToDisplayParts(function(writer){typeChecker.getSymbolDisplayBuilder().buildTypeParameterDisplay(type,writer,enclosingDeclaration)});ts.addRange(displayParts,typeParameterParts)}else ts.addRange(displayParts,ts.typeToDisplayParts(typeChecker,type,enclosingDeclaration));else if(16&symbolFlags||8192&symbolFlags||16384&symbolFlags||131072&symbolFlags||98304&symbolFlags||symbolKind===ScriptElementKind.memberFunctionElement){var allSignatures=type.getCallSignatures();addSignatureDisplayParts(allSignatures[0],allSignatures)}}else symbolKind=getSymbolKind(symbol,location);return documentation||(documentation=symbol.getDocumentationComment()),{displayParts:displayParts,documentation:documentation,symbolKind:symbolKind}}function getQuickInfoAtPosition(fileName,position){synchronizeHostData();var sourceFile=getValidSourceFile(fileName),node=ts.getTouchingPropertyName(sourceFile,position);if(node&&!isLabelName(node)){var typeChecker=program.getTypeChecker(),symbol=typeChecker.getSymbolAtLocation(node);if(symbol&&!typeChecker.isUnknownSymbol(symbol)){var displayPartsDocumentationsAndKind=getSymbolDisplayPartsDocumentationAndSymbolKind(symbol,sourceFile,getContainerNode(node),node);return{kind:displayPartsDocumentationsAndKind.symbolKind,kindModifiers:getSymbolModifiers(symbol),textSpan:ts.createTextSpan(node.getStart(),node.getWidth()),displayParts:displayPartsDocumentationsAndKind.displayParts,documentation:displayPartsDocumentationsAndKind.documentation}}switch(node.kind){case 69:case 169:case 136:case 97:case 162:case 95:var type=typeChecker.getTypeAtLocation(node);if(type)return{kind:ScriptElementKind.unknown,kindModifiers:ScriptElementKindModifier.none,textSpan:ts.createTextSpan(node.getStart(),node.getWidth()),displayParts:ts.typeToDisplayParts(typeChecker,type,getContainerNode(node)),documentation:type.symbol?type.symbol.getDocumentationComment():void 0}}}}function createDefinitionInfo(node,symbolKind,symbolName,containerName){return{fileName:node.getSourceFile().fileName,textSpan:ts.createTextSpanFromBounds(node.getStart(),node.getEnd()),kind:symbolKind,name:symbolName,containerKind:void 0,containerName:containerName}}function getDefinitionFromSymbol(symbol,node){function tryAddConstructSignature(symbol,location,symbolKind,symbolName,containerName,result){if((isNewExpressionTarget(location)||121===location.kind)&&32&symbol.flags){for(var _i=0,_a=symbol.getDeclarations();_i<_a.length;_i++){var declaration=_a[_i];if(ts.isClassLike(declaration))return tryAddSignature(declaration.members,!0,symbolKind,symbolName,containerName,result)}ts.Debug.fail("Expected declaration to have at least one class-like declaration")}return!1}function tryAddCallSignature(symbol,location,symbolKind,symbolName,containerName,result){return!!(isCallExpressionTarget(location)||isNewExpressionTarget(location)||isNameOfFunctionDeclaration(location))&&tryAddSignature(symbol.declarations,!1,symbolKind,symbolName,containerName,result)}function tryAddSignature(signatureDeclarations,selectConstructors,symbolKind,symbolName,containerName,result){var definition,declarations=[];return ts.forEach(signatureDeclarations,function(d){(selectConstructors&&145===d.kind||!selectConstructors&&(216===d.kind||144===d.kind||143===d.kind))&&(declarations.push(d),d.body&&(definition=d))}),definition?(result.push(createDefinitionInfo(definition,symbolKind,symbolName,containerName)),!0):!!declarations.length&&(result.push(createDefinitionInfo(ts.lastOrUndefined(declarations),symbolKind,symbolName,containerName)),!0)}var typeChecker=program.getTypeChecker(),result=[],declarations=symbol.getDeclarations(),symbolName=typeChecker.symbolToString(symbol),symbolKind=getSymbolKind(symbol,node),containerSymbol=symbol.parent,containerName=containerSymbol?typeChecker.symbolToString(containerSymbol,node):"";return tryAddConstructSignature(symbol,node,symbolKind,symbolName,containerName,result)||tryAddCallSignature(symbol,node,symbolKind,symbolName,containerName,result)||ts.forEach(declarations,function(declaration){result.push(createDefinitionInfo(declaration,symbolKind,symbolName,containerName))}),result}function getDefinitionAtPosition(fileName,position){synchronizeHostData();var sourceFile=getValidSourceFile(fileName),node=ts.getTouchingPropertyName(sourceFile,position);if(node){if(isJumpStatementTarget(node)){var labelName=node.text,label=getTargetLabel(node.parent,node.text);return label?[createDefinitionInfo(label,ScriptElementKind.label,labelName,void 0)]:void 0}var comment=ts.forEach(sourceFile.referencedFiles,function(r){return r.pos<=position&&position<r.end?r:void 0});if(comment){var referenceFile=ts.tryResolveScriptReference(program,sourceFile,comment);if(referenceFile)return[{fileName:referenceFile.fileName,textSpan:ts.createTextSpanFromBounds(0,0),kind:ScriptElementKind.scriptElement,name:comment.fileName,containerName:void 0,containerKind:void 0}]}else{var typeChecker=program.getTypeChecker(),symbol=typeChecker.getSymbolAtLocation(node);if(symbol){if(8388608&symbol.flags){var declaration=symbol.declarations[0];69===node.kind&&node.parent===declaration&&(symbol=typeChecker.getAliasedSymbol(symbol))}if(249===node.parent.kind){var shorthandSymbol=typeChecker.getShorthandAssignmentValueSymbol(symbol.valueDeclaration);if(!shorthandSymbol)return[];var shorthandDeclarations=shorthandSymbol.getDeclarations(),shorthandSymbolKind_1=getSymbolKind(shorthandSymbol,node),shorthandSymbolName_1=typeChecker.symbolToString(shorthandSymbol),shorthandContainerName_1=typeChecker.symbolToString(symbol.parent,node);return ts.map(shorthandDeclarations,function(declaration){return createDefinitionInfo(declaration,shorthandSymbolKind_1,shorthandSymbolName_1,shorthandContainerName_1)})}return getDefinitionFromSymbol(symbol,node)}}}}function getTypeDefinitionAtPosition(fileName,position){synchronizeHostData();var sourceFile=getValidSourceFile(fileName),node=ts.getTouchingPropertyName(sourceFile,position);if(node){var typeChecker=program.getTypeChecker(),symbol=typeChecker.getSymbolAtLocation(node);if(symbol){var type=typeChecker.getTypeOfSymbolAtLocation(symbol,node);if(type){if(16384&type.flags){var result_4=[];return ts.forEach(type.types,function(t){t.symbol&&ts.addRange(result_4,getDefinitionFromSymbol(t.symbol,node))}),result_4}if(type.symbol)return getDefinitionFromSymbol(type.symbol,node)}}}}function getOccurrencesAtPosition(fileName,position){var results=getOccurrencesAtPositionCore(fileName,position);if(results){var sourceFile_2=getCanonicalFileName(ts.normalizeSlashes(fileName));results=ts.filter(results,function(r){return getCanonicalFileName(ts.normalizeSlashes(r.fileName))===sourceFile_2})}return results}function getDocumentHighlights(fileName,position,filesToSearch){function getHighlightSpanForNode(node){var start=node.getStart(),end=node.getEnd();return{fileName:sourceFile.fileName,textSpan:ts.createTextSpanFromBounds(start,end),kind:HighlightSpanKind.none}}function getSemanticDocumentHighlights(node){function convertReferencedSymbols(referencedSymbols){if(referencedSymbols){for(var fileNameToDocumentHighlights={},result=[],_i=0,referencedSymbols_1=referencedSymbols;_i<referencedSymbols_1.length;_i++)for(var referencedSymbol=referencedSymbols_1[_i],_a=0,_b=referencedSymbol.references;_a<_b.length;_a++){var referenceEntry=_b[_a],fileName_1=referenceEntry.fileName,documentHighlights=ts.getProperty(fileNameToDocumentHighlights,fileName_1);documentHighlights||(documentHighlights={fileName:fileName_1,highlightSpans:[]},fileNameToDocumentHighlights[fileName_1]=documentHighlights,result.push(documentHighlights)),documentHighlights.highlightSpans.push({textSpan:referenceEntry.textSpan,kind:referenceEntry.isWriteAccess?HighlightSpanKind.writtenReference:HighlightSpanKind.reference})}return result}}if(69===node.kind||97===node.kind||162===node.kind||95===node.kind||isLiteralNameOfPropertyDeclarationOrIndexAccess(node)||isNameOfExternalModuleImportOrDeclaration(node)){var referencedSymbols=getReferencedSymbolsForNode(node,sourceFilesToSearch,!1,!1);return convertReferencedSymbols(referencedSymbols)}}function getSyntacticDocumentHighlights(node){function hasKind(node,kind){return void 0!==node&&node.kind===kind}function parent(node){return node&&node.parent}function getHighlightSpans(node){if(node)switch(node.kind){case 88:case 80:if(hasKind(node.parent,199))return getIfElseOccurrences(node.parent);break;case 94:if(hasKind(node.parent,207))return getReturnOccurrences(node.parent);break;case 98:if(hasKind(node.parent,211))return getThrowOccurrences(node.parent);break;case 72:if(hasKind(parent(parent(node)),212))return getTryCatchFinallyOccurrences(node.parent.parent);break;case 100:case 85:if(hasKind(parent(node),212))return getTryCatchFinallyOccurrences(node.parent);break;case 96:if(hasKind(node.parent,209))return getSwitchCaseDefaultOccurrences(node.parent);break;case 71:case 77:if(hasKind(parent(parent(parent(node))),209))return getSwitchCaseDefaultOccurrences(node.parent.parent.parent);break;case 70:case 75:if(hasKind(node.parent,206)||hasKind(node.parent,205))return getBreakOrContinueStatementOccurrences(node.parent);break;case 86:if(hasKind(node.parent,202)||hasKind(node.parent,203)||hasKind(node.parent,204))return getLoopBreakContinueOccurrences(node.parent);break;case 104:case 79:if(hasKind(node.parent,201)||hasKind(node.parent,200))return getLoopBreakContinueOccurrences(node.parent);break;case 121:if(hasKind(node.parent,145))return getConstructorOccurrences(node.parent);break;case 123:case 129:if(hasKind(node.parent,146)||hasKind(node.parent,147))return getGetAndSetOccurrences(node.parent);break;default:if(ts.isModifierKind(node.kind)&&node.parent&&(ts.isDeclaration(node.parent)||196===node.parent.kind))return getModifierOccurrences(node.kind,node.parent)}}function aggregateOwnedThrowStatements(node){function aggregate(node){if(211===node.kind)statementAccumulator.push(node);else if(212===node.kind){var tryStatement=node;aggregate(tryStatement.catchClause?tryStatement.catchClause:tryStatement.tryBlock),tryStatement.finallyBlock&&aggregate(tryStatement.finallyBlock)}else ts.isFunctionLike(node)||ts.forEachChild(node,aggregate);
}var statementAccumulator=[];return aggregate(node),statementAccumulator}function getThrowStatementOwner(throwStatement){for(var child=throwStatement;child.parent;){var parent_14=child.parent;if(ts.isFunctionBlock(parent_14)||251===parent_14.kind)return parent_14;if(212===parent_14.kind){var tryStatement=parent_14;if(tryStatement.tryBlock===child&&tryStatement.catchClause)return child}child=parent_14}}function aggregateAllBreakAndContinueStatements(node){function aggregate(node){206===node.kind||205===node.kind?statementAccumulator.push(node):ts.isFunctionLike(node)||ts.forEachChild(node,aggregate)}var statementAccumulator=[];return aggregate(node),statementAccumulator}function ownsBreakOrContinueStatement(owner,statement){var actualOwner=getBreakOrContinueOwner(statement);return actualOwner&&actualOwner===owner}function getBreakOrContinueOwner(statement){for(var node_2=statement.parent;node_2;node_2=node_2.parent)switch(node_2.kind){case 209:if(205===statement.kind)continue;case 202:case 203:case 204:case 201:case 200:if(!statement.label||isLabeledBy(node_2,statement.label.text))return node_2;break;default:if(ts.isFunctionLike(node_2))return}}function getModifierOccurrences(modifier,declaration){function getFlagFromModifier(modifier){switch(modifier){case 112:return 8;case 110:return 16;case 111:return 32;case 113:return 64;case 82:return 2;case 122:return 4;case 115:return 128;default:ts.Debug.fail()}}var container=declaration.parent;if(ts.isAccessibilityModifier(modifier)){if(!(217===container.kind||189===container.kind||139===declaration.kind&&hasKind(container,145)))return}else if(113===modifier){if(217!==container.kind&&189!==container.kind)return}else if(82===modifier||122===modifier){if(222!==container.kind&&251!==container.kind)return}else{if(115!==modifier)return;if(217!==container.kind&&217!==declaration.kind)return}var nodes,keywords=[],modifierFlag=getFlagFromModifier(modifier);switch(container.kind){case 222:case 251:nodes=128&modifierFlag?declaration.members.concat(declaration):container.statements;break;case 145:nodes=container.parameters.concat(container.parent.members);break;case 217:case 189:if(nodes=container.members,56&modifierFlag){var constructor=ts.forEach(container.members,function(member){return 145===member.kind&&member});constructor&&(nodes=nodes.concat(constructor.parameters))}else 128&modifierFlag&&(nodes=nodes.concat(container));break;default:ts.Debug.fail("Invalid container kind.")}return ts.forEach(nodes,function(node){node.modifiers&&node.flags&modifierFlag&&ts.forEach(node.modifiers,function(child){return pushKeywordIf(keywords,child,modifier)})}),ts.map(keywords,getHighlightSpanForNode)}function pushKeywordIf(keywordList,token){for(var expected=[],_i=2;_i<arguments.length;_i++)expected[_i-2]=arguments[_i];return!(!token||!ts.contains(expected,token.kind))&&(keywordList.push(token),!0)}function getGetAndSetOccurrences(accessorDeclaration){function tryPushAccessorKeyword(accessorSymbol,accessorKind){var accessor=ts.getDeclarationOfKind(accessorSymbol,accessorKind);accessor&&ts.forEach(accessor.getChildren(),function(child){return pushKeywordIf(keywords,child,123,129)})}var keywords=[];return tryPushAccessorKeyword(accessorDeclaration.symbol,146),tryPushAccessorKeyword(accessorDeclaration.symbol,147),ts.map(keywords,getHighlightSpanForNode)}function getConstructorOccurrences(constructorDeclaration){var declarations=constructorDeclaration.symbol.getDeclarations(),keywords=[];return ts.forEach(declarations,function(declaration){ts.forEach(declaration.getChildren(),function(token){return pushKeywordIf(keywords,token,121)})}),ts.map(keywords,getHighlightSpanForNode)}function getLoopBreakContinueOccurrences(loopNode){var keywords=[];if(pushKeywordIf(keywords,loopNode.getFirstToken(),86,104,79)&&200===loopNode.kind)for(var loopTokens=loopNode.getChildren(),i=loopTokens.length-1;i>=0&&!pushKeywordIf(keywords,loopTokens[i],104);i--);var breaksAndContinues=aggregateAllBreakAndContinueStatements(loopNode.statement);return ts.forEach(breaksAndContinues,function(statement){ownsBreakOrContinueStatement(loopNode,statement)&&pushKeywordIf(keywords,statement.getFirstToken(),70,75)}),ts.map(keywords,getHighlightSpanForNode)}function getBreakOrContinueStatementOccurrences(breakOrContinueStatement){var owner=getBreakOrContinueOwner(breakOrContinueStatement);if(owner)switch(owner.kind){case 202:case 203:case 204:case 200:case 201:return getLoopBreakContinueOccurrences(owner);case 209:return getSwitchCaseDefaultOccurrences(owner)}}function getSwitchCaseDefaultOccurrences(switchStatement){var keywords=[];return pushKeywordIf(keywords,switchStatement.getFirstToken(),96),ts.forEach(switchStatement.caseBlock.clauses,function(clause){pushKeywordIf(keywords,clause.getFirstToken(),71,77);var breaksAndContinues=aggregateAllBreakAndContinueStatements(clause);ts.forEach(breaksAndContinues,function(statement){ownsBreakOrContinueStatement(switchStatement,statement)&&pushKeywordIf(keywords,statement.getFirstToken(),70)})}),ts.map(keywords,getHighlightSpanForNode)}function getTryCatchFinallyOccurrences(tryStatement){var keywords=[];if(pushKeywordIf(keywords,tryStatement.getFirstToken(),100),tryStatement.catchClause&&pushKeywordIf(keywords,tryStatement.catchClause.getFirstToken(),72),tryStatement.finallyBlock){var finallyKeyword=ts.findChildOfKind(tryStatement,85,sourceFile);pushKeywordIf(keywords,finallyKeyword,85)}return ts.map(keywords,getHighlightSpanForNode)}function getThrowOccurrences(throwStatement){var owner=getThrowStatementOwner(throwStatement);if(owner){var keywords=[];return ts.forEach(aggregateOwnedThrowStatements(owner),function(throwStatement){pushKeywordIf(keywords,throwStatement.getFirstToken(),98)}),ts.isFunctionBlock(owner)&&ts.forEachReturnStatement(owner,function(returnStatement){pushKeywordIf(keywords,returnStatement.getFirstToken(),94)}),ts.map(keywords,getHighlightSpanForNode)}}function getReturnOccurrences(returnStatement){var func=ts.getContainingFunction(returnStatement);if(func&&hasKind(func.body,195)){var keywords=[];return ts.forEachReturnStatement(func.body,function(returnStatement){pushKeywordIf(keywords,returnStatement.getFirstToken(),94)}),ts.forEach(aggregateOwnedThrowStatements(func.body),function(throwStatement){pushKeywordIf(keywords,throwStatement.getFirstToken(),98)}),ts.map(keywords,getHighlightSpanForNode)}}function getIfElseOccurrences(ifStatement){for(var keywords=[];hasKind(ifStatement.parent,199)&&ifStatement.parent.elseStatement===ifStatement;)ifStatement=ifStatement.parent;for(;ifStatement;){var children=ifStatement.getChildren();pushKeywordIf(keywords,children[0],88);for(var i=children.length-1;i>=0&&!pushKeywordIf(keywords,children[i],80);i--);if(!hasKind(ifStatement.elseStatement,199))break;ifStatement=ifStatement.elseStatement}for(var result=[],i=0;i<keywords.length;i++){if(80===keywords[i].kind&&i<keywords.length-1){for(var elseKeyword=keywords[i],ifKeyword=keywords[i+1],shouldCombindElseAndIf=!0,j=ifKeyword.getStart()-1;j>=elseKeyword.end;j--)if(!ts.isWhiteSpace(sourceFile.text.charCodeAt(j))){shouldCombindElseAndIf=!1;break}if(shouldCombindElseAndIf){result.push({fileName:fileName,textSpan:ts.createTextSpanFromBounds(elseKeyword.getStart(),ifKeyword.end),kind:HighlightSpanKind.reference}),i++;continue}}result.push(getHighlightSpanForNode(keywords[i]))}return result}var fileName=sourceFile.fileName,highlightSpans=getHighlightSpans(node);if(highlightSpans&&0!==highlightSpans.length)return[{fileName:fileName,highlightSpans:highlightSpans}]}synchronizeHostData(),filesToSearch=ts.map(filesToSearch,ts.normalizeSlashes);var sourceFilesToSearch=ts.filter(program.getSourceFiles(),function(f){return ts.contains(filesToSearch,f.fileName)}),sourceFile=getValidSourceFile(fileName),node=ts.getTouchingWord(sourceFile,position);if(node)return getSemanticDocumentHighlights(node)||getSyntacticDocumentHighlights(node)}function getOccurrencesAtPositionCore(fileName,position){function convertDocumentHighlights(documentHighlights){if(documentHighlights){for(var result=[],_i=0,documentHighlights_1=documentHighlights;_i<documentHighlights_1.length;_i++)for(var entry=documentHighlights_1[_i],_a=0,_b=entry.highlightSpans;_a<_b.length;_a++){var highlightSpan=_b[_a];result.push({fileName:entry.fileName,textSpan:highlightSpan.textSpan,isWriteAccess:highlightSpan.kind===HighlightSpanKind.writtenReference})}return result}}return synchronizeHostData(),convertDocumentHighlights(getDocumentHighlights(fileName,position,[fileName]))}function convertReferences(referenceSymbols){if(referenceSymbols){for(var referenceEntries=[],_i=0,referenceSymbols_1=referenceSymbols;_i<referenceSymbols_1.length;_i++){var referenceSymbol=referenceSymbols_1[_i];ts.addRange(referenceEntries,referenceSymbol.references)}return referenceEntries}}function findRenameLocations(fileName,position,findInStrings,findInComments){var referencedSymbols=findReferencedSymbols(fileName,position,findInStrings,findInComments);return convertReferences(referencedSymbols)}function getReferencesAtPosition(fileName,position){var referencedSymbols=findReferencedSymbols(fileName,position,!1,!1);return convertReferences(referencedSymbols)}function findReferences(fileName,position){var referencedSymbols=findReferencedSymbols(fileName,position,!1,!1);return ts.filter(referencedSymbols,function(rs){return!!rs.definition})}function findReferencedSymbols(fileName,position,findInStrings,findInComments){synchronizeHostData();var sourceFile=getValidSourceFile(fileName),node=ts.getTouchingPropertyName(sourceFile,position);if(node&&(69===node.kind||isLiteralNameOfPropertyDeclarationOrIndexAccess(node)||isNameOfExternalModuleImportOrDeclaration(node)))return ts.Debug.assert(69===node.kind||8===node.kind||9===node.kind),getReferencedSymbolsForNode(node,program.getSourceFiles(),findInStrings,findInComments)}function getReferencedSymbolsForNode(node,sourceFiles,findInStrings,findInComments){function getDefinition(symbol){var info=getSymbolDisplayPartsDocumentationAndSymbolKind(symbol,node.getSourceFile(),getContainerNode(node),node),name=ts.map(info.displayParts,function(p){return p.text}).join(""),declarations=symbol.declarations;if(declarations&&0!==declarations.length)return{containerKind:"",containerName:"",name:name,kind:info.symbolKind,fileName:declarations[0].getSourceFile().fileName,textSpan:ts.createTextSpan(declarations[0].getStart(),0)}}function isImportSpecifierSymbol(symbol){return 8388608&symbol.flags&&!!ts.getDeclarationOfKind(symbol,229)}function getInternedName(symbol,location,declarations){if(ts.isImportOrExportSpecifierName(location))return location.getText();var localExportDefaultSymbol=ts.getLocalSymbolForExportDefault(symbol);return symbol=localExportDefaultSymbol||symbol,ts.stripQuotes(symbol.name)}function getSymbolScope(symbol){var valueDeclaration=symbol.valueDeclaration;if(valueDeclaration&&(176===valueDeclaration.kind||189===valueDeclaration.kind))return valueDeclaration;if(8196&symbol.flags){var privateDeclaration=ts.forEach(symbol.getDeclarations(),function(d){return 16&d.flags?d:void 0});if(privateDeclaration)return ts.getAncestor(privateDeclaration,217)}if(!(8388608&symbol.flags||symbol.parent||268435456&symbol.flags)){var scope,declarations=symbol.getDeclarations();if(declarations)for(var _i=0,declarations_8=declarations;_i<declarations_8.length;_i++){var declaration=declarations_8[_i],container=getContainerNode(declaration);if(!container)return;if(scope&&scope!==container)return;if(251===container.kind&&!ts.isExternalModule(container))return;scope=container}return scope}}function getPossibleSymbolReferencePositions(sourceFile,symbolName,start,end){var positions=[];if(!symbolName||!symbolName.length)return positions;for(var text=sourceFile.text,sourceLength=text.length,symbolNameLength=symbolName.length,position=text.indexOf(symbolName,start);position>=0&&(cancellationToken.throwIfCancellationRequested(),!(position>end));){var endPosition=position+symbolNameLength;0!==position&&ts.isIdentifierPart(text.charCodeAt(position-1),2)||endPosition!==sourceLength&&ts.isIdentifierPart(text.charCodeAt(endPosition),2)||positions.push(position),position=text.indexOf(symbolName,position+symbolNameLength+1)}return positions}function getLabelReferencesInNode(container,targetLabel){var references=[],sourceFile=container.getSourceFile(),labelName=targetLabel.text,possiblePositions=getPossibleSymbolReferencePositions(sourceFile,labelName,container.getStart(),container.getEnd());ts.forEach(possiblePositions,function(position){cancellationToken.throwIfCancellationRequested();var node=ts.getTouchingWord(sourceFile,position);node&&node.getWidth()===labelName.length&&(node===targetLabel||isJumpStatementTarget(node)&&getTargetLabel(node,labelName)===targetLabel)&&references.push(getReferenceEntryFromNode(node))});var definition={containerKind:"",containerName:"",fileName:targetLabel.getSourceFile().fileName,kind:ScriptElementKind.label,name:labelName,textSpan:ts.createTextSpanFromBounds(targetLabel.getStart(),targetLabel.getEnd())};return[{definition:definition,references:references}]}function isValidReferencePosition(node,searchSymbolName){if(node)switch(node.kind){case 69:return node.getWidth()===searchSymbolName.length;case 9:if(isLiteralNameOfPropertyDeclarationOrIndexAccess(node)||isNameOfExternalModuleImportOrDeclaration(node))return node.getWidth()===searchSymbolName.length+2;break;case 8:if(isLiteralNameOfPropertyDeclarationOrIndexAccess(node))return node.getWidth()===searchSymbolName.length}return!1}function getReferencesInNode(container,searchSymbol,searchText,searchLocation,searchMeaning,findInStrings,findInComments,result,symbolToIndex){function getReferencedSymbol(symbol){var symbolId=ts.getSymbolId(symbol),index=symbolToIndex[symbolId];return void 0===index&&(index=result.length,symbolToIndex[symbolId]=index,result.push({definition:getDefinition(symbol),references:[]})),result[index]}function isInNonReferenceComment(sourceFile,position){function isNonReferenceComment(c){var commentText=sourceFile.text.substring(c.pos,c.end);return!tripleSlashDirectivePrefixRegex.test(commentText)}return ts.isInCommentHelper(sourceFile,position,isNonReferenceComment)}var sourceFile=container.getSourceFile(),tripleSlashDirectivePrefixRegex=/^\/\/\/\s*</,possiblePositions=getPossibleSymbolReferencePositions(sourceFile,searchText,container.getStart(),container.getEnd());if(possiblePositions.length){var searchSymbols_1=populateSearchSymbolSet(searchSymbol,searchLocation);ts.forEach(possiblePositions,function(position){cancellationToken.throwIfCancellationRequested();var referenceLocation=ts.getTouchingPropertyName(sourceFile,position);if(!isValidReferencePosition(referenceLocation,searchText))return void((findInStrings&&ts.isInString(sourceFile,position)||findInComments&&isInNonReferenceComment(sourceFile,position))&&result.push({definition:void 0,references:[{fileName:sourceFile.fileName,textSpan:ts.createTextSpan(position,searchText.length),isWriteAccess:!1}]}));if(getMeaningFromLocation(referenceLocation)&searchMeaning){var referenceSymbol=typeChecker.getSymbolAtLocation(referenceLocation);if(referenceSymbol){var referenceSymbolDeclaration=referenceSymbol.valueDeclaration,shorthandValueSymbol=typeChecker.getShorthandAssignmentValueSymbol(referenceSymbolDeclaration),relatedSymbol=getRelatedSymbol(searchSymbols_1,referenceSymbol,referenceLocation);if(relatedSymbol){var referencedSymbol=getReferencedSymbol(relatedSymbol);referencedSymbol.references.push(getReferenceEntryFromNode(referenceLocation))}else if(!(67108864&referenceSymbol.flags)&&searchSymbols_1.indexOf(shorthandValueSymbol)>=0){var referencedSymbol=getReferencedSymbol(shorthandValueSymbol);referencedSymbol.references.push(getReferenceEntryFromNode(referenceSymbolDeclaration.name))}}}})}}function getReferencesForSuperKeyword(superKeyword){var searchSpaceNode=ts.getSuperContainer(superKeyword,!1);if(searchSpaceNode){var staticFlag=64;switch(searchSpaceNode.kind){case 142:case 141:case 144:case 143:case 145:case 146:case 147:staticFlag&=searchSpaceNode.flags,searchSpaceNode=searchSpaceNode.parent;break;default:return}var references=[],sourceFile=searchSpaceNode.getSourceFile(),possiblePositions=getPossibleSymbolReferencePositions(sourceFile,"super",searchSpaceNode.getStart(),searchSpaceNode.getEnd());ts.forEach(possiblePositions,function(position){cancellationToken.throwIfCancellationRequested();var node=ts.getTouchingWord(sourceFile,position);if(node&&95===node.kind){var container=ts.getSuperContainer(node,!1);container&&(64&container.flags)===staticFlag&&container.parent.symbol===searchSpaceNode.symbol&&references.push(getReferenceEntryFromNode(node))}});var definition=getDefinition(searchSpaceNode.symbol);return[{definition:definition,references:references}]}}function getReferencesForThisKeyword(thisOrSuperKeyword,sourceFiles){function getThisReferencesInFile(sourceFile,searchSpaceNode,possiblePositions,result){ts.forEach(possiblePositions,function(position){cancellationToken.throwIfCancellationRequested();var node=ts.getTouchingWord(sourceFile,position);if(node&&(97===node.kind||162===node.kind)){var container=ts.getThisContainer(node,!1);switch(searchSpaceNode.kind){case 176:case 216:searchSpaceNode.symbol===container.symbol&&result.push(getReferenceEntryFromNode(node));break;case 144:case 143:ts.isObjectLiteralMethod(searchSpaceNode)&&searchSpaceNode.symbol===container.symbol&&result.push(getReferenceEntryFromNode(node));break;case 189:case 217:container.parent&&searchSpaceNode.symbol===container.parent.symbol&&(64&container.flags)===staticFlag&&result.push(getReferenceEntryFromNode(node));break;case 251:251!==container.kind||ts.isExternalModule(container)||result.push(getReferenceEntryFromNode(node))}}})}var searchSpaceNode=ts.getThisContainer(thisOrSuperKeyword,!1),staticFlag=64;switch(searchSpaceNode.kind){case 144:case 143:if(ts.isObjectLiteralMethod(searchSpaceNode))break;case 142:case 141:case 145:case 146:case 147:staticFlag&=searchSpaceNode.flags,searchSpaceNode=searchSpaceNode.parent;break;case 251:if(ts.isExternalModule(searchSpaceNode))return;case 216:case 176:break;default:return}var possiblePositions,references=[];if(251===searchSpaceNode.kind)ts.forEach(sourceFiles,function(sourceFile){possiblePositions=getPossibleSymbolReferencePositions(sourceFile,"this",sourceFile.getStart(),sourceFile.getEnd()),getThisReferencesInFile(sourceFile,sourceFile,possiblePositions,references)});else{var sourceFile=searchSpaceNode.getSourceFile();possiblePositions=getPossibleSymbolReferencePositions(sourceFile,"this",searchSpaceNode.getStart(),searchSpaceNode.getEnd()),getThisReferencesInFile(sourceFile,searchSpaceNode,possiblePositions,references)}return[{definition:{containerKind:"",containerName:"",fileName:node.getSourceFile().fileName,kind:ScriptElementKind.variableElement,name:"this",textSpan:ts.createTextSpanFromBounds(node.getStart(),node.getEnd())},references:references}]}function populateSearchSymbolSet(symbol,location){var result=[symbol];if(isImportSpecifierSymbol(symbol)&&result.push(typeChecker.getAliasedSymbol(symbol)),233===location.parent.kind&&result.push(typeChecker.getExportSpecifierLocalTargetSymbol(location.parent)),isNameOfPropertyAssignment(location)){ts.forEach(getPropertySymbolsFromContextualType(location),function(contextualSymbol){ts.addRange(result,typeChecker.getRootSymbols(contextualSymbol))});var shorthandValueSymbol=typeChecker.getShorthandAssignmentValueSymbol(location.parent);shorthandValueSymbol&&result.push(shorthandValueSymbol)}return symbol.valueDeclaration&&139===symbol.valueDeclaration.kind&&ts.isParameterPropertyDeclaration(symbol.valueDeclaration)&&(result=result.concat(typeChecker.getSymbolsOfParameterPropertyDeclaration(symbol.valueDeclaration,symbol.name))),ts.forEach(typeChecker.getRootSymbols(symbol),function(rootSymbol){rootSymbol!==symbol&&result.push(rootSymbol),rootSymbol.parent&&96&rootSymbol.parent.flags&&getPropertySymbolsFromBaseTypes(rootSymbol.parent,rootSymbol.getName(),result,{})}),result}function getPropertySymbolsFromBaseTypes(symbol,propertyName,result,previousIterationSymbolsCache){function getPropertySymbolFromTypeReference(typeReference){if(typeReference){var type=typeChecker.getTypeAtLocation(typeReference);if(type){var propertySymbol=typeChecker.getPropertyOfType(type,propertyName);propertySymbol&&result.push(propertySymbol),previousIterationSymbolsCache[symbol.name]=symbol,getPropertySymbolsFromBaseTypes(type.symbol,propertyName,result,previousIterationSymbolsCache)}}}symbol&&(ts.hasProperty(previousIterationSymbolsCache,symbol.name)||96&symbol.flags&&ts.forEach(symbol.getDeclarations(),function(declaration){217===declaration.kind?(getPropertySymbolFromTypeReference(ts.getClassExtendsHeritageClauseElement(declaration)),ts.forEach(ts.getClassImplementsHeritageClauseElements(declaration),getPropertySymbolFromTypeReference)):218===declaration.kind&&ts.forEach(ts.getInterfaceBaseTypeNodes(declaration),getPropertySymbolFromTypeReference)}))}function getRelatedSymbol(searchSymbols,referenceSymbol,referenceLocation){if(searchSymbols.indexOf(referenceSymbol)>=0)return referenceSymbol;if(isImportSpecifierSymbol(referenceSymbol)){var aliasedSymbol=typeChecker.getAliasedSymbol(referenceSymbol);if(searchSymbols.indexOf(aliasedSymbol)>=0)return aliasedSymbol}if(233===referenceLocation.parent.kind){var aliasedSymbol=typeChecker.getExportSpecifierLocalTargetSymbol(referenceLocation.parent);if(searchSymbols.indexOf(aliasedSymbol)>=0)return aliasedSymbol}return isNameOfPropertyAssignment(referenceLocation)?ts.forEach(getPropertySymbolsFromContextualType(referenceLocation),function(contextualSymbol){return ts.forEach(typeChecker.getRootSymbols(contextualSymbol),function(s){return searchSymbols.indexOf(s)>=0?s:void 0})}):ts.forEach(typeChecker.getRootSymbols(referenceSymbol),function(rootSymbol){if(searchSymbols.indexOf(rootSymbol)>=0)return rootSymbol;if(rootSymbol.parent&&96&rootSymbol.parent.flags){var result_5=[];return getPropertySymbolsFromBaseTypes(rootSymbol.parent,rootSymbol.getName(),result_5,{}),ts.forEach(result_5,function(s){return searchSymbols.indexOf(s)>=0?s:void 0})}})}function getPropertySymbolsFromContextualType(node){if(isNameOfPropertyAssignment(node)){var objectLiteral=node.parent.parent,contextualType=typeChecker.getContextualType(objectLiteral),name_37=node.text;if(contextualType){if(16384&contextualType.flags){var unionProperty=contextualType.getProperty(name_37);if(unionProperty)return[unionProperty];var result_6=[];return ts.forEach(contextualType.types,function(t){var symbol=t.getProperty(name_37);symbol&&result_6.push(symbol)}),result_6}var symbol_1=contextualType.getProperty(name_37);if(symbol_1)return[symbol_1]}}}function getIntersectingMeaningFromDeclarations(meaning,declarations){if(declarations){var lastIterationMeaning=void 0;do{lastIterationMeaning=meaning;for(var _i=0,declarations_9=declarations;_i<declarations_9.length;_i++){var declaration=declarations_9[_i],declarationMeaning=getMeaningFromDeclaration(declaration);declarationMeaning&meaning&&(meaning|=declarationMeaning)}}while(meaning!==lastIterationMeaning)}return meaning}var typeChecker=program.getTypeChecker();if(isLabelName(node)){if(isJumpStatementTarget(node)){var labelDefinition=getTargetLabel(node.parent,node.text);return labelDefinition?getLabelReferencesInNode(labelDefinition.parent,labelDefinition):void 0}return getLabelReferencesInNode(node.parent,node)}if(97===node.kind||162===node.kind)return getReferencesForThisKeyword(node,sourceFiles);if(95===node.kind)return getReferencesForSuperKeyword(node);var symbol=typeChecker.getSymbolAtLocation(node);if(symbol){var declarations=symbol.declarations;if(declarations&&declarations.length){var result,searchMeaning=getIntersectingMeaningFromDeclarations(getMeaningFromLocation(node),declarations),declaredName=ts.stripQuotes(ts.getDeclaredName(typeChecker,symbol,node)),scope=getSymbolScope(symbol),symbolToIndex=[];if(scope)result=[],getReferencesInNode(scope,symbol,declaredName,node,searchMeaning,findInStrings,findInComments,result,symbolToIndex);else for(var internedName=getInternedName(symbol,node,declarations),_i=0,sourceFiles_3=sourceFiles;_i<sourceFiles_3.length;_i++){var sourceFile=sourceFiles_3[_i];cancellationToken.throwIfCancellationRequested();var nameTable=getNameTable(sourceFile);void 0!==ts.lookUp(nameTable,internedName)&&(result=result||[],getReferencesInNode(sourceFile,symbol,declaredName,node,searchMeaning,findInStrings,findInComments,result,symbolToIndex))}return result}}}function getReferenceEntryFromNode(node){var start=node.getStart(),end=node.getEnd();return 9===node.kind&&(start+=1,end-=1),{fileName:node.getSourceFile().fileName,textSpan:ts.createTextSpanFromBounds(start,end),isWriteAccess:isWriteAccess(node)}}function isWriteAccess(node){if(69===node.kind&&ts.isDeclarationName(node))return!0;var parent=node.parent;if(parent){if(183===parent.kind||182===parent.kind)return!0;if(184===parent.kind&&parent.left===node){var operator=parent.operatorToken.kind;return 56<=operator&&operator<=68}}return!1}function getNavigateToItems(searchValue,maxResultCount){return synchronizeHostData(),ts.NavigateTo.getNavigateToItems(program,cancellationToken,searchValue,maxResultCount)}function getEmitOutput(fileName){function writeFile(fileName,data,writeByteOrderMark){outputFiles.push({name:fileName,writeByteOrderMark:writeByteOrderMark,text:data})}synchronizeHostData();var sourceFile=getValidSourceFile(fileName),outputFiles=[],emitOutput=program.emit(sourceFile,writeFile,cancellationToken);return{outputFiles:outputFiles,emitSkipped:emitOutput.emitSkipped}}function getMeaningFromDeclaration(node){switch(node.kind){case 139:case 214:case 166:case 142:case 141:case 248:case 249:case 250:case 144:case 143:case 145:case 146:case 147:case 216:case 176:case 177:case 247:return 1;case 138:case 218:case 219:case 156:return 2;case 217:case 220:return 3;case 221:return ts.isAmbientModule(node)?5:1===ts.getModuleInstanceState(node)?5:4;case 228:case 229:case 224:case 225:case 230:case 231:return 7;case 251:return 5}return 7}function isTypeReference(node){return ts.isRightSideOfQualifiedNameOrPropertyAccess(node)&&(node=node.parent),152===node.parent.kind||191===node.parent.kind&&!ts.isExpressionWithTypeArgumentsInClassExtendsClause(node.parent)||97===node.kind&&!ts.isExpression(node)||162===node.kind}function isNamespaceReference(node){return isQualifiedNameNamespaceReference(node)||isPropertyAccessNamespaceReference(node)}function isPropertyAccessNamespaceReference(node){var root=node,isLastClause=!0;if(169===root.parent.kind){for(;root.parent&&169===root.parent.kind;)root=root.parent;isLastClause=root.name===node}if(!isLastClause&&191===root.parent.kind&&246===root.parent.parent.kind){var decl=root.parent.parent.parent;return 217===decl.kind&&106===root.parent.parent.token||218===decl.kind&&83===root.parent.parent.token}return!1}function isQualifiedNameNamespaceReference(node){var root=node,isLastClause=!0;if(136===root.parent.kind){for(;root.parent&&136===root.parent.kind;)root=root.parent;isLastClause=root.right===node}return 152===root.parent.kind&&!isLastClause}function isInRightSideOfImport(node){for(;136===node.parent.kind;)node=node.parent;return ts.isInternalModuleImportEqualsDeclaration(node.parent)&&node.parent.moduleReference===node}function getMeaningFromRightHandSideOfImportEquals(node){return ts.Debug.assert(69===node.kind),136===node.parent.kind&&node.parent.right===node&&224===node.parent.parent.kind?7:4}function getMeaningFromLocation(node){return 230===node.parent.kind?7:isInRightSideOfImport(node)?getMeaningFromRightHandSideOfImportEquals(node):ts.isDeclarationName(node)?getMeaningFromDeclaration(node.parent):isTypeReference(node)?2:isNamespaceReference(node)?4:1}function getSignatureHelpItems(fileName,position){synchronizeHostData();var sourceFile=getValidSourceFile(fileName);return ts.SignatureHelp.getSignatureHelpItems(program,sourceFile,position,cancellationToken)}function getSourceFile(fileName){return syntaxTreeCache.getCurrentSourceFile(fileName)}function getNameOrDottedNameSpan(fileName,startPos,endPos){var sourceFile=syntaxTreeCache.getCurrentSourceFile(fileName),node=ts.getTouchingPropertyName(sourceFile,startPos);if(node){switch(node.kind){case 169:case 136:case 9:case 163:case 84:case 99:case 93:case 95:case 97:case 162:case 69:break;default:return}for(var nodeForStartPos=node;;)if(isRightSideOfPropertyAccess(nodeForStartPos)||isRightSideOfQualifiedName(nodeForStartPos))nodeForStartPos=nodeForStartPos.parent;else{if(!isNameOfModuleDeclaration(nodeForStartPos))break;if(221!==nodeForStartPos.parent.parent.kind||nodeForStartPos.parent.parent.body!==nodeForStartPos.parent)break;nodeForStartPos=nodeForStartPos.parent.parent.name}return ts.createTextSpanFromBounds(nodeForStartPos.getStart(),node.getEnd())}}function getBreakpointStatementAtPosition(fileName,position){var sourceFile=syntaxTreeCache.getCurrentSourceFile(fileName);return ts.BreakpointResolver.spanInSourceFileAtLocation(sourceFile,position)}function getNavigationBarItems(fileName){var sourceFile=syntaxTreeCache.getCurrentSourceFile(fileName);return ts.NavigationBar.getNavigationBarItems(sourceFile,host.getCompilationSettings())}function getSemanticClassifications(fileName,span){return convertClassifications(getEncodedSemanticClassifications(fileName,span))}function checkForClassificationCancellation(kind){switch(kind){case 221:case 217:case 218:case 216:cancellationToken.throwIfCancellationRequested()}}function getEncodedSemanticClassifications(fileName,span){function pushClassification(start,length,type){result.push(start),result.push(length),result.push(type)}function classifySymbol(symbol,meaningAtPosition){function hasValueSideModule(symbol){return ts.forEach(symbol.declarations,function(declaration){return 221===declaration.kind&&1===ts.getModuleInstanceState(declaration)})}var flags=symbol.getFlags();if(0!==(788448&flags)){if(32&flags)return 11;if(384&flags)return 12;if(524288&flags)return 16;if(2&meaningAtPosition){if(64&flags)return 13;if(262144&flags)return 15}else if(1536&flags&&(4&meaningAtPosition||1&meaningAtPosition&&hasValueSideModule(symbol)))return 14}}function processNode(node){if(node&&ts.textSpanIntersectsWith(span,node.getFullStart(),node.getFullWidth())){var kind=node.kind;if(checkForClassificationCancellation(kind),69===kind&&!ts.nodeIsMissing(node)){var identifier=node;if(classifiableNames[identifier.text]){var symbol=typeChecker.getSymbolAtLocation(node);if(symbol){var type=classifySymbol(symbol,getMeaningFromLocation(node));type&&pushClassification(node.getStart(),node.getWidth(),type)}}}ts.forEachChild(node,processNode)}}synchronizeHostData();var sourceFile=getValidSourceFile(fileName),typeChecker=program.getTypeChecker(),result=[],classifiableNames=program.getClassifiableNames();return processNode(sourceFile),{spans:result,endOfLineState:0}}function getClassificationTypeName(type){switch(type){case 1:return ClassificationTypeNames.comment;case 2:return ClassificationTypeNames.identifier;case 3:return ClassificationTypeNames.keyword;case 4:return ClassificationTypeNames.numericLiteral;case 5:return ClassificationTypeNames.operator;case 6:return ClassificationTypeNames.stringLiteral;case 8:return ClassificationTypeNames.whiteSpace;case 9:return ClassificationTypeNames.text;case 10:return ClassificationTypeNames.punctuation;case 11:return ClassificationTypeNames.className;case 12:return ClassificationTypeNames.enumName;case 13:return ClassificationTypeNames.interfaceName;case 14:return ClassificationTypeNames.moduleName;case 15:return ClassificationTypeNames.typeParameterName;case 16:return ClassificationTypeNames.typeAliasName;case 17:return ClassificationTypeNames.parameterName;case 18:return ClassificationTypeNames.docCommentTagName;case 19:return ClassificationTypeNames.jsxOpenTagName;case 20:return ClassificationTypeNames.jsxCloseTagName;case 21:return ClassificationTypeNames.jsxSelfClosingTagName;
case 22:return ClassificationTypeNames.jsxAttribute;case 23:return ClassificationTypeNames.jsxText;case 24:return ClassificationTypeNames.jsxAttributeStringLiteralValue}}function convertClassifications(classifications){ts.Debug.assert(classifications.spans.length%3===0);for(var dense=classifications.spans,result=[],i=0,n=dense.length;i<n;i+=3)result.push({textSpan:ts.createTextSpan(dense[i],dense[i+1]),classificationType:getClassificationTypeName(dense[i+2])});return result}function getSyntacticClassifications(fileName,span){return convertClassifications(getEncodedSyntacticClassifications(fileName,span))}function getEncodedSyntacticClassifications(fileName,span){function pushClassification(start,length,type){result.push(start),result.push(length),result.push(type)}function classifyLeadingTriviaAndGetTokenStart(token){for(triviaScanner.setTextPos(token.pos);;){var start=triviaScanner.getTextPos();if(!ts.couldStartTrivia(sourceFile.text,start))return start;var kind=triviaScanner.scan(),end=triviaScanner.getTextPos(),width=end-start;if(!ts.isTrivia(kind))return start;if(4!==kind&&5!==kind)if(ts.isComment(kind))classifyComment(token,kind,start,width),triviaScanner.setTextPos(end);else if(7===kind){var text=sourceFile.text,ch=text.charCodeAt(start);if(60===ch||62===ch){pushClassification(start,width,1);continue}ts.Debug.assert(61===ch),classifyDisabledMergeCode(text,start,end)}}}function classifyComment(token,kind,start,width){if(3===kind){var docCommentAndDiagnostics=ts.parseIsolatedJSDocComment(sourceFile.text,start,width);if(docCommentAndDiagnostics&&docCommentAndDiagnostics.jsDocComment)return docCommentAndDiagnostics.jsDocComment.parent=token,void classifyJSDocComment(docCommentAndDiagnostics.jsDocComment)}pushCommentRange(start,width)}function pushCommentRange(start,width){pushClassification(start,width,1)}function classifyJSDocComment(docComment){function processJSDocParameterTag(tag){tag.preParameterName&&(pushCommentRange(pos,tag.preParameterName.pos-pos),pushClassification(tag.preParameterName.pos,tag.preParameterName.end-tag.preParameterName.pos,17),pos=tag.preParameterName.end),tag.typeExpression&&(pushCommentRange(pos,tag.typeExpression.pos-pos),processElement(tag.typeExpression),pos=tag.typeExpression.end),tag.postParameterName&&(pushCommentRange(pos,tag.postParameterName.pos-pos),pushClassification(tag.postParameterName.pos,tag.postParameterName.end-tag.postParameterName.pos,17),pos=tag.postParameterName.end)}for(var pos=docComment.pos,_i=0,_a=docComment.tags;_i<_a.length;_i++){var tag=_a[_i];switch(tag.pos!==pos&&pushCommentRange(pos,tag.pos-pos),pushClassification(tag.atToken.pos,tag.atToken.end-tag.atToken.pos,10),pushClassification(tag.tagName.pos,tag.tagName.end-tag.tagName.pos,18),pos=tag.tagName.end,tag.kind){case 270:processJSDocParameterTag(tag);break;case 273:processJSDocTemplateTag(tag);break;case 272:processElement(tag.typeExpression);break;case 271:processElement(tag.typeExpression)}pos=tag.end}pos!==docComment.end&&pushCommentRange(pos,docComment.end-pos)}function processJSDocTemplateTag(tag){for(var _i=0,_a=tag.getChildren();_i<_a.length;_i++){var child=_a[_i];processElement(child)}}function classifyDisabledMergeCode(text,start,end){var i;for(i=start;i<end&&!ts.isLineBreak(text.charCodeAt(i));i++);for(pushClassification(start,i-start,1),mergeConflictScanner.setTextPos(i);mergeConflictScanner.getTextPos()<end;)classifyDisabledCodeToken()}function classifyDisabledCodeToken(){var start=mergeConflictScanner.getTextPos(),tokenKind=mergeConflictScanner.scan(),end=mergeConflictScanner.getTextPos(),type=classifyTokenType(tokenKind);type&&pushClassification(start,end-start,type)}function tryClassifyNode(node){if(ts.nodeIsMissing(node))return!0;var classifiedElementName=tryClassifyJsxElementName(node);if(!ts.isToken(node)&&239!==node.kind&&void 0===classifiedElementName)return!1;var tokenStart=239===node.kind?node.pos:classifyLeadingTriviaAndGetTokenStart(node),tokenWidth=node.end-tokenStart;if(ts.Debug.assert(tokenWidth>=0),tokenWidth>0){var type=classifiedElementName||classifyTokenType(node.kind,node);type&&pushClassification(tokenStart,tokenWidth,type)}return!0}function tryClassifyJsxElementName(token){switch(token.parent&&token.parent.kind){case 238:if(token.parent.tagName===token)return 19;break;case 240:if(token.parent.tagName===token)return 20;break;case 237:if(token.parent.tagName===token)return 21;break;case 241:if(token.parent.name===token)return 22}}function classifyTokenType(tokenKind,token){if(ts.isKeyword(tokenKind))return 3;if((25===tokenKind||27===tokenKind)&&token&&ts.getTypeArgumentOrTypeParameterList(token.parent))return 10;if(ts.isPunctuation(tokenKind)){if(token){if(56===tokenKind&&(214===token.parent.kind||142===token.parent.kind||139===token.parent.kind||241===token.parent.kind))return 5;if(184===token.parent.kind||182===token.parent.kind||183===token.parent.kind||185===token.parent.kind)return 5}return 10}if(8===tokenKind)return 4;if(9===tokenKind||163===tokenKind)return 241===token.parent.kind?24:6;if(10===tokenKind)return 6;if(ts.isTemplateLiteralKind(tokenKind))return 6;if(239===tokenKind)return 23;if(69===tokenKind){if(token)switch(token.parent.kind){case 217:if(token.parent.name===token)return 11;return;case 138:if(token.parent.name===token)return 15;return;case 218:if(token.parent.name===token)return 13;return;case 220:if(token.parent.name===token)return 12;return;case 221:if(token.parent.name===token)return 14;return;case 139:if(token.parent.name===token)return 17;return}return 2}}function processElement(element){if(element&&ts.decodedTextSpanIntersectsWith(spanStart,spanLength,element.pos,element.getFullWidth())){checkForClassificationCancellation(element.kind);for(var children=element.getChildren(sourceFile),i=0,n=children.length;i<n;i++){var child=children[i];tryClassifyNode(child)||processElement(child)}}}var sourceFile=syntaxTreeCache.getCurrentSourceFile(fileName),spanStart=span.start,spanLength=span.length,triviaScanner=ts.createScanner(2,!1,sourceFile.languageVariant,sourceFile.text),mergeConflictScanner=ts.createScanner(2,!1,sourceFile.languageVariant,sourceFile.text),result=[];return processElement(sourceFile),{spans:result,endOfLineState:0}}function getOutliningSpans(fileName){var sourceFile=syntaxTreeCache.getCurrentSourceFile(fileName);return ts.OutliningElementsCollector.collectElements(sourceFile)}function getBraceMatchingAtPosition(fileName,position){function getMatchingTokenKind(token){switch(token.kind){case 15:return 16;case 17:return 18;case 19:return 20;case 25:return 27;case 16:return 15;case 18:return 17;case 20:return 19;case 27:return 25}}var sourceFile=syntaxTreeCache.getCurrentSourceFile(fileName),result=[],token=ts.getTouchingToken(sourceFile,position);if(token.getStart(sourceFile)===position){var matchKind=getMatchingTokenKind(token);if(matchKind)for(var parentElement=token.parent,childNodes=parentElement.getChildren(sourceFile),_i=0,childNodes_1=childNodes;_i<childNodes_1.length;_i++){var current=childNodes_1[_i];if(current.kind===matchKind){var range1=ts.createTextSpan(token.getStart(sourceFile),token.getWidth(sourceFile)),range2=ts.createTextSpan(current.getStart(sourceFile),current.getWidth(sourceFile));range1.start<range2.start?result.push(range1,range2):result.push(range2,range1);break}}}return result}function getIndentationAtPosition(fileName,position,editorOptions){var start=(new Date).getTime(),sourceFile=syntaxTreeCache.getCurrentSourceFile(fileName);log("getIndentationAtPosition: getCurrentSourceFile: "+((new Date).getTime()-start)),start=(new Date).getTime();var result=ts.formatting.SmartIndenter.getIndentation(position,sourceFile,editorOptions);return log("getIndentationAtPosition: computeIndentation  : "+((new Date).getTime()-start)),result}function getFormattingEditsForRange(fileName,start,end,options){var sourceFile=syntaxTreeCache.getCurrentSourceFile(fileName);return ts.formatting.formatSelection(start,end,sourceFile,getRuleProvider(options),options)}function getFormattingEditsForDocument(fileName,options){var sourceFile=syntaxTreeCache.getCurrentSourceFile(fileName);return ts.formatting.formatDocument(sourceFile,getRuleProvider(options),options)}function getFormattingEditsAfterKeystroke(fileName,position,key,options){var sourceFile=syntaxTreeCache.getCurrentSourceFile(fileName);return"}"===key?ts.formatting.formatOnClosingCurly(position,sourceFile,getRuleProvider(options),options):";"===key?ts.formatting.formatOnSemicolon(position,sourceFile,getRuleProvider(options),options):"\n"===key?ts.formatting.formatOnEnter(position,sourceFile,getRuleProvider(options),options):[]}function getDocCommentTemplateAtPosition(fileName,position){var sourceFile=syntaxTreeCache.getCurrentSourceFile(fileName);if(!(ts.isInString(sourceFile,position)||ts.isInComment(sourceFile,position)||ts.hasDocComment(sourceFile,position))){var tokenAtPos=ts.getTokenAtPosition(sourceFile,position),tokenStart=tokenAtPos.getStart();if(tokenAtPos&&!(tokenStart<position)){var commentOwner;findOwner:for(commentOwner=tokenAtPos;commentOwner;commentOwner=commentOwner.parent)switch(commentOwner.kind){case 216:case 144:case 145:case 217:case 196:break findOwner;case 251:return;case 221:if(221===commentOwner.parent.kind)return;break findOwner}if(commentOwner&&!(commentOwner.getStart()<position)){for(var parameters=getParametersForJsDocOwningNode(commentOwner),posLineAndChar=sourceFile.getLineAndCharacterOfPosition(position),lineStart=sourceFile.getLineStarts()[posLineAndChar.line],indentationStr=sourceFile.text.substr(lineStart,posLineAndChar.character),newLine=ts.getNewLineOrDefaultFromHost(host),docParams="",i=0,numParams=parameters.length;i<numParams;i++){var currentName=parameters[i].name,paramName=69===currentName.kind?currentName.text:"param"+i;docParams+=indentationStr+" * @param "+paramName+newLine}var preamble="/**"+newLine+indentationStr+" * ",result=preamble+newLine+docParams+indentationStr+" */"+(tokenStart===position?newLine+indentationStr:"");return{newText:result,caretOffset:preamble.length}}}}}function getParametersForJsDocOwningNode(commentOwner){if(ts.isFunctionLike(commentOwner))return commentOwner.parameters;if(196===commentOwner.kind){var varStatement=commentOwner,varDeclarations=varStatement.declarationList.declarations;if(1===varDeclarations.length&&varDeclarations[0].initializer)return getParametersFromRightHandSideOfAssignment(varDeclarations[0].initializer)}return emptyArray}function getParametersFromRightHandSideOfAssignment(rightHandSide){for(;175===rightHandSide.kind;)rightHandSide=rightHandSide.expression;switch(rightHandSide.kind){case 176:case 177:return rightHandSide.parameters;case 189:for(var _i=0,_a=rightHandSide.members;_i<_a.length;_i++){var member=_a[_i];if(145===member.kind)return member.parameters}}return emptyArray}function getTodoComments(fileName,descriptors){function escapeRegExp(str){return str.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g,"\\$&")}function getTodoCommentsRegExp(){var singleLineCommentStart=/(?:\/\/+\s*)/.source,multiLineCommentStart=/(?:\/\*+\s*)/.source,anyNumberOfSpacesAndAsterixesAtStartOfLine=/(?:^(?:\s|\*)*)/.source,preamble="("+anyNumberOfSpacesAndAsterixesAtStartOfLine+"|"+singleLineCommentStart+"|"+multiLineCommentStart+")",literals="(?:"+ts.map(descriptors,function(d){return"("+escapeRegExp(d.text)+")"}).join("|")+")",endOfLineOrEndOfComment=/(?:$|\*\/)/.source,messageRemainder=/(?:.*?)/.source,messagePortion="("+literals+messageRemainder+")",regExpString=preamble+messagePortion+endOfLineOrEndOfComment;return new RegExp(regExpString,"gim")}function isLetterOrDigit(char){return char>=97&&char<=122||char>=65&&char<=90||char>=48&&char<=57}synchronizeHostData();var sourceFile=getValidSourceFile(fileName);cancellationToken.throwIfCancellationRequested();var fileContents=sourceFile.text,result=[];if(descriptors.length>0)for(var regExp=getTodoCommentsRegExp(),matchArray=void 0;matchArray=regExp.exec(fileContents);){cancellationToken.throwIfCancellationRequested();var firstDescriptorCaptureIndex=3;ts.Debug.assert(matchArray.length===descriptors.length+firstDescriptorCaptureIndex);var preamble=matchArray[1],matchPosition=matchArray.index+preamble.length,token=ts.getTokenAtPosition(sourceFile,matchPosition);if(isInsideComment(sourceFile,token,matchPosition)){for(var descriptor=void 0,i=0,n=descriptors.length;i<n;i++)matchArray[i+firstDescriptorCaptureIndex]&&(descriptor=descriptors[i]);if(ts.Debug.assert(void 0!==descriptor),!isLetterOrDigit(fileContents.charCodeAt(matchPosition+descriptor.text.length))){var message=matchArray[2];result.push({descriptor:descriptor,message:message,position:matchPosition})}}}return result}function getRenameInfo(fileName,position){function getRenameInfoError(localizedErrorMessage){return{canRename:!1,localizedErrorMessage:localizedErrorMessage,displayName:void 0,fullDisplayName:void 0,kind:void 0,kindModifiers:void 0,triggerSpan:void 0}}synchronizeHostData();var sourceFile=getValidSourceFile(fileName),typeChecker=program.getTypeChecker(),node=ts.getTouchingWord(sourceFile,position);if(node&&69===node.kind){var symbol=typeChecker.getSymbolAtLocation(node);if(symbol){var declarations=symbol.getDeclarations();if(declarations&&declarations.length>0){var defaultLibFileName=host.getDefaultLibFileName(host.getCompilationSettings()),canonicalDefaultLibName=getCanonicalFileName(ts.normalizePath(defaultLibFileName));if(defaultLibFileName)for(var _i=0,declarations_10=declarations;_i<declarations_10.length;_i++){var current=declarations_10[_i],sourceFile_3=current.getSourceFile();if(sourceFile_3){var canonicalName=getCanonicalFileName(ts.normalizePath(sourceFile_3.fileName));if(canonicalName===canonicalDefaultLibName)return getRenameInfoError(ts.getLocaleSpecificMessage(ts.Diagnostics.You_cannot_rename_elements_that_are_defined_in_the_standard_TypeScript_library))}}var displayName=ts.stripQuotes(ts.getDeclaredName(typeChecker,symbol,node)),kind=getSymbolKind(symbol,node);if(kind)return{canRename:!0,kind:kind,displayName:displayName,localizedErrorMessage:void 0,fullDisplayName:typeChecker.getFullyQualifiedName(symbol),kindModifiers:getSymbolModifiers(symbol),triggerSpan:ts.createTextSpan(node.getStart(),node.getWidth())}}}}return getRenameInfoError(ts.getLocaleSpecificMessage(ts.Diagnostics.You_cannot_rename_this_element))}void 0===documentRegistry&&(documentRegistry=createDocumentRegistry(host.useCaseSensitiveFileNames&&host.useCaseSensitiveFileNames(),host.getCurrentDirectory()));var ruleProvider,program,lastProjectVersion,syntaxTreeCache=new SyntaxTreeCache(host),useCaseSensitivefileNames=!1,cancellationToken=new CancellationTokenObject(host.getCancellationToken&&host.getCancellationToken()),currentDirectory=host.getCurrentDirectory();!ts.localizedDiagnosticMessages&&host.getLocalizedDiagnosticMessages&&(ts.localizedDiagnosticMessages=host.getLocalizedDiagnosticMessages());var getCanonicalFileName=ts.createGetCanonicalFileName(useCaseSensitivefileNames);return{dispose:dispose,cleanupSemanticCache:cleanupSemanticCache,getSyntacticDiagnostics:getSyntacticDiagnostics,getSemanticDiagnostics:getSemanticDiagnostics,getCompilerOptionsDiagnostics:getCompilerOptionsDiagnostics,getSyntacticClassifications:getSyntacticClassifications,getSemanticClassifications:getSemanticClassifications,getEncodedSyntacticClassifications:getEncodedSyntacticClassifications,getEncodedSemanticClassifications:getEncodedSemanticClassifications,getCompletionsAtPosition:getCompletionsAtPosition,getCompletionEntryDetails:getCompletionEntryDetails,getSignatureHelpItems:getSignatureHelpItems,getQuickInfoAtPosition:getQuickInfoAtPosition,getDefinitionAtPosition:getDefinitionAtPosition,getTypeDefinitionAtPosition:getTypeDefinitionAtPosition,getReferencesAtPosition:getReferencesAtPosition,findReferences:findReferences,getOccurrencesAtPosition:getOccurrencesAtPosition,getDocumentHighlights:getDocumentHighlights,getNameOrDottedNameSpan:getNameOrDottedNameSpan,getBreakpointStatementAtPosition:getBreakpointStatementAtPosition,getNavigateToItems:getNavigateToItems,getRenameInfo:getRenameInfo,findRenameLocations:findRenameLocations,getNavigationBarItems:getNavigationBarItems,getOutliningSpans:getOutliningSpans,getTodoComments:getTodoComments,getBraceMatchingAtPosition:getBraceMatchingAtPosition,getIndentationAtPosition:getIndentationAtPosition,getFormattingEditsForRange:getFormattingEditsForRange,getFormattingEditsForDocument:getFormattingEditsForDocument,getFormattingEditsAfterKeystroke:getFormattingEditsAfterKeystroke,getDocCommentTemplateAtPosition:getDocCommentTemplateAtPosition,getEmitOutput:getEmitOutput,getSourceFile:getSourceFile,getProgram:getProgram}}function getNameTable(sourceFile){return sourceFile.nameTable||initializeNameTable(sourceFile),sourceFile.nameTable}function initializeNameTable(sourceFile){function walk(node){switch(node.kind){case 69:nameTable[node.text]=void 0===nameTable[node.text]?node.pos:-1;break;case 9:case 8:(ts.isDeclarationName(node)||235===node.parent.kind||isArgumentOfElementAccessExpression(node))&&(nameTable[node.text]=void 0===nameTable[node.text]?node.pos:-1);break;default:ts.forEachChild(node,walk)}}var nameTable={};walk(sourceFile),sourceFile.nameTable=nameTable}function isArgumentOfElementAccessExpression(node){return node&&node.parent&&170===node.parent.kind&&node.parent.argumentExpression===node}function createClassifier(){function canFollow(keyword1,keyword2){return!ts.isAccessibilityModifier(keyword1)||(123===keyword2||129===keyword2||121===keyword2||113===keyword2)}function convertClassifications(classifications,text){for(var entries=[],dense=classifications.spans,lastEnd=0,i=0,n=dense.length;i<n;i+=3){var start=dense[i],length_3=dense[i+1],type=dense[i+2];if(lastEnd>=0){var whitespaceLength_1=start-lastEnd;whitespaceLength_1>0&&entries.push({length:whitespaceLength_1,classification:TokenClass.Whitespace})}entries.push({length:length_3,classification:convertClassification(type)}),lastEnd=start+length_3}var whitespaceLength=text.length-lastEnd;return whitespaceLength>0&&entries.push({length:whitespaceLength,classification:TokenClass.Whitespace}),{entries:entries,finalLexState:classifications.endOfLineState}}function convertClassification(type){switch(type){case 1:return TokenClass.Comment;case 3:return TokenClass.Keyword;case 4:return TokenClass.NumberLiteral;case 5:return TokenClass.Operator;case 6:return TokenClass.StringLiteral;case 8:return TokenClass.Whitespace;case 10:return TokenClass.Punctuation;case 2:case 11:case 12:case 13:case 14:case 15:case 16:case 9:case 17:default:return TokenClass.Identifier}}function getClassificationsForLine(text,lexState,syntacticClassifierAbsent){return convertClassifications(getEncodedLexicalClassifications(text,lexState,syntacticClassifierAbsent),text)}function getEncodedLexicalClassifications(text,lexState,syntacticClassifierAbsent){function processToken(){var start=scanner.getTokenPos(),end=scanner.getTextPos();if(addResult(start,end,classFromKind(token)),end>=text.length)if(9===token||163===token){var tokenText=scanner.getTokenText();if(scanner.isUnterminated()){for(var lastCharIndex=tokenText.length-1,numBackslashes=0;92===tokenText.charCodeAt(lastCharIndex-numBackslashes);)numBackslashes++;if(1&numBackslashes){var quoteChar=tokenText.charCodeAt(0);result.endOfLineState=34===quoteChar?3:2}}}else 3===token?scanner.isUnterminated()&&(result.endOfLineState=1):ts.isTemplateLiteralKind(token)?scanner.isUnterminated()&&(14===token?result.endOfLineState=5:11===token?result.endOfLineState=4:ts.Debug.fail("Only 'NoSubstitutionTemplateLiteral's and 'TemplateTail's can be unterminated; got SyntaxKind #"+token)):templateStack.length>0&&12===ts.lastOrUndefined(templateStack)&&(result.endOfLineState=6)}function addResult(start,end,classification){if(8!==classification){0===start&&offset>0&&(start+=offset),start-=offset,end-=offset;var length=end-start;length>0&&(result.spans.push(start),result.spans.push(length),result.spans.push(classification))}}for(var offset=0,token=0,lastNonTriviaToken=0;templateStack.length>0;)templateStack.pop();switch(lexState){case 3:text='"\\\n'+text,offset=3;break;case 2:text="'\\\n"+text,offset=3;break;case 1:text="/*\n"+text,offset=3;break;case 4:text="`\n"+text,offset=2;break;case 5:text="}\n"+text,offset=2;case 6:templateStack.push(12)}scanner.setText(text);var result={endOfLineState:0,spans:[]},angleBracketStack=0;do{if(token=scanner.scan(),!ts.isTrivia(token)){if(39!==token&&61!==token||noRegexTable[lastNonTriviaToken]){if(21===lastNonTriviaToken&&isKeyword(token))token=69;else if(isKeyword(lastNonTriviaToken)&&isKeyword(token)&&!canFollow(lastNonTriviaToken,token))token=69;else if(69===lastNonTriviaToken&&25===token)angleBracketStack++;else if(27===token&&angleBracketStack>0)angleBracketStack--;else if(117===token||130===token||128===token||120===token||131===token)angleBracketStack>0&&!syntacticClassifierAbsent&&(token=69);else if(12===token)templateStack.push(token);else if(15===token)templateStack.length>0&&templateStack.push(token);else if(16===token&&templateStack.length>0){var lastTemplateStackToken=ts.lastOrUndefined(templateStack);12===lastTemplateStackToken?(token=scanner.reScanTemplateToken(),14===token?templateStack.pop():ts.Debug.assert(13===token,"Should have been a template middle. Was "+token)):(ts.Debug.assert(15===lastTemplateStackToken,"Should have been an open brace. Was: "+token),templateStack.pop())}}else 10===scanner.reScanSlashToken()&&(token=10);lastNonTriviaToken=token}processToken()}while(1!==token);return result}function isBinaryExpressionOperatorToken(token){switch(token){case 37:case 39:case 40:case 35:case 36:case 43:case 44:case 45:case 25:case 27:case 28:case 29:case 91:case 90:case 116:case 30:case 31:case 32:case 33:case 46:case 48:case 47:case 51:case 52:case 67:case 66:case 68:case 63:case 64:case 65:case 57:case 58:case 59:case 61:case 62:case 56:case 24:return!0;default:return!1}}function isPrefixUnaryExpressionOperatorToken(token){switch(token){case 35:case 36:case 50:case 49:case 41:case 42:return!0;default:return!1}}function isKeyword(token){return token>=70&&token<=135}function classFromKind(token){if(isKeyword(token))return 3;if(isBinaryExpressionOperatorToken(token)||isPrefixUnaryExpressionOperatorToken(token))return 5;if(token>=15&&token<=68)return 10;switch(token){case 8:return 4;case 9:case 163:return 6;case 10:return 7;case 7:case 3:case 2:return 1;case 5:case 4:return 8;case 69:default:return ts.isTemplateLiteralKind(token)?6:2}}var scanner=ts.createScanner(2,!1),noRegexTable=[];noRegexTable[69]=!0,noRegexTable[9]=!0,noRegexTable[8]=!0,noRegexTable[10]=!0,noRegexTable[97]=!0,noRegexTable[41]=!0,noRegexTable[42]=!0,noRegexTable[18]=!0,noRegexTable[20]=!0,noRegexTable[16]=!0,noRegexTable[99]=!0,noRegexTable[84]=!0;var templateStack=[];return{getClassificationsForLine:getClassificationsForLine,getEncodedLexicalClassifications:getEncodedLexicalClassifications}}function getDefaultLibFilePath(options){return __dirname+ts.directorySeparator+ts.getDefaultLibFileName(options)}function initializeServices(){ts.objectAllocator={getNodeConstructor:function(){return NodeObject},getSourceFileConstructor:function(){return SourceFileObject},getSymbolConstructor:function(){return SymbolObject},getTypeConstructor:function(){return TypeObject},getSignatureConstructor:function(){return SignatureObject}}}ts.servicesVersion="0.4";var ScriptSnapshot;!function(ScriptSnapshot){function fromString(text){return new StringScriptSnapshot(text)}var StringScriptSnapshot=function(){function StringScriptSnapshot(text){this.text=text}return StringScriptSnapshot.prototype.getText=function(start,end){return this.text.substring(start,end)},StringScriptSnapshot.prototype.getLength=function(){return this.text.length},StringScriptSnapshot.prototype.getChangeRange=function(oldSnapshot){},StringScriptSnapshot}();ScriptSnapshot.fromString=fromString}(ScriptSnapshot=ts.ScriptSnapshot||(ts.ScriptSnapshot={}));var jsDocCompletionEntries,scanner=ts.createScanner(2,!0),emptyArray=[],jsDocTagNames=["augments","author","argument","borrows","class","constant","constructor","constructs","default","deprecated","description","event","example","extends","field","fileOverview","function","ignore","inner","lends","link","memberOf","name","namespace","param","private","property","public","requires","returns","see","since","static","throws","type","version"],NodeObject=function(){function NodeObject(kind,pos,end){this.kind=kind,this.pos=pos,this.end=end,this.flags=0,this.parent=void 0}return NodeObject.prototype.getSourceFile=function(){return ts.getSourceFileOfNode(this)},NodeObject.prototype.getStart=function(sourceFile){return ts.getTokenPosOfNode(this,sourceFile)},NodeObject.prototype.getFullStart=function(){return this.pos},NodeObject.prototype.getEnd=function(){return this.end},NodeObject.prototype.getWidth=function(sourceFile){return this.getEnd()-this.getStart(sourceFile)},NodeObject.prototype.getFullWidth=function(){return this.end-this.pos},NodeObject.prototype.getLeadingTriviaWidth=function(sourceFile){return this.getStart(sourceFile)-this.pos},NodeObject.prototype.getFullText=function(sourceFile){return(sourceFile||this.getSourceFile()).text.substring(this.pos,this.end)},NodeObject.prototype.getText=function(sourceFile){return(sourceFile||this.getSourceFile()).text.substring(this.getStart(),this.getEnd())},NodeObject.prototype.addSyntheticNodes=function(nodes,pos,end){for(scanner.setTextPos(pos);pos<end;){var token=scanner.scan(),textPos=scanner.getTextPos();nodes.push(createNode(token,pos,textPos,2048,this)),pos=textPos}return pos},NodeObject.prototype.createSyntaxList=function(nodes){var list=createNode(274,nodes.pos,nodes.end,2048,this);list._children=[];for(var pos=nodes.pos,_i=0,nodes_7=nodes;_i<nodes_7.length;_i++){var node=nodes_7[_i];pos<node.pos&&(pos=this.addSyntheticNodes(list._children,pos,node.pos)),list._children.push(node),pos=node.end}return pos<nodes.end&&this.addSyntheticNodes(list._children,pos,nodes.end),list},NodeObject.prototype.createChildren=function(sourceFile){var children,_this=this;if(this.kind>=136){scanner.setText((sourceFile||this.getSourceFile()).text),children=[];var pos_3=this.pos,processNode=function(node){pos_3<node.pos&&(pos_3=_this.addSyntheticNodes(children,pos_3,node.pos)),children.push(node),pos_3=node.end},processNodes=function(nodes){pos_3<nodes.pos&&(pos_3=_this.addSyntheticNodes(children,pos_3,nodes.pos)),children.push(_this.createSyntaxList(nodes)),pos_3=nodes.end};ts.forEachChild(this,processNode,processNodes),pos_3<this.end&&this.addSyntheticNodes(children,pos_3,this.end),scanner.setText(void 0)}this._children=children||emptyArray},NodeObject.prototype.getChildCount=function(sourceFile){return this._children||this.createChildren(sourceFile),this._children.length},NodeObject.prototype.getChildAt=function(index,sourceFile){return this._children||this.createChildren(sourceFile),this._children[index]},NodeObject.prototype.getChildren=function(sourceFile){return this._children||this.createChildren(sourceFile),this._children},NodeObject.prototype.getFirstToken=function(sourceFile){var children=this.getChildren(sourceFile);if(children.length){var child=children[0];return child.kind<136?child:child.getFirstToken(sourceFile)}},NodeObject.prototype.getLastToken=function(sourceFile){var children=this.getChildren(sourceFile),child=ts.lastOrUndefined(children);if(child)return child.kind<136?child:child.getLastToken(sourceFile)},NodeObject}(),SymbolObject=function(){function SymbolObject(flags,name){this.flags=flags,this.name=name}return SymbolObject.prototype.getFlags=function(){return this.flags},SymbolObject.prototype.getName=function(){return this.name},SymbolObject.prototype.getDeclarations=function(){return this.declarations},SymbolObject.prototype.getDocumentationComment=function(){return void 0===this.documentationComment&&(this.documentationComment=getJsDocCommentsFromDeclarations(this.declarations,this.name,!(4&this.flags))),this.documentationComment},SymbolObject}(),TypeObject=function(){function TypeObject(checker,flags){this.checker=checker,this.flags=flags}return TypeObject.prototype.getFlags=function(){return this.flags},TypeObject.prototype.getSymbol=function(){return this.symbol},TypeObject.prototype.getProperties=function(){return this.checker.getPropertiesOfType(this)},TypeObject.prototype.getProperty=function(propertyName){return this.checker.getPropertyOfType(this,propertyName)},TypeObject.prototype.getApparentProperties=function(){return this.checker.getAugmentedPropertiesOfType(this)},TypeObject.prototype.getCallSignatures=function(){return this.checker.getSignaturesOfType(this,0)},TypeObject.prototype.getConstructSignatures=function(){return this.checker.getSignaturesOfType(this,1)},TypeObject.prototype.getStringIndexType=function(){return this.checker.getIndexTypeOfType(this,0)},TypeObject.prototype.getNumberIndexType=function(){return this.checker.getIndexTypeOfType(this,1)},TypeObject.prototype.getBaseTypes=function(){return 3072&this.flags?this.checker.getBaseTypes(this):void 0},TypeObject}(),SignatureObject=function(){function SignatureObject(checker){this.checker=checker}return SignatureObject.prototype.getDeclaration=function(){return this.declaration},SignatureObject.prototype.getTypeParameters=function(){return this.typeParameters},SignatureObject.prototype.getParameters=function(){return this.parameters},SignatureObject.prototype.getReturnType=function(){return this.checker.getReturnTypeOfSignature(this)},SignatureObject.prototype.getDocumentationComment=function(){return void 0===this.documentationComment&&(this.documentationComment=this.declaration?getJsDocCommentsFromDeclarations([this.declaration],void 0,!1):[]),this.documentationComment},SignatureObject}(),SourceFileObject=function(_super){function SourceFileObject(kind,pos,end){_super.call(this,kind,pos,end)}return __extends(SourceFileObject,_super),SourceFileObject.prototype.update=function(newText,textChangeRange){return ts.updateSourceFile(this,newText,textChangeRange)},SourceFileObject.prototype.getLineAndCharacterOfPosition=function(position){return ts.getLineAndCharacterOfPosition(this,position)},SourceFileObject.prototype.getLineStarts=function(){return ts.getLineStarts(this)},SourceFileObject.prototype.getPositionOfLineAndCharacter=function(line,character){return ts.getPositionOfLineAndCharacter(this,line,character)},SourceFileObject.prototype.getNamedDeclarations=function(){return this.namedDeclarations||(this.namedDeclarations=this.computeNamedDeclarations()),this.namedDeclarations},SourceFileObject.prototype.computeNamedDeclarations=function(){function addDeclaration(declaration){var name=getDeclarationName(declaration);if(name){var declarations=getDeclarations(name);declarations.push(declaration)}}function getDeclarations(name){return ts.getProperty(result,name)||(result[name]=[])}function getDeclarationName(declaration){if(declaration.name){var result_3=getTextOfIdentifierOrLiteral(declaration.name);if(void 0!==result_3)return result_3;if(137===declaration.name.kind){var expr=declaration.name.expression;return 169===expr.kind?expr.name.text:getTextOfIdentifierOrLiteral(expr)}}}function getTextOfIdentifierOrLiteral(node){if(node&&(69===node.kind||9===node.kind||8===node.kind))return node.text}function visit(node){switch(node.kind){case 216:case 144:case 143:var functionDeclaration=node,declarationName=getDeclarationName(functionDeclaration);if(declarationName){var declarations=getDeclarations(declarationName),lastDeclaration=ts.lastOrUndefined(declarations);lastDeclaration&&functionDeclaration.parent===lastDeclaration.parent&&functionDeclaration.symbol===lastDeclaration.symbol?functionDeclaration.body&&!lastDeclaration.body&&(declarations[declarations.length-1]=functionDeclaration):declarations.push(functionDeclaration),ts.forEachChild(node,visit)}break;case 217:case 218:case 219:case 220:case 221:case 224:case 233:case 229:case 224:case 226:case 227:
case 146:case 147:case 156:addDeclaration(node);case 145:case 196:case 215:case 164:case 165:case 222:ts.forEachChild(node,visit);break;case 195:ts.isFunctionBlock(node)&&ts.forEachChild(node,visit);break;case 139:if(!(56&node.flags))break;case 214:case 166:if(ts.isBindingPattern(node.name)){ts.forEachChild(node.name,visit);break}case 250:case 142:case 141:addDeclaration(node);break;case 231:node.exportClause&&ts.forEach(node.exportClause.elements,visit);break;case 225:var importClause=node.importClause;importClause&&(importClause.name&&addDeclaration(importClause),importClause.namedBindings&&(227===importClause.namedBindings.kind?addDeclaration(importClause.namedBindings):ts.forEach(importClause.namedBindings.elements,visit)))}}var result={};return ts.forEachChild(this,visit),result},SourceFileObject}(NodeObject),TextChange=function(){function TextChange(){}return TextChange}();ts.TextChange=TextChange;var HighlightSpanKind;!function(HighlightSpanKind){HighlightSpanKind.none="none",HighlightSpanKind.definition="definition",HighlightSpanKind.reference="reference",HighlightSpanKind.writtenReference="writtenReference"}(HighlightSpanKind=ts.HighlightSpanKind||(ts.HighlightSpanKind={})),function(IndentStyle){IndentStyle[IndentStyle.None=0]="None",IndentStyle[IndentStyle.Block=1]="Block",IndentStyle[IndentStyle.Smart=2]="Smart"}(ts.IndentStyle||(ts.IndentStyle={}));ts.IndentStyle;!function(SymbolDisplayPartKind){SymbolDisplayPartKind[SymbolDisplayPartKind.aliasName=0]="aliasName",SymbolDisplayPartKind[SymbolDisplayPartKind.className=1]="className",SymbolDisplayPartKind[SymbolDisplayPartKind.enumName=2]="enumName",SymbolDisplayPartKind[SymbolDisplayPartKind.fieldName=3]="fieldName",SymbolDisplayPartKind[SymbolDisplayPartKind.interfaceName=4]="interfaceName",SymbolDisplayPartKind[SymbolDisplayPartKind.keyword=5]="keyword",SymbolDisplayPartKind[SymbolDisplayPartKind.lineBreak=6]="lineBreak",SymbolDisplayPartKind[SymbolDisplayPartKind.numericLiteral=7]="numericLiteral",SymbolDisplayPartKind[SymbolDisplayPartKind.stringLiteral=8]="stringLiteral",SymbolDisplayPartKind[SymbolDisplayPartKind.localName=9]="localName",SymbolDisplayPartKind[SymbolDisplayPartKind.methodName=10]="methodName",SymbolDisplayPartKind[SymbolDisplayPartKind.moduleName=11]="moduleName",SymbolDisplayPartKind[SymbolDisplayPartKind.operator=12]="operator",SymbolDisplayPartKind[SymbolDisplayPartKind.parameterName=13]="parameterName",SymbolDisplayPartKind[SymbolDisplayPartKind.propertyName=14]="propertyName",SymbolDisplayPartKind[SymbolDisplayPartKind.punctuation=15]="punctuation",SymbolDisplayPartKind[SymbolDisplayPartKind.space=16]="space",SymbolDisplayPartKind[SymbolDisplayPartKind.text=17]="text",SymbolDisplayPartKind[SymbolDisplayPartKind.typeParameterName=18]="typeParameterName",SymbolDisplayPartKind[SymbolDisplayPartKind.enumMemberName=19]="enumMemberName",SymbolDisplayPartKind[SymbolDisplayPartKind.functionName=20]="functionName",SymbolDisplayPartKind[SymbolDisplayPartKind.regularExpressionLiteral=21]="regularExpressionLiteral"}(ts.SymbolDisplayPartKind||(ts.SymbolDisplayPartKind={}));var SymbolDisplayPartKind=ts.SymbolDisplayPartKind;!function(OutputFileType){OutputFileType[OutputFileType.JavaScript=0]="JavaScript",OutputFileType[OutputFileType.SourceMap=1]="SourceMap",OutputFileType[OutputFileType.Declaration=2]="Declaration"}(ts.OutputFileType||(ts.OutputFileType={}));ts.OutputFileType;!function(EndOfLineState){EndOfLineState[EndOfLineState.None=0]="None",EndOfLineState[EndOfLineState.InMultiLineCommentTrivia=1]="InMultiLineCommentTrivia",EndOfLineState[EndOfLineState.InSingleQuoteStringLiteral=2]="InSingleQuoteStringLiteral",EndOfLineState[EndOfLineState.InDoubleQuoteStringLiteral=3]="InDoubleQuoteStringLiteral",EndOfLineState[EndOfLineState.InTemplateHeadOrNoSubstitutionTemplate=4]="InTemplateHeadOrNoSubstitutionTemplate",EndOfLineState[EndOfLineState.InTemplateMiddleOrTail=5]="InTemplateMiddleOrTail",EndOfLineState[EndOfLineState.InTemplateSubstitutionPosition=6]="InTemplateSubstitutionPosition"}(ts.EndOfLineState||(ts.EndOfLineState={}));ts.EndOfLineState;!function(TokenClass){TokenClass[TokenClass.Punctuation=0]="Punctuation",TokenClass[TokenClass.Keyword=1]="Keyword",TokenClass[TokenClass.Operator=2]="Operator",TokenClass[TokenClass.Comment=3]="Comment",TokenClass[TokenClass.Whitespace=4]="Whitespace",TokenClass[TokenClass.Identifier=5]="Identifier",TokenClass[TokenClass.NumberLiteral=6]="NumberLiteral",TokenClass[TokenClass.StringLiteral=7]="StringLiteral",TokenClass[TokenClass.RegExpLiteral=8]="RegExpLiteral"}(ts.TokenClass||(ts.TokenClass={}));var ScriptElementKind,TokenClass=ts.TokenClass;!function(ScriptElementKind){ScriptElementKind.unknown="",ScriptElementKind.warning="warning",ScriptElementKind.keyword="keyword",ScriptElementKind.scriptElement="script",ScriptElementKind.moduleElement="module",ScriptElementKind.classElement="class",ScriptElementKind.localClassElement="local class",ScriptElementKind.interfaceElement="interface",ScriptElementKind.typeElement="type",ScriptElementKind.enumElement="enum",ScriptElementKind.variableElement="var",ScriptElementKind.localVariableElement="local var",ScriptElementKind.functionElement="function",ScriptElementKind.localFunctionElement="local function",ScriptElementKind.memberFunctionElement="method",ScriptElementKind.memberGetAccessorElement="getter",ScriptElementKind.memberSetAccessorElement="setter",ScriptElementKind.memberVariableElement="property",ScriptElementKind.constructorImplementationElement="constructor",ScriptElementKind.callSignatureElement="call",ScriptElementKind.indexSignatureElement="index",ScriptElementKind.constructSignatureElement="construct",ScriptElementKind.parameterElement="parameter",ScriptElementKind.typeParameterElement="type parameter",ScriptElementKind.primitiveType="primitive type",ScriptElementKind.label="label",ScriptElementKind.alias="alias",ScriptElementKind.constElement="const",ScriptElementKind.letElement="let"}(ScriptElementKind=ts.ScriptElementKind||(ts.ScriptElementKind={}));var ScriptElementKindModifier;!function(ScriptElementKindModifier){ScriptElementKindModifier.none="",ScriptElementKindModifier.publicMemberModifier="public",ScriptElementKindModifier.privateMemberModifier="private",ScriptElementKindModifier.protectedMemberModifier="protected",ScriptElementKindModifier.exportedModifier="export",ScriptElementKindModifier.ambientModifier="declare",ScriptElementKindModifier.staticModifier="static",ScriptElementKindModifier.abstractModifier="abstract"}(ScriptElementKindModifier=ts.ScriptElementKindModifier||(ts.ScriptElementKindModifier={}));var ClassificationTypeNames=function(){function ClassificationTypeNames(){}return ClassificationTypeNames.comment="comment",ClassificationTypeNames.identifier="identifier",ClassificationTypeNames.keyword="keyword",ClassificationTypeNames.numericLiteral="number",ClassificationTypeNames.operator="operator",ClassificationTypeNames.stringLiteral="string",ClassificationTypeNames.whiteSpace="whitespace",ClassificationTypeNames.text="text",ClassificationTypeNames.punctuation="punctuation",ClassificationTypeNames.className="class name",ClassificationTypeNames.enumName="enum name",ClassificationTypeNames.interfaceName="interface name",ClassificationTypeNames.moduleName="module name",ClassificationTypeNames.typeParameterName="type parameter name",ClassificationTypeNames.typeAliasName="type alias name",ClassificationTypeNames.parameterName="parameter name",ClassificationTypeNames.docCommentTagName="doc comment tag name",ClassificationTypeNames.jsxOpenTagName="jsx open tag name",ClassificationTypeNames.jsxCloseTagName="jsx close tag name",ClassificationTypeNames.jsxSelfClosingTagName="jsx self closing tag name",ClassificationTypeNames.jsxAttribute="jsx attribute",ClassificationTypeNames.jsxText="jsx text",ClassificationTypeNames.jsxAttributeStringLiteralValue="jsx attribute string literal value",ClassificationTypeNames}();ts.ClassificationTypeNames=ClassificationTypeNames,function(ClassificationType){ClassificationType[ClassificationType.comment=1]="comment",ClassificationType[ClassificationType.identifier=2]="identifier",ClassificationType[ClassificationType.keyword=3]="keyword",ClassificationType[ClassificationType.numericLiteral=4]="numericLiteral",ClassificationType[ClassificationType.operator=5]="operator",ClassificationType[ClassificationType.stringLiteral=6]="stringLiteral",ClassificationType[ClassificationType.regularExpressionLiteral=7]="regularExpressionLiteral",ClassificationType[ClassificationType.whiteSpace=8]="whiteSpace",ClassificationType[ClassificationType.text=9]="text",ClassificationType[ClassificationType.punctuation=10]="punctuation",ClassificationType[ClassificationType.className=11]="className",ClassificationType[ClassificationType.enumName=12]="enumName",ClassificationType[ClassificationType.interfaceName=13]="interfaceName",ClassificationType[ClassificationType.moduleName=14]="moduleName",ClassificationType[ClassificationType.typeParameterName=15]="typeParameterName",ClassificationType[ClassificationType.typeAliasName=16]="typeAliasName",ClassificationType[ClassificationType.parameterName=17]="parameterName",ClassificationType[ClassificationType.docCommentTagName=18]="docCommentTagName",ClassificationType[ClassificationType.jsxOpenTagName=19]="jsxOpenTagName",ClassificationType[ClassificationType.jsxCloseTagName=20]="jsxCloseTagName",ClassificationType[ClassificationType.jsxSelfClosingTagName=21]="jsxSelfClosingTagName",ClassificationType[ClassificationType.jsxAttribute=22]="jsxAttribute",ClassificationType[ClassificationType.jsxText=23]="jsxText",ClassificationType[ClassificationType.jsxAttributeStringLiteralValue=24]="jsxAttributeStringLiteralValue"}(ts.ClassificationType||(ts.ClassificationType={}));ts.ClassificationType;ts.displayPartsToString=displayPartsToString,ts.getDefaultCompilerOptions=getDefaultCompilerOptions;var HostCache=function(){function HostCache(host,getCanonicalFileName){this.host=host,this.getCanonicalFileName=getCanonicalFileName,this.currentDirectory=host.getCurrentDirectory(),this.fileNameToEntry=ts.createFileMap();for(var rootFileNames=host.getScriptFileNames(),_i=0,rootFileNames_1=rootFileNames;_i<rootFileNames_1.length;_i++){var fileName=rootFileNames_1[_i];this.createEntry(fileName,ts.toPath(fileName,this.currentDirectory,getCanonicalFileName))}this._compilationSettings=host.getCompilationSettings()||getDefaultCompilerOptions()}return HostCache.prototype.compilationSettings=function(){return this._compilationSettings},HostCache.prototype.createEntry=function(fileName,path){var entry,scriptSnapshot=this.host.getScriptSnapshot(fileName);return scriptSnapshot&&(entry={hostFileName:fileName,version:this.host.getScriptVersion(fileName),scriptSnapshot:scriptSnapshot}),this.fileNameToEntry.set(path,entry),entry},HostCache.prototype.getEntry=function(path){return this.fileNameToEntry.get(path)},HostCache.prototype.contains=function(path){return this.fileNameToEntry.contains(path)},HostCache.prototype.getOrCreateEntry=function(fileName){var path=ts.toPath(fileName,this.currentDirectory,this.getCanonicalFileName);return this.contains(path)?this.getEntry(path):this.createEntry(fileName,path)},HostCache.prototype.getRootFileNames=function(){var fileNames=[];return this.fileNameToEntry.forEachValue(function(path,value){value&&fileNames.push(value.hostFileName)}),fileNames},HostCache.prototype.getVersion=function(path){var file=this.getEntry(path);return file&&file.version},HostCache.prototype.getScriptSnapshot=function(path){var file=this.getEntry(path);return file&&file.scriptSnapshot},HostCache}(),SyntaxTreeCache=function(){function SyntaxTreeCache(host){this.host=host}return SyntaxTreeCache.prototype.getCurrentSourceFile=function(fileName){var scriptSnapshot=this.host.getScriptSnapshot(fileName);if(!scriptSnapshot)throw new Error("Could not find file: '"+fileName+"'.");var sourceFile,version=this.host.getScriptVersion(fileName);if(this.currentFileName!==fileName)sourceFile=createLanguageServiceSourceFile(fileName,scriptSnapshot,2,version,!0);else if(this.currentFileVersion!==version){var editRange=scriptSnapshot.getChangeRange(this.currentFileScriptSnapshot);sourceFile=updateLanguageServiceSourceFile(this.currentSourceFile,scriptSnapshot,version,editRange)}return sourceFile&&(this.currentFileVersion=version,this.currentFileName=fileName,this.currentFileScriptSnapshot=scriptSnapshot,this.currentSourceFile=sourceFile),this.currentSourceFile},SyntaxTreeCache}();ts.transpileModule=transpileModule,ts.transpile=transpile,ts.createLanguageServiceSourceFile=createLanguageServiceSourceFile,ts.disableIncrementalParsing=!1,ts.updateLanguageServiceSourceFile=updateLanguageServiceSourceFile,ts.createDocumentRegistry=createDocumentRegistry,ts.preProcessFile=preProcessFile;var SemanticMeaning;!function(SemanticMeaning){SemanticMeaning[SemanticMeaning.None=0]="None",SemanticMeaning[SemanticMeaning.Value=1]="Value",SemanticMeaning[SemanticMeaning.Type=2]="Type",SemanticMeaning[SemanticMeaning.Namespace=4]="Namespace",SemanticMeaning[SemanticMeaning.All=7]="All"}(SemanticMeaning||(SemanticMeaning={}));var BreakContinueSearchType;!function(BreakContinueSearchType){BreakContinueSearchType[BreakContinueSearchType.None=0]="None",BreakContinueSearchType[BreakContinueSearchType.Unlabeled=1]="Unlabeled",BreakContinueSearchType[BreakContinueSearchType.Labeled=2]="Labeled",BreakContinueSearchType[BreakContinueSearchType.All=3]="All"}(BreakContinueSearchType||(BreakContinueSearchType={}));for(var keywordCompletions=[],i=70;i<=135;i++)keywordCompletions.push({name:ts.tokenToString(i),kind:ScriptElementKind.keyword,kindModifiers:ScriptElementKindModifier.none,sortText:"0"});ts.getContainerNode=getContainerNode,ts.getNodeKind=getNodeKind;var CancellationTokenObject=function(){function CancellationTokenObject(cancellationToken){this.cancellationToken=cancellationToken}return CancellationTokenObject.prototype.isCancellationRequested=function(){return this.cancellationToken&&this.cancellationToken.isCancellationRequested()},CancellationTokenObject.prototype.throwIfCancellationRequested=function(){if(this.isCancellationRequested())throw new ts.OperationCanceledException},CancellationTokenObject}();ts.createLanguageService=createLanguageService,ts.getNameTable=getNameTable,ts.createClassifier=createClassifier,ts.getDefaultLibFilePath=getDefaultLibFilePath,initializeServices()}(ts||(ts={}));var ts;!function(ts){var BreakpointResolver;!function(BreakpointResolver){function spanInSourceFileAtLocation(sourceFile,position){function textSpan(startNode,endNode){var start=startNode.decorators?ts.skipTrivia(sourceFile.text,startNode.decorators.end):startNode.getStart(sourceFile);return ts.createTextSpanFromBounds(start,(endNode||startNode).getEnd())}function textSpanEndingAtNextToken(startNode,previousTokenToFindNextEndToken){return textSpan(startNode,ts.findNextToken(previousTokenToFindNextEndToken,previousTokenToFindNextEndToken.parent))}function spanInNodeIfStartsOnSameLine(node,otherwiseOnNode){return spanInNode(node&&lineOfPosition===sourceFile.getLineAndCharacterOfPosition(node.getStart(sourceFile)).line?node:otherwiseOnNode)}function spanInNodeArray(nodeArray){return ts.createTextSpanFromBounds(ts.skipTrivia(sourceFile.text,nodeArray.pos),nodeArray.end)}function spanInPreviousNode(node){return spanInNode(ts.findPrecedingToken(node.pos,sourceFile))}function spanInNextNode(node){return spanInNode(ts.findNextToken(node,node.parent))}function spanInNode(node){function textSpanFromVariableDeclaration(variableDeclaration){var declarations=variableDeclaration.parent.declarations;return declarations&&declarations[0]===variableDeclaration?textSpan(ts.findPrecedingToken(variableDeclaration.pos,sourceFile,variableDeclaration.parent),variableDeclaration):textSpan(variableDeclaration)}function spanInVariableDeclaration(variableDeclaration){if(203===variableDeclaration.parent.parent.kind)return spanInNode(variableDeclaration.parent.parent);if(ts.isBindingPattern(variableDeclaration.name))return spanInBindingPattern(variableDeclaration.name);if(variableDeclaration.initializer||2&variableDeclaration.flags||204===variableDeclaration.parent.parent.kind)return textSpanFromVariableDeclaration(variableDeclaration);var declarations=variableDeclaration.parent.declarations;return declarations&&declarations[0]!==variableDeclaration?spanInNode(ts.findPrecedingToken(variableDeclaration.pos,sourceFile,variableDeclaration.parent)):void 0}function canHaveSpanInParameterDeclaration(parameter){return!!parameter.initializer||void 0!==parameter.dotDotDotToken||!!(8&parameter.flags)||!!(16&parameter.flags)}function spanInParameterDeclaration(parameter){if(ts.isBindingPattern(parameter.name))return spanInBindingPattern(parameter.name);if(canHaveSpanInParameterDeclaration(parameter))return textSpan(parameter);var functionDeclaration=parameter.parent,indexOfParameter=ts.indexOf(functionDeclaration.parameters,parameter);return indexOfParameter?spanInParameterDeclaration(functionDeclaration.parameters[indexOfParameter-1]):spanInNode(functionDeclaration.body)}function canFunctionHaveSpanInWholeDeclaration(functionDeclaration){return!!(2&functionDeclaration.flags)||217===functionDeclaration.parent.kind&&145!==functionDeclaration.kind}function spanInFunctionDeclaration(functionDeclaration){if(functionDeclaration.body)return canFunctionHaveSpanInWholeDeclaration(functionDeclaration)?textSpan(functionDeclaration):spanInNode(functionDeclaration.body)}function spanInFunctionBlock(block){var nodeForSpanInBlock=block.statements.length?block.statements[0]:block.getLastToken();return canFunctionHaveSpanInWholeDeclaration(block.parent)?spanInNodeIfStartsOnSameLine(block.parent,nodeForSpanInBlock):spanInNode(nodeForSpanInBlock)}function spanInBlock(block){switch(block.parent.kind){case 221:if(1!==ts.getModuleInstanceState(block.parent))return;case 201:case 199:case 203:return spanInNodeIfStartsOnSameLine(block.parent,block.statements[0]);case 202:case 204:return spanInNodeIfStartsOnSameLine(ts.findPrecedingToken(block.pos,sourceFile,block.parent),block.statements[0])}return spanInNode(block.statements[0])}function spanInInitializerOfForLike(forLikeStaement){if(215!==forLikeStaement.initializer.kind)return spanInNode(forLikeStaement.initializer);var variableDeclarationList=forLikeStaement.initializer;return variableDeclarationList.declarations.length>0?spanInNode(variableDeclarationList.declarations[0]):void 0}function spanInForStatement(forStatement){return forStatement.initializer?spanInInitializerOfForLike(forStatement):forStatement.condition?textSpan(forStatement.condition):forStatement.incrementor?textSpan(forStatement.incrementor):void 0}function spanInBindingPattern(bindingPattern){var firstBindingElement=ts.forEach(bindingPattern.elements,function(element){return 190!==element.kind?element:void 0});return firstBindingElement?spanInNode(firstBindingElement):166===bindingPattern.parent.kind?textSpan(bindingPattern.parent):textSpanFromVariableDeclaration(bindingPattern.parent)}function spanInArrayLiteralOrObjectLiteralDestructuringPattern(node){ts.Debug.assert(165!==node.kind&&164!==node.kind);var elements=167===node.kind?node.elements:node.properties,firstBindingElement=ts.forEach(elements,function(element){return 190!==element.kind?element:void 0});return firstBindingElement?spanInNode(firstBindingElement):textSpan(184===node.parent.kind?node.parent:node)}function spanInOpenBraceToken(node){switch(node.parent.kind){case 220:var enumDeclaration=node.parent;return spanInNodeIfStartsOnSameLine(ts.findPrecedingToken(node.pos,sourceFile,node.parent),enumDeclaration.members.length?enumDeclaration.members[0]:enumDeclaration.getLastToken(sourceFile));case 217:var classDeclaration=node.parent;return spanInNodeIfStartsOnSameLine(ts.findPrecedingToken(node.pos,sourceFile,node.parent),classDeclaration.members.length?classDeclaration.members[0]:classDeclaration.getLastToken(sourceFile));case 223:return spanInNodeIfStartsOnSameLine(node.parent.parent,node.parent.clauses[0])}return spanInNode(node.parent)}function spanInCloseBraceToken(node){switch(node.parent.kind){case 222:if(1!==ts.getModuleInstanceState(node.parent.parent))return;case 220:case 217:return textSpan(node);case 195:if(ts.isFunctionBlock(node.parent))return textSpan(node);case 247:return spanInNode(ts.lastOrUndefined(node.parent.statements));case 223:var caseBlock=node.parent,lastClause=ts.lastOrUndefined(caseBlock.clauses);if(lastClause)return spanInNode(ts.lastOrUndefined(lastClause.statements));return;case 164:var bindingPattern=node.parent;return spanInNode(ts.lastOrUndefined(bindingPattern.elements)||bindingPattern);default:if(ts.isArrayLiteralOrObjectLiteralDestructuringPattern(node.parent)){var objectLiteral=node.parent;return textSpan(ts.lastOrUndefined(objectLiteral.properties)||objectLiteral)}return spanInNode(node.parent)}}function spanInCloseBracketToken(node){switch(node.parent.kind){case 165:var bindingPattern=node.parent;return textSpan(ts.lastOrUndefined(bindingPattern.elements)||bindingPattern);default:if(ts.isArrayLiteralOrObjectLiteralDestructuringPattern(node.parent)){var arrayLiteral=node.parent;return textSpan(ts.lastOrUndefined(arrayLiteral.elements)||arrayLiteral)}return spanInNode(node.parent)}}function spanInOpenParenToken(node){return 200===node.parent.kind||171===node.parent.kind||172===node.parent.kind?spanInPreviousNode(node):175===node.parent.kind?spanInNextNode(node):spanInNode(node.parent)}function spanInCloseParenToken(node){switch(node.parent.kind){case 176:case 216:case 177:case 144:case 143:case 146:case 147:case 145:case 201:case 200:case 202:case 204:case 171:case 172:case 175:return spanInPreviousNode(node);default:return spanInNode(node.parent)}}function spanInColonToken(node){return ts.isFunctionLike(node.parent)||248===node.parent.kind||139===node.parent.kind?spanInPreviousNode(node):spanInNode(node.parent)}function spanInGreaterThanOrLessThanToken(node){return 174===node.parent.kind?spanInNextNode(node):spanInNode(node.parent)}function spanInWhileKeyword(node){return 200===node.parent.kind?textSpanEndingAtNextToken(node,node.parent.expression):spanInNode(node.parent)}function spanInOfKeyword(node){return 204===node.parent.kind?spanInNextNode(node):spanInNode(node.parent)}if(node)switch(node.kind){case 196:return spanInVariableDeclaration(node.declarationList.declarations[0]);case 214:case 142:case 141:return spanInVariableDeclaration(node);case 139:return spanInParameterDeclaration(node);case 216:case 144:case 143:case 146:case 147:case 145:case 176:case 177:return spanInFunctionDeclaration(node);case 195:if(ts.isFunctionBlock(node))return spanInFunctionBlock(node);case 222:return spanInBlock(node);case 247:return spanInBlock(node.block);case 198:return textSpan(node.expression);case 207:return textSpan(node.getChildAt(0),node.expression);case 201:return textSpanEndingAtNextToken(node,node.expression);case 200:return spanInNode(node.statement);case 213:return textSpan(node.getChildAt(0));case 199:return textSpanEndingAtNextToken(node,node.expression);case 210:return spanInNode(node.statement);case 206:case 205:return textSpan(node.getChildAt(0),node.label);case 202:return spanInForStatement(node);case 203:return textSpanEndingAtNextToken(node,node.expression);case 204:return spanInInitializerOfForLike(node);case 209:return textSpanEndingAtNextToken(node,node.expression);case 244:case 245:return spanInNode(node.statements[0]);case 212:return spanInBlock(node.tryBlock);case 211:return textSpan(node,node.expression);case 230:return textSpan(node,node.expression);case 224:return textSpan(node,node.moduleReference);case 225:return textSpan(node,node.moduleSpecifier);case 231:return textSpan(node,node.moduleSpecifier);case 221:if(1!==ts.getModuleInstanceState(node))return;case 217:case 220:case 250:case 166:return textSpan(node);case 208:return spanInNode(node.statement);case 140:return spanInNodeArray(node.parent.decorators);case 164:case 165:return spanInBindingPattern(node);case 218:case 219:return;case 23:case 1:return spanInNodeIfStartsOnSameLine(ts.findPrecedingToken(node.pos,sourceFile));case 24:return spanInPreviousNode(node);case 15:return spanInOpenBraceToken(node);case 16:return spanInCloseBraceToken(node);case 20:return spanInCloseBracketToken(node);case 17:return spanInOpenParenToken(node);case 18:return spanInCloseParenToken(node);case 54:return spanInColonToken(node);case 27:case 25:return spanInGreaterThanOrLessThanToken(node);case 104:return spanInWhileKeyword(node);case 80:case 72:case 85:return spanInNextNode(node);case 135:return spanInOfKeyword(node);default:if(ts.isArrayLiteralOrObjectLiteralDestructuringPattern(node))return spanInArrayLiteralOrObjectLiteralDestructuringPattern(node);if((69===node.kind||188==node.kind||248===node.kind||249===node.kind)&&ts.isArrayLiteralOrObjectLiteralDestructuringPattern(node.parent))return textSpan(node);if(184===node.kind){var binaryExpression=node;if(ts.isArrayLiteralOrObjectLiteralDestructuringPattern(binaryExpression.left))return spanInArrayLiteralOrObjectLiteralDestructuringPattern(binaryExpression.left);if(56===binaryExpression.operatorToken.kind&&ts.isArrayLiteralOrObjectLiteralDestructuringPattern(binaryExpression.parent))return textSpan(node);if(24===binaryExpression.operatorToken.kind)return spanInNode(binaryExpression.left)}if(ts.isExpression(node))switch(node.parent.kind){case 200:return spanInPreviousNode(node);case 140:return spanInNode(node.parent);case 202:case 204:return textSpan(node);case 184:if(24===node.parent.operatorToken.kind)return textSpan(node);break;case 177:if(node.parent.body===node)return textSpan(node)}if(248===node.parent.kind&&node.parent.name===node&&!ts.isArrayLiteralOrObjectLiteralDestructuringPattern(node.parent.parent))return spanInNode(node.parent.initializer);if(174===node.parent.kind&&node.parent.type===node)return spanInNextNode(node.parent.type);if(ts.isFunctionLike(node.parent)&&node.parent.type===node)return spanInPreviousNode(node);if(214===node.parent.kind||139===node.parent.kind){var paramOrVarDecl=node.parent;if(paramOrVarDecl.initializer===node||paramOrVarDecl.type===node||ts.isAssignmentOperator(node.kind))return spanInPreviousNode(node)}if(184===node.parent.kind){var binaryExpression=node.parent;if(ts.isArrayLiteralOrObjectLiteralDestructuringPattern(binaryExpression.left)&&(binaryExpression.right===node||binaryExpression.operatorToken===node))return spanInPreviousNode(node)}return spanInNode(node.parent)}}if(!(4096&sourceFile.flags)){var tokenAtLocation=ts.getTokenAtPosition(sourceFile,position),lineOfPosition=sourceFile.getLineAndCharacterOfPosition(position).line;if((!(sourceFile.getLineAndCharacterOfPosition(tokenAtLocation.getStart(sourceFile)).line>lineOfPosition)||(tokenAtLocation=ts.findPrecedingToken(tokenAtLocation.pos,sourceFile),tokenAtLocation&&sourceFile.getLineAndCharacterOfPosition(tokenAtLocation.getEnd()).line===lineOfPosition))&&!ts.isInAmbientContext(tokenAtLocation))return spanInNode(tokenAtLocation)}}BreakpointResolver.spanInSourceFileAtLocation=spanInSourceFileAtLocation}(BreakpointResolver=ts.BreakpointResolver||(ts.BreakpointResolver={}))}(ts||(ts={}));var ts,debugObjectHost=this;!function(ts){function logInternalError(logger,err){logger&&logger.log("*INTERNAL ERROR* - Exception in typescript services: "+err.message)}function simpleForwardCall(logger,actionDescription,action,logPerformance){var start;logPerformance&&(logger.log(actionDescription),start=Date.now());var result=action();if(logPerformance){var end=Date.now();if(logger.log(actionDescription+" completed in "+(end-start)+" msec"),"string"==typeof result){var str=result;str.length>128&&(str=str.substring(0,128)+"..."),logger.log("  result.length="+str.length+", result='"+JSON.stringify(str)+"'")}}return result}function forwardJSONCall(logger,actionDescription,action,logPerformance){try{var result=simpleForwardCall(logger,actionDescription,action,logPerformance);return JSON.stringify({result:result})}catch(err){return err instanceof ts.OperationCanceledException?JSON.stringify({canceled:!0}):(logInternalError(logger,err),err.description=actionDescription,JSON.stringify({error:err}))}}function realizeDiagnostics(diagnostics,newLine){return diagnostics.map(function(d){return realizeDiagnostic(d,newLine)})}function realizeDiagnostic(diagnostic,newLine){return{message:ts.flattenDiagnosticMessageText(diagnostic.messageText,newLine),start:diagnostic.start,length:diagnostic.length,category:ts.DiagnosticCategory[diagnostic.category].toLowerCase(),code:diagnostic.code}}function convertClassifications(classifications){return{spans:classifications.spans.join(","),endOfLineState:classifications.endOfLineState}}var ScriptSnapshotShimAdapter=function(){function ScriptSnapshotShimAdapter(scriptSnapshotShim){this.scriptSnapshotShim=scriptSnapshotShim}return ScriptSnapshotShimAdapter.prototype.getText=function(start,end){return this.scriptSnapshotShim.getText(start,end)},ScriptSnapshotShimAdapter.prototype.getLength=function(){return this.scriptSnapshotShim.getLength()},ScriptSnapshotShimAdapter.prototype.getChangeRange=function(oldSnapshot){var oldSnapshotShim=oldSnapshot,encoded=this.scriptSnapshotShim.getChangeRange(oldSnapshotShim.scriptSnapshotShim);if(null==encoded)return null;var decoded=JSON.parse(encoded);return ts.createTextChangeRange(ts.createTextSpan(decoded.span.start,decoded.span.length),decoded.newLength)},ScriptSnapshotShimAdapter.prototype.dispose=function(){"dispose"in this.scriptSnapshotShim&&this.scriptSnapshotShim.dispose()},ScriptSnapshotShimAdapter}(),LanguageServiceShimHostAdapter=function(){function LanguageServiceShimHostAdapter(shimHost){var _this=this;this.shimHost=shimHost,this.loggingEnabled=!1,this.tracingEnabled=!1,"getModuleResolutionsForFile"in this.shimHost&&(this.resolveModuleNames=function(moduleNames,containingFile){var resolutionsInFile=JSON.parse(_this.shimHost.getModuleResolutionsForFile(containingFile));return ts.map(moduleNames,function(name){var result=ts.lookUp(resolutionsInFile,name);return result?{resolvedFileName:result}:void 0})}),"directoryExists"in this.shimHost&&(this.directoryExists=function(directoryName){return _this.shimHost.directoryExists(directoryName)})}return LanguageServiceShimHostAdapter.prototype.log=function(s){this.loggingEnabled&&this.shimHost.log(s)},LanguageServiceShimHostAdapter.prototype.trace=function(s){this.tracingEnabled&&this.shimHost.trace(s)},LanguageServiceShimHostAdapter.prototype.error=function(s){this.shimHost.error(s)},LanguageServiceShimHostAdapter.prototype.getProjectVersion=function(){if(this.shimHost.getProjectVersion)return this.shimHost.getProjectVersion()},LanguageServiceShimHostAdapter.prototype.useCaseSensitiveFileNames=function(){return!!this.shimHost.useCaseSensitiveFileNames&&this.shimHost.useCaseSensitiveFileNames()},LanguageServiceShimHostAdapter.prototype.getCompilationSettings=function(){var settingsJson=this.shimHost.getCompilationSettings();if(null==settingsJson||""==settingsJson)throw Error("LanguageServiceShimHostAdapter.getCompilationSettings: empty compilationSettings");return JSON.parse(settingsJson)},LanguageServiceShimHostAdapter.prototype.getScriptFileNames=function(){var encoded=this.shimHost.getScriptFileNames();return this.files=JSON.parse(encoded)},LanguageServiceShimHostAdapter.prototype.getScriptSnapshot=function(fileName){var scriptSnapshot=this.shimHost.getScriptSnapshot(fileName);return scriptSnapshot&&new ScriptSnapshotShimAdapter(scriptSnapshot)},LanguageServiceShimHostAdapter.prototype.getScriptVersion=function(fileName){return this.shimHost.getScriptVersion(fileName)},LanguageServiceShimHostAdapter.prototype.getLocalizedDiagnosticMessages=function(){var diagnosticMessagesJson=this.shimHost.getLocalizedDiagnosticMessages();if(null==diagnosticMessagesJson||""==diagnosticMessagesJson)return null;try{return JSON.parse(diagnosticMessagesJson)}catch(e){return this.log(e.description||"diagnosticMessages.generated.json has invalid JSON format"),
null}},LanguageServiceShimHostAdapter.prototype.getCancellationToken=function(){var hostCancellationToken=this.shimHost.getCancellationToken();return new ThrottledCancellationToken(hostCancellationToken)},LanguageServiceShimHostAdapter.prototype.getCurrentDirectory=function(){return this.shimHost.getCurrentDirectory()},LanguageServiceShimHostAdapter.prototype.getDefaultLibFileName=function(options){return this.shimHost.getDefaultLibFileName(JSON.stringify(options))},LanguageServiceShimHostAdapter}();ts.LanguageServiceShimHostAdapter=LanguageServiceShimHostAdapter;var ThrottledCancellationToken=function(){function ThrottledCancellationToken(hostCancellationToken){this.hostCancellationToken=hostCancellationToken,this.lastCancellationCheckTime=0}return ThrottledCancellationToken.prototype.isCancellationRequested=function(){var time=Date.now(),duration=Math.abs(time-this.lastCancellationCheckTime);return duration>10&&(this.lastCancellationCheckTime=time,this.hostCancellationToken.isCancellationRequested())},ThrottledCancellationToken}(),CoreServicesShimHostAdapter=function(){function CoreServicesShimHostAdapter(shimHost){var _this=this;this.shimHost=shimHost,"directoryExists"in this.shimHost&&(this.directoryExists=function(directoryName){return _this.shimHost.directoryExists(directoryName)})}return CoreServicesShimHostAdapter.prototype.readDirectory=function(rootDir,extension,exclude){var encoded=this.shimHost.readDirectory(rootDir,extension,JSON.stringify(exclude));return JSON.parse(encoded)},CoreServicesShimHostAdapter.prototype.fileExists=function(fileName){return this.shimHost.fileExists(fileName)},CoreServicesShimHostAdapter.prototype.readFile=function(fileName){return this.shimHost.readFile(fileName)},CoreServicesShimHostAdapter}();ts.CoreServicesShimHostAdapter=CoreServicesShimHostAdapter;var ShimBase=function(){function ShimBase(factory){this.factory=factory,factory.registerShim(this)}return ShimBase.prototype.dispose=function(dummy){this.factory.unregisterShim(this)},ShimBase}();ts.realizeDiagnostics=realizeDiagnostics;var LanguageServiceShimObject=function(_super){function LanguageServiceShimObject(factory,host,languageService){_super.call(this,factory),this.host=host,this.languageService=languageService,this.logPerformance=!1,this.logger=this.host}return __extends(LanguageServiceShimObject,_super),LanguageServiceShimObject.prototype.forwardJSONCall=function(actionDescription,action){return forwardJSONCall(this.logger,actionDescription,action,this.logPerformance)},LanguageServiceShimObject.prototype.dispose=function(dummy){this.logger.log("dispose()"),this.languageService.dispose(),this.languageService=null,debugObjectHost&&debugObjectHost.CollectGarbage&&(debugObjectHost.CollectGarbage(),this.logger.log("CollectGarbage()")),this.logger=null,_super.prototype.dispose.call(this,dummy)},LanguageServiceShimObject.prototype.refresh=function(throwOnError){this.forwardJSONCall("refresh("+throwOnError+")",function(){return null})},LanguageServiceShimObject.prototype.cleanupSemanticCache=function(){var _this=this;this.forwardJSONCall("cleanupSemanticCache()",function(){return _this.languageService.cleanupSemanticCache(),null})},LanguageServiceShimObject.prototype.realizeDiagnostics=function(diagnostics){var newLine=ts.getNewLineOrDefaultFromHost(this.host);return ts.realizeDiagnostics(diagnostics,newLine)},LanguageServiceShimObject.prototype.getSyntacticClassifications=function(fileName,start,length){var _this=this;return this.forwardJSONCall("getSyntacticClassifications('"+fileName+"', "+start+", "+length+")",function(){return _this.languageService.getSyntacticClassifications(fileName,ts.createTextSpan(start,length))})},LanguageServiceShimObject.prototype.getSemanticClassifications=function(fileName,start,length){var _this=this;return this.forwardJSONCall("getSemanticClassifications('"+fileName+"', "+start+", "+length+")",function(){return _this.languageService.getSemanticClassifications(fileName,ts.createTextSpan(start,length))})},LanguageServiceShimObject.prototype.getEncodedSyntacticClassifications=function(fileName,start,length){var _this=this;return this.forwardJSONCall("getEncodedSyntacticClassifications('"+fileName+"', "+start+", "+length+")",function(){return convertClassifications(_this.languageService.getEncodedSyntacticClassifications(fileName,ts.createTextSpan(start,length)))})},LanguageServiceShimObject.prototype.getEncodedSemanticClassifications=function(fileName,start,length){var _this=this;return this.forwardJSONCall("getEncodedSemanticClassifications('"+fileName+"', "+start+", "+length+")",function(){return convertClassifications(_this.languageService.getEncodedSemanticClassifications(fileName,ts.createTextSpan(start,length)))})},LanguageServiceShimObject.prototype.getSyntacticDiagnostics=function(fileName){var _this=this;return this.forwardJSONCall("getSyntacticDiagnostics('"+fileName+"')",function(){var diagnostics=_this.languageService.getSyntacticDiagnostics(fileName);return _this.realizeDiagnostics(diagnostics)})},LanguageServiceShimObject.prototype.getSemanticDiagnostics=function(fileName){var _this=this;return this.forwardJSONCall("getSemanticDiagnostics('"+fileName+"')",function(){var diagnostics=_this.languageService.getSemanticDiagnostics(fileName);return _this.realizeDiagnostics(diagnostics)})},LanguageServiceShimObject.prototype.getCompilerOptionsDiagnostics=function(){var _this=this;return this.forwardJSONCall("getCompilerOptionsDiagnostics()",function(){var diagnostics=_this.languageService.getCompilerOptionsDiagnostics();return _this.realizeDiagnostics(diagnostics)})},LanguageServiceShimObject.prototype.getQuickInfoAtPosition=function(fileName,position){var _this=this;return this.forwardJSONCall("getQuickInfoAtPosition('"+fileName+"', "+position+")",function(){return _this.languageService.getQuickInfoAtPosition(fileName,position)})},LanguageServiceShimObject.prototype.getNameOrDottedNameSpan=function(fileName,startPos,endPos){var _this=this;return this.forwardJSONCall("getNameOrDottedNameSpan('"+fileName+"', "+startPos+", "+endPos+")",function(){return _this.languageService.getNameOrDottedNameSpan(fileName,startPos,endPos)})},LanguageServiceShimObject.prototype.getBreakpointStatementAtPosition=function(fileName,position){var _this=this;return this.forwardJSONCall("getBreakpointStatementAtPosition('"+fileName+"', "+position+")",function(){return _this.languageService.getBreakpointStatementAtPosition(fileName,position)})},LanguageServiceShimObject.prototype.getSignatureHelpItems=function(fileName,position){var _this=this;return this.forwardJSONCall("getSignatureHelpItems('"+fileName+"', "+position+")",function(){return _this.languageService.getSignatureHelpItems(fileName,position)})},LanguageServiceShimObject.prototype.getDefinitionAtPosition=function(fileName,position){var _this=this;return this.forwardJSONCall("getDefinitionAtPosition('"+fileName+"', "+position+")",function(){return _this.languageService.getDefinitionAtPosition(fileName,position)})},LanguageServiceShimObject.prototype.getTypeDefinitionAtPosition=function(fileName,position){var _this=this;return this.forwardJSONCall("getTypeDefinitionAtPosition('"+fileName+"', "+position+")",function(){return _this.languageService.getTypeDefinitionAtPosition(fileName,position)})},LanguageServiceShimObject.prototype.getRenameInfo=function(fileName,position){var _this=this;return this.forwardJSONCall("getRenameInfo('"+fileName+"', "+position+")",function(){return _this.languageService.getRenameInfo(fileName,position)})},LanguageServiceShimObject.prototype.findRenameLocations=function(fileName,position,findInStrings,findInComments){var _this=this;return this.forwardJSONCall("findRenameLocations('"+fileName+"', "+position+", "+findInStrings+", "+findInComments+")",function(){return _this.languageService.findRenameLocations(fileName,position,findInStrings,findInComments)})},LanguageServiceShimObject.prototype.getBraceMatchingAtPosition=function(fileName,position){var _this=this;return this.forwardJSONCall("getBraceMatchingAtPosition('"+fileName+"', "+position+")",function(){return _this.languageService.getBraceMatchingAtPosition(fileName,position)})},LanguageServiceShimObject.prototype.getIndentationAtPosition=function(fileName,position,options){var _this=this;return this.forwardJSONCall("getIndentationAtPosition('"+fileName+"', "+position+")",function(){var localOptions=JSON.parse(options);return _this.languageService.getIndentationAtPosition(fileName,position,localOptions)})},LanguageServiceShimObject.prototype.getReferencesAtPosition=function(fileName,position){var _this=this;return this.forwardJSONCall("getReferencesAtPosition('"+fileName+"', "+position+")",function(){return _this.languageService.getReferencesAtPosition(fileName,position)})},LanguageServiceShimObject.prototype.findReferences=function(fileName,position){var _this=this;return this.forwardJSONCall("findReferences('"+fileName+"', "+position+")",function(){return _this.languageService.findReferences(fileName,position)})},LanguageServiceShimObject.prototype.getOccurrencesAtPosition=function(fileName,position){var _this=this;return this.forwardJSONCall("getOccurrencesAtPosition('"+fileName+"', "+position+")",function(){return _this.languageService.getOccurrencesAtPosition(fileName,position)})},LanguageServiceShimObject.prototype.getDocumentHighlights=function(fileName,position,filesToSearch){var _this=this;return this.forwardJSONCall("getDocumentHighlights('"+fileName+"', "+position+")",function(){var results=_this.languageService.getDocumentHighlights(fileName,position,JSON.parse(filesToSearch)),normalizedName=ts.normalizeSlashes(fileName).toLowerCase();return ts.filter(results,function(r){return ts.normalizeSlashes(r.fileName).toLowerCase()===normalizedName})})},LanguageServiceShimObject.prototype.getCompletionsAtPosition=function(fileName,position){var _this=this;return this.forwardJSONCall("getCompletionsAtPosition('"+fileName+"', "+position+")",function(){return _this.languageService.getCompletionsAtPosition(fileName,position)})},LanguageServiceShimObject.prototype.getCompletionEntryDetails=function(fileName,position,entryName){var _this=this;return this.forwardJSONCall("getCompletionEntryDetails('"+fileName+"', "+position+", '"+entryName+"')",function(){return _this.languageService.getCompletionEntryDetails(fileName,position,entryName)})},LanguageServiceShimObject.prototype.getFormattingEditsForRange=function(fileName,start,end,options){var _this=this;return this.forwardJSONCall("getFormattingEditsForRange('"+fileName+"', "+start+", "+end+")",function(){var localOptions=JSON.parse(options);return _this.languageService.getFormattingEditsForRange(fileName,start,end,localOptions)})},LanguageServiceShimObject.prototype.getFormattingEditsForDocument=function(fileName,options){var _this=this;return this.forwardJSONCall("getFormattingEditsForDocument('"+fileName+"')",function(){var localOptions=JSON.parse(options);return _this.languageService.getFormattingEditsForDocument(fileName,localOptions)})},LanguageServiceShimObject.prototype.getFormattingEditsAfterKeystroke=function(fileName,position,key,options){var _this=this;return this.forwardJSONCall("getFormattingEditsAfterKeystroke('"+fileName+"', "+position+", '"+key+"')",function(){var localOptions=JSON.parse(options);return _this.languageService.getFormattingEditsAfterKeystroke(fileName,position,key,localOptions)})},LanguageServiceShimObject.prototype.getDocCommentTemplateAtPosition=function(fileName,position){var _this=this;return this.forwardJSONCall("getDocCommentTemplateAtPosition('"+fileName+"', "+position+")",function(){return _this.languageService.getDocCommentTemplateAtPosition(fileName,position)})},LanguageServiceShimObject.prototype.getNavigateToItems=function(searchValue,maxResultCount){var _this=this;return this.forwardJSONCall("getNavigateToItems('"+searchValue+"', "+maxResultCount+")",function(){return _this.languageService.getNavigateToItems(searchValue,maxResultCount)})},LanguageServiceShimObject.prototype.getNavigationBarItems=function(fileName){var _this=this;return this.forwardJSONCall("getNavigationBarItems('"+fileName+"')",function(){return _this.languageService.getNavigationBarItems(fileName)})},LanguageServiceShimObject.prototype.getOutliningSpans=function(fileName){var _this=this;return this.forwardJSONCall("getOutliningSpans('"+fileName+"')",function(){return _this.languageService.getOutliningSpans(fileName)})},LanguageServiceShimObject.prototype.getTodoComments=function(fileName,descriptors){var _this=this;return this.forwardJSONCall("getTodoComments('"+fileName+"')",function(){return _this.languageService.getTodoComments(fileName,JSON.parse(descriptors))})},LanguageServiceShimObject.prototype.getEmitOutput=function(fileName){var _this=this;return this.forwardJSONCall("getEmitOutput('"+fileName+"')",function(){return _this.languageService.getEmitOutput(fileName)})},LanguageServiceShimObject}(ShimBase),ClassifierShimObject=function(_super){function ClassifierShimObject(factory,logger){_super.call(this,factory),this.logger=logger,this.logPerformance=!1,this.classifier=ts.createClassifier()}return __extends(ClassifierShimObject,_super),ClassifierShimObject.prototype.getEncodedLexicalClassifications=function(text,lexState,syntacticClassifierAbsent){var _this=this;return forwardJSONCall(this.logger,"getEncodedLexicalClassifications",function(){return convertClassifications(_this.classifier.getEncodedLexicalClassifications(text,lexState,syntacticClassifierAbsent))},this.logPerformance)},ClassifierShimObject.prototype.getClassificationsForLine=function(text,lexState,classifyKeywordsInGenerics){for(var classification=this.classifier.getClassificationsForLine(text,lexState,classifyKeywordsInGenerics),result="",_i=0,_a=classification.entries;_i<_a.length;_i++){var item=_a[_i];result+=item.length+"\n",result+=item.classification+"\n"}return result+=classification.finalLexState},ClassifierShimObject}(ShimBase),CoreServicesShimObject=function(_super){function CoreServicesShimObject(factory,logger,host){_super.call(this,factory),this.logger=logger,this.host=host,this.logPerformance=!1}return __extends(CoreServicesShimObject,_super),CoreServicesShimObject.prototype.forwardJSONCall=function(actionDescription,action){return forwardJSONCall(this.logger,actionDescription,action,this.logPerformance)},CoreServicesShimObject.prototype.resolveModuleName=function(fileName,moduleName,compilerOptionsJson){var _this=this;return this.forwardJSONCall("resolveModuleName('"+fileName+"')",function(){var compilerOptions=JSON.parse(compilerOptionsJson),result=ts.resolveModuleName(moduleName,ts.normalizeSlashes(fileName),compilerOptions,_this.host);return{resolvedFileName:result.resolvedModule?result.resolvedModule.resolvedFileName:void 0,failedLookupLocations:result.failedLookupLocations}})},CoreServicesShimObject.prototype.getPreProcessedFileInfo=function(fileName,sourceTextSnapshot){return this.forwardJSONCall("getPreProcessedFileInfo('"+fileName+"')",function(){var result=ts.preProcessFile(sourceTextSnapshot.getText(0,sourceTextSnapshot.getLength()),!0,!0),convertResult={referencedFiles:[],importedFiles:[],ambientExternalModules:result.ambientExternalModules,isLibFile:result.isLibFile};return ts.forEach(result.referencedFiles,function(refFile){convertResult.referencedFiles.push({path:ts.normalizePath(refFile.fileName),position:refFile.pos,length:refFile.end-refFile.pos})}),ts.forEach(result.importedFiles,function(importedFile){convertResult.importedFiles.push({path:ts.normalizeSlashes(importedFile.fileName),position:importedFile.pos,length:importedFile.end-importedFile.pos})}),convertResult})},CoreServicesShimObject.prototype.getTSConfigFileInfo=function(fileName,sourceTextSnapshot){var _this=this;return this.forwardJSONCall("getTSConfigFileInfo('"+fileName+"')",function(){var text=sourceTextSnapshot.getText(0,sourceTextSnapshot.getLength()),result=ts.parseConfigFileTextToJson(fileName,text);if(result.error)return{options:{},files:[],errors:[realizeDiagnostic(result.error,"\r\n")]};var normalizedFileName=ts.normalizeSlashes(fileName),configFile=ts.parseJsonConfigFileContent(result.config,_this.host,ts.getDirectoryPath(normalizedFileName),{},normalizedFileName);return{options:configFile.options,files:configFile.fileNames,errors:realizeDiagnostics(configFile.errors,"\r\n")}})},CoreServicesShimObject.prototype.getDefaultCompilationSettings=function(){return this.forwardJSONCall("getDefaultCompilationSettings()",function(){return ts.getDefaultCompilerOptions()})},CoreServicesShimObject}(ShimBase),TypeScriptServicesFactory=function(){function TypeScriptServicesFactory(){this._shims=[]}return TypeScriptServicesFactory.prototype.getServicesVersion=function(){return ts.servicesVersion},TypeScriptServicesFactory.prototype.createLanguageServiceShim=function(host){try{void 0===this.documentRegistry&&(this.documentRegistry=ts.createDocumentRegistry(host.useCaseSensitiveFileNames&&host.useCaseSensitiveFileNames(),host.getCurrentDirectory()));var hostAdapter=new LanguageServiceShimHostAdapter(host),languageService=ts.createLanguageService(hostAdapter,this.documentRegistry);return new LanguageServiceShimObject(this,host,languageService)}catch(err){throw logInternalError(host,err),err}},TypeScriptServicesFactory.prototype.createClassifierShim=function(logger){try{return new ClassifierShimObject(this,logger)}catch(err){throw logInternalError(logger,err),err}},TypeScriptServicesFactory.prototype.createCoreServicesShim=function(host){try{var adapter=new CoreServicesShimHostAdapter(host);return new CoreServicesShimObject(this,host,adapter)}catch(err){throw logInternalError(host,err),err}},TypeScriptServicesFactory.prototype.close=function(){this._shims=[],this.documentRegistry=void 0},TypeScriptServicesFactory.prototype.registerShim=function(shim){this._shims.push(shim)},TypeScriptServicesFactory.prototype.unregisterShim=function(shim){for(var i=0,n=this._shims.length;i<n;i++)if(this._shims[i]===shim)return void delete this._shims[i];throw new Error("Invalid operation")},TypeScriptServicesFactory}();ts.TypeScriptServicesFactory=TypeScriptServicesFactory,"undefined"!=typeof module&&module.exports&&(module.exports=ts)}(ts||(ts={}));var TypeScript;!function(TypeScript){var Services;!function(Services){Services.TypeScriptServicesFactory=ts.TypeScriptServicesFactory}(Services=TypeScript.Services||(TypeScript.Services={}))}(TypeScript||(TypeScript={}))}).call(exports,__webpack_require__(59),"node_modules/raml-definition-system/node_modules/ts-structure-parser/node_modules/typescript/lib/typescript.js",function(){return this}(),"node_modules/raml-definition-system/node_modules/ts-structure-parser/node_modules/typescript/lib")},function(module,exports,__webpack_require__){var indexOf=[].indexOf;module.exports=function(arr,obj){if(indexOf)return arr.indexOf(obj);for(var i=0;i<arr.length;++i)if(arr[i]===obj)return i;return-1}},function(module,exports,__webpack_require__){},function(module,exports,__webpack_require__){"use strict";var parser=function(){function peg$subclass(child,parent){function ctor(){this.constructor=child}ctor.prototype=parent.prototype,child.prototype=new ctor}function peg$SyntaxError(message,expected,found,location){this.message=message,this.expected=expected,this.found=found,this.location=location,this.name="SyntaxError","function"==typeof Error.captureStackTrace&&Error.captureStackTrace(this,peg$SyntaxError)}function peg$parse(input){function peg$computePosDetails(pos){var p,ch,details=peg$posDetailsCache[pos];if(details)return details;for(p=pos-1;!peg$posDetailsCache[p];)p--;for(details=peg$posDetailsCache[p],details={line:details.line,column:details.column,seenCR:details.seenCR};p<pos;)ch=input.charAt(p),"\n"===ch?(details.seenCR||details.line++,details.column=1,details.seenCR=!1):"\r"===ch||"\u2028"===ch||"\u2029"===ch?(details.line++,details.column=1,details.seenCR=!0):(details.column++,details.seenCR=!1),p++;return peg$posDetailsCache[pos]=details,details}function peg$computeLocation(startPos,endPos){var startPosDetails=peg$computePosDetails(startPos),endPosDetails=peg$computePosDetails(endPos);return{start:{offset:startPos,line:startPosDetails.line,column:startPosDetails.column},end:{offset:endPos,line:endPosDetails.line,column:endPosDetails.column}}}function peg$fail(expected){peg$currPos<peg$maxFailPos||(peg$currPos>peg$maxFailPos&&(peg$maxFailPos=peg$currPos,peg$maxFailExpected=[]),peg$maxFailExpected.push(expected))}function peg$buildException(message,expected,found,location){function cleanupExpected(expected){var i=1;for(expected.sort(function(a,b){return a.description<b.description?-1:a.description>b.description?1:0});i<expected.length;)expected[i-1]===expected[i]?expected.splice(i,1):i++}function buildMessage(expected,found){function stringEscape(s){function hex(ch){return ch.charCodeAt(0).toString(16).toUpperCase()}return s.replace(/\\/g,"\\\\").replace(/"/g,'\\"').replace(/\x08/g,"\\b").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\f/g,"\\f").replace(/\r/g,"\\r").replace(/[\x00-\x07\x0B\x0E\x0F]/g,function(ch){return"\\x0"+hex(ch)}).replace(/[\x10-\x1F\x80-\xFF]/g,function(ch){return"\\x"+hex(ch)}).replace(/[\u0100-\u0FFF]/g,function(ch){return"\\u0"+hex(ch)}).replace(/[\u1000-\uFFFF]/g,function(ch){return"\\u"+hex(ch)})}var expectedDesc,foundDesc,i,expectedDescs=new Array(expected.length);for(i=0;i<expected.length;i++)expectedDescs[i]=expected[i].description;return expectedDesc=expected.length>1?expectedDescs.slice(0,-1).join(", ")+" or "+expectedDescs[expected.length-1]:expectedDescs[0],foundDesc=found?'"'+stringEscape(found)+'"':"end of input","Expected "+expectedDesc+" but "+foundDesc+" found."}return null!==expected&&cleanupExpected(expected),new peg$SyntaxError(null!==message?message:buildMessage(expected,found),expected,found,location)}function peg$parseTerm(){var s0,s1,s2,s3,s4,s5,s6,s7;return s0=peg$currPos,s1=peg$parse_(),s1!==peg$FAILED?(s2=peg$parseFactor(),s2!==peg$FAILED?(s3=peg$currPos,s4=peg$parse_(),s4!==peg$FAILED?(124===input.charCodeAt(peg$currPos)?(s5=peg$c0,peg$currPos++):(s5=peg$FAILED,0===peg$silentFails&&peg$fail(peg$c1)),s5!==peg$FAILED?(s6=peg$parse_(),s6!==peg$FAILED?(s7=peg$parseTerm(),s7!==peg$FAILED?(s4=[s4,s5,s6,s7],s3=s4):(peg$currPos=s3,s3=peg$FAILED)):(peg$currPos=s3,s3=peg$FAILED)):(peg$currPos=s3,s3=peg$FAILED)):(peg$currPos=s3,s3=peg$FAILED),s3===peg$FAILED&&(s3=null),s3!==peg$FAILED?(peg$savedPos=s0,s1=peg$c2(s2,s3),s0=s1):(peg$currPos=s0,s0=peg$FAILED)):(peg$currPos=s0,s0=peg$FAILED)):(peg$currPos=s0,s0=peg$FAILED),s0}function peg$parseFactor(){var s0,s1,s2,s3,s4,s5,s6,s7,s8,s9;if(s0=peg$currPos,40===input.charCodeAt(peg$currPos)?(s1=peg$c3,peg$currPos++):(s1=peg$FAILED,0===peg$silentFails&&peg$fail(peg$c4)),s1!==peg$FAILED)if(s2=peg$parse_(),s2!==peg$FAILED)if(s3=peg$parseTerm(),s3!==peg$FAILED)if(s4=peg$parse_(),s4!==peg$FAILED)if(41===input.charCodeAt(peg$currPos)?(s5=peg$c5,peg$currPos++):(s5=peg$FAILED,0===peg$silentFails&&peg$fail(peg$c6)),s5!==peg$FAILED){for(s6=[],s7=peg$currPos,s8=peg$parse_(),s8!==peg$FAILED?(input.substr(peg$currPos,2)===peg$c7?(s9=peg$c7,peg$currPos+=2):(s9=peg$FAILED,0===peg$silentFails&&peg$fail(peg$c8)),s9!==peg$FAILED?(s8=[s8,s9],s7=s8):(peg$currPos=s7,s7=peg$FAILED)):(peg$currPos=s7,s7=peg$FAILED);s7!==peg$FAILED;)s6.push(s7),s7=peg$currPos,s8=peg$parse_(),s8!==peg$FAILED?(input.substr(peg$currPos,2)===peg$c7?(s9=peg$c7,peg$currPos+=2):(s9=peg$FAILED,0===peg$silentFails&&peg$fail(peg$c8)),s9!==peg$FAILED?(s8=[s8,s9],s7=s8):(peg$currPos=s7,s7=peg$FAILED)):(peg$currPos=s7,s7=peg$FAILED);s6!==peg$FAILED?(peg$savedPos=s0,s1=peg$c9(s3,s6),s0=s1):(peg$currPos=s0,s0=peg$FAILED)}else peg$currPos=s0,s0=peg$FAILED;else peg$currPos=s0,s0=peg$FAILED;else peg$currPos=s0,s0=peg$FAILED;else peg$currPos=s0,s0=peg$FAILED;else peg$currPos=s0,s0=peg$FAILED;return s0===peg$FAILED&&(s0=peg$parseLiteral()),s0}function peg$parseLiteral(){var s0,s1,s2,s3,s4,s5;if(peg$silentFails++,s0=peg$currPos,s1=[],s2=peg$parsechar(),s2!==peg$FAILED)for(;s2!==peg$FAILED;)s1.push(s2),s2=peg$parsechar();else s1=peg$FAILED;if(s1!==peg$FAILED){for(s2=[],s3=peg$currPos,s4=peg$parse_(),s4!==peg$FAILED?(input.substr(peg$currPos,2)===peg$c7?(s5=peg$c7,peg$currPos+=2):(s5=peg$FAILED,0===peg$silentFails&&peg$fail(peg$c8)),s5!==peg$FAILED?(s4=[s4,s5],s3=s4):(peg$currPos=s3,s3=peg$FAILED)):(peg$currPos=s3,s3=peg$FAILED);s3!==peg$FAILED;)s2.push(s3),s3=peg$currPos,s4=peg$parse_(),s4!==peg$FAILED?(input.substr(peg$currPos,2)===peg$c7?(s5=peg$c7,peg$currPos+=2):(s5=peg$FAILED,0===peg$silentFails&&peg$fail(peg$c8)),s5!==peg$FAILED?(s4=[s4,s5],s3=s4):(peg$currPos=s3,s3=peg$FAILED)):(peg$currPos=s3,s3=peg$FAILED);s2!==peg$FAILED?(peg$savedPos=s0,s1=peg$c19(s1,s2),s0=s1):(peg$currPos=s0,s0=peg$FAILED)}else peg$currPos=s0,s0=peg$FAILED;return peg$silentFails--,s0===peg$FAILED&&(s1=peg$FAILED,0===peg$silentFails&&peg$fail(peg$c18)),s0}function peg$parse_(){var s0,s1;for(peg$silentFails++,s0=[],peg$c21.test(input.charAt(peg$currPos))?(s1=input.charAt(peg$currPos),peg$currPos++):(s1=peg$FAILED,0===peg$silentFails&&peg$fail(peg$c22));s1!==peg$FAILED;)s0.push(s1),peg$c21.test(input.charAt(peg$currPos))?(s1=input.charAt(peg$currPos),peg$currPos++):(s1=peg$FAILED,0===peg$silentFails&&peg$fail(peg$c22));return peg$silentFails--,s0===peg$FAILED&&(s1=peg$FAILED,0===peg$silentFails&&peg$fail(peg$c20)),s0}function peg$parsechar(){var s0;return peg$c23.test(input.charAt(peg$currPos))?(s0=input.charAt(peg$currPos),peg$currPos++):(s0=peg$FAILED,0===peg$silentFails&&peg$fail(peg$c24)),s0===peg$FAILED&&(95===input.charCodeAt(peg$currPos)?(s0=peg$c25,peg$currPos++):(s0=peg$FAILED,0===peg$silentFails&&peg$fail(peg$c26)),s0===peg$FAILED&&(45===input.charCodeAt(peg$currPos)?(s0=peg$c27,peg$currPos++):(s0=peg$FAILED,0===peg$silentFails&&peg$fail(peg$c28)),s0===peg$FAILED&&(46===input.charCodeAt(peg$currPos)?(s0=peg$c29,peg$currPos++):(s0=peg$FAILED,0===peg$silentFails&&peg$fail(peg$c30)),s0===peg$FAILED&&(peg$c31.test(input.charAt(peg$currPos))?(s0=input.charAt(peg$currPos),peg$currPos++):(s0=peg$FAILED,0===peg$silentFails&&peg$fail(peg$c32)),s0===peg$FAILED&&(peg$c33.test(input.charAt(peg$currPos))?(s0=input.charAt(peg$currPos),peg$currPos++):(s0=peg$FAILED,0===peg$silentFails&&peg$fail(peg$c34)),s0===peg$FAILED&&(63===input.charCodeAt(peg$currPos)?(s0=peg$c35,peg$currPos++):(s0=peg$FAILED,0===peg$silentFails&&peg$fail(peg$c36)))))))),s0}var peg$result,options=arguments.length>1?arguments[1]:{},peg$FAILED={},peg$startRuleFunctions={Term:peg$parseTerm},peg$startRuleFunction=peg$parseTerm,peg$c0="|",peg$c1={type:"literal",value:"|",description:'"|"'},peg$c2=function(first,rest){return rest?{type:"union",first:first,rest:rest[3]}:first},peg$c3="(",peg$c4={type:"literal",value:"(",description:'"("'},peg$c5=")",peg$c6={type:"literal",value:")",description:'")"'},peg$c7="[]",peg$c8={type:"literal",value:"[]",description:'"[]"'},peg$c9=function(expr,arr){return{type:"parens",expr:expr,arr:arr.length}},peg$c18={type:"other",description:"name"},peg$c19=function(r,c){return{type:"name",value:r.join(""),arr:c.length}},peg$c20={type:"other",description:"whitespace"},peg$c21=/^[ \t\n\r]/,peg$c22={type:"class",value:"[ \\t\\n\\r]",description:"[ \\t\\n\\r]"},peg$c23=/^[A-Z]/,peg$c24={type:"class",value:"[A-Z]",description:"[A-Z]"},peg$c25="_",peg$c26={type:"literal",value:"_",description:'"_"'},peg$c27="-",peg$c28={type:"literal",value:"-",description:'"-"'},peg$c29=".",peg$c30={type:"literal",value:".",description:'"."'},peg$c31=/^[a-z]/,peg$c32={type:"class",value:"[a-z]",description:"[a-z]"},peg$c33=/^[0-9]/,peg$c34={type:"class",value:"[0-9]",description:"[0-9]"},peg$c35="?",peg$c36={type:"literal",value:"?",description:'"?"'},peg$currPos=0,peg$savedPos=0,peg$posDetailsCache=[{line:1,column:1,seenCR:!1}],peg$maxFailPos=0,peg$maxFailExpected=[],peg$silentFails=0;if("startRule"in options){if(!(options.startRule in peg$startRuleFunctions))throw new Error("Can't start parsing from rule \""+options.startRule+'".');peg$startRuleFunction=peg$startRuleFunctions[options.startRule]}if(peg$result=peg$startRuleFunction(),peg$result!==peg$FAILED&&peg$currPos===input.length)return peg$result;throw peg$result!==peg$FAILED&&peg$currPos<input.length&&peg$fail({type:"end",description:"end of input"}),peg$buildException(null,peg$maxFailExpected,peg$maxFailPos<input.length?input.charAt(peg$maxFailPos):null,peg$maxFailPos<input.length?peg$computeLocation(peg$maxFailPos,peg$maxFailPos+1):peg$computeLocation(peg$maxFailPos,peg$maxFailPos))}return peg$subclass(peg$SyntaxError,Error),{SyntaxError:peg$SyntaxError,parse:peg$parse}}();module.exports=parser},function(module,exports,__webpack_require__){var lookup="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";!function(exports){"use strict";function decode(elt){var code=elt.charCodeAt(0);return code===PLUS||code===PLUS_URL_SAFE?62:code===SLASH||code===SLASH_URL_SAFE?63:code<NUMBER?-1:code<NUMBER+10?code-NUMBER+26+26:code<UPPER+26?code-UPPER:code<LOWER+26?code-LOWER+26:void 0}function b64ToByteArray(b64){function push(v){arr[L++]=v}var i,j,l,tmp,placeHolders,arr;if(b64.length%4>0)throw new Error("Invalid string. Length must be a multiple of 4");var len=b64.length;placeHolders="="===b64.charAt(len-2)?2:"="===b64.charAt(len-1)?1:0,arr=new Arr(3*b64.length/4-placeHolders),l=placeHolders>0?b64.length-4:b64.length;var L=0;for(i=0,j=0;i<l;i+=4,j+=3)tmp=decode(b64.charAt(i))<<18|decode(b64.charAt(i+1))<<12|decode(b64.charAt(i+2))<<6|decode(b64.charAt(i+3)),push((16711680&tmp)>>16),push((65280&tmp)>>8),push(255&tmp);return 2===placeHolders?(tmp=decode(b64.charAt(i))<<2|decode(b64.charAt(i+1))>>4,push(255&tmp)):1===placeHolders&&(tmp=decode(b64.charAt(i))<<10|decode(b64.charAt(i+1))<<4|decode(b64.charAt(i+2))>>2,push(tmp>>8&255),push(255&tmp)),arr}function uint8ToBase64(uint8){function encode(num){return lookup.charAt(num)}function tripletToBase64(num){return encode(num>>18&63)+encode(num>>12&63)+encode(num>>6&63)+encode(63&num)}var i,temp,length,extraBytes=uint8.length%3,output="";for(i=0,length=uint8.length-extraBytes;i<length;i+=3)temp=(uint8[i]<<16)+(uint8[i+1]<<8)+uint8[i+2],output+=tripletToBase64(temp);switch(extraBytes){case 1:temp=uint8[uint8.length-1],output+=encode(temp>>2),output+=encode(temp<<4&63),output+="==";break;case 2:temp=(uint8[uint8.length-2]<<8)+uint8[uint8.length-1],output+=encode(temp>>10),output+=encode(temp>>4&63),output+=encode(temp<<2&63),output+="="}return output}var Arr="undefined"!=typeof Uint8Array?Uint8Array:Array,PLUS="+".charCodeAt(0),SLASH="/".charCodeAt(0),NUMBER="0".charCodeAt(0),LOWER="a".charCodeAt(0),UPPER="A".charCodeAt(0),PLUS_URL_SAFE="-".charCodeAt(0),SLASH_URL_SAFE="_".charCodeAt(0);exports.toByteArray=b64ToByteArray,exports.fromByteArray=uint8ToBase64}("undefined"==typeof exports?this.base64js={}:exports)},function(module,exports,__webpack_require__){module.exports=[{code:"1xx",phrase:"**Informational**",description:'"indicates an interim response for communicating connection status or request progress prior to completing the requested action and sending a final response." ~ [sure](http://www.urbandictionary.com/define.php?term=sure)',spec_title:"RFC7231#6.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.2"},{code:"100",phrase:"Continue",description:'"indicates that the initial part of a request has been received and has not yet been rejected by the server."',spec_title:"RFC7231#6.2.1",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.2.1"},{code:"101",phrase:"Switching Protocols",description:'"indicates that the server understands and is willing to comply with the client\'s request, via the Upgrade header field, for a change in the application protocol being used on this connection."',spec_title:"RFC7231#6.2.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.2.2"},{code:"2xx",phrase:"**Successful**",description:'"indicates that the client\'s request was successfully received, understood, and accepted." ~ [cool](https://twitter.com/DanaDanger/status/183316183494311936)',
spec_title:"RFC7231#6.3",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.3"},{code:"200",phrase:"OK",description:'"indicates that the request has succeeded."',spec_title:"RFC7231#6.3.1",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.3.1"},{code:"201",phrase:"Created",description:'"indicates that the request has been fulfilled and has resulted in one or more new resources being created."',spec_title:"RFC7231#6.3.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.3.2"},{code:"202",phrase:"Accepted",description:'"indicates that the request has been accepted for processing, but the processing has not been completed."',spec_title:"RFC7231#6.3.3",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.3.3"},{code:"203",phrase:"Non-Authoritative Information",description:'"indicates that the request was successful but the enclosed payload has been modified from that of the origin server\'s 200 (OK) response by a transforming proxy."',spec_title:"RFC7231#6.3.4",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.3.4"},{code:"204",phrase:"No Content",description:'"indicates that the server has successfully fulfilled the request and that there is no additional content to send in the response payload body."',spec_title:"RFC7231#6.3.5",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.3.5"},{code:"205",phrase:"Reset Content",description:'"indicates that the server has fulfilled the request and desires that the user agent reset the "document view", which caused the request to be sent, to its original state as received from the origin server."',spec_title:"RFC7231#6.3.6",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.3.6"},{code:"206",phrase:"Partial Content",description:'"indicates that the server is successfully fulfilling a range request for the target resource by transferring one or more parts of the selected representation that correspond to the satisfiable ranges found in the requests\'s Range header field."',spec_title:"RFC7233#4.1",spec_href:"http://tools.ietf.org/html/rfc7233#section-4.1"},{code:"3xx",phrase:"**Redirection**",description:'"indicates that further action needs to be taken by the user agent in order to fulfill the request." ~ [ask that dude over there](https://twitter.com/DanaDanger/status/183316183494311936)',spec_title:"RFC7231#6.4",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.4"},{code:"300",phrase:"Multiple Choices",description:'"indicates that the target resource has more than one representation, each with its own more specific identifier, and information about the alternatives is being provided so that the user (or user agent) can select a preferred representation by redirecting its request to one or more of those identifiers."',spec_title:"RFC7231#6.4.1",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.4.1"},{code:"301",phrase:"Moved Permanently",description:'"indicates that the target resource has been assigned a new permanent URI and any future references to this resource ought to use one of the enclosed URIs."',spec_title:"RFC7231#6.4.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.4.2"},{code:"302",phrase:"Found",description:'"indicates that the target resource resides temporarily under a different URI."',spec_title:"RFC7231#6.4.3",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.4.3"},{code:"303",phrase:"See Other",description:'"indicates that the server is redirecting the user agent to a different resource, as indicated by a URI in the Location header field, that is intended to provide an indirect response to the original request."',spec_title:"RFC7231#6.4.4",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.4.4"},{code:"304",phrase:"Not Modified",description:'"indicates that a conditional GET request has been received and would have resulted in a 200 (OK) response if it were not for the fact that the condition has evaluated to false."',spec_title:"RFC7232#4.1",spec_href:"http://tools.ietf.org/html/rfc7232#section-4.1"},{code:"305",phrase:"Use Proxy",description:"*deprecated*",spec_title:"RFC7231#6.4.5",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.4.5"},{code:"307",phrase:"Temporary Redirect",description:'"indicates that the target resource resides temporarily under a different URI and the user agent MUST NOT change the request method if it performs an automatic redirection to that URI."',spec_title:"RFC7231#6.4.7",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.4.7"},{code:"4xx",phrase:"**Client Error**",description:'"indicates that the client seems to have erred." ~ [*you* fucked up](https://twitter.com/DanaDanger/status/183316183494311936)',spec_title:"RFC7231#6.5",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5"},{code:"400",phrase:"Bad Request",description:'"indicates that the server cannot or will not process the request because the received syntax is invalid, nonsensical, or exceeds some limitation on what the server is willing to process."',spec_title:"RFC7231#6.5.1",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.1"},{code:"401",phrase:"Unauthorized",description:'"indicates that the request has not been applied because it lacks valid authentication credentials for the target resource."',spec_title:"RFC7235#6.3.1",spec_href:"http://tools.ietf.org/html/rfc7235#section-3.1"},{code:"402",phrase:"Payment Required",description:"*reserved*",spec_title:"RFC7231#6.5.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.2"},{code:"403",phrase:"Forbidden",description:'"indicates that the server understood the request but refuses to authorize it."',spec_title:"RFC7231#6.5.3",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.3"},{code:"404",phrase:"Not Found",description:'"indicates that the origin server did not find a current representation for the target resource or is not willing to disclose that one exists."',spec_title:"RFC7231#6.5.4",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.4"},{code:"405",phrase:"Method Not Allowed",description:'"indicates that the method specified in the request-line is known by the origin server but not supported by the target resource."',spec_title:"RFC7231#6.5.5",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.5"},{code:"406",phrase:"Not Acceptable",description:'"indicates that the target resource does not have a current representation that would be acceptable to the user agent, according to the proactive negotiation header fields received in the request, and the server is unwilling to supply a default representation."',spec_title:"RFC7231#6.5.6",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.6"},{code:"407",phrase:"Proxy Authentication Required",description:'"is similar to 401 (Unauthorized), but indicates that the client needs to authenticate itself in order to use a proxy."',spec_title:"RFC7231#6.3.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.3.2"},{code:"408",phrase:"Request Timeout",description:'"indicates that the server did not receive a complete request message within the time that it was prepared to wait."',spec_title:"RFC7231#6.5.7",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.7"},{code:"409",phrase:"Conflict",description:'"indicates that the request could not be completed due to a conflict with the current state of the resource."',spec_title:"RFC7231#6.5.8",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.8"},{code:"410",phrase:"Gone",description:'"indicates that access to the target resource is no longer available at the origin server and that this condition is likely to be permanent."',spec_title:"RFC7231#6.5.9",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.9"},{code:"411",phrase:"Length Required",description:'"indicates that the server refuses to accept the request without a defined Content-Length."',spec_title:"RFC7231#6.5.10",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.10"},{code:"412",phrase:"Precondition Failed",description:'"indicates that one or more preconditions given in the request header fields evaluated to false when tested on the server."',spec_title:"RFC7232#4.2",spec_href:"http://tools.ietf.org/html/rfc7232#section-4.2"},{code:"413",phrase:"Payload Too Large",description:'"indicates that the server is refusing to process a request because the request payload is larger than the server is willing or able to process."',spec_title:"RFC7231#6.5.11",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.11"},{code:"414",phrase:"URI Too Long",description:'"indicates that the server is refusing to service the request because the request-target is longer than the server is willing to interpret."',spec_title:"RFC7231#6.5.12",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.12"},{code:"415",phrase:"Unsupported Media Type",description:'"indicates that the origin server is refusing to service the request because the payload is in a format not supported by the target resource for this method."',spec_title:"RFC7231#6.5.13",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.13"},{code:"416",phrase:"Range Not Satisfiable",description:'"indicates that none of the ranges in the request\'s Range header field overlap the current extent of the selected resource or that the set of ranges requested has been rejected due to invalid ranges or an excessive request of small or overlapping ranges."',spec_title:"RFC7233#4.4",spec_href:"http://tools.ietf.org/html/rfc7233#section-4.4"},{code:"417",phrase:"Expectation Failed",description:'"indicates that the expectation given in the request\'s Expect header field could not be met by at least one of the inbound servers."',spec_title:"RFC7231#6.5.14",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.14"},{code:"426",phrase:"Upgrade Required",description:'"indicates that the server refuses to perform the request using the current protocol but might be willing to do so after the client upgrades to a different protocol."',spec_title:"RFC7231#6.5.15",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.15"},{code:"5xx",phrase:"**Server Error**",description:'"indicates that the server is aware that it has erred or is incapable of performing the requested method." ~ [*we* fucked up](https://twitter.com/DanaDanger/status/183316183494311936)',spec_title:"RFC7231#6.6",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.6"},{code:"500",phrase:"Internal Server Error",description:'"indicates that the server encountered an unexpected condition that prevented it from fulfilling the request."',spec_title:"RFC7231#6.6.1",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.6.1"},{code:"501",phrase:"Not Implemented",description:'"indicates that the server does not support the functionality required to fulfill the request."',spec_title:"RFC7231#6.6.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.6.2"},{code:"502",phrase:"Bad Gateway",description:'"indicates that the server, while acting as a gateway or proxy, received an invalid response from an inbound server it accessed while attempting to fulfill the request."',spec_title:"RFC7231#6.6.3",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.6.3"},{code:"503",phrase:"Service Unavailable",description:'"indicates that the server is currently unable to handle the request due to a temporary overload or scheduled maintenance, which will likely be alleviated after some delay."',spec_title:"RFC7231#6.6.4",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.6.4"},{code:"504",phrase:"Gateway Time-out",description:'"indicates that the server, while acting as a gateway or proxy, did not receive a timely response from an upstream server it needed to access in order to complete the request."',spec_title:"RFC7231#6.6.5",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.6.5"},{code:"505",phrase:"HTTP Version Not Supported",description:'"indicates that the server does not support, or refuses to support, the protocol version that was used in the request message."',spec_title:"RFC7231#6.6.6",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.6.6"},{code:"102",phrase:"Processing",description:'"is an interim response used to inform the client that the server has accepted the complete request, but has not yet completed it."',spec_title:"RFC5218#10.1",spec_href:"http://tools.ietf.org/html/rfc2518#section-10.1"},{code:"207",phrase:"Multi-Status",description:'"provides status for multiple independent operations."',spec_title:"RFC5218#10.2",spec_href:"http://tools.ietf.org/html/rfc2518#section-10.2"},{code:"226",phrase:"IM Used",description:'"The server has fulfilled a GET request for the resource, and the response is a representation of the result of one or more instance-manipulations applied to the current instance."',spec_title:"RFC3229#10.4.1",spec_href:"http://tools.ietf.org/html/rfc3229#section-10.4.1"},{code:"308",phrase:"Permanent Redirect",description:'"The target resource has been assigned a new permanent URI and any future references to this resource SHOULD use one of the returned URIs. [...] This status code is similar to 301 Moved Permanently (Section 7.3.2 of rfc7231), except that it does not allow rewriting the request method from POST to GET."',spec_title:"RFC7238",spec_href:"http://tools.ietf.org/html/rfc7238"},{code:"422",phrase:"Unprocessable Entity",description:'"means the server understands the content type of the request entity (hence a 415(Unsupported Media Type) status code is inappropriate), and the syntax of the request entity is correct (thus a 400 (Bad Request) status code is inappropriate) but was unable to process the contained instructions."',spec_title:"RFC5218#10.3",spec_href:"http://tools.ietf.org/html/rfc2518#section-10.3"},{code:"423",phrase:"Locked",description:'"means the source or destination resource of a method is locked."',spec_title:"RFC5218#10.4",spec_href:"http://tools.ietf.org/html/rfc2518#section-10.4"},{code:"424",phrase:"Failed Dependency",description:'"means that the method could not be performed on the resource because the requested action depended on another action and that action failed."',spec_title:"RFC5218#10.5",spec_href:"http://tools.ietf.org/html/rfc2518#section-10.5"},{code:"428",phrase:"Precondition Required",description:'"indicates that the origin server requires the request to be conditional."',spec_title:"RFC6585#3",spec_href:"http://tools.ietf.org/html/rfc6585#section-3"},{code:"429",phrase:"Too Many Requests",description:'"indicates that the user has sent too many requests in a given amount of time ("rate limiting")."',spec_title:"RFC6585#4",spec_href:"http://tools.ietf.org/html/rfc6585#section-4"},{code:"431",phrase:"Request Header Fields Too Large",description:'"indicates that the server is unwilling to process the request because its header fields are too large."',spec_title:"RFC6585#5",spec_href:"http://tools.ietf.org/html/rfc6585#section-5"},{code:"451",phrase:"Unavailable For Legal Reasons",description:'"This status code indicates that the server is denying access to the resource in response to a legal demand."',spec_title:"draft-tbray-http-legally-restricted-status",spec_href:"http://tools.ietf.org/html/draft-tbray-http-legally-restricted-status"},{code:"506",phrase:"Variant Also Negotiates",description:'"indicates that the server has an internal configuration error: the chosen variant resource is configured to engage in transparent content negotiation itself, and is therefore not a proper end point in the negotiation process."',spec_title:"RFC2295#8.1",spec_href:"http://tools.ietf.org/html/rfc2295#section-8.1"},{code:"507",phrase:"Insufficient Storage",description:'"means the method could not be performed on the resource because the server is unable to store the representation needed to successfully complete the request."',spec_title:"RFC5218#10.6",spec_href:"http://tools.ietf.org/html/rfc2518#section-10.6"},{code:"511",phrase:"Network Authentication Required",description:'"indicates that the client needs to authenticate to gain network access."',spec_title:"RFC6585#6",spec_href:"http://tools.ietf.org/html/rfc6585#section-6"},{code:"7xx",phrase:"**Developer Error**",description:"[err](http://www.urbandictionary.com/define.php?term=err)",spec_title:"7xx-rfc",spec_href:"http://documentup.com/joho/7XX-rfc"}]},function(module,exports,__webpack_require__){module.exports=[{method:"CONNECT",description:'"requests that the recipient establish a tunnel to the destination origin server identified by the request-target and, if successful, thereafter restrict its behavior to blind forwarding of packets, in both directions, until the connection is closed."',safe:!0,idempotent:!0,cacheable:!1,spec_title:"RFC7231#4.3.6",spec_href:"http://tools.ietf.org/html/rfc7231#section-4.3.6"},{method:"DELETE",description:'"requests that the origin server remove the association between the target resource and its current functionality."',safe:!1,idempotent:!0,cacheable:!1,spec_title:"RFC7231#4.3.5",spec_href:"http://tools.ietf.org/html/rfc7231#section-4.3.5"},{method:"GET",description:'"requests transfer of a current selected representation for the target resource."',safe:!0,idempotent:!0,cacheable:!0,spec_title:"RFC7231#4.3.1",spec_href:"http://tools.ietf.org/html/rfc7231#section-4.3.1"},{method:"HEAD",description:'"is identical to GET except that the server MUST NOT send a message body in the response (i.e., the response terminates at the end of the header block)."',safe:!0,idempotent:!0,cacheable:!0,spec_title:"RFC7231#4.3.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-4.3.2"},{method:"OPTIONS",description:'"requests information about the communication options available on the request/response chain identified by the effective request URI."',safe:!0,idempotent:!0,cacheable:!1,spec_title:"RFC7231#4.3.7",spec_href:"http://tools.ietf.org/html/rfc7231#section-4.3.7"},{method:"POST",description:'"requests that the target resource process the representation enclosed in the request according to the resource\'s own specific semantics."',safe:!1,idempotent:!1,cacheable:!1,spec_title:"RFC7231#4.3.3",spec_href:"http://tools.ietf.org/html/rfc7231#section-4.3.3"},{method:"PUT",description:'"requests that the state of the target resource be created or replaced with the state defined by the representation enclosed in the request message payload."',safe:!1,idempotent:!0,cacheable:!1,spec_title:"RFC7231#4.3.4",spec_href:"http://tools.ietf.org/html/rfc7231#section-4.3.4"},{method:"TRACE",description:'"is used to invoke a remote, application-layer loopback of the request message."',safe:!0,idempotent:!0,cacheable:!1,spec_title:"RFC7231#4.3.8",spec_href:"http://tools.ietf.org/html/rfc7231#section-4.3.8"},{method:"ACL",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3744#8.1",spec_href:"http://tools.ietf.org/html/rfc3744#section-8.1"},{method:"BASELINE-CONTROL",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#12.6",spec_href:"http://tools.ietf.org/html/rfc3253#section-12.6"},{method:"BIND",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC5842#4",spec_href:"http://tools.ietf.org/html/rfc5842#section-4"},{method:"CHECKIN",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#4.4",spec_href:"http://tools.ietf.org/html/rfc3253#section-4.4"},{method:"CHECKOUT",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#4.3",spec_href:"http://tools.ietf.org/html/rfc3253#section-4.3"},{method:"COPY",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC4918#9.8",spec_href:"http://tools.ietf.org/html/rfc4918#section-9.8"},{method:"LABEL",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#8.2",spec_href:"http://tools.ietf.org/html/rfc3253#section-8.2"},{method:"LINK",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC2068#19.6.1.2",spec_href:"http://tools.ietf.org/html/rfc2068#section-19.6.1.2"},{method:"LOCK",description:"",safe:!1,idempotent:!1,cacheable:"",spec_title:"RFC4918#9.10",spec_href:"http://tools.ietf.org/html/rfc4918#section-9.10"},{method:"MERGE",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#11.2",spec_href:"http://tools.ietf.org/html/rfc3253#section-11.2"},{method:"MKACTIVITY",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#13.5",spec_href:"http://tools.ietf.org/html/rfc3253#section-13.5"},{method:"MKCALENDAR",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC4791#5.3.1",spec_href:"http://tools.ietf.org/html/rfc4791#section-5.3.1"},{method:"MKCOL",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC4918#9.3",spec_href:"http://tools.ietf.org/html/rfc4918#section-9.3"},{method:"MKREDIRECTREF",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC4437#6",spec_href:"http://tools.ietf.org/html/rfc4437#section-6"},{method:"MKWORKSPACE",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#6.3",spec_href:"http://tools.ietf.org/html/rfc3253#section-6.3"},{method:"MOVE",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC4918#9.9",spec_href:"http://tools.ietf.org/html/rfc4918#section-9.9"},{method:"ORDERPATCH",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3648#7",spec_href:"http://tools.ietf.org/html/rfc3648#section-7"},{method:"PATCH",description:'"requests that a set of changes described in the request entity be applied to the resource identified by the Request-URI."',safe:!1,idempotent:!1,cacheable:!1,spec_title:"RFC5789",spec_href:"http://tools.ietf.org/html/rfc5789#section-2"},{method:"PROPFIND",description:"",safe:!0,idempotent:!0,cacheable:"",spec_title:"RFC4918#9.1",spec_href:"http://tools.ietf.org/html/rfc4918#section-9.1"},{method:"PROPPATCH",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC4918#9.2",spec_href:"http://tools.ietf.org/html/rfc4918#section-9.2"},{method:"REBIND",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC5842#6",spec_href:"http://tools.ietf.org/html/rfc5842#section-6"},{method:"REPORT",description:"",safe:!0,idempotent:!0,cacheable:"",spec_title:"RFC3253#3.6",spec_href:"http://tools.ietf.org/html/rfc3253#section-3.6"},{method:"SEARCH",description:"",safe:!0,idempotent:!0,cacheable:"",spec_title:"RFC5323#2",spec_href:"http://tools.ietf.org/html/rfc5323#section-2"},{method:"UNBIND",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC5842#5",spec_href:"http://tools.ietf.org/html/rfc5842#section-5"},{method:"UNCHECKOUT",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#4.5",spec_href:"http://tools.ietf.org/html/rfc3253#section-4.5"},{method:"UNLINK",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC2068#19.6.1.3",spec_href:"http://tools.ietf.org/html/rfc2068#section-19.6.1.3"},{method:"UNLOCK",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC4918#9.11",spec_href:"http://tools.ietf.org/html/rfc4918#section-9.11"},{method:"UPDATE",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#7.1",spec_href:"http://tools.ietf.org/html/rfc3253#section-7.1"},{method:"UPDATEREDIRECTREF",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC4437#7",spec_href:"http://tools.ietf.org/html/rfc4437#section-7"},{method:"VERSION-CONTROL",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#3.5",spec_href:"http://tools.ietf.org/html/rfc3253#section-3.5"}]},function(module,exports,__webpack_require__){module.exports=[{header:"Content-Encoding",description:'"indicates what content codings have been applied to the representation, beyond those inherent in the media type, and thus what decoding mechanisms have to be applied in order to obtain data in the media type referenced by the Content-Type header field."',spec_title:"RFC7231#3.1.2.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-3.1.2.2"},{header:"Content-Language",description:'"describes the natural language(s) of the intended audience for the representation."',spec_title:"RFC7231#3.1.3.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-3.1.3.2"},{header:"Content-Location",description:'"references a URI that can be used as an identifier for a specific resource corresponding to the representation in this message\'s payload."',spec_title:"RFC7231#3.1.4.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-3.1.4.2"},{header:"Content-Type",description:'"indicates the media type of the associated representation: either the representation enclosed in the message payload or the selected representation, as determined by the message semantics."',spec_title:"RFC7231#3.1.1.5",spec_href:"http://tools.ietf.org/html/rfc7231#section-3.1.1.5"},{header:"Content-Length",description:'"can provide the anticipated size, as a decimal number of octets, for a potential payload body."',spec_title:"RFC7230#3.3.2",spec_href:"http://tools.ietf.org/html/rfc7230#section-3.3.2"},{header:"Content-Range",description:'"is sent in a single part 206 (Partial Content) response to indicate the partial range of the selected representation enclosed as the message payload, sent in each part of a multipart 206 response to indicate the range enclosed within each body part, and sent in 416 (Range Not Satisfiable) responses to provide information about the selected representation."',spec_title:"RFC7233#4.2",spec_href:"http://tools.ietf.org/html/rfc7233#section-4.2"},{header:"Transfer-Encoding",description:'"lists the transfer coding names corresponding to the sequence of transfer codings that have been (or will be) applied to the payload body in order to form the message body."',spec_title:"RFC7230#3.3.1",spec_href:"http://tools.ietf.org/html/rfc7230#section-3.3.1"},{header:"Cache-Control",description:'"is used to specify directives for caches along the request/response chain."',spec_title:"RFC7234#7.2",spec_href:"http://tools.ietf.org/html/rfc7234#section-7.2"},{header:"Expect",description:'"is used to indicate that particular server behaviors are required by the client."',spec_title:"RFC7231#5.1.1",spec_href:"http://tools.ietf.org/html/rfc7231#section-5.1.1"},{header:"Host",description:'"provides the host and port information from the target URI, enabling the origin server to distinguish among resources while servicing requests for multiple host names on a single IP address."',spec_title:"RFC7230#5.4",spec_href:"http://tools.ietf.org/html/rfc7230#section-5.4"},{header:"Max-Forwards",description:'"provides a mechanism with the TRACE and OPTIONS methods to limit the number of times that the request is forwarded by proxies."',spec_title:"RFC7231#5.1.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-5.1.2"},{header:"Pragma",description:'"allows backwards compatibility with HTTP/1.0 caches, so that clients can specify a "no-cache" request that they will understand (as Cache-Control was not defined until HTTP/1.1)."',spec_title:"RFC7234#7.4",spec_href:"http://tools.ietf.org/html/rfc7234#section-7.4"},{header:"Range",description:'"modifies the method semantics to request transfer of only one or more subranges of the selected representation data, rather than the entire selected representation data."',spec_title:"RFC7233#3.1",spec_href:"http://tools.ietf.org/html/rfc7233#section-3.1"},{header:"TE",description:'"indicates what transfer codings, besides chunked, the client is willing to accept in response, and whether or not the client is willing to accept trailer fields in a chunked transfer coding."',spec_title:"RFC7230#4.3",spec_href:"http://tools.ietf.org/html/rfc7230#section-4.3"},{header:"If-Match",description:'"can be used to make a request method conditional on the current existence or value of an entity-tag for one or more representations of the target resource."',spec_title:"RFC7232#3.1",spec_href:"http://tools.ietf.org/html/rfc7232#section-3.1"},{header:"If-Modified-Since",description:'"can be used with GET or HEAD to make the method conditional by modification date: if the selected representation has not been modified since the time specified in this field, then do not perform the request method; instead, respond as detailed below."',spec_title:"RFC7232#3.3",spec_href:"http://tools.ietf.org/html/rfc7232#section-3.3"},{header:"If-None-Match",description:'"can be used to make a request method conditional on not matching any of the current entity-tag values for representations of the target resource."',spec_title:"RFC7232#3.2",spec_href:"http://tools.ietf.org/html/rfc7232#section-3.2"},{header:"If-Range",description:'"Informally, its meaning is: if the representation is unchanged, send me the part(s) that I am requesting in Range; otherwise, send me the entire representation."',spec_title:"RFC7233#3.2",spec_href:"http://tools.ietf.org/html/rfc7233#section-3.2"},{header:"If-Unmodified-Since",description:'"can be used to make a request method conditional by modification date: if the selected representation has been modified since the time specified in this field, then the server MUST NOT perform the requested operation and MUST instead respond with the 412 (Precondition Failed) status code."',spec_title:"RFC7232#3.4",spec_href:"http://tools.ietf.org/html/rfc7232#section-3.4"},{header:"Accept",description:'"can be used to specify certain media types which are acceptable for the response."',spec_title:"RFC7231#5.3.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-5.3.2"},{header:"Accept-Charset",description:'"can be sent by a user agent to indicate what charsets are acceptable in textual response content."',spec_title:"RFC7231#5.3.3",spec_href:"http://tools.ietf.org/html/rfc7231#section-5.3.3"},{header:"Accept-Encoding",description:'"can be used by user agents to indicate what response content-codings are acceptable in the response."',spec_title:"RFC7231#5.3.4",spec_href:"http://tools.ietf.org/html/rfc7231#section-5.3.4"},{header:"Accept-Language",description:'"can be used by user agents to indicate the set of natural languages that are preferred in the response."',spec_title:"RFC7231#5.3.5",spec_href:"http://tools.ietf.org/html/rfc7231#section-5.3.5"},{header:"Authorization",description:'"allows a user agent to authenticate itself with a server -- usually, but not necessarily, after receiving a 401 (Unauthorized) response."',spec_title:"RFC7235#4.1",spec_href:"http://tools.ietf.org/html/rfc7235#section-4.1"},{header:"Proxy-Authorization",description:'"allows the client to identify itself (or its user) to a proxy that requires authentication."',spec_title:"RFC7235#4.3",spec_href:"http://tools.ietf.org/html/rfc7235#section-4.3"},{header:"DNT",description:'"defined as the means for expressing a user\'s tracking preference via HTTP."',spec_title:"Tracking Preference Expression (DNT)",spec_href:"http://www.w3.org/TR/tracking-dnt/#dnt-header-field"},{header:"From",description:'"contains an Internet email address for a human user who controls the requesting user agent."',spec_title:"RFC7231#5.5.1",spec_href:"http://tools.ietf.org/html/rfc7231#section-5.5.1"},{header:"Referer",description:'"allows the user agent to specify a URI reference for the resource from which the target URI was obtained (i.e., the "referrer", though the field name is misspelled)."',spec_title:"RFC7231#5.5.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-5.5.2"},{header:"User-Agent",description:'"contains information about the user agent originating the request, which is often used by servers to help identify the scope of reported interoperability problems, to work around or tailor responses to avoid particular user agent limitations, and for analytics regarding browser or operating system use."',spec_title:"RFC7231#5.5.3",spec_href:"http://tools.ietf.org/html/rfc7231#section-5.5.3"},{header:"Age",description:'"conveys the sender\'s estimate of the amount of time since the response was generated or successfully validated at the origin server."',spec_title:"RFC7234#5.1",spec_href:"http://tools.ietf.org/html/rfc7234#section-5.1"},{header:"Cache-Control",
description:'"is used to specify directives for caches along the request/response chain."',spec_title:"RFC7234#7.2",spec_href:"http://tools.ietf.org/html/rfc7234#section-7.2"},{header:"Expires",description:'"gives the date/time after which the response is considered stale."',spec_title:"RFC7234#7.3",spec_href:"http://tools.ietf.org/html/rfc7234#section-7.3"},{header:"Date",description:'"represents the date and time at which the message was originated"',spec_title:"RFC7231#7.1.1.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-7.1.1.2"},{header:"Location",description:'"is used in some responses to refer to a specific resource in relation to the response."',spec_title:"RFC7231#7.1.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-7.1.2"},{header:"Retry-After",description:'"indicates how long the user agent ought to wait before making a follow-up request."',spec_title:"RFC7231#7.1.3",spec_href:"http://tools.ietf.org/html/rfc7231#section-7.1.3"},{header:"Tk",description:'"defined as an OPTIONAL means for indicating the tracking status that applied to the corresponding request and as a REQUIRED means for indicating that a state-changing request has resulted in an interactive change to the tracking status. "',spec_title:"Tracking Preference Expression (DNT)",spec_href:"http://www.w3.org/TR/tracking-dnt/#response-header-field"},{header:"Vary",description:'"describes what parts of a request message, aside from the method and request target, might influence the origin server\'s process for selecting and representing the response."',spec_title:"RFC7231#7.1.4",spec_href:"http://tools.ietf.org/html/rfc7231#section-7.1.4"},{header:"Warning",description:'"is used to carry additional information about the status or transformation of a message that might not be reflected in the message."',spec_title:"RFC7234#7.6",spec_href:"http://tools.ietf.org/html/rfc7234#section-7.6"},{header:"ETag",description:'"provides the current entity-tag for the selected representation, as determined at the conclusion of handling the request."',spec_title:"RFC7232#2.3",spec_href:"http://tools.ietf.org/html/rfc7232#section-2.3"},{header:"Last-Modified",description:'"provides a timestamp indicating the date and time at which the origin server believes the selected representation was last modified, as determined at the conclusion of handling the request."',spec_title:"RFC7232#2.2",spec_href:"http://tools.ietf.org/html/rfc7232#section-2.2"},{header:"WWW-Authenticate",description:'"consists of at least one challenge that indicates the authentication scheme(s) and parameters applicable to the effective request URI."',spec_title:"RFC7235#4.4",spec_href:"http://tools.ietf.org/html/rfc7235#section-4.4"},{header:"Proxy-Authenticate",description:'"consists of at least one challenge that indicates the authentication scheme(s) and parameters applicable to the proxy for this effective request URI."',spec_title:"RFC7235#4.2",spec_href:"http://tools.ietf.org/html/rfc7235#section-4.2"},{header:"Accept-Ranges",description:'"allows a server to indicate that it supports range requests for the target resource."',spec_title:"RFC7233#2.3",spec_href:"http://tools.ietf.org/html/rfc7233#section-2.3"},{header:"Allow",description:'"lists the set of methods advertised as supported by the target resource."',spec_title:"RFC7231#7.4.1",spec_href:"http://tools.ietf.org/html/rfc7231#section-7.4.1"},{header:"Server",description:'"contains information about the software used by the origin server to handle the request, which is often used by clients to help identify the scope of reported interoperability problems, to work around or tailor requests to avoid particular server limitations, and for analytics regarding server or operating system use."',spec_title:"RFC7231#7.4.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-7.4.2"},{header:"Accept-Patch",description:'"used to specify the patch document formats accepted by the server."',spec_title:"RFC5789#3.1",spec_href:"http://tools.ietf.org/html/rfc5789#section-3.1"},{header:"Accept-Post",description:'"indicates server support for specific media types for entity bodies in HTTP POST requests."',spec_title:"draft-wilde-accept-post",spec_href:"http://tools.ietf.org/html/draft-wilde-accept-post"},{header:"Access-Control-Allow-Credentials",description:'"indicates whether the response to request can be exposed when the omit credentials flag is unset"',spec_title:"CORS",spec_href:"http://www.w3.org/TR/cors/#access-control-allow-credentials-response-header"},{header:"Access-Control-Allow-Headers",description:'"indicates, as part of the response to a preflight request, which header field names can be used during the actual request"',spec_title:"CORS",spec_href:"http://www.w3.org/TR/cors/#access-control-allow-headers-response-header"},{header:"Access-Control-Allow-Methods",description:'"indicates, as part of the response to a preflight request, which methods can be used during the actual request"',spec_title:"CORS",spec_href:"http://www.w3.org/TR/cors/#access-control-allow-methods-response-header"},{header:"Access-Control-Allow-Origin",description:'"indicates whether a resource can be shared"',spec_title:"CORS",spec_href:"http://www.w3.org/TR/cors/#access-control-allow-origin-response-header"},{header:"Access-Control-Expose-Headers",description:'"indicates which headers are safe to expose to the API of a CORS API specification"',spec_title:"CORS",spec_href:"http://www.w3.org/TR/cors/#access-control-expose-headers-response-header"},{header:"Access-Control-Max-Age",description:'"indicates how long the results of a preflight request can be cached in a preflight result cache"',spec_title:"CORS",spec_href:"http://www.w3.org/TR/cors/#access-control-max-age-response-header"},{header:"Access-Control-Request-Headers",description:'"indicates which headers will be used in the actual request as part of the preflight request"',spec_title:"CORS",spec_href:"http://www.w3.org/TR/cors/#access-control-request-headers-request-header"},{header:"Access-Control-Request-Method",description:'"indicates which method will be used in the actual request as part of the preflight request"',spec_title:"CORS",spec_href:"http://www.w3.org/TR/cors/#access-control-request-method-request-header"},{header:"Content-Disposition",description:'"standard"',spec_title:"RFC6266",spec_href:"http://tools.ietf.org/html/rfc6266"},{header:"Content-Security-Policy",description:'"is the preferred mechanism for delivering a CSP policy"',spec_title:"CSP",spec_href:"http://www.w3.org/TR/CSP/#content-security-policy-header-field"},{header:"Content-Security-Policy-Report-Only",description:'"lets servers experiment with policies by monitoring (rather than enforcing) a policy"',spec_title:"CSP",spec_href:"http://www.w3.org/TR/CSP/#content-security-policy-report-only-header-field"},{header:"Cookie",description:'"standard"',spec_title:"RFC6265",spec_href:"http://tools.ietf.org/html/rfc6265"},{header:"Forwarded",description:'"standard"',spec_title:"RFC7239",spec_href:"http://tools.ietf.org/html/rfc7239"},{header:"Link",description:'"provides a means for serialising one or more links in HTTP headers."',spec_title:"RFC5988#5",spec_href:"http://tools.ietf.org/html/rfc5988#section-5"},{header:"Origin",description:'"standard"',spec_title:"RFC6454",spec_href:"http://tools.ietf.org/html/rfc6454"},{header:"Prefer",description:'"is used to indicate that particular server behaviors are preferred by the client, but not required for successful completion of the request."',spec_title:"draft-snell-http-prefer#2",spec_href:"http://tools.ietf.org/html/draft-snell-http-prefer#section-2"},{header:"Preference-Applied",description:'"MAY be included within a response message as an indication as to which Prefer tokens were honored by the server and applied to the processing of a request."',spec_title:"draft-snell-http-prefer#3",spec_href:"http://tools.ietf.org/html/draft-snell-http-prefer#section-3"},{header:"Set-Cookie",description:'"standard"',spec_title:"RFC6265",spec_href:"http://tools.ietf.org/html/rfc6265"},{header:"Strict-Transport-Security",description:'"standard"',spec_title:"RFC6797",spec_href:"http://tools.ietf.org/html/rfc6797"},{header:"Via",description:'""',spec_title:"RFC7230#5.7.1",spec_href:"http://tools.ietf.org/html/rfc7230#section-5.7.1"},{header:"A-IM",description:'""',spec_title:"RFC3229#10.5.3",spec_href:"http://tools.ietf.org/html/rfc3229#section-10.5.3"},{header:"Accept-Features",description:'"can be used by a user agent to give information about the presence or absence of certain features in the feature set of the current request."',spec_title:"RFC2295#8.2",spec_href:"http://tools.ietf.org/html/rfc2295#section-8.2"},{header:"Alt-Svc",description:'"is advertising the availability of alternate services to HTTP/1.1 and HTTP/2.0 clients by adding an Alt-Svc header field to responses."',spec_title:"draft-nottingham-httpbis-alt-svc",spec_href:"http://tools.ietf.org/html/draft-nottingham-httpbis-alt-svc"},{header:"Alternates",description:'"is used to convey the list of variants bound to a negotiable resource."',spec_title:"RFC2295#8.3",spec_href:"http://tools.ietf.org/html/rfc2295#section-8.3"},{header:"Apply-To-Redirect-Ref",description:'""',spec_title:"RFC4437",spec_href:"http://tools.ietf.org/html/rfc4437"},{header:"CH",description:'"describes an example list of client preferences that the server can use to adapt and optimize the resource to satisfy a given request."',spec_title:"draft-grigorik-http-client-hints",spec_href:"http://tools.ietf.org/html/draft-grigorik-http-client-hints"},{header:"Content-Base",description:'"obsoleted"',spec_title:"RFC2068",spec_href:"http://tools.ietf.org/html/rfc2068"},{header:"Cookie2",description:'"obsoleted"',spec_title:"RFC2965",spec_href:"http://tools.ietf.org/html/rfc2965"},{header:"DASL",description:'"standard"',spec_title:"RFC5323",spec_href:"http://tools.ietf.org/html/rfc5323"},{header:"DAV",description:'"standard"',spec_title:"RFC4918",spec_href:"http://tools.ietf.org/html/rfc4918"},{header:"Delta-Base",description:'""',spec_title:"RFC3229#10.5.1",spec_href:"http://tools.ietf.org/html/rfc3229#section-10.5.1"},{header:"Depth",description:'"standard"',spec_title:"RFC4918",spec_href:"http://tools.ietf.org/html/rfc4918"},{header:"Destination",description:'"standard"',spec_title:"RFC4918",spec_href:"http://tools.ietf.org/html/rfc4918"},{header:"IM",description:'""',spec_title:"RFC3229#10.5.2",spec_href:"http://tools.ietf.org/html/rfc3229#section-10.5.2"},{header:"If",description:'"standard"',spec_title:"RFC4918",spec_href:"http://tools.ietf.org/html/rfc4918"},{header:"If-Schedule-Tag-Match",description:'"standard"',spec_title:"RFC6638",spec_href:"http://tools.ietf.org/html/rfc6638"},{header:"Last-Event-ID",description:'"The value of the event source\'s last event ID string, encoded as UTF-8."',spec_title:"Server-Sent Events",spec_href:"http://www.w3.org/TR/eventsource/#last-event-id"},{header:"Link-Template",description:'"provides a means for serialising one or more links into HTTP headers."',spec_title:"draft-nottingham-link-template",spec_href:"http://tools.ietf.org/html/draft-nottingham-link-template"},{header:"Lock-Token",description:'"standard"',spec_title:"RFC4918",spec_href:"http://tools.ietf.org/html/rfc4918"},{header:"Negotiate",description:'"can contain directives for any content negotiation process initiated by the request."',spec_title:"RFC2295#8.4",spec_href:"http://tools.ietf.org/html/rfc2295#section-8.4"},{header:"Nice",description:'"indicates that a request is less important than a request that doesn\'t bear this header."',spec_title:"draft-thomson-http-nice",spec_href:"http://tools.ietf.org/html/draft-thomson-http-nice"},{header:"Overwrite",description:'"standard"',spec_title:"RFC4918",spec_href:"http://tools.ietf.org/html/rfc4918"},{header:"Redirect-Ref",description:'""',spec_title:"RFC4437",spec_href:"http://tools.ietf.org/html/rfc4437"},{header:"Schedule-Reply",description:'"standard"',spec_title:"RFC6638",spec_href:"http://tools.ietf.org/html/rfc6638"},{header:"Schedule-Tag",description:'"standard"',spec_title:"RFC6638",spec_href:"http://tools.ietf.org/html/rfc6638"},{header:"Sec-WebSocket-Accept",description:'"standard"',spec_title:"RFC6455",spec_href:"http://tools.ietf.org/html/rfc6455"},{header:"Sec-WebSocket-Extensions",description:'"standard"',spec_title:"RFC6455",spec_href:"http://tools.ietf.org/html/rfc6455"},{header:"Sec-WebSocket-Key",description:'"standard"',spec_title:"RFC6455",spec_href:"http://tools.ietf.org/html/rfc6455"},{header:"Sec-WebSocket-Protocol",description:'"standard"',spec_title:"RFC6455",spec_href:"http://tools.ietf.org/html/rfc6455"},{header:"Sec-WebSocket-Version",description:'"standard"',spec_title:"RFC6455",spec_href:"http://tools.ietf.org/html/rfc6455"},{header:"Set-Cookie2",description:'"obsoleted"',spec_title:"RFC2965",spec_href:"http://tools.ietf.org/html/rfc2965"},{header:"SLUG",description:'"standard"',spec_title:"RFC5023",spec_href:"http://tools.ietf.org/html/rfc5023"},{header:"TCN",description:'"is used by a server to signal that the resource is transparently negotiated."',spec_title:"RFC2295#8.5",spec_href:"http://tools.ietf.org/html/rfc2295#section-8.5"},{header:"Timeout",description:'"standard"',spec_title:"RFC4918",spec_href:"http://tools.ietf.org/html/rfc4918"},{header:"Variant-Vary",description:'"can be used in a choice response to record any vary information which applies to the variant data (the entity body combined with some of the entity headers) contained in the response, rather than to the response as a whole."',spec_title:"RFC2295#8.6",spec_href:"http://tools.ietf.org/html/rfc2295#section-8.6"},{header:"X-Frame-Options",description:'"indicates a policy that specifies whether the browser should render the transmitted resource within a <frame> or an <iframe>. Servers can declare this policy in the header of their HTTP responses to prevent clickjacking attacks, which ensures that their content is not embedded into other pages or frames."',spec_title:"RFC7034",spec_href:"http://tools.ietf.org/html/rfc7034"}]},function(module,exports,__webpack_require__){module.exports=[{relation:"about",description:'"Refers to a resource that is the subject of the link\'s context."',spec_title:"RFC6903",spec_href:"http://tools.ietf.org/html/rfc6903"},{relation:"alternate",description:'"Refers to a substitute for this context"',spec_title:"HTML5links",spec_href:"http://www.w3.org/TR/html5/links.html#link-type-alternate"},{relation:"appendix",description:'"Refers to an appendix."',spec_title:"HTML401",spec_href:"http://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"archives",description:'"Refers to a collection of records, documents, or other materials of historical interest."',spec_title:"HTML5linksWD",spec_href:"http://www.w3.org/TR/2011/WD-html5-20110113/links.html#rel-archives"},{relation:"author",description:'"Refers to the context\'s author."',spec_title:"HTML5links",spec_href:"http://www.w3.org/TR/html5/links.html#link-type-author"},{relation:"bookmark",description:'"Gives a permanent link to use for bookmarking purposes."',spec_title:"HTML5links",spec_href:"http://www.w3.org/TR/html5/links.html#link-type-bookmark"},{relation:"canonical",description:'"Designates the preferred version of a resource (the IRI and its contents)."',spec_title:"RFC6596",spec_href:"http://tools.ietf.org/html/rfc6596"},{relation:"chapter",description:'"Refers to a chapter in a collection of resources."',spec_title:"HTML401",spec_href:"http://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"collection",description:'"The target IRI points to a resource which represents the collection resource for the context IRI."',spec_title:"RFC6573",spec_href:"http://tools.ietf.org/html/rfc6573"},{relation:"contents",description:'"Refers to a table of contents."',spec_title:"HTML401",spec_href:"http://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"copyright",description:'"Refers to a copyright statement that applies to the link\'s context."',spec_title:"HTML401",spec_href:"http://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"create-form",description:'"The target IRI points to a resource where a submission form can be obtained."',spec_title:"RFC6861",spec_href:"http://tools.ietf.org/html/rfc6861"},{relation:"current",description:'"Refers to a resource containing the most recent item(s) in a collection of resources."',spec_title:"RFC5005",spec_href:"http://tools.ietf.org/html/rfc5005"},{relation:"describedby",description:'"Refers to a resource providing information about the link\'s context."',spec_title:"POWDER",spec_href:"http://www.w3.org/TR/powder-dr/#assoc-linking"},{relation:"describes",description:"\"The relationship A 'describes' B asserts that resource A provides a description of resource B. There are no constraints on the format or representation of either A or B, neither are there any further constraints on either resource.\"",spec_title:"RFC6892",spec_href:"http://tools.ietf.org/html/rfc6892"},{relation:"disclosure",description:'"Refers to a list of patent disclosures made with respect to material for which `disclosure` relation is specified."',spec_title:"RFC6579",spec_href:"http://tools.ietf.org/html/rfc6579"},{relation:"duplicate",description:'"Refers to a resource whose available representations are byte-for-byte identical with the corresponding representations of the context IRI."',spec_title:"RFC6249",spec_href:"http://tools.ietf.org/html/rfc6249"},{relation:"edit",description:'"Refers to a resource that can be used to edit the link\'s context."',spec_title:"RFC5023",spec_href:"http://tools.ietf.org/html/rfc5023"},{relation:"edit-form",description:'"The target IRI points to a resource where a submission form for editing associated resource can be obtained."',spec_title:"RFC6861",spec_href:"http://tools.ietf.org/html/rfc6861"},{relation:"edit-media",description:'"Refers to a resource that can be used to edit media associated with the link\'s context."',spec_title:"RFC5023",spec_href:"http://tools.ietf.org/html/rfc5023"},{relation:"enclosure",description:'"Identifies a related resource that is potentially large and might require special handling."',spec_title:"RFC4287",spec_href:"http://tools.ietf.org/html/rfc4287"},{relation:"first",description:'"An IRI that refers to the furthest preceding resource in a series of resources."',spec_title:"RFC5988",spec_href:"http://tools.ietf.org/html/rfc5988"},{relation:"glossary",description:'"Refers to a glossary of terms."',spec_title:"HTML401",spec_href:"http://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"help",description:'"Refers to context-sensitive help."',spec_title:"HTML5links",spec_href:"http://www.w3.org/TR/html5/links.html#link-type-help"},{relation:"hosts",description:'"Refers to a resource hosted by the server indicated by the link context."',spec_title:"RFC6690",spec_href:"http://tools.ietf.org/html/rfc6690"},{relation:"hub",description:'"Refers to a hub that enables registration for notification of updates to the context."',spec_title:"pubsubhubbub",spec_href:"http://pubsubhubbub.googlecode.com"},{relation:"icon",description:'"Refers to an icon representing the link\'s context."',spec_title:"HTML5links",spec_href:"http://www.w3.org/TR/html5/links.html#link-type-icon"},{relation:"index",description:'"Refers to an index."',spec_title:"HTML401",spec_href:"http://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"item",description:'"The target IRI points to a resource that is a member of the collection represented by the context IRI."',spec_title:"RFC6573",spec_href:"http://tools.ietf.org/html/rfc6573"},{relation:"last",description:'"An IRI that refers to the furthest following resource in a series of resources."',spec_title:"RFC5988",spec_href:"http://tools.ietf.org/html/rfc5988"},{relation:"latest-version",description:'"Points to a resource containing the latest (e.g., current) version of the context."',spec_title:"RFC5829",spec_href:"http://tools.ietf.org/html/rfc5829"},{relation:"license",description:'"Refers to a license associated with this context."',spec_title:"RFC4946",spec_href:"http://tools.ietf.org/html/rfc4946"},{relation:"lrdd",description:'"Refers to further information about the link\'s context, expressed as a LRDD (Link-based Resource Descriptor Document) resource. See [RFC6415](http://tools.ietf.org/html/rfc6415) for information about processing this relation type in host-meta documents. When used elsewhere, it refers to additional links and other metadata. Multiple instances indicate additional LRDD resources. LRDD resources MUST have an "application/xrd+xml" representation, and MAY have others."',spec_title:"RFC6415",spec_href:"http://tools.ietf.org/html/rfc6415"},{relation:"monitor",description:'"Refers to a resource that can be used to monitor changes in an HTTP resource."',spec_title:"RFC5989",spec_href:"http://tools.ietf.org/html/rfc5989"},{relation:"monitor-group",description:'"Refers to a resource that can be used to monitor changes in a specified group of HTTP resources."',spec_title:"RFC5989",spec_href:"http://tools.ietf.org/html/rfc5989"},{relation:"next",description:'"Indicates that the link\'s context is a part of a series, and that the next in the series is the link target."',spec_title:"HTML5links",spec_href:"http://www.w3.org/TR/html5/links.html#link-type-next"},{relation:"next-archive",description:'"Refers to the immediately following archive resource."',spec_title:"RFC5005",spec_href:"http://tools.ietf.org/html/rfc5005"},{relation:"nofollow",description:'"Indicates that the context’s original author or publisher does not endorse the link target."',spec_title:"HTML5links",spec_href:"http://www.w3.org/TR/html5/links.html#link-type-nofollow"},{relation:"noreferrer",description:'"Indicates that no referrer information is to be leaked when following the link."',spec_title:"HTML5links",spec_href:"http://www.w3.org/TR/html5/links.html#link-type-noreferrer"},{relation:"payment",description:'"Indicates a resource where payment is accepted."',spec_title:"RFC5988",spec_href:"http://tools.ietf.org/html/rfc5988"},{relation:"predecessor-version",description:'"Points to a resource containing the predecessor version in the version history."',spec_title:"RFC5829",spec_href:"http://tools.ietf.org/html/rfc5829"},{relation:"prefetch",description:'"Indicates that the link target should be preemptively cached."',spec_title:"HTML5links",spec_href:"http://www.w3.org/TR/html5/links.html#link-type-prefetch"},{relation:"prev",description:'"Indicates that the link\'s context is a part of a series, and that the previous in the series is the link target."',spec_title:"HTML5links",spec_href:"http://www.w3.org/TR/html5/links.html#link-type-prev"},{relation:"preview",description:'"Refers to a resource that provides a preview of the link\'s context."',spec_title:"RFC6903",spec_href:"http://tools.ietf.org/html/rfc6903"},{relation:"previous",description:'"Refers to the previous resource in an ordered series of resources. Synonym for `prev`."',spec_title:"HTML401",spec_href:"http://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"prev-archive",description:'"Refers to the immediately preceding archive resource."',spec_title:"RFC5005",spec_href:"http://tools.ietf.org/html/rfc5005"},{relation:"privacy-policy",description:'"Refers to a privacy policy associated with the link\'s context."',spec_title:"RFC6903",spec_href:"http://tools.ietf.org/html/rfc6903"},{relation:"profile",description:"Identifying that a resource representation conforms to a certain profile, without affecting the non-profile semantics of the resource representation",spec_title:"RFC6906",spec_href:"http://tools.ietf.org/html/rfc6906"},{relation:"related",description:'"Identifies a related resource."',spec_title:"RFC4287",spec_href:"http://tools.ietf.org/html/rfc4287"},{relation:"replies",description:'"Identifies a resource that is a reply to the context of the link."',spec_title:"RFC4685",spec_href:"http://tools.ietf.org/html/rfc4685"},{relation:"search",description:'"Refers to a resource that can be used to search through the link\'s context and related resources."',spec_title:"OpenSearch",spec_href:"http://www.opensearch.org/Specifications/OpenSearch/1.1"},{relation:"section",description:'"Refers to a section in a collection of resources."',spec_title:"HTML401",spec_href:"http://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"self",description:'"Conveys an identifier for the link\'s context."',spec_title:"RFC4287",spec_href:"http://tools.ietf.org/html/rfc4287"},{relation:"service",description:'"Indicates a URI that can be used to retrieve a service document."',spec_title:"RFC5023",spec_href:"http://tools.ietf.org/html/rfc5023"},{relation:"start",description:'"Refers to the first resource in a collection of resources."',spec_title:"HTML401",spec_href:"http://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"stylesheet",description:'"Refers to a stylesheet."',spec_title:"HTML5links",spec_href:"http://www.w3.org/TR/html5/links.html#link-type-stylesheet"},{relation:"subsection",description:'"Refers to a resource serving as a subsection in a collection of resources."',spec_title:"HTML401",spec_href:"http://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"successor-version",description:'"Points to a resource containing the successor version in the version history."',spec_title:"RFC5829",spec_href:"http://tools.ietf.org/html/rfc5829"},{relation:"tag",description:'"Gives a tag (identified by the given address) that applies to the current document."',spec_title:"HTML5links",spec_href:"http://www.w3.org/TR/html5/links.html#link-type-tag"},{relation:"terms-of-service",description:'"Refers to the terms of service associated with the link\'s context."',spec_title:"RFC6903",spec_href:"http://tools.ietf.org/html/rfc6903"},{relation:"type",description:'"Refers to a resource identifying the abstract semantic type of which the link\'s context is considered to be an instance."',spec_title:"RFC6903",spec_href:"http://tools.ietf.org/html/rfc6903"},{relation:"up",description:'"Refers to a parent document in a hierarchy of documents."',spec_title:"RFC5988",spec_href:"http://tools.ietf.org/html/rfc5988"},{relation:"version-history",description:'"Points to a resource containing the version history for the context."',spec_title:"RFC5829",spec_href:"http://tools.ietf.org/html/rfc5829"},{relation:"via",description:'"Identifies a resource that is the source of the information in the link\'s context."',spec_title:"RFC4287",spec_href:"http://tools.ietf.org/html/rfc4287"},{relation:"working-copy",description:'"Points to a working copy for this resource."',spec_title:"RFC5829",spec_href:"http://tools.ietf.org/html/rfc5829"},{relation:"working-copy-of",description:'"Points to the versioned resource from which this working copy was obtained."',spec_title:"RFC5829",spec_href:"http://tools.ietf.org/html/rfc5829"}]},function(module,exports,__webpack_require__){"use strict";function compileStyleAliases(map){var result={};return null!==map&&Object.keys(map).forEach(function(style){map[style].forEach(function(alias){result[String(alias)]=style})}),result}function Type(tag,options){if(options=options||{},Object.keys(options).forEach(function(name){if(-1===TYPE_CONSTRUCTOR_OPTIONS.indexOf(name))throw new YAMLException('Unknown option "'+name+'" is met in definition of "'+tag+'" YAML type.')}),this.tag=tag,this.kind=options.kind||null,this.resolve=options.resolve||function(){return!0},this.construct=options.construct||function(data){return data},this.instanceOf=options.instanceOf||null,this.predicate=options.predicate||null,this.represent=options.represent||null,this.defaultStyle=options.defaultStyle||null,this.styleAliases=compileStyleAliases(options.styleAliases||null),-1===YAML_NODE_KINDS.indexOf(this.kind))throw new YAMLException('Unknown kind "'+this.kind+'" is specified for "'+tag+'" YAML type.')}var YAMLException=__webpack_require__(98),TYPE_CONSTRUCTOR_OPTIONS=["kind","resolve","construct","instanceOf","predicate","represent","defaultStyle","styleAliases"],YAML_NODE_KINDS=["scalar","sequence","mapping"];module.exports=Type},function(module,exports,__webpack_require__){"use strict";var Schema=__webpack_require__(147);module.exports=new Schema({include:[__webpack_require__(201)],implicit:[__webpack_require__(202),__webpack_require__(203),__webpack_require__(204),__webpack_require__(205)]})},function(module,exports,__webpack_require__){function DOMParser(options){this.options=options||{locator:{}}}function buildErrorHandler(errorImpl,domBuilder,locator){function build(key){var fn=errorImpl[key];!fn&&isCallback&&(fn=2==errorImpl.length?function(msg){errorImpl(key,msg)}:errorImpl),errorHandler[key]=fn&&function(msg){fn("[xmldom "+key+"]\t"+msg+_locator(locator))}||function(){}}if(!errorImpl){if(domBuilder instanceof DOMHandler)return domBuilder;errorImpl=domBuilder}var errorHandler={},isCallback=errorImpl instanceof Function;return locator=locator||{},build("warning"),build("error"),build("fatalError"),errorHandler}function DOMHandler(){this.cdata=!1}function position(locator,node){node.lineNumber=locator.lineNumber,node.columnNumber=locator.columnNumber}function _locator(l){if(l)return"\n@"+(l.systemId||"")+"#[line:"+l.lineNumber+",col:"+l.columnNumber+"]"}function _toString(chars,start,length){return"string"==typeof chars?chars.substr(start,length):chars.length>=start+length||start?new java.lang.String(chars,start,length)+"":chars}function appendElement(hander,node){hander.currentElement?hander.currentElement.appendChild(node):hander.document.appendChild(node)}DOMParser.prototype.parseFromString=function(source,mimeType){var options=this.options,sax=new XMLReader,domBuilder=options.domBuilder||new DOMHandler,errorHandler=options.errorHandler,locator=options.locator,defaultNSMap=options.xmlns||{},entityMap={lt:"<",gt:">",amp:"&",quot:'"',apos:"'"};return locator&&domBuilder.setDocumentLocator(locator),sax.errorHandler=buildErrorHandler(errorHandler,domBuilder,locator),sax.domBuilder=options.domBuilder||domBuilder,/\/x?html?$/.test(mimeType)&&(entityMap.nbsp=" ",entityMap.copy="©",defaultNSMap[""]="http://www.w3.org/1999/xhtml"),defaultNSMap.xml=defaultNSMap.xml||"http://www.w3.org/XML/1998/namespace",source?sax.parse(source,defaultNSMap,entityMap):sax.errorHandler.error("invalid document source"),domBuilder.document},DOMHandler.prototype={startDocument:function(){this.document=(new DOMImplementation).createDocument(null,null,null),this.locator&&(this.document.documentURI=this.locator.systemId)},startElement:function(namespaceURI,localName,qName,attrs){var doc=this.document,el=doc.createElementNS(namespaceURI,qName||localName),len=attrs.length;appendElement(this,el),this.currentElement=el,this.locator&&position(this.locator,el);for(var i=0;i<len;i++){var namespaceURI=attrs.getURI(i),value=attrs.getValue(i),qName=attrs.getQName(i),attr=doc.createAttributeNS(namespaceURI,qName);attr.getOffset&&position(attr.getOffset(1),attr),attr.value=attr.nodeValue=value,el.setAttributeNode(attr)}},endElement:function(namespaceURI,localName,qName){var current=this.currentElement;current.tagName;this.currentElement=current.parentNode},startPrefixMapping:function(prefix,uri){},endPrefixMapping:function(prefix){},processingInstruction:function(target,data){var ins=this.document.createProcessingInstruction(target,data);this.locator&&position(this.locator,ins),appendElement(this,ins)},ignorableWhitespace:function(ch,start,length){},characters:function(chars,start,length){if(chars=_toString.apply(this,arguments),this.currentElement&&chars){if(this.cdata){var charNode=this.document.createCDATASection(chars);this.currentElement.appendChild(charNode)}else{var charNode=this.document.createTextNode(chars);this.currentElement.appendChild(charNode)}this.locator&&position(this.locator,charNode)}},skippedEntity:function(name){},endDocument:function(){this.document.normalize()},setDocumentLocator:function(locator){
(this.locator=locator)&&(locator.lineNumber=0)},comment:function(chars,start,length){chars=_toString.apply(this,arguments);var comm=this.document.createComment(chars);this.locator&&position(this.locator,comm),appendElement(this,comm)},startCDATA:function(){this.cdata=!0},endCDATA:function(){this.cdata=!1},startDTD:function(name,publicId,systemId){var impl=this.document.implementation;if(impl&&impl.createDocumentType){var dt=impl.createDocumentType(name,publicId,systemId);this.locator&&position(this.locator,dt),appendElement(this,dt)}},warning:function(error){console.warn("[xmldom warning]\t"+error,_locator(this.locator))},error:function(error){console.error("[xmldom error]\t"+error,_locator(this.locator))},fatalError:function(error){throw console.error("[xmldom fatalError]\t"+error,_locator(this.locator)),error}},"endDTD,startEntity,endEntity,attributeDecl,elementDecl,externalEntityDecl,internalEntityDecl,resolveEntity,getExternalSubset,notationDecl,unparsedEntityDecl".replace(/\w+/g,function(key){DOMHandler.prototype[key]=function(){return null}});var XMLReader=__webpack_require__(208).XMLReader,DOMImplementation=exports.DOMImplementation=__webpack_require__(209).DOMImplementation;exports.XMLSerializer=__webpack_require__(209).XMLSerializer,exports.DOMParser=DOMParser},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__;(function(){function createReduce(dir){function iterator(obj,iteratee,memo,keys,index,length){for(;index>=0&&index<length;index+=dir){var currentKey=keys?keys[index]:index;memo=iteratee(memo,obj[currentKey],currentKey,obj)}return memo}return function(obj,iteratee,memo,context){iteratee=optimizeCb(iteratee,context,4);var keys=!isArrayLike(obj)&&_.keys(obj),length=(keys||obj).length,index=dir>0?0:length-1;return arguments.length<3&&(memo=obj[keys?keys[index]:index],index+=dir),iterator(obj,iteratee,memo,keys,index,length)}}function createPredicateIndexFinder(dir){return function(array,predicate,context){predicate=cb(predicate,context);for(var length=getLength(array),index=dir>0?0:length-1;index>=0&&index<length;index+=dir)if(predicate(array[index],index,array))return index;return-1}}function createIndexFinder(dir,predicateFind,sortedIndex){return function(array,item,idx){var i=0,length=getLength(array);if("number"==typeof idx)dir>0?i=idx>=0?idx:Math.max(idx+length,i):length=idx>=0?Math.min(idx+1,length):idx+length+1;else if(sortedIndex&&idx&&length)return idx=sortedIndex(array,item),array[idx]===item?idx:-1;if(item!==item)return idx=predicateFind(slice.call(array,i,length),_.isNaN),idx>=0?idx+i:-1;for(idx=dir>0?i:length-1;idx>=0&&idx<length;idx+=dir)if(array[idx]===item)return idx;return-1}}function collectNonEnumProps(obj,keys){var nonEnumIdx=nonEnumerableProps.length,constructor=obj.constructor,proto=_.isFunction(constructor)&&constructor.prototype||ObjProto,prop="constructor";for(_.has(obj,prop)&&!_.contains(keys,prop)&&keys.push(prop);nonEnumIdx--;)prop=nonEnumerableProps[nonEnumIdx],prop in obj&&obj[prop]!==proto[prop]&&!_.contains(keys,prop)&&keys.push(prop)}var root=this,previousUnderscore=root._,ArrayProto=Array.prototype,ObjProto=Object.prototype,FuncProto=Function.prototype,push=ArrayProto.push,slice=ArrayProto.slice,toString=ObjProto.toString,hasOwnProperty=ObjProto.hasOwnProperty,nativeIsArray=Array.isArray,nativeKeys=Object.keys,nativeBind=FuncProto.bind,nativeCreate=Object.create,Ctor=function(){},_=function(obj){return obj instanceof _?obj:this instanceof _?void(this._wrapped=obj):new _(obj)};"undefined"!=typeof module&&module.exports&&(exports=module.exports=_),exports._=_,_.VERSION="1.8.3";var optimizeCb=function(func,context,argCount){if(void 0===context)return func;switch(null==argCount?3:argCount){case 1:return function(value){return func.call(context,value)};case 2:return function(value,other){return func.call(context,value,other)};case 3:return function(value,index,collection){return func.call(context,value,index,collection)};case 4:return function(accumulator,value,index,collection){return func.call(context,accumulator,value,index,collection)}}return function(){return func.apply(context,arguments)}},cb=function(value,context,argCount){return null==value?_.identity:_.isFunction(value)?optimizeCb(value,context,argCount):_.isObject(value)?_.matcher(value):_.property(value)};_.iteratee=function(value,context){return cb(value,context,1/0)};var createAssigner=function(keysFunc,undefinedOnly){return function(obj){var length=arguments.length;if(length<2||null==obj)return obj;for(var index=1;index<length;index++)for(var source=arguments[index],keys=keysFunc(source),l=keys.length,i=0;i<l;i++){var key=keys[i];undefinedOnly&&void 0!==obj[key]||(obj[key]=source[key])}return obj}},baseCreate=function(prototype){if(!_.isObject(prototype))return{};if(nativeCreate)return nativeCreate(prototype);Ctor.prototype=prototype;var result=new Ctor;return Ctor.prototype=null,result},property=function(key){return function(obj){return null==obj?void 0:obj[key]}},MAX_ARRAY_INDEX=Math.pow(2,53)-1,getLength=property("length"),isArrayLike=function(collection){var length=getLength(collection);return"number"==typeof length&&length>=0&&length<=MAX_ARRAY_INDEX};_.each=_.forEach=function(obj,iteratee,context){iteratee=optimizeCb(iteratee,context);var i,length;if(isArrayLike(obj))for(i=0,length=obj.length;i<length;i++)iteratee(obj[i],i,obj);else{var keys=_.keys(obj);for(i=0,length=keys.length;i<length;i++)iteratee(obj[keys[i]],keys[i],obj)}return obj},_.map=_.collect=function(obj,iteratee,context){iteratee=cb(iteratee,context);for(var keys=!isArrayLike(obj)&&_.keys(obj),length=(keys||obj).length,results=Array(length),index=0;index<length;index++){var currentKey=keys?keys[index]:index;results[index]=iteratee(obj[currentKey],currentKey,obj)}return results},_.reduce=_.foldl=_.inject=createReduce(1),_.reduceRight=_.foldr=createReduce(-1),_.find=_.detect=function(obj,predicate,context){var key;if(key=isArrayLike(obj)?_.findIndex(obj,predicate,context):_.findKey(obj,predicate,context),void 0!==key&&key!==-1)return obj[key]},_.filter=_.select=function(obj,predicate,context){var results=[];return predicate=cb(predicate,context),_.each(obj,function(value,index,list){predicate(value,index,list)&&results.push(value)}),results},_.reject=function(obj,predicate,context){return _.filter(obj,_.negate(cb(predicate)),context)},_.every=_.all=function(obj,predicate,context){predicate=cb(predicate,context);for(var keys=!isArrayLike(obj)&&_.keys(obj),length=(keys||obj).length,index=0;index<length;index++){var currentKey=keys?keys[index]:index;if(!predicate(obj[currentKey],currentKey,obj))return!1}return!0},_.some=_.any=function(obj,predicate,context){predicate=cb(predicate,context);for(var keys=!isArrayLike(obj)&&_.keys(obj),length=(keys||obj).length,index=0;index<length;index++){var currentKey=keys?keys[index]:index;if(predicate(obj[currentKey],currentKey,obj))return!0}return!1},_.contains=_.includes=_.include=function(obj,item,fromIndex,guard){return isArrayLike(obj)||(obj=_.values(obj)),("number"!=typeof fromIndex||guard)&&(fromIndex=0),_.indexOf(obj,item,fromIndex)>=0},_.invoke=function(obj,method){var args=slice.call(arguments,2),isFunc=_.isFunction(method);return _.map(obj,function(value){var func=isFunc?method:value[method];return null==func?func:func.apply(value,args)})},_.pluck=function(obj,key){return _.map(obj,_.property(key))},_.where=function(obj,attrs){return _.filter(obj,_.matcher(attrs))},_.findWhere=function(obj,attrs){return _.find(obj,_.matcher(attrs))},_.max=function(obj,iteratee,context){var value,computed,result=-(1/0),lastComputed=-(1/0);if(null==iteratee&&null!=obj){obj=isArrayLike(obj)?obj:_.values(obj);for(var i=0,length=obj.length;i<length;i++)value=obj[i],value>result&&(result=value)}else iteratee=cb(iteratee,context),_.each(obj,function(value,index,list){computed=iteratee(value,index,list),(computed>lastComputed||computed===-(1/0)&&result===-(1/0))&&(result=value,lastComputed=computed)});return result},_.min=function(obj,iteratee,context){var value,computed,result=1/0,lastComputed=1/0;if(null==iteratee&&null!=obj){obj=isArrayLike(obj)?obj:_.values(obj);for(var i=0,length=obj.length;i<length;i++)value=obj[i],value<result&&(result=value)}else iteratee=cb(iteratee,context),_.each(obj,function(value,index,list){computed=iteratee(value,index,list),(computed<lastComputed||computed===1/0&&result===1/0)&&(result=value,lastComputed=computed)});return result},_.shuffle=function(obj){for(var rand,set=isArrayLike(obj)?obj:_.values(obj),length=set.length,shuffled=Array(length),index=0;index<length;index++)rand=_.random(0,index),rand!==index&&(shuffled[index]=shuffled[rand]),shuffled[rand]=set[index];return shuffled},_.sample=function(obj,n,guard){return null==n||guard?(isArrayLike(obj)||(obj=_.values(obj)),obj[_.random(obj.length-1)]):_.shuffle(obj).slice(0,Math.max(0,n))},_.sortBy=function(obj,iteratee,context){return iteratee=cb(iteratee,context),_.pluck(_.map(obj,function(value,index,list){return{value:value,index:index,criteria:iteratee(value,index,list)}}).sort(function(left,right){var a=left.criteria,b=right.criteria;if(a!==b){if(a>b||void 0===a)return 1;if(a<b||void 0===b)return-1}return left.index-right.index}),"value")};var group=function(behavior){return function(obj,iteratee,context){var result={};return iteratee=cb(iteratee,context),_.each(obj,function(value,index){var key=iteratee(value,index,obj);behavior(result,value,key)}),result}};_.groupBy=group(function(result,value,key){_.has(result,key)?result[key].push(value):result[key]=[value]}),_.indexBy=group(function(result,value,key){result[key]=value}),_.countBy=group(function(result,value,key){_.has(result,key)?result[key]++:result[key]=1}),_.toArray=function(obj){return obj?_.isArray(obj)?slice.call(obj):isArrayLike(obj)?_.map(obj,_.identity):_.values(obj):[]},_.size=function(obj){return null==obj?0:isArrayLike(obj)?obj.length:_.keys(obj).length},_.partition=function(obj,predicate,context){predicate=cb(predicate,context);var pass=[],fail=[];return _.each(obj,function(value,key,obj){(predicate(value,key,obj)?pass:fail).push(value)}),[pass,fail]},_.first=_.head=_.take=function(array,n,guard){if(null!=array)return null==n||guard?array[0]:_.initial(array,array.length-n)},_.initial=function(array,n,guard){return slice.call(array,0,Math.max(0,array.length-(null==n||guard?1:n)))},_.last=function(array,n,guard){if(null!=array)return null==n||guard?array[array.length-1]:_.rest(array,Math.max(0,array.length-n))},_.rest=_.tail=_.drop=function(array,n,guard){return slice.call(array,null==n||guard?1:n)},_.compact=function(array){return _.filter(array,_.identity)};var flatten=function(input,shallow,strict,startIndex){for(var output=[],idx=0,i=startIndex||0,length=getLength(input);i<length;i++){var value=input[i];if(isArrayLike(value)&&(_.isArray(value)||_.isArguments(value))){shallow||(value=flatten(value,shallow,strict));var j=0,len=value.length;for(output.length+=len;j<len;)output[idx++]=value[j++]}else strict||(output[idx++]=value)}return output};_.flatten=function(array,shallow){return flatten(array,shallow,!1)},_.without=function(array){return _.difference(array,slice.call(arguments,1))},_.uniq=_.unique=function(array,isSorted,iteratee,context){_.isBoolean(isSorted)||(context=iteratee,iteratee=isSorted,isSorted=!1),null!=iteratee&&(iteratee=cb(iteratee,context));for(var result=[],seen=[],i=0,length=getLength(array);i<length;i++){var value=array[i],computed=iteratee?iteratee(value,i,array):value;isSorted?(i&&seen===computed||result.push(value),seen=computed):iteratee?_.contains(seen,computed)||(seen.push(computed),result.push(value)):_.contains(result,value)||result.push(value)}return result},_.union=function(){return _.uniq(flatten(arguments,!0,!0))},_.intersection=function(array){for(var result=[],argsLength=arguments.length,i=0,length=getLength(array);i<length;i++){var item=array[i];if(!_.contains(result,item)){for(var j=1;j<argsLength&&_.contains(arguments[j],item);j++);j===argsLength&&result.push(item)}}return result},_.difference=function(array){var rest=flatten(arguments,!0,!0,1);return _.filter(array,function(value){return!_.contains(rest,value)})},_.zip=function(){return _.unzip(arguments)},_.unzip=function(array){for(var length=array&&_.max(array,getLength).length||0,result=Array(length),index=0;index<length;index++)result[index]=_.pluck(array,index);return result},_.object=function(list,values){for(var result={},i=0,length=getLength(list);i<length;i++)values?result[list[i]]=values[i]:result[list[i][0]]=list[i][1];return result},_.findIndex=createPredicateIndexFinder(1),_.findLastIndex=createPredicateIndexFinder(-1),_.sortedIndex=function(array,obj,iteratee,context){iteratee=cb(iteratee,context,1);for(var value=iteratee(obj),low=0,high=getLength(array);low<high;){var mid=Math.floor((low+high)/2);iteratee(array[mid])<value?low=mid+1:high=mid}return low},_.indexOf=createIndexFinder(1,_.findIndex,_.sortedIndex),_.lastIndexOf=createIndexFinder(-1,_.findLastIndex),_.range=function(start,stop,step){null==stop&&(stop=start||0,start=0),step=step||1;for(var length=Math.max(Math.ceil((stop-start)/step),0),range=Array(length),idx=0;idx<length;idx++,start+=step)range[idx]=start;return range};var executeBound=function(sourceFunc,boundFunc,context,callingContext,args){if(!(callingContext instanceof boundFunc))return sourceFunc.apply(context,args);var self=baseCreate(sourceFunc.prototype),result=sourceFunc.apply(self,args);return _.isObject(result)?result:self};_.bind=function(func,context){if(nativeBind&&func.bind===nativeBind)return nativeBind.apply(func,slice.call(arguments,1));if(!_.isFunction(func))throw new TypeError("Bind must be called on a function");var args=slice.call(arguments,2),bound=function(){return executeBound(func,bound,context,this,args.concat(slice.call(arguments)))};return bound},_.partial=function(func){var boundArgs=slice.call(arguments,1),bound=function(){for(var position=0,length=boundArgs.length,args=Array(length),i=0;i<length;i++)args[i]=boundArgs[i]===_?arguments[position++]:boundArgs[i];for(;position<arguments.length;)args.push(arguments[position++]);return executeBound(func,bound,this,this,args)};return bound},_.bindAll=function(obj){var i,key,length=arguments.length;if(length<=1)throw new Error("bindAll must be passed function names");for(i=1;i<length;i++)key=arguments[i],obj[key]=_.bind(obj[key],obj);return obj},_.memoize=function(func,hasher){var memoize=function(key){var cache=memoize.cache,address=""+(hasher?hasher.apply(this,arguments):key);return _.has(cache,address)||(cache[address]=func.apply(this,arguments)),cache[address]};return memoize.cache={},memoize},_.delay=function(func,wait){var args=slice.call(arguments,2);return setTimeout(function(){return func.apply(null,args)},wait)},_.defer=_.partial(_.delay,_,1),_.throttle=function(func,wait,options){var context,args,result,timeout=null,previous=0;options||(options={});var later=function(){previous=options.leading===!1?0:_.now(),timeout=null,result=func.apply(context,args),timeout||(context=args=null)};return function(){var now=_.now();previous||options.leading!==!1||(previous=now);var remaining=wait-(now-previous);return context=this,args=arguments,remaining<=0||remaining>wait?(timeout&&(clearTimeout(timeout),timeout=null),previous=now,result=func.apply(context,args),timeout||(context=args=null)):timeout||options.trailing===!1||(timeout=setTimeout(later,remaining)),result}},_.debounce=function(func,wait,immediate){var timeout,args,context,timestamp,result,later=function(){var last=_.now()-timestamp;last<wait&&last>=0?timeout=setTimeout(later,wait-last):(timeout=null,immediate||(result=func.apply(context,args),timeout||(context=args=null)))};return function(){context=this,args=arguments,timestamp=_.now();var callNow=immediate&&!timeout;return timeout||(timeout=setTimeout(later,wait)),callNow&&(result=func.apply(context,args),context=args=null),result}},_.wrap=function(func,wrapper){return _.partial(wrapper,func)},_.negate=function(predicate){return function(){return!predicate.apply(this,arguments)}},_.compose=function(){var args=arguments,start=args.length-1;return function(){for(var i=start,result=args[start].apply(this,arguments);i--;)result=args[i].call(this,result);return result}},_.after=function(times,func){return function(){if(--times<1)return func.apply(this,arguments)}},_.before=function(times,func){var memo;return function(){return--times>0&&(memo=func.apply(this,arguments)),times<=1&&(func=null),memo}},_.once=_.partial(_.before,2);var hasEnumBug=!{toString:null}.propertyIsEnumerable("toString"),nonEnumerableProps=["valueOf","isPrototypeOf","toString","propertyIsEnumerable","hasOwnProperty","toLocaleString"];_.keys=function(obj){if(!_.isObject(obj))return[];if(nativeKeys)return nativeKeys(obj);var keys=[];for(var key in obj)_.has(obj,key)&&keys.push(key);return hasEnumBug&&collectNonEnumProps(obj,keys),keys},_.allKeys=function(obj){if(!_.isObject(obj))return[];var keys=[];for(var key in obj)keys.push(key);return hasEnumBug&&collectNonEnumProps(obj,keys),keys},_.values=function(obj){for(var keys=_.keys(obj),length=keys.length,values=Array(length),i=0;i<length;i++)values[i]=obj[keys[i]];return values},_.mapObject=function(obj,iteratee,context){iteratee=cb(iteratee,context);for(var currentKey,keys=_.keys(obj),length=keys.length,results={},index=0;index<length;index++)currentKey=keys[index],results[currentKey]=iteratee(obj[currentKey],currentKey,obj);return results},_.pairs=function(obj){for(var keys=_.keys(obj),length=keys.length,pairs=Array(length),i=0;i<length;i++)pairs[i]=[keys[i],obj[keys[i]]];return pairs},_.invert=function(obj){for(var result={},keys=_.keys(obj),i=0,length=keys.length;i<length;i++)result[obj[keys[i]]]=keys[i];return result},_.functions=_.methods=function(obj){var names=[];for(var key in obj)_.isFunction(obj[key])&&names.push(key);return names.sort()},_.extend=createAssigner(_.allKeys),_.extendOwn=_.assign=createAssigner(_.keys),_.findKey=function(obj,predicate,context){predicate=cb(predicate,context);for(var key,keys=_.keys(obj),i=0,length=keys.length;i<length;i++)if(key=keys[i],predicate(obj[key],key,obj))return key},_.pick=function(object,oiteratee,context){var iteratee,keys,result={},obj=object;if(null==obj)return result;_.isFunction(oiteratee)?(keys=_.allKeys(obj),iteratee=optimizeCb(oiteratee,context)):(keys=flatten(arguments,!1,!1,1),iteratee=function(value,key,obj){return key in obj},obj=Object(obj));for(var i=0,length=keys.length;i<length;i++){var key=keys[i],value=obj[key];iteratee(value,key,obj)&&(result[key]=value)}return result},_.omit=function(obj,iteratee,context){if(_.isFunction(iteratee))iteratee=_.negate(iteratee);else{var keys=_.map(flatten(arguments,!1,!1,1),String);iteratee=function(value,key){return!_.contains(keys,key)}}return _.pick(obj,iteratee,context)},_.defaults=createAssigner(_.allKeys,!0),_.create=function(prototype,props){var result=baseCreate(prototype);return props&&_.extendOwn(result,props),result},_.clone=function(obj){return _.isObject(obj)?_.isArray(obj)?obj.slice():_.extend({},obj):obj},_.tap=function(obj,interceptor){return interceptor(obj),obj},_.isMatch=function(object,attrs){var keys=_.keys(attrs),length=keys.length;if(null==object)return!length;for(var obj=Object(object),i=0;i<length;i++){var key=keys[i];if(attrs[key]!==obj[key]||!(key in obj))return!1}return!0};var eq=function(a,b,aStack,bStack){if(a===b)return 0!==a||1/a===1/b;if(null==a||null==b)return a===b;a instanceof _&&(a=a._wrapped),b instanceof _&&(b=b._wrapped);var className=toString.call(a);if(className!==toString.call(b))return!1;switch(className){case"[object RegExp]":case"[object String]":return""+a==""+b;case"[object Number]":return+a!==+a?+b!==+b:0===+a?1/+a===1/b:+a===+b;case"[object Date]":case"[object Boolean]":return+a===+b}var areArrays="[object Array]"===className;if(!areArrays){if("object"!=typeof a||"object"!=typeof b)return!1;var aCtor=a.constructor,bCtor=b.constructor;if(aCtor!==bCtor&&!(_.isFunction(aCtor)&&aCtor instanceof aCtor&&_.isFunction(bCtor)&&bCtor instanceof bCtor)&&"constructor"in a&&"constructor"in b)return!1}aStack=aStack||[],bStack=bStack||[];for(var length=aStack.length;length--;)if(aStack[length]===a)return bStack[length]===b;if(aStack.push(a),bStack.push(b),areArrays){if(length=a.length,length!==b.length)return!1;for(;length--;)if(!eq(a[length],b[length],aStack,bStack))return!1}else{var key,keys=_.keys(a);if(length=keys.length,_.keys(b).length!==length)return!1;for(;length--;)if(key=keys[length],!_.has(b,key)||!eq(a[key],b[key],aStack,bStack))return!1}return aStack.pop(),bStack.pop(),!0};_.isEqual=function(a,b){return eq(a,b)},_.isEmpty=function(obj){return null==obj||(isArrayLike(obj)&&(_.isArray(obj)||_.isString(obj)||_.isArguments(obj))?0===obj.length:0===_.keys(obj).length)},_.isElement=function(obj){return!(!obj||1!==obj.nodeType)},_.isArray=nativeIsArray||function(obj){return"[object Array]"===toString.call(obj)},_.isObject=function(obj){var type=typeof obj;return"function"===type||"object"===type&&!!obj},_.each(["Arguments","Function","String","Number","Date","RegExp","Error"],function(name){_["is"+name]=function(obj){return toString.call(obj)==="[object "+name+"]"}}),_.isArguments(arguments)||(_.isArguments=function(obj){return _.has(obj,"callee")}),"function"!=typeof/./&&"object"!=typeof Int8Array&&(_.isFunction=function(obj){return"function"==typeof obj||!1}),_.isFinite=function(obj){return isFinite(obj)&&!isNaN(parseFloat(obj))},_.isNaN=function(obj){return _.isNumber(obj)&&obj!==+obj},_.isBoolean=function(obj){return obj===!0||obj===!1||"[object Boolean]"===toString.call(obj)},_.isNull=function(obj){return null===obj},_.isUndefined=function(obj){return void 0===obj},_.has=function(obj,key){return null!=obj&&hasOwnProperty.call(obj,key)},_.noConflict=function(){return root._=previousUnderscore,this},_.identity=function(value){return value},_.constant=function(value){return function(){return value}},_.noop=function(){},_.property=property,_.propertyOf=function(obj){return null==obj?function(){}:function(key){return obj[key]}},_.matcher=_.matches=function(attrs){return attrs=_.extendOwn({},attrs),function(obj){return _.isMatch(obj,attrs)}},_.times=function(n,iteratee,context){var accum=Array(Math.max(0,n));iteratee=optimizeCb(iteratee,context,1);for(var i=0;i<n;i++)accum[i]=iteratee(i);return accum},_.random=function(min,max){return null==max&&(max=min,min=0),min+Math.floor(Math.random()*(max-min+1))},_.now=Date.now||function(){return(new Date).getTime()};var escapeMap={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#x27;","`":"&#x60;"},unescapeMap=_.invert(escapeMap),createEscaper=function(map){var escaper=function(match){return map[match]},source="(?:"+_.keys(map).join("|")+")",testRegexp=RegExp(source),replaceRegexp=RegExp(source,"g");return function(string){return string=null==string?"":""+string,testRegexp.test(string)?string.replace(replaceRegexp,escaper):string}};_.escape=createEscaper(escapeMap),_.unescape=createEscaper(unescapeMap),_.result=function(object,property,fallback){var value=null==object?void 0:object[property];return void 0===value&&(value=fallback),_.isFunction(value)?value.call(object):value};var idCounter=0;_.uniqueId=function(prefix){var id=++idCounter+"";return prefix?prefix+id:id},_.templateSettings={evaluate:/<%([\s\S]+?)%>/g,interpolate:/<%=([\s\S]+?)%>/g,escape:/<%-([\s\S]+?)%>/g};var noMatch=/(.)^/,escapes={"'":"'","\\":"\\","\r":"r","\n":"n","\u2028":"u2028","\u2029":"u2029"},escaper=/\\|'|\r|\n|\u2028|\u2029/g,escapeChar=function(match){return"\\"+escapes[match]};_.template=function(text,settings,oldSettings){!settings&&oldSettings&&(settings=oldSettings),settings=_.defaults({},settings,_.templateSettings);var matcher=RegExp([(settings.escape||noMatch).source,(settings.interpolate||noMatch).source,(settings.evaluate||noMatch).source].join("|")+"|$","g"),index=0,source="__p+='";text.replace(matcher,function(match,escape,interpolate,evaluate,offset){return source+=text.slice(index,offset).replace(escaper,escapeChar),index=offset+match.length,escape?source+="'+\n((__t=("+escape+"))==null?'':_.escape(__t))+\n'":interpolate?source+="'+\n((__t=("+interpolate+"))==null?'':__t)+\n'":evaluate&&(source+="';\n"+evaluate+"\n__p+='"),match}),source+="';\n",settings.variable||(source="with(obj||{}){\n"+source+"}\n"),source="var __t,__p='',__j=Array.prototype.join,print=function(){__p+=__j.call(arguments,'');};\n"+source+"return __p;\n";try{var render=new Function(settings.variable||"obj","_",source)}catch(e){throw e.source=source,e}var template=function(data){return render.call(this,data,_)},argument=settings.variable||"obj";return template.source="function("+argument+"){\n"+source+"}",template},_.chain=function(obj){var instance=_(obj);return instance._chain=!0,instance};var result=function(instance,obj){return instance._chain?_(obj).chain():obj};_.mixin=function(obj){_.each(_.functions(obj),function(name){var func=_[name]=obj[name];_.prototype[name]=function(){var args=[this._wrapped];return push.apply(args,arguments),result(this,func.apply(_,args))}})},_.mixin(_),_.each(["pop","push","reverse","shift","sort","splice","unshift"],function(name){var method=ArrayProto[name];_.prototype[name]=function(){var obj=this._wrapped;return method.apply(obj,arguments),"shift"!==name&&"splice"!==name||0!==obj.length||delete obj[0],result(this,obj)}}),_.each(["concat","join","slice"],function(name){var method=ArrayProto[name];_.prototype[name]=function(){return result(this,method.apply(this._wrapped,arguments))}}),_.prototype.value=function(){return this._wrapped},_.prototype.valueOf=_.prototype.toJSON=_.prototype.value,_.prototype.toString=function(){return""+this._wrapped},__WEBPACK_AMD_DEFINE_ARRAY__=[],__WEBPACK_AMD_DEFINE_RESULT__=function(){return _}.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__),!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__))}).call(this)},function(module,exports,__webpack_require__){(function(){function convert3to4Type(types,always){Array.isArray(types)||(types=[types]);for(var needsReplacement=!!always,result=[],i=0;i<types.length;i++){var entry=types[i];"object"==typeof entry?(result.push(entry),needsReplacement=!0):result.push({type:entry})}return needsReplacement&&result}function convert3to4(obj){if(obj.type)if("string"!=typeof obj.type){var anyOf=convert3to4Type(obj.type);anyOf&&(obj.anyOf=anyOf,delete obj.type)}else"any"==obj.type&&delete obj.type;if(obj.extends){var allOf=obj.extends;Array.isArray(allOf)||(allOf=[allOf]),obj.allOf=allOf,delete obj.extends}if(obj.disallow&&("string"==typeof obj.disallow?obj.not={type:obj.disallow}:obj.not={anyOf:convert3to4Type(obj.disallow,!0)},delete obj.disallow),obj.properties){var required=Array.isArray(obj.required)?obj.required:[];for(var key in obj.properties){var subSchema=obj.properties[key];subSchema&&"boolean"==typeof subSchema.required&&(subSchema.required&&required.push(key),delete subSchema.required)}required.length&&(obj.required=required)}if(obj.dependencies)for(var key in obj.dependencies)"string"==typeof obj.dependencies[key]&&(obj.dependencies[key]=[obj.dependencies[key]]);"boolean"==typeof obj.required&&delete obj.required,"undefined"!=typeof obj.divisibleBy&&(obj.multipleOf=obj.divisibleBy,delete obj.divisibleBy);for(var key in obj)if("properties"===key||"patternProperties"===key||"dependencies"===key)for(var subKey in obj[key])obj[key][subKey]=convert3to4(obj[key][subKey]);else if("enum"!==key)if(Array.isArray(obj[key]))for(var i=0;i<obj[key].length;i++)obj[key][i]=convert3to4(obj[key][i]);else"object"==typeof obj[key]&&(obj[key]=convert3to4(obj[key]));return obj}var api={v4:convert3to4};return module.exports=api,api})()},function(module,exports,__webpack_require__){"use strict";function noop(){}function getThen(obj){try{return obj.then}catch(ex){return LAST_ERROR=ex,IS_ERROR}}function tryCallOne(fn,a){try{return fn(a)}catch(ex){return LAST_ERROR=ex,IS_ERROR}}function tryCallTwo(fn,a,b){try{fn(a,b)}catch(ex){return LAST_ERROR=ex,IS_ERROR}}function Promise(fn){if("object"!=typeof this)throw new TypeError("Promises must be constructed via new");if("function"!=typeof fn)throw new TypeError("not a function");this._45=0,this._81=0,this._65=null,this._54=null,fn!==noop&&doResolve(fn,this)}function safeThen(self,onFulfilled,onRejected){return new self.constructor(function(resolve,reject){var res=new Promise(noop);res.then(resolve,reject),handle(self,new Handler(onFulfilled,onRejected,res))})}function handle(self,deferred){for(;3===self._81;)self=self._65;return Promise._10&&Promise._10(self),0===self._81?0===self._45?(self._45=1,void(self._54=deferred)):1===self._45?(self._45=2,void(self._54=[self._54,deferred])):void self._54.push(deferred):void handleResolved(self,deferred)}function handleResolved(self,deferred){asap(function(){var cb=1===self._81?deferred.onFulfilled:deferred.onRejected;if(null===cb)return void(1===self._81?resolve(deferred.promise,self._65):reject(deferred.promise,self._65));var ret=tryCallOne(cb,self._65);ret===IS_ERROR?reject(deferred.promise,LAST_ERROR):resolve(deferred.promise,ret)})}function resolve(self,newValue){if(newValue===self)return reject(self,new TypeError("A promise cannot be resolved with itself."));if(newValue&&("object"==typeof newValue||"function"==typeof newValue)){var then=getThen(newValue);if(then===IS_ERROR)return reject(self,LAST_ERROR);if(then===self.then&&newValue instanceof Promise)return self._81=3,self._65=newValue,void finale(self);if("function"==typeof then)return void doResolve(then.bind(newValue),self)}self._81=1,self._65=newValue,finale(self)}function reject(self,newValue){self._81=2,self._65=newValue,Promise._97&&Promise._97(self,newValue),finale(self)}function finale(self){if(1===self._45&&(handle(self,self._54),self._54=null),2===self._45){for(var i=0;i<self._54.length;i++)handle(self,self._54[i]);self._54=null}}function Handler(onFulfilled,onRejected,promise){this.onFulfilled="function"==typeof onFulfilled?onFulfilled:null,this.onRejected="function"==typeof onRejected?onRejected:null,this.promise=promise}function doResolve(fn,promise){var done=!1,res=tryCallTwo(fn,function(value){done||(done=!0,resolve(promise,value))},function(reason){done||(done=!0,reject(promise,reason))});done||res!==IS_ERROR||(done=!0,reject(promise,LAST_ERROR))}var asap=__webpack_require__(234),LAST_ERROR=null,IS_ERROR={};module.exports=Promise,Promise._10=null,Promise._97=null,Promise._61=noop,Promise.prototype.then=function(onFulfilled,onRejected){if(this.constructor!==Promise)return safeThen(this,onFulfilled,onRejected);var res=new Promise(noop);return handle(this,new Handler(onFulfilled,onRejected,res)),res}},function(module,exports,__webpack_require__){"use strict";var Promise=__webpack_require__(184);module.exports=Promise,Promise.prototype.done=function(onFulfilled,onRejected){var self=arguments.length?this.then.apply(this,arguments):this;self.then(null,function(err){setTimeout(function(){throw err},0)})}},function(module,exports,__webpack_require__){"use strict";var Promise=__webpack_require__(184);module.exports=Promise,Promise.prototype.finally=function(f){return this.then(function(value){return Promise.resolve(f()).then(function(){return value})},function(err){return Promise.resolve(f()).then(function(){throw err})})}},function(module,exports,__webpack_require__){"use strict";function valuePromise(value){var p=new Promise(Promise._61);return p._81=1,p._65=value,p}var Promise=__webpack_require__(184);module.exports=Promise;var TRUE=valuePromise(!0),FALSE=valuePromise(!1),NULL=valuePromise(null),UNDEFINED=valuePromise(void 0),ZERO=valuePromise(0),EMPTYSTRING=valuePromise("");Promise.resolve=function(value){if(value instanceof Promise)return value;if(null===value)return NULL;if(void 0===value)return UNDEFINED;if(value===!0)return TRUE;if(value===!1)return FALSE;if(0===value)return ZERO;if(""===value)return EMPTYSTRING;if("object"==typeof value||"function"==typeof value)try{
var then=value.then;if("function"==typeof then)return new Promise(then.bind(value))}catch(ex){return new Promise(function(resolve,reject){reject(ex)})}return valuePromise(value)},Promise.all=function(arr){var args=Array.prototype.slice.call(arr);return new Promise(function(resolve,reject){function res(i,val){if(val&&("object"==typeof val||"function"==typeof val)){if(val instanceof Promise&&val.then===Promise.prototype.then){for(;3===val._81;)val=val._65;return 1===val._81?res(i,val._65):(2===val._81&&reject(val._65),void val.then(function(val){res(i,val)},reject))}var then=val.then;if("function"==typeof then){var p=new Promise(then.bind(val));return void p.then(function(val){res(i,val)},reject)}}args[i]=val,0===--remaining&&resolve(args)}if(0===args.length)return resolve([]);for(var remaining=args.length,i=0;i<args.length;i++)res(i,args[i])})},Promise.reject=function(value){return new Promise(function(resolve,reject){reject(value)})},Promise.race=function(values){return new Promise(function(resolve,reject){values.forEach(function(value){Promise.resolve(value).then(resolve,reject)})})},Promise.prototype.catch=function(onRejected){return this.then(null,onRejected)}},function(module,exports,__webpack_require__){"use strict";function denodeifyWithCount(fn,argumentCount){for(var args=[],i=0;i<argumentCount;i++)args.push("a"+i);var body=["return function ("+args.join(",")+") {","var self = this;","return new Promise(function (rs, rj) {","var res = fn.call(",["self"].concat(args).concat([callbackFn]).join(","),");","if (res &&",'(typeof res === "object" || typeof res === "function") &&','typeof res.then === "function"',") {rs(res);}","});","};"].join("");return Function(["Promise","fn"],body)(Promise,fn)}function denodeifyWithoutCount(fn){for(var fnLength=Math.max(fn.length-1,3),args=[],i=0;i<fnLength;i++)args.push("a"+i);var body=["return function ("+args.join(",")+") {","var self = this;","var args;","var argLength = arguments.length;","if (arguments.length > "+fnLength+") {","args = new Array(arguments.length + 1);","for (var i = 0; i < arguments.length; i++) {","args[i] = arguments[i];","}","}","return new Promise(function (rs, rj) {","var cb = "+callbackFn+";","var res;","switch (argLength) {",args.concat(["extra"]).map(function(_,index){return"case "+index+":res = fn.call("+["self"].concat(args.slice(0,index)).concat("cb").join(",")+");break;"}).join(""),"default:","args[argLength] = cb;","res = fn.apply(self, args);","}","if (res &&",'(typeof res === "object" || typeof res === "function") &&','typeof res.then === "function"',") {rs(res);}","});","};"].join("");return Function(["Promise","fn"],body)(Promise,fn)}var Promise=__webpack_require__(184),asap=__webpack_require__(250);module.exports=Promise,Promise.denodeify=function(fn,argumentCount){return"number"==typeof argumentCount&&argumentCount!==1/0?denodeifyWithCount(fn,argumentCount):denodeifyWithoutCount(fn)};var callbackFn="function (err, res) {if (err) { rj(err); } else { rs(res); }}";Promise.nodeify=function(fn){return function(){var args=Array.prototype.slice.call(arguments),callback="function"==typeof args[args.length-1]?args.pop():null,ctx=this;try{return fn.apply(this,arguments).nodeify(callback,ctx)}catch(ex){if(null===callback||"undefined"==typeof callback)return new Promise(function(resolve,reject){reject(ex)});asap(function(){callback.call(ctx,ex)})}}},Promise.prototype.nodeify=function(callback,ctx){return"function"!=typeof callback?this:void this.then(function(value){asap(function(){callback.call(ctx,null,value)})},function(err){asap(function(){callback.call(ctx,err)})})}},function(module,exports,__webpack_require__){"use strict";var Promise=__webpack_require__(184);module.exports=Promise,Promise.enableSynchronous=function(){Promise.prototype.isPending=function(){return 0==this.getState()},Promise.prototype.isFulfilled=function(){return 1==this.getState()},Promise.prototype.isRejected=function(){return 2==this.getState()},Promise.prototype.getValue=function(){if(3===this._81)return this._65.getValue();if(!this.isFulfilled())throw new Error("Cannot get a value of an unfulfilled promise.");return this._65},Promise.prototype.getReason=function(){if(3===this._81)return this._65.getReason();if(!this.isRejected())throw new Error("Cannot get a rejection reason of a non-rejected promise.");return this._65},Promise.prototype.getState=function(){return 3===this._81?this._65.getState():this._81===-1||this._81===-2?0:this._81}},Promise.disableSynchronous=function(){Promise.prototype.isPending=void 0,Promise.prototype.isFulfilled=void 0,Promise.prototype.isRejected=void 0,Promise.prototype.getValue=void 0,Promise.prototype.getReason=void 0,Promise.prototype.getState=void 0}},function(module,exports,__webpack_require__){(function(process){"use strict";function ZSchema(options){if(this.cache={},this.referenceCache=[],this.setRemoteReference("http://json-schema.org/draft-04/schema",Draft4Schema),this.setRemoteReference("http://json-schema.org/draft-04/hyper-schema",Draft4HyperSchema),"object"==typeof options){for(var key,keys=Object.keys(options),idx=keys.length;idx--;)if(key=keys[idx],void 0===defaultOptions[key])throw new Error("Unexpected option passed to constructor: "+key);for(keys=Object.keys(defaultOptions),idx=keys.length;idx--;)key=keys[idx],void 0===options[key]&&(options[key]=Utils.clone(defaultOptions[key]));this.options=options}else this.options=Utils.clone(defaultOptions);this.options.strictMode===!0&&(this.options.forceAdditional=!0,this.options.forceItems=!0,this.options.forceMaxLength=!0,this.options.forceProperties=!0,this.options.noExtraKeywords=!0,this.options.noTypeless=!0,this.options.noEmptyStrings=!0,this.options.noEmptyArrays=!0)}__webpack_require__(211);var get=__webpack_require__(233),Report=__webpack_require__(212),FormatValidators=__webpack_require__(213),JsonValidation=__webpack_require__(214),SchemaCache=__webpack_require__(215),SchemaCompilation=__webpack_require__(216),SchemaValidation=__webpack_require__(217),Utils=__webpack_require__(218),Draft4Schema=__webpack_require__(235),Draft4HyperSchema=__webpack_require__(236),defaultOptions={asyncTimeout:2e3,forceAdditional:!1,assumeAdditional:!1,forceItems:!1,forceMinItems:!1,forceMaxItems:!1,forceMinLength:!1,forceMaxLength:!1,forceProperties:!1,ignoreUnresolvableReferences:!1,noExtraKeywords:!1,noTypeless:!1,noEmptyStrings:!1,noEmptyArrays:!1,strictUris:!1,strictMode:!1,reportPathAsArray:!1,breakOnFirstError:!0,pedanticCheck:!1,ignoreUnknownFormats:!1,customValidator:null};ZSchema.prototype.compileSchema=function(schema){var report=new Report(this.options);return schema=SchemaCache.getSchema.call(this,report,schema),SchemaCompilation.compileSchema.call(this,report,schema),this.lastReport=report,report.isValid()},ZSchema.prototype.validateSchema=function(schema){if(Array.isArray(schema)&&0===schema.length)throw new Error(".validateSchema was called with an empty array");var report=new Report(this.options);schema=SchemaCache.getSchema.call(this,report,schema);var compiled=SchemaCompilation.compileSchema.call(this,report,schema);return compiled&&SchemaValidation.validateSchema.call(this,report,schema),this.lastReport=report,report.isValid()},ZSchema.prototype.validate=function(json,schema,options,callback){"function"===Utils.whatIs(options)&&(callback=options,options={}),options||(options={});var whatIs=Utils.whatIs(schema);if("string"!==whatIs&&"object"!==whatIs){var e=new Error("Invalid .validate call - schema must be an string or object but "+whatIs+" was passed!");if(callback)return void process.nextTick(function(){callback(e,!1)});throw e}var foundError=!1,report=new Report(this.options);if("string"==typeof schema){var schemaName=schema;if(schema=SchemaCache.getSchema.call(this,report,schemaName),!schema)throw new Error("Schema with id '"+schemaName+"' wasn't found in the validator cache!")}else schema=SchemaCache.getSchema.call(this,report,schema);var compiled=!1;foundError||(compiled=SchemaCompilation.compileSchema.call(this,report,schema)),compiled||(this.lastReport=report,foundError=!0);var validated=!1;if(foundError||(validated=SchemaValidation.validateSchema.call(this,report,schema)),validated||(this.lastReport=report,foundError=!0),options.schemaPath&&(report.rootSchema=schema,schema=get(schema,options.schemaPath),!schema))throw new Error("Schema path '"+options.schemaPath+"' wasn't found in the schema!");if(foundError||JsonValidation.validate.call(this,report,schema,json),callback)return void report.processAsyncTasks(this.options.asyncTimeout,callback);if(report.asyncTasks.length>0)throw new Error("This validation has async tasks and cannot be done in sync mode, please provide callback argument.");return this.lastReport=report,report.isValid()},ZSchema.prototype.getLastError=function(){if(0===this.lastReport.errors.length)return null;var e=new Error;return e.name="z-schema validation error",e.message=this.lastReport.commonErrorMessage,e.details=this.lastReport.errors,e},ZSchema.prototype.getLastErrors=function(){return this.lastReport&&this.lastReport.errors.length>0?this.lastReport.errors:void 0},ZSchema.prototype.getMissingReferences=function(arr){arr=arr||this.lastReport.errors;for(var res=[],idx=arr.length;idx--;){var error=arr[idx];if("UNRESOLVABLE_REFERENCE"===error.code){var reference=error.params[0];res.indexOf(reference)===-1&&res.push(reference)}error.inner&&(res=res.concat(this.getMissingReferences(error.inner)))}return res},ZSchema.prototype.getMissingRemoteReferences=function(){for(var missingReferences=this.getMissingReferences(),missingRemoteReferences=[],idx=missingReferences.length;idx--;){var remoteReference=SchemaCache.getRemotePath(missingReferences[idx]);remoteReference&&missingRemoteReferences.indexOf(remoteReference)===-1&&missingRemoteReferences.push(remoteReference)}return missingRemoteReferences},ZSchema.prototype.setRemoteReference=function(uri,schema){schema="string"==typeof schema?JSON.parse(schema):Utils.cloneDeep(schema),SchemaCache.cacheSchemaByUri.call(this,uri,schema)},ZSchema.prototype.getResolvedSchema=function(schema){var report=new Report(this.options);schema=SchemaCache.getSchema.call(this,report,schema),schema=Utils.cloneDeep(schema);var visited=[],cleanup=function(schema){var key,typeOf=Utils.whatIs(schema);if(("object"===typeOf||"array"===typeOf)&&!schema.___$visited){if(schema.___$visited=!0,visited.push(schema),schema.$ref&&schema.__$refResolved){var from=schema.__$refResolved,to=schema;delete schema.$ref,delete schema.__$refResolved;for(key in from)from.hasOwnProperty(key)&&(to[key]=from[key])}for(key in schema)schema.hasOwnProperty(key)&&(0===key.indexOf("__$")?delete schema[key]:cleanup(schema[key]))}};if(cleanup(schema),visited.forEach(function(s){delete s.___$visited}),this.lastReport=report,report.isValid())return schema;throw this.getLastError()},ZSchema.prototype.setSchemaReader=function(schemaReader){return ZSchema.setSchemaReader(schemaReader)},ZSchema.prototype.getSchemaReader=function(){return ZSchema.schemaReader},ZSchema.setSchemaReader=function(schemaReader){ZSchema.schemaReader=schemaReader},ZSchema.registerFormat=function(formatName,validatorFunction){FormatValidators[formatName]=validatorFunction},ZSchema.unregisterFormat=function(formatName){delete FormatValidators[formatName]},ZSchema.getRegisteredFormats=function(){return Object.keys(FormatValidators)},ZSchema.getDefaultOptions=function(){return Utils.cloneDeep(defaultOptions)},module.exports=ZSchema}).call(exports,__webpack_require__(59))},function(module,exports,__webpack_require__){"use strict";var Utils=__webpack_require__(219),internals={delimiter:"&",arrayPrefixGenerators:{brackets:function(prefix){return prefix+"[]"},indices:function(prefix,key){return prefix+"["+key+"]"},repeat:function(prefix){return prefix}},strictNullHandling:!1,skipNulls:!1,encode:!0};internals.stringify=function(object,prefix,generateArrayPrefix,strictNullHandling,skipNulls,encode,filter,sort,allowDots){var obj=object;if("function"==typeof filter)obj=filter(prefix,obj);else if(Utils.isBuffer(obj))obj=String(obj);else if(obj instanceof Date)obj=obj.toISOString();else if(null===obj){if(strictNullHandling)return encode?Utils.encode(prefix):prefix;obj=""}if("string"==typeof obj||"number"==typeof obj||"boolean"==typeof obj)return encode?[Utils.encode(prefix)+"="+Utils.encode(obj)]:[prefix+"="+obj];var values=[];if("undefined"==typeof obj)return values;var objKeys;if(Array.isArray(filter))objKeys=filter;else{var keys=Object.keys(obj);objKeys=sort?keys.sort(sort):keys}for(var i=0;i<objKeys.length;++i){var key=objKeys[i];skipNulls&&null===obj[key]||(values=Array.isArray(obj)?values.concat(internals.stringify(obj[key],generateArrayPrefix(prefix,key),generateArrayPrefix,strictNullHandling,skipNulls,encode,filter,sort,allowDots)):values.concat(internals.stringify(obj[key],prefix+(allowDots?"."+key:"["+key+"]"),generateArrayPrefix,strictNullHandling,skipNulls,encode,filter,sort,allowDots)))}return values},module.exports=function(object,opts){var objKeys,filter,obj=object,options=opts||{},delimiter="undefined"==typeof options.delimiter?internals.delimiter:options.delimiter,strictNullHandling="boolean"==typeof options.strictNullHandling?options.strictNullHandling:internals.strictNullHandling,skipNulls="boolean"==typeof options.skipNulls?options.skipNulls:internals.skipNulls,encode="boolean"==typeof options.encode?options.encode:internals.encode,sort="function"==typeof options.sort?options.sort:null,allowDots="undefined"!=typeof options.allowDots&&options.allowDots;"function"==typeof options.filter?(filter=options.filter,obj=filter("",obj)):Array.isArray(options.filter)&&(objKeys=filter=options.filter);var keys=[];if("object"!=typeof obj||null===obj)return"";var arrayFormat;arrayFormat=options.arrayFormat in internals.arrayPrefixGenerators?options.arrayFormat:"indices"in options?options.indices?"indices":"repeat":"indices";var generateArrayPrefix=internals.arrayPrefixGenerators[arrayFormat];objKeys||(objKeys=Object.keys(obj)),sort&&objKeys.sort(sort);for(var i=0;i<objKeys.length;++i){var key=objKeys[i];skipNulls&&null===obj[key]||(keys=keys.concat(internals.stringify(obj[key],key,generateArrayPrefix,strictNullHandling,skipNulls,encode,filter,sort,allowDots)))}return keys.join(delimiter)}},function(module,exports,__webpack_require__){"use strict";var Utils=__webpack_require__(219),internals={delimiter:"&",depth:5,arrayLimit:20,parameterLimit:1e3,strictNullHandling:!1,plainObjects:!1,allowPrototypes:!1,allowDots:!1};internals.parseValues=function(str,options){for(var obj={},parts=str.split(options.delimiter,options.parameterLimit===1/0?void 0:options.parameterLimit),i=0;i<parts.length;++i){var part=parts[i],pos=part.indexOf("]=")===-1?part.indexOf("="):part.indexOf("]=")+1;if(pos===-1)obj[Utils.decode(part)]="",options.strictNullHandling&&(obj[Utils.decode(part)]=null);else{var key=Utils.decode(part.slice(0,pos)),val=Utils.decode(part.slice(pos+1));Object.prototype.hasOwnProperty.call(obj,key)?obj[key]=[].concat(obj[key]).concat(val):obj[key]=val}}return obj},internals.parseObject=function(chain,val,options){if(!chain.length)return val;var obj,root=chain.shift();if("[]"===root)obj=[],obj=obj.concat(internals.parseObject(chain,val,options));else{obj=options.plainObjects?Object.create(null):{};var cleanRoot="["===root[0]&&"]"===root[root.length-1]?root.slice(1,root.length-1):root,index=parseInt(cleanRoot,10);!isNaN(index)&&root!==cleanRoot&&String(index)===cleanRoot&&index>=0&&options.parseArrays&&index<=options.arrayLimit?(obj=[],obj[index]=internals.parseObject(chain,val,options)):obj[cleanRoot]=internals.parseObject(chain,val,options)}return obj},internals.parseKeys=function(givenKey,val,options){if(givenKey){var key=options.allowDots?givenKey.replace(/\.([^\.\[]+)/g,"[$1]"):givenKey,parent=/^([^\[\]]*)/,child=/(\[[^\[\]]*\])/g,segment=parent.exec(key),keys=[];if(segment[1]){if(!options.plainObjects&&Object.prototype.hasOwnProperty(segment[1])&&!options.allowPrototypes)return;keys.push(segment[1])}for(var i=0;null!==(segment=child.exec(key))&&i<options.depth;)i+=1,(options.plainObjects||!Object.prototype.hasOwnProperty(segment[1].replace(/\[|\]/g,""))||options.allowPrototypes)&&keys.push(segment[1]);return segment&&keys.push("["+key.slice(segment.index)+"]"),internals.parseObject(keys,val,options)}},module.exports=function(str,opts){var options=opts||{};if(options.delimiter="string"==typeof options.delimiter||Utils.isRegExp(options.delimiter)?options.delimiter:internals.delimiter,options.depth="number"==typeof options.depth?options.depth:internals.depth,options.arrayLimit="number"==typeof options.arrayLimit?options.arrayLimit:internals.arrayLimit,options.parseArrays=options.parseArrays!==!1,options.allowDots="boolean"==typeof options.allowDots?options.allowDots:internals.allowDots,options.plainObjects="boolean"==typeof options.plainObjects?options.plainObjects:internals.plainObjects,options.allowPrototypes="boolean"==typeof options.allowPrototypes?options.allowPrototypes:internals.allowPrototypes,options.parameterLimit="number"==typeof options.parameterLimit?options.parameterLimit:internals.parameterLimit,options.strictNullHandling="boolean"==typeof options.strictNullHandling?options.strictNullHandling:internals.strictNullHandling,""===str||null===str||"undefined"==typeof str)return options.plainObjects?Object.create(null):{};for(var tempObj="string"==typeof str?internals.parseValues(str,options):str,obj=options.plainObjects?Object.create(null):{},keys=Object.keys(tempObj),i=0;i<keys.length;++i){var key=keys[i],newObj=internals.parseKeys(key,tempObj[key],options);obj=Utils.merge(obj,newObj,options)}return Utils.compact(obj)}},function(module,exports,__webpack_require__){},function(module,exports,__webpack_require__){},function(module,exports,__webpack_require__){(function(process){"use strict";function nextTick(fn){for(var args=new Array(arguments.length-1),i=0;i<args.length;)args[i++]=arguments[i];process.nextTick(function(){fn.apply(null,args)})}!process.version||0===process.version.indexOf("v0.")||0===process.version.indexOf("v1.")&&0!==process.version.indexOf("v1.8.")?module.exports=nextTick:module.exports=process.nextTick}).call(exports,__webpack_require__(59))},function(module,exports,__webpack_require__){function EventEmitter(){this._events=this._events||{},this._maxListeners=this._maxListeners||void 0}function isFunction(arg){return"function"==typeof arg}function isNumber(arg){return"number"==typeof arg}function isObject(arg){return"object"==typeof arg&&null!==arg}function isUndefined(arg){return void 0===arg}module.exports=EventEmitter,EventEmitter.EventEmitter=EventEmitter,EventEmitter.prototype._events=void 0,EventEmitter.prototype._maxListeners=void 0,EventEmitter.defaultMaxListeners=10,EventEmitter.prototype.setMaxListeners=function(n){if(!isNumber(n)||n<0||isNaN(n))throw TypeError("n must be a positive number");return this._maxListeners=n,this},EventEmitter.prototype.emit=function(type){var er,handler,len,args,i,listeners;if(this._events||(this._events={}),"error"===type&&(!this._events.error||isObject(this._events.error)&&!this._events.error.length)){if(er=arguments[1],er instanceof Error)throw er;throw TypeError('Uncaught, unspecified "error" event.')}if(handler=this._events[type],isUndefined(handler))return!1;if(isFunction(handler))switch(arguments.length){case 1:handler.call(this);break;case 2:handler.call(this,arguments[1]);break;case 3:handler.call(this,arguments[1],arguments[2]);break;default:args=Array.prototype.slice.call(arguments,1),handler.apply(this,args)}else if(isObject(handler))for(args=Array.prototype.slice.call(arguments,1),listeners=handler.slice(),len=listeners.length,i=0;i<len;i++)listeners[i].apply(this,args);return!0},EventEmitter.prototype.addListener=function(type,listener){var m;if(!isFunction(listener))throw TypeError("listener must be a function");return this._events||(this._events={}),this._events.newListener&&this.emit("newListener",type,isFunction(listener.listener)?listener.listener:listener),this._events[type]?isObject(this._events[type])?this._events[type].push(listener):this._events[type]=[this._events[type],listener]:this._events[type]=listener,isObject(this._events[type])&&!this._events[type].warned&&(m=isUndefined(this._maxListeners)?EventEmitter.defaultMaxListeners:this._maxListeners,m&&m>0&&this._events[type].length>m&&(this._events[type].warned=!0,console.error("(node) warning: possible EventEmitter memory leak detected. %d listeners added. Use emitter.setMaxListeners() to increase limit.",this._events[type].length),"function"==typeof console.trace&&console.trace())),this},EventEmitter.prototype.on=EventEmitter.prototype.addListener,EventEmitter.prototype.once=function(type,listener){function g(){this.removeListener(type,g),fired||(fired=!0,listener.apply(this,arguments))}if(!isFunction(listener))throw TypeError("listener must be a function");var fired=!1;return g.listener=listener,this.on(type,g),this},EventEmitter.prototype.removeListener=function(type,listener){var list,position,length,i;if(!isFunction(listener))throw TypeError("listener must be a function");if(!this._events||!this._events[type])return this;if(list=this._events[type],length=list.length,position=-1,list===listener||isFunction(list.listener)&&list.listener===listener)delete this._events[type],this._events.removeListener&&this.emit("removeListener",type,listener);else if(isObject(list)){for(i=length;i-- >0;)if(list[i]===listener||list[i].listener&&list[i].listener===listener){position=i;break}if(position<0)return this;1===list.length?(list.length=0,delete this._events[type]):list.splice(position,1),this._events.removeListener&&this.emit("removeListener",type,listener)}return this},EventEmitter.prototype.removeAllListeners=function(type){var key,listeners;if(!this._events)return this;if(!this._events.removeListener)return 0===arguments.length?this._events={}:this._events[type]&&delete this._events[type],this;if(0===arguments.length){for(key in this._events)"removeListener"!==key&&this.removeAllListeners(key);return this.removeAllListeners("removeListener"),this._events={},this}if(listeners=this._events[type],isFunction(listeners))this.removeListener(type,listeners);else if(listeners)for(;listeners.length;)this.removeListener(type,listeners[listeners.length-1]);return delete this._events[type],this},EventEmitter.prototype.listeners=function(type){var ret;return ret=this._events&&this._events[type]?isFunction(this._events[type])?[this._events[type]]:this._events[type].slice():[]},EventEmitter.prototype.listenerCount=function(type){if(this._events){var evlistener=this._events[type];if(isFunction(evlistener))return 1;if(evlistener)return evlistener.length}return 0},EventEmitter.listenerCount=function(emitter,type){return emitter.listenerCount(type)}},function(module,exports,__webpack_require__){var toString={}.toString;module.exports=Array.isArray||function(arr){return"[object Array]"==toString.call(arr)}},function(module,exports,__webpack_require__){function assertEncoding(encoding){if(encoding&&!isBufferEncoding(encoding))throw new Error("Unknown encoding: "+encoding)}function passThroughWrite(buffer){return buffer.toString(this.encoding)}function utf16DetectIncompleteChar(buffer){this.charReceived=buffer.length%2,this.charLength=this.charReceived?2:0}function base64DetectIncompleteChar(buffer){this.charReceived=buffer.length%3,this.charLength=this.charReceived?3:0}var Buffer=__webpack_require__(92).Buffer,isBufferEncoding=Buffer.isEncoding||function(encoding){switch(encoding&&encoding.toLowerCase()){case"hex":case"utf8":case"utf-8":case"ascii":case"binary":case"base64":case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":case"raw":return!0;default:return!1}},StringDecoder=exports.StringDecoder=function(encoding){switch(this.encoding=(encoding||"utf8").toLowerCase().replace(/[-_]/,""),assertEncoding(encoding),this.encoding){case"utf8":this.surrogateSize=3;break;case"ucs2":case"utf16le":this.surrogateSize=2,this.detectIncompleteChar=utf16DetectIncompleteChar;break;case"base64":this.surrogateSize=3,this.detectIncompleteChar=base64DetectIncompleteChar;break;default:return void(this.write=passThroughWrite)}this.charBuffer=new Buffer(6),this.charReceived=0,this.charLength=0};StringDecoder.prototype.write=function(buffer){for(var charStr="";this.charLength;){var available=buffer.length>=this.charLength-this.charReceived?this.charLength-this.charReceived:buffer.length;if(buffer.copy(this.charBuffer,this.charReceived,0,available),this.charReceived+=available,this.charReceived<this.charLength)return"";buffer=buffer.slice(available,buffer.length),charStr=this.charBuffer.slice(0,this.charLength).toString(this.encoding);var charCode=charStr.charCodeAt(charStr.length-1);if(!(charCode>=55296&&charCode<=56319)){if(this.charReceived=this.charLength=0,0===buffer.length)return charStr;break}this.charLength+=this.surrogateSize,charStr=""}this.detectIncompleteChar(buffer);var end=buffer.length;this.charLength&&(buffer.copy(this.charBuffer,0,buffer.length-this.charReceived,end),end-=this.charReceived),charStr+=buffer.toString(this.encoding,0,end);var end=charStr.length-1,charCode=charStr.charCodeAt(end);if(charCode>=55296&&charCode<=56319){var size=this.surrogateSize;return this.charLength+=size,this.charReceived+=size,this.charBuffer.copy(this.charBuffer,size,0,size),buffer.copy(this.charBuffer,0,0,size),charStr.substring(0,end)}return charStr},StringDecoder.prototype.detectIncompleteChar=function(buffer){for(var i=buffer.length>=3?3:buffer.length;i>0;i--){var c=buffer[buffer.length-i];if(1==i&&c>>5==6){this.charLength=2;break}if(i<=2&&c>>4==14){this.charLength=3;break}if(i<=3&&c>>3==30){this.charLength=4;break}}this.charReceived=i},StringDecoder.prototype.end=function(buffer){var res="";if(buffer&&buffer.length&&(res=this.write(buffer)),this.charReceived){var cr=this.charReceived,buf=this.charBuffer,enc=this.encoding;res+=buf.slice(0,cr).toString(enc)}return res}},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__;!function(global){"use strict";var date={},lang="en",locales={en:{MMMM:["January","February","March","April","May","June","July","August","September","October","November","December"],MMM:["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"],dddd:["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"],ddd:["Sun","Mon","Tue","Wed","Thu","Fri","Sat"],dd:["Su","Mo","Tu","We","Th","Fr","Sa"],A:["a.m.","p.m."],formats:{YYYY:function(d){return("000"+d.getFullYear()).slice(-4)},YY:function(d){return("0"+d.getFullYear()).slice(-2)},Y:function(d){return""+d.getFullYear()},MMMM:function(d){return this.MMMM[d.getMonth()]},MMM:function(d){return this.MMM[d.getMonth()]},MM:function(d){return("0"+(d.getMonth()+1)).slice(-2)},M:function(d){return""+(d.getMonth()+1)},DD:function(d){return("0"+d.getDate()).slice(-2)},D:function(d){return""+d.getDate()},HH:function(d){return("0"+d.getHours()).slice(-2)},H:function(d){return""+d.getHours()},A:function(d){return this.A[d.getHours()>11|0]},hh:function(d){return("0"+(d.getHours()%12||12)).slice(-2)},h:function(d){return""+(d.getHours()%12||12)},mm:function(d){return("0"+d.getMinutes()).slice(-2)},m:function(d){return""+d.getMinutes()},ss:function(d){return("0"+d.getSeconds()).slice(-2)},s:function(d){return""+d.getSeconds()},SSS:function(d){return("00"+d.getMilliseconds()).slice(-3)},SS:function(d){return("0"+(d.getMilliseconds()/10|0)).slice(-2)},S:function(d){return""+(d.getMilliseconds()/100|0)},dddd:function(d){return this.dddd[d.getDay()]},ddd:function(d){return this.ddd[d.getDay()]},dd:function(d){return this.dd[d.getDay()]},Z:function(d){var offset=d.utc?0:d.getTimezoneOffset()/.6;return(offset>0?"-":"+")+("000"+Math.abs(offset-offset%100*.4)).slice(-4)},post:function(str){return str}},parsers:{h:function(h,a){return(12===h?0:h)+12*a},pre:function(str){return str}}}},isCommonJS=function(){return"object"==typeof module&&"object"==typeof module.exports},forEach=function(array,fn){for(var i=0,len=array.length;i<len&&0!==fn(array[i],i);i++);},parse=function(dateString,formatString){var k,length,str,offset=0,keys=formatString.match(/YYYY|YY|MMM?M?|DD|HH|hh|mm|ss|SSS?|./g),dt={Y:0,M:1,D:1,A:0,H:0,h:0,m:0,s:0,S:0};return dateString=locales[lang].parsers.pre(dateString),forEach(keys,function(key){k=key.charAt(0),length=key.length,str=dateString.slice(offset),/^(MM|DD|HH|hh|mm|ss|SS?S?)$/.test(key)?dt[k]=0|str.slice(0,length):/^(YYYY|YY|M|D|H|h|m|s)$/.test(key)?(str=(str.match(4===length?/^\d{1,4}/:/^\d\d?/)||[""])[0],length=str.length,dt[k]=0|str,"Y"===k&&dt.Y<70&&(dt.Y+=2e3)):/^(MMMM?|A)$/.test(key)&&forEach(locales[lang][key],function(val,i){if(!str.indexOf(val))return dt[k]="M"===k?i+1:i,length=val.length,0}),offset+=length}),dt},toH=function(h,a){return locales[lang].parsers.h(h,a)};date.format=function(dateObj,formatString,utc){var d=new Date(dateObj.getTime()+(utc?6e4*dateObj.getTimezoneOffset():0)),locale=locales[lang],formats=locale.formats;return d.utc=utc,formatString.replace(/(\[[^\[\]]*]|\[.*\][^\[]*\]|YYYY|YY|MMM?M?|DD|HH|hh|mm|ss|SSS?|ddd?d?|.)/g,function(token){var format=formats[token];return format?formats.post(format.call(locale,d)):token.replace(/\[(.*)]/,"$1")})},date.parse=function(dateString,formatString,utc){var dt=parse(dateString,formatString),dateObj=new Date(dt.Y,dt.M-1,dt.D,dt.H||toH(dt.h,dt.A),dt.m,dt.s,dt.S);return utc?new Date(dateObj.getTime()-6e4*dateObj.getTimezoneOffset()):dateObj},date.isValid=function(dateString,formatString){var dt=parse(dateString,formatString),H=dt.H||toH(dt.h,dt.A),d=new Date(dt.Y,dt.M-1,dt.D,H,dt.m,dt.s,dt.S);return dt.Y===d.getFullYear()&&dt.M-1===d.getMonth()&&dt.D===d.getDate()&&H===d.getHours()&&dt.m===d.getMinutes()&&dt.s===d.getSeconds()&&dt.S===d.getMilliseconds()},date.addYears=function(dateObj,years){var d=new Date(dateObj.getTime());return d.setFullYear(d.getFullYear()+years),d},date.addMonths=function(dateObj,months){var d=new Date(dateObj.getTime());return d.setMonth(d.getMonth()+months),d},date.addDays=function(dateObj,days){return new Date(dateObj.getTime()+864e5*days)},date.addHours=function(dateObj,hours){return new Date(dateObj.getTime()+36e5*hours)},date.addMinutes=function(dateObj,minutes){return new Date(dateObj.getTime()+6e4*minutes)},date.addSeconds=function(dateObj,seconds){return new Date(dateObj.getTime()+1e3*seconds)},date.addMilliseconds=function(dateObj,milliseconds){return new Date(dateObj.getTime()+milliseconds)},date.subtract=function(date1,date2){var delta=date1.getTime()-date2.getTime();return{toMilliseconds:function(){return delta},toSeconds:function(){return delta/1e3|0},toMinutes:function(){return delta/6e4|0},toHours:function(){return delta/36e5|0},toDays:function(){return delta/864e5|0}}},date.isLeapYear=function(dateObj){var y=dateObj.getFullYear();return!((y%4||!(y%100))&&y%400)},date.locale=function(code){return code&&("en"!==code&&isCommonJS()&&__webpack_require__(226)("./"+code),lang=code),lang},date.getLocales=function(code){return locales[code||lang]},date.setLocales=function(code,options){var copy=function(src,proto){var dst,key,Locale=function(){};Locale.prototype=proto,dst=new Locale;for(key in src)src.hasOwnProperty(key)&&(dst[key]=src[key]);return dst},base=locales[code]||locales.en,locale=copy(options,base);options.formats&&(locale.formats=copy(options.formats,base.formats)),options.parsers&&(locale.parsers=copy(options.parsers,base.parsers)),locales[code]=locale},isCommonJS()?module.exports=date:(__WEBPACK_AMD_DEFINE_ARRAY__=[],__WEBPACK_AMD_DEFINE_RESULT__=function(){return date}.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__),!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__)))}(this)},function(module,exports,__webpack_require__){(function(Buffer){var xmllint={},errrCount=0;!function(){var module=void 0,process=void 0,require=void 0;if("undefined"==typeof window)var window={};xmllint.validateXML=function(options){
function globalEval(x){eval.call(null,x)}function assert(condition,text){condition||abort("Assertion failed: "+text)}function getCFunc(ident){var func=Module["_"+ident];if(!func)try{func=eval("_"+ident)}catch(e){}return assert(func,"Cannot call unknown function "+ident+" (perhaps LLVM optimizations or closure removed it?)"),func}function setValue(ptr,value,type,noSafe){switch(type=type||"i8","*"===type.charAt(type.length-1)&&(type="i32"),type){case"i1":HEAP8[ptr>>0]=value;break;case"i8":HEAP8[ptr>>0]=value;break;case"i16":HEAP16[ptr>>1]=value;break;case"i32":HEAP32[ptr>>2]=value;break;case"i64":tempI64=[value>>>0,(tempDouble=value,+Math_abs(tempDouble)>=1?tempDouble>0?(0|Math_min(+Math_floor(tempDouble/4294967296),4294967295))>>>0:~~+Math_ceil((tempDouble-+(~~tempDouble>>>0))/4294967296)>>>0:0)],HEAP32[ptr>>2]=tempI64[0],HEAP32[ptr+4>>2]=tempI64[1];break;case"float":HEAPF32[ptr>>2]=value;break;case"double":HEAPF64[ptr>>3]=value;break;default:abort("invalid type for setValue: "+type)}}function getValue(ptr,type,noSafe){switch(type=type||"i8","*"===type.charAt(type.length-1)&&(type="i32"),type){case"i1":return HEAP8[ptr>>0];case"i8":return HEAP8[ptr>>0];case"i16":return HEAP16[ptr>>1];case"i32":return HEAP32[ptr>>2];case"i64":return HEAP32[ptr>>2];case"float":return HEAPF32[ptr>>2];case"double":return HEAPF64[ptr>>3];default:abort("invalid type for setValue: "+type)}return null}function allocate(slab,types,allocator,ptr){var zeroinit,size;"number"==typeof slab?(zeroinit=!0,size=slab):(zeroinit=!1,size=slab.length);var ret,singleType="string"==typeof types?types:null;if(ret=allocator==ALLOC_NONE?ptr:[_malloc,Runtime.stackAlloc,Runtime.staticAlloc,Runtime.dynamicAlloc][void 0===allocator?ALLOC_STATIC:allocator](Math.max(size,singleType?1:types.length)),zeroinit){var stop,ptr=ret;for(assert(0==(3&ret)),stop=ret+(size&-4);ptr<stop;ptr+=4)HEAP32[ptr>>2]=0;for(stop=ret+size;ptr<stop;)HEAP8[ptr++>>0]=0;return ret}if("i8"===singleType)return slab.subarray||slab.slice?HEAPU8.set(slab,ret):HEAPU8.set(new Uint8Array(slab),ret),ret;for(var type,typeSize,previousType,i=0;i<size;){var curr=slab[i];"function"==typeof curr&&(curr=Runtime.getFunctionIndex(curr)),type=singleType||types[i],0!==type?("i64"==type&&(type="i32"),setValue(ret+i,curr,type),previousType!==type&&(typeSize=Runtime.getNativeTypeSize(type),previousType=type),i+=typeSize):i++}return ret}function Pointer_stringify(ptr,length){if(0===length||!ptr)return"";for(var t,hasUtf=!1,i=0;;){if(t=HEAPU8[ptr+i>>0],t>=128)hasUtf=!0;else if(0==t&&!length)break;if(i++,length&&i==length)break}length||(length=i);var ret="";if(!hasUtf){for(var curr,MAX_CHUNK=1024;length>0;)curr=String.fromCharCode.apply(String,HEAPU8.subarray(ptr,ptr+Math.min(length,MAX_CHUNK))),ret=ret?ret+curr:curr,ptr+=MAX_CHUNK,length-=MAX_CHUNK;return ret}var utf8=new Runtime.UTF8Processor;for(i=0;i<length;i++)t=HEAPU8[ptr+i>>0],ret+=utf8.processCChar(t);return ret}function UTF16ToString(ptr){for(var i=0,str="";;){var codeUnit=HEAP16[ptr+2*i>>1];if(0==codeUnit)return str;++i,str+=String.fromCharCode(codeUnit)}}function stringToUTF16(str,outPtr){for(var i=0;i<str.length;++i){var codeUnit=str.charCodeAt(i);HEAP16[outPtr+2*i>>1]=codeUnit}HEAP16[outPtr+2*str.length>>1]=0}function UTF32ToString(ptr){for(var i=0,str="";;){var utf32=HEAP32[ptr+4*i>>2];if(0==utf32)return str;if(++i,utf32>=65536){var ch=utf32-65536;str+=String.fromCharCode(55296|ch>>10,56320|1023&ch)}else str+=String.fromCharCode(utf32)}}function stringToUTF32(str,outPtr){for(var iChar=0,iCodeUnit=0;iCodeUnit<str.length;++iCodeUnit){var codeUnit=str.charCodeAt(iCodeUnit);if(codeUnit>=55296&&codeUnit<=57343){var trailSurrogate=str.charCodeAt(++iCodeUnit);codeUnit=65536+((1023&codeUnit)<<10)|1023&trailSurrogate}HEAP32[outPtr+4*iChar>>2]=codeUnit,++iChar}HEAP32[outPtr+4*iChar>>2]=0}function demangle(func){function parseNested(){i++,"K"===func[i]&&i++;for(var parts=[];"E"!==func[i];)if("S"!==func[i])if("C"!==func[i]){var size=parseInt(func.substr(i)),pre=size.toString().length;if(!size||!pre){i--;break}var curr=func.substr(i+pre,size);parts.push(curr),subs.push(curr),i+=pre+size}else parts.push(parts[parts.length-1]),i+=2;else{i++;var next=func.indexOf("_",i),num=func.substring(i,next)||0;parts.push(subs[num]||"?"),i=next+1}return i++,parts}function parse(rawList,limit,allowVoid){function flushList(){return"("+list.join(", ")+")"}limit=limit||1/0;var name,ret="",list=[];if("N"===func[i]){if(name=parseNested().join("::"),limit--,0===limit)return rawList?[name]:name}else{("K"===func[i]||first&&"L"===func[i])&&i++;var size=parseInt(func.substr(i));if(size){var pre=size.toString().length;name=func.substr(i+pre,size),i+=pre+size}}if(first=!1,"I"===func[i]){i++;var iList=parse(!0),iRet=parse(!0,1,!0);ret+=iRet[0]+" "+name+"<"+iList.join(", ")+">"}else ret=name;paramLoop:for(;i<func.length&&limit-- >0;){var c=func[i++];if(c in basicTypes)list.push(basicTypes[c]);else switch(c){case"P":list.push(parse(!0,1,!0)[0]+"*");break;case"R":list.push(parse(!0,1,!0)[0]+"&");break;case"L":i++;var end=func.indexOf("E",i),size=end-i;list.push(func.substr(i,size)),i+=size+2;break;case"A":var size=parseInt(func.substr(i));if(i+=size.toString().length,"_"!==func[i])throw"?";i++,list.push(parse(!0,1,!0)[0]+" ["+size+"]");break;case"E":break paramLoop;default:ret+="?"+c;break paramLoop}}return allowVoid||1!==list.length||"void"!==list[0]||(list=[]),rawList?(ret&&list.push(ret+"?"),list):ret+flushList()}var hasLibcxxabi=!!Module.___cxa_demangle;if(hasLibcxxabi)try{var buf=_malloc(func.length);writeStringToMemory(func.substr(1),buf);var status=_malloc(4),ret=Module.___cxa_demangle(buf,0,0,status);if(0===getValue(status,"i32")&&ret)return Pointer_stringify(ret)}catch(e){}finally{buf&&_free(buf),status&&_free(status),ret&&_free(ret)}var i=3,basicTypes={v:"void",b:"bool",c:"char",s:"short",i:"int",l:"long",f:"float",d:"double",w:"wchar_t",a:"signed char",h:"unsigned char",t:"unsigned short",j:"unsigned int",m:"unsigned long",x:"long long",y:"unsigned long long",z:"..."},subs=[],first=!0,parsed=func;try{if("Object._main"==func||"_main"==func)return"main()";if("number"==typeof func&&(func=Pointer_stringify(func)),"_"!==func[0])return func;if("_"!==func[1])return func;if("Z"!==func[2])return func;switch(func[3]){case"n":return"operator new()";case"d":return"operator delete()"}parsed=parse()}catch(e){parsed+="?"}return parsed.indexOf("?")>=0&&!hasLibcxxabi&&Runtime.warnOnce("warning: a problem occurred in builtin C++ name demangling; build with  -s DEMANGLE_SUPPORT=1  to link in libcxxabi demangling"),parsed}function demangleAll(text){return text.replace(/__Z[\w\d_]+/g,function(x){var y=demangle(x);return x===y?x:x+" ["+y+"]"})}function jsStackTrace(){var err=new Error;if(!err.stack){try{throw new Error(0)}catch(e){err=e}if(!err.stack)return"(no stack trace available)"}return err.stack.toString()}function stackTrace(){return demangleAll(jsStackTrace())}function alignMemoryPage(x){return x+4095&-4096}function enlargeMemory(){abort("Cannot enlarge memory arrays. Either (1) compile with -s TOTAL_MEMORY=X with X higher than the current value "+TOTAL_MEMORY+", (2) compile with ALLOW_MEMORY_GROWTH which adjusts the size at runtime but prevents some optimizations, or (3) set Module.TOTAL_MEMORY before the program runs.")}function callRuntimeCallbacks(callbacks){for(;callbacks.length>0;){var callback=callbacks.shift();if("function"!=typeof callback){var func=callback.func;"number"==typeof func?void 0===callback.arg?Runtime.dynCall("v",func):Runtime.dynCall("vi",func,[callback.arg]):func(void 0===callback.arg?null:callback.arg)}else callback()}}function preRun(){if(Module.preRun)for("function"==typeof Module.preRun&&(Module.preRun=[Module.preRun]);Module.preRun.length;)addOnPreRun(Module.preRun.shift());callRuntimeCallbacks(__ATPRERUN__)}function ensureInitRuntime(){runtimeInitialized||(runtimeInitialized=!0,callRuntimeCallbacks(__ATINIT__))}function preMain(){callRuntimeCallbacks(__ATMAIN__)}function exitRuntime(){callRuntimeCallbacks(__ATEXIT__),runtimeExited=!0}function postRun(){if(Module.postRun)for("function"==typeof Module.postRun&&(Module.postRun=[Module.postRun]);Module.postRun.length;)addOnPostRun(Module.postRun.shift());callRuntimeCallbacks(__ATPOSTRUN__)}function addOnPreRun(cb){__ATPRERUN__.unshift(cb)}function addOnInit(cb){__ATINIT__.unshift(cb)}function addOnPreMain(cb){__ATMAIN__.unshift(cb)}function addOnExit(cb){__ATEXIT__.unshift(cb)}function addOnPostRun(cb){__ATPOSTRUN__.unshift(cb)}function intArrayFromString(stringy,dontAddNull,length){var ret=(new Runtime.UTF8Processor).processJSString(stringy);return length&&(ret.length=length),dontAddNull||ret.push(0),ret}function intArrayToString(array){for(var ret=[],i=0;i<array.length;i++){var chr=array[i];chr>255&&(chr&=255),ret.push(String.fromCharCode(chr))}return ret.join("")}function writeStringToMemory(string,buffer,dontAddNull){for(var array=intArrayFromString(string,dontAddNull),i=0;i<array.length;){var chr=array[i];HEAP8[buffer+i>>0]=chr,i+=1}}function writeArrayToMemory(array,buffer){for(var i=0;i<array.length;i++)HEAP8[buffer+i>>0]=array[i]}function writeAsciiToMemory(str,buffer,dontAddNull){for(var i=0;i<str.length;i++)HEAP8[buffer+i>>0]=str.charCodeAt(i);dontAddNull||(HEAP8[buffer+str.length>>0]=0)}function unSign(value,bits,ignore){return value>=0?value:bits<=32?2*Math.abs(1<<bits-1)+value:Math.pow(2,bits)+value}function reSign(value,bits,ignore){if(value<=0)return value;var half=bits<=32?Math.abs(1<<bits-1):Math.pow(2,bits-1);return value>=half&&(bits<=32||value>half)&&(value=-2*half+value),value}function addRunDependency(id){runDependencies++,Module.monitorRunDependencies&&Module.monitorRunDependencies(runDependencies)}function removeRunDependency(id){if(runDependencies--,Module.monitorRunDependencies&&Module.monitorRunDependencies(runDependencies),0==runDependencies&&(null!==runDependencyWatcher&&(clearInterval(runDependencyWatcher),runDependencyWatcher=null),dependenciesFulfilled)){var callback=dependenciesFulfilled;dependenciesFulfilled=null,callback()}}function copyTempFloat(ptr){HEAP8[tempDoublePtr]=HEAP8[ptr],HEAP8[tempDoublePtr+1]=HEAP8[ptr+1],HEAP8[tempDoublePtr+2]=HEAP8[ptr+2],HEAP8[tempDoublePtr+3]=HEAP8[ptr+3]}function copyTempDouble(ptr){HEAP8[tempDoublePtr]=HEAP8[ptr],HEAP8[tempDoublePtr+1]=HEAP8[ptr+1],HEAP8[tempDoublePtr+2]=HEAP8[ptr+2],HEAP8[tempDoublePtr+3]=HEAP8[ptr+3],HEAP8[tempDoublePtr+4]=HEAP8[ptr+4],HEAP8[tempDoublePtr+5]=HEAP8[ptr+5],HEAP8[tempDoublePtr+6]=HEAP8[ptr+6],HEAP8[tempDoublePtr+7]=HEAP8[ptr+7]}function ___assert_fail(condition,filename,line,func){throw ABORT=!0,"Assertion failed: "+Pointer_stringify(condition)+", at: "+[filename?Pointer_stringify(filename):"unknown filename",line,func?Pointer_stringify(func):"unknown function"]+" at "+stackTrace()}function ___setErrNo(value){return HEAP32[___errno_state>>2]=value,value}function _fflush(stream){}function _mkport(){throw"TODO"}function _recv(fd,buf,len,flags){var sock=SOCKFS.getSocket(fd);return sock?_read(fd,buf,len):(___setErrNo(ERRNO_CODES.EBADF),-1)}function _pread(fildes,buf,nbyte,offset){var stream=FS.getStream(fildes);if(!stream)return ___setErrNo(ERRNO_CODES.EBADF),-1;try{var slab=HEAP8;return FS.read(stream,slab,buf,nbyte,offset)}catch(e){return FS.handleFSError(e),-1}}function _read(fildes,buf,nbyte){var stream=FS.getStream(fildes);if(!stream)return ___setErrNo(ERRNO_CODES.EBADF),-1;try{var slab=HEAP8;return FS.read(stream,slab,buf,nbyte)}catch(e){return FS.handleFSError(e),-1}}function _fread(ptr,size,nitems,stream){var bytesToRead=nitems*size;if(0==bytesToRead)return 0;var bytesRead=0,streamObj=FS.getStreamFromPtr(stream);if(!streamObj)return ___setErrNo(ERRNO_CODES.EBADF),0;for(;streamObj.ungotten.length&&bytesToRead>0;)HEAP8[ptr++>>0]=streamObj.ungotten.pop(),bytesToRead--,bytesRead++;var err=_read(streamObj.fd,ptr,bytesToRead);return err==-1?(streamObj&&(streamObj.error=!0),0):(bytesRead+=err,bytesRead<bytesToRead&&(streamObj.eof=!0),bytesRead/size|0)}function _close(fildes){var stream=FS.getStream(fildes);if(!stream)return ___setErrNo(ERRNO_CODES.EBADF),-1;try{return FS.close(stream),0}catch(e){return FS.handleFSError(e),-1}}function _fsync(fildes){var stream=FS.getStream(fildes);return stream?0:(___setErrNo(ERRNO_CODES.EBADF),-1)}function _fileno(stream){return stream=FS.getStreamFromPtr(stream),stream?stream.fd:-1}function _fclose(stream){var fd=_fileno(stream);return _fsync(fd),_close(fd)}function _strerror_r(errnum,strerrbuf,buflen){if(errnum in ERRNO_MESSAGES){if(ERRNO_MESSAGES[errnum].length>buflen-1)return ___setErrNo(ERRNO_CODES.ERANGE);var msg=ERRNO_MESSAGES[errnum];return writeAsciiToMemory(msg,strerrbuf),0}return ___setErrNo(ERRNO_CODES.EINVAL)}function _strerror(errnum){return _strerror.buffer||(_strerror.buffer=_malloc(256)),_strerror_r(errnum,_strerror.buffer,256),_strerror.buffer}function _send(fd,buf,len,flags){var sock=SOCKFS.getSocket(fd);return sock?_write(fd,buf,len):(___setErrNo(ERRNO_CODES.EBADF),-1)}function _pwrite(fildes,buf,nbyte,offset){var stream=FS.getStream(fildes);if(!stream)return ___setErrNo(ERRNO_CODES.EBADF),-1;try{var slab=HEAP8;return FS.write(stream,slab,buf,nbyte,offset)}catch(e){return FS.handleFSError(e),-1}}function _write(fildes,buf,nbyte){var stream=FS.getStream(fildes);if(!stream)return ___setErrNo(ERRNO_CODES.EBADF),-1;try{var slab=HEAP8;return FS.write(stream,slab,buf,nbyte)}catch(e){return FS.handleFSError(e),-1}}function _fwrite(ptr,size,nitems,stream){var bytesToWrite=nitems*size;if(0==bytesToWrite)return 0;var fd=_fileno(stream),bytesWritten=_write(fd,ptr,bytesToWrite);if(bytesWritten==-1){var streamObj=FS.getStreamFromPtr(stream);return streamObj&&(streamObj.error=!0),0}return bytesWritten/size|0}function _abort(){Module.abort()}function __reallyNegative(x){return x<0||0===x&&1/x===-(1/0)}function __formatString(format,varargs){function getNextArg(type){var ret;return"double"===type?(HEAP32[tempDoublePtr>>2]=HEAP32[varargs+argIndex>>2],HEAP32[tempDoublePtr+4>>2]=HEAP32[varargs+(argIndex+4)>>2],ret=+HEAPF64[tempDoublePtr>>3]):"i64"==type?ret=[HEAP32[varargs+argIndex>>2],HEAP32[varargs+(argIndex+4)>>2]]:(type="i32",ret=HEAP32[varargs+argIndex>>2]),argIndex+=Runtime.getNativeFieldSize(type),ret}for(var curr,next,currArg,textIndex=format,argIndex=0,ret=[];;){var startTextIndex=textIndex;if(curr=HEAP8[textIndex>>0],0===curr)break;if(next=HEAP8[textIndex+1>>0],37==curr){var flagAlwaysSigned=!1,flagLeftAlign=!1,flagAlternative=!1,flagZeroPad=!1,flagPadSign=!1;flagsLoop:for(;;){switch(next){case 43:flagAlwaysSigned=!0;break;case 45:flagLeftAlign=!0;break;case 35:flagAlternative=!0;break;case 48:if(flagZeroPad)break flagsLoop;flagZeroPad=!0;break;case 32:flagPadSign=!0;break;default:break flagsLoop}textIndex++,next=HEAP8[textIndex+1>>0]}var width=0;if(42==next)width=getNextArg("i32"),textIndex++,next=HEAP8[textIndex+1>>0];else for(;next>=48&&next<=57;)width=10*width+(next-48),textIndex++,next=HEAP8[textIndex+1>>0];var precisionSet=!1,precision=-1;if(46==next){if(precision=0,precisionSet=!0,textIndex++,next=HEAP8[textIndex+1>>0],42==next)precision=getNextArg("i32"),textIndex++;else for(;;){var precisionChr=HEAP8[textIndex+1>>0];if(precisionChr<48||precisionChr>57)break;precision=10*precision+(precisionChr-48),textIndex++}next=HEAP8[textIndex+1>>0]}precision<0&&(precision=6,precisionSet=!1);var argSize;switch(String.fromCharCode(next)){case"h":var nextNext=HEAP8[textIndex+2>>0];104==nextNext?(textIndex++,argSize=1):argSize=2;break;case"l":var nextNext=HEAP8[textIndex+2>>0];108==nextNext?(textIndex++,argSize=8):argSize=4;break;case"L":case"q":case"j":argSize=8;break;case"z":case"t":case"I":argSize=4;break;default:argSize=null}switch(argSize&&textIndex++,next=HEAP8[textIndex+1>>0],String.fromCharCode(next)){case"d":case"i":case"u":case"o":case"x":case"X":case"p":var signed=100==next||105==next;argSize=argSize||4;var argText,currArg=getNextArg("i"+8*argSize),origArg=currArg;if(8==argSize&&(currArg=Runtime.makeBigInt(currArg[0],currArg[1],117==next)),argSize<=4){var limit=Math.pow(256,argSize)-1;currArg=(signed?reSign:unSign)(currArg&limit,8*argSize)}var currAbsArg=Math.abs(currArg),prefix="";if(100==next||105==next)argText=8==argSize&&i64Math?i64Math.stringify(origArg[0],origArg[1],null):reSign(currArg,8*argSize,1).toString(10);else if(117==next)argText=8==argSize&&i64Math?i64Math.stringify(origArg[0],origArg[1],!0):unSign(currArg,8*argSize,1).toString(10),currArg=Math.abs(currArg);else if(111==next)argText=(flagAlternative?"0":"")+currAbsArg.toString(8);else if(120==next||88==next){if(prefix=flagAlternative&&0!=currArg?"0x":"",8==argSize&&i64Math)if(origArg[1]){argText=(origArg[1]>>>0).toString(16);for(var lower=(origArg[0]>>>0).toString(16);lower.length<8;)lower="0"+lower;argText+=lower}else argText=(origArg[0]>>>0).toString(16);else if(currArg<0){currArg=-currArg,argText=(currAbsArg-1).toString(16);for(var buffer=[],i=0;i<argText.length;i++)buffer.push((15-parseInt(argText[i],16)).toString(16));for(argText=buffer.join("");argText.length<2*argSize;)argText="f"+argText}else argText=currAbsArg.toString(16);88==next&&(prefix=prefix.toUpperCase(),argText=argText.toUpperCase())}else 112==next&&(0===currAbsArg?argText="(nil)":(prefix="0x",argText=currAbsArg.toString(16)));if(precisionSet)for(;argText.length<precision;)argText="0"+argText;for(currArg>=0&&(flagAlwaysSigned?prefix="+"+prefix:flagPadSign&&(prefix=" "+prefix)),"-"==argText.charAt(0)&&(prefix="-"+prefix,argText=argText.substr(1));prefix.length+argText.length<width;)flagLeftAlign?argText+=" ":flagZeroPad?argText="0"+argText:prefix=" "+prefix;argText=prefix+argText,argText.split("").forEach(function(chr){ret.push(chr.charCodeAt(0))});break;case"f":case"F":case"e":case"E":case"g":case"G":var argText,currArg=getNextArg("double");if(isNaN(currArg))argText="nan",flagZeroPad=!1;else if(isFinite(currArg)){var isGeneral=!1,effectivePrecision=Math.min(precision,20);if(103==next||71==next){isGeneral=!0,precision=precision||1;var exponent=parseInt(currArg.toExponential(effectivePrecision).split("e")[1],10);precision>exponent&&exponent>=-4?(next=(103==next?"f":"F").charCodeAt(0),precision-=exponent+1):(next=(103==next?"e":"E").charCodeAt(0),precision--),effectivePrecision=Math.min(precision,20)}101==next||69==next?(argText=currArg.toExponential(effectivePrecision),/[eE][-+]\d$/.test(argText)&&(argText=argText.slice(0,-1)+"0"+argText.slice(-1))):102!=next&&70!=next||(argText=currArg.toFixed(effectivePrecision),0===currArg&&__reallyNegative(currArg)&&(argText="-"+argText));var parts=argText.split("e");if(isGeneral&&!flagAlternative)for(;parts[0].length>1&&parts[0].indexOf(".")!=-1&&("0"==parts[0].slice(-1)||"."==parts[0].slice(-1));)parts[0]=parts[0].slice(0,-1);else for(flagAlternative&&argText.indexOf(".")==-1&&(parts[0]+=".");precision>effectivePrecision++;)parts[0]+="0";argText=parts[0]+(parts.length>1?"e"+parts[1]:""),69==next&&(argText=argText.toUpperCase()),currArg>=0&&(flagAlwaysSigned?argText="+"+argText:flagPadSign&&(argText=" "+argText))}else argText=(currArg<0?"-":"")+"inf",flagZeroPad=!1;for(;argText.length<width;)flagLeftAlign?argText+=" ":argText=!flagZeroPad||"-"!=argText[0]&&"+"!=argText[0]?(flagZeroPad?"0":" ")+argText:argText[0]+"0"+argText.slice(1);next<97&&(argText=argText.toUpperCase()),argText.split("").forEach(function(chr){ret.push(chr.charCodeAt(0))});break;case"s":var arg=getNextArg("i8*"),argLength=arg?_strlen(arg):"(null)".length;if(precisionSet&&(argLength=Math.min(argLength,precision)),!flagLeftAlign)for(;argLength<width--;)ret.push(32);if(arg)for(var i=0;i<argLength;i++)ret.push(HEAPU8[arg++>>0]);else ret=ret.concat(intArrayFromString("(null)".substr(0,argLength),!0));if(flagLeftAlign)for(;argLength<width--;)ret.push(32);break;case"c":for(flagLeftAlign&&ret.push(getNextArg("i8"));--width>0;)ret.push(32);flagLeftAlign||ret.push(getNextArg("i8"));break;case"n":var ptr=getNextArg("i32*");HEAP32[ptr>>2]=ret.length;break;case"%":ret.push(curr);break;default:for(var i=startTextIndex;i<textIndex+2;i++)ret.push(HEAP8[i>>0])}textIndex+=2}else ret.push(curr),textIndex+=1}return ret}function _fprintf(stream,format,varargs){var result=__formatString(format,varargs),stack=Runtime.stackSave(),ret=_fwrite(allocate(result,"i8",ALLOC_STACK),1,result.length,stream);return Runtime.stackRestore(stack),ret}function _printf(format,varargs){var stdout=HEAP32[_stdout>>2];return _fprintf(stdout,format,varargs)}function _fgetc(stream){var streamObj=FS.getStreamFromPtr(stream);if(!streamObj)return-1;if(streamObj.eof||streamObj.error)return-1;var ret=_fread(_fgetc.ret,1,1,stream);return 0==ret?-1:ret==-1?(streamObj.error=!0,-1):HEAPU8[_fgetc.ret>>0]}function _fgets(s,n,stream){var streamObj=FS.getStreamFromPtr(stream);if(!streamObj)return 0;if(streamObj.error||streamObj.eof)return 0;for(var byte_,i=0;i<n-1&&10!=byte_;i++){if(byte_=_fgetc(stream),byte_==-1){if(streamObj.error||streamObj.eof&&0==i)return 0;if(streamObj.eof)break}HEAP8[s+i>>0]=byte_}return HEAP8[s+i>>0]=0,s}function _open(path,oflag,varargs){var mode=HEAP32[varargs>>2];path=Pointer_stringify(path);try{var stream=FS.open(path,oflag,mode);return stream.fd}catch(e){return FS.handleFSError(e),-1}}function _fopen(filename,mode){var flags;if(mode=Pointer_stringify(mode),"r"==mode[0])flags=mode.indexOf("+")!=-1?2:0;else if("w"==mode[0])flags=mode.indexOf("+")!=-1?2:1,flags|=64,flags|=512;else{if("a"!=mode[0])return ___setErrNo(ERRNO_CODES.EINVAL),0;flags=mode.indexOf("+")!=-1?2:1,flags|=64,flags|=1024}var fd=_open(filename,flags,allocate([511,0,0,0],"i32",ALLOC_STACK));return fd===-1?0:FS.getPtrForStream(FS.getStream(fd))}function _fputc(c,stream){var chr=unSign(255&c);HEAP8[_fputc.ret>>0]=chr;var fd=_fileno(stream),ret=_write(fd,_fputc.ret,1);if(ret==-1){var streamObj=FS.getStreamFromPtr(stream);return streamObj&&(streamObj.error=!0),-1}return chr}function _mmap(start,num,prot,flags,fd,offset){var ptr,allocated=!1;if(_mmap.mappings||(_mmap.mappings={}),fd==-1){if(ptr=_malloc(num),!ptr)return-1;_memset(ptr,0,num),allocated=!0}else{var info=FS.getStream(fd);if(!info)return-1;try{var res=FS.mmap(info,HEAPU8,start,num,offset,prot,flags);ptr=res.ptr,allocated=res.allocated}catch(e){return FS.handleFSError(e),-1}}return _mmap.mappings[ptr]={malloc:ptr,num:num,allocated:allocated},ptr}function __exit(status){Module.exit(status)}function _exit(status){__exit(status)}function _emscripten_set_main_loop_timing(mode,value){return Browser.mainLoop.timingMode=mode,Browser.mainLoop.timingValue=value,Browser.mainLoop.func?(0==mode?(Browser.mainLoop.scheduler=function(){setTimeout(Browser.mainLoop.runner,value)},Browser.mainLoop.method="timeout"):1==mode&&(Browser.mainLoop.scheduler=function(){Browser.requestAnimationFrame(Browser.mainLoop.runner)},Browser.mainLoop.method="rAF"),0):1}function _emscripten_set_main_loop(func,fps,simulateInfiniteLoop,arg){Module.noExitRuntime=!0,assert(!Browser.mainLoop.func,"emscripten_set_main_loop: there can only be one main loop function at once: call emscripten_cancel_main_loop to cancel the previous one before setting a new one with different parameters."),Browser.mainLoop.func=func,Browser.mainLoop.arg=arg;var thisMainLoopId=Browser.mainLoop.currentlyRunningMainloop;if(Browser.mainLoop.runner=function(){if(!ABORT){if(Browser.mainLoop.queue.length>0){var start=Date.now(),blocker=Browser.mainLoop.queue.shift();if(blocker.func(blocker.arg),Browser.mainLoop.remainingBlockers){var remaining=Browser.mainLoop.remainingBlockers,next=remaining%1==0?remaining-1:Math.floor(remaining);blocker.counted?Browser.mainLoop.remainingBlockers=next:(next+=.5,Browser.mainLoop.remainingBlockers=(8*remaining+next)/9)}return console.log('main loop blocker "'+blocker.name+'" took '+(Date.now()-start)+" ms"),Browser.mainLoop.updateStatus(),void setTimeout(Browser.mainLoop.runner,0)}if(!(thisMainLoopId<Browser.mainLoop.currentlyRunningMainloop)){if(Browser.mainLoop.currentFrameNumber=Browser.mainLoop.currentFrameNumber+1|0,1==Browser.mainLoop.timingMode&&Browser.mainLoop.timingValue>1&&Browser.mainLoop.currentFrameNumber%Browser.mainLoop.timingValue!=0)return void Browser.mainLoop.scheduler();"timeout"===Browser.mainLoop.method&&Module.ctx&&(Module.printErr("Looks like you are rendering without using requestAnimationFrame for the main loop. You should use 0 for the frame rate in emscripten_set_main_loop in order to use requestAnimationFrame, as that can greatly improve your frame rates!"),Browser.mainLoop.method=""),Browser.mainLoop.runIter(function(){"undefined"!=typeof arg?Runtime.dynCall("vi",func,[arg]):Runtime.dynCall("v",func)}),thisMainLoopId<Browser.mainLoop.currentlyRunningMainloop||("object"==typeof SDL&&SDL.audio&&SDL.audio.queueNewAudioData&&SDL.audio.queueNewAudioData(),Browser.mainLoop.scheduler())}}},fps&&fps>0?_emscripten_set_main_loop_timing(0,1e3/fps):_emscripten_set_main_loop_timing(1,1),Browser.mainLoop.scheduler(),simulateInfiniteLoop)throw"SimulateInfiniteLoop"}function _munmap(start,num){_mmap.mappings||(_mmap.mappings={});var info=_mmap.mappings[start];return info?(num==info.num&&(_mmap.mappings[start]=null,info.allocated&&_free(info.malloc)),0):0}function _stat(path,buf,dontResolveLastLink){path="string"!=typeof path?Pointer_stringify(path):path;try{var stat=dontResolveLastLink?FS.lstat(path):FS.stat(path);return HEAP32[buf>>2]=stat.dev,HEAP32[buf+4>>2]=0,HEAP32[buf+8>>2]=stat.ino,HEAP32[buf+12>>2]=stat.mode,HEAP32[buf+16>>2]=stat.nlink,HEAP32[buf+20>>2]=stat.uid,HEAP32[buf+24>>2]=stat.gid,HEAP32[buf+28>>2]=stat.rdev,HEAP32[buf+32>>2]=0,HEAP32[buf+36>>2]=stat.size,HEAP32[buf+40>>2]=4096,HEAP32[buf+44>>2]=stat.blocks,HEAP32[buf+48>>2]=stat.atime.getTime()/1e3|0,HEAP32[buf+52>>2]=0,HEAP32[buf+56>>2]=stat.mtime.getTime()/1e3|0,HEAP32[buf+60>>2]=0,HEAP32[buf+64>>2]=stat.ctime.getTime()/1e3|0,HEAP32[buf+68>>2]=0,HEAP32[buf+72>>2]=stat.ino,0}catch(e){return e.node&&PATH.normalize(path)!==PATH.normalize(FS.getPath(e.node))&&e.setErrno(ERRNO_CODES.ENOTDIR),FS.handleFSError(e),-1}}function _sysconf(name){switch(name){case 30:return PAGE_SIZE;case 132:case 133:case 12:case 137:case 138:case 15:case 235:case 16:case 17:case 18:case 19:case 20:case 149:case 13:case 10:case 236:case 153:case 9:case 21:case 22:case 159:case 154:case 14:case 77:case 78:case 139:case 80:case 81:case 79:case 82:case 68:case 67:case 164:case 11:case 29:case 47:case 48:case 95:case 52:case 51:case 46:return 200809;case 27:case 246:case 127:case 128:case 23:case 24:case 160:case 161:case 181:case 182:case 242:case 183:case 184:case 243:case 244:case 245:case 165:case 178:case 179:case 49:case 50:case 168:case 169:case 175:case 170:case 171:case 172:case 97:case 76:case 32:case 173:case 35:return-1;case 176:case 177:case 7:case 155:case 8:case 157:case 125:case 126:case 92:case 93:case 129:case 130:case 131:case 94:case 91:return 1;case 74:case 60:case 69:case 70:case 4:return 1024;case 31:case 42:case 72:return 32;case 87:case 26:case 33:return 2147483647;case 34:case 1:return 47839;case 38:case 36:return 99;case 43:case 37:return 2048;case 0:return 2097152;case 3:return 65536;case 28:return 32768;case 44:return 32767;case 75:return 16384;case 39:return 1e3;case 89:return 700;case 71:return 256;case 40:return 255;case 2:return 100;case 180:return 64;case 25:return 20;case 5:return 16;case 6:return 6;case 73:return 4;case 84:return"object"==typeof navigator?navigator.hardwareConcurrency||1:1}return ___setErrNo(ERRNO_CODES.EINVAL),-1}function _ferror(stream){return stream=FS.getStreamFromPtr(stream),Number(stream&&stream.error)}function _getcwd(buf,size){if(0==size)return ___setErrNo(ERRNO_CODES.EINVAL),0;var cwd=FS.cwd();return size<cwd.length+1?(___setErrNo(ERRNO_CODES.ERANGE),0):(writeAsciiToMemory(cwd,buf),buf)}function ___buildEnvironment(env){var poolPtr,envPtr,MAX_ENV_VALUES=64,TOTAL_ENV_SIZE=1024;___buildEnvironment.called?(envPtr=HEAP32[_environ>>2],poolPtr=HEAP32[envPtr>>2]):(___buildEnvironment.called=!0,ENV.USER="web_user",ENV.PATH="/",ENV.PWD="/",ENV.HOME="/home/web_user",ENV.LANG="C",ENV._=Module.thisProgram,poolPtr=allocate(TOTAL_ENV_SIZE,"i8",ALLOC_STATIC),envPtr=allocate(4*MAX_ENV_VALUES,"i8*",ALLOC_STATIC),HEAP32[envPtr>>2]=poolPtr,HEAP32[_environ>>2]=envPtr);var strings=[],totalSize=0;for(var key in env)if("string"==typeof env[key]){var line=key+"="+env[key];strings.push(line),totalSize+=line.length}if(totalSize>TOTAL_ENV_SIZE)throw new Error("Environment size exceeded TOTAL_ENV_SIZE!");for(var ptrSize=4,i=0;i<strings.length;i++){var line=strings[i];writeAsciiToMemory(line,poolPtr),HEAP32[envPtr+i*ptrSize>>2]=poolPtr,poolPtr+=line.length+1}HEAP32[envPtr+strings.length*ptrSize>>2]=0}function _getenv(name){return 0===name?0:(name=Pointer_stringify(name),ENV.hasOwnProperty(name)?(_getenv.ret&&_free(_getenv.ret),_getenv.ret=allocate(intArrayFromString(ENV[name]),"i8",ALLOC_NORMAL),_getenv.ret):0)}function _gettimeofday(ptr){var now=Date.now();return HEAP32[ptr>>2]=now/1e3|0,HEAP32[ptr+4>>2]=now%1e3*1e3|0,0}function _vfprintf(s,f,va_arg){return _fprintf(s,f,HEAP32[va_arg>>2])}function _emscripten_memcpy_big(dest,src,num){return HEAPU8.set(HEAPU8.subarray(src,src+num),dest),dest}function _sbrk(bytes){var self=_sbrk;self.called||(DYNAMICTOP=alignMemoryPage(DYNAMICTOP),self.called=!0,assert(Runtime.dynamicAlloc),self.alloc=Runtime.dynamicAlloc,Runtime.dynamicAlloc=function(){abort("cannot dynamically allocate, sbrk now has control")});var ret=DYNAMICTOP;return 0!=bytes&&self.alloc(bytes),ret}function ___errno_location(){return ___errno_state}function _time(ptr){var ret=Date.now()/1e3|0;return ptr&&(HEAP32[ptr>>2]=ret),ret}function _llvm_ctlz_i64(l,h){var ret=_llvm_ctlz_i32(h);return 32==ret&&(ret+=_llvm_ctlz_i32(l)),0|(asm.setTempRet0(0),ret)}function invoke_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7){try{return Module.dynCall_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if("number"!=typeof e&&"longjmp"!==e)throw e;asm.setThrew(1,0)}}function invoke_iiii(index,a1,a2,a3){try{return Module.dynCall_iiii(index,a1,a2,a3)}catch(e){if("number"!=typeof e&&"longjmp"!==e)throw e;asm.setThrew(1,0)}}function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7){try{Module.dynCall_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if("number"!=typeof e&&"longjmp"!==e)throw e;asm.setThrew(1,0)}}function invoke_viiiii(index,a1,a2,a3,a4,a5){try{Module.dynCall_viiiii(index,a1,a2,a3,a4,a5)}catch(e){if("number"!=typeof e&&"longjmp"!==e)throw e;asm.setThrew(1,0)}}function invoke_i(index){try{return Module.dynCall_i(index)}catch(e){if("number"!=typeof e&&"longjmp"!==e)throw e;asm.setThrew(1,0)}}function invoke_vi(index,a1){try{Module.dynCall_vi(index,a1)}catch(e){if("number"!=typeof e&&"longjmp"!==e)throw e;asm.setThrew(1,0)}}function invoke_vii(index,a1,a2){try{Module.dynCall_vii(index,a1,a2)}catch(e){if("number"!=typeof e&&"longjmp"!==e)throw e;asm.setThrew(1,0)}}function invoke_iiiiiii(index,a1,a2,a3,a4,a5,a6){try{return Module.dynCall_iiiiiii(index,a1,a2,a3,a4,a5,a6)}catch(e){if("number"!=typeof e&&"longjmp"!==e)throw e;asm.setThrew(1,0)}}function invoke_ii(index,a1){try{return Module.dynCall_ii(index,a1)}catch(e){if("number"!=typeof e&&"longjmp"!==e)throw e;asm.setThrew(1,0)}}function invoke_viii(index,a1,a2,a3){try{Module.dynCall_viii(index,a1,a2,a3)}catch(e){if("number"!=typeof e&&"longjmp"!==e)throw e;asm.setThrew(1,0)}}function invoke_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module.dynCall_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if("number"!=typeof e&&"longjmp"!==e)throw e;asm.setThrew(1,0)}}function invoke_iiiii(index,a1,a2,a3,a4){try{return Module.dynCall_iiiii(index,a1,a2,a3,a4)}catch(e){if("number"!=typeof e&&"longjmp"!==e)throw e;asm.setThrew(1,0)}}function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6){try{Module.dynCall_viiiiii(index,a1,a2,a3,a4,a5,a6)}catch(e){if("number"!=typeof e&&"longjmp"!==e)throw e;asm.setThrew(1,0)}}function invoke_iii(index,a1,a2){try{return Module.dynCall_iii(index,a1,a2)}catch(e){if("number"!=typeof e&&"longjmp"!==e)throw e;asm.setThrew(1,0)}}function invoke_iiiiii(index,a1,a2,a3,a4,a5){try{return Module.dynCall_iiiiii(index,a1,a2,a3,a4,a5);
}catch(e){if("number"!=typeof e&&"longjmp"!==e)throw e;asm.setThrew(1,0)}}function invoke_viiii(index,a1,a2,a3,a4){try{Module.dynCall_viiii(index,a1,a2,a3,a4)}catch(e){if("number"!=typeof e&&"longjmp"!==e)throw e;asm.setThrew(1,0)}}function ExitStatus(status){this.name="ExitStatus",this.message="Program terminated with exit("+status+")",this.status=status}function run(args){function doRun(){Module.calledRun||(Module.calledRun=!0,ABORT||(ensureInitRuntime(),preMain(),null!==preloadStartTime&&Date.now()-preloadStartTime>15&&Module.printErr("pre-main prep time: "+(Date.now()-preloadStartTime)+" ms"),Module.onRuntimeInitialized&&Module.onRuntimeInitialized(),Module._main&&shouldRunNow&&Module.callMain(args),postRun()))}args=args||Module.arguments,null===preloadStartTime&&(preloadStartTime=Date.now()),runDependencies>0||(preRun(),runDependencies>0||Module.calledRun||(Module.setStatus?(Module.setStatus("Running..."),setTimeout(function(){setTimeout(function(){Module.setStatus("")},1),doRun()},1)):doRun()))}function exit(status){if(!Module.noExitRuntime)throw ABORT=!0,EXITSTATUS=status,STACKTOP=initialStackTop,exitRuntime(),new ExitStatus(status)}function abort(text){text&&(Module.print(text),Module.printErr(text)),ABORT=!0,EXITSTATUS=1;var extra="\nIf this abort() is unexpected, build with -s ASSERTIONS=1 which can give more information.";throw"abort() at "+stackTrace()+extra}var Module={xml:options.xml,schema:options.schema};Module.preRun=function(){var i;for(i=0;i<1;i++)FS.createDataFile("/","file_"+i+".xml",Module.intArrayFromString(Module.xml[i]),!0,!0);for(i=0;i<Module.schema.length;i++)FS.createDataFile("/","file_"+i+".xsd",Module.intArrayFromString(Module.schema[i]),!0,!0)},Module.arguments=["--noout"],function(){var i;for("[object Array]"!==Object.prototype.toString.call(Module.schema)&&(Module.schema=[Module.schema]),"[object Array]"!==Object.prototype.toString.call(Module.xml)&&(Module.xml=[Module.xml]),i=0;i<Module.schema.length;i++)Module.arguments.push("--schema"),Module.arguments.push("file_"+i+".xsd");for(i=0;i<1;i++)Module.arguments.push("file_"+i+".xml")}(),Module.return="",Module.stdout=Module.stderr=function(code){Module.return+=String.fromCharCode(code)};var Module;Module||(Module=("undefined"!=typeof Module?Module:null)||{});var moduleOverrides={};for(var key in Module)Module.hasOwnProperty(key)&&(moduleOverrides[key]=Module[key]);if(Module.read=function(url){var xhr=new XMLHttpRequest;return xhr.open("GET",url,!1),xhr.send(null),xhr.responseText},"undefined"!=typeof arguments&&(Module.arguments=arguments),"undefined"!=typeof console)Module.print||(Module.print=function(x){console.log(x)}),Module.printErr||(Module.printErr=function(x){throw new Error("!_PERF_!")});else{var TRY_USE_DUMP=!1;Module.print||(Module.print=TRY_USE_DUMP&&"undefined"!=typeof dump?function(x){dump(x)}:function(x){})}window.Module=Module,!Module.load&&Module.read&&(Module.load=function(f){globalEval(Module.read(f))}),Module.print||(Module.print=function(){}),Module.printErr||(Module.printErr=Module.print),Module.arguments||(Module.arguments=[]),Module.thisProgram||(Module.thisProgram="./this.program"),Module.print=Module.print,Module.printErr=Module.printErr,Module.preRun=[],Module.postRun=[];for(var key in moduleOverrides)moduleOverrides.hasOwnProperty(key)&&(Module[key]=moduleOverrides[key]);var Runtime={setTempRet0:function(value){tempRet0=value},getTempRet0:function(){return tempRet0},stackSave:function(){return STACKTOP},stackRestore:function(stackTop){STACKTOP=stackTop},getNativeTypeSize:function(type){switch(type){case"i1":case"i8":return 1;case"i16":return 2;case"i32":return 4;case"i64":return 8;case"float":return 4;case"double":return 8;default:if("*"===type[type.length-1])return Runtime.QUANTUM_SIZE;if("i"===type[0]){var bits=parseInt(type.substr(1));return assert(bits%8===0),bits/8}return 0}},getNativeFieldSize:function(type){return Math.max(Runtime.getNativeTypeSize(type),Runtime.QUANTUM_SIZE)},STACK_ALIGN:16,getAlignSize:function(type,size,vararg){return vararg||"i64"!=type&&"double"!=type?type?Math.min(size||(type?Runtime.getNativeFieldSize(type):0),Runtime.QUANTUM_SIZE):Math.min(size,8):8},dynCall:function(sig,ptr,args){return args&&args.length?(args.splice||(args=Array.prototype.slice.call(args)),args.splice(0,0,ptr),Module["dynCall_"+sig].apply(null,args)):Module["dynCall_"+sig].call(null,ptr)},functionPointers:[],addFunction:function(func){for(var i=0;i<Runtime.functionPointers.length;i++)if(!Runtime.functionPointers[i])return Runtime.functionPointers[i]=func,2*(1+i);throw"Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS."},removeFunction:function(index){Runtime.functionPointers[(index-2)/2]=null},getAsmConst:function(code,numArgs){Runtime.asmConstCache||(Runtime.asmConstCache={});var func=Runtime.asmConstCache[code];if(func)return func;for(var args=[],i=0;i<numArgs;i++)args.push(String.fromCharCode(36)+i);var source=Pointer_stringify(code);'"'===source[0]&&(source.indexOf('"',1)===source.length-1?source=source.substr(1,source.length-2):abort("invalid EM_ASM input |"+source+"|. Please use EM_ASM(..code..) (no quotes) or EM_ASM({ ..code($0).. }, input) (to input values)"));try{var evalled=eval("(function(Module, FS) { return function("+args.join(",")+"){ "+source+" } })")(Module,"undefined"!=typeof FS?FS:null)}catch(e){throw Module.printErr("error in executing inline EM_ASM code: "+e+" on: \n\n"+source+"\n\nwith args |"+args+"| (make sure to use the right one out of EM_ASM, EM_ASM_ARGS, etc.)"),e}return Runtime.asmConstCache[code]=evalled},warnOnce:function(text){Runtime.warnOnce.shown||(Runtime.warnOnce.shown={}),Runtime.warnOnce.shown[text]||(Runtime.warnOnce.shown[text]=1,Module.printErr(text))},funcWrappers:{},getFuncWrapper:function(func,sig){assert(sig),Runtime.funcWrappers[sig]||(Runtime.funcWrappers[sig]={});var sigCache=Runtime.funcWrappers[sig];return sigCache[func]||(sigCache[func]=function(){return Runtime.dynCall(sig,func,arguments)}),sigCache[func]},UTF8Processor:function(){var buffer=[],needed=0;this.processCChar=function(code){if(code=255&code,0==buffer.length)return 0==(128&code)?String.fromCharCode(code):(buffer.push(code),needed=192==(224&code)?1:224==(240&code)?2:3,"");if(needed&&(buffer.push(code),needed--,needed>0))return"";var ret,c1=buffer[0],c2=buffer[1],c3=buffer[2],c4=buffer[3];if(2==buffer.length)ret=String.fromCharCode((31&c1)<<6|63&c2);else if(3==buffer.length)ret=String.fromCharCode((15&c1)<<12|(63&c2)<<6|63&c3);else{var codePoint=(7&c1)<<18|(63&c2)<<12|(63&c3)<<6|63&c4;ret=String.fromCharCode(((codePoint-65536)/1024|0)+55296,(codePoint-65536)%1024+56320)}return buffer.length=0,ret},this.processJSString=function(string){string=unescape(encodeURIComponent(string));for(var ret=[],i=0;i<string.length;i++)ret.push(string.charCodeAt(i));return ret}},getCompilerSetting:function(name){throw"You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work"},stackAlloc:function(size){var ret=STACKTOP;return STACKTOP=STACKTOP+size|0,STACKTOP=STACKTOP+15&-16,ret},staticAlloc:function(size){var ret=STATICTOP;return STATICTOP=STATICTOP+size|0,STATICTOP=STATICTOP+15&-16,ret},dynamicAlloc:function(size){var ret=DYNAMICTOP;return DYNAMICTOP=DYNAMICTOP+size|0,DYNAMICTOP=DYNAMICTOP+15&-16,DYNAMICTOP>=TOTAL_MEMORY&&enlargeMemory(),ret},alignMemory:function(size,quantum){var ret=size=Math.ceil(size/(quantum?quantum:16))*(quantum?quantum:16);return ret},makeBigInt:function(low,high,unsigned){var ret=unsigned?+(low>>>0)+4294967296*+(high>>>0):+(low>>>0)+4294967296*+(0|high);return ret},GLOBAL_BASE:8,QUANTUM_SIZE:4,__dummy__:0};Module.Runtime=Runtime;var __THREW__=0,ABORT=!1,EXITSTATUS=0,undef=0,tempValue,tempInt,tempBigInt,tempInt2,tempBigInt2,tempPair,tempBigIntI,tempBigIntR,tempBigIntS,tempBigIntP,tempBigIntD,tempDouble,tempFloat,tempI64,tempI64b,tempRet0,tempRet1,tempRet2,tempRet3,tempRet4,tempRet5,tempRet6,tempRet7,tempRet8,tempRet9,globalScope=this,cwrap,ccall;!function(){function parseJSFunc(jsfunc){var parsed=jsfunc.toString().match(sourceRegex).slice(1);return{arguments:parsed[0],body:parsed[1],returnValue:parsed[2]}}var JSfuncs={stackSave:function(){Runtime.stackSave()},stackRestore:function(){Runtime.stackRestore()},arrayToC:function(arr){var ret=Runtime.stackAlloc(arr.length);return writeArrayToMemory(arr,ret),ret},stringToC:function(str){var ret=0;return null!==str&&void 0!==str&&0!==str&&(ret=Runtime.stackAlloc((str.length<<2)+1),writeStringToMemory(str,ret)),ret}},toC={string:JSfuncs.stringToC,array:JSfuncs.arrayToC};ccall=function(ident,returnType,argTypes,args){var func=getCFunc(ident),cArgs=[],stack=0;if(args)for(var i=0;i<args.length;i++){var converter=toC[argTypes[i]];converter?(0===stack&&(stack=Runtime.stackSave()),cArgs[i]=converter(args[i])):cArgs[i]=args[i]}var ret=func.apply(null,cArgs);return"string"===returnType&&(ret=Pointer_stringify(ret)),0!==stack&&Runtime.stackRestore(stack),ret};var sourceRegex=/^function\s*\(([^)]*)\)\s*{\s*([^*]*?)[\s;]*(?:return\s*(.*?)[;\s]*)?}$/,JSsource={};for(var fun in JSfuncs)JSfuncs.hasOwnProperty(fun)&&(JSsource[fun]=parseJSFunc(JSfuncs[fun]));cwrap=function cwrap(ident,returnType,argTypes){argTypes=argTypes||[];var cfunc=getCFunc(ident),numericArgs=argTypes.every(function(type){return"number"===type}),numericRet="string"!==returnType;if(numericRet&&numericArgs)return cfunc;var argNames=argTypes.map(function(x,i){return"$"+i}),funcstr="(function("+argNames.join(",")+") {",nargs=argTypes.length;if(!numericArgs){funcstr+="var stack = "+JSsource.stackSave.body+";";for(var i=0;i<nargs;i++){var arg=argNames[i],type=argTypes[i];if("number"!==type){var convertCode=JSsource[type+"ToC"];funcstr+="var "+convertCode.arguments+" = "+arg+";",funcstr+=convertCode.body+";",funcstr+=arg+"="+convertCode.returnValue+";"}}}var cfuncname=parseJSFunc(function(){return cfunc}).returnValue;if(funcstr+="var ret = "+cfuncname+"("+argNames.join(",")+");",!numericRet){var strgfy=parseJSFunc(function(){return Pointer_stringify}).returnValue;funcstr+="ret = "+strgfy+"(ret);"}return numericArgs||(funcstr+=JSsource.stackRestore.body.replace("()","(stack)")+";"),funcstr+="return ret})",eval(funcstr)}}(),Module.cwrap=cwrap,Module.ccall=ccall,Module.setValue=setValue,Module.getValue=getValue;var ALLOC_NORMAL=0,ALLOC_STACK=1,ALLOC_STATIC=2,ALLOC_DYNAMIC=3,ALLOC_NONE=4;Module.ALLOC_NORMAL=ALLOC_NORMAL,Module.ALLOC_STACK=ALLOC_STACK,Module.ALLOC_STATIC=ALLOC_STATIC,Module.ALLOC_DYNAMIC=ALLOC_DYNAMIC,Module.ALLOC_NONE=ALLOC_NONE,Module.allocate=allocate,Module.Pointer_stringify=Pointer_stringify,Module.UTF16ToString=UTF16ToString,Module.stringToUTF16=stringToUTF16,Module.UTF32ToString=UTF32ToString,Module.stringToUTF32=stringToUTF32,Module.stackTrace=stackTrace;for(var PAGE_SIZE=4096,HEAP,HEAP8,HEAPU8,HEAP16,HEAPU16,HEAP32,HEAPU32,HEAPF32,HEAPF64,STATIC_BASE=0,STATICTOP=0,staticSealed=!1,STACK_BASE=0,STACKTOP=0,STACK_MAX=0,DYNAMIC_BASE=0,DYNAMICTOP=0,TOTAL_STACK=Module.TOTAL_STACK||5242880,TOTAL_MEMORY=Module.TOTAL_MEMORY||16777216,FAST_MEMORY=Module.FAST_MEMORY||2097152,totalMemory=65536;totalMemory<TOTAL_MEMORY||totalMemory<2*TOTAL_STACK;)totalMemory<16777216?totalMemory*=2:totalMemory+=16777216;totalMemory!==TOTAL_MEMORY&&(Module.printErr("increasing TOTAL_MEMORY to "+totalMemory+" to be compliant with the asm.js spec"),TOTAL_MEMORY=totalMemory),assert("undefined"!=typeof Int32Array&&"undefined"!=typeof Float64Array&&!!new Int32Array(1).subarray&&!!new Int32Array(1).set,"JS engine does not provide full typed array support");var buffer=new ArrayBuffer(TOTAL_MEMORY);HEAP8=new Int8Array(buffer),HEAP16=new Int16Array(buffer),HEAP32=new Int32Array(buffer),HEAPU8=new Uint8Array(buffer),HEAPU16=new Uint16Array(buffer),HEAPU32=new Uint32Array(buffer),HEAPF32=new Float32Array(buffer),HEAPF64=new Float64Array(buffer),HEAP32[0]=255,assert(255===HEAPU8[0]&&0===HEAPU8[3],"Typed arrays 2 must be run on a little-endian system"),Module.HEAP=HEAP,Module.buffer=buffer,Module.HEAP8=HEAP8,Module.HEAP16=HEAP16,Module.HEAP32=HEAP32,Module.HEAPU8=HEAPU8,Module.HEAPU16=HEAPU16,Module.HEAPU32=HEAPU32,Module.HEAPF32=HEAPF32,Module.HEAPF64=HEAPF64;var __ATPRERUN__=[],__ATINIT__=[],__ATMAIN__=[],__ATEXIT__=[],__ATPOSTRUN__=[],runtimeInitialized=!1,runtimeExited=!1;Module.addOnPreRun=Module.addOnPreRun=addOnPreRun,Module.addOnInit=Module.addOnInit=addOnInit,Module.addOnPreMain=Module.addOnPreMain=addOnPreMain,Module.addOnExit=Module.addOnExit=addOnExit,Module.addOnPostRun=Module.addOnPostRun=addOnPostRun,Module.intArrayFromString=intArrayFromString,Module.intArrayToString=intArrayToString,Module.writeStringToMemory=writeStringToMemory,Module.writeArrayToMemory=writeArrayToMemory,Module.writeAsciiToMemory=writeAsciiToMemory,Math.imul&&Math.imul(4294967295,5)===-5||(Math.imul=function(a,b){var ah=a>>>16,al=65535&a,bh=b>>>16,bl=65535&b;return al*bl+(ah*bl+al*bh<<16)|0}),Math.imul=Math.imul;var Math_abs=Math.abs,Math_cos=Math.cos,Math_sin=Math.sin,Math_tan=Math.tan,Math_acos=Math.acos,Math_asin=Math.asin,Math_atan=Math.atan,Math_atan2=Math.atan2,Math_exp=Math.exp,Math_log=Math.log,Math_sqrt=Math.sqrt,Math_ceil=Math.ceil,Math_floor=Math.floor,Math_pow=Math.pow,Math_imul=Math.imul,Math_fround=Math.fround,Math_min=Math.min,runDependencies=0,runDependencyWatcher=null,dependenciesFulfilled=null;Module.addRunDependency=addRunDependency,Module.removeRunDependency=removeRunDependency,Module.preloadedImages={},Module.preloadedAudios={};var memoryInitializer=null;STATIC_BASE=8,STATICTOP=STATIC_BASE+329776,__ATINIT__.push(),allocate([1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,45,0,0,0,0,0,0,0,45,100,101,98,117,103,0,0,45,45,100,101,98,117,103,0,0,0,0,0,0,0,0,0,45,115,104,101,108,108,0,0,45,45,115,104,101,108,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,99,111,112,121,0,0,0,45,45,99,111,112,121,0,0,0,0,0,0,0,0,0,0,45,114,101,99,111,118,101,114,0,0,0,0,0,0,0,0,45,45,114,101,99,111,118,101,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,0,0,45,104,117,103,101,0,0,0,45,45,104,117,103,101,0,0,45,110,111,101,110,116,0,0,45,45,110,111,101,110,116,0,0,0,0,0,0,0,0,0,45,110,111,101,110,99,0,0,45,45,110,111,101,110,99,0,0,0,0,0,0,0,0,0,45,110,115,99,108,101,97,110,0,0,0,0,0,0,0,0,45,45,110,115,99,108,101,97,110,0,0,0,0,0,0,0,45,110,111,99,100,97,116,97,0,0,0,0,0,0,0,0,45,45,110,111,99,100,97,116,97,0,0,0,0,0,0,0,45,110,111,100,105,99,116,0,45,45,110,111,100,105,99,116,0,0,0,0,0,0,0,0,45,118,101,114,115,105,111,110,0,0,0,0,0,0,0,0,45,45,118,101,114,115,105,111,110,0,0,0,0,0,0,0,45,110,111,111,117,116,0,0,45,45,110,111,111,117,116,0,45,111,0,0,0,0,0,0,45,111,117,116,112,117,116,0,45,45,111,117,116,112,117,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,104,116,109,108,111,117,116,0,0,0,0,0,0,0,0,45,45,104,116,109,108,111,117,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,110,111,119,114,97,112,0,45,45,110,111,119,114,97,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,104,116,109,108,0,0,0,45,45,104,116,109,108,0,0,0,0,0,0,0,0,0,0,45,120,109,108,111,117,116,0,45,45,120,109,108,111,117,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,110,111,100,101,102,100,116,100,0,0,0,0,0,0,0,45,45,110,111,100,101,102,100,116,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,108,111,97,100,100,116,100,0,0,0,0,0,0,0,0,45,45,108,111,97,100,100,116,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,100,116,100,97,116,116,114,0,0,0,0,0,0,0,0,45,45,100,116,100,97,116,116,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,118,97,108,105,100,0,0,45,45,118,97,108,105,100,0,0,0,0,0,0,0,0,0,45,112,111,115,116,118,97,108,105,100,0,0,0,0,0,0,45,45,112,111,115,116,118,97,108,105,100,0,0,0,0,0,0,0,0,0,0,0,0,0,45,100,116,100,118,97,108,105,100,0,0,0,0,0,0,0,45,45,100,116,100,118,97,108,105,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,100,116,100,118,97,108,105,100,102,112,105,0,0,0,0,45,45,100,116,100,118,97,108,105,100,102,112,105,0,0,0,0,0,0,0,0,0,0,0,45,100,114,111,112,100,116,100,0,0,0,0,0,0,0,0,45,45,100,114,111,112,100,116,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,105,110,115,101,114,116,0,45,45,105,110,115,101,114,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,116,105,109,105,110,103,0,45,45,116,105,109,105,110,103,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,97,117,116,111,0,0,0,45,45,97,117,116,111,0,0,0,0,0,0,0,0,0,0,45,114,101,112,101,97,116,0,45,45,114,101,112,101,97,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,112,117,115,104,0,0,0,45,45,112,117,115,104,0,0,0,0,0,0,0,0,0,0,45,112,117,115,104,115,109,97,108,108,0,0,0,0,0,0,45,45,112,117,115,104,115,109,97,108,108,0,0,0,0,0,0,16,0,0,0,0,0,0,45,109,101,109,111,114,121,0,45,45,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,116,101,115,116,73,79,0,45,45,116,101,115,116,73,79,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,120,105,110,99,108,117,100,101,0,0,0,0,0,0,0,45,45,120,105,110,99,108,117,100,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,110,111,120,105,110,99,108,117,100,101,110,111,100,101,0,45,45,110,111,120,105,110,99,108,117,100,101,110,111,100,101,0,0,0,0,0,0,0,0,45,110,111,102,105,120,117,112,45,98,97,115,101,45,117,114,105,115,0,0,0,0,0,0,45,45,110,111,102,105,120,117,112,45,98,97,115,101,45,117,114,105,115,0,0,0,0,0,45,110,111,119,97,114,110,105,110,103,0,0,0,0,0,0,45,45,110,111,119,97,114,110,105,110,103,0,0,0,0,0,45,112,101,100,97,110,116,105,99,0,0,0,0,0,0,0,45,45,112,101,100,97,110,116,105,99,0,0,0,0,0,0,45,100,101,98,117,103,101,110,116,0,0,0,0,0,0,0,45,45,100,101,98,117,103,101,110,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,99,49,52,110,0,0,0,45,45,99,49,52,110,0,0,0,0,0,0,0,0,0,0,45,99,49,52,110,49,49,0,45,45,99,49,52,110,49,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,101,120,99,45,99,49,52,110,0,0,0,0,0,0,0,45,45,101,120,99,45,99,49,52,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,99,97,116,97,108,111,103,115,0,0,0,0,0,0,0,45,45,99,97,116,97,108,111,103,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,110,111,99,97,116,97,108,111,103,115,0,0,0,0,0,45,45,110,111,99,97,116,97,108,111,103,115,0,0,0,0,0,0,0,0,0,0,0,0,45,101,110,99,111,100,101,0,45,45,101,110,99,111,100,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,85,84,70,45,56,0,0,0,68,86,69,110,99,0,0,0,45,110,111,98,108,97,110,107,115,0,0,0,0,0,0,0,45,45,110,111,98,108,97,110,107,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,109,97,120,109,101,109,0,45,45,109,97,120,109,101,109,0,0,0,0,0,0,0,0,37,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,102,111,114,109,97,116,0,45,45,102,111,114,109,97,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,112,114,101,116,116,121,0,45,45,112,114,101,116,116,121,0,0,0,0,0,0,0,0,45,115,116,114,101,97,109,0,45,45,115,116,114,101,97,109,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,119,97,108,107,101,114,0,45,45,119,97,108,107,101,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,115,97,120,49,0,0,0,45,45,115,97,120,49,0,0,0,0,0,0,0,0,0,0,45,115,97,120,0,0,0,0,45,45,115,97,120,0,0,0,0,0,0,0,0,0,0,0,45,99,104,107,114,101,103,105,115,116,101,114,0,0,0,0,45,45,99,104,107,114,101,103,105,115,116,101,114,0,0,0,0,0,0,0,0,0,0,0,45,114,101,108,97,120,110,103,0,0,0,0,0,0,0,0,45,45,114,101,108,97,120,110,103,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,115,99,104,101,109,97,0,45,45,115,99,104,101,109,97,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,115,99,104,101,109,97,116,114,111,110,0,0,0,0,0,45,45,115,99,104,101,109,97,116,114,111,110,0,0,0,0,0,0,0,0,0,0,0,0,45,110,111,110,101,116,0,0,45,45,110,111,110,101,116,0,45,110,111,99,111,109,112,97,99,116,0,0,0,0,0,0,45,45,110,111,99,111,109,112,97,99,116,0,0,0,0,0,45,108,111,97,100,45,116,114,97,99,101,0,0,0,0,0,45,45,108,111,97,100,45,116,114,97,99,101,0,0,0,0,0,0,0,0,0,0,0,0,45,112,97,116,104,0,0,0,45,45,112,97,116,104,0,0,45,112,97,116,116,101,114,110,0,0,0,0,0,0,0,0,45,45,112,97,116,116,101,114,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,120,112,97,116,104,0,0,45,45,120,112,97,116,104,0,0,0,0,0,0,0,0,0,45,111,108,100,120,109,108,49,48,0,0,0,0,0,0,0,45,45,111,108,100,120,109,108,49,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,85,110,107,110,111,119,110,32,111,112,116,105,111,110,32,37,115,10,0,0,0,0,0,0,83,71,77,76,95,67,65,84,65,76,79,71,95,70,73,76,69,83,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,36,83,71,77,76,95,67,65,84,65,76,79,71,95,70,73,76,69,83,32,110,111,116,32,115,101,116,10,0,0,0,88,77,76,76,73,78,84,95,73,78,68,69,78,84,0,0,0,0,0,0,0,0,0,0,60,33,68,79,67,84,89,80,69,32,72,84,77,76,32,80,85,66,76,73,67,32,34,45,47,47,87,51,67,47,47,68,84,68,32,72,84,77,76,32,52,46,48,32,84,114,97,110,115,105,116,105,111,110,97,108,47,47,69,78,34,10,0,0,9,34,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,84,82,47,82,69,67,45,104,116,109,108,52,48,47,108,111,111,115,101,46,100,116,100,34,62,10,0,0,60,104,116,109,108,62,60,104,101,97,100,62,60,116,105,116,108,101,62,37,115,32,111,117,116,112,117,116,60,47,116,105,116,108,101,62,60,47,104,101,97,100,62,10,0,0,0,0,60,98,111,100,121,32,98,103,99,111,108,111,114,61,34,35,102,102,102,102,102,102,34,62,60,104,49,32,97,108,105,103,110,61,34,99,101,110,116,101,114,34,62,37,115,32,111,117,116,112,117,116,60,47,104,49,62,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,99,104,101,109,97,116,114,111,110,32,115,99,104,101,109,97,32,37,115,32,102,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,10,0,0,0,0,0,0,0,0,0,67,111,109,112,105,108,105,110,103,32,116,104,101,32,115,99,104,101,109,97,115,0,0,0,0,0,0,0,0,0,0,0,82,101,108,97,120,45,78,71,32,115,99,104,101,109,97,32,37,115,32,102,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,10,0,0,0,0,0,0,0,0,0,0,0,87,88,83,32,115,99,104,101,109,97,32,37,115,32,102,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,97,116,116,101,114,110,32,37,115,32,102,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,10,0,0,0,0,0,0,0,0,0,0,0,82,101,103,105,115,116,114,97,116,105,111,110,32,99,111,117,110,116,32,111,102,102,58,32,37,100,10,0,0,0,0,0,37,100,32,105,116,101,114,97,116,105,111,110,115,0,0,0,60,47,98,111,100,121,62,60,47,104,116,109,108,62,10,0,49,46,48,0,0,0,0,0,105,110,102,111,0,0,0,0,97,98,99,0,0,0,0,0,114,0,0,0,0,0,0,0,109,109,97,112,32,102,97,105,108,117,114,101,32,102,111,114,32,102,105,108,101,32,37,115,10,0,0,0,0,0,0,0,80,97,114,115,105,110,103,0,88,105,110,99,108,117,100,101,32,112,114,111,99,101,115,115,105,110,103,0,0,0,0,0,67,111,112,121,105,110,103,0,70,114,101,101,105,110,103,32,111,114,105,103,105,110,97,108,0,0,0,0,0,0,0,0,99,111,117,108,100,32,110,111,116,32,103,101,116,32,118,97,108,105,100,32,108,105,115,116,32,111,102,32,101,108,101,109,101,110,116,115,10,0,0,0,78,111,32,101,108,101,109,101,110,116,32,99,97,110,32,98,101,32,105,110,115,101,114,116,101,100,32,117,110,100,101,114,32,114,111,111,116,10,0,0,37,100,32,101,108,101,109,101,110,116,32,116,121,112,101,115,32,99,97,110,32,98,101,32,105,110,115,101,114,116,101,100,32,117,110,100,101,114,32,114,111,111,116,58,10,0,0,0,37,115,10,0,0,0,0,0,0,0,0,0,0,0,0,0,119,98,0,0,0,0,0,0,102,97,105,108,101,100,32,116,111,32,111,112,101,110,32,37,115,10,0,0,0,0,0,0,83,97,118,105,110,103,0,0,67,97,110,39,116,32,119,114,105,116,101,32,100,97,116,97,10,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,97,110,111,110,105,99,97,108,105,122,101,10,0,70,97,105,108,101,100,32,116,111,32,115,97,118,101,10,0,0,0,0,0,0,0,0,0,102,97,105,108,101,100,32,115,97,118,101,32,116,111,32,37,115,10,0,0,0,0,0,0,80,97,114,115,105,110,103,32,68,84,68,0,0,0,0,0,67,111,117,108,100,32,110,111,116,32,112,97,114,115,101,32,68,84,68,32,37,115,10,0,67,111,117,108,100,110,39,116,32,97,108,108,111,99,97,116,101,32,118,97,108,105,100,97,116,105,111,110,32,99,111,110,116,101,120,116,10,0,0,0,68,111,99,117,109,101,110,116,32,37,115,32,100,111,101,115,32,110,111,116,32,118,97,108,105,100,97,116,101,32,97,103,97,105,110,115,116,32,37,115,10,0,0,0,0,0,0,0,86,97,108,105,100,97,116,105,110,103,32,97,103,97,105,110,115,116,32,68,84,68,0,0,68,111,99,117,109,101,110,116,32,37,115,32,100,111,101,115,32,110,111,116,32,118,97,108,105,100,97,116,101,10,0,0,86,97,108,105,100,97,116,105,110,103,0,0,0,0,0,0,37,115,32,118,97,108,105,100,97,116,101,115,10,0,0,0,37,115,32,102,97,105,108,115,32,116,111,32,118,97,108,105,100,97,116,101,10,0,0,0,37,115,32,118,97,108,105,100,97,116,105,111,110,32,103,101,110,101,114,97,116,101,100,32,97,110,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,10,0,0,0,0,0,0,70,114,101,101,105,110,103,0,0,0,0,0,0,0,0,0,120,109,108,83,116,114,101,97,109,80,117,115,104,40,41,32,102,97,105,108,117,114,101,10,0,0,0,0,0,0,0,0,119,97,108,107,105,110,103,32,116,104,114,111,117,103,104,32,116,104,101,32,100,111,99,0,102,97,105,108,101,100,32,116,111,32,119,97,108,107,32,116,104,114,111,117,103,104,32,116,104,101,32,100,111,99,10,0,70,97,105,108,101,100,32,116,111,32,99,114,97,116,101,32,97,32,114,101,97,100,101,114,32,102,114,111,109,32,116,104,101,32,100,111,99,117,109,101,110,116,10,0,0,0,0,0,45,45,0,0,0,0,0,0,37,100,32,37,100,32,37,115,32,37,100,32,37,100,0,0,10,0,0,0,0,0,0,0,32,37,115,10,0,0,0,0,78,111,100,101,32,37,115,32,109,97,116,99,104,101,115,32,112,97,116,116,101,114,110,32,37,115,10,0,0,0,0,0,120,109,108,80,97,116,116,101,114,110,77,97,116,99,104,32,97,110,100,32,120,109,108,83,116,114,101,97,109,80,117,115,104,32,100,105,115,97,103,114,101,101,10,0,0,0,0,0,32,32,112,97,116,116,101,114,110,32,37,115,32,110,111,100,101,32,37,115,10,0,0,0,120,109,108,83,116,114,101,97,109,80,111,112,40,41,32,102,97,105,108,117,114,101,10,0,37,115,0,0,0,0,0,0,79,117,116,32,111,102,32,109,101,109,111,114,121,32,102,111,114,32,88,80,97,116,104,10,0,0,0,0,0,0,0,0,88,80,97,116,104,32,101,118,97,108,117,97,116,105,111,110,32,102,97,105,108,117,114,101,10,0,0,0,0,0,0,0,88,80,97,116,104,32,115,101,116,32,105,115,32,101,109,112,116,121,10,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,73,110,102,105,110,105,116,121,0,0,0,0,0,0,0,0,45,73,110,102,105,110,105,116,121,0,0,0,0,0,0,0,78,97,78,0,0,0,0,0,37,48,103,0,0,0,0,0,88,80,97,116,104,32,79,98,106,101,99,116,32,105,115,32,117,110,105,110,105,116,105,97,108,105,122,101,100,10,0,0,88,80,97,116,104,32,111,98,106,101,99,116,32,111,102,32,117,110,101,120,112,101,99,116,101,100,32,116,121,112,101,10],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE),allocate([60,98,62,118,97,108,105,100,105,116,121,32,119,97,114,110,105,110,103,60,47,98,62,58,32,0,0,0,0,0,0,0,60,47,112,62,10,0,0,0,60,112,114,101,62,10,0,0,37,99,0,0,0,0,0,0,32,0,0,0,0,0,0,0,94,10,0,0,0,0,0,0,60,47,112,114,101,62,0,0,60,112,62,0,0,0,0,0,37,115,58,37,100,58,32,0,69,110,116,105,116,121,58,32,108,105,110,101,32,37,100,58,32,0,0,0,0,0,0,0,60,98,62,118,97,108,105,100,105,116,121,32,101,114,114,111,114,60,47,98,62,58,32,0,60,98,62,119,97,114,110,105,110,103,60,47,98,62,58,32,0,0,0,0,0,0,0,0,60,98,62,101,114,114,111,114,60,47,98,62,58,32,0,0,117,115,101,114,95,100,97,116,97,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,217,0,0,0,0,0,0,112,212,0,0,0,0,0,0,83,65,88,32,103,101,110,101,114,97,116,101,100,32,97,32,100,111,99,32,33,10,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,0,0,0,0,0,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,175,190,237,222,0,0,0,0,28,0,0,0,29,0,0,0,0,0,0,0,83,65,88,46,101,110,100,69,108,101,109,101,110,116,78,115,40,37,115,0,0,0,0,0,44,32,78,85,76,76,0,0,44,32,37,115,0,0,0,0,44,32,78,85,76,76,41,10,0,0,0,0,0,0,0,0,44,32,39,37,115,39,41,10,0,0,0,0,0,0,0,0,83,65,88,46,115,116,97,114,116,69,108,101,109,101,110,116,78,115,40,37,115,0,0,0,44,32,39,37,115,39,0,0,44,32,37,100,0,0,0,0,44,32,120,109,108,110,115,0,58,37,115,0,0,0,0,0,61,39,37,115,39,0,0,0,44,32,37,100,44,32,37,100,0,0,0,0,0,0,0,0,44,32,37,115,58,37,115,61,39,0,0,0,0,0,0,0,44,32,37,115,61,39,0,0,37,46,52,115,46,46,46,39,44,32,37,100,0,0,0,0,41,10,0,0,0,0,0,0,83,65,88,46,101,120,116,101,114,110,97,108,83,117,98,115,101,116,40,37,115,44,0,0,32,44,0,0,0,0,0,0,32,37,115,44,0,0,0,0,32,41,10,0,0,0,0,0,32,37,115,41,10,0,0,0,83,65,88,46,112,99,100,97,116,97,40,37,46,50,48,115,44,32,37,100,41,10,0,0,83,65,88,46,103,101,116,80,97,114,97,109,101,116,101,114,69,110,116,105,116,121,40,37,115,41,10,0,0,0,0,0,83,65,88,46,102,97,116,97,108,69,114,114,111,114,58,32,0,0,0,0,0,0,0,0,83,65,88,46,101,114,114,111,114,58,32,0,0,0,0,0,83,65,88,46,119,97,114,110,105,110,103,58,32,0,0,0,83,65,88,46,99,111,109,109,101,110,116,40,37,115,41,10,0,0,0,0,0,0,0,0,83,65,88,46,112,114,111,99,101,115,115,105,110,103,73,110,115,116,114,117,99,116,105,111,110,40,37,115,44,32,37,115,41,10,0,0,0,0,0,0,83,65,88,46,112,114,111,99,101,115,115,105,110,103,73,110,115,116,114,117,99,116,105,111,110,40,37,115,44,32,78,85,76,76,41,10,0,0,0,0,83,65,88,46,105,103,110,111,114,97,98,108,101,87,104,105,116,101,115,112,97,99,101,40,37,115,44,32,37,100,41,10,0,0,0,0,0,0,0,0,83,65,88,46,99,104,97,114,97,99,116,101,114,115,40,37,115,44,32,37,100,41,10,0,83,65,88,46,114,101,102,101,114,101,110,99,101,40,37,115,41,10,0,0,0,0,0,0,83,65,88,46,101,110,100,68,111,99,117,109,101,110,116,40,41,10,0,0,0,0,0,0,83,65,88,46,115,116,97,114,116,68,111,99,117,109,101,110,116,40,41,10,0,0,0,0,83,65,88,46,115,101,116,68,111,99,117,109,101,110,116,76,111,99,97,116,111,114,40,41,10,0,0,0,0,0,0,0,40,110,117,108,108,41,0,0,83,65,88,46,117,110,112,97,114,115,101,100,69,110,116,105,116,121,68,101,99,108,40,37,115,44,32,37,115,44,32,37,115,44,32,37,115,41,10,0,83,65,88,46,101,108,101,109,101,110,116,68,101,99,108,40,37,115,44,32,37,100,44,32,46,46,46,41,10,0,0,0,83,65,88,46,97,116,116,114,105,98,117,116,101,68,101,99,108,40,37,115,44,32,37,115,44,32,37,100,44,32,37,100,44,32,78,85,76,76,44,32,46,46,46,41,10,0,0,0,83,65,88,46,97,116,116,114,105,98,117,116,101,68,101,99,108,40,37,115,44,32,37,115,44,32,37,100,44,32,37,100,44,32,37,115,44,32,46,46,46,41,10,0,0,0,0,0,83,65,88,46,110,111,116,97,116,105,111,110,68,101,99,108,40,37,115,44,32,37,115,44,32,37,115,41,10,0,0,0,83,65,88,46,101,110,116,105,116,121,68,101,99,108,40,37,115,44,32,37,100,44,32,37,115,44,32,37,115,44,32,37,115,41,10,0,0,0,0,0,83,65,88,46,103,101,116,69,110,116,105,116,121,40,37,115,41,10,0,0,0,0,0,0,83,65,88,46,114,101,115,111,108,118,101,69,110,116,105,116,121,40,0,0,0,0,0,0,44,32,37,115,41,10,0,0,44,32,41,10,0,0,0,0,83,65,88,46,104,97,115,69,120,116,101,114,110,97,108,83,117,98,115,101,116,40,41,10,0,0,0,0,0,0,0,0,83,65,88,46,104,97,115,73,110,116,101,114,110,97,108,83,117,98,115,101,116,40,41,10,0,0,0,0,0,0,0,0,83,65,88,46,105,115,83,116,97,110,100,97,108,111,110,101,40,41,10,0,0,0,0,0,83,65,88,46,105,110,116,101,114,110,97,108,83,117,98,115,101,116,40,37,115,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,175,190,237,222,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,83,68,32,115,99,104,101,109,97,32,37,115,32,102,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,10,0,0,0,0,0,0,0,0,80,97,114,115,105,110,103,32,97,110,100,32,118,97,108,105,100,97,116,105,110,103,0,0,37,115,32,58,32,102,97,105,108,101,100,32,116,111,32,112,97,114,115,101,10,0,0,0,85,110,97,98,108,101,32,116,111,32,111,112,101,110,32,37,115,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,116,111,111,107,32,37,108,100,32,109,115,10,0,0,0,0,0,0,0,0,0,0,0,76,111,97,100,101,100,32,85,82,76,61,34,37,115,34,32,73,68,61,34,37,115,34,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,47,0,0,0,0,0,0,0,102,97,105,108,101,100,32,116,111,32,108,111,97,100,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,34,37,115,34,10,0,0,0,0,110,111,100,101,45,62,95,112,114,105,118,97,116,101,32,33,61,32,78,85,76,76,0,0,46,46,47,108,105,98,120,109,108,50,47,120,109,108,108,105,110,116,46,99,0,0,0,0,100,101,114,101,103,105,115,116,101,114,78,111,100,101,0,0,42,40,108,111,110,103,42,41,110,111,100,101,45,62,95,112,114,105,118,97,116,101,32,61,61,32,40,108,111,110,103,41,32,48,120,56,49,55,50,54,51,53,52,0,0,0,0,0,79,117,116,32,111,102,32,109,101,109,111,114,121,32,105,110,32,120,109,108,108,105,110,116,58,114,101,103,105,115,116,101,114,78,111,100,101,40,41,10,0,0,0,0,0,0,0,0,77,65,88,95,80,65,84,72,83,32,114,101,97,99,104,101,100,58,32,116,111,111,32,109,97,110,121,32,112,97,116,104,115,10,0,0,0,0,0,0,82,97,110,32,111,117,116,32,111,102,32,109,101,109,111,114,121,32,110,101,101,100,115,32,62,32,37,100,32,98,121,116,101,115,10,0,0,0,0,0,37,115,58,32,117,115,105,110,103,32,108,105,98,120,109,108,32,118,101,114,115,105,111,110,32,37,115,10,0,0,0,0,32,32,32,99,111,109,112,105,108,101,100,32,119,105,116,104,58,32,0,0,0,0,0,0,84,104,114,101,97,100,115,32,0,0,0,0,0,0,0,0,84,114,101,101,32,0,0,0,79,117,116,112,117,116,32,0,80,117,115,104,32,0,0,0,82,101,97,100,101,114,32,0,80,97,116,116,101,114,110,115,32,0,0,0,0,0,0,0,87,114,105,116,101,114,32,0,83,65,88,118,49,32,0,0,70,84,80,32,0,0,0,0,72,84,84,80,32,0,0,0,68,84,68,86,97,108,105,100,32,0,0,0,0,0,0,0,72,84,77,76,32,0,0,0,76,101,103,97,99,121,32,0,67,49,52,78,32,0,0,0,67,97,116,97,108,111,103,32,0,0,0,0,0,0,0,0,88,80,97,116,104,32,0,0,88,80,111,105,110,116,101,114,32,0,0,0,0,0,0,0,88,73,110,99,108,117,100,101,32,0,0,0,0,0,0,0,73,99,111,110,118,32,0,0,73,83,79,56,56,53,57,88,32,0,0,0,0,0,0,0,85,110,105,99,111,100,101,32,0,0,0,0,0,0,0,0,82,101,103,101,120,112,115,32,0,0,0,0,0,0,0,0,65,117,116,111,109,97,116,97,32,0,0,0,0,0,0,0,69,120,112,114,32,0,0,0,83,99,104,101,109,97,115,32,0,0,0,0,0,0,0,0,83,99,104,101,109,97,116,114,111,110,32,0,0,0,0,0,77,111,100,117,108,101,115,32,0,0,0,0,0,0,0,0,68,101,98,117,103,32,0,0,77,101,109,68,101,98,117,103,32,0,0,0,0,0,0,0,82,117,110,68,101,98,117,103,32,0,0,0,0,0,0,0,90,108,105,98,32,0,0,0,76,122,109,97,32,0,0,0,85,115,97,103,101,32,58,32,37,115,32,91,111,112,116,105,111,110,115,93,32,88,77,76,102,105,108,101,115,32,46,46,46,10,0,0,0,0,0,0,9,80,97,114,115,101,32,116,104,101,32,88,77,76,32,102,105,108,101,115,32,97,110,100,32,111,117,116,112,117,116,32,116,104,101,32,114,101,115,117,108,116,32,111,102,32,116,104,101,32,112,97,114,115,105,110,103,10,0,0,0,0,0,0,9,45,45,118,101,114,115,105,111,110,32,58,32,100,105,115,112,108,97,121,32,116,104,101,32,118,101,114,115,105,111,110,32,111,102,32,116,104,101,32,88,77,76,32,108,105,98,114,97,114,121,32,117,115,101,100,10,0,0,0,0,0,0,0,9,45,45,100,101,98,117,103,32,58,32,100,117,109,112,32,97,32,100,101,98,117,103,32,116,114,101,101,32,111,102,32,116,104,101,32,105,110,45,109,101,109,111,114,121,32,100,111,99,117,109,101,110,116,10,0,9,45,45,115,104,101,108,108,32,58,32,114,117,110,32,97,32,110,97,118,105,103,97,116,105,110,103,32,115,104,101,108,108,10,0,0,0,0,0,0,9,45,45,100,101,98,117,103,101,110,116,32,58,32,100,101,98,117,103,32,116,104,101,32,101,110,116,105,116,105,101,115,32,100,101,102,105,110,101,100,32,105,110,32,116,104,101,32,100,111,99,117,109,101,110,116,10,0,0,0,0,0,0,0,9,45,45,99,111,112,121,32,58,32,117,115,101,100,32,116,111,32,116,101,115,116,32,116,104,101,32,105,110,116,101,114,110,97,108,32,99,111,112,121,32,105,109,112,108,101,109,101,110,116,97,116,105,111,110,10,0,0,0,0,0,0,0,0,9,45,45,114,101,99,111,118,101,114,32,58,32,111,117,116,112,117,116,32,119,104,97,116,32,119,97,115,32,112,97,114,115,97,98,108,101,32,111,110,32,98,114,111,107,101,110,32,88,77,76,32,100,111,99,117,109,101,110,116,115,10,0,0,9,45,45,104,117,103,101,32,58,32,114,101,109,111,118,101,32,97,110,121,32,105,110,116,101,114,110,97,108,32,97,114,98,105,116,114,97,114,121,32,112,97,114,115,101,114,32,108,105,109,105,116,115,10,0,0,9,45,45,110,111,101,110,116,32,58,32,115,117,98,115,116,105,116,117,116,101,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,115,32,98,121,32,116,104,101,105,114,32,118,97,108,117,101,10,0,9,45,45,110,111,101,110,99,32,58,32,105,103,110,111,114,101,32,97,110,121,32,101,110,99,111,100,105,110,103,32,115,112,101,99,105,102,105,101,100,32,105,110,115,105,100,101,32,116,104,101,32,100,111,99,117,109,101,110,116,10,0,0,0,9,45,45,110,111,111,117,116,32,58,32,100,111,110,39,116,32,111,117,116,112,117,116,32,116,104,101,32,114,101,115,117,108,116,32,116,114,101,101,10,0,0,0,0,0,0,0,0,9,45,45,112,97,116,104,32,39,112,97,116,104,115,39,58,32,112,114,111,118,105,100,101,32,97,32,115,101,116,32,111,102,32,112,97,116,104,115,32,102,111,114,32,114,101,115,111,117,114,99,101,115,10,0,0,9,45,45,108,111,97,100,45,116,114,97,99,101,32,58,32,112,114,105,110,116,32,116,114,97,99,101,32,111,102,32,97,108,108,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,105,101,115,32,108,111,97,100,101,100,10,0,0,0,0,9,45,45,110,111,110,101,116,32,58,32,114,101,102,117,115,101,32,116,111,32,102,101,116,99,104,32,68,84,68,115,32,111,114,32,101,110,116,105,116,105,101,115,32,111,118,101,114,32,110,101,116,119,111,114,107,10,0,0,0,0,0,0,0,9,45,45,110,111,99,111,109,112,97,99,116,32,58,32,100,111,32,110,111,116,32,103,101,110,101,114,97,116,101,32,99,111,109,112,97,99,116,32,116,101,120,116,32,110,111,100,101,115,10,0,0,0,0,0,0,9,45,45,104,116,109,108,111,117,116,32,58,32,111,117,116,112,117,116,32,114,101,115,117,108,116,115,32,97,115,32,72,84,77,76,10,0,0,0,0,9,45,45,110,111,119,114,97,112,32,58,32,100,111,32,110,111,116,32,112,117,116,32,72,84,77,76,32,100,111,99,32,119,114,97,112,112,101,114,10,0,0,0,0,0,0,0,0,9,45,45,118,97,108,105,100,32,58,32,118,97,108,105,100,97,116,101,32,116,104,101,32,100,111,99,117,109,101,110,116,32,105,110,32,97,100,100,105,116,105,111,110,32,116,111,32,115,116,100,32,119,101,108,108,45,102,111,114,109,101,100,32,99,104,101,99,107,10,0,0,9,45,45,112,111,115,116,118,97,108,105,100,32,58,32,100,111,32,97,32,112,111,115,116,101,114,105,111,114,105,32,118,97,108,105,100,97,116,105,111,110,44,32,105,46,101,32,97,102,116,101,114,32,112,97,114,115,105,110,103,10,0,0,0,9,45,45,100,116,100,118,97,108,105,100,32,85,82,76,32,58,32,100,111,32,97,32,112,111,115,116,101,114,105,111,114,105,32,118,97,108,105,100,97,116,105,111,110,32,97,103,97,105,110,115,116,32,97,32,103,105,118,101,110,32,68,84,68,10,0,0,0,0,0,0,0,9,45,45,100,116,100,118,97,108,105,100,102,112,105,32,70,80,73,32,58,32,115,97,109,101,32,98,117,116,32,110,97,109,101,32,116,104,101,32,68,84,68,32,119,105,116,104,32,97,32,80,117,98,108,105,99,32,73,100,101,110,116,105,102,105,101,114,10,0,0,0,0,9,45,45,116,105,109,105,110,103,32,58,32,112,114,105,110,116,32,115,111,109,101,32,116,105,109,105,110,103,115,10,0,9,45,45,111,117,116,112,117,116,32,102,105,108,101,32,111,114,32,45,111,32,102,105,108,101,58,32,115,97,118,101,32,116,111,32,97,32,103,105,118,101,110,32,102,105,108,101,10,0,0,0,0,0,0,0,0,9,45,45,114,101,112,101,97,116,32,58,32,114,101,112,101,97,116,32,49,48,48,32,116,105,109,101,115,44,32,102,111,114,32,116,105,109,105,110,103,32,111,114,32,112,114,111,102,105,108,105,110,103,10,0,0,9,45,45,105,110,115,101,114,116,32,58,32,97,100,45,104,111,99,32,116,101,115,116,32,102,111,114,32,118,97,108,105,100,32,105,110,115,101,114,116,105,111,110,115,10,0,0,0,9,45,45,104,116,109,108,32,58,32,117,115,101,32,116,104,101,32,72,84,77,76,32,112,97,114,115,101,114,10,0,0,9,45,45,120,109,108,111,117,116,32,58,32,102,111,114,99,101,32,116,111,32,117,115,101,32,116,104,101,32,88,77,76,32,115,101,114,105,97,108,105,122,101,114,32,119,104,101,110,32,117,115,105,110,103,32,45,45,104,116,109,108,10,0,0,9,45,45,110,111,100,101,102,100,116,100,32,58,32,100,111,32,110,111,116,32,100,101,102,97,117,108,116,32,72,84,77,76,32,100,111,99,116,121,112,101,10,0,0,0,0,0,0,9,45,45,112,117,115,104,32,58,32,117,115,101,32,116,104,101,32,112,117,115,104,32,109,111,100,101,32,111,102,32,116,104,101,32,112,97,114,115,101,114,10,0,0,0,0,0,0,9,45,45,112,117,115,104,115,109,97,108,108,32,58,32,117,115,101,32,116,104,101,32,112,117,115,104,32,109,111,100,101,32,111,102,32,116,104,101,32,112,97,114,115,101,114,32,117,115,105,110,103,32,116,105,110,121,32,105,110,99,114,101,109,101,110,116,115,10,0,0,0,9,45,45,109,101,109,111,114,121,32,58,32,112,97,114,115,101,32,102,114,111,109,32,109,101,109,111,114,121,10,0,0,9,45,45,109,97,120,109,101,109,32,110,98,98,121,116,101,115,32,58,32,108,105,109,105,116,115,32,109,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,116,111,32,110,98,98,121,116,101,115,32,98,121,116,101,115,10,0,0,9,45,45,110,111,119,97,114,110,105,110,103,32,58,32,100,111,32,110,111,116,32,101,109,105,116,32,119,97,114,110,105,110,103,115,32,102,114,111,109,32,112,97,114,115,101,114,47,118,97,108,105,100,97,116,111,114,10,0,0,0,0,0,0,9,45,45,110,111,98,108,97,110,107,115,32,58,32,100,114,111,112,32,40,105,103,110,111,114,97,98,108,101,63,41,32,98,108,97,110,107,115,32,115,112,97,99,101,115,10,0,0,9,45,45,110,111,99,100,97,116,97,32,58,32,114,101,112,108,97,99,101,32,99,100,97,116,97,32,115,101,99,116,105,111,110,32,119,105,116,104,32,116,101,120,116,32,110,111,100,101,115,10,0,0,0,0,0,9,45,45,102,111,114,109,97,116,32,58,32,114,101,102,111,114,109,97,116,47,114,101,105,110,100,101,110,116,32,116,104,101,32,105,110,112,117,116,10,0,0,0,0,0,0,0,0,9,45,45,101,110,99,111,100,101,32,101,110,99,111,100,105,110,103,32,58,32,111,117,116,112,117,116,32,105,110,32,116,104,101,32,103,105,118,101,110,32,101,110,99,111,100,105,110,103,10,0,0,0,0,0,0,9,45,45,100,114,111,112,100,116,100,32,58,32,114,101,109,111,118,101,32,116,104,101,32,68,79,67,84,89,80,69,32,111,102,32,116,104,101,32,105,110,112,117,116,32,100,111,99,115,10,0,0,0,0,0,0,9,45,45,112,114,101,116,116,121,32,83,84,89,76,69,32,58,32,112,114,101,116,116,121,45,112,114,105,110,116,32,105,110,32,97,32,112,97,114,116,105,99,117,108,97,114,32,115,116,121,108,101,10,0,0,0,9,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,48,32,68,111,32,110,111,116,32,112,114,101,116,116,121,32,112,114,105,110,116,10,0,0,0,0,0,0,0,0,9,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,49,32,70,111,114,109,97,116,32,116,104,101,32,88,77,76,32,99,111,110,116,101,110,116,44,32,97,115,32,45,45,102,111,114,109,97,116,10,0,0,0,0,0,0,0,0,9,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,50,32,65,100,100,32,119,104,105,116,101,115,112,97,99,101,32,105,110,115,105,100,101,32,116,97,103,115,44,32,112,114,101,115,101,114,118,105,110,103,32,99,111,110,116,101,110,116,10,0,0,0,0,0,9,45,45,99,49,52,110,32,58,32,115,97,118,101,32,105,110,32,87,51,67,32,99,97,110,111,110,105,99,97,108,32,102,111,114,109,97,116,32,118,49,46,48,32,40,119,105,116,104,32,99,111,109,109,101,110,116,115,41,10,0,0,0,0,9,45,45,99,49,52,110,49,49,32,58,32,115,97,118,101,32,105,110,32,87,51,67,32,99,97,110,111,110,105,99,97,108,32,102,111,114,109,97,116,32,118,49,46,49,32,40,119,105,116,104,32,99,111,109,109,101,110,116,115,41,10,0,0,9,45,45,101,120,99,45,99,49,52,110,32,58,32,115,97,118,101,32,105,110,32,87,51,67,32,101,120,99,108,117,115,105,118,101,32,99,97,110,111,110,105,99,97,108,32,102,111,114,109,97,116,32,40,119,105,116,104,32,99,111,109,109,101,110,116,115,41,10,0,0,0,9,45,45,110,115,99,108,101,97,110,32,58,32,114,101,109,111,118,101,32,114,101,100,117,110,100,97,110,116,32,110,97,109,101,115,112,97,99,101,32,100,101,99,108,97,114,97,116,105,111,110,115,10,0,0,0,9,45,45,116,101,115,116,73,79,32,58,32,116,101,115,116,32,117,115,101,114,32,73,47,79,32,115,117,112,112,111,114,116,10,0,0,0,0,0,0,9,45,45,99,97,116,97,108,111,103,115,32,58,32,117,115,101,32,83,71,77,76,32,99,97,116,97,108,111,103,115,32,102,114,111,109,32,36,83,71,77,76,95,67,65,84,65,76,79,71,95,70,73,76,69,83,10,0,0,0,0,0,0,0,9,32,32,32,32,32,32,32,32,32,32,32,32,32,111,116,104,101,114,119,105,115,101,32,88,77,76,32,67,97,116,97,108,111,103,115,32,115,116,97,114,116,105,110,103,32,102,114,111,109,32,10,0,0,0,0,9,32,32,32,32,32,32,32,32,32,37,115,32,97,114,101,32,97,99,116,105,118,97,116,101,100,32,98,121,32,100,101,102,97,117,108,116,10,0,0,102,105,108,101,58,47,47,47,101,116,99,47,120,109,108,47,99,97,116,97,108,111,103,0,9,45,45,110,111,99,97,116,97,108,111,103,115,58,32,100,101,97,99,116,105,118,97,116,101,32,97,108,108,32,99,97,116,97,108,111,103,115,10,0,9,45,45,97,117,116,111,32,58,32,103,101,110,101,114,97,116,101,32,97,32,115,109,97,108,108,32,100,111,99,32,111,110,32,116,104,101,32,102,108,121,10,0,0,0,0,0,0,9,45,45,120,105,110,99,108,117,100,101,32,58,32,100,111,32,88,73,110,99,108,117,100,101,32,112,114,111,99,101,115,115,105,110,103,10,0,0,0,9,45,45,110,111,120,105,110,99,108,117,100,101,110,111,100,101,32,58,32,115,97,109,101,32,98,117,116,32,100,111,32,110,111,116,32,103,101,110,101,114,97,116,101,32,88,73,110,99,108,117,100,101,32,110,111,100,101,115,10,0,0,0,0,9,45,45,110,111,102,105,120,117,112,45,98,97,115,101,45,117,114,105,115,32,58,32,100,111,32,110,111,116,32,102,105,120,117,112,32,120,109,108,58,98,97,115,101,32,117,114,105,115,10,0,0,0,0,0,0,9,45,45,108,111,97,100,100,116,100,32,58,32,102,101,116,99,104,32,101,120,116,101,114,110,97,108,32,68,84,68,10,0,0,0,0,0,0,0,0,9,45,45,100,116,100,97,116,116,114,32,58,32,108,111,97,100,100,116,100,32,43,32,112,111,112,117,108,97,116,101,32,116,104,101,32,116,114,101,101,32,119,105,116,104,32,105,110,104,101,114,105,116,101,100,32,97,116,116,114,105,98,117,116,101,115,32,10,0,0,0,0,9,45,45,115,116,114,101,97,109,32,58,32,117,115,101,32,116,104,101,32,115,116,114,101,97,109,105,110,103,32,105,110,116,101,114,102,97,99,101,32,116,111,32,112,114,111,99,101,115,115,32,118,101,114,121,32,108,97,114,103,101,32,102,105,108,101,115,10,0,0,0,0,9,45,45,119,97,108,107,101,114,32,58,32,99,114,101,97,116,101,32,97,32,114,101,97,100,101,114,32,97,110,100,32,119,97,108,107,32,116,104,111,117,103,104,32,116,104,101,32,114,101,115,117,108,116,105,110,103,32,100,111,99,10,0,0,9,45,45,112,97,116,116,101,114,110,32,112,97,116,116,101,114,110,95,118,97,108,117,101,32,58,32,116,101,115,116,32,116,104,101,32,112,97,116,116,101,114,110,32,115,117,112,112,111,114,116,10,0,0,0,0,9,45,45,99,104,107,114,101,103,105,115,116,101,114,32,58,32,118,101,114,105,102,121,32,116,104,101,32,110,111,100,101,32,114,101,103,105,115,116,114,97,116,105,111,110,32,99,111,100,101,10,0,0,0,0,0,9,45,45,114,101,108,97,120,110,103,32,115,99,104,101,109,97,32,58,32,100,111,32,82,101,108,97,120,78,71,32,118,97,108,105,100,97,116,105,111,110,32,97,103,97,105,110,115,116,32,116,104,101,32,115,99,104,101,109,97,10,0,0,0,9,45,45,115,99,104,101,109,97,32,115,99,104,101,109,97,32,58,32,100,111,32,118,97,108,105,100,97,116,105,111,110,32,97,103,97,105,110,115,116,32,116,104,101,32,87,88,83,32,115,99,104,101,109,97,10,0,0,0,0,0,0,0,0,9,45,45,115,99,104,101,109,97,116,114,111,110,32,115,99,104,101,109,97,32,58,32,100,111,32,118,97,108,105,100,97,116,105,111,110,32,97,103,97,105,110,115,116,32,97,32,115,99,104,101,109,97,116,114,111,110,10,0,0,0,0,0,0,9,45,45,115,97,120,49,58,32,117,115,101,32,116,104,101,32,111,108,100,32,83,65,88,49,32,105,110,116,101,114,102,97,99,101,115,32,102,111,114,32,112,114,111,99,101,115,115,105,110,103,10,0,0,0,0,9,45,45,115,97,120,58,32,100,111,32,110,111,116,32,98,117,105,108,100,32,97,32,116,114,101,101,32,98,117,116,32,119,111,114,107,32,106,117,115,116,32,97,116,32,116,104,101,32,83,65,88,32,108,101,118,101,108,10,0,0,0,0,0,9,45,45,111,108,100,120,109,108,49,48,58,32,117,115,101,32,88,77,76,45,49,46,48,32,112,97,114,115,105,110,103,32,114,117,108,101,115,32,98,101,102,111,114,101,32,116,104,101,32,53,116,104,32,101,100,105,116,105,111,110,10,0,0,9,45,45,120,112,97,116,104,32,101,120,112,114,58,32,101,118,97,108,117,97,116,101,32,116,104,101,32,88,80,97,116,104,32,101,120,112,114,101,115,115,105,111,110,44,32,105,109,112,108,121,32,45,45,110,111,111,117,116,10,0,0,0,0,10,76,105,98,120,109,108,32,112,114,111,106,101,99,116,32,104,111,109,101,32,112,97,103,101,58,32,104,116,116,112,58,47,47,120,109,108,115,111,102,116,46,111,114,103,47,10,0,84,111,32,114,101,112,111,114,116,32,98,117,103,115,32,111,114,32,103,101,116,32,115,111,109,101,32,104,101,108,112,32,99,104,101,99,107,58,32,104,116,116,112,58,47,47,120,109,108,115,111,102,116,46,111,114,103,47,98,117,103,115,46,104,116,109,108,10,0,0,0,0,83,65,88,46,101,110,100,69,108,101,109,101,110,116,40,37,115,41,10,0,0,0,0,0,83,65,88,46,115,116,97,114,116,69,108,101,109,101,110,116,40,37,115,0,0,0,0,0,37,115,39,0,0,0,0,0,108,116,0,0,0,0,0,0,0,0,0,0,17,0,0,0,56,238,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,242,0,0,120,242,0,0,1,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,103,116,0,0,0,0,0,0,0,0,0,0,17,0,0,0,144,238,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,242,0,0,112,242,0,0,1,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,97,109,112,0,0,0,0,0,0,0,0,0,17,0,0,0,232,238,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,242,0,0,104,242,0,0,1,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,97,112,111,115,0,0,0,0,0,0,0,0,17,0,0,0,64,239,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,242,0,0,96,242,0,0,1,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,113,117,111,116,0,0,0,0,0,0,0,0,17,0,0,0,152,239,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,241,0,0,64,241,0,0,1,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,120,109,108,65,100,100,68,116,100,69,110,116,105,116,121,58,32,100,111,99,117,109,101,110,116,32,105,115,32,78,85,76,76,0,0,0,0,0,0,0,120,109,108,65,100,100,68,116,100,69,110,116,105,116,121,58,32,100,111,99,117,109,101,110,116,32,119,105,116,104,111,117,116,32,101,120,116,101,114,110,97,108,32,115,117,98,115,101,116,0,0,0,0,0,0,0,120,109,108,65,100,100,68,111,99,69,110,116,105,116,121,58,32,100,111,99,117,109,101,110,116,32,105,115,32,78,85,76,76,0,0,0,0,0,0,0,120,109,108,65,100,100,68,111,99,69,110,116,105,116,121,58,32,100,111,99,117,109,101,110,116,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,115,117,98,115,101,116,0,0,0,0,0,0,0,60,33,69,78,84,73,84,89,32,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,62,10,0,0,0,0,0,0,32,80,85,66,76,73,67,32,0,0,0,0,0,0,0,0,32,83,89,83,84,69,77,32,0,0,0,0,0,0,0,0,32,78,68,65,84,65,32,0,60,33,69,78,84,73,84,89,32,37,32,0,0,0,0,0,120,109,108,68,117,109,112,69,110,116,105,116,105,101,115,68,101,99,108,58,32,105,110,116,101,114,110,97,108,58,32,117,110,107,110,111,119,110,32,116,121,112,101,32,101,110,116,105,116,121,32,116,121,112,101,0,34,0,0,0,0,0,0,0,38,113,117,111,116,59,0,0,38,35,120,50,53,59,0,0,120,109,108,67,111,112,121,69,110,116,105,116,121,58,58,32,109,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,120,109,108,69,110,99,111,100,101,69,110,116,105,116,105,101,115,58,32,109,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,0,0,0,0,0,45,45,62,0,0,0,0,0,120,109,108,69,110,99,111,100,101,69,110,116,105,116,105,101,115,58,32,105,110,112,117,116,32,110,111,116,32,85,84,70,45,56,0,0,0,0,0,0,73,83,79,45,56,56,53,57,45,49,0,0,0,0,0,0,38,35,37,100,59,0,0,0,120,109,108,69,110,99,111,100,101,69,110,116,105,116,105,101,115,58,32,99,104,97,114,32,111,117,116,32,111,102,32,114,97,110,103,101,10,0,0,0,38,35,120,37,88,59,0,0,120,109,108,69,110,99,111,100,101,69,110,116,105,116,105,101,115,58,32,114,101,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,0,0,0,0,120,109,108,67,114,101,97,116,101,69,110,116,105,116,121,58,32,109,97,108,108,111,99,32,102,97,105,108,101,100,0,0,39,0,0,0,0,0,0,0,38,0,0,0,0,0,0,0,62,0,0,0,0,0,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,85,84,70,45,56,0,0,0,85,84,70,56,0,0,0,0,85,84,70,45,49,54,0,0,85,84,70,49,54,0,0,0,73,83,79,45,49,48,54,52,54,45,85,67,83,45,50,0,85,67,83,45,50,0,0,0,85,67,83,50,0,0,0,0,73,83,79,45,49,48,54,52,54,45,85,67,83,45,52,0,85,67,83,45,52,0,0,0,85,67,83,52,0,0,0,0,73,83,79,45,56,56,53,57,45,49,0,0,0,0,0,0,73,83,79,45,76,65,84,73,78,45,49,0,0,0,0,0,73,83,79,32,76,65,84,73,78,32,49,0,0,0,0,0,73,83,79,45,56,56,53,57,45,50,0,0,0,0,0,0,73,83,79,45,76,65,84,73,78,45,50,0,0,0,0,0,73,83,79,32,76,65,84,73,78,32,50,0,0,0,0,0,73,83,79,45,56,56,53,57,45,51,0,0,0,0,0,0,73,83,79,45,56,56,53,57,45,52,0,0,0,0,0,0,73,83,79,45,56,56,53,57,45,53,0,0,0,0,0,0,73,83,79,45,56,56,53,57,45,54,0,0,0,0,0,0,73,83,79,45,56,56,53,57,45,55,0,0,0,0,0,0,73,83,79,45,56,56,53,57,45,56,0,0,0,0,0,0,73,83,79,45,56,56,53,57,45,57,0,0,0,0,0,0,73,83,79,45,50,48,50,50,45,74,80,0,0,0,0,0,83,72,73,70,84,95,74,73,83,0,0,0,0,0,0,0,69,85,67,45,74,80,0,0,69,66,67,68,73,67,0,0,83,104,105,102,116,45,74,73,83,0,0,0,0,0,0,0,120,109,108,78,101,119,67,104,97,114,69,110,99,111,100,105,110,103,72,97,110,100,108,101,114,32,58,32,110,111,32,110,97,109,101,32,33,10,0,0,120,109,108,78,101,119,67,104,97,114,69,110,99,111,100,105,110,103,72,97,110,100,108,101,114,32,58,32,111,117,116,32,111,102,32,109,101,109,111,114,121,32,33,10,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,79,100,100,32,112,114,111,98,108,101,109,32,97,116,32,101,110,100,105,97,110,110,101,115,115,32,100,101,116,101,99,116,105,111,110,10,0,0,0,0,120,109,108,73,110,105,116,67,104,97,114,69,110,99,111,100,105,110,103,72,97,110,100,108,101,114,115,32,58,32,111,117,116,32,111,102,32,109,101,109,111,114,121,32,33,10,0,0,85,84,70,45,49,54,76,69,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,85,84,70,45,49,54,66,69,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,83,67,73,73,0,0,0,85,83,45,65,83,67,73,73,0,0,0,0,0,0,0,0,72,84,77,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,109,108,82,101,103,105,115,116,101,114,67,104,97,114,69,110,99,111,100,105,110,103,72,97,110,100,108,101,114,58,32,78,85,76,76,32,104,97,110,100,108,101,114,32,33,10,0,120,109,108,82,101,103,105,115,116,101,114,67,104,97,114,69,110,99,111,100,105,110,103,72,97,110,100,108,101,114,58,32,84,111,111,32,109,97,110,121,32,104,97,110,100,108,101,114,32,114,101,103,105,115,116,101,114,101,100,44,32,115,101,101,32,37,115,10,0,0,0,0,77,65,88,95,69,78,67,79,68,73,78,71,95,72,65,78,68,76,69,82,83,0,0,0,101,98,99,100,105,99,0,0,69,66,67,68,73,67,45,85,83,0,0,0,0,0,0,0,73,66,77,45,48,51,55,0,83,72,73,70,84,45,74,73,83,0,0,0,0,0,0,0,83,104,105,102,116,95,74,73,83,0,0,0,0,0,0,0,105,99,111,110,118,32,58,32,112,114,111,98,108,101,109,115,32,119,105,116,104,32,102,105,108,116,101,114,115,32,102,111,114,32,39,37,115,39,10,0,48,120,37,48,50,88,32,48,120,37,48,50,88,32,48,120,37,48,50,88,32,48,120,37,48,50,88,0,0,0,0,0,105,110,112,117,116,32,99,111,110,118,101,114,115,105,111,110,32,102,97,105,108,101,100,32,100,117,101,32,116,111,32,105,110,112,117,116,32,101,114,114,111,114,44,32,98,121,116,101,115,32,37,115,10,0,0,0,120,109,108,67,104,97,114,69,110,99,79,117,116,70,117,110,99,58,32,110,111,32,111,117,116,112,117,116,32,102,117,110,99,116,105,111,110,32,33,10,0,0,0,0,0,0,0,0,38,35,37,100,59,0,0,0,111,117,116,112,117,116,32,99,111,110,118,101,114,115,105,111,110,32,102,97,105,108,101,100,32,100,117,101,32,116,111,32,99,111,110,118,32,101,114,114,111,114,44,32,98,121,116,101,115,32,37,115,10,0,0,0,37,115,58,37,100,58,32,0,69,110,116,105,116,121,58,32,108,105,110,101,32,37,100,58,32,0,0,0,0,0,0,0,78,111,32,101,114,114,111,114,32,109,101,115,115,97,103,101,32,112,114,111,118,105,100,101,100,0,0,0,0,0,0,0,104,114,101,102,0,0,0,0,37,115,0,0,0,0,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,32,58,32,37,115,10,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,10,0,0,0,0,0,0,0,101,114,114,111,114,58,32,0,10,0,0,0,0,0,0,0,119,97,114,110,105,110,103,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,118,97,108,105,100,105,116,121,32,101,114,114,111,114,58,32,0,0,0,0,0,0,0,0,118,97,108,105,100,105,116,121,32,119,97,114,110,105,110,103,58,32,0,0,0,0,0,0,101,108,101,109,101,110,116,32,37,115,58,32,0,0,0,0,112,97,114,115,101,114,32,0,110,97,109,101,115,112,97,99,101,32,0,0,0,0,0,0,118,97,108,105,100,105,116,121,32,0,0,0,0,0,0,0,72,84,77,76,32,112,97,114,115,101,114,32,0,0,0,0,109,101,109,111,114,121,32,0,111,117,116,112,117,116,32,0,73,47,79,32,0,0,0,0,88,73,110,99,108,117,100,101,32,0,0,0,0,0,0,0,88,80,97,116,104,32,0,0,114,101,103,101,120,112,32,0,109,111,100,117,108,101,32,0,83,99,104,101,109,97,115,32,118,97,108,105,100,105,116,121,32,0,0,0,0,0,0,0,83,99,104,101,109,97,115,32,112,97,114,115,101,114,32,0,82,101,108,97,120,45,78,71,32,112,97,114,115,101,114,32,0,0,0,0,0,0,0,0,82,101,108,97,120,45,78,71,32,118,97,108,105,100,105,116,121,32,0,0,0,0,0,0,67,97,116,97,108,111,103,32,0,0,0,0,0,0,0,0,67,49,52,78,32,0,0,0,88,83,76,84,32,0,0,0,101,110,99,111,100,105,110,103,32,0,0,0,0,0,0,0,115,99,104,101,109,97,116,114,111,110,32,0,0,0,0,0,105,110,116,101,114,110,97,108,32,98,117,102,102,101,114,32,0,0,0,0,0,0,0,0,85,82,73,32,0,0,0,0,58,32,0,0,0,0,0,0,119,97,114,110,105,110,103,32,58,32,0,0,0,0,0,0,101,114,114,111,114,32,58,32,0,0,0,0,0,0,0,0,37,115,10,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,32,101,114,114,111,114,0,0,0,0,0,37,115,58,37,100,58,32,10,0,0,0,0,0,0,0,0,69,110,116,105,116,121,58,32,108,105,110,101,32,37,100,58,32,10,0,0,0,0,0,0,70,97,116,97,108,58,32,112,114,111,103,114,97,109,32,99,111,109,112,105,108,101,100,32,97,103,97,105,110,115,116,32,108,105,98,120,109,108,32,37,100,32,117,115,105,110,103,32,108,105,98,120,109,108,32,37,100,10,0,0,0,0,0,0,87,97,114,110,105,110,103,58,32,112,114,111,103,114,97,109,32,99,111,109,112,105,108,101,100,32,97,103,97,105,110,115,116,32,108,105,98,120,109,108,32,37,100,32,117,115,105,110,103,32,111,108,100,101,114,32,37,100,10,0,0,0,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,32,58,32,37,115,10,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,10,0,0,0,0,0,0,0,67,104,97,114,32,48,120,37,88,32,111,117,116,32,111,102,32,97,108,108,111,119,101,100,32,114,97,110,103,101,10,0,73,110,112,117,116,32,105,115,32,110,111,116,32,112,114,111,112,101,114,32,85,84,70,45,56,44,32,105,110,100,105,99,97,116,101,32,101,110,99,111,100,105,110,103,32,33,10,0,66,121,116,101,115,58,32,48,120,37,48,50,88,32,48,120,37,48,50,88,32,48,120,37,48,50,88,32,48,120,37,48,50,88,10,0,0,0,0,0,73,110,112,117,116,32,105,115,32,110,111,116,32,112,114,111,112,101,114,32,85,84,70,45,56,44,32,105,110,100,105,99,97,116,101,32,101,110,99,111,100,105,110,103,32,33,10,37,115,0,0,0,0,0,0,0,67,104,97,114,32,48,120,48,32,111,117,116,32,111,102,32,97,108,108,111,119,101,100,32,114,97,110,103,101,10,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,120,109,108,67,111,112,121,67,104,97,114,77,117,108,116,105,66,121,116,101,32,48,120,37,88,32,111,117,116,32,111,102,32,98,111,117,110,100,10,0,101,110,99,111,100,105,110,103,32,117,110,107,110,111,119,110,10,0,0,0,0,0,0,0,101,110,99,111,100,105,110,103,32,110,111,116,32,115,117,112],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+54128),
allocate([112,111,114,116,101,100,32,37,115,10,0,0,0,0,0,0,85,83,67,52,32,108,105,116,116,108,101,32,101,110,100,105,97,110,0,0,0,0,0,0,85,83,67,52,32,98,105,103,32,101,110,100,105,97,110,0,69,66,67,68,73,67,0,0,85,67,83,52,32,50,49,52,51,0,0,0,0,0,0,0,85,67,83,52,32,51,52,49,50,0,0,0,0,0,0,0,85,67,83,50,0,0,0,0,73,83,79,45,50,48,50,50,45,74,80,0,0,0,0,0,83,104,105,102,116,95,74,73,83,0,0,0,0,0,0,0,69,85,67,45,74,80,0,0,99,111,117,108,100,110,39,116,32,97,108,108,111,99,97,116,101,32,97,32,110,101,119,32,105,110,112,117,116,32,115,116,114,101,97,109,10,0,0,0,110,101,119,32,105,110,112,117,116,32,102,114,111,109,32,73,47,79,10,0,0,0,0,0,120,109,108,78,101,119,69,110,116,105,116,121,73,110,112,117,116,83,116,114,101,97,109,32,101,110,116,105,116,121,32,61,32,78,85,76,76,10,0,0,110,101,119,32,105,110,112,117,116,32,102,114,111,109,32,101,110,116,105,116,121,58,32,37,115,10,0,0,0,0,0,0,67,97,110,110,111,116,32,112,97,114,115,101,32,101,110,116,105,116,121,32,37,115,10,0,73,110,116,101,114,110,97,108,32,101,110,116,105,116,121,32,37,115,32,119,105,116,104,111,117,116,32,99,111,110,116,101,110,116,32,33,10,0,0,0,73,110,116,101,114,110,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,32,37,115,32,119,105,116,104,111,117,116,32,99,111,110,116,101,110,116,32,33,10,0,80,114,101,100,101,102,105,110,101,100,32,101,110,116,105,116,121,32,37,115,32,119,105,116,104,111,117,116,32,99,111,110,116,101,110,116,32,33,10,0,110,101,119,32,105,110,112,117,116,32,102,114,111,109,32,102,105,108,101,58,32,37,115,10,0,0,0,0,0,0,0,0,102,97,105,108,101,100,32,116,111,32,108,111,97,100,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,58,32,78,85,76,76,32,102,105,108,101,110,97,109,101,32,10,0,102,97,105,108,101,100,32,116,111,32,108,111,97,100,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,34,37,115,34,10,0,0,0,0,71,111,116,32,78,85,76,76,32,112,97,114,115,101,114,32,99,111,110,116,101,120,116,10,0,0,0,0,0,0,0,0,99,97,110,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,112,97,114,115,101,114,32,99,111,110,116,101,120,116,10,0,0,0,0,0,0,0,99,97,110,110,111,116,32,97,108,108,111,99,97,116,101,32,112,97,114,115,101,114,32,99,111,110,116,101,120,116,10,0,102,97,105,108,101,100,32,116,111,32,97,108,108,111,99,97,116,101,32,98,117,102,102,101,114,10,0,0,0,0,0,0,120,109,108,83,119,105,116,99,104,84,111,69,110,99,111,100,105,110,103,32,58,32,110,111,32,105,110,112,117,116,10,0,85,84,70,45,49,54,76,69,0,0,0,0,0,0,0,0,85,84,70,45,49,54,0,0,85,84,70,45,49,54,66,69,0,0,0,0,0,0,0,0,85,84,70,45,56,0,0,0,115,119,105,116,99,104,105,110,103,32,101,110,99,111,100,105,110,103,58,32,101,110,99,111,100,101,114,32,101,114,114,111,114,10,0,0,0,0,0,0,115,119,105,116,99,104,105,110,103,32,101,110,99,111,100,105,110,103,32,58,32,110,111,32,105,110,112,117,116,10,0,0,0,1,0,0,0,0,0,0,69,120,99,101,115,115,105,118,101,32,100,101,112,116,104,32,105,110,32,100,111,99,117,109,101,110,116,58,32,37,100,32,117,115,101,32,88,77,76,95,80,65,82,83,69,95,72,85,71,69,32,111,112,116,105,111,110,10,0,0,0,0,0,0,80,111,112,112,105,110,103,32,105,110,112,117,116,32,37,100,10,0,0,0,0,0,0,0,37,115,40,37,100,41,58,32,0,0,0,0,0,0,0,0,80,117,115,104,105,110,103,32,105,110,112,117,116,32,37,100,32,58,32,37,46,51,48,115,10,0,0,0,0,0,0,0,120,109,108,80,97,114,115,101,67,104,97,114,82,101,102,58,32,105,110,118,97,108,105,100,32,120,109,108,67,104,97,114,32,118,97,108,117,101,32,37,100,10,0,0,0,0,0,0,80,69,82,101,102,101,114,101,110,99,101,58,32,37,115,10,0,0,0,0,0,0,0,0,80,69,82,101,102,101,114,101,110,99,101,58,32,37,37,37,115,59,32,110,111,116,32,102,111,117,110,100,10,0,0,0,80,69,82,101,102,101,114,101,110,99,101,58,32,37,115,32,105,115,32,110,111,116,32,97,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,10,0,0,0,0,0,0,83,116,114,105,110,103,32,100,101,99,111,100,105,110,103,32,69,110,116,105,116,121,32,82,101,102,101,114,101,110,99,101,58,32,37,46,51,48,115,10,0,0,0,0,0,0,0,0,112,114,101,100,101,102,105,110,101,100,32,101,110,116,105,116,121,32,104,97,115,32,110,111,32,99,111,110,116,101,110,116,10,0,0,0,0,0,0,0,83,116,114,105,110,103,32,100,101,99,111,100,105,110,103,32,80,69,32,82,101,102,101,114,101,110,99,101,58,32,37,46,51,48,115,10,0,0,0,0,0,0,0,0,0,0,0,0,78,97,109,101,32,37,115,32,105,115,32,110,111,116,32,88,77,76,32,78,97,109,101,115,112,97,99,101,32,99,111,109,112,108,105,97,110,116,10,0,78,97,109,101,0,0,0,0,78,109,84,111,107,101,110,0,69,110,116,105,116,121,86,97,108,117,101,58,32,39,37,99,39,32,102,111,114,98,105,100,100,101,110,32,101,120,99,101,112,116,32,102,111,114,32,101,110,116,105,116,105,101,115,32,114,101,102,101,114,101,110,99,101,115,10,0,0,0,0,0,83,121,115,116,101,109,76,105,116,101,114,97,108,0,0,0,80,117,98,108,105,99,32,73,68,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,33,34,35,36,37,0,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,0,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,0,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,39,83,89,83,84,69,77,39,10,0,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,39,80,85,66,76,73,67,39,10,0,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,116,104,101,32,80,117,98,108,105,99,32,73,100,101,110,116,105,102,105,101,114,10,0,0,0,0,0,67,111,109,109,101,110,116,32,116,111,111,32,98,105,103,32,102,111,117,110,100,0,0,0,99,111,109,109,101,110,116,32,100,111,101,115,110,39,116,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,32,105,110,32,116,104,101,32,115,97,109,101,32,101,110,116,105,116,121,10,0,0,0,0,0,0,68,111,117,98,108,101,32,104,121,112,104,101,110,32,119,105,116,104,105,110,32,99,111,109,109,101,110,116,58,32,60,33,45,45,37,46,53,48,115,10,0,0,0,0,0,0,0,0,68,111,117,98,108,101,32,104,121,112,104,101,110,32,119,105,116,104,105,110,32,99,111,109,109,101,110,116,10,0,0,0,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,97,108,108,111,119,101,100,32,111,110,108,121,32,97,116,32,116,104,101,32,115,116,97,114,116,32,111,102,32,116,104,101,32,100,111,99,117,109,101,110,116,10,0,0,0,0,0,0,168,27,1,0,184,27,1,0,0,0,0,0,0,0,0,0,120,109,108,80,97,114,115,101,80,73,84,97,114,103,101,116,58,32,105,110,118,97,108,105,100,32,110,97,109,101,32,112,114,101,102,105,120,32,39,120,109,108,39,10,0,0,0,0,99,111,108,111,110,115,32,97,114,101,32,102,111,114,98,105,100,100,101,110,32,102,114,111,109,32,80,73,32,110,97,109,101,115,32,39,37,115,39,10,0,0,0,0,0,0,0,0,80,73,32,100,101,99,108,97,114,97,116,105,111,110,32,100,111,101,115,110,39,116,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,32,105,110,32,116,104,101,32,115,97,109,101,32,101,110,116,105,116,121,10,0,0,0,0,0,0,0,80,97,114,115,101,80,73,58,32,80,73,32,37,115,32,115,112,97,99,101,32,101,120,112,101,99,116,101,100,10,0,0,80,73,32,37,115,32,116,111,111,32,98,105,103,32,102,111,117,110,100,0,0,0,0,0,80,97,114,115,101,80,73,58,32,80,73,32,37,115,32,110,101,118,101,114,32,101,110,100,32,46,46,46,10,0,0,0,111,97,115,105,115,45,120,109,108,45,99,97,116,97,108,111,103,0,0,0,0,0,0,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,39,60,33,78,79,84,65,84,73,79,78,39,10,0,0,0,0,0,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,116,104,101,32,78,79,84,65,84,73,79,78,32,110,97,109,101,39,10,0,0,0,0,0,0,0,0,99,111,108,111,110,115,32,97,114,101,32,102,111,114,98,105,100,100,101,110,32,102,114,111,109,32,110,111,116,97,116,105,111,110,32,110,97,109,101,115,32,39,37,115,39,10,0,0,78,111,116,97,116,105,111,110,32,100,101,99,108,97,114,97,116,105,111,110,32,100,111,101,115,110,39,116,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,32,105,110,32,116,104,101,32,115,97,109,101,32,101,110,116,105,116,121,10,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,39,60,33,69,78,84,73,84,89,39,10,0,0,0,0,0,0,0,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,39,37,39,10,0,0,0,0,0,0,0,120,109,108,80,97,114,115,101,69,110,116,105,116,121,68,101,99,108,58,32,110,111,32,110,97,109,101,10,0,0,0,0,99,111,108,111,110,115,32,97,114,101,32,102,111,114,98,105,100,100,101,110,32,102,114,111,109,32,101,110,116,105,116,105,101,115,32,110,97,109,101,115,32,39,37,115,39,10,0,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,116,104,101,32,101,110,116,105,116,121,32,110,97,109,101,10,0,0,0,73,110,118,97,108,105,100,32,85,82,73,58,32,37,115,10,0,0,0,0,0,0,0,0,83,65,88,32,99,111,109,112,97,116,105,98,105,108,105,116,121,32,109,111,100,101,32,100,111,99,117,109,101,110,116,0,78,101,119,32,68,111,99,32,102,97,105,108,101,100,0,0,102,97,107,101,0,0,0,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,98,101,102,111,114,101,32,39,78,68,65,84,65,39,10,0,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,39,78,68,65,84,65,39,10,0,0,0,120,109,108,80,97,114,115,101,69,110,116,105,116,121,68,101,99,108,58,32,101,110,116,105,116,121,32,37,115,32,110,111,116,32,116,101,114,109,105,110,97,116,101,100,10,0,0,0,69,110,116,105,116,121,32,100,101,99,108,97,114,97,116,105,111,110,32,100,111,101,115,110,39,116,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,32,105,110,32,116,104,101,32,115,97,109,101,32,101,110,116,105,116,121,10,0,0,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,39,35,70,73,88,69,68,39,10,0,0,65,116,116,114,105,98,117,116,101,32,100,101,102,97,117,108,116,32,118,97,108,117,101,32,100,101,99,108,97,114,97,116,105,111,110,32,101,114,114,111,114,10,0,0,0,0,0,0,78,97,109,101,32,101,120,112,101,99,116,101,100,32,105,110,32,78,79,84,65,84,73,79,78,32,100,101,99,108,97,114,97,116,105,111,110,10,0,0,115,116,97,110,100,97,108,111,110,101,58,32,97,116,116,114,105,98,117,116,101,32,110,111,116,97,116,105,111,110,32,118,97,108,117,101,32,116,111,107,101,110,32,37,115,32,100,117,112,108,105,99,97,116,101,100,10,0,0,0,0,0,0,0,115,116,97,110,100,97,108,111,110,101,58,32,97,116,116,114,105,98,117,116,101,32,101,110,117,109,101,114,97,116,105,111,110,32,118,97,108,117,101,32,116,111,107,101,110,32,37,115,32,100,117,112,108,105,99,97,116,101,100,10,0,0,0,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,39,78,79,84,65,84,73,79,78,39,10,0,0,0,0,0,0,0,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,39,60,33,65,84,84,76,73,83,84,39,10,0,0,0,0,0,0,0,65,84,84,76,73,83,84,58,32,110,111,32,110,97,109,101,32,102,111,114,32,69,108,101,109,101,110,116,10,0,0,0,65,84,84,76,73,83,84,58,32,110,111,32,110,97,109,101,32,102,111,114,32,65,116,116,114,105,98,117,116,101,10,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,110,97,109,101,10,0,0,0,0,0,0,0,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,116,121,112,101,10,0,0,0,0,0,0,0,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,100,101,102,97,117,108,116,32,118,97,108,117,101,10,0,0,0,0,0,0,0,105,110,32,120,109,108,80,97,114,115,101,65,116,116,114,105,98,117,116,101,76,105,115,116,68,101,99,108,10,0,0,0,65,116,116,114,105,98,117,116,101,32,108,105,115,116,32,100,101,99,108,97,114,97,116,105,111,110,32,100,111,101,115,110,39,116,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,32,105,110,32,116,104,101,32,115,97,109,101,32,101,110,116,105,116,121,10,0,0,0,69,108,101,109,101,110,116,32,99,111,110,116,101,110,116,32,100,101,99,108,97,114,97,116,105,111,110,32,100,111,101,115,110,39,116,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,32,105,110,32,116,104,101,32,115,97,109,101,32,101,110,116,105,116,121,10,0,0,120,109,108,80,97,114,115,101,69,108,101,109,101,110,116,77,105,120,101,100,67,111,110,116,101,110,116,68,101,99,108,32,58,32,78,97,109,101,32,101,120,112,101,99,116,101,100,10,0,0,0,0,0,0,0,0,120,109,108,80,97,114,115,101,69,108,101,109,101,110,116,67,111,110,116,101,110,116,68,101,99,108,32,58,32,37,115,32,39,40,39,32,101,120,112,101,99,116,101,100,10,0,0,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,39,69,76,69,77,69,78,84,39,10,0,120,109,108,80,97,114,115,101,69,108,101,109,101,110,116,68,101,99,108,58,32,110,111,32,110,97,109,101,32,102,111,114,32,69,108,101,109,101,110,116,10,0,0,0,0,0,0,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,116,104,101,32,101,108,101,109,101,110,116,32,110,97,109,101,10,0,0,80,69,82,101,102,101,114,101,110,99,101,58,32,102,111,114,98,105,100,100,101,110,32,119,105,116,104,105,110,32,109,97,114,107,117,112,32,100,101,99,108,32,105,110,32,105,110,116,101,114,110,97,108,32,115,117,98,115,101,116,10,0,0,0,120,109,108,80,97,114,115,101,69,108,101,109,101,110,116,68,101,99,108,58,32,39,69,77,80,84,89,39,44,32,39,65,78,89,39,32,111,114,32,39,40,39,32,101,120,112,101,99,116,101,100,10,0,0,0,0,69,108,101,109,101,110,116,32,100,101,99,108,97,114,97,116,105,111,110,32,100,111,101,115,110,39,116,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,32,105,110,32,116,104,101,32,115,97,109,101,32,101,110,116,105,116,121,10,0,0,83,112,97,99,101,32,110,101,101,100,101,100,32,97,102,116,101,114,32,39,60,63,120,109,108,39,10,0,0,0,0,0,49,46,48,0,0,0,0,0,83,112,97,99,101,32,110,101,101,100,101,100,32,104,101,114,101,10,0,0,0,0,0,0,77,105,115,115,105,110,103,32,101,110,99,111,100,105,110,103,32,105,110,32,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,10,0,0,0,35,120,37,88,0,0,0,0,35,37,100,0,0,0,0,0,105,110,118,97,108,105,100,32,101,110,116,105,116,121,32,116,121,112,101,32,102,111,117,110,100,10,0,0,0,0,0,0,69,110,116,105,116,121,32,39,37,115,39,32,102,97,105,108,101,100,32,116,111,32,112,97,114,115,101,10,0,0,0,0,110,98,107,116,101,120,116,0,120,109,108,80,97,114,115,101,69,110,116,105,116,121,82,101,102,58,32,110,111,32,110,97,109,101,10,0,0,0,0,0,69,110,116,105,116,121,32,39,37,115,39,32,110,111,116,32,100,101,102,105,110,101,100,10,0,0,0,0,0,0,0,0,69,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,32,116,111,32,117,110,112,97,114,115,101,100,32,101,110,116,105,116,121,32,37,115,10,0,65,116,116,114,105,98,117,116,101,32,114,101,102,101,114,101,110,99,101,115,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,39,37,115,39,10,0,0,0,0,0,0,39,60,39,32,105,110,32,101,110,116,105,116,121,32,39,37,115,39,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,32,105,110,32,97,116,116,114,105,98,117,116,101,115,32,118,97,108,117,101,115,10,0,65,116,116,101,109,112,116,32,116,111,32,114,101,102,101,114,101,110,99,101,32,116,104,101,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,32,39,37,115,39,10,0,120,109,108,80,97,114,115,101,80,69,82,101,102,101,114,101,110,99,101,58,32,110,111,32,110,97,109,101,10,0,0,0,73,110,116,101,114,110,97,108,58,32,37,37,37,115,59,32,105,115,32,110,111,116,32,97,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,10,0,0,0,0,0,0,120,109,108,80,97,114,115,101,68,111,99,84,121,112,101,68,101,99,108,32,58,32,110,111,32,68,79,67,84,89,80,69,32,110,97,109,101,32,33,10,0,0,0,0,0,0,0,0,101,114,114,111,114,32,112,97,114,115,105,110,103,32,97,116,116,114,105,98,117,116,101,32,110,97,109,101,10,0,0,0,83,112,101,99,105,102,105,99,97,116,105,111,110,32,109,97,110,100,97,116,101,32,118,97,108,117,101,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,37,115,10,0,0,0,120,109,108,58,108,97,110,103,0,0,0,0,0,0,0,0,77,97,108,102,111,114,109,101,100,32,118,97,108,117,101,32,102,111,114,32,120,109,108,58,108,97,110,103,32,58,32,37,115,10,0,0,0,0,0,0,120,109,108,58,115,112,97,99,101,0,0,0,0,0,0,0,100,101,102,97,117,108,116,0,112,114,101,115,101,114,118,101,0,0,0,0,0,0,0,0,73,110,118,97,108,105,100,32,118,97,108,117,101,32,34,37,115,34,32,102,111,114,32,120,109,108,58,115,112,97,99,101,32,58,32,34,100,101,102,97,117,108,116,34,32,111,114,32,34,112,114,101,115,101,114,118,101,34,32,101,120,112,101,99,116,101,100,10,0,0,0,0,120,109,108,80,97,114,115,101,83,116,97,114,116,84,97,103,58,32,105,110,118,97,108,105,100,32,101,108,101,109,101,110,116,32,110,97,109,101,10,0,97,116,116,114,105,98,117,116,101,115,32,99,111,110,115,116,114,117,99,116,32,101,114,114,111,114,10,0,0,0,0,0,120,109,108,80,97,114,115,101,83,116,97,114,116,84,97,103,58,32,112,114,111,98,108,101,109,32,112,97,114,115,105,110,103,32,97,116,116,114,105,98,117,116,101,115,10,0,0,0,67,68,97,116,97,32,115,101,99,116,105,111,110,32,116,111,111,32,98,105,103,32,102,111,117,110,100,0,0,0,0,0,67,68,97,116,97,32,115,101,99,116,105,111,110,32,110,111,116,32,102,105,110,105,115,104,101,100,10,37,46,53,48,115,10,0,0,0,0,0,0,0,100,101,116,101,99,116,101,100,32,97,110,32,101,114,114,111,114,32,105,110,32,101,108,101,109,101,110,116,32,99,111,110,116,101,110,116,10,0,0,0,67,111,117,108,100,110,39,116,32,102,105,110,100,32,101,110,100,32,111,102,32,83,116,97,114,116,32,84,97,103,32,37,115,32,108,105,110,101,32,37,100,10,0,0,0,0,0,0,80,114,101,109,97,116,117,114,101,32,101,110,100,32,111,102,32,100,97,116,97,32,105,110,32,116,97,103,32,37,115,32,108,105,110,101,32,37,100,10,0,0,0,0,0,0,0,0,85,84,70,45,49,54,0,0,85,84,70,49,54,0,0,0,68,111,99,117,109,101,110,116,32,108,97,98,101,108,108,101,100,32,85,84,70,45,49,54,32,98,117,116,32,104,97,115,32,85,84,70,45,56,32,99,111,110,116,101,110,116,10,0,85,84,70,45,56,0,0,0,85,84,70,56,0,0,0,0,85,110,115,117,112,112,111,114,116,101,100,32,101,110,99,111,100,105,110,103,32,37,115,10,0,0,0,0,0,0,0,0,66,108,97,110,107,32,110,101,101,100,101,100,32,97,102,116,101,114,32,39,60,63,120,109,108,39,10,0,0,0,0,0,85,110,115,117,112,112,111,114,116,101,100,32,118,101,114,115,105,111,110,32,39,37,115,39,10,0,0,0,0,0,0,0,66,108,97,110,107,32,110,101,101,100,101,100,32,104,101,114,101,10,0,0,0,0,0,0,83,116,97,114,116,32,116,97,103,32,101,120,112,101,99,116,101,100,44,32,39,60,39,32,110,111,116,32,102,111,117,110,100,10,0,0,0,0,0,0,85,67,83,45,52,0,0,0,85,67,83,52,0,0,0,0,120,109,108,80,97,114,115,101,67,104,117,110,107,58,32,101,110,99,111,100,101,114,32,101,114,114,111,114,10,0,0,0,72,117,103,101,32,105,110,112,117,116,32,108,111,111,107,117,112,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,99,114,101,97,116,105,110,103,32,112,97,114,115,101,114,58,32,111,117,116,32,111,102,32,109,101,109,111,114,121,10,0,110,111,110,101,0,0,0,0,112,115,101,117,100,111,114,111,111,116,0,0,0,0,0,0,86,101,114,115,105,111,110,32,109,105,115,109,97,116,99,104,32,98,101,116,119,101,101,110,32,100,111,99,117,109,101,110,116,32,97,110,100,32,101,110,116,105,116,121,10,0,0,0,120,109,108,0,0,0,0,0,120,109,108,110,115,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,99,97,110,110,111,116,32,97,108,108,111,99,97,116,101,32,112,97,114,115,101,114,32,99,111,110,116,101,120,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,111,117,108,100,110,39,116,32,102,105,110,100,32,101,110,100,32,111,102,32,83,116,97,114,116,32,84,97,103,32,37,115,10,0,0,0,0,0,0,60,33,91,67,68,65,84,65,91,0,0,0,0,0,0,0,80,80,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,116,101,32,61,61,32,67,79,77,77,69,78,84,10,0,0,0,80,80,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,116,101,32,61,61,32,73,71,78,79,82,69,0,0,0,0,0,80,80,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,116,101,32,61,61,32,80,73,10,0,0,0,0,0,0,0,0,80,80,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,116,101,32,61,61,32,69,78,84,73,84,89,95,68,69,67,76,10,0,0,0,0,0,0,0,80,80,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,116,101,32,61,61,32,69,78,84,73,84,89,95,86,65,76,85,69,10,0,0,0,0,0,0,80,80,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,116,101,32,61,61,32,65,84,84,82,73,66,85,84,69,95,86,65,76,85,69,10,0,0,0,80,80,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,116,101,32,61,61,32,83,89,83,84,69,77,95,76,73,84,69,82,65,76,10,0,0,0,0,80,80,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,116,101,32,61,61,32,80,85,66,76,73,67,95,76,73,84,69,82,65,76,10,0,0,0,0,66,121,116,101,115,58,32,48,120,37,48,50,88,32,48,120,37,48,50,88,32,48,120,37,48,50,88,32,48,120,37,48,50,88,10,0,0,0,0,0,73,110,112,117,116,32,105,115,32,110,111,116,32,112,114,111,112,101,114,32,85,84,70,45,56,44,32,105,110,100,105,99,97,116,101,32,101,110,99,111,100,105,110,103,32,33,10,37,115,0,0,0,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,120,109,108,80,97,114,115,101,71,101,116,76,97,115,116,115,10,0,0,0,0,0,0,0,120,109,108,80,97,114,115,101,73,110,116,101,114,110,97,108,83,117,98,115,101,116,58,32,101,114,114,111,114,32,100,101,116,101,99,116,101,100,32,105,110,32,77,97,114,107,117,112,32,100,101,99,108,97,114,97,116,105,111,110,10,0,0,0,117,110,112,97,114,115,101,97,98,108,101,0,0,0,0,0,79,112,101,110,105,110,103,32,97,110,100,32,101,110,100,105,110,103,32,116,97,103,32,109,105,115,109,97,116,99,104,58,32,37,115,32,108,105,110,101,32,37,100,32,97,110,100,32,37,115,10,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,112,97,114,115,101,32,81,78,97,109,101,32,39,37,115,39,10,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,112,97,114,115,101,32,81,78,97,109,101,32,39,37,115,58,39,10,0,0,0,0,70,97,105,108,101,100,32,116,111,32,112,97,114,115,101,32,81,78,97,109,101,32,39,37,115,58,37,115,58,39,10,0,78,67,78,97,109,101,0,0,80,98,109,32,112,111,112,112,105,110,103,32,37,100,32,78,83,10,0,0,0,0,0,0,83,116,97,114,116,84,97,103,58,32,105,110,118,97,108,105,100,32,101,108,101,109,101,110,116,32,110,97,109,101,10,0,100,105,99,116,105,111,110,97,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,117,114,101,0,0,0,120,109,108,110,115,58,32,39,37,115,39,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,85,82,73,10,0,120,109,108,110,115,58,32,85,82,73,32,37,115,32,105,115,32,110,111,116,32,97,98,115,111,108,117,116,101,10,0,0,120,109,108,32,110,97,109,101,115,112,97,99,101,32,85,82,73,32,99,97,110,110,111,116,32,98,101,32,116,104,101,32,100,101,102,97,117,108,116,32,110,97,109,101,115,112,97,99,101,10,0,0,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,48,47,120,109,108,110,115,47,0,0,0,114,101,117,115,101,32,111,102,32,116,104,101,32,120,109,108,110,115,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,32,105,115,32,102,111,114,98,105,100,100,101,110,10,0,120,109,108,32,110,97,109,101,115,112,97,99,101,32,112,114,101,102,105,120,32,109,97,112,112,101,100,32,116,111,32,119,114,111,110,103,32,85,82,73,10,0,0,0,0,0,0,0,120,109,108,32,110,97,109,101,115,112,97,99,101,32,85,82,73,32,109,97,112,112,101,100,32,116,111,32,119,114,111,110,103,32,112,114,101,102,105,120,10,0,0,0,0,0,0,0,114,101,100,101,102,105,110,105,116,105,111,110,32,111,102,32,116,104,101,32,120,109,108,110,115,32,112,114,101,102,105,120,32,105,115,32,102,111,114,98,105,100,100,101,110,10,0,0,120,109,108,110,115,58,37,115,58,32,69,109,112,116,121,32,88,77,76,32,110,97,109,101,115,112,97,99,101,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,10,0,0,0,120,109,108,110,115,58,37,115,58,32,39,37,115,39,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,85,82,73,10,0,0,0,0,0,0,120,109,108,110,115,58,37,115,58,32,85,82,73,32,37,115,32,105,115,32,110,111,116,32,97,98,115,111,108,117,116,101,10,0,0,0,0,0,0,0,115,116,97,110,100,97,108,111,110,101,58,32,97,116,116,114,105,98,117,116,101,32,37,115,32,111,110,32,37,115,32,100,101,102,97,117,108,116,101,100,32,102,114,111,109,32,101,120,116,101,114,110,97,108,32,115,117,98,115,101,116,10,0,0,78,97,109,101,115,112,97,99,101,32,112,114,101,102,105,120,32,37,115,32,102,111,114,32,37,115,32,111,110,32,37,115,32,105,115,32,110,111,116,32,100,101,102,105,110,101,100,10,0,0,0,0,0,0,0,0,78,97,109,101,115,112,97,99,101,100,32,65,116,116,114,105,98,117,116,101,32,37,115,32,105,110,32,39,37,115,39,32,114,101,100,101,102,105,110,101,100,10,0,0,0,0,0,0,78,97,109,101,115,112,97,99,101,32,112,114,101,102,105,120,32,37,115,32,111,110,32,37,115,32,105,115,32,110,111,116,32,100,101,102,105,110,101,100,10,0,0,0,0,0,0,0,108,97,110,103,0,0,0,0,115,112,97,99,101,0,0,0,65,116,116,86,97,108,117,101,32,108,101,110,103,116,104,32,116,111,111,32,108,111,110,103,10,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,105,110,32,97,116,116,114,105,98,117,116,101,32,118,97,108,117,101,10,0,0,0,65,116,116,86,97,108,117,101,58,32,39,32,101,120,112,101,99,116,101,100,10,0,0,0,120,109,108,80,97,114,115,101,69,110,100,84,97,103,58,32,39,60,47,39,32,110,111,116,32,102,111,117,110,100,10,0,65,116,116,114,105,98,117,116,101,32,37,115,32,114,101,100,101,102,105,110,101,100,10,0,65,116,116,114,105,98,117,116,101,32,37,115,58,37,115,32,114,101,100,101,102,105,110,101,100,10,0,0,0,0,0,0,120,109,108,80,97,114,115,101,83,116,114,105,110,103,80,69,82,101,102,101,114,101,110,99,101,58,32,110,111,32,110,97,109,101,10,0,0,0,0,0,37,37,37,115,59,32,105,115,32,110,111,116,32,97,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,10,0,0,0,0,0,0,0,0,120,109,108,76,111,97,100,69,110,116,105,116,121,67,111,110,116,101,110,116,32,112,97,114,97,109,101,116,101,114,32,101,114,114,111,114,0,0,0,0,82,101,97,100,105,110,103,32,37,115,32,101,110,116,105,116,121,32,99,111,110,116,101,110,116,32,105,110,112,117,116,10,0,0,0,0,0,0,0,0,120,109,108,76,111,97,100,69,110,116,105,116,121,67,111,110,116,101,110,116,32,105,110,112,117,116,32,101,114,114,111,114,0,0,0,0,0,0,0,0,120,109,108,76,111,97,100,69,110,116,105,116,121,67,111,110,116,101,110,116,58,32,105,110,118,97,108,105,100,32,99,104,97,114,32,118,97,108,117,101,32,37,100,10,0,0,0,0,120,109,108,80,97,114,115,101,83,116,114,105,110,103,69,110,116,105,116,121,82,101,102,58,32,110,111,32,110,97,109,101,10,0,0,0,0,0,0,0,65,108,108,32,109,97,114,107,117,112,32,111,102,32,116,104,101,32,99,111,110,100,105,116,105,111,110,97,108,32,115,101,99,116,105,111,110,32,105,115,32,110,111,116,32,105,110,32,116,104,101,32,115,97,109,101,32,101,110,116,105,116,121,10,0,0,0,0,0,0,0,0,69,110,116,101,114,105,110,103,32,73,78,67,76,85,68,69,32,67,111,110,100,105,116,105,111,110,97,108,32,83,101,99,116,105,111,110,10,0,0,0,76,101,97,118,105,110,103,32,73,78,67,76,85,68,69,32,67,111,110,100,105,116,105,111,110,97,108,32,83,101,99,116,105,111,110,10,0,0,0,0,69,110,116,101,114,105,110,103,32,73,71,78,79,82,69,32,67,111,110,100,105,116,105,111,110,97,108,32,83,101,99,116,105,111,110,10,0,0,0,0,76,101,97,118,105,110,103,32,73,71,78,79,82,69,32,67,111,110,100,105,116,105,111,110,97,108,32,83,101,99,116,105,111,110,10,0,0,0,0,0,120,109,108,80,97,114,115,101,69,108,101,109,101,110,116,67,104,105,108,100,114,101,110,67,111,110,116,101,110,116,68,101,99,108,32,58,32,100,101,112,116,104,32,37,100,32,116,111,111,32,100,101,101,112,44,32,117,115,101,32,88,77,76,95,80,65,82,83,69,95,72,85,71,69,10,0,0,0,0,0,120,109,108,80,97,114,115,101,69,108,101,109,101,110,116,67,104,105,108,100,114,101,110,67,111,110,116,101,110,116,68,101,99,108,32,58,32,39,37,99,39,32,101,120,112,101,99,116,101,100,10,0,0,0,0,0,101,120,116,101,114,110,97,108,0,0,0,0,0,0,0,0,99,97,116,97,108,111,103,0,67,97,116,97,108,111,103,32,80,73,32,115,121,110,116,97,120,32,101,114,114,111,114,58,32,37,115,10,0,0,0,0,120,109,108,45,115,116,121,108,101,115,104,101,101,116,0,0,120,109,108,45,109,111,100,101,108,0,0,0,0,0,0,0,120,109,108,80,97,114,115,101,67,111,109,109,101,110,116,58,32,105,110,118,97,108,105,100,32,120,109,108,67,104,97,114,32,118,97,108,117,101,32,37,100,10,0,0,0,0,0,0,67,111,109,109,101,110,116,32,110,111,116,32,116,101,114,109,105,110,97,116,101,100,32,10,60,33,45,45,37,46,53,48,115,10,0,0,0,0,0,0,67,111,109,109,101,110,116,32,100,111,101,115,110,39,116,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,32,105,110,32,116,104,101,32,115,97,109,101,32,101,110,116,105,116,121,10,0,0,0,0,0,0,67,111,109,109,101,110,116,32,110,111,116,32,116,101,114,109,105,110,97,116,101,100,10,0,80,67,68,65,84,65,32,105,110,118,97,108,105,100,32,67,104,97,114,32,118,97,108,117,101,32,37,100,10,0,0,0,37,115,0,0,0,0,0,0,120,109,108,80,97,114,115,101,83,116,114,105,110,103,67,104,97,114,82,101,102,58,32,105,110,118,97,108,105,100,32,120,109,108,67,104,97,114,32,118,97,108,117,101,32,37,100,10,0,0,0,0,0,0,0,0,120,109,108,78,101,119,66,108,97,110,107,115,87,114,97,112,112,101,114,73,110,112,117,116,83,116,114,101,97,109,32,101,110,116,105,116,121,10,0,0,110,101,119,32,98,108,97,110,107,115,32,119,114,97,112,112,101,114,32,102,111,114,32,101,110,116,105,116,121,58,32,37,115,10,0,0,0,0,0,0,67,104,97,114,82,101,102,58,32,105,110,118,97,108,105,100,32,104,101,120,97,100,101,99,105,109,97,108,32,118,97,108,117,101,0,0,0,0,0,0,67,104,97,114,82,101,102,58,32,105,110,118,97,108,105,100,32,100,101,99,105,109,97,108,32,118,97,108,117,101,0,0,67,104,97,114,82,101,102,58,32,105,110,118,97,108,105,100,32,118,97,108,117,101,0,0,105,110,116,101,114,110,97,108,32,101,114,114,111,114,0,0,80,69,82,101,102,101,114,101,110,99,101,32,97,116,32,101,110,100,32,111,102,32,100,111,99,117,109,101,110,116,0,0,80,69,82,101,102,101,114,101,110,99,101,32,105,110,32,112,114,111,108,111,103,0,0,0,80,69,82,101,102,101,114,101,110,99,101,32,105,110,32,101,112,105,108,111,103,0,0,0,80,69,82,101,102,101,114,101,110,99,101,58,32,110,111,32,110,97,109,101,0,0,0,0,80,69,82,101,102,101,114,101,110,99,101,58,32,101,120,112,101,99,116,105,110,103,32,39,59,39,0,0,0,0,0,0,68,101,116,101,99,116,101,100,32,97,110,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,32,108,111,111,112,0,0,0,0,0,0,0,69,110,116,105,116,121,86,97,108,117,101,58,32,34,32,111,114,32,39,32,101,120,112,101,99,116,101,100,0,0,0,0,80,69,82,101,102,101,114,101,110,99,101,115,32,102,111,114,98,105,100,100,101,110,32,105,110,32,105,110,116,101,114,110,97,108,32,115,117,98,115,101,116,0,0,0,0,0,0,0,65,116,116,86,97,108,117,101,58,32,34,32,111,114,32,39,32,101,120,112,101,99,116,101,100,0,0,0,0,0,0,0,85,110,101,115,99,97,112,101,100,32,39,60,39,32,110,111,116,32,97,108,108,111,119,101,100,32,105,110,32,97,116,116,114,105,98,117,116,101,115,32,118,97,108,117,101,115,0,0,83,121,115,116,101,109,76,105,116,101,114,97,108,32,34,32,111,114,32,39,32,101,120,112,101,99,116,101,100,0,0,0,85,110,102,105,110,105,115,104,101,100,32,83,121,115,116,101,109,32,111,114,32,80,117,98,108,105,99,32,73,68,32,34,32,111,114,32,39,32,101,120,112,101,99,116,101,100,0,0,83,101,113,117,101,110,99,101,32,39,93,93,62,39,32,110,111,116,32,97,108,108,111,119,101,100,32,105,110,32,99,111,110,116,101,110,116,0,0,0,83,89,83,84,69,77,32,111,114,32,80,85,66,76,73,67,44,32,116,104,101,32,85,82,73,32,105,115,32,109,105,115,115,105,110,103,0,0,0,0,80,85,66,76,73,67,44,32,116,104,101,32,80,117,98,108,105,99,32,73,100,101,110,116,105,102,105,101,114,32,105,115,32,109,105,115,115,105,110,103,0,0,0,0,0,0,0,0,67,111,109,109,101,110,116,32,109,117,115,116,32,110,111,116,32,99,111,110,116,97,105,110,32,39,45,45,39,32,40,100,111,117,98,108,101,45,104,121,112,104,101,110,41,0,0,0,120,109,108,80,97,114,115,101,80,73,32,58,32,110,111,32,116,97,114,103,101,116,32,110,97,109,101,0,0,0,0,0,73,110,118,97,108,105,100,32,80,73,32,110,97,109,101,0,78,79,84,65,84,73,79,78,58,32,78,97,109,101,32,101,120,112,101,99,116,101,100,32,104,101,114,101,0,0,0,0,39,62,39,32,114,101,113,117,105,114,101,100,32,116,111,32,99,108,111,115,101,32,78,79,84,65,84,73,79,78,32,100,101,99,108,97,114,97,116,105,111,110,0,0,0,0,0,0,69,110,116,105,116,121,32,118,97,108,117,101,32,114,101,113,117,105,114,101,100,0,0,0,70,114,97,103,109,101,110,116,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,39,40,39,32,114,101,113,117,105,114,101,100,32,116,111,32,115,116,97,114,116,32,65,84,84,76,73,83,84,32,101,110,117,109,101,114,97,116,105,111,110,0,0,0,0,0,0,0,78,109,84,111,107,101,110,32,101,120,112,101,99,116,101,100,32,105,110,32,65,84,84,76,73,83,84,32,101,110,117,109,101,114,97,116,105,111,110,0,39,41,39,32,114,101,113,117,105,114,101,100,32,116,111,32,102,105,110,105,115,104,32,65,84,84,76,73,83,84,32,101,110,117,109,101,114,97,116,105,111,110,0,0,0,0,0,0,77,105,120,101,100,67,111,110,116,101,110,116,68,101,99,108,32,58,32,39,124,39,32,111,114,32,39,41,42,39,32,101,120,112,101,99,116,101,100,0,77,105,120,101,100,67,111,110,116,101,110,116,68,101,99,108,32,58,32,39,35,80,67,68,65,84,65,39,32,101,120,112,101,99,116,101,100,0,0,0,67,111,110,116,101,110,116,68,101,99,108,32,58,32,78,97,109,101,32,111,114,32,39,40,39,32,101,120,112,101,99,116,101,100,0,0,0,0,0,0,67,111,110,116,101,110,116,68,101,99,108,32,58,32,39,44,39,32,39,124,39,32,111,114,32,39,41,39,32,101,120,112,101,99,116,101,100,0,0,0,80,69,82,101,102,101,114,101,110,99,101,58,32,102,111,114,98,105,100,100,101,110,32,119,105,116,104,105,110,32,109,97,114,107,117,112,32,100,101,99,108,32,105,110,32,105,110,116,101,114,110,97,108,32,115,117,98,115,101,116,0,0,0,0,101,120,112,101,99,116,101,100,32,39,62,39,0,0,0,0,88,77,76,32,99,111,110,100,105,116,105,111,110,97,108,32,115,101,99,116,105,111,110,32,39,91,39,32,101,120,112,101,99,116,101,100,0,0,0,0,67,111,110,116,101,110,116,32,101,114,114,111,114,32,105,110,32,116,104,101,32,101,120,116,101,114,110,97,108,32,115,117,98,115,101,116,0,0,0,0,99,111,110,100,105,116,105,111,110,97,108,32,115,101,99,116,105,111,110,32,73,78,67,76,85,68,69,32,111,114,32,73,71,78,79,82,69,32,107,101,121,119,111,114,100,32,101,120,112,101,99,116,101,100,0,0,88,77,76,32,99,111,110,100,105,116,105,111,110,97,108,32,115,101,99,116,105,111,110,32,110,111,116,32,99,108,111,115,101,100,0,0,0,0,0,0,84,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,39,60,63,120,109,108,39,32,114,101,113,117,105,114,101,100,0,0,0,0,0,0,0,112,97,114,115,105,110,103,32,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,58,32,39,63,62,39,32,101,120,112,101,99,116,101,100,0,0,101,120,116,101,114,110,97,108,32,112,97,114,115,101,100,32,101,110,116,105,116,105,101,115,32,99,97,110,110,111,116,32,98,101,32,115,116,97,110,100,97,108,111,110,101,0,0,0,69,110,116,105,116,121,82,101,102,58,32,101,120,112,101,99,116,105,110,103,32,39,59,39,0,0,0,0,0,0,0,0,68,79,67,84,89,80,69,32,105,109,112,114,111,112,101,114,108,121,32,116,101,114,109,105,110,97,116,101,100],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+64368),
allocate([69,110,100,84,97,103,58,32,39,60,47,39,32,110,111,116,32,102,111,117,110,100,0,0,101,120,112,101,99,116,101,100,32,39,61,39,0,0,0,0,83,116,114,105,110,103,32,110,111,116,32,99,108,111,115,101,100,32,101,120,112,101,99,116,105,110,103,32,34,32,111,114,32,39,0,0,0,0,0,0,83,116,114,105,110,103,32,110,111,116,32,115,116,97,114,116,101,100,32,101,120,112,101,99,116,105,110,103,32,39,32,111,114,32,34,0,0,0,0,0,73,110,118,97,108,105,100,32,88,77,76,32,101,110,99,111,100,105,110,103,32,110,97,109,101,0,0,0,0,0,0,0,115,116,97,110,100,97,108,111,110,101,32,97,99,99,101,112,116,115,32,111,110,108,121,32,39,121,101,115,39,32,111,114,32,39,110,111,39,0,0,0,68,111,99,117,109,101,110,116,32,105,115,32,101,109,112,116,121,0,0,0,0,0,0,0,69,120,116,114,97,32,99,111,110,116,101,110,116,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,100,111,99,117,109,101,110,116,0,0,0,0,0,0,0,0,99,104,117,110,107,32,105,115,32,110,111,116,32,119,101,108,108,32,98,97,108,97,110,99,101,100,0,0,0,0,0,0,101,120,116,114,97,32,99,111,110,116,101,110,116,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,119,101,108,108,32,98,97,108,97,110,99,101,100,32,99,104,117,110,107,0,77,97,108,102,111,114,109,101,100,32,100,101,99,108,97,114,97,116,105,111,110,32,101,120,112,101,99,116,105,110,103,32,118,101,114,115,105,111,110,0,78,97,109,101,32,116,111,111,32,108,111,110,103,32,117,115,101,32,88,77,76,95,80,65,82,83,69,95,72,85,71,69,32,111,112,116,105,111,110,0,85,110,114,101,103,105,115,116,101,114,101,100,32,101,114,114,111,114,32,109,101,115,115,97,103,101,0,0,0,0,0,0,37,115,10,0,0,0,0,0,37,115,58,32,37,37,115,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,116,101,120,116,0,0,0,0,116,101,120,116,110,111,101,110,99,0,0,0,0,0,0,0,99,111,109,109,101,110,116,0,98,117,105,108,100,105,110,103,32,81,78,97,109,101,0,0,81,78,97,109,101,32,115,112,108,105,116,0,0,0,0,0,120,109,108,0,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,98,117,105,108,100,105,110,103,32,110,97,109,101,115,112,97,99,101,0,0,0,0,0,0,98,117,105,108,100,105,110,103,32,68,84,68,0,0,0,0,98,117,105,108,100,105,110,103,32,105,110,116,101,114,110,97,108,32,115,117,98,115,101,116,0,0,0,0,0,0,0,0,49,46,48,0,0,0,0,0,98,117,105,108,100,105,110,103,32,100,111,99,0,0,0,0,0,0,0,0,0,0,0,0,98,117,105,108,100,105,110,103,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,0,98,117,105,108,100,105,110,103,32,80,73,0,0,0,0,0,98,117,105,108,100,105,110,103,32,110,111,100,101,0,0,0,98,117,105,108,100,105,110,103,32,116,101,120,116,0,0,0,98,117,105,108,100,105,110,103,32,99,104,97,114,97,99,116,101,114,32,114,101,102,101,114,101,110,99,101,0,0,0,0,98,117,105,108,100,105,110,103,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,98,117,105,108,100,105,110,103,32,99,111,109,109,101,110,116,0,0,0,0,0,0,0,0,98,117,105,108,100,105,110,103,32,67,68,65,84,65,0,0,103,101,116,116,105,110,103,32,110,111,100,101,32,112,97,116,104,0,0,0,0,0,0,0,63,0,0,0,0,0,0,0,47,0,0,0,0,0,0,0,37,115,58,37,115,0,0,0,42,0,0,0,0,0,0,0,99,111,109,109,101,110,116,40,41,0,0,0,0,0,0,0,116,101,120,116,40,41,0,0,112,114,111,99,101,115,115,105,110,103,45,105,110,115,116,114,117,99,116,105,111,110,40,39,37,115,39,41,0,0,0,0,47,64,0,0,0,0,0,0,37,115,0,0,0,0,0,0,37,115,37,115,37,115,0,0,37,115,37,115,91,37,100,93,37,115,0,0,0,0,0,0,108,97,110,103,0,0,0,0,115,112,97,99,101,0,0,0,100,101,102,97,117,108,116,0,112,114,101,115,101,114,118,101,0,0,0,0,0,0,0,0,98,97,115,101,0,0,0,0,104,116,109,108,0,0,0,0,104,101,97,100,0,0,0,0,104,114,101,102,0,0,0,0,104,116,116,112,58,47,47,0,102,116,112,58,47,47,0,0,117,114,110,58,0,0,0,0,103,101,116,116,105,110,103,32,110,97,109,101,115,112,97,99,101,32,108,105,115,116,0,0,115,101,97,114,99,104,105,110,103,32,110,97,109,101,115,112,97,99,101,0,0,0,0,0,1,0,0,0,0,0,0,0,73,83,79,45,56,56,53,57,45,49,0,0,0,0,0,0,99,114,101,97,116,105,110,103,32,98,117,102,102,101,114,0,103,114,111,119,105,110,103,32,98,117,102,102,101,114,0,0,34,0,0,0,0,0,0,0,38,113,117,111,116,59,0,0,39,0,0,0,0,0,0,0,58,0,0,0,0,0,0,0,37,46,50,48,115,0,0,0,100,101,102,97,117,108,116,37,100,0,0,0,0,0,0,0,37,46,50,48,115,37,100,0,97,108,108,111,99,97,116,105,110,103,32,116,104,101,32,88,77,76,32,110,97,109,101,115,112,97,99,101,0,0,0,0,99,111,112,121,105,110,103,32,110,111,100,101,0,0,0,0,105,110,118,97,108,105,100,32,104,101,120,97,100,101,99,105,109,97,108,32,99,104,97,114,97,99,116,101,114,32,118,97,108,117,101,10,0,0,0,0,105,110,118,97,108,105,100,32,100,101,99,105,109,97,108,32,99,104,97,114,97,99,116,101,114,32,118,97,108,117,101,10,0,0,0,0,0,0,0,0,117,110,116,101,114,109,105,110,97,116,101,100,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,32,37,49,53,115,10,0,0,0,0,0,115,116,114,105,110,103,32,105,115,32,110,111,116,32,105,110,32,85,84,70,45,56,10,0,117,110,101,120,112,101,99,116,101,100,32,101,114,114,111,114,32,110,117,109,98,101,114,10,0,0,0,0,0,0,0,0,152,45,1,0,176,45,1,0,200,45,1,0,240,45,1,0,8,46,1,0,24,46,1,0,40,46,1,0,64,46,1,0,88,46,1,0,120,46,1,0,136,46,1,0,152,46,1,0,168,46,1,0,184,46,1,0,208,46,1,0,240,46,1,0,8,47,1,0,32,47,1,0,48,47,1,0,72,47,1,0,88,47,1,0,128,47,1,0,152,47,1,0,184,47,1,0,200,47,1,0,232,47,1,0,0,48,1,0,24,48,1,0,48,48,1,0,72,48,1,0,104,48,1,0,120,48,1,0,144,48,1,0,160,48,1,0,200,48,1,0,232,48,1,0,0,49,1,0,16,49,1,0,40,49,1,0,64,49,1,0,80,49,1,0,96,49,1,0,120,49,1,0,136,49,1,0,176,49,1,0,192,49,1,0,208,49,1,0,224,49,1,0,240,49,1,0,0,50,1,0,16,50,1,0,32,50,1,0,56,50,1,0,80,50,1,0,104,50,1,0,120,50,1,0,136,50,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,114,101,97,100,40,41,0,102,102,108,117,115,104,40,41,0,0,0,0,0,0,0,0,102,99,108,111,115,101,40,41,0,0,0,0,0,0,0,0,99,114,101,97,116,105,110,103,32,105,110,112,117,116,32,98,117,102,102,101,114,0,0,0,99,114,101,97,116,105,110,103,32,111,117,116,112,117,116,32,98,117,102,102,101,114,0,0,102,105,108,101,0,0,0,0,103,114,111,119,105,110,103,32,105,110,112,117,116,32,98,117,102,102,101,114,0,0,0,0,30,0,0,0,0,0,0,0,98,117,105,108,100,105,110,103,32,99,97,110,111,110,105,99,97,108,32,112,97,116,104,10,0,0,0,0,0,0,0,0,102,116,112,58,47,47,0,0,104,116,116,112,58,47,47,0,78,85,76,76,0,0,0,0,102,97,105,108,101,100,32,116,111,32,108,111,97,100,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,34,37,115,34,10,0,0,0,0,102,105,108,101,58,47,47,108,111,99,97,108,104,111,115,116,47,0,0,0,0,0,0,0,102,105,108,101,58,47,47,47,0,0,0,0,0,0,0,0,119,114,105,116,101,40,41,0,99,108,111,115,101,40,41,0,114,101,97,100,40,41,0,0,102,119,114,105,116,101,40,41,0,0,0,0,0,0,0,0,45,0,0,0,0,0,0,0,119,98,0,0,0,0,0,0,102,105,108,101,58,47,0,0,114,0,0,0,0,0,0,0,85,110,107,110,111,119,110,32,73,79,32,101,114,114,111,114,0,0,0,0,0,0,0,0,80,101,114,109,105,115,115,105,111,110,32,100,101,110,105,101,100,0,0,0,0,0,0,0,82,101,115,111,117,114,99,101,32,116,101,109,112,111,114,97,114,105,108,121,32,117,110,97,118,97,105,108,97,98,108,101,0,0,0,0,0,0,0,0,66,97,100,32,102,105,108,101,32,100,101,115,99,114,105,112,116,111,114,0,0,0,0,0,66,97,100,32,109,101,115,115,97,103,101,0,0,0,0,0,82,101,115,111,117,114,99,101,32,98,117,115,121,0,0,0,79,112,101,114,97,116,105,111,110,32,99,97,110,99,101,108,101,100,0,0,0,0,0,0,78,111,32,99,104,105,108,100,32,112,114,111,99,101,115,115,101,115,0,0,0,0,0,0,82,101,115,111,117,114,99,101,32,100,101,97,100,108,111,99,107,32,97,118,111,105,100,101,100,0,0,0,0,0,0,0,68,111,109,97,105,110,32,101,114,114,111,114,0,0,0,0,70,105,108,101,32,101,120,105,115,116,115,0,0,0,0,0,66,97,100,32,97,100,100,114,101,115,115,0,0,0,0,0,70,105,108,101,32,116,111,111,32,108,97,114,103,101,0,0,79,112,101,114,97,116,105,111,110,32,105,110,32,112,114,111,103,114,101,115,115,0,0,0,73,110,116,101,114,114,117,112,116,101,100,32,102,117,110,99,116,105,111,110,32,99,97,108,108,0,0,0,0,0,0,0,73,110,118,97,108,105,100,32,97,114,103,117,109,101,110,116,0,0,0,0,0,0,0,0,73,110,112,117,116,47,111,117,116,112,117,116,32,101,114,114,111,114,0,0,0,0,0,0,73,115,32,97,32,100,105,114,101,99,116,111,114,121,0,0,84,111,111,32,109,97,110,121,32,111,112,101,110,32,102,105,108,101,115,0,0,0,0,0,84,111,111,32,109,97,110,121,32,108,105,110,107,115,0,0,73,110,97,112,112,114,111,112,114,105,97,116,101,32,109,101,115,115,97,103,101,32,98,117,102,102,101,114,32,108,101,110,103,116,104,0,0,0,0,0,70,105,108,101,110,97,109,101,32,116,111,111,32,108,111,110,103,0,0,0,0,0,0,0,84,111,111,32,109,97,110,121,32,111,112,101,110,32,102,105,108,101,115,32,105,110,32,115,121,115,116,101,109,0,0,0,78,111,32,115,117,99,104,32,100,101,118,105,99,101,0,0,78,111,32,115,117,99,104,32,102,105,108,101,32,111,114,32,100,105,114,101,99,116,111,114,121,0,0,0,0,0,0,0,69,120,101,99,32,102,111,114,109,97,116,32,101,114,114,111,114,0,0,0,0,0,0,0,78,111,32,108,111,99,107,115,32,97,118,97,105,108,97,98,108,101,0,0,0,0,0,0,78,111,116,32,101,110,111,117,103,104,32,115,112,97,99,101,0,0,0,0,0,0,0,0,78,111,32,115,112,97,99,101,32,108,101,102,116,32,111,110,32,100,101,118,105,99,101,0,70,117,110,99,116,105,111,110,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,0,0,0,0,0,0,0,78,111,116,32,97,32,100,105,114,101,99,116,111,114,121,0,68,105,114,101,99,116,111,114,121,32,110,111,116,32,101,109,112,116,121,0,0,0,0,0,78,111,116,32,115,117,112,112,111,114,116,101,100,0,0,0,73,110,97,112,112,114,111,112,114,105,97,116,101,32,73,47,79,32,99,111,110,116,114,111,108,32,111,112,101,114,97,116,105,111,110,0,0,0,0,0,78,111,32,115,117,99,104,32,100,101,118,105,99,101,32,111,114,32,97,100,100,114,101,115,115,0,0,0,0,0,0,0,79,112,101,114,97,116,105,111,110,32,110,111,116,32,112,101,114,109,105,116,116,101,100,0,66,114,111,107,101,110,32,112,105,112,101,0,0,0,0,0,82,101,115,117,108,116,32,116,111,111,32,108,97,114,103,101,0,0,0,0,0,0,0,0,82,101,97,100,45,111,110,108,121,32,102,105,108,101,32,115,121,115,116,101,109,0,0,0,73,110,118,97,108,105,100,32,115,101,101,107,0,0,0,0,78,111,32,115,117,99,104,32,112,114,111,99,101,115,115,0,79,112,101,114,97,116,105,111,110,32,116,105,109,101,100,32,111,117,116,0,0,0,0,0,73,109,112,114,111,112,101,114,32,108,105,110,107,0,0,0,65,116,116,101,109,112,116,32,116,111,32,108,111,97,100,32,110,101,116,119,111,114,107,32,101,110,116,105,116,121,32,37,115,0,0,0,0,0,0,0,101,110,99,111,100,101,114,32,101,114,114,111,114,0,0,0,102,108,117,115,104,32,101,114,114,111,114,0,0,0,0,0,119,114,105,116,101,32,101,114,114,111,114,0,0,0,0,0,110,111,32,105,110,112,117,116,0,0,0,0,0,0,0,0,98,117,102,102,101,114,32,102,117,108,108,0,0,0,0,0,108,111,97,100,105,110,103,32,101,114,114,111,114,0,0,0,110,111,116,32,97,32,115,111,99,107,101,116,0,0,0,0,97,108,114,101,97,100,121,32,99,111,110,110,101,99,116,101,100,0,0,0,0,0,0,0,99,111,110,110,101,99,116,105,111,110,32,114,101,102,117,115,101,100,0,0,0,0,0,0,117,110,114,101,97,99,104,97,98,108,101,32,110,101,116,119,111,114,107,0,0,0,0,0,97,100,100,100,114,101,115,115,32,105,110,32,117,115,101,0,97,108,114,101,97,100,121,32,105,110,32,117,115,101,0,0,117,110,107,110,111,119,110,32,97,100,100,114,101,115,115,32,102,97,109,105,108,108,121,0,120,109,108,77,97,108,108,111,99,66,114,101,97,107,112,111,105,110,116,32,114,101,97,99,104,101,100,32,111,110,32,98,108,111,99,107,32,37,100,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,109,108,77,97,108,108,111,99,76,111,99,32,58,32,79,117,116,32,111,102,32,102,114,101,101,32,115,112,97,99,101,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,112,32,58,32,77,97,108,108,111,99,40,37,108,117,41,32,79,107,10,0,0,0,0,110,111,110,101,0,0,0,0,37,112,32,58,32,82,101,97,108,108,111,99,101,100,40,37,108,117,32,45,62,32,37,108,117,41,32,79,107,10,0,0,116,114,121,105,110,103,32,116,111,32,102,114,101,101,32,112,111,105,110,116,101,114,32,102,114,111,109,32,102,114,101,101,100,32,97,114,101,97,10,0,37,112,32,58,32,70,114,101,101,100,40,41,10,0,0,0,120,109,108,77,101,109,70,114,101,101,40,37,108,88,41,32,101,114,114,111,114,10,0,0,37,112,32,58,32,83,116,114,100,117,112,40,41,32,79,107,10,0,0,0,0,0,0,0,32,32,32,32,32,32,77,69,77,79,82,89,32,65,76,76,79,67,65,84,69,68,32,58,32,37,108,117,44,32,77,65,88,32,119,97,115,32,37,108,117,10,0,0,0,0,0,0,88,77,76,95,77,69,77,95,66,82,69,65,75,80,79,73,78,84,0,0,0,0,0,0,37,117,100,0,0,0,0,0,88,77,76,95,77,69,77,95,84,82,65,67,69,0,0,0,37,112,0,0,0,0,0,0,77,101,109,111,114,121,32,116,97,103,32,101,114,114,111,114,32,111,99,99,117,114,115,32,58,37,112,32,10,9,32,98,121,101,10,0,0,0,0,0,99,114,101,97,116,105,110,103,32,85,82,73,32,115,116,114,117,99,116,117,114,101,10,0,115,97,118,105,110,103,32,85,82,73,10,0,0,0,0,0,58,37,100,0,0,0,0,0,102,105,108,101,0,0,0,0,117,110,101,115,99,97,112,105,110,103,32,85,82,73,32,118,97,108,117,101,10,0,0,0,101,115,99,97,112,105,110,103,32,85,82,73,32,118,97,108,117,101,10,0,0,0,0,0,43,45,46,0,0,0,0,0,58,0,0,0,0,0,0,0,47,63,59,58,64,0,0,0,47,47,0,0,0,0,0,0,59,58,38,61,43,36,44,0,64,0,0,0,0,0,0,0,37,100,0,0,0,0,0,0,58,64,38,61,43,36,44,47,63,59,0,0,0,0,0,0,63,0,0,0,0,0,0,0,59,47,63,58,64,38,61,43,44,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,35,0,0,0,0,0,0,0,114,101,115,111,108,118,105,110,103,32,85,82,73,32,97,103,97,105,110,115,116,32,98,97,115,101,10,0,0,0,0,0,47,0,0,0,0,0,0,0,47,59,38,61,43,36,44,0,98,117,105,108,100,105,110,103,32,114,101,108,97,116,105,118,101,32,85,82,73,10,0,0,58,47,47,0,0,0,0,0,58,47,63,95,46,35,38,59,61,0,0,0,0,0,0,0,114,101,97,99,104,105,110,103,32,97,114,98,105,116,114,97,114,121,32,77,65,88,95,85,82,73,95,76,69,78,71,84,72,32,108,105,109,105,116,10,0,0,0,0,0,0,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,32,58,32,37,115,10,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,10,0,0,0,0,0,0,0,67,97,110,110,111,116,32,99,114,101,97,116,101,32,97,117,116,111,109,97,116,97,32,102,111,114,32,101,108,101,109,101,110,116,32,37,115,10,0,0,67,111,110,116,101,110,116,32,109,111,100,101,108,32,111,102,32,37,115,32,105,115,32,110,111,116,32,100,101,116,101,114,109,105,110,105,115,116,58,32,37,115,10,0,0,0,0,0,109,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,120,109,108,78,101,119,69,108,101,109,101,110,116,67,111,110,116,101,110,116,32,58,32,110,97,109,101,32,61,61,32,78,85,76,76,32,33,10,0,0,120,109,108,78,101,119,69,108,101,109,101,110,116,67,111,110,116,101,110,116,32,58,32,110,97,109,101,32,33,61,32,78,85,76,76,32,33,10,0,0,73,110,116,101,114,110,97,108,58,32,69,76,69,77,69,78,84,32,99,111,110,116,101,110,116,32,99,111,114,114,117,112,116,101,100,32,105,110,118,97,108,105,100,32,116,121,112,101,10,0,0,0,0,0,0,0,32,46,46,46,0,0,0,0,40,0,0,0,0,0,0,0,35,80,67,68,65,84,65,0,58,0,0,0,0,0,0,0,32,44,32,0,0,0,0,0,32,124,32,0,0,0,0,0,41,0,0,0,0,0,0,0,63,0,0,0,0,0,0,0,42,0,0,0,0,0,0,0,43,0,0,0,0,0,0,0,120,109,108,65,100,100,69,108,101,109,101,110,116,68,101,99,108,58,32,99,111,110,116,101,110,116,32,33,61,32,78,85,76,76,32,102,111,114,32,69,77,80,84,89,10,0,0,0,120,109,108,65,100,100,69,108,101,109,101,110,116,68,101,99,108,58,32,99,111,110,116,101,110,116,32,33,61,32,78,85,76,76,32,102,111,114,32,65,78,89,10,0,0,0,0,0,120,109,108,65,100,100,69,108,101,109,101,110,116,68,101,99,108,58,32,99,111,110,116,101,110,116,32,61,61,32,78,85,76,76,32,102,111,114,32,77,73,88,69,68,10,0,0,0,120,109,108,65,100,100,69,108,101,109,101,110,116,68,101,99,108,58,32,99,111,110,116,101,110,116,32,61,61,32,78,85,76,76,32,102,111,114,32,69,76,69,77,69,78,84,10,0,73,110,116,101,114,110,97,108,58,32,69,76,69,77,69,78,84,32,100,101,99,108,32,99,111,114,114,117,112,116,101,100,32,105,110,118,97,108,105,100,32,116,121,112,101,10,0,0,120,109,108,65,100,100,69,108,101,109,101,110,116,68,101,99,108,58,32,84,97,98,108,101,32,99,114,101,97,116,105,111,110,32,102,97,105,108,101,100,33,10,0,0,0,0,0,0,82,101,100,101,102,105,110,105,116,105,111,110,32,111,102,32,101,108,101,109,101,110,116,32,37,115,10,0,0,0,0,0,60,33,69,76,69,77,69,78,84,32,0,0,0,0,0,0,32,69,77,80,84,89,62,10,0,0,0,0,0,0,0,0,32,65,78,89,62,10,0,0,32,0,0,0,0,0,0,0,62,10,0,0,0,0,0,0,73,110,116,101,114,110,97,108,58,32,69,76,69,77,69,78,84,32,115,116,114,117,99,116,32,99,111,114,114,117,112,116,101,100,32,105,110,118,97,108,105,100,32,116,121,112,101,10,0,0,0,0,0,0,0,0,73,110,116,101,114,110,97,108,58,32,65,84,84,82,73,66,85,84,69,32,115,116,114,117,99,116,32,99,111,114,114,117,112,116,101,100,32,105,110,118,97,108,105,100,32,116,121,112,101,10,0,0,0,0,0,0,65,116,116,114,105,98,117,116,101,32,37,115,32,111,102,32,37,115,58,32,105,110,118,97,108,105,100,32,100,101,102,97,117,108,116,32,118,97,108,117,101,10,0,0,0,0,0,0,120,109,108,65,100,100,65,116,116,114,105,98,117,116,101,68,101,99,108,58,32,84,97,98,108,101,32,99,114,101,97,116,105,111,110,32,102,97,105,108,101,100,33,10,0,0,0,0,65,116,116,114,105,98,117,116,101,32,37,115,32,111,102,32,101,108,101,109,101,110,116,32,37,115,58,32,97,108,114,101,97,100,121,32,100,101,102,105,110,101,100,10,0,0,0,0,69,108,101,109,101,110,116,32,37,115,32,104,97,115,32,116,111,111,32,109,97,121,32,73,68,32,97,116,116,114,105,98,117,116,101,115,32,100,101,102,105,110,101,100,32,58,32,37,115,10,0,0,0,0,0,0,120,109,108,110,115,0,0,0,60,33,65,84,84,76,73,83,84,32,0,0,0,0,0,0,32,67,68,65,84,65,0,0,32,73,68,0,0,0,0,0,32,73,68,82,69,70,0,0,32,73,68,82,69,70,83,0,32,69,78,84,73,84,89,0,32,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,32,78,77,84,79,75,69,78,0,0,0,0,0,0,0,0,32,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,32,40,0,0,0,0,0,0,32,78,79,84,65,84,73,79,78,32,40,0,0,0,0,0,32,35,82,69,81,85,73,82,69,68,0,0,0,0,0,0,32,35,73,77,80,76,73,69,68,0,0,0,0,0,0,0,32,35,70,73,88,69,68,0,73,110,116,101,114,110,97,108,58,32,65,84,84,82,73,66,85,84,69,32,115,116,114,117,99,116,32,99,111,114,114,117,112,116,101,100,32,105,110,118,97,108,105,100,32,100,101,102,10,0,0,0,0,0,0,0,120,109,108,65,100,100,78,111,116,97,116,105,111,110,68,101,99,108,58,32,84,97,98,108,101,32,99,114,101,97,116,105,111,110,32,102,97,105,108,101,100,33,10,0,0,0,0,0,120,109,108,65,100,100,78,111,116,97,116,105,111,110,68,101,99,108,58,32,37,115,32,97,108,114,101,97,100,121,32,100,101,102,105,110,101,100,10,0,60,33,78,79,84,65,84,73,79,78,32,0,0,0,0,0,32,80,85,66,76,73,67,32,0,0,0,0,0,0,0,0,32,83,89,83,84,69,77,32,0,0,0,0,0,0,0,0,32,62,10,0,0,0,0,0,120,109,108,65,100,100,73,68,58,32,84,97,98,108,101,32,99,114,101,97,116,105,111,110,32,102,97,105,108,101,100,33,10,0,0,0,0,0,0,0,73,68,32,37,115,32,97,108,114,101,97,100,121,32,100,101,102,105,110,101,100,10,0,0,105,100,0,0,0,0,0,0,120,109,108,0,0,0,0,0,110,97,109,101,0,0,0,0,97,0,0,0,0,0,0,0,120,109,108,65,100,100,82,101,102,58,32,84,97,98,108,101,32,99,114,101,97,116,105,111,110,32,102,97,105,108,101,100,33,10,0,0,0,0,0,0,120,109,108,65,100,100,82,101,102,58,32,82,101,102,101,114,101,110,99,101,32,108,105,115,116,32,99,114,101,97,116,105,111,110,32,102,97,105,108,101,100,33,10,0,0,0,0,0,120,109,108,65,100,100,82,101,102,58,32,82,101,102,101,114,101,110,99,101,32,108,105,115,116,32,105,110,115,101,114,116,105,111,110,32,102,97,105,108,101,100,33,10,0,0,0,0,78,79,84,65,84,73,79,78,32,37,115,32,105,115,32,110,111,116,32,100,101,99,108,97,114,101,100,10,0,0,0,0,115,116,97,110,100,97,108,111,110,101,58,32,37,115,32,111,110,32,37,115,32,118,97,108,117,101,32,104,97,100,32,116,111,32,98,101,32,110,111,114,109,97,108,105,122,101,100,32,98,97,115,101,100,32,111,110,32,101,120,116,101,114,110,97,108,32,115,117,98,115,101,116,32,100,101,99,108,97,114,97,116,105,111,110,10,0,0,0,83,121,110,116,97,120,32,111,102,32,100,101,102,97,117,108,116,32,118,97,108,117,101,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,37,115,32,111,102,32,37,115,32,105,115,32,110,111,116,32,118,97,108,105,100,10,0,0,0,0,73,68,32,97,116,116,114,105,98,117,116,101,32,37,115,32,111,102,32,37,115,32,105,115,32,110,111,116,32,118,97,108,105,100,32,109,117,115,116,32,98,101,32,35,73,77,80,76,73,69,68,32,111,114,32,35,82,69,81,85,73,82,69,68,10,0,0,0,0,0,0,0,69,108,101,109,101,110,116,32,37,115,32,104,97,115,32,37,100,32,73,68,32,97,116,116,114,105,98,117,116,101,32,100,101,102,105,110,101,100,32,105,110,32,116,104,101,32,105,110,116,101,114,110,97,108,32,115,117,98,115,101,116,32,58,32,37,115,10,0,0,0,0,0,69,108,101,109,101,110,116,32,37,115,32,104,97,115,32,37,100,32,73,68,32,97,116,116,114,105,98,117,116,101,32,100,101,102,105,110,101,100,32,105,110,32,116,104,101,32,101,120,116,101,114,110,97,108,32,115,117,98,115,101,116,32,58,32,37,115,10,0,0,0,0,0,69,108,101,109,101,110,116,32,37,115,32,104,97,115,32,73,68,32,97,116,116,114,105,98,117,116,101,115,32,100,101,102,105,110,101,100,32,105,110,32,116,104,101,32,105,110,116,101,114,110,97,108,32,97,110,100,32,101,120,116,101,114,110,97,108,32,115,117,98,115,101,116,32,58,32,37,115,10,0,0,68,101,102,97,117,108,116,32,118,97,108,117,101,32,34,37,115,34,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,37,115,32,111,102,32,37,115,32,105,115,32,110,111,116,32,97,109,111,110,103,32,116,104,101,32,101,110,117,109,101,114,97,116,101,100,32,115,101,116,10,0,0,0,0,0,0,68,101,102,105,110,105,116,105,111,110,32,111,102,32,37,115,32,104,97,115,32,100,117,112,108,105,99,97,116,101,32,114,101,102,101,114,101,110,99,101,115,32,111,102,32,37,115,10,0,0,0,0,0,0,0,0,68,101,102,105,110,105,116,105,111,110,32,111,102,32,37,115,32,104,97,115,32,100,117,112,108,105,99,97,116,101,32,114,101,102,101,114,101,110,99,101,115,32,111,102,32,37,115,58,37,115,10,0,0,0,0,0,68,101,102,105,110,105,116,105,111,110,32,111,102,32,37,115,32,104,97,115,32,100,117,112,108,105,99,97,116,101,32,114,101,102,101,114,101,110,99,101,115,32,116,111,32,37,115,10,0,0,0,0,0,0,0,0,68,101,102,105,110,105,116,105,111,110,32,111,102,32,37,115,32,104,97,115,32,100,117,112,108,105,99,97,116,101,32,114,101,102,101,114,101,110,99,101,115,32,116,111,32,37,115,58,37,115,10,0,0,0,0,0,78,111,32,100,101,99,108,97,114,97,116,105,111,110,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,37,115,32,111,102,32,101,108,101,109,101,110,116,32,37,115,10,0,0,83,121,110,116,97,120,32,111,102,32,118,97,108,117,101,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,37,115,32,111,102,32,37,115,32,105,115,32,110,111,116,32,118,97,108,105,100,10,0,0,0,0,86,97,108,117,101,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,37,115,32,111,102,32,37,115,32,105,115,32,100,105,102,102,101,114,101,110,116,32,102,114,111,109,32,100,101,102,97,117,108,116,32,34,37,115,34,10,0,0,0,0,86,97,108,117,101,32,34,37,115,34,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,37,115,32,111,102,32,37,115,32,105,115,32,110,111,116,32,97,32,100,101,99,108,97,114,101,100,32,78,111,116,97,116,105,111,110,10,0,0,0,86,97,108,117,101,32,34,37,115,34,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,37,115,32,111,102,32,37,115,32,105,115,32,110,111,116,32,97,109,111,110,103,32,116,104,101,32,101,110,117,109,101,114,97,116,101,100,32,110,111,116,97,116,105,111,110,115,10,0,0,0,0,0,0,0,0,86,97,108,117,101,32,34,37,115,34,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,37,115,32,111,102,32,37,115,32,105,115,32,110,111,116,32,97,109,111,110,103,32,116,104,101,32,101,110,117,109,101,114,97,116,101,100,32,115,101,116,10,0,0,0,0,0,0,86,97,108,117,101,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,37,115,32,111,102,32,37,115,32,109,117,115,116,32,98,101,32,34,37,115,34,10,0,0,0,0,0,0,86,97,108,105,100,97,116,105,110,103,32,110,97,109,101,115,112,97,99,101,0,0,0,0,78,111,32,100,101,99,108,97,114,97,116,105,111,110,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,120,109,108,110,115,58,37,115,32,111,102,32,101,108,101,109,101,110,116,32,37,115,10,0,0,0,0,78,111,32,100,101,99,108,97,114,97,116,105,111,110,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,120,109,108,110,115,32,111,102,32,101,108,101,109,101,110,116,32,37,115,10,0,0,0,0,0,0,0,83,121,110,116,97,120,32,111,102,32,118,97,108,117,101,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,120,109,108,110,115,58,37,115,32,111,102,32,37,115,32,105,115,32,110,111,116,32,118,97,108,105,100,10,0,0,0,0,0,0,83,121,110,116,97,120,32,111,102,32,118,97,108,117,101,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,120,109,108,110,115,32,111,102,32,37,115,32,105,115,32,110,111,116,32,118,97,108,105,100,10,0,86,97,108,117,101,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,120,109,108,110,115,58,37,115,32,111,102,32,37,115,32,105,115,32,100,105,102,102,101,114,101,110,116,32,102,114,111,109,32,100,101,102,97,117,108,116,32,34,37,115,34,10,0,0,0,0,0,0,86,97,108,117,101,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,120,109,108,110,115,32,111,102,32,37,115,32,105,115,32,100,105,102,102,101,114,101,110,116,32,102,114,111,109,32,100,101,102,97,117,108,116,32,34,37,115,34,10,0,86,97,108,117,101,32,34,37,115,34,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,120,109,108,110,115,58,37,115,32,111,102,32,37,115,32,105,115,32,110,111,116,32,97,32,100,101,99,108,97,114,101,100,32,78,111,116,97,116,105,111,110,10,0,0,0,0,0,86,97,108,117,101,32,34,37,115,34,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,120,109,108,110,115,32,111,102,32,37,115,32,105,115,32,110,111,116,32,97,32,100,101,99,108,97,114,101,100,32,78,111,116,97,116,105,111,110,10,0,0,0,0,0,0,0,0,86,97,108,117,101,32,34,37,115,34,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,120,109,108,110,115,58,37,115,32,111,102,32,37,115,32,105,115,32,110,111,116,32,97,109,111,110,103,32,116,104,101,32,101,110,117,109,101,114,97,116,101,100,32,110,111,116,97,116,105,111,110,115,10,0,0,86,97,108,117,101,32,34,37,115,34,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,120,109,108,110,115,32,111,102,32,37,115,32,105,115,32,110,111,116,32,97,109,111,110,103,32,116,104,101,32,101,110,117,109,101,114,97,116,101,100,32,110,111,116,97,116,105,111,110,115,10,0,0,0,0,0,86,97,108,117,101,32,34,37,115,34,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,120,109,108,110,115,58,37,115,32,111,102,32,37,115,32,105,115,32,110,111,116,32,97,109,111,110,103,32,116,104,101,32,101,110,117,109,101,114,97,116,101,100,32,115,101,116,10,0,0,0,0,0,0,0,0,86,97,108,117,101,32,34,37,115,34,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,120,109,108,110,115,32,111,102,32,37,115,32,105,115,32,110,111,116,32,97,109,111,110,103,32,116,104,101,32,101,110,117,109,101,114,97,116,101,100,32,115,101,116,10,0,0,0,86,97,108,117,101,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,120,109,108,110,115,58,37,115,32,111,102,32,37,115,32,109,117,115,116,32,98,101,32,34,37,115,34,10,0,0,0,0,0,0,0,0,86,97,108,117,101,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,120,109,108,110,115,32,111,102,32,37,115,32,109,117,115,116,32,98,101,32,34,37,115,34,10,0,0,0,69,108,101,109,101,110,116,32,37,115,32,119,97,115,32,100,101,99,108,97,114,101,100,32,69,77,80,84,89,32,116,104,105,115,32,111,110,101,32,104,97,115,32,99,111,110,116,101,110,116,10,0,0,0,0,0,69,108,101,109,101,110,116,32,37,115,32,119,97,115,32,100,101,99,108,97,114,101,100,32,35,80,67,68,65,84,65,32,98,117,116,32,99,111,110,116,97,105,110,115,32,110,111,110,32,116,101,120,116,32,110,111,100,101,115,10,0,0,0,0,69,108,101,109,101,110,116,32,37,115,32,105,115,32,110,111,116,32,100,101,99,108,97,114,101,100,32,105,110,32,37,115,32,108,105,115,116,32,111,102,32,112,111,115,115,105,98,108,101,32,99,104,105,108,100,114,101,110,10,0,0,0,0,0,69,108,101,109,101,110,116,32,37,115,32,99,111,110,116,101,110,116,32,100,111,101,115,32,110,111,116,32,102,111,108,108,111,119,32,116,104,101,32,68,84,68,44,32,77,105,115,112,108,97,99,101,100,32,37,115,10,0,0,0,0,0,0,0,69,108,101,109,101,110,116,32,37,115,32,99,111,110,116,101,110,116,32,100,111,101,115,32,110,111,116,32,102,111,108,108,111,119,32,116,104,101,32,68,84,68,44,32,84,101,120,116,32,110,111,116,32,97,108,108,111,119,101,100,10,0,0,0,69,108,101,109,101,110,116,32,37,115,32,99,111,110,116,101,110,116,32,100,111,101,115,32,110,111,116,32,102,111,108,108,111,119,32,116,104,101,32,68,84,68,44,32,69,120,112,101,99,116,105,110,103,32,109,111,114,101,32,99,104,105,108,100,10,0,0,0,0,0,0,0,65,116,116,114,105,98,117,116,101,32,101,108,101,109,101,110,116,32,110,111,116,32,101,120,112,101,99,116,101,100,10,0,84,101,120,116,32,101,108,101,109,101,110,116,32,104,97,115,32,99,104,105,108,100,114,101,110,32,33,10,0,0,0,0,84,101,120,116,32,101,108,101,109,101,110,116,32,104,97,115,32,110,97,109,101,115,112,97,99,101,32,33,10,0,0,0,84,101,120,116,32,101,108,101,109,101,110,116,32,104,97,115,32,110,111,32,99,111,110,116,101,110,116,32,33,10,0,0,69,110,116,105,116,121,32,101,108,101,109,101,110,116,32,110,111,116,32,101,120,112,101,99,116,101,100,10,0,0,0,0,78,111,116,97,116,105,111,110,32,101,108,101,109,101,110,116,32,110,111,116,32,101,120,112,101,99,116,101,100,10,0,0,68,111,99,117,109,101,110,116,32,101,108,101,109,101,110,116,32,110,111,116,32,101,120,112,101,99,116,101,100,10,0,0,72,84,77,76,32,68,111,99,117,109,101,110,116,32,110,111,116,32,101,120,112,101,99,116,101,100,10,0,0,0,0,0,117,110,107,110,111,119,110,32,101,108,101,109,101,110,116,32,116,121,112,101,10,0,0,0,78,111,32,100,101,99,108,97,114,97,116,105,111,110,32,102,111,114,32,101,108,101,109,101,110,116,32,37,115,10,0,0,73,110,116,101,114,110,97,108,58,32,77,73,88,69,68,32,115,116,114,117,99,116,32,99,111,114,114,117,112,116,101,100,10,0,0,0,0,0,0,0,115,116,97,110,100,97,108,111,110,101,58,32,37,115,32,100,101,99,108,97,114,101,100,32,105,110,32,116,104,101,32,101,120,116,101,114,110,97,108,32,115,117,98,115,101,116,32,99,111,110,116,97,105,110,115,32,119,104,105,116,101,32,115,112,97,99,101,115,32,110,111,100,101,115,10,0,0,0,0,0,69,108,101,109,101,110,116,32,37,115,32,100,111,101,115,32,110,111,116,32,99,97,114,114,121,32,97,116,116,114,105,98,117,116,101,32,37,115,10,0,69,108,101,109,101,110,116,32,37,115,32,100,111,101,115,32,110,111,116,32,99,97,114,114,121,32,97,116,116,114,105,98,117,116,101,32,37,115,58,37,115,10,0,0,0,0,0,0,69,108,101,109,101,110,116,32,37,115,32,114,101,113,117,105,114,101,100,32,97,116,116,114,105,98,117,116,101,32,37,115,58,37,115,32,104,97,115,32,110,111,32,112,114,101,102,105,120,10,0,0,0,0,0,0,69,108,101,109,101,110,116,32,37,115,32,114,101,113,117,105,114,101,100,32,97,116,116,114,105,98,117,116,101,32,37,115,58,37,115,32,104,97,115,32,100,105,102,102,101,114,101,110,116,32,112,114,101,102,105,120,10,0,0,0,0,0,0,0,69,108,101,109,101,110,116,32,37,115,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,32,102,111,114,32,100,101,102,97,117,108,116,32,110,97,109,101,115,112,97,99,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,68,84,68,10,0,69,108,101,109,101,110,116,32,37,115,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,32,102,111,114,32,37,115,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,68,84,68,10,0,0,0,0,0,0,0,0,110,111,32,114,111,111,116,32,101,108,101,109,101,110,116,10,0,0,0,0,0,0,0,0,72,84,77,76,0,0,0,0,104,116,109,108,0,0,0,0,114,111,111,116,32,97,110,100,32,68,84,68,32,110,97,109,101,32,100,111,32,110,111,116,32,109,97,116,99,104,32,39,37,115,39,32,97,110,100,32,39,37,115,39,10,0,0,0,120,109,108,86,97,108,105,100,97,116,101,68,111,99,117,109,101,110,116,70,105,110,97,108,58,32,100,111,99,32,61,61,32,78,85,76,76,10,0,0,110,111,32,68,84,68,32,102,111,117,110,100,33,10,0,0,67,111,117,108,100,32,110,111,116,32,98,117,105,108,100,32,85,82,73,32,102,111,114,32,101,120,116,101,114,110,97,108,32,115,117,98,115,101,116,32,34,37,115,34,10,0,0,0,67,111,117,108,100,32,110,111,116,32,108,111,97,100,32,116,104,101,32,101,120,116,101,114,110,97,108,32,115,117,98,115,101,116,32,34,37,115,34,10,0,0,0,0,0,0,0,0,60,33,100,117,109,109,121,63,62,0,0,0,0,0,0,0,120,109,108,86,97,108,105,100,97,116,101,65,116,116,114,105,98,117,116,101,67,97,108,108,98,97,99,107,40,37,115,41,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,10,0,0,0,0,0,0,0,97,116,116,114,105,98,117,116,101,32,37,115,58,32,99,111,117,108,100,32,110,111,116,32,102,105,110,100,32,100,101,99,108,32,102,111,114,32,101,108,101,109,101,110,116,32,37,115,10,0,0,0,0,0,0,0,78,79,84,65,84,73,79,78,32,97,116,116,114,105,98,117,116,101,32,37,115,32,100,101,99,108,97,114,101,100,32,102,111,114,32,69,77,80,84,89,32,101,108,101,109,101,110,116,32,37,115,10,0,0,0,0,97,116,116,114,105,98,117,116,101,32,37,115,32,108,105,110,101,32,37,100,32,114,101,102,101,114,101,110,99,101,115,32,97,110,32,117,110,107,110,111,119,110,32,73,68,32,34,37,115,34,10,0,0,0,0,0,73,68,82,69,70,32,97,116,116,114,105,98,117,116,101,32,37,115,32,114,101,102,101,114,101,110,99,101,115,32,97,110,32,117,110,107,110,111,119,110,32,73,68,32,34,37,115,34],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+74608),
allocate([10,0,0,0,0,0,0,0,73,68,82,69,70,83,32,115,112,108,105,116,0,0,0,0,73,68,82,69,70,83,32,97,116,116,114,105,98,117,116,101,32,37,115,32,114,101,102,101,114,101,110,99,101,115,32,97,110,32,117,110,107,110,111,119,110,32,73,68,32,34,37,115,34,10,0,0,0,0,0,0,69,108,101,109,101,110,116,32,37,115,32,99,111,110,116,101,110,116,32,100,111,101,115,32,110,111,116,32,102,111,108,108,111,119,32,116,104,101,32,68,84,68,44,32,101,120,112,101,99,116,105,110,103,32,37,115,44,32,103,111,116,32,37,115,10,0,0,0,0,0,0,0,69,108,101,109,101,110,116,32,99,111,110,116,101,110,116,32,100,111,101,115,32,110,111,116,32,102,111,108,108,111,119,32,116,104,101,32,68,84,68,44,32,101,120,112,101,99,116,105,110,103,32,37,115,44,32,103,111,116,32,37,115,10,0,0,69,108,101,109,101,110,116,32,37,115,32,99,111,110,116,101,110,116,32,100,111,101,115,32,110,111,116,32,102,111,108,108,111,119,32,116,104,101,32,68,84,68,10,0,0,0,0,0,69,108,101,109,101,110,116,32,99,111,110,116,101,110,116,32,100,111,101,115,32,110,111,116,32,102,111,108,108,111,119,32,116,104,101,32,68,84,68,10,0,0,0,0,0,0,0,0,67,68,65,84,65,0,0,0,63,63,63,0,0,0,0,0,114,101,97,108,108,111,99,32,102,97,105,108,101,100,0,0,70,97,105,108,101,100,32,116,111,32,98,117,105,108,100,32,99,111,110,116,101,110,116,32,109,111,100,101,108,32,114,101,103,101,120,112,32,102,111,114,32,37,115,10,0,0,0,0,69,78,84,73,84,89,32,97,116,116,114,105,98,117,116,101,32,37,115,32,114,101,102,101,114,101,110,99,101,32,97,110,32,117,110,107,110,111,119,110,32,101,110,116,105,116,121,32,34,37,115,34,10,0,0,0,69,78,84,73,84,89,32,97,116,116,114,105,98,117,116,101,32,37,115,32,114,101,102,101,114,101,110,99,101,32,97,110,32,101,110,116,105,116,121,32,34,37,115,34,32,111,102,32,119,114,111,110,103,32,116,121,112,101,10,0,0,0,0,0,69,78,84,73,84,73,69,83,32,97,116,116,114,105,98,117,116,101,32,37,115,32,114,101,102,101,114,101,110,99,101,32,97,110,32,117,110,107,110,111,119,110,32,101,110,116,105,116,121,32,34,37,115,34,10,0,69,78,84,73,84,73,69,83,32,97,116,116,114,105,98,117,116,101,32,37,115,32,114,101,102,101,114,101,110,99,101,32,97,110,32,101,110,116,105,116,121,32,34,37,115,34,32,111,102,32,119,114,111,110,103,32,116,121,112,101,10,0,0,0,78,79,84,65,84,73,79,78,32,97,116,116,114,105,98,117,116,101,32,37,115,32,114,101,102,101,114,101,110,99,101,32,97,110,32,117,110,107,110,111,119,110,32,110,111,116,97,116,105,111,110,32,34,37,115,34,10,0,0,0,0,0,0,0,101,108,101,109,101,110,116,32,116,97,98,108,101,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,0,69,108,101,109,101,110,116,32,37,115,32,104,97,115,32,116,111,111,32,109,97,110,121,32,73,68,32,97,116,116,114,105,98,117,116,101,115,32,100,101,102,105,110,101,100,32,58,32,37,115,10,0,0,0,0,0,37,115,0,0,0,0,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,32,58,32,37,115,10,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,10,0,0,0,0,0,0,0,70,111,117,110,100,32,78,85,76,76,32,99,111,110,116,101,110,116,32,105,110,32,99,111,110,116,101,110,116,32,109,111,100,101,108,32,111,102,32,37,115,10,0,0,0,0,0,0,70,111,117,110,100,32,80,67,68,65,84,65,32,105,110,32,99,111,110,116,101,110,116,32,109,111,100,101,108,32,111,102,32,37,115,10,0,0,0,0,66,117,105,108,100,105,110,103,32,99,111,110,116,101,110,116,32,109,111,100,101,108,0,0,67,111,110,116,101,110,116,77,111,100,101,108,32,98,114,111,107,101,110,32,102,111,114,32,101,108,101,109,101,110,116,32,37,115,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,121,1,0,200,121,1,0,176,119,1,0,136,197,1,0,208,121,1,0,216,121,1,0,224,121,1,0,232,121,1,0,240,121,1,0,248,121,1,0,208,192,1,0,24,212,1,0,112,205,1,0,240,201,1,0,216,191,1,0,56,121,1,0,80,122,1,0,40,216,1,0,48,216,1,0,168,117,1,0,0,0,0,0,168,117,1,0,176,119,1,0,0,0,0,0,216,119,1,0,176,119,1,0,0,0,0,0,160,117,1,0,168,117,1,0,24,115,1,0,208,119,1,0,216,119,1,0,176,119,1,0,0,0,0,0,0,120,1,0,168,117,1,0,24,115,1,0,208,119,1,0,216,119,1,0,176,119,1,0,0,0,0,0,48,122,1,0,176,119,1,0,208,121,1,0,216,121,1,0,224,121,1,0,232,121,1,0,240,121,1,0,248,121,1,0,208,192,1,0,56,121,1,0,80,122,1,0,40,216,1,0,48,216,1,0,168,117,1,0,48,122,1,0,0,0,0,0,136,197,1,0,176,119,1,0,168,117,1,0,0,0,0,0,208,121,1,0,176,119,1,0,168,117,1,0,0,0,0,0,216,121,1,0,176,119,1,0,168,117,1,0,0,0,0,0,224,121,1,0,176,119,1,0,168,117,1,0,0,0,0,0,232,121,1,0,176,119,1,0,168,117,1,0,0,0,0,0,240,121,1,0,176,119,1,0,168,117,1,0,0,0,0,0,248,121,1,0,176,119,1,0,168,117,1,0,0,0,0,0,216,191,1,0,176,119,1,0,168,117,1,0,0,0,0,0,56,121,1,0,176,119,1,0,168,117,1,0,24,212,1,0,0,0,0,0,80,122,1,0,176,119,1,0,168,117,1,0,24,212,1,0,0,0,0,0,40,216,1,0,176,119,1,0,168,117,1,0,0,0,0,0,48,216,1,0,176,119,1,0,168,117,1,0,0,0,0,0,96,121,1,0,176,119,1,0,168,117,1,0,0,0,0,0,208,192,1,0,176,119,1,0,176,121,1,0,240,201,1,0,216,191,1,0,56,121,1,0,80,122,1,0,40,216,1,0,48,216,1,0,168,117,1,0,0,0,0,0,176,121,1,0,176,119,1,0,240,201,1,0,216,191,1,0,56,121,1,0,80,122,1,0,40,216,1,0,48,216,1,0,168,117,1,0,152,121,1,0,0,0,0,0,152,121,1,0,176,119,1,0,240,201,1,0,216,191,1,0,56,121,1,0,80,122,1,0,40,216,1,0,48,216,1,0,168,117,1,0,176,121,1,0,0,0,0,0,24,212,1,0,176,119,1,0,168,117,1,0,112,205,1,0,240,201,1,0,216,191,1,0,56,121,1,0,80,122,1,0,40,216,1,0,48,216,1,0,0,0,0,0,112,205,1,0,176,119,1,0,168,117,1,0,24,212,1,0,0,0,0,0,240,201,1,0,176,119,1,0,168,117,1,0,24,212,1,0,0,0,0,0,176,119,1,0,176,119,1,0,168,117,1,0,208,121,1,0,216,121,1,0,224,121,1,0,232,121,1,0,240,121,1,0,248,121,1,0,144,122,1,0,0,122,1,0,72,121,1,0,152,122,1,0,96,122,1,0,128,122,1,0,88,121,1,0,112,122,1,0,0,0,0,0,96,118,1,0,176,119,1,0,168,117,1,0,0,0,0,0,56,122,1,0,176,119,1,0,0,0,0,0,128,121,1,0,192,121,1,0,72,121,1,0,0,122,1,0,176,119,1,0,168,117,1,0,0,0,0,0,32,121,1,0,32,121,1,0,168,117,1,0,0,0,0,0,120,121,1,0,176,119,1,0,0,0,0,0,32,191,1,0,120,121,1,0,32,191,1,0,176,190,1,0,176,119,1,0,0,0,0,0,176,190,1,0,120,121,1,0,176,190,1,0,176,119,1,0,0,0,0,0,152,118,1,0,176,119,1,0,168,117,1,0,208,121,1,0,216,121,1,0,224,121,1,0,232,121,1,0,240,121,1,0,248,121,1,0,80,122,1,0,40,216,1,0,48,216,1,0,32,121,1,0,0,0,0,0,112,118,1,0,112,118,1,0,104,118,1,0,176,119,1,0,120,122,1,0,192,121,1,0,32,121,1,0,72,121,1,0,0,122,1,0,152,122,1,0,0,0,0,0,104,118,1,0,112,118,1,0,104,118,1,0,176,119,1,0,120,122,1,0,192,121,1,0,32,121,1,0,72,121,1,0,0,122,1,0,152,122,1,0,0,0,0,0,120,118,1,0,112,118,1,0,104,118,1,0,120,118,1,0,120,121,1,0,176,190,1,0,32,191,1,0,176,119,1,0,0,0,0,0,128,118,1,0,120,121,1,0,176,190,1,0,32,191,1,0,0,0,0,0,144,118,1,0,112,118,1,0,104,118,1,0,120,118,1,0,120,121,1,0,176,190,1,0,32,191,1,0,128,118,1,0,136,118,1,0,176,119,1,0,0,0,0,0,136,118,1,0,112,118,1,0,104,118,1,0,120,118,1,0,120,121,1,0,176,190,1,0,32,191,1,0,128,118,1,0,144,118,1,0,136,118,1,0,176,119,1,0,0,0,0,0,160,205,1,0,200,205,1,0,0,0,0,0,200,205,1,0,200,205,1,0,0,0,0,0,184,193,1,0,40,122,1,0,176,119,1,0,168,117,1,0,208,121,1,0,216,121,1,0,224,121,1,0,232,121,1,0,240,121,1,0,248,121,1,0,80,122,1,0,40,216,1,0,48,216,1,0,32,121,1,0,0,0,0,0,144,122,1,0,168,117,1,0,0,0,0,0,0,122,1,0,168,117,1,0,0,0,0,0,72,121,1,0,168,117,1,0,0,0,0,0,152,122,1,0,168,117,1,0,0,0,0,0,96,122,1,0,168,117,1,0,0,0,0,0,128,122,1,0,168,117,1,0,0,0,0,0,88,121,1,0,168,117,1,0,0,0,0,0,112,122,1,0,168,117,1,0,0,0,0,0,184,121,1,0,168,117,1,0,0,0,0,0,136,122,1,0,168,117,1,0,0,0,0,0,168,121,1,0,168,117,1,0,0,0,0,0,144,121,1,0,168,117,1,0,0,0,0,0,104,122,1,0,168,117,1,0,0,0,0,0,24,122,1,0,168,117,1,0,0,0,0,0,160,122,1,0,168,117,1,0,0,0,0,0,136,121,1,0,168,117,1,0,0,0,0,0,40,121,1,0,168,117,1,0,0,0,0,0,48,121,1,0,168,117,1,0,0,0,0,0,112,198,1,0,168,117,1,0,0,0,0,0,192,121,1,0,168,117,1,0,0,0,0,0,168,189,1,0,168,117,1,0,0,0,0,0,96,201,1,0,168,117,1,0,0,0,0,0,88,122,1,0,168,117,1,0,0,0,0,0,104,177,1,0,168,117,1,0,0,0,0,0,144,177,1,0,168,117,1,0,0,0,0,0,120,122,1,0,168,117,1,0,0,0,0,0,80,121,1,0,168,117,1,0,0,0,0,0,8,122,1,0,168,117,1,0,0,0,0,0,0,0,0,0,32,121,1,0,0,0,0,0,0,0,1,0,32,182,1,0,40,182,1,0,0,0,0,0,200,182,1,0,64,183,1,0,0,0,0,0,40,121,1,0,0,0,0,0,0,0,1,0,72,183,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,48,121,1,0,0,0,0,0,0,0,1,0,160,183,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,56,121,1,0,0,0,0,0,0,0,0,0,168,183,1,0,192,183,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,64,121,1,0,0,0,0,0,1,1,2,0,104,184,1,0,120,184,1,0,0,0,0,0,0,0,0,0,128,185,1,0,0,0,0,0,184,185,1,0,0,2,2,1,0,0,0,0,192,185,1,0,0,0,0,0,0,0,0,0,224,185,1,0,64,183,1,0,8,186,1,0,72,121,1,0,0,3,0,0,0,0,1,0,16,186,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,224,119,1,0,0,2,2,1,0,0,0,0,32,186,1,0,0,0,0,0,0,0,0,0,0,0,0,0,64,183,1,0,56,186,1,0,64,186,1,0,0,2,2,1,1,1,1,0,80,186,1,0,0,0,0,0,0,0,0,0,0,0,0,0,96,186,1,0,0,0,0,0,80,121,1,0,0,0,0,0,0,0,1,0,120,186,1,0,40,182,1,0,0,0,0,0,144,186,1,0,0,0,0,0,176,186,1,0,88,121,1,0,0,3,0,0,0,0,1,0,184,186,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,96,121,1,0,0,0,0,0,0,0,0,0,208,186,1,0,224,186,1,0,0,0,0,0,224,187,1,0,0,0,0,0,0,0,0,0,160,117,1,0,1,1,0,0,0,0,0,0,40,188,1,0,56,188,1,0,96,118,1,0,64,189,1,0,136,189,1,0,0,0,0,0,168,189,1,0,0,2,2,1,0,0,1,0,176,189,1,0,0,0,0,0,0,0,0,0,200,189,1,0,224,189,1,0,0,0,0,0,112,121,1,0,0,0,0,0,0,0,2,0,232,189,1,0,224,186,1,0,0,0,0,0,248,189,1,0,0,0,0,0,0,0,0,0,120,121,1,0,0,0,0,0,0,0,0,0,88,190,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,128,121,1,0,0,3,0,0,1,1,0,0,104,190,1,0,224,186,1,0,0,0,0,0,0,0,0,0,96,183,1,0,0,0,0,0,136,121,1,0,0,0,0,0,0,0,1,0,136,190,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,144,121,1,0,0,0,0,0,0,0,1,0,152,190,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,176,190,1,0,0,2,2,1,0,0,0,0,184,190,1,0,0,0,0,0,0,0,0,0,200,190,1,0,0,0,0,0,0,0,0,0,32,191,1,0,0,1,0,0,0,0,0,0,48,191,1,0,72,191,1,0,176,190,1,0,200,190,1,0,0,0,0,0,0,0,0,0,152,121,1,0,0,1,0,0,0,0,0,0,80,191,1,0,224,186,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,160,121,1,0,0,0,0,0,0,0,2,0,104,191,1,0,224,186,1,0,0,0,0,0,120,191,1,0,0,0,0,0,0,0,0,0,168,121,1,0,0,0,0,0,0,0,1,0,192,191,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,216,191,1,0,0,0,0,0,1,1,0,0,224,191,1,0,240,191,1,0,48,122,1,0,0,0,0,0,88,192,1,0,0,0,0,0,96,118,1,0,0,0,0,0,0,0,0,0,160,192,1,0,224,186,1,0,0,0,0,0,96,183,1,0,200,192,1,0,0,0,0,0,208,192,1,0,0,0,0,0,0,0,0,0,216,192,1,0,240,192,1,0,152,121,1,0,96,183,1,0,0,193,1,0,0,0,0,0,176,121,1,0,0,1,0,0,0,0,0,0,8,193,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,184,121,1,0,0,3,0,0,0,0,1,0,32,193,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,48,193,1,0,0,1,0,0,1,1,1,0,56,193,1,0,0,0,0,0,0,0,0,0,88,193,1,0,0,0,0,0,0,0,0,0,184,193,1,0,0,0,0,0,0,0,0,0,200,193,1,0,224,193,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,192,121,1,0,0,3,0,0,1,1,1,0,224,194,1,0,40,182,1,0,0,0,0,0,0,0,0,0,248,194,1,0,0,0,0,0,200,121,1,0,0,0,0,0,0,0,0,0,32,195,1,0,56,195,1,0,184,193,1,0,48,196,1,0,64,183,1,0,144,196,1,0,248,119,1,0,0,2,2,1,0,2,0,0,152,196,1,0,0,0,0,0,0,0,0,0,0,0,0,0,168,196,1,0,0,0,0,0,0,120,1,0,0,0,0,0,0,2,0,0,224,196,1,0,248,196,1,0,232,119,1,0,0,0,0,0,8,197,1,0,0,0,0,0,208,121,1,0,0,0,0,0,0,0,0,0,48,197,1,0,40,182,1,0,0,0,0,0,96,183,1,0,200,192,1,0,0,0,0,0,216,121,1,0,0,0,0,0,0,0,0,0,48,197,1,0,40,182,1,0,0,0,0,0,96,183,1,0,200,192,1,0,0,0,0,0,224,121,1,0,0,0,0,0,0,0,0,0,48,197,1,0,40,182,1,0,0,0,0,0,96,183,1,0,200,192,1,0,0,0,0,0,232,121,1,0,0,0,0,0,0,0,0,0,48,197,1,0,40,182,1,0,0,0,0,0,96,183,1,0,200,192,1,0,0,0,0,0,240,121,1,0,0,0,0,0,0,0,0,0,48,197,1,0,40,182,1,0,0,0,0,0,96,183,1,0,200,192,1,0,0,0,0,0,248,121,1,0,0,0,0,0,0,0,0,0,48,197,1,0,40,182,1,0,0,0,0,0,96,183,1,0,200,192,1,0,0,0,0,0,168,117,1,0,1,1,0,0,0,0,0,0,64,197,1,0,80,197,1,0,0,0,0,0,120,197,1,0,0,0,0,0,0,0,0,0,136,197,1,0,0,2,2,1,0,0,0,0,144,197,1,0,0,0,0,0,0,0,0,0,96,183,1,0,168,197,1,0,0,0,0,0,32,112,1,0,1,1,0,0,0,0,0,0,192,197,1,0,216,197,1,0,0,0,0,0,232,197,1,0,248,197,1,0,0,0,0,0,0,122,1,0,0,3,0,0,0,0,1,0,0,198,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,8,122,1,0,0,0,0,0,0,1,2,0,24,198,1,0,224,186,1,0,0,0,0,0,0,0,0,0,48,198,1,0,0,0,0,0,112,198,1,0,0,2,2,1,0,0,1,0,120,198,1,0,0,0,0,0,0,0,0,0,136,198,1,0,200,192,1,0,224,198,1,0,240,198,1,0,0,2,2,1,0,0,1,0,248,198,1,0,0,0,0,0,0,0,0,0,8,199,1,0,200,192,1,0,0,0,0,0,16,122,1,0,0,0,0,0,0,0,2,0,152,199,1,0,224,186,1,0,0,0,0,0,120,191,1,0,0,0,0,0,0,0,0,0,168,199,1,0,0,2,2,1,1,1,0,0,176,199,1,0,0,0,0,0,0,0,0,0,0,0,0,0,200,199,1,0,0,0,0,0,24,122,1,0,0,0,0,0,0,0,1,0,232,199,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,32,122,1,0,0,0,0,0,0,0,1,0,8,200,1,0,40,182,1,0,0,0,0,0,32,200,1,0,0,0,0,0,0,0,0,0,40,122,1,0,0,0,0,0,0,0,0,0,112,200,1,0,40,182,1,0,0,0,0,0,136,200,1,0,200,192,1,0,0,0,0,0,48,122,1,0,0,1,1,0,0,0,0,0,208,200,1,0,224,186,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,208,119,1,0,0,2,2,1,0,0,0,0,224,200,1,0,0,0,0,0,0,0,0,0,0,201,1,0,64,183,1,0,0,0,0,0,96,201,1,0,0,0,0,0,0,0,2,0,104,201,1,0,128,201,1,0,0,0,0,0,96,183,1,0,0,0,0,0,232,201,1,0,240,201,1,0,0,0,0,0,1,1,0,0,248,201,1,0,240,191,1,0,0,0,0,0,0,0,0,0,88,192,1,0,0,0,0,0,200,119,1,0,0,2,2,1,0,0,0,0,8,202,1,0,0,0,0,0,0,0,0,0,40,202,1,0,0,0,0,0,72,202,1,0,232,119,1,0,0,0,0,0,0,2,0,0,80,202,1,0,144,202,1,0,160,117,1,0,96,183,1,0,0,0,0,0,0,0,0,0,56,122,1,0,0,0,0,0,0,0,0,0,152,203,1,0,224,186,1,0,96,118,1,0,96,183,1,0,0,0,0,0,0,0,0,0,72,122,1,0,0,0,0,0,0,0,2,0,56,193,1,0,216,203,1,0,96,118,1,0,224,204,1,0,88,205,1,0,0,0,0,0,112,205,1,0,0,0,0,0,0,0,0,0,120,205,1,0,136,205,1,0,48,122,1,0,96,183,1,0,144,205,1,0,0,0,0,0,160,205,1,0,0,0,0,0,0,0,0,0,176,205,1,0,192,205,1,0,200,205,1,0,208,205,1,0,0,0,0,0,24,206,1,0,200,205,1,0,0,1,0,0,0,0,0,0,32,206,1,0,56,206,1,0,0,0,0,0,64,206,1,0,0,0,0,0,0,0,0,0,176,119,1,0,0,1,0,0,0,0,0,0,144,206,1,0,40,182,1,0,0,0,0,0,96,183,1,0,200,192,1,0,0,0,0,0,160,206,1,0,0,2,2,1,0,0,0,0,168,206,1,0,0,0,0,0,0,0,0,0,192,206,1,0,0,0,0,0,232,201,1,0,80,122,1,0,0,0,0,0,0,0,0,0,216,206,1,0,240,206,1,0,0,0,0,0,96,183,1,0,88,207,1,0,0,0,0,0,88,122,1,0,0,0,0,0,0,0,1,0,96,207,1,0,40,182,1,0,0,0,0,0,224,187,1,0,0,0,0,0,0,0,0,0,96,122,1,0,0,3,0,0,1,1,1,0,120,207,1,0,40,182,1,0,0,0,0,0,0,0,0,0,96,183,1,0,0,0,0,0,104,122,1,0,0,0,0,0,0,0,1,0,152,207,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,16,115,1,0,0,0,0,0,0,0,2,0,192,207,1,0,56,206,1,0,0,0,0,0,216,207,1,0,240,207,1,0,248,207,1,0,0,208,1,0,0,0,0,0,0,0,1,0,8,208,1,0,32,208,1,0,0,0,0,0,48,208,1,0,0,0,0,0,0,0,0,0,112,122,1,0,0,3,0,0,0,0,1,0,144,208,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,120,122,1,0,0,0,0,0,0,0,1,0,168,208,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,128,122,1,0,0,3,0,0,1,1,1,0,208,208,1,0,40,182,1,0,0,0,0,0,0,0,0,0,96,183,1,0,0,0,0,0,136,122,1,0,0,3,0,0,0,0,1,0,232,208,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,24,115,1,0,0,0,0,0,0,0,0,0,248,208,1,0,56,206,1,0,0,0,0,0,8,209,1,0,0,0,0,0,248,207,1,0,104,177,1,0,0,3,0,0,0,0,1,0,32,209,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,144,177,1,0,0,3,0,0,0,0,1,0,48,209,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,152,118,1,0,0,0,0,0,0,0,0,0,160,183,1,0,64,209,1,0,120,118,1,0,96,209,1,0,192,209,1,0,0,0,0,0,136,118,1,0,1,0,0,0,0,0,0,0,208,209,1,0,224,209,1,0,120,118,1,0,232,209,1,0,0,0,0,0,0,0,0,0,104,118,1,0,0,0,0,0,0,0,0,0,56,210,1,0,224,186,1,0,0,0,0,0,72,210,1,0,176,210,1,0,0,0,0,0,200,210,1,0,0,0,0,0,0,0,1,0,216,210,1,0,56,206,1,0,0,0,0,0,240,210,1,0,0,0,0,0,88,211,1,0,144,118,1,0,0,1,0,0,0,0,0,0,104,211,1,0,224,209,1,0,120,118,1,0,232,209,1,0,0,0,0,0,0,0,0,0,112,118,1,0,0,1,0,0,0,0,0,0,120,211,1,0,224,186,1,0,0,0,0,0,72,210,1,0,176,210,1,0,0,0,0,0,128,118,1,0,0,1,0,0,0,0,0,0,144,211,1,0,224,209,1,0,120,118,1,0,232,209,1,0,0,0,0,0,0,0,0,0,216,119,1,0,0,0,0,0,0,0,0,0,160,211,1,0,56,206,1,0,0,0,0,0,232,197,1,0,0,0,0,0,0,0,0,0,120,118,1,0,0,0,0,0,0,0,0,0,176,211,1,0,192,211,1,0,104,118,1,0,232,209,1,0,208,211,1,0,0,0,0,0,144,122,1,0,0,3,0,0,0,0,1,0,216,211,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,152,122,1,0,0,3,0,0,1,1,1,0,0,212,1,0,40,182,1,0,0,0,0,0,0,0,0,0,96,183,1,0,0,0,0,0,24,212,1,0,0,0,0,0,0,0,0,0,32,212,1,0,136,205,1,0,48,122,1,0,96,183,1,0,48,212,1,0,0,0,0,0,160,122,1,0,0,0,0,0,0,0,1,0,64,212,1,0,40,182,1,0,0,0,0,0,96,183,1,0,0,0,0,0,0,0,0,0,34,0,0,0,56,127,1,0,64,127,1,0,38,0,0,0,112,127,1,0,120,127,1,0,39,0,0,0,152,127,1,0,160,127,1,0,60,0,0,0,176,127,1,0,184,127,1,0,62,0,0,0,216,127,1,0,224,127,1,0,160,0,0,0,8,128,1,0,16,128,1,0,161,0,0,0,72,128,1,0,80,128,1,0,162,0,0,0,128,128,1,0,136,128,1,0,163,0,0,0,168,128,1,0,176,128,1,0,164,0,0,0,208,128,1,0,216,128,1,0,165,0,0,0,248,128,1,0,0,129,1,0,166,0,0,0,40,129,1,0,48,129,1,0,167,0,0,0,96,129,1,0,104,129,1,0,168,0,0,0,136,129,1,0,144,129,1,0,169,0,0,0,192,129,1,0,200,129,1,0,170,0,0,0,232,129,1,0,240,129,1,0,171,0,0,0,32,130,1,0,40,130,1,0,172,0,0,0,128,130,1,0,136,130,1,0,173,0,0,0,160,130,1,0,168,130,1,0,174,0,0,0,224,130,1,0,232,130,1,0,175,0,0,0,40,131,1,0,48,131,1,0,176,0,0,0,112,131,1,0,120,131,1,0,177,0,0,0,152,131,1,0,160,131,1,0,178,0,0,0,216,131,1,0,224,131,1,0,179,0,0,0,40,132,1,0,48,132,1,0,180,0,0,0,120,132,1,0,128,132,1,0,181,0,0,0,176,132,1,0,184,132,1,0,182,0,0,0,216,132,1,0,224,132,1,0,183,0,0,0,16,133,1,0,24,133,1,0,184,0,0,0,88,133,1,0,96,133,1,0,185,0,0,0,144,133,1,0,152,133,1,0,186,0,0,0,208,133,1,0,216,133,1,0,187,0,0,0,8,134,1,0,16,134,1,0,188,0,0,0,104,134,1,0,112,134,1,0,189,0,0,0,184,134,1,0,192,134,1,0,190,0,0,0,0,135,1,0,8,135,1,0,191,0,0,0,80,135,1,0,88,135,1,0,192,0,0,0,152,135,1,0,160,135,1,0,193,0,0,0,248,135,1,0,0,136,1,0,194,0,0,0,56,136,1,0,64,136,1,0,195,0,0,0,120,136,1,0,128,136,1,0,196,0,0,0,184,136,1,0,192,136,1,0,197,0,0,0,248,136,1,0,0,137,1,0,198,0,0,0,88,137,1,0,96,137,1,0,199,0,0,0,168,137,1,0,176,137,1,0,200,0,0,0,232,137,1,0,240,137,1,0,201,0,0,0,40,138,1,0,48,138,1,0,202,0,0,0,104,138,1,0,112,138,1,0,203,0,0,0,168,138,1,0,176,138,1,0,204,0,0,0,232,138,1,0,240,138,1,0,205,0,0,0,40,139,1,0,48,139,1,0,206,0,0,0,104,139,1,0,112,139,1,0,207,0,0,0,168,139,1,0,176,139,1,0,208,0,0,0,232,139,1,0,240,139,1,0,209,0,0,0,32,140,1,0,40,140,1,0,210,0,0,0,96,140,1,0,104,140,1,0,211,0,0,0,160,140,1,0,168,140,1,0,212,0,0,0,224,140,1,0,232,140,1,0,213,0,0,0,32,141,1,0,40,141,1,0,214,0,0,0,96,141,1,0,104,141,1,0,215,0,0,0,160,141,1,0,168,141,1,0,216,0,0,0,208,141,1,0,216,141,1,0,217,0,0,0,40,142,1,0,48,142,1,0,218,0,0,0,104,142,1,0,112,142,1,0,219,0,0,0,168,142,1,0,176,142,1,0,220,0,0,0,232,142,1,0,240,142,1,0,221,0,0,0,40,143,1,0,48,143,1,0,222,0,0,0,104,143,1,0,112,143,1,0,223,0,0,0,160,143,1,0,168,143,1,0,224,0,0,0,224,143,1,0,232,143,1,0,225,0,0,0,56,144,1,0,64,144,1,0,226,0,0,0,112,144,1,0,120,144,1,0,227,0,0,0,176,144,1,0,184,144,1,0,228,0,0,0,232,144,1,0,240,144,1,0,229,0,0,0,40,145,1,0,48,145,1,0,230,0,0,0,136,145,1,0,144,145,1,0,231,0,0,0,208,145,1,0,216,145,1,0,232,0,0,0,16,146,1,0,24,146,1,0,233,0,0,0,72,146,1,0,80,146,1,0,234,0,0,0,128,146,1,0,136,146,1,0,235,0,0,0,192,146,1,0,200,146,1,0,236,0,0,0,0,147,1,0,8,147,1,0,237,0,0,0,56,147,1,0,64,147,1,0,238,0,0,0,112,147,1,0,120,147,1,0,239,0,0,0,176,147,1,0,184,147,1,0,240,0,0,0,240,147,1,0,248,147,1,0,241,0,0,0,32,148,1,0,40,148,1,0,242,0,0,0,88,148,1,0,96,148,1,0,243,0,0,0,144,148,1,0,152,148,1,0,244,0,0,0,200,148,1,0,208,148,1,0,245,0,0,0,8,149,1,0,16,149,1,0,246,0,0,0,64,149,1,0,72,149,1,0,247,0,0,0,128,149,1,0,136,149,1,0,248,0,0,0,168,149,1,0,176,149,1,0,249,0,0,0,0,150,1,0,8,150,1,0,250,0,0,0,56,150,1,0,64,150,1,0,251,0,0,0,112,150,1,0,120,150,1,0,252,0,0,0,176,150,1,0,184,150,1,0,253,0,0,0,240,150,1,0,248,150,1,0,254,0,0,0,40,151,1,0,48,151,1,0,255,0,0,0,96,151,1,0,104,151,1,0,82,1,0,0,160,151,1,0,168,151,1,0,83,1,0,0,216,151,1,0,224,151,1,0,96,1,0,0,8,152,1,0,16,152,1,0,97,1,0,0,72,152,1,0,80,152,1,0,120,1,0,0,128,152,1,0,136,152,1,0,146,1,0,0,192,152,1,0,200,152,1,0,198,2,0,0,8,153,1,0,16,153,1,0,220,2,0,0,72,153,1,0,80,153,1,0,145,3,0,0,112,153,1,0,120,153,1,0,146,3,0,0,160,153,1,0,168,153,1,0,147,3,0,0,208,153,1,0,216,153,1,0,148,3,0,0,8,154,1,0,16,154,1,0,149,3,0,0,64,154,1,0,72,154,1,0,150,3,0,0,112,154,1,0,120,154,1,0,151,3,0,0,160,154,1,0,168,154,1,0,152,3,0,0,208,154,1,0,216,154,1,0,153,3,0,0,8,155,1,0,16,155,1,0,154,3,0,0,56,155,1,0,64,155,1,0,155,3,0,0,104,155,1,0,112,155,1,0,156,3,0,0,160,155,1,0,168,155,1,0,157,3,0,0,200,155,1,0,208,155,1,0,158,3,0,0,240,155,1,0,248,155,1,0,159,3,0,0,32,156,1,0,40,156,1,0,160,3,0,0,80,156,1,0,88,156,1,0,161,3,0,0,128,156,1,0,136,156,1,0,163,3,0,0,176,156,1,0,184,156,1,0,164,3,0,0,232,156,1,0,240,156,1,0,165,3,0,0,24,157,1,0,32,157,1,0,166,3,0,0,80,157,1,0,88,157,1,0,167,3,0,0,136,157,1,0,144,157,1,0,168,3,0,0,184,157,1,0,192,157,1,0,169,3,0,0,240,157,1,0,248,157,1,0,177,3,0,0,40,158,1,0,48,158,1,0,178,3,0,0,96,158,1,0,104,158,1,0,179,3,0,0,144,158,1,0,152,158,1,0,180,3,0,0,200,158,1,0,208,158,1,0,181,3,0,0,0,159,1,0,8,159,1,0,182,3,0,0,56,159,1,0,64,159,1,0,183,3,0,0,104,159,1,0,112,159,1,0,184,3,0,0,152,159,1,0,160,159,1,0,185,3,0,0,208,159,1,0,216,159,1,0,186,3,0,0,0,160,1,0,8,160,1,0,187,3,0,0,56,160,1,0,64,160,1,0,188,3,0,0,112,160,1,0,120,160,1,0,189,3,0,0,160,160,1,0,168,160,1,0,190,3,0,0,208,160,1,0,216,160,1,0,191,3,0,0,0,161,1,0,8,161,1,0,192,3,0,0,48,161,1,0,56,161,1,0,193,3,0,0,96,161,1,0,104,161,1,0,194,3,0,0,144,161,1,0,152,161,1,0,195,3,0,0,200,161,1,0,208,161,1,0,196,3,0,0,0,162,1,0,8,162,1,0,197,3,0,0,48,162,1,0,56,162,1,0,198,3,0,0,104,162,1,0,112,162,1,0,199,3,0,0,152,162,1,0,160,162,1,0,200,3,0,0,200,162,1,0,208,162,1,0,201,3,0,0,248,162,1,0,0,163,1,0,209,3,0,0,48,163,1,0,64,163,1,0,210,3,0,0,112,163,1,0,120,163,1,0,214,3,0,0,168,163,1,0,176,163,1,0,2,32,0,0,208,163,1,0,216,163,1,0,3,32,0,0,240,163,1,0,248,163,1,0,9,32,0,0,16,164,1,0,24,164,1,0,12,32,0,0,56,164,1,0,64,164,1,0,13,32,0,0,112,164,1,0,120,164,1,0,14,32,0,0,160,164,1,0,168,164,1,0,15,32,0,0,208,164,1,0,216,164,1,0,19,32,0,0,0,165,1,0,8,165,1,0,20,32,0,0,32,165,1,0,40,165,1,0,24,32,0,0,64,165,1,0,72,165,1,0,25,32,0,0,120,165,1,0,128,165,1,0,26,32,0,0,176,165,1,0,184,165,1,0,28,32,0,0,224,165,1,0,232,165,1,0,29,32,0,0,24,166,1,0,32,166,1,0,30,32,0,0,80,166,1,0,88,166,1,0,32,32,0,0,128,166,1,0,136,166,1,0,33,32,0,0,160,166,1,0,168,166,1,0,34,32,0,0,200,166,1,0,208,166,1,0,38,32,0,0,0,167,1,0,8,167,1,0,48,32,0,0,64,167,1,0,72,167,1,0,50,32,0,0,104,167,1,0,112,167,1,0,51,32,0,0,152,167,1,0,160,167,1,0,57,32,0,0,208,167,1,0,216,167,1,0,58,32,0,0,24,168,1,0,32,168,1,0,62,32,0,0,96,168,1,0,104,168,1,0,68,32,0,0,152,168,1,0,160,168,1,0,172,32,0,0,192,168,1,0,200,168,1,0,17,33,0,0,224,168,1,0,232,168,1,0,24,33,0,0,32,169,1,0,40,169,1,0,28,33,0,0,104,169,1,0,112,169,1,0,34,33,0,0,176,169,1,0,184,169,1,0,53,33,0,0,216,169,1,0,224,169,1,0,144,33,0,0,24,170,1,0,32,170,1,0,145,33,0,0,64,170,1,0,72,170,1,0,146,33,0,0,104,170,1,0,112,170,1,0,147,33,0,0,144,170,1,0,152,170,1,0,148,33,0,0,184,170,1,0,192,170,1,0,181,33,0,0,232,170,1,0,240,170,1,0,208,33,0,0,56,171,1,0,64,171,1,0,209,33,0,0,104,171,1,0,112,171,1,0,210,33,0,0,152,171,1,0,160,171,1,0,211,33,0,0,200,171,1,0,208,171,1,0,212,33,0,0,248,171,1,0,0,172,1,0,0,34,0,0,40,172,1,0,48,172,1,0,2,34,0,0,72,172,1,0,80,172,1,0,3,34,0,0,120,172,1,0,128,172,1,0,5,34,0,0,160,172,1,0,168,172,1,0,7,34,0,0,216,172,1,0,224,172,1,0,8,34,0,0,16,173,1,0,24,173,1,0,9,34,0,0,56,173,1,0,64,173,1,0,11,34,0,0,104,173,1,0,112,173,1,0,15,34,0,0,152,173,1,0,160,173,1,0,17,34,0,0,208,173,1,0,216,173,1,0,18,34,0,0,248,173,1,0,0,174,1,0,23,34,0,0,32,174,1,0,40,174,1,0,26,34,0,0,80,174,1,0,88,174,1,0,29,34,0,0,136,174,1,0,144,174,1,0,30,34,0,0,176,174,1,0,184,174,1,0,32,34,0,0,216,174,1,0,224,174,1,0,39,34,0,0,248,174,1,0,0,175,1,0,40,34,0,0,40,175,1,0,48,175,1,0,41,34,0,0,88,175,1,0,96,175,1,0,42,34,0,0,136,175,1,0,144,175,1,0,43,34,0,0,176,175,1,0,184,175,1,0,52,34,0,0,216,175,1,0,224,175,1,0,60,34,0,0,0,176,1,0,8,176,1,0,69,34,0,0,72,176,1,0,80,176,1,0,72,34,0,0,120,176,1,0,128,176,1,0,96,34,0,0,176,176,1,0,184,176,1,0,97,34,0,0,216,176,1,0,224,176,1,0,100,34,0,0,0,177,1,0,8,177,1,0,101,34,0,0,48,177,1,0,56,177,1,0,130,34,0,0,104,177,1,0,112,177,1,0,131,34,0,0,144,177,1,0,152,177,1,0,132,34,0,0,184,177,1,0,192,177,1,0,134,34,0,0,224,177,1,0,232,177,1,0,135,34,0,0,16,178,1,0,24,178,1,0,149,34,0,0,64,178,1,0,72,178,1,0,151,34,0,0,120,178,1,0,128,178,1,0,165,34,0,0,176,178,1,0,184,178,1,0,197,34,0,0,240,178,1,0,248,178,1,0,8,35,0,0,24,179,1,0,32,179,1,0,9,35,0,0,80,179,1,0,88,179,1,0,10,35,0,0,120,179,1,0,128,179,1,0,11,35,0,0,176,179,1,0,184,179,1,0,41,35,0,0,216,179,1,0,224,179,1,0,42,35,0,0,24,180,1,0,32,180,1,0,202,37,0,0,88,180,1,0,96,180,1,0,96,38,0,0,120,180,1,0,128,180,1,0,99,38,0,0,160,180,1,0,168,180,1,0,101,38,0,0,216,180,1,0,224,180,1,0,102,38,0,0,16,181,1,0,24,181,1,0,0,0,0,0,35,37,117,0,0,0,0,0,72,84,77,76,32,100,111,99,117,109,101,110,116,32,99,114,101,97,116,105,111,110,32,102,97,105,108,101,100,10,0,0,104,116,109,108,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,84,82,47,82,69,67,45,104,116,109,108,52,48,47,108,111,111,115,101,46,100,116,100,0,0,0,0,0,0,0,45,47,47,87,51,67,47,47,68,84,68,32,72,84,77,76,32,52,46,48,32,84,114,97,110,115,105,116,105,111,110,97,108,47,47,69,78,0,0,0,104,116,109,108,80,97,114,115,101,69,110,116,105,116,121,82,101,102,58,32,110,111,32,110,97,109,101,10,0,0,0,0,104,116,109,108,80,97,114,115,101,69,110,116,105,116,121,82,101,102,58,32,101,120,112,101,99,116,105,110,103,32,39,59,39,10,0,0,0,0,0,0,104,116,109,108,80,97,114,115,101,67,104,97,114,82,101,102,58,32,99,111,110,116,101,120,116,32,101,114,114,111,114,10,0,0,0,0,0,0,0,0,104,116,109,108,80,97,114,115,101,67,104,97,114,82,101,102,58,32,109,105,115,115,105,110,103,32,115,101,109,105,99,111,108,111,110,10,0,0,0,0,104,116,109,108,80,97,114,115,101,67,104,97,114,82,101,102,58,32,105,110,118,97,108,105,100,32,118,97,108,117,101,10,0,0,0,0,0,0,0,0,104,116,109,108,80,97,114,115,101,67,104,97,114,82,101,102,58,32,105,110,118,97,108,105,100,32,120,109,108,67,104,97,114,32,118,97,108,117,101,32,37,100,10,0,0,0,0,0,84,97,103,32,37,115,32,105,110,118,97,108,105,100,10,0,67,111,117,108,100,110,39,116,32,102,105,110,100,32,101,110,100,32,111,102,32,83,116,97,114,116,32,84,97,103,32,37,115,10,0,0,0,0,0,0,104,116,109,108,80,97,114,115,101,68,111,99,117,109,101,110,116,58,32,99,111,110,116,101,120,116,32,101,114,114,111,114,10,0,0,0,0,0,0,0,68,111,99,117,109,101,110,116,32,105,115,32,101,109,112,116,121,10,0,0,0,0,0,0,78,101,119,80,97,114,115,101,114,67,116,120,116,58,32,111,117,116,32,111,102,32,109,101,109,111,114,121,10,0,0,0,104,116,109,108,80,97,114,115,101,67,104,117,110,107,58,32,99,111,110,116,101,120,116,32,101,114,114,111,114,10,0,0,101,110,99,111,100,101,114,32,101,114,114,111,114,10,0,0,99,104,97,114,115,101,116,61,0,0,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,10,0,0,1,0,0,0,0,0,0,0,99,104,97,114,115,101,116,0,61,0,0,0,0,0,0,0,104,116,109,108,67,104,101,99,107,69,110,99,111,100,105,110,103,58,32,119,114,111,110,103,32,101,110,99,111,100,105,110,103,32,109,101,116,97,10,0,104,116,109,108,67,104,101,99,107,69,110,99,111,100,105,110,103,58,32,117,110,107,110,111,119,110,32,101,110,99,111,100,105,110,103,32,37,115,10,0,104,116,109,108,67,104,101,99,107,69,110,99,111,100,105,110,103,58,32,101,110,99,111,100,101,114,32,101,114,114,111,114,10,0,0,0,0,0,0,0,99,111,117,108,100,110,39,116,32,97,108,108,111,99,97,116,101,32,97,32,110,101,119,32,105,110,112,117,116,32,115,116,114,101,97,109,10,0,0,0,115,99,114,105,112,116,0,0,115,116,121,108,101,0,0,0,77,105,115,112,108,97,99,101,100,32,68,79,67,84,89,80,69,32,100,101,99,108,97,114,97,116,105,111,110,10,0,0,68,79,67,84,89,80,69,0,59,32,62,47,0,0,0,0,60,38,0,0,0,0,0,0,100,101,116,101,99,116,101,100,32,97,110,32,101,114,114,111,114,32,105,110,32,101,108,101,109,101,110,116,32,99,111,110],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+84848),allocate([116,101,110,116,10,0,0,0,72,80,80,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,116,101,32,61,61,32,67,68,65,84,65,10,0,0,0,0,72,80,80,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,116,101,32,61,61,32,68,84,68,10,0,0,0,0,0,0,72,80,80,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,116,101,32,61,61,32,67,79,77,77,69,78,84,10,0,0,72,80,80,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,116,101,32,61,61,32,80,73,10,0,0,0,0,0,0,0,72,80,80,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,116,101,32,61,61,32,69,78,84,73,84,89,95,68,69,67,76,10,0,0,0,0,0,0,72,80,80,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,116,101,32,61,61,32,69,78,84,73,84,89,95,86,65,76,85,69,10,0,0,0,0,0,72,80,80,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,116,101,32,61,61,32,65,84,84,82,73,66,85,84,69,95,86,65,76,85,69,10,0,0,72,80,80,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,116,101,32,61,61,32,88,77,76,95,80,65,82,83,69,82,95,83,89,83,84,69,77,95,76,73,84,69,82,65,76,10,0,0,0,0,0,0,0,0,72,80,80,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,116,101,32,61,61,32,88,77,76,95,80,65,82,83,69,82,95,73,71,78,79,82,69,10,0,0,0,0,0,0,0,0,72,80,80,58,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,116,101,32,61,61,32,88,77,76,95,80,65,82,83,69,82,95,76,73,84,69,82,65,76,10,0,0,0,0,0,0,0,104,116,109,108,80,97,114,115,101,69,110,100,84,97,103,58,32,39,60,47,39,32,110,111,116,32,102,111,117,110,100,10,0,0,0,0,0,0,0,0,69,110,100,32,116,97,103,32,58,32,101,120,112,101,99,116,101,100,32,39,62,39,10,0,98,111,100,121,0,0,0,0,104,101,97,100,0,0,0,0,85,110,101,120,112,101,99,116,101,100,32,101,110,100,32,116,97,103,32,58,32,37,115,10,0,0,0,0,0,0,0,0,79,112,101,110,105,110,103,32,97,110,100,32,101,110,100,105,110,103,32,116,97,103,32,109,105,115,109,97,116,99,104,58,32,37,115,32,97,110,100,32,37,115,10,0,0,0,0,0,96,118,1,0,150,0,0,0,104,118,1,0,160,0,0,0,112,118,1,0,160,0,0,0,120,118,1,0,170,0,0,0,128,118,1,0,180,0,0,0,136,118,1,0,180,0,0,0,144,118,1,0,180,0,0,0,152,118,1,0,190,0,0,0,168,117,1,0,200,0,0,0,160,117,1,0,200,0,0,0,32,112,1,0,220,0,0,0,0,0,0,0,100,0,0,0,100,105,118,0,0,0,0,0,116,100,0,0,0,0,0,0,116,104,0,0,0,0,0,0,116,114,0,0,0,0,0,0,116,104,101,97,100,0,0,0,116,98,111,100,121,0,0,0,116,102,111,111,116,0,0,0,116,97,98,108,101,0,0,0,38,0,0,0,0,0,0,0,69,108,101,109,101,110,116,32,37,115,32,101,109,98,101,100,115,32,99,108,111,115,101,32,116,97,103,10,0,0,0,0,73,110,118,97,108,105,100,32,99,104,97,114,32,105,110,32,67,68,65,84,65,32,48,120,37,88,10,0,0,0,0,0,67,104,97,114,32,48,120,37,88,32,111,117,116,32,111,102,32,97,108,108,111,119,101,100,32,114,97,110,103,101,10,0,85,110,115,117,112,112,111,114,116,101,100,32,101,110,99,111,100,105,110,103,32,37,115,0,66,121,116,101,115,58,32,48,120,37,48,50,88,32,48,120,37,48,50,88,32,48,120,37,48,50,88,32,48,120,37,48,50,88,10,0,0,0,0,0,66,121,116,101,115,58,32,48,120,37,48,50,88,10,0,0,73,110,112,117,116,32,105,115,32,110,111,116,32,112,114,111,112,101,114,32,85,84,70,45,56,44,32,105,110,100,105,99,97,116,101,32,101,110,99,111,100,105,110,103,32,33,10,0,72,84,84,80,45,69,81,85,73,86,0,0,0,0,0,0,67,79,78,84,69,78,84,0,67,72,65,82,83,69,84,61,0,0,0,0,0,0,0,0,112,0,0,0,0,0,0,0,32,112,1,0,168,117,1,0,0,0,0,0,0,0,0,0,109,101,116,97,0,0,0,0,108,105,110,107,0,0,0,0,116,105,116,108,101,0,0,0,98,97,115,101,0,0,0,0,110,111,102,114,97,109,101,115,0,0,0,0,0,0,0,0,102,114,97,109,101,0,0,0,102,114,97,109,101,115,101,116,0,0,0,0,0,0,0,0,45,47,47,87,51,67,47,47,68,84,68,32,72,84,77,76,32,52,46,48,49,47,47,69,78,0,0,0,0,0,0,0,45,47,47,87,51,67,47,47,68,84,68,32,72,84,77,76,32,52,47,47,69,78,0,0,32,121,1,0,40,121,1,0,48,121,1,0,56,121,1,0,64,121,1,0,72,121,1,0,80,121,1,0,88,121,1,0,96,121,1,0,160,117,1,0,112,121,1,0,120,121,1,0,128,121,1,0,136,121,1,0,144,121,1,0,152,121,1,0,160,121,1,0,168,121,1,0,96,118,1,0,176,121,1,0,184,121,1,0,192,121,1,0,200,121,1,0,208,121,1,0,216,121,1,0,224,121,1,0,232,121,1,0,240,121,1,0,248,121,1,0,0,122,1,0,8,122,1,0,16,122,1,0,24,122,1,0,32,122,1,0,40,122,1,0,48,122,1,0,232,119,1,0,56,122,1,0,72,122,1,0,176,119,1,0,80,122,1,0,88,122,1,0,96,122,1,0,104,122,1,0,112,122,1,0,120,122,1,0,128,122,1,0,136,122,1,0,104,118,1,0,112,118,1,0,144,122,1,0,152,122,1,0,160,122,1,0,0,0,0,0,97,0,0,0,0,0,0,0,97,98,98,114,0,0,0,0,97,99,114,111,110,121,109,0,97,100,100,114,101,115,115,0,97,112,112,108,101,116,0,0,98,0,0,0,0,0,0,0,98,100,111,0,0,0,0,0,98,105,103,0,0,0,0,0,98,108,111,99,107,113,117,111,116,101,0,0,0,0,0,0,98,117,116,116,111,110,0,0,99,97,112,116,105,111,110,0,99,101,110,116,101,114,0,0,99,105,116,101,0,0,0,0,99,111,100,101,0,0,0,0,100,100,0,0,0,0,0,0,100,101,108,0,0,0,0,0,100,102,110,0,0,0,0,0,100,116,0,0,0,0,0,0,101,109,0,0,0,0,0,0,102,111,110,116,0,0,0,0,102,111,114,109,0,0,0,0,104,49,0,0,0,0,0,0,104,50,0,0,0,0,0,0,104,51,0,0,0,0,0,0,104,52,0,0,0,0,0,0,104,53,0,0,0,0,0,0,104,54,0,0,0,0,0,0,105,0,0,0,0,0,0,0,105,102,114,97,109,101,0,0,105,110,115,0,0,0,0,0,107,98,100,0,0,0,0,0,108,97,98,101,108,0,0,0,108,101,103,101,110,100,0,0,108,105,0,0,0,0,0,0,110,111,115,99,114,105,112,116,0,0,0,0,0,0,0,0,111,98,106,101,99,116,0,0,112,114,101,0,0,0,0,0,113,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,115,97,109,112,0,0,0,0,115,109,97,108,108,0,0,0,115,112,97,110,0,0,0,0,115,116,114,105,107,101,0,0,115,116,114,111,110,103,0,0,116,116,0,0,0,0,0,0,117,0,0,0,0,0,0,0,118,97,114,0,0,0,0,0,104,116,109,108,73,110,105,116,80,97,114,115,101,114,67,116,120,116,58,32,111,117,116,32,111,102,32,109,101,109,111,114,121,10,0,0,0,0,0,0,104,116,109,108,80,97,114,115,101,68,111,99,84,121,112,101,68,101,99,108,32,58,32,110,111,32,68,79,67,84,89,80,69,32,110,97,109,101,32,33,10,0,0,0,0,0,0,0,68,79,67,84,89,80,69,32,105,109,112,114,111,112,101,114,108,121,32,116,101,114,109,105,110,97,116,101,100,10,0,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,39,83,89,83,84,69,77,39,10,0,0,104,116,109,108,80,97,114,115,101,69,120,116,101,114,110,97,108,73,68,58,32,83,89,83,84,69,77,44,32,110,111,32,85,82,73,10,0,0,0,0,83,112,97,99,101,32,114,101,113,117,105,114,101,100,32,97,102,116,101,114,32,39,80,85,66,76,73,67,39,10,0,0,104,116,109,108,80,97,114,115,101,69,120,116,101,114,110,97,108,73,68,58,32,80,85,66,76,73,67,44,32,110,111,32,80,117,98,108,105,99,32,73,100,101,110,116,105,102,105,101,114,10,0,0,0,0,0,0,85,110,102,105,110,105,115,104,101,100,32,80,117,98,105,100,76,105,116,101,114,97,108,10,0,0,0,0,0,0,0,0,80,117,98,105,100,76,105,116,101,114,97,108,32,34,32,111,114,32,39,32,101,120,112,101,99,116,101,100,10,0,0,0,85,110,102,105,110,105,115,104,101,100,32,83,121,115,116,101,109,76,105,116,101,114,97,108,10,0,0,0,0,0,0,0,32,111,114,32,39,32,101,120,112,101,99,116,101,100,10,0,80,97,114,115,101,80,73,58,32,80,73,32,37,115,32,115,112,97,99,101,32,101,120,112,101,99,116,101,100,10,0,0,80,97,114,115,101,80,73,58,32,80,73,32,37,115,32,110,101,118,101,114,32,101,110,100,32,46,46,46,10,0,0,0,80,73,32,105,115,32,110,111,116,32,115,116,97,114,116,101,100,32,99,111,114,114,101,99,116,108,121,0,0,0,0,0,98,117,102,102,101,114,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,10,0,0,0,0,0,0,0,103,114,111,119,105,110,103,32,98,117,102,102,101,114,32,102,97,105,108,101,100,10,0,0,67,111,109,109,101,110,116,32,110,111,116,32,116,101,114,109,105,110,97,116,101,100,32,10,60,33,45,45,37,46,53,48,115,10,0,0,0,0,0,0,104,116,109,108,80,97,114,115,101,83,116,97,114,116,84,97,103,58,32,105,110,118,97,108,105,100,32,101,108,101,109,101,110,116,32,110,97,109,101,10,0,0,0,0,0,0,0,0,104,116,109,108,80,97,114,115,101,69,108,101,109,101,110,116,73,110,116,101,114,110,97,108,58,32,99,111,110,116,101,120,116,32,101,114,114,111,114,10,0,0,0,0,0,0,0,0,104,116,109,108,80,97,114,115,101,83,116,97,114,116,84,97,103,58,32,99,111,110,116,101,120,116,32,101,114,114,111,114,10,0,0,0,0,0,0,0,104,116,109,108,80,97,114,115,101,83,116,97,114,116,84,97,103,58,32,109,105,115,112,108,97,99,101,100,32,60,104,116,109,108,62,32,116,97,103,10,0,0,0,0,0,0,0,0,104,116,109,108,80,97,114,115,101,83,116,97,114,116,84,97,103,58,32,109,105,115,112,108,97,99,101,100,32,60,104,101,97,100,62,32,116,97,103,10,0,0,0,0,0,0,0,0,104,116,109,108,80,97,114,115,101,83,116,97,114,116,84,97,103,58,32,109,105,115,112,108,97,99,101,100,32,60,98,111,100,121,62,32,116,97,103,10,0,0,0,0,0,0,0,0,65,116,116,114,105,98,117,116,101,32,37,115,32,114,101,100,101,102,105,110,101,100,10,0,104,116,109,108,80,97,114,115,101,83,116,97,114,116,84,97,103,58,32,112,114,111,98,108,101,109,32,112,97,114,115,105,110,103,32,97,116,116,114,105,98,117,116,101,115,10,0,0,104,116,116,112,45,101,113,117,105,118,0,0,0,0,0,0,67,111,110,116,101,110,116,45,84,121,112,101,0,0,0,0,99,111,110,116,101,110,116,0,101,114,114,111,114,32,112,97,114,115,105,110,103,32,97,116,116,114,105,98,117,116,101,32,110,97,109,101,10,0,0,0,65,116,116,86,97,108,117,101,58,32,34,32,101,120,112,101,99,116,101,100,10,0,0,0,65,116,116,86,97,108,117,101,58,32,39,32,101,120,112,101,99,116,101,100,10,0,0,0,65,116,116,86,97,108,117,101,58,32,110,111,32,118,97,108,117,101,32,102,111,117,110,100,10,0,0,0,0,0,0,0,103,114,111,119,105,110,103,32,98,117,102,102,101,114,10,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,32,58,32,37,115,10,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,10,0,0,0,0,0,0,0,113,117,111,116,0,0,0,0,113,117,111,116,97,116,105,111,110,32,109,97,114,107,32,61,32,65,80,76,32,113,117,111,116,101,44,32,85,43,48,48,50,50,32,73,83,79,110,117,109,0,0,0,0,0,0,0,97,109,112,0,0,0,0,0,97,109,112,101,114,115,97,110,100,44,32,85,43,48,48,50,54,32,73,83,79,110,117,109,0,0,0,0,0,0,0,0,97,112,111,115,0,0,0,0,115,105,110,103,108,101,32,113,117,111,116,101,0,0,0,0,108,116,0,0,0,0,0,0,108,101,115,115,45,116,104,97,110,32,115,105,103,110,44,32,85,43,48,48,51,67,32,73,83,79,110,117,109,0,0,0,103,116,0,0,0,0,0,0,103,114,101,97,116,101,114,45,116,104,97,110,32,115,105,103,110,44,32,85,43,48,48,51,69,32,73,83,79,110,117,109,0,0,0,0,0,0,0,0,110,98,115,112,0,0,0,0,110,111,45,98,114,101,97,107,32,115,112,97,99,101,32,61,32,110,111,110,45,98,114,101,97,107,105,110,103,32,115,112,97,99,101,44,32,85,43,48,48,65,48,32,73,83,79,110,117,109,0,0,0,0,0,0,105,101,120,99,108,0,0,0,105,110,118,101,114,116,101,100,32,101,120,99,108,97,109,97,116,105,111,110,32,109,97,114,107,44,32,85,43,48,48,65,49,32,73,83,79,110,117,109,0,0,0,0,0,0,0,0,99,101,110,116,0,0,0,0,99,101,110,116,32,115,105,103,110,44,32,85,43,48,48,65,50,32,73,83,79,110,117,109,0,0,0,0,0,0,0,0,112,111,117,110,100,0,0,0,112,111,117,110,100,32,115,105,103,110,44,32,85,43,48,48,65,51,32,73,83,79,110,117,109,0,0,0,0,0,0,0,99,117,114,114,101,110,0,0,99,117,114,114,101,110,99,121,32,115,105,103,110,44,32,85,43,48,48,65,52,32,73,83,79,110,117,109,0,0,0,0,121,101,110,0,0,0,0,0,121,101,110,32,115,105,103,110,32,61,32,121,117,97,110,32,115,105,103,110,44,32,85,43,48,48,65,53,32,73,83,79,110,117,109,0,0,0,0,0,98,114,118,98,97,114,0,0,98,114,111,107,101,110,32,98,97,114,32,61,32,98,114,111,107,101,110,32,118,101,114,116,105,99,97,108,32,98,97,114,44,32,85,43,48,48,65,54,32,73,83,79,110,117,109,0,115,101,99,116,0,0,0,0,115,101,99,116,105,111,110,32,115,105,103,110,44,32,85,43,48,48,65,55,32,73,83,79,110,117,109,0,0,0,0,0,117,109,108,0,0,0,0,0,100,105,97,101,114,101,115,105,115,32,61,32,115,112,97,99,105,110,103,32,100,105,97,101,114,101,115,105,115,44,32,85,43,48,48,65,56,32,73,83,79,100,105,97,0,0,0,0,99,111,112,121,0,0,0,0,99,111,112,121,114,105,103,104,116,32,115,105,103,110,44,32,85,43,48,48,65,57,32,73,83,79,110,117,109,0,0,0,111,114,100,102,0,0,0,0,102,101,109,105,110,105,110,101,32,111,114,100,105,110,97,108,32,105,110,100,105,99,97,116,111,114,44,32,85,43,48,48,65,65,32,73,83,79,110,117,109,0,0,0,0,0,0,0,108,97,113,117,111,0,0,0,108,101,102,116,45,112,111,105,110,116,105,110,103,32,100,111,117,98,108,101,32,97,110,103,108,101,32,113,117,111,116,97,116,105,111,110,32,109,97,114,107,32,61,32,108,101,102,116,32,112,111,105,110,116,105,110,103,32,103,117,105,108,108,101,109,101,116,44,32,85,43,48,48,65,66,32,73,83,79,110,117,109,0,0,0,0,0,0,110,111,116,0,0,0,0,0,110,111,116,32,115,105,103,110,44,32,85,43,48,48,65,67,32,73,83,79,110,117,109,0,115,104,121,0,0,0,0,0,115,111,102,116,32,104,121,112,104,101,110,32,61,32,100,105,115,99,114,101,116,105,111,110,97,114,121,32,104,121,112,104,101,110,44,32,85,43,48,48,65,68,32,73,83,79,110,117,109,0,0,0,0,0,0,0,114,101,103,0,0,0,0,0,114,101,103,105,115,116,101,114,101,100,32,115,105,103,110,32,61,32,114,101,103,105,115,116,101,114,101,100,32,116,114,97,100,101,32,109,97,114,107,32,115,105,103,110,44,32,85,43,48,48,65,69,32,73,83,79,110,117,109,0,0,0,0,0,109,97,99,114,0,0,0,0,109,97,99,114,111,110,32,61,32,115,112,97,99,105,110,103,32,109,97,99,114,111,110,32,61,32,111,118,101,114,108,105,110,101,32,61,32,65,80,76,32,111,118,101,114,98,97,114,44,32,85,43,48,48,65,70,32,73,83,79,100,105,97,0,100,101,103,0,0,0,0,0,100,101,103,114,101,101,32,115,105,103,110,44,32,85,43,48,48,66,48,32,73,83,79,110,117,109,0,0,0,0,0,0,112,108,117,115,109,110,0,0,112,108,117,115,45,109,105,110,117,115,32,115,105,103,110,32,61,32,112,108,117,115,45,111,114,45,109,105,110,117,115,32,115,105,103,110,44,32,85,43,48,48,66,49,32,73,83,79,110,117,109,0,0,0,0,0,115,117,112,50,0,0,0,0,115,117,112,101,114,115,99,114,105,112,116,32,116,119,111,32,61,32,115,117,112,101,114,115,99,114,105,112,116,32,100,105,103,105,116,32,116,119,111,32,61,32,115,113,117,97,114,101,100,44,32,85,43,48,48,66,50,32,73,83,79,110,117,109,0,0,0,0,0,0,0,0,115,117,112,51,0,0,0,0,115,117,112,101,114,115,99,114,105,112,116,32,116,104,114,101,101,32,61,32,115,117,112,101,114,115,99,114,105,112,116,32,100,105,103,105,116,32,116,104,114,101,101,32,61,32,99,117,98,101,100,44,32,85,43,48,48,66,51,32,73,83,79,110,117,109,0,0,0,0,0,0,97,99,117,116,101,0,0,0,97,99,117,116,101,32,97,99,99,101,110,116,32,61,32,115,112,97,99,105,110,103,32,97,99,117,116,101,44,32,85,43,48,48,66,52,32,73,83,79,100,105,97,0,0,0,0,0,109,105,99,114,111,0,0,0,109,105,99,114,111,32,115,105,103,110,44,32,85,43,48,48,66,53,32,73,83,79,110,117,109,0,0,0,0,0,0,0,112,97,114,97,0,0,0,0,112,105,108,99,114,111,119,32,115,105,103,110,32,61,32,112,97,114,97,103,114,97,112,104,32,115,105,103,110,44,32,85,43,48,48,66,54,32,73,83,79,110,117,109,0,0,0,0,109,105,100,100,111,116,0,0,109,105,100,100,108,101,32,100,111,116,32,61,32,71,101,111,114,103,105,97,110,32,99,111,109,109,97,32,71,114,101,101,107,32,109,105,100,100,108,101,32,100,111,116,44,32,85,43,48,48,66,55,32,73,83,79,110,117,109,0,0,0,0,0,99,101,100,105,108,0,0,0,99,101,100,105,108,108,97,32,61,32,115,112,97,99,105,110,103,32,99,101,100,105,108,108,97,44,32,85,43,48,48,66,56,32,73,83,79,100,105,97,0,0,0,0,0,0,0,0,115,117,112,49,0,0,0,0,115,117,112,101,114,115,99,114,105,112,116,32,111,110,101,32,61,32,115,117,112,101,114,115,99,114,105,112,116,32,100,105,103,105,116,32,111,110,101,44,32,85,43,48,48,66,57,32,73,83,79,110,117,109,0,0,111,114,100,109,0,0,0,0,109,97,115,99,117,108,105,110,101,32,111,114,100,105,110,97,108,32,105,110,100,105,99,97,116,111,114,44,32,85,43,48,48,66,65,32,73,83,79,110,117,109,0,0,0,0,0,0,114,97,113,117,111,0,0,0,114,105,103,104,116,45,112,111,105,110,116,105,110,103,32,100,111,117,98,108,101,32,97,110,103,108,101,32,113,117,111,116,97,116,105,111,110,32,109,97,114,107,32,114,105,103,104,116,32,112,111,105,110,116,105,110,103,32,103,117,105,108,108,101,109,101,116,44,32,85,43,48,48,66,66,32,73,83,79,110,117,109,0,0,0,0,0,0,102,114,97,99,49,52,0,0,118,117,108,103,97,114,32,102,114,97,99,116,105,111,110,32,111,110,101,32,113,117,97,114,116,101,114,32,61,32,102,114,97,99,116,105,111,110,32,111,110,101,32,113,117,97,114,116,101,114,44,32,85,43,48,48,66,67,32,73,83,79,110,117,109,0,0,0,0,0,0,0,102,114,97,99,49,50,0,0,118,117,108,103,97,114,32,102,114,97,99,116,105,111,110,32,111,110,101,32,104,97,108,102,32,61,32,102,114,97,99,116,105,111,110,32,111,110,101,32,104,97,108,102,44,32,85,43,48,48,66,68,32,73,83,79,110,117,109,0,0,0,0,0,102,114,97,99,51,52,0,0,118,117,108,103,97,114,32,102,114,97,99,116,105,111,110,32,116,104,114,101,101,32,113,117,97,114,116,101,114,115,32,61,32,102,114,97,99,116,105,111,110,32,116,104,114,101,101,32,113,117,97,114,116,101,114,115,44,32,85,43,48,48,66,69,32,73,83,79,110,117,109,0,105,113,117,101,115,116,0,0,105,110,118,101,114,116,101,100,32,113,117,101,115,116,105,111,110,32,109,97,114,107,32,61,32,116,117,114,110,101,100,32,113,117,101,115,116,105,111,110,32,109,97,114,107,44,32,85,43,48,48,66,70,32,73,83,79,110,117,109,0,0,0,0,65,103,114,97,118,101,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,65,32,119,105,116,104,32,103,114,97,118,101,32,61,32,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,65,32,103,114,97,118,101,44,32,85,43,48,48,67,48,32,73,83,79,108,97,116,49,0,0,0,0,0,0,0,0,65,97,99,117,116,101,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,65,32,119,105,116,104,32,97,99,117,116,101,44,32,85,43,48,48,67,49,32,73,83,79,108,97,116,49,0,0,0,0,0,0,0,65,99,105,114,99,0,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,65,32,119,105,116,104,32,99,105,114,99,117,109,102,108,101,120,44,32,85,43,48,48,67,50,32,73,83,79,108,97,116,49,0,0,65,116,105,108,100,101,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,65,32,119,105,116,104,32,116,105,108,100,101,44,32,85,43,48,48,67,51,32,73,83,79,108,97,116,49,0,0,0,0,0,0,0,65,117,109,108,0,0,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,65,32,119,105,116,104,32,100,105,97,101,114,101,115,105,115,44,32,85,43,48,48,67,52,32,73,83,79,108,97,116,49,0,0,0,65,114,105,110,103,0,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,65,32,119,105,116,104,32,114,105,110,103,32,97,98,111,118,101,32,61,32,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,65,32,114,105,110,103,44,32,85,43,48,48,67,53,32,73,83,79,108,97,116,49,0,0,0,0,65,69,108,105,103,0,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,65,69,32,61,32,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,105,103,97,116,117,114,101,32,65,69,44,32,85,43,48,48,67,54,32,73,83,79,108,97,116,49,0,0,0,0,0,67,99,101,100,105,108,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,67,32,119,105,116,104,32,99,101,100,105,108,108,97,44,32,85,43,48,48,67,55,32,73,83,79,108,97,116,49,0,0,0,0,0,69,103,114,97,118,101,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,69,32,119,105,116,104,32,103,114,97,118,101,44,32,85,43,48,48,67,56,32,73,83,79,108,97,116,49,0,0,0,0,0,0,0,69,97,99,117,116,101,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,69,32,119,105,116,104,32,97,99,117,116,101,44,32,85,43,48,48,67,57,32,73,83,79,108,97,116,49,0,0,0,0,0,0,0,69,99,105,114,99,0,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,69,32,119,105,116,104,32,99,105,114,99,117,109,102,108,101,120,44,32,85,43,48,48,67,65,32,73,83,79,108,97,116,49,0,0,69,117,109,108,0,0,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,69,32,119,105,116,104,32,100,105,97,101,114,101,115,105,115,44,32,85,43,48,48,67,66,32,73,83,79,108,97,116,49,0,0,0,73,103,114,97,118,101,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,73,32,119,105,116,104,32,103,114,97,118,101,44,32,85,43,48,48,67,67,32,73,83,79,108,97,116,49,0,0,0,0,0,0,0,73,97,99,117,116,101,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,73,32,119,105,116,104,32,97,99,117,116,101,44,32,85,43,48,48,67,68,32,73,83,79,108,97,116,49,0,0,0,0,0,0,0,73,99,105,114,99,0,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,73,32,119,105,116,104,32,99,105,114,99,117,109,102,108,101,120,44,32,85,43,48,48,67,69,32,73,83,79,108,97,116,49,0,0,73,117,109,108,0,0,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,73,32,119,105,116,104,32,100,105,97,101,114,101,115,105,115,44,32,85,43,48,48,67,70,32,73,83,79,108,97,116,49,0,0,0,69,84,72,0,0,0,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,69,84,72,44,32,85,43,48,48,68,48,32,73,83,79,108,97,116,49,0,0,0,0,0,0,0,0,78,116,105,108,100,101,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,78,32,119,105,116,104,32,116,105,108,100,101,44,32,85,43,48,48,68,49,32,73,83,79,108,97,116,49,0,0,0,0,0,0,0,79,103,114,97,118,101,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,79,32,119,105,116,104,32,103,114,97,118,101,44,32,85,43,48,48,68,50,32,73,83,79,108,97,116,49,0,0,0,0,0,0,0,79,97,99,117,116,101,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,79,32,119,105,116,104,32,97,99,117,116,101,44,32,85,43,48,48,68,51,32,73,83,79,108,97,116,49,0,0,0,0,0,0,0,79,99,105,114,99,0,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,79,32,119,105,116,104,32,99,105,114,99,117,109,102,108,101,120,44,32,85,43,48,48,68,52,32,73,83,79,108,97,116,49,0,0,79,116,105,108,100,101,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,79,32,119,105,116,104,32,116,105,108,100,101,44,32,85,43,48,48,68,53,32,73,83,79,108,97,116,49,0,0,0,0,0,0,0,79,117,109,108,0,0,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,79,32,119,105,116,104,32,100,105,97,101,114,101,115,105,115,44,32,85,43,48,48,68,54,32,73,83,79,108,97,116,49,0,0,0,116,105,109,101,115,0,0,0,109,117,108,116,105,112,108,105,99,97,116,105,111,110,32,115,105,103,110,44,32,85,43,48,48,68,55,32,73,83,79,110,117,109,0,0,0,0,0,0,79,115,108,97,115,104,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,79,32,119,105,116,104,32,115,116,114,111,107,101,32,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,79,32,115,108,97,115,104,44,32,85,43,48,48,68,56,32,73,83,79,108,97,116,49,0,85,103,114,97,118,101,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,85,32,119,105,116,104,32,103,114,97,118,101,44,32,85,43,48,48,68,57,32,73,83,79,108,97,116,49,0,0,0,0,0,0,0,85,97,99,117,116,101,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,85,32,119,105,116,104,32,97,99,117,116,101,44,32,85,43,48,48,68,65,32,73,83,79,108,97,116,49,0,0,0,0,0,0,0,85,99,105,114,99,0,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,85,32,119,105,116,104,32,99,105,114,99,117,109,102,108,101,120,44,32,85,43,48,48,68,66,32,73,83,79,108,97,116,49,0,0,85,117,109,108,0,0,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,85,32,119,105,116,104,32,100,105,97,101,114,101,115,105,115,44,32,85,43,48,48,68,67,32,73,83,79,108,97,116,49,0,0,0,89,97,99,117,116,101,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,89,32,119,105,116,104,32,97,99,117,116,101,44,32,85,43,48,48,68,68,32,73,83,79,108,97,116,49,0,0,0,0,0,0,0,84,72,79,82,78,0,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,84,72,79,82,78,44,32,85,43,48,48,68,69,32,73,83,79,108,97,116,49,0,0,0,0,0,0,115,122,108,105,103,0,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,115,104,97,114,112,32,115,32,61,32,101,115,115,45,122,101,100,44,32,85,43,48,48,68,70,32,73,83,79,108,97,116,49,0,0,0,0,97,103,114,97,118,101,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,97,32,119,105,116,104,32,103,114,97,118,101,32,61,32,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,97,32,103,114,97,118,101,44,32,85,43,48,48,69,48,32,73,83,79,108,97,116,49,0,0,0,0,97,97,99,117,116,101,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,97,32,119,105,116,104,32,97,99,117,116,101,44,32,85,43,48,48,69,49,32,73,83,79,108,97,116,49,0,97,99,105,114,99,0,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,97,32,119,105,116,104,32,99,105,114,99,117,109,102,108,101,120,44,32,85,43,48,48,69,50,32,73,83,79,108,97,116,49,0,0,0,0,97,116,105,108,100,101,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,97,32,119,105,116,104,32,116,105,108,100,101,44,32,85,43,48,48,69,51,32,73,83,79,108,97,116,49,0,97,117,109,108,0,0,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,97,32,119,105,116,104,32,100,105,97,101,114,101,115,105,115,44,32,85,43,48,48,69,52,32,73,83,79,108,97,116,49,0,0,0,0,0,97,114,105,110,103,0,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,97,32,119,105,116,104,32,114,105,110,103,32,97,98,111,118,101,32,61,32,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,97,32,114,105,110,103,44,32,85,43,48,48,69,53,32,73,83,79,108,97,116,49,0,0,0,0,0,0,0,0,97,101,108,105,103,0,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,97,101,32,61,32,108,97,116,105,110,32,115,109,97,108,108,32,108,105,103,97,116,117,114,101,32,97,101,44,32,85,43,48,48,69,54,32,73,83,79,108,97,116,49,0,99,99,101,100,105,108,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,99,32,119,105,116,104,32,99,101,100,105,108,108,97,44,32,85,43,48,48,69,55,32,73,83,79,108,97,116,49,0,0,0,0,0,0,0,101,103,114,97,118,101,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,101,32,119,105,116,104,32,103,114,97,118,101,44,32,85,43,48,48,69,56,32,73,83,79,108,97,116,49,0,101,97,99,117,116,101,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,101,32,119,105,116,104,32,97,99,117,116,101,44,32,85,43,48,48,69,57,32,73,83,79,108,97,116,49,0,101,99,105,114,99,0,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,101,32,119,105,116,104,32,99,105,114,99,117,109,102,108,101,120,44,32,85,43,48,48,69,65,32,73,83,79,108,97,116,49,0,0,0,0,101,117,109,108,0,0,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,101,32,119,105,116,104,32,100,105,97,101,114,101,115,105,115,44,32,85,43,48,48,69,66,32,73,83,79,108,97,116,49,0,0,0,0,0,105,103,114,97,118,101,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,105,32,119,105,116,104,32,103,114,97,118,101,44,32,85,43,48,48,69,67,32,73,83,79,108,97,116,49,0,105,97,99,117,116,101,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,105,32,119,105,116,104,32,97,99,117,116,101,44,32,85,43,48,48,69,68,32,73,83,79,108,97,116,49,0,105,99,105,114,99,0,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,105,32,119,105,116,104,32,99,105,114,99,117,109,102,108,101,120,44,32,85,43,48,48,69,69,32,73,83,79,108,97,116,49,0,0,0,0,105,117,109,108,0,0,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,105,32,119,105,116,104,32,100,105,97,101,114,101,115,105,115,44,32,85,43,48,48,69,70,32,73,83,79,108,97,116,49,0,0,0,0,0,101,116,104,0,0,0,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,101,116,104,44,32,85,43,48,48,70,48,32,73,83,79,108,97,116,49,0,0,110,116,105,108,100,101,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,110,32,119,105,116,104,32,116,105,108,100,101,44,32,85,43,48,48,70,49,32,73,83,79,108,97,116,49,0,111,103,114,97,118,101,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,111,32,119,105,116,104,32,103,114,97,118,101,44,32,85,43,48,48,70,50,32,73,83,79,108,97,116,49,0,111,97,99,117,116,101,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,111,32,119,105,116,104,32,97,99,117,116,101,44,32,85,43,48,48,70,51,32,73,83,79,108,97,116,49,0,111,99,105,114,99,0,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,111,32,119,105,116,104,32,99,105,114,99,117,109,102,108,101,120,44,32,85,43,48,48,70,52,32,73,83,79,108,97,116,49,0,0,0,0,111,116,105,108,100,101,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,111,32,119,105,116,104,32,116,105,108,100,101,44,32,85,43,48,48,70,53,32,73,83,79,108,97,116,49,0,111,117,109,108,0,0,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,111,32,119,105,116,104,32,100,105,97,101,114,101,115,105,115,44,32,85,43,48,48,70,54,32,73,83,79,108,97,116,49,0,0,0,0,0,100,105,118,105,100,101,0,0,100,105,118,105,115,105,111,110,32,115,105,103,110,44,32,85,43,48,48,70,55,32,73,83,79,110,117,109,0,0,0,0,111,115,108,97,115,104,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,111,32,119,105,116,104,32,115,116,114,111,107,101,44,32,61,32,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,111,32,115,108,97,115,104,44,32,85,43,48,48,70,56,32,73,83,79,108,97,116,49,0,0,117,103,114,97,118,101,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,117,32,119,105,116,104,32,103,114,97,118,101,44,32,85,43,48,48,70,57,32,73,83,79,108,97,116,49,0,117,97,99,117,116,101,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,117,32,119,105,116,104,32,97,99,117,116,101,44,32,85,43,48,48,70,65,32,73,83,79,108,97,116,49,0,117,99,105,114,99,0,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,117,32,119,105,116,104,32,99,105,114,99,117,109,102,108,101,120,44,32,85,43,48,48,70,66,32,73,83,79,108,97,116,49,0,0,0,0,117,117,109,108,0,0,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,117,32,119,105,116,104,32,100,105,97,101,114,101,115,105,115,44,32,85,43,48,48,70,67,32,73,83,79,108,97,116,49,0,0,0,0,0,121,97,99,117,116,101,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,121,32,119,105,116,104,32,97,99,117,116,101,44,32,85,43,48,48,70,68,32,73,83,79,108,97,116,49,0,116,104,111,114,110,0,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,116,104,111,114,110,32,119,105,116,104,44,32,85,43,48,48,70,69,32,73,83,79,108,97,116,49,0,0,0,121,117,109,108,0,0,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,121,32,119,105,116,104,32,100,105,97,101,114,101,115,105,115,44,32,85,43,48,48,70,70,32,73,83,79,108,97,116,49,0,0,0,0,0,79,69,108,105,103,0,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,105,103,97,116,117,114,101,32,79,69,44,32,85,43,48,49,53,50,32,73,83,79,108,97,116,50,0,0,0,0,0,0,0,111,101,108,105,103,0,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,105,103,97,116,117,114,101,32,111,101,44,32,85,43,48,49,53,51,32,73,83,79,108,97,116,50,0,83,99,97,114,111,110,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,83,32,119,105,116,104,32,99,97,114,111,110,44,32,85,43,48,49,54,48,32,73,83,79,108,97,116,50,0,0,0,0,0,0,0,115,99,97,114,111,110,0,0,108,97,116,105,110,32,115,109,97,108,108,32,108,101,116,116,101,114,32,115,32,119,105,116,104,32,99,97,114,111,110,44,32,85,43,48,49,54,49,32,73,83,79,108,97,116,50,0,89,117,109,108,0,0,0,0,108,97,116,105,110,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,89,32,119,105,116,104,32,100,105,97,101,114,101,115,105,115,44,32,85,43,48,49,55,56,32,73,83,79,108,97,116,50,0,0,0,102,110,111,102,0,0,0,0,108,97,116,105,110,32,115,109,97,108,108,32,102,32,119,105,116,104,32,104,111,111,107,32,61,32,102,117,110,99,116,105,111,110,32,61,32,102,108,111,114,105,110,44,32,85,43,48,49,57,50,32,73,83,79,116,101,99,104,0,0,0,0,0,99,105,114,99,0,0,0,0,109,111,100,105,102,105,101,114,32,108,101,116,116,101,114,32,99,105,114,99,117,109,102,108,101,120,32,97,99,99,101,110,116,44,32,85,43,48,50,67,54,32,73,83,79,112,117,98,0,0,0,0,0,0,0,0,116,105,108,100,101,0,0,0,115,109,97,108,108,32,116,105,108,100,101,44,32,85,43,48,50,68,67,32,73,83,79,100,105,97,0,0,0,0,0,0,65,108,112,104,97,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,97,108,112,104,97,44,32,85,43,48,51,57,49,0,0,0,0,0,0,66,101,116,97,0,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,98,101,116,97,44,32,85,43,48,51,57,50,0,0,0,0,0,0,0,71,97,109,109,97,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,103,97,109,109,97,44,32,85,43,48,51,57,51,32,73,83,79,103,114,107,51,0,0,0,0,0,0,68,101,108,116,97,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,100,101,108,116,97,44,32,85,43,48,51,57,52,32,73,83,79,103,114,107,51,0,0,0,0,0,0,69,112,115,105,108,111,110,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,101,112,115,105,108,111,110,44,32,85,43,48,51,57,53,0,0,0,0,90,101,116,97,0,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,122,101,116,97,44,32,85,43,48,51,57,54,0,0,0,0,0,0,0,69,116,97,0,0,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,101,116,97,44,32,85,43,48,51,57,55,0,0,0,0,0,0,0,0,84,104,101,116,97,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,116,104,101,116,97,44,32,85,43,48,51,57,56,32,73,83,79,103,114,107,51,0,0,0,0,0,0,73,111,116,97,0,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,105,111,116,97,44,32,85,43,48,51,57,57,0,0,0,0,0,0,0,75,97,112,112,97,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,107,97,112,112,97,44,32,85,43,48,51,57,65,0,0,0,0,0,0,76,97,109,98,100,97,0,0,103,114,101,101,107,32,99,97],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+95088),
allocate([112,105,116,97,108,32,108,101,116,116,101,114,32,108,97,109,98,100,97,44,32,85,43,48,51,57,66,32,73,83,79,103,114,107,51,0,0,0,0,0,77,117,0,0,0,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,109,117,44,32,85,43,48,51,57,67,0,78,117,0,0,0,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,110,117,44,32,85,43,48,51,57,68,0,88,105,0,0,0,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,120,105,44,32,85,43,48,51,57,69,32,73,83,79,103,114,107,51,0,79,109,105,99,114,111,110,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,111,109,105,99,114,111,110,44,32,85,43,48,51,57,70,0,0,0,0,80,105,0,0,0,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,112,105,44,32,85,43,48,51,65,48,32,73,83,79,103,114,107,51,0,82,104,111,0,0,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,114,104,111,44,32,85,43,48,51,65,49,0,0,0,0,0,0,0,0,83,105,103,109,97,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,115,105,103,109,97,44,32,85,43,48,51,65,51,32,73,83,79,103,114,107,51,0,0,0,0,0,0,84,97,117,0,0,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,116,97,117,44,32,85,43,48,51,65,52,0,0,0,0,0,0,0,0,85,112,115,105,108,111,110,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,117,112,115,105,108,111,110,44,32,85,43,48,51,65,53,32,73,83,79,103,114,107,51,0,0,0,0,80,104,105,0,0,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,112,104,105,44,32,85,43,48,51,65,54,32,73,83,79,103,114,107,51,0,0,0,0,0,0,0,0,67,104,105,0,0,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,99,104,105,44,32,85,43,48,51,65,55,0,0,0,0,0,0,0,0,80,115,105,0,0,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,112,115,105,44,32,85,43,48,51,65,56,32,73,83,79,103,114,107,51,0,0,0,0,0,0,0,0,79,109,101,103,97,0,0,0,103,114,101,101,107,32,99,97,112,105,116,97,108,32,108,101,116,116,101,114,32,111,109,101,103,97,44,32,85,43,48,51,65,57,32,73,83,79,103,114,107,51,0,0,0,0,0,0,97,108,112,104,97,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,97,108,112,104,97,44,32,85,43,48,51,66,49,32,73,83,79,103,114,107,51,0,0,0,0,0,0,0,0,98,101,116,97,0,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,98,101,116,97,44,32,85,43,48,51,66,50,32,73,83,79,103,114,107,51,0,103,97,109,109,97,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,103,97,109,109,97,44,32,85,43,48,51,66,51,32,73,83,79,103,114,107,51,0,0,0,0,0,0,0,0,100,101,108,116,97,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,100,101,108,116,97,44,32,85,43,48,51,66,52,32,73,83,79,103,114,107,51,0,0,0,0,0,0,0,0,101,112,115,105,108,111,110,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,101,112,115,105,108,111,110,44,32,85,43,48,51,66,53,32,73,83,79,103,114,107,51,0,0,0,0,0,0,122,101,116,97,0,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,122,101,116,97,44,32,85,43,48,51,66,54,32,73,83,79,103,114,107,51,0,101,116,97,0,0,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,101,116,97,44,32,85,43,48,51,66,55,32,73,83,79,103,114,107,51,0,0,116,104,101,116,97,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,116,104,101,116,97,44,32,85,43,48,51,66,56,32,73,83,79,103,114,107,51,0,0,0,0,0,0,0,0,105,111,116,97,0,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,105,111,116,97,44,32,85,43,48,51,66,57,32,73,83,79,103,114,107,51,0,107,97,112,112,97,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,107,97,112,112,97,44,32,85,43,48,51,66,65,32,73,83,79,103,114,107,51,0,0,0,0,0,0,0,0,108,97,109,98,100,97,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,108,97,109,98,100,97,44,32,85,43,48,51,66,66,32,73,83,79,103,114,107,51,0,0,0,0,0,0,0,109,117,0,0,0,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,109,117,44,32,85,43,48,51,66,67,32,73,83,79,103,114,107,51,0,0,0,110,117,0,0,0,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,110,117,44,32,85,43,48,51,66,68,32,73,83,79,103,114,107,51,0,0,0,120,105,0,0,0,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,120,105,44,32,85,43,48,51,66,69,32,73,83,79,103,114,107,51,0,0,0,111,109,105,99,114,111,110,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,111,109,105,99,114,111,110,44,32,85,43,48,51,66,70,32,78,69,87,0,0,112,105,0,0,0,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,112,105,44,32,85,43,48,51,67,48,32,73,83,79,103,114,107,51,0,0,0,114,104,111,0,0,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,114,104,111,44,32,85,43,48,51,67,49,32,73,83,79,103,114,107,51,0,0,115,105,103,109,97,102,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,102,105,110,97,108,32,115,105,103,109,97,44,32,85,43,48,51,67,50,32,73,83,79,103,114,107,51,0,0,115,105,103,109,97,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,115,105,103,109,97,44,32,85,43,48,51,67,51,32,73,83,79,103,114,107,51,0,0,0,0,0,0,0,0,116,97,117,0,0,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,116,97,117,44,32,85,43,48,51,67,52,32,73,83,79,103,114,107,51,0,0,117,112,115,105,108,111,110,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,117,112,115,105,108,111,110,44,32,85,43,48,51,67,53,32,73,83,79,103,114,107,51,0,0,0,0,0,0,112,104,105,0,0,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,112,104,105,44,32,85,43,48,51,67,54,32,73,83,79,103,114,107,51,0,0,99,104,105,0,0,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,99,104,105,44,32,85,43,48,51,67,55,32,73,83,79,103,114,107,51,0,0,112,115,105,0,0,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,112,115,105,44,32,85,43,48,51,67,56,32,73,83,79,103,114,107,51,0,0,111,109,101,103,97,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,111,109,101,103,97,44,32,85,43,48,51,67,57,32,73,83,79,103,114,107,51,0,0,0,0,0,0,0,0,116,104,101,116,97,115,121,109,0,0,0,0,0,0,0,0,103,114,101,101,107,32,115,109,97,108,108,32,108,101,116,116,101,114,32,116,104,101,116,97,32,115,121,109,98,111,108,44,32,85,43,48,51,68,49,32,78,69,87,0,0,0,0,0,117,112,115,105,104,0,0,0,103,114,101,101,107,32,117,112,115,105,108,111,110,32,119,105,116,104,32,104,111,111,107,32,115,121,109,98,111,108,44,32,85,43,48,51,68,50,32,78,69,87,0,0,0,0,0,0,112,105,118,0,0,0,0,0,103,114,101,101,107,32,112,105,32,115,121,109,98,111,108,44,32,85,43,48,51,68,54,32,73,83,79,103,114,107,51,0,101,110,115,112,0,0,0,0,101,110,32,115,112,97,99,101,44,32,85,43,50,48,48,50,32,73,83,79,112,117,98,0,101,109,115,112,0,0,0,0,101,109,32,115,112,97,99,101,44,32,85,43,50,48,48,51,32,73,83,79,112,117,98,0,116,104,105,110,115,112,0,0,116,104,105,110,32,115,112,97,99,101,44,32,85,43,50,48,48,57,32,73,83,79,112,117,98,0,0,0,0,0,0,0,122,119,110,106,0,0,0,0,122,101,114,111,32,119,105,100,116,104,32,110,111,110,45,106,111,105,110,101,114,44,32,85,43,50,48,48,67,32,78,69,87,32,82,70,67,32,50,48,55,48,0,0,0,0,0,0,122,119,106,0,0,0,0,0,122,101,114,111,32,119,105,100,116,104,32,106,111,105,110,101,114,44,32,85,43,50,48,48,68,32,78,69,87,32,82,70,67,32,50,48,55,48,0,0,108,114,109,0,0,0,0,0,108,101,102,116,45,116,111,45,114,105,103,104,116,32,109,97,114,107,44,32,85,43,50,48,48,69,32,78,69,87,32,82,70,67,32,50,48,55,48,0,114,108,109,0,0,0,0,0,114,105,103,104,116,45,116,111,45,108,101,102,116,32,109,97,114,107,44,32,85,43,50,48,48,70,32,78,69,87,32,82,70,67,32,50,48,55,48,0,110,100,97,115,104,0,0,0,101,110,32,100,97,115,104,44,32,85,43,50,48,49,51,32,73,83,79,112,117,98,0,0,109,100,97,115,104,0,0,0,101,109,32,100,97,115,104,44,32,85,43,50,48,49,52,32,73,83,79,112,117,98,0,0,108,115,113,117,111,0,0,0,108,101,102,116,32,115,105,110,103,108,101,32,113,117,111,116,97,116,105,111,110,32,109,97,114,107,44,32,85,43,50,48,49,56,32,73,83,79,110,117,109,0,0,0,0,0,0,0,114,115,113,117,111,0,0,0,114,105,103,104,116,32,115,105,110,103,108,101,32,113,117,111,116,97,116,105,111,110,32,109,97,114,107,44,32,85,43,50,48,49,57,32,73,83,79,110,117,109,0,0,0,0,0,0,115,98,113,117,111,0,0,0,115,105,110,103,108,101,32,108,111,119,45,57,32,113,117,111,116,97,116,105,111,110,32,109,97,114,107,44,32,85,43,50,48,49,65,32,78,69,87,0,108,100,113,117,111,0,0,0,108,101,102,116,32,100,111,117,98,108,101,32,113,117,111,116,97,116,105,111,110,32,109,97,114,107,44,32,85,43,50,48,49,67,32,73,83,79,110,117,109,0,0,0,0,0,0,0,114,100,113,117,111,0,0,0,114,105,103,104,116,32,100,111,117,98,108,101,32,113,117,111,116,97,116,105,111,110,32,109,97,114,107,44,32,85,43,50,48,49,68,32,73,83,79,110,117,109,0,0,0,0,0,0,98,100,113,117,111,0,0,0,100,111,117,98,108,101,32,108,111,119,45,57,32,113,117,111,116,97,116,105,111,110,32,109,97,114,107,44,32,85,43,50,48,49,69,32,78,69,87,0,100,97,103,103,101,114,0,0,100,97,103,103,101,114,44,32,85,43,50,48,50,48,32,73,83,79,112,117,98,0,0,0,68,97,103,103,101,114,0,0,100,111,117,98,108,101,32,100,97,103,103,101,114,44,32,85,43,50,48,50,49,32,73,83,79,112,117,98,0,0,0,0,98,117,108,108,0,0,0,0,98,117,108,108,101,116,32,61,32,98,108,97,99,107,32,115,109,97,108,108,32,99,105,114,99,108,101,44,32,85,43,50,48,50,50,32,73,83,79,112,117,98,0,0,0,0,0,0,104,101,108,108,105,112,0,0,104,111,114,105,122,111,110,116,97,108,32,101,108,108,105,112,115,105,115,32,61,32,116,104,114,101,101,32,100,111,116,32,108,101,97,100,101,114,44,32,85,43,50,48,50,54,32,73,83,79,112,117,98,0,0,0,112,101,114,109,105,108,0,0,112,101,114,32,109,105,108,108,101,32,115,105,103,110,44,32,85,43,50,48,51,48,32,73,83,79,116,101,99,104,0,0,112,114,105,109,101,0,0,0,112,114,105,109,101,32,61,32,109,105,110,117,116,101,115,32,61,32,102,101,101,116,44,32,85,43,50,48,51,50,32,73,83,79,116,101,99,104,0,0,80,114,105,109,101,0,0,0,100,111,117,98,108,101,32,112,114,105,109,101,32,61,32,115,101,99,111,110,100,115,32,61,32,105,110,99,104,101,115,44,32,85,43,50,48,51,51,32,73,83,79,116,101,99,104,0,108,115,97,113,117,111,0,0,115,105,110,103,108,101,32,108,101,102,116,45,112,111,105,110,116,105,110,103,32,97,110,103,108,101,32,113,117,111,116,97,116,105,111,110,32,109,97,114,107,44,32,85,43,50,48,51,57,32,73,83,79,32,112,114,111,112,111,115,101,100,0,0,114,115,97,113,117,111,0,0,115,105,110,103,108,101,32,114,105,103,104,116,45,112,111,105,110,116,105,110,103,32,97,110,103,108,101,32,113,117,111,116,97,116,105,111,110,32,109,97,114,107,44,32,85,43,50,48,51,65,32,73,83,79,32,112,114,111,112,111,115,101,100,0,111,108,105,110,101,0,0,0,111,118,101,114,108,105,110,101,32,61,32,115,112,97,99,105,110,103,32,111,118,101,114,115,99,111,114,101,44,32,85,43,50,48,51,69,32,78,69,87,0,0,0,0,0,0,0,0,102,114,97,115,108,0,0,0,102,114,97,99,116,105,111,110,32,115,108,97,115,104,44,32,85,43,50,48,52,52,32,78,69,87,0,0,0,0,0,0,101,117,114,111,0,0,0,0,101,117,114,111,32,115,105,103,110,44,32,85,43,50,48,65,67,32,78,69,87,0,0,0,105,109,97,103,101,0,0,0,98,108,97,99,107,108,101,116,116,101,114,32,99,97,112,105,116,97,108,32,73,32,61,32,105,109,97,103,105,110,97,114,121,32,112,97,114,116,44,32,85,43,50,49,49,49,32,73,83,79,97,109,115,111,0,0,119,101,105,101,114,112,0,0,115,99,114,105,112,116,32,99,97,112,105,116,97,108,32,80,32,61,32,112,111,119,101,114,32,115,101,116,32,61,32,87,101,105,101,114,115,116,114,97,115,115,32,112,44,32,85,43,50,49,49,56,32,73,83,79,97,109,115,111,0,0,0,0,114,101,97,108,0,0,0,0,98,108,97,99,107,108,101,116,116,101,114,32,99,97,112,105,116,97,108,32,82,32,61,32,114,101,97,108,32,112,97,114,116,32,115,121,109,98,111,108,44,32,85,43,50,49,49,67,32,73,83,79,97,109,115,111,0,0,0,0,0,0,0,0,116,114,97,100,101,0,0,0,116,114,97,100,101,32,109,97,114,107,32,115,105,103,110,44,32,85,43,50,49,50,50,32,73,83,79,110,117,109,0,0,97,108,101,102,115,121,109,0,97,108,101,102,32,115,121,109,98,111,108,32,61,32,102,105,114,115,116,32,116,114,97,110,115,102,105,110,105,116,101,32,99,97,114,100,105,110,97,108,44,32,85,43,50,49,51,53,32,78,69,87,0,0,0,0,108,97,114,114,0,0,0,0,108,101,102,116,119,97,114,100,115,32,97,114,114,111,119,44,32,85,43,50,49,57,48,32,73,83,79,110,117,109,0,0,117,97,114,114,0,0,0,0,117,112,119,97,114,100,115,32,97,114,114,111,119,44,32,85,43,50,49,57,49,32,73,83,79,110,117,109,0,0,0,0,114,97,114,114,0,0,0,0,114,105,103,104,116,119,97,114,100,115,32,97,114,114,111,119,44,32,85,43,50,49,57,50,32,73,83,79,110,117,109,0,100,97,114,114,0,0,0,0,100,111,119,110,119,97,114,100,115,32,97,114,114,111,119,44,32,85,43,50,49,57,51,32,73,83,79,110,117,109,0,0,104,97,114,114,0,0,0,0,108,101,102,116,32,114,105,103,104,116,32,97,114,114,111,119,44,32,85,43,50,49,57,52,32,73,83,79,97,109,115,97,0,0,0,0,0,0,0,0,99,114,97,114,114,0,0,0,100,111,119,110,119,97,114,100,115,32,97,114,114,111,119,32,119,105,116,104,32,99,111,114,110,101,114,32,108,101,102,116,119,97,114,100,115,32,61,32,99,97,114,114,105,97,103,101,32,114,101,116,117,114,110,44,32,85,43,50,49,66,53,32,78,69,87,0,0,0,0,0,108,65,114,114,0,0,0,0,108,101,102,116,119,97,114,100,115,32,100,111,117,98,108,101,32,97,114,114,111,119,44,32,85,43,50,49,68,48,32,73,83,79,116,101,99,104,0,0,117,65,114,114,0,0,0,0,117,112,119,97,114,100,115,32,100,111,117,98,108,101,32,97,114,114,111,119,44,32,85,43,50,49,68,49,32,73,83,79,97,109,115,97,0,0,0,0,114,65,114,114,0,0,0,0,114,105,103,104,116,119,97,114,100,115,32,100,111,117,98,108,101,32,97,114,114,111,119,44,32,85,43,50,49,68,50,32,73,83,79,116,101,99,104,0,100,65,114,114,0,0,0,0,100,111,119,110,119,97,114,100,115,32,100,111,117,98,108,101,32,97,114,114,111,119,44,32,85,43,50,49,68,51,32,73,83,79,97,109,115,97,0,0,104,65,114,114,0,0,0,0,108,101,102,116,32,114,105,103,104,116,32,100,111,117,98,108,101,32,97,114,114,111,119,44,32,85,43,50,49,68,52,32,73,83,79,97,109,115,97,0,102,111,114,97,108,108,0,0,102,111,114,32,97,108,108,44,32,85,43,50,50,48,48,32,73,83,79,116,101,99,104,0,112,97,114,116,0,0,0,0,112,97,114,116,105,97,108,32,100,105,102,102,101,114,101,110,116,105,97,108,44,32,85,43,50,50,48,50,32,73,83,79,116,101,99,104,0,0,0,0,101,120,105,115,116,0,0,0,116,104,101,114,101,32,101,120,105,115,116,115,44,32,85,43,50,50,48,51,32,73,83,79,116,101,99,104,0,0,0,0,101,109,112,116,121,0,0,0,101,109,112,116,121,32,115,101,116,32,61,32,110,117,108,108,32,115,101,116,32,61,32,100,105,97,109,101,116,101,114,44,32,85,43,50,50,48,53,32,73,83,79,97,109,115,111,0,110,97,98,108,97,0,0,0,110,97,98,108,97,32,61,32,98,97,99,107,119,97,114,100,32,100,105,102,102,101,114,101,110,99,101,44,32,85,43,50,50,48,55,32,73,83,79,116,101,99,104,0,0,0,0,0,105,115,105,110,0,0,0,0,101,108,101,109,101,110,116,32,111,102,44,32,85,43,50,50,48,56,32,73,83,79,116,101,99,104,0,0,0,0,0,0,110,111,116,105,110,0,0,0,110,111,116,32,97,110,32,101,108,101,109,101,110,116,32,111,102,44,32,85,43,50,50,48,57,32,73,83,79,116,101,99,104,0,0,0,0,0,0,0,110,105,0,0,0,0,0,0,99,111,110,116,97,105,110,115,32,97,115,32,109,101,109,98,101,114,44,32,85,43,50,50,48,66,32,73,83,79,116,101,99,104,0,0,0,0,0,0,112,114,111,100,0,0,0,0,110,45,97,114,121,32,112,114,111,100,117,99,116,32,61,32,112,114,111,100,117,99,116,32,115,105,103,110,44,32,85,43,50,50,48,70,32,73,83,79,97,109,115,98,0,0,0,0,115,117,109,0,0,0,0,0,110,45,97,114,121,32,115,117,109,109,97,116,105,111,110,44,32,85,43,50,50,49,49,32,73,83,79,97,109,115,98,0,109,105,110,117,115,0,0,0,109,105,110,117,115,32,115,105,103,110,44,32,85,43,50,50,49,50,32,73,83,79,116,101,99,104,0,0,0,0,0,0,108,111,119,97,115,116,0,0,97,115,116,101,114,105,115,107,32,111,112,101,114,97,116,111,114,44,32,85,43,50,50,49,55,32,73,83,79,116,101,99,104,0,0,0,0,0,0,0,114,97,100,105,99,0,0,0,115,113,117,97,114,101,32,114,111,111,116,32,61,32,114,97,100,105,99,97,108,32,115,105,103,110,44,32,85,43,50,50,49,65,32,73,83,79,116,101,99,104,0,0,0,0,0,0,112,114,111,112,0,0,0,0,112,114,111,112,111,114,116,105,111,110,97,108,32,116,111,44,32,85,43,50,50,49,68,32,73,83,79,116,101,99,104,0,105,110,102,105,110,0,0,0,105,110,102,105,110,105,116,121,44,32,85,43,50,50,49,69,32,73,83,79,116,101,99,104,0,0,0,0,0,0,0,0,97,110,103,0,0,0,0,0,97,110,103,108,101,44,32,85,43,50,50,50,48,32,73,83,79,97,109,115,111,0,0,0,97,110,100,0,0,0,0,0,108,111,103,105,99,97,108,32,97,110,100,32,61,32,119,101,100,103,101,44,32,85,43,50,50,50,55,32,73,83,79,116,101,99,104,0,0,0,0,0,111,114,0,0,0,0,0,0,108,111,103,105,99,97,108,32,111,114,32,61,32,118,101,101,44,32,85,43,50,50,50,56,32,73,83,79,116,101,99,104,0,0,0,0,0,0,0,0,99,97,112,0,0,0,0,0,105,110,116,101,114,115,101,99,116,105,111,110,32,61,32,99,97,112,44,32,85,43,50,50,50,57,32,73,83,79,116,101,99,104,0,0,0,0,0,0,99,117,112,0,0,0,0,0,117,110,105,111,110,32,61,32,99,117,112,44,32,85,43,50,50,50,65,32,73,83,79,116,101,99,104,0,0,0,0,0,105,110,116,0,0,0,0,0,105,110,116,101,103,114,97,108,44,32,85,43,50,50,50,66,32,73,83,79,116,101,99,104,0,0,0,0,0,0,0,0,116,104,101,114,101,52,0,0,116,104,101,114,101,102,111,114,101,44,32,85,43,50,50,51,52,32,73,83,79,116,101,99,104,0,0,0,0,0,0,0,115,105,109,0,0,0,0,0,116,105,108,100,101,32,111,112,101,114,97,116,111,114,32,61,32,118,97,114,105,101,115,32,119,105,116,104,32,61,32,115,105,109,105,108,97,114,32,116,111,44,32,85,43,50,50,51,67,32,73,83,79,116,101,99,104,0,0,0,0,0,0,0,99,111,110,103,0,0,0,0,97,112,112,114,111,120,105,109,97,116,101,108,121,32,101,113,117,97,108,32,116,111,44,32,85,43,50,50,52,53,32,73,83,79,116,101,99,104,0,0,97,115,121,109,112,0,0,0,97,108,109,111,115,116,32,101,113,117,97,108,32,116,111,32,61,32,97,115,121,109,112,116,111,116,105,99,32,116,111,44,32,85,43,50,50,52,56,32,73,83,79,97,109,115,114,0,110,101,0,0,0,0,0,0,110,111,116,32,101,113,117,97,108,32,116,111,44,32,85,43,50,50,54,48,32,73,83,79,116,101,99,104,0,0,0,0,101,113,117,105,118,0,0,0,105,100,101,110,116,105,99,97,108,32,116,111,44,32,85,43,50,50,54,49,32,73,83,79,116,101,99,104,0,0,0,0,108,101,0,0,0,0,0,0,108,101,115,115,45,116,104,97,110,32,111,114,32,101,113,117,97,108,32,116,111,44,32,85,43,50,50,54,52,32,73,83,79,116,101,99,104,0,0,0,103,101,0,0,0,0,0,0,103,114,101,97,116,101,114,45,116,104,97,110,32,111,114,32,101,113,117,97,108,32,116,111,44,32,85,43,50,50,54,53,32,73,83,79,116,101,99,104,0,0,0,0,0,0,0,0,115,117,98,0,0,0,0,0,115,117,98,115,101,116,32,111,102,44,32,85,43,50,50,56,50,32,73,83,79,116,101,99,104,0,0,0,0,0,0,0,115,117,112,0,0,0,0,0,115,117,112,101,114,115,101,116,32,111,102,44,32,85,43,50,50,56,51,32,73,83,79,116,101,99,104,0,0,0,0,0,110,115,117,98,0,0,0,0,110,111,116,32,97,32,115,117,98,115,101,116,32,111,102,44,32,85,43,50,50,56,52,32,73,83,79,97,109,115,110,0,115,117,98,101,0,0,0,0,115,117,98,115,101,116,32,111,102,32,111,114,32,101,113,117,97,108,32,116,111,44,32,85,43,50,50,56,54,32,73,83,79,116,101,99,104,0,0,0,115,117,112,101,0,0,0,0,115,117,112,101,114,115,101,116,32,111,102,32,111,114,32,101,113,117,97,108,32,116,111,44,32,85,43,50,50,56,55,32,73,83,79,116,101,99,104,0,111,112,108,117,115,0,0,0,99,105,114,99,108,101,100,32,112,108,117,115,32,61,32,100,105,114,101,99,116,32,115,117,109,44,32,85,43,50,50,57,53,32,73,83,79,97,109,115,98,0,0,0,0,0,0,0,111,116,105,109,101,115,0,0,99,105,114,99,108,101,100,32,116,105,109,101,115,32,61,32,118,101,99,116,111,114,32,112,114,111,100,117,99,116,44,32,85,43,50,50,57,55,32,73,83,79,97,109,115,98,0,0,112,101,114,112,0,0,0,0,117,112,32,116,97,99,107,32,61,32,111,114,116,104,111,103,111,110,97,108,32,116,111,32,61,32,112,101,114,112,101,110,100,105,99,117,108,97,114,44,32,85,43,50,50,65,53,32,73,83,79,116,101,99,104,0,115,100,111,116,0,0,0,0,100,111,116,32,111,112,101,114,97,116,111,114,44,32,85,43,50,50,67,53,32,73,83,79,97,109,115,98,0,0,0,0,108,99,101,105,108,0,0,0,108,101,102,116,32,99,101,105,108,105,110,103,32,61,32,97,112,108,32,117,112,115,116,105,108,101,44,32,85,43,50,51,48,56,32,73,83,79,97,109,115,99,0,0,0,0,0,0,114,99,101,105,108,0,0,0,114,105,103,104,116,32,99,101,105,108,105,110,103,44,32,85,43,50,51,48,57,32,73,83,79,97,109,115,99,0,0,0,108,102,108,111,111,114,0,0,108,101,102,116,32,102,108,111,111,114,32,61,32,97,112,108,32,100,111,119,110,115,116,105,108,101,44,32,85,43,50,51,48,65,32,73,83,79,97,109,115,99,0,0,0,0,0,0,114,102,108,111,111,114,0,0,114,105,103,104,116,32,102,108,111,111,114,44,32,85,43,50,51,48,66,32,73,83,79,97,109,115,99,0,0,0,0,0,108,97,110,103,0,0,0,0,108,101,102,116,45,112,111,105,110,116,105,110,103,32,97,110,103,108,101,32,98,114,97,99,107,101,116,32,61,32,98,114,97,44,32,85,43,50,51,50,57,32,73,83,79,116,101,99,104,0,0,0,0,0,0,0,114,97,110,103,0,0,0,0,114,105,103,104,116,45,112,111,105,110,116,105,110,103,32,97,110,103,108,101,32,98,114,97,99,107,101,116,32,61,32,107,101,116,44,32,85,43,50,51,50,65,32,73,83,79,116,101,99,104,0,0,0,0,0,0,108,111,122,0,0,0,0,0,108,111,122,101,110,103,101,44,32,85,43,50,53,67,65,32,73,83,79,112,117,98,0,0,115,112,97,100,101,115,0,0,98,108,97,99,107,32,115,112,97,100,101,32,115,117,105,116,44,32,85,43,50,54,54,48,32,73,83,79,112,117,98,0,99,108,117,98,115,0,0,0,98,108,97,99,107,32,99,108,117,98,32,115,117,105,116,32,61,32,115,104,97,109,114,111,99,107,44,32,85,43,50,54,54,51,32,73,83,79,112,117,98,0,0,0,0,0,0,0,104,101,97,114,116,115,0,0,98,108,97,99,107,32,104,101,97,114,116,32,115,117,105,116,32,61,32,118,97,108,101,110,116,105,110,101,44,32,85,43,50,54,54,53,32,73,83,79,112,117,98,0,0,0,0,0,100,105,97,109,115,0,0,0,98,108,97,99,107,32,100,105,97,109,111,110,100,32,115,117,105,116,44,32,85,43,50,54,54,54,32,73,83,79,112,117,98,0,0,0,0,0,0,0,111,110,99,108,105,99,107,0,111,110,100,98,108,99,108,105,99,107,0,0,0,0,0,0,111,110,109,111,117,115,101,100,111,119,110,0,0,0,0,0,111,110,109,111,117,115,101,117,112,0,0,0,0,0,0,0,111,110,109,111,117,115,101,111,118,101,114,0,0,0,0,0,111,110,109,111,117,115,101,111,117,116,0,0,0,0,0,0,111,110,107,101,121,112,114,101,115,115,0,0,0,0,0,0,111,110,107,101,121,100,111,119,110,0,0,0,0,0,0,0,111,110,107,101,121,117,112,0,111,110,108,111,97,100,0,0,111,110,117,110,108,111,97,100,0,0,0,0,0,0,0,0,111,110,102,111,99,117,115,0,111,110,98,108,117,114,0,0,111,110,115,117,98,109,105,116,0,0,0,0,0,0,0,0,111,110,114,101,115,101,116,0,111,110,99,104,97,110,103,101,0,0,0,0,0,0,0,0,111,110,115,101,108,101,99,116,0,0,0,0,0,0,0,0,97,110,99,104,111,114,32,0,144,122,1,0,0,122,1,0,72,121,1,0,152,122,1,0,96,122,1,0,128,122,1,0,88,121,1,0,112,122,1,0,184,121,1,0,136,122,1,0,168,121,1,0,144,121,1,0,104,122,1,0,24,122,1,0,160,122,1,0,136,121,1,0,40,121,1,0,48,121,1,0,32,121,1,0,112,198,1,0,64,121,1,0,48,193,1,0,72,122,1,0,192,121,1,0,64,186,1,0,168,189,1,0,16,115,1,0,96,201,1,0,88,122,1,0,104,177,1,0,144,177,1,0,120,122,1,0,80,121,1,0,8,122,1,0,240,198,1,0,0,208,1,0,200,210,1,0,32,122,1,0,112,121,1,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,96,114,1,0,112,212,1,0,168,212,1,0,128,214,1,0,136,214,1,0,152,214,1,0,160,214,1,0,224,212,1,0,8,216,1,0,16,216,1,0,208,212,1,0,216,181,1,0,224,181,1,0,0,0,0,0,0,0,0,0,32,216,1,0,0,0,0,0,97,98,98,114,101,118,105,97,116,101,100,32,102,111,114,109,0,0,0,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,0,0,0,0,0,0,0,0,0,0,0,0,105,110,102,111,114,109,97,116,105,111,110,32,111,110,32,97,117,116,104,111,114,32,0,0,144,122,1,0,0,122,1,0,72,121,1,0,152,122,1,0,96,122,1,0,128,122,1,0,88,121,1,0,112,122,1,0,184,121,1,0,136,122,1,0,168,121,1,0,144,121,1,0,104,122,1,0,24,122,1,0,160,122,1,0,136,121,1,0,40,121,1,0,48,121,1,0,32,121,1,0,112,198,1,0,64,121,1,0,48,193,1,0,72,122,1,0,192,121,1,0,64,186,1,0,168,189,1,0,16,115,1,0,96,201,1,0,88,122,1,0,104,177,1,0,144,177,1,0,120,122,1,0,80,121,1,0,8,122,1,0,240,198,1,0,0,208,1,0,200,210,1,0,32,122,1,0,112,121,1,0,176,119,1,0,0,0,0,0,0,0,0,0,106,97,118,97,32,97,112,112,108,101,116,32,0,0,0,0,208,121,1,0,216,121,1,0,224,121,1,0,232,121,1,0,240,121,1,0,248,121,1,0,24,212,1,0,112,205,1,0,216,191,1,0,240,201,1,0,80,122,1,0,176,119,1,0,208,192,1,0,96,118,1,0,128,121,1,0,56,122,1,0,232,119,1,0,96,121,1,0,200,121,1,0,168,199,1,0,136,197,1,0,152,118,1,0,184,193,1,0,56,121,1,0,144,122,1,0,0,122,1,0,72,121,1,0,152,122,1,0,96,122,1,0,128,122,1,0,88,121,1,0,112,122,1,0,184,121,1,0,136,122,1,0,168,121,1,0,144,121,1,0,104,122,1,0,24,122,1,0,160,122,1,0,136,121,1,0,40,121,1,0,48,121,1,0,32,121,1,0,112,198,1,0,64,121,1,0,48,193,1,0,72,122,1,0,192,121,1,0,64,186,1,0,168,189,1,0,16,115,1,0,96,201,1,0,88,122,1,0,104,177,1,0,144,177,1,0,120,122,1,0,80,121,1,0,8,122,1,0,240,198,1,0,0,208,1,0,200,210,1,0,32,122,1,0,112,121,1,0,160,206,1,0,0,0,0,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,56,214,1,0,96,214,1,0,200,214,1,0,168,212,1,0,0,213,1,0,248,212,1,0,48,213,1,0,24,214,1,0,32,214,1,0,0,0,0,0,97,114,101,97,0,0,0,0,99,108,105,101,110,116,45,115,105,100,101,32,105,109,97,103,101,32,109,97,112,32,97,114,101,97,32,0,0,0,0,0,8,216,1,0,16,216,1,0,128,214,1,0,24,216,1,0,208,212,1,0,224,212,1,0,216,181,1,0,224,181,1,0,0,0,0,0,0,0,0,0,200,214,1,0,0,0,0,0,98,111,108,100,32,116,101,120,116,32,115,116,121,108,101,0,100,111,99,117,109,101,110,116,32,98,97,115,101,32,117,114,105,32,0,0,0,0,0,0,128,214,1,0,0,0,0,0,98,97,115,101,102,111,110,116,0,0,0,0,0,0,0,0,98,97,115,101,32,102,111,110,116,32,115,105,122,101,32,0,152,212,1,0,160,213,1,0,128,215,1,0,136,215,1,0,0,0,0,0,0,0,0,0,105,49,56,110,32,98,105,100,105,32,111,118,101,114,45,114,105,100,101,32,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,0,0,0,0,0,0,0,0,216,191,1,0,0,0,0,0,108,97,114,103,101,32,116,101,120,116,32,115,116,121,108,101,0,0,0,0,0,0,0,0,108,111,110,103,32,113,117,111,116,97,116,105,111,110,32,0,208,121,1,0,216,121,1,0,224,121,1,0,232,121,1,0,240,121,1,0,248,121,1,0,24,212,1,0,112,205,1,0,216,191,1,0,240,201,1,0,80,122,1,0,176,119,1,0,208,192,1,0,96,118,1,0,128,121,1,0,56,122,1,0,232,119,1,0,96,121,1,0,200,121,1,0,168,199,1,0,136,197,1,0,152,118,1,0,184,193,1,0,56,121,1,0,144,122,1,0,0,122,1,0,72,121,1,0,152,122,1,0,96,122,1,0,128,122,1,0,88,121,1,0,112,122,1,0,184,121,1,0,136,122,1,0,168,121,1,0,144,121,1,0,104,122,1,0,24,122,1,0,160,122,1,0,136,121,1,0,40,121,1,0,48,121,1,0,32,121,1,0,112,198,1,0,64,121,1,0,48,193,1,0,72,122,1,0,192,121,1,0,64,186,1,0,168,189,1,0,16,115,1,0,96,201,1,0,88,122,1,0,104,177,1,0,144,177,1,0,120,122,1,0,80,121,1,0,8,122,1,0,240,198,1,0,0,208,1,0,200,210,1,0,32,122,1,0,112,121,1,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,136,121,1,0,0,0,0,0,0,0,0,0,100,111,99,117,109,101,110,116,32,98,111,100,121,32,0,0,208,121,1,0,216,121,1,0,224,121,1,0,232,121,1,0,240,121,1,0,248,121,1,0,24,212,1,0,112,205,1,0,216,191,1,0,240,201,1,0,80,122,1,0,176,119,1,0,208,192,1,0,96,118,1,0,128,121,1,0,56,122,1,0,232,119,1,0,96,121,1,0,200,121,1,0,168,199,1,0,136,197,1,0,152,118,1,0,184,193,1,0,56,121,1,0,144,122,1,0,0,122,1,0,72,121,1,0,152,122,1,0,96,122,1,0,128,122,1,0,88,121,1,0,112,122,1,0,184,121,1,0,136,122,1,0,168,121,1,0,144,121,1,0,104,122,1,0,24,122,1,0,160,122,1,0,136,121,1,0,40,121,1,0,48,121,1,0,32,121,1,0,112,198,1,0,64,121,1,0,48,193,1,0,72,122,1,0,192,121,1,0,64,186,1,0,168,189,1,0,16,115,1,0,96,201,1,0,88,122,1,0,104,177,1,0,144,177,1,0,120,122,1,0,80,121,1,0,8,122,1,0,240,198,1,0,0,208,1,0,200,210,1,0,32,122,1,0,112,121,1,0,16,122,1,0,160,121,1,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,192,181,1,0,200,181,1,0,0,0,0,0,224,215,1,0,128,212,1,0,240,215,1,0,208,119,1,0,248,215,1,0,0,216,1,0,0,0,0,0,0,0,0,0,98,114,0,0,0,0,0,0,102,111,114,99,101,100,32,108,105,110,101,32,98,114,101,97,107,32,0,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,0,0,0,0,0,0,0,0,216,215,1,0,0,0,0,0,112,117,115,104,32,98,117,116,116,111,110,32,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,168,212,1,0,232,213,1,0,112,212,1,0,176,212,1,0,208,212,1,0,224,212,1,0,216,181,1,0,224,181,1,0,0,0,0,0,116,97,98,108,101,32,99,97,112,116,105,111,110,32,0,0,115,104,111,114,116,104,97,110,100,32,102,111,114,32,100,105,118,32,97,108,105,103,110,61,99,101,110,116,101,114,32,0,99,105,116,97,116,105,111,110,0,0,0,0,0,0,0,0,99,111,109,112,117,116,101,114,32,99,111,100,101,32,102,114,97,103,109,101,110,116,0,0,99,111,108,0,0,0,0,0,116,97,98,108,101,32,99,111,108,117,109,110,32,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,120,122,1,0,248,212,1,0,48,213,1,0,56,213,1,0,64,213,1,0,72,213,1,0,0,0,0,0,99,111,108,103,114,111,117,112,0,0,0,0,0,0,0,0,116,97,98,108,101,32,99,111,108,117,109,110,32,103,114,111,117,112,32,0,0,0,0,0,176,190,1,0,0,0,0,0,100,101,102,105,110,105,116,105,111,110,32,100,101,115,99,114,105,112,116,105,111,110,32,0,100,101,108,101,116,101,100,32,116,101,120,116,32,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,200,215,1,0,136,121,1,0,0,0,0,0,105,110,115,116,97,110,99,101,32,100,101,102,105,110,105,116,105,111,110,0,0,0,0,0,100,105,114,0,0,0,0,0,100,105,114,101,99,116,111,114,121,32,108,105,115,116,0,0,208,121,1,0,216,121,1,0,224,121,1,0,232,121,1,0,240,121,1,0,248,121,1,0,24,212,1,0,112,205,1,0,216,191,1,0,240,201,1,0,80,122,1,0,176,119,1,0,208,192,1,0,96,118,1,0,128,121,1,0,56,122,1,0,232,119,1,0,96,121,1,0,200,121,1,0,168,199,1,0,136,197,1,0,152,118,1,0,184,193,1,0,56,121,1,0,48,122,1,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,120,212,1,0,0,0,0,0,0,0,0,0,103,101,110,101,114,105,99,32,108,97,110,103,117,97,103,101,47,115,116,121,108,101,32,99,111,110,116,97,105,110,101,114,0,0,0,0,0,0,0,0,48,213,1,0,0,0,0,0,100,108,0,0,0,0,0,0,100,101,102,105,110,105,116,105,111,110,32,108,105,115,116,32,0,0,0,0,0,0,0,0,176,121,1,0,152,121,1,0,0,0,0,0,0,0,0,0,120,212,1,0,0,0,0,0,100,101,102,105,110,105,116,105,111,110,32,116,101,114,109,32,0,0,0,0,0,0,0,0,101,109,112,104,97,115,105,115,0,0,0,0,0,0,0,0,101,109,98,101,100,0,0,0,103,101,110,101,114,105,99,32,101,109,98,101,100,100,101,100,32,111,98,106,101,99,116,32,0,0,0,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,48,213,1,0,200,214,1,0,88,213,1,0,144,121,1,0,56,214,1,0,240,214,1,0,0,213,1,0,144,215,1,0,24,214,1,0,168,212,1,0,152,215,1,0,160,215,1,0,176,215,1,0,200,213,1,0,112,212,1,0,192,215,1,0,32,214,1,0,248,212,1,0,0,0,0,0,0,0,0,0,102,105,101,108,100,115,101,116,0,0,0,0,0,0,0,0,102,111,114,109,32,99,111,110,116,114,111,108,32,103,114,111,117,112,32,0,0,0,0,0,208,121,1,0,216,121,1,0,224,121,1,0,232,121,1,0,240,121,1,0,248,121,1,0,24,212,1,0,112,205,1,0,216,191,1,0,240,201,1,0,80,122,1,0,176,119,1,0,208,192,1,0,96,118,1,0,128,121,1,0,56,122,1,0,232,119,1,0,96,121,1,0,200,121,1,0,168,199,1,0,136,197,1,0,152,118,1,0,184,193,1,0,56,121,1,0,144,122,1,0,0,122,1,0,72,121,1,0,152,122,1,0,96,122,1,0,128,122,1,0,88,121,1,0,112,122,1,0,184,121,1,0,136,122,1,0,168,121,1,0,144,121,1,0,104,122,1,0,24,122,1,0,160,122,1,0,136,121,1,0,40,121,1,0,48,121,1,0,32,121,1,0,112,198,1,0,64,121,1,0,48,193,1,0,72,122,1,0,192,121,1,0,64,186,1,0,168,189,1,0,16,115,1,0,96,201,1,0,88,122,1,0,104,177,1,0,144,177,1,0,120,122,1,0,80,121,1,0,8,122,1,0,240,198,1,0,0,208,1,0,200,210,1,0,32,122,1,0,112,121,1,0,40,122,1,0,108,111,99,97,108,32,99,104,97,110,103,101,32,116,111,32,102,111,110,116,32,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,160,213,1,0,128,215,1,0,136,215,1,0,0,0,0,0,105,110,116,101,114,97,99,116,105,118,101,32,102,111,114,109,32,0,0,0,0,0,0,0,208,121,1,0,216,121,1,0,224,121,1,0,232,121,1,0,240,121,1,0,248,121,1,0,24,212,1,0,112,205,1,0,216,191,1,0,240,201,1,0,144,122,1,0,0,122,1,0,72,121,1,0,152,122,1,0,96,122,1,0,128,122,1],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+105328),
allocate([88,121,1,0,112,122,1,0,184,121,1,0,136,122,1,0,168,121,1,0,144,121,1,0,104,122,1,0,24,122,1,0,160,122,1,0,136,121,1,0,40,121,1,0,48,121,1,0,32,121,1,0,112,198,1,0,64,121,1,0,48,193,1,0,72,122,1,0,192,121,1,0,64,186,1,0,168,189,1,0,16,115,1,0,96,201,1,0,88,122,1,0,104,177,1,0,144,177,1,0,120,122,1,0,80,121,1,0,8,122,1,0,240,198,1,0,0,208,1,0,200,210,1,0,32,122,1,0,112,121,1,0,80,122,1,0,176,119,1,0,96,118,1,0,128,121,1,0,56,122,1,0,232,119,1,0,96,121,1,0,168,199,1,0,136,197,1,0,152,118,1,0,184,193,1,0,56,121,1,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,96,215,1,0,104,215,1,0,216,214,1,0,168,212,1,0,232,181,1,0,248,181,1,0,112,215,1,0,0,0,0,0,0,0,0,0,88,215,1,0,0,0,0,0,115,117,98,119,105,110,100,111,119,32,0,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,224,214,1,0,168,212,1,0,200,213,1,0,240,214,1,0,0,215,1,0,16,215,1,0,72,215,1,0,32,215,1,0,0,0,0,0,0,0,0,0,119,105,110,100,111,119,32,115,117,98,100,105,118,105,115,105,111,110,0,0,0,0,0,0,0,120,1,0,248,119,1,0,232,119,1,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,136,212,1,0,144,212,1,0,192,181,1,0,200,181,1,0,0,0,0,0,0,0,0,0,104,101,97,100,105,110,103,32,0,0,0,0,0,0,0,0,100,111,99,117,109,101,110,116,32,104,101,97,100,32,0,0,216,119,1,0,168,199,1,0,224,119,1,0,16,115,1,0,24,115,1,0,200,119,1,0,208,119,1,0,72,122,1,0,0,0,0,0,0,0,0,0,216,179,1,0,216,191,1,0,64,215,1,0,0,0,0,0,104,114,0,0,0,0,0,0,104,111,114,105,122,111,110,116,97,108,32,114,117,108,101,32,0,0,0,0,0,0,0,0,48,213,1,0,56,215,1,0,160,213,1,0,248,212,1,0,0,0,0,0,0,0,0,0,100,111,99,117,109,101,110,116,32,114,111,111,116,32,101,108,101,109,101,110,116,32,0,0,168,117,1,0,160,117,1,0,0,120,1,0,0,0,0,0,216,179,1,0,216,191,1,0,0,0,0,0,0,0,0,0,48,215,1,0,0,0,0,0,105,116,97,108,105,99,32,116,101,120,116,32,115,116,121,108,101,0,0,0,0,0,0,0,105,110,108,105,110,101,32,115,117,98,119,105,110,100,111,119,32,0,0,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,224,214,1,0,168,212,1,0,200,213,1,0,240,214,1,0,0,215,1,0,16,215,1,0,32,215,1,0,48,213,1,0,0,213,1,0,248,212,1,0,0,0,0,0,0,0,0,0,105,109,103,0,0,0,0,0,101,109,98,101,100,100,101,100,32,105,109,97,103,101,32,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,224,214,1,0,168,212,1,0,0,213,1,0,248,212,1,0,112,214,1,0,208,214,1,0,0,0,0,0,200,213,1,0,200,214,1,0,0,0,0,0,0,0,0,0,105,110,112,117,116,0,0,0,102,111,114,109,32,99,111,110,116,114,111,108,32,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,112,212,1,0,168,212,1,0,232,213,1,0,176,214,1,0,176,212,1,0,192,212,1,0,160,213,1,0,184,214,1,0,200,213,1,0,200,214,1,0,112,214,1,0,208,214,1,0,208,212,1,0,224,212,1,0,216,181,1,0,224,181,1,0,16,182,1,0,0,182,1,0,216,214,1,0,0,0,0,0,0,0,0,0,105,110,115,101,114,116,101,100,32,116,101,120,116,0,0,0,105,115,105,110,100,101,120,0,115,105,110,103,108,101,32,108,105,110,101,32,112,114,111,109,112,116,32,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,168,214,1,0,0,0,0,0,116,101,120,116,32,116,111,32,98,101,32,101,110,116,101,114,101,100,32,98,121,32,116,104,101,32,117,115,101,114,0,0,102,111,114,109,32,102,105,101,108,100,32,108,97,98,101,108,32,116,101,120,116,32,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,224,213,1,0,224,212,1,0,216,181,1,0,224,181,1,0,0,0,0,0,102,105,101,108,100,115,101,116,32,108,101,103,101,110,100,32,0,0,0,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,224,212,1,0,0,0,0,0,0,0,0,0,108,105,115,116,32,105,116,101,109,32,0,0,0,0,0,0,97,32,109,101,100,105,97,45,105,110,100,101,112,101,110,100,101,110,116,32,108,105,110,107,32,0,0,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,96,114,1,0,128,214,1,0,136,214,1,0,112,212,1,0,152,214,1,0,160,214,1,0,152,213,1,0,0,0,0,0,0,0,0,0,109,97,112,0,0,0,0,0,99,108,105,101,110,116,45,115,105,100,101,32,105,109,97,103,101,32,109,97,112,32,0,0,208,121,1,0,216,121,1,0,224,121,1,0,232,121,1,0,240,121,1,0,248,121,1,0,24,212,1,0,112,205,1,0,216,191,1,0,240,201,1,0,80,122,1,0,176,119,1,0,208,192,1,0,96,118,1,0,128,121,1,0,56,122,1,0,232,119,1,0,96,121,1,0,200,121,1,0,168,199,1,0,136,197,1,0,152,118,1,0,184,193,1,0,56,121,1,0,184,185,1,0,0,0,0,0,168,212,1,0,0,0,0,0,109,101,110,117,0,0,0,0,109,101,110,117,32,108,105,115,116,32,0,0,0,0,0,0,103,101,110,101,114,105,99,32,109,101,116,97,105,110,102,111,114,109,97,116,105,111,110,32,0,0,0,0,0,0,0,0,216,179,1,0,216,191,1,0,80,126,1,0,168,212,1,0,120,214,1,0,96,114,1,0,0,0,0,0,0,0,0,0,112,126,1,0,0,0,0,0,97,108,116,101,114,110,97,116,101,32,99,111,110,116,101,110,116,32,99,111,110,116,97,105,110,101,114,32,102,111,114,32,110,111,110,32,102,114,97,109,101,45,98,97,115,101,100,32,114,101,110,100,101,114,105,110,103,32,0,0,0,0,0,0,160,117,1,0,208,121,1,0,216,121,1,0,224,121,1,0,232,121,1,0,240,121,1,0,248,121,1,0,24,212,1,0,112,205,1,0,216,191,1,0,240,201,1,0,80,122,1,0,176,119,1,0,208,192,1,0,96,118,1,0,128,121,1,0,56,122,1,0,232,119,1,0,96,121,1,0,200,121,1,0,168,199,1,0,136,197,1,0,152,118,1,0,184,193,1,0,56,121,1,0,144,122,1,0,0,122,1,0,72,121,1,0,152,122,1,0,96,122,1,0,128,122,1,0,88,121,1,0,112,122,1,0,184,121,1,0,136,122,1,0,168,121,1,0,144,121,1,0,104,122,1,0,24,122,1,0,160,122,1,0,136,121,1,0,40,121,1,0,48,121,1,0,32,121,1,0,112,198,1,0,64,121,1,0,48,193,1,0,72,122,1,0,192,121,1,0,64,186,1,0,168,189,1,0,16,115,1,0,96,201,1,0,88,122,1,0,104,177,1,0,144,177,1,0,120,122,1,0,80,121,1,0,8,122,1,0,240,198,1,0,0,208,1,0,200,210,1,0,32,122,1,0,112,121,1,0,0,0,0,0,0,0,0,0,97,108,116,101,114,110,97,116,101,32,99,111,110,116,101,110,116,32,99,111,110,116,97,105,110,101,114,32,102,111,114,32,110,111,110,32,115,99,114,105,112,116,45,98,97,115,101,100,32,114,101,110,100,101,114,105,110,103,32,0,0,0,0,0,208,121,1,0,216,121,1,0,224,121,1,0,232,121,1,0,240,121,1,0,248,121,1,0,24,212,1,0,112,205,1,0,216,191,1,0,240,201,1,0,80,122,1,0,176,119,1,0,208,192,1,0,96,118,1,0,128,121,1,0,56,122,1,0,232,119,1,0,96,121,1,0,200,121,1,0,168,199,1,0,136,197,1,0,152,118,1,0,184,193,1,0,56,121,1,0,144,122,1,0,0,122,1,0,72,121,1,0,152,122,1,0,96,122,1,0,128,122,1,0,88,121,1,0,112,122,1,0,184,121,1,0,136,122,1,0,168,121,1,0,144,121,1,0,104,122,1,0,24,122,1,0,160,122,1,0,136,121,1,0,40,121,1,0,48,121,1,0,32,121,1,0,112,198,1,0,64,121,1,0,48,193,1,0,72,122,1,0,192,121,1,0,64,186,1,0,168,189,1,0,16,115,1,0,96,201,1,0,88,122,1,0,104,177,1,0,144,177,1,0,120,122,1,0,80,121,1,0,8,122,1,0,240,198,1,0,0,208,1,0,200,210,1,0,32,122,1,0,112,121,1,0,160,206,1,0,0,0,0,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,40,214,1,0,48,214,1,0,56,214,1,0,72,214,1,0,112,212,1,0,80,214,1,0,96,214,1,0,104,214,1,0,0,213,1,0,248,212,1,0,112,214,1,0,168,212,1,0,208,212,1,0,0,0,0,0,0,0,0,0,48,213,1,0,88,213,1,0,24,214,1,0,32,214,1,0,0,0,0,0,0,0,0,0,111,108,0,0,0,0,0,0,111,114,100,101,114,101,100,32,108,105,115,116,32,0,0,0,48,122,1,0,0,0,0,0,112,212,1,0,120,212,1,0,16,214,1,0,0,0,0,0,111,112,116,103,114,111,117,112,0,0,0,0,0,0,0,0,111,112,116,105,111,110,32,103,114,111,117,112,32,0,0,0,200,205,1,0,0,0,0,0,111,112,116,105,111,110,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,176,212,1,0,0,0,0,0,0,0,0,0,32,122,1,0,0,0,0,0,115,101,108,101,99,116,97,98,108,101,32,99,104,111,105,99,101,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,176,212,1,0,32,122,1,0,0,214,1,0,232,213,1,0,0,0,0,0,112,97,114,97,103,114,97,112,104,32,0,0,0,0,0,0,112,97,114,97,109,0,0,0,110,97,109,101,100,32,112,114,111,112,101,114,116,121,32,118,97,108,117,101,32,0,0,0,152,212,1,0,232,213,1,0,240,213,1,0,112,212,1,0,0,0,0,0,0,0,0,0,112,114,101,102,111,114,109,97,116,116,101,100,32,116,101,120,116,32,0,0,0,0,0,0,184,121,1,0,136,122,1,0,168,121,1,0,144,121,1,0,104,122,1,0,24,122,1,0,160,122,1,0,136,121,1,0,40,121,1,0,48,121,1,0,144,122,1,0,0,122,1,0,72,121,1,0,152,122,1,0,96,122,1,0,128,122,1,0,32,121,1,0,168,189,1,0,16,115,1,0,96,201,1,0,88,122,1,0,120,122,1,0,80,121,1,0,8,122,1,0,0,0,0,0,0,0,0,0,248,212,1,0,0,0,0,0,115,104,111,114,116,32,105,110,108,105,110,101,32,113,117,111,116,97,116,105,111,110,32,0,115,116,114,105,107,101,45,116,104,114,111,117,103,104,32,116,101,120,116,32,115,116,121,108,101,0,0,0,0,0,0,0,115,97,109,112,108,101,32,112,114,111,103,114,97,109,32,111,117,116,112,117,116,44,32,115,99,114,105,112,116,115,44,32,101,116,99,46,0,0,0,0,115,99,114,105,112,116,32,115,116,97,116,101,109,101,110,116,115,32,0,0,0,0,0,0,96,114,1,0,200,213,1,0,208,213,1,0,216,213,1,0,224,213,1,0,0,0,0,0,184,213,1,0,0,0,0,0,112,212,1,0,0,0,0,0,115,101,108,101,99,116,0,0,111,112,116,105,111,110,32,115,101,108,101,99,116,111,114,32,0,0,0,0,0,0,0,0,160,205,1,0,200,205,1,0,0,0,0,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,168,212,1,0,160,213,1,0,168,213,1,0,176,212,1,0,208,212,1,0,216,181,1,0,224,181,1,0,0,182,1,0,0,0,0,0,115,109,97,108,108,32,116,101,120,116,32,115,116,121,108,101,0,0,0,0,0,0,0,0,103,101,110,101,114,105,99,32,108,97,110,103,117,97,103,101,47,115,116,121,108,101,32,99,111,110,116,97,105,110,101,114,32,0,0,0,0,0,0,0,115,116,114,105,107,101,45,116,104,114,111,117,103,104,32,116,101,120,116,0,0,0,0,0,115,116,114,111,110,103,32,101,109,112,104,97,115,105,115,0,115,116,121,108,101,32,105,110,102,111,32,0,0,0,0,0,216,179,1,0,216,191,1,0,152,213,1,0,216,119,1,0,0,0,0,0,0,0,0,0,115,117,98,115,99,114,105,112,116,0,0,0,0,0,0,0,115,117,112,101,114,115,99,114,105,112,116,32,0,0,0,0,120,121,1,0,176,190,1,0,32,191,1,0,128,118,1,0,144,118,1,0,136,118,1,0,120,118,1,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,80,213,1,0,248,212,1,0,88,213,1,0,248,119,1,0,96,213,1,0,104,213,1,0,120,213,1,0,136,213,1,0,0,0,0,0,48,213,1,0,128,212,1,0,0,0,0,0,0,0,0,0,116,97,98,108,101,32,98,111,100,121,32,0,0,0,0,0,120,118,1,0,0,0,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,48,213,1,0,56,213,1,0,64,213,1,0,72,213,1,0,0,0,0,0,116,97,98,108,101,32,100,97,116,97,32,99,101,108,108,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,40,121,1,0,8,213,1,0,16,213,1,0,24,213,1,0,32,213,1,0,40,213,1,0,48,213,1,0,56,213,1,0,64,213,1,0,72,213,1,0,0,0,0,0,240,212,1,0,128,212,1,0,248,212,1,0,0,213,1,0,0,0,0,0,0,0,0,0,116,101,120,116,97,114,101,97,0,0,0,0,0,0,0,0,109,117,108,116,105,45,108,105,110,101,32,116,101,120,116,32,102,105,101,108,100,32,0,0,152,212,1,0,160,212,1,0,24,115,1,0,216,119,1,0,216,179,1,0,216,191,1,0,64,181,1,0,72,181,1,0,88,181,1,0,104,181,1,0,120,181,1,0,136,181,1,0,152,181,1,0,168,181,1,0,184,181,1,0,168,212,1,0,176,212,1,0,192,212,1,0,208,212,1,0,224,212,1,0,216,181,1,0,224,181,1,0,16,182,1,0,0,182,1,0,0,0,0,0,0,0,0,0,136,212,1,0,144,212,1,0,0,0,0,0,0,0,0,0,116,97,98,108,101,32,102,111,111,116,101,114,32,0,0,0,116,97,98,108,101,32,104,101,97,100,101,114,32,99,101,108,108,0,0,0,0,0,0,0,116,97,98,108,101,32,104,101,97,100,101,114,32,0,0,0,100,111,99,117,109,101,110,116,32,116,105,116,108,101,32,0,116,97,98,108,101,32,114,111,119,32,0,0,0,0,0,0,112,118,1,0,104,118,1,0,0,0,0,0,0,0,0,0,128,212,1,0,0,0,0,0,116,101,108,101,116,121,112,101,32,111,114,32,109,111,110,111,115,112,97,99,101,100,32,116,101,120,116,32,115,116,121,108,101,0,0,0,0,0,0,0,117,110,100,101,114,108,105,110,101,100,32,116,101,120,116,32,115,116,121,108,101,0,0,0,117,108,0,0,0,0,0,0,117,110,111,114,100,101,114,101,100,32,108,105,115,116,32,0,112,212,1,0,120,212,1,0,0,0,0,0,0,0,0,0,105,110,115,116,97,110,99,101,32,111,102,32,97,32,118,97,114,105,97,98,108,101,32,111,114,32,112,114,111,103,114,97,109,32,97,114,103,117,109,101,110,116,0,0,0,0,0,0,116,121,112,101,0,0,0,0,99,111,109,112,97,99,116,0,98,103,99,111,108,111,114,0,114,111,119,115,0,0,0,0,99,111,108,115,0,0,0,0,105,100,0,0,0,0,0,0,99,108,97,115,115,0,0,0,110,97,109,101,0,0,0,0,100,105,115,97,98,108,101,100,0,0,0,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,116,97,98,105,110,100,101,120,0,0,0,0,0,0,0,0,97,99,99,101,115,115,107,101,121,0,0,0,0,0,0,0,110,111,119,114,97,112,0,0,119,105,100,116,104,0,0,0,104,101,105,103,104,116,0,0,97,120,105,115,0,0,0,0,104,101,97,100,101,114,115,0,115,99,111,112,101,0,0,0,114,111,119,115,112,97,110,0,99,111,108,115,112,97,110,0,97,108,105,103,110,0,0,0,99,104,97,114,0,0,0,0,99,104,97,114,111,102,102,0,118,97,108,105,103,110,0,0,115,117,109,109,97,114,121,0,98,111,114,100,101,114,0,0,114,117,108,101,115,0,0,0,99,101,108,108,115,112,97,99,105,110,103,0,0,0,0,0,99,101,108,108,112,97,100,100,105,110,103,0,0,0,0,0,100,97,116,97,112,97,103,101,115,105,122,101,0,0,0,0,109,101,100,105,97,0,0,0,115,105,122,101,0,0,0,0,109,117,108,116,105,112,108,101,0,0,0,0,0,0,0,0,108,97,110,103,117,97,103,101,0,0,0,0,0,0,0,0,115,114,99,0,0,0,0,0,100,101,102,101,114,0,0,0,101,118,101,110,116,0,0,0,102,111,114,0,0,0,0,0,118,97,108,117,101,0,0,0,118,97,108,117,101,116,121,112,101,0,0,0,0,0,0,0,115,101,108,101,99,116,101,100,0,0,0,0,0,0,0,0,115,116,97,114,116,0,0,0,104,115,112,97,99,101,0,0,118,115,112,97,99,101,0,0,100,101,99,108,97,114,101,0,99,108,97,115,115,105,100,0,99,111,100,101,98,97,115,101,0,0,0,0,0,0,0,0,100,97,116,97,0,0,0,0,99,111,100,101,116,121,112,101,0,0,0,0,0,0,0,0,97,114,99,104,105,118,101,0,115,116,97,110,100,98,121,0,117,115,101,109,97,112,0,0,115,99,104,101,109,101,0,0,104,114,101,102,0,0,0,0,104,114,101,102,108,97,110,103,0,0,0,0,0,0,0,0,114,101,108,0,0,0,0,0,114,101,118,0,0,0,0,0,112,114,111,109,112,116,0,0,99,104,101,99,107,101,100,0,109,97,120,108,101,110,103,116,104,0,0,0,0,0,0,0,97,108,116,0,0,0,0,0,105,115,109,97,112,0,0,0,97,99,99,101,112,116,0,0,108,111,110,103,100,101,115,99,0,0,0,0,0,0,0,0,102,114,97,109,101,98,111,114,100,101,114,0,0,0,0,0,109,97,114,103,105,110,119,105,100,116,104,0,0,0,0,0,109,97,114,103,105,110,104,101,105,103,104,116,0,0,0,0,115,99,114,111,108,108,105,110,103,0,0,0,0,0,0,0,118,101,114,115,105,111,110,0,110,111,115,104,97,100,101,0,112,114,111,102,105,108,101,0,110,111,114,101,115,105,122,101,0,0,0,0,0,0,0,0,97,99,116,105,111,110,0,0,109,101,116,104,111,100,0,0,101,110,99,116,121,112,101,0,97,99,99,101,112,116,45,99,104,97,114,115,101,116,0,0,99,111,108,111,114,0,0,0,102,97,99,101,0,0,0,0,104,105,100,100,101,110,0,0,112,97,108,101,116,116,101,0,112,108,117,103,105,110,115,112,97,99,101,0,0,0,0,0,112,108,117,103,105,110,117,114,108,0,0,0,0,0,0,0,117,110,105,116,115,0,0,0,100,97,116,101,116,105,109,101,0,0,0,0,0,0,0,0,99,108,101,97,114,0,0,0,98,97,99,107,103,114,111,117,110,100,0,0,0,0,0,0,116,101,120,116,0,0,0,0,118,108,105,110,107,0,0,0,97,108,105,110,107,0,0,0,115,104,97,112,101,0,0,0,99,111,111,114,100,115,0,0,110,111,104,114,101,102,0,0,116,97,114,103,101,116,0,0,108,105,115,116,105,110,103,0,120,109,112,0,0,0,0,0,104,116,109,108,0,0,0,0,104,101,97,100,0,0,0,0,109,101,116,97,0,0,0,0,104,116,116,112,45,101,113,117,105,118,0,0,0,0,0,0,67,111,110,116,101,110,116,45,84,121,112,101,0,0,0,0,99,111,110,116,101,110,116,0,99,104,97,114,115,101,116,61,0,0,0,0,0,0,0,0,67,104,97,114,115,101,116,61,0,0,0,0,0,0,0,0,67,72,65,82,83,69,84,61,0,0,0,0,0,0,0,0,99,104,97,114,115,101,116,32,61,0,0,0,0,0,0,0,67,104,97,114,115,101,116,32,61,0,0,0,0,0,0,0,67,72,65,82,83,69,84,32,61,0,0,0,0,0,0,0,116,101,120,116,47,104,116,109,108,59,32,99,104,97,114,115,101,116,61,37,115,0,0,0,200,218,1,0,208,218,1,0,216,218,1,0,224,218,1,0,232,218,1,0,248,218,1,0,0,219,1,0,16,219,1,0,24,219,1,0,40,219,1,0,48,219,1,0,56,219,1,0,72,219,1,0,0,0,0,0,72,84,77,76,0,0,0,0,97,115,99,105,105,0,0,0,115,99,114,105,112,116,0,0,115,116,121,108,101,0,0,0,60,33,45,45,0,0,0,0,45,45,62,0,0,0,0,0,60,63,0,0,0,0,0,0,32,0,0,0,0,0,0,0,62,0,0,0,0,0,0,0,38,0,0,0,0,0,0,0,59,0,0,0,0,0,0,0,60,0,0,0,0,0,0,0,58,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,98,111,100,121,0,0,0,0,62,60,47,0,0,0,0,0,60,47,0,0,0,0,0,0,85,84,70,45,56,0,0,0,60,33,68,79,67,84,89,80,69,32,0,0,0,0,0,0,32,80,85,66,76,73,67,32,0,0,0,0,0,0,0,0,32,83,89,83,84,69,77,32,0,0,0,0,0,0,0,0,62,10,0,0,0,0,0,0,61,0,0,0,0,0,0,0,104,114,101,102,0,0,0,0,97,99,116,105,111,110,0,0,115,114,99,0,0,0,0,0,110,97,109,101,0,0,0,0,97,0,0,0,0,0,0,0,34,0,0,0,0,0,0,0,64,47,58,61,63,59,35,37,38,44,43,0,0,0,0,0,61,34,34,0,0,0,0,0,115,116,114,105,110,103,32,105,115,32,110,111,116,32,105,110,32,85,84,70,45,56,10,0,105,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,118,97,108,117,101,10,0,0,0,0,0,0,0,0,117,110,107,110,111,119,110,32,101,110,99,111,100,105,110,103,32,37,115,10,0,0,0,0,72,84,77,76,32,104,97,115,32,110,111,32,68,79,67,84,89,80,69,10,0,0,0,0,117,110,101,120,112,101,99,116,101,100,32,101,114,114,111,114,32,110,117,109,98,101,114,10,0,0,0,0,0,0,0,0,99,104,101,99,107,101,100,0,99,111,109,112,97,99,116,0,100,101,99,108,97,114,101,0,100,101,102,101,114,0,0,0,100,105,115,97,98,108,101,100,0,0,0,0,0,0,0,0,105,115,109,97,112,0,0,0,109,117,108,116,105,112,108,101,0,0,0,0,0,0,0,0,110,111,104,114,101,102,0,0,110,111,114,101,115,105,122,101,0,0,0,0,0,0,0,0,110,111,115,104,97,100,101,0,110,111,119,114,97,112,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,115,101,108,101,99,116,101,100,0,0,0,0,0,0,0,0,40,78,85,76,76,41,0,0,35,37,88,0,0,0,0,0,46,46,46,0,0,0,0,0,78,85,76,76,10,0,0,0,45,0,0,0,0,0,0,0,97,0,0,0,0,0,0,0,116,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,101,0,0,0,0,0,0,0,69,0,0,0,0,0,0,0,112,0,0,0,0,0,0,0,99,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,104,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,70,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,110,0,0,0,0,0,0,0,63,0,0,0,0,0,0,0,32,37,56,100,32,0,0,0,37,115,58,0,0,0,0,0,37,115,0,0,0,0,0,0,100,101,102,97,117,108,116,32,45,62,32,37,115,0,0,0,37,115,32,45,62,32,37,115,0,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,37,115,58,32,110,111,32,115,117,99,104,32,110,111,100,101,10,0,0,0,0,0,0,0,37,115,32,105,115,32,97,32,66,111,111,108,101,97,110,10,0,0,0,0,0,0,0,0,37,115,32,105,115,32,97,32,110,117,109,98,101,114,10,0,37,115,32,105,115,32,97,32,115,116,114,105,110,103,10,0,37,115,32,105,115,32,97,32,112,111,105,110,116,10,0,0,37,115,32,105,115,32,97,32,114,97,110,103,101,10,0,0,37,115,32,105,115,32,117,115,101,114,45,100,101,102,105,110,101,100,10,0,0,0,0,0,37,115,32,105,115,32,97,110,32,88,83,76,84,32,118,97,108,117,101,32,116,114,101,101,10,0,0,0,0,0,0,0,32,78,111,32,98,97,115,101,32,102,111,117,110,100,32,33,33,33,10,0,0,0,0,0,37,115,10,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,119,114,105,116,101,32,116,111,32,37,115,10,0,0,119,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,115,97,118,101,32,116,111,32,37,115,10,0,0,0,84,111,32,115,97,118,101,32,116,111,32,115,117,98,112,97,114,116,115,32,111,102,32,97,32,100,111,99,117,109,101,110,116,32,117,115,101,32,116,104,101,32,39,119,114,105,116,101,39,32,99,111,109,109,97,110,100,10,0,0,0,0,0,0,47,10,0,0,0,0,0,0,32,32,0,0,0,0,0,0,37,115,32,62,32,0,0,0,47,0,0,0,0,0,0,0,37,115,58,37,115,32,62,32,0,0,0,0,0,0,0,0,63,32,62,32,0,0,0,0,101,120,105,116,0,0,0,0,113,117,105,116,0,0,0,0,98,121,101,0,0,0,0,0,104,101,108,112,0,0,0,0,9,98,97,115,101,32,32,32,32,32,32,32,32,32,100,105,115,112,108,97,121,32,88,77,76,32,98,97,115,101,32,111,102,32,116,104,101,32,110,111,100,101,10,0,0,0,0,0,9,115,101,116,98,97,115,101,32,85,82,73,32,32,99,104,97,110,103,101,32,116,104,101,32,88,77,76,32,98,97,115,101,32,111,102,32,116,104,101,32,110,111,100,101,10,0,0,9,98,121,101,32,32,32,32,32,32,32,32,32,32,108,101,97,118,101,32,115,104,101,108,108,10,0,0,0,0,0,0,9,99,97,116,32,91,110,111,100,101,93,32,32,32,100,105,115,112,108,97,121,32,110,111,100,101,32,111,114,32,99,117,114,114,101,110,116,32,110,111,100,101,10,0,0,0,0,0,9,99,100,32,91,112,97,116,104,93,32,32,32,32,99,104,97,110,103,101,32,100,105,114,101,99,116,111,114,121,32,116,111,32,112,97,116,104,32,111,114,32,116,111,32,114,111,111,116,10,0,0,0,0,0,0,9,100,105,114,32,91,112,97,116,104,93,32,32,32,100,117,109,112,115,32,105,110,102,111,114,109,97,116,105,111,110,115,32,97,98,111,117,116,32,116,104,101,32,110,111,100,101,32,40,110,97,109,101,115,112,97,99,101,44,32,97,116,116,114,105,98,117,116,101,115,44,32,99,111,110,116,101,110,116,41,10,0,0,0,0,0,0,0,9,100,117,32,91,112,97,116,104,93,32,32,32,32,115,104,111,119,32,116,104,101,32,115,116,114,117,99,116,117,114,101,32,111,102,32,116,104,101,32,115,117,98,116,114,101,101,32,117,110,100,101,114,32,112,97,116,104,32,111,114,32,116,104,101,32,99,117,114,114,101,110,116,32,110,111,100,101,10,0,9,101,120,105,116,32,32,32,32,32,32,32,32,32,108,101,97,118,101,32,115,104,101,108,108,10,0,0,0,0,0,0,9,104,101,108,112,32,32,32,32,32,32,32,32,32,100,105,115,112,108,97,121,32,116,104,105,115,32,104,101,108,112,10,0,0,0,0,0,0,0,0,9,102,114,101,101,32,32,32,32,32,32,32,32,32,100,105,115,112,108,97,121,32,109,101,109,111,114,121,32,117,115,97,103,101,10,0,0,0,0,0,9,108,111,97,100,32,91,110,97,109,101,93,32,32,108,111,97,100,32,97,32,110,101,119,32,100,111,99,117,109,101,110,116,32,119,105,116,104,32,110,97,109,101,10,0,0,0,0,9,108,115,32,91,112,97,116,104,93,32,32,32,32,108,105,115,116,32,99,111,110,116,101,110,116,115,32,111,102,32,112,97,116,104,32,111,114,32,116,104,101,32,99,117,114,114,101,110,116,32,100,105,114,101,99,116,111,114,121,10,0,0,0,9,115,101,116,32,120,109,108,95,102,114,97,103,109,101,110,116,32,114,101,112,108,97,99,101,32,116,104,101,32,99,117,114,114,101,110,116,32,110,111,100,101,32,99,111,110,116,101,110,116,32,119,105,116,104,32,116,104,101,32,102,114,97,103,109,101,110,116,32,112,97,114,115,101,100,32,105,110,32,99,111,110,116,101,120,116,10,0,9,120,112,97,116,104,32,101,120,112,114,32,32,32,101,118,97,108,117,97,116,101,32,116,104,101,32,88,80,97,116,104,32,101,120,112,114,101,115,115,105,111,110,32,105,110,32,116,104,97,116,32,99,111,110,116,101,120,116,32,97,110,100,32,112,114,105,110,116,32,116,104,101,32,114,101,115,117,108,116,10,0,0,0,0,0,0,0,9,115,101,116,110,115,32,110,115,114,101,103,32,32,114,101,103,105,115,116,101,114,32,97,32,110,97,109,101,115,112,97,99,101,32,116,111,32,97,32,112,114,101,102,105,120,32,105,110,32,116,104,101,32,88,80,97,116,104,32,101,118,97,108,117,97,116,105,111,110,32,99,111,110,116,101,120,116,10,0,9,32,32,32,32,32,32,32,32,32,32,32,32,32,102,111,114,109,97,116,32,102,111,114,32,110,115,114,101,103,32,105,115,58,32,112,114,101,102,105,120,61,91,110,115,117,114,105,93,32,40,105,46,101,46,32,112,114,101,102,105,120,61,32,117,110,115,101,116,115,32,97,32,112,114,101,102,105,120,41,10,0,0,0,0,0,0,0,9,115,101,116,114,111,111,116,110,115,32,32,32,32,114,101,103,105,115,116,101,114,32,97,108,108,32,110,97,109,101,115,112,97,99,101,32,102,111,117,110,100,32,111,110,32,116,104,101,32,114,111,111,116,32,101,108,101,109,101,110,116,10,0,9,32,32,32,32,32,32,32,32,32,32,32,32,32,116,104,101,32,100,101,102,97,117,108,116,32,110,97,109,101,115,112,97,99,101,32,105,102,32,97,110,121,32,117,115,101,115,32,39,100,101,102,97,117,108,116,110,115,39,32,112,114,101,102,105,120,10,0,0,0,0,0,9,112,119,100,32,32,32,32,32,32,32,32,32,32,100,105,115,112,108,97,121,32,99,117,114,114,101,110,116,32,119,111,114,107,105,110,103,32,100,105,114,101,99,116,111,114,121,10,0,0,0,0,0,0,0,0,9,119,104,101,114,101,105,115,32,32,32,32,32,32,100,105,115,112,108,97,121,32,97,98,115,111,108,117,116,101,32,112,97,116,104,32,111,102,32,91,112,97,116,104,93,32,111,114,32,99,117,114,114,101,110,116,32,119,111,114,107,105,110,103,32,100,105,114,101,99,116,111,114,121,10,0,0,0,0,0,9,113,117,105,116,32,32,32,32,32,32,32,32,32,108,101,97,118,101,32,115,104,101,108,108,10,0,0,0,0,0,0,9,115,97,118,101,32,91,110,97,109,101,93,32,32,115,97,118,101,32,116,104,105,115,32,100,111,99,117,109,101,110,116,32,116,111,32,110,97,109,101,32,111,114,32,116,104,101,32,111,114,105,103,105,110,97,108,32,110,97,109,101,10,0,0,9,119,114,105,116,101,32,91,110,97,109,101,93,32,119,114,105,116,101,32,116,104,101,32,99,117,114,114,101,110,116,32,110,111,100,101,32,116,111,32,116,104,101,32,102,105,108,101,110,97,109,101,10,0,0,0,9,118,97,108,105,100,97,116,101,32,32,32,32,32,99,104,101,99,107,32,116,104,101,32,100,111,99,117,109,101,110,116,32,102,111,114,32,101,114,114,111,114,115,10,0,0,0,0,9,114,101,108,97,120,110,103,32,114,110,103,32,32,118,97,108,105,100,97,116,101,32,116,104,101,32,100,111,99,117,109,101,110,116,32,97,103,97,105,115,110,116,32,116,104,101,32,82,101,108,97,120,45,78,71,32,115,99,104,101,109,97,115,10,0,0,0,0,0,0,0,9,103,114,101,112,32,115,116,114,105,110,103,32,32,115,101,97,114,99,104,32,102,111,114,32,97,32,115,116,114,105,110,103,32,105,110,32,116,104,101,32,115,117,98,116,114,101,101,10,0,0,0,0,0,0,0,118,97,108,105,100,97,116,101,0,0,0,0,0,0,0,0,108,111,97,100,0,0,0,0,114,101,108,97,120,110,103,0,115,97,118,101,0,0,0,0,119,114,105,116,101,0,0,0,87,114,105,116,101,32,99,111,109,109,97,110,100,32,114,101,113,117,105,114,101,115,32,97,32,102,105,108,101,110,97,109,101,32,97,114,103,117,109,101,110,116,10,0,0,0,0,0,103,114,101,112,0,0,0,0,102,114,101,101,0,0,0,0,37,100,0,0,0,0,0,0,112,119,100,0,0,0,0,0,100,117,0,0,0,0,0,0,98,97,115,101,0,0,0,0,115,101,116,0,0,0,0,0,115,101,116,110,115,0,0,0,115,101,116,110,115,58,32,112,114,101,102,105,120,61,91,110,115,117,114,105,93,32,114,101,113,117,105,114,101,100,10,0,115,101,116,114,111,111,116,110,115,0,0,0,0,0,0,0,120,112,97,116,104,0,0,0,120,112,97,116,104,58,32,101,120,112,114,101,115,115,105,111,110,32,114,101,113,117,105,114,101,100,10,0,0,0,0,0,115,101,116,98,97,115,101,0,108,115,0,0,0,0,0,0,100,105,114,0,0,0,0,0,119,104,101,114,101,105,115,0,99,100,0,0,0,0,0,0,99,97,110,110,111,116,32,99,100,32,116,111,32,110,97,109,101,115,112,97,99,101,10,0,37,115,32,105,115,32,97,32,37,100,32,78,111,100,101,32,83,101,116,10,0,0,0,0,37,115,32,105,115,32,97,110,32,101,109,112,116,121,32,78,111,100,101,32,83,101,116,10,0,0,0,0,0,0,0,0,99,97,116,0,0,0,0,0,32,45,45,45,45,45,45,45,10,0,0,0,0,0,0,0,85,110,107,110,111,119,110,32,99,111,109,109,97,110,100,32,37,115,10,0,0,0,0,0,100,101,102,97,117,108,116,110,115,0,0,0,0,0,0,0,69,114,114,111,114,58,32,117,110,97,98,108,101,32,116,111,32,114,101,103,105,115,116,101,114,32,78,83,32,119,105,116,104,32,112,114,101,102,105,120,61,34,37,115,34,32,97,110,100,32,104,114,101,102,61,34,37,115,34,10,0,0,0,0,102,97,105,108,101,100,32,116,111,32,112,97,114,115,101,32,99,111,110,116,101,110,116,10,0,0,0,0,0,0,0,0,37,115,32,58,32,0,0,0,82,101,108,97,120,45,78,71,32,115,99,104,101,109,97,32,37,115,32,102,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,10,0,0,0,37,115,32,118,97,108,105,100,97,116,101,115,10,0,0,0,37,115,32,102,97,105,108,115,32,116,111,32,118,97,108,105,100,97,116,101,10,0,0,0,37,115,32,118,97,108,105,100,97,116,105,111,110,32,103,101,110,101,114,97,116,101,100,32,97,110,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,10,0,0,0,0,0,0,68,84,68,32,110,111,100,101,32,105,115,32,78,85,76,76,10,0,0,0,0,0,0,0,78,111,100,101,32,105,115,32,110,111,116,32,97,32,68,84,68,0,0,0,0,0,0,0,68,84,68,40,37,115,41,0,68,84,68,0,0,0,0,0,44,32,80,85,66,76,73,67,32,37,115,0,0,0,0,0,44,32,83,89,83,84,69,77,32,37,115,0,0,0,0,0,78,111,100,101,32,104,97,115,32,110,111,32,112,97,114,101,110,116,10,0,0,0,0,0,78,111,100,101,32,104,97,115,32,110,111,32,100,111,99,10,0,0,0,0,0,0,0,0,112,115,101,117,100,111,114,111,111,116,0,0,0,0,0,0,78,111,100,101,32,100,111,99,32,100,105,102,102,101,114,115,32,102,114,111,109,32,112,97,114,101,110,116,39,115,32,111,110,101,10,0,0,0,0,0,65,116,116,114,32,104,97,115,32,110,111,32,112,114,101,118,32,97,110,100,32,110,111,116,32,102,105,114,115,116,32,111,102,32,97,116,116,114,32,108,105,115,116,10,0,0,0,0,78,111,100,101,32,104,97,115,32,110,111,32,112,114,101,118,32,97,110,100,32,110,111,116,32,102,105,114,115,116,32,111,102,32,112,97,114,101,110,116,32,108,105,115,116,10,0,0,78,111,100,101,32,112,114,101,118,45,62,110,101,120,116,32,58,32,98,97,99,107,32,108,105,110,107,32,119,114,111,110,103,10,0,0,0,0,0,0,78,111,100,101,32,104,97,115,32,110,111,32,110,101,120,116,32,97,110,100,32,110,111,116,32,108,97,115,116,32,111,102,32,112,97,114,101,110,116,32,108,105,115,116,10,0,0,0,78,111,100,101,32,110,101,120,116,45,62,112,114,101,118,32,58,32,102,111,114,119,97,114,100,32,108,105,110,107,32,119,114,111,110,103,10,0,0,0,110,98,107,116,101,120,116,0,84,101,120,116,32,110,111,100,101,32,104,97,115,32,119,114,111,110,103,32,110,97,109,101,32,39,37,115,39,0,0,0,67,111,109,109,101,110,116,32,110,111,100,101,32,104,97,115,32,119,114,111,110,103,32,110,97,109,101,32,39,37,115,39,0,0,0,0,0,0,0,0,67,68,97,116,97,32,115,101,99,116,105,111,110,32,104,97,115,32,110,111,110,32,78,85,76,76,32,110,97,109,101,32,39,37,115,39,0,0,0,0,78,97,109,101,32,105,115,32,78,85,76,76,0,0,0,0,78,97,109,101,32,105,115,32,110,111,116,32,97,110,32,78,67,78,97,109,101,32,39,37,115,39,0,0,0,0,0,0,78,97,109,101,32,105,115,32,110,111,116,32,102,114,111,109,32,116,104,101,32,100,111,99,117,109,101,110,116,32,100,105,99,116,105,111,110,110,97,114,121,32,39,37,115,39,0,0,83,116,114,105,110,103,32,105,115,32,110,111,116,32,85,84,70,45,56,32,37,115,0,0,82,101,102,101,114,101,110,99,101,32,116,111,32,100,101,102,97,117,108,116,32,110,97,109,101,115,112,97,99,101,32,110,111,116,32,105,110,32,115,99,111,112,101,10,0,0,0,0,82,101,102,101,114,101,110,99,101,32,116,111,32,110,97,109,101,115,112,97,99,101,32,39,37,115,39,32,110,111,116,32,105,110,32,115,99,111,112,101,10,0,0,0,0,0,0,0,82,101,102,101,114,101,110,99,101,32,116,111,32,100,101,102,97,117,108,116,32,110,97,109,101,115,112,97,99,101,32,110,111,116,32,111,110,32,97,110,99,101,115,116,111,114,10,0,82,101,102,101,114,101,110,99,101,32,116,111,32,110,97,109,101,115,112,97,99,101,32,39,37,115,39,32,110,111,116,32,111,110,32,97,110,99,101,115,116,111,114,10,0,0,0,0,68,79,67,85,77,69,78,84,32,61,61,32,78,85,76,76,32,33,10,0,0,0,0,0,110,97,109,101,61,0,0,0,118,101,114,115,105,111,110,61,0,0,0,0,0,0,0,0,101,110,99,111,100,105,110,103,61,0,0,0,0,0,0,0,85,82,76,61,0,0,0,0,115,116,97,110,100,97,108,111,110,101,61,116,114,117,101,10,0,0,0,0,0,0,0,0,110,97,109,101,115,112,97,99,101,32,110,111,100,101,32,105,115,32,78,85,76,76,10,0,78,111,100,101,32,105,115,32,110,111,116,32,97,32,110,97,109,101,115,112,97,99,101,32,100,101,99,108,97,114,97,116,105,111,110,0,0,0,0,0,73,110,99,111,109,112,108,101,116,101,32,110,97,109,101,115,112,97,99,101,32,37,115,32,104,114,101,102,61,78,85,76,76,10,0,0,0,0,0,0,73,110,99,111,109,112,108,101,116,101,32,100,101,102,97,117,108,116,32,110,97,109,101,115,112,97,99,101,32,104,114,101,102,61,78,85,76,76,10,0,110,97,109,101,115,112,97,99,101,32,37,115,32,104,114,101,102,61,0,0,0,0,0,0,100,101,102,97,117,108,116,32,110,97,109,101,115,112,97,99,101,32,104,114,101,102,61,0,77,105,115,112,108,97,99,101,100,32,69,76,69,77,69,78,84,32,110,111,100,101,10,0,77,105,115,112,108,97,99,101,100,32,65,84,84,82,73,66,85,84,69,32,110,111,100,101,10,0,0,0,0,0,0,0,77,105,115,112,108,97,99,101,100,32,84,69,88,84,32,110,111,100,101,10,0,0,0,0,77,105,115,112,108,97,99,101,100,32,67,68,65,84,65,32,110,111,100,101,10,0,0,0,77,105,115,112,108,97,99,101,100,32,69,78,84,73,84,89,82,69,70,32,110,111,100,101],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+115568),
allocate([10,0,0,0,0,0,0,0,77,105,115,112,108,97,99,101,100,32,69,78,84,73,84,89,32,110,111,100,101,10,0,0,77,105,115,112,108,97,99,101,100,32,80,73,32,110,111,100,101,10,0,0,0,0,0,0,77,105,115,112,108,97,99,101,100,32,67,79,77,77,69,78,84,32,110,111,100,101,10,0,68,79,67,85,77,69,78,84,10,0,0,0,0,0,0,0,72,84,77,76,32,68,79,67,85,77,69,78,84,10,0,0,77,105,115,112,108,97,99,101,100,32,68,79,67,84,89,80,69,32,110,111,100,101,10,0,77,105,115,112,108,97,99,101,100,32,70,82,65,71,77,69,78,84,32,110,111,100,101,10,0,0,0,0,0,0,0,0,77,105,115,112,108,97,99,101,100,32,78,79,84,65,84,73,79,78,32,110,111,100,101,10,0,0,0,0,0,0,0,0,85,110,107,110,111,119,110,32,110,111,100,101,32,116,121,112,101,32,37,100,10,0,0,0,110,111,100,101,32,105,115,32,78,85,76,76,10,0,0,0,69,76,69,77,69,78,84,32,0,0,0,0,0,0,0,0,58,0,0,0,0,0,0,0,69,114,114,111,114,44,32,65,84,84,82,73,66,85,84,69,32,102,111,117,110,100,32,104,101,114,101,10,0,0,0,0,84,69,88,84,32,110,111,32,101,110,99,0,0,0,0,0,84,69,88,84,0,0,0,0,32,99,111,109,112,97,99,116,10,0,0,0,0,0,0,0,32,105,110,116,101,114,110,101,100,10,0,0,0,0,0,0,67,68,65,84,65,95,83,69,67,84,73,79,78,10,0,0,69,78,84,73,84,89,95,82,69,70,40,37,115,41,10,0,69,78,84,73,84,89,10,0,80,73,32,37,115,10,0,0,67,79,77,77,69,78,84,10,0,0,0,0,0,0,0,0,69,114,114,111,114,44,32,68,79,67,85,77,69,78,84,32,102,111,117,110,100,32,104,101,114,101,10,0,0,0,0,0,68,79,67,85,77,69,78,84,95,84,89,80,69,10,0,0,68,79,67,85,77,69,78,84,95,70,82,65,71,10,0,0,78,79,84,65,84,73,79,78,10,0,0,0,0,0,0,0,73,78,67,76,85,68,69,32,83,84,65,82,84,10,0,0,73,78,67,76,85,68,69,32,69,78,68,10,0,0,0,0,80,66,77,58,32,100,111,99,32,61,61,32,78,85,76,76,32,33,33,33,10,0,0,0,99,111,110,116,101,110,116,61,0,0,0,0,0,0,0,0,69,110,116,105,116,121,32,105,115,32,78,85,76,76,10,0,73,78,84,69,82,78,65,76,95,71,69,78,69,82,65,76,95,69,78,84,73,84,89,32,0,0,0,0,0,0,0,0,69,88,84,69,82,78,65,76,95,71,69,78,69,82,65,76,95,80,65,82,83,69,68,95,69,78,84,73,84,89,32,0,69,88,84,69,82,78,65,76,95,71,69,78,69,82,65,76,95,85,78,80,65,82,83,69,68,95,69,78,84,73,84,89,32,0,0,0,0,0,0,0,73,78,84,69,82,78,65,76,95,80,65,82,65,77,69,84,69,82,95,69,78,84,73,84,89,32,0,0,0,0,0,0,69,88,84,69,82,78,65,76,95,80,65,82,65,77,69,84,69,82,95,69,78,84,73,84,89,32,0,0,0,0,0,0,69,78,84,73,84,89,95,37,100,32,33,32,0,0,0,0,69,120,116,101,114,110,97,108,73,68,61,37,115,10,0,0,83,121,115,116,101,109,73,68,61,37,115,10,0,0,0,0,85,82,73,61,37,115,10,0,69,110,116,105,116,121,32,100,101,99,108,97,114,97,116,105,111,110,32,105,115,32,78,85,76,76,10,0,0,0,0,0,78,111,100,101,32,105,115,32,110,111,116,32,97,110,32,101,110,116,105,116,121,32,100,101,99,108,97,114,97,116,105,111,110,0,0,0,0,0,0,0,69,78,84,73,84,89,68,69,67,76,40,0,0,0,0,0,41,0,0,0,0,0,0,0,69,110,116,105,116,121,32,100,101,99,108,97,114,97,116,105,111,110,32,104,97,115,32,110,111,32,110,97,109,101,0,0,44,32,105,110,116,101,114,110,97,108,10,0,0,0,0,0,44,32,101,120,116,101,114,110,97,108,32,112,97,114,115,101,100,10,0,0,0,0,0,0,44,32,117,110,112,97,114,115,101,100,10,0,0,0,0,0,44,32,112,97,114,97,109,101,116,101,114,10,0,0,0,0,44,32,101,120,116,101,114,110,97,108,32,112,97,114,97,109,101,116,101,114,10,0,0,0,44,32,112,114,101,100,101,102,105,110,101,100,10,0,0,0,32,69,120,116,101,114,110,97,108,73,68,61,37,115,10,0,32,83,121,115,116,101,109,73,68,61,37,115,10,0,0,0,32,85,82,73,61,37,115,10,0,0,0,0,0,0,0,0,32,99,111,110,116,101,110,116,61,0,0,0,0,0,0,0,65,116,116,114,105,98,117,116,101,32,100,101,99,108,97,114,97,116,105,111,110,32,105,115,32,78,85,76,76,10,0,0,78,111,100,101,32,105,115,32,110,111,116,32,97,110,32,97,116,116,114,105,98,117,116,101,32,100,101,99,108,97,114,97,116,105,111,110,0,0,0,0,65,84,84,82,68,69,67,76,40,37,115,41,0,0,0,0,78,111,100,101,32,97,116,116,114,105,98,117,116,101,32,100,101,99,108,97,114,97,116,105,111,110,32,104,97,115,32,110,111,32,110,97,109,101,0,0,32,102,111,114,32,37,115,0,78,111,100,101,32,97,116,116,114,105,98,117,116,101,32,100,101,99,108,97,114,97,116,105,111,110,32,104,97,115,32,110,111,32,101,108,101,109,101,110,116,32,110,97,109,101,0,0,32,67,68,65,84,65,0,0,32,73,68,0,0,0,0,0,32,73,68,82,69,70,0,0,32,73,68,82,69,70,83,0,32,69,78,84,73,84,89,0,32,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,32,78,77,84,79,75,69,78,0,0,0,0,0,0,0,0,32,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,32,69,78,85,77,69,82,65,84,73,79,78,0,0,0,0,32,78,79,84,65,84,73,79,78,32,0,0,0,0,0,0,124,37,115,0,0,0,0,0,32,40,37,115,0,0,0,0,46,46,46,41,0,0,0,0,32,82,69,81,85,73,82,69,68,0,0,0,0,0,0,0,32,73,77,80,76,73,69,68,0,0,0,0,0,0,0,0,32,70,73,88,69,68,0,0,34,0,0,0,0,0,0,0,69,108,101,109,101,110,116,32,100,101,99,108,97,114,97,116,105,111,110,32,105,115,32,78,85,76,76,10,0,0,0,0,78,111,100,101,32,105,115,32,110,111,116,32,97,110,32,101,108,101,109,101,110,116,32,100,101,99,108,97,114,97,116,105,111,110,0,0,0,0,0,0,69,76,69,77,68,69,67,76,40,0,0,0,0,0,0,0,69,108,101,109,101,110,116,32,100,101,99,108,97,114,97,116,105,111,110,32,104,97,115,32,110,111,32,110,97,109,101,0,44,32,85,78,68,69,70,73,78,69,68,0,0,0,0,0,44,32,69,77,80,84,89,0,44,32,65,78,89,0,0,0,44,32,77,73,88,69,68,32,0,0,0,0,0,0,0,0,69,110,116,105,116,105,101,115,32,105,110,32,105,110,116,101,114,110,97,108,32,115,117,98,115,101,116,10,0,0,0,0,78,111,32,101,110,116,105,116,105,101,115,32,105,110,32,105,110,116,101,114,110,97,108,32,115,117,98,115,101,116,10,0,69,110,116,105,116,105,101,115,32,105,110,32,101,120,116,101,114,110,97,108,32,115,117,98,115,101,116,10,0,0,0,0,78,111,32,101,110,116,105,116,105,101,115,32,105,110,32,101,120,116,101,114,110,97,108,32,115,117,98,115,101,116,10,0,69,110,116,105,116,121,32,105,115,32,78,85,76,76,0,0,73,78,84,69,82,78,65,76,32,71,69,78,69,82,65,76,44,32,0,0,0,0,0,0,69,88,84,69,82,78,65,76,32,80,65,82,83,69,68,44,32,0,0,0,0,0,0,0,69,88,84,69,82,78,65,76,32,85,78,80,65,82,83,69,68,44,32,0,0,0,0,0,73,78,84,69,82,78,65,76,32,80,65,82,65,77,69,84,69,82,44,32,0,0,0,0,69,88,84,69,82,78,65,76,32,80,65,82,65,77,69,84,69,82,44,32,0,0,0,0,85,110,107,110,111,119,110,32,101,110,116,105,116,121,32,116,121,112,101,32,37,100,10,0,73,68,32,34,37,115,34,0,83,89,83,84,69,77,32,34,37,115,34,0,0,0,0,0,10,32,111,114,105,103,32,34,37,115,34,0,0,0,0,0,10,32,99,111,110,116,101,110,116,32,34,37,115,34,0,0,65,116,116,114,32,105,115,32,78,85,76,76,0,0,0,0,65,84,84,82,73,66,85,84,69,32,0,0,0,0,0,0,65,116,116,114,105,98,117,116,101,32,104,97,115,32,110,111,32,110,97,109,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,115,0,0,0,0,0,0,96,0,2,0,104,0,2,0,128,0,2,0,152,0,2,0,176,0,2,0,216,0,2,0,240,0,2,0,8,1,2,0,32,1,2,0,64,1,2,0,88,1,2,0,112,1,2,0,128,1,2,0,160,1,2,0,184,1,2,0,216,1,2,0,248,1,2,0,8,2,2,0,24,2,2,0,48,2,2,0,80,2,2,0,96,2,2,0,120,2,2,0,152,2,2,0,176,2,2,0,200,2,2,0,79,98,106,101,99,116,32,105,115,32,101,109,112,116,121,32,40,78,85,76,76,41,10,0,79,98,106,101,99,116,32,105,115,32,117,110,105,110,105,116,105,97,108,105,122,101,100,10,0,0,0,0,0,0,0,0,79,98,106,101,99,116,32,105,115,32,97,32,78,111,100,101,32,83,101,116,32,58,10,0,79,98,106,101,99,116,32,105,115,32,97,110,32,88,83,76,84,32,118,97,108,117,101,32,116,114,101,101,32,58,10,0,79,98,106,101,99,116,32,105,115,32,97,32,66,111,111,108,101,97,110,32,58,32,0,0,116,114,117,101,10,0,0,0,102,97,108,115,101,10,0,0,79,98,106,101,99,116,32,105,115,32,97,32,110,117,109,98,101,114,32,58,32,73,110,102,105,110,105,116,121,10,0,0,79,98,106,101,99,116,32,105,115,32,97,32,110,117,109,98,101,114,32,58,32,45,73,110,102,105,110,105,116,121,10,0,79,98,106,101,99,116,32,105,115,32,97,32,110,117,109,98,101,114,32,58,32,78,97,78,10,0,0,0,0,0,0,0,79,98,106,101,99,116,32,105,115,32,97,32,110,117,109,98,101,114,32,58,32,48,10,0,79,98,106,101,99,116,32,105,115,32,97,32,110,117,109,98,101,114,32,58,32,37,48,103,10,0,0,0,0,0,0,0,79,98,106,101,99,116,32,105,115,32,97,32,115,116,114,105,110,103,32,58,32,0,0,0,10,0,0,0,0,0,0,0,79,98,106,101,99,116,32,105,115,32,97,32,112,111,105,110,116,32,58,32,105,110,100,101,120,32,37,100,32,105,110,32,110,111,100,101,0,0,0,0,79,98,106,101,99,116,32,105,115,32,97,32,99,111,108,108,97,112,115,101,100,32,114,97,110,103,101,32,58,10,0,0,105,110,100,101,120,32,37,100,32,105,110,32,0,0,0,0,110,111,100,101,10,0,0,0,79,98,106,101,99,116,32,105,115,32,97,32,114,97,110,103,101,32,58,10,0,0,0,0,70,114,111,109,32,0,0,0,84,111,32,0,0,0,0,0,79,98,106,101,99,116,32,105,115,32,97,32,76,111,99,97,116,105,111,110,32,83,101,116,58,10,0,0,0,0,0,0,79,98,106,101,99,116,32,105,115,32,117,115,101,114,32,100,101,102,105,110,101,100,10,0,46,46,47,108,105,98,120,109,108,50,47,120,112,97,116,104,46,99,0,0,0,0,0,0,88,80,97,116,104,32,115,116,97,99,107,32,100,101,112,116,104,32,108,105,109,105,116,32,114,101,97,99,104,101,100,10,0,0,0,0,0,0,0,0,112,117,115,104,105,110,103,32,118,97,108,117,101,10,0,0,99,114,101,97,116,105,110,103,32,110,111,100,101,115,101,116,10,0,0,0,0,0,0,0,103,114,111,119,105,110,103,32,110,111,100,101,115,101,116,10,0,0,0,0,0,0,0,0,103,114,111,119,105,110,103,32,110,111,100,101,115,101,116,32,104,105,116,32,108,105,109,105,116,10,0,0,0,0,0,0,109,101,114,103,105,110,103,32,110,111,100,101,115,101,116,10,0,0,0,0,0,0,0,0,109,101,114,103,105,110,103,32,110,111,100,101,115,101,116,32,104,105,116,32,108,105,109,105,116,10,0,0,0,0,0,0,99,114,101,97,116,105,110,103,32,110,111,100,101,32,115,101,116,32,111,98,106,101,99,116,10,0,0,0,0,0,0,0,120,109,108,0,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,99,114,101,97,116,105,110,103,32,102,108,111,97,116,32,111,98,106,101,99,116,10,0,0,99,114,101,97,116,105,110,103,32,98,111,111,108,101,97,110,32,111,98,106,101,99,116,10,0,0,0,0,0,0,0,0,99,114,101,97,116,105,110,103,32,115,116,114,105,110,103,32,111,98,106,101,99,116,10,0,0,0,0,0,0,0,0,0,99,111,112,121,105,110,103,32,111,98,106,101,99,116,10,0,120,109,108,88,80,97,116,104,79,98,106,101,99,116,67,111,112,121,58,32,117,110,115,117,112,112,111,114,116,101,100,32,116,121,112,101,32,37,100,10,0,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,73,110,102,105,110,105,116,121,0,0,0,0,0,0,0,0,45,73,110,102,105,110,105,116,121,0,0,0,0,0,0,0,78,97,78,0,0,0,0,0,48,0,0,0,0,0,0,0,85,110,105,109,112,108,101,109,101,110,116,101,100,32,98,108,111,99,107,32,97,116,32,37,115,58,37,100,10,0,0,0,99,114,101,97,116,105,110,103,32,99,111,110,116,101,120,116,10,0,0,0,0,0,0,0,99,114,101,97,116,105,110,103,32,112,97,114,115,101,114,32,99,111,110,116,101,120,116,10,0,0,0,0,0,0,0,0,102,97,107,101,32,110,111,100,101,32,108,105,98,120,115,108,116,0,0,0,0,0,0,0,184,254,1,0,0,0,0,0,120,109,108,88,80,97,116,104,84,114,97,110,115,108,97,116,101,70,117,110,99,116,105,111,110,58,32,73,110,118,97,108,105,100,32,85,84,70,56,32,115,116,114,105,110,103,10,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,36,64,0,0,0,0,0,0,89,64,0,0,0,0,0,64,143,64,0,0,0,0,0,136,195,64,0,0,0,0,0,106,248,64,0,0,0,0,128,132,46,65,0,0,0,0,208,18,99,65,0,0,0,0,132,215,151,65,0,0,0,0,101,205,205,65,0,0,0,32,95,160,2,66,0,0,0,232,118,72,55,66,0,0,0,162,148,26,109,66,0,0,64,229,156,48,162,66,0,0,144,30,196,188,214,66,0,0,52,38,245,107,12,67,0,128,224,55,121,195,65,67,0,160,216,133,87,52,118,67,0,200,78,103,109,193,171,67,0,61,145,96,228,88,225,67,64,140,181,120,29,175,21,68,110,111,100,101,0,0,0,0,116,101,120,116,0,0,0,0,99,111,109,109,101,110,116,0,112,114,111,99,101,115,115,105,110,103,45,105,110,115,116,114,117,99,116,105,111,110,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,32,97,116,32,37,115,58,37,100,10,0,0,0,0,0,0,0,0,78,85,76,76,32,99,111,110,116,101,120,116,32,112,111,105,110,116,101,114,10,0,0,0,120,109,108,88,80,97,116,104,69,118,97,108,58,32,101,118,97,108,117,97,116,105,111,110,32,102,97,105,108,101,100,10,0,0,0,0,0,0,0,0,120,109,108,88,80,97,116,104,69,118,97,108,58,32,37,100,32,111,98,106,101,99,116,32,108,101,102,116,32,111,110,32,116,104,101,32,115,116,97,99,107,10,0,0,0,0,0,0,98,111,111,108,101,97,110,0,99,101,105,108,105,110,103,0,99,111,117,110,116,0,0,0,99,111,110,99,97,116,0,0,99,111,110,116,97,105,110,115,0,0,0,0,0,0,0,0,105,100,0,0,0,0,0,0,102,108,111,111,114,0,0,0,108,97,115,116,0,0,0,0,108,97,110,103,0,0,0,0,108,111,99,97,108,45,110,97,109,101,0,0,0,0,0,0,110,111,116,0,0,0,0,0,110,97,109,101,0,0,0,0,110,97,109,101,115,112,97,99,101,45,117,114,105,0,0,0,110,111,114,109,97,108,105,122,101,45,115,112,97,99,101,0,110,117,109,98,101,114,0,0,112,111,115,105,116,105,111,110,0,0,0,0,0,0,0,0,114,111,117,110,100,0,0,0,115,116,114,105,110,103,0,0,115,116,114,105,110,103,45,108,101,110,103,116,104,0,0,0,115,116,97,114,116,115,45,119,105,116,104,0,0,0,0,0,115,117,98,115,116,114,105,110,103,0,0,0,0,0,0,0,115,117,98,115,116,114,105,110,103,45,98,101,102,111,114,101,0,0,0,0,0,0,0,0,115,117,98,115,116,114,105,110,103,45,97,102,116,101,114,0,115,117,109,0,0,0,0,0,116,114,97,110,115,108,97,116,101,0,0,0,0,0,0,0,101,115,99,97,112,101,45,117,114,105,0,0,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,50,47,48,56,47,120,113,117,101,114,121,45,102,117,110,99,116,105,111,110,115,0,0,0,0,0,0,99,114,101,97,116,105,110,103,32,101,118,97,108,117,97,116,105,111,110,32,99,111,110,116,101,120,116,10,0,0,0,0,120,109,108,88,80,97,116,104,82,117,110,69,118,97,108,58,32,108,97,115,116,32,105,115,32,108,101,115,115,32,116,104,97,110,32,122,101,114,111,10,0,0,0,0,0,0,0,0,120,109,108,88,80,97,116,104,67,111,109,112,79,112,69,118,97,108,58,32,118,97,114,105,97,98,108,101,32,37,115,32,98,111,117,110,100,32,116,111,32,117,110,100,101,102,105,110,101,100,32,112,114,101,102,105,120,32,37,115,10,0,0,0,120,109,108,88,80,97,116,104,67,111,109,112,79,112,69,118,97,108,58,32,112,97,114,97,109,101,116,101,114,32,101,114,114,111,114,10,0,0,0,0,120,109,108,88,80,97,116,104,67,111,109,112,79,112,69,118,97,108,58,32,102,117,110,99,116,105,111,110,32,37,115,32,98,111,117,110,100,32,116,111,32,117,110,100,101,102,105,110,101,100,32,112,114,101,102,105,120,32,37,115,10,0,0,0,120,109,108,88,80,97,116,104,67,111,109,112,79,112,69,118,97,108,58,32,102,117,110,99,116,105,111,110,32,37,115,32,110,111,116,32,102,111,117,110,100,10,0,0,0,0,0,0,88,80,97,116,104,58,32,117,110,107,110,111,119,110,32,112,114,101,99,111,109,112,105,108,101,100,32,111,112,101,114,97,116,105,111,110,32,37,100,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,109,108,88,80,97,116,104,67,111,109,112,105,108,101,100,69,118,97,108,58,32,101,118,97,108,117,97,116,105,111,110,32,102,97,105,108,101,100,10,0,0,0,0,0,0,0,0,120,109,108,88,80,97,116,104,67,111,109,112,105,108,101,100,69,118,97,108,58,32,37,100,32,111,98,106,101,99,116,115,32,108,101,102,116,32,111,110,32,116,104,101,32,115,116,97,99,107,46,10,0,0,0,0,97,100,100,105,110,103,32,115,116,101,112,10,0,0,0,0,58,58,0,0,0,0,0,0,114,97,110,103,101,45,116,111,0,0,0,0,0,0,0,0,97,110,99,101,115,116,111,114,0,0,0,0,0,0,0,0,97,110,99,101,115,116,111,114,45,111,114,45,115,101,108,102,0,0,0,0,0,0,0,0,97,116,116,114,105,98,117,116,101,0,0,0,0,0,0,0,99,104,105,108,100,0,0,0,100,101,115,99,101,110,100,97,110,116,0,0,0,0,0,0,100,101,115,99,101,110,100,97,110,116,45,111,114,45,115,101,108,102,0,0,0,0,0,0,102,111,108,108,111,119,105,110,103,0,0,0,0,0,0,0,102,111,108,108,111,119,105,110,103,45,115,105,98,108,105,110,103,0,0,0,0,0,0,0,110,97,109,101,115,112,97,99,101,0,0,0,0,0,0,0,112,97,114,101,110,116,0,0,112,114,101,99,101,100,105,110,103,0,0,0,0,0,0,0,112,114,101,99,101,100,105,110,103,45,115,105,98,108,105,110,103,0,0,0,0,0,0,0,115,101,108,102,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,110,97,109,101,115,112,97,99,101,115,32,97,114,114,97,121,10,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,115,116,114,101,97,109,97,98,108,101,32,101,120,112,114,101,115,115,105,111,110,10,0,0,0,0,0,0,0,0,0,0,0,18,0,0,0,40,247,1,0,32,247,1,0,0,0,0,0,0,0,0,0,99,111,109,112,97,114,105,110,103,32,110,111,100,101,115,101,116,115,10,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,99,111,109,112,111,110,101,110,116,10,0,0,0,97,108,108,111,99,97,116,105,110,103,32,115,116,101,112,115,10,0,0,0,0,0,0,0,37,100,0,0,0,0,0,0,37,42,46,42,101,0,0,0,37,48,46,42,102,0,0,0,120,109,108,80,111,105,110,116,101,114,76,105,115,116,67,114,101,97,116,101,58,32,97,108,108,111,99,97,116,105,110,103,32,105,116,101,109,10,0,0,120,109,108,80,111,105,110,116,101,114,76,105,115,116,65,100,100,83,105,122,101,58,32,114,101,45,97,108,108,111,99,97,116,105,110,103,32,105,116,101,109,10,0,0,0,0,0,0,100,117,112,108,105,99,97,116,105,110,103,32,110,97,109,101,115,112,97,99,101,10,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,32,58,32,37,115,10,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,10,0,0,0,0,0,0,0,76,111,99,97,116,105,111,110,83,101,116,32,105,115,32,78,85,76,76,32,33,10,0,0,37,100,32,58,32,0,0,0,78,111,100,101,32,105,115,32,78,85,76,76,32,33,10,0,32,47,10,0,0,0,0,0,86,97,108,117,101,32,84,114,101,101,32,105,115,32,78,85,76,76,32,33,10,0,0,0,78,111,100,101,83,101,116,32,105,115,32,78,85,76,76,32,33,10,0,0,0,0,0,0,83,101,116,32,99,111,110,116,97,105,110,115,32,37,100,32,110,111,100,101,115,58,10,0,79,107,10,0,0,0,0,0,78,117,109,98,101,114,32,101,110,99,111,100,105,110,103,10,0,0,0,0,0,0,0,0,85,110,102,105,110,105,115,104,101,100,32,108,105,116,101,114,97,108,10,0,0,0,0,0,83,116,97,114,116,32,111,102,32,108,105,116,101,114,97,108,10,0,0,0,0,0,0,0,69,120,112,101,99,116,101,100,32,36,32,102,111,114,32,118,97,114,105,97,98,108,101,32,114,101,102,101,114,101,110,99,101,10,0,0,0,0,0,0,85,110,100,101,102,105,110,101,100,32,118,97,114,105,97,98,108,101,10,0,0,0,0,0,73,110,118,97,108,105,100,32,112,114,101,100,105,99,97,116,101,10,0,0,0,0,0,0,73,110,118,97,108,105,100,32,101,120,112,114,101,115,115,105,111,110,10,0,0,0,0,0,77,105,115,115,105,110,103,32,99,108,111,115,105,110,103,32,99,117,114,108,121,32,98,114,97,99,101,10,0,0,0,0,85,110,114,101,103,105,115,116,101,114,101,100,32,102,117,110,99,116,105,111,110,10,0,0,73,110,118,97,108,105,100,32,111,112,101,114,97,110,100,10,0,0,0,0,0,0,0,0,73,110,118,97,108,105,100,32,116,121,112,101,10,0,0,0,73,110,118,97,108,105,100,32,110,117,109,98,101,114,32,111,102,32,97,114,103,117,109,101,110,116,115,10,0,0,0,0,73,110,118,97,108,105,100,32,99,111,110,116,101,120,116,32,115,105,122,101,10,0,0,0,73,110,118,97,108,105,100,32,99,111,110,116,101,120,116,32,112,111,115,105,116,105,111,110,10,0,0,0,0,0,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,101,114,114,111,114,10,0,0,0,0,0,0,0,0,83,121,110,116,97,120,32,101,114,114,111,114,10,0,0,0,82,101,115,111,117,114,99,101,32,101,114,114,111,114,10,0,83,117,98,32,114,101,115,111,117,114,99,101,32,101,114,114,111,114,10,0,0,0,0,0,85,110,100,101,102,105,110,101,100,32,110,97,109,101,115,112,97,99,101,32,112,114,101,102,105,120,10,0,0,0,0,0,69,110,99,111,100,105,110,103,32,101,114,114,111,114,10,0,67,104,97,114,32,111,117,116,32,111,102,32,88,77,76,32,114,97,110,103,101,10,0,0,73,110,118,97,108,105,100,32,111,114,32,105,110,99,111,109,112,108,101,116,101,32,99,111,110,116,101,120,116,10,0,0,83,116,97,99,107,32,117,115,97,103,101,32,101,114,114,111,114,10,0,0,0,0,0,0,70,111,114,98,105,100,100,101,110,32,118,97,114,105,97,98,108,101,10,0,0,0,0,0,63,63,32,85,110,107,110,111,119,110,32,101,114,114,111,114,32,63,63,10,0,0,0,0,128,0,0,0,0,0,0,0,0,1,2,3,4,5,6,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,127,240,0,0,0,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,116,101,109,112,111,114,97,114,121,32,115,116,111,114,97,103,101,32,102,111,114,32,116,105,109,32,115,111,114,116,58,32,110,101,101,100,32,37,108,117,32,98,121,116,101,115,0,97,108,108,111,99,97,116,105,110,103,32,114,97,110,103,101,0,0,0,0,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,32,97,116,32,37,115,58,37,100,10,0,0,0,0,0,0,0,0,46,46,47,108,105,98,120,109,108,50,47,120,112,111,105,110,116,101,114,46,99,0,0,0,97,108,108,111,99,97,116,105,110,103,32,108,111,99,97,116,105,111,110,115,101,116,0,0,97,100,100,105,110,103,32,108,111,99,97,116,105,111,110,32,116,111,32,115,101,116,0,0,114,97,110,103,101,45,116,111,0,0,0,0,0,0,0,0,114,97,110,103,101,0,0,0,114,97,110,103,101,45,105,110,115,105,100,101,0,0,0,0,115,116,114,105,110,103,45,114,97,110,103,101,0,0,0,0,115,116,97,114,116,45,112,111,105,110,116,0,0,0,0,0,101,110,100,45,112,111,105,110,116,0,0,0,0,0,0,0,104,101,114,101,0,0,0,0,32,111,114,105,103,105,110,0,120,109,108,88,80,116,114,69,118,97,108,58,32,101,118,97,108,117,97,116,105,111,110,32,102,97,105,108,101,100,32,116,111,32,114,101,116,117,114,110,32,97,32,110,111,100,101,32,115,101,116,10,0,0,0,0,120,109,108,88,80,116,114,69,118,97,108,58,32,111,98,106,101,99,116,40,115,41,32,108,101,102,116,32,111,110,32,116,104,101,32,101,118,97,108,32,115,116,97,99,107,10,0,0,85,110,105,109,112,108,101,109,101,110,116,101,100,32,98,108,111,99,107,32,97,116,32,37,115,58,37,100,10,0,0,0,97,108,108,111,99,97,116,105,110,103,32,112,111,105,110,116,0,0,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,101,118,97,108,117,97,116,105,111,110,32,99,111,110,116,101,120,116,0,0,0,97,108,108,111,99,97,116,105,110,103,32,98,117,102,102,101,114,0,0,0,0,0,0,0,120,112,111,105,110,116,101,114,0,0,0,0,0,0,0,0,101,108,101,109,101,110,116,0,120,109,108,110,115,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,115,99,104,101,109,101,32,39,37,115,39,10,0,0,0,0,0,0,0,0,119,97,114,110,105,110,103,58,32,67,104,105,108,100,83,101,113,32,110,111,116,32,115,116,97,114,116,105,110,103,32,98,121,32,47,49,10,0,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,32,58,32,37,115,10,0,0,99,114,101,97,116,105,110,103,32,88,73,110,99,108,117,100,101,32,99,111,110,116,101,120,116,0,0,0,0,0,0,0,88,73,110,99,108,117,100,101,32,101,114,114,111,114,58,32,119,111,117,108,100,32,114,101,115,117,108,116,32,105,110,32,109,117,108,116,105,112,108,101,32,114,111,111,116,32,110,111,100,101,115,10,0,0,0,0,102,97,105,108,101,100,32,116,111,32,98,117,105,108,100,32,110,111,100,101,10,0,0,0,104,114,101,102,0,0,0,0,0,0,0,0,0,0,0,0,112,97,114,115,101,0,0,0,120,109,108,0,0,0,0,0,116,101,120,116,0,0,0,0,105,110,118,97,108,105,100,32,118,97,108,117,101,32,37,115,32,102,111,114,32,39,112,97,114,115,101,39,10,0,0,0,102,97,105,108,101,100,32,98,117,105,108,100,32,85,82,76,10,0,0,0,0,0,0,0,102,97,108,108,98,97,99,107,0,0,0,0,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,51,47,88,73,110,99,108,117,100,101,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,49,47,88,73,110,99,108,117,100,101,0,99,111,117,108,100,32,110,111,116,32,108,111,97,100,32,37,115,44,32,97,110,100,32,110,111,32,102,97,108,108,98,97,99,107,32,119,97,115,32,102,111,117,110,100,10,0,0,0,105,110,118,97,108,105,100,32,118,97,108,117,101,32,85,82,73,32,37,115,10,0,0,0,102,114,97,103,109,101,110,116,32,105,100,101,110,116,105,102,105,101,114,32,102,111,114,98,105,100,100,101,110,32,102,111,114,32,116,101,120,116,58,32,37,115,10,0,0,0,0,0,116,101,120,116,32,115,101,114,105,97,108,105,122,97,116,105,111,110,32,111,102,32,100,111,99,117,109,101,110,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,10,0,0,0,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,101,110,99,111,100,105,110,103,32,37,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,10,0,0,0,0,0,0,37,115,32,99,111,110,116,97,105,110,115,32,105,110,118,97,108,105,100,32,99,104,97,114,10,0,0,0,0,0,0,0,112,114,111,99,101,115,115,105,110,103,32,116,101,120,116,0,99,111,117,108,100,32,110,111,116,32,99,114,101,97,116,101,32,88,80,111,105,110,116,101,114,32,99,111,110,116,101,120,116,10,0,0,0,0,0,0,88,80,111,105,110,116,101,114,32,101,118,97,108,117,97,116,105,111,110,32,102,97,105,108,101,100,58,32,35,37,115,10,0,0,0,0,0,0,0,0,88,80,111,105,110,116,101,114,32,105,115,32,110,111,116,32,97,32,114,97,110,103,101,58,32,35,37,115,10,0,0,0,88,80,111,105,110,116,101,114,32,115,101,108,101,99,116,115,32,97,110,32,97,116,116,114,105,98,117,116,101,58,32,35,37,115,10,0,0,0,0,0,88,80,111,105,110,116,101,114,32,115,101,108,101,99,116,115,32,97,32,110,97,109,101,115,112,97,99,101,58,32,35,37,115,10,0,0,0,0,0,0,88,80,111,105,110,116,101,114,32,115,101,108,101,99,116,115,32,117,110,101,120,112,101,99,116,101,100,32,110,111,100,101,115,58,32,35,37,115,10,0,98,97,115,101,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,116,114,121,105,110,103,32,116,111,32,98,117,105,108,100,32,114,101,108,97,116,105,118,101,32,85,82,73,32,102,114,111,109,32,37,115,10,0,0,0,116,114,121,105,110,103,32,116,111,32,114,101,98,117,105,108,100,32,98,97,115,101,32,102,114,111,109,32,37,115,10,0,112,114,111,99,101,115,115,105,110,103,32,100,111,99,0,0,109,105,115,109,97,116,99,104,32,105,110,32,114,101,100,101,102,105,110,105,116,105,111,110,32,111,102,32,101,110,116,105,116,121,32,37,115,10,0,0,99,97,110,110,111,116,32,97,108,108,111,99,97,116,101,32,112,97,114,115,101,114,32,99,111,110,116,101,120,116,0,0,120,112,111,105,110,116,101,114,0,0,0,0,0,0,0,0,73,110,118,97,108,105,100,32,102,114,97,103,109,101,110,116,32,105,100,101,110,116,105,102,105,101,114,32,105,110,32,85,82,73,32,37,115,32,117,115,101,32,116,104,101,32,120,112,111,105,110,116,101,114,32,97,116,116,114,105,98,117,116,101,10,0,0,0,0,0,0,0,100,101,116,101,99,116,101,100,32,97,32,108,111,99,97,108,32,114,101,99,117,114,115,105,111,110,32,119,105,116,104,32,110,111,32,120,112,111,105,110,116,101,114,32,105,110,32,37,115,10,0,0,0,0,0,0,100,101,116,101,99,116,101,100,32,97,32,114,101,99,117,114,115,105,111,110,32,105,110,32,37,115,10,0,0,0,0,0,103,114,111,119,105,110,103,32,88,73,110,99,108,117,100,101,32,99,111,110,116,101,120,116,0,0,0,0,0,0,0,0,105,110,99,108,117,100,101,0,37,115,32,104,97,115,32,97,110,32,39,105,110,99,108,117,100,101,39,32,99,104,105,108,100,10,0,0,0,0,0,0,37,115,32,104,97,115,32,109,117,108,116,105,112,108,101,32,102,97,108,108,98,97,99,107,32,99,104,105,108,100,114,101,110,10,0,0,0,0,0,0,37,115,32,105,115,32,110,111,116,32,116,104,101,32,99,104,105,108,100,32,111,102,32,97,110,32,39,105,110,99,108,117,100,101,39,10,0,0,0,0,97,100,100,105,110,103,32,85,82,76,0,0,0,0,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,32,58,32,37,115,10,0,0,0,0,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,10,0,0,1,0,0,0,0,0,0,0,82,101,115,111,108,118,101,58,32,112,117,98,73,68,32,37,115,32,115,121,115,73,68,32,37,115,10,0,0,0,0,0,82,101,115,111,108,118,101,58,32,112,117,98,73,68,32,37,115,10,0,0,0,0,0,0,82,101,115,111,108,118,101,58,32,115,121,115,73,68,32,37,115,10,0,0,0,0,0,0,82,101,115,111,108,118,101,32,85,82,73,32,37,115,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,77,76,95,68,69,66,85,71,95,67,65,84,65,76,79,71,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,77,76,95,67,65,84,65,76,79,71,95,70,73,76,69,83,0,0,0,0,0,0,0,102,105,108,101,58,47,47,47,101,116,99,47,120,109,108,47,99,97,116,97,108,111,103,0,67,97,116,97,108,111,103,115,32,99,108,101,97,110,117,112,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,99,97,116,97,108,111,103,0,3,0,0,0,0,0,0,0,65,100,100,105,110,103,32,100,111,99,117,109,101,110,116,32,99,97,116,97,108,111,103,32,37,115,10,0,0,0,0,0,76,111,99,97,108,32,82,101,115,111,108,118,101,58,32,112,117,98,73,68,32,37,115,32,115,121,115,73,68,32,37,115,10,0,0,0,0,0,0,0,76,111,99,97,108,32,82,101,115,111,108,118,101,58,32,112,117,98,73,68,32,37,115,10,0,0,0,0,0,0,0,0,76,111,99,97,108,32,82,101,115,111,108,118,101,58,32,115,121,115,73,68,32,37,115,10,0,0,0,0,0,0,0,0,70,111,117,110,100,32,37,115,32,105,110,32,102,105,108,101,32,104,97,115,104,10,0,0,37,115,32,110,111,116,32,102,111,117,110,100,32,105,110,32,102,105,108,101,32,104,97,115,104,10,0,0,0,0,0,0,37,115,32,97,100,100,101,100,32,116,111,32,102,105,108,101,32,104,97,115,104,10,0,0,70,97,105,108,101,100,32,116,111,32,112,97,114,115,101,32,99,97,116,97,108,111,103,32,37,115,10,0,0,0,0,0,37,100,32,80,97,114,115,105,110,103,32,99,97,116,97,108,111,103,32,37,115,10,0,0,117,114,110,58,111,97,115,105,115,58,110,97,109,101,115,58,116,99,58,101,110,116,105,116,121,58,120,109,108,110,115,58,120,109,108,58,99,97,116,97,108,111,103,0,0,0,0,0,112,114,101,102,101,114,0,0,115,121,115,116,101,109,0,0,112,117,98,108,105,99,0,0,73,110,118,97,108,105,100,32,118,97,108,117,101,32,102,111,114,32,112,114,101,102,101,114,58,32,39,37,115,39,10,0,70,105,108,101,32,37,115,32,105,115,32,110,111,116,32,97,110,32,88,77,76,32,67,97,116,97,108,111,103,10,0,0,103,114,111,117,112,0,0,0,105,100,0,0,0,0,0,0,98,97,115,101,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,112,117,98,108,105,99,73,100,0,0,0,0,0,0,0,0,117,114,105,0,0,0,0,0,115,121,115,116,101,109,73,100,0,0,0,0,0,0,0,0,114,101,119,114,105,116,101,83,121,115,116,101,109,0,0,0,115,121,115,116,101,109,73,100,83,116,97,114,116,83,116,114,105,110,103,0,0,0,0,0,114,101,119,114,105,116,101,80,114,101,102,105,120,0,0,0,100,101,108,101,103,97,116,101,80,117,98,108,105,99,0,0,112,117,98,108,105,99,73,100,83,116,97,114,116,83,116,114,105,110,103,0,0,0,0,0,100,101,108,101,103,97,116,101,83,121,115,116,101,109,0,0,110,97,109,101,0,0,0,0,114,101,119,114,105,116,101,85,82,73,0,0,0,0,0,0,117,114,105,83,116,97,114,116,83,116,114,105,110,103,0,0,100,101,108,101,103,97,116,101,85,82,73,0,0,0,0,0,110,101,120,116,67,97,116,97,108,111,103,0,0,0,0,0,37,115,32,101,110,116,114,121,32,108,97,99,107,115,32,39,37,115,39,10,0,0,0,0,70,111,117,110,100,32,37,115,58,32,39,37,115,39,32,39,37,115,39,10,0,0,0,0,70,111,117,110,100,32,37,115,58,32,39,37,115,39,10,0,37,115,32,101,110,116,114,121,32,39,37,115,39,32,98,114,111,107,101,110,32,63,58,32,37,115,10,0,0,0,0,0,83,89,83,84,69,77,0,0,80,85,66,76,73,67,0,0,68,69,76,69,71,65,84,69,0,0,0,0,0,0,0,0,69,78,84,73,84,89,0,0,68,79,67,84,89,80,69,0,76,73,78,75,84,89,80,69,0,0,0,0,0,0,0,0,78,79,84,65,84,73,79,78,0,0,0,0,0,0,0,0,83,71,77,76,68,69,67,76,0,0,0,0,0,0,0,0,68,79,67,85,77,69,78,84,0,0,0,0,0,0,0,0,67,65,84,65,76,79,71,0,66,65,83,69,0,0,0,0,117,114,110,58,112,117,98,108,105,99,105,100,58,0,0,0,85,82,78,32,73,68,32,37,115,32,101,120,112,97,110,100,101,100,32,116,111,32,78,85,76,76,10,0,0,0,0,0,85,82,78,32,73,68,32,101,120,112,97,110,100,101,100,32,116,111,32,37,115,10,0,0,68,101,116,101,99,116,101,100,32,114,101,99,117,114,115,105,111,110,32,105,110,32,99,97,116,97,108,111,103,32,37,115,10,0,0,0,0,0,0,0,70,111,117,110,100,32,85,82,73,32,109,97,116,99,104,32,37,115,10,0,0,0,0,0,85,115,105,110,103,32,114,101,119,114,105,116,105,110,103,32,114,117,108,101,32,37,115,10,0,0,0,0,0,0,0,0,84,114,121,105,110,103,32,85,82,73,32,100,101,108,101,103,97,116,101,32,37,115,10,0,80,117,98,108,105,99,32,85,82,78,32,73,68,32,37,115,32,101,120,112,97,110,100,101,100,32,116,111,32,78,85,76,76,10,0,0,0,0,0,0,80,117,98,108,105,99,32,85,82,78,32,73,68,32,101,120,112,97,110,100,101,100,32,116,111,32,37,115,10,0,0,0,83,121,115,116,101,109,32,85,82,78,32,73,68,32,37,115,32,101,120,112,97,110,100,101,100,32,116,111,32,78,85,76,76,10,0,0,0,0,0,0,83,121,115,116,101,109,32,85,82,78,32,73,68,32,101,120,112,97,110,100,101,100,32,116,111,32,37,115,10,0,0,0,70,111,117,110,100,32,115,121,115,116,101,109,32,109,97,116,99,104,32,37,115,44,32,117,115,105,110,103,32,37,115,10,0,0,0,0,0,0,0,0,84,114,121,105,110,103,32,115,121,115,116,101,109,32,100,101,108,101,103,97,116,101,32,37,115,10,0,0,0,0,0,0,70,111,117,110,100,32,112,117,98,108,105,99,32,109,97,116,99,104,32,37,115,10,0,0,84,114,121,105,110,103,32,112,117,98,108,105,99,32,100,101,108,101,103,97,116,101,32,37,115,10,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,99,97,116,97,108,111,103,32,101,110,116,114,121,0,0,0,0,0,0,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,32,58,32,37,115,10,0,0,79,86,69,82,82,73,68,69,0,0,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,112,117,98,108,105,99,32,73,68,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,99,97,116,97,108,111,103,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,99,97,116,97,108,111,103,32,100,97,116,97,0,70,114,101,101,32,99,97,116,97,108,111,103,32,101,110,116,114,121,32,37,115,10,0,0,70,114,101,101,32,99,97,116,97,108,111,103,32,101,110,116,114,121,10,0,0,0,0,0,0,0,0,0,0,0,0,0,31,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,33,0,0,0,0,0,0,0,34,0,0,0,0,0,0,0,50,48,57,48,50,0,0,0,96,18,2,0,0,0,0,0,1,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,35,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,32,32,0,0,0,0,0,0,8,19,2,0,0,0,0,0,0,0,0,0,0,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+125808),
allocate([57,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,60,0,0,0,0,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,51,0,0,0,0,0,0,0,53,0,0,0,65,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,120,101,99,117,116,105,110,103,32,99,49,52,110,0,0,105,110,118,97,108,105,100,32,109,111,100,101,32,102,111,114,32,101,120,101,99,117,116,105,110,103,32,99,49,52,110,0,120,109,108,67,49,52,78,69,120,101,99,117,116,101,58,32,111,117,116,112,117,116,32,98,117,102,102,101,114,32,101,110,99,111,100,101,114,32,33,61,32,78,85,76,76,32,98,117,116,32,67,49,52,78,32,114,101,113,117,105,114,101,115,32,85,84,70,56,32,111,117,116,112,117,116,10,0,0,0,0,120,109,108,67,49,52,78,69,120,101,99,117,116,101,58,32,117,110,97,98,108,101,32,116,111,32,99,114,101,97,116,101,32,67,49,52,78,32,99,111,110,116,101,120,116,10,0,0,112,114,111,99,101,115,115,105,110,103,32,100,111,99,115,32,99,104,105,108,100,114,101,110,32,108,105,115,116,0,0,0,102,108,117,115,104,105,110,103,32,111,117,116,112,117,116,32,98,117,102,102,101,114,0,0,100,117,109,112,105,110,103,32,100,111,99,32,116,111,32,109,101,109,111,114,121,0,0,0,99,114,101,97,116,105,110,103,32,111,117,116,112,117,116,32,98,117,102,102,101,114,0,0,115,97,118,105,110,103,32,100,111,99,32,116,111,32,111,117,116,112,117,116,32,98,117,102,102,101,114,0,0,0,0,0,99,111,112,105,110,103,32,99,97,110,111,110,105,99,97,110,105,122,101,100,32,100,111,99,117,109,101,110,116,0,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,32,58,32,37,115,10,0,0,102,114,101,101,105,110,103,32,99,111,110,116,101,120,116,0,100,101,115,116,114,111,121,105,110,103,32,110,97,109,101,115,112,97,99,101,115,32,115,116,97,99,107,0,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,32,58,32,37,115,10,0,0,0,0,112,114,111,99,101,115,115,105,110,103,32,110,111,100,101,32,108,105,115,116,0,0,0,0,112,114,111,99,101,115,115,105,110,103,32,110,111,100,101,0,110,111,114,109,97,108,105,122,105,110,103,32,116,101,120,116,32,110,111,100,101,0,0,0,10,60,63,0,0,0,0,0,60,63,0,0,0,0,0,0,32,0,0,0,0,0,0,0,110,111,114,109,97,108,105,122,105,110,103,32,112,105,32,110,111,100,101,0,0,0,0,0,63,62,10,0,0,0,0,0,63,62,0,0,0,0,0,0,10,60,33,45,45,0,0,0,60,33,45,45,0,0,0,0,110,111,114,109,97,108,105,122,105,110,103,32,99,111,109,109,101,110,116,32,110,111,100,101,0,0,0,0,0,0,0,0,45,45,62,10,0,0,0,0,45,45,62,0,0,0,0,0,88,77,76,95,65,84,84,82,73,66,85,84,69,95,78,79,68,69,0,0,0,0,0,0,88,77,76,95,78,65,77,69,83,80,65,67,69,95,68,69,67,76,0,0,0,0,0,0,88,77,76,95,69,78,84,73,84,89,95,82,69,70,95,78,79,68,69,0,0,0,0,0,88,77,76,95,69,78,84,73,84,89,95,78,79,68,69,0,85,110,107,110,111,119,110,32,110,111,100,101,32,116,121,112,101,32,37,100,32,102,111,117,110,100,32,58,32,37,115,10,0,0,0,0,0,0,0,0,78,111,100,101,32,37,115,32,105,115,32,105,110,118,97,108,105,100,32,104,101,114,101,32,58,32,37,115,10,0,0,0,97,108,108,111,99,97,116,105,110,103,32,98,117,102,102,101,114,0,0,0,0,0,0,0,103,114,111,119,105,110,103,32,98,117,102,102,101,114,0,0,112,114,111,99,101,115,115,105,110,103,32,101,108,101,109,101,110,116,32,110,111,100,101,0,99,104,101,99,107,105,110,103,32,102,111,114,32,114,101,108,97,116,105,118,101,32,110,97,109,101,115,112,97,99,101,115,0,0,0,0,0,0,0,0,60,0,0,0,0,0,0,0,58,0,0,0,0,0,0,0,112,114,111,99,101,115,115,105,110,103,32,110,97,109,101,115,112,97,99,101,115,32,97,120,105,115,0,0,0,0,0,0,112,114,111,99,101,115,115,105,110,103,32,97,116,116,114,105,98,117,116,101,115,32,97,120,105,115,0,0,0,0,0,0,62,0,0,0,0,0,0,0,112,114,111,99,101,115,115,105,110,103,32,99,104,105,108,100,114,101,110,115,32,108,105,115,116,0,0,0,0,0,0,0,60,47,0,0,0,0,0,0,114,101,115,116,111,114,105,110,103,32,110,97,109,101,115,112,97,99,101,115,32,115,116,97,99,107,0,0,0,0,0,0,99,114,101,97,116,105,110,103,32,97,116,116,114,105,98,117,116,101,115,32,108,105,115,116,0,0,0,0,0,0,0,0,108,97,110,103,0,0,0,0,115,112,97,99,101,0,0,0,98,97,115,101,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,119,114,105,116,105,110,103,32,97,116,116,114,105,98,117,116,101,115,0,0,0,0,0,0,61,34,0,0,0,0,0,0,110,111,114,109,97,108,105,122,105,110,103,32,97,116,116,114,105,98,117,116,101,115,32,97,120,105,115,0,0,0,0,0,34,0,0,0,0,0,0,0,112,114,111,99,101,115,115,105,110,103,32,120,109,108,58,98,97,115,101,32,97,116,116,114,105,98,117,116,101,0,0,0,112,114,111,99,101,115,115,105,110,103,32,120,109,108,58,98,97,115,101,32,97,116,116,114,105,98,117,116,101,32,45,32,99,97,110,39,116,32,103,101,116,32,97,116,116,114,32,118,97,108,117,101,0,0,0,0,47,0,0,0,0,0,0,0,112,114,111,99,101,115,115,105,110,103,32,120,109,108,58,98,97,115,101,32,97,116,116,114,105,98,117,116,101,32,45,32,99,97,110,39,116,32,109,111,100,105,102,121,32,117,114,105,0,0,0,0,0,0,0,0,112,114,111,99,101,115,115,105,110,103,32,120,109,108,58,98,97,115,101,32,97,116,116,114,105,98,117,116,101,32,45,32,99,97,110,39,116,32,99,111,110,115,116,114,117,99,116,32,117,114,105,0,0,0,0,0,0,0,0,0,0,0,0,0,112,114,111,99,101,115,115,105,110,103,32,120,109,108,58,98,97,115,101,32,97,116,116,114,105,98,117,116,101,32,45,32,99,97,110,39,116,32,99,111,110,115,116,114,117,99,116,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,0,0,120,109,108,0,0,0,0,0,115,104,105,102,116,105,110,103,32,110,97,109,101,115,112,97,99,101,115,32,115,116,97,99,107,0,0,0,0,0,0,0,112,114,111,99,101,115,115,105,110,103,32,110,97,109,101,115,112,97,99,101,115,32,97,120,105,115,32,40,101,120,99,32,99,49,52,110,41,0,0,0,99,114,101,97,116,105,110,103,32,110,97,109,101,115,112,97,99,101,115,32,108,105,115,116,32,40,101,120,99,32,99,49,52,110,41,0,0,0,0,0,35,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,119,114,105,116,105,110,103,32,110,97,109,101,115,112,97,99,101,115,0,0,0,0,0,0,32,120,109,108,110,115,58,0,61,0,0,0,0,0,0,0,32,120,109,108,110,115,61,0,34,34,0,0,0,0,0,0,115,101,97,114,99,104,105,110,103,32,110,97,109,101,115,112,97,99,101,115,32,115,116,97,99,107,32,40,101,120,99,32,99,49,52,110,41,0,0,0,97,100,100,105,110,103,32,110,97,109,101,115,112,97,99,101,32,116,111,32,115,116,97,99,107,0,0,0,0,0,0,0,97,100,100,105,110,103,32,110,111,100,101,32,116,111,32,115,116,97,99,107,0,0,0,0,115,101,97,114,99,104,105,110,103,32,110,97,109,101,115,112,97,99,101,115,32,115,116,97,99,107,32,40,99,49,52,110,41,0,0,0,0,0,0,0,112,114,111,99,101,115,115,105,110,103,32,110,97,109,101,115,112,97,99,101,115,32,97,120,105,115,32,40,99,49,52,110,41,0,0,0,0,0,0,0,99,114,101,97,116,105,110,103,32,110,97,109,101,115,112,97,99,101,115,32,108,105,115,116,32,40,99,49,52,110,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,115,97,118,105,110,103,32,110,97,109,101,115,112,97,99,101,115,32,115,116,97,99,107,0,112,97,114,115,105,110,103,32,110,97,109,101,115,112,97,99,101,32,117,114,105,0,0,0,117,114,110,0,0,0,0,0,100,97,118,0,0,0,0,0,82,101,108,97,116,105,118,101,32,110,97,109,101,115,112,97,99,101,32,85,82,32,105,115,32,105,110,118,97,108,105,100,32,104,101,114,101,32,58,32,37,115,10,0,0,0,0,0,99,114,101,97,116,105,110,103,32,110,101,119,32,99,111,110,116,101,120,116,0,0,0,0,120,109,108,67,49,52,78,78,101,119,67,116,120,58,32,111,117,116,112,117,116,32,98,117,102,102,101,114,32,101,110,99,111,100,101,114,32,33,61,32,78,85,76,76,32,98,117,116,32,67,49,52,78,32,114,101,113,117,105,114,101,115,32,85,84,70,56,32,111,117,116,112,117,116,10,0,0,0,0,0,120,109,108,67,49,52,78,78,101,119,67,116,120,58,32,115,111,117,114,99,101,32,100,111,99,117,109,101,110,116,32,110,111,116,32,105,110,32,85,84,70,56,10,0,0,0,0,0,99,114,101,97,116,105,110,103,32,99,111,110,116,101,120,116,0,0,0,0,0,0,0,0,120,109,108,67,49,52,78,78,101,119,67,116,120,58,32,120,109,108,67,49,52,78,86,105,115,105,98,108,101,78,115,83,116,97,99,107,67,114,101,97,116,101,32,102,97,105,108,101,100,10,0,0,0,0,0,0,99,114,101,97,116,105,110,103,32,110,97,109,101,115,112,97,99,101,115,32,115,116,97,99,107,0,0,0,0,0,0,0,37,115,0,0,0,0,0,0,73,110,118,97,108,105,100,32,112,97,114,97,109,101,116,101,114,32,58,32,37,115,10,0,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,109,97,108,108,111,99,32,111,102,32,37,108,100,32,98,121,116,101,32,102,97,105,108,101,100,10,0,0,0,0,0,0,99,114,101,97,116,105,110,103,32,98,117,102,102,101,114,0,0,0,0,0,0,0,0,0,103,114,111,119,105,110,103,32,98,117,102,102,101,114,0,0,34,0,0,0,0,0,0,0,38,113,117,111,116,59,0,0,39,0,0,0,0,0,0,0,73,110,112,117,116,32,114,101,102,101,114,101,110,99,101,32,111,117,116,115,105,100,101,32,111,102,32,116,104,101,32,98,117,102,102,101,114,0,0,0,99,114,101,97,116,105,110,103,32,101,120,101,99,117,116,105,111,110,32,99,111,110,116,101,120,116,0,0,0,0,0,0,120,109,108,70,65,80,97,114,115,101,82,101,103,69,120,112,58,32,101,120,116,114,97,32,99,104,97,114,97,99,116,101,114,115,0,0,0,0,0,0,110,111,116,32,37,115,0,0,97,116,111,109,32,112,117,115,104,58,32,97,116,111,109,32,105,115,32,78,85,76,76,0,112,117,115,104,105,110,103,32,97,116,111,109,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,99,111,117,110,116,101,114,0,0,0,0,0,0,97,100,100,32,115,116,97,116,101,58,32,115,116,97,116,101,32,105,115,32,78,85,76,76,0,0,0,0,0,0,0,0,97,100,100,32,115,116,97,116,101,58,32,116,97,114,103,101,116,32,105,115,32,78,85,76,76,0,0,0,0,0,0,0,97,100,100,105,110,103,32,116,114,97,110,115,105,116,105,111,110,0,0,0,0,0,0,0,103,101,110,114,97,116,101,32,116,114,97,110,115,105,116,105,111,110,58,32,97,116,111,109,32,61,61,32,78,85,76,76,0,0,0,0,0,0,0,0,99,111,112,121,105,110,103,32,97,116,111,109,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,114,97,110,103,101,0,0,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,97,116,111,109,0,84,79,68,79,58,32,88,77,76,95,82,69,71,69,88,80,95,83,84,82,73,78,71,10,0,0,0,0,0,0,0,0,114,117,110,110,105,110,103,32,114,101,103,101,120,112,0,0,101,112,115,105,108,111,110,32,116,114,97,110,115,105,116,105,111,110,32,108,101,102,116,32,97,116,32,114,117,110,116,105,109,101,10,0,0,0,0,0,101,120,101,99,32,115,97,118,101,58,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,0,0,0,0,115,97,118,105,110,103,32,114,101,103,101,120,112,0,0,0,99,111,109,112,105,108,105,110,103,32,114,101,103,101,120,112,0,0,0,0,0,0,0,0,102,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,58,32,37,115,10,0,0,101,120,112,101,99,116,105,110,103,32,97,32,98,114,97,110,99,104,32,97,102,116,101,114,32,124,0,0,0,0,0,0,105,110,116,101,114,110,97,108,58,32,110,111,32,97,116,111,109,32,103,101,110,101,114,97,116,101,100,0,0,0,0,0,73,109,112,114,111,112,101,114,32,113,117,97,110,116,105,102,105,101,114,0,0,0,0,0,85,110,116,101,114,109,105,110,97,116,101,100,32,113,117,97,110,116,105,102,105,101,114,0,120,109,108,70,65,80,97,114,115,101,65,116,111,109,58,32,101,120,112,101,99,116,105,110,103,32,39,41,39,0,0,0,120,109,108,70,65,80,97,114,115,101,67,104,97,114,67,108,97,115,115,58,32,39,93,39,32,101,120,112,101,99,116,101,100,0,0,0,0,0,0,0,69,115,99,97,112,101,100,32,115,101,113,117,101,110,99,101,58,32,101,120,112,101,99,116,105,110,103,32,92,0,0,0,69,120,112,101,99,116,105,110,103,32,39,123,39,0,0,0,69,120,112,101,99,116,105,110,103,32,39,125,39,0,0,0,87,114,111,110,103,32,101,115,99,97,112,101,32,115,101,113,117,101,110,99,101,44,32,109,105,115,117,115,101,32,111,102,32,99,104,97,114,97,99,116,101,114,32,39,92,39,0,0,73,115,88,88,88,88,32,101,120,112,101,99,116,101,100,0,85,110,107,110,111,119,110,32,99,104,97,114,32,112,114,111,112,101,114,116,121,0,0,0,97,100,100,32,114,97,110,103,101,58,32,97,116,111,109,32,105,115,32,78,85,76,76,0,97,100,100,32,114,97,110,103,101,58,32,97,116,111,109,32,105,115,32,110,111,116,32,114,97,110,103,101,115,0,0,0,97,100,100,105,110,103,32,114,97,110,103,101,115,0,0,0,99,104,97,114,67,108,97,115,115,69,120,112,114,58,32,39,93,39,32,101,120,112,101,99,116,101,100,0,0,0,0,0,69,120,112,101,99,116,105,110,103,32,39,93,39,0,0,0,73,110,118,97,108,105,100,32,101,115,99,97,112,101,32,118,97,108,117,101,0,0,0,0,69,120,112,101,99,116,105,110,103,32,97,32,99,104,97,114,32,114,97,110,103,101,0,0,69,120,112,101,99,116,105,110,103,32,116,104,101,32,101,110,100,32,111,102,32,97,32,99,104,97,114,32,114,97,110,103,101,0,0,0,0,0,0,0,69,110,100,32,111,102,32,114,97,110,103,101,32,105,115,32,98,101,102,111,114,101,32,115,116,97,114,116,32,111,102,32,114,97,110,103,101,0,0,0,97,100,100,105,110,103,32,115,116,97,116,101,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,115,116,97,116,101,0,0,0,0,0,0,0,0,85,110,105,109,112,108,101,109,101,110,116,101,100,32,98,108,111,99,107,32,97,116,32,37,115,58,37,100,10,0,0,0,46,46,47,108,105,98,120,109,108,50,47,120,109,108,114,101,103,101,120,112,46,99,0,0,112,117,115,104,105,110,103,32,105,110,112,117,116,32,115,116,114,105,110,103,0,0,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,32,58,32,37,115,10,0,0,85,110,105,109,112,108,101,109,101,110,116,101,100,32,98,108,111,99,107,32,97,116,32,37,115,58,37,100,10,0,0,0,46,46,47,108,105,98,120,109,108,50,47,120,109,108,115,99,104,101,109,97,115,46,99,0,10,0,0,0,0,0,0,0,120,109,108,83,99,104,101,109,97,67,104,101,99,107,70,97,99,101,116,0,0,0,0,0,97,32,116,121,112,101,32,117,115,101,114,32,100,101,114,105,118,101,100,32,116,121,112,101,32,104,97,115,32,110,111,32,98,97,115,101,32,116,121,112,101,0,0,0,0,0,0,0,42,0,0,0,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,120,109,108,83,99,104,101,109,97,67,104,101,99,107,70,97,99,101,116,44,32,102,97,105,108,101,100,32,116,111,32,118,97,108,105,100,97,116,101,32,116,104,101,32,118,97,108,117,101,32,39,37,115,39,32,111,102,32,116,104,101,32,102,97,99,101,116,32,39,37,115,39,32,97,103,97,105,110,115,116,32,116,104,101,32,98,97,115,101,32,116,121,112,101,0,0,84,104,101,32,118,97,108,117,101,32,39,37,115,39,32,111,102,32,116,104,101,32,102,97,99,101,116,32,100,111,101,115,32,110,111,116,32,118,97,108,105,100,97,116,101,32,97,103,97,105,110,115,116,32,116,104,101,32,98,97,115,101,32,116,121,112,101,32,39,37,115,39,0,0,0,0,0,0,0,0,118,97,108,117,101,32,119,97,115,32,110,111,116,32,99,111,109,112,117,116,101,100,0,0,84,104,101,32,118,97,108,117,101,32,39,37,115,39,32,111,102,32,116,104,101,32,102,97,99,101,116,32,39,112,97,116,116,101,114,110,39,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,114,101,103,117,108,97,114,32,101,120,112,114,101,115,115,105,111,110,0,118,97,108,105,100,97,116,105,110,103,32,102,97,99,101,116,32,118,97,108,117,101,0,0,84,104,101,32,118,97,108,117,101,32,39,37,115,39,32,111,102,32,116,104,101,32,102,97,99,101,116,32,39,37,115,39,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,39,37,115,39,0,0,0,0,110,111,110,78,101,103,97,116,105,118,101,73,110,116,101,103,101,114,0,0,0,0,0,0,112,111,115,105,116,105,118,101,73,110,116,101,103,101,114,0,112,114,101,115,101,114,118,101,0,0,0,0,0,0,0,0,114,101,112,108,97,99,101,0,99,111,108,108,97,112,115,101,0,0,0,0,0,0,0,0,84,104,101,32,118,97,108,117,101,32,39,37,115,39,32,111,102,32,116,104,101,32,102,97,99,101,116,32,39,119,104,105,116,101,115,112,97,99,101,39,32,105,115,32,110,111,116,32,118,97,108,105,100,0,0,0,70,97,105,108,101,100,32,116,111,32,108,111,99,97,116,101,32,116,104,101,32,109,97,105,110,32,115,99,104,101,109,97,32,114,101,115,111,117,114,99,101,32,97,116,32,39,37,115,39,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,108,111,99,97,116,101,32,116,104,101,32,109,97,105,110,32,115,99,104,101,109,97,32,114,101,115,111,117,114,99,101,0,0,0,0,0,0,0,120,109,108,83,99,104,101,109,97,80,97,114,115,101,0,0,65,110,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,32,111,99,99,117,114,101,100,0,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,118,97,108,105,100,97,116,105,111,110,32,99,111,110,116,101,120,116,0,0,0,84,104,101,32,100,111,99,117,109,101,110,116,32,104,97,115,32,110,111,32,100,111,99,117,109,101,110,116,32,101,108,101,109,101,110,116,0,0,0,0,120,109,108,83,99,104,101,109,97,65,117,103,109,101,110,116,73,68,67,58,32,97,108,108,111,99,97,116,105,110,103,32,97,110,32,97,117,103,109,101,110,116,101,100,32,73,68,67,32,100,101,102,105,110,105,116,105,111,110,0,0,0,0,0,120,109,108,83,99,104,101,109,97,67,114,101,97,116,101,80,67,116,120,116,79,110,86,67,116,120,116,0,0,0,0,0,102,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,97,32,116,101,109,112,46,32,112,97,114,115,101,114,32,99,111,110,116,101,120,116,0,120,109,108,83,99,104,101,109,97,83,65,88,72,97,110,100,108,101,67,68,97,116,97,83,101,99,116,105,111,110,0,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,86,80,117,115,104,84,101,120,116,40,41,0,0,0,0,78,101,105,116,104,101,114,32,99,104,97,114,97,99,116,101,114,32,110,111,114,32,101,108,101,109,101,110,116,32,99,111,110,116,101,110,116,32,105,115,32,97,108,108,111,119,101,100,32,98,101,99,97,117,115,101,32,116,104,101,32,101,108,101,109,101,110,116,32,105,115,32,39,110,105,108,108,101,100,39,0,0,0,0,0,0,0,0,67,104,97,114,97,99,116,101,114,32,99,111,110,116,101,110,116,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,44,32,98,101,99,97,117,115,101,32,116,104,101,32,99,111,110,116,101,110,116,32,116,121,112,101,32,105,115,32,101,109,112,116,121,0,0,0,0,0,67,104,97,114,97,99,116,101,114,32,99,111,110,116,101,110,116,32,111,116,104,101,114,32,116,104,97,110,32,119,104,105,116,101,115,112,97,99,101,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,32,98,101,99,97,117,115,101,32,116,104,101,32,99,111,110,116,101,110,116,32,116,121,112,101,32,105,115,32,39,101,108,101,109,101,110,116,45,111,110,108,121,39,0,0,0,0,0,0,0,120,109,108,83,99,104,101,109,97,83,65,88,72,97,110,100,108,101,69,110,100,69,108,101,109,101,110,116,78,115,0,0,101,108,101,109,32,112,111,112,32,109,105,115,109,97,116,99,104,0,0,0,0,0,0,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,86,97,108,105,100,97,116,111,114,80,111,112,69,108,101,109,40,41,0,0,0,0,0,120,109,108,83,99,104,101,109,97,86,97,108,105,100,97,116,111,114,80,111,112,69,108,101,109,0,0,0,0,0,0,0,102,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,97,32,114,101,103,101,120,32,99,111,110,116,101,120,116,0,0,0,0,0,0,0,0,77,105,115,115,105,110,103,32,99,104,105,108,100,32,101,108,101,109,101,110,116,40,115,41,0,0,0,0,0,0,0,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,86,67,104,101,99,107,67,86,67,83,105,109,112,108,101,84,121,112,101,40,41,0,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,67,104,101,99,107,67,79,83,86,97,108,105,100,68,101,102,97,117,108,116,40,41,0,99,97,108,108,105,110,103,32,120,109,108,78,101,119,84,101,120,116,40,41,0,0,0,0,84,104,101,32,99,111,110,116,101,110,116,32,109,117,115,116,32,110,111,116,32,99,111,110,116,97,105,110,116,32,101,108,101,109,101,110,116,32,110,111,100,101,115,32,115,105,110,99,101,32,116,104,101,114,101,32,105,115,32,97,32,102,105,120,101,100,32,118,97,108,117,101,32,99,111,110,115,116,114,97,105,110,116,0,0,0,0,0,84,104,101,32,105,110,105,116,105,97,108,32,118,97,108,117,101,32,39,37,115,39,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,102,105,120,101,100,32,118,97,108,117,101,32,99,111,110,115,116,114,97,105,110,116,32,39,37,115,39,0,0,0,84,104,101,32,97,99,116,117,97,108,32,118,97,108,117,101,32,39,37,115,39,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,102,105,120,101,100,32,118,97,108,117,101,32,99,111,110,115,116,114,97,105,110,116,32,39,37,115,39,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,73,68,67,32,108,105,115,116,32,111,102,32,110,111,100,101,45,116,97,98,108,101,32,105,116,101,109,115,0,114,101,45,97,108,108,111,99,97,116,105,110,103,32,73,68,67,32,108,105,115,116,32,111,102,32,110,111,100,101,45,116,97,98,108,101,32,105,116,101,109,115,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,97,110,32,97,114,114,97,121,32,111,102,32,73,68,67,32,110,111,100,101,45,116,97,98,108,101,32,105,116,101,109,115,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,97,32,80,83,86,73,32,73,68,67,32,98,105,110,100,105,110,103,32,105,116,101,109,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,110,101,119,32,105,116,101,109,32,108,105,115,116,0,0,0,0,0,0,0,0,103,114,111,119,105,110,103,32,105,116,101,109,32,108,105,115,116,0,0,0,0,0,0,0,77,111,114,101,32,116,104,97,110,32,111,110,101,32,109,97,116,99,104,32,102,111,117,110,100,32,102,111,114,32,107,101,121,45,115,101,113,117,101,110,99,101,32,37,115,32,111,102,32,107,101,121,114,101,102,32,39,37,115,39,0,0,0,0,78,111,32,109,97,116,99,104,32,102,111,117,110,100,32,102,111,114,32,107,101,121,45,115,101,113,117,101,110,99,101,32,37,115,32,111,102,32,107,101,121,114,101,102,32,39,37,115,39,0,0,0,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,49,47,88,77,76,83,99,104,101,109,97,0,0,0,0,0,0,0,0,91,0,0,0,0,0,0,0,39,0,0,0,0,0,0,0,120,109,108,83,99,104,101,109,97,70,111,114,109,97,116,73,68,67,75,101,121,83,101,113,117,101,110,99,101,0,0,0,102,97,105,108,101,100,32,116,111,32,99,111,109,112,117,116,101,32,97,32,99,97,110,111,110,105,99,97,108,32,118,97,108,117,101,0,0,0,0,0,63,63,63,0,0,0,0,0,39,44,32,0,0,0,0,0,93,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,69,108,101,109,101,110,116,32,39,37,115,39,58,32,0,0,46,10,0,0,0,0,0,0,114,101,45,97,108,108,111,99,97,116,105,110,103,32,97,110,32,97,114,114,97,121,32,111,102,32,73,68,67,32,110,111,100,101,45,116,97,98,108,101,32,105,116,101,109,115,0,0,120,109,108,83,99,104,101,109,97,88,80,97,116,104,80,114,111,99,101,115,115,72,105,115,116,111,114,121,0,0,0,0,99,97,108,108,105,110,103,32,120,109,108,83,116,114,101,97,109,80,111,112,40,41,0,0,102,105,101,108,100,32,114,101,115,111,108,118,101,115,32,116,111,32,97,32,67,84,32,119,105,116,104,32,115,105,109,112,108,101,32,99,111,110,116,101,110,116,32,98,117,116,32,116,104,101,32,67,84,32,105,115,32,109,105,115,115,105,110,103,32,116,104,101,32,83,84,32,100,101,102,105,110,105,116,105,111,110,0,0,0,0,0,0,84,104,101,32,88,80,97,116,104,32,39,37,115,39,32,111,102,32,97,32,102,105,101,108,100,32,111,102,32,37,115,32,100,111,101,115,32,101,118,97,108,117,97,116,101,32,116,111,32,97,32,110,111,100,101,32,111,102,32,110,111,110,45,115,105,109,112,108,101,32,116,121,112,101,0,0,0,0,0,0,87,97,114,110,105,110,103,58,32,78,111,32,112,114,101,99,111,109,112,117,116,101,100,32,118,97,108,117,101,32,97,118,97,105,108,97,98,108,101,44,32,116,104,101,32,118,97,108,117,101,32,119,97,115,32,101,105,116,104,101,114,32,105,110,118,97,108,105,100,32,111,114,32,115,111,109,101,116,104,105,110,103,32,115,116,114,97,110,103,101,32,104,97,112,112,101,110,100,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,97,110,32,97,114,114,97,121,32,111,102,32,107,101,121,45,115,101,113,117,101,110,99,101,115,0,0,0,0,114,101,97,108,108,111,99,97,116,105,110,103,32,97,110,32,97,114,114,97,121,32,111,102,32,107,101,121,45,115,101,113,117,101,110,99,101,115,0,0,84,104,101,32,88,80,97,116,104,32,39,37,115,39,32,111,102,32,97,32,102,105,101,108,100,32,111,102,32,37,115,32,101,118,97,108,117,97,116,101,115,32,116,111,32,97,32,110,111,100,101,45,115,101,116,32,119,105,116,104,32,109,111,114,101,32,116,104,97,110,32,111,110,101,32,109,101,109,98,101,114,0,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,97,110,32,73,68,67,32,107,101,121,45,115,101,113,117,101,110,99,101,0,0,97,108,108,111,99,97,116,105,110,103,32,97,32,73,68,67,32,107,101,121,0,0,0,0,68,117,112,108,105,99,97,116,101,32,107,101,121,45,115,101,113,117,101,110,99,101,32,37,115,32,105,110,32,37,115,0,97,108,108,111,99,97,116,105,110,103,32,97,110,32,73,68,67,32,110,111,100,101,45,116,97,98,108,101,32,105,116,101,109,0,0,0,0,0,0,0,78,111,116,32,97,108,108,32,102,105,101,108,100,115,32,111,102,32,37,115,32,101,118,97,108,117,97,116,101,32,116,111,32,97,32,110,111,100,101,0,84,104,101,32,115,116,97,116,101,32,111,98,106,101,99,116,32,116,111,32,98,101,32,114,101,109,111,118,101,100,32,105,115,32,110,111,116,32,116,104,101,32,102,105,114,115,116,32,105,110,32,116,104,101,32,108,105,115,116,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,116,104,101,32,73,68,67,32,110,111,100,101,32,116,97,98,108,101,32,105,116,101,109,32,108,105,115,116,0,114,101,45,97,108,108,111,99,97,116,105,110,103,32,116,104,101,32,73,68,67,32,110,111,100,101,32,116,97,98,108,101,32,105,116,101,109,32,108,105,115,116,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,116,104,101,32,73,68,67,32,107,101,121,32,115,116,111,114,97,103,101,32,108,105,115,116,0,0,0,0,0,114,101,45,97,108,108,111,99,97,116,105,110,103,32,116,104,101,32,73,68,67,32,107,101,121,32,115,116,111,114,97,103,101,32,108,105,115,116,0,0,32,39,0,0,0,0,0,0,99,111,109,112,108,101,120,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,0,115,105,109,112,108,101,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,0,0,101,108,101,109,101,110,116,32,100,101,99,108,97,114,97,116,105,111,110,0,0,0,0,0,97,116,116,114,105,98,117,116,101,32,117,115,101,0,0,0,97,116,116,114,105,98,117,116,101,32,100,101,99,108,97,114,97,116,105,111,110,0,0,0,109,111,100,101,108,32,103,114,111,117,112,32,100,101,102,105,110,105,116,105,111,110,0,0,97,116,116,114,105,98,117,116,101,32,103,114,111,117,112,32,100,101,102,105,110,105,116,105,111,110,0,0,0,0,0,0,110,111,116,97,116,105,111,110,32,100,101,99,108,97,114,97,116,105,111,110,0,0,0,0,109,111,100,101,108,32,103,114,111,117,112,32,40,115,101,113,117,101,110,99,101,41,0,0,109,111,100,101,108,32,103,114,111,117,112,32,40,99,104,111,105,99,101,41,0,0,0,0,109,111,100,101,108,32,103,114,111,117,112,32,40,97,108,108,41,0,0,0,0,0,0,0,112,97,114,116,105,99,108,101,0,0,0,0,0,0,0,0,117,110,105,113,117,101,32,105,100,101,110,116,105,116,121,45,99,111,110,115,116,114,97,105,110,116,0,0,0,0,0,0,107,101,121,32,105,100,101,110,116,105,116,121,45,99,111,110,115,116,114,97,105,110,116,0,107,101,121,114,101,102,32,105,100,101,110,116,105,116,121,45,99,111,110,115,116,114,97,105,110,116,0,0,0,0,0,0,119,105,108,100,99,97,114,100,32,40,97,110,121,41,0,0,91,104,101,108,112,101,114,32,99,111,109,112,111,110,101,110,116,93,32,81,78,97,109,101,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,91,104,101,108,112,101,114,32,99,111,109,112,111,110,101,110,116,93,32,97,116,116,114,105,98,117,116,101,32,117,115,101,32,112,114,111,104,105,98,105,116,105,111,110,0,0,0,0,78,111,116,32,97,32,115,99,104,101,109,97,32,99,111,109,112,111,110,101,110,116,0,0,70,111,114,32,97,32,115,116,114,105,110,103,32,116,111,32,98,101,32,97,32,118,97,108,105,100,32,100,101,102,97,117,108,116,44,32,116,104,101,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,32,109,117,115,116,32,98,101,32,97,32,115,105,109,112,108,101,32,116,121,112,101,32,111,114,32,97,32,99,111,109,112,108,101,120,32,116,121,112,101,32,119,105,116,104,32,115,105,109,112,108,101,32,99,111,110,116,101,110,116,32,111,114,32,109,105,120,101,100,32,99,111,110,116,101,110,116,32,97,110,100,32,97,32,112,97,114,116,105,99,108,101,32,101,109,112,116,105,97,98,108,101,0,0,0,120,109,108,83,99,104,101,109,97,67,104,101,99,107,67,79,83,86,97,108,105,100,68,101,102,97,117,108,116,0,0,0,46,0,0,0,0,0,0,0,32,69,120,112,101,99,116,101,100,32,105,115,32,111,110,101,32,111,102,32,40,32,0,0,32,69,120,112,101,99,116,101,100,32,105,115,32,40,32,0,35,35,111,116,104,101,114,0,123,42,125,0,0,0,0,0,123,35,35,111,116,104,101,114,58,0,0,0,0,0,0,0,123,0,0,0,0,0,0,0,125,0,0,0,0,0,0,0,44,32,0,0,0,0,0,0,32,41,46,10,0,0,0,0,69,108,101,109,101,110,116,32,39,0,0,0,0,0,0,0,97,116,116,114,105,98,117,116,101,32,39,0,0,0,0,0,39,58,32,0,0,0,0,0,120,109,108,83,99,104,101,109,97,83,65,88,72,97,110,100,108,101,83,116,97,114,116,69,108,101,109,101,110,116,78,115,0,0,0,0,0,0,0,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,86,97,108,105,100,97,116,111,114,80,117,115,104,69,108,101,109,40,41,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,110,97,109,101,115,112,97,99,101,32,98,105,110,100,105,110,103,115,32,102,111,114,32,83,65,88,32,118,97,108,105,100,97,116,105,111,110,0,0,0,0,0,0,0,0,114,101,45,97,108,108,111,99,97,116,105,110,103,32,110,97,109,101,115,112,97,99,101,32,98,105,110,100,105,110,103,115,32,102,111,114,32,83,65,88,32,118,97,108,105,100,97,116,105,111,110,0,0,0,0,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,86,97,108,105,100,97,116,111,114,80,117,115,104,65,116,116,114,105,98,117,116,101,40,41,0,0,0,0,0,0,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,86,97,108,105,100,97,116,101,69,108,101,109,40,41,0,120,109,108,83,99,104,101,109,97,86,97,108,105,100,97,116,101,69,108,101,109,0,0,0,105,110,32,115,107,105,112,45,115,116,97,116,101,0,0,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,83,116,114,101,97,109,86,97,108,105,100,97,116,101,67,104,105,108,100,69,108,101,109,101,110,116,40,41,0,0,0,116,104,101,32,99,104,105,108,100,32,101,108,101,109,101,110,116,32,119,97,115,32,118,97,108,105,100,32,98,117,116,32,110,101,105,116,104,101,114,32,116,104,101,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,114,32,116,104,101,32,116,121,112,101,32,119,97,115,32,115,101,116,0,0,0,0,78,111,32,109,97,116,99,104,105,110,103,32,103,108,111,98,97,108,32,100,101,99,108,97,114,97,116,105,111,110,32,97,118,97,105,108,97,98,108,101,32,102,111,114,32,116,104,101,32,118,97,108,105,100,97,116,105,111,110,32,114,111,111,116,0,0,0,0,0,0,0,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,86,97,108,105,100,97,116,101,69,108,101,109,87,105,108,100,99,97,114,100,40,41,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,86,97,108,105,100,97,116,101,69,108,101,109,68,101,99,108,40,41,0,0,0,0,0,84,104,101,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,32,105,115,32,97,98,115,101,110,116,0,0,0,84,104,101,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,32,105,115,32,97,98,115,116,114,97,99,116,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,88,80,97,116,104,69,118,97,108,117,97,116,101,40,41,0,0,0,0,0,0,0,0,99,97,108,108,105,110,103,32,97,116,116,114,105,98,117,116,101,115,32,118,97,108,105,100,97,116,105,111,110,0,0,0,84,104,101,32,97,116,116,114,105,98,117,116,101,32,39,37,115,39,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,46,10,0,0,0,0,0,120,109,108,83,99,104,101,109,97,86,65,116,116,114,105,98,117,116,101,115,67,111,109,112,108,101,120,0,0,0,0,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,71,101,116,70,114,101,115,104,65,116,116,114,73,110,102,111,40,41,0,0,0,0,0,100,101,102,97,117,108,116,47,102,105,120,101,100,32,118,97,108,117,101,32,111,110,32,97,110,32,97,116,116,114,105,98,117,116,101,32,117,115,101,32,119,97,115,32,110,111,116,32,112,114,101,99,111,109,112,117,116,101,100,0,0,0,0,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,67,111,112,121,86,97,108,117,101,40,41,0,0,0,0,99,97,108,108,108,105,110,103,32,120,109,108,78,101,119,80,114,111,112,40,41,0,0,0,112,37,100,0,0,0,0,0,99,111,117,108,100,32,110,111,116,32,99,111,109,112,117,116,101,32,97,32,110,115,32,112,114,101,102,105,120,32,102,111,114,32,97,32,100,101,102,97,117,108,116,47,102,105,120,101,100,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,83,116,114,101,97,109,86,97,108,105,100,97,116,101,83,105,109,112,108,101,84,121,112,101,86,97,108,117,101,40,41,0,0,0,0,0,0,0,0,84,104,101,32,97,116,116,114,105,98,117,116,101,32,39,37,115,39,32,105,115,32,114,101,113,117,105,114,101,100,32,98,117,116,32,109,105,115,115,105,110,103,0,0,0,0,0,0,84,104,101,32,118,97,108,117,101,32,39,37,115,39,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,102,105,120,101,100,32,118,97,108,117,101,32,99,111,110,115,116,114,97,105,110,116,32,39,37,115,39,0,0,0,78,111,32,109,97,116,99,104,105,110,103,32,103,108,111,98,97,108,32,97,116,116,114,105,98,117,116,101,32,100,101,99,108,97,114,97,116,105,111,110,32,97,118,97,105,108,97,98,108,101,44,32,98,117,116,32,100,101,109,97,110,100,101,100,32,98,121,32,116,104,101,32,115,116,114,105,99,116,32,119,105,108,100,99,97,114,100,0,35,35,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,97,116,116,114,105,98,117,116,101,32,105,110,102,111,32,108,105,115,116,0,0,114,101,45,97,108,108,111,99,97,116,105,110,103,32,97,116,116,114,105,98,117,116,101,32,105,110,102,111,32,108,105,115,116,0,0,0,0,0,0,0,120,109,108,83,99,104,101,109,97,71,101,116,70,114,101,115,104,65,116,116,114,73,110,102,111,0,0,0,0,0,0,0,97,116,116,114,32,105,110,102,111,32,110,111,116,32,99,108,101,97,114,101,100,0,0,0,99,114,101,97,116,105,110,103,32,110,101,119,32,97,116,116,114,105,98,117,116,101,32,105,110,102,111,0,0,0,0,0,120,109,108,83,99,104,101,109,97,88,80,97,116,104,69,118,97,108,117,97,116,101,0,0,99,97,108,108,105,110,103,32,120,109,108,83,116,114,101,97,109,80,117,115,104,40,41,0,97,108,108,111,99,97,116,105,110,103,32,116,104,101,32,115,116,97,116,101,32,111,98,106,101,99,116,32,104,105,115,116,111,114,121,0,0,0,0,0,114,101,45,97,108,108,111,99,97,116,105,110,103,32,116,104,101,32,115,116,97,116,101,32,111,98,106,101,99,116,32,104,105,115,116,111,114,121,0,0,97,108,108,111,99,97,116,105,110,103,32,97,110,32,73,68,67,32,115,116,97,116,101,32,111,98,106,101,99,116,0,0,120,109,108,83,99,104,101,109,97,73,68,67,65,100,100,83,116,97,116,101,79,98,106,101,99,116,0,0,0,0,0,0,102,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,97,110,32,88,80,97,116,104,32,118,97,108,105,100,97,116,105,111,110,32,99,111,110,116,101,120,116,0,0,0,0,78,111,32,109,97,116,99,104,105,110,103,32,100,101,99,108,97,114,97,116,105,111,110,32,97,118,97,105,108,97,98,108,101,0,0,0,0,0,0,0,84,104,101,32,101,108,101,109,101,110,116,32,100,101,99,108,97,114,97,116,105,111,110,32,105,115,32,97,98,115,116,114,97,99,116,0,0,0,0,0,120,109,108,83,99,104,101,109,97,86,97,108,105,100,97,116],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+136048),
allocate([101,69,108,101,109,68,101,99,108,0,0,0,0,0,0,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,86,67,104,101,99,107,67,86,67,83,105,109,112,108,101,84,121,112,101,40,41,32,116,111,32,118,97,108,105,100,97,116,101,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,39,120,115,105,58,110,105,108,39,0,0,0,0,0,0,84,104,101,32,101,108,101,109,101,110,116,32,105,115,32,110,111,116,32,39,110,105,108,108,97,98,108,101,39,0,0,0,84,104,101,32,101,108,101,109,101,110,116,32,99,97,110,110,111,116,32,98,101,32,39,110,105,108,108,101,100,39,32,98,101,99,97,117,115,101,32,116,104,101,114,101,32,105,115,32,97,32,102,105,120,101,100,32,118,97,108,117,101,32,99,111,110,115,116,114,97,105,110,116,32,100,101,102,105,110,101,100,32,102,111,114,32,105,116,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,80,114,111,99,101,115,115,88,83,73,84,121,112,101,40,41,32,116,111,32,112,114,111,99,101,115,115,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,39,120,115,105,58,116,121,112,101,39,0,0,0,120,109,108,83,99,104,101,109,97,73,68,67,82,101,103,105,115,116,101,114,77,97,116,99,104,101,114,115,0,0,0,0,84,104,101,32,99,104,97,105,110,32,111,102,32,73,68,67,32,109,97,116,99,104,101,114,115,32,105,115,32,101,120,112,101,99,116,101,100,32,116,111,32,98,101,32,101,109,112,116,121,0,0,0,0,0,0,0,67,111,117,108,100,32,110,111,116,32,102,105,110,100,32,97,110,32,97,117,103,109,101,110,116,101,100,32,73,68,67,32,105,116,101,109,32,102,111,114,32,97,110,32,73,68,67,32,100,101,102,105,110,105,116,105,111,110,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,97,110,32,73,68,67,32,109,97,116,99,104,101,114,0,0,0,0,0,0,0,120,109,108,83,99,104,101,109,97,86,97,108,105,100,97,116,101,69,108,101,109,101,110,116,66,121,68,101,99,108,97,114,97,116,105,111,110,0,0,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,81,78,97,109,101,69,120,112,97,110,100,40,41,32,116,111,32,118,97,108,105,100,97,116,101,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,39,120,115,105,58,116,121,112,101,39,0,0,0,0,0,84,104,101,32,81,78,97,109,101,32,118,97,108,117,101,32,39,37,115,39,32,111,102,32,116,104,101,32,120,115,105,58,116,121,112,101,32,97,116,116,114,105,98,117,116,101,32,100,111,101,115,32,110,111,116,32,114,101,115,111,108,118,101,32,116,111,32,97,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,0,0,0,0,84,104,101,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,32,39,37,115,39,44,32,115,112,101,99,105,102,105,101,100,32,98,121,32,120,115,105,58,116,121,112,101,44,32,105,115,32,98,108,111,99,107,101,100,32,111,114,32,110,111,116,32,118,97,108,105,100,108,121,32,100,101,114,105,118,101,100,32,102,114,111,109,32,116,104,101,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,32,111,102,32,116,104,101,32,101,108,101,109,101,110,116,32,100,101,99,108,97,114,97,116,105,111,110,0,0,120,109,108,83,99,104,101,109,97,84,121,112,101,70,105,120,117,112,0,0,0,0,0,0,116,104,105,115,32,102,117,110,99,116,105,111,110,32,110,101,101,100,115,32,97,32,112,97,114,115,101,114,32,99,111,110,116,101,120,116,0,0,0,0,120,109,108,83,99,104,101,109,97,70,105,120,117,112,83,105,109,112,108,101,84,121,112,101,83,116,97,103,101,84,119,111,0,0,0,0,0,0,0,0,109,105,115,115,105,110,103,32,98,97,115,101,84,121,112,101,0,0,0,0,0,0,0,0,73,116,32,105,115,32,97,110,32,101,114,114,111,114,32,102,111,114,32,98,111,116,104,32,39,108,101,110,103,116,104,39,32,97,110,100,32,101,105,116,104,101,114,32,111,102,32,39,109,105,110,76,101,110,103,116,104,39,32,111,114,32,39,109,97,120,76,101,110,103,116,104,39,32,116,111,32,98,101,32,115,112,101,99,105,102,105,101,100,32,111,110,32,116,104,101,32,115,97,109,101,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,0,0,0,73,116,32,105,115,32,97,110,32,101,114,114,111,114,32,102,111,114,32,98,111,116,104,32,39,37,115,39,32,97,110,100,32,39,37,115,39,32,116,111,32,98,101,32,115,112,101,99,105,102,105,101,100,32,111,110,32,116,104,101,32,115,97,109,101,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,0,0,0,0,0,0,0,84,104,101,32,98,97,115,101,32,116,121,112,101,39,115,32,102,97,99,101,116,32,105,115,32,39,102,105,120,101,100,39,44,32,116,104,117,115,32,116,104,101,32,118,97,108,117,101,32,109,117,115,116,32,110,111,116,32,100,105,102,102,101,114,0,0,0,0,0,0,0,0,84,104,101,32,39,119,104,105,116,101,115,112,97,99,101,39,32,118,97,108,117,101,32,104,97,115,32,116,111,32,98,101,32,101,113,117,97,108,32,116,111,32,111,114,32,115,116,114,111,110,103,101,114,32,116,104,97,110,32,116,104,101,32,39,119,104,105,116,101,115,112,97,99,101,39,32,118,97,108,117,101,32,111,102,32,116,104,101,32,98,97,115,101,32,116,121,112,101,0,0,0,0,0,0,100,101,114,105,118,105,110,103,32,102,97,99,101,116,115,44,32,99,114,101,97,116,105,110,103,32,97,32,102,97,99,101,116,32,108,105,110,107,0,0,120,109,108,83,99,104,101,109,97,68,101,114,105,118,101,65,110,100,86,97,108,105,100,97,116,101,70,97,99,101,116,115,0,0,0,0,0,0,0,0,97,110,32,101,114,114,111,114,32,111,99,99,117,114,101,100,0,0,0,0,0,0,0,0,39,32,104,97,115,32,116,111,32,98,101,0,0,0,0,0,32,101,113,117,97,108,32,116,111,0,0,0,0,0,0,0,32,103,114,101,97,116,101,114,32,116,104,97,110,0,0,0,32,108,101,115,115,32,116,104,97,110,0,0,0,0,0,0,32,111,114,32,101,113,117,97,108,32,116,111,0,0,0,0,39,32,111,102,32,116,104,101,32,98,97,115,101,32,116,121,112,101,0,0,0,0,0,0,37,115,58,32,0,0,0,0,97,116,111,109,105,99,32,116,121,112,101,32,39,120,115,58,0,0,0,0,0,0,0,0,108,105,115,116,32,116,121,112,101,32,39,120,115,58,0,0,117,110,105,111,110,32,116,121,112,101,32,39,120,115,58,0,115,105,109,112,108,101,32,116,121,112,101,32,39,120,115,58,0,0,0,0,0,0,0,0,108,111,99,97,108,32,0,0,97,116,111,109,105,99,32,116,121,112,101,0,0,0,0,0,108,105,115,116,32,116,121,112,101,0,0,0,0,0,0,0,117,110,105,111,110,32,116,121,112,101,0,0,0,0,0,0,115,105,109,112,108,101,32,116,121,112,101,0,0,0,0,0,99,111,109,112,108,101,120,32,116,121,112,101,0,0,0,0,97,116,116,114,105,98,117,116,101,32,117,115,101,32,0,0,40,117,110,107,110,111,119,110,41,0,0,0,0,0,0,0,97,116,116,114,105,98,117,116,101,32,100,101,99,108,46,0,101,108,101,109,101,110,116,32,100,101,99,108,46,0,0,0,117,110,105,113,117,101,32,39,0,0,0,0,0,0,0,0,107,101,121,32,39,0,0,0,107,101,121,82,101,102,32,39,0,0,0,0,0,0,0,0,32,119,105,108,100,99,97,114,100,0,0,0,0,0,0,0,102,97,99,101,116,32,39,0,109,111,100,101,108,32,103,114,111,117,112,32,100,101,102,46,0,0,0,0,0,0,0,0,44,32,97,116,116,114,105,98,117,116,101,32,39,0,0,0,115,107,105,112,0,0,0,0,108,97,120,0,0,0,0,0,115,116,114,105,99,116,0,0,105,110,118,97,108,105,100,32,112,114,111,99,101,115,115,32,99,111,110,116,101,110,116,115,0,0,0,0,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,120,109,108,83,99,104,101,109,97,67,114,101,97,116,101,86,67,116,120,116,79,110,80,67,116,120,116,44,32,102,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,97,32,116,101,109,112,46,32,118,97,108,105,100,97,116,105,111,110,32,99,111,110,116,101,120,116,46,10,0,0,0,0,0,0,120,109,108,83,99,104,101,109,97,67,104,101,99,107,67,79,83,83,84,82,101,115,116,114,105,99,116,115,0,0,0,0,103,105,118,101,110,32,116,121,112,101,32,105,115,32,110,111,116,32,97,32,117,115,101,114,45,100,101,114,105,118,101,100,32,115,105,109,112,108,101,84,121,112,101,0,0,0,0,0,84,104,101,32,98,97,115,101,32,116,121,112,101,32,39,37,115,39,32,105,115,32,110,111,116,32,97,110,32,97,116,111,109,105,99,32,115,105,109,112,108,101,32,116,121,112,101,0,84,104,101,32,102,105,110,97,108,32,111,102,32,105,116,115,32,98,97,115,101,32,116,121,112,101,32,39,37,115,39,32,109,117,115,116,32,110,111,116,32,99,111,110,116,97,105,110,32,39,114,101,115,116,114,105,99,116,105,111,110,39,0,0,102,97,105,108,101,100,32,116,111,32,103,101,116,32,112,114,105,109,105,116,105,118,101,32,116,121,112,101,0,0,0,0,102,97,105,108,101,100,32,116,111,32,101,118,97,108,117,97,116,101,32,116,104,101,32,105,116,101,109,32,116,121,112,101,0,0,0,0,0,0,0,0,84,104,101,32,105,116,101,109,32,116,121,112,101,32,39,37,115,39,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,97,32,118,97,114,105,101,116,121,32,111,102,32,97,116,111,109,105,99,32,111,114,32,117,110,105,111,110,0,0,0,84,104,101,32,105,116,101,109,32,116,121,112,101,32,105,115,32,97,32,117,110,105,111,110,32,116,121,112,101,44,32,98,117,116,32,116,104,101,32,109,101,109,98,101,114,32,116,121,112,101,32,39,37,115,39,32,111,102,32,116,104,105,115,32,105,116,101,109,32,116,121,112,101,32,105,115,32,110,111,116,32,97,116,111,109,105,99,0,84,104,101,32,102,105,110,97,108,32,111,102,32,105,116,115,32,105,116,101,109,32,116,121,112,101,32,39,37,115,39,32,109,117,115,116,32,110,111,116,32,99,111,110,116,97,105,110,32,39,108,105,115,116,39,0,84,104,101,32,98,97,115,101,32,116,121,112,101,32,39,37,115,39,32,109,117,115,116,32,98,101,32,97,32,108,105,115,116,32,116,121,112,101,0,0,84,104,101,32,39,102,105,110,97,108,39,32,111,102,32,116,104,101,32,98,97,115,101,32,116,121,112,101,32,39,37,115,39,32,109,117,115,116,32,110,111,116,32,99,111,110,116,97,105,110,32,39,114,101,115,116,114,105,99,116,105,111,110,39,0,0,0,0,0,0,0,0,102,97,105,108,101,100,32,116,111,32,101,118,97,108,32,116,104,101,32,105,116,101,109,32,116,121,112,101,32,111,102,32,97,32,98,97,115,101,32,116,121,112,101,0,0,0,0,0,84,104,101,32,105,116,101,109,32,116,121,112,101,32,39,37,115,39,32,105,115,32,110,111,116,32,118,97,108,105,100,108,121,32,100,101,114,105,118,101,100,32,102,114,111,109,32,116,104,101,32,105,116,101,109,32,116,121,112,101,32,39,37,115,39,32,111,102,32,116,104,101,32,98,97,115,101,32,116,121,112,101,32,39,37,115,39,0,84,104,101,32,109,101,109,98,101,114,32,116,121,112,101,32,39,37,115,39,32,105,115,32,110,101,105,116,104,101,114,32,97,110,32,97,116,111,109,105,99,44,32,110,111,114,32,97,32,108,105,115,116,32,116,121,112,101,0,0,0,0,0,0,84,104,101,32,39,102,105,110,97,108,39,32,111,102,32,109,101,109,98,101,114,32,116,121,112,101,32,39,37,115,39,32,99,111,110,116,97,105,110,115,32,39,117,110,105,111,110,39,0,0,0,0,0,0,0,0,78,111,32,102,97,99,101,116,115,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,84,104,101,32,98,97,115,101,32,116,121,112,101,32,39,37,115,39,32,105,115,32,110,111,116,32,97,32,117,110,105,111,110,32,116,121,112,101,0,0,84,104,101,32,39,102,105,110,97,108,39,32,111,102,32,105,116,115,32,98,97,115,101,32,116,121,112,101,32,39,37,115,39,32,109,117,115,116,32,110,111,116,32,99,111,110,116,97,105,110,32,39,114,101,115,116,114,105,99,116,105,111,110,39,0,0,0,0,0,0,0,0,100,105,102,102,101,114,101,110,116,32,110,117,109,98,101,114,32,111,102,32,109,101,109,98,101,114,32,116,121,112,101,115,32,105,110,32,98,97,115,101,0,0,0,0,0,0,0,0,84,104,101,32,109,101,109,98,101,114,32,116,121,112,101,32,37,115,32,105,115,32,110,111,116,32,118,97,108,105,100,108,121,32,100,101,114,105,118,101,100,32,102,114,111,109,32,105,116,115,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,109,101,109,98,101,114,32,116,121,112,101,32,37,115,32,111,102,32,116,104,101,32,98,97,115,101,32,116,121,112,101,32,37,115,0,0,0,0,0,37,115,58,32,84,104,101,32,102,97,99,101,116,32,39,37,115,39,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,46,10,0,0,0,0,0,37,115,58,32,84,104,101,32,102,97,99,101,116,32,39,37,115,39,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,32,111,110,32,116,121,112,101,115,32,100,101,114,105,118,101,100,32,102,114,111,109,32,116,104,101,32,116,121,112,101,32,37,115,46,10,0,0,0,78,111,32,98,97,115,101,32,116,121,112,101,32,101,120,105,115,116,101,110,116,0,0,0,84,104,101,32,98,97,115,101,32,116,121,112,101,32,39,37,115,39,32,105,115,32,110,111,116,32,97,32,115,105,109,112,108,101,32,116,121,112,101,0,65,32,116,121,112,101,44,32,100,101,114,105,118,101,100,32,98,121,32,108,105,115,116,32,111,114,32,117,110,105,111,110,44,32,109,117,115,116,32,104,97,118,101,32,116,104,101,32,115,105,109,112,108,101,32,117,114,45,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,32,97,115,32,98,97,115,101,32,116,121,112,101,44,32,110,111,116,32,39,37,115,39,0,0,0,0,0,0,0,0,84,104,101,32,118,97,114,105,101,116,121,32,105,115,32,97,98,115,101,110,116,0,0,0,97,108,108,111,99,97,116,105,110,103,32,97,32,116,121,112,101,32,108,105,110,107,0,0,120,109,108,83,99,104,101,109,97,70,105,120,117,112,67,111,109,112,108,101,120,84,121,112,101,0,0,0,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,120,109,108,83,99,104,101,109,97,84,121,112,101,70,105,120,117,112,44,32,99,111,109,112,108,101,120,32,116,121,112,101,32,39,37,115,39,58,32,116,104,101,32,60,115,105,109,112,108,101,67,111,110,116,101,110,116,62,60,114,101,115,116,114,105,99,116,105,111,110,62,32,105,115,32,109,105,115,115,105,110,103,32,97,32,60,115,105,109,112,108,101,84,121,112,101,62,32,99,104,105,108,100,44,32,98,117,116,32,119,97,115,32,110,111,116,32,99,97,116,99,104,101,100,32,98,121,32,120,109,108,83,99,104,101,109,97,67,104,101,99,107,83,82,67,67,84,40,41,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,120,109,108,83,99,104,101,109,97,84,121,112,101,70,105,120,117,112,44,32,99,111,109,112,108,101,120,32,116,121,112,101,32,39,37,115,39,58,32,116,104,101,32,60,101,120,116,101,110,115,105,111,110,62,101,100,32,98,97,115,101,32,116,121,112,101,32,105,115,32,97,32,99,111,109,112,108,101,120,32,116,121,112,101,32,119,105,116,104,32,110,111,32,115,105,109,112,108,101,32,99,111,110,116,101,110,116,32,116,121,112,101,0,0,0,0,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,120,109,108,83,99,104,101,109,97,84,121,112,101,70,105,120,117,112,44,32,99,111,109,112,108,101,120,32,116,121,112,101,32,39,37,115,39,32,119,105,116,104,32,60,115,105,109,112,108,101,67,111,110,116,101,110,116,62,58,32,117,110,104,97,110,100,108,101,100,32,100,101,114,105,118,97,116,105,111,110,32,99,97,115,101,0,0,0,84,104,101,32,116,121,112,101,32,104,97,115,32,97,110,32,39,97,108,108,39,32,109,111,100,101,108,32,103,114,111,117,112,32,105,110,32,105,116,115,32,123,99,111,110,116,101,110,116,32,116,121,112,101,125,32,97,110,100,32,116,104,117,115,32,99,97,110,110,111,116,32,98,101,32,100,101,114,105,118,101,100,32,102,114,111,109,32,97,32,110,111,110,45,101,109,112,116,121,32,116,121,112,101,44,32,115,105,110,99,101,32,116,104,105,115,32,119,111,117,108,100,32,112,114,111,100,117,99,101,32,97,32,39,115,101,113,117,101,110,99,101,39,32,109,111,100,101,108,32,103,114,111,117,112,32,99,111,110,116,97,105,110,105,110,103,32,116,104,101,32,39,97,108,108,39,32,109,111,100,101,108,32,103,114,111,117,112,59,32,39,97,108,108,39,32,109,111,100,101,108,32,103,114,111,117,112,115,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,32,116,111,32,97,112,112,101,97,114,32,105,110,115,105,100,101,32,111,116,104,101,114,32,109,111,100,101,108,32,103,114,111,117,112,115,0,0,0,0,65,32,116,121,112,101,32,99,97,110,110,111,116,32,98,101,32,100,101,114,105,118,101,100,32,98,121,32,101,120,116,101,110,115,105,111,110,32,102,114,111,109,32,97,32,116,121,112,101,32,119,104,105,99,104,32,104,97,115,32,97,110,32,39,97,108,108,39,32,109,111,100,101,108,32,103,114,111,117,112,32,105,110,32,105,116,115,32,123,99,111,110,116,101,110,116,32,116,121,112,101,125,44,32,115,105,110,99,101,32,116,104,105,115,32,119,111,117,108,100,32,112,114,111,100,117,99,101,32,97,32,39,115,101,113,117,101,110,99,101,39,32,109,111,100,101,108,32,103,114,111,117,112,32,99,111,110,116,97,105,110,105,110,103,32,116,104,101,32,39,97,108,108,39,32,109,111,100,101,108,32,103,114,111,117,112,59,32,39,97,108,108,39,32,109,111,100,101,108,32,103,114,111,117,112,115,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,32,116,111,32,97,112,112,101,97,114,32,105,110,115,105,100,101,32,111,116,104,101,114,32,109,111,100,101,108,32,103,114,111,117,112,115,0,0,0,0,0,0,84,104,101,32,98,97,115,101,32,116,121,112,101,32,109,117,115,116,32,98,101,32,97,32,99,111,109,112,108,101,120,32,116,121,112,101,0,0,0,0,84,104,101,32,39,102,105,110,97,108,39,32,111,102,32,116,104,101,32,98,97,115,101,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,32,99,111,110,116,97,105,110,115,32,39,114,101,115,116,114,105,99,116,105,111,110,39,0,0,84,104,101,32,123,99,111,110,116,101,110,116,32,116,121,112,101,125,32,37,115,32,105,115,32,110,111,116,32,118,97,108,105,100,108,121,32,100,101,114,105,118,101,100,32,102,114,111,109,32,116,104,101,32,98,97,115,101,32,116,121,112,101,39,115,32,123,99,111,110,116,101,110,116,32,116,121,112,101,125,32,37,115,0,0,0,0,0,84,104,101,32,99,111,110,116,101,110,116,32,116,121,112,101,32,111,102,32,116,104,101,32,98,97,115,101,32,116,121,112,101,32,109,117,115,116,32,98,101,32,101,105,116,104,101,114,32,97,32,115,105,109,112,108,101,32,116,121,112,101,32,111,114,32,39,109,105,120,101,100,39,32,97,110,100,32,97,110,32,101,109,112,116,105,97,98,108,101,32,112,97,114,116,105,99,108,101,0,0,0,0,0,84,104,101,32,99,111,110,116,101,110,116,32,116,121,112,101,32,111,102,32,116,104,101,32,98,97,115,101,32,116,121,112,101,32,109,117,115,116,32,98,101,32,101,105,116,104,101,114,32,101,109,112,116,121,32,111,114,32,39,109,105,120,101,100,39,32,40,111,114,32,39,101,108,101,109,101,110,116,115,45,111,110,108,121,39,41,32,97,110,100,32,97,110,32,101,109,112,116,105,97,98,108,101,32,112,97,114,116,105,99,108,101,0,0,0,0,0,0,0,0,73,102,32,116,104,101,32,99,111,110,116,101,110,116,32,116,121,112,101,32,105,115,32,39,109,105,120,101,100,39,44,32,116,104,101,110,32,116,104,101,32,99,111,110,116,101,110,116,32,116,121,112,101,32,111,102,32,116,104,101,32,98,97,115,101,32,116,121,112,101,32,109,117,115,116,32,97,108,115,111,32,98,101,32,39,109,105,120,101,100,39,0,0,0,0,0,84,104,101,32,116,121,112,101,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,114,101,115,116,114,105,99,116,105,111,110,32,111,102,32,105,116,115,32,98,97,115,101,32,116,121,112,101,0,0,0,0,84,104,101,32,39,111,112,116,105,111,110,97,108,39,32,97,116,116,114,105,98,117,116,101,32,117,115,101,32,105,115,32,105,110,99,111,110,115,105,115,116,101,110,116,32,119,105,116,104,32,116,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,39,114,101,113,117,105,114,101,100,39,32,97,116,116,114,105,98,117,116,101,32,117,115,101,32,111,102,32,116,104,101,32,37,115,32,37,115,0,0,0,0,0,0,0,98,97,115,101,0,0,0,0,114,101,100,101,102,105,110,101,100,0,0,0,0,0,0,0,84,104,101,32,97,116,116,114,105,98,117,116,101,32,100,101,99,108,97,114,97,116,105,111,110,39,115,32,37,115,32,105,115,32,110,111,116,32,118,97,108,105,100,108,121,32,100,101,114,105,118,101,100,32,102,114,111,109,32,116,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,37,115,32,111,102,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,100,101,99,108,97,114,97,116,105,111,110,32,105,110,32,116,104,101,32,37,115,32,37,115,0,0,0,0,0,0,0,84,104,101,32,101,102,102,101,99,116,105,118,101,32,118,97,108,117,101,32,99,111,110,115,116,114,97,105,110,116,32,111,102,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,117,115,101,32,105,115,32,105,110,99,111,110,115,105,115,116,101,110,116,32,119,105,116,104,32,105,116,115,32,99,111,114,114,101,115,112,111,110,100,101,110,116,32,105,110,32,116,104,101,32,37,115,32,37,115,0,78,101,105,116,104,101,114,32,97,32,109,97,116,99,104,105,110,103,32,97,116,116,114,105,98,117,116,101,32,117,115,101,44,32,110,111,114,32,97,32,109,97,116,99,104,105,110,103,32,119,105,108,100,99,97,114,100,32,101,120,105,115,116,115,32,105,110,32,116,104,101,32,37,115,32,37,115,0,0,0,65,32,109,97,116,99,104,105,110,103,32,97,116,116,114,105,98,117,116,101,32,117,115,101,32,102,111,114,32,116,104,101,32,39,114,101,113,117,105,114,101,100,39,32,37,115,32,111,102,32,116,104,101,32,37,115,32,37,115,32,105,115,32,109,105,115,115,105,110,103,0,0,84,104,101,32,37,115,32,104,97,115,32,97,110,32,97,116,116,114,105,98,117,116,101,32,119,105,108,100,99,97,114,100,44,32,98,117,116,32,116,104,101,32,37,115,32,37,115,32,39,37,115,39,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,111,110,101,0,0,84,104,101,32,97,116,116,114,105,98,117,116,101,32,119,105,108,100,99,97,114,100,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,115,117,98,115,101,116,32,111,102,32,116,104,101,32,119,105,108,100,99,97,114,100,32,105,110,32,116,104,101,32,37,115,32,37,115,32,39,37,115,39,0,0,84,104,101,32,123,112,114,111,99,101,115,115,32,99,111,110,116,101,110,116,115,125,32,111,102,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,119,105,108,100,99,97,114,100,32,105,115,32,119,101,97,107,101,114,32,116,104,97,110,32,116,104,101,32,111,110,101,32,105,110,32,116,104,101,32,37,115,32,37,115,32,39,37,115,39,0,0,0,0,0,0,0,58,32,0,0,0,0,0,0,84,104,101,32,39,102,105,110,97,108,39,32,111,102,32,116,104,101,32,98,97,115,101,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,32,99,111,110,116,97,105,110,115,32,39,101,120,116,101,110,115,105,111,110,39,0,0,0,0,84,104,101,32,99,111,110,116,101,110,116,32,116,121,112,101,32,109,117,115,116,32,115,112,101,99,105,102,121,32,97,32,112,97,114,116,105,99,108,101,0,0,0,0,0,0,0,0,84,104,101,32,99,111,110,116,101,110,116,32,116,121,112,101,32,111,102,32,98,111,116,104,44,32,116,104,101,32,116,121,112,101,32,97,110,100,32,105,116,115,32,98,97,115,101,32,116,121,112,101,44,32,109,117,115,116,32,101,105,116,104,101,114,32,39,109,105,120,101,100,39,32,111,114,32,39,101,108,101,109,101,110,116,45,111,110,108,121,39,0,0,0,0,0,84,104,101,32,99,111,110,116,101,110,116,32,116,121,112,101,32,109,117,115,116,32,98,101,32,116,104,101,32,115,105,109,112,108,101,32,98,97,115,101,32,116,121,112,101,0,0,0,73,102,32,116,104,101,32,98,97,115,101,32,116,121,112,101,32,105,115,32,97,32,115,105,109,112,108,101,32,116,121,112,101,44,32,116,104,101,32,100,101,114,105,118,97,116,105,111,110,32,109,101,116,104,111,100,32,109,117,115,116,32,98,101,32,39,101,120,116,101,110,115,105,111,110,39,0,0,0,0,68,117,112,108,105,99,97,116,101,32,37,115,0,0,0,0,84,104,101,114,101,32,109,117,115,116,32,110,111,116,32,101,120,105,115,116,32,109,111,114,101,32,116,104,97,110,32,111,110,101,32,97,116,116,114,105,98,117,116,101,32,100,101,99,108,97,114,97,116,105,111,110,32,111,102,32,116,121,112,101,32,39,120,115,58,73,68,39,32,40,111,114,32,100,101,114,105,118,101,100,32,102,114,111,109,32,39,120,115,58,73,68,39,41,46,32,84,104,101,32,37,115,32,118,105,111,108,97,116,101,115,32,116,104,105,115,32,99,111,110,115,116,114,97,105,110,116,0,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,120,109,108,83,99,104,101,109,97,73,116,101,109,76,105,115,116,82,101,109,111,118,101,44,32,105,110,100,101,120,32,101,114,114,111,114,46,10,0,0,120,109,108,83,99,104,101,109,97,70,105,120,117,112,84,121,112,101,65,116,116,114,105,98,117,116,101,85,115,101,115,0,110,111,32,98,97,115,101,32,116,121,112,101,0,0,0,0,102,97,105,108,101,100,32,116,111,32,101,120,112,97,110,100,32,97,116,116,114,105,98,117,116,101,115,0,0,0,0,0,84,104,101,32,117,110,105,111,110,32,111,102,32,116,104,101,32,119,105,108,99,97,114,100,32,105,115,32,110,111,116,32,101,120,112,114,101,115,115,105,98,108,101,46,10,0,0,0,99,114,101,97,116,105,110,103,32,119,105,108,100,99,97,114,100,32,110,97,109,101,115,112,97,99,101,32,99,111,110,115,116,114,97,105,110,116,0,0,120,109,108,83,99,104,101,109,97,69,120,112,97,110,100,65,116,116,114,105,98,117,116,101,71,114,111,117,112,82,101,102,115,0,0,0,0,0,0,0,117,110,101,120,112,101,99,116,101,100,32,97,116,116,114,32,112,114,111,104,105,98,105,116,105,111,110,32,102,111,117,110,100,0,0,0,0,0,0,0,83,107,105,112,112,105,110,103,32,112,111,105,110,116,108,101,115,115,32,97,116,116,114,105,98,117,116,101,32,117,115,101,32,112,114,111,104,105,98,105,116,105,111,110,32,39,37,115,39,44,32,115,105,110,99,101,32,97,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,97,116,116,114,105,98,117,116,101,32,117,115,101,32,101,120,105,115,116,115,32,97,108,114,101,97,100,121,32,105,110,32,116,104,101,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,0,0,0,0,84,104,101,32,105,110,116,101,114,115,101,99,116,105,111,110,32,111,102,32,116,104,101,32,119,105,108,99,97,114,100,32,105,115,32,110,111,116,32,101,120,112,114,101,115,115,105,98,108,101,46,10,0,0,0,0,97,100,100,105,110,103,32,119,105,108,100,99,97,114,100,0,97,108,108,111,99,97,116,105,110,103,32,109,111,100,101,108,32,103,114,111,117,112,32,99,111,109,112,111,110,101,110,116,0,0,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,112,97,114,116,105,99,108,101,32,99,111,109,112,111,110,101,110,116,0,0,0,120,109,108,83,99,104,101,109,97,70,105,120,117,112,83,105,109,112,108,101,84,121,112,101,83,116,97,103,101,79,110,101,0,0,0,0,0,0,0,0,108,105,115,116,32,116,121,112,101,32,104,97,115,32,110,111,32,105,116,101,109,45,116,121,112,101,32,97,115,115,105,103,110,101,100,0,0,0,0,0,117,110,105,111,110,32,116,121,112,101,32,104,97,115,32,110,111,32,109,101,109,98,101,114,45,116,121,112,101,115,32,97,115,115,105,103,110,101,100,0,116,121,112,101,32,104,97,115,32,110,111,32,98,97,115,101,45,116,121,112,101,32,97,115,115,105,103,110,101,100,0,0,97,108,108,111,99,97,116,105,110,103,32,116,121,112,101,0,97,108,108,111,99,97,116,105,110,103,32,114,101,100,101,102,105,110,105,116,105,111,110,32,105,110,102,111,0,0,0,0,73,102,32,117,115,105,110,103,32,60,99,111,109,112,108,101,120,67,111,110,116,101,110,116,62,44,32,116,104,101,32,98,97,115,101,32,116,121,112,101,32,105,115,32,101,120,112,101,99,116,101,100,32,116,111,32,98,101,32,97,32,99,111,109,112,108,101,120,32,116,121,112,101,46,32,84,104,101,32,98,97,115,101,32,116,121,112,101,32,39,37,115,39,32,105,115,32,97,32,115,105,109,112,108,101,32,116,121,112,101,0,0,73,102,32,117,115,105,110,103,32,60,115,105,109,112,108,101,67,111,110,116,101,110,116,62,32,97,110,100,32,60,114,101,115,116,114,105,99,116,105,111,110,62,44,32,116,104,101,32,98,97,115,101,32,116,121,112,101,32,109,117,115,116,32,98,101,32,97,32,99,111,109,112,108,101,120,32,116,121,112,101,46,32,84,104,101,32,98,97,115,101,32,116,121,112,101,32,39,37,115,39,32,105,115,32,97,32,115,105,109,112,108,101,32,116,121,112,101,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,120,109,108,83,99,104,101,109,97,67,104,101,99,107,83,82,67,67,84,44,32,39,37,115,39,44,32,98,97,115,101,32,116,121,112,101,32,104,97,115,32,110,111,32,99,111,110,116,101,110,116,32,116,121,112,101,0,0,0,0,0,0,0,0,65,32,60,115,105,109,112,108,101,84,121,112,101,62,32,105,115,32,101,120,112,101,99,116,101,100,32,97,109,111,110,103,32,116,104,101,32,99,104,105,108,100,114,101,110,32,111,102,32,60,114,101,115,116,114,105,99,116,105,111,110,62,44,32,105,102,32,60,115,105,109,112,108,101,67,111,110,116,101,110,116,62,32,105,115,32,117,115,101,100,32,97,110,100,32,116,104,101,32,98,97,115,101,32,116,121,112,101,32,39,37,115,39,32,105,115,32,97,32,99,111,109,112,108,101,120,32,116,121,112,101,0,0,0,0,0,73,102,32,60,115,105,109,112,108,101,67,111,110,116,101,110,116,62,32,97,110,100,32,60,114,101,115,116,114,105,99,116,105,111,110,62,32,105,115,32,117,115,101,100,44,32,116,104,101,32,98,97,115,101,32,116,121,112,101,32,109,117,115,116,32,98,101,32,97,32,115,105,109,112,108,101,32,116,121,112,101,32,111,114,32,97,32,99,111,109,112,108,101,120,32,116,121,112,101,32,119,105,116,104,32,109,105,120,101,100,32,99,111,110,116,101,110,116,32,97,110,100,32,112,97,114,116,105,99,108,101,32,101,109,112,116,105,97,98,108,101,46,32,84,104,101,32,98,97,115,101,32,116,121,112,101,32,39,37,115,39,32,105,115,32,110,111,110,101,32,111,102,32,116,104,111,115,101,0,0,0,0,0,0,73,102,32,60,115,105,109,112,108,101,67,111,110,116,101,110,116,62,32,97,110,100,32,60,101,120,116,101,110,115,105,111,110,62,32,105,115,32,117,115,101,100,44,32,116,104,101,32,98,97,115,101,32,116,121,112,101,32,109,117,115,116,32,98,101,32,97,32,115,105,109,112,108,101,32,116,121,112,101,46,32,84,104,101,32,98,97,115,101,32,116,121,112,101,32,39,37,115,39,32,105,115,32,97,32,99,111,109,112,108,101,120,32,116,121,112,101,0,0,0,184,44,2,0,0,0,0,0,84,104,101,32,81,78,97,109,101,32,118,97,108,117,101,32,39,37,115,39,32,104,97,115,32,110,111,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,110,97,109,101,115,112,97,99,101,32,100,101,99,108,97,114,97,116,105,111,110,32,105,110,32,115,99,111,112,101,0,0,0,0,0,0,0,0,120,109,108,83,99,104,101,109,97,76,111,111,107,117,112,78,97,109,101,115,112,97,99,101,0,0,0,0,0,0,0,0,110,111,32,110,111,100,101,32,111,114,32,110,111,100,101,39,115,32,100,111,99,32,97,118,97,108,105,97,98,108,101,0,39,37,115,39,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,118,97,108,117,101,32,111,102,32,0,0,0,84,104,101,32,99,104,97,114,97,99,116,101,114,32,99,111,110,116,101,110,116,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,118,97,108,117,101,32,111,102,32,0,0,116,104,101,32,108,111,99,97,108,32,0,0,0,0,0,0,116,104,101,32,0,0,0,0,120,115,58,0,0,0,0,0,120,109,108,83,99,104,101,109,97,86,97,108,105,100,97,116,101,69,108,101,109,87,105,108,100,99,97,114,100,0,0,0,98,97,100,32,97,114,103,117,109,101,110,116,115,0,0,0,78,111,32,109,97,116,99,104,105,110,103,32,103,108,111,98,97,108,32,101,108,101,109,101,110,116,32,100,101,99,108,97,114,97,116,105,111,110,32,97,118,97,105,108,97,98,108,101,44,32,98,117,116,32,100,101,109,97,110,100,101,100,32,98,121,32,116,104,101,32,115,116,114,105,99,116,32,119,105,108,100,99,97,114,100,0,0,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,80,114,111,99,101,115,115,88,83,73,84,121,112,101,40,41,32,116,111,32,112,114,111,99,101,115,115,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,39,120,115,105,58,110,105,108,39,0,0,0,0,120,109,108,83,99,104,101,109,97,86,97,108,105,100,97,116,101,67,104,105,108,100,69,108,101,109,0,0,0,0,0,0,110,111,116,32,105,110,116,101,110,100,101,100,32,102,111,114,32,116,104,101,32,118,97,108,105,100,97,116,105,111,110,32,114,111,111,116,0,0,0,0,78,101,105,116,104,101,114,32,99,104,97,114,97,99,116,101,114,32,110,111,114,32,101,108,101,109,101,110,116,32,99,111,110,116,101,110,116,32,105,115,32,97,108,108,111,119,101,100,44,32,98,101,99,97,117,115,101,32,116,104,101,32,101,108,101,109,101,110,116,32,119,97,115,32,39,110,105,108,108,101,100,39,0,0,0,0,0,0,69,108,101,109,101,110,116,32,99,111,110,116,101,110,116,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,44,32,98,101,99,97,117,115,101,32,116,104,101,32,99,111,110,116,101,110,116,32,116,121,112,101,32,105,115,32,101,109,112,116,121,0,0,0,0,0,0,0,116,121,112,101,32,104,97,115,32,101,108,101,109,32,99,111,110,116,101,110,116,32,98,117,116,32,110,111,32,99,111,110,116,101,110,116,32,109,111,100,101,108,0,0,0,0,0,0,118,97,108,105,100,97,116,105,110,103,32,101,108,101,109,44,32,98,117,116,32,101,108,101,109,32,99,111,110,116,101,110,116,32,105,115,32,97,108,114,101,97,100,121,32,105,110,118,97,108,105,100,0,0,0,0,99,97,108,108,105,110,103,32,120,109,108,82,101,103,69,120,101,99,80,117,115,104,83,116,114,105,110,103,50,40,41,0,84,104,105,115,32,101,108,101,109,101,110,116,32,105,115,32,110,111,116,32,101,120,112,101,99,116,101,100,0,0,0,0,69,108,101,109,101,110,116,32,99,111,110,116,101,110,116,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,44,32,98,101,99,97,117,115,101,32,116,104,101,32,99,111,110,116,101,110,116,32,116,121,112,101,32,105,115,32,97,32,115,105,109,112,108,101,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,0,0,0,0,69,108,101,109,101,110,116,32,99,111,110,116,101,110,116,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,44,32,98,101,99,97,117,115,101,32,116,104,101,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,32,105,115,32,115,105,109,112,108,101,0,0,0,84,104,101,32,118,97,108,117,101,32,109,117,115,116,32,99,111,110,115,105,115,116,32,111,102,32,116,117,112,108,101,115,58,32,116,104,101,32,116,97,114,103,101,116,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,32,97,110,100,32,116,104,101,32,100,111,99,117,109,101,110,116,39,115,32,85,82,73,0,0,0,0,0,0,120,109,108,83,99,104,101,109,97,65,115,115,101,109,98,108,101,66,121,88,83,73,0,0,97,115,115,101,109,98,108,105,110,103,32,115,99,104,101,109,97,116,97,0,0,0,0,0,120,109,108,83,99,104,101,109,97,65,115,115,101,109,98,108,101,66,121,76,111,99,97,116,105,111,110,0,0,0,0,0,110,111,32,112,97,114,115,101,114,32,99,111,110,116,101,120,116,32,97,118,97,105,108,97,98,108,101,0,0,0,0,0,110,111,32,99,111,110,115,116,114,117,99,116,111,114,0,0,84,104,101,32,100,111,99,117,109,101,110,116,32,97,116,32,108,111,99,97,116,105,111,110,32,39,37,115,39,32,99,111,117,108,100,32,110,111,116,32,98,101,32,97,99,113,117,105,114,101,100,0,0,0,0,0,120,109,108,83,99,104,101,109,97,80,117,115,104,65,116,116,114,105,98,117,116,101,0,0,110,105,108,0,0,0,0,0,152,95,2,0,0,0,0,0,116,121,112,101,0,0,0,0,115,99,104,101,109,97,76,111,99,97,116,105,111,110,0,0,110,111,78,97,109,101,115,112,97,99,101,83,99,104,101,109,97,76,111,99,97,116,105,111,110,0,0,0,0,0,0,0,120,95,2,0,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,48,47,120,109,108,110,115,47,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,49,47,88,77,76,83,99,104,101,109,97,45,105,110,115,116,97,110,99,101,0,0,0,0,0,0,0,120,109,108,83,99,104,101,109,97,86,97,108,105,100,97,116,111,114,80,117,115,104,69,108,101,109,0,0,0,0,0,0,99,97,108,108,105,110,103,32,120,109,108,83,99,104,101,109,97,71,101,116,70,114,101,115,104,69,108,101,109,73,110,102,111,40,41,0,0,0,0,0,120,109,108,83,99,104,101,109,97,71,101,116,70,114,101,115,104,69,108,101,109,73,110,102,111,0,0,0,0,0,0,0,105,110,99,111,110,115,105,115,116,101,110,116,32,100,101,112,116,104,32,101,110,99,111,117,110,116,101,114,101,100,0,0,97,108,108,111,99,97,116,105,110,103,32,116,104,101,32,101,108,101,109,101,110,116,32,105,110,102,111,32,97,114,114,97,121,0,0,0,0,0,0,0,114,101,45,97,108,108,111,99,97,116,105,110,103,32,116,104,101,32,101,108,101,109,101,110,116,32,105,110,102,111,32,97,114,114,97,121,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,97,110,32,101,108,101,109,101,110,116,32,105,110,102,111,0,0,0,0,0,0,101,108,101,109,32,105,110,102,111,32,104,97,115,32,110,111,116,32,98,101,101,110,32,99,108,101,97,114,101,100,0,0,120,109,108,83,99,104,101,109,97,86,83,116,97,114,116,0,110,111,32,105,110,115,116,97,110,99,101,32,116,111,32,118,97,108,105,100,97,116,101,0,120,109,108,83,99,104,101,109,97,68,111,99,87,97,108,107,0,0,0,0,0,0,0,0,120,109,108,83,99,104,101,109,97,86,68,111,99,87,97,108,107,0,0,0,0,0,0,0,116,104,101,114,101,32,105,115,32,97,116,32,108,101,97,115,116,32,111,110,101,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,32,105,110,32,116,104,101,32,110,111,100,101,45,116,114,101,101,32,99,117,114,114,101,110,116,108,121,32,98,101,105,110,103,32,118,97,108,105,100,97,116,101,100,46,32,80,114,111,99,101,115,115,105,110,103,32,111,102,32,101,110,116,105,116,105,101,115,32,119,105,116,104,32,116,104,105,115,32,88,77,76,32,83,99,104,101,109,97,32,112,114,111,99,101,115,115,111,114,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,40,121,101,116,41,46,32,80,108,101,97,115,101,32,115,117,98,115,116,105,116,117,116,101,32,101,110,116,105,116,105,101,115,32,98,101,102,111,114,101,32,118,97,108,105,100,97,116,105,111,110,46,0,0,101,108,101,109,101,110,116,32,112,111,115,105,116,105,111,110,32,109,105,115,109,97,116,99,104,0,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,97,110,32,105,116,101,109,32,108,105,115,116,32,115,116,114,117,99,116,117,114,101,0,0,0,0,0,0,0,120,109,108,83,99,104,101,109,97,86,67,104,101,99,107,67,86,67,83,105,109,112,108,101,84,121,112,101,0,0,0,0,99,111,117,108,100,32,110,111,116,32,103,101,116,32,116,104,101,32,98,117,105,108,116,45,105,110,32,116,121,112,101,0,118,97,108,105,100,97,116,105,110,103,32,97,103,97,105,110,115,116,32,97,32,98,117,105,108,116,45,105,110,32,116,121,112,101,0,0,0,0,0,0,118,97,108,105,100,97,116,105,110,103,32,102,97,99,101,116,115,32,111,102,32,97,116,111,109,105,99,32,115,105,109,112,108,101,32,116,121,112,101,0,118,97,108,105,100,97,116,105,110,103,32,97,110,32,105,116,101,109,32,111,102,32,108,105,115,116,32,115,105,109,112,108,101,32,116,121,112,101,0,0,118,97,108,105,100,97,116,105,110,103,32,102,97,99,101,116,115,32,111,102,32,108,105,115,116,32,115,105,109,112,108,101,32,116,121,112,101,0,0,0,117,110,105,111,110,32,115,105,109,112,108,101,32,116,121,112,101,32,104,97,115,32,110,111,32,109,101,109,98,101,114,32,116,121,112,101,115,0,0,0,118,97,108,105,100,97,116,105,110,103,32,109,101,109,98,101,114,115,32,111,102,32,117,110,105,111,110,32,115,105,109,112],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+146288),
allocate([108,101,32,116,121,112,101,0,118,97,108,105,100,97,116,105,110,103,32,102,97,99,101,116,115,32,111,102,32,117,110,105,111,110,32,115,105,109,112,108,101,32,116,121,112,101,0,0,120,109,108,83,99,104,101,109,97,86,97,108,105,100,97,116,101,70,97,99,101,116,115,0,118,97,108,105,100,97,116,105,110,103,32,97,103,97,105,110,115,116,32,97,32,97,116,111,109,105,99,32,116,121,112,101,32,102,97,99,101,116,0,0,118,97,108,105,100,97,116,105,110,103,32,97,103,97,105,110,115,116,32,97,32,108,105,115,116,32,116,121,112,101,32,102,97,99,101,116,0,0,0,0,118,97,108,105,100,97,116,105,110,103,32,97,103,97,105,110,115,116,32,97,110,32,101,110,117,109,101,114,97,116,105,111,110,32,102,97,99,101,116,0,118,97,108,105,100,97,116,105,110,103,32,97,103,97,105,110,115,116,32,97,32,112,97,116,116,101,114,110,32,102,97,99,101,116,0,0,0,0,0,0,39,93,32,0,0,0,0,0,84,104,101,32,118,97,108,117,101,32,39,37,115,39,32,104,97,115,32,97,32,108,101,110,103,116,104,32,111,102,32,39,37,115,39,59,32,0,0,0,84,104,101,32,118,97,108,117,101,32,104,97,115,32,97,32,108,101,110,103,116,104,32,111,102,32,39,37,115,39,59,32,0,0,0,0,0,0,0,0,37,108,117,0,0,0,0,0,116,104,105,115,32,100,105,102,102,101,114,115,32,102,114,111,109,32,116,104,101,32,97,108,108,111,119,101,100,32,108,101,110,103,116,104,32,111,102,32,39,37,115,39,46,10,0,0,116,104,105,115,32,101,120,99,101,101,100,115,32,116,104,101,32,97,108,108,111,119,101,100,32,109,97,120,105,109,117,109,32,108,101,110,103,116,104,32,111,102,32,39,37,115,39,46,10,0,0,0,0,0,0,0,116,104,105,115,32,117,110,100,101,114,114,117,110,115,32,116,104,101,32,97,108,108,111,119,101,100,32,109,105,110,105,109,117,109,32,108,101,110,103,116,104,32,111,102,32,39,37,115,39,46,10,0,0,0,0,0,84,104,101,32,118,97,108,117,101,32,39,37,115,39,32,105,115,32,110,111,116,32,97,110,32,101,108,101,109,101,110,116,32,111,102,32,116,104,101,32,115,101,116,32,123,37,115,125,46,10,0,0,0,0,0,0,84,104,101,32,118,97,108,117,101,32,39,37,115,39,32,105,115,32,110,111,116,32,97,99,99,101,112,116,101,100,32,98,121,32,116,104,101,32,112,97,116,116,101,114,110,32,39,37,115,39,46,10,0,0,0,0,84,104,101,32,118,97,108,117,101,32,39,37,115,39,32,105,115,32,108,101,115,115,32,116,104,97,110,32,116,104,101,32,109,105,110,105,109,117,109,32,118,97,108,117,101,32,97,108,108,111,119,101,100,32,40,39,37,115,39,41,46,10,0,0,84,104,101,32,118,97,108,117,101,32,39,37,115,39,32,105,115,32,103,114,101,97,116,101,114,32,116,104,97,110,32,116,104,101,32,109,97,120,105,109,117,109,32,118,97,108,117,101,32,97,108,108,111,119,101,100,32,40,39,37,115,39,41,46,10,0,0,0,0,0,0,0,84,104,101,32,118,97,108,117,101,32,39,37,115,39,32,109,117,115,116,32,98,101,32,103,114,101,97,116,101,114,32,116,104,97,110,32,39,37,115,39,46,10,0,0,0,0,0,0,84,104,101,32,118,97,108,117,101,32,39,37,115,39,32,109,117,115,116,32,98,101,32,108,101,115,115,32,116,104,97,110,32,39,37,115,39,46,10,0,84,104,101,32,118,97,108,117,101,32,39,37,115,39,32,104,97,115,32,109,111,114,101,32,100,105,103,105,116,115,32,116,104,97,110,32,97,114,101,32,97,108,108,111,119,101,100,32,40,39,37,115,39,41,46,10,0,0,0,0,0,0,0,0,84,104,101,32,118,97,108,117,101,32,39,37,115,39,32,104,97,115,32,109,111,114,101,32,102,114,97,99,116,105,111,110,97,108,32,100,105,103,105,116,115,32,116,104,97,110,32,97,114,101,32,97,108,108,111,119,101,100,32,40,39,37,115,39,41,46,10,0,0,0,0,0,84,104,101,32,118,97,108,117,101,32,39,37,115,39,32,105,115,32,110,111,116,32,102,97,99,101,116,45,118,97,108,105,100,46,10,0,0,0,0,0,84,104,101,32,118,97,108,117,101,32,105,115,32,110,111,116,32,102,97,99,101,116,45,118,97,108,105,100,46,10,0,0,120,109,108,83,99,104,101,109,97,70,111,114,109,97,116,70,97,99,101,116,69,110,117,109,83,101,116,0,0,0,0,0,99,111,109,112,117,116,101,32,116,104,101,32,99,97,110,111,110,105,99,97,108,32,108,101,120,105,99,97,108,32,114,101,112,114,101,115,101,110,116,97,116,105,111,110,0,0,0,0,44,32,39,0,0,0,0,0,120,109,108,83,99,104,101,109,97,86,97,108,105,100,97,116,101,81,78,97,109,101,0,0,99,97,108,108,105,110,103,32,120,109,108,86,97,108,105,100,97,116,101,81,78,97,109,101,40,41,0,0,0,0,0,0,120,109,108,83,99,104,101,109,97,86,97,108,105,100,97,116,101,78,111,116,97,116,105,111,110,0,0,0,0,0,0,0,97,32,115,99,104,101,109,97,32,105,115,32,110,101,101,100,101,100,32,111,110,32,116,104,101,32,118,97,108,105,100,97,116,105,111,110,32,99,111,110,116,101,120,116,0,0,0,0,112,97,116,116,101,114,110,0,109,97,120,69,120,99,108,117,115,105,118,101,0,0,0,0,109,97,120,73,110,99,108,117,115,105,118,101,0,0,0,0,109,105,110,69,120,99,108,117,115,105,118,101,0,0,0,0,109,105,110,73,110,99,108,117,115,105,118,101,0,0,0,0,119,104,105,116,101,83,112,97,99,101,0,0,0,0,0,0,101,110,117,109,101,114,97,116,105,111,110,0,0,0,0,0,108,101,110,103,116,104,0,0,109,97,120,76,101,110,103,116,104,0,0,0,0,0,0,0,109,105,110,76,101,110,103,116,104,0,0,0,0,0,0,0,116,111,116,97,108,68,105,103,105,116,115,0,0,0,0,0,102,114,97,99,116,105,111,110,68,105,103,105,116,115,0,0,73,110,116,101,114,110,97,108,32,69,114,114,111,114,0,0,67,97,110,110,111,116,32,99,114,101,97,116,101,32,97,117,116,111,109,97,116,97,32,102,111,114,32,99,111,109,112,108,101,120,32,116,121,112,101,32,37,115,10,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,32,116,104,101,32,99,111,110,116,101,110,116,32,109,111,100,101,108,0,0,0,0,0,84,104,101,32,99,111,110,116,101,110,116,32,109,111,100,101,108,32,105,115,32,110,111,116,32,100,101,116,101,114,109,105,110,105,115,116,0,0,0,0,120,109,108,83,99,104,101,109,97,66,117,105,108,100,65,67,111,110,116,101,110,116,77,111,100,101,108,0,0,0,0,0,112,97,114,116,105,99,108,101,32,105,115,32,78,85,76,76,0,0,0,0,0,0,0,0,60,101,108,101,109,101,110,116,62,32,112,97,114,116,105,99,108,101,32,104,97,115,32,110,111,32,116,101,114,109,0,0,102,111,117,110,100,32,117,110,101,120,112,101,99,116,101,100,32,116,101,114,109,32,111,102,32,116,121,112,101,32,39,37,115,39,32,105,110,32,99,111,110,116,101,110,116,32,109,111,100,101,108,0,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,0,0,0,0,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,120,109,108,83,99,104,101,109,97,66,117,105,108,100,67,111,110,116,101,110,116,77,111,100,101,108,70,111,114,83,117,98,115,116,71,114,111,117,112,44,32,100,101,99,108,97,114,97,116,105,111,110,32,105,115,32,109,97,114,107,101,100,32,104,97,118,105,110,103,32,97,32,115,117,98,115,116,46,32,103,114,111,117,112,32,98,117,116,32,110,111,110,101,32,97,118,97,105,108,97,98,108,101,46,10,0,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,97,32,115,117,98,115,116,105,116,117,116,105,111,110,32,103,114,111,117,112,32,99,111,110,116,97,105,110,101,114,0,0,0,0,0,0,0,120,109,108,83,99,104,101,109,97,83,117,98,115,116,71,114,111,117,112,65,100,100,0,0,102,97,105,108,101,100,32,116,111,32,97,100,100,32,97,32,110,101,119,32,115,117,98,115,116,105,116,117,116,105,111,110,32,99,111,110,116,97,105,110,101,114,0,0,0,0,0,0,79,110,108,121,32,103,108,111,98,97,108,32,101,108,101,109,101,110,116,32,100,101,99,108,97,114,97,116,105,111,110,115,32,99,97,110,32,104,97,118,101,32,97,32,115,117,98,115,116,105,116,117,116,105,111,110,32,103,114,111,117,112,32,97,102,102,105,108,105,97,116,105,111,110,0,0,0,0,0,0,84,104,101,32,101,108,101,109,101,110,116,32,100,101,99,108,97,114,97,116,105,111,110,32,39,37,115,39,32,100,101,102,105,110,101,115,32,97,32,99,105,114,99,117,108,97,114,32,115,117,98,115,116,105,116,117,116,105,111,110,32,103,114,111,117,112,32,116,111,32,101,108,101,109,101,110,116,32,100,101,99,108,97,114,97,116,105,111,110,32,39,37,115,39,0,0,84,104,101,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,32,39,37,115,39,32,119,97,115,32,101,105,116,104,101,114,32,114,101,106,101,99,116,101,100,32,98,121,32,116,104,101,32,115,117,98,115,116,105,116,117,116,105,111,110,32,103,114,111,117,112,32,97,102,102,105,108,105,97,116,105,111,110,32,39,37,115,39,44,32,111,114,32,110,111,116,32,118,97,108,105,100,108,121,32,100,101,114,105,118,101,100,32,102,114,111,109,32,105,116,115,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,32,39,37,115,39,0,0,0,84,104,101,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,32,40,111,114,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,39,115,32,99,111,110,116,101,110,116,32,116,121,112,101,41,32,105,115,32,111,114,32,105,115,32,100,101,114,105,118,101,100,32,102,114,111,109,32,73,68,59,32,118,97,108,117,101,32,99,111,110,115,116,114,97,105,110,116,115,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,32,105,110,32,99,111,110,106,117,110,99,116,105,111,110,32,119,105,116,104,32,115,117,99,104,32,97,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,120,109,108,83,99,104,101,109,97,67,104,101,99,107,69,108,101,109,80,114,111,112,115,67,111,114,114,101,99,116,44,32,116,121,112,101,32,105,115,32,109,105,115,115,105,110,103,46,46,46,32,115,107,105,112,112,105,110,103,32,118,97,108,105,100,97,116,105,111,110,32,111,102,32,116,104,101,32,118,97,108,117,101,32,99,111,110,115,116,114,97,105,110,116,0,0,102,105,120,101,100,0,0,0,100,101,102,97,117,108,116,0,120,109,108,83,99,104,101,109,97,69,108,101,109,67,104,101,99,107,86,97,108,67,111,110,115,116,114,0,0,0,0,0,102,97,105,108,101,100,32,116,111,32,118,97,108,105,100,97,116,101,32,116,104,101,32,118,97,108,117,101,32,99,111,110,115,116,114,97,105,110,116,32,111,102,32,97,110,32,101,108,101,109,101,110,116,32,100,101,99,108,97,114,97,116,105,111,110,0,0,0,0,0,0,0,70,111,114,32,97,32,115,116,114,105,110,103,32,116,111,32,98,101,32,97,32,118,97,108,105,100,32,100,101,102,97,117,108,116,44,32,116,104,101,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,32,109,117,115,116,32,98,101,32,97,32,115,105,109,112,108,101,32,116,121,112,101,32,111,114,32,97,32,99,111,109,112,108,101,120,32,116,121,112,101,32,119,105,116,104,32,109,105,120,101,100,32,99,111,110,116,101,110,116,32,97,110,100,32,97,32,112,97,114,116,105,99,108,101,32,101,109,112,116,105,97,98,108,101,0,0,0,0,0,120,109,108,83,99,104,101,109,97,80,97,114,115,101,67,104,101,99,107,67,79,83,86,97,108,105,100,68,101,102,97,117,108,116,0,0,0,0,0,0,84,104,101,32,97,116,116,114,105,98,117,116,101,32,100,101,99,108,97,114,97,116,105,111,110,32,104,97,115,32,97,32,39,102,105,120,101,100,39,32,118,97,108,117,101,32,99,111,110,115,116,114,97,105,110,116,32,44,32,116,104,117,115,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,117,115,101,32,109,117,115,116,32,97,108,115,111,32,104,97,118,101,32,97,32,39,102,105,120,101,100,39,32,118,97,108,117,101,32,99,111,110,115,116,114,97,105,110,116,0,0,0,0,0,86,97,108,117,101,32,99,111,110,115,116,114,97,105,110,116,115,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,32,105,102,32,116,104,101,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,32,105,115,32,111,114,32,105,115,32,100,101,114,105,118,101,100,32,102,114,111,109,32,120,115,58,73,68,0,0,0,0,120,109,108,83,99,104,101,109,97,67,104,101,99,107,65,116,116,114,85,115,101,80,114,111,112,115,67,111,114,114,101,99,116,0,0,0,0,0,0,0,84,104,101,32,118,97,108,117,101,32,111,102,32,116,104,101,32,118,97,108,117,101,32,99,111,110,115,116,114,97,105,110,116,32,105,115,32,110,111,116,32,118,97,108,105,100,0,0,84,104,101,32,39,102,105,120,101,100,39,32,118,97,108,117,101,32,99,111,110,115,116,114,97,105,110,116,32,111,102,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,117,115,101,32,109,117,115,116,32,109,97,116,99,104,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,100,101,99,108,97,114,97,116,105,111,110,39,115,32,118,97,108,117,101,32,99,111,110,115,116,114,97,105,110,116,32,39,37,115,39,0,0,120,109,108,83,99,104,101,109,97,67,104,101,99,107,65,116,116,114,80,114,111,112,115,67,111,114,114,101,99,116,0,0,84,104,101,32,117,110,105,111,110,32,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,32,105,115,32,99,105,114,99,117,108,97,114,0,0,0,67,105,114,99,117,108,97,114,32,114,101,102,101,114,101,110,99,101,32,116,111,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,103,114,111,117,112,32,39,37,115,39,32,100,101,102,105,110,101,100,0,0,67,105,114,99,117,108,97,114,32,114,101,102,101,114,101,110,99,101,32,116,111,32,116,104,101,32,109,111,100,101,108,32,103,114,111,117,112,32,100,101,102,105,110,105,116,105,111,110,32,39,37,115,39,32,100,101,102,105,110,101,100,0,0,0,84,104,101,32,100,101,102,105,110,105,116,105,111,110,32,105,115,32,99,105,114,99,117,108,97,114,0,0,0,0,0,0,114,101,102,0,0,0,0,0,37,115,44,32,97,116,116,114,105,98,117,116,101,32,39,37,115,39,58,32,84,104,101,32,81,78,97,109,101,32,118,97,108,117,101,32,39,37,115,39,32,100,111,101,115,32,110,111,116,32,114,101,115,111,108,118,101,32,116,111,32,97,40,110,41,32,37,115,46,10,0,0,114,101,102,101,114,0,0,0,84,104,101,32,107,101,121,114,101,102,32,114,101,102,101,114,101,110,99,101,115,32,97,32,107,101,121,114,101,102,0,0,84,104,101,32,99,97,114,100,105,110,97,108,105,116,121,32,111,102,32,116,104,101,32,107,101,121,114,101,102,32,100,105,102,102,101,114,115,32,102,114,111,109,32,116,104,101,32,99,97,114,100,105,110,97,108,105,116,121,32,111,102,32,116,104,101,32,114,101,102,101,114,101,110,99,101,100,32,107,101,121,47,117,110,105,113,117,101,32,39,37,115,39,0,0,0,0,65,32,109,111,100,101,108,32,103,114,111,117,112,32,100,101,102,105,110,105,116,105,111,110,32,105,115,32,114,101,102,101,114,101,110,99,101,100,44,32,98,117,116,32,105,116,32,99,111,110,116,97,105,110,115,32,97,110,32,39,97,108,108,39,32,109,111,100,101,108,32,103,114,111,117,112,44,32,119,104,105,99,104,32,99,97,110,110,111,116,32,98,101,32,99,111,110,116,97,105,110,101,100,32,98,121,32,109,111,100,101,108,32,103,114,111,117,112,115,0,105,116,101,109,84,121,112,101,0,0,0,0,0,0,0,0,84,104,101,32,112,97,114,116,105,99,108,101,39,115,32,123,109,97,120,32,111,99,99,117,114,115,125,32,109,117,115,116,32,98,101,32,49,44,32,115,105,110,99,101,32,116,104,101,32,114,101,102,101,114,101,110,99,101,32,114,101,115,111,108,118,101,115,32,116,111,32,97,110,32,39,97,108,108,39,32,109,111,100,101,108,32,103,114,111,117,112,0,0,0,0,0,109,101,109,98,101,114,84,121,112,101,115,0,0,0,0,0,116,121,112,101,32,100,101,102,105,110,105,116,105,111,110,0,115,117,98,115,116,105,116,117,116,105,111,110,71,114,111,117,112,0,0,0,0,0,0,0,120,109,108,83,99,104,101,109,97,65,100,100,67,111,109,112,111,110,101,110,116,115,0,0,85,110,101,120,112,101,99,116,101,100,32,103,108,111,98,97,108,32,99,111,109,112,111,110,101,110,116,32,116,121,112,101,0,0,0,0,0,0,0,0,102,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,97,32,99,111,109,112,111,110,101,110,116,32,104,97,115,104,32,116,97,98,108,101,0,65,32,103,108,111,98,97,108,32,37,115,32,39,37,115,39,32,100,111,101,115,32,97,108,114,101,97,100,121,32,101,120,105,115,116,0,0,0,0,0,84,104,101,32,37,115,32,39,37,115,39,32,116,111,32,98,101,32,114,101,100,101,102,105,110,101,100,32,99,111,117,108,100,32,110,111,116,32,98,101,32,102,111,117,110,100,32,105,110,32,116,104,101,32,114,101,100,101,102,105,110,101,100,32,115,99,104,101,109,97,0,0,120,109,108,83,99,104,101,109,97,82,101,115,111,108,118,101,82,101,100,101,102,82,101,102,101,114,101,110,99,101,115,0,85,110,101,120,112,101,99,116,101,100,32,114,101,100,101,102,105,110,101,100,32,99,111,109,112,111,110,101,110,116,32,116,121,112,101,0,0,0,0,0,84,104,101,32,114,101,102,101,114,101,110,99,101,100,32,37,115,32,119,97,115,32,97,108,114,101,97,100,121,32,114,101,100,101,102,105,110,101,100,46,32,77,117,108,116,105,112,108,101,32,114,101,100,101,102,105,110,105,116,105,111,110,32,111,102,32,116,104,101,32,115,97,109,101,32,99,111,109,112,111,110,101,110,116,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,0,0,105,110,99,108,117,100,101,0,105,109,112,111,114,116,0,0,114,101,100,101,102,105,110,101,0,0,0,0,0,0,0,0,97,110,110,111,116,97,116,105,111,110,0,0,0,0,0,0,99,111,109,112,108,101,120,84,121,112,101,0,0,0,0,0,115,105,109,112,108,101,84,121,112,101,0,0,0,0,0,0,101,108,101,109,101,110,116,0,97,116,116,114,105,98,117,116,101,0,0,0,0,0,0,0,97,116,116,114,105,98,117,116,101,71,114,111,117,112,0,0,103,114,111,117,112,0,0,0,110,111,116,97,116,105,111,110,0,0,0,0,0,0,0,0,40,40,105,110,99,108,117,100,101,32,124,32,105,109,112,111,114,116,32,124,32,114,101,100,101,102,105,110,101,32,124,32,97,110,110,111,116,97,116,105,111,110,41,42,44,32,40,40,40,115,105,109,112,108,101,84,121,112,101,32,124,32,99,111,109,112,108,101,120,84,121,112,101,32,124,32,103,114,111,117,112,32,124,32,97,116,116,114,105,98,117,116,101,71,114,111,117,112,41,32,124,32,101,108,101,109,101,110,116,32,124,32,97,116,116,114,105,98,117,116,101,32,124,32,110,111,116,97,116,105,111,110,41,44,32,97,110,110,111,116,97,116,105,111,110,42,41,42,41,0,0,0,37,115,58,32,37,115,46,10,0,0,0,0,0,0,0,0,37,115,58,32,84,104,101,32,99,111,110,116,101,110,116,32,105,115,32,110,111,116,32,118,97,108,105,100,46,32,69,120,112,101,99,116,101,100,32,105,115,32,37,115,46,10,0,0,37,115,58,32,84,104,101,32,99,111,110,116,101,110,116,32,105,115,32,110,111,116,32,118,97,108,105,100,46,10,0,0,110,97,109,101,0,0,0,0,78,111,116,97,116,105,111,110,32,104,97,115,32,110,111,32,110,97,109,101,10,0,0,0,105,100,0,0,0,0,0,0,40,97,110,110,111,116,97,116,105,111,110,63,41,0,0,0,68,117,112,108,105,99,97,116,101,32,118,97,108,117,101,32,39,37,115,39,32,111,102,32,115,105,109,112,108,101,32,116,121,112,101,32,39,120,115,58,73,68,39,0,0,0,0,0,84,104,101,32,118,97,108,117,101,32,39,37,115,39,32,111,102,32,115,105,109,112,108,101,32,116,121,112,101,32,39,120,115,58,73,68,39,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,39,120,115,58,78,67,78,97,109,101,39,0,0,0,0,0,0,0,0,39,46,0,0,0,0,0,0,84,104,101,32,118,97,108,117,101,32,39,37,115,39,32,105,115,32,110,111,116,32,118,97,108,105,100,46,0,0,0,0,84,104,101,32,99,104,97,114,97,99,116,101,114,32,99,111,110,116,101,110,116,32,105,115,32,110,111,116,32,118,97,108,105,100,46,0,0,0,0,0,32,69,120,112,101,99,116,101,100,32,105,115,32,39,0,0,39,46,10,0,0,0,0,0,97,100,100,32,97,110,110,111,116,97,116,105,111,110,0,0,97,108,108,0,0,0,0,0,99,104,111,105,99,101,0,0,115,101,113,117,101,110,99,101,0,0,0,0,0,0,0,0,40,97,110,110,111,116,97,116,105,111,110,63,44,32,40,97,108,108,32,124,32,99,104,111,105,99,101,32,124,32,115,101,113,117,101,110,99,101,41,63,41,0,0,0,0,0,0,0,40,48,32,124,32,49,41,0,49,0,0,0,0,0,0,0,120,115,58,110,111,110,78,101,103,97,116,105,118,101,73,110,116,101,103,101,114,0,0,0,40,120,115,58,110,111,110,78,101,103,97,116,105,118,101,73,110,116,101,103,101,114,32,124,32,117,110,98,111,117,110,100,101,100,41,0,0,0,0,0,109,97,120,79,99,99,117,114,115,0,0,0,0,0,0,0,109,105,110,79,99,99,117,114,115,0,0,0,0,0,0,0,73,110,118,97,108,105,100,32,118,97,108,117,101,32,102,111,114,32,109,105,110,79,99,99,117,114,115,32,40,109,117,115,116,32,98,101,32,48,32,111,114,32,49,41,0,0,0,0,73,110,118,97,108,105,100,32,118,97,108,117,101,32,102,111,114,32,109,97,120,79,99,99,117,114,115,32,40,109,117,115,116,32,98,101,32,48,32,111,114,32,49,41,0,0,0,0,40,97,110,110,111,116,97,116,105,111,110,63,44,32,40,97,110,110,111,116,97,116,105,111,110,63,44,32,101,108,101,109,101,110,116,42,41,0,0,0,97,110,121,0,0,0,0,0,84,104,101,32,114,101,100,101,102,105,110,105,110,103,32,109,111,100,101,108,32,103,114,111,117,112,32,100,101,102,105,110,105,116,105,111,110,32,39,37,115,39,32,109,117,115,116,32,110,111,116,32,99,111,110,116,97,105,110,32,109,111,114,101,32,116,104,97,110,32,111,110,101,32,114,101,102,101,114,101,110,99,101,32,116,111,32,116,104,101,32,114,101,100,101,102,105,110,101,100,32,100,101,102,105,110,105,116,105,111,110,0,84,104,101,32,114,101,100,101,102,105,110,105,110,103,32,109,111,100,101,108,32,103,114,111,117,112,32,100,101,102,105,110,105,116,105,111,110,32,39,37,115,39,32,109,117,115,116,32,110,111,116,32,99,111,110,116,97,105,110,32,97,32,114,101,102,101,114,101,110,99,101,32,116,111,32,116,104,101,32,114,101,100,101,102,105,110,101,100,32,100,101,102,105,110,105,116,105,111,110,32,119,105,116,104,32,97,32,109,97,120,79,99,99,117,114,115,47,109,105,110,79,99,99,117,114,115,32,111,116,104,101,114,32,116,104,97,110,32,49,0,0,0,0,0,40,97,110,110,111,116,97,116,105,111,110,63,44,32,40,101,108,101,109,101,110,116,32,124,32,103,114,111,117,112,32,124,32,99,104,111,105,99,101,32,124,32,115,101,113,117,101,110,99,101,32,124,32,97,110,121,41,42,41,0,0,0,0,0,110,97,109,101,115,112,97,99,101,0,0,0,0,0,0,0,112,114,111,99,101,115,115,67,111,110,116,101,110,116,115,0,40,115,116,114,105,99,116,32,124,32,115,107,105,112,32,124,32,108,97,120,41,0,0,0,35,35,97,110,121,0,0,0,40,40,35,35,97,110,121,32,124,32,35,35,111,116,104,101,114,41,32,124,32,76,105,115,116,32,111,102,32,40,120,115,58,97,110,121,85,82,73,32,124,32,40,35,35,116,97,114,103,101,116,78,97,109,101,115,112,97,99,101,32,124,32,35,35,108,111,99,97,108,41,41,41,0,0,0,0,0,0,0,35,35,116,97,114,103,101,116,78,97,109,101,115,112,97,99,101,0,0,0,0,0,0,0,35,35,108,111,99,97,108,0,120,109,108,83,99,104,101,109,97,80,86,97,108,65,116,116,114,78,111,100,101,86,97,108,117,101,0,0,0,0,0,0,116,104,101,32,103,105,118,101,110,32,116,121,112,101,32,105,115,32,110,111,116,32,97,32,98,117,105,108,116,45,105,110,32,116,121,112,101,0,0,0,118,97,108,105,100,97,116,105,111,110,32,117,115,105,110,103,32,116,104,101,32,103,105,118,101,110,32,116,121,112,101,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,119,104,105,108,101,32,112,97,114,115,105,110,103,32,97,32,115,99,104,101,109,97,0,102,97,105,108,101,100,32,116,111,32,118,97,108,105,100,97,116,101,32,97,32,115,99,104,101,109,97,32,97,116,116,114,105,98,117,116,101,32,118,97,108,117,101,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,81,78,97,109,101,32,114,101,102,101,114,101,110,99,101,32,105,116,101,109,0,82,101,102,101,114,101,110,99,101,115,32,102,114,111,109,32,116,104,105,115,32,115,99,104,101,109,97,32,116,111,32,99,111,109,112,111,110,101,110,116,115,32,105,110,32,110,111,32,110,97,109,101,115,112,97,99,101,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,44,32,115,105,110,99,101,32,110,111,116,32,105,110,100,105,99,97,116,101,100,32,98,121,32,97,110,32,105,109,112,111,114,116,32,115,116,97,116,101,109,101,110,116,0,0,0,82,101,102,101,114,101,110,99,101,115,32,102,114,111,109,32,116,104,105,115,32,115,99,104,101,109,97,32,116,111,32,99,111,109,112,111,110,101,110,116,115,32,105,110,32,116,104,101,32,110,97,109,101,115,112,97,99,101,32,39,37,115,39,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,44,32,115,105,110,99,101,32,110,111,116,32,105,110,100,105,99,97,116,101,100,32,98,121,32,97,110,32,105,109,112,111,114,116,32,115,116,97,116,101,109,101,110,116,0,0,0,0,0,84,104,101,32,118,97,108,117,101,32,39,37,115,39,32,111,102,32,115,105,109,112,108,101,32,116,121,112,101,32,39,120,115,58,81,78,97,109,101,39,32,104,97,115,32,110,111,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,110,97,109,101,115,112,97,99,101,32,100,101,99,108,97,114,97,116,105,111,110,32,105,110,32,115,99,111,112,101,0,0,0,0,84,104,101,32,118,97,108,117,101,32,109,117,115,116,32,98,101,32,103,114,101,97,116,101,114,32,116,104,97,110,32,111,114,32,101,113,117,97,108,32,116,111,32,49,0,0,0,0,84,104,101,32,118,97,108,117,101,32,109,117,115,116,32,110,111,116,32,98,101,32,103,114,101,97,116,101,114,32,116,104,97,110,32,116,104,101,32,118,97,108,117,101,32,111,102,32,39,109,97,120,79,99,99,117,114,115,39,0,0,0,0,0,37,115,44,32,97,116,116,114,105,98,117,116,101,32,39,37,115,39,58,32,37,115,46,10,0,0,0,0,0,0,0,0,85,110,107,110,111,119,110,0,117,110,98,111,117,110,100,101,100,0,0,0,0,0,0,0,37,115,84,104,101,32,97,116,116,114,105,98,117,116,101,32,39,37,115,39,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,46,10,0,0,0,97,100,100,105,110,103,32,103,114,111,117,112,0,0,0,0,37,115,58,32,84,104,101,32,97,116,116,114,105,98,117,116,101,32,39,37,115,39,32,105,115,32,114,101,113,117,105,114,101,100,32,98,117,116,32,109,105,115,115,105,110,103,46,10,0,0,0,0,0,0,0,0,97,110,121,65,116,116,114,105,98,117,116,101,0,0,0,0,40,97,110,110,111,116,97,116,105,111,110,63,44,32,40,40,97,116,116,114,105,98,117,116,101,32,124,32,97,116,116,114,105,98,117,116,101,71,114,111,117,112,41,42,44,32,97,110,121,65,116,116,114,105,98,117,116,101,63,41,41,0,0,0,84,104,101,32,114,101,100,101,102,105,110,105,110,103,32,97,116,116,114,105,98,117,116,101,32,103,114,111,117,112,32,100,101,102,105,110,105,116,105,111,110,32,39,37,115,39,32,109,117,115,116,32,110,111,116,32,99,111,110,116,97,105,110,32,109,111,114,101,32,116,104,97,110,32,111,110,101,32,114,101,102,101,114,101,110,99,101,32,116,111,32,116,104,101,32,114,101,100,101,102,105,110,101,100,32,100,101,102,105,110,105,116,105,111,110,0,0,0,0,0,102,111,114,109,0,0,0,0,113,117,97,108,105,102,105,101,100,0,0,0,0,0,0,0,117,110,113,117,97,108,105,102,105,101,100,0,0,0,0,0,40,113,117,97,108,105,102,105,101,100,32,124,32,117,110,113,117,97,108,105,102,105,101,100,41,0,0,0,0,0,0,0,117,115,101,0,0,0,0,0,111,112,116,105,111,110,97,108,0,0,0,0,0,0,0,0,112,114,111,104,105,98,105,116,101,100,0,0,0,0,0,0,114,101,113,117,105,114,101,100,0,0,0,0,0,0,0,0,40,111,112,116,105,111,110,97,108,32,124,32,112,114,111,104,105,98,105,116,101,100,32,124,32,114,101,113,117,105,114,101,100,41,0,0,0,0,0,0,84,104,101,32,118,97,108,117,101,32,111,102,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,39,117,115,101,39,32,109,117,115,116,32,98,101,32,39,111,112,116,105,111,110,97,108,39,32,105,102,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,39,100,101,102,97,117,108,116,39,32,105,115,32,112,114,101,115,101,110,116,0,0,0,0,0,0,0,84,104,101,32,116,97,114,103,101,116,32,110,97,109,101,115,112,97,99,101,32,109,117,115,116,32,110,111,116,32,109,97,116,99,104,32,39,37,115,39,0,0,0,0,0,0,0,0,120,109,108,110,115,0,0,0,84,104,101,32,118,97,108,117,101,32,111,102,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,109,117,115,116,32,110,111,116,32,109,97,116,99,104,32,39,120,109,108,110,115,39,0,0,0,0,0,0,0,83,107,105,112,112,105,110,103,32,97,116,116,114,105,98,117,116,101,32,117,115,101,32,112,114,111,104,105,98,105,116,105,111,110,44,32,115,105,110,99,101,32,105,116,32,105,115,32,112,111,105,110,116,108,101,115,115,32,105,110,115,105,100,101,32,97,110,32,60,97,116,116,114,105,98,117,116,101,71,114,111,117,112,62,0,0,0,0,83,107,105,112,112,105,110,103,32,97,116,116,114,105,98,117,116,101,32,117,115,101,32,112,114,111,104,105,98,105,116,105,111,110,44,32,115,105,110,99,101,32,105,116,32,105,115,32,112,111,105,110,116,108,101,115,115,32,119,104,101,110,32,101,120,116,101,110,100,105,110,103,32,97,32,116,121,112,101,0,83,107,105,112,112,105,110,103,32,100,117,112,108,105,99,97,116,101,32,97,116,116,114,105,98,117,116,101,32,117,115,101,32,112,114,111,104,105,98,105,116,105,111,110,32,39,37,115,39,0,0,0,0,0,0,0,84,104,101,32,97,116,116,114,105,98,117,116,101,32,39,116,121,112,101,39,32,97,110,100,32,116,104,101,32,60,115,105,109,112,108,101,84,121,112,101,62,32,99,104,105,108,100,32,97,114,101,32,109,117,116,117,97,108,108,121,32,101,120,99,108,117,115,105,118,101,0,0,40,97,110,110,111,116,97,116,105,111,110,63,44,32,115,105,109,112,108,101,84,121,112,101,63,41,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,97,116,116,114,105,98,117,116,101,32,117,115,101,32,112,114,111,104,105,98,105,116,105,111,110,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,97,116,116,114,105,98,117,116,101,0,0,0,0,37,115,58,32,84,104,101,32,97,116,116,114,105,98,117,116,101,115,32,39,37,115,39,32,97,110,100,32,39,37,115,39,32,97,114,101,32,109,117,116,117,97,108,108,121,32,101,120,99,108,117,115,105,118,101,46,10,0,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,97,116,116,114,105,98,117,116,101,32,103,114,111,117,112,0,0,0,0,0,0,79,110,108,121,32,116,104,101,32,97,116,116,114,105,98,117,116,101,115,32,39,109,105,110,79,99,99,117,114,115,39,44,32,39,109,97,120,79,99,99,117,114,115,39,32,97,110,100,32,39,105,100,39,32,97,114,101,32,97,108,108,111,119,101,100,32,105,110,32,97,100,100,105,116,105,111,110,32,116,111,32,39,114,101,102,39,0,0,98,108,111,99,107,0,0,0,110,105,108,108,97,98,108,101,0,0,0,0,0,0,0,0,102,105,110,97,108,0,0,0,97,98,115,116,114,97,99,116,0,0,0,0,0,0,0,0,40,35,97,108,108,32,124,32,76,105,115,116,32,111,102,32,40,101,120,116,101,110,115,105,111,110,32,124,32,114,101,115,116,114,105,99,116,105,111,110,41,41,0,0,0,0,0,0,40,35,97,108,108,32,124,32,76,105,115,116,32,111,102,32,40,101,120,116,101,110,115,105,111,110,32,124,32,114,101,115,116,114,105,99,116,105,111,110,32,124,32,115,117,98,115,116,105,116,117,116,105,111,110,41,41,0,0,0,0,0,0,0,84,104,101,32,97,116,116,114,105,98,117,116,101,32,39,116,121,112,101,39,32,97,110,100,32,116,104,101,32,60,99,111,109,112,108,101,120,84,121,112,101,62,32,99,104,105,108,100,32,97,114,101,32,109,117,116,117,97,108,108,121,32,101,120,99,108,117,115,105,118,101,0,117,110,105,113,117,101,0,0,107,101,121,0,0,0,0,0,107,101,121,114,101,102,0,0,40,97,110,110,111,116,97,116,105,111,110,63,44,32,40,40,115,105,109,112,108,101,84,121,112,101,32,124,32,99,111,109,112,108,101,120,84,121,112,101,41,63,44,32,40,117,110,105,113,117,101,32,124,32,107,101,121,32,124,32,107,101,121,114,101,102,41,42,41,41,0,0,65,32,99,104,105,108,100,32,101,108,101,109,101,110,116,32,105,115,32,109,105,115,115,105,110,103,0,0,0,0,0,0,40,97,110,110,111,116,97,116,105,111,110,63,44,32,40,115,101,108,101,99,116,111,114,44,32,102,105,101,108,100,43,41,41,0,0,0,0,0,0,0,115,101,108,101,99,116,111,114,0,0,0,0,0,0,0,0,102,105,101,108,100,0,0,0,120,112,97,116,104,0,0,0,97,108,108,111,99,97,116,105,110,103,32,97,32,39,115,101,108,101,99,116,111,114,39,32,111,102,32,97,110,32,105,100,101,110,116,105,116,121,45,99,111,110,115,116,114,97,105,110,116,32,100,101,102,105,110,105,116,105,111,110,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,120,109,108,83,99,104,101,109,97,80,97,114,115,101,73,68,67,83,101,108,101,99,116,111,114,65,110,100,70,105,101,108,100,44,32,118,97,108,105,100,97,116,105,110,103,32,116,104,101,32,88,80,97,116,104,32,101,120,112,114,101,115,115,105,111,110,32,111,102,32,97,32,73,68,67,32,115,101,108,101,99,116,111,114,46,10,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,120,109,108,83,99,104,101,109,97,65,100,100,65,110,110,111,116,97,116,105,111,110,44,32,84,104,101,32,105,116,101,109,32,105,115,32,110,111,116,32,97,32,97,110,110,111,116,97,116,101,100,32,115,99,104,101,109,97,32,99,111,109,112,111,110,101,110,116,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,120,109,108,83,99,104,101,109,97,67,104,101,99,107,67,83,101,108,101,99,116,111,114,88,80,97,116,104,44,32,116,104,101,32,115,101,108,101,99,116,111,114,32,105,115,32,110,111,116,32,115,112,101,99,105,102,105,101,100,46,10,0,0,0,84,104,101,32,88,80,97,116,104,32,101,120,112,114,101,115,115,105,111,110,32,111,102,32,116,104,101,32,115,101,108,101,99,116,111,114,32,105,115,32,110,111,116,32,118,97,108,105,100,0,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,97,32,110,97,109,101,115,112,97,99,101,32,97,114,114,97,121,0,0,0,0,84,104,101,32,88,80,97,116,104,32,101,120,112,114,101,115,115,105,111,110,32,39,37,115,39,32,99,111,117,108,100,32,110,111,116,32,98,101,32,99,111,109,112,105,108,101,100,0,97,108,108,111,99,97,116,105,110,103,32,97,110,32,105,100,101,110,116,105,116,121,45,99,111,110,115,116,114,97,105,110,116,32,100,101,102,105,110,105,116,105,111,110,0,0,0,0,35,97,108,108,0,0,0,0,101,120,116,101,110,115,105,111,110,0,0,0,0,0,0,0,114,101,115,116,114,105,99,116,105,111,110,0,0,0,0,0,115,117,98,115,116,105,116,117,116,105,111,110,0,0,0,0,108,105,115,116,0,0,0,0,117,110,105,111,110,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,48,0,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,101,108,101,109,101,110,116,0,0,0,0,0,0,82,101,100,101,102,105,110,105,116,105,111,110,32,111,102,32,98,117,105,108,116,45,105,110,32,115,105,109,112,108,101,32,116,121,112,101,115,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,0,40,35,97,108,108,32,124,32,76,105,115,116,32,111,102,32,40,108,105,115,116,32,124,32,117,110,105,111,110,32,124,32,114,101,115,116,114,105,99,116,105,111,110,41,0,0,0,0,40,97,110,110,111,116,97,116,105,111,110,63,44,32,40,114,101,115,116,114,105,99,116,105,111,110,32,124,32,108,105,115,116,32,124,32,117,110,105,111,110,41,41,0,0,0,0,0,84,104,105,115,32,105,115,32,97,32,114,101,100,101,102,105,110,105,116,105,111,110,44,32,116,104,117,115,32,116,104,101,32,60,115,105,109,112,108,101,84,121,112,101,62,32,109,117,115,116,32,104,97,118,101,32,97,32,60,114,101,115,116,114,105,99,116,105,111,110,62,32,99,104,105,108,100,0,0,0,120,109,108,83,99,104,101,109,97,80,97,114,115,101,85,110,105,111,110,44,32,97,108,108,111,99,97,116,105,110,103,32,97,32,116,121,112,101,32,108,105,110,107,0,0,0,0,0,40,97,110,110,111,116,97,116,105,111,110,63,44,32,115,105,109,112,108,101,84,121,112,101,42,41,0,0,0,0,0,0,69,105,116,104,101,114,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,39,109,101,109,98,101,114,84,121,112,101,115,39,32,111,114,32,97,116,32,108,101,97,115,116,32,111,110,101,32,60,115,105,109,112,108,101,84,121,112,101,62,32,99,104,105,108,100,32,109,117,115,116,32,98,101,32,112,114,101,115,101,110,116,0,0,0,84,104,101,32,97,116,116,114,105,98,117,116,101,32,39,105,116,101,109,84,121,112,101,39,32,97,110,100,32,116,104,101,32,60,115,105,109,112,108,101,84,121,112,101,62,32,99,104,105,108,100,32,97,114,101,32,109,117,116,117,97,108,108,121,32,101,120,99,108,117,115,105,118,101,0,0,0,0,0,0,69,105,116,104,101,114,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,39,105,116,101,109,84,121,112,101,39,32,111,114,32,116,104,101,32,60,115,105,109,112,108,101,84,121,112,101,62,32,99,104,105,108,100,32,109,117,115,116,32,98,101,32,112,114,101,115,101,110,116,0,0,0,0,0,0,0,84,104,105,115,32,105,115,32,97,32,114,101,100,101,102,105,110,105,116,105,111,110,44,32,98,117,116,32,116,104,101,32,81,78,97,109,101,32,118,97,108,117,101,32,39,37,115,39,32,111,102,32,116,104,101,32,39,98,97,115,101,39,32,97,116,116,114,105,98,117,116,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,116,121,112,101,39,115,32,100,101,115,105,103,110,97,116,105,111,110,32,39,37,115,39,0,0,0,0,0,84,104,101,32,97,116,116,114,105,98,117,116,101,32,39,98,97,115,101,39,32,97,110,100,32,116,104,101,32,60,115,105,109,112,108,101,84,121,112,101,62,32,99,104,105,108,100,32,97,114,101,32,109,117,116,117,97,108,108,121,32,101,120,99,108,117,115,105,118,101,0,0,69,105,116,104,101,114,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,39,98,97,115,101,39,32,111,114,32,97,32,60,115,105,109,112,108,101,84,121,112,101,62,32,99,104,105,108,100,32,109,117,115,116,32,98,101,32,112,114,101,115,101,110,116,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,97,32,102,97,99,101,116,32,108,105,110,107,0,97,110,110,111,116,97,116,105,111,110,63,44,32,40,103,114,111,117,112,32,124,32,97,108,108,32,124,32,99,104,111,105,99,101,32,124,32,115,101,113,117,101,110,99,101,41,63,44,32,40,40,97,116,116,114,105,98,117,116,101,32,124,32,97,116,116,114,105,98,117,116,101,71,114,111,117,112,41,42,44,32,97,110,121,65,116,116,114,105,98,117,116,101,63,41,41,0,0,0,0,0,0,0,0,40,97,110,110,111,116,97,116,105,111,110,63,44,32,40,115,105,109,112,108,101,84,121,112,101,63,44,32,40,109,105,110,69,120,99,108,117,115,105,118,101,32,124,32,109,105,110,73,110,99,108,117,115,105,118,101,32,124,32,109,97,120,69,120,99,108,117,115,105,118,101,32,124,32,109,97,120,73,110,99,108,117,115,105,118,101,32,124,32,116,111,116,97,108,68,105,103,105,116,115,32,124,32,102,114,97,99,116,105,111,110,68,105,103,105,116,115,32,124,32,108,101,110,103,116,104,32,124,32,109,105,110,76,101,110,103,116,104,32,124,32,109,97,120,76,101,110,103,116,104,32,124,32,101,110,117,109,101,114,97,116,105,111,110,32,124,32,119,104,105,116,101,83,112,97,99,101,32,124,32,112,97,116,116,101,114,110,41,42,41,63,44,32,40,40,97,116,116,114,105,98,117,116,101,32,124,32,97,116,116,114,105,98,117,116,101,71,114,111,117,112,41,42,44,32,97,110,121,65,116,116,114,105,98,117,116,101,63,41,41,0,0,0,0,0,0,0,0,40,97,110,110,111,116,97,116,105,111,110,63,44,32,40,115,105,109,112,108,101,84,121,112],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+156528),
allocate([101,63,44,32,40,109,105,110,69,120,99,108,117,115,105,118,101,32,124,32,109,105,110,73,110,99,108,117,115,105,118,101,32,124,32,109,97,120,69,120,99,108,117,115,105,118,101,32,124,32,109,97,120,73,110,99,108,117,115,105,118,101,32,124,32,116,111,116,97,108,68,105,103,105,116,115,32,124,32,102,114,97,99,116,105,111,110,68,105,103,105,116,115,32,124,32,108,101,110,103,116,104,32,124,32,109,105,110,76,101,110,103,116,104,32,124,32,109,97,120,76,101,110,103,116,104,32,124,32,101,110,117,109,101,114,97,116,105,111,110,32,124,32,119,104,105,116,101,83,112,97,99,101,32,124,32,112,97,116,116,101,114,110,41,42,41,41,0,97,108,108,111,99,97,116,105,110,103,32,102,97,99,101,116,0,0,0,0,0,0,0,0,118,97,108,117,101,0,0,0,70,97,99,101,116,32,37,115,32,104,97,115,32,110,111,32,118,97,108,117,101,10,0,0,85,110,107,110,111,119,110,32,102,97,99,101,116,32,116,121,112,101,32,37,115,10,0,0,70,97,99,101,116,32,37,115,32,104,97,115,32,117,110,101,120,112,101,99,116,101,100,32,99,104,105,108,100,32,99,111,110,116,101,110,116,10,0,0,109,105,120,101,100,0,0,0,40,35,97,108,108,32,124,32,76,105,115,116,32,111,102,32,40,101,120,116,101,110,115,105,111,110,32,124,32,114,101,115,116,114,105,99,116,105,111,110,41,41,32,0,0,0,0,0,115,105,109,112,108,101,67,111,110,116,101,110,116,0,0,0,99,111,109,112,108,101,120,67,111,110,116,101,110,116,0,0,40,97,110,110,111,116,97,116,105,111,110,63,44,32,40,115,105,109,112,108,101,67,111,110,116,101,110,116,32,124,32,99,111,109,112,108,101,120,67,111,110,116,101,110,116,32,124,32,40,40,103,114,111,117,112,32,124,32,97,108,108,32,124,32,99,104,111,105,99,101,32,124,32,115,101,113,117,101,110,99,101,41,63,44,32,40,40,97,116,116,114,105,98,117,116,101,32,124,32,97,116,116,114,105,98,117,116,101,71,114,111,117,112,41,42,44,32,97,110,121,65,116,116,114,105,98,117,116,101,63,41,41,41,41,0,0,84,104,105,115,32,105,115,32,97,32,114,101,100,101,102,105,110,105,116,105,111,110,44,32,116,104,117,115,32,116,104,101,32,60,99,111,109,112,108,101,120,84,121,112,101,62,32,109,117,115,116,32,104,97,118,101,32,97,32,60,114,101,115,116,114,105,99,116,105,111,110,62,32,111,114,32,60,101,120,116,101,110,115,105,111,110,62,32,103,114,97,110,100,45,99,104,105,108,100,0,0,0,0,0,40,97,110,110,111,116,97,116,105,111,110,63,44,32,40,114,101,115,116,114,105,99,116,105,111,110,32,124,32,101,120,116,101,110,115,105,111,110,41,41,0,0,0,0,0,0,0,0,40,97,110,110,111,116,97,116,105,111,110,63,44,32,40,40,103,114,111,117,112,32,124,32,97,108,108,32,124,32,99,104,111,105,99,101,32,124,32,115,101,113,117,101,110,99,101,41,63,44,32,40,40,97,116,116,114,105,98,117,116,101,32,124,32,97,116,116,114,105,98,117,116,101,71,114,111,117,112,41,42,44,32,97,110,121,65,116,116,114,105,98,117,116,101,63,41,41,41,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,108,111,97,100,32,116,104,101,32,100,111,99,117,109,101,110,116,32,39,37,115,39,32,102,111,114,32,105,110,99,108,117,115,105,111,110,0,0,70,97,105,108,101,100,32,116,111,32,108,111,97,100,32,116,104,101,32,100,111,99,117,109,101,110,116,32,39,37,115,39,32,102,111,114,32,114,101,100,101,102,105,110,105,116,105,111,110,0,0,0,0,0,0,0,84,104,101,32,116,97,114,103,101,116,32,110,97,109,101,115,112,97,99,101,32,111,102,32,116,104,101,32,105,110,99,108,117,100,101,100,47,114,101,100,101,102,105,110,101,100,32,115,99,104,101,109,97,32,39,37,115,39,32,104,97,115,32,116,111,32,98,101,32,97,98,115,101,110,116,44,32,115,105,110,99,101,32,116,104,101,32,105,110,99,108,117,100,105,110,103,47,114,101,100,101,102,105,110,105,110,103,32,115,99,104,101,109,97,32,104,97,115,32,110,111,32,116,97,114,103,101,116,32,110,97,109,101,115,112,97,99,101,0,0,0,0,0,0,84,104,101,32,116,97,114,103,101,116,32,110,97,109,101,115,112,97,99,101,32,39,37,115,39,32,111,102,32,116,104,101,32,105,110,99,108,117,100,101,100,47,114,101,100,101,102,105,110,101,100,32,115,99,104,101,109,97,32,39,37,115,39,32,100,105,102,102,101,114,115,32,102,114,111,109,32,39,37,115,39,32,111,102,32,116,104,101,32,105,110,99,108,117,100,105,110,103,47,114,101,100,101,102,105,110,105,110,103,32,115,99,104,101,109,97,0,0,0,0,84,104,101,32,116,97,114,103,101,116,32,110,97,109,101,115,112,97,99,101,32,111,102,32,116,104,101,32,105,110,99,108,117,100,101,100,47,114,101,100,101,102,105,110,101,100,32,115,99,104,101,109,97,32,39,37,115,39,32,104,97,115,32,116,111,32,98,101,32,97,98,115,101,110,116,32,111,114,32,116,104,101,32,115,97,109,101,32,97,115,32,116,104,101,32,105,110,99,108,117,100,105,110,103,47,114,101,100,101,102,105,110,105,110,103,32,115,99,104,101,109,97,39,115,32,116,97,114,103,101,116,32,110,97,109,101,115,112,97,99,101,0,0,0,40,97,110,110,111,116,97,116,105,111,110,32,124,32,40,115,105,109,112,108,101,84,121,112,101,32,124,32,99,111,109,112,108,101,120,84,121,112,101,32,124,32,103,114,111,117,112,32,124,32,97,116,116,114,105,98,117,116,101,71,114,111,117,112,41,41,42,0,0,0,0,0,120,109,108,83,99,104,101,109,97,80,97,114,115,101,78,101,119,68,111,99,0,0,0,0,114,101,112,97,114,115,105,110,103,32,97,32,115,99,104,101,109,97,32,100,111,99,0,0,112,97,114,115,105,110,103,32,97,32,115,99,104,101,109,97,32,100,111,99,44,32,98,117,116,32,116,104,101,114,101,39,115,32,110,111,32,100,111,99,0,0,0,0,0,0,0,0,120,109,108,83,99,104,101,109,97,80,97,114,115,101,73,110,99,108,117,100,101,79,114,82,101,100,101,102,105,110,101,0,99,111,117,108,100,32,110,111,116,32,98,117,105,108,100,32,97,110,32,85,82,73,32,102,114,111,109,32,116,104,101,32,115,99,104,101,109,97,76,111,99,97,116,105,111,110,0,0,84,104,101,32,115,99,104,101,109,97,32,100,111,99,117,109,101,110,116,32,39,37,115,39,32,99,97,110,110,111,116,32,114,101,100,101,102,105,110,101,32,105,116,115,101,108,102,46,0,0,0,0,0,0,0,0,84,104,101,32,115,99,104,101,109,97,32,100,111,99,117,109,101,110,116,32,39,37,115,39,32,99,97,110,110,111,116,32,105,110,99,108,117,100,101,32,105,116,115,101,108,102,46,0,84,104,101,32,118,97,108,117,101,32,111,102,32,116,104,101,32,97,116,116,114,105,98,117,116,101,32,39,110,97,109,101,115,112,97,99,101,39,32,109,117,115,116,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,116,97,114,103,101,116,32,110,97,109,101,115,112,97,99,101,32,39,37,115,39,32,111,102,32,116,104,101,32,105,109,112,111,114,116,105,110,103,32,115,99,104,101,109,97,0,84,104,101,32,97,116,116,114,105,98,117,116,101,32,39,110,97,109,101,115,112,97,99,101,39,32,109,117,115,116,32,98,101,32,101,120,105,115,116,101,110,116,32,105,102,32,116,104,101,32,105,109,112,111,114,116,105,110,103,32,115,99,104,101,109,97,32,104,97,115,32,110,111,32,116,97,114,103,101,116,32,110,97,109,101,115,112,97,99,101,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,108,111,99,97,116,101,32,97,32,115,99,104,101,109,97,32,97,116,32,108,111,99,97,116,105,111,110,32,39,37,115,39,46,32,83,107,105,112,112,105,110,103,32,116,104,101,32,105,109,112,111,114,116,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,120,109,108,83,99,104,101,109,97,80,86,97,108,65,116,116,114,44,32,116,104,101,32,103,105,118,101,110,32,116,121,112,101,32,39,37,115,39,32,105,115,32,110,111,116,32,97,32,98,117,105,108,116,45,105,110,32,116,121,112,101,46,10,0,97,112,112,105,110,102,111,0,115,111,117,114,99,101,0,0,100,111,99,117,109,101,110,116,97,116,105,111,110,0,0,0,108,97,110,103,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,40,97,112,112,105,110,102,111,32,124,32,100,111,99,117,109,101,110,116,97,116,105,111,110,41,42,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,97,110,110,111,116,97,116,105,111,110,0,0,0,116,97,114,103,101,116,78,97,109,101,115,112,97,99,101,0,101,108,101,109,101,110,116,70,111,114,109,68,101,102,97,117,108,116,0,0,0,0,0,0,97,116,116,114,105,98,117,116,101,70,111,114,109,68,101,102,97,117,108,116,0,0,0,0,102,105,110,97,108,68,101,102,97,117,108,116,0,0,0,0,40,35,97,108,108,32,124,32,76,105,115,116,32,111,102,32,40,101,120,116,101,110,115,105,111,110,32,124,32,114,101,115,116,114,105,99,116,105,111,110,32,124,32,108,105,115,116,32,124,32,117,110,105,111,110,41,41,0,0,0,0,0,0,0,98,108,111,99,107,68,101,102,97,117,108,116,0,0,0,0,84,104,101,32,115,99,104,101,109,97,32,109,117,115,116,32,110,111,116,32,105,109,112,111,114,116,47,105,110,99,108,117,100,101,47,114,101,100,101,102,105,110,101,32,105,116,115,101,108,102,0,0,0,0,0,0,105,110,95,109,101,109,111,114,121,95,98,117,102,102,101,114,0,0,0,0,0,0,0,0,84,104,101,32,115,99,104,101,109,97,32,100,111,99,117,109,101,110,116,32,39,37,115,39,32,99,97,110,110,111,116,32,98,101,32,105,109,112,111,114,116,101,100,44,32,115,105,110,99,101,32,105,116,32,119,97,115,32,97,108,114,101,97,100,121,32,105,110,99,108,117,100,101,100,32,111,114,32,114,101,100,101,102,105,110,101,100,0,84,104,101,32,115,99,104,101,109,97,32,100,111,99,117,109,101,110,116,32,39,37,115,39,32,99,97,110,110,111,116,32,98,101,32,105,110,99,108,117,100,101,100,32,111,114,32,114,101,100,101,102,105,110,101,100,44,32,115,105,110,99,101,32,105,116,32,119,97,115,32,97,108,114,101,97,100,121,32,105,109,112,111,114,116,101,100,0,83,107,105,112,112,105,110,103,32,105,109,112,111,114,116,32,111,102,32,115,99,104,101,109,97,32,108,111,99,97,116,101,100,32,97,116,32,39,37,115,39,32,102,111,114,32,116,104,101,32,110,97,109,101,115,112,97,99,101,32,39,37,115,39,44,32,115,105,110,99,101,32,116,104,105,115,32,110,97,109,101,115,112,97,99,101,32,119,97,115,32,97,108,114,101,97,100,121,32,105,109,112,111,114,116,101,100,32,119,105,116,104,32,116,104,101,32,115,99,104,101,109,97,32,108,111,99,97,116,101,100,32,97,116,32,39,37,115,39,0,0,0,0,0,120,109,108,83,99,104,101,109,97,65,100,100,83,99,104,101,109,97,68,111,99,0,0,0,116,114,121,105,110,103,32,116,111,32,108,111,97,100,32,97,32,115,99,104,101,109,97,32,100,111,99,44,32,98,117,116,32,97,32,100,111,99,32,105,115,32,97,108,114,101,97,100,121,32,97,115,115,105,103,110,101,100,32,116,111,32,116,104,101,32,115,99,104,101,109,97,32,98,117,99,107,101,116,0,120,109,108,83,99,104,101,109,97,71,101,116,68,111,99,44,32,97,108,108,111,99,97,116,105,110,103,32,97,32,112,97,114,115,101,114,32,99,111,110,116,101,120,116,0,0,0,0,70,97,105,108,101,100,32,116,111,32,112,97,114,115,101,32,116,104,101,32,88,77,76,32,114,101,115,111,117,114,99,101,32,39,37,115,39,0,0,0,78,111,32,105,110,102,111,114,109,97,116,105,111,110,32,102,111,114,32,112,97,114,115,105,110,103,32,119,97,115,32,112,114,111,118,105,100,101,100,32,119,105,116,104,32,116,104,101,32,103,105,118,101,110,32,115,99,104,101,109,97,32,112,97,114,115,101,114,32,99,111,110,116,101,120,116,46,10,0,0,84,104,101,32,100,111,99,117,109,101,110,116,32,39,37,115,39,32,104,97,115,32,110,111,32,100,111,99,117,109,101,110,116,32,101,108,101,109,101,110,116,0,0,0,0,0,0,0,115,99,104,101,109,97,0,0,84,104,101,32,88,77,76,32,100,111,99,117,109,101,110,116,32,39,37,115,39,32,105,115,32,110,111,116,32,97,32,115,99,104,101,109,97,32,100,111,99,117,109,101,110,116,0,0,120,109,108,83,99,104,101,109,97,66,117,99,107,101,116,67,114,101,97,116,101,0,0,0,110,111,32,109,97,105,110,32,115,99,104,101,109,97,32,111,110,32,99,111,110,115,116,114,117,99,116,111,114,0,0,0,97,108,108,111,99,97,116,105,110,103,32,115,99,104,101,109,97,32,98,117,99,107,101,116,0,0,0,0,0,0,0,0,102,105,114,115,116,32,98,117,99,107,101,116,32,98,117,116,32,105,116,39,115,32,97,110,32,105,110,99,108,117,100,101,32,111,114,32,114,101,100,101,102,105,110,101,0,0,0,0,109,97,105,110,32,98,117,99,107,101,116,32,98,117,116,32,105,116,39,115,32,110,111,116,32,116,104,101,32,102,105,114,115,116,32,111,110,101,0,0,102,97,105,108,101,100,32,116,111,32,97,100,100,32,116,104,101,32,115,99,104,101,109,97,32,98,117,99,107,101,116,32,116,111,32,116,104,101,32,104,97,115,104,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,115,99,104,101,109,97,32,114,101,108,97,116,105,111,110,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,115,99,104,101,109,97,32,99,111,110,115,116,114,117,99,116,105,111,110,32,99,111,110,116,101,120,116,0,0,97,108,108,111,99,97,116,105,110,103,32,108,105,115,116,32,111,102,32,115,99,104,101,109,97,32,98,117,99,107,101,116,115,0,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,108,105,115,116,32,111,102,32,112,101,110,100,105,110,103,32,103,108,111,98,97,108,32,99,111,109,112,111,110,101,110,116,115,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,115,99,104,101,109,97,0,0,0,0,0,0,0,40,78,85,76,76,41,0,0,97,108,108,111,99,97,116,105,110,103,32,115,99,104,101,109,97,32,112,97,114,115,101,114,32,99,111,110,116,101,120,116,0,0,0,0,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,120,109,108,83,99,104,101,109,97,67,111,109,112,111,110,101,110,116,76,105,115,116,70,114,101,101,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,109,112,111,110,101,110,116,32,116,121,112,101,32,39,37,115,39,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,97,110,121,84,121,112,101,0,0,0,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,109,111,100,101,108,32,103,114,111,117,112,32,99,111,109,112,111,110,101,110,116,0,0,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,119,105,108,100,99,97,114,100,32,99,111,109,112,111,110,101,110,116,0,0,0,99,111,117,108,100,32,110,111,116,32,99,114,101,97,116,101,32,97,110,32,97,116,116,114,105,98,117,116,101,32,119,105,108,100,99,97,114,100,32,111,110,32,97,110,121,84,121,112,101,0,0,0,0,0,0,0,97,110,121,83,105,109,112,108,101,84,121,112,101,0,0,0,0,0,0,0,0,0,0,0,115,116,114,105,110,103,0,0,0,0,0,0,0,0,0,0,100,101,99,105,109,97,108,0,0,0,0,0,0,0,0,0,100,97,116,101,0,0,0,0,0,0,0,0,0,0,0,0,100,97,116,101,84,105,109,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,116,105,109,101,0,0,0,0,0,0,0,0,0,0,0,0,103,89,101,97,114,0,0,0,0,0,0,0,0,0,0,0,103,89,101,97,114,77,111,110,116,104,0,0,0,0,0,0,0,0,0,0,0,0,0,0,103,77,111,110,116,104,0,0,0,0,0,0,0,0,0,0,103,77,111,110,116,104,68,97,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,103,68,97,121,0,0,0,0,0,0,0,0,0,0,0,0,100,117,114,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,108,111,97,116,0,0,0,0,0,0,0,0,0,0,0,100,111,117,98,108,101,0,0,0,0,0,0,0,0,0,0,98,111,111,108,101,97,110,0,0,0,0,0,0,0,0,0,97,110,121,85,82,73,0,0,0,0,0,0,0,0,0,0,104,101,120,66,105,110,97,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,115,101,54,52,66,105,110,97,114,121,0,0,0,0,0,0,0,0,0,0,0,0,78,79,84,65,84,73,79,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,81,78,97,109,101,0,0,0,0,0,0,0,0,0,0,0,105,110,116,101,103,101,114,0,0,0,0,0,0,0,0,0,110,111,110,80,111,115,105,116,105,118,101,73,110,116,101,103,101,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,110,101,103,97,116,105,118,101,73,110,116,101,103,101,114,0,0,0,0,0,0,0,0,0,108,111,110,103,0,0,0,0,0,0,0,0,0,0,0,0,105,110,116,0,0,0,0,0,0,0,0,0,0,0,0,0,115,104,111,114,116,0,0,0,0,0,0,0,0,0,0,0,98,121,116,101,0,0,0,0,0,0,0,0,0,0,0,0,110,111,110,78,101,103,97,116,105,118,101,73,110,116,101,103,101,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,117,110,115,105,103,110,101,100,76,111,110,103,0,0,0,0,0,0,0,0,0,0,0,0,117,110,115,105,103,110,101,100,73,110,116,0,0,0,0,0,0,0,0,0,0,0,0,0,117,110,115,105,103,110,101,100,83,104,111,114,116,0,0,0,0,0,0,0,0,0,0,0,117,110,115,105,103,110,101,100,66,121,116,101,0,0,0,0,0,0,0,0,0,0,0,0,112,111,115,105,116,105,118,101,73,110,116,101,103,101,114,0,0,0,0,0,0,0,0,0,110,111,114,109,97,108,105,122,101,100,83,116,114,105,110,103,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,116,111,107,101,110,0,0,0,0,0,0,0,0,0,0,0,108,97,110,103,117,97,103,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,78,97,109,101,0,0,0,0,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,0,0,0,0,0,0,0,0,78,67,78,97,109,101,0,0,0,0,0,0,0,0,0,0,73,68,0,0,0,0,0,0,0,0,0,0,0,0,0,0,73,68,82,69,70,0,0,0,0,0,0,0,0,0,0,0,69,78,84,73,84,89,0,0,0,0,0,0,0,0,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,73,68,82,69,70,83,0,0,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,123,0,0,0,0,0,0,0,125,0,0,0,0,0,0,0,48,46,48,0,0,0,0,0,37,108,117,37,108,117,37,108,117,0,0,0,0,0,0,0,37,108,117,37,108,117,0,0,37,108,117,0,0,0,0,0,48,0,0,0,0,0,0,0,45,37,108,117,37,108,117,37,108,117,0,0,0,0,0,0,45,37,108,117,37,108,117,0,45,37,108,117,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,80,37,108,117,89,37,108,117,77,37,108,117,68,84,37,108,117,72,37,108,117,77,37,46,49,52,103,83,0,0,0,0,45,80,37,108,117,89,37,108,117,77,37,108,117,68,84,37,108,117,72,37,108,117,77,37,46,49,52,103,83,0,0,0,37,48,52,108,100,0,0,0,45,45,37,48,50,117,0,0,45,45,45,37,48,50,117,0,45,45,37,48,50,117,45,37,48,50,117,0,0,0,0,0,45,37,48,52,108,100,45,37,48,50,117,0,0,0,0,0,37,48,52,108,100,45,37,48,50,117,0,0,0,0,0,0,37,48,50,117,58,37,48,50,117,58,37,48,50,46,49,52,103,90,0,0,0,0,0,0,37,48,50,117,58,37,48,50,117,58,37,48,50,46,49,52,103,0,0,0,0,0,0,0,37,48,52,108,100,58,37,48,50,117,58,37,48,50,117,90,0,0,0,0,0,0,0,0,37,48,52,108,100,58,37,48,50,117,58,37,48,50,117,0,37,48,52,108,100,58,37,48,50,117,58,37,48,50,117,84,37,48,50,117,58,37,48,50,117,58,37,48,50,46,49,52,103,90,0,0,0,0,0,0,37,48,52,108,100,58,37,48,50,117,58,37,48,50,117,84,37,48,50,117,58,37,48,50,117,58,37,48,50,46,49,52,103,0,0,0,0,0,0,0,37,48,49,46,49,52,101,0,63,63,63,0,0,0,0,0,31,0,0,0,29,0,0,0,31,0,0,0,30,0,0,0,31,0,0,0,30,0,0,0,31,0,0,0,31,0,0,0,30,0,0,0,31,0,0,0,30,0,0,0,31,0,0,0,31,0,0,0,28,0,0,0,31,0,0,0,30,0,0,0,31,0,0,0,30,0,0,0,31,0,0,0,31,0,0,0,30,0,0,0,31,0,0,0,30,0,0,0,31,0,0,0,85,110,105,109,112,108,101,109,101,110,116,101,100,32,98,108,111,99,107,32,97,116,32,37,115,58,37,100,10,0,0,0,46,46,47,108,105,98,120,109,108,50,47,120,109,108,115,99,104,101,109,97,115,116,121,112,101,115,46,99,0,0,0,0,0,0,0,0,31,0,0,0,60,0,0,0,91,0,0,0,121,0,0,0,152,0,0,0,182,0,0,0,213,0,0,0,244,0,0,0,18,1,0,0,49,1,0,0,79,1,0,0,0,0,0,0,31,0,0,0,59,0,0,0,90,0,0,0,120,0,0,0,151,0,0,0,181,0,0,0,212,0,0,0,243,0,0,0,17,1,0,0,48,1,0,0,78,1,0,0,0,0,0,0,28,0,0,0,59,0,0,0,89,0,0,0,120,0,0,0,150,0,0,0,181,0,0,0,212,0,0,0,242,0,0,0,17,1,0,0,47,1,0,0,78,1,0,0,0,0,0,0,31,0,0,0,62,0,0,0,92,0,0,0,123,0,0,0,153,0,0,0,184,0,0,0,215,0,0,0,245,0,0,0,20,1,0,0,50,1,0,0,81,1,0,0,37,102,0,0,0,0,0,0,37,108,102,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,104,101,120,98,105,110,32,100,97,116,97,0,0,97,108,108,111,99,97,116,105,110,103,32,98,97,115,101,54,52,32,100,97,116,97,0,0,89,77,68,72,77,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,245,64,0,0,0,0,0,32,172,64,0,0,0,0,0,0,78,64,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,112,97,114,116,105,99,108,101,32,99,111,109,112,111,110,101,110,116,0,0,0,99,111,117,108,100,32,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,98,97,115,105,99,32,116,121,112,101,115,0,0,0,0,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,49,47,88,77,76,83,99,104,101,109,97,0,0,0,0,0,0,0,0,16,206,2,0,128,0,0,0,18,0,0,0,7,0,0,0,144,205,2,0,216,205,2,0,11,0,0,0,3,0,0,0,72,205,2,0,120,205,2,0,23,1,0,0,50,0,0,0,88,199,2,0,184,203,2,0,140,1,0,0,28,0,0,0,72,192,2,0,120,198,2,0,20,0,0,0,0,0,0,0,248,191,2,0,0,0,0,0,211,0,0,0,20,0,0,0,8,188,2,0,88,191,2,0,10,0,0,0,0,0,0,0,224,187,2,0,0,0,0,0,134,1,0,0,31,0,0,0,208,180,2,0,232,186,2,0,113,0,0,0,6,0,0,0,216,178,2,0,160,180,2,0,55,0,0,0,2,0,0,0,232,177,2,0,200,178,2,0,108,0,0,0,5,0,0,0,16,176,2,0,192,177,2,0,42,0,0,0,5,0,0,0,64,175,2,0,232,175,2,0,21,0,0,0,2,0,0,0,216,174,2,0,48,175,2,0,20,0,0,0,2,0,0,0,120,174,2,0,200,174,2,0,84,0,0,0,2,0,0,0,24,173,2,0,104,174,2,0,11,0,0,0,0,0,0,0,232,172,2,0,0,0,0,0,63,0,0,0,0,0,0,0,232,171,2,0,0,0,0,0,72,0,0,0,2,0,0,0,184,170,2,0,216,171,2,0,65,0,0,0,0,0,0,0,176,169,2,0,0,0,0,0,133,0,0,0,20,0,0,0,248,166,2,0,16,169,2,0,13,0,0,0,0,0,0,0,192,166,2,0,0,0,0,0,22,0,0,0,0,0,0,0,104,166,2,0,0,0,0,0,48,0,0,0,10,0,0,0,88,165,2,0,24,166,2,0,103,0,0,0,10,0,0,0,104,163,2,0,8,165,2,0,9,0,0,0,0,0,0,0,64,163,2,0,0,0,0,0,32,0,32,0,160,0,160,0,128,22,128,22,14,24,14,24,0,32,10,32,40,32,41,32,47,32,47,32,95,32,95,32,0,48,0,48,0,0,0,0,166,0,167,0,169,0,169,0,174,0,174,0,176,0,176,0,182,0,182,0,130,4,130,4,14,6,15,6,233,6,233,6,253,6,254,6,250,9,250,9,112,11,112,11,243,11,248,11,250,11,250,11,1,15,3,15,19,15,23,15,26,15,31,15,52,15,52,15,54,15,54,15,56,15,56,15,190,15,197,15,199,15,204,15,207,15,207,15,64,25,64,25,224,25,255,25,0,33,1,33,3,33,6,33,8,33,9,33,20,33,20,33,22,33,24,33,30,33,35,33,37,33,37,33,39,33,39,33,41,33,41,33,46,33,46,33,50,33,50,33,58,33,59,33,74,33,74,33,149,33,153,33,156,33,159,33,161,33,162,33,164,33,165,33,167,33,173,33,175,33,205,33,208,33,209,33,211,33,211,33,213,33,243,33,0,35,7,35,12,35,31,35,34,35,40,35,43,35,123,35,125,35,154,35,183,35,208,35,0,36,38,36,64,36,74,36,156,36,233,36,0,37,182,37,184,37,192,37,194,37,247,37,0,38,23,38,25,38,110,38,112,38,125,38,128,38,145,38,160,38,161,38,1,39,4,39,6,39,9,39,12,39,39,39,41,39,75,39,77,39,77,39,79,39,82,39,86,39,86,39,88,39,94,39,97,39,103,39,148,39,148,39,152,39,175,39,177,39,190,39,0,40,255,40,0,43,13,43,128,46,153,46,155,46,243,46,0,47,213,47,240,47,251,47,4,48,4,48,18,48,19,48,32,48,32,48,54,48,55,48,62,48,63,48,144,49,145,49,150,49,159,49,0,50,30,50,42,50,67,50,80,50,80,50,96,50,125,50,127,50,127,50,138,50,176,50,192,50,254,50,0,51,255,51,192,77,255,77,144,164,198,164,253,253,253,253,228,255,228,255,232,255,232,255,237,255,238,255,252,255,253,255,0,0,0,0,2,1,1,0,2,1,1,0,55,1,1,0,63,1,1,0,0,208,1,0,245,208,1,0,0,209,1,0,38,209,1,0,42,209,1,0,100,209,1,0,106,209,1,0,108,209,1,0,131,209,1,0,132,209,1,0,140,209,1,0,169,209,1,0,174,209,1,0,221,209,1,0,0,211,1,0,86,211,1,0,43,0,43,0,60,0,62,0,124,0,124,0,126,0,126,0,172,0,172,0,177,0,177,0,215,0,215,0,247,0,247,0,246,3,246,3,68,32,68,32,82,32,82,32,122,32,124,32,138,32,140,32,64,33,68,33,75,33,75,33,144,33,148,33,154,33,155,33,160,33,160,33,163,33,163,33,166,33,166,33,174,33,174,33,206,33,207,33,210,33,210,33,212,33,212,33,244,33,255,34,8,35,11,35,32,35,33,35,124,35,124,35,155,35,179,35,183,37,183,37,193,37,193,37,248,37,255,37,111,38,111,38,208,39,229,39,240,39,255,39,0,41,130,41,153,41,215,41,220,41,251,41,254,41,255,42,41,251,41,251,98,254,98,254,100,254,102,254,11,255,11,255,28,255,30,255,92,255,92,255,94,255,94,255,226,255,226,255,233,255,236,255,193,214,1,0,193,214,1,0,219,214,1,0,219,214,1,0,251,214,1,0,251,214,1,0,21,215,1,0,21,215,1,0,53,215,1,0,53,215,1,0,79,215,1,0,79,215,1,0,111,215,1,0,111,215,1,0,137,215,1,0,137,215,1,0,169,215,1,0,169,215,1,0,195,215,1,0,195,215,1,0,94,0,94,0,96,0,96,0,168,0,168,0,175,0,175,0,180,0,180,0,184,0,184,0,194,2,197,2,210,2,223,2,229,2,237,2,239,2,255,2,116,3,117,3,132,3,133,3,189,31,189,31,191,31,193,31,205,31,207,31,221,31,223,31,237,31,239,31,253,31,254,31,155,48,156,48,62,255,62,255,64,255,64,255,227,255,227,255,36,0,36,0,162,0,165,0,242,9,243,9,241,10,241,10,249,11,249,11,63,14,63,14,219,23,219,23,160,32,177,32,252,253,252,253,105,254,105,254,4,255,4,255,224,255,225,255,229,255,230,255,0,0,0,0,36,0,36,0,43,0,43,0,60,0,62,0,94,0,94,0,96,0,96,0,124,0,124,0,126,0,126,0,162,0,169,0,172,0,172,0,174,0,177,0,180,0,180,0,182,0,182,0,184,0,184,0,215,0,215,0,247,0,247,0,194,2,197,2,210,2,223,2,229,2,237,2,239,2,255,2,116,3,117,3,132,3,133,3,246,3,246,3,130,4,130,4,14,6,15,6,233,6,233,6,253,6,254,6,242,9,243,9,250,9,250,9,241,10,241,10,112,11,112,11,243,11,250,11,63,14,63,14,1,15,3,15,19,15,23,15,26,15,31,15,52,15,52,15,54,15,54,15,56,15,56,15,190,15,197,15,199,15,204,15,207,15,207,15,219,23,219,23,64,25,64,25,224,25,255,25,189,31,189,31,191,31,193,31,205,31,207,31,221,31,223,31,237,31,239,31,253,31,254,31,68,32,68,32,82,32,82,32,122,32,124,32,138,32,140,32,160,32,177,32,0,33,1,33,3,33,6,33,8,33,9,33,20,33,20,33,22,33,24,33,30,33,35,33,37,33,37,33,39,33,39,33,41,33,41,33,46,33,46,33,50,33,50,33,58,33,59,33,64,33,68,33,74,33,75,33,144,33,40,35,43,35,179,35,183,35,208,35,0,36,38,36,64,36,74,36,156,36,233,36,0,37,23,38,25,38,125,38,128,38,145,38,160,38,161,38,1,39,4,39,6,39,9,39,12,39,39,39,41,39,75,39,77,39,77,39,79,39,82,39,86,39,86,39,88,39,94,39,97,39,103,39,148,39,148,39,152,39,175,39,177,39,190,39,208,39,229,39,240,39,130,41,153,41,215,41,220,41,251,41,254,41,13,43,128,46,153,46,155,46,243,46,0,47,213,47,240,47,251,47,4,48,4,48,18,48,19,48,32,48,32,48,54,48,55,48,62,48,63,48,155,48,156,48,144,49,145,49,150,49,159,49,0,50,30,50,42,50,67,50,80,50,80,50,96,50,125,50,127,50,127,50,138,50,176,50,192,50,254,50,0,51,255,51,192,77,255,77,144,164,198,164,41,251,41,251,252,253,253,253,98,254,98,254,100,254,102,254,105,254,105,254,4,255,4,255,11,255,11,255,28,255,30,255,62,255,62,255,64,255,64,255,92,255,92,255,94,255,94,255,224,255,230,255,232,255,238,255,252,255,253,255,0,0,0,0,2,1,1,0,2,1,1,0,55,1,1,0,63,1,1,0,0,208,1,0,245,208,1,0,0,209,1,0,38,209,1,0,42,209,1,0,100,209,1,0,106,209,1,0,108,209,1,0,131,209,1,0,132,209,1,0,140,209,1,0,169,209,1,0,174,209,1,0,221,209,1,0,0,211,1,0,86,211,1,0,193,214,1,0,193,214,1,0,219,214,1,0,219,214,1,0,251,214,1,0,251,214,1,0,21,215,1,0,21,215,1,0,53,215,1,0,53,215,1,0,79,215,1,0,79,215,1,0,111,215,1,0,111,215,1,0,137,215,1,0,137,215,1,0,169,215,1,0,169,215,1,0,195,215,1,0,195,215,1,0,40,0,40,0,91,0,91,0,123,0,123,0,58,15,58,15,60,15,60,15,155,22,155,22,26,32,26,32,30,32,30,32,69,32,69,32,125,32,125,32,141,32,141,32,41,35,41,35,180,35,180,35,104,39,104,39,106,39,106,39,108,39,108,39,110,39,110,39,112,39,112,39,114,39,114,39,116,39,116,39,230,39,230,39,232,39,232,39,234,39,234,39,131,41,131,41,133,41,133,41,135,41,135,41,137,41,137,41,139,41,139,41,141,41,141,41,143,41,143,41,145,41,145,41,147,41,147,41,149,41,149,41,151,41,151,41,216,41,216,41,218,41,218,41,252,41,252,41,8,48,8,48,10,48,10,48,12,48,12,48,14,48,14,48,16,48,16,48,20,48,20,48,22,48,22,48,24,48,24,48,26,48,26,48,29,48,29,48,62,253,62,253,53,254,53,254,55,254,55,254,57,254,57,254,59,254,59,254,61,254,61,254,63,254,63,254,65,254,65,254,67,254,67,254,71,254,71,254,89,254,89,254,91,254,91,254,93,254,93,254,8,255,8,255,59,255,59,255,91,255,91,255,95,255,95,255,98,255,98,255,0,0,0,0,33,0,35,0,37,0,39,0,42,0,42,0,44,0,44,0,46,0,47,0,58,0,59,0,63,0,64,0,92,0,92,0,161,0,161,0,183,0,183,0,191,0,191,0,126,3,126,3,135,3,135,3,90,5,95,5,137,5,137,5,190,5,190,5,192,5,192,5,195,5,195,5,243,5,244,5,12,6,13,6,27,6,27,6,31,6,31,6,106,6,109,6,212,6,212,6,0,7,13,7,100,9,101,9,112,9,112,9,244,13,244,13,79,14,79,14,90,14,91,14,4,15,18,15,133,15,133,15,74,16,79,16,251,16,251,16,97,19,104,19,109,22,110,22,235,22,237,22,53,23,54,23,212,23,214,23,216,23,218,23,0,24,5,24,7,24,10,24,68,25,69,25,22,32,23,32,32,32,39,32,48,32,56,32,59,32,62,32,65,32,67,32,71,32,81,32,83,32,83,32,87,32,87,32,182,35,182,35,1,48,3,48,61,48,61,48,48,254,48,254,69,254,70,254,73,254,76,254,80,254,82,254,84,254,87,254,95,254,97,254,104,254,104,254,106,254,107,254,1,255,3,255,5,255,7,255,10,255,10,255,12,255,12,255,14,255,15,255,26,255,27,255,31,255,32,255,60,255,60,255,97,255,97,255,100,255,100,255,0,1,1,0,1,1,1,0,159,3,1,0,159,3,1,0,41,0,41,0,93,0,93,0,125,0,125,0,59,15,59,15,61,15,61,15,156,22,156,22,70,32,70,32,126,32,126,32,142,32,142,32,42,35,42,35,181,35,181,35,105,39,105,39,107,39,107,39,109,39,109,39,111,39,111,39,113,39,113,39,115,39,115,39,117,39,117,39,231,39,231,39,233,39,233,39,235,39,235,39,132,41,132,41,134,41,134,41,136,41,136,41,138,41,138,41,140,41,140,41,142,41,142,41,144,41,144,41,146,41,146,41,148,41,148,41,150,41,150,41,152,41,152,41,217,41,217,41,219,41,219,41,253,41,253,41,9,48,9,48,11,48,11,48,13,48,13,48,15,48,15,48,17,48,17,48,21,48,21,48,23,48,23,48,25,48,25,48,27,48,27,48,30,48,31,48,63,253,63,253,54,254,54,254,56,254,56,254,58,254,58,254,60,254,60,254,62,254,62,254,64,254,64,254,66,254,66,254,68,254,68,254,72,254,72,254,90,254,90,254,92,254,92,254,94,254,94,254,9,255,9,255,61,255,61,255,93,255,93,255,96,255,96,255,99,255,99,255,0,0,0,0,45,0,45,0,138,5,138,5,6,24,6,24,16,32,21,32,28,48,28,48,48,48,48,48,160,48,160,48,49,254,50,254,88,254,88,254,99,254,99,254,13,255,13,255,0,0,0,0,33,0,35,0,37,0,42,0,44,0,47,0,58,0,59,0,63,0,64,0,91,0,93,0,95,0,95,0,123,0,123,0,125,0,125,0,161,0,161,0,171,0,171,0,183,0,183,0,187,0,187,0,191,0,191,0,126,3,126,3,135,3,135,3,90,5,95,5,137,5,138,5,190,5,190,5,192,5,192,5,195,5,195,5,243,5,244,5,12,6,13,6,27,6,27,6,31,6,31,6,106,6,109,6,212,6,212,6,0,7,13,7,100,9,101,9,112,9,112,9,244,13,244,13,79,14,79,14,90,14,91,14,4,15,18,15,58,15,61,15,133,15,133,15,74,16,79,16,251,16,251,16,97,19,104,19,109,22,110,22,155,22,156,22,235,22,237,22,53,23,54,23,212,23,214,23,216,23,218,23,0,24,10,24,68,25,69,25,16,32,39,32,48,32,67,32,69,32,81,32,83,32,84,32,87,32,87,32,125,32,126,32,141,32,142,32,41,35,42,35,180,35,182,35,104,39,117,39,230,39,235,39,131,41,152,41,216,41,219,41,252,41,253,41,1,48,3,48,8,48,17,48,20,48,31,48,48,48,48,48,61,48,61,48,160,48,160,48,251,48,251,48,62,253,63,253,48,254,82,254,84,254,97,254,99,254,99,254,104,254,104,254,106,254,107,254,1,255,3,255,5,255,10,255,12,255,15,255,26,255,27,255,31,255,32,255,59,255,61,255,63,255,63,255,91,255,91,255,93,255,93,255,95,255,101,255,0,1,1,0,1,1,1,0,159,3,1,0,159,3,1,0,178,0,179,0,185,0,185,0,188,0,190,0,244,9,249,9,240,11,242,11,42,15,51,15,114,19,124,19,240,23,249,23,112,32,112,32,116,32,121,32,128,32,137,32,83,33,95,33,96,36,155,36,234,36,255,36,118,39,147,39,146,49,149,49,32,50,41,50,81,50,95,50,128,50,137,50,177,50,191,50,7,1,1,0,51,1,1,0,32,3,1,0,35,3,1,0,48,0,57,0,96,6,105,6,240,6,249,6,102,9,111,9,230,9,239,9,102,10,111,10,230,10,239,10,102,11,111,11,231,11,239,11,102,12,111,12,230,12,239,12,102,13,111,13,80,14,89,14,208,14,217,14,32,15,41,15,64,16,73,16,105,19,113,19,224,23,233,23,16,24,25,24,70,25,79,25,16,255,25,255,0,0,0,0,160,4,1,0,169,4,1,0,206,215,1,0,255,215,1,0,48,0,57,0,178,0,179,0,185,0,185,0,188,0,190,0,96,6,105,6,240,6,249,6,102,9,111,9,230,9,239,9,244,9,249,9,102,10,111,10,230,10,239,10,102,11,111,11,231,11,242,11,102,12,111,12,230,12,239,12,102,13,111,13,80,14,89,14,208,14,217,14,32,15,51,15,64,16,73,16,105,19,124,19,238,22,240,22,224,23,233,23,240,23,249,23,16,24,25,24,70,25,79,25,112,32,112,32,116,32,121,32,128,32,137,32,83,33,131,33,96,36,155,36,234,36,255,36,118,39,147,39,7,48,7,48,33,48,41,48,56,48,58,48,146,49,149,49,32,50,41,50,81,50,95,50,128,50,137,50,177,50,191,50,16,255,25,255,7,1,1,0,51,1,1,0,32,3,1,0,35,3,1,0,74,3,1,0,74,3,1,0,160,4,1,0,169,4,1,0,206,215,1,0,255,215,1,0,0,3,87,3,93,3,111,3,131,4,134,4,145,5,161,5,163,5,185,5,187,5,189,5,191,5,191,5,193,5,194,5,196,5,196,5,16,6,21,6,75,6,88,6,112,6,112,6,214,6,220,6,223,6,228,6,231,6,232,6,234,6,237,6,17,7,17,7,48,7,74,7,166,7,176,7,1,9,2,9,60,9,60,9,65,9,72,9,77,9,77,9,81,9,84,9,98,9,99,9,129,9,129,9,188,9,188,9,193,9,196,9,205,9,205,9,226,9,227,9,1,10,2,10,60,10,60,10,65,10,66,10,71,10,72,10,75,10,77,10,112,10,113,10,129,10,130,10,188,10,188,10,193,10,197,10,199,10,200,10,205,10,205,10,226,10,227,10,1,11,1,11,60,11,60,11,63,11,63,11,65,11,67,11,77,11,77,11,86,11,86,11,130,11,130,11,192,11,192,11,205,11,205,11,62,12,64,12,70,12,72,12,74,12,77,12,85,12,86,12,188,12,188,12,191,12,191,12,198,12,198,12,204,12,205,12,65,13,67,13,77,13,77,13,202,13,202,13,210,13,212,13,214,13,214,13,49,14,49,14,52,14,58,14,71,14,78,14,177,14,177,14,180,14,185,14,187,14,188,14,200,14,205,14,24,15,25,15,53,15,53,15,55,15,55,15,57,15,57,15,113,15,126,15,128,15,132,15,134,15,135,15,144,15,151,15,153,15,188,15,198,15,198,15,45,16,48,16,50,16,50,16,54,16,55,16,57,16,57,16,88,16,89,16,18,23,20,23,50,23,52,23,82,23,83,23,114,23,115,23,183,23,189,23,198,23,198,23,201,23,211,23,221,23,221,23,11,24,13,24,169,24,169,24,32,25,34,25,39,25,40,25,50,25,50,25,57,25,59,25,208,32,220,32,225,32,225,32,229,32,234,32,42,48,47,48,153,48,154,48,30,251,30,251,0,254,15,254,32,254,35,254,103,209,1,0,105,209,1,0,123,209,1,0,130,209,1,0,133,209,1,0,139,209,1,0,170,209,1,0,173,209,1,0,0,1,14,0,239,1,14,0,3,9,3,9,62,9,64,9,73,9,76,9,130,9,131,9,190,9,192,9,199,9,200,9,203,9,204,9,215,9,215,9,3,10,3,10,62,10,64,10,131,10,131,10,190,10,192,10,201,10,201,10,203,10,204,10,2,11,3,11,62,11,62,11,64,11,64,11,71,11,72,11,75,11,76,11,87,11,87,11,190,11,191,11,193,11,194,11,198,11,200,11,202,11,204,11,215,11,215,11,1,12,3,12,65,12,68,12,130,12,131,12,190,12,190,12,192,12,196,12,199,12,200,12,202,12,203,12,213,12,214,12,2,13,3,13,62,13,64,13,70,13,72,13,74,13,76,13,87,13,87,13,130,13,131,13,207,13,209,13,216,13,223,13,242,13,243,13,62,15,63,15,127,15,127,15,44,16,44,16,49,16,49,16,56,16,56,16,86,16,87,16,182,23,182,23,190,23,197,23,199,23,200,23,35,25,38,25,41,25,43,25,48,25,49,25,51,25,56,25,0,0,0,0,101,209,1,0,102,209,1,0,109,209,1,0,114,209,1,0,0,3,87,3,93,3,111,3,131,4,134,4,136,4,137,4,145,5,161,5,163,5,185,5,187,5,189,5,191,5,191,5,193,5,194,5,196,5,196,5,16,6,21,6,75,6,88,6,112,6,112,6,214,6,220,6,222,6,228,6,231,6,232,6,234,6,237,6,17,7,17,7,48,7,74,7,166,7,176,7,1,9,3,9,60,9,60,9,62,9,77,9,81,9,84,9,98,9,99,9,129,9,131,9,188,9,188,9,190,9,196,9,199,9,200,9,203,9,205,9,215,9,215,9,226,9,227,9,1,10,3,10,60,10,60,10,62,10,66,10,71,10,72,10,75,10,77,10,112,10,113,10,129,10,131,10,188,10,188,10],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+166768),
allocate([190,10,197,10,199,10,201,10,203,10,205,10,226,10,227,10,1,11,3,11,60,11,60,11,62,11,67,11,71,11,72,11,75,11,77,11,86,11,87,11,130,11,130,11,190,11,194,11,198,11,200,11,202,11,205,11,215,11,215,11,1,12,3,12,62,12,68,12,70,12,72,12,74,12,77,12,85,12,86,12,130,12,131,12,188,12,188,12,190,12,196,12,198,12,200,12,202,12,205,12,213,12,214,12,2,13,3,13,62,13,67,13,70,13,72,13,74,13,77,13,87,13,87,13,130,13,131,13,202,13,202,13,207,13,212,13,214,13,214,13,216,13,223,13,242,13,243,13,49,14,49,14,52,14,58,14,71,14,78,14,177,14,177,14,180,14,185,14,187,14,188,14,200,14,205,14,24,15,25,15,53,15,53,15,55,15,55,15,57,15,57,15,62,15,63,15,113,15,132,15,134,15,135,15,144,15,151,15,153,15,188,15,198,15,198,15,44,16,50,16,54,16,57,16,86,16,89,16,18,23,20,23,50,23,52,23,82,23,83,23,114,23,115,23,182,23,211,23,221,23,221,23,11,24,13,24,169,24,169,24,32,25,43,25,48,25,59,25,208,32,234,32,42,48,47,48,153,48,154,48,30,251,30,251,0,254,15,254,32,254,35,254,0,0,0,0,101,209,1,0,105,209,1,0,109,209,1,0,114,209,1,0,123,209,1,0,130,209,1,0,133,209,1,0,139,209,1,0,170,209,1,0,173,209,1,0,0,1,14,0,239,1,14,0,65,0,90,0,192,0,214,0,216,0,222,0,0,1,0,1,2,1,2,1,4,1,4,1,6,1,6,1,8,1,8,1,10,1,10,1,12,1,12,1,14,1,14,1,16,1,16,1,18,1,18,1,20,1,20,1,22,1,22,1,24,1,24,1,26,1,26,1,28,1,28,1,30,1,30,1,32,1,32,1,34,1,34,1,36,1,36,1,38,1,38,1,40,1,40,1,42,1,42,1,44,1,44,1,46,1,46,1,48,1,48,1,50,1,50,1,52,1,52,1,54,1,54,1,57,1,57,1,59,1,59,1,61,1,61,1,63,1,63,1,65,1,65,1,67,1,67,1,69,1,69,1,71,1,71,1,74,1,74,1,76,1,76,1,78,1,78,1,80,1,80,1,82,1,82,1,84,1,84,1,86,1,86,1,88,1,88,1,90,1,90,1,92,1,92,1,94,1,94,1,96,1,96,1,98,1,98,1,100,1,100,1,102,1,102,1,104,1,104,1,106,1,106,1,108,1,108,1,110,1,110,1,112,1,112,1,114,1,114,1,116,1,116,1,118,1,118,1,120,1,121,1,123,1,123,1,125,1,125,1,129,1,130,1,132,1,132,1,134,1,135,1,137,1,139,1,142,1,145,1,147,1,148,1,150,1,152,1,156,1,157,1,159,1,160,1,162,1,162,1,164,1,164,1,166,1,167,1,169,1,169,1,172,1,172,1,174,1,175,1,177,1,179,1,181,1,181,1,183,1,184,1,188,1,188,1,196,1,196,1,199,1,199,1,202,1,202,1,205,1,205,1,207,1,207,1,209,1,209,1,211,1,211,1,213,1,213,1,215,1,215,1,217,1,217,1,219,1,219,1,222,1,222,1,224,1,224,1,226,1,226,1,228,1,228,1,230,1,230,1,232,1,232,1,234,1,234,1,236,1,236,1,238,1,238,1,241,1,241,1,244,1,244,1,246,1,248,1,250,1,250,1,252,1,252,1,254,1,254,1,0,2,0,2,2,2,2,2,4,2,4,2,6,2,6,2,8,2,8,2,10,2,10,2,12,2,12,2,14,2,14,2,16,2,16,2,18,2,18,2,20,2,20,2,22,2,22,2,24,2,24,2,26,2,26,2,28,2,28,2,30,2,30,2,32,2,32,2,34,2,34,2,36,2,36,2,38,2,38,2,40,2,40,2,42,2,42,2,44,2,44,2,46,2,46,2,48,2,48,2,50,2,50,2,134,3,134,3,136,3,138,3,140,3,140,3,142,3,143,3,145,3,161,3,163,3,171,3,210,3,212,3,216,3,216,3,218,3,218,3,220,3,220,3,222,3,222,3,224,3,224,3,226,3,226,3,228,3,228,3,230,3,230,3,232,3,232,3,234,3,234,3,236,3,236,3,238,3,238,3,244,3,244,3,247,3,247,3,249,3,250,3,0,4,47,4,96,4,96,4,98,4,98,4,100,4,100,4,102,4,102,4,104,4,104,4,106,4,106,4,108,4,108,4,110,4,110,4,112,4,112,4,114,4,114,4,116,4,116,4,118,4,118,4,120,4,120,4,122,4,122,4,124,4,124,4,126,4,126,4,128,4,128,4,138,4,138,4,140,4,140,4,142,4,142,4,144,4,144,4,146,4,146,4,148,4,148,4,150,4,150,4,152,4,152,4,154,4,154,4,156,4,156,4,158,4,158,4,160,4,160,4,162,4,162,4,164,4,164,4,166,4,166,4,168,4,168,4,170,4,170,4,172,4,172,4,174,4,174,4,176,4,176,4,178,4,178,4,180,4,180,4,182,4,182,4,184,4,184,4,186,4,186,4,188,4,188,4,190,4,190,4,192,4,193,4,195,4,195,4,197,4,197,4,199,4,199,4,201,4,201,4,203,4,203,4,205,4,205,4,208,4,208,4,210,4,210,4,212,4,212,4,214,4,214,4,216,4,216,4,218,4,218,4,220,4,220,4,222,4,222,4,224,4,224,4,226,4,226,4,228,4,228,4,230,4,230,4,232,4,232,4,234,4,234,4,236,4,236,4,238,4,238,4,240,4,240,4,242,4,242,4,244,4,244,4,248,4,248,4,0,5,0,5,2,5,2,5,4,5,4,5,6,5,6,5,8,5,8,5,10,5,10,5,12,5,12,5,14,5,14,5,49,5,86,5,160,16,197,16,0,30,0,30,2,30,2,30,4,30,4,30,6,30,6,30,8,30,8,30,10,30,10,30,12,30,12,30,14,30,14,30,16,30,16,30,18,30,18,30,20,30,20,30,22,30,22,30,24,30,24,30,26,30,26,30,28,30,28,30,30,30,30,30,32,30,32,30,34,30,34,30,36,30,36,30,38,30,38,30,40,30,40,30,42,30,42,30,44,30,44,30,46,30,46,30,48,30,48,30,50,30,50,30,52,30,52,30,54,30,54,30,56,30,56,30,58,30,58,30,60,30,60,30,62,30,62,30,64,30,64,30,66,30,66,30,68,30,68,30,70,30,70,30,72,30,72,30,74,30,74,30,76,30,76,30,78,30,78,30,80,30,80,30,82,30,82,30,84,30,84,30,86,30,86,30,88,30,88,30,90,30,90,30,92,30,92,30,94,30,94,30,96,30,96,30,98,30,98,30,100,30,100,30,102,30,102,30,104,30,104,30,106,30,106,30,108,30,108,30,110,30,110,30,112,30,112,30,114,30,114,30,116,30,116,30,118,30,118,30,120,30,120,30,122,30,122,30,124,30,124,30,126,30,126,30,128,30,128,30,130,30,130,30,132,30,132,30,134,30,134,30,136,30,136,30,138,30,138,30,140,30,140,30,142,30,142,30,144,30,144,30,146,30,146,30,148,30,148,30,160,30,160,30,162,30,162,30,164,30,164,30,166,30,166,30,168,30,168,30,170,30,170,30,172,30,172,30,174,30,174,30,176,30,176,30,178,30,178,30,180,30,180,30,182,30,182,30,184,30,184,30,186,30,186,30,188,30,188,30,190,30,190,30,192,30,192,30,194,30,194,30,196,30,196,30,198,30,198,30,200,30,200,30,202,30,202,30,204,30,204,30,206,30,206,30,208,30,208,30,210,30,210,30,212,30,212,30,214,30,214,30,216,30,216,30,218,30,218,30,220,30,220,30,222,30,222,30,224,30,224,30,226,30,226,30,228,30,228,30,230,30,230,30,232,30,232,30,234,30,234,30,236,30,236,30,238,30,238,30,240,30,240,30,242,30,242,30,244,30,244,30,246,30,246,30,248,30,248,30,8,31,15,31,24,31,29,31,40,31,47,31,56,31,63,31,72,31,77,31,89,31,89,31,91,31,91,31,93,31,93,31,95,31,95,31,104,31,111,31,184,31,187,31,200,31,203,31,216,31,219,31,232,31,236,31,248,31,251,31,2,33,2,33,7,33,7,33,11,33,13,33,16,33,18,33,21,33,21,33,25,33,29,33,36,33,36,33,38,33,38,33,40,33,40,33,42,33,45,33,48,33,49,33,51,33,51,33,62,33,63,33,69,33,69,33,33,255,58,255,0,4,1,0,39,4,1,0,0,212,1,0,25,212,1,0,52,212,1,0,77,212,1,0,104,212,1,0,129,212,1,0,156,212,1,0,156,212,1,0,158,212,1,0,159,212,1,0,162,212,1,0,162,212,1,0,165,212,1,0,166,212,1,0,169,212,1,0,172,212,1,0,174,212,1,0,181,212,1,0,208,212,1,0,233,212,1,0,4,213,1,0,5,213,1,0,7,213,1,0,10,213,1,0,13,213,1,0,20,213,1,0,22,213,1,0,28,213,1,0,56,213,1,0,57,213,1,0,59,213,1,0,62,213,1,0,64,213,1,0,68,213,1,0,70,213,1,0,70,213,1,0,74,213,1,0,80,213,1,0,108,213,1,0,133,213,1,0,160,213,1,0,185,213,1,0,212,213,1,0,237,213,1,0,8,214,1,0,33,214,1,0,60,214,1,0,85,214,1,0,112,214,1,0,137,214,1,0,168,214,1,0,192,214,1,0,226,214,1,0,250,214,1,0,28,215,1,0,52,215,1,0,86,215,1,0,110,215,1,0,144,215,1,0,168,215,1,0,197,1,197,1,200,1,200,1,203,1,203,1,242,1,242,1,136,31,143,31,152,31,159,31,168,31,175,31,188,31,188,31,204,31,204,31,252,31,252,31,187,1,187,1,192,1,195,1,208,5,234,5,240,5,242,5,33,6,58,6,65,6,74,6,110,6,111,6,113,6,211,6,213,6,213,6,238,6,239,6,250,6,252,6,255,6,255,6,16,7,16,7,18,7,47,7,77,7,79,7,128,7,165,7,177,7,177,7,4,9,57,9,61,9,61,9,80,9,80,9,88,9,97,9,133,9,140,9,143,9,144,9,147,9,168,9,170,9,176,9,178,9,178,9,182,9,185,9,189,9,189,9,220,9,221,9,223,9,225,9,240,9,241,9,5,10,10,10,15,10,16,10,19,10,40,10,42,10,48,10,50,10,51,10,53,10,54,10,56,10,57,10,89,10,92,10,94,10,94,10,114,10,116,10,133,10,141,10,143,10,145,10,147,10,168,10,170,10,176,10,178,10,179,10,181,10,185,10,189,10,189,10,208,10,208,10,224,10,225,10,5,11,12,11,15,11,16,11,19,11,40,11,42,11,48,11,50,11,51,11,53,11,57,11,61,11,61,11,92,11,93,11,95,11,97,11,113,11,113,11,131,11,131,11,133,11,138,11,142,11,144,11,146,11,149,11,153,11,154,11,156,11,156,11,158,11,159,11,163,11,164,11,168,11,170,11,174,11,181,11,183,11,185,11,5,12,12,12,14,12,16,12,18,12,40,12,42,12,51,12,53,12,57,12,96,12,97,12,133,12,140,12,142,12,144,12,146,12,168,12,170,12,179,12,181,12,185,12,189,12,189,12,222,12,222,12,224,12,225,12,5,13,12,13,14,13,16,13,18,13,40,13,42,13,57,13,96,13,97,13,133,13,150,13,154,13,177,13,179,13,187,13,189,13,189,13,192,13,198,13,1,14,48,14,50,14,51,14,64,14,69,14,129,14,130,14,132,14,132,14,135,14,136,14,138,14,138,14,141,14,141,14,148,14,151,14,153,14,159,14,161,14,163,14,165,14,165,14,167,14,167,14,170,14,171,14,173,14,176,14,178,14,179,14,189,14,189,14,192,14,196,14,220,14,221,14,0,15,0,15,64,15,71,15,73,15,106,15,136,15,139,15,0,16,33,16,35,16,39,16,41,16,42,16,80,16,85,16,208,16,248,16,0,17,89,17,95,17,162,17,168,17,249,17,0,18,6,18,8,18,70,18,72,18,72,18,74,18,77,18,80,18,86,18,88,18,88,18,90,18,93,18,96,18,134,18,136,18,136,18,138,18,141,18,144,18,174,18,176,18,176,18,178,18,181,18,184,18,190,18,192,18,192,18,194,18,197,18,200,18,206,18,208,18,214,18,216,18,238,18,240,18,14,19,16,19,16,19,18,19,21,19,24,19,30,19,32,19,70,19,72,19,90,19,160,19,244,19,1,20,108,22,111,22,118,22,129,22,154,22,160,22,234,22,0,23,12,23,14,23,17,23,32,23,49,23,64,23,81,23,96,23,108,23,110,23,112,23,128,23,179,23,220,23,220,23,32,24,66,24,68,24,119,24,128,24,168,24,0,25,28,25,80,25,109,25,112,25,116,25,53,33,56,33,6,48,6,48,60,48,60,48,65,48,150,48,159,48,159,48,161,48,250,48,255,48,255,48,5,49,44,49,49,49,142,49,160,49,183,49,240,49,255,49,0,52,0,52,181,77,181,77,0,78,0,78,165,159,165,159,0,160,140,164,0,172,0,172,163,215,163,215,0,249,45,250,48,250,106,250,29,251,29,251,31,251,40,251,42,251,54,251,56,251,60,251,62,251,62,251,64,251,65,251,67,251,68,251,70,251,177,251,211,251,61,253,80,253,143,253,146,253,199,253,240,253,251,253,112,254,116,254,118,254,252,254,102,255,111,255,113,255,157,255,160,255,190,255,194,255,199,255,202,255,207,255,210,255,215,255,218,255,220,255,0,0,0,0,0,0,1,0,11,0,1,0,13,0,1,0,38,0,1,0,40,0,1,0,58,0,1,0,60,0,1,0,61,0,1,0,63,0,1,0,77,0,1,0,80,0,1,0,93,0,1,0,128,0,1,0,250,0,1,0,0,3,1,0,30,3,1,0,48,3,1,0,73,3,1,0,128,3,1,0,157,3,1,0,80,4,1,0,157,4,1,0,0,8,1,0,5,8,1,0,8,8,1,0,8,8,1,0,10,8,1,0,53,8,1,0,55,8,1,0,56,8,1,0,60,8,1,0,60,8,1,0,63,8,1,0,63,8,1,0,0,0,2,0,0,0,2,0,214,166,2,0,214,166,2,0,0,248,2,0,29,250,2,0,176,2,193,2,198,2,209,2,224,2,228,2,238,2,238,2,122,3,122,3,89,5,89,5,64,6,64,6,229,6,230,6,70,14,70,14,198,14,198,14,215,23,215,23,67,24,67,24,44,29,97,29,5,48,5,48,49,48,53,48,59,48,59,48,157,48,158,48,252,48,254,48,112,255,112,255,158,255,159,255,97,0,122,0,170,0,170,0,181,0,181,0,186,0,186,0,223,0,246,0,248,0,255,0,1,1,1,1,3,1,3,1,5,1,5,1,7,1,7,1,9,1,9,1,11,1,11,1,13,1,13,1,15,1,15,1,17,1,17,1,19,1,19,1,21,1,21,1,23,1,23,1,25,1,25,1,27,1,27,1,29,1,29,1,31,1,31,1,33,1,33,1,35,1,35,1,37,1,37,1,39,1,39,1,41,1,41,1,43,1,43,1,45,1,45,1,47,1,47,1,49,1,49,1,51,1,51,1,53,1,53,1,55,1,56,1,58,1,58,1,60,1,60,1,62,1,62,1,64,1,64,1,66,1,66,1,68,1,68,1,70,1,70,1,72,1,73,1,75,1,75,1,77,1,77,1,79,1,79,1,81,1,81,1,83,1,83,1,85,1,85,1,87,1,87,1,89,1,89,1,91,1,91,1,93,1,93,1,95,1,95,1,97,1,97,1,99,1,99,1,101,1,101,1,103,1,103,1,105,1,105,1,107,1,107,1,109,1,109,1,111,1,111,1,113,1,113,1,115,1,115,1,117,1,117,1,119,1,119,1,122,1,122,1,124,1,124,1,126,1,128,1,131,1,131,1,133,1,133,1,136,1,136,1,140,1,141,1,146,1,146,1,149,1,149,1,153,1,155,1,158,1,158,1,161,1,161,1,163,1,163,1,165,1,165,1,168,1,168,1,170,1,171,1,173,1,173,1,176,1,176,1,180,1,180,1,182,1,182,1,185,1,186,1,189,1,191,1,198,1,198,1,201,1,201,1,204,1,204,1,206,1,206,1,208,1,208,1,210,1,210,1,212,1,212,1,214,1,214,1,216,1,216,1,218,1,218,1,220,1,221,1,223,1,223,1,225,1,225,1,227,1,227,1,229,1,229,1,231,1,231,1,233,1,233,1,235,1,235,1,237,1,237,1,239,1,240,1,243,1,243,1,245,1,245,1,249,1,249,1,251,1,251,1,253,1,253,1,255,1,255,1,1,2,1,2,3,2,3,2,5,2,5,2,7,2,7,2,9,2,9,2,11,2,11,2,13,2,13,2,15,2,15,2,17,2,17,2,19,2,19,2,21,2,21,2,23,2,23,2,25,2,25,2,27,2,27,2,29,2,29,2,31,2,31,2,33,2,33,2,35,2,35,2,37,2,37,2,39,2,39,2,41,2,41,2,43,2,43,2,45,2,45,2,47,2,47,2,49,2,49,2,51,2,54,2,80,2,175,2,144,3,144,3,172,3,206,3,208,3,209,3,213,3,215,3,217,3,217,3,219,3,219,3,221,3,221,3,223,3,223,3,225,3,225,3,227,3,227,3,229,3,229,3,231,3,231,3,233,3,233,3,235,3,235,3,237,3,237,3,239,3,243,3,245,3,245,3,248,3,248,3,251,3,251,3,48,4,95,4,97,4,97,4,99,4,99,4,101,4,101,4,103,4,103,4,105,4,105,4,107,4,107,4,109,4,109,4,111,4,111,4,113,4,113,4,115,4,115,4,117,4,117,4,119,4,119,4,121,4,121,4,123,4,123,4,125,4,125,4,127,4,127,4,129,4,129,4,139,4,139,4,141,4,141,4,143,4,143,4,145,4,145,4,147,4,147,4,149,4,149,4,151,4,151,4,153,4,153,4,155,4,155,4,157,4,157,4,159,4,159,4,161,4,161,4,163,4,163,4,165,4,165,4,167,4,167,4,169,4,169,4,171,4,171,4,173,4,173,4,175,4,175,4,177,4,177,4,179,4,179,4,181,4,181,4,183,4,183,4,185,4,185,4,187,4,187,4,189,4,189,4,191,4,191,4,194,4,194,4,196,4,196,4,198,4,198,4,200,4,200,4,202,4,202,4,204,4,204,4,206,4,206,4,209,4,209,4,211,4,211,4,213,4,213,4,215,4,215,4,217,4,217,4,219,4,219,4,221,4,221,4,223,4,223,4,225,4,225,4,227,4,227,4,229,4,229,4,231,4,231,4,233,4,233,4,235,4,235,4,237,4,237,4,239,4,239,4,241,4,241,4,243,4,243,4,245,4,245,4,249,4,249,4,1,5,1,5,3,5,3,5,5,5,5,5,7,5,7,5,9,5,9,5,11,5,11,5,13,5,13,5,15,5,15,5,97,5,135,5,0,29,43,29,98,29,107,29,1,30,1,30,3,30,3,30,5,30,5,30,7,30,7,30,9,30,9,30,11,30,11,30,13,30,13,30,15,30,15,30,17,30,17,30,19,30,19,30,21,30,21,30,23,30,23,30,25,30,25,30,27,30,27,30,29,30,29,30,31,30,31,30,33,30,33,30,35,30,35,30,37,30,37,30,39,30,39,30,41,30,41,30,43,30,43,30,45,30,45,30,47,30,47,30,49,30,49,30,51,30,51,30,53,30,53,30,55,30,55,30,57,30,57,30,59,30,59,30,61,30,61,30,63,30,63,30,65,30,65,30,67,30,67,30,69,30,69,30,71,30,71,30,73,30,73,30,75,30,75,30,77,30,77,30,79,30,79,30,81,30,81,30,83,30,83,30,85,30,85,30,87,30,87,30,89,30,89,30,91,30,91,30,93,30,93,30,95,30,95,30,97,30,97,30,99,30,99,30,101,30,101,30,103,30,103,30,105,30,105,30,107,30,107,30,109,30,109,30,111,30,111,30,113,30,113,30,115,30,115,30,117,30,117,30,119,30,119,30,121,30,121,30,123,30,123,30,125,30,125,30,127,30,127,30,129,30,129,30,131,30,131,30,133,30,133,30,135,30,135,30,137,30,137,30,139,30,139,30,141,30,141,30,143,30,143,30,145,30,145,30,147,30,147,30,149,30,155,30,161,30,161,30,163,30,163,30,165,30,165,30,167,30,167,30,169,30,169,30,171,30,171,30,173,30,173,30,175,30,175,30,177,30,177,30,179,30,179,30,181,30,181,30,183,30,183,30,185,30,185,30,187,30,187,30,189,30,189,30,191,30,191,30,193,30,193,30,195,30,195,30,197,30,197,30,199,30,199,30,201,30,201,30,203,30,203,30,205,30,205,30,207,30,207,30,209,30,209,30,211,30,211,30,213,30,213,30,215,30,215,30,217,30,217,30,219,30,219,30,221,30,221,30,223,30,223,30,225,30,225,30,227,30,227,30,229,30,229,30,231,30,231,30,233,30,233,30,235,30,235,30,237,30,237,30,239,30,239,30,241,30,241,30,243,30,243,30,245,30,245,30,247,30,247,30,249,30,249,30,0,31,7,31,16,31,21,31,32,31,39,31,48,31,55,31,64,31,69,31,80,31,87,31,96,31,103,31,112,31,125,31,128,31,135,31,144,31,151,31,160,31,167,31,176,31,180,31,182,31,183,31,190,31,190,31,194,31,196,31,198,31,199,31,208,31,211,31,214,31,215,31,224,31,231,31,242,31,244,31,246,31,247,31,113,32,113,32,127,32,127,32,10,33,10,33,14,33,15,33,19,33,19,33,47,33,47,33,52,33,52,33,57,33,57,33,61,33,61,33,70,33,73,33,0,251,6,251,19,251,23,251,65,255,90,255,40,4,1,0,79,4,1,0,26,212,1,0,51,212,1,0,78,212,1,0,84,212,1,0,86,212,1,0,103,212,1,0,130,212,1,0,155,212,1,0,182,212,1,0,185,212,1,0,187,212,1,0,187,212,1,0,189,212,1,0,195,212,1,0,197,212,1,0,207,212,1,0,234,212,1,0,3,213,1,0,30,213,1,0,55,213,1,0,82,213,1,0,107,213,1,0,134,213,1,0,159,213,1,0,186,213,1,0,211,213,1,0,238,213,1,0,7,214,1,0,34,214,1,0,59,214,1,0,86,214,1,0,111,214,1,0,138,214,1,0,163,214,1,0,194,214,1,0,218,214,1,0,220,214,1,0,225,214,1,0,252,214,1,0,20,215,1,0,22,215,1,0,27,215,1,0,54,215,1,0,78,215,1,0,80,215,1,0,85,215,1,0,112,215,1,0,136,215,1,0,138,215,1,0,143,215,1,0,170,215,1,0,194,215,1,0,196,215,1,0,201,215,1,0,65,0,90,0,97,0,122,0,170,0,170,0,181,0,181,0,186,0,186,0,192,0,214,0,216,0,246,0,248,0,54,2,80,2,193,2,198,2,209,2,224,2,228,2,238,2,238,2,122,3,122,3,134,3,134,3,136,3,138,3,140,3,140,3,142,3,161,3,163,3,206,3,208,3,245,3,247,3,251,3,0,4,129,4,138,4,206,4,208,4,245,4,248,4,249,4,0,5,15,5,49,5,86,5,89,5,89,5,97,5,135,5,208,5,234,5,240,5,242,5,33,6,58,6,64,6,74,6,110,6,111,6,113,6,211,6,213,6,213,6,229,6,230,6,238,6,239,6,250,6,252,6,255,6,255,6,16,7,16,7,18,7,47,7,77,7,79,7,128,7,165,7,177,7,177,7,4,9,57,9,61,9,61,9,80,9,80,9,88,9,97,9,133,9,140,9,143,9,144,9,147,9,168,9,170,9,176,9,178,9,178,9,182,9,185,9,189,9,189,9,220,9,221,9,223,9,225,9,240,9,241,9,5,10,10,10,15,10,16,10,19,10,40,10,42,10,48,10,50,10,51,10,53,10,54,10,56,10,57,10,89,10,92,10,94,10,94,10,114,10,116,10,133,10,141,10,143,10,145,10,147,10,168,10,170,10,176,10,178,10,179,10,181,10,185,10,189,10,189,10,208,10,208,10,224,10,225,10,5,11,12,11,15,11,16,11,19,11,40,11,42,11,48,11,50,11,51,11,53,11,57,11,61,11,61,11,92,11,93,11,95,11,97,11,113,11,113,11,131,11,131,11,133,11,138,11,142,11,144,11,146,11,149,11,153,11,154,11,156,11,156,11,158,11,159,11,163,11,164,11,168,11,170,11,174,11,181,11,183,11,185,11,5,12,12,12,14,12,16,12,18,12,40,12,42,12,51,12,53,12,57,12,96,12,97,12,133,12,140,12,142,12,144,12,146,12,168,12,170,12,179,12,181,12,185,12,189,12,189,12,222,12,222,12,224,12,225,12,5,13,12,13,14,13,16,13,18,13,40,13,42,13,57,13,96,13,97,13,133,13,150,13,154,13,177,13,179,13,187,13,189,13,189,13,192,13,198,13,1,14,48,14,50,14,51,14,64,14,70,14,129,14,130,14,132,14,132,14,135,14,136,14,138,14,138,14,141,14,141,14,148,14,151,14,153,14,159,14,161,14,163,14,165,14,165,14,167,14,167,14,170,14,171,14,173,14,176,14,178,14,179,14,189,14,189,14,192,14,196,14,198,14,198,14,220,14,221,14,0,15,0,15,64,15,71,15,73,15,106,15,136,15,139,15,0,16,33,16,35,16,39,16,41,16,42,16,80,16,85,16,160,16,197,16,208,16,248,16,0,17,89,17,95,17,162,17,168,17,249,17,0,18,6,18,8,18,70,18,72,18,72,18,74,18,77,18,80,18,86,18,88,18,88,18,90,18,93,18,96,18,134,18,136,18,136,18,138,18,141,18,144,18,174,18,176,18,176,18,178,18,181,18,184,18,190,18,192,18,192,18,194,18,197,18,200,18,206,18,208,18,214,18,216,18,238,18,240,18,14,19,16,19,16,19,18,19,21,19,24,19,30,19,32,19,70,19,72,19,90,19,160,19,244,19,1,20,108,22,111,22,118,22,129,22,154,22,160,22,234,22,0,23,12,23,14,23,17,23,32,23,49,23,64,23,81,23,96,23,108,23,110,23,112,23,128,23,179,23,215,23,215,23,220,23,220,23,32,24,119,24,128,24,168,24,0,25,28,25,80,25,109,25,112,25,116,25,0,29,107,29,0,30,155,30,160,30,249,30,0,31,21,31,24,31,29,31,32,31,69,31,72,31,77,31,80,31,87,31,89,31,89,31,91,31,91,31,93,31,93,31,95,31,125,31,128,31,180,31,182,31,188,31,190,31,190,31,194,31,196,31,198,31,204,31,208,31,211,31,214,31,219,31,224,31,236,31,242,31,244,31,246,31,252,31,113,32,113,32,127,32,127,32,2,33,2,33,7,33,7,33,10,33,19,33,21,33,21,33,25,33,29,33,36,33,36,33,38,33,38,33,40,33,40,33,42,33,45,33,47,33,49,33,51,33,57,33,61,33,63,33,69,33,73,33,5,48,6,48,49,48,53,48,59,48,60,48,65,48,150,48,157,48,159,48,161,48,250,48,252,48,255,48,5,49,44,49,49,49,142,49,160,49,183,49,240,49,255,49,0,52,0,52,181,77,181,77,0,78,0,78,165,159,165,159,0,160,140,164,0,172,0,172,163,215,163,215,0,249,45,250,48,250,106,250,0,251,6,251,19,251,23,251,29,251,29,251,31,251,40,251,42,251,54,251,56,251,60,251,62,251,62,251,64,251,65,251,67,251,68,251,70,251,177,251,211,251,61,253,80,253,143,253,146,253,199,253,240,253,251,253,112,254,116,254,118,254,252,254,33,255,58,255,65,255,90,255,102,255,190,255,194,255,199,255,202,255,207,255,210,255,215,255,218,255,220,255,0,0,0,0,0,0,1,0,11,0,1,0,13,0,1,0,38,0,1,0,40,0,1,0,58,0,1,0,60,0,1,0,61,0,1,0,63,0,1,0,77,0,1,0,80,0,1,0,93,0,1,0,128,0,1,0,250,0,1,0,0,3,1,0,30,3,1,0,48,3,1,0,73,3,1,0,128,3,1,0,157,3,1,0,0,4,1,0,157,4,1,0,0,8,1,0,5,8,1,0,8,8,1,0,8,8,1,0,10,8,1,0,53,8,1,0,55,8,1,0,56,8,1,0,60,8,1,0,60,8,1,0,63,8,1,0,63,8,1,0,0,212,1,0,84,212,1,0,86,212,1,0,156,212,1,0,158,212,1,0,159,212,1,0,162,212,1,0,162,212,1,0,165,212,1,0,166,212,1,0,169,212,1,0,172,212,1,0,174,212,1,0,185,212,1,0,187,212,1,0,187,212,1,0,189,212,1,0,195,212,1,0,197,212,1,0,5,213,1,0,7,213,1,0,10,213,1,0,13,213,1,0,20,213,1,0,22,213,1,0,28,213,1,0,30,213,1,0,57,213,1,0,59,213,1,0,62,213,1,0,64,213,1,0,68,213,1,0,70,213,1,0,70,213,1,0,74,213,1,0,80,213,1,0,82,213,1,0,163,214,1,0,168,214,1,0,192,214,1,0,194,214,1,0,218,214,1,0,220,214,1,0,250,214,1,0,252,214,1,0,20,215,1,0,22,215,1,0,52,215,1,0,54,215,1,0,78,215,1,0,80,215,1,0,110,215,1,0,112,215,1,0,136,215,1,0,138,215,1,0,168,215,1,0,170,215,1,0,194,215,1,0,196,215,1,0,201,215,1,0,0,0,2,0,0,0,2,0,214,166,2,0,214,166,2,0,0,248,2,0,29,250,2,0,173,0,173,0,0,6,3,6,221,6,221,6,15,7,15,7,180,23,181,23,11,32,15,32,42,32,46,32,96,32,99,32,106,32,111,32,255,254,255,254,249,255,251,255,0,0,0,0,115,209,1,0,122,209,1,0,1,0,14,0,1,0,14,0,32,0,14,0,127,0,14,0,0,0,31,0,127,0,159,0,173,0,173,0,0,6,3,6,221,6,221,6,15,7,15,7,180,23,181,23,11,32,15,32,42,32,46,32,96,32,99,32,106,32,111,32,0,216,0,216,127,219,128,219,255,219,0,220,255,223,0,224,255,248,255,248,255,254,255,254,249,255,251,255,115,209,1,0,122,209,1,0,1,0,14,0,1,0,14,0,32,0,14,0,127,0,14,0,0,0,15,0,0,0,15,0,253,255,15,0,253,255,15,0,0,0,16,0,0,0,16,0,253,255,16,0,253,255,16,0,16,210,2,0,66,0,0,0,32,210,2,0,67,0,0,0,64,210,2,0,68,0,0,0,72,210,2,0,69,0,0,0,104,210,2,0,70,0,0,0,136,210,2,0,71,0,0,0,152,210,2,0,72,0,0,0,160,210,2,0,73,0,0,0,176,210,2,0,74,0,0,0,184,210,2,0,75,0,0,0,200,210,2,0,76,0,0,0,216,210,2,0,77,0,0,0,240,210,2,0,78,0,0,0,0,211,2,0,79,0,0,0,16,211,2,0,80,0,0,0,24,211,2,0,81,0,0,0,48,211,2,0,82,0,0,0,72,211,2,0,83,0,0,0,96,211,2,0,84,0,0,0,128,211,2,0,85,0,0,0,168,211,2,0,86,0,0,0,192,211,2,0,87,0,0,0,224,211,2,0,88,0,0,0,248,211,2,0,89,0,0,0,24,212,2,0,90,0,0,0,56,212,2,0,91,0,0,0,72,212,2,0,92,0,0,0,104,212,2,0,93,0,0,0,144,212,2,0,94,0,0,0,168,212,2,0,95,0,0,0,200,212,2,0,96,0,0,0,216,212,2,0,97,0,0,0,232,212,2,0,98,0,0,0,0,213,2,0,99,0,0,0,16,213,2,0,100,0,0,0,40,213,2,0,101,0,0,0,48,213,2,0,102,0,0,0,64,213,2,0,103,0,0,0,80,213,2,0,104,0,0,0,104,213,2,0,105,0,0,0,136,213,2,0,106,0,0,0,152,213,2,0,107,0,0,0,176,213,2,0,108,0,0,0,192,213,2,0,109,0,0,0,208,213,2,0,110,0,0,0,216,213,2,0,111,0,0,0,224,213,2,0,112,0,0,0,240,213,2,0,113,0,0,0,0,214,2,0,114,0,0,0,16,214,2,0,115,0,0,0,32,214,2,0,116,0,0,0,64,214,2,0,117,0,0,0,88,214,2,0,118,0,0,0,104,214,2,0,119,0,0,0,120,214,2,0,120,0,0,0,128,214,2,0,121,0,0,0,136,214,2,0,122,0,0,0,168,214,2,0,123,0,0,0,184,214,2,0,124,0,0,0,200,214,2,0,125,0,0,0,216,214,2,0,126,0,0,0,0,215,2,0,127,0,0,0,8,215,2,0,128,0,0,0,24,215,2,0,129,0,0,0,32,215,2,0,130,0,0,0,48,215,2,0,131,0,0,0,80,215,2,0,132,0,0,0,88,215,2,0,133,0,0,0,104,215,2,0,134,0,0,0,112,215,2,0,135,0,0,0,136,215,2,0,136,0,0,0,152,215,2,0,137,0,0,0,168,215,2,0,138,0,0,0,192,215,2,0,139,0,0,0,216,215,2,0,140,0,0,0,224,215,2,0,141,0,0,0,248,215,2,0,142,0,0,0,16,216,2,0,143,0,0,0,32,216,2,0,144,0,0,0,48,216,2,0,145,0,0,0,80,216,2,0,146,0,0,0,104,216,2,0,147,0,0,0,144,216,2,0,148,0,0,0,184,216,2,0,149,0,0,0,208,216,2,0,150,0,0,0,240,216,2,0,151,0,0,0,8,217,2,0,152,0,0,0,24,217,2,0,153,0,0,0,40,217,2,0,154,0,0,0,48,217,2,0,155,0,0,0,64,217,2,0,156,0,0,0,72,217,2,0,157,0,0,0,88,217,2,0,158,0,0,0,120,217,2,0,159,0,0,0,128,217,2,0,160,0,0,0,136,217,2,0,161,0,0,0,160,217,2,0,162,0,0,0,176,217,2,0,163,0,0,0,192,217,2,0,164,0,0,0,200,217,2,0,165,0,0,0,208,217,2,0,166,0,0,0,216,217,2,0,167,0,0,0,240,217,2,0,168,0,0,0,8,218,2,0,169,0,0,0,24,218,2,0,170,0,0,0,56,218,2,0,171,0,0,0,80,218,2,0,172,0,0,0,104,218,2,0,173,0,0,0,144,218,2,0,174,0,0,0,176,218,2,0,175,0,0,0,208,218,2,0,176,0,0,0,216,218,2,0,177,0,0,0,224,218,2,0,178,0,0,0,240,218,2,0,179,0,0,0,248,218,2,0,180,0,0,0,0,219,2,0,181,0,0,0,24,219,2,0,182,0,0,0,32,219,2,0,183,0,0,0,40,219,2,0,184,0,0,0,48,219,2,0,185,0,0,0,56,219,2,0,186,0,0,0,64,219,2,0,187,0,0,0,80,219,2,0,188,0,0,0,120,219,2,0,189,0,0,0,144,219,2,0,190,0,0,0,176,219,2,0,191,0,0,0,192,219,2,0,192,0,0,0,208,219,2,0,193,0,0,0,65,101,103,101,97,110,78,117,109,98,101,114,115,0,0,0,65,108,112,104,97,98,101,116,105,99,80,114,101,115,101,110,116,97,116,105,111,110,70,111,114,109,115,0,0,0,0,0,65,114,97,98,105,99,0,0,65,114,97,98,105,99,80,114,101,115,101,110,116,97,116,105,111,110,70,111,114,109,115,45,65,0,0,0,0,0,0,0,65,114,97,98,105,99,80,114,101,115,101,110,116,97,116,105,111,110,70,111,114,109,115,45,66,0,0,0,0,0,0,0,65,114,109,101,110,105,97,110,0,0,0,0,0,0,0,0,65,114,114,111,119,115,0,0,66,97,115,105,99,76,97,116,105,110,0,0,0,0,0,0,66,101,110,103,97,108,105,0,66,108,111,99,107,69,108,101,109,101,110,116,115,0,0,0,66,111,112,111,109,111,102,111,0,0,0,0,0,0,0,0,66,111,112,111,109,111,102,111,69,120,116,101,110,100,101,100,0,0,0,0,0,0,0,0,66,111,120,68,114,97,119,105,110,103,0,0,0,0,0,0,66,114,97,105,108,108,101,80,97,116,116,101,114,110,115,0,66,117,104,105,100,0,0,0,66,121,122,97,110,116,105,110,101,77,117,115,105,99,97,108,83,121,109,98,111,108,115,0,67,74,75,67,111,109,112,97,116,105,98,105,108,105,116,121,0,0,0,0,0,0,0,0,67,74,75,67,111,109,112,97,116,105,98,105,108,105,116,121,70,111,114,109,115,0,0,0,67,74,75,67,111,109,112,97,116,105,98,105,108,105,116,121,73,100,101,111,103,114,97,112,104,115,0,0,0,0,0,0,67,74,75,67,111,109,112,97,116,105,98,105,108,105,116,121,73,100,101,111,103,114,97,112,104,115,83,117,112,112,108,101,109,101,110,116,0,0,0,0,67,74,75,82,97,100,105,99,97,108,115,83,117,112,112,108,101,109,101,110,116,0,0,0,67,74,75,83,121,109,98,111,108,115,97,110,100,80,117,110,99,116,117,97,116,105,111,110,0,0,0,0,0,0,0,0,67,74,75,85,110,105,102,105,101,100,73,100,101,111,103,114,97,112,104,115,0,0,0,0,67,74,75,85,110,105,102,105,101,100,73,100,101,111,103,114,97,112,104,115,69,120,116,101,110,115,105,111,110,65,0,0,67,74,75,85,110,105,102,105,101,100,73,100,101,111,103,114,97,112,104,115,69,120,116,101,110,115,105,111,110,66,0,0,67,104,101,114,111,107,101,101,0,0,0,0,0,0,0,0,67,111,109,98,105,110,105,110,103,68,105,97,99,114,105,116,105,99,97,108,77,97,114,107,115,0,0,0,0,0,0,0,67,111,109,98,105,110,105,110,103,68,105,97,99,114,105,116,105,99,97,108,77,97,114,107,115,102,111,114,83,121,109,98,111,108,115,0,0,0,0,0,67,111,109,98,105,110,105,110,103,72,97,108,102,77,97,114,107,115,0,0,0,0,0,0,67,111,109,98,105,110,105,110,103,77,97,114,107,115,102,111,114,83,121,109,98,111,108,115,0,0,0,0,0,0,0,0,67,111,110,116,114,111,108,80,105,99,116,117,114,101,115,0,67,117,114,114,101,110,99,121,83,121,109,98,111,108,115,0,67,121,112,114,105,111,116,83,121,108,108,97,98,97,114,121,0,0,0,0,0,0,0,0,67,121,114,105,108,108,105,99,0,0,0,0,0,0,0,0,67,121,114,105,108,108,105,99,83,117,112,112,108,101,109,101,110,116,0,0,0,0,0,0,68,101,115,101,114,101,116,0,68,101,118,97,110,97,103,97,114,105,0,0,0,0,0,0,68,105,110,103,98,97,116,115,0,0,0,0,0,0,0,0,69,110,99,108,111,115,101,100,65,108,112,104,97,110,117,109,101,114,105,99,115,0,0,0,69,110,99,108,111,115,101,100,67,74,75,76,101,116,116,101,114,115,97,110,100,77,111,110,116,104,115,0,0,0,0,0,69,116,104,105,111,112,105,99,0,0,0,0,0,0,0,0,71,101,110,101,114,97,108,80,117,110,99,116,117,97,116,105,111,110,0,0,0,0,0,0,71,101,111,109,101,116,114,105,99,83,104,97,112,101,115,0,71,101,111,114,103,105,97,110,0,0,0,0,0,0,0,0,71,111,116,104,105,99,0,0,71,114,101,101,107,0,0,0,71,114,101,101,107,69,120,116,101,110,100,101,100,0,0,0,71,114,101,101,107,97,110,100,67,111,112,116,105,99,0,0,71,117,106,97,114,97,116,105,0,0,0,0,0,0,0,0,71,117,114,109,117,107,104,105,0,0,0,0,0,0,0,0,72,97,108,102,119,105,100,116,104,97,110,100,70,117,108,108,119,105,100,116,104,70,111,114,109,115,0,0,0,0,0,0,72,97,110,103,117,108,67,111,109,112,97,116,105,98,105,108,105,116,121,74,97,109,111,0,72,97,110,103,117,108,74,97,109,111,0,0,0,0,0,0,72,97,110,103,117,108,83,121,108,108,97,98,108,101,115,0,72,97,110,117,110,111,111,0,72,101,98,114,101,119,0,0,72,105,103,104,80,114,105,118,97,116,101,85,115,101,83,117,114,114,111,103,97,116,101,115,0,0,0,0,0,0,0,0,72,105,103,104,83,117,114,114,111,103,97,116,101,115,0,0,72,105,114,97,103,97,110,97,0,0,0,0,0,0,0,0,73,80,65,69,120,116,101,110,115,105,111,110,115,0,0,0,73,100,101,111,103,114,97,112,104,105,99,68,101,115,99,114,105,112,116,105,111,110,67,104,97,114,97,99,116,101,114,115,0,0,0,0,0,0,0,0,75,97,110,98,117,110,0,0,75,97,110,103,120,105,82,97,100,105,99,97,108,115,0,0,75,97,110,110,97,100,97,0,75,97,116,97,107,97,110,97,0,0,0,0,0,0,0,0,75,97,116,97,107,97,110,97,80,104,111,110,101,116,105,99,69,120,116,101,110,115,105,111,110,115,0,0,0,0,0,0,75,104,109,101,114,0,0,0,75,104,109,101,114,83,121,109,98,111,108,115,0,0,0,0,76,97,111,0,0,0,0,0,76,97,116,105,110,45,49,83,117,112,112,108,101,109,101,110,116,0,0,0,0,0,0,0,76,97,116,105,110,69,120,116,101,110,100,101,100,45,65,0,76,97,116,105,110,69,120,116,101,110,100,101,100,45,66,0,76,97,116,105,110,69,120,116,101,110,100,101,100,65,100,100,105,116,105,111,110,97,108,0,76,101,116,116,101,114,108,105,107,101,83,121,109,98,111,108,115,0,0,0,0,0,0,0,76,105,109,98,117,0,0,0,76,105,110,101,97,114,66,73,100,101,111,103,114,97,109,115,0,0,0,0,0,0,0,0,76,105,110,101,97,114,66,83,121,108,108,97,98,97,114,121,0,0,0,0,0,0,0,0,76,111,119,83,117,114,114,111,103,97,116,101,115,0,0,0,77,97,108,97,121,97,108,97,109,0,0,0,0,0,0,0,77,97,116,104,101,109,97,116,105,99,97,108,65,108,112,104,97,110,117,109,101,114,105,99,83,121,109,98,111,108,115,0,77,97,116,104,101,109,97,116,105,99,97,108,79,112,101,114,97,116,111,114,115,0,0,0,77,105,115,99,101,108,108,97,110,101,111,117,115,77,97,116,104,101,109,97,116,105,99,97,108,83,121,109,98,111,108,115,45,65,0,0,0,0,0,0,77,105,115,99,101,108,108,97,110,101,111,117,115,77,97,116,104,101,109,97,116,105,99,97,108,83,121,109,98,111,108,115,45,66,0,0,0,0,0,0,77,105,115,99,101,108,108,97,110,101,111,117,115,83,121,109,98,111,108,115,0,0,0,0,77,105,115,99,101,108,108,97,110,101,111,117,115,83,121,109,98,111,108,115,97,110,100,65,114,114,111,119,115,0,0,0,77,105,115,99,101,108,108,97,110,101,111,117,115,84,101,99,104,110,105,99,97,108,0,0,77,111,110,103,111,108,105,97,110,0,0,0,0,0,0,0,77,117,115,105,99,97,108,83,121,109,98,111,108,115,0,0,77,121,97,110,109,97,114,0,78,117,109,98,101,114,70,111,114,109,115,0,0,0,0,0,79,103,104,97,109,0,0,0,79,108,100,73,116,97,108,105,99,0,0,0,0,0,0,0,79,112,116,105,99,97,108,67,104,97,114,97,99,116,101,114,82,101,99,111,103,110,105,116,105,111,110,0,0,0,0,0,79,114,105,121,97,0,0,0,79,115,109,97,110,121,97,0,80,104,111,110,101,116,105,99,69,120,116,101,110,115,105,111,110,115,0,0,0,0,0,0,80,114,105,118,97,116,101,85,115,101,0,0,0,0,0,0,80,114,105,118,97,116,101,85,115,101,65,114,101,97,0,0,82,117,110,105,99,0,0,0,83,104,97,118,105,97,110,0,83,105,110,104,97,108,97,0,83,109,97,108,108,70,111,114,109,86,97,114,105,97,110,116,115,0,0,0,0,0,0,0,83,112,97,99,105,110,103,77,111,100,105,102,105,101,114,76,101,116,116,101,114,115,0,0,83,112,101,99,105,97,108,115,0,0,0,0,0,0,0,0,83,117,112,101,114,115,99,114,105,112,116,115,97,110,100,83,117,98,115,99,114,105,112,116,115,0,0,0,0,0,0,0,83,117,112,112,108,101,109,101,110,116,97,108,65,114,114,111,119,115,45,65,0,0,0,0,83,117,112,112,108,101,109,101,110,116,97,108,65,114,114,111,119,115,45,66,0,0,0,0,83,117,112,112,108,101,109,101,110,116,97,108,77,97,116,104,101,109,97,116,105,99,97,108,79,112,101,114,97,116,111,114,115,0,0,0,0,0,0,0,83,117,112,112,108,101,109,101,110,116,97,114,121,80,114,105,118,97,116,101,85,115,101,65,114,101,97,45,65,0,0,0,83,117,112,112,108,101,109,101,110,116,97,114,121,80,114,105,118,97,116,101,85,115,101,65,114,101,97,45,66,0,0,0,83,121,114,105,97,99,0,0,84,97,103,97,108,111,103,0,84,97,103,98,97,110,119,97,0,0,0,0,0,0,0,0,84,97,103,115,0,0,0,0,84,97,105,76,101,0,0,0,84,97,105,88,117,97,110,74,105,110,103,83,121,109,98,111,108,115,0,0,0,0,0,0,84,97,109,105,108,0,0,0,84,101,108,117,103,117,0,0,84,104,97,97,110,97,0,0,84,104,97,105,0,0,0,0,84,105,98,101,116,97,110,0,85,103,97,114,105,116,105,99,0,0,0,0,0,0,0,0,85,110,105,102,105,101,100,67,97,110,97,100,105,97,110,65,98,111,114,105,103,105,110,97,108,83,121,108,108,97,98,105,99,115],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+177008),allocate([86,97,114,105,97,116,105,111,110,83,101,108,101,99,116,111,114,115,0,0,0,0,0,0,86,97,114,105,97,116,105,111,110,83,101,108,101,99,116,111,114,115,83,117,112,112,108,101,109,101,110,116,0,0,0,0,89,105,82,97,100,105,99,97,108,115,0,0,0,0,0,0,89,105,83,121,108,108,97,98,108,101,115,0,0,0,0,0,89,105,106,105,110,103,72,101,120,97,103,114,97,109,83,121,109,98,111,108,115,0,0,0,0,0,0,0,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,51,47,88,73,110,99,108,117,100,101,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,49,47,88,73,110,99,108,117,100,101,0,120,109,108,78,101,119,84,101,120,116,82,101,97,100,101,114,32,58,32,109,97,108,108,111,99,32,102,97,105,108,101,100,10,0,0,0,0,0,0,0,120,109,108,110,115,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,48,47,120,109,108,110,115,47,0,0,0,58,0,0,0,0,0,0,0,35,116,101,120,116,0,0,0,35,99,100,97,116,97,45,115,101,99,116,105,111,110,0,0,35,99,111,109,109,101,110,116,0,0,0,0,0,0,0,0,35,100,111,99,117,109,101,110,116,0,0,0,0,0,0,0,35,100,111,99,117,109,101,110,116,45,102,114,97,103,109,101,110,116,0,0,0,0,0,0,120,109,108,84,101,120,116,82,101,97,100,101,114,83,101,116,117,112,32,58,32,109,97,108,108,111,99,32,102,97,105,108,101,100,10,0,0,0,0,0,120,109,108,77,97,108,108,111,99,32,102,97,105,108,101,100,32,33,10,0,0,0,0,0,120,109,108,82,101,97,108,108,111,99,32,102,97,105,108,101,100,32,33,10,0,0,0,0,105,110,99,108,117,100,101,0,118,115,110,112,114,105,110,116,102,32,102,97,105,108,101,100,32,33,10,0,0,0,0,0,37,115,0,0,0,0,0,0,69,120,112,97,110,100,32,102,97,105,108,101,100,32,33,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,97,108,108,111,99,97,116,101,32,115,104,32,116,97,98,108,101,32,102,111,114,32,82,101,108,97,120,45,78,71,32,116,121,112,101,115,10,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,49,47,88,77,76,83,99,104,101,109,97,45,100,97,116,97,116,121,112,101,115,0,0,0,0,0,0,64,241,2,0,0,0,0,0,98,117,105,108,100,105,110,103,32,112,97,114,115,101,114,10,0,0,0,0,0,0,0,0,120,109,108,82,101,108,97,120,78,71,80,97,114,115,101,58,32,99,111,117,108,100,32,110,111,116,32,108,111,97,100,32,37,115,10,0,0,0,0,0,120,109,108,82,101,108,97,120,78,71,80,97,114,115,101,58,32,99,111,117,108,100,32,110,111,116,32,112,97,114,115,101,32,115,99,104,101,109,97,115,10,0,0,0,0,0,0,0,105,110,95,109,101,109,111,114,121,95,98,117,102,102,101,114,0,0,0,0,0,0,0,0,120,109,108,82,101,108,97,120,78,71,80,97,114,115,101,58,32,110,111,116,104,105,110,103,32,116,111,32,112,97,114,115,101,10,0,0,0,0,0,0,120,109,108,82,101,108,97,120,78,71,80,97,114,115,101,58,32,37,115,32,105,115,32,101,109,112,116,121,10,0,0,0,115,99,104,101,109,97,115,0,35,116,101,120,116,0,0,0,32,84,79,68,79,32,0,0,0,0,0,0,0,0,0,0,98,117,105,108,100,105,110,103,32,99,111,110,116,101,120,116,10,0,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,10,0,0,102,97,105,108,101,100,32,116,111,32,118,97,108,105,100,97,116,101,32,116,121,112,101,32,37,115,10,0,0,0,0,0,84,121,112,101,32,37,115,32,100,111,101,115,110,39,116,32,97,108,108,111,119,32,118,97,108,117,101,32,39,37,115,39,10,0,0,0,0,0,0,0,73,68,32,37,115,32,114,101,100,101,102,105,110,101,100,10,0,0,0,0,0,0,0,0,102,97,105,108,101,100,32,116,111,32,99,111,109,112,97,114,101,32,116,121,112,101,32,37,115,10,0,0,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,110,111,32,115,116,97,116,101,10,0,0,0,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,110,111,32,100,101,102,105,110,101,10,0,0,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,37,115,10,0,0,0,0,0,69,120,116,114,97,32,100,97,116,97,32,105,110,32,108,105,115,116,58,32,37,115,10,0,73,110,116,101,114,110,97,108,58,32,105,110,116,101,114,108,101,97,118,101,32,98,108,111,99,107,32,104,97,115,32,110,111,32,100,97,116,97,10,0,73,110,118,97,108,105,100,32,115,101,113,117,101,110,99,101,32,105,110,32,105,110,116,101,114,108,101,97,118,101,10,0,69,120,116,114,97,32,101,108,101,109,101,110,116,32,37,115,32,105,110,32,105,110,116,101,114,108,101,97,118,101,10,0,69,120,112,101,99,116,105,110,103,32,101,108,101,109,101,110,116,32,37,115,44,32,103,111,116,32,37,115,10,0,0,0,69,120,112,101,99,116,105,110,103,32,97,32,110,97,109,101,115,112,97,99,101,32,102,111,114,32,101,108,101,109,101,110,116,32,37,115,10,0,0,0,69,108,101,109,101,110,116,32,37,115,32,104,97,115,32,119,114,111,110,103,32,110,97,109,101,115,112,97,99,101,58,32,101,120,112,101,99,116,105,110,103,32,37,115,10,0,0,0,68,105,100,32,110,111,116,32,101,120,112,101,99,116,32,101,108,101,109,101,110,116,32,37,115,32,116,104,101,114,101,10,0,0,0,0,0,0,0,0,68,105,100,32,110,111,116,32,101,120,112,101,99,116,32,116,101,120,116,32,105,110,32,101,108,101,109,101,110,116,32,37,115,32,99,111,110,116,101,110,116,10,0,0,0,0,0,0,69,120,112,101,99,116,105,110,103,32,110,111,32,110,97,109,101,115,112,97,99,101,32,102,111,114,32,101,108,101,109,101,110,116,32,37,115,10,0,0,69,120,112,101,99,116,105,110,103,32,101,108,101,109,101,110,116,32,37,115,32,116,111,32,98,101,32,101,109,112,116,121,10,0,0,0,0,0,0,0,69,120,112,101,99,116,105,110,103,32,97,110,32,101,108,101,109,101,110,116,32,37,115,44,32,103,111,116,32,110,111,116,104,105,110,103,10,0,0,0,69,120,112,101,99,116,105,110,103,32,97,110,32,101,108,101,109,101,110,116,32,103,111,116,32,116,101,120,116,10,0,0,69,108,101,109,101,110,116,32,37,115,32,102,97,105,108,101,100,32,116,111,32,118,97,108,105,100,97,116,101,32,97,116,116,114,105,98,117,116,101,115,10,0,0,0,0,0,0,0,69,108,101,109,101,110,116,32,37,115,32,102,97,105,108,101,100,32,116,111,32,118,97,108,105,100,97,116,101,32,99,111,110,116,101,110,116,10,0,0,69,108,101,109,101,110,116,32,37,115,32,104,97,115,32,101,120,116,114,97,32,99,111,110,116,101,110,116,58,32,37,115,10,0,0,0,0,0,0,0,73,110,118,97,108,105,100,32,97,116,116,114,105,98,117,116,101,32,37,115,32,102,111,114,32,101,108,101,109,101,110,116,32,37,115,10,0,0,0,0,68,97,116,97,116,121,112,101,32,101,108,101,109,101,110,116,32,37,115,32,99,111,110,116,97,105,110,115,32,110,111,32,100,97,116,97,10,0,0,0,68,97,116,97,116,121,112,101,32,101,108,101,109,101,110,116,32,37,115,32,104,97,115,32,99,104,105,108,100,32,101,108,101,109,101,110,116,115,10,0,86,97,108,117,101,32,101,108,101,109,101,110,116,32,37,115,32,104,97,115,32,99,104,105,108,100,32,101,108,101,109,101,110,116,115,10,0,0,0,0,76,105,115,116,32,101,108,101,109,101,110,116,32,37,115,32,104,97,115,32,99,104,105,108,100,32,101,108,101,109,101,110,116,115,10,0,0,0,0,0,69,114,114,111,114,32,118,97,108,105,100,97,116,105,110,103,32,100,97,116,97,116,121,112,101,32,37,115,10,0,0,0,69,114,114,111,114,32,118,97,108,105,100,97,116,105,110,103,32,118,97,108,117,101,32,37,115,10,0,0,0,0,0,0,69,114,114,111,114,32,118,97,108,105,100,97,116,105,110,103,32,108,105,115,116,10,0,0,78,111,32,116,111,112,32,103,114,97,109,109,97,114,32,100,101,102,105,110,101,100,10,0,69,120,116,114,97,32,100,97,116,97,32,105,110,32,116,104,101,32,100,111,99,117,109,101,110,116,10,0,0,0,0,0,85,110,107,110,111,119,110,32,101,114,114,111,114,32,33,10,0,0,0,0,0,0,0,0,85,110,107,110,111,119,110,32,101,114,114,111,114,32,99,111,100,101,32,37,100,10,0,0,115,116,111,114,105,110,103,32,115,116,97,116,101,115,10,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,32,58,32,37,115,10,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,101,100,10,0,0,0,0,0,0,0,85,110,105,109,112,108,101,109,101,110,116,101,100,32,98,108,111,99,107,32,97,116,32,37,115,58,37,100,10,0,0,0,46,46,47,108,105,98,120,109,108,50,47,114,101,108,97,120,110,103,46,99,0,0,0,0,97,100,100,105,110,103,32,115,116,97,116,101,115,10,0,0,35,97,110,121,0,0,0,0,118,97,108,105,100,97,116,105,110,103,10,0,0,0,0,0,110,111,110,97,109,101,0,0,97,108,108,111,99,97,116,105,110,103,32,115,116,97,116,101,115,10,0,0,0,0,0,0,78,85,76,76,32,100,101,102,105,110,105,116,105,111,110,32,108,105,115,116,0,0,0,0,99,97,108,108,98,97,99,107,32,111,110,32,37,115,32,109,105,115,115,105,110,103,32,99,111,110,116,101,120,116,10,0,99,97,108,108,98,97,99,107,32,111,110,32,37,115,32,109,105,115,115,105,110,103,32,100,101,102,105,110,101,10,0,0,99,97,108,108,98,97,99,107,32,111,110,32,37,115,32,109,105,115,115,105,110,103,32,105,110,102,111,10,0,0,0,0,99,97,108,108,98,97,99,107,32,111,110,32,37,115,32,100,101,102,105,110,101,32,105,115,32,110,111,116,32,101,108,101,109,101,110,116,10,0,0,0,112,117,115,104,105,110,103,32,101,114,114,111,114,10,0,0,82,78,71,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,32,116,114,121,105,110,103,32,116,111,32,99,111,109,112,105,108,101,32,37,115,10,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,101,109,112,116,121,0,0,0,110,111,116,65,108,108,111,119,101,100,0,0,0,0,0,0,101,120,99,101,112,116,0,0,116,101,120,116,0,0,0,0,101,108,101,109,101,110,116,0,100,97,116,97,116,121,112,101,0,0,0,0,0,0,0,0,118,97,108,117,101,0,0,0,108,105,115,116,0,0,0,0,97,116,116,114,105,98,117,116,101,0,0,0,0,0,0,0,100,101,102,0,0,0,0,0,114,101,102,0,0,0,0,0,101,120,116,101,114,110,97,108,82,101,102,0,0,0,0,0,112,97,114,101,110,116,82,101,102,0,0,0,0,0,0,0,111,112,116,105,111,110,97,108,0,0,0,0,0,0,0,0,122,101,114,111,79,114,77,111,114,101,0,0,0,0,0,0,111,110,101,79,114,77,111,114,101,0,0,0,0,0,0,0,99,104,111,105,99,101,0,0,103,114,111,117,112,0,0,0,105,110,116,101,114,108,101,97,118,101,0,0,0,0,0,0,115,116,97,114,116,0,0,0,110,111,111,112,0,0,0,0,112,97,114,97,109,0,0,0,117,110,107,110,111,119,110,0,97,108,108,111,99,97,116,105,110,103,32,100,101,102,105,110,101,10,0,0,0,0,0,0,69,108,101,109,101,110,116,32,111,114,32,116,101,120,116,32,99,111,110,102,108,105,99,116,115,32,105,110,32,105,110,116,101,114,108,101,97,118,101,10,0,0,0,0,0,0,0,0,65,116,116,114,105,98,117,116,101,115,32,99,111,110,102,108,105,99,116,115,32,105,110,32,105,110,116,101,114,108,101,97,118,101,10,0,0,0,0,0,105,110,32,105,110,116,101,114,108,101,97,118,101,32,99,111,109,112,117,116,97,116,105,111,110,10,0,0,0,0,0,0,24,231,2,0,0,0,0,0,1,0,0,0,0,0,0,0,103,101,116,116,105,110,103,32,101,108,101,109,101,110,116,32,108,105,115,116,10,0,0,0,103,114,97,109,109,97,114,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,100,97,116,97,47,101,120,99,101,112,116,47,47,114,101,102,10,0,0,0,0,0,0,0,73,110,116,101,114,110,97,108,32,102,111,117,110,100,32,110,111,32,100,101,102,105,110,101,32,102,111,114,32,112,97,114,101,110,116,32,114,101,102,115,10,0,0,0,0,0,0,0,73,110,116,101,114,110,97,108,32,102,111,117,110,100,32,110,111,32,100,101,102,105,110,101,32,102,111,114,32,114,101,102,32,37,115,10,0,0,0,0,110,117,108,108,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,100,97,116,97,47,101,120,99,101,112,116,47,47,101,108,101,109,101,110,116,40,114,101,102,41,10,0,0,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,108,105,115,116,47,47,101,108,101,109,101,110,116,40,114,101,102,41,10,0,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,97,116,116,114,105,98,117,116,101,47,47,101,108,101,109,101,110,116,40,114,101,102,41,10,0,0,0,0,0,0,0,0,69,108,101,109,101,110,116,32,37,115,32,97,116,116,114,105,98,117,116,101,115,32,104,97,118,101,32,97,32,99,111,110,116,101,110,116,32,116,121,112,101,32,101,114,114,111,114,10,0,0,0,0,0,0,0,0,69,108,101,109,101,110,116,32,37,115,32,104,97,115,32,97,32,99,111,110,116,101,110,116,32,116,121,112,101,32,101,114,114,111,114,10,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,97,116,116,114,105,98,117,116,101,47,47,97,116,116,114,105,98,117,116,101,10,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,108,105,115,116,47,47,97,116,116,114,105,98,117,116,101,10,0,0,0,0,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,111,110,101,79,114,77,111,114,101,47,47,103,114,111,117,112,47,47,97,116,116,114,105,98,117,116,101,10,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,111,110,101,79,114,77,111,114,101,47,47,105,110,116,101,114,108,101,97,118,101,47,47,97,116,116,114,105,98,117,116,101,10,0,0,0,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,100,97,116,97,47,101,120,99,101,112,116,47,47,97,116,116,114,105,98,117,116,101,10,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,115,116,97,114,116,47,47,97,116,116,114,105,98,117,116,101,10,0,0,0,0,0,0,0,70,111,117,110,100,32,97,110,121,78,97,109,101,32,97,116,116,114,105,98,117,116,101,32,119,105,116,104,111,117,116,32,111,110,101,79,114,77,111,114,101,32,97,110,99,101,115,116,111,114,10,0,0,0,0,0,70,111,117,110,100,32,110,115,78,97,109,101,32,97,116,116,114,105,98,117,116,101,32,119,105,116,104,111,117,116,32,111,110,101,79,114,77,111,114,101,32,97,110,99,101,115,116,111,114,10,0,0,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,100,97,116,97,47,101,120,99,101,112,116,47,47,111,110,101,79,114,77,111,114,101,10,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,115,116,97,114,116,47,47,111,110,101,79,114,77,111,114,101,10,0,0,0,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,108,105,115,116,47,47,108,105,115,116,10,0,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,100,97,116,97,47,101,120,99,101,112,116,47,47,108,105,115,116,10,0,0,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,115,116,97,114,116,47,47,108,105,115,116,10,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,100,97,116,97,47,101,120,99,101,112,116,47,47,103,114,111,117,112,10,0,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,115,116,97,114,116,47,47,103,114,111,117,112,10,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,108,105,115,116,47,47,105,110,116,101,114,108,101,97,118,101,10,0,0,0,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,100,97,116,97,47,101,120,99,101,112,116,47,47,105,110,116,101,114,108,101,97,118,101,10,0,0,0,0,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,115,116,97,114,116,47,47,105,110,116,101,114,108,101,97,118,101,10,0,0,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,115,116,97,114,116,47,47,100,97,116,97,10,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,115,116,97,114,116,47,47,118,97,108,117,101,10,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,108,105,115,116,47,47,116,101,120,116,10,0,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,100,97,116,97,47,101,120,99,101,112,116,47,47,116,101,120,116,10,0,0,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,115,116,97,114,116,47,47,116,101,120,116,10,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,100,97,116,97,47,101,120,99,101,112,116,47,47,101,109,112,116,121,10,0,0,0,0,0,70,111,117,110,100,32,102,111,114,98,105,100,100,101,110,32,112,97,116,116,101,114,110,32,115,116,97,114,116,47,47,101,109,112,116,121,10,0,0,0,98,117,105,108,100,105,110,103,32,99,104,111,105,99,101,10,0,0,0,0,0,0,0,0,98,117,105,108,100,105,110,103,32,103,114,111,117,112,10,0,65,116,116,114,105,98,117,116,101,115,32,99,111,110,102,108,105,99,116,115,32,105,110,32,103,114,111,117,112,10,0,0,68,101,116,101,99,116,101,100,32,97,32,99,121,99,108,101,32,105,110,32,37,115,32,114,101,102,101,114,101,110,99,101,115,10,0,0,0,0,0,0,115,116,97,114,116,32,104,97,115,32,110,111,32,99,104,105,108,100,114,101,110,10,0,0,101,108,101,109,101,110,116,32,101,109,112,116,121,32,105,115,32,110,111,116,32,101,109,112,116,121,10,0,0,0,0,0,101,108,101,109,101,110,116,32,110,111,116,65,108,108,111,119,101,100,32,105,115,32,110,111,116,32,101,109,112,116,121,10,0,0,0,0,0,0,0,0,115,116,97,114,116,32,109,111,114,101,32,116,104,97,110,32,111,110,101,32,99,104,105,108,100,114,101,110,10,0,0,0,101,109,112,116,121,58,32,104,97,100,32,97,32,99,104,105,108,100,32,110,111,100,101,10,0,0,0,0,0,0,0,0,116,101,120,116,58,32,104,97,100,32,97,32,99,104,105,108,100,32,110,111,100,101,10,0,69,108,101,109,101,110,116,32,37,115,32,105,115,32,101,109,112,116,121,10,0,0,0,0,110,97,109,101,0,0,0,0,114,101,102,32,104,97,115,32,110,111,32,110,97,109,101,10,0,0,0,0,0,0,0,0,114,101,102,32,110,97,109,101,32,39,37,115,39,32,105,115,32,110,111,116,32,97,110,32,78,67,78,97,109,101,10,0,114,101,102,32,105,115,32,110,111,116,32,101,109,112,116,121,10,0,0,0,0,0,0,0,67,111,117,108,100,32,110,111,116,32,99,114,101,97,116,101,32,114,101,102,101,114,101,110,99,101,115,32,104,97,115,104,10,0,0,0,0,0,0,0,69,114,114,111,114,32,114,101,102,115,32,100,101,102,105,110,105,116,105,111,110,115,32,39,37,115,39,10,0,0,0,0,69,114,114,111,114,32,114,101,102,115,32,100,101,102,105,110,105,116,105,111,110,115,10,0,100,97,116,97,0,0,0,0,120,109,108,82,101,108,97,120,78,71,80,97,114,115,101,58,32,110,111,116,65,108,108,111,119,101,100,32,101,108,101,109,101,110,116,32,105,115,32,110,111,116,32,101,109,112,116,121,10,0,0,0,0,0,0,0,85,115,101,32,111,102,32,112,97,114,101,110,116,82,101,102,32,119,105,116,104,111,117,116,32,97,32,112,97,114,101,110,116,32,103,114,97,109,109,97,114,10,0,0,0,0,0,0,112,97,114,101,110,116,82,101,102,32,104,97,115,32,110,111,32,110,97,109,101,10,0,0,112,97,114,101,110,116,82,101,102,32,110,97,109,101,32,39,37,115,39,32,105,115,32,110,111,116,32,97,110,32,78,67,78,97,109,101,10,0,0,0,112,97,114,101,110,116,82,101,102,32,105,115,32,110,111,116,32,101,109,112,116,121,10,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,32,112,97,114,101,110,116,82,101,102,32,100,101,102,105,110,105,116,105,111,110,115,32,39,37,115,39,10,0,0,0,0,0,0,109,105,120,101,100,0,0,0,77,105,120,101,100,32,105,115,32,101,109,112,116,121,10,0,85,110,101,120,112,101,99,116,101,100,32,110,111,100,101,32,37,115,32,105,115,32,110,111,116,32,97,32,112,97,116,116,101,114,110,10,0,0,0,0,110,115,0,0,0,0,0,0,99,114,101,97,116,101,32,105,110,116,101,114,108,101,97,118,101,115,10,0,0,0,0,0,105,110,116,101,114,108,101,97,118,101,37,100,0,0,0,0,70,97,105,108,101,100,32,116,111,32,97,100,100,32,37,115,32,116,111,32,104,97,115,104,32,116,97,98,108,101,10,0,69,108,101,109,101,110,116,32,105,110,116,101,114,108,101,97,118,101,32,105,115,32,101,109,112,116,121,10,0,0,0,0,116,121,112,101,0,0,0,0,118,97,108,117,101,32,116,121,112,101,32,39,37,115,39,32,105,115,32,110,111,116,32,97,110,32,78,67,78,97,109,101,10,0,0,0,0,0,0,0,104,116,116,112,58,47,47,114,101,108,97,120,110,103,46,111,114,103,47,110,115,47,115,116,114,117,99,116,117,114,101,47,49,46,48,0,0,0,0,0,85,115,101,32,111,102,32,117,110,114,101,103,105,115,116,101,114,101,100,32,116,121,112,101,32,108,105,98,114,97,114,121,32,39,37,115,39,10,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,32,119,105,116,104,32,116,121,112,101,32,108,105,98,114,97,114,121,32,39,37,115,39,58,32,110,111,32,39,104,97,118,101,39,10,0,0,0,0,0,0,0,69,114,114,111,114,32,116,121,112,101,32,39,37,115,39,32,105,115,32,110,111,116,32,101,120,112,111,114,116,101,100,32,98,121,32,116,121,112,101,32,108,105,98,114,97,114,121,32,39,37,115,39,10,0,0,0,69,120,112,101,99,116,105,110,103,32,97,32,115,105,110,103,108,101,32,116,101,120,116,32,118,97,108,117,101,32,102,111,114,32,60,118,97,108,117,101,62,99,111,110,116,101,110,116,10,0,0,0,0,0,0,0,69,108,101,109,101,110,116,32,60,118,97,108,117,101,62,32,104,97,115,32,110,111,32,99,111,110,116,101,110,116,10,0,86,97,108,117,101,32,39,37,115,39,32,105,115,32,110,111,116,32,97,99,99,101,112,116,97,98,108,101,32,102,111,114,32,116,121,112,101,32,39,37,115,39,10,0,0,0,0,0,100,97,116,97,116,121,112,101,76,105,98,114,97,114,121,0,58,47,35,63,0,0,0,0,100,97,116,97,32,104,97,115,32,110,111,32,116,121,112,101,10,0,0,0,0,0,0,0,100,97,116,97,32,116,121,112,101,32,39,37,115,39,32,105,115,32,110,111,116,32,97,110,32,78,67,78,97,109,101,10,0,0,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,84,121,112,101,32,108,105,98,114,97,114,121,32,39,37,115,39,32,100,111,101,115,32,110,111,116,32,97,108,108,111,119,32,116,121,112,101,32,112,97,114,97,109,101,116,101,114,115,10,0,0,0,0,0,0,0,112,97,114,97,109,32,104,97,115,32,110,111,32,110,97,109,101,10,0,0,0,0,0,0,101,120,99,101,112,116,32,104,97,115,32,110,111,32,99,111,110,116,101,110,116,10,0,0,69,108,101,109,101,110,116,32,100,97,116,97,32,104,97,115,32,117,110,101,120,112,101,99,116,101,100,32,99,111,110,116,101,110,116,32,37,115,10,0,120,109,108,82,101,108,97,120,78,71,80,97,114,115,101,97,116,116,114,105,98,117,116,101,58,32,97,116,116,114,105,98,117,116,101,32,104,97,115,32,110,111,32,99,104,105,108,100,114,101,110,10,0,0,0,0,97,116,116,114,105,98,117,116,101,32,104,97,115,32,105,110,118,97,108,105,100,32,99,111,110,116,101,110,116,10,0,0,82,78,71,32,73,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,110,111,111,112,32,102,111,117,110,100,32,105,110,32,97,116,116,114,105,98,117,116,101,10,0,0,0,0,97,116,116,114,105,98,117,116,101,32,104,97,115,32,109,117,108,116,105,112,108,101,32,99,104,105,108,100,114,101,110,10,0,0,0,0,0,0,0,0,97,110,121,78,97,109,101,0,110,115,78,97,109,101,0,0,69,108,101,109,101,110,116,32,37,115,32,110,97,109,101,32,39,37,115,39,32,105,115,32,110,111,116,32,97,110,32,78,67,78,97,109,101,10,0,0,110,97,109,101,32,39,37,115,39,32,105,115,32,110,111,116,32,97,110,32,78,67,78,97,109,101,10,0,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,48,47,120,109,108,110,115,0,0,0,0,65,116,116,114,105,98,117,116,101,32,119,105,116,104,32,110,97,109,101,115,112,97,99,101,32,39,37,115,39,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,10,0,0,0,120,109,108,110,115,0,0,0,65,116,116,114,105,98,117,116,101,32,119,105,116,104,32,81,78,97,109,101,32,39,120,109,108,110,115,39,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,10,0,0,0,0,110,115,78,97,109,101,32,104,97,115,32,110,111,32,110,115,32,97,116,116,114,105,98,117,116,101,10,0,0,0,0,0,69,108,101,109,101,110,116,32,99,104,111,105,99,101,32,105,115,32,101,109,112,116,121,10,0,0,0,0,0,0,0,0,101,120,112,101,99,116,105,110,103,32,110,97,109,101,44,32,97,110,121,78,97,109,101,44,32,110,115,78,97,109,101,32,111,114,32,99,104,111,105,99,101,32,58,32,103,111,116,32,37,115,10,0,0,0,0,0,110,111,116,104,105,110,103,0,69,120,112,101,99,116,105,110,103,32,97,110,32,101,120,99,101,112,116,32,110,111,100,101,10,0,0,0,0,0,0,0,101,120,99,101,112,116,78,97,109,101,67,108,97,115,115,32,97,108,108,111,119,115,32,111,110,108,121,32,97,32,115,105,110,103,108,101,32,101,120,99,101,112,116,32,110,111,100,101,10,0,0,0,0,0,0,0,120,109,108,82,101,108,97,120,78,71,80,97,114,115,101,69,108,101,109,101,110,116,58,32,101,108,101,109,101,110,116,32,104,97,115,32,110,111,32,99,104,105,108,100,114,101,110,10,0,0,0,0,0,0,0,0,120,109,108,82,101,108,97,120,78,71,80,97,114,115,101,69,108,101,109,101,110,116,58,32,101,108,101,109,101,110,116,32,104,97,115,32,110,111,32,99,111,110,116,101,110,116,10,0,82,78,71,32,73,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,115,116,97,114,116,32,102,111,117,110,100,32,105,110,32,101,108,101,109,101,110,116,10,0,0,0,0,0,82,78,71,32,73,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,112,97,114,97,109,32,102,111,117,110,100,32,105,110,32,101,108,101,109,101,110,116,10,0,0,0,0,0,82,78,71,32,73,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,101,120,99,101,112,116,32,102,111,117,110,100,32,105,110,32,101,108,101,109,101,110,116,10,0,0,0,0,82,78,71,32,73,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,110,111,111,112,32,102,111,117,110,100,32,105,110,32,101,108,101,109,101,110,116,10,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,112,97,114,115,101,32,60,103,114,97,109,109,97,114,62,32,99,111,110,116,101,110,116,10,0,0,0,0,0,0,69,108,101,109,101,110,116,32,60,103,114,97,109,109,97,114,62,32,104,97,115,32,110,111,32,60,115,116,97,114,116,62,10,0,0,0,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,110,111,32,103,114,97,109,109,97,114,32,105,110,32,67,104,101,99,107,82,101,102,101,114,101,110,99,101,32,37,115,10,0,0,0,0,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,114,101,102,101,114,101,110,99,101,32,104,97,115,32,99,111,110,116,101,110,116,32,105,110,32,67,104,101,99,107,82,101,102,101,114,101,110,99,101,32,37,115,10,0,0,0,0,0,82,101,102,101,114,101,110,99,101,32,37,115,32,104,97,115,32,110,111,32,109,97,116,99,104,105,110,103,32,100,101,102,105,110,105,116,105,111,110,10,0,0,0,0,0,0,0,0,99,111,109,98,105,110,101,0,68,101,102,105,110,101,115,32,102,111,114,32,37,115,32,117,115,101,32,98,111,116,104,32,39,99,104,111,105,99,101,39,32,97,110,100,32,39,105,110,116,101,114,108,101,97,118,101,39,10,0,0,0,0,0,0,68,101,102,105,110,101,115,32,102,111,114,32,37,115,32,117,115,101,32,117,110,107,110,111,119,110,32,99,111,109,98,105,110,101,32,118,97,108,117,101,32,39,37,115,39,39,10,0,83,111,109,101,32,100,101,102,105,110,101,115,32,102,111,114,32,37,115,32,110,101,101,100,115,32,116,104,101,32,99,111,109,98,105,110,101,32,97,116,116,114,105,98,117,116,101,10,0,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,105,110,116,101,114,108,101,97,118,101,115,32,104,97,115,104,32,116,97,98,108,101,10,0,0,0,0,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,115,116,97,114,116,32,101,108,101,109,101,110,116,32,110,111,116,32,102,111,117,110,100,10,0,0,0,0,0,0,0,0,60,115,116,97,114,116,62,32,117,115,101,32,98,111,116,104,32,39,99,104,111,105,99,101,39,32,97,110,100,32,39,105,110,116,101,114,108,101,97,118,101,39,10,0,0,0,0,0,60,115,116,97,114,116,62,32,117,115,101,115,32,117,110,107,110,111,119,110,32,99,111,109,98,105,110,101,32,118,97,108,117,101,32,39,37,115,39,39,10,0,0,0,0,0,0,0,83,111,109,101,32,60,115,116,97,114,116,62,32,101,108,101,109,101,110,116,32,109,105,115,115,32,116,104,101,32,99,111,109,98,105,110,101,32,97,116,116,114,105,98,117,116,101,10,0,0,0,0,0,0,0,0,103,114,97,109,109,97,114,32,104,97,115,32,110,111,32,99,104,105,108,100,114,101,110,10,0,0,0,0,0,0,0,0,100,101,102,105,110,101,0,0,105,110,99,108,117,100,101,0,103,114,97,109,109,97,114,32,104,97,115,32,117,110,101,120,112,101,99,116,101,100,32,99,104,105,108,100,32,37,115,10,0,0,0,0,0,0,0,0,73,110,99,108,117,100,101,32,110,111,100,101,32,104,97,115,32,110,111,32,100,97,116,97,10,0,0,0,0,0,0,0,73,110,99,108,117,100,101,32,100,111,99,117,109,101,110,116,32,105,115,32,101,109,112,116,121,10,0,0,0,0,0,0,73,110,99,108,117,100,101,32,100,111,99,117,109,101,110,116,32,114,111,111,116,32,105,115,32,110,111,116,32,97,32,103,114,97,109,109,97,114,10,0,100,101,102,105,110,101,32,104,97,115,32,110,111,32,110,97,109,101,10,0,0,0,0,0,100,101,102,105,110,101,32,110,97,109,101,32,39,37,115,39,32,105,115,32,110,111,116,32,97,110,32,78,67,78,97,109,101,10,0,0,0,0,0,0,100,101,102,105,110,101,32,104,97,115,32,110,111,32,99,104,105,108,100,114,101,110,10,0,67,111,117,108,100,32,110,111,116,32,99,114,101,97,116,101,32,100,101,102,105,110,105,116,105,111,110,32,104,97,115,104,10,0,0,0,0,0,0,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,32,111,110,32,100,101,102,105,110,101,32,97,103,103,114,101,103,97,116,105,111,110,32,111,102,32,37,115,10,0,0,0,0,0,101,108,101,109,101,110,116,32,37,115,32,100,111,101,115,110,39,116,32,97,108,108,111,119,32,102,111,114,101,105,103,110,32,101,108,101,109,101,110,116,115,10,0,0,0,0,0,0,104,114,101,102,0,0,0,0,120,109,108,82,101,108,97,120,78,71,80,97,114,115,101,58,32,101,120,116,101,114,110,97,108,82,101,102,32,104,97,115,32,110,111,32,104,114,101,102,32,97,116,116,114,105,98,117,116,101,10,0,0,0,0,0,73,110,99,111,114,114,101,99,116,32,85,82,73,32,102,111,114,32,101,120,116,101,114,110,97,108,82,101,102,32,37,115,10,0,0,0,0,0,0,0,70,114,97,103,109,101,110,116,32,102,111,114,98,105,100,100,101,110,32,105,110,32,85,82,73,32,102,111,114,32,101,120,116,101,114,110,97,108,82,101,102,32,37,115,10,0,0,0,70,97,105,108,101,100,32,116,111,32,99,111,109,112,117,116,101,32,85,82,76,32,102,111,114,32,101,120,116,101,114,110,97,108,82,101,102,32,37,115,10,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,108,111,97,100,32,101,120,116,101,114,110,97,108,82,101,102,32,37,115,10,0,0,120,109,108,82,101,108,97,120,78,71,80,97,114,115,101,58,32,105,110,99,108,117,100,101,32,104,97,115,32,110,111,32,104,114,101,102,32,97,116,116,114,105,98,117,116,101,10,0,70,97,105,108,101,100,32,116,111,32,99,111,109,112,117,116,101,32,85,82,76,32,102,111,114,32,105,110,99,108,117,100,101,32,37,115,10,0,0,0,70,97,105,108,101,100,32,116,111,32,108,111,97,100,32,105,110,99,108,117,100,101,32,37,115,10,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,97,32,110,97,109,101,32,37,115,32,101,108,101,109,101,110,116,10,0,0,0,0,0,120,109,108,82,101,108,97,120,78,71,80,97,114,115,101,58,32,110,111,32,110,97,109,101,115,112,97,99,101,32,102,111,114,32,112,114,101,102,105,120,32,37,115,10,0,0,0,0,70,111,117,110,100,32,110,115,78,97,109,101,47,101,120,99,101,112,116,47,47,110,115,78,97,109,101,32,102,111,114,98,105,100,100,101,110,32,99,111,110,115,116,114,117,99,116,10,0,0,0,0,0,0,0,0,70,111,117,110,100,32,97,110,121,78,97,109,101,47,101,120,99,101,112,116,47,47,97,110,121,78,97,109,101,32,102,111,114,98,105,100,100,101,110,32,99,111,110,115,116,114,117,99,116,10,0,0,0,0,0,0,70,111,117,110,100,32,110,115,78,97,109,101,47,101,120,99,101,112,116,47,47,97,110,121,78,97,109,101,32,102,111,114,98,105,100,100,101,110,32,99,111,110,115,116,114,117,99,116,10,0,0,0,0,0,0,0,100,105,118,0,0,0,0,0,68,101,116,101,99,116,101,100,32,97,110,32,73,110,99,108,117,100,101,32,114,101,99,117,114,115,105,111,110,32,102,111,114,32,37,115,10,0,0,0,120,109,108,82,101,108,97,120,78,71,58,32,99,111,117,108,100,32,110,111,116,32,108,111,97,100,32,37,115,10,0,0,97,108,108,111,99,97,116,105,110,103,32,105,110,99,108,117,100,101,10,0,0,0,0,0,120,109,108,82,101,108,97,120,78,71,58,32,105,110,99,108,117,100,101,100,32,100,111,99,117,109,101,110,116,32,105,115,32,101,109,112,116,121,32,37,115,10,0,0,0,0,0,0,120,109,108,82,101,108,97,120,78,71,58,32,105,110,99,108,117,100,101,100,32,100,111,99,117,109,101,110,116,32,37,115,32,114,111,111,116,32,105,115,32,110,111,116,32,97,32,103,114,97,109,109,97,114,10,0,120,109,108,82,101,108,97,120,78,71,58,32,105,110,99,108,117,100,101,32,37,115,32,104,97,115,32,97,32,115,116,97,114,116,32,98,117,116,32,110,111,116,32,116,104,101,32,105,110,99,108,117,100,101,100,32,103,114,97,109,109,97,114,10,0,0,0,0,0,0,0,0,120,109,108,82,101,108,97,120,78,71,58,32,105,110,99,108,117,100,101,32,37,115,32,104,97,115,32,100,101,102,105,110,101,32,119,105,116,104,111,117,116,32,110,97,109,101,10,0,120,109,108,82,101,108,97,120,78,71,58,32,105,110,99,108,117,100,101,32,37,115,32,104,97,115,32,97,32,100,101,102,105,110,101,32,37,115,32,98,117,116,32,110,111,116,32,116,104,101,32,105,110,99,108,117,100,101,100,32,103,114,97,109,109,97,114,10,0,0,0,0,68,101,116,101,99,116,101,100,32,97,110,32,101,120,116,101,114,110,97,108,82,101,102,32,114,101,99,117,114,115,105,111,110,32,102,111,114,32,37,115,10,0,0,0,0,0,0,0,120,109,108,82,101,108,97,120,78,71,58,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,32,102,111,114,32,100,111,99,32,37,115,10,0,97,100,100,105,110,103,32,100,111,99,117,109,101,110,116,10,0,0,0,0,0,0,0,0,65,116,116,114,105,98,117,116,101,32,37,115,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,32,111,110,32,37,115,10,0,0,0,0,0,0,65,116,116,114,105,98,117,116,101,32,37,115,32,99,111,110,116,97,105,110,115,32,105,110,118,97,108,105,100,32,85,82,73,32,37,115,10,0,0,0,65,116,116,114,105,98,117,116,101,32,37,115,32,85,82,73,32,37,115,32,105,115,32,110,111,116,32,97,98,115,111,108,117,116,101,10,0,0,0,0,65,116,116,114,105,98,117,116,101,32,37,115,32,85,82,73,32,37,115,32,104,97,115,32,97,32,102,114,97,103,109,101,110,116,32,73,68,10,0,0,85,110,107,110,111,119,110,32,97,116,116,114,105,98,117,116,101,32,37,115,32,111,110,32,37,115,10,0,0,0,0,0,115,116,114,105,110,103,0,0,116,111,107,101,110,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,49,47,88,77,76,83,99,104,101,109,97,0,0,0,0,0,0,0,0,109,105,110,73,110,99,108,117,115,105,118,101,0,0,0,0,109,105,110,69,120,99,108,117,115,105,118,101,0,0,0,0,109,97,120,73,110,99,108,117,115,105,118,101,0,0,0,0,109,97,120,69,120,99,108,117,115,105,118,101,0,0,0,0,116,111,116,97,108,68,105,103,105,116,115,0,0,0,0,0,102,114,97,99,116,105,111,110,68,105,103,105,116,115,0,0,112,97,116,116,101,114,110,0,101,110,117,109,101,114,97,116,105,111,110,0,0,0,0,0,119,104,105,116,101,83,112,97,99,101,0,0,0,0,0,0,108,101,110,103,116,104,0,0,109,97,120,76,101,110,103,116,104,0,0,0,0,0,0,0,109,105,110,76,101,110,103,116,104,0,0,0,0,0,0,0,82,101,108,97,120,45,78,71,32,116,121,112,101,115,32,108,105,98,114,97,114,121,32,39,37,115,39,32,97,108,114,101,97,100,121,32,114,101,103,105,115,116,101,114,101,100,10,0,97,100,100,105,110,103,32,116,121,112,101,115,32,108,105,98,114,97,114,121,10,0,0,0,82,101,108,97,120,45,78,71,32,116,121,112,101,115,32,108,105,98,114,97,114,121,32,102,97,105,108,101,100,32,116,111,32,114,101,103,105,115,116,101,114,32,39,37,115,39,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,109,108,83,65,88,50,73,110,116,101,114,110,97,108,83,117,98,115,101,116,0,0,0,120,109,108,83,65,88,50,69,120,116,101,114,110,97,108,83,117,98,115,101,116,0,0,0,69,110,116,105,116,121,40,37,115,41,32,100,111,99,117,109,101,110,116,32,109,97,114,107,101,100,32,115,116,97,110,100,97,108,111,110,101,32,98,117,116,32,114,101,113,117,105,114,101,115,32,101,120,116,101,114,110,97,108,32,115,117,98,115,101,116,10,0,0,0,0,0,70,97,105,108,117,114,101,32,116,111,32,112,114,111,99,101,115,115,32,101,110,116,105,116,121,32,37,115,10,0,0,0,69,110,116,105,116,121,40,37,115,41,32,97,108,114,101,97,100,121,32,100,101,102,105,110,101,100,32,105,110,32,116,104,101,32,105,110,116,101,114,110,97,108,32,115,117,98,115,101,116,10,0,0,0,0,0,0,69,110,116,105,116,121,40,37,115,41,32,97,108,114,101,97,100,121,32,100,101,102,105,110,101,100,32,105,110,32,116,104,101,32,101,120,116,101,114,110,97,108,32,115,117,98,115,101,116,10,0,0,0,0,0,0,83,65,88,46,120,109,108,83,65,88,50,69,110,116,105,116,121,68,101,99,108,40,37,115,41,32,99,97,108,108,101,100,32,119,104,105,108,101,32,110,111,116,32,105,110,32,115,117,98,115,101,116,10,0,0,0,120,109,108,58,105,100,0,0,120,109,108,58,105,100,32,58,32,97,116,116,114,105,98,117,116,101,32,116,121,112,101,32,115,104,111,117,108,100,32,98,101,32,73,68,10,0,0,0,83,65,88,46,120,109,108,83,65,88,50,65,116,116,114,105,98,117,116,101,68,101,99,108,40,37,115,41,32,99,97,108,108,101,100,32,119,104,105,108],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+187248),
allocate([101,32,110,111,116,32,105,110,32,115,117,98,115,101,116,10,0,0,0,0,0,0,0,0,83,65,88,46,120,109,108,83,65,88,50,69,108,101,109,101,110,116,68,101,99,108,40,37,115,41,32,99,97,108,108,101,100,32,119,104,105,108,101,32,110,111,116,32,105,110,32,115,117,98,115,101,116,10,0,0,83,65,88,46,120,109,108,83,65,88,50,78,111,116,97,116,105,111,110,68,101,99,108,40,37,115,41,32,101,120,116,101,114,110,97,108,73,68,32,111,114,32,80,117,98,108,105,99,73,68,32,109,105,115,115,105,110,103,10,0,0,0,0,0,83,65,88,46,120,109,108,83,65,88,50,78,111,116,97,116,105,111,110,68,101,99,108,40,37,115,41,32,99,97,108,108,101,100,32,119,104,105,108,101,32,110,111,116,32,105,110,32,115,117,98,115,101,116,10,0,83,65,88,46,120,109,108,83,65,88,50,85,110,112,97,114,115,101,100,69,110,116,105,116,121,68,101,99,108,40,37,115,41,32,99,97,108,108,101,100,32,119,104,105,108,101,32,110,111,116,32,105,110,32,115,117,98,115,101,116,10,0,0,0,120,109,108,83,65,88,50,83,116,97,114,116,68,111,99,117,109,101,110,116,0,0,0,0,86,97,108,105,100,97,116,105,111,110,32,102,97,105,108,101,100,58,32,110,111,32,68,84,68,32,102,111,117,110,100,32,33,0,0,0,0,0,0,0,120,109,108,83,65,88,50,83,116,97,114,116,69,108,101,109,101,110,116,0,0,0,0,0,78,97,109,101,115,112,97,99,101,32,112,114,101,102,105,120,32,37,115,32,105,115,32,110,111,116,32,100,101,102,105,110,101,100,10,0,0,0,0,0,120,109,108,83,65,88,50,83,116,97,114,116,69,108,101,109,101,110,116,78,115,0,0,0,120,109,108,0,0,0,0,0,78,97,109,101,115,112,97,99,101,32,112,114,101,102,105,120,32,37,115,32,119,97,115,32,110,111,116,32,102,111,117,110,100,10,0,0,0,0,0,0,78,97,109,101,115,112,97,99,101,32,100,101,102,97,117,108,116,32,112,114,101,102,105,120,32,119,97,115,32,110,111,116,32,102,111,117,110,100,10,0,120,109,108,83,65,88,50,67,104,97,114,97,99,116,101,114,115,0,0,0,0,0,0,0,120,109,108,83,65,88,50,67,104,97,114,97,99,116,101,114,115,58,32,120,109,108,83,116,114,100,117,112,32,114,101,116,117,114,110,101,100,32,78,85,76,76,0,0,0,0,0,0,120,109,108,83,65,88,50,67,104,97,114,97,99,116,101,114,115,58,32,104,117,103,101,32,116,101,120,116,32,110,111,100,101,0,0,0,0,0,0,0,120,109,108,83,65,88,50,67,104,97,114,97,99,116,101,114,115,32,111,118,101,114,102,108,111,119,32,112,114,101,118,101,110,116,101,100,0,0,0,0,2,0,0,0,0,0,0,0,120,109,108,83,65,88,50,84,101,120,116,78,111,100,101,0,120,109,108,83,65,88,50,65,116,116,114,105,98,117,116,101,78,115,0,0,0,0,0,0,120,109,108,58,105,100,32,58,32,97,116,116,114,105,98,117,116,101,32,118,97,108,117,101,32,37,115,32,105,115,32,110,111,116,32,97,110,32,78,67,78,97,109,101,10,0,0,0,120,109,108,110,115,0,0,0,105,110,118,97,108,105,100,32,110,97,109,101,115,112,97,99,101,32,100,101,99,108,97,114,97,116,105,111,110,32,39,37,115,39,10,0,0,0,0,0,65,118,111,105,100,32,97,116,116,114,105,98,117,116,101,32,101,110,100,105,110,103,32,119,105,116,104,32,39,58,39,32,108,105,107,101,32,39,37,115,39,10,0,0,0,0,0,0,120,109,108,110,115,58,32,37,115,32,110,111,116,32,97,32,118,97,108,105,100,32,85,82,73,10,0,0,0,0,0,0,120,109,108,110,115,58,32,85,82,73,32,37,115,32,105,115,32,110,111,116,32,97,98,115,111,108,117,116,101,10,0,0,69,109,112,116,121,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,32,102,111,114,32,112,114,101,102,105,120,32,37,115,10,0,0,0,0,0,120,109,108,110,115,58,37,115,58,32,37,115,32,110,111,116,32,97,32,118,97,108,105,100,32,85,82,73,10,0,0,0,120,109,108,110,115,58,37,115,58,32,85,82,73,32,37,115,32,105,115,32,110,111,116,32,97,98,115,111,108,117,116,101,10,0,0,0,0,0,0,0,78,97,109,101,115,112,97,99,101,32,112,114,101,102,105,120,32,37,115,32,111,102,32,97,116,116,114,105,98,117,116,101,32,37,115,32,105,115,32,110,111,116,32,100,101,102,105,110,101,100,10,0,0,0,0,0,65,116,116,114,105,98,117,116,101,32,37,115,32,105,110,32,37,115,32,114,101,100,101,102,105,110,101,100,10,0,0,0,58,0,0,0,0,0,0,0,115,116,97,110,100,97,108,111,110,101,58,32,97,116,116,114,105,98,117,116,101,32,37,115,32,111,110,32,37,115,32,100,101,102,97,117,108,116,101,100,32,102,114,111,109,32,101,120,116,101,114,110,97,108,32,115,117,98,115,101,116,10,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,10,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,49,1,52,1,62,1,65,1,72,1,74,1,126,1,128,1,195,1,205,1,240,1,244,1,245,1,250,1,23,2,80,2,168,2,187,2,193,2,134,3,134,3,136,3,138,3,140,3,140,3,142,3,161,3,163,3,206,3,208,3,214,3,218,3,218,3,220,3,220,3,222,3,222,3,224,3,224,3,226,3,243,3,1,4,12,4,14,4,79,4,81,4,92,4,94,4,129,4,144,4,196,4,199,4,200,4,203,4,204,4,208,4,235,4,238,4,245,4,248,4,249,4,49,5,86,5,89,5,89,5,97,5,134,5,208,5,234,5,240,5,242,5,33,6,58,6,65,6,74,6,113,6,183,6,186,6,190,6,192,6,206,6,208,6,211,6,213,6,213,6,229,6,230,6,5,9,57,9,61,9,61,9,88,9,97,9,133,9,140,9,143,9,144,9,147,9,168,9,170,9,176,9,178,9,178,9,182,9,185,9,220,9,221,9,223,9,225,9,240,9,241,9,5,10,10,10,15,10,16,10,19,10,40,10,42,10,48,10,50,10,51,10,53,10,54,10,56,10,57,10,89,10,92,10,94,10,94,10,114,10,116,10,133,10,139,10,141,10,141,10,143,10,145,10,147,10,168,10,170,10,176,10,178,10,179,10,181,10,185,10,189,10,189,10,224,10,224,10,5,11,12,11,15,11,16,11,19,11,40,11,42,11,48,11,50,11,51,11,54,11,57,11,61,11,61,11,92,11,93,11,95,11,97,11,133,11,138,11,142,11,144,11,146,11,149,11,153,11,154,11,156,11,156,11,158,11,159,11,163,11,164,11,168,11,170,11,174,11,181,11,183,11,185,11,5,12,12,12,14,12,16,12,18,12,40,12,42,12,51,12,53,12,57,12,96,12,97,12,133,12,140,12,142,12,144,12,146,12,168,12,170,12,179,12,181,12,185,12,222,12,222,12,224,12,225,12,5,13,12,13,14,13,16,13,18,13,40,13,42,13,57,13,96,13,97,13,1,14,46,14,48,14,48,14,50,14,51,14,64,14,69,14,129,14,130,14,132,14,132,14,135,14,136,14,138,14,138,14,141,14,141,14,148,14,151,14,153,14,159,14,161,14,163,14,165,14,165,14,167,14,167,14,170,14,171,14,173,14,174,14,176,14,176,14,178,14,179,14,189,14,189,14,192,14,196,14,64,15,71,15,73,15,105,15,160,16,197,16,208,16,246,16,0,17,0,17,2,17,3,17,5,17,7,17,9,17,9,17,11,17,12,17,14,17,18,17,60,17,60,17,62,17,62,17,64,17,64,17,76,17,76,17,78,17,78,17,80,17,80,17,84,17,85,17,89,17,89,17,95,17,97,17,99,17,99,17,101,17,101,17,103,17,103,17,105,17,105,17,109,17,110,17,114,17,115,17,117,17,117,17,158,17,158,17,168,17,168,17,171,17,171,17,174,17,175,17,183,17,184,17,186,17,186,17,188,17,194,17,235,17,235,17,240,17,240,17,249,17,249,17,0,30,155,30,160,30,249,30,0,31,21,31,24,31,29,31,32,31,69,31,72,31,77,31,80,31,87,31,89,31,89,31,91,31,91,31,93,31,93,31,95,31,125,31,128,31,180,31,182,31,188,31,190,31,190,31,194,31,196,31,198,31,204,31,208,31,211,31,214,31,219,31,224,31,236,31,242,31,244,31,246,31,252,31,38,33,38,33,42,33,43,33,46,33,46,33,128,33,130,33,65,48,148,48,161,48,250,48,5,49,44,49,0,172,163,215,0,0,0,0,197,0,0,0,0,0,0,0,40,9,3,0,0,0,0,0,0,3,69,3,96,3,97,3,131,4,134,4,145,5,161,5,163,5,185,5,187,5,189,5,191,5,191,5,193,5,194,5,196,5,196,5,75,6,82,6,112,6,112,6,214,6,220,6,221,6,223,6,224,6,228,6,231,6,232,6,234,6,237,6,1,9,3,9,60,9,60,9,62,9,76,9,77,9,77,9,81,9,84,9,98,9,99,9,129,9,131,9,188,9,188,9,190,9,190,9,191,9,191,9,192,9,196,9,199,9,200,9,203,9,205,9,215,9,215,9,226,9,227,9,2,10,2,10,60,10,60,10,62,10,62,10,63,10,63,10,64,10,66,10,71,10,72,10,75,10,77,10,112,10,113,10,129,10,131,10,188,10,188,10,190,10,197,10,199,10,201,10,203,10,205,10,1,11,3,11,60,11,60,11,62,11,67,11,71,11,72,11,75,11,77,11,86,11,87,11,130,11,131,11,190,11,194,11,198,11,200,11,202,11,205,11,215,11,215,11,1,12,3,12,62,12,68,12,70,12,72,12,74,12,77,12,85,12,86,12,130,12,131,12,190,12,196,12,198,12,200,12,202,12,205,12,213,12,214,12,2,13,3,13,62,13,67,13,70,13,72,13,74,13,77,13,87,13,87,13,49,14,49,14,52,14,58,14,71,14,78,14,177,14,177,14,180,14,185,14,187,14,188,14,200,14,205,14,24,15,25,15,53,15,53,15,55,15,55,15,57,15,57,15,62,15,62,15,63,15,63,15,113,15,132,15,134,15,139,15,144,15,149,15,151,15,151,15,153,15,173,15,177,15,183,15,185,15,185,15,208,32,220,32,225,32,225,32,42,48,47,48,153,48,153,48,154,48,154,48,0,0,0,0,95,0,0,0,0,0,0,0,80,12,3,0,0,0,0,0,96,6,105,6,240,6,249,6,102,9,111,9,230,9,239,9,102,10,111,10,230,10,239,10,102,11,111,11,231,11,239,11,102,12,111,12,230,12,239,12,102,13,111,13,80,14,89,14,208,14,217,14,32,15,41,15,14,0,0,0,0,0,0,0,224,13,3,0,0,0,0,0,208,2,208,2,209,2,209,2,135,3,135,3,64,6,64,6,70,14,70,14,198,14,198,14,5,48,5,48,49,48,53,48,157,48,158,48,252,48,254,48,10,0,0,0,0,0,0,0,40,14,3,0,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,99,104,105,108,100,0,0,0,97,116,116,114,105,98,117,116,101,0,0,0,0,0,0,0,45,47,47,87,51,67,47,47,68,84,68,32,88,72,84,77,76,32,49,46,48,32,83,116,114,105,99,116,47,47,69,78,0,0,0,0,0,0,0,0,45,47,47,87,51,67,47,47,68,84,68,32,88,72,84,77,76,32,49,46,48,32,70,114,97,109,101,115,101,116,47,47,69,78,0,0,0,0,0,0,45,47,47,87,51,67,47,47,68,84,68,32,88,72,84,77,76,32,49,46,48,32,84,114,97,110,115,105,116,105,111,110,97,108,47,47,69,78,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,84,82,47,120,104,116,109,108,49,47,68,84,68,47,120,104,116,109,108,49,45,115,116,114,105,99,116,46,100,116,100,0,0,0,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,84,82,47,120,104,116,109,108,49,47,68,84,68,47,120,104,116,109,108,49,45,102,114,97,109,101,115,101,116,46,100,116,100,0,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,84,82,47,120,104,116,109,108,49,47,68,84,68,47,120,104,116,109,108,49,45,116,114,97,110,115,105,116,105,111,110,97,108,46,100,116,100,0,38,35,49,48,59,0,0,0,38,35,49,51,59,0,0,0,38,35,57,59,0,0,0,0,38,113,117,111,116,59,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,38,97,109,112,59,0,0,0,73,83,79,45,56,56,53,57,45,49,0,0,0,0,0,0,99,114,101,97,116,105,110,103,32,98,117,102,102,101,114,0,85,84,70,45,56,0,0,0,99,114,101,97,116,105,110,103,32,111,117,116,112,117,116,0,60,63,0,0,0,0,0,0,32,0,0,0,0,0,0,0,63,62,0,0,0,0,0,0,60,33,45,45,0,0,0,0,45,45,62,0,0,0,0,0,38,0,0,0,0,0,0,0,59,0,0,0,0,0,0,0,60,33,91,67,68,65,84,65,91,93,93,62,0,0,0,0,60,33,91,67,68,65,84,65,91,0,0,0,0,0,0,0,93,93,62,0,0,0,0,0,60,0,0,0,0,0,0,0,58,0,0,0,0,0,0,0,104,116,109,108,0,0,0,0,32,120,109,108,110,115,61,34,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,49,57,57,57,47,120,104,116,109,108,34,0,0,0,104,101,97,100,0,0,0,0,109,101,116,97,0,0,0,0,104,116,116,112,45,101,113,117,105,118,0,0,0,0,0,0,67,111,110,116,101,110,116,45,84,121,112,101,0,0,0,0,32,47,62,0,0,0,0,0,62,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,60,109,101,116,97,32,104,116,116,112,45,101,113,117,105,118,61,34,67,111,110,116,101,110,116,45,84,121,112,101,34,32,99,111,110,116,101,110,116,61,34,116,101,120,116,47,104,116,109,108,59,32,99,104,97,114,115,101,116,61,0,0,0,0,34,32,47,62,0,0,0,0,60,47,0,0,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,49,57,57,57,47,120,104,116,109,108,0,0,0,0,97,114,101,97,0,0,0,0,98,114,0,0,0,0,0,0,98,97,115,101,0,0,0,0,98,97,115,101,102,111,110,116,0,0,0,0,0,0,0,0,99,111,108,0,0,0,0,0,102,114,97,109,101,0,0,0,104,114,0,0,0,0,0,0,105,109,103,0,0,0,0,0,105,110,112,117,116,0,0,0,105,115,105,110,100,101,120,0,108,105,110,107,0,0,0,0,112,97,114,97,109,0,0,0,105,100,0,0,0,0,0,0,110,97,109,101,0,0,0,0,108,97,110,103,0,0,0,0,120,109,108,0,0,0,0,0,97,0,0,0,0,0,0,0,112,0,0,0,0,0,0,0,100,105,118,0,0,0,0,0,109,97,112,0,0,0,0,0,97,112,112,108,101,116,0,0,102,111,114,109,0,0,0,0,105,102,114,97,109,101,0,0,32,105,100,61,34,0,0,0,34,0,0,0,0,0,0,0,32,120,109,108,58,108,97,110,103,61,34,0,0,0,0,0,32,108,97,110,103,61,34,0,61,34,0,0,0,0,0,0,60,33,68,79,67,84,89,80,69,32,0,0,0,0,0,0,32,80,85,66,76,73,67,32,0,0,0,0,0,0,0,0,32,83,89,83,84,69,77,32,0,0,0,0,0,0,0,0,32,91,10,0,0,0,0,0,93,62,0,0,0,0,0,0,120,109,108,69,115,99,97,112,101,69,110,116,105,116,105,101,115,32,58,32,99,104,97,114,32,111,117,116,32,111,102,32,114,97,110,103,101,10,0,0,115,116,114,105,110,103,32,105,115,32,110,111,116,32,105,110,32,85,84,70,45,56,10,0,105,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,118,97,108,117,101,10,0,0,0,0,0,0,0,0,117,110,107,110,111,119,110,32,101,110,99,111,100,105,110,103,32,37,115,10,0,0,0,0,100,111,99,117,109,101,110,116,32,104,97,115,32,110,111,32,68,79,67,84,89,80,69,10,0,0,0,0,0,0,0,0,117,110,101,120,112,101,99,116,101,100,32,101,114,114,111,114,32,110,117,109,98,101,114,10,0,0,0,0,0,0,0,0,47,62,0,0,0,0,0,0,72,84,77,76,0,0,0,0,99,114,101,97,116,105,110,103,32,101,110,99,111,100,105,110,103,32,98,117,102,102,101,114,0,0,0,0,0,0,0,0,60,63,120,109,108,32,118,101,114,115,105,111,110,61,0,0,34,49,46,48,34,0,0,0,32,101,110,99,111,100,105,110,103,61,0,0,0,0,0,0,32,115,116,97,110,100,97,108,111,110,101,61,34,110,111,34,0,0,0,0,0,0,0,0,32,115,116,97,110,100,97,108,111,110,101,61,34,121,101,115,34,0,0,0,0,0,0,0,63,62,10,0,0,0,0,0,99,114,101,97,116,105,110,103,32,115,97,118,105,110,103,32,99,111,110,116,101,120,116,0,120,109,108,110,115,58,0,0,120,109,108,110,115,0,0,0,61,0,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,115,99,104,101,109,97,32,112,97,114,115,101,114,32,99,111,110,116,101,120,116,0,0,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,115,99,104,101,109,97,32,112,97,114,115,101,114,32,88,80,97,116,104,32,99,111,110,116,101,120,116,0,0,120,109,108,83,99,104,101,109,97,116,114,111,110,80,97,114,115,101,58,32,99,111,117,108,100,32,110,111,116,32,108,111,97,100,32,39,37,115,39,46,10,0,0,0,0,0,0,0,120,109,108,83,99,104,101,109,97,116,114,111,110,80,97,114,115,101,58,32,99,111,117,108,100,32,110,111,116,32,112,97,114,115,101,46,10,0,0,0,105,110,95,109,101,109,111,114,121,95,98,117,102,102,101,114,0,0,0,0,0,0,0,0,84,104,101,32,115,99,104,101,109,97,32,104,97,115,32,110,111,32,100,111,99,117,109,101,110,116,32,101,108,101,109,101,110,116,46,10,0,0,0,0,115,99,104,101,109,97,0,0,96,25,3,0,0,0,0,0,56,25,3,0,0,0,0,0,84,104,101,32,88,77,76,32,100,111,99,117,109,101,110,116,32,39,37,115,39,32,105,115,32,110,111,116,32,97,32,88,77,76,32,115,99,104,101,109,97,116,114,111,110,32,100,111,99,117,109,101,110,116,0,0,116,105,116,108,101,0,0,0,110,115,0,0,0,0,0,0,112,114,101,102,105,120,0,0,117,114,105,0,0,0,0,0,110,115,32,101,108,101,109,101,110,116,32,104,97,115,32,110,111,32,117,114,105,0,0,0,110,115,32,101,108,101,109,101,110,116,32,104,97,115,32,110,111,32,112,114,101,102,105,120,0,0,0,0,0,0,0,0,112,97,116,116,101,114,110,0,69,120,112,101,99,116,105,110,103,32,97,32,112,97,116,116,101,114,110,32,101,108,101,109,101,110,116,32,105,110,115,116,101,97,100,32,111,102,32,37,115,0,0,0,0,0,0,0,84,104,101,32,115,99,104,101,109,97,116,114,111,110,32,100,111,99,117,109,101,110,116,32,39,37,115,39,32,104,97,115,32,110,111,32,112,97,116,116,101,114,110,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,118,97,108,105,100,97,116,105,111,110,32,99,111,110,116,101,120,116,0,0,0,85,110,105,109,112,108,101,109,101,110,116,101,100,32,98,108,111,99,107,32,97,116,32,37,115,58,37,100,10,0,0,0,46,46,47,108,105,98,120,109,108,50,47,115,99,104,101,109,97,116,114,111,110,46,99,0,80,97,116,116,101,114,110,58,32,37,115,10,0,0,0,0,37,115,0,0,0,0,0,0,110,111,100,101,32,102,97,105,108,101,100,32,97,115,115,101,114,116,0,0,0,0,0,0,110,111,100,101,32,102,97,105,108,101,100,32,114,101,112,111,114,116,0,0,0,0,0,0,37,115,32,108,105,110,101,32,37,108,100,58,32,37,115,10,0,0,0,0,0,0,0,0,110,97,109,101,0,0,0,0,112,97,116,104,0,0,0,0,58,0,0,0,0,0,0,0,105,100,0,0,0,0,0,0,114,117,108,101,0,0,0,0,69,120,112,101,99,116,105,110,103,32,97,32,114,117,108,101,32,101,108,101,109,101,110,116,32,105,110,115,116,101,97,100,32,111,102,32,37,115,0,0,80,97,116,116,101,114,110,32,104,97,115,32,110,111,32,114,117,108,101,32,101,108,101,109,101,110,116,0,0,0,0,0,99,111,110,116,101,120,116,0,114,117,108,101,32,104,97,115,32,110,111,32,99,111,110,116,101,120,116,32,97,116,116,114,105,98,117,116,101,0,0,0,114,117,108,101,32,104,97,115,32,97,110,32,101,109,112,116,121,32,99,111,110,116,101,120,116,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,97,115,115,101,114,116,0,0,116,101,115,116,0,0,0,0,97,115,115,101,114,116,32,104,97,115,32,110,111,32,116,101,115,116,32,97,116,116,114,105,98,117,116,101,0,0,0,0,97,115,115,101,114,116,32,104,97,115,32,97,110,32,101,109,112,116,121,32,116,101,115,116,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,0,114,101,112,111,114,116,0,0,69,120,112,101,99,116,105,110,103,32,97,110,32,97,115,115,101,114,116,32,111,114,32,97,32,114,101,112,111,114,116,32,101,108,101,109,101,110,116,32,105,110,115,116,101,97,100,32,111,102,32,37,115,0,0,0,114,117,108,101,32,104,97,115,32,110,111,32,97,115,115,101,114,116,32,110,111,114,32,114,101,112,111,114,116,32,101,108,101,109,101,110,116,0,0,0,70,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,32,116,101,115,116,32,101,120,112,114,101,115,115,105,111,110,32,37,115,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,115,99,104,101,109,97,32,116,101,115,116,0,0,70,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,32,99,111,110,116,101,120,116,32,101,120,112,114,101,115,115,105,111,110,32,37,115,0,97,108,108,111,99,97,116,105,110,103,32,115,99,104,101,109,97,32,114,117,108,101,0,0,97,108,108,111,99,97,116,105,110,103,32,115,99,104,101,109,97,32,112,97,116,116,101,114,110,0,0,0,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,112,97,114,115,101,114,32,110,97,109,101,115,112,97,99,101,115,0,0,0,0,97,108,108,111,99,97,116,105,110,103,32,115,99,104,101,109,97,0,0,0,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,97,115,99,99,46,110,101,116,47,120,109,108,47,115,99,104,101,109,97,116,114,111,110,0,0,0,0,0,0,104,116,116,112,58,47,47,112,117,114,108,46,111,99,108,99,46,111,114,103,47,100,115,100,108,47,115,99,104,101,109,97,116,114,111,110,0,0,0,0,67,97,110,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,109,101,109,111,114,121,32,102,111,114,32,108,105,115,116,0,0,0,0,0,0,0,67,97,110,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,109,101,109,111,114,121,32,102,111,114,32,115,101,110,116,105,110,101,108,0,0,0,67,97,110,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,109,101,109,111,114,121,32,102,111,114,32,110,101,119,32,108,105,110,107,0,0,0,117,116,102,56,0,0,200,119,99,104,97,114,116,0,0,198,117,99,115,50,0,117,99,115,50,98,101,0,0,196,117,99,115,50,108,101,0,0,197,117,116,102,49,54,0,117,116,102,49,54,98,101,0,0,194,117,116,102,49,54,108,101,0,0,193,117,99,115,52,0,117,99,115,52,98,101,0,117,116,102,51,50,0,117,116,102,51,50,98,101,0,0,192,117,99,115,52,108,101,0,117,116,102,51,50,108,101,0,0,195,97,115,99,105,105,0,117,115,97,115,99,105,105,0,105,115,111,54,52,54,0,105,115,111,54,52,54,117,115,0,0,199,101,117,99,106,112,0,0,208,115,104,105,102,116,106,105,115,0,115,106,105,115,0,0,209,103,98,49,56,48,51,48,0,0,216,103,98,107,0,0,217,103,98,50,51,49,50,0,0,218,98,105,103,53,0,98,105,103,102,105,118,101,0,99,112,57,53,48,0,98,105,103,53,104,107,115,99,115,0,0,224,101,117,99,107,114,0,107,115,99,53,54,48,49,0,107,115,120,49,48,48,49,0,99,112,57,52,57,0,0,232,105,115,111,56,56,53,57,49,0,108,97,116,105,110,49,0,0,128,105,115,111,56,56,53,57,50,0,0,32,0,84,0,137,18,0,32,1,6,0,0,152,65,134,26,127,0,48,72,32,0,88,32,201,18,0,36,17,198,35,0,156,81,198,26,128,80,66,136,32,90,0,0,192,4,0,16,113,1,0,29,0,112,2,0,41,0,0,192,7,33,48,1,5,0,0,88,1,0,0,94,208,1,128,29,0,0,128,6,0,91,0,0,0,5,0,20,129,1,0,30,0,128,2,0,42,0,0,0,8,34,52,17,5,0,0,92,1,0,0,95,212,1,192,29,0,0,144,70,36,105,115,111,56,56,53,57,51,0,0,32,0,212,0,9,0,0,4,48,3,0,0,244,64,70,11,63,0,16,64,32,0,216,0,0,0,0,0,64,3,0,0,248,80,134,11,64,0,16,128,32,0,0,0,64,0,0,108,144,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,188,0,0,0,43,0,0,0,0,0,200,33,6,0,0,0,0,64,0,0,112,160,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,192,0,0,0,44,0,0,0,0,0,204,49,70,36,105,115,111,56,56,53,57,52,0,0,32,0,84,48,4,23,0,220,96,4,0,0,152,49,66,12,108,0,48,8,0,0,88,32,73,23,0,224,112,196,35,0,156,65,130,12,109,72,65,200,20,17,0,0,0,0,0,0,0,192,14,29,0,112,2,0,37,0,0,64,14,33,56,65,69,16,0,0,0,0,0,0,224,1,0,0,0,184,1,7,0,18,0,0,0,0,0,0,0,0,15,30,0,128,2,0,38,0,0,128,14,34,60,81,133,16,0,0,0,0,0,0,228,1,0,0,0,188,17,71,36,105,115,111,56,56,53,57,53,0,0,32,0,136,51,14,57,229,152,115,14,58,233,168,179,14,59,237,0,224,206,59,240,196,35,207,60,244,212,99,207,61,248,228,163,207,62,252,244,227,207,63,0,5,36,208,64,4,21,100,208,65,8,37,164,208,66,12,53,228,208,67,16,69,36,209,68,20,85,100,209,69,24,101,164,209,70,28,117,228,209,71,32,133,36,210,72,36,149,100,210,73,40,165,164,210,74,44,181,228,210,75,53,194,20,147,76,51,209,84,147,77,55,225,148,147,78,59,13,192,83,79,105,115,111,56,56,53,57,54,0,0,32,0,4,16,64,0,0,4,16,64,0,1,4,16,64,0,115,1,16,64,0,1,4,16,64,0,1,4,16,64,0,1,4,16,0,93,1,4,16,64,93,1,216,117,23,94,121,233,181,23,95,125,249,245,23,96,129,9,54,24,97,133,25,118,24,98,137,41,182,24,99,141,57,246,88,0,1,4,16,64,0,144,69,38,217,100,148,85,102,217,101,152,101,166,217,102,156,117,230,217,103,160,133,38,90,0,1,4,16,64,0,1,4,16,64,0,1,4,16,64,0,105,115,111,56,56,53,57,55,0,0,32,0,144,88,34,0,51,210,8,0,0,0,0,160,9,0,0,0,16,128,136,0,0,0,0,0,155,112,210,9,0,158,124,2,10,0,161,0,32,202,40,164,148,98,202,41,168,164,162,202,42,172,180,226,202,43,176,196,34,203,44,180,212,18,128,45,183,224,146,139,46,187,240,210,139,47,191,0,19,140,48,195,16,83,140,49,199,32,147,140,50,203,48,211,140,51,207,64,19,141,52,211,80,83,141,53,215,96,147,141,54,219,112,211,141,55,223,128,19,78,0,105,115,111,56,56,53,57,56,0,0,32,0,4,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,0,0,0,0,0,64,0,1,4,16,64,0,1,4,16,64,0,1,4,16,64,0,1,4,16,64,0,1,4,16,64,0,1,4,16,64,0,1,4,16,64,0,1,4,16,192,136,83,81,85,149,85,87,97,149,149,86,91,113,213,149,87,95,129,21,150,88,99,145,85,150,89,103,161,149,150,90,107,177,213,86,0,1,120,248,97,0,105,115,111,56,56,53,57,57,0,0,80,45,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,244,64,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,80,6,0,105,115,111,56,56,53,57,49,48,0,0,32,0,84,48,66,12,57,220,16,4,0,70,132,96,6,27,131,0,0,135,20,0,88,64,130,12,58,224,32,4,0,71,136,112,70,27,132,136,24,199,20,17,0,0,0,0,0,0,0,192,14,29,0,112,2,0,37,0,0,0,0,0,56,65,5,0,0,0,0,128,27,0,224,1,0,0,0,0,0,0,0,18,0,0,0,0,0,0,0,0,15,30,0,128,2,0,38,0,0,0,0,0,60,81,5,0,0,0,0,192,27,0,228,1,0,0,0,0,0,192,16,105,115,111,56,56,53,57,49,49,0,116,105,115,54,50,48,0,0,32,0,188,6,91,108,178,205,70,91,109,182,221,134,91,110,186,237,198,91,111,190,253,6,92,112,194,13,71,92,113,198,29,135,92,114,202,45,199,92,115,206,61,7,93,116,210,77,71,93,117,214,93,135,93,118,218,109,199,93,119,222,125,7,94,120,226,141,71,94,121,230,157,135,94,0,1,4,16,64,122,234,173,199,94,123,238,189,7,95,124,242,205,71,95,125,246,221,135,95,126,250,237,199,95,127,254,253,7,96,128,2,14,72,96,129,1,4,16,64,0,105,115,111,56,56,53,57,49,51,0,0,32,0,160,8,0,0,0,164,8,0,0,13,0,192,5,0,0,0,0,192,2,0,0,0,0,0,39,2,0,0,0,16,0,208,5,0,0,0,0,128,3,21,236,16,193,5,0,0,112,194,8,29,0,240,71,9,49,4,145,131,17,102,48,225,4,0,84,0,0,0,0,120,40,1,6,28,0,4,50,8,0,22,240,32,1,6,0,0,128,2,9,30,0,0,136,9,50,8,161,195,17,103,52,241,4,0,85,0,0,0,0,121,44,17,70,28,0,8,66,72,137,105,115,111,56,56,53,57,49,52,0,0,32,0,24,120,32,0,27,112,128,32,0,20,2,96,97,130,26,2,0,128,31,10,46,248,2,12,12,54,8,128,131,21,62,120,33,132,27,98,152,97,132,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,122,0,0,0,0,0,0,0,128,132,0,0,0,0,0,0,0,192,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,123,0,0,0,0,0,0,0,192,132,0,0,0,0,0,0,0,208,7,0,105,115,111,56,56,53,57,49,53,0,108,97,116,105,110,57,0,0,36,51,2,96,6,0,103,0,0,0,0,0,0,0,0,0,0,0,0,0,0,131,0,0,0,0,132,0,0,0,0,88,100,225,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,105,115,111,56,56,53,57,49,54,0,0,32,0,84,96,129,18,51,166,104,6,0,103,0,160,8,0,127,0,0,72,32,0,0,208,193,18,131,160,8,0,0,132,120,176,8,0,88,100,225,135,32,0,0,0,192,4,0,92,0,0,0,0,0,0,0,0,0,0,0,0,0,33,48,1,0,0,0,88,1,0,24,118,0,0,0,0,0,156,192,8,0,0,0,0,0,5,0,96,0,0,0,0,0,0,0,0,0,0,0,0,0,34,52,1,0,0,0,92,1,64,24,119,0,0,0,0,0,160,208,8,0,99,112,49,50,53,48,0,119,105,110,100,111,119,115,49,50,53,48,0,0,0,51,6,96,98,0,41,182,168,226,138,1,184,104,198,139,96,168,49,200,31,1,144,88,226,137,40,178,8,98,136,1,216,120,6,140,97,172,65,8,32,0,60,2,137,18,0,84,0,0,0,0,0,64,6,0,0,0,0,64,32,0,0,32,201,18,0,0,0,0,0,0,88,80,6,0,72,80,146,132,32,90,0,0,192,4,0,16,113,1,0,29,0,112,2,0,41,0,0,192,7,33,48,1,5,0,0,88,1,0,0,94,208,1,128,29,0,0,128,6,0,91,0,0,0,5,0,20,129,1,0,30,0,128,2,0,42,0,0,0,8,34,52,17,5,0,0,92,1,0,0,95,212,1,192,29,0,0,144,70,36,99,112,49,50,53,49,0,119,105,110,100,111,119,115,49,50,53,49,0,0,0,227,144,99,162,76,41,182,168,226,138,51,186,168,206,139,235,180,195,206,59,49,145,88,226,137,40,178,8,98,136,1,216,136,19,140,57,237,164,83,79,0,184,195,83,58,0,248,4,0,0,226,0,80,14,0,0,0,0,0,58,0,0,112,78,77,63,1,0,0,0,48,213,56,19,0,55,153,67,147,77,240,196,35,207,60,244,212,99,207,61,248,228,163,207,62,252,244,227,207,63,0,5,36,208,64,4,21,100,208,65,8,37,164,208,66,12,53,228,208,67,16,69,36,209,68,20,85,100,209,69,24,101,164,209,70,28,117,228,209,71,32,133,36,210,72,36,149,100,210,73,40,165,164,210,74,44,181,228,210,75,99,112,49,50,53,50,0,119,105,110,100,111,119,115,49,50,53,50,0,0,0,51,6,96,98,33,41,182,168,226,138,142,184,104,198,139,88,4,48,72,0,1,144,88,226,137,40,178,8,98,136,147,216,120,6,140,89,4,64,136,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,99,112,49,50,53,51,0,119,105,110,100,111,119,115,49,50,53,51,0,0,0,51,6,96,98,33,41,182,168,226,138,1,184,24,192,139,1,4,16,64,0,1,144,88,226,137,40,178,8,98,136,1,216,24,0,140,1,4,16,64,0,0,112,210,9,0,0,0,0,0,0,0,0,16,0,0,0,0,0,128,136,0,0,0,0,0,155,0,0,0,0,158,124,2,10,0,161,0,32,202,40,164,148,98,202,41,168,164,162,202,42,172,180,226,202,43,176,196,34,203,44,180,212,18,128,45,183,224,146,139,46,187,240,210,139,47,191,0,19,140,48,195,16,83,140,49,199,32,147,140,50,203,48,211,140,51,207,64,19,141,52,211,80,83,141,53,215,96,147,141,54,219,112,211,141,55,223,128,19,78,0,99,112,49,50,53,52,0,119,105,110,100,111,119,115,49,50,53,52,0,0,0,51,6,96,98,33,41,182,168,226,138,142,184,104,198,139,88,4,16,64,0,1,144,88,226,137,40,178,8,98,136,147,216,120,6,140,89,4,16,128,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,244,64,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,80,6,0,99,112,49,50,53,53,0,119,105,110,100,111,119,115,49,50,53,53,0,0,0,51,6,96,98,33,41,182,168,226,138,142,184,24,192,139,1,4,16,64,0,1,144,88,226,137,40,178,8,98,136,147,216,24,0,140,1,4,16,64,0,0,0,0,0,0,49,2,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,0,0,0,0,0,0,0,64,5,37,212,80,68,21,101,212,81,72,37,21,128,82,75,49,213,148,83,79,65,21,149,84,110,189,5,87,92,114,5,16,64,0,1,4,16,64,0,83,81,85,149,85,87,97,149,149,86,91,113,213,149,87,95,129,21,150,88,99,145,85,150,89,103,161,149,150,90,107,177,213,86,0,1,120,248,97,0,99,112,49,50,53,54,0,119,105,110,100,111,119,115,49,50,53,54,0,0,0,51,146,102,98,33,41,182,168,226,138,142,184,56,218,139,88,148,134,154,105,170,145,88,226,137,40,178,8,98,136,169,217,120,26,140,89,112,216,225,106,0,204,5,0,0,0,0,0,0,0,0,0,192,26,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,23,0,0,0,0,64,93,173,217,117,23,94,121,233,181,23,95,125,249,245,23,96,129,9,54,24,97,133,25,118,24,98,137,41,182,24,0,140,53,230,216,99,144,69,38,217,100,0,80,6,64,101,150,93,134,25,0,0,0,0,0,0,153,105,6,0,0,155,113,214,153,103,0,124,6,26,0,161,1,32,26,0,0,120,248,161,107,99,112,49,50,53,55,0,119,105,110,100,111,119,115,49,50,53,55,0,0,0,51,6,96,98,0,41,182,168,226,138,1,184,24,192,139,1,16,240,136,2,1,144,88,226,137,40,178,8,98,136,1,216,24,0,140,1,24,32,73,0,0,4,0,0,0,0,4,0,0,0,13,0,192,5,0,0,0,0,192,2,0,0,0,0,0,0,0,0,0,0,16,0,208,5,0,0,0,0,128,3,21,236,16,193,5,0,0,112,194,8,29,0,240,71,9,49,4,145,131,17,102,48,225,4,0,84,0,0,0,0,120,40,1,6,28,0,4,50,8,0,22,240,32,1,6,0,0,128,2,9,30,0,0,136,9,50,8,161,195,17,103,52,241,4,0,85,0,0,0,0,121,44,17,70,28,0,8,66,72,36,99,112,49,50,53,56,0,119,105,110,100,111,119,115,49,50,53,56,0,0,0,51,6,96,98,33,41,182,168,226,138,142,184,24,192,139,88,4,16,64,0,1,144,88,226,137,40,178,8,98,136,147,216,24,0,140,89,4,16,128,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,4,0,0,0,0,0,0,0,0,0,0,149,0,0,0,0,33,0,128,9,0,0,24,2,0,0,0,0,0,0,0,0,32,114,9,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,150,0,0,0,0,34,0,144,9,0,0,28,2,0,0,0,0,0,0,0,0,36,34,35,0,107,111,105,56,114,0,0,0,62,254,8,100,144,66,14,73,100,145,70,30,137,164,153,103,162,153,166,154,107,178,217,38,143,110,222,136,99,142,58,238,40,64,143,7,32,144,192,3,73,42,185,36,76,76,54,233,228,147,80,70,41,229,148,84,86,105,229,149,88,102,169,165,56,91,114,217,165,151,95,130,25,166,152,99,146,89,102,1,46,65,20,145,73,20,85,68,210,68,37,97,148,145,70,27,113,212,145,71,31,189,4,82,72,34,141,100,145,68,44,173,116,17,74,45,165,116,146,74,14,193,19,143,65,244,212,67,208,60,5,225,147,143,62,251,240,211,143,63,255,60,4,80,64,2,13,100,143,60,12,45,116,15,66,13,37,116,144,66,107,111,105,56,117,0,0,0,62,254,8,100,144,66,14,73,100,145,70,30,137,164,153,103,162,153,166,154,107,178,217,38,143,110,222,136,99,142,58,238,40,64,143,7,32,144,192,3,73,42,185,36,76,51,53,89,147,77,80,70,41,229,148,84,254,100,229,149,88,102,169,165,56,229,112,121,14,58,95,130,25,166,152,99,250,84,102,1,46,65,20,145,73,20,85,68,210,68,37,97,148,145,70,27,113,212,145,71,31,189,4,82,72,34,141,100,145,68,44,173,116,17,74,45,165,116,146,74,14,193,19,143,65,244,212,67,208,60,5,225,147,143,62,251,240,211,143,63,255,60,4,80,64,2,13,100,143,60,12,45,116,15,66,13,37,116,144,66,0,0,0,0,0,0,0,0,0,48,1,48,2,48,12,255,14,255,251,48,26,255,27,255,31,255,1,255,155,48,156,48,180,0,64,255,168,0,62,255,227,255,63,255,253,48,254,48,157,48,158,48,3,48,221,78,5,48,6,48,7,48,252,48,21,32,16,32,15,255,92,0,28,48,22,32,92,255,38,32,37,32,24,32,25,32,28,32,29,32,8,255,9,255,20,48,21,48,59,255,61,255,91,255,93,255,8,48,9,48,10,48,11,48,12,48,13,48,14,48,15,48,16,48,17,48,11,255,18,34,177,0,215,0,247,0,29,255,96,34,28,255,30,255,102,34,103,34,30,34,52,34,66,38,64,38,176,0,50,32,51,32,3,33,229,255,4,255,162,0,163,0,5,255,3,255,6,255,10,255,32,255,167,0,6,38,5,38,203,37,207,37,206,37,199,37,198,37,161,37,160,37,179,37,178,37,189,37,188,37,59,32,18,48,146,33,144,33,145,33,147,33,19,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,34,11,34,134,34,135,34,130,34,131,34,42,34,41,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,39,34,40,34,172,0,210,33,212,33,0,34,3,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,34,165,34,18,35,2,34,7,34,97,34,82,34,106,34,107,34,26,34,61,34,29,34,53,34,43,34,44,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,43,33,48,32,111,38,109,38,106,38,32,32,33,32,182,0,0,0,0,0,0,0,0,0,239,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,255,17,255,18,255,19,255,20,255,21,255,22,255,23,255,24,255,25,255],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+197488),allocate([33,255,34,255,35,255,36,255,37,255,38,255,39,255,40,255,41,255,42,255,43,255,44,255,45,255,46,255,47,255,48,255,49,255,50,255,51,255,52,255,53,255,54,255,55,255,56,255,57,255,58,255,0,0,0,0,0,0,0,0,0,0,0,0,65,255,66,255,67,255,68,255,69,255,70,255,71,255,72,255,73,255,74,255,75,255,76,255,77,255,78,255,79,255,80,255,81,255,82,255,83,255,84,255,85,255,86,255,87,255,88,255,89,255,90,255,0,0,0,0,0,0,0,0,65,48,66,48,67,48,68,48,69,48,70,48,71,48,72,48,73,48,74,48,75,48,76,48,77,48,78,48,79,48,80,48,81,48,82,48,83,48,84,48,85,48,86,48,87,48,88,48,89,48,90,48,91,48,92,48,93,48,94,48,95,48,96,48,97,48,98,48,99,48,100,48,101,48,102,48,103,48,104,48,105,48,106,48,107,48,108,48,109,48,110,48,111,48,112,48,113,48,114,48,115,48,116,48,117,48,118,48,119,48,120,48,121,48,122,48,123,48,124,48,125,48,126,48,127,48,128,48,129,48,130,48,131,48,132,48,133,48,134,48,135,48,136,48,137,48,138,48,139,48,140,48,141,48,142,48,143,48,144,48,145,48,146,48,147,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,161,48,162,48,163,48,164,48,165,48,166,48,167,48,168,48,169,48,170,48,171,48,172,48,173,48,174,48,175,48,176,48,177,48,178,48,179,48,180,48,181,48,182,48,183,48,184,48,185,48,186,48,187,48,188,48,189,48,190,48,191,48,192,48,193,48,194,48,195,48,196,48,197,48,198,48,199,48,200,48,201,48,202,48,203,48,204,48,205,48,206,48,207,48,208,48,209,48,210,48,211,48,212,48,213,48,214,48,215,48,216,48,217,48,218,48,219,48,220,48,221,48,222,48,223,48,224,48,225,48,226,48,227,48,228,48,229,48,230,48,231,48,232,48,233,48,234,48,235,48,236,48,237,48,238,48,239,48,240,48,241,48,242,48,243,48,244,48,245,48,246,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,145,3,146,3,147,3,148,3,149,3,150,3,151,3,152,3,153,3,154,3,155,3,156,3,157,3,158,3,159,3,160,3,161,3,163,3,164,3,165,3,166,3,167,3,168,3,169,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,177,3,178,3,179,3,180,3,181,3,182,3,183,3,184,3,185,3,186,3,187,3,188,3,189,3,190,3,191,3,192,3,193,3,195,3,196,3,197,3,198,3,199,3,200,3,201,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,4,17,4,18,4,19,4,20,4,21,4,1,4,22,4,23,4,24,4,25,4,26,4,27,4,28,4,29,4,30,4,31,4,32,4,33,4,34,4,35,4,36,4,37,4,38,4,39,4,40,4,41,4,42,4,43,4,44,4,45,4,46,4,47,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,4,49,4,50,4,51,4,52,4,53,4,81,4,54,4,55,4,56,4,57,4,58,4,59,4,60,4,61,4,62,4,63,4,64,4,65,4,66,4,67,4,68,4,69,4,70,4,71,4,72,4,73,4,74,4,75,4,76,4,77,4,78,4,79,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,2,37,12,37,16,37,24,37,20,37,28,37,44,37,36,37,52,37,60,37,1,37,3,37,15,37,19,37,27,37,23,37,35,37,51,37,43,37,59,37,75,37,32,37,47,37,40,37,55,37,63,37,29,37,48,37,37,37,56,37,66,37],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+207728),
allocate([156,78,22,85,3,90,63,150,192,84,27,97,40,99,246,89,34,144,117,132,28,131,80,122,170,96,225,99,37,110,237,101,102,132,166,130,245,155,147,104,39,87,161,101,113,98,155,91,208,89,123,134,244,152,98,125,190,125,142,155,22,98,159,124,183,136,137,91,181,94,9,99,151,102,72,104,199,149,141,151,79,103,229,78,10,79,77,79,157,79,73,80,242,86,55,89,212,89,1,90,9,92,223,96,15,97,112,97,19,102,5,105,186,112,79,117,112,117,251,121,173,125,239,125,195,128,14,132,99,136,2,139,85,144,122,144,59,83,149,78,165,78,223,87,178,128,193,144,239,120,0,78,241,88,162,110,56,144,50,122,40,131,139,130,47,156,65,81,112,83,189,84,225,84,224,86,251,89,21,95,242,152,235,109,228,128,45,133,98,150,112,150,160,150,251,151,11,84,243,83,135,91,207,112,189,127,194,143,232,150,111,83,92,157,186,122,17,78,147,120,252,129,38,110,24,86,4,85,29,107,26,133,59,156,229,89,169,83,102,109,220,116,143,149,66,86,145,78,75,144,242,150,79,131,12,153,225,83,182,85,48,91,113,95,32,102,243,102,4,104,56,108,243,108,41,109,91,116,200,118,78,122,52,152,241,130,91,136,96,138,237,146,178,109,171,117,202,118,197,153,166,96,1,139,138,141,178,149,142,105,173,83,134,81,18,87,48,88,68,89,180,91,246,94,40,96,169,99,244,99,191,108,20,111,142,112,20,113,89,113,213,113,63,115,1,126,118,130,209,130,151,133,96,144,91,146,27,157,105,88,188,101,90,108,37,117,249,81,46,89,101,89,128,95,220,95,188,98,250,101,42,106,39,107,180,107,139,115,193,127,86,137,44,157,14,157,196,158,161,92,150,108,123,131,4,81,75,92,182,97,198,129,118,104,97,114,89,78,250,79,120,83,105,96,41,110,79,122,243,151,11,78,22,83,238,78,85,79,61,79,161,79,115,79,160,82,239,83,9,86,15,89,193,90,182,91,225,91,209,121,135,102,156,103,182,103,76,107,179,108,107,112,194,115,141,121,190,121,60,122,135,123,177,130,219,130,4,131,119,131,239,131,211,131,102,135,178,138,41,86,168,140,230,143,78,144,30,151,138,134,196,79,232,92,17,98,89,114,59,117,229,129,189,130,254,134,192,140,197,150,19,153,213,153,203,78,26,79,227,137,222,86,74,88,202,88,251,94,235,95,42,96,148,96,98,96,208,97,18,98,208,98,57,101,65,155,102,102,176,104,119,109,112,112,76,117,134,118,117,125,165,130,249,135,139,149,142,150,157,140,241,81,190,82,22,89,179,84,179,91,22,93,104,97,130,105,175,109,141,120,203,132,87,136,114,138,167,147,184,154,108,109,168,153,217,134,163,87,255,103,206,134,14,146,131,82,135,86,4,84,211,94,225,98,185,100,60,104,56,104,187,107,114,115,186,120,107,122,154,137,210,137,107,141,3,143,237,144,163,149,148,150,105,151,102,91,179,92,125,105,77,152,78,152,155,99,32,123,43,106,127,106,182,104,13,156,95,111,114,82,157,85,112,96,236,98,59,109,7,110,209,110,91,132,16,137,68,143,20,78,57,156,246,83,27,105,58,106,132,151,42,104,92,81,195,122,178,132,220,145,140,147,91,86,40,157,34,104,5,131,49,132,165,124,8,82,197,130,230,116,126,78,131,79,160,81,210,91,10,82,216,82,231,82,251,93,154,85,42,88,230,89,140,91,152,91,219,91,114,94,121,94,163,96,31,97,99,97,190,97,219,99,98,101,209,103,83,104,250,104,62,107,83,107,87,108,34,111,151,111,69,111,176,116,24,117,227,118,11,119,255,122,161,123,33,124,233,125,54,127,240,127,157,128,102,130,158,131,179,137,204,138,171,140,132,144,81,148,147,149,145,149,162,149,101,150,211,151,40,153,24,130,56,78,43,84,184,92,204,93,169,115,76,118,60,119,169,92,235,127,11,141,193,150,17,152,84,152,88,152,1,79,14,79,113,83,156,85,104,86,250,87,71,89,9,91,196,91,144,92,12,94,126,94,204,95,238,99,58,103,215,101,226,101,31,103,203,104,196,104,95,106,48,94,197,107,23,108,125,108,127,117,72,121,99,91,0,122,0,125,189,95,143,137,24,138,180,140,119,141,204,142,29,143,226,152,14,154,60,155,128,78,125,80,0,81,147,89,156,91,47,98,128,98,236,100,58,107,160,114,145,117,71,121,169,127,251,135,188,138,112,139,172,99,202,131,160,151,9,84,3,84,171,85,84,104,88,106,112,138,39,120,117,103,205,158,116,83,162,91,26,129,80,134,6,144,24,78,69,78,199,78,17,79,202,83,56,84,174,91,19,95,37,96,81,101,61,103,66,108,114,108,227,108,120,112,3,116,118,122,174,122,8,123,26,125,254,124,102,125,231,101,91,114,187,83,69,92,232,93,210,98,224,98,25,99,32,110,90,134,49,138,221,141,248,146,1,111,166,121,90,155,168,78,171,78,172,78,155,79,160,79,209,80,71,81,246,122,113,81,246,81,84,83,33,83,127,83,235,83,172,85,131,88,225,92,55,95,74,95,47,96,80,96,109,96,31,99,89,101,75,106,193,108,194,114,237,114,239,119,248,128,5,129,8,130,78,133,247,144,225,147,255,151,87,153,90,154,240,78,221,81,45,92,129,102,109,105,64,92,242,102,117,105,137,115,80,104,129,124,197,80,228,82,71,87,254,93,38,147,164,101,35,107,61,107,52,116,129,121,189,121,75,123,202,125,185,130,204,131,127,136,95,137,57,139,209,143,209,145,31,84,128,146,93,78,54,80,229,83,58,83,215,114,150,115,233,119,230,130,175,142,198,153,200,153,210,153,119,81,26,97,94,134,176,85,122,122,118,80,211,91,71,144,133,150,50,78,219,106,231,145,81,92,72,92,152,99,159,122,147,108,116,151,97,143,170,122,138,113,136,150,130,124,23,104,112,126,81,104,108,147,242,82,27,84,171,133,19,138,164,127,205,142,225,144,102,83,136,136,65,121,194,79,190,80,17,82,68,81,83,85,45,87,234,115,139,87,81,89,98,95,132,95,117,96,118,97,103,97,169,97,178,99,58,100,108,101,111,102,66,104,19,110,102,117,61,122,251,124,76,125,153,125,75,126,107,127,14,131,74,131,205,134,8,138,99,138,102,139,253,142,26,152,143,157,184,130,206,143,232,155,135,82,31,98,131,100,192,111,153,150,65,104,145,80,32,107,122,108,84,111,116,122,80,125,64,136,35,138,8,103,246,78,57,80,38,80,101,80,124,81,56,82,99,82,167,85,15,87,5,88,204,90,250,94,178,97,248,97,243,98,114,99,28,105,41,106,125,114,172,114,46,115,20,120,111,120,121,125,12,119,169,128,139,137,25,139,226,140,210,142,99,144,117,147,122,150,85,152,19,154,120,158,67,81,159,83,179,83,123,94,38,95,27,110,144,110,132,115,254,115,67,125,55,130,0,138,250,138,80,150,78,78,11,80,228,83,124,84,250,86,209,89,100,91,241,93,171,94,39,95,56,98,69,101,175,103,86,110,208,114,202,124,180,136,161,128,225,128,240,131,78,134,135,138,232,141,55,146,199,150,103,152,19,159,148,78,146,78,13,79,72,83,73,84,62,84,47,90,140,95,161,95,159,96,167,104,142,106,90,116,129,120,158,138,164,138,119,139,144,145,94,78,201,155,164,78,124,79,175,79,25,80,22,80,73,81,108,81,159,82,185,82,254,82,154,83,227,83,17,84,14,84,137,85,81,87,162,87,125,89,84,91,93,91,143,91,229,93,231,93,247,93,120,94,131,94,154,94,183,94,24,95,82,96,76,97,151,98,216,98,167,99,59,101,2,102,67,102,244,102,109,103,33,104,151,104,203,105,95,108,42,109,105,109,47,110,157,110,50,117,135,118,108,120,63,122,224,124,5,125,24,125,94,125,177,125,21,128,3,128,175,128,177,128,84,129,143,129,42,130,82,131,76,136,97,136,27,139,162,140,252,140,202,144,117,145,113,146,63,120,252,146,164,149,77,150,5,152,153,153,216,154,59,157,91,82,171,82,247,83,8,84,213,88,247,98,224,111,106,140,95,143,185,158,75,81,59,82,74,84,253,86,64,122,119,145,96,157,210,158,68,115,9,111,112,129,17,117,253,95,218,96,168,154,219,114,188,143,100,107,3,152,202,78,240,86,100,87,190,88,90,90,104,96,199,97,15,102,6,102,57,104,177,104,247,109,213,117,58,125,110,130,66,155,155,78,80,79,201,83,6,85,111,93,230,93,238,93,251,103,153,108,115,116,2,120,80,138,150,147,223,136,80,87,167,94,43,99,181,80,172,80,141,81,0,103,201,84,94,88,187,89,176,91,105,95,77,98,161,99,61,104,115,107,8,110,125,112,199,145,128,114,21,120,38,120,109,121,142,101,48,125,220,131,193,136,9,143,155,150,100,82,40,87,80,103,106,127,161,140,180,81,66,87,42,150,58,88,138,105,180,128,178,84,14,93,252,87,149,120,250,157,92,79,74,82,139,84,62,100,40,102,20,103,245,103,132,122,86,123,34,125,47,147,92,104,173,155,57,123,25,83,138,81,55,82,223,91,246,98,174,100,230,100,45,103,186,107,169,133,209,150,144,118,214,155,76,99,6,147,171,155,191,118,82,102,9,78,152,80,194,83,113,92,232,96,146,100,99,101,95,104,230,113,202,115,35,117,151,123,130,126,149,134,131,139,219,140,120,145,16,153,172,101,171,102,139,107,213,78,212,78,58,79,127,79,58,82,248,83,242,83,227,85,219,86,235,88,203,89,201,89,255,89,80,91,77,92,2,94,43,94,215,95,29,96,7,99,47,101,92,91,175,101,189,101,232,101,157,103,98,107,123,107,15,108,69,115,73,121,193,121,248,124,25,125,43,125,162,128,2,129,243,129,150,137,94,138,105,138,102,138,140,138,238,138,199,140,220,140,204,150,252,152,111,107,139,78,60,79,141,79,80,81,87,91,250,91,72,97,1,99,66,102,33,107,203,110,187,108,62,114,189,116,212,117,193,120,58,121,12,128,51,128,234,129,148,132,158,143,80,108,127,158,15,95,88,139,43,157,250,122,248,142,141,91,235,150,3,78,241,83,247,87,49,89,201,90,164,91,137,96,127,110,6,111,190,117,234,140,159,91,0,133,224,123,114,80,244,103,157,130,97,92,74,133,30,126,14,130,153,81,4,92,104,99,102,141,156,101,110,113,62,121,23,125,5,128,29,139,202,142,110,144,199,134,170,144,31,80,250,82,58,92,83,103,124,112,53,114,76,145,200,145,43,147,229,130,194,91,49,95,249,96,59,78,214,83,136,91,75,98,49,103,138,107,233,114,224,115,46,122,107,129,163,141,82,145,150,153,18,81,215,83,106,84,255,91,136,99,57,106,172,125,0,151,218,86,206,83,104,84,151,91,49,92,222,93,238,79,1,97,254,98,50,109,192,121,203,121,66,125,77,126,210,127,237,129,31,130,144,132,70,136,114,137,144,139,116,142,47,143,49,144,75,145,108,145,198,150,156,145,192,78,79,79,69,81,65,83,147,95,14,98,212,103,65,108,11,110,99,115,38,126,205,145,131,146,212,83,25,89,191,91,209,109,93,121,46,126,155,124,126,88,159,113,250,81,83,136,240,143,202,79,251,92,37,102,172,119,227,122,28,130,255,153,198,81,170,95,236,101,111,105,137,107,243,109,150,110,100,111,254,118,20,125,225,93,117,144,135,145,6,152,230,81,29,82,64,98,145,102,217,102,26,110,182,94,210,125,114,127,248,102,175,133,247,133,248,138,169,82,217,83,115,89,143,94,144,95,85,96,228,146,100,150,183,80,31,81,221,82,32,83,71,83,236,83,232,84,70,85,49,85,23,86,104,89,190,89,60,90,181,91,6,92,15,92,17,92,26,92,132,94,138,94,224,94,112,95,127,98,132,98,219,98,140,99,119,99,7,102,12,102,45,102,118,102,126,103,162,104,31,106,53,106,188,108,136,109,9,110,88,110,60,113,38,113,103,113,199,117,1,119,93,120,1,121,101,121,240,121,224,122,17,123,167,124,57,125,150,128,214,131,139,132,73,133,93,136,243,136,31,138,60,138,84,138,115,138,97,140,222,140,164,145,102,146,126,147,24,148,156,150,152,151,10,78,8,78,30,78,87,78,151,81,112,82,206,87,52,88,204,88,34,91,56,94,197,96,254,100,97,103,86,103,68,109,182,114,115,117,99,122,184,132,114,139,184,145,32,147,49,86,244,87,254,152,237,98,13,105,150,107,237,113,84,126,119,128,114,130,230,137,223,152,85,135,177,143,59,92,56,79,225,79,181,79,7,85,32,90,221,91,233,91,195,95,78,97,47,99,176,101,75,102,238,104,155,105,120,109,241,109,51,117,185,117,31,119,94,121,230,121,51,125,227,129,175,130,170,133,170,137,58,138,171,142,155,143,50,144,221,145,7,151,186,78,193,78,3,82,117,88,236,88,11,92,26,117,61,92,78,129,10,138,197,143,99,150,109,151,37,123,207,138,8,152,98,145,243,86,168,83,23,144,57,84,130,87,37,94,168,99,52,108,138,112,97,119,139,124,224,127,112,136,66,144,84,145,16,147,24,147,143,150,94,116,196,154,7,93,105,93,112,101,162,103,168,141,219,150,110,99,73,103,25,105,197,131,23,152,192,150,254,136,132,111,122,100,248,91,22,78,44,112,93,117,47,102,196,81,54,82,226,82,211,89,129,95,39,96,16,98,63,101,116,101,31,102,116,102,242,104,22,104,99,107,5,110,114,114,31,117,219,118,190,124,86,128,240,88,253,136,127,137,160,138,147,138,203,138,29,144,146,145,82,151,89,151,137,101,14,122,6,129,187,150,45,94,220,96,26,98,165,101,20,102,144,103,243,119,77,122,77,124,62,126,10,129,172,140,100,141,225,141,95,142,169,120,7,82,217,98,165,99,66,100,152,98,45,138,131,122,192,123,172,138,234,150,118,125,12,130,73,135,217,78,72,81,67,83,96,83,163,91,2,92,22,92,221,93,38,98,71,98,176,100,19,104,52,104,201,108,69,109,23,109,211,103,92,111,78,113,125,113,203,101,127,122,173,123,218,125,74,126,168,127,122,129,27,130,57,130,166,133,110,138,206,140,245,141,120,144,119,144,173,146,145,146,131,149,174,155,77,82,132,85,56,111,54,113,104,81,133,121,85,126,179,129,206,124,76,86,81,88,168,92,170,99,254,102,253,102,90,105,217,114,143,117,142,117,14,121,86,121,223,121,151,124,32,125,68,125,7,134,52,138,59,150,97,144,32,159,231,80,117,82,204,83,226,83,9,80,170,85,238,88,79,89,61,114,139,91,100,92,29,83,227,96,243,96,92,99,131,99,63,99,187,99,205,100,233,101,249,102,227,93,205,105,253,105,21,111,229,113,137,78,233,117,248,118,147,122,223,124,207,125,156,125,97,128,73,131,88,131,108,132,188,132,251,133,197,136,112,141,1,144,109,144,151,147,28,151,18,154,207,80,151,88,142,97,211,129,53,133,8,141,32,144,195,79,116,80,71,82,115,83,111,96,73,99,95,103,44,110,179,141,31,144,215,79,94,92,202,140,207,101,154,125,82,83,150,136,118,81,195,99,88,91,107,91,10,92,13,100,81,103,92,144,214,78,26,89,42,89,112,108,81,138,62,85,21,88,165,89,240,96,83,98,193,103,53,130,85,105,64,150,196,153,40,154,83,79,6,88,254,91,16,128,177,92,47,94,133,95,32,96,75,97,52,98,255,102,240,108,222,110,206,128,127,129,212,130,139,136,184,140,0,144,46,144,138,150,219,158,219,155,227,78,240,83,39,89,44,123,141,145,76,152,249,157,221,110,39,112,83,83,68,85,133,91,88,98,158,98,211,98,162,108,239,111,34,116,23,138,56,148,193,111,254,138,56,131,231,81,248,134,234,83,233,83,70,79,84,144,176,143,106,89,49,129,253,93,234,122,191,143,218,104,55,140,248,114,72,156,61,106,176,138,57,78,88,83,6,86,102,87,197,98,162,99,230,101,78,107,225,109,91,110,173,112,237,119,239,122,170,123,187,125,61,128,198,128,203,134,149,138,91,147,227,86,199,88,62,95,173,101,150,102,128,106,181,107,55,117,199,138,36,80,229,119,48,87,27,95,101,96,122,102,96,108,244,117,26,122,110,127,244,129,24,135,69,144,179,153,201,123,92,117,249,122,81,123,196,132,16,144,233,121,146,122,54,131,225,90,64,119,45,78,242,78,153,91,224,95,189,98,60,102,241,103,232,108,107,134,119,136,59,138,78,145,243,146,208,153,23,106,38,112,42,115,231,130,87,132,175,140,1,78,70,81,203,81,139,85,245,91,22,94,51,94,129,94,20,95,53,95,107,95,180,95,242,97,17,99,162,102,29,103,110,111,82,114,58,117,58,119,116,128,57,129,120,129,118,135,191,138,220,138,133,141,243,141,154,146,119,149,2,152,229,156,197,82,87,99,244,118,21,103,136,108,205,115,195,140,174,147,115,150,37,109,156,88,14,105,204,105,253,143,154,147,219,117,26,144,90,88,2,104,180,99,251,105,67,79,44,111,216,103,187,143,38,133,180,125,84,147,63,105,112,111,106,87,247,88,44,91,44,125,42,114,10,84,227,145,180,157,173,78,78,79,92,80,117,80,67,82,158,140,72,84,36,88,154,91,29,94,149,94,173,94,247,94,31,95,140,96,181,98,58,99,208,99,175,104,64,108,135,120,142,121,11,122,224,125,71,130,2,138,230,138,68,142,19,144,184,144,45,145,216,145,14,159,229,108,88,100,226,100,117,101,244,110,132,118,27,123,105,144,209,147,186,110,242,84,185,95,164,100,77,143,237,143,68,146,120,81,107,88,41,89,85,92,151,94,251,109,143,126,28,117,188,140,226,142,91,152,185,112,29,79,191,107,177,111,48,117,251,150,78,81,16,84,53,88,87,88,172,89,96,92,146,95,151,101,92,103,33,110,123,118,223,131,237,140,20,144,253,144,77,147,37,120,58,120,170,82,166,94,31,87,116,89,18,96,18,80,90,81,172,81,205,81,0,82,16,85,84,88,88,88,87,89,149,91,246,92,139,93,188,96,149,98,45,100,113,103,67,104,188,104,223,104,215,118,216,109,111,110,155,109,111,112,200,113,83,95,216,117,119,121,73,123,84,123,82,123,214,124,113,125,48,82,99,132,105,133,228,133,14,138,4,139,70,140,15,142,3,144,15,144,25,148,118,150,45,152,48,154,216,149,205,80,213,82,12,84,2,88,14,92,167,97,158,100,30,109,179,119,229,122,244,128,4,132,83,144,133,146,224,92,7,157,63,83,151,95,179,95,156,109,121,114,99,119,191,121,228,123,210,107,236,114,173,138,3,104,97,106,248,81,129,122,52,105,74,92,246,156,235,130,197,91,73,145,30,112,120,86,111,92,199,96,102,101,140,108,90,140,65,144,19,152,81,84,199,102,13,146,72,89,163,144,133,81,77,78,234,81,153,133,14,139,88,112,122,99,75,147,98,105,180,153,4,126,119,117,87,83,96,105,223,142,227,150,93,108,140,78,60,92,16,95,233,143,2,83,209,140,137,128,121,134,255,94,229,101,115,78,101,81,130,89,63,92,238,151,251,78,138,89,205,95,141,138,225,111,176,121,98,121,231,91,113,132,43,115,177,113,116,94,245,95,123,99,154,100,195,113,152,124,67,78,252,94,75,78,220,87,162,86,169,96,195,111,13,125,253,128,51,129,191,129,178,143,151,137,164,134,244,93,138,98,173,100,135,137,119,103,226,108,62,109,54,116,52,120,70,90,117,127,173,130,172,153,243,79,195,94,221,98,146,99,87,101,111,103,195,118,76,114,204,128,186,128,41,143,77,145,13,80,249,87,146,90,133,104,115,105,100,113,253,114,183,140,242,88,224,140,106,150,25,144,127,135,228,121,231,119,41,132,47,79,101,82,90,83,205,98,207,103,202,108,125,118,148,123,149,124,54,130,132,133,235,143,221,102,32,111,6,114,27,126,171,131,193,153,166,158,253,81,177,123,114,120,184,123,135,128,72,123,232,106,97,94,140,128,81,117,96,117,107,81,98,146,140,110,122,118,151,145,234,154,16,79,112,127,156,98,79,123,165,149,233,156,122,86,89,88,228,134,188,150,52,79,36,82,74,83,205,83,219,83,6,94,44,100,145,101,127,103,62,108,78,108,72,114,175,114,237,115,84,117,65,126,44,130,233,133,169,140,196,123,198,145,105,113,18,152,239,152,61,99,105,102,106,117,228,118,208,120,67,133,238,134,42,83,81,83,38,84,131,89,135,94,124,95,178,96,73,98,121,98,171,98,144,101,212,107,204,108,178,117,174,118,145,120,216,121,203,125,119,127,165,128,171,136,185,138,187,140,127,144,94,151,219,152,11,106,56,124,153,80,62,92,174,95,135,103,216,107,53,116,9,119,142,127,59,159,202,103,23,122,57,83,139,117,237,154,102,95,157,129,241,131,152,128,60,95,197,95,98,117,70,123,60,144,103,104,235,89,155,90,16,125,126,118,44,139,245,79,106,95,25,106,55,108,2,111,226,116,104,121,104,136,85,138,121,140,223,94,207,99,197,117,210,121,215,130,40,147,242,146,156,132,237,134,45,156,193,84,108,95,140,101,92,109,21,112,167,140,211,140,59,152,79,101,246,116,13,78,216,78,224,87,43,89,102,90,204,91,168,81,3,94,156,94,22,96,118,98,119,101,167,101,110,102,110,109,54,114,38,123,80,129,154,129,153,130,92,139,160,140,230,140,116,141,28,150,68,150,174,79,171,100,102,107,30,130,97,132,106,133,232,144,1,92,83,105,168,152,122,132,87,133,15,79,111,82,169,95,69,94,13,103,143,121,121,129,7,137,134,137,245,109,23,95,85,98,184,108,207,78,105,114,146,155,6,82,59,84,116,86,179,88,164,97,110,98,26,113,110,89,137,124,222,124,27,125,240,150,135,101,94,128,25,78,117,79,117,81,64,88,99,94,115,94,10,95,196,103,38,78,61,133,137,149,91,150,115,124,1,152,251,80,193,88,86,118,167,120,37,82,165,119,17,133,134,123,79,80,9,89,71,114,199,123,232,125,186,143,212,143,77,144,191,79,201,82,41,90,1,95,173,151,221,79,23,130,234,146,3,87,85,99,105,107,43,117,220,136,20,143,66,122,223,82,147,88,85,97,10,98,174,102,205,107,63,124,233,131,35,80,248,79,5,83,70,84,49,88,73,89,157,91,240,92,239,92,41,93,150,94,177,98,103,99,62,101,185,101,11,103,213,108,225,108,249,112,50,120,43,126,222,128,179,130,12,132,236,132,2,135,18,137,42,138,74,140,166,144,210,146,253,152,243,156,108,157,79,78,161,78,141,80,86,82,74,87,168,89,61,94,216,95,217,95,63,98,180,102,27,103,208,103,210,104,146,81,33,125,170,128,168,129,0,139,140,140,191,140,126,146,50,150,32,84,44,152,23,83,213,80,92,83,168,88,178,100,52,103,103,114,102,119,70,122,230,145,195,82,161,108,134,107,0,88,76,94,84,89,44,103,251,127,225,81,198,118,105,100,232,120,84,155,187,158,203,87,185,89,39,102,154,103,206,107,233,84,217,105,85,94,156,129,149,103,170,155,254,103,82,156,93,104,166,78,227,79,200,83,185,98,43,103,171,108,196,143,173,79,109,126,191,158,7,78,98,97,128,110,43,111,19,133,115,84,42,103,69,155,243,93,149,123,172,92,198,91,28,135,74,110,209,132,20,122,8,129,153,89,141,124,17,108,32,119,217,82,34,89,33,113,95,114,219,119,39,151,97,157,11,105,127,90,24,90,165,81,13,84,125,84,14,102,223,118,247,143,152,146,244,156,234,89,93,114,197,110,77,81,201,104,191,125,236,125,98,151,186,158,120,100,33,106,2,131,132,89,95,91,219,107,27,115,242,118,178,125,23,128,153,132,50,81,40,103,217,158,238,118,98,103,255,82,5,153,36,92,59,98,126,124,176,140,79,85,182,96,11,125,128,149,1,83,95,78,182,81,28,89,58,114,54,128,206,145,37,95,226,119,132,83,121,95,4,125,172,133,51,138,141,142,86,151,243,103,174,133,83,148,9,97,8,97,185,108,82,118,237,138,56,143,47,85,81,79,42,81,199,82,203,83,165,91,125,94,160,96,130,97,214,99,9,103,218,103,103,110,140,109,54,115,55,115,49,117,80,121,213,136,152,138,74,144,145,144,245,144,196,150,141,135,21,89,136,78,89,79,14,78,137,138,63,143,16,152,173,80,124,94,150,89,185,91,184,94,218,99,250,99,193,100,220,102,74,105,216,105,11,109,182,110,148,113,40,117,175,122,138,127,0,128,73,132,201,132,129,137,33,139,10,142,101,144,125,150,10,153,126,97,145,98,50,107,131,108,116,109,204,127,252,127,192,109,133,127,186,135,248,136,101,103,177,131,60,152,247,150,27,109,97,125,61,132,106,145,113,78,117,83,80,93,4,107,235,111,205,133,45,134,167,137,41,82,15,84,101,92,78,103,168,104,6,116,131,116,226,117,207,136,225,136,204,145,226,150,120,150,139,95,135,115,203,122,78,132,160,99,101,117,137,82,65,109,156,110,9,116,89,117,107,120,146,124,134,150,220,122,141,159,182,79,110,97,197,101,92,134,134,78,174,78,218,80,33,78,204,81,238,91,153,101,129,104,188,109,31,115,66,118,173,119,28,122,231,124,111,130,210,138,124,144,207,145,117,150,24,152,155,82,209,125,43,80,152,83,151,103,203,109,208,113,51,116,232,129,42,143,163,150,87,156,159,158,96,116,65,88,153,109,47,125,94,152,228,78,54,79,139,79,183,81,177,82,186,93,28,96,178,115,60,121,211,130,52,146,183,150,246,150,10,151,151,158,98,159,166,102,116,107,23,82,163,82,200,112,194,136,201,94,75,96,144,97,35,111,73,113,62,124,244,125,111,128,238,132,35,144,44,147,66,84,111,155,211,106,137,112,194,140,239,141,50,151,180,82,65,90,202,94,4,95,23,103,124,105,148,105,106,109,15,111,98,114,252,114,237,123,1,128,126,128,75,135,206,144,109,81,147,158,132,121,139,128,50,147,214,138,45,80,140,84,113,138,106,107,196,140,7,129,209,96,160,103,242,157,153,78,152,78,16,156,107,138,193,133,104,133,0,105,126,110,151,120,85,129,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,95,16,78,21,78,42,78,49,78,54,78,60,78,63,78,66,78,86,78,88,78,130,78,133,78,107,140,138,78,18,130,13,95,142,78,158,78,159,78,160,78,162,78,176,78,179,78,182,78,206,78,205,78,196,78,198,78,194,78,215,78,222,78,237,78,223,78,247,78,9,79,90,79,48,79,91,79,93,79,87,79,71,79,118,79,136,79,143,79,152,79,123,79,105,79,112,79,145,79,111,79,134,79,150,79,24,81,212,79,223,79,206,79,216,79,219,79,209,79,218,79,208,79,228,79,229,79,26,80,40,80,20,80,42,80,37,80,5,80,28,79,246,79,33,80,41,80,44,80,254,79,239,79,17,80,6,80,67,80,71,80,3,103,85,80,80,80,72,80,90,80,86,80,108,80,120,80,128,80,154,80,133,80,180,80,178,80,201,80,202,80,179,80,194,80,214,80,222,80,229,80,237,80,227,80,238,80,249,80,245,80,9,81,1,81,2,81,22,81,21,81,20,81,26,81,33,81,58,81,55,81,60,81,59,81,63,81,64,81,82,81,76,81,84,81,98,81,248,122,105,81,106,81,110,81,128,81,130,81,216,86,140,81,137,81,143,81,145,81,147,81,149,81,150,81,164,81,166,81,162,81,169,81,170,81,171,81,179,81,177,81,178,81,176,81,181,81,189,81,197,81,201,81,219,81,224,81,85,134,233,81,237,81,240,81,245,81,254,81,4,82,11,82,20,82,14,82,39,82,42,82,46,82,51,82,57,82,79,82,68,82,75,82,76,82,94,82,84,82,106,82,116,82,105,82,115,82,127,82,125,82,141,82,148,82,146,82,113,82,136,82,145,82,168,143,167,143,172,82,173,82,188,82,181,82,193,82,205,82,215,82,222,82,227,82,230,82,237,152,224,82,243,82,245,82,248,82,249,82,6,83,8,83,56,117,13,83,16,83,15,83,21,83,26,83,35,83,47,83,49,83,51,83,56,83,64,83,70,83,69,83,23,78,73,83,77,83,214,81,94,83,105,83,110,83,24,89,123,83,119,83,130,83,150,83,160,83,166,83,165,83,174,83,176,83,182,83,195,83,18,124,217,150,223,83,252,102,238,113,238,83,232,83,237,83,250,83,1,84,61,84,64,84,44,84,45,84,60,84,46,84,54,84,41,84,29,84,78,84,143,84,117,84,142,84,95,84,113,84,119,84,112,84,146,84,123,84,128,84,118,84,132,84,144,84,134,84,199,84,162,84,184,84,165,84,172,84,196,84,200,84,168,84,171,84,194,84,164,84,190,84,188,84,216,84,229,84,230,84,15,85,20,85,253,84,238,84,237,84,250,84,226,84,57,85,64,85,99,85,76,85,46,85,92,85,69,85,86,85,87,85,56,85,51,85,93,85,153,85,128,85,175,84,138,85,159,85,123,85,126,85,152,85,158,85,174,85,124,85,131,85,169,85,135,85,168,85,218,85,197,85,223,85,196,85,220,85,228,85,212,85,20,86,247,85,22,86,254,85,253,85,27,86,249,85,78,86,80,86,223,113,52,86,54,86,50,86,56,86,107,86,100,86,47,86,108,86,106,86,134,86,128,86,138,86,160,86,148,86,143,86,165,86,174,86,182,86,180,86,194,86,188,86,193,86,195,86,192,86,200,86,206,86,209,86,211,86,215,86,238,86,249,86,0,87,255,86,4,87,9,87,8,87,11,87,13,87,19,87,24,87,22,87,199,85,28,87,38,87,55,87,56,87,78,87,59,87,64,87,79,87,105,87,192,87,136,87,97,87,127,87,137,87,147,87,160,87,179,87,164,87,170,87,176,87,195,87,198,87,212,87,210,87,211,87,10,88,214,87,227,87,11,88,25,88,29,88,114,88,33,88,98,88,75,88,112,88,192,107,82,88,61,88,121,88,133,88,185,88,159,88,171,88,186,88,222,88,187,88,184,88,174,88,197,88,211,88,209,88,215,88,217,88,216,88,229,88,220,88,228,88,223,88,239,88,250,88,249,88,251,88,252,88,253,88,2,89,10,89,16,89,27,89,166,104,37,89,44,89,45,89,50,89,56,89,62,89,210,122,85,89,80,89,78,89,90,89,88,89,98,89,96,89,103,89,108,89,105,89,120,89,129,89,157,89,94,79,171,79,163,89,178,89,198,89,232,89,220,89,141,89,217,89,218,89,37,90,31,90,17,90,28,90,9,90,26,90,64,90,108,90,73,90,53,90,54,90,98,90,106,90,154,90,188,90,190,90,203,90,194,90,189,90,227,90,215,90,230,90,233,90,214,90,250,90,251,90,12,91,11,91,22,91,50,91,208,90,42,91,54,91,62,91,67,91,69,91,64,91,81,91,85,91,90,91,91,91,101,91,105,91,112,91,115,91,117,91,120,91,136,101,122,91,128,91,131,91,166,91,184,91,195,91,199,91,201,91,212,91,208,91,228,91,230,91,226,91,222,91,229,91,235,91,240,91,246,91,243,91,5,92,7,92,8,92,13,92,19,92,32,92,34,92,40,92,56,92,57,92,65,92,70,92,78,92,83,92,80,92,79,92,113,91,108,92,110,92,98,78,118,92,121,92,140,92,145,92,148,92,155,89,171,92,187,92,182,92,188,92,183,92,197,92,190,92,199,92,217,92,233,92,253,92,250,92,237,92,140,93,234,92,11,93,21,93,23,93,92,93,31,93,27,93,17,93,20,93,34,93,26,93,25,93,24,93,76,93,82,93,78,93,75,93,108,93,115,93,118,93,135,93,132,93,130,93,162,93,157,93,172,93,174,93,189,93,144,93,183,93,188,93,201,93,205,93,211,93,210,93,214,93,219,93,235,93,242,93,245,93,11,94,26,94,25,94,17,94,27,94,54,94,55,94,68,94,67,94,64,94,78,94,87,94,84,94,95,94,98,94,100,94,71,94,117,94,118,94,122,94,188,158,127,94,160,94,193,94,194,94,200,94,208,94,207,94,214,94,227,94,221,94,218,94,219,94,226,94,225,94,232,94,233,94,236,94,241,94,243,94,240,94,244,94,248,94,254,94,3,95,9,95,93,95,92,95,11,95,17,95,22,95,41,95,45,95,56,95,65,95,72,95,76,95,78,95,47,95,81,95,86,95,87,95,89,95,97,95,109,95,115,95,119,95,131,95,130,95,127,95,138,95,136,95,145,95,135,95,158,95,153,95,152,95,160,95,168,95,173,95,188,95,214,95,251,95,228,95,248,95,241,95,221,95,179,96,255,95,33,96,96,96,25,96,16,96,41,96,14,96,49,96,27,96,21,96,43,96,38,96,15,96,58,96,90,96,65,96,106,96,119,96,95,96,74,96,70,96,77,96,99,96,67,96,100,96,66,96,108,96,107,96,89,96,129,96,141,96,231,96,131,96,154,96,132,96,155,96,150,96,151,96,146,96,167,96,139,96,225,96,184,96,224,96,211,96,180,96,240,95,189,96,198,96,181,96,216,96,77,97,21,97,6,97,246,96,247,96,0,97,244,96,250,96,3,97,33,97,251,96,241,96,13,97,14,97,71,97,62,97,40,97,39,97,74,97,63,97,60,97,44,97,52,97,61,97,66,97,68,97,115,97,119,97,88,97,89,97,90,97,107,97,116,97,111,97,101,97,113,97,95,97,93,97,83,97,117,97,153,97,150,97,135,97,172,97,148,97,154,97,138,97,145,97,171,97,174,97,204,97,202,97,201,97,247,97,200,97,195,97,198,97,186,97,203,97,121,127,205,97,230,97,227,97,246,97,250,97,244,97,255,97,253,97,252,97,254,97,0,98,8,98,9,98,13,98,12,98,20,98,27,98,30,98,33,98,42,98,46,98,48,98,50,98,51,98,65,98,78,98,94,98,99,98,91,98,96,98,104,98,124,98,130,98,137,98,126,98,146,98,147,98,150,98,212,98,131,98,148,98,215,98,209,98,187,98,207,98,255,98,198,98,212,100,200,98,220,98,204,98,202,98,194,98,199,98,155,98,201,98,12,99,238,98,241,98,39,99,2,99,8,99,239,98,245,98,80,99,62,99,77,99,28,100,79,99,150,99,142,99,128,99,171,99,118,99,163,99,143,99,137,99,159,99,181,99,107,99,105,99,190,99,233,99,192,99,198,99,227,99,201,99,210,99,246,99,196,99,22,100,52,100,6,100,19,100,38,100,54,100,29,101,23,100,40,100,15,100,103,100,111,100,118,100,78,100,42,101,149,100,147,100,165,100,169,100,136,100,188,100,218,100,210,100,197,100,199,100,187,100,216,100,194,100,241,100,231,100,9,130,224,100,225,100,172,98,227,100,239,100,44,101,246,100,244,100,242,100,250,100,0,101,253,100,24,101,28,101,5,101,36,101,35,101,43,101,52,101,53,101,55,101,54,101,56,101,75,117,72,101,86,101,85,101,77,101,88,101,94,101,93,101,114,101,120,101,130,101,131,101,138,139,155,101,159,101,171,101,183,101,195,101,198,101,193,101,196,101,204,101,210,101,219,101,217,101,224,101,225,101,241,101,114,103,10,102,3,102,251,101,115,103,53,102,54,102,52,102,28,102,79,102,68,102,73,102,65,102,94,102,93,102,100,102,103,102,104,102,95,102,98,102,112,102,131,102,136,102,142,102,137,102,132,102,152,102,157,102,193,102,185,102,201,102,190,102,188,102,196,102,184,102,214,102,218,102,224,102,63,102,230,102,233,102,240,102,245,102,247,102,15,103,22,103,30,103,38,103,39,103,56,151,46,103,63,103,54,103,65,103,56,103,55,103,70,103,94,103,96,103,89,103,99,103,100,103,137,103,112,103,169,103,124,103,106,103,140,103,139,103,166,103,161,103,133,103,183,103,239,103,180,103,236,103,179,103,233,103,184,103,228,103,222,103,221,103,226,103,238,103,185,103,206,103,198,103,231,103,156,106,30,104,70,104,41,104,64,104,77,104,50,104,78,104,179,104,43,104,89,104,99,104,119,104,127,104,159,104,143,104,173,104,148,104,157,104,155,104,131,104,174,106,185,104,116,104,181,104,160,104,186,104,15,105,141,104,126,104,1,105,202,104,8,105,216,104,34,105,38,105,225,104,12,105,205,104,212,104,231,104,213,104,54,105,18,105,4,105,215,104,227,104,37,105,249,104,224,104,239,104,40,105,42,105,26,105,35,105,33,105,198,104,121,105,119,105,92,105,120,105,107,105,84,105,126,105,110,105,57,105,116,105,61,105,89,105,48,105,97,105,94,105,93,105,129,105,106,105,178,105,174,105,208,105,191,105,193,105,211,105,190,105,206,105,232,91,202,105,221,105,187,105,195,105,167,105,46,106,145,105,160,105,156,105,149,105,180,105,222,105,232,105,2,106,27,106,255,105,10,107,249,105,242,105,231,105,5,106,177,105,30,106,237,105,20,106,235,105,10,106,18,106,193,106,35,106,19,106,68,106,12,106,114,106,54,106,120,106,71,106,98,106,89,106,102,106,72,106,56,106,34,106,144,106,141,106,160,106,132,106,162,106,163,106,151,106,23,134,187,106,195,106,194,106,184,106,179,106,172,106,222,106,209,106,223,106,170,106,218,106,234,106,251,106,5,107,22,134,250,106,18,107,22,107,49,155,31,107,56,107,55,107,220,118,57,107,238,152,71,107,67,107,73,107,80,107,89,107,84,107,91,107,95,107,97,107,120,107,121,107,127,107,128,107,132,107,131,107,141,107,152,107,149,107,158,107,164,107,170,107,171,107,175,107,178,107,177,107,179,107,183,107,188,107,198,107,203,107,211,107,223,107,236,107,235,107,243,107,239,107,190,158,8,108,19,108,20,108,27,108,36,108,35,108,94,108,85,108,98,108,106,108,130,108,141,108,154,108,129,108,155,108,126,108,104,108,115,108,146,108,144,108,196,108,241,108,211,108,189,108,215,108,197,108,221,108,174,108,177,108,190,108,186,108,219,108,239,108,217,108,234,108,31,109,77,136,54,109,43,109,61,109,56,109,25,109,53,109,51,109,18,109,12,109,99,109,147,109,100,109,90,109,121,109,89,109,142,109,149,109,228,111,133,109,249,109,21,110,10,110,181,109,199,109,230,109,184,109,198,109,236,109,222,109,204,109,232,109,210,109,197,109,250,109,217,109,228,109,213,109,234,109,238,109,45,110,110,110,46,110,25,110,114,110,95,110,62,110,35,110,107,110,43,110,118,110,77,110,31,110,67,110,58,110,78,110,36,110,255,110,29,110,56,110,130,110,170,110,152,110,201,110,183,110,211,110,189,110,175,110,196,110,178,110,212,110,213,110,143,110,165,110,194,110,159,110,65,111,17,111,76,112,236,110,248,110,254,110,63,111,242,110,49,111,239,110,50,111,204,110,62,111,19,111,247,110,134,111,122,111,120,111,129,111,128,111,111,111,91,111,243,111,109,111,130,111,124,111,88,111,142,111,145,111,194,111,102,111,179,111,163,111,161,111,164,111,185,111,198,111,170,111,223,111,213,111,236,111,212,111,216,111,241,111,238,111,219,111,9,112,11,112,250,111,17,112,1,112,15,112,254,111,27,112,26,112,116,111,29,112,24,112,31,112,48,112,62,112,50,112,81,112,99,112,153,112,146,112,175,112,241,112,172,112,184,112,179,112,174,112,223,112,203,112,221,112,217,112,9,113,253,112,28,113,25,113,101,113,85,113,136,113,102,113,98,113,76,113,86,113,108,113,143,113,251,113,132,113,149,113,168,113,172,113,215,113,185,113,190,113,210,113,201,113,212,113,206,113,224,113,236,113,231,113,245,113,252,113,249,113,255,113,13,114,16,114,27,114,40,114,45,114,44,114,48,114,50,114,59,114,60,114,63,114,64,114,70,114,75,114,88,114,116,114,126,114,130,114,129,114,135,114,146,114,150,114,162,114,167,114,185,114,178,114,195,114,198,114,196,114,206,114,210,114,226,114,224,114,225,114,249,114,247,114,15,80,23,115,10,115,28,115,22,115,29,115,52,115,47,115,41,115,37,115,62,115,78,115,79,115,216,158,87,115,106,115,104,115,112,115,120,115,117,115,123,115,122,115,200,115,179,115,206,115,187,115,192,115,229,115,238,115,222,115,162,116,5,116,111,116,37,116,248,115,50,116,58,116,85,116,63,116,95,116,89,116,65,116,92,116,105,116,112,116,99,116,106,116,118,116,126,116,139,116,158,116,167,116,202,116,207,116,212,116,241,115,224,116,227,116,231,116,233,116,238,116,242,116,240,116,241,116,248,116,247,116,4,117,3,117,5,117,12,117,14,117,13,117,21,117,19,117,30,117,38,117,44,117,60,117,68,117,77,117,74,117,73,117,91,117,70,117,90,117,105,117,100,117,103,117,107,117,109,117,120,117,118,117,134,117,135,117,116,117,138,117,137,117,130,117,148,117,154,117,157,117,165,117,163,117,194,117,179,117,195,117,181,117,189,117,184,117,188,117,177,117,205,117,202,117,210,117,217,117,227,117,222,117,254,117,255,117,252,117,1,118,240,117,250,117,242,117,243,117,11,118,13,118,9,118,31,118,39,118,32,118,33,118,34,118,36,118,52,118,48,118,59,118,71,118,72,118,70,118,92,118,88,118,97,118,98,118,104,118,105,118,106,118,103,118,108,118,112,118,114,118,118,118,120,118,124,118,128,118,131,118,136,118,139,118,142,118,150,118,147,118,153,118,154,118,176,118,180,118,184,118,185,118,186,118,194,118,205,118,214,118,210,118,222,118,225,118,229,118,231,118,234,118,47,134,251,118,8,119,7,119,4,119,41,119,36,119,30,119,37,119,38,119,27,119,55,119,56,119,71,119,90,119,104,119,107,119,91,119,101,119,127,119,126,119,121,119,142,119,139,119,145,119,160,119,158,119,176,119,182,119,185,119,191,119,188,119,189,119,187,119,199,119,205,119,215,119,218,119,220,119,227,119,238,119,252,119,12,120,18,120,38,121,32,120,42,121,69,120,142,120,116,120,134,120,124,120,154,120,140,120,163,120,181,120,170,120,175,120,209,120,198,120,203,120,212,120,190,120,188,120,197,120,202,120,236,120,231,120,218,120,253,120,244,120,7,121,18,121,17,121,25,121,44,121,43,121,64,121,96,121,87,121,95,121,90,121,85,121,83,121,122,121,127,121,138,121,157,121,167,121,75,159,170,121,174,121,179,121,185,121,186,121,201,121,213,121,231,121,236,121,225,121,227,121,8,122,13,122,24,122,25,122,32,122,31,122,128,121,49,122,59,122,62,122,55,122,67,122,87,122,73,122,97,122,98,122,105,122,157,159,112,122,121,122,125,122,136,122,151,122,149,122,152,122,150,122,169,122,200,122,176,122,182,122,197,122,196,122,191,122,131,144,199,122,202,122,205,122,207,122,213,122,211,122,217,122,218,122,221,122,225,122,226,122,230,122,237,122,240,122,2,123,15,123,10,123,6,123,51,123,24,123,25,123,30,123,53,123,40,123,54,123,80,123,122,123,4,123,77,123,11,123,76,123,69,123,117,123,101,123,116,123,103,123,112,123,113,123,108,123,110,123,157,123,152,123,159,123,141,123,156,123,154,123,139,123,146,123,143,123,93,123,153,123,203,123,193,123,204,123,207,123,180,123,198,123,221,123,233,123,17,124,20,124,230,123,229,123,96,124,0,124,7,124,19,124,243,123,247,123,23,124,13,124,246,123,35,124,39,124,42,124,31,124,55,124,43,124,61,124,76,124,67,124,84,124,79,124,64,124,80,124,88,124,95,124,100,124,86,124,101,124,108,124,117,124,131,124,144,124,164,124,173,124,162,124,171,124,161,124,168,124,179,124,178,124,177,124,174,124,185,124,189,124,192,124,197,124,194,124,216,124,210,124,220,124,226,124,59,155,239,124,242,124,244,124,246,124,250,124,6,125,2,125,28,125,21,125,10,125,69,125,75,125,46,125,50,125,63,125,53,125,70,125,115,125,86,125,78,125,114,125,104,125,110,125,79,125,99,125,147,125,137,125,91,125,143,125,125,125,155,125,186,125,174,125,163,125,181,125,199,125,189,125,171,125,61,126,162,125,175,125,220,125,184,125,159,125,176,125,216,125,221,125,228,125,222,125,251,125,242,125,225,125,5,126,10,126,35,126,33,126,18,126,49,126,31,126,9,126,11,126,34,126,70,126,102,126,59,126,53,126,57,126,67,126,55,126,50,126,58,126,103,126,93,126,86,126,94,126,89,126,90,126,121,126,106,126,105,126,124,126,123,126,131,126,213,125,125,126,174,143,127,126,136,126,137,126,140,126,146,126,144,126,147,126,148,126,150,126,142,126,155,126,156,126,56,127,58,127,69,127,76,127,77,127,78,127,80,127,81,127,85,127,84,127,88,127,95,127,96,127,104,127,105,127,103,127,120,127,130,127,134,127,131,127,136,127,135,127,140,127,148,127,158,127,157,127,154,127,163,127,175,127,178,127,185,127,174,127,182,127,184,127,113,139,197,127,198,127,202,127,213,127,212,127,225,127,230,127,233,127,243,127,249,127,220,152],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+210108),
allocate([6,128,4,128,11,128,18,128,24,128,25,128,28,128,33,128,40,128,63,128,59,128,74,128,70,128,82,128,88,128,90,128,95,128,98,128,104,128,115,128,114,128,112,128,118,128,121,128,125,128,127,128,132,128,134,128,133,128,155,128,147,128,154,128,173,128,144,81,172,128,219,128,229,128,217,128,221,128,196,128,218,128,214,128,9,129,239,128,241,128,27,129,41,129,35,129,47,129,75,129,139,150,70,129,62,129,83,129,81,129,252,128,113,129,110,129,101,129,102,129,116,129,131,129,136,129,138,129,128,129,130,129,160,129,149,129,164,129,163,129,95,129,147,129,169,129,176,129,181,129,190,129,184,129,189,129,192,129,194,129,186,129,201,129,205,129,209,129,217,129,216,129,200,129,218,129,223,129,224,129,231,129,250,129,251,129,254,129,1,130,2,130,5,130,7,130,10,130,13,130,16,130,22,130,41,130,43,130,56,130,51,130,64,130,89,130,88,130,93,130,90,130,95,130,100,130,98,130,104,130,106,130,107,130,46,130,113,130,119,130,120,130,126,130,141,130,146,130,171,130,159,130,187,130,172,130,225,130,227,130,223,130,210,130,244,130,243,130,250,130,147,131,3,131,251,130,249,130,222,130,6,131,220,130,9,131,217,130,53,131,52,131,22,131,50,131,49,131,64,131,57,131,80,131,69,131,47,131,43,131,23,131,24,131,133,131,154,131,170,131,159,131,162,131,150,131,35,131,142,131,135,131,138,131,124,131,181,131,115,131,117,131,160,131,137,131,168,131,244,131,19,132,235,131,206,131,253,131,3,132,216,131,11,132,193,131,247,131,7,132,224,131,242,131,13,132,34,132,32,132,189,131,56,132,6,133,251,131,109,132,42,132,60,132,90,133,132,132,119,132,107,132,173,132,110,132,130,132,105,132,70,132,44,132,111,132,121,132,53,132,202,132,98,132,185,132,191,132,159,132,217,132,205,132,187,132,218,132,208,132,193,132,198,132,214,132,161,132,33,133,255,132,244,132,23,133,24,133,44,133,31,133,21,133,20,133,252,132,64,133,99,133,88,133,72,133,65,133,2,134,75,133,85,133,128,133,164,133,136,133,145,133,138,133,168,133,109,133,148,133,155,133,234,133,135,133,156,133,119,133,126,133,144,133,201,133,186,133,207,133,185,133,208,133,213,133,221,133,229,133,220,133,249,133,10,134,19,134,11,134,254,133,250,133,6,134,34,134,26,134,48,134,63,134,77,134,85,78,84,134,95,134,103,134,113,134,147,134,163,134,169,134,170,134,139,134,140,134,182,134,175,134,196,134,198,134,176,134,201,134,35,136,171,134,212,134,222,134,233,134,236,134,223,134,219,134,239,134,18,135,6,135,8,135,0,135,3,135,251,134,17,135,9,135,13,135,249,134,10,135,52,135,63,135,55,135,59,135,37,135,41,135,26,135,96,135,95,135,120,135,76,135,78,135,116,135,87,135,104,135,110,135,89,135,83,135,99,135,106,135,5,136,162,135,159,135,130,135,175,135,203,135,189,135,192,135,208,135,214,150,171,135,196,135,179,135,199,135,198,135,187,135,239,135,242,135,224,135,15,136,13,136,254,135,246,135,247,135,14,136,210,135,17,136,22,136,21,136,34,136,33,136,49,136,54,136,57,136,39,136,59,136,68,136,66,136,82,136,89,136,94,136,98,136,107,136,129,136,126,136,158,136,117,136,125,136,181,136,114,136,130,136,151,136,146,136,174,136,153,136,162,136,141,136,164,136,176,136,191,136,177,136,195,136,196,136,212,136,216,136,217,136,221,136,249,136,2,137,252,136,244,136,232,136,242,136,4,137,12,137,10,137,19,137,67,137,30,137,37,137,42,137,43,137,65,137,68,137,59,137,54,137,56,137,76,137,29,137,96,137,94,137,102,137,100,137,109,137,106,137,111,137,116,137,119,137,126,137,131,137,136,137,138,137,147,137,152,137,161,137,169,137,166,137,172,137,175,137,178,137,186,137,189,137,191,137,192,137,218,137,220,137,221,137,231,137,244,137,248,137,3,138,22,138,16,138,12,138,27,138,29,138,37,138,54,138,65,138,91,138,82,138,70,138,72,138,124,138,109,138,108,138,98,138,133,138,130,138,132,138,168,138,161,138,145,138,165,138,166,138,154,138,163,138,196,138,205,138,194,138,218,138,235,138,243,138,231,138,228,138,241,138,20,139,224,138,226,138,247,138,222,138,219,138,12,139,7,139,26,139,225,138,22,139,16,139,23,139,32,139,51,139,171,151,38,139,43,139,62,139,40,139,65,139,76,139,79,139,78,139,73,139,86,139,91,139,90,139,107,139,95,139,108,139,111,139,116,139,125,139,128,139,140,139,142,139,146,139,147,139,150,139,153,139,154,139,58,140,65,140,63,140,72,140,76,140,78,140,80,140,85,140,98,140,108,140,120,140,122,140,130,140,137,140,133,140,138,140,141,140,142,140,148,140,124,140,152,140,29,98,173,140,170,140,189,140,178,140,179,140,174,140,182,140,200,140,193,140,228,140,227,140,218,140,253,140,250,140,251,140,4,141,5,141,10,141,7,141,15,141,13,141,16,141,78,159,19,141,205,140,20,141,22,141,103,141,109,141,113,141,115,141,129,141,153,141,194,141,190,141,186,141,207,141,218,141,214,141,204,141,219,141,203,141,234,141,235,141,223,141,227,141,252,141,8,142,9,142,255,141,29,142,30,142,16,142,31,142,66,142,53,142,48,142,52,142,74,142,71,142,73,142,76,142,80,142,72,142,89,142,100,142,96,142,42,142,99,142,85,142,118,142,114,142,124,142,129,142,135,142,133,142,132,142,139,142,138,142,147,142,145,142,148,142,153,142,170,142,161,142,172,142,176,142,198,142,177,142,190,142,197,142,200,142,203,142,219,142,227,142,252,142,251,142,235,142,254,142,10,143,5,143,21,143,18,143,25,143,19,143,28,143,31,143,27,143,12,143,38,143,51,143,59,143,57,143,69,143,66,143,62,143,76,143,73,143,70,143,78,143,87,143,92,143,98,143,99,143,100,143,156,143,159,143,163,143,173,143,175,143,183,143,218,143,229,143,226,143,234,143,239,143,135,144,244,143,5,144,249,143,250,143,17,144,21,144,33,144,13,144,30,144,22,144,11,144,39,144,54,144,53,144,57,144,248,143,79,144,80,144,81,144,82,144,14,144,73,144,62,144,86,144,88,144,94,144,104,144,111,144,118,144,168,150,114,144,130,144,125,144,129,144,128,144,138,144,137,144,143,144,168,144,175,144,177,144,181,144,226,144,228,144,72,98,219,144,2,145,18,145,25,145,50,145,48,145,74,145,86,145,88,145,99,145,101,145,105,145,115,145,114,145,139,145,137,145,130,145,162,145,171,145,175,145,170,145,181,145,180,145,186,145,192,145,193,145,201,145,203,145,208,145,214,145,223,145,225,145,219,145,252,145,245,145,246,145,30,146,255,145,20,146,44,146,21,146,17,146,94,146,87,146,69,146,73,146,100,146,72,146,149,146,63,146,75,146,80,146,156,146,150,146,147,146,155,146,90,146,207,146,185,146,183,146,233,146,15,147,250,146,68,147,46,147,25,147,34,147,26,147,35,147,58,147,53,147,59,147,92,147,96,147,124,147,110,147,86,147,176,147,172,147,173,147,148,147,185,147,214,147,215,147,232,147,229,147,216,147,195,147,221,147,208,147,200,147,228,147,26,148,20,148,19,148,3,148,7,148,16,148,54,148,43,148,53,148,33,148,58,148,65,148,82,148,68,148,91,148,96,148,98,148,94,148,106,148,41,146,112,148,117,148,119,148,125,148,90,148,124,148,126,148,129,148,127,148,130,149,135,149,138,149,148,149,150,149,152,149,153,149,160,149,168,149,167,149,173,149,188,149,187,149,185,149,190,149,202,149,246,111,195,149,205,149,204,149,213,149,212,149,214,149,220,149,225,149,229,149,226,149,33,150,40,150,46,150,47,150,66,150,76,150,79,150,75,150,119,150,92,150,94,150,93,150,95,150,102,150,114,150,108,150,141,150,152,150,149,150,151,150,170,150,167,150,177,150,178,150,176,150,180,150,182,150,184,150,185,150,206,150,203,150,201,150,205,150,77,137,220,150,13,151,213,150,249,150,4,151,6,151,8,151,19,151,14,151,17,151,15,151,22,151,25,151,36,151,42,151,48,151,57,151,61,151,62,151,68,151,70,151,72,151,66,151,73,151,92,151,96,151,100,151,102,151,104,151,210,82,107,151,113,151,121,151,133,151,124,151,129,151,122,151,134,151,139,151,143,151,144,151,156,151,168,151,166,151,163,151,179,151,180,151,195,151,198,151,200,151,203,151,220,151,237,151,79,159,242,151,223,122,246,151,245,151,15,152,12,152,56,152,36,152,33,152,55,152,61,152,70,152,79,152,75,152,107,152,111,152,112,152,113,152,116,152,115,152,170,152,175,152,177,152,182,152,196,152,195,152,198,152,233,152,235,152,3,153,9,153,18,153,20,153,24,153,33,153,29,153,30,153,36,153,32,153,44,153,46,153,61,153,62,153,66,153,73,153,69,153,80,153,75,153,81,153,82,153,76,153,85,153,151,153,152,153,165,153,173,153,174,153,188,153,223,153,219,153,221,153,216,153,209,153,237,153,238,153,241,153,242,153,251,153,248,153,1,154,15,154,5,154,226,153,25,154,43,154,55,154,69,154,66,154,64,154,67,154,62,154,85,154,77,154,91,154,87,154,95,154,98,154,101,154,100,154,105,154,107,154,106,154,173,154,176,154,188,154,192,154,207,154,209,154,211,154,212,154,222,154,223,154,226,154,227,154,230,154,239,154,235,154,238,154,244,154,241,154,247,154,251,154,6,155,24,155,26,155,31,155,34,155,35,155,37,155,39,155,40,155,41,155,42,155,46,155,47,155,50,155,68,155,67,155,79,155,77,155,78,155,81,155,88,155,116,155,147,155,131,155,145,155,150,155,151,155,159,155,160,155,168,155,180,155,192,155,202,155,185,155,198,155,207,155,209,155,210,155,227,155,226,155,228,155,212,155,225,155,58,156,242,155,241,155,240,155,21,156,20,156,9,156,19,156,12,156,6,156,8,156,18,156,10,156,4,156,46,156,27,156,37,156,36,156,33,156,48,156,71,156,50,156,70,156,62,156,90,156,96,156,103,156,118,156,120,156,231,156,236,156,240,156,9,157,8,157,235,156,3,157,6,157,42,157,38,157,175,157,35,157,31,157,68,157,21,157,18,157,65,157,63,157,62,157,70,157,72,157,93,157,94,157,100,157,81,157,80,157,89,157,114,157,137,157,135,157,171,157,111,157,122,157,154,157,164,157,169,157,178,157,196,157,193,157,187,157,184,157,186,157,198,157,207,157,194,157,217,157,211,157,248,157,230,157,237,157,239,157,253,157,26,158,27,158,30,158,117,158,121,158,125,158,129,158,136,158,139,158,140,158,146,158,149,158,145,158,157,158,165,158,169,158,184,158,170,158,173,158,97,151,204,158,206,158,207,158,208,158,212,158,220,158,222,158,221,158,224,158,229,158,232,158,239,158,244,158,246,158,247,158,249,158,251,158,252,158,253,158,7,159,8,159,183,118,21,159,33,159,44,159,62,159,74,159,82,159,84,159,99,159,95,159,96,159,97,159,102,159,103,159,108,159,106,159,119,159,114,159,118,159,149,159,156,159,160,159,47,88,199,105,89,144,100,116,220,81,153,113,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,78,4,78,5,78,6,78,15,78,18,78,23,78,31,78,32,78,33,78,35,78,38,78,41,78,46,78,47,78,49,78,51,78,53,78,55,78,60,78,64,78,65,78,66,78,68,78,70,78,74,78,81,78,85,78,87,78,90,78,91,78,98,78,99,78,100,78,101,78,103,78,104,78,106,78,107,78,108,78,109,78,110,78,111,78,114,78,116,78,117,78,118,78,119,78,120,78,121,78,122,78,123,78,124,78,125,78,127,78,128,78,129,78,130,78,131,78,132,78,133,78,135,78,138,78,144,78,150,78,151,78,153,78,156,78,157,78,158,78,163,78,170,78,175,78,176,78,177,78,180,78,182,78,183,78,184,78,185,78,188,78,189,78,190,78,200,78,204,78,207,78,208,78,210,78,218,78,219,78,220,78,224,78,226,78,230,78,231,78,233,78,237,78,238,78,239,78,241,78,244,78,248,78,249,78,250,78,252,78,254,78,0,79,2,79,3,79,4,79,5,79,6,79,7,79,8,79,11,79,12,79,18,79,19,79,20,79,21,79,22,79,28,79,29,79,33,79,35,79,40,79,41,79,44,79,45,79,46,79,49,79,51,79,53,79,55,79,57,79,59,79,62,79,63,79,64,79,65,79,66,79,68,79,69,79,71,79,72,79,73,79,74,79,75,79,76,79,82,79,84,79,86,79,97,79,98,79,102,79,104,79,106,79,107,79,109,79,110,79,113,79,114,79,117,79,119,79,120,79,121,79,122,79,125,79,128,79,129,79,130,79,133,79,134,79,135,79,138,79,140,79,142,79,144,79,146,79,147,79,149,79,150,79,152,79,153,79,154,79,156,79,158,79,159,79,161,79,162,79,164,79,171,79,173,79,176,79,177,79,178,79,179,79,180,79,182,79,183,79,184,79,185,79,186,79,187,79,188,79,189,79,190,79,192,79,193,79,194,79,198,79,199,79,200,79,201,79,203,79,204,79,205,79,210,79,211,79,212,79,213,79,214,79,217,79,219,79,224,79,226,79,228,79,229,79,231,79,235,79,236,79,240,79,242,79,244,79,245,79,246,79,247,79,249,79,251,79,252,79,253,79,255,79,0,80,1,80,2,80,3,80,4,80,5,80,6,80,7,80,8,80,9,80,10,80,11,80,14,80,16,80,17,80,19,80,21,80,22,80,23,80,27,80,29,80,30,80,32,80,34,80,35,80,36,80,39,80,43,80,47,80,48,80,49,80,50,80,51,80,52,80,53,80,54,80,55,80,56,80,57,80,59,80,61,80,63,80,64,80,65,80,66,80,68,80,69,80,70,80,73,80,74,80,75,80,77,80,80,80,81,80,82,80,83,80,84,80,86,80,87,80,88,80,89,80,91,80,93,80,94,80,95,80,96,80,97,80,98,80,99,80,100,80,102,80,103,80,104,80,105,80,106,80,107,80,109,80,110,80,111,80,112,80,113,80,114,80,115,80,116,80,117,80,120,80,121,80,122,80,124,80,125,80,129,80,130,80,131,80,132,80,134,80,135,80,137,80,138,80,139,80,140,80,142,80,143,80,144,80,145,80,146,80,147,80,148,80,149,80,150,80,151,80,152,80,153,80,154,80,155,80,156,80,157,80,158,80,159,80,160,80,161,80,162,80,164,80,166,80,170,80,171,80,173,80,174,80,175,80,176,80,177,80,179,80,180,80,181,80,182,80,183,80,184,80,185,80,188,80,189,80,190,80,191,80,192,80,193,80,194,80,195,80,196,80,197,80,198,80,199,80,200,80,201,80,202,80,203,80,204,80,205,80,206,80,208,80,209,80,210,80,211,80,212,80,213,80,215,80,216,80,217,80,219,80,220,80,221,80,222,80,223,80,224,80,225,80,226,80,227,80,228,80,229,80,232,80,233,80,234,80,235,80,239,80,240,80,241,80,242,80,244,80,246,80,247,80,248,80,249,80,250,80,252,80,253,80,254,80,255,80,0,81,1,81,2,81,3,81,4,81,5,81,8,81,9,81,10,81,12,81,13,81,14,81,15,81,16,81,17,81,19,81,20,81,21,81,22,81,23,81,24,81,25,81,26,81,27,81,28,81,29,81,30,81,31,81,32,81,34,81,35,81,36,81,37,81,38,81,39,81,40,81,41,81,42,81,43,81,44,81,45,81,46,81,47,81,48,81,49,81,50,81,51,81,52,81,53,81,54,81,55,81,56,81,57,81,58,81,59,81,60,81,61,81,62,81,66,81,71,81,74,81,76,81,78,81,79,81,80,81,82,81,83,81,87,81,88,81,89,81,91,81,93,81,94,81,95,81,96,81,97,81,99,81,100,81,102,81,103,81,105,81,106,81,111,81,114,81,122,81,126,81,127,81,131,81,132,81,134,81,135,81,138,81,139,81,142,81,143,81,144,81,145,81,147,81,148,81,152,81,154,81,157,81,158,81,159,81,161,81,163,81,166,81,167,81,168,81,169,81,170,81,173,81,174,81,180,81,184,81,185,81,186,81,190,81,191,81,193,81,194,81,195,81,197,81,200,81,202,81,205,81,206,81,208,81,210,81,211,81,212,81,213,81,214,81,215,81,216,81,217,81,218,81,220,81,222,81,223,81,226,81,227,81,229,81,230,81,231,81,232,81,233,81,234,81,236,81,238,81,241,81,242,81,244,81,247,81,254,81,4,82,5,82,9,82,11,82,12,82,15,82,16,82,19,82,20,82,21,82,28,82,30,82,31,82,33,82,34,82,35,82,37,82,38,82,39,82,42,82,44,82,47,82,49,82,50,82,52,82,53,82,60,82,62,82,68,82,69,82,70,82,71,82,72,82,73,82,75,82,78,82,79,82,82,82,83,82,85,82,87,82,88,82,89,82,90,82,91,82,93,82,95,82,96,82,98,82,99,82,100,82,102,82,104,82,107,82,108,82,109,82,110,82,112,82,113,82,115,82,116,82,117,82,118,82,119,82,120,82,121,82,122,82,123,82,124,82,126,82,128,82,131,82,132,82,133,82,134,82,135,82,137,82,138,82,139,82,140,82,141,82,142,82,143,82,145,82,146,82,148,82,149,82,150,82,151,82,152,82,153,82,154,82,156,82,164,82,165,82,166,82,167,82,174,82,175,82,176,82,180,82,181,82,182,82,183,82,184,82,185,82,186,82,187,82,188,82,189,82,192,82,193,82,194,82,196,82,197,82,198,82,200,82,202,82,204,82,205,82,206,82,207,82,209,82,211,82,212,82,213,82,215,82,217,82,218,82,219,82,220,82,221,82,222,82,224,82,225,82,226,82,227,82,229,82,230,82,231,82,232,82,233,82,234,82,235,82,236,82,237,82,238,82,239,82,241,82,242,82,243,82,244,82,245,82,246,82,247,82,248,82,251,82,252,82,253,82,1,83,2,83,3,83,4,83,7,83,9,83,10,83,11,83,12,83,14,83,17,83,18,83,19,83,20,83,24,83,27,83,28,83,30,83,31,83,34,83,36,83,37,83,39,83,40,83,41,83,43,83,44,83,45,83,47,83,48,83,49,83,50,83,51,83,52,83,53,83,54,83,55,83,56,83,60,83,61,83,64,83,66,83,68,83,70,83,75,83,76,83,77,83,80,83,84,83,88,83,89,83,91,83,93,83,101,83,104,83,106,83,108,83,109,83,114,83,118,83,121,83,123,83,124,83,125,83,126,83,128,83,129,83,131,83,135,83,136,83,138,83,142,83,143,83,144,83,145,83,146,83,147,83,148,83,150,83,151,83,153,83,155,83,156,83,158,83,160,83,161,83,164,83,167,83,170,83,171,83,172,83,173,83,175,83,176,83,177,83,178,83,179,83,180,83,181,83,183,83,184,83,185,83,186,83,188,83,189,83,190,83,192,83,195,83,196,83,197,83,198,83,199,83,206,83,207,83,208,83,210,83,211,83,213,83,218,83,220,83,221,83,222,83,225,83,226,83,231,83,244,83,250,83,254,83,255,83,0,84,2,84,5,84,7,84,11,84,20,84,24,84,25,84,26,84,28,84,34,84,36,84,37,84,42,84,48,84,51,84,54,84,55,84,58,84,61,84,63,84,65,84,66,84,68,84,69,84,71,84,73,84,76,84,77,84,78,84,79,84,81,84,90,84,93,84,94,84,95,84,96,84,97,84,99,84,101,84,103,84,105,84,106,84,107,84,108,84,109,84,110,84,111,84,112,84,116,84,121,84,122,84,126,84,127,84,129,84,131,84,133,84,135,84,136,84,137,84,138,84,141,84,145,84,147,84,151,84,152,84,156,84,158,84,159,84,160,84,161,84,162,84,165,84,174,84,176,84,178,84,181,84,182,84,183,84,185,84,186,84,188,84,190,84,195,84,197,84,202,84,203,84,214,84,216,84,219,84,224,84,225,84,226,84,227,84,228,84,235,84,236,84,239,84,240,84,241,84,244,84,245,84,246,84,247,84,248,84,249,84,251,84,254,84,0,85,2,85,3,85,4,85,5,85,8,85,10,85,11,85,12,85,13,85,14,85,18,85,19,85,21,85,22,85,23,85,24,85,25,85,26,85,28,85,29,85,30,85,31,85,33,85,37,85,38,85,40,85,41,85,43,85,45,85,50,85,52,85,53,85,54,85,56,85,57,85,58,85,59,85,61,85,64,85,66,85,69,85,71,85,72,85,75,85,76,85,77,85,78,85,79,85,81,85,82,85,83,85,84,85,87,85,88,85,89,85,90,85,91,85,93,85,94,85,95,85,96,85,98,85,99,85,104,85,105,85,107,85,111,85,112,85,113,85,114,85,115,85,116,85,121,85,122,85,125,85,127,85,133,85,134,85,140,85,141,85,142,85,144,85,146,85,147,85,149,85,150,85,151,85,154,85,155,85,158,85,160,85,161,85,162,85,163,85,164,85,165,85,166,85,168,85,169,85,170,85,171,85,172,85,173,85,174,85,175,85,176,85,178,85,180,85,182,85,184,85,186,85,188,85,191,85,192,85,193,85,194,85,195,85,198,85,199,85,200,85,202,85,203,85,206,85,207,85,208,85,213,85,215,85,216,85,217,85,218,85,219,85,222,85,224,85,226,85,231,85,233,85,237,85,238,85,240,85,241,85,244,85,246,85,248,85,249,85,250,85,251,85,252,85,255,85,2,86,3,86,4,86,5,86,6,86,7,86,10,86,11,86,13,86,16,86,17,86,18,86,19,86,20,86,21,86,22,86,23,86,25,86,26,86,28,86,29,86,32,86,33,86,34,86,37,86,38,86,40,86,41,86,42,86,43,86,46,86,47,86,48,86,51,86,53,86,55,86,56,86,58,86,60,86,61,86,62,86,64,86,65,86,66,86,67,86,68,86,69,86,70,86,71,86,72,86,73,86,74,86,75,86,79,86,80,86,81,86,82,86,83,86,85,86,86,86,90,86,91,86,93,86,94,86,95,86,96,86,97,86,99,86,101,86,102,86,103,86,109,86,110,86,111,86,112,86,114,86,115,86,116,86,117,86,119,86,120,86,121,86,122,86,125,86,126,86,127,86,128,86,129,86,130,86,131,86,132,86,135,86,136,86,137,86,138,86,139,86,140,86,141,86,144,86,145,86,146,86,148,86,149,86,150,86,151,86,152,86,153,86,154,86,155,86,156,86,157,86,158,86,159,86,160,86,161,86,162,86,164,86,165,86,166,86,167,86,168,86,169,86,170,86,171,86,172,86,173,86,174,86,176,86,177,86,178,86,179,86,180,86,181,86,182,86,184,86,185,86,186,86,187,86,189,86,190,86,191,86,192,86,193,86,194,86,195,86,196,86,197,86,198,86,199,86,200,86,201,86,203,86,204,86,205,86,206,86,207,86,208,86,209,86,210,86,211,86,213,86,214,86,216,86,217,86,220,86,227,86,229,86,230,86,231,86,232,86,233,86,234,86,236,86,238,86,239,86,242,86,243,86,246,86,247,86,248,86,251,86,252,86,0,87,1,87,2,87,5,87,7,87,11,87,12,87,13,87,14,87,15,87,16,87,17,87,18,87,19,87,20,87,21,87,22,87,23,87,24,87,25,87,26,87,27,87,29,87,30,87,32,87,33,87,34,87,36,87,37,87,38,87,39,87,43,87,49,87,50,87,52,87,53,87,54,87,55,87,56,87,60,87,61,87,63,87,65,87,67,87,68,87,69,87,70,87,72,87,73,87,75,87,82,87,83,87,84,87,85,87,86,87,88,87,89,87,98,87,99,87,101,87,103,87,108,87,110,87,112,87,113,87,114,87,116,87,117,87,120,87,121,87,122,87,125,87,126,87,127,87,128,87,129,87,135,87,136,87,137,87,138,87,141,87,142,87,143,87,144,87,145,87,148,87,149,87,150,87,151,87,152,87,153,87,154,87,156,87,157,87,158,87,159,87,165,87,168,87,170,87,172,87,175,87,176,87,177,87,179,87,181,87,182,87,183,87,185,87,186,87,187,87,188,87,189,87,190,87,191,87,192,87,193,87,196,87,197,87,198,87,199,87,200,87,201,87,202,87,204,87,205,87,208,87,209,87,211,87,214,87,215,87,219,87,220,87,222,87,225,87,226,87,227,87,229,87,230,87,231,87,232,87,233,87,234,87,235,87,236,87,238,87,240,87,241,87,242,87,243,87,245,87,246,87,247,87,251,87,252,87,254,87,255,87,1,88,3,88,4,88,5,88,8,88,9,88,10,88,12,88,14,88,15,88,16,88,18,88,19,88,20,88,22,88,23,88,24,88,26,88,27,88,28,88,29,88,31,88,34,88,35,88,37,88,38,88,39,88,40,88,41,88,43,88,44,88,45,88,46,88,47,88,49,88,50,88,51,88,52,88,54,88,55,88,56,88,57,88,58,88,59,88,60,88,61,88,62,88,63,88,64,88,65,88,66,88,67,88,69,88,70,88,71,88,72,88,73,88,74,88,75,88,78,88,79,88,80,88,82,88,83,88,85,88,86,88,87,88,89,88,90,88,91,88,92,88,93,88,95,88,96,88,97,88,98,88,99,88,100,88,102,88,103,88,104,88,105,88,106,88,109,88,110,88,111,88,112,88,113,88,114,88,115,88,116,88,117,88,118,88,119,88,120,88,121,88,122,88,123,88,124,88,125,88,127,88,130,88,132,88,134,88,135,88,136,88,138,88,139,88,140,88,141,88,142,88,143,88,144,88,145,88,148,88,149,88,150,88,151,88,152,88,155,88,156,88,157,88,160,88,161,88,162,88,163,88,164,88,165,88,166,88,167,88,170,88,171,88,172,88,173,88,174,88,175,88,176,88,177,88,178,88,179,88,180,88,181,88,182,88,183,88,184,88,185,88,186,88,187,88,189,88,190,88,191,88,192,88,194,88,195,88,196,88,198,88,199,88,200,88,201,88,202,88,203,88,204,88,205,88,206,88,207,88,208,88,210,88,211,88,212,88,214,88,215,88,216,88,217,88,218,88,219,88,220,88,221,88,222,88,223,88,224,88,225,88,226,88,227,88,229,88,230,88,231,88,232,88,233,88,234,88,237,88,239,88,241,88,242,88,244,88,245,88,247,88,248,88,250,88,251,88,252,88,253,88,254,88,255,88,0,89,1,89,3,89,5,89,6,89,8,89,9,89,10,89,11,89,12,89,14,89,16,89,17,89,18,89,19,89,23,89,24,89,27,89,29,89,30,89,32,89,33,89,34,89,35,89,38,89,40,89,44,89,48,89,50,89,51,89,53,89,54,89,59,89,61,89,62,89,63,89,64,89,67,89,69,89,70,89,74,89,76,89,77,89,80,89,82,89,83,89,89,89,91,89,92,89,93,89,94,89,95,89,97,89,99,89,100,89,102,89,103,89,104,89,105,89,106,89,107,89,108,89,109,89,110,89,111,89,112,89,113,89,114,89,117,89,119,89,122,89,123,89,124,89,126,89,127,89,128,89,133,89,137,89,139,89,140,89,142,89,143,89,144,89,145,89,148,89,149,89,152,89,154,89,155,89,156,89,157,89,159,89,160,89,161,89,162,89,166,89,167,89,172,89,173,89,176,89,177,89,179,89,180,89,181,89,182,89,183,89,184,89,186,89,188,89,189,89,191,89,192,89,193,89,194,89,195,89,196,89,197,89,199,89,200,89,201,89,204,89,205,89,206,89,207,89,213,89,214,89,217,89,219,89,222,89,223,89,224,89,225,89,226,89,228,89,230,89,231,89,233,89,234,89,235,89,237,89,238,89,239,89,240,89,241,89,242,89,243,89,244,89,245,89,246,89,247,89,248,89,250,89,252,89,253,89,254,89,0,90,2,90,10,90,11,90,13,90,14,90,15,90,16,90,18,90,20,90,21,90,22,90,23,90,25,90,26,90,27,90,29,90,30,90,33,90,34,90,36,90,38,90,39,90,40,90,42,90,43,90,44,90,45,90,46,90,47,90,48,90,51,90,53,90,55,90,56,90,57,90,58,90,59,90,61,90,62,90,63,90,65,90,66,90,67,90,68,90,69,90,71,90,72,90,75,90,76,90,77,90,78,90,79,90,80,90,81,90,82,90,83,90,84,90,86,90,87,90,88,90,89,90,91,90,92,90,93,90,94,90,95,90,96,90,97,90,99,90,100,90,101,90,102,90,104,90,105,90,107,90,108,90,109,90,110,90,111,90,112,90,113,90,114,90,115,90,120,90,121,90,123,90,124,90,125,90,126,90,128,90,129,90,130,90,131,90,132,90,133,90,134,90,135,90,136,90,137,90,138,90,139,90,140,90,141,90,142,90,143,90,144,90,145,90,147,90,148,90,149,90,150,90,151,90,152,90,153,90,156,90,157,90,158,90,159,90,160,90,161,90,162,90,163,90,164,90,165,90,166,90,167,90,168,90,169,90,171,90,172,90,173,90,174,90,175,90,176,90,177,90,180,90,182,90,183,90,185,90,186,90,187,90,188,90,189,90,191,90,192,90,195,90,196,90,197,90,198,90,199,90,200,90,202,90,203,90,205,90,206,90,207,90,208,90,209,90,211,90,213,90,215,90,217,90,218,90,219,90,221,90,222,90,223,90,226,90,228,90,229,90,231,90,232,90,234,90,236,90,237,90,238,90,239,90,240,90,242,90,243,90,244,90,245,90,246,90,247,90,248,90,249,90,250,90,251,90,252,90,253,90,254,90,255,90,0,91,1,91,2,91,3,91,4,91,5,91,6,91,7,91,8,91,10,91,11,91,12,91,13,91,14,91,15,91,16,91,17,91,18,91,19,91,20,91,21,91,24,91,25,91,26,91,27,91,28,91,29,91,30,91,31,91,32,91,33,91,34,91,35,91,36,91,37,91,38,91,39,91,40,91,41,91,42,91,43,91,44,91,45,91,46,91,47,91,48,91,49,91,51,91,53,91,54,91,56,91,57,91,58,91,59,91,60,91,61,91,62,91,63,91,65,91,66,91,67,91,68,91,69,91,70,91,71,91,72,91,73,91,74,91,75,91,76,91,77,91,78,91,79,91,82,91,86,91,94,91,96,91,97,91,103,91,104,91,107,91,109,91,110,91,111,91,114,91,116,91,118,91,119,91,120,91,121,91,123,91,124,91,126,91,127,91,130,91,134,91,138,91,141,91,142,91,144,91,145,91,146,91,148,91,150,91,159,91,167,91,168,91,169,91,172,91,173,91,174,91,175,91,177,91,178,91,183,91,186,91,187,91,188,91,192,91,193,91,195,91,200,91,201,91,202,91,203,91,205,91,206,91,207,91,209,91,212,91,213,91,214,91,215,91,216,91,217,91,218,91,219,91,220,91,224,91,226,91,227,91,230,91,231,91,233,91,234,91,235,91,236,91,237,91,239,91,241,91,242,91,243,91,244,91,245,91,246,91,247,91,253,91,254,91,0,92,2,92,3,92,5,92,7,92,8,92,11,92,12,92,13,92,14,92,16,92,18,92,19,92,23,92,25,92,27,92,30,92,31,92,32,92,33,92,35,92,38,92,40,92,41,92,42,92,43,92,45,92,46,92,47,92,48,92,50,92,51,92,53,92,54,92,55,92,67,92,68,92,70,92,71,92,76,92,77,92,82,92,83,92,84,92,86,92,87,92,88,92,90,92,91,92,92,92,93,92,95,92,98,92,100,92,103,92,104,92,105,92,106,92,107,92,108,92,109,92,112,92,114,92,115,92,116,92,117,92,118,92,119,92,120,92,123,92,124,92,125,92,126,92,128,92,131,92,132,92,133,92,134,92,135,92,137,92,138,92,139,92,142,92,143,92,146,92,147,92,149,92,157,92,158,92,159,92,160,92,161,92,164,92,165,92,166,92,167,92,168,92,170,92,174,92,175,92,176,92,178,92,180,92,182,92,185,92,186,92,187,92,188,92,190,92,192,92,194,92,195,92,197,92,198,92,199,92,200,92,201,92,202,92,204,92,205,92,206,92,207,92,208,92,209,92,211,92,212,92,213,92,214,92,215,92,216,92,218,92,219,92,220,92,221,92,222,92,223,92,224,92,226,92,227,92,231,92,233,92,235,92,236,92,238,92,239,92,241,92,242,92,243,92,244,92,245,92,246,92,247,92,248,92,249,92,250,92,252,92,253,92,254,92,255,92,0,93,1,93,4,93,5,93,8,93,9,93,10,93,11,93,12,93,13,93,15,93,16,93,17,93,18,93,19,93,21,93,23,93,24,93,25,93,26,93,28,93,29,93,31,93,32,93,33,93,34,93,35,93,37,93,40,93,42,93,43,93,44,93,47,93,48,93,49,93,50,93,51,93,53,93,54,93,55,93,56,93,57,93,58,93,59,93,60,93,63,93,64,93,65,93,66,93,67,93,68,93,69,93,70,93,72,93,73,93,77,93,78,93,79,93,80,93,81,93,82,93,83,93,84,93,85,93,86,93,87,93,89,93,90,93,92,93,94,93,95,93,96,93,97,93,98,93,99,93,100,93,101,93,102,93,103,93,104,93,106,93,109,93,110,93,112,93,113,93,114,93,115,93,117,93,118,93,119,93,120,93,121,93,122,93,123,93,124,93,125,93,126,93,127,93,128,93,129,93,131,93,132,93,133,93,134,93,135,93,136,93,137,93,138,93,139,93,140,93,141,93,142,93,143,93,144,93,145,93,146,93,147,93,148,93,149,93,150,93,151,93,152,93,154,93,155,93,156,93,158,93,159,93,160,93,161,93,162,93,163,93,164,93,165,93,166,93,167,93,168,93,169,93,170,93,171,93,172,93,173,93,174,93,175,93,176,93,177,93,178,93,179,93,180,93,181,93,182,93,184,93,185,93,186,93,187,93,188,93,189,93,190,93,191,93,192,93,193,93,194,93,195,93,196,93,198,93,199,93,200,93,201,93,202,93,203,93,204,93,206,93,207,93,208,93,209,93,210,93,211,93,212,93,213,93,214,93,215,93,216,93,217,93,218,93,220,93,223,93,224,93,227,93,228,93,234,93,236,93,237,93,240,93,245,93,246,93,248,93,249,93,250,93,251,93,252,93,255,93,0,94,4,94,7,94,9,94,10,94,11,94,13,94,14,94,18,94,19,94,23,94,30,94,31,94,32,94,33,94,34,94,35,94,36,94,37,94,40,94,41,94,42,94,43,94,44,94,47,94,48,94,50,94,51,94,52,94,53,94,54,94,57,94,58,94,62,94,63,94,64,94,65,94,67,94,70,94,71,94,72,94,73,94,74,94,75,94,77,94,78,94,79,94,80,94,81,94,82,94,83,94,86,94,87,94,88,94,89,94,90,94,92,94,93,94,95,94,96,94,99,94,100,94,101,94,102,94,103,94,104,94,105,94,106,94,107,94,108,94,109,94,110,94,111,94,112,94,113,94,117,94,119,94,121,94,126,94,129,94,130,94,131,94,133,94,136,94,137,94,140,94,141,94,142,94,146,94,152,94,155,94,157,94,161,94,162,94,163,94,164,94,168,94,169,94,170,94,171,94,172,94,174,94,175,94,176,94,177,94,178,94,180,94,186,94,187,94,188,94,189,94,191,94,192,94,193,94,194,94,195,94,196,94,197,94,198,94,199,94,200,94,203,94,204,94,205,94,206,94,207,94,208,94,212,94,213,94,215,94,216,94,217,94,218,94,220,94,221,94,222,94,223,94,224,94,225,94,226,94,227,94,228,94,229,94,230,94,231,94,233,94,235,94,236,94,237,94,238,94,239,94,240,94,241,94,242,94,243,94,245,94,248,94,249,94,251,94,252,94,253,94,5,95,6,95,7,95,9,95,12,95,13,95,14,95,16,95,18,95,20,95,22,95,25,95,26,95,28,95,29,95,30,95,33,95,34,95,35,95,36,95,40,95,43,95,44,95,46,95,48,95,50,95,51,95,52,95,53,95,54,95,55,95,56,95,59,95,61,95,62,95,63,95,65,95,66,95,67,95,68,95,69,95,70,95,71,95,72,95,73,95,74,95,75,95,76,95,77,95,78,95,79,95,81,95,84,95,89,95,90,95,91,95,92,95,94,95,95,95,96,95,99,95,101,95,103,95,104,95,107,95,110,95,111,95,114,95,116,95,117,95,118,95,120,95,122,95,125,95,126,95,127,95,131,95,134,95,141,95,142,95,143,95,145,95,147,95,148,95,150,95,154,95,155,95,157,95,158,95,159,95,160,95,162,95,163,95,164,95,165,95,166,95,167,95,169,95,171,95,172,95,175,95,176,95,177,95,178,95,179,95,180,95,182,95,184,95,185,95,186,95,187,95,190,95,191,95,192,95,193,95,194,95,199,95,200,95,202,95,203,95,206,95,211,95,212,95,213,95,218,95,219,95,220,95,222,95,223,95,226,95,227,95,229,95,230,95,232,95,233,95,236,95,239,95,240,95,242,95,243,95,244,95,246,95,247,95,249,95,250,95,252,95,7,96,8,96,9,96,11,96,12,96,16,96,17,96,19,96,23,96,24,96,26,96,30,96,31,96,34,96,35,96,36,96,44,96,45,96,46,96,48,96,49,96,50,96,51,96,52,96,54,96,55,96,56,96,57,96,58,96,61,96,62,96,64,96,68,96,69,96,70,96,71,96,72,96,73,96,74,96,76,96,78,96,79,96,81,96,83,96,84,96,86,96,87,96,88,96,91,96,92,96,94,96,95,96,96,96,97,96,101,96,102,96,110,96,113,96,114,96,116,96,117,96,119,96,126,96,128,96,129,96,130,96,133,96,134,96,135,96,136,96,138,96,139,96,142,96,143,96,144,96,145,96,147,96,149,96,151,96,152,96,153,96,156,96,158,96,161,96,162,96,164,96,165,96,167,96,169,96,170,96,174,96,176,96,179,96,181,96,182,96,183,96,185,96,186,96,189,96,190,96,191,96,192,96,193,96,194,96,195,96,196,96,199,96,200,96,201,96,204,96,205,96,206,96,207,96,208,96,210,96,211,96,212,96,214,96,215,96,217,96,219,96,222,96,225,96,226,96,227,96,228,96,229,96,234,96,241,96,242,96,245,96,247,96,248,96,251,96,252,96,253,96,254,96,255,96,2,97,3,97,4,97,5,97,7,97,10,97,11,97,12,97,16,97,17,97,18,97,19,97,20,97,22,97,23,97,24,97,25,97,27,97,28,97,29,97,30,97,33,97,34,97,37,97,40,97,41,97,42,97,44,97,45,97,46,97,47,97,48,97,49,97,50,97,51,97,52,97,53,97,54,97,55,97,56,97,57,97,58,97,59,97,60,97,61,97,62,97,64,97,65,97,66,97,67,97,68,97,69,97,70,97,71,97,73,97,75,97,77,97,79,97,80,97,82,97,83,97,84,97,86,97,87,97,88,97,89,97,90,97,91,97,92,97,94,97,95,97,96,97,97,97,99,97,100,97,101,97,102,97,105,97,106,97,107,97,108,97,109,97,110,97,111,97,113,97,114,97,115,97,116,97,118,97,120,97,121,97,122,97,123,97,124,97,125,97,126,97,127,97,128,97,129,97,130,97,131,97,132,97,133,97,134,97,135,97,136,97,137,97,138,97,140,97,141,97,143,97,144,97,145,97,146,97,147,97,149,97,150,97,151,97,152,97,153,97,154,97,155,97,156,97,158,97,159,97,160,97,161,97,162,97,163,97,164,97,165,97,166,97,170,97,171,97,173,97,174,97,175,97,176,97,177,97,178,97,179,97,180,97,181,97,182,97,184,97,185,97,186,97,187,97,188,97,189,97,191,97,192,97,193,97,195,97,196,97,197,97,198,97,199,97,201,97,204,97,205,97,206,97,207,97,208,97,211,97,213,97,214,97,215,97,216,97,217,97,218,97,219,97,220,97,221,97,222,97,223,97,224,97,225,97,226,97,227,97,228,97,229,97,231,97,232,97,233,97,234,97,235,97,236,97,237,97,238,97,239,97,240,97,241,97,242,97,243,97,244,97,246,97,247,97,248,97,249,97,250,97,251,97,252,97,253,97,254,97,0,98,1,98,2,98,3,98,4,98,5,98,7,98,9,98,19,98,20,98,25,98,28,98,29,98,30,98,32,98,35,98,38,98,39,98,40,98,41,98,43,98,45,98,47,98,48,98,49,98,50,98,53,98,54,98,56,98,57,98,58,98,59,98,60,98,66,98,68,98,69,98,70,98,74,98,79,98,80,98,85,98,86,98,87,98,89,98,90,98,92,98,93,98,94,98,95,98,96,98,97,98,98,98,100,98,101,98,104,98,113,98,114,98,116,98,117,98,119,98,120,98,122,98,123,98,125,98,129,98,130,98,131,98,133,98,134,98,135,98,136,98,139,98,140,98,141,98,142,98,143,98,144,98,148,98,153,98,156,98,157,98,158,98,163,98,166,98,167,98,169,98,170,98,173,98,174,98,175,98,176,98,178,98,179,98,180,98,182,98,183,98,184,98,186,98,190,98,192,98,193,98,195,98,203,98,207,98,209,98,213,98,221,98,222,98,224,98,225,98,228,98,234,98,235,98,240,98,242,98,245,98,248,98,249,98,250,98,251,98,0,99,3,99,4,99,5,99,6,99,10,99,11,99,12,99,13,99,15,99,16,99,18,99,19,99,20,99,21,99,23,99,24,99,25,99,28,99,38,99,39,99,41,99,44,99,45,99,46,99,48,99,49,99,51,99,52,99,53,99,54,99,55,99,56,99,59,99,60,99,62,99,63,99,64,99,65,99,68,99,71,99,72,99,74,99,81,99,82,99,83,99,84,99,86,99,87,99,88,99,89,99,90,99,91,99,92,99,93,99,96,99,100,99,101,99,102,99,104,99,106,99,107,99,108,99,111,99,112,99,114,99,115,99,116,99,117,99,120,99,121,99,124,99,125,99,126,99,127,99,129,99,131,99,132,99,133,99,134,99,139,99,141,99,145,99,147,99,148,99,149,99,151,99,153,99,154,99,155,99,156,99,157,99,158,99,159,99,161,99,164,99,166,99,171,99,175,99,177,99,178,99,181,99,182,99,185,99,187,99,189,99,191,99,192,99,193,99,194,99,195,99,197,99,199,99,200,99,202,99,203,99,204,99,209,99,211,99,212,99,213,99,215,99,216,99,217,99,218,99,219,99,220,99,221,99,223,99,226,99,228,99,229,99,230,99,231,99,232,99,235,99,236,99,238,99,239,99,240,99,241,99,243,99,245,99,247,99,249,99,250,99,251,99,252,99,254,99,3,100,4,100,6,100,7,100,8,100,9,100,10,100,13,100,14,100,17,100,18,100,21,100,22,100,23,100,24,100,25,100,26,100,29,100,31,100,34,100,35,100,36,100,37,100,39,100,40,100,41,100,43,100,46,100,47,100,48,100,49,100,50,100,51,100,53,100,54,100,55,100,56,100,57,100,59,100,60,100,62,100,64,100,66,100,67,100,73,100,75,100,76,100,77,100,78,100,79,100,80,100,81,100,83,100,85,100,86,100,87,100,89,100,90,100,91,100,92,100,93,100,95,100,96,100,97,100,98,100,99,100,100,100,101,100,102,100,104,100,106,100,107,100,108,100,110,100,111,100,112,100,113,100,114,100,115,100,116,100,117,100,118,100,119,100,123,100,124,100,125,100,126,100,127,100,128,100,129,100,131,100,134,100,136,100,137,100,138,100,139,100,140,100,141,100,142,100,143,100,144,100,147,100,148,100,151,100,152,100,154,100,155,100,156,100,157,100,159,100,160,100,161,100,162,100,163,100,165,100,166,100,167,100,168,100,170,100,171,100,175,100,177,100,178,100,179,100,180,100,182,100,185,100,187,100,189,100,190,100,191,100,193,100,195,100,196,100,198,100,199,100,200,100,201,100,202,100,203,100,204,100,207,100,209,100,211,100,212,100,213,100,214,100,217,100,218,100,219,100,220,100,221,100,223,100,224,100,225,100,227,100,229,100,231,100,232,100,233,100,234,100,235,100,236,100,237,100,238,100,239,100,240,100,241,100,242,100,243,100,244,100,245,100,246,100,247,100,248,100,249,100,250,100,251,100,252,100,253,100,254,100,255,100,1,101,2,101,3,101,4,101,5,101,6,101,7,101,8,101,10,101,11,101,12,101,13,101,14,101,15,101,16,101,17,101,19,101,20,101,21,101,22,101,23,101,25,101,26,101,27,101,28,101,29,101,30,101,31,101,32,101,33,101,34,101,35,101,36,101,38,101,39,101,40,101,41,101,42,101,44,101,45,101,48,101,49,101,50,101,51,101,55,101,58,101,60,101,61,101,64,101,65,101,66,101,67,101,68,101,70,101,71,101,74,101,75,101,77,101,78,101,80,101,82,101,83,101,84,101,87,101,88,101,90,101,92,101,95,101,96,101,97,101,100,101,101,101,103,101,104,101,105,101,106,101,109,101,110,101,111,101,113,101,115,101,117,101,118,101,120,101,121,101,122,101,123,101,124,101,125,101,126,101,127,101,128,101,129,101,130,101,131,101,132,101,133,101,134,101,136,101,137,101,138,101,141,101,142,101,143,101,146,101,148,101,149,101,150,101,152,101,154,101,157,101],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+220348),
allocate([158,101,160,101,162,101,163,101,166,101,168,101,170,101,172,101,174,101,177,101,178,101,179,101,180,101,181,101,182,101,183,101,184,101,186,101,187,101,190,101,191,101,192,101,194,101,199,101,200,101,201,101,202,101,205,101,208,101,209,101,211,101,212,101,213,101,216,101,217,101,218,101,219,101,220,101,221,101,222,101,223,101,225,101,227,101,228,101,234,101,235,101,242,101,243,101,244,101,245,101,248,101,249,101,251,101,252,101,253,101,254,101,255,101,1,102,4,102,5,102,7,102,8,102,9,102,11,102,13,102,16,102,17,102,18,102,22,102,23,102,24,102,26,102,27,102,28,102,30,102,33,102,34,102,35,102,36,102,38,102,41,102,42,102,43,102,44,102,46,102,48,102,50,102,51,102,55,102,56,102,57,102,58,102,59,102,61,102,63,102,64,102,66,102,68,102,69,102,70,102,71,102,72,102,73,102,74,102,77,102,78,102,80,102,81,102,88,102,89,102,91,102,92,102,93,102,94,102,96,102,98,102,99,102,101,102,103,102,105,102,106,102,107,102,108,102,109,102,113,102,114,102,115,102,117,102,120,102,121,102,123,102,124,102,125,102,127,102,128,102,129,102,131,102,133,102,134,102,136,102,137,102,138,102,139,102,141,102,142,102,143,102,144,102,146,102,147,102,148,102,149,102,152,102,153,102,154,102,155,102,156,102,158,102,159,102,160,102,161,102,162,102,163,102,164,102,165,102,166,102,169,102,170,102,171,102,172,102,173,102,175,102,176,102,177,102,178,102,179,102,181,102,182,102,183,102,184,102,186,102,187,102,188,102,189,102,191,102,192,102,193,102,194,102,195,102,196,102,197,102,198,102,199,102,200,102,201,102,202,102,203,102,204,102,205,102,206,102,207,102,208,102,209,102,210,102,211,102,212,102,213,102,214,102,215,102,216,102,218,102,222,102,223,102,224,102,225,102,226,102,227,102,228,102,229,102,231,102,232,102,234,102,235,102,236,102,237,102,238,102,239,102,241,102,245,102,246,102,248,102,250,102,251,102,253,102,1,103,2,103,3,103,4,103,5,103,6,103,7,103,12,103,14,103,15,103,17,103,18,103,19,103,22,103,24,103,25,103,26,103,28,103,30,103,32,103,33,103,34,103,35,103,36,103,37,103,39,103,41,103,46,103,48,103,50,103,51,103,54,103,55,103,56,103,57,103,59,103,60,103,62,103,63,103,65,103,68,103,69,103,71,103,74,103,75,103,77,103,82,103,84,103,85,103,87,103,88,103,89,103,90,103,91,103,93,103,98,103,99,103,100,103,102,103,103,103,107,103,108,103,110,103,113,103,116,103,118,103,120,103,121,103,122,103,123,103,125,103,128,103,130,103,131,103,133,103,134,103,136,103,138,103,140,103,141,103,142,103,143,103,145,103,146,103,147,103,148,103,150,103,153,103,155,103,159,103,160,103,161,103,164,103,166,103,169,103,172,103,174,103,177,103,178,103,180,103,185,103,186,103,187,103,188,103,189,103,190,103,191,103,192,103,194,103,197,103,198,103,199,103,200,103,201,103,202,103,203,103,204,103,205,103,206,103,213,103,214,103,215,103,219,103,223,103,225,103,227,103,228,103,230,103,231,103,232,103,234,103,235,103,237,103,238,103,242,103,245,103,246,103,247,103,248,103,249,103,250,103,251,103,252,103,254,103,1,104,2,104,3,104,4,104,6,104,13,104,16,104,18,104,20,104,21,104,24,104,25,104,26,104,27,104,28,104,30,104,31,104,32,104,34,104,35,104,36,104,37,104,38,104,39,104,40,104,43,104,44,104,45,104,46,104,47,104,48,104,49,104,52,104,53,104,54,104,58,104,59,104,63,104,71,104,75,104,77,104,79,104,82,104,86,104,87,104,88,104,89,104,90,104,91,104,92,104,93,104,94,104,95,104,106,104,108,104,109,104,110,104,111,104,112,104,113,104,114,104,115,104,117,104,120,104,121,104,122,104,123,104,124,104,125,104,126,104,127,104,128,104,130,104,132,104,135,104,136,104,137,104,138,104,139,104,140,104,141,104,142,104,144,104,145,104,146,104,148,104,149,104,150,104,152,104,153,104,154,104,155,104,156,104,157,104,158,104,159,104,160,104,161,104,163,104,164,104,165,104,169,104,170,104,171,104,172,104,174,104,177,104,178,104,180,104,182,104,183,104,184,104,185,104,186,104,187,104,188,104,189,104,190,104,191,104,193,104,195,104,196,104,197,104,198,104,199,104,200,104,202,104,204,104,206,104,207,104,208,104,209,104,211,104,212,104,214,104,215,104,217,104,219,104,220,104,221,104,222,104,223,104,225,104,226,104,228,104,229,104,230,104,231,104,232,104,233,104,234,104,235,104,236,104,237,104,239,104,242,104,243,104,244,104,246,104,247,104,248,104,251,104,253,104,254,104,255,104,0,105,2,105,3,105,4,105,6,105,7,105,8,105,9,105,10,105,12,105,15,105,17,105,19,105,20,105,21,105,22,105,23,105,24,105,25,105,26,105,27,105,28,105,29,105,30,105,33,105,34,105,35,105,37,105,38,105,39,105,40,105,41,105,42,105,43,105,44,105,46,105,47,105,49,105,50,105,51,105,53,105,54,105,55,105,56,105,58,105,59,105,60,105,62,105,64,105,65,105,67,105,68,105,69,105,70,105,71,105,72,105,73,105,74,105,75,105,76,105,77,105,78,105,79,105,80,105,81,105,82,105,83,105,85,105,86,105,88,105,89,105,91,105,92,105,95,105,97,105,98,105,100,105,101,105,103,105,104,105,105,105,106,105,108,105,109,105,111,105,112,105,114,105,115,105,116,105,117,105,118,105,122,105,123,105,125,105,126,105,127,105,129,105,131,105,133,105,138,105,139,105,140,105,142,105,143,105,144,105,145,105,146,105,147,105,150,105,151,105,153,105,154,105,157,105,158,105,159,105,160,105,161,105,162,105,163,105,164,105,165,105,166,105,169,105,170,105,172,105,174,105,175,105,176,105,178,105,179,105,181,105,182,105,184,105,185,105,186,105,188,105,189,105,190,105,191,105,192,105,194,105,195,105,196,105,197,105,198,105,199,105,200,105,201,105,203,105,205,105,207,105,209,105,210,105,211,105,213,105,214,105,215,105,216,105,217,105,218,105,220,105,221,105,222,105,225,105,226,105,227,105,228,105,229,105,230,105,231,105,232,105,233,105,234,105,235,105,236,105,238,105,239,105,240,105,241,105,243,105,244,105,245,105,246,105,247,105,248,105,249,105,250,105,251,105,252,105,254,105,0,106,1,106,2,106,3,106,4,106,5,106,6,106,7,106,8,106,9,106,11,106,12,106,13,106,14,106,15,106,16,106,17,106,18,106,19,106,20,106,21,106,22,106,25,106,26,106,27,106,28,106,29,106,30,106,32,106,34,106,35,106,36,106,37,106,38,106,39,106,41,106,43,106,44,106,45,106,46,106,48,106,50,106,51,106,52,106,54,106,55,106,56,106,57,106,58,106,59,106,60,106,63,106,64,106,65,106,66,106,67,106,69,106,70,106,72,106,73,106,74,106,75,106,76,106,77,106,78,106,79,106,81,106,82,106,83,106,84,106,85,106,86,106,87,106,90,106,92,106,93,106,94,106,95,106,96,106,98,106,99,106,100,106,102,106,103,106,104,106,105,106,106,106,107,106,108,106,109,106,110,106,111,106,112,106,114,106,115,106,116,106,117,106,118,106,119,106,120,106,122,106,123,106,125,106,126,106,127,106,129,106,130,106,131,106,133,106,134,106,135,106,136,106,137,106,138,106,139,106,140,106,141,106,143,106,146,106,147,106,148,106,149,106,150,106,152,106,153,106,154,106,155,106,156,106,157,106,158,106,159,106,161,106,162,106,163,106,164,106,165,106,166,106,167,106,168,106,170,106,173,106,174,106,175,106,176,106,177,106,178,106,179,106,180,106,181,106,182,106,183,106,184,106,185,106,186,106,187,106,188,106,189,106,190,106,191,106,192,106,193,106,194,106,195,106,196,106,197,106,198,106,199,106,200,106,201,106,202,106,203,106,204,106,205,106,206,106,207,106,208,106,209,106,210,106,211,106,212,106,213,106,214,106,215,106,216,106,217,106,218,106,219,106,220,106,221,106,222,106,223,106,224,106,225,106,226,106,227,106,228,106,229,106,230,106,231,106,232,106,233,106,234,106,235,106,236,106,237,106,238,106,239,106,240,106,241,106,242,106,243,106,244,106,245,106,246,106,247,106,248,106,249,106,250,106,251,106,252,106,253,106,254,106,255,106,0,107,1,107,2,107,3,107,4,107,5,107,6,107,7,107,8,107,9,107,10,107,11,107,12,107,13,107,14,107,15,107,16,107,17,107,18,107,19,107,20,107,21,107,22,107,23,107,24,107,25,107,26,107,27,107,28,107,29,107,30,107,31,107,37,107,38,107,40,107,41,107,42,107,43,107,44,107,45,107,46,107,47,107,48,107,49,107,51,107,52,107,53,107,54,107,56,107,59,107,60,107,61,107,63,107,64,107,65,107,66,107,68,107,69,107,72,107,74,107,75,107,77,107,78,107,79,107,80,107,81,107,82,107,83,107,84,107,85,107,86,107,87,107,88,107,90,107,91,107,92,107,93,107,94,107,95,107,96,107,97,107,104,107,105,107,107,107,108,107,109,107,110,107,111,107,112,107,113,107,114,107,115,107,116,107,117,107,118,107,119,107,120,107,122,107,125,107,126,107,127,107,128,107,133,107,136,107,140,107,142,107,143,107,144,107,145,107,148,107,149,107,151,107,152,107,153,107,156,107,157,107,158,107,159,107,160,107,162,107,163,107,164,107,165,107,166,107,167,107,168,107,169,107,171,107,172,107,173,107,174,107,175,107,176,107,177,107,178,107,182,107,184,107,185,107,186,107,187,107,188,107,189,107,190,107,192,107,195,107,196,107,198,107,199,107,200,107,201,107,202,107,204,107,206,107,208,107,209,107,216,107,218,107,220,107,221,107,222,107,223,107,224,107,226,107,227,107,228,107,229,107,230,107,231,107,232,107,233,107,236,107,237,107,238,107,240,107,241,107,242,107,244,107,246,107,247,107,248,107,250,107,251,107,252,107,254,107,255,107,0,108,1,108,2,108,3,108,4,108,8,108,9,108,10,108,11,108,12,108,14,108,18,108,23,108,28,108,29,108,30,108,32,108,35,108,37,108,43,108,44,108,45,108,49,108,51,108,54,108,55,108,57,108,58,108,59,108,60,108,62,108,63,108,67,108,68,108,69,108,72,108,75,108,76,108,77,108,78,108,79,108,81,108,82,108,83,108,86,108,88,108,89,108,90,108,98,108,99,108,101,108,102,108,103,108,107,108,108,108,109,108,110,108,111,108,113,108,115,108,117,108,119,108,120,108,122,108,123,108,124,108,127,108,128,108,132,108,135,108,138,108,139,108,141,108,142,108,145,108,146,108,149,108,150,108,151,108,152,108,154,108,156,108,157,108,158,108,160,108,162,108,168,108,172,108,175,108,176,108,180,108,181,108,182,108,183,108,186,108,192,108,193,108,194,108,195,108,198,108,199,108,200,108,203,108,205,108,206,108,207,108,209,108,210,108,216,108,217,108,218,108,220,108,221,108,223,108,228,108,230,108,231,108,233,108,236,108,237,108,242,108,244,108,249,108,255,108,0,109,2,109,3,109,5,109,6,109,8,109,9,109,10,109,13,109,15,109,16,109,17,109,19,109,20,109,21,109,22,109,24,109,28,109,29,109,31,109,32,109,33,109,34,109,35,109,36,109,38,109,40,109,41,109,44,109,45,109,47,109,48,109,52,109,54,109,55,109,56,109,58,109,63,109,64,109,66,109,68,109,73,109,76,109,80,109,85,109,86,109,87,109,88,109,91,109,93,109,95,109,97,109,98,109,100,109,101,109,103,109,104,109,107,109,108,109,109,109,112,109,113,109,114,109,115,109,117,109,118,109,121,109,122,109,123,109,125,109,126,109,127,109,128,109,129,109,131,109,132,109,134,109,135,109,138,109,139,109,141,109,143,109,144,109,146,109,150,109,151,109,152,109,153,109,154,109,156,109,162,109,165,109,172,109,173,109,176,109,177,109,179,109,180,109,182,109,183,109,185,109,186,109,187,109,188,109,189,109,190,109,193,109,194,109,195,109,200,109,201,109,202,109,205,109,206,109,207,109,208,109,210,109,211,109,212,109,213,109,215,109,218,109,219,109,220,109,223,109,226,109,227,109,229,109,231,109,232,109,233,109,234,109,237,109,239,109,240,109,242,109,244,109,245,109,246,109,248,109,250,109,253,109,254,109,255,109,0,110,1,110,2,110,3,110,4,110,6,110,7,110,8,110,9,110,11,110,15,110,18,110,19,110,21,110,24,110,25,110,27,110,28,110,30,110,31,110,34,110,38,110,39,110,40,110,42,110,44,110,46,110,48,110,49,110,51,110,53,110,54,110,55,110,57,110,59,110,60,110,61,110,62,110,63,110,64,110,65,110,66,110,69,110,70,110,71,110,72,110,73,110,74,110,75,110,76,110,79,110,80,110,81,110,82,110,85,110,87,110,89,110,90,110,92,110,93,110,94,110,96,110,97,110,98,110,99,110,100,110,101,110,102,110,103,110,104,110,105,110,106,110,108,110,109,110,111,110,112,110,113,110,114,110,115,110,116,110,117,110,118,110,119,110,120,110,121,110,122,110,123,110,124,110,125,110,128,110,129,110,130,110,132,110,135,110,136,110,138,110,139,110,140,110,141,110,142,110,145,110,146,110,147,110,148,110,149,110,150,110,151,110,153,110,154,110,155,110,157,110,158,110,160,110,161,110,163,110,164,110,166,110,168,110,169,110,171,110,172,110,173,110,174,110,176,110,179,110,181,110,184,110,185,110,188,110,190,110,191,110,192,110,195,110,196,110,197,110,198,110,200,110,201,110,202,110,204,110,205,110,206,110,208,110,210,110,214,110,216,110,217,110,219,110,220,110,221,110,227,110,231,110,234,110,235,110,236,110,237,110,238,110,239,110,240,110,241,110,242,110,243,110,245,110,246,110,247,110,248,110,250,110,251,110,252,110,253,110,254,110,255,110,0,111,1,111,3,111,4,111,5,111,7,111,8,111,10,111,11,111,12,111,13,111,14,111,16,111,17,111,18,111,22,111,23,111,24,111,25,111,26,111,27,111,28,111,29,111,30,111,31,111,33,111,34,111,35,111,37,111,38,111,39,111,40,111,44,111,46,111,48,111,50,111,52,111,53,111,55,111,56,111,57,111,58,111,59,111,60,111,61,111,63,111,64,111,65,111,66,111,67,111,68,111,69,111,72,111,73,111,74,111,76,111,78,111,79,111,80,111,81,111,82,111,83,111,84,111,85,111,86,111,87,111,89,111,90,111,91,111,93,111,95,111,96,111,97,111,99,111,100,111,101,111,103,111,104,111,105,111,106,111,107,111,108,111,111,111,112,111,113,111,115,111,117,111,118,111,119,111,121,111,123,111,125,111,126,111,127,111,128,111,129,111,130,111,131,111,133,111,134,111,135,111,138,111,139,111,143,111,144,111,145,111,146,111,147,111,148,111,149,111,150,111,151,111,152,111,153,111,154,111,155,111,157,111,158,111,159,111,160,111,162,111,163,111,164,111,165,111,166,111,168,111,169,111,170,111,171,111,172,111,173,111,174,111,175,111,176,111,177,111,178,111,180,111,181,111,183,111,184,111,186,111,187,111,188,111,189,111,190,111,191,111,193,111,195,111,196,111,197,111,198,111,199,111,200,111,202,111,203,111,204,111,205,111,206,111,207,111,208,111,211,111,212,111,213,111,214,111,215,111,216,111,217,111,218,111,219,111,220,111,221,111,223,111,226,111,227,111,228,111,229,111,230,111,231,111,232,111,233,111,234,111,235,111,236,111,237,111,240,111,241,111,242,111,243,111,244,111,245,111,246,111,247,111,248,111,249,111,250,111,251,111,252,111,253,111,254,111,255,111,0,112,1,112,2,112,3,112,4,112,5,112,6,112,7,112,8,112,9,112,10,112,11,112,12,112,13,112,14,112,15,112,16,112,18,112,19,112,20,112,21,112,22,112,23,112,24,112,25,112,28,112,29,112,30,112,31,112,32,112,33,112,34,112,36,112,37,112,38,112,39,112,40,112,41,112,42,112,43,112,44,112,45,112,46,112,47,112,48,112,49,112,50,112,51,112,52,112,54,112,55,112,56,112,58,112,59,112,60,112,61,112,62,112,63,112,64,112,65,112,66,112,67,112,68,112,69,112,70,112,71,112,72,112,73,112,74,112,75,112,77,112,78,112,80,112,81,112,82,112,83,112,84,112,85,112,86,112,87,112,88,112,89,112,90,112,91,112,92,112,93,112,95,112,96,112,97,112,98,112,99,112,100,112,101,112,102,112,103,112,104,112,105,112,106,112,110,112,113,112,114,112,115,112,116,112,119,112,121,112,122,112,123,112,125,112,129,112,130,112,131,112,132,112,134,112,135,112,136,112,139,112,140,112,141,112,143,112,144,112,145,112,147,112,151,112,152,112,154,112,155,112,158,112,159,112,160,112,161,112,162,112,163,112,164,112,165,112,166,112,167,112,168,112,169,112,170,112,176,112,178,112,180,112,181,112,182,112,186,112,190,112,191,112,196,112,197,112,198,112,199,112,201,112,203,112,204,112,205,112,206,112,207,112,208,112,209,112,210,112,211,112,212,112,213,112,214,112,215,112,218,112,220,112,221,112,222,112,224,112,225,112,226,112,227,112,229,112,234,112,238,112,240,112,241,112,242,112,243,112,244,112,245,112,246,112,248,112,250,112,251,112,252,112,254,112,255,112,0,113,1,113,2,113,3,113,4,113,5,113,6,113,7,113,8,113,11,113,12,113,13,113,14,113,15,113,17,113,18,113,20,113,23,113,27,113,28,113,29,113,30,113,31,113,32,113,33,113,34,113,35,113,36,113,37,113,39,113,40,113,41,113,42,113,43,113,44,113,45,113,46,113,50,113,51,113,52,113,53,113,55,113,56,113,57,113,58,113,59,113,60,113,61,113,62,113,63,113,64,113,65,113,66,113,67,113,68,113,70,113,71,113,72,113,73,113,75,113,77,113,79,113,80,113,81,113,82,113,83,113,84,113,85,113,86,113,87,113,88,113,89,113,90,113,91,113,93,113,95,113,96,113,97,113,98,113,99,113,101,113,105,113,106,113,107,113,108,113,109,113,111,113,112,113,113,113,116,113,117,113,118,113,119,113,121,113,123,113,124,113,126,113,127,113,128,113,129,113,130,113,131,113,133,113,134,113,135,113,136,113,137,113,139,113,140,113,141,113,142,113,144,113,145,113,146,113,147,113,149,113,150,113,151,113,154,113,155,113,156,113,157,113,158,113,161,113,162,113,163,113,164,113,165,113,166,113,167,113,169,113,170,113,171,113,173,113,174,113,175,113,176,113,177,113,178,113,180,113,182,113,183,113,184,113,186,113,187,113,188,113,189,113,190,113,191,113,192,113,193,113,194,113,196,113,197,113,198,113,199,113,200,113,201,113,202,113,203,113,204,113,205,113,207,113,208,113,209,113,210,113,211,113,214,113,215,113,216,113,217,113,218,113,219,113,220,113,221,113,222,113,223,113,225,113,226,113,227,113,228,113,230,113,232,113,233,113,234,113,235,113,236,113,237,113,239,113,240,113,241,113,242,113,243,113,244,113,245,113,246,113,247,113,248,113,250,113,251,113,252,113,253,113,254,113,255,113,0,114,1,114,2,114,3,114,4,114,5,114,7,114,8,114,9,114,10,114,11,114,12,114,13,114,14,114,15,114,16,114,17,114,18,114,19,114,20,114,21,114,22,114,23,114,24,114,25,114,26,114,27,114,28,114,30,114,31,114,32,114,33,114,34,114,35,114,36,114,37,114,38,114,39,114,41,114,43,114,45,114,46,114,47,114,50,114,51,114,52,114,58,114,60,114,62,114,64,114,65,114,66,114,67,114,68,114,69,114,70,114,73,114,74,114,75,114,78,114,79,114,80,114,81,114,83,114,84,114,85,114,87,114,88,114,90,114,92,114,94,114,96,114,99,114,100,114,101,114,104,114,106,114,107,114,108,114,109,114,112,114,113,114,115,114,116,114,118,114,119,114,120,114,123,114,124,114,125,114,130,114,131,114,133,114,134,114,135,114,136,114,137,114,140,114,142,114,144,114,145,114,147,114,148,114,149,114,150,114,151,114,152,114,153,114,154,114,155,114,156,114,157,114,158,114,160,114,161,114,162,114,163,114,164,114,165,114,166,114,167,114,168,114,169,114,170,114,171,114,174,114,177,114,178,114,179,114,181,114,186,114,187,114,188,114,189,114,190,114,191,114,192,114,197,114,198,114,199,114,201,114,202,114,203,114,204,114,207,114,209,114,211,114,212,114,213,114,214,114,216,114,218,114,219,114,198,228,199,228,200,228,201,228,202,228,203,228,204,228,205,228,206,228,207,228,208,228,209,228,210,228,211,228,212,228,213,228,214,228,215,228,216,228,217,228,218,228,219,228,220,228,221,228,222,228,223,228,224,228,225,228,226,228,227,228,228,228,229,228,230,228,231,228,232,228,233,228,234,228,235,228,236,228,237,228,238,228,239,228,240,228,241,228,242,228,243,228,244,228,245,228,246,228,247,228,248,228,249,228,250,228,251,228,252,228,253,228,254,228,255,228,0,229,1,229,2,229,3,229,4,229,5,229,6,229,7,229,8,229,9,229,10,229,11,229,12,229,13,229,14,229,15,229,16,229,17,229,18,229,19,229,20,229,21,229,22,229,23,229,24,229,25,229,26,229,27,229,28,229,29,229,30,229,31,229,32,229,33,229,34,229,35,229,36,229,37,229,0,48,1,48,2,48,183,0,201,2,199,2,168,0,3,48,5,48,20,32,94,255,22,32,38,32,24,32,25,32,28,32,29,32,20,48,21,48,8,48,9,48,10,48,11,48,12,48,13,48,14,48,15,48,22,48,23,48,16,48,17,48,177,0,215,0,247,0,54,34,39,34,40,34,17,34,15,34,42,34,41,34,8,34,55,34,26,34,165,34,37,34,32,34,18,35,153,34,43,34,46,34,97,34,76,34,72,34,61,34,29,34,96,34,110,34,111,34,100,34,101,34,30,34,53,34,52,34,66,38,64,38,176,0,50,32,51,32,3,33,4,255,164,0,224,255,225,255,48,32,167,0,22,33,6,38,5,38,203,37,207,37,206,37,199,37,198,37,161,37,160,37,179,37,178,37,59,32,146,33,144,33,145,33,147,33,19,48,38,229,39,229,40,229,41,229,42,229,43,229,44,229,45,229,46,229,47,229,48,229,49,229,50,229,51,229,52,229,53,229,54,229,55,229,56,229,57,229,58,229,59,229,60,229,61,229,62,229,63,229,64,229,65,229,66,229,67,229,68,229,69,229,70,229,71,229,72,229,73,229,74,229,75,229,76,229,77,229,78,229,79,229,80,229,81,229,82,229,83,229,84,229,85,229,86,229,87,229,88,229,89,229,90,229,91,229,92,229,93,229,94,229,95,229,96,229,97,229,98,229,99,229,100,229,101,229,102,229,103,229,104,229,105,229,106,229,107,229,108,229,109,229,110,229,111,229,112,229,113,229,114,229,115,229,116,229,117,229,118,229,119,229,120,229,121,229,122,229,123,229,124,229,125,229,126,229,127,229,128,229,129,229,130,229,131,229,132,229,133,229,112,33,113,33,114,33,115,33,116,33,117,33,118,33,119,33,120,33,121,33,102,231,103,231,104,231,105,231,106,231,107,231,136,36,137,36,138,36,139,36,140,36,141,36,142,36,143,36,144,36,145,36,146,36,147,36,148,36,149,36,150,36,151,36,152,36,153,36,154,36,155,36,116,36,117,36,118,36,119,36,120,36,121,36,122,36,123,36,124,36,125,36,126,36,127,36,128,36,129,36,130,36,131,36,132,36,133,36,134,36,135,36,96,36,97,36,98,36,99,36,100,36,101,36,102,36,103,36,104,36,105,36,172,32,109,231,32,50,33,50,34,50,35,50,36,50,37,50,38,50,39,50,40,50,41,50,110,231,111,231,96,33,97,33,98,33,99,33,100,33,101,33,102,33,103,33,104,33,105,33,106,33,107,33,112,231,113,231,134,229,135,229,136,229,137,229,138,229,139,229,140,229,141,229,142,229,143,229,144,229,145,229,146,229,147,229,148,229,149,229,150,229,151,229,152,229,153,229,154,229,155,229,156,229,157,229,158,229,159,229,160,229,161,229,162,229,163,229,164,229,165,229,166,229,167,229,168,229,169,229,170,229,171,229,172,229,173,229,174,229,175,229,176,229,177,229,178,229,179,229,180,229,181,229,182,229,183,229,184,229,185,229,186,229,187,229,188,229,189,229,190,229,191,229,192,229,193,229,194,229,195,229,196,229,197,229,198,229,199,229,200,229,201,229,202,229,203,229,204,229,205,229,206,229,207,229,208,229,209,229,210,229,211,229,212,229,213,229,214,229,215,229,216,229,217,229,218,229,219,229,220,229,221,229,222,229,223,229,224,229,225,229,226,229,227,229,228,229,229,229,1,255,2,255,3,255,229,255,5,255,6,255,7,255,8,255,9,255,10,255,11,255,12,255,13,255,14,255,15,255,16,255,17,255,18,255,19,255,20,255,21,255,22,255,23,255,24,255,25,255,26,255,27,255,28,255,29,255,30,255,31,255,32,255,33,255,34,255,35,255,36,255,37,255,38,255,39,255,40,255,41,255,42,255,43,255,44,255,45,255,46,255,47,255,48,255,49,255,50,255,51,255,52,255,53,255,54,255,55,255,56,255,57,255,58,255,59,255,60,255,61,255,62,255,63,255,64,255,65,255,66,255,67,255,68,255,69,255,70,255,71,255,72,255,73,255,74,255,75,255,76,255,77,255,78,255,79,255,80,255,81,255,82,255,83,255,84,255,85,255,86,255,87,255,88,255,89,255,90,255,91,255,92,255,93,255,227,255,230,229,231,229,232,229,233,229,234,229,235,229,236,229,237,229,238,229,239,229,240,229,241,229,242,229,243,229,244,229,245,229,246,229,247,229,248,229,249,229,250,229,251,229,252,229,253,229,254,229,255,229,0,230,1,230,2,230,3,230,4,230,5,230,6,230,7,230,8,230,9,230,10,230,11,230,12,230,13,230,14,230,15,230,16,230,17,230,18,230,19,230,20,230,21,230,22,230,23,230,24,230,25,230,26,230,27,230,28,230,29,230,30,230,31,230,32,230,33,230,34,230,35,230,36,230,37,230,38,230,39,230,40,230,41,230,42,230,43,230,44,230,45,230,46,230,47,230,48,230,49,230,50,230,51,230,52,230,53,230,54,230,55,230,56,230,57,230,58,230,59,230,60,230,61,230,62,230,63,230,64,230,65,230,66,230,67,230,68,230,69,230,65,48,66,48,67,48,68,48,69,48,70,48,71,48,72,48,73,48,74,48,75,48,76,48,77,48,78,48,79,48,80,48,81,48,82,48,83,48,84,48,85,48,86,48,87,48,88,48,89,48,90,48,91,48,92,48,93,48,94,48,95,48,96,48,97,48,98,48,99,48,100,48,101,48,102,48,103,48,104,48,105,48,106,48,107,48,108,48,109,48,110,48,111,48,112,48,113,48,114,48,115,48,116,48,117,48,118,48,119,48,120,48,121,48,122,48,123,48,124,48,125,48,126,48,127,48,128,48,129,48,130,48,131,48,132,48,133,48,134,48,135,48,136,48,137,48,138,48,139,48,140,48,141,48,142,48,143,48,144,48,145,48,146,48,147,48,114,231,115,231,116,231,117,231,118,231,119,231,120,231,121,231,122,231,123,231,124,231,70,230,71,230,72,230,73,230,74,230,75,230,76,230,77,230,78,230,79,230,80,230,81,230,82,230,83,230,84,230,85,230,86,230,87,230,88,230,89,230,90,230,91,230,92,230,93,230,94,230,95,230,96,230,97,230,98,230,99,230,100,230,101,230,102,230,103,230,104,230,105,230,106,230,107,230,108,230,109,230,110,230,111,230,112,230,113,230,114,230,115,230,116,230,117,230,118,230,119,230,120,230,121,230,122,230,123,230,124,230,125,230,126,230,127,230,128,230,129,230,130,230,131,230,132,230,133,230,134,230,135,230,136,230,137,230,138,230,139,230,140,230,141,230,142,230,143,230,144,230,145,230,146,230,147,230,148,230,149,230,150,230,151,230,152,230,153,230,154,230,155,230,156,230,157,230,158,230,159,230,160,230,161,230,162,230,163,230,164,230,165,230,161,48,162,48,163,48,164,48,165,48,166,48,167,48,168,48,169,48,170,48,171,48,172,48,173,48,174,48,175,48,176,48,177,48,178,48,179,48,180,48,181,48,182,48,183,48,184,48,185,48,186,48,187,48,188,48,189,48,190,48,191,48,192,48,193,48,194,48,195,48,196,48,197,48,198,48,199,48,200,48,201,48,202,48,203,48,204,48,205,48,206,48,207,48,208,48,209,48,210,48,211,48,212,48,213,48,214,48,215,48,216,48,217,48,218,48,219,48,220,48,221,48,222,48,223,48,224,48,225,48,226,48,227,48,228,48,229,48,230,48,231,48,232,48,233,48,234,48,235,48,236,48,237,48,238,48,239,48,240,48,241,48,242,48,243,48,244,48,245,48,246,48,125,231,126,231,127,231,128,231,129,231,130,231,131,231,132,231,166,230,167,230,168,230,169,230,170,230,171,230,172,230,173,230,174,230,175,230,176,230,177,230,178,230,179,230,180,230,181,230,182,230,183,230,184,230,185,230,186,230,187,230,188,230,189,230,190,230,191,230,192,230,193,230,194,230,195,230,196,230,197,230,198,230,199,230,200,230,201,230,202,230,203,230,204,230,205,230,206,230,207,230,208,230,209,230,210,230,211,230,212,230,213,230,214,230,215,230,216,230,217,230,218,230,219,230,220,230,221,230,222,230,223,230,224,230,225,230,226,230,227,230,228,230,229,230,230,230,231,230,232,230,233,230,234,230,235,230,236,230,237,230,238,230,239,230,240,230,241,230,242,230,243,230,244,230,245,230,246,230,247,230,248,230,249,230,250,230,251,230,252,230,253,230,254,230,255,230,0,231,1,231,2,231,3,231,4,231,5,231,145,3,146,3,147,3,148,3,149,3,150,3,151,3,152,3,153,3,154,3,155,3,156,3,157,3,158,3,159,3,160,3,161,3,163,3,164,3,165,3,166,3,167,3,168,3,169,3,133,231,134,231,135,231,136,231,137,231,138,231,139,231,140,231,177,3,178,3,179,3,180,3,181,3,182,3,183,3,184,3,185,3,186,3,187,3,188,3,189,3,190,3,191,3,192,3,193,3,195,3,196,3,197,3,198,3,199,3,200,3,201,3,141,231,142,231,143,231,144,231,145,231,146,231,147,231,53,254,54,254,57,254,58,254,63,254,64,254,61,254,62,254,65,254,66,254,67,254,68,254,148,231,149,231,59,254,60,254,55,254,56,254,49,254,150,231,51,254,52,254,151,231,152,231,153,231,154,231,155,231,156,231,157,231,158,231,159,231,6,231,7,231,8,231,9,231,10,231,11,231,12,231,13,231,14,231,15,231,16,231,17,231,18,231,19,231,20,231,21,231,22,231,23,231,24,231,25,231,26,231,27,231,28,231,29,231,30,231,31,231,32,231,33,231,34,231,35,231,36,231,37,231,38,231,39,231,40,231,41,231,42,231,43,231,44,231,45,231,46,231,47,231,48,231,49,231,50,231,51,231,52,231,53,231,54,231,55,231,56,231,57,231,58,231,59,231,60,231,61,231,62,231,63,231,64,231,65,231,66,231,67,231,68,231,69,231,70,231,71,231,72,231,73,231,74,231,75,231,76,231,77,231,78,231,79,231,80,231,81,231,82,231,83,231,84,231,85,231,86,231,87,231,88,231,89,231,90,231,91,231,92,231,93,231,94,231,95,231,96,231,97,231,98,231,99,231,100,231,101,231,16,4,17,4,18,4,19,4,20,4,21,4,1,4,22,4,23,4,24,4,25,4,26,4,27,4,28,4,29,4,30,4,31,4,32,4,33,4,34,4,35,4,36,4,37,4,38,4,39,4,40,4,41,4,42,4,43,4,44,4,45,4,46,4,47,4,160,231,161,231,162,231,163,231,164,231,165,231,166,231,167,231,168,231,169,231,170,231,171,231,172,231,173,231,174,231,48,4,49,4,50,4,51,4,52,4,53,4,81,4,54,4,55,4,56,4,57,4,58,4,59,4,60,4,61,4,62,4,63,4,64,4,65,4,66,4,67,4,68,4,69,4,70,4,71,4,72,4,73,4,74,4,75,4,76,4,77,4,78,4,79,4,175,231,176,231,177,231,178,231,179,231,180,231,181,231,182,231,183,231,184,231,185,231,186,231,187,231,202,2,203,2,217,2,19,32,21,32,37,32,53,32,5,33,9,33,150,33,151,33,152,33,153,33,21,34,31,34,35,34,82,34,102,34,103,34,191,34,80,37,81,37,82,37,83,37,84,37,85,37,86,37,87,37,88,37,89,37,90,37,91,37,92,37,93,37,94,37,95,37,96,37,97,37,98,37,99,37,100,37,101,37,102,37,103,37,104,37,105,37,106,37,107,37,108,37,109,37,110,37,111,37,112,37,113,37,114,37,115,37,129,37,130,37,131,37,132,37,133,37,134,37,135,37,136,37,137,37,138,37,139,37,140,37,141,37,142,37,143,37,147,37,148,37,149,37,188,37,189,37,226,37,227,37,228,37,229,37,9,38,149,34,18,48,29,48,30,48,188,231,189,231,190,231,191,231,192,231,193,231,194,231,195,231,196,231,197,231,198,231,1,1,225,0,206,1,224,0,19,1,233,0,27,1,232,0,43,1,237,0,208,1,236,0,77,1,243,0,210,1,242,0,107,1,250,0,212,1,249,0,214,1,216,1,218,1,220,1,252,0,234,0,81,2,199,231,68,1,72,1,249,1,97,2,201,231,202,231,203,231,204,231,5,49,6,49,7,49,8,49,9,49,10,49,11,49,12,49,13,49,14,49,15,49,16,49,17,49,18,49,19,49,20,49,21,49,22,49,23,49,24,49,25,49,26,49,27,49,28,49,29,49,30,49,31,49,32,49,33,49,34,49,35,49,36,49,37,49,38,49,39,49,40,49,41,49,205,231,206,231,207,231,208,231,209,231,210,231,211,231,212,231,213,231,214,231,215,231,216,231,217,231,218,231,219,231,220,231,221,231,222,231,223,231,224,231,225,231,33,48,34,48,35,48,36,48,37,48,38,48,39,48,40,48,41,48,163,50,142,51,143,51,156,51,157,51,158,51,161,51,196,51,206,51,209,51,210,51,213,51,48,254,226,255,228,255,226,231,33,33,49,50,227,231,16,32,228,231,229,231,230,231,252,48,155,48,156,48,253,48,254,48,6,48,157,48,158,48,73,254,74,254,75,254,76,254,77,254,78,254,79,254,80,254,81,254,82,254,84,254,85,254,86,254,87,254,89,254,90,254,91,254,92,254,93,254,94,254,95,254,96,254,97,254,98,254,99,254,100,254,101,254,102,254,104,254,105,254,106,254,107,254,62,48,240,47,241,47,242,47,243,47,244,47,245,47,246,47,247,47,248,47,249,47,250,47,251,47,7,48,244,231,245,231,246,231,247,231,248,231,249,231,250,231,251,231,252,231,253,231,254,231,255,231,0,232,0,37,1,37,2,37,3,37,4,37,5,37,6,37,7,37,8,37,9,37,10,37,11,37,12,37,13,37,14,37,15,37,16,37,17,37,18,37,19,37,20,37,21,37,22,37,23,37,24,37,25,37,26,37,27,37,28,37,29,37,30,37,31,37,32,37,33,37,34,37,35,37,36,37,37,37,38,37,39,37,40,37,41,37,42,37,43,37,44,37,45,37,46,37,47,37,48,37,49,37,50,37,51,37,52,37,53,37,54,37,55,37,56,37,57,37,58,37,59,37,60,37,61,37,62,37,63,37,64,37,65,37,66,37,67,37,68,37,69,37,70,37,71,37,72,37,73,37,74,37,75,37,1,232,2,232,3,232,4,232,5,232,6,232,7,232,8,232,9,232,10,232,11,232,12,232,13,232,14,232,15,232,220,114,221,114,223,114,226,114,227,114,228,114,229,114,230,114,231,114,234,114,235,114,245,114,246,114,249,114,253,114,254,114,255,114,0,115,2,115,4,115,5,115,6,115,7,115,8,115,9,115,11,115,12,115,13,115,15,115,16,115,17,115,18,115,20,115,24,115,25,115,26,115,31,115,32,115,35,115,36,115,38,115,39,115,40,115,45,115,47,115,48,115,50,115,51,115,53,115,54,115,58,115,59,115,60,115,61,115,64,115,65,115,66,115,67,115,68,115,69,115,70,115,71,115,72,115,73,115,74,115,75,115,76,115,78,115,79,115,81,115,83,115,84,115,85,115,86,115,88,115,89,115,90,115,91,115,92,115,93,115,94,115,95,115,97,115,98,115,99,115,100,115,101,115,102,115,103,115,104,115,105,115,106,115,107,115,110,115,112,115,113,115,0,224,1,224,2,224,3,224,4,224,5,224,6,224,7,224,8,224,9,224,10,224,11,224,12,224,13,224,14,224,15,224,16,224,17,224,18,224,19,224,20,224,21,224,22,224,23,224,24,224,25,224,26,224,27,224,28,224,29,224,30,224,31,224,32,224,33,224,34,224,35,224,36,224,37,224,38,224,39,224,40,224,41,224,42,224,43,224,44,224,45,224,46,224,47,224,48,224,49,224,50,224,51,224,52,224,53,224,54,224,55,224,56,224,57,224,58,224,59,224,60,224,61,224,62,224,63,224,64,224,65,224,66,224,67,224,68,224,69,224,70,224,71,224,72,224,73,224,74,224,75,224,76,224,77,224,78,224,79,224,80,224,81,224,82,224,83,224,84,224,85,224,86,224,87,224,88,224,89,224,90,224,91,224,92,224,93,224,114,115,115,115,116,115,117,115,118,115,119,115,120,115,121,115,122,115,123,115,124,115,125,115,127,115,128,115,129,115,130,115,131,115,133,115,134,115,136,115,138,115,140,115,141,115,143,115,144,115,146,115,147,115,148,115,149,115,151,115,152,115,153,115,154,115,156,115,157,115,158,115,160,115,161,115,163,115,164,115,165,115,166,115,167,115,168,115,170,115,172,115,173,115,177,115,180,115,181,115,182,115,184,115,185,115,188,115,189,115,190,115,191,115,193,115,195,115,196,115,197,115,198,115,199,115,203,115,204,115,206,115,210,115,211,115,212,115,213,115,214,115,215,115,216,115,218,115,219,115,220,115,221,115,223,115,225,115,226,115,227,115,228,115,230,115,232,115,234,115,235,115,236,115,238,115,239,115,240,115,241,115,243,115,244,115,245,115,246,115,247,115,94,224,95,224,96,224,97,224,98,224,99,224,100,224,101,224,102,224,103,224,104,224,105,224,106,224,107,224,108,224,109,224,110,224,111,224,112,224,113,224,114,224,115,224,116,224,117,224,118,224,119,224,120,224,121,224,122,224,123,224,124,224,125,224,126,224,127,224,128,224,129,224,130,224,131,224,132,224,133,224,134,224,135,224,136,224,137,224,138,224,139,224,140,224,141,224,142,224,143,224,144,224,145,224,146,224,147,224,148,224,149,224,150,224,151,224,152,224,153,224,154,224,155,224,156,224,157,224,158,224,159,224,160,224,161,224,162,224,163,224,164,224,165,224,166,224,167,224,168,224,169,224,170,224,171,224,172,224,173,224,174,224,175,224,176,224,177,224,178,224,179,224,180,224,181,224,182,224,183,224,184,224,185,224,186,224,187,224,248,115,249,115,250,115,251,115,252,115,253,115,254,115,255,115,0,116,1,116,2,116,4,116,7,116,8,116,11,116,12,116,13,116,14,116,17,116,18,116,19,116,20,116,21,116,22,116,23,116,24,116,25,116,28,116,29,116,30,116,31,116,32,116,33,116,35,116,36,116,39,116,41,116,43,116,45,116,47,116,49,116,50,116,55,116,56,116,57,116,58,116,59,116,61,116,62,116,63,116,64,116,66,116,67,116,68,116,69,116,70,116,71,116,72,116,73,116,74,116,75,116,76,116,77,116,78,116,79,116,80,116,81,116,82,116,83,116,84,116,86,116,88,116,93,116,96,116,97,116,98,116,99,116,100,116,101,116,102,116,103,116,104,116,105,116,106,116,107,116,108,116,110,116,111,116,113,116,114,116,115,116,116,116,117,116,120,116,121,116,122,116,188,224,189,224,190,224,191,224,192,224,193,224,194,224,195,224,196,224,197,224,198,224,199,224,200,224,201,224,202,224,203,224,204,224,205,224,206,224,207,224,208,224,209,224,210,224,211,224,212,224,213,224,214,224,215,224,216,224,217,224,218,224,219,224,220,224,221,224,222,224,223,224,224,224,225,224,226,224,227,224,228,224,229,224,230,224,231,224,232,224,233,224,234,224,235,224,236,224,237,224,238,224,239,224,240,224,241,224,242,224,243,224,244,224,245,224,246,224,247,224,248,224,249,224,250,224,251,224,252,224,253,224,254,224,255,224,0,225,1,225,2,225,3,225,4,225,5,225,6,225,7,225,8,225,9,225,10,225,11,225,12,225,13,225,14,225,15,225,16,225,17,225,18,225,19,225,20,225,21,225,22,225,23,225,24,225,25,225,123,116,124,116,125,116,127,116,130,116,132,116,133,116,134,116,136,116,137,116,138,116,140,116,141,116,143,116,145,116,146,116,147,116,148,116,149,116,150,116,151,116,152,116,153,116,154,116,155,116,157,116,159,116,160,116,161,116,162,116,163,116,164,116,165,116,166,116,170,116,171,116,172,116,173,116,174,116,175,116,176,116,177,116,178,116,179,116,180,116,181,116,182,116,183,116,184,116,185,116,187,116,188,116,189,116,190,116,191,116,192,116,193,116,194,116,195,116,196,116,197,116,198,116,199,116,200,116,201,116,202,116,203,116,204,116,205,116,206,116,207,116,208,116,209,116,211,116,212,116,213,116,214,116,215,116,216,116,217,116,218,116,219,116,221,116,223,116,225,116,229,116,231,116,232,116,233,116,234,116,235,116,236,116,237,116,240,116,241,116,242,116,26,225,27,225,28,225,29,225,30,225,31,225,32,225,33,225,34,225,35,225,36,225,37,225,38,225,39,225,40,225,41,225,42,225,43,225,44,225,45,225,46,225,47,225,48,225,49,225,50,225,51,225,52,225,53,225,54,225,55,225,56,225,57,225,58,225,59,225,60,225,61,225,62,225,63,225,64,225,65,225,66,225,67,225,68,225,69,225,70,225,71,225,72,225,73,225,74,225,75,225,76,225,77,225,78,225,79,225,80,225,81,225,82,225,83,225,84,225,85,225,86,225,87,225,88,225,89,225,90,225,91,225,92,225,93,225,94,225,95,225,96,225,97,225,98,225,99,225,100,225,101,225,102,225,103,225,104,225,105,225,106,225,107,225,108,225,109,225,110,225,111,225,112,225,113,225,114,225,115,225,116,225,117,225,118,225,119,225,243,116,245,116,248,116,249,116,250,116,251,116,252,116,253,116,254,116,0,117,1,117,2,117,3,117,5,117,6,117,7,117,8,117,9,117,10,117,11,117,12,117,14,117,16,117,18,117,20,117,21,117,22,117,23,117,27,117,29,117,30,117,32,117,33,117,34,117,35,117,36,117,38,117,39,117,42,117,46,117,52,117,54,117,57,117,60,117,61,117,63,117,65,117,66,117,67,117,68,117,70,117,71,117,73,117,74,117,77,117,80,117,81,117,82,117,83,117,85,117,86,117,87,117,88,117,93,117,94,117,95,117,96,117,97,117,98,117,99,117,100,117,103,117,104,117,105,117,107,117,108,117,109,117,110,117,111,117,112,117,113,117,115,117,117,117,118,117,119,117,122,117,123,117,124,117,125,117,126,117,128,117,129,117,130,117,132,117,133,117,135,117,120,225,121,225,122,225,123,225,124,225,125,225,126,225,127,225,128,225,129,225,130,225,131,225,132,225,133,225,134,225,135,225,136,225,137,225,138,225,139,225,140,225,141,225,142,225,143,225,144,225,145,225,146,225,147,225,148,225,149,225,150,225,151,225,152,225,153,225,154,225,155,225,156,225,157,225,158,225,159,225,160,225,161,225,162,225,163,225,164,225,165,225,166,225,167,225,168,225,169,225,170,225,171,225,172,225,173,225,174,225,175,225,176,225,177,225,178,225,179,225,180,225,181,225,182,225,183,225,184,225,185,225,186,225,187,225,188,225,189,225,190,225,191,225,192,225,193,225,194,225,195,225,196,225,197,225,198,225,199,225,200,225,201,225,202,225,203,225,204,225,205,225,206,225,207,225,208,225,209,225,210,225,211,225,212,225,213,225,136,117,137,117,138,117,140,117,141,117,142,117,144,117,147,117,149,117,152,117,155,117,156,117,158,117,162,117,166,117,167,117,168,117,169,117,170,117,173,117,182,117,183,117,186,117,187,117,191,117,192,117,193,117,198,117,203,117,204,117,206,117,207,117,208,117,209,117,211,117,215,117,217,117,218,117,220,117,221,117,223,117,224,117,225,117,229,117,233,117,236,117,237,117,238,117,239,117,242,117,243,117,245,117,246,117,247,117,248,117,250,117,251,117,253,117,254,117,2,118,4,118,6,118,7,118,8,118,9,118,11,118,13,118,14,118,15,118,17,118,18,118,19,118,20,118,22,118,26,118,28,118,29,118,30,118,33,118,35,118,39,118,40,118,44,118,46,118,47,118,49,118,50,118,54,118,55,118,57,118,58,118,59,118,61,118,65,118,66,118,68,118,214,225,215,225,216,225,217,225,218,225,219,225,220,225,221,225,222,225,223,225,224,225,225,225,226,225,227,225,228,225,229,225,230,225,231,225,232,225,233,225,234,225,235,225,236,225,237,225,238,225,239,225,240,225,241,225,242,225,243,225,244,225,245,225,246,225,247,225,248,225,249,225,250,225,251,225],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+230588),
allocate([252,225,253,225,254,225,255,225,0,226,1,226,2,226,3,226,4,226,5,226,6,226,7,226,8,226,9,226,10,226,11,226,12,226,13,226,14,226,15,226,16,226,17,226,18,226,19,226,20,226,21,226,22,226,23,226,24,226,25,226,26,226,27,226,28,226,29,226,30,226,31,226,32,226,33,226,34,226,35,226,36,226,37,226,38,226,39,226,40,226,41,226,42,226,43,226,44,226,45,226,46,226,47,226,48,226,49,226,50,226,51,226,69,118,70,118,71,118,72,118,73,118,74,118,75,118,78,118,79,118,80,118,81,118,82,118,83,118,85,118,87,118,88,118,89,118,90,118,91,118,93,118,95,118,96,118,97,118,98,118,100,118,101,118,102,118,103,118,104,118,105,118,106,118,108,118,109,118,110,118,112,118,113,118,114,118,115,118,116,118,117,118,118,118,119,118,121,118,122,118,124,118,127,118,128,118,129,118,131,118,133,118,137,118,138,118,140,118,141,118,143,118,144,118,146,118,148,118,149,118,151,118,152,118,154,118,155,118,156,118,157,118,158,118,159,118,160,118,161,118,162,118,163,118,165,118,166,118,167,118,168,118,169,118,170,118,171,118,172,118,173,118,175,118,176,118,179,118,181,118,182,118,183,118,184,118,185,118,186,118,187,118,188,118,189,118,190,118,192,118,193,118,195,118,74,85,63,150,195,87,40,99,206,84,9,85,192,84,145,118,76,118,60,133,238,119,126,130,141,120,49,114,152,150,141,151,40,108,137,91,250,79,9,99,151,102,184,92,250,128,72,104,174,128,2,102,206,118,249,81,86,101,172,113,241,127,132,136,178,80,101,89,202,97,179,111,173,130,76,99,82,98,237,83,39,84,6,123,107,81,164,117,244,93,212,98,203,141,118,151,138,98,25,128,93,87,56,151,98,127,56,114,125,118,207,103,126,118,70,100,112,79,37,141,220,98,23,122,145,101,237,115,44,100,115,98,44,130,129,152,127,103,72,114,110,98,204,98,52,79,227,116,74,83,158,82,202,126,166,144,46,94,134,104,156,105,128,129,209,126,210,104,197,120,140,134,81,149,141,80,36,140,222,130,222,128,5,83,18,137,101,82,196,118,199,118,201,118,203,118,204,118,211,118,213,118,217,118,218,118,220,118,221,118,222,118,224,118,225,118,226,118,227,118,228,118,230,118,231,118,232,118,233,118,234,118,235,118,236,118,237,118,240,118,243,118,245,118,246,118,247,118,250,118,251,118,253,118,255,118,0,119,2,119,3,119,5,119,6,119,10,119,12,119,14,119,15,119,16,119,17,119,18,119,19,119,20,119,21,119,22,119,23,119,24,119,27,119,28,119,29,119,30,119,33,119,35,119,36,119,37,119,39,119,42,119,43,119,44,119,46,119,48,119,49,119,50,119,51,119,52,119,57,119,59,119,61,119,62,119,63,119,66,119,68,119,69,119,70,119,72,119,73,119,74,119,75,119,76,119,77,119,78,119,79,119,82,119,83,119,84,119,85,119,86,119,87,119,88,119,89,119,92,119,132,133,249,150,221,79,33,88,113,153,157,91,177,98,165,98,180,102,121,140,141,156,6,114,111,103,145,120,178,96,81,83,23,83,136,143,204,128,29,141,161,148,13,80,200,114,7,89,235,96,25,113,171,136,84,89,239,130,44,103,40,123,41,93,247,126,45,117,245,108,102,142,248,143,60,144,59,159,212,107,25,145,20,123,124,95,167,120,214,132,61,133,213,107,217,107,214,107,1,94,135,94,249,117,237,149,93,101,10,95,197,95,159,143,193,88,194,129,127,144,91,150,173,151,185,143,22,127,44,141,65,98,191,79,216,83,94,83,168,143,169,143,171,143,77,144,7,104,106,95,152,129,104,136,214,156,139,97,43,82,42,118,108,95,140,101,210,111,232,110,190,91,72,100,117,81,176,81,196,103,25,78,201,121,124,153,179,112,93,119,94,119,95,119,96,119,100,119,103,119,105,119,106,119,109,119,110,119,111,119,112,119,113,119,114,119,115,119,116,119,117,119,118,119,119,119,120,119,122,119,123,119,124,119,129,119,130,119,131,119,134,119,135,119,136,119,137,119,138,119,139,119,143,119,144,119,147,119,148,119,149,119,150,119,151,119,152,119,153,119,154,119,155,119,156,119,157,119,158,119,161,119,163,119,164,119,166,119,168,119,171,119,173,119,174,119,175,119,177,119,178,119,180,119,182,119,183,119,184,119,185,119,186,119,188,119,190,119,192,119,193,119,194,119,195,119,196,119,197,119,198,119,199,119,200,119,201,119,202,119,203,119,204,119,206,119,207,119,208,119,209,119,210,119,211,119,212,119,213,119,214,119,216,119,217,119,218,119,221,119,222,119,223,119,224,119,225,119,228,119,197,117,118,94,187,115,224,131,173,100,232,98,181,148,226,108,90,83,195,82,15,100,194,148,148,123,47,79,27,94,54,130,22,129,138,129,36,110,202,108,115,154,85,99,92,83,250,84,101,136,224,87,13,78,3,94,101,107,63,124,232,144,22,96,230,100,28,115,193,136,80,103,77,98,34,141,108,119,41,142,199,145,105,95,220,131,33,133,16,153,194,83,149,134,139,107,237,96,232,96,127,112,205,130,49,130,211,78,167,108,207,133,205,100,217,124,253,105,249,102,73,131,149,83,86,123,167,79,140,81,75,109,66,92,109,142,210,99,201,83,44,131,54,131,229,103,180,120,61,100,223,91,148,92,238,93,231,139,198,98,244,103,122,140,0,100,186,99,73,135,139,153,23,140,32,127,242,148,167,78,16,150,164,152,12,102,22,115,230,119,232,119,234,119,239,119,240,119,241,119,242,119,244,119,245,119,247,119,249,119,250,119,251,119,252,119,3,120,4,120,5,120,6,120,7,120,8,120,10,120,11,120,14,120,15,120,16,120,19,120,21,120,25,120,27,120,30,120,32,120,33,120,34,120,36,120,40,120,42,120,43,120,46,120,47,120,49,120,50,120,51,120,53,120,54,120,61,120,63,120,65,120,66,120,67,120,68,120,70,120,72,120,73,120,74,120,75,120,77,120,79,120,81,120,83,120,84,120,88,120,89,120,90,120,91,120,92,120,94,120,95,120,96,120,97,120,98,120,99,120,100,120,101,120,102,120,103,120,104,120,105,120,111,120,112,120,113,120,114,120,115,120,116,120,117,120,118,120,120,120,121,120,122,120,123,120,125,120,126,120,127,120,128,120,129,120,130,120,131,120,58,87,29,92,56,94,127,149,127,80,160,128,130,83,94,101,69,117,49,85,33,80,133,141,132,98,158,148,29,103,50,86,110,111,226,93,53,84,146,112,102,143,111,98,164,100,163,99,123,95,136,111,244,144,227,129,176,143,24,92,104,102,241,95,137,108,72,150,129,141,108,136,145,100,240,121,206,87,89,106,16,98,72,84,88,78,11,122,233,96,132,111,218,139,127,98,30,144,139,154,228,121,3,84,244,117,1,99,25,83,96,108,223,143,27,95,112,154,59,128,127,159,136,79,58,92,100,141,197,127,165,101,189,112,69,81,178,81,107,134,7,93,160,91,189,98,108,145,116,117,12,142,32,122,1,97,121,123,199,78,248,126,133,119,17,78,237,129,29,82,250,81,113,106,168,83,135,142,4,149,207,150,193,110,100,150,90,105,132,120,133,120,134,120,136,120,138,120,139,120,143,120,144,120,146,120,148,120,149,120,150,120,153,120,157,120,158,120,160,120,162,120,164,120,166,120,168,120,169,120,170,120,171,120,172,120,173,120,174,120,175,120,181,120,182,120,183,120,184,120,186,120,187,120,188,120,189,120,191,120,192,120,194,120,195,120,196,120,198,120,199,120,200,120,204,120,205,120,206,120,207,120,209,120,210,120,211,120,214,120,215,120,216,120,218,120,219,120,220,120,221,120,222,120,223,120,224,120,225,120,226,120,227,120,228,120,229,120,230,120,231,120,233,120,234,120,235,120,237,120,238,120,239,120,240,120,241,120,243,120,245,120,246,120,248,120,249,120,251,120,252,120,253,120,254,120,255,120,0,121,2,121,3,121,4,121,6,121,7,121,8,121,9,121,10,121,11,121,12,121,64,120,168,80,215,119,16,100,230,137,4,89,227,99,221,93,127,122,61,105,32,79,57,130,152,85,50,78,174,117,151,122,98,94,138,94,239,149,27,82,57,84,138,112,118,99,36,149,130,87,37,102,63,105,135,145,7,85,243,109,175,126,34,136,51,98,240,126,181,117,40,131,193,120,204,150,158,143,72,97,247,116,205,139,100,107,58,82,80,141,33,107,106,128,113,132,241,86,6,83,206,78,27,78,209,81,151,124,139,145,7,124,195,79,127,142,225,123,156,122,103,100,20,93,172,80,6,129,1,118,185,124,236,109,224,127,81,103,88,91,248,91,203,120,174,100,19,100,170,99,43,99,25,149,45,100,190,143,84,123,41,118,83,98,39,89,70,84,121,107,163,80,52,98,38,94,134,107,227,78,55,141,139,136,133,95,46,144,13,121,14,121,15,121,16,121,17,121,18,121,20,121,21,121,22,121,23,121,24,121,25,121,26,121,27,121,28,121,29,121,31,121,32,121,33,121,34,121,35,121,37,121,38,121,39,121,40,121,41,121,42,121,43,121,44,121,45,121,46,121,47,121,48,121,49,121,50,121,51,121,53,121,54,121,55,121,56,121,57,121,61,121,63,121,66,121,67,121,68,121,69,121,71,121,74,121,75,121,76,121,77,121,78,121,79,121,80,121,81,121,82,121,84,121,85,121,88,121,89,121,97,121,99,121,100,121,102,121,105,121,106,121,107,121,108,121,110,121,112,121,113,121,114,121,115,121,116,121,117,121,118,121,121,121,123,121,124,121,125,121,126,121,127,121,130,121,131,121,134,121,135,121,136,121,137,121,139,121,140,121,141,121,142,121,144,121,145,121,146,121,32,96,61,128,197,98,57,78,85,83,248,144,184,99,198,128,230,101,46,108,70,79,238,96,225,109,222,139,57,95,203,134,83,95,33,99,90,81,97,131,99,104,0,82,99,99,72,142,18,80,155,92,119,121,252,91,48,82,59,122,188,96,83,144,215,118,183,95,151,95,132,118,108,142,111,112,123,118,73,123,170,119,243,81,147,144,36,88,78,79,244,110,234,143,76,101,27,123,196,114,164,109,223,127,225,90,181,98,149,94,48,87,130,132,44,123,29,94,31,95,18,144,20,127,160,152,130,99,199,110,152,120,185,112,120,81,91,151,171,87,53,117,67,79,56,117,151,94,230,96,96,89,192,109,191,107,137,120,252,83,213,150,203,81,1,82,137,99,10,84,147,148,3,140,204,141,57,114,159,120,118,135,237,143,13,140,224,83,147,121,148,121,149,121,150,121,151,121,152,121,153,121,155,121,156,121,157,121,158,121,159,121,160,121,161,121,162,121,163,121,164,121,165,121,166,121,168,121,169,121,170,121,171,121,172,121,173,121,174,121,175,121,176,121,177,121,178,121,180,121,181,121,182,121,183,121,184,121,188,121,191,121,194,121,196,121,197,121,199,121,200,121,202,121,204,121,206,121,207,121,208,121,211,121,212,121,214,121,215,121,217,121,218,121,219,121,220,121,221,121,222,121,224,121,225,121,226,121,229,121,232,121,234,121,236,121,238,121,241,121,242,121,243,121,244,121,245,121,246,121,247,121,249,121,250,121,252,121,254,121,255,121,1,122,4,122,5,122,7,122,8,122,9,122,10,122,12,122,15,122,16,122,17,122,18,122,19,122,21,122,22,122,24,122,25,122,27,122,28,122,1,78,239,118,238,83,137,148,118,152,14,159,45,149,154,91,162,139,34,78,28,78,172,81,99,132,194,97,168,82,11,104,151,79,107,96,187,81,30,109,92,81,150,98,151,101,97,150,70,140,23,144,216,117,253,144,99,119,210,107,138,114,236,114,251,139,53,88,121,119,76,141,92,103,64,149,154,128,166,94,33,110,146,89,239,122,237,119,59,149,181,107,173,101,14,127,6,88,81,81,31,150,249,91,169,88,40,84,114,142,102,101,127,152,228,86,157,148,254,118,65,144,135,99,198,84,26,89,58,89,155,87,178,142,53,103,250,141,53,130,65,82,240,96,21,88,254,134,232,92,69,158,196,79,157,152,185,139,37,90,118,96,132,83,124,98,79,144,2,145,127,153,105,96,12,128,63,81,51,128,20,92,117,153,49,109,140,78,29,122,31,122,33,122,34,122,36,122,37,122,38,122,39,122,40,122,41,122,42,122,43,122,44,122,45,122,46,122,47,122,48,122,49,122,50,122,52,122,53,122,54,122,56,122,58,122,62,122,64,122,65,122,66,122,67,122,68,122,69,122,71,122,72,122,73,122,74,122,75,122,76,122,77,122,78,122,79,122,80,122,82,122,83,122,84,122,85,122,86,122,88,122,89,122,90,122,91,122,92,122,93,122,94,122,95,122,96,122,97,122,98,122,99,122,100,122,101,122,102,122,103,122,104,122,105,122,106,122,107,122,108,122,109,122,110,122,111,122,113,122,114,122,115,122,117,122,123,122,124,122,125,122,126,122,130,122,133,122,135,122,137,122,138,122,139,122,140,122,142,122,143,122,144,122,147,122,148,122,153,122,154,122,155,122,158,122,161,122,162,122,48,141,209,83,90,127,79,123,16,79,79,78,0,150,213,108,208,115,233,133,6,94,106,117,251,127,10,106,254,119,146,148,65,126,225,81,230,112,205,83,212,143,3,131,41,141,175,114,109,153,219,108,74,87,179,130,185,101,170,128,63,98,50,150,168,89,255,78,191,139,186,126,62,101,242,131,94,151,97,85,222,152,165,128,42,83,253,139,32,84,186,128,159,94,184,108,57,141,172,130,90,145,41,84,27,108,6,82,183,126,95,87,26,113,126,108,137,124,75,89,253,78,255,95,36,97,170,124,48,78,1,92,171,103,2,135,240,92,11,149,206,152,175,117,253,112,34,144,175,81,29,127,189,139,73,89,228,81,91,79,38,84,43,89,119,101,164,128,117,91,118,98,194,98,144,143,69,94,31,108,38,123,15,79,216,79,13,103,163,122,164,122,167,122,169,122,170,122,171,122,174,122,175,122,176,122,177,122,178,122,180,122,181,122,182,122,183,122,184,122,185,122,186,122,187,122,188,122,189,122,190,122,192,122,193,122,194,122,195,122,196,122,197,122,198,122,199,122,200,122,201,122,202,122,204,122,205,122,206,122,207,122,208,122,209,122,210,122,211,122,212,122,213,122,215,122,216,122,218,122,219,122,220,122,221,122,225,122,226,122,228,122,231,122,232,122,233,122,234,122,235,122,236,122,238,122,240,122,241,122,242,122,243,122,244,122,245,122,246,122,247,122,248,122,251,122,252,122,254,122,0,123,1,123,2,123,5,123,7,123,9,123,12,123,13,123,14,123,16,123,18,123,19,123,22,123,23,123,24,123,26,123,28,123,29,123,31,123,33,123,34,123,35,123,39,123,41,123,45,123,110,109,170,109,143,121,177,136,23,95,43,117,154,98,133,143,239,79,220,145,167,101,47,129,81,129,156,94,80,129,116,141,111,82,134,137,75,141,13,89,133,80,216,78,28,150,54,114,121,129,31,141,204,91,163,139,68,150,135,89,26,127,144,84,118,86,14,86,229,139,57,101,130,105,153,148,214,118,137,110,114,94,24,117,70,103,209,103,255,122,157,128,118,141,31,97,198,121,98,101,99,141,136,81,26,82,162,148,56,127,155,128,178,126,151,92,47,110,96,103,217,123,139,118,216,154,143,129,148,127,213,124,30,100,80,149,63,122,74,84,229,84,76,107,1,100,8,98,61,158,243,128,153,117,114,82,105,151,91,132,60,104,228,134,1,150,148,150,236,148,42,78,4,84,217,126,57,104,223,141,21,128,244,102,154,94,185,127,47,123,48,123,50,123,52,123,53,123,54,123,55,123,57,123,59,123,61,123,63,123,64,123,65,123,66,123,67,123,68,123,70,123,72,123,74,123,77,123,78,123,83,123,85,123,87,123,89,123,92,123,94,123,95,123,97,123,99,123,100,123,101,123,102,123,103,123,104,123,105,123,106,123,107,123,108,123,109,123,111,123,112,123,115,123,116,123,118,123,120,123,122,123,124,123,125,123,127,123,129,123,130,123,131,123,132,123,134,123,135,123,136,123,137,123,138,123,139,123,140,123,142,123,143,123,145,123,146,123,147,123,150,123,152,123,153,123,154,123,155,123,158,123,159,123,160,123,163,123,164,123,165,123,174,123,175,123,176,123,178,123,179,123,181,123,182,123,183,123,185,123,186,123,187,123,188,123,189,123,190,123,191,123,192,123,194,123,195,123,196,123,194,87,63,128,151,104,229,93,59,101,159,82,109,96,154,159,155,79,172,142,108,81,171,91,19,95,233,93,94,108,241,98,33,141,113,81,169,148,254,82,159,108,223,130,215,114,162,87,132,103,45,141,31,89,156,143,199,131,149,84,141,123,48,79,189,108,100,91,209,89,19,159,228,83,202,134,168,154,55,140,161,128,69,101,126,152,250,86,199,150,46,82,220,116,80,82,225,91,2,99,2,137,86,78,208,98,42,96,250,104,115,81,152,91,160,81,194,137,161,123,134,153,80,127,239,96,76,112,47,141,73,81,127,94,27,144,112,116,196,137,45,87,69,120,82,95,159,159,250,149,104,143,60,155,225,139,120,118,66,104,220,103,234,141,53,141,61,82,138,143,218,110,205,104,5,149,237,144,253,86,156,103,249,136,199,143,200,84,197,123,200,123,201,123,202,123,203,123,205,123,206,123,207,123,208,123,210,123,212,123,213,123,214,123,215,123,216,123,219,123,220,123,222,123,223,123,224,123,226,123,227,123,228,123,231,123,232,123,233,123,235,123,236,123,237,123,239,123,240,123,242,123,243,123,244,123,245,123,246,123,248,123,249,123,250,123,251,123,253,123,255,123,0,124,1,124,2,124,3,124,4,124,5,124,6,124,8,124,9,124,10,124,13,124,14,124,16,124,17,124,18,124,19,124,20,124,21,124,23,124,24,124,25,124,26,124,27,124,28,124,29,124,30,124,32,124,33,124,34,124,35,124,36,124,37,124,40,124,41,124,43,124,44,124,45,124,46,124,47,124,48,124,49,124,50,124,51,124,52,124,53,124,54,124,55,124,57,124,58,124,59,124,60,124,61,124,62,124,66,124,184,154,105,91,119,109,38,108,165,78,179,91,135,154,99,145,168,97,175,144,233,151,43,84,181,109,210,91,253,81,138,85,85,127,240,127,188,100,77,99,241,101,190,97,141,96,10,113,87,108,73,108,47,89,109,103,42,130,213,88,142,86,106,140,235,107,221,144,125,89,23,128,247,83,105,109,117,84,157,85,119,131,207,131,56,104,190,121,140,84,85,79,8,84,210,118,137,140,2,150,179,108,184,109,107,141,16,137,100,158,58,141,63,86,209,158,213,117,136,95,224,114,104,96,252,84,168,78,42,106,97,136,82,96,112,143,196,84,216,112,121,134,63,158,42,109,143,91,24,95,162,126,137,85,175,79,52,115,60,84,154,83,25,80,14,84,124,84,78,78,253,95,90,116,246,88,107,132,225,128,116,135,208,114,202,124,86,110,67,124,68,124,69,124,70,124,71,124,72,124,73,124,74,124,75,124,76,124,78,124,79,124,80,124,81,124,82,124,83,124,84,124,85,124,86,124,87,124,88,124,89,124,90,124,91,124,92,124,93,124,94,124,95,124,96,124,97,124,98,124,99,124,100,124,101,124,102,124,103,124,104,124,105,124,106,124,107,124,108,124,109,124,110,124,111,124,112,124,113,124,114,124,117,124,118,124,119,124,120,124,121,124,122,124,126,124,127,124,128,124,129,124,130,124,131,124,132,124,133,124,134,124,135,124,136,124,138,124,139,124,140,124,141,124,142,124,143,124,144,124,147,124,148,124,150,124,153,124,154,124,155,124,160,124,161,124,163,124,166,124,167,124,168,124,169,124,171,124,172,124,173,124,175,124,176,124,180,124,181,124,182,124,183,124,184,124,186,124,187,124,39,95,78,134,44,85,164,98,146,78,170,108,55,98,177,130,215,84,78,83,62,115,209,110,59,117,18,82,22,83,221,139,208,105,138,95,0,96,238,109,79,87,34,107,175,115,83,104,216,143,19,127,98,99,163,96,36,85,234,117,98,140,21,113,163,109,166,91,123,94,82,131,76,97,196,158,250,120,87,135,39,124,135,118,240,81,246,96,76,113,67,102,76,94,77,96,14,140,112,112,37,99,137,143,189,95,98,96,212,134,222,86,193,107,148,96,103,97,73,83,224,96,102,102,63,141,253,121,26,79,233,112,71,108,179,139,242,139,216,126,100,131,15,102,90,90,66,155,81,109,247,109,65,140,59,109,25,79,107,112,183,131,22,98,209,96,13,151,39,141,120,121,251,81,62,87,250,87,58,103,120,117,61,122,239,121,149,123,191,124,192,124,194,124,195,124,196,124,198,124,201,124,203,124,206,124,207,124,208,124,209,124,210,124,211,124,212,124,216,124,218,124,219,124,221,124,222,124,225,124,226,124,227,124,228,124,229,124,230,124,231,124,233,124,234,124,235,124,236,124,237,124,238,124,240,124,241,124,242,124,243,124,244,124,245,124,246,124,247,124,249,124,250,124,252,124,253,124,254,124,255,124,0,125,1,125,2,125,3,125,4,125,5,125,6,125,7,125,8,125,9,125,11,125,12,125,13,125,14,125,15,125,16,125,17,125,18,125,19,125,20,125,21,125,22,125,23,125,24,125,25,125,26,125,27,125,28,125,29,125,30,125,31,125,33,125,35,125,36,125,37,125,38,125,40,125,41,125,42,125,44,125,45,125,46,125,48,125,49,125,50,125,51,125,52,125,53,125,54,125,140,128,101,153,249,143,192,111,165,139,33,158,236,89,233,126,9,127,9,84,129,103,216,104,145,143,77,124,198,150,202,83,37,96,190,117,114,108,115,83,201,90,167,126,36,99,224,81,10,129,241,93,223,132,128,98,128,81,99,91,14,79,109,121,66,82,184,96,78,109,196,91,194,91,161,139,176,139,226,101,204,95,69,150,147,89,231,126,170,126,9,86,183,103,57,89,115,79,182,91,160,82,90,131,138,152,62,141,50,117,190,148,71,80,60,122,247,78,182,103,126,154,193,90,124,107,209,118,90,87,22,92,58,123,244,149,78,113,124,81,169,128,112,130,120,89,4,127,39,131,192,104,236,103,177,120,119,120,227,98,97,99,128,123,237,79,106,82,207,81,80,131,219,105,116,146,245,141,49,141,193,137,46,149,173,123,246,78,55,125,56,125,57,125,58,125,59,125,60,125,61,125,62,125,63,125,64,125,65,125,66,125,67,125,68,125,69,125,70,125,71,125,72,125,73,125,74,125,75,125,76,125,77,125,78,125,79,125,80,125,81,125,82,125,83,125,84,125,85,125,86,125,87,125,88,125,89,125,90,125,91,125,92,125,93,125,94,125,95,125,96,125,97,125,98,125,99,125,100,125,101,125,102,125,103,125,104,125,105,125,106,125,107,125,108,125,109,125,111,125,112,125,113,125,114,125,115,125,116,125,117,125,118,125,120,125,121,125,122,125,123,125,124,125,125,125,126,125,127,125,128,125,129,125,130,125,131,125,132,125,133,125,134,125,135,125,136,125,137,125,138,125,139,125,140,125,141,125,142,125,143,125,144,125,145,125,146,125,147,125,148,125,149,125,150,125,151,125,152,125,101,80,48,130,81,82,111,153,16,110,133,110,167,109,250,94,245,80,220,89,6,92,70,109,95,108,134,117,139,132,104,104,86,89,178,139,32,83,113,145,77,150,73,133,18,105,1,121,38,113,246,128,164,78,202,144,71,109,132,154,7,90,188,86,5,100,240,148,235,119,165,79,26,129,225,114,210,137,122,153,52,127,222,126,127,82,89,101,117,145,127,143,131,143,235,83,150,122,237,99,165,99,134,118,248,121,87,136,54,150,42,98,171,82,130,130,84,104,112,103,119,99,107,119,237,122,1,109,211,126,227,137,208,89,18,98,201,133,165,130,76,117,31,80,203,78,165,117,235,139,74,92,254,93,75,123,164,101,209,145,202,78,37,109,95,137,39,125,38,149,197,78,40,140,219,143,115,151,75,102,129,121,209,143,236,112,120,109,153,125,154,125,155,125,156,125,157,125,158,125,159,125,160,125,161,125,162,125,163,125,164,125,165,125,167,125,168,125,169,125,170,125,171,125,172,125,173,125,175,125,176,125,177,125,178,125,179,125,180,125,181,125,182,125,183,125,184,125,185,125,186,125,187,125,188,125,189,125,190,125,191,125,192,125,193,125,194,125,195,125,196,125,197,125,198,125,199,125,200,125,201,125,202,125,203,125,204,125,205,125,206,125,207,125,208,125,209,125,210,125,211,125,212,125,213,125,214,125,215,125,216,125,217,125,218,125,219,125,220,125,221,125,222,125,223,125,224,125,225,125,226,125,227,125,228,125,229,125,230,125,231,125,232,125,233,125,234,125,235,125,236,125,237,125,238,125,239,125,240,125,241,125,242,125,243,125,244,125,245,125,246,125,247,125,248,125,249,125,250,125,61,92,178,82,70,131,98,81,14,131,91,119,118,102,184,156,172,78,202,96,190,124,179,124,207,126,149,78,102,139,111,102,136,152,89,151,131,88,108,101,92,149,132,95,201,117,86,151,223,122,222,122,192,81,175,112,152,122,234,99,118,122,160,126,150,115,237,151,69,78,120,112,93,78,82,145,169,83,81,101,231,101,252,129,5,130,142,84,49,92,154,117,160,151,216,98,217,114,189,117,69,92,121,154,202,131,64,92,128,84,233,119,62,78,174,108,90,128,210,98,110,99,232,93,119,81,221,141,30,142,47,149,241,79,229,83,231,96,172,112,103,82,80,99,67,158,31,90,38,80,55,119,119,83,226,126,133,100,43,101,137,98,152,99,20,80,53,114,201,137,179,81,192,139,221,126,71,87,204,131,167,148,155,81,27,84,251,92,251,125,252,125,253,125,254,125,255,125,0,126,1,126,2,126,3,126,4,126,5,126,6,126,7,126,8,126,9,126,10,126,11,126,12,126,13,126,14,126,15,126,16,126,17,126,18,126,19,126,20,126,21,126,22,126,23,126,24,126,25,126,26,126,27,126,28,126,29,126,30,126,31,126,32,126,33,126,34,126,35,126,36,126,37,126,38,126,39,126,40,126,41,126,42,126,43,126,44,126,45,126,46,126,47,126,48,126,49,126,50,126,51,126,52,126,53,126,54,126,55,126,56,126,57,126,58,126,60,126,61,126,62,126,63,126,64,126,66,126,67,126,68,126,69,126,70,126,72,126,73,126,74,126,75,126,76,126,77,126,78,126,79,126,80,126,81,126,82,126,83,126,84,126,85,126,86,126,87,126,88,126,89,126,90,126,91,126,92,126,93,126,202,79,227,122,90,109,225,144,143,154,128,85,150,84,97,83,175,84,0,95,233,99,119,105,239,81,104,97,10,82,42,88,216,82,78,87,13,120,11,119,183,94,119,97,224,124,91,98,151,98,162,78,149,112,3,128,247,98,228,112,96,151,119,87,219,130,239,103,245,104,213,120,151,152,209,121,243,88,179,84,239,83,52,110,75,81,59,82,162,91,254,139,175,128,67,85,166,87,115,96,81,87,45,84,122,122,80,96,84,91,167,99,160,98,227,83,99,98,199,91,175,103,237,84,159,122,230,130,119,145,147,94,228,136,56,89,174,87,14,99,232,141,239,128,87,87,119,123,169,79,235,95,189,91,62,107,33,83,80,123,194,114,70,104,255,119,54,119,247,101,181,81,143,78,212,118,191,92,165,122,117,132,78,89,65,155,128,80,94,126,95,126,96,126,97,126,98,126,99,126,100,126,101,126,102,126,103,126,104,126,105,126,106,126,107,126,108,126,109,126,110,126,111,126,112,126,113,126,114,126,115,126,116,126,117,126,118,126,119,126,120,126,121,126,122,126,123,126,124,126,125,126,126,126,127,126,128,126,129,126,131,126,132,126,133,126,134,126,135,126,136,126,137,126,138,126,139,126,140,126,141,126,142,126,143,126,144,126,145,126,146,126,147,126,148,126,149,126,150,126,151,126,152,126,153,126,154,126,156,126,157,126,158,126,174,126,180,126,187,126,188,126,214,126,228,126,236,126,249,126,10,127,16,127,30,127,55,127,57,127,59,127,60,127,61,127,62,127,63,127,64,127,65,127,67,127,70,127,71,127,72,127,73,127,74,127,75,127,76,127,77,127,78,127,79,127,82,127,83,127,136,153,39,97,131,110,100,87,6,102,70,99,240,86,236,98,105,98,211,94,20,150,131,87,201,98,135,85,33,135,74,129,163,143,102,85,177,131,101,103,86,141,221,132,106,90,15,104,230,98,238,123,17,150,112,81,156,111,48,140,253,99,200,137,210,97,6,127,194,112,229,110,5,116,148,105,252,114,202,94,206,144,23,103,106,109,94,99,179,82,98,114,1,128,108,79,229,89,106,145,217,112,157,109,210,82,80,78,247,150,109,149,126,133,202,120,47,125,33,81,146,87,194,100,139,128,123,124,234,108,241,104,94,105,183,81,152,83,168,104,129,114,206,158,241,123,248,114,187,121,19,111,6,116,78,103,204,145,164,156,60,121,137,131,84,131,15,84,23,104,61,78,137,83,177,82,62,120,134,83,41,82,136,80,139,79,208,79,86,127,89,127,91,127,92,127,93,127,94,127,96,127,99,127,100,127,101,127,102,127,103,127,107,127,108,127,109,127,111,127,112,127,115,127,117,127,118,127,119,127,120,127,122,127,123,127,124,127,125,127,127,127,128,127,130,127,131,127,132,127,133,127,134,127,135,127,136,127,137,127,139,127,141,127,143,127,144,127,145,127,146,127,147,127,149,127,150,127,151,127,152,127,153,127,155,127,156,127,160,127,162,127,163,127,165,127,166,127,168,127,169,127,170,127,171,127,172,127,173,127,174,127,177,127,179,127,180,127,181,127,182,127,183,127,186,127,187,127,190,127,192,127,194,127,195,127,196,127,198,127,199,127,200,127,201,127,203,127,205,127,207,127,208,127,209,127,210,127,211,127,214,127,215,127,217,127,218,127,219,127,220,127,221,127,222,127,226,127,227,127,226,117,203,122,146,124,165,108,182,150,155,82,131,116,233,84,233,79,84,128,178,131,222,143,112,149,201,94,28,96,159,109,24,94,91,101,56,129,254,148,75,96,188,112,195,126,174,124,201,81,129,104,177,124,111,130,36,78,134,143,207,145,126,102,174,78,5,140,169,100,74,128,218,80,151,117,206,113,229,91,189,143,102,111,134,78,130,100,99,149,214,94,153,101,23,82,194,136,200,112,163,82,14,115,51,116,151,103,247,120,22,151,52,78,187,144,222,156,203,109,219,81,65,141,29,84,206,98,178,115,241,131,246,150,132,159,195,148,54,79,154,127,204,81,117,112,117,150,173,92,134,152,230,83,228,78,156,110,9,116,180,105,107,120,143,153,89,117,24,82,36,118,65,109,243,103,109,81,153,159,75,128,153,84,60,123,191,122,228,127,231,127,232,127,234,127,235,127,236,127,237,127,239,127,242,127,244,127,245,127,246,127,247,127,248,127,249,127,250,127,253,127,254,127,255,127,2,128,7,128,8,128,9,128,10,128,14,128,15,128,17,128,19,128,26,128,27,128,29,128,30,128,31,128,33,128,35,128,36,128,43,128,44,128,45,128,46,128,47,128,48,128,50,128,52,128,57,128,58,128,60,128,62,128,64,128,65,128,68,128,69,128,71,128,72,128,73,128,78,128,79,128,80,128,81,128,83,128,85,128,86,128,87,128,89,128,91,128,92,128,93,128,94,128,95,128,96,128,97,128,98,128,99,128,100,128,101,128,102,128,103,128,104,128,107,128,108,128,109,128,110,128,111,128,112,128,114,128,115,128,116,128,117,128,118,128,119,128,120,128,121,128,122,128,123,128,124,128,125,128,134,150,132,87,226,98,71,150,124,105,4,90,2,100,211,123,15,111,75,150,166,130,98,83,133,152,144,94,137,112,179,99,100,83,79,134,129,156,147,158,140,120,50,151,239,141,66,141,127,158,94,111,132,121,85,95,70,150,46,98,116,154,21,84,221,148,163,79,197,101,101,92,97,92,21,127,81,134,47,108,139,95,135,115,228,110,255,126,230,92,27,99,106,91,230,110,117,83,113,78,160,99,101,117,161,98,110,143,38,79,209,78,166,108,182,126,186,139,29,132,186,135,87,127,59,144,35,149,169,123,161,154,248,136,61,132,27,109,134,154,220,126,136,89,187,158,155,115,1,120,130,134,108,154,130,154,27,86,23,84,203,87,112,78,166,158,86,83,200,143,9,129,146,119,146,153,238,134,225,110,19,133,252,102,98,97,43,111,126,128,129,128,130,128,133,128,136,128,138,128,141,128,142,128,143,128,144,128,145,128,146,128,148,128,149,128,151,128,153,128,158,128,163,128,166,128,167,128,168,128,172,128,176,128,179,128,181,128,182,128,184,128,185,128,187,128,197,128,199,128,200,128,201,128,202,128,203,128,207,128,208,128,209,128,210,128,211,128,212,128,213,128,216,128,223,128,224,128,226,128,227,128,230,128,238,128,245,128,247,128,249,128,251,128,254,128,255,128,0,129,1,129,3,129,4,129,5,129,7,129,8,129,11,129,12,129,21,129,23,129,25,129,27,129,28,129,29,129,31,129,32,129,33,129,34,129,35,129,36,129,37,129,38,129,39,129,40,129,41,129,42,129,43,129,45,129,46,129,48,129,51,129,52,129,53,129,55,129,57,129,58,129,59,129,60,129,61,129,63,129,41,140,146,130,43,131,242,118,19,108,217,95,189,131,43,115,5,131,26,149,219,107,219,119,198,148,111,83,2,131,146,81,61,94,140,140,56,141,72,78,171,115,154,103,133,104,118,145,9,151,100,113,161,108,9,119,146,90,65,149,207,107,142,127,39,102,208,91,185,89,154,90,232,149,247,149,236,78,12,132,153,132,172,106,223,118,48,149,27,115,166,104,95,91,47,119,154,145,97,151,220,124,247,143,28,140,37,95,115,124,216,121,197,137,204,108,28,135,198,91,66,94,201,104,32,119,245,126,149,81,77,81,201,82,41,90,5,127,98,151,215,130,207,99,132,119,208,133,210,121,58,110,153,94,153,89,17,133,109,112,17,108,191,98,191,118,79,101,175,96,253,149,14,102,159,135,35,158,237,148,13,84,125,84,44,140,120,100,64,129,65,129,66,129,67,129,68,129,69,129,71,129,73,129,77,129,78,129,79,129,82,129,86,129,87,129,88,129,91,129,92,129,93,129,94,129,95,129,97,129,98,129,99,129,100,129,102,129,104,129,106,129,107,129,108,129,111,129,114,129,115,129,117,129,118,129,119,129,120,129,129,129,131,129,132,129,133,129,134,129,135,129,137,129,139,129,140,129,141,129,142,129,144,129,146,129,147,129,148,129,149,129,150,129,151,129,153,129,154,129,158,129,159,129,160,129,161,129,162,129,164,129,165,129,167,129,169,129,171,129,172,129,173,129,174,129,175,129,176,129,177,129,178,129,180,129,181,129,182,129,183,129,184,129,185,129,188,129,189,129,190,129,191,129,196,129,197,129,199,129,200,129,201,129,203,129,205,129,206,129,207,129,208,129,209,129,210,129,211,129,121,100,17,134,33,106,156,129,232,120,105,100,84,155,185,98,43,103,171,131,168,88,216,158,171,108,32,111,222,91,76,150,11,140,95,114,208,103,199,98,97,114,169,78,198,89,205,107,147,88,174,102,85,94,223,82,85,97,40,103,238,118,102,119,103,114,70,122,255,98,234,84,80,84,160,148,163,144,28,90,179,126,22,108,67,78,118,89,16,128,72,89,87,83,55,117,190,150,202,86,32,99,17,129,124,96,249,149,214,109,98,84,129,153,133,81,233,90,253,128,174,89,19,151,42,80,229,108,60,92,223,98,96,79,63,83,123,129,6,144,186,110,43,133,200,98,116,94,190,120,181,100,123,99,245,95,24,90,127,145,31,158,63,92,79,99,66,128,125,91,110,85,74,149,77,149,133,109,168,96,224,103,222,114,221,81,129,91,212,129,213,129,214,129,215,129,216,129,217,129,218,129,219,129,220,129,221,129,222,129,223,129,224,129,225,129,226,129,228,129,229,129,230,129,232,129,233,129,235,129,238,129,239,129,240,129,241,129,242,129,245,129,246,129,247,129,248,129,249,129,250,129,253,129,255,129,3,130,7,130,8,130,9,130,10,130,11,130,14,130,15,130,17,130,19,130,21,130,22,130,23,130,24,130,25,130,26,130,29,130,32,130,36,130,37,130,38,130,39,130,41,130,46,130,50,130,58,130,60,130,61,130,63,130,64,130,65,130,66,130,67,130,69,130,70,130,72,130,74,130,76,130,77,130,78,130,80,130,81,130,82,130,83,130,84,130,85,130,86,130,87,130,89,130,91,130,92,130,93,130,94,130,96,130,97,130,98,130,99,130,100,130,101,130,102,130,103,130,105,130,231,98,222,108,91,114,109,98,174,148,189,126,19,129,83,109,156,81,4,95,116,89,170,82,18,96,115,89,150,102,80,134,159,117,42,99,230,97,239,124,250,139,230,84,39,107,37,158,180,107,213,133,85,84,118,80,164,108,106,85,180,141,44,114,21,94,21,96,54,116,205,98,146,99,76,114,152,95,67,110,62,109,0,101,88,111,216,118,208,120,252,118,84,117,36,82,219,83,83,78,158,94,193,101,42,128,214,128,155,98,134,84,40,82,174,112,141,136,209,141,225,108,120,84,218,128,249,87,244,136,84,141,106,150,77,145,105,79,155,108,183,85,198,118,48,120,168,98,249,112,142,111,109,95,236,132,218,104,124,120,247,123,168,129,11,103,79,158,103,99,176,120,111,87,18,120,57,151,121,98,171,98,136,82,53,116,215,107,106,130,107,130,108,130,109,130,113,130,117,130,118,130,119,130,120,130,123,130,124,130,128,130,129,130,131,130,133,130,134,130,135,130,137,130,140,130,144,130,147,130,148,130,149,130,150,130,154,130,155,130,158,130,160,130,162,130,163,130,167,130,178,130,181,130,182,130,186,130,187,130,188,130,191,130,192,130,194,130,195,130,197,130,198,130,201,130,208,130,214,130,217,130,218,130,221,130,226,130,231,130,232,130,233,130,234,130,236,130,237,130,238,130,240,130,242,130,243,130,245,130,246,130,248,130,250,130,252,130,253,130,254,130,255,130,0,131,10,131,11,131,13,131,16,131,18,131,19,131,22,131,24,131,25,131,29,131,30,131,31,131,32,131,33,131,34,131,35,131,36,131,37,131,38,131,41,131,42,131,46,131,48,131,50,131,55,131,59,131,61,131,100,85,62,129,178,117,174,118,57,83,222,117,251,80,65,92,108,139,199,123,79,80,71,114,151,154,216,152,2,111,226,116,104,121,135,100,165,119,252,98,145,152,43,141,193,84,88,128,82,78,106,87,249,130,13,132,115,94,237,81,246,116,196,139,79,92,97,87,252,108,135,152,70,90,52,120,68,155,235,143,149,124,86,82,81,98,250,148,198,78,134,131,97,132,233,131,178,132,212,87,52,103,3,87,110,102,102,109,49,140,221,102,17,112,31,103,58,107,22,104,26,98,187,89,3,78,196,81,6,111,210,103,143,108,118,81,203,104,71,89,103,107,102,117,14,93,16,129,80,159,215,101,72,121,65,121,145,154,119,141,130,92,94,78,1,79,47,84,81,89,12,120,104,86,20,108,196,143,3,95,125,108,227,108,171,139,144,99,62,131,63,131,65,131,66,131,68,131,69,131,72,131,74,131,75,131,76,131,77,131,78,131,83,131,85,131,86,131,87,131,88,131,89,131,93,131,98,131,112,131,113,131,114,131,115,131,116,131,117,131,118,131,121,131,122,131,126,131,127,131,128,131,129,131,130,131,131,131,132,131,135,131,136,131,138,131,139,131,140,131,141,131,143,131,144,131,145,131,148,131,149,131,150,131,151,131,153,131,154,131,157,131,159,131,161,131,162,131,163,131,164,131,165,131,166,131,167,131,172,131,173,131,174,131,175,131,181,131,187,131,190,131,191,131,194,131,195,131,196,131,198,131,200,131,201,131,203,131,205,131,206,131,208,131,209,131,210,131,211,131,213,131,215,131,217,131,218,131,219,131,222,131,226,131,227,131,228,131,230,131,231,131,232,131,235,131,236,131,237,131,112,96,61,109,117,114,102,98,142,148,197,148,67,83,193,143,126,123,223,78,38,140,126,78,212,158,177,148,179,148,77,82,92,111,99,144,69,109,52,140,17,88,76,93,32,107,73,107,170,103,91,84,84,129,140,127,153,88,55,133,58,95,162,98,71,106,57,149,114,101,132,96,101,104,167,119,84,78,168,79,231,93,152,151,172,100,216,127,237,92,207,79,141,122,7,82,4,131,20,78,47,96,131,122,166,148,181,79,178,78,230,121,52,116,228,82,185,130,210,100,189,121,221,91,129,108,82,151,123,143,34,108,62,80,127,83,5,110,206,100,116,102,48,108,197,96,119,152,247,139,134,94,60,116,119,122,203,121,24,78,177,144,3,116,66,108,218,86,75,145,197,108,139,141,58,83,198,134,242,102,175,142,72,92,113,154,32,110,238,131,239,131,243,131,244,131,245,131,246,131,247,131,250,131,251,131,252,131,254,131,255,131,0,132,2,132,5,132,7,132,8,132,9,132,10,132,16,132,18,132,19,132,20,132,21,132,22,132,23,132,25,132,26,132,27,132,30,132,31,132,32,132,33,132,34,132,35,132,41,132,42,132,43,132,44,132,45,132,46,132,47,132,48,132,50,132,51,132,52,132,53,132,54,132,55,132,57,132,58,132,59,132,62,132,63,132,64,132,65,132,66,132,67,132,68,132,69,132,71,132,72,132,73,132,74,132,75,132,76,132,77,132,78,132,79,132,80,132,82,132,83,132,84,132,85,132,86,132,88,132,93,132,94,132,95,132,96,132,98,132,100,132,101,132,102,132,103,132,104,132,106,132,110,132,111,132,112,132,114,132,116,132,119,132,121,132,123,132,124,132,214,83,54,90,139,159,163,141,187,83,8,87,167,152,67,103,155,145,201,108,104,81,202,117,243,98,172,114,56,82,157,82,58,127,148,112,56,118,116,83,74,158,183,105,110,120,192,150,217,136,164,127,54,113,195,113,137,81,211,103,228,116,228,88,24,101,183,86,169,139,118,153,112,98,213,126,249,96,237,112,236,88,193,78,186,78,205,95,231,151,251,78,164,139,3,82,138,89,171,126,84,98,205,78,229,101,14,98,56,131,201,132,99,131,141,135,148,113,182,110,185,91,210,126,151,81,201,99,212,103,137,128,57,131,21,136,18,81,122,91,130,89,177,143,115,78,93,108,101,81,37,137,111,143,46,150,74,133,94,116,16,149,240,149,166,109,229,130,49,95,146,100,18,109,40,132,110,129,195,156,94,88,91,141,9,78,193,83,125,132,126,132,127,132,128,132,129,132,131,132,132,132,133,132,134,132,138,132,141,132,143,132,144,132,145,132,146,132,147,132,148,132,149,132,150,132,152,132,154,132,155,132,157,132,158,132,159,132,160,132,162,132,163,132,164,132,165,132,166,132,167,132,168,132,169,132,170,132,171,132,172,132,173,132,174,132,176,132,177,132,179,132,181,132,182,132,183,132,187,132,188,132,190,132,192,132,194,132,195,132,197,132,198,132,199,132,200,132,203,132,204,132,206,132,207,132,210,132,212,132,213,132,215,132,216,132,217,132,218,132,219,132,220,132,222,132,225,132,226,132,228,132,231,132,232,132,233,132,234,132,235,132,237,132,238,132,239,132,241,132,242,132,243,132,244,132,245,132,246,132,247,132,248,132,249,132,250,132,251,132,253,132,254,132,0,133,1,133,2,133,30,79,99,101,81,104,211,85,39,78,20,100,154,154,107,98,194,90,95,116,114,130,169,109,238,104,231,80,142,131,2,120,64,103,57,82,153,108,177,126,187,80,101,85,94,113,91,123,82,102,202,115,235,130,73,103,113,92,32,82,125,113,107,136,234,149,85,150,197,100,97,141,179,129,132,85,85,108,71,98,46,127,146,88,36,79,70,85,79,141,76,102,10,78,26,92,243,136,162,104,78,99,13,122,231,112,141,130,250,82,246,151,17,92,232,84,181,144,205,126,98,89,74,141,199,134,12,130,13,130,102,141,68,100,4,92,81,97,137,109,62,121,190,139,55,120,51,117,123,84,56,79,171,142,241,109,32,90,197,126,94,121,136,108,161,91,118,90,26,117,190,128,78,97,23,110,240,88,31,117,37,117,114,114,71,83,243,126,3,133,4,133,5,133,6,133,7,133,8,133,9,133,10,133,11,133,13,133,14,133,15,133,16,133,18,133,20,133,21,133,22,133,24,133,25,133,27,133,28,133,29,133,30,133,32,133,34,133,35,133,36,133,37,133,38,133,39,133,40,133,41,133,42,133,45,133,46,133,47,133,48,133,49,133,50,133,51,133,52,133,53,133,54,133,62,133,63,133,64,133,65,133,66,133,68,133,69,133,70,133,71,133,75,133,76,133,77,133,78,133,79,133,80,133,81,133,82,133,83,133,84,133,85,133,87,133,88,133,90,133,91,133,92,133,93,133,95,133,96,133,97,133,98,133,99,133,101,133,102,133,103,133,105,133,106,133,107,133,108,133,109,133,110,133,111,133,112,133,113,133,115,133,117,133,118,133,119,133,120,133,124,133,125,133,127,133,128,133,129,133,1,119,219,118,105,82,220,128,35,87,8,94,49,89,238,114,189,101,127,110,215,139,56,92,113,134,65,83,243,119,254,98,246,101,192,78,223,152,128,134,158,91,198,139,242,83,226,119,127,79,78,92,118,154,203,89],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+240828),
allocate([15,95,58,121,235,88,22,78,255,103,139,78,237,98,147,138,29,144,191,82,47,102,220,85,108,86,2,144,213,78,141,79,202,145,112,153,15,108,2,94,67,96,164,91,198,137,213,139,54,101,75,98,150,153,136,91,255,91,136,99,46,85,215,83,38,118,125,81,44,133,162,103,179,104,138,107,146,98,147,143,212,83,18,130,209,109,143,117,102,78,78,141,112,91,159,113,175,133,145,102,217,102,114,127,0,135,205,158,32,159,94,92,47,103,240,143,17,104,95,103,13,98,214,122,133,88,182,94,112,101,49,111,130,133,131,133,134,133,136,133,137,133,138,133,139,133,140,133,141,133,142,133,144,133,145,133,146,133,147,133,148,133,149,133,150,133,151,133,152,133,153,133,154,133,157,133,158,133,159,133,160,133,161,133,162,133,163,133,165,133,166,133,167,133,169,133,171,133,172,133,173,133,177,133,178,133,179,133,180,133,181,133,182,133,184,133,186,133,187,133,188,133,189,133,190,133,191,133,192,133,194,133,195,133,196,133,197,133,198,133,199,133,200,133,202,133,203,133,204,133,205,133,206,133,209,133,210,133,212,133,214,133,215,133,216,133,217,133,218,133,219,133,221,133,222,133,223,133,224,133,225,133,226,133,227,133,229,133,230,133,231,133,232,133,234,133,235,133,236,133,237,133,238,133,239,133,240,133,241,133,242,133,243,133,244,133,245,133,246,133,247,133,248,133,85,96,55,82,13,128,84,100,112,136,41,117,5,94,19,104,244,98,28,151,204,83,61,114,1,140,52,108,97,119,14,122,46,84,172,119,122,152,28,130,244,139,85,120,20,103,193,112,175,101,149,100,54,86,29,96,193,121,248,83,29,78,123,107,134,128,250,91,227,85,219,86,58,79,60,79,114,153,243,93,126,103,56,128,2,96,130,152,1,144,139,91,188,139,245,139,28,100,88,130,222,100,253,85,207,130,101,145,215,79,32,125,31,144,159,124,243,80,81,88,175,110,191,91,201,139,131,128,120,145,156,132,151,123,125,134,139,150,143,150,229,126,211,154,142,120,129,92,87,122,66,144,167,150,95,121,89,91,95,99,11,123,209,132,173,104,6,85,41,127,16,116,34,125,1,149,64,98,76,88,214,78,131,91,121,89,84,88,249,133,250,133,252,133,253,133,254,133,0,134,1,134,2,134,3,134,4,134,6,134,7,134,8,134,9,134,10,134,11,134,12,134,13,134,14,134,15,134,16,134,18,134,19,134,20,134,21,134,23,134,24,134,25,134,26,134,27,134,28,134,29,134,30,134,31,134,32,134,33,134,34,134,35,134,36,134,37,134,38,134,40,134,42,134,43,134,44,134,45,134,46,134,47,134,48,134,49,134,50,134,51,134,52,134,53,134,54,134,55,134,57,134,58,134,59,134,61,134,62,134,63,134,64,134,65,134,66,134,67,134,68,134,69,134,70,134,71,134,72,134,73,134,74,134,75,134,76,134,82,134,83,134,85,134,86,134,87,134,88,134,89,134,91,134,92,134,93,134,95,134,96,134,97,134,99,134,100,134,101,134,102,134,103,134,104,134,105,134,106,134,109,115,30,99,75,142,15,142,206,128,212,130,172,98,240,83,240,108,94,145,42,89,1,96,112,108,77,87,74,100,42,141,43,118,233,110,91,87,128,106,240,117,109,111,45,140,8,140,102,87,239,107,146,136,179,120,162,99,249,83,173,112,100,108,88,88,42,100,2,88,224,104,155,129,16,85,214,124,24,80,186,142,204,109,159,141,235,112,143,99,155,109,212,110,230,126,4,132,67,104,3,144,216,109,118,150,168,139,87,89,121,114,228,133,126,129,188,117,138,138,175,104,84,82,34,142,17,149,208,99,152,152,68,142,124,85,83,79,255,102,143,86,213,96,149,109,67,82,73,92,41,89,251,109,107,88,48,117,28,117,108,96,20,130,70,129,17,99,97,103,226,143,58,119,243,141,52,141,193,148,22,94,133,83,44,84,195,112,109,134,111,134,112,134,114,134,115,134,116,134,117,134,118,134,119,134,120,134,131,134,132,134,133,134,134,134,135,134,136,134,137,134,142,134,143,134,144,134,145,134,146,134,148,134,150,134,151,134,152,134,153,134,154,134,155,134,158,134,159,134,160,134,161,134,162,134,165,134,166,134,171,134,173,134,174,134,178,134,179,134,183,134,184,134,185,134,187,134,188,134,189,134,190,134,191,134,193,134,194,134,195,134,197,134,200,134,204,134,205,134,210,134,211,134,213,134,214,134,215,134,218,134,220,134,221,134,224,134,225,134,226,134,227,134,229,134,230,134,231,134,232,134,234,134,235,134,236,134,239,134,245,134,246,134,247,134,250,134,251,134,252,134,253,134,255,134,1,135,4,135,5,135,6,135,11,135,12,135,14,135,15,135,16,135,17,135,20,135,22,135,64,108,247,94,92,80,173,78,173,94,58,99,71,130,26,144,80,104,110,145,179,119,12,84,220,148,100,95,229,122,118,104,69,99,82,123,223,126,219,117,119,80,149,98,52,89,15,144,248,81,195,121,129,122,254,86,146,95,20,144,130,109,96,92,31,87,16,84,84,81,77,110,226,86,168,99,147,152,127,129,21,135,42,137,0,144,30,84,111,92,192,129,214,98,88,98,49,129,53,158,64,150,110,154,124,154,45,105,165,89,211,98,62,85,22,99,199,84,217,134,60,109,3,90,230,116,156,136,106,107,22,89,76,140,47,95,126,110,169,115,125,152,56,78,247,112,140,91,151,120,61,99,90,102,150,118,203,96,155,91,73,90,7,78,85,129,106,108,139,115,161,78,137,103,81,127,128,95,250,101,27,103,216,95,132,89,1,90,25,135,27,135,29,135,31,135,32,135,36,135,38,135,39,135,40,135,42,135,43,135,44,135,45,135,47,135,48,135,50,135,51,135,53,135,54,135,56,135,57,135,58,135,60,135,61,135,64,135,65,135,66,135,67,135,68,135,69,135,70,135,74,135,75,135,77,135,79,135,80,135,81,135,82,135,84,135,85,135,86,135,88,135,90,135,91,135,92,135,93,135,94,135,95,135,97,135,98,135,102,135,103,135,104,135,105,135,106,135,107,135,108,135,109,135,111,135,113,135,114,135,115,135,117,135,119,135,120,135,121,135,122,135,127,135,128,135,129,135,132,135,134,135,135,135,137,135,138,135,140,135,142,135,143,135,144,135,145,135,146,135,148,135,149,135,150,135,152,135,153,135,154,135,155,135,156,135,157,135,158,135,160,135,161,135,162,135,163,135,164,135,205,93,174,95,113,83,230,151,221,143,69,104,244,86,47,85,223,96,58,78,77,111,244,126,199,130,14,132,212,89,31,79,42,79,62,92,172,126,42,103,26,133,115,84,79,117,195,128,130,85,79,155,77,79,45,110,19,140,9,92,112,97,107,83,31,118,41,110,138,134,135,101,251,149,185,126,59,84,51,122,10,125,238,149,225,85,193,127,238,116,29,99,23,135,161,109,157,122,17,98,161,101,103,83,225,99,131,108,235,93,92,84,168,148,76,78,97,108,236,139,75,92,224,101,156,130,167,104,62,84,52,84,203,107,102,107,148,78,66,99,72,83,30,130,13,79,174,79,94,87,10,98,254,150,100,102,105,114,255,82,161,82,159,96,239,139,20,102,153,113,144,103,127,137,82,120,253,119,112,102,59,86,56,84,33,149,122,114,165,135,166,135,167,135,169,135,170,135,174,135,176,135,177,135,178,135,180,135,182,135,183,135,184,135,185,135,187,135,188,135,190,135,191,135,193,135,194,135,195,135,196,135,197,135,199,135,200,135,201,135,204,135,205,135,206,135,207,135,208,135,212,135,213,135,214,135,215,135,216,135,217,135,218,135,220,135,221,135,222,135,223,135,225,135,226,135,227,135,228,135,230,135,231,135,232,135,233,135,235,135,236,135,237,135,239,135,240,135,241,135,242,135,243,135,244,135,245,135,246,135,247,135,248,135,250,135,251,135,252,135,253,135,255,135,0,136,1,136,2,136,4,136,5,136,6,136,7,136,8,136,9,136,11,136,12,136,13,136,14,136,15,136,16,136,17,136,18,136,20,136,23,136,24,136,25,136,26,136,28,136,29,136,30,136,31,136,32,136,35,136,0,122,111,96,12,94,137,96,157,129,21,89,220,96,132,113,239,112,170,110,80,108,128,114,132,106,173,136,45,94,96,78,179,90,156,85,227,148,23,109,251,124,153,150,15,98,198,126,142,119,126,134,35,83,30,151,150,143,135,102,225,92,160,79,237,114,11,78,166,83,15,89,19,84,128,99,40,149,72,81,217,78,156,156,164,126,184,84,36,141,84,136,55,130,242,149,142,109,38,95,204,90,62,102,105,150,176,115,46,115,191,83,122,129,133,153,161,127,170,91,119,150,80,150,191,126,248,118,162,83,118,149,153,153,177,123,68,137,88,110,97,78,212,127,101,121,230,139,243,96,205,84,171,78,121,152,247,93,97,106,207,80,17,84,97,140,39,132,93,120,4,151,74,82,238,84,163,86,0,149,136,109,181,91,198,109,83,102,36,136,37,136,38,136,39,136,40,136,41,136,42,136,43,136,44,136,45,136,46,136,47,136,48,136,49,136,51,136,52,136,53,136,54,136,55,136,56,136,58,136,59,136,61,136,62,136,63,136,65,136,66,136,67,136,70,136,71,136,72,136,73,136,74,136,75,136,78,136,79,136,80,136,81,136,82,136,83,136,85,136,86,136,88,136,90,136,91,136,92,136,93,136,94,136,95,136,96,136,102,136,103,136,106,136,109,136,111,136,113,136,115,136,116,136,117,136,118,136,120,136,121,136,122,136,123,136,124,136,128,136,131,136,134,136,135,136,137,136,138,136,140,136,142,136,143,136,144,136,145,136,147,136,148,136,149,136,151,136,152,136,153,136,154,136,155,136,157,136,158,136,159,136,160,136,161,136,163,136,165,136,166,136,167,136,168,136,169,136,170,136,15,92,93,91,33,104,150,128,120,85,17,123,72,101,84,105,155,78,71,107,78,135,139,151,79,83,31,99,58,100,170,144,156,101,193,128,16,140,153,81,176,104,120,83,249,135,200,97,196,108,251,108,34,140,81,92,170,133,175,130,12,149,35,107,155,143,176,101,251,95,195,95,225,79,69,136,31,102,101,129,41,115,250,96,116,81,17,82,139,87,98,95,162,144,76,136,146,145,120,94,79,103,39,96,211,89,68,81,246,81,248,128,8,83,121,108,196,150,138,113,17,79,238,79,158,127,61,103,197,85,8,149,192,121,150,136,227,126,159,88,12,98,0,151,90,134,24,86,123,152,144,95,184,139,196,132,87,145,217,83,237,101,143,94,92,117,100,96,110,125,127,90,234,126,237,126,105,143,167,85,163,91,172,96,203,101,132,115,172,136,174,136,175,136,176,136,178,136,179,136,180,136,181,136,182,136,184,136,185,136,186,136,187,136,189,136,190,136,191,136,192,136,195,136,196,136,199,136,200,136,202,136,203,136,204,136,205,136,207,136,208,136,209,136,211,136,214,136,215,136,218,136,219,136,220,136,221,136,222,136,224,136,225,136,230,136,231,136,233,136,234,136,235,136,236,136,237,136,238,136,239,136,242,136,245,136,246,136,247,136,250,136,251,136,253,136,255,136,0,137,1,137,3,137,4,137,5,137,6,137,7,137,8,137,9,137,11,137,12,137,13,137,14,137,15,137,17,137,20,137,21,137,22,137,23,137,24,137,28,137,29,137,30,137,31,137,32,137,34,137,35,137,36,137,38,137,39,137,40,137,41,137,44,137,45,137,46,137,47,137,49,137,50,137,51,137,53,137,55,137,9,144,99,118,41,119,218,126,116,151,155,133,102,91,116,122,234,150,64,136,203,82,143,113,170,95,236,101,226,139,251,91,111,154,225,93,137,107,91,108,173,139,175,139,10,144,197,143,139,83,188,98,38,158,45,158,64,84,43,78,189,130,89,114,156,134,22,93,89,136,175,109,197,150,209,84,154,78,182,139,9,113,189,84,9,150,223,112,249,109,208,118,37,78,20,120,18,135,169,92,246,94,0,138,156,152,14,150,142,112,191,108,68,89,169,99,60,119,77,136,20,111,115,130,48,88,213,113,140,83,26,120,193,150,1,85,102,95,48,113,180,91,26,140,140,154,131,107,46,89,47,158,231,121,104,103,108,98,111,79,161,117,138,127,11,109,51,150,39,108,240,78,210,117,123,81,55,104,62,111,128,144,112,129,150,89,118,116,56,137,57,137,58,137,59,137,60,137,61,137,62,137,63,137,64,137,66,137,67,137,69,137,70,137,71,137,72,137,73,137,74,137,75,137,76,137,77,137,78,137,79,137,80,137,81,137,82,137,83,137,84,137,85,137,86,137,87,137,88,137,89,137,90,137,91,137,92,137,93,137,96,137,97,137,98,137,99,137,100,137,101,137,103,137,104,137,105,137,106,137,107,137,108,137,109,137,110,137,111,137,112,137,113,137,114,137,115,137,116,137,117,137,118,137,119,137,120,137,121,137,122,137,124,137,125,137,126,137,128,137,130,137,132,137,133,137,135,137,136,137,137,137,138,137,139,137,140,137,141,137,142,137,143,137,144,137,145,137,146,137,147,137,148,137,149,137,150,137,151,137,152,137,153,137,154,137,155,137,156,137,157,137,158,137,159,137,160,137,161,137,71,100,39,92,101,144,145,122,35,140,218,89,172,84,0,130,111,131,129,137,0,128,48,105,78,86,54,128,55,114,206,145,182,81,95,78,117,152,150,99,26,78,246,83,243,102,75,129,28,89,178,109,0,78,249,88,59,83,214,99,241,148,157,79,10,79,99,136,144,152,55,89,87,144,251,121,234,78,240,128,145,117,130,108,156,91,232,89,93,95,5,105,129,134,26,80,242,93,89,78,227,119,229,78,122,130,145,98,19,102,145,144,121,92,191,78,121,95,198,129,56,144,132,128,171,117,166,78,212,136,15,97,197,107,198,95,73,78,202,118,162,110,227,139,174,139,10,140,209,139,2,95,252,127,204,127,206,126,53,131,107,131,224,86,183,107,243,151,52,150,251,89,31,84,246,148,235,109,197,91,110,153,57,92,21,95,144,150,162,137,163,137,164,137,165,137,166,137,167,137,168,137,169,137,170,137,171,137,172,137,173,137,174,137,175,137,176,137,177,137,178,137,179,137,180,137,181,137,182,137,183,137,184,137,185,137,186,137,187,137,188,137,189,137,190,137,191,137,192,137,195,137,205,137,211,137,212,137,213,137,215,137,216,137,217,137,219,137,221,137,223,137,224,137,225,137,226,137,228,137,231,137,232,137,233,137,234,137,236,137,237,137,238,137,240,137,241,137,242,137,244,137,245,137,246,137,247,137,248,137,249,137,250,137,251,137,252,137,253,137,254,137,255,137,1,138,2,138,3,138,4,138,5,138,6,138,8,138,9,138,10,138,11,138,12,138,13,138,14,138,15,138,16,138,17,138,18,138,19,138,20,138,21,138,22,138,23,138,24,138,25,138,26,138,27,138,28,138,29,138,112,83,241,130,49,106,116,90,112,158,148,94,40,127,185,131,36,132,37,132,103,131,71,135,206,143,98,141,200,118,113,95,150,152,108,120,32,102,223,84,229,98,99,79,195,129,200,117,184,94,205,150,10,142,249,134,143,84,243,108,140,109,56,108,127,96,199,82,40,117,125,94,24,79,160,96,231,95,36,92,49,117,174,144,192,148,185,114,185,108,56,110,73,145,9,103,203,83,243,83,81,79,201,145,241,139,200,83,124,94,194,143,228,109,142,78,194,118,134,105,94,134,26,97,6,130,89,79,222,79,62,144,124,156,9,97,29,110,20,110,133,150,136,78,49,90,232,150,14,78,127,92,185,121,135,91,237,139,189,127,137,115,223,87,139,130,193,144,1,84,71,144,187,85,234,92,161,95,8,97,50,107,241,114,178,128,137,138,30,138,31,138,32,138,33,138,34,138,35,138,36,138,37,138,38,138,39,138,40,138,41,138,42,138,43,138,44,138,45,138,46,138,47,138,48,138,49,138,50,138,51,138,52,138,53,138,54,138,55,138,56,138,57,138,58,138,59,138,60,138,61,138,63,138,64,138,65,138,66,138,67,138,68,138,69,138,70,138,71,138,73,138,74,138,75,138,76,138,77,138,78,138,79,138,80,138,81,138,82,138,83,138,84,138,85,138,86,138,87,138,88,138,89,138,90,138,91,138,92,138,93,138,94,138,95,138,96,138,97,138,98,138,99,138,100,138,101,138,102,138,103,138,104,138,105,138,106,138,107,138,108,138,109,138,110,138,111,138,112,138,113,138,114,138,115,138,116,138,117,138,118,138,119,138,120,138,122,138,123,138,124,138,125,138,126,138,127,138,128,138,116,109,211,91,213,136,132,152,107,140,109,154,51,158,10,110,164,81,67,81,163,87,129,136,159,83,244,99,149,143,237,86,88,84,6,87,63,115,144,110,24,127,220,143,209,130,63,97,40,96,98,150,240,102,166,126,138,141,195,141,165,148,179,92,164,124,8,103,166,96,5,150,24,128,145,78,231,144,0,83,104,150,65,81,208,143,116,133,93,145,85,102,245,151,85,91,29,83,56,120,66,103,61,104,201,84,126,112,176,91,125,143,141,81,40,87,177,84,18,101,130,102,94,141,67,141,15,129,108,132,109,144,223,124,255,81,251,133,163,103,233,101,161,111,164,134,129,142,106,86,32,144,130,118,118,112,229,113,35,141,233,98,25,82,253,108,60,141,14,96,158,88,142,97,254,102,96,141,78,98,179,85,35,110,45,103,103,143,129,138,130,138,131,138,132,138,133,138,134,138,135,138,136,138,139,138,140,138,141,138,142,138,143,138,144,138,145,138,146,138,148,138,149,138,150,138,151,138,152,138,153,138,154,138,155,138,156,138,157,138,158,138,159,138,160,138,161,138,162,138,163,138,164,138,165,138,166,138,167,138,168,138,169,138,170,138,171,138,172,138,173,138,174,138,175,138,176,138,177,138,178,138,179,138,180,138,181,138,182,138,183,138,184,138,185,138,186,138,187,138,188,138,189,138,190,138,191,138,192,138,193,138,194,138,195,138,196,138,197,138,198,138,199,138,200,138,201,138,202,138,203,138,204,138,205,138,206,138,207,138,208,138,209,138,210,138,211,138,212,138,213,138,214,138,215,138,216,138,217,138,218,138,219,138,220,138,221,138,222,138,223,138,224,138,225,138,226,138,227,138,225,148,248,149,40,119,5,104,168,105,139,84,77,78,184,112,200,139,88,100,139,101,133,91,132,122,58,80,232,91,187,119,225,107,121,138,152,124,190,108,207,118,169,101,151,143,45,93,85,92,56,134,8,104,96,83,24,98,217,122,91,110,253,126,31,106,224,122,112,95,51,111,32,95,140,99,168,109,86,103,8,78,16,94,38,141,215,78,192,128,52,118,156,150,219,98,45,102,126,98,188,108,117,141,103,113,105,127,70,81,135,128,236,83,110,144,152,98,242,84,240,134,153,143,5,128,23,149,23,133,217,143,89,109,205,115,159,101,31,119,4,117,39,120,251,129,30,141,136,148,166,79,149,103,185,117,202,139,7,151,47,99,71,149,53,150,184,132,35,99,65,119,129,95,240,114,137,78,20,96,116,101,239,98,99,107,63,101,228,138,229,138,230,138,231,138,232,138,233,138,234,138,235,138,236,138,237,138,238,138,239,138,240,138,241,138,242,138,243,138,244,138,245,138,246,138,247,138,248,138,249,138,250,138,251,138,252,138,253,138,254,138,255,138,0,139,1,139,2,139,3,139,4,139,5,139,6,139,8,139,9,139,10,139,11,139,12,139,13,139,14,139,15,139,16,139,17,139,18,139,19,139,20,139,21,139,22,139,23,139,24,139,25,139,26,139,27,139,28,139,29,139,30,139,31,139,32,139,33,139,34,139,35,139,36,139,37,139,39,139,40,139,41,139,42,139,43,139,44,139,45,139,46,139,47,139,48,139,49,139,50,139,51,139,52,139,53,139,54,139,55,139,56,139,57,139,58,139,59,139,60,139,61,139,62,139,63,139,64,139,65,139,66,139,67,139,68,139,69,139,39,94,199,117,209,144,193,139,157,130,157,103,47,101,49,84,24,135,229,119,162,128,2,129,65,108,75,78,199,126,76,128,244,118,13,105,150,107,103,98,60,80,132,79,64,87,7,99,98,107,190,141,234,83,232,101,184,126,215,95,26,99,183,99,243,129,244,129,110,127,28,94,217,92,54,82,122,102,233,121,26,122,40,141,153,112,212,117,222,110,187,108,146,122,45,78,197,118,224,95,159,148,119,136,200,126,205,121,191,128,205,145,242,78,23,79,31,130,104,84,222,93,50,109,204,139,165,124,116,143,152,128,26,94,146,84,177,118,153,91,60,102,164,154,224,115,42,104,219,134,49,103,42,115,248,139,219,139,16,144,249,122,219,112,110,113,196,98,169,119,49,86,59,78,87,132,241,103,169,82,192,134,46,141,248,148,81,123,70,139,71,139,72,139,73,139,74,139,75,139,76,139,77,139,78,139,79,139,80,139,81,139,82,139,83,139,84,139,85,139,86,139,87,139,88,139,89,139,90,139,91,139,92,139,93,139,94,139,95,139,96,139,97,139,98,139,99,139,100,139,101,139,103,139,104,139,105,139,106,139,107,139,109,139,110,139,111,139,112,139,113,139,114,139,115,139,116,139,117,139,118,139,119,139,120,139,121,139,122,139,123,139,124,139,125,139,126,139,127,139,128,139,129,139,130,139,131,139,132,139,133,139,134,139,135,139,136,139,137,139,138,139,139,139,140,139,141,139,142,139,143,139,144,139,145,139,146,139,147,139,148,139,149,139,150,139,151,139,152,139,153,139,154,139,155,139,156,139,157,139,158,139,159,139,172,139,177,139,187,139,199,139,208,139,234,139,9,140,30,140,79,79,232,108,93,121,123,154,147,98,42,114,253,98,19,78,22,120,108,143,176,100,90,141,198,123,105,104,132,94,197,136,134,89,158,100,238,88,182,114,14,105,37,149,253,143,88,141,96,87,0,127,6,140,198,81,73,99,217,98,83,83,76,104,34,116,1,131,76,145,68,85,64,119,124,112,74,109,121,81,168,84,68,141,255,89,203,110,196,109,92,91,43,125,212,78,125,124,211,110,80,91,234,129,13,110,87,91,3,155,213,104,42,142,151,91,252,126,59,96,181,126,185,144,112,141,79,89,205,99,223,121,179,141,82,83,207,101,86,121,197,139,59,150,196,126,187,148,130,126,52,86,137,145,0,103,106,127,10,92,117,144,40,102,230,93,80,79,222,103,90,80,92,79,80,87,167,94,16,232,17,232,18,232,19,232,20,232,56,140,57,140,58,140,59,140,60,140,61,140,62,140,63,140,64,140,66,140,67,140,68,140,69,140,72,140,74,140,75,140,77,140,78,140,79,140,80,140,81,140,82,140,83,140,84,140,86,140,87,140,88,140,89,140,91,140,92,140,93,140,94,140,95,140,96,140,99,140,100,140,101,140,102,140,103,140,104,140,105,140,108,140,109,140,110,140,111,140,112,140,113,140,114,140,116,140,117,140,118,140,119,140,123,140,124,140,125,140,126,140,127,140,128,140,129,140,131,140,132,140,134,140,135,140,136,140,139,140,141,140,142,140,143,140,144,140,145,140,146,140,147,140,149,140,150,140,151,140,153,140,154,140,155,140,156,140,157,140,158,140,159,140,160,140,161,140,162,140,163,140,164,140,165,140,166,140,167,140,168,140,169,140,170,140,171,140,172,140,173,140,141,78,12,78,64,81,16,78,255,94,69,83,21,78,152,78,30,78,50,155,108,91,105,86,40,78,186,121,63,78,21,83,71,78,45,89,59,114,110,83,16,108,223,86,228,128,151,153,211,107,126,119,23,159,54,78,159,78,16,159,92,78,105,78,147,78,136,130,91,91,108,85,15,86,196,78,141,83,157,83,163,83,165,83,174,83,101,151,93,141,26,83,245,83,38,83,46,83,62,83,92,141,102,83,99,83,2,82,8,82,14,82,45,82,51,82,63,82,64,82,76,82,94,82,97,82,92,82,175,132,125,82,130,82,129,82,144,82,147,82,130,81,84,127,187,78,195,78,201,78,194,78,232,78,225,78,235,78,222,78,27,79,243,78,34,79,100,79,245,78,37,79,39,79,9,79,43,79,94,79,103,79,56,101,90,79,93,79,174,140,175,140,176,140,177,140,178,140,179,140,180,140,181,140,182,140,183,140,184,140,185,140,186,140,187,140,188,140,189,140,190,140,191,140,192,140,193,140,194,140,195,140,196,140,197,140,198,140,199,140,200,140,201,140,202,140,203,140,204,140,205,140,206,140,207,140,208,140,209,140,210,140,211,140,212,140,213,140,214,140,215,140,216,140,217,140,218,140,219,140,220,140,221,140,222,140,223,140,224,140,225,140,226,140,227,140,228,140,229,140,230,140,231,140,232,140,233,140,234,140,235,140,236,140,237,140,238,140,239,140,240,140,241,140,242,140,243,140,244,140,245,140,246,140,247,140,248,140,249,140,250,140,251,140,252,140,253,140,254,140,255,140,0,141,1,141,2,141,3,141,4,141,5,141,6,141,7,141,8,141,9,141,10,141,11,141,12,141,13,141,95,79,87,79,50,79,61,79,118,79,116,79,145,79,137,79,131,79,143,79,126,79,123,79,170,79,124,79,172,79,148,79,230,79,232,79,234,79,197,79,218,79,227,79,220,79,209,79,223,79,248,79,41,80,76,80,243,79,44,80,15,80,46,80,45,80,254,79,28,80,12,80,37,80,40,80,126,80,67,80,85,80,72,80,78,80,108,80,123,80,165,80,167,80,169,80,186,80,214,80,6,81,237,80,236,80,230,80,238,80,7,81,11,81,221,78,61,108,88,79,101,79,206,79,160,159,70,108,116,124,110,81,253,93,201,158,152,153,129,81,20,89,249,82,13,83,7,138,16,83,235,81,25,89,85,81,160,78,86,81,179,78,110,136,164,136,181,78,20,129,210,136,128,121,52,91,3,136,184,127,171,81,177,81,189,81,188,81,14,141,15,141,16,141,17,141,18,141,19,141,20,141,21,141,22,141,23,141,24,141,25,141,26,141,27,141,28,141,32,141,81,141,82,141,87,141,95,141,101,141,104,141,105,141,106,141,108,141,110,141,111,141,113,141,114,141,120,141,121,141,122,141,123,141,124,141,125,141,126,141,127,141,128,141,130,141,131,141,134,141,135,141,136,141,137,141,140,141,141,141,142,141,143,141,144,141,146,141,147,141,149,141,150,141,151,141,152,141,153,141,154,141,155,141,156,141,157,141,158,141,160,141,161,141,162,141,164,141,165,141,166,141,167,141,168,141,169,141,170,141,171,141,172,141,173,141,174,141,175,141,176,141,178,141,182,141,183,141,185,141,187,141,189,141,192,141,193,141,194,141,197,141,199,141,200,141,201,141,202,141,205,141,208,141,210,141,211,141,212,141,199,81,150,81,162,81,165,81,160,139,166,139,167,139,170,139,180,139,181,139,183,139,194,139,195,139,203,139,207,139,206,139,210,139,211,139,212,139,214,139,216,139,217,139,220,139,223,139,224,139,228,139,232,139,233,139,238,139,240,139,243,139,246,139,249,139,252,139,255,139,0,140,2,140,4,140,7,140,12,140,15,140,17,140,18,140,20,140,21,140,22,140,25,140,27,140,24,140,29,140,31,140,32,140,33,140,37,140,39,140,42,140,43,140,46,140,47,140,50,140,51,140,53,140,54,140,105,83,122,83,29,150,34,150,33,150,49,150,42,150,61,150,60,150,66,150,73,150,84,150,95,150,103,150,108,150,114,150,116,150,136,150,141,150,151,150,176,150,151,144,155,144,157,144,153,144,172,144,161,144,180,144,179,144,182,144,186,144,213,141,216,141,217,141,220,141,224,141,225,141,226,141,229,141,230,141,231,141,233,141,237,141,238,141,240,141,241,141,242,141,244,141,246,141,252,141,254,141,255,141,0,142,1,142,2,142,3,142,4,142,6,142,7,142,8,142,11,142,13,142,14,142,16,142,17,142,18,142,19,142,21,142,22,142,23,142,24,142,25,142,26,142,27,142,28,142,32,142,33,142,36,142,37,142,38,142,39,142,40,142,43,142,45,142,48,142,50,142,51,142,52,142,54,142,55,142,56,142,59,142,60,142,62,142,63,142,67,142,69,142,70,142,76,142,77,142,78,142,79,142,80,142,83,142,84,142,85,142,86,142,87,142,88,142,90,142,91,142,92,142,93,142,94,142,95,142,96,142,97,142,98,142,99,142,100,142,101,142,103,142,104,142,106,142,107,142,110,142,113,142,184,144,176,144,207,144,197,144,190,144,208,144,196,144,199,144,211,144,230,144,226,144,220,144,215,144,219,144,235,144,239,144,254,144,4,145,34,145,30,145,35,145,49,145,47,145,57,145,67,145,70,145,13,82,66,89,162,82,172,82,173,82,190,82,255,84,208,82,214,82,240,82,223,83,238,113,205,119,244,94,245,81,252,81,47,155,182,83,1,95,90,117,239,93,76,87,169,87,161,87,126,88,188,88,197,88,209,88,41,87,44,87,42,87,51,87,57,87,46,87,47,87,92,87,59,87,66,87,105,87,133,87,107,87,134,87,124,87,123,87,104,87,109,87,118,87,115,87,173,87,164,87,140,87,178,87,207,87,167,87,180,87,147,87,160,87,213,87,216,87,218,87,217,87,210,87,184,87,244,87,239,87,248,87,228,87,221,87,115,142,117,142,119,142,120,142,121,142,122,142,123,142,125,142,126,142,128,142,130,142,131,142,132,142,134,142,136,142,137,142,138,142,139,142,140,142,141,142,142,142,145,142,146,142,147,142,149,142,150,142,151,142,152,142,153,142,154,142,155,142,157,142,159,142,160,142,161,142,162,142,163,142,164,142,165,142,166,142,167,142,168,142,169,142,170,142,173,142,174,142,176,142,177,142,179,142,180,142,181,142,182,142,183,142,184,142,185,142,187,142,188,142,189,142,190,142,191,142,192,142,193,142,194,142,195,142,196,142,197,142,198,142,199,142,200,142,201,142,202,142,203,142,204,142,205,142,207,142,208,142,209,142,210,142,211,142,212,142,213,142,214,142,215,142,216,142,217,142,218,142,219,142,220,142,221,142,222,142,223,142,224,142,225,142,226,142,227,142,228,142,11,88,13,88,253,87,237,87,0,88,30,88,25,88,68,88,32,88,101,88,108,88,129,88,137,88,154,88,128,88,168,153,25,159,255,97,121,130,125,130,127,130,143,130,138,130,168,130,132,130,142,130,145,130,151,130,153,130,171,130,184,130,190,130,176,130,200,130,202,130,227,130,152,130,183,130,174,130,203,130,204,130,193,130,169,130,180,130,161,130,170,130,159,130,196,130,206,130,164,130,225,130,9,131,247,130,228,130,15,131,7,131,220,130,244,130,210,130,216,130,12,131,251,130,211,130,17,131,26,131,6,131,20,131,21,131,224,130,213,130,28,131,81,131,91,131,92,131,8,131,146,131,60,131,52,131,49,131,155,131,94,131,47,131,79,131,71,131,67,131,95,131,64,131,23,131,96,131,45,131,58,131,51,131,102,131,101,131,229,142,230,142,231,142,232,142,233,142,234,142,235,142,236,142,237,142,238,142,239,142,240,142,241,142,242,142,243,142,244,142,245,142,246,142,247,142,248,142,249,142,250,142,251,142,252,142,253,142,254,142,255,142,0,143,1,143,2,143,3,143,4,143,5,143,6,143,7,143,8,143,9,143,10,143,11,143,12,143,13,143,14,143,15,143,16,143,17,143,18,143,19,143,20,143,21,143,22,143,23,143,24,143,25,143,26,143,27,143,28,143,29,143,30,143,31,143,32,143,33,143,34,143,35,143,36,143,37,143,38,143,39,143,40,143,41,143,42,143,43,143,44,143,45,143,46,143,47,143,48,143,49,143,50,143,51,143,52,143,53,143,54,143,55,143,56,143,57,143,58,143,59,143,60,143,61,143,62,143,63,143,64,143,65,143,66,143,67,143,68,143,104,131,27,131,105,131,108,131,106,131,109,131,110,131,176,131,120,131,179,131,180,131,160,131,170,131,147,131,156,131,133,131,124,131,182,131,169,131,125,131,184,131,123,131,152,131,158,131,168,131,186,131,188,131,193,131,1,132,229,131,216,131,7,88,24,132,11,132,221,131,253,131,214,131,28,132,56,132,17,132,6,132,212,131,223,131,15,132,3,132,248,131,249,131,234,131,197,131,192,131,38,132,240,131,225,131,92,132,81,132,90,132,89,132,115,132,135,132,136,132,122,132,137,132,120,132,60,132,70,132,105,132,118,132,140,132,142,132,49,132,109,132,193,132,205,132,208,132,230,132,189,132,211,132,202,132,191,132,186,132,224,132,161,132,185,132,180,132,151,132,229,132,227,132,12,133,13,117,56,133,240,132,57,133,31,133,58,133,69,143,70,143,71,143,72,143,73,143,74,143,75,143,76,143,77,143,78,143,79,143,80,143,81,143,82,143,83,143,84,143,85,143,86,143,87,143,88,143,89,143,90,143,91,143,92,143,93,143,94,143,95,143,96,143,97,143,98,143,99,143,100,143,101,143,106,143,128,143,140,143,146,143,157,143,160,143,161,143,162,143,164,143,165,143,166,143,167,143,170,143,172,143,173,143,174,143,175,143,178,143,179,143,180,143,181,143,183,143,184,143,186,143,187,143,188,143,191,143,192,143,195,143,198,143,201,143,202,143,203,143,204,143,205,143,207,143,210,143,214,143,215,143,218,143,224,143,225,143,227,143,231,143,236,143,239,143,241,143,242,143,244,143,245,143,246,143,250,143,251,143,252,143,254,143,255,143,7,144,8,144,12,144,14,144,19,144,21,144,24,144,86,133,59,133,255,132,252,132,89,133,72,133,104,133,100,133,94,133,122,133,162,119,67,133,114,133,123,133,164,133,168,133,135,133,143,133,121,133,174,133,156,133,133,133,185,133,183,133,176,133,211,133,193,133,220,133,255,133,39,134,5,134,41,134,22,134,60,134,254,94,8,95,60,89,65,89,55,128,85,89,90,89,88,89,15,83,34,92,37,92,44,92,52,92,76,98,106,98,159,98,187,98,202,98,218,98,215,98,238,98,34,99,246,98,57,99,75,99,67,99,173,99,246,99,113,99,122,99,142,99,180,99,109,99,172,99,138,99,105,99,174,99,188,99,242,99,248,99,224,99,255,99,196,99,222,99,206,99,82,100,198,99,190,99,69,100,65,100,11,100,27,100,32,100,12,100,38,100,33,100,94,100,132,100,109,100,150,100,25,144,28,144,35,144,36,144,37,144,39,144,40,144,41,144,42,144,43,144,44,144,48,144,49,144,50,144,51,144,52,144,55,144,57,144,58,144,61,144,63,144,64,144,67,144,69,144,70,144,72,144,73,144,74,144,75,144,76,144,78,144,84,144,85,144,86,144,89,144,90,144,92,144,93,144,94,144,95,144,96,144,97,144,100,144,102,144,103,144,105,144,106,144,107,144,108,144,111,144,112,144,113,144,114,144,115,144,118,144,119,144,120,144,121,144,122,144,123,144,124,144,126,144,129,144,132,144,133,144,134,144,135,144,137,144,138,144,140,144,141,144,142,144,143,144,144,144,146,144,148,144,150,144,152,144,154,144,156,144,158,144,159,144,160,144,164,144,165,144,167,144,168,144,169,144,171,144,173,144,178,144,183,144,188,144,189,144,191,144,192,144,122,100,183,100,184,100,153,100,186,100,192,100,208,100,215,100,228,100,226,100,9,101,37,101,46,101,11,95,210,95,25,117,17,95,95,83,241,83,253,83,233,83,232,83,251,83,18,84,22,84,6,84,75,84,82,84,83,84,84,84,86,84,67,84,33,84,87,84,89,84,35,84,50,84,130,84,148,84,119,84,113,84,100,84,154,84,155,84,132,84,118,84,102,84,157,84,208,84,173,84,194,84,180,84,210,84,167,84,166,84,211,84,212,84,114,84,163,84,213,84,187,84,191,84,204,84,217,84,218,84,220,84,169,84,170,84,164,84,221,84,207,84,222,84,27,85,231,84,32,85,253,84,20,85,243,84,34,85,35,85,15,85,17,85,39,85,42,85,103,85,143,85,181,85,73,85,109,85,65,85,85,85,63,85,80,85,60,85,194,144,195,144,198,144,200,144,201,144,203,144,204,144,205,144,210,144,212,144,213,144,214,144,216,144,217,144,218,144,222,144,223,144,224,144,227,144,228,144,229,144,233,144,234,144,236,144,238,144,240,144,241,144,242,144,243,144,245,144,246,144,247,144,249,144,250,144,251,144,252,144,255,144,0,145,1,145,3,145,5,145,6,145,7,145,8,145,9,145,10,145,11,145,12,145,13,145,14,145,15,145,16,145,17,145,18,145,19,145,20,145,21,145,22,145,23,145,24,145,26,145,27,145,28,145,29,145,31,145,32,145,33,145,36,145,37,145,38,145,39,145,40,145,41,145,42,145,43,145,44,145,45,145,46,145,48,145,50,145,51,145,52,145,53,145,54,145,55,145,56,145,58,145,59,145,60,145,61,145,62,145,63,145,64,145,65,145,66,145,68,145,55,85,86,85,117,85,118,85,119,85,51,85,48,85,92,85,139,85,210,85,131,85,177,85,185,85,136,85,129,85,159,85,126,85,214,85,145,85,123,85,223,85,189,85,190,85,148,85,153,85,234,85,247,85,201,85,31,86,209,85,235,85,236,85,212,85,230,85,221,85,196,85,239,85,229,85,242,85,243,85,204,85,205,85,232,85,245,85,228,85,148,143,30,86,8,86,12,86,1,86,36,86,35,86,254,85,0,86,39,86,45,86,88,86,57,86,87,86,44,86,77,86,98,86,89,86,92,86,76,86,84,86,134,86,100,86,113,86,107,86,123,86,124,86,133,86,147,86,175,86,212,86,215,86,221,86,225,86,245,86,235,86,249,86,255,86,4,87,10,87,9,87,28,87,15,94,25,94,20,94,17,94,49,94,59,94,60,94,69,145,71,145,72,145,81,145,83,145,84,145,85,145,86,145,88,145,89,145,91,145,92,145,95,145,96,145,102,145,103,145,104,145,107,145,109,145,115,145,122,145,123,145,124,145,128,145,129,145,130,145,131,145,132,145,134,145,136,145,138,145,142,145,143,145,147,145,148,145,149,145,150,145,151,145,152,145,153,145,156,145,157,145,158,145,159,145,160,145,161,145,164,145,165,145,166,145,167,145,168,145,169,145,171,145,172,145,176,145,177,145,178,145,179,145,182,145,183,145,184,145,185,145,187,145,188,145,189,145,190,145,191,145,192,145,193,145,194,145,195,145,196,145,197,145,198,145,200,145,203,145,208,145,210,145,211,145,212,145,213,145,214,145,215,145,216,145,217,145,218,145,219,145,221,145,222,145,223,145,224,145,225,145,226,145,227,145,228,145,229,145,55,94,68,94,84,94,91,94,94,94,97,94,140,92,122,92,141,92,144,92,150,92,136,92,152,92,153,92,145,92,154,92,156,92,181,92,162,92,189,92,172,92,171,92,177,92,163,92,193,92,183,92,196,92,210,92,228,92,203,92,229,92,2,93,3,93,39,93,38,93,46,93,36,93,30,93,6,93,27,93,88,93,62,93,52,93,61,93,108,93,91,93,111,93,93,93,107,93,75,93,74,93,105,93,116,93,130,93,153,93,157,93,115,140,183,93,197,93,115,95,119,95,130,95,135,95,137,95,140,95,149,95,153,95,156,95,168,95,173,95,181,95,188,95,98,136,97,95,173,114,176,114,180,114,183,114,184,114,195,114,193,114,206,114,205,114,210,114,232,114,239,114,233,114,242,114,244,114,247,114,1,115,243,114,3,115,250,114,230,145,231,145,232,145,233,145,234,145,235,145,236,145,237,145,238,145,239,145,240,145,241,145,242,145,243,145,244,145,245,145,246,145,247,145,248,145,249,145,250,145,251,145,252,145,253,145,254,145,255,145,0,146,1,146,2,146,3,146,4,146,5,146,6,146,7,146,8,146,9,146,10,146,11,146,12,146,13,146,14,146,15,146,16,146,17,146,18,146,19,146,20,146,21,146,22,146,23,146,24,146,25,146,26,146,27,146,28,146,29,146,30,146,31,146,32,146,33,146,34,146,35,146,36,146,37,146,38,146,39,146,40,146,41,146,42,146,43,146,44,146,45,146,46,146,47,146,48,146,49,146,50,146,51,146,52,146,53,146,54,146,55,146,56,146,57,146,58,146,59,146,60,146,61,146,62,146,63,146,64,146,65,146,66,146,67,146,68,146,69,146,251,114,23,115,19,115,33,115,10,115,30,115,29,115,21,115,34,115,57,115,37,115,44,115,56,115,49,115,80,115,77,115,87,115,96,115,108,115,111,115,126,115,27,130,37,89,231,152,36,89,2,89,99,153,103,153,104,153,105,153,106,153,107,153,108,153,116,153,119,153,125,153,128,153,132,153,135,153,138,153,141,153,144,153,145,153,147,153,148,153,149,153,128,94,145,94,139,94,150,94,165,94,160,94,185,94,181,94,190,94,179,94,83,141,210,94,209,94,219,94,232,94,234,94,186,129,196,95,201,95,214,95,207,95,3,96,238,95,4,96,225,95,228,95,254,95,5,96,6,96,234,95,237,95,248,95,25,96,53,96,38,96,27,96,15,96,13,96,41,96,43,96,10,96,63,96,33,96,120,96,121,96,123,96,122,96,66,96,70,146,71,146,72,146,73,146,74,146,75,146,76,146,77,146,78,146,79,146,80,146,81,146,82,146,83,146,84,146,85,146,86,146,87,146,88,146,89,146,90,146,91,146,92,146,93,146,94,146,95,146,96,146,97,146,98,146,99,146,100,146,101,146,102,146,103,146,104,146,105,146,106,146,107,146,108,146,109,146,110,146,111,146,112,146,113,146,114,146,115,146,117,146,118,146,119,146,120,146,121,146,122,146,123,146,124,146,125,146,126,146,127,146,128,146,129,146,130,146,131,146,132,146,133,146,134,146,135,146,136,146,137,146,138,146,139,146,140,146,141,146,143,146,144,146,145,146,146,146,147,146,148,146,149,146,150,146,151,146,152,146,153,146,154,146,155,146,156,146,157,146,158,146,159,146,160,146,161,146,162,146,163,146,164,146,165,146,166,146,167,146,106,96,125,96,150,96,154,96,173,96,157,96,131,96,146,96,140,96,155,96,236,96,187,96,177,96,221,96,216,96,198,96,218,96,180,96,32,97,38,97,21,97,35,97,244,96,0,97,14,97,43,97,74,97,117,97,172,97,148,97,167,97,183,97,212,97,245,97,221,95,179,150,233,149,235,149,241,149,243,149,245,149,246,149,252,149,254,149,3,150,4,150,6,150,8,150,10,150,11,150,12,150,13,150,15,150,18,150,21,150,22,150,23,150,25,150,26,150,44,78,63,114,21,98,53,108,84,108,92,108,74,108,163,108,133,108,144,108,148,108,140,108,104,108,105,108,116,108,118,108,134,108,169,108,208,108,212,108,173,108,247,108,248,108,241,108,215,108,178,108,224,108,214,108,250,108,235,108,238,108,177,108,211,108,239,108,254,108,168,146,169,146,170,146,171,146,172,146,173,146,175,146,176,146,177,146,178,146,179,146,180,146,181,146,182,146,183,146,184,146,185,146,186,146,187,146,188,146,189,146,190,146,191,146,192,146,193,146,194,146,195,146,196,146,197,146,198,146,199,146,201,146,202,146,203,146,204,146,205,146,206,146,207,146,208,146,209,146,210,146,211,146,212,146,213,146,214,146,215,146,216,146,217,146,218,146,219,146,220,146,221,146,222,146,223,146,224,146,225,146,226,146,227,146,228,146,229,146,230,146,231,146,232,146,233,146,234,146,235,146,236,146,237,146,238,146,239,146,240,146,241,146,242,146,243,146,244,146,245,146,246,146,247,146,248,146,249,146,250,146,251,146,252,146,253,146,254,146,255,146,0,147,1,147,2,147,3,147,4,147,5,147,6,147,7,147,8,147,9,147,57,109,39,109,12,109,67,109,72,109,7,109,4,109,25,109,14,109,43,109,77,109,46,109,53,109,26,109,79,109,82,109,84,109,51,109,145,109,111,109,158,109,160,109,94,109,147,109,148,109,92,109,96,109,124,109,99,109,26,110,199,109,197,109,222,109,14,110,191,109,224,109,17,110,230,109,221,109,217,109,22,110,171,109,12,110,174,109,43,110,110,110,78,110,107,110,178,110,95,110,134,110,83,110,84,110,50,110,37,110,68,110,223,110,177,110,152,110,224,110,45,111,226,110,165,110,167,110,189,110,187,110,183,110,215,110,180,110,207,110,143,110,194,110,159,110,98,111,70,111,71,111,36,111,21,111,249,110,47,111,54,111,75,111,116,111,42,111,9,111,41,111,137,111,141,111,140,111,120,111,114,111,124,111,122,111,209,111,10,147,11,147,12,147,13,147,14,147,15,147,16,147,17,147,18,147,19,147,20,147,21,147,22,147,23,147,24,147,25,147,26,147,27,147,28,147,29,147,30,147,31,147,32,147,33,147,34,147,35,147,36,147,37,147,38,147,39,147,40,147,41,147,42,147,43,147,44,147,45,147,46,147,47,147,48,147,49,147,50,147,51,147,52,147,53,147,54,147,55,147,56,147,57,147,58,147,59,147,60,147,61,147,63,147,64,147,65,147,66,147,67,147,68,147,69,147,70,147,71,147,72,147,73,147,74,147,75,147,76,147,77,147,78,147,79,147,80,147,81,147,82,147,83,147,84,147,85,147,86,147,87,147,88,147,89,147,90,147,91,147,92,147,93,147,94,147,95,147,96,147,97,147,98,147,99,147,100,147,101,147,102,147,103,147,104,147,105,147,107,147,201,111,167,111,185,111,182,111,194,111,225,111,238,111,222,111,224,111,239,111,26,112,35,112,27,112,57,112,53,112,79,112,94,112,128,91],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+251068),
allocate([132,91,149,91,147,91,165,91,184,91,47,117,158,154,52,100,228,91,238,91,48,137,240,91,71,142,7,139,182,143,211,143,213,143,229,143,238,143,228,143,233,143,230,143,243,143,232,143,5,144,4,144,11,144,38,144,17,144,13,144,22,144,33,144,53,144,54,144,45,144,47,144,68,144,81,144,82,144,80,144,104,144,88,144,98,144,91,144,185,102,116,144,125,144,130,144,136,144,131,144,139,144,80,95,87,95,86,95,88,95,59,92,171,84,80,92,89,92,113,91,99,92,102,92,188,127,42,95,41,95,45,95,116,130,60,95,59,155,110,92,129,89,131,89,141,89,169,89,170,89,163,89,108,147,109,147,110,147,111,147,112,147,113,147,114,147,115,147,116,147,117,147,118,147,119,147,120,147,121,147,122,147,123,147,124,147,125,147,126,147,127,147,128,147,129,147,130,147,131,147,132,147,133,147,134,147,135,147,136,147,137,147,138,147,139,147,140,147,141,147,142,147,144,147,145,147,146,147,147,147,148,147,149,147,150,147,151,147,152,147,153,147,154,147,155,147,156,147,157,147,158,147,159,147,160,147,161,147,162,147,163,147,164,147,165,147,166,147,167,147,168,147,169,147,170,147,171,147,172,147,173,147,174,147,175,147,176,147,177,147,178,147,179,147,180,147,181,147,182,147,183,147,184,147,185,147,186,147,187,147,188,147,189,147,190,147,191,147,192,147,193,147,194,147,195,147,196,147,197,147,198,147,199,147,200,147,201,147,203,147,204,147,205,147,151,89,202,89,171,89,158,89,164,89,210,89,178,89,175,89,215,89,190,89,5,90,6,90,221,89,8,90,227,89,216,89,249,89,12,90,9,90,50,90,52,90,17,90,35,90,19,90,64,90,103,90,74,90,85,90,60,90,98,90,117,90,236,128,170,90,155,90,119,90,122,90,190,90,235,90,178,90,210,90,212,90,184,90,224,90,227,90,241,90,214,90,230,90,216,90,220,90,9,91,23,91,22,91,50,91,55,91,64,91,21,92,28,92,90,91,101,91,115,91,81,91,83,91,98,91,117,154,119,154,120,154,122,154,127,154,125,154,128,154,129,154,133,154,136,154,138,154,144,154,146,154,147,154,150,154,152,154,155,154,156,154,157,154,159,154,160,154,162,154,163,154,165,154,167,154,159,126,161,126,163,126,165,126,168,126,169,126,206,147,207,147,208,147,209,147,210,147,211,147,212,147,213,147,215,147,216,147,217,147,218,147,219,147,220,147,221,147,222,147,223,147,224,147,225,147,226,147,227,147,228,147,229,147,230,147,231,147,232,147,233,147,234,147,235,147,236,147,237,147,238,147,239,147,240,147,241,147,242,147,243,147,244,147,245,147,246,147,247,147,248,147,249,147,250,147,251,147,252,147,253,147,254,147,255,147,0,148,1,148,2,148,3,148,4,148,5,148,6,148,7,148,8,148,9,148,10,148,11,148,12,148,13,148,14,148,15,148,16,148,17,148,18,148,19,148,20,148,21,148,22,148,23,148,24,148,25,148,26,148,27,148,28,148,29,148,30,148,31,148,32,148,33,148,34,148,35,148,36,148,37,148,38,148,39,148,40,148,41,148,42,148,43,148,44,148,45,148,46,148,173,126,176,126,190,126,192,126,193,126,194,126,201,126,203,126,204,126,208,126,212,126,215,126,219,126,224,126,225,126,232,126,235,126,238,126,239,126,241,126,242,126,13,127,246,126,250,126,251,126,254,126,1,127,2,127,3,127,7,127,8,127,11,127,12,127,15,127,17,127,18,127,23,127,25,127,28,127,27,127,31,127,33,127,34,127,35,127,36,127,37,127,38,127,39,127,42,127,43,127,44,127,45,127,47,127,48,127,49,127,50,127,51,127,53,127,122,94,127,117,219,93,62,117,149,144,142,115,145,115,174,115,162,115,159,115,207,115,194,115,209,115,183,115,179,115,192,115,201,115,200,115,229,115,217,115,124,152,10,116,233,115,231,115,222,115,186,115,242,115,15,116,42,116,91,116,38,116,37,116,40,116,48,116,46,116,44,116,47,148,48,148,49,148,50,148,51,148,52,148,53,148,54,148,55,148,56,148,57,148,58,148,59,148,60,148,61,148,63,148,64,148,65,148,66,148,67,148,68,148,69,148,70,148,71,148,72,148,73,148,74,148,75,148,76,148,77,148,78,148,79,148,80,148,81,148,82,148,83,148,84,148,85,148,86,148,87,148,88,148,89,148,90,148,91,148,92,148,93,148,94,148,95,148,96,148,97,148,98,148,99,148,100,148,101,148,102,148,103,148,104,148,105,148,106,148,108,148,109,148,110,148,111,148,112,148,113,148,114,148,115,148,116,148,117,148,118,148,119,148,120,148,121,148,122,148,123,148,124,148,125,148,126,148,127,148,128,148,129,148,130,148,131,148,132,148,145,148,150,148,152,148,199,148,207,148,211,148,212,148,218,148,230,148,251,148,28,149,32,149,27,116,26,116,65,116,92,116,87,116,85,116,89,116,119,116,109,116,126,116,156,116,142,116,128,116,129,116,135,116,139,116,158,116,168,116,169,116,144,116,167,116,210,116,186,116,234,151,235,151,236,151,76,103,83,103,94,103,72,103,105,103,165,103,135,103,106,103,115,103,152,103,167,103,117,103,168,103,158,103,173,103,139,103,119,103,124,103,240,103,9,104,216,103,10,104,233,103,176,103,12,104,217,103,181,103,218,103,179,103,221,103,0,104,195,103,184,103,226,103,14,104,193,103,253,103,50,104,51,104,96,104,97,104,78,104,98,104,68,104,100,104,131,104,29,104,85,104,102,104,65,104,103,104,64,104,62,104,74,104,73,104,41,104,181,104,143,104,116,104,119,104,147,104,107,104,194,104,110,105,252,104,31,105,32,105,249,104,39,149,51,149,61,149,67,149,72,149,75,149,85,149,90,149,96,149,110,149,116,149,117,149,119,149,120,149,121,149,122,149,123,149,124,149,125,149,126,149,128,149,129,149,130,149,131,149,132,149,133,149,134,149,135,149,136,149,137,149,138,149,139,149,140,149,141,149,142,149,143,149,144,149,145,149,146,149,147,149,148,149,149,149,150,149,151,149,152,149,153,149,154,149,155,149,156,149,157,149,158,149,159,149,160,149,161,149,162,149,163,149,164,149,165,149,166,149,167,149,168,149,169,149,170,149,171,149,172,149,173,149,174,149,175,149,176,149,177,149,178,149,179,149,180,149,181,149,182,149,183,149,184,149,185,149,186,149,187,149,188,149,189,149,190,149,191,149,192,149,193,149,194,149,195,149,196,149,197,149,198,149,199,149,200,149,201,149,202,149,203,149,36,105,240,104,11,105,1,105,87,105,227,104,16,105,113,105,57,105,96,105,66,105,93,105,132,105,107,105,128,105,152,105,120,105,52,105,204,105,135,105,136,105,206,105,137,105,102,105,99,105,121,105,155,105,167,105,187,105,171,105,173,105,212,105,177,105,193,105,202,105,223,105,149,105,224,105,141,105,255,105,47,106,237,105,23,106,24,106,101,106,242,105,68,106,62,106,160,106,80,106,91,106,53,106,142,106,121,106,61,106,40,106,88,106,124,106,145,106,144,106,169,106,151,106,171,106,55,115,82,115,129,107,130,107,135,107,132,107,146,107,147,107,141,107,154,107,155,107,161,107,170,107,107,143,109,143,113,143,114,143,115,143,117,143,118,143,120,143,119,143,121,143,122,143,124,143,126,143,129,143,130,143,132,143,135,143,139,143,204,149,205,149,206,149,207,149,208,149,209,149,210,149,211,149,212,149,213,149,214,149,215,149,216,149,217,149,218,149,219,149,220,149,221,149,222,149,223,149,224,149,225,149,226,149,227,149,228,149,229,149,230,149,231,149,236,149,255,149,7,150,19,150,24,150,27,150,30,150,32,150,35,150,36,150,37,150,38,150,39,150,40,150,41,150,43,150,44,150,45,150,47,150,48,150,55,150,56,150,57,150,58,150,62,150,65,150,67,150,74,150,78,150,79,150,81,150,82,150,83,150,86,150,87,150,88,150,89,150,90,150,92,150,93,150,94,150,96,150,99,150,101,150,102,150,107,150,109,150,110,150,111,150,112,150,113,150,115,150,120,150,121,150,122,150,123,150,124,150,125,150,126,150,127,150,128,150,129,150,130,150,131,150,132,150,135,150,137,150,138,150,141,143,142,143,143,143,152,143,154,143,206,142,11,98,23,98,27,98,31,98,34,98,33,98,37,98,36,98,44,98,231,129,239,116,244,116,255,116,15,117,17,117,19,117,52,101,238,101,239,101,240,101,10,102,25,102,114,103,3,102,21,102,0,102,133,112,247,102,29,102,52,102,49,102,54,102,53,102,6,128,95,102,84,102,65,102,79,102,86,102,97,102,87,102,119,102,132,102,140,102,167,102,157,102,190,102,219,102,220,102,230,102,233,102,50,141,51,141,54,141,59,141,61,141,64,141,69,141,70,141,72,141,73,141,71,141,77,141,85,141,89,141,199,137,202,137,203,137,204,137,206,137,207,137,208,137,209,137,110,114,159,114,93,114,102,114,111,114,126,114,127,114,132,114,139,114,141,114,143,114,146,114,8,99,50,99,176,99,140,150,142,150,145,150,146,150,147,150,149,150,150,150,154,150,155,150,157,150,158,150,159,150,160,150,161,150,162,150,163,150,164,150,165,150,166,150,168,150,169,150,170,150,171,150,172,150,173,150,174,150,175,150,177,150,178,150,180,150,181,150,183,150,184,150,186,150,187,150,191,150,194,150,195,150,200,150,202,150,203,150,208,150,209,150,211,150,212,150,214,150,215,150,216,150,217,150,218,150,219,150,220,150,221,150,222,150,223,150,225,150,226,150,227,150,228,150,229,150,230,150,231,150,235,150,236,150,237,150,238,150,240,150,241,150,242,150,244,150,245,150,248,150,250,150,251,150,252,150,253,150,255,150,2,151,3,151,5,151,10,151,11,151,12,151,16,151,17,151,18,151,20,151,21,151,23,151,24,151,25,151,26,151,27,151,29,151,31,151,32,151,63,100,216,100,4,128,234,107,243,107,253,107,245,107,249,107,5,108,7,108,6,108,13,108,21,108,24,108,25,108,26,108,33,108,41,108,36,108,42,108,50,108,53,101,85,101,107,101,77,114,82,114,86,114,48,114,98,134,22,82,159,128,156,128,147,128,188,128,10,103,189,128,177,128,171,128,173,128,180,128,183,128,231,128,232,128,233,128,234,128,219,128,194,128,196,128,217,128,205,128,215,128,16,103,221,128,235,128,241,128,244,128,237,128,13,129,14,129,242,128,252,128,21,103,18,129,90,140,54,129,30,129,44,129,24,129,50,129,72,129,76,129,83,129,116,129,89,129,90,129,113,129,96,129,105,129,124,129,125,129,109,129,103,129,77,88,181,90,136,129,130,129,145,129,213,110,163,129,170,129,204,129,38,103,202,129,187,129,33,151,34,151,35,151,36,151,37,151,38,151,39,151,40,151,41,151,43,151,44,151,46,151,47,151,49,151,51,151,52,151,53,151,54,151,55,151,58,151,59,151,60,151,61,151,63,151,64,151,65,151,66,151,67,151,68,151,69,151,70,151,71,151,72,151,73,151,74,151,75,151,76,151,77,151,78,151,79,151,80,151,81,151,84,151,85,151,87,151,88,151,90,151,92,151,93,151,95,151,99,151,100,151,102,151,103,151,104,151,106,151,107,151,108,151,109,151,110,151,111,151,112,151,113,151,114,151,117,151,119,151,120,151,121,151,122,151,123,151,125,151,126,151,127,151,128,151,129,151,130,151,131,151,132,151,134,151,135,151,136,151,137,151,138,151,140,151,142,151,143,151,144,151,147,151,149,151,150,151,151,151,153,151,154,151,155,151,156,151,157,151,193,129,166,129,36,107,55,107,57,107,67,107,70,107,89,107,209,152,210,152,211,152,213,152,217,152,218,152,179,107,64,95,194,107,243,137,144,101,81,159,147,101,188,101,198,101,196,101,195,101,204,101,206,101,210,101,214,101,128,112,156,112,150,112,157,112,187,112,192,112,183,112,171,112,177,112,232,112,202,112,16,113,19,113,22,113,47,113,49,113,115,113,92,113,104,113,69,113,114,113,74,113,120,113,122,113,152,113,179,113,181,113,168,113,160,113,224,113,212,113,231,113,249,113,29,114,40,114,108,112,24,113,102,113,185,113,62,98,61,98,67,98,72,98,73,98,59,121,64,121,70,121,73,121,91,121,92,121,83,121,90,121,98,121,87,121,96,121,111,121,103,121,122,121,133,121,138,121,154,121,167,121,179,121,209,95,208,95,158,151,159,151,161,151,162,151,164,151,165,151,166,151,167,151,168,151,169,151,170,151,172,151,174,151,176,151,177,151,179,151,181,151,182,151,183,151,184,151,185,151,186,151,187,151,188,151,189,151,190,151,191,151,192,151,193,151,194,151,195,151,196,151,197,151,198,151,199,151,200,151,201,151,202,151,203,151,204,151,205,151,206,151,207,151,208,151,209,151,210,151,211,151,212,151,213,151,214,151,215,151,216,151,217,151,218,151,219,151,220,151,221,151,222,151,223,151,224,151,225,151,226,151,227,151,228,151,229,151,232,151,238,151,239,151,240,151,241,151,242,151,244,151,247,151,248,151,249,151,250,151,251,151,252,151,253,151,254,151,255,151,0,152,1,152,2,152,3,152,4,152,5,152,6,152,7,152,8,152,9,152,10,152,11,152,12,152,13,152,14,152,60,96,93,96,90,96,103,96,65,96,89,96,99,96,171,96,6,97,13,97,93,97,169,97,157,97,203,97,209,97,6,98,128,128,127,128,147,108,246,108,252,109,246,119,248,119,0,120,9,120,23,120,24,120,17,120,171,101,45,120,28,120,29,120,57,120,58,120,59,120,31,120,60,120,37,120,44,120,35,120,41,120,78,120,109,120,86,120,87,120,38,120,80,120,71,120,76,120,106,120,155,120,147,120,154,120,135,120,156,120,161,120,163,120,178,120,185,120,165,120,212,120,217,120,201,120,236,120,242,120,5,121,244,120,19,121,36,121,30,121,52,121,155,159,249,158,251,158,252,158,241,118,4,119,13,119,249,118,7,119,8,119,26,119,34,119,25,119,45,119,38,119,53,119,56,119,80,119,81,119,71,119,67,119,90,119,104,119,15,152,16,152,17,152,18,152,19,152,20,152,21,152,22,152,23,152,24,152,25,152,26,152,27,152,28,152,29,152,30,152,31,152,32,152,33,152,34,152,35,152,36,152,37,152,38,152,39,152,40,152,41,152,42,152,43,152,44,152,45,152,46,152,47,152,48,152,49,152,50,152,51,152,52,152,53,152,54,152,55,152,56,152,57,152,58,152,59,152,60,152,61,152,62,152,63,152,64,152,65,152,66,152,67,152,68,152,69,152,70,152,71,152,72,152,73,152,74,152,75,152,76,152,77,152,78,152,79,152,80,152,81,152,82,152,83,152,84,152,85,152,86,152,87,152,88,152,89,152,90,152,91,152,92,152,93,152,94,152,95,152,96,152,97,152,98,152,99,152,100,152,101,152,102,152,103,152,104,152,105,152,106,152,107,152,108,152,109,152,110,152,98,119,101,119,127,119,141,119,125,119,128,119,140,119,145,119,159,119,160,119,176,119,181,119,189,119,58,117,64,117,78,117,75,117,72,117,91,117,114,117,121,117,131,117,88,127,97,127,95,127,72,138,104,127,116,127,113,127,121,127,129,127,126,127,205,118,229,118,50,136,133,148,134,148,135,148,139,148,138,148,140,148,141,148,143,148,144,148,148,148,151,148,149,148,154,148,155,148,156,148,163,148,164,148,171,148,170,148,173,148,172,148,175,148,176,148,178,148,180,148,182,148,183,148,184,148,185,148,186,148,188,148,189,148,191,148,196,148,200,148,201,148,202,148,203,148,204,148,205,148,206,148,208,148,209,148,210,148,213,148,214,148,215,148,217,148,216,148,219,148,222,148,223,148,224,148,226,148,228,148,229,148,231,148,232,148,234,148,111,152,112,152,113,152,114,152,115,152,116,152,139,152,142,152,146,152,149,152,153,152,163,152,168,152,169,152,170,152,171,152,172,152,173,152,174,152,175,152,176,152,177,152,178,152,179,152,180,152,181,152,182,152,183,152,184,152,185,152,186,152,187,152,188,152,189,152,190,152,191,152,192,152,193,152,194,152,195,152,196,152,197,152,198,152,199,152,200,152,201,152,202,152,203,152,204,152,205,152,207,152,208,152,212,152,214,152,215,152,219,152,220,152,221,152,224,152,225,152,226,152,227,152,228,152,229,152,230,152,233,152,234,152,235,152,236,152,237,152,238,152,239,152,240,152,241,152,242,152,243,152,244,152,245,152,246,152,247,152,248,152,249,152,250,152,251,152,252,152,253,152,254,152,255,152,0,153,1,153,2,153,3,153,4,153,5,153,6,153,7,153,233,148,235,148,238,148,239,148,243,148,244,148,245,148,247,148,249,148,252,148,253,148,255,148,3,149,2,149,6,149,7,149,9,149,10,149,13,149,14,149,15,149,18,149,19,149,20,149,21,149,22,149,24,149,27,149,29,149,30,149,31,149,34,149,42,149,43,149,41,149,44,149,49,149,50,149,52,149,54,149,55,149,56,149,60,149,62,149,63,149,66,149,53,149,68,149,69,149,70,149,73,149,76,149,78,149,79,149,82,149,83,149,84,149,86,149,87,149,88,149,89,149,91,149,94,149,95,149,93,149,97,149,98,149,100,149,101,149,102,149,103,149,104,149,105,149,106,149,107,149,108,149,111,149,113,149,114,149,115,149,58,149,231,119,236,119,201,150,213,121,237,121,227,121,235,121,6,122,71,93,3,122,2,122,30,122,20,122,8,153,9,153,10,153,11,153,12,153,14,153,15,153,17,153,18,153,19,153,20,153,21,153,22,153,23,153,24,153,25,153,26,153,27,153,28,153,29,153,30,153,31,153,32,153,33,153,34,153,35,153,36,153,37,153,38,153,39,153,40,153,41,153,42,153,43,153,44,153,45,153,47,153,48,153,49,153,50,153,51,153,52,153,53,153,54,153,55,153,56,153,57,153,58,153,59,153,60,153,61,153,62,153,63,153,64,153,65,153,66,153,67,153,68,153,69,153,70,153,71,153,72,153,73,153,74,153,75,153,76,153,77,153,78,153,79,153,80,153,81,153,82,153,83,153,86,153,87,153,88,153,89,153,90,153,91,153,92,153,93,153,94,153,95,153,96,153,97,153,98,153,100,153,102,153,115,153,120,153,121,153,123,153,126,153,130,153,131,153,137,153,57,122,55,122,81,122,207,158,165,153,112,122,136,118,142,118,147,118,153,118,164,118,222,116,224,116,44,117,32,158,34,158,40,158,41,158,42,158,43,158,44,158,50,158,49,158,54,158,56,158,55,158,57,158,58,158,62,158,65,158,66,158,68,158,70,158,71,158,72,158,73,158,75,158,76,158,78,158,81,158,85,158,87,158,90,158,91,158,92,158,94,158,99,158,102,158,103,158,104,158,105,158,106,158,107,158,108,158,113,158,109,158,115,158,146,117,148,117,150,117,160,117,157,117,172,117,163,117,179,117,180,117,184,117,196,117,177,117,176,117,195,117,194,117,214,117,205,117,227,117,232,117,230,117,228,117,235,117,231,117,3,118,241,117,252,117,255,117,16,118,0,118,5,118,12,118,23,118,10,118,37,118,24,118,21,118,25,118,140,153,142,153,154,153,155,153,156,153,157,153,158,153,159,153,160,153,161,153,162,153,163,153,164,153,166,153,167,153,169,153,170,153,171,153,172,153,173,153,174,153,175,153,176,153,177,153,178,153,179,153,180,153,181,153,182,153,183,153,184,153,185,153,186,153,187,153,188,153,189,153,190,153,191,153,192,153,193,153,194,153,195,153,196,153,197,153,198,153,199,153,200,153,201,153,202,153,203,153,204,153,205,153,206,153,207,153,208,153,209,153,210,153,211,153,212,153,213,153,214,153,215,153,216,153,217,153,218,153,219,153,220,153,221,153,222,153,223,153,224,153,225,153,226,153,227,153,228,153,229,153,230,153,231,153,232,153,233,153,234,153,235,153,236,153,237,153,238,153,239,153,240,153,241,153,242,153,243,153,244,153,245,153,246,153,247,153,248,153,249,153,27,118,60,118,34,118,32,118,64,118,45,118,48,118,63,118,53,118,67,118,62,118,51,118,77,118,94,118,84,118,92,118,86,118,107,118,111,118,202,127,230,122,120,122,121,122,128,122,134,122,136,122,149,122,166,122,160,122,172,122,168,122,173,122,179,122,100,136,105,136,114,136,125,136,127,136,130,136,162,136,198,136,183,136,188,136,201,136,226,136,206,136,227,136,229,136,241,136,26,137,252,136,232,136,254,136,240,136,33,137,25,137,19,137,27,137,10,137,52,137,43,137,54,137,65,137,102,137,123,137,139,117,229,128,178,118,180,118,220,119,18,128,20,128,22,128,28,128,32,128,34,128,37,128,38,128,39,128,41,128,40,128,49,128,11,128,53,128,67,128,70,128,77,128,82,128,105,128,113,128,131,137,120,152,128,152,131,152,250,153,251,153,252,153,253,153,254,153,255,153,0,154,1,154,2,154,3,154,4,154,5,154,6,154,7,154,8,154,9,154,10,154,11,154,12,154,13,154,14,154,15,154,16,154,17,154,18,154,19,154,20,154,21,154,22,154,23,154,24,154,25,154,26,154,27,154,28,154,29,154,30,154,31,154,32,154,33,154,34,154,35,154,36,154,37,154,38,154,39,154,40,154,41,154,42,154,43,154,44,154,45,154,46,154,47,154,48,154,49,154,50,154,51,154,52,154,53,154,54,154,55,154,56,154,57,154,58,154,59,154,60,154,61,154,62,154,63,154,64,154,65,154,66,154,67,154,68,154,69,154,70,154,71,154,72,154,73,154,74,154,75,154,76,154,77,154,78,154,79,154,80,154,81,154,82,154,83,154,84,154,85,154,86,154,87,154,88,154,89,154,137,152,140,152,141,152,143,152,148,152,154,152,155,152,158,152,159,152,161,152,162,152,165,152,166,152,77,134,84,134,108,134,110,134,127,134,122,134,124,134,123,134,168,134,141,134,139,134,172,134,157,134,167,134,163,134,170,134,147,134,169,134,182,134,196,134,181,134,206,134,176,134,186,134,177,134,175,134,201,134,207,134,180,134,233,134,241,134,242,134,237,134,243,134,208,134,19,135,222,134,244,134,223,134,216,134,209,134,3,135,7,135,248,134,8,135,10,135,13,135,9,135,35,135,59,135,30,135,37,135,46,135,26,135,62,135,72,135,52,135,49,135,41,135,55,135,63,135,130,135,34,135,125,135,126,135,123,135,96,135,112,135,76,135,110,135,139,135,83,135,99,135,124,135,100,135,89,135,101,135,147,135,175,135,168,135,210,135,90,154,91,154,92,154,93,154,94,154,95,154,96,154,97,154,98,154,99,154,100,154,101,154,102,154,103,154,104,154,105,154,106,154,107,154,114,154,131,154,137,154,141,154,142,154,148,154,149,154,153,154,166,154,169,154,170,154,171,154,172,154,173,154,174,154,175,154,178,154,179,154,180,154,181,154,185,154,187,154,189,154,190,154,191,154,195,154,196,154,198,154,199,154,200,154,201,154,202,154,205,154,206,154,207,154,208,154,210,154,212,154,213,154,214,154,215,154,217,154,218,154,219,154,220,154,221,154,222,154,224,154,226,154,227,154,228,154,229,154,231,154,232,154,233,154,234,154,236,154,238,154,240,154,241,154,242,154,243,154,244,154,245,154,246,154,247,154,248,154,250,154,252,154,253,154,254,154,255,154,0,155,1,155,2,155,4,155,5,155,6,155,198,135,136,135,133,135,173,135,151,135,131,135,171,135,229,135,172,135,181,135,179,135,203,135,211,135,189,135,209,135,192,135,202,135,219,135,234,135,224,135,238,135,22,136,19,136,254,135,10,136,27,136,33,136,57,136,60,136,54,127,66,127,68,127,69,127,16,130,250,122,253,122,8,123,3,123,4,123,21,123,10,123,43,123,15,123,71,123,56,123,42,123,25,123,46,123,49,123,32,123,37,123,36,123,51,123,62,123,30,123,88,123,90,123,69,123,117,123,76,123,93,123,96,123,110,123,123,123,98,123,114,123,113,123,144,123,166,123,167,123,184,123,172,123,157,123,168,123,133,123,170,123,156,123,162,123,171,123,180,123,209,123,193,123,204,123,221,123,218,123,229,123,230,123,234,123,12,124,254,123,252,123,15,124,22,124,11,124,7,155,9,155,10,155,11,155,12,155,13,155,14,155,16,155,17,155,18,155,20,155,21,155,22,155,23,155,24,155,25,155,26,155,27,155,28,155,29,155,30,155,32,155,33,155,34,155,36,155,37,155,38,155,39,155,40,155,41,155,42,155,43,155,44,155,45,155,46,155,48,155,49,155,51,155,52,155,53,155,54,155,55,155,56,155,57,155,58,155,61,155,62,155,63,155,64,155,70,155,74,155,75,155,76,155,78,155,80,155,82,155,83,155,85,155,86,155,87,155,88,155,89,155,90,155,91,155,92,155,93,155,94,155,95,155,96,155,97,155,98,155,99,155,100,155,101,155,102,155,103,155,104,155,105,155,106,155,107,155,108,155,109,155,110,155,111,155,112,155,113,155,114,155,115,155,116,155,117,155,118,155,119,155,120,155,121,155,122,155,123,155,31,124,42,124,38,124,56,124,65,124,64,124,254,129,1,130,2,130,4,130,236,129,68,136,33,130,34,130,35,130,45,130,47,130,40,130,43,130,56,130,59,130,51,130,52,130,62,130,68,130,73,130,75,130,79,130,90,130,95,130,104,130,126,136,133,136,136,136,216,136,223,136,94,137,157,127,159,127,167,127,175,127,176,127,178,127,124,124,73,101,145,124,157,124,156,124,158,124,162,124,178,124,188,124,189,124,193,124,199,124,204,124,205,124,200,124,197,124,215,124,232,124,110,130,168,102,191,127,206,127,213,127,229,127,225,127,230,127,233,127,238,127,243,127,248,124,119,125,166,125,174,125,71,126,155,126,184,158,180,158,115,141,132,141,148,141,145,141,177,141,103,141,109,141,71,140,73,140,74,145,80,145,78,145,79,145,100,145,124,155,125,155,126,155,127,155,128,155,129,155,130,155,131,155,132,155,133,155,134,155,135,155,136,155,137,155,138,155,139,155,140,155,141,155,142,155,143,155,144,155,145,155,146,155,147,155,148,155,149,155,150,155,151,155,152,155,153,155,154,155,155,155,156,155,157,155,158,155,159,155,160,155,161,155,162,155,163,155,164,155,165,155,166,155,167,155,168,155,169,155,170,155,171,155,172,155,173,155,174,155,175,155,176,155,177,155,178,155,179,155,180,155,181,155,182,155,183,155,184,155,185,155,186,155,187,155,188,155,189,155,190,155,191,155,192,155,193,155,194,155,195,155,196,155,197,155,198,155,199,155,200,155,201,155,202,155,203,155,204,155,205,155,206,155,207,155,208,155,209,155,210,155,211,155,212,155,213,155,214,155,215,155,216,155,217,155,218,155,219,155,98,145,97,145,112,145,105,145,111,145,125,145,126,145,114,145,116,145,121,145,140,145,133,145,144,145,141,145,145,145,162,145,163,145,170,145,173,145,174,145,175,145,181,145,180,145,186,145,85,140,126,158,184,141,235,141,5,142,89,142,105,142,181,141,191,141,188,141,186,141,196,141,214,141,215,141,218,141,222,141,206,141,207,141,219,141,198,141,236,141,247,141,248,141,227,141,249,141,251,141,228,141,9,142,253,141,20,142,29,142,31,142,44,142,46,142,35,142,47,142,58,142,64,142,57,142,53,142,61,142,49,142,73,142,65,142,66,142,81,142,82,142,74,142,112,142,118,142,124,142,111,142,116,142,133,142,143,142,148,142,144,142,156,142,158,142,120,140,130,140,138,140,133,140,152,140,148,140,155,101,214,137,222,137,218,137,220,137,220,155,221,155,222,155,223,155,224,155,225,155,226,155,227,155,228,155,229,155,230,155,231,155,232,155,233,155,234,155,235,155,236,155,237,155,238,155,239,155,240,155,241,155,242,155,243,155,244,155,245,155,246,155,247,155,248,155,249,155,250,155,251,155,252,155,253,155,254,155,255,155,0,156,1,156,2,156,3,156,4,156,5,156,6,156,7,156,8,156,9,156,10,156,11,156,12,156,13,156,14,156,15,156,16,156,17,156,18,156,19,156,20,156,21,156,22,156,23,156,24,156,25,156,26,156,27,156,28,156,29,156,30,156,31,156,32,156,33,156,34,156,35,156,36,156,37,156,38,156,39,156,40,156,41,156,42,156,43,156,44,156,45,156,46,156,47,156,48,156,49,156,50,156,51,156,52,156,53,156,54,156,55,156,56,156,57,156,58,156,59,156,229,137,235,137,239,137,62,138,38,139,83,151,233,150,243,150,239,150,6,151,1,151,8,151,15,151,14,151,42,151,45,151,48,151,62,151,128,159,131,159,133,159,134,159,135,159,136,159,137,159,138,159,140,159,254,158,11,159,13,159,185,150,188,150,189,150,206,150,210,150,191,119,224,150,142,146,174,146,200,146,62,147,106,147,202,147,143,147,62,148,107,148,127,156,130,156,133,156,134,156,135,156,136,156,35,122,139,156,142,156,144,156,145,156,146,156,148,156,149,156,154,156,155,156,158,156,159,156,160,156,161,156,162,156,163,156,165,156,166,156,167,156,168,156,169,156,171,156,173,156,174,156,176,156,177,156,178,156,179,156,180,156,181,156,182,156,183,156,186,156,187,156,188,156,189,156,196,156,197,156,198,156,199,156,202,156,203,156,60,156,61,156,62,156,63,156,64,156,65,156,66,156,67,156,68,156,69,156,70,156,71,156,72,156,73,156,74,156,75,156,76,156,77,156,78,156,79,156,80,156,81,156,82,156,83,156,84,156,85,156,86,156,87,156,88,156,89,156,90,156,91,156,92,156,93,156,94,156,95,156,96,156,97,156,98,156,99,156,100,156,101,156,102,156,103,156,104,156,105,156,106,156,107,156,108,156,109,156,110,156,111,156,112,156,113,156,114,156,115,156,116,156,117,156,118,156,119,156,120,156,121,156,122,156,123,156,125,156,126,156,128,156,131,156,132,156,137,156,138,156,140,156,143,156,147,156,150,156,151,156,152,156,153,156,157,156,170,156,172,156,175,156,185,156,190,156,191,156,192,156,193,156,194,156,200,156,201,156,209,156,210,156,218,156,219,156,224,156,225,156,204,156,205,156,206,156,207,156,208,156,211,156,212,156,213,156,215,156,216,156,217,156,220,156,221,156,223,156,226,156,124,151,133,151,145,151,146,151,148,151,175,151,171,151,163,151,178,151,180,151,177,154,176,154,183,154,88,158,182,154,186,154,188,154,193,154,192,154,197,154,194,154,203,154,204,154,209,154,69,155,67,155,71,155,73,155,72,155,77,155,81,155,232,152,13,153,46,153,85,153,84,153,223,154,225,154,230,154,239,154,235,154,251,154,237,154,249,154,8,155,15,155,19,155,31,155,35,155,189,158,190,158,59,126,130,158,135,158,136,158,139,158,146,158,214,147,157,158,159,158,219,158,220,158,221,158,224,158,223,158,226,158,233,158,231,158,229,158,234,158,239,158,34,159,44,159,47,159,57,159,55,159,61,159,62,159,68,159,227,156,228,156,229,156,230,156,231,156,232,156,233,156,234,156,235,156,236,156,237,156,238,156,239,156,240,156,241,156,242,156,243,156,244,156,245,156,246,156,247,156,248,156,249,156,250,156,251,156,252,156,253,156,254,156,255,156,0,157,1,157,2,157,3,157,4,157,5,157,6,157,7,157,8,157,9,157,10,157,11,157,12,157,13,157,14,157,15,157,16,157,17,157,18,157,19,157,20,157,21,157,22,157,23,157,24,157,25,157,26,157,27,157,28,157,29,157,30,157,31,157,32,157,33,157,34,157,35,157,36,157,37,157,38,157,39,157,40,157,41,157,42,157,43,157,44,157,45,157,46,157,47,157,48,157,49,157,50,157,51,157,52,157,53,157,54,157,55,157,56,157,57,157,58,157,59,157,60,157,61,157,62,157,63,157,64,157,65,157,66,157,52,226,53,226,54,226,55,226,56,226,57,226,58,226,59,226,60,226,61,226,62,226,63,226,64,226,65,226,66,226,67,226,68,226,69,226,70,226,71,226,72,226,73,226,74,226,75,226,76,226,77,226,78,226,79,226,80,226,81,226,82,226,83,226,84,226,85,226,86,226,87,226,88,226,89,226,90,226,91,226,92,226,93,226,94,226,95,226,96,226,97,226,98,226,99,226,100,226,101,226,102,226,103,226,104,226,105,226,106,226,107,226,108,226,109,226,110,226,111,226,112,226,113,226,114,226,115,226,116,226,117,226,118,226,119,226,120,226,121,226,122,226,123,226,124,226,125,226,126,226,127,226,128,226,129,226,130,226,131,226,132,226,133,226,134,226,135,226,136,226,137,226,138,226,139,226,140,226,141,226,142,226,143,226,144,226,145,226,67,157,68,157,69,157,70,157,71,157,72,157,73,157,74,157,75,157,76,157,77,157,78,157,79,157,80,157,81,157,82,157,83,157,84,157,85,157,86,157,87,157,88,157,89,157,90,157,91,157,92,157,93,157,94,157,95,157,96,157,97,157,98,157,99,157,100,157,101,157,102,157,103,157,104,157,105,157,106,157,107,157,108,157,109,157,110,157,111,157,112,157,113,157,114,157,115,157,116,157,117,157,118,157,119,157,120,157,121,157,122,157,123,157,124,157,125,157,126,157,127,157,128,157,129,157,130,157,131,157,132,157,133,157,134,157,135,157,136,157,137,157,138,157,139,157,140,157,141,157,142,157,143,157,144,157,145,157,146,157,147,157,148,157,149,157,150,157,151,157,152,157,153,157,154,157,155,157,156,157,157,157,158,157,159,157,160,157,161,157,162,157,146,226,147,226,148,226,149,226,150,226,151,226,152,226,153,226,154,226,155,226,156,226,157,226,158,226,159,226,160,226,161,226,162,226,163,226,164,226,165,226,166,226,167,226,168,226,169,226,170,226,171,226,172,226,173,226,174,226,175,226,176,226,177,226,178,226,179,226,180,226,181,226,182,226,183,226,184,226,185,226,186,226,187,226,188,226,189,226,190,226,191,226,192,226,193,226,194,226,195,226,196,226,197,226,198,226,199,226,200,226,201,226,202,226,203,226,204,226,205,226,206,226,207,226,208,226,209,226,210,226,211,226,212,226,213,226,214,226,215,226,216,226,217,226,218,226,219,226,220,226,221,226,222,226,223,226,224,226,225,226,226,226,227,226,228,226,229,226,230,226,231,226,232,226,233,226,234,226,235,226,236,226,237,226,238,226,239,226,163,157,164,157,165,157,166,157,167,157,168,157,169,157,170,157,171,157,172,157,173,157,174,157,175,157,176,157,177,157,178,157,179,157,180,157,181,157,182,157,183,157,184,157,185,157,186,157,187,157,188,157,189,157,190,157,191,157,192,157,193,157,194,157,195,157,196,157,197,157,198,157,199,157,200,157,201,157,202,157,203,157,204,157,205,157,206,157,207,157,208,157,209,157,210,157,211,157,212,157,213,157,214,157,215,157,216,157,217,157,218,157,219,157,220,157,221,157,222,157,223,157,224,157,225,157,226,157,227,157,228,157,229,157,230,157,231,157,232,157,233,157,234,157,235,157,236,157,237,157,238,157,239,157,240,157,241,157,242,157,243,157,244,157,245,157,246,157,247,157,248,157,249,157,250,157,251,157,252,157,253,157,254,157,255,157,0,158,1,158,2,158,240,226,241,226,242,226,243,226,244,226,245,226,246,226,247,226,248,226,249,226,250,226,251,226,252,226,253,226,254,226,255,226,0,227,1,227,2,227,3,227,4,227,5,227,6,227,7,227,8,227,9,227,10,227,11,227,12,227,13,227,14,227,15,227,16,227,17,227,18,227,19,227,20,227,21,227,22,227,23,227,24,227,25,227,26,227,27,227,28,227,29,227,30,227,31,227,32,227,33,227,34,227,35,227,36,227,37,227,38,227,39,227,40,227,41,227,42,227,43,227,44,227,45,227,46,227,47,227,48,227,49,227,50,227,51,227,52,227,53,227,54,227,55,227,56,227,57,227,58,227,59,227,60,227,61,227,62,227,63,227,64,227,65,227,66,227,67,227,68,227,69,227,70,227,71,227,72,227,73,227,74,227,75,227,76,227,77,227,3,158,4,158,5,158,6,158,7,158,8,158,9,158,10,158,11,158,12,158,13,158,14,158,15,158,16,158,17,158,18,158,19,158,20,158,21,158,22,158,23,158,24,158,25,158,26,158,27,158,28,158,29,158,30,158,36,158,39,158,46,158,48,158,52,158,59,158,60,158,64,158,77,158,80,158,82,158,83,158,84,158,86,158,89,158,93,158,95,158,96,158,97,158,98,158,101,158,110,158,111,158,114,158,116,158,117,158,118,158,119,158,120,158,121,158,122,158,123,158,124,158,125,158,128,158,129,158,131,158,132,158,133,158,134,158,137,158,138,158,140,158,141,158,142,158,143,158,144,158,145,158,148,158,149,158,150,158,151,158,152,158,153,158,154,158,155,158,156,158,158,158,160,158,161,158,162,158,163,158,164,158,165,158,167,158,168,158,169,158,170,158,78,227,79,227,80,227,81,227,82,227,83,227,84,227,85,227,86,227,87,227,88,227,89,227,90,227,91,227,92,227,93,227,94,227,95,227,96,227,97,227,98,227,99,227,100,227,101,227,102,227,103,227,104,227,105,227,106,227,107,227,108,227,109,227,110,227,111,227,112,227,113,227,114,227,115,227,116,227,117,227,118,227,119,227,120,227,121,227,122,227,123,227,124,227,125,227,126,227,127,227,128,227,129,227,130,227,131,227,132,227,133,227,134,227,135,227,136,227,137,227,138,227,139,227,140,227,141,227,142,227,143,227,144,227,145,227,146,227,147,227,148,227,149,227,150,227,151,227,152,227,153,227,154,227,155,227,156,227,157,227,158,227,159,227,160,227,161,227,162,227,163,227,164,227,165,227,166,227,167,227,168,227,169,227,170,227,171,227,171,158,172,158,173,158,174,158,175,158,176,158,177,158,178,158,179,158,181,158,182,158,183,158,185,158,186,158,188,158,191,158,192,158,193,158,194,158,195,158,197,158,198,158,199,158,200,158,202,158,203,158,204,158,208,158,210,158,211,158,213,158,214,158,215,158,217,158,218,158,222,158,225,158,227,158,228,158,230,158,232,158,235,158,236,158,237,158,238,158,240,158,241,158,242,158,243,158,244,158,245,158,246,158,247,158,248,158,250,158,253,158,255,158,0,159,1,159,2,159,3,159,4,159,5,159,6,159,7,159,8,159,9,159,10,159,12,159,15,159,17,159,18,159,20,159,21,159,22,159,24,159,26,159,27,159,28,159,29,159,30,159,31,159,33,159,35,159,36,159,37,159,38,159,39,159,40,159,41,159,42,159,43,159,45,159,46,159,48,159,49,159,172,227,173,227,174,227,175,227,176,227,177,227,178,227,179,227,180,227,181,227,182,227,183,227,184,227,185,227,186,227,187,227,188,227,189,227,190,227,191,227,192,227,193,227,194,227,195,227,196,227,197,227,198,227,199,227,200,227,201,227,202,227,203,227,204,227,205,227,206,227,207,227,208,227,209,227,210,227,211,227,212,227,213,227,214,227,215,227,216,227,217,227,218,227,219,227,220,227,221,227,222,227,223,227,224,227,225,227,226,227,227,227,228,227,229,227,230,227,231,227,232,227,233,227,234,227,235,227,236,227,237,227,238,227,239,227,240,227,241,227,242,227,243,227,244,227,245,227,246,227,247,227,248,227,249,227,250,227,251,227,252,227,253,227,254,227,255,227,0,228,1,228,2,228,3,228,4,228,5,228,6,228,7,228,8,228,9,228,50,159,51,159,52,159,53,159,54,159,56,159,58,159,60,159,63,159,64,159,65,159,66,159,67,159,69,159,70,159,71,159,72,159,73,159,74,159,75,159,76,159,77,159,78,159,79,159,82,159,83,159,84,159,85,159,86,159,87,159,88,159,89,159,90,159,91,159,92,159,93,159,94,159,95,159,96,159,97,159,98,159,99,159,100,159,101,159,102,159,103,159,104,159,105,159,106,159,107,159,108,159,109,159,110,159,111,159,112,159,113,159,114,159,115,159,116,159,117,159,118,159,119,159,120,159,121,159,122,159,123,159,124,159,125,159,126,159,129,159,130,159,141,159,142,159,143,159,144,159,145,159,146,159,147,159,148,159,149,159,150,159,151,159,152,159,156,159,157,159,158,159,161,159,162,159,163,159,164,159,165,159,44,249,121,249,149,249,231,249,241,249,10,228,11,228,12,228,13,228,14,228,15,228,16,228,17,228,18,228,19,228,20,228,21,228,22,228,23,228,24,228,25,228,26,228,27,228,28,228,29,228,30,228,31,228,32,228,33,228,34,228,35,228,36,228,37,228,38,228,39,228,40,228,41,228,42,228,43,228,44,228,45,228,46,228,47,228,48,228,49,228,50,228,51,228,52,228,53,228,54,228,55,228,56,228,57,228,58,228,59,228,60,228,61,228,62,228,63,228,64,228,65,228,66,228,67,228,68,228,69,228,70,228,71,228,72,228,73,228,74,228,75,228,76,228,77,228,78,228,79,228,80,228,81,228,82,228,83,228,84,228,85,228,86,228,87,228,88,228,89,228,90,228,91,228,92,228,93,228,94,228,95,228,96,228,97,228,98,228,99,228,100,228,101,228,102,228,103,228,12,250,13,250,14,250,15,250,17,250,19,250,20,250,24,250,31,250,32,250,33,250,35,250,36,250,39,250,40,250,41,250,129,46,22,232,23,232,24,232,132,46,115,52,71,52,136,46,139,46,30,232,158,53,26,54,14,54,140,46,151,46,110,57,24,57,38,232,207,57,223,57,115,58,208,57,43,232,44,232,78,59,110,60,224,60,167,46,49,232,50,232,170,46,86,64,95,65,174,46,55,67,179,46,182,46,183,46,59,232,177,67,172,67,187,46,221,67,214,68,97,70,76,70,67,232,35,71,41,71,124,71,141,71,202,46,71,73,122,73,125,73,130,73,131,73,133,73,134,73,159,73,155,73,183,73,182,73,84,232,85,232,163,76,159,76,160,76,161,76,119,76,162,76,19,77,20,77,21,77,22,77,23,77,24,77,25,77,174,77,100,232,104,228,105,228,106,228,107,228,108,228,109,228,110,228,111,228,112,228,113,228,114,228,115,228,116,228,117,228,118,228,119,228,120,228,121,228,122,228,123,228,124,228,125,228,126,228,127,228,128,228,129,228,130,228,131,228,132,228,133,228,134,228,135,228,136,228,137,228,138,228,139,228,140,228,141,228,142,228,143,228,144,228,145,228,146,228,147,228,148,228,149,228,150,228,151,228,152,228,153,228,154,228,155,228,156,228,157,228,158,228,159,228,160,228,161,228,162,228,163,228,164,228,165,228,166,228,167,228,168,228,169,228,170,228,171,228,172,228,173,228,174,228,175,228,176,228,177,228,178,228,179,228,180,228,181,228,182,228,183,228,184,228,185,228,186,228,187,228,188,228,189,228,190,228,191,228,192,228,193,228,194,228,195,228,196,228,197,228,240,67,50,76,3,70,166,69,120,69,103,114,119,77,179,69,177,124,226,76,197,124,149,59,54,71,68,71,71,76,64,76,191,66,23,54,82,115,139,110,210,112,87,76,81,163,79,71,218,69,133,76,108,124,7,77,164,74,161,70,35,107,37,114,84,90,99,26,6,62,97,63,77,102,251,86,0,0,149,125,29,89,185,139,244,61,52,151,239,123,219,91,94,29,164,90,37,54,176,158,209,90,183,91,252,92,110,103,147,133,69,153,97,116,157,116,117,56,83,29,158,54,33,96,236,62,222,88,245,58,252,122,151,159,97,65,13,137,234,49,138,10,94,50,10,67,132,132,150,159,47,148,48,73,19,134,150,88,74,151,24,146,208,121,50,122,96,102,41,106,157,136,76,116,197,123,130,103,44,122,79,82,70,144,230,52,196,115,185,93,198,116,199,159,179,87,47,73,76,84,49,65,142,54,24,88,114,122,101,123,143,139,174,70,136,110,129,65,153,93,174,123,188,36,200,159,193,36,201,36,204,36,201,159,4,133,187,53,180,64,202,159,225,68,255,173,193,98,110,112,203,159,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,49,193,49,194,49,195,49,196,49,12,1,197,49,209,0,205,0,198,49,199,49,203,0,232,31,200,49,202,0,201,49,202,49,203,49,204,49,14,1,205,49,206,49,0,1,193,0,205,1,192,0,18,1,201,0,26,1,200,0,76,1,211,0,209,1,210,0,0,220,190,30,4,220,192,30,202,0,1,1,225,0,206,1,224,0,81,2,19,1,233,0,27,1,232,0,43,1,237,0,208,1,236,0,77,1,243,0,210,1,242,0,107,1,250,0,212,1,249,0,214,1,216,1,218,1,220,1,252,0,8,220,191,30,12,220,193,30,234,0,97,2,218,35,219,35],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+261308),
allocate([169,163,69,17,0,0,10,101,0,0,0,0,61,78,221,110,78,157,223,145,0,0,0,0,53,119,145,100,26,79,40,79,168,79,86,81,116,81,156,81,228,81,161,82,168,82,59,83,78,83,209,83,216,83,226,86,240,88,4,89,7,89,50,89,52,89,102,91,158,91,159,91,154,92,134,94,59,96,137,101,254,103,4,104,101,104,78,109,188,112,53,117,164,126,172,126,186,126,199,126,207,126,223,126,6,127,55,127,122,130,207,130,111,131,198,137,190,139,226,139,102,143,103,143,110,143,17,116,252,124,205,125,70,105,201,122,39,82,0,0,0,0,0,0,0,0,140,145,184,120,94,145,188,128,0,0,11,141,246,128,231,9,0,0,0,0,159,128,199,158,205,76,201,157,12,158,62,76,246,157,14,112,10,158,51,161,193,53,0,0,154,110,62,130,25,117,0,0,17,73,108,154,143,154,153,159,135,121,108,132,202,29,208,5,230,42,36,78,129,78,128,78,135,78,191,78,235,78,55,79,76,52,189,79,72,62,3,80,136,80,125,52,147,52,165,52,134,81,5,89,219,81,252,81,5,82,137,78,121,82,144,82,39,83,199,53,169,83,81,53,176,83,83,53,194,83,35,84,109,53,114,53,129,54,147,84,163,84,180,84,185,84,208,84,239,84,24,85,35,85,40,85,152,53,63,85,165,53,191,53,215,85,197,53,132,125,37,85,0,0,66,12,21,13,43,81,144,85,198,44,236,57,65,3,70,142,184,77,229,148,83,64,190,128,122,119,56,44,52,58,213,71,93,129,242,105,234,77,221,100,124,13,180,15,213,12,244,16,141,100,126,142,150,14,11,12,100,15,169,44,86,130,211,68,0,0,70,13,77,154,233,128,244,71,167,78,194,44,178,154,103,58,244,149,237,63,6,53,199,82,212,151,200,120,68,45,110,157,21,152,0,0,217,67,165,96,180,100,227,84,76,45,202,43,119,16,251,57,111,16,218,102,22,103,160,121,234,100,82,80,67,12,104,142,161,33,76,139,49,7,0,0,11,72,169,1,250,63,115,88,141,45,0,0,200,69,252,4,151,96,76,15,150,13,121,85,187,64,186,67,0,0,180,74,102,42,157,16,170,129,245,152,156,13,121,99,254,57,117,39,192,141,161,86,124,100,67,62,0,0,1,166,9,14,207,42,201,44,0,0,200,16,194,57,146,57,6,58,155,130,120,53,73,94,199,32,82,86,49,15,178,44,32,151,188,52,61,108,59,78,0,0,0,0,116,117,139,46,8,34,91,166,205,140,122,14,52,12,28,104,147,127,207,16,3,40,57,41,251,53,227,81,140,14,141,15,170,14,147,63,48,15,71,13,79,17,76,14,0,0,171,14,169,11,72,13,192,16,61,17,249,63,150,38,50,100,173,15,244,51,57,118,206,43,126,13,127,13,81,44,85,44,24,58,152,14,199,16,46,15,50,166,80,107,210,140,153,141,202,140,170,149,204,84,196,130,185,85,0,0,195,158,38,156,182,154,94,119,238,45,64,113,109,129,236,128,28,92,114,101,52,129,151,55,95,83,189,128,182,145,250,14,15,14,119,14,251,14,221,53,235,77,9,54,214,12,175,86,181,39,201,16,16,14,120,14,120,16,72,17,7,130,85,20,121,14,80,78,164,45,84,90,29,16,30,16,245,16,246,16,156,87,17,14,148,118,205,130,181,15,123,14,126,81,3,55,182,15,128,17,216,82,189,162,218,73,58,24,119,65,124,130,153,88,104,82,26,54,61,87,178,123,104,91,0,72,44,75,39,159,231,73,31,156,141,155,116,91,61,49,251,85,242,53,137,86,40,78,2,89,193,27,120,248,81,151,134,0,91,78,187,78,62,53,35,92,81,95,196,95,250,56,76,98,53,101,122,107,53,108,58,108,108,112,43,114,44,78,173,114,233,72,82,127,59,121,249,124,83,127,106,98,193,52,0,0,75,99,2,128,128,128,18,102,81,105,93,83,100,136,193,137,178,120,160,139,29,141,133,148,120,149,127,149,232,149,15,142,230,151,117,152,206,152,222,152,99,153,16,152,124,156,31,158,196,158,111,107,7,249,55,78,135,0,29,150,55,98,162,148,0,0,59,80,254,109,115,156,166,159,201,61,143,136,78,65,119,112,245,92,32,75,205,81,89,53,48,93,34,97,50,138,167,143,246,145,145,113,25,103,186,115,129,50,7,161,139,60,128,25,16,75,228,120,2,116,174,81,15,135,9,64,99,106,186,162,35,66,15,134,111,10,42,122,71,153,234,138,85,151,77,112,36,83,126,32,244,147,217,118,227,137,167,159,221,119,163,78,240,79,188,80,47,78,23,79,168,159,52,84,139,125,146,88,208,88,182,29,146,94,153,94,194,95,18,39,139,101,249,51,25,105,67,106,99,60,255,108,0,0,0,114,5,69,140,115,219,62,19,74,21,91,185,116,131,139,164,92,149,86,147,122,236,123,195,124,108,126,248,130,151,133,169,159,144,136,170,159,185,142,171,159,207,143,95,133,224,153,33,146,172,159,185,141,63,20,113,64,162,66,26,90,0,0,0,0,0,0,104,152,107,103,118,66,61,87,0,0,214,133,123,73,191,130,13,113,129,76,116,109,123,93,21,107,190,111,173,159,174,159,150,91,175,159,231,102,91,126,87,110,202,121,136,61,195,68,86,50,150,39,154,67,54,69,0,0,213,92,26,59,249,138,120,92,18,61,81,53,120,93,178,159,87,113,88,69,236,64,35,30,119,76,120,57,74,52,164,1,65,108,204,138,180,79,57,2,191,89,108,129,86,152,250,152,59,95,159,11,0,0,193,33,109,137,2,65,187,70,121,144,7,63,179,159,181,161,248,64,214,55,247,70,70,108,124,65,178,134,255,115,109,69,212,56,154,84,97,69,27,69,137,77,123,76,118,77,234,69,200,63,15,75,97,54,222,68,189,68,237,65,62,93,72,93,86,93,252,61,15,56,164,93,185,93,32,56,56,56,66,94,189,94,37,95,131,95,8,57,20,57,63,57,77,57,215,96,61,97,229,92,137,57,183,97,185,97,207,97,184,57,44,98,144,98,229,98,24,99,248,57,177,86,3,58,226,99,251,99,7,100,90,100,75,58,192,100,21,93,33,86,159,159,151,58,134,101,189,58,255,101,83,102,242,58,146,102,34,59,22,103,66,59,164,103,0,104,88,59,74,104,132,104,114,59,113,59,123,59,9,105,67,105,92,114,100,105,159,105,133,105,188,59,214,105,221,59,101,106,116,106,113,106,130,106,236,59,153,106,242,59,171,106,181,106,212,106,246,106,129,107,193,107,234,107,117,108,170,108,203,60,2,109,6,109,38,109,129,109,239,60,164,109,177,109,21,110,24,110,41,110,134,110,192,137,187,110,226,110,218,110,127,159,232,110,233,110,36,111,52,111,70,61,65,63,129,111,190,111,106,61,117,61,183,113,153,92,138,61,44,112,145,61,80,112,84,112,111,112,127,112,137,112,37,3,193,67,241,53,216,14,215,62,190,87,211,110,62,113,224,87,78,54,162,105,233,139,116,91,73,122,225,88,217,148,101,122,125,122,172,89,187,122,176,122,194,122,195,122,209,113,141,100,202,65,218,122,221,122,234,122,239,65,178,84,1,92,11,123,85,123,41,123,14,83,254,92,162,123,111,123,156,131,180,91,127,108,208,123,33,132,146,123,0,0,32,93,173,61,101,92,146,132,250,123,0,0,53,124,193,92,68,124,131,124,130,72,166,124,125,102,120,69,201,124,199,124,230,124,116,124,243,124,245,124,0,0,103,126,29,69,68,110,93,125,214,110,141,116,137,125,171,125,53,113,179,125,0,0,87,64,41,96,228,125,19,61,245,125,249,23,229,125,109,131,0,0,33,97,90,97,110,126,146,126,43,67,108,148,39,126,64,127,65,127,71,127,54,121,208,98,225,153,151,127,81,99,163,127,97,22,104,0,92,69,102,55,3,69,58,131,250,127,137,100,0,0,8,128,29,128,0,0,47,128,135,160,195,108,59,128,60,128,97,128,20,39,137,73,38,102,227,61,232,102,37,103,167,128,72,138,7,129,26,129,176,88,246,38,127,108,152,100,184,79,231,100,138,20,24,130,94,24,83,106,101,74,149,74,122,68,41,130,13,11,82,106,126,61,249,79,253,20,226,132,98,131,10,107,167,73,48,53,115,23,248,61,170,130,27,105,148,249,219,65,75,133,208,130,26,131,22,14,180,23,193,54,125,49,90,53,123,130,226,130,24,131,139,62,163,109,5,107,151,107,206,53,191,61,29,131,236,85,133,131,11,69,165,109,172,131,0,0,211,131,126,52,212,110,87,106,90,133,150,52,66,110,239,46,88,132,228,91,113,132,211,61,228,68,167,106,74,132,181,60,88,121,0,0,150,107,119,110,67,110,222,132,0,0,145,131,160,68,147,132,228,132,145,92,64,66,192,92,67,69,52,133,242,90,153,110,39,69,115,133,22,69,191,103,22,134,37,134,59,134,193,133,136,112,2,134,130,21,205,112,178,249,106,69,40,134,72,54,162,24,247,83,154,115,126,134,113,135,248,160,238,135,39,44,177,135,218,135,15,136,97,86,108,134,86,104,15,70,69,136,70,136,224,117,185,61,228,117,94,136,156,136,91,70,180,136,181,136,193,99,197,136,119,119,15,119,135,137,138,137,0,0,0,0,167,137,188,137,37,138,231,137,36,121,189,122,156,138,147,119,254,145,144,138,89,122,233,122,58,123,143,63,19,71,56,123,124,113,12,139,31,139,48,84,101,85,63,139,76,139,77,139,169,138,122,74,144,139,155,139,175,138,223,22,21,70,79,136,155,140,84,125,143,125,212,249,37,55,83,125,214,140,152,125,189,125,18,141,3,141,16,25,219,140,92,112,17,141,201,76,208,62,0,0,169,141,2,128,20,16,138,73,124,59,188,129,12,113,231,122,173,142,182,142,195,142,212,146,25,143,45,143,101,131,18,132,165,143,3,147,159,162,80,10,179,143,42,73,222,137,61,133,187,61,248,94,98,50,249,143,20,160,188,134,1,133,37,35,128,57,215,110,55,144,60,133,190,122,97,144,108,133,11,134,168,144,19,135,196,144,230,134,174,144,0,0,103,145,240,58,169,145,196,145,172,124,51,137,137,30,14,146,159,108,65,146,98,146,185,85,0,0,198,138,155,60,12,139,219,85,49,13,44,147,107,147,225,138,235,139,143,112,195,90,226,138,229,138,101,73,68,146,236,139,57,140,255,139,115,147,91,148,188,142,133,149,166,149,38,148,160,149,246,111,185,66,122,38,216,134,124,18,46,62,223,73,28,108,123,150,150,150,108,65,163,150,213,110,218,97,182,150,245,120,224,138,189,150,204,83,161,73,184,108,116,2,16,100,175,144,229,144,209,74,21,25,10,51,49,151,66,134,54,151,15,74,61,69,133,69,233,74,117,112,65,91,27,151,0,0,213,145,87,151,74,91,235,145,95,151,37,148,208,80,183,48,188,48,137,151,159,151,177,151,190,151,192,151,210,151,224,151,108,84,238,151,28,116,51,148,0,0,245,151,29,148,122,121,209,74,52,152,51,152,75,152,102,152,14,59,117,113,81,61,48,6,92,65,6,87,202,152,183,152,200,152,199,152,255,74,39,109,211,22,176,85,225,152,230,152,236,152,120,147,57,153,41,74,114,75,87,152,5,153,245,153,12,154,59,154,16,154,88,154,37,87,196,54,177,144,213,155,224,154,226,154,5,155,244,154,14,76,20,155,45,155,0,134,52,80,52,155,168,105,195,56,125,48,80,155,64,155,62,157,69,90,99,24,142,155,75,66,2,156,255,155,12,156,104,158,212,157,183,159,146,161,171,161,225,160,35,161,223,161,126,157,131,157,52,161,14,158,136,104,196,157,91,33,147,161,32,162,59,25,51,162,57,157,185,160,180,162,144,158,149,158,158,158,162,158,52,77,170,158,175,158,100,67,193,158,96,59,229,57,29,61,50,79,190,55,43,140,2,159,8,159,150,75,36,148,162,109,23,159,0,0,57,159,159,86,138,86,69,159,184,153,139,144,242,151,127,132,98,159,105,159,220,122,142,159,22,114,190,75,117,73,187,73,119,113,248,73,72,67,81,74,158,115,218,139,250,24,159,121,126,137,54,142,105,147,243,147,68,138,236,146,129,147,203,147,108,137,185,68,23,114,235,62,114,119,67,122,208,112,115,68,248,67,126,113,239,23,163,112,190,24,153,53,199,62,133,24,47,84,248,23,34,55,251,22,57,24,225,54,116,23,209,24,75,95,35,55,192,22,91,87,37,74,254,19,168,18,198,19,182,20,3,133,166,54,0,0,85,132,148,73,101,113,49,62,92,85,251,62,82,112,244,68,238,54,157,153,38,111,249,103,51,55,21,60,231,61,108,88,34,25,16,104,87,64,63,55,225,64,139,64,15,65,33,108,203,84,158,86,177,102,146,86,223,15,168,11,13,14,198,147,19,139,156,147,248,78,43,81,25,56,54,68,188,78,101,4,127,3,75,79,138,79,81,86,104,90,171,1,203,3,153,57,10,3,20,4,53,52,41,79,192,2,179,142,117,2,218,138,12,2,152,78,205,80,13,81,162,79,3,79,14,74,138,62,66,79,46,80,108,80,129,80,204,79,229,79,88,80,252,80,0,0,0,0,0,0,0,0,118,110,149,53,57,62,191,62,114,109,132,24,137,62,168,81,195,81,224,5,221,68,163,4,146,4,145,4,122,141,156,138,14,7,89,82,164,82,115,8,225,82,0,0,122,70,140,113,140,67,32,12,172,73,228,16,209,105,29,14,0,0,222,62,153,116,20,116,86,116,152,115,142,75,188,74,141,64,208,83,132,53,15,114,201,64,180,85,69,3,205,84,198,11,29,87,93,146,244,150,102,147,221,87,141,87,127,87,62,54,203,88,153,90,70,138,250,22,111,23,16,23,44,90,184,89,143,146,126,90,207,90,18,90,70,89,243,25,97,24,149,66,245,54,5,109,67,116,33,90,131,94,129,90,215,139,19,4,224,147,140,116,3,19,5,113,114,73,8,148,251,137,189,147,160,55,30,92,158,92,94,94,72,94,150,25,124,25,238,58,205,94,79,91,3,25,4,25,1,55,160,24,221,54,254,22,211,54,42,129,71,138,186,29,114,52,168,137,12,95,14,95,39,25,171,23,107,90,59,23,68,91,20,134,253,117,96,136,126,96,96,40,43,38,219,95,184,62,175,37,190,37,136,144,115,111,192,97,62,0,70,0,27,38,153,97,152,97,117,96,155,44,7,45,212,70,77,145,113,100,101,70,106,43,41,58,34,43,80,52,234,152,120,46,55,99,91,164,182,100,49,99,209,99,227,73,103,45,164,98,161,44,59,100,107,101,114,105,244,59,142,48,173,50,137,73,171,50,13,85,224,50,217,24,63,148,206,102,137,50,179,49,224,58,144,65,132,85,34,139,143,85,252,22,91,85,37,84,238,120,3,49,42,24,52,50,100,52,15,50,130,49,201,66,142,102,36,109,107,102,147,75,48,102,112,120,235,29,99,102,210,50,225,50,30,102,114,88,209,56,58,56,188,55,153,59,162,55,254,51,208,116,150,59,143,103,42,70,182,104,30,104,196,59,190,106,99,56,213,55,135,68,51,106,82,106,201,106,5,107,18,25,17,101,152,104,76,106,215,59,122,106,87,107,192,63,154,60,160,147,242,146,234,139,203,138,137,146,30,128,220,137,103,148,165,109,11,111,236,73,0,0,127,63,143,61,4,110,60,64,61,90,10,110,71,88,36,109,66,120,59,113,26,67,118,66,241,112,80,114,135,114,148,114,143,71,37,71,121,81,164,74,235,5,122,116,248,62,95,54,74,74,23,73,225,95,6,63,177,62,223,74,35,140,53,63,167,96,243,62,204,116,60,116,135,147,55,116,159,68,234,109,81,69,131,117,99,63,217,76,6,77,88,63,85,117,115,118,198,165,25,59,104,116,204,138,171,73,142,73,251,58,205,61,78,74,255,62,197,73,243,72,250,145,50,87,66,147,227,138,100,24,223,80,33,82,231,81,120,119,50,50,14,119,15,119,123,119,151,70,129,55,94,58,240,72,56,116,155,116,191,62,186,74,199,74,200,64,150,74,174,97,7,147,129,85,30,120,141,120,136,120,210,120,208,115,89,121,65,119,227,86,14,65,0,0,150,132,165,121,45,106,250,62,58,122,244,121,110,65,230,22,50,65,53,146,241,121,76,13,140,73,153,2,186,61,110,23,151,53,107,85,112,53,170,54,212,1,13,12,226,122,89,90,245,38,175,90,156,90,13,90,91,2,240,120,42,90,198,91,254,122,249,65,93,124,109,124,17,66,179,91,188,94,166,94,205,124,249,73,176,23,142,124,124,124,174,124,178,106,220,125,7,126,211,125,78,127,97,98,92,97,72,123,151,125,130,94,106,66,117,107,22,9,214,103,78,0,207,53,196,87,18,100,248,99,98,73,221,127,39,123,44,8,233,90,67,93,12,123,14,94,230,153,69,134,99,154,28,106,63,52,226,57,247,73,173,101,31,154,160,101,128,132,39,113,209,108,234,68,55,129,2,68,198,128,9,129,66,129,180,103,195,152,66,106,98,130,101,130,81,106,83,132,167,109,16,134,27,114,134,90,127,65,64,24,43,91,161,24,228,90,216,24,160,134,188,249,143,61,45,136,34,116,2,90,110,136,69,79,135,136,191,136,230,136,101,137,77,137,131,86,84,137,133,119,132,119,245,139,217,139,156,139,249,137,173,62,163,132,245,70,207,70,242,55,61,138,28,138,72,148,77,95,43,146,132,66,212,101,41,113,196,112,69,24,109,157,159,140,233,140,220,125,154,89,195,119,240,89,110,67,212,54,42,142,167,142,9,76,48,143,74,143,244,66,88,108,187,111,33,35,155,72,121,111,139,110,218,23,233,155,181,54,47,73,187,144,0,0,113,85,6,73,187,145,4,148,75,138,98,64,252,138,39,148,29,140,59,140,229,132,43,138,153,149,167,149,151,149,150,149,52,141,69,116,194,62,255,72,66,74,234,67,231,62,37,50,143,150,231,142,102,142,101,142,204,62,237,73,120,74,238,63,18,116,107,116,252,62,65,151,176,144,71,104,29,74,147,144,223,87,0,0,104,147,137,137,38,140,47,139,190,99,186,146,17,91,105,139,60,73,249,115,27,66,155,151,113,151,56,153,38,15,193,93,197,139,178,74,31,152,218,148,246,146,215,149,229,145,192,68,80,139,103,74,100,139,220,152,69,138,0,63,42,146,37,73,20,132,59,153,77,153,6,123,253,61,155,153,111,75,170,153,92,154,101,139,200,88,143,106,33,154,254,90,47,154,241,152,144,75,72,153,188,153,189,75,151,75,125,147,114,88,2,19,34,88,184,73,232,20,68,120,31,39,184,61,197,104,125,61,88,148,39,57,80,97,129,39,107,41,7,97,79,156,83,156,123,156,53,156,16,156,127,155,207,155,45,158,159,155,245,161,254,160,33,157,174,76,4,65,24,158,176,76,12,157,180,161,237,160,243,160,47,153,165,157,189,132,18,110,223,111,130,107,252,133,51,69,164,109,132,110,240,109,32,132,238,133,0,110,215,55,100,96,226,121,156,53,64,54,45,73,222,73,98,61,219,147,190,146,72,147,191,2,185,120,119,146,77,148,228,79,64,52,100,144,93,85,61,120,84,120,182,120,75,120,87,23,201,49,65,73,154,54,114,79,218,111,217,111,0,0,30,112,20,84,181,65,187,87,243,88,138,87,22,157,215,87,52,113,175,52,172,65,235,113,64,108,151,79,0,0,181,23,73,138,12,97,206,90,11,90,188,66,136,68,44,55,123,75,252,137,187,147,184,147,214,24,29,15,114,132,192,108,19,20,250,66,38,44,193,67,148,89,183,61,65,103,168,125,91,97,164,96,185,73,139,73,250,137,229,146,226,115,233,62,180,116,99,139,159,24,225,62,179,74,216,106,243,115,251,115,214,62,62,74,148,74,217,23,102,74,167,3,36,20,229,73,72,116,22,73,165,112,118,73,132,146,230,115,95,147,254,4,49,147,206,138,22,138,134,147,231,139,213,85,53,73,130,138,107,113,67,73,255,12,164,86,26,6,235,11,184,12,2,85,196,121,250,23,254,125,194,22,80,74,82,24,46,69,1,148,10,55,192,138,173,73,176,89,191,24,131,24,132,116,161,90,226,54,91,61,176,54,95,146,121,90,129,138,98,24,116,147,205,60,180,10,150,74,138,57,244,80,105,61,76,61,156,19,117,113,251,66,24,130,15,110,228,144,235,68,87,109,79,126,103,112,175,108,214,60,237,63,45,62,2,110,12,111,111,61,245,3,81,117,188,54,200,52,128,70,218,62,113,72,196,89,110,146,62,73,65,143,28,140,192,107,18,88,200,87,214,54,82,20,254,112,98,67,113,74,227,47,176,18,189,35,185,104,103,105,152,19,229,52,244,123,223,54,131,138,214,55,250,51,159,76,26,106,173,54,183,108,62,132,223,68,206,68,38,109,81,109,130,108,222,111,23,111,9,113,61,131,58,23,237,131,128,108,83,112,219,23,137,89,130,90,179,23,97,90,113,90,5,25,252,65,45,55,239,89,60,23,199,54,142,113,144,147,154,102,165,66,110,90,43,90,147,66,43,106,249,62,54,119,91,68,202,66,29,113,89,66,225,137,176,79,40,109,194,92,206,68,77,126,189,67,12,106,86,66,4,19,166,112,51,113,233,67,165,61,223,108,37,248,79,74,101,126,235,89,47,93,243,61,92,95,93,74,223,23,164,125,38,132,133,84,250,58,0,51,20,2,126,87,213,8,25,6,229,63,158,31,182,162,3,112,91,145,112,93,143,115,211,124,89,138,32,148,200,79,231,127,205,114,16,115,244,122,56,115,57,115,246,86,65,115,72,115,169,62,24,123,108,144,245,113,242,72,225,115,246,129,202,62,12,119,209,62,162,108,253,86,25,116,30,116,31,116,226,62,240,62,244,62,250,62,211,116,14,63,83,63,66,117,109,117,114,117,141,117,124,63,200,117,220,117,192,63,77,118,215,63,116,118,220,63,122,118,92,79,136,113,35,86,128,137,105,88,29,64,67,119,57,64,97,103,69,64,219,53,152,119,106,64,111,64,94,92,190,119,203,119,242,88,24,120,185,112,28,120,168,64,57,120,71,120,81,120,102,120,72,132,53,85,51,121,3,104,50,121,3,65,9,65,145,121,153,121,187,143,6,122,188,143,103,65,145,122,178,65,188,122,121,130,196,65,207,122,219,122,207,65,33,78,98,123,108,123,123,123,18,124,27,124,96,66,122,66,123,124,156,124,140,66,184,124,148,66,237,124,147,143,192,112,207,12,207,125,212,125,208,125,253,125,174,127,180,127,159,114,151,67,32,128,37,128,57,123,46,128,49,128,84,128,204,61,180,87,160,112,183,128,233,128,237,67,12,129,42,115,14,129,18,129,96,117,20,129,1,68,57,59,86,129,89,129,90,129,19,68,58,88,124,129,132,129,37,68,147,129,45,68,165,129,239,87,193,129,228,129,84,130,143,68,166,130,118,130,202,130,216,130,255,130,176,68,87,131,105,150,138,105,5,132,245,112,100,132,227,96,136,132,4,69,190,132,225,132,248,132,16,133,56,133,82,133,59,69,111,133,112,133,224,133,119,69,114,134,146,134,178,134,239,134,69,150,139,135,6,70,23,70,174,136,255,136,36,137,71,137,145,137,103,121,41,138,56,138,148,138,180,138,81,140,212,140,242,140,28,141,152,71,95,88,195,141,237,71,238,78,58,142,216,85,84,87,113,142,245,85,176,142,55,72,206,142,226,142,228,142,237,142,242,142,183,143,193,143,202,143,204,143,51,144,196,153,173,72,224,152,19,146,30,73,40,146,88,146,107,146,177,146,174,146,191,146,227,146,235,146,243,146,244,146,253,146,67,147,132,147,173,147,69,73,81,73,191,158,23,148,1,83,29,148,45,148,62,148,106,73,84,148,121,148,45,149,162,149,167,73,244,149,51,150,229,73,160,103,36,74,64,151,53,74,178,151,194,151,84,86,228,74,232,96,185,152,25,75,241,152,68,88,14,153,25,153,180,81,28,153,55,153,66,153,93,153,98,153,112,75,197,153,157,75,60,154,15,155,131,122,105,155,129,155,221,155,241,155,244,155,109,76,32,156,111,55,194,27,73,157,58,156,254,158,80,86,147,157,189,157,192,157,252,157,246,148,182,143,123,158,172,158,177,158,189,158,198,158,220,148,226,158,241,158,248,158,200,122,68,159,148,0,183,2,160,3,26,105,195,148,172,89,215,4,64,88,193,148,185,55,213,5,21,6,118,6,186,22,87,87,115,113,194,10,205,10,191,11,106,84,59,248,203,11,158,84,251,11,59,12,83,12,101,12,124,12,231,96,141,12,122,86,181,12,221,12,237,12,111,13,178,13,200,13,85,105,47,156,165,135,4,14,14,14,215,14,144,15,45,15,115,14,32,92,188,15,11,94,92,16,79,16,118,16,30,103,123,16,136,16,150,16,71,54,191,16,211,16,47,17,59,17,100,83,173,132,227,18,117,19,54,19,129,139,119,21,25,22,195,23,199,23,120,78,187,112,45,24,106,25,45,26,69,26,42,28,112,28,172,28,200,30,195,98,213,30,21,31,152,113,85,104,69,32,233,105,200,54,124,34,215,35,250,35,42,39,113,40,79,41,253,130,103,41,147,41,213,42,165,137,232,42,160,143,14,43,184,151,63,43,71,152,189,154,76,44,0,0,136,44,183,44,232,91,8,45,18,45,183,45,149,45,66,46,116,47,204,47,51,48,102,48,31,51,222,51,177,95,72,102,191,102,121,122,103,53,243,53,0,0,186,73,0,0,26,54,22,55,0,0,70,3,181,88,14,103,24,105,167,58,87,118,226,95,17,62,185,62,254,117,154,32,208,72,184,74,25,65,154,138,238,66,13,67,59,64,52,67,150,67,69,74,202,5,210,81,17,6,159,89,168,30,190,59,255,60,4,68,214,68,136,87,116,70,155,57,47,71,232,133,201,153,98,55,195,33,94,139,78,139,0,0,18,72,251,72,21,74,9,114,192,74,120,12,101,89,165,78,134,79,121,7,218,142,44,80,143,82,63,87,113,113,153,82,25,84,74,63,167,74,188,85,70,84,110,84,82,107,0,0,115,52,63,85,50,118,94,85,24,71,98,85,102,85,199,87,63,73,93,88,102,80,251,52,204,51,0,0,3,89,124,71,72,137,174,90,137,91,6,92,144,29,161,87,81,113,0,0,2,97,18,124,86,144,178,97,154,79,98,139,2,100,74,100,91,93,247,107,0,0,132,100,28,25,234,138,246,73,136,100,239,63,18,101,192,75,191,101,181,102,27,39,101,148,225,87,149,97,39,90,205,248,0,0,185,86,33,69,252,102,106,78,52,73,86,150,143,109,189,108,24,54,119,137,153,103,110,104,17,100,94,104,0,0,199,104,66,123,192,144,17,10,38,105,0,0,57,105,69,122,0,0,250,105,38,154,45,106,95,54,105,100,33,0,131,121,52,106,91,107,44,93,25,53,0,0,157,107,208,70,164,108,59,117,101,136,174,109,182,88,28,55,141,37,75,112,205,113,84,60,128,114,133,114,129,146,122,33,139,114,48,147,230,114,208,73,57,108,159,148,80,116,248,14,39,136,245,136,38,41,115,132,177,23,184,110,42,74,32,24,164,57,185,54,0,0,0,0,63,69,182,102,173,156,164,152,67,137,204,119,88,120,214,86,223,64,10,22,161,57,47,55,232,128,197,19,173,113,102,131,221,121,168,145,0,0,183,76,175,112,171,137,253,121,10,122,11,123,102,125,122,65,67,123,126,121,9,128,181,111,223,162,3,106,24,131,162,83,7,110,191,147,54,104,93,151,111,129,35,128,181,105,237,19,47,50,72,128,133,93,48,140,131,128,21,87,35,152,73,137,171,93,136,73,190,101,213,105,210,83,165,74,129,63,17,60,54,103,144,128,244,128,46,129,161,31,79,129,137,129,175,129,26,130,6,131,47,131,138,131,202,53,104,132,170,134,250,72,230,99,86,137,8,120,85,146,184,137,242,67,231,137,223,67,232,137,70,139,212,139,248,89,9,140,0,0,197,143,236,144,0,0,16,145,60,145,247,61,94,145,202,74,208,143,143,114,139,86,231,148,233,149,176,149,184,149,50,151,209,152,73,153,106,153,195,153,40,154,14,155,90,157,155,157,159,126,248,158,35,159,164,76,71,149,147,162,162,113,255,162,145,77,18,144,203,165,156,77,156,12,190,143,193,85,186,143,176,36,185,143,147,74,9,69,127,126,86,111,177,106,234,78,228,52,44,139,157,120,58,55,128,142,245,23,36,128,108,139,153,139,62,122,175,102,235,61,85,118,183,60,53,86,86,89,154,78,129,94,88,98,191,86,109,14,14,142,109,91,136,62,158,76,222,99,0,0,246,23,123,24,48,101,45,86,74,92,26,84,17,83,198,61,152,157,125,76,34,86,30,86,73,127,216,94,117,89,64,61,112,135,28,78,234,15,73,13,186,54,23,129,94,157,24,141,59,118,69,156,78,118,185,119,69,147,50,84,72,129,247,130,37,86,50,129,24,132,189,128,234,85,98,121,67,86,22,84,157,14,206,53,5,86,241,85,241,102,226,130,45,54,52,117,240,85,186,85,151,84,114,85,65,12,150,12,208,94,72,81,118,14,98,44,162,14,171,158,90,125,222,85,117,16,157,98,109,151,148,84,205,140,246,113,118,145,252,99,185,99,254,99,105,85,67,43,114,156,179,46,154,81,223,52,167,13,167,81,77,84,30,85,19,85,102,118,45,142,138,104,177,117,182,128,4,136,134,135,199,136,182,129,28,132,193,16,236,68,4,115,6,71,144,91,11,131,147,104,123,86,244,38,47,125,163,65,115,125,208,110,182,114,112,145,217,17,8,146,252,60,169,166,172,14,249,14,102,114,162,28,78,71,194,79,249,127,235,15,250,64,93,156,31,101,160,45,243,72,224,71,124,157,236,15,10,14,0,0,163,117,237,15,0,0,72,96,135,17,163,113,142,126,80,157,26,78,4,78,119,53,13,91,178,108,103,83,172,54,220,57,125,83,165,54,24,70,154,88,110,75,45,130,75,84,170,87,149,90,121,9,0,0,82,58,101,36,116,115,172,158,9,77,237,155,254,60,48,159,91,76,169,79,158,149,222,159,92,132,182,61,178,114,179,103,32,55,46,99,37,125,247,62,44,62,42,58,8,144,204,82,116,62,122,54,233,69,142,4,64,118,240,90,182,14,122,120,46,127,167,88,191,64,124,86,139,155,116,93,84,118,52,164,133,158,225,76,0,0,251,55,25,97,218,48,242,67,0,0,93,86,169,18,167,87,99,73,6,158,52,82,174,112,173,53,0,0,124,157,86,124,57,155,222,87,108,23,83,92,211,100,208,148,53,99,100,113,173,134,40,13,34,109,226,74,113,13,0,0,254,81,15,31,142,93,3,151,209,29,129,158,76,144,31,123,2,155,209,92,163,123,104,98,53,99,255,154,207,123,42,155,126,124,0,0,66,124,134,124,21,156,252,123,9,155,0,0,27,156,62,73,90,159,115,85,195,91,253,79,152,158,242,79,96,82,6,62,209,82,103,87,86,80,183,89,18,94,200,151,171,157,92,143,105,84,180,151,64,153,186,151,44,83,48,97,44,105,218,83,10,156,2,157,59,76,65,150,128,105,166,80,70,117,109,23,218,153,115,82,0,0,89,145,129,150,92,145,0,0,81,145,151,142,127,99,35,109,202,106,17,86,142,145,122,117,133,98,252,3,79,115,112,124,33,92,253,60,0,0,25,73,214,118,157,155,42,78,212,12,190,131,66,136,0,0,74,92,192,105,0,0,122,87,31,82,245,93,206,78,49,108,242,1,57,79,156,84,218,84,154,82,130,141,254,53,0,0,243,53,0,0,82,107,124,145,165,159,151,155,46,152,180,152,186,154,168,158,132,158,122,113,20,123,0,0,250,107,24,136,120,127,0,0,32,86,74,166,119,142,83,159,0,0,212,141,79,142,28,158,1,142,130,98,125,131,40,142,117,142,211,122,119,74,62,122,216,120,234,108,103,138,7,118,90,138,38,159,206,108,214,135,195,117,178,162,83,120,64,248,12,141,226,114,113,115,45,139,2,115,241,116,235,140,187,74,47,134,186,95,160,136,183,68,0,0,59,24,5,110,0,0,126,138,27,37,0,0,253,96,103,118,215,154,68,157,110,147,143,155,245,135,0,0,0,0,247,140,44,115,33,151,176,155,214,53,178,114,7,76,81,124,74,153,89,97,89,97,4,76,150,158,125,97,0,0,95,87,111,97,166,98,57,98,0,0,92,58,226,97,170,83,245,51,100,99,2,104,210,53,87,93,194,139,218,143,57,142,0,0,217,80,70,29,6,121,50,83,56,150,59,15,101,64,0,0,254,119,0,0,194,124,26,95,218,124,45,122,102,128,99,128,77,125,5,117,242,116,148,137,26,130,12,103,98,128,134,116,91,128,240,116,3,129,36,119,137,137,204,103,83,117,209,110,169,135,206,135,200,129,140,135,73,138,173,140,67,139,43,119,248,116,218,132,53,54,178,105,166,141,0,0,169,137,0,0,185,109,193,135,17,64,231,116,219,61,118,113,164,96,156,97,209,60,0,0,119,96,0,0,113,127,45,139,0,0,233,96,126,75,32,82,24,60,199,60,215,94,86,118,49,85,68,25,254,18,3,153,220,109,173,112,193,92,173,97,15,138,119,54,238,0,70,104,14,79,98,69,31,91,76,99,80,159,166,158,107,98,71,5,219,146,223,5,197,63,76,133,181,66,239,115,181,81,73,54,66,73,228,137,68,147,219,25,238,130,200,60,60,120,68,103,223,98,51,73,170,137,160,2,179,107,5,19,171,79,237,36,8,80,41,109,132,122,0,54,177,74,19,37,0,0,126,3,164,95,128,3,71,3,219,110,31,4,0,0,1,81,122,52,14,81,108,152,67,55,22,132,164,73,135,4,96,81,180,51,106,81,255,11,252,32,229,2,48,37,142,5,51,50,131,25,130,91,125,135,179,5,153,60,178,81,184,81,52,157,201,81,207,81,209,81,220,60,211,81,166,74,179,81,226,81,66,83,237,81,205,131,62,105,45,55,123,95,11,82,38,82,60,82,181,82,87,82,148,82,185,82,197,82,21,124,66,133,224,82,13,134,19,107,0,0,222,138,73,85,217,110,128,63,84,9,236,63,51,83,0,0,226,11,203,108,38,23,27,104,213,115,74,96,170,62,204,56,232,22,221,113,162,68,109,83,116,83,171,134,126,83,0,0,150,21,19,22,230,119,147,83,155,138,160,83,171,83,174,83,167,115,114,87,89,63,156,115,193,83,197,83,73,108,73,78,254,87,217,83,171,58,143,11,224,83,235,63,163,45,246,83,119,12,19,84,121,112,43,85,87,102,91,109,109,84,83,107,116,13,93,85,143,84,164,84,166,71,13,23,221,14,180,61,77,13,188,137,152,38,71,85,237,76,47,84,23,116,134,85,169,85,0,0,215,24,58,64,82,69,53,68,179,102,180,16,55,86,205,102,138,50,164,102,173,102,77,86,79,86,241,120,241,86,135,151,254,83,0,87,239,86,237,86,102,139,35,54,79,18,70,87,165,65,110,108,139,112,66,87,177,54,126,108,230,87,22,20,3,88,84,20,99,67,38,88,245,75,92,88,170,88,97,53,224,88,220,88,60,18,251,88,255,91,67,87,80,161,120,66,211,147,161,53,31,89,166,104,195,54,89,110,62,22,36,90,83,85,146,22,5,133,201,89,78,13,129,108,42,109,220,23,217,89,251,23,178,23,166,109,113,109,40,24,213,22,249,89,69,110,171,90,99,90,230,54,169,73,0,0,8,55,150,90,101,116,211,90,161,111,84,37,133,61,17,25,50,55,184,22,131,94,208,82,118,91,136,101,124,91,14,122,4,64,93,72,4,2,213,91,96,97,52,26,204,89,165,5,243,91,157,91,16,77,5,92,68,27,19,92,206,115,20,92,165,28,40,107,73,92,221,72,133,92,233,92,239,92,139,93,249,29,55,30,16,93,24,93,70,93,164,30,186,92,215,93,252,130,45,56,1,73,73,32,115,33,135,130,54,56,194,59,46,94,138,106,0,0,122,94,188,68,211,12,166,83,183,78,0,0,168,83,113,23,9,94,244,94,130,132,249,94,251,94,160,56,252,94,62,104,27,148,13,95,193,1,148,248,222,58,174,72,58,19,58,95,136,104,208,35,0,0,113,36,99,95,189,151,110,110,114,95,64,147,54,138,167,95,182,93,95,61,80,82,106,31,248,112,104,38,214,145,158,2,41,138,49,96,133,102,119,24,99,57,199,61,57,54,144,87,180,39,113,121,64,62,158,96,0,0,179,96,130,73,143,73,83,122,164,116,225,80,160,90,100,97,36,132,66,97,166,248,210,110,129,97,244,81,86,6,135,97,170,91,183,63,95,40,211,97,157,139,93,153,208,97,50,57,128,41,193,40,35,96,92,97,30,101,139,99,24,1,197,98,112,23,213,98,13,46,108,99,223,73,23,58,56,100,248,99,142,19,252,23,0,0,138,111,54,46,20,152,140,64,29,87,225,100,229,100,123,148,102,58,58,100,87,58,77,101,22,111,40,74,35,74,133,101,109,101,95,101,126,48,181,101,64,73,55,75,209,101,216,64,41,24,224,101,227,101,223,95,0,52,24,102,247,49,248,49,68,102,164,49,165,49,75,102,117,14,103,102,230,81,115,102,0,0,61,30,49,50,244,133,200,49,19,83,197,119,247,40,164,153,2,103,156,67,33,74,43,59,250,105,194,55,0,0,103,103,98,103,205,65,237,144,215,103,233,68,34,104,80,110,60,146,1,104,230,51,160,109,93,104,111,52,225,105,11,106,223,138,115,105,195,104,205,53,1,105,0,105,50,61,1,58,60,54,128,59,172,103,97,105,74,138,252,66,54,105,152,105,161,59,201,3,99,131,144,80,249,105,89,54,42,33,69,106,3,55,157,106,243,59,177,103,200,106,156,145,13,60,29,107,35,9,222,96,53,107,116,107,205,39,181,110,219,58,181,3,88,25,64,55,33,84,90,59,225,107,252,62,220,107,55,108,139,36,241,72,81,107,90,108,38,130,121,108,188,61,197,68,189,61,164,65,12,73,0,73,201,60,229,54,235,60,50,13,131,155,249,49,145,36,143,127,55,104,37,109,161,109,235,109,150,109,92,109,124,110,4,111,127,73,133,64,114,110,51,133,116,111,199,81,0,0,0,0,46,132,33,139,0,0,47,62,83,116,130,63,204,121,79,110,145,90,75,48,248,111,13,55,157,111,48,62,250,110,151,20,61,64,85,69,240,147,68,111,92,111,78,61,116,111,112,145,59,61,159,111,68,65,211,111,145,64,85,65,57,64,240,63,180,63,63,65,223,81,86,65,87,65,64,65,221,97,75,112,126,112,167,112,129,112,204,112,213,112,214,112,223,112,4,65,232,61,180,113,150,113,119,66,43,113,69,113,136,90,74,113,0,0,156,92,101,67,79,113,98,147,193,66,44,113,90,68,39,74,34,74,186,113,232,139,189,112,14,114,66,148,21,114,17,89,67,148,36,114,65,147,5,86,46,114,64,114,116,73,189,104,85,114,87,114,85,62,68,48,13,104,61,111,130,114,0,0,43,115,35,72,43,136,237,72,4,136,40,115,46,115,207,115,170,115,58,12,46,106,201,115,73,116,226,65,231,22,36,74,35,102,197,54,183,73,141,73,251,73,247,115,21,116,3,105,38,74,57,116,195,5,215,62,0,0,173,40,96,116,178,142,71,116,228,115,118,116,185,131,108,116,48,55,116,116,241,147,44,106,130,116,83,73,140,74,95,65,121,74,143,139,70,91,3,140,158,24,200,116,136,25,14,117,0,0,30,117,217,142,75,26,215,91,172,142,133,147,77,117,74,117,103,117,110,117,130,79,4,63,19,77,142,117,93,116,158,117,180,117,2,118,44,118,81,118,79,118,111,118,118,118,245,99,144,118,239,129,248,55,17,105,14,105,161,118,165,118,183,118,204,118,159,111,98,132,157,80,125,81,28,30,30,119,38,119,64,119,175,100,32,82,88,119,172,50,175,119,100,137,104,137,193,22,244,119,0,0,118,19,18,74,202,104,175,120,199,120,211,120,165,150,46,121,224,85,215,120,52,121,177,120,12,118,184,143,132,136,43,139,131,96,28,38,134,121,0,137,2,105,128,121,87,88,157,121,57,123,60,121,169,121,42,110,38,113,168,62,198,121,13,145,212,121,32,5,95,68,15,82,130,184,248,0,0,64,32,169,78,4,0,0,0,0,52,11,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,64,0,0,0,0,0,0,0,0,4,88,0,60,0,0,0,0,0,128,92,173,220,243,187,201,67,238,237,164,15,38,193,155,118,242,239,222,251,250,247,15,50,68,175,254,239,253,254,17,96,176,0,0,33,25,129,32,16,136,168,96,33,105,36,0,68,137,196,0,0,3,64,53,0,67,132,49,81,147,104,2,2,0,0,0,0,0,0,0,0,0,0,0,64,0,1,128,172,100,130,64,140,161,144,4,80,96,212,0,210,42,24,157,104,53,151,79,216,248,32,196,130,28,40,130,117,148,2,56,64,160,161,197,16,113,77,196,13,152,185,94,91,1,67,159,153,3,120,32,226,31,8,137,1,201,64,7,3,13,154,144,82,209,79,124,3,2,33,32,192,110,19,131,181,219,245,229,119,144,79,23,154,54,23,12,0,110,186,9,47,96,84,0,30,120,104,34,112,86,158,37,243,142,183,23,11,239,230,119,23,91,27,193,16,152,141,18,24,182,207,1,49,114,26,91,44,182,192,32,226,195,92,130,27,224,218,206,133,214,64,169,84,11,208,15,72,68,64,16,9,212,64,174,59,100,30,68,43,23,8,134,130,54,24,160,137,231,156,91,8,132,3,2,218,144,236,219,135,133,191,162,173,157,142,157,152,32,37,70,0,70,159,127,227,213,201,132,244,214,77,6,227,182,24,18,9,0,0,0,4,0,0,32,0,0,0,0,2,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,142,120,110,95,63,126,221,61,247,252,155,252,174,210,255,143,107,241,231,191,186,174,110,23,239,220,167,62,182,181,119,201,146,215,165,182,74,110,155,185,129,77,103,254,84,241,155,98,254,111,82,215,54,254,191,41,69,129,249,189,101,166,66,57,0,0,66,96,143,0,148,64,64,210,175,215,209,219,0,160,152,178,123,6,82,32,152,22,200,61,9,0,0,1,0,0,0,1,10,178,8,128,0,0,0,4,136,32,20,16,76,0,0,4,0,161,68,16,0,65,1,0,8,64,240,223,79,54,88,241,245,181,128,245,103,128,64,0,80,78,65,200,132,0,90,96,216,1,43,1,80,161,22,196,64,242,110,17,172,32,57,196,192,8,7,12,9,152,150,196,155,16,28,152,108,134,42,166,1,70,17,109,229,203,196,192,146,16,33,22,18,157,114,244,105,14,23,42,162,129,244,123,0,8,164,11,144,16,44,204,57,74,1,240,22,11,10,64,12,29,234,12,68,14,69,2,0,8,4,4,8,4,4,8,2,4,0,0,0,0,0,0,0,195,138,204,132,195,138,204,140,195,170,204,132,195,170,204,140,0,0,0,0,0,0,0,0,0,48,12,255,1,48,2,48,14,255,39,32,27,255,26,255,31,255,1,255,48,254,38,32,37,32,80,254,81,254,82,254,183,0,84,254,85,254,86,254,87,254,92,255,19,32,49,254,20,32,51,254,116,37,52,254,79,254,8,255,9,255,53,254,54,254,91,255,93,255,55,254,56,254,20,48,21,48,57,254,58,254,16,48,17,48,59,254,60,254,10,48,11,48,61,254,62,254,8,48,9,48,63,254,64,254,12,48,13,48,65,254,66,254,14,48,15,48,67,254,68,254,89,254,90,254,91,254,92,254,93,254,94,254,24,32,25,32,28,32,29,32,29,48,30,48,53,32,50,32,3,255,6,255,10,255,59,32,167,0,3,48,203,37,207,37,179,37,178,37,206,37,6,38,5,38,199,37,198,37,161,37,160,37,189,37,188,37,163,50,5,33,175,0,227,255,63,255,205,2,73,254,74,254,77,254,78,254,75,254,76,254,95,254,96,254,97,254,11,255,13,255,215,0,247,0,177,0,26,34,28,255,30,255,29,255,102,34,103,34,96,34,30,34,82,34,97,34,98,254,99,254,100,254,101,254,102,254,94,255,41,34,42,34,165,34,32,34,31,34,191,34,210,51,209,51,43,34,46,34,53,34,52,34,64,38,66,38,149,34,153,34,145,33,147,33,144,33,146,33,150,33,151,33,153,33,152,33,37,34,35,34,15,255,60,255,21,34,104,254,4,255,229,255,18,48,224,255,225,255,5,255,32,255,3,33,9,33,105,254,106,254,107,254,213,51,156,51,157,51,158,51,206,51,161,51,142,51,143,51,196,51,176,0,89,81,91,81,94,81,93,81,97,81,99,81,231,85,233,116,206,124,129,37,130,37,131,37,132,37,133,37,134,37,135,37,136,37,143,37,142,37,141,37,140,37,139,37,138,37,137,37,60,37,52,37,44,37,36,37,28,37,148,37,0,37,2,37,149,37,12,37,16,37,20,37,24,37,109,37,110,37,112,37,111,37,80,37,94,37,106,37,97,37,226,37,227,37,229,37,228,37,113,37,114,37,115,37,16,255,17,255,18,255,19,255,20,255,21,255,22,255,23,255],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+271588),
allocate([24,255,25,255,96,33,97,33,98,33,99,33,100,33,101,33,102,33,103,33,104,33,105,33,33,48,34,48,35,48,36,48,37,48,38,48,39,48,40,48,41,48,65,83,68,83,69,83,33,255,34,255,35,255,36,255,37,255,38,255,39,255,40,255,41,255,42,255,43,255,44,255,45,255,46,255,47,255,48,255,49,255,50,255,51,255,52,255,53,255,54,255,55,255,56,255,57,255,58,255,65,255,66,255,67,255,68,255,69,255,70,255,71,255,72,255,73,255,74,255,75,255,76,255,77,255,78,255,79,255,80,255,81,255,82,255,83,255,84,255,85,255,86,255,87,255,88,255,89,255,90,255,145,3,146,3,147,3,148,3,149,3,150,3,151,3,152,3,153,3,154,3,155,3,156,3,157,3,158,3,159,3,160,3,161,3,163,3,164,3,165,3,166,3,167,3,168,3,169,3,177,3,178,3,179,3,180,3,181,3,182,3,183,3,184,3,185,3,186,3,187,3,188,3,189,3,190,3,191,3,192,3,193,3,195,3,196,3,197,3,198,3,199,3,200,3,201,3,5,49,6,49,7,49,8,49,9,49,10,49,11,49,12,49,13,49,14,49,15,49,16,49,17,49,18,49,19,49,20,49,21,49,22,49,23,49,24,49,25,49,26,49,27,49,28,49,29,49,30,49,31,49,32,49,33,49,34,49,35,49,36,49,37,49,38,49,39,49,40,49,41,49,217,2,201,2,202,2,199,2,203,2,0,36,1,36,2,36,3,36,4,36,5,36,6,36,7,36,8,36,9,36,10,36,11,36,12,36,13,36,14,36,15,36,16,36,17,36,18,36,19,36,20,36,21,36,22,36,23,36,24,36,25,36,26,36,27,36,28,36,29,36,30,36,31,36,33,36,172,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,78,89,78,1,78,3,78,67,78,93,78,134,78,140,78,186,78,63,81,101,81,107,81,224,81,0,82,1,82,155,82,21,83,65,83,92,83,200,83,9,78,11,78,8,78,10,78,43,78,56,78,225,81,69,78,72,78,95,78,94,78,142,78,161,78,64,81,3,82,250,82,67,83,201,83,227,83,31,87,235,88,21,89,39,89,115,89,80,91,81,91,83,91,248,91,15,92,34,92,56,92,113,92,221,93,229,93,241,93,242,93,243,93,254,93,114,94,254,94,11,95,19,95,77,98,17,78,16,78,13,78,45,78,48,78,57,78,75,78,57,92,136,78,145,78,149,78,146,78,148,78,162,78,193,78,192,78,195,78,198,78,199,78,205,78,202,78,203,78,196,78,67,81,65,81,103,81,109,81,110,81,108,81,151,81,246,81,6,82,7,82,8,82,251,82,254,82,255,82,22,83,57,83,72,83,71,83,69,83,94,83,132,83,203,83,202,83,205,83,236,88,41,89,43,89,42,89,45,89,84,91,17,92,36,92,58,92,111,92,244,93,123,94,255,94,20,95,21,95,195,95,8,98,54,98,75,98,78,98,47,101,135,101,151,101,164,101,185,101,229,101,240,102,8,103,40,103,32,107,98,107,121,107,203,107,212,107,219,107,15,108,52,108,107,112,42,114,54,114,59,114,71,114,89,114,91,114,172,114,139,115,25,78,22,78,21,78,20,78,24,78,59,78,77,78,79,78,78,78,229,78,216,78,212,78,213,78,214,78,215,78,227,78,228,78,217,78,222,78,69,81,68,81,137,81,138,81,172,81,249,81,250,81,248,81,10,82,160,82,159,82,5,83,6,83,23,83,29,83,223,78,74,83,73,83,97,83,96,83,111,83,110,83,187,83,239,83,228,83,243,83,236,83,238,83,233,83,232,83,252,83,248,83,245,83,235,83,230,83,234,83,242,83,241,83,240,83,229,83,237,83,251,83,219,86,218,86,22,89,46,89,49,89,116,89,118,89,85,91,131,91,60,92,232,93,231,93,230,93,2,94,3,94,115,94,124,94,1,95,24,95,23,95,197,95,10,98,83,98,84,98,82,98,81,98,165,101,230,101,46,103,44,103,42,103,43,103,45,103,99,107,205,107,17,108,16,108,56,108,65,108,64,108,62,108,175,114,132,115,137,115,220,116,230,116,24,117,31,117,40,117,41,117,48,117,49,117,50,117,51,117,139,117,125,118,174,118,191,118,238,118,219,119,226,119,243,119,58,121,190,121,116,122,203,122,30,78,31,78,82,78,83,78,105,78,153,78,164,78,166,78,165,78,255,78,9,79,25,79,10,79,21,79,13,79,16,79,17,79,15,79,242,78,246,78,251,78,240,78,243,78,253,78,1,79,11,79,73,81,71,81,70,81,72,81,104,81,113,81,141,81,176,81,23,82,17,82,18,82,14,82,22,82,163,82,8,83,33,83,32,83,112,83,113,83,9,84,15,84,12,84,10,84,16,84,1,84,11,84,4,84,17,84,13,84,8,84,3,84,14,84,6,84,18,84,224,86,222,86,221,86,51,87,48,87,40,87,45,87,44,87,47,87,41,87,25,89,26,89,55,89,56,89,132,89,120,89,131,89,125,89,121,89,130,89,129,89,87,91,88,91,135,91,136,91,133,91,137,91,250,91,22,92,121,92,222,93,6,94,118,94,116,94,15,95,27,95,217,95,214,95,14,98,12,98,13,98,16,98,99,98,91,98,88,98,54,101,233,101,232,101,236,101,237,101,242,102,243,102,9,103,61,103,52,103,49,103,53,103,33,107,100,107,123,107,22,108,93,108,87,108,89,108,95,108,96,108,80,108,85,108,97,108,91,108,77,108,78,108,112,112,95,114,93,114,126,118,249,122,115,124,248,124,54,127,138,127,189,127,1,128,3,128,12,128,18,128,51,128,127,128,137,128,139,128,140,128,227,129,234,129,243,129,252,129,12,130,27,130,31,130,110,130,114,130,126,130,107,134,64,136,76,136,99,136,127,137,33,150,50,78,168,78,77,79,79,79,71,79,87,79,94,79,52,79,91,79,85,79,48,79,80,79,81,79,61,79,58,79,56,79,67,79,84,79,60,79,70,79,99,79,92,79,96,79,47,79,78,79,54,79,89,79,93,79,72,79,90,79,76,81,75,81,77,81,117,81,182,81,183,81,37,82,36,82,41,82,42,82,40,82,171,82,169,82,170,82,172,82,35,83,115,83,117,83,29,84,45,84,30,84,62,84,38,84,78,84,39,84,70,84,67,84,51,84,72,84,66,84,27,84,41,84,74,84,57,84,59,84,56,84,46,84,53,84,54,84,32,84,60,84,64,84,49,84,43,84,31,84,44,84,234,86,240,86,228,86,235,86,74,87,81,87,64,87,77,87,71,87,78,87,62,87,80,87,79,87,59,87,239,88,62,89,157,89,146,89,168,89,158,89,163,89,153,89,150,89,141,89,164,89,147,89,138,89,165,89,93,91,92,91,90,91,91,91,140,91,139,91,143,91,44,92,64,92,65,92,63,92,62,92,144,92,145,92,148,92,140,92,235,93,12,94,143,94,135,94,138,94,247,94,4,95,31,95,100,95,98,95,119,95,121,95,216,95,204,95,215,95,205,95,241,95,235,95,248,95,234,95,18,98,17,98,132,98,151,98,150,98,128,98,118,98,137,98,109,98,138,98,124,98,126,98,121,98,115,98,146,98,111,98,152,98,110,98,149,98,147,98,145,98,134,98,57,101,59,101,56,101,241,101,244,102,95,103,78,103,79,103,80,103,81,103,92,103,86,103,94,103,73,103,70,103,96,103,83,103,87,103,101,107,207,107,66,108,94,108,153,108,129,108,136,108,137,108,133,108,155,108,106,108,122,108,144,108,112,108,140,108,104,108,150,108,146,108,125,108,131,108,114,108,126,108,116,108,134,108,118,108,141,108,148,108,152,108,130,108,118,112,124,112,125,112,120,112,98,114,97,114,96,114,196,114,194,114,150,115,44,117,43,117,55,117,56,117,130,118,239,118,227,119,193,121,192,121,191,121,118,122,251,124,85,127,150,128,147,128,157,128,152,128,155,128,154,128,178,128,111,130,146,130,139,130,141,130,139,137,210,137,0,138,55,140,70,140,85,140,157,140,100,141,112,141,179,141,171,142,202,142,155,143,176,143,194,143,198,143,197,143,196,143,225,93,145,144,162,144,170,144,166,144,163,144,73,145,198,145,204,145,50,150,46,150,49,150,42,150,44,150,38,78,86,78,115,78,139,78,155,78,158,78,171,78,172,78,111,79,157,79,141,79,115,79,127,79,108,79,155,79,139,79,134,79,131,79,112,79,117,79,136,79,105,79,123,79,150,79,126,79,143,79,145,79,122,79,84,81,82,81,85,81,105,81,119,81,118,81,120,81,189,81,253,81,59,82,56,82,55,82,58,82,48,82,46,82,54,82,65,82,190,82,187,82,82,83,84,83,83,83,81,83,102,83,119,83,120,83,121,83,214,83,212,83,215,83,115,84,117,84,150,84,120,84,149,84,128,84,123,84,119,84,132,84,146,84,134,84,124,84,144,84,113,84,118,84,140,84,154,84,98,84,104,84,139,84,125,84,142,84,250,86,131,87,119,87,106,87,105,87,97,87,102,87,100,87,124,87,28,89,73,89,71,89,72,89,68,89,84,89,190,89,187,89,212,89,185,89,174,89,209,89,198,89,208,89,205,89,203,89,211,89,202,89,175,89,179,89,210,89,197,89,95,91,100,91,99,91,151,91,154,91,152,91,156,91,153,91,155,91,26,92,72,92,69,92,70,92,183,92,161,92,184,92,169,92,171,92,177,92,179,92,24,94,26,94,22,94,21,94,27,94,17,94,120,94,154,94,151,94,156,94,149,94,150,94,246,94,38,95,39,95,41,95,128,95,129,95,127,95,124,95,221,95,224,95,253,95,245,95,255,95,15,96,20,96,47,96,53,96,22,96,42,96,21,96,33,96,39,96,41,96,43,96,27,96,22,98,21,98,63,98,62,98,64,98,127,98,201,98,204,98,196,98,191,98,194,98,185,98,210,98,219,98,171,98,211,98,212,98,203,98,200,98,168,98,189,98,188,98,208,98,217,98,199,98,205,98,181,98,218,98,177,98,216,98,214,98,215,98,198,98,172,98,206,98,62,101,167,101,188,101,250,101,20,102,19,102,12,102,6,102,2,102,14,102,0,102,15,102,21,102,10,102,7,102,13,103,11,103,109,103,139,103,149,103,113,103,156,103,115,103,119,103,135,103,157,103,151,103,111,103,112,103,127,103,137,103,126,103,144,103,117,103,154,103,147,103,124,103,106,103,114,103,35,107,102,107,103,107,127,107,19,108,27,108,227,108,232,108,243,108,177,108,204,108,229,108,179,108,189,108,190,108,188,108,226,108,171,108,213,108,211,108,184,108,196,108,185,108,193,108,174,108,215,108,197,108,241,108,191,108,187,108,225,108,219,108,202,108,172,108,239,108,220,108,214,108,224,108,149,112,142,112,146,112,138,112,153,112,44,114,45,114,56,114,72,114,103,114,105,114,192,114,206,114,217,114,215,114,208,114,169,115,168,115,159,115,171,115,165,115,61,117,157,117,153,117,154,117,132,118,194,118,242,118,244,118,229,119,253,119,62,121,64,121,65,121,201,121,200,121,122,122,121,122,250,122,254,124,84,127,140,127,139,127,5,128,186,128,165,128,162,128,177,128,161,128,171,128,169,128,180,128,170,128,175,128,229,129,254,129,13,130,179,130,157,130,153,130,173,130,189,130,159,130,185,130,177,130,172,130,165,130,175,130,184,130,163,130,176,130,190,130,183,130,78,134,113,134,29,82,104,136,203,142,206,143,212,143,209,143,181,144,184,144,177,144,182,144,199,145,209,145,119,149,128,149,28,150,64,150,63,150,59,150,68,150,66,150,185,150,232,150,82,151,94,151,159,78,173,78,174,78,225,79,181,79,175,79,191,79,224,79,209,79,207,79,221,79,195,79,182,79,216,79,223,79,202,79,215,79,174,79,208,79,196,79,194,79,218,79,206,79,222,79,183,79,87,81,146,81,145,81,160,81,78,82,67,82,74,82,77,82,76,82,75,82,71,82,199,82,201,82,195,82,193,82,13,83,87,83,123,83,154,83,219,83,172,84,192,84,168,84,206,84,201,84,184,84,166,84,179,84,199,84,194,84,189,84,170,84,193,84,196,84,200,84,175,84,171,84,177,84,187,84,169,84,167,84,191,84,255,86,130,87,139,87,160,87,163,87,162,87,206,87,174,87,147,87,85,89,81,89,79,89,78,89,80,89,220,89,216,89,255,89,227,89,232,89,3,90,229,89,234,89,218,89,230,89,1,90,251,89,105,91,163,91,166,91,164,91,162,91,165,91,1,92,78,92,79,92,77,92,75,92,217,92,210,92,247,93,29,94,37,94,31,94,125,94,160,94,166,94,250,94,8,95,45,95,101,95,136,95,133,95,138,95,139,95,135,95,140,95,137,95,18,96,29,96,32,96,37,96,14,96,40,96,77,96,112,96,104,96,98,96,70,96,67,96,108,96,107,96,106,96,100,96,65,98,220,98,22,99,9,99,252,98,237,98,1,99,238,98,253,98,7,99,241,98,247,98,239,98,236,98,254,98,244,98,17,99,2,99,63,101,69,101,171,101,189,101,226,101,37,102,45,102,32,102,39,102,47,102,31,102,40,102,49,102,36,102,247,102,255,103,211,103,241,103,212,103,208,103,236,103,182,103,175,103,245,103,233,103,239,103,196,103,209,103,180,103,218,103,229,103,184,103,207,103,222,103,243,103,176,103,217,103,226,103,221,103,210,103,106,107,131,107,134,107,181,107,210,107,215,107,31,108,201,108,11,109,50,109,42,109,65,109,37,109,12,109,49,109,30,109,23,109,59,109,61,109,62,109,54,109,27,109,245,108,57,109,39,109,56,109,41,109,46,109,53,109,14,109,43,109,171,112,186,112,179,112,172,112,175,112,173,112,184,112,174,112,164,112,48,114,114,114,111,114,116,114,233,114,224,114,225,114,183,115,202,115,187,115,178,115,205,115,192,115,179,115,26,117,45,117,79,117,76,117,78,117,75,117,171,117,164,117,165,117,162,117,163,117,120,118,134,118,135,118,136,118,200,118,198,118,195,118,197,118,1,119,249,118,248,118,9,119,11,119,254,118,252,118,7,119,220,119,2,120,20,120,12,120,13,120,70,121,73,121,72,121,71,121,185,121,186,121,209,121,210,121,203,121,127,122,129,122,255,122,253,122,125,124,2,125,5,125,0,125,9,125,7,125,4,125,6,125,56,127,142,127,191,127,4,128,16,128,13,128,17,128,54,128,214,128,229,128,218,128,195,128,196,128,204,128,225,128,219,128,206,128,222,128,228,128,221,128,244,129,34,130,231,130,3,131,5,131,227,130,219,130,230,130,4,131,229,130,2,131,9,131,210,130,215,130,241,130,1,131,220,130,212,130,209,130,222,130,211,130,223,130,239,130,6,131,80,134,121,134,123,134,122,134,77,136,107,136,129,137,212,137,8,138,2,138,3,138,158,140,160,140,116,141,115,141,180,141,205,142,204,142,240,143,230,143,226,143,234,143,229,143,237,143,235,143,228,143,232,143,202,144,206,144,193,144,195,144,75,145,74,145,205,145,130,149,80,150,75,150,76,150,77,150,98,151,105,151,203,151,237,151,243,151,1,152,168,152,219,152,223,152,150,153,153,153,88,78,179,78,12,80,13,80,35,80,239,79,38,80,37,80,248,79,41,80,22,80,6,80,60,80,31,80,26,80,18,80,17,80,250,79,0,80,20,80,40,80,241,79,33,80,11,80,25,80,24,80,243,79,238,79,45,80,42,80,254,79,43,80,9,80,124,81,164,81,165,81,162,81,205,81,204,81,198,81,203,81,86,82,92,82,84,82,91,82,93,82,42,83,127,83,159,83,157,83,223,83,232,84,16,85,1,85,55,85,252,84,229,84,242,84,6,85,250,84,20,85,233,84,237,84,225,84,9,85,238,84,234,84,230,84,39,85,7,85,253,84,15,85,3,87,4,87,194,87,212,87,203,87,195,87,9,88,15,89,87,89,88,89,90,89,17,90,24,90,28,90,31,90,27,90,19,90,236,89,32,90,35,90,41,90,37,90,12,90,9,90,107,91,88,92,176,91,179,91,182,91,180,91,174,91,181,91,185,91,184,91,4,92,81,92,85,92,80,92,237,92,253,92,251,92,234,92,232,92,240,92,246,92,1,93,244,92,238,93,45,94,43,94,171,94,173,94,167,94,49,95,146,95,145,95,144,95,89,96,99,96,101,96,80,96,85,96,109,96,105,96,111,96,132,96,159,96,154,96,141,96,148,96,140,96,133,96,150,96,71,98,243,98,8,99,255,98,78,99,62,99,47,99,85,99,66,99,70,99,79,99,73,99,58,99,80,99,61,99,42,99,43,99,40,99,77,99,76,99,72,101,73,101,153,101,193,101,197,101,66,102,73,102,79,102,67,102,82,102,76,102,69,102,65,102,248,102,20,103,21,103,23,103,33,104,56,104,72,104,70,104,83,104,57,104,66,104,84,104,41,104,179,104,23,104,76,104,81,104,61,104,244,103,80,104,64,104,60,104,67,104,42,104,69,104,19,104,24,104,65,104,138,107,137,107,183,107,35,108,39,108,40,108,38,108,36,108,240,108,106,109,149,109,136,109,135,109,102,109,120,109,119,109,89,109,147,109,108,109,137,109,110,109,90,109,116,109,105,109,140,109,138,109,121,109,133,109,101,109,148,109,202,112,216,112,228,112,217,112,200,112,207,112,57,114,121,114,252,114,249,114,253,114,248,114,247,114,134,115,237,115,9,116,238,115,224,115,234,115,222,115,84,117,93,117,92,117,90,117,89,117,190,117,197,117,199,117,178,117,179,117,189,117,188,117,185,117,194,117,184,117,139,118,176,118,202,118,205,118,206,118,41,119,31,119,32,119,40,119,233,119,48,120,39,120,56,120,29,120,52,120,55,120,37,120,45,120,32,120,31,120,50,120,85,121,80,121,96,121,95,121,86,121,94,121,93,121,87,121,90,121,228,121,227,121,231,121,223,121,230,121,233,121,216,121,132,122,136,122,217,122,6,123,17,123,137,124,33,125,23,125,11,125,10,125,32,125,34,125,20,125,16,125,21,125,26,125,28,125,13,125,25,125,27,125,58,127,95,127,148,127,197,127,193,127,6,128,24,128,21,128,25,128,23,128,61,128,63,128,241,128,2,129,240,128,5,129,237,128,244,128,6,129,248,128,243,128,8,129,253,128,10,129,252,128,239,128,237,129,236,129,0,130,16,130,42,130,43,130,40,130,44,130,187,130,43,131,82,131,84,131,74,131,56,131,80,131,73,131,53,131,52,131,79,131,50,131,57,131,54,131,23,131,64,131,49,131,40,131,67,131,84,134,138,134,170,134,147,134,164,134,169,134,140,134,163,134,156,134,112,136,119,136,129,136,130,136,125,136,121,136,24,138,16,138,14,138,12,138,21,138,10,138,23,138,19,138,22,138,15,138,17,138,72,140,122,140,121,140,161,140,162,140,119,141,172,142,210,142,212,142,207,142,177,143,1,144,6,144,247,143,0,144,250,143,244,143,3,144,253,143,5,144,248,143,149,144,225,144,221,144,226,144,82,145,77,145,76,145,216,145,221,145,215,145,220,145,217,145,131,149,98,150,99,150,97,150,91,150,93,150,100,150,88,150,94,150,187,150,226,152,172,153,168,154,216,154,37,155,50,155,60,155,126,78,122,80,125,80,92,80,71,80,67,80,76,80,90,80,73,80,101,80,118,80,78,80,85,80,117,80,116,80,119,80,79,80,15,80,111,80,109,80,92,81,149,81,240,81,106,82,111,82,210,82,217,82,216,82,213,82,16,83,15,83,25,83,63,83,64,83,62,83,195,83,252,102,70,85,106,85,102,85,68,85,94,85,97,85,67,85,74,85,49,85,86,85,79,85,85,85,47,85,100,85,56,85,46,85,92,85,44,85,99,85,51,85,65,85,87,85,8,87,11,87,9,87,223,87,5,88,10,88,6,88,224,87,228,87,250,87,2,88,53,88,247,87,249,87,32,89,98,89,54,90,65,90,73,90,102,90,106,90,64,90,60,90,98,90,90,90,70,90,74,90,112,91,199,91,197,91,196,91,194,91,191,91,198,91,9,92,8,92,7,92,96,92,92,92,93,92,7,93,6,93,14,93,27,93,22,93,34,93,17,93,41,93,20,93,25,93,36,93,39,93,23,93,226,93,56,94,54,94,51,94,55,94,183,94,184,94,182,94,181,94,190,94,53,95,55,95,87,95,108,95,105,95,107,95,151,95,153,95,158,95,152,95,161,95,160,95,156,95,127,96,163,96,137,96,160,96,168,96,203,96,180,96,230,96,189,96,197,96,187,96,181,96,220,96,188,96,216,96,213,96,198,96,223,96,184,96,218,96,199,96,26,98,27,98,72,98,160,99,167,99,114,99,150,99,162,99,165,99,119,99,103,99,152,99,170,99,113,99,169,99,137,99,131,99,155,99,107,99,168,99,132,99,136,99,153,99,161,99,172,99,146,99,143,99,128,99,123,99,105,99,104,99,122,99,93,101,86,101,81,101,89,101,87,101,95,85,79,101,88,101,85,101,84,101,156,101,155,101,172,101,207,101,203,101,204,101,206,101,93,102,90,102,100,102,104,102,102,102,94,102,249,102,215,82,27,103,129,104,175,104,162,104,147,104,181,104,127,104,118,104,177,104,167,104,151,104,176,104,131,104,196,104,173,104,134,104,133,104,148,104,157,104,168,104,159,104,161,104,130,104,50,107,186,107,235,107,236,107,43,108,142,109,188,109,243,109,217,109,178,109,225,109,204,109,228,109,251,109,250,109,5,110,199,109,203,109,175,109,209,109,174,109,222,109,249,109,184,109,247,109,245,109,197,109,210,109,26,110,181,109,218,109,235,109,216,109,234,109,241,109,238,109,232,109,198,109,196,109,170,109,236,109,191,109,230,109,249,112,9,113,10,113,253,112,239,112,61,114,125,114,129,114,28,115,27,115,22,115,19,115,25,115,135,115,5,116,10,116,3,116,6,116,254,115,13,116,224,116,246,116,247,116,28,117,34,117,101,117,102,117,98,117,112,117,143,117,212,117,213,117,181,117,202,117,205,117,142,118,212,118,210,118,219,118,55,119,62,119,60,119,54,119,56,119,58,119,107,120,67,120,78,120,101,121,104,121,109,121,251,121,146,122,149,122,32,123,40,123,27,123,44,123,38,123,25,123,30,123,46,123,146,124,151,124,149,124,70,125,67,125,113,125,46,125,57,125,60,125,64,125,48,125,51,125,68,125,47,125,66,125,50,125,49,125,61,127,158,127,154,127,204,127,206,127,210,127,28,128,74,128,70,128,47,129,22,129,35,129,43,129,41,129,48,129,36,129,2,130,53,130,55,130,54,130,57,130,142,131,158,131,152,131,120,131,162,131,150,131,189,131,171,131,146,131,138,131,147,131,137,131,160,131,119,131,123,131,124,131,134,131,167,131,85,134,106,95,199,134,192,134,182,134,196,134,181,134,198,134,203,134,177,134,175,134,201,134,83,136,158,136,136,136,171,136,146,136,150,136,141,136,139,136,147,137,143,137,42,138,29,138,35,138,37,138,49,138,45,138,31,138,27,138,34,138,73,140,90,140,169,140,172,140,171,140,168,140,170,140,167,140,103,141,102,141,190,141,186,141,219,142,223,142,25,144,13,144,26,144,23,144,35,144,31,144,29,144,16,144,21,144,30,144,32,144,15,144,34,144,22,144,27,144,20,144,232,144,237,144,253,144,87,145,206,145,245,145,230,145,227,145,231,145,237,145,233,145,137,149,106,150,117,150,115,150,120,150,112,150,116,150,118,150,119,150,108,150,192,150,234,150,233,150,224,122,223,122,2,152,3,152,90,155,229,156,117,158,127,158,165,158,187,158,162,80,141,80,133,80,153,80,145,80,128,80,150,80,152,80,154,80,0,103,241,81,114,82,116,82,117,82,105,82,222,82,221,82,219,82,90,83,165,83,123,85,128,85,167,85,124,85,138,85,157,85,152,85,130,85,156,85,170,85,148,85,135,85,139,85,131,85,179,85,174,85,159,85,62,85,178,85,154,85,187,85,172,85,177,85,126,85,137,85,171,85,153,85,13,87,47,88,42,88,52,88,36,88,48,88,49,88,33,88,29,88,32,88,249,88,250,88,96,89,119,90,154,90,127,90,146,90,155,90,167,90,115,91,113,91,210,91,204,91,211,91,208,91,10,92,11,92,49,92,76,93,80,93,52,93,71,93,253,93,69,94,61,94,64,94,67,94,126,94,202,94,193,94,194,94,196,94,60,95,109,95,169,95,170,95,168,95,209,96,225,96,178,96,182,96,224,96,28,97,35,97,250,96,21,97,240,96,251,96,244,96,104,97,241,96,14,97,246,96,9,97,0,97,18,97,31,98,73,98,163,99,140,99,207,99,192,99,233,99,201,99,198,99,205,99,210,99,227,99,208,99,225,99,214,99,237,99,238,99,118,99,244,99,234,99,219,99,82,100,218,99,249,99,94,101,102,101,98,101,99,101,145,101,144,101,175,101,110,102,112,102,116,102,118,102,111,102,145,102,122,102,126,102,119,102,254,102,255,102,31,103,29,103,250,104,213,104,224,104,216,104,215,104,5,105,223,104,245,104,238,104,231,104,249,104,210,104,242,104,227,104,203,104,205,104,13,105,18,105,14,105,201,104,218,104,110,105,251,104,62,107,58,107,61,107,152,107,150,107,188,107,239,107,46,108,47,108,44,108,47,110,56,110,84,110,33,110,50,110,103,110,74,110,32,110,37,110,35,110,27,110,91,110,88,110,36,110,86,110,110,110,45,110,38,110,111,110,52,110,77,110,58,110,44,110,67,110,29,110,62,110,203,110,137,110,25,110,78,110,99,110,68,110,114,110,105,110,95,110,25,113,26,113,38,113,48,113,33,113,54,113,110,113,28,113,76,114,132,114,128,114,54,115,37,115,52,115,41,115,58,116,42,116,51,116,34,116,37,116,53,116,54,116,52,116,47,116,27,116,38,116,40,116,37,117,38,117,107,117,106,117,226,117,219,117,227,117,217,117,216,117,222,117,224,117,123,118,124,118,150,118,147,118,180,118,220,118,79,119,237,119,93,120,108,120,111,120,13,122,8,122,11,122,5,122,0,122,152,122,151,122,150,122,229,122,227,122,73,123,86,123,70,123,80,123,82,123,84,123,77,123,75,123,79,123,81,123,159,124,165,124,94,125,80,125,104,125,85,125,43,125,110,125,114,125,97,125,102,125,98,125,112,125,115,125,132,85,212,127,213,127,11,128,82,128,133,128,85,129,84,129,75,129,81,129,78,129,57,129,70,129,62,129,76,129,83,129,116,129,18,130,28,130,233,131,3,132,248,131,13,132,224,131,197,131,11,132,193,131,239,131,241,131,244,131,87,132,10,132,240,131,12,132,204,131,253,131,242,131,202,131,56,132,14,132,4,132,220,131,7,132,212,131,223,131,91,134,223,134,217,134,237,134,212,134,219,134,228,134,208,134,222,134,87,136,193,136,194,136,177,136,131,137,150,137,59,138,96,138,85,138,94,138,60,138,65,138,84,138,91,138,80,138,70,138,52,138,58,138,54,138,86,138,97,140,130,140,175,140,188,140,179,140,189,140,193,140,187,140,192,140,180,140,183,140,182,140,191,140,184,140,138,141,133,141,129,141,206,141,221,141,203,141,218,141,209,141,204,141,219,141,198,141,251,142,248,142,252,142,156,143,46,144,53,144,49,144,56,144,50,144,54,144,2,145,245,144,9,145,254,144,99,145,101,145,207,145,20,146,21,146,35,146,9,146,30,146,13,146,16,146,7,146,17,146,148,149,143,149,139,149,145,149,147,149,146,149,142,149,138,150,142,150,139,150,125,150,133,150,134,150,141,150,114,150,132,150,193,150,197,150,196,150,198,150,199,150,239,150,242,150,204,151,5,152,6,152,8,152,231,152,234,152,239,152,233,152,242,152,237,152,174,153,173,153,195,158,205,158,209,158,130,78,173,80,181,80,178,80,179,80,197,80,190,80,172,80,183,80,187,80,175,80,199,80,127,82,119,82,125,82,223,82,230,82,228,82,226,82,227,82,47,83,223,85,232,85,211,85,230,85,206,85,220,85,199,85,209,85,227,85,228,85,239,85,218,85,225,85,197,85,198,85,229,85,201,85,18,87,19,87,94,88,81,88,88,88,87,88,90,88,84,88,107,88,76,88,109,88,74,88,98,88,82,88,75,88,103,89,193,90,201,90,204,90,190,90,189,90,188,90,179,90,194,90,178,90,105,93,111,93,76,94,121,94,201,94,200,94,18,95,89,95,172,95,174,95,26,97,15,97,72,97,31,97,243,96,27,97,249,96,1,97,8,97,78,97,76,97,68,97,77,97,62,97,52,97,39,97,13,97,6,97,55,97,33,98,34,98,19,100,62,100,30,100,42,100,45,100,61,100,44,100,15,100,28,100,20,100,13,100,54,100,22,100,23,100,6,100,108,101,159,101,176,101,151,102,137,102,135,102,136,102,150,102,132,102,152,102,141,102,3,103,148,105,109,105,90,105,119,105,96,105,84,105,117,105,48,105,130,105,74,105,104,105,107,105,94,105,83,105,121,105,134,105,93,105,99,105,91,105,71,107,114,107,192,107,191,107,211,107,253,107,162,110,175,110,211,110,182,110,194,110,144,110,157,110,199,110,197,110,165,110,152,110,188,110,186,110,171,110,209,110,150,110,156,110,196,110,212,110,170,110,167,110,180,110,78,113,89,113,105,113,100,113,73,113,103,113,92,113,108,113,102,113,76,113,101,113,94,113,70,113,104,113,86,113,58,114,82,114,55,115,69,115,63,115,62,115,111,116,90,116,85,116,95,116,94,116,65,116,63,116,89,116,91,116,92,116,118,117,120,117,0,118,240,117,1,118,242,117,241,117,250,117,255,117,244,117,243,117,222,118,223,118,91,119,107,119,102,119,94,119,99,119,121,119,106,119,108,119,92,119,101,119,104,119,98,119,238,119,142,120,176,120,151,120,152,120,140,120,137,120,124,120,145,120,147,120,127,120,122,121,127,121,129,121,44,132,189,121,28,122,26,122,32,122,20,122,31,122,30,122,159,122,160,122,119,123,192,123,96,123,110,123,103,123,177,124,179,124,181,124,147,125,121,125,145,125,129,125,143,125,91,125,110,127,105,127,106,127,114,127,169,127,168,127,164,127,86,128,88,128,134,128,132,128,113,129,112,129,120,129,101,129,110,129,115,129,107,129,121,129,122,129,102,129,5,130,71,130,130,132,119,132,61,132,49,132,117,132,102,132,107,132,73,132,108,132,91,132,60,132,53,132,97,132,99,132,105,132,109,132,70,132,94,134,92,134,95,134,249,134,19,135,8,135,7,135,0,135,254,134,251,134,2,135,3,135,6,135,10,135,89,136,223,136,212,136,217,136,220,136,216,136,221,136,225,136,202,136,213,136,210,136,156,137,227,137,107,138,114,138,115,138,102,138,105,138,112,138,135,138,124,138,99,138,160,138,113,138,133,138,109,138,98,138,110,138,108,138,121,138,123,138,62,138,104,138,98,140,138,140,137,140,202,140,199,140,200,140,196,140,178,140,195,140,194,140,197,140,225,141,223,141,232,141,239,141,243,141,250,141,234,141,228,141,230,141,178,142,3,143,9,143,254,142,10,143,159,143,178,143,75,144,74,144,83,144,66,144,84,144,60,144,85,144,80,144,71,144,79,144,78,144,77,144,81,144,62,144,65,144,18,145,23,145,108,145,106,145,105,145,201,145,55,146,87,146,56,146,61,146,64,146,62,146,91,146,75,146,100,146,81,146,52,146,73,146,77,146,69,146,57,146,63,146,90,146,152,149,152,150,148,150,149,150,205,150,203,150,201,150,202,150,247,150,251,150,249,150,246,150,86,151,116,151,118,151,16,152,17,152,19,152,10,152,18,152,12,152,252,152,244,152,253,152,254,152,179,153,177,153,180,153,225,154,233,156,130,158,14,159,19,159,32,159,231,80,238,80,229,80,214,80,237,80,218,80,213,80,207,80,209,80,241,80,206,80,233,80,98,81,243,81,131,82,130,82,49,83,173,83,254,85,0,86,27,86,23,86,253,85,20,86,6,86,9,86,13,86,14,86,247,85,22,86,31,86,8,86,16,86,246,85,24,87,22,87,117,88,126,88,131,88,147,88,138,88,121,88,133,88,125,88,253,88,37,89,34,89,36,89,106,89,105,89,225,90,230,90,233,90,215,90,214,90,216,90,227,90,117,91,222,91,231,91,225,91,229,91,230,91,232,91,226,91,228,91,223,91,13,92,98,92,132,93,135,93,91,94,99,94,85,94,87,94,84,94,211,94,214,94,10,95,70,95,112,95,185,95,71,97,63,97,75,97,119,97,98,97,99,97,95,97,90,97,88,97,117,97,42,98,135,100,88,100,84,100,164,100,120,100,95,100,122,100,81,100,103,100,52,100,109,100,123,100,114,101,161,101,215,101,214,101,162,102,168,102,157,102,156,105,168,105,149,105,193,105,174,105,211,105,203,105,155,105,183,105,187,105,171,105,180,105,208,105,205,105,173,105,204,105,166,105,195,105,163,105,73,107,76,107,51,108,51,111,20,111,254,110,19,111,244,110,41,111,62,111,32,111,44,111,15,111,2,111,34,111,255,110,239,110,6,111,49,111,56,111,50,111,35,111,21,111,43,111,47,111,136,111,42,111,236,110,1,111,242,110,204,110,247,110,148,113,153,113,125,113,138,113,132,113,146,113,62,114,146,114,150,114,68,115,80,115,100,116,99,116,106,116,112,116,109,116,4,117,145,117,39,118,13,118,11,118,9,118,19,118,225,118,227,118,132,119,125,119,127,119,97,119,193,120,159,120,167,120,179,120,169,120,163,120,142,121,143,121,141,121,46,122,49,122,170,122,169,122,237,122,239,122,161,123,149,123,139,123,117,123,151,123,157,123,148,123,143,123,184,123,135,123,132,123,185,124,189,124,190,124,187,125,176,125,156,125,189,125,190,125,160,125,202,125,180,125,178,125,177,125,186,125,162,125,191,125,181,125,184,125,173,125,210,125,199,125,172,125,112,127,224,127,225,127,223,127,94,128,90,128,135,128,80,129,128,129,143,129,136,129,138,129,127,129,130,129,231,129,250,129,7,130,20,130,30,130,75,130,201,132,191,132,198,132,196,132,153,132,158,132,178,132,156,132,203,132,184,132,192,132,211,132,144,132,188,132,209,132,202,132,63,135,28,135,59,135,34,135,37,135,52,135,24,135,85,135,55,135,41,135,243,136,2,137,244,136,249,136,248,136,253,136,232,136,26,137,239,136,166,138,140,138,158,138,163,138,141,138,161,138,147,138,164,138,170,138,165,138,168,138,152,138,145,138,154,138,167,138,106,140,141,140,140,140,211,140,209,140,210,140,107,141,153,141,149,141,252,141,20,143,18,143,21,143,19,143,163,143,96,144,88,144,92,144,99,144,89,144,94,144,98,144,93,144,91,144,25,145,24,145,30,145,117,145,120,145,119,145,116,145,120,146,128,146,133,146,152,146,150,146,123,146,147,146,156,146,168,146,124,146,145,146,161,149,168,149,169,149,163,149,165,149,164,149,153,150,156,150,155,150,204,150,210,150,0,151,124,151,133,151,246,151,23,152,24,152,175,152,177,152,3,153,5,153,12,153,9,153,193,153,175,154,176,154,230,154,65,155,66,155,244,156,246,156,243,156,188,158,59,159,74,159,4,81,0,81,251,80,245,80,249,80,2,81,8,81,9,81,5,81,220,81,135,82,136,82,137,82,141,82,138,82,240,82,178,83,46,86,59,86,57,86,50,86,63,86,52,86,41,86,83,86,78,86,87,86,116,86,54,86,47,86,48,86,128,88,159,88,158,88,179,88,156,88,174,88,169,88,166,88,109,89,9,91,251,90,11,91,245,90,12,91,8,91,238,91,236,91,233,91,235,91,100,92,101,92,157,93,148,93,98,94,95,94,97,94,226,94,218,94,223,94,221,94,227,94,224,94,72,95,113,95,183,95,181,95,118,97,103,97,110,97,93,97,85,97,130,97,124,97,112,97,107,97,126,97,167,97,144,97,171,97,142,97,172,97,154,97,164,97,148,97,174,97,46,98,105,100,111,100,121,100,158,100,178,100,136,100,144,100,176,100,165,100,147,100,149,100,169,100,146,100,174,100,173,100,171,100,154,100,172,100,153,100,162,100,179,100,117,101,119,101,120,101,174,102,171,102,180,102,177,102,35,106,31,106,232,105,1,106,30,106,25,106,253,105,33,106,19,106,10,106,243,105,2,106,5,106,237,105,17,106,80,107,78,107,164,107,197,107,198,107,63,111,124,111,132,111,81,111,102,111,84,111,134,111,109,111,91,111,120,111,110,111,142,111,122,111,112,111,100,111,151,111,88,111,213,110,111,111,96,111,95,111,159,113,172,113,177,113,168,113,86,114,155,114,78,115,87,115,105,116,139,116,131,116,126,116,128,116,127,117,32,118,41,118,31,118,36,118,38,118,33,118,34,118,154,118,186,118,228,118,142,119,135,119,140,119,145,119,139,119,203,120,197,120,186,120,202,120,190,120,213,120,188,120,208,120,63,122,60,122,64,122,61,122,55,122,59,122,175,122,174,122,173,123,177,123,196,123,180,123,198,123,199,123,193,123,160,123,204,123,202,124,224,125,244,125,239,125,251,125,216,125,236,125,221,125,232,125,227,125,218,125,222,125,233,125,158,125,217,125,242,125,249,125,117,127,119,127,175,127,233,127,38,128,155,129,156,129,157,129,160,129,154,129,152,129,23,133,61,133,26,133,238,132,44,133,45,133,19,133,17,133,35,133,33,133,20,133,236,132,37,133,255,132,6,133,130,135,116,135,118,135,96,135,102,135,120,135,104,135,89,135,87,135,76,135,83,135,91,136,93,136,16,137,7,137,18,137,19,137,21,137,10,137,188,138,210,138,199,138,196,138,149,138,203,138,248,138,178,138,201,138,194,138,191,138,176,138,214,138,205,138,182,138,185,138,219,138,76,140,78,140,108,140,224,140,222,140,230,140,228,140,236,140,237,140,226,140,227,140,220,140,234,140,225,140,109,141,159,141,163,141,43,142,16,142,29,142,34,142,15,142,41,142,31,142,33,142,30,142,186,142,29,143,27,143,31,143,41,143,38,143,42,143,28,143,30,143,37,143,105,144,110,144,104,144,109,144,119,144,48,145,45,145,39,145,49,145,135,145,137,145,139,145,131,145,197,146,187,146,183,146,234,146,172,146,228,146,193,146,179,146,188,146,210,146,199,146,240,146,178,146,173,149,177,149,4,151,6,151,7,151,9,151,96,151,141,151,139,151,143,151,33,152,43,152,28,152,179,152,10,153,19,153,18,153,24,153,221,153,208,153,223,153,219,153,209,153,213,153,210,153,217,153,183,154,238,154,239,154,39,155,69,155,68,155,119,155,111,155,6,157,9,157,3,157,169,158,190,158,206,158,168,88,82,159,18,81,24,81,20,81,16,81,21,81,128,81,170,81,221,81,145,82,147,82,243,82,89,86,107,86,121,86,105,86,100,86,120,86,106,86,104,86,101,86,113,86,111,86,108,86,98,86,118,86,193,88,190,88,199,88,197,88,110,89,29,91,52,91,120,91,240,91,14,92,74,95,178,97,145,97,169,97,138,97,205,97,182,97,190,97,202,97,200,97,48,98,197,100,193,100,203,100,187,100,188,100,218,100,196,100,199,100,194,100,205,100,191,100,210,100,212,100,190,100,116,101,198,102,201,102,185,102,196,102,199,102,184,102,61,106,56,106,58,106,89,106,107,106,88,106,57,106,68,106,98,106,97,106,75,106,71,106,53,106,95,106,72,106,89,107,119,107,5,108,194,111,177,111,161,111,195,111,164,111,193,111,167,111,179,111,192,111,185,111,182,111,166,111,160,111,180,111,190,113,201,113,208,113,210,113,200,113,213,113,185,113,206,113,217,113,220,113,195,113,196,113,104,115,156,116,163,116,152,116,159,116,158,116,226,116,12,117,13,117,52,118,56,118,58,118,231,118,229,118,160,119,158,119,159,119,165,119,232,120,218,120,236,120,231,120,166,121,77,122,78,122,70,122,76,122,75,122,186,122,217,123,17,124,201,123,228,123,219,123,225,123,233,123,230,123,213,124,214,124,10,126,17,126,8,126,27,126,35,126,30,126,29,126,9,126,16,126,121,127,178,127,240,127,241,127,238,127,40,128,179,129,169,129,168,129,251,129,8,130,88,130,89,130,74,133,89,133,72,133,104,133,105,133,67,133,73,133,109,133,106,133,94,133,131,135,159,135,158,135,162,135,141,135,97,136,42,137,50,137,37,137,43,137,33,137,170,137,166,137,230,138,250,138,235,138,241,138,0,139,220,138,231,138,238,138,254,138,1,139,2,139,247,138,237,138,243,138,246,138,252,138,107,140,109,140,147,140,244,140,68,142,49,142,52,142,66,142,57,142,53,142,59,143,47,143,56,143,51,143,168,143,166,143,117,144,116,144,120,144,114,144,124,144,122,144,52,145,146,145,32,147,54,147,248,146,51,147,47,147,34,147,252,146,43,147,4,147,26,147,16,147,38,147,33,147,21,147,46,147,25,147,187,149,167,150,168,150,170,150,213,150,14,151,17,151,22,151,13,151,19,151,15,151,91,151,92,151,102,151,152,151,48,152,56,152,59,152,55,152,45,152,57,152,36,152,16,153,40,153,30,153,27,153,33,153,26,153,237,153,226,153,241,153,184,154,188,154,251,154,237,154,40,155,145,155,21,157,35,157,38,157,40,157,18,157,27,157,216,158,212,158,141,159,156,159,42,81,31,81,33,81,50,81,245,82,142,86,128,86,144,86,133,86,135,86,143,86,213,88,211,88,209,88,206,88,48,91,42,91,36,91,122,91,55,92,104,92,188,93,186,93,189,93,184,93,107,94,76,95,189,95,201,97,194,97,199,97,230,97,203,97,50,98,52,98,206,100,202,100,216,100,224,100,240,100,230,100,236,100,241,100,226,100,237,100,130,101,131,101,217,102,214,102,128,106,148,106,132,106,162,106,156,106,219,106,163,106,126,106,151,106,144,106,160,106,92,107,174,107,218,107,8,108,216,111,241,111,223,111,224,111,219,111,228,111,235,111,239,111,128,111,236,111,225,111,233,111,213,111,238,111,240,111,231,113,223,113,238,113,230,113,229,113,237,113,236,113,244,113,224,113,53,114,70,114,112,115,114,115,169,116,176,116,166,116,168,116,70,118,66,118,76,118,234,118,179,119,170,119,176,119,172,119,167,119,173,119,239,119,247,120,250,120,244,120,239,120,1,121,167,121,170,121,87,122,191,122,7,124,13,124,254,123,247,123,12,124,224,123,224,124,220,124,222,124,226,124,223,124,217,124,221,124,46,126,62,126,70,126,55,126,50,126,67,126,43,126,61,126,49,126,69,126,65,126,52,126,57,126,72,126,53,126,63,126,47,126,68,127,243,127,252,127,113,128,114,128,112,128,111,128,115,128,198,129,195,129,186,129,194,129,192,129,191,129,189,129,201,129,190,129,232,129,9,130,113,130,170,133,132,133,126,133,156,133,145,133,148,133,175,133,155,133,135,133,168,133,138,133,103,134,192,135,209,135,179,135,210,135,198,135,171,135,187,135,186,135,200,135,203,135,59,137,54,137,68,137,56,137,61,137,172,137,14,139,23,139,25,139,27,139,10,139,32,139,29,139,4,139,16,139,65,140,63,140,115,140,250,140,253,140,252,140,248,140,251,140,168,141,73,142,75,142,72,142,74,142,68,143,62,143,66,143,69,143,63,143,127,144,125,144,132,144,129,144,130,144,128,144,57,145,163,145,158,145,156,145,77,147,130,147,40,147,117,147,74,147,101,147,75,147,24,147,126,147,108,147,91,147,112,147,90,147,84,147,202,149,203,149,204,149,200,149,198,149,177,150,184,150,214,150,28,151,30,151,160,151,211,151,70,152,182,152,53,153,1,154,255,153,174,155,171,155,170,155,173,155,59,157,63,157,139,158,207,158,222,158,220,158,221,158,219,158,62,159,75,159,226,83,149,86,174,86,217,88,216,88,56,91,93,95,227,97,51,98,244,100,242,100,254,100,6,101,250,100,251,100,247,100,183,101,220,102,38,103,179,106,172,106,195,106,187,106,184,106,194,106,174,106,175,106,95,107,120,107,175,107,9,112,11,112,254,111,6,112,250,111,17,112,15,112,251,113,252,113,254,113,248,113,119,115,117,115,167,116,191,116,21,117,86,118,88,118,82,118,189,119,191,119,187,119,188,119,14,121,174,121,97,122,98,122,96,122,196,122,197,122,43,124,39,124,42,124,30,124,35,124,33,124,231,124,84,126,85,126,94,126,90,126,97,126,82,126,89,126,72,127,249,127,251,127,119,128,118,128,205,129,207,129,10,130,207,133,169,133,205,133,208,133,201,133,176,133,186,133,185,133,166,133,239,135,236,135,242,135,224,135,134,137,178,137,244,137,40,139,57,139,44,139,43,139,80,140,5,141,89,142,99,142,102,142,100,142,95,142,85,142,192,142,73,143,77,143,135,144,131,144,136,144,171,145,172,145,208,145,148,147,138,147,150,147,162,147,179,147,174,147,172,147,176,147,152,147,154,147,151,147,212,149,214,149,208,149,213,149,226,150,220,150,217,150,219,150,222,150,36,151,163,151,166,151,173,151,249,151,77,152,79,152,76,152,78,152,83,152,186,152,62,153,63,153,61,153,46,153,165,153,14,154,193,154,3,155,6,155,79,155,78,155,77,155,202,155,201,155,253,155,200,155],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+281828),
allocate([192,155,81,157,93,157,96,157,224,158,21,159,44,159,51,81,165,86,222,88,223,88,226,88,245,91,144,159,236,94,242,97,247,97,246,97,245,97,0,101,15,101,224,102,221,102,229,106,221,106,218,106,211,106,27,112,31,112,40,112,26,112,29,112,21,112,24,112,6,114,13,114,88,114,162,114,120,115,122,115,189,116,202,116,227,116,135,117,134,117,95,118,97,118,199,119,25,121,177,121,107,122,105,122,62,124,63,124,56,124,61,124,55,124,64,124,107,126,109,126,121,126,105,126,106,126,133,127,115,126,182,127,185,127,184,127,216,129,233,133,221,133,234,133,213,133,228,133,229,133,247,133,251,135,5,136,13,136,249,135,254,135,96,137,95,137,86,137,94,137,65,139,92,139,88,139,73,139,90,139,78,139,79,139,70,139,89,139,8,141,10,141,124,142,114,142,135,142,118,142,108,142,122,142,116,142,84,143,78,143,173,143,138,144,139,144,177,145,174,145,225,147,209,147,223,147,195,147,200,147,220,147,221,147,214,147,226,147,205,147,216,147,228,147,215,147,232,147,220,149,180,150,227,150,42,151,39,151,97,151,220,151,251,151,94,152,88,152,91,152,188,152,69,153,73,153,22,154,25,154,13,155,232,155,231,155,214,155,219,155,137,157,97,157,114,157,106,157,108,157,146,158,151,158,147,158,180,158,248,82,168,86,183,86,182,86,180,86,188,86,228,88,64,91,67,91,125,91,246,91,201,93,248,97,250,97,24,101,20,101,25,101,230,102,39,103,236,106,62,112,48,112,50,112,16,114,123,115,207,116,98,118,101,118,38,121,42,121,44,121,43,121,199,122,246,122,76,124,67,124,77,124,239,124,240,124,174,143,125,126,124,126,130,126,76,127,0,128,218,129,102,130,251,133,249,133,17,134,250,133,6,134,11,134,7,134,10,134,20,136,21,136,100,137,186,137,248,137,112,139,108,139,102,139,111,139,95,139,107,139,15,141,13,141,137,142,129,142,133,142,130,142,180,145,203,145,24,148,3,148,253,147,225,149,48,151,196,152,82,153,81,153,168,153,43,154,48,154,55,154,53,154,19,156,13,156,121,158,181,158,232,158,47,159,95,159,99,159,97,159,55,81,56,81,193,86,192,86,194,86,20,89,108,92,205,93,252,97,254,97,29,101,28,101,149,101,233,102,251,106,4,107,250,106,178,107,76,112,27,114,167,114,214,116,212,116,105,118,211,119,80,124,143,126,140,126,188,127,23,134,45,134,26,134,35,136,34,136,33,136,31,136,106,137,108,137,189,137,116,139,119,139,125,139,19,141,138,142,141,142,139,142,95,143,175,143,186,145,46,148,51,148,53,148,58,148,56,148,50,148,43,148,226,149,56,151,57,151,50,151,255,151,103,152,101,152,87,153,69,154,67,154,64,154,62,154,207,154,84,155,81,155,45,156,37,156,175,157,180,157,194,157,184,157,157,158,239,158,25,159,92,159,102,159,103,159,60,81,59,81,200,86,202,86,201,86,127,91,212,93,210,93,78,95,255,97,36,101,10,107,97,107,81,112,88,112,128,115,228,116,138,117,110,118,108,118,179,121,96,124,95,124,126,128,125,128,223,129,114,137,111,137,252,137,128,139,22,141,23,141,145,142,147,142,97,143,72,145,68,148,81,148,82,148,61,151,62,151,195,151,193,151,107,152,85,153,85,154,77,154,210,154,26,155,73,156,49,156,62,156,59,156,211,157,215,157,52,159,108,159,106,159,148,159,204,86,214,93,0,98,35,101,43,101,42,101,236,102,16,107,218,116,202,122,100,124,99,124,101,124,147,126,150,126,148,126,226,129,56,134,63,134,49,136,138,139,144,144,143,144,99,148,96,148,100,148,104,151,111,152,92,153,90,154,91,154,87,154,211,154,212,154,209,154,84,156,87,156,86,156,229,157,159,158,244,158,209,86,233,88,44,101,94,112,113,118,114,118,215,119,80,127,136,127,54,136,57,136,98,136,147,139,146,139,150,139,119,130,27,141,192,145,106,148,66,151,72,151,68,151,198,151,112,152,95,154,34,155,88,155,95,156,249,157,250,157,124,158,125,158,7,159,119,159,114,159,243,94,22,107,99,112,108,124,110,124,59,136,192,137,161,142,193,145,114,148,112,148,113,152,94,153,214,154,35,155,204,158,100,112,218,119,154,139,119,148,201,151,98,154,101,154,156,126,156,139,170,142,197,145,125,148,126,148,124,148,119,156,120,156,247,158,84,140,127,148,26,158,40,114,106,154,49,155,27,158,30,158,114,124,96,36,97,36,98,36,99,36,100,36,101,36,102,36,103,36,104,36,105,36,116,36,117,36,118,36,119,36,120,36,121,36,122,36,123,36,124,36,125,36,112,33,113,33,114,33,115,33,116,33,117,33,118,33,119,33,120,33,121,33,54,78,63,78,133,78,160,78,130,81,150,81,171,81,249,82,56,83,105,83,182,83,10,89,128,91,219,93,122,94,127,94,244,94,80,95,97,95,52,101,224,101,146,117,118,118,181,143,182,150,168,0,198,2,253,48,254,48,157,48,158,48,0,0,0,0,5,48,6,48,7,48,252,48,59,255,61,255,61,39,65,48,66,48,67,48,68,48,69,48,70,48,71,48,72,48,73,48,74,48,75,48,76,48,77,48,78,48,79,48,80,48,81,48,82,48,83,48,84,48,85,48,86,48,87,48,88,48,89,48,90,48,91,48,92,48,93,48,94,48,95,48,96,48,97,48,98,48,99,48,100,48,101,48,102,48,103,48,104,48,105,48,106,48,107,48,108,48,109,48,110,48,111,48,112,48,113,48,114,48,115,48,116,48,117,48,118,48,119,48,120,48,121,48,122,48,123,48,124,48,125,48,126,48,127,48,128,48,129,48,130,48,131,48,132,48,133,48,134,48,135,48,136,48,137,48,138,48,139,48,140,48,141,48,142,48,143,48,144,48,145,48,146,48,147,48,161,48,162,48,163,48,164,48,165,48,166,48,167,48,168,48,169,48,170,48,171,48,172,48,173,48,174,48,175,48,176,48,177,48,178,48,179,48,180,48,181,48,182,48,183,48,184,48,185,48,186,48,187,48,188,48,189,48,190,48,191,48,192,48,193,48,194,48,195,48,196,48,197,48,198,48,199,48,200,48,201,48,202,48,203,48,204,48,205,48,206,48,207,48,208,48,209,48,210,48,211,48,212,48,213,48,214,48,215,48,216,48,217,48,218,48,219,48,220,48,221,48,222,48,223,48,224,48,225,48,226,48,227,48,228,48,229,48,230,48,231,48,232,48,233,48,234,48,235,48,236,48,237,48,238,48,239,48,240,48,241,48,242,48,243,48,244,48,245,48,246,48,16,4,17,4,18,4,19,4,20,4,21,4,1,4,22,4,23,4,24,4,25,4,26,4,27,4,28,4,29,4,30,4,31,4,32,4,33,4,34,4,35,4,36,4,37,4,38,4,39,4,40,4,41,4,42,4,43,4,44,4,45,4,46,4,47,4,48,4,49,4,50,4,51,4,52,4,53,4,81,4,54,4,55,4,56,4,57,4,58,4,59,4,60,4,61,4,62,4,63,4,64,4,65,4,66,4,67,4,68,4,69,4,70,4,71,4,72,4,73,4,74,4,75,4,76,4,77,4,78,4,79,4,231,33,184,33,185,33,207,49,204,0,90,78,138,0,2,82,145,68,176,159,136,81,177,159,7,118,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,226,255,228,255,7,255,2,255,49,50,22,33,33,33,155,48,156,48,128,46,132,46,134,46,135,46,136,46,138,46,140,46,141,46,149,46,156,46,157,46,165,46,167,46,170,46,172,46,174,46,182,46,188,46,190,46,198,46,202,46,204,46,205,46,207,46,214,46,215,46,222,46,227,46,0,0,0,0,0,0,131,2,80,2,91,2,84,2,117,2,83,1,248,0,75,1,138,2,106,2,66,78,92,78,245,81,26,83,130,83,7,78,12,78,71,78,141,78,215,86,12,250,110,92,115,95,15,78,135,81,14,78,46,78,147,78,194,78,201,78,200,78,152,81,252,82,108,83,185,83,32,87,3,89,44,89,16,92,255,93,225,101,179,107,204,107,20,108,63,114,49,78,60,78,232,78,220,78,233,78,225,78,221,78,218,78,12,82,28,83,76,83,34,87,35,87,23,89,47,89,129,91,132,91,18,92,59,92,116,92,115,92,4,94,128,94,130,94,201,95,9,98,80,98,21,108,54,108,67,108,63,108,59,108,174,114,176,114,138,115,184,121,138,128,30,150,14,79,24,79,44,79,245,78,20,79,241,78,0,79,247,78,8,79,29,79,2,79,5,79,34,79,19,79,4,79,244,78,18,79,177,81,19,82,9,82,16,82,166,82,34,83,31,83,77,83,138,83,7,84,225,86,223,86,46,87,42,87,52,87,60,89,128,89,124,89,133,89,123,89,126,89,119,89,127,89,86,91,21,92,37,92,124,92,122,92,123,92,126,92,223,93,117,94,132,94,2,95,26,95,116,95,213,95,212,95,207,95,92,98,94,98,100,98,97,98,102,98,98,98,89,98,96,98,90,98,101,98,239,101,238,101,62,103,57,103,56,103,59,103,58,103,63,103,60,103,51,103,24,108,70,108,82,108,92,108,79,108,74,108,84,108,75,108,76,108,113,112,94,114,180,114,181,114,142,115,42,117,127,118,117,122,81,127,120,130,124,130,128,130,125,130,127,130,77,134,126,137,153,144,151,144,152,144,155,144,148,144,34,150,36,150,32,150,35,150,86,79,59,79,98,79,73,79,83,79,100,79,62,79,103,79,82,79,95,79,65,79,88,79,45,79,51,79,63,79,97,79,143,81,185,81,28,82,30,82,33,82,173,82,174,82,9,83,99,83,114,83,142,83,143,83,48,84,55,84,42,84,84,84,69,84,25,84,28,84,37,84,24,84,61,84,79,84,65,84,40,84,36,84,71,84,238,86,231,86,229,86,65,87,69,87,76,87,73,87,75,87,82,87,6,89,64,89,166,89,152,89,160,89,151,89,142,89,162,89,144,89,143,89,167,89,161,89,142,91,146,91,40,92,42,92,141,92,143,92,136,92,139,92,137,92,146,92,138,92,134,92,147,92,149,92,224,93,10,94,14,94,139,94,137,94,140,94,136,94,141,94,5,95,29,95,120,95,118,95,210,95,209,95,208,95,237,95,232,95,238,95,243,95,225,95,228,95,227,95,250,95,239,95,247,95,251,95,0,96,244,95,58,98,131,98,140,98,142,98,143,98,148,98,135,98,113,98,123,98,122,98,112,98,129,98,136,98,119,98,125,98,114,98,116,98,55,101,240,101,244,101,243,101,242,101,245,101,69,103,71,103,89,103,85,103,76,103,72,103,93,103,77,103,90,103,75,103,208,107,25,108,26,108,120,108,103,108,107,108,132,108,139,108,143,108,113,108,111,108,105,108,154,108,109,108,135,108,149,108,156,108,102,108,115,108,101,108,123,108,142,108,116,112,122,112,99,114,191,114,189,114,195,114,198,114,193,114,186,114,197,114,149,115,151,115,147,115,148,115,146,115,58,117,57,117,148,117,149,117,129,118,61,121,52,128,149,128,153,128,144,128,146,128,156,128,144,130,143,130,133,130,142,130,145,130,147,130,138,130,131,130,132,130,120,140,201,143,191,143,159,144,161,144,165,144,158,144,167,144,160,144,48,150,40,150,47,150,45,150,51,78,152,79,124,79,133,79,125,79,128,79,135,79,118,79,116,79,137,79,132,79,119,79,76,79,151,79,106,79,154,79,121,79,129,79,120,79,144,79,156,79,148,79,158,79,146,79,130,79,149,79,107,79,110,79,158,81,188,81,190,81,53,82,50,82,51,82,70,82,49,82,188,82,10,83,11,83,60,83,146,83,148,83,135,84,127,84,129,84,145,84,130,84,136,84,107,84,122,84,126,84,101,84,108,84,116,84,102,84,141,84,111,84,97,84,96,84,152,84,99,84,103,84,100,84,247,86,249,86,111,87,114,87,109,87,107,87,113,87,112,87,118,87,128,87,117,87,123,87,115,87,116,87,98,87,104,87,125,87,12,89,69,89,181,89,186,89,207,89,206,89,178,89,204,89,193,89,182,89,188,89,195,89,214,89,177,89,189,89,192,89,200,89,180,89,199,89,98,91,101,91,147,91,149,91,68,92,71,92,174,92,164,92,160,92,181,92,175,92,168,92,172,92,159,92,163,92,173,92,162,92,170,92,167,92,157,92,165,92,182,92,176,92,166,92,23,94,20,94,25,94,40,95,34,95,35,95,36,95,84,95,130,95,126,95,125,95,222,95,229,95,45,96,38,96,25,96,50,96,11,96,52,96,10,96,23,96,51,96,26,96,30,96,44,96,34,96,13,96,16,96,46,96,19,96,17,96,12,96,9,96,28,96,20,98,61,98,173,98,180,98,209,98,190,98,170,98,182,98,202,98,174,98,179,98,175,98,187,98,169,98,176,98,184,98,61,101,168,101,187,101,9,102,252,101,4,102,18,102,8,102,251,101,3,102,11,102,13,102,5,102,253,101,17,102,16,102,246,102,10,103,133,103,108,103,142,103,146,103,118,103,123,103,152,103,134,103,132,103,116,103,141,103,140,103,122,103,159,103,145,103,153,103,131,103,125,103,129,103,120,103,121,103,148,103,37,107,128,107,126,107,222,107,29,108,147,108,236,108,235,108,238,108,217,108,182,108,212,108,173,108,231,108,183,108,208,108,194,108,186,108,195,108,198,108,237,108,242,108,210,108,221,108,180,108,138,108,157,108,128,108,222,108,192,108,48,109,205,108,199,108,176,108,249,108,207,108,233,108,209,108,148,112,152,112,133,112,147,112,134,112,132,112,145,112,150,112,130,112,154,112,131,112,106,114,214,114,203,114,216,114,201,114,220,114,210,114,212,114,218,114,204,114,209,114,164,115,161,115,173,115,166,115,162,115,160,115,172,115,157,115,221,116,232,116,63,117,64,117,62,117,140,117,152,117,175,118,243,118,241,118,240,118,245,118,248,119,252,119,249,119,251,119,250,119,247,119,66,121,63,121,197,121,120,122,123,122,251,122,117,124,253,124,53,128,143,128,174,128,163,128,184,128,181,128,173,128,32,130,160,130,192,130,171,130,154,130,152,130,155,130,181,130,167,130,174,130,188,130,158,130,186,130,180,130,168,130,161,130,169,130,194,130,164,130,195,130,182,130,162,130,112,134,111,134,109,134,110,134,86,140,210,143,203,143,211,143,205,143,214,143,213,143,215,143,178,144,180,144,175,144,179,144,176,144,57,150,61,150,60,150,58,150,67,150,205,79,197,79,211,79,178,79,201,79,203,79,193,79,212,79,220,79,217,79,187,79,179,79,219,79,199,79,214,79,186,79,192,79,185,79,236,79,68,82,73,82,192,82,194,82,61,83,124,83,151,83,150,83,153,83,152,83,186,84,161,84,173,84,165,84,207,84,195,84,13,131,183,84,174,84,214,84,182,84,197,84,198,84,160,84,112,84,188,84,162,84,190,84,114,84,222,84,176,84,181,87,158,87,159,87,164,87,140,87,151,87,157,87,155,87,148,87,152,87,143,87,153,87,165,87,154,87,149,87,244,88,13,89,83,89,225,89,222,89,238,89,0,90,241,89,221,89,250,89,253,89,252,89,246,89,228,89,242,89,247,89,219,89,233,89,243,89,245,89,224,89,254,89,244,89,237,89,168,91,76,92,208,92,216,92,204,92,215,92,203,92,219,92,222,92,218,92,201,92,199,92,202,92,214,92,211,92,212,92,207,92,200,92,198,92,206,92,223,92,248,92,249,93,33,94,34,94,35,94,32,94,36,94,176,94,164,94,162,94,155,94,163,94,165,94,7,95,46,95,86,95,134,95,55,96,57,96,84,96,114,96,94,96,69,96,83,96,71,96,73,96,91,96,76,96,64,96,66,96,95,96,36,96,68,96,88,96,102,96,110,96,66,98,67,98,207,98,13,99,11,99,245,98,14,99,3,99,235,98,249,98,15,99,12,99,248,98,246,98,0,99,19,99,20,99,250,98,21,99,251,98,240,98,65,101,67,101,170,101,191,101,54,102,33,102,50,102,53,102,28,102,38,102,34,102,51,102,43,102,58,102,29,102,52,102,57,102,46,102,15,103,16,103,193,103,242,103,200,103,186,103,220,103,187,103,248,103,216,103,192,103,183,103,197,103,235,103,228,103,223,103,181,103,205,103,179,103,247,103,246,103,238,103,227,103,194,103,185,103,206,103,231,103,240,103,178,103,252,103,198,103,237,103,204,103,174,103,230,103,219,103,250,103,201,103,202,103,195,103,234,103,203,103,40,107,130,107,132,107,182,107,214,107,216,107,224,107,32,108,33,108,40,109,52,109,45,109,31,109,60,109,63,109,18,109,10,109,218,108,51,109,4,109,25,109,58,109,26,109,17,109,0,109,29,109,66,109,1,109,24,109,55,109,3,109,15,109,64,109,7,109,32,109,44,109,8,109,34,109,9,109,16,109,183,112,159,112,190,112,177,112,176,112,161,112,180,112,181,112,169,112,65,114,73,114,74,114,108,114,112,114,115,114,110,114,202,114,228,114,232,114,235,114,223,114,234,114,230,114,227,114,133,115,204,115,194,115,200,115,197,115,185,115,182,115,181,115,180,115,235,115,191,115,199,115,190,115,195,115,198,115,184,115,203,115,236,116,238,116,46,117,71,117,72,117,167,117,170,117,121,118,196,118,8,119,3,119,4,119,5,119,10,119,247,118,251,118,250,118,231,119,232,119,6,120,17,120,18,120,5,120,16,120,15,120,14,120,9,120,3,120,19,120,74,121,76,121,75,121,69,121,68,121,213,121,205,121,207,121,214,121,206,121,128,122,126,122,209,122,0,123,1,123,122,124,120,124,121,124,127,124,128,124,129,124,3,125,8,125,1,125,88,127,145,127,141,127,190,127,7,128,14,128,15,128,20,128,55,128,216,128,199,128,224,128,209,128,200,128,194,128,208,128,197,128,227,128,217,128,220,128,202,128,213,128,201,128,207,128,215,128,230,128,205,128,255,129,33,130,148,130,217,130,254,130,249,130,7,131,232,130,0,131,213,130,58,131,235,130,214,130,244,130,236,130,225,130,242,130,245,130,12,131,251,130,246,130,240,130,234,130,228,130,224,130,250,130,243,130,237,130,119,134,116,134,124,134,115,134,65,136,78,136,103,136,106,136,105,136,211,137,4,138,7,138,114,141,227,143,225,143,238,143,224,143,241,144,189,144,191,144,213,144,197,144,190,144,199,144,203,144,200,144,212,145,211,145,84,150,79,150,81,150,83,150,74,150,78,150,30,80,5,80,7,80,19,80,34,80,48,80,27,80,245,79,244,79,51,80,55,80,44,80,246,79,247,79,23,80,28,80,32,80,39,80,53,80,47,80,49,80,14,80,90,81,148,81,147,81,202,81,196,81,197,81,200,81,206,81,97,82,90,82,82,82,94,82,95,82,85,82,98,82,205,82,14,83,158,83,38,85,226,84,23,85,18,85,231,84,243,84,228,84,26,85,255,84,4,85,8,85,235,84,17,85,5,85,241,84,10,85,251,84,247,84,248,84,224,84,14,85,3,85,11,85,1,87,2,87,204,87,50,88,213,87,210,87,186,87,198,87,189,87,188,87,184,87,182,87,191,87,199,87,208,87,185,87,193,87,14,89,74,89,25,90,22,90,45,90,46,90,21,90,15,90,23,90,10,90,30,90,51,90,108,91,167,91,173,91,172,91,3,92,86,92,84,92,236,92,255,92,238,92,241,92,247,92,0,93,249,92,41,94,40,94,168,94,174,94,170,94,172,94,51,95,48,95,103,95,93,96,90,96,103,96,65,96,162,96,136,96,128,96,146,96,129,96,157,96,131,96,149,96,155,96,151,96,135,96,156,96,142,96,25,98,70,98,242,98,16,99,86,99,44,99,68,99,69,99,54,99,67,99,228,99,57,99,75,99,74,99,60,99,41,99,65,99,52,99,88,99,84,99,89,99,45,99,71,99,51,99,90,99,81,99,56,99,87,99,64,99,72,99,74,101,70,101,198,101,195,101,196,101,194,101,74,102,95,102,71,102,81,102,18,103,19,103,31,104,26,104,73,104,50,104,51,104,59,104,75,104,79,104,22,104,49,104,28,104,53,104,43,104,45,104,47,104,78,104,68,104,52,104,29,104,18,104,20,104,38,104,40,104,46,104,77,104,58,104,37,104,32,104,44,107,47,107,45,107,49,107,52,107,109,107,130,128,136,107,230,107,228,107,232,107,227,107,226,107,231,107,37,108,122,109,99,109,100,109,118,109,13,109,97,109,146,109,88,109,98,109,109,109,111,109,145,109,141,109,239,109,127,109,134,109,94,109,103,109,96,109,151,109,112,109,124,109,95,109,130,109,152,109,47,109,104,109,139,109,126,109,128,109,132,109,22,109,131,109,123,109,125,109,117,109,144,109,220,112,211,112,209,112,221,112,203,112,57,127,226,112,215,112,210,112,222,112,224,112,212,112,205,112,197,112,198,112,199,112,218,112,206,112,225,112,66,114,120,114,119,114,118,114,0,115,250,114,244,114,254,114,246,114,243,114,251,114,1,115,211,115,217,115,229,115,214,115,188,115,231,115,227,115,233,115,220,115,210,115,219,115,212,115,221,115,218,115,215,115,216,115,232,115,222,116,223,116,244,116,245,116,33,117,91,117,95,117,176,117,193,117,187,117,196,117,192,117,191,117,182,117,186,117,138,118,201,118,29,119,27,119,16,119,19,119,18,119,35,119,17,119,21,119,25,119,26,119,34,119,39,119,35,120,44,120,34,120,53,120,47,120,40,120,46,120,43,120,33,120,41,120,51,120,42,120,49,120,84,121,91,121,79,121,92,121,83,121,82,121,81,121,235,121,236,121,224,121,238,121,237,121,234,121,220,121,222,121,221,121,134,122,137,122,133,122,139,122,140,122,138,122,135,122,216,122,16,123,4,123,19,123,5,123,15,123,8,123,10,123,14,123,9,123,18,123,132,124,145,124,138,124,140,124,136,124,141,124,133,124,30,125,29,125,17,125,14,125,24,125,22,125,19,125,31,125,18,125,15,125,12,125,92,127,97,127,94,127,96,127,93,127,91,127,150,127,146,127,195,127,194,127,192,127,22,128,62,128,57,128,250,128,242,128,249,128,245,128,1,129,251,128,0,129,1,130,47,130,37,130,51,131,45,131,68,131,25,131,81,131,37,131,86,131,63,131,65,131,38,131,28,131,34,131,66,131,78,131,27,131,42,131,8,131,60,131,77,131,22,131,36,131,32,131,55,131,47,131,41,131,71,131,69,131,76,131,83,131,30,131,44,131,75,131,39,131,72,131,83,134,82,134,162,134,168,134,150,134,141,134,145,134,158,134,135,134,151,134,134,134,139,134,154,134,133,134,165,134,153,134,161,134,167,134,149,134,152,134,142,134,157,134,144,134,148,134,67,136,68,136,109,136,117,136,118,136,114,136,128,136,113,136,127,136,111,136,131,136,126,136,116,136,124,136,18,138,71,140,87,140,123,140,164,140,163,140,118,141,120,141,181,141,183,141,182,141,209,142,211,142,254,143,245,143,2,144,255,143,251,143,4,144,252,143,246,143,214,144,224,144,217,144,218,144,227,144,223,144,229,144,216,144,219,144,215,144,220,144,228,144,80,145,78,145,79,145,213,145,226,145,218,145,92,150,95,150,188,150,227,152,223,154,47,155,127,78,112,80,106,80,97,80,94,80,96,80,83,80,75,80,93,80,114,80,72,80,77,80,65,80,91,80,74,80,98,80,21,80,69,80,95,80,105,80,107,80,99,80,100,80,70,80,64,80,110,80,115,80,87,80,81,80,208,81,107,82,109,82,108,82,110,82,214,82,211,82,45,83,156,83,117,85,118,85,60,85,77,85,80,85,52,85,42,85,81,85,98,85,54,85,53,85,48,85,82,85,69,85,12,85,50,85,101,85,78,85,57,85,72,85,45,85,59,85,64,85,75,85,10,87,7,87,251,87,20,88,226,87,246,87,220,87,244,87,0,88,237,87,253,87,8,88,248,87,11,88,243,87,207,87,7,88,238,87,227,87,242,87,229,87,236,87,225,87,14,88,252,87,16,88,231,87,1,88,12,88,241,87,233,87,240,87,13,88,4,88,92,89,96,90,88,90,85,90,103,90,94,90,56,90,53,90,109,90,80,90,95,90,101,90,108,90,83,90,100,90,87,90,67,90,93,90,82,90,68,90,91,90,72,90,142,90,62,90,77,90,57,90,76,90,112,90,105,90,71,90,81,90,86,90,66,90,92,90,114,91,110,91,193,91,192,91,89,92,30,93,11,93,29,93,26,93,32,93,12,93,40,93,13,93,38,93,37,93,15,93,48,93,18,93,35,93,31,93,46,93,62,94,52,94,177,94,180,94,185,94,178,94,179,94,54,95,56,95,155,95,150,95,159,95,138,96,144,96,134,96,190,96,176,96,186,96,211,96,212,96,207,96,228,96,217,96,221,96,200,96,177,96,219,96,183,96,202,96,191,96,195,96,205,96,192,96,50,99,101,99,138,99,130,99,125,99,189,99,158,99,173,99,157,99,151,99,171,99,142,99,111,99,135,99,144,99,110,99,175,99,117,99,156,99,109,99,174,99,124,99,164,99,59,99,159,99,120,99,133,99,129,99,145,99,141,99,112,99,83,101,205,101,101,102,97,102,91,102,89,102,92,102,98,102,24,103,121,104,135,104,144,104,156,104,109,104,110,104,174,104,171,104,86,105,111,104,163,104,172,104,169,104,117,104,116,104,178,104,143,104,119,104,146,104,124,104,107,104,114,104,170,104,128,104,113,104,126,104,155,104,150,104,139,104,160,104,137,104,164,104,120,104,123,104,145,104,140,104,138,104,125,104,54,107,51,107,55,107,56,107,145,107,143,107,141,107,142,107,140,107,42,108,192,109,171,109,180,109,179,109,116,110,172,109,233,109,226,109,183,109,246,109,212,109,0,110,200,109,224,109,223,109,214,109,190,109,229,109,220,109,221,109,219,109,244,109,202,109,189,109,237,109,240,109,186,109,213,109,194,109,207,109,201,109,208,109,242,109,211,109,253,109,215,109,205,109,227,109,187,109,250,112,13,113,247,112,23,113,244,112,12,113,240,112,4,113,243,112,16,113,252,112,255,112,6,113,19,113,0,113,248,112,246,112,11,113,2,113,14,113,126,114,123,114,124,114,127,114,29,115,23,115,7,115,17,115,24,115,10,115,8,115,255,114,15,115,30,115,136,115,246,115,248,115,245,115,4,116,1,116,253,115,7,116,0,116,250,115,252,115,255,115,12,116,11,116,244,115,8,116,100,117,99,117,206,117,210,117,207,117,203,117,204,117,209,117,208,117,143,118,137,118,211,118,57,119,47,119,45,119,49,119,50,119,52,119,51,119,61,119,37,119,59,119,53,119,72,120,82,120,73,120,77,120,74,120,76,120,38,120,69,120,80,120,100,121,103,121,105,121,106,121,99,121,107,121,97,121,187,121,250,121,248,121,246,121,247,121,143,122,148,122,144,122,53,123,71,123,52,123,37,123,48,123,34,123,36,123,51,123,24,123,42,123,29,123,49,123,43,123,45,123,47,123,50,123,56,123,26,123,35,123,148,124,152,124,150,124,163,124,53,125,61,125,56,125,54,125,58,125,69,125,44,125,41,125,65,125,71,125,62,125,63,125,74,125,59,125,40,125,99,127,149,127,156,127,157,127,155,127,202,127,203,127,205,127,208,127,209,127,199,127,207,127,201,127,31,128,30,128,27,128,71,128,67,128,72,128,24,129,37,129,25,129,27,129,45,129,31,129,44,129,30,129,33,129,21,129,39,129,29,129,34,129,17,130,56,130,51,130,58,130,52,130,50,130,116,130,144,131,163,131,168,131,141,131,122,131,115,131,164,131,116,131,143,131,129,131,149,131,153,131,117,131,148,131,169,131,125,131,131,131,140,131,157,131,155,131,170,131,139,131,126,131,165,131,175,131,136,131,151,131,176,131,127,131,166,131,135,131,174,131,118,131,154,131,89,134,86,134,191,134,183,134,194,134,193,134,197,134,186,134,176,134,200,134,185,134,179,134,184,134,204,134,180,134,187,134,188,134,195,134,189,134,190,134,82,136,137,136,149,136,168,136,162,136,170,136,154,136,145,136,161,136,159,136,152,136,167,136,153,136,155,136,151,136,164,136,172,136,140,136,147,136,142,136,130,137,214,137,217,137,213,137,48,138,39,138,44,138,30,138,57,140,59,140,92,140,93,140,125,140,165,140,125,141,123,141,121,141,188,141,194,141,185,141,191,141,193,141,216,142,222,142,221,142,220,142,215,142,224,142,225,142,36,144,11,144,17,144,28,144,12,144,33,144,239,144,234,144,240,144,244,144,242,144,243,144,212,144,235,144,236,144,233,144,86,145,88,145,90,145,83,145,85,145,236,145,244,145,241,145,243,145,248,145,228,145,249,145,234,145,235,145,247,145,232,145,238,145,122,149,134,149,136,149,124,150,109,150,107,150,113,150,111,150,191,150,106,151,4,152,229,152,151,153,155,80,149,80,148,80,158,80,139,80,163,80,131,80,140,80,142,80,157,80,104,80,156,80,146,80,130,80,135,80,95,81,212,81,18,83,17,83,164,83,167,83,145,85,168,85,165,85,173,85,119,85,69,86,162,85,147,85,136,85,143,85,181,85,129,85,163,85,146,85,164,85,125,85,140,85,166,85,127,85,149,85,161,85,142,85,12,87,41,88,55,88,25,88,30,88,39,88,35,88,40,88,245,87,72,88,37,88,28,88,27,88,51,88,63,88,54,88,46,88,57,88,56,88,45,88,44,88,59,88,97,89,175,90,148,90,159,90,122,90,162,90,158,90,120,90,166,90,124,90,165,90,172,90,149,90,174,90,55,90,132,90,138,90,151,90,131,90,139,90,169,90,123,90,125,90,140,90,156,90,143,90,147,90,157,90,234,91,205,91,203,91,212,91,209,91,202,91,206,91,12,92,48,92,55,93,67,93,107,93,65,93,75,93,63,93,53,93,81,93,78,93,85,93,51,93,58,93,82,93,61,93,49,93,89,93,66,93,57,93,73,93,56,93,60,93,50,93,54,93,64,93,69,93,68,94,65,94,88,95,166,95,165,95,171,95,201,96,185,96,204,96,226,96,206,96,196,96,20,97,242,96,10,97,22,97,5,97,245,96,19,97,248,96,252,96,254,96,193,96,3,97,24,97,29,97,16,97,255,96,4,97,11,97,74,98,148,99,177,99,176,99,206,99,229,99,232,99,239,99,195,99,157,100,243,99,202,99,224,99,246,99,213,99,242,99,245,99,97,100,223,99,190,99,221,99,220,99,196,99,216,99,211,99,194,99,199,99,204,99,203,99,200,99,240,99,215,99,217,99,50,101,103,101,106,101,100,101,92,101,104,101,101,101,140,101,157,101,158,101,174,101,208,101,210,101,124,102,108,102,123,102,128,102,113,102,121,102,106,102,114,102,1,103,12,105,211,104,4,105,220,104,42,105,236,104,234,104,241,104,15,105,214,104,247,104,235,104,228,104,246,104,19,105,16,105,243,104,225,104,7,105,204,104,8,105,112,105,180,104,17,105,239,104,198,104,20,105,248,104,208,104,253,104,252,104,232,104,11,105,10,105,23,105,206,104,200,104,221,104,222,104,230,104,244,104,209,104,6,105,212,104,233,104,21,105,37,105,199,104,57,107,59,107,63,107,60,107,148,107,151,107,153,107,149,107,189,107,240,107,242,107,243,107,48,108,252,109,70,110,71,110,31,110,73,110,136,110,60,110,61,110,69,110,98,110,43,110,63,110,65,110,93,110,115,110,28,110,51,110,75,110,64,110,81,110,59,110,3,110,46,110,94,110,104,110,92,110,97,110,49,110,40,110,96,110,113,110,107,110,57,110,34,110,48,110,83,110,101,110,39,110,120,110,100,110,119,110,85,110,121,110,82,110,102,110,53,110,54,110,90,110,32,113,30,113,47,113,251,112,46,113,49,113,35,113,37,113,34,113,50,113,31,113,40,113,58,113,27,113,75,114,90,114,136,114,137,114,134,114,133,114,139,114,18,115,11,115,48,115,34,115,49,115,51,115,39,115,50,115,45,115,38,115,35,115,53,115,12,115,46,116,44,116,48,116,43,116,22,116,26,116,33,116,45,116,49,116,36,116,35,116,29,116,41,116,32,116,50,116,251,116,47,117,111,117,108,117,231,117,218,117,225,117,230,117,221,117,223,117,228,117,215,117,149,118,146,118,218,118,70,119,71,119,68,119,77,119,69,119,74,119,78,119,75,119,76,119,222,119,236,119,96,120,100,120,101,120,92,120,109,120,113,120,106,120,110,120,112,120,105,120,104,120,94,120,98,120,116,121,115,121,114,121,112,121,2,122,10,122,3,122,12,122,4,122,153,122,230,122,228,122,74,123,59,123,68,123,72,123,76,123,78,123,64,123,88,123,69,123,162,124,158,124,168,124,161,124,88,125,111,125,99,125,83,125,86,125,103,125,106,125,79,125,109,125,92,125,107,125,82,125,84,125,105,125,81,125,95,125,78,125,62,127,63,127,101,127,102,127,162,127,160,127,161,127,215,127,81,128,79,128,80,128,254,128,212,128,67,129,74,129,82,129,79,129,71,129,61,129,77,129,58,129,230,129,238,129,247,129,248,129,249,129,4,130,60,130,61,130,63,130,117,130,59,131,207,131,249,131,35,132,192,131,232,131,18,132,231,131,228,131,252,131,246,131,16,132,198,131,200,131,235,131,227,131,191,131,1,132,221,131,229,131,216,131,255,131,225,131,203,131,206,131,214,131,245,131,201,131,9,132,15,132,222,131,17,132,6,132,194,131,243,131,213,131,250,131,199,131,209,131,234,131,19,132,195,131,236,131,238,131,196,131,251,131,215,131,226,131,27,132,219,131,254,131,216,134,226,134,230,134,211,134,227,134,218,134,234,134,221,134,235,134,220,134,236,134,233,134,215,134,232,134,209,134,72,136,86,136,85,136,186,136,215,136,185,136,184,136,192,136,190,136,182,136,188,136,183,136,189,136,178,136,1,137,201,136,149,137,152,137,151,137,221,137,218,137,219,137,78,138,77,138,57,138,89,138,64,138,87,138,88,138,68,138,69,138,82,138,72,138,81,138,74,138,76,138,79,138,95,140,129,140,128,140,186,140,190,140,176,140,185,140,181,140,132,141,128,141,137,141,216,141,211,141,205,141,199,141,214,141,220,141,207,141,213,141,217,141,200,141,215,141,197,141,239,142,247,142,250,142,249,142,230,142,238,142,229,142,245,142,231,142,232,142,246,142,235,142,241,142,236,142,244,142,233,142,45,144,52,144,47,144,6,145,44,145,4,145,255,144,252,144,8,145,249,144,251,144,1,145,0,145,7,145,5,145,3,145,97,145,100,145,95,145,98,145,96,145,1,146,10,146,37,146,3,146,26,146,38,146,15,146,12,146,0,146,18,146,255,145,253,145,6,146,4,146,39,146,2,146,28,146,36,146,25,146,23,146,5,146,22,146,123,149,141,149,140,149,144,149,135,150,126,150,136,150,137,150,131,150,128,150,194,150,200,150,195,150,241,150,240,150,108,151,112,151,110,151,7,152,169,152,235,152,230,156,249,158,131,78,132,78,182,78,189,80,191,80,198,80,174,80,196,80,202,80,180,80,200,80,194,80,176,80,193,80,186,80,177,80,203,80,201,80,182,80,184,80,215,81,122,82,120,82,123,82,124,82,195,85,219,85,204,85,208,85,203,85,202,85,221,85,192,85,212,85,196,85,233,85,191,85,210,85,141,85,207,85,213,85,226,85,214,85,200,85,242,85,205,85,217,85,194,85,20,87,83,88,104,88,100,88,79,88,77,88,73,88,111,88,85,88,78,88,93,88,89,88,101,88,91,88,61,88,99,88,113,88,252,88,199,90,196,90,203,90,186,90,184,90,177,90,181,90,176,90,191,90,200,90,187,90,198,90,183,90,192,90,202,90,180,90,182,90,205,90,185,90,144,90,214,91,216,91,217,91,31,92,51,92,113,93,99,93,74,93,101,93,114,93,108,93,94,93,104,93,103,93,98,93,240,93,79,94,78,94,74,94,77,94,75,94,197,94,204,94,198,94,203,94,199,94,64,95,175,95,173,95,247,96,73,97,74,97,43,97,69,97,54,97,50,97,46,97,70,97,47,97,79,97,41,97,64,97,32,98,104,145,35,98,37,98,36,98,197,99,241,99,235,99,16,100,18,100,9,100,32,100,36,100,51,100,67,100,31,100,21,100,24,100,57,100,55,100,34,100,35,100,12,100,38,100,48,100,40,100,65,100,53,100,47,100,10,100,26,100,64,100,37,100,39,100,11,100,231,99,27,100,46,100,33,100,14,100,111,101,146,101,211,101,134,102,140,102,149,102,144,102,139,102,138,102,153,102,148,102,120,102,32,103,102,105,95,105,56,105,78,105,98,105,113,105,63,105,69,105,106,105,57,105,66,105,87,105,89,105,122,105,72,105,73,105,53,105,108,105,51,105,61,105,101,105,240,104,120,105,52,105,105,105,64,105,111,105,68,105,118,105,88,105,65,105,116,105,76,105,59,105,75,105,55,105,92,105,79,105,81,105,50,105,82,105,47,105,123,105,60,105,70,107,69,107,67,107,66,107,72,107,65,107,155,107,13,250,251,107,252,107,249,107,247,107,248,107,155,110,214,110,200,110,143,110,192,110,159,110,147,110,148,110,160,110,177,110,185,110,198,110,210,110,189,110,193,110,158,110,201,110,183,110,176,110,205,110,166,110,207,110,178,110,190,110,195,110,220,110,216,110,153,110,146,110,142,110,141,110,164,110,161,110,191,110,179,110,208,110,202,110,151,110,174,110,163,110,71,113,84,113,82,113,99,113,96,113,65,113,93,113,98,113,114,113,120,113,106,113,97,113,66,113,88,113,67,113,75,113,112,113,95,113,80,113,83,113,68,113,77,113,90,113,79,114,141,114,140,114,145,114,144,114,142,114,60,115,66,115,59,115,58,115,64,115,74,115,73,115,68,116,74,116,75,116,82,116,81,116,87,116,64,116,79,116,80,116,78,116,66,116,70,116,77,116,84,116,225,116,255,116,254,116,253,116,29,117,121,117,119,117,131,105,239,117,15,118,3,118,247,117,254,117,252,117,249,117,248,117,16,118,251,117,246,117,237,117,245,117,253,117,153,118,181,118,221,118,85,119,95,119,96,119,82,119,86,119,90,119,105,119,103,119,84,119,89,119,109,119,224,119,135,120,154,120,148,120,143,120,132,120,149,120,133,120,134,120,161,120,131,120,121,120,153,120,128,120,150,120,123,120,124,121,130,121,125,121,121,121,17,122,24,122,25,122,18,122,23,122,21,122,34,122,19,122,27,122,16,122,163,122,162,122,158,122,235,122,102,123,100,123,109,123,116,123,105,123,114,123,101,123,115,123,113,123,112,123,97,123,120,123,118,123,99,123,178,124,180,124,175,124,136,125,134,125,128,125,141,125,127,125,133,125,122,125,142,125,123,125,131,125,124,125,140,125,148,125,132,125,125,125,146,125,109,127,107,127,103,127,104,127,108,127,166,127,165,127,167,127,219,127,220,127,33,128,100,129,96,129,119,129,92,129,105,129,91,129,98,129,114,129,33,103,94,129,118,129,103,129,111,129,68,129,97,129,29,130,73,130,68,130,64,130,66,130,69,130,241,132,63,132,86,132,118,132,121,132,143,132,141,132,101,132,81,132,64,132,134,132,103,132,48,132,77,132,125,132,90,132,89,132,116,132,115,132,93,132,7,133,94,132,55,132,58,132,52,132,122,132,67,132,120,132,50,132,69,132,41,132,217,131,75,132,47,132,66,132,45,132,95,132,112,132,57,132,78,132,76,132,82,132,111,132,197,132,142,132,59,132,71,132,54,132,51,132,104,132,126,132,68,132,43,132,96,132,84,132,110,132,80,132,11,135,4,135,247,134,12,135,250,134,214,134,245,134,77,135,248,134,14,135,9,135,1,135,246,134,13,135,5,135,214,136,203,136,205,136,206,136,222,136,219,136,218,136,204,136,208,136,133,137,155,137,223,137,229,137,228,137,225,137,224,137,226,137,220,137,230,137,118,138,134,138,127,138,97,138,63,138,119,138,130,138,132,138,117,138,131,138,129,138,116,138,122,138,60,140,75,140,74,140,101,140,100,140,102,140,134,140,132,140,133,140,204,140,104,141,105,141,145,141,140,141,142,141,143,141,141,141,147,141,148,141,144,141,146,141,240,141,224,141,236,141,241,141,238,141,208,141,233,141,227,141,226,141,231,141,242,141,235,141,244,141,6,143,255,142,1,143,0,143,5,143,7,143,8,143,2,143,11,143,82,144,63,144,68,144,73,144,61,144,16,145,13,145,15,145,17,145,22,145,20,145,11,145,14,145,110,145,111,145,72,146,82,146,48,146,58,146,102,146,51,146,101,146,94,146,131,146,46,146,74,146,70,146,109,146,108,146,79,146,96,146,103,146,111,146,54,146,97,146,112,146,49,146,84,146,99,146,80,146,114,146,78,146,83,146,76,146,86,146,50,146,159,149,156,149,158,149,155,149,146,150,147,150,145,150,151,150,206,150,250,150,253,150,248,150,245,150,115,151,119,151,120,151,114,151,15,152,13,152,14,152,172,152,246,152,249,152,175,153,178,153,176,153,181,153,173,154,171,154,91,155,234,156,237,156,231,156,128,158,253,158,230,80,212,80,215,80,232,80,243,80,219,80,234,80,221,80,228,80,211,80,236,80,240,80,239,80,227,80,224,80,216,81,128,82,129,82,233,82,235,82,48,83,172,83,39,86,21,86,12,86,18,86,252,85,15,86,28,86,1,86,19,86,2,86,250,85,29,86,4,86,255,85,249,85,137,88,124,88,144,88,152,88,134,88,129,88,127,88,116,88,139,88,122,88,135,88,145,88,142,88,118,88,130,88,136,88,123,88,148,88,143,88,254,88,107,89,220,90,238,90,229,90,213,90,234,90,218,90,237,90,235,90,243,90,226,90,224,90,219,90,236,90,222,90,221,90,217,90,232,90,223,90,119,91,224,91,227,91,99,92,130,93,128,93,125,93,134,93,122,93,129,93,119,93,138,93,137,93,136,93,126,93,124,93,141,93,121,93,127,93,88,94,89,94,83,94,216,94,209,94,215,94,206,94,220,94,213,94,217,94,210,94,212,94,68,95,67,95,111,95,182,95,44,97,40,97,65,97,94,97,113,97,115,97,82,97,83,97,114,97,108,97,128,97,116,97,84,97,122,97,91,97,101,97,59,97,106,97,97,97,86,97,41,98,39,98,43,98,43,100,77,100,91,100,93,100,116,100,118,100,114,100,115,100,125,100,117,100,102,100,166,100,78,100,130,100,94,100,92,100,75,100,83,100,96,100,80,100,127,100,63,100,108,100,107,100,89,100,101,100,119,100,115,101,160,101,161,102,160,102,159,102,5,103,4,103,34,103,177,105,182,105,201,105,160,105,206,105,150,105,176,105,172,105,188,105,145,105,153,105,142,105,167,105,141,105,169,105,190,105,175,105,191,105,196,105,189,105,164,105,212,105,185,105,202,105,154,105,207,105,179,105,147,105,170,105,161,105,158,105,217,105,151,105,144,105,194,105,181,105,165,105,198,105,74,107,77,107,75,107,158,107,159,107,160,107,195,107,196,107,254,107,206,110,245,110,241,110,3,111,37,111,248,110,55,111,251,110,46,111,9,111,78,111,25,111,26,111,39,111,24,111,59,111,18,111,237,110,10,111,54,111,115,111,249,110,238,110,45,111,64,111,48,111,60,111,53,111,235,110,7,111,14,111,67,111,5,111,253,110,246,110,57,111,28,111,252,110,58,111,31,111,13,111,30,111,8,111,33,111,135,113,144,113,137,113,128,113,133,113,130,113,143,113,123,113,134,113,129,113,151,113,68,114,83,114,151,114,149,114,147,114,67,115,77,115,81,115,76,115,98,116,115,116,113,116,117,116,114,116,103,116,110,116,0,117,2,117,3,117,125,117,144,117,22,118,8,118,12,118,21,118,17,118,10,118,20,118,184,118,129,119,124,119,133,119,130,119,110,119,128,119,111,119,126,119,131,119,178,120,170,120,180,120,173,120,168,120,126,120,171,120,158,120,165,120,160,120,172,120,162,120,164,120,152,121,138,121,139,121,150,121,149,121,148,121,147,121,151,121,136,121,146,121,144,121,43,122,74,122,48,122,47,122,40,122,38,122,168,122,171,122,172,122,238,122,136,123,156,123,138,123,145,123,144,123,150,123,141,123,140,123,155,123,142,123,133,123,152,123,132,82,153,123,164,123,130,123,187,124,191,124,188,124,186,124,167,125,183,125,194,125,163,125,170,125,193,125,192,125,197,125,157,125,206,125,196,125,198,125,203,125,204,125,175,125,185,125,150,125,188,125,159,125,166,125,174,125,169,125,161,125,201,125,115,127,226,127,227,127,229,127,222,127,36,128,93,128,92,128,137,129,134,129,131,129,135,129,141,129,140,129,139,129,21,130,151,132,164,132,161,132,159,132,186,132,206,132,194,132,172,132,174,132,171,132,185,132,180,132,193,132,205,132,170,132,154,132,177,132,208,132,157,132,167,132,187,132,162,132,148,132,199,132,204,132,155,132,169,132,175,132,168,132,214,132,152,132,182,132,207,132,160,132,215,132,212,132,210,132,219,132,176,132,145,132,97,134,51,135,35,135,40,135,107,135,64,135],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+292068),
allocate([46,135,30,135,33,135,25,135,27,135,67,135,44,135,65,135,62,135,70,135,32,135,50,135,42,135,45,135,60,135,18,135,58,135,49,135,53,135,66,135,38,135,39,135,56,135,36,135,26,135,48,135,17,135,247,136,231,136,241,136,242,136,250,136,254,136,238,136,252,136,246,136,251,136,240,136,236,136,235,136,157,137,161,137,159,137,158,137,233,137,235,137,232,137,171,138,153,138,139,138,146,138,143,138,150,138,61,140,104,140,105,140,213,140,207,140,215,140,150,141,9,142,2,142,255,141,13,142,253,141,10,142,3,142,7,142,6,142,5,142,254,141,0,142,4,142,16,143,17,143,14,143,13,143,35,145,28,145,32,145,34,145,31,145,29,145,26,145,36,145,33,145,27,145,122,145,114,145,121,145,115,145,165,146,164,146,118,146,155,146,122,146,160,146,148,146,170,146,141,146,166,146,154,146,171,146,121,146,151,146,127,146,163,146,238,146,142,146,130,146,149,146,162,146,125,146,136,146,161,146,138,146,134,146,140,146,153,146,167,146,126,146,135,146,169,146,157,146,139,146,45,146,158,150,161,150,255,150,88,151,125,151,122,151,126,151,131,151,128,151,130,151,123,151,132,151,129,151,127,151,206,151,205,151,22,152,173,152,174,152,2,153,0,153,7,153,157,153,156,153,195,153,185,153,187,153,186,153,194,153,189,153,199,153,177,154,227,154,231,154,62,155,63,155,96,155,97,155,95,155,241,156,242,156,245,156,167,158,255,80,3,81,48,81,248,80,6,81,7,81,246,80,254,80,11,81,12,81,253,80,10,81,139,82,140,82,241,82,239,82,72,86,66,86,76,86,53,86,65,86,74,86,73,86,70,86,88,86,90,86,64,86,51,86,61,86,44,86,62,86,56,86,42,86,58,86,26,87,171,88,157,88,177,88,160,88,163,88,175,88,172,88,165,88,161,88,255,88,255,90,244,90,253,90,247,90,246,90,3,91,248,90,2,91,249,90,1,91,7,91,5,91,15,91,103,92,153,93,151,93,159,93,146,93,162,93,147,93,149,93,160,93,156,93,161,93,154,93,158,93,105,94,93,94,96,94,92,94,243,125,219,94,222,94,225,94,73,95,178,95,139,97,131,97,121,97,177,97,176,97,162,97,137,97,155,97,147,97,175,97,173,97,159,97,146,97,170,97,161,97,141,97,102,97,179,97,45,98,110,100,112,100,150,100,160,100,133,100,151,100,156,100,143,100,139,100,138,100,140,100,163,100,159,100,104,100,177,100,152,100,118,101,122,101,121,101,123,101,178,101,179,101,181,102,176,102,169,102,178,102,183,102,170,102,175,102,0,106,6,106,23,106,229,105,248,105,21,106,241,105,228,105,32,106,255,105,236,105,226,105,27,106,29,106,254,105,39,106,242,105,238,105,20,106,247,105,231,105,64,106,8,106,230,105,251,105,13,106,252,105,235,105,9,106,4,106,24,106,37,106,15,106,246,105,38,106,7,106,244,105,22,106,81,107,165,107,163,107,162,107,166,107,1,108,0,108,255,107,2,108,65,111,38,111,126,111,135,111,198,111,146,111,141,111,137,111,140,111,98,111,79,111,133,111,90,111,150,111,118,111,108,111,130,111,85,111,114,111,82,111,80,111,87,111,148,111,147,111,93,111,0,111,97,111,107,111,125,111,103,111,144,111,83,111,139,111,105,111,127,111,149,111,99,111,119,111,106,111,123,111,178,113,175,113,155,113,176,113,160,113,154,113,169,113,181,113,157,113,165,113,158,113,164,113,161,113,170,113,156,113,167,113,179,113,152,114,154,114,88,115,82,115,94,115,95,115,96,115,93,115,91,115,97,115,90,115,89,115,98,115,135,116,137,116,138,116,134,116,129,116,125,116,133,116,136,116,124,116,121,116,8,117,7,117,126,117,37,118,30,118,25,118,29,118,28,118,35,118,26,118,40,118,27,118,156,118,157,118,158,118,155,118,141,119,143,119,137,119,136,119,205,120,187,120,207,120,204,120,209,120,206,120,212,120,200,120,195,120,196,120,201,120,154,121,161,121,160,121,156,121,162,121,155,121,118,107,57,122,178,122,180,122,179,122,183,123,203,123,190,123,172,123,206,123,175,123,185,123,202,123,181,123,197,124,200,124,204,124,203,124,247,125,219,125,234,125,231,125,215,125,225,125,3,126,250,125,230,125,246,125,241,125,240,125,238,125,223,125,118,127,172,127,176,127,173,127,237,127,235,127,234,127,236,127,230,127,232,127,100,128,103,128,163,129,159,129,158,129,149,129,162,129,153,129,151,129,22,130,79,130,83,130,82,130,80,130,78,130,81,130,36,133,59,133,15,133,0,133,41,133,14,133,9,133,13,133,31,133,10,133,39,133,28,133,251,132,43,133,250,132,8,133,12,133,244,132,42,133,242,132,21,133,247,132,235,132,243,132,252,132,18,133,234,132,233,132,22,133,254,132,40,133,29,133,46,133,2,133,253,132,30,133,246,132,49,133,38,133,231,132,232,132,240,132,239,132,249,132,24,133,32,133,48,133,11,133,25,133,47,133,98,134,86,135,99,135,100,135,119,135,225,135,115,135,88,135,84,135,91,135,82,135,97,135,90,135,81,135,94,135,109,135,106,135,80,135,78,135,95,135,93,135,111,135,108,135,122,135,110,135,92,135,101,135,79,135,123,135,117,135,98,135,103,135,105,135,90,136,5,137,12,137,20,137,11,137,23,137,24,137,25,137,6,137,22,137,17,137,14,137,9,137,162,137,164,137,163,137,237,137,240,137,236,137,207,138,198,138,184,138,211,138,209,138,212,138,213,138,187,138,215,138,190,138,192,138,197,138,216,138,195,138,186,138,189,138,217,138,62,140,77,140,143,140,229,140,223,140,217,140,232,140,218,140,221,140,231,140,160,141,156,141,161,141,155,141,32,142,35,142,37,142,36,142,46,142,21,142,27,142,22,142,17,142,25,142,38,142,39,142,20,142,18,142,24,142,19,142,28,142,23,142,26,142,44,143,36,143,24,143,26,143,32,143,35,143,22,143,23,143,115,144,112,144,111,144,103,144,107,144,47,145,43,145,41,145,42,145,50,145,38,145,46,145,133,145,134,145,138,145,129,145,130,145,132,145,128,145,208,146,195,146,196,146,192,146,217,146,182,146,207,146,241,146,223,146,216,146,233,146,215,146,221,146,204,146,239,146,194,146,232,146,202,146,200,146,206,146,230,146,205,146,213,146,201,146,224,146,222,146,231,146,209,146,211,146,181,146,225,146,198,146,180,146,124,149,172,149,171,149,174,149,176,149,164,150,162,150,211,150,5,151,8,151,2,151,90,151,138,151,142,151,136,151,208,151,207,151,30,152,29,152,38,152,41,152,40,152,32,152,27,152,39,152,178,152,8,153,250,152,17,153,20,153,22,153,23,153,21,153,220,153,205,153,207,153,211,153,212,153,206,153,201,153,214,153,216,153,203,153,215,153,204,153,179,154,236,154,235,154,243,154,242,154,241,154,70,155,67,155,103,155,116,155,113,155,102,155,118,155,117,155,112,155,104,155,100,155,108,155,252,156,250,156,253,156,255,156,247,156,7,157,0,157,249,156,251,156,8,157,5,157,4,157,131,158,211,158,15,159,16,159,28,81,19,81,23,81,26,81,17,81,222,81,52,83,225,83,112,86,96,86,110,86,115,86,102,86,99,86,109,86,114,86,94,86,119,86,28,87,27,87,200,88,189,88,201,88,191,88,186,88,194,88,188,88,198,88,23,91,25,91,27,91,33,91,20,91,19,91,16,91,22,91,40,91,26,91,32,91,30,91,239,91,172,93,177,93,169,93,167,93,181,93,176,93,174,93,170,93,168,93,178,93,173,93,175,93,180,93,103,94,104,94,102,94,111,94,233,94,231,94,230,94,232,94,229,94,75,95,188,95,157,97,168,97,150,97,197,97,180,97,198,97,193,97,204,97,186,97,191,97,184,97,140,97,215,100,214,100,208,100,207,100,201,100,189,100,137,100,195,100,219,100,243,100,217,100,51,101,127,101,124,101,162,101,200,102,190,102,192,102,202,102,203,102,207,102,189,102,187,102,186,102,204,102,35,103,52,106,102,106,73,106,103,106,50,106,104,106,62,106,93,106,109,106,118,106,91,106,81,106,40,106,90,106,59,106,63,106,65,106,106,106,100,106,80,106,79,106,84,106,111,106,105,106,96,106,60,106,94,106,86,106,85,106,77,106,78,106,70,106,85,107,84,107,86,107,167,107,170,107,171,107,200,107,199,107,4,108,3,108,6,108,173,111,203,111,163,111,199,111,188,111,206,111,200,111,94,111,196,111,189,111,158,111,202,111,168,111,4,112,165,111,174,111,186,111,172,111,170,111,207,111,191,111,184,111,162,111,201,111,171,111,205,111,175,111,178,111,176,111,197,113,194,113,191,113,184,113,214,113,192,113,193,113,203,113,212,113,202,113,199,113,207,113,189,113,216,113,188,113,198,113,218,113,219,113,157,114,158,114,105,115,102,115,103,115,108,115,101,115,107,115,106,115,127,116,154,116,160,116,148,116,146,116,149,116,161,116,11,117,128,117,47,118,45,118,49,118,61,118,51,118,60,118,53,118,50,118,48,118,187,118,230,118,154,119,157,119,161,119,156,119,155,119,162,119,163,119,149,119,153,119,151,119,221,120,233,120,229,120,234,120,222,120,227,120,219,120,225,120,226,120,237,120,223,120,224,120,164,121,68,122,72,122,71,122,182,122,184,122,181,122,177,122,183,122,222,123,227,123,231,123,221,123,213,123,229,123,218,123,232,123,249,123,212,123,234,123,226,123,220,123,235,123,216,123,223,123,210,124,212,124,215,124,208,124,209,124,18,126,33,126,23,126,12,126,31,126,32,126,19,126,14,126,28,126,21,126,26,126,34,126,11,126,15,126,22,126,13,126,20,126,37,126,36,126,67,127,123,127,124,127,122,127,177,127,239,127,42,128,41,128,108,128,177,129,166,129,174,129,185,129,181,129,171,129,176,129,172,129,180,129,178,129,183,129,167,129,242,129,85,130,86,130,87,130,86,133,69,133,107,133,77,133,83,133,97,133,88,133,64,133,70,133,100,133,65,133,98,133,68,133,81,133,71,133,99,133,62,133,91,133,113,133,78,133,110,133,117,133,85,133,103,133,96,133,140,133,102,133,93,133,84,133,101,133,108,133,99,134,101,134,100,134,155,135,143,135,151,135,147,135,146,135,136,135,129,135,150,135,152,135,121,135,135,135,163,135,133,135,144,135,145,135,157,135,132,135,148,135,156,135,154,135,137,135,30,137,38,137,48,137,45,137,46,137,39,137,49,137,34,137,41,137,35,137,47,137,44,137,31,137,241,137,224,138,226,138,242,138,244,138,245,138,221,138,20,139,228,138,223,138,240,138,200,138,222,138,225,138,232,138,255,138,239,138,251,138,145,140,146,140,144,140,245,140,238,140,241,140,240,140,243,140,108,141,110,141,165,141,167,141,51,142,62,142,56,142,64,142,69,142,54,142,60,142,61,142,65,142,48,142,63,142,189,142,54,143,46,143,53,143,50,143,57,143,55,143,52,143,118,144,121,144,123,144,134,144,250,144,51,145,53,145,54,145,147,145,144,145,145,145,141,145,143,145,39,147,30,147,8,147,31,147,6,147,15,147,122,147,56,147,60,147,27,147,35,147,18,147,1,147,70,147,45,147,14,147,13,147,203,146,29,147,250,146,37,147,19,147,249,146,247,146,52,147,2,147,36,147,255,146,41,147,57,147,53,147,42,147,20,147,12,147,11,147,254,146,9,147,0,147,251,146,22,147,188,149,205,149,190,149,185,149,186,149,182,149,191,149,181,149,189,149,169,150,212,150,11,151,18,151,16,151,153,151,151,151,148,151,240,151,248,151,53,152,47,152,50,152,36,153,31,153,39,153,41,153,158,153,238,153,236,153,229,153,228,153,240,153,227,153,234,153,233,153,231,153,185,154,191,154,180,154,187,154,246,154,250,154,249,154,247,154,51,155,128,155,133,155,135,155,124,155,126,155,123,155,130,155,147,155,146,155,144,155,122,155,149,155,125,155,136,155,37,157,23,157,32,157,30,157,20,157,41,157,29,157,24,157,34,157,16,157,25,157,31,157,136,158,134,158,135,158,174,158,173,158,213,158,214,158,250,158,18,159,61,159,38,81,37,81,34,81,36,81,32,81,41,81,244,82,147,86,140,86,141,86,134,86,132,86,131,86,126,86,130,86,127,86,129,86,214,88,212,88,207,88,210,88,45,91,37,91,50,91,35,91,44,91,39,91,38,91,47,91,46,91,123,91,241,91,242,91,183,93,108,94,106,94,190,95,187,95,195,97,181,97,188,97,231,97,224,97,229,97,228,97,232,97,222,97,239,100,233,100,227,100,235,100,228,100,232,100,129,101,128,101,182,101,218,101,210,102,141,106,150,106,129,106,165,106,137,106,159,106,155,106,161,106,158,106,135,106,147,106,142,106,149,106,131,106,168,106,164,106,145,106,127,106,166,106,154,106,133,106,140,106,146,106,91,107,173,107,9,108,204,111,169,111,244,111,212,111,227,111,220,111,237,111,231,111,230,111,222,111,242,111,221,111,226,111,232,111,225,113,241,113,232,113,242,113,228,113,240,113,226,113,115,115,110,115,111,115,151,116,178,116,171,116,144,116,170,116,173,116,177,116,165,116,175,116,16,117,17,117,18,117,15,117,132,117,67,118,72,118,73,118,71,118,164,118,233,118,181,119,171,119,178,119,183,119,182,119,180,119,177,119,168,119,240,119,243,120,253,120,2,121,251,120,252,120,242,120,5,121,249,120,254,120,4,121,171,121,168,121,92,122,91,122,86,122,88,122,84,122,90,122,190,122,192,122,193,122,5,124,15,124,242,123,0,124,255,123,251,123,14,124,244,123,11,124,243,123,2,124,9,124,3,124,1,124,248,123,253,123,6,124,240,123,241,123,16,124,10,124,232,124,45,126,60,126,66,126,51,126,72,152,56,126,42,126,73,126,64,126,71,126,41,126,76,126,48,126,59,126,54,126,68,126,58,126,69,127,127,127,126,127,125,127,244,127,242,127,44,128,187,129,196,129,204,129,202,129,197,129,199,129,188,129,233,129,91,130,90,130,92,130,131,133,128,133,143,133,167,133,149,133,160,133,139,133,163,133,123,133,164,133,154,133,158,133,119,133,124,133,137,133,161,133,122,133,120,133,87,133,142,133,150,133,134,133,141,133,153,133,157,133,129,133,162,133,130,133,136,133,133,133,121,133,118,133,152,133,144,133,159,133,104,134,190,135,170,135,173,135,197,135,176,135,172,135,185,135,181,135,188,135,174,135,201,135,195,135,194,135,204,135,183,135,175,135,196,135,202,135,180,135,182,135,191,135,184,135,189,135,222,135,178,135,53,137,51,137,60,137,62,137,65,137,82,137,55,137,66,137,173,137,175,137,174,137,242,137,243,137,30,139,24,139,22,139,17,139,5,139,11,139,34,139,15,139,18,139,21,139,7,139,13,139,8,139,6,139,28,139,19,139,26,139,79,140,112,140,114,140,113,140,111,140,149,140,148,140,249,140,111,141,78,142,77,142,83,142,80,142,76,142,71,142,67,143,64,143,133,144,126,144,56,145,154,145,162,145,155,145,153,145,159,145,161,145,157,145,160,145,161,147,131,147,175,147,100,147,86,147,71,147,124,147,88,147,92,147,118,147,73,147,80,147,81,147,96,147,109,147,143,147,76,147,106,147,121,147,87,147,85,147,82,147,79,147,113,147,119,147,123,147,97,147,94,147,99,147,103,147,128,147,78,147,89,147,199,149,192,149,201,149,195,149,197,149,183,149,174,150,176,150,172,150,32,151,31,151,24,151,29,151,25,151,154,151,161,151,156,151,158,151,157,151,213,151,212,151,241,151,65,152,68,152,74,152,73,152,69,152,67,152,37,153,43,153,44,153,42,153,51,153,50,153,47,153,45,153,49,153,48,153,152,153,163,153,161,153,2,154,250,153,244,153,247,153,249,153,248,153,246,153,251,153,253,153,254,153,252,153,3,154,190,154,254,154,253,154,1,155,252,154,72,155,154,155,168,155,158,155,155,155,166,155,161,155,165,155,164,155,134,155,162,155,160,155,175,155,51,157,65,157,103,157,54,157,46,157,47,157,49,157,56,157,48,157,69,157,66,157,67,157,62,157,55,157,64,157,61,157,245,127,45,157,138,158,137,158,141,158,176,158,200,158,218,158,251,158,255,158,36,159,35,159,34,159,84,159,160,159,49,81,45,81,46,81,152,86,156,86,151,86,154,86,157,86,153,86,112,89,60,91,105,92,106,92,192,93,109,94,110,94,216,97,223,97,237,97,238,97,241,97,234,97,240,97,235,97,214,97,233,97,255,100,4,101,253,100,248,100,1,101,3,101,252,100,148,101,219,101,218,102,219,102,216,102,197,106,185,106,189,106,225,106,198,106,186,106,182,106,183,106,199,106,180,106,173,106,94,107,201,107,11,108,7,112,12,112,13,112,1,112,5,112,20,112,14,112,255,111,0,112,251,111,38,112,252,111,247,111,10,112,1,114,255,113,249,113,3,114,253,113,118,115,184,116,192,116,181,116,193,116,190,116,182,116,187,116,194,116,20,117,19,117,92,118,100,118,89,118,80,118,83,118,87,118,90,118,166,118,189,118,236,118,194,119,186,119,255,120,12,121,19,121,20,121,9,121,16,121,18,121,17,121,173,121,172,121,95,122,28,124,41,124,25,124,32,124,31,124,45,124,29,124,38,124,40,124,34,124,37,124,48,124,92,126,80,126,86,126,99,126,88,126,98,126,95,126,81,126,96,126,87,126,83,126,181,127,179,127,247,127,248,127,117,128,209,129,210,129,208,129,95,130,94,130,180,133,198,133,192,133,195,133,194,133,179,133,181,133,189,133,199,133,196,133,191,133,203,133,206,133,200,133,197,133,177,133,182,133,210,133,36,134,184,133,183,133,190,133,105,134,231,135,230,135,226,135,219,135,235,135,234,135,229,135,223,135,243,135,228,135,212,135,220,135,211,135,237,135,216,135,227,135,164,135,215,135,217,135,1,136,244,135,232,135,221,135,83,137,75,137,79,137,76,137,70,137,80,137,81,137,73,137,42,139,39,139,35,139,51,139,48,139,53,139,71,139,47,139,60,139,62,139,49,139,37,139,55,139,38,139,54,139,46,139,36,139,59,139,61,139,58,139,66,140,117,140,153,140,152,140,151,140,254,140,4,141,2,141,0,141,92,142,98,142,96,142,87,142,86,142,94,142,101,142,103,142,91,142,90,142,97,142,93,142,105,142,84,142,70,143,71,143,72,143,75,143,40,145,58,145,59,145,62,145,168,145,165,145,167,145,175,145,170,145,181,147,140,147,146,147,183,147,155,147,157,147,137,147,167,147,142,147,170,147,158,147,166,147,149,147,136,147,153,147,159,147,141,147,177,147,145,147,178,147,164,147,168,147,180,147,163,147,165,147,210,149,211,149,209,149,179,150,215,150,218,150,194,93,223,150,216,150,221,150,35,151,34,151,37,151,172,151,174,151,168,151,171,151,164,151,170,151,162,151,165,151,215,151,217,151,214,151,216,151,250,151,80,152,81,152,82,152,184,152,65,153,60,153,58,153,15,154,11,154,9,154,13,154,4,154,17,154,10,154,5,154,7,154,6,154,192,154,220,154,8,155,4,155,5,155,41,155,53,155,74,155,76,155,75,155,199,155,198,155,195,155,191,155,193,155,181,155,184,155,211,155,182,155,196,155,185,155,189,155,92,157,83,157,79,157,74,157,91,157,75,157,89,157,86,157,76,157,87,157,82,157,84,157,95,157,88,157,90,157,142,158,140,158,223,158,1,159,0,159,22,159,37,159,43,159,42,159,41,159,40,159,76,159,85,159,52,81,53,81,150,82,247,82,180,83,171,86,173,86,166,86,167,86,170,86,172,86,218,88,221,88,219,88,18,89,61,91,62,91,63,91,195,93,112,94,191,95,251,97,7,101,16,101,13,101,9,101,12,101,14,101,132,101,222,101,221,101,222,102,231,106,224,106,204,106,209,106,217,106,203,106,223,106,220,106,208,106,235,106,207,106,205,106,222,106,96,107,176,107,12,108,25,112,39,112,32,112,22,112,43,112,33,112,34,112,35,112,41,112,23,112,36,112,28,112,42,112,12,114,10,114,7,114,2,114,5,114,165,114,166,114,164,114,163,114,161,114,203,116,197,116,183,116,195,116,22,117,96,118,201,119,202,119,196,119,241,119,29,121,27,121,33,121,28,121,23,121,30,121,176,121,103,122,104,122,51,124,60,124,57,124,44,124,59,124,236,124,234,124,118,126,117,126,120,126,112,126,119,126,111,126,122,126,114,126,116,126,104,126,75,127,74,127,131,127,134,127,183,127,253,127,254,127,120,128,215,129,213,129,100,130,97,130,99,130,235,133,241,133,237,133,217,133,225,133,232,133,218,133,215,133,236,133,242,133,248,133,216,133,223,133,227,133,220,133,209,133,240,133,230,133,239,133,222,133,226,133,0,136,250,135,3,136,246,135,247,135,9,136,12,136,11,136,6,136,252,135,8,136,255,135,10,136,2,136,98,137,90,137,91,137,87,137,97,137,92,137,88,137,93,137,89,137,136,137,183,137,182,137,246,137,80,139,72,139,74,139,64,139,83,139,86,139,84,139,75,139,85,139,81,139,66,139,82,139,87,139,67,140,119,140,118,140,154,140,6,141,7,141,9,141,172,141,170,141,173,141,171,141,109,142,120,142,115,142,106,142,111,142,123,142,194,142,82,143,81,143,79,143,80,143,83,143,180,143,64,145,63,145,176,145,173,145,222,147,199,147,207,147,194,147,218,147,208,147,249,147,236,147,204,147,217,147,169,147,230,147,202,147,212,147,238,147,227,147,213,147,196,147,206,147,192,147,210,147,231,147,125,149,218,149,219,149,225,150,41,151,43,151,44,151,40,151,38,151,179,151,183,151,182,151,221,151,222,151,223,151,92,152,89,152,93,152,87,152,191,152,189,152,187,152,190,152,72,153,71,153,67,153,166,153,167,153,26,154,21,154,37,154,29,154,36,154,27,154,34,154,32,154,39,154,35,154,30,154,28,154,20,154,194,154,11,155,10,155,14,155,12,155,55,155,234,155,235,155,224,155,222,155,228,155,230,155,226,155,240,155,212,155,215,155,236,155,220,155,217,155,229,155,213,155,225,155,218,155,119,157,129,157,138,157,132,157,136,157,113,157,128,157,120,157,134,157,139,157,140,157,125,157,107,157,116,157,117,157,112,157,105,157,133,157,115,157,123,157,130,157,111,157,121,157,127,157,135,157,104,157,148,158,145,158,192,158,252,158,45,159,64,159,65,159,77,159,86,159,87,159,88,159,55,83,178,86,181,86,179,86,227,88,69,91,198,93,199,93,238,94,239,94,192,95,193,95,249,97,23,101,22,101,21,101,19,101,223,101,232,102,227,102,228,102,243,106,240,106,234,106,232,106,249,106,241,106,238,106,239,106,60,112,53,112,47,112,55,112,52,112,49,112,66,112,56,112,63,112,58,112,57,112,64,112,59,112,51,112,65,112,19,114,20,114,168,114,125,115,124,115,186,116,171,118,170,118,190,118,237,118,204,119,206,119,207,119,205,119,242,119,37,121,35,121,39,121,40,121,36,121,41,121,178,121,110,122,108,122,109,122,247,122,73,124,72,124,74,124,71,124,69,124,238,124,123,126,126,126,129,126,128,126,186,127,255,127,121,128,219,129,217,129,11,130,104,130,105,130,34,134,255,133,1,134,254,133,27,134,0,134,246,133,4,134,9,134,5,134,12,134,253,133,25,136,16,136,17,136,23,136,19,136,22,136,99,137,102,137,185,137,247,137,96,139,106,139,93,139,104,139,99,139,101,139,103,139,109,139,174,141,134,142,136,142,132,142,89,143,86,143,87,143,85,143,88,143,90,143,141,144,67,145,65,145,183,145,181,145,178,145,179,145,11,148,19,148,251,147,32,148,15,148,20,148,254,147,21,148,16,148,40,148,25,148,13,148,245,147,0,148,247,147,7,148,14,148,22,148,18,148,250,147,9,148,248,147,10,148,255,147,252,147,12,148,246,147,17,148,6,148,222,149,224,149,223,149,46,151,47,151,185,151,187,151,253,151,254,151,96,152,98,152,99,152,95,152,193,152,194,152,80,153,78,153,89,153,76,153,75,153,83,153,50,154,52,154,49,154,44,154,42,154,54,154,41,154,46,154,56,154,45,154,199,154,202,154,198,154,16,155,18,155,17,155,11,156,8,156,247,155,5,156,18,156,248,155,64,156,7,156,14,156,6,156,23,156,20,156,9,156,159,157,153,157,164,157,157,157,146,157,152,157,144,157,155,157,160,157,148,157,156,157,170,157,151,157,161,157,154,157,162,157,168,157,158,157,163,157,191,157,169,157,150,157,166,157,167,157,153,158,155,158,154,158,229,158,228,158,231,158,230,158,48,159,46,159,91,159,96,159,94,159,93,159,89,159,145,159,58,81,57,81,152,82,151,82,195,86,189,86,190,86,72,91,71,91,203,93,207,93,241,94,253,97,27,101,2,107,252,106,3,107,248,106,0,107,67,112,68,112,74,112,72,112,73,112,69,112,70,112,29,114,26,114,25,114,126,115,23,117,106,118,208,119,45,121,49,121,47,121,84,124,83,124,242,124,138,126,135,126,136,126,139,126,134,126,141,126,77,127,187,127,48,128,221,129,24,134,42,134,38,134,31,134,35,134,28,134,25,134,39,134,46,134,33,134,32,134,41,134,30,134,37,134,41,136,29,136,27,136,32,136,36,136,28,136,43,136,74,136,109,137,105,137,110,137,107,137,250,137,121,139,120,139,69,139,122,139,123,139,16,141,20,141,175,141,142,142,140,142,94,143,91,143,93,143,70,145,68,145,69,145,185,145,63,148,59,148,54,148,41,148,61,148,60,148,48,148,57,148,42,148,55,148,44,148,64,148,49,148,229,149,228,149,227,149,53,151,58,151,191,151,225,151,100,152,201,152,198,152,192,152,88,153,86,153,57,154,61,154,70,154,68,154,66,154,65,154,58,154,63,154,205,154,21,155,23,155,24,155,22,155,58,155,82,155,43,156,29,156,28,156,44,156,35,156,40,156,41,156,36,156,33,156,183,157,182,157,188,157,193,157,199,157,202,157,207,157,190,157,197,157,195,157,187,157,181,157,206,157,185,157,186,157,172,157,200,157,177,157,173,157,204,157,179,157,205,157,178,157,122,158,156,158,235,158,238,158,237,158,27,159,24,159,26,159,49,159,78,159,101,159,100,159,146,159,185,78,198,86,197,86,203,86,113,89,75,91,76,91,213,93,209,93,242,94,33,101,32,101,38,101,34,101,11,107,8,107,9,107,13,108,85,112,86,112,87,112,82,112,30,114,31,114,169,114,127,115,216,116,213,116,217,116,215,116,109,118,173,118,53,121,180,121,112,122,113,122,87,124,92,124,89,124,91,124,90,124,244,124,241,124,145,126,79,127,135,127,222,129,107,130,52,134,53,134,51,134,44,134,50,134,54,134,44,136,40,136,38,136,42,136,37,136,113,137,191,137,190,137,251,137,126,139,132,139,130,139,134,139,133,139,127,139,21,141,149,142,148,142,154,142,146,142,144,142,150,142,151,142,96,143,98,143,71,145,76,148,80,148,74,148,75,148,79,148,71,148,69,148,72,148,73,148,70,148,63,151,227,151,106,152,105,152,203,152,84,153,91,153,78,154,83,154,84,154,76,154,79,154,72,154,74,154,73,154,82,154,80,154,208,154,25,155,43,155,59,155,86,155,85,155,70,156,72,156,63,156,68,156,57,156,51,156,65,156,60,156,55,156,52,156,50,156,61,156,54,156,219,157,210,157,222,157,218,157,203,157,208,157,220,157,209,157,223,157,233,157,217,157,216,157,214,157,245,157,213,157,221,157,182,158,240,158,53,159,51,159,50,159,66,159,107,159,149,159,162,159,61,81,153,82,232,88,231,88,114,89,77,91,216,93,47,136,79,95,1,98,3,98,4,98,41,101,37,101,150,101,235,102,17,107,18,107,15,107,202,107,91,112,90,112,34,114,130,115,129,115,131,115,112,118,212,119,103,124,102,124,149,126,108,130,58,134,64,134,57,134,60,134,49,134,59,134,62,134,48,136,50,136,46,136,51,136,118,137,116,137,115,137,254,137,140,139,142,139,139,139,136,139,69,140,25,141,152,142,100,143,99,143,188,145,98,148,85,148,93,148,87,148,94,148,196,151,197,151,0,152,86,154,89,154,30,155,31,155,32,155,82,156,88,156,80,156,74,156,77,156,75,156,85,156,89,156,76,156,78,156,251,157,247,157,239,157,227,157,235,157,248,157,228,157,246,157,225,157,238,157,230,157,242,157,240,157,226,157,236,157,244,157,243,157,232,157,237,157,194,158,208,158,242,158,243,158,6,159,28,159,56,159,55,159,54,159,67,159,79,159,113,159,112,159,110,159,111,159,211,86,205,86,78,91,109,92,45,101,237,102,238,102,19,107,95,112,97,112,93,112,96,112,35,114,219,116,229,116,213,119,56,121,183,121,182,121,106,124,151,126,137,127,109,130,67,134,56,136,55,136,53,136,75,136,148,139,149,139,158,142,159,142,160,142,157,142,190,145,189,145,194,145,107,148,104,148,105,148,229,150,70,151,67,151,71,151,199,151,229,151,94,154,213,154,89,155,99,156,103,156,102,156,98,156,94,156,96,156,2,158,254,157,7,158,3,158,6,158,5,158,0,158,1,158,9,158,255,157,253,157,4,158,160,158,30,159,70,159,116,159,117,159,118,159,212,86,46,101,184,101,24,107,25,107,23,107,26,107,98,112,38,114,170,114,216,119,217,119,57,121,105,124,107,124,246,124,154,126,152,126,155,126,153,126,224,129,225,129,70,134,71,134,72,134,121,137,122,137,124,137,123,137,255,137,152,139,153,139,165,142,164,142,163,142,110,148,109,148,111,148,113,148,115,148,73,151,114,152,95,153,104,156,110,156,109,156,11,158,13,158,16,158,15,158,18,158,17,158,161,158,245,158,9,159,71,159,120,159,123,159,122,159,121,159,30,87,102,112,111,124,60,136,178,141,166,142,195,145,116,148,120,148,118,148,117,148,96,154,116,156,115,156,113,156,117,156,20,158,19,158,246,158,10,159,164,159,104,112,101,112,247,124,106,134,62,136,61,136,63,136,158,139,156,140,169,142,201,142,75,151,115,152,116,152,204,152,97,153,171,153,100,154,102,154,103,154,36,155,21,158,23,158,72,159,7,98,30,107,39,114,76,134,168,142,130,148,128,148,129,148,105,154,104,154,46,155,25,158,41,114,75,134,159,139,131,148,121,156,183,158,117,118,107,154,122,156,29,158,105,112,106,112,164,158,126,159,73,159,152,159,129,120,185,146,207,136,187,88,82,96,167,124,250,90,84,37,102,37,87,37,96,37,108,37,99,37,90,37,105,37,93,37,82,37,100,37,85,37,94,37,106,37,97,37,88,37,103,37,91,37,83,37,101,37,86,37,95,37,107,37,98,37,89,37,104,37,92,37,81,37,80,37,109,37,110,37,112,37,111,37,147,37,0,0,0,0,0,0,0,48,1,48,2,48,183,0,37,32,38,32,168,0,3,48,173,0,21,32,37,34,60,255,60,34,24,32,25,32,28,32,29,32,20,48,21,48,8,48,9,48,10,48,11,48,12,48,13,48,14,48,15,48,16,48,17,48,177,0,215,0,247,0,96,34,100,34,101,34,30,34,52,34,176,0,50,32,51,32,3,33,43,33,224,255,225,255,229,255,66,38,64,38,32,34,165,34,18,35,2,34,7,34,97,34,82,34,167,0,59,32,6,38,5,38,203,37,207,37,206,37,199,37,198,37,161,37,160,37,179,37,178,37,189,37,188,37,146,33,144,33,145,33,147,33,148,33,19,48,106,34,107,34,26,34,61,34,29,34,53,34,43,34,44,34,8,34,11,34,134,34,135,34,130,34,131,34,42,34,41,34,39,34,40,34,226,255,210,33,212,33,0,34,3,34,180,0,94,255,199,2,216,2,221,2,218,2,217,2,184,0,219,2,161,0,191,0,208,2,46,34,17,34,15,34,164,0,9,33,48,32,193,37,192,37,183,37,182,37,100,38,96,38,97,38,101,38,103,38,99,38,153,34,200,37,163,37,208,37,209,37,146,37,164,37,165,37,168,37,167,37,166,37,169,37,104,38,15,38,14,38,28,38,30,38,182,0,32,32,33,32,149,33,151,33,153,33,150,33,152,33,109,38,105,38,106,38,108,38,127,50,28,50,22,33,199,51,34,33,194,51,216,51,33,33,172,32,174,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,255,2,255,3,255,4,255,5,255,6,255,7,255,8,255,9,255,10,255,11,255,12,255,13,255,14,255,15,255,16,255,17,255,18,255,19,255,20,255,21,255,22,255,23,255,24,255,25,255,26,255,27,255,28,255,29,255,30,255,31,255,32,255,33,255,34,255,35,255,36,255,37,255,38,255,39,255,40,255,41,255,42,255,43,255,44,255,45,255,46,255,47,255,48,255,49,255,50,255,51,255,52,255,53,255,54,255,55,255,56,255,57,255,58,255,59,255,230,255,61,255,62,255,63,255,64,255,65,255,66,255,67,255,68,255,69,255,70,255,71,255,72,255,73,255,74,255,75,255,76,255,77,255,78,255,79,255,80,255,81,255,82,255,83,255,84,255,85,255,86,255,87,255,88,255,89,255,90,255,91,255,92,255,93,255,227,255,49,49,50,49,51,49,52,49,53,49,54,49,55,49,56,49,57,49,58,49,59,49,60,49,61,49,62,49,63,49,64,49,65,49,66,49,67,49,68,49,69,49,70,49,71,49,72,49,73,49,74,49,75,49,76,49,77,49,78,49,79,49,80,49,81,49,82,49,83,49,84,49,85,49,86,49,87,49,88,49,89,49,90,49,91,49,92,49,93,49,94,49,95,49,96,49,97,49,98,49,99,49,100,49,101,49,102,49,103,49,104,49,105,49,106,49,107,49,108,49,109,49,110,49,111,49,112,49,113,49,114,49,115,49,116,49,117,49,118,49,119,49,120,49,121,49,122,49,123,49,124,49,125,49,126,49,127,49,128,49,129,49,130,49,131,49,132,49,133,49,134,49,135,49,136,49,137,49,138,49,139,49,140,49,141,49,142,49,112,33,113,33,114,33,115,33,116,33,117,33,118,33,119,33,120,33,121,33,0,0,0,0,0,0,0,0,0,0,96,33,97,33,98,33,99,33,100,33,101,33,102,33,103,33,104,33,105,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,145,3,146,3,147,3,148,3,149,3,150,3,151,3,152,3,153,3,154,3,155,3,156,3,157,3,158,3,159,3,160,3,161,3,163,3,164,3,165,3,166,3,167,3,168,3,169,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,177,3,178,3,179,3,180,3,181,3,182,3,183,3,184,3,185,3,186,3,187,3,188,3,189,3,190,3,191,3,192,3,193,3,195,3,196,3,197,3,198,3,199,3,200,3,201,3,0,0,0,0,0,0,0,0,0,0,0,0,0,37,2,37,12,37,16,37,24,37,20,37,28,37,44,37,36,37,52,37,60,37,1,37,3,37,15,37,19,37,27,37,23,37,35,37,51,37,43,37,59,37,75,37,32,37,47,37,40,37,55,37,63,37,29,37,48,37,37,37,56,37,66,37,18,37,17,37,26,37,25,37,22,37,21,37,14,37,13,37,30,37,31,37,33,37,34,37,38,37,39,37,41,37,42,37,45,37,46,37,49,37,50,37,53,37,54,37,57,37,58,37,61,37,62,37,64,37,65,37,67,37,68,37,69,37,70,37,71,37,72,37,73,37,74,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,149,51,150,51,151,51,19,33,152,51,196,51,163,51,164,51,165,51,166,51,153,51,154,51,155,51,156,51,157,51,158,51,159,51,160,51,161,51,162,51,202,51,141,51,142,51,143,51,207,51,136,51,137,51,200,51,167,51,168,51,176,51,177,51,178,51,179,51,180,51,181,51,182,51,183,51,184,51,185,51,128,51,129,51,130,51,131,51,132,51,186,51,187,51,188,51,189,51,190,51,191,51,144,51,145,51,146,51,147,51,148,51,38,33,192,51,193,51,138,51,139,51,140,51,214,51,197,51,173,51,174,51,175,51,219,51,169,51,170,51,171,51,172,51,221,51,208,51,211,51,195,51,201,51,220,51,198,51,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,198,0,208,0,170,0,38,1,0,0,50,1,0,0,63,1,65,1,216,0,82,1,186,0,222,0,102,1,74,1,0,0,96,50,97,50,98,50,99,50,100,50,101,50,102,50,103,50,104,50,105,50,106,50,107,50,108,50,109,50,110,50,111,50,112,50,113,50,114,50,115,50,116,50,117,50,118,50,119,50,120,50,121,50,122,50,123,50,208,36,209,36,210,36,211,36,212,36,213,36,214,36,215,36,216,36,217,36,218,36,219,36,220,36,221,36,222,36,223,36,224,36,225,36,226,36,227,36,228,36,229,36,230,36,231,36,232,36,233,36,96,36,97,36,98,36,99,36,100,36,101,36,102,36,103,36,104,36,105,36,106,36,107,36,108,36,109,36,110,36,189,0,83,33,84,33,188,0,190,0,91,33,92,33,93,33,94,33,230,0,17,1,240,0,39,1,49,1,51,1,56,1,64,1,66,1,248,0,83,1,223,0,254,0,103,1,75,1,73,1,0,50,1,50,2,50,3,50,4,50,5,50,6,50,7,50,8,50,9,50,10,50,11,50,12,50,13,50,14,50,15,50,16,50,17,50,18,50,19,50,20,50,21,50,22,50,23,50,24,50,25,50,26,50,27,50,156,36,157,36,158,36,159,36,160,36,161,36,162,36,163,36,164,36,165,36,166,36,167,36,168,36,169,36,170,36,171,36,172,36,173,36,174,36,175,36,176,36,177,36,178,36,179,36,180,36,181,36,116,36,117,36,118,36,119,36,120,36,121,36,122,36,123,36,124,36,125,36,126,36,127,36,128,36,129,36,130,36,185,0,178,0,179,0,116,32,127,32,129,32,130,32,131,32,132,32,65,48,66,48,67,48,68,48,69,48,70,48,71,48,72,48,73,48,74,48,75,48,76,48,77,48,78,48,79,48,80,48,81,48,82,48,83,48,84,48,85,48,86,48,87,48,88,48,89,48,90,48,91,48,92,48,93,48,94,48,95,48,96,48,97,48,98,48,99,48,100,48,101,48,102,48,103,48,104,48,105,48,106,48,107,48,108,48,109,48,110,48,111,48,112,48,113,48,114,48,115,48,116,48,117,48,118,48,119,48,120,48,121,48,122,48,123,48,124,48,125,48,126,48,127,48,128,48,129,48,130,48,131,48,132,48,133,48,134,48,135,48,136,48,137,48,138,48,139,48,140,48,141,48,142,48,143,48,144,48,145,48,146,48,147,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,161,48,162,48,163,48,164,48,165,48,166,48,167,48,168,48,169,48,170,48,171,48,172,48,173,48,174,48,175,48,176,48,177,48,178,48,179,48,180,48,181,48,182,48,183,48,184,48,185,48,186,48,187,48,188,48,189,48,190,48,191,48,192,48,193,48,194,48,195,48,196,48,197,48,198,48,199,48,200,48,201,48,202,48,203,48,204,48,205,48,206,48,207,48,208,48,209,48,210,48,211,48,212,48,213,48,214,48,215,48,216,48,217,48,218,48,219,48,220,48,221,48,222,48,223,48,224,48,225,48,226,48,227,48,228,48,229,48,230,48,231,48,232,48,233,48,234,48,235,48,236,48,237,48,238,48,239,48,240,48,241,48,242,48,243,48,244,48,245,48,246,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,4,17,4,18,4,19,4,20,4,21,4,1,4,22,4,23,4,24,4,25,4,26,4,27,4,28,4,29,4,30,4,31,4,32,4,33,4,34,4,35,4,36,4,37,4,38,4,39,4,40,4,41,4,42,4,43,4,44,4,45,4,46,4,47,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,4,49,4,50,4,51,4,52,4,53,4,81,4,54,4,55,4,56,4,57,4,58,4,59,4,60,4,61,4,62,4,63,4,64,4,65,4,66,4,67,4,68,4,69,4,70,4,71,4,72,4,73,4,74,4,75,4,76,4,77,4,78,4,79,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,172,1,172,4,172,7,172,8,172,9,172,10,172,16,172,17,172,18,172,19,172,20,172,21,172,22,172,23,172,25,172,26,172,27,172,28,172,29,172,32,172,36,172,44,172,45,172,47,172,48,172,49,172,56,172,57,172,60,172,64,172,75,172,77,172,84,172,88,172,92,172,112,172,113,172,116,172,119,172,120,172,122,172,128,172,129,172,131,172,132,172,133,172,134,172,137,172,138,172,139,172,140,172,144,172,148,172,156,172,157,172,159,172,160,172,161,172,168,172,169,172,170,172,172,172,175,172,176,172,184,172,185,172,187,172,188,172,189,172,193,172,196,172,200,172,204,172,213,172,215,172,224,172,225,172,228,172,231,172,232,172,234,172,236,172,239,172,240,172,241,172,243,172,245,172,246,172,252,172,253,172,0,173,4,173,6,173,12,173,13,173,15,173,17,173,24,173,28,173,32,173,41,173,44,173,45,173,52,173,53,173,56,173,60,173,68,173,69,173,71,173,73,173,80,173,84,173,88,173,97,173,99,173,108,173,109,173,112,173,115,173,116,173,117,173,118,173,123,173,124,173,125,173,127,173,129,173,130,173,136,173,137,173,140,173,144,173,156,173,157,173,164,173,183,173,192,173,193,173,196,173,200,173,208,173,209,173,211,173,220,173,224,173,228,173,248,173,249,173,252,173,255,173,0,174,1,174,8,174,9,174,11,174,13,174,20,174,48,174,49,174,52,174,55,174,56,174,58,174,64,174,65,174,67,174,69,174,70,174,74,174,76,174,77,174,78,174,80,174,84,174,86,174,92,174,93,174,95,174,96,174,97,174,101,174,104,174,105,174,108,174,112,174,120,174,121,174,123,174,124,174,125,174,132,174,133,174,140,174,188,174,189,174,190,174,192,174,196,174,204,174,205,174,207,174,208,174,209,174,216,174,217,174,220,174,232,174,235,174,237,174,244,174,248,174,252,174,7,175,8,175],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+302308),
allocate([13,175,16,175,44,175,45,175,48,175,50,175,52,175,60,175,61,175,63,175,65,175,66,175,67,175,72,175,73,175,80,175,92,175,93,175,100,175,101,175,121,175,128,175,132,175,136,175,144,175,145,175,149,175,156,175,184,175,185,175,188,175,192,175,199,175,200,175,201,175,203,175,205,175,206,175,212,175,220,175,232,175,233,175,240,175,241,175,244,175,248,175,0,176,1,176,4,176,12,176,16,176,20,176,28,176,29,176,40,176,68,176,69,176,72,176,74,176,76,176,78,176,83,176,84,176,85,176,87,176,89,176,93,176,124,176,125,176,128,176,132,176,140,176,141,176,143,176,145,176,152,176,153,176,154,176,156,176,159,176,160,176,161,176,162,176,168,176,169,176,171,176,172,176,173,176,174,176,175,176,177,176,179,176,180,176,181,176,184,176,188,176,196,176,197,176,199,176,200,176,201,176,208,176,209,176,212,176,216,176,224,176,229,176,8,177,9,177,11,177,12,177,16,177,18,177,19,177,24,177,25,177,27,177,28,177,29,177,35,177,36,177,37,177,40,177,44,177,52,177,53,177,55,177,56,177,57,177,64,177,65,177,68,177,72,177,80,177,81,177,84,177,85,177,88,177,92,177,96,177,120,177,121,177,124,177,128,177,130,177,136,177,137,177,139,177,141,177,146,177,147,177,148,177,152,177,156,177,168,177,204,177,208,177,212,177,220,177,221,177,223,177,232,177,233,177,236,177,240,177,249,177,251,177,253,177,4,178,5,178,8,178,11,178,12,178,20,178,21,178,23,178,25,178,32,178,52,178,60,178,88,178,92,178,96,178,104,178,105,178,116,178,117,178,124,178,132,178,133,178,137,178,144,178,145,178,148,178,152,178,153,178,154,178,160,178,161,178,163,178,165,178,166,178,170,178,172,178,176,178,180,178,200,178,201,178,204,178,208,178,210,178,216,178,217,178,219,178,221,178,226,178,228,178,229,178,230,178,232,178,235,178,236,178,237,178,238,178,239,178,243,178,244,178,245,178,247,178,248,178,249,178,250,178,251,178,255,178,0,179,1,179,4,179,8,179,16,179,17,179,19,179,20,179,21,179,28,179,84,179,85,179,86,179,88,179,91,179,92,179,94,179,95,179,100,179,101,179,103,179,105,179,107,179,110,179,112,179,113,179,116,179,120,179,128,179,129,179,131,179,132,179,133,179,140,179,144,179,148,179,160,179,161,179,168,179,172,179,196,179,197,179,200,179,203,179,204,179,206,179,208,179,212,179,213,179,215,179,217,179,219,179,221,179,224,179,228,179,232,179,252,179,16,180,24,180,28,180,32,180,40,180,41,180,43,180,52,180,80,180,81,180,84,180,88,180,96,180,97,180,99,180,101,180,108,180,128,180,136,180,157,180,164,180,168,180,172,180,181,180,183,180,185,180,192,180,196,180,200,180,208,180,213,180,220,180,221,180,224,180,227,180,228,180,230,180,236,180,237,180,239,180,241,180,248,180,20,181,21,181,24,181,27,181,28,181,36,181,37,181,39,181,40,181,41,181,42,181,48,181,49,181,52,181,56,181,64,181,65,181,67,181,68,181,69,181,75,181,76,181,77,181,80,181,84,181,92,181,93,181,95,181,96,181,97,181,160,181,161,181,164,181,168,181,170,181,171,181,176,181,177,181,179,181,180,181,181,181,187,181,188,181,189,181,192,181,196,181,204,181,205,181,207,181,208,181,209,181,216,181,236,181,16,182,17,182,20,182,24,182,37,182,44,182,52,182,72,182,100,182,104,182,156,182,157,182,160,182,164,182,171,182,172,182,177,182,212,182,240,182,244,182,248,182,0,183,1,183,5,183,40,183,41,183,44,183,47,183,48,183,56,183,57,183,59,183,68,183,72,183,76,183,84,183,85,183,96,183,100,183,104,183,112,183,113,183,115,183,117,183,124,183,125,183,128,183,132,183,140,183,141,183,143,183,144,183,145,183,146,183,150,183,151,183,152,183,153,183,156,183,160,183,168,183,169,183,171,183,172,183,173,183,180,183,181,183,184,183,199,183,201,183,236,183,237,183,240,183,244,183,252,183,253,183,255,183,0,184,1,184,7,184,8,184,9,184,12,184,16,184,24,184,25,184,27,184,29,184,36,184,37,184,40,184,44,184,52,184,53,184,55,184,56,184,57,184,64,184,68,184,81,184,83,184,92,184,93,184,96,184,100,184,108,184,109,184,111,184,113,184,120,184,124,184,141,184,168,184,176,184,180,184,184,184,192,184,193,184,195,184,197,184,204,184,208,184,212,184,221,184,223,184,225,184,232,184,233,184,236,184,240,184,248,184,249,184,251,184,253,184,4,185,24,185,32,185,60,185,61,185,64,185,68,185,76,185,79,185,81,185,88,185,89,185,92,185,96,185,104,185,105,185,107,185,109,185,116,185,117,185,120,185,124,185,132,185,133,185,135,185,137,185,138,185,141,185,142,185,172,185,173,185,176,185,180,185,188,185,189,185,191,185,193,185,200,185,201,185,204,185,206,185,207,185,208,185,209,185,210,185,216,185,217,185,219,185,221,185,222,185,225,185,227,185,228,185,229,185,232,185,236,185,244,185,245,185,247,185,248,185,249,185,250,185,0,186,1,186,8,186,21,186,56,186,57,186,60,186,64,186,66,186,72,186,73,186,75,186,77,186,78,186,83,186,84,186,85,186,88,186,92,186,100,186,101,186,103,186,104,186,105,186,112,186,113,186,116,186,120,186,131,186,132,186,133,186,135,186,140,186,168,186,169,186,171,186,172,186,176,186,178,186,184,186,185,186,187,186,189,186,196,186,200,186,216,186,217,186,252,186,0,187,4,187,13,187,15,187,17,187,24,187,28,187,32,187,41,187,43,187,52,187,53,187,54,187,56,187,59,187,60,187,61,187,62,187,68,187,69,187,71,187,73,187,77,187,79,187,80,187,84,187,88,187,97,187,99,187,108,187,136,187,140,187,144,187,164,187,168,187,172,187,180,187,183,187,192,187,196,187,200,187,208,187,211,187,248,187,249,187,252,187,255,187,0,188,2,188,8,188,9,188,11,188,12,188,13,188,15,188,17,188,20,188,21,188,22,188,23,188,24,188,27,188,28,188,29,188,30,188,31,188,36,188,37,188,39,188,41,188,45,188,48,188,49,188,52,188,56,188,64,188,65,188,67,188,68,188,69,188,73,188,76,188,77,188,80,188,93,188,132,188,133,188,136,188,139,188,140,188,142,188,148,188,149,188,151,188,153,188,154,188,160,188,161,188,164,188,167,188,168,188,176,188,177,188,179,188,180,188,181,188,188,188,189,188,192,188,196,188,205,188,207,188,208,188,209,188,213,188,216,188,220,188,244,188,245,188,246,188,248,188,252,188,4,189,5,189,7,189,9,189,16,189,20,189,36,189,44,189,64,189,72,189,73,189,76,189,80,189,88,189,89,189,100,189,104,189,128,189,129,189,132,189,135,189,136,189,137,189,138,189,144,189,145,189,147,189,149,189,153,189,154,189,156,189,164,189,176,189,184,189,212,189,213,189,216,189,220,189,233,189,240,189,244,189,248,189,0,190,3,190,5,190,12,190,13,190,16,190,20,190,28,190,29,190,31,190,68,190,69,190,72,190,76,190,78,190,84,190,85,190,87,190,89,190,90,190,91,190,96,190,97,190,100,190,104,190,106,190,112,190,113,190,115,190,116,190,117,190,123,190,124,190,125,190,128,190,132,190,140,190,141,190,143,190,144,190,145,190,152,190,153,190,168,190,208,190,209,190,212,190,215,190,216,190,224,190,227,190,228,190,229,190,236,190,1,191,8,191,9,191,24,191,25,191,27,191,28,191,29,191,64,191,65,191,68,191,72,191,80,191,81,191,85,191,148,191,176,191,197,191,204,191,205,191,208,191,212,191,220,191,223,191,225,191,60,192,81,192,88,192,92,192,96,192,104,192,105,192,144,192,145,192,148,192,152,192,160,192,161,192,163,192,165,192,172,192,173,192,175,192,176,192,179,192,180,192,181,192,182,192,188,192,189,192,191,192,192,192,193,192,197,192,200,192,201,192,204,192,208,192,216,192,217,192,219,192,220,192,221,192,228,192,229,192,232,192,236,192,244,192,245,192,247,192,249,192,0,193,4,193,8,193,16,193,21,193,28,193,29,193,30,193,31,193,32,193,35,193,36,193,38,193,39,193,44,193,45,193,47,193,48,193,49,193,54,193,56,193,57,193,60,193,64,193,72,193,73,193,75,193,76,193,77,193,84,193,85,193,88,193,92,193,100,193,101,193,103,193,104,193,105,193,112,193,116,193,120,193,133,193,140,193,141,193,142,193,144,193,148,193,150,193,156,193,157,193,159,193,161,193,165,193,168,193,169,193,172,193,176,193,189,193,196,193,200,193,204,193,212,193,215,193,216,193,224,193,228,193,232,193,240,193,241,193,243,193,252,193,253,193,0,194,4,194,12,194,13,194,15,194,17,194,24,194,25,194,28,194,31,194,32,194,40,194,41,194,43,194,45,194,47,194,49,194,50,194,52,194,72,194,80,194,81,194,84,194,88,194,96,194,101,194,108,194,109,194,112,194,116,194,124,194,125,194,127,194,129,194,136,194,137,194,144,194,152,194,155,194,157,194,164,194,165,194,168,194,172,194,173,194,180,194,181,194,183,194,185,194,220,194,221,194,224,194,227,194,228,194,235,194,236,194,237,194,239,194,241,194,246,194,248,194,249,194,251,194,252,194,0,195,8,195,9,195,12,195,13,195,19,195,20,195,21,195,24,195,28,195,36,195,37,195,40,195,41,195,69,195,104,195,105,195,108,195,112,195,114,195,120,195,121,195,124,195,125,195,132,195,136,195,140,195,192,195,216,195,217,195,220,195,223,195,224,195,226,195,232,195,233,195,237,195,244,195,245,195,248,195,8,196,16,196,36,196,44,196,48,196,52,196,60,196,61,196,72,196,100,196,101,196,104,196,108,196,116,196,117,196,121,196,128,196,148,196,156,196,184,196,188,196,233,196,240,196,241,196,244,196,248,196,250,196,255,196,0,197,1,197,12,197,16,197,20,197,28,197,40,197,41,197,44,197,48,197,56,197,57,197,59,197,61,197,68,197,69,197,72,197,73,197,74,197,76,197,77,197,78,197,83,197,84,197,85,197,87,197,88,197,89,197,93,197,94,197,96,197,97,197,100,197,104,197,112,197,113,197,115,197,116,197,117,197,124,197,125,197,128,197,132,197,135,197,140,197,141,197,143,197,145,197,149,197,151,197,152,197,156,197,160,197,169,197,180,197,181,197,184,197,185,197,187,197,188,197,189,197,190,197,196,197,197,197,198,197,199,197,200,197,201,197,202,197,204,197,206,197,208,197,209,197,212,197,216,197,224,197,225,197,227,197,229,197,236,197,237,197,238,197,240,197,244,197,246,197,247,197,252,197,253,197,254,197,255,197,0,198,1,198,5,198,6,198,7,198,8,198,12,198,16,198,24,198,25,198,27,198,28,198,36,198,37,198,40,198,44,198,45,198,46,198,48,198,51,198,52,198,53,198,55,198,57,198,59,198,64,198,65,198,68,198,72,198,80,198,81,198,83,198,84,198,85,198,92,198,93,198,96,198,108,198,111,198,113,198,120,198,121,198,124,198,128,198,136,198,137,198,139,198,141,198,148,198,149,198,152,198,156,198,164,198,165,198,167,198,169,198,176,198,177,198,180,198,184,198,185,198,186,198,192,198,193,198,195,198,197,198,204,198,205,198,208,198,212,198,220,198,221,198,224,198,225,198,232,198,233,198,236,198,240,198,248,198,249,198,253,198,4,199,5,199,8,199,12,199,20,199,21,199,23,199,25,199,32,199,33,199,36,199,40,199,48,199,49,199,51,199,53,199,55,199,60,199,61,199,64,199,68,199,74,199,76,199,77,199,79,199,81,199,82,199,83,199,84,199,85,199,86,199,87,199,88,199,92,199,96,199,104,199,107,199,116,199,117,199,120,199,124,199,125,199,126,199,131,199,132,199,133,199,135,199,136,199,137,199,138,199,142,199,144,199,145,199,148,199,150,199,151,199,152,199,154,199,160,199,161,199,163,199,164,199,165,199,166,199,172,199,173,199,176,199,180,199,188,199,189,199,191,199,192,199,193,199,200,199,201,199,204,199,206,199,208,199,216,199,221,199,228,199,232,199,236,199,0,200,1,200,4,200,8,200,10,200,16,200,17,200,19,200,21,200,22,200,28,200,29,200,32,200,36,200,44,200,45,200,47,200,49,200,56,200,60,200,64,200,72,200,73,200,76,200,77,200,84,200,112,200,113,200,116,200,120,200,122,200,128,200,129,200,131,200,133,200,134,200,135,200,139,200,140,200,141,200,148,200,157,200,159,200,161,200,168,200,188,200,189,200,196,200,200,200,204,200,212,200,213,200,215,200,217,200,224,200,225,200,228,200,245,200,252,200,253,200,0,201,4,201,5,201,6,201,12,201,13,201,15,201,17,201,24,201,44,201,52,201,80,201,81,201,84,201,88,201,96,201,97,201,99,201,108,201,112,201,116,201,124,201,136,201,137,201,140,201,144,201,152,201,153,201,155,201,157,201,192,201,193,201,196,201,199,201,200,201,202,201,208,201,209,201,211,201,213,201,214,201,217,201,218,201,220,201,221,201,224,201,226,201,228,201,231,201,236,201,237,201,239,201,240,201,241,201,248,201,249,201,252,201,0,202,8,202,9,202,11,202,12,202,13,202,20,202,24,202,41,202,76,202,77,202,80,202,84,202,92,202,93,202,95,202,96,202,97,202,104,202,125,202,132,202,152,202,188,202,189,202,192,202,196,202,204,202,205,202,207,202,209,202,211,202,216,202,217,202,224,202,236,202,244,202,8,203,16,203,20,203,24,203,32,203,33,203,65,203,72,203,73,203,76,203,80,203,88,203,89,203,93,203,100,203,120,203,121,203,156,203,184,203,212,203,228,203,231,203,233,203,12,204,13,204,16,204,20,204,28,204,29,204,33,204,34,204,39,204,40,204,41,204,44,204,46,204,48,204,56,204,57,204,59,204,60,204,61,204,62,204,68,204,69,204,72,204,76,204,84,204,85,204,87,204,88,204,89,204,96,204,100,204,102,204,104,204,112,204,117,204,152,204,153,204,156,204,160,204,168,204,169,204,171,204,172,204,173,204,180,204,181,204,184,204,188,204,196,204,197,204,199,204,201,204,208,204,212,204,228,204,236,204,240,204,1,205,8,205,9,205,12,205,16,205,24,205,25,205,27,205,29,205,36,205,40,205,44,205,57,205,92,205,96,205,100,205,108,205,109,205,111,205,113,205,120,205,136,205,148,205,149,205,152,205,156,205,164,205,165,205,167,205,169,205,176,205,196,205,204,205,208,205,232,205,236,205,240,205,248,205,249,205,251,205,253,205,4,206,8,206,12,206,20,206,25,206,32,206,33,206,36,206,40,206,48,206,49,206,51,206,53,206,88,206,89,206,92,206,95,206,96,206,97,206,104,206,105,206,107,206,109,206,116,206,117,206,120,206,124,206,132,206,133,206,135,206,137,206,144,206,145,206,148,206,152,206,160,206,161,206,163,206,164,206,165,206,172,206,173,206,193,206,228,206,229,206,232,206,235,206,236,206,244,206,245,206,247,206,248,206,249,206,0,207,1,207,4,207,8,207,16,207,17,207,19,207,21,207,28,207,32,207,36,207,44,207,45,207,47,207,48,207,49,207,56,207,84,207,85,207,88,207,92,207,100,207,101,207,103,207,105,207,112,207,113,207,116,207,120,207,128,207,133,207,140,207,161,207,168,207,176,207,196,207,224,207,225,207,228,207,232,207,240,207,241,207,243,207,245,207,252,207,0,208,4,208,17,208,24,208,45,208,52,208,53,208,56,208,60,208,68,208,69,208,71,208,73,208,80,208,84,208,88,208,96,208,108,208,109,208,112,208,116,208,124,208,125,208,129,208,164,208,165,208,168,208,172,208,180,208,181,208,183,208,185,208,192,208,193,208,196,208,200,208,201,208,208,208,209,208,211,208,212,208,213,208,220,208,221,208,224,208,228,208,236,208,237,208,239,208,240,208,241,208,248,208,13,209,48,209,49,209,52,209,56,209,58,209,64,209,65,209,67,209,68,209,69,209,76,209,77,209,80,209,84,209,92,209,93,209,95,209,97,209,104,209,108,209,124,209,132,209,136,209,160,209,161,209,164,209,168,209,176,209,177,209,179,209,181,209,186,209,188,209,192,209,216,209,244,209,248,209,7,210,9,210,16,210,44,210,45,210,48,210,52,210,60,210,61,210,63,210,65,210,72,210,92,210,100,210,128,210,129,210,132,210,136,210,144,210,145,210,149,210,156,210,160,210,164,210,172,210,177,210,184,210,185,210,188,210,191,210,192,210,194,210,200,210,201,210,203,210,212,210,216,210,220,210,228,210,229,210,240,210,241,210,244,210,248,210,0,211,1,211,3,211,5,211,12,211,13,211,14,211,16,211,20,211,22,211,28,211,29,211,31,211,32,211,33,211,37,211,40,211,41,211,44,211,48,211,56,211,57,211,59,211,60,211,61,211,68,211,69,211,124,211,125,211,128,211,132,211,140,211,141,211,143,211,144,211,145,211,152,211,153,211,156,211,160,211,168,211,169,211,171,211,173,211,180,211,184,211,188,211,196,211,197,211,200,211,201,211,208,211,216,211,225,211,227,211,236,211,237,211,240,211,244,211,252,211,253,211,255,211,1,212,8,212,29,212,64,212,68,212,92,212,96,212,100,212,109,212,111,212,120,212,121,212,124,212,127,212,128,212,130,212,136,212,137,212,139,212,141,212,148,212,169,212,204,212,208,212,212,212,220,212,223,212,232,212,236,212,240,212,248,212,251,212,253,212,4,213,8,213,12,213,20,213,21,213,23,213,60,213,61,213,64,213,68,213,76,213,77,213,79,213,81,213,88,213,89,213,92,213,96,213,101,213,104,213,105,213,107,213,109,213,116,213,117,213,120,213,124,213,132,213,133,213,135,213,136,213,137,213,144,213,165,213,200,213,201,213,204,213,208,213,210,213,216,213,217,213,219,213,221,213,228,213,229,213,232,213,236,213,244,213,245,213,247,213,249,213,0,214,1,214,4,214,8,214,16,214,17,214,19,214,20,214,21,214,28,214,32,214,36,214,45,214,56,214,57,214,60,214,64,214,69,214,72,214,73,214,75,214,77,214,81,214,84,214,85,214,88,214,92,214,103,214,105,214,112,214,113,214,116,214,131,214,133,214,140,214,141,214,144,214,148,214,157,214,159,214,161,214,168,214,172,214,176,214,185,214,187,214,196,214,197,214,200,214,204,214,209,214,212,214,215,214,217,214,224,214,228,214,232,214,240,214,245,214,252,214,253,214,0,215,4,215,17,215,24,215,25,215,28,215,32,215,40,215,41,215,43,215,45,215,52,215,53,215,56,215,60,215,68,215,71,215,73,215,80,215,81,215,84,215,86,215,87,215,88,215,89,215,96,215,97,215,99,215,101,215,105,215,108,215,112,215,116,215,124,215,125,215,129,215,136,215,137,215,140,215,144,215,152,215,153,215,155,215,157,215,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,61,79,115,79,71,80,249,80,160,82,239,83,117,84,229,84,9,86,193,90,182,91,135,102,182,103,183,103,239,103,76,107,194,115,194,117,60,122,219,130,4,131,87,136,136,136,54,138,200,140,207,141,251,142,230,143,213,153,59,82,116,83,4,84,106,96,100,97,188,107,207,115,26,129,186,137,210,137,163,149,131,79,10,82,190,88,120,89,230,89,114,94,121,94,199,97,192,99,70,103,236,103,127,104,151,111,78,118,11,119,245,120,8,122,255,122,33,124,157,128,110,130,113,130,235,138,147,149,107,78,157,85,247,102,52,110,163,120,237,122,91,132,16,137,78,135,168,151,216,82,78,87,42,88,76,93,31,97,190,97,33,98,98,101,209,103,68,106,27,110,24,117,179,117,227,118,176,119,58,125,175,144,81,148,82,148,149,159,35,83,172,92,50,117,219,128,64,146,152,149,91,82,8,88,220,89,161,92,23,93,183,94,58,95,74,95,119,97,95,108,122,117,134,117,224,124,115,125,177,125,140,127,84,129,33,130,145,133,65,137,27,139,252,146,77,150,71,156,203,78,247,78,11,80,241,81,79,88,55,97,62,97,104,97,57,101,234,105,17,111,165,117,134,118,214,118,135,123,165,130,203,132,0,249,167,147,139,149,128,85,162,91,81,87,1,249,179,124,185,127,181,145,40,80,187,83,69,92,232,93,210,98,110,99,218,100,231,100,32,110,172,112,91,121,221,141,30,142,2,249,125,144,69,146,248,146,126,78,246,78,101,80,254,93,250,94,6,97,87,105,113,129,84,134,71,142,117,147,43,154,94,78,145,80,112,103,64,104,9,81,141,82,146,82,162,106,188,119,16,146,212,158,171,82,47,96,242,143,72,80,169,97,237,99,202,100,60,104,132,106,192,111,136,129,161,137,148,150,5,88,125,114,172,114,4,117,121,125,109,126,169,128,139,137,116,139,99,144,81,157,137,98,122,108,84,111,80,125,58,127,35,138,124,81,74,97,157,123,25,139,87,146,140,147,172,78,211,79,30,80,190,80,6,81,193,82,205,82,127,83,112,87,131,88,154,94,145,95,118,97,172,97,206,100,108,101,111,102,187,102,244,102,151,104,135,109,133,112,241,112,159,116,165,116,202,116,217,117,108,120,236,120,223,122,246,122,69,125,147,125,21,128,63,128,27,129,150,131,102,139,21,143,21,144,225,147,3,152,56,152,90,154,232,155,194,79,83,85,58,88,81,89,99,91,70,92,184,96,18,98,66,104,176,104,232,104,170,110,76,117,120,118,206,120,61,122,251,124,107,126,124,126,8,138,161,138,63,140,142,150,196,157,228,83,233,83,74,84,113,84,250,86,209,89,100,91,59,92,171,94,247,98,55,101,69,101,114,101,160,102,175,103,193,105,189,108,252,117,144,118,126,119,63,122,148,127,3,128,161,128,143,129,230,130,253,130,240,131,193,133,49,136,180,136,165,138,3,249,156,143,46,147,199,150,103,152,216,154,19,159,237,84,155,101,242,102,143,104,64,122,55,140,96,157,240,86,100,87,17,93,6,102,177,104,205,104,254,110,40,116,158,136,228,155,104,108,4,249,168,154,155,79,108,81,113,81,159,82,84,91,229,93,80,96,109,96,241,98,167,99,59,101,217,115,122,122,163,134,162,140,143,151,50,78,225,91,8,98,156,103,220,116,209,121,211,131,135,138,178,138,232,141,78,144,75,147,70,152,211,94,232,105,255,133,237,144,5,249,160,81,152,91,236,91,99,97,250,104,62,107,76,112,47,116,216,116,161,123,80,127,197,131,192,137,171,140,220,149,40,153,46,82,93,96,236,98,2,144,138,79,73,81,33,83,217,88,227,94,224,102,56,109,154,112,194,114,214,115,80,123,241,128,91,148,102,83,155,99,107,127,86,78,128,80,74,88,222,88,42,96,39,97,208,98,208,105,65,155,143,91,24,125,177,128,95,143,164,78,209,80,172,84,172,85,12,91,160,93,231,93,42,101,78,101,33,104,75,106,225,114,142,118,239,119,94,125,249,127,160,129,78,133,223,134,3,143,78,143,202,144,3,153,85,154,171,155,24,78,69,78,93,78,199,78,241,79,119,81,254,82,64,83,227,83,229,83,142,84,20,86,117,87,162,87,199,91,135,93,208,94,252,97,216,98,81,101,184,103,233,103,203,105,80,107,198,107,236,107,66,108,157,110,120,112,215,114,150,115,3,116,191,119,233,119,118,122,127,125,9,128,252,129,5,130,10,130,223,130,98,136,51,139,252,140,192,142,17,144,177,144,100,146,182,146,210,153,69,154,233,156,215,157,156,159,11,87,64,92,202,131,160,151,171,151,180,158,27,84,152,122,164,127,217,136,205,142,225,144,0,88,72,92,152,99,159,122,174,91,19,95,121,122,174,122,142,130,172,142,38,80,56,82,248,82,119,83,8,87,243,98,114,99,10,107,195,109,55,119,165,83,87,115,104,133,118,142,213,149,58,103,195,106,112,111,109,138,204,142,75,153,6,249,119,102,120,107,180,140,60,155,7,249,235,83,45,87,78,89,198,99,251,105,234,115,69,120,186,122,197,122,254,124,117,132,143,137,115,141,53,144,168,149,251,82,71,87,71,117,96,123,204,131,30,146,8,249,88,106,75,81,75,82,135,82,31,98,216,104,117,105,153,150,197,80,164,82,228,82,195,97,164,101,57,104,255,105,126,116,75,123,185,130,235,131,178,137,57,139,209,143,73,153,9,249,202,78,151,89,210,100,17,102,142,106,52,116,129,121,189,121,169,130,126,136,127,136,95,137,10,249,38,147,11,79,202,83,37,96,113,98,114,108,26,125,102,125,152,78,98,81,220,119,175,128,1,79,14,79,118,81,128,81,220,85,104,86,59,87,250,87,252,87,20,89,71,89,147,89,196,91,144,92,14,93,241,93,126,94,204,95,128,98,215,101,227,101,30,103,31,103,94,103,203,104,196,104,95,106,58,107,35,108,125,108,130,108,199,109,152,115,38,116,42,116,130,116,163,116,120,117,127,117,129,120,239,120,65,121,71,121,72,121,122,121,149,123,0,125,186,125,136,127,6,128,45,128,140,128,24,138,79,139,72,140,119,141,33,147,36,147,226,152,81,153,14,154,15,154,101,154,146,158,202,125,118,79,9,84,238,98,84,104,209,145,171,85,58,81,11,249,12,249,28,90,230,97,13,249,207,98,255,98,14,249,15,249,16,249,17,249,18,249,19,249,163,144,20,249,21,249,22,249,23,249,24,249,254,138,25,249,26,249,27,249,28,249,150,102,29,249,86,113,30,249,31,249,227,150,32,249,79,99,122,99,87,83,33,249,143,103,96,105,115,110,34,249,55,117,35,249,36,249,37,249,13,125,38,249,39,249,114,136,202,86,24,90,40,249,41,249,42,249,43,249,44,249,67,78,45,249,103,81,72,89,240,103,16,128,46,249,115,89,116,94,154,100,202,121,245,95,108,96,200,98,123,99,231,91,215,91,170,82,47,249,116,89,41,95,18,96,48,249,49,249,50,249,89,116,51,249,52,249,53,249,54,249,55,249,56,249,209,153,57,249,58,249,59,249,60,249,61,249,62,249,63,249,64,249,65,249,66,249,67,249,195,111,68,249,69,249,191,129,178,143,241,96,70,249,71,249,102,129,72,249,73,249,63,92,74,249,75,249,76,249,77,249,78,249,79,249,80,249,81,249,233,90,37,138,123,103,16,125,82,249,83,249,84,249,85,249,86,249,87,249,253,128,88,249,89,249,60,92,229,108,63,83,186,110,26,89,54,131,57,78,182,78,70,79,174,85,24,87,199,88,86,95,183,101,230,101,128,106,181,107,77,110,237,119,239,122,30,124,222,125,203,134,146,136,50,145,91,147,187,100,190,111,122,115,184,117,84,144,86,85,77,87,186,97,212,100,199,102,225,109,91,110,109,111,185,111,240,117,67,128,189,129,65,133,131,137,199,138,90,139,31,147,147,108,83,117,84,123,15,142,93,144,16,85,2,88,88,88,98,94,7,98,158,100,224,104,118,117,214,124,179,135,232,158,227,78,136,87,110,87,39,89,13,92,177,92,54,94,133,95,52,98,225,100,179,115,250,129,139,136,184,140,138,150,219,158,133,91,183,95,179,96,18,80,0,82,48,82,22,87,53,88,87,88,14,92,96,92,246,92,139,93,166,94,146,95,188,96,17,99,137,99,23,100,67,104,249,104,194,106,216,109,33,110,212,110,228,111,254,113,220,118,121,119,177,121,59,122,4,132,169,137,237,140,243,141,72,142,3,144,20,144,83,144,253,144,77,147,118,150,220,151,210,107,6,112,88,114,162,114,104,115,99,119,191,121,228,123,155,126,128,139,169,88,199,96,102,101,253,101,190,102,140,108,30,113,201,113,90,140,19,152,109,78,129,122,221,78,172,81,205,81,213,82,12,84,167,97,113,103,80,104,223,104,30,109,124,111,188,117,179,119,229,122,244,128,99,132,133,146,92,81,151,101,92,103,147,103,216,117,199,122,115,131,90,249,70,140,23,144,45,152,111,92,192,129,154,130,65,144,111,144,13,146,151,95,157,93,89,106,200,113,123,118,73,123,228,133,4,139,39,145,48,154,135,85,246,97,91,249,105,118,133,127,63,134,186,135,248,136,143,144,92,249,27,109,217,112,222,115,97,125,61,132,93,249,106,145,241,153,94,249,130,78,117,83,4,107,18,107,62,112,27,114,45,134,30,158,76,82,163,143,80,93,229,100,44,101,22,107,235,111,67,124,156,126,205,133,100,137,189,137,201,98,216,129,31,136,202,94,23,103,106,109,252,114,5,116,111,116,130,135,222,144,134,79,13,93,160,95,10,132,183,81,160,99,101,117,174,78,6,80,105,81,201,81,129,104,17,106,174,124,177,124,231,124,111,130,210,138,27,143,207,145,182,79,55,81,245,82,66,84,236,94,110,97,62,98,197,101,218,106,254,111,42,121,220,133,35,136,173,149,98,154,106,154,151,158,206,158,155,82,198,102,119,107,29,112,43,121,98,143,66,151,144,97,0,98,35,101,35,111,73,113,137,116,244,125,111,128,238,132,38,143,35,144,74,147,189,81,23,82,163,82,12,109,200,112,194,136,201,94,130,101,174,107,194,111,62,124,117,115,228,78,54,79,249,86,95,249,186,92,186,93,28,96,178,115,45,123,154,127,206,127,70,128,30,144,52,146,246,150,72,151,24,152,97,159,139,79,167,111,174,121,180,145,183,150,222,82,96,249,136,100,196,100,211,106,94,111,24,112,16,114,231,118,1,128,6,134,92,134,239,141,5,143,50,151,111,155,250,157,117,158,140,120,127,121,160,125,201,131,4,147,127,158,147,158,214,138,223,88,4,95,39,103,39,112,207,116,96,124,126,128,33,81,40,112,98,114,202,120,194,140,218,140,244,140,247,150,134,78,218,80,238,91,214,94,153,101,206,113,66,118,173,119,74,128,252,132,124,144,39,155,141,159,216,88,65,90,98,92,19,106,218,109,15,111,59,118,47,125,55,126,30,133,56,137,228,147,75,150,137,82,210,101,243,103,180,105,65,109,156,110,15,112,9,116,96,116,89,117,36,118,107,120,44,139,94,152,109,81,46,98,120,150,150,79,43,80,25,93,234,109,184,125,42,143,139,95,68,97,23,104,97,249,134,150,210,82,139,128,220,81,204,81,94,105,28,122,190,125,241,131,117,150,218,79,41,82,152,83,15,84,14,85,101,92,167,96,78,103,168,104,108,109,129,114,248,114,6,116,131,116,98,249,226,117,108,124,121,127,184,127,137,131,207,136,225,136,204,145,208,145,226,150,201,155,29,84,126,111,208,113,152,116,250,133,170,142,163,150,87,156,159,158,151,103,203,109,51,116,232,129,22,151,44,120,203,122,32,123,146,124,105,100,106,116,242,117,188,120,232,120,172,153,84,155,187,158,222,91,85,94,32,111,156,129,171,131,136,144,7,78,77,83,41,90,210,93,78,95,98,97,61,99,105,102,252,102,255,110,43,111,99,112,158,119,44,132,19,133,59,136,19,143,69,153,59,156,28,85,185,98,43,103,171,108,9,131,106,137,122,151,161,78,132,89,216,95,217,95,27,103,178,125,84,127,146,130,43,131,189,131,30,143,153,144,203,87,185,89,146,90,208,91,39,102,154,103,133,104,207,107,100,113,117,127,183,140,227,140,129,144,69,155,8,129,138,140,76,150,64,154,165,158,95,91,19,108,27,115,242,118,223,118,12,132,170,81,147,137,77,81,149,81,201,82,201,104,148,108,4,119,32,119,191,125,236,125,98,151,181,158,197,110,17,133,165,81,13,84,125,84,14,102,157,102,39,105,159,110,191,118,145,119,23,131,194,132,159,135,105,145,152,146,244,156,130,136,174,79,146,81,223,82,198,89,61,94,85,97,120,100,121,100,174,102,208,103,33,106,205,107,219,107,95,114,97,114,65,116,56,119,219,119,23,128,188,130,5,131,0,139,40,139,140,140,40,103,144,108,103,114,238,118,102,119,70,122,169,157,127,107,146,108,34,89,38,103,153,132,111,83,147,88,153,89,223,94,207,99,52,102,115,103,58,110,43,115,215,122,215,130,40,147,217,82,235,93,174,97,203,97,10,98,199,98,171,100,224,101,89,105,102,107,203,107,33,113,247,115,93,117,70,126,30,130,2,131,106,133,163,138,191,140,39,151,97,157,168,88,216,158,17,80,14,82,59,84,79,85,135,101,118,108,10,125,11,125,94,128,138,134,128,149,239,150,255,82,149,108,105,114,115,84,154,90,62,92,75,93,76,95,174,95,42,103,182,104,99,105,60,110,68,110,9,119,115,124,142,127,135,133,14,139,247,143,97,151,244,158,183,92,182,96,13,97,171,97,79,101,251,101,252,101,17,108,239,108,159,115,201,115,225,125,148,149,198,91,28,135,16,139,93,82,90,83,205,98,15,100,178,100,52,103,56,106,202,108,192,115,158,116,148,123,149,124,27,126,138,129,54,130,132,133,235,143,249,150,193,153,52,79,74,83,205,83,219,83,204,98,44,100,0,101,145,101,195,105,238,108,88,111,237,115,84,117,34,118,228,118,252,118,208,120,251,120,44,121,70,125,44,130,224,135,212,143,18,152,239,152,195,82,212,98,165,100,36,110,81,111,124,118,203,141,177,145,98,146,238,154,67,155,35,80,141,80,74,87,168,89,40,92,71,94,119,95,63,98,62,101,185,101,193,101,9,102,139,103,156,105,194,110,197,120,33,125,170,128,128,129,43,130,179,130,161,132,140,134,42,138,23,139,166,144,50,150,144,159,13,80,243,79,99,249,249,87,152,95,220,98,146,99,111,103,67,110,25,113,195,118,204,128,218,128,244,136,245,136,25,137,224,140,41,143,77,145,106,150,47,79,112,79,27,94,207,103,34,104,125,118,126,118,68,155,97,94,10,106,105,113,212,113,106,117,100,249,65,126,67,133,233,133,220,152,16,79,79,123,112,127,165,149,225,81,6,94,181,104,62,108,78,108,219,108,175,114,196,123,3,131,213,108,58,116,251,80,136,82,193,88,216,100,151,106,167,116,86,118,167,120,23,134,226,149,57,151,101,249,94,83,1,95,138,139,168,143,175,143,138,144,37,82,165,119,73,156,8,159,25,78,2,80,117,81,91,92,119,94,30,102,58,102,196,103,197,104,179,112,1,117,197,117,201,121,221,122,39,143,32,153,8,154,221,79,33,88,49,88,246,91,110,102,101,107,17,109,122,110,125,111,228,115,43,117,233,131,220,136,19,137,92,139,20,143,15,79,213,80,16,83,92,83,147,91,169,95,13,103,143,121,121,129,47,131,20,133,7,137,134,137,57,143,59,143,165,153,18,156,44,103,118,78,248,79,73,89,1,92,239,92,240,92,103,99,210,104,253,112,162,113,43,116,43,126,236,132,2,135,34,144,210,146,243,156,13,78,216,78,239,79,133,80,86,82,111,82,38,84,144,84,224,87,43,89,102,90,90,91,117,91,204,91,156,94,102,249,118,98,119,101,167,101,110,109,165,110,54,114,38,123,63,124,54,127,80,129,81,129,154,129,64,130,153,130,169,131,3,138,160,140,230,140,251,140,116,141,186,141,232,144,220,145,28,150,68,150,217,153,231,156,23,83,6,82,41,84,116,86,179,88,84,89,110,89,255,95,164,97,110,98,16,102,126,108,26,113,198,118,137,124,222,124,27,125,172,130,193,140,240,150,103,249,91,79,23,95,127,95,194,98,41,93,11,103,218,104,124,120,67,126,108,157,21,78,153,80,21,83,42,83,81,83,131,89,98,90,135,94,178,96,138,97,73,98,121,98,144,101,135,103,167,105,212,107,214,107,215,107,216,107,184,108,104,249,53,116,250,117,18,120,145,120,213,121,216,121,131,124,203,125,225,127,165,128,62,129,194,129,242,131,26,135,232,136,185,138,108,139,187,140,25,145,94,151,219,152,59,159,172,86,42,91,108,95,140,101,179,106,175,107,92,109,241,111,21,112,93,114,173,115,167,140,211,140,59,152,145,97,55,108,88,128,1,154,77,78,139,78,155,78,213,78,58,79,60,79,127,79,223,79,255,80,242,83,248,83,6,85,227,85,219,86,235,88,98,89,17,90,235,91,250,91,4,92,243,93,43,94,153,95,29,96,104,99,156,101,175,101,246,103,251,103,173,104,123,107,153,108,215,108,35,110,9,112,69,115,2,120,62,121,64,121,96,121,193,121,233,123,23,125,114,125,134,128,13,130,142,131,209,132,199,134,223,136,80,138,94,138,29,139,220,140,102,141,173,143,170,144,252,152,223,153,157,158,74,82,105,249,20,103,106,249,152,80,42,82,113,92,99,101,85,108,202,115,35,117,157,117,151,123,156,132,120,145,48,151,119,78,146,100,186,107,94,113,169,133,9,78,107,249,73,103,238,104,23,110,159,130,24,133,107,136,247,99,129,111,18,146,175,152,10,78,183,80,207,80,31,81,70,85,170,85,23,86,64,91,25,92,224,92,56,94,138,94,160,94,194,94,243,96,81,104,97,106,88,110,61,114,64,114,192,114,248,118,101,121,177,123,212,127,243,136,244,137,115,138,97,140,222,140,28,151,94,88,189,116,253,140,199,85,108,249,97,122,34,125,114,130,114,114,31,117,37,117,109,249,25,123,133,88,251,88,188,93,143,94,182,94,144,95,85,96,146,98,127,99,77,101,145,102,217,102,248,102,22,104,242,104,128,114,94,116,110,123,110,125,214,125,114,127,229,128,18,130,175,133,127,137,147,138,29,144,228,146,205,158,32,159,21,89,109,89,45,94,220,96,20,102,115,102,144,103,80,108,197,109,95,111,243,119,169,120,198,132,203,145,43,147,217,78,202,80,72,81,132,85,11,91,163,91,71,98,126,101,203,101,50,110,125,113,1,116,68,116,135,116,191,116,108,118,170,121,218,125,85,126,168,127,122,129,179,129,57,130,26,134,236,135,117,138,227,141,120,144,145,146,37,148,77,153,174,155,104,83,81,92,84,105,196,108,41,109,43,110,12,130,155,133,59,137,45,138,170,138,234,150,103,159,97,82,185,102,178,107,150,126,254,135,13,141,131,149,93,150,29,101,137,109,238,113,110,249,206,87,211,89,172,91,39,96,250,96,16,98,31,102,95,102,41,115,249,115,219,118,1,119,108,123,86,128,114,128,101,129,160,138,146,145,22,78,226,82,114,107,23,109,5,122,57,123,48,125,111,249,176,140,236,83,47,86,81,88,181,91,15,92,17,92,226,93,64,98,131,99,20,100,45,102,179,104,188,108,136,109,175,110,31,112,164,112,210,113,38,117,143,117,142,117,25,118,17,123,224,123,43,124,32,125,57,125,44,133,109,133,7,134,52,138,13,144,97,144,181,144,183,146,246,151,55,154,215,79,108,92,95,103,145,109,159,124,140,126,22,139,22,141,31,144,107,91,253,93,13,100,192,132,92,144,225,152,135,115,139,91,154,96,126,103,222,109,31,138,166,138,1,144,12,152,55,82,112,249,81,112,142,120,150,147,112,136,215,145,238,79,215,83,253,85,218,86,130,87,253,88,194,90,136,91,171,92,192,92,37,94,1,97,13,98,75,98,136,99,28,100,54,101,120,101,57,106,138,107,52,108,25,109,49,111,231,113,233,114,120,115,7,116,178,116,38,118,97,119,192,121,87,122,234,122,185,124,143,125,172,125,97,126,158,127,41,129,49,131,144,132,218,132,234,133,150,136,176,138,144,139,56,143,66,144,131,144,108,145,150,146,185,146,139,150,167,150,168,150,214,150,0,151,8,152,150,153,211,154,26,155,212,83,126,88,25,89,112,91,191,91,209,109,90,111,159,113,33,116,185,116,133,128,253,131,225,93,135,95,170,95,66,96,236,101,18,104,111,105,83,106,137,107,53,109,243,109,227,115,254,118,172,119,77,123,20,125,35,129,28,130,64,131,244,132,99,133,98,138,196,138,135,145,30,147,6,152,180,153,12,98,83,136,240,143,101,146,7,93,39,93,105,93,95,116,157,129,104,135,213,111,254,98,210,127,54,137,114,137,30,78,88,78,231,80,221,82,71,83,127,98,7,102,105,126,5,136,94,150,141,79,25,83,54,86,203,89,164,90,56,92,78,92,77,92,2,94,17,95,67,96,189,101,47,102,66,102,190,103,244,103,28,115,226,119,58,121,197,127,148,132,205,132,150,137,102,138,105,138,225,138,85,140,122,140,244,87,212,91,15,95,111,96,237,98,13,105,150,107,92,110,132,113,210,123,85,135,88,139,254,142,223,152,254,152,56,79,129,79,225,79,123,84,32,90,184,91,60,97,176,101,104,102,252,113,51,117,94,121,51,125,78,129,227,129,152,131,170,133,206,133,3,135,10,138,171,142,155,143,113,249,197,143,49,89,164,91,230,91,137,96,233,91,11,92,195,95,129,108,114,249,241,109,11,112,26,117,175,130,246,138,192,78,65,83,115,249,217,150,15,108,158,78,196,79,82,81,94,85,37,90,232,92,17,98,89,114,189,130,170,131,254,134,89,136,29,138,63,150,197,150,19,153,9,157,93,157,10,88,179,92,189,93,68,94,225,96,21,97,225,99,2,106,37,110,2,145,84,147,78,152,16,156,119,159,137,91,184,92,9,99,79,102,72,104,60,119,193,150,141,151,84,152,159,155,161,101,1,139,203,142,188,149,53,85,169,92,214,93,181,94,151,102,76,118,244,131,199,149,211,88,188,98,206,114,40,157,240,78,46,89,15,96,59,102,131,107,231,121,38,157,147,83,192,84,195,87,22,93,27,97,214,102,175,109,141,120,126,130,152,150,68,151,132,83,124,98,150,99,178,109,10,126,75,129,77,152,251,106,76,127,175,157,26,158,95,78,59,80,182,81,28,89,249,96,246,99,48,105,58,114,54,128,116,249,206,145,49,95,117,249,118,249,4,125,229,130,111,132,187,132,229,133,141,142,119,249,111,79,120,249,121,249,228,88,67,91,89,96,218,99,24,101,109,101,152,102,122,249,74,105,35,106,11,109,1,112,108,113,210,117,13,118,179,121,112,122,123,249,138,127,124,249,68,137,125,249,147,139,192,145,125,150,126,249,10,153,4,87,161,95,188,101,1,111,0,118,166,121,158,138,173,153,90,155,108,159,4,81,182,97,145,98,141,106,198,129,67,80,48,88,102,95,9,113,0,138,250,138,124,91,22,134,250,79,60,81,180,86,68,89,169,99,249,109,170,93,109,105,134,81,136,78,89,79,127,249,128,249,129,249,130,89,130,249,131,249,95,107,93,108,132,249,181,116,22,121,133,249,7,130,69,130,57,131,63,143,93,143,134,249,24,153,135,249,136,249,137,249,166,78,138,249,223,87,121,95,19,102,139,249,140,249,171,117,121,126,111,139,141,249,6,144,91,154,165,86,39,88,248,89,31,90,180,91,142,249,246,94,143,249,144,249,80,99,59,99,145,249,61,105,135,108,191,108,142,109,147,109,245,109,20,111,146,249,223,112,54,113,89,113,147,249,195,113,213,113,148,249,79,120,111,120,149,249,117,123,227,125,150,249,47,126,151,249,77,136,223,142,152,249,153,249,154,249,91,146,155,249,246,156,156,249,157,249,158,249,133,96,133,109,159,249,177,113,160,249,161,249,177,149,173,83,162,249,163,249,164,249,211,103,165,249,142,112,48,113,48,116,118,130,210,130,166,249,187,149,229,154,125,158,196,102,167,249,193,113,73,132,168,249,169,249,75,88,170,249,171,249,184,93,113,95,172,249,32,102,142,102,121,105,174,105,56,108,243,108,54,110,65,111,218,111,27,112,47,112,80,113,223,113,112,115,173,249,91,116,174,249,212,116,200,118,78,122,147,126,175,249,176,249,241,130,96,138,206,143,177,249,72,147,178,249,25,151,179,249,180,249,66,78,42,80,181,249,8,82,225,83,243,102,109,108,202,111,10,115,127,119,98,122,174,130,221,133,2,134,182,249,212,136,99,138,125,139,107,140,183,249,179,146,184,249,19,151,16,152,148,78,13,79,201,79,178,80,72,83,62,84,51,84,218,85,98,88,186,88,103,89,27,90,228,91,159,96,185,249,202,97,86,101,255,101,100,102,167,104,90,108,179,111,207,112,172,113,82,115,125,123,8,135,164,138,50,156,7,159,75,92,131,108,68,115,137,115,58,146,171,110,101,116,31,118,105,122,21,126,10,134,64,81,197,88,193,100,238,116,21,117,112,118,193,127,149,144,205,150,84,153,38,110,230,116,169,122,170,122,229,129,217,134,120,135,27,138,73,90,140,91,155,91,161,104,0,105,99,109,169,115,19,116,44,116,151,120,233,125,235,127,24,129,85,129,158,131,76,140,46,150,17,152,240,102,128,95,250,101,137,103,106,108,139,115,45,80,3,90,106,107,238,119,22,89,108,93,205,93,37,115,79,117,186,249,187,249],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+312548),
allocate([229,80,249,81,47,88,45,89,150,89,218,89,229,91,188,249,189,249,162,93,215,98,22,100,147,100,254,100,190,249,220,102,191,249,72,106,192,249,255,113,100,116,193,249,136,122,175,122,71,126,94,126,0,128,112,129,194,249,239,135,129,137,32,139,89,144,195,249,128,144,82,153,126,97,50,107,116,109,31,126,37,137,177,143,209,79,173,80,151,81,199,82,199,87,137,88,185,91,184,94,66,97,149,105,140,109,103,110,182,110,148,113,98,116,40,117,44,117,115,128,56,131,201,132,10,142,148,147,222,147,196,249,142,78,81,79,118,80,42,81,200,83,203,83,243,83,135,91,211,91,36,92,26,97,130,97,244,101,91,114,151,115,64,116,194,118,80,121,145,121,185,121,6,125,189,127,139,130,213,133,94,134,194,143,71,144,245,144,234,145,133,150,232,150,233,150,214,82,103,95,237,101,49,102,47,104,92,113,54,122,193,144,10,152,145,78,197,249,82,106,158,107,144,111,137,113,24,128,184,130,83,133,75,144,149,150,242,150,251,151,26,133,49,155,144,78,138,113,196,150,67,81,159,83,225,84,19,87,18,87,163,87,155,90,196,90,195,91,40,96,63,97,244,99,133,108,57,109,114,110,144,110,48,114,63,115,87,116,209,130,129,136,69,143,96,144,198,249,98,150,88,152,27,157,8,103,138,141,94,146,77,79,73,80,222,80,113,83,13,87,212,89,1,90,9,92,112,97,144,102,45,110,50,114,75,116,239,125,195,128,14,132,102,132,63,133,95,135,91,136,24,137,2,139,85,144,203,151,79,155,115,78,145,79,18,81,106,81,199,249,47,85,169,85,122,91,165,91,124,94,125,94,190,94,160,96,223,96,8,97,9,97,196,99,56,101,9,103,200,249,212,103,218,103,201,249,97,105,98,105,185,108,39,109,202,249,56,110,203,249,225,111,54,115,55,115,204,249,92,116,49,117,205,249,82,118,206,249,207,249,173,125,254,129,56,132,213,136,152,138,219,138,237,138,48,142,66,142,74,144,62,144,122,144,73,145,201,145,110,147,208,249,209,249,9,88,210,249,211,107,137,128,178,128,211,249,212,249,65,81,107,89,57,92,213,249,214,249,100,111,167,115,228,128,7,141,215,249,23,146,143,149,216,249,217,249,218,249,219,249,127,128,14,98,28,112,104,125,141,135,220,249,160,87,105,96,71,97,183,107,190,138,128,146,177,150,89,78,31,84,235,109,45,133,112,150,243,151,238,152,214,99,227,108,145,144,221,81,201,97,186,129,249,157,157,79,26,80,0,81,156,91,15,97,255,97,236,100,5,105,197,107,145,117,227,119,169,127,100,130,143,133,251,135,99,136,188,138,112,139,171,145,140,78,229,78,10,79,221,249,222,249,55,89,232,89,223,249,242,93,27,95,91,95,33,96,224,249,225,249,226,249,227,249,62,114,229,115,228,249,112,117,205,117,229,249,251,121,230,249,12,128,51,128,132,128,225,130,81,131,231,249,232,249,189,140,179,140,135,144,233,249,234,249,244,152,12,153,235,249,236,249,55,112,202,118,202,127,204,127,252,127,26,139,186,78,193,78,3,82,112,83,237,249,189,84,224,86,251,89,197,91,21,95,205,95,110,110,238,249,239,249,106,125,53,131,240,249,147,134,141,138,241,249,109,151,119,151,242,249,243,249,0,78,90,79,126,79,249,88,229,101,162,110,56,144,176,147,185,153,251,78,236,88,138,89,217,89,65,96,244,249,245,249,20,122,246,249,79,131,195,140,101,81,68,83,247,249,248,249,249,249,205,78,105,82,85,91,191,130,212,78,58,82,168,84,201,89,255,89,80,91,87,91,92,91,99,96,72,97,203,110,153,112,110,113,134,115,247,116,181,117,193,120,43,125,5,128,234,129,40,131,23,133,201,133,238,138,199,140,204,150,92,79,250,82,188,86,171,101,40,102,124,112,184,112,53,114,189,125,141,130,76,145,192,150,114,157,113,91,231,104,152,107,122,111,222,118,145,92,171,102,91,111,180,123,42,124,54,136,220,150,8,78,215,78,32,83,52,88,187,88,239,88,108,89,7,92,51,94,132,94,53,95,140,99,178,102,86,103,31,106,163,106,12,107,63,111,70,114,250,249,80,115,139,116,224,122,167,124,120,129,223,129,231,129,138,131,108,132,35,133,148,133,207,133,221,136,19,141,172,145,119,149,156,150,141,81,201,84,40,87,176,91,77,98,80,103,61,104,147,104,61,110,211,110,125,112,33,126,193,136,161,140,9,143,75,159,78,159,45,114,143,123,205,138,26,147,71,79,78,79,50,81,128,84,208,89,149,94,181,98,117,103,110,105,23,106,174,108,26,110,217,114,42,115,189,117,184,123,53,125,231,130,249,131,87,132,247,133,91,138,175,140,135,142,25,144,184,144,206,150,95,159,227,82,10,84,225,90,194,91,88,100,117,101,244,110,196,114,251,249,132,118,77,122,27,123,77,124,62,126,223,127,123,131,43,139,202,140,100,141,225,141,95,142,234,143,249,143,105,144,209,147,67,79,122,79,179,80,104,81,120,81,77,82,106,82,97,88,124,88,96,89,8,92,85,92,219,94,155,96,48,98,19,104,191,107,8,108,177,111,78,113,32,116,48,117,56,117,81,117,114,118,76,123,139,123,173,123,198,123,143,126,110,138,62,143,73,143,63,146,147,146,34,147,43,148,251,150,90,152,107,152,30,153,7,82,42,98,152,98,89,109,100,118,202,122,192,123,118,125,96,83,190,92,151,94,56,111,185,112,152,124,17,151,142,155,222,158,165,99,122,100,118,135,1,78,149,78,173,78,92,80,117,80,72,84,195,89,154,91,64,94,173,94,247,94,129,95,197,96,58,99,63,101,116,101,204,101,118,102,120,102,254,103,104,105,137,106,99,107,64,108,192,109,232,109,31,110,94,110,30,112,161,112,142,115,253,115,58,117,91,119,135,120,142,121,11,122,125,122,190,124,142,125,71,130,2,138,234,138,158,140,45,145,74,145,216,145,102,146,204,146,32,147,6,151,86,151,92,151,2,152,14,159,54,82,145,82,124,85,36,88,29,94,31,95,140,96,208,99,175,104,223,111,109,121,44,123,205,129,186,133,253,136,248,138,68,142,141,145,100,150,155,150,61,151,76,152,74,159,206,79,70,81,203,81,169,82,50,86,20,95,107,95,170,99,205,100,233,101,65,102,250,102,249,102,29,103,157,104,215,104,253,105,21,111,110,111,103,113,229,113,42,114,170,116,58,119,86,121,90,121,223,121,32,122,149,122,151,124,223,124,68,125,112,126,135,128,251,133,164,134,84,138,191,138,153,141,129,142,32,144,109,144,227,145,59,150,213,150,229,156,207,101,7,124,179,141,195,147,88,91,10,92,82,83,217,98,29,115,39,80,151,91,158,95,176,96,107,97,213,104,217,109,46,116,46,122,66,125,156,125,49,126,107,129,42,142,53,142,126,147,24,148,80,79,80,87,230,93,167,94,43,99,106,127,59,78,79,79,143,79,90,80,221,89,196,128,106,84,104,84,254,85,79,89,153,91,222,93,218,94,93,102,49,103,241,103,42,104,232,108,50,109,74,110,141,111,183,112,224,115,135,117,76,124,2,125,44,125,162,125,31,130,219,134,59,138,133,138,112,141,138,142,51,143,49,144,78,145,82,145,68,148,208,153,249,122,165,124,202,79,1,81,198,81,200,87,239,91,251,92,89,102,61,106,90,109,150,110,236,111,12,113,111,117,227,122,34,136,33,144,117,144,203,150,255,153,1,131,45,78,242,78,70,136,205,145,125,83,219,106,107,105,65,108,122,132,158,88,142,97,254,102,239,98,221,112,17,117,199,117,82,126,184,132,73,139,8,141,75,78,234,83,171,84,48,87,64,87,215,95,1,99,7,99,111,100,47,101,232,101,122,102,157,103,179,103,98,107,96,108,154,108,44,111,229,119,37,120,73,121,87,121,25,125,162,128,2,129,243,129,157,130,183,130,24,135,140,138,252,249,4,141,190,141,114,144,244,118,25,122,55,122,84,126,119,128,7,85,212,85,117,88,47,99,34,100,73,102,75,102,109,104,155,105,132,107,37,109,177,110,205,115,104,116,161,116,91,117,185,117,225,118,30,119,139,119,230,121,9,126,29,126,251,129,47,133,151,136,58,138,209,140,235,142,176,143,50,144,173,147,99,150,115,150,7,151,132,79,241,83,234,89,201,90,25,94,78,104,198,116,190,117,233,121,146,122,163,129,237,134,234,140,204,141,237,143,159,101,21,103,253,249,247,87,87,111,221,125,47,143,246,147,198,150,181,95,242,97,132,111,20,78,152,79,31,80,201,83,223,85,111,93,238,93,33,107,100,107,203,120,154,123,254,249,73,142,202,142,110,144,73,99,62,100,64,119,132,122,47,147,127,148,106,159,176,100,175,111,230,113,168,116,218,116,196,122,18,124,130,126,178,124,152,126,154,139,10,141,125,148,16,153,76,153,57,82,223,91,230,100,45,103,46,125,237,80,195,83,121,88,88,97,89,97,250,97,172,101,217,122,146,139,150,139,9,80,33,80,117,82,49,85,60,90,224,94,112,95,52,97,94,101,12,102,54,102,162,102,205,105,196,110,50,111,22,115,33,118,147,122,57,129,89,130,214,131,188,132,181,80,240,87,192,91,232,91,105,95,161,99,38,120,181,125,220,131,33,133,199,145,245,145,138,81,245,103,86,123,172,140,196,81,187,89,189,96,85,134,28,80,255,249,84,82,58,92,125,97,26,98,211,98,242,100,165,101,204,110,32,118,10,129,96,142,95,150,187,150,223,78,67,83,152,85,41,89,221,93,197,100,201,108,250,109,148,115,127,122,27,130,166,133,228,140,16,142,119,144,231,145,225,149,33,150,198,151,248,81,242,84,134,85,185,95,164,100,136,111,180,125,31,143,77,143,53,148,201,80,22,92,190,108,251,109,27,117,187,119,61,124,100,124,121,138,194,138,30,88,190,89,22,94,119,99,82,114,138,117,107,119,220,138,188,140,18,143,243,94,116,102,248,109,125,128,193,131,203,138,81,151,214,155,0,250,67,82,255,102,149,109,239,110,224,125,230,138,46,144,94,144,212,154,29,82,127,82,232,84,148,97,132,98,219,98,162,104,18,105,90,105,53,106,146,112,38,113,93,120,1,121,14,121,210,121,13,122,150,128,120,130,213,130,73,131,73,133,130,140,133,141,98,145,139,145,174,145,195,79,209,86,237,113,215,119,0,135,248,137,248,91,214,95,81,103,168,144,226,83,90,88,245,91,164,96,129,97,96,100,61,126,112,128,37,133,131,146,174,100,172,80,20,93,0,103,156,88,189,98,168,99,14,105,120,105,30,106,107,110,186,118,203,121,187,130,41,132,207,138,168,141,253,143,18,145,75,145,156,145,16,147,24,147,154,147,219,150,54,154,13,156,17,78,92,117,93,121,250,122,81,123,201,123,46,126,196,132,89,142,116,142,248,142,16,144,37,102,63,105,67,116,250,81,46,103,220,158,69,81,224,95,150,108,242,135,93,136,119,136,180,96,181,129,3,132,5,141,214,83,57,84,52,86,54,90,49,92,138,112,224,127,90,128,6,129,237,129,163,141,137,145,95,154,242,157,116,80,196,78,160,83,251,96,44,110,100,92,136,79,36,80,228,85,217,92,95,94,101,96,148,104,187,108,196,109,190,113,212,117,244,117,97,118,26,122,73,122,199,125,251,125,110,127,244,129,169,134,28,143,201,150,179,153,82,159,71,82,197,82,237,152,170,137,3,78,210,103,6,111,181,79,226,91,149,103,136,108,120,109,27,116,39,120,221,145,124,147,196,135,228,121,49,122,235,95,214,78,164,84,62,85,174,88,165,89,240,96,83,98,214,98,54,103,85,105,53,130,64,150,177,153,221,153,44,80,83,83,68,85,124,87,1,250,88,98,2,250,226,100,107,102,221,103,193,111,239,111,34,116,56,116,23,138,56,148,81,84,6,86,102,87,72,95,154,97,78,107,88,112,173,112,187,125,149,138,106,89,43,129,162,99,8,119,61,128,170,140,84,88,45,100,187,105,149,91,17,94,111,110,3,250,105,133,76,81,240,83,42,89,32,96,75,97,134,107,112,108,240,108,30,123,206,128,212,130,198,141,176,144,177,152,4,250,199,100,164,111,145,100,4,101,78,81,16,84,31,87,14,138,95,97,118,104,5,250,219,117,82,123,113,125,26,144,6,88,204,105,127,129,42,137,0,144,57,152,120,80,87,89,172,89,149,98,15,144,42,155,93,97,121,114,214,149,97,87,70,90,244,93,138,98,173,100,250,100,119,103,226,108,62,109,44,114,54,116,52,120,119,127,173,130,219,141,23,152,36,82,66,87,127,103,72,114,227,116,169,140,166,143,17,146,42,150,107,81,237,83,76,99,105,79,4,85,150,96,87,101,155,108,127,109,76,114,253,114,23,122,135,137,157,140,109,95,142,111,249,112,168,129,14,97,191,79,79,80,65,98,71,114,199,123,232,125,233,127,77,144,173,151,25,154,182,140,106,87,115,94,176,103,13,132,85,138,32,84,22,91,99,94,226,94,10,95,131,101,186,128,61,133,137,149,91,150,72,79,5,83,13,83,15,83,134,84,250,84,3,87,3,94,22,96,155,98,177,98,85,99,6,250,225,108,102,109,177,117,50,120,222,128,47,129,222,130,97,132,178,132,141,136,18,137,11,144,234,146,253,152,145,155,69,94,180,102,221,102,17,112,6,114,7,250,245,79,125,82,106,95,83,97,83,103,25,106,2,111,226,116,104,121,104,136,121,140,199,152,196,152,67,154,193,84,31,122,83,105,247,138,74,140,168,152,174,153,124,95,171,98,178,117,174,118,171,136,127,144,66,150,57,83,60,95,197,95,204,108,204,115,98,117,139,117,70,123,254,130,157,153,79,78,60,144,11,78,85,79,166,83,15,89,200,94,48,102,179,108,85,116,119,131,102,135,192,140,80,144,30,151,21,156,209,88,120,91,80,134,20,139,180,157,210,91,104,96,141,96,241,101,87,108,34,111,163,111,26,112,85,127,240,127,145,149,146,149,80,150,211,151,114,82,68,143,253,81,43,84,184,84,99,85,138,85,187,106,181,109,216,125,102,130,156,146,119,150,121,158,8,84,200,84,210,118,228,134,164,149,212,149,92,150,162,78,9,79,238,89,230,90,247,93,82,96,151,98,109,103,65,104,134,108,47,110,56,127,155,128,42,130,8,250,9,250,5,152,165,78,85,80,179,84,147,87,90,89,105,91,179,91,200,97,119,105,119,109,35,112,249,135,227,137,114,138,231,138,130,144,237,153,184,154,190,82,56,104,22,80,120,94,79,103,71,131,76,136,171,78,17,84,174,86,230,115,21,145,255,151,9,153,87,153,153,153,83,86,159,88,91,134,49,138,178,97,246,106,123,115,210,142,71,107,170,150,87,154,85,89,0,114,107,141,105,151,212,79,244,92,38,95,248,97,91,102,235,108,171,112,132,115,185,115,254,115,41,119,77,119,67,125,98,125,35,126,55,130,82,136,10,250,226,140,73,146,111,152,81,91,116,122,64,136,1,152,204,90,224,79,84,83,62,89,253,92,62,99,121,109,249,114,5,129,7,129,162,131,207,146,48,152,168,78,68,81,17,82,139,87,98,95,194,108,206,110,5,112,80,112,175,112,146,113,233,115,105,116,74,131,162,135,97,136,8,144,162,144,163,147,168,153,110,81,87,95,224,96,103,97,179,102,89,133,74,142,175,145,139,151,78,78,146,78,124,84,213,88,250,88,125,89,181,92,39,95,54,98,72,98,10,102,103,102,235,107,105,109,207,109,86,110,248,110,148,111,224,111,233,111,93,112,208,114,37,116,90,116,224,116,147,118,92,121,202,124,30,126,225,128,166,130,107,132,191,132,78,134,95,134,116,135,119,139,106,140,172,147,0,152,101,152,209,96,22,98,119,145,90,90,15,102,247,109,62,110,63,116,66,155,253,95,218,96,15,123,196,84,24,95,94,108,211,108,42,109,216,112,5,125,121,134,12,138,59,157,22,83,140,84,5,91,58,106,107,112,117,117,141,121,190,121,177,130,239,131,113,138,65,139,168,140,116,151,11,250,244,100,43,101,186,120,187,120,107,122,56,78,154,85,80,89,166,91,123,94,163,96,219,99,97,107,101,102,83,104,25,110,101,113,176,116,8,125,132,144,105,154,37,156,59,109,209,110,62,115,65,140,202,149,240,81,76,94,168,95,77,96,246,96,48,97,76,97,67,102,68,102,165,105,193,108,95,110,201,110,98,111,76,113,156,116,135,118,193,123,39,124,82,131,87,135,81,144,141,150,195,158,47,83,222,86,251,94,138,95,98,96,148,96,247,97,102,102,3,103,156,106,238,109,174,111,112,112,106,115,106,126,190,129,52,131,212,134,168,138,196,140,131,82,114,115,150,91,107,106,4,148,238,84,134,86,93,91,72,101,133,101,201,102,159,104,141,109,198,109,59,114,180,128,117,145,77,154,175,79,25,80,154,83,14,84,60,84,137,85,197,85,63,94,140,95,61,103,102,113,221,115,5,144,219,82,243,82,100,88,206,88,4,113,143,113,251,113,176,133,19,138,136,102,168,133,167,85,132,102,74,113,49,132,73,83,153,85,193,107,89,95,189,95,238,99,137,102,71,113,241,138,29,143,190,158,17,79,58,100,203,112,102,117,103,134,100,96,78,139,248,157,71,81,246,81,8,83,54,109,248,128,209,158,21,102,35,107,152,112,213,117,3,84,121,92,7,125,22,138,32,107,61,107,70,107,56,84,112,96,61,109,213,127,8,130,214,80,222,81,156,85,107,86,205,86,236,89,9,91,12,94,153,97,152,97,49,98,94,102,230,102,153,113,185,113,186,113,167,114,167,121,0,122,178,127,112,138,0,0,0,0,0,0,1,0,160,0,167,0,168,0,169,0,175,0,176,0,178,0,183,0,184,0,198,0,215,0,216,0,230,0,247,0,248,0,0,1,1,1,2,1,3,1,4,1,5,1,6,1,7,1,8,1,9,1,10,1,11,1,12,1,13,1,14,1,15,1,16,1,17,1,18,1,19,1,22,1,23,1,24,1,25,1,26,1,27,1,28,1,29,1,30,1,31,1,32,1,33,1,34,1,35,1,36,1,37,1,38,1,39,1,40,1,41,1,42,1,43,1,46,1,47,1,48,1,49,1,52,1,53,1,54,1,55,1,56,1,57,1,58,1,59,1,60,1,61,1,62,1,65,1,66,1,67,1,68,1,69,1,70,1,71,1,72,1,74,1,75,1,76,1,77,1,80,1,81,1,82,1,83,1,84,1,85,1,86,1,87,1,88,1,89,1,90,1,91,1,92,1,93,1,94,1,95,1,96,1,97,1,98,1,99,1,100,1,101,1,102,1,103,1,104,1,105,1,106,1,107,1,108,1,109,1,110,1,111,1,112,1,113,1,114,1,115,1,116,1,117,1,118,1,119,1,120,1,121,1,122,1,123,1,124,1,125,1,126,1,146,1,160,1,161,1,175,1,176,1,24,2,25,2,26,2,27,2,198,2,199,2,216,2,217,2,219,2,220,2,221,2,0,3,1,3,3,3,9,3,35,3,122,3,132,3,133,3,134,3,136,3,137,3,138,3,140,3,142,3,143,3,144,3,145,3,146,3,147,3,148,3,149,3,150,3,151,3,152,3,153,3,154,3,155,3,156,3,157,3,158,3,159,3,160,3,161,3,163,3,164,3,165,3,166,3,167,3,168,3,169,3,170,3,171,3,172,3,173,3,174,3,175,3,176,3,177,3,178,3,179,3,180,3,181,3,182,3,183,3,184,3,185,3,186,3,187,3,188,3,189,3,190,3,191,3,192,3,193,3,194,3,195,3,196,3,197,3,198,3,199,3,200,3,201,3,202,3,203,3,204,3,205,3,206,3,1,4,2,4,3,4,4,4,5,4,6,4,7,4,8,4,9,4,10,4,11,4,12,4,14,4,15,4,16,4,17,4,18,4,19,4,20,4,21,4,22,4,23,4,24,4,25,4,26,4,27,4,28,4,29,4,30,4,31,4,32,4,33,4,34,4,35,4,36,4,37,4,38,4,39,4,40,4,41,4,42,4,43,4,44,4,45,4,46,4,47,4,48,4,49,4,50,4,51,4,52,4,53,4,54,4,55,4,56,4,57,4,58,4,59,4,60,4,61,4,62,4,63,4,64,4,65,4,66,4,67,4,68,4,69,4,70,4,71,4,72,4,73,4,74,4,75,4,76,4,77,4,78,4,79,4,81,4,82,4,83,4,84,4,85,4,86,4,87,4,88,4,89,4,90,4,91,4,92,4,94,4,95,4,144,4,145,4,176,5,177,5,178,5,179,5,180,5,181,5,182,5,183,5,184,5,185,5,187,5,188,5,189,5,190,5,191,5,192,5,193,5,194,5,195,5,208,5,209,5,210,5,211,5,212,5,213,5,214,5,215,5,216,5,217,5,218,5,219,5,220,5,221,5,222,5,223,5,224,5,225,5,226,5,227,5,228,5,229,5,230,5,231,5,232,5,233,5,234,5,240,5,241,5,242,5,243,5,244,5,12,6,27,6,31,6,33,6,34,6,35,6,36,6,37,6,38,6,39,6,40,6,41,6,42,6,43,6,44,6,45,6,46,6,47,6,48,6,49,6,50,6,51,6,52,6,53,6,54,6,55,6,56,6,57,6,58,6,64,6,65,6,66,6,67,6,68,6,69,6,70,6,71,6,72,6,73,6,74,6,75,6,76,6,77,6,78,6,79,6,80,6,81,6,82,6,121,6,126,6,134,6,136,6,145,6,152,6,169,6,175,6,186,6,190,6,193,6,210,6,1,14,2,14,3,14,4,14,5,14,6,14,7,14,8,14,9,14,10,14,11,14,12,14,13,14,14,14,15,14,16,14,17,14,18,14,19,14,20,14,21,14,22,14,23,14,24,14,25,14,26,14,27,14,28,14,29,14,30,14,31,14,32,14,33,14,34,14,35,14,36,14,37,14,38,14,39,14,40,14,41,14,42,14,43,14,44,14,45,14,46,14,47,14,48,14,49,14,50,14,51,14,52,14,53,14,54,14,55,14,56,14,57,14,58,14,63,14,64,14,65,14,66,14,67,14,68,14,69,14,70,14,71,14,72,14,73,14,74,14,75,14,76,14,77,14,78,14,79,14,80,14,81,14,82,14,83,14,84,14,85,14,86,14,87,14,88,14,89,14,90,14,91,14,2,30,3,30,10,30,11,30,30,30,31,30,64,30,65,30,86,30,87,30,96,30,97,30,106,30,107,30,128,30,129,30,130,30,131,30,132,30,133,30,242,30,243,30,12,32,13,32,14,32,15,32,19,32,20,32,21,32,23,32,24,32,25,32,26,32,28,32,29,32,30,32,32,32,33,32,34,32,38,32,48,32,57,32,58,32,170,32,171,32,172,32,175,32,22,33,34,33,25,34,26,34,72,34,100,34,101,34,32,35,33,35,0,37,2,37,12,37,16,37,20,37,24,37,28,37,36,37,44,37,52,37,60,37,80,37,81,37,82,37,83,37,84,37,85,37,86,37,87,37,88,37,89,37,90,37,91,37,92,37,93,37,94,37,95,37,96,37,97,37,98,37,99,37,100,37,101,37,102,37,103,37,104,37,105,37,106,37,107,37,108,37,128,37,132,37,136,37,140,37,144,37,145,37,146,37,147,37,160,37,0,0,2,0,0,192,3,0,0,192,4,0,0,192,5,0,0,192,6,0,0,192,7,0,0,192,8,0,0,192,9,0,0,192,10,0,0,192,11,0,0,192,12,0,0,192,13,0,0,192,14,0,0,192,15,0,0,192,16,0,0,192,17,0,0,192,18,0,0,192,19,0,0,192,20,0,0,192,21,0,0,192,22,0,0,192,23,0,0,192,24,0,0,192,25,0,0,192,26,0,0,192,27,0,0,192,28,0,0,192,29,0,0,192,30,0,0,192,31,0,0,192,0,0,0,179,1,0,0,195,2,0,0,195,3,0,0,195,4,0,0,195,5,0,0,195,6,0,0,195,7,0,0,195,8,0,0,195,9,0,0,195,10,0,0,195,11,0,0,195,12,0,0,195,13,0,0,211,14,0,0,195,15,0,0,195,0,0,12,187,1,0,12,195,2,0,12,195,3,0,12,195,4,0,12,211,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,1,2,3,4,5,6,7,8,9,255,255,255,255,255,255,255,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,255,255,255,255,255,255,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,1,2,4,7,3,6,5,0,0,0,0,0,0,0,0,105,110,102,105,110,105,116,121,0,0,0,0,0,0,0,0,110,97,110,0,0,0,0,0,95,112,137,0,255,9,47,15,10,0,0,0,100,0,0,0,232,3,0,0,16,39,0,0,160,134,1,0,64,66,15,0,128,150,152,0,0,225,245,5,17,0,10,0,17,17,17,0,0,0,0,5,0,0,0,0,0,0,9,0,0,0,0,11,0,0,0,0,0,0,0,0,17,0,15,10,17,17,17,3,10,7,0,1,19,9,11,11,0,0,9,6,11,0,0,11,0,6,17,0,0,0,17,17,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,0,17,0,10,10,17,17,17,0,10,0,0,2,0,9,11,0,0,0,9,0,11,0,0,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,12,0,0,0,0,9,12,0,0,0,0,0,12,0,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,0,0,0,0,13,0,0,0,4,13,0,0,0,0,9,14,0,0,0,0,0,14,0,0,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,15,0,0,0,0,9,16,0,0,0,0,0,16,0,0,16,0,0,18,0,0,0,18,18,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,18,0,0,0,18,18,18,0,0,0,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,0,10,0,0,0,0,9,11,0,0,0,0,0,11,0,0,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,12,0,0,0,0,9,12,0,0,0,0,0,12,0,0,12,0,0,45,43,32,32,32,48,88,48,120,0,0,0,0,0,0,0,40,110,117,108,108,41,0,0,45,48,88,43,48,88,32,48,88,45,48,120,43,48,120,32,48,120,0,0,0,0,0,0,105,110,102,0,0,0,0,0,73,78,70,0,0,0,0,0,110,97,110,0,0,0,0,0,78,65,78,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,194,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+322788);var tempDoublePtr=Runtime.alignMemory(allocate(12,"i8",ALLOC_STATIC),8);assert(tempDoublePtr%8==0),Module._i64Subtract=_i64Subtract,Module._bitshift64Ashr=_bitshift64Ashr;var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86},ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"},___errno_state=0,PATH={splitPath:function(filename){var splitPathRe=/^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;return splitPathRe.exec(filename).slice(1)},normalizeArray:function(parts,allowAboveRoot){for(var up=0,i=parts.length-1;i>=0;i--){var last=parts[i];"."===last?parts.splice(i,1):".."===last?(parts.splice(i,1),up++):up&&(parts.splice(i,1),up--)}if(allowAboveRoot)for(;up--;up)parts.unshift("..");return parts},normalize:function(path){var isAbsolute="/"===path.charAt(0),trailingSlash="/"===path.substr(-1);return path=PATH.normalizeArray(path.split("/").filter(function(p){return!!p}),!isAbsolute).join("/"),path||isAbsolute||(path="."),path&&trailingSlash&&(path+="/"),(isAbsolute?"/":"")+path},dirname:function(path){var result=PATH.splitPath(path),root=result[0],dir=result[1];return root||dir?(dir&&(dir=dir.substr(0,dir.length-1)),root+dir):"."},basename:function(path){if("/"===path)return"/";var lastSlash=path.lastIndexOf("/");return lastSlash===-1?path:path.substr(lastSlash+1)},extname:function(path){return PATH.splitPath(path)[3]},join:function(){var paths=Array.prototype.slice.call(arguments,0);return PATH.normalize(paths.join("/"))},join2:function(l,r){return PATH.normalize(l+"/"+r)},resolve:function(){for(var resolvedPath="",resolvedAbsolute=!1,i=arguments.length-1;i>=-1&&!resolvedAbsolute;i--){var path=i>=0?arguments[i]:FS.cwd();if("string"!=typeof path)throw new TypeError("Arguments to path.resolve must be strings");if(!path)return"";resolvedPath=path+"/"+resolvedPath,resolvedAbsolute="/"===path.charAt(0)}return resolvedPath=PATH.normalizeArray(resolvedPath.split("/").filter(function(p){return!!p}),!resolvedAbsolute).join("/"),(resolvedAbsolute?"/":"")+resolvedPath||"."},relative:function(from,to){function trim(arr){for(var start=0;start<arr.length&&""===arr[start];start++);for(var end=arr.length-1;end>=0&&""===arr[end];end--);return start>end?[]:arr.slice(start,end-start+1)}from=PATH.resolve(from).substr(1),to=PATH.resolve(to).substr(1);for(var fromParts=trim(from.split("/")),toParts=trim(to.split("/")),length=Math.min(fromParts.length,toParts.length),samePartsLength=length,i=0;i<length;i++)if(fromParts[i]!==toParts[i]){samePartsLength=i;break}for(var outputParts=[],i=samePartsLength;i<fromParts.length;i++)outputParts.push("..");return outputParts=outputParts.concat(toParts.slice(samePartsLength)),outputParts.join("/")}},TTY={ttys:[],init:function(){},shutdown:function(){},register:function(dev,ops){TTY.ttys[dev]={input:[],output:[],ops:ops},FS.registerDevice(dev,TTY.stream_ops)},stream_ops:{open:function(stream){var tty=TTY.ttys[stream.node.rdev];if(!tty)throw new FS.ErrnoError(ERRNO_CODES.ENODEV);stream.tty=tty,stream.seekable=!1},close:function(stream){stream.tty.ops.flush(stream.tty)},flush:function(stream){stream.tty.ops.flush(stream.tty)},read:function(stream,buffer,offset,length,pos){if(!stream.tty||!stream.tty.ops.get_char)throw new FS.ErrnoError(ERRNO_CODES.ENXIO);for(var bytesRead=0,i=0;i<length;i++){var result;try{result=stream.tty.ops.get_char(stream.tty)}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}if(void 0===result&&0===bytesRead)throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);if(null===result||void 0===result)break;bytesRead++,buffer[offset+i]=result}return bytesRead&&(stream.node.timestamp=Date.now()),bytesRead},write:function(stream,buffer,offset,length,pos){if(!stream.tty||!stream.tty.ops.put_char)throw new FS.ErrnoError(ERRNO_CODES.ENXIO);for(var i=0;i<length;i++)try{stream.tty.ops.put_char(stream.tty,buffer[offset+i])}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}return length&&(stream.node.timestamp=Date.now()),i}},default_tty_ops:{get_char:function(tty){if(!tty.input.length){var result=null;if("undefined"!=typeof window&&"function"==typeof window.prompt?(result=window.prompt("Input: "),null!==result&&(result+="\n")):"function"==typeof readline&&(result=readline(),null!==result&&(result+="\n")),!result)return null;tty.input=intArrayFromString(result,!0)}return tty.input.shift()},flush:function(tty){tty.output&&tty.output.length>0&&(Module.print(tty.output.join("")),tty.output=[])},put_char:function(tty,val){null===val||10===val?(Module.print(tty.output.join("")),tty.output=[]):tty.output.push(TTY.utf8.processCChar(val))}},default_tty1_ops:{put_char:function(tty,val){null===val||10===val?(Module.printErr(tty.output.join("")),tty.output=[]):tty.output.push(TTY.utf8.processCChar(val))},flush:function(tty){tty.output&&tty.output.length>0&&(Module.printErr(tty.output.join("")),tty.output=[])}}},MEMFS={ops_table:null,mount:function(mount){return MEMFS.createNode(null,"/",16895,0)},createNode:function(parent,name,mode,dev){if(FS.isBlkdev(mode)||FS.isFIFO(mode))throw new FS.ErrnoError(ERRNO_CODES.EPERM);MEMFS.ops_table||(MEMFS.ops_table={dir:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr,lookup:MEMFS.node_ops.lookup,
mknod:MEMFS.node_ops.mknod,rename:MEMFS.node_ops.rename,unlink:MEMFS.node_ops.unlink,rmdir:MEMFS.node_ops.rmdir,readdir:MEMFS.node_ops.readdir,symlink:MEMFS.node_ops.symlink},stream:{llseek:MEMFS.stream_ops.llseek}},file:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr},stream:{llseek:MEMFS.stream_ops.llseek,read:MEMFS.stream_ops.read,write:MEMFS.stream_ops.write,allocate:MEMFS.stream_ops.allocate,mmap:MEMFS.stream_ops.mmap}},link:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr,readlink:MEMFS.node_ops.readlink},stream:{}},chrdev:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr},stream:FS.chrdev_stream_ops}});var node=FS.createNode(parent,name,mode,dev);return FS.isDir(node.mode)?(node.node_ops=MEMFS.ops_table.dir.node,node.stream_ops=MEMFS.ops_table.dir.stream,node.contents={}):FS.isFile(node.mode)?(node.node_ops=MEMFS.ops_table.file.node,node.stream_ops=MEMFS.ops_table.file.stream,node.usedBytes=0,node.contents=null):FS.isLink(node.mode)?(node.node_ops=MEMFS.ops_table.link.node,node.stream_ops=MEMFS.ops_table.link.stream):FS.isChrdev(node.mode)&&(node.node_ops=MEMFS.ops_table.chrdev.node,node.stream_ops=MEMFS.ops_table.chrdev.stream),node.timestamp=Date.now(),parent&&(parent.contents[name]=node),node},getFileDataAsRegularArray:function(node){if(node.contents&&node.contents.subarray){for(var arr=[],i=0;i<node.usedBytes;++i)arr.push(node.contents[i]);return arr}return node.contents},getFileDataAsTypedArray:function(node){return node.contents?node.contents.subarray?node.contents.subarray(0,node.usedBytes):new Uint8Array(node.contents):new Uint8Array},expandFileStorage:function(node,newCapacity){if(node.contents&&node.contents.subarray&&newCapacity>node.contents.length&&(node.contents=MEMFS.getFileDataAsRegularArray(node),node.usedBytes=node.contents.length),!node.contents||node.contents.subarray){var prevCapacity=node.contents?node.contents.buffer.byteLength:0;if(prevCapacity>=newCapacity)return;var CAPACITY_DOUBLING_MAX=1048576;newCapacity=Math.max(newCapacity,prevCapacity*(prevCapacity<CAPACITY_DOUBLING_MAX?2:1.125)|0),0!=prevCapacity&&(newCapacity=Math.max(newCapacity,256));var oldContents=node.contents;return node.contents=new Uint8Array(newCapacity),void(node.usedBytes>0&&node.contents.set(oldContents.subarray(0,node.usedBytes),0))}for(!node.contents&&newCapacity>0&&(node.contents=[]);node.contents.length<newCapacity;)node.contents.push(0)},resizeFileStorage:function(node,newSize){if(node.usedBytes!=newSize){if(0==newSize)return node.contents=null,void(node.usedBytes=0);if(!node.contents||node.contents.subarray){var oldContents=node.contents;return node.contents=new Uint8Array(new ArrayBuffer(newSize)),oldContents&&node.contents.set(oldContents.subarray(0,Math.min(newSize,node.usedBytes))),void(node.usedBytes=newSize)}if(node.contents||(node.contents=[]),node.contents.length>newSize)node.contents.length=newSize;else for(;node.contents.length<newSize;)node.contents.push(0);node.usedBytes=newSize}},node_ops:{getattr:function(node){var attr={};return attr.dev=FS.isChrdev(node.mode)?node.id:1,attr.ino=node.id,attr.mode=node.mode,attr.nlink=1,attr.uid=0,attr.gid=0,attr.rdev=node.rdev,FS.isDir(node.mode)?attr.size=4096:FS.isFile(node.mode)?attr.size=node.usedBytes:FS.isLink(node.mode)?attr.size=node.link.length:attr.size=0,attr.atime=new Date(node.timestamp),attr.mtime=new Date(node.timestamp),attr.ctime=new Date(node.timestamp),attr.blksize=4096,attr.blocks=Math.ceil(attr.size/attr.blksize),attr},setattr:function(node,attr){void 0!==attr.mode&&(node.mode=attr.mode),void 0!==attr.timestamp&&(node.timestamp=attr.timestamp),void 0!==attr.size&&MEMFS.resizeFileStorage(node,attr.size)},lookup:function(parent,name){throw FS.genericErrors[ERRNO_CODES.ENOENT]},mknod:function(parent,name,mode,dev){return MEMFS.createNode(parent,name,mode,dev)},rename:function(old_node,new_dir,new_name){if(FS.isDir(old_node.mode)){var new_node;try{new_node=FS.lookupNode(new_dir,new_name)}catch(e){}if(new_node)for(var i in new_node.contents)throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY)}delete old_node.parent.contents[old_node.name],old_node.name=new_name,new_dir.contents[new_name]=old_node,old_node.parent=new_dir},unlink:function(parent,name){delete parent.contents[name]},rmdir:function(parent,name){var node=FS.lookupNode(parent,name);for(var i in node.contents)throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);delete parent.contents[name]},readdir:function(node){var entries=[".",".."];for(var key in node.contents)node.contents.hasOwnProperty(key)&&entries.push(key);return entries},symlink:function(parent,newname,oldpath){var node=MEMFS.createNode(parent,newname,41471,0);return node.link=oldpath,node},readlink:function(node){if(!FS.isLink(node.mode))throw new FS.ErrnoError(ERRNO_CODES.EINVAL);return node.link}},stream_ops:{read:function(stream,buffer,offset,length,position){var contents=stream.node.contents;if(position>=stream.node.usedBytes)return 0;var size=Math.min(stream.node.usedBytes-position,length);if(assert(size>=0),size>8&&contents.subarray)buffer.set(contents.subarray(position,position+size),offset);else for(var i=0;i<size;i++)buffer[offset+i]=contents[position+i];return size},write:function(stream,buffer,offset,length,position,canOwn){if(!length)return 0;var node=stream.node;if(node.timestamp=Date.now(),buffer.subarray&&(!node.contents||node.contents.subarray)){if(canOwn)return node.contents=buffer.subarray(offset,offset+length),node.usedBytes=length,length;if(0===node.usedBytes&&0===position)return node.contents=new Uint8Array(buffer.subarray(offset,offset+length)),node.usedBytes=length,length;if(position+length<=node.usedBytes)return node.contents.set(buffer.subarray(offset,offset+length),position),length}if(MEMFS.expandFileStorage(node,position+length),node.contents.subarray&&buffer.subarray)node.contents.set(buffer.subarray(offset,offset+length),position);else for(var i=0;i<length;i++)node.contents[position+i]=buffer[offset+i];return node.usedBytes=Math.max(node.usedBytes,position+length),length},llseek:function(stream,offset,whence){var position=offset;if(1===whence?position+=stream.position:2===whence&&FS.isFile(stream.node.mode)&&(position+=stream.node.usedBytes),position<0)throw new FS.ErrnoError(ERRNO_CODES.EINVAL);return position},allocate:function(stream,offset,length){MEMFS.expandFileStorage(stream.node,offset+length),stream.node.usedBytes=Math.max(stream.node.usedBytes,offset+length)},mmap:function(stream,buffer,offset,length,position,prot,flags){if(!FS.isFile(stream.node.mode))throw new FS.ErrnoError(ERRNO_CODES.ENODEV);var ptr,allocated,contents=stream.node.contents;if(2&flags||contents.buffer!==buffer&&contents.buffer!==buffer.buffer){if((position>0||position+length<stream.node.usedBytes)&&(contents=contents.subarray?contents.subarray(position,position+length):Array.prototype.slice.call(contents,position,position+length)),allocated=!0,ptr=_malloc(length),!ptr)throw new FS.ErrnoError(ERRNO_CODES.ENOMEM);buffer.set(contents,ptr)}else allocated=!1,ptr=contents.byteOffset;return{ptr:ptr,allocated:allocated}}}},IDBFS={dbs:{},indexedDB:function(){if("undefined"!=typeof indexedDB)return indexedDB;var ret=null;return"object"==typeof window&&(ret=window.indexedDB||window.mozIndexedDB||window.webkitIndexedDB||window.msIndexedDB),assert(ret,"IDBFS used, but indexedDB not supported"),ret},DB_VERSION:21,DB_STORE_NAME:"FILE_DATA",mount:function(mount){return MEMFS.mount.apply(null,arguments)},syncfs:function(mount,populate,callback){IDBFS.getLocalSet(mount,function(err,local){return err?callback(err):void IDBFS.getRemoteSet(mount,function(err,remote){if(err)return callback(err);var src=populate?remote:local,dst=populate?local:remote;IDBFS.reconcile(src,dst,callback)})})},getDB:function(name,callback){var db=IDBFS.dbs[name];if(db)return callback(null,db);var req;try{req=IDBFS.indexedDB().open(name,IDBFS.DB_VERSION)}catch(e){return callback(e)}req.onupgradeneeded=function(e){var fileStore,db=e.target.result,transaction=e.target.transaction;fileStore=db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)?transaction.objectStore(IDBFS.DB_STORE_NAME):db.createObjectStore(IDBFS.DB_STORE_NAME),fileStore.createIndex("timestamp","timestamp",{unique:!1})},req.onsuccess=function(){db=req.result,IDBFS.dbs[name]=db,callback(null,db)},req.onerror=function(){callback(this.error)}},getLocalSet:function(mount,callback){function isRealDir(p){return"."!==p&&".."!==p}function toAbsolute(root){return function(p){return PATH.join2(root,p)}}for(var entries={},check=FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));check.length;){var stat,path=check.pop();try{stat=FS.stat(path)}catch(e){return callback(e)}FS.isDir(stat.mode)&&check.push.apply(check,FS.readdir(path).filter(isRealDir).map(toAbsolute(path))),entries[path]={timestamp:stat.mtime}}return callback(null,{type:"local",entries:entries})},getRemoteSet:function(mount,callback){var entries={};IDBFS.getDB(mount.mountpoint,function(err,db){if(err)return callback(err);var transaction=db.transaction([IDBFS.DB_STORE_NAME],"readonly");transaction.onerror=function(){callback(this.error)};var store=transaction.objectStore(IDBFS.DB_STORE_NAME),index=store.index("timestamp");index.openKeyCursor().onsuccess=function(event){var cursor=event.target.result;return cursor?(entries[cursor.primaryKey]={timestamp:cursor.key},void cursor.continue()):callback(null,{type:"remote",db:db,entries:entries})}})},loadLocalEntry:function(path,callback){var stat,node;try{var lookup=FS.lookupPath(path);node=lookup.node,stat=FS.stat(path)}catch(e){return callback(e)}return FS.isDir(stat.mode)?callback(null,{timestamp:stat.mtime,mode:stat.mode}):FS.isFile(stat.mode)?(node.contents=MEMFS.getFileDataAsTypedArray(node),callback(null,{timestamp:stat.mtime,mode:stat.mode,contents:node.contents})):callback(new Error("node type not supported"))},storeLocalEntry:function(path,entry,callback){try{if(FS.isDir(entry.mode))FS.mkdir(path,entry.mode);else{if(!FS.isFile(entry.mode))return callback(new Error("node type not supported"));FS.writeFile(path,entry.contents,{encoding:"binary",canOwn:!0})}FS.chmod(path,entry.mode),FS.utime(path,entry.timestamp,entry.timestamp)}catch(e){return callback(e)}callback(null)},removeLocalEntry:function(path,callback){try{var stat=(FS.lookupPath(path),FS.stat(path));FS.isDir(stat.mode)?FS.rmdir(path):FS.isFile(stat.mode)&&FS.unlink(path)}catch(e){return callback(e)}callback(null)},loadRemoteEntry:function(store,path,callback){var req=store.get(path);req.onsuccess=function(event){callback(null,event.target.result)},req.onerror=function(){callback(this.error)}},storeRemoteEntry:function(store,path,entry,callback){var req=store.put(entry,path);req.onsuccess=function(){callback(null)},req.onerror=function(){callback(this.error)}},removeRemoteEntry:function(store,path,callback){var req=store.delete(path);req.onsuccess=function(){callback(null)},req.onerror=function(){callback(this.error)}},reconcile:function(src,dst,callback){function done(err){if(err){if(!done.errored)return done.errored=!0,callback(err)}else if(++completed>=total)return callback(null)}var total=0,create=[];Object.keys(src.entries).forEach(function(key){var e=src.entries[key],e2=dst.entries[key];(!e2||e.timestamp>e2.timestamp)&&(create.push(key),total++)});var remove=[];if(Object.keys(dst.entries).forEach(function(key){var e2=(dst.entries[key],src.entries[key]);e2||(remove.push(key),total++)}),!total)return callback(null);var completed=0,db="remote"===src.type?src.db:dst.db,transaction=db.transaction([IDBFS.DB_STORE_NAME],"readwrite"),store=transaction.objectStore(IDBFS.DB_STORE_NAME);transaction.onerror=function(){done(this.error)},create.sort().forEach(function(path){"local"===dst.type?IDBFS.loadRemoteEntry(store,path,function(err,entry){return err?done(err):void IDBFS.storeLocalEntry(path,entry,done)}):IDBFS.loadLocalEntry(path,function(err,entry){return err?done(err):void IDBFS.storeRemoteEntry(store,path,entry,done)})}),remove.sort().reverse().forEach(function(path){"local"===dst.type?IDBFS.removeLocalEntry(path,done):IDBFS.removeRemoteEntry(store,path,done)})}},NODEFS={isWindows:!1,staticInit:function(){NODEFS.isWindows=!!process.platform.match(/^win/)},mount:function(mount){return assert(!1),NODEFS.createNode(null,"/",NODEFS.getMode(mount.opts.root),0)},createNode:function(parent,name,mode,dev){if(!FS.isDir(mode)&&!FS.isFile(mode)&&!FS.isLink(mode))throw new FS.ErrnoError(ERRNO_CODES.EINVAL);var node=FS.createNode(parent,name,mode);return node.node_ops=NODEFS.node_ops,node.stream_ops=NODEFS.stream_ops,node},getMode:function(path){var stat;try{stat=fs.lstatSync(path),NODEFS.isWindows&&(stat.mode=stat.mode|(146&stat.mode)>>1)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}return stat.mode},realPath:function(node){for(var parts=[];node.parent!==node;)parts.push(node.name),node=node.parent;return parts.push(node.mount.opts.root),parts.reverse(),PATH.join.apply(null,parts)},flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:function(flags){return flags in NODEFS.flagsToPermissionStringMap?NODEFS.flagsToPermissionStringMap[flags]:flags},node_ops:{getattr:function(node){var stat,path=NODEFS.realPath(node);try{stat=fs.lstatSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}return NODEFS.isWindows&&!stat.blksize&&(stat.blksize=4096),NODEFS.isWindows&&!stat.blocks&&(stat.blocks=(stat.size+stat.blksize-1)/stat.blksize|0),{dev:stat.dev,ino:stat.ino,mode:stat.mode,nlink:stat.nlink,uid:stat.uid,gid:stat.gid,rdev:stat.rdev,size:stat.size,atime:stat.atime,mtime:stat.mtime,ctime:stat.ctime,blksize:stat.blksize,blocks:stat.blocks}},setattr:function(node,attr){var path=NODEFS.realPath(node);try{if(void 0!==attr.mode&&(fs.chmodSync(path,attr.mode),node.mode=attr.mode),void 0!==attr.timestamp){var date=new Date(attr.timestamp);fs.utimesSync(path,date,date)}void 0!==attr.size&&fs.truncateSync(path,attr.size)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}},lookup:function(parent,name){var path=PATH.join2(NODEFS.realPath(parent),name),mode=NODEFS.getMode(path);return NODEFS.createNode(parent,name,mode)},mknod:function(parent,name,mode,dev){var node=NODEFS.createNode(parent,name,mode,dev),path=NODEFS.realPath(node);try{FS.isDir(node.mode)?fs.mkdirSync(path,node.mode):fs.writeFileSync(path,"",{mode:node.mode})}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}return node},rename:function(oldNode,newDir,newName){var oldPath=NODEFS.realPath(oldNode),newPath=PATH.join2(NODEFS.realPath(newDir),newName);try{fs.renameSync(oldPath,newPath)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}},unlink:function(parent,name){var path=PATH.join2(NODEFS.realPath(parent),name);try{fs.unlinkSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}},rmdir:function(parent,name){var path=PATH.join2(NODEFS.realPath(parent),name);try{fs.rmdirSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}},readdir:function(node){var path=NODEFS.realPath(node);try{return fs.readdirSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}},symlink:function(parent,newName,oldPath){var newPath=PATH.join2(NODEFS.realPath(parent),newName);try{fs.symlinkSync(oldPath,newPath)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}},readlink:function(node){var path=NODEFS.realPath(node);try{return fs.readlinkSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}},stream_ops:{open:function(stream){var path=NODEFS.realPath(stream.node);try{FS.isFile(stream.node.mode)&&(stream.nfd=fs.openSync(path,NODEFS.flagsToPermissionString(stream.flags)))}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}},close:function(stream){try{FS.isFile(stream.node.mode)&&stream.nfd&&fs.closeSync(stream.nfd)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}},read:function(stream,buffer,offset,length,position){if(0===length)return 0;var res,nbuffer=new Buffer(length);try{res=fs.readSync(stream.nfd,nbuffer,0,length,position)}catch(e){throw new FS.ErrnoError(ERRNO_CODES[e.code])}if(res>0)for(var i=0;i<res;i++)buffer[offset+i]=nbuffer[i];return res},write:function(stream,buffer,offset,length,position){var res,nbuffer=new Buffer(buffer.subarray(offset,offset+length));try{res=fs.writeSync(stream.nfd,nbuffer,0,length,position)}catch(e){throw new FS.ErrnoError(ERRNO_CODES[e.code])}return res},llseek:function(stream,offset,whence){var position=offset;if(1===whence)position+=stream.position;else if(2===whence&&FS.isFile(stream.node.mode))try{var stat=fs.fstatSync(stream.nfd);position+=stat.size}catch(e){throw new FS.ErrnoError(ERRNO_CODES[e.code])}if(position<0)throw new FS.ErrnoError(ERRNO_CODES.EINVAL);return position}}},_stdin=allocate(1,"i32*",ALLOC_STATIC),_stdout=allocate(1,"i32*",ALLOC_STATIC),_stderr=allocate(1,"i32*",ALLOC_STATIC),FS={root:null,mounts:[],devices:[null],streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:!1,ignorePermissions:!0,trackingDelegate:{},tracking:{openFlags:{READ:1,WRITE:2}},ErrnoError:null,genericErrors:{},handleFSError:function(e){if(!(e instanceof FS.ErrnoError))throw e+" : "+stackTrace();return ___setErrNo(e.errno)},lookupPath:function(path,opts){if(path=PATH.resolve(FS.cwd(),path),opts=opts||{},!path)return{path:"",node:null};var defaults={follow_mount:!0,recurse_count:0};for(var key in defaults)void 0===opts[key]&&(opts[key]=defaults[key]);if(opts.recurse_count>8)throw new FS.ErrnoError(ERRNO_CODES.ELOOP);for(var parts=PATH.normalizeArray(path.split("/").filter(function(p){return!!p}),!1),current=FS.root,current_path="/",i=0;i<parts.length;i++){var islast=i===parts.length-1;if(islast&&opts.parent)break;if(current=FS.lookupNode(current,parts[i]),current_path=PATH.join2(current_path,parts[i]),FS.isMountpoint(current)&&(!islast||islast&&opts.follow_mount)&&(current=current.mounted.root),!islast||opts.follow)for(var count=0;FS.isLink(current.mode);){var link=FS.readlink(current_path);current_path=PATH.resolve(PATH.dirname(current_path),link);var lookup=FS.lookupPath(current_path,{recurse_count:opts.recurse_count});if(current=lookup.node,count++>40)throw new FS.ErrnoError(ERRNO_CODES.ELOOP)}}return{path:current_path,node:current}},getPath:function(node){for(var path;;){if(FS.isRoot(node)){var mount=node.mount.mountpoint;return path?"/"!==mount[mount.length-1]?mount+"/"+path:mount+path:mount}path=path?node.name+"/"+path:node.name,node=node.parent}},hashName:function(parentid,name){for(var hash=0,i=0;i<name.length;i++)hash=(hash<<5)-hash+name.charCodeAt(i)|0;return(parentid+hash>>>0)%FS.nameTable.length},hashAddNode:function(node){var hash=FS.hashName(node.parent.id,node.name);node.name_next=FS.nameTable[hash],FS.nameTable[hash]=node},hashRemoveNode:function(node){var hash=FS.hashName(node.parent.id,node.name);if(FS.nameTable[hash]===node)FS.nameTable[hash]=node.name_next;else for(var current=FS.nameTable[hash];current;){if(current.name_next===node){current.name_next=node.name_next;break}current=current.name_next}},lookupNode:function(parent,name){var err=FS.mayLookup(parent);if(err)throw new FS.ErrnoError(err,parent);for(var hash=FS.hashName(parent.id,name),node=FS.nameTable[hash];node;node=node.name_next){var nodeName=node.name;if(node.parent.id===parent.id&&nodeName===name)return node}return FS.lookup(parent,name)},createNode:function(parent,name,mode,rdev){if(!FS.FSNode){FS.FSNode=function(parent,name,mode,rdev){parent||(parent=this),this.parent=parent,this.mount=parent.mount,this.mounted=null,this.id=FS.nextInode++,this.name=name,this.mode=mode,this.node_ops={},this.stream_ops={},this.rdev=rdev},FS.FSNode.prototype={};var readMode=365,writeMode=146;Object.defineProperties(FS.FSNode.prototype,{read:{get:function(){return(this.mode&readMode)===readMode},set:function(val){val?this.mode|=readMode:this.mode&=~readMode}},write:{get:function(){return(this.mode&writeMode)===writeMode},set:function(val){val?this.mode|=writeMode:this.mode&=~writeMode}},isFolder:{get:function(){return FS.isDir(this.mode)}},isDevice:{get:function(){return FS.isChrdev(this.mode)}}})}var node=new FS.FSNode(parent,name,mode,rdev);return FS.hashAddNode(node),node},destroyNode:function(node){FS.hashRemoveNode(node)},isRoot:function(node){return node===node.parent},isMountpoint:function(node){return!!node.mounted},isFile:function(mode){return 32768===(61440&mode)},isDir:function(mode){return 16384===(61440&mode)},isLink:function(mode){return 40960===(61440&mode)},isChrdev:function(mode){return 8192===(61440&mode)},isBlkdev:function(mode){return 24576===(61440&mode)},isFIFO:function(mode){return 4096===(61440&mode)},isSocket:function(mode){return 49152===(49152&mode)},flagModes:{r:0,rs:1052672,"r+":2,w:577,wx:705,xw:705,"w+":578,"wx+":706,"xw+":706,a:1089,ax:1217,xa:1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:function(str){var flags=FS.flagModes[str];if("undefined"==typeof flags)throw new Error("Unknown file open mode: "+str);return flags},flagsToPermissionString:function(flag){var accmode=2097155&flag,perms=["r","w","rw"][accmode];return 512&flag&&(perms+="w"),perms},nodePermissions:function(node,perms){return FS.ignorePermissions?0:(perms.indexOf("r")===-1||292&node.mode)&&(perms.indexOf("w")===-1||146&node.mode)&&(perms.indexOf("x")===-1||73&node.mode)?0:ERRNO_CODES.EACCES},mayLookup:function(dir){var err=FS.nodePermissions(dir,"x");return err?err:dir.node_ops.lookup?0:ERRNO_CODES.EACCES},mayCreate:function(dir,name){try{FS.lookupNode(dir,name);return ERRNO_CODES.EEXIST}catch(e){}return FS.nodePermissions(dir,"wx")},mayDelete:function(dir,name,isdir){var node;try{node=FS.lookupNode(dir,name)}catch(e){return e.errno}var err=FS.nodePermissions(dir,"wx");if(err)return err;if(isdir){if(!FS.isDir(node.mode))return ERRNO_CODES.ENOTDIR;if(FS.isRoot(node)||FS.getPath(node)===FS.cwd())return ERRNO_CODES.EBUSY}else if(FS.isDir(node.mode))return ERRNO_CODES.EISDIR;return 0},mayOpen:function(node,flags){return node?FS.isLink(node.mode)?ERRNO_CODES.ELOOP:FS.isDir(node.mode)&&(0!==(2097155&flags)||512&flags)?ERRNO_CODES.EISDIR:FS.nodePermissions(node,FS.flagsToPermissionString(flags)):ERRNO_CODES.ENOENT},MAX_OPEN_FDS:4096,nextfd:function(fd_start,fd_end){fd_start=fd_start||0,fd_end=fd_end||FS.MAX_OPEN_FDS;for(var fd=fd_start;fd<=fd_end;fd++)if(!FS.streams[fd])return fd;throw new FS.ErrnoError(ERRNO_CODES.EMFILE)},getStream:function(fd){return FS.streams[fd]},createStream:function(stream,fd_start,fd_end){FS.FSStream||(FS.FSStream=function(){},FS.FSStream.prototype={},Object.defineProperties(FS.FSStream.prototype,{object:{get:function(){return this.node},set:function(val){this.node=val}},isRead:{get:function(){return 1!==(2097155&this.flags)}},isWrite:{get:function(){return 0!==(2097155&this.flags)}},isAppend:{get:function(){return 1024&this.flags}}}));var newStream=new FS.FSStream;for(var p in stream)newStream[p]=stream[p];stream=newStream;var fd=FS.nextfd(fd_start,fd_end);return stream.fd=fd,FS.streams[fd]=stream,stream},closeStream:function(fd){FS.streams[fd]=null},getStreamFromPtr:function(ptr){return FS.streams[ptr-1]},getPtrForStream:function(stream){return stream?stream.fd+1:0},chrdev_stream_ops:{open:function(stream){var device=FS.getDevice(stream.node.rdev);stream.stream_ops=device.stream_ops,stream.stream_ops.open&&stream.stream_ops.open(stream)},llseek:function(){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)}},major:function(dev){return dev>>8},minor:function(dev){return 255&dev},makedev:function(ma,mi){return ma<<8|mi},registerDevice:function(dev,ops){FS.devices[dev]={stream_ops:ops}},getDevice:function(dev){return FS.devices[dev]},getMounts:function(mount){for(var mounts=[],check=[mount];check.length;){var m=check.pop();mounts.push(m),check.push.apply(check,m.mounts)}return mounts},syncfs:function(populate,callback){function done(err){if(err){if(!done.errored)return done.errored=!0,callback(err)}else++completed>=mounts.length&&callback(null)}"function"==typeof populate&&(callback=populate,populate=!1);var mounts=FS.getMounts(FS.root.mount),completed=0;mounts.forEach(function(mount){return mount.type.syncfs?void mount.type.syncfs(mount,populate,done):done(null)})},mount:function(type,opts,mountpoint){var node,root="/"===mountpoint,pseudo=!mountpoint;if(root&&FS.root)throw new FS.ErrnoError(ERRNO_CODES.EBUSY);if(!root&&!pseudo){var lookup=FS.lookupPath(mountpoint,{follow_mount:!1});if(mountpoint=lookup.path,node=lookup.node,FS.isMountpoint(node))throw new FS.ErrnoError(ERRNO_CODES.EBUSY);if(!FS.isDir(node.mode))throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}var mount={type:type,opts:opts,mountpoint:mountpoint,mounts:[]},mountRoot=type.mount(mount);return mountRoot.mount=mount,mount.root=mountRoot,root?FS.root=mountRoot:node&&(node.mounted=mount,node.mount&&node.mount.mounts.push(mount)),mountRoot},unmount:function(mountpoint){var lookup=FS.lookupPath(mountpoint,{follow_mount:!1});if(!FS.isMountpoint(lookup.node))throw new FS.ErrnoError(ERRNO_CODES.EINVAL);var node=lookup.node,mount=node.mounted,mounts=FS.getMounts(mount);Object.keys(FS.nameTable).forEach(function(hash){for(var current=FS.nameTable[hash];current;){var next=current.name_next;mounts.indexOf(current.mount)!==-1&&FS.destroyNode(current),current=next}}),node.mounted=null;var idx=node.mount.mounts.indexOf(mount);assert(idx!==-1),node.mount.mounts.splice(idx,1)},lookup:function(parent,name){return parent.node_ops.lookup(parent,name)},mknod:function(path,mode,dev){var lookup=FS.lookupPath(path,{parent:!0}),parent=lookup.node,name=PATH.basename(path);if(!name||"."===name||".."===name)throw new FS.ErrnoError(ERRNO_CODES.EINVAL);var err=FS.mayCreate(parent,name);if(err)throw new FS.ErrnoError(err);if(!parent.node_ops.mknod)throw new FS.ErrnoError(ERRNO_CODES.EPERM);return parent.node_ops.mknod(parent,name,mode,dev)},create:function(path,mode){return mode=void 0!==mode?mode:438,mode&=4095,mode|=32768,FS.mknod(path,mode,0)},mkdir:function(path,mode){return mode=void 0!==mode?mode:511,mode&=1023,mode|=16384,FS.mknod(path,mode,0)},mkdev:function(path,mode,dev){return"undefined"==typeof dev&&(dev=mode,mode=438),mode|=8192,FS.mknod(path,mode,dev)},symlink:function(oldpath,newpath){if(!PATH.resolve(oldpath))throw new FS.ErrnoError(ERRNO_CODES.ENOENT);var lookup=FS.lookupPath(newpath,{parent:!0}),parent=lookup.node;if(!parent)throw new FS.ErrnoError(ERRNO_CODES.ENOENT);var newname=PATH.basename(newpath),err=FS.mayCreate(parent,newname);if(err)throw new FS.ErrnoError(err);if(!parent.node_ops.symlink)throw new FS.ErrnoError(ERRNO_CODES.EPERM);return parent.node_ops.symlink(parent,newname,oldpath)},rename:function(old_path,new_path){var lookup,old_dir,new_dir,old_dirname=PATH.dirname(old_path),new_dirname=PATH.dirname(new_path),old_name=PATH.basename(old_path),new_name=PATH.basename(new_path);try{lookup=FS.lookupPath(old_path,{parent:!0}),old_dir=lookup.node,lookup=FS.lookupPath(new_path,{parent:!0}),new_dir=lookup.node}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}if(!old_dir||!new_dir)throw new FS.ErrnoError(ERRNO_CODES.ENOENT);if(old_dir.mount!==new_dir.mount)throw new FS.ErrnoError(ERRNO_CODES.EXDEV);var old_node=FS.lookupNode(old_dir,old_name),relative=PATH.relative(old_path,new_dirname);if("."!==relative.charAt(0))throw new FS.ErrnoError(ERRNO_CODES.EINVAL);if(relative=PATH.relative(new_path,old_dirname),"."!==relative.charAt(0))throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);var new_node;try{new_node=FS.lookupNode(new_dir,new_name)}catch(e){}if(old_node!==new_node){var isdir=FS.isDir(old_node.mode),err=FS.mayDelete(old_dir,old_name,isdir);if(err)throw new FS.ErrnoError(err);if(err=new_node?FS.mayDelete(new_dir,new_name,isdir):FS.mayCreate(new_dir,new_name))throw new FS.ErrnoError(err);if(!old_dir.node_ops.rename)throw new FS.ErrnoError(ERRNO_CODES.EPERM);if(FS.isMountpoint(old_node)||new_node&&FS.isMountpoint(new_node))throw new FS.ErrnoError(ERRNO_CODES.EBUSY);if(new_dir!==old_dir&&(err=FS.nodePermissions(old_dir,"w")))throw new FS.ErrnoError(err);try{FS.trackingDelegate.willMovePath&&FS.trackingDelegate.willMovePath(old_path,new_path)}catch(e){console.log("FS.trackingDelegate['willMovePath']('"+old_path+"', '"+new_path+"') threw an exception: "+e.message)}FS.hashRemoveNode(old_node);try{old_dir.node_ops.rename(old_node,new_dir,new_name)}catch(e){throw e}finally{FS.hashAddNode(old_node)}try{FS.trackingDelegate.onMovePath&&FS.trackingDelegate.onMovePath(old_path,new_path)}catch(e){console.log("FS.trackingDelegate['onMovePath']('"+old_path+"', '"+new_path+"') threw an exception: "+e.message)}}},rmdir:function(path){var lookup=FS.lookupPath(path,{parent:!0}),parent=lookup.node,name=PATH.basename(path),node=FS.lookupNode(parent,name),err=FS.mayDelete(parent,name,!0);if(err)throw new FS.ErrnoError(err);if(!parent.node_ops.rmdir)throw new FS.ErrnoError(ERRNO_CODES.EPERM);if(FS.isMountpoint(node))throw new FS.ErrnoError(ERRNO_CODES.EBUSY);try{FS.trackingDelegate.willDeletePath&&FS.trackingDelegate.willDeletePath(path)}catch(e){console.log("FS.trackingDelegate['willDeletePath']('"+path+"') threw an exception: "+e.message)}parent.node_ops.rmdir(parent,name),FS.destroyNode(node);try{FS.trackingDelegate.onDeletePath&&FS.trackingDelegate.onDeletePath(path)}catch(e){console.log("FS.trackingDelegate['onDeletePath']('"+path+"') threw an exception: "+e.message)}},readdir:function(path){var lookup=FS.lookupPath(path,{follow:!0}),node=lookup.node;if(!node.node_ops.readdir)throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);return node.node_ops.readdir(node)},unlink:function(path){var lookup=FS.lookupPath(path,{parent:!0}),parent=lookup.node,name=PATH.basename(path),node=FS.lookupNode(parent,name),err=FS.mayDelete(parent,name,!1);if(err)throw err===ERRNO_CODES.EISDIR&&(err=ERRNO_CODES.EPERM),new FS.ErrnoError(err);if(!parent.node_ops.unlink)throw new FS.ErrnoError(ERRNO_CODES.EPERM);if(FS.isMountpoint(node))throw new FS.ErrnoError(ERRNO_CODES.EBUSY);try{FS.trackingDelegate.willDeletePath&&FS.trackingDelegate.willDeletePath(path)}catch(e){console.log("FS.trackingDelegate['willDeletePath']('"+path+"') threw an exception: "+e.message)}parent.node_ops.unlink(parent,name),FS.destroyNode(node);try{FS.trackingDelegate.onDeletePath&&FS.trackingDelegate.onDeletePath(path)}catch(e){console.log("FS.trackingDelegate['onDeletePath']('"+path+"') threw an exception: "+e.message)}},readlink:function(path){var lookup=FS.lookupPath(path),link=lookup.node;if(!link)throw new FS.ErrnoError(ERRNO_CODES.ENOENT);if(!link.node_ops.readlink)throw new FS.ErrnoError(ERRNO_CODES.EINVAL);return link.node_ops.readlink(link)},stat:function(path,dontFollow){var lookup=FS.lookupPath(path,{follow:!dontFollow}),node=lookup.node;if(!node)throw new FS.ErrnoError(ERRNO_CODES.ENOENT);if(!node.node_ops.getattr)throw new FS.ErrnoError(ERRNO_CODES.EPERM);return node.node_ops.getattr(node)},lstat:function(path){return FS.stat(path,!0)},chmod:function(path,mode,dontFollow){var node;if("string"==typeof path){var lookup=FS.lookupPath(path,{follow:!dontFollow});node=lookup.node}else node=path;if(!node.node_ops.setattr)throw new FS.ErrnoError(ERRNO_CODES.EPERM);node.node_ops.setattr(node,{mode:4095&mode|node.mode&-4096,timestamp:Date.now()})},lchmod:function(path,mode){FS.chmod(path,mode,!0)},fchmod:function(fd,mode){var stream=FS.getStream(fd);if(!stream)throw new FS.ErrnoError(ERRNO_CODES.EBADF);FS.chmod(stream.node,mode)},chown:function(path,uid,gid,dontFollow){var node;if("string"==typeof path){var lookup=FS.lookupPath(path,{follow:!dontFollow});node=lookup.node}else node=path;if(!node.node_ops.setattr)throw new FS.ErrnoError(ERRNO_CODES.EPERM);node.node_ops.setattr(node,{timestamp:Date.now()});
},lchown:function(path,uid,gid){FS.chown(path,uid,gid,!0)},fchown:function(fd,uid,gid){var stream=FS.getStream(fd);if(!stream)throw new FS.ErrnoError(ERRNO_CODES.EBADF);FS.chown(stream.node,uid,gid)},truncate:function(path,len){if(len<0)throw new FS.ErrnoError(ERRNO_CODES.EINVAL);var node;if("string"==typeof path){var lookup=FS.lookupPath(path,{follow:!0});node=lookup.node}else node=path;if(!node.node_ops.setattr)throw new FS.ErrnoError(ERRNO_CODES.EPERM);if(FS.isDir(node.mode))throw new FS.ErrnoError(ERRNO_CODES.EISDIR);if(!FS.isFile(node.mode))throw new FS.ErrnoError(ERRNO_CODES.EINVAL);var err=FS.nodePermissions(node,"w");if(err)throw new FS.ErrnoError(err);node.node_ops.setattr(node,{size:len,timestamp:Date.now()})},ftruncate:function(fd,len){var stream=FS.getStream(fd);if(!stream)throw new FS.ErrnoError(ERRNO_CODES.EBADF);if(0===(2097155&stream.flags))throw new FS.ErrnoError(ERRNO_CODES.EINVAL);FS.truncate(stream.node,len)},utime:function(path,atime,mtime){var lookup=FS.lookupPath(path,{follow:!0}),node=lookup.node;node.node_ops.setattr(node,{timestamp:Math.max(atime,mtime)})},open:function(path,flags,mode,fd_start,fd_end){if(""===path)throw new FS.ErrnoError(ERRNO_CODES.ENOENT);flags="string"==typeof flags?FS.modeStringToFlags(flags):flags,mode="undefined"==typeof mode?438:mode,mode=64&flags?4095&mode|32768:0;var node;if("object"==typeof path)node=path;else{path=PATH.normalize(path);try{var lookup=FS.lookupPath(path,{follow:!(131072&flags)});node=lookup.node}catch(e){}}var created=!1;if(64&flags)if(node){if(128&flags)throw new FS.ErrnoError(ERRNO_CODES.EEXIST)}else node=FS.mknod(path,mode,0),created=!0;if(!node)throw new FS.ErrnoError(ERRNO_CODES.ENOENT);if(FS.isChrdev(node.mode)&&(flags&=-513),!created){var err=FS.mayOpen(node,flags);if(err)throw new FS.ErrnoError(err)}512&flags&&FS.truncate(node,0),flags&=-641;var stream=FS.createStream({node:node,path:FS.getPath(node),flags:flags,seekable:!0,position:0,stream_ops:node.stream_ops,ungotten:[],error:!1},fd_start,fd_end);stream.stream_ops.open&&stream.stream_ops.open(stream),!Module.logReadFiles||1&flags||(FS.readFiles||(FS.readFiles={}),path in FS.readFiles||(FS.readFiles[path]=1,Module.printErr("read file: "+path)));try{if(FS.trackingDelegate.onOpenFile){var trackingFlags=0;1!==(2097155&flags)&&(trackingFlags|=FS.tracking.openFlags.READ),0!==(2097155&flags)&&(trackingFlags|=FS.tracking.openFlags.WRITE),FS.trackingDelegate.onOpenFile(path,trackingFlags)}}catch(e){console.log("FS.trackingDelegate['onOpenFile']('"+path+"', flags) threw an exception: "+e.message)}return stream},close:function(stream){try{stream.stream_ops.close&&stream.stream_ops.close(stream)}catch(e){throw e}finally{FS.closeStream(stream.fd)}},llseek:function(stream,offset,whence){if(!stream.seekable||!stream.stream_ops.llseek)throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);return stream.position=stream.stream_ops.llseek(stream,offset,whence),stream.ungotten=[],stream.position},read:function(stream,buffer,offset,length,position){if(length<0||position<0)throw new FS.ErrnoError(ERRNO_CODES.EINVAL);if(1===(2097155&stream.flags))throw new FS.ErrnoError(ERRNO_CODES.EBADF);if(FS.isDir(stream.node.mode))throw new FS.ErrnoError(ERRNO_CODES.EISDIR);if(!stream.stream_ops.read)throw new FS.ErrnoError(ERRNO_CODES.EINVAL);var seeking=!0;if("undefined"==typeof position)position=stream.position,seeking=!1;else if(!stream.seekable)throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);var bytesRead=stream.stream_ops.read(stream,buffer,offset,length,position);return seeking||(stream.position+=bytesRead),bytesRead},write:function(stream,buffer,offset,length,position,canOwn){if(length<0||position<0)throw new FS.ErrnoError(ERRNO_CODES.EINVAL);if(0===(2097155&stream.flags))throw new FS.ErrnoError(ERRNO_CODES.EBADF);if(FS.isDir(stream.node.mode))throw new FS.ErrnoError(ERRNO_CODES.EISDIR);if(!stream.stream_ops.write)throw new FS.ErrnoError(ERRNO_CODES.EINVAL);1024&stream.flags&&FS.llseek(stream,0,2);var seeking=!0;if("undefined"==typeof position)position=stream.position,seeking=!1;else if(!stream.seekable)throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);var bytesWritten=stream.stream_ops.write(stream,buffer,offset,length,position,canOwn);seeking||(stream.position+=bytesWritten);try{stream.path&&FS.trackingDelegate.onWriteToFile&&FS.trackingDelegate.onWriteToFile(stream.path)}catch(e){console.log("FS.trackingDelegate['onWriteToFile']('"+path+"') threw an exception: "+e.message)}return bytesWritten},allocate:function(stream,offset,length){if(offset<0||length<=0)throw new FS.ErrnoError(ERRNO_CODES.EINVAL);if(0===(2097155&stream.flags))throw new FS.ErrnoError(ERRNO_CODES.EBADF);if(!FS.isFile(stream.node.mode)&&!FS.isDir(node.mode))throw new FS.ErrnoError(ERRNO_CODES.ENODEV);if(!stream.stream_ops.allocate)throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);stream.stream_ops.allocate(stream,offset,length)},mmap:function(stream,buffer,offset,length,position,prot,flags){if(1===(2097155&stream.flags))throw new FS.ErrnoError(ERRNO_CODES.EACCES);if(!stream.stream_ops.mmap)throw new FS.ErrnoError(ERRNO_CODES.ENODEV);return stream.stream_ops.mmap(stream,buffer,offset,length,position,prot,flags)},ioctl:function(stream,cmd,arg){if(!stream.stream_ops.ioctl)throw new FS.ErrnoError(ERRNO_CODES.ENOTTY);return stream.stream_ops.ioctl(stream,cmd,arg)},readFile:function(path,opts){if(opts=opts||{},opts.flags=opts.flags||"r",opts.encoding=opts.encoding||"binary","utf8"!==opts.encoding&&"binary"!==opts.encoding)throw new Error('Invalid encoding type "'+opts.encoding+'"');var ret,stream=FS.open(path,opts.flags),stat=FS.stat(path),length=stat.size,buf=new Uint8Array(length);if(FS.read(stream,buf,0,length,0),"utf8"===opts.encoding){ret="";for(var utf8=new Runtime.UTF8Processor,i=0;i<length;i++)ret+=utf8.processCChar(buf[i])}else"binary"===opts.encoding&&(ret=buf);return FS.close(stream),ret},writeFile:function(path,data,opts){if(opts=opts||{},opts.flags=opts.flags||"w",opts.encoding=opts.encoding||"utf8","utf8"!==opts.encoding&&"binary"!==opts.encoding)throw new Error('Invalid encoding type "'+opts.encoding+'"');var stream=FS.open(path,opts.flags,opts.mode);if("utf8"===opts.encoding){var utf8=new Runtime.UTF8Processor,buf=new Uint8Array(utf8.processJSString(data));FS.write(stream,buf,0,buf.length,0,opts.canOwn)}else"binary"===opts.encoding&&FS.write(stream,data,0,data.length,0,opts.canOwn);FS.close(stream)},cwd:function(){return FS.currentPath},chdir:function(path){var lookup=FS.lookupPath(path,{follow:!0});if(!FS.isDir(lookup.node.mode))throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);var err=FS.nodePermissions(lookup.node,"x");if(err)throw new FS.ErrnoError(err);FS.currentPath=lookup.path},createDefaultDirectories:function(){FS.mkdir("/tmp"),FS.mkdir("/home"),FS.mkdir("/home/web_user")},createDefaultDevices:function(){FS.mkdir("/dev"),FS.registerDevice(FS.makedev(1,3),{read:function(){return 0},write:function(){return 0}}),FS.mkdev("/dev/null",FS.makedev(1,3)),TTY.register(FS.makedev(5,0),TTY.default_tty_ops),TTY.register(FS.makedev(6,0),TTY.default_tty1_ops),FS.mkdev("/dev/tty",FS.makedev(5,0)),FS.mkdev("/dev/tty1",FS.makedev(6,0));var random_device;if("undefined"!=typeof crypto){var randomBuffer=new Uint8Array(1);random_device=function(){return crypto.getRandomValues(randomBuffer),randomBuffer[0]}}else random_device=function(){return 256*Math.random()|0};FS.createDevice("/dev","random",random_device),FS.createDevice("/dev","urandom",random_device),FS.mkdir("/dev/shm"),FS.mkdir("/dev/shm/tmp")},createStandardStreams:function(){Module.stdin?FS.createDevice("/dev","stdin",Module.stdin):FS.symlink("/dev/tty","/dev/stdin"),Module.stdout?FS.createDevice("/dev","stdout",null,Module.stdout):FS.symlink("/dev/tty","/dev/stdout"),Module.stderr?FS.createDevice("/dev","stderr",null,Module.stderr):FS.symlink("/dev/tty1","/dev/stderr");var stdin=FS.open("/dev/stdin","r");HEAP32[_stdin>>2]=FS.getPtrForStream(stdin),assert(0===stdin.fd,"invalid handle for stdin ("+stdin.fd+")");var stdout=FS.open("/dev/stdout","w");HEAP32[_stdout>>2]=FS.getPtrForStream(stdout),assert(1===stdout.fd,"invalid handle for stdout ("+stdout.fd+")");var stderr=FS.open("/dev/stderr","w");HEAP32[_stderr>>2]=FS.getPtrForStream(stderr),assert(2===stderr.fd,"invalid handle for stderr ("+stderr.fd+")")},ensureErrnoError:function(){FS.ErrnoError||(FS.ErrnoError=function(errno,node){this.node=node,this.setErrno=function(errno){this.errno=errno;for(var key in ERRNO_CODES)if(ERRNO_CODES[key]===errno){this.code=key;break}},this.setErrno(errno),this.message=ERRNO_MESSAGES[errno]},FS.ErrnoError.prototype=new Error,FS.ErrnoError.prototype.constructor=FS.ErrnoError,[ERRNO_CODES.ENOENT].forEach(function(code){FS.genericErrors[code]=new FS.ErrnoError(code),FS.genericErrors[code].stack="<generic error, no stack>"}))},staticInit:function(){FS.ensureErrnoError(),FS.nameTable=new Array(4096),FS.mount(MEMFS,{},"/"),FS.createDefaultDirectories(),FS.createDefaultDevices()},init:function(input,output,error){assert(!FS.init.initialized,"FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)"),FS.init.initialized=!0,FS.ensureErrnoError(),Module.stdin=input||Module.stdin,Module.stdout=output||Module.stdout,Module.stderr=error||Module.stderr,FS.createStandardStreams()},quit:function(){FS.init.initialized=!1;for(var i=0;i<FS.streams.length;i++){var stream=FS.streams[i];stream&&FS.close(stream)}},getMode:function(canRead,canWrite){var mode=0;return canRead&&(mode|=365),canWrite&&(mode|=146),mode},joinPath:function(parts,forceRelative){var path=PATH.join.apply(null,parts);return forceRelative&&"/"==path[0]&&(path=path.substr(1)),path},absolutePath:function(relative,base){return PATH.resolve(base,relative)},standardizePath:function(path){return PATH.normalize(path)},findObject:function(path,dontResolveLastLink){var ret=FS.analyzePath(path,dontResolveLastLink);return ret.exists?ret.object:(___setErrNo(ret.error),null)},analyzePath:function(path,dontResolveLastLink){try{var lookup=FS.lookupPath(path,{follow:!dontResolveLastLink});path=lookup.path}catch(e){}var ret={isRoot:!1,exists:!1,error:0,name:null,path:null,object:null,parentExists:!1,parentPath:null,parentObject:null};try{var lookup=FS.lookupPath(path,{parent:!0});ret.parentExists=!0,ret.parentPath=lookup.path,ret.parentObject=lookup.node,ret.name=PATH.basename(path),lookup=FS.lookupPath(path,{follow:!dontResolveLastLink}),ret.exists=!0,ret.path=lookup.path,ret.object=lookup.node,ret.name=lookup.node.name,ret.isRoot="/"===lookup.path}catch(e){ret.error=e.errno}return ret},createFolder:function(parent,name,canRead,canWrite){var path=PATH.join2("string"==typeof parent?parent:FS.getPath(parent),name),mode=FS.getMode(canRead,canWrite);return FS.mkdir(path,mode)},createPath:function(parent,path,canRead,canWrite){parent="string"==typeof parent?parent:FS.getPath(parent);for(var parts=path.split("/").reverse();parts.length;){var part=parts.pop();if(part){var current=PATH.join2(parent,part);try{FS.mkdir(current)}catch(e){}parent=current}}return current},createFile:function(parent,name,properties,canRead,canWrite){var path=PATH.join2("string"==typeof parent?parent:FS.getPath(parent),name),mode=FS.getMode(canRead,canWrite);return FS.create(path,mode)},createDataFile:function(parent,name,data,canRead,canWrite,canOwn){var path=name?PATH.join2("string"==typeof parent?parent:FS.getPath(parent),name):parent,mode=FS.getMode(canRead,canWrite),node=FS.create(path,mode);if(data){if("string"==typeof data){for(var arr=new Array(data.length),i=0,len=data.length;i<len;++i)arr[i]=data.charCodeAt(i);data=arr}FS.chmod(node,146|mode);var stream=FS.open(node,"w");FS.write(stream,data,0,data.length,0,canOwn),FS.close(stream),FS.chmod(node,mode)}return node},createDevice:function(parent,name,input,output){var path=PATH.join2("string"==typeof parent?parent:FS.getPath(parent),name),mode=FS.getMode(!!input,!!output);FS.createDevice.major||(FS.createDevice.major=64);var dev=FS.makedev(FS.createDevice.major++,0);return FS.registerDevice(dev,{open:function(stream){stream.seekable=!1},close:function(stream){output&&output.buffer&&output.buffer.length&&output(10)},read:function(stream,buffer,offset,length,pos){for(var bytesRead=0,i=0;i<length;i++){var result;try{result=input()}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}if(void 0===result&&0===bytesRead)throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);if(null===result||void 0===result)break;bytesRead++,buffer[offset+i]=result}return bytesRead&&(stream.node.timestamp=Date.now()),bytesRead},write:function(stream,buffer,offset,length,pos){for(var i=0;i<length;i++)try{output(buffer[offset+i])}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}return length&&(stream.node.timestamp=Date.now()),i}}),FS.mkdev(path,mode,dev)},createLink:function(parent,name,target,canRead,canWrite){var path=PATH.join2("string"==typeof parent?parent:FS.getPath(parent),name);return FS.symlink(target,path)},forceLoadFile:function(obj){if(obj.isDevice||obj.isFolder||obj.link||obj.contents)return!0;var success=!0;if("undefined"!=typeof XMLHttpRequest)throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.");if(!Module.read)throw new Error("Cannot load without read() or XMLHttpRequest.");try{obj.contents=intArrayFromString(Module.read(obj.url),!0),obj.usedBytes=obj.contents.length}catch(e){success=!1}return success||___setErrNo(ERRNO_CODES.EIO),success},createLazyFile:function(parent,name,url,canRead,canWrite){function LazyUint8Array(){this.lengthKnown=!1,this.chunks=[]}if(LazyUint8Array.prototype.get=function(idx){if(!(idx>this.length-1||idx<0)){var chunkOffset=idx%this.chunkSize,chunkNum=idx/this.chunkSize|0;return this.getter(chunkNum)[chunkOffset]}},LazyUint8Array.prototype.setDataGetter=function(getter){this.getter=getter},LazyUint8Array.prototype.cacheLength=function(){var xhr=new XMLHttpRequest;if(xhr.open("HEAD",url,!1),xhr.send(null),!(xhr.status>=200&&xhr.status<300||304===xhr.status))throw new Error("Couldn't load "+url+". Status: "+xhr.status);var header,datalength=Number(xhr.getResponseHeader("Content-length")),hasByteServing=(header=xhr.getResponseHeader("Accept-Ranges"))&&"bytes"===header,chunkSize=1048576;hasByteServing||(chunkSize=datalength);var doXHR=function(from,to){if(from>to)throw new Error("invalid range ("+from+", "+to+") or no bytes requested!");if(to>datalength-1)throw new Error("only "+datalength+" bytes available! programmer error!");var xhr=new XMLHttpRequest;if(xhr.open("GET",url,!1),datalength!==chunkSize&&xhr.setRequestHeader("Range","bytes="+from+"-"+to),"undefined"!=typeof Uint8Array&&(xhr.responseType="arraybuffer"),xhr.overrideMimeType&&xhr.overrideMimeType("text/plain; charset=x-user-defined"),xhr.send(null),!(xhr.status>=200&&xhr.status<300||304===xhr.status))throw new Error("Couldn't load "+url+". Status: "+xhr.status);return void 0!==xhr.response?new Uint8Array(xhr.response||[]):intArrayFromString(xhr.responseText||"",!0)},lazyArray=this;lazyArray.setDataGetter(function(chunkNum){var start=chunkNum*chunkSize,end=(chunkNum+1)*chunkSize-1;if(end=Math.min(end,datalength-1),"undefined"==typeof lazyArray.chunks[chunkNum]&&(lazyArray.chunks[chunkNum]=doXHR(start,end)),"undefined"==typeof lazyArray.chunks[chunkNum])throw new Error("doXHR failed!");return lazyArray.chunks[chunkNum]}),this._length=datalength,this._chunkSize=chunkSize,this.lengthKnown=!0},"undefined"!=typeof XMLHttpRequest){throw"Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc";var properties}else var properties={isDevice:!1,url:url};var node=FS.createFile(parent,name,properties,canRead,canWrite);properties.contents?node.contents=properties.contents:properties.url&&(node.contents=null,node.url=properties.url),Object.defineProperty(node,"usedBytes",{get:function(){return this.contents.length}});var stream_ops={},keys=Object.keys(node.stream_ops);return keys.forEach(function(key){var fn=node.stream_ops[key];stream_ops[key]=function(){if(!FS.forceLoadFile(node))throw new FS.ErrnoError(ERRNO_CODES.EIO);return fn.apply(null,arguments)}}),stream_ops.read=function(stream,buffer,offset,length,position){if(!FS.forceLoadFile(node))throw new FS.ErrnoError(ERRNO_CODES.EIO);var contents=stream.node.contents;if(position>=contents.length)return 0;var size=Math.min(contents.length-position,length);if(assert(size>=0),contents.slice)for(var i=0;i<size;i++)buffer[offset+i]=contents[position+i];else for(var i=0;i<size;i++)buffer[offset+i]=contents.get(position+i);return size},node.stream_ops=stream_ops,node},createPreloadedFile:function(parent,name,url,canRead,canWrite,onload,onerror,dontCreateFile,canOwn){function processData(byteArray){function finish(byteArray){dontCreateFile||FS.createDataFile(parent,name,byteArray,canRead,canWrite,canOwn),onload&&onload(),removeRunDependency("cp "+fullname)}var handled=!1;Module.preloadPlugins.forEach(function(plugin){handled||plugin.canHandle(fullname)&&(plugin.handle(byteArray,fullname,finish,function(){onerror&&onerror(),removeRunDependency("cp "+fullname)}),handled=!0)}),handled||finish(byteArray)}Browser.init();var fullname=name?PATH.resolve(PATH.join2(parent,name)):parent;addRunDependency("cp "+fullname),"string"==typeof url?Browser.asyncLoad(url,function(byteArray){processData(byteArray)},onerror):processData(url)},indexedDB:function(){return window.indexedDB||window.mozIndexedDB||window.webkitIndexedDB||window.msIndexedDB},DB_NAME:function(){return"EM_FS_"+window.location.pathname},DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:function(paths,onload,onerror){onload=onload||function(){},onerror=onerror||function(){};var indexedDB=FS.indexedDB();try{var openRequest=indexedDB.open(FS.DB_NAME(),FS.DB_VERSION)}catch(e){return onerror(e)}openRequest.onupgradeneeded=function(){console.log("creating db");var db=openRequest.result;db.createObjectStore(FS.DB_STORE_NAME)},openRequest.onsuccess=function(){function finish(){0==fail?onload():onerror()}var db=openRequest.result,transaction=db.transaction([FS.DB_STORE_NAME],"readwrite"),files=transaction.objectStore(FS.DB_STORE_NAME),ok=0,fail=0,total=paths.length;paths.forEach(function(path){var putRequest=files.put(FS.analyzePath(path).object.contents,path);putRequest.onsuccess=function(){ok++,ok+fail==total&&finish()},putRequest.onerror=function(){fail++,ok+fail==total&&finish()}}),transaction.onerror=onerror},openRequest.onerror=onerror},loadFilesFromDB:function(paths,onload,onerror){onload=onload||function(){},onerror=onerror||function(){};var indexedDB=FS.indexedDB();try{var openRequest=indexedDB.open(FS.DB_NAME(),FS.DB_VERSION)}catch(e){return onerror(e)}openRequest.onupgradeneeded=onerror,openRequest.onsuccess=function(){function finish(){0==fail?onload():onerror()}var db=openRequest.result;try{var transaction=db.transaction([FS.DB_STORE_NAME],"readonly")}catch(e){return void onerror(e)}var files=transaction.objectStore(FS.DB_STORE_NAME),ok=0,fail=0,total=paths.length;paths.forEach(function(path){var getRequest=files.get(path);getRequest.onsuccess=function(){FS.analyzePath(path).exists&&FS.unlink(path),FS.createDataFile(PATH.dirname(path),PATH.basename(path),getRequest.result,!0,!0,!0),ok++,ok+fail==total&&finish()},getRequest.onerror=function(){fail++,ok+fail==total&&finish()}}),transaction.onerror=onerror},openRequest.onerror=onerror}},SOCKFS={mount:function(mount){return Module.websocket=Module.websocket&&"object"==typeof Module.websocket?Module.websocket:{},Module.websocket._callbacks={},Module.websocket.on=function(event,callback){return"function"==typeof callback&&(this._callbacks[event]=callback),this},Module.websocket.emit=function(event,param){"function"==typeof this._callbacks[event]&&this._callbacks[event].call(this,param)},FS.createNode(null,"/",16895,0)},createSocket:function(family,type,protocol){var streaming=1==type;protocol&&assert(streaming==(6==protocol));var sock={family:family,type:type,protocol:protocol,server:null,error:null,peers:{},pending:[],recv_queue:[],sock_ops:SOCKFS.websocket_sock_ops},name=SOCKFS.nextname(),node=FS.createNode(SOCKFS.root,name,49152,0);node.sock=sock;var stream=FS.createStream({path:name,node:node,flags:FS.modeStringToFlags("r+"),seekable:!1,stream_ops:SOCKFS.stream_ops});return sock.stream=stream,sock},getSocket:function(fd){var stream=FS.getStream(fd);return stream&&FS.isSocket(stream.node.mode)?stream.node.sock:null},stream_ops:{poll:function(stream){var sock=stream.node.sock;return sock.sock_ops.poll(sock)},ioctl:function(stream,request,varargs){var sock=stream.node.sock;return sock.sock_ops.ioctl(sock,request,varargs)},read:function(stream,buffer,offset,length,position){var sock=stream.node.sock,msg=sock.sock_ops.recvmsg(sock,length);return msg?(buffer.set(msg.buffer,offset),msg.buffer.length):0},write:function(stream,buffer,offset,length,position){var sock=stream.node.sock;return sock.sock_ops.sendmsg(sock,buffer,offset,length)},close:function(stream){var sock=stream.node.sock;sock.sock_ops.close(sock)}},nextname:function(){return SOCKFS.nextname.current||(SOCKFS.nextname.current=0),"socket["+SOCKFS.nextname.current++ +"]"},websocket_sock_ops:{createPeer:function(sock,addr,port){var ws;if("object"==typeof addr&&(ws=addr,addr=null,port=null),ws)if(ws._socket)addr=ws._socket.remoteAddress,port=ws._socket.remotePort;else{var result=/ws[s]?:\/\/([^:]+):(\d+)/.exec(ws.url);if(!result)throw new Error("WebSocket URL must be in the format ws(s)://address:port");addr=result[1],port=parseInt(result[2],10)}else try{var runtimeConfig=Module.websocket&&"object"==typeof Module.websocket,url="ws:#".replace("#","//");if(runtimeConfig&&"string"==typeof Module.websocket.url&&(url=Module.websocket.url),"ws://"===url||"wss://"===url){var parts=addr.split("/");url=url+parts[0]+":"+port+"/"+parts.slice(1).join("/")}var subProtocols="binary";runtimeConfig&&"string"==typeof Module.websocket.subprotocol&&(subProtocols=Module.websocket.subprotocol),subProtocols=subProtocols.replace(/^ +| +$/g,"").split(/ *, */);var opts=subProtocols,WebSocket=window.WebSocket;ws=new WebSocket(url,opts),ws.binaryType="arraybuffer"}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EHOSTUNREACH)}var peer={addr:addr,port:port,socket:ws,dgram_send_queue:[]};return SOCKFS.websocket_sock_ops.addPeer(sock,peer),SOCKFS.websocket_sock_ops.handlePeerEvents(sock,peer),2===sock.type&&"undefined"!=typeof sock.sport&&peer.dgram_send_queue.push(new Uint8Array([255,255,255,255,"p".charCodeAt(0),"o".charCodeAt(0),"r".charCodeAt(0),"t".charCodeAt(0),(65280&sock.sport)>>8,255&sock.sport])),peer},getPeer:function(sock,addr,port){return sock.peers[addr+":"+port]},addPeer:function(sock,peer){sock.peers[peer.addr+":"+peer.port]=peer},removePeer:function(sock,peer){delete sock.peers[peer.addr+":"+peer.port]},handlePeerEvents:function(sock,peer){function handleMessage(data){assert("string"!=typeof data&&void 0!==data.byteLength),data=new Uint8Array(data);var wasfirst=first;if(first=!1,wasfirst&&10===data.length&&255===data[0]&&255===data[1]&&255===data[2]&&255===data[3]&&data[4]==="p".charCodeAt(0)&&data[5]==="o".charCodeAt(0)&&data[6]==="r".charCodeAt(0)&&data[7]==="t".charCodeAt(0)){var newport=data[8]<<8|data[9];return SOCKFS.websocket_sock_ops.removePeer(sock,peer),peer.port=newport,void SOCKFS.websocket_sock_ops.addPeer(sock,peer)}sock.recv_queue.push({addr:peer.addr,port:peer.port,data:data}),Module.websocket.emit("message",sock.stream.fd)}var first=!0,handleOpen=function(){Module.websocket.emit("open",sock.stream.fd);try{for(var queued=peer.dgram_send_queue.shift();queued;)peer.socket.send(queued),queued=peer.dgram_send_queue.shift()}catch(e){peer.socket.close()}};peer.socket.onopen=handleOpen,peer.socket.onclose=function(){Module.websocket.emit("close",sock.stream.fd)},peer.socket.onmessage=function(event){handleMessage(event.data)},peer.socket.onerror=function(error){sock.error=ERRNO_CODES.ECONNREFUSED,Module.websocket.emit("error",[sock.stream.fd,sock.error,"ECONNREFUSED: Connection refused"])}},poll:function(sock){if(1===sock.type&&sock.server)return sock.pending.length?65:0;var mask=0,dest=1===sock.type?SOCKFS.websocket_sock_ops.getPeer(sock,sock.daddr,sock.dport):null;return(sock.recv_queue.length||!dest||dest&&dest.socket.readyState===dest.socket.CLOSING||dest&&dest.socket.readyState===dest.socket.CLOSED)&&(mask|=65),(!dest||dest&&dest.socket.readyState===dest.socket.OPEN)&&(mask|=4),(dest&&dest.socket.readyState===dest.socket.CLOSING||dest&&dest.socket.readyState===dest.socket.CLOSED)&&(mask|=16),mask},ioctl:function(sock,request,arg){switch(request){case 21531:var bytes=0;return sock.recv_queue.length&&(bytes=sock.recv_queue[0].data.length),HEAP32[arg>>2]=bytes,0;default:return ERRNO_CODES.EINVAL}},close:function(sock){if(sock.server){try{sock.server.close()}catch(e){}sock.server=null}for(var peers=Object.keys(sock.peers),i=0;i<peers.length;i++){var peer=sock.peers[peers[i]];try{peer.socket.close()}catch(e){}SOCKFS.websocket_sock_ops.removePeer(sock,peer)}return 0},bind:function(sock,addr,port){if("undefined"!=typeof sock.saddr||"undefined"!=typeof sock.sport)throw new FS.ErrnoError(ERRNO_CODES.EINVAL);if(sock.saddr=addr,sock.sport=port||_mkport(),2===sock.type){sock.server&&(sock.server.close(),sock.server=null);try{sock.sock_ops.listen(sock,0)}catch(e){if(!(e instanceof FS.ErrnoError))throw e;if(e.errno!==ERRNO_CODES.EOPNOTSUPP)throw e}}},connect:function(sock,addr,port){if(sock.server)throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);if("undefined"!=typeof sock.daddr&&"undefined"!=typeof sock.dport){var dest=SOCKFS.websocket_sock_ops.getPeer(sock,sock.daddr,sock.dport);if(dest)throw dest.socket.readyState===dest.socket.CONNECTING?new FS.ErrnoError(ERRNO_CODES.EALREADY):new FS.ErrnoError(ERRNO_CODES.EISCONN)}var peer=SOCKFS.websocket_sock_ops.createPeer(sock,addr,port);throw sock.daddr=peer.addr,sock.dport=peer.port,new FS.ErrnoError(ERRNO_CODES.EINPROGRESS)},listen:function(sock,backlog){throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP)},accept:function(listensock){if(!listensock.server)throw new FS.ErrnoError(ERRNO_CODES.EINVAL);var newsock=listensock.pending.shift();return newsock.stream.flags=listensock.stream.flags,newsock},getname:function(sock,peer){var addr,port;if(peer){if(void 0===sock.daddr||void 0===sock.dport)throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);addr=sock.daddr,port=sock.dport}else addr=sock.saddr||0,port=sock.sport||0;return{addr:addr,port:port}},sendmsg:function(sock,buffer,offset,length,addr,port){if(2===sock.type){if(void 0!==addr&&void 0!==port||(addr=sock.daddr,port=sock.dport),void 0===addr||void 0===port)throw new FS.ErrnoError(ERRNO_CODES.EDESTADDRREQ)}else addr=sock.daddr,port=sock.dport;var dest=SOCKFS.websocket_sock_ops.getPeer(sock,addr,port);if(1===sock.type){if(!dest||dest.socket.readyState===dest.socket.CLOSING||dest.socket.readyState===dest.socket.CLOSED)throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);if(dest.socket.readyState===dest.socket.CONNECTING)throw new FS.ErrnoError(ERRNO_CODES.EAGAIN)}var data;if(data=buffer instanceof Array||buffer instanceof ArrayBuffer?buffer.slice(offset,offset+length):buffer.buffer.slice(buffer.byteOffset+offset,buffer.byteOffset+offset+length),2===sock.type&&(!dest||dest.socket.readyState!==dest.socket.OPEN))return dest&&dest.socket.readyState!==dest.socket.CLOSING&&dest.socket.readyState!==dest.socket.CLOSED||(dest=SOCKFS.websocket_sock_ops.createPeer(sock,addr,port)),dest.dgram_send_queue.push(data),length;try{return dest.socket.send(data),length}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}},recvmsg:function(sock,length){if(1===sock.type&&sock.server)throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);var queued=sock.recv_queue.shift();if(!queued){if(1===sock.type){var dest=SOCKFS.websocket_sock_ops.getPeer(sock,sock.daddr,sock.dport);if(dest){if(dest.socket.readyState===dest.socket.CLOSING||dest.socket.readyState===dest.socket.CLOSED)return null;throw new FS.ErrnoError(ERRNO_CODES.EAGAIN)}throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN)}throw new FS.ErrnoError(ERRNO_CODES.EAGAIN)}var queuedLength=queued.data.byteLength||queued.data.length,queuedOffset=queued.data.byteOffset||0,queuedBuffer=queued.data.buffer||queued.data,bytesRead=Math.min(length,queuedLength),res={buffer:new Uint8Array(queuedBuffer,queuedOffset,bytesRead),addr:queued.addr,port:queued.port};if(1===sock.type&&bytesRead<queuedLength){var bytesRemaining=queuedLength-bytesRead;queued.data=new Uint8Array(queuedBuffer,queuedOffset+bytesRead,bytesRemaining),sock.recv_queue.unshift(queued)}return res}}};Module._strlen=_strlen,Module._strcat=_strcat,Module._bitshift64Shl=_bitshift64Shl,Module._strncpy=_strncpy,Module._i64Add=_i64Add;var _fabs=Math_abs,_floor=Math_floor;Module._memset=_memset;var Browser={mainLoop:{scheduler:null,method:"",currentlyRunningMainloop:0,func:null,arg:0,timingMode:0,timingValue:0,currentFrameNumber:0,queue:[],pause:function(){Browser.mainLoop.scheduler=null,Browser.mainLoop.currentlyRunningMainloop++},resume:function(){Browser.mainLoop.currentlyRunningMainloop++;var timingMode=Browser.mainLoop.timingMode,timingValue=Browser.mainLoop.timingValue,func=Browser.mainLoop.func;Browser.mainLoop.func=null,_emscripten_set_main_loop(func,0,!1,Browser.mainLoop.arg),_emscripten_set_main_loop_timing(timingMode,timingValue)},updateStatus:function(){if(Module.setStatus){var message=Module.statusMessage||"Please wait...",remaining=Browser.mainLoop.remainingBlockers,expected=Browser.mainLoop.expectedBlockers;remaining?remaining<expected?Module.setStatus(message+" ("+(expected-remaining)+"/"+expected+")"):Module.setStatus(message):Module.setStatus("")}},runIter:function(func){if(!ABORT){if(Module.preMainLoop){var preRet=Module.preMainLoop();if(preRet===!1)return}try{func()}catch(e){if(e instanceof ExitStatus)return;throw e&&"object"==typeof e&&e.stack&&Module.printErr("exception thrown: "+[e,e.stack]),e}Module.postMainLoop&&Module.postMainLoop()}}},isFullScreen:!1,pointerLock:!1,moduleContextCreatedCallbacks:[],workers:[],init:function(){function pointerLockChange(){Browser.pointerLock=document.pointerLockElement===canvas||document.mozPointerLockElement===canvas||document.webkitPointerLockElement===canvas||document.msPointerLockElement===canvas}if(Module.preloadPlugins||(Module.preloadPlugins=[]),!Browser.initted){Browser.initted=!0;try{new Blob,Browser.hasBlobConstructor=!0}catch(e){Browser.hasBlobConstructor=!1,console.log("warning: no blob constructor, cannot create blobs with mimetypes")}Browser.BlobBuilder="undefined"!=typeof MozBlobBuilder?MozBlobBuilder:"undefined"!=typeof WebKitBlobBuilder?WebKitBlobBuilder:Browser.hasBlobConstructor?null:console.log("warning: no BlobBuilder"),Browser.URLObject="undefined"!=typeof window?window.URL?window.URL:window.webkitURL:void 0,Module.noImageDecoding||"undefined"!=typeof Browser.URLObject||(console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available."),Module.noImageDecoding=!0);var imagePlugin={};imagePlugin.canHandle=function(name){return!Module.noImageDecoding&&/\.(jpg|jpeg|png|bmp)$/i.test(name)},imagePlugin.handle=function(byteArray,name,onload,onerror){var b=null;if(Browser.hasBlobConstructor)try{b=new Blob([byteArray],{type:Browser.getMimetype(name)}),b.size!==byteArray.length&&(b=new Blob([new Uint8Array(byteArray).buffer],{type:Browser.getMimetype(name)}))}catch(e){Runtime.warnOnce("Blob constructor present but fails: "+e+"; falling back to blob builder")}if(!b){var bb=new Browser.BlobBuilder;bb.append(new Uint8Array(byteArray).buffer),b=bb.getBlob()}var url=Browser.URLObject.createObjectURL(b),img=new Image;img.onload=function(){assert(img.complete,"Image "+name+" could not be decoded");var canvas=document.createElement("canvas");canvas.width=img.width,canvas.height=img.height;var ctx=canvas.getContext("2d");ctx.drawImage(img,0,0),
Module.preloadedImages[name]=canvas,Browser.URLObject.revokeObjectURL(url),onload&&onload(byteArray)},img.onerror=function(event){console.log("Image "+url+" could not be decoded"),onerror&&onerror()},img.src=url},Module.preloadPlugins.push(imagePlugin);var audioPlugin={};audioPlugin.canHandle=function(name){return!Module.noAudioDecoding&&name.substr(-4)in{".ogg":1,".wav":1,".mp3":1}},audioPlugin.handle=function(byteArray,name,onload,onerror){function finish(audio){done||(done=!0,Module.preloadedAudios[name]=audio,onload&&onload(byteArray))}function fail(){done||(done=!0,Module.preloadedAudios[name]=new Audio,onerror&&onerror())}var done=!1;if(!Browser.hasBlobConstructor)return fail();try{var b=new Blob([byteArray],{type:Browser.getMimetype(name)})}catch(e){return fail()}var url=Browser.URLObject.createObjectURL(b),audio=new Audio;audio.addEventListener("canplaythrough",function(){finish(audio)},!1),audio.onerror=function(event){function encode64(data){for(var BASE="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",PAD="=",ret="",leftchar=0,leftbits=0,i=0;i<data.length;i++)for(leftchar=leftchar<<8|data[i],leftbits+=8;leftbits>=6;){var curr=leftchar>>leftbits-6&63;leftbits-=6,ret+=BASE[curr]}return 2==leftbits?(ret+=BASE[(3&leftchar)<<4],ret+=PAD+PAD):4==leftbits&&(ret+=BASE[(15&leftchar)<<2],ret+=PAD),ret}done||(console.log("warning: browser could not fully decode audio "+name+", trying slower base64 approach"),audio.src="data:audio/x-"+name.substr(-3)+";base64,"+encode64(byteArray),finish(audio))},audio.src=url,Browser.safeSetTimeout(function(){finish(audio)},1e4)},Module.preloadPlugins.push(audioPlugin);var canvas=Module.canvas;canvas&&(canvas.requestPointerLock=canvas.requestPointerLock||canvas.mozRequestPointerLock||canvas.webkitRequestPointerLock||canvas.msRequestPointerLock||function(){},canvas.exitPointerLock=document.exitPointerLock||document.mozExitPointerLock||document.webkitExitPointerLock||document.msExitPointerLock||function(){},canvas.exitPointerLock=canvas.exitPointerLock.bind(document),document.addEventListener("pointerlockchange",pointerLockChange,!1),document.addEventListener("mozpointerlockchange",pointerLockChange,!1),document.addEventListener("webkitpointerlockchange",pointerLockChange,!1),document.addEventListener("mspointerlockchange",pointerLockChange,!1),Module.elementPointerLock&&canvas.addEventListener("click",function(ev){!Browser.pointerLock&&canvas.requestPointerLock&&(canvas.requestPointerLock(),ev.preventDefault())},!1))}},createContext:function(canvas,useWebGL,setInModule,webGLContextAttributes){if(useWebGL&&Module.ctx&&canvas==Module.canvas)return Module.ctx;var ctx,contextHandle;if(useWebGL){var contextAttributes={antialias:!1,alpha:!1};if(webGLContextAttributes)for(var attribute in webGLContextAttributes)contextAttributes[attribute]=webGLContextAttributes[attribute];contextHandle=GL.createContext(canvas,contextAttributes),contextHandle&&(ctx=GL.getContext(contextHandle).GLctx),canvas.style.backgroundColor="black"}else ctx=canvas.getContext("2d");return ctx?(setInModule&&(useWebGL||assert("undefined"==typeof GLctx,"cannot set in module if GLctx is used, but we are a non-GL context that would replace it"),Module.ctx=ctx,useWebGL&&GL.makeContextCurrent(contextHandle),Module.useWebGL=useWebGL,Browser.moduleContextCreatedCallbacks.forEach(function(callback){callback()}),Browser.init()),ctx):null},destroyContext:function(canvas,useWebGL,setInModule){},fullScreenHandlersInstalled:!1,lockPointer:void 0,resizeCanvas:void 0,requestFullScreen:function(lockPointer,resizeCanvas){function fullScreenChange(){Browser.isFullScreen=!1;var canvasContainer=canvas.parentNode;(document.webkitFullScreenElement||document.webkitFullscreenElement||document.mozFullScreenElement||document.mozFullscreenElement||document.fullScreenElement||document.fullscreenElement||document.msFullScreenElement||document.msFullscreenElement||document.webkitCurrentFullScreenElement)===canvasContainer?(canvas.cancelFullScreen=document.cancelFullScreen||document.mozCancelFullScreen||document.webkitCancelFullScreen||document.msExitFullscreen||document.exitFullscreen||function(){},canvas.cancelFullScreen=canvas.cancelFullScreen.bind(document),Browser.lockPointer&&canvas.requestPointerLock(),Browser.isFullScreen=!0,Browser.resizeCanvas&&Browser.setFullScreenCanvasSize()):(canvasContainer.parentNode.insertBefore(canvas,canvasContainer),canvasContainer.parentNode.removeChild(canvasContainer),Browser.resizeCanvas&&Browser.setWindowedCanvasSize()),Module.onFullScreen&&Module.onFullScreen(Browser.isFullScreen),Browser.updateCanvasDimensions(canvas)}Browser.lockPointer=lockPointer,Browser.resizeCanvas=resizeCanvas,"undefined"==typeof Browser.lockPointer&&(Browser.lockPointer=!0),"undefined"==typeof Browser.resizeCanvas&&(Browser.resizeCanvas=!1);var canvas=Module.canvas;Browser.fullScreenHandlersInstalled||(Browser.fullScreenHandlersInstalled=!0,document.addEventListener("fullscreenchange",fullScreenChange,!1),document.addEventListener("mozfullscreenchange",fullScreenChange,!1),document.addEventListener("webkitfullscreenchange",fullScreenChange,!1),document.addEventListener("MSFullscreenChange",fullScreenChange,!1));var canvasContainer=document.createElement("div");canvas.parentNode.insertBefore(canvasContainer,canvas),canvasContainer.appendChild(canvas),canvasContainer.requestFullScreen=canvasContainer.requestFullScreen||canvasContainer.mozRequestFullScreen||canvasContainer.msRequestFullscreen||(canvasContainer.webkitRequestFullScreen?function(){canvasContainer.webkitRequestFullScreen(Element.ALLOW_KEYBOARD_INPUT)}:null),canvasContainer.requestFullScreen()},nextRAF:0,fakeRequestAnimationFrame:function(func){var now=Date.now();if(0===Browser.nextRAF)Browser.nextRAF=now+1e3/60;else for(;now+2>=Browser.nextRAF;)Browser.nextRAF+=1e3/60;var delay=Math.max(Browser.nextRAF-now,0);setTimeout(func,delay)},requestAnimationFrame:function(func){"undefined"==typeof window?Browser.fakeRequestAnimationFrame(func):(window.requestAnimationFrame||(window.requestAnimationFrame=window.requestAnimationFrame||window.mozRequestAnimationFrame||window.webkitRequestAnimationFrame||window.msRequestAnimationFrame||window.oRequestAnimationFrame||Browser.fakeRequestAnimationFrame),window.requestAnimationFrame(func))},safeCallback:function(func){return function(){if(!ABORT)return func.apply(null,arguments)}},safeRequestAnimationFrame:function(func){return Browser.requestAnimationFrame(function(){ABORT||func()})},safeSetTimeout:function(func,timeout){return Module.noExitRuntime=!0,setTimeout(function(){ABORT||func()},timeout)},safeSetInterval:function(func,timeout){return Module.noExitRuntime=!0,setInterval(function(){ABORT||func()},timeout)},getMimetype:function(name){return{jpg:"image/jpeg",jpeg:"image/jpeg",png:"image/png",bmp:"image/bmp",ogg:"audio/ogg",wav:"audio/wav",mp3:"audio/mpeg"}[name.substr(name.lastIndexOf(".")+1)]},getUserMedia:function(func){window.getUserMedia||(window.getUserMedia=navigator.getUserMedia||navigator.mozGetUserMedia),window.getUserMedia(func)},getMovementX:function(event){return event.movementX||event.mozMovementX||event.webkitMovementX||0},getMovementY:function(event){return event.movementY||event.mozMovementY||event.webkitMovementY||0},getMouseWheelDelta:function(event){var delta=0;switch(event.type){case"DOMMouseScroll":delta=event.detail;break;case"mousewheel":delta=event.wheelDelta;break;case"wheel":delta=event.deltaY;break;default:throw"unrecognized mouse wheel event: "+event.type}return delta},mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,touches:{},lastTouches:{},calculateMouseEvent:function(event){if(Browser.pointerLock)"mousemove"!=event.type&&"mozMovementX"in event?Browser.mouseMovementX=Browser.mouseMovementY=0:(Browser.mouseMovementX=Browser.getMovementX(event),Browser.mouseMovementY=Browser.getMovementY(event)),"undefined"!=typeof SDL?(Browser.mouseX=SDL.mouseX+Browser.mouseMovementX,Browser.mouseY=SDL.mouseY+Browser.mouseMovementY):(Browser.mouseX+=Browser.mouseMovementX,Browser.mouseY+=Browser.mouseMovementY);else{var rect=Module.canvas.getBoundingClientRect(),cw=Module.canvas.width,ch=Module.canvas.height,scrollX="undefined"!=typeof window.scrollX?window.scrollX:window.pageXOffset,scrollY="undefined"!=typeof window.scrollY?window.scrollY:window.pageYOffset;if("touchstart"===event.type||"touchend"===event.type||"touchmove"===event.type){var touch=event.touch;if(void 0===touch)return;var adjustedX=touch.pageX-(scrollX+rect.left),adjustedY=touch.pageY-(scrollY+rect.top);adjustedX*=cw/rect.width,adjustedY*=ch/rect.height;var coords={x:adjustedX,y:adjustedY};return void("touchstart"===event.type?(Browser.lastTouches[touch.identifier]=coords,Browser.touches[touch.identifier]=coords):"touchend"!==event.type&&"touchmove"!==event.type||(Browser.lastTouches[touch.identifier]=Browser.touches[touch.identifier],Browser.touches[touch.identifier]={x:adjustedX,y:adjustedY}))}var x=event.pageX-(scrollX+rect.left),y=event.pageY-(scrollY+rect.top);x*=cw/rect.width,y*=ch/rect.height,Browser.mouseMovementX=x-Browser.mouseX,Browser.mouseMovementY=y-Browser.mouseY,Browser.mouseX=x,Browser.mouseY=y}},xhrLoad:function(url,onload,onerror){var xhr=new XMLHttpRequest;xhr.open("GET",url,!0),xhr.responseType="arraybuffer",xhr.onload=function(){200==xhr.status||0==xhr.status&&xhr.response?onload(xhr.response):onerror()},xhr.onerror=onerror,xhr.send(null)},asyncLoad:function(url,onload,onerror,noRunDep){Browser.xhrLoad(url,function(arrayBuffer){assert(arrayBuffer,'Loading data file "'+url+'" failed (no arrayBuffer).'),onload(new Uint8Array(arrayBuffer)),noRunDep||removeRunDependency("al "+url)},function(event){if(!onerror)throw'Loading data file "'+url+'" failed.';onerror()}),noRunDep||addRunDependency("al "+url)},resizeListeners:[],updateResizeListeners:function(){var canvas=Module.canvas;Browser.resizeListeners.forEach(function(listener){listener(canvas.width,canvas.height)})},setCanvasSize:function(width,height,noUpdates){var canvas=Module.canvas;Browser.updateCanvasDimensions(canvas,width,height),noUpdates||Browser.updateResizeListeners()},windowedWidth:0,windowedHeight:0,setFullScreenCanvasSize:function(){if("undefined"!=typeof SDL){var flags=HEAPU32[SDL.screen+0*Runtime.QUANTUM_SIZE>>2];flags=8388608|flags,HEAP32[SDL.screen+0*Runtime.QUANTUM_SIZE>>2]=flags}Browser.updateResizeListeners()},setWindowedCanvasSize:function(){if("undefined"!=typeof SDL){var flags=HEAPU32[SDL.screen+0*Runtime.QUANTUM_SIZE>>2];flags&=-8388609,HEAP32[SDL.screen+0*Runtime.QUANTUM_SIZE>>2]=flags}Browser.updateResizeListeners()},updateCanvasDimensions:function(canvas,wNative,hNative){wNative&&hNative?(canvas.widthNative=wNative,canvas.heightNative=hNative):(wNative=canvas.widthNative,hNative=canvas.heightNative);var w=wNative,h=hNative;if(Module.forcedAspectRatio&&Module.forcedAspectRatio>0&&(w/h<Module.forcedAspectRatio?w=Math.round(h*Module.forcedAspectRatio):h=Math.round(w/Module.forcedAspectRatio)),(document.webkitFullScreenElement||document.webkitFullscreenElement||document.mozFullScreenElement||document.mozFullscreenElement||document.fullScreenElement||document.fullscreenElement||document.msFullScreenElement||document.msFullscreenElement||document.webkitCurrentFullScreenElement)===canvas.parentNode&&"undefined"!=typeof screen){var factor=Math.min(screen.width/w,screen.height/h);w=Math.round(w*factor),h=Math.round(h*factor)}Browser.resizeCanvas?(canvas.width!=w&&(canvas.width=w),canvas.height!=h&&(canvas.height=h),"undefined"!=typeof canvas.style&&(canvas.style.removeProperty("width"),canvas.style.removeProperty("height"))):(canvas.width!=wNative&&(canvas.width=wNative),canvas.height!=hNative&&(canvas.height=hNative),"undefined"!=typeof canvas.style&&(w!=wNative||h!=hNative?(canvas.style.setProperty("width",w+"px","important"),canvas.style.setProperty("height",h+"px","important")):(canvas.style.removeProperty("width"),canvas.style.removeProperty("height"))))},wgetRequests:{},nextWgetRequestHandle:0,getNextWgetRequestHandle:function(){var handle=Browser.nextWgetRequestHandle;return Browser.nextWgetRequestHandle++,handle}};Module._bitshift64Lshr=_bitshift64Lshr;var _BDtoILow=!0,_BDtoIHigh=!0,_environ=allocate(1,"i32*",ALLOC_STATIC),___environ=_environ,ENV={},_labs=Math_abs;Module._memcpy=_memcpy;var _llvm_pow_f64=Math_pow;Module._memmove=_memmove;var _BItoD=!0;Module._strcpy=_strcpy;var ctlz_i8=allocate([8,7,6,6,5,5,5,5,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],"i8",ALLOC_STATIC);Module._llvm_ctlz_i32=_llvm_ctlz_i32,FS.staticInit(),__ATINIT__.unshift({func:function(){Module.noFSInit||FS.init.initialized||FS.init()}}),__ATMAIN__.push({func:function(){FS.ignorePermissions=!1}}),__ATEXIT__.push({func:function(){FS.quit()}}),Module.FS_createFolder=FS.createFolder,Module.FS_createPath=FS.createPath,Module.FS_createDataFile=FS.createDataFile,Module.FS_createPreloadedFile=FS.createPreloadedFile,Module.FS_createLazyFile=FS.createLazyFile,Module.FS_createLink=FS.createLink,Module.FS_createDevice=FS.createDevice,___errno_state=Runtime.staticAlloc(4),HEAP32[___errno_state>>2]=0,__ATINIT__.unshift({func:function(){TTY.init()}}),__ATEXIT__.push({func:function(){TTY.shutdown()}}),TTY.utf8=new Runtime.UTF8Processor,__ATINIT__.push({func:function(){SOCKFS.root=FS.mount(SOCKFS,{},null)}}),_fgetc.ret=allocate([0],"i8",ALLOC_STATIC),_fputc.ret=allocate([0],"i8",ALLOC_STATIC),Module.requestFullScreen=function(lockPointer,resizeCanvas){Browser.requestFullScreen(lockPointer,resizeCanvas)},Module.requestAnimationFrame=function(func){Browser.requestAnimationFrame(func)},Module.setCanvasSize=function(width,height,noUpdates){Browser.setCanvasSize(width,height,noUpdates)},Module.pauseMainLoop=function(){Browser.mainLoop.pause()},Module.resumeMainLoop=function(){Browser.mainLoop.resume()},Module.getUserMedia=function(){Browser.getUserMedia()},___buildEnvironment(ENV),STACK_BASE=STACKTOP=Runtime.alignMemory(STATICTOP),staticSealed=!0,STACK_MAX=STACK_BASE+TOTAL_STACK,DYNAMIC_BASE=DYNAMICTOP=Runtime.alignMemory(STACK_MAX),assert(DYNAMIC_BASE<TOTAL_MEMORY,"TOTAL_MEMORY not big enough for stack");var cttz_i8=allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0],"i8",ALLOC_DYNAMIC);Module.asmGlobalArg={Math:Math,Int8Array:Int8Array,Int16Array:Int16Array,Int32Array:Int32Array,Uint8Array:Uint8Array,Uint16Array:Uint16Array,Uint32Array:Uint32Array,Float32Array:Float32Array,Float64Array:Float64Array},Module.asmLibraryArg={abort:abort,assert:assert,min:Math_min,invoke_iiiiiiii:invoke_iiiiiiii,invoke_iiii:invoke_iiii,invoke_viiiiiii:invoke_viiiiiii,invoke_viiiii:invoke_viiiii,invoke_i:invoke_i,invoke_vi:invoke_vi,invoke_vii:invoke_vii,invoke_iiiiiii:invoke_iiiiiii,invoke_ii:invoke_ii,invoke_viii:invoke_viii,invoke_viiiiiiiii:invoke_viiiiiiiii,invoke_iiiii:invoke_iiiii,invoke_viiiiii:invoke_viiiiii,invoke_iii:invoke_iii,invoke_iiiiii:invoke_iiiiii,invoke_viiii:invoke_viiii,_fabs:_fabs,_llvm_pow_f64:_llvm_pow_f64,_send:_send,_getcwd:_getcwd,_fread:_fread,__reallyNegative:__reallyNegative,_vfprintf:_vfprintf,_emscripten_set_main_loop_timing:_emscripten_set_main_loop_timing,___assert_fail:___assert_fail,_floor:_floor,_fflush:_fflush,_llvm_ctlz_i64:_llvm_ctlz_i64,_pwrite:_pwrite,_strerror_r:_strerror_r,_fprintf:_fprintf,_open:_open,_sbrk:_sbrk,_emscripten_memcpy_big:_emscripten_memcpy_big,_fileno:_fileno,__formatString:__formatString,__exit:__exit,_close:_close,_ferror:_ferror,_munmap:_munmap,___buildEnvironment:___buildEnvironment,_pread:_pread,_printf:_printf,_fclose:_fclose,_write:_write,_fsync:_fsync,___errno_location:___errno_location,_stat:_stat,_recv:_recv,_fgetc:_fgetc,_getenv:_getenv,_sysconf:_sysconf,_read:_read,_fputc:_fputc,_emscripten_set_main_loop:_emscripten_set_main_loop,_abort:_abort,_fwrite:_fwrite,_time:_time,_mkport:_mkport,_strerror:_strerror,_gettimeofday:_gettimeofday,_fgets:_fgets,_mmap:_mmap,_fopen:_fopen,_exit:_exit,_labs:_labs,___setErrNo:___setErrNo,STACKTOP:STACKTOP,STACK_MAX:STACK_MAX,tempDoublePtr:tempDoublePtr,ABORT:ABORT,cttz_i8:cttz_i8,ctlz_i8:ctlz_i8,NaN:NaN,Infinity:1/0,_stderr:_stderr,_stdin:_stdin,_stdout:_stdout};var asm=function(global,env,buffer){"use asm";var a=new global.Int8Array(buffer);var b=new global.Int16Array(buffer);var c=new global.Int32Array(buffer);var d=new global.Uint8Array(buffer);var e=new global.Uint16Array(buffer);var f=new global.Uint32Array(buffer);var g=new global.Float32Array(buffer);var h=new global.Float64Array(buffer);var i=env.STACKTOP|0;var j=env.STACK_MAX|0;var k=env.tempDoublePtr|0;var l=env.ABORT|0;var m=env.cttz_i8|0;var n=env.ctlz_i8|0;var o=env._stderr|0;var p=env._stdin|0;var q=env._stdout|0;var r=0;var s=0;var t=0;var u=0;var v=+env.NaN,w=+env.Infinity;var x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;var G=0;var H=0;var I=0;var J=0;var K=0;var L=0;var M=0;var N=0;var O=0;var P=0;var Q=global.Math.floor;var R=global.Math.abs;var S=global.Math.sqrt;var T=global.Math.pow;var U=global.Math.cos;var V=global.Math.sin;var W=global.Math.tan;var X=global.Math.acos;var Y=global.Math.asin;var Z=global.Math.atan;var _=global.Math.atan2;var $=global.Math.exp;var aa=global.Math.log;var ba=global.Math.ceil;var ca=global.Math.imul;var da=env.abort;var ea=env.assert;var fa=env.min;var ga=env.invoke_iiiiiiii;var ha=env.invoke_iiii;var ia=env.invoke_viiiiiii;var ja=env.invoke_viiiii;var ka=env.invoke_i;var la=env.invoke_vi;var ma=env.invoke_vii;var na=env.invoke_iiiiiii;var oa=env.invoke_ii;var pa=env.invoke_viii;var qa=env.invoke_viiiiiiiii;var ra=env.invoke_iiiii;var sa=env.invoke_viiiiii;var ta=env.invoke_iii;var ua=env.invoke_iiiiii;var va=env.invoke_viiii;var wa=env._fabs;var xa=env._llvm_pow_f64;var ya=env._send;var za=env._getcwd;var Aa=env._fread;var Ba=env.__reallyNegative;var Ca=env._vfprintf;var Da=env._emscripten_set_main_loop_timing;var Ea=env.___assert_fail;var Fa=env._floor;var Ga=env._fflush;var Ha=env._llvm_ctlz_i64;var Ia=env._pwrite;var Ja=env._strerror_r;var Ka=env._fprintf;var La=env._open;var Ma=env._sbrk;var Na=env._emscripten_memcpy_big;var Oa=env._fileno;var Pa=env.__formatString;var Qa=env.__exit;var Ra=env._close;var Sa=env._ferror;var Ta=env._munmap;var Ua=env.___buildEnvironment;var Va=env._pread;var Wa=env._printf;var Xa=env._fclose;var Ya=env._write;var Za=env._fsync;var _a=env.___errno_location;var $a=env._stat;var ab=env._recv;var bb=env._fgetc;var cb=env._getenv;var db=env._sysconf;var eb=env._read;var fb=env._fputc;var gb=env._emscripten_set_main_loop;var hb=env._abort;var ib=env._fwrite;var jb=env._time;var kb=env._mkport;var lb=env._strerror;var mb=env._gettimeofday;var nb=env._fgets;var ob=env._mmap;var pb=env._fopen;var qb=env._exit;var rb=env._labs;var sb=env.___setErrNo;var tb=0;function Vo(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+32|0;e=b+20|0;f=b+16|0;g=b+12|0;h=b+8|0;j=b+4|0;k=b;c[f>>2]=a;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==47:0){a=(c[f>>2]|0)+200|0;c[a>>2]=(c[a>>2]|0)+2;a=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+2;a=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[a>>2]=(c[a>>2]|0)+2;c[g>>2]=Po(c[f>>2]|0)|0;if(!(c[g>>2]|0)){c[e>>2]=0;l=c[e>>2]|0;i=b;return l|0}Fo(c[f>>2]|0)|0;if(9<=(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)m=10;else if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13?32>(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0):0)m=11;else m=10;if((m|0)==10)if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=62)m=11;else me(c[f>>2]|0);a:do if((m|0)==11?(zo(c[f>>2]|0,73,95624,0,0),(c[(c[f>>2]|0)+288>>2]|0)!=0):0){while(1){n=c[f>>2]|0;if(!(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0))break;a=(d[c[(c[n+36>>2]|0)+16>>2]>>0]|0|0)!=62;me(c[f>>2]|0);if(!a)break a}me(n)}while(0);do if((c[(c[f>>2]|0)+248>>2]|0)>0){if(((qy(c[g>>2]|0,94240)|0)==0?(qy(c[g>>2]|0,95648)|0)==0:0)?(qy(c[g>>2]|0,95656)|0)==0:0)break;n=(c[f>>2]|0)+248|0;c[n>>2]=(c[n>>2]|0)+-1;c[e>>2]=0;l=c[e>>2]|0;i=b;return l|0}while(0);c[j>>2]=(c[(c[f>>2]|0)+188>>2]|0)-1;while(1){if((c[j>>2]|0)<0)break;if(qy(c[g>>2]|0,c[(c[(c[f>>2]|0)+196>>2]|0)+(c[j>>2]<<2)>>2]|0)|0)break;c[j>>2]=(c[j>>2]|0)+-1}n=c[f>>2]|0;m=c[g>>2]|0;if((c[j>>2]|0)<0){zo(n,76,95664,m,0);c[e>>2]=0;l=c[e>>2]|0;i=b;return l|0}ip(n,m);if(((qy(c[g>>2]|0,c[(c[f>>2]|0)+184>>2]|0)|0)==0?(c[(c[f>>2]|0)+184>>2]|0)!=0:0)?(qy(c[(c[f>>2]|0)+184>>2]|0,c[g>>2]|0)|0)==0:0)zo(c[f>>2]|0,76,95696,c[g>>2]|0,c[(c[f>>2]|0)+184>>2]|0);c[h>>2]=c[(c[f>>2]|0)+184>>2];if((c[h>>2]|0)!=0?(qy(c[h>>2]|0,c[g>>2]|0)|0)!=0:0){if((c[c[f>>2]>>2]|0)!=0?(c[(c[c[f>>2]>>2]|0)+60>>2]|0)!=0:0)Ab[c[(c[c[f>>2]>>2]|0)+60>>2]&511](c[(c[f>>2]|0)+4>>2]|0,c[g>>2]|0);jp(c[f>>2]|0)|0;Co(c[f>>2]|0)|0;c[k>>2]=1}else c[k>>2]=0;c[e>>2]=c[k>>2];l=c[e>>2]|0;i=b;return l|0}zo(c[f>>2]|0,74,95584,0,0);c[e>>2]=0;l=c[e>>2]|0;i=b;return l|0}function Wo(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+112|0;f=e+8|0;g=e+4|0;h=e;j=e+12|0;c[g>>2]=b;c[h>>2]=0;if(!(65<=(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)<=90:0))k=3;do if((k|0)==3){if(97<=(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)<=122:0)break;if((d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=95?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=58:0){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}}while(0);a:while(1){if((c[h>>2]|0)>=100)break;if(!(65<=(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+(1+(c[h>>2]|0))>>0]|0|0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+(1+(c[h>>2]|0))>>0]|0|0)<=90:0))k=11;do if((k|0)==11){k=0;if(97<=(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+(1+(c[h>>2]|0))>>0]|0|0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+(1+(c[h>>2]|0))>>0]|0|0)<=122:0)break;if(48<=(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+(1+(c[h>>2]|0))>>0]|0|0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+(1+(c[h>>2]|0))>>0]|0|0)<=57:0)break;if(((d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+(1+(c[h>>2]|0))>>0]|0|0)!=58?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+(1+(c[h>>2]|0))>>0]|0|0)!=45:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+(1+(c[h>>2]|0))>>0]|0|0)!=95:0)break a}while(0);if((d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+(1+(c[h>>2]|0))>>0]|0|0)>=65?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+(1+(c[h>>2]|0))>>0]|0|0)<=90:0)a[j+(c[h>>2]|0)>>0]=(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+(1+(c[h>>2]|0))>>0]|0)+32;else a[j+(c[h>>2]|0)>>0]=a[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+(1+(c[h>>2]|0))>>0]|0;c[h>>2]=(c[h>>2]|0)+1}c[f>>2]=AP(c[(c[g>>2]|0)+296>>2]|0,j,c[h>>2]|0)|0;l=c[f>>2]|0;i=e;return l|0}function Xo(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+1024|0;f=e+12|0;g=e+16|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=b;c[h>>2]=0;if(((c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)le(c[(c[f>>2]|0)+36>>2]|0);c[j>>2]=ap(c[f>>2]|0,k)|0;a:while(1){if(!(9<=(c[j>>2]|0)&(c[j>>2]|0)<=10|(c[j>>2]|0)==13|32<=(c[j>>2]|0)))break;do if((c[j>>2]|0)==60?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==47:0){b=c[f>>2]|0;if(c[(c[f>>2]|0)+288>>2]|0){l=c[b+184>>2]|0;m=(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+2|0;if(!(uy(l,m,xy(c[(c[f>>2]|0)+184>>2]|0)|0)|0))break a;zo(c[f>>2]|0,76,95912,c[(c[f>>2]|0)+184>>2]|0,0);break}if((d[(c[(c[b+36>>2]|0)+16>>2]|0)+2>>0]|0|0)>=65?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)<=90:0)break a;if((d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)>=97?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)<=122:0)break a}while(0);if((c[k>>2]|0)==1){b=c[j>>2]&255;m=c[h>>2]|0;c[h>>2]=m+1;a[g+m>>0]=b}else{b=qe(c[k>>2]|0,g+(c[h>>2]|0)|0,c[j>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+b}if((c[h>>2]|0)>=1e3){b=c[c[f>>2]>>2]|0;if(!(c[(c[c[f>>2]>>2]|0)+100>>2]|0)){if(c[b+68>>2]|0)Db[c[(c[c[f>>2]>>2]|0)+68>>2]&511](c[(c[f>>2]|0)+4>>2]|0,g,c[h>>2]|0)}else Db[c[b+100>>2]&511](c[(c[f>>2]|0)+4>>2]|0,g,c[h>>2]|0);c[h>>2]=0}if((c[(c[f>>2]|0)+292>>2]|0)==0?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)ke(c[(c[f>>2]|0)+36>>2]|0,250)|0;b=c[(c[f>>2]|0)+36>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){m=b+28|0;c[m>>2]=(c[m>>2]|0)+1;c[(c[(c[f>>2]|0)+36>>2]|0)+32>>2]=1}else{m=b+32|0;c[m>>2]=(c[m>>2]|0)+1}c[(c[f>>2]|0)+176>>2]=0;m=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[m>>2]=(c[m>>2]|0)+(c[k>>2]|0);m=(c[f>>2]|0)+200|0;c[m>>2]=(c[m>>2]|0)+1;c[j>>2]=ap(c[f>>2]|0,k)|0}do if(!(9<=(c[j>>2]|0)&(c[j>>2]|0)<=10|(c[j>>2]|0)==13|32<=(c[j>>2]|0))){if((c[j>>2]|0)==0?(c[(c[f>>2]|0)+292>>2]|0)!=0:0)break;Ao(c[f>>2]|0,9,95944,c[j>>2]|0);if((c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)>>>0<(c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)>>>0)me(c[f>>2]|0)}while(0);if(!(c[h>>2]|0)){i=e;return}if(!(c[c[f>>2]>>2]|0)){i=e;return}if(c[(c[f>>2]|0)+212>>2]|0){i=e;return}j=c[c[f>>2]>>2]|0;if(c[(c[c[f>>2]>>2]|0)+100>>2]|0){Db[c[j+100>>2]&511](c[(c[f>>2]|0)+4>>2]|0,g,c[h>>2]|0);i=e;return}if(!(c[j+68>>2]|0)){i=e;return}Db[c[(c[c[f>>2]>>2]|0)+68>>2]&511](c[(c[f>>2]|0)+4>>2]|0,g,c[h>>2]|0);i=e;return}function Yo(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+48|0;f=e+32|0;g=e+28|0;h=e+36|0;j=e+24|0;k=e+20|0;l=e+16|0;m=e+12|0;n=e+8|0;o=e+4|0;p=e;c[f>>2]=b;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=38){i=e;return}if((d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==35){c[m>>2]=0;c[k>>2]=io(c[f>>2]|0)|0;if(!(c[k>>2]|0)){i=e;return}b=c[k>>2]|0;do if((c[k>>2]|0)>>>0>=128){q=c[k>>2]|0;if(b>>>0<2048){r=c[m>>2]|0;c[m>>2]=r+1;a[h+r>>0]=q>>>6&31|192;c[l>>2]=0;break}r=c[k>>2]|0;if(q>>>0<65536){q=c[m>>2]|0;c[m>>2]=q+1;a[h+q>>0]=r>>>12&15|224;c[l>>2]=6;break}else{q=c[m>>2]|0;c[m>>2]=q+1;a[h+q>>0]=r>>>18&7|240;c[l>>2]=12;break}}else{r=c[m>>2]|0;c[m>>2]=r+1;a[h+r>>0]=b;c[l>>2]=-6}while(0);while(1){if((c[l>>2]|0)<0)break;b=((c[k>>2]|0)>>>(c[l>>2]|0)&63|128)&255;r=c[m>>2]|0;c[m>>2]=r+1;a[h+r>>0]=b;c[l>>2]=(c[l>>2]|0)-6}a[h+(c[m>>2]|0)>>0]=0;ep(c[f>>2]|0)|0;if(!(c[c[f>>2]>>2]|0)){i=e;return}if(!(c[(c[c[f>>2]>>2]|0)+68>>2]|0)){i=e;return}Db[c[(c[c[f>>2]>>2]|0)+68>>2]&511](c[(c[f>>2]|0)+4>>2]|0,h,c[m>>2]|0);i=e;return}c[g>>2]=ho(c[f>>2]|0,j)|0;if(!(c[j>>2]|0)){ep(c[f>>2]|0)|0;if(!(c[c[f>>2]>>2]|0)){i=e;return}if(!(c[(c[c[f>>2]>>2]|0)+68>>2]|0)){i=e;return}Db[c[(c[c[f>>2]>>2]|0)+68>>2]&511](c[(c[f>>2]|0)+4>>2]|0,95904,1);i=e;return}if((c[g>>2]|0)!=0?(c[c[g>>2]>>2]|0)>>>0>0:0){c[p>>2]=0;c[n>>2]=c[c[g>>2]>>2];g=c[n>>2]|0;do if((c[n>>2]|0)>>>0>=128){m=c[n>>2]|0;if(g>>>0<2048){l=c[p>>2]|0;c[p>>2]=l+1;a[h+l>>0]=m>>>6&31|192;c[o>>2]=0;break}l=c[n>>2]|0;if(m>>>0<65536){m=c[p>>2]|0;c[p>>2]=m+1;a[h+m>>0]=l>>>12&15|224;c[o>>2]=6;break}else{m=c[p>>2]|0;c[p>>2]=m+1;a[h+m>>0]=l>>>18&7|240;c[o>>2]=12;break}}else{l=c[p>>2]|0;c[p>>2]=l+1;a[h+l>>0]=g;c[o>>2]=-6}while(0);while(1){if((c[o>>2]|0)<0)break;g=((c[n>>2]|0)>>>(c[o>>2]|0)&63|128)&255;l=c[p>>2]|0;c[p>>2]=l+1;a[h+l>>0]=g;c[o>>2]=(c[o>>2]|0)-6}a[h+(c[p>>2]|0)>>0]=0;ep(c[f>>2]|0)|0;if(!(c[c[f>>2]>>2]|0)){i=e;return}if(!(c[(c[c[f>>2]>>2]|0)+68>>2]|0)){i=e;return}Db[c[(c[c[f>>2]>>2]|0)+68>>2]&511](c[(c[f>>2]|0)+4>>2]|0,h,c[p>>2]|0);i=e;return}ep(c[f>>2]|0)|0;if(!(c[c[f>>2]>>2]|0)){i=e;return}if(!(c[(c[c[f>>2]>>2]|0)+68>>2]|0)){i=e;return}Db[c[(c[c[f>>2]>>2]|0)+68>>2]&511](c[(c[f>>2]|0)+4>>2]|0,95904,1);p=c[(c[c[f>>2]>>2]|0)+68>>2]|0;h=c[(c[f>>2]|0)+4>>2]|0;f=c[j>>2]|0;o=xy(c[j>>2]|0)|0;Db[p&511](h,f,o);i=e;return}function Zo(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+1040|0;f=e+16|0;g=e+20|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[f>>2]=b;c[h>>2]=0;c[l>>2]=0;if(((c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)le(c[(c[f>>2]|0)+36>>2]|0);c[j>>2]=ap(c[f>>2]|0,k)|0;while(1){if((c[j>>2]|0)==60?(c[(c[f>>2]|0)+176>>2]|0)!=60:0)break;if((c[j>>2]|0)!=38){if(!(c[j>>2]|0))break}else if(!((c[j>>2]|0)!=0?(c[(c[f>>2]|0)+176>>2]|0)==38:0))break;b=c[j>>2]|0;if((c[j>>2]|0)<256)if(9<=(b|0)&(c[j>>2]|0)<=10|(c[j>>2]|0)==13|32<=(c[j>>2]|0))m=16;else m=15;else if((!(256<=(b|0)&(c[j>>2]|0)<=55295)?!(57344<=(c[j>>2]|0)&(c[j>>2]|0)<=65533):0)?!(65536<=(c[j>>2]|0)&(c[j>>2]|0)<=1114111):0)m=15;else m=16;do if((m|0)==15){m=0;Ao(c[f>>2]|0,9,95944,c[j>>2]|0)}else if((m|0)==16){m=0;if((c[k>>2]|0)==1){b=c[j>>2]&255;n=c[h>>2]|0;c[h>>2]=n+1;a[g+n>>0]=b;break}else{b=qe(c[k>>2]|0,g+(c[h>>2]|0)|0,c[j>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+b;break}}while(0);if((c[h>>2]|0)>=1e3){do if((c[c[f>>2]>>2]|0)!=0?(c[(c[f>>2]|0)+212>>2]|0)==0:0){b=(kp(c[f>>2]|0,g,c[h>>2]|0)|0)!=0;n=c[f>>2]|0;if(!b){ep(n)|0;if(!(c[(c[c[f>>2]>>2]|0)+68>>2]|0))break;Db[c[(c[c[f>>2]>>2]|0)+68>>2]&511](c[(c[f>>2]|0)+4>>2]|0,g,c[h>>2]|0);break}b=c[c[f>>2]>>2]|0;if(c[n+208>>2]|0){if(!(c[b+68>>2]|0))break;Db[c[(c[c[f>>2]>>2]|0)+68>>2]&511](c[(c[f>>2]|0)+4>>2]|0,g,c[h>>2]|0);break}else{if(!(c[b+72>>2]|0))break;Db[c[(c[c[f>>2]>>2]|0)+72>>2]&511](c[(c[f>>2]|0)+4>>2]|0,g,c[h>>2]|0);break}}while(0);c[h>>2]=0}b=c[(c[f>>2]|0)+36>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){n=b+28|0;c[n>>2]=(c[n>>2]|0)+1;c[(c[(c[f>>2]|0)+36>>2]|0)+32>>2]=1}else{n=b+32|0;c[n>>2]=(c[n>>2]|0)+1}c[(c[f>>2]|0)+176>>2]=0;n=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[n>>2]=(c[n>>2]|0)+(c[k>>2]|0);n=(c[f>>2]|0)+200|0;c[n>>2]=(c[n>>2]|0)+1;c[l>>2]=(c[l>>2]|0)+1;if((c[l>>2]|0)>100){c[l>>2]=0;if(((c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)le(c[(c[f>>2]|0)+36>>2]|0);if((c[(c[f>>2]|0)+292>>2]|0)==0?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)ke(c[(c[f>>2]|0)+36>>2]|0,250)|0}c[j>>2]=ap(c[f>>2]|0,k)|0;if(c[j>>2]|0)continue;if(((c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)le(c[(c[f>>2]|0)+36>>2]|0);if((c[(c[f>>2]|0)+292>>2]|0)==0?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)ke(c[(c[f>>2]|0)+36>>2]|0,250)|0;c[j>>2]=ap(c[f>>2]|0,k)|0}if(!(c[h>>2]|0)){if(c[j>>2]|0){i=e;return}c[(c[f>>2]|0)+172>>2]=-1;i=e;return}a[g+(c[h>>2]|0)>>0]=0;if(!(c[c[f>>2]>>2]|0)){i=e;return}if(c[(c[f>>2]|0)+212>>2]|0){i=e;return}j=(kp(c[f>>2]|0,g,c[h>>2]|0)|0)!=0;k=c[f>>2]|0;if(!j){ep(k)|0;if(!(c[(c[c[f>>2]>>2]|0)+68>>2]|0)){i=e;return}Db[c[(c[c[f>>2]>>2]|0)+68>>2]&511](c[(c[f>>2]|0)+4>>2]|0,g,c[h>>2]|0);i=e;return}j=c[c[f>>2]>>2]|0;if(c[k+208>>2]|0){if(!(c[j+68>>2]|0)){i=e;return}Db[c[(c[c[f>>2]>>2]|0)+68>>2]&511](c[(c[f>>2]|0)+4>>2]|0,g,c[h>>2]|0);i=e;return}else{if(!(c[j+72>>2]|0)){i=e;return}Db[c[(c[c[f>>2]>>2]|0)+72>>2]&511](c[(c[f>>2]|0)+4>>2]|0,g,c[h>>2]|0);i=e;return}}function _o(a){a=a|0;var b=0,e=0;b=i;i=i+16|0;e=b;c[e>>2]=a;if((c[(c[e>>2]|0)+52>>2]|0)!=0?(c[(c[e>>2]|0)+68>>2]|0)!=0:0){c[(c[(c[e>>2]|0)+448>>2]|0)+12>>2]=(c[(c[(c[e>>2]|0)+36>>2]|0)+36>>2]|0)+((c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[e>>2]|0)+36>>2]|0)+12>>2]|0));c[(c[(c[e>>2]|0)+448>>2]|0)+16>>2]=c[(c[(c[e>>2]|0)+36>>2]|0)+28>>2];c[c[(c[e>>2]|0)+448>>2]>>2]=c[(c[e>>2]|0)+52>>2];De(c[e>>2]|0,c[(c[e>>2]|0)+448>>2]|0);jp(c[e>>2]|0)|0}if(9<=(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0){
i=b;return}if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==13){i=b;return}if(32<=(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)){i=b;return}Do(c[e>>2]|0);i=b;return}function $o(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+48|0;f=e+32|0;g=e+28|0;h=e+24|0;j=e+4|0;k=e;c[f>>2]=b;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[j+16>>2]=0;if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+36>>2]|0)!=0:0){if((c[(c[f>>2]|0)+172>>2]|0)==-1){i=e;return}if(c[(c[f>>2]|0)+68>>2]|0){c[j+4>>2]=(c[(c[(c[f>>2]|0)+36>>2]|0)+36>>2]|0)+((c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+12>>2]|0));c[j+8>>2]=c[(c[(c[f>>2]|0)+36>>2]|0)+28>>2]}c[k>>2]=Bo(c[f>>2]|0)|0;c[g>>2]=c[(c[f>>2]|0)+184>>2];if((c[k>>2]|0)==-1|(c[g>>2]|0)==0){if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0)!=62){i=e;return}me(c[f>>2]|0);i=e;return}c[h>>2]=bo(c[g>>2]|0)|0;if(!(c[h>>2]|0))zo(c[f>>2]|0,801,94576,c[g>>2]|0,0);if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0)==47?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0)==62:0){k=(c[f>>2]|0)+200|0;c[k>>2]=(c[k>>2]|0)+2;k=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[k>>2]=(c[k>>2]|0)+2;k=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[k>>2]=(c[k>>2]|0)+2;if((c[c[f>>2]>>2]|0)!=0?(c[(c[c[f>>2]>>2]|0)+60>>2]|0)!=0:0)Ab[c[(c[c[f>>2]>>2]|0)+60>>2]&511](c[(c[f>>2]|0)+4>>2]|0,c[g>>2]|0);Co(c[f>>2]|0)|0;i=e;return}k=c[f>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0)!=62){zo(k,73,94592,c[g>>2]|0,0);if(qy(c[g>>2]|0,c[(c[f>>2]|0)+184>>2]|0)|0){Re(c[f>>2]|0)|0;Co(c[f>>2]|0)|0}if(c[(c[f>>2]|0)+68>>2]|0)dp(c[f>>2]|0,j)|0;_o(c[f>>2]|0);i=e;return}me(k);if((c[h>>2]|0)!=0?(a[(c[h>>2]|0)+7>>0]|0)!=0:0){if((c[c[f>>2]>>2]|0)!=0?(c[(c[c[f>>2]>>2]|0)+60>>2]|0)!=0:0)Ab[c[(c[c[f>>2]>>2]|0)+60>>2]&511](c[(c[f>>2]|0)+4>>2]|0,c[g>>2]|0);Co(c[f>>2]|0)|0;i=e;return}if(!(c[(c[f>>2]|0)+68>>2]|0)){i=e;return}dp(c[f>>2]|0,j)|0;i=e;return}zo(c[f>>2]|0,1,97568,0,0);i=e;return}function ap(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+208|0;g=f;h=f+40|0;j=f+36|0;k=f+32|0;l=f+28|0;m=f+194|0;n=f+24|0;o=f+20|0;p=f+16|0;q=f+44|0;c[j>>2]=b;c[k>>2]=e;if((c[(c[j>>2]|0)+172>>2]|0)==-1){c[h>>2]=0;r=c[h>>2]|0;i=f;return r|0}if(c[(c[j>>2]|0)+176>>2]|0){c[c[k>>2]>>2]=0;c[h>>2]=c[(c[j>>2]|0)+176>>2];r=c[h>>2]|0;i=f;return r|0}if((c[(c[j>>2]|0)+256>>2]|0)!=1){c[c[k>>2]>>2]=1;e=c[j>>2]|0;if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<128){c[h>>2]=d[c[(c[e+36>>2]|0)+16>>2]>>0];r=c[h>>2]|0;i=f;return r|0}c[o>>2]=lp(e)|0;e=c[j>>2]|0;do if(c[o>>2]|0){if(c[(c[e+36>>2]|0)+44>>2]|0)zb[c[135736>>2]&511](c[(c[(c[j>>2]|0)+36>>2]|0)+44>>2]|0);c[(c[(c[j>>2]|0)+36>>2]|0)+44>>2]=c[o>>2];c[p>>2]=Dd(c[o>>2]|0)|0;b=c[j>>2]|0;if(c[p>>2]|0){se(b,c[p>>2]|0)|0;break}else{zo(b,81,96008,c[o>>2]|0,0);break}}else re(e,10)|0;while(0);c[(c[j>>2]|0)+256>>2]=1;c[h>>2]=ne(c[j>>2]|0,c[k>>2]|0)|0;r=c[h>>2]|0;i=f;return r|0}c[l>>2]=c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2];a[m>>0]=a[c[l>>2]>>0]|0;if(!((d[m>>0]|0)&128)){if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)>>>0<(c[(c[(c[j>>2]|0)+36>>2]|0)+20>>2]|0)>>>0:0){Ao(c[j>>2]|0,9,95976,0);c[c[k>>2]>>2]=1;c[h>>2]=32;r=c[h>>2]|0;i=f;return r|0}c[c[k>>2]>>2]=1;c[h>>2]=d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0];r=c[h>>2]|0;i=f;return r|0}if(!(d[(c[l>>2]|0)+1>>0]|0)){ke(c[(c[j>>2]|0)+36>>2]|0,250)|0;c[l>>2]=c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]}a:do if(((d[(c[l>>2]|0)+1>>0]|0)&192|0)==128){do if(((d[m>>0]|0)&224|0)==224){if(!(d[(c[l>>2]|0)+2>>0]|0)){ke(c[(c[j>>2]|0)+36>>2]|0,250)|0;c[l>>2]=c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]}if(((d[(c[l>>2]|0)+2>>0]|0)&192|0)!=128)break a;if(((d[m>>0]|0)&240|0)!=240){c[c[k>>2]>>2]=3;c[n>>2]=((d[c[l>>2]>>0]|0)&15)<<12;c[n>>2]=c[n>>2]|((d[(c[l>>2]|0)+1>>0]|0)&63)<<6;c[n>>2]=c[n>>2]|(d[(c[l>>2]|0)+2>>0]|0)&63;break}if(!(d[(c[l>>2]|0)+3>>0]|0)){ke(c[(c[j>>2]|0)+36>>2]|0,250)|0;c[l>>2]=c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]}if(((d[m>>0]|0)&248|0)!=240)break a;if(((d[(c[l>>2]|0)+3>>0]|0)&192|0)!=128)break a;c[c[k>>2]>>2]=4;c[n>>2]=((d[c[l>>2]>>0]|0)&7)<<18;c[n>>2]=c[n>>2]|((d[(c[l>>2]|0)+1>>0]|0)&63)<<12;c[n>>2]=c[n>>2]|((d[(c[l>>2]|0)+2>>0]|0)&63)<<6;c[n>>2]=c[n>>2]|(d[(c[l>>2]|0)+3>>0]|0)&63}else{c[c[k>>2]>>2]=2;c[n>>2]=((d[c[l>>2]>>0]|0)&31)<<6;c[n>>2]=c[n>>2]|(d[(c[l>>2]|0)+1>>0]|0)&63}while(0);e=c[n>>2]|0;if((c[n>>2]|0)>>>0<256){if(!(9<=e>>>0&(c[n>>2]|0)>>>0<=10|(c[n>>2]|0)==13|32<=(c[n>>2]|0)>>>0))s=27}else if((!(256<=e>>>0&(c[n>>2]|0)>>>0<=55295)?!(57344<=(c[n>>2]|0)>>>0&(c[n>>2]|0)>>>0<=65533):0)?!(65536<=(c[n>>2]|0)>>>0&(c[n>>2]|0)>>>0<=1114111):0)s=27;if((s|0)==27)Ao(c[j>>2]|0,9,95976,c[n>>2]|0);c[h>>2]=c[n>>2];r=c[h>>2]|0;i=f;return r|0}while(0);n=d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0;if(((c[(c[(c[j>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=4){s=d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0;l=d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0;m=d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0;c[g>>2]=n;c[g+4>>2]=s;c[g+8>>2]=l;c[g+12>>2]=m;JT(q,149,96032,g)|0}else{c[g>>2]=n;JT(q,149,96072,g)|0}zo(c[j>>2]|0,81,96088,q,0);c[(c[j>>2]|0)+256>>2]=10;c[c[k>>2]>>2]=1;c[h>>2]=d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0];r=c[h>>2]|0;i=f;return r|0}function bp(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;if((((((WS(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0)|0)==83?(WS(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0)|0)==89:0)?(WS(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0)|0)==83:0)?(WS(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0)|0)==84:0)?(WS(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0)|0)==69:0)?(WS(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0)|0)==77:0){b=(c[f>>2]|0)+200|0;c[b>>2]=(c[b>>2]|0)+6;b=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[b>>2]=(c[b>>2]|0)+6;b=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[b>>2]=(c[b>>2]|0)+6;do if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13)zo(c[f>>2]|0,65,97056,0,0)}while(0);Fo(c[f>>2]|0)|0;c[h>>2]=mp(c[f>>2]|0)|0;if(c[h>>2]|0){j=c[h>>2]|0;i=e;return j|0}zo(c[f>>2]|0,70,97088,0,0);j=c[h>>2]|0;i=e;return j|0}if((WS(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0)|0)!=80){j=c[h>>2]|0;i=e;return j|0}if((WS(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0)|0)!=85){j=c[h>>2]|0;i=e;return j|0}if((WS(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0)|0)!=66){j=c[h>>2]|0;i=e;return j|0}if((WS(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0)|0)!=76){j=c[h>>2]|0;i=e;return j|0}if((WS(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0)|0)!=73){j=c[h>>2]|0;i=e;return j|0}if((WS(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0)|0)!=67){j=c[h>>2]|0;i=e;return j|0}b=(c[f>>2]|0)+200|0;c[b>>2]=(c[b>>2]|0)+6;b=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[b>>2]=(c[b>>2]|0)+6;b=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[b>>2]=(c[b>>2]|0)+6;do if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13)zo(c[f>>2]|0,65,97128,0,0)}while(0);Fo(c[f>>2]|0)|0;b=np(c[f>>2]|0)|0;c[c[g>>2]>>2]=b;if(!(c[c[g>>2]>>2]|0))zo(c[f>>2]|0,71,97160,0,0);Fo(c[f>>2]|0)|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=34?(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=39:0){j=c[h>>2]|0;i=e;return j|0}c[h>>2]=mp(c[f>>2]|0)|0;j=c[h>>2]|0;i=e;return j|0}function cp(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;k=i;i=i+48|0;l=k+36|0;m=k+32|0;n=k+43|0;o=k+42|0;p=k+41|0;q=k+28|0;r=k+24|0;s=k+20|0;t=k+16|0;u=k+12|0;v=k+8|0;w=k+4|0;x=k;y=k+40|0;c[m>>2]=b;a[n>>0]=e;a[o>>0]=f;a[p>>0]=g;c[q>>2]=h;c[r>>2]=j;c[w>>2]=0;c[x>>2]=0;a[y>>0]=0;c[u>>2]=c[(c[m>>2]|0)+36>>2];if(!(c[u>>2]|0)){c[l>>2]=-1;z=c[l>>2]|0;i=k;return z|0}c[s>>2]=(c[(c[u>>2]|0)+16>>2]|0)-(c[(c[u>>2]|0)+12>>2]|0);if((c[s>>2]|0)<0){c[l>>2]=-1;z=c[l>>2]|0;i=k;return z|0}if((c[(c[m>>2]|0)+204>>2]|0)>(c[s>>2]|0))c[s>>2]=c[(c[m>>2]|0)+204>>2];j=c[u>>2]|0;if(!(c[c[u>>2]>>2]|0)){c[v>>2]=c[j+12>>2];c[t>>2]=c[(c[u>>2]|0)+24>>2]}else{c[v>>2]=Vy(c[(c[j>>2]|0)+16>>2]|0)|0;c[t>>2]=_y(c[(c[c[u>>2]>>2]|0)+16>>2]|0)|0}if(!(a[p>>0]|0)){if(a[o>>0]|0)c[t>>2]=(c[t>>2]|0)+-1}else c[t>>2]=(c[t>>2]|0)-2;a:while(1){A=(c[w>>2]|0)!=0;if((c[s>>2]|0)>=(c[t>>2]|0)){B=45;break}if(((((!A?!((c[q>>2]|0)!=0?1:((c[s>>2]|0)+4|0)>=(c[t>>2]|0)):0)?(d[(c[v>>2]|0)+(c[s>>2]|0)>>0]|0)==60:0)?(d[(c[v>>2]|0)+((c[s>>2]|0)+1)>>0]|0)==33:0)?(d[(c[v>>2]|0)+((c[s>>2]|0)+2)>>0]|0)==45:0)?(d[(c[v>>2]|0)+((c[s>>2]|0)+3)>>0]|0)==45:0){c[w>>2]=1;c[s>>2]=(c[s>>2]|0)+2}do if(c[r>>2]|0){if((d[(c[v>>2]|0)+(c[s>>2]|0)>>0]|0)!=34?(d[(c[v>>2]|0)+(c[s>>2]|0)>>0]|0)!=39:0)if(c[x>>2]|0)break;else{B=30;break}j=a[(c[v>>2]|0)+(c[s>>2]|0)>>0]|0;if(!(c[x>>2]|0)){a[y>>0]=j;c[x>>2]=1;break}if((j&255|0)==(a[y>>0]|0))c[x>>2]=0;else B=30}else B=30;while(0);do if((B|0)==30){B=0;j=c[s>>2]|0;if(c[w>>2]|0){if((j+3|0)>(c[t>>2]|0)){B=32;break a}if((d[(c[v>>2]|0)+(c[s>>2]|0)>>0]|0)!=45)break;if((d[(c[v>>2]|0)+((c[s>>2]|0)+1)>>0]|0)!=45)break;if((d[(c[v>>2]|0)+((c[s>>2]|0)+2)>>0]|0)!=62)break;c[w>>2]=0;c[s>>2]=(c[s>>2]|0)+2;break}if((d[(c[v>>2]|0)+j>>0]|0)==(d[n>>0]|0))if(d[p>>0]|0){if((d[(c[v>>2]|0)+((c[s>>2]|0)+1)>>0]|0)!=(d[o>>0]|0))break;if((d[(c[v>>2]|0)+((c[s>>2]|0)+2)>>0]|0)!=(d[p>>0]|0))break;else{B=43;break a}}else{if(!(d[o>>0]|0)){B=43;break a}if((d[(c[v>>2]|0)+((c[s>>2]|0)+1)>>0]|0)!=(d[o>>0]|0))break;else{B=43;break a}}}while(0);c[s>>2]=(c[s>>2]|0)+1}if((B|0)==32){c[l>>2]=-1;z=c[l>>2]|0;i=k;return z|0}else if((B|0)==43){c[(c[m>>2]|0)+204>>2]=0;c[l>>2]=(c[s>>2]|0)-((c[(c[u>>2]|0)+16>>2]|0)-(c[(c[u>>2]|0)+12>>2]|0));z=c[l>>2]|0;i=k;return z|0}else if((B|0)==45){if(!(A|(c[x>>2]|0)!=0))c[(c[m>>2]|0)+204>>2]=c[s>>2];c[l>>2]=-1;z=c[l>>2]|0;i=k;return z|0}return 0}function dp(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if((c[(c[f>>2]|0)+452>>2]|0)>=(c[(c[f>>2]|0)+456>>2]|0)){if(!(c[(c[f>>2]|0)+456>>2]|0))c[(c[f>>2]|0)+456>>2]=5;b=(c[f>>2]|0)+456|0;c[b>>2]=c[b>>2]<<1;b=Hb[c[135760>>2]&511](c[(c[f>>2]|0)+460>>2]|0,(c[(c[f>>2]|0)+456>>2]|0)*20|0)|0;c[(c[f>>2]|0)+460>>2]=b;if(!(c[(c[f>>2]|0)+460>>2]|0)){xo(c[f>>2]|0,0);c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}}b=(c[(c[f>>2]|0)+460>>2]|0)+((c[(c[f>>2]|0)+452>>2]|0)*20|0)|0;a=c[g>>2]|0;c[b+0>>2]=c[a+0>>2];c[b+4>>2]=c[a+4>>2];c[b+8>>2]=c[a+8>>2];c[b+12>>2]=c[a+12>>2];c[b+16>>2]=c[a+16>>2];c[(c[f>>2]|0)+448>>2]=(c[(c[f>>2]|0)+460>>2]|0)+((c[(c[f>>2]|0)+452>>2]|0)*20|0);a=(c[f>>2]|0)+452|0;f=c[a>>2]|0;c[a>>2]=f+1;c[e>>2]=f;h=c[e>>2]|0;i=d;return h|0}function ep(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;if(!(c[e>>2]|0)){c[d>>2]=-1;h=c[d>>2]|0;i=b;return h|0}c[f>>2]=c[(c[e>>2]|0)+184>>2];if(!(c[f>>2]|0)){Qo(c[e>>2]|0,96176);Ro(c[e>>2]|0,96176);Uo(c[e>>2]|0,96176)|0;if((c[c[e>>2]>>2]|0)!=0?(c[(c[c[e>>2]>>2]|0)+56>>2]|0)!=0:0)Db[c[(c[c[e>>2]>>2]|0)+56>>2]&511](c[(c[e>>2]|0)+4>>2]|0,96176,0);c[d>>2]=1;h=c[d>>2]|0;i=b;return h|0}if(!(c[23702]|0)){c[d>>2]=0;h=c[d>>2]|0;i=b;return h|0}c[g>>2]=0;while(1){if(!(c[96184+(c[g>>2]<<2)>>2]|0)){j=18;break}if(qy(c[f>>2]|0,c[96184+(c[g>>2]<<2)>>2]|0)|0)break;c[g>>2]=(c[g>>2]|0)+1}if((j|0)==18){c[d>>2]=0;h=c[d>>2]|0;i=b;return h|0}Qo(c[e>>2]|0,96176);Ro(c[e>>2]|0,96176);Uo(c[e>>2]|0,96176)|0;if((c[c[e>>2]>>2]|0)!=0?(c[(c[c[e>>2]>>2]|0)+56>>2]|0)!=0:0)Db[c[(c[c[e>>2]>>2]|0)+56>>2]&511](c[(c[e>>2]|0)+4>>2]|0,96176,0);c[d>>2]=1;h=c[d>>2]|0;i=b;return h|0}function fp(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+48|0;g=f+36|0;h=f+32|0;j=f+28|0;k=f+24|0;l=f+20|0;m=f+16|0;n=f+12|0;o=f+8|0;p=f+4|0;q=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=e;c[p>>2]=0;c[n>>2]=c[(c[h>>2]|0)+36>>2];if(!(c[n>>2]|0)){c[g>>2]=-1;r=c[g>>2]|0;i=f;return r|0}c[l>>2]=(c[(c[n>>2]|0)+16>>2]|0)-(c[(c[n>>2]|0)+12>>2]|0);if((c[l>>2]|0)<0){c[g>>2]=-1;r=c[g>>2]|0;i=f;return r|0}if((c[(c[h>>2]|0)+204>>2]|0)>(c[l>>2]|0))c[l>>2]=c[(c[h>>2]|0)+204>>2];e=c[n>>2]|0;if(!(c[c[n>>2]>>2]|0)){c[o>>2]=c[e+12>>2];c[m>>2]=c[(c[n>>2]|0)+24>>2]}else{c[o>>2]=Vy(c[(c[e>>2]|0)+16>>2]|0)|0;c[m>>2]=_y(c[(c[c[n>>2]>>2]|0)+16>>2]|0)|0}a:while(1){if((c[l>>2]|0)>=(c[m>>2]|0)){s=31;break}if((((((c[p>>2]|0)==0?((c[l>>2]|0)+4|0)<(c[m>>2]|0):0)?(d[(c[o>>2]|0)+(c[l>>2]|0)>>0]|0|0)==60:0)?(d[(c[o>>2]|0)+((c[l>>2]|0)+1)>>0]|0|0)==33:0)?(d[(c[o>>2]|0)+((c[l>>2]|0)+2)>>0]|0|0)==45:0)?(d[(c[o>>2]|0)+((c[l>>2]|0)+3)>>0]|0|0)==45:0){c[p>>2]=1;c[l>>2]=(c[l>>2]|0)+2}b:do if(c[p>>2]|0){if(((c[l>>2]|0)+3|0)>(c[m>>2]|0)){s=20;break a}if(((d[(c[o>>2]|0)+(c[l>>2]|0)>>0]|0|0)==45?(d[(c[o>>2]|0)+((c[l>>2]|0)+1)>>0]|0|0)==45:0)?(d[(c[o>>2]|0)+((c[l>>2]|0)+2)>>0]|0|0)==62:0){c[p>>2]=0;c[l>>2]=(c[l>>2]|0)+2}}else{c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[k>>2]|0))break b;if((d[(c[o>>2]|0)+(c[l>>2]|0)>>0]|0|0)==(d[(c[j>>2]|0)+(c[q>>2]|0)>>0]|0|0)){s=28;break a}c[q>>2]=(c[q>>2]|0)+1}}while(0);c[l>>2]=(c[l>>2]|0)+1}if((s|0)==20){c[g>>2]=-1;r=c[g>>2]|0;i=f;return r|0}else if((s|0)==28){c[(c[h>>2]|0)+204>>2]=0;c[g>>2]=(c[l>>2]|0)-((c[(c[n>>2]|0)+16>>2]|0)-(c[(c[n>>2]|0)+12>>2]|0));r=c[g>>2]|0;i=f;return r|0}else if((s|0)==31){c[(c[h>>2]|0)+204>>2]=c[l>>2];c[g>>2]=-1;r=c[g>>2]|0;i=f;return r|0}return 0}function gp(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){i=e;return}if(c[(c[f>>2]|0)+360>>2]&2097152){i=e;return}if(!((c[g>>2]|0)!=0?(c[(c[(c[f>>2]|0)+36>>2]|0)+44>>2]|0)==0:0)){i=e;return}while(1){if((d[c[g>>2]>>0]|0|0)!=32?(d[c[g>>2]>>0]|0|0)!=9:0)break;c[g>>2]=(c[g>>2]|0)+1}if(c[(c[(c[f>>2]|0)+36>>2]|0)+44>>2]|0)zb[c[135736>>2]&511](c[(c[(c[f>>2]|0)+36>>2]|0)+44>>2]|0);b=my(c[g>>2]|0)|0;c[(c[(c[f>>2]|0)+36>>2]|0)+44>>2]=b;c[h>>2]=wd(c[g>>2]|0)|0;do if((c[h>>2]|0)==-1){c[j>>2]=Dd(c[g>>2]|0)|0;b=c[f>>2]|0;if(c[j>>2]|0){se(b,c[j>>2]|0)|0;c[(c[f>>2]|0)+256>>2]=1;break}else{zo(b,32,94872,c[g>>2]|0,0);break}}else{if(((c[h>>2]|0)==2|(c[h>>2]|0)==3|(c[h>>2]|0)==4|(c[h>>2]|0)==5?(c[c[(c[f>>2]|0)+36>>2]>>2]|0)!=0:0)?(c[(c[c[(c[f>>2]|0)+36>>2]>>2]|0)+12>>2]|0)==0:0)zo(c[f>>2]|0,81,94832,0,0);else re(c[f>>2]|0,c[h>>2]|0)|0;c[(c[f>>2]|0)+256>>2]=1}while(0);if(!(c[c[(c[f>>2]|0)+36>>2]>>2]|0)){i=e;return}if(!(c[(c[c[(c[f>>2]|0)+36>>2]>>2]|0)+12>>2]|0)){i=e;return}if(!(c[(c[c[(c[f>>2]|0)+36>>2]>>2]|0)+20>>2]|0)){i=e;return}if(!(c[(c[c[(c[f>>2]|0)+36>>2]>>2]|0)+16>>2]|0)){i=e;return}c[l>>2]=(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+12>>2]|0);Ty(c[(c[c[(c[f>>2]|0)+36>>2]>>2]|0)+16>>2]|0,c[l>>2]|0)|0;c[k>>2]=Fd(c[c[(c[f>>2]|0)+36>>2]>>2]|0,1)|0;if((c[k>>2]|0)<0)zo(c[f>>2]|0,81,94912,0,0);iz(c[(c[c[(c[f>>2]|0)+36>>2]>>2]|0)+16>>2]|0,c[(c[f>>2]|0)+36>>2]|0)|0;i=e;return}function hp(a){a=a|0;var b=0,e=0,f=0,g=0;b=i;i=i+16|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=0;a=c[e>>2]|0;do if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==34){me(a);c[f>>2]=op(c[e>>2]|0,34)|0;g=c[e>>2]|0;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=34){zo(g,40,97944,0,0);break}else{me(g);break}}else{g=c[e>>2]|0;if((d[c[(c[a+36>>2]|0)+16>>2]>>0]|0|0)!=39){c[f>>2]=op(g,0)|0;if(c[f>>2]|0)break;zo(c[e>>2]|0,41,97992,0,0);break}me(g);c[f>>2]=op(c[e>>2]|0,39)|0;g=c[e>>2]|0;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=39){zo(g,40,97968,0,0);break}else{me(g);break}}while(0);i=b;return c[f>>2]|0}function ip(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=b;c[g>>2]=d;c[k>>2]=pp(c[g>>2]|0)|0;c[j>>2]=(c[(c[f>>2]|0)+188>>2]|0)-1;while(1){if((c[j>>2]|0)<0)break;if(qy(c[g>>2]|0,c[(c[(c[f>>2]|0)+196>>2]|0)+(c[j>>2]<<2)>>2]|0)|0)break;d=pp(c[(c[(c[f>>2]|0)+196>>2]|0)+(c[j>>2]<<2)>>2]|0)|0;if((d|0)>(c[k>>2]|0)){l=15;break}c[j>>2]=(c[j>>2]|0)+-1}if((l|0)==15){i=e;return}if((c[j>>2]|0)<0){i=e;return}while(1){if(!((qy(c[g>>2]|0,c[(c[f>>2]|0)+184>>2]|0)|0)!=0^1))break;c[h>>2]=bo(c[(c[f>>2]|0)+184>>2]|0)|0;if((c[h>>2]|0)!=0?(a[(c[h>>2]|0)+5>>0]|0)==3:0)zo(c[f>>2]|0,76,95696,c[g>>2]|0,c[(c[f>>2]|0)+184>>2]|0);if((c[c[f>>2]>>2]|0)!=0?(c[(c[c[f>>2]>>2]|0)+60>>2]|0)!=0:0)Ab[c[(c[c[f>>2]>>2]|0)+60>>2]&511](c[(c[f>>2]|0)+4>>2]|0,c[(c[f>>2]|0)+184>>2]|0);Co(c[f>>2]|0)|0}i=e;return}function jp(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;if((c[(c[e>>2]|0)+452>>2]|0)<=0){c[d>>2]=0;f=c[d>>2]|0;i=b;return f|0}a=(c[e>>2]|0)+452|0;c[a>>2]=(c[a>>2]|0)+-1;if((c[(c[e>>2]|0)+452>>2]|0)<0){c[d>>2]=0;f=c[d>>2]|0;i=b;return f|0}a=c[e>>2]|0;if((c[(c[e>>2]|0)+452>>2]|0)>0)c[(c[e>>2]|0)+448>>2]=(c[(c[e>>2]|0)+460>>2]|0)+(((c[a+452>>2]|0)-1|0)*20|0);else c[a+448>>2]=0;c[d>>2]=(c[(c[e>>2]|0)+460>>2]|0)+((c[(c[e>>2]|0)+452>>2]|0)*20|0);f=c[d>>2]|0;i=b;return f|0}function kp(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+32|0;g=f+28|0;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f+4|0;o=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=e;c[m>>2]=0;a:while(1){if((c[m>>2]|0)>=(c[k>>2]|0))break;do if((d[(c[j>>2]|0)+(c[m>>2]|0)>>0]|0|0)!=32){if(9<=(d[(c[j>>2]|0)+(c[m>>2]|0)>>0]|0|0)?(d[(c[j>>2]|0)+(c[m>>2]|0)>>0]|0|0)<=10:0)break;if((d[(c[j>>2]|0)+(c[m>>2]|0)>>0]|0|0)!=13){p=7;break a}}while(0);c[m>>2]=(c[m>>2]|0)+1}if((p|0)==7){c[g>>2]=0;q=c[g>>2]|0;i=f;return q|0}if(!(d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0)){c[g>>2]=1;q=c[g>>2]|0;i=f;return q|0}if((d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=60){c[g>>2]=0;q=c[g>>2]|0;i=f;return q|0}if(!(c[(c[h>>2]|0)+184>>2]|0)){c[g>>2]=1;q=c[g>>2]|0;i=f;return q|0}if(qy(c[(c[h>>2]|0)+184>>2]|0,94240)|0){c[g>>2]=1;q=c[g>>2]|0;i=f;return q|0}if(qy(c[(c[h>>2]|0)+184>>2]|0,95656)|0){c[g>>2]=1;q=c[g>>2]|0;i=f;return q|0}do if((((qy(c[(c[h>>2]|0)+184>>2]|0,95648)|0)!=0?(c[(c[h>>2]|0)+8>>2]|0)!=0:0)?(c[o>>2]=Nh(c[(c[h>>2]|0)+8>>2]|0)|0,(c[o>>2]|0)!=0):0)?(c[(c[o>>2]|0)+52>>2]|0)!=0:0){if((ty(c[(c[o>>2]|0)+52>>2]|0,96272)|0)!=0?(ty(c[(c[o>>2]|0)+52>>2]|0,96304)|0)!=0:0)break;c[g>>2]=1;q=c[g>>2]|0;i=f;return q|0}while(0);if(!(c[(c[h>>2]|0)+52>>2]|0)){c[g>>2]=0;q=c[g>>2]|0;i=f;return q|0}c[n>>2]=Bi(c[(c[h>>2]|0)+52>>2]|0)|0;while(1){if(c[n>>2]|0)r=(c[(c[n>>2]|0)+4>>2]|0)==8;else r=0;s=c[n>>2]|0;if(!r)break;c[n>>2]=c[s+28>>2]}b:do if(!s){if((c[(c[(c[h>>2]|0)+52>>2]|0)+4>>2]|0)!=1?(c[(c[(c[h>>2]|0)+52>>2]|0)+40>>2]|0)!=0:0){c[g>>2]=0;q=c[g>>2]|0;i=f;return q|0}c[l>>2]=0;while(1){if((c[l>>2]|0)>>>0>=53)break b;if(qy(c[(c[h>>2]|0)+184>>2]|0,c[96328+(c[l>>2]<<2)>>2]|0)|0)break;c[l>>2]=(c[l>>2]|0)+1}c[g>>2]=0;q=c[g>>2]|0;i=f;return q|0}else{if(hj(c[n>>2]|0)|0){c[g>>2]=0;q=c[g>>2]|0;i=f;return q|0}c[l>>2]=0;while(1){if((c[l>>2]|0)>>>0>=53)break b;if(qy(c[(c[n>>2]|0)+8>>2]|0,c[96328+(c[l>>2]<<2)>>2]|0)|0)break;c[l>>2]=(c[l>>2]|0)+1}c[g>>2]=0;q=c[g>>2]|0;i=f;return q|0}while(0);c[g>>2]=1;q=c[g>>2]|0;i=f;return q|0}function lp(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+32|0;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;j=b;c[f>>2]=a;if(((((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+36>>2]|0)!=0:0)?(c[(c[(c[f>>2]|0)+36>>2]|0)+44>>2]|0)==0:0)?(c[c[(c[f>>2]|0)+36>>2]>>2]|0)!=0:0)?(c[(c[c[(c[f>>2]|0)+36>>2]>>2]|0)+12>>2]|0)==0:0){if((c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)!=0?(c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)!=0:0){c[g>>2]=c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2];c[j>>2]=c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2];if(d[c[j>>2]>>0]|0){c[e>>2]=0;k=c[e>>2]|0;i=b;return k|0}c[h>>2]=yy(c[g>>2]|0,96136)|0;if(!(c[h>>2]|0)){c[e>>2]=0;k=c[e>>2]|0;i=b;return k|0}c[h>>2]=yy(c[h>>2]|0,96152)|0;if(!(c[h>>2]|0)){c[e>>2]=0;k=c[e>>2]|0;i=b;return k|0}c[h>>2]=yy(c[h>>2]|0,96160)|0;if(!(c[h>>2]|0)){c[e>>2]=0;k=c[e>>2]|0;i=b;return k|0}c[h>>2]=(c[h>>2]|0)+8;c[g>>2]=c[h>>2];while(1){if((d[c[h>>2]>>0]|0|0)>=65?(d[c[h>>2]>>0]|0|0)<=90:0)l=1;else m=21;do if((m|0)==21){m=0;if((d[c[h>>2]>>0]|0|0)>=97?(d[c[h>>2]>>0]|0|0)<=122:0){l=1;break}if((d[c[h>>2]>>0]|0|0)>=48?(d[c[h>>2]>>0]|0|0)<=57:0){l=1;break}if((d[c[h>>2]>>0]|0|0)!=45?(d[c[h>>2]>>0]|0|0)!=95:0){if((d[c[h>>2]>>0]|0|0)==58){l=1;break}l=(d[c[h>>2]>>0]|0|0)==47}else l=1}while(0);n=c[h>>2]|0;if(!l)break;c[h>>2]=n+1}if((n|0)==(c[g>>2]|0)){c[e>>2]=0;k=c[e>>2]|0;i=b;return k|0}else{c[e>>2]=ly(c[g>>2]|0,(c[h>>2]|0)-(c[g>>2]|0)|0)|0;k=c[e>>2]|0;i=b;return k|0}}c[e>>2]=0;k=c[e>>2]|0;i=b;return k|0}c[e>>2]=0;k=c[e>>2]|0;i=b;return k|0}function mp(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;c[g>>2]=0;a=c[e>>2]|0;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==34){me(a);c[f>>2]=c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2];while(1){if(9<=(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)h=7;else if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13?32>(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0):0)j=0;else h=7;if((h|0)==7){h=0;j=(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=34}k=c[e>>2]|0;if(!j)break;me(k)}if(!(9<=(d[c[(c[k+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0))h=12;if(((h|0)==12?(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13:0)?32>(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0):0){zo(c[e>>2]|0,44,97280,0,0);l=c[g>>2]|0;i=b;return l|0}c[g>>2]=ly(c[f>>2]|0,(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)-(c[f>>2]|0)|0)|0;me(c[e>>2]|0);l=c[g>>2]|0;i=b;return l|0}k=c[e>>2]|0;if((d[c[(c[a+36>>2]|0)+16>>2]>>0]|0|0)!=39){zo(k,43,97312,0,0);l=c[g>>2]|0;i=b;return l|0}me(k);c[f>>2]=c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2];while(1){if(9<=(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)h=22;else if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13?32>(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0):0)m=0;else h=22;if((h|0)==22){h=0;m=(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=39}n=c[e>>2]|0;if(!m)break;me(n)}if(!(9<=(d[c[(c[n+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0))h=27;if(((h|0)==27?(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13:0)?32>(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0):0){zo(c[e>>2]|0,44,97280,0,0);l=c[g>>2]|0;i=b;return l|0}c[g>>2]=ly(c[f>>2]|0,(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)-(c[f>>2]|0)|0)|0;me(c[e>>2]|0);l=c[g>>2]|0;i=b;return l|0}function np(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=b;c[h>>2]=0;b=c[f>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0)==34){me(b);c[g>>2]=c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2];while(1){j=c[f>>2]|0;if(!(a[198696+(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0)>>0]|0))break;me(j)}if((d[c[(c[j+36>>2]|0)+16>>2]>>0]|0)!=34){zo(c[f>>2]|0,44,97216,0,0);k=c[h>>2]|0;i=e;return k|0}else{c[h>>2]=ly(c[g>>2]|0,(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)-(c[g>>2]|0)|0)|0;me(c[f>>2]|0);k=c[h>>2]|0;i=e;return k|0}}j=c[f>>2]|0;if((d[c[(c[b+36>>2]|0)+16>>2]>>0]|0)!=39){zo(j,43,97248,0,0);k=c[h>>2]|0;i=e;return k|0}me(j);c[g>>2]=c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2];while(1){if(d[198696+(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0)>>0]|0)l=(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0)!=39;else l=0;m=c[f>>2]|0;if(!l)break;me(m)}if((d[c[(c[m+36>>2]|0)+16>>2]>>0]|0)!=39){zo(c[f>>2]|0,44,97216,0,0);k=c[h>>2]|0;i=e;return k|0}else{c[h>>2]=ly(c[g>>2]|0,(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)-(c[g>>2]|0)|0)|0;me(c[f>>2]|0);k=c[h>>2]|0;i=e;return k|0}return 0}function op(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;f=i;i=i+112|0;g=f+96|0;h=f+92|0;j=f+100|0;k=f+88|0;l=f+84|0;m=f+80|0;n=f+76|0;o=f+72|0;p=f+68|0;q=f+64|0;r=f+60|0;s=f+56|0;t=f+52|0;u=f+48|0;v=f+44|0;w=f+40|0;x=f+36|0;y=f+32|0;z=f+28|0;A=f+24|0;B=f+20|0;C=f+16|0;D=f+12|0;E=f+8|0;F=f+4|0;G=f;c[h>>2]=b;a[j>>0]=e;c[k>>2]=0;c[l>>2]=0;c[m>>2]=0;c[n>>2]=0;c[o>>2]=0;c[l>>2]=100;c[k>>2]=Cb[c[135752>>2]&511](c[l>>2]|0)|0;if(!(c[k>>2]|0)){xo(c[h>>2]|0,97424);c[g>>2]=0;H=c[g>>2]|0;i=f;return H|0}c[m>>2]=c[k>>2];a:while(1){if(!(d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0)){I=68;break}if((d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==(d[j>>0]|0|0)){I=68;break}if((d[j>>0]|0|0)==0?(d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==62:0){I=68;break}if(!(d[j>>0]|0)){if((d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==32){I=68;break}if(9<=(d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0){I=68;break}if((d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==13){I=68;break}}if((d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=38){if(((c[m>>2]|0)-(c[k>>2]|0)|0)>((c[l>>2]|0)-100|0)){c[F>>2]=(c[m>>2]|0)-(c[k>>2]|0);c[l>>2]=c[l>>2]<<1;c[G>>2]=Hb[c[135760>>2]&511](c[k>>2]|0,c[l>>2]|0)|0;if(!(c[G>>2]|0)){I=56;break}c[k>>2]=c[G>>2];c[m>>2]=(c[k>>2]|0)+(c[F>>2]|0)}c[C>>2]=ap(c[h>>2]|0,E)|0;e=c[C>>2]|0;do if((c[C>>2]|0)>>>0>=128){b=c[C>>2]|0;if(e>>>0<2048){J=c[m>>2]|0;c[m>>2]=J+1;a[J>>0]=b>>>6&31|192;c[D>>2]=0;break}J=c[C>>2]|0;if(b>>>0<65536){b=c[m>>2]|0;c[m>>2]=b+1;a[b>>0]=J>>>12&15|224;c[D>>2]=6;break}else{b=c[m>>2]|0;c[m>>2]=b+1;a[b>>0]=J>>>18&7|240;c[D>>2]=12;break}}else{J=c[m>>2]|0;c[m>>2]=J+1;a[J>>0]=e;c[D>>2]=-6}while(0);while(1){if((c[D>>2]|0)<0)break;e=((c[C>>2]|0)>>>(c[D>>2]|0)&63|128)&255;J=c[m>>2]|0;c[m>>2]=J+1;a[J>>0]=e;c[D>>2]=(c[D>>2]|0)-6}me(c[h>>2]|0);continue}e=c[h>>2]|0;if((d[(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==35){c[q>>2]=io(e)|0;J=c[q>>2]|0;do if((c[q>>2]|0)>>>0>=128){b=c[q>>2]|0;if(J>>>0<2048){K=c[m>>2]|0;c[m>>2]=K+1;a[K>>0]=b>>>6&31|192;c[r>>2]=0;break}K=c[q>>2]|0;if(b>>>0<65536){b=c[m>>2]|0;c[m>>2]=b+1;a[b>>0]=K>>>12&15|224;c[r>>2]=6;break}else{b=c[m>>2]|0;c[m>>2]=b+1;a[b>>0]=K>>>18&7|240;c[r>>2]=12;break}}else{K=c[m>>2]|0;c[m>>2]=K+1;a[K>>0]=J;c[r>>2]=-6}while(0);while(1){if((c[r>>2]|0)<0)break;J=((c[q>>2]|0)>>>(c[r>>2]|0)&63|128)&255;K=c[m>>2]|0;c[m>>2]=K+1;a[K>>0]=J;c[r>>2]=(c[r>>2]|0)-6}if(((c[m>>2]|0)-(c[k>>2]|0)|0)<=((c[l>>2]|0)-100|0))continue;c[s>>2]=(c[m>>2]|0)-(c[k>>2]|0);c[l>>2]=c[l>>2]<<1;c[t>>2]=Hb[c[135760>>2]&511](c[k>>2]|0,c[l>>2]|0)|0;if(!(c[t>>2]|0)){I=26;break}c[k>>2]=c[t>>2];c[m>>2]=(c[k>>2]|0)+(c[s>>2]|0);continue}c[p>>2]=ho(e,n)|0;if(!(c[n>>2]|0)){J=c[m>>2]|0;c[m>>2]=J+1;a[J>>0]=38;if(((c[m>>2]|0)-(c[k>>2]|0)|0)<=((c[l>>2]|0)-100|0))continue;c[u>>2]=(c[m>>2]|0)-(c[k>>2]|0);c[l>>2]=c[l>>2]<<1;c[v>>2]=Hb[c[135760>>2]&511](c[k>>2]|0,c[l>>2]|0)|0;if(!(c[v>>2]|0)){I=31;break}c[k>>2]=c[v>>2];c[m>>2]=(c[k>>2]|0)+(c[u>>2]|0);continue}J=c[m>>2]|0;if(!(c[p>>2]|0)){c[m>>2]=J+1;a[J>>0]=38;c[o>>2]=c[n>>2];while(1){if(!(d[c[o>>2]>>0]|0))continue a;if(((c[m>>2]|0)-(c[k>>2]|0)|0)>((c[l>>2]|0)-100|0)){c[w>>2]=(c[m>>2]|0)-(c[k>>2]|0);c[l>>2]=c[l>>2]<<1;c[x>>2]=Hb[c[135760>>2]&511](c[k>>2]|0,c[l>>2]|0)|0;if(!(c[x>>2]|0)){I=38;break a}c[k>>2]=c[x>>2];c[m>>2]=(c[k>>2]|0)+(c[w>>2]|0)}K=c[o>>2]|0;c[o>>2]=K+1;b=a[K>>0]|0;K=c[m>>2]|0;c[m>>2]=K+1;a[K>>0]=b}}if((J-(c[k>>2]|0)|0)>((c[l>>2]|0)-100|0)){c[A>>2]=(c[m>>2]|0)-(c[k>>2]|0);c[l>>2]=c[l>>2]<<1;c[B>>2]=Hb[c[135760>>2]&511](c[k>>2]|0,c[l>>2]|0)|0;if(!(c[B>>2]|0)){I=43;break}c[k>>2]=c[B>>2];c[m>>2]=(c[k>>2]|0)+(c[A>>2]|0)}c[y>>2]=c[c[p>>2]>>2];e=c[y>>2]|0;do if((c[y>>2]|0)>>>0>=128){b=c[y>>2]|0;if(e>>>0<2048){K=c[m>>2]|0;c[m>>2]=K+1;a[K>>0]=b>>>6&31|192;c[z>>2]=0;break}K=c[y>>2]|0;if(b>>>0<65536){b=c[m>>2]|0;c[m>>2]=b+1;a[b>>0]=K>>>12&15|224;c[z>>2]=6;break}else{b=c[m>>2]|0;c[m>>2]=b+1;a[b>>0]=K>>>18&7|240;c[z>>2]=12;break}}else{K=c[m>>2]|0;c[m>>2]=K+1;a[K>>0]=e;c[z>>2]=-6}while(0);while(1){if((c[z>>2]|0)<0)continue a;e=((c[y>>2]|0)>>>(c[z>>2]|0)&63|128)&255;J=c[m>>2]|0;c[m>>2]=J+1;a[J>>0]=e;c[z>>2]=(c[z>>2]|0)-6}}if((I|0)==26){xo(c[h>>2]|0,98024);zb[c[135736>>2]&511](c[k>>2]|0);c[g>>2]=0;H=c[g>>2]|0;i=f;return H|0}else if((I|0)==31){xo(c[h>>2]|0,98024);zb[c[135736>>2]&511](c[k>>2]|0);c[g>>2]=0;H=c[g>>2]|0;i=f;return H|0}else if((I|0)==38){xo(c[h>>2]|0,98024);zb[c[135736>>2]&511](c[k>>2]|0);c[g>>2]=0;H=c[g>>2]|0;i=f;return H|0}else if((I|0)==43){xo(c[h>>2]|0,98024);zb[c[135736>>2]&511](c[k>>2]|0);c[g>>2]=0;H=c[g>>2]|0;i=f;return H|0}else if((I|0)==56){xo(c[h>>2]|0,98024);zb[c[135736>>2]&511](c[k>>2]|0);c[g>>2]=0;H=c[g>>2]|0;i=f;return H|0}else if((I|0)==68){a[c[m>>2]>>0]=0;c[g>>2]=c[k>>2];H=c[g>>2]|0;i=f;return H|0}return 0}function pp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=0;while(1){if(c[95744+(c[e>>2]<<3)>>2]|0)f=(qy(c[95744+(c[e>>2]<<3)>>2]|0,c[d>>2]|0)|0)!=0^1;else f=0;g=c[e>>2]|0;if(!f)break;c[e>>2]=g+1}i=b;return c[95748+(g<<3)>>2]|0}function qp(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+32|0;e=b+28|0;f=b+24|0;g=b+20|0;h=b+16|0;j=b+12|0;k=b+8|0;l=b+4|0;m=b;c[f>>2]=a;if(!(c[f>>2]|0)){c[e>>2]=0;n=c[e>>2]|0;i=b;return n|0}c[g>>2]=c[(c[f>>2]|0)+12>>2];while(1){if(!(c[g>>2]|0)){o=11;break}if((c[(c[g>>2]|0)+4>>2]|0)==1?(c[(c[g>>2]|0)+8>>2]|0)!=0:0){if(qy(c[(c[g>>2]|0)+8>>2]|0,120888)|0){o=11;break}if(qy(c[(c[g>>2]|0)+8>>2]|0,120896)|0){o=22;break}if(qy(c[(c[g>>2]|0)+8>>2]|0,120904)|0)break}c[g>>2]=c[(c[g>>2]|0)+24>>2]}a:do if((o|0)==11){if(!(c[g>>2]|0)){c[e>>2]=0;n=c[e>>2]|0;i=b;return n|0}c[g>>2]=c[(c[g>>2]|0)+12>>2];while(1){if(!(c[g>>2]|0))break;if((c[(c[g>>2]|0)+4>>2]|0)==1?(c[(c[g>>2]|0)+8>>2]|0)!=0:0){if(qy(c[(c[g>>2]|0)+8>>2]|0,120896)|0)break;if(qy(c[(c[g>>2]|0)+8>>2]|0,120904)|0)break a}c[g>>2]=c[(c[g>>2]|0)+24>>2]}if(!(c[g>>2]|0)){c[e>>2]=0;n=c[e>>2]|0;i=b;return n|0}else o=22}while(0);if((o|0)==22)c[g>>2]=c[(c[g>>2]|0)+12>>2];b:while(1){if(!(c[g>>2]|0)){o=41;break}c:do if(((c[(c[g>>2]|0)+4>>2]|0)==1?(c[(c[g>>2]|0)+8>>2]|0)!=0:0)?(qy(c[(c[g>>2]|0)+8>>2]|0,120904)|0)!=0:0){c[k>>2]=c[(c[g>>2]|0)+44>>2];c[h>>2]=0;c[l>>2]=0;while(1){if(!(c[k>>2]|0))break c;if(((c[(c[k>>2]|0)+12>>2]|0)!=0?(c[(c[(c[k>>2]|0)+12>>2]|0)+4>>2]|0)==3:0)?(c[(c[(c[k>>2]|0)+12>>2]|0)+24>>2]|0)==0:0){c[m>>2]=c[(c[(c[k>>2]|0)+12>>2]|0)+40>>2];if((ty(c[(c[k>>2]|0)+8>>2]|0,120912)|0)==0?(ty(c[m>>2]|0,120928)|0)==0:0)c[l>>2]=1;else o=35;if(((o|0)==35?(o=0,(c[m>>2]|0)!=0):0)?(ty(c[(c[k>>2]|0)+8>>2]|0,120944)|0)==0:0)c[h>>2]=c[m>>2];if((c[l>>2]|0)!=0&(c[h>>2]|0)!=0)break b}c[k>>2]=c[(c[k>>2]|0)+24>>2]}}while(0);c[g>>2]=c[(c[g>>2]|0)+24>>2]}if((o|0)==41){c[e>>2]=0;n=c[e>>2]|0;i=b;return n|0}c[j>>2]=wy(c[h>>2]|0,120952)|0;if(!(c[j>>2]|0))c[j>>2]=wy(c[h>>2]|0,120968)|0;if(!(c[j>>2]|0))c[j>>2]=wy(c[h>>2]|0,120984)|0;if(!(c[j>>2]|0)){c[j>>2]=wy(c[h>>2]|0,121e3)|0;if(!(c[j>>2]|0))c[j>>2]=wy(c[h>>2]|0,121016)|0;if(!(c[j>>2]|0))c[j>>2]=wy(c[h>>2]|0,121032)|0;if(c[j>>2]|0)c[j>>2]=(c[j>>2]|0)+9}else c[j>>2]=(c[j>>2]|0)+8;d:do if(c[j>>2]|0)while(1){if((d[c[j>>2]>>0]|0|0)!=32?(d[c[j>>2]>>0]|0|0)!=9:0)break d;c[j>>2]=(c[j>>2]|0)+1}while(0);c[e>>2]=c[j>>2];n=c[e>>2]|0;i=b;return n|0}function rp(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+144|0;f=e;g=e+40|0;h=e+36|0;j=e+32|0;k=e+28|0;l=e+24|0;m=e+20|0;n=e+16|0;o=e+44|0;p=e+12|0;q=e+8|0;r=e+4|0;c[h>>2]=b;c[j>>2]=d;c[l>>2]=0;c[m>>2]=0;c[n>>2]=0;a[o>>0]=0;if(!(c[h>>2]|0)){c[g>>2]=-1;s=c[g>>2]|0;i=e;return s|0}if(!(ty(c[j>>2]|0,120888)|0)){c[g>>2]=-1;s=c[g>>2]|0;i=e;return s|0}if(c[j>>2]|0){c[f>>2]=c[j>>2];JT(o,100,121048,f)|0;a[o+99>>0]=0}c[k>>2]=c[(c[h>>2]|0)+12>>2];while(1){if(!(c[k>>2]|0)){t=15;break}if((c[(c[k>>2]|0)+4>>2]|0)==1?(c[(c[k>>2]|0)+8>>2]|0)!=0:0){if(!(ty(c[(c[k>>2]|0)+8>>2]|0,120888)|0)){t=15;break}if(!(ty(c[(c[k>>2]|0)+8>>2]|0,120896)|0)){t=27;break}if(!(ty(c[(c[k>>2]|0)+8>>2]|0,120904)|0)){t=29;break}}c[k>>2]=c[(c[k>>2]|0)+24>>2]}do if((t|0)==15){if(!(c[k>>2]|0)){c[g>>2]=-1;s=c[g>>2]|0;i=e;return s|0}c[k>>2]=c[(c[k>>2]|0)+12>>2];while(1){if(!(c[k>>2]|0))break;if((c[(c[k>>2]|0)+4>>2]|0)==1?(c[(c[k>>2]|0)+8>>2]|0)!=0:0){if(!(ty(c[(c[k>>2]|0)+8>>2]|0,120896)|0))break;if(!(ty(c[(c[k>>2]|0)+8>>2]|0,120904)|0)){t=23;break}}c[k>>2]=c[(c[k>>2]|0)+24>>2]}if((t|0)==23){c[m>>2]=c[(c[k>>2]|0)+20>>2];t=29;break}if(!(c[k>>2]|0)){c[g>>2]=-1;s=c[g>>2]|0;i=e;return s|0}else t=27}while(0);if((t|0)==27?(c[m>>2]=c[k>>2],(c[(c[k>>2]|0)+12>>2]|0)!=0):0){c[k>>2]=c[(c[k>>2]|0)+12>>2];t=29}a:do if((t|0)==29){while(1){t=0;if(!(c[k>>2]|0))break a;if(((c[(c[k>>2]|0)+4>>2]|0)==1?(c[(c[k>>2]|0)+8>>2]|0)!=0:0)?(ty(c[(c[k>>2]|0)+8>>2]|0,120904)|0)==0:0){c[p>>2]=c[(c[k>>2]|0)+44>>2];c[n>>2]=0;c[q>>2]=0;while(1){if(!(c[p>>2]|0))break;if(((c[(c[p>>2]|0)+12>>2]|0)!=0?(c[(c[(c[p>>2]|0)+12>>2]|0)+4>>2]|0)==3:0)?(c[(c[(c[p>>2]|0)+12>>2]|0)+24>>2]|0)==0:0){c[r>>2]=c[(c[(c[p>>2]|0)+12>>2]|0)+40>>2];if((ty(c[(c[p>>2]|0)+8>>2]|0,120912)|0)==0?(ty(c[r>>2]|0,120928)|0)==0:0)c[q>>2]=1;else t=41;
if(((t|0)==41?(t=0,(c[r>>2]|0)!=0):0)?(ty(c[(c[p>>2]|0)+8>>2]|0,120944)|0)==0:0)c[n>>2]=c[r>>2];if((c[q>>2]|0)!=0&(c[n>>2]|0)!=0)break}c[p>>2]=c[(c[p>>2]|0)+24>>2]}if((c[q>>2]|0)!=0&(c[n>>2]|0)!=0)break}c[k>>2]=c[(c[k>>2]|0)+24>>2];t=29}c[l>>2]=c[k>>2]}while(0);k=c[j>>2]|0;do if(!(c[l>>2]|0)){if((k|0)!=0&(c[m>>2]|0)!=0){c[l>>2]=ji(c[h>>2]|0,0,120904,0)|0;t=c[m>>2]|0;if(!(c[(c[m>>2]|0)+12>>2]|0))zi(t,c[l>>2]|0)|0;else wi(c[t+12>>2]|0,c[l>>2]|0)|0;$h(c[l>>2]|0,120912,120928)|0;$h(c[l>>2]|0,120944,o)|0}}else{if(!k){Qh(c[l>>2]|0);Rh(c[l>>2]|0);break}if(!(yy(c[n>>2]|0,c[j>>2]|0)|0))gj(c[l>>2]|0,120944,o)|0}while(0);c[g>>2]=0;s=c[g>>2]|0;i=e;return s|0}function sp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=0;while(1){if(!(c[121072+(c[f>>2]<<2)>>2]|0)){g=6;break}if(!(ty(c[121072+(c[f>>2]<<2)>>2]|0,c[e>>2]|0)|0)){g=4;break}c[f>>2]=(c[f>>2]|0)+1}if((g|0)==4){c[d>>2]=1;h=c[d>>2]|0;i=b;return h|0}else if((g|0)==6){c[d>>2]=0;h=c[d>>2]|0;i=b;return h|0}return 0}function tp(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+48|0;h=g+36|0;j=g+32|0;k=g+28|0;l=g+24|0;m=g+20|0;n=g+16|0;o=g+12|0;p=g+8|0;q=g+4|0;r=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[p>>2]=0;Rf();if(((c[m>>2]|0)!=0?(c[r>>2]=wd(c[m>>2]|0)|0,(c[r>>2]|0)!=1):0)?(c[p>>2]=Dd(c[m>>2]|0)|0,(c[p>>2]|0)==0):0)Cp(1403,0,c[m>>2]|0);if(!(c[p>>2]|0))c[p>>2]=Dd(121128)|0;if(!(c[p>>2]|0))c[p>>2]=Dd(121136)|0;c[o>>2]=Fk(c[j>>2]|0,c[p>>2]|0)|0;if(!(c[o>>2]|0)){c[h>>2]=0;s=c[h>>2]|0;i=g;return s|0}else{up(c[o>>2]|0,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0);c[q>>2]=zk(c[o>>2]|0)|0;c[h>>2]=c[q>>2];s=c[h>>2]|0;i=g;return s|0}return 0}function up(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+32|0;k=j+24|0;l=j+20|0;m=j+16|0;n=j+12|0;o=j+8|0;p=j+4|0;q=j;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;c[o>>2]=h;Rf();if((c[m>>2]|0)==0|(c[k>>2]|0)==0){i=j;return}if((c[(c[m>>2]|0)+4>>2]|0)==14){i=j;return}if((c[(c[m>>2]|0)+4>>2]|0)!=13?(c[(c[m>>2]|0)+4>>2]|0)!=9:0){if((c[(c[m>>2]|0)+4>>2]|0)==2){Dp(c[k>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0);i=j;return}h=c[m>>2]|0;if((c[(c[m>>2]|0)+4>>2]|0)==3){if(!(c[h+40>>2]|0)){i=j;return}if(!((c[(c[m>>2]|0)+8>>2]|0)!=75104?(c[(c[m>>2]|0)+8>>2]|0)==75112:0))r=12;do if((r|0)==12){if(c[(c[m>>2]|0)+20>>2]|0){if(!(ty(c[(c[(c[m>>2]|0)+20>>2]|0)+8>>2]|0,121144)|0))break;if(!(ty(c[(c[(c[m>>2]|0)+20>>2]|0)+8>>2]|0,121152)|0))break}c[q>>2]=cd(c[l>>2]|0,c[(c[m>>2]|0)+40>>2]|0)|0;if(!(c[q>>2]|0)){i=j;return}Qk(c[k>>2]|0,c[q>>2]|0)|0;zb[c[135736>>2]&511](c[q>>2]|0);i=j;return}while(0);Qk(c[k>>2]|0,c[(c[m>>2]|0)+40>>2]|0)|0;i=j;return}q=c[m>>2]|0;if((c[h+4>>2]|0)==8){if(!(c[q+40>>2]|0)){i=j;return}Qk(c[k>>2]|0,121160)|0;Qk(c[k>>2]|0,c[(c[m>>2]|0)+40>>2]|0)|0;Qk(c[k>>2]|0,121168)|0;i=j;return}h=c[m>>2]|0;if((c[q+4>>2]|0)==7){if(!(c[h+8>>2]|0)){i=j;return}Qk(c[k>>2]|0,121176)|0;Qk(c[k>>2]|0,c[(c[m>>2]|0)+8>>2]|0)|0;if(c[(c[m>>2]|0)+40>>2]|0){Qk(c[k>>2]|0,121184)|0;Qk(c[k>>2]|0,c[(c[m>>2]|0)+40>>2]|0)|0}Qk(c[k>>2]|0,121192)|0;i=j;return}if((c[h+4>>2]|0)==5){Qk(c[k>>2]|0,121200)|0;Qk(c[k>>2]|0,c[(c[m>>2]|0)+8>>2]|0)|0;Qk(c[k>>2]|0,121208)|0;i=j;return}h=c[m>>2]|0;if((c[(c[m>>2]|0)+4>>2]|0)==4){if(!(c[h+40>>2]|0)){i=j;return}Qk(c[k>>2]|0,c[(c[m>>2]|0)+40>>2]|0)|0;i=j;return}if(!(c[h+36>>2]|0))c[p>>2]=bo(c[(c[m>>2]|0)+8>>2]|0)|0;else c[p>>2]=0;Qk(c[k>>2]|0,121216)|0;if((c[(c[m>>2]|0)+36>>2]|0)!=0?(c[(c[(c[m>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){Qk(c[k>>2]|0,c[(c[(c[m>>2]|0)+36>>2]|0)+12>>2]|0)|0;Qk(c[k>>2]|0,121224)|0}Qk(c[k>>2]|0,c[(c[m>>2]|0)+8>>2]|0)|0;if(c[(c[m>>2]|0)+48>>2]|0)qR(c[k>>2]|0,c[(c[m>>2]|0)+48>>2]|0);if(c[(c[m>>2]|0)+44>>2]|0)Ep(c[k>>2]|0,c[l>>2]|0,c[(c[m>>2]|0)+44>>2]|0,c[n>>2]|0);if((c[p>>2]|0)!=0?(a[(c[p>>2]|0)+7>>0]|0)!=0:0){Qk(c[k>>2]|0,121192)|0;if(!(c[o>>2]|0)){i=j;return}if(a[(c[p>>2]|0)+10>>0]|0){i=j;return}if(!(c[(c[m>>2]|0)+24>>2]|0)){i=j;return}if((c[(c[(c[m>>2]|0)+24>>2]|0)+4>>2]|0)==3){i=j;return}if((c[(c[(c[m>>2]|0)+24>>2]|0)+4>>2]|0)==5){i=j;return}if(!(c[(c[m>>2]|0)+20>>2]|0)){i=j;return}if(!(c[(c[(c[m>>2]|0)+20>>2]|0)+8>>2]|0)){i=j;return}if((d[c[(c[(c[m>>2]|0)+20>>2]|0)+8>>2]>>0]|0)==112){i=j;return}Qk(c[k>>2]|0,121232)|0;i=j;return}if(!((c[(c[m>>2]|0)+4>>2]|0)!=1?(c[(c[m>>2]|0)+40>>2]|0)!=0:0))r=54;if((r|0)==54?(c[(c[m>>2]|0)+12>>2]|0)==0:0){do if(c[p>>2]|0){if(!(a[(c[p>>2]|0)+6>>0]|0)){r=60;break}if(!(py(c[c[p>>2]>>2]|0,120888)|0)){r=60;break}if(!(py(c[c[p>>2]>>2]|0,121240)|0)){r=60;break}Qk(c[k>>2]|0,121192)|0}else r=60;while(0);if((r|0)==60){Qk(c[k>>2]|0,121248)|0;do if(c[(c[m>>2]|0)+36>>2]|0){if(!(c[(c[(c[m>>2]|0)+36>>2]|0)+12>>2]|0))break;Qk(c[k>>2]|0,c[(c[(c[m>>2]|0)+36>>2]|0)+12>>2]|0)|0;Qk(c[k>>2]|0,121224)|0}while(0);Qk(c[k>>2]|0,c[(c[m>>2]|0)+8>>2]|0)|0;Qk(c[k>>2]|0,121192)|0}if(!(c[o>>2]|0)){i=j;return}if(!((c[p>>2]|0)!=0?(c[(c[m>>2]|0)+24>>2]|0)!=0:0)){i=j;return}if(a[(c[p>>2]|0)+10>>0]|0){i=j;return}if((c[(c[(c[m>>2]|0)+24>>2]|0)+4>>2]|0)==3){i=j;return}if((c[(c[(c[m>>2]|0)+24>>2]|0)+4>>2]|0)==5){i=j;return}if(!(c[(c[m>>2]|0)+20>>2]|0)){i=j;return}if(!(c[(c[(c[m>>2]|0)+20>>2]|0)+8>>2]|0)){i=j;return}if((d[c[(c[(c[m>>2]|0)+20>>2]|0)+8>>2]>>0]|0)==112){i=j;return}Qk(c[k>>2]|0,121232)|0;i=j;return}Qk(c[k>>2]|0,121192)|0;if((c[(c[m>>2]|0)+4>>2]|0)!=1?(c[(c[m>>2]|0)+40>>2]|0)!=0:0)Qk(c[k>>2]|0,c[(c[m>>2]|0)+40>>2]|0)|0;do if(c[(c[m>>2]|0)+12>>2]|0){do if((c[o>>2]|0)!=0&(c[p>>2]|0)!=0){if(a[(c[p>>2]|0)+10>>0]|0)break;if((c[(c[(c[m>>2]|0)+12>>2]|0)+4>>2]|0)==3)break;if((c[(c[(c[m>>2]|0)+12>>2]|0)+4>>2]|0)==5)break;if((c[(c[m>>2]|0)+12>>2]|0)==(c[(c[m>>2]|0)+16>>2]|0))break;if(!(c[(c[m>>2]|0)+8>>2]|0))break;if((d[c[(c[m>>2]|0)+8>>2]>>0]|0)==112)break;Qk(c[k>>2]|0,121232)|0}while(0);Fp(c[k>>2]|0,c[l>>2]|0,c[(c[m>>2]|0)+12>>2]|0,c[n>>2]|0,c[o>>2]|0);if(!((c[o>>2]|0)!=0&(c[p>>2]|0)!=0))break;if(a[(c[p>>2]|0)+10>>0]|0)break;if((c[(c[(c[m>>2]|0)+16>>2]|0)+4>>2]|0)==3)break;if((c[(c[(c[m>>2]|0)+16>>2]|0)+4>>2]|0)==5)break;if((c[(c[m>>2]|0)+12>>2]|0)==(c[(c[m>>2]|0)+16>>2]|0))break;if(!(c[(c[m>>2]|0)+8>>2]|0))break;if((d[c[(c[m>>2]|0)+8>>2]>>0]|0)==112)break;Qk(c[k>>2]|0,121232)|0}while(0);Qk(c[k>>2]|0,121256)|0;do if(c[(c[m>>2]|0)+36>>2]|0){if(!(c[(c[(c[m>>2]|0)+36>>2]|0)+12>>2]|0))break;Qk(c[k>>2]|0,c[(c[(c[m>>2]|0)+36>>2]|0)+12>>2]|0)|0;Qk(c[k>>2]|0,121224)|0}while(0);Qk(c[k>>2]|0,c[(c[m>>2]|0)+8>>2]|0)|0;Qk(c[k>>2]|0,121192)|0;if(!((c[o>>2]|0)!=0&(c[p>>2]|0)!=0)){i=j;return}if(a[(c[p>>2]|0)+10>>0]|0){i=j;return}if(!(c[(c[m>>2]|0)+24>>2]|0)){i=j;return}if((c[(c[(c[m>>2]|0)+24>>2]|0)+4>>2]|0)==3){i=j;return}if((c[(c[(c[m>>2]|0)+24>>2]|0)+4>>2]|0)==5){i=j;return}if(!(c[(c[m>>2]|0)+20>>2]|0)){i=j;return}if(!(c[(c[(c[m>>2]|0)+20>>2]|0)+8>>2]|0)){i=j;return}if((d[c[(c[(c[m>>2]|0)+20>>2]|0)+8>>2]>>0]|0)==112){i=j;return}Qk(c[k>>2]|0,121232)|0;i=j;return}xp(c[k>>2]|0,c[m>>2]|0,c[n>>2]|0);i=j;return}function vp(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;tp(c[f>>2]|0,c[g>>2]|0,c[h>>2]|0,0,1)|0;i=e;return}function wp(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;Rf();if((c[g>>2]|0)==0|(c[h>>2]|0)==0){i=f;return}c[l>>2]=c[(c[h>>2]|0)+4>>2];c[(c[h>>2]|0)+4>>2]=13;if(c[(c[h>>2]|0)+44>>2]|0)Gp(c[g>>2]|0,c[h>>2]|0,0);if(c[(c[h>>2]|0)+12>>2]|0)Fp(c[g>>2]|0,c[h>>2]|0,c[(c[h>>2]|0)+12>>2]|0,c[j>>2]|0,c[k>>2]|0);Qk(c[g>>2]|0,121232)|0;c[(c[h>>2]|0)+4>>2]=c[l>>2];i=f;return}function xp(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;wp(c[f>>2]|0,c[g>>2]|0,c[h>>2]|0,1);i=e;return}function yp(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;up(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,1);i=f;return}function zp(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+28|0;f=d+24|0;g=d+20|0;h=d+16|0;j=d+12|0;k=d+8|0;l=d+4|0;m=d;c[f>>2]=a;c[g>>2]=b;c[j>>2]=0;Rf();if((c[g>>2]|0)==0|(c[f>>2]|0)==0){c[e>>2]=-1;n=c[e>>2]|0;i=d;return n|0}c[k>>2]=qp(c[g>>2]|0)|0;do if(c[k>>2]|0){c[m>>2]=wd(c[k>>2]|0)|0;if((c[m>>2]|0)==(c[(c[g>>2]|0)+76>>2]|0)){c[j>>2]=Dd(c[k>>2]|0)|0;break}if((c[(c[g>>2]|0)+76>>2]|0)!=1){c[e>>2]=-1;n=c[e>>2]|0;i=d;return n|0}else{c[j>>2]=Dd(c[k>>2]|0)|0;if(c[j>>2]|0)break;Cp(1403,0,c[k>>2]|0);break}}while(0);if(!(c[j>>2]|0))c[j>>2]=Dd(121128)|0;if(!(c[j>>2]|0))c[j>>2]=Dd(121136)|0;c[h>>2]=Fk(c[f>>2]|0,c[j>>2]|0)|0;if(!(c[h>>2]|0)){c[e>>2]=-1;n=c[e>>2]|0;i=d;return n|0}else{xp(c[h>>2]|0,c[g>>2]|0,0);c[l>>2]=zk(c[h>>2]|0)|0;c[e>>2]=c[l>>2];n=c[e>>2]|0;i=d;return n|0}return 0}function Ap(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+28|0;f=d+24|0;g=d+20|0;h=d+16|0;j=d+12|0;k=d+8|0;l=d+4|0;m=d;c[f>>2]=a;c[g>>2]=b;c[j>>2]=0;if((c[g>>2]|0)==0|(c[f>>2]|0)==0){c[e>>2]=-1;n=c[e>>2]|0;i=d;return n|0}Rf();c[k>>2]=qp(c[g>>2]|0)|0;do if((c[k>>2]|0)!=0?(c[m>>2]=wd(c[k>>2]|0)|0,(c[m>>2]|0)!=(c[(c[g>>2]|0)+76>>2]|0)):0)if((c[(c[g>>2]|0)+76>>2]|0)!=1){c[e>>2]=-1;n=c[e>>2]|0;i=d;return n|0}else{c[j>>2]=Dd(c[k>>2]|0)|0;if(c[j>>2]|0)break;Cp(1403,0,c[k>>2]|0);break}while(0);if(!(c[j>>2]|0))c[j>>2]=Dd(121128)|0;if(!(c[j>>2]|0))c[j>>2]=Dd(121136)|0;c[h>>2]=Ek(c[f>>2]|0,c[j>>2]|0,c[(c[g>>2]|0)+36>>2]|0)|0;if(!(c[h>>2]|0)){c[e>>2]=0;n=c[e>>2]|0;i=d;return n|0}else{xp(c[h>>2]|0,c[g>>2]|0,0);c[l>>2]=zk(c[h>>2]|0)|0;c[e>>2]=c[l>>2];n=c[e>>2]|0;i=d;return n|0}return 0}function Bp(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+48|0;g=f+32|0;h=f+28|0;j=f+24|0;k=f+20|0;l=f+16|0;m=f+12|0;n=f+8|0;o=f+4|0;p=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[n>>2]=0;if((c[j>>2]|0)==0|(c[h>>2]|0)==0){c[g>>2]=-1;q=c[g>>2]|0;i=f;return q|0}Rf();if(c[k>>2]|0){c[p>>2]=wd(c[k>>2]|0)|0;do if((c[p>>2]|0)!=(c[(c[j>>2]|0)+76>>2]|0))if((c[(c[j>>2]|0)+76>>2]|0)!=1){c[g>>2]=-1;q=c[g>>2]|0;i=f;return q|0}else{c[n>>2]=Dd(c[k>>2]|0)|0;if(c[n>>2]|0)break;Cp(1403,0,c[k>>2]|0);break}while(0);rp(c[j>>2]|0,c[k>>2]|0)|0}else rp(c[j>>2]|0,121264)|0;if(!(c[n>>2]|0))c[n>>2]=Dd(121128)|0;if(!(c[n>>2]|0))c[n>>2]=Dd(121136)|0;c[m>>2]=Ek(c[h>>2]|0,c[n>>2]|0,0)|0;if(!(c[m>>2]|0)){c[g>>2]=0;q=c[g>>2]|0;i=f;return q|0}else{wp(c[m>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0);c[o>>2]=zk(c[m>>2]|0)|0;c[g>>2]=c[o>>2];q=c[g>>2]|0;i=f;return q|0}return 0}function Cp(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=0;d=c[f>>2]|0;if((d|0)==1402)c[j>>2]=121488;else if((d|0)==1401)c[j>>2]=121432;else if((d|0)==1400)c[j>>2]=121408;else if((d|0)==1403)c[j>>2]=121464;else c[j>>2]=121512;ce(7,c[f>>2]|0,c[g>>2]|0,c[j>>2]|0,c[h>>2]|0);i=e;return}function Dp(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+48|0;j=h+32|0;k=h+28|0;l=h+24|0;m=h+16|0;n=h+12|0;o=h+8|0;p=h+36|0;q=h+4|0;r=h;c[j>>2]=b;c[k>>2]=e;c[l>>2]=f;c[h+20>>2]=g;if(!(c[l>>2]|0)){i=h;return}Qk(c[j>>2]|0,121184)|0;if((c[(c[l>>2]|0)+36>>2]|0)!=0?(c[(c[(c[l>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){Qk(c[j>>2]|0,c[(c[(c[l>>2]|0)+36>>2]|0)+12>>2]|0)|0;Qk(c[j>>2]|0,121224)|0}Qk(c[j>>2]|0,c[(c[l>>2]|0)+8>>2]|0)|0;if(!(c[(c[l>>2]|0)+12>>2]|0)){i=h;return}if(sp(c[(c[l>>2]|0)+8>>2]|0)|0){i=h;return}c[m>>2]=_h(c[k>>2]|0,c[(c[l>>2]|0)+12>>2]|0,0)|0;k=c[j>>2]|0;if(!(c[m>>2]|0)){Qk(k,121400)|0;i=h;return}Qk(k,121328)|0;do if(((c[(c[l>>2]|0)+36>>2]|0)==0?(c[(c[l>>2]|0)+20>>2]|0)!=0:0)?(c[(c[(c[l>>2]|0)+20>>2]|0)+36>>2]|0)==0:0){if(((ty(c[(c[l>>2]|0)+8>>2]|0,121336)|0)!=0?(ty(c[(c[l>>2]|0)+8>>2]|0,121344)|0)!=0:0)?(ty(c[(c[l>>2]|0)+8>>2]|0,121352)|0)!=0:0){if(ty(c[(c[l>>2]|0)+8>>2]|0,121360)|0){s=31;break}if(ty(c[(c[(c[l>>2]|0)+20>>2]|0)+8>>2]|0,121368)|0){s=31;break}}c[n>>2]=c[m>>2];fz(c[(c[j>>2]|0)+16>>2]|0,121376)|0;a:while(1){do if((d[c[n>>2]>>0]|0|0)!=32){if(9<=(d[c[n>>2]>>0]|0|0)?(d[c[n>>2]>>0]|0|0)<=10:0)break;if((d[c[n>>2]>>0]|0|0)!=13)break a}while(0);c[n>>2]=(c[n>>2]|0)+1}while(1){c[q>>2]=0;c[r>>2]=wy(c[n>>2]|0,121160)|0;if((c[r>>2]|0)!=0?(c[q>>2]=wy(c[n>>2]|0,121168)|0,(c[q>>2]|0)!=0):0)a[c[r>>2]>>0]=0;c[o>>2]=Fl(c[n>>2]|0,121384)|0;k=c[(c[j>>2]|0)+16>>2]|0;if(c[o>>2]|0){ez(k,c[o>>2]|0)|0;zb[c[135736>>2]&511](c[o>>2]|0)}else ez(k,c[n>>2]|0)|0;if(!(c[q>>2]|0))break;a[c[r>>2]>>0]=60;c[q>>2]=(c[q>>2]|0)+3;a[p>>0]=a[c[q>>2]>>0]|0;a[c[q>>2]>>0]=0;ez(c[(c[j>>2]|0)+16>>2]|0,c[r>>2]|0)|0;a[c[q>>2]>>0]=a[p>>0]|0;c[n>>2]=c[q>>2]}fz(c[(c[j>>2]|0)+16>>2]|0,121376)|0}else s=31;while(0);if((s|0)==31)gz(c[(c[j>>2]|0)+16>>2]|0,c[m>>2]|0)|0;zb[c[135736>>2]&511](c[m>>2]|0);i=h;return}function Ep(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;if(!((c[j>>2]|0)!=0&(c[j>>2]|0)!=0)){i=f;return}do{Dp(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0);c[j>>2]=c[(c[j>>2]|0)+24>>2]}while((c[j>>2]|0)!=0);i=f;return}function Fp(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+32|0;h=g+16|0;j=g+12|0;k=g+8|0;l=g+4|0;m=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;if(!((c[k>>2]|0)!=0&(c[k>>2]|0)!=0)){i=g;return}do{up(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0);c[k>>2]=c[(c[k>>2]|0)+24>>2]}while((c[k>>2]|0)!=0);i=g;return}function Gp(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e;c[f>>2]=a;c[g>>2]=b;c[e+4>>2]=d;c[h>>2]=c[(c[g>>2]|0)+44>>2];if(!(c[h>>2]|0)){Cp(1402,c[g>>2]|0,0);i=e;return}Qk(c[f>>2]|0,121272)|0;Qk(c[f>>2]|0,c[(c[h>>2]|0)+8>>2]|0)|0;if(c[(c[h>>2]|0)+52>>2]|0){Qk(c[f>>2]|0,121288)|0;gz(c[(c[f>>2]|0)+16>>2]|0,c[(c[h>>2]|0)+52>>2]|0)|0;if(c[(c[h>>2]|0)+56>>2]|0){Qk(c[f>>2]|0,121184)|0;gz(c[(c[f>>2]|0)+16>>2]|0,c[(c[h>>2]|0)+56>>2]|0)|0}}else if(c[(c[h>>2]|0)+56>>2]|0){Qk(c[f>>2]|0,121304)|0;gz(c[(c[f>>2]|0)+16>>2]|0,c[(c[h>>2]|0)+56>>2]|0)|0}Qk(c[f>>2]|0,121320)|0;i=e;return}function Hp(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=e+12|0;h=e+8|0;j=e+4|0;c[g>>2]=a;c[h>>2]=b;if(!(c[g>>2]|0))c[g>>2]=c[q>>2];if(!(c[h>>2]|0)){Ka(c[g>>2]|0,121688,f|0)|0;i=e;return}c[j>>2]=0;while(1){if((c[j>>2]|0)>=40)break;if(!(d[(c[h>>2]|0)+(c[j>>2]|0)>>0]|0)){k=18;break}do if((d[(c[h>>2]|0)+(c[j>>2]|0)>>0]|0|0)!=32){if(9<=(d[(c[h>>2]|0)+(c[j>>2]|0)>>0]|0|0)?(d[(c[h>>2]|0)+(c[j>>2]|0)>>0]|0|0)<=10:0){k=12;break}if((d[(c[h>>2]|0)+(c[j>>2]|0)>>0]|0|0)!=13)if((d[(c[h>>2]|0)+(c[j>>2]|0)>>0]|0|0)>=128){b=c[g>>2]|0;c[f>>2]=d[(c[h>>2]|0)+(c[j>>2]|0)>>0];Ka(b|0,121696,f|0)|0;break}else{fb(d[(c[h>>2]|0)+(c[j>>2]|0)>>0]|0|0,c[g>>2]|0)|0;break}else k=12}else k=12;while(0);if((k|0)==12){k=0;fb(32,c[g>>2]|0)|0}c[j>>2]=(c[j>>2]|0)+1}if((k|0)==18){i=e;return}Ka(c[g>>2]|0,121704,f|0)|0;i=e;return}function Ip(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+160|0;f=e+148|0;g=e+144|0;h=e+140|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if(!(c[f>>2]|0)){i=e;return}_p(j);c[j>>2]=c[f>>2];c[j+108>>2]=c[h>>2];$p(j,c[g>>2]|0);aq(j);i=e;return}function Jp(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+160|0;e=d+144|0;f=d+140|0;g=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}_p(g);c[g>>2]=c[e>>2];bq(g,c[f>>2]|0);aq(g);i=d;return}function Kp(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+160|0;f=e+148|0;g=e+144|0;h=e+140|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if(!(c[f>>2]|0)){i=e;return}_p(j);c[j>>2]=c[f>>2];c[j+108>>2]=c[h>>2];dq(j,c[g>>2]|0);aq(j);i=e;return}function Lp(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+160|0;e=d+144|0;f=d+140|0;g=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0))c[e>>2]=c[q>>2];_p(g);b=g+136|0;c[b>>2]=c[b>>2]|1;c[g>>2]=c[e>>2];gq(g,c[f>>2]|0);aq(g);i=d;return}function Mp(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+160|0;e=d+144|0;f=d+140|0;g=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0))c[e>>2]=c[q>>2];_p(g);b=g+136|0;c[b>>2]=c[b>>2]|1;c[g>>2]=c[e>>2];hq(g,c[f>>2]|0);aq(g);i=d;return}function Np(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;c[f>>2]=0;c[g>>2]=0;if(!(c[e>>2]|0)){c[d>>2]=0;h=c[d>>2]|0;i=b;return h|0}switch(c[(c[e>>2]|0)+4>>2]|0){case 21:case 13:case 9:{c[g>>2]=c[(c[e>>2]|0)+12>>2];break}case 20:case 19:case 18:case 17:case 16:case 15:case 14:case 12:case 11:case 6:case 10:case 5:{c[f>>2]=1;break}case 1:{c[g>>2]=c[(c[e>>2]|0)+12>>2];break}case 2:{c[g>>2]=c[(c[e>>2]|0)+12>>2];break}case 8:case 7:case 4:case 3:{if(c[(c[e>>2]|0)+40>>2]|0)c[f>>2]=xy(c[(c[e>>2]|0)+40>>2]|0)|0;break}default:{}}while(1){if(!(c[g>>2]|0))break;c[g>>2]=c[(c[g>>2]|0)+24>>2];c[f>>2]=(c[f>>2]|0)+1}c[d>>2]=c[f>>2];h=c[d>>2]|0;i=b;return h|0}function Op(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+16|0;g=d+12|0;h=d+8|0;c[f>>2]=a;c[g>>2]=b;if(!(c[f>>2]|0)){i=d;return}if(!(c[g>>2]|0)){Ka(c[f>>2]|0,121712,e|0)|0;i=d;return}do switch(c[(c[g>>2]|0)+4>>2]|0){case 4:{Ka(c[f>>2]|0,121744,e|0)|0;break}case 8:{Ka(c[f>>2]|0,121776,e|0)|0;break}case 12:{Ka(c[f>>2]|0,121816,e|0)|0;break}case 10:{Ka(c[f>>2]|0,121800,e|0)|0;break}case 3:{Ka(c[f>>2]|0,121736,e|0)|0;break}case 13:{Ka(c[f>>2]|0,121792,e|0)|0;break}case 11:{Ka(c[f>>2]|0,121808,e|0)|0;break}case 18:{Ka(c[f>>2]|0,121824,e|0)|0;break}case 6:{Ka(c[f>>2]|0,121760,e|0)|0;break}case 2:{Ka(c[f>>2]|0,121728,e|0)|0;break}case 7:{Ka(c[f>>2]|0,121768,e|0)|0;break}case 1:{Ka(c[f>>2]|0,121720,e|0)|0;break}case 5:{Ka(c[f>>2]|0,121752,e|0)|0;break}case 9:{Ka(c[f>>2]|0,121784,e|0)|0;break}default:Ka(c[f>>2]|0,121832,e|0)|0}while(0);do if((c[(c[g>>2]|0)+4>>2]|0)!=18){b=c[f>>2]|0;if(c[(c[g>>2]|0)+44>>2]|0)Ka(b|0,121728,e|0)|0;else Ka(b|0,121720,e|0)|0;b=c[f>>2]|0;if(c[(c[g>>2]|0)+48>>2]|0){Ka(b|0,121824,e|0)|0;break}else{Ka(b|0,121720,e|0)|0;break}}while(0);b=c[f>>2]|0;c[e>>2]=Np(c[g>>2]|0)|0;Ka(b|0,121840,e|0)|0;a:do switch(c[(c[g>>2]|0)+4>>2]|0){case 1:{if(c[(c[g>>2]|0)+8>>2]|0){if((c[(c[g>>2]|0)+36>>2]|0)!=0?(c[(c[(c[g>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){b=c[f>>2]|0;c[e>>2]=c[(c[(c[g>>2]|0)+36>>2]|0)+12>>2];Ka(b|0,121848,e|0)|0}b=c[f>>2]|0;c[e>>2]=c[(c[g>>2]|0)+8>>2];Ka(b|0,121856,e|0)|0}break}case 6:{if(c[(c[g>>2]|0)+8>>2]|0){b=c[f>>2]|0;c[e>>2]=c[(c[g>>2]|0)+8>>2];Ka(b|0,121856,e|0)|0}break}case 2:{if(c[(c[g>>2]|0)+8>>2]|0){b=c[f>>2]|0;c[e>>2]=c[(c[g>>2]|0)+8>>2];Ka(b|0,121856,e|0)|0}break}case 5:{if(c[(c[g>>2]|0)+8>>2]|0){b=c[f>>2]|0;c[e>>2]=c[(c[g>>2]|0)+8>>2];Ka(b|0,121856,e|0)|0}break}case 12:case 11:case 10:case 13:case 9:case 8:case 4:break;case 3:{if(c[(c[g>>2]|0)+40>>2]|0)Hp(c[f>>2]|0,c[(c[g>>2]|0)+40>>2]|0);break}case 7:{if(c[(c[g>>2]|0)+8>>2]|0){b=c[f>>2]|0;c[e>>2]=c[(c[g>>2]|0)+8>>2];Ka(b|0,121856,e|0)|0}break}case 18:{c[h>>2]=c[g>>2];b=c[f>>2]|0;a=c[h>>2]|0;if(!(c[(c[h>>2]|0)+12>>2]|0)){c[e>>2]=c[a+8>>2];Ka(b|0,121864,e|0)|0;break a}else{j=c[(c[h>>2]|0)+8>>2]|0;c[e>>2]=c[a+12>>2];c[e+4>>2]=j;Ka(b|0,121880,e|0)|0;break a}break}default:if(c[(c[g>>2]|0)+8>>2]|0){b=c[f>>2]|0;c[e>>2]=c[(c[g>>2]|0)+8>>2];Ka(b|0,121856,e|0)|0}}while(0);Ka(c[f>>2]|0,121896,e|0)|0;i=d;return}function Pp(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+12|0;k=f+4|0;c[h>>2]=a;c[f+16>>2]=b;c[j>>2]=d;c[f+8>>2]=e;if(!(c[h>>2]|0)){c[g>>2]=0;l=c[g>>2]|0;i=f;return l|0}if(!(c[j>>2]|0)){Ka(c[(c[h>>2]|0)+20>>2]|0,121712,f|0)|0;c[g>>2]=0;l=c[g>>2]|0;i=f;return l|0}do if((c[(c[j>>2]|0)+4>>2]|0)!=9?(c[(c[j>>2]|0)+4>>2]|0)!=13:0){if((c[(c[j>>2]|0)+4>>2]|0)==18){Op(c[(c[h>>2]|0)+20>>2]|0,c[j>>2]|0);c[g>>2]=0;l=c[g>>2]|0;i=f;return l|0}if(c[(c[j>>2]|0)+12>>2]|0){c[k>>2]=c[(c[j>>2]|0)+12>>2];break}Op(c[(c[h>>2]|0)+20>>2]|0,c[j>>2]|0);c[g>>2]=0;l=c[g>>2]|0;i=f;return l|0}else m=7;while(0);if((m|0)==7)c[k>>2]=c[(c[j>>2]|0)+12>>2];while(1){if(!(c[k>>2]|0))break;Op(c[(c[h>>2]|0)+20>>2]|0,c[k>>2]|0);c[k>>2]=c[(c[k>>2]|0)+24>>2]}c[g>>2]=0;l=c[g>>2]|0;i=f;return l|0}function Qp(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f;h=f+24|0;j=f+20|0;k=f+12|0;l=f+4|0;c[j>>2]=a;c[f+16>>2]=b;c[k>>2]=d;c[f+8>>2]=e;if(!(c[j>>2]|0)){c[h>>2]=0;m=c[h>>2]|0;i=f;return m|0}if(!(c[k>>2]|0)){Ka(c[(c[j>>2]|0)+20>>2]|0,121712,g|0)|0;c[h>>2]=0;m=c[h>>2]|0;i=f;return m|0}c[l>>2]=Xi(c[(c[k>>2]|0)+32>>2]|0,c[k>>2]|0)|0;k=c[(c[j>>2]|0)+20>>2]|0;if(!(c[l>>2]|0))Ka(k|0,122072,g|0)|0;else{c[g>>2]=c[l>>2];Ka(k|0,122096,g|0)|0;zb[c[135736>>2]&511](c[l>>2]|0)}c[h>>2]=0;m=c[h>>2]|0;i=f;return m|0}function Rp(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+8|0;c[h>>2]=a;c[f+12>>2]=b;c[j>>2]=d;c[f+4>>2]=e;if(!(c[h>>2]|0)){c[g>>2]=0;k=c[g>>2]|0;i=f;return k|0}if(!(c[j>>2]|0)){Ka(c[(c[h>>2]|0)+20>>2]|0,121712,f|0)|0;c[g>>2]=0;k=c[g>>2]|0;i=f;return k|0}do if((c[(c[j>>2]|0)+4>>2]|0)!=9?(c[(c[j>>2]|0)+4>>2]|0)!=13:0){e=c[(c[h>>2]|0)+20>>2]|0;d=c[j>>2]|0;if((c[(c[j>>2]|0)+4>>2]|0)==2){Ip(e,d,0);break}else{Kp(e,d,0);break}}else l=7;while(0);if((l|0)==7)Lp(c[(c[h>>2]|0)+20>>2]|0,c[j>>2]|0);c[g>>2]=0;k=c[g>>2]|0;i=f;return k|0}function Sp(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f;h=f+20|0;j=f+16|0;k=f+8|0;c[j>>2]=a;c[f+12>>2]=b;c[k>>2]=d;c[f+4>>2]=e;if(!(c[j>>2]|0)){c[h>>2]=0;l=c[h>>2]|0;i=f;return l|0}e=c[j>>2]|0;if(!(c[k>>2]|0)){Ka(c[e+20>>2]|0,121712,g|0)|0;c[h>>2]=0;l=c[h>>2]|0;i=f;return l|0}d=c[(c[k>>2]|0)+4>>2]|0;do if((c[(c[e+4>>2]|0)+4>>2]|0)==13){b=c[(c[j>>2]|0)+20>>2]|0;if((d|0)==13){zp(b,c[k>>2]|0)|0;break}else{vp(b,c[(c[j>>2]|0)+4>>2]|0,c[k>>2]|0);break}}else{b=c[(c[j>>2]|0)+20>>2]|0;if((d|0)==9){FR(b,c[k>>2]|0)|0;break}else{zR(b,c[(c[j>>2]|0)+4>>2]|0,c[k>>2]|0);break}}while(0);Ka(c[(c[j>>2]|0)+20>>2]|0,121896,g|0)|0;c[h>>2]=0;l=c[h>>2]|0;i=f;return l|0}function Tp(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+16|0;k=f+4|0;l=f;c[h>>2]=a;c[j>>2]=b;c[f+12>>2]=d;c[f+8>>2]=e;c[l>>2]=0;if((c[h>>2]|0)==0|(c[j>>2]|0)==0){c[g>>2]=-1;m=c[g>>2]|0;i=f;return m|0}if(c[(c[h>>2]|0)+4>>2]|0)c[l>>2]=(c[(c[(c[h>>2]|0)+4>>2]|0)+4>>2]|0)==13&1;e=c[j>>2]|0;if(c[l>>2]|0)c[k>>2]=so(e,0)|0;else c[k>>2]=gg(e,0,0)|0;if(!(c[k>>2]|0)){c[g>>2]=-1;m=c[g>>2]|0;i=f;return m|0}if((c[(c[h>>2]|0)+16>>2]|0)==1)Th(c[(c[h>>2]|0)+4>>2]|0);c[(c[h>>2]|0)+16>>2]=1;Nr(c[(c[h>>2]|0)+12>>2]|0);zb[c[135736>>2]&511](c[c[h>>2]>>2]|0);c[(c[h>>2]|0)+4>>2]=c[k>>2];c[(c[h>>2]|0)+8>>2]=c[k>>2];e=Lr(c[k>>2]|0)|0;c[(c[h>>2]|0)+12>>2]=e;e=Jl(c[j>>2]|0)|0;c[c[h>>2]>>2]=e;c[g>>2]=0;m=c[g>>2]|0;i=f;return m|0}function Up(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g;j=g+24|0;k=g+20|0;l=g+16|0;m=g+12|0;n=g+4|0;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[g+8>>2]=f;if(!(c[m>>2]|0)){c[j>>2]=-1;o=c[j>>2]|0;i=g;return o|0}if((c[l>>2]|0)!=0?(a[c[l>>2]>>0]|0)!=0:0){f=c[(c[m>>2]|0)+4>>2]|0;do if((f|0)==9){if((JR(c[l>>2]|0,c[(c[k>>2]|0)+4>>2]|0)|0)<-1){e=c[33976]|0;d=c[33980]|0;c[h>>2]=c[l>>2];Db[e&511](d,122104,h);c[j>>2]=-1;o=c[j>>2]|0;i=g;return o|0}}else if((f|0)==13){if((Ap(c[l>>2]|0,c[(c[k>>2]|0)+4>>2]|0)|0)<0){d=c[33976]|0;e=c[33980]|0;c[h>>2]=c[l>>2];Db[d&511](e,122104,h);c[j>>2]=-1;o=c[j>>2]|0;i=g;return o|0}}else{c[n>>2]=pb(c[l>>2]|0,122128)|0;if(c[n>>2]|0){zR(c[n>>2]|0,c[(c[k>>2]|0)+4>>2]|0,c[m>>2]|0);Xa(c[n>>2]|0)|0;break}e=c[33976]|0;d=c[33980]|0;c[h>>2]=c[l>>2];Db[e&511](d,122104,h);c[j>>2]=-1;o=c[j>>2]|0;i=g;return o|0}while(0);c[j>>2]=0;o=c[j>>2]|0;i=g;return o|0}c[j>>2]=-1;o=c[j>>2]|0;i=g;return o|0}function Vp(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+32|0;h=g;j=g+20|0;k=g+16|0;l=g+12|0;c[k>>2]=b;c[l>>2]=d;c[g+8>>2]=e;c[g+4>>2]=f;if((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+4>>2]|0)!=0:0){if(!((c[l>>2]|0)!=0?(a[c[l>>2]>>0]|0)!=0:0))c[l>>2]=c[c[k>>2]>>2];if(!(c[l>>2]|0)){c[j>>2]=-1;m=c[j>>2]|0;i=g;return m|0}f=c[(c[(c[k>>2]|0)+4>>2]|0)+4>>2]|0;if((f|0)==9){if((JR(c[l>>2]|0,c[(c[k>>2]|0)+4>>2]|0)|0)<0){e=c[33976]|0;d=c[33980]|0;c[h>>2]=c[l>>2];Db[e&511](d,122136,h)}}else if((f|0)==13){if((Ap(c[l>>2]|0,c[(c[k>>2]|0)+4>>2]|0)|0)<0){k=c[33976]|0;f=c[33980]|0;c[h>>2]=c[l>>2];Db[k&511](f,122136,h)}}else{Db[c[135904>>2]&511](c[33980]|0,122160,h);c[j>>2]=-1;m=c[j>>2]|0;i=g;return m|0}c[j>>2]=0;m=c[j>>2]|0;i=g;return m|0}c[j>>2]=-1;m=c[j>>2]|0;i=g;return m|0}function Wp(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,p=0;g=i;i=i+96|0;h=g+88|0;j=g+84|0;k=g+80|0;l=g+8|0;m=g+4|0;n=g;c[j>>2]=b;c[k>>2]=d;c[g+76>>2]=e;c[g+72>>2]=f;c[m>>2]=-1;if((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+4>>2]|0)!=0:0){c[l>>2]=c[o>>2];c[l+4>>2]=203;c[l+8>>2]=203;if((c[k>>2]|0)!=0?(a[c[k>>2]>>0]|0)!=0:0){c[n>>2]=Wf(0,c[k>>2]|0)|0;if(c[n>>2]|0){c[m>>2]=dn(l,c[(c[j>>2]|0)+4>>2]|0,c[n>>2]|0)|0;Ph(c[n>>2]|0)}}else c[m>>2]=fn(l,c[(c[j>>2]|0)+4>>2]|0)|0;c[h>>2]=c[m>>2];p=c[h>>2]|0;i=g;return p|0}c[h>>2]=-1;p=c[h>>2]|0;i=g;return p|0}function Xp(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+48|0;g=f;h=f+32|0;j=f+28|0;k=f+20|0;l=f+12|0;m=f+8|0;n=f+4|0;c[j>>2]=a;c[f+24>>2]=b;c[k>>2]=d;c[f+16>>2]=e;c[m>>2]=0;if(!(c[j>>2]|0)){c[h>>2]=-1;o=c[h>>2]|0;i=f;return o|0}if(!(c[k>>2]|0)){c[h>>2]=-1;o=c[h>>2]|0;i=f;return o|0}c[l>>2]=c[k>>2];while(1){if(!(c[l>>2]|0))break;if((c[(c[l>>2]|0)+4>>2]|0)!=9?(c[(c[l>>2]|0)+4>>2]|0)!=13:0){if((c[(c[l>>2]|0)+4>>2]|0)==1){c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[m>>2]|0))break;Ka(c[(c[j>>2]|0)+20>>2]|0,122232,g|0)|0;c[n>>2]=(c[n>>2]|0)+1}if((c[(c[l>>2]|0)+36>>2]|0)!=0?(c[(c[(c[l>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){e=c[(c[j>>2]|0)+20>>2]|0;c[g>>2]=c[(c[(c[l>>2]|0)+36>>2]|0)+12>>2];Ka(e|0,121848,g|0)|0}e=c[(c[j>>2]|0)+20>>2]|0;c[g>>2]=c[(c[l>>2]|0)+8>>2];Ka(e|0,122096,g|0)|0}}else Ka(c[(c[j>>2]|0)+20>>2]|0,122224,g|0)|0;if((c[(c[l>>2]|0)+4>>2]|0)!=9?(c[(c[l>>2]|0)+4>>2]|0)!=13:0){if((c[(c[l>>2]|0)+12>>2]|0)!=0?(c[(c[l>>2]|0)+4>>2]|0)!=5:0){c[l>>2]=c[(c[l>>2]|0)+12>>2];c[m>>2]=(c[m>>2]|0)+1;continue}if((c[l>>2]|0)!=(c[k>>2]|0)?(c[(c[l>>2]|0)+24>>2]|0)!=0:0){c[l>>2]=c[(c[l>>2]|0)+24>>2];continue}if((c[l>>2]|0)==(c[k>>2]|0)){c[l>>2]=0;continue}while(1){if((c[l>>2]|0)==(c[k>>2]|0))break;if(c[(c[l>>2]|0)+20>>2]|0){c[l>>2]=c[(c[l>>2]|0)+20>>2];c[m>>2]=(c[m>>2]|0)+-1}if((c[l>>2]|0)!=(c[k>>2]|0)?(c[(c[l>>2]|0)+24>>2]|0)!=0:0){p=33;break}if(!(c[(c[l>>2]|0)+20>>2]|0)){p=35;break}if((c[l>>2]|0)==(c[k>>2]|0)){p=37;break}}if((p|0)==33){p=0;c[l>>2]=c[(c[l>>2]|0)+24>>2]}else if((p|0)==35){p=0;c[l>>2]=0}else if((p|0)==37){p=0;c[l>>2]=0}if((c[l>>2]|0)!=(c[k>>2]|0))continue;c[l>>2]=0;continue}c[l>>2]=c[(c[l>>2]|0)+12>>2]}c[h>>2]=0;o=c[h>>2]|0;i=f;return o|0}function Yp(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+32|0;h=g;j=g+24|0;k=g+16|0;l=g+12|0;m=g+4|0;c[g+20>>2]=b;c[k>>2]=d;c[l>>2]=e;c[g+8>>2]=f;if((c[l>>2]|0)==0|(c[k>>2]|0)==0){c[j>>2]=-1;n=c[j>>2]|0;i=g;return n|0}c[m>>2]=Oi(c[l>>2]|0)|0;if(!(c[m>>2]|0)){c[j>>2]=-1;n=c[j>>2]|0;i=g;return n|0}else{l=c[k>>2]|0;c[h>>2]=c[m>>2];JT(l,499,121856,h)|0;a[(c[k>>2]|0)+499>>0]=48;zb[c[135736>>2]&511](c[m>>2]|0);c[j>>2]=0;n=c[j>>2]|0;i=g;return n|0}return 0}function Zp(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;g=i;i=i+2080|0;h=g;j=g+72|0;k=g+68|0;l=g+64|0;m=g+60|0;n=g+1580|0;o=g+56|0;p=g+52|0;r=g+1480|0;s=g+1080|0;t=g+48|0;u=g+44|0;v=g+40|0;w=g+36|0;x=g+576|0;y=g+32|0;z=g+28|0;A=g+24|0;B=g+20|0;C=g+76|0;D=g+16|0;E=g+12|0;F=g+8|0;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;cU(n|0,0,500)|0;a[n>>0]=47;a[n+1>>0]=32;a[n+2>>0]=62;a[n+3>>0]=32;c[o>>2]=0;if((c[j>>2]|0)==0|(c[k>>2]|0)==0|(c[l>>2]|0)==0){i=g;return}if(!(c[m>>2]|0))c[m>>2]=c[q>>2];c[u>>2]=Cb[c[135744>>2]&511](28)|0;if(!(c[u>>2]|0)){i=g;return}c[(c[u>>2]|0)+16>>2]=0;c[(c[u>>2]|0)+4>>2]=c[j>>2];c[(c[u>>2]|0)+24>>2]=c[l>>2];c[(c[u>>2]|0)+20>>2]=c[m>>2];m=my(c[k>>2]|0)|0;c[c[u>>2]>>2]=m;c[(c[u>>2]|0)+8>>2]=c[(c[u>>2]|0)+4>>2];m=Lr(c[(c[u>>2]|0)+4>>2]|0)|0;c[(c[u>>2]|0)+12>>2]=m;if(!(c[(c[u>>2]|0)+12>>2]|0)){zb[c[135736>>2]&511](c[u>>2]|0);i=g;return}while(1){do if((c[(c[u>>2]|0)+8>>2]|0)==(c[(c[u>>2]|0)+4>>2]|0)){c[h>>2]=122248;JT(n,500,122240,h)|0}else{if((((c[(c[u>>2]|0)+8>>2]|0)!=0?(c[(c[(c[u>>2]|0)+8>>2]|0)+8>>2]|0)!=0:0)?(c[(c[(c[u>>2]|0)+8>>2]|0)+36>>2]|0)!=0:0)?(c[(c[(c[(c[u>>2]|0)+8>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){m=c[(c[(c[u>>2]|0)+8>>2]|0)+8>>2]|0;c[h>>2]=c[(c[(c[(c[u>>2]|0)+8>>2]|0)+36>>2]|0)+12>>2];c[h+4>>2]=m;JT(n,500,122256,h)|0;break}if((c[(c[u>>2]|0)+8>>2]|0)!=0?(c[(c[(c[u>>2]|0)+8>>2]|0)+8>>2]|0)!=0:0){c[h>>2]=c[(c[(c[u>>2]|0)+8>>2]|0)+8>>2];JT(n,500,122240,h)|0;break}JT(n,500,122272,h)|0}while(0);a[n+499>>0]=0;c[o>>2]=Cb[c[(c[u>>2]|0)+24>>2]&511](n)|0;if(!(c[o>>2]|0))break;c[p>>2]=c[o>>2];while(1){if((a[c[p>>2]>>0]|0)!=32?(a[c[p>>2]>>0]|0)!=9:0)break;c[p>>2]=(c[p>>2]|0)+1}c[t>>2]=0;while(1){if((a[c[p>>2]>>0]|0)==32)break;if((a[c[p>>2]>>0]|0)==9)break;if((a[c[p>>2]>>0]|0)==10)break;if((a[c[p>>2]>>0]|0)==13)break;if(!(a[c[p>>2]>>0]|0))break;m=c[p>>2]|0;c[p>>2]=m+1;k=a[m>>0]|0;m=c[t>>2]|0;c[t>>2]=m+1;a[r+m>>0]=k}a[r+(c[t>>2]|0)>>0]=0;if(!(c[t>>2]|0))continue;while(1){if((a[c[p>>2]>>0]|0)!=32?(a[c[p>>2]>>0]|0)!=9:0)break;c[p>>2]=(c[p>>2]|0)+1}c[t>>2]=0;while(1){if((a[c[p>>2]>>0]|0)==10)break;if((a[c[p>>2]>>0]|0)==13)break;if(!(a[c[p>>2]>>0]|0))break;if(!(a[c[p>>2]>>0]|0))break;k=c[p>>2]|0;c[p>>2]=k+1;m=a[k>>0]|0;k=c[t>>2]|0;c[t>>2]=k+1;a[s+k>>0]=m}a[s+(c[t>>2]|0)>>0]=0;if(!(PT(r,122280)|0))break;if(!(PT(r,122288)|0))break;if(!(PT(r,122296)|0))break;a:do if(PT(r,122304)|0){if(!(PT(r,123880)|0)){Wp(c[u>>2]|0,s,0,0)|0;break}if(!(PT(r,123896)|0)){Tp(c[u>>2]|0,s,0,0)|0;break}if(!(PT(r,123904)|0)){iq(c[u>>2]|0,s,0,0)|0;break}if(!(PT(r,123912)|0)){Vp(c[u>>2]|0,s,0,0)|0;break}if(!(PT(r,123920)|0))if(!(a[s>>0]|0)){Db[c[135904>>2]&511](c[33980]|0,123928,h);break}else{Up(c[u>>2]|0,s,c[(c[u>>2]|0)+8>>2]|0,0)|0;break}if(!(PT(r,123976)|0)){jq(c[u>>2]|0,s,c[(c[u>>2]|0)+8>>2]|0,0)|0;break}if(!(PT(r,123984)|0))if(!(a[s>>0]|0)){ul(c[(c[u>>2]|0)+20>>2]|0,0);break}else{c[w>>2]=0;c[h>>2]=w;bT(s,123992,h)|0;ul(c[(c[u>>2]|0)+20>>2]|0,c[w>>2]|0);break}if(!(PT(r,124e3)|0)){if(Yp(c[u>>2]|0,x,c[(c[u>>2]|0)+8>>2]|0,0)|0)break;m=c[(c[u>>2]|0)+20>>2]|0;c[h>>2]=x;Ka(m|0,122096,h|0)|0;break}if(!(PT(r,124008)|0)){m=c[u>>2]|0;if(!(a[s>>0]|0)){Xp(m,0,c[(c[u>>2]|0)+8>>2]|0,0)|0;break}c[(c[(c[u>>2]|0)+12>>2]|0)+4>>2]=c[m+8>>2];c[(c[(c[u>>2]|0)+12>>2]|0)+4>>2]=c[(c[u>>2]|0)+8>>2];c[v>>2]=Rs(s,c[(c[u>>2]|0)+12>>2]|0)|0;if(c[v>>2]|0){b:do switch(c[c[v>>2]>>2]|0){case 8:{m=c[33976]|0;k=c[33980]|0;c[h>>2]=s;Db[m&511](k,122016,h);break}case 9:{k=c[33976]|0;m=c[33980]|0;c[h>>2]=s;Db[k&511](m,122040,h);break}case 3:{m=c[33976]|0;k=c[33980]|0;c[h>>2]=s;Db[m&511](k,121952,h);break}case 4:{k=c[33976]|0;m=c[33980]|0;c[h>>2]=s;Db[k&511](m,121968,h);break}case 7:{m=c[33976]|0;k=c[33980]|0;c[h>>2]=s;Db[m&511](k,122e3,h);break}case 0:{k=c[33976]|0;m=c[33980]|0;c[h>>2]=s;Db[k&511](m,121904,h);break}case 1:{if(!(c[(c[v>>2]|0)+4>>2]|0))break b;c[y>>2]=0;while(1){if((c[y>>2]|0)>=(c[c[(c[v>>2]|0)+4>>2]>>2]|0))break b;Xp(c[u>>2]|0,0,c[(c[(c[(c[v>>2]|0)+4>>2]|0)+8>>2]|0)+(c[y>>2]<<2)>>2]|0,0)|0;c[y>>2]=(c[y>>2]|0)+1}break}case 2:{m=c[33976]|0;k=c[33980]|0;c[h>>2]=s;Db[m&511](k,121928,h);break}case 5:{k=c[33976]|0;m=c[33980]|0;c[h>>2]=s;Db[k&511](m,121984,h);break}case 6:{m=c[33976]|0;k=c[33980]|0;c[h>>2]=s;Db[m&511](k,122e3,h);break}default:{}}while(0);Qq(c[v>>2]|0)}else{k=c[33976]|0;m=c[33980]|0;c[h>>2]=s;Db[k&511](m,121904,h)}c[(c[(c[u>>2]|0)+12>>2]|0)+4>>2]=0;break}if(!(PT(r,124016)|0)){Qp(c[u>>2]|0,0,c[(c[u>>2]|0)+8>>2]|0,0)|0;break}if(!(PT(r,124024)|0)){kq(c[u>>2]|0,s,c[(c[u>>2]|0)+8>>2]|0,0)|0;break}if(!(PT(r,124032)|0))if(!(a[s>>0]|0)){Db[c[135904>>2]&511](c[33980]|0,124040,h);break}else{lq(c[u>>2]|0,s,0,0)|0;break}if(!(PT(r,124072)|0)){c[z>>2]=Pi(c[(c[u>>2]|0)+4>>2]|0)|0;mq(c[u>>2]|0,0,c[z>>2]|0,0)|0;break}if(!(PT(r,124088)|0))if(!(a[s>>0]|0)){Db[c[135904>>2]&511](c[33980]|0,124096,h);break}else{c[(c[(c[u>>2]|0)+12>>2]|0)+4>>2]=c[(c[u>>2]|0)+8>>2];c[v>>2]=Rs(s,c[(c[u>>2]|0)+12>>2]|0)|0;Rq(c[(c[u>>2]|0)+20>>2]|0,c[v>>2]|0,0);Qq(c[v>>2]|0);break}if(!(PT(r,124128)|0)){nq(c[u>>2]|0,s,c[(c[u>>2]|0)+8>>2]|0,0)|0;break}do if(PT(r,124136)|0){if(!(PT(r,124144)|0))break;if(!(PT(r,124152)|0)){m=c[u>>2]|0;if(!(a[s>>0]|0)){if(Yp(m,C,c[(c[u>>2]|0)+8>>2]|0,0)|0)break a;k=c[(c[u>>2]|0)+20>>2]|0;c[h>>2]=C;Ka(k|0,122096,h|0)|0;break a}c[(c[(c[u>>2]|0)+12>>2]|0)+4>>2]=c[m+8>>2];c[v>>2]=Rs(s,c[(c[u>>2]|0)+12>>2]|0)|0;
if(c[v>>2]|0){c:do switch(c[c[v>>2]>>2]|0){case 4:{m=c[33976]|0;k=c[33980]|0;c[h>>2]=s;Db[m&511](k,121968,h);break}case 5:{k=c[33976]|0;m=c[33980]|0;c[h>>2]=s;Db[k&511](m,121984,h);break}case 6:{m=c[33976]|0;k=c[33980]|0;c[h>>2]=s;Db[m&511](k,122e3,h);break}case 7:{k=c[33976]|0;m=c[33980]|0;c[h>>2]=s;Db[k&511](m,122e3,h);break}case 8:{m=c[33976]|0;k=c[33980]|0;c[h>>2]=s;Db[m&511](k,122016,h);break}case 9:{k=c[33976]|0;m=c[33980]|0;c[h>>2]=s;Db[k&511](m,122040,h);break}case 2:{m=c[33976]|0;k=c[33980]|0;c[h>>2]=s;Db[m&511](k,121928,h);break}case 3:{k=c[33976]|0;m=c[33980]|0;c[h>>2]=s;Db[k&511](m,121952,h);break}case 0:{m=c[33976]|0;k=c[33980]|0;c[h>>2]=s;Db[m&511](k,121904,h);break}case 1:{if(!(c[(c[v>>2]|0)+4>>2]|0))break c;c[D>>2]=0;while(1){if((c[D>>2]|0)>=(c[c[(c[v>>2]|0)+4>>2]>>2]|0))break c;if(!(Yp(c[u>>2]|0,C,c[(c[(c[(c[v>>2]|0)+4>>2]|0)+8>>2]|0)+(c[D>>2]<<2)>>2]|0,0)|0)){k=c[(c[u>>2]|0)+20>>2]|0;c[h>>2]=C;Ka(k|0,122096,h|0)|0}c[D>>2]=(c[D>>2]|0)+1}break}default:{}}while(0);Qq(c[v>>2]|0)}else{k=c[33976]|0;m=c[33980]|0;c[h>>2]=s;Db[k&511](m,121904,h)}c[(c[(c[u>>2]|0)+12>>2]|0)+4>>2]=0;break a}if(PT(r,124160)|0){if(PT(r,124248)|0){m=c[33976]|0;k=c[33980]|0;c[h>>2]=r;Db[m&511](k,124272,h);break a}k=c[u>>2]|0;if(!(a[s>>0]|0)){Sp(k,0,c[(c[u>>2]|0)+8>>2]|0,0)|0;break a}c[(c[(c[u>>2]|0)+12>>2]|0)+4>>2]=c[k+8>>2];c[(c[(c[u>>2]|0)+12>>2]|0)+4>>2]=c[(c[u>>2]|0)+8>>2];c[v>>2]=Rs(s,c[(c[u>>2]|0)+12>>2]|0)|0;if(c[v>>2]|0){d:do switch(c[c[v>>2]>>2]|0){case 2:{k=c[33976]|0;m=c[33980]|0;c[h>>2]=s;Db[k&511](m,121928,h);break}case 3:{m=c[33976]|0;k=c[33980]|0;c[h>>2]=s;Db[m&511](k,121952,h);break}case 4:{k=c[33976]|0;m=c[33980]|0;c[h>>2]=s;Db[k&511](m,121968,h);break}case 5:{m=c[33976]|0;k=c[33980]|0;c[h>>2]=s;Db[m&511](k,121984,h);break}case 6:{k=c[33976]|0;m=c[33980]|0;c[h>>2]=s;Db[k&511](m,122e3,h);break}case 7:{m=c[33976]|0;k=c[33980]|0;c[h>>2]=s;Db[m&511](k,122e3,h);break}case 8:{k=c[33976]|0;m=c[33980]|0;c[h>>2]=s;Db[k&511](m,122016,h);break}case 9:{m=c[33976]|0;k=c[33980]|0;c[h>>2]=s;Db[m&511](k,122040,h);break}case 0:{k=c[33976]|0;m=c[33980]|0;c[h>>2]=s;Db[k&511](m,121904,h);break}case 1:{if(!(c[(c[v>>2]|0)+4>>2]|0))break d;c[F>>2]=0;while(1){if((c[F>>2]|0)>=(c[c[(c[v>>2]|0)+4>>2]>>2]|0))break d;if((c[t>>2]|0)>0)Ka(c[(c[u>>2]|0)+20>>2]|0,124256,h|0)|0;Sp(c[u>>2]|0,0,c[(c[(c[(c[v>>2]|0)+4>>2]|0)+8>>2]|0)+(c[F>>2]<<2)>>2]|0,0)|0;c[F>>2]=(c[F>>2]|0)+1}break}default:{}}while(0);Qq(c[v>>2]|0)}else{m=c[33976]|0;k=c[33980]|0;c[h>>2]=s;Db[m&511](k,121904,h)}c[(c[(c[u>>2]|0)+12>>2]|0)+4>>2]=0;break a}k=c[u>>2]|0;if(!(a[s>>0]|0)){c[(c[u>>2]|0)+8>>2]=c[k+4>>2];break a}c[(c[(c[u>>2]|0)+12>>2]|0)+4>>2]=c[k+8>>2];c[E>>2]=ZT(s|0)|0;do if((c[E>>2]|0)>=2){if((a[s+((c[E>>2]|0)-1)>>0]|0)!=47)break;a[s+((c[E>>2]|0)-1)>>0]=0}while(0);c[v>>2]=Rs(s,c[(c[u>>2]|0)+12>>2]|0)|0;if(c[v>>2]|0){e:do switch(c[c[v>>2]>>2]|0){case 0:{k=c[33976]|0;m=c[33980]|0;c[h>>2]=s;Db[k&511](m,121904,h);break}case 1:{if(!(c[(c[v>>2]|0)+4>>2]|0)){m=c[33976]|0;k=c[33980]|0;c[h>>2]=s;Db[m&511](k,124216,h);break e}if((c[c[(c[v>>2]|0)+4>>2]>>2]|0)!=1){k=c[33976]|0;m=c[33980]|0;l=c[c[(c[v>>2]|0)+4>>2]>>2]|0;c[h>>2]=s;c[h+4>>2]=l;Db[k&511](m,124192,h);break e}c[(c[u>>2]|0)+8>>2]=c[c[(c[(c[v>>2]|0)+4>>2]|0)+8>>2]>>2];if(!(c[(c[u>>2]|0)+8>>2]|0))break e;if((c[(c[(c[u>>2]|0)+8>>2]|0)+4>>2]|0)!=18)break e;Db[c[135904>>2]&511](c[33980]|0,124168,h);c[(c[u>>2]|0)+8>>2]=0;break}case 2:{m=c[33976]|0;k=c[33980]|0;c[h>>2]=s;Db[m&511](k,121928,h);break}case 3:{k=c[33976]|0;m=c[33980]|0;c[h>>2]=s;Db[k&511](m,121952,h);break}case 4:{m=c[33976]|0;k=c[33980]|0;c[h>>2]=s;Db[m&511](k,121968,h);break}case 5:{k=c[33976]|0;m=c[33980]|0;c[h>>2]=s;Db[k&511](m,121984,h);break}case 6:{m=c[33976]|0;k=c[33980]|0;c[h>>2]=s;Db[m&511](k,122e3,h);break}case 7:{k=c[33976]|0;m=c[33980]|0;c[h>>2]=s;Db[k&511](m,122e3,h);break}case 8:{m=c[33976]|0;k=c[33980]|0;c[h>>2]=s;Db[m&511](k,122016,h);break}case 9:{k=c[33976]|0;m=c[33980]|0;c[h>>2]=s;Db[k&511](m,122040,h);break}default:{}}while(0);Qq(c[v>>2]|0)}else{m=c[33976]|0;k=c[33980]|0;c[h>>2]=s;Db[m&511](k,121904,h)}c[(c[(c[u>>2]|0)+12>>2]|0)+4>>2]=0;break a}while(0);c[A>>2]=((PT(r,124144)|0)!=0^1)&1;if(!(a[s>>0]|0)){k=c[u>>2]|0;m=c[(c[u>>2]|0)+8>>2]|0;if(c[A>>2]|0){Rp(k,0,m,0)|0;break}else{Pp(k,0,m,0)|0;break}}c[(c[(c[u>>2]|0)+12>>2]|0)+4>>2]=c[(c[u>>2]|0)+8>>2];c[(c[(c[u>>2]|0)+12>>2]|0)+4>>2]=c[(c[u>>2]|0)+8>>2];c[v>>2]=Rs(s,c[(c[u>>2]|0)+12>>2]|0)|0;if(c[v>>2]|0){f:do switch(c[c[v>>2]>>2]|0){case 1:{if(!(c[(c[v>>2]|0)+4>>2]|0))break f;c[B>>2]=0;while(1){if((c[B>>2]|0)>=(c[c[(c[v>>2]|0)+4>>2]>>2]|0))break f;m=c[u>>2]|0;k=c[(c[(c[(c[v>>2]|0)+4>>2]|0)+8>>2]|0)+(c[B>>2]<<2)>>2]|0;if(c[A>>2]|0)Rp(m,0,k,0)|0;else Pp(m,0,k,0)|0;c[B>>2]=(c[B>>2]|0)+1}break}case 7:{k=c[33976]|0;m=c[33980]|0;c[h>>2]=s;Db[k&511](m,122e3,h);break}case 8:{m=c[33976]|0;k=c[33980]|0;c[h>>2]=s;Db[m&511](k,122016,h);break}case 9:{k=c[33976]|0;m=c[33980]|0;c[h>>2]=s;Db[k&511](m,122040,h);break}case 0:{m=c[33976]|0;k=c[33980]|0;c[h>>2]=s;Db[m&511](k,121904,h);break}case 2:{k=c[33976]|0;m=c[33980]|0;c[h>>2]=s;Db[k&511](m,121928,h);break}case 3:{m=c[33976]|0;k=c[33980]|0;c[h>>2]=s;Db[m&511](k,121952,h);break}case 4:{k=c[33976]|0;m=c[33980]|0;c[h>>2]=s;Db[k&511](m,121968,h);break}case 5:{m=c[33976]|0;k=c[33980]|0;c[h>>2]=s;Db[m&511](k,121984,h);break}case 6:{k=c[33976]|0;m=c[33980]|0;c[h>>2]=s;Db[k&511](m,122e3,h);break}default:{}}while(0);Qq(c[v>>2]|0)}else{m=c[33976]|0;k=c[33980]|0;c[h>>2]=s;Db[m&511](k,121904,h)}c[(c[(c[u>>2]|0)+12>>2]|0)+4>>2]=0}else{Ka(c[(c[u>>2]|0)+20>>2]|0,122312,h|0)|0;Ka(c[(c[u>>2]|0)+20>>2]|0,122360,h|0)|0;Ka(c[(c[u>>2]|0)+20>>2]|0,122408,h|0)|0;Ka(c[(c[u>>2]|0)+20>>2]|0,122440,h|0)|0;Ka(c[(c[u>>2]|0)+20>>2]|0,122488,h|0)|0;Ka(c[(c[u>>2]|0)+20>>2]|0,122544,h|0)|0;Ka(c[(c[u>>2]|0)+20>>2]|0,122632,h|0)|0;Ka(c[(c[u>>2]|0)+20>>2]|0,122712,h|0)|0;Ka(c[(c[u>>2]|0)+20>>2]|0,122744,h|0)|0;Ka(c[(c[u>>2]|0)+20>>2]|0,122784,h|0)|0;Ka(c[(c[u>>2]|0)+20>>2]|0,122824,h|0)|0;Ka(c[(c[u>>2]|0)+20>>2]|0,122872,h|0)|0;Ka(c[(c[u>>2]|0)+20>>2]|0,122936,h|0)|0;Ka(c[(c[u>>2]|0)+20>>2]|0,123024,h|0)|0;Ka(c[(c[u>>2]|0)+20>>2]|0,123112,h|0)|0;Ka(c[(c[u>>2]|0)+20>>2]|0,123192,h|0)|0;Ka(c[(c[u>>2]|0)+20>>2]|0,123280,h|0)|0;Ka(c[(c[u>>2]|0)+20>>2]|0,123344,h|0)|0;Ka(c[(c[u>>2]|0)+20>>2]|0,123416,h|0)|0;Ka(c[(c[u>>2]|0)+20>>2]|0,123472,h|0)|0;Ka(c[(c[u>>2]|0)+20>>2]|0,123552,h|0)|0;Ka(c[(c[u>>2]|0)+20>>2]|0,123584,h|0)|0;Ka(c[(c[u>>2]|0)+20>>2]|0,123648,h|0)|0;Ka(c[(c[u>>2]|0)+20>>2]|0,123704,h|0)|0;Ka(c[(c[u>>2]|0)+20>>2]|0,123752,h|0)|0;Ka(c[(c[u>>2]|0)+20>>2]|0,123824,h|0)|0}while(0);jT(c[o>>2]|0);c[o>>2]=0}Nr(c[(c[u>>2]|0)+12>>2]|0);if(c[(c[u>>2]|0)+16>>2]|0)Th(c[(c[u>>2]|0)+4>>2]|0);if(c[c[u>>2]>>2]|0)zb[c[135736>>2]&511](c[c[u>>2]>>2]|0);zb[c[135736>>2]&511](c[u>>2]|0);if(!(c[o>>2]|0)){i=g;return}jT(c[o>>2]|0);i=g;return}function _p(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=b;c[(c[e>>2]|0)+108>>2]=0;c[(c[e>>2]|0)+124>>2]=0;c[(c[e>>2]|0)+128>>2]=0;c[c[e>>2]>>2]=c[q>>2];c[(c[e>>2]|0)+112>>2]=0;c[(c[e>>2]|0)+116>>2]=0;c[(c[e>>2]|0)+120>>2]=0;c[(c[e>>2]|0)+132>>2]=0;c[(c[e>>2]|0)+136>>2]=0;c[f>>2]=0;while(1){if((c[f>>2]|0)>=100)break;a[(c[e>>2]|0)+4+(c[f>>2]|0)>>0]=32;c[f>>2]=(c[f>>2]|0)+1}a[(c[e>>2]|0)+104>>0]=0;i=d;return}function $p(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;g=d+4|0;c[f>>2]=a;c[g>>2]=b;oq(c[f>>2]|0);b=(c[(c[f>>2]|0)+124>>2]|0)!=0;if(!(c[g>>2]|0)){if(b){i=d;return}Ka(c[c[f>>2]>>2]|0,127816,e|0)|0;i=d;return}if(!b?(Ka(c[c[f>>2]>>2]|0,127832,e|0)|0,pq(c[f>>2]|0,c[(c[g>>2]|0)+8>>2]|0),Ka(c[c[f>>2]>>2]|0,121896,e|0)|0,(c[(c[g>>2]|0)+12>>2]|0)!=0):0){e=(c[f>>2]|0)+108|0;c[e>>2]=(c[e>>2]|0)+1;fq(c[f>>2]|0,c[(c[g>>2]|0)+12>>2]|0);e=(c[f>>2]|0)+108|0;c[e>>2]=(c[e>>2]|0)+-1}if(!(c[(c[g>>2]|0)+8>>2]|0))qq(c[f>>2]|0,5015,127848);rq(c[f>>2]|0,c[g>>2]|0);i=d;return}function aq(a){a=a|0;var b=0;b=i;i=i+16|0;c[b>>2]=a;i=b;return}function bq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;c[f>>2]=a;c[g>>2]=b;if(!(c[g>>2]|0)){i=d;return}sq(c[f>>2]|0,c[g>>2]|0);if((c[(c[g>>2]|0)+44>>2]|0)!=0?(c[(c[(c[g>>2]|0)+44>>2]|0)+48>>2]|0)!=0:0){c[h>>2]=c[(c[(c[g>>2]|0)+44>>2]|0)+48>>2];if(!(c[(c[f>>2]|0)+124>>2]|0))Ka(c[c[f>>2]>>2]|0,127472,e|0)|0;Wj(c[h>>2]|0,259,c[f>>2]|0)}else Ka(c[c[f>>2]>>2]|0,127504,e|0)|0;if((c[(c[g>>2]|0)+48>>2]|0)!=0?(c[(c[(c[g>>2]|0)+48>>2]|0)+48>>2]|0)!=0:0){c[j>>2]=c[(c[(c[g>>2]|0)+48>>2]|0)+48>>2];if(!(c[(c[f>>2]|0)+124>>2]|0))Ka(c[c[f>>2]>>2]|0,127536,e|0)|0;Wj(c[j>>2]|0,259,c[f>>2]|0);i=d;return}if(c[(c[f>>2]|0)+124>>2]|0){i=d;return}Ka(c[c[f>>2]>>2]|0,127568,e|0)|0;i=d;return}function cq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;while(1){if(!(c[f>>2]|0))break;$p(c[e>>2]|0,c[f>>2]|0);c[f>>2]=c[(c[f>>2]|0)+24>>2]}i=d;return}function dq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=d+12|0;g=d+8|0;h=d+4|0;c[f>>2]=a;c[g>>2]=b;if(!(c[g>>2]|0)){if(c[(c[f>>2]|0)+124>>2]|0){i=d;return}oq(c[f>>2]|0);Ka(c[c[f>>2]>>2]|0,126040,e|0)|0;i=d;return}c[(c[f>>2]|0)+116>>2]=c[g>>2];a:do switch(c[(c[g>>2]|0)+4>>2]|0){case 1:{if(!(c[(c[f>>2]|0)+124>>2]|0)){oq(c[f>>2]|0);Ka(c[c[f>>2]>>2]|0,126056,e|0)|0;if((c[(c[g>>2]|0)+36>>2]|0)!=0?(c[(c[(c[g>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){pq(c[f>>2]|0,c[(c[(c[g>>2]|0)+36>>2]|0)+12>>2]|0);Ka(c[c[f>>2]>>2]|0,126072,e|0)|0}pq(c[f>>2]|0,c[(c[g>>2]|0)+8>>2]|0);Ka(c[c[f>>2]>>2]|0,121896,e|0)|0}break}case 4:{if(!(c[(c[f>>2]|0)+124>>2]|0)){oq(c[f>>2]|0);Ka(c[c[f>>2]>>2]|0,126168,e|0)|0}break}case 15:{vq(c[f>>2]|0,c[g>>2]|0);i=d;return}case 13:case 9:{if(!(c[(c[f>>2]|0)+124>>2]|0))oq(c[f>>2]|0);Ka(c[c[f>>2]>>2]|0,126232,e|0)|0;rq(c[f>>2]|0,c[g>>2]|0);i=d;return}case 11:{if(!(c[(c[f>>2]|0)+124>>2]|0)){oq(c[f>>2]|0);Ka(c[c[f>>2]>>2]|0,126280,e|0)|0}break}case 2:{if(!(c[(c[f>>2]|0)+124>>2]|0))oq(c[f>>2]|0);Ka(c[c[f>>2]>>2]|0,126080,e|0)|0;rq(c[f>>2]|0,c[g>>2]|0);i=d;return}case 16:{wq(c[f>>2]|0,c[g>>2]|0);i=d;return}case 5:{if(!(c[(c[f>>2]|0)+124>>2]|0)){oq(c[f>>2]|0);b=c[c[f>>2]>>2]|0;c[e>>2]=c[(c[g>>2]|0)+8>>2];Ka(b|0,126184,e|0)|0}break}case 17:{xq(c[f>>2]|0,c[g>>2]|0);i=d;return}case 8:{if(!(c[(c[f>>2]|0)+124>>2]|0)){oq(c[f>>2]|0);Ka(c[c[f>>2]>>2]|0,126216,e|0)|0}break}case 7:{if(!(c[(c[f>>2]|0)+124>>2]|0)){oq(c[f>>2]|0);b=c[c[f>>2]>>2]|0;c[e>>2]=c[(c[g>>2]|0)+8>>2];Ka(b|0,126208,e|0)|0}break}case 12:{if(!(c[(c[f>>2]|0)+124>>2]|0)){oq(c[f>>2]|0);Ka(c[c[f>>2]>>2]|0,126296,e|0)|0}break}case 14:{uq(c[f>>2]|0,c[g>>2]|0);i=d;return}case 19:{if(c[(c[f>>2]|0)+124>>2]|0){i=d;return}oq(c[f>>2]|0);Ka(c[c[f>>2]>>2]|0,126312,e|0)|0;i=d;return}case 6:{if(!(c[(c[f>>2]|0)+124>>2]|0)){oq(c[f>>2]|0);Ka(c[c[f>>2]>>2]|0,126200,e|0)|0}break}case 10:{if(!(c[(c[f>>2]|0)+124>>2]|0)){oq(c[f>>2]|0);Ka(c[c[f>>2]>>2]|0,126264,e|0)|0}break}case 18:{yq(c[f>>2]|0,c[g>>2]|0);i=d;return}case 20:{if(c[(c[f>>2]|0)+124>>2]|0){i=d;return}oq(c[f>>2]|0);Ka(c[c[f>>2]>>2]|0,126328,e|0)|0;i=d;return}case 3:{if(!(c[(c[f>>2]|0)+124>>2]|0)){oq(c[f>>2]|0);b=c[c[f>>2]>>2]|0;if((c[(c[g>>2]|0)+8>>2]|0)==75112)Ka(b|0,126112,e|0)|0;else Ka(b|0,126128,e|0)|0;if(!(c[(c[f>>2]|0)+136>>2]&1)){Ka(c[c[f>>2]>>2]|0,121896,e|0)|0;break a}b=c[f>>2]|0;if((c[(c[g>>2]|0)+40>>2]|0)==((c[g>>2]|0)+44|0)){Ka(c[b>>2]|0,126136,e|0)|0;break a}a=(CP(c[b+120>>2]|0,c[(c[g>>2]|0)+40>>2]|0)|0)==1;b=c[c[f>>2]>>2]|0;if(a){Ka(b|0,126152,e|0)|0;break a}else{Ka(b|0,121896,e|0)|0;break a}}break}default:{if(!(c[(c[f>>2]|0)+124>>2]|0))oq(c[f>>2]|0);zq(c[f>>2]|0,5011,126016,c[(c[g>>2]|0)+4>>2]|0);i=d;return}}while(0);if(!(c[(c[g>>2]|0)+32>>2]|0)){if(!(c[(c[f>>2]|0)+124>>2]|0))oq(c[f>>2]|0);Ka(c[c[f>>2]>>2]|0,126344,e|0)|0}b=(c[f>>2]|0)+108|0;c[b>>2]=(c[b>>2]|0)+1;if((c[(c[g>>2]|0)+4>>2]|0)==1?(c[(c[g>>2]|0)+48>>2]|0)!=0:0)Aq(c[f>>2]|0,c[(c[g>>2]|0)+48>>2]|0);if((c[(c[g>>2]|0)+4>>2]|0)==1?(c[(c[g>>2]|0)+44>>2]|0)!=0:0)cq(c[f>>2]|0,c[(c[g>>2]|0)+44>>2]|0);b=c[g>>2]|0;if((c[(c[g>>2]|0)+4>>2]|0)!=5){if(((c[b+4>>2]|0)!=1?(c[(c[g>>2]|0)+40>>2]|0)!=0:0)?(c[(c[f>>2]|0)+124>>2]|0)==0:0){oq(c[f>>2]|0);Ka(c[c[f>>2]>>2]|0,126368,e|0)|0;pq(c[f>>2]|0,c[(c[g>>2]|0)+40>>2]|0);Ka(c[c[f>>2]>>2]|0,121896,e|0)|0}}else{c[h>>2]=ad(c[b+32>>2]|0,c[(c[g>>2]|0)+8>>2]|0)|0;if(c[h>>2]|0)Bq(c[f>>2]|0,c[h>>2]|0)}h=(c[f>>2]|0)+108|0;c[h>>2]=(c[h>>2]|0)+-1;rq(c[f>>2]|0,c[g>>2]|0);i=d;return}function eq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;g=d+4|0;c[f>>2]=a;c[g>>2]=b;b=c[f>>2]|0;if(!(c[g>>2]|0)){if(c[b+124>>2]|0){i=d;return}oq(c[f>>2]|0);Ka(c[c[f>>2]>>2]|0,126040,e|0)|0;i=d;return}dq(b,c[g>>2]|0);if((c[(c[g>>2]|0)+4>>2]|0)==18){i=d;return}if(!(c[(c[g>>2]|0)+12>>2]|0)){i=d;return}if((c[(c[g>>2]|0)+4>>2]|0)==5){i=d;return}b=(c[f>>2]|0)+108|0;c[b>>2]=(c[b>>2]|0)+1;fq(c[f>>2]|0,c[(c[g>>2]|0)+12>>2]|0);g=(c[f>>2]|0)+108|0;c[g>>2]=(c[g>>2]|0)+-1;i=d;return}function fq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;while(1){if(!(c[f>>2]|0))break;eq(c[e>>2]|0,c[f>>2]|0);c[f>>2]=c[(c[f>>2]|0)+24>>2]}i=d;return}function gq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;g=d+4|0;c[f>>2]=a;c[g>>2]=b;if(!(c[g>>2]|0)){i=d;return}sq(c[f>>2]|0,c[g>>2]|0);if(!(c[(c[f>>2]|0)+124>>2]|0)){if(c[(c[g>>2]|0)+8>>2]|0){Ka(c[c[f>>2]>>2]|0,125424,e|0)|0;pq(c[f>>2]|0,c[(c[g>>2]|0)+8>>2]|0);Ka(c[c[f>>2]>>2]|0,121896,e|0)|0}if(c[(c[g>>2]|0)+56>>2]|0){Ka(c[c[f>>2]>>2]|0,125432,e|0)|0;pq(c[f>>2]|0,c[(c[g>>2]|0)+56>>2]|0);Ka(c[c[f>>2]>>2]|0,121896,e|0)|0}if(c[(c[g>>2]|0)+60>>2]|0){Ka(c[c[f>>2]>>2]|0,125448,e|0)|0;pq(c[f>>2]|0,c[(c[g>>2]|0)+60>>2]|0);Ka(c[c[f>>2]>>2]|0,121896,e|0)|0}if(c[(c[g>>2]|0)+72>>2]|0){Ka(c[c[f>>2]>>2]|0,125464,e|0)|0;pq(c[f>>2]|0,c[(c[g>>2]|0)+72>>2]|0);Ka(c[c[f>>2]>>2]|0,121896,e|0)|0}if(c[(c[g>>2]|0)+40>>2]|0)Ka(c[c[f>>2]>>2]|0,125472,e|0)|0}if(!(c[(c[g>>2]|0)+52>>2]|0)){i=d;return}Aq(c[f>>2]|0,c[(c[g>>2]|0)+52>>2]|0);i=d;return}function hq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;g=d+4|0;c[f>>2]=a;c[g>>2]=b;b=c[f>>2]|0;if(!(c[g>>2]|0)){if(c[b+124>>2]|0){i=d;return}Ka(c[c[f>>2]>>2]|0,125400,e|0)|0;i=d;return}gq(b,c[g>>2]|0);if((c[(c[g>>2]|0)+4>>2]|0)!=9?(c[(c[g>>2]|0)+4>>2]|0)!=13:0){i=d;return}if(!(c[(c[g>>2]|0)+12>>2]|0)){i=d;return}b=(c[f>>2]|0)+108|0;c[b>>2]=(c[b>>2]|0)+1;fq(c[f>>2]|0,c[(c[g>>2]|0)+12>>2]|0);g=(c[f>>2]|0)+108|0;c[g>>2]=(c[g>>2]|0)+-1;i=d;return}function iq(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,p=0,q=0;f=i;i=i+48|0;g=f;h=f+36|0;j=f+32|0;k=f+28|0;l=f+16|0;m=f+12|0;n=f+8|0;p=f+4|0;c[j>>2]=a;c[k>>2]=b;c[f+24>>2]=d;c[f+20>>2]=e;c[m>>2]=YM(c[k>>2]|0)|0;$M(c[m>>2]|0,203,203,c[o>>2]|0);c[l>>2]=_M(c[m>>2]|0)|0;ZM(c[m>>2]|0);if(!(c[l>>2]|0)){m=c[33976]|0;e=c[33980]|0;c[g>>2]=c[k>>2];Db[m&511](e,124416,g);c[h>>2]=-1;q=c[h>>2]|0;i=f;return q|0}c[n>>2]=eN(c[l>>2]|0)|0;gN(c[n>>2]|0,203,203,c[o>>2]|0);c[p>>2]=iN(c[n>>2]|0,c[(c[j>>2]|0)+4>>2]|0)|0;do if(c[p>>2]|0){e=c[o>>2]|0;m=c[c[j>>2]>>2]|0;if((c[p>>2]|0)>0){c[g>>2]=m;Ka(e|0,124472,g|0)|0;break}else{c[g>>2]=m;Ka(e|0,124496,g|0)|0;break}}else{e=c[o>>2]|0;c[g>>2]=c[c[j>>2]>>2];Ka(e|0,124456,g|0)|0}while(0);fN(c[n>>2]|0);if(c[l>>2]|0)VM(c[l>>2]|0);c[h>>2]=0;q=c[h>>2]|0;i=f;return q|0}function jq(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f;h=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[f+4>>2]=e;if(!(c[j>>2]|0)){c[h>>2]=0;m=c[h>>2]|0;i=f;return m|0}if(!(c[l>>2]|0)){c[h>>2]=0;m=c[h>>2]|0;i=f;return m|0}if(!(c[k>>2]|0)){c[h>>2]=0;m=c[h>>2]|0;i=f;return m|0}if(((vy(c[k>>2]|0,63)|0)==0?(vy(c[k>>2]|0,42)|0)==0:0)?(vy(c[k>>2]|0,46)|0)==0:0)vy(c[k>>2]|0,91)|0;a:while(1){if(!(c[l>>2]|0))break;e=c[l>>2]|0;if((c[(c[l>>2]|0)+4>>2]|0)==8){if(wy(c[e+40>>2]|0,c[k>>2]|0)|0){d=c[(c[j>>2]|0)+20>>2]|0;c[g>>2]=Oi(c[l>>2]|0)|0;Ka(d|0,124408,g|0)|0;Pp(c[j>>2]|0,0,c[l>>2]|0,0)|0}}else if((c[e+4>>2]|0)==3?(wy(c[(c[l>>2]|0)+40>>2]|0,c[k>>2]|0)|0)!=0:0){e=c[(c[j>>2]|0)+20>>2]|0;c[g>>2]=Oi(c[(c[l>>2]|0)+20>>2]|0)|0;Ka(e|0,124408,g|0)|0;Pp(c[j>>2]|0,0,c[(c[l>>2]|0)+20>>2]|0,0)|0}if((c[(c[l>>2]|0)+4>>2]|0)!=9?(c[(c[l>>2]|0)+4>>2]|0)!=13:0){if((c[(c[l>>2]|0)+12>>2]|0)!=0?(c[(c[l>>2]|0)+4>>2]|0)!=5:0){c[l>>2]=c[(c[l>>2]|0)+12>>2];continue}if(c[(c[l>>2]|0)+24>>2]|0){c[l>>2]=c[(c[l>>2]|0)+24>>2];continue}while(1){if(!(c[l>>2]|0))continue a;if(c[(c[l>>2]|0)+20>>2]|0)c[l>>2]=c[(c[l>>2]|0)+20>>2];n=c[l>>2]|0;if(c[(c[l>>2]|0)+24>>2]|0){o=30;break}if(!(c[n+20>>2]|0)){o=32;break}}if((o|0)==30){o=0;c[l>>2]=c[n+24>>2];continue}else if((o|0)==32){o=0;c[l>>2]=0;continue}}c[l>>2]=c[(c[l>>2]|0)+12>>2]}c[h>>2]=0;m=c[h>>2]|0;i=f;return m|0}function kq(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f;h=f+28|0;j=f+24|0;k=f+20|0;l=f+16|0;m=f+8|0;n=f+4|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[f+12>>2]=e;if(!(c[j>>2]|0)){c[h>>2]=0;o=c[h>>2]|0;i=f;return o|0}if(!(c[l>>2]|0)){Ka(c[(c[j>>2]|0)+20>>2]|0,121712,g|0)|0;c[h>>2]=0;o=c[h>>2]|0;i=f;return o|0}if(!(c[k>>2]|0)){Ka(c[(c[j>>2]|0)+20>>2]|0,121712,g|0)|0;c[h>>2]=0;o=c[h>>2]|0;i=f;return o|0}e=c[l>>2]|0;d=c[k>>2]|0;c[n>>2]=Yf(e,d,ZT(c[k>>2]|0)|0,0,m)|0;if(!(c[n>>2]|0)){if(c[(c[l>>2]|0)+12>>2]|0){Uh(c[(c[l>>2]|0)+12>>2]|0);c[(c[l>>2]|0)+12>>2]=0;c[(c[l>>2]|0)+16>>2]=0}yi(c[l>>2]|0,c[m>>2]|0)|0}else Ka(c[(c[j>>2]|0)+20>>2]|0,124376,g|0)|0;c[h>>2]=0;o=c[h>>2]|0;i=f;return o|0}function lq(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+48|0;j=h;k=h+40|0;l=h+36|0;m=h+32|0;n=h+20|0;o=h+16|0;p=h+12|0;q=h+8|0;c[l>>2]=b;c[m>>2]=e;c[h+28>>2]=f;c[h+24>>2]=g;c[n>>2]=my(c[m>>2]|0)|0;c[q>>2]=c[n>>2];while(1){if(!(c[q>>2]|0)){r=10;break}if(!(d[c[q>>2]>>0]|0)){r=10;break}c[o>>2]=c[q>>2];c[q>>2]=vy(c[q>>2]|0,61)|0;if(!(c[q>>2]|0)){r=5;break}m=c[q>>2]|0;c[q>>2]=m+1;a[m>>0]=0;c[p>>2]=c[q>>2];c[q>>2]=vy(c[q>>2]|0,32)|0;if(c[q>>2]|0){m=c[q>>2]|0;c[q>>2]=m+1;a[m>>0]=0}if(rr(c[(c[l>>2]|0)+12>>2]|0,c[o>>2]|0,c[p>>2]|0)|0){r=9;break}}if((r|0)==5){Ka(c[(c[l>>2]|0)+20>>2]|0,124040,j|0)|0;zb[c[135736>>2]&511](c[n>>2]|0);c[k>>2]=-1;s=c[k>>2]|0;i=h;return s|0}else if((r|0)==9){q=c[(c[l>>2]|0)+20>>2]|0;l=c[p>>2]|0;c[j>>2]=c[o>>2];c[j+4>>2]=l;Ka(q|0,124312,j|0)|0;zb[c[135736>>2]&511](c[n>>2]|0);c[k>>2]=-1;s=c[k>>2]|0;i=h;return s|0}else if((r|0)==10){zb[c[135736>>2]&511](c[n>>2]|0);c[k>>2]=0;s=c[k>>2]|0;i=h;return s|0}return 0}function mq(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+8|0;k=f;c[h>>2]=a;c[f+12>>2]=b;c[j>>2]=d;c[f+4>>2]=e;if((((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+4>>2]|0)==1:0)?!((c[h>>2]|0)==0?1:(c[(c[j>>2]|0)+48>>2]|0)==0):0)?(c[(c[h>>2]|0)+12>>2]|0)!=0:0){c[k>>2]=c[(c[j>>2]|0)+48>>2];while(1){if(!(c[k>>2]|0))break;j=c[(c[h>>2]|0)+12>>2]|0;e=c[k>>2]|0;if(!(c[(c[k>>2]|0)+12>>2]|0))rr(j,124296,c[e+8>>2]|0)|0;else rr(j,c[e+12>>2]|0,c[(c[k>>2]|0)+8>>2]|0)|0;c[k>>2]=c[c[k>>2]>>2]}c[g>>2]=0;l=c[g>>2]|0;i=f;return l|0}c[g>>2]=-1;l=c[g>>2]|0;i=f;return l|0}function nq(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;c[f+12>>2]=a;c[g>>2]=b;c[h>>2]=d;c[f>>2]=e;Wi(c[h>>2]|0,c[g>>2]|0);i=f;return 0}function oq(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=b+4|0;c[e>>2]=a;if(c[(c[e>>2]|0)+124>>2]|0){i=b;return}if(!(c[c[e>>2]>>2]|0)){i=b;return}if((c[(c[e>>2]|0)+108>>2]|0)<=0){i=b;return}a=c[c[e>>2]>>2]|0;f=c[e>>2]|0;if((c[(c[e>>2]|0)+108>>2]|0)<50){c[d>>2]=(c[e>>2]|0)+4+(100-(c[f+108>>2]<<1));Ka(a|0,121856,d|0)|0;i=b;return}else{c[d>>2]=f+4;Ka(a|0,121856,d|0)|0;i=b;return}}function pq(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=e+12|0;h=e+8|0;j=e+4|0;c[g>>2]=a;c[h>>2]=b;if(c[(c[g>>2]|0)+124>>2]|0){i=e;return}if(!(c[h>>2]|0)){Ka(c[c[g>>2]>>2]|0,121688,f|0)|0;i=e;return}c[j>>2]=0;while(1){if((c[j>>2]|0)>=40)break;if(!(d[(c[h>>2]|0)+(c[j>>2]|0)>>0]|0)){k=17;break}do if((d[(c[h>>2]|0)+(c[j>>2]|0)>>0]|0|0)!=32){if(9<=(d[(c[h>>2]|0)+(c[j>>2]|0)>>0]|0|0)?(d[(c[h>>2]|0)+(c[j>>2]|0)>>0]|0|0)<=10:0){k=11;break}if((d[(c[h>>2]|0)+(c[j>>2]|0)>>0]|0|0)!=13)if((d[(c[h>>2]|0)+(c[j>>2]|0)>>0]|0|0)>=128){b=c[c[g>>2]>>2]|0;c[f>>2]=d[(c[h>>2]|0)+(c[j>>2]|0)>>0];Ka(b|0,121696,f|0)|0;break}else{fb(d[(c[h>>2]|0)+(c[j>>2]|0)>>0]|0|0,c[c[g>>2]>>2]|0)|0;break}else k=11}else k=11;while(0);if((k|0)==11){k=0;fb(32,c[c[g>>2]>>2]|0)|0}c[j>>2]=(c[j>>2]|0)+1}if((k|0)==17){i=e;return}Ka(c[c[g>>2]>>2]|0,121704,f|0)|0;i=e;return}function qq(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;g=e+12|0;h=e+8|0;j=e+4|0;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;d=(c[g>>2]|0)+128|0;c[d>>2]=(c[d>>2]|0)+1;d=c[(c[g>>2]|0)+116>>2]|0;g=c[h>>2]|0;c[f>>2]=c[j>>2];Xd(0,0,0,0,d,24,g,2,0,0,0,0,0,0,0,121856,f);i=e;return}function rq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=c[(c[f>>2]|0)+32>>2];if(!(c[(c[f>>2]|0)+20>>2]|0))qq(c[e>>2]|0,5013,124640);if(c[(c[f>>2]|0)+32>>2]|0){c[h>>2]=c[(c[g>>2]|0)+80>>2];if((c[h>>2]|0)==0?(c[(c[e>>2]|0)+132>>2]|0)==0:0)c[(c[e>>2]|0)+132>>2]=1;if(!(c[(c[e>>2]|0)+112>>2]|0))c[(c[e>>2]|0)+112>>2]=c[g>>2];if(!(c[(c[e>>2]|0)+120>>2]|0))c[(c[e>>2]|0)+120>>2]=c[h>>2]}else{qq(c[e>>2]|0,5014,124664);c[h>>2]=0}if(((c[(c[f>>2]|0)+20>>2]|0)!=0?(c[(c[f>>2]|0)+32>>2]|0)!=(c[(c[(c[f>>2]|0)+20>>2]|0)+32>>2]|0):0)?(qy(c[(c[f>>2]|0)+8>>2]|0,124688)|0)==0:0)qq(c[e>>2]|0,5017,124704);h=c[f>>2]|0;do if(!(c[(c[f>>2]|0)+28>>2]|0)){g=(c[(c[f>>2]|0)+20>>2]|0)!=0;if((c[h+4>>2]|0)==2){if(!g)break;if((c[f>>2]|0)==(c[(c[(c[f>>2]|0)+20>>2]|0)+44>>2]|0))break;qq(c[e>>2]|0,5018,124744);break}else{if(!g)break;if((c[(c[(c[f>>2]|0)+20>>2]|0)+12>>2]|0)==(c[f>>2]|0))break;qq(c[e>>2]|0,5018,124792);break}}else if((c[(c[h+28>>2]|0)+24>>2]|0)!=(c[f>>2]|0))qq(c[e>>2]|0,5019,124840);while(0);h=c[f>>2]|0;if(!(c[(c[f>>2]|0)+24>>2]|0)){if((((c[h+20>>2]|0)!=0?(c[(c[f>>2]|0)+4>>2]|0)!=2:0)?(c[(c[(c[f>>2]|0)+20>>2]|0)+16>>2]|0)!=(c[f>>2]|0):0)?(c[(c[(c[f>>2]|0)+20>>2]|0)+4>>2]|0)==1:0)qq(c[e>>2]|0,5020,124880)}else{if((c[(c[h+24>>2]|0)+28>>2]|0)!=(c[f>>2]|0))qq(c[e>>2]|0,5021,124928);if((c[(c[(c[f>>2]|0)+24>>2]|0)+20>>2]|0)!=(c[(c[f>>2]|0)+20>>2]|0))qq(c[e>>2]|0,5029,124928)}h=c[f>>2]|0;if((c[(c[f>>2]|0)+4>>2]|0)==1){c[j>>2]=c[h+48>>2];while(1){if(!(c[j>>2]|0))break;Cq(c[e>>2]|0,c[f>>2]|0,c[j>>2]|0);c[j>>2]=c[c[j>>2]>>2]}if(c[(c[f>>2]|0)+36>>2]|0)Cq(c[e>>2]|0,c[f>>2]|0,c[(c[f>>2]|0)+36>>2]|0)}else if((c[h+4>>2]|0)==2?(c[(c[f>>2]|0)+36>>2]|0)!=0:0)Cq(c[e>>2]|0,c[f>>2]|0,c[(c[f>>2]|0)+36>>2]|0);if((((((((c[(c[f>>2]|0)+4>>2]|0)!=1?(c[(c[f>>2]|0)+4>>2]|0)!=2:0)?(c[(c[f>>2]|0)+4>>2]|0)!=15:0)?(c[(c[f>>2]|0)+4>>2]|0)!=16:0)?(c[(c[f>>2]|0)+4>>2]|0)!=14:0)?(c[(c[f>>2]|0)+4>>2]|0)!=13:0)?(c[(c[f>>2]|0)+4>>2]|0)!=9:0)?(c[(c[f>>2]|0)+40>>2]|0)!=0:0)Dq(c[e>>2]|0,c[(c[f>>2]|0)+40>>2]|0);switch(c[(c[f>>2]|0)+4>>2]|0){case 2:case 1:{Eq(c[e>>2]|0,c[(c[f>>2]|0)+8>>2]|0);i=d;return}case 4:{if(!(c[(c[f>>2]|0)+8>>2]|0)){i=d;return}Fq(c[e>>2]|0,5037,125048,c[(c[f>>2]|0)+8>>2]|0);i=d;return}case 3:{if((c[(c[f>>2]|0)+8>>2]|0)==75104){i=d;return}if((c[(c[f>>2]|0)+8>>2]|0)==75112){i=d;return}if((c[(c[e>>2]|0)+120>>2]|0)!=0?(h=c[(c[f>>2]|0)+8>>2]|0,(h|0)==(AP(c[(c[e>>2]|0)+120>>2]|0,124968,7)|0)):0){i=d;return}Fq(c[e>>2]|0,5036,124976,c[(c[f>>2]|0)+8>>2]|0);i=d;return}case 7:{Eq(c[e>>2]|0,c[(c[f>>2]|0)+8>>2]|0);i=d;return}case 8:{if((c[(c[f>>2]|0)+8>>2]|0)==75128){i=d;return}Fq(c[e>>2]|0,5036,125008,c[(c[f>>2]|0)+8>>2]|0);i=d;return}default:{i=d;return}}}function sq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;g=d+4|0;c[f>>2]=a;c[g>>2]=b;a:do if(!(c[g>>2]|0)){if(!(c[(c[f>>2]|0)+124>>2]|0))Ka(c[c[f>>2]>>2]|0,125400,e|0)|0}else{c[(c[f>>2]|0)+116>>2]=c[g>>2];do switch(c[(c[g>>2]|0)+4>>2]|0){case 3:{qq(c[f>>2]|0,5002,125744);break a;break}case 5:{qq(c[f>>2]|0,5004,125792);break a;break}case 10:{qq(c[f>>2]|0,5008,125928);break a;break}case 12:{qq(c[f>>2]|0,5010,125984);break a;break}case 4:{qq(c[f>>2]|0,5003,125768);break a;break}case 13:{if(c[(c[f>>2]|0)+124>>2]|0)break a;Ka(c[c[f>>2]>>2]|0,125912,e|0)|0;break a;break}case 9:{if(c[(c[f>>2]|0)+124>>2]|0)break a;Ka(c[c[f>>2]>>2]|0,125896,e|0)|0;break a;break}case 7:{qq(c[f>>2]|0,5006,125848);break a;break}case 2:{qq(c[f>>2]|0,5001,125712);break a;break}case 8:{qq(c[f>>2]|0,5007,125872);break a;break}case 1:{qq(c[f>>2]|0,5e3,125688);break a;break}case 11:{qq(c[f>>2]|0,5009,125952);break a;break}case 6:{qq(c[f>>2]|0,5005,125824);break a;break}default:{zq(c[f>>2]|0,5011,126016,c[(c[g>>2]|0)+4>>2]|0);break a}}while(0)}while(0);i=d;return}function tq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;g=d+4|0;c[f>>2]=a;c[g>>2]=b;b=(c[(c[g>>2]|0)+124>>2]|0)!=0;if(!(c[f>>2]|0)){if(b){i=d;return}Ka(c[c[g>>2]>>2]|0,127600,e|0)|0;i=d;return}if(b){i=d;return}b=c[c[g>>2]>>2]|0;c[e>>2]=c[(c[f>>2]|0)+8>>2];Ka(b|0,124408,e|0)|0;switch(c[(c[f>>2]|0)+48>>2]|0){case 2:{Ka(c[c[g>>2]>>2]|0,127640,e|0)|0;break}case 5:{Ka(c[c[g>>2]>>2]|0,127712,e|0)|0;break}case 1:{Ka(c[c[g>>2]>>2]|0,127616,e|0)|0;break}case 3:{Ka(c[c[g>>2]>>2]|0,127664,e|0)|0;break}case 4:{Ka(c[c[g>>2]>>2]|0,127688,e|0)|0;break}default:zq(c[g>>2]|0,5012,127736,c[(c[f>>2]|0)+48>>2]|0)}if(c[(c[f>>2]|0)+52>>2]|0){b=c[c[g>>2]>>2]|0;c[e>>2]=c[(c[f>>2]|0)+52>>2];Ka(b|0,127760,e|0)|0}if(c[(c[f>>2]|0)+56>>2]|0){b=c[c[g>>2]>>2]|0;c[e>>2]=c[(c[f>>2]|0)+56>>2];Ka(b|0,127768,e|0)|0}if(c[(c[f>>2]|0)+36>>2]|0){b=c[c[g>>2]>>2]|0;c[e>>2]=c[(c[f>>2]|0)+36>>2];Ka(b|0,127784,e|0)|0}if((c[(c[f>>2]|0)+4>>2]|0)!=1?(c[(c[f>>2]|0)+40>>2]|0)!=0:0){b=c[c[g>>2]>>2]|0;c[e>>2]=c[(c[f>>2]|0)+40>>2];Ka(b|0,127800,e|0)|0}Ka(c[c[g>>2]>>2]|0,121896,e|0)|0;i=d;return}function uq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;g=d+4|0;c[f>>2]=a;c[g>>2]=b;oq(c[f>>2]|0);if(!(c[g>>2]|0)){if(c[(c[f>>2]|0)+124>>2]|0){i=d;return}Ka(c[c[f>>2]>>2]|0,124544,e|0)|0;i=d;return}b=c[f>>2]|0;if((c[(c[g>>2]|0)+4>>2]|0)!=14){qq(b,5022,124568);i=d;return}if(!(c[b+124>>2]|0)){b=c[c[f>>2]>>2]|0;if(c[(c[g>>2]|0)+8>>2]|0){c[e>>2]=c[(c[g>>2]|0)+8>>2];Ka(b|0,124592,e|0)|0}else Ka(b|0,124600,e|0)|0;if(c[(c[g>>2]|0)+52>>2]|0){b=c[c[f>>2]>>2]|0;c[e>>2]=c[(c[g>>2]|0)+52>>2];Ka(b|0,124608,e|0)|0}if(c[(c[g>>2]|0)+56>>2]|0){b=c[c[f>>2]>>2]|0;c[e>>2]=c[(c[g>>2]|0)+56>>2];Ka(b|0,124624,e|0)|0}Ka(c[c[f>>2]>>2]|0,121896,e|0)|0}rq(c[f>>2]|0,c[g>>2]|0);i=d;return}function vq(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+5024|0;f=e;g=e+8|0;h=e+4|0;j=e+12|0;c[g>>2]=b;c[h>>2]=d;oq(c[g>>2]|0);if(!(c[h>>2]|0)){if(c[(c[g>>2]|0)+124>>2]|0){i=e;return}Ka(c[c[g>>2]>>2]|0,127304,f|0)|0;i=e;return}if((c[(c[h>>2]|0)+4>>2]|0)!=15){qq(c[g>>2]|0,5025,127336);i=e;return}d=c[g>>2]|0;if(c[(c[h>>2]|0)+8>>2]|0){if(!(c[d+124>>2]|0)){Ka(c[c[g>>2]>>2]|0,127376,f|0)|0;pq(c[g>>2]|0,c[(c[h>>2]|0)+8>>2]|0);Ka(c[c[g>>2]>>2]|0,126712,f|0)|0}}else qq(d,5015,127392);if(!(c[(c[g>>2]|0)+124>>2]|0)){switch(c[(c[h>>2]|0)+36>>2]|0){case 0:{Ka(c[c[g>>2]>>2]|0,127424,f|0)|0;break}case 2:{Ka(c[c[g>>2]>>2]|0,127448,f|0)|0;break}case 4:{Ka(c[c[g>>2]>>2]|0,127456,f|0)|0;break}case 1:{Ka(c[c[g>>2]>>2]|0,127440,f|0)|0;break}case 3:{Ka(c[c[g>>2]>>2]|0,127456,f|0)|0;break}default:{}}if((c[(c[h>>2]|0)+4>>2]|0)!=1?(c[(c[h>>2]|0)+40>>2]|0)!=0:0){a[j>>0]=0;fm(j,5e3,c[(c[h>>2]|0)+40>>2]|0,1);a[j+5e3>>0]=0;d=c[c[g>>2]>>2]|0;c[f>>2]=j;Ka(d|0,121856,f|0)|0}Ka(c[c[g>>2]>>2]|0,121896,f|0)|0}rq(c[g>>2]|0,c[h>>2]|0);i=e;return}function wq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;c[f>>2]=a;c[g>>2]=b;oq(c[f>>2]|0);if(!(c[g>>2]|0)){if(c[(c[f>>2]|0)+124>>2]|0){i=d;return}Ka(c[c[f>>2]>>2]|0,126928,e|0)|0;i=d;return}if((c[(c[g>>2]|0)+4>>2]|0)!=16){qq(c[f>>2]|0,5024,126960);i=d;return}b=c[f>>2]|0;if(c[(c[g>>2]|0)+8>>2]|0){if(!(c[b+124>>2]|0)){a=c[c[f>>2]>>2]|0;c[e>>2]=c[(c[g>>2]|0)+8>>2];Ka(a|0,127e3,e|0)|0}}else qq(b,5015,127016);b=c[f>>2]|0;if(c[(c[g>>2]|0)+60>>2]|0){if(!(c[b+124>>2]|0)){a=c[c[f>>2]>>2]|0;c[e>>2]=c[(c[g>>2]|0)+60>>2];Ka(a|0,127056,e|0)|0}}else qq(b,5016,127064);if(!(c[(c[f>>2]|0)+124>>2]|0)){do switch(c[(c[g>>2]|0)+40>>2]|0){case 3:{Ka(c[c[f>>2]>>2]|0,127128,e|0)|0;break}case 8:{Ka(c[c[f>>2]>>2]|0,127184,e|0)|0;break}case 1:{Ka(c[c[f>>2]>>2]|0,127112,e|0)|0;break}case 9:{Ka(c[c[f>>2]>>2]|0,127200,e|0)|0;break}case 2:{Ka(c[c[f>>2]>>2]|0,127120,e|0)|0;break}case 6:{Ka(c[c[f>>2]>>2]|0,127152,e|0)|0;break}case 5:{Ka(c[c[f>>2]>>2]|0,127144,e|0)|0;break}case 10:{Ka(c[c[f>>2]>>2]|0,127216,e|0)|0;break}case 4:{Ka(c[c[f>>2]>>2]|0,127136,e|0)|0;break}case 7:{Ka(c[c[f>>2]>>2]|0,127168,e|0)|0;break}default:{}}while(0);do if(c[(c[g>>2]|0)+52>>2]|0){c[j>>2]=c[(c[g>>2]|0)+52>>2];c[h>>2]=0;while(1){if((c[h>>2]|0)>=5)break;b=c[c[f>>2]>>2]|0;a=c[(c[j>>2]|0)+4>>2]|0;if(c[h>>2]|0){c[e>>2]=a;Ka(b|0,127232,e|0)|0}else{c[e>>2]=a;Ka(b|0,127240,e|0)|0}c[j>>2]=c[c[j>>2]>>2];if(!(c[j>>2]|0))break;c[h>>2]=(c[h>>2]|0)+1}b=c[c[f>>2]>>2]|0;if(!(c[j>>2]|0)){Ka(b|0,126712,e|0)|0;break}else{Ka(b|0,127248,e|0)|0;break}}while(0);j=c[(c[g>>2]|0)+44>>2]|0;if((j|0)==4)Ka(c[c[f>>2]>>2]|0,127288,e|0)|0;else if((j|0)==2)Ka(c[c[f>>2]>>2]|0,127256,e|0)|0;else if((j|0)==3)Ka(c[c[f>>2]>>2]|0,127272,e|0)|0;if(c[(c[g>>2]|0)+48>>2]|0){Ka(c[c[f>>2]>>2]|0,127296,e|0)|0;pq(c[f>>2]|0,c[(c[g>>2]|0)+48>>2]|0);Ka(c[c[f>>2]>>2]|0,127296,e|0)|0}Ka(c[c[f>>2]>>2]|0,121896,e|0)|0}rq(c[f>>2]|0,c[g>>2]|0);i=d;return}function xq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;g=d+4|0;c[f>>2]=a;c[g>>2]=b;oq(c[f>>2]|0);if(!(c[g>>2]|0)){if(c[(c[f>>2]|0)+124>>2]|0){i=d;return}Ka(c[c[f>>2]>>2]|0,126624,e|0)|0;i=d;return}if((c[(c[g>>2]|0)+4>>2]|0)!=17){qq(c[f>>2]|0,5026,126656);i=d;return}b=c[f>>2]|0;if(c[(c[g>>2]|0)+8>>2]|0){if(!(c[b+124>>2]|0)){Ka(c[c[f>>2]>>2]|0,126696,e|0)|0;pq(c[f>>2]|0,c[(c[g>>2]|0)+8>>2]|0);Ka(c[c[f>>2]>>2]|0,126712,e|0)|0}}else qq(b,5015,126720);if(!(c[(c[f>>2]|0)+124>>2]|0)){switch(c[(c[g>>2]|0)+48>>2]|0){case 5:{Ka(c[c[f>>2]>>2]|0,126824,e|0)|0;break}case 2:{Ka(c[c[f>>2]>>2]|0,126768,e|0)|0;break}case 4:{Ka(c[c[f>>2]>>2]|0,126808,e|0)|0;break}case 6:{Ka(c[c[f>>2]>>2]|0,126848,e|0)|0;break}case 1:{Ka(c[c[f>>2]>>2]|0,126752,e|0)|0;break}case 3:{Ka(c[c[f>>2]>>2]|0,126792,e|0)|0;break}default:{}}if(c[(c[g>>2]|0)+52>>2]|0){oq(c[f>>2]|0);b=c[c[f>>2]>>2]|0;c[e>>2]=c[(c[g>>2]|0)+52>>2];Ka(b|0,126864,e|0)|0}if(c[(c[g>>2]|0)+56>>2]|0){oq(c[f>>2]|0);b=c[c[f>>2]>>2]|0;c[e>>2]=c[(c[g>>2]|0)+56>>2];Ka(b|0,126880,e|0)|0}if(c[(c[g>>2]|0)+64>>2]|0){oq(c[f>>2]|0);b=c[c[f>>2]>>2]|0;c[e>>2]=c[(c[g>>2]|0)+64>>2];Ka(b|0,126896,e|0)|0}if(c[(c[g>>2]|0)+40>>2]|0){oq(c[f>>2]|0);Ka(c[c[f>>2]>>2]|0,126912,e|0)|0;pq(c[f>>2]|0,c[(c[g>>2]|0)+40>>2]|0);Ka(c[c[f>>2]>>2]|0,121896,e|0)|0}}rq(c[f>>2]|0,c[g>>2]|0);i=d;return}function yq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;g=d+4|0;c[f>>2]=a;c[g>>2]=b;oq(c[f>>2]|0);if(!(c[g>>2]|0)){if(c[(c[f>>2]|0)+124>>2]|0){i=d;return}Ka(c[c[f>>2]>>2]|0,125496,e|0)|0;i=d;return}if((c[(c[g>>2]|0)+4>>2]|0)!=18){qq(c[f>>2]|0,5027,125520);i=d;return}if(!(c[(c[g>>2]|0)+8>>2]|0)){b=c[f>>2]|0;if(c[(c[g>>2]|0)+12>>2]|0){Fq(b,5028,125560,c[(c[g>>2]|0)+12>>2]|0);i=d;return}else{qq(b,5028,125600);i=d;return}}if(c[(c[f>>2]|0)+124>>2]|0){i=d;return}b=c[c[f>>2]>>2]|0;if(c[(c[g>>2]|0)+12>>2]|0){c[e>>2]=c[(c[g>>2]|0)+12>>2];Ka(b|0,125640,e|0)|0}else Ka(b|0,125664,e|0)|0;pq(c[f>>2]|0,c[(c[g>>2]|0)+8>>2]|0);Ka(c[c[f>>2]>>2]|0,121896,e|0)|0;i=d;return}function zq(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;e=(c[h>>2]|0)+128|0;c[e>>2]=(c[e>>2]|0)+1;e=c[(c[h>>2]|0)+116>>2]|0;h=c[j>>2]|0;j=c[k>>2]|0;c[g>>2]=c[l>>2];Xd(0,0,0,0,e,24,h,2,0,0,0,0,0,0,0,j,g);i=f;return}function Aq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;while(1){if(!(c[f>>2]|0))break;yq(c[e>>2]|0,c[f>>2]|0);c[f>>2]=c[c[f>>2]>>2]}i=d;return}function Bq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;g=d+4|0;c[f>>2]=a;c[g>>2]=b;oq(c[f>>2]|0);b=(c[(c[f>>2]|0)+124>>2]|0)!=0;if(!(c[g>>2]|0)){if(b){i=d;return}Ka(c[c[f>>2]>>2]|0,126384,e|0)|0;i=d;return}if(b){i=d;return}switch(c[(c[g>>2]|0)+48>>2]|0){case 5:{Ka(c[c[f>>2]>>2]|0,126536,e|0)|0;break}case 2:{Ka(c[c[f>>2]>>2]|0,126432,e|0)|0;break}case 3:{Ka(c[c[f>>2]>>2]|0,126464,e|0)|0;break}case 4:{Ka(c[c[f>>2]>>2]|0,126504,e|0)|0;break}case 1:{Ka(c[c[f>>2]>>2]|0,126400,e|0)|0;break}default:{b=c[c[f>>2]>>2]|0;c[e>>2]=c[(c[g>>2]|0)+48>>2];Ka(b|0,126568,e|0)|0;
}}b=c[c[f>>2]>>2]|0;c[e>>2]=c[(c[g>>2]|0)+8>>2];Ka(b|0,122096,e|0)|0;if(c[(c[g>>2]|0)+52>>2]|0){oq(c[f>>2]|0);b=c[c[f>>2]>>2]|0;c[e>>2]=c[(c[g>>2]|0)+52>>2];Ka(b|0,126584,e|0)|0}if(c[(c[g>>2]|0)+56>>2]|0){oq(c[f>>2]|0);b=c[c[f>>2]>>2]|0;c[e>>2]=c[(c[g>>2]|0)+56>>2];Ka(b|0,126600,e|0)|0}if(c[(c[g>>2]|0)+64>>2]|0){oq(c[f>>2]|0);b=c[c[f>>2]>>2]|0;c[e>>2]=c[(c[g>>2]|0)+64>>2];Ka(b|0,126616,e|0)|0}if(!(c[(c[g>>2]|0)+40>>2]|0)){i=d;return}oq(c[f>>2]|0);Ka(c[c[f>>2]>>2]|0,126368,e|0)|0;pq(c[f>>2]|0,c[(c[g>>2]|0)+40>>2]|0);Ka(c[c[f>>2]>>2]|0,121896,e|0)|0;i=d;return}function Cq(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=Gq(c[g>>2]|0,c[h>>2]|0)|0;do if((c[j>>2]|0)==-2){g=c[f>>2]|0;if(!(c[(c[h>>2]|0)+12>>2]|0)){qq(g,5030,125208);break}else{Fq(g,5030,125256,c[(c[h>>2]|0)+12>>2]|0);break}}while(0);if((c[j>>2]|0)!=-3){i=e;return}j=c[f>>2]|0;if(!(c[(c[h>>2]|0)+12>>2]|0)){qq(j,5031,125304);i=e;return}else{Fq(j,5031,125352,c[(c[h>>2]|0)+12>>2]|0);i=e;return}}function Dq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if(!(c[f>>2]|0)){i=d;return}if(!(c[(c[e>>2]|0)+124>>2]|0)){i=d;return}if(Fy(c[f>>2]|0)|0){i=d;return}Fq(c[e>>2]|0,5032,125184,c[f>>2]|0);i=d;return}function Eq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if(!(c[(c[e>>2]|0)+124>>2]|0)){i=d;return}if(!(c[f>>2]|0)){qq(c[e>>2]|0,5015,125088);i=d;return}if(Gh(c[f>>2]|0,0)|0)Fq(c[e>>2]|0,5034,125104,c[f>>2]|0);if(!(c[(c[e>>2]|0)+120>>2]|0)){i=d;return}if(CP(c[(c[e>>2]|0)+120>>2]|0,c[f>>2]|0)|0){i=d;return}if((c[(c[e>>2]|0)+112>>2]|0)!=0?(c[(c[(c[e>>2]|0)+112>>2]|0)+88>>2]&4608|0)!=0:0){i=d;return}Fq(c[e>>2]|0,5035,125136,c[f>>2]|0);i=d;return}function Fq(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;e=(c[h>>2]|0)+128|0;c[e>>2]=(c[e>>2]|0)+1;e=c[(c[h>>2]|0)+116>>2]|0;h=c[j>>2]|0;j=c[k>>2]|0;c[g>>2]=c[l>>2];Xd(0,0,0,0,e,24,h,2,0,0,0,0,0,0,0,j,g);i=f;return}function Gq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){c[e>>2]=-1;k=c[e>>2]|0;i=d;return k|0}if((((((c[(c[f>>2]|0)+4>>2]|0)!=1?(c[(c[f>>2]|0)+4>>2]|0)!=2:0)?(c[(c[f>>2]|0)+4>>2]|0)!=9:0)?(c[(c[f>>2]|0)+4>>2]|0)!=3:0)?(c[(c[f>>2]|0)+4>>2]|0)!=13:0)?(c[(c[f>>2]|0)+4>>2]|0)!=19:0){c[e>>2]=-2;k=c[e>>2]|0;i=d;return k|0}a:while(1){if(c[f>>2]|0)if(((c[(c[f>>2]|0)+4>>2]|0)!=1?(c[(c[f>>2]|0)+4>>2]|0)!=2:0)?(c[(c[f>>2]|0)+4>>2]|0)!=3:0)l=(c[(c[f>>2]|0)+4>>2]|0)==19;else l=1;else l=0;m=c[f>>2]|0;if(!l){n=26;break}if(!((c[m+4>>2]|0)!=1?(c[(c[f>>2]|0)+4>>2]|0)!=19:0))n=18;b:do if((n|0)==18){n=0;c[h>>2]=c[(c[f>>2]|0)+48>>2];while(1){if(!(c[h>>2]|0))break b;if((c[h>>2]|0)==(c[g>>2]|0)){n=21;break a}if(qy(c[(c[h>>2]|0)+12>>2]|0,c[(c[g>>2]|0)+12>>2]|0)|0){n=23;break a}c[h>>2]=c[c[h>>2]>>2]}}while(0);c[f>>2]=c[(c[f>>2]|0)+20>>2]}if((n|0)==21){c[e>>2]=1;k=c[e>>2]|0;i=d;return k|0}else if((n|0)==23){c[e>>2]=-2;k=c[e>>2]|0;i=d;return k|0}else if((n|0)==26){do if(m){if((c[(c[f>>2]|0)+4>>2]|0)!=9?(c[(c[f>>2]|0)+4>>2]|0)!=13:0)break;c[j>>2]=c[(c[f>>2]|0)+52>>2];if((c[j>>2]|0)==(c[g>>2]|0)){c[e>>2]=1;k=c[e>>2]|0;i=d;return k|0}}while(0);c[e>>2]=-3;k=c[e>>2]|0;i=d;return k|0}return 0}function Hq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+28|0;f=d+8|0;g=d+24|0;h=d+20|0;j=d+16|0;k=d;l=f;c[l>>2]=a;c[l+4>>2]=b;b=f;l=Ha(c[b>>2]|0,c[b+4>>2]|0,0)|0;c[g>>2]=64-l;c[h>>2]=((c[g>>2]|0)>6?c[g>>2]|0:6)-6;g=f;l=dU(c[g>>2]|0,c[g+4>>2]|0,c[h>>2]|0)|0;c[j>>2]=l;l=$T(1,0,c[h>>2]|0)|0;h=XT(l|0,G|0,1,0)|0;l=k;c[l>>2]=h;c[l+4>>2]=G;l=k;k=f;f=c[j>>2]|0;if((c[l>>2]&c[k>>2]|0)!=0?1:(c[l+4>>2]&c[k+4>>2]|0)!=0){c[e>>2]=f+1;m=c[e>>2]|0;i=d;return m|0}else{c[e>>2]=f;m=c[e>>2]|0;i=d;return m|0}return 0}function Iq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;Ss(c[e>>2]|0,1,c[f>>2]|0);i=d;return}function Jq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+2112|0;e=d+2096|0;f=d+2092|0;g=d+2088|0;h=d+2076|0;j=d+24|0;k=d+2072|0;l=d+16|0;m=d+8|0;n=d;c[e>>2]=a;c[f>>2]=b;c[k>>2]=0;b=n;c[b>>2]=0;c[b+4>>2]=0;if((c[f>>2]|0)>>>0<64){Iq(c[e>>2]|0,c[f>>2]|0);i=d;return}c[g>>2]=Hq(c[f>>2]|0,0)|0;c[h>>2]=d+2080;c[c[h>>2]>>2]=0;c[(c[h>>2]|0)+4>>2]=0;b=n;a=Ts(c[e>>2]|0,c[b>>2]|0,c[b+4>>2]|0,c[f>>2]|0)|0;b=l;c[b>>2]=a;c[b+4>>2]=G;b=c[g>>2]|0;a=m;c[a>>2]=b;c[a+4>>2]=((b|0)<0)<<31>>31;b=m;a=c[b+4>>2]|0;o=c[g>>2]|0;p=((o|0)<0)<<31>>31;if((a|0)<(p|0)|((a|0)==(p|0)?(c[b>>2]|0)>>>0<o>>>0:0)){o=c[g>>2]|0;b=m;c[b>>2]=o;c[b+4>>2]=((o|0)<0)<<31>>31}o=m;b=c[o>>2]|0;p=c[o+4>>2]|0;o=n;a=XT(c[f>>2]|0,0,c[o>>2]|0,c[o+4>>2]|0)|0;o=G;if((p|0)>(o|0)|(p|0)==(o|0)&b>>>0>a>>>0){a=n;b=XT(c[f>>2]|0,0,c[a>>2]|0,c[a+4>>2]|0)|0;a=m;c[a>>2]=b;c[a+4>>2]=G}a=m;b=c[a+4>>2]|0;o=l;p=c[o+4>>2]|0;if((b|0)>(p|0)|((b|0)==(p|0)?(c[a>>2]|0)>>>0>(c[o>>2]|0)>>>0:0)){Ss((c[e>>2]|0)+(c[n>>2]<<2)|0,c[l>>2]|0,c[m>>2]|0);o=m;a=c[o+4>>2]|0;p=l;c[p>>2]=c[o>>2];c[p+4>>2]=a}a=n;p=c[a+4>>2]|0;o=j+(c[k>>2]<<4)|0;c[o>>2]=c[a>>2];c[o+4>>2]=p;p=l;o=c[p+4>>2]|0;a=j+(c[k>>2]<<4)+8|0;c[a>>2]=c[p>>2];c[a+4>>2]=o;c[k>>2]=(c[k>>2]|0)+1;o=l;a=n;p=bU(c[a>>2]|0,c[a+4>>2]|0,c[o>>2]|0,c[o+4>>2]|0)|0;o=n;c[o>>2]=p;c[o+4>>2]=G;o=n;if((c[o+4>>2]|0)==0?(c[o>>2]|0)==(c[f>>2]|0):0){while(1){if((c[k>>2]|0)<=1)break;Us(c[e>>2]|0,j,c[k>>2]|0,c[h>>2]|0);o=j+((c[k>>2]|0)-1<<4)+8|0;p=j+((c[k>>2]|0)-2<<4)+8|0;a=p;b=bU(c[a>>2]|0,c[a+4>>2]|0,c[o>>2]|0,c[o+4>>2]|0)|0;o=p;c[o>>2]=b;c[o+4>>2]=G;c[k>>2]=(c[k>>2]|0)+-1}if(!(c[(c[h>>2]|0)+4>>2]|0)){i=d;return}jT(c[(c[h>>2]|0)+4>>2]|0);c[(c[h>>2]|0)+4>>2]=0;i=d;return}o=n;b=Ts(c[e>>2]|0,c[o>>2]|0,c[o+4>>2]|0,c[f>>2]|0)|0;o=l;c[o>>2]=b;c[o+4>>2]=G;o=c[g>>2]|0;b=m;c[b>>2]=o;c[b+4>>2]=((o|0)<0)<<31>>31;o=m;b=c[o+4>>2]|0;p=c[g>>2]|0;a=((p|0)<0)<<31>>31;if((b|0)<(a|0)|((b|0)==(a|0)?(c[o>>2]|0)>>>0<p>>>0:0)){p=c[g>>2]|0;o=m;c[o>>2]=p;c[o+4>>2]=((p|0)<0)<<31>>31}p=m;o=c[p>>2]|0;a=c[p+4>>2]|0;p=n;b=XT(c[f>>2]|0,0,c[p>>2]|0,c[p+4>>2]|0)|0;p=G;if((a|0)>(p|0)|(a|0)==(p|0)&o>>>0>b>>>0){b=n;o=XT(c[f>>2]|0,0,c[b>>2]|0,c[b+4>>2]|0)|0;b=m;c[b>>2]=o;c[b+4>>2]=G}b=m;o=c[b+4>>2]|0;p=l;a=c[p+4>>2]|0;if((o|0)>(a|0)|((o|0)==(a|0)?(c[b>>2]|0)>>>0>(c[p>>2]|0)>>>0:0)){Ss((c[e>>2]|0)+(c[n>>2]<<2)|0,c[l>>2]|0,c[m>>2]|0);p=m;b=c[p+4>>2]|0;a=l;c[a>>2]=c[p>>2];c[a+4>>2]=b}b=n;a=c[b+4>>2]|0;p=j+(c[k>>2]<<4)|0;c[p>>2]=c[b>>2];c[p+4>>2]=a;a=l;p=c[a+4>>2]|0;b=j+(c[k>>2]<<4)+8|0;c[b>>2]=c[a>>2];c[b+4>>2]=p;c[k>>2]=(c[k>>2]|0)+1;p=l;b=n;a=bU(c[b>>2]|0,c[b+4>>2]|0,c[p>>2]|0,c[p+4>>2]|0)|0;p=n;c[p>>2]=a;c[p+4>>2]=G;p=n;if((c[p+4>>2]|0)==0?(c[p>>2]|0)==(c[f>>2]|0):0){while(1){if((c[k>>2]|0)<=1)break;Us(c[e>>2]|0,j,c[k>>2]|0,c[h>>2]|0);p=j+((c[k>>2]|0)-1<<4)+8|0;a=j+((c[k>>2]|0)-2<<4)+8|0;b=a;o=bU(c[b>>2]|0,c[b+4>>2]|0,c[p>>2]|0,c[p+4>>2]|0)|0;p=a;c[p>>2]=o;c[p+4>>2]=G;c[k>>2]=(c[k>>2]|0)+-1}if(!(c[(c[h>>2]|0)+4>>2]|0)){i=d;return}jT(c[(c[h>>2]|0)+4>>2]|0);c[(c[h>>2]|0)+4>>2]=0;i=d;return}p=n;o=Ts(c[e>>2]|0,c[p>>2]|0,c[p+4>>2]|0,c[f>>2]|0)|0;p=l;c[p>>2]=o;c[p+4>>2]=G;p=c[g>>2]|0;o=m;c[o>>2]=p;c[o+4>>2]=((p|0)<0)<<31>>31;p=m;o=c[p+4>>2]|0;a=c[g>>2]|0;b=((a|0)<0)<<31>>31;if((o|0)<(b|0)|((o|0)==(b|0)?(c[p>>2]|0)>>>0<a>>>0:0)){a=c[g>>2]|0;p=m;c[p>>2]=a;c[p+4>>2]=((a|0)<0)<<31>>31}a=m;p=c[a>>2]|0;b=c[a+4>>2]|0;a=n;o=XT(c[f>>2]|0,0,c[a>>2]|0,c[a+4>>2]|0)|0;a=G;if((b|0)>(a|0)|(b|0)==(a|0)&p>>>0>o>>>0){o=n;p=XT(c[f>>2]|0,0,c[o>>2]|0,c[o+4>>2]|0)|0;o=m;c[o>>2]=p;c[o+4>>2]=G}o=m;p=c[o+4>>2]|0;a=l;b=c[a+4>>2]|0;if((p|0)>(b|0)|((p|0)==(b|0)?(c[o>>2]|0)>>>0>(c[a>>2]|0)>>>0:0)){Ss((c[e>>2]|0)+(c[n>>2]<<2)|0,c[l>>2]|0,c[m>>2]|0);a=m;o=c[a+4>>2]|0;b=l;c[b>>2]=c[a>>2];c[b+4>>2]=o}o=n;b=c[o+4>>2]|0;a=j+(c[k>>2]<<4)|0;c[a>>2]=c[o>>2];c[a+4>>2]=b;b=l;a=c[b+4>>2]|0;o=j+(c[k>>2]<<4)+8|0;c[o>>2]=c[b>>2];c[o+4>>2]=a;c[k>>2]=(c[k>>2]|0)+1;a=l;o=n;b=bU(c[o>>2]|0,c[o+4>>2]|0,c[a>>2]|0,c[a+4>>2]|0)|0;a=n;c[a>>2]=b;c[a+4>>2]=G;a=n;if((c[a+4>>2]|0)==0?(c[a>>2]|0)==(c[f>>2]|0):0){while(1){if((c[k>>2]|0)<=1)break;Us(c[e>>2]|0,j,c[k>>2]|0,c[h>>2]|0);a=j+((c[k>>2]|0)-1<<4)+8|0;b=j+((c[k>>2]|0)-2<<4)+8|0;o=b;p=bU(c[o>>2]|0,c[o+4>>2]|0,c[a>>2]|0,c[a+4>>2]|0)|0;a=b;c[a>>2]=p;c[a+4>>2]=G;c[k>>2]=(c[k>>2]|0)+-1}if(!(c[(c[h>>2]|0)+4>>2]|0)){i=d;return}jT(c[(c[h>>2]|0)+4>>2]|0);c[(c[h>>2]|0)+4>>2]=0;i=d;return}while(1){a=(Vs(j,c[k>>2]|0)|0)!=0;p=c[e>>2]|0;if(!a){c[k>>2]=Ws(p,j,c[k>>2]|0,c[h>>2]|0,c[f>>2]|0)|0;continue}a=n;b=Ts(p,c[a>>2]|0,c[a+4>>2]|0,c[f>>2]|0)|0;a=l;c[a>>2]=b;c[a+4>>2]=G;a=c[g>>2]|0;b=m;c[b>>2]=a;c[b+4>>2]=((a|0)<0)<<31>>31;a=m;b=c[a+4>>2]|0;p=c[g>>2]|0;o=((p|0)<0)<<31>>31;if((b|0)<(o|0)|((b|0)==(o|0)?(c[a>>2]|0)>>>0<p>>>0:0)){p=c[g>>2]|0;a=m;c[a>>2]=p;c[a+4>>2]=((p|0)<0)<<31>>31}p=m;a=c[p>>2]|0;o=c[p+4>>2]|0;p=n;b=XT(c[f>>2]|0,0,c[p>>2]|0,c[p+4>>2]|0)|0;p=G;if((o|0)>(p|0)|(o|0)==(p|0)&a>>>0>b>>>0){b=n;a=XT(c[f>>2]|0,0,c[b>>2]|0,c[b+4>>2]|0)|0;b=m;c[b>>2]=a;c[b+4>>2]=G}b=m;a=c[b+4>>2]|0;p=l;o=c[p+4>>2]|0;if((a|0)>(o|0)|((a|0)==(o|0)?(c[b>>2]|0)>>>0>(c[p>>2]|0)>>>0:0)){Ss((c[e>>2]|0)+(c[n>>2]<<2)|0,c[l>>2]|0,c[m>>2]|0);p=m;b=c[p+4>>2]|0;o=l;c[o>>2]=c[p>>2];c[o+4>>2]=b}b=n;o=c[b+4>>2]|0;p=j+(c[k>>2]<<4)|0;c[p>>2]=c[b>>2];c[p+4>>2]=o;o=l;p=c[o+4>>2]|0;b=j+(c[k>>2]<<4)+8|0;c[b>>2]=c[o>>2];c[b+4>>2]=p;c[k>>2]=(c[k>>2]|0)+1;p=l;b=n;o=bU(c[b>>2]|0,c[b+4>>2]|0,c[p>>2]|0,c[p+4>>2]|0)|0;p=n;c[p>>2]=o;c[p+4>>2]=G;p=n;if((c[p+4>>2]|0)==0?(c[p>>2]|0)==(c[f>>2]|0):0)break}while(1){if((c[k>>2]|0)<=1)break;Us(c[e>>2]|0,j,c[k>>2]|0,c[h>>2]|0);f=j+((c[k>>2]|0)-1<<4)+8|0;n=j+((c[k>>2]|0)-2<<4)+8|0;l=n;m=bU(c[l>>2]|0,c[l+4>>2]|0,c[f>>2]|0,c[f+4>>2]|0)|0;f=n;c[f>>2]=m;c[f+4>>2]=G;c[k>>2]=(c[k>>2]|0)+-1}if(!(c[(c[h>>2]|0)+4>>2]|0)){i=d;return}jT(c[(c[h>>2]|0)+4>>2]|0);c[(c[h>>2]|0)+4>>2]=0;i=d;return}function Kq(){var a=0;a=i;if(c[31974]|0){i=a;return}h[15985]=+Xs();h[15986]=+Ys();h[15984]=+Zs();h[15988]=+_s();c[31974]=1;i=a;return}function Lq(a){a=+a;var b=0,c=0,d=0;b=i;i=i+16|0;c=b;h[c>>3]=a;d=$s(+h[c>>3])|0;i=b;return d|0}function Mq(a){a=+a;var b=0,c=0,d=0;b=i;i=i+16|0;c=b;h[c>>3]=a;d=at(+h[c>>3])|0;i=b;return d|0}function Nq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=d+4|0;c[f>>2]=a;c[g>>2]=b;c[g>>2]=(c[g>>2]|0)<0|(c[g>>2]|0)>25?25:b;b=c[g>>2]|0;if(!(c[f>>2]|0)){c[e>>2]=c[127920+(c[g>>2]<<2)>>2];Xd(0,0,0,0,0,12,b+1200-0|0,2,0,0,0,0,0,0,0,127912,e);i=d;return}c[(c[f>>2]|0)+8>>2]=b;if(!(c[(c[f>>2]|0)+12>>2]|0)){b=(c[g>>2]|0)+1200-0|0;a=c[(c[f>>2]|0)+4>>2]|0;h=(c[c[f>>2]>>2]|0)-(c[(c[f>>2]|0)+4>>2]|0)|0;c[e>>2]=c[127920+(c[g>>2]<<2)>>2];Xd(0,0,0,0,0,12,b,2,0,0,a,0,0,h,0,127912,e);i=d;return}Yd((c[(c[f>>2]|0)+12>>2]|0)+136|0);c[(c[(c[f>>2]|0)+12>>2]|0)+136>>2]=12;c[(c[(c[f>>2]|0)+12>>2]|0)+140>>2]=(c[g>>2]|0)+1200-0;c[(c[(c[f>>2]|0)+12>>2]|0)+148>>2]=2;h=my(c[(c[f>>2]|0)+4>>2]|0)|0;c[(c[(c[f>>2]|0)+12>>2]|0)+160>>2]=h;c[(c[(c[f>>2]|0)+12>>2]|0)+172>>2]=(c[c[f>>2]>>2]|0)-(c[(c[f>>2]|0)+4>>2]|0);c[(c[(c[f>>2]|0)+12>>2]|0)+184>>2]=c[(c[(c[f>>2]|0)+12>>2]|0)+188>>2];h=c[(c[f>>2]|0)+12>>2]|0;if(c[(c[(c[f>>2]|0)+12>>2]|0)+132>>2]|0){Ab[c[h+132>>2]&511](c[(c[(c[f>>2]|0)+12>>2]|0)+128>>2]|0,(c[(c[f>>2]|0)+12>>2]|0)+136|0);i=d;return}else{a=c[h+188>>2]|0;h=(c[g>>2]|0)+1200-0|0;b=c[(c[f>>2]|0)+4>>2]|0;j=(c[c[f>>2]>>2]|0)-(c[(c[f>>2]|0)+4>>2]|0)|0;c[e>>2]=c[127920+(c[g>>2]<<2)>>2];Xd(0,0,0,0,a,12,h,2,0,0,b,0,0,j,0,127912,e);i=d;return}}function Oq(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f+12|0;h=f;c[g>>2]=a;c[f+8>>2]=b;c[f+4>>2]=d;c[h>>2]=e;Nq(c[g>>2]|0,c[h>>2]|0);i=f;return}function Pq(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}a=(c[(c[d>>2]|0)+20>>2]|0)==0;c[f>>2]=0;a:do if(a)while(1){if((c[f>>2]|0)>=(c[c[d>>2]>>2]|0))break a;c[e>>2]=(c[(c[d>>2]|0)+8>>2]|0)+((c[f>>2]|0)*40|0);do if(c[(c[e>>2]|0)+24>>2]|0)if((c[c[e>>2]>>2]|0)==12){Qq(c[(c[e>>2]|0)+24>>2]|0);break}else{zb[c[135736>>2]&511](c[(c[e>>2]|0)+24>>2]|0);break}while(0);if(c[(c[e>>2]|0)+28>>2]|0)zb[c[135736>>2]&511](c[(c[e>>2]|0)+28>>2]|0);c[f>>2]=(c[f>>2]|0)+1}else{while(1){if((c[f>>2]|0)>=(c[c[d>>2]>>2]|0))break;c[e>>2]=(c[(c[d>>2]|0)+8>>2]|0)+((c[f>>2]|0)*40|0);if((c[(c[e>>2]|0)+24>>2]|0)!=0?(c[c[e>>2]>>2]|0)==12:0)Qq(c[(c[e>>2]|0)+24>>2]|0);c[f>>2]=(c[f>>2]|0)+1}zP(c[(c[d>>2]|0)+20>>2]|0)}while(0);if(c[(c[d>>2]|0)+8>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+8>>2]|0);if(c[(c[d>>2]|0)+24>>2]|0)FQ(c[(c[d>>2]|0)+24>>2]|0);if(c[(c[d>>2]|0)+16>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+16>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function Qq(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}do if((c[c[d>>2]>>2]|0)!=1?(c[c[d>>2]>>2]|0)!=9:0){a=c[d>>2]|0;if((c[c[d>>2]>>2]|0)==7){if(!(c[a+28>>2]|0))break;ev(c[(c[d>>2]|0)+28>>2]|0);break}if((c[a>>2]|0)==4?(c[(c[d>>2]|0)+24>>2]|0)!=0:0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+24>>2]|0)}else e=4;while(0);do if((e|0)==4){a=c[d>>2]|0;if(c[(c[d>>2]|0)+8>>2]|0){c[a>>2]=9;if(!(c[(c[d>>2]|0)+4>>2]|0))break;bt(c[(c[d>>2]|0)+4>>2]|0);break}else{if(!(c[a+4>>2]|0))break;fr(c[(c[d>>2]|0)+4>>2]|0);break}}while(0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function Rq(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+128|0;g=f;j=f+20|0;l=f+16|0;m=f+12|0;n=f+8|0;o=f+24|0;c[j>>2]=b;c[l>>2]=d;c[m>>2]=e;if(!(c[j>>2]|0)){i=f;return}c[n>>2]=0;while(1){p=o+((c[n>>2]<<1)+1)|0;if(!((c[n>>2]|0)<25?(c[n>>2]|0)<(c[m>>2]|0):0))break;a[p>>0]=32;a[o+(c[n>>2]<<1)>>0]=32;c[n>>2]=(c[n>>2]|0)+1}a[p>>0]=0;a[o+(c[n>>2]<<1)>>0]=0;n=c[j>>2]|0;c[g>>2]=o;Ka(n|0,127912,g|0)|0;if(!(c[l>>2]|0)){Ka(c[j>>2]|0,128024,g|0)|0;i=f;return}do switch(c[c[l>>2]>>2]|0){case 5:{n=c[j>>2]|0;c[g>>2]=c[(c[l>>2]|0)+32>>2];Ka(n|0,128360,g|0)|0;ft(c[j>>2]|0,c[(c[l>>2]|0)+28>>2]|0,(c[m>>2]|0)+1|0);Ka(c[j>>2]|0,128352,g|0)|0;i=f;return}case 6:{do if(c[(c[l>>2]|0)+36>>2]|0){if((c[(c[l>>2]|0)+36>>2]|0)==(c[(c[l>>2]|0)+28>>2]|0)?(c[(c[l>>2]|0)+32>>2]|0)==(c[(c[l>>2]|0)+40>>2]|0):0)break;Ka(c[j>>2]|0,128456,g|0)|0;n=c[j>>2]|0;c[g>>2]=o;Ka(n|0,127912,g|0)|0;Ka(c[j>>2]|0,128480,g|0)|0;if((c[(c[l>>2]|0)+32>>2]|0)>=0){n=c[j>>2]|0;c[g>>2]=c[(c[l>>2]|0)+32>>2];Ka(n|0,128432,g|0)|0}Ka(c[j>>2]|0,128448,g|0)|0;ft(c[j>>2]|0,c[(c[l>>2]|0)+28>>2]|0,(c[m>>2]|0)+1|0);n=c[j>>2]|0;c[g>>2]=o;Ka(n|0,127912,g|0)|0;Ka(c[j>>2]|0,128488,g|0)|0;if((c[(c[l>>2]|0)+40>>2]|0)>=0){n=c[j>>2]|0;c[g>>2]=c[(c[l>>2]|0)+40>>2];Ka(n|0,128432,g|0)|0}Ka(c[j>>2]|0,128448,g|0)|0;ft(c[j>>2]|0,c[(c[l>>2]|0)+36>>2]|0,(c[m>>2]|0)+1|0);Ka(c[j>>2]|0,128352,g|0)|0;i=f;return}while(0);Ka(c[j>>2]|0,128400,g|0)|0;n=c[j>>2]|0;c[g>>2]=o;Ka(n|0,127912,g|0)|0;if((c[(c[l>>2]|0)+32>>2]|0)>=0){n=c[j>>2]|0;c[g>>2]=c[(c[l>>2]|0)+32>>2];Ka(n|0,128432,g|0)|0}Ka(c[j>>2]|0,128448,g|0)|0;ft(c[j>>2]|0,c[(c[l>>2]|0)+28>>2]|0,(c[m>>2]|0)+1|0);i=f;return}case 9:{Ka(c[j>>2]|0,128104,g|0)|0;dt(c[j>>2]|0,c[(c[l>>2]|0)+4>>2]|0,c[m>>2]|0);i=f;return}case 0:{Ka(c[j>>2]|0,128048,g|0)|0;i=f;return}case 4:{Ka(c[j>>2]|0,128328,g|0)|0;Hp(c[j>>2]|0,c[(c[l>>2]|0)+24>>2]|0);Ka(c[j>>2]|0,128352,g|0)|0;i=f;return}case 3:{n=Mq(+h[(c[l>>2]|0)+16>>3])|0;if((n|0)==-1){Ka(c[j>>2]|0,128208,g|0)|0;i=f;return}else if((n|0)==1){Ka(c[j>>2]|0,128176,g|0)|0;i=f;return}else{if(Lq(+h[(c[l>>2]|0)+16>>3])|0){Ka(c[j>>2]|0,128240,g|0)|0;i=f;return}if(+h[(c[l>>2]|0)+16>>3]==0?(et(+h[(c[l>>2]|0)+16>>3])|0)!=0:0){Ka(c[j>>2]|0,128272,g|0)|0;i=f;return}n=c[j>>2]|0;h[k>>3]=+h[(c[l>>2]|0)+16>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];Ka(n|0,128296,g|0)|0;i=f;return}break}case 7:{Ka(c[j>>2]|0,128496,g|0)|0;gt(c[j>>2]|0,c[(c[l>>2]|0)+28>>2]|0,c[m>>2]|0);i=f;return}case 8:{Ka(c[j>>2]|0,128528,g|0)|0;i=f;return}case 1:{Ka(c[j>>2]|0,128080,g|0)|0;ct(c[j>>2]|0,c[(c[l>>2]|0)+4>>2]|0,c[m>>2]|0);i=f;return}case 2:{Ka(c[j>>2]|0,128136,g|0)|0;n=c[j>>2]|0;if(c[(c[l>>2]|0)+8>>2]|0){Ka(n|0,128160,g|0)|0;i=f;return}else{Ka(n|0,128168,g|0)|0;i=f;return}break}default:{i=f;return}}while(0)}function Sq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+20>>2]|0)>0:0){a=c[e>>2]|0;if((c[(c[e>>2]|0)+20>>2]|0)<=(c[(c[e>>2]|0)+44>>2]|0)){Oq(a,128552,2830,23);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}h=a+20|0;c[h>>2]=(c[h>>2]|0)+-1;h=c[e>>2]|0;if((c[(c[e>>2]|0)+20>>2]|0)>0)c[(c[e>>2]|0)+16>>2]=c[(c[(c[e>>2]|0)+28>>2]|0)+((c[h+20>>2]|0)-1<<2)>>2];else c[h+16>>2]=0;c[f>>2]=c[(c[(c[e>>2]|0)+28>>2]|0)+(c[(c[e>>2]|0)+20>>2]<<2)>>2];c[(c[(c[e>>2]|0)+28>>2]|0)+(c[(c[e>>2]|0)+20>>2]<<2)>>2]=0;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}function Tq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){c[e>>2]=-1;j=c[e>>2]|0;i=d;return j|0}do if((c[(c[f>>2]|0)+20>>2]|0)>=(c[(c[f>>2]|0)+24>>2]|0)){if((c[(c[f>>2]|0)+24>>2]|0)>=1e6){it(0,128576);c[(c[f>>2]|0)+8>>2]=15;c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}c[h>>2]=Hb[c[135760>>2]&511](c[(c[f>>2]|0)+28>>2]|0,c[(c[f>>2]|0)+24>>2]<<1<<2)|0;if(c[h>>2]|0){b=(c[f>>2]|0)+24|0;c[b>>2]=c[b>>2]<<1;c[(c[f>>2]|0)+28>>2]=c[h>>2];break}it(0,128616);c[(c[f>>2]|0)+8>>2]=15;c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}while(0);c[(c[(c[f>>2]|0)+28>>2]|0)+(c[(c[f>>2]|0)+20>>2]<<2)>>2]=c[g>>2];c[(c[f>>2]|0)+16>>2]=c[g>>2];g=(c[f>>2]|0)+20|0;f=c[g>>2]|0;c[g>>2]=f+1;c[e>>2]=f;j=c[e>>2]|0;i=d;return j|0}function Uq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;c[f>>2]=Sq(c[e>>2]|0)|0;if(!(c[f>>2]|0)){Oq(c[e>>2]|0,128552,2896,10);if(c[e>>2]|0)c[(c[e>>2]|0)+8>>2]=10;c[d>>2]=0;h=c[d>>2]|0;i=b;return h|0}a=c[f>>2]|0;if((c[c[f>>2]>>2]|0)!=2)c[g>>2]=Vq(a)|0;else c[g>>2]=c[a+8>>2];jt(c[(c[e>>2]|0)+12>>2]|0,c[f>>2]|0);c[d>>2]=c[g>>2];h=c[d>>2]|0;i=b;return h|0}function Vq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+16|0;f=b+12|0;g=b+8|0;c[f>>2]=a;c[g>>2]=0;if(!(c[f>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=b;return j|0}switch(c[c[f>>2]>>2]|0){case 2:{c[g>>2]=c[(c[f>>2]|0)+8>>2];break}case 4:{c[g>>2]=Jr(c[(c[f>>2]|0)+24>>2]|0)|0;break}case 3:{c[g>>2]=Ir(+h[(c[f>>2]|0)+16>>3])|0;break}case 7:case 6:case 5:case 8:{a=c[33976]|0;k=c[33980]|0;c[d>>2]=128552;c[d+4>>2]=6066;Db[a&511](k,129064,d);c[g>>2]=0;break}case 9:case 1:{c[g>>2]=Kr(c[(c[f>>2]|0)+4>>2]|0)|0;break}case 0:{c[g>>2]=0;break}default:{}}c[e>>2]=c[g>>2];j=c[e>>2]|0;i=b;return j|0}function Wq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b+16|0;e=b+8|0;f=b+24|0;g=b;c[f>>2]=a;h[g>>3]=0;if(!(c[f>>2]|0)){h[e>>3]=+h[15984];j=+h[e>>3];i=b;return+j}switch(c[c[f>>2]>>2]|0){case 0:{h[g>>3]=+h[15984];break}case 2:{h[g>>3]=+Dr(c[(c[f>>2]|0)+8>>2]|0);break}case 4:{h[g>>3]=+Er(c[(c[f>>2]|0)+24>>2]|0);break}case 3:{h[g>>3]=+h[(c[f>>2]|0)+16>>3];break}case 7:case 6:case 5:case 8:{a=c[33976]|0;k=c[33980]|0;c[d>>2]=128552;c[d+4>>2]=5954;Db[a&511](k,129064,d);h[g>>3]=+h[15984];break}case 9:case 1:{h[g>>3]=+Hr(c[(c[f>>2]|0)+4>>2]|0);break}default:{}}h[e>>3]=+h[g>>3];j=+h[e>>3];i=b;return+j}function Xq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;c[f>>2]=0;if(!(c[e>>2]|0)){c[d>>2]=-1;h=c[d>>2]|0;i=b;return h|0}c[g>>2]=c[(c[e>>2]|0)+12>>2];a:while(1){if(!(c[g>>2]|0))break;if((c[(c[g>>2]|0)+4>>2]|0)==1?(a=(c[f>>2]|0)+1|0,c[f>>2]=a,c[(c[g>>2]|0)+40>>2]=0-a,(c[(c[g>>2]|0)+12>>2]|0)!=0):0){c[g>>2]=c[(c[g>>2]|0)+12>>2];continue}if(c[(c[g>>2]|0)+24>>2]|0){c[g>>2]=c[(c[g>>2]|0)+24>>2];continue}while(1){c[g>>2]=c[(c[g>>2]|0)+20>>2];if(!(c[g>>2]|0))continue a;if((c[g>>2]|0)==(c[e>>2]|0)){j=12;break}k=c[g>>2]|0;if(c[(c[g>>2]|0)+24>>2]|0){j=14;break}if(!k)continue a}if((j|0)==12){j=0;c[g>>2]=0;continue}else if((j|0)==14){j=0;c[g>>2]=c[k+24>>2];continue}}c[d>>2]=c[f>>2];h=c[d>>2]|0;i=b;return h|0}function Yq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+64|0;e=d+56|0;f=d+52|0;g=d+48|0;h=d+44|0;j=d+40|0;k=d+36|0;l=d+32|0;m=d+28|0;n=d+24|0;o=d+20|0;p=d+16|0;q=d+12|0;r=d+8|0;s=d+4|0;t=d;c[f>>2]=a;c[g>>2]=b;c[k>>2]=0;c[l>>2]=0;c[m>>2]=0;c[n>>2]=0;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){c[e>>2]=-2;u=c[e>>2]|0;i=d;return u|0}if((c[f>>2]|0)==(c[g>>2]|0)){c[e>>2]=0;u=c[e>>2]|0;i=d;return u|0}if((c[(c[f>>2]|0)+4>>2]|0)==2){c[k>>2]=1;c[m>>2]=c[f>>2];c[f>>2]=c[(c[f>>2]|0)+20>>2]}if((c[(c[g>>2]|0)+4>>2]|0)==2){c[l>>2]=1;c[n>>2]=c[g>>2];c[g>>2]=c[(c[g>>2]|0)+20>>2]}if((c[f>>2]|0)==(c[g>>2]|0)){if((c[k>>2]|0)!=(c[l>>2]|0))if((c[l>>2]|0)==1){c[e>>2]=1;u=c[e>>2]|0;i=d;return u|0}else{c[e>>2]=-1;u=c[e>>2]|0;i=d;return u|0}if(!(c[k>>2]|0)){c[e>>2]=0;u=c[e>>2]|0;i=d;return u|0}c[o>>2]=c[(c[n>>2]|0)+28>>2];while(1){if(!(c[o>>2]|0)){v=17;break}if((c[o>>2]|0)==(c[m>>2]|0)){v=15;break}c[o>>2]=c[(c[o>>2]|0)+28>>2]}if((v|0)==15){c[e>>2]=1;u=c[e>>2]|0;i=d;return u|0}else if((v|0)==17){c[e>>2]=-1;u=c[e>>2]|0;i=d;return u|0}}if((c[(c[f>>2]|0)+4>>2]|0)!=18?(c[(c[g>>2]|0)+4>>2]|0)!=18:0){if((c[f>>2]|0)==(c[(c[g>>2]|0)+28>>2]|0)){c[e>>2]=1;u=c[e>>2]|0;i=d;return u|0}if((c[f>>2]|0)==(c[(c[g>>2]|0)+24>>2]|0)){c[e>>2]=-1;u=c[e>>2]|0;i=d;return u|0}if(((((c[(c[f>>2]|0)+4>>2]|0)==1?(c[(c[g>>2]|0)+4>>2]|0)==1:0)?0>(c[(c[f>>2]|0)+40>>2]|0):0)?0>(c[(c[g>>2]|0)+40>>2]|0):0)?(c[(c[f>>2]|0)+32>>2]|0)==(c[(c[g>>2]|0)+32>>2]|0):0){c[q>>2]=0-(c[(c[f>>2]|0)+40>>2]|0);c[r>>2]=0-(c[(c[g>>2]|0)+40>>2]|0);if((c[q>>2]|0)<(c[r>>2]|0)){c[e>>2]=1;u=c[e>>2]|0;i=d;return u|0}if((c[q>>2]|0)>(c[r>>2]|0)){c[e>>2]=-1;u=c[e>>2]|0;i=d;return u|0}}c[j>>2]=0;c[o>>2]=c[g>>2];while(1){w=c[o>>2]|0;if(!(c[(c[o>>2]|0)+20>>2]|0))break;if((w|0)==(c[f>>2]|0)){v=41;break}c[j>>2]=(c[j>>2]|0)+1;c[o>>2]=c[(c[o>>2]|0)+20>>2]}if((v|0)==41){c[e>>2]=1;u=c[e>>2]|0;i=d;return u|0}c[p>>2]=w;c[h>>2]=0;c[o>>2]=c[f>>2];while(1){if(!(c[(c[o>>2]|0)+20>>2]|0))break;if((c[o>>2]|0)==(c[g>>2]|0)){v=46;break}c[h>>2]=(c[h>>2]|0)+1;c[o>>2]=c[(c[o>>2]|0)+20>>2]}if((v|0)==46){c[e>>2]=-1;u=c[e>>2]|0;i=d;return u|0}if((c[p>>2]|0)!=(c[o>>2]|0)){c[e>>2]=-2;u=c[e>>2]|0;i=d;return u|0}while(1){if((c[h>>2]|0)<=(c[j>>2]|0))break;c[h>>2]=(c[h>>2]|0)+-1;c[f>>2]=c[(c[f>>2]|0)+20>>2]}while(1){if((c[j>>2]|0)<=(c[h>>2]|0))break;c[j>>2]=(c[j>>2]|0)+-1;c[g>>2]=c[(c[g>>2]|0)+20>>2]}while(1){x=c[f>>2]|0;if((c[(c[f>>2]|0)+20>>2]|0)==(c[(c[g>>2]|0)+20>>2]|0))break;c[f>>2]=c[x+20>>2];c[g>>2]=c[(c[g>>2]|0)+20>>2];if((c[f>>2]|0)==0|(c[g>>2]|0)==0){v=56;break}}if((v|0)==56){c[e>>2]=-2;u=c[e>>2]|0;i=d;return u|0}if((x|0)==(c[(c[g>>2]|0)+28>>2]|0)){c[e>>2]=1;u=c[e>>2]|0;i=d;return u|0}if((c[f>>2]|0)==(c[(c[g>>2]|0)+24>>2]|0)){c[e>>2]=-1;u=c[e>>2]|0;i=d;return u|0}do if(((((c[(c[f>>2]|0)+4>>2]|0)==1?(c[(c[g>>2]|0)+4>>2]|0)==1:0)?0>(c[(c[f>>2]|0)+40>>2]|0):0)?0>(c[(c[g>>2]|0)+40>>2]|0):0)?(c[(c[f>>2]|0)+32>>2]|0)==(c[(c[g>>2]|0)+32>>2]|0):0){c[s>>2]=0-(c[(c[f>>2]|0)+40>>2]|0);c[t>>2]=0-(c[(c[g>>2]|0)+40>>2]|0);if((c[s>>2]|0)<(c[t>>2]|0)){c[e>>2]=1;u=c[e>>2]|0;i=d;return u|0}if((c[s>>2]|0)<=(c[t>>2]|0))break;c[e>>2]=-1;u=c[e>>2]|0;i=d;return u|0}while(0);c[o>>2]=c[(c[f>>2]|0)+24>>2];while(1){if(!(c[o>>2]|0)){v=75;break}if((c[o>>2]|0)==(c[g>>2]|0)){v=73;break}c[o>>2]=c[(c[o>>2]|0)+24>>2]}if((v|0)==73){c[e>>2]=1;u=c[e>>2]|0;i=d;return u|0}else if((v|0)==75){c[e>>2]=-1;u=c[e>>2]|0;i=d;return u|0}}c[e>>2]=1;u=c[e>>2]|0;i=d;return u|0}function Zq(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}Jq(c[(c[d>>2]|0)+8>>2]|0,c[c[d>>2]>>2]|0);i=b;return}function _q(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if((c[(c[d>>2]|0)+4>>2]|0)!=18){i=b;return}if(!(c[c[d>>2]>>2]|0)){i=b;return}if((c[(c[c[d>>2]>>2]|0)+4>>2]|0)==18){i=b;return}if(c[(c[d>>2]|0)+8>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+8>>2]|0);if(c[(c[d>>2]|0)+12>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+12>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function $q(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](12)|0;if(!(c[f>>2]|0)){it(0,128632);c[d>>2]=0;h=c[d>>2]|0;i=b;return h|0}a=c[f>>2]|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;do if(c[e>>2]|0){a=Cb[c[135744>>2]&511](40)|0;c[(c[f>>2]|0)+8>>2]=a;if(!(c[(c[f>>2]|0)+8>>2]|0)){it(0,128632);zb[c[135736>>2]&511](c[f>>2]|0);c[d>>2]=0;h=c[d>>2]|0;i=b;return h|0}a=(c[(c[f>>2]|0)+8>>2]|0)+0|0;j=a+40|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(j|0));c[(c[f>>2]|0)+4>>2]=10;a=c[e>>2]|0;if((c[(c[e>>2]|0)+4>>2]|0)==18){c[g>>2]=a;j=kt(c[c[g>>2]>>2]|0,c[g>>2]|0)|0;k=c[f>>2]|0;l=c[k>>2]|0;c[k>>2]=l+1;c[(c[(c[f>>2]|0)+8>>2]|0)+(l<<2)>>2]=j;break}else{j=c[f>>2]|0;l=c[j>>2]|0;c[j>>2]=l+1;c[(c[(c[f>>2]|0)+8>>2]|0)+(l<<2)>>2]=a;break}}while(0);c[d>>2]=c[f>>2];h=c[d>>2]|0;i=b;return h|0}function ar(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}b=(c[(c[g>>2]|0)+4>>2]|0)==18;c[h>>2]=0;a:do if(b){while(1){if((c[h>>2]|0)>=(c[c[f>>2]>>2]|0))break a;if((c[(c[(c[(c[f>>2]|0)+8>>2]|0)+(c[h>>2]<<2)>>2]|0)+4>>2]|0)==18){c[j>>2]=c[g>>2];c[k>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+(c[h>>2]<<2)>>2];if((c[j>>2]|0)==(c[k>>2]|0)){m=7;break}if(((c[c[j>>2]>>2]|0)!=0?(c[c[k>>2]>>2]|0)==(c[c[j>>2]>>2]|0):0)?(qy(c[(c[j>>2]|0)+12>>2]|0,c[(c[k>>2]|0)+12>>2]|0)|0)!=0:0){m=11;break}}c[h>>2]=(c[h>>2]|0)+1}if((m|0)==7){c[e>>2]=1;l=c[e>>2]|0;i=d;return l|0}else if((m|0)==11){c[e>>2]=1;l=c[e>>2]|0;i=d;return l|0}}else{while(1){if((c[h>>2]|0)>=(c[c[f>>2]>>2]|0))break a;if((c[(c[(c[f>>2]|0)+8>>2]|0)+(c[h>>2]<<2)>>2]|0)==(c[g>>2]|0))break;c[h>>2]=(c[h>>2]|0)+1}c[e>>2]=1;l=c[e>>2]|0;i=d;return l|0}while(0);c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}function br(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if((!((c[g>>2]|0)==0|(c[j>>2]|0)==0|(c[h>>2]|0)==0)?(c[(c[j>>2]|0)+4>>2]|0)==18:0)?(c[(c[h>>2]|0)+4>>2]|0)==1:0){c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[c[g>>2]>>2]|0))break;if((((c[(c[(c[g>>2]|0)+8>>2]|0)+(c[k>>2]<<2)>>2]|0)!=0?(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+(c[k>>2]<<2)>>2]|0)+4>>2]|0)==18:0)?(c[c[(c[(c[g>>2]|0)+8>>2]|0)+(c[k>>2]<<2)>>2]>>2]|0)==(c[h>>2]|0):0)?(qy(c[(c[j>>2]|0)+12>>2]|0,c[(c[(c[(c[g>>2]|0)+8>>2]|0)+(c[k>>2]<<2)>>2]|0)+12>>2]|0)|0)!=0:0){m=11;break}c[k>>2]=(c[k>>2]|0)+1}if((m|0)==11){c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}do if(c[(c[g>>2]|0)+4>>2]|0){if((c[c[g>>2]>>2]|0)==(c[(c[g>>2]|0)+4>>2]|0)){if((c[(c[g>>2]|0)+4>>2]|0)>=1e7){it(0,128680);c[f>>2]=-1;n=c[f>>2]|0;i=e;return n|0}c[l>>2]=Hb[c[135760>>2]&511](c[(c[g>>2]|0)+8>>2]|0,c[(c[g>>2]|0)+4>>2]<<1<<2)|0;if(c[l>>2]|0){m=(c[g>>2]|0)+4|0;c[m>>2]=c[m>>2]<<1;c[(c[g>>2]|0)+8>>2]=c[l>>2];break}it(0,128656);c[f>>2]=-1;n=c[f>>2]|0;i=e;return n|0}}else{m=Cb[c[135744>>2]&511](40)|0;c[(c[g>>2]|0)+8>>2]=m;if(c[(c[g>>2]|0)+8>>2]|0){m=(c[(c[g>>2]|0)+8>>2]|0)+0|0;k=m+40|0;do{c[m>>2]=0;m=m+4|0}while((m|0)<(k|0));c[(c[g>>2]|0)+4>>2]=10;break}it(0,128656);c[f>>2]=-1;n=c[f>>2]|0;i=e;return n|0}while(0);l=kt(c[h>>2]|0,c[j>>2]|0)|0;j=c[g>>2]|0;h=c[j>>2]|0;c[j>>2]=h+1;c[(c[(c[g>>2]|0)+8>>2]|0)+(h<<2)>>2]=l;c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}c[f>>2]=-1;n=c[f>>2]|0;i=e;return n|0}function cr(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){c[e>>2]=-1;l=c[e>>2]|0;i=d;return l|0}c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[c[f>>2]>>2]|0))break;if((c[(c[(c[f>>2]|0)+8>>2]|0)+(c[h>>2]<<2)>>2]|0)==(c[g>>2]|0)){m=6;break}c[h>>2]=(c[h>>2]|0)+1}if((m|0)==6){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}do if(c[(c[f>>2]|0)+4>>2]|0){if((c[c[f>>2]>>2]|0)==(c[(c[f>>2]|0)+4>>2]|0)){if((c[(c[f>>2]|0)+4>>2]|0)>=1e7){it(0,128680);c[e>>2]=-1;l=c[e>>2]|0;i=d;return l|0}c[j>>2]=Hb[c[135760>>2]&511](c[(c[f>>2]|0)+8>>2]|0,c[(c[f>>2]|0)+4>>2]<<1<<2)|0;if(c[j>>2]|0){m=(c[f>>2]|0)+4|0;c[m>>2]=c[m>>2]<<1;c[(c[f>>2]|0)+8>>2]=c[j>>2];break}it(0,128656);c[e>>2]=-1;l=c[e>>2]|0;i=d;return l|0}}else{m=Cb[c[135744>>2]&511](40)|0;c[(c[f>>2]|0)+8>>2]=m;if(c[(c[f>>2]|0)+8>>2]|0){m=(c[(c[f>>2]|0)+8>>2]|0)+0|0;h=m+40|0;do{c[m>>2]=0;m=m+4|0}while((m|0)<(h|0));c[(c[f>>2]|0)+4>>2]=10;break}it(0,128656);c[e>>2]=-1;l=c[e>>2]|0;i=d;return l|0}while(0);j=c[g>>2]|0;if((c[(c[g>>2]|0)+4>>2]|0)==18){c[k>>2]=j;g=kt(c[c[k>>2]>>2]|0,c[k>>2]|0)|0;k=c[f>>2]|0;m=c[k>>2]|0;c[k>>2]=m+1;c[(c[(c[f>>2]|0)+8>>2]|0)+(m<<2)>>2]=g}else{g=c[f>>2]|0;m=c[g>>2]|0;c[g>>2]=m+1;c[(c[(c[f>>2]|0)+8>>2]|0)+(m<<2)>>2]=j}c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}function dr(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){c[e>>2]=-1;k=c[e>>2]|0;i=d;return k|0}do if(c[(c[f>>2]|0)+4>>2]|0){if((c[c[f>>2]>>2]|0)==(c[(c[f>>2]|0)+4>>2]|0)){if((c[(c[f>>2]|0)+4>>2]|0)>=1e7){it(0,128680);c[e>>2]=-1;k=c[e>>2]|0;i=d;return k|0}c[h>>2]=Hb[c[135760>>2]&511](c[(c[f>>2]|0)+8>>2]|0,c[(c[f>>2]|0)+4>>2]<<1<<2)|0;if(c[h>>2]|0){c[(c[f>>2]|0)+8>>2]=c[h>>2];b=(c[f>>2]|0)+4|0;c[b>>2]=c[b>>2]<<1;break}it(0,128656);c[e>>2]=-1;k=c[e>>2]|0;i=d;return k|0}}else{b=Cb[c[135744>>2]&511](40)|0;c[(c[f>>2]|0)+8>>2]=b;if(c[(c[f>>2]|0)+8>>2]|0){b=(c[(c[f>>2]|0)+8>>2]|0)+0|0;a=b+40|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(a|0));c[(c[f>>2]|0)+4>>2]=10;break}it(0,128656);c[e>>2]=-1;k=c[e>>2]|0;i=d;return k|0}while(0);h=c[g>>2]|0;if((c[(c[g>>2]|0)+4>>2]|0)==18){c[j>>2]=h;g=kt(c[c[j>>2]>>2]|0,c[j>>2]|0)|0;j=c[f>>2]|0;b=c[j>>2]|0;c[j>>2]=b+1;c[(c[(c[f>>2]|0)+8>>2]|0)+(b<<2)>>2]=g}else{g=c[f>>2]|0;b=c[g>>2]|0;c[g>>2]=b+1;c[(c[(c[f>>2]|0)+8>>2]|0)+(b<<2)>>2]=h}c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}function er(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+48|0;e=d+40|0;f=d+36|0;g=d+32|0;h=d+28|0;j=d+24|0;k=d+20|0;l=d+16|0;m=d+12|0;n=d+8|0;o=d+4|0;p=d;c[f>>2]=a;c[g>>2]=b;b=c[f>>2]|0;if(!(c[g>>2]|0)){c[e>>2]=b;q=c[e>>2]|0;i=d;return q|0}if((b|0)==0?(c[f>>2]=$q(0)|0,(c[f>>2]|0)==0):0){c[e>>2]=0;q=c[e>>2]|0;i=d;return q|0}c[k>>2]=c[c[f>>2]>>2];c[h>>2]=0;a:while(1){if((c[h>>2]|0)>=(c[c[g>>2]>>2]|0)){r=33;break}c[n>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+(c[h>>2]<<2)>>2];c[l>>2]=0;c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[k>>2]|0))break;c[m>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+(c[j>>2]<<2)>>2];if((c[m>>2]|0)==(c[n>>2]|0)){r=11;break}if((((c[(c[m>>2]|0)+4>>2]|0)==18?(c[(c[n>>2]|0)+4>>2]|0)==18:0)?(c[c[m>>2]>>2]|0)==(c[c[n>>2]>>2]|0):0)?(qy(c[(c[m>>2]|0)+12>>2]|0,c[(c[n>>2]|0)+12>>2]|0)|0)!=0:0){r=16;break}c[j>>2]=(c[j>>2]|0)+1}if((r|0)==11){r=0;c[l>>2]=1}else if((r|0)==16){r=0;c[l>>2]=1}do if(!(c[l>>2]|0)){if(c[(c[f>>2]|0)+4>>2]|0){if((c[c[f>>2]>>2]|0)==(c[(c[f>>2]|0)+4>>2]|0)){if((c[(c[f>>2]|0)+4>>2]|0)>=1e7){r=25;break a}c[o>>2]=Hb[c[135760>>2]&511](c[(c[f>>2]|0)+8>>2]|0,c[(c[f>>2]|0)+4>>2]<<1<<2)|0;if(!(c[o>>2]|0)){r=27;break a}c[(c[f>>2]|0)+8>>2]=c[o>>2];b=(c[f>>2]|0)+4|0;c[b>>2]=c[b>>2]<<1}}else{b=Cb[c[135744>>2]&511](40)|0;c[(c[f>>2]|0)+8>>2]=b;if(!(c[(c[f>>2]|0)+8>>2]|0)){r=21;break a}b=(c[(c[f>>2]|0)+8>>2]|0)+0|0;a=b+40|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(a|0));c[(c[f>>2]|0)+4>>2]=10}b=c[n>>2]|0;if((c[(c[n>>2]|0)+4>>2]|0)==18){c[p>>2]=b;a=kt(c[c[p>>2]>>2]|0,c[p>>2]|0)|0;s=c[f>>2]|0;t=c[s>>2]|0;c[s>>2]=t+1;c[(c[(c[f>>2]|0)+8>>2]|0)+(t<<2)>>2]=a;break}else{a=c[f>>2]|0;t=c[a>>2]|0;c[a>>2]=t+1;c[(c[(c[f>>2]|0)+8>>2]|0)+(t<<2)>>2]=b;break}}while(0);c[h>>2]=(c[h>>2]|0)+1}if((r|0)==21){it(0,128712);c[e>>2]=0;q=c[e>>2]|0;i=d;return q|0}else if((r|0)==25){it(0,128736);c[e>>2]=0;q=c[e>>2]|0;i=d;return q|0}else if((r|0)==27){it(0,128712);c[e>>2]=0;q=c[e>>2]|0;i=d;return q|0}else if((r|0)==33){c[e>>2]=c[f>>2];q=c[e>>2]|0;i=d;return q|0}return 0}function fr(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+8>>2]|0){c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[c[d>>2]>>2]|0))break;if((c[(c[(c[d>>2]|0)+8>>2]|0)+(c[e>>2]<<2)>>2]|0)!=0?(c[(c[(c[(c[d>>2]|0)+8>>2]|0)+(c[e>>2]<<2)>>2]|0)+4>>2]|0)==18:0)_q(c[(c[(c[d>>2]|0)+8>>2]|0)+(c[e>>2]<<2)>>2]|0);c[e>>2]=(c[e>>2]|0)+1}zb[c[135736>>2]&511](c[(c[d>>2]|0)+8>>2]|0)}zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function gr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](48)|0;if(!(c[f>>2]|0)){it(0,128632);c[d>>2]=0;g=c[d>>2]|0;
i=b;return g|0}else{a=(c[f>>2]|0)+0|0;h=a+48|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(h|0));c[c[f>>2]>>2]=1;c[(c[f>>2]|0)+8>>2]=0;a=$q(c[e>>2]|0)|0;c[(c[f>>2]|0)+4>>2]=a;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function hr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](48)|0;if(!(c[f>>2]|0)){it(0,128768);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{a=(c[f>>2]|0)+0|0;h=a+48|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(h|0));c[c[f>>2]>>2]=1;c[(c[f>>2]|0)+4>>2]=c[e>>2];c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function ir(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;a=_i(c[d>>2]|0)|0;c[e>>2]=a;if(!a)c[e>>2]=my(128928)|0;i=b;return c[e>>2]|0}function jr(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=kr(c[f>>2]|0,c[g>>2]|0,0,c[h>>2]|0)|0;i=e;return d|0}function kr(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;do if(c[h>>2]|0){if(!(c[j>>2]|0)){c[g>>2]=-1;break}if(!(c[(c[h>>2]|0)+40>>2]|0)){e=Ij(0)|0;c[(c[h>>2]|0)+40>>2]=e}if(!(c[(c[h>>2]|0)+40>>2]|0)){c[g>>2]=-1;break}e=c[(c[h>>2]|0)+40>>2]|0;d=c[j>>2]|0;b=c[k>>2]|0;if(!(c[l>>2]|0)){c[g>>2]=ck(e,d,b,0)|0;break}else{c[g>>2]=Nj(e,d,b,c[l>>2]|0)|0;break}}else c[g>>2]=-1;while(0);i=f;return c[g>>2]|0}function lr(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;if(!(c[f>>2]|0)){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}if((c[(c[f>>2]|0)+112>>2]|0)!=0?(c[j>>2]=c[(c[f>>2]|0)+112>>2],c[k>>2]=vb[c[j>>2]&511](c[(c[f>>2]|0)+116>>2]|0,c[g>>2]|0,0)|0,c[h>>2]=c[k>>2],(c[h>>2]|0)!=0):0){c[e>>2]=c[h>>2];l=c[e>>2]|0;i=d;return l|0}c[e>>2]=mr(c[f>>2]|0,c[g>>2]|0,0)|0;l=c[e>>2]|0;i=d;return l|0}function mr(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(!(c[g>>2]|0)){c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}if(!(c[h>>2]|0)){c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}if((c[(c[g>>2]|0)+112>>2]|0)!=0?(c[l>>2]=c[(c[g>>2]|0)+112>>2],c[m>>2]=vb[c[l>>2]&511](c[(c[g>>2]|0)+116>>2]|0,c[h>>2]|0,c[j>>2]|0)|0,c[k>>2]=c[m>>2],(c[k>>2]|0)!=0):0){c[f>>2]=c[k>>2];n=c[f>>2]|0;i=e;return n|0}if(!(c[(c[g>>2]|0)+40>>2]|0)){c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}else{c[k>>2]=Tj(c[(c[g>>2]|0)+40>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;c[f>>2]=c[k>>2];n=c[f>>2]|0;i=e;return n|0}return 0}function nr(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}Kj(c[(c[d>>2]|0)+40>>2]|0,0);c[(c[d>>2]|0)+40>>2]=0;i=b;return}function or(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if(!(c[f>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}b=c[f>>2]|0;if(c[(c[f>>2]|0)+92>>2]|0){c[h>>2]=vb[c[b+92>>2]&511](c[(c[f>>2]|0)+96>>2]|0,c[g>>2]|0,0)|0;c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}else{c[e>>2]=pr(b,c[g>>2]|0,0)|0;j=c[e>>2]|0;i=d;return j|0}return 0}function pr(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(!(c[g>>2]|0)){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}if((c[(c[g>>2]|0)+92>>2]|0)!=0?(c[k>>2]=vb[c[(c[g>>2]|0)+92>>2]&511](c[(c[g>>2]|0)+96>>2]|0,c[h>>2]|0,c[j>>2]|0)|0,(c[k>>2]|0)!=0):0){c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}if(!(c[(c[g>>2]|0)+16>>2]|0)){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}if(!(c[h>>2]|0)){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}else{k=c[g>>2]|0;c[f>>2]=lt(k,Tj(c[(c[g>>2]|0)+16>>2]|0,c[h>>2]|0,c[j>>2]|0)|0)|0;l=c[f>>2]|0;i=e;return l|0}return 0}function qr(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}Kj(c[(c[d>>2]|0)+16>>2]|0,260);c[(c[d>>2]|0)+16>>2]=0;i=b;return}function rr(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=e;do if(c[h>>2]|0){if(!(c[j>>2]|0)){c[g>>2]=-1;break}if(!(d[c[j>>2]>>0]|0)){c[g>>2]=-1;break}if(!(c[(c[h>>2]|0)+88>>2]|0)){e=Ij(10)|0;c[(c[h>>2]|0)+88>>2]=e}if(!(c[(c[h>>2]|0)+88>>2]|0)){c[g>>2]=-1;break}e=c[(c[h>>2]|0)+88>>2]|0;b=c[j>>2]|0;if(!(c[k>>2]|0)){c[g>>2]=ak(e,b,c[33934]|0)|0;break}else{a=my(c[k>>2]|0)|0;c[g>>2]=Oj(e,b,a,c[33934]|0)|0;break}}else c[g>>2]=-1;while(0);i=f;return c[g>>2]|0}function sr(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if(!(c[f>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}if(!(c[g>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}if(qy(c[g>>2]|0,128800)|0){c[e>>2]=128808;j=c[e>>2]|0;i=d;return j|0}a:do if(c[(c[f>>2]|0)+56>>2]|0){c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[(c[f>>2]|0)+60>>2]|0))break a;if((c[(c[(c[f>>2]|0)+56>>2]|0)+(c[h>>2]<<2)>>2]|0)!=0?(qy(c[(c[(c[(c[f>>2]|0)+56>>2]|0)+(c[h>>2]<<2)>>2]|0)+12>>2]|0,c[g>>2]|0)|0)!=0:0)break;c[h>>2]=(c[h>>2]|0)+1}c[e>>2]=c[(c[(c[(c[f>>2]|0)+56>>2]|0)+(c[h>>2]<<2)>>2]|0)+8>>2];j=c[e>>2]|0;i=d;return j|0}while(0);c[e>>2]=Rj(c[(c[f>>2]|0)+88>>2]|0,c[g>>2]|0)|0;j=c[e>>2]|0;i=d;return j|0}function tr(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}Kj(c[(c[d>>2]|0)+88>>2]|0,c[33934]|0);c[(c[d>>2]|0)+88>>2]=0;i=b;return}function ur(a){a=+a;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+16|0;d=b+12|0;e=b;f=b+8|0;h[e>>3]=a;c[f>>2]=Cb[c[135744>>2]&511](48)|0;if(!(c[f>>2]|0)){it(0,128848);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{j=(c[f>>2]|0)+0|0;k=j+48|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));c[c[f>>2]>>2]=3;h[(c[f>>2]|0)+16>>3]=+h[e>>3];c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function vr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](48)|0;if(!(c[f>>2]|0)){it(0,128872);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{a=(c[f>>2]|0)+0|0;h=a+48|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(h|0));c[c[f>>2]>>2]=2;c[(c[f>>2]|0)+8>>2]=(c[e>>2]|0)!=0&1;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function wr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](48)|0;if(!(c[f>>2]|0)){it(0,128904);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}a=(c[f>>2]|0)+0|0;h=a+48|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(h|0));c[c[f>>2]>>2]=4;if(c[e>>2]|0){a=my(c[e>>2]|0)|0;c[(c[f>>2]|0)+24>>2]=a}else{a=my(128928)|0;c[(c[f>>2]|0)+24>>2]=a}c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}function xr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](48)|0;if(!(c[f>>2]|0)){it(0,128904);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{a=(c[f>>2]|0)+0|0;h=a+48|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(h|0));c[c[f>>2]>>2]=4;c[(c[f>>2]|0)+24>>2]=c[e>>2];c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function yr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](48)|0;if(!(c[f>>2]|0)){it(0,128904);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{a=(c[f>>2]|0)+0|0;h=a+48|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(h|0));c[c[f>>2]>>2]=4;a=my(c[e>>2]|0)|0;c[(c[f>>2]|0)+24>>2]=a;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function zr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;c[f>>2]=a;if(!(c[f>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=b;return j|0}c[g>>2]=Cb[c[135744>>2]&511](48)|0;if(!(c[g>>2]|0)){it(0,128936);c[e>>2]=0;j=c[e>>2]|0;i=b;return j|0}a=(c[g>>2]|0)+0|0;k=(c[f>>2]|0)+0|0;l=a+48|0;do{c[a>>2]=c[k>>2];a=a+4|0;k=k+4|0}while((a|0)<(l|0));switch(c[c[f>>2]>>2]|0){case 9:case 1:{k=er(0,c[(c[f>>2]|0)+4>>2]|0)|0;c[(c[g>>2]|0)+4>>2]=k;c[(c[g>>2]|0)+8>>2]=0;break}case 0:{k=c[33976]|0;a=c[33980]|0;c[d>>2]=c[c[f>>2]>>2];Db[k&511](a,128952,d);break}case 7:{c[h>>2]=c[(c[f>>2]|0)+28>>2];d=dv(0,c[h>>2]|0)|0;c[(c[g>>2]|0)+28>>2]=d;break}case 8:{c[(c[g>>2]|0)+28>>2]=c[(c[f>>2]|0)+28>>2];break}case 4:{d=my(c[(c[f>>2]|0)+24>>2]|0)|0;c[(c[g>>2]|0)+24>>2]=d;break}default:{}}c[e>>2]=c[g>>2];j=c[e>>2]|0;i=b;return j|0}function Ar(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;if(c[d>>2]|0)c[e>>2]=my(129e3)|0;else c[e>>2]=my(129008)|0;i=b;return c[e>>2]|0}function Br(b){b=+b;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+112|0;e=d;f=d+8|0;g=d+12|0;h[e>>3]=b;j=Mq(+h[e>>3])|0;do if((j|0)==1)c[f>>2]=my(129016)|0;else if((j|0)==-1)c[f>>2]=my(129032)|0;else{if(Lq(+h[e>>3])|0){c[f>>2]=my(129048)|0;break}if(+h[e>>3]==0?(et(+h[e>>3])|0)!=0:0){c[f>>2]=my(129056)|0;break}mt(+h[e>>3],g,99);a[g+99>>0]=0;c[f>>2]=my(g)|0}while(0);i=d;return c[f>>2]|0}function Cr(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;if(((c[e>>2]|0)!=0?(c[c[e>>2]>>2]|0)!=0:0)?(c[(c[e>>2]|0)+8>>2]|0)!=0:0){if((c[c[e>>2]>>2]|0)>1)Zq(c[e>>2]|0);c[d>>2]=ir(c[c[(c[e>>2]|0)+8>>2]>>2]|0)|0;f=c[d>>2]|0;i=b;return f|0}c[d>>2]=my(128928)|0;f=c[d>>2]|0;i=b;return f|0}function Dr(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;e=b+8|0;c[e>>2]=a;if(c[e>>2]|0)h[d>>3]=1;else h[d>>3]=0;i=b;return+ +h[d>>3]}function Er(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;e=+Fr(c[d>>2]|0);i=b;return+e}function Fr(a){a=a|0;var b=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+80|0;e=b+24|0;f=b+64|0;g=b+60|0;j=b+16|0;k=b+56|0;l=b+52|0;m=b+48|0;n=b+44|0;o=b+40|0;p=b+8|0;q=b+36|0;r=b+32|0;s=b;c[f>>2]=a;c[g>>2]=c[f>>2];c[k>>2]=0;c[l>>2]=0;c[m>>2]=0;c[n>>2]=0;c[o>>2]=0;if(!(c[g>>2]|0)){h[e>>3]=0;t=+h[e>>3];i=b;return+t}while(1){do if((d[c[g>>2]>>0]|0|0)==32)u=1;else{if(9<=(d[c[g>>2]>>0]|0|0)?(d[c[g>>2]>>0]|0|0)<=10:0){u=1;break}u=(d[c[g>>2]>>0]|0|0)==13}while(0);v=c[g>>2]|0;if(!u)break;c[g>>2]=v+1}do if((d[v>>0]|0|0)!=46){if((d[c[g>>2]>>0]|0|0)>=48?(d[c[g>>2]>>0]|0|0)<=57:0)break;if((d[c[g>>2]>>0]|0|0)!=45){h[e>>3]=+h[15984];t=+h[e>>3];i=b;return+t}}while(0);if((d[c[g>>2]>>0]|0|0)==45){c[l>>2]=1;c[g>>2]=(c[g>>2]|0)+1}h[j>>3]=0;while(1){if((d[c[g>>2]>>0]|0|0)<48)break;if((d[c[g>>2]>>0]|0|0)>57)break;h[j>>3]=+h[j>>3]*10;c[o>>2]=(d[c[g>>2]>>0]|0)-48;c[k>>2]=1;c[g>>2]=(c[g>>2]|0)+1;h[p>>3]=+((c[o>>2]|0)>>>0);h[j>>3]=+h[j>>3]+ +h[p>>3]}a:do if((d[c[g>>2]>>0]|0|0)==46){c[r>>2]=0;h[s>>3]=0;c[g>>2]=(c[g>>2]|0)+1;if((d[c[g>>2]>>0]|0|0)<48){if(!(c[k>>2]|0))w=24}else if(!((c[k>>2]|0)!=0?1:(d[c[g>>2]>>0]|0|0)<=57))w=24;if((w|0)==24){h[e>>3]=+h[15984];t=+h[e>>3];i=b;return+t}while(1){if((d[c[g>>2]>>0]|0|0)<48)break;if(!((c[r>>2]|0)<20?(d[c[g>>2]>>0]|0|0)<=57:0))break;c[q>>2]=(d[c[g>>2]>>0]|0)-48;h[s>>3]=+h[s>>3]*10+ +(c[q>>2]|0);c[r>>2]=(c[r>>2]|0)+1;c[g>>2]=(c[g>>2]|0)+1}h[s>>3]=+h[s>>3]/+h[129232+(c[r>>2]<<3)>>3];h[j>>3]=+h[j>>3]+ +h[s>>3];while(1){if((d[c[g>>2]>>0]|0|0)<48)break a;if((d[c[g>>2]>>0]|0|0)>57)break a;c[g>>2]=(c[g>>2]|0)+1}}while(0);if(!((d[c[g>>2]>>0]|0|0)!=101?(d[c[g>>2]>>0]|0|0)!=69:0))w=34;b:do if((w|0)==34){c[g>>2]=(c[g>>2]|0)+1;if((d[c[g>>2]>>0]|0|0)!=45){if((d[c[g>>2]>>0]|0|0)==43)c[g>>2]=(c[g>>2]|0)+1}else{c[n>>2]=1;c[g>>2]=(c[g>>2]|0)+1}while(1){if((d[c[g>>2]>>0]|0|0)<48)break b;if((d[c[g>>2]>>0]|0|0)>57)break b;c[m>>2]=((c[m>>2]|0)*10|0)+((d[c[g>>2]>>0]|0)-48);c[g>>2]=(c[g>>2]|0)+1}}while(0);while(1){do if((d[c[g>>2]>>0]|0|0)==32)x=1;else{if(9<=(d[c[g>>2]>>0]|0|0)?(d[c[g>>2]>>0]|0|0)<=10:0){x=1;break}x=(d[c[g>>2]>>0]|0|0)==13}while(0);y=c[g>>2]|0;if(!x)break;c[g>>2]=y+1}if(d[y>>0]|0){h[e>>3]=+h[15984];t=+h[e>>3];i=b;return+t}if(c[l>>2]|0)h[j>>3]=-+h[j>>3];if(c[n>>2]|0)c[m>>2]=0-(c[m>>2]|0);z=+T(10,+ +(c[m>>2]|0));h[j>>3]=+h[j>>3]*z;h[e>>3]=+h[j>>3];t=+h[e>>3];i=b;return+t}function Gr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b+8|0;e=b+20|0;f=b+16|0;g=b;c[e>>2]=a;if(!(c[e>>2]|0)){h[d>>3]=+h[15984];j=+h[d>>3];i=b;return+j}c[f>>2]=ir(c[e>>2]|0)|0;if(!(c[f>>2]|0)){h[d>>3]=+h[15984];j=+h[d>>3];i=b;return+j}else{h[g>>3]=+Er(c[f>>2]|0);zb[c[135736>>2]&511](c[f>>2]|0);h[d>>3]=+h[g>>3];j=+h[d>>3];i=b;return+j}return+0}function Hr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b+8|0;e=b+20|0;f=b+16|0;g=b;c[e>>2]=a;if(!(c[e>>2]|0)){h[d>>3]=+h[15984];j=+h[d>>3];i=b;return+j}else{c[f>>2]=Cr(c[e>>2]|0)|0;h[g>>3]=+Er(c[f>>2]|0);zb[c[135736>>2]&511](c[f>>2]|0);h[d>>3]=+h[g>>3];j=+h[d>>3];i=b;return+j}return+0}function Ir(a){a=+a;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b;h[e>>3]=a;f=(Lq(+h[e>>3])|0)!=0;if(f|+h[e>>3]==0){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{c[d>>2]=1;g=c[d>>2]|0;i=b;return g|0}return 0}function Jr(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;if((c[e>>2]|0)!=0?(xy(c[e>>2]|0)|0)!=0:0)c[d>>2]=1;else c[d>>2]=0;i=b;return c[d>>2]|0}function Kr(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;if((c[e>>2]|0)!=0?(c[c[e>>2]>>2]|0)!=0:0)c[d>>2]=1;else c[d>>2]=0;i=b;return c[d>>2]|0}function Lr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](204)|0;if(!(c[f>>2]|0)){it(0,129096);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{cU(c[f>>2]|0,0,204)|0;c[c[f>>2]>>2]=c[e>>2];c[(c[f>>2]|0)+4>>2]=0;c[(c[f>>2]|0)+16>>2]=0;c[(c[f>>2]|0)+20>>2]=0;c[(c[f>>2]|0)+24>>2]=0;c[(c[f>>2]|0)+28>>2]=0;e=Ij(0)|0;c[(c[f>>2]|0)+40>>2]=e;c[(c[f>>2]|0)+44>>2]=0;c[(c[f>>2]|0)+48>>2]=0;c[(c[f>>2]|0)+52>>2]=0;c[(c[f>>2]|0)+88>>2]=0;c[(c[f>>2]|0)+64>>2]=0;c[(c[f>>2]|0)+68>>2]=-1;c[(c[f>>2]|0)+72>>2]=-1;Mr(c[f>>2]|0);c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function Mr(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;jr(c[d>>2]|0,129592,261)|0;jr(c[d>>2]|0,129600,262)|0;jr(c[d>>2]|0,129608,263)|0;jr(c[d>>2]|0,129616,264)|0;jr(c[d>>2]|0,129624,265)|0;jr(c[d>>2]|0,129640,266)|0;jr(c[d>>2]|0,129008,267)|0;jr(c[d>>2]|0,129648,268)|0;jr(c[d>>2]|0,129656,269)|0;jr(c[d>>2]|0,129664,270)|0;jr(c[d>>2]|0,129672,271)|0;jr(c[d>>2]|0,129688,272)|0;jr(c[d>>2]|0,129696,273)|0;jr(c[d>>2]|0,129704,274)|0;jr(c[d>>2]|0,129720,275)|0;jr(c[d>>2]|0,129736,276)|0;jr(c[d>>2]|0,129744,277)|0;jr(c[d>>2]|0,129760,278)|0;jr(c[d>>2]|0,129768,279)|0;jr(c[d>>2]|0,129776,280)|0;jr(c[d>>2]|0,129792,281)|0;jr(c[d>>2]|0,129808,282)|0;jr(c[d>>2]|0,129824,283)|0;jr(c[d>>2]|0,129848,284)|0;jr(c[d>>2]|0,129864,285)|0;jr(c[d>>2]|0,129e3,286)|0;jr(c[d>>2]|0,129872,287)|0;kr(c[d>>2]|0,129888,129904,288)|0;i=b;return}function Nr(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+200>>2]|0)ht(c[(c[d>>2]|0)+200>>2]|0);tr(c[d>>2]|0);nr(c[d>>2]|0);qr(c[d>>2]|0);Yd((c[d>>2]|0)+136|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function Or(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=Cb[c[135744>>2]&511](48)|0;if(!(c[h>>2]|0)){it(c[g>>2]|0,129120);c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}b=(c[h>>2]|0)+0|0;a=b+48|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(a|0));b=c[f>>2]|0;c[(c[h>>2]|0)+4>>2]=b;c[c[h>>2]>>2]=b;c[(c[h>>2]|0)+12>>2]=c[g>>2];b=pt()|0;c[(c[h>>2]|0)+32>>2]=b;if(!(c[(c[h>>2]|0)+32>>2]|0)){zb[c[135736>>2]&511](c[(c[h>>2]|0)+28>>2]|0);zb[c[135736>>2]&511](c[h>>2]|0);c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+192>>2]|0)!=0:0){c[(c[(c[h>>2]|0)+32>>2]|0)+20>>2]=c[(c[g>>2]|0)+192>>2];yP(c[(c[(c[h>>2]|0)+32>>2]|0)+20>>2]|0)|0}c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}function Pr(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(c[(c[d>>2]|0)+28>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+28>>2]|0);if(!(c[(c[d>>2]|0)+32>>2]|0)){e=c[33934]|0;f=c[d>>2]|0;zb[e&511](f);i=b;return}if(c[(c[(c[d>>2]|0)+32>>2]|0)+24>>2]|0){FQ(c[(c[(c[d>>2]|0)+32>>2]|0)+24>>2]|0);c[(c[(c[d>>2]|0)+32>>2]|0)+24>>2]=0}Pq(c[(c[d>>2]|0)+32>>2]|0);e=c[33934]|0;f=c[d>>2]|0;zb[e&511](f);i=b;return}function Qr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+32|0;d=b;e=b+28|0;f=b+24|0;g=b+20|0;j=b+16|0;k=b+12|0;l=b+8|0;c[f>>2]=a;c[l>>2]=0;if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+12>>2]|0)!=0:0){c[j>>2]=Sq(c[f>>2]|0)|0;c[g>>2]=Sq(c[f>>2]|0)|0;a=c[g>>2]|0;if((c[g>>2]|0)==0|(c[j>>2]|0)==0){m=c[(c[f>>2]|0)+12>>2]|0;if(a)jt(m,c[g>>2]|0);else jt(m,c[j>>2]|0);Nq(c[f>>2]|0,10);c[e>>2]=0;n=c[e>>2]|0;i=b;return n|0}if((a|0)==(c[j>>2]|0)){Qq(c[g>>2]|0);c[e>>2]=1;n=c[e>>2]|0;i=b;return n|0}if((((c[c[j>>2]>>2]|0)!=1?(c[c[j>>2]>>2]|0)!=9:0)?(c[c[g>>2]>>2]|0)!=1:0)?(c[c[g>>2]>>2]|0)!=9:0){c[e>>2]=tt(c[f>>2]|0,c[g>>2]|0,c[j>>2]|0)|0;n=c[e>>2]|0;i=b;return n|0}if((c[c[g>>2]>>2]|0)!=1?(c[c[g>>2]>>2]|0)!=9:0){c[k>>2]=c[j>>2];c[j>>2]=c[g>>2];c[g>>2]=c[k>>2]}switch(c[c[j>>2]>>2]|0){case 2:{if((c[(c[g>>2]|0)+4>>2]|0)!=0?(c[c[(c[g>>2]|0)+4>>2]>>2]|0)!=0:0)c[l>>2]=1;else c[l>>2]=0;c[l>>2]=(c[l>>2]|0)==(c[(c[j>>2]|0)+8>>2]|0)&1;break}case 3:{c[l>>2]=rt(c[f>>2]|0,c[g>>2]|0,+h[(c[j>>2]|0)+16>>3],0)|0;break}case 4:{c[l>>2]=st(c[g>>2]|0,c[(c[j>>2]|0)+24>>2]|0,0)|0;break}case 6:case 5:case 8:case 7:{k=c[33976]|0;a=c[33980]|0;c[d>>2]=128552;c[d+4>>2]=7204;Db[k&511](a,129064,d);break}case 9:case 1:{c[l>>2]=qt(c[g>>2]|0,c[j>>2]|0,0)|0;break}default:{}}jt(c[(c[f>>2]|0)+12>>2]|0,c[g>>2]|0);jt(c[(c[f>>2]|0)+12>>2]|0,c[j>>2]|0);c[e>>2]=c[l>>2];n=c[e>>2]|0;i=b;return n|0}c[e>>2]=0;n=c[e>>2]|0;i=b;return n|0}function Rr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+32|0;d=b;e=b+28|0;f=b+24|0;g=b+20|0;j=b+16|0;k=b+12|0;l=b+8|0;c[f>>2]=a;c[l>>2]=0;if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+12>>2]|0)!=0:0){c[j>>2]=Sq(c[f>>2]|0)|0;c[g>>2]=Sq(c[f>>2]|0)|0;a=c[g>>2]|0;if((c[g>>2]|0)==0|(c[j>>2]|0)==0){m=c[(c[f>>2]|0)+12>>2]|0;if(a)jt(m,c[g>>2]|0);else jt(m,c[j>>2]|0);Nq(c[f>>2]|0,10);c[e>>2]=0;n=c[e>>2]|0;i=b;return n|0}if((a|0)==(c[j>>2]|0)){jt(c[(c[f>>2]|0)+12>>2]|0,c[g>>2]|0);c[e>>2]=0;n=c[e>>2]|0;i=b;return n|0}if((((c[c[j>>2]>>2]|0)!=1?(c[c[j>>2]>>2]|0)!=9:0)?(c[c[g>>2]>>2]|0)!=1:0)?(c[c[g>>2]>>2]|0)!=9:0){c[e>>2]=((tt(c[f>>2]|0,c[g>>2]|0,c[j>>2]|0)|0)!=0^1)&1;n=c[e>>2]|0;i=b;return n|0}if((c[c[g>>2]>>2]|0)!=1?(c[c[g>>2]>>2]|0)!=9:0){c[k>>2]=c[j>>2];c[j>>2]=c[g>>2];c[g>>2]=c[k>>2]}switch(c[c[j>>2]>>2]|0){case 2:{if((c[(c[g>>2]|0)+4>>2]|0)!=0?(c[c[(c[g>>2]|0)+4>>2]>>2]|0)!=0:0)c[l>>2]=1;else c[l>>2]=0;c[l>>2]=(c[l>>2]|0)!=(c[(c[j>>2]|0)+8>>2]|0)&1;break}case 4:{c[l>>2]=st(c[g>>2]|0,c[(c[j>>2]|0)+24>>2]|0,1)|0;break}case 3:{c[l>>2]=rt(c[f>>2]|0,c[g>>2]|0,+h[(c[j>>2]|0)+16>>3],1)|0;break}case 6:case 5:case 8:case 7:{k=c[33976]|0;a=c[33980]|0;c[d>>2]=128552;c[d+4>>2]=7289;Db[k&511](a,129064,d);break}case 9:case 1:{c[l>>2]=qt(c[g>>2]|0,c[j>>2]|0,1)|0;break}default:{}}jt(c[(c[f>>2]|0)+12>>2]|0,c[g>>2]|0);jt(c[(c[f>>2]|0)+12>>2]|0,c[j>>2]|0);c[e>>2]=c[l>>2];n=c[e>>2]|0;i=b;return n|0}c[e>>2]=0;n=c[e>>2]|0;i=b;return n|0}function Sr(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+48|0;f=e+32|0;g=e+28|0;j=e+24|0;k=e+20|0;l=e+16|0;m=e+12|0;n=e+8|0;o=e+4|0;p=e;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=0;c[m>>2]=0;c[n>>2]=0;if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+12>>2]|0)!=0:0){c[p>>2]=Sq(c[g>>2]|0)|0;c[o>>2]=Sq(c[g>>2]|0)|0;if((c[o>>2]|0)==0|(c[p>>2]|0)==0){d=c[(c[g>>2]|0)+12>>2]|0;if(c[o>>2]|0)jt(d,c[o>>2]|0);else jt(d,c[p>>2]|0);Nq(c[g>>2]|0,10);c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}if((((c[c[p>>2]>>2]|0)!=1?(c[c[p>>2]>>2]|0)!=9:0)?(c[c[o>>2]>>2]|0)!=1:0)?(c[c[o>>2]>>2]|0)!=9:0){if((c[c[o>>2]>>2]|0)!=3){Tq(c[g>>2]|0,c[o>>2]|0)|0;Tr(c[g>>2]|0,1);c[o>>2]=Sq(c[g>>2]|0)|0}if((c[c[o>>2]>>2]|0)!=3){Qq(c[o>>2]|0);Qq(c[p>>2]|0);Nq(c[g>>2]|0,10);c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}if((c[c[p>>2]>>2]|0)!=3){Tq(c[g>>2]|0,c[p>>2]|0)|0;Tr(c[g>>2]|0,1);c[p>>2]=Sq(c[g>>2]|0)|0}if((c[c[p>>2]>>2]|0)!=3){jt(c[(c[g>>2]|0)+12>>2]|0,c[o>>2]|0);jt(c[(c[g>>2]|0)+12>>2]|0,c[p>>2]|0);Nq(c[g>>2]|0,10);c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}a:do if((Lq(+h[(c[o>>2]|0)+16>>3])|0)==0?(Lq(+h[(c[p>>2]|0)+16>>3])|0)==0:0){c[m>>2]=Mq(+h[(c[o>>2]|0)+16>>3])|0;c[n>>2]=Mq(+h[(c[p>>2]|0)+16>>3])|0;if((c[j>>2]|0)!=0&(c[k>>2]|0)!=0){do if(!((c[m>>2]|0)==-1&(c[n>>2]|0)!=-1)){if((c[n>>2]|0)==1&(c[m>>2]|0)!=1)break;if((c[m>>2]|0)==0&(c[n>>2]|0)==0){c[l>>2]=+h[(c[o>>2]|0)+16>>3]<+h[(c[p>>2]|0)+16>>3]&1;break a}else{c[l>>2]=0;break a}}while(0);c[l>>2]=1;break}if(!((c[j>>2]|0)==0|(c[k>>2]|0)!=0)){if((c[m>>2]|0)==-1|(c[n>>2]|0)==1){c[l>>2]=1;break}if((c[m>>2]|0)==0&(c[n>>2]|0)==0){c[l>>2]=+h[(c[o>>2]|0)+16>>3]<=+h[(c[p>>2]|0)+16>>3]&1;break}else{c[l>>2]=0;break}}if(!((c[j>>2]|0)==0&(c[k>>2]|0)!=0)){if((c[j>>2]|0)!=0|(c[k>>2]|0)!=0)break;if((c[m>>2]|0)==1|(c[n>>2]|0)==-1){c[l>>2]=1;break}if((c[m>>2]|0)==0&(c[n>>2]|0)==0){c[l>>2]=+h[(c[o>>2]|0)+16>>3]>=+h[(c[p>>2]|0)+16>>3]&1;break}else{c[l>>2]=0;break}}else{do if(!((c[m>>2]|0)==1&(c[n>>2]|0)!=1)){if((c[n>>2]|0)==-1&(c[m>>2]|0)!=-1)break;if((c[m>>2]|0)==0&(c[n>>2]|0)==0){c[l>>2]=+h[(c[o>>2]|0)+16>>3]>+h[(c[p>>2]|0)+16>>3]&1;break a}else{c[l>>2]=0;break a}}while(0);c[l>>2]=1;break}}else r=33;while(0);if((r|0)==33)c[l>>2]=0;jt(c[(c[g>>2]|0)+12>>2]|0,c[o>>2]|0);jt(c[(c[g>>2]|0)+12>>2]|0,c[p>>2]|0);c[f>>2]=c[l>>2];q=c[f>>2]|0;i=e;return q|0}if((c[c[p>>2]>>2]|0)!=1?(c[c[p>>2]>>2]|0)!=9:0)r=18;else r=15;do if((r|0)==15){if((c[c[o>>2]>>2]|0)!=1?(c[c[o>>2]>>2]|0)!=9:0){r=18;break}c[l>>2]=ut(c[j>>2]|0,c[k>>2]|0,c[o>>2]|0,c[p>>2]|0)|0}while(0);do if((r|0)==18){if((c[c[o>>2]>>2]|0)!=1?(c[c[o>>2]>>2]|0)!=9:0){c[l>>2]=vt(c[g>>2]|0,((c[j>>2]|0)!=0^1)&1,c[k>>2]|0,c[p>>2]|0,c[o>>2]|0)|0;break}c[l>>2]=vt(c[g>>2]|0,c[j>>2]|0,c[k>>2]|0,c[o>>2]|0,c[p>>2]|0)|0}while(0);c[f>>2]=c[l>>2];q=c[f>>2]|0;i=e;return q|0}c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}function Tr(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;j=d;k=d+8|0;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}b=c[e>>2]|0;if(!(c[f>>2]|0)){a=c[e>>2]|0;if(!(c[(c[b+12>>2]|0)+4>>2]|0)){Tq(a,wt(c[(c[e>>2]|0)+12>>2]|0,0)|0)|0;i=d;return}else{c[k>>2]=_i(c[(c[a+12>>2]|0)+4>>2]|0)|0;h[j>>3]=+Fr(c[k>>2]|0);a=c[e>>2]|0;Tq(a,wt(c[(c[e>>2]|0)+12>>2]|0,+h[j>>3])|0)|0;zb[c[135736>>2]&511](c[k>>2]|0);i=d;return}}if(!b){i=d;return}b=c[e>>2]|0;if((c[f>>2]|0)!=1){Nq(b,12);i=d;return}f=c[e>>2]|0;if((c[b+20>>2]|0)<((c[(c[e>>2]|0)+44>>2]|0)+1|0)){Nq(f,23);i=d;return}else{c[g>>2]=Sq(f)|0;f=c[e>>2]|0;Tq(f,xt(c[(c[e>>2]|0)+12>>2]|0,c[g>>2]|0)|0)|0;i=d;return}}function Ur(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(!(c[(c[d>>2]|0)+12>>2]|0)){i=b;return}if((c[(c[d>>2]|0)+16>>2]|0)!=0?(c[c[(c[d>>2]|0)+16>>2]>>2]|0)!=3:0)Tr(c[d>>2]|0,1);if((c[(c[d>>2]|0)+16>>2]|0)!=0?(c[c[(c[d>>2]|0)+16>>2]>>2]|0)==3:0){if(Lq(+h[(c[(c[d>>2]|0)+16>>2]|0)+16>>3])|0){h[(c[(c[d>>2]|0)+16>>2]|0)+16>>3]=+h[15984];i=b;return}if((Mq(+h[(c[(c[d>>2]|0)+16>>2]|0)+16>>3])|0)==1){h[(c[(c[d>>2]|0)+16>>2]|0)+16>>3]=+h[15986];i=b;return}if((Mq(+h[(c[(c[d>>2]|0)+16>>2]|0)+16>>3])|0)==-1){h[(c[(c[d>>2]|0)+16>>2]|0)+16>>3]=+h[15985];i=b;return}e=+h[(c[(c[d>>2]|0)+16>>2]|0)+16>>3];if(!(+h[(c[(c[d>>2]|0)+16>>2]|0)+16>>3]==0)){h[(c[(c[d>>2]|0)+16>>2]|0)+16>>3]=-e;i=b;return}if(!(et(e)|0)){h[(c[(c[d>>2]|0)+16>>2]|0)+16>>3]=+h[15988];i=b;return}else{h[(c[(c[d>>2]|0)+16>>2]|0)+16>>3]=0;i=b;return}}Nq(c[d>>2]|0,11);i=b;return}function Vr(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b;c[d>>2]=a;c[e>>2]=Sq(c[d>>2]|0)|0;if(!(c[e>>2]|0)){Nq(c[d>>2]|0,10);i=b;return}h[f>>3]=+Wq(c[e>>2]|0);jt(c[(c[d>>2]|0)+12>>2]|0,c[e>>2]|0);if((c[(c[d>>2]|0)+16>>2]|0)!=0?(c[c[(c[d>>2]|0)+16>>2]>>2]|0)!=3:0)Tr(c[d>>2]|0,1);if((c[(c[d>>2]|0)+16>>2]|0)!=0?(c[c[(c[d>>2]|0)+16>>2]>>2]|0)==3:0){e=(c[(c[d>>2]|0)+16>>2]|0)+16|0;h[e>>3]=+h[e>>3]+ +h[f>>3];i=b;return}Nq(c[d>>2]|0,11);i=b;return}function Wr(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b;c[d>>2]=a;c[e>>2]=Sq(c[d>>2]|0)|0;if(!(c[e>>2]|0)){Nq(c[d>>2]|0,10);i=b;return}h[f>>3]=+Wq(c[e>>2]|0);jt(c[(c[d>>2]|0)+12>>2]|0,c[e>>2]|0);if((c[(c[d>>2]|0)+16>>2]|0)!=0?(c[c[(c[d>>2]|0)+16>>2]>>2]|0)!=3:0)Tr(c[d>>2]|0,1);if((c[(c[d>>2]|0)+16>>2]|0)!=0?(c[c[(c[d>>2]|0)+16>>2]>>2]|0)==3:0){e=(c[(c[d>>2]|0)+16>>2]|0)+16|0;h[e>>3]=+h[e>>3]-+h[f>>3];i=b;return}Nq(c[d>>2]|0,11);i=b;return}function Xr(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b;c[d>>2]=a;c[e>>2]=Sq(c[d>>2]|0)|0;if(!(c[e>>2]|0)){Nq(c[d>>2]|0,10);i=b;return}h[f>>3]=+Wq(c[e>>2]|0);jt(c[(c[d>>2]|0)+12>>2]|0,c[e>>2]|0);if((c[(c[d>>2]|0)+16>>2]|0)!=0?(c[c[(c[d>>2]|0)+16>>2]>>2]|0)!=3:0)Tr(c[d>>2]|0,1);if((c[(c[d>>2]|0)+16>>2]|0)!=0?(c[c[(c[d>>2]|0)+16>>2]>>2]|0)==3:0){e=(c[(c[d>>2]|0)+16>>2]|0)+16|0;h[e>>3]=+h[e>>3]*+h[f>>3];i=b;return}Nq(c[d>>2]|0,11);i=b;return}function Yr(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b;c[d>>2]=a;c[e>>2]=Sq(c[d>>2]|0)|0;if(!(c[e>>2]|0)){Nq(c[d>>2]|0,10);i=b;return}h[f>>3]=+Wq(c[e>>2]|0);jt(c[(c[d>>2]|0)+12>>2]|0,c[e>>2]|0);if((c[(c[d>>2]|0)+16>>2]|0)!=0?(c[c[(c[d>>2]|0)+16>>2]>>2]|0)!=3:0)Tr(c[d>>2]|0,1);if((c[(c[d>>2]|0)+16>>2]|0)!=0?(c[c[(c[d>>2]|0)+16>>2]>>2]|0)==3:0){if((Lq(+h[f>>3])|0)==0?(Lq(+h[(c[(c[d>>2]|0)+16>>2]|0)+16>>3])|0)==0:0){if(+h[f>>3]==0?(et(+h[f>>3])|0)!=0:0){if(+h[(c[(c[d>>2]|0)+16>>2]|0)+16>>3]==0){h[(c[(c[d>>2]|0)+16>>2]|0)+16>>3]=+h[15984];i=b;return}if(+h[(c[(c[d>>2]|0)+16>>2]|0)+16>>3]>0){h[(c[(c[d>>2]|0)+16>>2]|0)+16>>3]=+h[15986];i=b;return}if(!(+h[(c[(c[d>>2]|0)+16>>2]|0)+16>>3]<0)){i=b;return}h[(c[(c[d>>2]|0)+16>>2]|0)+16>>3]=+h[15985];i=b;return}if(!(+h[f>>3]==0)){e=(c[(c[d>>2]|0)+16>>2]|0)+16|0;h[e>>3]=+h[e>>3]/+h[f>>3];i=b;return}if(+h[(c[(c[d>>2]|0)+16>>2]|0)+16>>3]==0){h[(c[(c[d>>2]|0)+16>>2]|0)+16>>3]=+h[15984];i=b;return}if(+h[(c[(c[d>>2]|0)+16>>2]|0)+16>>3]>0){h[(c[(c[d>>2]|0)+16>>2]|0)+16>>3]=+h[15985];i=b;return}if(!(+h[(c[(c[d>>2]|0)+16>>2]|0)+16>>3]<0)){i=b;return}h[(c[(c[d>>2]|0)+16>>2]|0)+16>>3]=+h[15986];i=b;return}h[(c[(c[d>>2]|0)+16>>2]|0)+16>>3]=+h[15984];i=b;return}Nq(c[d>>2]|0,11);i=b;return}function Zr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b+20|0;e=b+16|0;f=b+8|0;g=b;c[d>>2]=a;c[e>>2]=Sq(c[d>>2]|0)|0;if(!(c[e>>2]|0)){Nq(c[d>>2]|0,10);i=b;return}h[g>>3]=+Wq(c[e>>2]|0);jt(c[(c[d>>2]|0)+12>>2]|0,c[e>>2]|0);if((c[(c[d>>2]|0)+16>>2]|0)!=0?(c[c[(c[d>>2]|0)+16>>2]>>2]|0)!=3:0)Tr(c[d>>2]|0,1);if((c[(c[d>>2]|0)+16>>2]|0)!=0?(c[c[(c[d>>2]|0)+16>>2]>>2]|0)==3:0){h[f>>3]=+h[(c[(c[d>>2]|0)+16>>2]|0)+16>>3];if(+h[g>>3]==0){h[(c[(c[d>>2]|0)+16>>2]|0)+16>>3]=+h[15984];i=b;return}else{j=+uT(+h[f>>3],+h[g>>3]);h[(c[(c[d>>2]|0)+16>>2]|0)+16>>3]=j;i=b;return}}Nq(c[d>>2]|0,11);i=b;return}function _r(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;do if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+12>>2]|0)!=0:0)if(!(c[g>>2]|0)){c[e>>2]=c[(c[(c[f>>2]|0)+12>>2]|0)+4>>2];break}else{c[e>>2]=0;break}else h=3;while(0);if((h|0)==3)c[e>>2]=0;i=d;return c[e>>2]|0}function $r(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;a:do if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+12>>2]|0)!=0:0){if(c[g>>2]|0){if((c[(c[g>>2]|0)+4>>2]|0)!=9?(c[(c[g>>2]|0)+4>>2]|0)!=13:0){c[e>>2]=c[(c[g>>2]|0)+24>>2];break}c[e>>2]=0;break}if(!(c[(c[(c[f>>2]|0)+12>>2]|0)+4>>2]|0)){c[e>>2]=0;break}switch(c[(c[(c[(c[f>>2]|0)+12>>2]|0)+4>>2]|0)+4>>2]|0){case 20:case 19:case 18:case 2:case 17:case 16:case 15:{c[e>>2]=0;break a;break}case 14:case 12:case 8:case 7:case 6:case 5:case 4:case 3:case 1:{c[e>>2]=c[(c[(c[(c[f>>2]|0)+12>>2]|0)+4>>2]|0)+12>>2];break a;break}case 21:case 13:case 11:case 10:case 9:{c[e>>2]=c[(c[(c[(c[f>>2]|0)+12>>2]|0)+4>>2]|0)+12>>2];break a;break}default:{c[e>>2]=0;break a}}}else h=3;while(0);if((h|0)==3)c[e>>2]=0;i=d;return c[e>>2]|0}function as(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+12>>2]|0)!=0:0){if(!(c[g>>2]|0)){if(!(c[(c[(c[f>>2]|0)+12>>2]|0)+4>>2]|0)){c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}if((c[(c[(c[(c[f>>2]|0)+12>>2]|0)+4>>2]|0)+4>>2]|0)!=2?(c[(c[(c[(c[f>>2]|0)+12>>2]|0)+4>>2]|0)+4>>2]|0)!=18:0){b=c[(c[f>>2]|0)+12>>2]|0;if((c[(c[(c[f>>2]|0)+12>>2]|0)+4>>2]|0)==(c[c[(c[f>>2]|0)+12>>2]>>2]|0)){c[e>>2]=c[(c[b>>2]|0)+12>>2];h=c[e>>2]|0;i=d;return h|0}else{c[e>>2]=c[(c[b+4>>2]|0)+12>>2];h=c[e>>2]|0;i=d;return h|0}}c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}if((c[(c[g>>2]|0)+4>>2]|0)==18){c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}if(((c[(c[g>>2]|0)+12>>2]|0)!=0?(c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]|0)!=17:0)?(c[g>>2]=c[(c[g>>2]|0)+12>>2],(c[(c[g>>2]|0)+4>>2]|0)!=14):0){c[e>>2]=c[g>>2];h=c[e>>2]|0;i=d;return h|0}if((c[g>>2]|0)==(c[(c[(c[f>>2]|0)+12>>2]|0)+4>>2]|0)){c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}while(1){if(!(c[(c[g>>2]|0)+24>>2]|0))break;c[g>>2]=c[(c[g>>2]|0)+24>>2];if((c[(c[g>>2]|0)+4>>2]|0)==17)continue;if((c[(c[g>>2]|0)+4>>2]|0)!=14){j=24;break}}if((j|0)==24){c[e>>2]=c[g>>2];h=c[e>>2]|0;i=d;return h|0}while(1){c[g>>2]=c[(c[g>>2]|0)+20>>2];if(!(c[g>>2]|0)){j=31;break}if((c[g>>2]|0)==(c[(c[(c[f>>2]|0)+12>>2]|0)+4>>2]|0)){j=27;break}k=c[g>>2]|0;if(c[(c[g>>2]|0)+24>>2]|0){j=29;break}if(!k){j=31;break}}if((j|0)==27){c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}else if((j|0)==29){c[g>>2]=c[k+24>>2];c[e>>2]=c[g>>2];h=c[e>>2]|0;i=d;return h|0}else if((j|0)==31){c[e>>2]=c[g>>2];h=c[e>>2]|0;i=d;return h|0}}c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}function bs(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+12>>2]|0)!=0:0){b=c[f>>2]|0;if(c[g>>2]|0){c[e>>2]=as(b,c[g>>2]|0)|0;h=c[e>>2]|0;i=d;return h|0}if(!(c[(c[b+12>>2]|0)+4>>2]|0)){c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}if((c[(c[(c[(c[f>>2]|0)+12>>2]|0)+4>>2]|0)+4>>2]|0)!=2?(c[(c[(c[(c[f>>2]|0)+12>>2]|0)+4>>2]|0)+4>>2]|0)!=18:0){c[e>>2]=c[(c[(c[f>>2]|0)+12>>2]|0)+4>>2];h=c[e>>2]|0;i=d;return h|0}c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}function cs(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+12>>2]|0)!=0:0){a:do if(!(c[h>>2]|0)){if(!(c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]|0)){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}switch(c[(c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]|0)+4>>2]|0){case 2:{c[j>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2];c[f>>2]=c[(c[j>>2]|0)+20>>2];l=c[f>>2]|0;i=e;return l|0}case 21:case 13:case 11:case 10:case 9:{c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}case 18:{c[k>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2];if((c[c[k>>2]>>2]|0)!=0?(c[(c[c[k>>2]>>2]|0)+4>>2]|0)!=18:0){c[f>>2]=c[c[k>>2]>>2];l=c[f>>2]|0;i=e;return l|0}c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}case 17:case 20:case 19:case 16:case 15:case 14:case 12:case 8:case 7:case 6:case 5:case 4:case 3:case 1:{b=c[(c[g>>2]|0)+12>>2]|0;if(!(c[(c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]|0)+20>>2]|0)){c[f>>2]=c[b>>2];l=c[f>>2]|0;i=e;return l|0}do if((c[(c[(c[b+4>>2]|0)+20>>2]|0)+4>>2]|0)==1){if((d[c[(c[(c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]|0)+20>>2]|0)+8>>2]>>0]|0|0)!=32?(qy(c[(c[(c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]|0)+20>>2]|0)+8>>2]|0,129152)|0)==0:0)break;c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}while(0);c[f>>2]=c[(c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]|0)+20>>2];l=c[f>>2]|0;i=e;return l|0}default:break a}}while(0);c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}function ds(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[g>>2]=a;c[h>>2]=b;a:do if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+12>>2]|0)!=0:0){if(!(c[h>>2]|0)){if(!(c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]|0)){c[f>>2]=0;break}switch(c[(c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]|0)+4>>2]|0){case 2:{c[j>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2];c[f>>2]=c[(c[j>>2]|0)+20>>2];break a;break}case 18:{c[k>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2];if((c[c[k>>2]>>2]|0)!=0?(c[(c[c[k>>2]>>2]|0)+4>>2]|0)!=18:0){c[f>>2]=c[c[k>>2]>>2];break a}c[f>>2]=0;break a;break}case 20:case 19:case 12:case 17:case 16:case 15:case 14:case 8:case 7:case 6:case 5:case 4:case 3:case 1:{b=c[(c[g>>2]|0)+12>>2]|0;if(!(c[(c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]|0)+20>>2]|0)){c[f>>2]=c[b>>2];break a}do if((c[(c[(c[b+4>>2]|0)+20>>2]|0)+4>>2]|0)==1){if((d[c[(c[(c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]|0)+20>>2]|0)+8>>2]>>0]|0|0)!=32?(qy(c[(c[(c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]|0)+20>>2]|0)+8>>2]|0,129152)|0)==0:0)break;c[f>>2]=0;break a}while(0);c[f>>2]=c[(c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]|0)+20>>2];break a;break}case 21:case 13:case 11:case 10:case 9:{c[f>>2]=0;break a;break}default:{c[f>>2]=0;break a}}}if((c[h>>2]|0)==(c[(c[c[(c[g>>2]|0)+12>>2]>>2]|0)+12>>2]|0)){c[f>>2]=c[c[(c[g>>2]|0)+12>>2]>>2];break}if((c[h>>2]|0)==(c[c[(c[g>>2]|0)+12>>2]>>2]|0)){c[f>>2]=0;break}switch(c[(c[h>>2]|0)+4>>2]|0){case 21:case 13:case 11:
case 10:case 9:{c[f>>2]=0;break a;break}case 18:{c[m>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2];if((c[c[m>>2]>>2]|0)!=0?(c[(c[c[m>>2]>>2]|0)+4>>2]|0)!=18:0){c[f>>2]=c[c[m>>2]>>2];break a}c[f>>2]=0;break a;break}case 20:case 19:case 17:case 16:case 15:case 14:case 12:case 8:case 7:case 6:case 5:case 4:case 3:case 1:{if(!(c[(c[h>>2]|0)+20>>2]|0)){c[f>>2]=0;break a}do if((c[(c[(c[h>>2]|0)+20>>2]|0)+4>>2]|0)==1){if((d[c[(c[(c[h>>2]|0)+20>>2]|0)+8>>2]>>0]|0|0)!=32?(qy(c[(c[(c[h>>2]|0)+20>>2]|0)+8>>2]|0,129152)|0)==0:0)break;c[f>>2]=0;break a}while(0);c[f>>2]=c[(c[h>>2]|0)+20>>2];break a;break}case 2:{c[l>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2];c[f>>2]=c[(c[l>>2]|0)+20>>2];break a;break}default:{c[f>>2]=0;break a}}}else n=3;while(0);if((n|0)==3)c[f>>2]=0;i=e;return c[f>>2]|0}function es(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+12>>2]|0)!=0:0){b=c[f>>2]|0;if(!(c[g>>2]|0)){c[e>>2]=c[(c[b+12>>2]|0)+4>>2];h=c[e>>2]|0;i=d;return h|0}else{c[e>>2]=ds(b,c[g>>2]|0)|0;h=c[e>>2]|0;i=d;return h|0}}c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}function fs(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+12>>2]|0)!=0:0){if((c[(c[(c[(c[f>>2]|0)+12>>2]|0)+4>>2]|0)+4>>2]|0)!=2?(c[(c[(c[(c[f>>2]|0)+12>>2]|0)+4>>2]|0)+4>>2]|0)!=18:0){if((c[g>>2]|0)==(c[c[(c[f>>2]|0)+12>>2]>>2]|0)){c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}if(!(c[g>>2]|0)){c[e>>2]=c[(c[(c[(c[f>>2]|0)+12>>2]|0)+4>>2]|0)+24>>2];h=c[e>>2]|0;i=d;return h|0}else{c[e>>2]=c[(c[g>>2]|0)+24>>2];h=c[e>>2]|0;i=d;return h|0}}c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}function gs(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+12>>2]|0)!=0:0){if((c[(c[(c[(c[f>>2]|0)+12>>2]|0)+4>>2]|0)+4>>2]|0)!=2?(c[(c[(c[(c[f>>2]|0)+12>>2]|0)+4>>2]|0)+4>>2]|0)!=18:0){if((c[g>>2]|0)==(c[c[(c[f>>2]|0)+12>>2]>>2]|0)){c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}if(!(c[g>>2]|0)){c[e>>2]=c[(c[(c[(c[f>>2]|0)+12>>2]|0)+4>>2]|0)+28>>2];h=c[e>>2]|0;i=d;return h|0}if(((c[(c[g>>2]|0)+28>>2]|0)!=0?(c[(c[(c[g>>2]|0)+28>>2]|0)+4>>2]|0)==14:0)?(c[g>>2]=c[(c[g>>2]|0)+28>>2],(c[g>>2]|0)==0):0){c[e>>2]=c[(c[(c[(c[f>>2]|0)+12>>2]|0)+4>>2]|0)+28>>2];h=c[e>>2]|0;i=d;return h|0}c[e>>2]=c[(c[g>>2]|0)+28>>2];h=c[e>>2]|0;i=d;return h|0}c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}function hs(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+12>>2]|0)!=0:0){if((((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+4>>2]|0)!=2:0)?(c[(c[g>>2]|0)+4>>2]|0)!=18:0)?(c[(c[g>>2]|0)+12>>2]|0)!=0:0){c[e>>2]=c[(c[g>>2]|0)+12>>2];h=c[e>>2]|0;i=d;return h|0}do if(!(c[g>>2]|0)){c[g>>2]=c[(c[(c[f>>2]|0)+12>>2]|0)+4>>2];if((c[(c[g>>2]|0)+4>>2]|0)==18){c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}else{if((c[(c[g>>2]|0)+4>>2]|0)!=2)break;c[g>>2]=c[(c[g>>2]|0)+20>>2];break}}while(0);if(!(c[g>>2]|0)){c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}if(c[(c[g>>2]|0)+24>>2]|0){c[e>>2]=c[(c[g>>2]|0)+24>>2];h=c[e>>2]|0;i=d;return h|0}while(1){c[g>>2]=c[(c[g>>2]|0)+20>>2];if(!(c[g>>2]|0)){j=24;break}if((c[g>>2]|0)==(c[c[(c[f>>2]|0)+12>>2]>>2]|0)){j=20;break}k=c[g>>2]|0;if(c[(c[g>>2]|0)+24>>2]|0){j=22;break}if(!k){j=24;break}}if((j|0)==20){c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}else if((j|0)==22){c[e>>2]=c[k+24>>2];h=c[e>>2]|0;i=d;return h|0}else if((j|0)==24){c[e>>2]=c[g>>2];h=c[e>>2]|0;i=d;return h|0}}c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}function is(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+12>>2]|0)!=0:0){if((c[(c[(c[(c[f>>2]|0)+12>>2]|0)+4>>2]|0)+4>>2]|0)!=1){c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}if((c[(c[(c[f>>2]|0)+12>>2]|0)+120>>2]|0)==0?(c[g>>2]|0)!=(c[32294]|0):0){if(c[(c[(c[f>>2]|0)+12>>2]|0)+120>>2]|0)zb[c[135736>>2]&511](c[(c[(c[f>>2]|0)+12>>2]|0)+120>>2]|0);g=bj(c[c[(c[f>>2]|0)+12>>2]>>2]|0,c[(c[(c[f>>2]|0)+12>>2]|0)+4>>2]|0)|0;c[(c[(c[f>>2]|0)+12>>2]|0)+120>>2]=g;c[(c[(c[f>>2]|0)+12>>2]|0)+124>>2]=0;a:do if(c[(c[(c[f>>2]|0)+12>>2]|0)+120>>2]|0)while(1){if(!(c[(c[(c[(c[f>>2]|0)+12>>2]|0)+120>>2]|0)+(c[(c[(c[f>>2]|0)+12>>2]|0)+124>>2]<<2)>>2]|0))break a;g=(c[(c[f>>2]|0)+12>>2]|0)+124|0;c[g>>2]=(c[g>>2]|0)+1}while(0);c[e>>2]=c[32294];h=c[e>>2]|0;i=d;return h|0}g=c[(c[f>>2]|0)+12>>2]|0;if((c[(c[(c[f>>2]|0)+12>>2]|0)+124>>2]|0)>0){b=g+124|0;a=(c[b>>2]|0)+-1|0;c[b>>2]=a;c[e>>2]=c[(c[(c[(c[f>>2]|0)+12>>2]|0)+120>>2]|0)+(a<<2)>>2];h=c[e>>2]|0;i=d;return h|0}if(c[g+120>>2]|0)zb[c[135736>>2]&511](c[(c[(c[f>>2]|0)+12>>2]|0)+120>>2]|0);c[(c[(c[f>>2]|0)+12>>2]|0)+120>>2]=0;c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}function js(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;do if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+12>>2]|0)!=0:0){if(!(c[(c[(c[f>>2]|0)+12>>2]|0)+4>>2]|0)){c[e>>2]=0;break}if((c[(c[(c[(c[f>>2]|0)+12>>2]|0)+4>>2]|0)+4>>2]|0)!=1){c[e>>2]=0;break}if(c[g>>2]|0){c[e>>2]=c[(c[g>>2]|0)+24>>2];break}if((c[(c[(c[f>>2]|0)+12>>2]|0)+4>>2]|0)==(c[c[(c[f>>2]|0)+12>>2]>>2]|0)){c[e>>2]=0;break}else{c[e>>2]=c[(c[(c[(c[f>>2]|0)+12>>2]|0)+4>>2]|0)+44>>2];break}}else h=3;while(0);if((h|0)==3)c[e>>2]=0;i=d;return c[e>>2]|0}function ks(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(!(c[(c[d>>2]|0)+12>>2]|0)){i=b;return}c[(c[(c[d>>2]|0)+12>>2]|0)+4>>2]=c[c[(c[d>>2]|0)+12>>2]>>2];a=c[d>>2]|0;Tq(a,yt(c[(c[d>>2]|0)+12>>2]|0,c[(c[(c[d>>2]|0)+12>>2]|0)+4>>2]|0)|0)|0;i=b;return}function ls(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}b=c[e>>2]|0;if(c[f>>2]|0){Nq(b,12);i=d;return}f=c[e>>2]|0;if((c[b+20>>2]|0)<((c[(c[e>>2]|0)+44>>2]|0)+0|0)){Nq(f,23);i=d;return}b=c[e>>2]|0;if((c[(c[f+12>>2]|0)+68>>2]|0)>=0){Tq(b,wt(c[(c[e>>2]|0)+12>>2]|0,+(c[(c[(c[e>>2]|0)+12>>2]|0)+68>>2]|0))|0)|0;i=d;return}else{Nq(b,13);i=d;return}}function ms(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}b=c[e>>2]|0;if(c[f>>2]|0){Nq(b,12);i=d;return}f=c[e>>2]|0;if((c[b+20>>2]|0)<((c[(c[e>>2]|0)+44>>2]|0)+0|0)){Nq(f,23);i=d;return}b=c[e>>2]|0;if((c[(c[f+12>>2]|0)+72>>2]|0)>=0){Tq(b,wt(c[(c[e>>2]|0)+12>>2]|0,+(c[(c[(c[e>>2]|0)+12>>2]|0)+72>>2]|0))|0)|0;i=d;return}else{Nq(b,14);i=d;return}}function ns(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}b=c[e>>2]|0;if((c[f>>2]|0)!=1){Nq(b,12);i=d;return}f=c[e>>2]|0;if((c[b+20>>2]|0)<((c[(c[e>>2]|0)+44>>2]|0)+1|0)){Nq(f,23);i=d;return}do if(c[f+16>>2]|0){if((c[c[(c[e>>2]|0)+16>>2]>>2]|0)!=1?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)!=9:0)break;c[g>>2]=Sq(c[e>>2]|0)|0;do if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+4>>2]|0)!=0:0){if((c[c[g>>2]>>2]|0)!=1?(c[c[g>>2]>>2]|0)!=9:0){if((c[c[(c[g>>2]|0)+4>>2]>>2]|0)==1?(c[(c[(c[g>>2]|0)+4>>2]|0)+8>>2]|0)!=0:0){c[j>>2]=0;c[h>>2]=c[c[(c[(c[g>>2]|0)+4>>2]|0)+8>>2]>>2];a:do if((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+4>>2]|0)!=18:0){c[h>>2]=c[(c[h>>2]|0)+12>>2];while(1){if(!(c[h>>2]|0))break a;c[h>>2]=c[(c[h>>2]|0)+24>>2];c[j>>2]=(c[j>>2]|0)+1}}while(0);b=c[e>>2]|0;Tq(b,wt(c[(c[e>>2]|0)+12>>2]|0,+(c[j>>2]|0))|0)|0;break}b=c[e>>2]|0;Tq(b,wt(c[(c[e>>2]|0)+12>>2]|0,0)|0)|0;break}b=c[e>>2]|0;Tq(b,wt(c[(c[e>>2]|0)+12>>2]|0,+(c[c[(c[g>>2]|0)+4>>2]>>2]|0))|0)|0}else k=12;while(0);if((k|0)==12){b=c[e>>2]|0;Tq(b,wt(c[(c[e>>2]|0)+12>>2]|0,0)|0)|0}jt(c[(c[e>>2]|0)+12>>2]|0,c[g>>2]|0);i=d;return}while(0);Nq(c[e>>2]|0,11);i=d;return}function os(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}b=c[e>>2]|0;if((c[f>>2]|0)!=1){Nq(b,12);i=d;return}f=c[e>>2]|0;if((c[b+20>>2]|0)<((c[(c[e>>2]|0)+44>>2]|0)+1|0)){Nq(f,23);i=d;return}c[j>>2]=Sq(f)|0;if(!(c[j>>2]|0)){Nq(c[e>>2]|0,10);i=d;return}if((c[c[j>>2]>>2]|0)!=1?(c[c[j>>2]>>2]|0)!=9:0){c[j>>2]=Bt(c[(c[e>>2]|0)+12>>2]|0,c[j>>2]|0)|0;c[h>>2]=zt(c[c[(c[e>>2]|0)+12>>2]>>2]|0,c[(c[j>>2]|0)+24>>2]|0)|0;f=c[e>>2]|0;Tq(f,At(c[(c[e>>2]|0)+12>>2]|0,c[h>>2]|0)|0)|0;jt(c[(c[e>>2]|0)+12>>2]|0,c[j>>2]|0);i=d;return}c[h>>2]=$q(0)|0;a:do if(c[(c[j>>2]|0)+4>>2]|0){c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[c[(c[j>>2]|0)+4>>2]>>2]|0))break a;c[g>>2]=ir(c[(c[(c[(c[j>>2]|0)+4>>2]|0)+8>>2]|0)+(c[l>>2]<<2)>>2]|0)|0;c[k>>2]=zt(c[c[(c[e>>2]|0)+12>>2]>>2]|0,c[g>>2]|0)|0;c[h>>2]=er(c[h>>2]|0,c[k>>2]|0)|0;fr(c[k>>2]|0);if(c[g>>2]|0)zb[c[135736>>2]&511](c[g>>2]|0);c[l>>2]=(c[l>>2]|0)+1}}while(0);jt(c[(c[e>>2]|0)+12>>2]|0,c[j>>2]|0);j=c[e>>2]|0;Tq(j,At(c[(c[e>>2]|0)+12>>2]|0,c[h>>2]|0)|0)|0;i=d;return}function ps(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;if(!(c[f>>2]|0)){i=e;return}if(!(c[g>>2]|0)){b=c[f>>2]|0;Tq(b,yt(c[(c[f>>2]|0)+12>>2]|0,c[(c[(c[f>>2]|0)+12>>2]|0)+4>>2]|0)|0)|0;c[g>>2]=1}if(!(c[f>>2]|0)){i=e;return}b=c[f>>2]|0;if((c[g>>2]|0)!=1){Nq(b,12);i=e;return}g=c[f>>2]|0;if((c[b+20>>2]|0)<((c[(c[f>>2]|0)+44>>2]|0)+1|0)){Nq(g,23);i=e;return}do if(c[g+16>>2]|0){if((c[c[(c[f>>2]|0)+16>>2]>>2]|0)!=1?(c[c[(c[f>>2]|0)+16>>2]>>2]|0)!=9:0)break;c[h>>2]=Sq(c[f>>2]|0)|0;do if((c[(c[h>>2]|0)+4>>2]|0)!=0?(c[c[(c[h>>2]|0)+4>>2]>>2]|0)!=0:0){c[j>>2]=0;b=c[(c[(c[(c[(c[h>>2]|0)+4>>2]|0)+8>>2]|0)+(c[j>>2]<<2)>>2]|0)+4>>2]|0;if((b|0)==7|(b|0)==2|(b|0)==1){a=c[f>>2]|0;k=c[(c[f>>2]|0)+12>>2]|0;if((d[c[(c[(c[(c[(c[h>>2]|0)+4>>2]|0)+8>>2]|0)+(c[j>>2]<<2)>>2]|0)+8>>2]>>0]|0|0)==32){Tq(a,Ct(k,128928)|0)|0;break}else{Tq(a,Dt(k,c[(c[(c[(c[(c[h>>2]|0)+4>>2]|0)+8>>2]|0)+(c[j>>2]<<2)>>2]|0)+8>>2]|0)|0)|0;break}}else if((b|0)==18){b=c[f>>2]|0;Tq(b,Dt(c[(c[f>>2]|0)+12>>2]|0,c[(c[(c[(c[(c[h>>2]|0)+4>>2]|0)+8>>2]|0)+(c[j>>2]<<2)>>2]|0)+12>>2]|0)|0)|0;break}else{b=c[f>>2]|0;Tq(b,Ct(c[(c[f>>2]|0)+12>>2]|0,128928)|0)|0;break}}else l=15;while(0);if((l|0)==15){b=c[f>>2]|0;Tq(b,Ct(c[(c[f>>2]|0)+12>>2]|0,128928)|0)|0}jt(c[(c[f>>2]|0)+12>>2]|0,c[h>>2]|0);i=e;return}while(0);Nq(c[f>>2]|0,11);i=e;return}function qs(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}if(!(c[f>>2]|0)){b=c[e>>2]|0;Tq(b,yt(c[(c[e>>2]|0)+12>>2]|0,c[(c[(c[e>>2]|0)+12>>2]|0)+4>>2]|0)|0)|0;c[f>>2]=1}if(!(c[e>>2]|0)){i=d;return}b=c[e>>2]|0;if((c[f>>2]|0)!=1){Nq(b,12);i=d;return}f=c[e>>2]|0;if((c[b+20>>2]|0)<((c[(c[e>>2]|0)+44>>2]|0)+1|0)){Nq(f,23);i=d;return}do if(c[f+16>>2]|0){if((c[c[(c[e>>2]|0)+16>>2]>>2]|0)!=1?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)!=9:0)break;c[g>>2]=Sq(c[e>>2]|0)|0;do if((c[(c[g>>2]|0)+4>>2]|0)!=0?(c[c[(c[g>>2]|0)+4>>2]>>2]|0)!=0:0){c[h>>2]=0;if(((c[(c[(c[(c[(c[g>>2]|0)+4>>2]|0)+8>>2]|0)+(c[h>>2]<<2)>>2]|0)+4>>2]|0)+-1|0)>>>0>=2){b=c[e>>2]|0;Tq(b,Ct(c[(c[e>>2]|0)+12>>2]|0,128928)|0)|0;break}b=c[e>>2]|0;a=c[(c[e>>2]|0)+12>>2]|0;if(!(c[(c[(c[(c[(c[g>>2]|0)+4>>2]|0)+8>>2]|0)+(c[h>>2]<<2)>>2]|0)+36>>2]|0)){Tq(b,Ct(a,128928)|0)|0;break}else{Tq(b,Dt(a,c[(c[(c[(c[(c[(c[g>>2]|0)+4>>2]|0)+8>>2]|0)+(c[h>>2]<<2)>>2]|0)+36>>2]|0)+8>>2]|0)|0)|0;break}}else j=15;while(0);if((j|0)==15){a=c[e>>2]|0;Tq(a,Ct(c[(c[e>>2]|0)+12>>2]|0,128928)|0)|0}jt(c[(c[e>>2]|0)+12>>2]|0,c[g>>2]|0);i=d;return}while(0);Nq(c[e>>2]|0,11);i=d;return}function rs(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}b=c[e>>2]|0;if(!(c[f>>2]|0)){a=c[(c[e>>2]|0)+12>>2]|0;Tq(b,Et(a,ir(c[(c[(c[e>>2]|0)+12>>2]|0)+4>>2]|0)|0)|0)|0;i=d;return}if(!b){i=d;return}b=c[e>>2]|0;if((c[f>>2]|0)!=1){Nq(b,12);i=d;return}f=c[e>>2]|0;if((c[b+20>>2]|0)<((c[(c[e>>2]|0)+44>>2]|0)+1|0)){Nq(f,23);i=d;return}c[g>>2]=Sq(f)|0;f=c[e>>2]|0;if(!(c[g>>2]|0)){Nq(f,10);i=d;return}else{Tq(f,Bt(c[(c[e>>2]|0)+12>>2]|0,c[g>>2]|0)|0)|0;i=d;return}}function ss(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;b=(c[e>>2]|0)==0;if(!(c[f>>2]|0)){if(b){i=d;return}if(!(c[(c[e>>2]|0)+12>>2]|0)){i=d;return}a=c[e>>2]|0;if(!(c[(c[(c[e>>2]|0)+12>>2]|0)+4>>2]|0)){Tq(a,wt(c[(c[e>>2]|0)+12>>2]|0,0)|0)|0;i=d;return}else{c[h>>2]=ir(c[(c[a+12>>2]|0)+4>>2]|0)|0;a=c[e>>2]|0;j=c[(c[e>>2]|0)+12>>2]|0;Tq(a,wt(j,+(Dy(c[h>>2]|0)|0))|0)|0;zb[c[135736>>2]&511](c[h>>2]|0);i=d;return}}if(b){i=d;return}b=c[e>>2]|0;if((c[f>>2]|0)!=1){Nq(b,12);i=d;return}f=c[e>>2]|0;if((c[b+20>>2]|0)<((c[(c[e>>2]|0)+44>>2]|0)+1|0)){Nq(f,23);i=d;return}if((c[f+16>>2]|0)!=0?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)!=4:0)rs(c[e>>2]|0,1);if((c[(c[e>>2]|0)+16>>2]|0)!=0?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)==4:0){c[g>>2]=Sq(c[e>>2]|0)|0;f=c[e>>2]|0;b=c[(c[e>>2]|0)+12>>2]|0;Tq(f,wt(b,+(Dy(c[(c[g>>2]|0)+24>>2]|0)|0))|0)|0;jt(c[(c[e>>2]|0)+12>>2]|0,c[g>>2]|0);i=d;return}Nq(c[e>>2]|0,11);i=d;return}function ts(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}if((c[f>>2]|0)<2){if(!(c[e>>2]|0)){i=d;return}b=c[e>>2]|0;if((c[f>>2]|0)!=2){Nq(b,12);i=d;return}if((c[b+20>>2]|0)<((c[(c[e>>2]|0)+44>>2]|0)+2|0)){Nq(c[e>>2]|0,23);i=d;return}}if((c[(c[e>>2]|0)+16>>2]|0)!=0?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)!=4:0)rs(c[e>>2]|0,1);c[g>>2]=Sq(c[e>>2]|0)|0;if((c[g>>2]|0)!=0?(c[c[g>>2]>>2]|0)==4:0){c[f>>2]=(c[f>>2]|0)+-1;while(1){k=c[e>>2]|0;if((c[f>>2]|0)<=0){l=23;break}if((c[k+16>>2]|0)!=0?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)!=4:0)rs(c[e>>2]|0,1);c[h>>2]=Sq(c[e>>2]|0)|0;if(!(c[h>>2]|0)){l=21;break}if((c[c[h>>2]>>2]|0)!=4){l=21;break}c[j>>2]=By(c[(c[h>>2]|0)+24>>2]|0,c[(c[g>>2]|0)+24>>2]|0)|0;c[(c[h>>2]|0)+24>>2]=c[(c[g>>2]|0)+24>>2];c[(c[g>>2]|0)+24>>2]=c[j>>2];jt(c[(c[e>>2]|0)+12>>2]|0,c[h>>2]|0);c[f>>2]=(c[f>>2]|0)+-1}if((l|0)==21){jt(c[(c[e>>2]|0)+12>>2]|0,c[h>>2]|0);jt(c[(c[e>>2]|0)+12>>2]|0,c[g>>2]|0);Nq(c[e>>2]|0,11);i=d;return}else if((l|0)==23){Tq(k,c[g>>2]|0)|0;i=d;return}}jt(c[(c[e>>2]|0)+12>>2]|0,c[g>>2]|0);i=d;return}function us(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}b=c[e>>2]|0;if((c[f>>2]|0)!=2){Nq(b,12);i=d;return}f=c[e>>2]|0;if((c[b+20>>2]|0)<((c[(c[e>>2]|0)+44>>2]|0)+2|0)){Nq(f,23);i=d;return}if((c[f+16>>2]|0)!=0?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)!=4:0)rs(c[e>>2]|0,1);if((c[(c[e>>2]|0)+16>>2]|0)!=0?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)==4:0){c[h>>2]=Sq(c[e>>2]|0)|0;if((c[(c[e>>2]|0)+16>>2]|0)!=0?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)!=4:0)rs(c[e>>2]|0,1);c[g>>2]=Sq(c[e>>2]|0)|0;if((c[g>>2]|0)!=0?(c[c[g>>2]>>2]|0)==4:0){f=(wy(c[(c[g>>2]|0)+24>>2]|0,c[(c[h>>2]|0)+24>>2]|0)|0)!=0;b=c[e>>2]|0;a=c[(c[e>>2]|0)+12>>2]|0;if(f)Tq(b,Ft(a,1)|0)|0;else Tq(b,Ft(a,0)|0)|0;jt(c[(c[e>>2]|0)+12>>2]|0,c[g>>2]|0);jt(c[(c[e>>2]|0)+12>>2]|0,c[h>>2]|0);i=d;return}jt(c[(c[e>>2]|0)+12>>2]|0,c[g>>2]|0);jt(c[(c[e>>2]|0)+12>>2]|0,c[h>>2]|0);Nq(c[e>>2]|0,11);i=d;return}Nq(c[e>>2]|0,11);i=d;return}function vs(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}b=c[e>>2]|0;if((c[f>>2]|0)!=2){Nq(b,12);i=d;return}f=c[e>>2]|0;if((c[b+20>>2]|0)<((c[(c[e>>2]|0)+44>>2]|0)+2|0)){Nq(f,23);i=d;return}if((c[f+16>>2]|0)!=0?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)!=4:0)rs(c[e>>2]|0,1);if((c[(c[e>>2]|0)+16>>2]|0)!=0?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)==4:0){c[h>>2]=Sq(c[e>>2]|0)|0;if((c[(c[e>>2]|0)+16>>2]|0)!=0?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)!=4:0)rs(c[e>>2]|0,1);c[g>>2]=Sq(c[e>>2]|0)|0;if((c[g>>2]|0)!=0?(c[c[g>>2]>>2]|0)==4:0){c[j>>2]=xy(c[(c[h>>2]|0)+24>>2]|0)|0;f=(sy(c[(c[g>>2]|0)+24>>2]|0,c[(c[h>>2]|0)+24>>2]|0,c[j>>2]|0)|0)!=0;j=c[e>>2]|0;b=c[(c[e>>2]|0)+12>>2]|0;if(f)Tq(j,Ft(b,0)|0)|0;else Tq(j,Ft(b,1)|0)|0;jt(c[(c[e>>2]|0)+12>>2]|0,c[g>>2]|0);jt(c[(c[e>>2]|0)+12>>2]|0,c[h>>2]|0);i=d;return}jt(c[(c[e>>2]|0)+12>>2]|0,c[g>>2]|0);jt(c[(c[e>>2]|0)+12>>2]|0,c[h>>2]|0);Nq(c[e>>2]|0,11);i=d;return}Nq(c[e>>2]|0,11);i=d;return}function ws(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+64|0;e=d+48|0;f=d+44|0;g=d+40|0;j=d+36|0;k=d+32|0;l=d+8|0;m=d;n=d+28|0;o=d+24|0;p=d+20|0;q=d+16|0;c[e>>2]=a;c[f>>2]=b;h[l>>3]=0;if((c[f>>2]|0)<2){if(!(c[e>>2]|0)){i=d;return}b=c[e>>2]|0;if((c[f>>2]|0)!=2){Nq(b,12);i=d;return}if((c[b+20>>2]|0)<((c[(c[e>>2]|0)+44>>2]|0)+2|0)){Nq(c[e>>2]|0,23);i=d;return}}if((c[f>>2]|0)>3){if(!(c[e>>2]|0)){i=d;return}b=c[e>>2]|0;if((c[f>>2]|0)!=3){Nq(b,12);i=d;return}if((c[b+20>>2]|0)<((c[(c[e>>2]|0)+44>>2]|0)+3|0)){Nq(c[e>>2]|0,23);i=d;return}}do if((c[f>>2]|0)==3){if((c[(c[e>>2]|0)+16>>2]|0)!=0?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)!=3:0)Tr(c[e>>2]|0,1);if((c[(c[e>>2]|0)+16>>2]|0)!=0?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)==3:0){c[k>>2]=Sq(c[e>>2]|0)|0;h[l>>3]=+h[(c[k>>2]|0)+16>>3];jt(c[(c[e>>2]|0)+12>>2]|0,c[k>>2]|0);break}Nq(c[e>>2]|0,11);i=d;return}while(0);if((c[(c[e>>2]|0)+16>>2]|0)!=0?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)!=3:0)Tr(c[e>>2]|0,1);if((c[(c[e>>2]|0)+16>>2]|0)!=0?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)==3:0){c[j>>2]=Sq(c[e>>2]|0)|0;h[m>>3]=+h[(c[j>>2]|0)+16>>3];jt(c[(c[e>>2]|0)+12>>2]|0,c[j>>2]|0);if((c[(c[e>>2]|0)+16>>2]|0)!=0?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)!=4:0)rs(c[e>>2]|0,1);if((c[(c[e>>2]|0)+16>>2]|0)!=0?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)==4:0){c[g>>2]=Sq(c[e>>2]|0)|0;c[p>>2]=Dy(c[(c[g>>2]|0)+24>>2]|0)|0;if((c[f>>2]|0)!=3?(h[l>>3]=+(c[p>>2]|0),+h[m>>3]<1):0)h[m>>3]=1;if((Mq(+h[m>>3])|0)==0?(Lq(+h[m>>3]+ +h[l>>3])|0)==0:0){c[n>>2]=~~+h[m>>3];if(+(c[n>>2]|0)+.5<=+h[m>>3])c[n>>2]=(c[n>>2]|0)+1;do if((Mq(+h[l>>3])|0)==1){c[o>>2]=c[p>>2];if((c[n>>2]|0)<1)c[n>>2]=1}else{m=(Mq(+h[l>>3])|0)==-1;if(m|+h[l>>3]<0){c[o>>2]=0;break}c[o>>2]=~~+h[l>>3];if(+(c[o>>2]|0)+.5<=+h[l>>3])c[o>>2]=(c[o>>2]|0)+1}while(0);c[n>>2]=(c[n>>2]|0)-1;c[o>>2]=(c[o>>2]|0)+(c[n>>2]|0);if((c[n>>2]|0)<0)c[n>>2]=0;if((c[o>>2]|0)>(c[p>>2]|0))c[o>>2]=c[p>>2];c[o>>2]=(c[o>>2]|0)-(c[n>>2]|0);c[q>>2]=Ky(c[(c[g>>2]|0)+24>>2]|0,c[n>>2]|0,c[o>>2]|0)|0}else c[q>>2]=0;o=c[e>>2]|0;n=c[(c[e>>2]|0)+12>>2]|0;if(!(c[q>>2]|0))Tq(o,Ct(n,128928)|0)|0;else{Tq(o,Dt(n,c[q>>2]|0)|0)|0;zb[c[135736>>2]&511](c[q>>2]|0)}jt(c[(c[e>>2]|0)+12>>2]|0,c[g>>2]|0);i=d;return}Nq(c[e>>2]|0,11);i=d;return}Nq(c[e>>2]|0,11);i=d;return}function xs(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}b=c[e>>2]|0;if((c[f>>2]|0)!=2){Nq(b,12);i=d;return}f=c[e>>2]|0;if((c[b+20>>2]|0)<((c[(c[e>>2]|0)+44>>2]|0)+2|0)){Nq(f,23);i=d;return}if((c[f+16>>2]|0)!=0?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)!=4:0)rs(c[e>>2]|0,1);c[h>>2]=Sq(c[e>>2]|0)|0;if((c[(c[e>>2]|0)+16>>2]|0)!=0?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)!=4:0)rs(c[e>>2]|0,1);c[g>>2]=Sq(c[e>>2]|0)|0;c[j>>2]=Ly()|0;if(c[j>>2]|0){c[k>>2]=wy(c[(c[g>>2]|0)+24>>2]|0,c[(c[h>>2]|0)+24>>2]|0)|0;if(c[k>>2]|0){c[l>>2]=(c[k>>2]|0)-(c[(c[g>>2]|0)+24>>2]|0);cz(c[j>>2]|0,c[(c[g>>2]|0)+24>>2]|0,c[l>>2]|0)|0}l=c[e>>2]|0;k=c[(c[e>>2]|0)+12>>2]|0;Tq(l,Dt(k,Vy(c[j>>2]|0)|0)|0)|0;Ry(c[j>>2]|0)}jt(c[(c[e>>2]|0)+12>>2]|0,c[g>>2]|0);jt(c[(c[e>>2]|0)+12>>2]|0,c[h>>2]|0);i=d;return}function ys(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}b=c[e>>2]|0;if((c[f>>2]|0)!=2){Nq(b,12);i=d;return}f=c[e>>2]|0;if((c[b+20>>2]|0)<((c[(c[e>>2]|0)+44>>2]|0)+2|0)){Nq(f,23);i=d;return}if((c[f+16>>2]|0)!=0?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)!=4:0)rs(c[e>>2]|0,1);c[h>>2]=Sq(c[e>>2]|0)|0;if((c[(c[e>>2]|0)+16>>2]|0)!=0?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)!=4:0)rs(c[e>>2]|0,1);c[g>>2]=Sq(c[e>>2]|0)|0;c[j>>2]=Ly()|0;if(c[j>>2]|0){c[k>>2]=wy(c[(c[g>>2]|0)+24>>2]|0,c[(c[h>>2]|0)+24>>2]|0)|0;if(c[k>>2]|0){f=(c[k>>2]|0)-(c[(c[g>>2]|0)+24>>2]|0)|0;c[l>>2]=f+(xy(c[(c[h>>2]|0)+24>>2]|0)|0);f=c[j>>2]|0;k=(c[(c[g>>2]|0)+24>>2]|0)+(c[l>>2]|0)|0;b=xy(c[(c[g>>2]|0)+24>>2]|0)|0;cz(f,k,b-(c[l>>2]|0)|0)|0}l=c[e>>2]|0;b=c[(c[e>>2]|0)+12>>2]|0;Tq(l,Dt(b,Vy(c[j>>2]|0)|0)|0)|0;Ry(c[j>>2]|0)}jt(c[(c[e>>2]|0)+12>>2]|0,c[g>>2]|0);jt(c[(c[e>>2]|0)+12>>2]|0,c[h>>2]|0);i=d;return}function zs(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;m=f+20|0;c[g>>2]=b;c[h>>2]=e;c[j>>2]=0;c[k>>2]=0;if(!(c[g>>2]|0)){i=f;return}if(!(c[h>>2]|0)){e=c[g>>2]|0;b=c[(c[g>>2]|0)+12>>2]|0;Tq(e,Et(b,ir(c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]|0)|0)|0)|0;c[h>>2]=1}if(!(c[g>>2]|0)){i=f;return}b=c[g>>2]|0;if((c[h>>2]|0)!=1){Nq(b,12);i=f;return}h=c[g>>2]|0;if((c[b+20>>2]|0)<((c[(c[g>>2]|0)+44>>2]|0)+1|0)){Nq(h,23);i=f;return}if((c[h+16>>2]|0)!=0?(c[c[(c[g>>2]|0)+16>>2]>>2]|0)!=4:0)rs(c[g>>2]|0,1);if((c[(c[g>>2]|0)+16>>2]|0)!=0?(c[c[(c[g>>2]|0)+16>>2]>>2]|0)==4:0){c[j>>2]=Sq(c[g>>2]|0)|0;c[k>>2]=c[(c[j>>2]|0)+24>>2];c[l>>2]=Ly()|0;if((c[l>>2]|0)!=0&(c[k>>2]|0)!=0){a:while(1){do if((d[c[k>>2]>>0]|0)!=32){if(9<=(d[c[k>>2]>>0]|0)?(d[c[k>>2]>>0]|0)<=10:0)break;if((d[c[k>>2]>>0]|0)!=13)break a}while(0);c[k>>2]=(c[k>>2]|0)+1}a[m>>0]=0;while(1){if(!(a[c[k>>2]>>0]|0))break;do if((d[c[k>>2]>>0]|0)!=32){if(9<=(d[c[k>>2]>>0]|0)?(d[c[k>>2]>>0]|0)<=10:0){n=27;break}if((d[c[k>>2]>>0]|0)!=13){if(a[m>>0]|0){cz(c[l>>2]|0,m,1)|0;a[m>>0]=0}cz(c[l>>2]|0,c[k>>2]|0,1)|0}else n=27}else n=27;while(0);if((n|0)==27){n=0;a[m>>0]=32}c[k>>2]=(c[k>>2]|0)+1}k=c[g>>2]|0;m=c[(c[g>>2]|0)+12>>2]|0;Tq(k,Dt(m,Vy(c[l>>2]|0)|0)|0)|0;Ry(c[l>>2]|0)}jt(c[(c[g>>2]|0)+12>>2]|0,c[j>>2]|0);i=f;return}Nq(c[g>>2]|0,11);i=f;return}function As(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+48|0;g=f;h=f+40|0;j=f+36|0;k=f+32|0;l=f+28|0;m=f+24|0;n=f+20|0;o=f+16|0;p=f+12|0;q=f+44|0;r=f+8|0;s=f+4|0;c[h>>2]=b;c[j>>2]=e;if(!(c[h>>2]|0)){i=f;return}e=c[h>>2]|0;if((c[j>>2]|0)!=3){Nq(e,12);i=f;return}j=c[h>>2]|0;if((c[e+20>>2]|0)<((c[(c[h>>2]|0)+44>>2]|0)+3|0)){Nq(j,23);i=f;return}if((c[j+16>>2]|0)!=0?(c[c[(c[h>>2]|0)+16>>2]>>2]|0)!=4:0)rs(c[h>>2]|0,1);c[m>>2]=Sq(c[h>>2]|0)|0;if((c[(c[h>>2]|0)+16>>2]|0)!=0?(c[c[(c[h>>2]|0)+16>>2]>>2]|0)!=4:0)rs(c[h>>2]|0,1);c[l>>2]=Sq(c[h>>2]|0)|0;if((c[(c[h>>2]|0)+16>>2]|0)!=0?(c[c[(c[h>>2]|0)+16>>2]>>2]|0)!=4:0)rs(c[h>>2]|0,1);c[k>>2]=Sq(c[h>>2]|0)|0;c[n>>2]=Ly()|0;a:do if(c[n>>2]|0){c[p>>2]=Dy(c[(c[m>>2]|0)+24>>2]|0)|0;c[s>>2]=c[(c[k>>2]|0)+24>>2];while(1){j=a[c[s>>2]>>0]|0;a[q>>0]=j;if(!(j<<24>>24))break a;c[o>>2]=Jy(c[(c[l>>2]|0)+24>>2]|0,c[s>>2]|0)|0;if((c[o>>2]|0)>=0){if((c[o>>2]|0)<(c[p>>2]|0)?(c[r>>2]=Iy(c[(c[m>>2]|0)+24>>2]|0,c[o>>2]|0)|0,(c[r>>2]|0)!=0):0){j=c[n>>2]|0;e=c[r>>2]|0;cz(j,e,Gy(c[r>>2]|0,1)|0)|0}}else{e=c[n>>2]|0;j=c[s>>2]|0;cz(e,j,Gy(c[s>>2]|0,1)|0)|0}c[s>>2]=(c[s>>2]|0)+1;if(!((d[q>>0]|0)&128))continue;if(((d[q>>0]|0)&192|0)!=192)break;while(1){j=(d[q>>0]|0)<<1&255;a[q>>0]=j;if(!(j&128))break;j=c[s>>2]|0;c[s>>2]=j+1;if(((d[j>>0]|0)&192|0)!=128){t=28;break}}if((t|0)==28){t=0;Db[c[135904>>2]&511](c[33980]|0,129184,g)}if((d[q>>0]|0)&128)break a}Db[c[135904>>2]&511](c[33980]|0,129184,g)}while(0);g=c[h>>2]|0;q=c[(c[h>>2]|0)+12>>2]|0;Tq(g,Dt(q,Vy(c[n>>2]|0)|0)|0)|0;Ry(c[n>>2]|0);jt(c[(c[h>>2]|0)+12>>2]|0,c[k>>2]|0);jt(c[(c[h>>2]|0)+12>>2]|0,c[l>>2]|0);jt(c[(c[h>>2]|0)+12>>2]|0,c[m>>2]|0);i=f;return}function Bs(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}b=c[e>>2]|0;if((c[f>>2]|0)!=1){Nq(b,12);i=d;return}f=c[e>>2]|0;if((c[b+20>>2]|0)<((c[(c[e>>2]|0)+44>>2]|0)+1|0)){Nq(f,23);i=d;return}c[g>>2]=Sq(f)|0;f=c[e>>2]|0;if(!(c[g>>2]|0)){Nq(f,10);i=d;return}else{c[g>>2]=Gt(c[f+12>>2]|0,c[g>>2]|0)|0;Tq(c[e>>2]|0,c[g>>2]|0)|0;i=d;return}}function Cs(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}b=c[e>>2]|0;if((c[f>>2]|0)!=1){Nq(b,12);i=d;return}f=c[e>>2]|0;if((c[b+20>>2]|0)<((c[(c[e>>2]|0)+44>>2]|0)+1|0)){Nq(f,23);i=d;return}if((c[f+16>>2]|0)!=0?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)!=2:0)Bs(c[e>>2]|0,1);if((c[(c[e>>2]|0)+16>>2]|0)!=0?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)==2:0){c[(c[(c[e>>2]|0)+16>>2]|0)+8>>2]=((c[(c[(c[e>>2]|0)+16>>2]|0)+8>>2]|0)!=0^1)&1;i=d;return}Nq(c[e>>2]|0,11);i=d;return}function Ds(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}b=c[e>>2]|0;if(c[f>>2]|0){Nq(b,12);i=d;return}f=c[e>>2]|0;if((c[b+20>>2]|0)<((c[(c[e>>2]|0)+44>>2]|0)+0|0)){Nq(f,23);i=d;return}else{Tq(f,Ft(c[(c[e>>2]|0)+12>>2]|0,1)|0)|0;i=d;return}}function Es(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}b=c[e>>2]|0;if(c[f>>2]|0){Nq(b,12);i=d;return}f=c[e>>2]|0;if((c[b+20>>2]|0)<((c[(c[e>>2]|0)+44>>2]|0)+0|0)){Nq(f,23);i=d;return}else{Tq(f,Ft(c[(c[e>>2]|0)+12>>2]|0,0)|0)|0;i=d;return}}function Fs(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;c[j>>2]=0;c[l>>2]=0;if(!(c[f>>2]|0)){i=e;return}b=c[f>>2]|0;if((c[g>>2]|0)!=1){Nq(b,12);i=e;return}g=c[f>>2]|0;if((c[b+20>>2]|0)<((c[(c[f>>2]|0)+44>>2]|0)+1|0)){Nq(g,23);i=e;return}if((c[g+16>>2]|0)!=0?(c[c[(c[f>>2]|0)+16>>2]>>2]|0)!=4:0)rs(c[f>>2]|0,1);if((c[(c[f>>2]|0)+16>>2]|0)!=0?(c[c[(c[f>>2]|0)+16>>2]>>2]|0)==4:0){c[h>>2]=Sq(c[f>>2]|0)|0;c[k>>2]=c[(c[h>>2]|0)+24>>2];c[j>>2]=Ti(c[(c[(c[f>>2]|0)+12>>2]|0)+4>>2]|0)|0;a:do if((c[j>>2]|0)!=0&(c[k>>2]|0)!=0){c[m>>2]=0;while(1){n=c[m>>2]|0;if(!(d[(c[k>>2]|0)+(c[m>>2]|0)>>0]|0))break;g=WS(d[(c[k>>2]|0)+n>>0]|0)|0;if((g|0)!=(WS(d[(c[j>>2]|0)+(c[m>>2]|0)>>0]|0)|0))break a;c[m>>2]=(c[m>>2]|0)+1}if((d[(c[j>>2]|0)+n>>0]|0|0)!=0?(d[(c[j>>2]|0)+(c[m>>2]|0)>>0]|0|0)!=45:0)break;c[l>>2]=1}while(0);if(c[j>>2]|0)zb[c[135736>>2]&511](c[j>>2]|0);jt(c[(c[f>>2]|0)+12>>2]|0,c[h>>2]|0);h=c[f>>2]|0;Tq(h,Ft(c[(c[f>>2]|0)+12>>2]|0,c[l>>2]|0)|0)|0;i=e;return}Nq(c[f>>2]|0,11);i=e;return}function Gs(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;j=d+8|0;k=d;c[e>>2]=a;c[f>>2]=b;h[k>>3]=0;if(!(c[e>>2]|0)){i=d;return}b=c[e>>2]|0;if((c[f>>2]|0)!=1){Nq(b,12);i=d;return}f=c[e>>2]|0;if((c[b+20>>2]|0)<((c[(c[e>>2]|0)+44>>2]|0)+1|0)){Nq(f,23);i=d;return}do if(c[f+16>>2]|0){if((c[c[(c[e>>2]|0)+16>>2]>>2]|0)!=1?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)!=9:0)break;c[g>>2]=Sq(c[e>>2]|0)|0;a:do if((c[(c[g>>2]|0)+4>>2]|0)!=0?(c[c[(c[g>>2]|0)+4>>2]>>2]|0)!=0:0){c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[c[(c[g>>2]|0)+4>>2]>>2]|0))break a;l=+Gr(c[(c[(c[(c[g>>2]|0)+4>>2]|0)+8>>2]|0)+(c[j>>2]<<2)>>2]|0);h[k>>3]=+h[k>>3]+l;c[j>>2]=(c[j>>2]|0)+1}}while(0);b=c[e>>2]|0;Tq(b,wt(c[(c[e>>2]|0)+12>>2]|0,+h[k>>3])|0)|0;jt(c[(c[e>>2]|0)+12>>2]|0,c[g>>2]|0);i=d;return}while(0);Nq(c[e>>2]|0,11);i=d;return}function Hs(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}b=c[e>>2]|0;if((c[f>>2]|0)!=1){Nq(b,12);i=d;return}f=c[e>>2]|0;if((c[b+20>>2]|0)<((c[(c[e>>2]|0)+44>>2]|0)+1|0)){Nq(f,23);i=d;return}if((c[f+16>>2]|0)!=0?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)!=3:0)Tr(c[e>>2]|0,1);if((c[(c[e>>2]|0)+16>>2]|0)!=0?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)==3:0){h[g>>3]=+uT(+h[(c[(c[e>>2]|0)+16>>2]|0)+16>>3],2147483647);h[g>>3]=+h[(c[(c[e>>2]|0)+16>>2]|0)+16>>3]-+h[g>>3]+ +(~~+h[g>>3]|0);if(!(+h[g>>3]!=+h[(c[(c[e>>2]|0)+16>>2]|0)+16>>3])){i=d;return}j=+h[g>>3];if(+h[(c[(c[e>>2]|0)+16>>2]|0)+16>>3]>0){h[(c[(c[e>>2]|0)+16>>2]|0)+16>>3]=j;i=d;return}else{h[(c[(c[e>>2]|0)+16>>2]|0)+16>>3]=j-1;i=d;return}}Nq(c[e>>2]|0,11);i=d;return}function Is(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}b=c[e>>2]|0;if((c[f>>2]|0)!=1){Nq(b,12);i=d;return}f=c[e>>2]|0;if((c[b+20>>2]|0)<((c[(c[e>>2]|0)+44>>2]|0)+1|0)){Nq(f,23);i=d;return}if((c[f+16>>2]|0)!=0?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)!=3:0)Tr(c[e>>2]|0,1);if((c[(c[e>>2]|0)+16>>2]|0)!=0?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)==3:0){h[g>>3]=+uT(+h[(c[(c[e>>2]|0)+16>>2]|0)+16>>3],2147483647);h[g>>3]=+h[(c[(c[e>>2]|0)+16>>2]|0)+16>>3]-+h[g>>3]+ +(~~+h[g>>3]|0);if(!(+h[g>>3]!=+h[(c[(c[e>>2]|0)+16>>2]|0)+16>>3])){i=d;return}if(+h[(c[(c[e>>2]|0)+16>>2]|0)+16>>3]>0){h[(c[(c[e>>2]|0)+16>>2]|0)+16>>3]=+h[g>>3]+1;i=d;return}if(+h[g>>3]==0?+h[(c[(c[e>>2]|0)+16>>2]|0)+16>>3]<0:0){h[(c[(c[e>>2]|0)+16>>2]|0)+16>>3]=+h[15988];i=d;return}else{h[(c[(c[e>>2]|0)+16>>2]|0)+16>>3]=+h[g>>3];i=d;return}}Nq(c[e>>2]|0,11);i=d;return}function Js(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}b=c[e>>2]|0;if((c[f>>2]|0)!=1){Nq(b,12);i=d;return}f=c[e>>2]|0;if((c[b+20>>2]|0)<((c[(c[e>>2]|0)+44>>2]|0)+1|0)){Nq(f,23);i=d;return}if((c[f+16>>2]|0)!=0?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)!=3:0)Tr(c[e>>2]|0,1);if((c[(c[e>>2]|0)+16>>2]|0)!=0?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)==3:0){if(Lq(+h[(c[(c[e>>2]|0)+16>>2]|0)+16>>3])|0){i=d;return}if((Mq(+h[(c[(c[e>>2]|0)+16>>2]|0)+16>>3])|0)==1){i=d;return}if((Mq(+h[(c[(c[e>>2]|0)+16>>2]|0)+16>>3])|0)==-1){i=d;return}if(+h[(c[(c[e>>2]|0)+16>>2]|0)+16>>3]==0){i=d;return}h[g>>3]=+uT(+h[(c[(c[e>>2]|0)+16>>2]|0)+16>>3],2147483647);h[g>>3]=+h[(c[(c[e>>2]|0)+16>>2]|0)+16>>3]-+h[g>>3]+ +(~~+h[g>>3]|0);j=+h[(c[(c[e>>2]|0)+16>>2]|0)+16>>3];k=+h[g>>3];if(!(+h[(c[(c[e>>2]|0)+16>>2]|0)+16>>3]<0)){l=+h[g>>3];if(j<k+.5){h[(c[(c[e>>2]|0)+16>>2]|0)+16>>3]=l;i=d;return}else{h[(c[(c[e>>2]|0)+16>>2]|0)+16>>3]=l+1;i=d;return}}l=+h[g>>3];if(j<k-.5)h[(c[(c[e>>2]|0)+16>>2]|0)+16>>3]=l-1;else h[(c[(c[e>>2]|0)+16>>2]|0)+16>>3]=l;if(!(+h[(c[(c[e>>2]|0)+16>>2]|0)+16>>3]==0)){i=d;return}h[(c[(c[e>>2]|0)+16>>2]|0)+16>>3]=+h[15988];i=d;return}Nq(c[e>>2]|0,11);i=d;return}function Ks(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+32|0;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;j=b;c[f>>2]=a;c[j>>2]=0;if((c[f>>2]|0)!=0?(c[c[f>>2]>>2]|0)!=0:0){c[g>>2]=c[c[f>>2]>>2];if((d[c[g>>2]>>0]|0|0)>=97?(d[c[g>>2]>>0]|0|0)<=122:0)k=9;else k=6;do if((k|0)==6){if((d[c[g>>2]>>0]|0|0)>=65?(d[c[g>>2]>>0]|0|0)<=90:0){k=9;break}if((d[c[g>>2]>>0]|0|0)==95)k=9}while(0);do if((k|0)==9){c[g>>2]=(c[g>>2]|0)+1;while(1){if((d[c[g>>2]>>0]|0|0)>=97?(d[c[g>>2]>>0]|0|0)<=122:0)l=1;else k=12;do if((k|0)==12){k=0;if((d[c[g>>2]>>0]|0|0)>=65?(d[c[g>>2]>>0]|0|0)<=90:0){l=1;break}if((d[c[g>>2]>>0]|0|0)>=48?(d[c[g>>2]>>0]|0|0)<=57:0){l=1;break}if((d[c[g>>2]>>0]|0|0)!=95?(d[c[g>>2]>>0]|0|0)!=46:0)l=(d[c[g>>2]>>0]|0|0)==45;else l=1}while(0);m=c[g>>2]|0;if(!l)break;c[g>>2]=m+1}if((((((((d[m>>0]|0|0)!=32?(d[c[g>>2]>>0]|0|0)!=62:0)?(d[c[g>>2]>>0]|0|0)!=47:0)?(d[c[g>>2]>>0]|0|0)!=91:0)?(d[c[g>>2]>>0]|0|0)!=93:0)?(d[c[g>>2]>>0]|0|0)!=58:0)?(d[c[g>>2]>>0]|0|0)!=64:0)?(d[c[g>>2]>>0]|0|0)!=42:0)break;c[j>>2]=(c[g>>2]|0)-(c[c[f>>2]>>2]|0);if(!(c[j>>2]|0)){c[e>>2]=0;n=c[e>>2]|0;i=b;return n|0}else{c[h>>2]=ly(c[c[f>>2]>>2]|0,c[j>>2]|0)|0;c[c[f>>2]>>2]=c[g>>2];c[e>>2]=c[h>>2];n=c[e>>2]|0;i=b;return n|0}}while(0);c[e>>2]=Ht(c[f>>2]|0,0)|0;n=c[e>>2]|0;i=b;return n|0}c[e>>2]=0;n=c[e>>2]|0;i=b;return n|0}function Ls(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+32|0;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;j=b;c[f>>2]=a;c[j>>2]=0;if((c[f>>2]|0)!=0?(c[c[f>>2]>>2]|0)!=0:0){c[g>>2]=c[c[f>>2]>>2];if((d[c[g>>2]>>0]|0|0)>=97?(d[c[g>>2]>>0]|0|0)<=122:0)k=10;else k=6;do if((k|0)==6){if((d[c[g>>2]>>0]|0|0)>=65?(d[c[g>>2]>>0]|0|0)<=90:0){k=10;break}if(!((d[c[g>>2]>>0]|0|0)!=95?(d[c[g>>2]>>0]|0|0)!=58:0))k=10}while(0);if((k|0)==10){c[g>>2]=(c[g>>2]|0)+1;while(1){if((d[c[g>>2]>>0]|0|0)>=97?(d[c[g>>2]>>0]|0|0)<=122:0)l=1;else k=13;do if((k|0)==13){k=0;if((d[c[g>>2]>>0]|0|0)>=65?(d[c[g>>2]>>0]|0|0)<=90:0){l=1;break}if((d[c[g>>2]>>0]|0|0)>=48?(d[c[g>>2]>>0]|0|0)<=57:0){l=1;break}if(((d[c[g>>2]>>0]|0|0)!=95?(d[c[g>>2]>>0]|0|0)!=45:0)?(d[c[g>>2]>>0]|0|0)!=58:0)l=(d[c[g>>2]>>0]|0|0)==46;else l=1}while(0);m=c[g>>2]|0;if(!l)break;c[g>>2]=m+1}if((d[m>>0]|0|0)>0?(d[c[g>>2]>>0]|0|0)<128:0){c[j>>2]=(c[g>>2]|0)-(c[c[f>>2]>>2]|0);if((c[j>>2]|0)>>>0>5e4){c[c[f>>2]>>2]=c[g>>2];Nq(c[f>>2]|0,7);c[e>>2]=0;n=c[e>>2]|0;i=b;return n|0}else{c[h>>2]=ly(c[c[f>>2]>>2]|0,c[j>>2]|0)|0;c[c[f>>2]>>2]=c[g>>2];c[e>>2]=c[h>>2];n=c[e>>2]|0;i=b;return n|0}}}c[e>>2]=Ht(c[f>>2]|0,1)|0;n=c[e>>2]|0;i=b;return n|0}c[e>>2]=0;n=c[e>>2]|0;i=b;return n|0}function Ms(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;do if(c[e>>2]|0){if(qy(c[e>>2]|0,129400)|0){c[d>>2]=1;break}if(qy(c[e>>2]|0,129408)|0){
c[d>>2]=1;break}if(qy(c[e>>2]|0,129416)|0){c[d>>2]=1;break}if(qy(c[e>>2]|0,129424)|0){c[d>>2]=1;break}else{c[d>>2]=0;break}}else c[d>>2]=0;while(0);i=b;return c[d>>2]|0}function Ns(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e;g=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;c[j>>2]=a;c[k>>2]=b;a:do if((c[j>>2]|0)==0|(c[k>>2]|0)==0)c[g>>2]=0;else switch(c[c[k>>2]>>2]|0){case 9:case 1:{if(!(c[(c[k>>2]|0)+4>>2]|0)){c[g>>2]=0;break a}else{c[g>>2]=(c[c[(c[k>>2]|0)+4>>2]>>2]|0)!=0&1;break a}break}case 2:{c[g>>2]=c[(c[k>>2]|0)+8>>2];break a;break}case 7:{c[l>>2]=c[(c[k>>2]|0)+28>>2];if(!(c[l>>2]|0)){c[g>>2]=0;break a}else{c[g>>2]=(c[c[l>>2]>>2]|0)!=0&1;break a}break}case 4:{if(c[(c[k>>2]|0)+24>>2]|0)m=(d[c[(c[k>>2]|0)+24>>2]>>0]|0|0)!=0;else m=0;c[g>>2]=m&1;break a;break}case 3:{c[g>>2]=+h[(c[k>>2]|0)+16>>3]==+(c[(c[(c[j>>2]|0)+12>>2]|0)+72>>2]|0)&1;break a;break}default:{b=c[33976]|0;a=c[33980]|0;c[f>>2]=128552;c[f+4>>2]=14647;Db[b&511](a,129448,f);c[g>>2]=0;break a}}while(0);i=e;return c[g>>2]|0}function Os(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[k>>2]=It(c[g>>2]|0,c[h>>2]|0)|0;if(c[k>>2]|0){c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}Kq();c[j>>2]=Or(c[h>>2]|0,c[g>>2]|0)|0;if(!(c[j>>2]|0)){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}Jt(c[j>>2]|0,1);g=c[j>>2]|0;if(c[(c[j>>2]|0)+8>>2]|0){Pr(g);c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}b=c[j>>2]|0;if(d[c[g>>2]>>0]|0){Oq(b,128552,14835,7);c[k>>2]=0}else{c[k>>2]=c[b+32>>2];c[(c[j>>2]|0)+32>>2]=0}Pr(c[j>>2]|0);if(((c[k>>2]|0)!=0?(j=my(c[h>>2]|0)|0,c[(c[k>>2]|0)+16>>2]=j,(c[c[k>>2]>>2]|0)>1):0)?(c[(c[k>>2]|0)+12>>2]|0)>=0:0)Kt(c[k>>2]|0,(c[(c[k>>2]|0)+8>>2]|0)+((c[(c[k>>2]|0)+12>>2]|0)*40|0)|0);c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}function Ps(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=0;Lt(c[e>>2]|0,c[f>>2]|0,g,0)|0;i=d;return c[g>>2]|0}function Qs(a){a=a|0;var b=0,e=0,f=0,g=0;b=i;i=i+16|0;e=b+4|0;f=b;c[e>>2]=a;if(!(c[e>>2]|0)){i=b;return}c[f>>2]=It(c[(c[e>>2]|0)+12>>2]|0,c[(c[e>>2]|0)+4>>2]|0)|0;a=c[e>>2]|0;a:do if(c[f>>2]|0){if(c[a+32>>2]|0)Pq(c[(c[e>>2]|0)+32>>2]|0);c[(c[e>>2]|0)+32>>2]=c[f>>2];if(c[c[e>>2]>>2]|0)while(1){if(!(d[c[c[e>>2]>>2]>>0]|0))break a;g=c[e>>2]|0;c[g>>2]=(c[g>>2]|0)+1}}else{Jt(a,1);if((((c[(c[e>>2]|0)+8>>2]|0)==0?(c[(c[e>>2]|0)+32>>2]|0)!=0:0)?(c[c[(c[e>>2]|0)+32>>2]>>2]|0)>1:0)?(c[(c[(c[e>>2]|0)+32>>2]|0)+12>>2]|0)>=0:0)Kt(c[(c[e>>2]|0)+32>>2]|0,(c[(c[(c[e>>2]|0)+32>>2]|0)+8>>2]|0)+((c[(c[(c[e>>2]|0)+32>>2]|0)+12>>2]|0)*40|0)|0)}while(0);if(c[(c[e>>2]|0)+8>>2]|0){i=b;return}Mt(c[e>>2]|0,0)|0;i=b;return}function Rs(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+48|0;f=e;g=e+32|0;h=e+28|0;j=e+24|0;k=e+20|0;l=e+16|0;m=e+12|0;n=e+8|0;o=e+4|0;c[h>>2]=a;c[j>>2]=b;c[n>>2]=0;c[o>>2]=0;if(!(c[j>>2]|0)){Xd(0,0,0,0,0,12,1,3,128552,15056,0,0,0,0,0,129480,f);c[g>>2]=0;p=c[g>>2]|0;i=e;return p|0}Kq();c[k>>2]=Or(c[h>>2]|0,c[j>>2]|0)|0;if(!(c[k>>2]|0)){c[g>>2]=0;p=c[g>>2]|0;i=e;return p|0}Qs(c[k>>2]|0);do if(!(c[(c[k>>2]|0)+16>>2]|0)){Db[c[135904>>2]&511](c[33980]|0,129504,f);c[l>>2]=0}else{if(((d[c[c[k>>2]>>2]>>0]|0|0)!=0?(c[(c[k>>2]|0)+32>>2]|0)!=0:0)?(c[(c[(c[k>>2]|0)+32>>2]|0)+24>>2]|0)==0:0){Oq(c[k>>2]|0,128552,15074,7);c[l>>2]=0;break}c[l>>2]=Sq(c[k>>2]|0)|0}while(0);do{c[m>>2]=Sq(c[k>>2]|0)|0;if(c[m>>2]|0){if((c[m>>2]|0)!=(c[n>>2]|0))c[o>>2]=(c[o>>2]|0)+1;jt(c[j>>2]|0,c[m>>2]|0)}}while((c[m>>2]|0)!=0);if((c[o>>2]|0)!=0&(c[l>>2]|0)!=0){m=c[33976]|0;j=c[33980]|0;c[f>>2]=c[o>>2];Db[m&511](j,129544,f)}if(c[(c[k>>2]|0)+8>>2]|0){Qq(c[l>>2]|0);c[l>>2]=0}Pr(c[k>>2]|0);c[g>>2]=c[l>>2];p=c[g>>2]|0;i=e;return p|0}function Ss(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+48|0;f=e+36|0;g=e+32|0;h=e+28|0;j=e+16|0;k=e+8|0;l=e+24|0;m=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=j;c[d>>2]=c[g>>2];c[d+4>>2]=0;while(1){d=j;g=c[d+4>>2]|0;if(!((g|0)<0|((g|0)==0?(c[d>>2]|0)>>>0<(c[h>>2]|0)>>>0:0)))break;d=j;g=XT(c[d>>2]|0,c[d+4>>2]|0,1,0)|0;if((Nt(c[(c[f>>2]|0)+(g<<2)>>2]|0,c[(c[f>>2]|0)+(c[j>>2]<<2)>>2]|0)|0)>0){c[l>>2]=c[(c[f>>2]|0)+(c[j>>2]<<2)>>2];g=Ot(c[f>>2]|0,c[l>>2]|0,c[j>>2]|0)|0;d=m;c[d>>2]=g;c[d+4>>2]=G;d=j;g=XT(c[d>>2]|0,c[d+4>>2]|0,1,0)|0;d=k;c[d>>2]=g;c[d+4>>2]=G;while(1){d=k;g=c[d+4>>2]|0;b=m;a=c[b+4>>2]|0;if(!((g|0)>(a|0)|((g|0)==(a|0)?(c[d>>2]|0)>>>0>=(c[b>>2]|0)>>>0:0)))break;b=c[(c[f>>2]|0)+(c[k>>2]<<2)>>2]|0;d=k;a=bU(c[d>>2]|0,c[d+4>>2]|0,1,0)|0;c[(c[f>>2]|0)+(a<<2)>>2]=b;b=k;a=bU(c[b>>2]|0,c[b+4>>2]|0,-1,-1)|0;b=k;c[b>>2]=a;c[b+4>>2]=G}c[(c[f>>2]|0)+(c[m>>2]<<2)>>2]=c[l>>2]}b=j;a=bU(c[b>>2]|0,c[b+4>>2]|0,1,0)|0;b=j;c[b>>2]=a;c[b+4>>2]=G}i=e;return}function Ts(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+48|0;g=f+16|0;h=f+32|0;j=f+8|0;k=f+28|0;l=f;m=f+24|0;c[h>>2]=a;a=j;c[a>>2]=b;c[a+4>>2]=d;c[k>>2]=e;e=j;d=XT(c[k>>2]|0,0,c[e>>2]|0,c[e+4>>2]|0)|0;if((d|0)==1&(G|0)==0){d=g;c[d>>2]=1;c[d+4>>2]=0;n=g;o=n;p=c[o>>2]|0;q=n+4|0;r=q;s=c[r>>2]|0;G=s;i=f;return p|0}d=j;e=c[d>>2]|0;a=c[d+4>>2]|0;d=XT(c[k>>2]|0,0,2,0)|0;b=G;if((a|0)>(b|0)|(a|0)==(b|0)&e>>>0>=d>>>0){if((Nt(c[(c[h>>2]|0)+((c[k>>2]|0)-2<<2)>>2]|0,c[(c[h>>2]|0)+((c[k>>2]|0)-1<<2)>>2]|0)|0)>0){c[m>>2]=c[(c[h>>2]|0)+((c[k>>2]|0)-2<<2)>>2];c[(c[h>>2]|0)+((c[k>>2]|0)-2<<2)>>2]=c[(c[h>>2]|0)+((c[k>>2]|0)-1<<2)>>2];c[(c[h>>2]|0)+((c[k>>2]|0)-1<<2)>>2]=c[m>>2]}m=g;c[m>>2]=2;c[m+4>>2]=0;n=g;o=n;p=c[o>>2]|0;q=n+4|0;r=q;s=c[r>>2]|0;G=s;i=f;return p|0}m=j;d=bU(c[m>>2]|0,c[m+4>>2]|0,2,0)|0;m=l;c[m>>2]=d;c[m+4>>2]=G;m=c[(c[h>>2]|0)+(c[j>>2]<<2)>>2]|0;d=j;e=bU(c[d>>2]|0,c[d+4>>2]|0,1,0)|0;if((Nt(m,c[(c[h>>2]|0)+(e<<2)>>2]|0)|0)<=0){while(1){e=l;m=c[e>>2]|0;d=c[e+4>>2]|0;e=XT(c[k>>2]|0,0,1,0)|0;if((m|0)==(e|0)&(d|0)==(G|0))break;d=l;e=XT(c[d>>2]|0,c[d+4>>2]|0,1,0)|0;if((Nt(c[(c[h>>2]|0)+(e<<2)>>2]|0,c[(c[h>>2]|0)+(c[l>>2]<<2)>>2]|0)|0)>0)break;e=l;d=bU(c[e>>2]|0,c[e+4>>2]|0,1,0)|0;e=l;c[e>>2]=d;c[e+4>>2]=G}e=l;d=j;m=XT(c[e>>2]|0,c[e+4>>2]|0,c[d>>2]|0,c[d+4>>2]|0)|0;d=g;c[d>>2]=m;c[d+4>>2]=G;n=g;o=n;p=c[o>>2]|0;q=n+4|0;r=q;s=c[r>>2]|0;G=s;i=f;return p|0}else{while(1){d=l;m=c[d>>2]|0;e=c[d+4>>2]|0;d=XT(c[k>>2]|0,0,1,0)|0;if((m|0)==(d|0)&(e|0)==(G|0))break;e=l;d=XT(c[e>>2]|0,c[e+4>>2]|0,1,0)|0;if((Nt(c[(c[h>>2]|0)+(d<<2)>>2]|0,c[(c[h>>2]|0)+(c[l>>2]<<2)>>2]|0)|0)<=0)break;d=l;e=bU(c[d>>2]|0,c[d+4>>2]|0,1,0)|0;d=l;c[d>>2]=e;c[d+4>>2]=G}k=c[h>>2]|0;h=j;d=c[h>>2]|0;e=c[h+4>>2]|0;h=l;m=XT(c[h>>2]|0,c[h+4>>2]|0,1,0)|0;Pt(k,d,e,m,G);m=l;l=j;j=XT(c[m>>2]|0,c[m+4>>2]|0,c[l>>2]|0,c[l+4>>2]|0)|0;l=g;c[l>>2]=j;c[l+4>>2]=G;n=g;o=n;p=c[o>>2]|0;q=n+4|0;r=q;s=c[r>>2]|0;G=s;i=f;return p|0}return 0}function Us(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;i=i+80|0;g=f+64|0;h=f+60|0;j=f+56|0;k=f+52|0;l=f+40|0;m=f+32|0;n=f+24|0;o=f+48|0;p=f+16|0;q=f+8|0;r=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;e=(c[h>>2]|0)+((c[j>>2]|0)-2<<4)+8|0;d=c[e+4>>2]|0;b=l;c[b>>2]=c[e>>2];c[b+4>>2]=d;d=(c[h>>2]|0)+((c[j>>2]|0)-1<<4)+8|0;b=c[d+4>>2]|0;e=m;c[e>>2]=c[d>>2];c[e+4>>2]=b;b=(c[h>>2]|0)+((c[j>>2]|0)-2<<4)|0;j=c[b+4>>2]|0;h=n;c[h>>2]=c[b>>2];c[h+4>>2]=j;j=c[k>>2]|0;h=l;b=c[h+4>>2]|0;e=m;d=c[e+4>>2]|0;a=(b|0)<(d|0)|((b|0)==(d|0)?(c[h>>2]|0)>>>0<(c[e>>2]|0)>>>0:0);e=l;h=c[e+4>>2]|0;h=m;d=c[h+4>>2]|0;d=a?c[e>>2]|0:c[h>>2]|0;Qt(j,d);c[o>>2]=c[(c[k>>2]|0)+4>>2];k=l;d=c[k+4>>2]|0;j=m;h=c[j+4>>2]|0;e=c[o>>2]|0;a=n;b=c[a>>2]|0;s=c[a+4>>2]|0;if((d|0)<(h|0)|((d|0)==(h|0)?(c[k>>2]|0)>>>0<(c[j>>2]|0)>>>0:0)){j=(c[g>>2]|0)+(b<<2)|0;k=l;h=mU(c[k>>2]|0,c[k+4>>2]|0,4,0)|0;eU(e|0,j|0,h|0)|0;h=p;c[h>>2]=0;c[h+4>>2]=0;h=n;j=l;k=bU(c[h>>2]|0,c[h+4>>2]|0,c[j>>2]|0,c[j+4>>2]|0)|0;j=q;c[j>>2]=k;c[j+4>>2]=G;j=n;k=c[j+4>>2]|0;h=r;c[h>>2]=c[j>>2];c[h+4>>2]=k;while(1){k=r;h=c[k>>2]|0;j=c[k+4>>2]|0;k=n;d=l;a=bU(c[k>>2]|0,c[k+4>>2]|0,c[d>>2]|0,c[d+4>>2]|0)|0;d=m;k=bU(a|0,G|0,c[d>>2]|0,c[d+4>>2]|0)|0;d=G;if(!((j|0)<(d|0)|(j|0)==(d|0)&h>>>0<k>>>0))break;k=p;h=c[k+4>>2]|0;d=l;j=c[d+4>>2]|0;do if((h|0)<(j|0)|((h|0)==(j|0)?(c[k>>2]|0)>>>0<(c[d>>2]|0)>>>0:0)?(a=q,t=c[a>>2]|0,u=c[a+4>>2]|0,a=n,v=l,w=bU(c[a>>2]|0,c[a+4>>2]|0,c[v>>2]|0,c[v+4>>2]|0)|0,v=m,a=bU(w|0,G|0,c[v>>2]|0,c[v+4>>2]|0)|0,v=G,(u|0)<(v|0)|(u|0)==(v|0)&t>>>0<a>>>0):0)if((Nt(c[(c[o>>2]|0)+(c[p>>2]<<2)>>2]|0,c[(c[g>>2]|0)+(c[q>>2]<<2)>>2]|0)|0)<=0){a=p;t=c[a>>2]|0;v=bU(t|0,c[a+4>>2]|0,1,0)|0;a=p;c[a>>2]=v;c[a+4>>2]=G;c[(c[g>>2]|0)+(c[r>>2]<<2)>>2]=c[(c[o>>2]|0)+(t<<2)>>2];break}else{t=q;a=c[t>>2]|0;v=bU(a|0,c[t+4>>2]|0,1,0)|0;t=q;c[t>>2]=v;c[t+4>>2]=G;c[(c[g>>2]|0)+(c[r>>2]<<2)>>2]=c[(c[g>>2]|0)+(a<<2)>>2];break}else x=9;while(0);do if((x|0)==9){x=0;d=p;k=c[d+4>>2]|0;j=l;h=c[j+4>>2]|0;if((k|0)<(h|0)|((k|0)==(h|0)?(c[d>>2]|0)>>>0<(c[j>>2]|0)>>>0:0)){j=p;d=c[j>>2]|0;h=bU(d|0,c[j+4>>2]|0,1,0)|0;j=p;c[j>>2]=h;c[j+4>>2]=G;c[(c[g>>2]|0)+(c[r>>2]<<2)>>2]=c[(c[o>>2]|0)+(d<<2)>>2];break}else{d=q;j=c[d>>2]|0;h=bU(j|0,c[d+4>>2]|0,1,0)|0;d=q;c[d>>2]=h;c[d+4>>2]=G;c[(c[g>>2]|0)+(c[r>>2]<<2)>>2]=c[(c[g>>2]|0)+(j<<2)>>2];break}}while(0);j=r;d=bU(c[j>>2]|0,c[j+4>>2]|0,1,0)|0;j=r;c[j>>2]=d;c[j+4>>2]=G}i=f;return}else{j=l;d=bU(b|0,s|0,c[j>>2]|0,c[j+4>>2]|0)|0;j=(c[g>>2]|0)+(d<<2)|0;d=m;s=mU(c[d>>2]|0,c[d+4>>2]|0,4,0)|0;eU(e|0,j|0,s|0)|0;s=m;j=XT(c[s>>2]|0,c[s+4>>2]|0,1,0)|0;s=p;c[s>>2]=j;c[s+4>>2]=G;s=n;j=l;e=bU(c[s>>2]|0,c[s+4>>2]|0,c[j>>2]|0,c[j+4>>2]|0)|0;j=XT(e|0,G|0,1,0)|0;e=q;c[e>>2]=j;c[e+4>>2]=G;e=n;j=l;l=bU(c[e>>2]|0,c[e+4>>2]|0,c[j>>2]|0,c[j+4>>2]|0)|0;j=m;m=bU(l|0,G|0,c[j>>2]|0,c[j+4>>2]|0)|0;j=XT(m|0,G|0,1,0)|0;m=r;c[m>>2]=j;c[m+4>>2]=G;while(1){m=r;j=c[m+4>>2]|0;l=n;e=c[l+4>>2]|0;if(!((j|0)>(e|0)|((j|0)==(e|0)?(c[m>>2]|0)>>>0>=(c[l>>2]|0)>>>0:0)))break;l=p;m=c[l+4>>2]|0;do if((m|0)>0|(m|0)==0&(c[l>>2]|0)>>>0>=0?(e=q,j=c[e+4>>2]|0,s=n,d=c[s+4>>2]|0,(j|0)>(d|0)|((j|0)==(d|0)?(c[e>>2]|0)>>>0>=(c[s>>2]|0)>>>0:0)):0)if((Nt(c[(c[g>>2]|0)+(c[q>>2]<<2)>>2]|0,c[(c[o>>2]|0)+(c[p>>2]<<2)>>2]|0)|0)>0){s=q;e=c[s>>2]|0;d=bU(e|0,c[s+4>>2]|0,-1,-1)|0;s=q;c[s>>2]=d;c[s+4>>2]=G;c[(c[g>>2]|0)+(c[r>>2]<<2)>>2]=c[(c[g>>2]|0)+(e<<2)>>2];break}else{e=p;s=c[e>>2]|0;d=bU(s|0,c[e+4>>2]|0,-1,-1)|0;e=p;c[e>>2]=d;c[e+4>>2]=G;c[(c[g>>2]|0)+(c[r>>2]<<2)>>2]=c[(c[o>>2]|0)+(s<<2)>>2];break}else x=20;while(0);do if((x|0)==20){x=0;l=p;m=c[l+4>>2]|0;if((m|0)>0|(m|0)==0&(c[l>>2]|0)>>>0>=0){l=p;m=c[l>>2]|0;s=bU(m|0,c[l+4>>2]|0,-1,-1)|0;l=p;c[l>>2]=s;c[l+4>>2]=G;c[(c[g>>2]|0)+(c[r>>2]<<2)>>2]=c[(c[o>>2]|0)+(m<<2)>>2];break}else{m=q;l=c[m>>2]|0;s=bU(l|0,c[m+4>>2]|0,-1,-1)|0;m=q;c[m>>2]=s;c[m+4>>2]=G;c[(c[g>>2]|0)+(c[r>>2]<<2)>>2]=c[(c[g>>2]|0)+(l<<2)>>2];break}}while(0);l=r;m=bU(c[l>>2]|0,c[l+4>>2]|0,-1,-1)|0;l=r;c[l>>2]=m;c[l+4>>2]=G}i=f;return}}function Vs(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d+48|0;f=d+44|0;g=d+40|0;h=d+32|0;j=d+24|0;k=d+16|0;l=d+8|0;m=d;c[f>>2]=a;c[g>>2]=b;if((c[g>>2]|0)<2){c[e>>2]=1;n=c[e>>2]|0;i=d;return n|0}b=c[g>>2]|0;if((c[g>>2]|0)==2){a=(c[f>>2]|0)+(b-2<<4)+8|0;o=c[a+4>>2]|0;p=l;c[p>>2]=c[a>>2];c[p+4>>2]=o;o=(c[f>>2]|0)+((c[g>>2]|0)-1<<4)+8|0;p=c[o+4>>2]|0;a=m;c[a>>2]=c[o>>2];c[a+4>>2]=p;p=l;l=c[p+4>>2]|0;a=m;m=c[a+4>>2]|0;if((l|0)<(m|0)|((l|0)==(m|0)?(c[p>>2]|0)>>>0<=(c[a>>2]|0)>>>0:0)){c[e>>2]=0;n=c[e>>2]|0;i=d;return n|0}else{c[e>>2]=1;n=c[e>>2]|0;i=d;return n|0}}a=(c[f>>2]|0)+(b-3<<4)+8|0;b=c[a+4>>2]|0;p=h;c[p>>2]=c[a>>2];c[p+4>>2]=b;b=(c[f>>2]|0)+((c[g>>2]|0)-2<<4)+8|0;p=c[b+4>>2]|0;a=j;c[a>>2]=c[b>>2];c[a+4>>2]=p;p=(c[f>>2]|0)+((c[g>>2]|0)-1<<4)+8|0;g=c[p+4>>2]|0;f=k;c[f>>2]=c[p>>2];c[f+4>>2]=g;g=h;h=c[g>>2]|0;f=c[g+4>>2]|0;g=j;p=k;a=bU(c[g>>2]|0,c[g+4>>2]|0,c[p>>2]|0,c[p+4>>2]|0)|0;p=G;if(!((f|0)<(p|0)|(f|0)==(p|0)&h>>>0<=a>>>0)?(a=j,j=c[a+4>>2]|0,h=k,k=c[h+4>>2]|0,!((j|0)<(k|0)|((j|0)==(k|0)?(c[a>>2]|0)>>>0<=(c[h>>2]|0)>>>0:0))):0){c[e>>2]=1;n=c[e>>2]|0;i=d;return n|0}c[e>>2]=0;n=c[e>>2]|0;i=d;return n|0}function Ws(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+48|0;h=g+40|0;j=g+36|0;k=g+32|0;l=g+28|0;m=g+24|0;n=g+16|0;o=g+8|0;p=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;while(1){if((c[k>>2]|0)<=1){q=16;break}if((c[k>>2]|0)==2?(f=(c[j>>2]|0)+8|0,e=(c[j>>2]|0)+24|0,d=bU(c[f>>2]|0,c[f+4>>2]|0,c[e>>2]|0,c[e+4>>2]|0)|0,(G|0)==0?(d|0)==(c[m>>2]|0):0):0){q=5;break}if((c[k>>2]|0)==2?(d=(c[j>>2]|0)+8|0,e=c[d+4>>2]|0,f=(c[j>>2]|0)+24|0,b=c[f+4>>2]|0,(e|0)<(b|0)|((e|0)==(b|0)?(c[d>>2]|0)>>>0<=(c[f>>2]|0)>>>0:0)):0){q=8;break}if((c[k>>2]|0)==2){q=16;break}f=(c[j>>2]|0)+((c[k>>2]|0)-3<<4)+8|0;d=c[f+4>>2]|0;b=n;c[b>>2]=c[f>>2];c[b+4>>2]=d;d=(c[j>>2]|0)+((c[k>>2]|0)-2<<4)+8|0;b=c[d+4>>2]|0;f=o;c[f>>2]=c[d>>2];c[f+4>>2]=b;b=(c[j>>2]|0)+((c[k>>2]|0)-1<<4)+8|0;f=c[b+4>>2]|0;d=p;c[d>>2]=c[b>>2];c[d+4>>2]=f;f=n;d=c[f>>2]|0;b=c[f+4>>2]|0;f=o;e=p;a=bU(c[f>>2]|0,c[f+4>>2]|0,c[e>>2]|0,c[e+4>>2]|0)|0;e=G;if(!((b|0)<(e|0)|(b|0)==(e|0)&d>>>0<=a>>>0)){a=o;d=c[a+4>>2]|0;e=p;b=c[e+4>>2]|0;if(!((d|0)<(b|0)|((d|0)==(b|0)?(c[a>>2]|0)>>>0<=(c[e>>2]|0)>>>0:0))){q=16;break}Us(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0);e=(c[j>>2]|0)+((c[k>>2]|0)-1<<4)+8|0;a=(c[j>>2]|0)+((c[k>>2]|0)-2<<4)+8|0;b=a;d=bU(c[b>>2]|0,c[b+4>>2]|0,c[e>>2]|0,c[e+4>>2]|0)|0;e=a;c[e>>2]=d;c[e+4>>2]=G;c[k>>2]=(c[k>>2]|0)+-1;continue}e=n;d=c[e+4>>2]|0;a=p;b=c[a+4>>2]|0;f=c[h>>2]|0;r=c[j>>2]|0;s=c[k>>2]|0;if((d|0)<(b|0)|((d|0)==(b|0)?(c[e>>2]|0)>>>0<(c[a>>2]|0)>>>0:0)){Us(f,r,s-1|0,c[l>>2]|0);a=(c[j>>2]|0)+((c[k>>2]|0)-2<<4)+8|0;e=(c[j>>2]|0)+((c[k>>2]|0)-3<<4)+8|0;b=e;d=bU(c[b>>2]|0,c[b+4>>2]|0,c[a>>2]|0,c[a+4>>2]|0)|0;a=e;c[a>>2]=d;c[a+4>>2]=G;a=(c[j>>2]|0)+((c[k>>2]|0)-2<<4)|0;d=(c[j>>2]|0)+((c[k>>2]|0)-1<<4)|0;c[a+0>>2]=c[d+0>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[k>>2]=(c[k>>2]|0)+-1;continue}else{Us(f,r,s,c[l>>2]|0);s=(c[j>>2]|0)+((c[k>>2]|0)-1<<4)+8|0;r=(c[j>>2]|0)+((c[k>>2]|0)-2<<4)+8|0;f=r;d=bU(c[f>>2]|0,c[f+4>>2]|0,c[s>>2]|0,c[s+4>>2]|0)|0;s=r;c[s>>2]=d;c[s+4>>2]=G;c[k>>2]=(c[k>>2]|0)+-1;continue}}if((q|0)==5){Us(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0);p=(c[j>>2]|0)+24|0;n=(c[j>>2]|0)+8|0;o=n;m=bU(c[o>>2]|0,c[o+4>>2]|0,c[p>>2]|0,c[p+4>>2]|0)|0;p=n;c[p>>2]=m;c[p+4>>2]=G;c[k>>2]=(c[k>>2]|0)+-1;t=c[k>>2]|0;i=g;return t|0}else if((q|0)==8){Us(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0);l=(c[j>>2]|0)+24|0;h=(c[j>>2]|0)+8|0;j=h;p=bU(c[j>>2]|0,c[j+4>>2]|0,c[l>>2]|0,c[l+4>>2]|0)|0;l=h;c[l>>2]=p;c[l+4>>2]=G;c[k>>2]=(c[k>>2]|0)+-1;t=c[k>>2]|0;i=g;return t|0}else if((q|0)==16){t=c[k>>2]|0;i=g;return t|0}return 0}function Xs(){var a=0;a=i;if(+h[16480]==0)h[16480]=+Rt(131848);i=a;return+ +h[16480]}function Ys(){var a=0;a=i;if(+h[16479]==0)h[16479]=-+Xs();i=a;return+ +h[16479]}function Zs(){var a=0;a=i;if(+h[16478]==0)h[16478]=+zT(128928);i=a;return+ +h[16478]}function _s(){var a=0,b=0;a=i;b=+Rt(131808);i=a;return+b}function $s(a){a=+a;var b=0,c=0,d=0;b=i;i=i+16|0;c=b;h[c>>3]=a;d=St(+h[c>>3])|0;c=G&2147483647;i=b;return(c>>>0>2146435072|(c|0)==2146435072&d>>>0>0)&1|0}function at(a){a=+a;var b=0,c=0,d=0,e=0;b=i;i=i+16|0;c=b;h[c>>3]=a;d=St(+h[c>>3])|0;if(!((d|0)==0&(G&2147483647|0)==2146435072)){e=0;i=b;return e|0}e=+h[c>>3]>0?1:-1;i=b;return e|0}function bt(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+8>>2]|0){c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[c[d>>2]>>2]|0))break;do if(c[(c[(c[d>>2]|0)+8>>2]|0)+(c[e>>2]<<2)>>2]|0){a=c[(c[(c[d>>2]|0)+8>>2]|0)+(c[e>>2]<<2)>>2]|0;if((c[(c[(c[(c[d>>2]|0)+8>>2]|0)+(c[e>>2]<<2)>>2]|0)+4>>2]|0)==18){_q(a);break}else{Uh(a);break}}while(0);c[e>>2]=(c[e>>2]|0)+1}zb[c[135736>>2]&511](c[(c[d>>2]|0)+8>>2]|0)}zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function ct(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+128|0;g=f;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f+20|0;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=0;while(1){n=m+((c[l>>2]<<1)+1)|0;if(!((c[l>>2]|0)<25?(c[l>>2]|0)<(c[k>>2]|0):0))break;a[n>>0]=32;a[m+(c[l>>2]<<1)>>0]=32;c[l>>2]=(c[l>>2]|0)+1}a[n>>0]=0;a[m+(c[l>>2]<<1)>>0]=0;if(!(c[j>>2]|0)){n=c[h>>2]|0;c[g>>2]=m;Ka(n|0,127912,g|0)|0;Ka(c[h>>2]|0,131120,g|0)|0;i=f;return}if(!(c[j>>2]|0)){i=f;return}n=c[h>>2]|0;c[g>>2]=c[c[j>>2]>>2];Ka(n|0,131144,g|0)|0;c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[c[j>>2]>>2]|0))break;n=c[h>>2]|0;c[g>>2]=m;Ka(n|0,127912,g|0)|0;n=c[h>>2]|0;c[g>>2]=(c[l>>2]|0)+1;Ka(n|0,130840,g|0)|0;ft(c[h>>2]|0,c[(c[(c[j>>2]|0)+8>>2]|0)+(c[l>>2]<<2)>>2]|0,(c[k>>2]|0)+1|0);c[l>>2]=(c[l>>2]|0)+1}i=f;return}function dt(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+128|0;g=f;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f+20|0;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=0;while(1){n=m+((c[l>>2]<<1)+1)|0;if(!((c[l>>2]|0)<25?(c[l>>2]|0)<(c[k>>2]|0):0))break;a[n>>0]=32;a[m+(c[l>>2]<<1)>>0]=32;c[l>>2]=(c[l>>2]|0)+1}a[n>>0]=0;a[m+(c[l>>2]<<1)>>0]=0;if(((c[j>>2]|0)!=0?(c[c[j>>2]>>2]|0)!=0:0)?(c[c[(c[j>>2]|0)+8>>2]>>2]|0)!=0:0){n=c[h>>2]|0;c[g>>2]=m;Ka(n|0,127912,g|0)|0;n=c[h>>2]|0;c[g>>2]=(c[l>>2]|0)+1;Ka(n|0,130840,g|0)|0;Ut(c[h>>2]|0,c[(c[c[(c[j>>2]|0)+8>>2]>>2]|0)+12>>2]|0,(c[k>>2]|0)+1|0);i=f;return}k=c[h>>2]|0;c[g>>2]=m;Ka(k|0,127912,g|0)|0;Ka(c[h>>2]|0,131096,g|0)|0;i=f;return}function et(a){a=+a;var b=0,c=0,d=0;b=i;i=i+16|0;c=b;h[c>>3]=a;d=Vt(+h[c>>3])|0;i=b;return d|0}function ft(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+128|0;g=f;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f+20|0;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=0;while(1){n=m+((c[l>>2]<<1)+1)|0;if(!((c[l>>2]|0)<25?(c[l>>2]|0)<(c[k>>2]|0):0))break;a[n>>0]=32;a[m+(c[l>>2]<<1)>>0]=32;c[l>>2]=(c[l>>2]|0)+1}a[n>>0]=0;a[m+(c[l>>2]<<1)>>0]=0;if(!(c[j>>2]|0)){l=c[h>>2]|0;c[g>>2]=m;Ka(l|0,127912,g|0)|0;Ka(c[h>>2]|0,131072,g|0)|0;i=f;return}if((c[(c[j>>2]|0)+4>>2]|0)!=9?(c[(c[j>>2]|0)+4>>2]|0)!=13:0){l=c[h>>2]|0;n=c[j>>2]|0;if((c[(c[j>>2]|0)+4>>2]|0)==2){Ip(l,n,c[k>>2]|0);i=f;return}else{Kp(l,n,c[k>>2]|0);i=f;return}}k=c[h>>2]|0;c[g>>2]=m;Ka(k|0,127912,g|0)|0;Ka(c[h>>2]|0,131088,g|0)|0;i=f;return}function gt(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+128|0;g=f;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f+20|0;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=0;while(1){n=m+((c[l>>2]<<1)+1)|0;if(!((c[l>>2]|0)<25?(c[l>>2]|0)<(c[k>>2]|0):0))break;a[n>>0]=32;a[m+(c[l>>2]<<1)>>0]=32;c[l>>2]=(c[l>>2]|0)+1}a[n>>0]=0;a[m+(c[l>>2]<<1)>>0]=0;if(!(c[j>>2]|0)){n=c[h>>2]|0;c[g>>2]=m;Ka(n|0,127912,g|0)|0;Ka(c[h>>2]|0,131040,g|0)|0;i=f;return}c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[c[j>>2]>>2]|0))break;n=c[h>>2]|0;c[g>>2]=m;Ka(n|0,127912,g|0)|0;n=c[h>>2]|0;c[g>>2]=(c[l>>2]|0)+1;Ka(n|0,131064,g|0)|0;Rq(c[h>>2]|0,c[(c[(c[j>>2]|0)+8>>2]|0)+(c[l>>2]<<2)>>2]|0,(c[k>>2]|0)+1|0);c[l>>2]=(c[l>>2]|0)+1}i=f;return}function ht(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[c[d>>2]>>2]|0)Wt(c[c[d>>2]>>2]|0);if(c[(c[d>>2]|0)+4>>2]|0)Wt(c[(c[d>>2]|0)+4>>2]|0);if(c[(c[d>>2]|0)+8>>2]|0)Wt(c[(c[d>>2]|0)+8>>2]|0);if(c[(c[d>>2]|0)+12>>2]|0)Wt(c[(c[d>>2]|0)+12>>2]|0);if(c[(c[d>>2]|0)+16>>2]|0)Wt(c[(c[d>>2]|0)+16>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function it(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+224|0;e=d;f=d+8|0;g=d+4|0;h=d+16|0;c[f>>2]=a;c[g>>2]=b;b=(c[g>>2]|0)!=0;if(!(c[f>>2]|0))if(b){a=c[g>>2]|0;c[e>>2]=c[g>>2];Xd(0,0,0,0,0,12,2,3,0,0,a,0,0,0,0,130976,e);i=d;return}else{Xd(0,0,0,0,0,12,2,3,0,0,0,0,0,0,0,131008,e);i=d;return}if(b){c[e>>2]=c[g>>2];Cy(h,200,130976,e)|0;e=my(h)|0;c[(c[f>>2]|0)+144>>2]=e}else{e=my(131008)|0;c[(c[f>>2]|0)+144>>2]=e}c[(c[f>>2]|0)+136>>2]=12;c[(c[f>>2]|0)+140>>2]=2;if(!(c[(c[f>>2]|0)+132>>2]|0)){i=d;return}Ab[c[(c[f>>2]|0)+132>>2]&511](c[(c[f>>2]|0)+128>>2]|0,(c[f>>2]|0)+136|0);i=d;return}function jt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[e>>2]=a;c[f>>2]=b;if(!(c[f>>2]|0)){i=d;return}if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+200>>2]|0)!=0:0){c[g>>2]=c[(c[e>>2]|0)+200>>2];a:do switch(c[c[f>>2]>>2]|0){case 3:{if((c[(c[g>>2]|0)+12>>2]|0)!=0?(c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]|0)>=(c[(c[g>>2]|0)+32>>2]|0):0){l=35;break a}if((c[(c[g>>2]|0)+12>>2]|0)==0?(e=Xt(10)|0,c[(c[g>>2]|0)+12>>2]=e,(c[(c[g>>2]|0)+12>>2]|0)==0):0){l=54;break a}if((Yt(c[(c[g>>2]|0)+12>>2]|0,c[f>>2]|0,0)|0)==-1)l=54;break}case 7:{if(c[(c[f>>2]|0)+28>>2]|0){ev(c[(c[f>>2]|0)+28>>2]|0);l=54}else l=54;break}case 2:{if((c[(c[g>>2]|0)+8>>2]|0)!=0?(c[(c[(c[g>>2]|0)+8>>2]|0)+4>>2]|0)>=(c[(c[g>>2]|0)+28>>2]|0):0){l=35;break a}if((c[(c[g>>2]|0)+8>>2]|0)==0?(e=Xt(10)|0,c[(c[g>>2]|0)+8>>2]=e,(c[(c[g>>2]|0)+8>>2]|0)==0):0){l=54;break a}if((Yt(c[(c[g>>2]|0)+8>>2]|0,c[f>>2]|0,0)|0)==-1)l=54;break}case 9:case 1:{if(c[(c[f>>2]|0)+4>>2]|0){e=c[f>>2]|0;if(c[(c[f>>2]|0)+8>>2]|0){c[e>>2]=9;bt(c[(c[f>>2]|0)+4>>2]|0);c[(c[f>>2]|0)+4>>2]=0;l=35;break a}do if((c[(c[e+4>>2]|0)+4>>2]|0)<=40){if((c[c[g>>2]>>2]|0)!=0?(c[(c[c[g>>2]>>2]|0)+4>>2]|0)>=(c[(c[g>>2]|0)+20>>2]|0):0)break;if((c[c[g>>2]>>2]|0)==0?(b=Xt(10)|0,c[c[g>>2]>>2]=b,(c[c[g>>2]>>2]|0)==0):0){l=54;break a}if((Yt(c[c[g>>2]>>2]|0,c[f>>2]|0,0)|0)==-1){l=54;break a}else break a}while(0);fr(c[(c[f>>2]|0)+4>>2]|0);c[(c[f>>2]|0)+4>>2]=0;l=35}else l=35;break}case 4:{if(c[(c[f>>2]|0)+24>>2]|0)zb[c[135736>>2]&511](c[(c[f>>2]|0)+24>>2]|0);if((c[(c[g>>2]|0)+4>>2]|0)!=0?(c[(c[(c[g>>2]|0)+4>>2]|0)+4>>2]|0)>=(c[(c[g>>2]|0)+24>>2]|0):0){l=35;break a}if((c[(c[g>>2]|0)+4>>2]|0)==0?(e=Xt(10)|0,c[(c[g>>2]|0)+4>>2]=e,(c[(c[g>>2]|0)+4>>2]|0)==0):0){l=54;break a}if((Yt(c[(c[g>>2]|0)+4>>2]|0,c[f>>2]|0,0)|0)==-1)l=54;break}default:l=54}while(0);do if((l|0)==35){if((c[(c[g>>2]|0)+16>>2]|0)!=0?(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]|0)>=(c[(c[g>>2]|0)+36>>2]|0):0){l=54;break}if((c[(c[g>>2]|0)+16>>2]|0)==0?(e=Xt(10)|0,c[(c[g>>2]|0)+16>>2]=e,(c[(c[g>>2]|0)+16>>2]|0)==0):0){l=54;break}if((Yt(c[(c[g>>2]|0)+16>>2]|0,c[f>>2]|0,0)|0)==-1)l=54}while(0);if((l|0)==54){if(c[(c[f>>2]|0)+4>>2]|0)fr(c[(c[f>>2]|0)+4>>2]|0);zb[c[135736>>2]&511](c[f>>2]|0);i=d;return}l=c[f>>2]|0;if(!(c[(c[f>>2]|0)+4>>2]|0)){m=l+0|0;n=m+48|0;do{c[m>>2]=0;m=m+4|0}while((m|0)<(n|0));i=d;return}c[h>>2]=c[l+4>>2];b:do if((c[c[h>>2]>>2]|0)<=1){if(((c[c[h>>2]>>2]|0)==1?(c[c[(c[h>>2]|0)+8>>2]>>2]|0)!=0:0)?(c[(c[c[(c[h>>2]|0)+8>>2]>>2]|0)+4>>2]|0)==18:0)_q(c[c[(c[h>>2]|0)+8>>2]>>2]|0)}else{c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[c[h>>2]>>2]|0))break b;c[k>>2]=c[(c[(c[h>>2]|0)+8>>2]|0)+(c[j>>2]<<2)>>2];if((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+4>>2]|0)==18:0)_q(c[k>>2]|0);c[j>>2]=(c[j>>2]|0)+1}}while(0);c[c[h>>2]>>2]=0;m=(c[f>>2]|0)+0|0;n=m+48|0;do{c[m>>2]=0;m=m+4|0}while((m|0)<(n|0));c[(c[f>>2]|0)+4>>2]=c[h>>2];i=d;return}Qq(c[f>>2]|0);i=d;return}function kt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+4>>2]|0)==18:0){if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+4>>2]|0)!=18:0){c[h>>2]=Cb[c[135744>>2]&511](24)|0;if(!(c[h>>2]|0)){it(0,130952);c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}b=c[h>>2]|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[(c[h>>2]|0)+4>>2]=18;if(c[(c[g>>2]|0)+8>>2]|0){b=my(c[(c[g>>2]|0)+8>>2]|0)|0;c[(c[h>>2]|0)+8>>2]=b}if(c[(c[g>>2]|0)+12>>2]|0){b=my(c[(c[g>>2]|0)+12>>2]|0)|0;c[(c[h>>2]|0)+12>>2]=b}c[c[h>>2]>>2]=c[f>>2];c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}c[e>>2]=c[g>>2];j=c[e>>2]|0;i=d;return j|0}c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}function lt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;a:do if(!(c[g>>2]|0))c[e>>2]=0;else{do if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+200>>2]|0)!=0:0){b=c[c[g>>2]>>2]|0;if((b|0)==4){c[e>>2]=Dt(c[f>>2]|0,c[(c[g>>2]|0)+24>>2]|0)|0;break a}else if((b|0)==3){c[e>>2]=wt(c[f>>2]|0,+h[(c[g>>2]|0)+16>>3])|0;break a}else if((b|0)==2){c[e>>2]=Ft(c[f>>2]|0,c[(c[g>>2]|0)+8>>2]|0)|0;break a}else if((b|0)==1){b=c[f>>2]|0;c[e>>2]=At(b,er(0,c[(c[g>>2]|0)+4>>2]|0)|0)|0;break a}else break}while(0);c[e>>2]=zr(c[g>>2]|0)|0}while(0);i=d;return c[e>>2]|0}function mt(b,d,e){b=+b;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;i=i+144|0;g=f+16|0;j=f+8|0;l=f+68|0;m=f+64|0;n=f+100|0;o=f+60|0;p=f+56|0;q=f+52|0;r=f+72|0;s=f+48|0;t=f+44|0;u=f+40|0;v=f+36|0;w=f;x=f+32|0;h[j>>3]=b;c[l>>2]=d;c[m>>2]=e;e=Mq(+h[j>>3])|0;if((e|0)==-1){if((c[m>>2]|0)<=10){i=f;return}JT(c[l>>2]|0,c[m>>2]|0,129032,g)|0;i=f;return}else if((e|0)==1){if((c[m>>2]|0)<=9){i=f;return}JT(c[l>>2]|0,c[m>>2]|0,129016,g)|0;i=f;return}else{if(Lq(+h[j>>3])|0){if((c[m>>2]|0)<=4){i=f;return}JT(c[l>>2]|0,c[m>>2]|0,129048,g)|0;i=f;return}if(+h[j>>3]==0?(et(+h[j>>3])|0)!=0:0){JT(c[l>>2]|0,c[m>>2]|0,129056,g)|0;i=f;return}b=+h[j>>3];if(+h[j>>3]==+(~~+h[j>>3]|0)){c[q>>2]=~~b;c[o>>2]=c[l>>2];a:do if(!(c[q>>2]|0)){e=c[o>>2]|0;c[o>>2]=e+1;a[e>>0]=48}else{c[g>>2]=c[q>>2];JT(n,29,130840,g)|0;c[p>>2]=n;while(1){if(!(a[c[p>>2]>>0]|0))break a;if(((c[o>>2]|0)-(c[l>>2]|0)|0)>=(c[m>>2]|0))break a;e=c[p>>2]|0;c[p>>2]=e+1;d=a[e>>0]|0;e=c[o>>2]|0;c[o>>2]=e+1;a[e>>0]=d}}while(0);if(((c[o>>2]|0)-(c[l>>2]|0)|0)<(c[m>>2]|0)){a[c[o>>2]>>0]=0;i=f;return}if((c[m>>2]|0)<=0){i=f;return}c[o>>2]=(c[o>>2]|0)+-1;a[c[o>>2]>>0]=0;i=f;return}h[w>>3]=+R(+b);b:do if((+h[w>>3]>1e9|+h[w>>3]<1e-5)&+h[w>>3]!=0){c[s>>2]=21;c[t>>2]=14;o=c[t>>2]|0;b=+h[j>>3];c[g>>2]=c[s>>2];c[g+4>>2]=o;o=g+8|0;h[k>>3]=b;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];c[x>>2]=JT(r,28,130848,g)|0;while(1){if((c[x>>2]|0)<=0)break b;if((a[r+(c[x>>2]|0)>>0]|0)==101)break b;c[x>>2]=(c[x>>2]|0)+-1}}else{do if(+h[w>>3]>0){c[s>>2]=~~+yT(+h[w>>3]);o=15-(c[s>>2]|0)|0;if((c[s>>2]|0)>0){c[t>>2]=o-1;break}else{c[t>>2]=o;break}}else c[t>>2]=1;while(0);b=+h[j>>3];c[g>>2]=c[t>>2];o=g+4|0;h[k>>3]=b;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];c[x>>2]=JT(r,28,130856,g)|0}while(0);while(1){if((a[r>>0]|0)!=32)break;c[u>>2]=r;while(1){g=a[(c[u>>2]|0)+1>>0]|0;a[c[u>>2]>>0]=g;if(!(g<<24>>24))break;c[u>>2]=(c[u>>2]|0)+1}c[x>>2]=(c[x>>2]|0)+-1}c[v>>2]=r+(c[x>>2]|0);c[u>>2]=c[v>>2];do{g=(c[u>>2]|0)+-1|0;c[u>>2]=g}while((a[g>>0]|0)==48);if((a[c[u>>2]>>0]|0)!=46)c[u>>2]=(c[u>>2]|0)+1;do{g=c[v>>2]|0;c[v>>2]=g+1;t=a[g>>0]|0;g=c[u>>2]|0;c[u>>2]=g+1;a[g>>0]=t}while((t<<24>>24|0)!=0);c[x>>2]=(ZT(r|0)|0)+1;if((c[x>>2]|0)>(c[m>>2]|0)){a[r+((c[m>>2]|0)-1)>>0]=0;c[x>>2]=c[m>>2]}fU(c[l>>2]|0,r|0,c[x>>2]|0)|0;i=f;return}}function nt(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=a;c[g>>2]=b;if(!(c[g>>2]|0)){b=c[f>>2]|0;Tq(b,yt(c[(c[f>>2]|0)+12>>2]|0,c[(c[(c[f>>2]|0)+12>>2]|0)+4>>2]|0)|0)|0;c[g>>2]=1}if(!(c[f>>2]|0)){i=e;return}b=c[f>>2]|0;if((c[g>>2]|0)!=1){Nq(b,12);i=e;return}g=c[f>>2]|0;if((c[b+20>>2]|0)<((c[(c[f>>2]|0)+44>>2]|0)+1|0)){Nq(g,23);i=e;return}do if(c[g+16>>2]|0){if((c[c[(c[f>>2]|0)+16>>2]>>2]|0)!=1?(c[c[(c[f>>2]|0)+16>>2]>>2]|0)!=9:0)break;c[h>>2]=Sq(c[f>>2]|0)|0;do if((c[(c[h>>2]|0)+4>>2]|0)!=0?(c[c[(c[h>>2]|0)+4>>2]>>2]|0)!=0:0){c[j>>2]=0;if(((c[(c[(c[(c[(c[h>>2]|0)+4>>2]|0)+8>>2]|0)+(c[j>>2]<<2)>>2]|0)+4>>2]|0)+-1|0)>>>0>=2){b=c[f>>2]|0;Tq(b,yt(c[(c[f>>2]|0)+12>>2]|0,c[(c[(c[(c[h>>2]|0)+4>>2]|0)+8>>2]|0)+(c[j>>2]<<2)>>2]|0)|0)|0;ps(c[f>>2]|0,1);break}if((d[c[(c[(c[(c[(c[h>>2]|0)+4>>2]|0)+8>>2]|0)+(c[j>>2]<<2)>>2]|0)+8>>2]>>0]|0|0)==32){b=c[f>>2]|0;Tq(b,Ct(c[(c[f>>2]|0)+12>>2]|0,128928)|0)|0;break}if((c[(c[(c[(c[(c[h>>2]|0)+4>>2]|0)+8>>2]|0)+(c[j>>2]<<2)>>2]|0)+36>>2]|0)!=0?(c[(c[(c[(c[(c[(c[h>>2]|0)+4>>2]|0)+8>>2]|0)+(c[j>>2]<<2)>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){c[k>>2]=Bh(c[(c[(c[(c[(c[h>>2]|0)+4>>2]|0)+8>>2]|0)+(c[j>>2]<<2)>>2]|0)+8>>2]|0,c[(c[(c[(c[(c[(c[h>>2]|0)+4>>2]|0)+8>>2]|0)+(c[j>>2]<<2)>>2]|0)+36>>2]|0)+12>>2]|0,0,0)|0;if((c[k>>2]|0)==(c[(c[(c[(c[(c[h>>2]|0)+4>>2]|0)+8>>2]|0)+(c[j>>2]<<2)>>2]|0)+8>>2]|0))c[k>>2]=my(c[(c[(c[(c[(c[h>>2]|0)+4>>2]|0)+8>>2]|0)+(c[j>>2]<<2)>>2]|0)+8>>2]|0)|0;b=c[f>>2]|0;if(c[k>>2]|0){Tq(b,Et(c[(c[f>>2]|0)+12>>2]|0,c[k>>2]|0)|0)|0;break}Nq(b,15);i=e;return}b=c[f>>2]|0;Tq(b,Dt(c[(c[f>>2]|0)+12>>2]|0,c[(c[(c[(c[(c[h>>2]|0)+4>>2]|0)+8>>2]|0)+(c[j>>2]<<2)>>2]|0)+8>>2]|0)|0)|0}else l=14;while(0);if((l|0)==14){b=c[f>>2]|0;Tq(b,Ct(c[(c[f>>2]|0)+12>>2]|0,128928)|0)|0}jt(c[(c[f>>2]|0)+12>>2]|0,c[h>>2]|0);i=e;return}while(0);Nq(c[f>>2]|0,11);i=e;return}function ot(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;n=f+24|0;c[g>>2]=b;c[h>>2]=e;if(!(c[g>>2]|0)){i=f;return}e=c[g>>2]|0;if((c[h>>2]|0)!=2){Nq(e,12);i=f;return}h=c[g>>2]|0;if((c[e+20>>2]|0)<((c[(c[g>>2]|0)+44>>2]|0)+2|0)){Nq(h,23);i=f;return}c[k>>2]=Uq(h)|0;if((c[(c[g>>2]|0)+16>>2]|0)!=0?(c[c[(c[g>>2]|0)+16>>2]>>2]|0)!=4:0)rs(c[g>>2]|0,1);c[j>>2]=Sq(c[g>>2]|0)|0;c[l>>2]=Ly()|0;a[n>>0]=37;a[n+3>>0]=0;a:do if(c[l>>2]|0){c[m>>2]=c[(c[j>>2]|0)+24>>2];while(1){if(!(a[c[m>>2]>>0]|0))break a;if((d[c[m>>2]>>0]|0)>=65?(d[c[m>>2]>>0]|0)<=90:0)o=51;else o=14;b:do if((o|0)==14){o=0;if((d[c[m>>2]>>0]|0)>=97?(d[c[m>>2]>>0]|0)<=122:0){o=51;break}if((d[c[m>>2]>>0]|0)>=48?(d[c[m>>2]>>0]|0)<=57:0){o=51;break}if((((((((d[c[m>>2]>>0]|0)!=45?(d[c[m>>2]>>0]|0)!=95:0)?(d[c[m>>2]>>0]|0)!=46:0)?(d[c[m>>2]>>0]|0)!=33:0)?(d[c[m>>2]>>0]|0)!=126:0)?(d[c[m>>2]>>0]|0)!=42:0)?(d[c[m>>2]>>0]|0)!=39:0)?(d[c[m>>2]>>0]|0)!=40:0){if((d[c[m>>2]>>0]|0)==41){o=51;break}c:do if((d[c[m>>2]>>0]|0)==37){if(!((d[(c[m>>2]|0)+1>>0]|0)>=65?(d[(c[m>>2]|0)+1>>0]|0)<=70:0))o=30;do if((o|0)==30){o=0;if((d[(c[m>>2]|0)+1>>0]|0)>=97?(d[(c[m>>2]|0)+1>>0]|0)<=102:0)break;if((d[(c[m>>2]|0)+1>>0]|0)<48)break c;if((d[(c[m>>2]|0)+1>>0]|0)>57)break c}while(0);if((d[(c[m>>2]|0)+2>>0]|0)>=65?(d[(c[m>>2]|0)+2>>0]|0)<=70:0){o=51;break b}if((d[(c[m>>2]|0)+2>>0]|0)>=97?(d[(c[m>>2]|0)+2>>0]|0)<=102:0){o=51;break b}if((d[(c[m>>2]|0)+2>>0]|0)<48)break;if((d[(c[m>>2]|0)+2>>0]|0)<=57){o=51;break b}}while(0);if(!(c[k>>2]|0)){if((d[c[m>>2]>>0]|0)==59){o=51;break}if((d[c[m>>2]>>0]|0)==47){o=51;break}if((d[c[m>>2]>>0]|0)==63){o=51;break}if((d[c[m>>2]>>0]|0)==58){o=51;break}if((d[c[m>>2]>>0]|0)==64){o=51;break}if((d[c[m>>2]>>0]|0)==38){o=51;break}if((d[c[m>>2]>>0]|0)==61){o=51;break}if((d[c[m>>2]>>0]|0)==43){o=51;break}if((d[c[m>>2]>>0]|0)==36){o=51;break}if((d[c[m>>2]>>0]|0)==44){o=51;break}}h=d[c[m>>2]>>0]>>4;if((d[c[m>>2]>>0]>>4|0)<10)a[n+1>>0]=48+h;else a[n+1>>0]=55+h;h=d[c[m>>2]>>0]&15;if((d[c[m>>2]>>0]&15|0)<10)a[n+2>>0]=48+h;else a[n+2>>0]=55+h;cz(c[l>>2]|0,n,3)|0}else o=51}while(0);if((o|0)==51){o=0;cz(c[l>>2]|0,c[m>>2]|0,1)|0}c[m>>2]=(c[m>>2]|0)+1}}while(0);m=c[g>>2]|0;o=c[(c[g>>2]|0)+12>>2]|0;Tq(m,Dt(o,Vy(c[l>>2]|0)|0)|0)|0;Ry(c[l>>2]|0);jt(c[(c[g>>2]|0)+12>>2]|0,c[j>>2]|0);i=f;return}function pt(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=Cb[c[135744>>2]&511](28)|0;if(!(c[d>>2]|0)){it(0,130792);c[b>>2]=0;e=c[b>>2]|0;i=a;return e|0}f=c[d>>2]|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=0;c[(c[d>>2]|0)+4>>2]=10;c[c[d>>2]>>2]=0;f=Cb[c[135744>>2]&511]((c[(c[d>>2]|0)+4>>2]|0)*40|0)|0;c[(c[d>>2]|0)+8>>2]=f;if(!(c[(c[d>>2]|0)+8>>2]|0)){it(0,130816);zb[c[135736>>2]&511](c[d>>2]|0);c[b>>2]=0;e=c[b>>2]|0;i=a;return e|0}else{cU(c[(c[d>>2]|0)+8>>2]|0,0,(c[(c[d>>2]|0)+4>>2]|0)*40|0)|0;c[(c[d>>2]|0)+12>>2]=-1;c[b>>2]=c[d>>2];e=c[b>>2]|0;i=a;return e|0}return 0}function qt(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;i=i+64|0;f=e+48|0;g=e+44|0;h=e+40|0;j=e+36|0;k=e+32|0;l=e+28|0;m=e+24|0;n=e+20|0;o=e+16|0;p=e+12|0;q=e+8|0;r=e+4|0;s=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[q>>2]=0;do if(c[g>>2]|0){if((c[c[g>>2]>>2]|0)!=1?(c[c[g>>2]>>2]|0)!=9:0)break;do if(c[h>>2]|0){if((c[c[h>>2]>>2]|0)!=1?(c[c[h>>2]>>2]|0)!=9:0)break;c[r>>2]=c[(c[g>>2]|0)+4>>2];c[s>>2]=c[(c[h>>2]|0)+4>>2];if((c[r>>2]|0)!=0?(c[c[r>>2]>>2]|0)>0:0){if((c[s>>2]|0)!=0?(c[c[s>>2]>>2]|0)>0:0){a:do if(!(c[j>>2]|0)){c[k>>2]=0;b:while(1){if((c[k>>2]|0)>=(c[c[r>>2]>>2]|0))break a;c[l>>2]=0;while(1){t=c[k>>2]|0;if((c[l>>2]|0)>=(c[c[s>>2]>>2]|0))break;if((c[(c[(c[r>>2]|0)+8>>2]|0)+(t<<2)>>2]|0)==(c[(c[(c[s>>2]|0)+8>>2]|0)+(c[l>>2]<<2)>>2]|0))break b;c[l>>2]=(c[l>>2]|0)+1}c[k>>2]=t+1}c[f>>2]=1;u=c[f>>2]|0;i=e;return u|0}while(0);c[o>>2]=Cb[c[135744>>2]&511](c[c[r>>2]>>2]<<2)|0;if(!(c[o>>2]|0)){it(0,130768);c[f>>2]=0;u=c[f>>2]|0;i=e;return u|0}c[m>>2]=Cb[c[135744>>2]&511](c[c[r>>2]>>2]<<2)|0;if(!(c[m>>2]|0)){it(0,130768);zb[c[135736>>2]&511](c[o>>2]|0);c[f>>2]=0;u=c[f>>2]|0;i=e;return u|0}cU(c[o>>2]|0,0,c[c[r>>2]>>2]<<2|0)|0;c[p>>2]=Cb[c[135744>>2]&511](c[c[s>>2]>>2]<<2)|0;if(!(c[p>>2]|0)){
it(0,130768);zb[c[135736>>2]&511](c[m>>2]|0);zb[c[135736>>2]&511](c[o>>2]|0);c[f>>2]=0;u=c[f>>2]|0;i=e;return u|0}c[n>>2]=Cb[c[135744>>2]&511](c[c[s>>2]>>2]<<2)|0;if(!(c[n>>2]|0)){it(0,130768);zb[c[135736>>2]&511](c[m>>2]|0);zb[c[135736>>2]&511](c[o>>2]|0);zb[c[135736>>2]&511](c[p>>2]|0);c[f>>2]=0;u=c[f>>2]|0;i=e;return u|0}cU(c[p>>2]|0,0,c[c[s>>2]>>2]<<2|0)|0;c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[c[r>>2]>>2]|0))break;d=Zt(c[(c[(c[r>>2]|0)+8>>2]|0)+(c[k>>2]<<2)>>2]|0)|0;c[(c[m>>2]|0)+(c[k>>2]<<2)>>2]=d;c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[c[s>>2]>>2]|0))break;if(!(c[k>>2]|0)){d=Zt(c[(c[(c[s>>2]|0)+8>>2]|0)+(c[l>>2]<<2)>>2]|0)|0;c[(c[n>>2]|0)+(c[l>>2]<<2)>>2]=d}if((c[(c[m>>2]|0)+(c[k>>2]<<2)>>2]|0)!=(c[(c[n>>2]|0)+(c[l>>2]<<2)>>2]|0)){if(c[j>>2]|0){v=40;break}}else{if(!(c[(c[o>>2]|0)+(c[k>>2]<<2)>>2]|0)){d=_i(c[(c[(c[r>>2]|0)+8>>2]|0)+(c[k>>2]<<2)>>2]|0)|0;c[(c[o>>2]|0)+(c[k>>2]<<2)>>2]=d}if(!(c[(c[p>>2]|0)+(c[l>>2]<<2)>>2]|0)){d=_i(c[(c[(c[s>>2]|0)+8>>2]|0)+(c[l>>2]<<2)>>2]|0)|0;c[(c[p>>2]|0)+(c[l>>2]<<2)>>2]=d}d=qy(c[(c[o>>2]|0)+(c[k>>2]<<2)>>2]|0,c[(c[p>>2]|0)+(c[l>>2]<<2)>>2]|0)|0;c[q>>2]=d^c[j>>2];if(c[q>>2]|0)break}c[l>>2]=(c[l>>2]|0)+1}if((v|0)==40){v=0;c[q>>2]=1}if(c[q>>2]|0)break;c[k>>2]=(c[k>>2]|0)+1}c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[c[r>>2]>>2]|0))break;if(c[(c[o>>2]|0)+(c[k>>2]<<2)>>2]|0)zb[c[135736>>2]&511](c[(c[o>>2]|0)+(c[k>>2]<<2)>>2]|0);c[k>>2]=(c[k>>2]|0)+1}c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[c[s>>2]>>2]|0))break;if(c[(c[p>>2]|0)+(c[l>>2]<<2)>>2]|0)zb[c[135736>>2]&511](c[(c[p>>2]|0)+(c[l>>2]<<2)>>2]|0);c[l>>2]=(c[l>>2]|0)+1}zb[c[135736>>2]&511](c[o>>2]|0);zb[c[135736>>2]&511](c[p>>2]|0);zb[c[135736>>2]&511](c[m>>2]|0);zb[c[135736>>2]&511](c[n>>2]|0);c[f>>2]=c[q>>2];u=c[f>>2]|0;i=e;return u|0}c[f>>2]=0;u=c[f>>2]|0;i=e;return u|0}c[f>>2]=0;u=c[f>>2]|0;i=e;return u|0}while(0);c[f>>2]=0;u=c[f>>2]|0;i=e;return u|0}while(0);c[f>>2]=0;u=c[f>>2]|0;i=e;return u|0}function rt(a,b,d,e){a=a|0;b=b|0;d=+d;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+64|0;g=f+48|0;j=f+44|0;k=f+40|0;l=f+8|0;m=f+36|0;n=f+32|0;o=f+28|0;p=f+24|0;q=f+20|0;r=f+16|0;s=f;c[j>>2]=a;c[k>>2]=b;h[l>>3]=d;c[m>>2]=e;c[o>>2]=0;do if(c[k>>2]|0){if((c[c[k>>2]>>2]|0)!=1?(c[c[k>>2]>>2]|0)!=9:0)break;c[p>>2]=c[(c[k>>2]|0)+4>>2];a:do if(c[p>>2]|0){c[n>>2]=0;b:while(1){if((c[n>>2]|0)>=(c[c[p>>2]>>2]|0))break a;c[q>>2]=ir(c[(c[(c[p>>2]|0)+8>>2]|0)+(c[n>>2]<<2)>>2]|0)|0;do if(c[q>>2]|0){e=c[j>>2]|0;Tq(e,Dt(c[(c[j>>2]|0)+12>>2]|0,c[q>>2]|0)|0)|0;zb[c[135736>>2]&511](c[q>>2]|0);Tr(c[j>>2]|0,1);c[r>>2]=Sq(c[j>>2]|0)|0;h[s>>3]=+h[(c[r>>2]|0)+16>>3];jt(c[(c[j>>2]|0)+12>>2]|0,c[r>>2]|0);e=(Lq(+h[s>>3])|0)!=0;b=(c[m>>2]|0)!=0;if(e){if(!b)break;c[o>>2]=1;break}if(!b?+h[s>>3]==+h[l>>3]:0){t=12;break b}if((c[m>>2]|0)!=0?+h[s>>3]!=+h[l>>3]:0){t=15;break b}}while(0);c[n>>2]=(c[n>>2]|0)+1}if((t|0)==12){c[o>>2]=1;break}else if((t|0)==15){c[o>>2]=1;break}}while(0);c[g>>2]=c[o>>2];u=c[g>>2]|0;i=f;return u|0}while(0);c[g>>2]=0;u=c[g>>2]|0;i=f;return u|0}function st(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;n=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;do if(!((c[h>>2]|0)==0|(c[g>>2]|0)==0)){if((c[c[g>>2]>>2]|0)!=1?(c[c[g>>2]>>2]|0)!=9:0)break;c[l>>2]=c[(c[g>>2]|0)+4>>2];if((c[l>>2]|0)!=0?(c[c[l>>2]>>2]|0)>0:0){c[n>>2]=_t(c[h>>2]|0)|0;c[k>>2]=0;a:while(1){if((c[k>>2]|0)>=(c[c[l>>2]>>2]|0)){o=28;break}d=Zt(c[(c[(c[l>>2]|0)+8>>2]|0)+(c[k>>2]<<2)>>2]|0)|0;do if((d|0)==(c[n>>2]|0)){c[m>>2]=_i(c[(c[(c[l>>2]|0)+8>>2]|0)+(c[k>>2]<<2)>>2]|0)|0;if((c[m>>2]|0)!=0?(qy(c[h>>2]|0,c[m>>2]|0)|0)!=0:0){zb[c[135736>>2]&511](c[m>>2]|0);if(c[j>>2]|0)break;else{o=14;break a}}if((c[m>>2]|0)==0?(qy(c[h>>2]|0,128928)|0)!=0:0)if(c[j>>2]|0)break;else{o=18;break a}p=(c[m>>2]|0)!=0;if(c[j>>2]|0){o=20;break a}if(p)zb[c[135736>>2]&511](c[m>>2]|0)}else if(c[j>>2]|0){o=26;break a}while(0);c[k>>2]=(c[k>>2]|0)+1}if((o|0)==14){c[f>>2]=1;q=c[f>>2]|0;i=e;return q|0}else if((o|0)==18){c[f>>2]=1;q=c[f>>2]|0;i=e;return q|0}else if((o|0)==20){if(p)zb[c[135736>>2]&511](c[m>>2]|0);c[f>>2]=1;q=c[f>>2]|0;i=e;return q|0}else if((o|0)==26){c[f>>2]=1;q=c[f>>2]|0;i=e;return q|0}else if((o|0)==28){c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}}c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}while(0);c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}function tt(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=e;c[m>>2]=0;a:do switch(c[c[k>>2]>>2]|0){case 3:{switch(c[c[l>>2]>>2]|0){case 4:{Tq(c[j>>2]|0,c[l>>2]|0)|0;Tr(c[j>>2]|0,1);c[l>>2]=Sq(c[j>>2]|0)|0;break}case 3:break;case 6:case 5:case 8:case 7:{e=c[33976]|0;b=c[33980]|0;c[g>>2]=128552;c[g+4>>2]=7047;Db[e&511](b,129064,g);break a;break}case 2:{c[m>>2]=(c[(c[l>>2]|0)+8>>2]|0)==(Ir(+h[(c[k>>2]|0)+16>>3])|0)&1;break a;break}default:break a}if((Lq(+h[(c[k>>2]|0)+16>>3])|0)==0?(Lq(+h[(c[l>>2]|0)+16>>3])|0)==0:0){if((Mq(+h[(c[k>>2]|0)+16>>3])|0)==1)if((Mq(+h[(c[l>>2]|0)+16>>3])|0)==1){c[m>>2]=1;break a}else{c[m>>2]=0;break a}b=(Mq(+h[(c[k>>2]|0)+16>>3])|0)==-1;e=Mq(+h[(c[l>>2]|0)+16>>3])|0;if(b)if((e|0)==-1){c[m>>2]=1;break a}else{c[m>>2]=0;break a}if((e|0)==1)if((Mq(+h[(c[k>>2]|0)+16>>3])|0)==1){c[m>>2]=1;break a}else{c[m>>2]=0;break a}e=(Mq(+h[(c[l>>2]|0)+16>>3])|0)==-1;n=+h[(c[k>>2]|0)+16>>3];if(!e){c[m>>2]=n==+h[(c[l>>2]|0)+16>>3]&1;break a}if((Mq(n)|0)==-1){c[m>>2]=1;break a}else{c[m>>2]=0;break a}}c[m>>2]=0;break}case 6:case 5:case 8:case 7:{e=c[33976]|0;b=c[33980]|0;c[g>>2]=128552;c[g+4>>2]=7119;Db[e&511](b,129064,g);break}case 2:{switch(c[c[l>>2]>>2]|0){case 6:case 5:case 8:case 7:{b=c[33976]|0;e=c[33980]|0;c[g>>2]=128552;c[g+4>>2]=6990;Db[b&511](e,129064,g);break a;break}case 3:{c[m>>2]=(c[(c[k>>2]|0)+8>>2]|0)==(Ir(+h[(c[l>>2]|0)+16>>3])|0)&1;break a;break}case 2:{c[m>>2]=(c[(c[k>>2]|0)+8>>2]|0)==(c[(c[l>>2]|0)+8>>2]|0)&1;break a;break}case 4:{if((c[(c[l>>2]|0)+24>>2]|0)!=0?(d[c[(c[l>>2]|0)+24>>2]>>0]|0|0)!=0:0)c[m>>2]=1;else c[m>>2]=0;c[m>>2]=(c[(c[k>>2]|0)+8>>2]|0)==(c[m>>2]|0)&1;break a;break}default:break a}break}case 4:{switch(c[c[l>>2]>>2]|0){case 3:{Tq(c[j>>2]|0,c[k>>2]|0)|0;Tr(c[j>>2]|0,1);c[k>>2]=Sq(c[j>>2]|0)|0;if((Lq(+h[(c[k>>2]|0)+16>>3])|0)==0?(Lq(+h[(c[l>>2]|0)+16>>3])|0)==0:0){if((Mq(+h[(c[k>>2]|0)+16>>3])|0)==1)if((Mq(+h[(c[l>>2]|0)+16>>3])|0)==1){c[m>>2]=1;break a}else{c[m>>2]=0;break a}e=(Mq(+h[(c[k>>2]|0)+16>>3])|0)==-1;b=Mq(+h[(c[l>>2]|0)+16>>3])|0;if(e)if((b|0)==-1){c[m>>2]=1;break a}else{c[m>>2]=0;break a}if((b|0)==1)if((Mq(+h[(c[k>>2]|0)+16>>3])|0)==1){c[m>>2]=1;break a}else{c[m>>2]=0;break a}b=(Mq(+h[(c[l>>2]|0)+16>>3])|0)==-1;n=+h[(c[k>>2]|0)+16>>3];if(!b){c[m>>2]=n==+h[(c[l>>2]|0)+16>>3]&1;break a}if((Mq(n)|0)==-1){c[m>>2]=1;break a}else{c[m>>2]=0;break a}}c[m>>2]=0;break a;break}case 6:case 5:case 8:case 7:{b=c[33976]|0;e=c[33980]|0;c[g>>2]=128552;c[g+4>>2]=7108;Db[b&511](e,129064,g);break a;break}case 2:{if((c[(c[k>>2]|0)+24>>2]|0)!=0?(d[c[(c[k>>2]|0)+24>>2]>>0]|0|0)!=0:0)c[m>>2]=1;else c[m>>2]=0;c[m>>2]=(c[(c[l>>2]|0)+8>>2]|0)==(c[m>>2]|0)&1;break a;break}case 4:{c[m>>2]=qy(c[(c[k>>2]|0)+24>>2]|0,c[(c[l>>2]|0)+24>>2]|0)|0;break a;break}default:break a}break}default:{}}while(0);jt(c[(c[j>>2]|0)+12>>2]|0,c[k>>2]|0);jt(c[(c[j>>2]|0)+12>>2]|0,c[l>>2]|0);i=f;return c[m>>2]|0}function ut(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;i=i+64|0;g=f+52|0;j=f+48|0;k=f+44|0;l=f+40|0;m=f+36|0;n=f+32|0;o=f+28|0;p=f+24|0;q=f;r=f+20|0;s=f+16|0;t=f+12|0;u=f+8|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[p>>2]=0;c[s>>2]=0;do if(c[l>>2]|0){if((c[c[l>>2]>>2]|0)!=1?(c[c[l>>2]>>2]|0)!=9:0)break;do if(c[m>>2]|0){if((c[c[m>>2]>>2]|0)!=1?(c[c[m>>2]>>2]|0)!=9:0)break;c[t>>2]=c[(c[l>>2]|0)+4>>2];c[u>>2]=c[(c[m>>2]|0)+4>>2];if((c[t>>2]|0)!=0?(c[c[t>>2]>>2]|0)>0:0){if((c[u>>2]|0)!=0?(c[c[u>>2]>>2]|0)>0:0){c[r>>2]=Cb[c[135744>>2]&511](c[c[u>>2]>>2]<<3)|0;if(!(c[r>>2]|0)){it(0,130768);Qq(c[l>>2]|0);Qq(c[m>>2]|0);c[g>>2]=0;v=c[g>>2]|0;i=f;return v|0}c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[c[t>>2]>>2]|0))break;h[q>>3]=+Gr(c[(c[(c[t>>2]|0)+8>>2]|0)+(c[n>>2]<<2)>>2]|0);if(!(Lq(+h[q>>3])|0)){c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[c[u>>2]>>2]|0))break;if(!(c[p>>2]|0)){w=+Gr(c[(c[(c[u>>2]|0)+8>>2]|0)+(c[o>>2]<<2)>>2]|0);h[(c[r>>2]|0)+(c[o>>2]<<3)>>3]=w}if(!(Lq(+h[(c[r>>2]|0)+(c[o>>2]<<3)>>3])|0)){do if((c[j>>2]|0)!=0&(c[k>>2]|0)!=0)c[s>>2]=+h[q>>3]<+h[(c[r>>2]|0)+(c[o>>2]<<3)>>3]&1;else{if(!((c[j>>2]|0)==0|(c[k>>2]|0)!=0)){c[s>>2]=+h[q>>3]<=+h[(c[r>>2]|0)+(c[o>>2]<<3)>>3]&1;break}if((c[j>>2]|0)==0&(c[k>>2]|0)!=0){c[s>>2]=+h[q>>3]>+h[(c[r>>2]|0)+(c[o>>2]<<3)>>3]&1;break}if((c[j>>2]|0)!=0|(c[k>>2]|0)!=0)break;c[s>>2]=+h[q>>3]>=+h[(c[r>>2]|0)+(c[o>>2]<<3)>>3]&1}while(0);if(c[s>>2]|0)break}c[o>>2]=(c[o>>2]|0)+1}if(c[s>>2]|0)break;c[p>>2]=1}c[n>>2]=(c[n>>2]|0)+1}zb[c[135736>>2]&511](c[r>>2]|0);Qq(c[l>>2]|0);Qq(c[m>>2]|0);c[g>>2]=c[s>>2];v=c[g>>2]|0;i=f;return v|0}Qq(c[l>>2]|0);Qq(c[m>>2]|0);c[g>>2]=0;v=c[g>>2]|0;i=f;return v|0}Qq(c[l>>2]|0);Qq(c[m>>2]|0);c[g>>2]=0;v=c[g>>2]|0;i=f;return v|0}while(0);Qq(c[l>>2]|0);Qq(c[m>>2]|0);c[g>>2]=0;v=c[g>>2]|0;i=f;return v|0}while(0);Qq(c[m>>2]|0);c[g>>2]=0;v=c[g>>2]|0;i=f;return v|0}function vt(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+32|0;h=g;j=g+28|0;k=g+24|0;l=g+20|0;m=g+16|0;n=g+12|0;o=g+8|0;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;do if(!((c[o>>2]|0)==0|(c[n>>2]|0)==0)){if((c[c[n>>2]>>2]|0)!=1?(c[c[n>>2]>>2]|0)!=9:0)break;switch(c[c[o>>2]>>2]|0){case 9:case 1:{c[j>>2]=ut(c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0)|0;p=c[j>>2]|0;i=g;return p|0}case 4:{c[j>>2]=au(c[k>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0)|0;p=c[j>>2]|0;i=g;return p|0}case 2:{Tq(c[k>>2]|0,c[n>>2]|0)|0;Bs(c[k>>2]|0,1);Tq(c[k>>2]|0,c[o>>2]|0)|0;c[j>>2]=Sr(c[k>>2]|0,c[l>>2]|0,c[m>>2]|0)|0;p=c[j>>2]|0;i=g;return p|0}case 3:{c[j>>2]=$t(c[k>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0)|0;p=c[j>>2]|0;i=g;return p|0}default:{f=c[33976]|0;e=c[33980]|0;c[h>>2]=128552;c[h+4>>2]=6705;Db[f&511](e,129064,h);c[j>>2]=0;p=c[j>>2]|0;i=g;return p|0}}}while(0);c[j>>2]=0;p=c[j>>2]|0;i=g;return p|0}function wt(a,b){a=a|0;b=+b;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d;j=d+16|0;k=d+12|0;l=d+8|0;c[f>>2]=a;h[g>>3]=b;if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+200>>2]|0)!=0:0){c[j>>2]=c[(c[f>>2]|0)+200>>2];if((c[(c[j>>2]|0)+12>>2]|0)!=0?(c[(c[(c[j>>2]|0)+12>>2]|0)+4>>2]|0)!=0:0){f=(c[(c[j>>2]|0)+12>>2]|0)+4|0;a=(c[f>>2]|0)+-1|0;c[f>>2]=a;c[k>>2]=c[(c[c[(c[j>>2]|0)+12>>2]>>2]|0)+(a<<2)>>2];c[c[k>>2]>>2]=3;h[(c[k>>2]|0)+16>>3]=+h[g>>3];c[e>>2]=c[k>>2];m=c[e>>2]|0;i=d;return m|0}if((c[(c[j>>2]|0)+16>>2]|0)!=0?(c[(c[(c[j>>2]|0)+16>>2]|0)+4>>2]|0)!=0:0){k=(c[(c[j>>2]|0)+16>>2]|0)+4|0;a=(c[k>>2]|0)+-1|0;c[k>>2]=a;c[l>>2]=c[(c[c[(c[j>>2]|0)+16>>2]>>2]|0)+(a<<2)>>2];c[c[l>>2]>>2]=3;h[(c[l>>2]|0)+16>>3]=+h[g>>3];c[e>>2]=c[l>>2];m=c[e>>2]|0;i=d;return m|0}}c[e>>2]=ur(+h[g>>3])|0;m=c[e>>2]|0;i=d;return m|0}function xt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if(!(c[g>>2]|0)){c[e>>2]=wt(c[f>>2]|0,0)|0;j=c[e>>2]|0;i=d;return j|0}if((c[c[g>>2]>>2]|0)==3){c[e>>2]=c[g>>2];j=c[e>>2]|0;i=d;return j|0}else{b=c[f>>2]|0;c[h>>2]=wt(b,+Wq(c[g>>2]|0))|0;jt(c[f>>2]|0,c[g>>2]|0);c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}return 0}function yt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+200>>2]|0)!=0:0){c[h>>2]=c[(c[f>>2]|0)+200>>2];if((c[c[h>>2]>>2]|0)!=0?(c[(c[c[h>>2]>>2]|0)+4>>2]|0)!=0:0){b=(c[c[h>>2]>>2]|0)+4|0;a=(c[b>>2]|0)+-1|0;c[b>>2]=a;c[j>>2]=c[(c[c[c[h>>2]>>2]>>2]|0)+(a<<2)>>2];c[c[j>>2]>>2]=1;c[(c[j>>2]|0)+8>>2]=0;do if(c[g>>2]|0){if((c[(c[(c[j>>2]|0)+4>>2]|0)+4>>2]|0)!=0?(c[(c[g>>2]|0)+4>>2]|0)!=18:0){c[c[(c[(c[j>>2]|0)+4>>2]|0)+8>>2]>>2]=c[g>>2];c[c[(c[j>>2]|0)+4>>2]>>2]=1;break}dr(c[(c[j>>2]|0)+4>>2]|0,c[g>>2]|0)|0}while(0);c[e>>2]=c[j>>2];l=c[e>>2]|0;i=d;return l|0}if((c[(c[h>>2]|0)+16>>2]|0)!=0?(c[(c[(c[h>>2]|0)+16>>2]|0)+4>>2]|0)!=0:0){j=(c[(c[h>>2]|0)+16>>2]|0)+4|0;a=(c[j>>2]|0)+-1|0;c[j>>2]=a;c[k>>2]=c[(c[c[(c[h>>2]|0)+16>>2]>>2]|0)+(a<<2)>>2];c[c[k>>2]>>2]=1;c[(c[k>>2]|0)+8>>2]=0;a=$q(c[g>>2]|0)|0;c[(c[k>>2]|0)+4>>2]=a;if(!(c[(c[k>>2]|0)+4>>2]|0)){c[(c[f>>2]|0)+136>>2]=12;c[(c[f>>2]|0)+140>>2]=2;c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}else{c[e>>2]=c[k>>2];l=c[e>>2]|0;i=d;return l|0}}}c[e>>2]=gr(c[g>>2]|0)|0;l=c[e>>2]|0;i=d;return l|0}function zt(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;n=e;c[g>>2]=a;c[h>>2]=b;c[k>>2]=c[h>>2];c[n>>2]=0;if(!(c[h>>2]|0)){c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}c[j>>2]=$q(0)|0;if(!(c[j>>2]|0)){c[f>>2]=c[j>>2];o=c[f>>2]|0;i=e;return o|0}a:while(1){do if((d[c[k>>2]>>0]|0|0)!=32){if(9<=(d[c[k>>2]>>0]|0|0)?(d[c[k>>2]>>0]|0|0)<=10:0)break;if((d[c[k>>2]>>0]|0|0)!=13)break a}while(0);c[k>>2]=(c[k>>2]|0)+1}while(1){if(!(d[c[k>>2]>>0]|0))break;while(1){if((d[c[k>>2]>>0]|0|0)==32)break;if(9<=(d[c[k>>2]>>0]|0|0)?(d[c[k>>2]>>0]|0|0)<=10:0)break;if((d[c[k>>2]>>0]|0|0)==13)break;if(!(d[c[k>>2]>>0]|0))break;c[k>>2]=(c[k>>2]|0)+1}c[l>>2]=ly(c[h>>2]|0,(c[k>>2]|0)-(c[h>>2]|0)|0)|0;if(c[l>>2]|0){c[m>>2]=Hm(c[g>>2]|0,c[l>>2]|0)|0;if(c[m>>2]|0){b=c[m>>2]|0;do if((c[(c[m>>2]|0)+4>>2]|0)!=2)if((c[b+4>>2]|0)==1){c[n>>2]=c[m>>2];break}else{c[n>>2]=0;break}else c[n>>2]=c[b+20>>2];while(0);if(c[n>>2]|0)cr(c[j>>2]|0,c[n>>2]|0)|0}zb[c[135736>>2]&511](c[l>>2]|0)}while(1){do if((d[c[k>>2]>>0]|0|0)==32)p=1;else{if(9<=(d[c[k>>2]>>0]|0|0)?(d[c[k>>2]>>0]|0|0)<=10:0){p=1;break}p=(d[c[k>>2]>>0]|0|0)==13}while(0);q=c[k>>2]|0;if(!p)break;c[k>>2]=q+1}c[h>>2]=q}c[f>>2]=c[j>>2];o=c[f>>2]|0;i=e;return o|0}function At(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[f>>2]=a;c[g>>2]=b;if((((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+200>>2]|0)!=0:0)?(c[h>>2]=c[(c[f>>2]|0)+200>>2],(c[(c[h>>2]|0)+16>>2]|0)!=0):0)?(c[(c[(c[h>>2]|0)+16>>2]|0)+4>>2]|0)!=0:0){f=(c[(c[h>>2]|0)+16>>2]|0)+4|0;b=(c[f>>2]|0)+-1|0;c[f>>2]=b;c[j>>2]=c[(c[c[(c[h>>2]|0)+16>>2]>>2]|0)+(b<<2)>>2];c[c[j>>2]>>2]=1;c[(c[j>>2]|0)+4>>2]=c[g>>2];c[e>>2]=c[j>>2];k=c[e>>2]|0;i=d;return k|0}c[e>>2]=hr(c[g>>2]|0)|0;k=c[e>>2]|0;i=d;return k|0}function Bt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d;f=d+20|0;g=d+16|0;j=d+12|0;k=d+8|0;c[g>>2]=a;c[j>>2]=b;c[k>>2]=0;if(!(c[j>>2]|0)){c[f>>2]=Ct(c[g>>2]|0,128928)|0;l=c[f>>2]|0;i=d;return l|0}switch(c[c[j>>2]>>2]|0){case 9:case 1:{c[k>>2]=Cr(c[(c[j>>2]|0)+4>>2]|0)|0;break}case 3:{c[k>>2]=Br(+h[(c[j>>2]|0)+16>>3])|0;break}case 6:case 5:case 8:case 7:{b=c[33976]|0;a=c[33980]|0;c[e>>2]=128552;c[e+4>>2]=2680;Db[b&511](a,129064,e);break}case 2:{c[k>>2]=Ar(c[(c[j>>2]|0)+8>>2]|0)|0;break}case 4:{c[f>>2]=c[j>>2];l=c[f>>2]|0;i=d;return l|0}default:{}}jt(c[g>>2]|0,c[j>>2]|0);j=c[g>>2]|0;if(!(c[k>>2]|0)){c[f>>2]=Ct(j,128928)|0;l=c[f>>2]|0;i=d;return l|0}else{c[f>>2]=Et(j,c[k>>2]|0)|0;l=c[f>>2]|0;i=d;return l|0}return 0}function Ct(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+200>>2]|0)!=0:0){c[h>>2]=c[(c[f>>2]|0)+200>>2];if((c[(c[h>>2]|0)+4>>2]|0)!=0?(c[(c[(c[h>>2]|0)+4>>2]|0)+4>>2]|0)!=0:0){f=(c[(c[h>>2]|0)+4>>2]|0)+4|0;b=(c[f>>2]|0)+-1|0;c[f>>2]=b;c[j>>2]=c[(c[c[(c[h>>2]|0)+4>>2]>>2]|0)+(b<<2)>>2];c[c[j>>2]>>2]=4;b=my(c[g>>2]|0)|0;c[(c[j>>2]|0)+24>>2]=b;c[e>>2]=c[j>>2];l=c[e>>2]|0;i=d;return l|0}if((c[(c[h>>2]|0)+16>>2]|0)!=0?(c[(c[(c[h>>2]|0)+16>>2]|0)+4>>2]|0)!=0:0){j=(c[(c[h>>2]|0)+16>>2]|0)+4|0;b=(c[j>>2]|0)+-1|0;c[j>>2]=b;c[k>>2]=c[(c[c[(c[h>>2]|0)+16>>2]>>2]|0)+(b<<2)>>2];c[c[k>>2]>>2]=4;b=my(c[g>>2]|0)|0;c[(c[k>>2]|0)+24>>2]=b;c[e>>2]=c[k>>2];l=c[e>>2]|0;i=d;return l|0}}c[e>>2]=yr(c[g>>2]|0)|0;l=c[e>>2]|0;i=d;return l|0}function Dt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+200>>2]|0)!=0:0){c[h>>2]=c[(c[f>>2]|0)+200>>2];if((c[(c[h>>2]|0)+4>>2]|0)!=0?(c[(c[(c[h>>2]|0)+4>>2]|0)+4>>2]|0)!=0:0){f=(c[(c[h>>2]|0)+4>>2]|0)+4|0;b=(c[f>>2]|0)+-1|0;c[f>>2]=b;c[j>>2]=c[(c[c[(c[h>>2]|0)+4>>2]>>2]|0)+(b<<2)>>2];c[c[j>>2]>>2]=4;if(c[g>>2]|0){b=my(c[g>>2]|0)|0;c[(c[j>>2]|0)+24>>2]=b}else{b=my(128928)|0;c[(c[j>>2]|0)+24>>2]=b}c[e>>2]=c[j>>2];l=c[e>>2]|0;i=d;return l|0}if((c[(c[h>>2]|0)+16>>2]|0)!=0?(c[(c[(c[h>>2]|0)+16>>2]|0)+4>>2]|0)!=0:0){j=(c[(c[h>>2]|0)+16>>2]|0)+4|0;b=(c[j>>2]|0)+-1|0;c[j>>2]=b;c[k>>2]=c[(c[c[(c[h>>2]|0)+16>>2]>>2]|0)+(b<<2)>>2];c[c[k>>2]>>2]=4;if(c[g>>2]|0){b=my(c[g>>2]|0)|0;c[(c[k>>2]|0)+24>>2]=b}else{b=my(128928)|0;c[(c[k>>2]|0)+24>>2]=b}c[e>>2]=c[k>>2];l=c[e>>2]|0;i=d;return l|0}}c[e>>2]=wr(c[g>>2]|0)|0;l=c[e>>2]|0;i=d;return l|0}function Et(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+200>>2]|0)!=0:0){c[h>>2]=c[(c[f>>2]|0)+200>>2];if((c[(c[h>>2]|0)+4>>2]|0)!=0?(c[(c[(c[h>>2]|0)+4>>2]|0)+4>>2]|0)!=0:0){f=(c[(c[h>>2]|0)+4>>2]|0)+4|0;b=(c[f>>2]|0)+-1|0;c[f>>2]=b;c[j>>2]=c[(c[c[(c[h>>2]|0)+4>>2]>>2]|0)+(b<<2)>>2];c[c[j>>2]>>2]=4;c[(c[j>>2]|0)+24>>2]=c[g>>2];c[e>>2]=c[j>>2];l=c[e>>2]|0;i=d;return l|0}if((c[(c[h>>2]|0)+16>>2]|0)!=0?(c[(c[(c[h>>2]|0)+16>>2]|0)+4>>2]|0)!=0:0){j=(c[(c[h>>2]|0)+16>>2]|0)+4|0;b=(c[j>>2]|0)+-1|0;c[j>>2]=b;c[k>>2]=c[(c[c[(c[h>>2]|0)+16>>2]>>2]|0)+(b<<2)>>2];c[c[k>>2]>>2]=4;c[(c[k>>2]|0)+24>>2]=c[g>>2];c[e>>2]=c[k>>2];l=c[e>>2]|0;i=d;return l|0}}c[e>>2]=xr(c[g>>2]|0)|0;l=c[e>>2]|0;i=d;return l|0}function Ft(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+200>>2]|0)!=0:0){c[h>>2]=c[(c[f>>2]|0)+200>>2];if((c[(c[h>>2]|0)+8>>2]|0)!=0?(c[(c[(c[h>>2]|0)+8>>2]|0)+4>>2]|0)!=0:0){f=(c[(c[h>>2]|0)+8>>2]|0)+4|0;b=(c[f>>2]|0)+-1|0;c[f>>2]=b;c[j>>2]=c[(c[c[(c[h>>2]|0)+8>>2]>>2]|0)+(b<<2)>>2];c[c[j>>2]>>2]=2;c[(c[j>>2]|0)+8>>2]=(c[g>>2]|0)!=0&1;c[e>>2]=c[j>>2];l=c[e>>2]|0;i=d;return l|0}if((c[(c[h>>2]|0)+16>>2]|0)!=0?(c[(c[(c[h>>2]|0)+16>>2]|0)+4>>2]|0)!=0:0){j=(c[(c[h>>2]|0)+16>>2]|0)+4|0;b=(c[j>>2]|0)+-1|0;c[j>>2]=b;c[k>>2]=c[(c[c[(c[h>>2]|0)+16>>2]>>2]|0)+(b<<2)>>2];c[c[k>>2]>>2]=2;c[(c[k>>2]|0)+8>>2]=(c[g>>2]|0)!=0&1;c[e>>2]=c[k>>2];l=c[e>>2]|0;i=d;return l|0}}c[e>>2]=vr(c[g>>2]|0)|0;l=c[e>>2]|0;i=d;return l|0}function Gt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if(!(c[g>>2]|0)){c[e>>2]=Ft(c[f>>2]|0,0)|0;j=c[e>>2]|0;i=d;return j|0}if((c[c[g>>2]>>2]|0)==2){c[e>>2]=c[g>>2];j=c[e>>2]|0;i=d;return j|0}else{b=c[f>>2]|0;c[h>>2]=Ft(b,Vq(c[g>>2]|0)|0)|0;jt(c[f>>2]|0,c[g>>2]|0);c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}return 0}function Ht(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+144|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+32|0;k=e+16|0;l=e+12|0;m=e+8|0;n=e+4|0;o=e;c[g>>2]=b;c[h>>2]=d;c[k>>2]=0;c[m>>2]=bu(c[g>>2]|0,l)|0;a:do if(!((c[m>>2]|0)==32|(c[m>>2]|0)==62|(c[m>>2]|0)==47|(c[m>>2]|0)==91|(c[m>>2]|0)==93|(c[m>>2]|0)==64|(c[m>>2]|0)==42)){d=c[m>>2]|0;if((c[m>>2]|0)<256){if(((!(65<=(d|0)&(c[m>>2]|0)<=90)?!(97<=(c[m>>2]|0)&(c[m>>2]|0)<=122):0)?!(192<=(c[m>>2]|0)&(c[m>>2]|0)<=214):0)?!(216<=(c[m>>2]|0)&(c[m>>2]|0)<=246|248<=(c[m>>2]|0)):0)p=8}else if(!(DQ(d,199744)|0))p=8;do if((p|0)==8){d=c[m>>2]|0;if((c[m>>2]|0)<256)if((d|0)!=95&(c[h>>2]|0)!=0&(c[m>>2]|0)!=58)break a;else break;if(!(19968<=(d|0)&(c[m>>2]|0)<=40869|(c[m>>2]|0)==12295)?(12321<=(c[m>>2]|0)&(c[m>>2]|0)<=12329^1)&(c[m>>2]|0)!=95&(c[h>>2]|0)!=0&(c[m>>2]|0)!=58:0)break a}while(0);b:do{if(!((c[m>>2]|0)!=32&(c[m>>2]|0)!=62&(c[m>>2]|0)!=47)){p=72;break}d=c[m>>2]|0;if((c[m>>2]|0)<256){if(((!(65<=(d|0)&(c[m>>2]|0)<=90)?!(97<=(c[m>>2]|0)&(c[m>>2]|0)<=122):0)?!(192<=(c[m>>2]|0)&(c[m>>2]|0)<=214):0)?!(216<=(c[m>>2]|0)&(c[m>>2]|0)<=246|248<=(c[m>>2]|0)):0)p=20}else if(!(DQ(d,199744)|0))p=20;do if((p|0)==20){p=0;if((c[m>>2]|0)>=256){if(19968<=(c[m>>2]|0)&(c[m>>2]|0)<=40869|(c[m>>2]|0)==12295)break;if(12321<=(c[m>>2]|0)&(c[m>>2]|0)<=12329)break}d=c[m>>2]|0;if((c[m>>2]|0)<256){if(48<=(d|0)&(c[m>>2]|0)<=57|(c[m>>2]|0)==46|(c[m>>2]|0)==45|(c[m>>2]|0)==95)break}else{b=(DQ(d,200216)|0)!=0;if(b|(c[m>>2]|0)==46|(c[m>>2]|0)==45|(c[m>>2]|0)==95)break}if(!((c[h>>2]|0)!=0&(c[m>>2]|0)==58)){if((c[m>>2]|0)>=256?(DQ(c[m>>2]|0,200144)|0)!=0:0)break;b=c[m>>2]|0;if((c[m>>2]|0)<256)q=(b|0)==183&1;else q=DQ(b,200272)|0;if(!q){p=72;break b}}}while(0);if((c[l>>2]|0)==1){b=c[m>>2]&255;d=c[k>>2]|0;c[k>>2]=d+1;a[j+d>>0]=b}else{b=qe(c[l>>2]|0,j+(c[k>>2]|0)|0,c[m>>2]|0)|0;c[k>>2]=(c[k>>2]|0)+b}b=c[g>>2]|0;c[b>>2]=(c[b>>2]|0)+(c[l>>2]|0);c[m>>2]=bu(c[g>>2]|0,l)|0}while((c[k>>2]|0)<100);if((p|0)==72)if(!(c[k>>2]|0)){c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}else{c[f>>2]=ly(j,c[k>>2]|0)|0;r=c[f>>2]|0;i=e;return r|0}c[o>>2]=c[k>>2]<<1;if((c[k>>2]|0)>5e4){Nq(c[g>>2]|0,7);c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}c[n>>2]=Cb[c[135752>>2]&511](c[o>>2]|0)|0;if(!(c[n>>2]|0)){Nq(c[g>>2]|0,15);c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}eU(c[n>>2]|0,j|0,c[k>>2]|0)|0;while(1){b=c[m>>2]|0;if((c[m>>2]|0)<256)if(((!(65<=(b|0)&(c[m>>2]|0)<=90)?!(97<=(c[m>>2]|0)&(c[m>>2]|0)<=122):0)?!(192<=(c[m>>2]|0)&(c[m>>2]|0)<=214):0)?!(216<=(c[m>>2]|0)&(c[m>>2]|0)<=246|248<=(c[m>>2]|0)):0)p=48;else s=1;else if(DQ(b,199744)|0)s=1;else p=48;do if((p|0)==48){p=0;if((c[m>>2]|0)>=256){if(19968<=(c[m>>2]|0)&(c[m>>2]|0)<=40869|(c[m>>2]|0)==12295){s=1;break}if(12321<=(c[m>>2]|0)&(c[m>>2]|0)<=12329){s=1;break}}b=c[m>>2]|0;if((c[m>>2]|0)<256){if(48<=(b|0)&(c[m>>2]|0)<=57|(c[m>>2]|0)==46|(c[m>>2]|0)==45|(c[m>>2]|0)==95){s=1;break}}else{d=(DQ(b,200216)|0)!=0;if(d|(c[m>>2]|0)==46|(c[m>>2]|0)==45|(c[m>>2]|0)==95){s=1;break}}if((c[h>>2]|0)!=0&(c[m>>2]|0)==58)s=1;else{if((c[m>>2]|0)>=256?(DQ(c[m>>2]|0,200144)|0)!=0:0){s=1;break}d=c[m>>2]|0;if((c[m>>2]|0)<256)t=(d|0)==183&1;else t=DQ(d,200272)|0;s=(t|0)!=0}}while(0);u=c[k>>2]|0;if(!s){p=71;break}if((u+10|0)>(c[o>>2]|0)){if((c[o>>2]|0)>5e4){p=64;break}c[o>>2]=c[o>>2]<<1;c[n>>2]=Hb[c[135760>>2]&511](c[n>>2]|0,c[o>>2]|0)|0;if(!(c[n>>2]|0)){p=66;break}}if((c[l>>2]|0)==1){d=c[m>>2]&255;b=c[k>>2]|0;c[k>>2]=b+1;a[(c[n>>2]|0)+b>>0]=d}else{d=qe(c[l>>2]|0,(c[n>>2]|0)+(c[k>>2]|0)|0,c[m>>2]|0)|0;c[k>>2]=(c[k>>2]|0)+d}d=c[g>>2]|0;c[d>>2]=(c[d>>2]|0)+(c[l>>2]|0);c[m>>2]=bu(c[g>>2]|0,l)|0}if((p|0)==64){Nq(c[g>>2]|0,7);c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}else if((p|0)==66){Nq(c[g>>2]|0,15);c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}else if((p|0)==71){a[(c[n>>2]|0)+u>>0]=0;c[f>>2]=c[n>>2];r=c[f>>2]|0;i=e;return r|0}}while(0);c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}function It(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+48|0;f=e+40|0;g=e+36|0;h=e+32|0;j=e+28|0;k=e+24|0;l=e+20|0;m=e+16|0;n=e+12|0;o=e+8|0;p=e+4|0;q=e;c[g>>2]=a;c[h>>2]=b;c[l>>2]=0;c[m>>2]=0;if(((vy(c[h>>2]|0,91)|0)==0?(vy(c[h>>2]|0,40)|0)==0:0)?(vy(c[h>>2]|0,64)|0)==0:0){c[q>>2]=vy(c[h>>2]|0,58)|0;do if(c[q>>2]|0){if(((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+60>>2]|0)!=0:0)?(d[(c[q>>2]|0)+1>>0]|0|0)!=58:0)break;c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}while(0);if((c[g>>2]|0)!=0?(c[l>>2]=c[(c[g>>2]|0)+192>>2],(c[(c[g>>2]|0)+60>>2]|0)>0):0){c[m>>2]=Cb[c[135744>>2]&511]((c[(c[g>>2]|0)+60>>2]|0)+1<<1<<2)|0;if(!(c[m>>2]|0)){it(c[g>>2]|0,130672);c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}c[o>>2]=0;c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[(c[g>>2]|0)+60>>2]|0))break;c[n>>2]=c[(c[(c[g>>2]|0)+56>>2]|0)+(c[p>>2]<<2)>>2];q=c[(c[n>>2]|0)+8>>2]|0;b=c[o>>2]|0;c[o>>2]=b+1;c[(c[m>>2]|0)+(b<<2)>>2]=q;q=c[(c[n>>2]|0)+12>>2]|0;b=c[o>>2]|0;c[o>>2]=b+1;c[(c[m>>2]|0)+(b<<2)>>2]=q;c[p>>2]=(c[p>>2]|0)+1}p=c[o>>2]|0;c[o>>2]=p+1;c[(c[m>>2]|0)+(p<<2)>>2]=0;c[(c[m>>2]|0)+(c[o>>2]<<2)>>2]=0}c[j>>2]=MQ(c[h>>2]|0,c[l>>2]|0,1,c[m>>2]|0)|0;if(c[m>>2]|0)zb[c[135736>>2]&511](c[m>>2]|0);if((c[j>>2]|0)!=0?(PQ(c[j>>2]|0)|0)==1:0){c[k>>2]=pt()|0;if(!(c[k>>2]|0)){it(c[g>>2]|0,130704);c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}c[(c[k>>2]|0)+24>>2]=c[j>>2];c[(c[k>>2]|0)+20>>2]=c[l>>2];if(c[(c[k>>2]|0)+20>>2]|0)yP(c[(c[k>>2]|0)+20>>2]|0)|0;c[f>>2]=c[k>>2];r=c[f>>2]|0;i=e;return r|0}EQ(c[j>>2]|0)}c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}function Jt(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;cu(c[f>>2]|0);if(c[(c[f>>2]|0)+8>>2]|0){i=e;return}a:while(1){do if((d[c[c[f>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[f>>2]>>2]>>0]|0|0)?(d[c[c[f>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[f>>2]>>2]>>0]|0|0)!=13)break a}while(0);b=c[f>>2]|0;if(!(d[c[c[f>>2]>>2]>>0]|0))continue;c[b>>2]=(c[b>>2]|0)+1}b:while(1){if((d[c[c[f>>2]>>2]>>0]|0|0)!=111)break;if((d[(c[c[f>>2]>>2]|0)+1>>0]|0|0)!=114)break;c[h>>2]=c[(c[(c[f>>2]|0)+32>>2]|0)+12>>2];b=c[f>>2]|0;c[b>>2]=(c[b>>2]|0)+2;while(1){do if((d[c[c[f>>2]>>2]>>0]|0|0)==32)j=1;else{if(9<=(d[c[c[f>>2]>>2]>>0]|0|0)?(d[c[c[f>>2]>>2]>>0]|0|0)<=10:0){j=1;break}j=(d[c[c[f>>2]>>2]>>0]|0|0)==13}while(0);k=c[f>>2]|0;if(!j)break;b=c[f>>2]|0;if(!(d[c[k>>2]>>0]|0))continue;c[b>>2]=(c[b>>2]|0)+1}cu(k);if(c[(c[f>>2]|0)+8>>2]|0){l=29;break}du(c[(c[f>>2]|0)+32>>2]|0,c[h>>2]|0,c[(c[(c[f>>2]|0)+32>>2]|0)+12>>2]|0,2,0,0,0,0,0)|0;while(1){do if((d[c[c[f>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[f>>2]>>2]>>0]|0|0)?(d[c[c[f>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[f>>2]>>2]>>0]|0|0)!=13)continue b}while(0);b=c[f>>2]|0;if(!(d[c[c[f>>2]>>2]>>0]|0))continue;c[b>>2]=(c[b>>2]|0)+1}}if((l|0)==29){i=e;return}if(!(c[g>>2]|0)){i=e;return}if((c[(c[(c[(c[f>>2]|0)+32>>2]|0)+8>>2]|0)+((c[(c[(c[f>>2]|0)+32>>2]|0)+12>>2]|0)*40|0)>>2]|0)==12){i=e;return}du(c[(c[f>>2]|0)+32>>2]|0,c[(c[(c[f>>2]|0)+32>>2]|0)+12>>2]|0,-1,18,0,0,0,0,0)|0;i=e;return}function Kt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;do if((((((((c[c[f>>2]>>2]|0)==11?(c[(c[f>>2]|0)+4>>2]|0)!=-1:0)?(c[(c[f>>2]|0)+8>>2]|0)==-1:0)?(c[g>>2]=(c[(c[e>>2]|0)+8>>2]|0)+((c[(c[f>>2]|0)+4>>2]|0)*40|0),(c[c[g>>2]>>2]|0)==11):0)?(c[(c[g>>2]|0)+12>>2]|0)==6:0)?(c[(c[g>>2]|0)+8>>2]|0)==-1:0)?(c[(c[g>>2]|0)+16>>2]|0)==1:0)?(c[(c[g>>2]|0)+20>>2]|0)==0:0){b=c[(c[f>>2]|0)+12>>2]|0;if((b|0)==6|(b|0)==13){c[(c[f>>2]|0)+4>>2]=c[(c[g>>2]|0)+4>>2];c[(c[f>>2]|0)+12>>2]=6;break}else if((b|0)==5|(b|0)==4){c[(c[f>>2]|0)+4>>2]=c[(c[g>>2]|0)+4>>2];c[(c[f>>2]|0)+12>>2]=5;break}else break}while(0);if((c[(c[f>>2]|0)+4>>2]|0)!=-1)Kt(c[e>>2]|0,(c[(c[e>>2]|0)+8>>2]|0)+((c[(c[f>>2]|0)+4>>2]|0)*40|0)|0);if((c[(c[f>>2]|0)+8>>2]|0)==-1){i=d;return}Kt(c[e>>2]|0,(c[(c[e>>2]|0)+8>>2]|0)+((c[(c[f>>2]|0)+8>>2]|0)*40|0)|0);i=d;return}function Lt(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+48|0;g=f;h=f+36|0;j=f+32|0;k=f+28|0;l=f+24|0;m=f+20|0;n=f+16|0;o=f+12|0;p=f+8|0;q=f+4|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;if(!(c[k>>2]|0)){Xd(0,0,0,0,0,12,1,3,128552,14895,0,0,0,0,0,129480,g);c[h>>2]=-1;r=c[h>>2]|0;i=f;return r|0}if(!(c[j>>2]|0)){c[h>>2]=-1;r=c[h>>2]|0;i=f;return r|0}Kq();c[32576]=(c[32576]|0)+1;if((c[32576]|0)>1)c[32574]=1;c[n>>2]=eu(c[j>>2]|0,c[k>>2]|0)|0;c[o>>2]=Mt(c[n>>2]|0,c[m>>2]|0)|0;do if(c[l>>2]|0)if(!(c[(c[n>>2]|0)+16>>2]|0)){Db[c[135904>>2]&511](c[33980]|0,130312,g);c[c[l>>2]>>2]=0;break}else{j=Sq(c[n>>2]|0)|0;c[c[l>>2]>>2]=j;break}while(0);do if((c[(c[n>>2]|0)+20>>2]|0)>0){c[q>>2]=0;do{c[p>>2]=Sq(c[n>>2]|0)|0;if(c[p>>2]|0){c[q>>2]=(c[q>>2]|0)+1;jt(c[k>>2]|0,c[p>>2]|0)}}while((c[p>>2]|0)!=0);if(c[q>>2]|0){if(!(c[m>>2]|0)){if(!(c[l>>2]|0))break;if(!(c[c[l>>2]>>2]|0))break}j=c[33976]|0;e=c[33980]|0;c[g>>2]=c[q>>2];Db[j&511](e,130360,g)}}while(0);if(((c[l>>2]|0)!=0?(c[(c[n>>2]|0)+8>>2]|0)!=0:0)?(c[c[l>>2]>>2]|0)!=0:0){Qq(c[c[l>>2]>>2]|0);c[c[l>>2]>>2]=0}c[(c[n>>2]|0)+32>>2]=0;Pr(c[n>>2]|0);c[32576]=(c[32576]|0)+-1;c[h>>2]=c[o>>2];r=c[h>>2]|0;i=f;return r|0}function Mt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d;f=d+24|0;g=d+20|0;h=d+16|0;j=d+12|0;k=d+8|0;l=d+4|0;c[g>>2]=a;c[h>>2]=b;if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+32>>2]|0)!=0:0){if(!(c[(c[g>>2]|0)+28>>2]|0)){b=Cb[c[135744>>2]&511](40)|0;c[(c[g>>2]|0)+28>>2]=b;if(!(c[(c[g>>2]|0)+28>>2]|0)){fu(c[g>>2]|0,129952);zb[c[135736>>2]&511](c[g>>2]|0)}c[(c[g>>2]|0)+20>>2]=0;c[(c[g>>2]|0)+24>>2]=10;c[(c[g>>2]|0)+16>>2]=0;c[(c[g>>2]|0)+44>>2]=0}do if(c[(c[(c[g>>2]|0)+32>>2]|0)+24>>2]|0){if(c[h>>2]|0){c[k>>2]=gu(c[(c[g>>2]|0)+12>>2]|0,c[(c[(c[g>>2]|0)+32>>2]|0)+24>>2]|0,0,1)|0;if((c[k>>2]|0)==-1)break;c[f>>2]=c[k>>2];m=c[f>>2]|0;i=d;return m|0}c[l>>2]=0;c[k>>2]=gu(c[(c[g>>2]|0)+12>>2]|0,c[(c[(c[g>>2]|0)+32>>2]|0)+24>>2]|0,l,0)|0;if((c[k>>2]|0)!=-1&(c[l>>2]|0)!=0){Tq(c[g>>2]|0,c[l>>2]|0)|0;c[f>>2]=0;m=c[f>>2]|0;i=d;return m|0}else{if(!(c[l>>2]|0))break;jt(c[(c[g>>2]|0)+12>>2]|0,c[l>>2]|0);break}}while(0);c[j>>2]=c[(c[g>>2]|0)+32>>2];if((c[(c[j>>2]|0)+12>>2]|0)<0){Db[c[135904>>2]&511](c[33980]|0,129984,e);c[f>>2]=-1;m=c[f>>2]|0;i=d;return m|0}e=c[g>>2]|0;g=(c[(c[j>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+12>>2]|0)*40|0)|0;if(c[h>>2]|0){c[f>>2]=hu(e,g,0)|0;m=c[f>>2]|0;i=d;return m|0}else{iu(e,g)|0;c[f>>2]=0;m=c[f>>2]|0;i=d;return m|0}}c[f>>2]=-1;m=c[f>>2]|0;i=d;return m|0}function Nt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=ju(c[e>>2]|0,c[f>>2]|0)|0;f=c[g>>2]|0;i=d;return((c[g>>2]|0)==-2?f:0-f|0)|0}function Ot(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+64|0;f=e+32|0;g=e+60|0;h=e+56|0;j=e+52|0;k=e+24|0;l=e+16|0;m=e+8|0;n=e+48|0;o=e+44|0;p=e;q=e+40|0;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;d=k;c[d>>2]=0;c[d+4>>2]=0;d=m;c[d>>2]=(c[j>>2]|0)-1;c[d+4>>2]=0;d=m;j=YT(c[d>>2]|0,c[d+4>>2]|0,1)|0;d=l;c[d>>2]=j;c[d+4>>2]=G;c[n>>2]=c[(c[g>>2]|0)+(c[k>>2]<<2)>>2];if((Nt(c[h>>2]|0,c[n>>2]|0)|0)<0){d=f;c[d>>2]=0;c[d+4>>2]=0;r=f;s=r;t=c[s>>2]|0;u=r+4|0;v=u;w=c[v>>2]|0;G=w;i=e;return t|0}if(!(Nt(c[h>>2]|0,c[n>>2]|0)|0)){d=p;c[d>>2]=1;c[d+4>>2]=0;while(1){d=(Nt(c[h>>2]|0,c[(c[g>>2]|0)+(c[p>>2]<<2)>>2]|0)|0)==0;j=p;x=c[j>>2]|0;y=c[j+4>>2]|0;if(!d)break;d=bU(x|0,y|0,1,0)|0;j=p;c[j>>2]=d;c[j+4>>2]=G}p=f;c[p>>2]=x;c[p+4>>2]=y;r=f;s=r;t=c[s>>2]|0;u=r+4|0;v=u;w=c[v>>2]|0;G=w;i=e;return t|0}c[o>>2]=c[(c[g>>2]|0)+(c[l>>2]<<2)>>2];while(1){c[q>>2]=Nt(c[h>>2]|0,c[o>>2]|0)|0;if((c[q>>2]|0)<0){y=l;p=k;x=XT(c[y>>2]|0,c[y+4>>2]|0,c[p>>2]|0,c[p+4>>2]|0)|0;p=G;y=l;z=c[y>>2]|0;A=c[y+4>>2]|0;if((p|0)<0|(p|0)==0&x>>>0<=1){B=11;break}x=m;c[x>>2]=z;c[x+4>>2]=A}else{if((c[q>>2]|0)<=0){B=17;break}x=m;p=l;y=XT(c[x>>2]|0,c[x+4>>2]|0,c[p>>2]|0,c[p+4>>2]|0)|0;p=G;x=l;C=c[x>>2]|0;D=c[x+4>>2]|0;if((p|0)<0|(p|0)==0&y>>>0<=1){B=15;break}y=k;c[y>>2]=C;c[y+4>>2]=D;c[n>>2]=c[o>>2]}y=k;p=c[y>>2]|0;x=c[y+4>>2]|0;y=m;j=k;d=XT(c[y>>2]|0,c[y+4>>2]|0,c[j>>2]|0,c[j+4>>2]|0)|0;j=YT(d|0,G|0,1)|0;d=bU(p|0,x|0,j|0,G|0)|0;j=l;c[j>>2]=d;c[j+4>>2]=G;c[o>>2]=c[(c[g>>2]|0)+(c[l>>2]<<2)>>2]}if((B|0)==11){k=f;c[k>>2]=z;c[k+4>>2]=A;r=f;s=r;t=c[s>>2]|0;u=r+4|0;v=u;w=c[v>>2]|0;G=w;i=e;return t|0}else if((B|0)==15){A=bU(C|0,D|0,1,0)|0;D=f;c[D>>2]=A;c[D+4>>2]=G;r=f;s=r;t=c[s>>2]|0;u=r+4|0;v=u;w=c[v>>2]|0;G=w;i=e;return t|0}else if((B|0)==17){while(1){B=0;D=l;A=bU(c[D>>2]|0,c[D+4>>2]|0,1,0)|0;D=l;c[D>>2]=A;c[D+4>>2]=G;c[o>>2]=c[(c[g>>2]|0)+(A<<2)>>2];if(!(Nt(c[h>>2]|0,c[o>>2]|0)|0))B=17;else break}B=l;l=c[B+4>>2]|0;o=f;c[o>>2]=c[B>>2];c[o+4>>2]=l;r=f;s=r;t=c[s>>2]|0;u=r+4|0;v=u;w=c[v>>2]|0;G=w;i=e;return t|0}return 0}function Pt(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+32|0;h=g+20|0;j=g+8|0;k=g;l=g+16|0;c[h>>2]=a;a=j;c[a>>2]=b;c[a+4>>2]=d;d=k;c[d>>2]=e;c[d+4>>2]=f;while(1){f=j;d=c[f+4>>2]|0;e=k;a=c[e+4>>2]|0;if((d|0)>(a|0)|((d|0)==(a|0)?(c[f>>2]|0)>>>0>=(c[e>>2]|0)>>>0:0))break;c[l>>2]=c[(c[h>>2]|0)+(c[j>>2]<<2)>>2];c[(c[h>>2]|0)+(c[j>>2]<<2)>>2]=c[(c[h>>2]|0)+(c[k>>2]<<2)>>2];c[(c[h>>2]|0)+(c[k>>2]<<2)>>2]=c[l>>2];e=j;f=bU(c[e>>2]|0,c[e+4>>2]|0,1,0)|0;e=j;c[e>>2]=f;c[e+4>>2]=G;e=k;f=bU(c[e>>2]|0,c[e+4>>2]|0,-1,-1)|0;e=k;c[e>>2]=f;c[e+4>>2]=G}i=g;return}function Qt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;
f=d+12|0;g=d+8|0;h=d+4|0;c[f>>2]=a;c[g>>2]=b;if((c[c[f>>2]>>2]|0)>>>0>=(c[g>>2]|0)>>>0){i=d;return}c[h>>2]=kT(c[(c[f>>2]|0)+4>>2]|0,c[g>>2]<<2)|0;if(!(c[h>>2]|0)){b=c[o>>2]|0;c[e>>2]=c[g>>2]<<2;Ka(b|0,131856,e|0)|0;qb(1)}c[(c[f>>2]|0)+4>>2]=c[h>>2];c[c[f>>2]>>2]=c[g>>2];i=d;return}function Rt(b){b=b|0;var e=0,f=0,g=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e;j=e+8|0;c[f>>2]=b;c[j>>2]=0;while(1){if((c[j>>2]|0)>=8)break;a[g+(d[131816+(7-(c[j>>2]|0))>>0]|0)>>0]=a[(c[f>>2]|0)+(c[j>>2]|0)>>0]|0;c[j>>2]=(c[j>>2]|0)+1}i=e;return+ +h[g>>3]}function St(a){a=+a;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+8|0;e=b;h[d>>3]=a;h[e>>3]=+h[d>>3];d=e;G=c[d+4>>2]|0;i=b;return c[d>>2]|0}function Tt(a){a=+a;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;g[d>>2]=a;g[e>>2]=+g[d>>2];i=b;return c[e>>2]|0}function Ut(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+128|0;g=f;h=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f+24|0;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[m>>2]=0;while(1){o=n+((c[m>>2]<<1)+1)|0;if(!((c[m>>2]|0)<25?(c[m>>2]|0)<(c[k>>2]|0):0))break;a[o>>0]=32;a[n+(c[m>>2]<<1)>>0]=32;c[m>>2]=(c[m>>2]|0)+1}a[o>>0]=0;a[n+(c[m>>2]<<1)>>0]=0;if(!(c[j>>2]|0)){m=c[h>>2]|0;c[g>>2]=n;Ka(m|0,127912,g|0)|0;Ka(c[h>>2]|0,131072,g|0)|0;i=f;return}while(1){if(!(c[j>>2]|0))break;c[l>>2]=c[j>>2];c[j>>2]=c[(c[j>>2]|0)+24>>2];Kp(c[h>>2]|0,c[l>>2]|0,c[k>>2]|0)}i=f;return}function Vt(a){a=+a;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;e=b+8|0;h[d>>3]=a;ku(+h[d>>3],e)|0;i=b;return c[e>>2]|0}function Wt(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[(c[d>>2]|0)+4>>2]|0))break;c[f>>2]=c[(c[c[d>>2]>>2]|0)+(c[e>>2]<<2)>>2];if(c[(c[f>>2]|0)+4>>2]|0){if(c[(c[(c[f>>2]|0)+4>>2]|0)+8>>2]|0)zb[c[135736>>2]&511](c[(c[(c[f>>2]|0)+4>>2]|0)+8>>2]|0);zb[c[135736>>2]&511](c[(c[f>>2]|0)+4>>2]|0)}zb[c[135736>>2]&511](c[f>>2]|0);c[e>>2]=(c[e>>2]|0)+1}lu(c[d>>2]|0);i=b;return}function Xt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](12)|0;if(!(c[f>>2]|0)){it(0,130864);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}a=c[f>>2]|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;if((c[e>>2]|0)>0){Yt(c[f>>2]|0,0,c[e>>2]|0)|0;c[(c[f>>2]|0)+4>>2]=0}c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}function Yt(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;do if(c[c[g>>2]>>2]|0){if((c[(c[g>>2]|0)+8>>2]|0)<=(c[(c[g>>2]|0)+4>>2]|0)){if((c[(c[g>>2]|0)+8>>2]|0)>5e7){it(0,130904);c[f>>2]=-1;k=c[f>>2]|0;i=e;return k|0}d=(c[g>>2]|0)+8|0;c[d>>2]=c[d>>2]<<1;d=Hb[c[135760>>2]&511](c[c[g>>2]>>2]|0,c[(c[g>>2]|0)+8>>2]<<2)|0;c[c[g>>2]>>2]=d;if(!(c[c[g>>2]>>2]|0)){it(0,130904);c[(c[g>>2]|0)+8>>2]=0;c[f>>2]=-1;k=c[f>>2]|0;i=e;return k|0}}}else{if((c[j>>2]|0)<=0)c[j>>2]=1;d=Cb[c[135744>>2]&511](c[j>>2]<<2)|0;c[c[g>>2]>>2]=d;if(c[c[g>>2]>>2]|0){c[(c[g>>2]|0)+4>>2]=0;c[(c[g>>2]|0)+8>>2]=c[j>>2];break}it(0,130864);c[f>>2]=-1;k=c[f>>2]|0;i=e;return k|0}while(0);j=c[h>>2]|0;h=(c[g>>2]|0)+4|0;d=c[h>>2]|0;c[h>>2]=d+1;c[(c[c[g>>2]>>2]|0)+(d<<2)>>2]=j;c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}function Zt(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+32|0;e=b+20|0;f=b+16|0;g=b+12|0;h=b+8|0;j=b+4|0;k=b;c[f>>2]=a;c[g>>2]=2;c[h>>2]=0;c[j>>2]=0;c[k>>2]=0;if(!(c[f>>2]|0)){c[e>>2]=0;l=c[e>>2]|0;i=b;return l|0}if((c[(c[f>>2]|0)+4>>2]|0)==9){c[j>>2]=Pi(c[f>>2]|0)|0;if(!(c[j>>2]|0))c[f>>2]=c[(c[f>>2]|0)+12>>2];else c[f>>2]=c[j>>2];if(!(c[f>>2]|0)){c[e>>2]=0;l=c[e>>2]|0;i=b;return l|0}}switch(c[(c[f>>2]|0)+4>>2]|0){case 2:{c[j>>2]=c[(c[f>>2]|0)+12>>2];break}case 1:{c[j>>2]=c[(c[f>>2]|0)+12>>2];break}case 3:case 4:case 7:case 8:{c[h>>2]=c[(c[f>>2]|0)+40>>2];if(!(c[h>>2]|0)){c[e>>2]=0;l=c[e>>2]|0;i=b;return l|0}if(!(d[c[h>>2]>>0]|0)){c[e>>2]=0;l=c[e>>2]|0;i=b;return l|0}else{c[e>>2]=(d[c[h>>2]>>0]|0)+((d[(c[h>>2]|0)+1>>0]|0)<<8);l=c[e>>2]|0;i=b;return l|0}break}case 18:{c[h>>2]=c[(c[f>>2]|0)+8>>2];if(!(c[h>>2]|0)){c[e>>2]=0;l=c[e>>2]|0;i=b;return l|0}if(!(d[c[h>>2]>>0]|0)){c[e>>2]=0;l=c[e>>2]|0;i=b;return l|0}else{c[e>>2]=(d[c[h>>2]>>0]|0)+((d[(c[h>>2]|0)+1>>0]|0)<<8);l=c[e>>2]|0;i=b;return l|0}break}default:{c[e>>2]=0;l=c[e>>2]|0;i=b;return l|0}}a:while(1){if(!(c[j>>2]|0)){m=47;break}switch(c[(c[j>>2]|0)+4>>2]|0){case 18:{c[h>>2]=c[(c[j>>2]|0)+8>>2];break}case 3:case 4:case 7:case 8:{c[h>>2]=c[(c[j>>2]|0)+40>>2];break}default:{}}if((c[h>>2]|0)!=0?(d[c[h>>2]>>0]|0|0)!=0:0){if((c[g>>2]|0)==1){m=30;break}if(d[(c[h>>2]|0)+1>>0]|0){m=33;break}c[g>>2]=1;c[k>>2]=d[c[h>>2]>>0]}if(((c[(c[j>>2]|0)+12>>2]|0)!=0?(c[(c[j>>2]|0)+4>>2]|0)!=14:0)?(c[(c[(c[j>>2]|0)+12>>2]|0)+4>>2]|0)!=17:0){c[j>>2]=c[(c[j>>2]|0)+12>>2];continue}if((c[j>>2]|0)==(c[f>>2]|0)){m=47;break}if(c[(c[j>>2]|0)+24>>2]|0){c[j>>2]=c[(c[j>>2]|0)+24>>2];continue}while(1){c[j>>2]=c[(c[j>>2]|0)+20>>2];if(!(c[j>>2]|0))continue a;if((c[j>>2]|0)==(c[f>>2]|0)){m=43;break}n=c[j>>2]|0;if(c[(c[j>>2]|0)+24>>2]|0){m=45;break}if(!n)continue a}if((m|0)==43){m=0;c[j>>2]=0;continue}else if((m|0)==45){m=0;c[j>>2]=c[n+24>>2];continue}}if((m|0)==30){c[e>>2]=(c[k>>2]|0)+((d[c[h>>2]>>0]|0)<<8);l=c[e>>2]|0;i=b;return l|0}else if((m|0)==33){c[e>>2]=(d[c[h>>2]>>0]|0)+((d[(c[h>>2]|0)+1>>0]|0)<<8);l=c[e>>2]|0;i=b;return l|0}else if((m|0)==47){c[e>>2]=c[k>>2];l=c[e>>2]|0;i=b;return l|0}return 0}function _t(a){a=a|0;var b=0,e=0,f=0;b=i;i=i+16|0;e=b+4|0;f=b;c[f>>2]=a;do if(c[f>>2]|0)if(!(d[c[f>>2]>>0]|0)){c[e>>2]=0;break}else{c[e>>2]=(d[c[f>>2]>>0]|0)+((d[(c[f>>2]|0)+1>>0]|0)<<8);break}else c[e>>2]=0;while(0);i=b;return c[e>>2]|0}function $t(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+48|0;h=g+36|0;j=g+32|0;k=g+28|0;l=g+24|0;m=g+20|0;n=g+16|0;o=g+12|0;p=g+8|0;q=g+4|0;r=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[p>>2]=0;do if(!((c[n>>2]|0)==0|(c[m>>2]|0)==0)){if((c[c[m>>2]>>2]|0)!=1?(c[c[m>>2]>>2]|0)!=9:0)break;c[q>>2]=c[(c[m>>2]|0)+4>>2];a:do if(c[q>>2]|0){c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[c[q>>2]>>2]|0))break a;c[r>>2]=ir(c[(c[(c[q>>2]|0)+8>>2]|0)+(c[o>>2]<<2)>>2]|0)|0;if((c[r>>2]|0)!=0?(f=c[j>>2]|0,Tq(f,Dt(c[(c[j>>2]|0)+12>>2]|0,c[r>>2]|0)|0)|0,zb[c[135736>>2]&511](c[r>>2]|0),Tr(c[j>>2]|0,1),f=c[j>>2]|0,Tq(f,lt(c[(c[j>>2]|0)+12>>2]|0,c[n>>2]|0)|0)|0,c[p>>2]=Sr(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0)|0,(c[p>>2]|0)!=0):0)break a;c[o>>2]=(c[o>>2]|0)+1}}while(0);jt(c[(c[j>>2]|0)+12>>2]|0,c[m>>2]|0);jt(c[(c[j>>2]|0)+12>>2]|0,c[n>>2]|0);c[h>>2]=c[p>>2];s=c[h>>2]|0;i=g;return s|0}while(0);jt(c[(c[j>>2]|0)+12>>2]|0,c[m>>2]|0);jt(c[(c[j>>2]|0)+12>>2]|0,c[n>>2]|0);c[h>>2]=0;s=c[h>>2]|0;i=g;return s|0}function au(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+48|0;h=g+36|0;j=g+32|0;k=g+28|0;l=g+24|0;m=g+20|0;n=g+16|0;o=g+12|0;p=g+8|0;q=g+4|0;r=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[p>>2]=0;do if(!((c[n>>2]|0)==0|(c[m>>2]|0)==0)){if((c[c[m>>2]>>2]|0)!=1?(c[c[m>>2]>>2]|0)!=9:0)break;c[q>>2]=c[(c[m>>2]|0)+4>>2];a:do if(c[q>>2]|0){c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[c[q>>2]>>2]|0))break a;c[r>>2]=ir(c[(c[(c[q>>2]|0)+8>>2]|0)+(c[o>>2]<<2)>>2]|0)|0;if((c[r>>2]|0)!=0?(f=c[j>>2]|0,Tq(f,Dt(c[(c[j>>2]|0)+12>>2]|0,c[r>>2]|0)|0)|0,zb[c[135736>>2]&511](c[r>>2]|0),f=c[j>>2]|0,Tq(f,lt(c[(c[j>>2]|0)+12>>2]|0,c[n>>2]|0)|0)|0,c[p>>2]=Sr(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0)|0,(c[p>>2]|0)!=0):0)break a;c[o>>2]=(c[o>>2]|0)+1}}while(0);jt(c[(c[j>>2]|0)+12>>2]|0,c[m>>2]|0);jt(c[(c[j>>2]|0)+12>>2]|0,c[n>>2]|0);c[h>>2]=c[p>>2];s=c[h>>2]|0;i=g;return s|0}while(0);jt(c[(c[j>>2]|0)+12>>2]|0,c[m>>2]|0);jt(c[(c[j>>2]|0)+12>>2]|0,c[n>>2]|0);c[h>>2]=0;s=c[h>>2]|0;i=g;return s|0}function bu(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+20|0;l=f+4|0;m=f;c[h>>2]=b;c[j>>2]=e;if(!(c[h>>2]|0)){c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}c[m>>2]=c[c[h>>2]>>2];a[k>>0]=a[c[m>>2]>>0]|0;if(!((d[k>>0]|0)&128)){c[c[j>>2]>>2]=1;c[g>>2]=d[c[m>>2]>>0];n=c[g>>2]|0;i=f;return n|0}a:do if(((d[(c[m>>2]|0)+1>>0]|0)&192|0)==128){do if(((d[k>>0]|0)&224|0)==224){if(((d[(c[m>>2]|0)+2>>0]|0)&192|0)!=128)break a;if(((d[k>>0]|0)&240|0)!=240){c[c[j>>2]>>2]=3;c[l>>2]=((d[c[m>>2]>>0]|0)&15)<<12;c[l>>2]=c[l>>2]|((d[(c[m>>2]|0)+1>>0]|0)&63)<<6;c[l>>2]=c[l>>2]|(d[(c[m>>2]|0)+2>>0]|0)&63;break}if(((d[k>>0]|0)&248|0)!=240)break a;if(((d[(c[m>>2]|0)+3>>0]|0)&192|0)!=128)break a;c[c[j>>2]>>2]=4;c[l>>2]=((d[c[m>>2]>>0]|0)&7)<<18;c[l>>2]=c[l>>2]|((d[(c[m>>2]|0)+1>>0]|0)&63)<<12;c[l>>2]=c[l>>2]|((d[(c[m>>2]|0)+2>>0]|0)&63)<<6;c[l>>2]=c[l>>2]|(d[(c[m>>2]|0)+3>>0]|0)&63}else{c[c[j>>2]>>2]=2;c[l>>2]=((d[c[m>>2]>>0]|0)&31)<<6;c[l>>2]=c[l>>2]|(d[(c[m>>2]|0)+1>>0]|0)&63}while(0);e=c[l>>2]|0;if((c[l>>2]|0)>>>0<256)if(9<=e>>>0&(c[l>>2]|0)>>>0<=10|(c[l>>2]|0)==13|32<=(c[l>>2]|0)>>>0)o=19;else o=18;else if((!(256<=e>>>0&(c[l>>2]|0)>>>0<=55295)?!(57344<=(c[l>>2]|0)>>>0&(c[l>>2]|0)>>>0<=65533):0)?!(65536<=(c[l>>2]|0)>>>0&(c[l>>2]|0)>>>0<=1114111):0)o=18;else o=19;if((o|0)==18){Nq(c[h>>2]|0,21);c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}else if((o|0)==19){c[g>>2]=c[l>>2];n=c[g>>2]|0;i=f;return n|0}}while(0);c[c[j>>2]>>2]=0;Nq(c[h>>2]|0,20);c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}function cu(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;e=b+4|0;f=b;c[e>>2]=a;mu(c[e>>2]|0);if(c[(c[e>>2]|0)+8>>2]|0){i=b;return}a:while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[e>>2]>>2]>>0]|0|0)!=13)break a}while(0);a=c[e>>2]|0;if(!(d[c[c[e>>2]>>2]>>0]|0))continue;c[a>>2]=(c[a>>2]|0)+1}b:while(1){if((d[c[c[e>>2]>>2]>>0]|0|0)!=97){g=27;break}if((d[(c[c[e>>2]>>2]|0)+1>>0]|0|0)!=110){g=27;break}if((d[(c[c[e>>2]>>2]|0)+2>>0]|0|0)!=100){g=27;break}c[f>>2]=c[(c[(c[e>>2]|0)+32>>2]|0)+12>>2];a=c[e>>2]|0;c[a>>2]=(c[a>>2]|0)+3;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)h=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){h=1;break}h=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);j=c[e>>2]|0;if(!h)break;a=c[e>>2]|0;if(!(d[c[j>>2]>>0]|0))continue;c[a>>2]=(c[a>>2]|0)+1}mu(j);if(c[(c[e>>2]|0)+8>>2]|0){g=27;break}du(c[(c[e>>2]|0)+32>>2]|0,c[f>>2]|0,c[(c[(c[e>>2]|0)+32>>2]|0)+12>>2]|0,1,0,0,0,0,0)|0;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[e>>2]>>2]>>0]|0|0)!=13)continue b}while(0);a=c[e>>2]|0;if(!(d[c[c[e>>2]>>2]>>0]|0))continue;c[a>>2]=(c[a>>2]|0)+1}}if((g|0)==27){i=b;return}}function du(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;l=i;i=i+48|0;m=l+40|0;n=l+36|0;o=l+32|0;p=l+28|0;q=l+24|0;r=l+20|0;s=l+16|0;t=l+12|0;u=l+8|0;v=l+4|0;w=l;c[n>>2]=a;c[o>>2]=b;c[p>>2]=d;c[q>>2]=e;c[r>>2]=f;c[s>>2]=g;c[t>>2]=h;c[u>>2]=j;c[v>>2]=k;do if((c[c[n>>2]>>2]|0)>=(c[(c[n>>2]|0)+4>>2]|0)){if((c[(c[n>>2]|0)+4>>2]|0)>=1e6){it(0,130416);c[m>>2]=-1;x=c[m>>2]|0;i=l;return x|0}k=(c[n>>2]|0)+4|0;c[k>>2]=c[k>>2]<<1;c[w>>2]=Hb[c[135760>>2]&511](c[(c[n>>2]|0)+8>>2]|0,(c[(c[n>>2]|0)+4>>2]|0)*40|0)|0;if(c[w>>2]|0){c[(c[n>>2]|0)+8>>2]=c[w>>2];break}k=(c[n>>2]|0)+4|0;c[k>>2]=(c[k>>2]|0)/2|0;it(0,130416);c[m>>2]=-1;x=c[m>>2]|0;i=l;return x|0}while(0);c[(c[n>>2]|0)+12>>2]=c[c[n>>2]>>2];c[(c[(c[n>>2]|0)+8>>2]|0)+((c[c[n>>2]>>2]|0)*40|0)+4>>2]=c[o>>2];c[(c[(c[n>>2]|0)+8>>2]|0)+((c[c[n>>2]>>2]|0)*40|0)+8>>2]=c[p>>2];c[(c[(c[n>>2]|0)+8>>2]|0)+((c[c[n>>2]>>2]|0)*40|0)>>2]=c[q>>2];c[(c[(c[n>>2]|0)+8>>2]|0)+((c[c[n>>2]>>2]|0)*40|0)+12>>2]=c[r>>2];c[(c[(c[n>>2]|0)+8>>2]|0)+((c[c[n>>2]>>2]|0)*40|0)+16>>2]=c[s>>2];c[(c[(c[n>>2]|0)+8>>2]|0)+((c[c[n>>2]>>2]|0)*40|0)+20>>2]=c[t>>2];do if((c[(c[n>>2]|0)+20>>2]|0)!=0?(c[q>>2]|0)==14|(c[q>>2]|0)==13|(c[q>>2]|0)==11:0){t=c[n>>2]|0;if(c[u>>2]|0){s=AP(c[t+20>>2]|0,c[u>>2]|0,-1)|0;c[(c[(c[n>>2]|0)+8>>2]|0)+((c[c[n>>2]>>2]|0)*40|0)+24>>2]=s;zb[c[135736>>2]&511](c[u>>2]|0)}else c[(c[(c[n>>2]|0)+8>>2]|0)+((c[t>>2]|0)*40|0)+24>>2]=0;t=c[n>>2]|0;if(c[v>>2]|0){s=AP(c[t+20>>2]|0,c[v>>2]|0,-1)|0;c[(c[(c[n>>2]|0)+8>>2]|0)+((c[c[n>>2]>>2]|0)*40|0)+28>>2]=s;zb[c[135736>>2]&511](c[v>>2]|0);break}else{c[(c[(c[n>>2]|0)+8>>2]|0)+((c[t>>2]|0)*40|0)+28>>2]=0;break}}else y=15;while(0);if((y|0)==15){c[(c[(c[n>>2]|0)+8>>2]|0)+((c[c[n>>2]>>2]|0)*40|0)+24>>2]=c[u>>2];c[(c[(c[n>>2]|0)+8>>2]|0)+((c[c[n>>2]>>2]|0)*40|0)+28>>2]=c[v>>2]}c[(c[(c[n>>2]|0)+8>>2]|0)+((c[c[n>>2]>>2]|0)*40|0)+32>>2]=0;v=c[n>>2]|0;n=c[v>>2]|0;c[v>>2]=n+1;c[m>>2]=n;x=c[m>>2]|0;i=l;return x|0}function eu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=Cb[c[135744>>2]&511](48)|0;if(!(c[h>>2]|0)){it(c[g>>2]|0,129952);c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}b=(c[h>>2]|0)+0|0;a=b+48|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(a|0));b=Cb[c[135744>>2]&511](40)|0;c[(c[h>>2]|0)+28>>2]=b;if(!(c[(c[h>>2]|0)+28>>2]|0)){zb[c[135736>>2]&511](c[h>>2]|0);it(c[g>>2]|0,129952);c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}else{c[(c[h>>2]|0)+20>>2]=0;c[(c[h>>2]|0)+24>>2]=10;c[(c[h>>2]|0)+16>>2]=0;c[(c[h>>2]|0)+44>>2]=0;c[(c[h>>2]|0)+12>>2]=c[g>>2];c[(c[h>>2]|0)+32>>2]=c[f>>2];c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}return 0}function fu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){it(0,c[f>>2]|0);i=d;return}else{c[(c[e>>2]|0)+8>>2]=15;it(c[(c[e>>2]|0)+12>>2]|0,c[f>>2]|0);i=d;return}}function gu(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;f=i;i=i+64|0;g=f+56|0;h=f+52|0;j=f+48|0;k=f+44|0;l=f+40|0;m=f+36|0;n=f+32|0;o=f+28|0;p=f+24|0;q=f+20|0;r=f+16|0;s=f+12|0;t=f+8|0;u=f+4|0;v=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[s>>2]=0;c[t>>2]=0;c[u>>2]=0;c[v>>2]=0;if((c[h>>2]|0)==0|(c[j>>2]|0)==0){c[g>>2]=-1;w=c[g>>2]|0;i=f;return w|0}c[m>>2]=QQ(c[j>>2]|0)|0;if((c[m>>2]|0)==-1){c[g>>2]=-1;w=c[g>>2]|0;i=f;return w|0}if((c[m>>2]|0)==-2)c[m>>2]=1e4;c[n>>2]=RQ(c[j>>2]|0)|0;if((c[n>>2]|0)==-1){c[g>>2]=-1;w=c[g>>2]|0;i=f;return w|0}c[o>>2]=SQ(c[j>>2]|0)|0;if((c[o>>2]|0)<0){c[g>>2]=-1;w=c[g>>2]|0;i=f;return w|0}if(!(c[l>>2]|0)){if(!(c[k>>2]|0)){c[g>>2]=-1;w=c[g>>2]|0;i=f;return w|0}e=yt(c[h>>2]|0,0)|0;c[c[k>>2]>>2]=e;if(!(c[c[k>>2]>>2]|0)){c[g>>2]=-1;w=c[g>>2]|0;i=f;return w|0}}do if(!(c[n>>2]|0)){e=(c[l>>2]|0)!=0;if(c[o>>2]|0){if(!e){dr(c[(c[c[k>>2]>>2]|0)+4>>2]|0,c[c[h>>2]>>2]|0)|0;break}c[g>>2]=1;w=c[g>>2]|0;i=f;return w|0}else{if(!e){dr(c[(c[c[k>>2]>>2]|0)+4>>2]|0,c[(c[h>>2]|0)+4>>2]|0)|0;break}c[g>>2]=1;w=c[g>>2]|0;i=f;return w|0}}while(0);if(!(c[m>>2]|0)){c[g>>2]=0;w=c[g>>2]|0;i=f;return w|0}n=c[h>>2]|0;if(!(c[o>>2]|0)){if(c[n+4>>2]|0){switch(c[(c[(c[h>>2]|0)+4>>2]|0)+4>>2]|0){case 21:case 13:case 11:case 9:case 1:{c[s>>2]=c[(c[h>>2]|0)+4>>2];break}default:{}}c[t>>2]=c[s>>2]}}else c[s>>2]=c[n>>2];if(!(c[s>>2]|0)){c[g>>2]=0;w=c[g>>2]|0;i=f;return w|0}c[u>>2]=OQ(c[j>>2]|0)|0;if(!(c[u>>2]|0)){c[g>>2]=0;w=c[g>>2]|0;i=f;return w|0}c[r>>2]=LQ(c[u>>2]|0)|0;if((c[o>>2]|0)!=0?(c[p>>2]=HQ(c[u>>2]|0,0,0)|0,(c[p>>2]|0)>=0&(c[p>>2]|0)==1):0){if(!(c[l>>2]|0)){dr(c[(c[c[k>>2]>>2]|0)+4>>2]|0,c[s>>2]|0)|0;x=40}}else x=40;a:do if((x|0)==40){c[q>>2]=0;b:while(1){if((c[(c[s>>2]|0)+4>>2]|0)==18)break;if((((c[(c[s>>2]|0)+12>>2]|0)!=0?(c[q>>2]|0)<(c[m>>2]|0):0)?(c[(c[(c[s>>2]|0)+12>>2]|0)+4>>2]|0)!=17:0)?(c[s>>2]=c[(c[s>>2]|0)+12>>2],c[q>>2]=(c[q>>2]|0)+1,(c[(c[s>>2]|0)+4>>2]|0)!=14):0)x=80;else x=63;c:do if((x|0)==63){x=0;if((c[s>>2]|0)==(c[t>>2]|0))break b;while(1){if(!(c[(c[s>>2]|0)+24>>2]|0))break;c[s>>2]=c[(c[s>>2]|0)+24>>2];if((c[(c[s>>2]|0)+4>>2]|0)==17)continue;if((c[(c[s>>2]|0)+4>>2]|0)!=14)break c}while(1){c[s>>2]=c[(c[s>>2]|0)+20>>2];c[q>>2]=(c[q>>2]|0)+-1;if(!(c[s>>2]|0))break b;if((c[s>>2]|0)==(c[t>>2]|0))break b;d:do if((c[(c[s>>2]|0)+4>>2]|0)==1)c[p>>2]=KQ(c[u>>2]|0)|0;else{if(!(c[r>>2]|0))break;do if((c[(c[s>>2]|0)+4>>2]|0)!=3){if((c[(c[s>>2]|0)+4>>2]|0)==4)break;if((c[(c[s>>2]|0)+4>>2]|0)==8)break;if((c[(c[s>>2]|0)+4>>2]|0)!=7)break d}while(0);c[p>>2]=KQ(c[u>>2]|0)|0}while(0);y=c[s>>2]|0;if(c[(c[s>>2]|0)+24>>2]|0)break;if(!y){x=80;break c}}c[s>>2]=c[y+24>>2];x=80}while(0);if((x|0)==80?(x=0,!((c[s>>2]|0)!=0&(c[q>>2]|0)>=0)):0)break;e:while(1){c[v>>2]=(c[v>>2]|0)+1;switch(c[(c[s>>2]|0)+4>>2]|0){case 7:case 8:case 4:case 3:case 1:break;default:continue b}if((c[(c[s>>2]|0)+4>>2]|0)==1){if(c[(c[s>>2]|0)+36>>2]|0)z=c[(c[(c[s>>2]|0)+36>>2]|0)+8>>2]|0;else z=0;c[p>>2]=HQ(c[u>>2]|0,c[(c[s>>2]|0)+8>>2]|0,z)|0}else{if(!(c[r>>2]|0))continue b;c[p>>2]=IQ(c[u>>2]|0,0,0,c[(c[s>>2]|0)+4>>2]|0)|0}do if((c[p>>2]|0)>=0&(c[p>>2]|0)==1){if(c[l>>2]|0)break a;if((dr(c[(c[c[k>>2]>>2]|0)+4>>2]|0,c[s>>2]|0)|0)>=0)break;c[(c[h>>2]|0)+136>>2]=12;c[(c[h>>2]|0)+140>>2]=2}while(0);if((c[(c[s>>2]|0)+12>>2]|0)!=0?(c[q>>2]|0)<(c[m>>2]|0):0)continue b;c[p>>2]=KQ(c[u>>2]|0)|0;while(1){if(!(c[(c[s>>2]|0)+24>>2]|0))continue b;c[s>>2]=c[(c[s>>2]|0)+24>>2];if((c[(c[s>>2]|0)+4>>2]|0)==17)continue;if((c[(c[s>>2]|0)+4>>2]|0)!=14)continue e}}}if(c[u>>2]|0)GQ(c[u>>2]|0);c[g>>2]=0;w=c[g>>2]|0;i=f;return w|0}while(0);if(c[u>>2]|0)GQ(c[u>>2]|0);c[g>>2]=1;w=c[g>>2]|0;i=f;return w|0}function hu(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=0;while(1){d=c[c[h>>2]>>2]|0;if(!d){m=3;break}else if((d|0)==11){m=10;break}else if((d|0)==12){m=4;break}else if((d|0)!=18){m=18;break}if((c[(c[h>>2]|0)+4>>2]|0)==-1){m=9;break}c[h>>2]=(c[(c[(c[g>>2]|0)+32>>2]|0)+8>>2]|0)+((c[(c[h>>2]|0)+4>>2]|0)*40|0)}do if((m|0)==3)c[f>>2]=0;else if((m|0)==4){c[k>>2]=c[(c[h>>2]|0)+24>>2];if(c[j>>2]|0){c[f>>2]=Ns(c[g>>2]|0,c[k>>2]|0)|0;break}else{c[f>>2]=Vq(c[k>>2]|0)|0;break}}else if((m|0)==9)c[f>>2]=0;else if((m|0)==10){if((c[(c[h>>2]|0)+4>>2]|0)==-1){c[f>>2]=0;break}iu(c[g>>2]|0,(c[(c[(c[g>>2]|0)+32>>2]|0)+8>>2]|0)+((c[(c[h>>2]|0)+4>>2]|0)*40|0)|0)|0;if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=-1;break}nu(c[g>>2]|0,c[h>>2]|0,0,0,1)|0;if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=-1;break}c[k>>2]=Sq(c[g>>2]|0)|0;if(!(c[k>>2]|0))c[f>>2]=-1;else m=22}else if((m|0)==18){iu(c[g>>2]|0,c[h>>2]|0)|0;if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=-1;break}c[k>>2]=Sq(c[g>>2]|0)|0;if(!(c[k>>2]|0))c[f>>2]=-1;else m=22}while(0);do if((m|0)==22){if(!(c[k>>2]|0)){c[f>>2]=0;break}do if((c[c[k>>2]>>2]|0)!=2)if(c[j>>2]|0){c[l>>2]=Ns(c[g>>2]|0,c[k>>2]|0)|0;break}else{c[l>>2]=Vq(c[k>>2]|0)|0;break}else c[l>>2]=c[(c[k>>2]|0)+8>>2];while(0);jt(c[(c[g>>2]|0)+12>>2]|0,c[k>>2]|0);c[f>>2]=c[l>>2]}while(0);i=e;return c[f>>2]|0}function iu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;d=i;i=i+192|0;e=d;f=d+184|0;g=d+180|0;j=d+176|0;k=d+172|0;l=d+168|0;m=d+164|0;n=d+160|0;o=d+156|0;p=d+152|0;q=d+148|0;r=d+144|0;s=d+140|0;t=d+136|0;u=d+132|0;v=d+128|0;w=d+124|0;x=d+120|0;y=d+116|0;z=d+112|0;A=d+108|0;B=d+104|0;C=d+100|0;D=d+96|0;E=d+92|0;F=d+88|0;G=d+84|0;H=d+80|0;I=d+76|0;J=d+72|0;K=d+68|0;L=d+64|0;M=d+60|0;N=d+56|0;O=d+52|0;P=d+48|0;Q=d+44|0;R=d+40|0;S=d+36|0;T=d+32|0;U=d+28|0;V=d+24|0;W=d+20|0;X=d+16|0;Y=d+12|0;Z=d+8|0;c[g>>2]=a;c[j>>2]=b;c[k>>2]=0;if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}c[n>>2]=c[(c[g>>2]|0)+32>>2];do switch(c[c[j>>2]>>2]|0){case 0:{c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}case 8:{ks(c[g>>2]|0);c[f>>2]=c[k>>2];_=c[f>>2]|0;i=d;return _|0}case 10:{if((c[(c[j>>2]|0)+4>>2]|0)!=-1){b=iu(c[g>>2]|0,(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+4>>2]|0)*40|0)|0)|0;c[k>>2]=(c[k>>2]|0)+b}if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}if((c[(c[j>>2]|0)+8>>2]|0)!=-1){b=iu(c[g>>2]|0,(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+8>>2]|0)*40|0)|0)|0;c[k>>2]=(c[k>>2]|0)+b}if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}else{c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=0;c[f>>2]=c[k>>2];_=c[f>>2]|0;i=d;return _|0}break}case 9:{if((c[(c[j>>2]|0)+4>>2]|0)!=-1){b=iu(c[g>>2]|0,(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+4>>2]|0)*40|0)|0)|0;c[k>>2]=(c[k>>2]|0)+b}if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}if((c[(c[j>>2]|0)+8>>2]|0)!=-1){b=iu(c[g>>2]|0,(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+8>>2]|0)*40|0)|0)|0;c[k>>2]=(c[k>>2]|0)+b}if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}else{b=c[g>>2]|0;Tq(b,yt(c[(c[g>>2]|0)+12>>2]|0,c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]|0)|0)|0;c[f>>2]=c[k>>2];_=c[f>>2]|0;i=d;return _|0}break}case 11:{if((c[(c[j>>2]|0)+4>>2]|0)==-1){c[f>>2]=c[k>>2];_=c[f>>2]|0;i=d;return _|0}c[k>>2]=(iu(c[g>>2]|0,(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+4>>2]|0)*40|0)|0)|0)+(c[k>>2]|0);if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}else{b=nu(c[g>>2]|0,c[j>>2]|0,0,0,0)|0;c[k>>2]=(c[k>>2]|0)+b;c[f>>2]=c[k>>2];_=c[f>>2]|0;i=d;return _|0}break}case 7:{c[r>>2]=c[c[(c[g>>2]|0)+12>>2]>>2];c[q>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2];c[s>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+72>>2];c[t>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2];c[k>>2]=(iu(c[g>>2]|0,(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+4>>2]|0)*40|0)|0)|0)+(c[k>>2]|0);if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}c[c[(c[g>>2]|0)+12>>2]>>2]=c[r>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=c[q>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+72>>2]=c[s>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2]=c[t>>2];c[k>>2]=(iu(c[g>>2]|0,(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+8>>2]|0)*40|0)|0)|0)+(c[k>>2]|0);if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}if((c[(c[g>>2]|0)+16>>2]|0)!=0?(c[c[(c[g>>2]|0)+16>>2]>>2]|0)==1:0){c[p>>2]=Sq(c[g>>2]|0)|0;if((c[(c[g>>2]|0)+16>>2]|0)!=0?(c[c[(c[g>>2]|0)+16>>2]>>2]|0)==1:0){c[o>>2]=Sq(c[g>>2]|0)|0;if(c[(c[o>>2]|0)+4>>2]|0){if((c[(c[p>>2]|0)+4>>2]|0)!=0?(c[c[(c[p>>2]|0)+4>>2]>>2]|0)!=0:0)$=78}else $=78;if(($|0)==78){b=er(c[(c[o>>2]|0)+4>>2]|0,c[(c[p>>2]|0)+4>>2]|0)|0;c[(c[o>>2]|0)+4>>2]=b}Tq(c[g>>2]|0,c[o>>2]|0)|0;jt(c[(c[g>>2]|0)+12>>2]|0,c[p>>2]|0);c[f>>2]=c[k>>2];_=c[f>>2]|0;i=d;return _|0}Nq(c[g>>2]|0,11);c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}Nq(c[g>>2]|0,11);c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}case 5:{c[r>>2]=c[c[(c[g>>2]|0)+12>>2]>>2];c[q>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2];c[s>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+72>>2];c[t>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2];c[k>>2]=(iu(c[g>>2]|0,(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+4>>2]|0)*40|0)|0)|0)+(c[k>>2]|0);if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}if((c[(c[j>>2]|0)+8>>2]|0)!=-1){c[c[(c[g>>2]|0)+12>>2]>>2]=c[r>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=c[q>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+72>>2]=c[s>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2]=c[t>>2];b=iu(c[g>>2]|0,(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+8>>2]|0)*40|0)|0)|0;c[k>>2]=(c[k>>2]|0)+b}if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}do if(c[(c[j>>2]|0)+12>>2]|0){if((c[(c[j>>2]|0)+12>>2]|0)==1){Vr(c[g>>2]|0);break}if((c[(c[j>>2]|0)+12>>2]|0)==2){Ur(c[g>>2]|0);break}if((c[(c[j>>2]|0)+12>>2]|0)==3){if((c[(c[g>>2]|0)+16>>2]|0)!=0?(c[c[(c[g>>2]|0)+16>>2]>>2]|0)!=3:0)Tr(c[g>>2]|0,1);if((c[(c[g>>2]|0)+16>>2]|0)!=0?(c[c[(c[g>>2]|0)+16>>2]>>2]|0)==3:0)break;Nq(c[g>>2]|0,11);c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}}else Wr(c[g>>2]|0);while(0);c[f>>2]=c[k>>2];_=c[f>>2]|0;i=d;return _|0}case 1:{c[r>>2]=c[c[(c[g>>2]|0)+12>>2]>>2];c[q>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2];c[s>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+72>>2];c[t>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2];c[k>>2]=(iu(c[g>>2]|0,(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+4>>2]|0)*40|0)|0)|0)+(c[k>>2]|0);if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}Bs(c[g>>2]|0,1);if((c[(c[g>>2]|0)+16>>2]|0)!=0?(c[(c[(c[g>>2]|0)+16>>2]|0)+8>>2]|0)!=0:0){c[p>>2]=Sq(c[g>>2]|0)|0;c[c[(c[g>>2]|0)+12>>2]>>2]=c[r>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=c[q>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+72>>2]=c[s>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2]=c[t>>2];b=iu(c[g>>2]|0,(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+8>>2]|0)*40|0)|0)|0;c[k>>2]=(c[k>>2]|0)+b;if(c[(c[g>>2]|0)+8>>2]|0){Qq(c[p>>2]|0);c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}else{Bs(c[g>>2]|0,1);c[o>>2]=Sq(c[g>>2]|0)|0;b=(c[o>>2]|0)+8|0;c[b>>2]=c[b>>2]&c[(c[p>>2]|0)+8>>2];Tq(c[g>>2]|0,c[o>>2]|0)|0;jt(c[(c[g>>2]|0)+12>>2]|0,c[p>>2]|0);c[f>>2]=c[k>>2];_=c[f>>2]|0;i=d;return _|0}}c[f>>2]=c[k>>2];_=c[f>>2]|0;i=d;return _|0}case 2:{c[r>>2]=c[c[(c[g>>2]|0)+12>>2]>>2];c[q>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2];c[s>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+72>>2];c[t>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2];c[k>>2]=(iu(c[g>>2]|0,(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+4>>2]|0)*40|0)|0)|0)+(c[k>>2]|0);if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}Bs(c[g>>2]|0,1);if((c[(c[g>>2]|0)+16>>2]|0)!=0?(c[(c[(c[g>>2]|0)+16>>2]|0)+8>>2]|0)!=1:0){c[p>>2]=Sq(c[g>>2]|0)|0;c[c[(c[g>>2]|0)+12>>2]>>2]=c[r>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=c[q>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+72>>2]=c[s>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2]=c[t>>2];b=iu(c[g>>2]|0,(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+8>>2]|0)*40|0)|0)|0;c[k>>2]=(c[k>>2]|0)+b;if(c[(c[g>>2]|0)+8>>2]|0){Qq(c[p>>2]|0);c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}else{Bs(c[g>>2]|0,1);c[o>>2]=Sq(c[g>>2]|0)|0;b=(c[o>>2]|0)+8|0;c[b>>2]=c[b>>2]|c[(c[p>>2]|0)+8>>2];Tq(c[g>>2]|0,c[o>>2]|0)|0;jt(c[(c[g>>2]|0)+12>>2]|0,c[p>>2]|0);c[f>>2]=c[k>>2];_=c[f>>2]|0;i=d;return _|0}}c[f>>2]=c[k>>2];_=c[f>>2]|0;i=d;return _|0}case 4:{c[r>>2]=c[c[(c[g>>2]|0)+12>>2]>>2];c[q>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2];c[s>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+72>>2];c[t>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2];c[k>>2]=(iu(c[g>>2]|0,(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+4>>2]|0)*40|0)|0)|0)+(c[k>>2]|0);if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}c[c[(c[g>>2]|0)+12>>2]>>2]=c[r>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=c[q>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+72>>2]=c[s>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2]=c[t>>2];c[k>>2]=(iu(c[g>>2]|0,(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+8>>2]|0)*40|0)|0)|0)+(c[k>>2]|0);if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}else{c[m>>2]=Sr(c[g>>2]|0,c[(c[j>>2]|0)+12>>2]|0,c[(c[j>>2]|0)+16>>2]|0)|0;b=c[g>>2]|0;Tq(b,Ft(c[(c[g>>2]|0)+12>>2]|0,c[m>>2]|0)|0)|0;c[f>>2]=c[k>>2];_=c[f>>2]|0;i=d;return _|0}break}case 12:{Tq(c[g>>2]|0,lt(c[(c[g>>2]|0)+12>>2]|0,c[(c[j>>2]|0)+24>>2]|0)|0)|0;c[f>>2]=c[k>>2];_=c[f>>2]|0;i=d;return _|0}case 13:{if((c[(c[j>>2]|0)+4>>2]|0)!=-1){b=iu(c[g>>2]|0,(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+4>>2]|0)*40|0)|0)|0;c[k>>2]=(c[k>>2]|0)+b}b=c[(c[g>>2]|0)+12>>2]|0;a=c[j>>2]|0;do if(!(c[(c[j>>2]|0)+28>>2]|0)){c[u>>2]=or(b,c[a+24>>2]|0)|0;aa=c[g>>2]|0;if(c[u>>2]|0){Tq(aa,c[u>>2]|0)|0;break}c[aa+8>>2]=5;c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}else{c[v>>2]=sr(b,c[a+28>>2]|0)|0;if(!(c[v>>2]|0)){aa=c[33976]|0;ba=c[33980]|0;ca=c[(c[j>>2]|0)+28>>2]|0;c[e>>2]=c[(c[j>>2]|0)+24>>2];c[e+4>>2]=ca;Db[aa&511](ba,130032,e);c[(c[g>>2]|0)+8>>2]=19;c[f>>2]=c[k>>2];_=c[f>>2]|0;i=d;return _|0}c[u>>2]=pr(c[(c[g>>2]|0)+12>>2]|0,c[(c[j>>2]|0)+24>>2]|0,c[v>>2]|0)|0;ba=c[g>>2]|0;if(c[u>>2]|0){Tq(ba,c[u>>2]|0)|0;break}c[ba+8>>2]=5;c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}while(0);c[f>>2]=c[k>>2];_=c[f>>2]|0;i=d;return _|0}case 14:{c[A>>2]=ou(c[g>>2]|0)|0;if((c[(c[j>>2]|0)+4>>2]|0)!=-1?(a=iu(c[g>>2]|0,(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+4>>2]|0)*40|0)|0)|0,c[k>>2]=(c[k>>2]|0)+a,(c[(c[g>>2]|0)+8>>2]|0)!=0):0){pu(c[g>>2]|0,c[A>>2]|0);c[f>>2]=c[k>>2];_=c[f>>2]|0;i=d;return _|0}if((c[(c[g>>2]|0)+20>>2]|0)<((c[(c[g>>2]|0)+44>>2]|0)+(c[(c[j>>2]|0)+12>>2]|0)|0)){Db[c[135904>>2]&511](c[33980]|0,130096,e);c[(c[g>>2]|0)+8>>2]=10;pu(c[g>>2]|0,c[A>>2]|0);c[f>>2]=c[k>>2];_=c[f>>2]|0;i=d;return _|0}c[z>>2]=0;while(1){if((c[z>>2]|0)>=(c[(c[j>>2]|0)+12>>2]|0))break;if(!(c[(c[(c[g>>2]|0)+28>>2]|0)+((c[(c[g>>2]|0)+20>>2]|0)-1-(c[z>>2]|0)<<2)>>2]|0)){$=125;break}c[z>>2]=(c[z>>2]|0)+1}if(($|0)==125){Db[c[135904>>2]&511](c[33980]|0,130096,e);c[(c[g>>2]|0)+8>>2]=10;pu(c[g>>2]|0,c[A>>2]|0);c[f>>2]=c[k>>2];_=c[f>>2]|0;i=d;return _|0}do if(c[(c[j>>2]|0)+32>>2]|0)c[w>>2]=c[(c[j>>2]|0)+32>>2];else{c[B>>2]=0;a=c[(c[g>>2]|0)+12>>2]|0;b=c[j>>2]|0;do if(!(c[(c[j>>2]|0)+28>>2]|0))c[w>>2]=lr(a,c[b+24>>2]|0)|0;else{c[B>>2]=sr(a,c[b+28>>2]|0)|0;if(c[B>>2]|0){c[w>>2]=mr(c[(c[g>>2]|0)+12>>2]|0,c[(c[j>>2]|0)+24>>2]|0,c[B>>2]|0)|0;break}ba=c[33976]|0;aa=c[33980]|0;ca=c[(c[j>>2]|0)+28>>2]|0;c[e>>2]=c[(c[j>>2]|0)+24>>2];c[e+4>>2]=ca;Db[ba&511](aa,130136,e);pu(c[g>>2]|0,c[A>>2]|0);c[(c[g>>2]|0)+8>>2]=19;c[f>>2]=c[k>>2];_=c[f>>2]|0;i=d;return _|0}while(0);if(c[w>>2]|0){c[(c[j>>2]|0)+32>>2]=c[w>>2];c[(c[j>>2]|0)+36>>2]=c[B>>2];break}b=c[33976]|0;a=c[33980]|0;c[e>>2]=c[(c[j>>2]|0)+24>>2];Db[b&511](a,130200,e);Nq(c[g>>2]|0,9);c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}while(0);c[x>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+104>>2];c[y>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+108>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+104>>2]=c[(c[j>>2]|0)+24>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+108>>2]=c[(c[j>>2]|0)+36>>2];Ab[c[w>>2]&511](c[g>>2]|0,c[(c[j>>2]|0)+12>>2]|0);c[(c[(c[g>>2]|0)+12>>2]|0)+104>>2]=c[x>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+108>>2]=c[y>>2];pu(c[g>>2]|0,c[A>>2]|0);c[f>>2]=c[k>>2];_=c[f>>2]|0;i=d;return _|0}case 18:{if((c[(c[j>>2]|0)+4>>2]|0)!=-1){a=iu(c[g>>2]|0,(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+4>>2]|0)*40|0)|0)|0;c[k>>2]=(c[k>>2]|0)+a}if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}if((((c[(c[g>>2]|0)+16>>2]|0)!=0?(c[c[(c[g>>2]|0)+16>>2]>>2]|0)==1:0)?(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]|0)!=0:0)?(c[c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]>>2]|0)>1:0)Zq(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]|0);c[f>>2]=c[k>>2];_=c[f>>2]|0;i=d;return _|0}case 19:{c[U>>2]=0;if((c[(c[j>>2]|0)+4>>2]|0)!=-1){a=iu(c[g>>2]|0,(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+4>>2]|0)*40|0)|0)|0;c[k>>2]=(c[k>>2]|0)+a}if((c[(c[j>>2]|0)+8>>2]|0)==-1){c[f>>2]=c[k>>2];_=c[f>>2]|0;i=d;return _|0}a=(c[(c[g>>2]|0)+16>>2]|0)==0;a:do if((c[c[(c[g>>2]|0)+16>>2]>>2]|0)==7){if(!a?(c[c[(c[g>>2]|0)+16>>2]>>2]|0)==7:0){c[S>>2]=Sq(c[g>>2]|0)|0;c[V>>2]=c[(c[S>>2]|0)+28>>2];if((c[V>>2]|0)!=0?(c[c[V>>2]>>2]|0)!=0:0){c[U>>2]=bv(0)|0;c[X>>2]=0;while(1){if((c[X>>2]|0)>=(c[c[V>>2]>>2]|0))break a;c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=c[(c[(c[(c[V>>2]|0)+8>>2]|0)+(c[X>>2]<<2)>>2]|0)+28>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2]=c[c[V>>2]>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+72>>2]=(c[X>>2]|0)+1;c[T>>2]=yt(c[(c[g>>2]|0)+12>>2]|0,c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]|0)|0;Tq(c[g>>2]|0,c[T>>2]|0)|0;if((c[(c[j>>2]|0)+8>>2]|0)!=-1){b=iu(c[g>>2]|0,(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+8>>2]|0)*40|0)|0)|0;c[k>>2]=(c[k>>2]|0)+b}if(c[(c[g>>2]|0)+8>>2]|0)break;c[R>>2]=Sq(c[g>>2]|0)|0;b:do if((c[c[R>>2]>>2]|0)!=7){c[Q>>2]=av(c[(c[(c[(c[V>>2]|0)+8>>2]|0)+(c[X>>2]<<2)>>2]|0)+28>>2]|0,c[R>>2]|0)|0;if(c[Q>>2]|0)cv(c[U>>2]|0,c[Q>>2]|0)}else{c[Z>>2]=c[(c[R>>2]|0)+28>>2];c[Y>>2]=0;while(1){if((c[Y>>2]|0)>=(c[c[Z>>2]>>2]|0))break b;c[Q>>2]=Zu(c[(c[(c[(c[V>>2]|0)+8>>2]|0)+(c[X>>2]<<2)>>2]|0)+28>>2]|0,c[(c[(c[(c[V>>2]|0)+8>>2]|0)+(c[X>>2]<<2)>>2]|0)+32>>2]|0,c[(c[(c[(c[Z>>2]|0)+8>>2]|0)+(c[Y>>2]<<2)>>2]|0)+36>>2]|0,c[(c[(c[(c[Z>>2]|0)+8>>2]|0)+(c[Y>>2]<<2)>>2]|0)+40>>2]|0)|0;if(c[Q>>2]|0)cv(c[U>>2]|0,c[Q>>2]|0);c[Y>>2]=(c[Y>>2]|0)+1}}while(0);if(c[R>>2]|0)jt(c[(c[g>>2]|0)+12>>2]|0,c[R>>2]|0);if((c[(c[g>>2]|0)+16>>2]|0)==(c[T>>2]|0)){c[R>>2]=Sq(c[g>>2]|0)|0;jt(c[(c[g>>2]|0)+12>>2]|0,c[R>>2]|0)}c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=0;c[X>>2]=(c[X>>2]|0)+1}Qq(c[S>>2]|0);c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=0;c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2]=0;c[(c[(c[g>>2]|0)+12>>2]|0)+72>>2]=0;b=iu(c[g>>2]|0,(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+8>>2]|0)*40|0)|0)|0;c[k>>2]=(c[k>>2]|0)+b;c[R>>2]=Sq(c[g>>2]|0)|0;if(c[R>>2]|0)jt(c[(c[g>>2]|0)+12>>2]|0,c[R>>2]|0);Tq(c[g>>2]|0,c[S>>2]|0)|0;if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}else{c[f>>2]=c[k>>2];_=c[f>>2]|0;i=d;return _|0}}Nq(c[g>>2]|0,11);c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}else{if(!a?(c[c[(c[g>>2]|0)+16>>2]>>2]|0)==1:0){c[S>>2]=Sq(c[g>>2]|0)|0;c[W>>2]=c[(c[S>>2]|0)+4>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=0;c[U>>2]=bv(0)|0;if(!(c[W>>2]|0))break;c[X>>2]=0;while(1){if((c[X>>2]|0)>=(c[c[W>>2]>>2]|0))break a;c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=c[(c[(c[W>>2]|0)+8>>2]|0)+(c[X>>2]<<2)>>2];c[T>>2]=yt(c[(c[g>>2]|0)+12>>2]|0,c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]|0)|0;Tq(c[g>>2]|0,c[T>>2]|0)|0;if((c[(c[j>>2]|0)+8>>2]|0)!=-1){b=iu(c[g>>2]|0,(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+8>>2]|0)*40|0)|0)|0;c[k>>2]=(c[k>>2]|0)+b}if(c[(c[g>>2]|0)+8>>2]|0)break;
c[R>>2]=Sq(c[g>>2]|0)|0;c[Q>>2]=av(c[(c[(c[W>>2]|0)+8>>2]|0)+(c[X>>2]<<2)>>2]|0,c[R>>2]|0)|0;if(c[Q>>2]|0)cv(c[U>>2]|0,c[Q>>2]|0);if(c[R>>2]|0)jt(c[(c[g>>2]|0)+12>>2]|0,c[R>>2]|0);if((c[(c[g>>2]|0)+16>>2]|0)==(c[T>>2]|0)){c[R>>2]=Sq(c[g>>2]|0)|0;jt(c[(c[g>>2]|0)+12>>2]|0,c[R>>2]|0)}c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=0;c[X>>2]=(c[X>>2]|0)+1}Qq(c[S>>2]|0);c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}Nq(c[g>>2]|0,11);c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}while(0);jt(c[(c[g>>2]|0)+12>>2]|0,c[S>>2]|0);c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=0;c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2]=-1;c[(c[(c[g>>2]|0)+12>>2]|0)+72>>2]=-1;a=c[g>>2]|0;Tq(a,hv(c[U>>2]|0)|0)|0;c[f>>2]=c[k>>2];_=c[f>>2]|0;i=d;return _|0}case 15:{c[r>>2]=c[c[(c[g>>2]|0)+12>>2]>>2];c[q>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2];c[s>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+72>>2];c[t>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2];if((c[(c[j>>2]|0)+4>>2]|0)!=-1?(a=iu(c[g>>2]|0,(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+4>>2]|0)*40|0)|0)|0,c[k>>2]=(c[k>>2]|0)+a,c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2]=c[t>>2],c[(c[(c[g>>2]|0)+12>>2]|0)+72>>2]=c[s>>2],c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=c[q>>2],c[c[(c[g>>2]|0)+12>>2]>>2]=c[r>>2],(c[(c[g>>2]|0)+8>>2]|0)!=0):0){c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}if((c[(c[j>>2]|0)+8>>2]|0)!=-1?(a=iu(c[g>>2]|0,(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+8>>2]|0)*40|0)|0)|0,c[k>>2]=(c[k>>2]|0)+a,c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2]=c[t>>2],c[(c[(c[g>>2]|0)+12>>2]|0)+72>>2]=c[s>>2],c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=c[q>>2],c[c[(c[g>>2]|0)+12>>2]>>2]=c[r>>2],(c[(c[g>>2]|0)+8>>2]|0)!=0):0){c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}c[f>>2]=c[k>>2];_=c[f>>2]|0;i=d;return _|0}case 17:case 16:{c[F>>2]=0;do if((c[(c[j>>2]|0)+4>>2]|0)!=-1?(c[(c[j>>2]|0)+8>>2]|0)!=-1:0){if((c[(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+4>>2]|0)*40|0)>>2]|0)!=18?(c[(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+4>>2]|0)*40|0)>>2]|0)!=17:0)break;if((((c[(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+8>>2]|0)*40|0)>>2]|0)==12?(c[K>>2]=c[(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+8>>2]|0)*40|0)+24>>2],(c[K>>2]|0)!=0):0)?(c[c[K>>2]>>2]|0)==3:0)?+h[(c[K>>2]|0)+16>>3]==1:0){c[L>>2]=0;a=qu(c[g>>2]|0,(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+4>>2]|0)*40|0)|0,L)|0;c[k>>2]=(c[k>>2]|0)+a;if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}if((((c[(c[g>>2]|0)+16>>2]|0)!=0?(c[c[(c[g>>2]|0)+16>>2]>>2]|0)==1:0)?(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]|0)!=0:0)?(c[c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]>>2]|0)>1:0)c[c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]>>2]=1;c[f>>2]=c[k>>2];_=c[f>>2]|0;i=d;return _|0}}while(0);if((((((((((c[(c[j>>2]|0)+4>>2]|0)!=-1?(c[(c[j>>2]|0)+8>>2]|0)!=-1:0)?(c[(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+4>>2]|0)*40|0)>>2]|0)==18:0)?(c[(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+8>>2]|0)*40|0)>>2]|0)==18:0)?(c[M>>2]=c[(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+8>>2]|0)*40|0)+4>>2],(c[M>>2]|0)!=-1):0)?(c[(c[(c[n>>2]|0)+8>>2]|0)+((c[M>>2]|0)*40|0)>>2]|0)==14:0)?(c[(c[(c[n>>2]|0)+8>>2]|0)+((c[M>>2]|0)*40|0)+28>>2]|0)==0:0)?(c[(c[(c[n>>2]|0)+8>>2]|0)+((c[M>>2]|0)*40|0)+12>>2]|0)==0:0)?(c[(c[(c[n>>2]|0)+8>>2]|0)+((c[M>>2]|0)*40|0)+24>>2]|0)!=0:0)?(qy(c[(c[(c[n>>2]|0)+8>>2]|0)+((c[M>>2]|0)*40|0)+24>>2]|0,129656)|0)!=0:0){c[N>>2]=0;a=ru(c[g>>2]|0,(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+4>>2]|0)*40|0)|0,N)|0;c[k>>2]=(c[k>>2]|0)+a;if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}do if((((c[(c[g>>2]|0)+16>>2]|0)!=0?(c[c[(c[g>>2]|0)+16>>2]>>2]|0)==1:0)?(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]|0)!=0:0)?(c[(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]|0)+8>>2]|0)!=0:0){if((c[c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]>>2]|0)<=1)break;c[c[(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]|0)+8>>2]>>2]=c[(c[(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]|0)+8>>2]|0)+((c[c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]>>2]|0)-1<<2)>>2];c[c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]>>2]=1}while(0);c[f>>2]=c[k>>2];_=c[f>>2]|0;i=d;return _|0}if((c[(c[j>>2]|0)+4>>2]|0)!=-1){a=iu(c[g>>2]|0,(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+4>>2]|0)*40|0)|0)|0;c[k>>2]=(c[k>>2]|0)+a}if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}if((c[(c[j>>2]|0)+8>>2]|0)==-1){c[f>>2]=c[k>>2];_=c[f>>2]|0;i=d;return _|0}if(!(c[(c[g>>2]|0)+16>>2]|0)){c[f>>2]=c[k>>2];_=c[f>>2]|0;i=d;return _|0}c[H>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2];if((c[c[(c[g>>2]|0)+16>>2]>>2]|0)==7){c[O>>2]=0;if((c[(c[g>>2]|0)+16>>2]|0)!=0?(c[c[(c[g>>2]|0)+16>>2]>>2]|0)==7:0){c[D>>2]=Sq(c[g>>2]|0)|0;c[P>>2]=c[(c[D>>2]|0)+28>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=0;if((c[P>>2]|0)!=0?(c[c[P>>2]>>2]|0)!=0:0){c[O>>2]=bv(0)|0;c[J>>2]=0;while(1){if((c[J>>2]|0)>=(c[c[P>>2]>>2]|0)){$=214;break}c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=c[(c[(c[(c[P>>2]|0)+8>>2]|0)+(c[J>>2]<<2)>>2]|0)+28>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2]=c[c[P>>2]>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+72>>2]=(c[J>>2]|0)+1;c[E>>2]=yt(c[(c[g>>2]|0)+12>>2]|0,c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]|0)|0;Tq(c[g>>2]|0,c[E>>2]|0)|0;if((c[(c[j>>2]|0)+8>>2]|0)!=-1){a=iu(c[g>>2]|0,(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+8>>2]|0)*40|0)|0)|0;c[k>>2]=(c[k>>2]|0)+a}if(c[(c[g>>2]|0)+8>>2]|0){$=206;break}c[C>>2]=Sq(c[g>>2]|0)|0;if(Ns(c[g>>2]|0,c[C>>2]|0)|0){a=c[O>>2]|0;cv(a,zr(c[(c[(c[P>>2]|0)+8>>2]|0)+(c[J>>2]<<2)>>2]|0)|0)}if(c[C>>2]|0)jt(c[(c[g>>2]|0)+12>>2]|0,c[C>>2]|0);if((c[(c[g>>2]|0)+16>>2]|0)==(c[E>>2]|0)){c[C>>2]=Sq(c[g>>2]|0)|0;jt(c[(c[g>>2]|0)+12>>2]|0,c[C>>2]|0)}c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=0;c[J>>2]=(c[J>>2]|0)+1}if(($|0)==206){Qq(c[D>>2]|0);c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}else if(($|0)==214){jt(c[(c[g>>2]|0)+12>>2]|0,c[D>>2]|0);c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=0;c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2]=-1;c[(c[(c[g>>2]|0)+12>>2]|0)+72>>2]=-1;a=c[g>>2]|0;Tq(a,hv(c[O>>2]|0)|0)|0;c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=c[H>>2];c[f>>2]=c[k>>2];_=c[f>>2]|0;i=d;return _|0}}c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2]=0;c[(c[(c[g>>2]|0)+12>>2]|0)+72>>2]=0;if((c[(c[j>>2]|0)+8>>2]|0)!=-1){a=iu(c[g>>2]|0,(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+8>>2]|0)*40|0)|0)|0;c[k>>2]=(c[k>>2]|0)+a}c[C>>2]=Sq(c[g>>2]|0)|0;if(c[C>>2]|0)jt(c[(c[g>>2]|0)+12>>2]|0,c[C>>2]|0);Tq(c[g>>2]|0,c[D>>2]|0)|0;if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}else{c[f>>2]=c[k>>2];_=c[f>>2]|0;i=d;return _|0}}Nq(c[g>>2]|0,11);c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}if((c[(c[g>>2]|0)+16>>2]|0)!=0?(c[c[(c[g>>2]|0)+16>>2]>>2]|0)==1:0){c[D>>2]=Sq(c[g>>2]|0)|0;c[G>>2]=c[(c[D>>2]|0)+4>>2];c[H>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2];c[I>>2]=c[c[(c[g>>2]|0)+12>>2]>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=0;if((c[G>>2]|0)!=0?(c[c[G>>2]>>2]|0)!=0:0){c[E>>2]=0;c[F>>2]=$q(0)|0;c[J>>2]=0;while(1){if((c[J>>2]|0)>=(c[c[G>>2]>>2]|0))break;c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=c[(c[(c[G>>2]|0)+8>>2]|0)+(c[J>>2]<<2)>>2];if((c[(c[(c[(c[G>>2]|0)+8>>2]|0)+(c[J>>2]<<2)>>2]|0)+4>>2]|0)!=18?(c[(c[(c[(c[G>>2]|0)+8>>2]|0)+(c[J>>2]<<2)>>2]|0)+32>>2]|0)!=0:0)c[c[(c[g>>2]|0)+12>>2]>>2]=c[(c[(c[(c[G>>2]|0)+8>>2]|0)+(c[J>>2]<<2)>>2]|0)+32>>2];do if(!(c[E>>2]|0))c[E>>2]=yt(c[(c[g>>2]|0)+12>>2]|0,c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]|0)|0;else{if((dr(c[(c[E>>2]|0)+4>>2]|0,c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]|0)|0)>=0)break;c[(c[g>>2]|0)+8>>2]=15}while(0);Tq(c[g>>2]|0,c[E>>2]|0)|0;c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2]=c[c[G>>2]>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+72>>2]=(c[J>>2]|0)+1;if((c[(c[j>>2]|0)+8>>2]|0)!=-1){a=iu(c[g>>2]|0,(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+8>>2]|0)*40|0)|0)|0;c[k>>2]=(c[k>>2]|0)+a}if(c[(c[g>>2]|0)+8>>2]|0){$=234;break}c[C>>2]=Sq(c[g>>2]|0)|0;do if(Ns(c[g>>2]|0,c[C>>2]|0)|0){if((cr(c[F>>2]|0,c[(c[(c[G>>2]|0)+8>>2]|0)+(c[J>>2]<<2)>>2]|0)|0)>=0)break;c[(c[g>>2]|0)+8>>2]=15}while(0);if(c[C>>2]|0)jt(c[(c[g>>2]|0)+12>>2]|0,c[C>>2]|0);if((c[(c[g>>2]|0)+16>>2]|0)==(c[E>>2]|0)){Sq(c[g>>2]|0)|0;su(c[(c[E>>2]|0)+4>>2]|0,1)}else c[E>>2]=0;c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=0;c[J>>2]=(c[J>>2]|0)+1}if(($|0)==234){fr(c[F>>2]|0);Qq(c[D>>2]|0);c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}if(c[E>>2]|0)jt(c[(c[g>>2]|0)+12>>2]|0,c[E>>2]|0);jt(c[(c[g>>2]|0)+12>>2]|0,c[D>>2]|0);c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=0;c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2]=-1;c[(c[(c[g>>2]|0)+12>>2]|0)+72>>2]=-1;c[c[(c[g>>2]|0)+12>>2]>>2]=c[I>>2];a=c[g>>2]|0;Tq(a,At(c[(c[g>>2]|0)+12>>2]|0,c[F>>2]|0)|0)|0}else $=220;if(($|0)==220?(c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2]=0,c[(c[(c[g>>2]|0)+12>>2]|0)+72>>2]=0,Tq(c[g>>2]|0,c[D>>2]|0)|0,c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=c[H>>2],(c[(c[g>>2]|0)+8>>2]|0)!=0):0){c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=c[H>>2];c[f>>2]=c[k>>2];_=c[f>>2]|0;i=d;return _|0}Nq(c[g>>2]|0,11);c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}case 3:{c[r>>2]=c[c[(c[g>>2]|0)+12>>2]>>2];c[q>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2];c[s>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+72>>2];c[t>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2];a=iu(c[g>>2]|0,(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+4>>2]|0)*40|0)|0)|0;c[k>>2]=(c[k>>2]|0)+a;if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}c[c[(c[g>>2]|0)+12>>2]>>2]=c[r>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=c[q>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+72>>2]=c[s>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2]=c[t>>2];a=iu(c[g>>2]|0,(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+8>>2]|0)*40|0)|0)|0;c[k>>2]=(c[k>>2]|0)+a;if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}a=c[g>>2]|0;if(c[(c[j>>2]|0)+12>>2]|0)c[l>>2]=Qr(a)|0;else c[l>>2]=Rr(a)|0;a=c[g>>2]|0;Tq(a,Ft(c[(c[g>>2]|0)+12>>2]|0,c[l>>2]|0)|0)|0;c[f>>2]=c[k>>2];_=c[f>>2]|0;i=d;return _|0}case 6:{c[r>>2]=c[c[(c[g>>2]|0)+12>>2]>>2];c[q>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2];c[s>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+72>>2];c[t>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2];a=iu(c[g>>2]|0,(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+4>>2]|0)*40|0)|0)|0;c[k>>2]=(c[k>>2]|0)+a;if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}c[c[(c[g>>2]|0)+12>>2]>>2]=c[r>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=c[q>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+72>>2]=c[s>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2]=c[t>>2];a=iu(c[g>>2]|0,(c[(c[n>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+8>>2]|0)*40|0)|0)|0;c[k>>2]=(c[k>>2]|0)+a;if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;_=c[f>>2]|0;i=d;return _|0}do if(c[(c[j>>2]|0)+12>>2]|0){if((c[(c[j>>2]|0)+12>>2]|0)==1){Yr(c[g>>2]|0);break}if((c[(c[j>>2]|0)+12>>2]|0)==2)Zr(c[g>>2]|0)}else Xr(c[g>>2]|0);while(0);c[f>>2]=c[k>>2];_=c[f>>2]|0;i=d;return _|0}default:{a=c[33976]|0;b=c[33980]|0;c[e>>2]=c[c[j>>2]>>2];Db[a&511](b,130248,e);c[(c[g>>2]|0)+8>>2]=10;c[f>>2]=c[k>>2];_=c[f>>2]|0;i=d;return _|0}}while(0);return 0}function ju(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+64|0;e=d+52|0;f=d+48|0;g=d+44|0;h=d+40|0;j=d+36|0;k=d+32|0;l=d+28|0;m=d+24|0;n=d+20|0;o=d+16|0;p=d+12|0;q=d+8|0;r=d+4|0;s=d;c[f>>2]=a;c[g>>2]=b;c[k>>2]=0;c[l>>2]=0;c[m>>2]=0;c[n>>2]=0;c[o>>2]=0;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){c[e>>2]=-2;t=c[e>>2]|0;i=d;return t|0}if((c[f>>2]|0)==(c[g>>2]|0)){c[e>>2]=0;t=c[e>>2]|0;i=d;return t|0}a:do switch(c[(c[f>>2]|0)+4>>2]|0){case 2:{c[l>>2]=1;c[n>>2]=c[f>>2];c[f>>2]=c[(c[f>>2]|0)+20>>2];c[k>>2]=1;u=27;break}case 7:case 8:case 4:case 3:{c[n>>2]=c[f>>2];do if(c[(c[f>>2]|0)+28>>2]|0){while(1){c[f>>2]=c[(c[f>>2]|0)+28>>2];if((c[(c[f>>2]|0)+4>>2]|0)==1){u=17;break}if(!(c[(c[f>>2]|0)+28>>2]|0)){u=19;break}}if((u|0)==17){c[l>>2]=3;break}else if((u|0)==19){c[l>>2]=2;c[f>>2]=c[(c[f>>2]|0)+20>>2];break}}else{c[l>>2]=2;c[f>>2]=c[(c[f>>2]|0)+20>>2]}while(0);if(((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+4>>2]|0)==1:0)?0>(c[(c[f>>2]|0)+40>>2]|0):0){c[k>>2]=1;u=27;break a}c[f>>2]=c[n>>2];c[l>>2]=0;u=27;break}case 18:{c[e>>2]=1;t=c[e>>2]|0;i=d;return t|0}case 1:{if((c[(c[g>>2]|0)+4>>2]|0)==1){if((0>(c[(c[f>>2]|0)+40>>2]|0)?0>(c[(c[g>>2]|0)+40>>2]|0):0)?(c[(c[f>>2]|0)+32>>2]|0)==(c[(c[g>>2]|0)+32>>2]|0):0){c[r>>2]=0-(c[(c[f>>2]|0)+40>>2]|0);c[s>>2]=0-(c[(c[g>>2]|0)+40>>2]|0);if((c[r>>2]|0)<(c[s>>2]|0)){c[e>>2]=1;t=c[e>>2]|0;i=d;return t|0}if((c[r>>2]|0)>(c[s>>2]|0)){c[e>>2]=-1;t=c[e>>2]|0;i=d;return t|0}else u=27}}else u=27;break}default:u=27}while(0);if((u|0)==27){b:do switch(c[(c[g>>2]|0)+4>>2]|0){case 7:case 8:case 4:case 3:{c[o>>2]=c[g>>2];do if(c[(c[g>>2]|0)+28>>2]|0){while(1){c[g>>2]=c[(c[g>>2]|0)+28>>2];if((c[(c[g>>2]|0)+4>>2]|0)==1){u=31;break}if(!(c[(c[g>>2]|0)+28>>2]|0)){u=33;break}}if((u|0)==31){c[m>>2]=3;break}else if((u|0)==33){c[m>>2]=2;c[g>>2]=c[(c[g>>2]|0)+20>>2];break}}else{c[m>>2]=2;c[g>>2]=c[(c[g>>2]|0)+20>>2]}while(0);if(((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+4>>2]|0)==1:0)?0>(c[(c[g>>2]|0)+40>>2]|0):0){c[k>>2]=1;break b}c[g>>2]=c[o>>2];c[m>>2]=0;break}case 2:{c[m>>2]=1;c[o>>2]=c[g>>2];c[g>>2]=c[(c[g>>2]|0)+20>>2];c[k>>2]=1;break}case 18:{c[e>>2]=1;t=c[e>>2]|0;i=d;return t|0}default:{}}while(0);c:do if(c[k>>2]|0){if((c[f>>2]|0)!=(c[g>>2]|0)){d:do if((c[m>>2]|0)==3&(c[l>>2]|0)>1){c[p>>2]=c[(c[f>>2]|0)+20>>2];while(1){if(!(c[p>>2]|0))break d;if((c[p>>2]|0)==(c[g>>2]|0))break;c[p>>2]=c[(c[p>>2]|0)+20>>2]}c[e>>2]=1;t=c[e>>2]|0;i=d;return t|0}while(0);if(!((c[l>>2]|0)==3&(c[m>>2]|0)>1))break;c[p>>2]=c[(c[g>>2]|0)+20>>2];while(1){if(!(c[p>>2]|0))break c;if((c[p>>2]|0)==(c[f>>2]|0))break;c[p>>2]=c[(c[p>>2]|0)+20>>2]}c[e>>2]=-1;t=c[e>>2]|0;i=d;return t|0}if((c[l>>2]|0)!=(c[m>>2]|0))if((c[l>>2]|0)<(c[m>>2]|0)){c[e>>2]=1;t=c[e>>2]|0;i=d;return t|0}else{c[e>>2]=-1;t=c[e>>2]|0;i=d;return t|0}c[p>>2]=c[(c[o>>2]|0)+28>>2];while(1){if(!(c[p>>2]|0)){u=51;break}if((c[p>>2]|0)==(c[n>>2]|0)){u=47;break}if((c[(c[p>>2]|0)+4>>2]|0)==1){u=49;break}c[p>>2]=c[(c[p>>2]|0)+28>>2]}if((u|0)==47){c[e>>2]=1;t=c[e>>2]|0;i=d;return t|0}else if((u|0)==49){c[e>>2]=-1;t=c[e>>2]|0;i=d;return t|0}else if((u|0)==51){c[e>>2]=-1;t=c[e>>2]|0;i=d;return t|0}}while(0);if(((((c[(c[f>>2]|0)+4>>2]|0)==1?(c[(c[g>>2]|0)+4>>2]|0)==1:0)?0>(c[(c[f>>2]|0)+40>>2]|0):0)?0>(c[(c[g>>2]|0)+40>>2]|0):0)?(c[(c[f>>2]|0)+32>>2]|0)==(c[(c[g>>2]|0)+32>>2]|0):0){c[r>>2]=0-(c[(c[f>>2]|0)+40>>2]|0);c[s>>2]=0-(c[(c[g>>2]|0)+40>>2]|0);if((c[r>>2]|0)<(c[s>>2]|0)){c[e>>2]=1;t=c[e>>2]|0;i=d;return t|0}if((c[r>>2]|0)>(c[s>>2]|0)){c[e>>2]=-1;t=c[e>>2]|0;i=d;return t|0}}}if((c[f>>2]|0)==(c[(c[g>>2]|0)+28>>2]|0)){c[e>>2]=1;t=c[e>>2]|0;i=d;return t|0}if((c[f>>2]|0)==(c[(c[g>>2]|0)+24>>2]|0)){c[e>>2]=-1;t=c[e>>2]|0;i=d;return t|0}c[j>>2]=0;c[p>>2]=c[g>>2];while(1){v=c[p>>2]|0;if(!(c[(c[p>>2]|0)+20>>2]|0))break;if((v|0)==(c[f>>2]|0)){u=83;break}c[j>>2]=(c[j>>2]|0)+1;c[p>>2]=c[(c[p>>2]|0)+20>>2]}if((u|0)==83){c[e>>2]=1;t=c[e>>2]|0;i=d;return t|0}c[q>>2]=v;c[h>>2]=0;c[p>>2]=c[f>>2];while(1){if(!(c[(c[p>>2]|0)+20>>2]|0))break;if((c[p>>2]|0)==(c[g>>2]|0)){u=88;break}c[h>>2]=(c[h>>2]|0)+1;c[p>>2]=c[(c[p>>2]|0)+20>>2]}if((u|0)==88){c[e>>2]=-1;t=c[e>>2]|0;i=d;return t|0}if((c[q>>2]|0)!=(c[p>>2]|0)){c[e>>2]=-2;t=c[e>>2]|0;i=d;return t|0}while(1){if((c[h>>2]|0)<=(c[j>>2]|0))break;c[h>>2]=(c[h>>2]|0)+-1;c[f>>2]=c[(c[f>>2]|0)+20>>2]}while(1){if((c[j>>2]|0)<=(c[h>>2]|0))break;c[j>>2]=(c[j>>2]|0)+-1;c[g>>2]=c[(c[g>>2]|0)+20>>2]}while(1){w=c[f>>2]|0;if((c[(c[f>>2]|0)+20>>2]|0)==(c[(c[g>>2]|0)+20>>2]|0))break;c[f>>2]=c[w+20>>2];c[g>>2]=c[(c[g>>2]|0)+20>>2];if((c[f>>2]|0)==0|(c[g>>2]|0)==0){u=98;break}}if((u|0)==98){c[e>>2]=-2;t=c[e>>2]|0;i=d;return t|0}if((w|0)==(c[(c[g>>2]|0)+28>>2]|0)){c[e>>2]=1;t=c[e>>2]|0;i=d;return t|0}if((c[f>>2]|0)==(c[(c[g>>2]|0)+24>>2]|0)){c[e>>2]=-1;t=c[e>>2]|0;i=d;return t|0}if(((((c[(c[f>>2]|0)+4>>2]|0)==1?(c[(c[g>>2]|0)+4>>2]|0)==1:0)?0>(c[(c[f>>2]|0)+40>>2]|0):0)?0>(c[(c[g>>2]|0)+40>>2]|0):0)?(c[(c[f>>2]|0)+32>>2]|0)==(c[(c[g>>2]|0)+32>>2]|0):0){c[r>>2]=0-(c[(c[f>>2]|0)+40>>2]|0);c[s>>2]=0-(c[(c[g>>2]|0)+40>>2]|0);if((c[r>>2]|0)<(c[s>>2]|0)){c[e>>2]=1;t=c[e>>2]|0;i=d;return t|0}if((c[r>>2]|0)>(c[s>>2]|0)){c[e>>2]=-1;t=c[e>>2]|0;i=d;return t|0}}c[p>>2]=c[(c[f>>2]|0)+24>>2];while(1){if(!(c[p>>2]|0)){u=117;break}if((c[p>>2]|0)==(c[g>>2]|0)){u=115;break}c[p>>2]=c[(c[p>>2]|0)+24>>2]}if((u|0)==115){c[e>>2]=1;t=c[e>>2]|0;i=d;return t|0}else if((u|0)==117){c[e>>2]=-1;t=c[e>>2]|0;i=d;return t|0}return 0}function ku(a,b){a=+a;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d;g=d+8|0;h[f>>3]=a;c[g>>2]=b;b=St(+h[f>>3])|0;j=dU(b|0,G|0,63)|0;c[c[g>>2]>>2]=j;j=rT(+h[f>>3])|0;if((j|0)==3)c[e>>2]=3;else if((j|0)==2)c[e>>2]=4;else if(!j)c[e>>2]=1;else if((j|0)==1)c[e>>2]=0;else c[e>>2]=2;i=d;return c[e>>2]|0}function lu(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[c[d>>2]>>2]|0)zb[c[135736>>2]&511](c[c[d>>2]>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function mu(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;tu(c[e>>2]|0);if(c[(c[e>>2]|0)+8>>2]|0){i=b;return}a:while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[e>>2]>>2]>>0]|0|0)!=13)break a}while(0);a=c[e>>2]|0;if(!(d[c[c[e>>2]>>2]>>0]|0))continue;c[a>>2]=(c[a>>2]|0)+1}b:while(1){if((d[c[c[e>>2]>>2]>>0]|0|0)!=61){if((d[c[c[e>>2]>>2]>>0]|0|0)!=33){h=34;break}if((d[(c[c[e>>2]>>2]|0)+1>>0]|0|0)!=61){h=34;break}}c[g>>2]=c[(c[(c[e>>2]|0)+32>>2]|0)+12>>2];if((d[c[c[e>>2]>>2]>>0]|0|0)==61)c[f>>2]=1;else c[f>>2]=0;a=c[e>>2]|0;if(d[c[c[e>>2]>>2]>>0]|0)c[a>>2]=(c[a>>2]|0)+1;if((c[f>>2]|0)==0?(a=c[e>>2]|0,(d[c[c[e>>2]>>2]>>0]|0|0)!=0):0)c[a>>2]=(c[a>>2]|0)+1;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)j=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){j=1;break}j=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);k=c[e>>2]|0;if(!j)break;a=c[e>>2]|0;if(!(d[c[k>>2]>>0]|0))continue;c[a>>2]=(c[a>>2]|0)+1}tu(k);if(c[(c[e>>2]|0)+8>>2]|0){h=34;break}du(c[(c[e>>2]|0)+32>>2]|0,c[g>>2]|0,c[(c[(c[e>>2]|0)+32>>2]|0)+12>>2]|0,3,c[f>>2]|0,0,0,0,0)|0;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[e>>2]>>2]>>0]|0|0)!=13)continue b}while(0);a=c[e>>2]|0;if(!(d[c[c[e>>2]>>2]>>0]|0))continue;c[a>>2]=(c[a>>2]|0)+1}}if((h|0)==34){i=b;return}}function nu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;g=i;i=i+160|0;h=g;j=g+148|0;k=g+144|0;l=g+140|0;m=g+136|0;n=g+132|0;o=g+128|0;p=g+124|0;q=g+120|0;r=g+116|0;s=g+112|0;t=g+108|0;u=g+104|0;v=g+100|0;w=g+96|0;x=g+92|0;y=g+88|0;z=g+84|0;A=g+80|0;B=g+76|0;C=g+72|0;D=g+68|0;E=g+64|0;F=g+60|0;G=g+56|0;H=g+52|0;I=g+48|0;J=g+44|0;K=g+40|0;L=g+36|0;M=g+32|0;N=g+28|0;O=g+24|0;P=g+20|0;Q=g+16|0;R=g+12|0;S=g+8|0;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=c[(c[l>>2]|0)+12>>2];c[q>>2]=c[(c[l>>2]|0)+16>>2];c[r>>2]=c[(c[l>>2]|0)+20>>2];c[s>>2]=c[(c[l>>2]|0)+24>>2];c[t>>2]=c[(c[l>>2]|0)+28>>2];c[u>>2]=0;c[v>>2]=0;c[w>>2]=0;c[M>>2]=0;c[Q>>2]=c[(c[k>>2]|0)+12>>2];if((c[(c[k>>2]|0)+16>>2]|0)!=0?(c[c[(c[k>>2]|0)+16>>2]>>2]|0)==1:0){c[x>>2]=Sq(c[k>>2]|0)|0;if((c[s>>2]|0)!=0?(c[u>>2]=sr(c[Q>>2]|0,c[s>>2]|0)|0,(c[u>>2]|0)==0):0){jt(c[Q>>2]|0,c[x>>2]|0);Nq(c[k>>2]|0,19);c[j>>2]=0;T=c[j>>2]|0;i=g;return T|0}c[O>>2]=289;do switch(c[p>>2]|0){case 9:{c[m>>2]=0;c[n>>2]=0;c[M>>2]=300;c[O>>2]=293;break}case 3:{c[m>>2]=0;c[n>>2]=0;c[M>>2]=292;c[O>>2]=293;break}case 7:{c[n>>2]=0;c[M>>2]=298;break}case 11:{c[m>>2]=0;c[M>>2]=302;break}case 8:{c[n>>2]=0;c[M>>2]=299;break}case 1:{c[m>>2]=0;c[M>>2]=290;break}case 12:{c[m>>2]=0;c[M>>2]=303;break}case 6:{c[n>>2]=0;c[M>>2]=297;break}case 4:{c[n>>2]=0;if(((c[q>>2]|0)==5|(c[q>>2]|0)==3)&(c[r>>2]|0)==0)c[M>>2]=294;else c[M>>2]=295;c[O>>2]=293;break}case 13:{c[m>>2]=0;c[n>>2]=0;c[M>>2]=304;c[O>>2]=293;break}case 2:{c[m>>2]=0;c[M>>2]=291;break}case 5:{c[n>>2]=0;c[M>>2]=296;break}case 10:{c[m>>2]=0;c[M>>2]=301;break}default:{}}while(0);if(!(c[M>>2]|0)){jt(c[Q>>2]|0,c[x>>2]|0);c[j>>2]=0;T=c[j>>2]|0;i=g;return T|0}c[y>>2]=c[(c[x>>2]|0)+4>>2];if((c[y>>2]|0)!=0?(c[c[y>>2]>>2]|0)>0:0){c[F>>2]=0;c[E>>2]=0;c[G>>2]=0;c[H>>2]=0;do if((c[(c[l>>2]|0)+8>>2]|0)!=-1?(c[E>>2]=(c[(c[(c[k>>2]|0)+32>>2]|0)+8>>2]|0)+((c[(c[l>>2]|0)+8>>2]|0)*40|0),(yu(c[k>>2]|0,c[E>>2]|0,F)|0)!=0):0)if((c[(c[E>>2]|0)+4>>2]|0)!=-1){c[E>>2]=(c[(c[(c[k>>2]|0)+32>>2]|0)+8>>2]|0)+((c[(c[E>>2]|0)+4>>2]|0)*40|0);c[G>>2]=1;break}else{c[E>>2]=0;c[H>>2]=1;break}while(0);if(c[o>>2]|0)U=(c[E>>2]|0)==0;else U=0;c[L>>2]=U?1:0;c[P>>2]=c[(c[Q>>2]|0)+4>>2];c[N>>2]=305;c[B>>2]=0;c[C>>2]=0;c[A>>2]=0;c[z>>2]=0;a:while(1){if(!((c[A>>2]|0)!=0?1:(c[z>>2]|0)<(c[c[y>>2]>>2]|0)))break;if(c[(c[k>>2]|0)+8>>2]|0)break;U=c[z>>2]|0;c[z>>2]=U+1;c[(c[Q>>2]|0)+4>>2]=c[(c[(c[y>>2]|0)+8>>2]|0)+(U<<2)>>2];if((c[C>>2]|0)==0?(c[C>>2]=$q(0)|0,(c[C>>2]|0)==0):0){V=41;break}c[I>>2]=0;c[D>>2]=0;c[w>>2]=0;b:while(1){c[D>>2]=Hb[c[M>>2]&511](c[k>>2]|0,c[D>>2]|0)|0;if(!(c[D>>2]|0)){V=211;break}do if((c[m>>2]|0)!=0?(c[c[m>>2]>>2]|0)!=0:0){if((c[c[m>>2]>>2]|0)==(c[D>>2]|0)){V=211;break b}if((c[v>>2]|0)%256|0)break;if((ju(c[c[m>>2]>>2]|0,c[D>>2]|0)|0)>=0){V=211;break b}}while(0);do if((c[n>>2]|0)!=0?(c[c[n>>2]>>2]|0)!=0:0){if((c[c[n>>2]>>2]|0)==(c[D>>2]|0)){V=211;break b}if((c[v>>2]|0)%256|0)break;if((ju(c[D>>2]|0,c[c[n>>2]>>2]|0)|0)>=0){V=211;break b}}while(0);c[v>>2]=(c[v>>2]|0)+1;c:do switch(c[q>>2]|0){case 5:{do if((c[p>>2]|0)==3){if((c[(c[D>>2]|0)+4>>2]|0)!=2)break c}else{U=c[(c[D>>2]|0)+4>>2]|0;if((c[p>>2]|0)==9)if((U|0)!=18)break c;else break;else if((U|0)!=1)break c;else break}while(0);U=c[(c[D>>2]|0)+4>>2]|0;if((U|0)==18){if((c[(c[D>>2]|0)+4>>2]|0)!=18)break c;c[S>>2]=c[D>>2];if(!((c[t>>2]|0)!=0?(c[(c[S>>2]|0)+12>>2]|0)!=0:0))break c;if(!(qy(c[(c[S>>2]|0)+12>>2]|0,c[t>>2]|0)|0))break c;if(c[H>>2]|0){l=(c[I>>2]|0)+1|0;c[I>>2]=l;if((l|0)==(c[F>>2]|0)){V=197;break b}else break c}c[w>>2]=1;if((br(c[C>>2]|0,c[(c[Q>>2]|0)+4>>2]|0,c[D>>2]|0)|0)<0)c[(c[k>>2]|0)+8>>2]=15;if(c[L>>2]|0){V=208;break a}else break c}else if((U|0)==2){c[R>>2]=c[D>>2];if(!(qy(c[t>>2]|0,c[(c[R>>2]|0)+8>>2]|0)|0))break c;l=c[(c[R>>2]|0)+36>>2]|0;if(!(c[s>>2]|0)){if((l|0)!=0?(c[(c[(c[R>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0)break c;if(c[H>>2]|0){f=(c[I>>2]|0)+1|0;c[I>>2]=f;if((f|0)==(c[F>>2]|0)){V=178;break b}else break c}if((Hb[c[N>>2]&511](c[C>>2]|0,c[D>>2]|0)|0)<0)c[(c[k>>2]|0)+8>>2]=15;if(c[L>>2]|0){V=208;break a}else break c}else{if(!l)break c;if(!(qy(c[u>>2]|0,c[(c[(c[R>>2]|0)+36>>2]|0)+8>>2]|0)|0))break c;if(c[H>>2]|0){l=(c[I>>2]|0)+1|0;c[I>>2]=l;if((l|0)==(c[F>>2]|0)){V=187;break b}else break c}if((Hb[c[N>>2]&511](c[C>>2]|0,c[D>>2]|0)|0)<0)c[(c[k>>2]|0)+8>>2]=15;if(c[L>>2]|0){V=208;break a}else break c}}else if((U|0)==1){if(!(qy(c[t>>2]|0,c[(c[D>>2]|0)+8>>2]|0)|0))break c;U=c[(c[D>>2]|0)+36>>2]|0;if(!(c[s>>2]|0)){if(U)break c;if(c[H>>2]|0){l=(c[I>>2]|0)+1|0;c[I>>2]=l;if((l|0)==(c[F>>2]|0)){V=158;break b}else break c}if((Hb[c[N>>2]&511](c[C>>2]|0,c[D>>2]|0)|0)<0)c[(c[k>>2]|0)+8>>2]=15;if(c[L>>2]|0){V=208;break a}else break c}if(!U)break c;if(!(qy(c[u>>2]|0,c[(c[(c[D>>2]|0)+36>>2]|0)+8>>2]|0)|0))break c;if(c[H>>2]|0){U=(c[I>>2]|0)+1|0;c[I>>2]=U;if((U|0)==(c[F>>2]|0)){V=167;break b}else break c}if((Hb[c[N>>2]&511](c[C>>2]|0,c[D>>2]|0)|0)<0)c[(c[k>>2]|0)+8>>2]=15;if(c[L>>2]|0){V=208;break a}else break c}else break c;break}case 2:{if((c[(c[D>>2]|0)+4>>2]|0)==7){if((c[t>>2]|0)!=0?(qy(c[t>>2]|0,c[(c[D>>2]|0)+8>>2]|0)|0)==0:0)break c;if(c[H>>2]|0){U=(c[I>>2]|0)+1|0;c[I>>2]=U;if((U|0)==(c[F>>2]|0)){V=95;break b}else break c}if((Hb[c[N>>2]&511](c[C>>2]|0,c[D>>2]|0)|0)<0)c[(c[k>>2]|0)+8>>2]=15;if(c[L>>2]|0){V=208;break a}}break}case 1:{U=c[(c[D>>2]|0)+4>>2]|0;if(!(c[r>>2]|0)){switch(U|0){case 18:case 3:case 4:case 8:case 7:case 2:case 1:case 21:case 13:case 9:break;default:break c}if(c[H>>2]|0){l=(c[I>>2]|0)+1|0;c[I>>2]=l;if((l|0)==(c[F>>2]|0)){V=60;break b}else break c}if((Hb[c[N>>2]&511](c[C>>2]|0,c[D>>2]|0)|0)<0)c[(c[k>>2]|0)+8>>2]=15;if(c[L>>2]|0){V=208;break a}else break c}if((U|0)!=(c[r>>2]|0)){if((c[r>>2]|0)!=3)break c;if((c[(c[D>>2]|0)+4>>2]|0)!=4)break c;if(c[H>>2]|0){U=(c[I>>2]|0)+1|0;c[I>>2]=U;if((U|0)==(c[F>>2]|0)){V=85;break b}else break c}if((Hb[c[N>>2]&511](c[C>>2]|0,c[D>>2]|0)|0)<0)c[(c[k>>2]|0)+8>>2]=15;if(c[L>>2]|0){V=208;break a}else break c}U=(c[H>>2]|0)!=0;if((c[(c[D>>2]|0)+4>>2]|0)==18){if(U){l=(c[I>>2]|0)+1|0;c[I>>2]=l;if((l|0)==(c[F>>2]|0)){V=69;break b}else break c}c[w>>2]=1;if((br(c[C>>2]|0,c[(c[Q>>2]|0)+4>>2]|0,c[D>>2]|0)|0)<0)c[(c[k>>2]|0)+8>>2]=15;if(c[L>>2]|0){V=208;break a}else break c}else{if(U){U=(c[I>>2]|0)+1|0;c[I>>2]=U;if((U|0)==(c[F>>2]|0)){V=76;break b}else break c}if((Hb[c[N>>2]&511](c[C>>2]|0,c[D>>2]|0)|0)<0)c[(c[k>>2]|0)+8>>2]=15;if(c[L>>2]|0){V=208;break a}else break c}break}case 0:{V=55;break a;break}case 4:{U=c[33976]|0;l=c[33980]|0;c[h>>2]=128552;c[h+4>>2]=12457;Db[U&511](l,129064,h);break}case 3:{if((c[p>>2]|0)==3){if((c[(c[D>>2]|0)+4>>2]|0)!=2)break c;if(!(c[s>>2]|0)){if(c[H>>2]|0){l=(c[I>>2]|0)+1|0;c[I>>2]=l;if((l|0)==(c[F>>2]|0)){V=105;break b}else break c}if((Hb[c[N>>2]&511](c[C>>2]|0,c[D>>2]|0)|0)<0)c[(c[k>>2]|0)+8>>2]=15;if(c[L>>2]|0){V=208;break a}else break c}if(!(c[(c[D>>2]|0)+36>>2]|0))break c;if(!(qy(c[u>>2]|0,c[(c[(c[D>>2]|0)+36>>2]|0)+8>>2]|0)|0))break c;if(c[H>>2]|0){l=(c[I>>2]|0)+1|0;c[I>>2]=l;if((l|0)==(c[F>>2]|0)){V=114;break b}else break c}if((Hb[c[N>>2]&511](c[C>>2]|0,c[D>>2]|0)|0)<0)c[(c[k>>2]|0)+8>>2]=15;if(c[L>>2]|0){V=208;break a}else break c}l=c[(c[D>>2]|0)+4>>2]|0;if((c[p>>2]|0)==9){if((l|0)!=18)break c;if(c[H>>2]|0){U=(c[I>>2]|0)+1|0;c[I>>2]=U;if((U|0)==(c[F>>2]|0)){V=123;break b}else break c}c[w>>2]=1;if((br(c[C>>2]|0,c[(c[Q>>2]|0)+4>>2]|0,c[D>>2]|0)|0)<0)c[(c[k>>2]|0)+8>>2]=15;if(c[L>>2]|0){V=208;break a}else break c}if((l|0)!=1)break c;if(!(c[s>>2]|0)){if(c[H>>2]|0){l=(c[I>>2]|0)+1|0;c[I>>2]=l;if((l|0)==(c[F>>2]|0)){V=132;break b}else break c}if((Hb[c[N>>2]&511](c[C>>2]|0,c[D>>2]|0)|0)<0)c[(c[k>>2]|0)+8>>2]=15;if(c[L>>2]|0){V=208;break a}else break c}if(!(c[(c[D>>2]|0)+36>>2]|0))break c;if(!(qy(c[u>>2]|0,c[(c[(c[D>>2]|0)+36>>2]|0)+8>>2]|0)|0))break c;if(c[H>>2]|0){l=(c[I>>2]|0)+1|0;c[I>>2]=l;if((l|0)==(c[F>>2]|0)){V=141;break b}else break c}if((Hb[c[N>>2]&511](c[C>>2]|0,c[D>>2]|0)|0)<0)c[(c[k>>2]|0)+8>>2]=15;if(c[L>>2]|0){V=208;break a}break}default:{}}while(0);if(!(c[D>>2]|0)){V=211;break}if(c[(c[k>>2]|0)+8>>2]|0){V=211;break}}switch(V|0){case 60:{V=0;if((Hb[c[N>>2]&511](c[C>>2]|0,c[D>>2]|0)|0)<0)c[(c[k>>2]|0)+8>>2]=15;break}case 69:{V=0;c[w>>2]=1;if((br(c[C>>2]|0,c[(c[Q>>2]|0)+4>>2]|0,c[D>>2]|0)|0)<0)c[(c[k>>2]|0)+8>>2]=15;break}case 76:{V=0;if((Hb[c[N>>2]&511](c[C>>2]|0,c[D>>2]|0)|0)<0)c[(c[k>>2]|0)+8>>2]=15;break}case 85:{V=0;if((Hb[c[N>>2]&511](c[C>>2]|0,c[D>>2]|0)|0)<0)c[(c[k>>2]|0)+8>>2]=15;break}case 95:{V=0;if((Hb[c[N>>2]&511](c[C>>2]|0,c[D>>2]|0)|0)<0)c[(c[k>>2]|0)+8>>2]=15;break}case 105:{V=0;if((Hb[c[N>>2]&511](c[C>>2]|0,c[D>>2]|0)|0)<0)c[(c[k>>2]|0)+8>>2]=15;break}case 114:{V=0;if((Hb[c[N>>2]&511](c[C>>2]|0,c[D>>2]|0)|0)<0)c[(c[k>>2]|0)+8>>2]=15;break}case 123:{V=0;c[w>>2]=1;if((br(c[C>>2]|0,c[(c[Q>>2]|0)+4>>2]|0,c[D>>2]|0)|0)<0)c[(c[k>>2]|0)+8>>2]=15;break}case 132:{V=0;if((Hb[c[N>>2]&511](c[C>>2]|0,c[D>>2]|0)|0)<0)c[(c[k>>2]|0)+8>>2]=15;break}case 141:{V=0;if((Hb[c[N>>2]&511](c[C>>2]|0,c[D>>2]|0)|0)<0)c[(c[k>>2]|0)+8>>2]=15;break}case 158:{V=0;if((Hb[c[N>>2]&511](c[C>>2]|0,c[D>>2]|0)|0)<0)c[(c[k>>2]|0)+8>>2]=15;break}case 167:{V=0;if((Hb[c[N>>2]&511](c[C>>2]|0,c[D>>2]|0)|0)<0)c[(c[k>>2]|0)+8>>2]=15;break}case 178:{V=0;if((Hb[c[N>>2]&511](c[C>>2]|0,c[D>>2]|0)|0)<0)c[(c[k>>2]|0)+8>>2]=15;break}case 187:{V=0;if((Hb[c[N>>2]&511](c[C>>2]|0,c[D>>2]|0)|0)<0)c[(c[k>>2]|0)+8>>2]=15;break}case 197:{V=0;c[w>>2]=1;if((br(c[C>>2]|0,c[(c[Q>>2]|0)+4>>2]|0,c[D>>2]|0)|0)<0)c[(c[k>>2]|0)+8>>2]=15;break}case 211:{V=0;if(c[(c[k>>2]|0)+8>>2]|0)break a;if((c[E>>2]|0)!=0?(c[c[C>>2]>>2]|0)>0:0){c[J>>2]=c[c[C>>2]>>2];l=c[k>>2]|0;U=c[E>>2]|0;f=c[C>>2]|0;e=c[J>>2]|0;if(c[G>>2]|0)c[K>>2]=zu(l,U,f,e,c[F>>2]|0,c[F>>2]|0,c[w>>2]|0)|0;else c[K>>2]=Au(l,U,f,e,c[w>>2]|0)|0;if(c[(c[k>>2]|0)+8>>2]|0){V=218;break a}e=c[C>>2]|0;if(!(c[K>>2]|0)){su(e,c[w>>2]|0);continue a}if((c[e>>2]|0)<=0)continue a;do if(!(c[B>>2]|0))if((c[J>>2]|0)!=(c[K>>2]|0)){c[B>>2]=vb[c[O>>2]&511](0,c[C>>2]|0,1)|0;break}else{c[B>>2]=c[C>>2];c[C>>2]=0;break}else c[B>>2]=vb[c[O>>2]&511](c[B>>2]|0,c[C>>2]|0,(c[J>>2]|0)!=(c[K>>2]|0)?1:0)|0;while(0);if(c[o>>2]|0)break a;else continue a}if((c[c[C>>2]>>2]|0)<=0)continue a;if(!(c[B>>2]|0)){c[B>>2]=c[C>>2];c[C>>2]=0;continue a}else{c[B>>2]=vb[c[O>>2]&511](c[B>>2]|0,c[C>>2]|0,0)|0;continue a}break}}if(!(c[B>>2]|0)){c[B>>2]=c[C>>2];c[C>>2]=0}else c[B>>2]=vb[c[O>>2]&511](c[B>>2]|0,c[C>>2]|0,0)|0;if(c[o>>2]|0)break}do if((V|0)==41)c[v>>2]=0;else if((V|0)==55){c[v>>2]=0;o=c[33976]|0;K=c[33980]|0;c[h>>2]=128552;c[h+4>>2]=12379;Db[o&511](K,129448,h)}else if((V|0)==208)if(!(c[B>>2]|0)){c[B>>2]=c[C>>2];c[C>>2]=0;break}else{c[B>>2]=vb[c[O>>2]&511](c[B>>2]|0,c[C>>2]|0,0)|0;break}else if((V|0)==218)c[v>>2]=0;while(0);if((c[(c[x>>2]|0)+8>>2]|0)!=0?(c[(c[x>>2]|0)+28>>2]|0)!=0:0){c[(c[(c[k>>2]|0)+16>>2]|0)+8>>2]=1;c[(c[(c[k>>2]|0)+16>>2]|0)+28>>2]=c[(c[x>>2]|0)+28>>2];c[(c[x>>2]|0)+28>>2]=0;c[(c[x>>2]|0)+8>>2]=0}jt(c[Q>>2]|0,c[x>>2]|0);do if(!(c[B>>2]|0)){if((c[C>>2]|0)!=0?(c[c[C>>2]>>2]|0)==0:0){c[B>>2]=c[C>>2];break}c[B>>2]=$q(0)|0}while(0);if((c[C>>2]|0)!=0?(c[C>>2]|0)!=(c[B>>2]|0):0)fr(c[C>>2]|0);C=c[k>>2]|0;Tq(C,At(c[Q>>2]|0,c[B>>2]|0)|0)|0;c[(c[Q>>2]|0)+4>>2]=c[P>>2];c[j>>2]=c[v>>2];T=c[j>>2]|0;i=g;return T|0}jt(c[Q>>2]|0,c[x>>2]|0);x=c[k>>2]|0;Tq(x,At(c[Q>>2]|0,0)|0)|0;c[j>>2]=0;T=c[j>>2]|0;i=g;return T|0}Nq(c[k>>2]|0,11);c[j>>2]=0;T=c[j>>2]|0;i=g;return T|0}function ou(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if(!(c[e>>2]|0)){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{c[f>>2]=c[(c[e>>2]|0)+44>>2];c[(c[e>>2]|0)+44>>2]=c[(c[e>>2]|0)+20>>2];c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function pu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}if((c[(c[e>>2]|0)+20>>2]|0)<(c[(c[e>>2]|0)+44>>2]|0))Oq(c[e>>2]|0,128552,2808,23);c[(c[e>>2]|0)+44>>2]=c[f>>2];i=d;return}function qu(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+48|0;f=e+32|0;g=e+28|0;h=e+24|0;j=e+20|0;k=e+16|0;l=e+12|0;m=e+8|0;n=e+4|0;o=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=0;if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}c[m>>2]=c[(c[g>>2]|0)+32>>2];do switch(c[c[h>>2]>>2]|0){case 0:{c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}case 12:{Tq(c[g>>2]|0,lt(c[(c[g>>2]|0)+12>>2]|0,c[(c[h>>2]|0)+24>>2]|0)|0)|0;c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}case 7:{c[k>>2]=qu(c[g>>2]|0,(c[(c[m>>2]|0)+8>>2]|0)+((c[(c[h>>2]|0)+4>>2]|0)*40|0)|0,c[j>>2]|0)|0;if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}if((((c[(c[g>>2]|0)+16>>2]|0)!=0?(c[c[(c[g>>2]|0)+16>>2]>>2]|0)==1:0)?(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]|0)!=0:0)?(c[c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]>>2]|0)>=1:0){if((c[c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]>>2]|0)>1)Zq(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]|0);c[c[j>>2]>>2]=c[c[(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]|0)+8>>2]>>2]}c[l>>2]=qu(c[g>>2]|0,(c[(c[m>>2]|0)+8>>2]|0)+((c[(c[h>>2]|0)+8>>2]|0)*40|0)|0,c[j>>2]|0)|0;if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}if((c[(c[g>>2]|0)+16>>2]|0)!=0?(c[c[(c[g>>2]|0)+16>>2]>>2]|0)==1:0){c[o>>2]=Sq(c[g>>2]|0)|0;if((c[(c[g>>2]|0)+16>>2]|0)!=0?(c[c[(c[g>>2]|0)+16>>2]>>2]|0)==1:0){c[n>>2]=Sq(c[g>>2]|0)|0;d=er(c[(c[n>>2]|0)+4>>2]|0,c[(c[o>>2]|0)+4>>2]|0)|0;c[(c[n>>2]|0)+4>>2]=d;Tq(c[g>>2]|0,c[n>>2]|0)|0;jt(c[(c[g>>2]|0)+12>>2]|0,c[o>>2]|0);if((c[k>>2]|0)>(c[l>>2]|0))Bu(c[h>>2]|0);c[f>>2]=(c[k>>2]|0)+(c[l>>2]|0);p=c[f>>2]|0;i=e;return p|0}Nq(c[g>>2]|0,11);c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}Nq(c[g>>2]|0,11);c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}case 10:{if((c[(c[h>>2]|0)+4>>2]|0)!=-1){d=iu(c[g>>2]|0,(c[(c[m>>2]|0)+8>>2]|0)+((c[(c[h>>2]|0)+4>>2]|0)*40|0)|0)|0;c[k>>2]=(c[k>>2]|0)+d}if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}if((c[(c[h>>2]|0)+8>>2]|0)!=-1){d=iu(c[g>>2]|0,(c[(c[m>>2]|0)+8>>2]|0)+((c[(c[h>>2]|0)+8>>2]|0)*40|0)|0)|0;c[k>>2]=(c[k>>2]|0)+d}if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}else{c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=0;c[f>>2]=c[k>>2];p=c[f>>2]|0;i=e;return p|0}break}case 18:{if((c[(c[h>>2]|0)+4>>2]|0)!=-1){d=qu(c[g>>2]|0,(c[(c[m>>2]|0)+8>>2]|0)+((c[(c[h>>2]|0)+4>>2]|0)*40|0)|0,c[j>>2]|0)|0;c[k>>2]=(c[k>>2]|0)+d}if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}if((((c[(c[g>>2]|0)+16>>2]|0)!=0?(c[c[(c[g>>2]|0)+16>>2]>>2]|0)==1:0)?(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]|0)!=0:0)?(c[c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]>>2]|0)>1:0)Zq(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]|0);c[f>>2]=c[k>>2];p=c[f>>2]|0;i=e;return p|0}case 9:{if((c[(c[h>>2]|0)+4>>2]|0)!=-1){
d=iu(c[g>>2]|0,(c[(c[m>>2]|0)+8>>2]|0)+((c[(c[h>>2]|0)+4>>2]|0)*40|0)|0)|0;c[k>>2]=(c[k>>2]|0)+d}if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}if((c[(c[h>>2]|0)+8>>2]|0)!=-1){d=iu(c[g>>2]|0,(c[(c[m>>2]|0)+8>>2]|0)+((c[(c[h>>2]|0)+8>>2]|0)*40|0)|0)|0;c[k>>2]=(c[k>>2]|0)+d}if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}else{d=c[g>>2]|0;Tq(d,yt(c[(c[g>>2]|0)+12>>2]|0,c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]|0)|0)|0;c[f>>2]=c[k>>2];p=c[f>>2]|0;i=e;return p|0}break}case 11:{if((c[(c[h>>2]|0)+4>>2]|0)==-1){c[f>>2]=c[k>>2];p=c[f>>2]|0;i=e;return p|0}c[k>>2]=iu(c[g>>2]|0,(c[(c[m>>2]|0)+8>>2]|0)+((c[(c[h>>2]|0)+4>>2]|0)*40|0)|0)|0;if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}else{d=nu(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0,0,0)|0;c[k>>2]=(c[k>>2]|0)+d;c[f>>2]=c[k>>2];p=c[f>>2]|0;i=e;return p|0}break}case 8:{ks(c[g>>2]|0);c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}case 17:{c[k>>2]=(Cu(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0)|0)+(c[k>>2]|0);c[f>>2]=c[k>>2];p=c[f>>2]|0;i=e;return p|0}default:{c[f>>2]=iu(c[g>>2]|0,c[h>>2]|0)|0;p=c[f>>2]|0;i=e;return p|0}}while(0);return 0}function ru(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+64|0;f=e+48|0;g=e+44|0;h=e+40|0;j=e+36|0;k=e+32|0;l=e+28|0;m=e+24|0;n=e+20|0;o=e+16|0;p=e+12|0;q=e+8|0;r=e+4|0;s=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=0;if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}c[m>>2]=c[(c[g>>2]|0)+32>>2];switch(c[c[h>>2]>>2]|0){case 0:{c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}case 11:{if((c[(c[h>>2]|0)+4>>2]|0)==-1){c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}c[k>>2]=(iu(c[g>>2]|0,(c[(c[m>>2]|0)+8>>2]|0)+((c[(c[h>>2]|0)+4>>2]|0)*40|0)|0)|0)+(c[k>>2]|0);if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}else{d=nu(c[g>>2]|0,c[h>>2]|0,0,c[j>>2]|0,0)|0;c[k>>2]=(c[k>>2]|0)+d;c[f>>2]=c[k>>2];t=c[f>>2]|0;i=e;return t|0}break}case 7:{c[q>>2]=c[c[(c[g>>2]|0)+12>>2]>>2];c[p>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2];c[r>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+72>>2];c[s>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2];c[k>>2]=ru(c[g>>2]|0,(c[(c[m>>2]|0)+8>>2]|0)+((c[(c[h>>2]|0)+4>>2]|0)*40|0)|0,c[j>>2]|0)|0;if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}if((((c[(c[g>>2]|0)+16>>2]|0)!=0?(c[c[(c[g>>2]|0)+16>>2]>>2]|0)==1:0)?(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]|0)!=0:0)?(c[c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]>>2]|0)>=1:0){if((c[c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]>>2]|0)>1)Zq(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]|0);c[c[j>>2]>>2]=c[(c[(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]|0)+8>>2]|0)+((c[c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]>>2]|0)-1<<2)>>2]}c[c[(c[g>>2]|0)+12>>2]>>2]=c[q>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=c[p>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+72>>2]=c[r>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2]=c[s>>2];c[l>>2]=ru(c[g>>2]|0,(c[(c[m>>2]|0)+8>>2]|0)+((c[(c[h>>2]|0)+8>>2]|0)*40|0)|0,c[j>>2]|0)|0;if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}if((c[(c[g>>2]|0)+16>>2]|0)!=0?(c[c[(c[g>>2]|0)+16>>2]>>2]|0)==1:0){c[o>>2]=Sq(c[g>>2]|0)|0;if((c[(c[g>>2]|0)+16>>2]|0)!=0?(c[c[(c[g>>2]|0)+16>>2]>>2]|0)==1:0){c[n>>2]=Sq(c[g>>2]|0)|0;s=er(c[(c[n>>2]|0)+4>>2]|0,c[(c[o>>2]|0)+4>>2]|0)|0;c[(c[n>>2]|0)+4>>2]=s;Tq(c[g>>2]|0,c[n>>2]|0)|0;jt(c[(c[g>>2]|0)+12>>2]|0,c[o>>2]|0);if((c[k>>2]|0)>(c[l>>2]|0))Bu(c[h>>2]|0);c[f>>2]=(c[k>>2]|0)+(c[l>>2]|0);t=c[f>>2]|0;i=e;return t|0}Nq(c[g>>2]|0,11);c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}Nq(c[g>>2]|0,11);c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}case 10:{if((c[(c[h>>2]|0)+4>>2]|0)!=-1){l=iu(c[g>>2]|0,(c[(c[m>>2]|0)+8>>2]|0)+((c[(c[h>>2]|0)+4>>2]|0)*40|0)|0)|0;c[k>>2]=(c[k>>2]|0)+l}if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}if((c[(c[h>>2]|0)+8>>2]|0)!=-1){l=iu(c[g>>2]|0,(c[(c[m>>2]|0)+8>>2]|0)+((c[(c[h>>2]|0)+8>>2]|0)*40|0)|0)|0;c[k>>2]=(c[k>>2]|0)+l}if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}else{c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=0;c[f>>2]=c[k>>2];t=c[f>>2]|0;i=e;return t|0}break}case 9:{if((c[(c[h>>2]|0)+4>>2]|0)!=-1){l=iu(c[g>>2]|0,(c[(c[m>>2]|0)+8>>2]|0)+((c[(c[h>>2]|0)+4>>2]|0)*40|0)|0)|0;c[k>>2]=(c[k>>2]|0)+l}if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}if((c[(c[h>>2]|0)+8>>2]|0)!=-1){l=iu(c[g>>2]|0,(c[(c[m>>2]|0)+8>>2]|0)+((c[(c[h>>2]|0)+8>>2]|0)*40|0)|0)|0;c[k>>2]=(c[k>>2]|0)+l}if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}else{l=c[g>>2]|0;Tq(l,yt(c[(c[g>>2]|0)+12>>2]|0,c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]|0)|0)|0;c[f>>2]=c[k>>2];t=c[f>>2]|0;i=e;return t|0}break}case 8:{ks(c[g>>2]|0);c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}case 12:{Tq(c[g>>2]|0,lt(c[(c[g>>2]|0)+12>>2]|0,c[(c[h>>2]|0)+24>>2]|0)|0)|0;c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}case 18:{if((c[(c[h>>2]|0)+4>>2]|0)!=-1){l=ru(c[g>>2]|0,(c[(c[m>>2]|0)+8>>2]|0)+((c[(c[h>>2]|0)+4>>2]|0)*40|0)|0,c[j>>2]|0)|0;c[k>>2]=(c[k>>2]|0)+l}if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}if((((c[(c[g>>2]|0)+16>>2]|0)!=0?(c[c[(c[g>>2]|0)+16>>2]>>2]|0)==1:0)?(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]|0)!=0:0)?(c[c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]>>2]|0)>1:0)Zq(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]|0);c[f>>2]=c[k>>2];t=c[f>>2]|0;i=e;return t|0}default:{c[f>>2]=iu(c[g>>2]|0,c[h>>2]|0)|0;t=c[f>>2]|0;i=e;return t|0}}return 0}function su(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}if((c[c[e>>2]>>2]|0)<=0){i=d;return}a:do if(c[f>>2]|0){c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[c[e>>2]>>2]|0))break a;c[h>>2]=c[(c[(c[e>>2]|0)+8>>2]|0)+(c[g>>2]<<2)>>2];if((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+4>>2]|0)==18:0)_q(c[h>>2]|0);c[g>>2]=(c[g>>2]|0)+1}}while(0);c[c[e>>2]>>2]=0;i=d;return}function tu(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[e>>2]=a;Du(c[e>>2]|0);if(c[(c[e>>2]|0)+8>>2]|0){i=b;return}a:while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[e>>2]>>2]>>0]|0|0)!=13)break a}while(0);a=c[e>>2]|0;if(!(d[c[c[e>>2]>>2]>>0]|0))continue;c[a>>2]=(c[a>>2]|0)+1}b:while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)!=60?(d[c[c[e>>2]>>2]>>0]|0|0)!=62:0){if((d[c[c[e>>2]>>2]>>0]|0|0)==60?(d[(c[c[e>>2]>>2]|0)+1>>0]|0|0)==61:0)break;if((d[c[c[e>>2]>>2]>>0]|0|0)!=62){j=40;break b}if((d[(c[c[e>>2]>>2]|0)+1>>0]|0|0)!=61){j=40;break b}}while(0);c[h>>2]=c[(c[(c[e>>2]|0)+32>>2]|0)+12>>2];if((d[c[c[e>>2]>>2]>>0]|0|0)==60)c[f>>2]=1;else c[f>>2]=0;if((d[(c[c[e>>2]>>2]|0)+1>>0]|0|0)==61)c[g>>2]=0;else c[g>>2]=1;a=c[e>>2]|0;if(d[c[c[e>>2]>>2]>>0]|0)c[a>>2]=(c[a>>2]|0)+1;if((c[g>>2]|0)==0?(a=c[e>>2]|0,(d[c[c[e>>2]>>2]>>0]|0|0)!=0):0)c[a>>2]=(c[a>>2]|0)+1;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)k=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){k=1;break}k=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);l=c[e>>2]|0;if(!k)break;a=c[e>>2]|0;if(!(d[c[l>>2]>>0]|0))continue;c[a>>2]=(c[a>>2]|0)+1}Du(l);if(c[(c[e>>2]|0)+8>>2]|0){j=40;break}du(c[(c[e>>2]|0)+32>>2]|0,c[h>>2]|0,c[(c[(c[e>>2]|0)+32>>2]|0)+12>>2]|0,4,c[f>>2]|0,c[g>>2]|0,0,0,0)|0;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[e>>2]>>2]>>0]|0|0)!=13)continue b}while(0);a=c[e>>2]|0;if(!(d[c[c[e>>2]>>2]>>0]|0))continue;c[a>>2]=(c[a>>2]|0)+1}}if((j|0)==40){i=b;return}}function uu(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+48|0;f=e+40|0;g=e+36|0;h=e+32|0;j=e+28|0;k=e+24|0;l=e+20|0;m=e+16|0;n=e+12|0;o=e+8|0;p=e+4|0;q=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;a:do if((c[g>>2]|0)==0&(c[j>>2]|0)==0){c[g>>2]=Eu(c[c[h>>2]>>2]|0)|0;if(!(c[g>>2]|0)){c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}else{if(!(c[c[h>>2]>>2]|0))break;eU(c[(c[g>>2]|0)+8>>2]|0,c[(c[h>>2]|0)+8>>2]|0,c[c[h>>2]>>2]<<2|0)|0;c[c[g>>2]>>2]=c[c[h>>2]>>2];break}}else{if(!(c[g>>2]|0))c[g>>2]=$q(0)|0;if(!(c[g>>2]|0)){c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}c[m>>2]=c[c[g>>2]>>2];c[k>>2]=0;b:while(1){if((c[k>>2]|0)>=(c[c[h>>2]>>2]|0))break a;c[o>>2]=c[(c[(c[h>>2]|0)+8>>2]|0)+(c[k>>2]<<2)>>2];c:do if(c[o>>2]|0){c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[m>>2]|0))break;c[n>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+(c[l>>2]<<2)>>2];if((c[n>>2]|0)==(c[o>>2]|0))break c;if((((c[(c[n>>2]|0)+4>>2]|0)==18?(c[(c[o>>2]|0)+4>>2]|0)==18:0)?(c[c[n>>2]>>2]|0)==(c[c[o>>2]>>2]|0):0)?(qy(c[(c[n>>2]|0)+12>>2]|0,c[(c[o>>2]|0)+12>>2]|0)|0)!=0:0){s=20;break}c[l>>2]=(c[l>>2]|0)+1}if((s|0)==20){s=0;c[(c[(c[h>>2]|0)+8>>2]|0)+(c[k>>2]<<2)>>2]=0;_q(c[o>>2]|0);break}if(c[(c[g>>2]|0)+4>>2]|0){if((c[c[g>>2]>>2]|0)>=(c[(c[g>>2]|0)+4>>2]|0)){if((c[(c[g>>2]|0)+4>>2]|0)>=1e7){s=28;break b}c[p>>2]=Hb[c[135760>>2]&511](c[(c[g>>2]|0)+8>>2]|0,c[(c[g>>2]|0)+4>>2]<<1<<2)|0;if(!(c[p>>2]|0)){s=30;break b}c[(c[g>>2]|0)+8>>2]=c[p>>2];d=(c[g>>2]|0)+4|0;c[d>>2]=c[d>>2]<<1}}else{d=Cb[c[135744>>2]&511](40)|0;c[(c[g>>2]|0)+8>>2]=d;if(!(c[(c[g>>2]|0)+8>>2]|0)){s=24;break b}d=(c[(c[g>>2]|0)+8>>2]|0)+0|0;b=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(b|0));c[(c[g>>2]|0)+4>>2]=10}d=c[o>>2]|0;if((c[(c[o>>2]|0)+4>>2]|0)==18){c[q>>2]=d;b=kt(c[c[q>>2]>>2]|0,c[q>>2]|0)|0;a=c[g>>2]|0;t=c[a>>2]|0;c[a>>2]=t+1;c[(c[(c[g>>2]|0)+8>>2]|0)+(t<<2)>>2]=b;break}else{b=c[g>>2]|0;t=c[b>>2]|0;c[b>>2]=t+1;c[(c[(c[g>>2]|0)+8>>2]|0)+(t<<2)>>2]=d;break}}while(0);c[k>>2]=(c[k>>2]|0)+1}if((s|0)==24){it(0,128712);c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}else if((s|0)==28){it(0,128736);c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}else if((s|0)==30){it(0,128712);c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}}while(0);c[c[h>>2]>>2]=0;c[f>>2]=c[g>>2];r=c[f>>2]|0;i=e;return r|0}function vu(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;d=c[g>>2]|0;if(!(c[h>>2]|0)){c[f>>2]=d;n=c[f>>2]|0;i=e;return n|0}a:do if((d|0)==0&(c[j>>2]|0)==0){c[g>>2]=Eu(c[c[h>>2]>>2]|0)|0;if(!(c[g>>2]|0)){c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}else{if(!(c[c[h>>2]>>2]|0))break;eU(c[(c[g>>2]|0)+8>>2]|0,c[(c[h>>2]|0)+8>>2]|0,c[c[h>>2]>>2]<<2|0)|0;c[c[g>>2]>>2]=c[c[h>>2]>>2];break}}else{if(!(c[g>>2]|0))c[g>>2]=$q(0)|0;if(!(c[g>>2]|0)){c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[c[h>>2]>>2]|0))break a;c[l>>2]=c[(c[(c[h>>2]|0)+8>>2]|0)+(c[k>>2]<<2)>>2];if(c[l>>2]|0){if(c[(c[g>>2]|0)+4>>2]|0){if((c[c[g>>2]>>2]|0)>=(c[(c[g>>2]|0)+4>>2]|0)){if((c[(c[g>>2]|0)+4>>2]|0)>=1e7){o=21;break}c[m>>2]=Hb[c[135760>>2]&511](c[(c[g>>2]|0)+8>>2]|0,c[(c[g>>2]|0)+4>>2]<<1<<2)|0;if(!(c[m>>2]|0)){o=23;break}c[(c[g>>2]|0)+8>>2]=c[m>>2];b=(c[g>>2]|0)+4|0;c[b>>2]=c[b>>2]<<1}}else{b=Cb[c[135744>>2]&511](40)|0;c[(c[g>>2]|0)+8>>2]=b;if(!(c[(c[g>>2]|0)+8>>2]|0)){o=17;break}b=(c[(c[g>>2]|0)+8>>2]|0)+0|0;a=b+40|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(a|0));c[(c[g>>2]|0)+4>>2]=10}b=c[l>>2]|0;a=c[g>>2]|0;p=c[a>>2]|0;c[a>>2]=p+1;c[(c[(c[g>>2]|0)+8>>2]|0)+(p<<2)>>2]=b}c[k>>2]=(c[k>>2]|0)+1}if((o|0)==17){it(0,128712);c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}else if((o|0)==21){it(0,128736);c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}else if((o|0)==23){it(0,128712);c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}}while(0);c[c[h>>2]>>2]=0;c[f>>2]=c[g>>2];n=c[f>>2]|0;i=e;return n|0}function wu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;a:do if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+12>>2]|0)!=0:0){if(c[g>>2]|0){switch(c[(c[g>>2]|0)+4>>2]|0){case 20:case 8:case 7:case 4:case 6:case 5:case 3:case 1:break;default:{c[e>>2]=0;break a}}if(!(c[(c[g>>2]|0)+24>>2]|0)){c[e>>2]=0;break}b=c[(c[g>>2]|0)+24>>2]|0;if((c[(c[(c[g>>2]|0)+24>>2]|0)+4>>2]|0)==1){c[e>>2]=b;break}c[g>>2]=b;do{c[g>>2]=c[(c[g>>2]|0)+24>>2];if(!(c[g>>2]|0))break}while((c[(c[g>>2]|0)+4>>2]|0)!=1);c[e>>2]=c[g>>2];break}c[g>>2]=c[(c[(c[f>>2]|0)+12>>2]|0)+4>>2];if(!(c[g>>2]|0)){c[e>>2]=0;break}switch(c[(c[g>>2]|0)+4>>2]|0){case 21:case 13:case 9:{c[e>>2]=Pi(c[g>>2]|0)|0;break a;break}case 6:case 5:case 11:case 1:{c[g>>2]=c[(c[g>>2]|0)+12>>2];if(!(c[g>>2]|0)){c[e>>2]=0;break a}if((c[(c[g>>2]|0)+4>>2]|0)==1){c[e>>2]=c[g>>2];break a}do{c[g>>2]=c[(c[g>>2]|0)+24>>2];if(!(c[g>>2]|0))break}while((c[(c[g>>2]|0)+4>>2]|0)!=1);c[e>>2]=c[g>>2];break a;break}default:{c[e>>2]=0;break a}}}else h=3;while(0);if((h|0)==3)c[e>>2]=0;i=d;return c[e>>2]|0}function xu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+12>>2]|0)!=0:0){do if(!(c[g>>2]|0)){c[g>>2]=c[(c[(c[f>>2]|0)+12>>2]|0)+4>>2];if(!(c[g>>2]|0)){c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}if((c[(c[g>>2]|0)+4>>2]|0)!=18){c[(c[f>>2]|0)+40>>2]=c[(c[g>>2]|0)+20>>2];break}c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}while(0);if((c[(c[g>>2]|0)+4>>2]|0)==18){c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}if((c[(c[g>>2]|0)+28>>2]|0)!=0?(c[(c[(c[g>>2]|0)+28>>2]|0)+4>>2]|0)==14:0)c[g>>2]=c[(c[g>>2]|0)+28>>2];while(1){j=c[g>>2]|0;if(c[(c[g>>2]|0)+28>>2]|0){k=23;break}c[g>>2]=c[j+20>>2];if(!(c[g>>2]|0)){k=17;break}if((c[g>>2]|0)==(c[(c[c[(c[f>>2]|0)+12>>2]>>2]|0)+12>>2]|0)){k=19;break}l=c[g>>2]|0;if((c[g>>2]|0)!=(c[(c[f>>2]|0)+40>>2]|0)){k=21;break}c[(c[f>>2]|0)+40>>2]=c[l+20>>2]}if((k|0)==17){c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}else if((k|0)==19){c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}else if((k|0)==21){c[e>>2]=l;h=c[e>>2]|0;i=d;return h|0}else if((k|0)==23){c[g>>2]=c[j+28>>2];while(1){m=c[g>>2]|0;if(!(c[(c[g>>2]|0)+16>>2]|0))break;c[g>>2]=c[m+16>>2]}c[e>>2]=m;h=c[e>>2]|0;i=d;return h|0}}c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}function yu(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;if((c[c[j>>2]>>2]|0)!=16?(c[c[j>>2]>>2]|0)!=17:0){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}if((c[(c[j>>2]|0)+8>>2]|0)==-1){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}c[l>>2]=(c[(c[(c[g>>2]|0)+32>>2]|0)+8>>2]|0)+((c[(c[j>>2]|0)+8>>2]|0)*40|0);if(((((c[l>>2]|0)!=0?(c[c[l>>2]>>2]|0)==12:0)?(c[(c[l>>2]|0)+24>>2]|0)!=0:0)?(c[c[(c[l>>2]|0)+24>>2]>>2]|0)==3:0)?(c[c[k>>2]>>2]=~~+h[(c[(c[l>>2]|0)+24>>2]|0)+16>>3],+h[(c[(c[l>>2]|0)+24>>2]|0)+16>>3]==+(c[c[k>>2]>>2]|0)):0){c[f>>2]=1;m=c[f>>2]|0;i=e;return m|0}c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}function zu(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;j=i;i=i+96|0;k=j+88|0;l=j+84|0;m=j+80|0;n=j+76|0;o=j+72|0;p=j+68|0;q=j+64|0;r=j+60|0;s=j+56|0;t=j+52|0;u=j+48|0;v=j+44|0;w=j+40|0;x=j+36|0;y=j+32|0;z=j+28|0;A=j+24|0;B=j+20|0;C=j+16|0;D=j+12|0;E=j+8|0;F=j+4|0;G=j;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;c[r>>2]=h;if((c[(c[m>>2]|0)+4>>2]|0)!=-1){c[s>>2]=c[(c[l>>2]|0)+32>>2];c[o>>2]=Au(c[l>>2]|0,(c[(c[s>>2]|0)+8>>2]|0)+((c[(c[m>>2]|0)+4>>2]|0)*40|0)|0,c[n>>2]|0,c[o>>2]|0,c[r>>2]|0)|0;if(c[(c[l>>2]|0)+8>>2]|0){c[k>>2]=0;H=c[k>>2]|0;i=j;return H|0}if((c[o>>2]|0)<=0){c[k>>2]=0;H=c[k>>2]|0;i=j;return H|0}}if((c[o>>2]|0)<(c[p>>2]|0)){su(c[n>>2]|0,c[r>>2]|0);c[k>>2]=0;H=c[k>>2]|0;i=j;return H|0}if((c[(c[m>>2]|0)+8>>2]|0)==-1){c[k>>2]=c[o>>2];H=c[k>>2]|0;i=j;return H|0}c[v>>2]=0;c[w>>2]=0;c[x>>2]=0;c[A>>2]=0;c[B>>2]=0;c[D>>2]=0;c[E>>2]=c[(c[l>>2]|0)+12>>2];c[C>>2]=c[(c[E>>2]|0)+4>>2];c[t>>2]=c[c[E>>2]>>2];c[z>>2]=(c[(c[(c[l>>2]|0)+32>>2]|0)+8>>2]|0)+((c[(c[m>>2]|0)+8>>2]|0)*40|0);c[u>>2]=0;a:while(1){if((c[u>>2]|0)>=(c[c[n>>2]>>2]|0))break;do if(c[(c[(c[n>>2]|0)+8>>2]|0)+(c[u>>2]<<2)>>2]|0){c[D>>2]=c[(c[(c[n>>2]|0)+8>>2]|0)+(c[u>>2]<<2)>>2];c[(c[E>>2]|0)+4>>2]=c[D>>2];c[(c[E>>2]|0)+68>>2]=c[o>>2];m=(c[x>>2]|0)+1|0;c[x>>2]=m;c[(c[E>>2]|0)+72>>2]=m;if((c[(c[D>>2]|0)+4>>2]|0)!=18?(c[(c[D>>2]|0)+32>>2]|0)!=0:0)c[c[E>>2]>>2]=c[(c[D>>2]|0)+32>>2];if(c[A>>2]|0){if((dr(c[(c[A>>2]|0)+4>>2]|0,c[D>>2]|0)|0)<0){I=19;break a}}else c[A>>2]=yt(c[E>>2]|0,c[D>>2]|0)|0;c[F>>2]=ou(c[l>>2]|0)|0;Tq(c[l>>2]|0,c[A>>2]|0)|0;c[y>>2]=hu(c[l>>2]|0,c[z>>2]|0,1)|0;c[G>>2]=Sq(c[l>>2]|0)|0;pu(c[l>>2]|0,c[F>>2]|0);if((c[y>>2]|0)==-1?1:(c[(c[l>>2]|0)+8>>2]|0)!=0){I=21;break a}Tq(c[l>>2]|0,c[G>>2]|0)|0;if(c[y>>2]|0)c[v>>2]=(c[v>>2]|0)+1;if(((c[y>>2]|0)!=0?(c[v>>2]|0)>=(c[p>>2]|0):0)?(c[v>>2]|0)<=(c[q>>2]|0):0){c[w>>2]=(c[w>>2]|0)+1;if((c[p>>2]|0)==(c[q>>2]|0)){I=29;break a}if((c[v>>2]|0)==(c[q>>2]|0)){I=33;break a}}else I=34;if((I|0)==34?(I=0,c[(c[(c[n>>2]|0)+8>>2]|0)+(c[u>>2]<<2)>>2]=0,(c[(c[D>>2]|0)+4>>2]|0)==18):0)_q(c[D>>2]|0);if(c[B>>2]|0){jt(c[(c[l>>2]|0)+12>>2]|0,c[B>>2]|0);c[B>>2]=0}if((c[(c[l>>2]|0)+16>>2]|0)==(c[A>>2]|0)){Sq(c[l>>2]|0)|0;su(c[(c[A>>2]|0)+4>>2]|0,c[r>>2]|0);break}else{c[A>>2]=0;break}}while(0);c[u>>2]=(c[u>>2]|0)+1}if((I|0)==19)c[(c[l>>2]|0)+8>>2]=15;else if((I|0)==21){while(1){I=0;if((c[G>>2]|0)==(c[A>>2]|0))break;jt(c[E>>2]|0,c[G>>2]|0);c[G>>2]=Sq(c[l>>2]|0)|0;I=21}su(c[n>>2]|0,c[r>>2]|0);c[w>>2]=0}else if((I|0)==29){if((c[(c[D>>2]|0)+4>>2]|0)==18)c[(c[(c[n>>2]|0)+8>>2]|0)+(c[u>>2]<<2)>>2]=0;su(c[n>>2]|0,c[r>>2]|0);c[c[n>>2]>>2]=1;c[c[(c[n>>2]|0)+8>>2]>>2]=c[D>>2]}else if((I|0)==33)Fu(c[n>>2]|0,(c[u>>2]|0)+1|0,c[r>>2]|0);if(c[A>>2]|0){if((c[(c[l>>2]|0)+16>>2]|0)==(c[A>>2]|0))Sq(c[l>>2]|0)|0;jt(c[E>>2]|0,c[A>>2]|0)}if(c[B>>2]|0)jt(c[(c[l>>2]|0)+12>>2]|0,c[B>>2]|0);c[(c[E>>2]|0)+4>>2]=c[C>>2];c[c[E>>2]>>2]=c[t>>2];c[(c[E>>2]|0)+68>>2]=-1;c[(c[E>>2]|0)+72>>2]=-1;c[k>>2]=c[w>>2];H=c[k>>2]|0;i=j;return H|0}function Au(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;i=i+80|0;h=g+68|0;j=g+64|0;k=g+60|0;l=g+56|0;m=g+52|0;n=g+48|0;o=g+44|0;p=g+40|0;q=g+36|0;r=g+32|0;s=g+28|0;t=g+24|0;u=g+20|0;v=g+16|0;w=g+12|0;x=g+8|0;y=g+4|0;z=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;if((c[(c[k>>2]|0)+4>>2]|0)!=-1){c[o>>2]=c[(c[j>>2]|0)+32>>2];c[m>>2]=Au(c[j>>2]|0,(c[(c[o>>2]|0)+8>>2]|0)+((c[(c[k>>2]|0)+4>>2]|0)*40|0)|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0)|0;if(c[(c[j>>2]|0)+8>>2]|0){c[h>>2]=0;A=c[h>>2]|0;i=g;return A|0}if((c[m>>2]|0)<=0){c[h>>2]=0;A=c[h>>2]|0;i=g;return A|0}}if((c[(c[k>>2]|0)+8>>2]|0)==-1){c[h>>2]=c[m>>2];A=c[h>>2]|0;i=g;return A|0}c[p>>2]=c[(c[j>>2]|0)+12>>2];c[v>>2]=0;c[y>>2]=0;c[z>>2]=0;c[r>>2]=c[(c[p>>2]|0)+4>>2];c[s>>2]=c[c[p>>2]>>2];c[x>>2]=(c[(c[(c[j>>2]|0)+32>>2]|0)+8>>2]|0)+((c[(c[k>>2]|0)+8>>2]|0)*40|0);c[w>>2]=0;c[t>>2]=0;a:while(1){if((c[t>>2]|0)>=(c[c[l>>2]>>2]|0)){B=27;break}do if(c[(c[(c[l>>2]|0)+8>>2]|0)+(c[t>>2]<<2)>>2]|0){c[q>>2]=c[(c[(c[l>>2]|0)+8>>2]|0)+(c[t>>2]<<2)>>2];c[(c[p>>2]|0)+4>>2]=c[q>>2];c[(c[p>>2]|0)+68>>2]=c[m>>2];k=(c[v>>2]|0)+1|0;c[v>>2]=k;c[(c[p>>2]|0)+72>>2]=k;if((c[(c[q>>2]|0)+4>>2]|0)!=18?(c[(c[q>>2]|0)+32>>2]|0)!=0:0)c[c[p>>2]>>2]=c[(c[q>>2]|0)+32>>2];if(c[y>>2]|0){if((dr(c[(c[y>>2]|0)+4>>2]|0,c[q>>2]|0)|0)<0){B=16;break a}}else c[y>>2]=yt(c[p>>2]|0,c[q>>2]|0)|0;Tq(c[j>>2]|0,c[y>>2]|0)|0;c[u>>2]=hu(c[j>>2]|0,c[x>>2]|0,1)|0;if((c[u>>2]|0)==-1?1:(c[(c[j>>2]|0)+8>>2]|0)!=0){B=18;break a}if(!(c[u>>2]|0)){c[(c[(c[l>>2]|0)+8>>2]|0)+(c[t>>2]<<2)>>2]=0;if((c[(c[q>>2]|0)+4>>2]|0)==18)_q(c[q>>2]|0)}else c[w>>2]=(c[w>>2]|0)+1;if((c[(c[j>>2]|0)+16>>2]|0)==(c[y>>2]|0)){Sq(c[j>>2]|0)|0;su(c[(c[y>>2]|0)+4>>2]|0,c[n>>2]|0);break}else{c[y>>2]=0;break}}while(0);c[t>>2]=(c[t>>2]|0)+1}if((B|0)==16)c[(c[j>>2]|0)+8>>2]=15;else if((B|0)==18){su(c[l>>2]|0,c[n>>2]|0);c[w>>2]=0}else if((B|0)==27?(c[y>>2]|0)!=0:0){if((c[(c[j>>2]|0)+16>>2]|0)==(c[y>>2]|0))Sq(c[j>>2]|0)|0;jt(c[p>>2]|0,c[y>>2]|0)}if(c[z>>2]|0)jt(c[(c[j>>2]|0)+12>>2]|0,c[z>>2]|0);c[(c[p>>2]|0)+4>>2]=c[r>>2];c[c[p>>2]>>2]=c[s>>2];c[(c[p>>2]|0)+68>>2]=-1;c[(c[p>>2]|0)+72>>2]=-1;c[h>>2]=c[w>>2];A=c[h>>2]|0;i=g;return A|0}function Bu(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;if(c[32574]|0){i=b;return}c[e>>2]=c[(c[d>>2]|0)+4>>2];c[(c[d>>2]|0)+4>>2]=c[(c[d>>2]|0)+8>>2];c[(c[d>>2]|0)+8>>2]=c[e>>2];i=b;return}function Cu(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+80|0;f=e+72|0;g=e+68|0;h=e+64|0;j=e+60|0;k=e+56|0;l=e+52|0;m=e+48|0;n=e+44|0;o=e+40|0;p=e+36|0;q=e+32|0;r=e+28|0;s=e+24|0;t=e+20|0;u=e+16|0;v=e+12|0;w=e+8|0;x=e+4|0;y=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=0;if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;z=c[f>>2]|0;i=e;return z|0}c[l>>2]=c[(c[g>>2]|0)+32>>2];if((((((((((c[(c[h>>2]|0)+4>>2]|0)!=-1?(c[(c[h>>2]|0)+8>>2]|0)!=-1:0)?(c[(c[(c[l>>2]|0)+8>>2]|0)+((c[(c[h>>2]|0)+4>>2]|0)*40|0)>>2]|0)==18:0)?(c[(c[(c[l>>2]|0)+8>>2]|0)+((c[(c[h>>2]|0)+8>>2]|0)*40|0)>>2]|0)==18:0)?(c[s>>2]=c[(c[(c[l>>2]|0)+8>>2]|0)+((c[(c[h>>2]|0)+8>>2]|0)*40|0)+4>>2],(c[s>>2]|0)!=-1):0)?(c[(c[(c[l>>2]|0)+8>>2]|0)+((c[s>>2]|0)*40|0)>>2]|0)==14:0)?(c[(c[(c[l>>2]|0)+8>>2]|0)+((c[s>>2]|0)*40|0)+28>>2]|0)==0:0)?(c[(c[(c[l>>2]|0)+8>>2]|0)+((c[s>>2]|0)*40|0)+12>>2]|0)==0:0)?(c[(c[(c[l>>2]|0)+8>>2]|0)+((c[s>>2]|0)*40|0)+24>>2]|0)!=0:0)?(qy(c[(c[(c[l>>2]|0)+8>>2]|0)+((c[s>>2]|0)*40|0)+24>>2]|0,129656)|0)!=0:0){c[t>>2]=0;s=ru(c[g>>2]|0,(c[(c[l>>2]|0)+8>>2]|0)+((c[(c[h>>2]|0)+4>>2]|0)*40|0)|0,t)|0;c[k>>2]=(c[k>>2]|0)+s;if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;z=c[f>>2]|0;i=e;return z|0}if(((((c[(c[g>>2]|0)+16>>2]|0)!=0?(c[c[(c[g>>2]|0)+16>>2]>>2]|0)==1:0)?(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]|0)!=0:0)?(c[(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]|0)+8>>2]|0)!=0:0)?(c[c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]>>2]|0)>1:0){c[c[(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]|0)+8>>2]>>2]=c[(c[(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]|0)+8>>2]|0)+((c[c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]>>2]|0)-1<<2)>>2];c[c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]>>2]=1;c[c[j>>2]>>2]=c[c[(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]|0)+8>>2]>>2]}c[f>>2]=c[k>>2];z=c[f>>2]|0;i=e;return z|0}if((c[(c[h>>2]|0)+4>>2]|0)!=-1){s=iu(c[g>>2]|0,(c[(c[l>>2]|0)+8>>2]|0)+((c[(c[h>>2]|0)+4>>2]|0)*40|0)|0)|0;c[k>>2]=(c[k>>2]|0)+s}if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;z=c[f>>2]|0;i=e;return z|0}if((c[(c[h>>2]|0)+8>>2]|0)==-1){c[f>>2]=c[k>>2];z=c[f>>2]|0;i=e;return z|0}if(!(c[(c[g>>2]|0)+16>>2]|0)){c[f>>2]=c[k>>2];z=c[f>>2]|0;i=e;return z|0}c[p>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2];if((c[c[(c[g>>2]|0)+16>>2]>>2]|0)!=7){if((c[(c[g>>2]|0)+16>>2]|0)!=0?(c[c[(c[g>>2]|0)+16>>2]>>2]|0)==1:0){c[n>>2]=Sq(c[g>>2]|0)|0;c[o>>2]=c[(c[n>>2]|0)+4>>2];c[p>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2];c[q>>2]=c[c[(c[g>>2]|0)+12>>2]>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=0;if((c[o>>2]|0)!=0?(c[c[o>>2]>>2]|0)!=0:0){c[y>>2]=0;c[x>>2]=$q(0)|0;c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[c[o>>2]>>2]|0))break;c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=c[(c[(c[o>>2]|0)+8>>2]|0)+(c[r>>2]<<2)>>2];if((c[(c[(c[(c[o>>2]|0)+8>>2]|0)+(c[r>>2]<<2)>>2]|0)+4>>2]|0)!=18?(c[(c[(c[(c[o>>2]|0)+8>>2]|0)+(c[r>>2]<<2)>>2]|0)+32>>2]|0)!=0:0)c[c[(c[g>>2]|0)+12>>2]>>2]=c[(c[(c[(c[o>>2]|0)+8>>2]|0)+(c[r>>2]<<2)>>2]|0)+32>>2];if(c[y>>2]|0){if((dr(c[(c[y>>2]|0)+4>>2]|0,c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]|0)|0)<0)c[(c[g>>2]|0)+8>>2]=15}else c[y>>2]=yt(c[(c[g>>2]|0)+12>>2]|0,c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]|0)|0;Tq(c[g>>2]|0,c[y>>2]|0)|0;c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2]=c[c[o>>2]>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+72>>2]=(c[r>>2]|0)+1;if((c[(c[h>>2]|0)+8>>2]|0)!=-1){s=iu(c[g>>2]|0,(c[(c[l>>2]|0)+8>>2]|0)+((c[(c[h>>2]|0)+8>>2]|0)*40|0)|0)|0;c[k>>2]=(c[k>>2]|0)+s}if(c[(c[g>>2]|0)+8>>2]|0){A=85;break}c[m>>2]=Sq(c[g>>2]|0)|0;do if(Ns(c[g>>2]|0,c[m>>2]|0)|0){if((cr(c[x>>2]|0,c[(c[(c[o>>2]|0)+8>>2]|0)+(c[r>>2]<<2)>>2]|0)|0)>=0)break;c[(c[g>>2]|0)+8>>2]=15}while(0);if(c[m>>2]|0)jt(c[(c[g>>2]|0)+12>>2]|0,c[m>>2]|0);if((c[(c[g>>2]|0)+16>>2]|0)==(c[y>>2]|0)){Sq(c[g>>2]|0)|0;su(c[(c[y>>2]|0)+4>>2]|0,1)}else c[y>>2]=0;c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=0;if((c[c[x>>2]>>2]|0)>0){A=95;break}c[r>>2]=(c[r>>2]|0)+1}if((A|0)==85){fr(c[x>>2]|0);Qq(c[n>>2]|0);c[f>>2]=0;z=c[f>>2]|0;i=e;return z|0}else if((A|0)==95)c[c[j>>2]>>2]=c[c[(c[x>>2]|0)+8>>2]>>2];if(c[y>>2]|0)jt(c[(c[g>>2]|0)+12>>2]|0,c[y>>2]|0);jt(c[(c[g>>2]|0)+12>>2]|0,c[n>>2]|0);c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=0;c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2]=-1;c[(c[(c[g>>2]|0)+12>>2]|0)+72>>2]=-1;c[c[(c[g>>2]|0)+12>>2]>>2]=c[q>>2];q=c[g>>2]|0;Tq(q,At(c[(c[g>>2]|0)+12>>2]|0,c[x>>2]|0)|0)|0}else A=71;if((A|0)==71?(c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2]=0,c[(c[(c[g>>2]|0)+12>>2]|0)+72>>2]=0,Tq(c[g>>2]|0,c[n>>2]|0)|0,c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=c[p>>2],(c[(c[g>>2]|0)+8>>2]|0)!=0):0){c[f>>2]=0;z=c[f>>2]|0;i=e;return z|0}c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=c[p>>2];c[f>>2]=c[k>>2];z=c[f>>2]|0;i=e;return z|0}Nq(c[g>>2]|0,11);c[f>>2]=0;z=c[f>>2]|0;i=e;return z|0}c[u>>2]=0;c[v>>2]=0;if((c[(c[g>>2]|0)+16>>2]|0)!=0?(c[c[(c[g>>2]|0)+16>>2]>>2]|0)==7:0){c[n>>2]=Sq(c[g>>2]|0)|0;c[w>>2]=c[(c[n>>2]|0)+28>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=0;if((c[w>>2]|0)!=0?(c[c[w>>2]>>2]|0)!=0:0){c[v>>2]=bv(0)|0;c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[c[w>>2]>>2]|0))break;c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=c[(c[(c[(c[w>>2]|0)+8>>2]|0)+(c[r>>2]<<2)>>2]|0)+28>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2]=c[c[w>>2]>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+72>>2]=(c[r>>2]|0)+1;if(c[u>>2]|0){if((dr(c[(c[u>>2]|0)+4>>2]|0,c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]|0)|0)<0)c[(c[g>>2]|0)+8>>2]=15}else c[u>>2]=yt(c[(c[g>>2]|0)+12>>2]|0,c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]|0)|0;Tq(c[g>>2]|0,c[u>>2]|0)|0;if((c[(c[h>>2]|0)+8>>2]|0)!=-1){x=iu(c[g>>2]|0,(c[(c[l>>2]|0)+8>>2]|0)+((c[(c[h>>2]|0)+8>>2]|0)*40|0)|0)|0;c[k>>2]=(c[k>>2]|0)+x}if(c[(c[g>>2]|0)+8>>2]|0){A=52;break}c[m>>2]=Sq(c[g>>2]|0)|0;if(Ns(c[g>>2]|0,c[m>>2]|0)|0){x=c[v>>2]|0;cv(x,lt(c[(c[g>>2]|0)+12>>2]|0,c[(c[(c[w>>2]|0)+8>>2]|0)+(c[r>>2]<<2)>>2]|0)|0)}if(c[m>>2]|0)jt(c[(c[g>>2]|0)+12>>2]|0,c[m>>2]|0);if((c[(c[g>>2]|0)+16>>2]|0)==(c[u>>2]|0)){Sq(c[g>>2]|0)|0;su(c[(c[u>>2]|0)+4>>2]|0,1)}else c[u>>2]=0;c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=0;B=c[r>>2]|0;if((c[c[v>>2]>>2]|0)>0){A=61;break}c[r>>2]=B+1}if((A|0)==52){Qq(c[n>>2]|0);c[f>>2]=0;z=c[f>>2]|0;i=e;return z|0}else if((A|0)==61)c[c[j>>2]>>2]=c[(c[(c[(c[w>>2]|0)+8>>2]|0)+(B<<2)>>2]|0)+28>>2];if(c[u>>2]|0)jt(c[(c[g>>2]|0)+12>>2]|0,c[u>>2]|0);jt(c[(c[g>>2]|0)+12>>2]|0,c[n>>2]|0);c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=0;c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2]=-1;c[(c[(c[g>>2]|0)+12>>2]|0)+72>>2]=-1;u=c[g>>2]|0;Tq(u,hv(c[v>>2]|0)|0)|0;c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=c[p>>2];c[f>>2]=c[k>>2];z=c[f>>2]|0;i=e;return z|0}c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2]=0;c[(c[(c[g>>2]|0)+12>>2]|0)+72>>2]=0;if((c[(c[h>>2]|0)+8>>2]|0)!=-1){p=iu(c[g>>2]|0,(c[(c[l>>2]|0)+8>>2]|0)+((c[(c[h>>2]|0)+8>>2]|0)*40|0)|0)|0;c[k>>2]=(c[k>>2]|0)+p}c[m>>2]=Sq(c[g>>2]|0)|0;if(c[m>>2]|0)jt(c[(c[g>>2]|0)+12>>2]|0,c[m>>2]|0);Tq(c[g>>2]|0,c[n>>2]|0)|0;if(c[(c[g>>2]|0)+8>>2]|0){c[f>>2]=0;z=c[f>>2]|0;i=e;return z|0}else{c[f>>2]=c[k>>2];z=c[f>>2]|0;i=e;return z|0}}Nq(c[g>>2]|0,11);c[f>>2]=0;z=c[f>>2]|0;i=e;return z|0}function Du(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;Gu(c[e>>2]|0);if(c[(c[e>>2]|0)+8>>2]|0){i=b;return}a:while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[e>>2]>>2]>>0]|0|0)!=13)break a}while(0);a=c[e>>2]|0;if(!(d[c[c[e>>2]>>2]>>0]|0))continue;c[a>>2]=(c[a>>2]|0)+1}b:while(1){if((d[c[c[e>>2]>>2]>>0]|0|0)!=43?(d[c[c[e>>2]>>2]>>0]|0|0)!=45:0){h=30;break}c[g>>2]=c[(c[(c[e>>2]|0)+32>>2]|0)+12>>2];if((d[c[c[e>>2]>>2]>>0]|0|0)==43)c[f>>2]=1;else c[f>>2]=0;a=c[e>>2]|0;if(d[c[c[e>>2]>>2]>>0]|0)c[a>>2]=(c[a>>2]|0)+1;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)j=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){j=1;break}j=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);k=c[e>>2]|0;if(!j)break;a=c[e>>2]|0;if(!(d[c[k>>2]>>0]|0))continue;c[a>>2]=(c[a>>2]|0)+1}Gu(k);if(c[(c[e>>2]|0)+8>>2]|0){h=30;break}du(c[(c[e>>2]|0)+32>>2]|0,c[g>>2]|0,c[(c[(c[e>>2]|0)+32>>2]|0)+12>>2]|0,5,c[f>>2]|0,0,0,0,0)|0;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[e>>2]>>2]>>0]|0|0)!=13)continue b}while(0);a=c[e>>2]|0;if(!(d[c[c[e>>2]>>2]>>0]|0))continue;c[a>>2]=(c[a>>2]|0)+1}}if((h|0)==30){i=b;return}}function Eu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](12)|0;if(!(c[f>>2]|0)){it(0,128632);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}a=c[f>>2]|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;if((c[e>>2]|0)<10)c[e>>2]=10;a=Cb[c[135744>>2]&511](c[e>>2]<<2)|0;c[(c[f>>2]|0)+8>>2]=a;if(!(c[(c[f>>2]|0)+8>>2]|0)){it(0,128632);zb[c[135736>>2]&511](c[f>>2]|0);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{cU(c[(c[f>>2]|0)+8>>2]|0,0,c[e>>2]<<2|0)|0;c[(c[f>>2]|0)+4>>2]=c[e>>2];c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function Fu(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if(!(c[f>>2]|0)){i=e;return}if((c[c[f>>2]>>2]|0)<=0){i=e;return}if((c[g>>2]|0)>=(c[c[f>>2]>>2]|0)){i=e;return}a:do if(c[h>>2]|0){c[j>>2]=c[g>>2];while(1){if((c[j>>2]|0)>=(c[c[f>>2]>>2]|0))break a;c[k>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+(c[j>>2]<<2)>>2];if((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+4>>2]|0)==18:0)_q(c[k>>2]|0);c[j>>2]=(c[j>>2]|0)+1}}while(0);c[c[f>>2]>>2]=c[g>>2];i=e;return}function Gu(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;Hu(c[e>>2]|0);if(c[(c[e>>2]|0)+8>>2]|0){i=b;return}a:while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[e>>2]>>2]>>0]|0|0)!=13)break a}while(0);a=c[e>>2]|0;if(!(d[c[c[e>>2]>>2]>>0]|0))continue;c[a>>2]=(c[a>>2]|0)+1}b:while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)!=42){if(((d[c[c[e>>2]>>2]>>0]|0|0)==100?(d[(c[c[e>>2]>>2]|0)+1>>0]|0|0)==105:0)?(d[(c[c[e>>2]>>2]|0)+2>>0]|0|0)==118:0)break;if((d[c[c[e>>2]>>2]>>0]|0|0)!=109){h=37;break b}if((d[(c[c[e>>2]>>2]|0)+1>>0]|0|0)!=111){h=37;break b}if((d[(c[c[e>>2]>>2]|0)+2>>0]|0|0)!=100){h=37;break b}}while(0);c[f>>2]=-1;c[g>>2]=c[(c[(c[e>>2]|0)+32>>2]|0)+12>>2];do if((d[c[c[e>>2]>>2]>>0]|0|0)==42){c[f>>2]=0;a=c[e>>2]|0;if(d[c[c[e>>2]>>2]>>0]|0)c[a>>2]=(c[a>>2]|0)+1}else{if((d[c[c[e>>2]>>2]>>0]|0|0)==100){c[f>>2]=1;a=c[e>>2]|0;c[a>>2]=(c[a>>2]|0)+3;break}if((d[c[c[e>>2]>>2]>>0]|0|0)==109){c[f>>2]=2;a=c[e>>2]|0;c[a>>2]=(c[a>>2]|0)+3}}while(0);while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)j=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){j=1;break}j=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);k=c[e>>2]|0;if(!j)break;a=c[e>>2]|0;if(!(d[c[k>>2]>>0]|0))continue;c[a>>2]=(c[a>>2]|0)+1}Hu(k);if(c[(c[e>>2]|0)+8>>2]|0){h=37;break}du(c[(c[e>>2]|0)+32>>2]|0,c[g>>2]|0,c[(c[(c[e>>2]|0)+32>>2]|0)+12>>2]|0,6,c[f>>2]|0,0,0,0,0)|0;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[e>>2]>>2]>>0]|0|0)!=13)continue b}while(0);a=c[e>>2]|0;if(!(d[c[c[e>>2]>>2]>>0]|0))continue;c[a>>2]=(c[a>>2]|0)+1}}if((h|0)==37){i=b;return}}function Hu(a){a=a|0;var b=0,e=0,f=0,g=0;b=i;i=i+16|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;c[f>>2]=0;c[g>>2]=0;a:while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[e>>2]>>2]>>0]|0|0)!=13)break a}while(0);a=c[e>>2]|0;if(!(d[c[c[e>>2]>>2]>>0]|0))continue;c[a>>2]=(c[a>>2]|0)+1}b:while(1){if((d[c[c[e>>2]>>2]>>0]|0|0)!=45)break;c[f>>2]=1-(c[f>>2]|0);c[g>>2]=1;a=c[e>>2]|0;if(d[c[c[e>>2]>>2]>>0]|0)c[a>>2]=(c[a>>2]|0)+1;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[e>>2]>>2]>>0]|0|0)!=13)continue b}while(0);a=c[e>>2]|0;if(!(d[c[c[e>>2]>>2]>>0]|0))continue;c[a>>2]=(c[a>>2]|0)+1}}Iu(c[e>>2]|0);if(!((c[g>>2]|0)!=0?(c[(c[e>>2]|0)+8>>2]|0)==0:0)){i=b;return}g=c[(c[e>>2]|0)+32>>2]|0;a=c[(c[(c[e>>2]|0)+32>>2]|0)+12>>2]|0;if(c[f>>2]|0){du(g,a,-1,5,2,0,0,0,0)|0;i=b;return}else{du(g,a,-1,5,3,0,0,0,0)|0;i=b;return}}function Iu(a){a=a|0;var b=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;e=b+4|0;f=b;c[e>>2]=a;Ju(c[e>>2]|0);if(c[(c[e>>2]|0)+8>>2]|0){i=b;return}a:while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[e>>2]>>2]>>0]|0|0)!=13)break a}while(0);a=c[e>>2]|0;if(!(d[c[c[e>>2]>>2]>>0]|0))continue;c[a>>2]=(c[a>>2]|0)+1}b:while(1){if((d[c[c[e>>2]>>2]>>0]|0|0)!=124)break;c[f>>2]=c[(c[(c[e>>2]|0)+32>>2]|0)+12>>2];du(c[(c[e>>2]|0)+32>>2]|0,-1,-1,9,0,0,0,0,0)|0;a=c[e>>2]|0;if(d[c[c[e>>2]>>2]>>0]|0)c[a>>2]=(c[a>>2]|0)+1;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)g=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){g=1;break}g=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);h=c[e>>2]|0;if(!g)break;a=c[e>>2]|0;if(!(d[c[h>>2]>>0]|0))continue;
c[a>>2]=(c[a>>2]|0)+1}Ju(h);du(c[(c[e>>2]|0)+32>>2]|0,c[f>>2]|0,c[(c[(c[e>>2]|0)+32>>2]|0)+12>>2]|0,7,0,0,0,0,0)|0;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[e>>2]>>2]>>0]|0|0)!=13)continue b}while(0);a=c[e>>2]|0;if(!(d[c[c[e>>2]>>2]>>0]|0))continue;c[a>>2]=(c[a>>2]|0)+1}}i=b;return}function Ju(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[e>>2]=a;c[f>>2]=1;c[g>>2]=0;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)j=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){j=1;break}j=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);k=d[c[c[e>>2]>>2]>>0]|0;if(!j)break;a=c[e>>2]|0;if(!k)continue;c[a>>2]=(c[a>>2]|0)+1}do if((k|0)!=36?(d[c[c[e>>2]>>2]>>0]|0|0)!=40:0){if(48<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=57:0){l=18;break}if((d[c[c[e>>2]>>2]>>0]|0|0)!=39?(d[c[c[e>>2]>>2]>>0]|0|0)!=34:0){if(((d[c[c[e>>2]>>2]>>0]|0|0)==46?48<=(d[(c[c[e>>2]>>2]|0)+1>>0]|0|0):0)?(d[(c[c[e>>2]>>2]|0)+1>>0]|0|0)<=57:0){l=18;break}if((d[c[c[e>>2]>>2]>>0]|0|0)==42){c[f>>2]=1;break}if((d[c[c[e>>2]>>2]>>0]|0|0)==47){c[f>>2]=1;break}if((d[c[c[e>>2]>>2]>>0]|0|0)==64){c[f>>2]=1;break}if((d[c[c[e>>2]>>2]>>0]|0|0)==46){c[f>>2]=1;break}while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)m=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){m=1;break}m=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);n=c[e>>2]|0;if(!m)break;j=c[e>>2]|0;if(!(d[c[n>>2]>>0]|0))continue;c[j>>2]=(c[j>>2]|0)+1}c[g>>2]=Ku(n)|0;if((c[g>>2]|0)!=0?(wy(c[g>>2]|0,130432)|0)!=0:0){c[f>>2]=1;zb[c[135736>>2]&511](c[g>>2]|0);break}if(!(c[g>>2]|0)){Nq(c[e>>2]|0,7);i=b;return}c[h>>2]=xy(c[g>>2]|0)|0;a:while(1){if(!(d[(c[c[e>>2]>>2]|0)+(c[h>>2]|0)>>0]|0))break;if((d[(c[c[e>>2]>>2]|0)+(c[h>>2]|0)>>0]|0|0)==47){l=41;break}do if((d[(c[c[e>>2]>>2]|0)+(c[h>>2]|0)>>0]|0|0)!=32){if(9<=(d[(c[c[e>>2]>>2]|0)+(c[h>>2]|0)>>0]|0|0)?(d[(c[c[e>>2]>>2]|0)+(c[h>>2]|0)>>0]|0|0)<=10:0)break;if((d[(c[c[e>>2]>>2]|0)+(c[h>>2]|0)>>0]|0|0)!=13){l=46;break a}}while(0);c[h>>2]=(c[h>>2]|0)+1}b:do if((l|0)==41)c[f>>2]=1;else if((l|0)==46){if((d[(c[c[e>>2]>>2]|0)+(c[h>>2]|0)>>0]|0|0)==58){c[f>>2]=1;break}if((d[(c[c[e>>2]>>2]|0)+(c[h>>2]|0)>>0]|0|0)==40)if(Ms(c[g>>2]|0)|0){c[f>>2]=1;break}else{c[f>>2]=0;break}if((d[(c[c[e>>2]>>2]|0)+(c[h>>2]|0)>>0]|0|0)==91){c[f>>2]=1;break}do if((d[(c[c[e>>2]>>2]|0)+(c[h>>2]|0)>>0]|0|0)!=60?(d[(c[c[e>>2]>>2]|0)+(c[h>>2]|0)>>0]|0|0)!=62:0){if((d[(c[c[e>>2]>>2]|0)+(c[h>>2]|0)>>0]|0|0)==61)break;c[f>>2]=1;break b}while(0);c[f>>2]=1}while(0);if(!(d[(c[c[e>>2]>>2]|0)+(c[h>>2]|0)>>0]|0))c[f>>2]=1;zb[c[135736>>2]&511](c[g>>2]|0)}else l=18}else l=18;while(0);if((l|0)==18)c[f>>2]=0;l=c[e>>2]|0;do if(!(c[f>>2]|0)){Mu(l);if(c[(c[e>>2]|0)+8>>2]|0){i=b;return}if((d[c[c[e>>2]>>2]>>0]|0|0)==47?(d[(c[c[e>>2]>>2]|0)+1>>0]|0|0)==47:0){g=c[e>>2]|0;c[g>>2]=(c[g>>2]|0)+2;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)o=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){o=1;break}o=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);p=c[e>>2]|0;if(!o)break;g=c[e>>2]|0;if(!(d[c[p>>2]>>0]|0))continue;c[g>>2]=(c[g>>2]|0)+1}du(c[p+32>>2]|0,c[(c[(c[e>>2]|0)+32>>2]|0)+12>>2]|0,-1,11,6,1,0,0,0)|0;du(c[(c[e>>2]|0)+32>>2]|0,c[(c[(c[e>>2]|0)+32>>2]|0)+12>>2]|0,-1,10,1,0,0,0,0)|0;Nu(c[e>>2]|0);break}if((d[c[c[e>>2]>>2]>>0]|0|0)==47)Nu(c[e>>2]|0)}else{g=c[(c[e>>2]|0)+32>>2]|0;if((d[c[l>>2]>>0]|0|0)==47)du(g,-1,-1,8,0,0,0,0,0)|0;else du(g,-1,-1,9,0,0,0,0,0)|0;Lu(c[e>>2]|0)}while(0);c:while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[e>>2]>>2]>>0]|0|0)!=13)break c}while(0);l=c[e>>2]|0;if(!(d[c[c[e>>2]>>2]>>0]|0))continue;c[l>>2]=(c[l>>2]|0)+1}i=b;return}function Ku(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+32|0;d=b+24|0;e=b+20|0;f=b+16|0;g=b+12|0;h=b+8|0;j=b+4|0;k=b;c[e>>2]=a;c[f>>2]=0;c[j>>2]=c[c[e>>2]>>2];c[h>>2]=bu(c[e>>2]|0,g)|0;a:do if(!((c[h>>2]|0)==32|(c[h>>2]|0)==62|(c[h>>2]|0)==47)){a=c[h>>2]|0;if((c[h>>2]|0)<256){if(((!(65<=(a|0)&(c[h>>2]|0)<=90)?!(97<=(c[h>>2]|0)&(c[h>>2]|0)<=122):0)?!(192<=(c[h>>2]|0)&(c[h>>2]|0)<=214):0)?!(216<=(c[h>>2]|0)&(c[h>>2]|0)<=246|248<=(c[h>>2]|0)):0)l=8}else if(!(DQ(a,199744)|0))l=8;do if((l|0)==8){a=c[h>>2]|0;if((c[h>>2]|0)<256)if((a|0)!=95&(c[h>>2]|0)!=58)break a;else break;if(!(19968<=(a|0)&(c[h>>2]|0)<=40869|(c[h>>2]|0)==12295)?(12321<=(c[h>>2]|0)&(c[h>>2]|0)<=12329^1)&(c[h>>2]|0)!=95&(c[h>>2]|0)!=58:0)break a}while(0);b:while(1){if(!((c[h>>2]|0)!=32&(c[h>>2]|0)!=62&(c[h>>2]|0)!=47))break;a=c[h>>2]|0;if((c[h>>2]|0)<256){if(((!(65<=(a|0)&(c[h>>2]|0)<=90)?!(97<=(c[h>>2]|0)&(c[h>>2]|0)<=122):0)?!(192<=(c[h>>2]|0)&(c[h>>2]|0)<=214):0)?!(216<=(c[h>>2]|0)&(c[h>>2]|0)<=246|248<=(c[h>>2]|0)):0)l=20}else if(!(DQ(a,199744)|0))l=20;do if((l|0)==20){l=0;if((c[h>>2]|0)>=256){if(19968<=(c[h>>2]|0)&(c[h>>2]|0)<=40869|(c[h>>2]|0)==12295)break;if(12321<=(c[h>>2]|0)&(c[h>>2]|0)<=12329)break}a=c[h>>2]|0;if((c[h>>2]|0)<256){if(48<=(a|0)&(c[h>>2]|0)<=57|(c[h>>2]|0)==46|(c[h>>2]|0)==45|(c[h>>2]|0)==95|(c[h>>2]|0)==58)break}else{m=(DQ(a,200216)|0)!=0;if(m|(c[h>>2]|0)==46|(c[h>>2]|0)==45|(c[h>>2]|0)==95|(c[h>>2]|0)==58)break}if((c[h>>2]|0)>=256?(DQ(c[h>>2]|0,200144)|0)!=0:0)break;m=c[h>>2]|0;if((c[h>>2]|0)<256)n=(m|0)==183&1;else n=DQ(m,200272)|0;if(!n)break b}while(0);c[f>>2]=(c[f>>2]|0)+(c[g>>2]|0);m=c[e>>2]|0;c[m>>2]=(c[m>>2]|0)+(c[g>>2]|0);c[h>>2]=bu(c[e>>2]|0,g)|0}c[k>>2]=ly(c[j>>2]|0,(c[c[e>>2]>>2]|0)-(c[j>>2]|0)|0)|0;c[c[e>>2]>>2]=c[j>>2];c[d>>2]=c[k>>2];o=c[d>>2]|0;i=b;return o|0}while(0);c[d>>2]=0;o=c[d>>2]|0;i=b;return o|0}function Lu(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;e=b;c[e>>2]=a;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)f=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){f=1;break}f=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);g=d[c[c[e>>2]>>2]>>0]|0;if(!f)break;a=c[e>>2]|0;if(!g)continue;c[a>>2]=(c[a>>2]|0)+1}if((g|0)!=47){Nu(c[e>>2]|0);i=b;return}while(1){if((d[c[c[e>>2]>>2]>>0]|0|0)!=47){h=44;break}if((d[c[c[e>>2]>>2]>>0]|0|0)==47?(d[(c[c[e>>2]>>2]|0)+1>>0]|0|0)==47:0){g=c[e>>2]|0;c[g>>2]=(c[g>>2]|0)+2;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)j=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){j=1;break}j=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);k=c[e>>2]|0;if(!j)break;g=c[e>>2]|0;if(!(d[c[k>>2]>>0]|0))continue;c[g>>2]=(c[g>>2]|0)+1}du(c[k+32>>2]|0,c[(c[(c[e>>2]|0)+32>>2]|0)+12>>2]|0,-1,11,6,1,0,0,0)|0;Nu(c[e>>2]|0)}else h=23;a:do if((h|0)==23?(h=0,(d[c[c[e>>2]>>2]>>0]|0|0)==47):0){g=c[e>>2]|0;if(d[c[c[e>>2]>>2]>>0]|0)c[g>>2]=(c[g>>2]|0)+1;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)l=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){l=1;break}l=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);m=(d[c[c[e>>2]>>2]>>0]|0|0)!=0;if(!l)break;g=c[e>>2]|0;if(!m)continue;c[g>>2]=(c[g>>2]|0)+1}if(m){if(!(65<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=90:0))h=36;do if((h|0)==36){h=0;if(97<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=122:0)break;if((((d[c[c[e>>2]>>2]>>0]|0|0)!=95?(d[c[c[e>>2]>>2]>>0]|0|0)!=46:0)?(d[c[c[e>>2]>>2]>>0]|0|0)!=64:0)?(d[c[c[e>>2]>>2]>>0]|0|0)!=42:0)break a}while(0);Nu(c[e>>2]|0)}}while(0);if(c[(c[e>>2]|0)+8>>2]|0){h=44;break}}if((h|0)==44){i=b;return}}function Mu(a){a=a|0;var b=0,e=0;b=i;i=i+16|0;e=b;c[e>>2]=a;Ou(c[e>>2]|0);if(c[(c[e>>2]|0)+8>>2]|0){i=b;return}a:while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[e>>2]>>2]>>0]|0|0)!=13)break a}while(0);a=c[e>>2]|0;if(!(d[c[c[e>>2]>>2]>>0]|0))continue;c[a>>2]=(c[a>>2]|0)+1}b:while(1){if((d[c[c[e>>2]>>2]>>0]|0|0)!=91)break;Pu(c[e>>2]|0,1);while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[e>>2]>>2]>>0]|0|0)!=13)continue b}while(0);a=c[e>>2]|0;if(!(d[c[c[e>>2]>>2]>>0]|0))continue;c[a>>2]=(c[a>>2]|0)+1}}i=b;return}function Nu(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;e=b;c[e>>2]=a;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)f=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){f=1;break}f=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);g=d[c[c[e>>2]>>2]>>0]|0;if(!f)break;a=c[e>>2]|0;if(!g)continue;c[a>>2]=(c[a>>2]|0)+1}if((g|0)==47?(d[(c[c[e>>2]>>2]|0)+1>>0]|0|0)==47:0){g=c[e>>2]|0;c[g>>2]=(c[g>>2]|0)+2;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)h=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){h=1;break}h=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);j=c[e>>2]|0;if(!h)break;g=c[e>>2]|0;if(!(d[c[j>>2]>>0]|0))continue;c[g>>2]=(c[g>>2]|0)+1}du(c[j+32>>2]|0,c[(c[(c[e>>2]|0)+32>>2]|0)+12>>2]|0,-1,11,6,1,0,0,0)|0}else k=20;a:do if((k|0)==20?(d[c[c[e>>2]>>2]>>0]|0|0)==47:0){j=c[e>>2]|0;if(d[c[c[e>>2]>>2]>>0]|0)c[j>>2]=(c[j>>2]|0)+1;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[e>>2]>>2]>>0]|0|0)!=13)break a}while(0);j=c[e>>2]|0;if(!(d[c[c[e>>2]>>2]>>0]|0))continue;c[j>>2]=(c[j>>2]|0)+1}}while(0);Qu(c[e>>2]|0);if(c[(c[e>>2]|0)+8>>2]|0){i=b;return}b:while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[e>>2]>>2]>>0]|0|0)!=13)break b}while(0);j=c[e>>2]|0;if(!(d[c[c[e>>2]>>2]>>0]|0))continue;c[j>>2]=(c[j>>2]|0)+1}c:while(1){if((d[c[c[e>>2]>>2]>>0]|0|0)!=47)break;if((d[c[c[e>>2]>>2]>>0]|0|0)==47?(d[(c[c[e>>2]>>2]|0)+1>>0]|0|0)==47:0){j=c[e>>2]|0;c[j>>2]=(c[j>>2]|0)+2;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)l=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){l=1;break}l=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);m=c[e>>2]|0;if(!l)break;j=c[e>>2]|0;if(!(d[c[m>>2]>>0]|0))continue;c[j>>2]=(c[j>>2]|0)+1}du(c[m+32>>2]|0,c[(c[(c[e>>2]|0)+32>>2]|0)+12>>2]|0,-1,11,6,1,0,0,0)|0;Qu(c[e>>2]|0)}else k=48;if((k|0)==48?(k=0,(d[c[c[e>>2]>>2]>>0]|0|0)==47):0){j=c[e>>2]|0;if(d[c[c[e>>2]>>2]>>0]|0)c[j>>2]=(c[j>>2]|0)+1;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)n=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){n=1;break}n=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);o=c[e>>2]|0;if(!n)break;j=c[e>>2]|0;if(!(d[c[o>>2]>>0]|0))continue;c[j>>2]=(c[j>>2]|0)+1}Qu(o)}while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[e>>2]>>2]>>0]|0|0)!=13)continue c}while(0);j=c[e>>2]|0;if(!(d[c[c[e>>2]>>2]>>0]|0))continue;c[j>>2]=(c[j>>2]|0)+1}}i=b;return}function Ou(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+16|0;e=b;c[e>>2]=a;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)f=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){f=1;break}f=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);g=d[c[c[e>>2]>>2]>>0]|0;if(!f)break;a=c[e>>2]|0;if(!g)continue;c[a>>2]=(c[a>>2]|0)+1}f=c[e>>2]|0;a:do if((g|0)==36)Ru(f);else{a=d[c[c[e>>2]>>2]>>0]|0;if((d[c[f>>2]>>0]|0|0)!=40){if(!(48<=(a|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=57:0))h=34;do if((h|0)==34){if(((d[c[c[e>>2]>>2]>>0]|0|0)==46?48<=(d[(c[c[e>>2]>>2]|0)+1>>0]|0|0):0)?(d[(c[c[e>>2]>>2]|0)+1>>0]|0|0)<=57:0)break;if((d[c[c[e>>2]>>2]>>0]|0|0)!=39?(d[c[c[e>>2]>>2]>>0]|0|0)!=34:0){Uu(c[e>>2]|0);break a}Tu(c[e>>2]|0);break a}while(0);Su(c[e>>2]|0);break}j=c[e>>2]|0;if(a)c[j>>2]=(c[j>>2]|0)+1;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)k=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){k=1;break}k=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);l=c[e>>2]|0;if(!k)break;j=c[e>>2]|0;if(!(d[c[l>>2]>>0]|0))continue;c[j>>2]=(c[j>>2]|0)+1}Jt(l,1);if(c[(c[e>>2]|0)+8>>2]|0){i=b;return}a=c[e>>2]|0;if((d[c[c[e>>2]>>2]>>0]|0|0)!=41){Nq(a,7);i=b;return}j=c[e>>2]|0;if(d[c[a>>2]>>0]|0)c[j>>2]=(c[j>>2]|0)+1;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[e>>2]>>2]>>0]|0|0)!=13)break a}while(0);j=c[e>>2]|0;if(!(d[c[c[e>>2]>>2]>>0]|0))continue;c[j>>2]=(c[j>>2]|0)+1}}while(0);b:while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[e>>2]>>2]>>0]|0|0)!=13)break b}while(0);l=c[e>>2]|0;if(!(d[c[c[e>>2]>>2]>>0]|0))continue;c[l>>2]=(c[l>>2]|0)+1}i=b;return}function Pu(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=c[(c[(c[f>>2]|0)+32>>2]|0)+12>>2];while(1){do if((d[c[c[f>>2]>>2]>>0]|0|0)==32)j=1;else{if(9<=(d[c[c[f>>2]>>2]>>0]|0|0)?(d[c[c[f>>2]>>2]>>0]|0|0)<=10:0){j=1;break}j=(d[c[c[f>>2]>>2]>>0]|0|0)==13}while(0);k=d[c[c[f>>2]>>2]>>0]|0;if(!j)break;b=c[f>>2]|0;if(!k)continue;c[b>>2]=(c[b>>2]|0)+1}j=c[f>>2]|0;if((k|0)!=91){Nq(j,6);i=e;return}k=c[f>>2]|0;if(d[c[j>>2]>>0]|0)c[k>>2]=(c[k>>2]|0)+1;while(1){do if((d[c[c[f>>2]>>2]>>0]|0|0)==32)l=1;else{if(9<=(d[c[c[f>>2]>>2]>>0]|0|0)?(d[c[c[f>>2]>>2]>>0]|0|0)<=10:0){l=1;break}l=(d[c[c[f>>2]>>2]>>0]|0|0)==13}while(0);m=c[f>>2]|0;if(!l)break;k=c[f>>2]|0;if(!(d[c[m>>2]>>0]|0))continue;c[k>>2]=(c[k>>2]|0)+1}c[(c[m+32>>2]|0)+12>>2]=-1;m=c[f>>2]|0;if(c[g>>2]|0)Jt(m,1);else Jt(m,0);if(c[(c[f>>2]|0)+8>>2]|0){i=e;return}if((d[c[c[f>>2]>>2]>>0]|0|0)!=93){Nq(c[f>>2]|0,6);i=e;return}m=c[(c[f>>2]|0)+32>>2]|0;l=c[h>>2]|0;h=c[(c[(c[f>>2]|0)+32>>2]|0)+12>>2]|0;if(c[g>>2]|0)du(m,l,h,17,0,0,0,0,0)|0;else du(m,l,h,16,0,0,0,0,0)|0;h=c[f>>2]|0;if(d[c[c[f>>2]>>2]>>0]|0)c[h>>2]=(c[h>>2]|0)+1;a:while(1){do if((d[c[c[f>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[f>>2]>>2]>>0]|0|0)?(d[c[c[f>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[f>>2]>>2]>>0]|0|0)!=13)break a}while(0);h=c[f>>2]|0;if(!(d[c[c[f>>2]>>2]>>0]|0))continue;c[h>>2]=(c[h>>2]|0)+1}i=e;return}function Qu(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+48|0;e=b+32|0;f=b+28|0;g=b+24|0;h=b+20|0;j=b+16|0;k=b+12|0;l=b+8|0;m=b+4|0;n=b;c[e>>2]=a;c[f>>2]=0;c[g>>2]=-1;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)o=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){o=1;break}o=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);p=d[c[c[e>>2]>>2]>>0]|0;if(!o)break;a=c[e>>2]|0;if(!p)continue;c[a>>2]=(c[a>>2]|0)+1}if((p|0)==46?(d[(c[c[e>>2]>>2]|0)+1>>0]|0|0)==46:0){p=c[e>>2]|0;c[p>>2]=(c[p>>2]|0)+2;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)q=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){q=1;break}q=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);r=c[e>>2]|0;if(!q)break;p=c[e>>2]|0;if(!(d[c[r>>2]>>0]|0))continue;c[p>>2]=(c[p>>2]|0)+1}du(c[r+32>>2]|0,c[(c[(c[e>>2]|0)+32>>2]|0)+12>>2]|0,-1,11,10,1,0,0,0)|0;i=b;return}if((d[c[c[e>>2]>>2]>>0]|0|0)==46){r=c[e>>2]|0;if(d[c[c[e>>2]>>2]>>0]|0)c[r>>2]=(c[r>>2]|0)+1;a:while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[e>>2]>>2]>>0]|0|0)!=13)break a}while(0);r=c[e>>2]|0;if(!(d[c[c[e>>2]>>2]>>0]|0))continue;c[r>>2]=(c[r>>2]|0)+1}i=b;return}c[h>>2]=0;c[j>>2]=0;c[k>>2]=0;c[l>>2]=0;c[m>>2]=0;if(((c[(c[e>>2]|0)+36>>2]|0)!=0?(c[h>>2]=Ks(c[e>>2]|0)|0,(c[h>>2]|0)!=0):0)?(qy(c[h>>2]|0,130440)|0)!=0:0){c[g>>2]=c[(c[(c[e>>2]|0)+32>>2]|0)+12>>2];zb[c[135736>>2]&511](c[h>>2]|0);while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)s=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){s=1;break}s=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);t=d[c[c[e>>2]>>2]>>0]|0;if(!s)break;r=c[e>>2]|0;if(!t)continue;c[r>>2]=(c[r>>2]|0)+1}s=c[e>>2]|0;if((t|0)!=40){Nq(s,7);i=b;return}t=c[e>>2]|0;if(d[c[s>>2]>>0]|0)c[t>>2]=(c[t>>2]|0)+1;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)u=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){u=1;break}u=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);v=c[e>>2]|0;if(!u)break;t=c[e>>2]|0;if(!(d[c[v>>2]>>0]|0))continue;c[t>>2]=(c[t>>2]|0)+1}Jt(v,1);if(c[(c[e>>2]|0)+8>>2]|0){i=b;return}while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)w=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){w=1;break}w=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);x=d[c[c[e>>2]>>2]>>0]|0;if(!w)break;v=c[e>>2]|0;if(!x)continue;c[v>>2]=(c[v>>2]|0)+1}w=c[e>>2]|0;if((x|0)!=41){Nq(w,7);i=b;return}x=c[e>>2]|0;if(d[c[w>>2]>>0]|0)c[x>>2]=(c[x>>2]|0)+1;c[f>>2]=1}else{do if((d[c[c[e>>2]>>2]>>0]|0|0)==42)c[l>>2]=4;else{if(!(c[h>>2]|0))c[h>>2]=Ks(c[e>>2]|0)|0;if(!(c[h>>2]|0)){if((d[c[c[e>>2]>>2]>>0]|0|0)!=64){c[l>>2]=4;break}x=c[e>>2]|0;if(d[c[c[e>>2]>>2]>>0]|0)c[x>>2]=(c[x>>2]|0)+1;c[l>>2]=3;break}c[l>>2]=Vu(c[h>>2]|0)|0;if(!(c[l>>2]|0)){c[l>>2]=4;break}while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)y=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){y=1;break}y=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);z=d[c[c[e>>2]>>2]>>0]|0;if(!y)break;x=c[e>>2]|0;if(!z)continue;c[x>>2]=(c[x>>2]|0)+1}if((z|0)==58?(d[(c[c[e>>2]>>2]|0)+1>>0]|0|0)==58:0){x=c[e>>2]|0;c[x>>2]=(c[x>>2]|0)+2;zb[c[135736>>2]&511](c[h>>2]|0);c[h>>2]=0;break}c[l>>2]=4}while(0);if(c[(c[e>>2]|0)+8>>2]|0){zb[c[135736>>2]&511](c[h>>2]|0);i=b;return}c[h>>2]=Wu(c[e>>2]|0,k,m,j,c[h>>2]|0)|0;if(!(c[k>>2]|0)){i=b;return}if((((c[j>>2]|0)!=0?(c[(c[e>>2]|0)+12>>2]|0)!=0:0)?(c[(c[(c[e>>2]|0)+12>>2]|0)+196>>2]&1|0)!=0:0)?(sr(c[(c[e>>2]|0)+12>>2]|0,c[j>>2]|0)|0)==0:0)Nq(c[e>>2]|0,19)}c[n>>2]=c[(c[(c[e>>2]|0)+32>>2]|0)+12>>2];c[(c[(c[e>>2]|0)+32>>2]|0)+12>>2]=-1;b:while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[e>>2]>>2]>>0]|0|0)!=13)break b}while(0);z=c[e>>2]|0;if(!(d[c[c[e>>2]>>2]>>0]|0))continue;c[z>>2]=(c[z>>2]|0)+1}while(1){if((d[c[c[e>>2]>>2]>>0]|0|0)!=91)break;Pu(c[e>>2]|0,0)}z=c[(c[e>>2]|0)+32>>2]|0;if(c[f>>2]|0){du(z,c[g>>2]|0,c[n>>2]|0,19,0,0,0,0,0)|0;i=b;return}else{du(z,c[n>>2]|0,c[(c[(c[e>>2]|0)+32>>2]|0)+12>>2]|0,11,c[l>>2]|0,c[k>>2]|0,c[m>>2]|0,c[j>>2]|0,c[h>>2]|0)|0;i=b;return}}function Ru(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+16|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)h=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){h=1;break}h=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);j=d[c[c[e>>2]>>2]>>0]|0;if(!h)break;a=c[e>>2]|0;if(!j)continue;c[a>>2]=(c[a>>2]|0)+1}h=c[e>>2]|0;if((j|0)!=36){Nq(h,4);i=b;return}j=c[e>>2]|0;if(d[c[h>>2]>>0]|0)c[j>>2]=(c[j>>2]|0)+1;c[f>>2]=Xu(c[e>>2]|0,g)|0;j=c[e>>2]|0;if(!(c[f>>2]|0)){Nq(j,4);i=b;return}c[(c[j+32>>2]|0)+12>>2]=-1;du(c[(c[e>>2]|0)+32>>2]|0,c[(c[(c[e>>2]|0)+32>>2]|0)+12>>2]|0,-1,13,0,0,0,c[f>>2]|0,c[g>>2]|0)|0;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)k=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){k=1;break}k=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);l=c[e>>2]|0;if(!k)break;g=c[e>>2]|0;if(!(d[c[l>>2]>>0]|0))continue;c[g>>2]=(c[g>>2]|0)+1}if(!(c[l+12>>2]|0)){i=b;return}if(!(c[(c[(c[e>>2]|0)+12>>2]|0)+196>>2]&2)){i=b;return}Nq(c[e>>2]|0,24);i=b;return}function Su(a){a=a|0;var b=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+64|0;e=b+48|0;f=b+16|0;g=b+44|0;j=b+40|0;k=b+36|0;l=b+32|0;m=b+8|0;n=b+28|0;o=b+24|0;p=b;c[e>>2]=a;h[f>>3]=0;c[g>>2]=0;c[j>>2]=0;c[k>>2]=0;c[l>>2]=0;if(c[(c[e>>2]|0)+8>>2]|0){i=b;return}do if((d[c[c[e>>2]>>2]>>0]|0|0)!=46){if((d[c[c[e>>2]>>2]>>0]|0|0)>=48?(d[c[c[e>>2]>>2]>>0]|0|0)<=57:0)break;Nq(c[e>>2]|0,1);i=b;return}while(0);h[f>>3]=0;while(1){if((d[c[c[e>>2]>>2]>>0]|0|0)<48)break;if((d[c[c[e>>2]>>2]>>0]|0|0)>57)break;h[f>>3]=+h[f>>3]*10;c[l>>2]=(d[c[c[e>>2]>>2]>>0]|0)-48;c[g>>2]=1;a=c[e>>2]|0;if(d[c[c[e>>2]>>2]>>0]|0)c[a>>2]=(c[a>>2]|0)+1;h[m>>3]=+((c[l>>2]|0)>>>0);h[f>>3]=+h[f>>3]+ +h[m>>3]}a:do if((d[c[c[e>>2]>>2]>>0]|0|0)==46){c[o>>2]=0;h[p>>3]=0;m=c[e>>2]|0;if(d[c[c[e>>2]>>2]>>0]|0)c[m>>2]=(c[m>>2]|0)+1;if((d[c[c[e>>2]>>2]>>0]|0|0)<48){if(!(c[g>>2]|0))q=18}else if(!((c[g>>2]|0)!=0?1:(d[c[c[e>>2]>>2]>>0]|0|0)<=57))q=18;if((q|0)==18){Nq(c[e>>2]|0,1);i=b;return}while(1){if((d[c[c[e>>2]>>2]>>0]|0|0)<48)break;if(!((c[o>>2]|0)<20?(d[c[c[e>>2]>>2]>>0]|0|0)<=57:0))break;c[n>>2]=(d[c[c[e>>2]>>2]>>0]|0)-48;h[p>>3]=+h[p>>3]*10+ +(c[n>>2]|0);c[o>>2]=(c[o>>2]|0)+1;m=c[e>>2]|0;if(!(d[c[c[e>>2]>>2]>>0]|0))continue;c[m>>2]=(c[m>>2]|0)+1}h[p>>3]=+h[p>>3]/+h[129232+(c[o>>2]<<3)>>3];h[f>>3]=+h[f>>3]+ +h[p>>3];while(1){if((d[c[c[e>>2]>>2]>>0]|0|0)<48)break a;if((d[c[c[e>>2]>>2]>>0]|0|0)>57)break a;m=c[e>>2]|0;if(!(d[c[c[e>>2]>>2]>>0]|0))continue;c[m>>2]=(c[m>>2]|0)+1}}while(0);if(!((d[c[c[e>>2]>>2]>>0]|0|0)!=101?(d[c[c[e>>2]>>2]>>0]|0|0)!=69:0)){p=c[e>>2]|0;if(d[c[c[e>>2]>>2]>>0]|0)c[p>>2]=(c[p>>2]|0)+1;if((d[c[c[e>>2]>>2]>>0]|0|0)==45){c[k>>2]=1;p=c[e>>2]|0;if(d[c[c[e>>2]>>2]>>0]|0)c[p>>2]=(c[p>>2]|0)+1}else if((d[c[c[e>>2]>>2]>>0]|0|0)==43?(p=c[e>>2]|0,(d[c[c[e>>2]>>2]>>0]|0|0)!=0):0)c[p>>2]=(c[p>>2]|0)+1;while(1){if((d[c[c[e>>2]>>2]>>0]|0|0)<48)break;if((d[c[c[e>>2]>>2]>>0]|0|0)>57)break;c[j>>2]=((c[j>>2]|0)*10|0)+((d[c[c[e>>2]>>2]>>0]|0)-48);p=c[e>>2]|0;if(!(d[c[c[e>>2]>>2]>>0]|0))continue;c[p>>2]=(c[p>>2]|0)+1}if(c[k>>2]|0)c[j>>2]=0-(c[j>>2]|0);r=+T(10,+ +(c[j>>2]|0));h[f>>3]=+h[f>>3]*r}j=c[(c[e>>2]|0)+32>>2]|0;k=c[(c[(c[e>>2]|0)+32>>2]|0)+12>>2]|0;du(j,k,-1,12,3,0,0,wt(c[(c[e>>2]|0)+12>>2]|0,+h[f>>3])|0,0)|0;i=b;return}function Tu(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;c[g>>2]=0;a=d[c[c[e>>2]>>2]>>0]|0;if((d[c[c[e>>2]>>2]>>0]|0|0)==34){h=c[e>>2]|0;if(a)c[h>>2]=(c[h>>2]|0)+1;c[f>>2]=c[c[e>>2]>>2];while(1){if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0)j=9;else if((d[c[c[e>>2]>>2]>>0]|0|0)!=13?32>(d[c[c[e>>2]>>2]>>0]|0|0):0)k=0;else j=9;if((j|0)==9){j=0;k=(d[c[c[e>>2]>>2]>>0]|0|0)!=34}l=d[c[c[e>>2]>>2]>>0]|0;if(!k)break;h=c[e>>2]|0;if(!l)continue;c[h>>2]=(c[h>>2]|0)+1}if(!(9<=(l|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0))j=15;if(((j|0)==15?(d[c[c[e>>2]>>2]>>0]|0|0)!=13:0)?32>(d[c[c[e>>2]>>2]>>0]|0|0):0){Nq(c[e>>2]|0,2);i=b;return}c[g>>2]=ly(c[f>>2]|0,(c[c[e>>2]>>2]|0)-(c[f>>2]|0)|0)|0;l=c[e>>2]|0;if(d[c[c[e>>2]>>2]>>0]|0)c[l>>2]=(c[l>>2]|0)+1}else{l=c[e>>2]|0;if((a|0)!=39){Nq(l,3);i=b;return}a=c[e>>2]|0;if(d[c[l>>2]>>0]|0)c[a>>2]=(c[a>>2]|0)+1;c[f>>2]=c[c[e>>2]>>2];while(1){if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0)j=28;else if((d[c[c[e>>2]>>2]>>0]|0|0)!=13?32>(d[c[c[e>>2]>>2]>>0]|0|0):0)m=0;else j=28;if((j|0)==28){j=0;m=(d[c[c[e>>2]>>2]>>0]|0|0)!=39}n=d[c[c[e>>2]>>2]>>0]|0;if(!m)break;a=c[e>>2]|0;if(!n)continue;c[a>>2]=(c[a>>2]|0)+1}if(!(9<=(n|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0))j=34;if(((j|0)==34?(d[c[c[e>>2]>>2]>>0]|0|0)!=13:0)?32>(d[c[c[e>>2]>>2]>>0]|0|0):0){Nq(c[e>>2]|0,2);i=b;return}c[g>>2]=ly(c[f>>2]|0,(c[c[e>>2]>>2]|0)-(c[f>>2]|0)|0)|0;f=c[e>>2]|0;if(d[c[c[e>>2]>>2]>>0]|0)c[f>>2]=(c[f>>2]|0)+1}if(!(c[g>>2]|0)){i=b;return}f=c[(c[e>>2]|0)+32>>2]|0;j=c[(c[(c[e>>2]|0)+32>>2]|0)+12>>2]|0;du(f,j,-1,12,4,0,0,Dt(c[(c[e>>2]|0)+12>>2]|0,c[g>>2]|0)|0,0)|0;zb[c[135736>>2]&511](c[g>>2]|0);i=b;return}function Uu(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+32|0;e=b+20|0;f=b+16|0;g=b+12|0;h=b+8|0;j=b+4|0;k=b;c[e>>2]=a;c[h>>2]=0;c[j>>2]=1;c[f>>2]=Xu(c[e>>2]|0,g)|0;if(!(c[f>>2]|0)){zb[c[135736>>2]&511](c[g>>2]|0);Nq(c[e>>2]|0,7);i=b;return}while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)l=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){l=1;break}l=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);m=d[c[c[e>>2]>>2]>>0]|0;if(!l)break;a=c[e>>2]|0;if(!m)continue;c[a>>2]=(c[a>>2]|0)+1}l=c[e>>2]|0;if((m|0)!=40){Nq(l,7);i=b;return}m=c[e>>2]|0;if(d[c[l>>2]>>0]|0)c[m>>2]=(c[m>>2]|0)+1;a:while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[e>>2]>>2]>>0]|0|0)!=13)break a}while(0);m=c[e>>2]|0;if(!(d[c[c[e>>2]>>2]>>0]|0))continue;c[m>>2]=(c[m>>2]|0)+1}if(((c[g>>2]|0)==0?(d[c[f>>2]>>0]|0|0)==99:0)?(qy(c[f>>2]|0,129608)|0)!=0:0)c[j>>2]=0;c[(c[(c[e>>2]|0)+32>>2]|0)+12>>2]=-1;b:do if((d[c[c[e>>2]>>2]>>0]|0|0)!=41){c:while(1){if(!(d[c[c[e>>2]>>2]>>0]|0))break b;c[k>>2]=c[(c[(c[e>>2]|0)+32>>2]|0)+12>>2];c[(c[(c[e>>2]|0)+32>>2]|0)+12>>2]=-1;Jt(c[e>>2]|0,c[j>>2]|0);if(c[(c[e>>2]|0)+8>>2]|0){n=27;break}du(c[(c[e>>2]|0)+32>>2]|0,c[k>>2]|0,c[(c[(c[e>>2]|0)+32>>2]|0)+12>>2]|0,15,0,0,0,0,0)|0;c[h>>2]=(c[h>>2]|0)+1;if((d[c[c[e>>2]>>2]>>0]|0|0)==41)break b;o=c[e>>2]|0;if((d[c[c[e>>2]>>2]>>0]|0|0)!=44){n=30;break}m=c[e>>2]|0;if(d[c[o>>2]>>0]|0)c[m>>2]=(c[m>>2]|0)+1;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[e>>2]>>2]>>0]|0|0)!=13)continue c}while(0);m=c[e>>2]|0;if(!(d[c[c[e>>2]>>2]>>0]|0))continue;c[m>>2]=(c[m>>2]|0)+1}}if((n|0)==27){zb[c[135736>>2]&511](c[f>>2]|0);zb[c[135736>>2]&511](c[g>>2]|0);i=b;return}else if((n|0)==30){Nq(o,7);i=b;return}}while(0);du(c[(c[e>>2]|0)+32>>2]|0,c[(c[(c[e>>2]|0)+32>>2]|0)+12>>2]|0,-1,14,c[h>>2]|0,0,0,c[f>>2]|0,c[g>>2]|0)|0;g=c[e>>2]|0;if(d[c[c[e>>2]>>2]>>0]|0)c[g>>2]=(c[g>>2]|0)+1;d:while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[e>>2]>>2]>>0]|0|0)!=13)break d}while(0);g=c[e>>2]|0;if(!(d[c[c[e>>2]>>2]>>0]|0))continue;c[g>>2]=(c[g>>2]|0)+1}i=b;return}function Vu(a){a=a|0;var b=0,e=0,f=0;b=i;i=i+16|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=0;switch(d[c[e>>2]>>0]|0|0){case 110:{if(qy(c[e>>2]|0,130600)|0)c[f>>2]=9;break}case 115:{if(qy(c[e>>2]|0,130664)|0)c[f>>2]=13;break}case 97:{if(qy(c[e>>2]|0,130456)|0)c[f>>2]=1;if(qy(c[e>>2]|0,130472)|0)c[f>>2]=2;if(qy(c[e>>2]|0,130496)|0)c[f>>2]=3;break}case 99:{if(qy(c[e>>2]|0,130512)|0)c[f>>2]=4;break}case 102:{if(qy(c[e>>2]|0,130560)|0)c[f>>2]=7;if(qy(c[e>>2]|0,130576)|0)c[f>>2]=8;break}case 112:{if(qy(c[e>>2]|0,130616)|0)c[f>>2]=10;if(qy(c[e>>2]|0,130624)|0)c[f>>2]=11;if(qy(c[e>>2]|0,130640)|0)c[f>>2]=12;break}case 100:{if(qy(c[e>>2]|0,130520)|0)c[f>>2]=5;if(qy(c[e>>2]|0,130536)|0)c[f>>2]=6;break}default:{}}i=b;return c[f>>2]|0}function Wu(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+48|0;j=h;k=h+32|0;l=h+28|0;m=h+24|0;n=h+20|0;o=h+16|0;p=h+12|0;q=h+8|0;c[l>>2]=a;c[m>>2]=b;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;if((c[m>>2]|0)==0|(c[n>>2]|0)==0|(c[o>>2]|0)==0){g=c[33976]|0;f=c[33980]|0;c[j>>2]=128552;c[j+4>>2]=11124;Db[g&511](f,129448,j);c[k>>2]=0;r=c[k>>2]|0;i=h;return r|0}c[c[n>>2]>>2]=0;c[c[m>>2]>>2]=0;c[c[o>>2]>>2]=0;a:while(1){do if((d[c[c[l>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[l>>2]>>2]>>0]|0|0)?(d[c[c[l>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[l>>2]>>2]>>0]|0|0)!=13)break a}while(0);j=c[l>>2]|0;if(!(d[c[c[l>>2]>>2]>>0]|0))continue;c[j>>2]=(c[j>>2]|0)+1}if((c[p>>2]|0)==0?(d[c[c[l>>2]>>2]>>0]|0|0)==42:0){j=c[l>>2]|0;if(d[c[c[l>>2]>>2]>>0]|0)c[j>>2]=(c[j>>2]|0)+1;c[c[m>>2]>>2]=3;c[k>>2]=0;r=c[k>>2]|0;i=h;return r|0}if(!(c[p>>2]|0))c[p>>2]=Ks(c[l>>2]|0)|0;j=c[l>>2]|0;if(!(c[p>>2]|0)){Nq(j,7);c[k>>2]=0;r=c[k>>2]|0;i=h;return r|0}do if((d[c[j>>2]>>0]|0|0)==32)s=1;else{if(9<=(d[c[c[l>>2]>>2]>>0]|0|0)?(d[c[c[l>>2]>>2]>>0]|0|0)<=10:0){s=1;break}s=(d[c[c[l>>2]>>2]>>0]|0|0)==13}while(0);c[q>>2]=s&1;while(1){do if((d[c[c[l>>2]>>2]>>0]|0|0)==32)t=1;else{if(9<=(d[c[c[l>>2]>>2]>>0]|0|0)?(d[c[c[l>>2]>>2]>>0]|0|0)<=10:0){t=1;break}t=(d[c[c[l>>2]>>2]>>0]|0|0)==13}while(0);u=d[c[c[l>>2]>>2]>>0]|0;if(!t)break;s=c[l>>2]|0;if(!u)continue;c[s>>2]=(c[s>>2]|0)+1}if((u|0)!=40){c[c[m>>2]>>2]=5;do if((c[q>>2]|0)==0?(d[c[c[l>>2]>>2]>>0]|0|0)==58:0){u=c[l>>2]|0;if(d[c[c[l>>2]>>2]>>0]|0)c[u>>2]=(c[u>>2]|0)+1;c[c[o>>2]>>2]=c[p>>2];u=c[l>>2]|0;if((d[c[c[l>>2]>>2]>>0]|0|0)!=42){c[p>>2]=Ks(u)|0;if(c[p>>2]|0)break;Nq(c[l>>2]|0,7);c[k>>2]=0;r=c[k>>2]|0;i=h;return r|0}t=c[l>>2]|0;if(d[c[u>>2]>>0]|0)c[t>>2]=(c[t>>2]|0)+1;c[c[m>>2]>>2]=3;c[k>>2]=0;r=c[k>>2]|0;i=h;return r|0}while(0);c[k>>2]=c[p>>2];r=c[k>>2]|0;i=h;return r|0}o=c[l>>2]|0;if(d[c[c[l>>2]>>2]>>0]|0)c[o>>2]=(c[o>>2]|0)+1;do if(qy(c[p>>2]|0,129416)|0)c[c[n>>2]>>2]=8;else{if(qy(c[p>>2]|0,129400)|0){c[c[n>>2]>>2]=0;break}if(qy(c[p>>2]|0,129424)|0){c[c[n>>2]>>2]=7;break}if(qy(c[p>>2]|0,129408)|0){c[c[n>>2]>>2]=3;break}if(c[p>>2]|0)zb[c[135736>>2]&511](c[p>>2]|0);Nq(c[l>>2]|0,7);c[k>>2]=0;r=c[k>>2]|0;i=h;return r|0}while(0);c[c[m>>2]>>2]=1;b:while(1){do if((d[c[c[l>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[l>>2]>>2]>>0]|0|0)?(d[c[c[l>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[l>>2]>>2]>>0]|0|0)!=13)break b}while(0);o=c[l>>2]|0;if(!(d[c[c[l>>2]>>2]>>0]|0))continue;c[o>>2]=(c[o>>2]|0)+1}c:do if((c[c[n>>2]>>2]|0)==7){if(c[p>>2]|0)zb[c[135736>>2]&511](c[p>>2]|0);c[p>>2]=0;if((d[c[c[l>>2]>>2]>>0]|0|0)!=41){c[p>>2]=Yu(c[l>>2]|0)|0;if(c[(c[l>>2]|0)+8>>2]|0){c[k>>2]=0;r=c[k>>2]|0;i=h;return r|0}c[c[m>>2]>>2]=2;while(1){do if((d[c[c[l>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[l>>2]>>2]>>0]|0|0)?(d[c[c[l>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[l>>2]>>2]>>0]|0|0)!=13)break c}while(0);o=c[l>>2]|0;if(!(d[c[c[l>>2]>>2]>>0]|0))continue;c[o>>2]=(c[o>>2]|0)+1}}}while(0);if((d[c[c[l>>2]>>2]>>0]|0|0)!=41){if(c[p>>2]|0)zb[c[135736>>2]&511](c[p>>2]|0);Nq(c[l>>2]|0,8);c[k>>2]=0;r=c[k>>2]|0;i=h;return r|0}else{m=c[l>>2]|0;if(d[c[c[l>>2]>>2]>>0]|0)c[m>>2]=(c[m>>2]|0)+1;c[k>>2]=c[p>>2];r=c[k>>2]|0;i=h;return r|0}return 0}function Xu(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;c[c[g>>2]>>2]=0;c[h>>2]=Ks(c[f>>2]|0)|0;if(!(c[h>>2]|0)){j=c[h>>2]|0;i=e;return j|0}if((d[c[c[f>>2]>>2]>>0]|0|0)!=58){j=c[h>>2]|0;i=e;return j|0}c[c[g>>2]>>2]=c[h>>2];g=c[f>>2]|0;if(d[c[c[f>>2]>>2]>>0]|0)c[g>>2]=(c[g>>2]|0)+1;c[h>>2]=Ks(c[f>>2]|0)|0;j=c[h>>2]|0;i=e;return j|0}function Yu(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[f>>2]=a;c[h>>2]=0;a=d[c[c[f>>2]>>2]>>0]|0;if((d[c[c[f>>2]>>2]>>0]|0|0)==34){j=c[f>>2]|0;if(a)c[j>>2]=(c[j>>2]|0)+1;c[g>>2]=c[c[f>>2]>>2];while(1){if(9<=(d[c[c[f>>2]>>2]>>0]|0|0)?(d[c[c[f>>2]>>2]>>0]|0|0)<=10:0)k=9;else if((d[c[c[f>>2]>>2]>>0]|0|0)!=13?32>(d[c[c[f>>2]>>2]>>0]|0|0):0)l=0;else k=9;if((k|0)==9){k=0;l=(d[c[c[f>>2]>>2]>>0]|0|0)!=34}m=d[c[c[f>>2]>>2]>>0]|0;if(!l)break;j=c[f>>2]|0;if(!m)continue;c[j>>2]=(c[j>>2]|0)+1}if(!(9<=(m|0)?(d[c[c[f>>2]>>2]>>0]|0|0)<=10:0))k=15;if(((k|0)==15?(d[c[c[f>>2]>>2]>>0]|0|0)!=13:0)?32>(d[c[c[f>>2]>>2]>>0]|0|0):0){Nq(c[f>>2]|0,2);c[e>>2]=0;n=c[e>>2]|0;i=b;return n|0}c[h>>2]=ly(c[g>>2]|0,(c[c[f>>2]>>2]|0)-(c[g>>2]|0)|0)|0;m=c[f>>2]|0;if(d[c[c[f>>2]>>2]>>0]|0)c[m>>2]=(c[m>>2]|0)+1}else{m=c[f>>2]|0;if((a|0)!=39){Nq(m,3);c[e>>2]=0;n=c[e>>2]|0;i=b;return n|0}a=c[f>>2]|0;if(d[c[m>>2]>>0]|0)c[a>>2]=(c[a>>2]|0)+1;c[g>>2]=c[c[f>>2]>>2];while(1){if(9<=(d[c[c[f>>2]>>2]>>0]|0|0)?(d[c[c[f>>2]>>2]>>0]|0|0)<=10:0)k=28;else if((d[c[c[f>>2]>>2]>>0]|0|0)!=13?32>(d[c[c[f>>2]>>2]>>0]|0|0):0)o=0;else k=28;if((k|0)==28){k=0;o=(d[c[c[f>>2]>>2]>>0]|0|0)!=39}p=d[c[c[f>>2]>>2]>>0]|0;if(!o)break;a=c[f>>2]|0;if(!p)continue;c[a>>2]=(c[a>>2]|0)+1}if(!(9<=(p|0)?(d[c[c[f>>2]>>2]>>0]|0|0)<=10:0))k=34;if(((k|0)==34?(d[c[c[f>>2]>>2]>>0]|0|0)!=13:0)?32>(d[c[c[f>>2]>>2]>>0]|0|0):0){Nq(c[f>>2]|0,2);c[e>>2]=0;n=c[e>>2]|0;i=b;return n|0}c[h>>2]=ly(c[g>>2]|0,(c[c[f>>2]>>2]|0)-(c[g>>2]|0)|0)|0;g=c[f>>2]|0;if(d[c[c[f>>2]>>2]>>0]|0)c[g>>2]=(c[g>>2]|0)+1}c[e>>2]=c[h>>2];n=c[e>>2]|0;i=b;return n|0}function Zu(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;do if(c[h>>2]|0){if(!(c[k>>2]|0)){c[g>>2]=0;break}if((c[j>>2]|0)<0){c[g>>2]=0;break}if((c[l>>2]|0)<0){c[g>>2]=0;break}c[m>>2]=Cb[c[135744>>2]&511](48)|0;if(!(c[m>>2]|0)){mv(131920);c[g>>2]=0;break}else{e=(c[m>>2]|0)+0|0;d=e+48|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(d|0));c[c[m>>2]>>2]=6;c[(c[m>>2]|0)+28>>2]=c[h>>2];c[(c[m>>2]|0)+32>>2]=c[j>>2];c[(c[m>>2]|0)+36>>2]=c[k>>2];c[(c[m>>2]|0)+40>>2]=c[l>>2];nv(c[m>>2]|0);c[g>>2]=c[m>>2];break}}else c[g>>2]=0;while(0);i=f;return c[g>>2]|0}function _u(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if(!(c[f>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}if(!(c[g>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}c[h>>2]=Cb[c[135744>>2]&511](48)|0;if(!(c[h>>2]|0)){mv(131920);c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}else{b=(c[h>>2]|0)+0|0;a=b+48|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(a|0));c[c[h>>2]>>2]=6;c[(c[h>>2]|0)+28>>2]=c[f>>2];
c[(c[h>>2]|0)+32>>2]=-1;c[(c[h>>2]|0)+36>>2]=c[g>>2];c[(c[h>>2]|0)+40>>2]=-1;nv(c[h>>2]|0);c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}return 0}function $u(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if(!(c[e>>2]|0)){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}c[f>>2]=Cb[c[135744>>2]&511](48)|0;if(!(c[f>>2]|0)){mv(131920);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{a=(c[f>>2]|0)+0|0;h=a+48|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(h|0));c[c[f>>2]>>2]=6;c[(c[f>>2]|0)+28>>2]=c[e>>2];c[(c[f>>2]|0)+32>>2]=-1;c[(c[f>>2]|0)+36>>2]=0;c[(c[f>>2]|0)+40>>2]=-1;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function av(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;c[g>>2]=a;c[h>>2]=b;if(!(c[g>>2]|0)){c[f>>2]=0;k=c[f>>2]|0;i=d;return k|0}if(!(c[h>>2]|0)){c[f>>2]=0;k=c[f>>2]|0;i=d;return k|0}b=c[c[h>>2]>>2]|0;if((b|0)==1)l=6;else if(!((b|0)==6|(b|0)==5)){c[f>>2]=0;k=c[f>>2]|0;i=d;return k|0}if((l|0)==6?(c[c[(c[h>>2]|0)+4>>2]>>2]|0)<=0:0){c[f>>2]=0;k=c[f>>2]|0;i=d;return k|0}c[j>>2]=Cb[c[135744>>2]&511](48)|0;if(!(c[j>>2]|0)){mv(131920);c[f>>2]=0;k=c[f>>2]|0;i=d;return k|0}l=(c[j>>2]|0)+0|0;b=l+48|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(b|0));c[c[j>>2]>>2]=6;c[(c[j>>2]|0)+28>>2]=c[g>>2];c[(c[j>>2]|0)+32>>2]=-1;g=c[c[h>>2]>>2]|0;if((g|0)==1){c[(c[j>>2]|0)+36>>2]=c[(c[(c[(c[h>>2]|0)+4>>2]|0)+8>>2]|0)+((c[c[(c[h>>2]|0)+4>>2]>>2]|0)-1<<2)>>2];c[(c[j>>2]|0)+40>>2]=-1}else if((g|0)==5){c[(c[j>>2]|0)+36>>2]=c[(c[h>>2]|0)+28>>2];c[(c[j>>2]|0)+40>>2]=c[(c[h>>2]|0)+32>>2]}else if((g|0)==6){c[(c[j>>2]|0)+36>>2]=c[(c[h>>2]|0)+36>>2];c[(c[j>>2]|0)+40>>2]=c[(c[h>>2]|0)+40>>2]}else{h=c[33976]|0;g=c[33980]|0;c[e>>2]=131976;c[e+4>>2]=590;Db[h&511](g,131944,e);c[f>>2]=0;k=c[f>>2]|0;i=d;return k|0}nv(c[j>>2]|0);c[f>>2]=c[j>>2];k=c[f>>2]|0;i=d;return k|0}function bv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](12)|0;if(!(c[f>>2]|0)){mv(132e3);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}a=c[f>>2]|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;do if(c[e>>2]|0){a=Cb[c[135744>>2]&511](40)|0;c[(c[f>>2]|0)+8>>2]=a;if(c[(c[f>>2]|0)+8>>2]|0){a=(c[(c[f>>2]|0)+8>>2]|0)+0|0;h=a+40|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(h|0));c[(c[f>>2]|0)+4>>2]=10;a=c[e>>2]|0;h=c[f>>2]|0;j=c[h>>2]|0;c[h>>2]=j+1;c[(c[(c[f>>2]|0)+8>>2]|0)+(j<<2)>>2]=a;break}mv(132e3);zb[c[135736>>2]&511](c[f>>2]|0);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}while(0);c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}function cv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;if((c[e>>2]|0)==0|(c[f>>2]|0)==0){i=d;return}c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[c[e>>2]>>2]|0))break;if(ov(c[(c[(c[e>>2]|0)+8>>2]|0)+(c[g>>2]<<2)>>2]|0,c[f>>2]|0)|0){j=5;break}c[g>>2]=(c[g>>2]|0)+1}if((j|0)==5){Qq(c[f>>2]|0);i=d;return}do if(c[(c[e>>2]|0)+4>>2]|0){if((c[c[e>>2]>>2]|0)==(c[(c[e>>2]|0)+4>>2]|0)){j=(c[e>>2]|0)+4|0;c[j>>2]=c[j>>2]<<1;c[h>>2]=Hb[c[135760>>2]&511](c[(c[e>>2]|0)+8>>2]|0,c[(c[e>>2]|0)+4>>2]<<2)|0;if(c[h>>2]|0){c[(c[e>>2]|0)+8>>2]=c[h>>2];break}mv(132024);i=d;return}}else{j=Cb[c[135744>>2]&511](40)|0;c[(c[e>>2]|0)+8>>2]=j;if(c[(c[e>>2]|0)+8>>2]|0){j=(c[(c[e>>2]|0)+8>>2]|0)+0|0;g=j+40|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(g|0));c[(c[e>>2]|0)+4>>2]=10;break}mv(132024);i=d;return}while(0);h=c[f>>2]|0;f=c[e>>2]|0;j=c[f>>2]|0;c[f>>2]=j+1;c[(c[(c[e>>2]|0)+8>>2]|0)+(j<<2)>>2]=h;i=d;return}function dv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if(!(c[f>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}if(!(c[g>>2]|0)){c[e>>2]=c[f>>2];j=c[e>>2]|0;i=d;return j|0}c[h>>2]=0;while(1){k=c[f>>2]|0;if((c[h>>2]|0)>=(c[c[g>>2]>>2]|0))break;cv(k,c[(c[(c[g>>2]|0)+8>>2]|0)+(c[h>>2]<<2)>>2]|0);c[h>>2]=(c[h>>2]|0)+1}c[e>>2]=k;j=c[e>>2]|0;i=d;return j|0}function ev(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+8>>2]|0){c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[c[d>>2]>>2]|0))break;Qq(c[(c[(c[d>>2]|0)+8>>2]|0)+(c[e>>2]<<2)>>2]|0);c[e>>2]=(c[e>>2]|0)+1}zb[c[135736>>2]&511](c[(c[d>>2]|0)+8>>2]|0)}zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function fv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=Cb[c[135744>>2]&511](48)|0;if(!(c[h>>2]|0)){mv(132e3);c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}b=(c[h>>2]|0)+0|0;a=b+48|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(a|0));c[c[h>>2]>>2]=7;b=c[f>>2]|0;if(!(c[g>>2]|0)){f=bv($u(b)|0)|0;c[(c[h>>2]|0)+28>>2]=f}else{f=bv(_u(b,c[g>>2]|0)|0)|0;c[(c[h>>2]|0)+28>>2]=f}c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}function gv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](48)|0;if(!(c[f>>2]|0)){mv(132e3);c[d>>2]=0;j=c[d>>2]|0;i=b;return j|0}a=(c[f>>2]|0)+0|0;k=a+48|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(k|0));c[c[f>>2]>>2]=7;if(c[e>>2]|0){c[h>>2]=bv(0)|0;if(!(c[h>>2]|0)){c[d>>2]=c[f>>2];j=c[d>>2]|0;i=b;return j|0}c[g>>2]=0;while(1){l=c[h>>2]|0;if((c[g>>2]|0)>=(c[c[e>>2]>>2]|0))break;cv(l,$u(c[(c[(c[e>>2]|0)+8>>2]|0)+(c[g>>2]<<2)>>2]|0)|0);c[g>>2]=(c[g>>2]|0)+1}c[(c[f>>2]|0)+28>>2]=l}c[d>>2]=c[f>>2];j=c[d>>2]|0;i=b;return j|0}function hv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](48)|0;if(!(c[f>>2]|0)){mv(132e3);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{a=(c[f>>2]|0)+0|0;h=a+48|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(h|0));c[c[f>>2]>>2]=7;c[(c[f>>2]|0)+28>>2]=c[e>>2];c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function iv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=Lr(c[g>>2]|0)|0;g=c[k>>2]|0;if(!(c[k>>2]|0)){c[f>>2]=g;l=c[f>>2]|0;i=e;return l|0}else{c[g+76>>2]=1;c[(c[k>>2]|0)+80>>2]=c[h>>2];c[(c[k>>2]|0)+84>>2]=c[j>>2];jr(c[k>>2]|0,132048,306)|0;jr(c[k>>2]|0,132064,307)|0;jr(c[k>>2]|0,132072,308)|0;jr(c[k>>2]|0,132088,309)|0;jr(c[k>>2]|0,132104,310)|0;jr(c[k>>2]|0,132120,311)|0;jr(c[k>>2]|0,132136,312)|0;jr(c[k>>2]|0,132144,313)|0;c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}return 0}function jv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+48|0;e=d+36|0;f=d+32|0;g=d+28|0;h=d+24|0;j=d+20|0;k=d+16|0;l=d+12|0;m=d+8|0;n=d+4|0;o=d;c[e>>2]=a;c[f>>2]=b;c[m>>2]=0;if((c[e>>2]|0)==0|(c[e>>2]|0)==0){i=d;return}b=c[e>>2]|0;if((c[f>>2]|0)!=1){Nq(b,12);i=d;return}f=c[e>>2]|0;if((c[b+20>>2]|0)<((c[(c[e>>2]|0)+44>>2]|0)+1|0)){Nq(f,23);i=d;return}if((c[f+16>>2]|0)!=0?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)==1:0){c[k>>2]=Sq(c[e>>2]|0)|0;c[n>>2]=c[(c[k>>2]|0)+4>>2];c[(c[(c[e>>2]|0)+12>>2]|0)+4>>2]=0;c[h>>2]=c[c[e>>2]>>2];c[m>>2]=bv(0)|0;c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[c[n>>2]>>2]|0))break;c[c[e>>2]>>2]=c[h>>2];c[(c[(c[e>>2]|0)+12>>2]|0)+4>>2]=c[(c[(c[n>>2]|0)+8>>2]|0)+(c[o>>2]<<2)>>2];c[l>>2]=gr(c[(c[(c[e>>2]|0)+12>>2]|0)+4>>2]|0)|0;Tq(c[e>>2]|0,c[l>>2]|0)|0;Qs(c[e>>2]|0);if(c[(c[e>>2]|0)+8>>2]|0){p=20;break}c[j>>2]=Sq(c[e>>2]|0)|0;c[g>>2]=av(c[(c[(c[n>>2]|0)+8>>2]|0)+(c[o>>2]<<2)>>2]|0,c[j>>2]|0)|0;if(c[g>>2]|0)cv(c[m>>2]|0,c[g>>2]|0);if(c[j>>2]|0)Qq(c[j>>2]|0);if((c[(c[e>>2]|0)+16>>2]|0)==(c[l>>2]|0)){c[j>>2]=Sq(c[e>>2]|0)|0;Qq(c[j>>2]|0)}c[(c[(c[e>>2]|0)+12>>2]|0)+4>>2]=0;c[o>>2]=(c[o>>2]|0)+1}if((p|0)==20){i=d;return}Qq(c[k>>2]|0);c[(c[(c[e>>2]|0)+12>>2]|0)+4>>2]=0;c[(c[(c[e>>2]|0)+12>>2]|0)+68>>2]=-1;c[(c[(c[e>>2]|0)+12>>2]|0)+72>>2]=-1;k=c[e>>2]|0;Tq(k,hv(c[m>>2]|0)|0)|0;i=d;return}Nq(c[e>>2]|0,11);i=d;return}function kv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+48|0;e=d+32|0;f=d+28|0;g=d+24|0;h=d+20|0;j=d+16|0;k=d+12|0;l=d+8|0;m=d+4|0;n=d;c[f>>2]=a;c[g>>2]=b;c[j>>2]=0;c[l>>2]=0;c[m>>2]=0;Kq();if((c[g>>2]|0)==0|(c[f>>2]|0)==0){c[e>>2]=0;o=c[e>>2]|0;i=d;return o|0}c[h>>2]=Or(c[f>>2]|0,c[g>>2]|0)|0;if(!(c[h>>2]|0)){c[e>>2]=0;o=c[e>>2]|0;i=d;return o|0}c[(c[h>>2]|0)+36>>2]=1;wv(c[h>>2]|0);if(((c[(c[h>>2]|0)+16>>2]|0)!=0?(c[c[(c[h>>2]|0)+16>>2]>>2]|0)!=1:0)?(c[c[(c[h>>2]|0)+16>>2]>>2]|0)!=7:0)xv(c[h>>2]|0,1902,132152,0);else c[j>>2]=Sq(c[h>>2]|0)|0;do{c[k>>2]=Sq(c[h>>2]|0)|0;if(c[k>>2]|0){do if((c[k>>2]|0)!=(c[l>>2]|0)){if((c[c[k>>2]>>2]|0)!=1){c[m>>2]=(c[m>>2]|0)+1;break}c[n>>2]=c[(c[k>>2]|0)+4>>2];if((c[c[n>>2]>>2]|0)==1?(c[c[(c[n>>2]|0)+8>>2]>>2]|0)==(c[c[g>>2]>>2]|0):0)break;c[m>>2]=(c[m>>2]|0)+1}while(0);Qq(c[k>>2]|0)}}while((c[k>>2]|0)!=0);if(c[m>>2]|0)xv(c[h>>2]|0,1903,132208,0);if(c[(c[h>>2]|0)+8>>2]|0){Qq(c[j>>2]|0);c[j>>2]=0}Pr(c[h>>2]|0);c[e>>2]=c[j>>2];o=c[e>>2]|0;i=d;return o|0}function lv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d;f=d+16|0;g=d+12|0;h=d+8|0;c[g>>2]=a;c[h>>2]=b;a:while(1){if(!(c[g>>2]|0)){j=4;break}if((c[(c[g>>2]|0)+4>>2]|0)==18){j=4;break}if(c[(c[g>>2]|0)+12>>2]|0){c[g>>2]=c[(c[g>>2]|0)+12>>2];if(c[h>>2]|0){b=c[h>>2]|0;c[b>>2]=(c[b>>2]|0)+1;j=17}else j=17}b:while(1){if((j|0)==17){j=0;if((c[(c[g>>2]|0)+4>>2]|0)==1){j=24;break a}if((c[(c[g>>2]|0)+4>>2]|0)==3){j=24;break a}if((c[(c[g>>2]|0)+4>>2]|0)==9){j=24;break a}if((c[(c[g>>2]|0)+4>>2]|0)==13){j=24;break a}if((c[(c[g>>2]|0)+4>>2]|0)==4){j=24;break a}if((c[(c[g>>2]|0)+4>>2]|0)!=5)continue a;b=c[33976]|0;a=c[33980]|0;c[e>>2]=131976;c[e+4>>2]=2362;Db[b&511](a,132256,e)}if(c[(c[g>>2]|0)+24>>2]|0){c[g>>2]=c[(c[g>>2]|0)+24>>2];j=17;continue}while(1){c[g>>2]=c[(c[g>>2]|0)+20>>2];if(c[h>>2]|0){a=c[h>>2]|0;c[a>>2]=(c[a>>2]|0)+-1}if(!(c[g>>2]|0)){j=13;break a}k=c[g>>2]|0;if(c[(c[g>>2]|0)+24>>2]|0)break;if(!k){j=17;continue b}}c[g>>2]=c[k+24>>2];j=17}}if((j|0)==4){c[f>>2]=0;l=c[f>>2]|0;i=d;return l|0}else if((j|0)==13){c[f>>2]=0;l=c[f>>2]|0;i=d;return l|0}else if((j|0)==24){c[f>>2]=c[g>>2];l=c[f>>2]|0;i=d;return l|0}return 0}function mv(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;e=b+4|0;c[e>>2]=a;a=c[e>>2]|0;c[d>>2]=c[e>>2];Xd(0,0,0,0,0,13,2,2,0,0,a,0,0,0,0,132472,d);i=b;return}function nv(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if((c[c[d>>2]>>2]|0)!=6){i=b;return}if(!(c[(c[d>>2]|0)+36>>2]|0)){i=b;return}c[e>>2]=yv(c[(c[d>>2]|0)+28>>2]|0,c[(c[d>>2]|0)+32>>2]|0,c[(c[d>>2]|0)+36>>2]|0,c[(c[d>>2]|0)+40>>2]|0)|0;if((c[e>>2]|0)!=-1){i=b;return}c[f>>2]=c[(c[d>>2]|0)+28>>2];c[(c[d>>2]|0)+28>>2]=c[(c[d>>2]|0)+36>>2];c[(c[d>>2]|0)+36>>2]=c[f>>2];c[e>>2]=c[(c[d>>2]|0)+32>>2];c[(c[d>>2]|0)+32>>2]=c[(c[d>>2]|0)+40>>2];c[(c[d>>2]|0)+40>>2]=c[e>>2];i=b;return}function ov(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;do if((c[f>>2]|0)!=(c[g>>2]|0)){if((c[f>>2]|0)==0|(c[g>>2]|0)==0){c[e>>2]=0;break}if((c[c[f>>2]>>2]|0)!=(c[c[g>>2]>>2]|0)){c[e>>2]=0;break}if((c[c[f>>2]>>2]|0)!=6){c[e>>2]=0;break}if((c[(c[f>>2]|0)+28>>2]|0)!=(c[(c[g>>2]|0)+28>>2]|0)){c[e>>2]=0;break}if((c[(c[f>>2]|0)+32>>2]|0)!=(c[(c[g>>2]|0)+32>>2]|0)){c[e>>2]=0;break}if((c[(c[f>>2]|0)+36>>2]|0)!=(c[(c[g>>2]|0)+36>>2]|0)){c[e>>2]=0;break}if((c[(c[f>>2]|0)+40>>2]|0)!=(c[(c[g>>2]|0)+40>>2]|0)){c[e>>2]=0;break}else{c[e>>2]=1;break}}else c[e>>2]=1;while(0);i=d;return c[e>>2]|0}function pv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}b=c[e>>2]|0;if((c[f>>2]|0)!=1){Nq(b,12);i=d;return}f=c[e>>2]|0;if((c[b+20>>2]|0)<((c[(c[e>>2]|0)+44>>2]|0)+1|0)){Nq(f,23);i=d;return}do if(c[f+16>>2]|0){if((c[c[(c[e>>2]|0)+16>>2]>>2]|0)!=7?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)!=1:0)break;c[h>>2]=Sq(c[e>>2]|0)|0;do if((c[c[h>>2]>>2]|0)==1){c[l>>2]=gv(c[(c[h>>2]|0)+4>>2]|0)|0;Qq(c[h>>2]|0);if(c[l>>2]|0){c[h>>2]=c[l>>2];break}Nq(c[e>>2]|0,15);i=d;return}while(0);c[j>>2]=c[(c[h>>2]|0)+28>>2];c[k>>2]=bv(0)|0;if(!(c[k>>2]|0)){Qq(c[h>>2]|0);Nq(c[e>>2]|0,15);i=d;return}c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[c[j>>2]>>2]|0))break;b=c[k>>2]|0;cv(b,zv(c[e>>2]|0,c[(c[(c[j>>2]|0)+8>>2]|0)+(c[g>>2]<<2)>>2]|0)|0);c[g>>2]=(c[g>>2]|0)+1}b=c[e>>2]|0;Tq(b,hv(c[k>>2]|0)|0)|0;Qq(c[h>>2]|0);i=d;return}while(0);Nq(c[e>>2]|0,11);i=d;return}function qv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}b=c[e>>2]|0;if((c[f>>2]|0)!=1){Nq(b,12);i=d;return}f=c[e>>2]|0;if((c[b+20>>2]|0)<((c[(c[e>>2]|0)+44>>2]|0)+1|0)){Nq(f,23);i=d;return}do if(c[f+16>>2]|0){if((c[c[(c[e>>2]|0)+16>>2]>>2]|0)!=7?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)!=1:0)break;c[h>>2]=Sq(c[e>>2]|0)|0;do if((c[c[h>>2]>>2]|0)==1){c[l>>2]=gv(c[(c[h>>2]|0)+4>>2]|0)|0;Qq(c[h>>2]|0);if(c[l>>2]|0){c[h>>2]=c[l>>2];break}Nq(c[e>>2]|0,15);i=d;return}while(0);c[j>>2]=c[(c[h>>2]|0)+28>>2];c[k>>2]=bv(0)|0;if(!(c[k>>2]|0)){Qq(c[h>>2]|0);Nq(c[e>>2]|0,15);i=d;return}c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[c[j>>2]>>2]|0))break;b=c[k>>2]|0;cv(b,Av(c[e>>2]|0,c[(c[(c[j>>2]|0)+8>>2]|0)+(c[g>>2]<<2)>>2]|0)|0);c[g>>2]=(c[g>>2]|0)+1}b=c[e>>2]|0;Tq(b,hv(c[k>>2]|0)|0)|0;Qq(c[h>>2]|0);i=d;return}while(0);Nq(c[e>>2]|0,11);i=d;return}function rv(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=i;i=i+96|0;f=e+80|0;g=e+76|0;j=e+72|0;k=e+68|0;l=e+64|0;m=e+60|0;n=e+56|0;o=e+52|0;p=e+48|0;q=e+44|0;r=e+40|0;s=e+36|0;t=e+32|0;u=e+28|0;v=e+24|0;w=e+20|0;x=e+16|0;y=e+12|0;z=e+8|0;A=e+4|0;B=e;c[f>>2]=a;c[g>>2]=b;c[l>>2]=0;c[o>>2]=0;c[u>>2]=0;c[v>>2]=0;c[x>>2]=0;c[y>>2]=0;if((c[g>>2]|0)<2|(c[g>>2]|0)>4){Nq(c[f>>2]|0,12);i=e;return}do if((c[g>>2]|0)>=4){if((c[(c[f>>2]|0)+16>>2]|0)!=0?(c[c[(c[f>>2]|0)+16>>2]>>2]|0)==3:0){c[v>>2]=Sq(c[f>>2]|0)|0;if(!(c[v>>2]|0))break;c[y>>2]=~~+h[(c[v>>2]|0)+16>>3];break}Nq(c[f>>2]|0,11);i=e;return}while(0);do if((c[g>>2]|0)>=3){if((c[(c[f>>2]|0)+16>>2]|0)!=0?(c[c[(c[f>>2]|0)+16>>2]>>2]|0)==3:0){c[u>>2]=Sq(c[f>>2]|0)|0;if(!(c[u>>2]|0))break;c[x>>2]=~~+h[(c[u>>2]|0)+16>>3];break}Nq(c[f>>2]|0,11);i=e;return}while(0);if((c[(c[f>>2]|0)+16>>2]|0)!=0?(c[c[(c[f>>2]|0)+16>>2]>>2]|0)==4:0){c[t>>2]=Sq(c[f>>2]|0)|0;do if(c[(c[f>>2]|0)+16>>2]|0){if((c[c[(c[f>>2]|0)+16>>2]>>2]|0)!=7?(c[c[(c[f>>2]|0)+16>>2]>>2]|0)!=1:0)break;c[q>>2]=Sq(c[f>>2]|0)|0;c[s>>2]=bv(0)|0;g=c[q>>2]|0;if(!(c[s>>2]|0)){Qq(g);Nq(c[f>>2]|0,15);i=e;return}a:do if(c[g+4>>2]|0){do if((c[c[q>>2]>>2]|0)==1){c[z>>2]=gv(c[(c[q>>2]|0)+4>>2]|0)|0;Qq(c[q>>2]|0);if(c[z>>2]|0){c[q>>2]=c[z>>2];break}Nq(c[f>>2]|0,15);i=e;return}while(0);c[r>>2]=c[(c[q>>2]|0)+28>>2];c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[c[r>>2]>>2]|0))break a;Bv(c[(c[(c[r>>2]|0)+8>>2]|0)+(c[j>>2]<<2)>>2]|0,n,k)|0;Cv(c[(c[(c[r>>2]|0)+8>>2]|0)+(c[j>>2]<<2)>>2]|0,o,l)|0;Dv(n,k,0)|0;Ev(o,l)|0;do{c[p>>2]=c[o>>2];c[m>>2]=c[l>>2];c[w>>2]=Fv(c[(c[t>>2]|0)+24>>2]|0,n,k,p,m)|0;if((c[w>>2]|0)==1){do if(c[u>>2]|0){if(Dv(n,k,(c[x>>2]|0)-1|0)|0)break;if((c[v>>2]|0)!=0&(c[y>>2]|0)>0){c[B>>2]=c[n>>2];c[A>>2]=(c[k>>2]|0)-1;if(Dv(B,A,c[y>>2]|0)|0)break;b=c[s>>2]|0;cv(b,Zu(c[n>>2]|0,c[k>>2]|0,c[B>>2]|0,c[A>>2]|0)|0);break}b=c[s>>2]|0;a=c[n>>2]|0;C=c[k>>2]|0;if((c[v>>2]|0)!=0&(c[y>>2]|0)<=0){cv(b,Zu(a,C,c[n>>2]|0,c[k>>2]|0)|0);break}else{cv(b,Zu(a,C,c[p>>2]|0,c[m>>2]|0)|0);break}}else{C=c[s>>2]|0;cv(C,Zu(c[n>>2]|0,c[k>>2]|0,c[p>>2]|0,c[m>>2]|0)|0)}while(0);c[n>>2]=c[p>>2];c[k>>2]=c[m>>2];if(!(d[c[(c[t>>2]|0)+24>>2]>>0]|0))c[k>>2]=(c[k>>2]|0)+1}}while((c[w>>2]|0)==1);c[j>>2]=(c[j>>2]|0)+1}}while(0);g=c[f>>2]|0;Tq(g,hv(c[s>>2]|0)|0)|0;Qq(c[q>>2]|0);Qq(c[t>>2]|0);if(c[u>>2]|0)Qq(c[u>>2]|0);if(!(c[v>>2]|0)){i=e;return}Qq(c[v>>2]|0);i=e;return}while(0);Nq(c[f>>2]|0,11);i=e;return}Nq(c[f>>2]|0,11);i=e;return}function sv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+48|0;e=d+32|0;f=d+28|0;g=d+24|0;h=d+20|0;j=d+16|0;k=d+12|0;l=d+8|0;m=d+4|0;n=d;c[e>>2]=a;c[f>>2]=b;c[k>>2]=0;c[l>>2]=0;if(!(c[e>>2]|0)){i=d;return}b=c[e>>2]|0;if((c[f>>2]|0)!=1){Nq(b,12);i=d;return}f=c[e>>2]|0;if((c[b+20>>2]|0)<((c[(c[e>>2]|0)+44>>2]|0)+1|0)){Nq(f,23);i=d;return}do if(c[f+16>>2]|0){if((c[c[(c[e>>2]|0)+16>>2]>>2]|0)!=7?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)!=1:0)break;c[h>>2]=Sq(c[e>>2]|0)|0;do if((c[c[h>>2]>>2]|0)==1){c[g>>2]=gv(c[(c[h>>2]|0)+4>>2]|0)|0;Qq(c[h>>2]|0);if(c[g>>2]|0){c[h>>2]=c[g>>2];break}Nq(c[e>>2]|0,15);i=d;return}while(0);c[k>>2]=bv(0)|0;b=c[h>>2]|0;if(!(c[k>>2]|0)){Qq(b);Nq(c[e>>2]|0,15);i=d;return}c[l>>2]=c[b+28>>2];a:do if(c[l>>2]|0){c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[c[l>>2]>>2]|0))break a;c[g>>2]=c[(c[(c[l>>2]|0)+8>>2]|0)+(c[m>>2]<<2)>>2];if(c[g>>2]|0){c[j>>2]=0;b=c[c[g>>2]>>2]|0;if((b|0)==5)c[j>>2]=Gv(c[(c[g>>2]|0)+28>>2]|0,c[(c[g>>2]|0)+32>>2]|0)|0;else if((b|0)==6?(c[n>>2]=c[(c[g>>2]|0)+28>>2],(c[n>>2]|0)!=0):0){if((c[(c[n>>2]|0)+4>>2]|0)==2)break;c[j>>2]=Gv(c[n>>2]|0,c[(c[g>>2]|0)+32>>2]|0)|0}if(c[j>>2]|0)cv(c[k>>2]|0,c[j>>2]|0)}c[m>>2]=(c[m>>2]|0)+1}Qq(c[h>>2]|0);ev(c[k>>2]|0);Nq(c[e>>2]|0,16);i=d;return}while(0);Qq(c[h>>2]|0);b=c[e>>2]|0;Tq(b,hv(c[k>>2]|0)|0)|0;i=d;return}while(0);Nq(c[e>>2]|0,11);i=d;return}function tv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+48|0;e=d+32|0;f=d+28|0;g=d+24|0;h=d+20|0;j=d+16|0;k=d+12|0;l=d+8|0;m=d+4|0;n=d;c[e>>2]=a;c[f>>2]=b;c[k>>2]=0;c[l>>2]=0;if(!(c[e>>2]|0)){i=d;return}b=c[e>>2]|0;if((c[f>>2]|0)!=1){Nq(b,12);i=d;return}f=c[e>>2]|0;if((c[b+20>>2]|0)<((c[(c[e>>2]|0)+44>>2]|0)+1|0)){Nq(f,23);i=d;return}do if(c[f+16>>2]|0){if((c[c[(c[e>>2]|0)+16>>2]>>2]|0)!=7?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)!=1:0)break;c[h>>2]=Sq(c[e>>2]|0)|0;do if((c[c[h>>2]>>2]|0)==1){c[g>>2]=gv(c[(c[h>>2]|0)+4>>2]|0)|0;Qq(c[h>>2]|0);if(c[g>>2]|0){c[h>>2]=c[g>>2];break}Nq(c[e>>2]|0,15);i=d;return}while(0);c[k>>2]=bv(0)|0;b=c[h>>2]|0;if(!(c[k>>2]|0)){Qq(b);Nq(c[e>>2]|0,15);i=d;return}c[l>>2]=c[b+28>>2];a:do if(c[l>>2]|0){c[m>>2]=0;b:while(1){if((c[m>>2]|0)>=(c[c[l>>2]>>2]|0))break a;c[g>>2]=c[(c[(c[l>>2]|0)+8>>2]|0)+(c[m>>2]<<2)>>2];if(c[g>>2]|0){c[j>>2]=0;b=c[c[g>>2]>>2]|0;do if((b|0)==6){c[n>>2]=c[(c[g>>2]|0)+36>>2];if(c[n>>2]|0){if((c[(c[n>>2]|0)+4>>2]|0)==2)break b;c[j>>2]=Gv(c[n>>2]|0,c[(c[g>>2]|0)+40>>2]|0)|0;break}else{if(c[(c[g>>2]|0)+28>>2]|0)break;a=c[n>>2]|0;c[j>>2]=Gv(a,Hv(c[n>>2]|0)|0)|0;break}}else if((b|0)==5)c[j>>2]=Gv(c[(c[g>>2]|0)+28>>2]|0,c[(c[g>>2]|0)+32>>2]|0)|0;while(0);if(c[j>>2]|0)cv(c[k>>2]|0,c[j>>2]|0)}c[m>>2]=(c[m>>2]|0)+1}Qq(c[h>>2]|0);ev(c[k>>2]|0);Nq(c[e>>2]|0,16);i=d;return}while(0);Qq(c[h>>2]|0);b=c[e>>2]|0;Tq(b,hv(c[k>>2]|0)|0)|0;i=d;return}while(0);Nq(c[e>>2]|0,11);i=d;return}function uv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}b=c[e>>2]|0;if(c[f>>2]|0){Nq(b,12);i=d;return}f=c[e>>2]|0;if((c[b+20>>2]|0)<((c[(c[e>>2]|0)+44>>2]|0)+0|0)){Nq(f,23);i=d;return}b=c[e>>2]|0;if(!(c[(c[f+12>>2]|0)+80>>2]|0)){Nq(b,16);i=d;return}else{Tq(b,fv(c[(c[(c[e>>2]|0)+12>>2]|0)+80>>2]|0,0)|0)|0;i=d;return}}function vv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}b=c[e>>2]|0;if(c[f>>2]|0){Nq(b,12);i=d;return}f=c[e>>2]|0;if((c[b+20>>2]|0)<((c[(c[e>>2]|0)+44>>2]|0)+0|0)){Nq(f,23);i=d;return}b=c[e>>2]|0;if(!(c[(c[f+12>>2]|0)+84>>2]|0)){Nq(b,16);i=d;return}else{Tq(b,fv(c[(c[(c[e>>2]|0)+12>>2]|0)+84>>2]|0,0)|0)|0;i=d;return}}function wv(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;e=b+4|0;f=b;c[e>>2]=a;do if(!(c[(c[e>>2]|0)+28>>2]|0)){a=Cb[c[135744>>2]&511](40)|0;c[(c[e>>2]|0)+28>>2]=a;if(c[(c[e>>2]|0)+28>>2]|0){c[(c[e>>2]|0)+20>>2]=0;c[(c[e>>2]|0)+24>>2]=10;c[(c[e>>2]|0)+16>>2]=0;c[(c[e>>2]|0)+44>>2]=0;break}mv(132312);i=b;return}while(0);while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)g=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){g=1;break}g=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);h=d[c[c[e>>2]>>2]>>0]|0;if(!g)break;a=c[e>>2]|0;if(!h)continue;c[a>>2]=(c[a>>2]|0)+1}g=c[e>>2]|0;do if((h|0)==47){ks(g);Iv(c[e>>2]|0,0)}else{c[f>>2]=Ls(g)|0;a=c[e>>2]|0;if(!(c[f>>2]|0)){Nq(a,7);i=b;return}j=c[e>>2]|0;k=c[f>>2]|0;if((d[c[a>>2]>>0]|0|0)!=40){Iv(j,k);break}Jv(j,k);i=b;return}while(0);while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)l=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){l=1;break}l=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);m=(d[c[c[e>>2]>>2]>>0]|0|0)!=0;if(!l)break;f=c[e>>2]|0;if(!m)continue;c[f>>2]=(c[f>>2]|0)+1}if(!m){i=b;return}Nq(c[e>>2]|0,7);i=b;return}function xv(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if(c[h>>2]|0)c[(c[h>>2]|0)+8>>2]=c[j>>2];if((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+12>>2]|0)!=0:0){c[(c[(c[h>>2]|0)+12>>2]|0)+136>>2]=13;c[(c[(c[h>>2]|0)+12>>2]|0)+140>>2]=c[j>>2];c[(c[(c[h>>2]|0)+12>>2]|0)+148>>2]=2;e=my(c[(c[h>>2]|0)+4>>2]|0)|0;c[(c[(c[h>>2]|0)+12>>2]|0)+160>>2]=e;c[(c[(c[h>>2]|0)+12>>2]|0)+172>>2]=(c[c[h>>2]>>2]|0)-(c[(c[h>>2]|0)+4>>2]|0);c[(c[(c[h>>2]|0)+12>>2]|0)+184>>2]=c[(c[(c[h>>2]|0)+12>>2]|0)+188>>2];e=c[(c[h>>2]|0)+12>>2]|0;if(c[(c[(c[h>>2]|0)+12>>2]|0)+132>>2]|0){Ab[c[e+132>>2]&511](c[(c[(c[h>>2]|0)+12>>2]|0)+128>>2]|0,(c[(c[h>>2]|0)+12>>2]|0)+136|0);i=f;return}else{d=c[e+188>>2]|0;e=c[j>>2]|0;b=c[l>>2]|0;a=c[(c[h>>2]|0)+4>>2]|0;m=(c[c[h>>2]>>2]|0)-(c[(c[h>>2]|0)+4>>2]|0)|0;h=c[k>>2]|0;c[g>>2]=c[l>>2];Xd(0,0,0,0,d,13,e,2,0,0,b,a,0,m,0,h,g);i=f;return}}h=c[j>>2]|0;j=c[l>>2]|0;m=c[k>>2]|0;c[g>>2]=c[l>>2];Xd(0,0,0,0,0,13,h,2,0,0,j,0,0,0,0,m,g);i=f;return}function yv(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;do if(!((c[h>>2]|0)==0|(c[k>>2]|0)==0)){if((c[h>>2]|0)!=(c[k>>2]|0)){c[g>>2]=Yq(c[h>>2]|0,c[k>>2]|0)|0;break}if((c[j>>2]|0)<(c[l>>2]|0)){c[g>>2]=1;break}if((c[j>>2]|0)>(c[l>>2]|0)){c[g>>2]=-1;break}else{c[g>>2]=0;break}}else c[g>>2]=-2;while(0);i=f;return c[g>>2]|0}function zv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d;f=d+24|0;g=d+20|0;h=d+16|0;j=d+12|0;k=d+8|0;c[g>>2]=a;c[h>>2]=b;if(!(c[h>>2]|0)){c[f>>2]=0;l=c[f>>2]|0;i=d;return l|0}if(((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+12>>2]|0)!=0:0)?(c[c[(c[g>>2]|0)+12>>2]>>2]|0)!=0:0){b=c[c[h>>2]>>2]|0;if((b|0)==6){a=c[(c[h>>2]|0)+28>>2]|0;if(c[(c[h>>2]|0)+36>>2]|0){c[f>>2]=Zu(a,c[(c[h>>2]|0)+32>>2]|0,c[(c[h>>2]|0)+36>>2]|0,c[(c[h>>2]|0)+40>>2]|0)|0;l=c[f>>2]|0;i=d;return l|0}c[j>>2]=a;a=c[j>>2]|0;if((c[j>>2]|0)==(c[c[(c[g>>2]|0)+12>>2]>>2]|0)){g=c[j>>2]|0;c[f>>2]=Zu(a,0,g,Lv(c[j>>2]|0)|0)|0;l=c[f>>2]|0;i=d;return l|0}switch(c[a+4>>2]|0){case 13:case 12:case 9:case 8:case 7:case 5:case 4:case 3:case 1:{c[k>>2]=Mv(c[j>>2]|0)|0;c[j>>2]=c[(c[j>>2]|0)+20>>2];c[f>>2]=Zu(c[j>>2]|0,(c[k>>2]|0)-1|0,c[j>>2]|0,(c[k>>2]|0)+1|0)|0;l=c[f>>2]|0;i=d;return l|0}case 2:{c[f>>2]=Zu(c[j>>2]|0,0,c[j>>2]|0,Lv(c[j>>2]|0)|0)|0;l=c[f>>2]|0;i=d;return l|0}default:{c[f>>2]=0;l=c[f>>2]|0;i=d;return l|0}}}else if((b|0)==5){c[f>>2]=Zu(c[(c[h>>2]|0)+28>>2]|0,c[(c[h>>2]|0)+32>>2]|0,c[(c[h>>2]|0)+28>>2]|0,c[(c[h>>2]|0)+32>>2]|0)|0;l=c[f>>2]|0;i=d;return l|0}else{h=c[33976]|0;b=c[33980]|0;c[e>>2]=131976;c[e+4>>2]=2022;Db[h&511](b,132256,e);c[f>>2]=0;l=c[f>>2]|0;i=d;return l|0}}c[f>>2]=0;l=c[f>>2]|0;i=d;return l|0}function Av(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d;f=d+24|0;g=d+20|0;h=d+16|0;j=d+12|0;k=d+8|0;c[g>>2]=a;c[h>>2]=b;a:do if(!(c[h>>2]|0))c[f>>2]=0;else{if(((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+12>>2]|0)!=0:0)?(c[c[(c[g>>2]|0)+12>>2]>>2]|0)!=0:0){b=c[c[h>>2]>>2]|0;if((b|0)==5){c[j>>2]=c[(c[h>>2]|0)+28>>2];switch(c[(c[j>>2]|0)+4>>2]|0){case 4:case 3:case 8:case 7:{a=c[j>>2]|0;l=c[j>>2]|0;if(!(c[(c[j>>2]|0)+40>>2]|0)){c[f>>2]=Zu(a,0,l,0)|0;break a}else{c[f>>2]=Zu(a,0,l,xy(c[(c[j>>2]|0)+40>>2]|0)|0)|0;break a}break}case 13:case 12:case 9:case 5:case 1:case 2:{c[f>>2]=Zu(c[j>>2]|0,0,c[j>>2]|0,Lv(c[j>>2]|0)|0)|0;break a;break}default:{c[f>>2]=0;break a}}}else if((b|0)==6){c[k>>2]=c[(c[h>>2]|0)+28>>2];b=c[k>>2]|0;if(c[(c[h>>2]|0)+36>>2]|0){c[f>>2]=Zu(b,c[(c[h>>2]|0)+32>>2]|0,c[(c[h>>2]|0)+36>>2]|0,c[(c[h>>2]|0)+40>>2]|0)|0;break}switch(c[b+4>>2]|0){case 13:case 12:case 9:case 5:case 1:case 2:{c[f>>2]=Zu(c[k>>2]|0,0,c[k>>2]|0,Lv(c[k>>2]|0)|0)|0;break a;break}case 4:case 3:case 8:case 7:{b=c[k>>2]|0;l=c[k>>2]|0;if(!(c[(c[k>>2]|0)+40>>2]|0)){c[f>>2]=Zu(b,0,l,0)|0;break a}else{c[f>>2]=Zu(b,0,l,xy(c[(c[k>>2]|0)+40>>2]|0)|0)|0;break a}break}default:{c[f>>2]=0;break a}}}else{l=c[33976]|0;b=c[33980]|0;c[e>>2]=131976;c[e+4>>2]=2167;Db[l&511](b,132256,e);c[f>>2]=0;break}}c[f>>2]=0}while(0);i=d;return c[f>>2]|0}function Bv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if((c[g>>2]|0)==0|(c[h>>2]|0)==0|(c[j>>2]|0)==0){c[f>>2]=-1;k=c[f>>2]|0;i=e;return k|0}d=c[c[g>>2]>>2]|0;if((d|0)==5){c[c[h>>2]>>2]=c[(c[g>>2]|0)+28>>2];if((c[(c[g>>2]|0)+32>>2]|0)<=0)c[c[j>>2]>>2]=0;else c[c[j>>2]>>2]=c[(c[g>>2]|0)+32>>2];c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}else if((d|0)==6){c[c[h>>2]>>2]=c[(c[g>>2]|0)+28>>2];if((c[(c[g>>2]|0)+32>>2]|0)<=0)c[c[j>>2]>>2]=0;else c[c[j>>2]>>2]=c[(c[g>>2]|0)+32>>2];c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}else{c[f>>2]=-1;k=c[f>>2]|0;i=e;return k|0}return 0}function Cv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if((c[g>>2]|0)==0|(c[h>>2]|0)==0|(c[j>>2]|0)==0){c[f>>2]=-1;k=c[f>>2]|0;i=e;return k|0}d=c[c[g>>2]>>2]|0;if((d|0)==6){c[c[h>>2]>>2]=c[(c[g>>2]|0)+28>>2];if((c[(c[g>>2]|0)+32>>2]|0)<=0)c[c[j>>2]>>2]=0;else c[c[j>>2]>>2]=c[(c[g>>2]|0)+32>>2];c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}else if((d|0)==5){c[c[h>>2]>>2]=c[(c[g>>2]|0)+28>>2];if((c[(c[g>>2]|0)+32>>2]|0)<=0)c[c[j>>2]>>2]=0;else c[c[j>>2]>>2]=c[(c[g>>2]|0)+32>>2];c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}else{c[f>>2]=-1;k=c[f>>2]|0;i=e;return k|0}return 0}function Dv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+48|0;f=e;g=e+32|0;h=e+28|0;j=e+24|0;k=e+20|0;l=e+16|0;m=e+12|0;n=e+8|0;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;if((c[h>>2]|0)==0|(c[j>>2]|0)==0){c[g>>2]=-1;o=c[g>>2]|0;i=e;return o|0}c[l>>2]=c[c[h>>2]>>2];if((c[l>>2]|0)!=0?(c[(c[l>>2]|0)+4>>2]|0)!=18:0){c[m>>2]=c[c[j>>2]>>2];while(1){if((c[k>>2]|0)<0){p=30;break}while(1){if(!(c[l>>2]|0))break;if(((c[(c[l>>2]|0)+4>>2]|0)!=1?(c[(c[l>>2]|0)+4>>2]|0)!=9:0)?(c[(c[l>>2]|0)+4>>2]|0)!=13:0)break;d=c[l>>2]|0;if((c[m>>2]|0)>0){c[l>>2]=Kv(d,c[m>>2]|0)|0;c[m>>2]=0;continue}else{c[l>>2]=lv(d,0)|0;c[m>>2]=0;continue}}if(!(c[l>>2]|0)){p=16;break}if(!(c[m>>2]|0))c[m>>2]=1;if(!(c[k>>2]|0)){p=20;break}c[n>>2]=0;if((c[(c[l>>2]|0)+4>>2]|0)!=1?(c[(c[l>>2]|0)+40>>2]|0)!=0:0)c[n>>2]=xy(c[(c[l>>2]|0)+40>>2]|0)|0;if((c[m>>2]|0)>(c[n>>2]|0)){d=c[33976]|0;b=c[33980]|0;c[f>>2]=131976;c[f+4>>2]=2436;Db[d&511](b,131944,f);c[m>>2]=c[n>>2]}if(((c[m>>2]|0)+(c[k>>2]|0)|0)<(c[n>>2]|0))if(((c[m>>2]|0)+(c[k>>2]|0)|0)<(c[n>>2]|0)){p=29;break}else continue;else{c[k>>2]=(c[k>>2]|0)-((c[n>>2]|0)-(c[m>>2]|0));c[l>>2]=lv(c[l>>2]|0,0)|0;c[m>>2]=0;continue}}if((p|0)==16){c[c[h>>2]>>2]=0;c[c[j>>2]>>2]=0;c[g>>2]=-1;o=c[g>>2]|0;i=e;return o|0}else if((p|0)==20){c[c[h>>2]>>2]=c[l>>2];c[c[j>>2]>>2]=c[m>>2];c[g>>2]=0;o=c[g>>2]|0;i=e;return o|0}else if((p|0)==29){c[m>>2]=(c[m>>2]|0)+(c[k>>2]|0);c[c[h>>2]>>2]=c[l>>2];c[c[j>>2]>>2]=c[m>>2];c[g>>2]=0;o=c[g>>2]|0;i=e;return o|0}else if((p|0)==30){c[g>>2]=-1;o=c[g>>2]|0;i=e;return o|0}}c[g>>2]=-1;o=c[g>>2]|0;i=e;return o|0}function Ev(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;c[k>>2]=0;if(((c[f>>2]|0)!=0?(c[c[f>>2]>>2]|0)!=0:0)?!((c[g>>2]|0)==0?1:(c[(c[c[f>>2]>>2]|0)+4>>2]|0)==18):0){c[h>>2]=c[c[f>>2]>>2];c[j>>2]=c[c[g>>2]>>2];if((c[(c[h>>2]|0)+4>>2]|0)!=1?(c[(c[h>>2]|0)+4>>2]|0)!=9:0){if((c[j>>2]|0)>0?(c[(c[h>>2]|0)+4>>2]|0)==13:0)l=9}else l=8;if((l|0)==8?(c[j>>2]|0)>0:0)l=9;if((l|0)==9)c[h>>2]=Kv(c[h>>2]|0,c[j>>2]|0)|0;while(1){if(!(c[h>>2]|0))break;m=c[h>>2]|0;if(!(c[(c[h>>2]|0)+16>>2]|0)){l=13;break}c[h>>2]=c[m+16>>2]}do if((l|0)==13){if((c[m+4>>2]|0)!=1?(c[(c[h>>2]|0)+40>>2]|0)!=0:0){c[k>>2]=xy(c[(c[h>>2]|0)+40>>2]|0)|0;break}c[e>>2]=-1;n=c[e>>2]|0;i=d;return n|0}while(0);if(!(c[h>>2]|0)){c[e>>2]=-1;n=c[e>>2]|0;i=d;return n|0}else{c[c[f>>2]>>2]=c[h>>2];c[c[g>>2]>>2]=c[k>>2];c[e>>2]=0;n=c[e>>2]|0;i=d;return n|0}}c[e>>2]=-1;n=c[e>>2]|0;i=d;return n|0}function Fv(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=i;i=i+48|0;k=j+36|0;l=j+32|0;m=j+28|0;n=j+24|0;o=j+20|0;p=j+16|0;q=j+12|0;r=j+8|0;s=j+4|0;t=j;u=j+40|0;c[l>>2]=b;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[p>>2]=h;if(!(c[l>>2]|0)){c[k>>2]=-1;v=c[k>>2]|0;i=j;return v|0}if(((c[m>>2]|0)!=0?(c[c[m>>2]>>2]|0)!=0:0)?!((c[n>>2]|0)==0?1:(c[(c[c[m>>2]>>2]|0)+4>>2]|0)==18):0){if((c[o>>2]|0)==0|(c[p>>2]|0)==0){c[k>>2]=-1;v=c[k>>2]|0;i=j;return v|0}c[q>>2]=c[c[m>>2]>>2];c[s>>2]=(c[c[n>>2]>>2]|0)-1;a[u>>0]=a[c[l>>2]>>0]|0;a:while(1){if(!(c[q>>2]|0)){w=28;break}b:do if((c[(c[q>>2]|0)+4>>2]|0)!=1?(c[(c[q>>2]|0)+40>>2]|0)!=0:0){c[t>>2]=xy(c[(c[q>>2]|0)+40>>2]|0)|0;while(1){if((c[s>>2]|0)>(c[t>>2]|0))break b;if(!(d[u>>0]|0)){w=21;break a}c[r>>2]=vy((c[(c[q>>2]|0)+40>>2]|0)+(c[s>>2]|0)|0,a[u>>0]|0)|0;if(!(c[r>>2]|0)){c[s>>2]=(c[t>>2]|0)+1;continue}c[s>>2]=(c[r>>2]|0)-(c[(c[q>>2]|0)+40>>2]|0);if(Nv(c[l>>2]|0,c[q>>2]|0,(c[s>>2]|0)+1|0,c[o>>2]|0,c[p>>2]|0)|0){w=18;break a}c[s>>2]=(c[s>>2]|0)+1}}while(0);if((c[q>>2]|0)==(c[c[o>>2]>>2]|0)?(c[s>>2]|0)>=(c[c[p>>2]>>2]|0):0){w=24;break}c[q>>2]=lv(c[q>>2]|0,0)|0;if(!(c[q>>2]|0)){w=26;break}c[s>>2]=1}if((w|0)==18){c[c[m>>2]>>2]=c[q>>2];c[c[n>>2]>>2]=(c[s>>2]|0)+1;c[k>>2]=1;v=c[k>>2]|0;i=j;return v|0}else if((w|0)==21){c[c[m>>2]>>2]=c[q>>2];c[c[n>>2]>>2]=(c[s>>2]|0)+1;c[c[o>>2]>>2]=c[q>>2];c[c[p>>2]>>2]=(c[s>>2]|0)+1;c[k>>2]=1;v=c[k>>2]|0;i=j;return v|0}else if((w|0)==24){c[k>>2]=0;v=c[k>>2]|0;i=j;return v|0}else if((w|0)==26){c[k>>2]=0;v=c[k>>2]|0;i=j;return v|0}else if((w|0)==28){c[k>>2]=0;v=c[k>>2]|0;i=j;return v|0}}c[k>>2]=-1;v=c[k>>2]|0;i=j;return v|0}function Gv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if(!(c[f>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}if((c[g>>2]|0)<0){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}c[h>>2]=Cb[c[135744>>2]&511](48)|0;if(!(c[h>>2]|0)){mv(132288);c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}else{b=(c[h>>2]|0)+0|0;a=b+48|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(a|0));c[c[h>>2]>>2]=5;c[(c[h>>2]|0)+28>>2]=c[f>>2];c[(c[h>>2]|0)+32>>2]=c[g>>2];c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}return 0}function Hv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=0;if(!(c[e>>2]|0)){c[d>>2]=-1;g=c[d>>2]|0;i=b;return g|0}a:do switch(c[(c[e>>2]|0)+4>>2]|0){case 1:case 9:case 13:{c[e>>2]=c[(c[e>>2]|0)+12>>2];while(1){if(!(c[e>>2]|0))break a;if((c[(c[e>>2]|0)+4>>2]|0)==1)c[f>>2]=(c[f>>2]|0)+1;c[e>>2]=c[(c[e>>2]|0)+24>>2]}break}case 2:{c[d>>2]=-1;g=c[d>>2]|0;i=b;return g|0}case 5:case 4:case 3:case 8:case 7:{c[f>>2]=xy(c[(c[e>>2]|0)+40>>2]|0)|0;break}default:{c[d>>2]=-1;g=c[d>>2]|0;i=b;return g|0}}while(0);c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}function Iv(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;if(((c[g>>2]|0)==0?(d[c[c[f>>2]>>2]>>0]|0|0)==47:0)?(d[(c[c[f>>2]>>2]|0)+1>>0]|0|0)!=49:0)xv(c[f>>2]|0,1901,132432,0);if((c[g>>2]|0)!=0?(b=c[f>>2]|0,Tq(b,wr(c[g>>2]|0)|0)|0,zb[c[135736>>2]&511](c[g>>2]|0),os(c[f>>2]|0,1),(c[(c[f>>2]|0)+8>>2]|0)!=0):0){i=e;return}while(1){if((d[c[c[f>>2]>>2]>>0]|0|0)!=47)break;c[h>>2]=0;g=c[f>>2]|0;if(d[c[c[f>>2]>>2]>>0]|0)c[g>>2]=(c[g>>2]|0)+1;while(1){if((d[c[c[f>>2]>>2]>>0]|0|0)<48)break;if((d[c[c[f>>2]>>2]>>0]|0|0)>57)break;c[h>>2]=((c[h>>2]|0)*10|0)+((d[c[c[f>>2]>>2]>>0]|0)-48);g=c[f>>2]|0;if(!(d[c[c[f>>2]>>2]>>0]|0))continue;c[g>>2]=(c[g>>2]|0)+1}Ov(c[f>>2]|0,c[h>>2]|0)}i=e;return}function Jv(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=a;c[g>>2]=b;if(!(c[g>>2]|0))c[g>>2]=Ls(c[f>>2]|0)|0;if(!(c[g>>2]|0)){Nq(c[f>>2]|0,7);i=e;return}while(1){if(!(c[g>>2]|0)){l=25;break}c[(c[f>>2]|0)+8>>2]=0;Pv(c[f>>2]|0,c[g>>2]|0);if((c[(c[f>>2]|0)+8>>2]|0)!=0?(c[(c[f>>2]|0)+8>>2]|0)!=1900:0){l=25;break}if(c[(c[f>>2]|0)+16>>2]|0){c[h>>2]=c[(c[f>>2]|0)+16>>2];
b=c[c[h>>2]>>2]|0;if((b|0)==7){c[j>>2]=c[(c[(c[f>>2]|0)+16>>2]|0)+28>>2];if((c[j>>2]|0)!=0?(c[c[j>>2]>>2]|0)>0:0){l=25;break}}else if(((b|0)==1?(c[k>>2]=c[(c[(c[f>>2]|0)+16>>2]|0)+4>>2],(c[k>>2]|0)!=0):0)?(c[c[k>>2]>>2]|0)>0:0){l=25;break}do{c[h>>2]=Sq(c[f>>2]|0)|0;if(c[h>>2]|0)Qq(c[h>>2]|0)}while((c[h>>2]|0)!=0)}while(1){do if((d[c[c[f>>2]>>2]>>0]|0|0)==32)m=1;else{if(9<=(d[c[c[f>>2]>>2]>>0]|0|0)?(d[c[c[f>>2]>>2]>>0]|0|0)<=10:0){m=1;break}m=(d[c[c[f>>2]>>2]>>0]|0|0)==13}while(0);n=c[f>>2]|0;if(!m)break;b=c[f>>2]|0;if(!(d[c[n>>2]>>0]|0))continue;c[b>>2]=(c[b>>2]|0)+1}c[g>>2]=Ls(n)|0}if((l|0)==25){i=e;return}}function Kv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+4>>2]|0)!=18:0){c[f>>2]=c[(c[f>>2]|0)+12>>2];c[h>>2]=0;while(1){if((c[h>>2]|0)>(c[g>>2]|0)){j=13;break}k=c[f>>2]|0;if(!(c[f>>2]|0)){j=7;break}if(!(((c[k+4>>2]|0)!=1?(c[(c[f>>2]|0)+4>>2]|0)!=9:0)?(c[(c[f>>2]|0)+4>>2]|0)!=13:0))j=11;if((j|0)==11?(j=0,c[h>>2]=(c[h>>2]|0)+1,(c[h>>2]|0)==(c[g>>2]|0)):0){j=13;break}c[f>>2]=c[(c[f>>2]|0)+24>>2]}if((j|0)==7){c[e>>2]=k;l=c[e>>2]|0;i=d;return l|0}else if((j|0)==13){c[e>>2]=c[f>>2];l=c[e>>2]|0;i=d;return l|0}}c[e>>2]=c[f>>2];l=c[e>>2]|0;i=d;return l|0}function Lv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+4>>2]|0)!=18:0){c[e>>2]=c[(c[e>>2]|0)+12>>2];c[f>>2]=0;while(1){if(!(c[e>>2]|0))break;if(!(((c[(c[e>>2]|0)+4>>2]|0)!=1?(c[(c[e>>2]|0)+4>>2]|0)!=9:0)?(c[(c[e>>2]|0)+4>>2]|0)!=13:0))c[f>>2]=(c[f>>2]|0)+1;c[e>>2]=c[(c[e>>2]|0)+24>>2]}c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}c[d>>2]=-1;g=c[d>>2]|0;i=b;return g|0}function Mv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+4>>2]|0)!=18:0){c[f>>2]=1;while(1){if(!(c[e>>2]|0))break;if(!(((c[(c[e>>2]|0)+4>>2]|0)!=1?(c[(c[e>>2]|0)+4>>2]|0)!=9:0)?(c[(c[e>>2]|0)+4>>2]|0)!=13:0))c[f>>2]=(c[f>>2]|0)+1;c[e>>2]=c[(c[e>>2]|0)+28>>2]}c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}c[d>>2]=-1;g=c[d>>2]|0;i=b;return g|0}function Nv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+48|0;h=g+44|0;j=g+40|0;k=g+36|0;l=g+32|0;m=g+28|0;n=g+24|0;o=g+20|0;p=g+16|0;q=g+12|0;r=g+8|0;s=g+4|0;t=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;if(!(c[j>>2]|0)){c[h>>2]=-1;u=c[h>>2]|0;i=g;return u|0}if((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+4>>2]|0)!=18:0){if(((c[m>>2]|0)!=0?(c[c[m>>2]>>2]|0)!=0:0)?!((c[n>>2]|0)==0?1:(c[(c[c[m>>2]>>2]|0)+4>>2]|0)==18):0){c[o>>2]=c[k>>2];c[p>>2]=(c[l>>2]|0)-1;c[r>>2]=xy(c[j>>2]|0)|0;while(1){if((c[r>>2]|0)<=0){v=27;break}if((c[o>>2]|0)==(c[c[m>>2]>>2]|0)?((c[p>>2]|0)+(c[r>>2]|0)|0)>(c[c[n>>2]>>2]|0):0){v=14;break}if((c[(c[o>>2]|0)+4>>2]|0)!=1?(c[(c[o>>2]|0)+40>>2]|0)!=0:0){c[q>>2]=xy(c[(c[o>>2]|0)+40>>2]|0)|0;if((c[q>>2]|0)>=((c[p>>2]|0)+(c[r>>2]|0)|0)){v=18;break}c[t>>2]=(c[q>>2]|0)-(c[p>>2]|0);c[s>>2]=((sy((c[(c[o>>2]|0)+40>>2]|0)+(c[p>>2]|0)|0,c[j>>2]|0,c[t>>2]|0)|0)!=0^1)&1;if(!(c[s>>2]|0)){v=23;break}c[j>>2]=(c[j>>2]|0)+(c[t>>2]|0);c[r>>2]=(c[r>>2]|0)-(c[t>>2]|0)}c[o>>2]=lv(c[o>>2]|0,0)|0;if(!(c[o>>2]|0)){v=25;break}c[p>>2]=0}if((v|0)==14){c[h>>2]=0;u=c[h>>2]|0;i=g;return u|0}else if((v|0)==18){c[s>>2]=((sy((c[(c[o>>2]|0)+40>>2]|0)+(c[p>>2]|0)|0,c[j>>2]|0,c[r>>2]|0)|0)!=0^1)&1;if(c[s>>2]|0){c[c[m>>2]>>2]=c[o>>2];c[c[n>>2]>>2]=(c[p>>2]|0)+(c[r>>2]|0);c[h>>2]=1;u=c[h>>2]|0;i=g;return u|0}else{c[h>>2]=0;u=c[h>>2]|0;i=g;return u|0}}else if((v|0)==23){c[h>>2]=0;u=c[h>>2]|0;i=g;return u|0}else if((v|0)==25){c[h>>2]=0;u=c[h>>2]|0;i=g;return u|0}else if((v|0)==27){c[h>>2]=1;u=c[h>>2]|0;i=g;return u|0}}c[h>>2]=-1;u=c[h>>2]|0;i=g;return u|0}c[h>>2]=-1;u=c[h>>2]|0;i=g;return u|0}function Ov(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=0;if((c[(c[e>>2]|0)+16>>2]|0)!=0?(c[c[(c[e>>2]|0)+16>>2]>>2]|0)==1:0){c[h>>2]=Sq(c[e>>2]|0)|0;c[j>>2]=c[(c[h>>2]|0)+4>>2];if(!((c[f>>2]|0)<=0|(c[j>>2]|0)==0)?(c[c[j>>2]>>2]|0)==1:0){c[g>>2]=Kv(c[c[(c[j>>2]|0)+8>>2]>>2]|0,c[f>>2]|0)|0;if(!(c[g>>2]|0)){Qq(c[h>>2]|0);f=c[e>>2]|0;Tq(f,gr(0)|0)|0;i=d;return}else{c[c[(c[j>>2]|0)+8>>2]>>2]=c[g>>2];Tq(c[e>>2]|0,c[h>>2]|0)|0;i=d;return}}Qq(c[h>>2]|0);h=c[e>>2]|0;Tq(h,gr(0)|0)|0;i=d;return}Nq(c[e>>2]|0,11);i=d;return}function Pv(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+64|0;g=f+48|0;h=f+44|0;j=f+40|0;k=f+36|0;l=f+32|0;m=f+28|0;n=f+24|0;o=f+20|0;p=f+16|0;q=f+12|0;r=f+8|0;s=f+4|0;t=f;c[g>>2]=b;c[h>>2]=e;if(!(c[h>>2]|0))c[h>>2]=Ls(c[g>>2]|0)|0;e=c[g>>2]|0;if(!(c[h>>2]|0)){Nq(e,7);i=f;return}b=c[g>>2]|0;if((d[c[e>>2]>>0]|0|0)!=40){Nq(b,7);i=f;return}e=c[g>>2]|0;if(d[c[b>>2]>>0]|0)c[e>>2]=(c[e>>2]|0)+1;c[m>>2]=1;c[l>>2]=xy(c[c[g>>2]>>2]|0)|0;c[l>>2]=(c[l>>2]|0)+1;c[j>>2]=Cb[c[135752>>2]&511](c[l>>2]|0)|0;if(!(c[j>>2]|0)){mv(132344);i=f;return}c[k>>2]=c[j>>2];a:while(1){if(!(d[c[c[g>>2]>>2]>>0]|0))break;do if((d[c[c[g>>2]>>2]>>0]|0|0)==41){c[m>>2]=(c[m>>2]|0)+-1;if(!(c[m>>2]|0)){u=15;break a}}else{if((d[c[c[g>>2]>>2]>>0]|0|0)==40){c[m>>2]=(c[m>>2]|0)+1;break}if((d[c[c[g>>2]>>2]>>0]|0|0)==94){if(((d[(c[c[g>>2]>>2]|0)+1>>0]|0|0)!=41?(d[(c[c[g>>2]>>2]|0)+1>>0]|0|0)!=40:0)?(d[(c[c[g>>2]>>2]|0)+1>>0]|0|0)!=94:0)break;l=c[g>>2]|0;if(d[c[c[g>>2]>>2]>>0]|0)c[l>>2]=(c[l>>2]|0)+1}}while(0);l=a[c[c[g>>2]>>2]>>0]|0;e=c[k>>2]|0;c[k>>2]=e+1;a[e>>0]=l;l=c[g>>2]|0;if(!(d[c[c[g>>2]>>2]>>0]|0))continue;c[l>>2]=(c[l>>2]|0)+1}if((u|0)==15?(u=c[g>>2]|0,(d[c[c[g>>2]>>2]>>0]|0|0)!=0):0)c[u>>2]=(c[u>>2]|0)+1;a[c[k>>2]>>0]=0;if((c[m>>2]|0)!=0?(d[c[c[g>>2]>>2]>>0]|0|0)==0:0){zb[c[135736>>2]&511](c[j>>2]|0);Nq(c[g>>2]|0,16);i=f;return}do if(qy(c[h>>2]|0,132368)|0){c[n>>2]=c[c[g>>2]>>2];c[c[g>>2]>>2]=c[j>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]=c[c[(c[g>>2]|0)+12>>2]>>2];c[(c[(c[g>>2]|0)+12>>2]|0)+72>>2]=1;c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2]=1;Qs(c[g>>2]|0);c[c[g>>2]>>2]=c[n>>2]}else{if(qy(c[h>>2]|0,132384)|0){c[o>>2]=c[c[g>>2]>>2];c[c[g>>2]>>2]=c[j>>2];m=c[g>>2]|0;do if((d[c[j>>2]>>0]|0|0)==47){ks(m);Iv(c[g>>2]|0,0)}else{c[p>>2]=Ls(m)|0;if(c[p>>2]|0){Iv(c[g>>2]|0,c[p>>2]|0);break}c[c[g>>2]>>2]=c[o>>2];zb[c[135736>>2]&511](c[j>>2]|0);Nq(c[g>>2]|0,7);i=f;return}while(0);c[c[g>>2]>>2]=c[o>>2];break}m=(qy(c[h>>2]|0,132392)|0)!=0;k=c[g>>2]|0;if(!m){xv(k,1900,132400,c[h>>2]|0);break}c[q>>2]=c[k>>2];c[c[g>>2]>>2]=c[j>>2];c[r>>2]=Ks(c[g>>2]|0)|0;if(!(c[r>>2]|0)){zb[c[135736>>2]&511](c[j>>2]|0);zb[c[135736>>2]&511](c[h>>2]|0);Nq(c[g>>2]|0,16);i=f;return}while(1){do if((d[c[c[g>>2]>>2]>>0]|0|0)==32)v=1;else{if(9<=(d[c[c[g>>2]>>2]>>0]|0|0)?(d[c[c[g>>2]>>2]>>0]|0|0)<=10:0){v=1;break}v=(d[c[c[g>>2]>>2]>>0]|0|0)==13}while(0);w=d[c[c[g>>2]>>2]>>0]|0;if(!v)break;k=c[g>>2]|0;if(!w)continue;c[k>>2]=(c[k>>2]|0)+1}if((w|0)!=61){zb[c[135736>>2]&511](c[r>>2]|0);zb[c[135736>>2]&511](c[j>>2]|0);zb[c[135736>>2]&511](c[h>>2]|0);Nq(c[g>>2]|0,16);i=f;return}k=c[g>>2]|0;if(d[c[c[g>>2]>>2]>>0]|0)c[k>>2]=(c[k>>2]|0)+1;while(1){do if((d[c[c[g>>2]>>2]>>0]|0|0)==32)x=1;else{if(9<=(d[c[c[g>>2]>>2]>>0]|0|0)?(d[c[c[g>>2]>>2]>>0]|0|0)<=10:0){x=1;break}x=(d[c[c[g>>2]>>2]>>0]|0|0)==13}while(0);y=c[c[g>>2]>>2]|0;if(!x)break;k=c[g>>2]|0;if(!(d[y>>0]|0))continue;c[k>>2]=(c[k>>2]|0)+1}c[t>>2]=yl(y)|0;if(!(c[t>>2]|0)){zb[c[135736>>2]&511](c[r>>2]|0);zb[c[135736>>2]&511](c[j>>2]|0);zb[c[135736>>2]&511](c[h>>2]|0);Nq(c[g>>2]|0,16);i=f;return}c[s>>2]=Cl(c[t>>2]|0)|0;Al(c[t>>2]|0);if(c[s>>2]|0){rr(c[(c[g>>2]|0)+12>>2]|0,c[r>>2]|0,c[s>>2]|0)|0;c[c[g>>2]>>2]=c[q>>2];zb[c[135736>>2]&511](c[s>>2]|0);zb[c[135736>>2]&511](c[r>>2]|0);break}zb[c[135736>>2]&511](c[r>>2]|0);zb[c[135736>>2]&511](c[j>>2]|0);zb[c[135736>>2]&511](c[h>>2]|0);Nq(c[g>>2]|0,15);i=f;return}while(0);zb[c[135736>>2]&511](c[j>>2]|0);zb[c[135736>>2]&511](c[h>>2]|0);i=f;return}function Qv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if(!(c[e>>2]|0)){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}c[f>>2]=Cb[c[135744>>2]&511](72)|0;if(!(c[f>>2]|0)){Xv(0,c[e>>2]|0,132504);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{a=(c[f>>2]|0)+0|0;h=a+72|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(h|0));c[c[f>>2]>>2]=c[e>>2];c[(c[f>>2]|0)+8>>2]=0;c[(c[f>>2]|0)+4>>2]=0;c[(c[f>>2]|0)+12>>2]=0;c[(c[f>>2]|0)+16>>2]=0;c[(c[f>>2]|0)+52>>2]=0;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function Rv(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}while(1){f=c[d>>2]|0;if((c[(c[d>>2]|0)+40>>2]|0)<=0)break;Yv(f)}if(c[f+48>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+48>>2]|0);c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[(c[d>>2]|0)+8>>2]|0))break;if(c[(c[(c[d>>2]|0)+16>>2]|0)+(c[e>>2]<<2)>>2]|0)Zv(c[(c[(c[d>>2]|0)+16>>2]|0)+(c[e>>2]<<2)>>2]|0);c[e>>2]=(c[e>>2]|0)+1}a:do if(c[(c[d>>2]|0)+32>>2]|0){c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[(c[d>>2]|0)+20>>2]|0))break a;if(c[(c[(c[d>>2]|0)+32>>2]|0)+(c[e>>2]<<2)>>2]|0)zb[c[135736>>2]&511](c[(c[(c[d>>2]|0)+32>>2]|0)+(c[e>>2]<<2)>>2]|0);c[e>>2]=(c[e>>2]|0)+1}}while(0);if(c[(c[d>>2]|0)+16>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+16>>2]|0);if(c[(c[d>>2]|0)+28>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+28>>2]|0);if(c[(c[d>>2]|0)+32>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+32>>2]|0);if(c[(c[d>>2]|0)+64>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+64>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function Sv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if(!(c[f>>2]|0)){c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}else{c[(c[f>>2]|0)+60>>2]=c[g>>2];c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}return 0}function Tv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[l>>2]=0;if(((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+4>>2]|0)!=18:0)?(c[(c[g>>2]|0)+32>>2]|0)!=0:0){c[k>>2]=Qv(c[(c[g>>2]|0)+32>>2]|0)|0;if(!(c[k>>2]|0)){c[f>>2]=-1;m=c[f>>2]|0;i=e;return m|0}c[(c[k>>2]|0)+68>>2]=c[j>>2];j=my(c[(c[(c[g>>2]|0)+32>>2]|0)+72>>2]|0)|0;c[(c[k>>2]|0)+64>>2]=j;Sv(c[k>>2]|0,c[h>>2]|0)|0;c[l>>2]=_v(c[k>>2]|0,c[(c[g>>2]|0)+32>>2]|0,c[g>>2]|0)|0;if((c[l>>2]|0)>=0?(c[(c[k>>2]|0)+52>>2]|0)>0:0)c[l>>2]=-1;Rv(c[k>>2]|0);c[f>>2]=c[l>>2];m=c[f>>2]|0;i=e;return m|0}c[f>>2]=-1;m=c[f>>2]|0;i=e;return m|0}function Uv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(!(c[g>>2]|0)){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}c[k>>2]=Pi(c[g>>2]|0)|0;if(!(c[k>>2]|0)){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}else{c[f>>2]=Tv(c[k>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;l=c[f>>2]|0;i=e;return l|0}return 0}function Vv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=Uv(c[e>>2]|0,c[f>>2]|0,0)|0;i=d;return b|0}function Wv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;if(((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+4>>2]|0)!=18:0)?!((c[f>>2]|0)==0?1:(c[(c[g>>2]|0)+32>>2]|0)==0):0){c[h>>2]=_v(c[f>>2]|0,c[(c[g>>2]|0)+32>>2]|0,c[g>>2]|0)|0;if((c[h>>2]|0)>=0?(c[(c[f>>2]|0)+52>>2]|0)>0:0)c[h>>2]=-1;c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}c[e>>2]=-1;j=c[e>>2]|0;i=d;return j|0}function Xv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;g=e+12|0;h=e+8|0;j=e+4|0;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(c[g>>2]|0){d=(c[g>>2]|0)+52|0;c[d>>2]=(c[d>>2]|0)+1}d=c[g>>2]|0;g=c[h>>2]|0;h=c[j>>2]|0;c[f>>2]=c[j>>2];Xd(0,0,0,d,g,11,2,2,0,0,h,0,0,0,0,133840,f);i=e;return}function Yv(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;if((c[(c[d>>2]|0)+40>>2]|0)<=0){i=b;return}a=(c[d>>2]|0)+40|0;c[a>>2]=(c[a>>2]|0)+-1;a=c[d>>2]|0;if((c[(c[d>>2]|0)+40>>2]|0)>0)c[(c[d>>2]|0)+36>>2]=c[(c[(c[d>>2]|0)+48>>2]|0)+((c[a+40>>2]|0)-1<<2)>>2];else c[a+36>>2]=0;c[e>>2]=c[(c[(c[d>>2]|0)+48>>2]|0)+(c[(c[d>>2]|0)+40>>2]<<2)>>2];c[(c[(c[d>>2]|0)+48>>2]|0)+(c[(c[d>>2]|0)+40>>2]<<2)>>2]=0;if(!(c[e>>2]|0)){i=b;return}zb[c[135736>>2]&511](c[e>>2]|0);i=b;return}function Zv(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+8>>2]|0)Th(c[(c[d>>2]|0)+8>>2]|0);if(c[c[d>>2]>>2]|0)zb[c[135736>>2]&511](c[c[d>>2]>>2]|0);if(c[(c[d>>2]|0)+4>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+4>>2]|0);if(c[(c[d>>2]|0)+28>>2]|0)Qq(c[(c[d>>2]|0)+28>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function _v(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;n=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[l>>2]=0;if(!((c[h>>2]|0)==0|(c[j>>2]|0)==0)?(c[(c[j>>2]|0)+4>>2]|0)!=18:0){if(!(c[g>>2]|0)){c[f>>2]=-1;o=c[f>>2]|0;i=e;return o|0}if((c[(c[h>>2]|0)+72>>2]|0)!=0?(c[l>>2]=$v(c[g>>2]|0,c[(c[h>>2]|0)+72>>2]|0)|0,(c[l>>2]|0)<0):0){c[f>>2]=-1;o=c[f>>2]|0;i=e;return o|0}c[n>>2]=c[(c[g>>2]|0)+8>>2];c[k>>2]=c[j>>2];if((aw(c[g>>2]|0,c[k>>2]|0)|0)==1)bw(c[g>>2]|0,c[k>>2]|0)|0;a:while(1){if(!(c[k>>2]|0))break;if((c[k>>2]|0)==(c[(c[j>>2]|0)+20>>2]|0))break;if((((c[(c[k>>2]|0)+12>>2]|0)!=0?(c[(c[(c[k>>2]|0)+12>>2]|0)+4>>2]|0)!=17:0)?(c[(c[(c[k>>2]|0)+12>>2]|0)+4>>2]|0)!=19:0)?(c[(c[(c[k>>2]|0)+12>>2]|0)+4>>2]|0)!=20:0){c[k>>2]=c[(c[k>>2]|0)+12>>2];if(!(aw(c[g>>2]|0,c[k>>2]|0)|0))continue;bw(c[g>>2]|0,c[k>>2]|0)|0;continue}d=c[k>>2]|0;if(c[(c[k>>2]|0)+24>>2]|0){c[k>>2]=c[d+24>>2];if(!(aw(c[g>>2]|0,c[k>>2]|0)|0))continue;bw(c[g>>2]|0,c[k>>2]|0)|0;continue}if((d|0)==(c[j>>2]|0))break;while(1){c[k>>2]=c[(c[k>>2]|0)+20>>2];if(!(c[k>>2]|0))continue a;if((c[k>>2]|0)==(c[(c[j>>2]|0)+20>>2]|0))continue a;p=c[k>>2]|0;if(c[(c[k>>2]|0)+24>>2]|0)break;if(!p)continue a}c[k>>2]=c[p+24>>2];if(!(aw(c[g>>2]|0,c[k>>2]|0)|0))continue;bw(c[g>>2]|0,c[k>>2]|0)|0}c[m>>2]=c[n>>2];while(1){q=c[g>>2]|0;if((c[m>>2]|0)>=(c[(c[g>>2]|0)+8>>2]|0))break;cw(q,c[m>>2]|0)|0;c[l>>2]=(c[l>>2]|0)+1;c[m>>2]=(c[m>>2]|0)+1}c[m>>2]=c[q+4>>2];while(1){if((c[m>>2]|0)>=(c[(c[g>>2]|0)+8>>2]|0))break;if(!(((c[(c[(c[(c[g>>2]|0)+16>>2]|0)+(c[m>>2]<<2)>>2]|0)+16>>2]|0)==0?(c[(c[(c[(c[g>>2]|0)+16>>2]|0)+(c[m>>2]<<2)>>2]|0)+28>>2]|0)==0:0)?(c[(c[(c[(c[g>>2]|0)+16>>2]|0)+(c[m>>2]<<2)>>2]|0)+32>>2]|0)==0:0))dw(c[g>>2]|0,c[m>>2]|0)|0;c[m>>2]=(c[m>>2]|0)+1}if(c[(c[h>>2]|0)+72>>2]|0)Yv(c[g>>2]|0);c[f>>2]=c[l>>2];o=c[f>>2]|0;i=e;return o|0}c[f>>2]=-1;o=c[f>>2]|0;i=e;return o|0}function $v(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;b=c[f>>2]|0;if((c[(c[f>>2]|0)+40>>2]|0)>40){ew(b,0,1600,133640,c[g>>2]|0);c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}if((c[b+48>>2]|0)==0?(c[(c[f>>2]|0)+44>>2]=4,c[(c[f>>2]|0)+40>>2]=0,b=Cb[c[135744>>2]&511](c[(c[f>>2]|0)+44>>2]<<2)|0,c[(c[f>>2]|0)+48>>2]=b,(c[(c[f>>2]|0)+48>>2]|0)==0):0){Xv(c[f>>2]|0,0,133824);c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}if((c[(c[f>>2]|0)+40>>2]|0)>=(c[(c[f>>2]|0)+44>>2]|0)?(b=(c[f>>2]|0)+44|0,c[b>>2]=c[b>>2]<<1,b=Hb[c[135760>>2]&511](c[(c[f>>2]|0)+48>>2]|0,c[(c[f>>2]|0)+44>>2]<<2)|0,c[(c[f>>2]|0)+48>>2]=b,(c[(c[f>>2]|0)+48>>2]|0)==0):0){Xv(c[f>>2]|0,0,133824);c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}b=my(c[g>>2]|0)|0;c[(c[(c[f>>2]|0)+48>>2]|0)+(c[(c[f>>2]|0)+40>>2]<<2)>>2]=b;c[(c[f>>2]|0)+36>>2]=b;b=(c[f>>2]|0)+40|0;f=c[b>>2]|0;c[b>>2]=f+1;c[e>>2]=f;h=c[e>>2]|0;i=d;return h|0}function aw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[f>>2]=a;c[g>>2]=b;if(!(c[g>>2]|0)){c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}if((c[(c[g>>2]|0)+4>>2]|0)!=1){c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}if(!(c[(c[g>>2]|0)+36>>2]|0)){c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}if(!((qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,132728)|0)==0?(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,132760)|0)==0:0))l=9;a:do if((l|0)==9){if((qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,132760)|0)!=0?(c[(c[f>>2]|0)+56>>2]|0)==0:0)c[(c[f>>2]|0)+56>>2]=1;b=(qy(c[(c[g>>2]|0)+8>>2]|0,133704)|0)!=0;a=c[g>>2]|0;if(!b){if(!(qy(c[a+8>>2]|0,132712)|0))break;do if(((c[(c[g>>2]|0)+20>>2]|0)!=0?(c[(c[(c[g>>2]|0)+20>>2]|0)+4>>2]|0)==1:0)?(c[(c[(c[g>>2]|0)+20>>2]|0)+36>>2]|0)!=0:0){if((qy(c[(c[(c[(c[g>>2]|0)+20>>2]|0)+36>>2]|0)+8>>2]|0,132728)|0)==0?(qy(c[(c[(c[(c[g>>2]|0)+20>>2]|0)+36>>2]|0)+8>>2]|0,132760)|0)==0:0)break;if(qy(c[(c[(c[g>>2]|0)+20>>2]|0)+8>>2]|0,133704)|0)break a}while(0);ew(c[f>>2]|0,c[g>>2]|0,1616,133784,132712);break}c[h>>2]=c[a+12>>2];c[j>>2]=0;b:while(1){if(!(c[h>>2]|0))break;do if((c[(c[h>>2]|0)+4>>2]|0)==1?(c[(c[h>>2]|0)+36>>2]|0)!=0:0){if((qy(c[(c[(c[h>>2]|0)+36>>2]|0)+8>>2]|0,132728)|0)==0?(qy(c[(c[(c[h>>2]|0)+36>>2]|0)+8>>2]|0,132760)|0)==0:0)break;if(qy(c[(c[h>>2]|0)+8>>2]|0,133704)|0){l=20;break b}if(qy(c[(c[h>>2]|0)+8>>2]|0,132712)|0)c[j>>2]=(c[j>>2]|0)+1}while(0);c[h>>2]=c[(c[h>>2]|0)+24>>2]}if((l|0)==20){ew(c[f>>2]|0,c[g>>2]|0,1614,133712,133704);c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}if((c[j>>2]|0)>1){ew(c[f>>2]|0,c[g>>2]|0,1615,133744,133704);c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}else{c[e>>2]=1;k=c[e>>2]|0;i=d;return k|0}}while(0);c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}function bw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;fw(c[e>>2]|0,c[f>>2]|0)|0;i=d;return 0}function cw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+64|0;e=d+52|0;f=d+48|0;g=d+44|0;h=d+40|0;j=d+36|0;k=d+32|0;l=d+28|0;m=d+24|0;n=d+20|0;o=d+16|0;p=d+12|0;q=d+8|0;r=d+4|0;s=d;c[f>>2]=a;c[g>>2]=b;c[o>>2]=1;if(!(c[f>>2]|0)){c[e>>2]=-1;t=c[e>>2]|0;i=d;return t|0}if((c[g>>2]|0)>=0?(c[g>>2]|0)<(c[(c[f>>2]|0)+8>>2]|0):0){c[h>>2]=c[(c[(c[(c[f>>2]|0)+16>>2]|0)+(c[g>>2]<<2)>>2]|0)+12>>2];if(!(c[h>>2]|0)){c[e>>2]=-1;t=c[e>>2]|0;i=d;return t|0}c[j>>2]=gw(c[f>>2]|0,c[h>>2]|0,132616)|0;if((c[j>>2]|0)==0?(c[j>>2]=my(132624)|0,(c[j>>2]|0)==0):0){c[e>>2]=-1;t=c[e>>2]|0;i=d;return t|0}c[k>>2]=gw(c[f>>2]|0,c[h>>2]|0,132632)|0;do if(c[k>>2]|0){if(qy(c[k>>2]|0,132640)|0){c[o>>2]=1;break}if(qy(c[k>>2]|0,132648)|0){c[o>>2]=0;break}ew(c[f>>2]|0,c[(c[(c[(c[f>>2]|0)+16>>2]|0)+(c[g>>2]<<2)>>2]|0)+12>>2]|0,1601,132656,c[k>>2]|0);if(c[j>>2]|0)zb[c[135736>>2]&511](c[j>>2]|0);if(c[k>>2]|0)zb[c[135736>>2]&511](c[k>>2]|0);c[e>>2]=-1;t=c[e>>2]|0;i=d;return t|0}while(0);c[l>>2]=Xi(c[c[f>>2]>>2]|0,c[h>>2]|0)|0;b=c[j>>2]|0;if(!(c[l>>2]|0))c[n>>2]=Hl(b,c[(c[c[f>>2]>>2]|0)+72>>2]|0)|0;else c[n>>2]=Hl(b,c[l>>2]|0)|0;if(!(c[n>>2]|0)){c[q>>2]=Gl(c[l>>2]|0)|0;c[r>>2]=Gl(c[j>>2]|0)|0;c[n>>2]=Hl(c[r>>2]|0,c[q>>2]|0)|0;if(c[q>>2]|0)zb[c[135736>>2]&511](c[q>>2]|0);if(c[r>>2]|0)zb[c[135736>>2]&511](c[r>>2]|0)}r=c[f>>2]|0;if(!(c[n>>2]|0)){ew(r,c[(c[(c[(c[f>>2]|0)+16>>2]|0)+(c[g>>2]<<2)>>2]|0)+12>>2]|0,1605,132688,0);if(c[k>>2]|0)zb[c[135736>>2]&511](c[k>>2]|0);if(c[j>>2]|0)zb[c[135736>>2]&511](c[j>>2]|0);if(c[l>>2]|0)zb[c[135736>>2]&511](c[l>>2]|0);c[e>>2]=-1;t=c[e>>2]|0;i=d;return t|0}c[m>>2]=c[r+64>>2];c[(c[f>>2]|0)+64>>2]=c[l>>2];r=c[f>>2]|0;q=c[n>>2]|0;b=c[g>>2]|0;if(c[o>>2]|0)c[p>>2]=hw(r,q,b)|0;else c[p>>2]=iw(r,q,b)|0;c[(c[f>>2]|0)+64>>2]=c[m>>2];a:do if((c[p>>2]|0)<0){c[s>>2]=c[(c[h>>2]|0)+12>>2];while(1){if(!(c[s>>2]|0))break a;do if(((c[(c[s>>2]|0)+4>>2]|0)==1?(c[(c[s>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[s>>2]|0)+8>>2]|0,132712)|0)!=0:0){if((qy(c[(c[(c[s>>2]|0)+36>>2]|0)+8>>2]|0,132728)|0)==0?(qy(c[(c[(c[s>>2]|0)+36>>2]|0)+8>>2]|0,132760)|0)==0:0)break;c[p>>2]=jw(c[f>>2]|0,c[s>>2]|0,c[g>>2]|0)|0;if(!(c[p>>2]|0))break a}while(0);c[s>>2]=c[(c[s>>2]|0)+24>>2]}}while(0);if((c[p>>2]|0)<0)ew(c[f>>2]|0,c[(c[(c[(c[f>>2]|0)+16>>2]|0)+(c[g>>2]<<2)>>2]|0)+12>>2]|0,1604,132792,c[n>>2]|0);if(c[n>>2]|0)zb[c[135736>>2]&511](c[n>>2]|0);if(c[k>>2]|0)zb[c[135736>>2]&511](c[k>>2]|0);if(c[j>>2]|0)zb[c[135736>>2]&511](c[j>>2]|0);if(c[l>>2]|0)zb[c[135736>>2]&511](c[l>>2]|0);c[e>>2]=0;t=c[e>>2]|0;i=d;return t|0}c[e>>2]=-1;t=c[e>>2]|0;i=d;return t|0}function dw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+28|0;f=d+24|0;g=d+20|0;h=d+16|0;j=d+12|0;k=d+8|0;l=d+4|0;m=d;c[f>>2]=a;c[g>>2]=b;if(!(c[f>>2]|0)){c[e>>2]=-1;n=c[e>>2]|0;i=d;return n|0}if((c[g>>2]|0)>=0?(c[g>>2]|0)<(c[(c[f>>2]|0)+8>>2]|0):0){c[h>>2]=c[(c[(c[(c[f>>2]|0)+16>>2]|0)+(c[g>>2]<<2)>>2]|0)+12>>2];if((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+4>>2]|0)!=18:0){if((c[(c[(c[(c[f>>2]|0)+16>>2]|0)+(c[g>>2]<<2)>>2]|0)+16>>2]|0)==0?(c[(c[(c[(c[f>>2]|0)+16>>2]|0)+(c[g>>2]<<2)>>2]|0)+28>>2]|0)!=0:0){b=kw(c[f>>2]|0,c[c[f>>2]>>2]|0,c[c[f>>2]>>2]|0,c[(c[(c[(c[f>>2]|0)+16>>2]|0)+(c[g>>2]<<2)>>2]|0)+28>>2]|0)|0;c[(c[(c[(c[f>>2]|0)+16>>2]|0)+(c[g>>2]<<2)>>2]|0)+16>>2]=b;Qq(c[(c[(c[(c[f>>2]|0)+16>>2]|0)+(c[g>>2]<<2)>>2]|0)+28>>2]|0);c[(c[(c[(c[f>>2]|0)+16>>2]|0)+(c[g>>2]<<2)>>2]|0)+28>>2]=0}c[k>>2]=c[(c[(c[(c[f>>2]|0)+16>>2]|0)+(c[g>>2]<<2)>>2]|0)+16>>2];c[(c[(c[(c[f>>2]|0)+16>>2]|0)+(c[g>>2]<<2)>>2]|0)+16>>2]=0;if((c[(c[h>>2]|0)+20>>2]|0)!=0?(c[(c[(c[h>>2]|0)+20>>2]|0)+4>>2]|0)!=1:0){c[m>>2]=0;c[l>>2]=c[k>>2];while(1){if(!(c[l>>2]|0))break;if((c[(c[l>>2]|0)+4>>2]|0)==1)c[m>>2]=(c[m>>2]|0)+1;c[l>>2]=c[(c[l>>2]|0)+24>>2]}if((c[m>>2]|0)>1){ew(c[f>>2]|0,c[(c[(c[(c[f>>2]|0)+16>>2]|0)+(c[g>>2]<<2)>>2]|0)+12>>2]|0,1611,132536,0);c[e>>2]=-1;n=c[e>>2]|0;i=d;return n|0}}a:do if(c[(c[f>>2]|0)+60>>2]&32768){while(1){if(!(c[k>>2]|0))break;c[j>>2]=c[k>>2];c[k>>2]=c[(c[k>>2]|0)+24>>2];wi(c[h>>2]|0,c[j>>2]|0)|0}Qh(c[h>>2]|0);Rh(c[h>>2]|0)}else{c[(c[h>>2]|0)+4>>2]=19;c[j>>2]=ji(c[(c[h>>2]|0)+32>>2]|0,c[(c[h>>2]|0)+36>>2]|0,c[(c[h>>2]|0)+8>>2]|0,0)|0;if(!(c[j>>2]|0)){ew(c[f>>2]|0,c[(c[(c[(c[f>>2]|0)+16>>2]|0)+(c[g>>2]<<2)>>2]|0)+12>>2]|0,1609,132592,0);c[e>>2]=-1;n=c[e>>2]|0;i=d;return n|0}c[(c[j>>2]|0)+4>>2]=20;Xh(c[h>>2]|0,c[j>>2]|0)|0;while(1){if(!(c[k>>2]|0))break a;c[h>>2]=c[k>>2];c[k>>2]=c[(c[k>>2]|0)+24>>2];wi(c[j>>2]|0,c[h>>2]|0)|0}}while(0);c[e>>2]=0;n=c[e>>2]|0;i=d;return n|0}c[e>>2]=-1;n=c[e>>2]|0;i=d;return n|0}c[e>>2]=-1;n=c[e>>2]|0;i=d;return n|0}function ew(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+32|0;h=g;j=g+20|0;k=g+16|0;l=g+12|0;m=g+8|0;n=g+4|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;if(c[j>>2]|0){f=(c[j>>2]|0)+52|0;c[f>>2]=(c[f>>2]|0)+1}f=c[j>>2]|0;j=c[k>>2]|0;k=c[l>>2]|0;l=c[n>>2]|0;e=c[m>>2]|0;c[h>>2]=c[n>>2];Xd(0,0,0,f,j,11,k,2,0,0,l,0,0,0,0,e,h);i=g;return}function fw(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+64|0;f=e+60|0;g=e+56|0;h=e+52|0;j=e+48|0;k=e+44|0;l=e+40|0;m=e+36|0;n=e+32|0;o=e+28|0;p=e+24|0;q=e+20|0;r=e+16|0;s=e+12|0;t=e+8|0;u=e+4|0;v=e;c[g>>2]=a;c[h>>2]=b;c[m>>2]=0;c[r>>2]=1;c[t>>2]=0;if(!(c[g>>2]|0)){c[f>>2]=-1;w=c[f>>2]|0;i=e;return w|0}if(!(c[h>>2]|0)){c[f>>2]=-1;w=c[f>>2]|0;i=e;return w|0}c[n>>2]=gw(c[g>>2]|0,c[h>>2]|0,132616)|0;if((c[n>>2]|0)==0?(c[n>>2]=my(132624)|0,(c[n>>2]|0)==0):0){c[f>>2]=-1;w=c[f>>2]|0;i=e;return w|0}if(!((d[c[n>>2]>>0]|0|0)!=35?(d[c[n>>2]>>0]|0|0)!=0:0))c[t>>2]=1;c[o>>2]=gw(c[g>>2]|0,c[h>>2]|0,132632)|0;do if(c[o>>2]|0){if(qy(c[o>>2]|0,132640)|0){c[r>>2]=1;break}if(qy(c[o>>2]|0,132648)|0){c[r>>2]=0;break}ew(c[g>>2]|0,c[h>>2]|0,1601,132656,c[o>>2]|0);if(c[n>>2]|0)zb[c[135736>>2]&511](c[n>>2]|0);if(c[o>>2]|0)zb[c[135736>>2]&511](c[o>>2]|0);c[f>>2]=-1;w=c[f>>2]|0;i=e;return w|0}while(0);c[p>>2]=Xi(c[c[g>>2]>>2]|0,c[h>>2]|0)|0;b=c[n>>2]|0;if(!(c[p>>2]|0))c[q>>2]=Hl(b,c[(c[c[g>>2]>>2]|0)+72>>2]|0)|0;else c[q>>2]=Hl(b,c[p>>2]|0)|0;if(!(c[q>>2]|0)){c[u>>2]=Gl(c[p>>2]|0)|0;c[v>>2]=Gl(c[n>>2]|0)|0;c[q>>2]=Hl(c[v>>2]|0,c[u>>2]|0)|0;if(c[u>>2]|0)zb[c[135736>>2]&511](c[u>>2]|0);if(c[v>>2]|0)zb[c[135736>>2]&511](c[v>>2]|0)}if(c[o>>2]|0)zb[c[135736>>2]&511](c[o>>2]|0);if(c[n>>2]|0)zb[c[135736>>2]&511](c[n>>2]|0);if(c[p>>2]|0)zb[c[135736>>2]&511](c[p>>2]|0);p=c[g>>2]|0;n=c[h>>2]|0;if(!(c[q>>2]|0)){ew(p,n,1605,132688,0);c[f>>2]=-1;w=c[f>>2]|0;i=e;return w|0}c[m>>2]=gw(p,n,133496)|0;c[k>>2]=yl(c[q>>2]|0)|0;if(!(c[k>>2]|0)){ew(c[g>>2]|0,c[h>>2]|0,1605,132840,c[q>>2]|0);if(c[m>>2]|0)zb[c[135736>>2]&511](c[m>>2]|0);zb[c[135736>>2]&511](c[q>>2]|0);c[f>>2]=-1;w=c[f>>2]|0;i=e;return w|0}do if(c[(c[k>>2]|0)+32>>2]|0)if(c[(c[g>>2]|0)+56>>2]|0){if(!(c[m>>2]|0))c[m>>2]=c[(c[k>>2]|0)+32>>2];else zb[c[135736>>2]&511](c[(c[k>>2]|0)+32>>2]|0);c[(c[k>>2]|0)+32>>2]=0;break}else{ew(c[g>>2]|0,c[h>>2]|0,1618,133512,c[q>>2]|0);if(c[m>>2]|0)zb[c[135736>>2]&511](c[m>>2]|0);Al(c[k>>2]|0);zb[c[135736>>2]&511](c[q>>2]|0);c[f>>2]=-1;w=c[f>>2]|0;i=e;return w|0}while(0);c[l>>2]=Cl(c[k>>2]|0)|0;Al(c[k>>2]|0);zb[c[135736>>2]&511](c[q>>2]|0);if(!(c[l>>2]|0)){ew(c[g>>2]|0,c[h>>2]|0,1605,132840,c[q>>2]|0);if(c[m>>2]|0)zb[c[135736>>2]&511](c[m>>2]|0);c[f>>2]=-1;w=c[f>>2]|0;i=e;return w|0}do if((c[t>>2]|0)==1&(c[r>>2]|0)==1){if((c[m>>2]|0)!=0?(d[c[m>>2]>>0]|0|0)!=0:0)break;ew(c[g>>2]|0,c[h>>2]|0,1600,133584,c[l>>2]|0);if(c[m>>2]|0)zb[c[135736>>2]&511](c[m>>2]|0);c[f>>2]=-1;w=c[f>>2]|0;i=e;return w|0}while(0);a:do if((c[t>>2]|0)==0&(c[r>>2]|0)==1){c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[(c[g>>2]|0)+40>>2]|0))break a;if(qy(c[l>>2]|0,c[(c[(c[g>>2]|0)+48>>2]|0)+(c[s>>2]<<2)>>2]|0)|0)break;c[s>>2]=(c[s>>2]|0)+1}ew(c[g>>2]|0,c[h>>2]|0,1600,133640,c[l>>2]|0);c[f>>2]=-1;w=c[f>>2]|0;i=e;return w|0}while(0);c[j>>2]=lw(c[g>>2]|0,c[l>>2]|0,c[h>>2]|0)|0;if(!(c[j>>2]|0)){c[f>>2]=-1;w=c[f>>2]|0;i=e;return w|0}else{c[(c[j>>2]|0)+4>>2]=c[m>>2];c[(c[j>>2]|0)+8>>2]=0;c[(c[j>>2]|0)+20>>2]=c[r>>2];c[(c[j>>2]|0)+24>>2]=1;zb[c[135736>>2]&511](c[l>>2]|0);c[f>>2]=0;w=c[f>>2]|0;i=e;return w|0}return 0}function gw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=Ui(c[h>>2]|0,132728,c[j>>2]|0)|0;if(c[k>>2]|0){c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}if((c[(c[g>>2]|0)+56>>2]|0)!=0?(c[k>>2]=Ui(c[h>>2]|0,132760,c[j>>2]|0)|0,(c[k>>2]|0)!=0):0){c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}c[k>>2]=Yi(c[h>>2]|0,c[j>>2]|0)|0;c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}function hw(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+80|0;g=f+68|0;h=f+64|0;j=f+60|0;k=f+56|0;l=f+52|0;m=f+48|0;n=f+44|0;o=f+40|0;p=f+36|0;q=f+32|0;r=f+28|0;s=f+24|0;t=f+20|0;u=f+16|0;v=f+12|0;w=f+8|0;x=f+4|0;y=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=e;c[o>>2]=0;c[p>>2]=0;c[m>>2]=yl(c[j>>2]|0)|0;if(!(c[m>>2]|0)){ew(c[h>>2]|0,c[(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)+12>>2]|0,1605,132840,c[j>>2]|0);c[g>>2]=-1;z=c[g>>2]|0;i=f;return z|0}if(c[(c[m>>2]|0)+32>>2]|0){c[o>>2]=c[(c[m>>2]|0)+32>>2];c[(c[m>>2]|0)+32>>2]=0}if(((c[(c[h>>2]|0)+16>>2]|0)!=0?(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)!=0:0)?(c[(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)+4>>2]|0)!=0:0){if(c[o>>2]|0)zb[c[135736>>2]&511](c[o>>2]|0);c[o>>2]=my(c[(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)+4>>2]|0)|0}c[n>>2]=Cl(c[m>>2]|0)|0;Al(c[m>>2]|0);if(!(c[n>>2]|0)){m=c[h>>2]|0;if(c[(c[h>>2]|0)+16>>2]|0)ew(m,c[(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)+12>>2]|0,1605,132840,c[j>>2]|0);else ew(m,0,1605,132840,c[j>>2]|0);if(c[o>>2]|0)zb[c[135736>>2]&511](c[o>>2]|0);c[g>>2]=-1;z=c[g>>2]|0;i=f;return z|0}do if((d[c[n>>2]>>0]|0|0)!=0?(d[c[n>>2]>>0]|0|0)!=35:0){if((c[c[h>>2]>>2]|0)!=0?(qy(c[n>>2]|0,c[(c[c[h>>2]>>2]|0)+72>>2]|0)|0)!=0:0){A=22;break}c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[(c[h>>2]|0)+8>>2]|0))break;if((qy(c[n>>2]|0,c[c[(c[(c[h>>2]|0)+16>>2]|0)+(c[p>>2]<<2)>>2]>>2]|0)|0)!=0?(c[(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[p>>2]<<2)>>2]|0)+8>>2]|0)!=0:0){A=27;break}c[p>>2]=(c[p>>2]|0)+1}if((A|0)==27){c[l>>2]=c[(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[p>>2]<<2)>>2]|0)+8>>2];break}c[q>>2]=c[(c[h>>2]|0)+60>>2];if(c[o>>2]|0){j=(c[h>>2]|0)+60|0;c[j>>2]=c[j>>2]|2}c[l>>2]=mw(c[h>>2]|0,c[n>>2]|0)|0;c[(c[h>>2]|0)+60>>2]=c[q>>2];if(!(c[l>>2]|0)){zb[c[135736>>2]&511](c[n>>2]|0);if(c[o>>2]|0)zb[c[135736>>2]&511](c[o>>2]|0);c[g>>2]=-1;z=c[g>>2]|0;i=f;return z|0}c[(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)+8>>2]=c[l>>2];if(!(qy(c[n>>2]|0,c[(c[l>>2]|0)+72>>2]|0)|0)){zb[c[135736>>2]&511](c[n>>2]|0);c[n>>2]=my(c[(c[l>>2]|0)+72>>2]|0)|0}c[p>>2]=(c[k>>2]|0)+1;while(1){if((c[p>>2]|0)>=(c[(c[h>>2]|0)+8>>2]|0))break;if(qy(c[n>>2]|0,c[c[(c[(c[h>>2]|0)+16>>2]|0)+(c[p>>2]<<2)>>2]>>2]|0)|0){A=40;break}c[p>>2]=(c[p>>2]|0)+1}if((A|0)==40){j=(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)+24|0;c[j>>2]=(c[j>>2]|0)+1}nw(c[h>>2]|0,c[c[h>>2]>>2]|0,c[l>>2]|0)|0;ow(c[h>>2]|0,c[l>>2]|0,c[n>>2]|0)}else A=22;while(0);if((A|0)==22)c[l>>2]=0;q=(c[l>>2]|0)==0;do if(!(c[o>>2]|0)){j=c[h>>2]|0;if(q){m=Ki(c[(c[j>>2]|0)+12>>2]|0)|0;c[(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)+16>>2]=m;break}else{m=pw(j,c[c[h>>2]>>2]|0,c[l>>2]|0,c[(c[l>>2]|0)+12>>2]|0)|0;c[(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)+16>>2]=m;break}}else{if(q)c[s>>2]=iv(c[c[h>>2]>>2]|0,c[(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)+12>>2]|0,0)|0;else c[s>>2]=iv(c[l>>2]|0,0,0)|0;if(!(c[s>>2]|0)){ew(c[h>>2]|0,c[(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)+12>>2]|0,1612,133056,0);zb[c[135736>>2]&511](c[n>>2]|0);zb[c[135736>>2]&511](c[o>>2]|0);c[g>>2]=-1;z=c[g>>2]|0;i=f;return z|0}c[r>>2]=kv(c[o>>2]|0,c[s>>2]|0)|0;if(!(c[r>>2]|0)){ew(c[h>>2]|0,c[(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)+12>>2]|0,1612,133096,c[o>>2]|0);Nr(c[s>>2]|0);zb[c[135736>>2]&511](c[n>>2]|0);zb[c[135736>>2]&511](c[o>>2]|0);c[g>>2]=-1;z=c[g>>2]|0;i=f;return z|0}switch(c[c[r>>2]>>2]|0){case 9:case 8:case 5:case 4:case 3:case 2:case 0:{ew(c[h>>2]|0,c[(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)+12>>2]|0,1613,133136,c[o>>2]|0);Nr(c[s>>2]|0);zb[c[135736>>2]&511](c[n>>2]|0);zb[c[135736>>2]&511](c[o>>2]|0);c[g>>2]=-1;z=c[g>>2]|0;i=f;return z|0}case 1:{A=56;break}default:{}}do if((A|0)==56){if((c[(c[r>>2]|0)+4>>2]|0)!=0?(c[c[(c[r>>2]|0)+4>>2]>>2]|0)>0:0)break;Nr(c[s>>2]|0);zb[c[135736>>2]&511](c[n>>2]|0);zb[c[135736>>2]&511](c[o>>2]|0);c[g>>2]=-1;z=c[g>>2]|0;i=f;return z|0}while(0);c[t>>2]=c[(c[r>>2]|0)+4>>2];a:do if(c[t>>2]|0){c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[c[t>>2]>>2]|0))break a;b:do if(c[(c[(c[t>>2]|0)+8>>2]|0)+(c[p>>2]<<2)>>2]|0)switch(c[(c[(c[(c[t>>2]|0)+8>>2]|0)+(c[p>>2]<<2)>>2]|0)+4>>2]|0){case 10:case 11:case 12:case 14:case 15:case 16:case 17:case 19:case 20:{ew(c[h>>2]|0,c[(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)+12>>2]|0,1613,133248,c[o>>2]|0);c[(c[(c[t>>2]|0)+8>>2]|0)+(c[p>>2]<<2)>>2]=0;c[(c[(c[t>>2]|0)+8>>2]|0)+(c[p>>2]<<2)>>2]=0;break b;break}case 18:{ew(c[h>>2]|0,c[(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)+12>>2]|0,1613,133208,c[o>>2]|0);c[(c[(c[t>>2]|0)+8>>2]|0)+(c[p>>2]<<2)>>2]=0;break b;break}case 2:{ew(c[h>>2]|0,c[(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)+12>>2]|0,1613,133168,c[o>>2]|0);c[(c[(c[t>>2]|0)+8>>2]|0)+(c[p>>2]<<2)>>2]=0;break b;break}default:break b}while(0);c[p>>2]=(c[p>>2]|0)+1}}while(0);if(!(c[l>>2]|0)){c[(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)+28>>2]=c[r>>2];c[(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)+16>>2]=0}else{m=kw(c[h>>2]|0,c[c[h>>2]>>2]|0,c[l>>2]|0,c[r>>2]|0)|0;c[(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)+16>>2]=m;Qq(c[r>>2]|0)}Nr(c[s>>2]|0);zb[c[135736>>2]&511](c[o>>2]|0)}while(0);if(((c[l>>2]|0)!=0&(c[n>>2]|0)!=0?(c[(c[h>>2]|0)+60>>2]&262144|0)==0:0)?(c[(c[l>>2]|0)+88>>2]&262144|0)==0:0){c[v>>2]=Ui(c[(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)+12>>2]|0,133288,133296)|0;do if(!(c[v>>2]|0)){c[w>>2]=Il(c[n>>2]|0,c[(c[h>>2]|0)+64>>2]|0)|0;if(!(c[w>>2]|0)){ew(c[h>>2]|0,c[(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)+12>>2]|0,1605,133336,c[n>>2]|0);break}if(vy(c[w>>2]|0,47)|0){c[v>>2]=c[w>>2];break}else{zb[c[135736>>2]&511](c[w>>2]|0);break}}while(0);if(c[v>>2]|0){c[u>>2]=c[(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)+16>>2];while(1){if(!(c[u>>2]|0))break;do if((c[(c[u>>2]|0)+4>>2]|0)==1){c[w>>2]=Xi(c[(c[u>>2]|0)+32>>2]|0,c[u>>2]|0)|0;if(!(c[w>>2]|0)){Wi(c[u>>2]|0,c[v>>2]|0);break}l=(qy(c[w>>2]|0,c[(c[(c[u>>2]|0)+32>>2]|0)+72>>2]|0)|0)!=0;o=c[u>>2]|0;if(!l){c[x>>2]=Ui(o,133288,133296)|0;if(c[x>>2]|0){c[y>>2]=Hl(c[x>>2]|0,c[v>>2]|0)|0;if(!(c[y>>2]|0))ew(c[h>>2]|0,c[(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)+12>>2]|0,1605,133376,c[x>>2]|0);else{Wi(c[u>>2]|0,c[y>>2]|0);zb[c[135736>>2]&511](c[y>>2]|0)}zb[c[135736>>2]&511](c[x>>2]|0)}}else Wi(o,c[v>>2]|0);zb[c[135736>>2]&511](c[w>>2]|0)}while(0);c[u>>2]=c[(c[u>>2]|0)+24>>2]}zb[c[135736>>2]&511](c[v>>2]|0)}}if(((c[k>>2]|0)<(c[(c[h>>2]|0)+8>>2]|0)?(c[(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)+8>>2]|0)!=0:0)?(c[(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)+24>>2]|0)<=1:0){
Th(c[(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)+8>>2]|0);c[(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)+8>>2]=0}zb[c[135736>>2]&511](c[n>>2]|0);c[g>>2]=0;z=c[g>>2]|0;i=f;return z|0}function iw(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+80|0;g=f+68|0;h=f+64|0;j=f+60|0;k=f+56|0;l=f+52|0;m=f+48|0;n=f+44|0;o=f+40|0;p=f+36|0;q=f+32|0;r=f+28|0;s=f+24|0;t=f+20|0;u=f+16|0;v=f+12|0;w=f+8|0;x=f+4|0;y=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=e;c[q>>2]=0;c[r>>2]=0;c[u>>2]=0;c[n>>2]=yl(c[j>>2]|0)|0;if(!(c[n>>2]|0)){ew(c[h>>2]|0,c[(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)+12>>2]|0,1605,132840,c[j>>2]|0);c[g>>2]=-1;z=c[g>>2]|0;i=f;return z|0}if(c[(c[n>>2]|0)+32>>2]|0){ew(c[h>>2]|0,c[(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)+12>>2]|0,1606,132864,c[(c[n>>2]|0)+32>>2]|0);Al(c[n>>2]|0);c[g>>2]=-1;z=c[g>>2]|0;i=f;return z|0}c[o>>2]=Cl(c[n>>2]|0)|0;Al(c[n>>2]|0);if(!(c[o>>2]|0)){ew(c[h>>2]|0,c[(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)+12>>2]|0,1605,132840,c[j>>2]|0);c[g>>2]=-1;z=c[g>>2]|0;i=f;return z|0}if(!(d[c[o>>2]>>0]|0)){ew(c[h>>2]|0,c[(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)+12>>2]|0,1607,132912,0);zb[c[135736>>2]&511](c[o>>2]|0);c[g>>2]=-1;z=c[g>>2]|0;i=f;return z|0}c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[(c[h>>2]|0)+20>>2]|0)){A=14;break}j=(qy(c[o>>2]|0,c[(c[(c[h>>2]|0)+32>>2]|0)+(c[p>>2]<<2)>>2]|0)|0)!=0;B=c[p>>2]|0;if(j){A=12;break}c[p>>2]=B+1}do if((A|0)==12)c[m>>2]=Hi(c[(c[(c[h>>2]|0)+28>>2]|0)+(B<<2)>>2]|0,1)|0;else if((A|0)==14){if((c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)!=0?(c[(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)+12>>2]|0)!=0:0)c[q>>2]=Yi(c[(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)+12>>2]|0,132960)|0;do if(c[q>>2]|0){c[r>>2]=wd(c[q>>2]|0)|0;if((c[r>>2]|0)!=-1){zb[c[135736>>2]&511](c[q>>2]|0);break}ew(c[h>>2]|0,c[(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)+12>>2]|0,1610,132976,c[q>>2]|0);zb[c[135736>>2]&511](c[q>>2]|0);zb[c[135736>>2]&511](c[o>>2]|0);c[g>>2]=-1;z=c[g>>2]|0;i=f;return z|0}while(0);c[s>>2]=Be()|0;c[t>>2]=Vk(c[o>>2]|0,0,c[s>>2]|0)|0;if(!(c[t>>2]|0)){Ae(c[s>>2]|0);zb[c[135736>>2]&511](c[o>>2]|0);c[g>>2]=-1;z=c[g>>2]|0;i=f;return z|0}c[l>>2]=c[c[t>>2]>>2];if(!(c[l>>2]|0)){te(c[t>>2]|0);Ae(c[s>>2]|0);zb[c[135736>>2]&511](c[o>>2]|0);c[g>>2]=-1;z=c[g>>2]|0;i=f;return z|0}if(c[(c[l>>2]|0)+12>>2]|0)Hd(c[(c[l>>2]|0)+12>>2]|0)|0;j=Cd(c[r>>2]|0)|0;c[(c[l>>2]|0)+12>>2]=j;c[m>>2]=li(0)|0;while(1){if((Nk(c[l>>2]|0,128)|0)<=0){A=41;break}c[w>>2]=Vy(c[(c[l>>2]|0)+16>>2]|0)|0;c[v>>2]=Zy(c[(c[l>>2]|0)+16>>2]|0)|0;c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[v>>2]|0)){A=40;break}c[x>>2]=oe(0,(c[w>>2]|0)+(c[p>>2]|0)|0,y)|0;j=c[x>>2]|0;if((c[x>>2]|0)<256){if(!(9<=(j|0)&(c[x>>2]|0)<=10|(c[x>>2]|0)==13|32<=(c[x>>2]|0)))break}else if((!(256<=(j|0)&(c[x>>2]|0)<=55295)?!(57344<=(c[x>>2]|0)&(c[x>>2]|0)<=65533):0)?!(65536<=(c[x>>2]|0)&(c[x>>2]|0)<=1114111):0)break;c[u>>2]=0;$i(c[m>>2]|0,(c[w>>2]|0)+(c[p>>2]|0)|0,c[y>>2]|0);c[p>>2]=(c[p>>2]|0)+(c[y>>2]|0)}if((A|0)==40){A=0;Ty(c[(c[l>>2]|0)+16>>2]|0,c[v>>2]|0)|0;continue}if((c[u>>2]|0)!=0?1:((c[v>>2]|0)-(c[p>>2]|0)|0)>=4)break;c[u>>2]=1;Ty(c[(c[l>>2]|0)+16>>2]|0,c[p>>2]|0)|0}if((A|0)==41){Ae(c[s>>2]|0);qw(c[h>>2]|0,c[m>>2]|0,c[o>>2]|0);te(c[t>>2]|0);break}ew(c[h>>2]|0,c[(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)+12>>2]|0,1608,133008,c[o>>2]|0);yk(c[l>>2]|0);zb[c[135736>>2]&511](c[o>>2]|0);c[g>>2]=-1;z=c[g>>2]|0;i=f;return z|0}while(0);c[(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)+16>>2]=c[m>>2];zb[c[135736>>2]&511](c[o>>2]|0);c[g>>2]=0;z=c[g>>2]|0;i=f;return z|0}function jw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[l>>2]=0;if((c[h>>2]|0)!=0?!((c[g>>2]|0)==0?1:(c[(c[h>>2]|0)+4>>2]|0)==18):0){if(c[(c[h>>2]|0)+12>>2]|0){c[k>>2]=Qv(c[c[g>>2]>>2]|0)|0;if(!(c[k>>2]|0)){c[f>>2]=-1;m=c[f>>2]|0;i=e;return m|0}c[(c[k>>2]|0)+68>>2]=c[(c[g>>2]|0)+68>>2];d=my(c[(c[g>>2]|0)+64>>2]|0)|0;c[(c[k>>2]|0)+64>>2]=d;Sv(c[k>>2]|0,c[(c[g>>2]|0)+60>>2]|0)|0;c[l>>2]=_v(c[k>>2]|0,c[c[g>>2]>>2]|0,c[(c[h>>2]|0)+12>>2]|0)|0;if((c[(c[g>>2]|0)+52>>2]|0)<=0){if((c[l>>2]|0)>0)c[l>>2]=0}else c[l>>2]=-1;Rv(c[k>>2]|0);k=Ji(c[c[g>>2]>>2]|0,c[(c[h>>2]|0)+12>>2]|0)|0;c[(c[(c[(c[g>>2]|0)+16>>2]|0)+(c[j>>2]<<2)>>2]|0)+16>>2]=k}else{c[(c[(c[(c[g>>2]|0)+16>>2]|0)+(c[j>>2]<<2)>>2]|0)+16>>2]=0;c[(c[(c[(c[g>>2]|0)+16>>2]|0)+(c[j>>2]<<2)>>2]|0)+32>>2]=1}c[f>>2]=c[l>>2];m=c[f>>2]|0;i=e;return m|0}c[f>>2]=-1;m=c[f>>2]|0;i=e;return m|0}function kw(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+48|0;g=f+44|0;h=f+40|0;j=f+36|0;k=f+32|0;l=f+28|0;m=f+24|0;n=f+20|0;o=f+16|0;p=f+12|0;q=f+8|0;r=f+4|0;s=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=0;c[n>>2]=0;if(!(c[k>>2]|0))c[k>>2]=c[c[h>>2]>>2];if((c[h>>2]|0)==0|(c[j>>2]|0)==0|(c[k>>2]|0)==0|(c[l>>2]|0)==0){c[g>>2]=0;t=c[g>>2]|0;i=f;return t|0}e=c[c[l>>2]>>2]|0;a:do if((e|0)==6){c[g>>2]=sw(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0)|0;t=c[g>>2]|0;i=f;return t|0}else if((e|0)==1){c[p>>2]=c[(c[l>>2]|0)+4>>2];if(!(c[p>>2]|0)){c[g>>2]=0;t=c[g>>2]|0;i=f;return t|0}c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[c[p>>2]>>2]|0))break a;b:do if(c[(c[(c[p>>2]|0)+8>>2]|0)+(c[o>>2]<<2)>>2]|0){switch(c[(c[(c[(c[p>>2]|0)+8>>2]|0)+(c[o>>2]<<2)>>2]|0)+4>>2]|0){case 2:case 18:case 10:case 11:case 12:case 14:case 15:case 16:case 17:{break b;break}case 19:break;default:{if(!(c[n>>2]|0)){d=rw(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,c[(c[(c[p>>2]|0)+8>>2]|0)+(c[o>>2]<<2)>>2]|0)|0;c[n>>2]=d;c[m>>2]=d;break b}Xh(c[n>>2]|0,rw(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,c[(c[(c[p>>2]|0)+8>>2]|0)+(c[o>>2]<<2)>>2]|0)|0)|0;if(!(c[(c[n>>2]|0)+24>>2]|0))break b;c[n>>2]=c[(c[n>>2]|0)+24>>2];break b}}c[r>>2]=c[(c[(c[p>>2]|0)+8>>2]|0)+(c[o>>2]<<2)>>2];c[r>>2]=c[(c[r>>2]|0)+24>>2];while(1){if(!(c[r>>2]|0))break b;switch(c[(c[r>>2]|0)+4>>2]|0){case 8:case 7:case 6:case 5:case 1:case 4:case 3:break;default:break b}c[q>>2]=rw(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,c[r>>2]|0)|0;if(!(c[n>>2]|0)){d=c[q>>2]|0;c[n>>2]=d;c[m>>2]=d}else{Xh(c[n>>2]|0,c[q>>2]|0)|0;c[n>>2]=c[q>>2]}c[r>>2]=c[(c[r>>2]|0)+24>>2]}}while(0);c[o>>2]=(c[o>>2]|0)+1}}else if((e|0)==7){c[s>>2]=c[(c[l>>2]|0)+28>>2];if(!(c[s>>2]|0)){c[g>>2]=0;t=c[g>>2]|0;i=f;return t|0}c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[c[s>>2]>>2]|0))break a;if(!(c[n>>2]|0)){d=kw(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,c[(c[(c[s>>2]|0)+8>>2]|0)+(c[o>>2]<<2)>>2]|0)|0;c[n>>2]=d;c[m>>2]=d}else{d=c[n>>2]|0;Xh(d,kw(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,c[(c[(c[s>>2]|0)+8>>2]|0)+(c[o>>2]<<2)>>2]|0)|0)|0}c:do if(c[n>>2]|0)while(1){if(!(c[(c[n>>2]|0)+24>>2]|0))break c;c[n>>2]=c[(c[n>>2]|0)+24>>2]}while(0);c[o>>2]=(c[o>>2]|0)+1}}while(0);c[g>>2]=c[m>>2];t=c[g>>2]|0;i=f;return t|0}function lw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=Cb[c[135744>>2]&511](36)|0;if(!(c[k>>2]|0)){Xv(c[g>>2]|0,c[j>>2]|0,133672);c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}d=(c[k>>2]|0)+0|0;b=d+36|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(b|0));if(!(c[h>>2]|0))c[c[k>>2]>>2]=0;else{d=my(c[h>>2]|0)|0;c[c[k>>2]>>2]=d}c[(c[k>>2]|0)+4>>2]=0;c[(c[k>>2]|0)+12>>2]=c[j>>2];c[(c[k>>2]|0)+8>>2]=0;c[(c[k>>2]|0)+24>>2]=0;c[(c[k>>2]|0)+20>>2]=0;c[(c[k>>2]|0)+16>>2]=0;if((c[(c[g>>2]|0)+12>>2]|0)==0?(c[(c[g>>2]|0)+12>>2]=4,d=Cb[c[135744>>2]&511](c[(c[g>>2]|0)+12>>2]<<2)|0,c[(c[g>>2]|0)+16>>2]=d,(c[(c[g>>2]|0)+16>>2]|0)==0):0){Xv(c[g>>2]|0,c[j>>2]|0,133672);Zv(c[k>>2]|0);c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}if((c[(c[g>>2]|0)+8>>2]|0)>=(c[(c[g>>2]|0)+12>>2]|0)?(d=(c[g>>2]|0)+12|0,c[d>>2]=c[d>>2]<<1,d=Hb[c[135760>>2]&511](c[(c[g>>2]|0)+16>>2]|0,c[(c[g>>2]|0)+12>>2]<<2)|0,c[(c[g>>2]|0)+16>>2]=d,(c[(c[g>>2]|0)+16>>2]|0)==0):0){Xv(c[g>>2]|0,c[j>>2]|0,133672);Zv(c[k>>2]|0);c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}j=c[k>>2]|0;d=(c[g>>2]|0)+8|0;h=c[d>>2]|0;c[d>>2]=h+1;c[(c[(c[g>>2]|0)+16>>2]|0)+(h<<2)>>2]=j;c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}function mw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;Rf();c[j>>2]=Be()|0;b=c[f>>2]|0;if(!(c[j>>2]|0)){Xv(b,0,133464);c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}c[(c[j>>2]|0)+272>>2]=c[b+68>>2];if((c[c[f>>2]>>2]|0)!=0?(c[(c[c[f>>2]>>2]|0)+80>>2]|0)!=0:0){if(c[(c[j>>2]|0)+296>>2]|0)zP(c[(c[j>>2]|0)+296>>2]|0);c[(c[j>>2]|0)+296>>2]=c[(c[c[f>>2]>>2]|0)+80>>2];yP(c[(c[j>>2]|0)+296>>2]|0)|0}fg(c[j>>2]|0,c[(c[f>>2]|0)+60>>2]|4)|0;c[k>>2]=Vk(c[g>>2]|0,0,c[j>>2]|0)|0;f=c[j>>2]|0;if(!(c[k>>2]|0)){Ae(f);c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}Oe(f,c[k>>2]|0)|0;if(!(c[(c[j>>2]|0)+180>>2]|0)){k=Rk(c[g>>2]|0)|0;c[(c[j>>2]|0)+180>>2]=k}k=(c[j>>2]|0)+276|0;c[k>>2]=c[k>>2]|2;Qf(c[j>>2]|0)|0;if(c[(c[j>>2]|0)+12>>2]|0)c[h>>2]=c[(c[j>>2]|0)+8>>2];else{c[h>>2]=0;if(c[(c[j>>2]|0)+8>>2]|0)Th(c[(c[j>>2]|0)+8>>2]|0);c[(c[j>>2]|0)+8>>2]=0}Ae(c[j>>2]|0);c[e>>2]=c[h>>2];l=c[e>>2]|0;i=d;return l|0}function nw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+48|0;f=e+40|0;g=e+36|0;h=e+32|0;j=e+28|0;k=e+24|0;l=e+20|0;m=e+16|0;n=e+8|0;o=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(!(c[g>>2]|0)){c[f>>2]=-1;p=c[f>>2]|0;i=e;return p|0}if((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+44>>2]|0)!=0:0){c[l>>2]=c[(c[h>>2]|0)+44>>2];if(!(c[l>>2]|0)){c[k>>2]=Pi(c[h>>2]|0)|0;if(!(c[k>>2]|0)){c[f>>2]=-1;p=c[f>>2]|0;i=e;return p|0}c[l>>2]=Oh(c[h>>2]|0,c[(c[k>>2]|0)+8>>2]|0,0,0)|0;if(!(c[l>>2]|0)){c[f>>2]=-1;p=c[f>>2]|0;i=e;return p|0}}c[m>>2]=c[(c[j>>2]|0)+44>>2];if((c[m>>2]|0)!=0?(c[(c[m>>2]|0)+48>>2]|0)!=0:0){c[n+4>>2]=c[g>>2];c[n>>2]=c[h>>2];Wj(c[(c[m>>2]|0)+48>>2]|0,314,n)}c[m>>2]=c[(c[j>>2]|0)+48>>2];if((((c[m>>2]|0)!=0?(c[(c[m>>2]|0)+48>>2]|0)!=0:0)?(c[o+4>>2]=c[g>>2],c[o>>2]=c[h>>2],(qy(c[(c[l>>2]|0)+52>>2]|0,c[(c[m>>2]|0)+52>>2]|0)|0)==0):0)?(qy(c[(c[l>>2]|0)+56>>2]|0,c[(c[m>>2]|0)+56>>2]|0)|0)==0:0)Wj(c[(c[m>>2]|0)+48>>2]|0,314,o);c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}function ow(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[e+8>>2]=d;c[h>>2]=Qv(c[g>>2]|0)|0;if(!(c[h>>2]|0)){i=e;return}c[(c[h>>2]|0)+68>>2]=c[(c[f>>2]|0)+68>>2];c[(c[h>>2]|0)+12>>2]=c[(c[f>>2]|0)+12>>2];c[(c[h>>2]|0)+8>>2]=c[(c[f>>2]|0)+8>>2];d=Cb[c[135744>>2]&511](c[(c[h>>2]|0)+12>>2]<<2)|0;c[(c[h>>2]|0)+16>>2]=d;d=c[f>>2]|0;if(!(c[(c[h>>2]|0)+16>>2]|0)){Xv(d,c[g>>2]|0,133408);zb[c[135736>>2]&511](c[h>>2]|0);i=e;return}c[(c[h>>2]|0)+44>>2]=c[d+44>>2];c[(c[h>>2]|0)+40>>2]=c[(c[f>>2]|0)+40>>2];c[(c[h>>2]|0)+48>>2]=c[(c[f>>2]|0)+48>>2];d=my(c[(c[f>>2]|0)+64>>2]|0)|0;c[(c[h>>2]|0)+64>>2]=d;c[(c[h>>2]|0)+4>>2]=c[(c[f>>2]|0)+8>>2];c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[(c[f>>2]|0)+8>>2]|0))break;c[(c[(c[h>>2]|0)+16>>2]|0)+(c[j>>2]<<2)>>2]=c[(c[(c[f>>2]|0)+16>>2]|0)+(c[j>>2]<<2)>>2];d=(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[j>>2]<<2)>>2]|0)+24|0;c[d>>2]=(c[d>>2]|0)+1;c[j>>2]=(c[j>>2]|0)+1}c[(c[h>>2]|0)+60>>2]=c[(c[f>>2]|0)+60>>2];d=c[h>>2]|0;b=c[g>>2]|0;_v(d,b,Pi(c[g>>2]|0)|0)|0;c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[(c[f>>2]|0)+8>>2]|0))break;g=(c[(c[(c[h>>2]|0)+16>>2]|0)+(c[j>>2]<<2)>>2]|0)+24|0;c[g>>2]=(c[g>>2]|0)+-1;c[(c[(c[h>>2]|0)+16>>2]|0)+(c[j>>2]<<2)>>2]=0;c[j>>2]=(c[j>>2]|0)+1}c[(c[f>>2]|0)+48>>2]=c[(c[h>>2]|0)+48>>2];c[(c[f>>2]|0)+44>>2]=c[(c[h>>2]|0)+44>>2];c[(c[h>>2]|0)+44>>2]=0;c[(c[h>>2]|0)+40>>2]=0;c[(c[h>>2]|0)+48>>2]=0;Rv(c[h>>2]|0);i=e;return}function pw(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+48|0;g=f+32|0;h=f+28|0;j=f+24|0;k=f+20|0;l=f+16|0;m=f+12|0;n=f+8|0;o=f+4|0;p=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[o>>2]=0;c[p>>2]=0;if((c[h>>2]|0)==0|(c[j>>2]|0)==0|(c[k>>2]|0)==0|(c[l>>2]|0)==0){c[g>>2]=0;q=c[g>>2]|0;i=f;return q|0}c[m>>2]=c[l>>2];while(1){if(!(c[m>>2]|0))break;c[n>>2]=rw(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,c[m>>2]|0)|0;do if(c[n>>2]|0){l=c[n>>2]|0;if(!(c[o>>2]|0)){c[p>>2]=l;c[o>>2]=l;break}else{c[(c[p>>2]|0)+24>>2]=l;c[(c[n>>2]|0)+28>>2]=c[p>>2];c[p>>2]=c[n>>2];break}}while(0);c[m>>2]=c[(c[m>>2]|0)+24>>2]}c[g>>2]=c[o>>2];q=c[g>>2]|0;i=f;return q|0}function qw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if(!(c[(c[f>>2]|0)+24>>2]|0)){c[(c[f>>2]|0)+24>>2]=4;d=Cb[c[135744>>2]&511](c[(c[f>>2]|0)+24>>2]<<2)|0;c[(c[f>>2]|0)+28>>2]=d;if(!(c[(c[f>>2]|0)+28>>2]|0)){Xv(c[f>>2]|0,0,133040);i=e;return}d=Cb[c[135744>>2]&511](c[(c[f>>2]|0)+24>>2]<<2)|0;c[(c[f>>2]|0)+32>>2]=d;if(!(c[(c[f>>2]|0)+32>>2]|0)){Xv(c[f>>2]|0,0,133040);i=e;return}}if((c[(c[f>>2]|0)+20>>2]|0)>=(c[(c[f>>2]|0)+24>>2]|0)){d=(c[f>>2]|0)+24|0;c[d>>2]=c[d>>2]<<1;d=Hb[c[135760>>2]&511](c[(c[f>>2]|0)+28>>2]|0,c[(c[f>>2]|0)+24>>2]<<2)|0;c[(c[f>>2]|0)+28>>2]=d;if(!(c[(c[f>>2]|0)+28>>2]|0)){Xv(c[f>>2]|0,0,133040);i=e;return}d=Hb[c[135760>>2]&511](c[(c[f>>2]|0)+32>>2]|0,c[(c[f>>2]|0)+24>>2]<<2)|0;c[(c[f>>2]|0)+32>>2]=d;if(!(c[(c[f>>2]|0)+32>>2]|0)){Xv(c[f>>2]|0,0,133040);i=e;return}}c[(c[(c[f>>2]|0)+28>>2]|0)+(c[(c[f>>2]|0)+20>>2]<<2)>>2]=c[g>>2];g=my(c[h>>2]|0)|0;c[(c[(c[f>>2]|0)+32>>2]|0)+(c[(c[f>>2]|0)+20>>2]<<2)>>2]=g;g=(c[f>>2]|0)+20|0;c[g>>2]=(c[g>>2]|0)+1;i=e;return}function rw(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=0;if((c[h>>2]|0)==0|(c[j>>2]|0)==0|(c[k>>2]|0)==0|(c[l>>2]|0)==0){c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}if((c[(c[l>>2]|0)+4>>2]|0)==14){c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}if((c[(c[l>>2]|0)+4>>2]|0)==9)c[m>>2]=pw(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,c[(c[l>>2]|0)+12>>2]|0)|0;else c[m>>2]=Ii(c[l>>2]|0,c[j>>2]|0,1)|0;c[g>>2]=c[m>>2];n=c[g>>2]|0;i=f;return n|0}function sw(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;f=i;i=i+96|0;g=f+84|0;h=f+80|0;j=f+76|0;k=f+72|0;l=f+68|0;m=f+64|0;n=f+60|0;o=f+56|0;p=f+52|0;q=f+48|0;r=f+44|0;s=f+40|0;t=f+36|0;u=f+32|0;v=f+28|0;w=f+24|0;x=f+20|0;y=f+16|0;z=f+12|0;A=f+8|0;B=f+4|0;C=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=0;c[n>>2]=0;c[o>>2]=0;c[w>>2]=0;c[x>>2]=0;c[y>>2]=0;c[z>>2]=0;if((c[h>>2]|0)==0|(c[j>>2]|0)==0|(c[k>>2]|0)==0|(c[l>>2]|0)==0){c[g>>2]=0;D=c[g>>2]|0;i=f;return D|0}if((c[c[l>>2]>>2]|0)!=6){c[g>>2]=0;D=c[g>>2]|0;i=f;return D|0}c[r>>2]=c[(c[l>>2]|0)+28>>2];if((c[r>>2]|0)!=0?(c[(c[r>>2]|0)+4>>2]|0)!=18:0){c[t>>2]=c[(c[l>>2]|0)+36>>2];if(!(c[t>>2]|0)){c[g>>2]=Ii(c[r>>2]|0,c[j>>2]|0,1)|0;D=c[g>>2]|0;i=f;return D|0}if((c[(c[t>>2]|0)+4>>2]|0)==18){c[g>>2]=0;D=c[g>>2]|0;i=f;return D|0}c[s>>2]=c[r>>2];c[u>>2]=c[(c[l>>2]|0)+32>>2];c[v>>2]=c[(c[l>>2]|0)+40>>2];a:while(1){if(!(c[s>>2]|0)){E=65;break}b:while(1){if((c[w>>2]|0)<0){while(1){if((c[w>>2]|0)>=0)break;c[q>>2]=Ii(c[o>>2]|0,c[j>>2]|0,2)|0;zi(c[q>>2]|0,c[m>>2]|0)|0;c[m>>2]=c[q>>2];c[o>>2]=c[(c[o>>2]|0)+20>>2];c[w>>2]=(c[w>>2]|0)+1}c[n>>2]=c[m>>2];c[x>>2]=0}while(1){if((c[w>>2]|0)>=(c[x>>2]|0))break;c[n>>2]=c[(c[n>>2]|0)+20>>2];c[x>>2]=(c[x>>2]|0)+-1}F=c[s>>2]|0;if((c[s>>2]|0)==(c[t>>2]|0))break;do if((F|0)!=(c[r>>2]|0)){c[p>>2]=0;switch(c[(c[s>>2]|0)+4>>2]|0){case 2:case 20:case 19:case 17:case 6:case 16:case 15:case 14:break;default:c[p>>2]=Ii(c[s>>2]|0,c[j>>2]|0,2)|0}if(c[p>>2]|0){l=c[n>>2]|0;k=c[p>>2]|0;if((c[w>>2]|0)==(c[x>>2]|0))Xh(l,k)|0;else{zi(l,k)|0;c[x>>2]=c[w>>2]}c[n>>2]=c[p>>2]}}else{if((c[(c[s>>2]|0)+4>>2]|0)!=3?(c[(c[s>>2]|0)+4>>2]|0)!=4:0){c[p>>2]=Ii(c[s>>2]|0,c[j>>2]|0,2)|0;k=c[p>>2]|0;c[n>>2]=k;c[m>>2]=k;c[o>>2]=c[(c[s>>2]|0)+20>>2];if((c[u>>2]|0)>1){E=55;break b}else break}c[C>>2]=c[(c[s>>2]|0)+40>>2];if(!(c[C>>2]|0))c[p>>2]=ni(0,0)|0;else{if((c[u>>2]|0)>1){c[C>>2]=(c[C>>2]|0)+((c[u>>2]|0)-1);c[u>>2]=0}c[p>>2]=li(c[C>>2]|0)|0}k=c[p>>2]|0;c[m>>2]=k;c[n>>2]=k;c[o>>2]=c[(c[s>>2]|0)+20>>2]}while(0);c[s>>2]=lv(c[s>>2]|0,w)|0;if(!(c[z>>2]|0))continue a;if(!((c[s>>2]|0)!=0?(c[w>>2]|0)<(c[y>>2]|0):0)){E=65;break a}}if((E|0)==55){E=0;c[s>>2]=uw(c[s>>2]|0,(c[u>>2]|0)-1|0)|0;c[x>>2]=1;c[w>>2]=1;c[u>>2]=0;continue}if((c[F+4>>2]|0)==3)break;c[y>>2]=c[w>>2];c[z>>2]=1;c[p>>2]=Ii(c[s>>2]|0,c[j>>2]|0,2)|0;do if(c[m>>2]|0){k=c[n>>2]|0;l=c[p>>2]|0;if((c[w>>2]|0)==(c[x>>2]|0)){Xh(k,l)|0;break}else{zi(k,l)|0;c[x>>2]=c[w>>2];break}}else{c[m>>2]=c[p>>2];c[o>>2]=c[(c[s>>2]|0)+20>>2]}while(0);c[n>>2]=c[p>>2];if((c[v>>2]|0)>1){c[t>>2]=uw(c[s>>2]|0,(c[v>>2]|0)-1|0)|0;c[v>>2]=0}l=c[s>>2]|0;if((c[u>>2]|0)>1?(c[s>>2]|0)==(c[r>>2]|0):0){c[s>>2]=uw(l,(c[u>>2]|0)-1|0)|0;c[u>>2]=0}else c[s>>2]=c[l+12>>2];c[w>>2]=(c[w>>2]|0)+1}if((E|0)==65){c[g>>2]=c[m>>2];D=c[g>>2]|0;i=f;return D|0}c[A>>2]=c[(c[s>>2]|0)+40>>2];if(!(c[A>>2]|0))c[p>>2]=ni(0,0)|0;else{c[B>>2]=c[v>>2];if((c[u>>2]|0)>1?(c[s>>2]|0)==(c[r>>2]|0):0){c[A>>2]=(c[A>>2]|0)+((c[u>>2]|0)-1);c[B>>2]=(c[B>>2]|0)-((c[u>>2]|0)-1)}else c[B>>2]=c[v>>2];c[p>>2]=ni(c[A>>2]|0,c[B>>2]|0)|0}if(!(c[m>>2]|0)){c[g>>2]=c[p>>2];D=c[g>>2]|0;i=f;return D|0}B=c[n>>2]|0;n=c[p>>2]|0;if((c[w>>2]|0)==(c[x>>2]|0))Xh(B,n)|0;else zi(B,n)|0;c[g>>2]=c[m>>2];D=c[g>>2]|0;i=f;return D|0}c[g>>2]=0;D=c[g>>2]|0;i=f;return D|0}function tw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[f>>2]=a;c[g>>2]=b;c[e+16>>2]=d;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){i=e;return}c[l>>2]=c[(c[g>>2]|0)+4>>2];c[k>>2]=c[c[g>>2]>>2];if((c[l>>2]|0)==0|(c[k>>2]|0)==0){i=e;return}if(((c[(c[f>>2]|0)+48>>2]|0)+-4|0)>>>0<3){i=e;return}c[h>>2]=_c(c[k>>2]|0,c[(c[f>>2]|0)+8>>2]|0,c[(c[f>>2]|0)+48>>2]|0,c[(c[f>>2]|0)+52>>2]|0,c[(c[f>>2]|0)+56>>2]|0,c[(c[f>>2]|0)+40>>2]|0)|0;if(c[h>>2]|0){if(!(c[(c[f>>2]|0)+64>>2]|0)){i=e;return}g=my(c[(c[f>>2]|0)+64>>2]|0)|0;c[(c[h>>2]|0)+64>>2]=g;i=e;return}c[j>>2]=ad(c[k>>2]|0,c[(c[f>>2]|0)+8>>2]|0)|0;if(!(c[j>>2]|0)){i=e;return}do if((c[(c[f>>2]|0)+48>>2]|0)==(c[(c[j>>2]|0)+48>>2]|0)){if((c[(c[f>>2]|0)+56>>2]|0)!=0?(c[(c[j>>2]|0)+56>>2]|0)!=0:0){if(!(qy(c[(c[f>>2]|0)+56>>2]|0,c[(c[j>>2]|0)+56>>2]|0)|0))break;i=e;return}if((c[(c[f>>2]|0)+52>>2]|0)!=0?(c[(c[j>>2]|0)+52>>2]|0)!=0:0){if(!(qy(c[(c[f>>2]|0)+52>>2]|0,c[(c[j>>2]|0)+52>>2]|0)|0))break;i=e;return}if(((c[(c[f>>2]|0)+40>>2]|0)!=0?(c[(c[j>>2]|0)+40>>2]|0)!=0:0)?(qy(c[(c[f>>2]|0)+40>>2]|0,c[(c[j>>2]|0)+40>>2]|0)|0)!=0:0){i=e;return}}while(0);switch(c[(c[f>>2]|0)+48>>2]|0){case 2:case 1:case 6:case 5:case 4:{i=e;return}default:{}}ew(c[l>>2]|0,c[f>>2]|0,1602,133424,c[(c[f>>2]|0)+8>>2]|0);i=e;return}function uw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+4>>2]|0)!=18:0){c[f>>2]=c[(c[f>>2]|0)+12>>2];c[h>>2]=0;while(1){if((c[h>>2]|0)>(c[g>>2]|0)){j=13;break}k=c[f>>2]|0;if(!(c[f>>2]|0)){j=7;break}if(!(((c[k+4>>2]|0)!=1?(c[(c[f>>2]|0)+4>>2]|0)!=9:0)?(c[(c[f>>2]|0)+4>>2]|0)!=13:0))j=11;if((j|0)==11?(j=0,c[h>>2]=(c[h>>2]|0)+1,(c[h>>2]|0)==(c[g>>2]|0)):0){j=13;break}c[f>>2]=c[(c[f>>2]|0)+24>>2]}if((j|0)==7){c[e>>2]=k;l=c[e>>2]|0;i=d;return l|0}else if((j|0)==13){c[e>>2]=c[f>>2];l=c[e>>2]|0;i=d;return l|0}}c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}function vw(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+60>>2]|0)Lw(c[(c[d>>2]|0)+60>>2]|0);if(c[(c[d>>2]|0)+52>>2]|0)Kj(c[(c[d>>2]|0)+52>>2]|0,315);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function ww(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+32|0;d=b;e=b+28|0;f=b+24|0;g=b+20|0;h=b+16|0;j=b+12|0;k=b+8|0;l=b+4|0;c[f>>2]=a;c[j>>2]=0;c[h>>2]=Be()|0;if(!(c[h>>2]|0)){if(c[34014]|0)Db[c[135968+88>>2]&511](0,133880,d);c[e>>2]=0;m=c[e>>2]|0;i=b;return m|0}c[l>>2]=Ck(c[f>>2]|0,0)|0;d=c[h>>2]|0;if(!(c[l>>2]|0)){Ae(d);c[e>>2]=0;m=c[e>>2]|0;i=b;return m|0}c[k>>2]=ue(d)|0;if(!(c[k>>2]|0)){Ae(c[h>>2]|0);c[e>>2]=0;m=c[e>>2]|0;i=b;return m|0}d=Jl(c[f>>2]|0)|0;c[(c[k>>2]|0)+4>>2]=d;c[c[k>>2]>>2]=c[l>>2];iz(c[(c[l>>2]|0)+16>>2]|0,c[k>>2]|0)|0;Oe(c[h>>2]|0,c[k>>2]|0)|0;if((c[j>>2]|0)==0?(c[(c[h>>2]|0)+180>>2]|0)==0:0)c[j>>2]=Rk(c[f>>2]|0)|0;if((c[j>>2]|0)!=0?(c[(c[h>>2]|0)+180>>2]|0)==0:0)c[(c[h>>2]|0)+180>>2]=c[j>>2];c[(c[h>>2]|0)+100>>2]=0;c[(c[h>>2]|0)+104>>2]=0;c[(c[h>>2]|0)+276>>2]=0;c[(c[h>>2]|0)+268>>2]=0;c[(c[h>>2]|0)+364>>2]=1;Qf(c[h>>2]|0)|0;if(c[(c[h>>2]|0)+12>>2]|0)c[g>>2]=c[(c[h>>2]|0)+8>>2];else{c[g>>2]=0;Th(c[(c[h>>2]|0)+8>>2]|0);c[(c[h>>2]|0)+8>>2]=0}Ae(c[h>>2]|0);c[e>>2]=c[g>>2];m=c[e>>2]|0;i=b;return m|0}function xw(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+32|0;e=b+20|0;f=b+16|0;g=b+12|0;h=b+8|0;j=b+4|0;k=b;c[f>>2]=a;c[g>>2]=Nw(c[f>>2]|0)|0;if(!(c[g>>2]|0)){c[e>>2]=0;l=c[e>>2]|0;i=b;return l|0}c[h>>2]=c[g>>2];while(1){if(((d[c[h>>2]>>0]|0|0)!=0?(d[c[h>>2]>>0]|0|0)!=45:0)?(d[c[h>>2]>>0]|0|0)!=60:0){if((d[c[h>>2]>>0]|0|0)>=65?(d[c[h>>2]>>0]|0|0)<=90:0)m=1;else if((d[c[h>>2]>>0]|0|0)>=97)m=(d[c[h>>2]>>0]|0|0)<=122;else m=0;n=m^1}else n=0;o=c[h>>2]|0;if(!n)break;c[h>>2]=o+1}h=c[33474]|0;do if((d[o>>0]|0|0)!=60){c[j>>2]=Ow(2,h)|0;if(!(c[j>>2]|0)){zb[c[135736>>2]&511](c[g>>2]|0);c[e>>2]=0;l=c[e>>2]|0;i=b;return l|0}c[k>>2]=Pw(c[j>>2]|0,c[g>>2]|0,c[f>>2]|0,0)|0;if((c[k>>2]|0)<0){vw(c[j>>2]|0);zb[c[135736>>2]&511](c[g>>2]|0);c[e>>2]=0;l=c[e>>2]|0;i=b;return l|0}}else{c[j>>2]=Ow(1,h)|0;if(c[j>>2]|0){n=Qw(1,0,0,c[f>>2]|0,c[33474]|0,0)|0;c[(c[j>>2]|0)+60>>2]=n;break}zb[c[135736>>2]&511](c[g>>2]|0);c[e>>2]=0;l=c[e>>2]|0;i=b;return l|0}while(0);zb[c[135736>>2]&511](c[g>>2]|0);c[e>>2]=c[j>>2];l=c[e>>2]|0;i=b;return l|0}function yw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e;g=e+28|0;h=e+24|0;j=e+20|0;k=e+16|0;l=e+12|0;m=e+8|0;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=0;if((c[j>>2]|0)==0&(c[k>>2]|0)==0|(c[h>>2]|0)==0){c[g>>2]=0;n=c[g>>2]|0;i=e;return n|0}do if(c[33468]|0){if((c[j>>2]|0)!=0&(c[k>>2]|0)!=0){d=c[33976]|0;b=c[33980]|0;a=c[k>>2]|0;c[f>>2]=c[j>>2];c[f+4>>2]=a;Db[d&511](b,133904,f);break}b=c[33976]|0;d=c[33980]|0;if(c[j>>2]|0){c[f>>2]=c[j>>2];Db[b&511](d,133936,f);break}else{c[f>>2]=c[k>>2];Db[b&511](d,133960,f);break}}while(0);f=c[h>>2]|0;if((c[c[h>>2]>>2]|0)!=1){c[m>>2]=Uw(f,c[j>>2]|0,c[k>>2]|0)|0;if(c[m>>2]|0)c[l>>2]=my(c[m>>2]|0)|0}else{m=Rw(c[f+60>>2]|0,c[j>>2]|0,c[k>>2]|0)|0;c[l>>2]=m;c[l>>2]=(c[l>>2]|0)==(-1|0)?0:m}c[g>>2]=c[l>>2];n=c[g>>2]|0;i=e;return n|0}function zw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;c[g>>2]=a;c[h>>2]=b;c[j>>2]=0;if((c[h>>2]|0)==0|(c[g>>2]|0)==0){c[f>>2]=0;l=c[f>>2]|0;i=d;return l|0}if(c[33468]|0){b=c[33976]|0;a=c[33980]|0;c[e>>2]=c[h>>2];Db[b&511](a,133984,e)}e=c[g>>2]|0;if((c[c[g>>2]>>2]|0)!=1){c[k>>2]=Uw(e,0,c[h>>2]|0)|0;if(c[k>>2]|0)c[j>>2]=my(c[k>>2]|0)|0}else{k=Vw(c[e+60>>2]|0,c[h>>2]|0)|0;c[j>>2]=k;c[j>>2]=(c[j>>2]|0)==(-1|0)?0:k}c[f>>2]=c[j>>2];l=c[f>>2]|0;i=d;return l|0}function Aw(){var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+32|0;d=b+20|0;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;j=b;if(c[33500]|0){i=b;return}Ww();vx(c[33502]|0);if(cb(134016)|0)c[33468]=1;if((c[33510]|0)==0?(k=cb(134048)|0,c[d>>2]=k,c[d>>2]=(c[d>>2]|0)==0?134072:k,c[h>>2]=Ow(1,c[33474]|0)|0,(c[h>>2]|0)!=0):0){c[f>>2]=c[d>>2];c[j>>2]=(c[h>>2]|0)+60;while(1){if(!(a[c[f>>2]>>0]|0))break;while(1){do if((a[c[f>>2]>>0]|0)==32)l=1;else{if(9<=(a[c[f>>2]>>0]|0)?(a[c[f>>2]>>0]|0)<=10:0){l=1;break}l=(a[c[f>>2]>>0]|0)==13}while(0);m=c[f>>2]|0;if(!l)break;c[f>>2]=m+1}if(!(a[m>>0]|0))continue;c[g>>2]=c[f>>2];while(1){if(!(a[c[f>>2]>>0]|0))break;do if((a[c[f>>2]>>0]|0)==32)n=1;else{if(9<=(a[c[f>>2]>>0]|0)?(a[c[f>>2]>>0]|0)<=10:0){n=1;break}n=(a[c[f>>2]>>0]|0)==13}while(0);if(!(n^1))break;c[f>>2]=(c[f>>2]|0)+1}c[e>>2]=ly(c[g>>2]|0,(c[f>>2]|0)-(c[g>>2]|0)|0)|0;if(!(c[e>>2]|0))continue;d=Qw(1,0,0,c[e>>2]|0,c[33474]|0,0)|0;c[c[j>>2]>>2]=d;if(c[c[j>>2]>>2]|0)c[j>>2]=c[c[j>>2]>>2];zb[c[135736>>2]&511](c[e>>2]|0)}c[33510]=c[h>>2]}wx(c[33502]|0);i=b;return}function Bw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;if(!(c[33500]|0))Ww();vx(c[33502]|0);if(c[33510]|0){c[f>>2]=Xw(c[33510]|0,c[e>>2]|0)|0;wx(c[33502]|0);c[d>>2]=c[f>>2];h=c[d>>2]|0;i=b;return h|0}c[g>>2]=xw(c[e>>2]|0)|0;if(!(c[g>>2]|0)){wx(c[33502]|0);c[d>>2]=-1;h=c[d>>2]|0;i=b;return h|0}else{c[33510]=c[g>>2];wx(c[33502]|0);c[d>>2]=0;h=c[d>>2]|0;i=b;return h|0}return 0}function Cw(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=b;if(!(c[e>>2]|0)){i=d;return}c[f>>2]=c[e>>2];a:while(1){if(!(a[c[f>>2]>>0]|0))break;while(1){do if((a[c[f>>2]>>0]|0)==32)j=1;else{if(9<=(a[c[f>>2]>>0]|0)?(a[c[f>>2]>>0]|0)<=10:0){j=1;break}j=(a[c[f>>2]>>0]|0)==13}while(0);k=c[f>>2]|0;if(!j)break;c[f>>2]=k+1}if(a[k>>0]|0){c[g>>2]=c[f>>2];while(1){if(!(a[c[f>>2]>>0]|0))break;if((a[c[f>>2]>>0]|0)==58)break;do if((a[c[f>>2]>>0]|0)==32)l=1;else{if(9<=(a[c[f>>2]>>0]|0)?(a[c[f>>2]>>0]|0)<=10:0){l=1;break}l=(a[c[f>>2]>>0]|0)==13}while(0);if(!(l^1))break;c[f>>2]=(c[f>>2]|0)+1}c[h>>2]=ly(c[g>>2]|0,(c[f>>2]|0)-(c[g>>2]|0)|0)|0;if(c[h>>2]|0){Bw(c[h>>2]|0)|0;zb[c[135736>>2]&511](c[h>>2]|0)}}while(1){if((a[c[f>>2]>>0]|0)!=58)continue a;c[f>>2]=(c[f>>2]|0)+1}}i=d;return}function Dw(){var a=0;a=i;i=i+16|0;if(!(c[33500]|0)){i=a;return}vx(c[33502]|0);if(c[33468]|0)Db[c[135904>>2]&511](c[33980]|0,134096,a);if(c[33530]|0)Kj(c[33530]|0,316);c[33530]=0;if(c[33510]|0)vw(c[33510]|0);c[33510]=0;c[33468]=0;c[33500]=0;wx(c[33502]|0);ux(c[33502]|0);i=a;return}function Ew(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;if(!(c[33500]|0))Aw();c[g>>2]=yw(c[33510]|0,c[e>>2]|0,c[f>>2]|0)|0;i=d;return c[g>>2]|0}function Fw(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;if(!(c[33500]|0))Aw();c[e>>2]=zw(c[33510]|0,c[d>>2]|0)|0;i=b;return c[e>>2]|0}function Gw(){return c[33534]|0}function Hw(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;if(!(c[33500]|0))Aw();c[e>>2]=c[d>>2];if(!(c[e>>2]|0)){i=b;return}Lw(c[e>>2]|0);i=b;return}function Iw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;c[g>>2]=a;c[h>>2]=b;if(!(c[33500]|0))Aw();if(!(c[h>>2]|0)){c[f>>2]=c[g>>2];l=c[f>>2]|0;i=d;return l|0}if(c[33468]|0){b=c[33976]|0;a=c[33980]|0;c[e>>2]=c[h>>2];Db[b&511](a,134144,e)}c[k>>2]=Qw(1,0,c[h>>2]|0,0,c[33474]|0,0)|0;h=c[g>>2]|0;if(!(c[k>>2]|0)){c[f>>2]=h;l=c[f>>2]|0;i=d;return l|0}c[j>>2]=h;if(!(c[j>>2]|0)){c[f>>2]=c[k>>2];l=c[f>>2]|0;i=d;return l|0}while(1){if(!(c[c[j>>2]>>2]|0))break;c[j>>2]=c[c[j>>2]>>2]}c[c[j>>2]>>2]=c[k>>2];c[f>>2]=c[g>>2];l=c[f>>2]|0;i=d;return l|0}function Jw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e;g=e+28|0;h=e+24|0;j=e+20|0;k=e+16|0;l=e+12|0;m=e+8|0;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;if(!(c[33500]|0))Aw();if((c[j>>2]|0)==0&(c[k>>2]|0)==0){c[g>>2]=0;n=c[g>>2]|0;i=e;return n|0}do if(c[33468]|0){if((c[j>>2]|0)!=0&(c[k>>2]|0)!=0){d=c[33976]|0;b=c[33980]|0;a=c[k>>2]|0;c[f>>2]=c[j>>2];c[f+4>>2]=a;Db[d&511](b,134176,f);break}b=c[33976]|0;d=c[33980]|0;if(c[j>>2]|0){c[f>>2]=c[j>>2];Db[b&511](d,134216,f);break}else{c[f>>2]=c[k>>2];Db[b&511](d,134248,f);break}}while(0);c[l>>2]=c[h>>2];if(!(c[l>>2]|0)){c[g>>2]=0;n=c[g>>2]|0;i=e;return n|0}c[m>>2]=Rw(c[l>>2]|0,c[j>>2]|0,c[k>>2]|0)|0;if((c[m>>2]|0)!=0&(c[m>>2]|0)!=(-1|0)){c[g>>2]=c[m>>2];n=c[g>>2]|0;i=e;return n|0}else{c[g>>2]=0;n=c[g>>2]|0;i=e;return n|0}return 0}function Kw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;c[g>>2]=a;c[h>>2]=b;if(!(c[33500]|0))Aw();if(!(c[h>>2]|0)){c[f>>2]=0;l=c[f>>2]|0;i=d;return l|0}if(c[33468]|0){b=c[33976]|0;a=c[33980]|0;c[e>>2]=c[h>>2];Db[b&511](a,133984,e)}c[j>>2]=c[g>>2];if(!(c[j>>2]|0)){c[f>>2]=0;l=c[f>>2]|0;i=d;return l|0}c[k>>2]=Vw(c[j>>2]|0,c[h>>2]|0)|0;if((c[k>>2]|0)!=0&(c[k>>2]|0)!=(-1|0)){c[f>>2]=c[k>>2];l=c[f>>2]|0;i=d;return l|0}else{c[f>>2]=0;l=c[f>>2]|0;i=d;return l|0}return 0}function Lw(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;while(1){if(!(c[d>>2]|0))break;c[e>>2]=c[c[d>>2]>>2];Mw(c[d>>2]|0);c[d>>2]=c[e>>2]}i=b;return}function Mw(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=b+4|0;c[e>>2]=a;if(!(c[e>>2]|0)){i=b;return}if((c[(c[e>>2]|0)+32>>2]|0)==1){i=b;return}do if(c[33468]|0){if(c[(c[e>>2]|0)+16>>2]|0){a=c[33976]|0;f=c[33980]|0;c[d>>2]=c[(c[e>>2]|0)+16>>2];Db[a&511](f,135680,d);break}f=c[33976]|0;a=c[33980]|0;if(c[(c[e>>2]|0)+20>>2]|0){c[d>>2]=c[(c[e>>2]|0)+20>>2];Db[f&511](a,135680,d);break}else{Db[f&511](a,135704,d);break}}while(0);if(c[(c[e>>2]|0)+16>>2]|0)zb[c[135736>>2]&511](c[(c[e>>2]|0)+16>>2]|0);if(c[(c[e>>2]|0)+20>>2]|0)zb[c[135736>>2]&511](c[(c[e>>2]|0)+20>>2]|0);if(c[(c[e>>2]|0)+24>>2]|0)zb[c[135736>>2]&511](c[(c[e>>2]|0)+24>>2]|0);zb[c[135736>>2]&511](c[e>>2]|0);i=b;return}function Nw(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+112|0;e=d+100|0;f=d+96|0;g=d+92|0;h=d+88|0;j=d+84|0;k=d+8|0;l=d+4|0;c[f>>2]=b;if(!(c[f>>2]|0)){c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}if(($a(c[f>>2]|0,k|0)|0)<0){c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}b=La(c[f>>2]|0,0,d|0)|0;c[g>>2]=b;if((b|0)<0){c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}c[j>>2]=c[k+36>>2];c[l>>2]=Cb[c[135752>>2]&511]((c[j>>2]|0)+10|0)|0;if(!(c[l>>2]|0)){Zw(135656);Ra(c[g>>2]|0)|0;c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}c[h>>2]=eb(c[g>>2]|0,c[l>>2]|0,c[j>>2]|0)|0;Ra(c[g>>2]|0)|0;if((c[h>>2]|0)<0){zb[c[135736>>2]&511](c[l>>2]|0);c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}else{a[(c[l>>2]|0)+(c[h>>2]|0)>>0]=0;c[e>>2]=c[l>>2];m=c[e>>2]|0;i=d;return m|0}return 0}function Ow(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=Cb[c[135744>>2]&511](64)|0;if(!(c[h>>2]|0)){Zw(135632);c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}b=(c[h>>2]|0)+0|0;a=b+64|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(a|0));c[c[h>>2]>>2]=c[f>>2];c[(c[h>>2]|0)+44>>2]=0;c[(c[h>>2]|0)+48>>2]=10;c[(c[h>>2]|0)+56>>2]=c[g>>2];if((c[c[h>>2]>>2]|0)==2){g=Ij(10)|0;c[(c[h>>2]|0)+52>>2]=g}c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}function Pw(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;g=i;i=i+64|0;h=g+60|0;j=g+56|0;k=g+52|0;l=g+48|0;m=g+44|0;n=g+40|0;o=g+36|0;p=g+32|0;q=g+28|0;r=g+24|0;s=g+20|0;t=g+16|0;u=g+12|0;v=g+8|0;w=g+4|0;x=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=c[k>>2];c[o>>2]=0;if((c[n>>2]|0)==0|(c[l>>2]|0)==0){c[h>>2]=-1;y=c[h>>2]|0;i=g;return y|0}c[o>>2]=my(c[l>>2]|0)|0;a:while(1){if(!(c[n>>2]|0))break;while(1){if(!(d[c[n>>2]>>0]|0))break a;while(1){do if((d[c[n>>2]>>0]|0|0)==32)z=1;else{if(9<=(d[c[n>>2]>>0]|0|0)?(d[c[n>>2]>>0]|0|0)<=10:0){z=1;break}z=(d[c[n>>2]>>0]|0|0)==13}while(0);A=c[n>>2]|0;if(!z)break;c[n>>2]=A+1}if(!(d[A>>0]|0))break a;if((d[c[n>>2]>>0]|0|0)!=45)break;if((d[(c[n>>2]|0)+1>>0]|0|0)!=45)break;c[n>>2]=_w(c[n>>2]|0)|0;if(!((c[n>>2]|0)!=0&(c[n>>2]|0)!=0))break a}c[q>>2]=0;c[r>>2]=0;c[s>>2]=0;c[n>>2]=$w(c[n>>2]|0,r)|0;if(!(c[r>>2]|0))break;do if((d[c[n>>2]>>0]|0|0)!=32){if(9<=(d[c[n>>2]>>0]|0|0)?(d[c[n>>2]>>0]|0|0)<=10:0)break;if((d[c[n>>2]>>0]|0|0)!=13)break a}while(0);b:while(1){do if((d[c[n>>2]>>0]|0|0)!=32){if(9<=(d[c[n>>2]>>0]|0|0)?(d[c[n>>2]>>0]|0|0)<=10:0)break;if((d[c[n>>2]>>0]|0|0)!=13)break b}while(0);c[n>>2]=(c[n>>2]|0)+1}do if(!(qy(c[r>>2]|0,134936)|0)){if(qy(c[r>>2]|0,134944)|0){c[s>>2]=14;break}if(qy(c[r>>2]|0,134952)|0){c[s>>2]=20;break}if(qy(c[r>>2]|0,134968)|0){c[s>>2]=15;break}if(qy(c[r>>2]|0,134976)|0){c[s>>2]=17;break}if(qy(c[r>>2]|0,134984)|0){c[s>>2]=18;break}if(qy(c[r>>2]|0,135e3)|0){c[s>>2]=19;break}if(qy(c[r>>2]|0,135016)|0){c[s>>2]=24;break}if(qy(c[r>>2]|0,135032)|0){c[s>>2]=23;break}if(qy(c[r>>2]|0,135048)|0){c[s>>2]=22;break}if(qy(c[r>>2]|0,135056)|0){c[s>>2]=21;break}if(qy(c[r>>2]|0,135592)|0){zb[c[135736>>2]&511](c[r>>2]|0);c[n>>2]=$w(c[n>>2]|0,r)|0;if(!(c[r>>2]|0))break a;zb[c[135736>>2]&511](c[r>>2]|0);continue a}}else c[s>>2]=13;while(0);zb[c[135736>>2]&511](c[r>>2]|0);c[r>>2]=0;c:do switch(c[s>>2]|0){case 24:case 23:case 22:case 21:{c[n>>2]=ax(c[n>>2]|0,q)|0;break}case 19:case 18:case 17:case 16:{B=54;break}case 20:case 13:case 14:{c[n>>2]=ax(c[n>>2]|0,r)|0;if(c[n>>2]|0){do if((c[s>>2]|0)!=13?(c[t>>2]=bx(c[r>>2]|0)|0,(c[t>>2]|0)!=0):0){
if(c[r>>2]|0)zb[c[135736>>2]&511](c[r>>2]|0);if(d[c[t>>2]>>0]|0){c[r>>2]=c[t>>2];break}else{zb[c[135736>>2]&511](c[t>>2]|0);c[r>>2]=0;break}}while(0);do if((d[c[n>>2]>>0]|0|0)!=32){if(9<=(d[c[n>>2]>>0]|0|0)?(d[c[n>>2]>>0]|0|0)<=10:0)break;if((d[c[n>>2]>>0]|0|0)!=13)break c}while(0);while(1){do if((d[c[n>>2]>>0]|0|0)==32)C=1;else{if(9<=(d[c[n>>2]>>0]|0|0)?(d[c[n>>2]>>0]|0|0)<=10:0){C=1;break}C=(d[c[n>>2]>>0]|0|0)==13}while(0);D=c[n>>2]|0;if(!C)break;c[n>>2]=D+1}c[n>>2]=ax(D,q)|0}break}case 15:{if((d[c[n>>2]>>0]|0|0)==37){c[s>>2]=16;B=54}else B=54;break}default:{}}while(0);d:do if((B|0)==54?(B=0,c[n>>2]=$w(c[n>>2]|0,r)|0,(c[n>>2]|0)!=0):0){do if((d[c[n>>2]>>0]|0|0)!=32){if(9<=(d[c[n>>2]>>0]|0|0)?(d[c[n>>2]>>0]|0|0)<=10:0)break;if((d[c[n>>2]>>0]|0|0)!=13)break d}while(0);while(1){do if((d[c[n>>2]>>0]|0|0)==32)E=1;else{if(9<=(d[c[n>>2]>>0]|0|0)?(d[c[n>>2]>>0]|0|0)<=10:0){E=1;break}E=(d[c[n>>2]>>0]|0|0)==13}while(0);F=c[n>>2]|0;if(!E)break;c[n>>2]=F+1}c[n>>2]=ax(F,q)|0}while(0);if(!(c[n>>2]|0)){B=87;break}do if((c[s>>2]|0)!=21){if((c[s>>2]|0)==14|(c[s>>2]|0)==13){c[u>>2]=Hl(c[q>>2]|0,c[o>>2]|0)|0;if(!(c[u>>2]|0))break;c[v>>2]=Qw(c[s>>2]|0,c[r>>2]|0,c[u>>2]|0,0,0,0)|0;c[p>>2]=Lj(c[(c[j>>2]|0)+52>>2]|0,c[r>>2]|0,c[v>>2]|0)|0;if((c[p>>2]|0)<0)Mw(c[v>>2]|0);zb[c[135736>>2]&511](c[u>>2]|0);break}if((c[s>>2]|0)==22)if(c[m>>2]|0){c[w>>2]=Qw(c[s>>2]|0,c[q>>2]|0,0,0,0,0)|0;c[p>>2]=Lj(c[(c[j>>2]|0)+52>>2]|0,c[q>>2]|0,c[w>>2]|0)|0;if((c[p>>2]|0)>=0)break;Mw(c[w>>2]|0);break}else{c[x>>2]=Hl(c[q>>2]|0,c[o>>2]|0)|0;if(!(c[x>>2]|0))break;Xw(c[j>>2]|0,c[x>>2]|0)|0;zb[c[135736>>2]&511](c[x>>2]|0);break}}else{if(c[o>>2]|0)zb[c[135736>>2]&511](c[o>>2]|0);c[o>>2]=my(c[q>>2]|0)|0}while(0);if(c[r>>2]|0)zb[c[135736>>2]&511](c[r>>2]|0);if(!(c[q>>2]|0))continue;zb[c[135736>>2]&511](c[q>>2]|0)}if((B|0)==87){if(c[r>>2]|0)zb[c[135736>>2]&511](c[r>>2]|0);if(c[q>>2]|0)zb[c[135736>>2]&511](c[q>>2]|0)}if(c[o>>2]|0)zb[c[135736>>2]&511](c[o>>2]|0);if(!(c[n>>2]|0)){c[h>>2]=-1;y=c[h>>2]|0;i=g;return y|0}else{c[h>>2]=0;y=c[h>>2]|0;i=g;return y|0}return 0}function Qw(a,b,e,f,g,h){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;j=i;i=i+48|0;k=j+32|0;l=j+28|0;m=j+24|0;n=j+20|0;o=j+16|0;p=j+12|0;q=j+8|0;r=j+4|0;s=j;c[l>>2]=a;c[m>>2]=b;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=h;c[s>>2]=0;c[r>>2]=Cb[c[135744>>2]&511](44)|0;if(!(c[r>>2]|0)){Zw(135528);c[k>>2]=0;t=c[k>>2]|0;i=j;return t|0}c[c[r>>2]>>2]=0;c[(c[r>>2]|0)+4>>2]=0;c[(c[r>>2]|0)+8>>2]=0;c[(c[r>>2]|0)+12>>2]=c[l>>2];if((c[l>>2]|0)==5|(c[l>>2]|0)==8?(c[s>>2]=bx(c[m>>2]|0)|0,(c[s>>2]|0)!=0):0)c[m>>2]=(d[c[s>>2]>>0]|0|0)!=0?c[s>>2]|0:0;if(c[m>>2]|0){l=my(c[m>>2]|0)|0;c[(c[r>>2]|0)+16>>2]=l}else c[(c[r>>2]|0)+16>>2]=0;if(c[s>>2]|0)zb[c[135736>>2]&511](c[s>>2]|0);if(c[n>>2]|0){s=my(c[n>>2]|0)|0;c[(c[r>>2]|0)+20>>2]=s}else c[(c[r>>2]|0)+20>>2]=0;if(!(c[o>>2]|0))c[o>>2]=c[n>>2];if(c[o>>2]|0){n=my(c[o>>2]|0)|0;c[(c[r>>2]|0)+24>>2]=n}else c[(c[r>>2]|0)+24>>2]=0;c[(c[r>>2]|0)+28>>2]=c[p>>2];c[(c[r>>2]|0)+32>>2]=0;c[(c[r>>2]|0)+36>>2]=0;c[(c[r>>2]|0)+40>>2]=c[q>>2];c[k>>2]=c[r>>2];t=c[k>>2]|0;i=j;return t|0}function Rw(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+32|0;g=f;h=f+28|0;j=f+24|0;k=f+20|0;l=f+16|0;m=f+12|0;n=f+8|0;o=f+4|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=e;c[m>>2]=0;c[n>>2]=0;if(!(c[j>>2]|0)){c[h>>2]=0;p=c[h>>2]|0;i=f;return p|0}if((c[k>>2]|0)==0&(c[l>>2]|0)==0){c[h>>2]=0;p=c[h>>2]|0;i=f;return p|0}c[o>>2]=bx(c[k>>2]|0)|0;if(c[o>>2]|0)c[k>>2]=(d[c[o>>2]>>0]|0|0)!=0?c[o>>2]|0:0;if(!(sy(c[k>>2]|0,135064,13)|0)){c[n>>2]=cx(c[k>>2]|0)|0;do if(c[33468]|0){e=c[33976]|0;b=c[33980]|0;if(!(c[n>>2]|0)){c[g>>2]=c[k>>2];Db[e&511](b,135256,g);break}else{c[g>>2]=c[n>>2];Db[e&511](b,135296,g);break}}while(0);c[m>>2]=Rw(c[j>>2]|0,c[n>>2]|0,c[l>>2]|0)|0;if(c[n>>2]|0)zb[c[135736>>2]&511](c[n>>2]|0);if(c[o>>2]|0)zb[c[135736>>2]&511](c[o>>2]|0);c[h>>2]=c[m>>2];p=c[h>>2]|0;i=f;return p|0}if(sy(c[l>>2]|0,135064,13)|0){while(1){if(!(c[j>>2]|0))break;if((c[(c[j>>2]|0)+12>>2]|0)==1){if(!(c[(c[j>>2]|0)+8>>2]|0))dx(c[j>>2]|0)|0;if(c[(c[j>>2]|0)+8>>2]|0){c[m>>2]=ex(c[(c[j>>2]|0)+8>>2]|0,c[k>>2]|0,c[l>>2]|0)|0;if(c[m>>2]|0)break;if((c[(c[j>>2]|0)+8>>2]|0)!=0?(c[(c[(c[j>>2]|0)+8>>2]|0)+36>>2]|0)>50:0){q=40;break}}}c[j>>2]=c[c[j>>2]>>2]}if((q|0)==40)c[m>>2]=0;if(c[o>>2]|0)zb[c[135736>>2]&511](c[o>>2]|0);c[h>>2]=c[m>>2];p=c[h>>2]|0;i=f;return p|0}c[n>>2]=cx(c[l>>2]|0)|0;do if(c[33468]|0){q=c[33976]|0;b=c[33980]|0;if(!(c[n>>2]|0)){c[g>>2]=c[l>>2];Db[q&511](b,135328,g);break}else{c[g>>2]=c[n>>2];Db[q&511](b,135368,g);break}}while(0);do if(c[k>>2]|0){g=(qy(c[k>>2]|0,c[n>>2]|0)|0)!=0;l=c[j>>2]|0;b=c[k>>2]|0;if(g){c[m>>2]=Rw(l,b,0)|0;break}else{c[m>>2]=Rw(l,b,c[n>>2]|0)|0;break}}else c[m>>2]=Rw(c[j>>2]|0,c[n>>2]|0,0)|0;while(0);if(c[n>>2]|0)zb[c[135736>>2]&511](c[n>>2]|0);if(c[o>>2]|0)zb[c[135736>>2]&511](c[o>>2]|0);c[h>>2]=c[m>>2];p=c[h>>2]|0;i=f;return p|0}function Sw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;do if(c[f>>2]|0){c[h>>2]=Rj(c[f>>2]|0,c[g>>2]|0)|0;if(!(c[h>>2]|0)){c[e>>2]=0;break}if((c[(c[h>>2]|0)+12>>2]|0)==13){c[e>>2]=c[(c[h>>2]|0)+24>>2];break}else{c[e>>2]=0;break}}else c[e>>2]=0;while(0);i=d;return c[e>>2]|0}function Tw(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;if(!(c[g>>2]|0)){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}c[k>>2]=bx(c[h>>2]|0)|0;if(c[k>>2]|0)c[h>>2]=(d[c[k>>2]>>0]|0|0)!=0?c[k>>2]|0:0;c[j>>2]=Rj(c[g>>2]|0,c[h>>2]|0)|0;if(!(c[j>>2]|0)){if(c[k>>2]|0)zb[c[135736>>2]&511](c[k>>2]|0);c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}h=(c[k>>2]|0)!=0;if((c[(c[j>>2]|0)+12>>2]|0)==14){if(h)zb[c[135736>>2]&511](c[k>>2]|0);c[f>>2]=c[(c[j>>2]|0)+24>>2];l=c[f>>2]|0;i=e;return l|0}else{if(h)zb[c[135736>>2]&511](c[k>>2]|0);c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}return 0}function Uw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=0;if(!(c[(c[g>>2]|0)+52>>2]|0)){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}if(c[h>>2]|0)c[k>>2]=Tw(c[(c[g>>2]|0)+52>>2]|0,c[h>>2]|0)|0;if(c[k>>2]|0){c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}if(c[j>>2]|0)c[k>>2]=Sw(c[(c[g>>2]|0)+52>>2]|0,c[j>>2]|0)|0;if(c[k>>2]|0){c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}else{c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}return 0}function Vw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;c[g>>2]=a;c[h>>2]=b;c[j>>2]=0;c[k>>2]=0;if(!(c[g>>2]|0)){c[f>>2]=0;l=c[f>>2]|0;i=d;return l|0}if(!(c[h>>2]|0)){c[f>>2]=0;l=c[f>>2]|0;i=d;return l|0}if(!(sy(c[h>>2]|0,135064,13)|0)){c[k>>2]=cx(c[h>>2]|0)|0;do if(c[33468]|0){b=c[33976]|0;a=c[33980]|0;if(!(c[k>>2]|0)){c[e>>2]=c[h>>2];Db[b&511](a,135080,e);break}else{c[e>>2]=c[k>>2];Db[b&511](a,135112,e);break}}while(0);c[j>>2]=Rw(c[g>>2]|0,c[k>>2]|0,0)|0;if(c[k>>2]|0)zb[c[135736>>2]&511](c[k>>2]|0);c[f>>2]=c[j>>2];l=c[f>>2]|0;i=d;return l|0}while(1){if(!(c[g>>2]|0)){m=21;break}if((c[(c[g>>2]|0)+12>>2]|0)==1){if(!(c[(c[g>>2]|0)+8>>2]|0))dx(c[g>>2]|0)|0;if((c[(c[g>>2]|0)+8>>2]|0)!=0?(c[j>>2]=fx(c[(c[g>>2]|0)+8>>2]|0,c[h>>2]|0)|0,(c[j>>2]|0)!=0):0){m=19;break}}c[g>>2]=c[c[g>>2]>>2]}if((m|0)==19){c[f>>2]=c[j>>2];l=c[f>>2]|0;i=d;return l|0}else if((m|0)==21){c[f>>2]=c[j>>2];l=c[f>>2]|0;i=d;return l|0}return 0}function Ww(){var a=0;a=i;if(c[33500]|0){i=a;return}if(cb(134016)|0)c[33468]=1;c[33502]=tx()|0;c[33500]=1;i=a;return}function Xw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){c[e>>2]=-1;m=c[e>>2]|0;i=d;return m|0}b=c[g>>2]|0;do if((c[c[f>>2]>>2]|0)==2){c[j>>2]=Nw(b)|0;if(!(c[j>>2]|0)){c[e>>2]=-1;m=c[e>>2]|0;i=d;return m|0}c[h>>2]=Pw(c[f>>2]|0,c[j>>2]|0,c[g>>2]|0,0)|0;a=(c[h>>2]|0)<0;zb[c[135736>>2]&511](c[j>>2]|0);if(a){c[e>>2]=-1;m=c[e>>2]|0;i=d;return m|0}}else{c[k>>2]=Qw(1,0,0,b,c[33474]|0,0)|0;c[l>>2]=c[(c[f>>2]|0)+60>>2];if(!(c[l>>2]|0)){c[(c[f>>2]|0)+60>>2]=c[k>>2];break}while(1){if(!(c[c[l>>2]>>2]|0))break;c[l>>2]=c[c[l>>2]>>2]}c[c[l>>2]>>2]=c[k>>2]}while(0);c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}function Yw(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}c[e>>2]=c[(c[d>>2]|0)+8>>2];while(1){if(!(c[e>>2]|0))break;c[f>>2]=c[c[e>>2]>>2];c[(c[e>>2]|0)+32>>2]=0;c[(c[e>>2]|0)+8>>2]=0;Mw(c[e>>2]|0);c[e>>2]=c[f>>2]}c[(c[d>>2]|0)+32>>2]=0;Mw(c[d>>2]|0);i=b;return}function Zw(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;e=b+4|0;c[e>>2]=a;a=c[e>>2]|0;c[d>>2]=c[e>>2];Xd(0,0,0,0,0,20,2,2,0,0,a,0,0,0,0,135560,d);i=b;return}function _w(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;e=b+4|0;f=b;c[f>>2]=a;if((d[c[f>>2]>>0]|0|0)==45?(d[(c[f>>2]|0)+1>>0]|0|0)==45:0){c[f>>2]=(c[f>>2]|0)+2;while(1){if(d[c[f>>2]>>0]|0)if((d[c[f>>2]>>0]|0|0)!=45)g=1;else g=(d[(c[f>>2]|0)+1>>0]|0|0)!=45;else g=0;h=c[f>>2]|0;if(!g)break;c[f>>2]=h+1}if(!(d[h>>0]|0)){c[e>>2]=0;j=c[e>>2]|0;i=b;return j|0}else{c[e>>2]=(c[f>>2]|0)+2;j=c[e>>2]|0;i=b;return j|0}}c[e>>2]=c[f>>2];j=c[e>>2]|0;i=b;return j|0}function $w(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+128|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+20|0;l=f+4|0;m=f;c[h>>2]=b;c[j>>2]=e;c[l>>2]=0;c[c[j>>2]>>2]=0;c[m>>2]=d[c[h>>2]>>0];e=c[m>>2]|0;if((c[m>>2]|0)<256){if(((!(65<=(e|0)&(c[m>>2]|0)<=90)?!(97<=(c[m>>2]|0)&(c[m>>2]|0)<=122):0)?!(192<=(c[m>>2]|0)&(c[m>>2]|0)<=214):0)?!(216<=(c[m>>2]|0)&(c[m>>2]|0)<=246|248<=(c[m>>2]|0)):0)n=7}else if(!(DQ(e,199744)|0))n=7;do if((n|0)==7){e=c[m>>2]|0;if((c[m>>2]|0)<256){if(!((e|0)!=95&(c[m>>2]|0)!=58))break}else{if(19968<=(e|0)&(c[m>>2]|0)<=40869|(c[m>>2]|0)==12295)break;if(!((12321<=(c[m>>2]|0)&(c[m>>2]|0)<=12329^1)&(c[m>>2]|0)!=95&(c[m>>2]|0)!=58))break}c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}while(0);a:while(1){e=c[m>>2]|0;if((c[m>>2]|0)<256){if(((!(65<=(e|0)&(c[m>>2]|0)<=90)?!(97<=(c[m>>2]|0)&(c[m>>2]|0)<=122):0)?!(192<=(c[m>>2]|0)&(c[m>>2]|0)<=214):0)?!(216<=(c[m>>2]|0)&(c[m>>2]|0)<=246|248<=(c[m>>2]|0)):0)n=18}else if(!(DQ(e,199744)|0))n=18;do if((n|0)==18){n=0;if((c[m>>2]|0)>=256){if(19968<=(c[m>>2]|0)&(c[m>>2]|0)<=40869|(c[m>>2]|0)==12295)break;if(12321<=(c[m>>2]|0)&(c[m>>2]|0)<=12329)break}e=c[m>>2]|0;if((c[m>>2]|0)<256)if(48<=(e|0)&(c[m>>2]|0)<=57|(c[m>>2]|0)==46|(c[m>>2]|0)==45|(c[m>>2]|0)==95|(c[m>>2]|0)==58)break;else{n=26;break a}else{b=(DQ(e,200216)|0)!=0;if(b|(c[m>>2]|0)==46|(c[m>>2]|0)==45|(c[m>>2]|0)==95|(c[m>>2]|0)==58)break;else{n=26;break a}}}while(0);b=c[m>>2]&255;e=c[l>>2]|0;c[l>>2]=e+1;a[k+e>>0]=b;c[h>>2]=(c[h>>2]|0)+1;c[m>>2]=d[c[h>>2]>>0];if((c[l>>2]|0)>=100){n=25;break}}if((n|0)==25){c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}else if((n|0)==26){n=ly(k,c[l>>2]|0)|0;c[c[j>>2]>>2]=n;c[g>>2]=c[h>>2];o=c[g>>2]|0;i=f;return o|0}return 0}function ax(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+48|0;g=f+28|0;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f+4|0;o=f+32|0;p=f;c[h>>2]=b;c[j>>2]=e;c[k>>2]=0;c[m>>2]=0;c[n>>2]=50;c[p>>2]=0;c[c[j>>2]>>2]=0;e=c[h>>2]|0;do if((d[c[h>>2]>>0]|0|0)!=34)if((d[e>>0]|0|0)==39){c[h>>2]=(c[h>>2]|0)+1;a[o>>0]=39;break}else{a[o>>0]=32;break}else{c[h>>2]=e+1;a[o>>0]=34}while(0);c[k>>2]=Cb[c[135752>>2]&511](c[n>>2]|0)|0;if(!(c[k>>2]|0)){Zw(135608);c[g>>2]=0;q=c[g>>2]|0;i=f;return q|0}while(1){if((d[198696+(d[c[h>>2]>>0]|0)>>0]|0|0)==0?(d[c[h>>2]>>0]|0|0)!=63:0)break;if((d[c[h>>2]>>0]|0|0)==(d[o>>0]|0|0)?(d[o>>0]|0|0)!=32:0)break;if((d[o>>0]|0|0)==32){if((d[c[h>>2]>>0]|0|0)==32)break;if(9<=(d[c[h>>2]>>0]|0|0)?(d[c[h>>2]>>0]|0|0)<=10:0)break;if((d[c[h>>2]>>0]|0|0)==13)break}if(((c[m>>2]|0)+1|0)>=(c[n>>2]|0)){c[n>>2]=c[n>>2]<<1;c[l>>2]=Hb[c[135760>>2]&511](c[k>>2]|0,c[n>>2]|0)|0;if(!(c[l>>2]|0)){r=19;break}c[k>>2]=c[l>>2]}e=a[c[h>>2]>>0]|0;b=c[m>>2]|0;c[m>>2]=b+1;a[(c[k>>2]|0)+b>>0]=e;c[p>>2]=(c[p>>2]|0)+1;c[h>>2]=(c[h>>2]|0)+1}if((r|0)==19){Zw(135608);zb[c[135736>>2]&511](c[k>>2]|0);c[g>>2]=0;q=c[g>>2]|0;i=f;return q|0}a[(c[k>>2]|0)+(c[m>>2]|0)>>0]=0;m=d[c[h>>2]>>0]|0;do if((d[o>>0]|0|0)==32){if((m|0)!=32){if(9<=(d[c[h>>2]>>0]|0|0)?(d[c[h>>2]>>0]|0|0)<=10:0)break;if((d[c[h>>2]>>0]|0|0)!=13){zb[c[135736>>2]&511](c[k>>2]|0);c[g>>2]=0;q=c[g>>2]|0;i=f;return q|0}}}else{if((m|0)==(d[o>>0]|0|0)){c[h>>2]=(c[h>>2]|0)+1;break}zb[c[135736>>2]&511](c[k>>2]|0);c[g>>2]=0;q=c[g>>2]|0;i=f;return q|0}while(0);c[c[j>>2]>>2]=c[k>>2];c[g>>2]=c[h>>2];q=c[g>>2]|0;i=f;return q|0}function bx(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[g>>2]=b;c[h>>2]=1;if(!(c[g>>2]|0)){c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}c[j>>2]=1;c[k>>2]=c[g>>2];while(1){if(!((c[h>>2]|0)!=0?(d[c[k>>2]>>0]|0|0)!=0:0))break;do if((d[c[k>>2]>>0]|0|0)!=32){if(9<=(d[c[k>>2]>>0]|0|0)?(d[c[k>>2]>>0]|0|0)<=10:0){o=10;break}if((d[c[k>>2]>>0]|0|0)!=13)c[j>>2]=0;else o=10}else o=10;while(0);do if((o|0)==10){o=0;if((c[j>>2]|0)!=0?1:(d[c[k>>2]>>0]|0|0)!=32){c[h>>2]=0;break}else{c[j>>2]=1;break}}while(0);c[k>>2]=(c[k>>2]|0)+1}if(!((c[h>>2]|0)==0|(c[j>>2]|0)!=0)){c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}c[l>>2]=my(c[g>>2]|0)|0;c[m>>2]=c[l>>2];c[j>>2]=0;c[k>>2]=c[g>>2];while(1){if(!(d[c[k>>2]>>0]|0))break;do if((d[c[k>>2]>>0]|0|0)!=32){if(9<=(d[c[k>>2]>>0]|0|0)?(d[c[k>>2]>>0]|0|0)<=10:0){o=22;break}if((d[c[k>>2]>>0]|0|0)!=13){if(c[j>>2]|0){g=c[m>>2]|0;c[m>>2]=g+1;a[g>>0]=32;c[j>>2]=0}g=a[c[k>>2]>>0]|0;h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=g}else o=22}else o=22;while(0);if((o|0)==22?(o=0,(c[m>>2]|0)!=(c[l>>2]|0)):0)c[j>>2]=1;c[k>>2]=(c[k>>2]|0)+1}a[c[m>>2]>>0]=0;c[f>>2]=c[l>>2];n=c[f>>2]|0;i=e;return n|0}function cx(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+2016|0;f=e+8|0;g=e+4|0;h=e+16|0;j=e;c[g>>2]=b;c[j>>2]=0;if(sy(c[g>>2]|0,135064,13)|0){c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}c[g>>2]=(c[g>>2]|0)+13;a:while(1){if((c[j>>2]|0)>>>0>1996?1:(d[c[g>>2]>>0]|0|0)==0)break;if((d[c[g>>2]>>0]|0|0)==43){b=c[j>>2]|0;c[j>>2]=b+1;a[h+b>>0]=32;c[g>>2]=(c[g>>2]|0)+1;continue}if((d[c[g>>2]>>0]|0|0)==58){b=c[j>>2]|0;c[j>>2]=b+1;a[h+b>>0]=47;b=c[j>>2]|0;c[j>>2]=b+1;a[h+b>>0]=47;c[g>>2]=(c[g>>2]|0)+1;continue}if((d[c[g>>2]>>0]|0|0)==59){b=c[j>>2]|0;c[j>>2]=b+1;a[h+b>>0]=58;b=c[j>>2]|0;c[j>>2]=b+1;a[h+b>>0]=58;c[g>>2]=(c[g>>2]|0)+1;continue}b=c[g>>2]|0;if((d[c[g>>2]>>0]|0|0)!=37){l=a[b>>0]|0;m=c[j>>2]|0;c[j>>2]=m+1;a[h+m>>0]=l;c[g>>2]=(c[g>>2]|0)+1;continue}if((d[b+1>>0]|0|0)==50?(d[(c[g>>2]|0)+2>>0]|0|0)==66:0){b=c[j>>2]|0;c[j>>2]=b+1;a[h+b>>0]=43}else n=15;do if((n|0)==15){n=0;if((d[(c[g>>2]|0)+1>>0]|0|0)==51?(d[(c[g>>2]|0)+2>>0]|0|0)==65:0){b=c[j>>2]|0;c[j>>2]=b+1;a[h+b>>0]=58;break}if((d[(c[g>>2]|0)+1>>0]|0|0)==50?(d[(c[g>>2]|0)+2>>0]|0|0)==70:0){b=c[j>>2]|0;c[j>>2]=b+1;a[h+b>>0]=47;break}if((d[(c[g>>2]|0)+1>>0]|0|0)==51?(d[(c[g>>2]|0)+2>>0]|0|0)==66:0){b=c[j>>2]|0;c[j>>2]=b+1;a[h+b>>0]=59;break}if((d[(c[g>>2]|0)+1>>0]|0|0)==50?(d[(c[g>>2]|0)+2>>0]|0|0)==55:0){b=c[j>>2]|0;c[j>>2]=b+1;a[h+b>>0]=39;break}if((d[(c[g>>2]|0)+1>>0]|0|0)==51?(d[(c[g>>2]|0)+2>>0]|0|0)==70:0){b=c[j>>2]|0;c[j>>2]=b+1;a[h+b>>0]=63;break}if((d[(c[g>>2]|0)+1>>0]|0|0)==50?(d[(c[g>>2]|0)+2>>0]|0|0)==51:0){b=c[j>>2]|0;c[j>>2]=b+1;a[h+b>>0]=35;break}if((d[(c[g>>2]|0)+1>>0]|0|0)==50?(d[(c[g>>2]|0)+2>>0]|0|0)==53:0){b=c[j>>2]|0;c[j>>2]=b+1;a[h+b>>0]=37;break}b=a[c[g>>2]>>0]|0;l=c[j>>2]|0;c[j>>2]=l+1;a[h+l>>0]=b;c[g>>2]=(c[g>>2]|0)+1;continue a}while(0);c[g>>2]=(c[g>>2]|0)+3}a[h+(c[j>>2]|0)>>0]=0;c[f>>2]=my(h)|0;k=c[f>>2]|0;i=e;return k|0}function dx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b;e=b+12|0;f=b+8|0;g=b+4|0;c[f>>2]=a;if(!(c[f>>2]|0)){c[e>>2]=-1;h=c[e>>2]|0;i=b;return h|0}if(!(c[(c[f>>2]|0)+24>>2]|0)){c[e>>2]=-1;h=c[e>>2]|0;i=b;return h|0}vx(c[33502]|0);if(c[(c[f>>2]|0)+8>>2]|0){wx(c[33502]|0);c[e>>2]=0;h=c[e>>2]|0;i=b;return h|0}do if(c[33530]|0){c[g>>2]=Rj(c[33530]|0,c[(c[f>>2]|0)+24>>2]|0)|0;a=(c[33468]|0)!=0;if(!(c[g>>2]|0)){if(!a)break;j=c[33976]|0;k=c[33980]|0;c[d>>2]=c[(c[f>>2]|0)+24>>2];Db[j&511](k,134304,d);break}if(a){a=c[33976]|0;k=c[33980]|0;c[d>>2]=c[(c[f>>2]|0)+24>>2];Db[a&511](k,134280,d)}k=c[g>>2]|0;if((c[(c[f>>2]|0)+12>>2]|0)==1)c[(c[f>>2]|0)+8>>2]=c[k+8>>2];else c[(c[f>>2]|0)+8>>2]=k;c[(c[f>>2]|0)+32>>2]=0;wx(c[33502]|0);c[e>>2]=0;h=c[e>>2]|0;i=b;return h|0}while(0);c[g>>2]=gx(c[(c[f>>2]|0)+28>>2]|0,c[(c[f>>2]|0)+24>>2]|0)|0;k=(c[f>>2]|0)+12|0;if(!(c[g>>2]|0)){c[k>>2]=2;wx(c[33502]|0);c[e>>2]=-1;h=c[e>>2]|0;i=b;return h|0}a=c[g>>2]|0;if((c[k>>2]|0)==1)c[(c[f>>2]|0)+8>>2]=c[a+8>>2];else c[(c[f>>2]|0)+8>>2]=a;c[(c[g>>2]|0)+32>>2]=1;if(!(c[33530]|0))c[33530]=Ij(10)|0;if(c[33530]|0){if(c[33468]|0){a=c[33976]|0;k=c[33980]|0;c[d>>2]=c[(c[f>>2]|0)+24>>2];Db[a&511](k,134336,d)}Lj(c[33530]|0,c[(c[f>>2]|0)+24>>2]|0,c[g>>2]|0)|0}wx(c[33502]|0);c[e>>2]=0;h=c[e>>2]|0;i=b;return h|0}function ex(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+480|0;f=e;g=e+464|0;h=e+460|0;j=e+456|0;k=e+452|0;l=e+448|0;m=e+444|0;n=e+440|0;o=e+436|0;p=e+432|0;q=e+428|0;r=e+424|0;s=e+224|0;t=e+220|0;u=e+216|0;v=e+16|0;w=e+12|0;x=e+8|0;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=0;c[n>>2]=0;c[o>>2]=0;d=c[h>>2]|0;if((c[(c[h>>2]|0)+36>>2]|0)>50){hx(d,0,1654,135136,c[(c[h>>2]|0)+16>>2]|0,0,0);c[g>>2]=0;y=c[g>>2]|0;i=e;return y|0}b=d+36|0;c[b>>2]=(c[b>>2]|0)+1;if(c[k>>2]|0){c[p>>2]=0;c[q>>2]=0;c[m>>2]=c[h>>2];c[n>>2]=0;while(1){if(!(c[m>>2]|0))break;b=c[(c[m>>2]|0)+12>>2]|0;if((b|0)==7){c[r>>2]=xy(c[(c[m>>2]|0)+16>>2]|0)|0;if((c[r>>2]|0)>(c[q>>2]|0)?(sy(c[k>>2]|0,c[(c[m>>2]|0)+16>>2]|0,c[r>>2]|0)|0)==0:0){c[q>>2]=c[r>>2];c[p>>2]=c[m>>2]}}else if((b|0)==3)c[o>>2]=(c[o>>2]|0)+1;else if((b|0)==6){if(qy(c[k>>2]|0,c[(c[m>>2]|0)+16>>2]|0)|0){z=8;break}}else if((b|0)==9?(b=c[k>>2]|0,d=c[(c[m>>2]|0)+16>>2]|0,(sy(b,d,xy(c[(c[m>>2]|0)+16>>2]|0)|0)|0)==0):0)c[n>>2]=(c[n>>2]|0)+1;c[m>>2]=c[c[m>>2]>>2]}if((z|0)==8){if(c[33468]|0){r=c[33976]|0;d=c[33980]|0;b=c[(c[m>>2]|0)+24>>2]|0;c[f>>2]=c[(c[m>>2]|0)+16>>2];c[f+4>>2]=b;Db[r&511](d,135400,f)}d=(c[h>>2]|0)+36|0;c[d>>2]=(c[d>>2]|0)+-1;c[g>>2]=my(c[(c[m>>2]|0)+24>>2]|0)|0;y=c[g>>2]|0;i=e;return y|0}if(c[p>>2]|0){if(c[33468]|0){d=c[33976]|0;r=c[33980]|0;c[f>>2]=c[(c[p>>2]|0)+16>>2];Db[d&511](r,135200,f)}c[l>>2]=my(c[(c[p>>2]|0)+24>>2]|0)|0;if(c[l>>2]|0)c[l>>2]=By(c[l>>2]|0,(c[k>>2]|0)+(c[q>>2]|0)|0)|0;q=(c[h>>2]|0)+36|0;c[q>>2]=(c[q>>2]|0)+-1;c[g>>2]=c[l>>2];y=c[g>>2]|0;i=e;return y|0}if(c[n>>2]|0){c[t>>2]=0;c[m>>2]=c[h>>2];while(1){if(!(c[m>>2]|0)){z=45;break}if((c[(c[m>>2]|0)+12>>2]|0)==9?(q=c[k>>2]|0,p=c[(c[m>>2]|0)+16>>2]|0,(sy(q,p,xy(c[(c[m>>2]|0)+16>>2]|0)|0)|0)==0):0){c[u>>2]=0;while(1){if((c[u>>2]|0)>=(c[t>>2]|0))break;if(qy(c[(c[m>>2]|0)+24>>2]|0,c[s+(c[u>>2]<<2)>>2]|0)|0)break;c[u>>2]=(c[u>>2]|0)+1}if((c[u>>2]|0)<(c[t>>2]|0)){c[m>>2]=c[c[m>>2]>>2];continue}if((c[t>>2]|0)<50){p=c[(c[m>>2]|0)+24>>2]|0;q=c[t>>2]|0;c[t>>2]=q+1;c[s+(q<<2)>>2]=p}if(!(c[(c[m>>2]|0)+8>>2]|0))dx(c[m>>2]|0)|0;if(c[(c[m>>2]|0)+8>>2]|0){if(c[33468]|0){p=c[33976]|0;q=c[33980]|0;c[f>>2]=c[(c[m>>2]|0)+24>>2];Db[p&511](q,135440,f)}c[l>>2]=Rw(c[(c[m>>2]|0)+8>>2]|0,0,c[k>>2]|0)|0;if(c[l>>2]|0){z=43;break}}}c[m>>2]=c[c[m>>2]>>2]}if((z|0)==43){s=(c[h>>2]|0)+36|0;c[s>>2]=(c[s>>2]|0)+-1;c[g>>2]=c[l>>2];y=c[g>>2]|0;i=e;return y|0}else if((z|0)==45){s=(c[h>>2]|0)+36|0;c[s>>2]=(c[s>>2]|0)+-1;c[g>>2]=-1;y=c[g>>2]|0;i=e;return y|0}}}if(c[j>>2]|0){c[m>>2]=c[h>>2];c[n>>2]=0;while(1){if(!(c[m>>2]|0))break;s=c[(c[m>>2]|0)+12>>2]|0;if((s|0)==8){t=c[j>>2]|0;u=c[(c[m>>2]|0)+16>>2]|0;if((sy(t,u,xy(c[(c[m>>2]|0)+16>>2]|0)|0)|0)==0?(c[(c[m>>2]|0)+28>>2]|0)==1:0)c[n>>2]=(c[n>>2]|0)+1}else if((s|0)==3){if(!(c[k>>2]|0))c[o>>2]=(c[o>>2]|0)+1}else if((s|0)==5?(qy(c[j>>2]|0,c[(c[m>>2]|0)+16>>2]|0)|0)!=0:0){z=51;break}c[m>>2]=c[c[m>>2]>>2]}if((z|0)==51){if(c[33468]|0){s=c[33976]|0;u=c[33980]|0;c[f>>2]=c[(c[m>>2]|0)+16>>2];Db[s&511](u,135472,f)}u=(c[h>>2]|0)+36|0;c[u>>2]=(c[u>>2]|0)+-1;c[g>>2]=my(c[(c[m>>2]|0)+24>>2]|0)|0;y=c[g>>2]|0;i=e;return y|0}if(c[n>>2]|0){c[w>>2]=0;c[m>>2]=c[h>>2];while(1){if(!(c[m>>2]|0)){z=82;break}if(((c[(c[m>>2]|0)+12>>2]|0)==8?(c[(c[m>>2]|0)+28>>2]|0)==1:0)?(n=c[j>>2]|0,u=c[(c[m>>2]|0)+16>>2]|0,(sy(n,u,xy(c[(c[m>>2]|0)+16>>2]|0)|0)|0)==0):0){c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[w>>2]|0))break;if(qy(c[(c[m>>2]|0)+24>>2]|0,c[v+(c[x>>2]<<2)>>2]|0)|0)break;c[x>>2]=(c[x>>2]|0)+1}if((c[x>>2]|0)<(c[w>>2]|0)){c[m>>2]=c[c[m>>2]>>2];continue}if((c[w>>2]|0)<50){u=c[(c[m>>2]|0)+24>>2]|0;n=c[w>>2]|0;c[w>>2]=n+1;c[v+(n<<2)>>2]=u}if(!(c[(c[m>>2]|0)+8>>2]|0))dx(c[m>>2]|0)|0;if(c[(c[m>>2]|0)+8>>2]|0){if(c[33468]|0){u=c[33976]|0;n=c[33980]|0;c[f>>2]=c[(c[m>>2]|0)+24>>2];Db[u&511](n,135496,f)}c[l>>2]=Rw(c[(c[m>>2]|0)+8>>2]|0,c[j>>2]|0,0)|0;if(c[l>>2]|0){z=80;break}}}c[m>>2]=c[c[m>>2]>>2]}if((z|0)==80){f=(c[h>>2]|0)+36|0;c[f>>2]=(c[f>>2]|0)+-1;c[g>>2]=c[l>>2];y=c[g>>2]|0;i=e;return y|0}else if((z|0)==82){f=(c[h>>2]|0)+36|0;c[f>>2]=(c[f>>2]|0)+-1;c[g>>2]=-1;y=c[g>>2]|0;i=e;return y|0}}}a:do if(c[o>>2]|0){c[m>>2]=c[h>>2];while(1){if(!(c[m>>2]|0))break a;if((c[(c[m>>2]|0)+12>>2]|0)==3){if(!(c[(c[m>>2]|0)+8>>2]|0))dx(c[m>>2]|0)|0;if(c[(c[m>>2]|0)+8>>2]|0){c[l>>2]=Rw(c[(c[m>>2]|0)+8>>2]|0,c[j>>2]|0,c[k>>2]|0)|0;A=(c[h>>2]|0)+36|0;B=c[A>>2]|0;if(c[l>>2]|0){z=91;break}if((B|0)>50){z=93;break}}}c[m>>2]=c[c[m>>2]>>2]}if((z|0)==91){c[A>>2]=B+-1;c[g>>2]=c[l>>2];y=c[g>>2]|0;i=e;return y|0}else if((z|0)==93){c[g>>2]=0;y=c[g>>2]|0;i=e;return y|0}}while(0);z=(c[h>>2]|0)+36|0;c[z>>2]=(c[z>>2]|0)+-1;c[g>>2]=0;y=c[g>>2]|0;i=e;return y|0}function fx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+256|0;e=d;f=d+252|0;g=d+248|0;h=d+244|0;j=d+240|0;k=d+236|0;l=d+232|0;m=d+228|0;n=d+224|0;o=d+220|0;p=d+216|0;q=d+16|0;r=d+8|0;s=d+4|0;c[g>>2]=a;c[h>>2]=b;c[j>>2]=0;c[l>>2]=0;c[m>>2]=0;c[n>>2]=0;c[o>>2]=0;if(!(c[g>>2]|0)){c[f>>2]=0;t=c[f>>2]|0;i=d;return t|0}if(!(c[h>>2]|0)){c[f>>2]=0;t=c[f>>2]|0;i=d;return t|0}b=c[g>>2]|0;if((c[(c[g>>2]|0)+36>>2]|0)>50){hx(b,0,1654,135136,c[(c[g>>2]|0)+16>>2]|0,0,0);c[f>>2]=0;t=c[f>>2]|0;i=d;return t|0}c[k>>2]=b;c[l>>2]=0;while(1){if(!(c[k>>2]|0))break;b=c[(c[k>>2]|0)+12>>2]|0;if((b|0)==10){if(qy(c[h>>2]|0,c[(c[k>>2]|0)+16>>2]|0)|0){u=11;break}}else if((b|0)==12){a=c[h>>2]|0;v=c[(c[k>>2]|0)+16>>2]|0;if(!(sy(a,v,xy(c[(c[k>>2]|0)+16>>2]|0)|0)|0))c[l>>2]=(c[l>>2]|0)+1}else if((b|0)==11){c[p>>2]=xy(c[(c[k>>2]|0)+16>>2]|0)|0;if((c[p>>2]|0)>(c[o>>2]|0)?(sy(c[h>>2]|0,c[(c[k>>2]|0)+16>>2]|0,c[p>>2]|0)|0)==0:0){c[o>>2]=c[p>>2];c[n>>2]=c[k>>2]}}else if((b|0)==3)c[m>>2]=(c[m>>2]|0)+1;c[k>>2]=c[c[k>>2]>>2]}if((u|0)==11){if(c[33468]|0){p=c[33976]|0;b=c[33980]|0;c[e>>2]=c[(c[k>>2]|0)+16>>2];Db[p&511](b,135176,e)}c[f>>2]=my(c[(c[k>>2]|0)+24>>2]|0)|0;t=c[f>>2]|0;i=d;return t|0}if(c[n>>2]|0){if(c[33468]|0){b=c[33976]|0;p=c[33980]|0;c[e>>2]=c[(c[n>>2]|0)+16>>2];Db[b&511](p,135200,e)}c[j>>2]=my(c[(c[n>>2]|0)+24>>2]|0)|0;if(c[j>>2]|0)c[j>>2]=By(c[j>>2]|0,(c[h>>2]|0)+(c[o>>2]|0)|0)|0;c[f>>2]=c[j>>2];t=c[f>>2]|0;i=d;return t|0}if(!(c[l>>2]|0)){a:do if(c[m>>2]|0){c[k>>2]=c[g>>2];while(1){if(!(c[k>>2]|0))break a;if((c[(c[k>>2]|0)+12>>2]|0)==3){if(!(c[(c[k>>2]|0)+8>>2]|0))dx(c[k>>2]|0)|0;if((c[(c[k>>2]|0)+8>>2]|0)!=0?(c[j>>2]=Vw(c[(c[k>>2]|0)+8>>2]|0,c[h>>2]|0)|0,(c[j>>2]|0)!=0):0)break}c[k>>2]=c[c[k>>2]>>2]}c[f>>2]=c[j>>2];t=c[f>>2]|0;i=d;return t|0}while(0);c[f>>2]=0;t=c[f>>2]|0;i=d;return t|0}c[r>>2]=0;c[k>>2]=c[g>>2];while(1){if(!(c[k>>2]|0)){u=49;break}if(!((c[(c[k>>2]|0)+12>>2]|0)!=9?(c[(c[k>>2]|0)+12>>2]|0)!=12:0))u=32;if((u|0)==32?(u=0,g=c[h>>2]|0,m=c[(c[k>>2]|0)+16>>2]|0,(sy(g,m,xy(c[(c[k>>2]|0)+16>>2]|0)|0)|0)==0):0){c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[r>>2]|0))break;if(qy(c[(c[k>>2]|0)+24>>2]|0,c[q+(c[s>>2]<<2)>>2]|0)|0)break;c[s>>2]=(c[s>>2]|0)+1}if((c[s>>2]|0)<(c[r>>2]|0)){c[k>>2]=c[c[k>>2]>>2];continue}if((c[r>>2]|0)<50){m=c[(c[k>>2]|0)+24>>2]|0;g=c[r>>2]|0;c[r>>2]=g+1;c[q+(g<<2)>>2]=m}if(!(c[(c[k>>2]|0)+8>>2]|0))dx(c[k>>2]|0)|0;if(c[(c[k>>2]|0)+8>>2]|0){if(c[33468]|0){m=c[33976]|0;g=c[33980]|0;c[e>>2]=c[(c[k>>2]|0)+24>>2];Db[m&511](g,135232,e)}c[j>>2]=Vw(c[(c[k>>2]|0)+8>>2]|0,c[h>>2]|0)|0;if(c[j>>2]|0){u=47;break}}}c[k>>2]=c[c[k>>2]>>2]}if((u|0)==47){c[f>>2]=c[j>>2];t=c[f>>2]|0;i=d;return t|0}else if((u|0)==49){c[f>>2]=-1;t=c[f>>2]|0;i=d;return t|0}return 0}function gx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+48|0;e=d;f=d+32|0;g=d+28|0;h=d+24|0;j=d+20|0;k=d+16|0;l=d+12|0;m=d+8|0;c[g>>2]=a;c[h>>2]=b;c[m>>2]=0;if(!(c[h>>2]|0)){c[f>>2]=0;n=c[f>>2]|0;i=d;return n|0}c[j>>2]=ww(c[h>>2]|0)|0;b=(c[33468]|0)!=0;if(!(c[j>>2]|0)){if(b){a=c[33976]|0;o=c[33980]|0;c[e>>2]=c[h>>2];Db[a&511](o,134360,e)}c[f>>2]=0;n=c[f>>2]|0;i=d;return n|0}if(b){b=c[33976]|0;o=c[33980]|0;a=yx()|0;p=c[h>>2]|0;c[e>>2]=a;c[e+4>>2]=p;Db[b&511](o,134392,e)}c[k>>2]=Pi(c[j>>2]|0)|0;if(((((c[k>>2]|0)!=0?(qy(c[(c[k>>2]|0)+8>>2]|0,134128)|0)!=0:0)?(c[(c[k>>2]|0)+36>>2]|0)!=0:0)?(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0)!=0:0)?(qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,134416)|0)!=0:0){c[m>>2]=Qw(1,0,c[h>>2]|0,0,c[g>>2]|0,0)|0;if(!(c[m>>2]|0)){Th(c[j>>2]|0);c[f>>2]=0;n=c[f>>2]|0;i=d;return n|0}c[l>>2]=Yi(c[k>>2]|0,134464)|0;if(c[l>>2]|0){do if(!(qy(c[l>>2]|0,134472)|0))if(qy(c[l>>2]|0,134480)|0){c[g>>2]=1;break}else{hx(0,c[k>>2]|0,1652,134488,c[l>>2]|0,0,0);break}else c[g>>2]=2;while(0);zb[c[135736>>2]&511](c[l>>2]|0)}c[k>>2]=c[(c[k>>2]|0)+12>>2];ix(c[k>>2]|0,c[g>>2]|0,c[m>>2]|0,0);Th(c[j>>2]|0);c[f>>2]=c[m>>2];n=c[f>>2]|0;i=d;return n|0}hx(0,c[j>>2]|0,1653,134520,c[h>>2]|0,0,0);Th(c[j>>2]|0);c[f>>2]=0;n=c[f>>2]|0;i=d;return n|0}function hx(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+48|0;k=j;l=j+36|0;m=j+32|0;n=j+28|0;o=j+24|0;p=j+20|0;q=j+16|0;r=j+12|0;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;c[r>>2]=h;h=c[l>>2]|0;l=c[m>>2]|0;m=c[n>>2]|0;n=c[p>>2]|0;g=c[q>>2]|0;f=c[r>>2]|0;e=c[o>>2]|0;o=c[q>>2]|0;q=c[r>>2]|0;c[k>>2]=c[p>>2];c[k+4>>2]=o;c[k+8>>2]=q;Xd(0,0,0,h,l,20,m,2,0,0,n,g,f,0,0,e,k);i=j;return}function ix(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;while(1){if(!(c[g>>2]|0))break;if(((c[(c[g>>2]|0)+36>>2]|0)!=0?(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0)!=0:0)?(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,134416)|0)!=0:0)jx(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0);c[g>>2]=c[(c[g>>2]|0)+24>>2]}i=f;return}function jx(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+48|0;g=f+32|0;h=f+28|0;j=f+24|0;k=f+20|0;l=f+16|0;m=f+12|0;n=f+8|0;o=f+4|0;p=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=0;c[m>>2]=0;if(!(c[g>>2]|0)){i=f;return}do if(!(qy(c[(c[g>>2]|0)+8>>2]|0,134552)|0)){e=(qy(c[(c[g>>2]|0)+8>>2]|0,134480)|0)!=0;d=c[g>>2]|0;if(e){c[m>>2]=kx(d,5,134480,134616,134632,c[h>>2]|0,c[k>>2]|0)|0;break}e=(qy(c[d+8>>2]|0,134472)|0)!=0;d=c[g>>2]|0;if(e){c[m>>2]=kx(d,6,134472,134640,134632,c[h>>2]|0,c[k>>2]|0)|0;break}e=(qy(c[d+8>>2]|0,134656)|0)!=0;d=c[g>>2]|0;if(e){c[m>>2]=kx(d,7,134656,134672,134696,c[h>>2]|0,c[k>>2]|0)|0;break}e=(qy(c[d+8>>2]|0,134712)|0)!=0;d=c[g>>2]|0;if(e){c[m>>2]=kx(d,8,134712,134728,134128,c[h>>2]|0,c[k>>2]|0)|0;break}e=(qy(c[d+8>>2]|0,134752)|0)!=0;d=c[g>>2]|0;if(e){c[m>>2]=kx(d,9,134752,134672,134128,c[h>>2]|0,c[k>>2]|0)|0;break}e=(qy(c[d+8>>2]|0,134632)|0)!=0;d=c[g>>2]|0;if(e){c[m>>2]=kx(d,10,134632,134768,134632,c[h>>2]|0,c[k>>2]|0)|0;break}e=(qy(c[d+8>>2]|0,134776)|0)!=0;d=c[g>>2]|0;if(e){c[m>>2]=kx(d,11,134776,134792,134696,c[h>>2]|0,c[k>>2]|0)|0;break}e=(qy(c[d+8>>2]|0,134808)|0)!=0;d=c[g>>2]|0;if(e){c[m>>2]=kx(d,12,134808,134792,134128,c[h>>2]|0,c[k>>2]|0)|0;break}if(qy(c[d+8>>2]|0,134824)|0)c[m>>2]=kx(c[g>>2]|0,3,134824,0,134128,c[h>>2]|0,c[k>>2]|0)|0}else{c[o>>2]=0;c[n>>2]=Yi(c[g>>2]|0,134464)|0;if(c[n>>2]|0){do if(!(qy(c[n>>2]|0,134472)|0))if(qy(c[n>>2]|0,134480)|0){c[h>>2]=1;break}else{hx(c[j>>2]|0,c[g>>2]|0,1652,134488,c[n>>2]|0,0,0);break}else c[h>>2]=2;while(0);zb[c[135736>>2]&511](c[n>>2]|0);c[o>>2]=c[h>>2]}c[n>>2]=Yi(c[g>>2]|0,134560)|0;c[l>>2]=Ui(c[g>>2]|0,134568,134576)|0;c[m>>2]=Qw(4,c[n>>2]|0,c[l>>2]|0,0,c[o>>2]|0,c[k>>2]|0)|0;zb[c[135736>>2]&511](c[n>>2]|0)}while(0);if(c[m>>2]|0){do if(c[j>>2]|0){c[(c[m>>2]|0)+4>>2]=c[j>>2];if(!(c[(c[j>>2]|0)+8>>2]|0)){c[(c[j>>2]|0)+8>>2]=c[m>>2];break}c[p>>2]=c[(c[j>>2]|0)+8>>2];while(1){if(!(c[c[p>>2]>>2]|0))break;c[p>>2]=c[c[p>>2]>>2]}c[c[p>>2]>>2]=c[m>>2]}while(0);if((c[(c[m>>2]|0)+12>>2]|0)==4)ix(c[(c[g>>2]|0)+12>>2]|0,c[h>>2]|0,c[j>>2]|0,c[m>>2]|0)}if(!(c[l>>2]|0)){i=f;return}zb[c[135736>>2]&511](c[l>>2]|0);i=f;return}function kx(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;j=i;i=i+80|0;k=j;l=j+64|0;m=j+60|0;n=j+56|0;o=j+52|0;p=j+48|0;q=j+44|0;r=j+40|0;s=j+36|0;t=j+32|0;u=j+28|0;v=j+24|0;w=j+20|0;x=j+16|0;y=j+12|0;c[m>>2]=a;c[n>>2]=b;c[o>>2]=d;c[p>>2]=e;c[q>>2]=f;c[r>>2]=g;c[s>>2]=h;c[t>>2]=1;c[v>>2]=0;c[w>>2]=0;c[x>>2]=0;c[y>>2]=0;if((c[p>>2]|0)!=0?(c[v>>2]=Yi(c[m>>2]|0,c[p>>2]|0)|0,(c[v>>2]|0)==0):0){hx(c[y>>2]|0,c[m>>2]|0,1650,134840,c[o>>2]|0,c[p>>2]|0,0);c[t>>2]=0}c[u>>2]=Yi(c[m>>2]|0,c[q>>2]|0)|0;if(!(c[u>>2]|0)){hx(c[y>>2]|0,c[m>>2]|0,1650,134840,c[o>>2]|0,c[q>>2]|0,0);c[t>>2]=0}if(!(c[t>>2]|0)){if(c[v>>2]|0)zb[c[135736>>2]&511](c[v>>2]|0);if(c[u>>2]|0)zb[c[135736>>2]&511](c[u>>2]|0);c[l>>2]=0;z=c[l>>2]|0;i=j;return z|0}c[w>>2]=Xi(c[(c[m>>2]|0)+32>>2]|0,c[m>>2]|0)|0;c[x>>2]=Hl(c[u>>2]|0,c[w>>2]|0)|0;if(c[x>>2]|0){do if((c[33468]|0)>1){t=c[33976]|0;p=c[33980]|0;h=c[o>>2]|0;if(c[v>>2]|0){g=c[v>>2]|0;f=c[x>>2]|0;c[k>>2]=h;c[k+4>>2]=g;c[k+8>>2]=f;Db[t&511](p,134864,k);break}else{f=c[x>>2]|0;c[k>>2]=h;c[k+4>>2]=f;Db[t&511](p,134888,k);break}}while(0);c[y>>2]=Qw(c[n>>2]|0,c[v>>2]|0,c[u>>2]|0,c[x>>2]|0,c[r>>2]|0,c[s>>2]|0)|0}else hx(c[y>>2]|0,c[m>>2]|0,1651,134904,c[o>>2]|0,c[q>>2]|0,c[u>>2]|0);if(c[v>>2]|0)zb[c[135736>>2]&511](c[v>>2]|0);if(c[u>>2]|0)zb[c[135736>>2]&511](c[u>>2]|0);if(c[w>>2]|0)zb[c[135736>>2]&511](c[w>>2]|0);if(c[x>>2]|0)zb[c[135736>>2]&511](c[x>>2]|0);c[l>>2]=c[y>>2];z=c[l>>2]|0;i=j;return z|0}function lx(){var a=0;a=i;if(c[33932]|0){i=a;return}c[33932]=px()|0;i=a;return}function mx(){var a=0;a=i;if(c[33932]|0){qx(c[33932]|0);c[33932]=0}xx();i=a;return}function nx(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[33968];c[18774]=1;c[33968]=c[d>>2];i=b;return c[e>>2]|0}function ox(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[33970];c[18774]=1;c[33970]=c[d>>2];i=b;return c[e>>2]|0}function px(){var a=0,b=0,d=0,e=0;a=i;i=i+16|0;b=a+4|0;d=a;e=iT(4)|0;c[d>>2]=e;if(!e)c[b>>2]=0;else c[b>>2]=c[d>>2];i=a;return c[b>>2]|0}function qx(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}jT(c[d>>2]|0);i=b;return}function rx(a){a=a|0;var b=0;b=i;i=i+16|0;c[b>>2]=a;i=b;return}function sx(a){a=a|0;var b=0;b=i;i=i+16|0;c[b>>2]=a;i=b;return}function tx(){var a=0,b=0,d=0,e=0;a=i;i=i+16|0;b=a+4|0;d=a;e=iT(4)|0;c[d>>2]=e;if(!e)c[b>>2]=0;else c[b>>2]=c[d>>2];i=a;return c[b>>2]|0}function ux(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}jT(c[d>>2]|0);i=b;return}function vx(a){a=a|0;var b=0;b=i;i=i+16|0;c[b>>2]=a;i=b;return}function wx(a){a=a|0;var b=0;b=i;i=i+16|0;c[b>>2]=a;i=b;return}function xx(){return}function yx(){return 0}function zx(){return}function Ax(){return}function Bx(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=i;i=i+48|0;k=j+40|0;l=j+36|0;m=j+32|0;n=j+28|0;o=j+24|0;p=j+20|0;q=j+16|0;r=j+12|0;s=j+8|0;t=j+4|0;u=j;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;c[r>>2]=h;c[t>>2]=0;if((c[r>>2]|0)==0|(c[l>>2]|0)==0){Ex(136264);c[k>>2]=-1;v=c[k>>2]|0;i=j;return v|0}if((c[o>>2]|0)>>>0>=3){Ex(136280);c[k>>2]=-1;v=c[k>>2]|0;i=j;return v|0}c[t>>2]=c[o>>2];o=c[l>>2]|0;if(c[(c[r>>2]|0)+12>>2]|0){Fx(0,o,1951,136312);c[k>>2]=-1;v=c[k>>2]|0;i=j;return v|0}c[s>>2]=Gx(o,c[m>>2]|0,c[n>>2]|0,c[t>>2]|0,c[p>>2]|0,c[q>>2]|0,c[r>>2]|0)|0;q=c[l>>2]|0;if(!(c[s>>2]|0)){Fx(0,q,1950,136392);c[k>>2]=-1;v=c[k>>2]|0;i=j;return v|0}if((c[q+12>>2]|0)!=0?(c[u>>2]=Hx(c[s>>2]|0,c[(c[l>>2]|0)+12>>2]|0)|0,
(c[u>>2]|0)<0):0){Ix(136440);Jx(c[s>>2]|0);c[k>>2]=-1;v=c[k>>2]|0;i=j;return v|0}c[u>>2]=Ak(c[r>>2]|0)|0;if((c[u>>2]|0)<0){Ix(136472);Jx(c[s>>2]|0);c[k>>2]=-1;v=c[k>>2]|0;i=j;return v|0}else{Jx(c[s>>2]|0);c[k>>2]=c[u>>2];v=c[k>>2]|0;i=j;return v|0}return 0}function Cx(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+32|0;j=h+20|0;k=h+16|0;l=h+12|0;m=h+8|0;n=h+4|0;o=h;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;g=Bx(c[j>>2]|0,317,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0)|0;i=h;return g|0}function Dx(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+48|0;j=h+32|0;k=h+28|0;l=h+24|0;m=h+20|0;n=h+16|0;o=h+12|0;p=h+8|0;q=h+4|0;r=h;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;if(!(c[p>>2]|0)){Ex(136496);c[j>>2]=-1;s=c[j>>2]|0;i=h;return s|0}c[c[p>>2]>>2]=0;c[r>>2]=wk(0)|0;if(!(c[r>>2]|0)){Lx(136520);c[j>>2]=-1;s=c[j>>2]|0;i=h;return s|0}c[q>>2]=Cx(c[k>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[r>>2]|0)|0;if((c[q>>2]|0)<0){Ix(136544);zk(c[r>>2]|0)|0;c[j>>2]=-1;s=c[j>>2]|0;i=h;return s|0}c[q>>2]=_y(c[(c[r>>2]|0)+16>>2]|0)|0;if((c[q>>2]|0)>0){o=Vy(c[(c[r>>2]|0)+16>>2]|0)|0;n=ly(o,c[q>>2]|0)|0;c[c[p>>2]>>2]=n}zk(c[r>>2]|0)|0;if((c[q>>2]|0)>0?(c[c[p>>2]>>2]|0)==0:0){Lx(136576);c[j>>2]=-1;s=c[j>>2]|0;i=h;return s|0}else{c[j>>2]=c[q>>2];s=c[j>>2]|0;i=h;return s|0}return 0}function Ex(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;e=b+4|0;c[e>>2]=a;a=c[e>>2]|0;c[d>>2]=c[e>>2];Xd(0,0,0,0,0,21,1,2,0,0,a,0,0,0,0,138632,d);i=b;return}function Fx(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if(c[h>>2]|0)c[(c[h>>2]|0)+40>>2]=c[k>>2];e=c[h>>2]|0;h=c[j>>2]|0;j=c[k>>2]|0;c[g>>2]=c[l>>2];Xd(0,0,0,e,h,21,j,2,0,0,0,0,0,0,0,138624,g);i=f;return}function Gx(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;j=i;i=i+48|0;k=j+32|0;l=j+28|0;m=j+24|0;n=j+20|0;o=j+16|0;p=j+12|0;q=j+8|0;r=j+4|0;s=j;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;c[r>>2]=h;c[s>>2]=0;if((c[l>>2]|0)==0|(c[r>>2]|0)==0){Ex(138360);c[k>>2]=0;t=c[k>>2]|0;i=j;return t|0}if(c[(c[r>>2]|0)+12>>2]|0){Fx(c[s>>2]|0,c[l>>2]|0,1951,138384);c[k>>2]=0;t=c[k>>2]|0;i=j;return t|0}if((c[(c[l>>2]|0)+76>>2]|0)!=1){Fx(c[s>>2]|0,c[l>>2]|0,1951,138464);c[k>>2]=0;t=c[k>>2]|0;i=j;return t|0}c[s>>2]=Cb[c[135744>>2]&511](44)|0;if(!(c[s>>2]|0)){Lx(138512);c[k>>2]=0;t=c[k>>2]|0;i=j;return t|0}h=(c[s>>2]|0)+0|0;g=h+44|0;do{c[h>>2]=0;h=h+4|0}while((h|0)<(g|0));c[c[s>>2]>>2]=c[l>>2];c[(c[s>>2]|0)+12>>2]=c[q>>2];c[(c[s>>2]|0)+4>>2]=c[m>>2];c[(c[s>>2]|0)+8>>2]=c[n>>2];c[(c[s>>2]|0)+16>>2]=c[r>>2];c[(c[s>>2]|0)+24>>2]=1;c[(c[s>>2]|0)+20>>2]=0;r=Mx()|0;c[(c[s>>2]|0)+28>>2]=r;if(!(c[(c[s>>2]|0)+28>>2]|0)){Fx(c[s>>2]|0,c[l>>2]|0,1952,138536);Jx(c[s>>2]|0);c[k>>2]=0;t=c[k>>2]|0;i=j;return t|0}c[(c[s>>2]|0)+32>>2]=c[o>>2];if((c[(c[s>>2]|0)+32>>2]|0)==1)c[(c[s>>2]|0)+36>>2]=c[p>>2];c[k>>2]=c[s>>2];t=c[k>>2]|0;i=j;return t|0}function Hx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if(!(c[f>>2]|0)){Ex(136712);c[e>>2]=-1;j=c[e>>2]|0;i=d;return j|0}c[h>>2]=0;while(1){if(!((c[g>>2]|0)!=0&(c[h>>2]|0)>=0))break;c[h>>2]=Nx(c[f>>2]|0,c[g>>2]|0)|0;c[g>>2]=c[(c[g>>2]|0)+24>>2]}c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}function Ix(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;e=b+4|0;c[e>>2]=a;a=c[e>>2]|0;c[d>>2]=c[e>>2];Xd(0,0,0,0,0,21,1,2,0,0,a,0,0,0,0,136688,d);i=b;return}function Jx(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){Ex(136640);i=b;return}if(c[(c[d>>2]|0)+28>>2]|0)Ox(c[(c[d>>2]|0)+28>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function Kx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+48|0;f=e+36|0;g=e+32|0;h=e+28|0;j=e+24|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(!((c[g>>2]|0)!=0&(c[h>>2]|0)!=0)){c[f>>2]=1;l=c[f>>2]|0;i=e;return l|0}if((c[(c[h>>2]|0)+4>>2]|0)!=18){c[f>>2]=ar(c[g>>2]|0,c[h>>2]|0)|0;l=c[f>>2]|0;i=e;return l|0}d=c[h>>2]|0;c[k+0>>2]=c[d+0>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2];c[k+12>>2]=c[d+12>>2];c[k+16>>2]=c[d+16>>2];c[k+20>>2]=c[d+20>>2];if((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+4>>2]|0)==2:0)c[k>>2]=c[(c[j>>2]|0)+20>>2];else c[k>>2]=c[j>>2];c[f>>2]=ar(c[g>>2]|0,k)|0;l=c[f>>2]|0;i=e;return l|0}function Lx(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;e=b+4|0;c[e>>2]=a;a=c[e>>2]|0;c[d>>2]=c[e>>2];Xd(0,0,0,0,0,21,2,2,0,0,a,0,0,0,0,136608,d);i=b;return}function Mx(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=Cb[c[135744>>2]&511](24)|0;if(!(c[d>>2]|0)){Lx(138592);c[b>>2]=0;e=c[b>>2]|0;i=a;return e|0}else{f=c[d>>2]|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;c[b>>2]=c[d>>2];e=c[b>>2]|0;i=a;return e|0}return 0}function Nx(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;n=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=0;if((c[g>>2]|0)==0|(c[h>>2]|0)==0){Ex(136736);c[f>>2]=-1;o=c[f>>2]|0;i=e;return o|0}if(c[(c[g>>2]|0)+4>>2]|0)p=vb[c[(c[g>>2]|0)+4>>2]&511](c[(c[g>>2]|0)+8>>2]|0,c[h>>2]|0,c[(c[h>>2]|0)+20>>2]|0)|0;else p=1;c[k>>2]=p;a:do switch(c[(c[h>>2]|0)+4>>2]|0){case 8:{if((c[k>>2]|0)!=0?(c[(c[g>>2]|0)+12>>2]|0)!=0:0){p=c[(c[g>>2]|0)+16>>2]|0;if((c[(c[g>>2]|0)+20>>2]|0)==2)Qk(p,136840)|0;else Qk(p,136848)|0;do if(c[(c[h>>2]|0)+40>>2]|0){c[n>>2]=Qx(c[(c[h>>2]|0)+40>>2]|0,1)|0;if(c[n>>2]|0){Qk(c[(c[g>>2]|0)+16>>2]|0,c[n>>2]|0)|0;zb[c[135736>>2]&511](c[n>>2]|0);break}Ix(136856);c[f>>2]=-1;o=c[f>>2]|0;i=e;return o|0}while(0);p=c[(c[g>>2]|0)+16>>2]|0;if(!(c[(c[g>>2]|0)+20>>2]|0)){Qk(p,136888)|0;break a}else{Qk(p,136896)|0;break a}}break}case 18:{Rx(136928,136736);c[f>>2]=-1;o=c[f>>2]|0;i=e;return o|0}case 7:{if(c[k>>2]|0){p=c[(c[g>>2]|0)+16>>2]|0;if((c[(c[g>>2]|0)+20>>2]|0)==2)Qk(p,136776)|0;else Qk(p,136784)|0;Qk(c[(c[g>>2]|0)+16>>2]|0,c[(c[h>>2]|0)+8>>2]|0)|0;do if((c[(c[h>>2]|0)+40>>2]|0)!=0?(d[c[(c[h>>2]|0)+40>>2]>>0]|0|0)!=0:0){Qk(c[(c[g>>2]|0)+16>>2]|0,136792)|0;c[m>>2]=Qx(c[(c[h>>2]|0)+40>>2]|0,2)|0;if(c[m>>2]|0){Qk(c[(c[g>>2]|0)+16>>2]|0,c[m>>2]|0)|0;zb[c[135736>>2]&511](c[m>>2]|0);break}Ix(136800);c[f>>2]=-1;o=c[f>>2]|0;i=e;return o|0}while(0);p=c[(c[g>>2]|0)+16>>2]|0;if(!(c[(c[g>>2]|0)+20>>2]|0)){Qk(p,136824)|0;break a}else{Qk(p,136832)|0;break a}}break}case 3:case 4:{if((c[k>>2]|0)!=0?(c[(c[h>>2]|0)+40>>2]|0)!=0:0){c[l>>2]=Qx(c[(c[h>>2]|0)+40>>2]|0,3)|0;if(c[l>>2]|0){Qk(c[(c[g>>2]|0)+16>>2]|0,c[l>>2]|0)|0;zb[c[135736>>2]&511](c[l>>2]|0);break a}Ix(136752);c[f>>2]=-1;o=c[f>>2]|0;i=e;return o|0}break}case 1:{c[j>>2]=Px(c[g>>2]|0,c[h>>2]|0,c[k>>2]|0)|0;break}case 2:{Rx(136904,136736);c[f>>2]=-1;o=c[f>>2]|0;i=e;return o|0}case 13:case 21:case 11:case 9:{if(c[(c[h>>2]|0)+12>>2]|0){c[(c[g>>2]|0)+20>>2]=0;c[(c[g>>2]|0)+24>>2]=1;c[j>>2]=Hx(c[g>>2]|0,c[(c[h>>2]|0)+12>>2]|0)|0}break}case 6:{Rx(136976,136736);c[f>>2]=-1;o=c[f>>2]|0;i=e;return o|0}case 20:case 19:case 17:case 16:case 15:case 14:case 12:case 10:break;case 5:{Rx(136952,136736);c[f>>2]=-1;o=c[f>>2]|0;i=e;return o|0}default:{Sx(c[(c[h>>2]|0)+4>>2]|0,136736);c[f>>2]=-1;o=c[f>>2]|0;i=e;return o|0}}while(0);c[f>>2]=c[j>>2];o=c[f>>2]|0;i=e;return o|0}function Ox(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){Ex(136656);i=b;return}if(c[(c[d>>2]|0)+16>>2]|0){cU(c[(c[d>>2]|0)+16>>2]|0,0,c[(c[d>>2]|0)+12>>2]<<2|0)|0;zb[c[135736>>2]&511](c[(c[d>>2]|0)+16>>2]|0)}if(c[(c[d>>2]|0)+20>>2]|0){cU(c[(c[d>>2]|0)+20>>2]|0,0,c[(c[d>>2]|0)+12>>2]<<2|0)|0;zb[c[135736>>2]&511](c[(c[d>>2]|0)+20>>2]|0)}a=c[d>>2]|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function Px(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+64|0;f=e+48|0;g=e+44|0;h=e+40|0;j=e+36|0;k=e+32|0;l=e+8|0;m=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[m>>2]=0;if(!((c[g>>2]|0)==0|(c[h>>2]|0)==0)?(c[(c[h>>2]|0)+4>>2]|0)==1:0){if((Tx(c[g>>2]|0,c[h>>2]|0)|0)<0){Ix(137128);c[f>>2]=-1;n=c[f>>2]|0;i=e;return n|0}c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;Ux(c[(c[g>>2]|0)+28>>2]|0,l);if(c[j>>2]|0){if(c[(c[g>>2]|0)+24>>2]|0){c[m>>2]=c[(c[g>>2]|0)+24>>2];c[(c[g>>2]|0)+24>>2]=0;c[(c[g>>2]|0)+20>>2]=1}Qk(c[(c[g>>2]|0)+16>>2]|0,137168)|0;if((c[(c[h>>2]|0)+36>>2]|0)!=0?(xy(c[(c[(c[h>>2]|0)+36>>2]|0)+12>>2]|0)|0)>0:0){Qk(c[(c[g>>2]|0)+16>>2]|0,c[(c[(c[h>>2]|0)+36>>2]|0)+12>>2]|0)|0;Qk(c[(c[g>>2]|0)+16>>2]|0,137176)|0}Qk(c[(c[g>>2]|0)+16>>2]|0,c[(c[h>>2]|0)+8>>2]|0)|0}d=c[g>>2]|0;b=c[h>>2]|0;a=c[j>>2]|0;if((c[(c[g>>2]|0)+32>>2]|0)==1)c[k>>2]=Wx(d,b,a)|0;else c[k>>2]=Vx(d,b,a)|0;if((c[k>>2]|0)<0){Ix(137184);c[f>>2]=-1;n=c[f>>2]|0;i=e;return n|0}if(c[j>>2]|0)Xx(c[(c[g>>2]|0)+28>>2]|0);c[k>>2]=Yx(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;if((c[k>>2]|0)<0){Ix(137216);c[f>>2]=-1;n=c[f>>2]|0;i=e;return n|0}if(c[j>>2]|0)Qk(c[(c[g>>2]|0)+16>>2]|0,137248)|0;if((c[(c[h>>2]|0)+12>>2]|0)!=0?(c[k>>2]=Hx(c[g>>2]|0,c[(c[h>>2]|0)+12>>2]|0)|0,(c[k>>2]|0)<0):0){Ix(137256);c[f>>2]=-1;n=c[f>>2]|0;i=e;return n|0}if(c[j>>2]|0){Qk(c[(c[g>>2]|0)+16>>2]|0,137288)|0;if((c[(c[h>>2]|0)+36>>2]|0)!=0?(xy(c[(c[(c[h>>2]|0)+36>>2]|0)+12>>2]|0)|0)>0:0){Qk(c[(c[g>>2]|0)+16>>2]|0,c[(c[(c[h>>2]|0)+36>>2]|0)+12>>2]|0)|0;Qk(c[(c[g>>2]|0)+16>>2]|0,137176)|0}Qk(c[(c[g>>2]|0)+16>>2]|0,c[(c[h>>2]|0)+8>>2]|0)|0;Qk(c[(c[g>>2]|0)+16>>2]|0,137248)|0;if(c[m>>2]|0){c[(c[g>>2]|0)+24>>2]=c[m>>2];c[(c[g>>2]|0)+20>>2]=2}}Zx(c[(c[g>>2]|0)+28>>2]|0,l);c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}Ex(137104);c[f>>2]=-1;n=c[f>>2]|0;i=e;return n|0}function Qx(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+32|0;g=f+28|0;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f+4|0;o=f;c[h>>2]=b;c[j>>2]=e;c[k>>2]=c[h>>2];c[l>>2]=0;c[m>>2]=0;c[n>>2]=0;if(!(c[h>>2]|0)){c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}c[n>>2]=1e3;c[l>>2]=Cb[c[135752>>2]&511](c[n>>2]|0)|0;if(!(c[l>>2]|0)){Lx(137064);c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}c[m>>2]=c[l>>2];while(1){q=c[m>>2]|0;if(!(d[c[k>>2]>>0]|0)){r=30;break}if((q-(c[l>>2]|0)|0)>((c[n>>2]|0)-10|0)){c[o>>2]=(c[m>>2]|0)-(c[l>>2]|0);c[n>>2]=c[n>>2]<<1;c[l>>2]=Hb[c[135760>>2]&511](c[l>>2]|0,c[n>>2]|0)|0;if(!(c[l>>2]|0)){r=9;break}c[m>>2]=(c[l>>2]|0)+(c[o>>2]|0)}if((d[c[k>>2]>>0]|0|0)==60?(c[j>>2]|0)==0|(c[j>>2]|0)==3:0){h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=38;h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=108;h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=116;h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=59}else r=14;do if((r|0)==14){r=0;if((c[j>>2]|0)==3?(d[c[k>>2]>>0]|0|0)==62:0){h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=38;h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=103;h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=116;h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=59;break}if((d[c[k>>2]>>0]|0|0)==38?(c[j>>2]|0)==0|(c[j>>2]|0)==3:0){h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=38;h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=97;h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=109;h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=112;h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=59;break}if((c[j>>2]|0)==0?(d[c[k>>2]>>0]|0|0)==34:0){h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=38;h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=113;h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=117;h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=111;h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=116;h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=59;break}if((c[j>>2]|0)==0?(d[c[k>>2]>>0]|0|0)==9:0){h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=38;h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=35;h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=120;h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=57;h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=59;break}if((c[j>>2]|0)==0?(d[c[k>>2]>>0]|0|0)==10:0){h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=38;h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=35;h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=120;h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=65;h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=59;break}if((d[c[k>>2]>>0]|0|0)==13?(c[j>>2]|0)==0|(c[j>>2]|0)==3|(c[j>>2]|0)==1|(c[j>>2]|0)==2:0){h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=38;h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=35;h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=120;h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=68;h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=59;break}h=a[c[k>>2]>>0]|0;e=c[m>>2]|0;c[m>>2]=e+1;a[e>>0]=h}while(0);c[k>>2]=(c[k>>2]|0)+1}if((r|0)==9){Lx(137088);c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}else if((r|0)==30){a[q>>0]=0;c[g>>2]=c[l>>2];p=c[g>>2]|0;i=f;return p|0}return 0}function Rx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+12|0;g=d+8|0;c[f>>2]=a;c[g>>2]=b;b=c[g>>2]|0;a=c[g>>2]|0;c[e>>2]=c[f>>2];c[e+4>>2]=a;Xd(0,0,0,0,0,21,1953,2,0,0,b,0,0,0,0,137032,e);i=d;return}function Sx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+12|0;g=d+8|0;c[f>>2]=a;c[g>>2]=b;b=c[g>>2]|0;a=c[g>>2]|0;c[e>>2]=c[f>>2];c[e+4>>2]=a;Xd(0,0,0,0,0,21,1954,2,0,0,b,0,0,0,0,136992,e);i=d;return}function Tx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[f>>2]=a;c[g>>2]=b;if(!((c[f>>2]|0)==0|(c[g>>2]|0)==0)?(c[(c[g>>2]|0)+4>>2]|0)==1:0){c[h>>2]=c[(c[g>>2]|0)+48>>2];while(1){if(!(c[h>>2]|0)){k=17;break}if((xy(c[(c[h>>2]|0)+8>>2]|0)|0)>0){c[j>>2]=yl(c[(c[h>>2]|0)+8>>2]|0)|0;if(!(c[j>>2]|0)){k=8;break}g=(xy(c[c[j>>2]>>2]|0)|0)==0;l=c[c[j>>2]>>2]|0;if(g){k=10;break}if(((ty(l,138296)|0)!=0?(ty(c[c[j>>2]>>2]|0,138304)|0)!=0:0)?(xy(c[(c[j>>2]|0)+12>>2]|0)|0)==0:0){k=14;break}Al(c[j>>2]|0)}c[h>>2]=c[c[h>>2]>>2]}if((k|0)==8){Ix(138272);c[e>>2]=-1;m=c[e>>2]|0;i=d;return m|0}else if((k|0)==10){_x(l);Al(c[j>>2]|0);c[e>>2]=-1;m=c[e>>2]|0;i=d;return m|0}else if((k|0)==14){_x(c[c[j>>2]>>2]|0);Al(c[j>>2]|0);c[e>>2]=-1;m=c[e>>2]|0;i=d;return m|0}else if((k|0)==17){c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}}Ex(137128);c[e>>2]=-1;m=c[e>>2]|0;i=d;return m|0}function Ux(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if((c[e>>2]|0)==0|(c[f>>2]|0)==0){Ex(138248);i=d;return}else{c[c[f>>2]>>2]=c[c[e>>2]>>2];c[(c[f>>2]|0)+4>>2]=c[(c[e>>2]|0)+4>>2];c[(c[f>>2]|0)+8>>2]=c[(c[e>>2]|0)+8>>2];i=d;return}}function Vx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+48|0;f=e+36|0;g=e+32|0;h=e+28|0;j=e+24|0;k=e+20|0;l=e+16|0;m=e+12|0;n=e+8|0;o=e+4|0;p=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[p>>2]=0;if(!((c[g>>2]|0)==0|(c[h>>2]|0)==0)?(c[(c[h>>2]|0)+4>>2]|0)==1:0){c[n>>2]=IS(0,318)|0;if(!(c[n>>2]|0)){Ix(138192);c[f>>2]=-1;q=c[f>>2]|0;i=e;return q|0}c[k>>2]=c[h>>2];while(1){if(!(c[k>>2]|0))break;c[l>>2]=c[(c[k>>2]|0)+48>>2];while(1){if(!(c[l>>2]|0))break;c[m>>2]=cj(c[(c[h>>2]|0)+32>>2]|0,c[h>>2]|0,c[(c[l>>2]|0)+12>>2]|0)|0;do if((c[m>>2]|0)==(c[l>>2]|0)?(ay(c[l>>2]|0)|0)==0:0){if((c[(c[g>>2]|0)+4>>2]|0)!=0?(vb[c[(c[g>>2]|0)+4>>2]&511](c[(c[g>>2]|0)+8>>2]|0,c[l>>2]|0,c[h>>2]|0)|0)==0:0)break;c[o>>2]=by(c[(c[g>>2]|0)+28>>2]|0,c[l>>2]|0)|0;if(c[j>>2]|0)cy(c[(c[g>>2]|0)+28>>2]|0,c[l>>2]|0,c[h>>2]|0);if(!(c[o>>2]|0))KS(c[n>>2]|0,c[l>>2]|0)|0;if(!(xy(c[(c[l>>2]|0)+12>>2]|0)|0))c[p>>2]=1}while(0);c[l>>2]=c[c[l>>2]>>2]}c[k>>2]=c[(c[k>>2]|0)+20>>2]}if(!((c[j>>2]|0)==0|(c[p>>2]|0)!=0)?(c[34556]=0,c[34557]=0,c[34558]=0,c[34559]=0,c[34560]=0,c[34561]=0,(by(c[(c[g>>2]|0)+28>>2]|0,138224)|0)==0):0)dy(138224,c[g>>2]|0)|0;PS(c[n>>2]|0,319,c[g>>2]|0);MS(c[n>>2]|0);c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}Ex(138152);c[f>>2]=-1;q=c[f>>2]|0;i=e;return q|0}function Wx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+64|0;f=e+48|0;g=e+44|0;h=e+40|0;j=e+36|0;k=e+32|0;l=e+28|0;m=e+24|0;n=e+20|0;o=e+16|0;p=e+12|0;q=e+8|0;r=e+4|0;s=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[o>>2]=0;c[p>>2]=0;c[q>>2]=0;if(!((c[g>>2]|0)==0|(c[h>>2]|0)==0)?(c[(c[h>>2]|0)+4>>2]|0)==1:0){if((c[(c[g>>2]|0)+32>>2]|0)!=1){Ex(137816);c[f>>2]=-1;t=c[f>>2]|0;i=e;return t|0}c[l>>2]=IS(0,318)|0;if(!(c[l>>2]|0)){Ix(137856);c[f>>2]=-1;t=c[f>>2]|0;i=e;return t|0}a:do if(c[(c[g>>2]|0)+36>>2]|0){c[s>>2]=0;while(1){if(!(c[(c[(c[g>>2]|0)+36>>2]|0)+(c[s>>2]<<2)>>2]|0))break a;c[r>>2]=c[(c[(c[g>>2]|0)+36>>2]|0)+(c[s>>2]<<2)>>2];if(!((qy(c[r>>2]|0,137896)|0)==0?(qy(c[r>>2]|0,137704)|0)==0:0)){c[r>>2]=0;c[q>>2]=1}c[k>>2]=cj(c[(c[h>>2]|0)+32>>2]|0,c[h>>2]|0,c[r>>2]|0)|0;do if((c[k>>2]|0)!=0?(ay(c[k>>2]|0)|0)==0:0){if((c[(c[g>>2]|0)+4>>2]|0)!=0?(vb[c[(c[g>>2]|0)+4>>2]&511](c[(c[g>>2]|0)+8>>2]|0,c[k>>2]|0,c[h>>2]|0)|0)==0:0)break;c[n>>2]=by(c[(c[g>>2]|0)+28>>2]|0,c[k>>2]|0)|0;if(c[j>>2]|0)cy(c[(c[g>>2]|0)+28>>2]|0,c[k>>2]|0,c[h>>2]|0);if(!(c[n>>2]|0))KS(c[l>>2]|0,c[k>>2]|0)|0;if(!(xy(c[(c[k>>2]|0)+12>>2]|0)|0))c[o>>2]=1}while(0);c[s>>2]=(c[s>>2]|0)+1}}while(0);s=c[h>>2]|0;if(c[(c[h>>2]|0)+36>>2]|0)c[k>>2]=c[s+36>>2];else{c[k>>2]=cj(c[s+32>>2]|0,c[h>>2]|0,0)|0;c[p>>2]=1}if((c[k>>2]|0)!=0?(ay(c[k>>2]|0)|0)==0:0){do if(c[j>>2]|0){if((c[(c[g>>2]|0)+4>>2]|0)!=0?(vb[c[(c[g>>2]|0)+4>>2]&511](c[(c[g>>2]|0)+8>>2]|0,c[k>>2]|0,c[h>>2]|0)|0)==0:0)break;if(!(ey(c[(c[g>>2]|0)+28>>2]|0,c[k>>2]|0,c[g>>2]|0)|0))KS(c[l>>2]|0,c[k>>2]|0)|0}while(0);if(c[j>>2]|0)cy(c[(c[g>>2]|0)+28>>2]|0,c[k>>2]|0,c[h>>2]|0);if(!(xy(c[(c[k>>2]|0)+12>>2]|0)|0))c[o>>2]=1}c[m>>2]=c[(c[h>>2]|0)+44>>2];while(1){if(!(c[m>>2]|0))break;do if((c[(c[m>>2]|0)+36>>2]|0)!=0?(ay(c[(c[m>>2]|0)+36>>2]|0)|0)==0:0){if((c[(c[g>>2]|0)+4>>2]|0)!=0?(vb[c[(c[g>>2]|0)+4>>2]&511](c[(c[g>>2]|0)+8>>2]|0,c[m>>2]|0,c[h>>2]|0)|0)==0:0){u=49;break}c[n>>2]=ey(c[(c[g>>2]|0)+28>>2]|0,c[(c[m>>2]|0)+36>>2]|0,c[g>>2]|0)|0;cy(c[(c[g>>2]|0)+28>>2]|0,c[(c[m>>2]|0)+36>>2]|0,c[h>>2]|0);if((c[n>>2]|0)==0&(c[j>>2]|0)!=0)KS(c[l>>2]|0,c[(c[m>>2]|0)+36>>2]|0)|0;if(!(xy(c[(c[(c[m>>2]|0)+36>>2]|0)+12>>2]|0)|0))c[o>>2]=1}else u=49;while(0);if((((u|0)==49?(u=0,(c[(c[m>>2]|0)+36>>2]|0)!=0):0)?(xy(c[(c[(c[m>>2]|0)+36>>2]|0)+12>>2]|0)|0)==0:0)?(xy(c[(c[(c[m>>2]|0)+36>>2]|0)+8>>2]|0)|0)==0:0)c[p>>2]=1;c[m>>2]=c[(c[m>>2]|0)+24>>2]}if((c[j>>2]|0)!=0&(c[p>>2]|0)!=0^1|(c[o>>2]|0)!=0|(c[q>>2]|0)!=0){if((((c[j>>2]|0)==0|(c[o>>2]|0)!=0)^1)&(c[q>>2]|0)!=0?(c[34484]=0,c[34485]=0,c[34486]=0,c[34487]=0,c[34488]=0,c[34489]=0,(by(c[(c[g>>2]|0)+28>>2]|0,137936)|0)==0):0)dy(137936,c[g>>2]|0)|0}else{c[34478]=0;c[34479]=0;c[34480]=0;c[34481]=0;c[34482]=0;c[34483]=0;c[n>>2]=ey(c[(c[g>>2]|0)+28>>2]|0,137912,c[g>>2]|0)|0;if(!(c[n>>2]|0))dy(137912,c[g>>2]|0)|0}PS(c[l>>2]|0,319,c[g>>2]|0);MS(c[l>>2]|0);c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}Ex(137816);c[f>>2]=-1;t=c[f>>2]|0;i=e;return t|0}function Xx(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){Ex(137784);i=b;return}else{c[(c[d>>2]|0)+4>>2]=c[(c[d>>2]|0)+8>>2];c[(c[d>>2]|0)+8>>2]=c[c[d>>2]>>2];i=b;return}}function Yx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+48|0;f=e+44|0;g=e+40|0;h=e+36|0;j=e+32|0;k=e+28|0;l=e+24|0;m=e+20|0;n=e+16|0;o=e+12|0;p=e+8|0;q=e+4|0;r=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[m>>2]=0;c[n>>2]=0;c[o>>2]=0;c[p>>2]=0;if(!((c[g>>2]|0)==0|(c[h>>2]|0)==0)?(c[(c[h>>2]|0)+4>>2]|0)==1:0){c[l>>2]=IS(0,320)|0;if(!(c[l>>2]|0)){Ix(137328);c[f>>2]=-1;s=c[f>>2]|0;i=e;return s|0}d=c[(c[g>>2]|0)+32>>2]|0;a:do if((d|0)==2){c[k>>2]=c[(c[h>>2]|0)+44>>2];while(1){t=(c[j>>2]|0)!=0;if(!(c[k>>2]|0))break;do if(t?(gy(c[k>>2]|0)|0)!=0:0){c[r>>2]=0;if((c[r>>2]|0)==0&(c[o>>2]|0)==0?(qy(c[(c[k>>2]|0)+8>>2]|0,137360)|0)!=0:0){c[o>>2]=c[k>>2];c[r>>2]=1}if((c[r>>2]|0)==0&(c[p>>2]|0)==0?(qy(c[(c[k>>2]|0)+8>>2]|0,137368)|0)!=0:0){c[p>>2]=c[k>>2];c[r>>2]=1}if((c[r>>2]|0)==0&(c[n>>2]|0)==0?(qy(c[(c[k>>2]|0)+8>>2]|0,137376)|0)!=0:0){c[n>>2]=c[k>>2];c[r>>2]=1}if(!(c[r>>2]|0)){if((c[(c[g>>2]|0)+4>>2]|0)!=0?(vb[c[(c[g>>2]|0)+4>>2]&511](c[(c[g>>2]|0)+8>>2]|0,c[k>>2]|0,c[h>>2]|0)|0)==0:0)break;KS(c[l>>2]|0,c[k>>2]|0)|0}}else u=36;while(0);do if((u|0)==36){u=0;if((c[(c[g>>2]|0)+4>>2]|0)!=0?(vb[c[(c[g>>2]|0)+4>>2]&511](c[(c[g>>2]|0)+8>>2]|0,c[k>>2]|0,c[h>>2]|0)|0)==0:0)break;KS(c[l>>2]|0,c[k>>2]|0)|0}while(0);c[k>>2]=c[(c[k>>2]|0)+24>>2]}if(t){if(!(c[o>>2]|0))c[o>>2]=hy(c[g>>2]|0,c[(c[h>>2]|0)+20>>2]|0,137360,137384)|0;if(c[o>>2]|0)KS(c[l>>2]|0,c[o>>2]|0)|0;if(!(c[p>>2]|0))c[p>>2]=hy(c[g>>2]|0,c[(c[h>>2]|0)+20>>2]|0,137368,137384)|0;if(c[p>>2]|0)KS(c[l>>2]|0,c[p>>2]|0)|0;if(!(c[n>>2]|0))c[n>>2]=hy(c[g>>2]|0,c[(c[h>>2]|0)+20>>2]|0,137376,137384)|0;if((c[n>>2]|0)!=0?(c[n>>2]=iy(c[g>>2]|0,c[n>>2]|0)|0,(c[n>>2]|0)!=0):0){KS(c[l>>2]|0,c[n>>2]|0)|0;c[(c[n>>2]|0)+24>>2]=c[m>>2];c[m>>2]=c[n>>2]}}}else if(!d){c[k>>2]=c[(c[h>>2]|0)+44>>2];while(1){if(!(c[k>>2]|0))break;if(!((c[(c[g>>2]|0)+4>>2]|0)!=0?(vb[c[(c[g>>2]|0)+4>>2]&511](c[(c[g>>2]|0)+8>>2]|0,c[k>>2]|0,c[h>>2]|0)|0)==0:0))KS(c[l>>2]|0,c[k>>2]|0)|0;c[k>>2]=c[(c[k>>2]|0)+24>>2]}if((((c[j>>2]|0)!=0?(c[(c[h>>2]|0)+20>>2]|0)!=0:0)?(c[(c[g>>2]|0)+4>>2]|0)!=0:0)?(vb[c[(c[g>>2]|0)+4>>2]&511](c[(c[g>>2]|0)+8>>2]|0,c[(c[h>>2]|0)+20>>2]|0,c[(c[(c[h>>2]|0)+20>>2]|0)+20>>2]|0)|0)==0:0){c[q>>2]=c[(c[h>>2]|0)+20>>2];while(1){if(!(c[q>>2]|0))break a;c[k>>2]=c[(c[q>>2]|0)+44>>2];while(1){if(!(c[k>>2]|0))break;if((gy(c[k>>2]|0)|0)!=0?(JS(c[l>>2]|0,c[k>>2]|0)|0)==0:0)KS(c[l>>2]|0,c[k>>2]|0)|0;c[k>>2]=c[(c[k>>2]|0)+24>>2]}c[q>>2]=c[(c[q>>2]|0)+20>>2]}}}else if((d|0)==1){c[k>>2]=c[(c[h>>2]|0)+44>>2];while(1){if(!(c[k>>2]|0))break a;if(!((c[(c[g>>2]|0)+4>>2]|0)!=0?(vb[c[(c[g>>2]|0)+4>>2]&511](c[(c[g>>2]|0)+8>>2]|0,c[k>>2]|0,c[h>>2]|0)|0)==0:0))KS(c[l>>2]|0,c[k>>2]|0)|0;c[k>>2]=c[(c[k>>2]|0)+24>>2]}}while(0);PS(c[l>>2]|0,321,c[g>>2]|0);di(c[m>>2]|0);MS(c[l>>2]|0);c[f>>2]=0;s=c[f>>2]|0;i=e;return s|0}Ex(137216);c[f>>2]=-1;s=c[f>>2]|0;i=e;return s|0}function Zx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if((c[e>>2]|0)==0|(c[f>>2]|0)==0){Ex(137296);i=d;return}else{c[c[e>>2]>>2]=c[c[f>>2]>>2];c[(c[e>>2]|0)+4>>2]=c[(c[f>>2]|0)+4>>2];c[(c[e>>2]|0)+8>>2]=c[(c[f>>2]|0)+8>>2];i=d;return}}function _x(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;e=b+4|0;c[e>>2]=a;c[d>>2]=c[e>>2];Xd(0,0,0,0,0,21,1955,2,0,0,0,0,0,0,0,138312,d);i=b;return}function $x(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;do if((c[f>>2]|0)!=(c[g>>2]|0)){if(!(c[f>>2]|0)){c[e>>2]=-1;break}if(!(c[g>>2]|0)){c[e>>2]=1;break}else{c[e>>2]=py(c[(c[f>>2]|0)+12>>2]|0,c[(c[g>>2]|0)+12>>2]|0)|0;break}}else c[e>>2]=0;while(0);i=d;return c[e>>2]|0}function ay(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)!=0?(qy(c[(c[d>>2]|0)+12>>2]|0,137776)|0)!=0:0)e=(qy(c[(c[d>>2]|0)+8>>2]|0,137384)|0)!=0;else e=0;i=b;return e&1|0}function by(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+48|0;e=d+32|0;f=d+28|0;g=d+24|0;h=d+20|0;j=d+16|0;k=d+12|0;l=d+8|0;m=d+4|0;n=d;c[f>>2]=a;c[g>>2]=b;if(!(c[f>>2]|0)){Ex(138112);c[e>>2]=0;o=c[e>>2]|0;i=d;return o|0}if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+12>>2]|0)!=0:0)p=c[(c[g>>2]|0)+12>>2]|0;else p=137704;c[j>>2]=p;if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+8>>2]|0)!=0:0)q=c[(c[g>>2]|0)+8>>2]|0;else q=137704;c[k>>2]=q;if(ky(c[j>>2]|0,0)|0)r=(ky(c[k>>2]|0,0)|0)!=0;else r=0;c[l>>2]=r&1;a:do if(c[(c[f>>2]|0)+16>>2]|0){if(c[l>>2]|0)s=0;else s=c[(c[f>>2]|0)+4>>2]|0;c[m>>2]=s;c[h>>2]=(c[c[f>>2]>>2]|0)-1;while(1){if((c[h>>2]|0)<(c[m>>2]|0))break a;c[n>>2]=c[(c[(c[f>>2]|0)+16>>2]|0)+(c[h>>2]<<2)>>2];if(c[n>>2]|0)t=c[(c[n>>2]|0)+12>>2]|0;else t=0;if(ky(c[j>>2]|0,t)|0)break;c[h>>2]=(c[h>>2]|0)+-1}if(c[n>>2]|0)u=c[(c[n>>2]|0)+8>>2]|0;else u=0;c[e>>2]=ky(c[k>>2]|0,u)|0;o=c[e>>2]|0;i=d;return o|0}while(0);c[e>>2]=c[l>>2];o=c[e>>2]|0;i=d;return o|0}function cy(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;do if(c[f>>2]|0){if((c[(c[f>>2]|0)+16>>2]|0)==0?(c[(c[f>>2]|0)+20>>2]|0)!=0:0)break;if((c[(c[f>>2]|0)+16>>2]|0)!=0?(c[(c[f>>2]|0)+20>>2]|0)==0:0)break;do if((c[(c[f>>2]|0)+16>>2]|0)==0?(c[(c[f>>2]|0)+20>>2]|0)==0:0){d=Cb[c[135744>>2]&511](64)|0;c[(c[f>>2]|0)+16>>2]=d;d=Cb[c[135744>>2]&511](64)|0;c[(c[f>>2]|0)+20>>2]=d;if((c[(c[f>>2]|0)+16>>2]|0)!=0?(c[(c[f>>2]|0)+20>>2]|0)!=0:0){d=(c[(c[f>>2]|0)+16>>2]|0)+0|0;b=d+64|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(b|0));d=(c[(c[f>>2]|0)+20>>2]|0)+0|0;b=d+64|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(b|0));c[(c[f>>2]|0)+12>>2]=16;break}Lx(138088);i=e;return}else l=13;while(0);do if((l|0)==13?(c[(c[f>>2]|0)+12>>2]|0)==(c[c[f>>2]>>2]|0):0){c[k>>2]=c[(c[f>>2]|0)+12>>2]<<1;c[j>>2]=Hb[c[135760>>2]&511](c[(c[f>>2]|0)+16>>2]|0,c[k>>2]<<2)|0;if(!(c[j>>2]|0)){Lx(138088);i=e;return}c[(c[f>>2]|0)+16>>2]=c[j>>2];c[j>>2]=Hb[c[135760>>2]&511](c[(c[f>>2]|0)+20>>2]|0,c[k>>2]<<2)|0;if(c[j>>2]|0){c[(c[f>>2]|0)+20>>2]=c[j>>2];c[(c[f>>2]|0)+12>>2]=c[k>>2];break}Lx(138088);i=e;return}while(0);c[(c[(c[f>>2]|0)+16>>2]|0)+(c[c[f>>2]>>2]<<2)>>2]=c[g>>2];c[(c[(c[f>>2]|0)+20>>2]|0)+(c[c[f>>2]>>2]<<2)>>2]=c[h>>2];d=c[f>>2]|0;c[d>>2]=(c[d>>2]|0)+1;i=e;return}while(0);Ex(138056);i=e;return}function dy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){Ex(137960);c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}b=c[(c[g>>2]|0)+16>>2]|0;if(c[(c[f>>2]|0)+12>>2]|0){Qk(b,137984)|0;Qk(c[(c[g>>2]|0)+16>>2]|0,c[(c[f>>2]|0)+12>>2]|0)|0;Qk(c[(c[g>>2]|0)+16>>2]|0,137992)|0}else Qk(b,138e3)|0;b=c[(c[g>>2]|0)+16>>2]|0;if(c[(c[f>>2]|0)+8>>2]|0)gz(c[b+16>>2]|0,c[(c[f>>2]|0)+8>>2]|0)|0;else Qk(b,138008)|0;c[e>>2]=1;h=c[e>>2]|0;i=d;return h|0}function ey(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+48|0;f=e+36|0;g=e+32|0;h=e+28|0;j=e+24|0;k=e+20|0;l=e+16|0;m=e+12|0;n=e+8|0;o=e+4|0;p=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(!(c[g>>2]|0)){Ex(138016);c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}if((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+12>>2]|0)!=0:0)r=c[(c[h>>2]|0)+12>>2]|0;else r=137704;c[l>>2]=r;if((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+8>>2]|0)!=0:0)s=c[(c[h>>2]|0)+8>>2]|0;else s=137704;c[m>>2]=s;if(ky(c[l>>2]|0,0)|0)t=(ky(c[m>>2]|0,0)|0)!=0;else t=0;c[n>>2]=t&1;a:do if(c[(c[g>>2]|0)+16>>2]|0){c[o>>2]=0;c[k>>2]=(c[c[g>>2]>>2]|0)-1;while(1){if((c[k>>2]|0)<(c[o>>2]|0))break a;c[p>>2]=c[(c[(c[g>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2];if(c[p>>2]|0)u=c[(c[p>>2]|0)+12>>2]|0;else u=0;if(ky(c[l>>2]|0,u)|0)break;c[k>>2]=(c[k>>2]|0)+-1}if(c[p>>2]|0)v=c[(c[p>>2]|0)+8>>2]|0;else v=0;if(!(ky(c[m>>2]|0,v)|0)){c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}if(c[(c[j>>2]|0)+4>>2]|0)w=vb[c[(c[j>>2]|0)+4>>2]&511](c[(c[j>>2]|0)+8>>2]|0,c[p>>2]|0,c[(c[(c[g>>2]|0)+20>>2]|0)+(c[k>>2]<<2)>>2]|0)|0;else w=1;c[f>>2]=w;q=c[f>>2]|0;i=e;return q|0}while(0);c[f>>2]=c[n>>2];q=c[f>>2]|0;i=e;return q|0}function fy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;do if((c[f>>2]|0)==(c[g>>2]|0))c[e>>2]=0;else{if(!(c[f>>2]|0)){c[e>>2]=-1;break}if(!(c[g>>2]|0)){c[e>>2]=1;break}b=c[f>>2]|0;if((c[(c[f>>2]|0)+36>>2]|0)==(c[(c[g>>2]|0)+36>>2]|0)){c[e>>2]=py(c[b+8>>2]|0,c[(c[g>>2]|0)+8>>2]|0)|0;break}if(!(c[b+36>>2]|0)){c[e>>2]=-1;break}if(!(c[(c[g>>2]|0)+36>>2]|0)){c[e>>2]=1;break}if(!(c[(c[(c[f>>2]|0)+36>>2]|0)+12>>2]|0)){c[e>>2]=-1;break}if(!(c[(c[(c[g>>2]|0)+36>>2]|0)+12>>2]|0)){c[e>>2]=1;break}c[h>>2]=py(c[(c[(c[f>>2]|0)+36>>2]|0)+8>>2]|0,c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0)|0;if(!(c[h>>2]|0))c[h>>2]=py(c[(c[f>>2]|0)+8>>2]|0,c[(c[g>>2]|0)+8>>2]|0)|0;c[e>>2]=c[h>>2]}while(0);i=d;return c[e>>2]|0}function gy(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[(c[d>>2]|0)+36>>2]|0)){e=0;f=e&1;i=b;return f|0}e=(ay(c[(c[d>>2]|0)+36>>2]|0)|0)!=0;f=e&1;i=b;return f|0}function hy(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;while(1){if(!(c[j>>2]|0)){n=9;break}if(c[(c[h>>2]|0)+4>>2]|0)o=vb[c[(c[h>>2]|0)+4>>2]&511](c[(c[h>>2]|0)+8>>2]|0,c[j>>2]|0,c[(c[j>>2]|0)+20>>2]|0)|0;else o=1;if(!((o|0)!=0^1)){n=9;break}c[m>>2]=Ai(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0)|0;if(c[m>>2]|0){n=7;break}c[j>>2]=c[(c[j>>2]|0)+20>>2]}if((n|0)==7){c[g>>2]=c[m>>2];p=c[g>>2]|0;i=f;return p|0}else if((n|0)==9){c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}return 0}function iy(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+48|0;f=e+32|0;g=e+28|0;h=e+24|0;j=e+20|0;k=e+16|0;l=e+12|0;m=e+8|0;n=e+4|0;o=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=0;if(!((c[g>>2]|0)==0|(c[h>>2]|0)==0)?(c[(c[h>>2]|0)+20>>2]|0)!=0:0){c[j>>2]=_h(c[c[g>>2]>>2]|0,c[(c[h>>2]|0)+12>>2]|0,1)|0;if(!(c[j>>2]|0)){Ix(137528);c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}c[k>>2]=c[(c[(c[h>>2]|0)+20>>2]|0)+20>>2];while(1){if(!(c[k>>2]|0)){q=23;break}if(c[(c[g>>2]|0)+4>>2]|0)r=vb[c[(c[g>>2]|0)+4>>2]&511](c[(c[g>>2]|0)+8>>2]|0,c[k>>2]|0,c[(c[k>>2]|0)+20>>2]|0)|0;else r=1;if(!((r|0)!=0^1)){q=23;break}c[l>>2]=Ai(c[k>>2]|0,137376,137384)|0;if(c[l>>2]|0){c[m>>2]=_h(c[c[g>>2]>>2]|0,c[(c[l>>2]|0)+12>>2]|0,1)|0;if(!(c[m>>2]|0)){q=13;break}c[o>>2]=xy(c[m>>2]|0)|0;if((c[o>>2]|0)>1?(d[(c[m>>2]|0)+((c[o>>2]|0)-2)>>0]|0|0)==46:0){c[n>>2]=By(c[m>>2]|0,137584)|0;if(!(c[n>>2]|0)){q=17;break}c[m>>2]=c[n>>2]}c[n>>2]=Hl(c[j>>2]|0,c[m>>2]|0)|0;b=(c[n>>2]|0)==0;zb[c[135736>>2]&511](c[m>>2]|0);zb[c[135736>>2]&511](c[j>>2]|0);if(b){q=20;break}c[j>>2]=c[n>>2]}c[k>>2]=c[(c[k>>2]|0)+20>>2]}if((q|0)==13){zb[c[135736>>2]&511](c[j>>2]|0);Ix(137528);c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}else if((q|0)==17){zb[c[135736>>2]&511](c[m>>2]|0);zb[c[135736>>2]&511](c[j>>2]|0);Ix(137592);c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}else if((q|0)==20){Ix(137648);c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}else if((q|0)==23){if((c[j>>2]|0)!=0?(qy(c[j>>2]|0,137704)|0)==0:0){c[l>>2]=ai(0,c[(c[h>>2]|0)+36>>2]|0,137376,c[j>>2]|0)|0;h=(c[l>>2]|0)==0;zb[c[135736>>2]&511](c[j>>2]|0);if(h){Ix(137712);c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}else{c[f>>2]=c[l>>2];p=c[f>>2]|0;i=e;return p|0}}zb[c[135736>>2]&511](c[j>>2]|0);c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}}Ex(137496);c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}function jy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){Ex(137424);c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}Qk(c[(c[g>>2]|0)+16>>2]|0,136792)|0;if((c[(c[f>>2]|0)+36>>2]|0)!=0?(xy(c[(c[(c[f>>2]|0)+36>>2]|0)+12>>2]|0)|0)>0:0){Qk(c[(c[g>>2]|0)+16>>2]|0,c[(c[(c[f>>2]|0)+36>>2]|0)+12>>2]|0)|0;Qk(c[(c[g>>2]|0)+16>>2]|0,137176)|0}Qk(c[(c[g>>2]|0)+16>>2]|0,c[(c[f>>2]|0)+8>>2]|0)|0;Qk(c[(c[g>>2]|0)+16>>2]|0,137448)|0;c[h>>2]=_h(c[c[g>>2]>>2]|0,c[(c[f>>2]|0)+12>>2]|0,1)|0;do if(c[h>>2]|0){c[j>>2]=Qx(c[h>>2]|0,0)|0;zb[c[135736>>2]&511](c[h>>2]|0);if(c[j>>2]|0){Qk(c[(c[g>>2]|0)+16>>2]|0,c[j>>2]|0)|0;zb[c[135736>>2]&511](c[j>>2]|0);break}Ix(137456);c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}while(0);Qk(c[(c[g>>2]|0)+16>>2]|0,137488)|0;c[e>>2]=1;k=c[e>>2]|0;i=d;return k|0}function ky(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;c[h>>2]=b;c[j>>2]=e;do if((c[h>>2]|0)!=(c[j>>2]|0)){e=c[j>>2]|0;if(!(c[h>>2]|0)){c[g>>2]=(d[e>>0]|0)==0&1;break}if(!e){c[g>>2]=(d[c[h>>2]>>0]|0)==0&1;break}while(1){e=c[h>>2]|0;c[h>>2]=e+1;if((d[e>>0]|0)!=(d[c[j>>2]>>0]|0)){k=8;break}e=c[j>>2]|0;c[j>>2]=e+1;if(!(a[e>>0]|0)){k=10;break}}if((k|0)==8){c[g>>2]=0;break}else if((k|0)==10){c[g>>2]=1;break}}else c[g>>2]=1;while(0);i=f;return c[g>>2]|0}function ly(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=b;c[h>>2]=d;if((c[g>>2]|0)==0|(c[h>>2]|0)<0){c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}c[j>>2]=Cb[c[135752>>2]&511]((c[h>>2]|0)+1|0)|0;if(!(c[j>>2]|0)){ie(0,0);c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}else{eU(c[j>>2]|0,c[g>>2]|0,c[h>>2]|0)|0;a[(c[j>>2]|0)+(c[h>>2]|0)>>0]=0;c[f>>2]=c[j>>2];k=c[f>>2]|0;i=e;return k|0}return 0}function my(a){a=a|0;var b=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;e=b+8|0;f=b+4|0;g=b;c[f>>2]=a;c[g>>2]=c[f>>2];if(!(c[f>>2]|0)){c[e>>2]=0;h=c[e>>2]|0;i=b;return h|0}while(1){if(!(d[c[g>>2]>>0]|0))break;c[g>>2]=(c[g>>2]|0)+1}c[e>>2]=ly(c[f>>2]|0,(c[g>>2]|0)-(c[f>>2]|0)|0)|0;h=c[e>>2]|0;i=b;return h|0}function ny(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[h>>2]=b;c[j>>2]=e;if((c[h>>2]|0)==0|(c[j>>2]|0)<0){c[g>>2]=0;m=c[g>>2]|0;i=f;return m|0}c[l>>2]=Cb[c[135752>>2]&511]((c[j>>2]|0)+1|0)|0;if(!(c[l>>2]|0)){ie(0,0);c[g>>2]=0;m=c[g>>2]|0;i=f;return m|0}c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[j>>2]|0)){n=10;break}a[(c[l>>2]|0)+(c[k>>2]|0)>>0]=a[(c[h>>2]|0)+(c[k>>2]|0)>>0]|0;if(!(d[(c[l>>2]|0)+(c[k>>2]|0)>>0]|0)){n=8;break}c[k>>2]=(c[k>>2]|0)+1}if((n|0)==8){c[g>>2]=c[l>>2];m=c[g>>2]|0;i=f;return m|0}else if((n|0)==10){a[(c[l>>2]|0)+(c[j>>2]|0)>>0]=0;
c[g>>2]=c[l>>2];m=c[g>>2]|0;i=f;return m|0}return 0}function oy(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=b;c[g>>2]=c[f>>2];if(!(c[f>>2]|0)){c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}while(1){if(!(a[c[g>>2]>>0]|0))break;c[g>>2]=(c[g>>2]|0)+1}c[e>>2]=ny(c[f>>2]|0,(c[g>>2]|0)-(c[f>>2]|0)|0)|0;h=c[e>>2]|0;i=d;return h|0}function py(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=a;c[h>>2]=b;do if((c[g>>2]|0)!=(c[h>>2]|0)){if(!(c[g>>2]|0)){c[f>>2]=-1;break}if(!(c[h>>2]|0)){c[f>>2]=1;break}while(1){b=c[g>>2]|0;c[g>>2]=b+1;c[j>>2]=(d[b>>0]|0)-(d[c[h>>2]>>0]|0);if(c[j>>2]|0){k=8;break}b=c[h>>2]|0;c[h>>2]=b+1;if(!(d[b>>0]|0)){k=10;break}}if((k|0)==8){c[f>>2]=c[j>>2];break}else if((k|0)==10){c[f>>2]=0;break}}else c[f>>2]=0;while(0);i=e;return c[f>>2]|0}function qy(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;c[h>>2]=b;c[j>>2]=e;do if((c[h>>2]|0)!=(c[j>>2]|0)){if(!(c[h>>2]|0)){c[g>>2]=0;break}if(!(c[j>>2]|0)){c[g>>2]=0;break}while(1){e=c[h>>2]|0;c[h>>2]=e+1;if((d[e>>0]|0)!=(d[c[j>>2]>>0]|0)){k=8;break}e=c[j>>2]|0;c[j>>2]=e+1;if(!(a[e>>0]|0)){k=10;break}}if((k|0)==8){c[g>>2]=0;break}else if((k|0)==10){c[g>>2]=1;break}}else c[g>>2]=1;while(0);i=f;return c[g>>2]|0}function ry(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+16|0;h=g+12|0;j=g+8|0;k=g+4|0;l=g;c[j>>2]=b;c[k>>2]=e;c[l>>2]=f;f=c[k>>2]|0;do if(c[j>>2]|0){if(!f){c[h>>2]=0;break}if(!(c[l>>2]|0)){c[h>>2]=0;break}do{e=c[j>>2]|0;c[j>>2]=e+1;if((d[e>>0]|0)!=(d[c[l>>2]>>0]|0)){m=8;break}e=c[l>>2]|0;c[l>>2]=e+1;if(!(d[e>>0]|0))break}while((d[c[j>>2]>>0]|0)!=0);if((m|0)==8){c[h>>2]=0;break}e=c[l>>2]|0;c[l>>2]=e+1;if((d[e>>0]|0)!=58){c[h>>2]=0;break}while(1){e=c[k>>2]|0;c[k>>2]=e+1;if((d[e>>0]|0)!=(d[c[l>>2]>>0]|0)){m=14;break}e=c[l>>2]|0;c[l>>2]=e+1;if(!(a[e>>0]|0)){m=16;break}}if((m|0)==14){c[h>>2]=0;break}else if((m|0)==16){c[h>>2]=1;break}}else c[h>>2]=qy(f,c[l>>2]|0)|0;while(0);i=g;return c[h>>2]|0}function sy(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;do if((c[j>>2]|0)>0){if((c[g>>2]|0)==(c[h>>2]|0)){c[f>>2]=0;break}if(!(c[g>>2]|0)){c[f>>2]=-1;break}if(!(c[h>>2]|0)){c[f>>2]=1;break}else{c[k>>2]=QT(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;c[f>>2]=c[k>>2];break}}else c[f>>2]=0;while(0);i=e;return c[f>>2]|0}function ty(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=a;c[h>>2]=b;do if((c[g>>2]|0)!=(c[h>>2]|0)){if(!(c[g>>2]|0)){c[f>>2]=-1;break}if(!(c[h>>2]|0)){c[f>>2]=1;break}while(1){b=c[g>>2]|0;c[g>>2]=b+1;c[j>>2]=(d[138656+(d[b>>0]|0)>>0]|0)-(d[138656+(d[c[h>>2]>>0]|0)>>0]|0);if(c[j>>2]|0){k=8;break}b=c[h>>2]|0;c[h>>2]=b+1;if(!(d[b>>0]|0)){k=10;break}}if((k|0)==8){c[f>>2]=c[j>>2];break}else if((k|0)==10){c[f>>2]=0;break}}else c[f>>2]=0;while(0);i=e;return c[f>>2]|0}function uy(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=e;do if((c[k>>2]|0)>0){if((c[h>>2]|0)==(c[j>>2]|0)){c[g>>2]=0;break}if(!(c[h>>2]|0)){c[g>>2]=-1;break}if(!(c[j>>2]|0)){c[g>>2]=1;break}while(1){e=c[h>>2]|0;c[h>>2]=e+1;c[l>>2]=(d[138656+(d[e>>0]|0)>>0]|0)-(d[138656+(d[c[j>>2]>>0]|0)>>0]|0);if(c[l>>2]|0){m=11;break}e=(c[k>>2]|0)+-1|0;c[k>>2]=e;if(!e){m=11;break}e=c[j>>2]|0;c[j>>2]=e+1;if(!(d[e>>0]|0)){m=13;break}}if((m|0)==11){c[g>>2]=c[l>>2];break}else if((m|0)==13){c[g>>2]=0;break}}else c[g>>2]=0;while(0);i=f;return c[g>>2]|0}function vy(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f+4|0;h=f;j=f+8|0;c[h>>2]=b;a[j>>0]=e;do if(c[h>>2]|0){while(1){if(!(d[c[h>>2]>>0]|0)){k=7;break}l=c[h>>2]|0;if((d[c[h>>2]>>0]|0|0)==(d[j>>0]|0|0)){k=5;break}c[h>>2]=l+1}if((k|0)==5){c[g>>2]=l;break}else if((k|0)==7){c[g>>2]=0;break}}else c[g>>2]=0;while(0);i=f;return c[g>>2]|0}function wy(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=a;c[h>>2]=b;do if(c[g>>2]|0){if(!(c[h>>2]|0)){c[f>>2]=0;break}c[j>>2]=xy(c[h>>2]|0)|0;if(!(c[j>>2]|0)){c[f>>2]=c[g>>2];break}while(1){if(!(d[c[g>>2]>>0]|0)){k=12;break}if((d[c[g>>2]>>0]|0|0)==(d[c[h>>2]>>0]|0|0)?(sy(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0)|0)==0:0){k=10;break}c[g>>2]=(c[g>>2]|0)+1}if((k|0)==10){c[f>>2]=c[g>>2];break}else if((k|0)==12){c[f>>2]=0;break}}else c[f>>2]=0;while(0);i=e;return c[f>>2]|0}function xy(a){a=a|0;var b=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;e=b+8|0;f=b+4|0;g=b;c[f>>2]=a;c[g>>2]=0;if(!(c[f>>2]|0)){c[e>>2]=0;h=c[e>>2]|0;i=b;return h|0}while(1){if(!(d[c[f>>2]>>0]|0))break;c[f>>2]=(c[f>>2]|0)+1;c[g>>2]=(c[g>>2]|0)+1}c[e>>2]=c[g>>2];h=c[e>>2]|0;i=b;return h|0}function yy(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=a;c[h>>2]=b;do if(c[g>>2]|0){if(!(c[h>>2]|0)){c[f>>2]=0;break}c[j>>2]=xy(c[h>>2]|0)|0;if(!(c[j>>2]|0)){c[f>>2]=c[g>>2];break}while(1){if(!(d[c[g>>2]>>0]|0)){k=12;break}if((d[138656+(d[c[g>>2]>>0]|0)>>0]|0|0)==(d[138656+(d[c[h>>2]>>0]|0)>>0]|0|0)?(uy(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0)|0)==0:0){k=10;break}c[g>>2]=(c[g>>2]|0)+1}if((k|0)==10){c[f>>2]=c[g>>2];break}else if((k|0)==12){c[f>>2]=0;break}}else c[f>>2]=0;while(0);i=e;return c[f>>2]|0}function zy(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;if((c[j>>2]|0)==0|(c[k>>2]|0)==0){c[g>>2]=c[h>>2];n=c[g>>2]|0;i=f;return n|0}if((c[k>>2]|0)<0){c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}if(!(c[h>>2]|0)){c[g>>2]=ly(c[j>>2]|0,c[k>>2]|0)|0;n=c[g>>2]|0;i=f;return n|0}c[l>>2]=xy(c[h>>2]|0)|0;c[m>>2]=Hb[c[135760>>2]&511](c[h>>2]|0,(c[l>>2]|0)+(c[k>>2]|0)+1|0)|0;if(!(c[m>>2]|0)){ie(0,0);c[g>>2]=c[h>>2];n=c[g>>2]|0;i=f;return n|0}else{eU((c[m>>2]|0)+(c[l>>2]|0)|0,c[j>>2]|0,c[k>>2]|0)|0;a[(c[m>>2]|0)+((c[l>>2]|0)+(c[k>>2]|0))>>0]=0;c[g>>2]=c[m>>2];n=c[g>>2]|0;i=f;return n|0}return 0}function Ay(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;if((c[k>>2]|0)<0)c[k>>2]=xy(c[j>>2]|0)|0;e=c[h>>2]|0;if((c[j>>2]|0)==0|(c[k>>2]|0)==0){c[g>>2]=my(e)|0;n=c[g>>2]|0;i=f;return n|0}if(!e){c[g>>2]=ly(c[j>>2]|0,c[k>>2]|0)|0;n=c[g>>2]|0;i=f;return n|0}c[l>>2]=xy(c[h>>2]|0)|0;c[m>>2]=Cb[c[135744>>2]&511]((c[l>>2]|0)+(c[k>>2]|0)+1|0)|0;if(!(c[m>>2]|0)){ie(0,0);c[g>>2]=ly(c[h>>2]|0,c[l>>2]|0)|0;n=c[g>>2]|0;i=f;return n|0}else{eU(c[m>>2]|0,c[h>>2]|0,c[l>>2]|0)|0;eU((c[m>>2]|0)+(c[l>>2]|0)|0,c[j>>2]|0,c[k>>2]|0)|0;a[(c[m>>2]|0)+((c[l>>2]|0)+(c[k>>2]|0))>>0]=0;c[g>>2]=c[m>>2];n=c[g>>2]|0;i=f;return n|0}return 0}function By(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=c[h>>2];b=c[g>>2]|0;if(!(c[h>>2]|0)){c[f>>2]=b;k=c[f>>2]|0;i=e;return k|0}if(!b){c[f>>2]=my(c[h>>2]|0)|0;k=c[f>>2]|0;i=e;return k|0}while(1){if(!(d[c[j>>2]>>0]|0))break;c[j>>2]=(c[j>>2]|0)+1}c[f>>2]=zy(c[g>>2]|0,c[h>>2]|0,(c[j>>2]|0)-(c[h>>2]|0)|0)|0;k=c[f>>2]|0;i=e;return k|0}function Cy(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+48|0;h=g+36|0;j=g+32|0;k=g+28|0;l=g+24|0;m=g+8|0;n=g;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if((c[j>>2]|0)==0|(c[l>>2]|0)==0){c[h>>2]=-1;o=c[h>>2]|0;i=g;return o|0}else{c[m>>2]=f;c[n>>2]=LT(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,m)|0;a[(c[j>>2]|0)+((c[k>>2]|0)-1)>>0]=0;c[h>>2]=c[n>>2];o=c[h>>2]|0;i=g;return o|0}return 0}function Dy(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=b+8|0;f=b+4|0;g=b;c[f>>2]=a;c[g>>2]=0;if(!(c[f>>2]|0)){c[e>>2]=-1;h=c[e>>2]|0;i=b;return h|0}a:while(1){if(!(d[c[f>>2]>>0]|0)){j=19;break}a=(c[f>>2]|0)+1|0;do if((d[c[f>>2]>>0]|0)&128){if(((d[a>>0]|0)&192|0)!=128){j=6;break a}k=(c[f>>2]|0)+2|0;if(((d[c[f>>2]>>0]|0)&224|0)!=224){c[f>>2]=k;break}if(((d[k>>0]|0)&192|0)!=128){j=9;break a}k=c[f>>2]|0;if(((d[c[f>>2]>>0]|0)&240|0)!=240){c[f>>2]=k+3;break}if(((d[k>>0]|0)&248|0)!=240){j=13;break a}if(((d[(c[f>>2]|0)+3>>0]|0)&192|0)!=128){j=13;break a}c[f>>2]=(c[f>>2]|0)+4}else c[f>>2]=a;while(0);c[g>>2]=(c[g>>2]|0)+1}if((j|0)==6){c[e>>2]=-1;h=c[e>>2]|0;i=b;return h|0}else if((j|0)==9){c[e>>2]=-1;h=c[e>>2]|0;i=b;return h|0}else if((j|0)==13){c[e>>2]=-1;h=c[e>>2]|0;i=b;return h|0}else if((j|0)==19){c[e>>2]=c[g>>2];h=c[e>>2]|0;i=b;return h|0}return 0}function Ey(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=a;c[h>>2]=b;a:do if(!((c[g>>2]|0)==0|(c[h>>2]|0)==0)?(c[c[h>>2]>>2]|0)>=1:0){c[j>>2]=d[c[g>>2]>>0];b=c[h>>2]|0;do if(c[j>>2]&128){if((c[b>>2]|0)<2)break a;if(((d[(c[g>>2]|0)+1>>0]|0)&192|0)!=128)break a;a=c[h>>2]|0;if((c[j>>2]&224|0)!=224){c[a>>2]=2;c[j>>2]=((d[c[g>>2]>>0]|0)&31)<<6;c[j>>2]=c[j>>2]|(d[(c[g>>2]|0)+1>>0]|0)&63;break}if((c[a>>2]|0)<3)break a;if(((d[(c[g>>2]|0)+2>>0]|0)&192|0)!=128)break a;a=c[h>>2]|0;if((c[j>>2]&240|0)!=240){c[a>>2]=3;c[j>>2]=((d[c[g>>2]>>0]|0)&15)<<12;c[j>>2]=c[j>>2]|((d[(c[g>>2]|0)+1>>0]|0)&63)<<6;c[j>>2]=c[j>>2]|(d[(c[g>>2]|0)+2>>0]|0)&63;break}if((c[a>>2]|0)<4)break a;if((c[j>>2]&248|0)!=240)break a;if(((d[(c[g>>2]|0)+3>>0]|0)&192|0)!=128)break a;c[c[h>>2]>>2]=4;c[j>>2]=((d[c[g>>2]>>0]|0)&7)<<18;c[j>>2]=c[j>>2]|((d[(c[g>>2]|0)+1>>0]|0)&63)<<12;c[j>>2]=c[j>>2]|((d[(c[g>>2]|0)+2>>0]|0)&63)<<6;c[j>>2]=c[j>>2]|(d[(c[g>>2]|0)+3>>0]|0)&63}else c[b>>2]=1;while(0);c[f>>2]=c[j>>2];k=c[f>>2]|0;i=e;return k|0}while(0);if(c[h>>2]|0)c[c[h>>2]>>2]=0;c[f>>2]=-1;k=c[f>>2]|0;i=e;return k|0}function Fy(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=e+12|0;c[g>>2]=b;if(!(c[g>>2]|0)){c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}c[h>>2]=0;while(1){b=a[(c[g>>2]|0)+(c[h>>2]|0)>>0]|0;a[j>>0]=b;if(!(b<<24>>24)){l=23;break}if(!((d[j>>0]|0)&128)){c[h>>2]=(c[h>>2]|0)+1;continue}if(((d[j>>0]|0)&224|0)==192){if(((d[(c[g>>2]|0)+((c[h>>2]|0)+1)>>0]|0)&192|0)!=128){l=9;break}c[h>>2]=(c[h>>2]|0)+2;continue}if(((d[j>>0]|0)&240|0)==224){if(((d[(c[g>>2]|0)+((c[h>>2]|0)+1)>>0]|0)&192|0)!=128){l=14;break}if(((d[(c[g>>2]|0)+((c[h>>2]|0)+2)>>0]|0)&192|0)!=128){l=14;break}c[h>>2]=(c[h>>2]|0)+3;continue}if(((d[j>>0]|0)&248|0)!=240){l=22;break}if(((d[(c[g>>2]|0)+((c[h>>2]|0)+1)>>0]|0)&192|0)!=128){l=20;break}if(((d[(c[g>>2]|0)+((c[h>>2]|0)+2)>>0]|0)&192|0)!=128){l=20;break}if(((d[(c[g>>2]|0)+((c[h>>2]|0)+3)>>0]|0)&192|0)!=128){l=20;break}c[h>>2]=(c[h>>2]|0)+4}if((l|0)==9){c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}else if((l|0)==14){c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}else if((l|0)==20){c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}else if((l|0)==22){c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}else if((l|0)==23){c[f>>2]=1;k=c[f>>2]|0;i=e;return k|0}return 0}function Gy(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;l=f+16|0;c[h>>2]=b;c[j>>2]=e;c[k>>2]=c[h>>2];if(!(c[h>>2]|0)){c[g>>2]=0;m=c[g>>2]|0;i=f;return m|0}if((c[j>>2]|0)<=0){c[g>>2]=0;m=c[g>>2]|0;i=f;return m|0}a:while(1){e=c[j>>2]|0;c[j>>2]=e+-1;if((e|0)<=0)break;if(!(a[c[k>>2]>>0]|0))break;e=c[k>>2]|0;c[k>>2]=e+1;b=a[e>>0]|0;a[l>>0]=b;if(!(b&128))continue;while(1){b=d[l>>0]<<1&255;a[l>>0]=b;if(!(b&128))continue a;c[k>>2]=(c[k>>2]|0)+1;if(!(d[c[k>>2]>>0]|0))continue a}}c[g>>2]=(c[k>>2]|0)-(c[h>>2]|0);m=c[g>>2]|0;i=f;return m|0}function Hy(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;c[h>>2]=b;c[j>>2]=d;if((c[h>>2]|0)==0|(c[j>>2]|0)<0){c[g>>2]=0;m=c[g>>2]|0;i=e;return m|0}c[l>>2]=Gy(c[h>>2]|0,c[j>>2]|0)|0;c[k>>2]=Cb[c[135752>>2]&511]((c[l>>2]|0)+1|0)|0;if(!(c[k>>2]|0)){d=c[33976]|0;b=c[33980]|0;c[f>>2]=(c[j>>2]|0)+1;Db[d&511](b,138912,f);c[g>>2]=0;m=c[g>>2]|0;i=e;return m|0}else{eU(c[k>>2]|0,c[h>>2]|0,c[l>>2]|0)|0;a[(c[k>>2]|0)+(c[l>>2]|0)>>0]=0;c[g>>2]=c[k>>2];m=c[g>>2]|0;i=e;return m|0}return 0}function Iy(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;k=f+12|0;c[h>>2]=b;c[j>>2]=e;do if(c[h>>2]|0){if((c[j>>2]|0)<0){c[g>>2]=0;break}a:while(1){e=c[j>>2]|0;c[j>>2]=e+-1;l=c[h>>2]|0;if(!e){m=14;break}c[h>>2]=l+1;e=a[l>>0]|0;a[k>>0]=e;if(!(e&255)){m=7;break}if(!((d[k>>0]|0)&128))continue;if(((d[k>>0]|0)&192|0)!=192){m=10;break}while(1){e=(d[k>>0]|0)<<1&255;a[k>>0]=e;if(!(e&128))continue a;e=c[h>>2]|0;c[h>>2]=e+1;if(((d[e>>0]|0)&192|0)!=128){m=13;break a}}}if((m|0)==7){c[g>>2]=0;break}else if((m|0)==10){c[g>>2]=0;break}else if((m|0)==13){c[g>>2]=0;break}else if((m|0)==14){c[g>>2]=l;break}}else c[g>>2]=0;while(0);i=f;return c[g>>2]|0}function Jy(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;m=f+20|0;c[h>>2]=b;c[j>>2]=e;if((c[h>>2]|0)==0|(c[j>>2]|0)==0){c[g>>2]=-1;n=c[g>>2]|0;i=f;return n|0}c[l>>2]=Gy(c[j>>2]|0,1)|0;c[k>>2]=0;a:while(1){e=a[c[h>>2]>>0]|0;a[m>>0]=e;if(!(e&255)){o=14;break}if(!(sy(c[h>>2]|0,c[j>>2]|0,c[l>>2]|0)|0)){o=6;break}c[h>>2]=(c[h>>2]|0)+1;b:do if((d[m>>0]|0)&128){if(((d[m>>0]|0)&192|0)!=192){o=9;break a}while(1){e=(d[m>>0]|0)<<1&255;a[m>>0]=e;if(!(e&128))break b;e=c[h>>2]|0;c[h>>2]=e+1;if(((d[e>>0]|0)&192|0)!=128){o=12;break a}}}while(0);c[k>>2]=(c[k>>2]|0)+1}if((o|0)==6){c[g>>2]=c[k>>2];n=c[g>>2]|0;i=f;return n|0}else if((o|0)==9){c[g>>2]=-1;n=c[g>>2]|0;i=f;return n|0}else if((o|0)==12){c[g>>2]=-1;n=c[g>>2]|0;i=f;return n|0}else if((o|0)==14){c[g>>2]=-1;n=c[g>>2]|0;i=f;return n|0}return 0}function Ky(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+32|0;h=g+16|0;j=g+12|0;k=g+8|0;l=g+4|0;m=g;n=g+20|0;c[j>>2]=b;c[k>>2]=e;c[l>>2]=f;do if(c[j>>2]|0){if((c[k>>2]|0)<0){c[h>>2]=0;break}if((c[l>>2]|0)<0){c[h>>2]=0;break}c[m>>2]=0;a:while(1){o=c[j>>2]|0;if((c[m>>2]|0)>=(c[k>>2]|0)){p=18;break}c[j>>2]=o+1;f=a[o>>0]|0;a[n>>0]=f;if(!(f&255)){p=10;break}b:do if((d[n>>0]|0)&128){if(((d[n>>0]|0)&192|0)!=192){p=13;break a}while(1){f=(d[n>>0]|0)<<1&255;a[n>>0]=f;if(!(f&128))break b;f=c[j>>2]|0;c[j>>2]=f+1;if(((d[f>>0]|0)&192|0)!=128){p=16;break a}}}while(0);c[m>>2]=(c[m>>2]|0)+1}if((p|0)==10){c[h>>2]=0;break}else if((p|0)==13){c[h>>2]=0;break}else if((p|0)==16){c[h>>2]=0;break}else if((p|0)==18){c[h>>2]=Hy(o,c[l>>2]|0)|0;break}}else c[h>>2]=0;while(0);i=g;return c[h>>2]|0}function Ly(){var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=Cb[c[135744>>2]&511](36)|0;if(!(c[e>>2]|0)){lz(0,138944);c[d>>2]=0;f=c[d>>2]|0;i=b;return f|0}c[(c[e>>2]|0)+4>>2]=0;c[(c[e>>2]|0)+20>>2]=0;c[(c[e>>2]|0)+32>>2]=0;c[(c[e>>2]|0)+28>>2]=0;c[(c[e>>2]|0)+24>>2]=c[33950];c[(c[e>>2]|0)+8>>2]=c[33950];c[(c[e>>2]|0)+12>>2]=c[33948];g=Cb[c[135752>>2]&511](c[(c[e>>2]|0)+24>>2]|0)|0;c[c[e>>2]>>2]=g;g=c[e>>2]|0;if(!(c[c[e>>2]>>2]|0)){lz(g,138944);zb[c[135736>>2]&511](c[e>>2]|0);c[d>>2]=0;f=c[d>>2]|0;i=b;return f|0}else{a[c[g>>2]>>0]=0;c[(c[e>>2]|0)+16>>2]=0;c[d>>2]=c[e>>2];f=c[d>>2]|0;i=b;return f|0}return 0}function My(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=b;c[g>>2]=Cb[c[135744>>2]&511](36)|0;if(!(c[g>>2]|0)){lz(0,138944);c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}c[(c[g>>2]|0)+4>>2]=0;c[(c[g>>2]|0)+20>>2]=0;c[(c[g>>2]|0)+32>>2]=0;c[(c[g>>2]|0)+28>>2]=0;c[(c[g>>2]|0)+12>>2]=c[33948];if(c[f>>2]|0)j=(c[f>>2]|0)+2|0;else j=0;c[(c[g>>2]|0)+24>>2]=j;c[(c[g>>2]|0)+8>>2]=c[(c[g>>2]|0)+24>>2];do if(c[(c[g>>2]|0)+24>>2]|0){j=Cb[c[135752>>2]&511](c[(c[g>>2]|0)+24>>2]|0)|0;c[c[g>>2]>>2]=j;j=c[g>>2]|0;if(c[c[g>>2]>>2]|0){a[c[j>>2]>>0]=0;break}lz(j,138944);zb[c[135736>>2]&511](c[g>>2]|0);c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}else c[c[g>>2]>>2]=0;while(0);c[(c[g>>2]|0)+16>>2]=0;c[e>>2]=c[g>>2];h=c[e>>2]|0;i=d;return h|0}function Ny(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;do if(c[e>>2]|0){if((c[(c[e>>2]|0)+12>>2]|0)==2){c[d>>2]=0;break}if(c[(c[e>>2]|0)+28>>2]|0){c[d>>2]=0;break}if(c[(c[e>>2]|0)+32>>2]|0){c[d>>2]=0;break}else{c[f>>2]=c[c[e>>2]>>2];c[c[e>>2]>>2]=0;c[(c[e>>2]|0)+24>>2]=0;c[(c[e>>2]|0)+20>>2]=0;c[(c[e>>2]|0)+4>>2]=0;c[(c[e>>2]|0)+8>>2]=0;c[d>>2]=c[f>>2];break}}else c[d>>2]=0;while(0);i=b;return c[d>>2]|0}function Oy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}c[h>>2]=Cb[c[135744>>2]&511](36)|0;if(!(c[h>>2]|0)){lz(0,138944);c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}if((c[g>>2]|0)>>>0<2147483647){c[(c[h>>2]|0)+4>>2]=c[g>>2];c[(c[h>>2]|0)+8>>2]=c[g>>2]}else{c[(c[h>>2]|0)+4>>2]=2147483647;c[(c[h>>2]|0)+8>>2]=2147483647}c[(c[h>>2]|0)+20>>2]=c[g>>2];c[(c[h>>2]|0)+24>>2]=c[g>>2];c[(c[h>>2]|0)+12>>2]=2;c[c[h>>2]>>2]=c[f>>2];c[(c[h>>2]|0)+32>>2]=0;c[(c[h>>2]|0)+28>>2]=0;c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}function Py(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;if(!(c[e>>2]|0))c[d>>2]=-1;else c[d>>2]=c[(c[e>>2]|0)+12>>2];i=b;return c[d>>2]|0}function Qy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+32>>2]|0)==0:0){if((c[(c[f>>2]|0)+12>>2]|0)!=2?(c[(c[f>>2]|0)+12>>2]|0)!=3:0){b=c[g>>2]|0;if((c[g>>2]|0)==0|(c[g>>2]|0)==1|(c[g>>2]|0)==4|(c[g>>2]|0)==2){c[(c[f>>2]|0)+12>>2]=b;if(c[(c[f>>2]|0)+28>>2]|0)c[(c[(c[f>>2]|0)+28>>2]|0)+12>>2]=c[g>>2];c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}else{if((b|0)==3){c[(c[f>>2]|0)+12>>2]=3;c[(c[f>>2]|0)+16>>2]=c[c[f>>2]>>2]}c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}}c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}function Ry(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if((c[(c[d>>2]|0)+12>>2]|0)==3?(c[(c[d>>2]|0)+16>>2]|0)!=0:0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+16>>2]|0);else e=5;if(((e|0)==5?(c[c[d>>2]>>2]|0)!=0:0)?(c[(c[d>>2]|0)+12>>2]|0)!=2:0)zb[c[135736>>2]&511](c[c[d>>2]>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function Sy(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=b;if(!(c[e>>2]|0)){i=d;return}if(c[(c[e>>2]|0)+32>>2]|0){i=d;return}if(!(c[c[e>>2]>>2]|0)){i=d;return}if((c[(c[e>>2]|0)+24>>2]|0)!=(c[(c[e>>2]|0)+8>>2]|0)?(c[(c[e>>2]|0)+8>>2]|0)>>>0<2147483647:0)c[(c[e>>2]|0)+24>>2]=c[(c[e>>2]|0)+8>>2];if((c[(c[e>>2]|0)+20>>2]|0)!=(c[(c[e>>2]|0)+4>>2]|0)?(c[(c[e>>2]|0)+4>>2]|0)>>>0<2147483647:0)c[(c[e>>2]|0)+20>>2]=c[(c[e>>2]|0)+4>>2];c[(c[e>>2]|0)+20>>2]=0;b=c[e>>2]|0;do if((c[(c[e>>2]|0)+12>>2]|0)==2)c[b>>2]=138960;else{if((c[b+12>>2]|0)==3?(c[(c[e>>2]|0)+16>>2]|0)!=0:0){c[f>>2]=(c[c[e>>2]>>2]|0)-(c[(c[e>>2]|0)+16>>2]|0);g=(c[e>>2]|0)+24|0;c[g>>2]=(c[g>>2]|0)+(c[f>>2]|0);c[c[e>>2]>>2]=c[(c[e>>2]|0)+16>>2];a[c[c[e>>2]>>2]>>0]=0;break}a[c[c[e>>2]>>2]>>0]=0}while(0);f=c[e>>2]|0;if((c[(c[e>>2]|0)+24>>2]|0)>>>0<2147483647)c[(c[e>>2]|0)+8>>2]=c[f+24>>2];else c[f+8>>2]=2147483647;f=c[e>>2]|0;if((c[(c[e>>2]|0)+20>>2]|0)>>>0<2147483647){c[(c[e>>2]|0)+4>>2]=c[f+20>>2];i=d;return}else{c[f+4>>2]=2147483647;i=d;return}}function Ty(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=b;c[h>>2]=d;if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+32>>2]|0)==0:0){if((c[(c[g>>2]|0)+24>>2]|0)!=(c[(c[g>>2]|0)+8>>2]|0)?(c[(c[g>>2]|0)+8>>2]|0)>>>0<2147483647:0)c[(c[g>>2]|0)+24>>2]=c[(c[g>>2]|0)+8>>2];if((c[(c[g>>2]|0)+20>>2]|0)!=(c[(c[g>>2]|0)+4>>2]|0)?(c[(c[g>>2]|0)+4>>2]|0)>>>0<2147483647:0)c[(c[g>>2]|0)+20>>2]=c[(c[g>>2]|0)+4>>2];if(!(c[h>>2]|0)){c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}if((c[h>>2]|0)>>>0>(c[(c[g>>2]|0)+20>>2]|0)>>>0){c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}d=(c[g>>2]|0)+20|0;c[d>>2]=(c[d>>2]|0)-(c[h>>2]|0);do if((c[(c[g>>2]|0)+12>>2]|0)==2)l=17;else{if((c[(c[g>>2]|0)+12>>2]|0)==3?(c[(c[g>>2]|0)+16>>2]|0)!=0:0){l=17;break}fU(c[c[g>>2]>>2]|0,(c[c[g>>2]>>2]|0)+(c[h>>2]|0)|0,c[(c[g>>2]|0)+20>>2]|0)|0;a[(c[c[g>>2]>>2]|0)+(c[(c[g>>2]|0)+20>>2]|0)>>0]=0}while(0);if((((l|0)==17?(l=c[g>>2]|0,c[l>>2]=(c[l>>2]|0)+(c[h>>2]|0),l=(c[g>>2]|0)+24|0,c[l>>2]=(c[l>>2]|0)-(c[h>>2]|0),(c[(c[g>>2]|0)+12>>2]|0)==3):0)?(c[(c[g>>2]|0)+16>>2]|0)!=0:0)?(c[j>>2]=(c[c[g>>2]>>2]|0)-(c[(c[g>>2]|0)+16>>2]|0),(c[j>>2]|0)>>>0>=(c[(c[g>>2]|0)+24>>2]|0)>>>0):0){fU(c[(c[g>>2]|0)+16>>2]|0,c[c[g>>2]>>2]|0,c[(c[g>>2]|0)+20>>2]|0)|0;c[c[g>>2]>>2]=c[(c[g>>2]|0)+16>>2];a[(c[c[g>>2]>>2]|0)+(c[(c[g>>2]|0)+20>>2]|0)>>0]=0;l=(c[g>>2]|0)+24|0;c[l>>2]=(c[l>>2]|0)+(c[j>>2]|0)}j=c[g>>2]|0;if((c[(c[g>>2]|0)+24>>2]|0)>>>0<2147483647)c[(c[g>>2]|0)+8>>2]=c[j+24>>2];else c[j+8>>2]=2147483647;j=c[g>>2]|0;if((c[(c[g>>2]|0)+20>>2]|0)>>>0<2147483647)c[(c[g>>2]|0)+4>>2]=c[j+20>>2];else c[j+4>>2]=2147483647;c[f>>2]=c[h>>2];k=c[f>>2]|0;i=e;return k|0}c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}function Uy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;do if(!((c[f>>2]|0)==0|(c[g>>2]|0)<0)){if(!(c[g>>2]|0)){c[e>>2]=0;break}c[h>>2]=mz(c[f>>2]|0,c[g>>2]|0)|0;if(c[(c[f>>2]|0)+32>>2]|0){c[e>>2]=-1;break}else{c[e>>2]=c[h>>2];break}}else c[e>>2]=-1;while(0);i=d;return c[e>>2]|0}function Vy(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+32>>2]|0)==0:0){c[d>>2]=c[c[e>>2]>>2];f=c[d>>2]|0;i=b;return f|0}c[d>>2]=0;f=c[d>>2]|0;i=b;return f|0}function Wy(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+32>>2]|0)==0:0){if((c[(c[e>>2]|0)+24>>2]|0)!=(c[(c[e>>2]|0)+8>>2]|0)?(c[(c[e>>2]|0)+8>>2]|0)>>>0<2147483647:0)c[(c[e>>2]|0)+24>>2]=c[(c[e>>2]|0)+8>>2];if((c[(c[e>>2]|0)+20>>2]|0)!=(c[(c[e>>2]|0)+4>>2]|0)?(c[(c[e>>2]|0)+4>>2]|0)>>>0<2147483647:0)c[(c[e>>2]|0)+20>>2]=c[(c[e>>2]|0)+4>>2];c[d>>2]=(c[c[e>>2]>>2]|0)+(c[(c[e>>2]|0)+20>>2]|0);f=c[d>>2]|0;i=b;return f|0}c[d>>2]=0;f=c[d>>2]|0;i=b;return f|0}function Xy(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[g>>2]=b;c[h>>2]=d;if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+32>>2]|0)==0:0){if((c[(c[g>>2]|0)+24>>2]|0)!=(c[(c[g>>2]|0)+8>>2]|0)?(c[(c[g>>2]|0)+8>>2]|0)>>>0<2147483647:0)c[(c[g>>2]|0)+24>>2]=c[(c[g>>2]|0)+8>>2];if((c[(c[g>>2]|0)+20>>2]|0)!=(c[(c[g>>2]|0)+4>>2]|0)?(c[(c[g>>2]|0)+4>>2]|0)>>>0<2147483647:0)c[(c[g>>2]|0)+20>>2]=c[(c[g>>2]|0)+4>>2];if((c[h>>2]|0)>>>0>((c[(c[g>>2]|0)+24>>2]|0)-(c[(c[g>>2]|0)+20>>2]|0)|0)>>>0){c[f>>2]=-1;j=c[f>>2]|0;i=e;return j|0}d=(c[g>>2]|0)+20|0;c[d>>2]=(c[d>>2]|0)+(c[h>>2]|0);h=c[g>>2]|0;if((c[(c[g>>2]|0)+24>>2]|0)>>>0<2147483647)c[(c[g>>2]|0)+8>>2]=c[h+24>>2];else c[h+8>>2]=2147483647;h=c[g>>2]|0;if((c[(c[g>>2]|0)+20>>2]|0)>>>0<2147483647)c[(c[g>>2]|0)+4>>2]=c[h+20>>2];else c[h+4>>2]=2147483647;if((c[(c[g>>2]|0)+24>>2]|0)>>>0>(c[(c[g>>2]|0)+20>>2]|0)>>>0){a[(c[c[g>>2]>>2]|0)+(c[(c[g>>2]|0)+20>>2]|0)>>0]=0;c[f>>2]=0;j=c[f>>2]|0;i=e;return j|0}else{c[f>>2]=-1;j=c[f>>2]|0;i=e;return j|0}}c[f>>2]=-1;j=c[f>>2]|0;i=e;return j|0}function Yy(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[g>>2]=b;c[h>>2]=d;if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+32>>2]|0)==0:0){if((c[(c[g>>2]|0)+24>>2]|0)!=(c[(c[g>>2]|0)+8>>2]|0)?(c[(c[g>>2]|0)+8>>2]|0)>>>0<2147483647:0)c[(c[g>>2]|0)+24>>2]=c[(c[g>>2]|0)+8>>2];if((c[(c[g>>2]|0)+20>>2]|0)!=(c[(c[g>>2]|0)+4>>2]|0)?(c[(c[g>>2]|0)+4>>2]|0)>>>0<2147483647:0)c[(c[g>>2]|0)+20>>2]=c[(c[g>>2]|0)+4>>2];if((c[h>>2]|0)>>>0>(c[(c[g>>2]|0)+20>>2]|0)>>>0){c[f>>2]=-1;j=c[f>>2]|0;i=e;return j|0}d=(c[g>>2]|0)+20|0;c[d>>2]=(c[d>>2]|0)-(c[h>>2]|0);a[(c[c[g>>2]>>2]|0)+(c[(c[g>>2]|0)+20>>2]|0)>>0]=0;h=c[g>>2]|0;if((c[(c[g>>2]|0)+24>>2]|0)>>>0<2147483647)c[(c[g>>2]|0)+8>>2]=c[h+24>>2];else c[h+8>>2]=2147483647;h=c[g>>2]|0;if((c[(c[g>>2]|0)+20>>2]|0)>>>0<2147483647)c[(c[g>>2]|0)+4>>2]=c[h+20>>2];else c[h+4>>2]=2147483647;c[f>>2]=0;j=c[f>>2]|0;i=e;return j|0}c[f>>2]=-1;j=c[f>>2]|0;i=e;return j|0}function Zy(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+32>>2]|0)==0:0){if((c[(c[e>>2]|0)+24>>2]|0)!=(c[(c[e>>2]|0)+8>>2]|0)?(c[(c[e>>2]|0)+8>>2]|0)>>>0<2147483647:0)c[(c[e>>2]|0)+24>>2]=c[(c[e>>2]|0)+8>>2];if((c[(c[e>>2]|0)+20>>2]|0)!=(c[(c[e>>2]|0)+4>>2]|0)?(c[(c[e>>2]|0)+4>>2]|0)>>>0<2147483647:0)c[(c[e>>2]|0)+20>>2]=c[(c[e>>2]|0)+4>>2];c[d>>2]=c[(c[e>>2]|0)+20>>2];f=c[d>>2]|0;i=b;return f|0}c[d>>2]=0;f=c[d>>2]|0;i=b;return f|0}function _y(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+32>>2]|0)==0:0){if((c[(c[e>>2]|0)+24>>2]|0)!=(c[(c[e>>2]|0)+8>>2]|0)?(c[(c[e>>2]|0)+8>>2]|0)>>>0<2147483647:0)c[(c[e>>2]|0)+24>>2]=c[(c[e>>2]|0)+8>>2];if((c[(c[e>>2]|0)+20>>2]|0)!=(c[(c[e>>2]|0)+4>>2]|0)?(c[(c[e>>2]|0)+4>>2]|0)>>>0<2147483647:0)c[(c[e>>2]|0)+20>>2]=c[(c[e>>2]|0)+4>>2];c[d>>2]=c[(c[e>>2]|0)+20>>2];f=c[d>>2]|0;i=b;return f|0}c[d>>2]=0;f=c[d>>2]|0;i=b;return f|0}function $y(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+32>>2]|0)==0:0){if((c[(c[e>>2]|0)+24>>2]|0)!=(c[(c[e>>2]|0)+8>>2]|0)?(c[(c[e>>2]|0)+8>>2]|0)>>>0<2147483647:0)c[(c[e>>2]|0)+24>>2]=c[(c[e>>2]|0)+8>>2];if((c[(c[e>>2]|0)+20>>2]|0)!=(c[(c[e>>2]|0)+4>>2]|0)?(c[(c[e>>2]|0)+4>>2]|0)>>>0<2147483647:0)c[(c[e>>2]|0)+20>>2]=c[(c[e>>2]|0)+4>>2];c[d>>2]=(c[(c[e>>2]|0)+24>>2]|0)-(c[(c[e>>2]|0)+20>>2]|0);f=c[d>>2]|0;i=b;return f|0}c[d>>2]=0;f=c[d>>2]|0;i=b;return f|0}function az(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+32>>2]|0)==0:0){if((c[(c[e>>2]|0)+24>>2]|0)!=(c[(c[e>>2]|0)+8>>2]|0)?(c[(c[e>>2]|0)+8>>2]|0)>>>0<2147483647:0)c[(c[e>>2]|0)+24>>2]=c[(c[e>>2]|0)+8>>2];if((c[(c[e>>2]|0)+20>>2]|0)!=(c[(c[e>>2]|0)+4>>2]|0)?(c[(c[e>>2]|0)+4>>2]|0)>>>0<2147483647:0)c[(c[e>>2]|0)+20>>2]=c[(c[e>>2]|0)+4>>2];c[d>>2]=(c[(c[e>>2]|0)+20>>2]|0)==0&1;f=c[d>>2]|0;i=b;return f|0}c[d>>2]=-1;f=c[d>>2]|0;i=b;return f|0}function bz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=b;c[h>>2]=d;c[k>>2]=0;if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+32>>2]|0)==0:0){if((c[(c[g>>2]|0)+24>>2]|0)!=(c[(c[g>>2]|0)+8>>2]|0)?(c[(c[g>>2]|0)+8>>2]|0)>>>0<2147483647:0)c[(c[g>>2]|0)+24>>2]=c[(c[g>>2]|0)+8>>2];if((c[(c[g>>2]|0)+20>>2]|0)!=(c[(c[g>>2]|0)+4>>2]|0)?(c[(c[g>>2]|0)+4>>2]|0)>>>0<2147483647:0)c[(c[g>>2]|0)+20>>2]=c[(c[g>>2]|0)+4>>2];if((c[(c[g>>2]|0)+12>>2]|0)==2){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}if((c[h>>2]|0)>>>0<(c[(c[g>>2]|0)+24>>2]|0)>>>0){c[f>>2]=1;m=c[f>>2]|0;i=e;return m|0}d=c[(c[g>>2]|0)+12>>2]|0;a:do if((d|0)==4){if((c[(c[g>>2]|0)+20>>2]|0)>>>0<4096){c[j>>2]=c[h>>2];break}c[j>>2]=c[(c[g>>2]|0)+24>>2]<<1;while(1){if((c[h>>2]|0)>>>0<=(c[j>>2]|0)>>>0)break a;if((c[j>>2]|0)>>>0>2147483647)break;c[j>>2]=c[j>>2]<<1}lz(c[g>>2]|0,138968);c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}else if((d|0)==0|(d|0)==3){if(c[(c[g>>2]|0)+24>>2]|0)n=c[(c[g>>2]|0)+24>>2]<<1;else n=(c[h>>2]|0)+10|0;c[j>>2]=n;while(1){if((c[h>>2]|0)>>>0<=(c[j>>2]|0)>>>0)break a;if((c[j>>2]|0)>>>0>2147483647)break;c[j>>2]=c[j>>2]<<1}lz(c[g>>2]|0,138968);c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}else if((d|0)==1)c[j>>2]=(c[h>>2]|0)+10;else c[j>>2]=(c[h>>2]|0)+10;while(0);do if((c[(c[g>>2]|0)+12>>2]|0)==3?(c[(c[g>>2]|0)+16>>2]|0)!=0:0){c[l>>2]=(c[c[g>>2]>>2]|0)-(c[(c[g>>2]|0)+16>>2]|0);if((c[l>>2]|0)>>>0>(c[j>>2]|0)>>>0){fU(c[(c[g>>2]|0)+16>>2]|0,c[c[g>>2]>>2]|0,c[(c[g>>2]|0)+20>>2]|0)|0;c[c[g>>2]>>2]=c[(c[g>>2]|0)+16>>2];a[(c[c[g>>2]>>2]|0)+(c[(c[g>>2]|0)+20>>2]|0)>>0]=0;h=(c[g>>2]|0)+24|0;c[h>>2]=(c[h>>2]|0)+(c[l>>2]|0);break}c[k>>2]=Hb[c[135760>>2]&511](c[(c[g>>2]|0)+16>>2]|0,(c[l>>2]|0)+(c[j>>2]|0)|0)|0;if(c[k>>2]|0){c[(c[g>>2]|0)+16>>2]=c[k>>2];c[c[g>>2]>>2]=(c[k>>2]|0)+(c[l>>2]|0);break}lz(c[g>>2]|0,138968);c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}else o=39;while(0);do if((o|0)==39){do if(c[c[g>>2]>>2]|0){if(((c[(c[g>>2]|0)+24>>2]|0)-(c[(c[g>>2]|0)+20>>2]|0)|0)>>>0<100){c[k>>2]=Hb[c[135760>>2]&511](c[c[g>>2]>>2]|0,c[j>>2]|0)|0;break}c[k>>2]=Cb[c[135752>>2]&511](c[j>>2]|0)|0;if(c[k>>2]|0){eU(c[k>>2]|0,c[c[g>>2]>>2]|0,c[(c[g>>2]|0)+20>>2]|0)|0;zb[c[135736>>2]&511](c[c[g>>2]>>2]|0);a[(c[k>>2]|0)+(c[(c[g>>2]|0)+20>>2]|0)>>0]=0}}else c[k>>2]=Cb[c[135752>>2]&511](c[j>>2]|0)|0;while(0);if(c[k>>2]|0){c[c[g>>2]>>2]=c[k>>2];break}lz(c[g>>2]|0,138968);c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}while(0);c[(c[g>>2]|0)+24>>2]=c[j>>2];j=c[g>>2]|0;if((c[(c[g>>2]|0)+24>>2]|0)>>>0<2147483647)c[(c[g>>2]|0)+8>>2]=c[j+24>>2];else c[j+8>>2]=2147483647;j=c[g>>2]|0;if((c[(c[g>>2]|0)+20>>2]|0)>>>0<2147483647)c[(c[g>>2]|0)+4>>2]=c[j+20>>2];else c[j+4>>2]=2147483647;c[f>>2]=1;m=c[f>>2]|0;i=e;return m|0}c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}function cz(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;if(!((c[j>>2]|0)==0|(c[h>>2]|0)==0)?(c[(c[h>>2]|0)+32>>2]|0)==0:0){if((c[(c[h>>2]|0)+24>>2]|0)!=(c[(c[h>>2]|0)+8>>2]|0)?(c[(c[h>>2]|0)+8>>2]|0)>>>0<2147483647:0)c[(c[h>>2]|0)+24>>2]=c[(c[h>>2]|0)+8>>2];if((c[(c[h>>2]|0)+20>>2]|0)!=(c[(c[h>>2]|0)+4>>2]|0)?(c[(c[h>>2]|0)+4>>2]|0)>>>0<2147483647:0)c[(c[h>>2]|0)+20>>2]=c[(c[h>>2]|0)+4>>2];if((c[(c[h>>2]|0)+12>>2]|0)==2){c[g>>2]=-1;m=c[g>>2]|0;i=f;return m|0}if((c[k>>2]|0)<-1){c[g>>2]=-1;m=c[g>>2]|0;i=f;return m|0}if(!(c[k>>2]|0)){c[g>>2]=0;m=c[g>>2]|0;i=f;return m|0}if((c[k>>2]|0)<0)c[k>>2]=xy(c[j>>2]|0)|0;if((c[k>>2]|0)<0){c[g>>2]=-1;m=c[g>>2]|0;i=f;return m|0}if(!(c[k>>2]|0)){c[g>>2]=0;m=c[g>>2]|0;i=f;return m|0}c[l>>2]=(c[(c[h>>2]|0)+20>>2]|0)+(c[k>>2]|0)+2;if((c[l>>2]|0)>>>0>(c[(c[h>>2]|0)+24>>2]|0)>>>0?(bz(c[h>>2]|0,c[l>>2]|0)|0)==0:0){lz(c[h>>2]|0,138968);c[g>>2]=2;m=c[g>>2]|0;i=f;return m|0}fU((c[c[h>>2]>>2]|0)+(c[(c[h>>2]|0)+20>>2]|0)|0,c[j>>2]|0,c[k>>2]|0)|0;j=(c[h>>2]|0)+20|0;c[j>>2]=(c[j>>2]|0)+(c[k>>2]|0);a[(c[c[h>>2]>>2]|0)+(c[(c[h>>2]|0)+20>>2]|0)>>0]=0;k=c[h>>2]|0;if((c[(c[h>>2]|0)+24>>2]|0)>>>0<2147483647)c[(c[h>>2]|0)+8>>2]=c[k+24>>2];else c[k+8>>2]=2147483647;k=c[h>>2]|0;if((c[(c[h>>2]|0)+20>>2]|0)>>>0<2147483647)c[(c[h>>2]|0)+4>>2]=c[k+20>>2];else c[k+4>>2]=2147483647;c[g>>2]=0;m=c[g>>2]|0;i=f;return m|0}c[g>>2]=-1;m=c[g>>2]|0;i=f;return m|0}function dz(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;if((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+32>>2]|0)==0:0){if((c[(c[h>>2]|0)+24>>2]|0)!=(c[(c[h>>2]|0)+8>>2]|0)?(c[(c[h>>2]|0)+8>>2]|0)>>>0<2147483647:0)c[(c[h>>2]|0)+24>>2]=c[(c[h>>2]|0)+8>>2];if((c[(c[h>>2]|0)+20>>2]|0)!=(c[(c[h>>2]|0)+4>>2]|0)?(c[(c[h>>2]|0)+4>>2]|0)>>>0<2147483647:0)c[(c[h>>2]|0)+20>>2]=c[(c[h>>2]|0)+4>>2];if((c[(c[h>>2]|0)+12>>2]|0)==2){c[g>>2]=-1;n=c[g>>2]|0;i=f;return n|0}if(!(c[j>>2]|0)){c[g>>2]=-1;n=c[g>>2]|0;i=f;return n|0}if((c[k>>2]|0)<-1){c[g>>2]=-1;n=c[g>>2]|0;i=f;return n|0}if(!(c[k>>2]|0)){c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}if((c[k>>2]|0)<0)c[k>>2]=xy(c[j>>2]|0)|0;if((c[k>>2]|0)<=0){c[g>>2]=-1;n=c[g>>2]|0;i=f;return n|0}if(((c[(c[h>>2]|0)+12>>2]|0)==3?(c[(c[h>>2]|0)+16>>2]|0)!=0:0)?(c[m>>2]=(c[c[h>>2]>>2]|0)-(c[(c[h>>2]|0)+16>>2]|0),(c[m>>2]|0)>>>0>(c[k>>2]|0)>>>0):0){m=c[h>>2]|0;c[m>>2]=(c[m>>2]|0)+(0-(c[k>>2]|0));fU(c[c[h>>2]>>2]|0,c[j>>2]|0,c[k>>2]|0)|0;m=(c[h>>2]|0)+20|0;c[m>>2]=(c[m>>2]|0)+(c[k>>2]|0);m=(c[h>>2]|0)+24|0;c[m>>2]=(c[m>>2]|0)+(c[k>>2]|0);m=c[h>>2]|0;if((c[(c[h>>2]|0)+24>>2]|0)>>>0<2147483647)c[(c[h>>2]|0)+8>>2]=c[m+24>>2];else c[m+8>>2]=2147483647;m=c[h>>2]|0;if((c[(c[h>>2]|0)+20>>2]|0)>>>0<2147483647)c[(c[h>>2]|0)+4>>2]=c[m+20>>2];else c[m+4>>2]=2147483647;c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}c[l>>2]=(c[(c[h>>2]|0)+20>>2]|0)+(c[k>>2]|0)+2;if((c[l>>2]|0)>>>0>(c[(c[h>>2]|0)+24>>2]|0)>>>0?(bz(c[h>>2]|0,c[l>>2]|0)|0)==0:0){lz(c[h>>2]|0,138968);c[g>>2]=2;n=c[g>>2]|0;i=f;return n|0}fU((c[c[h>>2]>>2]|0)+(c[k>>2]|0)|0,c[c[h>>2]>>2]|0,c[(c[h>>2]|0)+20>>2]|0)|0;fU(c[c[h>>2]>>2]|0,c[j>>2]|0,c[k>>2]|0)|0;j=(c[h>>2]|0)+20|0;c[j>>2]=(c[j>>2]|0)+(c[k>>2]|0);a[(c[c[h>>2]>>2]|0)+(c[(c[h>>2]|0)+20>>2]|0)>>0]=0;k=c[h>>2]|0;if((c[(c[h>>2]|0)+24>>2]|0)>>>0<2147483647)c[(c[h>>2]|0)+8>>2]=c[k+24>>2];else c[k+8>>2]=2147483647;k=c[h>>2]|0;if((c[(c[h>>2]|0)+20>>2]|0)>>>0<2147483647)c[(c[h>>2]|0)+4>>2]=c[k+20>>2];else c[k+4>>2]=2147483647;c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}c[g>>2]=-1;n=c[g>>2]|0;i=f;return n|0}function ez(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+32>>2]|0)==0:0){if((c[(c[f>>2]|0)+24>>2]|0)!=(c[(c[f>>2]|0)+8>>2]|0)?(c[(c[f>>2]|0)+8>>2]|0)>>>0<2147483647:0)c[(c[f>>2]|0)+24>>2]=c[(c[f>>2]|0)+8>>2];if((c[(c[f>>2]|0)+20>>2]|0)!=(c[(c[f>>2]|0)+4>>2]|0)?(c[(c[f>>2]|0)+4>>2]|0)>>>0<2147483647:0)c[(c[f>>2]|0)+20>>2]=c[(c[f>>2]|0)+4>>2];
if((c[(c[f>>2]|0)+12>>2]|0)==2){c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}if(!(c[g>>2]|0)){c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}else{c[e>>2]=cz(c[f>>2]|0,c[g>>2]|0,-1)|0;h=c[e>>2]|0;i=d;return h|0}}c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}function fz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=b;c[h>>2]=d;if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+32>>2]|0)==0:0){if((c[(c[g>>2]|0)+24>>2]|0)!=(c[(c[g>>2]|0)+8>>2]|0)?(c[(c[g>>2]|0)+8>>2]|0)>>>0<2147483647:0)c[(c[g>>2]|0)+24>>2]=c[(c[g>>2]|0)+8>>2];if((c[(c[g>>2]|0)+20>>2]|0)!=(c[(c[g>>2]|0)+4>>2]|0)?(c[(c[g>>2]|0)+4>>2]|0)>>>0<2147483647:0)c[(c[g>>2]|0)+20>>2]=c[(c[g>>2]|0)+4>>2];if((c[(c[g>>2]|0)+12>>2]|0)==2){c[f>>2]=-1;k=c[f>>2]|0;i=e;return k|0}if(!(c[h>>2]|0)){c[f>>2]=-1;k=c[f>>2]|0;i=e;return k|0}c[j>>2]=c[h>>2];while(1){l=c[(c[g>>2]|0)+20>>2]|0;if(!(a[c[j>>2]>>0]|0))break;if((l+10|0)>>>0>=(c[(c[g>>2]|0)+24>>2]|0)>>>0?(bz(c[g>>2]|0,(c[(c[g>>2]|0)+20>>2]|0)+10|0)|0)==0:0){m=18;break}h=a[c[j>>2]>>0]|0;d=(c[g>>2]|0)+20|0;b=c[d>>2]|0;c[d>>2]=b+1;a[(c[c[g>>2]>>2]|0)+b>>0]=h;c[j>>2]=(c[j>>2]|0)+1}if((m|0)==18){lz(c[g>>2]|0,138968);c[f>>2]=2;k=c[f>>2]|0;i=e;return k|0}a[(c[c[g>>2]>>2]|0)+l>>0]=0;l=c[g>>2]|0;if((c[(c[g>>2]|0)+24>>2]|0)>>>0<2147483647)c[(c[g>>2]|0)+8>>2]=c[l+24>>2];else c[l+8>>2]=2147483647;l=c[g>>2]|0;if((c[(c[g>>2]|0)+20>>2]|0)>>>0<2147483647)c[(c[g>>2]|0)+4>>2]=c[l+20>>2];else c[l+4>>2]=2147483647;c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}c[f>>2]=-1;k=c[f>>2]|0;i=e;return k|0}function gz(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+32>>2]|0)==0:0){if((c[(c[g>>2]|0)+24>>2]|0)!=(c[(c[g>>2]|0)+8>>2]|0)?(c[(c[g>>2]|0)+8>>2]|0)>>>0<2147483647:0)c[(c[g>>2]|0)+24>>2]=c[(c[g>>2]|0)+8>>2];if((c[(c[g>>2]|0)+20>>2]|0)!=(c[(c[g>>2]|0)+4>>2]|0)?(c[(c[g>>2]|0)+4>>2]|0)>>>0<2147483647:0)c[(c[g>>2]|0)+20>>2]=c[(c[g>>2]|0)+4>>2];if((c[(c[g>>2]|0)+12>>2]|0)==2){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}do if(vy(c[h>>2]|0,34)|0){b=(vy(c[h>>2]|0,39)|0)!=0;a=c[g>>2]|0;if(!b){fz(a,139e3)|0;ez(c[g>>2]|0,c[h>>2]|0)|0;fz(c[g>>2]|0,139e3)|0;break}fz(a,138984)|0;a=c[h>>2]|0;c[j>>2]=a;c[k>>2]=a;while(1){if(!(d[c[j>>2]>>0]|0))break;if((d[c[j>>2]>>0]|0|0)!=34){c[j>>2]=(c[j>>2]|0)+1;continue}if((c[k>>2]|0)!=(c[j>>2]|0))cz(c[g>>2]|0,c[k>>2]|0,(c[j>>2]|0)-(c[k>>2]|0)|0)|0;cz(c[g>>2]|0,138992,6)|0;c[j>>2]=(c[j>>2]|0)+1;c[k>>2]=c[j>>2]}if((c[k>>2]|0)!=(c[j>>2]|0))cz(c[g>>2]|0,c[k>>2]|0,(c[j>>2]|0)-(c[k>>2]|0)|0)|0;fz(c[g>>2]|0,138984)|0}else{fz(c[g>>2]|0,138984)|0;ez(c[g>>2]|0,c[h>>2]|0)|0;fz(c[g>>2]|0,138984)|0}while(0);c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}function hz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+32>>2]|0)==0:0){if((c[(c[f>>2]|0)+24>>2]|0)!=(c[(c[f>>2]|0)+8>>2]|0)?(c[(c[f>>2]|0)+8>>2]|0)>>>0<2147483647:0)c[(c[f>>2]|0)+24>>2]=c[(c[f>>2]|0)+8>>2];if((c[(c[f>>2]|0)+20>>2]|0)!=(c[(c[f>>2]|0)+4>>2]|0)?(c[(c[f>>2]|0)+4>>2]|0)>>>0<2147483647:0)c[(c[f>>2]|0)+20>>2]=c[(c[f>>2]|0)+4>>2];if(((c[g>>2]|0)!=0?(c[c[g>>2]>>2]|0)!=0:0)?(c[(c[g>>2]|0)+4>>2]|0)>>>0>0:0)c[h>>2]=cz(c[f>>2]|0,c[c[g>>2]>>2]|0,c[(c[g>>2]|0)+4>>2]|0)|0;lj(c[g>>2]|0);c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}lj(c[g>>2]|0);c[e>>2]=-1;j=c[e>>2]|0;i=d;return j|0}function iz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if(!((c[g>>2]|0)==0|(c[f>>2]|0)==0)?(c[(c[f>>2]|0)+32>>2]|0)==0:0){if((c[(c[f>>2]|0)+24>>2]|0)!=(c[(c[f>>2]|0)+8>>2]|0)?(c[(c[f>>2]|0)+8>>2]|0)>>>0<2147483647:0)c[(c[f>>2]|0)+24>>2]=c[(c[f>>2]|0)+8>>2];if((c[(c[f>>2]|0)+20>>2]|0)!=(c[(c[f>>2]|0)+4>>2]|0)?(c[(c[f>>2]|0)+4>>2]|0)>>>0<2147483647:0)c[(c[f>>2]|0)+20>>2]=c[(c[f>>2]|0)+4>>2];b=c[c[f>>2]>>2]|0;c[(c[g>>2]|0)+16>>2]=b;c[(c[g>>2]|0)+12>>2]=b;c[(c[g>>2]|0)+20>>2]=(c[c[f>>2]>>2]|0)+(c[(c[f>>2]|0)+20>>2]|0);c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}function jz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if(!((c[g>>2]|0)==0|(c[f>>2]|0)==0)?(c[(c[f>>2]|0)+32>>2]|0)==0:0){if((c[(c[f>>2]|0)+24>>2]|0)!=(c[(c[f>>2]|0)+8>>2]|0)?(c[(c[f>>2]|0)+8>>2]|0)>>>0<2147483647:0)c[(c[f>>2]|0)+24>>2]=c[(c[f>>2]|0)+8>>2];if((c[(c[f>>2]|0)+20>>2]|0)!=(c[(c[f>>2]|0)+4>>2]|0)?(c[(c[f>>2]|0)+4>>2]|0)>>>0<2147483647:0)c[(c[f>>2]|0)+20>>2]=c[(c[f>>2]|0)+4>>2];c[h>>2]=(c[(c[g>>2]|0)+12>>2]|0)-(c[c[f>>2]>>2]|0);if((c[h>>2]|0)>>>0>(c[(c[f>>2]|0)+24>>2]|0)>>>0){nz(c[f>>2]|0,139008);c[h>>2]=0}c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}c[e>>2]=-1;j=c[e>>2]|0;i=d;return j|0}function kz(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if(!((c[j>>2]|0)==0|(c[h>>2]|0)==0)?(c[(c[h>>2]|0)+32>>2]|0)==0:0){if((c[(c[h>>2]|0)+24>>2]|0)!=(c[(c[h>>2]|0)+8>>2]|0)?(c[(c[h>>2]|0)+8>>2]|0)>>>0<2147483647:0)c[(c[h>>2]|0)+24>>2]=c[(c[h>>2]|0)+8>>2];if((c[(c[h>>2]|0)+20>>2]|0)!=(c[(c[h>>2]|0)+4>>2]|0)?(c[(c[h>>2]|0)+4>>2]|0)>>>0<2147483647:0)c[(c[h>>2]|0)+20>>2]=c[(c[h>>2]|0)+4>>2];c[(c[j>>2]|0)+12>>2]=(c[c[h>>2]>>2]|0)+(c[k>>2]|0);c[(c[j>>2]|0)+16>>2]=(c[(c[j>>2]|0)+12>>2]|0)+(c[l>>2]|0);c[(c[j>>2]|0)+20>>2]=(c[c[h>>2]>>2]|0)+(c[(c[h>>2]|0)+20>>2]|0);c[g>>2]=0;m=c[g>>2]|0;i=f;return m|0}c[g>>2]=-1;m=c[g>>2]|0;i=f;return m|0}function lz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;ce(29,2,0,0,c[f>>2]|0);if(!(c[e>>2]|0)){i=d;return}if(c[(c[e>>2]|0)+32>>2]|0){i=d;return}c[(c[e>>2]|0)+32>>2]=2;i=d;return}function mz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+32>>2]|0)==0:0){if((c[(c[f>>2]|0)+24>>2]|0)!=(c[(c[f>>2]|0)+8>>2]|0)?(c[(c[f>>2]|0)+8>>2]|0)>>>0<2147483647:0)c[(c[f>>2]|0)+24>>2]=c[(c[f>>2]|0)+8>>2];if((c[(c[f>>2]|0)+20>>2]|0)!=(c[(c[f>>2]|0)+4>>2]|0)?(c[(c[f>>2]|0)+4>>2]|0)>>>0<2147483647:0)c[(c[f>>2]|0)+20>>2]=c[(c[f>>2]|0)+4>>2];if((c[(c[f>>2]|0)+12>>2]|0)==2){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}b=c[(c[f>>2]|0)+24>>2]|0;if(((c[(c[f>>2]|0)+20>>2]|0)+(c[g>>2]|0)|0)>>>0<(c[(c[f>>2]|0)+24>>2]|0)>>>0){c[e>>2]=b-(c[(c[f>>2]|0)+20>>2]|0);l=c[e>>2]|0;i=d;return l|0}a=c[f>>2]|0;if(b>>>0>(c[g>>2]|0)>>>0)c[h>>2]=c[a+24>>2]<<1;else c[h>>2]=(c[a+20>>2]|0)+(c[g>>2]|0)+100;do if((c[(c[f>>2]|0)+12>>2]|0)==3?(c[(c[f>>2]|0)+16>>2]|0)!=0:0){c[k>>2]=(c[c[f>>2]>>2]|0)-(c[(c[f>>2]|0)+16>>2]|0);c[j>>2]=Hb[c[135760>>2]&511](c[(c[f>>2]|0)+16>>2]|0,(c[k>>2]|0)+(c[h>>2]|0)|0)|0;if(c[j>>2]|0){c[(c[f>>2]|0)+16>>2]=c[j>>2];c[c[f>>2]>>2]=(c[j>>2]|0)+(c[k>>2]|0);break}lz(c[f>>2]|0,138968);c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}else m=22;while(0);do if((m|0)==22){c[j>>2]=Hb[c[135760>>2]&511](c[c[f>>2]>>2]|0,c[h>>2]|0)|0;if(c[j>>2]|0){c[c[f>>2]>>2]=c[j>>2];break}lz(c[f>>2]|0,138968);c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}while(0);c[(c[f>>2]|0)+24>>2]=c[h>>2];h=c[f>>2]|0;if((c[(c[f>>2]|0)+24>>2]|0)>>>0<2147483647)c[(c[f>>2]|0)+8>>2]=c[h+24>>2];else c[h+8>>2]=2147483647;h=c[f>>2]|0;if((c[(c[f>>2]|0)+20>>2]|0)>>>0<2147483647)c[(c[f>>2]|0)+4>>2]=c[h+20>>2];else c[h+4>>2]=2147483647;c[e>>2]=(c[(c[f>>2]|0)+24>>2]|0)-(c[(c[f>>2]|0)+20>>2]|0);l=c[e>>2]|0;i=d;return l|0}c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}function nz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;ce(29,7e3,0,0,c[f>>2]|0);if(!(c[e>>2]|0)){i=d;return}if(c[(c[e>>2]|0)+32>>2]|0){i=d;return}c[(c[e>>2]|0)+32>>2]=7e3;i=d;return}function oz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(!(c[g>>2]|0)){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}if((c[(c[g>>2]|0)+40>>2]|0)==0?(c[(c[g>>2]|0)+8>>2]|0)==0:0){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}c[k>>2]=Cb[c[135744>>2]&511](92)|0;if(!(c[k>>2]|0)){Qz(0,139048);c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}d=(c[k>>2]|0)+0|0;b=d+92|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(b|0));c[(c[k>>2]|0)+64>>2]=0;c[(c[k>>2]|0)+56>>2]=0;c[(c[k>>2]|0)+4>>2]=1;c[(c[k>>2]|0)+32>>2]=0;c[(c[k>>2]|0)+36>>2]=0;c[(c[k>>2]|0)+40>>2]=0;c[c[k>>2]>>2]=0;c[(c[k>>2]|0)+8>>2]=c[g>>2];if(!(c[(c[g>>2]|0)+40>>2]|0))c[(c[k>>2]|0)+20>>2]=c[c[(c[g>>2]|0)+8>>2]>>2];c[(c[k>>2]|0)+24>>2]=0;c[(c[k>>2]|0)+28>>2]=0;c[(c[k>>2]|0)+12>>2]=c[h>>2];c[(c[k>>2]|0)+16>>2]=c[j>>2];do if((c[(c[g>>2]|0)+20>>2]|0)>0){j=Cb[c[135744>>2]&511](c[(c[g>>2]|0)+20>>2]<<2<<1)|0;c[(c[k>>2]|0)+44>>2]=j;if(c[(c[k>>2]|0)+44>>2]|0){cU(c[(c[k>>2]|0)+44>>2]|0,0,c[(c[g>>2]|0)+20>>2]<<2<<1|0)|0;c[(c[k>>2]|0)+84>>2]=(c[(c[k>>2]|0)+44>>2]|0)+(c[(c[g>>2]|0)+20>>2]<<2);break}Qz(0,139048);zb[c[135736>>2]&511](c[k>>2]|0);c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}else{c[(c[k>>2]|0)+44>>2]=0;c[(c[k>>2]|0)+84>>2]=0}while(0);c[(c[k>>2]|0)+48>>2]=0;c[(c[k>>2]|0)+52>>2]=0;c[(c[k>>2]|0)+68>>2]=0;c[(c[k>>2]|0)+72>>2]=-1;c[(c[k>>2]|0)+80>>2]=0;c[(c[k>>2]|0)+88>>2]=0;c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}function pz(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+40>>2]|0){a:do if(c[(c[d>>2]|0)+44>>2]|0){c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[(c[d>>2]|0)+32>>2]|0))break a;if(c[(c[(c[d>>2]|0)+40>>2]|0)+(c[e>>2]<<4)+12>>2]|0)zb[c[135736>>2]&511](c[(c[(c[d>>2]|0)+40>>2]|0)+(c[e>>2]<<4)+12>>2]|0);c[e>>2]=(c[e>>2]|0)+1}}while(0);zb[c[135736>>2]&511](c[(c[d>>2]|0)+40>>2]|0)}if(c[(c[d>>2]|0)+44>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+44>>2]|0);if(c[(c[d>>2]|0)+68>>2]|0){c[f>>2]=0;while(1){if((c[f>>2]|0)>=(c[(c[d>>2]|0)+52>>2]|0))break;if(c[(c[(c[d>>2]|0)+68>>2]|0)+(c[f>>2]<<3)>>2]|0)zb[c[135736>>2]&511](c[(c[(c[d>>2]|0)+68>>2]|0)+(c[f>>2]<<3)>>2]|0);c[f>>2]=(c[f>>2]|0)+1}zb[c[135736>>2]&511](c[(c[d>>2]|0)+68>>2]|0)}if(c[(c[d>>2]|0)+80>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+80>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function qz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=Rz(c[f>>2]|0,c[g>>2]|0,c[h>>2]|0,0)|0;i=e;return d|0}function rz(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+192|0;h=g+32|0;j=g+28|0;k=g+24|0;l=g+20|0;m=g+16|0;n=g+36|0;o=g+12|0;p=g+8|0;q=g+4|0;r=g;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;if(!(c[j>>2]|0)){c[h>>2]=-1;s=c[h>>2]|0;i=g;return s|0}if(!(c[(c[j>>2]|0)+8>>2]|0)){c[h>>2]=-1;s=c[h>>2]|0;i=g;return s|0}if(c[c[j>>2]>>2]|0){c[h>>2]=c[c[j>>2]>>2];s=c[h>>2]|0;i=g;return s|0}if(!(c[l>>2]|0)){c[h>>2]=qz(c[j>>2]|0,c[k>>2]|0,c[m>>2]|0)|0;s=c[h>>2]|0;i=g;return s|0}c[o>>2]=ZT(c[l>>2]|0)|0;c[p>>2]=ZT(c[k>>2]|0)|0;if(150<((c[o>>2]|0)+(c[p>>2]|0)+2|0)){c[r>>2]=Cb[c[135752>>2]&511]((c[o>>2]|0)+(c[p>>2]|0)+2|0)|0;if(!(c[r>>2]|0)){c[c[j>>2]>>2]=-1;c[h>>2]=-1;s=c[h>>2]|0;i=g;return s|0}}else c[r>>2]=n;eU(c[r>>2]|0,c[k>>2]|0,c[p>>2]|0)|0;a[(c[r>>2]|0)+(c[p>>2]|0)>>0]=124;eU((c[r>>2]|0)+((c[p>>2]|0)+1)|0,c[l>>2]|0,c[o>>2]|0)|0;a[(c[r>>2]|0)+((c[o>>2]|0)+(c[p>>2]|0)+1)>>0]=0;p=c[j>>2]|0;if(c[(c[(c[j>>2]|0)+8>>2]|0)+40>>2]|0)c[q>>2]=Sz(p,c[(c[j>>2]|0)+8>>2]|0,c[r>>2]|0,c[m>>2]|0)|0;else c[q>>2]=Rz(p,c[r>>2]|0,c[m>>2]|0,1)|0;if((c[r>>2]|0)!=(n|0))zb[c[135736>>2]&511](c[r>>2]|0);c[h>>2]=c[q>>2];s=c[h>>2]|0;i=g;return s|0}function sz(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+32|0;h=g+16|0;j=g+12|0;k=g+8|0;l=g+4|0;m=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;f=Tz(c[h>>2]|0,0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0)|0;i=g;return f|0}function tz(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+32|0;j=h+24|0;k=h+20|0;l=h+16|0;m=h+12|0;n=h+8|0;o=h+4|0;p=h;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;if(!(c[k>>2]|0)){c[j>>2]=-1;q=c[j>>2]|0;i=h;return q|0}do if(c[l>>2]|0)if(c[c[k>>2]>>2]|0){c[c[l>>2]>>2]=c[(c[k>>2]|0)+80>>2];break}else{c[c[l>>2]>>2]=0;break}while(0);c[j>>2]=Tz(c[k>>2]|0,1,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0)|0;q=c[j>>2]|0;i=h;return q|0}function uz(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[f>>2]=a;c[h>>2]=Uz(c[f>>2]|0)|0;if(!(c[h>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=b;return j|0}c[(c[h>>2]|0)+20>>2]=0;f=Vz(c[h>>2]|0)|0;c[(c[h>>2]|0)+24>>2]=f;c[(c[h>>2]|0)+16>>2]=f;Wz(c[h>>2]|0,c[(c[h>>2]|0)+16>>2]|0)|0;Xz(c[h>>2]|0,1);if(d[c[(c[h>>2]|0)+4>>2]>>0]|0){c[(c[h>>2]|0)+8>>2]=1450;Yz(c[h>>2]|0,139080)}f=c[h>>2]|0;if(c[(c[h>>2]|0)+8>>2]|0){Zz(f);c[e>>2]=0;j=c[e>>2]|0;i=b;return j|0}c[(c[h>>2]|0)+20>>2]=c[f+24>>2];c[c[(c[h>>2]|0)+16>>2]>>2]=1;c[c[(c[h>>2]|0)+20>>2]>>2]=2;_z(c[h>>2]|0);f=c[h>>2]|0;if(c[(c[h>>2]|0)+8>>2]|0){Zz(f);c[e>>2]=0;j=c[e>>2]|0;i=b;return j|0}else{c[g>>2]=$z(f)|0;Zz(c[h>>2]|0);c[e>>2]=c[g>>2];j=c[e>>2]|0;i=b;return j|0}return 0}function vz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}else{c[e>>2]=aA(c[f>>2]|0,c[g>>2]|0)|0;h=c[e>>2]|0;i=d;return h|0}return 0}function wz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;d=b+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[e>>2]=a;if(!(c[e>>2]|0)){c[d>>2]=-1;j=c[d>>2]|0;i=b;return j|0}if((c[(c[e>>2]|0)+28>>2]|0)!=-1){c[d>>2]=c[(c[e>>2]|0)+28>>2];j=c[d>>2]|0;i=b;return j|0}c[f>>2]=xz()|0;if(c[(c[f>>2]|0)+52>>2]|0){c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[(c[f>>2]|0)+48>>2]|0))break;bA(c[(c[(c[f>>2]|0)+52>>2]|0)+(c[h>>2]<<2)>>2]|0);c[h>>2]=(c[h>>2]|0)+1}zb[c[135736>>2]&511](c[(c[f>>2]|0)+52>>2]|0)}c[(c[f>>2]|0)+36>>2]=c[(c[e>>2]|0)+12>>2];c[(c[f>>2]|0)+40>>2]=c[(c[e>>2]|0)+16>>2];c[(c[f>>2]|0)+48>>2]=c[(c[e>>2]|0)+4>>2];c[(c[f>>2]|0)+52>>2]=c[(c[e>>2]|0)+8>>2];c[(c[f>>2]|0)+68>>2]=-1;c[(c[f>>2]|0)+76>>2]=c[(c[e>>2]|0)+32>>2];c[g>>2]=cA(c[f>>2]|0)|0;c[(c[f>>2]|0)+40>>2]=0;c[(c[f>>2]|0)+52>>2]=0;yz(c[f>>2]|0);c[(c[e>>2]|0)+28>>2]=c[g>>2];c[d>>2]=c[g>>2];j=c[d>>2]|0;i=b;return j|0}function xz(){var a=0,b=0,d=0,e=0,f=0,g=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=Uz(0)|0;if(!(c[d>>2]|0)){c[b>>2]=0;e=c[b>>2]|0;i=a;return e|0}c[(c[d>>2]|0)+20>>2]=0;f=Vz(c[d>>2]|0)|0;c[(c[d>>2]|0)+24>>2]=f;c[(c[d>>2]|0)+16>>2]=f;f=c[d>>2]|0;if(!(c[(c[d>>2]|0)+16>>2]|0)){yz(f);c[b>>2]=0;e=c[b>>2]|0;i=a;return e|0}c[c[f+16>>2]>>2]=1;f=(Wz(c[d>>2]|0,c[(c[d>>2]|0)+16>>2]|0)|0)<0;g=c[d>>2]|0;if(f){bA(c[g+16>>2]|0);yz(c[d>>2]|0);c[b>>2]=0;e=c[b>>2]|0;i=a;return e|0}else{c[g+76>>2]=0;c[b>>2]=c[d>>2];e=c[b>>2]|0;i=a;return e|0}return 0}function yz(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}Zz(c[d>>2]|0);i=b;return}function zz(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[c[d>>2]>>2]|0)zb[c[135736>>2]&511](c[c[d>>2]>>2]|0);if(c[(c[d>>2]|0)+8>>2]|0){c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[(c[d>>2]|0)+4>>2]|0))break;bA(c[(c[(c[d>>2]|0)+8>>2]|0)+(c[e>>2]<<2)>>2]|0);c[e>>2]=(c[e>>2]|0)+1}zb[c[135736>>2]&511](c[(c[d>>2]|0)+8>>2]|0)}if(c[(c[d>>2]|0)+16>>2]|0){c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[(c[d>>2]|0)+12>>2]|0))break;dA(c[(c[(c[d>>2]|0)+16>>2]|0)+(c[e>>2]<<2)>>2]|0);c[e>>2]=(c[e>>2]|0)+1}zb[c[135736>>2]&511](c[(c[d>>2]|0)+16>>2]|0)}if(c[(c[d>>2]|0)+24>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+24>>2]|0);if(c[(c[d>>2]|0)+40>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+40>>2]|0);if(c[(c[d>>2]|0)+44>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+44>>2]|0);if(c[(c[d>>2]|0)+52>>2]|0){c[e>>2]=0;while(1){f=c[33934]|0;if((c[e>>2]|0)>=(c[(c[d>>2]|0)+48>>2]|0))break;zb[f&511](c[(c[(c[d>>2]|0)+52>>2]|0)+(c[e>>2]<<2)>>2]|0);c[e>>2]=(c[e>>2]|0)+1}zb[f&511](c[(c[d>>2]|0)+52>>2]|0)}zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function Az(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}b=(c[e>>2]|0)+76|0;c[b>>2]=c[b>>2]|c[f>>2];i=d;return}function Bz(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;if(!(c[e>>2]|0))c[d>>2]=0;else c[d>>2]=c[(c[e>>2]|0)+16>>2];i=b;return c[d>>2]|0}function Cz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}else{c[c[g>>2]>>2]=2;c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}return 0}function Dz(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+32|0;h=g+24|0;j=g+20|0;k=g+16|0;l=g+12|0;m=g+8|0;n=g+4|0;o=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;if((c[j>>2]|0)==0|(c[k>>2]|0)==0|(c[m>>2]|0)==0){c[h>>2]=0;p=c[h>>2]|0;i=g;return p|0}c[o>>2]=eA(c[j>>2]|0,5)|0;if(!(c[o>>2]|0)){c[h>>2]=0;p=c[h>>2]|0;i=g;return p|0}c[(c[o>>2]|0)+60>>2]=c[n>>2];n=my(c[m>>2]|0)|0;c[(c[o>>2]|0)+20>>2]=n;if((fA(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,c[o>>2]|0)|0)<0){dA(c[o>>2]|0);c[h>>2]=0;p=c[h>>2]|0;i=g;return p|0}if(!(c[l>>2]|0)){c[h>>2]=c[(c[j>>2]|0)+24>>2];p=c[h>>2]|0;i=g;return p|0}else{c[h>>2]=c[l>>2];p=c[h>>2]|0;i=g;return p|0}return 0}function Ez(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;k=i;i=i+48|0;l=k+40|0;m=k+36|0;n=k+32|0;o=k+28|0;p=k+24|0;q=k+20|0;r=k+16|0;s=k+12|0;t=k+8|0;u=k+4|0;v=k;c[m>>2]=b;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=h;c[r>>2]=j;if((c[m>>2]|0)==0|(c[n>>2]|0)==0|(c[p>>2]|0)==0){c[l>>2]=0;w=c[l>>2]|0;i=k;return w|0}c[s>>2]=eA(c[m>>2]|0,5)|0;if(!(c[s>>2]|0)){c[l>>2]=0;w=c[l>>2]|0;i=k;return w|0}c[(c[s>>2]|0)+60>>2]=c[r>>2];do if((c[q>>2]|0)!=0?(d[c[q>>2]>>0]|0|0)!=0:0){c[t>>2]=ZT(c[q>>2]|0)|0;c[u>>2]=ZT(c[p>>2]|0)|0;c[v>>2]=Cb[c[135752>>2]&511]((c[t>>2]|0)+(c[u>>2]|0)+2|0)|0;if(c[v>>2]|0){eU(c[v>>2]|0,c[p>>2]|0,c[u>>2]|0)|0;a[(c[v>>2]|0)+(c[u>>2]|0)>>0]=124;eU((c[v>>2]|0)+((c[u>>2]|0)+1)|0,c[q>>2]|0,c[t>>2]|0)|0;a[(c[v>>2]|0)+((c[t>>2]|0)+(c[u>>2]|0)+1)>>0]=0;c[(c[s>>2]|0)+20>>2]=c[v>>2];break}dA(c[s>>2]|0);c[l>>2]=0;w=c[l>>2]|0;i=k;return w|0}else x=7;while(0);if((x|0)==7){x=my(c[p>>2]|0)|0;c[(c[s>>2]|0)+20>>2]=x}if((fA(c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[s>>2]|0)|0)<0){dA(c[s>>2]|0);c[l>>2]=0;w=c[l>>2]|0;i=k;return w|0}if(!(c[o>>2]|0)){c[l>>2]=c[(c[m>>2]|0)+24>>2];w=c[l>>2]|0;i=k;return w|0}else{c[l>>2]=c[o>>2];w=c[l>>2]|0;i=k;return w|0}return 0}function Fz(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;k=i;i=i+256|0;l=k;m=k+44|0;n=k+40|0;o=k+36|0;p=k+32|0;q=k+28|0;r=k+24|0;s=k+20|0;t=k+16|0;u=k+48|0;v=k+12|0;w=k+8|0;x=k+4|0;c[n>>2]=b;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;c[r>>2]=h;c[s>>2]=j;if((c[n>>2]|0)==0|(c[o>>2]|0)==0|(c[q>>2]|0)==0){c[m>>2]=0;y=c[m>>2]|0;i=k;return y|0}c[t>>2]=eA(c[n>>2]|0,5)|0;if(!(c[t>>2]|0)){c[m>>2]=0;y=c[m>>2]|0;i=k;return y|0}c[(c[t>>2]|0)+60>>2]=c[s>>2];c[(c[t>>2]|0)+28>>2]=1;do if((c[r>>2]|0)!=0?(d[c[r>>2]>>0]|0|0)!=0:0){c[v>>2]=ZT(c[r>>2]|0)|0;c[w>>2]=ZT(c[q>>2]|0)|0;c[x>>2]=Cb[c[135752>>2]&511]((c[v>>2]|0)+(c[w>>2]|0)+2|0)|0;if(c[x>>2]|0){eU(c[x>>2]|0,c[q>>2]|0,c[w>>2]|0)|0;a[(c[x>>2]|0)+(c[w>>2]|0)>>0]=124;eU((c[x>>2]|0)+((c[w>>2]|0)+1)|0,c[r>>2]|0,c[v>>2]|0)|0;a[(c[x>>2]|0)+((c[v>>2]|0)+(c[w>>2]|0)+1)>>0]=0;c[(c[t>>2]|0)+20>>2]=c[x>>2];break}dA(c[t>>2]|0);c[m>>2]=0;y=c[m>>2]|0;i=k;return y|0}else z=7;while(0);if((z|0)==7){z=my(c[q>>2]|0)|0;c[(c[t>>2]|0)+20>>2]=z}c[l>>2]=c[(c[t>>2]|0)+20>>2];JT(u,199,139120,l)|0;a[u+199>>0]=0;l=my(u)|0;c[(c[t>>2]|0)+24>>2]=l;if((fA(c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[t>>2]|0)|0)<0){dA(c[t>>2]|0);c[m>>2]=0;y=c[m>>2]|0;i=k;return y|0}t=(c[n>>2]|0)+72|0;c[t>>2]=(c[t>>2]|0)+1;if(!(c[p>>2]|0)){c[m>>2]=c[(c[n>>2]|0)+24>>2];y=c[m>>2]|0;i=k;return y|0}else{c[m>>2]=c[p>>2];y=c[m>>2]|0;i=k;return y|0}return 0}function Gz(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;m=i;i=i+64|0;n=m+52|0;o=m+48|0;p=m+44|0;q=m+40|0;r=m+36|0;s=m+32|0;t=m+28|0;u=m+24|0;v=m+20|0;w=m+16|0;x=m+12|0;y=m+8|0;z=m+4|0;A=m;c[o>>2]=b;c[p>>2]=e;c[q>>2]=f;c[r>>2]=g;c[s>>2]=h;c[t>>2]=j;c[u>>2]=k;c[v>>2]=l;if((c[o>>2]|0)==0|(c[p>>2]|0)==0|(c[r>>2]|0)==0){c[n>>2]=0;B=c[n>>2]|0;i=m;return B|0}if((c[t>>2]|0)<0){c[n>>2]=0;B=c[n>>2]|0;i=m;return B|0}if((c[u>>2]|0)<1?1:(c[u>>2]|0)<(c[t>>2]|0)){c[n>>2]=0;B=c[n>>2]|0;i=m;return B|0}c[w>>2]=eA(c[o>>2]|0,5)|0;if(!(c[w>>2]|0)){c[n>>2]=0;B=c[n>>2]|0;i=m;return B|0}do if((c[s>>2]|0)!=0?(d[c[s>>2]>>0]|0|0)!=0:0){c[y>>2]=ZT(c[s>>2]|0)|0;c[z>>2]=ZT(c[r>>2]|0)|0;c[A>>2]=Cb[c[135752>>2]&511]((c[y>>2]|0)+(c[z>>2]|0)+2|0)|0;if(c[A>>2]|0){eU(c[A>>2]|0,c[r>>2]|0,c[z>>2]|0)|0;a[(c[A>>2]|0)+(c[z>>2]|0)>>0]=124;eU((c[A>>2]|0)+((c[z>>2]|0)+1)|0,c[s>>2]|0,c[y>>2]|0)|0;a[(c[A>>2]|0)+((c[y>>2]|0)+(c[z>>2]|0)+1)>>0]=0;c[(c[w>>2]|0)+20>>2]=c[A>>2];break}dA(c[w>>2]|0);c[n>>2]=0;B=c[n>>2]|0;i=m;return B|0}else C=11;while(0);if((C|0)==11){C=my(c[r>>2]|0)|0;c[(c[w>>2]|0)+20>>2]=C}c[(c[w>>2]|0)+60>>2]=c[v>>2];if(!(c[t>>2]|0))c[(c[w>>2]|0)+12>>2]=1;else c[(c[w>>2]|0)+12>>2]=c[t>>2];c[(c[w>>2]|0)+16>>2]=c[u>>2];c[x>>2]=gA(c[o>>2]|0)|0;c[(c[(c[o>>2]|0)+64>>2]|0)+(c[x>>2]<<3)>>2]=c[t>>2];c[(c[(c[o>>2]|0)+64>>2]|0)+(c[x>>2]<<3)+4>>2]=c[u>>2];if(!(c[q>>2]|0)){c[q>>2]=Vz(c[o>>2]|0)|0;Wz(c[o>>2]|0,c[q>>2]|0)|0}hA(c[o>>2]|0,c[p>>2]|0,c[w>>2]|0,c[q>>2]|0,c[x>>2]|0,-1);iA(c[o>>2]|0,c[w>>2]|0)|0;c[(c[o>>2]|0)+24>>2]=c[q>>2];if(!(c[q>>2]|0))c[q>>2]=c[(c[o>>2]|0)+24>>2];if(!(c[q>>2]|0)){c[n>>2]=0;B=c[n>>2]|0;i=m;return B|0}if(!(c[t>>2]|0))jA(c[o>>2]|0,c[p>>2]|0,c[q>>2]|0);c[n>>2]=c[q>>2];B=c[n>>2]|0;i=m;return B|0}function Hz(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;m=i;i=i+64|0;n=m+52|0;o=m+48|0;p=m+44|0;q=m+40|0;r=m+36|0;s=m+32|0;t=m+28|0;u=m+24|0;v=m+20|0;w=m+16|0;x=m+12|0;y=m+8|0;z=m+4|0;A=m;c[o>>2]=b;c[p>>2]=e;c[q>>2]=f;c[r>>2]=g;c[s>>2]=h;c[t>>2]=j;c[u>>2]=k;c[v>>2]=l;if((c[o>>2]|0)==0|(c[p>>2]|0)==0|(c[r>>2]|0)==0){c[n>>2]=0;B=c[n>>2]|0;i=m;return B|0}if((c[t>>2]|0)<1){c[n>>2]=0;B=c[n>>2]|0;i=m;return B|0}if((c[u>>2]|0)<1?1:(c[u>>2]|0)<(c[t>>2]|0)){c[n>>2]=0;B=c[n>>2]|0;i=m;return B|0}c[w>>2]=eA(c[o>>2]|0,5)|0;if(!(c[w>>2]|0)){c[n>>2]=0;B=c[n>>2]|0;i=m;return B|0}do if((c[s>>2]|0)!=0?(d[c[s>>2]>>0]|0|0)!=0:0){c[y>>2]=ZT(c[s>>2]|0)|0;c[z>>2]=ZT(c[r>>2]|0)|0;c[A>>2]=Cb[c[135752>>2]&511]((c[y>>2]|0)+(c[z>>2]|0)+2|0)|0;if(c[A>>2]|0){eU(c[A>>2]|0,c[r>>2]|0,c[z>>2]|0)|0;a[(c[A>>2]|0)+(c[z>>2]|0)>>0]=124;eU((c[A>>2]|0)+((c[z>>2]|0)+1)|0,c[s>>2]|0,c[y>>2]|0)|0;a[(c[A>>2]|0)+((c[y>>2]|0)+(c[z>>2]|0)+1)>>0]=0;c[(c[w>>2]|0)+20>>2]=c[A>>2];break}dA(c[w>>2]|0);c[n>>2]=0;B=c[n>>2]|0;i=m;return B|0}else C=11;while(0);if((C|0)==11){C=my(c[r>>2]|0)|0;c[(c[w>>2]|0)+20>>2]=C}c[(c[w>>2]|0)+60>>2]=c[v>>2];c[(c[w>>2]|0)+8>>2]=6;c[(c[w>>2]|0)+12>>2]=c[t>>2];c[(c[w>>2]|0)+16>>2]=c[u>>2];c[x>>2]=gA(c[o>>2]|0)|0;c[(c[(c[o>>2]|0)+64>>2]|0)+(c[x>>2]<<3)>>2]=1;c[(c[(c[o>>2]|0)+64>>2]|0)+(c[x>>2]<<3)+4>>2]=1;if(!(c[q>>2]|0)){c[q>>2]=Vz(c[o>>2]|0)|0;Wz(c[o>>2]|0,c[q>>2]|0)|0}hA(c[o>>2]|0,c[p>>2]|0,c[w>>2]|0,c[q>>2]|0,c[x>>2]|0,-1);iA(c[o>>2]|0,c[w>>2]|0)|0;c[(c[o>>2]|0)+24>>2]=c[q>>2];c[n>>2]=c[q>>2];B=c[n>>2]|0;i=m;return B|0}function Iz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if(!(c[e>>2]|0)){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{c[f>>2]=Vz(c[e>>2]|0)|0;Wz(c[e>>2]|0,c[f>>2]|0)|0;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function Jz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if((c[g>>2]|0)==0|(c[h>>2]|0)==0){c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}jA(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0);if(!(c[j>>2]|0)){c[f>>2]=c[(c[g>>2]|0)+24>>2];k=c[f>>2]|0;i=e;return k|0}else{c[f>>2]=c[j>>2];k=c[f>>2]|0;i=e;return k|0}return 0}function Kz(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if((c[h>>2]|0)==0|(c[j>>2]|0)==0){c[g>>2]=0;m=c[g>>2]|0;i=f;return m|0}kA(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0);if(!(c[k>>2]|0)){c[g>>2]=c[(c[h>>2]|0)+24>>2];m=c[g>>2]|0;i=f;return m|0}else{c[g>>2]=c[k>>2];m=c[g>>2]|0;i=f;return m|0}return 0}function Lz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(!(c[g>>2]|0)){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}c[k>>2]=gA(c[g>>2]|0)|0;if((c[k>>2]|0)<0){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}else{c[(c[(c[g>>2]|0)+64>>2]|0)+(c[k>>2]<<3)>>2]=c[h>>2];c[(c[(c[g>>2]|0)+64>>2]|0)+(c[k>>2]<<3)+4>>2]=c[j>>2];c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}return 0}function Mz(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if((c[h>>2]|0)==0|(c[j>>2]|0)==0|(c[l>>2]|0)<0){c[g>>2]=0;m=c[g>>2]|0;i=f;return m|0}lA(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0);if(!(c[k>>2]|0)){c[g>>2]=c[(c[h>>2]|0)+24>>2];m=c[g>>2]|0;i=f;return m|0}else{c[g>>2]=c[k>>2];m=c[g>>2]|0;i=f;return m|0}return 0}function Nz(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if((c[h>>2]|0)==0|(c[j>>2]|0)==0|(c[l>>2]|0)<0){c[g>>2]=0;m=c[g>>2]|0;i=f;return m|0}mA(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0);if(!(c[k>>2]|0)){c[g>>2]=c[(c[h>>2]|0)+24>>2];m=c[g>>2]|0;i=f;return m|0}else{c[g>>2]=c[k>>2];m=c[g>>2]|0;i=f;return m|0}return 0}function Oz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+8>>2]|0)==0:0){_z(c[e>>2]|0);c[f>>2]=$z(c[e>>2]|0)|0;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}function Pz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if(!(c[e>>2]|0)){c[d>>2]=-1;g=c[d>>2]|0;i=b;return g|0}else{c[f>>2]=cA(c[e>>2]|0)|0;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function Qz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=d+12|0;g=d+8|0;h=d+4|0;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;if(c[f>>2]|0){c[h>>2]=c[c[f>>2]>>2];c[(c[f>>2]|0)+8>>2]=2}f=c[g>>2]|0;b=c[h>>2]|0;c[e>>2]=c[g>>2];Xd(0,0,0,0,0,14,2,3,0,0,f,b,0,0,0,140264,e);i=d;return}function Rz(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;f=i;i=i+112|0;g=f;h=f+100|0;j=f+96|0;k=f+92|0;l=f+88|0;m=f+84|0;n=f+80|0;p=f+76|0;q=f+72|0;r=f+68|0;s=f+64|0;t=f+60|0;u=f+56|0;v=f+52|0;w=f+48|0;x=f+44|0;y=f+40|0;z=f+36|0;A=f+32|0;B=f+28|0;C=f+24|0;D=f+20|0;E=f+16|0;F=f+12|0;G=f+8|0;H=f+4|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[r>>2]=0;c[s>>2]=1;if(!(c[j>>2]|0)){c[h>>2]=-1;I=c[h>>2]|0;i=f;return I|0}if(!(c[(c[j>>2]|0)+8>>2]|0)){c[h>>2]=-1;I=c[h>>2]|0;i=f;return I|0}e=c[j>>2]|0;if(c[c[j>>2]>>2]|0){c[h>>2]=c[e>>2];I=c[h>>2]|0;i=f;return I|0}if(c[(c[e+8>>2]|0)+40>>2]|0){c[h>>2]=Sz(c[j>>2]|0,c[(c[j>>2]|0)+8>>2]|0,c[k>>2]|0,c[l>>2]|0)|0;I=c[h>>2]|0;i=f;return I|0}do if(!(c[k>>2]|0)){if((c[c[(c[j>>2]|0)+20>>2]>>2]|0)!=2){c[r>>2]=1;break}c[h>>2]=1;I=c[h>>2]|0;i=f;return I|0}while(0);if((c[k>>2]|0)!=0?(c[(c[j>>2]|0)+52>>2]|0)>0:0){nA(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0);c[k>>2]=c[(c[(c[j>>2]|0)+68>>2]|0)+(c[(c[j>>2]|0)+56>>2]<<3)>>2];c[l>>2]=c[(c[(c[j>>2]|0)+68>>2]|0)+(c[(c[j>>2]|0)+56>>2]<<3)+4>>2]}a:while(1){if(c[c[j>>2]>>2]|0)break;if(!(c[k>>2]|0)){if((c[r>>2]|0)!=1)break;if((c[c[(c[j>>2]|0)+20>>2]>>2]|0)==2)break}if(!((c[k>>2]|0)==0?(c[(c[j>>2]|0)+44>>2]|0)==0:0))J=22;b:do if((J|0)==22){J=0;c[(c[j>>2]|0)+28>>2]=0;c:while(1){if((c[(c[j>>2]|0)+24>>2]|0)>=(c[(c[(c[j>>2]|0)+20>>2]|0)+24>>2]|0))break;c[n>>2]=(c[(c[(c[j>>2]|0)+20>>2]|0)+28>>2]|0)+((c[(c[j>>2]|0)+24>>2]|0)*20|0);if((c[(c[n>>2]|0)+4>>2]|0)>=0){c[p>>2]=c[c[n>>2]>>2];c[q>>2]=0;d:do if((c[(c[n>>2]|0)+12>>2]|0)==1193047){c[q>>2]=0;if((c[k>>2]|0)==0&(c[r>>2]|0)!=0){c[q>>2]=1;break}if(c[k>>2]|0){c[t>>2]=0;e:while(1){if((c[t>>2]|0)>=(c[(c[(c[j>>2]|0)+20>>2]|0)+24>>2]|0))break d;c[v>>2]=(c[(c[(c[j>>2]|0)+20>>2]|0)+28>>2]|0)+((c[t>>2]|0)*20|0);do if((c[(c[v>>2]|0)+8>>2]|0)>=0){if((c[v>>2]|0)==(c[n>>2]|0))break;c[w>>2]=(c[(c[(c[j>>2]|0)+8>>2]|0)+24>>2]|0)+(c[(c[v>>2]|0)+8>>2]<<3);c[u>>2]=c[(c[(c[j>>2]|0)+44>>2]|0)+(c[(c[v>>2]|0)+8>>2]<<2)>>2];do if((c[u>>2]|0)<(c[(c[w>>2]|0)+4>>2]|0)){if(!(c[c[v>>2]>>2]|0))break;if(qy(c[k>>2]|0,c[(c[c[v>>2]>>2]|0)+20>>2]|0)|0){J=36;break e}}while(0);if((c[u>>2]|0)<(c[c[w>>2]>>2]|0))break;if((c[u>>2]|0)>=(c[(c[w>>2]|0)+4>>2]|0))break;if(!(c[c[v>>2]>>2]|0))break;if(qy(c[k>>2]|0,c[(c[c[v>>2]>>2]|0)+20>>2]|0)|0){J=41;break e}}while(0);c[t>>2]=(c[t>>2]|0)+1}if((J|0)==36){J=0;c[q>>2]=0;break}else if((J|0)==41){J=0;c[q>>2]=1;break}}}else{if((c[(c[n>>2]|0)+12>>2]|0)==1193046){c[q>>2]=1;c[x>>2]=0;f:while(1){if((c[x>>2]|0)>=(c[(c[(c[j>>2]|0)+20>>2]|0)+24>>2]|0))break d;c[z>>2]=(c[(c[(c[j>>2]|0)+20>>2]|0)+28>>2]|0)+((c[x>>2]|0)*20|0);do if((c[(c[z>>2]|0)+8>>2]|0)>=0){if((c[z>>2]|0)==(c[n>>2]|0))break;c[A>>2]=(c[(c[(c[j>>2]|0)+8>>2]|0)+24>>2]|0)+(c[(c[z>>2]|0)+8>>2]<<3);c[y>>2]=c[(c[(c[j>>2]|0)+44>>2]|0)+(c[(c[z>>2]|0)+8>>2]<<2)>>2];if((c[y>>2]|0)<(c[c[A>>2]>>2]|0))break f;if((c[y>>2]|0)>(c[(c[A>>2]|0)+4>>2]|0))break f}while(0);c[x>>2]=(c[x>>2]|0)+1}c[q>>2]=0;break}if((c[(c[n>>2]|0)+12>>2]|0)>=0){c[B>>2]=c[(c[(c[j>>2]|0)+44>>2]|0)+(c[(c[n>>2]|0)+12>>2]<<2)>>2];c[C>>2]=(c[(c[(c[j>>2]|0)+8>>2]|0)+24>>2]|0)+(c[(c[n>>2]|0)+12>>2]<<3);if((c[B>>2]|0)>=(c[c[C>>2]>>2]|0))K=(c[B>>2]|0)<=(c[(c[C>>2]|0)+4>>2]|0);else K=0;c[q>>2]=K&1;break}if(!(c[p>>2]|0)){J=57;break c}if(!(c[k>>2]|0))break;c[q>>2]=oA(c[(c[p>>2]|0)+20>>2]|0,c[k>>2]|0)|0;if(c[(c[p>>2]|0)+28>>2]|0){e=((c[q>>2]|0)!=0^1)&1;c[q>>2]=e;c[q>>2]=(c[m>>2]|0)!=0?e:0}do if((c[q>>2]|0)==1){if((c[(c[n>>2]|0)+8>>2]|0)<0)break;c[E>>2]=c[(c[(c[j>>2]|0)+44>>2]|0)+(c[(c[n>>2]|0)+8>>2]<<2)>>2];c[D>>2]=(c[(c[(c[j>>2]|0)+8>>2]|0)+24>>2]|0)+(c[(c[n>>2]|0)+8>>2]<<3);if((c[E>>2]|0)<(c[(c[D>>2]|0)+4>>2]|0))break;c[q>>2]=0}while(0);if((c[q>>2]|0)!=1)break;if((c[(c[p>>2]|0)+12>>2]|0)<=0)break;if((c[(c[p>>2]|0)+16>>2]|0)<=0)break;c[F>>2]=c[(c[(c[(c[j>>2]|0)+8>>2]|0)+8>>2]|0)+(c[(c[n>>2]|0)+4>>2]<<2)>>2];if((c[(c[(c[j>>2]|0)+20>>2]|0)+24>>2]|0)>((c[(c[j>>2]|0)+24>>2]|0)+1|0)){if((c[(c[j>>2]|0)+52>>2]|0)<=0)nA(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0);pA(c[j>>2]|0)}c[(c[j>>2]|0)+28>>2]=1;do{if((c[(c[j>>2]|0)+28>>2]|0)==(c[(c[p>>2]|0)+16>>2]|0))break;e=(c[j>>2]|0)+56|0;c[e>>2]=(c[e>>2]|0)+1;c[k>>2]=c[(c[(c[j>>2]|0)+68>>2]|0)+(c[(c[j>>2]|0)+56>>2]<<3)>>2];c[l>>2]=c[(c[(c[j>>2]|0)+68>>2]|0)+(c[(c[j>>2]|0)+56>>2]<<3)+4>>2];L=c[j>>2]|0;if(!(c[k>>2]|0)){J=75;break}if((c[L+28>>2]|0)>=(c[(c[p>>2]|0)+12>>2]|0)){c[G>>2]=c[(c[j>>2]|0)+24>>2];c[H>>2]=c[(c[j>>2]|0)+20>>2];c[(c[j>>2]|0)+24>>2]=-1;c[(c[j>>2]|0)+20>>2]=c[F>>2];if((c[(c[j>>2]|0)+52>>2]|0)<=0)nA(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0);pA(c[j>>2]|0);c[(c[j>>2]|0)+24>>2]=c[G>>2];c[(c[j>>2]|0)+20>>2]=c[H>>2]}c[q>>2]=qy(c[k>>2]|0,c[(c[p>>2]|0)+20>>2]|0)|0;e=(c[j>>2]|0)+28|0;c[e>>2]=(c[e>>2]|0)+1}while((c[q>>2]|0)==1);if((J|0)==75){J=0;e=L+56|0;c[e>>2]=(c[e>>2]|0)+-1}if((c[(c[j>>2]|0)+28>>2]|0)<(c[(c[p>>2]|0)+12>>2]|0))c[q>>2]=0;if((c[q>>2]|0)<0)c[q>>2]=0;if(!(c[q>>2]|0))break b}while(0);if((c[q>>2]|0)==1){J=87;break}if((c[q>>2]|0)<0){J=110;break}}e=(c[j>>2]|0)+24|0;c[e>>2]=(c[e>>2]|0)+1}if((J|0)==57){J=0;Ka(c[o>>2]|0,139424,g|0)|0;c[c[j>>2]>>2]=-2}else if((J|0)==87){J=0;if(((c[p>>2]|0)!=0?(c[(c[j>>2]|0)+12>>2]|0)!=0:0)&(c[l>>2]|0)!=0)Jb[c[(c[j>>2]|0)+12>>2]&511](c[(c[j>>2]|0)+16>>2]|0,c[(c[p>>2]|0)+20>>2]|0,c[(c[p>>2]|0)+60>>2]|0,c[l>>2]|0);if((c[(c[(c[j>>2]|0)+20>>2]|0)+24>>2]|0)>((c[(c[j>>2]|0)+24>>2]|0)+1|0)){if((c[(c[j>>2]|0)+52>>2]|0)<=0)nA(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0);pA(c[j>>2]|0)}if((c[(c[n>>2]|0)+8>>2]|0)>=0){e=(c[(c[j>>2]|0)+44>>2]|0)+(c[(c[n>>2]|0)+8>>2]<<2)|0;c[e>>2]=(c[e>>2]|0)+1}if((c[(c[n>>2]|0)+12>>2]|0)>=0?(c[(c[n>>2]|0)+12>>2]|0)<1193046:0)c[(c[(c[j>>2]|0)+44>>2]|0)+(c[(c[n>>2]|0)+12>>2]<<2)>>2]=0;if((c[(c[(c[(c[j>>2]|0)+8>>2]|0)+8>>2]|0)+(c[(c[n>>2]|0)+4>>2]<<2)>>2]|0)!=0?(c[c[(c[(c[(c[j>>2]|0)+8>>2]|0)+8>>2]|0)+(c[(c[n>>2]|0)+4>>2]<<2)>>2]>>2]|0)==4:0){if(c[(c[j>>2]|0)+80>>2]|0)zb[c[135736>>2]&511](c[(c[j>>2]|0)+80>>2]|0);e=my(c[k>>2]|0)|0;c[(c[j>>2]|0)+80>>2]=e;c[(c[j>>2]|0)+76>>2]=c[(c[j>>2]|0)+20>>2];eU(c[(c[j>>2]|0)+84>>2]|0,c[(c[j>>2]|0)+44>>2]|0,c[(c[(c[j>>2]|0)+8>>2]|0)+20>>2]<<2|0)|0;
}c[(c[j>>2]|0)+20>>2]=c[(c[(c[(c[j>>2]|0)+8>>2]|0)+8>>2]|0)+(c[(c[n>>2]|0)+4>>2]<<2)>>2];c[(c[j>>2]|0)+24>>2]=0;do if(c[c[n>>2]>>2]|0){if(!(c[(c[j>>2]|0)+68>>2]|0)){c[k>>2]=0;c[l>>2]=0;break}e=(c[j>>2]|0)+56|0;c[e>>2]=(c[e>>2]|0)+1;if((c[(c[j>>2]|0)+56>>2]|0)<(c[(c[j>>2]|0)+52>>2]|0)){c[k>>2]=c[(c[(c[j>>2]|0)+68>>2]|0)+(c[(c[j>>2]|0)+56>>2]<<3)>>2];c[l>>2]=c[(c[(c[j>>2]|0)+68>>2]|0)+(c[(c[j>>2]|0)+56>>2]<<3)+4>>2];break}else{c[k>>2]=0;c[l>>2]=0;break}}while(0);c[s>>2]=1;continue a}else if((J|0)==110){J=0;c[c[j>>2]>>2]=-4}if((c[(c[j>>2]|0)+24>>2]|0)==0?(c[(c[(c[j>>2]|0)+20>>2]|0)+24>>2]|0)!=0:0)continue a}while(0);if(((c[s>>2]|0)!=0?(c[(c[j>>2]|0)+20>>2]|0)!=0:0)?(c[c[(c[j>>2]|0)+20>>2]>>2]|0)!=4:0){c[s>>2]=0;if(c[(c[j>>2]|0)+80>>2]|0)zb[c[135736>>2]&511](c[(c[j>>2]|0)+80>>2]|0);e=my(c[k>>2]|0)|0;c[(c[j>>2]|0)+80>>2]=e;c[(c[j>>2]|0)+76>>2]=c[(c[j>>2]|0)+20>>2];eU(c[(c[j>>2]|0)+84>>2]|0,c[(c[j>>2]|0)+44>>2]|0,c[(c[(c[j>>2]|0)+8>>2]|0)+20>>2]<<2|0)|0}c[(c[j>>2]|0)+4>>2]=0;qA(c[j>>2]|0);if(!(c[(c[j>>2]|0)+68>>2]|0))continue;if(c[c[j>>2]>>2]|0)continue;c[k>>2]=c[(c[(c[j>>2]|0)+68>>2]|0)+(c[(c[j>>2]|0)+56>>2]<<3)>>2];c[l>>2]=c[(c[(c[j>>2]|0)+68>>2]|0)+(c[(c[j>>2]|0)+56>>2]<<3)+4>>2]}l=c[j>>2]|0;if(!(c[c[j>>2]>>2]|0)){c[h>>2]=(c[c[l+20>>2]>>2]|0)==2&1;I=c[h>>2]|0;i=f;return I|0}else{c[h>>2]=c[l>>2];I=c[h>>2]|0;i=f;return I|0}return 0}function Sz(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+32|0;g=f+28|0;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f+4|0;o=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=c[(c[h>>2]|0)+56>>2];if(((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+40>>2]|0)!=0:0)?(c[(c[j>>2]|0)+52>>2]|0)!=0:0){if(!(c[k>>2]|0)){e=ca(c[m>>2]|0,(c[(c[j>>2]|0)+48>>2]|0)+1|0)|0;if((c[(c[(c[j>>2]|0)+40>>2]|0)+(e<<2)>>2]|0)==2){c[g>>2]=1;p=c[g>>2]|0;i=f;return p|0}else{c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}}c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[(c[j>>2]|0)+48>>2]|0))break;e=ca(c[m>>2]|0,(c[(c[j>>2]|0)+48>>2]|0)+1|0)|0;c[o>>2]=c[(c[(c[j>>2]|0)+40>>2]|0)+(e+(c[n>>2]|0)+1<<2)>>2];if(((c[o>>2]|0)>0?(c[o>>2]|0)<=(c[(c[j>>2]|0)+36>>2]|0):0)?(c[o>>2]=(c[o>>2]|0)+-1,(oA(c[(c[(c[j>>2]|0)+52>>2]|0)+(c[n>>2]<<2)>>2]|0,c[k>>2]|0)|0)!=0):0){q=14;break}c[n>>2]=(c[n>>2]|0)+1}if((q|0)==14){c[(c[h>>2]|0)+56>>2]=c[o>>2];if((c[(c[h>>2]|0)+12>>2]|0)!=0?(c[(c[j>>2]|0)+44>>2]|0)!=0:0){q=ca(c[m>>2]|0,c[(c[j>>2]|0)+48>>2]|0)|0;Jb[c[(c[h>>2]|0)+12>>2]&511](c[(c[h>>2]|0)+16>>2]|0,c[k>>2]|0,c[(c[(c[j>>2]|0)+44>>2]|0)+(q+(c[n>>2]|0)<<2)>>2]|0,c[l>>2]|0)}l=ca(c[o>>2]|0,(c[(c[j>>2]|0)+48>>2]|0)+1|0)|0;if((c[(c[(c[j>>2]|0)+40>>2]|0)+(l<<2)>>2]|0)!=4){l=ca(c[o>>2]|0,(c[(c[j>>2]|0)+48>>2]|0)+1|0)|0;if((c[(c[(c[j>>2]|0)+40>>2]|0)+(l<<2)>>2]|0)==2){c[g>>2]=1;p=c[g>>2]|0;i=f;return p|0}else{c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}}}if(c[(c[h>>2]|0)+80>>2]|0)zb[c[135736>>2]&511](c[(c[h>>2]|0)+80>>2]|0);l=my(c[k>>2]|0)|0;c[(c[h>>2]|0)+80>>2]=l;c[(c[h>>2]|0)+72>>2]=c[m>>2];c[c[h>>2]>>2]=-1;c[g>>2]=-1;p=c[g>>2]|0;i=f;return p|0}c[g>>2]=-1;p=c[g>>2]|0;i=f;return p|0}function Tz(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=i;i=i+96|0;j=h;k=h+80|0;l=h+76|0;m=h+72|0;n=h+68|0;o=h+64|0;p=h+60|0;q=h+56|0;r=h+52|0;s=h+48|0;t=h+44|0;u=h+40|0;v=h+36|0;w=h+32|0;x=h+28|0;y=h+24|0;z=h+20|0;A=h+16|0;B=h+12|0;C=h+8|0;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;c[s>>2]=0;if(!((c[l>>2]|0)==0|(c[n>>2]|0)==0|(c[o>>2]|0)==0|(c[p>>2]|0)==0)?(c[c[n>>2]>>2]|0)>0:0){c[r>>2]=c[c[n>>2]>>2];c[c[n>>2]>>2]=0;c[c[o>>2]>>2]=0;a:do if((c[(c[l>>2]|0)+8>>2]|0)!=0?(c[(c[(c[l>>2]|0)+8>>2]|0)+40>>2]|0)!=0:0){c[t>>2]=c[(c[l>>2]|0)+8>>2];g=c[l>>2]|0;do if(c[m>>2]|0){if((c[g+72>>2]|0)!=-1){c[w>>2]=c[(c[l>>2]|0)+72>>2];break}c[k>>2]=-1;D=c[k>>2]|0;i=h;return D|0}else c[w>>2]=c[g+56>>2];while(0);do if(c[q>>2]|0){g=ca(c[w>>2]|0,(c[(c[t>>2]|0)+48>>2]|0)+1|0)|0;f=c[q>>2]|0;if((c[(c[(c[t>>2]|0)+40>>2]|0)+(g<<2)>>2]|0)==2){c[f>>2]=1;break}else{c[f>>2]=0;break}}while(0);c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[(c[t>>2]|0)+48>>2]|0))break;if((c[s>>2]|0)>=(c[r>>2]|0))break;f=ca(c[w>>2]|0,(c[(c[t>>2]|0)+48>>2]|0)+1|0)|0;c[u>>2]=c[(c[(c[t>>2]|0)+40>>2]|0)+(f+(c[v>>2]|0)+1<<2)>>2];if(((c[u>>2]|0)>0?(c[u>>2]|0)<=(c[(c[t>>2]|0)+36>>2]|0):0)?(f=ca((c[u>>2]|0)-1|0,(c[(c[t>>2]|0)+48>>2]|0)+1|0)|0,(c[(c[(c[t>>2]|0)+40>>2]|0)+(f<<2)>>2]|0)!=4):0){f=c[(c[(c[t>>2]|0)+52>>2]|0)+(c[v>>2]<<2)>>2]|0;g=c[s>>2]|0;c[s>>2]=g+1;c[(c[p>>2]|0)+(g<<2)>>2]=f;f=c[n>>2]|0;c[f>>2]=(c[f>>2]|0)+1}c[v>>2]=(c[v>>2]|0)+1}c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[(c[t>>2]|0)+48>>2]|0))break a;if((c[s>>2]|0)>=(c[r>>2]|0))break a;f=ca(c[w>>2]|0,(c[(c[t>>2]|0)+48>>2]|0)+1|0)|0;c[u>>2]=c[(c[(c[t>>2]|0)+40>>2]|0)+(f+(c[v>>2]|0)+1<<2)>>2];if(((c[u>>2]|0)>0?(c[u>>2]|0)<=(c[(c[t>>2]|0)+36>>2]|0):0)?(f=ca((c[u>>2]|0)-1|0,(c[(c[t>>2]|0)+48>>2]|0)+1|0)|0,(c[(c[(c[t>>2]|0)+40>>2]|0)+(f<<2)>>2]|0)==4):0){f=c[(c[(c[t>>2]|0)+52>>2]|0)+(c[v>>2]<<2)>>2]|0;g=c[s>>2]|0;c[s>>2]=g+1;c[(c[p>>2]|0)+(g<<2)>>2]=f;f=c[o>>2]|0;c[f>>2]=(c[f>>2]|0)+1}c[v>>2]=(c[v>>2]|0)+1}}else E=31;while(0);b:do if((E|0)==31){do if(c[q>>2]|0){v=c[q>>2]|0;if((c[c[(c[l>>2]|0)+20>>2]>>2]|0)==2){c[v>>2]=1;break}else{c[v>>2]=0;break}}while(0);v=c[l>>2]|0;do if(c[m>>2]|0){if(c[v+76>>2]|0){c[A>>2]=c[(c[l>>2]|0)+76>>2];break}c[k>>2]=-1;D=c[k>>2]|0;i=h;return D|0}else{if(c[v+20>>2]|0){c[A>>2]=c[(c[l>>2]|0)+20>>2];break}c[k>>2]=-1;D=c[k>>2]|0;i=h;return D|0}while(0);c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[(c[A>>2]|0)+24>>2]|0))break;if((c[s>>2]|0)>=(c[r>>2]|0))break;c[y>>2]=(c[(c[A>>2]|0)+28>>2]|0)+((c[x>>2]|0)*20|0);do if(((c[(c[y>>2]|0)+4>>2]|0)>=0?(c[z>>2]=c[c[y>>2]>>2],(c[z>>2]|0)!=0):0)?(c[(c[z>>2]|0)+20>>2]|0)!=0:0){if((c[(c[y>>2]|0)+12>>2]|0)==1193047){v=c[33976]|0;t=c[33980]|0;c[j>>2]=140216;c[j+4>>2]=4289;Db[v&511](t,140184,j);break}if((c[(c[y>>2]|0)+12>>2]|0)==1193046){t=c[33976]|0;v=c[33980]|0;c[j>>2]=140216;c[j+4>>2]=4292;Db[t&511](v,140184,j);break}if((c[(c[y>>2]|0)+8>>2]|0)<0){if(!(c[(c[l>>2]|0)+8>>2]|0))break;if(!(c[(c[(c[(c[l>>2]|0)+8>>2]|0)+8>>2]|0)+(c[(c[y>>2]|0)+4>>2]<<2)>>2]|0))break;if((c[c[(c[(c[(c[l>>2]|0)+8>>2]|0)+8>>2]|0)+(c[(c[y>>2]|0)+4>>2]<<2)>>2]>>2]|0)==4)break;v=c[z>>2]|0;if(c[(c[z>>2]|0)+28>>2]|0){t=c[v+24>>2]|0;u=c[s>>2]|0;c[s>>2]=u+1;c[(c[p>>2]|0)+(u<<2)>>2]=t}else{t=c[v+20>>2]|0;v=c[s>>2]|0;c[s>>2]=v+1;c[(c[p>>2]|0)+(v<<2)>>2]=t}t=c[n>>2]|0;c[t>>2]=(c[t>>2]|0)+1;break}c[B>>2]=0;t=c[(c[y>>2]|0)+8>>2]|0;v=c[l>>2]|0;if(c[m>>2]|0)c[C>>2]=c[(c[v+84>>2]|0)+(t<<2)>>2];else c[C>>2]=c[(c[v+44>>2]|0)+(t<<2)>>2];if(c[(c[l>>2]|0)+8>>2]|0)c[B>>2]=(c[(c[(c[l>>2]|0)+8>>2]|0)+24>>2]|0)+(c[(c[y>>2]|0)+8>>2]<<3);if((c[B>>2]|0)!=0?(c[C>>2]|0)>=(c[(c[B>>2]|0)+4>>2]|0):0)break;t=c[z>>2]|0;if(c[(c[z>>2]|0)+28>>2]|0){v=c[t+24>>2]|0;u=c[s>>2]|0;c[s>>2]=u+1;c[(c[p>>2]|0)+(u<<2)>>2]=v}else{v=c[t+20>>2]|0;t=c[s>>2]|0;c[s>>2]=t+1;c[(c[p>>2]|0)+(t<<2)>>2]=v}v=c[n>>2]|0;c[v>>2]=(c[v>>2]|0)+1}while(0);c[x>>2]=(c[x>>2]|0)+1}c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[(c[A>>2]|0)+24>>2]|0))break b;if((c[s>>2]|0)>=(c[r>>2]|0))break b;c[y>>2]=(c[(c[A>>2]|0)+28>>2]|0)+((c[x>>2]|0)*20|0);if((((((((c[(c[y>>2]|0)+4>>2]|0)>=0?(c[z>>2]=c[c[y>>2]>>2],(c[z>>2]|0)!=0):0)?(c[(c[z>>2]|0)+20>>2]|0)!=0:0)?(c[(c[y>>2]|0)+12>>2]|0)!=1193047:0)?(c[(c[y>>2]|0)+12>>2]|0)!=1193046:0)?(c[(c[y>>2]|0)+8>>2]|0)<0:0)?(c[(c[(c[(c[l>>2]|0)+8>>2]|0)+8>>2]|0)+(c[(c[y>>2]|0)+4>>2]<<2)>>2]|0)!=0:0)?(c[c[(c[(c[(c[l>>2]|0)+8>>2]|0)+8>>2]|0)+(c[(c[y>>2]|0)+4>>2]<<2)>>2]>>2]|0)==4:0){v=c[z>>2]|0;if(c[(c[z>>2]|0)+28>>2]|0){t=c[v+24>>2]|0;u=c[s>>2]|0;c[s>>2]=u+1;c[(c[p>>2]|0)+(u<<2)>>2]=t}else{t=c[v+20>>2]|0;v=c[s>>2]|0;c[s>>2]=v+1;c[(c[p>>2]|0)+(v<<2)>>2]=t}t=c[o>>2]|0;c[t>>2]=(c[t>>2]|0)+1}c[x>>2]=(c[x>>2]|0)+1}}while(0);c[k>>2]=0;D=c[k>>2]|0;i=h;return D|0}c[k>>2]=-1;D=c[k>>2]|0;i=h;return D|0}function Uz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](80)|0;if(!(c[f>>2]|0)){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}a=(c[f>>2]|0)+0|0;h=a+80|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(h|0));if(c[e>>2]|0){a=my(c[e>>2]|0)|0;c[c[f>>2]>>2]=a}c[(c[f>>2]|0)+4>>2]=c[c[f>>2]>>2];c[(c[f>>2]|0)+12>>2]=0;c[(c[f>>2]|0)+72>>2]=0;c[(c[f>>2]|0)+8>>2]=0;c[(c[f>>2]|0)+68>>2]=-1;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}function Vz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](44)|0;if(!(c[f>>2]|0)){Qz(c[e>>2]|0,140160);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{e=(c[f>>2]|0)+0|0;a=e+44|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(a|0));c[c[f>>2]>>2]=3;c[(c[f>>2]|0)+4>>2]=0;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function Wz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if(!(c[g>>2]|0)){c[e>>2]=-1;j=c[e>>2]|0;i=d;return j|0}b=c[f>>2]|0;do if(!(c[(c[f>>2]|0)+44>>2]|0)){c[b+44>>2]=4;a=Cb[c[135744>>2]&511](c[(c[f>>2]|0)+44>>2]<<2)|0;c[(c[f>>2]|0)+52>>2]=a;if(!(c[(c[f>>2]|0)+52>>2]|0)){Qz(c[f>>2]|0,140144);c[(c[f>>2]|0)+44>>2]=0;c[e>>2]=-1;j=c[e>>2]|0;i=d;return j|0}}else if((c[b+48>>2]|0)>=(c[(c[f>>2]|0)+44>>2]|0)){a=(c[f>>2]|0)+44|0;c[a>>2]=c[a>>2]<<1;c[h>>2]=Hb[c[135760>>2]&511](c[(c[f>>2]|0)+52>>2]|0,c[(c[f>>2]|0)+44>>2]<<2)|0;if(c[h>>2]|0){c[(c[f>>2]|0)+52>>2]=c[h>>2];break}Qz(c[f>>2]|0,140144);a=(c[f>>2]|0)+44|0;c[a>>2]=(c[a>>2]|0)/2|0;c[e>>2]=-1;j=c[e>>2]|0;i=d;return j|0}while(0);c[(c[g>>2]|0)+16>>2]=c[(c[f>>2]|0)+48>>2];h=c[g>>2]|0;g=(c[f>>2]|0)+48|0;b=c[g>>2]|0;c[g>>2]=b+1;c[(c[(c[f>>2]|0)+52>>2]|0)+(b<<2)>>2]=h;c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}function Xz(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=c[(c[f>>2]|0)+24>>2];c[(c[f>>2]|0)+20>>2]=0;rA(c[f>>2]|0,0)|0;if(c[g>>2]|0)c[c[(c[f>>2]|0)+24>>2]>>2]=2;b=c[(c[f>>2]|0)+24>>2]|0;if((d[c[(c[f>>2]|0)+4>>2]>>0]|0|0)!=124){c[(c[f>>2]|0)+20>>2]=b;i=e;return}c[j>>2]=b;while(1){if((d[c[(c[f>>2]|0)+4>>2]>>0]|0|0)!=124)break;if(c[(c[f>>2]|0)+8>>2]|0)break;b=(c[f>>2]|0)+4|0;c[b>>2]=(c[b>>2]|0)+1;if(!(d[c[(c[f>>2]|0)+4>>2]>>0]|0)){k=9;break}c[(c[f>>2]|0)+24>>2]=c[h>>2];c[(c[f>>2]|0)+20>>2]=0;rA(c[f>>2]|0,c[j>>2]|0)|0}if((k|0)==9){c[(c[f>>2]|0)+8>>2]=1450;Yz(c[f>>2]|0,139560);i=e;return}if(c[g>>2]|0){i=e;return}c[(c[f>>2]|0)+24>>2]=c[j>>2];c[(c[f>>2]|0)+20>>2]=c[j>>2];i=e;return}function Yz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;c[j>>2]=0;if(c[f>>2]|0){c[h>>2]=c[c[f>>2]>>2];c[j>>2]=(c[(c[f>>2]|0)+4>>2]|0)-(c[c[f>>2]>>2]|0);c[(c[f>>2]|0)+8>>2]=1450}f=c[g>>2]|0;b=c[h>>2]|0;h=c[j>>2]|0;c[e>>2]=c[g>>2];Xd(0,0,0,0,0,14,1450,3,0,0,f,b,0,h,0,139536,e);i=d;return}function Zz(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[c[d>>2]>>2]|0)zb[c[135736>>2]&511](c[c[d>>2]>>2]|0);if(c[(c[d>>2]|0)+52>>2]|0){c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[(c[d>>2]|0)+48>>2]|0))break;bA(c[(c[(c[d>>2]|0)+52>>2]|0)+(c[e>>2]<<2)>>2]|0);c[e>>2]=(c[e>>2]|0)+1}zb[c[135736>>2]&511](c[(c[d>>2]|0)+52>>2]|0)}if(c[(c[d>>2]|0)+40>>2]|0){c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[(c[d>>2]|0)+36>>2]|0))break;dA(c[(c[(c[d>>2]|0)+40>>2]|0)+(c[e>>2]<<2)>>2]|0);c[e>>2]=(c[e>>2]|0)+1}zb[c[135736>>2]&511](c[(c[d>>2]|0)+40>>2]|0)}if(c[(c[d>>2]|0)+64>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+64>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function _z(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=b+32|0;e=b+28|0;f=b+24|0;g=b+20|0;h=b+16|0;j=b+12|0;k=b+8|0;l=b+4|0;m=b;c[d>>2]=a;if(!(c[(c[d>>2]|0)+52>>2]|0)){i=b;return}sA(c[d>>2]|0);c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[(c[d>>2]|0)+48>>2]|0))break;c[g>>2]=c[(c[(c[d>>2]|0)+52>>2]|0)+(c[e>>2]<<2)>>2];if((c[g>>2]|0)!=0?(c[c[g>>2]>>2]|0)==5:0){bA(c[g>>2]|0);c[(c[(c[d>>2]|0)+52>>2]|0)+(c[e>>2]<<2)>>2]=0}c[e>>2]=(c[e>>2]|0)+1}c[h>>2]=0;c[e>>2]=(c[(c[d>>2]|0)+48>>2]|0)-1;while(1){if((c[e>>2]|0)<0)break;c[g>>2]=c[(c[(c[d>>2]|0)+52>>2]|0)+(c[e>>2]<<2)>>2];a:do if(c[g>>2]|0){if((c[(c[g>>2]|0)+24>>2]|0)==0?(c[c[g>>2]>>2]|0)!=2:0)c[c[g>>2]>>2]=4;c[f>>2]=0;while(1){if((c[f>>2]|0)>=(c[(c[g>>2]|0)+24>>2]|0))break a;do if((c[(c[(c[g>>2]|0)+28>>2]|0)+((c[f>>2]|0)*20|0)>>2]|0)==0?(c[(c[(c[g>>2]|0)+28>>2]|0)+((c[f>>2]|0)*20|0)+4>>2]|0)>=0:0){a=(c[(c[g>>2]|0)+28>>2]|0)+((c[f>>2]|0)*20|0)|0;if((c[(c[(c[g>>2]|0)+28>>2]|0)+((c[f>>2]|0)*20|0)+4>>2]|0)==(c[e>>2]|0)){c[a+4>>2]=-1;break}if((c[a+12>>2]|0)<0){c[j>>2]=c[(c[(c[g>>2]|0)+28>>2]|0)+((c[f>>2]|0)*20|0)+4>>2];c[h>>2]=1;c[(c[(c[g>>2]|0)+28>>2]|0)+((c[f>>2]|0)*20|0)+4>>2]=-2;c[(c[g>>2]|0)+4>>2]=1;tA(c[d>>2]|0,c[e>>2]|0,c[j>>2]|0,c[(c[(c[g>>2]|0)+28>>2]|0)+((c[f>>2]|0)*20|0)+8>>2]|0);c[(c[g>>2]|0)+4>>2]=0}}while(0);c[f>>2]=(c[f>>2]|0)+1}}while(0);c[e>>2]=(c[e>>2]|0)+-1}b:do if(c[h>>2]|0){c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[(c[d>>2]|0)+48>>2]|0))break b;c[g>>2]=c[(c[(c[d>>2]|0)+52>>2]|0)+(c[e>>2]<<2)>>2];c:do if(c[g>>2]|0){c[f>>2]=0;while(1){if((c[f>>2]|0)>=(c[(c[g>>2]|0)+24>>2]|0))break c;c[k>>2]=(c[(c[g>>2]|0)+28>>2]|0)+((c[f>>2]|0)*20|0);if(((c[c[k>>2]>>2]|0)==0?(c[(c[k>>2]|0)+12>>2]|0)<0:0)?(c[(c[k>>2]|0)+4>>2]|0)>=0:0)c[(c[k>>2]|0)+4>>2]=-1;c[f>>2]=(c[f>>2]|0)+1}}while(0);c[e>>2]=(c[e>>2]|0)+1}}while(0);c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[(c[d>>2]|0)+48>>2]|0))break;c[g>>2]=c[(c[(c[d>>2]|0)+52>>2]|0)+(c[e>>2]<<2)>>2];if(c[g>>2]|0)c[(c[g>>2]|0)+12>>2]=0;c[e>>2]=(c[e>>2]|0)+1}c[g>>2]=c[c[(c[d>>2]|0)+52>>2]>>2];if(c[g>>2]|0)c[(c[g>>2]|0)+12>>2]=1;while(1){if(!(c[g>>2]|0))break;c[l>>2]=0;c[(c[g>>2]|0)+12>>2]=2;c[f>>2]=0;while(1){if((c[f>>2]|0)>=(c[(c[g>>2]|0)+24>>2]|0))break;do if((c[(c[(c[g>>2]|0)+28>>2]|0)+((c[f>>2]|0)*20|0)+4>>2]|0)>=0){if((c[(c[(c[g>>2]|0)+28>>2]|0)+((c[f>>2]|0)*20|0)>>2]|0)==0?(c[(c[(c[g>>2]|0)+28>>2]|0)+((c[f>>2]|0)*20|0)+12>>2]|0)<0:0)break;c[m>>2]=c[(c[(c[g>>2]|0)+28>>2]|0)+((c[f>>2]|0)*20|0)+4>>2];if((c[(c[(c[d>>2]|0)+52>>2]|0)+(c[m>>2]<<2)>>2]|0)!=0?(c[(c[(c[(c[d>>2]|0)+52>>2]|0)+(c[m>>2]<<2)>>2]|0)+12>>2]|0)==0:0){c[(c[(c[(c[d>>2]|0)+52>>2]|0)+(c[m>>2]<<2)>>2]|0)+12>>2]=1;c[l>>2]=c[(c[(c[d>>2]|0)+52>>2]|0)+(c[m>>2]<<2)>>2]}}while(0);c[f>>2]=(c[f>>2]|0)+1}d:do if(!(c[l>>2]|0)){c[e>>2]=1;while(1){if((c[e>>2]|0)>=(c[(c[d>>2]|0)+48>>2]|0))break d;c[g>>2]=c[(c[(c[d>>2]|0)+52>>2]|0)+(c[e>>2]<<2)>>2];if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+12>>2]|0)==1:0)break;c[e>>2]=(c[e>>2]|0)+1}c[l>>2]=c[g>>2]}while(0);c[g>>2]=c[l>>2]}c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[(c[d>>2]|0)+48>>2]|0))break;c[g>>2]=c[(c[(c[d>>2]|0)+52>>2]|0)+(c[e>>2]<<2)>>2];if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+12>>2]|0)==0:0){bA(c[g>>2]|0);c[(c[(c[d>>2]|0)+52>>2]|0)+(c[e>>2]<<2)>>2]=0}c[e>>2]=(c[e>>2]|0)+1}i=b;return}function $z(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;b=i;i=i+80|0;d=b+72|0;e=b+68|0;f=b+64|0;g=b+60|0;h=b+56|0;j=b+52|0;k=b+48|0;l=b+44|0;m=b+40|0;n=b+36|0;o=b+32|0;p=b+28|0;q=b+24|0;r=b+20|0;s=b+16|0;t=b+12|0;u=b+8|0;v=b+4|0;w=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](56)|0;if(!(c[f>>2]|0)){Qz(c[e>>2]|0,139512);c[d>>2]=0;x=c[d>>2]|0;i=b;return x|0}a=(c[f>>2]|0)+0|0;y=a+56|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(y|0));c[c[f>>2]>>2]=c[c[e>>2]>>2];c[(c[f>>2]|0)+4>>2]=c[(c[e>>2]|0)+48>>2];c[(c[f>>2]|0)+8>>2]=c[(c[e>>2]|0)+52>>2];c[(c[f>>2]|0)+12>>2]=c[(c[e>>2]|0)+36>>2];c[(c[f>>2]|0)+16>>2]=c[(c[e>>2]|0)+40>>2];c[(c[f>>2]|0)+20>>2]=c[(c[e>>2]|0)+60>>2];c[(c[f>>2]|0)+24>>2]=c[(c[e>>2]|0)+64>>2];c[(c[f>>2]|0)+28>>2]=c[(c[e>>2]|0)+68>>2];c[(c[f>>2]|0)+32>>2]=c[(c[e>>2]|0)+76>>2];if((c[(c[f>>2]|0)+28>>2]|0)==-1)wz(c[f>>2]|0)|0;do if((((((c[(c[f>>2]|0)+28>>2]|0)!=0?(c[(c[f>>2]|0)+20>>2]|0)==0:0)?(c[(c[e>>2]|0)+72>>2]|0)==0:0)?(c[(c[f>>2]|0)+16>>2]|0)!=0:0)?(c[c[(c[f>>2]|0)+16>>2]>>2]|0)!=0:0)?(c[(c[c[(c[f>>2]|0)+16>>2]>>2]|0)+4>>2]|0)==5:0){c[j>>2]=0;c[k>>2]=0;c[l>>2]=Cb[c[135744>>2]&511](c[(c[f>>2]|0)+4>>2]<<2)|0;if(!(c[l>>2]|0)){Qz(c[e>>2]|0,139512);zb[c[135736>>2]&511](c[f>>2]|0);c[d>>2]=0;x=c[d>>2]|0;i=b;return x|0}c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[(c[f>>2]|0)+4>>2]|0))break;if(c[(c[(c[f>>2]|0)+8>>2]|0)+(c[g>>2]<<2)>>2]|0){c[(c[l>>2]|0)+(c[g>>2]<<2)>>2]=c[j>>2];c[j>>2]=(c[j>>2]|0)+1}else c[(c[l>>2]|0)+(c[g>>2]<<2)>>2]=-1;c[g>>2]=(c[g>>2]|0)+1}c[p>>2]=Cb[c[135744>>2]&511](c[(c[f>>2]|0)+12>>2]<<2)|0;if(!(c[p>>2]|0)){Qz(c[e>>2]|0,139512);zb[c[135736>>2]&511](c[l>>2]|0);zb[c[135736>>2]&511](c[f>>2]|0);c[d>>2]=0;x=c[d>>2]|0;i=b;return x|0}c[m>>2]=Cb[c[135744>>2]&511](c[(c[f>>2]|0)+12>>2]<<2)|0;if(!(c[m>>2]|0)){Qz(c[e>>2]|0,139512);zb[c[135736>>2]&511](c[p>>2]|0);zb[c[135736>>2]&511](c[l>>2]|0);zb[c[135736>>2]&511](c[f>>2]|0);c[d>>2]=0;x=c[d>>2]|0;i=b;return x|0}c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[(c[f>>2]|0)+12>>2]|0)){z=44;break}if((c[(c[(c[(c[f>>2]|0)+16>>2]|0)+(c[g>>2]<<2)>>2]|0)+4>>2]|0)!=5){z=39;break}if((c[(c[(c[(c[f>>2]|0)+16>>2]|0)+(c[g>>2]<<2)>>2]|0)+8>>2]|0)!=2){z=39;break}c[q>>2]=c[(c[(c[(c[f>>2]|0)+16>>2]|0)+(c[g>>2]<<2)>>2]|0)+20>>2];c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[k>>2]|0))break;a=(qy(c[(c[p>>2]|0)+(c[h>>2]<<2)>>2]|0,c[q>>2]|0)|0)!=0;A=c[h>>2]|0;if(a){z=30;break}c[h>>2]=A+1}if((z|0)==30){z=0;c[(c[m>>2]|0)+(c[g>>2]<<2)>>2]=A}if((c[h>>2]|0)>=(c[k>>2]|0)){c[(c[m>>2]|0)+(c[g>>2]<<2)>>2]=c[k>>2];a=my(c[q>>2]|0)|0;c[(c[p>>2]|0)+(c[k>>2]<<2)>>2]=a;if(!(c[(c[p>>2]|0)+(c[k>>2]<<2)>>2]|0)){z=34;break}c[k>>2]=(c[k>>2]|0)+1}c[g>>2]=(c[g>>2]|0)+1}if((z|0)==34){c[g>>2]=0;while(1){B=c[33934]|0;if((c[g>>2]|0)>=(c[k>>2]|0))break;zb[B&511](c[(c[p>>2]|0)+(c[g>>2]<<2)>>2]|0);c[g>>2]=(c[g>>2]|0)+1}zb[B&511](c[m>>2]|0);zb[c[135736>>2]&511](c[p>>2]|0);zb[c[135736>>2]&511](c[l>>2]|0);zb[c[135736>>2]&511](c[f>>2]|0);c[d>>2]=0;x=c[d>>2]|0;i=b;return x|0}else if((z|0)==39){zb[c[135736>>2]&511](c[l>>2]|0);zb[c[135736>>2]&511](c[m>>2]|0);c[g>>2]=0;while(1){C=c[33934]|0;if((c[g>>2]|0)>=(c[k>>2]|0))break;zb[C&511](c[(c[p>>2]|0)+(c[g>>2]<<2)>>2]|0);c[g>>2]=(c[g>>2]|0)+1}zb[C&511](c[p>>2]|0);zb[c[135736>>2]&511](c[f>>2]|0);c[d>>2]=0;x=c[d>>2]|0;i=b;return x|0}else if((z|0)==44){a=(ca((c[j>>2]|0)+1|0,(c[k>>2]|0)+1|0)|0)<<2;c[n>>2]=Cb[c[135744>>2]&511](a)|0;if(!(c[n>>2]|0)){zb[c[135736>>2]&511](c[l>>2]|0);zb[c[135736>>2]&511](c[m>>2]|0);zb[c[135736>>2]&511](c[p>>2]|0);zb[c[135736>>2]&511](c[f>>2]|0);c[d>>2]=0;x=c[d>>2]|0;i=b;return x|0}cU(c[n>>2]|0,0,(ca((c[j>>2]|0)+1|0,(c[k>>2]|0)+1|0)|0)<<2|0)|0;c[o>>2]=0;c[g>>2]=0;a:while(1){if((c[g>>2]|0)>=(c[(c[f>>2]|0)+4>>2]|0))break;c[r>>2]=c[(c[l>>2]|0)+(c[g>>2]<<2)>>2];b:do if((c[r>>2]|0)!=-1){c[v>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+(c[g>>2]<<2)>>2];a=ca(c[r>>2]|0,(c[k>>2]|0)+1|0)|0;c[(c[n>>2]|0)+(a<<2)>>2]=c[c[v>>2]>>2];c[h>>2]=0;c:while(1){if((c[h>>2]|0)>=(c[(c[v>>2]|0)+24>>2]|0))break b;c[w>>2]=(c[(c[v>>2]|0)+28>>2]|0)+((c[h>>2]|0)*20|0);do if((c[(c[w>>2]|0)+4>>2]|0)!=-1){if(!(c[c[w>>2]>>2]|0))break;c[s>>2]=c[(c[m>>2]|0)+(c[c[c[w>>2]>>2]>>2]<<2)>>2];if((c[o>>2]|0)==0?(c[(c[c[w>>2]>>2]|0)+60>>2]|0)!=0:0){a=(ca(c[j>>2]|0,c[k>>2]|0)|0)<<2;c[o>>2]=Cb[c[135744>>2]&511](a)|0;if(!(c[o>>2]|0))break c;cU(c[o>>2]|0,0,(ca(c[j>>2]|0,c[k>>2]|0)|0)<<2|0)|0}c[t>>2]=c[(c[l>>2]|0)+(c[(c[w>>2]|0)+4>>2]<<2)>>2];a=ca(c[r>>2]|0,(c[k>>2]|0)+1|0)|0;c[u>>2]=c[(c[n>>2]|0)+(a+(c[s>>2]|0)+1<<2)>>2];if(c[u>>2]|0)if((c[u>>2]|0)!=((c[t>>2]|0)+1|0)){z=59;break a}else break;a=ca(c[r>>2]|0,(c[k>>2]|0)+1|0)|0;c[(c[n>>2]|0)+(a+(c[s>>2]|0)+1<<2)>>2]=(c[t>>2]|0)+1;if(!(c[o>>2]|0))break;a=ca(c[r>>2]|0,c[k>>2]|0)|0;c[(c[o>>2]|0)+(a+(c[s>>2]|0)<<2)>>2]=c[(c[c[w>>2]>>2]|0)+60>>2]}while(0);c[h>>2]=(c[h>>2]|0)+1}Qz(c[e>>2]|0,139512)}while(0);c[g>>2]=(c[g>>2]|0)+1}if((z|0)==59){c[(c[f>>2]|0)+28>>2]=0;if(c[o>>2]|0)zb[c[135736>>2]&511](c[o>>2]|0);zb[c[135736>>2]&511](c[n>>2]|0);zb[c[135736>>2]&511](c[l>>2]|0);zb[c[135736>>2]&511](c[m>>2]|0);c[g>>2]=0;while(1){D=c[33934]|0;if((c[g>>2]|0)>=(c[k>>2]|0))break;zb[D&511](c[(c[p>>2]|0)+(c[g>>2]<<2)>>2]|0);c[g>>2]=(c[g>>2]|0)+1}zb[D&511](c[p>>2]|0);break}c[(c[f>>2]|0)+28>>2]=1;if(c[(c[f>>2]|0)+8>>2]|0){c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[(c[f>>2]|0)+4>>2]|0))break;bA(c[(c[(c[f>>2]|0)+8>>2]|0)+(c[g>>2]<<2)>>2]|0);c[g>>2]=(c[g>>2]|0)+1}zb[c[135736>>2]&511](c[(c[f>>2]|0)+8>>2]|0)}c[(c[f>>2]|0)+8>>2]=0;c[(c[f>>2]|0)+4>>2]=0;if(c[(c[f>>2]|0)+16>>2]|0){c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[(c[f>>2]|0)+12>>2]|0))break;dA(c[(c[(c[f>>2]|0)+16>>2]|0)+(c[g>>2]<<2)>>2]|0);c[g>>2]=(c[g>>2]|0)+1}zb[c[135736>>2]&511](c[(c[f>>2]|0)+16>>2]|0)}c[(c[f>>2]|0)+16>>2]=0;c[(c[f>>2]|0)+12>>2]=0;c[(c[f>>2]|0)+40>>2]=c[n>>2];c[(c[f>>2]|0)+44>>2]=c[o>>2];c[(c[f>>2]|0)+52>>2]=c[p>>2];c[(c[f>>2]|0)+48>>2]=c[k>>2];c[(c[f>>2]|0)+36>>2]=c[j>>2];zb[c[135736>>2]&511](c[l>>2]|0);zb[c[135736>>2]&511](c[m>>2]|0);break}}while(0);c[c[e>>2]>>2]=0;c[(c[e>>2]|0)+48>>2]=0;c[(c[e>>2]|0)+52>>2]=0;c[(c[e>>2]|0)+36>>2]=0;c[(c[e>>2]|0)+40>>2]=0;c[(c[e>>2]|0)+60>>2]=0;c[(c[e>>2]|0)+64>>2]=0;c[d>>2]=c[f>>2];x=c[d>>2]|0;i=b;return x|0}function aA(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=i;i=i+176|0;f=e;g=e+164|0;h=e+160|0;j=e+156|0;k=e+60|0;l=e+56|0;m=e+52|0;n=e+48|0;p=e+44|0;q=e+40|0;r=e+36|0;s=e+32|0;t=e+28|0;u=e+24|0;v=e+20|0;w=e+16|0;x=e+12|0;y=e+8|0;z=e+4|0;c[h>>2]=a;c[j>>2]=b;c[k>>2]=e+64;c[m>>2]=0;c[(c[k>>2]|0)+64>>2]=c[j>>2];c[(c[k>>2]|0)+56>>2]=0;c[(c[k>>2]|0)+88>>2]=0;c[(c[k>>2]|0)+4>>2]=1;c[(c[k>>2]|0)+32>>2]=0;c[(c[k>>2]|0)+36>>2]=0;c[(c[k>>2]|0)+40>>2]=0;c[c[k>>2]>>2]=0;c[(c[k>>2]|0)+8>>2]=c[h>>2];c[(c[k>>2]|0)+20>>2]=c[c[(c[h>>2]|0)+8>>2]>>2];c[(c[k>>2]|0)+24>>2]=0;c[(c[k>>2]|0)+28>>2]=0;c[(c[k>>2]|0)+68>>2]=0;c[(c[k>>2]|0)+48>>2]=0;do if((c[(c[h>>2]|0)+20>>2]|0)>0){j=Cb[c[135744>>2]&511](c[(c[h>>2]|0)+20>>2]<<2)|0;c[(c[k>>2]|0)+44>>2]=j;if(c[(c[k>>2]|0)+44>>2]|0){cU(c[(c[k>>2]|0)+44>>2]|0,0,c[(c[h>>2]|0)+20>>2]<<2|0)|0;break}Qz(0,139408);c[g>>2]=-1;A=c[g>>2]|0;i=e;return A|0}else c[(c[k>>2]|0)+44>>2]=0;while(0);a:while(1){if(c[c[k>>2]>>2]|0)break;if(!(c[(c[k>>2]|0)+20>>2]|0))break;if(!(d[(c[(c[k>>2]|0)+64>>2]|0)+(c[(c[k>>2]|0)+56>>2]|0)>>0]|0)){if(!(c[(c[k>>2]|0)+20>>2]|0))break;if((c[c[(c[k>>2]|0)+20>>2]>>2]|0)==2)break}c[n>>2]=1;if((d[(c[(c[k>>2]|0)+64>>2]|0)+(c[(c[k>>2]|0)+56>>2]|0)>>0]|0|0)==0?(c[(c[k>>2]|0)+44>>2]|0)==0:0){if((c[(c[k>>2]|0)+24>>2]|0)<(c[(c[(c[k>>2]|0)+20>>2]|0)+24>>2]|0)){c[q>>2]=(c[(c[(c[k>>2]|0)+20>>2]|0)+28>>2]|0)+((c[(c[k>>2]|0)+24>>2]|0)*20|0);if((c[(c[q>>2]|0)+4>>2]|0)>=0){c[r>>2]=c[c[q>>2]>>2];if((c[(c[r>>2]|0)+12>>2]|0)==0?(c[(c[r>>2]|0)+16>>2]|0)>0:0)B=17}else B=17}}else B=17;b:do if((B|0)==17){B=0;c[(c[k>>2]|0)+28>>2]=0;c:while(1){if((c[(c[k>>2]|0)+24>>2]|0)>=(c[(c[(c[k>>2]|0)+20>>2]|0)+24>>2]|0)){B=88;break}c[q>>2]=(c[(c[(c[k>>2]|0)+20>>2]|0)+28>>2]|0)+((c[(c[k>>2]|0)+24>>2]|0)*20|0);d:do if((c[(c[q>>2]|0)+4>>2]|0)>=0){c[r>>2]=c[c[q>>2]>>2];c[l>>2]=0;c[p>>2]=1;do if((c[(c[q>>2]|0)+12>>2]|0)>=0){if(!(c[(c[k>>2]|0)+44>>2]|0)){B=22;break a}c[s>>2]=c[(c[(c[k>>2]|0)+44>>2]|0)+(c[(c[q>>2]|0)+12>>2]<<2)>>2];c[t>>2]=(c[(c[(c[k>>2]|0)+8>>2]|0)+24>>2]|0)+(c[(c[q>>2]|0)+12>>2]<<3);if((c[s>>2]|0)>=(c[c[t>>2]>>2]|0))C=(c[s>>2]|0)<=(c[(c[t>>2]|0)+4>>2]|0);else C=0;c[l>>2]=C&1;if((c[l>>2]|0)!=0?(c[c[t>>2]>>2]|0)!=(c[(c[t>>2]|0)+4>>2]|0):0)c[p>>2]=0}else{if(!(c[r>>2]|0)){B=29;break c}if(!(d[(c[(c[k>>2]|0)+64>>2]|0)+(c[(c[k>>2]|0)+56>>2]|0)>>0]|0)){if(c[(c[r>>2]|0)+12>>2]|0)break;if((c[(c[r>>2]|0)+16>>2]|0)<=0)break;c[(c[k>>2]|0)+28>>2]=1;c[n>>2]=0;c[l>>2]=1;break}c[m>>2]=oe(0,(c[(c[k>>2]|0)+64>>2]|0)+(c[(c[k>>2]|0)+56>>2]|0)|0,n)|0;c[l>>2]=uA(c[r>>2]|0,c[m>>2]|0)|0;if(((c[l>>2]|0)==1?(c[(c[r>>2]|0)+12>>2]|0)>=0:0)?(c[(c[r>>2]|0)+16>>2]|0)>0:0){c[u>>2]=c[(c[(c[h>>2]|0)+8>>2]|0)+(c[(c[q>>2]|0)+4>>2]<<2)>>2];if((c[(c[q>>2]|0)+8>>2]|0)>=0){if(!(c[(c[k>>2]|0)+44>>2]|0)){B=38;break a}if(!(c[(c[k>>2]|0)+8>>2]|0)){B=38;break a}if(!(c[(c[(c[k>>2]|0)+8>>2]|0)+24>>2]|0)){B=38;break a}c[v>>2]=(c[(c[(c[k>>2]|0)+8>>2]|0)+24>>2]|0)+(c[(c[q>>2]|0)+8>>2]<<3);if((c[(c[(c[k>>2]|0)+44>>2]|0)+(c[(c[q>>2]|0)+8>>2]<<2)>>2]|0)>=(c[(c[v>>2]|0)+4>>2]|0))break d;j=(c[(c[k>>2]|0)+44>>2]|0)+(c[(c[q>>2]|0)+8>>2]<<2)|0;c[j>>2]=(c[j>>2]|0)+1}if((c[(c[(c[k>>2]|0)+20>>2]|0)+24>>2]|0)>((c[(c[k>>2]|0)+24>>2]|0)+1|0))pA(c[k>>2]|0);c[(c[k>>2]|0)+28>>2]=1;do{if((c[(c[k>>2]|0)+28>>2]|0)==(c[(c[r>>2]|0)+16>>2]|0))break;j=(c[k>>2]|0)+56|0;c[j>>2]=(c[j>>2]|0)+(c[n>>2]|0);if(!(d[(c[(c[k>>2]|0)+64>>2]|0)+(c[(c[k>>2]|0)+56>>2]|0)>>0]|0)){B=46;break}if((c[(c[k>>2]|0)+28>>2]|0)>=(c[(c[r>>2]|0)+12>>2]|0)){c[w>>2]=c[(c[k>>2]|0)+24>>2];c[x>>2]=c[(c[k>>2]|0)+20>>2];c[(c[k>>2]|0)+24>>2]=-1;c[(c[k>>2]|0)+20>>2]=c[u>>2];pA(c[k>>2]|0);c[(c[k>>2]|0)+24>>2]=c[w>>2];c[(c[k>>2]|0)+20>>2]=c[x>>2]}c[m>>2]=oe(0,(c[(c[k>>2]|0)+64>>2]|0)+(c[(c[k>>2]|0)+56>>2]|0)|0,n)|0;c[l>>2]=uA(c[r>>2]|0,c[m>>2]|0)|0;j=(c[k>>2]|0)+28|0;c[j>>2]=(c[j>>2]|0)+1}while((c[l>>2]|0)==1);if((B|0)==46){B=0;j=(c[k>>2]|0)+56|0;c[j>>2]=(c[j>>2]|0)-(c[n>>2]|0)}if((c[(c[k>>2]|0)+28>>2]|0)<(c[(c[r>>2]|0)+12>>2]|0))c[l>>2]=0;if((c[l>>2]|0)<0)c[l>>2]=0;if(!(c[l>>2]|0))break b;if((c[(c[q>>2]|0)+8>>2]|0)<0)break;if(!(c[(c[k>>2]|0)+44>>2]|0)){B=57;break a}j=(c[(c[k>>2]|0)+44>>2]|0)+(c[(c[q>>2]|0)+8>>2]<<2)|0;c[j>>2]=(c[j>>2]|0)+-1;break}if(((c[l>>2]|0)==0?(c[(c[r>>2]|0)+12>>2]|0)==0:0)?(c[(c[r>>2]|0)+16>>2]|0)>0:0){c[(c[k>>2]|0)+28>>2]=1;c[n>>2]=0;c[l>>2]=1}}while(0);if((c[l>>2]|0)!=1)if((c[l>>2]|0)<0){B=86;break c}else break;if((c[(c[q>>2]|0)+16>>2]|0)!=1){if(((c[p>>2]|0)==0?(c[(c[q>>2]|0)+12>>2]|0)>=0:0)?(c[(c[(c[k>>2]|0)+20>>2]|0)+24>>2]|0)>((c[(c[k>>2]|0)+24>>2]|0)+1|0):0)B=70}else B=70;if((B|0)==70){B=0;pA(c[k>>2]|0)}if((c[(c[q>>2]|0)+8>>2]|0)<0)break c;if(!(c[(c[k>>2]|0)+44>>2]|0)){B=75;break a}if(!(c[(c[k>>2]|0)+8>>2]|0)){B=75;break a}if(!(c[(c[(c[k>>2]|0)+8>>2]|0)+24>>2]|0)){B=75;break a}c[y>>2]=(c[(c[(c[k>>2]|0)+8>>2]|0)+24>>2]|0)+(c[(c[q>>2]|0)+8>>2]<<3);if((c[(c[(c[k>>2]|0)+44>>2]|0)+(c[(c[q>>2]|0)+8>>2]<<2)>>2]|0)<(c[(c[y>>2]|0)+4>>2]|0)){B=77;break c}}while(0);j=(c[k>>2]|0)+24|0;c[j>>2]=(c[j>>2]|0)+1}if((B|0)==29){B=0;Ka(c[o>>2]|0,139424,f|0)|0;c[c[k>>2]>>2]=-2;B=88}else if((B|0)==77){B=0;j=(c[(c[k>>2]|0)+44>>2]|0)+(c[(c[q>>2]|0)+8>>2]<<2)|0;c[j>>2]=(c[j>>2]|0)+1}else if((B|0)==86){B=0;c[c[k>>2]>>2]=-4;B=88}if((B|0)==88){B=0;if(c[(c[k>>2]|0)+24>>2]|0)break;if(!(c[(c[(c[k>>2]|0)+20>>2]|0)+24>>2]|0))break;else continue a}if((c[(c[q>>2]|0)+12>>2]|0)>=0?(c[(c[q>>2]|0)+12>>2]|0)<1193046:0){if(!(c[(c[k>>2]|0)+44>>2]|0)){B=81;break a}c[(c[(c[k>>2]|0)+44>>2]|0)+(c[(c[q>>2]|0)+12>>2]<<2)>>2]=0}c[(c[k>>2]|0)+20>>2]=c[(c[(c[h>>2]|0)+8>>2]|0)+(c[(c[q>>2]|0)+4>>2]<<2)>>2];c[(c[k>>2]|0)+24>>2]=0;if(!(c[c[q>>2]>>2]|0))continue a;j=(c[k>>2]|0)+56|0;c[j>>2]=(c[j>>2]|0)+(c[n>>2]|0);continue a}while(0);c[(c[k>>2]|0)+4>>2]=0;qA(c[k>>2]|0)}if((B|0)==22)c[c[k>>2]>>2]=-1;else if((B|0)==38)c[c[k>>2]>>2]=-1;else if((B|0)==57)c[c[k>>2]>>2]=-1;else if((B|0)==75)c[c[k>>2]>>2]=-1;else if((B|0)==81)c[c[k>>2]>>2]=-1;if(c[(c[k>>2]|0)+40>>2]|0){e:do if(c[(c[k>>2]|0)+44>>2]|0){c[z>>2]=0;while(1){if((c[z>>2]|0)>=(c[(c[k>>2]|0)+32>>2]|0))break e;if(c[(c[(c[k>>2]|0)+40>>2]|0)+(c[z>>2]<<4)+12>>2]|0)zb[c[135736>>2]&511](c[(c[(c[k>>2]|0)+40>>2]|0)+(c[z>>2]<<4)+12>>2]|0);c[z>>2]=(c[z>>2]|0)+1}}while(0);zb[c[135736>>2]&511](c[(c[k>>2]|0)+40>>2]|0)}if(!(c[(c[k>>2]|0)+20>>2]|0)){c[g>>2]=-1;A=c[g>>2]|0;i=e;return A|0}if(c[(c[k>>2]|0)+44>>2]|0)zb[c[135736>>2]&511](c[(c[k>>2]|0)+44>>2]|0);if(!(c[c[k>>2]>>2]|0)){c[g>>2]=1;A=c[g>>2]|0;i=e;return A|0}z=c[k>>2]|0;if((c[c[k>>2]>>2]|0)!=-1){c[g>>2]=c[z>>2];A=c[g>>2]|0;i=e;return A|0}if((c[z+88>>2]|0)>1e7){c[g>>2]=-1;A=c[g>>2]|0;i=e;return A|0}else{c[g>>2]=0;A=c[g>>2]|0;i=e;return A|0}return 0}function bA(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+28>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+28>>2]|0);if(c[(c[d>>2]|0)+40>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+40>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function cA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+48|0;d=b+40|0;e=b+36|0;f=b+32|0;g=b+28|0;h=b+24|0;j=b+20|0;k=b+16|0;l=b+12|0;m=b+8|0;n=b+4|0;o=b;c[e>>2]=a;c[n>>2]=1;c[o>>2]=1;a=c[e>>2]|0;if((c[(c[e>>2]|0)+68>>2]|0)!=-1){c[d>>2]=c[a+68>>2];p=c[d>>2]|0;i=b;return p|0}if(c[a+76>>2]&1)c[o>>2]=0;c[f>>2]=0;while(1){if((c[f>>2]|0)>=(c[(c[e>>2]|0)+48>>2]|0))break;c[h>>2]=c[(c[(c[e>>2]|0)+52>>2]|0)+(c[f>>2]<<2)>>2];a:do if((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+24>>2]|0)>=2:0){c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[(c[h>>2]|0)+24>>2]|0))break a;c[j>>2]=(c[(c[h>>2]|0)+28>>2]|0)+((c[g>>2]|0)*20|0);b:do if((c[c[j>>2]>>2]|0)!=0?(c[(c[j>>2]|0)+4>>2]|0)!=-1:0){c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[g>>2]|0))break b;c[k>>2]=(c[(c[h>>2]|0)+28>>2]|0)+((c[m>>2]|0)*20|0);do if(((((c[(c[k>>2]|0)+4>>2]|0)!=-1?(c[c[k>>2]>>2]|0)!=0:0)?(c[(c[j>>2]|0)+4>>2]|0)==(c[(c[k>>2]|0)+4>>2]|0):0)?(vA(c[c[j>>2]>>2]|0,c[c[k>>2]>>2]|0,c[o>>2]|0)|0)!=0:0)?(c[(c[j>>2]|0)+8>>2]|0)==(c[(c[k>>2]|0)+8>>2]|0):0){if((c[(c[j>>2]|0)+12>>2]|0)!=(c[(c[k>>2]|0)+12>>2]|0))break;c[(c[k>>2]|0)+4>>2]=-1}while(0);c[m>>2]=(c[m>>2]|0)+1}}while(0);c[g>>2]=(c[g>>2]|0)+1}}while(0);c[f>>2]=(c[f>>2]|0)+1}c[f>>2]=0;while(1){if((c[f>>2]|0)>=(c[(c[e>>2]|0)+48>>2]|0))break;c[h>>2]=c[(c[(c[e>>2]|0)+52>>2]|0)+(c[f>>2]<<2)>>2];if((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+24>>2]|0)>=2:0){c[l>>2]=0;c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[(c[h>>2]|0)+24>>2]|0))break;c[j>>2]=(c[(c[h>>2]|0)+28>>2]|0)+((c[g>>2]|0)*20|0);c:do if((c[c[j>>2]>>2]|0)!=0?(c[(c[j>>2]|0)+4>>2]|0)!=-1:0){c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[g>>2]|0))break c;c[k>>2]=(c[(c[h>>2]|0)+28>>2]|0)+((c[m>>2]|0)*20|0);do if((c[(c[k>>2]|0)+4>>2]|0)!=-1){o=c[j>>2]|0;if(c[c[k>>2]>>2]|0){if(!(wA(c[o>>2]|0,c[c[k>>2]>>2]|0,1)|0))break;c[n>>2]=0;c[(c[j>>2]|0)+16>>2]=1;c[(c[k>>2]|0)+16>>2]=1;c[l>>2]=c[j>>2];break}if((c[o+4>>2]|0)!=-1?(c[n>>2]=xA(c[e>>2]|0,c[(c[(c[e>>2]|0)+52>>2]|0)+(c[(c[j>>2]|0)+4>>2]<<2)>>2]|0,c[(c[k>>2]|0)+4>>2]|0,c[c[k>>2]>>2]|0)|0,(c[n>>2]|0)==0):0){c[(c[j>>2]|0)+16>>2]=1;c[l>>2]=c[j>>2]}}while(0);c[m>>2]=(c[m>>2]|0)+1}}while(0);c[g>>2]=(c[g>>2]|0)+1}if(c[l>>2]|0)c[(c[l>>2]|0)+16>>2]=2}c[f>>2]=(c[f>>2]|0)+1}c[(c[e>>2]|0)+68>>2]=c[n>>2];c[d>>2]=c[n>>2];p=c[d>>2]|0;i=b;return p|0}function dA(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[(c[d>>2]|0)+52>>2]|0))break;yA(c[(c[(c[d>>2]|0)+56>>2]|0)+(c[e>>2]<<2)>>2]|0);c[e>>2]=(c[e>>2]|0)+1}if(c[(c[d>>2]|0)+56>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+56>>2]|0);if((c[(c[d>>2]|0)+4>>2]|0)==5?(c[(c[d>>2]|0)+20>>2]|0)!=0:0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+20>>2]|0);if((c[(c[d>>2]|0)+4>>2]|0)==5?(c[(c[d>>2]|0)+24>>2]|0)!=0:0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+24>>2]|0);if((c[(c[d>>2]|0)+4>>2]|0)==136?(c[(c[d>>2]|0)+20>>2]|0)!=0:0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+20>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function eA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=Cb[c[135744>>2]&511](64)|0;if(!(c[h>>2]|0)){Qz(c[f>>2]|0,139360);c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}else{f=(c[h>>2]|0)+0|0;b=f+64|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(b|0));c[(c[h>>2]|0)+4>>2]=c[g>>2];c[(c[h>>2]|0)+8>>2]=2;c[(c[h>>2]|0)+12>>2]=0;c[(c[h>>2]|0)+16>>2]=0;c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}return 0}function fA(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+48|0;g=f+40|0;h=f+36|0;j=f+32|0;k=f+28|0;l=f+24|0;m=f+20|0;n=f+16|0;o=f+12|0;p=f+8|0;q=f+4|0;r=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if(!(c[l>>2]|0)){c[(c[h>>2]|0)+8>>2]=1450;Yz(c[h>>2]|0,139280);c[g>>2]=-1;s=c[g>>2]|0;i=f;return s|0}if((c[(c[l>>2]|0)+4>>2]|0)==4){if((iA(c[h>>2]|0,c[l>>2]|0)|0)<0){c[g>>2]=-1;s=c[g>>2]|0;i=f;return s|0}if(((c[k>>2]|0)!=0?(c[(c[l>>2]|0)+44>>2]|0)!=(c[k>>2]|0):0)?(c[(c[l>>2]|0)+8>>2]|0)!=8:0)jA(c[h>>2]|0,c[(c[l>>2]|0)+44>>2]|0,c[k>>2]|0);e=c[(c[l>>2]|0)+8>>2]|0;do if((e|0)==8){if(c[k>>2]|0)c[p>>2]=c[k>>2];else{c[p>>2]=Vz(c[h>>2]|0)|0;Wz(c[h>>2]|0,c[p>>2]|0)|0}do if((c[(c[l>>2]|0)+12>>2]|0)==0?(c[(c[l>>2]|0)+40>>2]|0)==0:0){c[q>>2]=zA(c[h>>2]|0,c[l>>2]|0)|0;if(!(c[q>>2]|0)){c[g>>2]=-1;s=c[g>>2]|0;i=f;return s|0}c[(c[q>>2]|0)+8>>2]=2;c[(c[q>>2]|0)+12>>2]=0;c[(c[q>>2]|0)+16>>2]=0;if((fA(c[h>>2]|0,c[(c[l>>2]|0)+36>>2]|0,0,c[q>>2]|0)|0)>=0){c[o>>2]=c[(c[h>>2]|0)+24>>2];c[n>>2]=gA(c[h>>2]|0)|0;c[(c[(c[h>>2]|0)+64>>2]|0)+(c[n>>2]<<3)>>2]=(c[(c[l>>2]|0)+12>>2]|0)-1;c[(c[(c[h>>2]|0)+64>>2]|0)+(c[n>>2]<<3)+4>>2]=(c[(c[l>>2]|0)+16>>2]|0)-1;
lA(c[h>>2]|0,c[o>>2]|0,c[(c[l>>2]|0)+44>>2]|0,c[n>>2]|0);mA(c[h>>2]|0,c[o>>2]|0,c[p>>2]|0,c[n>>2]|0);jA(c[h>>2]|0,c[(c[l>>2]|0)+36>>2]|0,c[p>>2]|0);break}c[g>>2]=-1;s=c[g>>2]|0;i=f;return s|0}else t=26;while(0);if((t|0)==26?(c[n>>2]=gA(c[h>>2]|0)|0,c[(c[(c[h>>2]|0)+64>>2]|0)+(c[n>>2]<<3)>>2]=(c[(c[l>>2]|0)+12>>2]|0)-1,c[(c[(c[h>>2]|0)+64>>2]|0)+(c[n>>2]<<3)+4>>2]=(c[(c[l>>2]|0)+16>>2]|0)-1,lA(c[h>>2]|0,c[(c[l>>2]|0)+44>>2]|0,c[(c[l>>2]|0)+36>>2]|0,c[n>>2]|0),mA(c[h>>2]|0,c[(c[l>>2]|0)+44>>2]|0,c[p>>2]|0,c[n>>2]|0),(c[(c[l>>2]|0)+12>>2]|0)==0):0)jA(c[h>>2]|0,c[(c[l>>2]|0)+40>>2]|0,c[p>>2]|0);c[(c[l>>2]|0)+12>>2]=0;c[(c[l>>2]|0)+16>>2]=0;c[(c[l>>2]|0)+8>>2]=2;c[(c[h>>2]|0)+24>>2]=c[p>>2]}else if((e|0)==4){c[(c[l>>2]|0)+8>>2]=2;jA(c[h>>2]|0,c[(c[l>>2]|0)+36>>2]|0,c[(c[l>>2]|0)+44>>2]|0);jA(c[h>>2]|0,c[(c[l>>2]|0)+44>>2]|0,c[(c[l>>2]|0)+36>>2]|0)}else if((e|0)==3){c[(c[l>>2]|0)+8>>2]=2;d=c[h>>2]|0;b=c[(c[l>>2]|0)+36>>2]|0;if(!(c[k>>2]|0)){jA(d,b,0);jA(c[h>>2]|0,c[(c[l>>2]|0)+44>>2]|0,c[(c[h>>2]|0)+24>>2]|0);break}else{jA(d,b,c[k>>2]|0);break}}else if((e|0)==5){c[(c[l>>2]|0)+8>>2]=2;jA(c[h>>2]|0,c[(c[l>>2]|0)+44>>2]|0,c[(c[l>>2]|0)+36>>2]|0)}while(0);c[g>>2]=0;s=c[g>>2]|0;i=f;return s|0}else{if(((c[(c[l>>2]|0)+12>>2]|0)==0?(c[(c[l>>2]|0)+16>>2]|0)==0:0)?(c[(c[l>>2]|0)+8>>2]|0)==8:0){do if(!(c[k>>2]|0)){c[k>>2]=Vz(c[h>>2]|0)|0;if(c[k>>2]|0){Wz(c[h>>2]|0,c[k>>2]|0)|0;break}c[g>>2]=-1;s=c[g>>2]|0;i=f;return s|0}while(0);jA(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0);c[(c[h>>2]|0)+24>>2]=c[k>>2];dA(c[l>>2]|0);c[g>>2]=0;s=c[g>>2]|0;i=f;return s|0}do if(!(c[k>>2]|0)){c[k>>2]=Vz(c[h>>2]|0)|0;if(c[k>>2]|0){Wz(c[h>>2]|0,c[k>>2]|0)|0;break}c[g>>2]=-1;s=c[g>>2]|0;i=f;return s|0}while(0);c[m>>2]=c[k>>2];if(!((c[(c[l>>2]|0)+8>>2]|0)!=4?(c[(c[l>>2]|0)+8>>2]|0)!=5:0))t=44;do if((t|0)==44){c[r>>2]=Vz(c[h>>2]|0)|0;if(c[r>>2]|0){Wz(c[h>>2]|0,c[r>>2]|0)|0;jA(c[h>>2]|0,c[r>>2]|0,c[k>>2]|0);c[k>>2]=c[r>>2];break}c[g>>2]=-1;s=c[g>>2]|0;i=f;return s|0}while(0);if((iA(c[h>>2]|0,c[l>>2]|0)|0)<0){c[g>>2]=-1;s=c[g>>2]|0;i=f;return s|0}hA(c[h>>2]|0,c[j>>2]|0,c[l>>2]|0,c[k>>2]|0,-1,-1);c[(c[h>>2]|0)+24>>2]=c[m>>2];m=c[(c[l>>2]|0)+8>>2]|0;if((m|0)==5){c[(c[l>>2]|0)+8>>2]=2;hA(c[h>>2]|0,c[k>>2]|0,c[l>>2]|0,c[k>>2]|0,-1,-1)}else if((m|0)==3){c[(c[l>>2]|0)+8>>2]=2;jA(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0)}else if((m|0)==4){c[(c[l>>2]|0)+8>>2]=2;jA(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0);hA(c[h>>2]|0,c[k>>2]|0,c[l>>2]|0,c[k>>2]|0,-1,-1)}c[g>>2]=0;s=c[g>>2]|0;i=f;return s|0}return 0}function gA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;a=c[e>>2]|0;do if(!(c[(c[e>>2]|0)+56>>2]|0)){c[a+56>>2]=4;g=Cb[c[135744>>2]&511](c[(c[e>>2]|0)+56>>2]<<3)|0;c[(c[e>>2]|0)+64>>2]=g;if(!(c[(c[e>>2]|0)+64>>2]|0)){Qz(c[e>>2]|0,139168);c[(c[e>>2]|0)+56>>2]=0;c[d>>2]=-1;h=c[d>>2]|0;i=b;return h|0}}else if((c[a+60>>2]|0)>=(c[(c[e>>2]|0)+56>>2]|0)){g=(c[e>>2]|0)+56|0;c[g>>2]=c[g>>2]<<1;c[f>>2]=Hb[c[135760>>2]&511](c[(c[e>>2]|0)+64>>2]|0,c[(c[e>>2]|0)+56>>2]<<3)|0;if(c[f>>2]|0){c[(c[e>>2]|0)+64>>2]=c[f>>2];break}Qz(c[e>>2]|0,139168);g=(c[e>>2]|0)+56|0;c[g>>2]=(c[g>>2]|0)/2|0;c[d>>2]=-1;h=c[d>>2]|0;i=b;return h|0}while(0);c[(c[(c[e>>2]|0)+64>>2]|0)+(c[(c[e>>2]|0)+60>>2]<<3)>>2]=-1;c[(c[(c[e>>2]|0)+64>>2]|0)+(c[(c[e>>2]|0)+60>>2]<<3)+4>>2]=-1;f=(c[e>>2]|0)+60|0;e=c[f>>2]|0;c[f>>2]=e+1;c[d>>2]=e;h=c[d>>2]|0;i=b;return h|0}function hA(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+48|0;j=h+32|0;k=h+28|0;l=h+24|0;m=h+20|0;n=h+16|0;o=h+12|0;p=h+8|0;q=h+4|0;r=h;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;if(!(c[k>>2]|0)){c[(c[j>>2]|0)+8>>2]=1450;Yz(c[j>>2]|0,139192);i=h;return}if(!(c[m>>2]|0)){c[(c[j>>2]|0)+8>>2]=1450;Yz(c[j>>2]|0,139224);i=h;return}c[p>>2]=(c[(c[k>>2]|0)+24>>2]|0)-1;while(1){if((c[p>>2]|0)<0)break;c[q>>2]=(c[(c[k>>2]|0)+28>>2]|0)+((c[p>>2]|0)*20|0);if((((c[c[q>>2]>>2]|0)==(c[l>>2]|0)?(c[(c[q>>2]|0)+4>>2]|0)==(c[(c[m>>2]|0)+16>>2]|0):0)?(c[(c[q>>2]|0)+8>>2]|0)==(c[n>>2]|0):0)?(c[(c[q>>2]|0)+12>>2]|0)==(c[o>>2]|0):0){s=20;break}c[p>>2]=(c[p>>2]|0)+-1}if((s|0)==20){i=h;return}s=c[k>>2]|0;do if(!(c[(c[k>>2]|0)+20>>2]|0)){c[s+20>>2]=8;p=Cb[c[135744>>2]&511]((c[(c[k>>2]|0)+20>>2]|0)*20|0)|0;c[(c[k>>2]|0)+28>>2]=p;if(!(c[(c[k>>2]|0)+28>>2]|0)){Qz(c[j>>2]|0,139256);c[(c[k>>2]|0)+20>>2]=0;i=h;return}}else if((c[s+24>>2]|0)>=(c[(c[k>>2]|0)+20>>2]|0)){p=(c[k>>2]|0)+20|0;c[p>>2]=c[p>>2]<<1;c[r>>2]=Hb[c[135760>>2]&511](c[(c[k>>2]|0)+28>>2]|0,(c[(c[k>>2]|0)+20>>2]|0)*20|0)|0;if(c[r>>2]|0){c[(c[k>>2]|0)+28>>2]=c[r>>2];break}Qz(c[j>>2]|0,139256);p=(c[k>>2]|0)+20|0;c[p>>2]=(c[p>>2]|0)/2|0;i=h;return}while(0);c[(c[(c[k>>2]|0)+28>>2]|0)+((c[(c[k>>2]|0)+24>>2]|0)*20|0)>>2]=c[l>>2];c[(c[(c[k>>2]|0)+28>>2]|0)+((c[(c[k>>2]|0)+24>>2]|0)*20|0)+4>>2]=c[(c[m>>2]|0)+16>>2];c[(c[(c[k>>2]|0)+28>>2]|0)+((c[(c[k>>2]|0)+24>>2]|0)*20|0)+8>>2]=c[n>>2];c[(c[(c[k>>2]|0)+28>>2]|0)+((c[(c[k>>2]|0)+24>>2]|0)*20|0)+12>>2]=c[o>>2];c[(c[(c[k>>2]|0)+28>>2]|0)+((c[(c[k>>2]|0)+24>>2]|0)*20|0)+16>>2]=0;o=(c[k>>2]|0)+24|0;c[o>>2]=(c[o>>2]|0)+1;AA(c[j>>2]|0,c[m>>2]|0,c[(c[k>>2]|0)+16>>2]|0);i=h;return}function iA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;b=c[f>>2]|0;if(!(c[g>>2]|0)){c[b+8>>2]=1450;Yz(c[f>>2]|0,139128);c[e>>2]=-1;j=c[e>>2]|0;i=d;return j|0}a=c[f>>2]|0;do if(!(c[b+32>>2]|0)){c[a+32>>2]=4;k=Cb[c[135744>>2]&511](c[(c[f>>2]|0)+32>>2]<<2)|0;c[(c[f>>2]|0)+40>>2]=k;if(!(c[(c[f>>2]|0)+40>>2]|0)){Qz(c[f>>2]|0,139152);c[(c[f>>2]|0)+32>>2]=0;c[e>>2]=-1;j=c[e>>2]|0;i=d;return j|0}}else if((c[a+36>>2]|0)>=(c[(c[f>>2]|0)+32>>2]|0)){k=(c[f>>2]|0)+32|0;c[k>>2]=c[k>>2]<<1;c[h>>2]=Hb[c[135760>>2]&511](c[(c[f>>2]|0)+40>>2]|0,c[(c[f>>2]|0)+32>>2]<<2)|0;if(c[h>>2]|0){c[(c[f>>2]|0)+40>>2]=c[h>>2];break}Qz(c[f>>2]|0,139168);k=(c[f>>2]|0)+32|0;c[k>>2]=(c[k>>2]|0)/2|0;c[e>>2]=-1;j=c[e>>2]|0;i=d;return j|0}while(0);c[c[g>>2]>>2]=c[(c[f>>2]|0)+36>>2];h=c[g>>2]|0;g=(c[f>>2]|0)+36|0;a=c[g>>2]|0;c[g>>2]=a+1;c[(c[(c[f>>2]|0)+40>>2]|0)+(a<<2)>>2]=h;c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}function jA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if(!(c[h>>2]|0)){c[h>>2]=Vz(c[f>>2]|0)|0;Wz(c[f>>2]|0,c[h>>2]|0)|0;c[(c[f>>2]|0)+24>>2]=c[h>>2]}hA(c[f>>2]|0,c[g>>2]|0,0,c[h>>2]|0,-1,-1);i=e;return}function kA(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;if(!(c[j>>2]|0)){c[j>>2]=Vz(c[g>>2]|0)|0;Wz(c[g>>2]|0,c[j>>2]|0)|0;c[(c[g>>2]|0)+24>>2]=c[j>>2]}e=c[g>>2]|0;g=c[h>>2]|0;h=c[j>>2]|0;if(c[k>>2]|0){hA(e,g,0,h,-1,1193047);i=f;return}else{hA(e,g,0,h,-1,1193046);i=f;return}}function lA(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;if(!(c[j>>2]|0)){c[j>>2]=Vz(c[g>>2]|0)|0;Wz(c[g>>2]|0,c[j>>2]|0)|0;c[(c[g>>2]|0)+24>>2]=c[j>>2]}hA(c[g>>2]|0,c[h>>2]|0,0,c[j>>2]|0,c[k>>2]|0,-1);i=f;return}function mA(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;if(!(c[j>>2]|0)){c[j>>2]=Vz(c[g>>2]|0)|0;Wz(c[g>>2]|0,c[j>>2]|0)|0;c[(c[g>>2]|0)+24>>2]=c[j>>2]}hA(c[g>>2]|0,c[h>>2]|0,0,c[j>>2]|0,-1,c[k>>2]|0);i=f;return}function nA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=c[f>>2]|0;do if(!(c[(c[f>>2]|0)+48>>2]|0)){c[d+48>>2]=4;b=Cb[c[135744>>2]&511](c[(c[f>>2]|0)+48>>2]<<3)|0;c[(c[f>>2]|0)+68>>2]=b;if(!(c[(c[f>>2]|0)+68>>2]|0)){Qz(0,140240);c[(c[f>>2]|0)+48>>2]=0;i=e;return}}else if(((c[d+52>>2]|0)+1|0)>=(c[(c[f>>2]|0)+48>>2]|0)){b=(c[f>>2]|0)+48|0;c[b>>2]=c[b>>2]<<1;c[j>>2]=Hb[c[135760>>2]&511](c[(c[f>>2]|0)+68>>2]|0,c[(c[f>>2]|0)+48>>2]<<3)|0;if(c[j>>2]|0){c[(c[f>>2]|0)+68>>2]=c[j>>2];break}Qz(0,140240);b=(c[f>>2]|0)+48|0;c[b>>2]=(c[b>>2]|0)/2|0;i=e;return}while(0);j=my(c[g>>2]|0)|0;c[(c[(c[f>>2]|0)+68>>2]|0)+(c[(c[f>>2]|0)+52>>2]<<3)>>2]=j;c[(c[(c[f>>2]|0)+68>>2]|0)+(c[(c[f>>2]|0)+52>>2]<<3)+4>>2]=c[h>>2];h=(c[f>>2]|0)+52|0;c[h>>2]=(c[h>>2]|0)+1;c[(c[(c[f>>2]|0)+68>>2]|0)+(c[(c[f>>2]|0)+52>>2]<<3)>>2]=0;c[(c[(c[f>>2]|0)+68>>2]|0)+(c[(c[f>>2]|0)+52>>2]<<3)+4>>2]=0;i=e;return}function oA(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=a;c[h>>2]=b;if((c[g>>2]|0)==(c[h>>2]|0)){c[f>>2]=1;k=c[f>>2]|0;i=e;return k|0}if(!(c[g>>2]|0)){c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}if(!(c[h>>2]|0)){c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}a:do b:do if((d[c[g>>2]>>0]|0|0)!=(d[c[h>>2]>>0]|0|0)){if((d[c[h>>2]>>0]|0|0)==42){c[j>>2]=c[h>>2];c[h>>2]=c[g>>2];c[g>>2]=c[j>>2]}if(!(d[c[h>>2]>>0]|0)){l=15;break a}if(!(d[c[g>>2]>>0]|0)){l=15;break a}b=c[g>>2]|0;c[g>>2]=b+1;if((d[b>>0]|0|0)!=42){l=15;break a}do{if((d[c[h>>2]>>0]|0|0)==124)break b;c[h>>2]=(c[h>>2]|0)+1}while((d[c[h>>2]>>0]|0|0)!=0)}else{c[g>>2]=(c[g>>2]|0)+1;c[h>>2]=(c[h>>2]|0)+1}while(0);while((d[c[h>>2]>>0]|0|0)!=0);if((l|0)==15){c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}if(d[c[g>>2]>>0]|0){c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}else{c[f>>2]=1;k=c[f>>2]|0;i=e;return k|0}return 0}function pA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;if((c[(c[d>>2]|0)+88>>2]|0)>1e7){i=b;return}a=(c[d>>2]|0)+88|0;c[a>>2]=(c[a>>2]|0)+1;a=c[d>>2]|0;do if(c[(c[d>>2]|0)+32>>2]|0){if((c[a+36>>2]|0)>=(c[(c[d>>2]|0)+32>>2]|0)){c[f>>2]=c[(c[d>>2]|0)+32>>2];g=(c[d>>2]|0)+32|0;c[g>>2]=c[g>>2]<<1;c[e>>2]=Hb[c[135760>>2]&511](c[(c[d>>2]|0)+40>>2]|0,c[(c[d>>2]|0)+32>>2]<<4)|0;if(c[e>>2]|0){c[(c[d>>2]|0)+40>>2]=c[e>>2];c[e>>2]=(c[(c[d>>2]|0)+40>>2]|0)+(c[f>>2]<<4);cU(c[e>>2]|0,0,(c[(c[d>>2]|0)+32>>2]|0)-(c[f>>2]|0)<<4|0)|0;break}Qz(0,139496);g=(c[d>>2]|0)+32|0;c[g>>2]=(c[g>>2]|0)/2|0;i=b;return}}else{c[a+32>>2]=4;g=Cb[c[135744>>2]&511](c[(c[d>>2]|0)+32>>2]<<4)|0;c[(c[d>>2]|0)+40>>2]=g;if(c[(c[d>>2]|0)+40>>2]|0){cU(c[(c[d>>2]|0)+40>>2]|0,0,c[(c[d>>2]|0)+32>>2]<<4|0)|0;break}Qz(0,139496);c[(c[d>>2]|0)+32>>2]=0;i=b;return}while(0);c[(c[(c[d>>2]|0)+40>>2]|0)+(c[(c[d>>2]|0)+36>>2]<<4)>>2]=c[(c[d>>2]|0)+20>>2];c[(c[(c[d>>2]|0)+40>>2]|0)+(c[(c[d>>2]|0)+36>>2]<<4)+4>>2]=c[(c[d>>2]|0)+56>>2];c[(c[(c[d>>2]|0)+40>>2]|0)+(c[(c[d>>2]|0)+36>>2]<<4)+8>>2]=(c[(c[d>>2]|0)+24>>2]|0)+1;if((c[(c[(c[d>>2]|0)+8>>2]|0)+20>>2]|0)>0){if((c[(c[(c[d>>2]|0)+40>>2]|0)+(c[(c[d>>2]|0)+36>>2]<<4)+12>>2]|0)==0?(a=Cb[c[135744>>2]&511](c[(c[(c[d>>2]|0)+8>>2]|0)+20>>2]<<2)|0,c[(c[(c[d>>2]|0)+40>>2]|0)+(c[(c[d>>2]|0)+36>>2]<<4)+12>>2]=a,(c[(c[(c[d>>2]|0)+40>>2]|0)+(c[(c[d>>2]|0)+36>>2]<<4)+12>>2]|0)==0):0){Qz(0,139496);c[c[d>>2]>>2]=-5;i=b;return}eU(c[(c[(c[d>>2]|0)+40>>2]|0)+(c[(c[d>>2]|0)+36>>2]<<4)+12>>2]|0,c[(c[d>>2]|0)+44>>2]|0,c[(c[(c[d>>2]|0)+8>>2]|0)+20>>2]<<2|0)|0}a=(c[d>>2]|0)+36|0;c[a>>2]=(c[a>>2]|0)+1;i=b;return}function qA(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;c[d>>2]=a;a=c[d>>2]|0;if((c[(c[d>>2]|0)+36>>2]|0)<=0){c[a>>2]=-1;i=b;return}e=a+36|0;c[e>>2]=(c[e>>2]|0)+-1;c[(c[d>>2]|0)+20>>2]=c[(c[(c[d>>2]|0)+40>>2]|0)+(c[(c[d>>2]|0)+36>>2]<<4)>>2];c[(c[d>>2]|0)+56>>2]=c[(c[(c[d>>2]|0)+40>>2]|0)+(c[(c[d>>2]|0)+36>>2]<<4)+4>>2];c[(c[d>>2]|0)+24>>2]=c[(c[(c[d>>2]|0)+40>>2]|0)+(c[(c[d>>2]|0)+36>>2]<<4)+8>>2];if((c[(c[(c[d>>2]|0)+8>>2]|0)+20>>2]|0)<=0){i=b;return}if(!(c[(c[(c[d>>2]|0)+40>>2]|0)+(c[(c[d>>2]|0)+36>>2]<<4)+12>>2]|0)){Ka(c[o>>2]|0,139464,b|0)|0;c[c[d>>2]>>2]=-6;i=b;return}if(!(c[(c[d>>2]|0)+44>>2]|0)){i=b;return}eU(c[(c[d>>2]|0)+44>>2]|0,c[(c[(c[d>>2]|0)+40>>2]|0)+(c[(c[d>>2]|0)+36>>2]<<4)+12>>2]|0,c[(c[(c[d>>2]|0)+8>>2]|0)+20>>2]<<2|0)|0;i=b;return}function rA(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=c[(c[g>>2]|0)+24>>2];c[k>>2]=BA(c[g>>2]|0)|0;do if(c[k>>2]|0){b=c[g>>2]|0;a=c[j>>2]|0;if((d[c[(c[g>>2]|0)+4>>2]>>0]|0|0)!=124?(d[c[(c[g>>2]|0)+4>>2]>>0]|0|0)!=41:0)l=0;else l=c[h>>2]|0;if((fA(b,a,l,c[(c[g>>2]|0)+28>>2]|0)|0)>=0){c[j>>2]=c[(c[g>>2]|0)+24>>2];c[(c[g>>2]|0)+28>>2]=0;break}c[f>>2]=-1;m=c[f>>2]|0;i=e;return m|0}while(0);while(1){if(!(c[k>>2]|0)){n=17;break}if(c[(c[g>>2]|0)+8>>2]|0){n=17;break}c[k>>2]=BA(c[g>>2]|0)|0;if(!(c[k>>2]|0))continue;l=c[g>>2]|0;a=c[j>>2]|0;if((d[c[(c[g>>2]|0)+4>>2]>>0]|0|0)!=124?(d[c[(c[g>>2]|0)+4>>2]>>0]|0|0)!=41:0)o=0;else o=c[h>>2]|0;if((fA(l,a,o,c[(c[g>>2]|0)+28>>2]|0)|0)<0){n=15;break}c[j>>2]=c[(c[g>>2]|0)+24>>2];c[(c[g>>2]|0)+28>>2]=0}if((n|0)==15){c[f>>2]=-1;m=c[f>>2]|0;i=e;return m|0}else if((n|0)==17){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}return 0}function sA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+32|0;d=b+24|0;e=b+20|0;f=b+16|0;g=b+12|0;h=b+8|0;j=b+4|0;k=b;c[d>>2]=a;c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[(c[d>>2]|0)+48>>2]|0))break;c[j>>2]=c[(c[(c[d>>2]|0)+52>>2]|0)+(c[e>>2]<<2)>>2];if(((((((((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+24>>2]|0)==1:0)?(c[c[j>>2]>>2]|0)!=5:0)?(c[c[(c[j>>2]|0)+28>>2]>>2]|0)==0:0)?(c[(c[(c[j>>2]|0)+28>>2]|0)+4>>2]|0)>=0:0)?(c[(c[(c[j>>2]|0)+28>>2]|0)+4>>2]|0)!=(c[e>>2]|0):0)?(c[(c[(c[j>>2]|0)+28>>2]|0)+8>>2]|0)<0:0)?(c[(c[(c[j>>2]|0)+28>>2]|0)+12>>2]|0)<0:0)?(c[h>>2]=c[(c[(c[j>>2]|0)+28>>2]|0)+4>>2],(c[c[j>>2]>>2]|0)!=1):0){c[f>>2]=0;while(1){if((c[f>>2]|0)>=(c[(c[j>>2]|0)+36>>2]|0))break;c[k>>2]=c[(c[(c[d>>2]|0)+52>>2]|0)+(c[(c[(c[j>>2]|0)+40>>2]|0)+(c[f>>2]<<2)>>2]<<2)>>2];c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[(c[k>>2]|0)+24>>2]|0))break;if((c[(c[(c[k>>2]|0)+28>>2]|0)+((c[g>>2]|0)*20|0)+4>>2]|0)==(c[e>>2]|0)){c[(c[(c[k>>2]|0)+28>>2]|0)+((c[g>>2]|0)*20|0)+4>>2]=-1;hA(c[d>>2]|0,c[k>>2]|0,c[(c[(c[k>>2]|0)+28>>2]|0)+((c[g>>2]|0)*20|0)>>2]|0,c[(c[(c[d>>2]|0)+52>>2]|0)+(c[h>>2]<<2)>>2]|0,c[(c[(c[k>>2]|0)+28>>2]|0)+((c[g>>2]|0)*20|0)+8>>2]|0,c[(c[(c[k>>2]|0)+28>>2]|0)+((c[g>>2]|0)*20|0)+12>>2]|0)}c[g>>2]=(c[g>>2]|0)+1}c[f>>2]=(c[f>>2]|0)+1}if((c[c[j>>2]>>2]|0)==2)c[c[(c[(c[d>>2]|0)+52>>2]|0)+(c[h>>2]<<2)>>2]>>2]=2;c[(c[j>>2]|0)+24>>2]=0;c[c[j>>2]>>2]=5}c[e>>2]=(c[e>>2]|0)+1}i=b;return}function tA(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+48|0;g=f+32|0;h=f+28|0;j=f+24|0;k=f+20|0;l=f+16|0;m=f+12|0;n=f+8|0;o=f+4|0;p=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[m>>2]=c[(c[(c[g>>2]|0)+52>>2]|0)+(c[h>>2]<<2)>>2];if(!(c[m>>2]|0)){i=f;return}c[n>>2]=c[(c[(c[g>>2]|0)+52>>2]|0)+(c[j>>2]<<2)>>2];if(!(c[n>>2]|0)){i=f;return}if((c[(c[n>>2]|0)+4>>2]|0)==1){i=f;return}if((c[(c[n>>2]|0)+4>>2]|0)==2){i=f;return}c[(c[n>>2]|0)+4>>2]=2;if((c[c[n>>2]>>2]|0)==2)c[c[m>>2]>>2]=2;c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[(c[n>>2]|0)+24>>2]|0))break;do if((c[(c[(c[n>>2]|0)+28>>2]|0)+((c[l>>2]|0)*20|0)+4>>2]|0)>=0){j=c[(c[(c[n>>2]|0)+28>>2]|0)+((c[l>>2]|0)*20|0)+4>>2]|0;if(c[(c[(c[n>>2]|0)+28>>2]|0)+((c[l>>2]|0)*20|0)>>2]|0){c[p>>2]=j;e=c[g>>2]|0;d=c[m>>2]|0;b=c[(c[(c[n>>2]|0)+28>>2]|0)+((c[l>>2]|0)*20|0)>>2]|0;a=c[(c[(c[g>>2]|0)+52>>2]|0)+(c[p>>2]<<2)>>2]|0;if((c[(c[(c[n>>2]|0)+28>>2]|0)+((c[l>>2]|0)*20|0)+8>>2]|0)>=0){hA(e,d,b,a,c[(c[(c[n>>2]|0)+28>>2]|0)+((c[l>>2]|0)*20|0)+8>>2]|0,-1);break}else{hA(e,d,b,a,c[k>>2]|0,-1);break}}if((j|0)!=(c[h>>2]|0)){j=(c[(c[n>>2]|0)+28>>2]|0)+((c[l>>2]|0)*20|0)|0;if((c[(c[(c[n>>2]|0)+28>>2]|0)+((c[l>>2]|0)*20|0)+12>>2]|0)>=0){c[o>>2]=c[j+4>>2];hA(c[g>>2]|0,c[m>>2]|0,0,c[(c[(c[g>>2]|0)+52>>2]|0)+(c[o>>2]<<2)>>2]|0,-1,c[(c[(c[n>>2]|0)+28>>2]|0)+((c[l>>2]|0)*20|0)+12>>2]|0);break}a=c[g>>2]|0;b=c[h>>2]|0;d=c[(c[(c[n>>2]|0)+28>>2]|0)+((c[l>>2]|0)*20|0)+4>>2]|0;if((c[j+8>>2]|0)>=0){tA(a,b,d,c[(c[(c[n>>2]|0)+28>>2]|0)+((c[l>>2]|0)*20|0)+8>>2]|0);break}else{tA(a,b,d,c[k>>2]|0);break}}}while(0);c[l>>2]=(c[l>>2]|0)+1}c[(c[n>>2]|0)+4>>2]=0;i=f;return}function uA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+32|0;e=d;f=d+28|0;g=d+24|0;h=d+20|0;j=d+16|0;k=d+12|0;l=d+8|0;m=d+4|0;c[g>>2]=a;c[h>>2]=b;c[k>>2]=0;do if(c[g>>2]|0){b=c[h>>2]|0;if((c[h>>2]|0)<256){if(!(9<=(b|0)&(c[h>>2]|0)<=10|(c[h>>2]|0)==13|32<=(c[h>>2]|0)))break}else if((!(256<=(b|0)&(c[h>>2]|0)<=55295)?!(57344<=(c[h>>2]|0)&(c[h>>2]|0)<=65533):0)?!(65536<=(c[h>>2]|0)&(c[h>>2]|0)<=1114111):0)break;switch(c[(c[g>>2]|0)+4>>2]|0){case 136:case 135:case 134:case 133:case 132:case 131:case 130:case 129:case 128:case 127:case 126:case 125:case 124:case 123:case 122:case 121:case 120:case 119:case 118:case 117:case 116:case 115:case 114:case 113:case 112:case 111:case 110:case 109:case 108:case 107:case 106:case 105:case 104:case 103:case 102:case 101:case 100:case 16:case 15:case 14:case 13:case 12:case 11:case 10:case 9:case 8:case 7:case 6:{c[k>>2]=CA(c[(c[g>>2]|0)+4>>2]|0,c[h>>2]|0,0,0,0,c[(c[g>>2]|0)+20>>2]|0)|0;if(c[(c[g>>2]|0)+28>>2]|0)c[k>>2]=((c[k>>2]|0)!=0^1)&1;break}case 2:{c[f>>2]=(c[h>>2]|0)==(c[(c[g>>2]|0)+32>>2]|0)&1;n=c[f>>2]|0;i=d;return n|0}case 3:{c[m>>2]=0;c[j>>2]=0;a:while(1){if((c[j>>2]|0)>=(c[(c[g>>2]|0)+52>>2]|0)){o=23;break}c[l>>2]=c[(c[(c[g>>2]|0)+56>>2]|0)+(c[j>>2]<<2)>>2];b=c[l>>2]|0;do if((c[c[l>>2]>>2]|0)==2){c[k>>2]=CA(c[b+4>>2]|0,c[h>>2]|0,0,c[(c[l>>2]|0)+8>>2]|0,c[(c[l>>2]|0)+12>>2]|0,c[(c[l>>2]|0)+16>>2]|0)|0;if(c[k>>2]|0){o=15;break a}}else{a=(c[b>>2]|0)!=0;c[k>>2]=CA(c[(c[l>>2]|0)+4>>2]|0,c[h>>2]|0,0,c[(c[l>>2]|0)+8>>2]|0,c[(c[l>>2]|0)+12>>2]|0,c[(c[l>>2]|0)+16>>2]|0)|0;p=c[k>>2]|0;if(a){if(p){o=19;break a}c[m>>2]=1;break}else{if(!p)break;c[m>>2]=1;break}}while(0);c[j>>2]=(c[j>>2]|0)+1}if((o|0)==15){c[f>>2]=0;n=c[f>>2]|0;i=d;return n|0}else if((o|0)==19){c[f>>2]=0;n=c[f>>2]|0;i=d;return n|0}else if((o|0)==23){c[f>>2]=c[m>>2];n=c[f>>2]|0;i=d;return n|0}break}case 5:{Wa(139376,e|0)|0;c[f>>2]=-1;n=c[f>>2]|0;i=d;return n|0}case 1:case 4:{c[f>>2]=-1;n=c[f>>2]|0;i=d;return n|0}default:{}}c[f>>2]=c[k>>2];n=c[f>>2]|0;i=d;return n|0}while(0);c[f>>2]=-1;n=c[f>>2]|0;i=d;return n|0}function vA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=0;if((c[g>>2]|0)==(c[h>>2]|0)){c[f>>2]=1;l=c[f>>2]|0;i=e;return l|0}if((c[g>>2]|0)==0|(c[h>>2]|0)==0){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}if((c[(c[g>>2]|0)+4>>2]|0)!=(c[(c[h>>2]|0)+4>>2]|0)){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}d=c[(c[g>>2]|0)+4>>2]|0;do if((d|0)==1)c[k>>2]=0;else if((d|0)==2)c[k>>2]=(c[(c[g>>2]|0)+32>>2]|0)==(c[(c[h>>2]|0)+32>>2]|0)&1;else if((d|0)==3)c[k>>2]=0;else if((d|0)==5){b=c[(c[g>>2]|0)+20>>2]|0;a=c[(c[h>>2]|0)+20>>2]|0;if(c[j>>2]|0){c[k>>2]=qy(b,a)|0;break}else{c[k>>2]=(b|0)==(a|0)&1;break}}while(0);c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}function wA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+48|0;f=e+40|0;g=e+36|0;h=e+32|0;j=e+28|0;k=e+24|0;l=e+20|0;m=e+16|0;n=e+12|0;o=e+8|0;p=e+4|0;q=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=1;if((c[g>>2]|0)==(c[h>>2]|0)){c[f>>2]=1;r=c[f>>2]|0;i=e;return r|0}if((c[g>>2]|0)==0|(c[h>>2]|0)==0){c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}if((c[(c[g>>2]|0)+4>>2]|0)!=6?(c[(c[h>>2]|0)+4>>2]|0)!=6:0){if((c[(c[g>>2]|0)+4>>2]|0)>>>0>(c[(c[h>>2]|0)+4>>2]|0)>>>0){c[l>>2]=c[g>>2];c[g>>2]=c[h>>2];c[h>>2]=c[l>>2]}if((c[(c[g>>2]|0)+4>>2]|0)!=(c[(c[h>>2]|0)+4>>2]|0)?(c[k>>2]=DA(c[(c[g>>2]|0)+4>>2]|0,c[(c[h>>2]|0)+4>>2]|0)|0,(c[k>>2]|0)==0):0){c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}l=c[(c[g>>2]|0)+4>>2]|0;do if((l|0)==5){d=c[(c[g>>2]|0)+20>>2]|0;b=c[(c[h>>2]|0)+20>>2]|0;if(c[j>>2]|0){c[k>>2]=oA(d,b)|0;s=30;break}else{c[k>>2]=(d|0)!=(b|0)&1;s=30;break}}else if((l|0)==2)if((c[(c[h>>2]|0)+4>>2]|0)==2){c[k>>2]=(c[(c[g>>2]|0)+32>>2]|0)==(c[(c[h>>2]|0)+32>>2]|0)&1;s=30;break}else{b=uA(c[h>>2]|0,c[(c[g>>2]|0)+32>>2]|0)|0;c[k>>2]=b;c[k>>2]=(c[k>>2]|0)<0?1:b;s=30;break}else if((l|0)==3)if((c[(c[h>>2]|0)+4>>2]|0)==3){c[m>>2]=0;a:while(1){if((c[m>>2]|0)>=(c[(c[g>>2]|0)+52>>2]|0)){s=29;break}c[n>>2]=0;while(1){t=c[m>>2]|0;if((c[n>>2]|0)>=(c[(c[h>>2]|0)+52>>2]|0))break;c[p>>2]=c[(c[(c[g>>2]|0)+56>>2]|0)+(t<<2)>>2];c[q>>2]=c[(c[(c[h>>2]|0)+56>>2]|0)+(c[n>>2]<<2)>>2];c[o>>2]=EA(c[p>>2]|0,c[q>>2]|0)|0;if((c[o>>2]|0)==1){s=26;break a}c[n>>2]=(c[n>>2]|0)+1}c[m>>2]=t+1}if((s|0)==26){c[k>>2]=1;s=30;break}else if((s|0)==29){c[k>>2]=0;s=30;break}}else s=30;while(0);if((s|0)==30){if((c[(c[g>>2]|0)+28>>2]|0)!=(c[(c[h>>2]|0)+28>>2]|0))c[k>>2]=((c[k>>2]|0)!=0^1)&1;if(!(c[k>>2]|0)){c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}}c[f>>2]=1;r=c[f>>2]|0;i=e;return r|0}c[f>>2]=1;r=c[f>>2]|0;i=e;return r|0}function xA(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+48|0;g=f+40|0;h=f+36|0;j=f+32|0;k=f+28|0;l=f+24|0;m=f+20|0;n=f+16|0;o=f+12|0;p=f+8|0;q=f+4|0;r=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=1;c[r>>2]=1;if(!(c[j>>2]|0)){c[g>>2]=c[m>>2];s=c[g>>2]|0;i=f;return s|0}if((c[(c[j>>2]|0)+8>>2]|0)==2){c[g>>2]=c[m>>2];s=c[g>>2]|0;i=f;return s|0}if(c[(c[h>>2]|0)+76>>2]&1)c[r>>2]=0;c[p>>2]=c[(c[j>>2]|0)+24>>2];c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[p>>2]|0))break;c[q>>2]=(c[(c[j>>2]|0)+28>>2]|0)+((c[o>>2]|0)*20|0);e=c[(c[q>>2]|0)+4>>2]|0;if(!(c[c[q>>2]>>2]|0)){if((e|0)>=0?(c[(c[j>>2]|0)+8>>2]=2,c[n>>2]=xA(c[h>>2]|0,c[(c[(c[h>>2]|0)+52>>2]|0)+(c[(c[q>>2]|0)+4>>2]<<2)>>2]|0,c[k>>2]|0,c[l>>2]|0)|0,c[(c[j>>2]|0)+8>>2]=0,(c[n>>2]|0)==0):0)c[m>>2]=0}else if((e|0)==(c[k>>2]|0)?(wA(c[c[q>>2]>>2]|0,c[l>>2]|0,c[r>>2]|0)|0)!=0:0){c[m>>2]=0;c[(c[q>>2]|0)+16>>2]=1}c[o>>2]=(c[o>>2]|0)+1}c[g>>2]=c[m>>2];s=c[g>>2]|0;i=f;return s|0}function yA(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+16>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+16>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function zA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=Cb[c[135744>>2]&511](64)|0;if(!(c[h>>2]|0)){Qz(c[f>>2]|0,139320);c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}b=(c[h>>2]|0)+0|0;a=b+64|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(a|0));c[(c[h>>2]|0)+4>>2]=c[(c[g>>2]|0)+4>>2];c[(c[h>>2]|0)+8>>2]=c[(c[g>>2]|0)+8>>2];c[(c[h>>2]|0)+12>>2]=c[(c[g>>2]|0)+12>>2];c[(c[h>>2]|0)+16>>2]=c[(c[g>>2]|0)+16>>2];a:do if((c[(c[g>>2]|0)+52>>2]|0)>0){b=Cb[c[135744>>2]&511](c[(c[g>>2]|0)+52>>2]<<2)|0;c[(c[h>>2]|0)+56>>2]=b;b:do if(!(c[(c[h>>2]|0)+56>>2]|0))Qz(c[f>>2]|0,139320);else{c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[(c[g>>2]|0)+52>>2]|0))break a;b=FA(c[f>>2]|0,c[(c[(c[g>>2]|0)+56>>2]|0)+(c[j>>2]<<2)>>2]|0)|0;c[(c[(c[h>>2]|0)+56>>2]|0)+(c[j>>2]<<2)>>2]=b;if(!(c[(c[(c[h>>2]|0)+56>>2]|0)+(c[j>>2]<<2)>>2]|0))break b;c[(c[h>>2]|0)+52>>2]=(c[j>>2]|0)+1;c[j>>2]=(c[j>>2]|0)+1}}while(0);dA(c[h>>2]|0);c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}while(0);c[e>>2]=c[h>>2];k=c[e>>2]|0;i=d;return k|0}function AA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=c[g>>2]|0;do if(!(c[(c[g>>2]|0)+32>>2]|0)){c[d+32>>2]=8;b=Cb[c[135744>>2]&511](c[(c[g>>2]|0)+32>>2]<<2)|0;c[(c[g>>2]|0)+40>>2]=b;if(!(c[(c[g>>2]|0)+40>>2]|0)){Qz(c[f>>2]|0,139256);c[(c[g>>2]|0)+32>>2]=0;i=e;return}}else if((c[d+36>>2]|0)>=(c[(c[g>>2]|0)+32>>2]|0)){b=(c[g>>2]|0)+32|0;c[b>>2]=c[b>>2]<<1;c[j>>2]=Hb[c[135760>>2]&511](c[(c[g>>2]|0)+40>>2]|0,c[(c[g>>2]|0)+32>>2]<<2)|0;if(c[j>>2]|0){c[(c[g>>2]|0)+40>>2]=c[j>>2];break}Qz(c[f>>2]|0,139256);b=(c[g>>2]|0)+32|0;c[b>>2]=(c[b>>2]|0)/2|0;i=e;return}while(0);c[(c[(c[g>>2]|0)+40>>2]|0)+(c[(c[g>>2]|0)+36>>2]<<2)>>2]=c[h>>2];h=(c[g>>2]|0)+36|0;c[h>>2]=(c[h>>2]|0)+1;i=e;return}function BA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[(c[e>>2]|0)+28>>2]=0;c[f>>2]=GA(c[e>>2]|0)|0;if(!(c[f>>2]|0)){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}if(!(c[(c[e>>2]|0)+28>>2]|0)){c[(c[e>>2]|0)+8>>2]=1450;Yz(c[e>>2]|0,139592)}HA(c[e>>2]|0)|0;c[d>>2]=1;g=c[d>>2]|0;i=b;return g|0}function CA(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;h=i;i=i+32|0;j=h+28|0;k=h+24|0;l=h+20|0;m=h+16|0;n=h+12|0;o=h+8|0;p=h+4|0;q=h;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=0;do switch(c[k>>2]|0){case 128:{c[q>>2]=HL(c[l>>2]|0)|0;break}case 104:{c[q>>2]=mL(c[l>>2]|0)|0;break}case 109:{c[q>>2]=sL(c[l>>2]|0)|0;break}case 108:{c[q>>2]=rL(c[l>>2]|0)|0;break}case 10:{c[m>>2]=((c[m>>2]|0)!=0^1)&1;r=14;break}case 112:{c[q>>2]=wL(c[l>>2]|0)|0;break}case 105:{c[q>>2]=nL(c[l>>2]|0)|0;break}case 9:{r=14;break}case 113:{c[q>>2]=xL(c[l>>2]|0)|0;break}case 110:{c[q>>2]=uL(c[l>>2]|0)|0;break}case 116:{c[q>>2]=AL(c[l>>2]|0)|0;break}case 115:{c[q>>2]=zL(c[l>>2]|0)|0;break}case 102:{c[q>>2]=lL(c[l>>2]|0)|0;break}case 15:{c[m>>2]=((c[m>>2]|0)!=0^1)&1;r=49;break}case 121:{c[q>>2]=EL(c[l>>2]|0)|0;break}case 136:{c[q>>2]=fL(c[l>>2]|0,c[p>>2]|0)|0;break}case 134:{c[q>>2]=jL(c[l>>2]|0)|0;break}case 135:{c[q>>2]=0;break}case 122:{c[q>>2]=LL(c[l>>2]|0)|0;break}case 6:{if((c[l>>2]|0)!=10)s=(c[l>>2]|0)!=13;else s=0;c[q>>2]=s&1;break}case 13:{r=47;break}case 111:{c[q>>2]=vL(c[l>>2]|0)|0;break}case 11:{r=27;break}case 12:{c[m>>2]=((c[m>>2]|0)!=0^1)&1;r=27;break}case 107:{c[q>>2]=tL(c[l>>2]|0)|0;break}case 123:{c[q>>2]=OL(c[l>>2]|0)|0;break}case 7:{r=10;break}case 8:{c[m>>2]=((c[m>>2]|0)!=0^1)&1;r=10;break}case 2:{if((c[l>>2]|0)>=(c[n>>2]|0))t=(c[l>>2]|0)<=(c[o>>2]|0);else t=0;c[q>>2]=t&1;break}case 133:{c[q>>2]=iL(c[l>>2]|0)|0;break}case 118:{c[q>>2]=BL(c[l>>2]|0)|0;break}case 124:{c[q>>2]=ML(c[l>>2]|0)|0;break}case 131:{c[q>>2]=gL(c[l>>2]|0)|0;break}case 132:{c[q>>2]=hL(c[l>>2]|0)|0;break}case 100:{c[q>>2]=kL(c[l>>2]|0)|0;break}case 103:{c[q>>2]=oL(c[l>>2]|0)|0;break}case 14:{c[m>>2]=((c[m>>2]|0)!=0^1)&1;r=47;break}case 1:case 3:case 4:case 5:{c[j>>2]=-1;u=c[j>>2]|0;i=h;return u|0}case 129:{c[q>>2]=IL(c[l>>2]|0)|0;break}case 130:{c[q>>2]=KL(c[l>>2]|0)|0;break}case 106:{c[q>>2]=qL(c[l>>2]|0)|0;break}case 125:{c[q>>2]=NL(c[l>>2]|0)|0;break}case 117:{c[q>>2]=FL(c[l>>2]|0)|0;break}case 101:{c[q>>2]=pL(c[l>>2]|0)|0;break}case 16:{r=49;break}case 126:{c[q>>2]=GL(c[l>>2]|0)|0;break}case 127:{c[q>>2]=JL(c[l>>2]|0)|0;break}case 120:{c[q>>2]=CL(c[l>>2]|0)|0;break}case 119:{c[q>>2]=DL(c[l>>2]|0)|0;break}case 114:{c[q>>2]=yL(c[l>>2]|0)|0;break}default:{}}while(0);if((r|0)==10){if((c[l>>2]|0)==10|(c[l>>2]|0)==13|(c[l>>2]|0)==9)v=1;else v=(c[l>>2]|0)==32;c[q>>2]=v&1}else if((r|0)==14){v=c[l>>2]|0;if((c[l>>2]|0)<256)if(((!(65<=(v|0)&(c[l>>2]|0)<=90)?!(97<=(c[l>>2]|0)&(c[l>>2]|0)<=122):0)?!(192<=(c[l>>2]|0)&(c[l>>2]|0)<=214):0)?!(216<=(c[l>>2]|0)&(c[l>>2]|0)<=246|248<=(c[l>>2]|0)):0)r=20;else w=1;else if(DQ(v,199744)|0)w=1;else r=20;do if((r|0)==20){v=c[l>>2]|0;if((c[l>>2]|0)<256){if((v|0)==95){w=1;break}}else{if(19968<=(v|0)&(c[l>>2]|0)<=40869|(c[l>>2]|0)==12295){w=1;break}if(12321<=(c[l>>2]|0)&(c[l>>2]|0)<=12329|(c[l>>2]|0)==95){w=1;break}}w=(c[l>>2]|0)==58}while(0);c[q>>2]=w&1}else if((r|0)==27){w=c[l>>2]|0;if((c[l>>2]|0)<256)if(((!(65<=(w|0)&(c[l>>2]|0)<=90)?!(97<=(c[l>>2]|0)&(c[l>>2]|0)<=122):0)?!(192<=(c[l>>2]|0)&(c[l>>2]|0)<=214):0)?!(216<=(c[l>>2]|0)&(c[l>>2]|0)<=246|248<=(c[l>>2]|0)):0)r=33;else x=1;else if(DQ(w,199744)|0)x=1;else r=33;do if((r|0)==33){if((c[l>>2]|0)>=256){if(19968<=(c[l>>2]|0)&(c[l>>2]|0)<=40869|(c[l>>2]|0)==12295){x=1;break}if(12321<=(c[l>>2]|0)&(c[l>>2]|0)<=12329){x=1;break}}w=c[l>>2]|0;if((c[l>>2]|0)<256){if(48<=(w|0)&(c[l>>2]|0)<=57|(c[l>>2]|0)==46|(c[l>>2]|0)==45|(c[l>>2]|0)==95|(c[l>>2]|0)==58){x=1;break}}else{v=(DQ(w,200216)|0)!=0;if(v|(c[l>>2]|0)==46|(c[l>>2]|0)==45|(c[l>>2]|0)==95|(c[l>>2]|0)==58){x=1;break}}if((c[l>>2]|0)>=256?(DQ(c[l>>2]|0,200144)|0)!=0:0){x=1;break}v=c[l>>2]|0;if((c[l>>2]|0)<256)y=(v|0)==183&1;else y=DQ(v,200272)|0;x=(y|0)!=0}while(0);c[q>>2]=x&1}else if((r|0)==47)c[q>>2]=vL(c[l>>2]|0)|0;else if((r|0)==49){c[q>>2]=yL(c[l>>2]|0)|0;if(!(c[q>>2]|0))c[q>>2]=LL(c[l>>2]|0)|0;if(!(c[q>>2]|0))c[q>>2]=gL(c[l>>2]|0)|0}l=c[q>>2]|0;if(c[m>>2]|0){c[j>>2]=((l|0)!=0^1)&1;u=c[j>>2]|0;i=h;return u|0}else{c[j>>2]=l;u=c[j>>2]|0;i=h;return u|0}return 0}function DA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;a:do if((c[f>>2]|0)==1|(c[f>>2]|0)==2|(c[f>>2]|0)==3|(c[f>>2]|0)==4|(c[f>>2]|0)==5|(c[f>>2]|0)==6)c[e>>2]=1;else{if((c[g>>2]|0)==1|(c[g>>2]|0)==2|(c[g>>2]|0)==3|(c[g>>2]|0)==4|(c[g>>2]|0)==5|(c[g>>2]|0)==6){c[e>>2]=1;break}if((c[f>>2]|0)==(c[g>>2]|0)){c[e>>2]=1;break}if((c[f>>2]|0)>>>0>(c[g>>2]|0)>>>0){c[h>>2]=c[f>>2];c[f>>2]=c[g>>2];c[g>>2]=c[h>>2]}b:do switch(c[f>>2]|0){case 100:{if((c[g>>2]|0)>>>0<=105){c[e>>2]=1;break a}else{c[e>>2]=0;break a}break}case 132:case 133:case 134:case 135:{c[e>>2]=0;break a;break}case 126:{if((c[g>>2]|0)>>>0<=130){c[e>>2]=1;break a}else{c[e>>2]=0;break a}break}case 106:{if((c[g>>2]|0)>>>0<=109){c[e>>2]=1;break a}else{c[e>>2]=0;break a}break}case 13:{if((((((!((c[g>>2]|0)==14|(c[g>>2]|0)==15)?!((c[g>>2]|0)>>>0>=100&(c[g>>2]|0)>>>0<=105):0)?!((c[g>>2]|0)>>>0>=106&(c[g>>2]|0)>>>0<=109):0)?!((c[g>>2]|0)>>>0>=114&(c[g>>2]|0)>>>0<=121):0)?!((c[g>>2]|0)>>>0>=122&(c[g>>2]|0)>>>0<=125):0)?!((c[g>>2]|0)>>>0>=126&(c[g>>2]|0)>>>0<=130):0)?!((c[g>>2]|0)>>>0>=131&(c[g>>2]|0)>>>0<=135):0)break b;c[e>>2]=0;break a;break}case 131:{if((c[g>>2]|0)>>>0<=135){c[e>>2]=1;break a}else{c[e>>2]=0;break a}break}case 15:{if((((((c[g>>2]|0)!=14?!((c[g>>2]|0)>>>0>=106&(c[g>>2]|0)>>>0<=109):0)?!((c[g>>2]|0)>>>0>=114&(c[g>>2]|0)>>>0<=121):0)?!((c[g>>2]|0)>>>0>=122&(c[g>>2]|0)>>>0<=125):0)?!((c[g>>2]|0)>>>0>=126&(c[g>>2]|0)>>>0<=130):0)?!((c[g>>2]|0)>>>0>=131&(c[g>>2]|0)>>>0<=135):0)break b;c[e>>2]=0;break a;break}case 7:{if((((((c[g>>2]|0)!=8?!((c[g>>2]|0)>>>0>=100&(c[g>>2]|0)>>>0<=105):0)?!((c[g>>2]|0)>>>0>=110&(c[g>>2]|0)>>>0<=113):0)?!((c[g>>2]|0)>>>0>=106&(c[g>>2]|0)>>>0<=109):0)?!((c[g>>2]|0)>>>0>=114&(c[g>>2]|0)>>>0<=121):0)?!((c[g>>2]|0)>>>0>=126&(c[g>>2]|0)>>>0<=130):0)break b;c[e>>2]=0;break a;break}case 125:case 124:case 123:{c[e>>2]=0;break a;break}case 105:case 104:case 103:case 102:case 101:{c[e>>2]=0;break a;break}case 11:{if((((((c[g>>2]|0)!=12?!((c[g>>2]|0)>>>0>=106&(c[g>>2]|0)>>>0<=109):0)?!((c[g>>2]|0)>>>0>=114&(c[g>>2]|0)>>>0<=121):0)?!((c[g>>2]|0)>>>0>=122&(c[g>>2]|0)>>>0<=125):0)?!((c[g>>2]|0)>>>0>=126&(c[g>>2]|0)>>>0<=130):0)?!((c[g>>2]|0)>>>0>=131&(c[g>>2]|0)>>>0<=135):0)break b;c[e>>2]=0;break a;break}case 110:{if((c[g>>2]|0)>>>0<=113){c[e>>2]=1;break a}else{c[e>>2]=0;break a}break}case 121:case 120:case 119:case 118:case 117:case 116:case 115:{c[e>>2]=0;break a;break}case 9:{if(((((((c[g>>2]|0)!=10?!((c[g>>2]|0)>>>0>=110&(c[g>>2]|0)>>>0<=113):0)?!((c[g>>2]|0)>>>0>=106&(c[g>>2]|0)>>>0<=109):0)?!((c[g>>2]|0)>>>0>=122&(c[g>>2]|0)>>>0<=125):0)?!((c[g>>2]|0)>>>0>=114&(c[g>>2]|0)>>>0<=121):0)?!((c[g>>2]|0)>>>0>=126&(c[g>>2]|0)>>>0<=130):0)?!((c[g>>2]|0)>>>0>=131&(c[g>>2]|0)>>>0<=135):0)break b;c[e>>2]=0;break a;break}case 122:{if((c[g>>2]|0)>>>0<=125){c[e>>2]=1;break a}else{c[e>>2]=0;break a}break}case 114:{if((c[g>>2]|0)>>>0<=121){c[e>>2]=1;break a}else{c[e>>2]=0;break a}break}case 130:case 129:case 128:case 127:{c[e>>2]=0;break a;break}case 113:case 112:case 111:{c[e>>2]=0;break a;break}case 109:case 108:case 107:{c[e>>2]=0;break a;break}default:{}}while(0);c[e>>2]=1}while(0);i=d;return c[e>>2]|0}function EA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;if((((((c[(c[f>>2]|0)+4>>2]|0)!=3?(c[(c[g>>2]|0)+4>>2]|0)!=3:0)?(c[(c[g>>2]|0)+4>>2]|0)!=4:0)?(c[(c[f>>2]|0)+4>>2]|0)!=4:0)?(c[(c[f>>2]|0)+4>>2]|0)!=5:0)?(c[(c[g>>2]|0)+4>>2]|0)!=5:0){if((c[(c[f>>2]|0)+4>>2]|0)>>>0>(c[(c[g>>2]|0)+4>>2]|0)>>>0){c[j>>2]=c[f>>2];c[f>>2]=c[g>>2];c[g>>2]=c[j>>2]}a:do if((c[(c[f>>2]|0)+4>>2]|0)!=6?(c[(c[g>>2]|0)+4>>2]|0)!=6:0){if((c[(c[f>>2]|0)+4>>2]|0)!=1?(c[(c[g>>2]|0)+4>>2]|0)!=1:0){j=c[(c[f>>2]|0)+4>>2]|0;if((c[(c[f>>2]|0)+4>>2]|0)==(c[(c[g>>2]|0)+4>>2]|0)){if((j|0)!=2){c[h>>2]=1;break}if((c[(c[f>>2]|0)+12>>2]|0)>=(c[(c[g>>2]|0)+8>>2]|0)?(c[(c[g>>2]|0)+12>>2]|0)>=(c[(c[f>>2]|0)+8>>2]|0):0){c[h>>2]=1;break}c[h>>2]=0;break}if((j|0)==2){c[l>>2]=0;if((c[c[f>>2]>>2]|0)==0?(c[c[g>>2]>>2]|0)!=0:0)m=28;else m=26;if(((m|0)==26?(c[c[f>>2]>>2]|0)!=0:0)?(c[c[g>>2]>>2]|0)==0:0)m=28;if((m|0)==28)c[l>>2]=1;c[k>>2]=c[(c[f>>2]|0)+8>>2];while(1){if((c[k>>2]|0)>(c[(c[f>>2]|0)+12>>2]|0)){m=37;break}c[h>>2]=CA(c[(c[g>>2]|0)+4>>2]|0,c[k>>2]|0,0,c[(c[g>>2]|0)+8>>2]|0,c[(c[g>>2]|0)+12>>2]|0,c[(c[g>>2]|0)+16>>2]|0)|0;if((c[h>>2]|0)<0){
m=32;break}if((c[l>>2]|0)==1&(c[h>>2]|0)==0){m=35;break}if((c[l>>2]|0)==0&(c[h>>2]|0)==1){m=35;break}c[k>>2]=(c[k>>2]|0)+1}if((m|0)==32){c[e>>2]=-1;n=c[e>>2]|0;i=d;return n|0}else if((m|0)==35){c[e>>2]=1;n=c[e>>2]|0;i=d;return n|0}else if((m|0)==37){c[e>>2]=0;n=c[e>>2]|0;i=d;return n|0}}if((c[(c[f>>2]|0)+4>>2]|0)!=136?(c[(c[g>>2]|0)+4>>2]|0)!=136:0){do if((c[(c[f>>2]|0)+4>>2]|0)>>>0>=100){if((c[(c[g>>2]|0)+4>>2]|0)>>>0<100)break;c[h>>2]=0;switch(c[(c[f>>2]|0)+4>>2]|0){case 106:{do if((c[(c[g>>2]|0)+4>>2]|0)!=107){if((c[(c[g>>2]|0)+4>>2]|0)==108)break;if((c[(c[g>>2]|0)+4>>2]|0)!=109)break a}while(0);c[h>>2]=1;break a;break}case 110:{do if((c[(c[g>>2]|0)+4>>2]|0)!=111){if((c[(c[g>>2]|0)+4>>2]|0)==112)break;if((c[(c[g>>2]|0)+4>>2]|0)!=113)break a}while(0);c[h>>2]=1;break a;break}case 114:{do if((c[(c[g>>2]|0)+4>>2]|0)!=115){if((c[(c[g>>2]|0)+4>>2]|0)==116)break;if((c[(c[g>>2]|0)+4>>2]|0)==117)break;if((c[(c[g>>2]|0)+4>>2]|0)==118)break;if((c[(c[g>>2]|0)+4>>2]|0)==119)break;if((c[(c[g>>2]|0)+4>>2]|0)==120)break;if((c[(c[g>>2]|0)+4>>2]|0)!=121)break a}while(0);c[h>>2]=1;break a;break}case 100:{do if((c[(c[g>>2]|0)+4>>2]|0)!=101){if((c[(c[g>>2]|0)+4>>2]|0)==102)break;if((c[(c[g>>2]|0)+4>>2]|0)==103)break;if((c[(c[g>>2]|0)+4>>2]|0)==104)break;if((c[(c[g>>2]|0)+4>>2]|0)!=105)break a}while(0);c[h>>2]=1;break a;break}case 131:{do if((c[(c[g>>2]|0)+4>>2]|0)!=132){if((c[(c[g>>2]|0)+4>>2]|0)==133)break;if((c[(c[g>>2]|0)+4>>2]|0)!=134)break a}while(0);c[h>>2]=1;break a;break}case 126:{do if((c[(c[g>>2]|0)+4>>2]|0)!=127){if((c[(c[g>>2]|0)+4>>2]|0)==128)break;if((c[(c[g>>2]|0)+4>>2]|0)==129)break;if((c[(c[g>>2]|0)+4>>2]|0)!=130)break a}while(0);c[h>>2]=1;break a;break}case 122:{do if((c[(c[g>>2]|0)+4>>2]|0)!=123){if((c[(c[g>>2]|0)+4>>2]|0)==124)break;if((c[(c[g>>2]|0)+4>>2]|0)!=125)break a}while(0);c[h>>2]=1;break a;break}default:{do if((c[(c[g>>2]|0)+4>>2]|0)>>>0>=100){if((c[(c[g>>2]|0)+4>>2]|0)>>>0>=136)break;c[h>>2]=0;break a}while(0);c[e>>2]=1;n=c[e>>2]|0;i=d;return n|0}}}while(0);do if((c[(c[f>>2]|0)+4>>2]|0)==7){if((c[(c[g>>2]|0)+4>>2]|0)!=8)break;c[h>>2]=0;break a}while(0);do if((c[(c[f>>2]|0)+4>>2]|0)==9){if((c[(c[g>>2]|0)+4>>2]|0)!=10)break;c[h>>2]=0;break a}while(0);do if((c[(c[f>>2]|0)+4>>2]|0)==11){if((c[(c[g>>2]|0)+4>>2]|0)!=12)break;c[h>>2]=0;break a}while(0);do if((c[(c[f>>2]|0)+4>>2]|0)==13){if((c[(c[g>>2]|0)+4>>2]|0)!=14)break;c[h>>2]=0;break a}while(0);do if((c[(c[f>>2]|0)+4>>2]|0)==15){if((c[(c[g>>2]|0)+4>>2]|0)!=16)break;c[h>>2]=0;break a}while(0);c[e>>2]=1;n=c[e>>2]|0;i=d;return n|0}if((c[(c[f>>2]|0)+4>>2]|0)==(c[(c[g>>2]|0)+4>>2]|0)){c[h>>2]=qy(c[(c[f>>2]|0)+16>>2]|0,c[(c[g>>2]|0)+16>>2]|0)|0;break}c[e>>2]=1;n=c[e>>2]|0;i=d;return n|0}c[e>>2]=0;n=c[e>>2]|0;i=d;return n|0}else m=12;while(0);if((m|0)==12)c[h>>2]=1;if((c[c[f>>2]>>2]|0)==0?(c[c[g>>2]>>2]|0)!=0:0)m=105;else m=103;if(((m|0)==103?(c[c[f>>2]>>2]|0)!=0:0)?(c[c[g>>2]>>2]|0)==0:0)m=105;if((m|0)==105)c[h>>2]=((c[h>>2]|0)!=0^1)&1;c[e>>2]=c[h>>2];n=c[e>>2]|0;i=d;return n|0}c[e>>2]=-1;n=c[e>>2]|0;i=d;return n|0}function FA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if(!(c[g>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}c[h>>2]=IA(c[f>>2]|0,c[c[g>>2]>>2]|0,c[(c[g>>2]|0)+4>>2]|0,c[(c[g>>2]|0)+8>>2]|0,c[(c[g>>2]|0)+12>>2]|0)|0;if(!(c[h>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}if((c[(c[g>>2]|0)+16>>2]|0)!=0?(b=my(c[(c[g>>2]|0)+16>>2]|0)|0,c[(c[h>>2]|0)+16>>2]=b,(c[(c[h>>2]|0)+16>>2]|0)==0):0){Qz(c[f>>2]|0,139336);yA(c[h>>2]|0);c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}function GA(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+32|0;e=b+24|0;f=b+20|0;g=b+16|0;h=b+12|0;j=b+8|0;k=b+4|0;l=b;c[f>>2]=a;c[g>>2]=JA(c[f>>2]|0)|0;a=c[f>>2]|0;if((c[g>>2]|0)>0){m=eA(a,2)|0;c[(c[f>>2]|0)+28>>2]=m;if(!(c[(c[f>>2]|0)+28>>2]|0)){c[e>>2]=-1;n=c[e>>2]|0;i=b;return n|0}else{c[g>>2]=oe(0,c[(c[f>>2]|0)+4>>2]|0,h)|0;c[(c[(c[f>>2]|0)+28>>2]|0)+32>>2]=c[g>>2];g=(c[f>>2]|0)+4|0;c[g>>2]=(c[g>>2]|0)+(c[h>>2]|0);c[e>>2]=1;n=c[e>>2]|0;i=b;return n|0}}if((d[c[a+4>>2]>>0]|0|0)==124){c[e>>2]=0;n=c[e>>2]|0;i=b;return n|0}if(!(d[c[(c[f>>2]|0)+4>>2]>>0]|0)){c[e>>2]=0;n=c[e>>2]|0;i=b;return n|0}if((d[c[(c[f>>2]|0)+4>>2]>>0]|0|0)==41){c[e>>2]=0;n=c[e>>2]|0;i=b;return n|0}a=(c[f>>2]|0)+4|0;h=c[a>>2]|0;if((d[c[(c[f>>2]|0)+4>>2]>>0]|0|0)!=40){if(((d[h>>0]|0|0)!=91?(d[c[(c[f>>2]|0)+4>>2]>>0]|0|0)!=92:0)?(d[c[(c[f>>2]|0)+4>>2]>>0]|0|0)!=46:0){c[e>>2]=0;n=c[e>>2]|0;i=b;return n|0}KA(c[f>>2]|0);c[e>>2]=1;n=c[e>>2]|0;i=b;return n|0}c[a>>2]=h+1;jA(c[f>>2]|0,c[(c[f>>2]|0)+24>>2]|0,0);c[l>>2]=c[(c[f>>2]|0)+24>>2];jA(c[f>>2]|0,c[(c[f>>2]|0)+24>>2]|0,0);c[j>>2]=c[(c[f>>2]|0)+24>>2];c[k>>2]=c[(c[f>>2]|0)+20>>2];c[(c[f>>2]|0)+20>>2]=0;c[(c[f>>2]|0)+28>>2]=0;Xz(c[f>>2]|0,0);h=c[f>>2]|0;if((d[c[(c[f>>2]|0)+4>>2]>>0]|0|0)==41){a=h+4|0;c[a>>2]=(c[a>>2]|0)+1}else{c[h+8>>2]=1450;Yz(c[f>>2]|0,139672)}h=eA(c[f>>2]|0,4)|0;c[(c[f>>2]|0)+28>>2]=h;if(!(c[(c[f>>2]|0)+28>>2]|0)){c[e>>2]=-1;n=c[e>>2]|0;i=b;return n|0}else{c[(c[(c[f>>2]|0)+28>>2]|0)+36>>2]=c[j>>2];c[(c[(c[f>>2]|0)+28>>2]|0)+40>>2]=c[l>>2];c[(c[(c[f>>2]|0)+28>>2]|0)+44>>2]=c[(c[f>>2]|0)+24>>2];c[(c[f>>2]|0)+20>>2]=c[k>>2];c[e>>2]=1;n=c[e>>2]|0;i=b;return n|0}return 0}function HA(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+32|0;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;j=b;c[f>>2]=a;c[g>>2]=d[c[(c[f>>2]|0)+4>>2]>>0];if((c[g>>2]|0)==63|(c[g>>2]|0)==42|(c[g>>2]|0)==43){do if(c[(c[f>>2]|0)+28>>2]|0){if((c[g>>2]|0)==63){c[(c[(c[f>>2]|0)+28>>2]|0)+8>>2]=3;break}if((c[g>>2]|0)==42){c[(c[(c[f>>2]|0)+28>>2]|0)+8>>2]=4;break}if((c[g>>2]|0)==43)c[(c[(c[f>>2]|0)+28>>2]|0)+8>>2]=5}while(0);a=(c[f>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[e>>2]=1;k=c[e>>2]|0;i=b;return k|0}if((c[g>>2]|0)!=123){c[e>>2]=0;k=c[e>>2]|0;i=b;return k|0}c[h>>2]=0;c[j>>2]=0;a=(c[f>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[g>>2]=LA(c[f>>2]|0)|0;if((c[g>>2]|0)>=0)c[h>>2]=c[g>>2];do if((d[c[(c[f>>2]|0)+4>>2]>>0]|0|0)==44){a=(c[f>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;if((d[c[(c[f>>2]|0)+4>>2]>>0]|0|0)==125){c[j>>2]=2147483647;break}c[g>>2]=LA(c[f>>2]|0)|0;if((c[g>>2]|0)>=0){c[j>>2]=c[g>>2];break}else{c[(c[f>>2]|0)+8>>2]=1450;Yz(c[f>>2]|0,139624);break}}while(0);g=c[f>>2]|0;if((d[c[(c[f>>2]|0)+4>>2]>>0]|0|0)==125){a=g+4|0;c[a>>2]=(c[a>>2]|0)+1}else{c[g+8>>2]=1450;Yz(c[f>>2]|0,139648)}if(!(c[j>>2]|0))c[j>>2]=c[h>>2];if(c[(c[f>>2]|0)+28>>2]|0){c[(c[(c[f>>2]|0)+28>>2]|0)+8>>2]=8;c[(c[(c[f>>2]|0)+28>>2]|0)+12>>2]=c[h>>2];c[(c[(c[f>>2]|0)+28>>2]|0)+16>>2]=c[j>>2]}c[e>>2]=1;k=c[e>>2]|0;i=b;return k|0}function IA(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+32|0;h=g+24|0;j=g+20|0;k=g+16|0;l=g+12|0;m=g+8|0;n=g+4|0;o=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=Cb[c[135744>>2]&511](20)|0;if(!(c[o>>2]|0)){Qz(c[j>>2]|0,139336);c[h>>2]=0;p=c[h>>2]|0;i=g;return p|0}else{c[c[o>>2]>>2]=c[k>>2];c[(c[o>>2]|0)+4>>2]=c[l>>2];c[(c[o>>2]|0)+8>>2]=c[m>>2];c[(c[o>>2]|0)+12>>2]=c[n>>2];c[h>>2]=c[o>>2];p=c[h>>2]|0;i=g;return p|0}return 0}function JA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;c[e>>2]=a;c[f>>2]=oe(0,c[(c[e>>2]|0)+4>>2]|0,b)|0;if((c[f>>2]|0)==46|(c[f>>2]|0)==92|(c[f>>2]|0)==63|(c[f>>2]|0)==42|(c[f>>2]|0)==43|(c[f>>2]|0)==40|(c[f>>2]|0)==41|(c[f>>2]|0)==124|(c[f>>2]|0)==91|(c[f>>2]|0)==93|(c[f>>2]|0)==0){c[d>>2]=-1;g=c[d>>2]|0;i=b;return g|0}else{c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function KA(a){a=a|0;var b=0,e=0,f=0;b=i;i=i+16|0;e=b;c[e>>2]=a;a=c[e>>2]|0;if((d[c[(c[e>>2]|0)+4>>2]>>0]|0|0)!=91){NA(a);i=b;return}f=a+4|0;c[f>>2]=(c[f>>2]|0)+1;f=eA(c[e>>2]|0,3)|0;c[(c[e>>2]|0)+28>>2]=f;if(!(c[(c[e>>2]|0)+28>>2]|0)){i=b;return}MA(c[e>>2]|0);f=c[e>>2]|0;if((d[c[(c[e>>2]|0)+4>>2]>>0]|0|0)==93){a=f+4|0;c[a>>2]=(c[a>>2]|0)+1;i=b;return}else{c[f+8>>2]=1450;Yz(c[e>>2]|0,139704);i=b;return}}function LA(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[f>>2]=a;c[g>>2]=0;c[h>>2]=0;while(1){if((d[c[(c[f>>2]|0)+4>>2]>>0]|0|0)<48)break;if((d[c[(c[f>>2]|0)+4>>2]>>0]|0|0)>57)break;c[g>>2]=((c[g>>2]|0)*10|0)+((d[c[(c[f>>2]|0)+4>>2]>>0]|0)-48);c[h>>2]=1;a=(c[f>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1}if((c[h>>2]|0)!=1){c[e>>2]=-1;j=c[e>>2]|0;i=b;return j|0}else{c[e>>2]=c[g>>2];j=c[e>>2]|0;i=b;return j|0}return 0}function MA(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[e>>2]=a;c[f>>2]=c[(c[e>>2]|0)+12>>2];while(1){if((d[c[(c[e>>2]|0)+4>>2]>>0]|0|0)==93){j=13;break}if(c[(c[e>>2]|0)+8>>2]|0){j=13;break}a=c[e>>2]|0;if((d[c[(c[e>>2]|0)+4>>2]>>0]|0|0)==94){c[g>>2]=c[a+12>>2];k=(c[e>>2]|0)+4|0;c[k>>2]=(c[k>>2]|0)+1;c[(c[e>>2]|0)+12>>2]=((c[(c[e>>2]|0)+12>>2]|0)!=0^1)&1;OA(c[e>>2]|0);c[(c[e>>2]|0)+12>>2]=c[g>>2];continue}if((d[c[a+4>>2]>>0]|0|0)==45?(d[(c[(c[e>>2]|0)+4>>2]|0)+1>>0]|0|0)==91:0){j=8;break}if((d[c[(c[e>>2]|0)+4>>2]>>0]|0|0)==93)continue;OA(c[e>>2]|0)}if((j|0)==8){c[h>>2]=c[(c[e>>2]|0)+12>>2];c[(c[e>>2]|0)+12>>2]=2;g=(c[e>>2]|0)+4|0;c[g>>2]=(c[g>>2]|0)+1;g=(c[e>>2]|0)+4|0;c[g>>2]=(c[g>>2]|0)+1;MA(c[e>>2]|0);g=c[e>>2]|0;if((d[c[(c[e>>2]|0)+4>>2]>>0]|0|0)==93){a=g+4|0;c[a>>2]=(c[a>>2]|0)+1;c[(c[e>>2]|0)+12>>2]=c[h>>2];l=c[f>>2]|0;m=c[e>>2]|0;n=m+12|0;c[n>>2]=l;i=b;return}else{c[g+8>>2]=1450;Yz(c[e>>2]|0,139968);l=c[f>>2]|0;m=c[e>>2]|0;n=m+12|0;c[n>>2]=l;i=b;return}}else if((j|0)==13){l=c[f>>2]|0;m=c[e>>2]|0;n=m+12|0;c[n>>2]=l;i=b;return}}function NA(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;a=c[e>>2]|0;if((d[c[(c[e>>2]|0)+4>>2]>>0]|0|0)==46){h=c[e>>2]|0;if(c[a+28>>2]|0){if((c[(c[h+28>>2]|0)+4>>2]|0)==3)PA(c[e>>2]|0,c[(c[e>>2]|0)+28>>2]|0,c[(c[e>>2]|0)+12>>2]|0,6,0,0,0)}else{j=eA(h,6)|0;c[(c[e>>2]|0)+28>>2]=j}j=(c[e>>2]|0)+4|0;c[j>>2]=(c[j>>2]|0)+1;i=b;return}j=c[e>>2]|0;if((d[c[a+4>>2]>>0]|0|0)!=92){c[j+8>>2]=1450;Yz(c[e>>2]|0,139744);i=b;return}a=j+4|0;c[a>>2]=(c[a>>2]|0)+1;c[f>>2]=d[c[(c[e>>2]|0)+4>>2]>>0];if((c[f>>2]|0)==112){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;a=c[e>>2]|0;if((d[c[(c[e>>2]|0)+4>>2]>>0]|0|0)!=123){c[a+8>>2]=1450;Yz(c[e>>2]|0,139776);i=b;return}j=a+4|0;c[j>>2]=(c[j>>2]|0)+1;QA(c[e>>2]|0);j=c[e>>2]|0;if((d[c[(c[e>>2]|0)+4>>2]>>0]|0|0)!=125){c[j+8>>2]=1450;Yz(c[e>>2]|0,139792);i=b;return}else{a=j+4|0;c[a>>2]=(c[a>>2]|0)+1;i=b;return}}if((c[f>>2]|0)==80){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;a=c[e>>2]|0;if((d[c[(c[e>>2]|0)+4>>2]>>0]|0|0)!=123){c[a+8>>2]=1450;Yz(c[e>>2]|0,139776);i=b;return}j=a+4|0;c[j>>2]=(c[j>>2]|0)+1;QA(c[e>>2]|0);c[(c[(c[e>>2]|0)+28>>2]|0)+28>>2]=1;j=c[e>>2]|0;if((d[c[(c[e>>2]|0)+4>>2]>>0]|0|0)!=125){c[j+8>>2]=1450;Yz(c[e>>2]|0,139792);i=b;return}else{a=j+4|0;c[a>>2]=(c[a>>2]|0)+1;i=b;return}}if((c[f>>2]|0)==110|(c[f>>2]|0)==114|(c[f>>2]|0)==116|(c[f>>2]|0)==92|(c[f>>2]|0)==124|(c[f>>2]|0)==46|(c[f>>2]|0)==63|(c[f>>2]|0)==42|(c[f>>2]|0)==43|(c[f>>2]|0)==40|(c[f>>2]|0)==41|(c[f>>2]|0)==123|(c[f>>2]|0)==125|(c[f>>2]|0)==45|(c[f>>2]|0)==91|(c[f>>2]|0)==93|(c[f>>2]|0)==94){a=c[e>>2]|0;do if(!(c[(c[e>>2]|0)+28>>2]|0)){j=eA(a,2)|0;c[(c[e>>2]|0)+28>>2]=j;if(c[(c[e>>2]|0)+28>>2]|0){j=c[f>>2]|0;if((j|0)==116){c[(c[(c[e>>2]|0)+28>>2]|0)+32>>2]=9;break}else if((j|0)==110){c[(c[(c[e>>2]|0)+28>>2]|0)+32>>2]=10;break}else if((j|0)==114){c[(c[(c[e>>2]|0)+28>>2]|0)+32>>2]=13;break}else{c[(c[(c[e>>2]|0)+28>>2]|0)+32>>2]=c[f>>2];break}}}else if((c[(c[a+28>>2]|0)+4>>2]|0)==3){j=c[f>>2]|0;if((j|0)==110)c[f>>2]=10;else if((j|0)==114)c[f>>2]=13;else if((j|0)==116)c[f>>2]=9;PA(c[e>>2]|0,c[(c[e>>2]|0)+28>>2]|0,c[(c[e>>2]|0)+12>>2]|0,2,c[f>>2]|0,c[f>>2]|0,0)}while(0);a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;i=b;return}if(!((c[f>>2]|0)==115|(c[f>>2]|0)==83|(c[f>>2]|0)==105|(c[f>>2]|0)==73|(c[f>>2]|0)==99|(c[f>>2]|0)==67|(c[f>>2]|0)==100|(c[f>>2]|0)==68|(c[f>>2]|0)==119|(c[f>>2]|0)==87)){c[(c[e>>2]|0)+8>>2]=1450;Yz(c[e>>2]|0,139808);i=b;return}c[g>>2]=7;do switch(c[f>>2]|0){case 115:{c[g>>2]=7;break}case 83:{c[g>>2]=8;break}case 99:{c[g>>2]=11;break}case 67:{c[g>>2]=12;break}case 119:{c[g>>2]=15;break}case 87:{c[g>>2]=16;break}case 105:{c[g>>2]=9;break}case 73:{c[g>>2]=10;break}case 100:{c[g>>2]=13;break}case 68:{c[g>>2]=14;break}default:{}}while(0);f=(c[e>>2]|0)+4|0;c[f>>2]=(c[f>>2]|0)+1;f=c[e>>2]|0;if(!(c[(c[e>>2]|0)+28>>2]|0)){a=eA(f,c[g>>2]|0)|0;c[(c[e>>2]|0)+28>>2]=a;i=b;return}if((c[(c[f+28>>2]|0)+4>>2]|0)!=3){i=b;return}PA(c[e>>2]|0,c[(c[e>>2]|0)+28>>2]|0,c[(c[e>>2]|0)+12>>2]|0,c[g>>2]|0,0,0,0);i=b;return}function OA(a){a=a|0;var b=0,e=0,f=0;b=i;i=i+16|0;e=b;c[e>>2]=a;while(1){a=c[e>>2]|0;if((d[c[(c[e>>2]|0)+4>>2]>>0]|0|0)==92)NA(a);else RA(a);if((d[c[(c[e>>2]|0)+4>>2]>>0]|0|0)==93){f=10;break}if((d[c[(c[e>>2]|0)+4>>2]>>0]|0|0)==94){f=10;break}if((d[c[(c[e>>2]|0)+4>>2]>>0]|0|0)==45){f=10;break}if(!(d[c[(c[e>>2]|0)+4>>2]>>0]|0)){f=10;break}if(c[(c[e>>2]|0)+8>>2]|0){f=10;break}}if((f|0)==10){i=b;return}}function PA(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i;i=i+48|0;k=j+32|0;l=j+28|0;m=j+24|0;n=j+20|0;o=j+16|0;p=j+12|0;q=j+8|0;r=j+4|0;s=j;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=h;if(!(c[l>>2]|0)){c[(c[k>>2]|0)+8>>2]=1450;Yz(c[k>>2]|0,139896);i=j;return}if((c[(c[l>>2]|0)+4>>2]|0)!=3){c[(c[k>>2]|0)+8>>2]=1450;Yz(c[k>>2]|0,139920);i=j;return}h=c[l>>2]|0;do if(!(c[(c[l>>2]|0)+48>>2]|0)){c[h+48>>2]=4;g=Cb[c[135744>>2]&511](c[(c[l>>2]|0)+48>>2]<<2)|0;c[(c[l>>2]|0)+56>>2]=g;if(!(c[(c[l>>2]|0)+56>>2]|0)){Qz(c[k>>2]|0,139952);c[(c[l>>2]|0)+48>>2]=0;i=j;return}}else if((c[h+52>>2]|0)>=(c[(c[l>>2]|0)+48>>2]|0)){g=(c[l>>2]|0)+48|0;c[g>>2]=c[g>>2]<<1;c[s>>2]=Hb[c[135760>>2]&511](c[(c[l>>2]|0)+56>>2]|0,c[(c[l>>2]|0)+48>>2]<<2)|0;if(c[s>>2]|0){c[(c[l>>2]|0)+56>>2]=c[s>>2];break}Qz(c[k>>2]|0,139952);g=(c[l>>2]|0)+48|0;c[g>>2]=(c[g>>2]|0)/2|0;i=j;return}while(0);c[r>>2]=IA(c[k>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0)|0;if(!(c[r>>2]|0)){i=j;return}c[(c[r>>2]|0)+16>>2]=c[q>>2];q=c[r>>2]|0;r=(c[l>>2]|0)+52|0;p=c[r>>2]|0;c[r>>2]=p+1;c[(c[(c[l>>2]|0)+56>>2]|0)+(p<<2)>>2]=q;i=j;return}function QA(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;j=b;c[e>>2]=a;c[g>>2]=0;c[h>>2]=0;c[f>>2]=d[c[(c[e>>2]|0)+4>>2]>>0];do if((c[f>>2]|0)==76){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[f>>2]=d[c[(c[e>>2]|0)+4>>2]>>0];if((c[f>>2]|0)==117){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[g>>2]=101;break}if((c[f>>2]|0)==108){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[g>>2]=102;break}if((c[f>>2]|0)==116){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[g>>2]=103;break}if((c[f>>2]|0)==109){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[g>>2]=104;break}if((c[f>>2]|0)==111){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[g>>2]=105;break}else{c[g>>2]=100;break}}else{if((c[f>>2]|0)==77){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[f>>2]=d[c[(c[e>>2]|0)+4>>2]>>0];if((c[f>>2]|0)==110){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[g>>2]=107;break}if((c[f>>2]|0)==99){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[g>>2]=108;break}if((c[f>>2]|0)==101){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[g>>2]=109;break}else{c[g>>2]=106;break}}if((c[f>>2]|0)==78){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[f>>2]=d[c[(c[e>>2]|0)+4>>2]>>0];if((c[f>>2]|0)==100){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[g>>2]=111;break}if((c[f>>2]|0)==108){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[g>>2]=112;break}if((c[f>>2]|0)==111){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[g>>2]=113;break}else{c[g>>2]=110;break}}if((c[f>>2]|0)==80){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[f>>2]=d[c[(c[e>>2]|0)+4>>2]>>0];if((c[f>>2]|0)==99){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[g>>2]=115;break}if((c[f>>2]|0)==100){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[g>>2]=116;break}if((c[f>>2]|0)==115){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[g>>2]=117;break}if((c[f>>2]|0)==101){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[g>>2]=118;break}if((c[f>>2]|0)==105){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[g>>2]=119;break}if((c[f>>2]|0)==102){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[g>>2]=120;break}if((c[f>>2]|0)==111){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[g>>2]=121;break}else{c[g>>2]=114;break}}if((c[f>>2]|0)==90){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[f>>2]=d[c[(c[e>>2]|0)+4>>2]>>0];if((c[f>>2]|0)==115){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[g>>2]=123;break}if((c[f>>2]|0)==108){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[g>>2]=124;break}if((c[f>>2]|0)==112){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[g>>2]=125;break}else{c[g>>2]=122;break}}if((c[f>>2]|0)==83){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[f>>2]=d[c[(c[e>>2]|0)+4>>2]>>0];if((c[f>>2]|0)==109){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[g>>2]=127;break}if((c[f>>2]|0)==99){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[g>>2]=128;break}if((c[f>>2]|0)==107){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[g>>2]=129;break}if((c[f>>2]|0)==111){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[g>>2]=130;break}else{c[g>>2]=126;break}}if((c[f>>2]|0)==67){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[f>>2]=d[c[(c[e>>2]|0)+4>>2]>>0];if((c[f>>2]|0)==99){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[g>>2]=132;break}if((c[f>>2]|0)==102){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[g>>2]=133;break}if((c[f>>2]|0)==111){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[g>>2]=134;break}if((c[f>>2]|0)==110){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[g>>2]=135;break}else{c[g>>2]=131;break}}a=c[e>>2]|0;if((c[f>>2]|0)!=73){c[a+8>>2]=1450;Yz(c[e>>2]|0,139872);i=b;return}k=a+4|0;c[k>>2]=(c[k>>2]|0)+1;c[f>>2]=d[c[(c[e>>2]|0)+4>>2]>>0];k=c[e>>2]|0;if((c[f>>2]|0)!=115){c[k+8>>2]=1450;Yz(c[e>>2]|0,139856);i=b;return}a=k+4|0;c[a>>2]=(c[a>>2]|0)+1;c[j>>2]=c[(c[e>>2]|0)+4>>2];c[f>>2]=d[c[(c[e>>2]|0)+4>>2]>>0];if(!((!((c[f>>2]|0)>=97&(c[f>>2]|0)<=122)?!((c[f>>2]|0)>=65&(c[f>>2]|0)<=90):0)?!((c[f>>2]|0)>=48&(c[f>>2]|0)<=57|(c[f>>2]|0)==45):0))l=79;a:do if((l|0)==79){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[f>>2]=d[c[(c[e>>2]|0)+4>>2]>>0];while(1){if((!((c[f>>2]|0)>=97&(c[f>>2]|0)<=122)?!((c[f>>2]|0)>=65&(c[f>>2]|0)<=90):0)?!((c[f>>2]|0)>=48&(c[f>>2]|0)<=57|(c[f>>2]|0)==45):0)break a;a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[f>>2]=d[c[(c[e>>2]|0)+4>>2]>>0]}}while(0);c[g>>2]=136;c[h>>2]=ly(c[j>>2]|0,(c[(c[e>>2]|0)+4>>2]|0)-(c[j>>2]|0)|0)|0}while(0);j=c[e>>2]|0;if(!(c[(c[e>>2]|0)+28>>2]|0)){f=eA(j,c[g>>2]|0)|0;c[(c[e>>2]|0)+28>>2]=f;if(!(c[(c[e>>2]|0)+28>>2]|0)){i=b;return}c[(c[(c[e>>2]|0)+28>>2]|0)+20>>2]=c[h>>2];i=b;return}else{if((c[(c[j+28>>2]|0)+4>>2]|0)!=3){i=b;return}PA(c[e>>2]|0,c[(c[e>>2]|0)+28>>2]|0,c[(c[e>>2]|0)+12>>2]|0,c[g>>2]|0,0,0,c[h>>2]|0);i=b;return}}function RA(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+32|0;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;j=b;c[e>>2]=a;c[h>>2]=-1;c[j>>2]=-1;a=c[e>>2]|0;if(!(d[c[(c[e>>2]|0)+4>>2]>>0]|0)){c[a+8>>2]=1450;Yz(c[e>>2]|0,14e4);i=b;return}c[f>>2]=d[c[a+4>>2]>>0];do if((c[f>>2]|0)==92){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[f>>2]=d[c[(c[e>>2]|0)+4>>2]>>0];switch(c[f>>2]|0){case 93:case 91:case 41:case 40:case 125:case 123:case 43:case 42:case 63:case 94:case 45:case 46:case 124:case 92:{c[h>>2]=c[f>>2];break}case 114:{c[h>>2]=13;break}case 116:{c[h>>2]=9;break}case 110:{c[h>>2]=10;break}default:{c[(c[e>>2]|0)+8>>2]=1450;Yz(c[e>>2]|0,140016);i=b;return}}c[j>>2]=c[h>>2];c[g>>2]=1}else{a=c[e>>2]|0;if((c[f>>2]|0)!=91&(c[f>>2]|0)!=93){k=oe(0,c[a+4>>2]|0,g)|0;c[h>>2]=k;c[j>>2]=k;break}c[a+8>>2]=1450;Yz(c[e>>2]|0,140040);i=b;return}while(0);if((((c[h>>2]|0)==45?(d[(c[(c[e>>2]|0)+4>>2]|0)+1>>0]|0|0)!=93:0)?(d[(c[(c[e>>2]|0)+4>>2]|0)+-1>>0]|0|0)!=91:0)?(d[(c[(c[e>>2]|0)+4>>2]|0)+-1>>0]|0|0)!=94:0){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+(c[g>>2]|0);i=b;return}a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+(c[g>>2]|0);c[f>>2]=d[c[(c[e>>2]|0)+4>>2]>>0];if((c[f>>2]|0)==45?(d[(c[(c[e>>2]|0)+4>>2]|0)+1>>0]|0|0)!=93:0){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[f>>2]=d[c[(c[e>>2]|0)+4>>2]>>0];do if((c[f>>2]|0)==92){a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[f>>2]=d[c[(c[e>>2]|0)+4>>2]>>0];switch(c[f>>2]|0){case 93:case 91:case 41:case 40:case 125:case 123:case 43:case 42:case 63:case 94:case 45:case 46:case 124:case 92:{c[j>>2]=c[f>>2];break}case 110:{c[j>>2]=10;break}case 114:{c[j>>2]=13;break}case 116:{c[j>>2]=9;break}default:{c[(c[e>>2]|0)+8>>2]=1450;Yz(c[e>>2]|0,140016);i=b;return}}c[g>>2]=1}else{a=c[e>>2]|0;if((c[f>>2]|0)!=91&(c[f>>2]|0)!=93){c[j>>2]=oe(0,c[a+4>>2]|0,g)|0;break}c[a+8>>2]=1450;Yz(c[e>>2]|0,140064);i=b;return}while(0);f=(c[e>>2]|0)+4|0;c[f>>2]=(c[f>>2]|0)+(c[g>>2]|0);g=c[e>>2]|0;if((c[j>>2]|0)<(c[h>>2]|0)){c[g+8>>2]=1450;Yz(c[e>>2]|0,140104);i=b;return}else{PA(g,c[(c[e>>2]|0)+28>>2]|0,c[(c[e>>2]|0)+12>>2]|0,2,c[h>>2]|0,c[j>>2]|0,0);i=b;return}}PA(c[e>>2]|0,c[(c[e>>2]|0)+28>>2]|0,c[(c[e>>2]|0)+12>>2]|0,2,c[h>>2]|0,c[j>>2]|0,0);i=b;return}function SA(){var a=0,b=0,d=0,e=0,f=0,g=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=Cb[c[135744>>2]&511](40)|0;if(!(c[d>>2]|0)){c[b>>2]=0;e=c[b>>2]|0;i=a;return e|0}else{f=(c[d>>2]|0)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));c[b>>2]=c[d>>2];e=c[b>>2]|0;i=a;return e|0}return 0}function TA(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+8>>2]|0)mB(c[(c[d>>2]|0)+8>>2]|0);if(c[(c[d>>2]|0)+32>>2]|0)nB(c[(c[d>>2]|0)+32>>2]|0);if(c[(c[d>>2]|0)+36>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+36>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function UA(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+32>>2]|0)PH(c[(c[d>>2]|0)+32>>2]|0);if(c[(c[d>>2]|0)+36>>2]|0)zz(c[(c[d>>2]|0)+36>>2]|0);if(c[(c[d>>2]|0)+16>>2]|0)mB(c[(c[d>>2]|0)+16>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function VA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+32|0;d=b+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+24>>2]|0)mB(c[(c[d>>2]|0)+24>>2]|0);a:do if(c[(c[d>>2]|0)+68>>2]|0){c[e>>2]=c[(c[d>>2]|0)+68>>2];while(1){if(!(c[e>>2]|0))break a;c[f>>2]=c[(c[e>>2]|0)+4>>2];UA(c[e>>2]|0);c[e>>2]=c[f>>2]}}while(0);if(c[(c[d>>2]|0)+116>>2]|0)oB(c[(c[d>>2]|0)+116>>2]|0);if(c[(c[d>>2]|0)+92>>2]|0)pB(c[(c[d>>2]|0)+92>>2]|0);if(c[(c[d>>2]|0)+96>>2]|0){c[h>>2]=c[(c[d>>2]|0)+96>>2];do{c[g>>2]=c[c[h>>2]>>2];zb[c[135736>>2]&511](c[h>>2]|0);c[h>>2]=c[g>>2]}while((c[h>>2]|0)!=0)}if(c[(c[d>>2]|0)+108>>2]|0)zz(c[(c[d>>2]|0)+108>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function WA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+32|0;d=b;e=b+16|0;f=b+12|0;g=b+8|0;c[e>>2]=a;if(!(c[e>>2]|0)){i=b;return}if(c[(c[e>>2]|0)+80>>2]|0){a=c[33976]|0;h=c[33980]|0;c[d>>2]=140328;c[d+4>>2]=4118;Db[a&511](h,140296,d)}if(c[(c[e>>2]|0)+44>>2]|0)Kj(c[(c[e>>2]|0)+44>>2]|0,0);if(c[(c[e>>2]|0)+32>>2]|0)Kj(c[(c[e>>2]|0)+32>>2]|0,0);if(c[(c[e>>2]|0)+36>>2]|0)Kj(c[(c[e>>2]|0)+36>>2]|0,0);if(c[(c[e>>2]|0)+40>>2]|0)Kj(c[(c[e>>2]|0)+40>>2]|0,0);if(c[(c[e>>2]|0)+28>>2]|0)Kj(c[(c[e>>2]|0)+28>>2]|0,0);if(c[(c[e>>2]|0)+56>>2]|0)Kj(c[(c[e>>2]|0)+56>>2]|0,0);if(c[(c[e>>2]|0)+76>>2]|0)Kj(c[(c[e>>2]|0)+76>>2]|0,0);if(c[(c[e>>2]|0)+48>>2]|0)Kj(c[(c[e>>2]|0)+48>>2]|0,322);if(c[(c[e>>2]|0)+64>>2]|0){c[f>>2]=c[(c[e>>2]|0)+64>>2];c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[(c[f>>2]|0)+4>>2]|0))break;qB(c[(c[c[f>>2]>>2]|0)+(c[g>>2]<<2)>>2]|0);c[g>>2]=(c[g>>2]|0)+1}oB(c[f>>2]|0)}if(c[(c[e>>2]|0)+20>>2]|0)mB(c[(c[e>>2]|0)+20>>2]|0);zP(c[(c[e>>2]|0)+60>>2]|0);zb[c[135736>>2]&511](c[e>>2]|0);i=b;return}function XA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if(!(c[e>>2]|0)){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}c[f>>2]=rB()|0;if(!(c[f>>2]|0)){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{a=xP()|0;c[(c[f>>2]|0)+80>>2]=a;a=AP(c[(c[f>>2]|0)+80>>2]|0,c[e>>2]|0,-1)|0;c[(c[f>>2]|0)+44>>2]=a;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function YA(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if((c[(c[d>>2]|0)+48>>2]|0)!=0?(c[(c[d>>2]|0)+52>>2]|0)==0:0)Th(c[(c[d>>2]|0)+48>>2]|0);if(c[(c[d>>2]|0)+92>>2]|0)ZA(c[(c[d>>2]|0)+92>>2]|0);if((c[(c[d>>2]|0)+32>>2]|0)!=0?(c[(c[d>>2]|0)+28>>2]|0)!=0:0){sB(c[(c[d>>2]|0)+28>>2]|0);c[(c[d>>2]|0)+28>>2]=0;c[(c[d>>2]|0)+32>>2]=0}if(c[(c[d>>2]|0)+128>>2]|0)oB(c[(c[d>>2]|0)+128>>2]|0);zP(c[(c[d>>2]|0)+80>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function ZA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+48|0;d=b+36|0;e=b+32|0;f=b+28|0;g=b+24|0;h=b+20|0;j=b+16|0;k=b+12|0;l=b+8|0;m=b+4|0;n=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+72>>2]|0)PH(c[(c[d>>2]|0)+72>>2]|0);if(c[(c[d>>2]|0)+88>>2]|0)YA(c[(c[d>>2]|0)+88>>2]|0);if(c[(c[d>>2]|0)+128>>2]|0){c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[(c[d>>2]|0)+132>>2]|0))break;c[f>>2]=c[(c[(c[d>>2]|0)+128>>2]|0)+(c[e>>2]<<2)>>2];zb[c[135736>>2]&511](c[(c[f>>2]|0)+4>>2]|0);zb[c[135736>>2]&511](c[f>>2]|0);c[e>>2]=(c[e>>2]|0)+1}zb[c[135736>>2]&511](c[(c[d>>2]|0)+128>>2]|0)}if(c[(c[d>>2]|0)+140>>2]|0){c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[(c[d>>2]|0)+144>>2]|0))break;tB(c[(c[(c[d>>2]|0)+140>>2]|0)+(c[g>>2]<<2)>>2]|0);c[g>>2]=(c[g>>2]|0)+1}zb[c[135736>>2]&511](c[(c[d>>2]|0)+140>>2]|0)}if(c[(c[d>>2]|0)+116>>2]|0){uB(c[(c[d>>2]|0)+116>>2]|0);c[(c[d>>2]|0)+116>>2]=0}if(c[(c[d>>2]|0)+120>>2]|0){uB(c[(c[d>>2]|0)+120>>2]|0);c[(c[d>>2]|0)+120>>2]=0}if(c[(c[d>>2]|0)+112>>2]|0){c[h>>2]=c[(c[d>>2]|0)+112>>2];do{c[j>>2]=c[c[h>>2]>>2];zb[c[135736>>2]&511](c[h>>2]|0);c[h>>2]=c[j>>2]}while((c[h>>2]|0)!=0)}if(c[(c[d>>2]|0)+164>>2]|0){if(c[(c[d>>2]|0)+168>>2]|0)vB(c[d>>2]|0);c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[(c[d>>2]|0)+172>>2]|0))break;c[l>>2]=c[(c[(c[d>>2]|0)+164>>2]|0)+(c[k>>2]<<2)>>2];zb[c[135736>>2]&511](c[l>>2]|0);c[k>>2]=(c[k>>2]|0)+1}zb[c[135736>>2]&511](c[(c[d>>2]|0)+164>>2]|0)}if(c[(c[d>>2]|0)+100>>2]|0){c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[(c[d>>2]|0)+104>>2]|0))break;c[n>>2]=c[(c[(c[d>>2]|0)+100>>2]|0)+(c[m>>2]<<2)>>2];if(!(c[n>>2]|0))break;wB(c[d>>2]|0,c[n>>2]|0);zb[c[135736>>2]&511](c[n>>2]|0);c[m>>2]=(c[m>>2]|0)+1}zb[c[135736>>2]&511](c[(c[d>>2]|0)+100>>2]|0)}if(c[(c[d>>2]|0)+180>>2]|0)oB(c[(c[d>>2]|0)+180>>2]|0);if(c[(c[d>>2]|0)+156>>2]|0)zP(c[(c[d>>2]|0)+156>>2]|0);if(c[(c[d>>2]|0)+48>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+48>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function _A(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+48|0;g=f;h=f+40|0;j=f+36|0;k=f+32|0;l=f+28|0;m=f+20|0;n=f+16|0;o=f+12|0;p=f+8|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[f+24>>2]=e;c[m>>2]=0;if((c[j>>2]|0)==0|(c[k>>2]|0)==0){c[h>>2]=-1;q=c[h>>2]|0;i=f;return q|0}if(!(c[l>>2]|0))c[n>>2]=0;else c[n>>2]=1;a:do switch(c[c[j>>2]>>2]|0){case 1007:case 1003:case 1002:case 1001:case 1e3:{e=c[k>>2]|0;if((c[c[k>>2]>>2]|0)!=1){c[o>>2]=c[e+64>>2];if(!(c[o>>2]|0)){xB(c[l>>2]|0,140360,140384);c[h>>2]=-1;q=c[h>>2]|0;i=f;return q|0}}else c[o>>2]=e;if((c[n>>2]|0)==0?(c[l>>2]=XA(140432)|0,(c[l>>2]|0)==0):0){c[h>>2]=-1;q=c[h>>2]|0;i=f;return q|0}c[m>>2]=yB(c[l>>2]|0,c[(c[j>>2]|0)+20>>2]|0,c[o>>2]|0,c[(c[j>>2]|0)+8>>2]|0,(c[j>>2]|0)+32|0,1,1,0)|0;if(!(c[m>>2]|0)){if(c[(c[j>>2]|0)+32>>2]|0){r=45;break a}if(c[n>>2]|0)xB(c[l>>2]|0,140360,140632);e=c[33976]|0;d=c[33980]|0;c[g>>2]=140328;c[g+4>>2]=18739;Db[e&511](d,140296,g);r=45;break a}if((c[m>>2]|0)<0){if(!(c[n>>2]|0)){r=48;break a}d=c[l>>2]|0;e=c[(c[j>>2]|0)+20>>2]|0;b=c[(c[j>>2]|0)+8>>2]|0;AB(d,3069,e,0,140440,b,zB(c[c[j>>2]>>2]|0)|0);r=48;break a}c[m>>2]=1717;if((c[n>>2]|0)!=0?(c[p>>2]=0,b=c[l>>2]|0,e=c[m>>2]|0,d=c[(c[j>>2]|0)+20>>2]|0,a=c[j>>2]|0,s=c[(c[j>>2]|0)+8>>2]|0,AB(b,e,d,a,140552,s,BB(p,c[(c[o>>2]|0)+112>>2]|0,c[(c[o>>2]|0)+8>>2]|0)|0),(c[p>>2]|0)!=0):0){zb[c[135736>>2]&511](c[p>>2]|0);c[p>>2]=0;r=45}else r=45;break}case 1011:case 1010:case 1009:case 1005:case 1004:{if((c[c[j>>2]>>2]|0)==1004){s=IH(34)|0;c[m>>2]=VH(s,c[(c[j>>2]|0)+8>>2]|0,(c[j>>2]|0)+32|0)|0}else{s=IH(33)|0;c[m>>2]=VH(s,c[(c[j>>2]|0)+8>>2]|0,(c[j>>2]|0)+32|0)|0}if(c[m>>2]|0)if((c[m>>2]|0)<0){if(!(c[n>>2]|0)){r=48;break a}xB(c[l>>2]|0,140360,140728);r=48;break a}else{c[m>>2]=1717;if(!(c[n>>2]|0)){r=45;break a}s=c[l>>2]|0;a=c[m>>2]|0;d=c[(c[j>>2]|0)+20>>2]|0;e=c[k>>2]|0;b=c[(c[j>>2]|0)+8>>2]|0;t=zB(c[c[j>>2]>>2]|0)|0;CB(s,a,d,e,140752,b,t,(c[c[j>>2]>>2]|0)!=1004?140808:140832,0);r=45;break a}else r=45;break}case 1006:{t=uz(c[(c[j>>2]|0)+8>>2]|0)|0;c[(c[j>>2]|0)+36>>2]=t;if((c[(c[j>>2]|0)+36>>2]|0)==0?(c[m>>2]=1756,(c[n>>2]|0)!=0):0){AB(c[l>>2]|0,c[m>>2]|0,c[(c[j>>2]|0)+20>>2]|0,c[k>>2]|0,140656,c[(c[j>>2]|0)+8>>2]|0,0);r=45}else r=45;break}case 1008:{t=(qy(c[(c[j>>2]|0)+8>>2]|0,140848)|0)!=0;b=c[j>>2]|0;if(t){c[b+28>>2]=1;r=45;break a}t=(qy(c[b+8>>2]|0,140864)|0)!=0;b=c[j>>2]|0;if(t){c[b+28>>2]=2;r=45;break a}if(qy(c[b+8>>2]|0,140872)|0){c[(c[j>>2]|0)+28>>2]=3;r=45;break a}c[m>>2]=1717;if(c[n>>2]|0){AB(c[l>>2]|0,c[m>>2]|0,c[(c[j>>2]|0)+20>>2]|0,c[k>>2]|0,140888,c[(c[j>>2]|0)+8>>2]|0,0);r=45}else r=45;break}default:r=45}while(0);if((r|0)==45){if((c[n>>2]|0)==0&(c[l>>2]|0)!=0)YA(c[l>>2]|0);c[h>>2]=c[m>>2];q=c[h>>2]|0;i=f;return q|0}else if((r|0)==48){if((c[n>>2]|0)==0&(c[l>>2]|0)!=0)YA(c[l>>2]|0);c[h>>2]=-1;q=c[h>>2]|0;i=f;return q|0}return 0}function $A(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+32|0;d=b+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[e>>2]=a;c[f>>2]=0;c[g>>2]=0;FH();if(!(c[e>>2]|0)){c[d>>2]=0;j=c[d>>2]|0;i=b;return j|0}c[(c[e>>2]|0)+20>>2]=0;c[(c[e>>2]|0)+16>>2]=0;c[(c[e>>2]|0)+40>>2]=0;c[f>>2]=DB(c[e>>2]|0)|0;a:do if(c[f>>2]|0){do if(!(c[(c[e>>2]|0)+28>>2]|0)){a=EB(c[(c[e>>2]|0)+80>>2]|0)|0;c[(c[e>>2]|0)+28>>2]=a;if(c[(c[e>>2]|0)+28>>2]|0){c[(c[e>>2]|0)+32>>2]=1;break}c[d>>2]=0;j=c[d>>2]|0;i=b;return j|0}while(0);c[c[(c[e>>2]|0)+28>>2]>>2]=c[f>>2];c[h>>2]=FB(c[e>>2]|0,0,c[(c[e>>2]|0)+44>>2]|0,c[(c[e>>2]|0)+48>>2]|0,c[(c[e>>2]|0)+56>>2]|0,c[(c[e>>2]|0)+60>>2]|0,0,0,0,g)|0;if((c[h>>2]|0)!=-1){do if(!(c[h>>2]|0)){a=c[e>>2]|0;if(!(c[g>>2]|0)){k=c[e>>2]|0;if(c[a+44>>2]|0){AB(k,1757,0,0,140944,c[(c[e>>2]|0)+44>>2]|0,0);break}else{AB(k,1757,0,0,141e3,0,0);break}}else{if((GB(a,c[f>>2]|0,c[g>>2]|0)|0)==-1)break a;if(c[(c[e>>2]|0)+20>>2]|0)break;c[(c[f>>2]|0)+16>>2]=c[(c[g>>2]|0)+20>>2];c[(c[f>>2]|0)+68>>2]=c[(c[e>>2]|0)+52>>2];c[(c[e>>2]|0)+36>>2]=c[f>>2];if((HB(c[e>>2]|0,c[(c[(c[e>>2]|0)+28>>2]|0)+4>>2]|0)|0)==-1)break a;else break}}while(0);if(c[(c[e>>2]|0)+20>>2]|0){if(c[f>>2]|0){WA(c[f>>2]|0);c[f>>2]=0}if(c[(c[e>>2]|0)+28>>2]|0){sB(c[(c[e>>2]|0)+28>>2]|0);c[(c[e>>2]|0)+28>>2]=0;c[(c[e>>2]|0)+32>>2]=0}}c[(c[e>>2]|0)+36>>2]=0;c[d>>2]=c[f>>2];j=c[d>>2]|0;i=b;return j|0}}while(0);if(c[f>>2]|0){WA(c[f>>2]|0);c[f>>2]=0}if(c[(c[e>>2]|0)+28>>2]|0){sB(c[(c[e>>2]|0)+28>>2]|0);c[(c[e>>2]|0)+28>>2]=0;c[(c[e>>2]|0)+32>>2]=0}xB(c[e>>2]|0,141048,141064);c[(c[e>>2]|0)+36>>2]=0;c[d>>2]=0;j=c[d>>2]|0;i=b;return j|0}function aB(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;if(!(c[g>>2]|0)){i=f;return}c[(c[g>>2]|0)+8>>2]=c[h>>2];c[(c[g>>2]|0)+12>>2]=c[j>>2];c[(c[g>>2]|0)+4>>2]=c[k>>2];if(!(c[(c[g>>2]|0)+92>>2]|0)){i=f;return}bB(c[(c[g>>2]|0)+92>>2]|0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0);i=f;return}function bB(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;if(!(c[g>>2]|0)){i=f;return}c[(c[g>>2]|0)+8>>2]=c[h>>2];c[(c[g>>2]|0)+12>>2]=c[j>>2];c[(c[g>>2]|0)+4>>2]=c[k>>2];if(!(c[(c[g>>2]|0)+88>>2]|0)){i=f;return}aB(c[(c[g>>2]|0)+88>>2]|0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0);i=f;return}function cB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if(!(c[f>>2]|0)){i=e;return}c[(c[f>>2]|0)+24>>2]=c[g>>2];c[(c[f>>2]|0)+4>>2]=c[h>>2];if(!(c[(c[f>>2]|0)+92>>2]|0)){i=e;return}dB(c[(c[f>>2]|0)+92>>2]|0,c[g>>2]|0,c[h>>2]|0);i=e;return}function dB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if(!(c[f>>2]|0)){i=e;return}c[(c[f>>2]|0)+16>>2]=c[g>>2];c[(c[f>>2]|0)+8>>2]=0;c[(c[f>>2]|0)+12>>2]=0;c[(c[f>>2]|0)+4>>2]=c[h>>2];if(!(c[(c[f>>2]|0)+88>>2]|0)){i=e;return}cB(c[(c[f>>2]|0)+88>>2]|0,c[g>>2]|0,c[h>>2]|0);i=e;return}function eB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](204)|0;if(!(c[f>>2]|0)){IB(0,141096,0);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{cU(c[f>>2]|0,0,204)|0;
c[c[f>>2]>>2]=2;a=xP()|0;c[(c[f>>2]|0)+156>>2]=a;a=JB()|0;c[(c[f>>2]|0)+180>>2]=a;c[(c[f>>2]|0)+20>>2]=c[e>>2];c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function fB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}if(c[(c[e>>2]|0)+48>>2]|0)zb[c[135736>>2]&511](c[(c[e>>2]|0)+48>>2]|0);if(c[f>>2]|0){b=my(c[f>>2]|0)|0;c[(c[e>>2]|0)+48>>2]=b;i=d;return}else{c[(c[e>>2]|0)+48>>2]=0;i=d;return}}function gB(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;if(!(c[e>>2]|0)){c[d>>2]=-1;f=c[d>>2]|0;i=b;return f|0}else{c[d>>2]=(c[(c[e>>2]|0)+52>>2]|0)==0&1;f=c[d>>2]|0;i=b;return f|0}return 0}function hB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}c[(c[f>>2]|0)+24>>2]=c[g>>2];b=Pi(c[g>>2]|0)|0;c[(c[f>>2]|0)+60>>2]=b;b=c[f>>2]|0;if(!(c[(c[f>>2]|0)+60>>2]|0)){AB(b,1872,c[g>>2]|0,0,141128,0,0);c[e>>2]=c[(c[f>>2]|0)+52>>2];h=c[e>>2]|0;i=d;return h|0}else{c[(c[f>>2]|0)+84>>2]=c[b+60>>2];c[e>>2]=KB(c[f>>2]|0)|0;h=c[e>>2]|0;i=d;return h|0}return 0}function iB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if((c[g>>2]|0)==0|(c[h>>2]|0)==0|(c[j>>2]|0)==0){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}c[l>>2]=c[c[h>>2]>>2];if((c[l>>2]|0)!=0?(c[(c[l>>2]|0)+108>>2]|0)!=-554844497:0){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}do if(((c[l>>2]|0)!=0?(c[(c[l>>2]|0)+116>>2]|0)==0:0)?(c[(c[l>>2]|0)+120>>2]|0)==0:0){if((c[(c[l>>2]|0)+56>>2]|0)==0?(c[(c[l>>2]|0)+60>>2]|0)==0:0)break;c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}while(0);c[k>>2]=Cb[c[135744>>2]&511](152)|0;if(!(c[k>>2]|0)){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}cU(c[k>>2]|0,0,152)|0;c[c[k>>2]>>2]=-599541215;c[(c[k>>2]|0)+128>>2]=-554844497;c[(c[k>>2]|0)+148>>2]=c[g>>2];c[(c[k>>2]|0)+4>>2]=c[h>>2];c[(c[k>>2]|0)+8>>2]=c[l>>2];if(!(c[l>>2]|0)){c[(c[k>>2]|0)+136>>2]=323;c[(c[k>>2]|0)+140>>2]=324;c[(c[k>>2]|0)+92>>2]=325;c[(c[k>>2]|0)+88>>2]=325;c[(c[k>>2]|0)+120>>2]=326;c[(c[k>>2]|0)+84>>2]=327;c[(c[k>>2]|0)+16>>2]=c[g>>2];c[c[j>>2]>>2]=c[g>>2]}else{if(c[c[l>>2]>>2]|0)c[(c[k>>2]|0)+20>>2]=328;if(c[(c[l>>2]|0)+4>>2]|0)c[(c[k>>2]|0)+24>>2]=329;if(c[(c[l>>2]|0)+8>>2]|0)c[(c[k>>2]|0)+28>>2]=330;if(c[(c[l>>2]|0)+12>>2]|0)c[(c[k>>2]|0)+32>>2]=331;if(c[(c[l>>2]|0)+16>>2]|0)c[(c[k>>2]|0)+36>>2]=332;if(c[(c[l>>2]|0)+20>>2]|0)c[(c[k>>2]|0)+40>>2]=333;if(c[(c[l>>2]|0)+24>>2]|0)c[(c[k>>2]|0)+44>>2]=334;if(c[(c[l>>2]|0)+28>>2]|0)c[(c[k>>2]|0)+48>>2]=335;if(c[(c[l>>2]|0)+32>>2]|0)c[(c[k>>2]|0)+52>>2]=336;if(c[(c[l>>2]|0)+36>>2]|0)c[(c[k>>2]|0)+56>>2]=337;if(c[(c[l>>2]|0)+40>>2]|0)c[(c[k>>2]|0)+60>>2]=338;if(c[(c[l>>2]|0)+44>>2]|0)c[(c[k>>2]|0)+64>>2]=339;if(c[(c[l>>2]|0)+48>>2]|0)c[(c[k>>2]|0)+68>>2]=340;if(c[(c[l>>2]|0)+52>>2]|0)c[(c[k>>2]|0)+72>>2]=341;if(c[(c[l>>2]|0)+76>>2]|0)c[(c[k>>2]|0)+96>>2]=342;if(c[(c[l>>2]|0)+80>>2]|0)c[(c[k>>2]|0)+100>>2]=343;if(c[(c[l>>2]|0)+84>>2]|0)c[(c[k>>2]|0)+104>>2]=344;if(c[(c[l>>2]|0)+88>>2]|0)c[(c[k>>2]|0)+108>>2]=345;if(c[(c[l>>2]|0)+92>>2]|0)c[(c[k>>2]|0)+112>>2]=346;if(c[(c[l>>2]|0)+96>>2]|0)c[(c[k>>2]|0)+116>>2]=347;if(c[(c[l>>2]|0)+104>>2]|0)c[(c[k>>2]|0)+124>>2]=348;c[(c[k>>2]|0)+88>>2]=349;do if(c[(c[l>>2]|0)+72>>2]|0){if((c[(c[l>>2]|0)+72>>2]|0)==(c[(c[l>>2]|0)+68>>2]|0)){n=61;break}c[(c[k>>2]|0)+92>>2]=350}else n=61;while(0);if((n|0)==61)c[(c[k>>2]|0)+92>>2]=349;c[(c[k>>2]|0)+120>>2]=351;c[(c[k>>2]|0)+84>>2]=352;c[(c[k>>2]|0)+136>>2]=353;c[(c[k>>2]|0)+140>>2]=354;c[(c[k>>2]|0)+12>>2]=c[j>>2];c[(c[k>>2]|0)+16>>2]=c[c[j>>2]>>2];c[c[j>>2]>>2]=c[k>>2]}c[c[h>>2]>>2]=(c[k>>2]|0)+20;c[(c[g>>2]|0)+36>>2]=c[c[h>>2]>>2];h=(c[g>>2]|0)+152|0;c[h>>2]=c[h>>2]|1;pC(c[g>>2]|0)|0;c[f>>2]=c[k>>2];m=c[f>>2]|0;i=e;return m|0}function jB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;if((c[e>>2]|0)!=0?(c[c[e>>2]>>2]|0)==-599541215:0){c[c[e>>2]>>2]=0;qC(c[(c[e>>2]|0)+148>>2]|0);c[f>>2]=c[(c[e>>2]|0)+4>>2];c[c[f>>2]>>2]=c[(c[e>>2]|0)+8>>2];if(c[(c[e>>2]|0)+8>>2]|0){c[g>>2]=c[(c[e>>2]|0)+12>>2];c[c[g>>2]>>2]=c[(c[e>>2]|0)+16>>2]}zb[c[135736>>2]&511](c[e>>2]|0);c[d>>2]=0;h=c[d>>2]|0;i=b;return h|0}c[d>>2]=-1;h=c[d>>2]|0;i=b;return h|0}function kB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if(!(c[f>>2]|0)){i=e;return}c[(c[f>>2]|0)+196>>2]=c[g>>2];c[(c[f>>2]|0)+200>>2]=c[h>>2];i=e;return}function lB(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+48|0;h=g+40|0;j=g+36|0;k=g+32|0;l=g+28|0;m=g+24|0;n=g+20|0;o=g+16|0;p=g+12|0;q=g+8|0;r=g+4|0;s=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=0;c[p>>2]=0;c[q>>2]=0;c[r>>2]=0;if((c[j>>2]|0)==0|(c[k>>2]|0)==0){c[h>>2]=-1;t=c[h>>2]|0;i=g;return t|0}c[q>>2]=Be()|0;if(!(c[q>>2]|0)){c[h>>2]=-1;t=c[h>>2]|0;i=g;return t|0}c[p>>2]=c[c[q>>2]>>2];c[c[q>>2]>>2]=c[m>>2];c[(c[q>>2]|0)+4>>2]=c[n>>2];c[(c[q>>2]|0)+280>>2]=1;kB(c[j>>2]|0,355,c[q>>2]|0);c[r>>2]=ve(c[q>>2]|0,c[k>>2]|0,c[l>>2]|0)|0;do if(c[r>>2]|0){Oe(c[q>>2]|0,c[r>>2]|0)|0;c[(c[j>>2]|0)+40>>2]=c[q>>2];c[(c[j>>2]|0)+28>>2]=c[k>>2];c[o>>2]=iB(c[j>>2]|0,c[q>>2]|0,(c[q>>2]|0)+4|0)|0;if(!(c[o>>2]|0)){c[s>>2]=-1;break}c[(c[j>>2]|0)+28>>2]=c[k>>2];c[(c[j>>2]|0)+32>>2]=c[l>>2];c[(c[j>>2]|0)+36>>2]=c[c[q>>2]>>2];n=(c[j>>2]|0)+152|0;c[n>>2]=c[n>>2]|1;c[s>>2]=KB(c[j>>2]|0)|0;if((c[s>>2]|0)==0?(c[(c[(c[j>>2]|0)+40>>2]|0)+12>>2]|0)==0:0){n=c[(c[(c[j>>2]|0)+40>>2]|0)+84>>2]|0;c[s>>2]=n;c[s>>2]=(c[s>>2]|0)==0?1:n}}else c[s>>2]=-1;while(0);c[(c[j>>2]|0)+40>>2]=0;c[(c[j>>2]|0)+36>>2]=0;c[(c[j>>2]|0)+28>>2]=0;if(c[o>>2]|0)jB(c[o>>2]|0)|0;if(c[q>>2]|0){c[c[q>>2]>>2]=c[p>>2];Ae(c[q>>2]|0)}c[h>>2]=c[s>>2];t=c[h>>2]|0;i=g;return t|0}function mB(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(!(c[c[d>>2]>>2]|0)){zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}else{do{c[e>>2]=c[d>>2];c[d>>2]=c[c[d>>2]>>2];zb[c[135736>>2]&511](c[e>>2]|0)}while((c[d>>2]|0)!=0);i=b;return}}function nB(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;while(1){if(!(c[d>>2]|0))break;c[e>>2]=c[c[d>>2]>>2];zb[c[135736>>2]&511](c[d>>2]|0);c[d>>2]=c[e>>2]}i=b;return}function oB(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[c[d>>2]>>2]|0)zb[c[135736>>2]&511](c[c[d>>2]>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function pB(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;while(1){if(!(c[d>>2]|0))break;c[e>>2]=c[c[d>>2]>>2];zb[c[135736>>2]&511](c[d>>2]|0);c[d>>2]=c[e>>2]}i=b;return}function qB(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+44>>2]|0){sC(c[(c[d>>2]|0)+44>>2]|0);oB(c[(c[d>>2]|0)+44>>2]|0)}if(c[(c[d>>2]|0)+48>>2]|0){sC(c[(c[d>>2]|0)+48>>2]|0);oB(c[(c[d>>2]|0)+48>>2]|0)}if(c[(c[d>>2]|0)+24>>2]|0){c[f>>2]=c[(c[d>>2]|0)+24>>2];do{c[e>>2]=c[f>>2];c[f>>2]=c[c[f>>2]>>2];zb[c[135736>>2]&511](c[e>>2]|0)}while((c[f>>2]|0)!=0)}if((c[(c[d>>2]|0)+40>>2]|0)==0?(c[(c[d>>2]|0)+20>>2]|0)!=0:0)Th(c[(c[d>>2]|0)+20>>2]|0);if((c[c[d>>2]>>2]|0)==1?(c[(c[d>>2]|0)+52>>2]|0)!=0:0)WA(c[(c[d>>2]|0)+52>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function rB(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=Cb[c[135744>>2]&511](132)|0;if(!(c[d>>2]|0)){tC(0,170240,0);c[b>>2]=0;e=c[b>>2]|0;i=a;return e|0}cU(c[d>>2]|0,0,132)|0;c[c[d>>2]>>2]=1;f=JB()|0;c[(c[d>>2]|0)+128>>2]=f;if(!(c[(c[d>>2]|0)+128>>2]|0)){zb[c[135736>>2]&511](c[d>>2]|0);c[b>>2]=0;e=c[b>>2]|0;i=a;return e|0}else{c[b>>2]=c[d>>2];e=c[b>>2]|0;i=a;return e|0}return 0}function sB(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(c[(c[d>>2]|0)+12>>2]|0)oB(c[(c[d>>2]|0)+12>>2]|0);if(c[(c[d>>2]|0)+20>>2]|0)oB(c[(c[d>>2]|0)+20>>2]|0);if(c[(c[d>>2]|0)+24>>2]|0)Kj(c[(c[d>>2]|0)+24>>2]|0,356);if(c[(c[d>>2]|0)+28>>2]|0)vC(c[(c[d>>2]|0)+28>>2]|0);if(!(c[(c[d>>2]|0)+8>>2]|0)){e=c[33934]|0;f=c[d>>2]|0;zb[e&511](f);i=b;return}zP(c[(c[d>>2]|0)+8>>2]|0);e=c[33934]|0;f=c[d>>2]|0;zb[e&511](f);i=b;return}function tB(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(c[(c[d>>2]|0)+4>>2]|0)PH(c[(c[d>>2]|0)+4>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function uB(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;while(1){if(!(c[d>>2]|0))break;c[e>>2]=c[(c[d>>2]|0)+4>>2];if(c[(c[d>>2]|0)+12>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+12>>2]|0);if(c[(c[d>>2]|0)+32>>2]|0)GQ(c[(c[d>>2]|0)+32>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);c[d>>2]=c[e>>2]}i=b;return}function vB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;if(!(c[(c[d>>2]|0)+168>>2]|0)){i=b;return}c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[(c[d>>2]|0)+168>>2]|0))break;c[f>>2]=c[(c[(c[d>>2]|0)+164>>2]|0)+(c[e>>2]<<2)>>2];if(c[(c[f>>2]|0)+32>>2]&1){if(c[(c[f>>2]|0)+12>>2]|0)zb[c[135736>>2]&511](c[(c[f>>2]|0)+12>>2]|0);if(c[(c[f>>2]|0)+16>>2]|0)zb[c[135736>>2]&511](c[(c[f>>2]|0)+16>>2]|0)}if((c[(c[f>>2]|0)+32>>2]&2|0)!=0?(c[(c[f>>2]|0)+20>>2]|0)!=0:0)zb[c[135736>>2]&511](c[(c[f>>2]|0)+20>>2]|0);if(c[(c[f>>2]|0)+24>>2]|0){PH(c[(c[f>>2]|0)+24>>2]|0);c[(c[f>>2]|0)+24>>2]=0}a=(c[f>>2]|0)+0|0;g=a+60|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(g|0));c[e>>2]=(c[e>>2]|0)+1}c[(c[d>>2]|0)+168>>2]=0;i=b;return}function wB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;c[(c[f>>2]|0)+76>>2]=0;c[(c[f>>2]|0)+80>>2]=0;b=(c[f>>2]|0)+12|0;if(c[(c[f>>2]|0)+32>>2]&1){if(c[b>>2]|0){zb[c[135736>>2]&511](c[(c[f>>2]|0)+12>>2]|0);c[(c[f>>2]|0)+12>>2]=0}if(c[(c[f>>2]|0)+16>>2]|0){zb[c[135736>>2]&511](c[(c[f>>2]|0)+16>>2]|0);c[(c[f>>2]|0)+16>>2]=0}}else{c[b>>2]=0;c[(c[f>>2]|0)+16>>2]=0}b=(c[f>>2]|0)+20|0;if(c[(c[f>>2]|0)+32>>2]&2){if(c[b>>2]|0){zb[c[135736>>2]&511](c[(c[f>>2]|0)+20>>2]|0);c[(c[f>>2]|0)+20>>2]=0}}else c[b>>2]=0;if(c[(c[f>>2]|0)+24>>2]|0){PH(c[(c[f>>2]|0)+24>>2]|0);c[(c[f>>2]|0)+24>>2]=0}if(c[(c[f>>2]|0)+56>>2]|0){wC(c[e>>2]|0,c[(c[f>>2]|0)+56>>2]|0);c[(c[f>>2]|0)+56>>2]=0}if(c[(c[f>>2]|0)+52>>2]|0){xC(c[(c[f>>2]|0)+52>>2]|0);c[(c[f>>2]|0)+52>>2]=0}if(c[(c[f>>2]|0)+60>>2]|0){pz(c[(c[f>>2]|0)+60>>2]|0);c[(c[f>>2]|0)+60>>2]=0}if(!(c[(c[f>>2]|0)+64>>2]|0)){i=d;return}zb[c[135736>>2]&511](c[(c[f>>2]|0)+64>>2]|0);c[(c[f>>2]|0)+64>>2]=0;c[(c[f>>2]|0)+68>>2]=0;c[(c[f>>2]|0)+72>>2]=0;i=d;return}function xB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;yC(c[f>>2]|0,c[g>>2]|0,c[h>>2]|0,0,0);i=e;return}function yB(a,b,e,f,g,h,j,k){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;l=i;i=i+96|0;m=l;n=l+92|0;o=l+88|0;p=l+84|0;q=l+80|0;r=l+76|0;s=l+72|0;t=l+68|0;u=l+64|0;v=l+60|0;w=l+56|0;x=l+52|0;y=l+48|0;z=l+44|0;A=l+40|0;B=l+36|0;C=l+32|0;D=l+28|0;E=l+24|0;F=l+20|0;G=l+16|0;H=l+12|0;I=l+8|0;c[o>>2]=a;c[p>>2]=b;c[q>>2]=e;c[r>>2]=f;c[s>>2]=g;c[t>>2]=h;c[u>>2]=j;c[v>>2]=k;c[w>>2]=0;c[x>>2]=(c[s>>2]|0)!=0?1:0;c[y>>2]=0;c[z>>2]=0;if((c[s>>2]|0)!=0?(c[c[s>>2]>>2]|0)!=0:0){PH(c[c[s>>2]>>2]|0);c[c[s>>2]>>2]=0}if((c[x>>2]|0)==0?(c[(c[q>>2]|0)+48>>2]&2097152|0)!=0:0)c[x>>2]=1;if(!(c[r>>2]|0))c[r>>2]=142672;if((c[c[q>>2]>>2]|0)==1?(c[(c[q>>2]|0)+88>>2]|0)==46:0)J=12;else J=11;a:do if((J|0)==11)if(!(c[(c[q>>2]|0)+48>>2]&256)){if(!(c[(c[q>>2]|0)+48>>2]&64)){if(!(c[(c[q>>2]|0)+48>>2]&128))break;c[I>>2]=EC(c[q>>2]|0)|0;if(!(c[I>>2]|0)){xB(c[o>>2]|0,156240,156464);J=149;break}while(1){if(!(c[I>>2]|0))break;k=c[o>>2]|0;j=c[p>>2]|0;h=c[(c[I>>2]|0)+4>>2]|0;g=c[r>>2]|0;if(c[x>>2]|0)c[w>>2]=yB(k,j,h,g,y,0,1,0)|0;else c[w>>2]=yB(k,j,h,g,0,0,1,0)|0;if((c[w>>2]|0)<=0)break;c[I>>2]=c[c[I>>2]>>2]}do if(c[w>>2]|0)if((c[w>>2]|0)<0){xB(c[o>>2]|0,156240,156504);J=149;break a}else{c[w>>2]=1826;break}while(0);do if((c[w>>2]|0)==0?(c[(c[q>>2]|0)+48>>2]&134217728|0)!=0:0){do if(!(c[v>>2]|0)){if((c[u>>2]|0)==0?(c[(c[q>>2]|0)+48>>2]&268435456|0)==0:0)break;c[z>>2]=zC(c[(c[I>>2]|0)+4>>2]|0,c[r>>2]|0)|0;if(c[z>>2]|0)c[r>>2]=c[z>>2];c[v>>2]=1}while(0);c[w>>2]=CC(c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,0,c[r>>2]|0,c[y>>2]|0,0,c[t>>2]|0)|0;if(c[w>>2]|0)if((c[w>>2]|0)<0){xB(c[o>>2]|0,156240,156544);J=149;break a}else{c[w>>2]=1826;break}}while(0);if(!((c[t>>2]|0)!=0&(c[w>>2]|0)>0))break;DC(c[o>>2]|0,c[w>>2]|0,c[p>>2]|0,c[r>>2]|0,c[q>>2]|0,1);break}c[E>>2]=0;c[F>>2]=0;c[G>>2]=0;c[H>>2]=0;do if(!(c[v>>2]|0)){if((c[u>>2]|0)==0?(c[(c[q>>2]|0)+48>>2]&268435456|0)==0:0)break;c[z>>2]=zC(c[q>>2]|0,c[r>>2]|0)|0;if(c[z>>2]|0)c[r>>2]=c[z>>2];c[v>>2]=1}while(0);c[B>>2]=c[(c[q>>2]|0)+28>>2];c[C>>2]=c[r>>2];while(1){do if((d[c[C>>2]>>0]|0|0)==32)K=1;else{if(9<=(d[c[C>>2]>>0]|0|0)?(d[c[C>>2]>>0]|0|0)<=10:0){K=1;break}K=(d[c[C>>2]>>0]|0|0)==13}while(0);g=c[C>>2]|0;if(K){c[C>>2]=g+1;continue}c[D>>2]=g;while(1){if(d[c[D>>2]>>0]|0){do if((d[c[D>>2]>>0]|0|0)==32)L=1;else{if(9<=(d[c[D>>2]>>0]|0|0)?(d[c[D>>2]>>0]|0|0)<=10:0){L=1;break}L=(d[c[D>>2]>>0]|0|0)==13}while(0);M=L^1}else M=0;N=c[D>>2]|0;if(!M)break;c[D>>2]=N+1}if((N|0)==(c[C>>2]|0))break;c[E>>2]=ly(c[C>>2]|0,(c[D>>2]|0)-(c[C>>2]|0)|0)|0;c[F>>2]=(c[F>>2]|0)+1;g=c[o>>2]|0;h=c[p>>2]|0;j=c[B>>2]|0;k=c[E>>2]|0;f=c[t>>2]|0;if(c[x>>2]|0)c[w>>2]=yB(g,h,j,k,H,f,0,1)|0;else c[w>>2]=yB(g,h,j,k,0,f,0,1)|0;if(c[E>>2]|0){zb[c[135736>>2]&511](c[E>>2]|0);c[E>>2]=0}if(c[H>>2]|0){if(!(c[y>>2]|0))c[y>>2]=c[H>>2];else JH(c[G>>2]|0,c[H>>2]|0)|0;c[G>>2]=c[H>>2];c[H>>2]=0}if(c[w>>2]|0){J=92;break}c[C>>2]=c[D>>2];if(!(d[c[C>>2]>>0]|0))break}do if((J|0)==92)if((c[w>>2]|0)<0){xB(c[o>>2]|0,156240,156384);J=149;break a}else{c[w>>2]=1825;break}while(0);if(c[E>>2]|0){zb[c[135736>>2]&511](c[E>>2]|0);c[E>>2]=0}do if(((c[w>>2]|0)==0?(c[(c[q>>2]|0)+48>>2]&134217728|0)!=0:0)?(c[w>>2]=CC(c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,0,c[r>>2]|0,c[y>>2]|0,c[F>>2]|0,c[t>>2]|0)|0,(c[w>>2]|0)!=0):0)if((c[w>>2]|0)<0){xB(c[o>>2]|0,156240,156424);J=149;break a}else{c[w>>2]=1825;break}while(0);if((c[t>>2]|0)!=0&(c[w>>2]|0)>0){c[u>>2]=1;do if(!(c[v>>2]|0)){if((c[u>>2]|0)==0?(c[(c[q>>2]|0)+48>>2]&268435456|0)==0:0)break;c[z>>2]=zC(c[q>>2]|0,c[r>>2]|0)|0;if(c[z>>2]|0)c[r>>2]=c[z>>2];c[v>>2]=1}while(0);DC(c[o>>2]|0,c[w>>2]|0,c[p>>2]|0,c[r>>2]|0,c[q>>2]|0,1)}}else J=12;while(0);b:do if((J|0)==12){do if(!(c[v>>2]|0)){if((c[u>>2]|0)==0?(c[(c[q>>2]|0)+48>>2]&268435456|0)==0:0)break;c[z>>2]=zC(c[q>>2]|0,c[r>>2]|0)|0;if(c[z>>2]|0)c[r>>2]=c[z>>2];c[v>>2]=1}while(0);F=c[q>>2]|0;if((c[c[q>>2]>>2]|0)!=1){c[A>>2]=c[F+64>>2];while(1){if(c[A>>2]|0)O=(c[c[A>>2]>>2]|0)!=1;else O=0;P=c[A>>2]|0;if(!O)break;c[A>>2]=c[P+64>>2]}if(!P){xB(c[o>>2]|0,156240,156272);J=149;break}}else c[A>>2]=F;do if((c[c[o>>2]>>2]|0)==2){E=c[(c[A>>2]|0)+88>>2]|0;if((E|0)==21){c[w>>2]=BC(c[o>>2]|0,c[r>>2]|0,y,c[x>>2]|0)|0;break}else if((E|0)!=28){E=c[A>>2]|0;C=c[r>>2]|0;D=c[p>>2]|0;if(c[x>>2]|0){c[w>>2]=UH(E,C,y,D)|0;break}else{c[w>>2]=UH(E,C,0,D)|0;break}}else{c[w>>2]=AC(c[o>>2]|0,c[(c[o>>2]|0)+20>>2]|0,0,c[r>>2]|0,y,c[x>>2]|0)|0;break}}else{if((c[c[o>>2]>>2]|0)!=1){D=c[33976]|0;C=c[33980]|0;c[m>>2]=140328;c[m+4>>2]=24593;Db[D&511](C,140296,m);J=149;break b}if((c[(c[A>>2]|0)+88>>2]|0)==28){c[w>>2]=AC(0,c[(c[o>>2]|0)+36>>2]|0,c[p>>2]|0,c[r>>2]|0,y,c[x>>2]|0)|0;break}C=c[A>>2]|0;D=c[r>>2]|0;E=c[p>>2]|0;if(c[x>>2]|0){c[w>>2]=UH(C,D,y,E)|0;break}else{c[w>>2]=UH(C,D,0,E)|0;break}}while(0);do if(c[w>>2]|0){if((c[w>>2]|0)<0){xB(c[o>>2]|0,156240,156304);J=149;break b}if(c[(c[q>>2]|0)+48>>2]&64){c[w>>2]=1825;break}else{c[w>>2]=1824;break}}while(0);do if(((c[w>>2]|0)==0?(c[(c[q>>2]|0)+48>>2]&134217728|0)!=0:0)?(c[w>>2]=CC(c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[(c[A>>2]|0)+88>>2]|0,c[r>>2]|0,c[y>>2]|0,0,c[t>>2]|0)|0,(c[w>>2]|0)!=0):0){if((c[w>>2]|0)<0){xB(c[o>>2]|0,156240,156344);J=149;break b}if(c[(c[q>>2]|0)+48>>2]&64){c[w>>2]=1825;break}else{c[w>>2]=1824;break}}while(0);if((c[t>>2]|0)!=0&(c[w>>2]|0)>0)DC(c[o>>2]|0,c[w>>2]|0,c[p>>2]|0,c[r>>2]|0,c[q>>2]|0,1)}while(0);if((J|0)==149){if(c[z>>2]|0)zb[c[135736>>2]&511](c[z>>2]|0);if(c[y>>2]|0)PH(c[y>>2]|0);c[n>>2]=-1;Q=c[n>>2]|0;i=l;return Q|0}if(c[z>>2]|0)zb[c[135736>>2]&511](c[z>>2]|0);do if(!(c[w>>2]|0)){z=c[y>>2]|0;if(c[s>>2]|0){c[c[s>>2]>>2]=z;break}if(z)PH(c[y>>2]|0)}else if(c[y>>2]|0)PH(c[y>>2]|0);while(0);c[n>>2]=c[w>>2];Q=c[n>>2]|0;i=l;return Q|0}function zB(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;do switch(c[e>>2]|0){case 1e3:{c[d>>2]=157848;break}case 1010:{c[d>>2]=157904;break}case 1002:{c[d>>2]=157816;break}case 1001:{c[d>>2]=157832;break}case 1003:{c[d>>2]=157800;break}case 1004:{c[d>>2]=157936;break}case 1009:{c[d>>2]=157896;break}case 1005:{c[d>>2]=157952;break}case 1007:{c[d>>2]=157880;break}case 1006:{c[d>>2]=157792;break}case 1011:{c[d>>2]=157920;break}case 1008:{c[d>>2]=157864;break}default:c[d>>2]=157968}while(0);i=b;return c[d>>2]|0}function AB(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+32|0;k=j+24|0;l=j+20|0;m=j+16|0;n=j+12|0;o=j+8|0;p=j+4|0;q=j;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=h;CB(c[k>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,0,0);i=j;return}function BB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(c[c[g>>2]>>2]|0){zb[c[135736>>2]&511](c[c[g>>2]>>2]|0);c[c[g>>2]>>2]=0}if(c[h>>2]|0){d=my(144432)|0;c[c[g>>2]>>2]=d;d=By(c[c[g>>2]>>2]|0,c[h>>2]|0)|0;c[c[g>>2]>>2]=d;d=By(c[c[g>>2]>>2]|0,144440)|0;c[c[g>>2]>>2]=d}do if(c[j>>2]|0){if(c[h>>2]|0){d=By(c[c[g>>2]>>2]|0,c[j>>2]|0)|0;c[c[g>>2]>>2]=d;break}c[f>>2]=c[j>>2];k=c[f>>2]|0;i=e;return k|0}else{d=By(c[c[g>>2]>>2]|0,170232)|0;c[c[g>>2]>>2]=d}while(0);c[f>>2]=c[c[g>>2]>>2];k=c[f>>2]|0;i=e;return k|0}function CB(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;l=i;i=i+48|0;m=l+36|0;n=l+32|0;o=l+28|0;p=l+24|0;q=l+20|0;r=l+16|0;s=l+12|0;t=l+8|0;u=l+4|0;v=l;c[m>>2]=a;c[n>>2]=b;c[o>>2]=d;c[p>>2]=e;c[q>>2]=f;c[r>>2]=g;c[s>>2]=h;c[t>>2]=j;c[u>>2]=k;c[v>>2]=0;if((c[o>>2]|0)==0&(c[p>>2]|0)!=0?(c[c[m>>2]>>2]|0)==1:0){c[o>>2]=FC(c[p>>2]|0)|0;GC(v,0,c[p>>2]|0,0)|0;c[v>>2]=By(c[v>>2]|0,152080)|0}else HC(v,c[m>>2]|0,c[o>>2]|0)|0;c[v>>2]=By(c[v>>2]|0,c[q>>2]|0)|0;c[v>>2]=By(c[v>>2]|0,142704)|0;IC(c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[v>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0);if(!(c[v>>2]|0)){i=l;return}zb[c[135736>>2]&511](c[v>>2]|0);c[v>>2]=0;i=l;return}function DB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](84)|0;if(!(c[f>>2]|0)){tC(c[e>>2]|0,170208,0);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{a=(c[f>>2]|0)+0|0;h=a+84|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(h|0));c[(c[f>>2]|0)+60>>2]=c[(c[e>>2]|0)+80>>2];yP(c[(c[f>>2]|0)+60>>2]|0)|0;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function EB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](36)|0;if(!(c[f>>2]|0)){tC(0,170080,0);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}a=(c[f>>2]|0)+0|0;h=a+36|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(h|0));a=JB()|0;c[(c[f>>2]|0)+12>>2]=a;if(!(c[(c[f>>2]|0)+12>>2]|0)){tC(0,170120,0);zb[c[135736>>2]&511](c[f>>2]|0);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}a=JB()|0;c[(c[f>>2]|0)+20>>2]=a;if(!(c[(c[f>>2]|0)+20>>2]|0)){tC(0,170160,0);sB(c[f>>2]|0);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{c[(c[f>>2]|0)+8>>2]=c[e>>2];yP(c[e>>2]|0)|0;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function FB(a,b,d,e,f,g,h,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;m=i;i=i+96|0;n=m+88|0;o=m+84|0;p=m+80|0;q=m+76|0;r=m+72|0;s=m+68|0;t=m+64|0;u=m+60|0;v=m+56|0;w=m+52|0;x=m+48|0;y=m+44|0;z=m+40|0;A=m+36|0;B=m+32|0;C=m+28|0;D=m+24|0;E=m+20|0;F=m+16|0;G=m+12|0;H=m+8|0;I=m+4|0;J=m;c[o>>2]=a;c[p>>2]=b;c[q>>2]=d;c[r>>2]=e;c[s>>2]=f;c[t>>2]=g;c[u>>2]=h;c[v>>2]=j;c[w>>2]=k;c[x>>2]=l;c[y>>2]=0;c[z>>2]=0;c[A>>2]=0;c[B>>2]=0;c[C>>2]=0;c[D>>2]=0;c[E>>2]=0;c[F>>2]=0;if(c[x>>2]|0)c[c[x>>2]>>2]=0;l=c[p>>2]|0;if((l|0)==2)c[C>>2]=3050;else if((l|0)==3)c[C>>2]=3081;else if((l|0)==0|(l|0)==1)c[C>>2]=3082;a:do if(((c[p>>2]|0)!=0?(c[(c[(c[o>>2]|0)+28>>2]|0)+12>>2]|0)!=0:0)?(c[(c[(c[(c[o>>2]|0)+28>>2]|0)+12>>2]|0)+4>>2]|0)>0:0){if(((c[q>>2]|0)!=0?(c[F>>2]=JC(c[o>>2]|0,c[q>>2]|0)|0,(c[F>>2]|0)!=0):0)?(c[(c[(c[o>>2]|0)+28>>2]|0)+16>>2]|0)==(c[F>>2]|0):0){AB(c[o>>2]|0,c[C>>2]|0,c[u>>2]|0,0,169048,0,0);K=92;break}c[z>>2]=KC()|0;if(!(c[z>>2]|0)){c[n>>2]=-1;L=c[n>>2]|0;i=m;return L|0}LC(c[(c[(c[o>>2]|0)+28>>2]|0)+16>>2]|0,c[z>>2]|0);c[(c[z>>2]|0)+4>>2]=c[p>>2];if((c[p>>2]|0)==0|(c[p>>2]|0)==1){c[(c[z>>2]|0)+8>>2]=c[w>>2];if(!(c[q>>2]|0)){K=92;break}c[y>>2]=c[w>>2]}do if(c[F>>2]|0){if((c[p>>2]|0)==0|(c[p>>2]|0)==1?(c[(c[F>>2]|0)+36>>2]|0)==0:0){if(!(c[q>>2]|0))c[q>>2]=169104;if(qy(c[q>>2]|0,c[(c[F>>2]|0)+8>>2]|0)|0)break;AB(c[o>>2]|0,c[C>>2]|0,c[u>>2]|0,0,169128,c[q>>2]|0,0);K=92;break a}if(!((c[p>>2]|0)==0|(c[p>>2]|0)==1)?(c[(c[F>>2]|0)+36>>2]|0)!=0:0){if(!(c[q>>2]|0))c[q>>2]=169104;if(!(qy(c[q>>2]|0,c[(c[F>>2]|0)+8>>2]|0)|0)){AB(c[o>>2]|0,c[C>>2]|0,c[u>>2]|0,0,169216,c[q>>2]|0,0);K=92;break a}}}while(0);l=(c[F>>2]|0)!=0;do if((c[p>>2]|0)==0|(c[p>>2]|0)==1){if(l){c[(c[z>>2]|0)+12>>2]=c[F>>2];K=92;break a}c[F>>2]=MC(c[o>>2]|0,c[w>>2]|0,1)|0;if(c[F>>2]|0){c[(c[z>>2]|0)+12>>2]=c[F>>2];k=c[q>>2]|0;j=(c[F>>2]|0)+8|0;if(!(c[(c[F>>2]|0)+8>>2]|0)){c[j>>2]=k;break}if(qy(k,c[j>>2]|0)|0){K=92;break a}if(!(c[q>>2]|0))c[q>>2]=169104;NC(c[o>>2]|0,3083,c[u>>2]|0,0,169304,c[q>>2]|0,c[w>>2]|0,c[(c[F>>2]|0)+8>>2]|0);K=92;break a}}else if(l){if((c[(c[F>>2]|0)+12>>2]|0)==0?(c[(c[F>>2]|0)+16>>2]|0)!=(c[v>>2]|0):0){c[G>>2]=OC(c[o>>2]|0,c[q>>2]|0,c[v>>2]|0)|0;if(c[G>>2]|0){c[(c[z>>2]|0)+12>>2]=c[G>>2];K=92;break a}else{c[F>>2]=0;break}}c[(c[z>>2]|0)+12>>2]=c[F>>2];K=92;break a}while(0);if((c[F>>2]|0)!=0?(c[(c[F>>2]|0)+20>>2]|0)!=0:0)xB(c[o>>2]|0,169448,169472);else K=52}else K=52;while(0);b:do if((K|0)==52){do if(c[r>>2]|0){c[A>>2]=c[r>>2];c[E>>2]=1;if(c[(c[r>>2]|0)+72>>2]|0){c[q>>2]=AP(c[(c[o>>2]|0)+80>>2]|0,c[(c[r>>2]|0)+72>>2]|0,-1)|0;K=73;break}else{c[q>>2]=169104;K=73;break}}else{if(!((c[q>>2]|0)!=0|(c[s>>2]|0)!=0)){PC(c[o>>2]|0,0,1758,169640,0,0);break b}c[H>>2]=Be()|0;if(!(c[H>>2]|0)){tC(0,169552,0);break b}if((c[(c[o>>2]|0)+80>>2]|0)!=0?(c[(c[H>>2]|0)+296>>2]|0)!=0:0){zP(c[(c[H>>2]|0)+296>>2]|0);c[(c[H>>2]|0)+296>>2]=c[(c[o>>2]|0)+80>>2];yP(c[(c[H>>2]|0)+296>>2]|0)|0}if(!(c[q>>2]|0)){if((c[s>>2]|0)!=0?(c[A>>2]=lg(c[H>>2]|0,c[s>>2]|0,c[t>>2]|0,0,0,2)|0,c[q>>2]=169104,(c[A>>2]|0)!=0):0){G=my(c[q>>2]|0)|0;c[(c[A>>2]|0)+72>>2]=G}}else c[A>>2]=kg(c[H>>2]|0,c[q>>2]|0,0,2)|0;do if(!(c[A>>2]|0)){c[I>>2]=de()|0;if((c[I>>2]|0)!=0?(c[c[I>>2]>>2]|0)==8:0)break;c[D>>2]=1;c[B>>2]=3067;AB(c[o>>2]|0,c[B>>2]|0,c[u>>2]|0,0,169600,c[q>>2]|0,0)}while(0);Ae(c[H>>2]|0);if(!((c[A>>2]|0)==0&(c[D>>2]|0)!=0))K=73}while(0);c:do if((K|0)==73){do if(c[A>>2]|0){c[J>>2]=0;c[D>>2]=1;c[J>>2]=Pi(c[A>>2]|0)|0;G=c[o>>2]|0;if(!(c[J>>2]|0)){AB(G,1759,c[u>>2]|0,0,169720,c[q>>2]|0,0);break c}QC(G,c[J>>2]|0);if((((c[J>>2]|0)!=0?(c[(c[J>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[J>>2]|0)+8>>2]|0,169768)|0)!=0:0)?(qy(c[(c[(c[J>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){c[y>>2]=RC(c[o>>2]|0,c[J>>2]|0,168888)|0;break}AB(c[o>>2]|0,1772,c[u>>2]|0,0,169776,c[q>>2]|0,0);break c}while(0);if((c[F>>2]|0)==0&(c[D>>2]|0)!=0?(c[F>>2]=SC(c[o>>2]|0,c[p>>2]|0,c[y>>2]|0)|0,(c[F>>2]|0)==0):0)break b;if(!(c[F>>2]|0)){K=92;break b}c[(c[F>>2]|0)+8>>2]=c[q>>2];c[(c[F>>2]|0)+28>>2]=c[D>>2];if((c[A>>2]|0)!=0?(c[(c[F>>2]|0)+20>>2]=c[A>>2],c[(c[F>>2]|0)+16>>2]=c[y>>2],c[(c[F>>2]|0)+12>>2]=c[y>>2],(c[E>>2]|0)!=0):0)c[(c[F>>2]|0)+40>>2]=1;if((c[p>>2]|0)==0|(c[p>>2]|0)==1){G=(c[F>>2]|0)+36|0;c[G>>2]=(c[G>>2]|0)+1}if(!(c[z>>2]|0)){K=92;break b}c[(c[z>>2]|0)+12>>2]=c[F>>2];K=92;break b}while(0);if(!((c[A>>2]|0)==0|(c[E>>2]|0)!=0)?(Th(c[A>>2]|0),(c[F>>2]|0)!=0):0)c[(c[F>>2]|0)+20>>2]=0;c[n>>2]=c[(c[o>>2]|0)+16>>2];L=c[n>>2]|0;i=m;return L|0}while(0);if((K|0)==92){if(c[x>>2]|0)c[c[x>>2]>>2]=c[F>>2];c[n>>2]=0;L=c[n>>2]|0;i=m;return L|0}if(!((c[A>>2]|0)==0|(c[E>>2]|0)!=0)?(Th(c[A>>2]|0),(c[F>>2]|0)!=0):0)c[(c[F>>2]|0)+20>>2]=0;c[n>>2]=-1;L=c[n>>2]|0;i=m;return L|0}function GB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+48|0;f=e+32|0;g=e+28|0;h=e+24|0;j=e+20|0;k=e+16|0;l=e+12|0;m=e+8|0;n=e+4|0;o=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[o>>2]=c[(c[(c[f>>2]|0)+28>>2]|0)+16>>2];c[j>>2]=c[(c[g>>2]|0)+24>>2];c[k>>2]=c[(c[g>>2]|0)+16>>2];if(c[(c[g>>2]|0)+24>>2]|0)TC(c[g>>2]|0);c[(c[g>>2]|0)+16>>2]=c[(c[h>>2]|0)+20>>2];c[(c[f>>2]|0)+36>>2]=c[g>>2];c[(c[f>>2]|0)+112>>2]=c[(c[h>>2]|0)+16>>2];c[(c[(c[f>>2]|0)+28>>2]|0)+16>>2]=c[h>>2];if((c[(c[h>>2]|0)+16>>2]|0)!=0?(qy(c[(c[h>>2]|0)+16>>2]|0,c[38526]|0)|0)!=0:0)c[(c[f>>2]|0)+96>>2]=1;d=(c[h>>2]|0)+32|0;c[d>>2]=(c[d>>2]|0)+1;c[l>>2]=Pi(c[(c[h>>2]|0)+20>>2]|0)|0;c[m>>2]=UC(c[f>>2]|0,c[g>>2]|0,c[l>>2]|0)|0;if((((c[m>>2]|0)==0?(c[(c[l>>2]|0)+12>>2]|0)!=0:0)?(c[n>>2]=c[(c[f>>2]|0)+20>>2],c[m>>2]=VC(c[f>>2]|0,c[g>>2]|0,c[(c[l>>2]|0)+12>>2]|0)|0,(c[m>>2]|0)==0&(c[m>>2]|0)==0):0)?(c[n>>2]|0)!=(c[(c[f>>2]|0)+20>>2]|0):0)c[m>>2]=c[(c[f>>2]|0)+16>>2];c[(c[(c[f>>2]|0)+28>>2]|0)+16>>2]=c[o>>2];c[(c[g>>2]|0)+16>>2]=c[k>>2];c[(c[g>>2]|0)+24>>2]=c[j>>2];i=e;return c[m>>2]|0}function HB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+48|0;e=d+40|0;f=d+36|0;g=d+32|0;h=d+28|0;j=d+24|0;k=d+20|0;l=d+16|0;m=d+12|0;n=d+8|0;o=d+4|0;p=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=c[(c[f>>2]|0)+28>>2];c[n>>2]=0;c[o>>2]=c[(c[h>>2]|0)+16>>2];if((c[(c[h>>2]|0)+20>>2]|0)!=0?(c[(c[(c[h>>2]|0)+20>>2]|0)+4>>2]|0)!=0:0){if(!(c[(c[h>>2]|0)+16>>2]|0))c[(c[h>>2]|0)+16>>2]=c[g>>2];WC(c[f>>2]|0)|0;XC(c[f>>2]|0,c[g>>2]|0)|0;c[(c[f>>2]|0)+84>>2]=0;c[k>>2]=c[c[(c[h>>2]|0)+20>>2]>>2];c[l>>2]=c[(c[(c[h>>2]|0)+20>>2]|0)+4>>2];c[m>>2]=0;a:while(1){if((c[m>>2]|0)>=(c[l>>2]|0)){q=20;break}c[j>>2]=c[(c[k>>2]|0)+(c[m>>2]<<2)>>2];switch(c[c[j>>2]>>2]|0){case 26:{$C(c[j>>2]|0,c[f>>2]|0)|0;if((c[(c[f>>2]|0)+16>>2]|0)==3069){q=115;break a}break}case 8:case 7:case 6:{bD(c[f>>2]|0,c[j>>2]|0);if((c[(c[f>>2]|0)+16>>2]|0)==3069){q=115;break a}break}case 4:case 5:{ZC(c[j>>2]|0,c[f>>2]|0);if((c[(c[f>>2]|0)+16>>2]|0)==3069){q=115;break a}break}case 14:{YC(c[j>>2]|0,c[f>>2]|0);if((c[(c[f>>2]|0)+16>>2]|0)==3069){q=115;break a}break}case 15:{_C(c[j>>2]|0,c[f>>2]|0)|0;if((c[(c[f>>2]|0)+16>>2]|0)==3069){q=115;break a}break}case 2e3:{if((c[(c[j>>2]|0)+8>>2]|0)==16)aD(c[j>>2]|0,c[f>>2]|0)|0;if((c[(c[f>>2]|0)+16>>2]|0)==3069){q=115;break a}break}case 2001:{dD(c[j>>2]|0,c[f>>2]|0)|0;if((c[(c[f>>2]|0)+16>>2]|0)==3069){q=115;break a}break}case 24:case 22:case 23:{cD(c[j>>2]|0,c[f>>2]|0)|0;if((c[(c[f>>2]|0)+16>>2]|0)==3069){q=115;break a}break}default:{}}c[m>>2]=(c[m>>2]|0)+1}b:do if((q|0)==20){c:do if(!(c[(c[f>>2]|0)+20>>2]|0)){c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[l>>2]|0))break;c[j>>2]=c[(c[k>>2]|0)+(c[m>>2]<<2)>>2];g=c[c[j>>2]>>2]|0;if((g|0)==16){gD(c[j>>2]|0,c[f>>2]|0)|0;if((c[(c[f>>2]|0)+16>>2]|0)==3069){q=115;break b}if(c[(c[f>>2]|0)+20>>2]|0)break c}else if((g|0)==4|(g|0)==5){eD(c[j>>2]|0,c[f>>2]|0);if((c[(c[f>>2]|0)+16>>2]|0)==3069){q=115;break b}if(c[(c[f>>2]|0)+20>>2]|0)break c}else if((g|0)==17){fD(c[j>>2]|0,c[f>>2]|0);if((c[(c[f>>2]|0)+16>>2]|0)==3069){q=115;break b}if(c[(c[f>>2]|0)+20>>2]|0)break c}c[m>>2]=(c[m>>2]|0)+1}if(!(c[(c[f>>2]|0)+20>>2]|0)){c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[l>>2]|0))break;c[j>>2]=c[(c[k>>2]|0)+(c[m>>2]<<2)>>2];if(((c[c[j>>2]>>2]|0)+-6|0)>>>0<2)hD(c[f>>2]|0,c[j>>2]|0);c[m>>2]=(c[m>>2]|0)+1}if(!(c[(c[f>>2]|0)+20>>2]|0)){c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[l>>2]|0))break;c[j>>2]=c[(c[k>>2]|0)+(c[m>>2]<<2)>>2];if((((c[c[j>>2]>>2]|0)==16?(c[(c[j>>2]|0)+36>>2]&1|0)==0:0)?(c[(c[j>>2]|0)+36>>2]&16|0)!=0:0)?(iD(c[f>>2]|0,c[j>>2]|0)|0,(c[(c[f>>2]|0)+16>>2]|0)==3069):0){q=115;break b}c[m>>2]=(c[m>>2]|0)+1}if(!(c[(c[f>>2]|0)+20>>2]|0)){c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[l>>2]|0))break;c[j>>2]=c[(c[k>>2]|0)+(c[m>>2]<<2)>>2];if((((c[c[j>>2]>>2]|0)==4?(c[c[j>>2]>>2]|0)!=1:0)?(c[(c[j>>2]|0)+48>>2]&536870912|0)==0:0)?(jD(c[f>>2]|0,c[j>>2]|0)|0,(c[(c[f>>2]|0)+16>>2]|0)==3069):0){q=115;break b}c[m>>2]=(c[m>>2]|0)+1}if(!(c[(c[f>>2]|0)+20>>2]|0)){c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[l>>2]|0))break;c[j>>2]=c[(c[k>>2]|0)+(c[m>>2]<<2)>>2];if(((c[c[j>>2]>>2]|0)==4?(c[(c[j>>2]|0)+92>>2]|0)!=0:0)?(kD(c[f>>2]|0,c[j>>2]|0)|0,(c[(c[f>>2]|0)+16>>2]|0)==3069):0){q=115;break b}c[m>>2]=(c[m>>2]|0)+1}if(!(c[(c[f>>2]|0)+20>>2]|0)){c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[l>>2]|0))break;c[j>>2]=c[(c[k>>2]|0)+(c[m>>2]<<2)>>2];if((((c[c[j>>2]>>2]|0)==4?(c[c[j>>2]>>2]|0)!=1:0)?(c[(c[j>>2]|0)+48>>2]&4194304|0)==0:0)?(lD(c[f>>2]|0,c[j>>2]|0)|0,(c[(c[f>>2]|0)+16>>2]|0)==3069):0){q=115;break b}c[m>>2]=(c[m>>2]|0)+1}if(!(c[(c[f>>2]|0)+20>>2]|0)){c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[l>>2]|0))break;c[j>>2]=c[(c[k>>2]|0)+(c[m>>2]<<2)>>2];if((c[c[j>>2]>>2]|0)==15?(mD(c[f>>2]|0,c[j>>2]|0)|0,(c[(c[f>>2]|0)+16>>2]|0)==3069):0){q=115;break b}c[m>>2]=(c[m>>2]|0)+1}if(!(c[(c[f>>2]|0)+20>>2]|0)){c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[l>>2]|0))break;c[j>>2]=c[(c[k>>2]|0)+(c[m>>2]<<2)>>2];if(((c[c[j>>2]>>2]|0)==26?(c[(c[j>>2]|0)+28>>2]|0)!=0:0)?(nD(c[f>>2]|0,c[j>>2]|0)|0,(c[(c[f>>2]|0)+16>>2]|0)==3069):0){q=115;break b}c[m>>2]=(c[m>>2]|0)+1}if(!(c[(c[f>>2]|0)+20>>2]|0)){c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[l>>2]|0))break;c[j>>2]=c[(c[k>>2]|0)+(c[m>>2]<<2)>>2];do if((c[c[j>>2]>>2]|0)==16?(c[(c[j>>2]|0)+56>>2]|0)!=0:0){if((c[(c[(c[j>>2]|0)+56>>2]|0)+4>>2]|0)<=1)break;oD(c[f>>2]|0,c[j>>2]|0)|0;if((c[(c[f>>2]|0)+16>>2]|0)==3069){q=115;break b}}while(0);c[m>>2]=(c[m>>2]|0)+1}if(!(c[(c[f>>2]|0)+20>>2]|0)){if(c[(c[(c[f>>2]|0)+28>>2]|0)+28>>2]|0)pD(c[f>>2]|0)|0;if(!(c[(c[f>>2]|0)+20>>2]|0)){c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[l>>2]|0))break;c[j>>2]=c[(c[c[(c[h>>2]|0)+20>>2]>>2]|0)+(c[m>>2]<<2)>>2];do if((c[c[j>>2]>>2]|0)==5){if((c[c[j>>2]>>2]|0)==1)break;if(c[(c[j>>2]|0)+48>>2]&4194304)break;qD(c[f>>2]|0,c[j>>2]|0)|0;if((c[(c[f>>2]|0)+16>>2]|0)==3069){q=115;break b}}while(0);c[m>>2]=(c[m>>2]|0)+1}if(!(c[(c[f>>2]|0)+20>>2]|0)){c[k>>2]=c[c[(c[h>>2]|0)+20>>2]>>2];c[l>>2]=c[(c[(c[h>>2]|0)+20>>2]|0)+4>>2];c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[l>>2]|0))break;c[j>>2]=c[(c[k>>2]|0)+(c[m>>2]<<2)>>2];do if((c[c[j>>2]>>2]|0)==14){c[p>>2]=c[j>>2];if(c[(c[p>>2]|0)+48>>2]&262144)break;rD(c[p>>2]|0,c[f>>2]|0);if((c[(c[f>>2]|0)+16>>2]|0)==3069){q=115;break b}}while(0);c[m>>2]=(c[m>>2]|0)+1}if(!(c[(c[f>>2]|0)+20>>2]|0)){c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[l>>2]|0))break;c[j>>2]=c[(c[k>>2]|0)+(c[m>>2]<<2)>>2];if((c[c[j>>2]>>2]|0)==5)sD(c[j>>2]|0,c[f>>2]|0);c[m>>2]=(c[m>>2]|0)+1}if(!(c[(c[f>>2]|0)+20>>2]|0))break b}}}}}}}}}}}}}while(0);c[n>>2]=c[(c[f>>2]|0)+16>>2]}while(0);if((q|0)==115)c[n>>2]=-1;c[(c[h>>2]|0)+16>>2]=c[o>>2];c[(c[(c[h>>2]|0)+20>>2]|0)+4>>2]=0;if(c[(c[h>>2]|0)+24>>2]|0){Kj(c[(c[h>>2]|0)+24>>2]|0,356);c[(c[h>>2]|0)+24>>2]=0}if(c[(c[h>>2]|0)+28>>2]|0){vC(c[(c[h>>2]|0)+28>>2]|0);c[(c[h>>2]|0)+28>>2]=0}c[e>>2]=c[n>>2];r=c[e>>2]|0;i=d;return r|0}c[e>>2]=0;r=c[e>>2]|0;i=d;return r|0}function IB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if(c[f>>2]|0){d=(c[f>>2]|0)+56|0;c[d>>2]=(c[d>>2]|0)+1;c[(c[f>>2]|0)+52>>2]=1818}ce(17,2,c[h>>2]|0,0,c[g>>2]|0);i=e;return}function JB(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=Cb[c[135744>>2]&511](12)|0;if(!(c[d>>2]|0)){tC(0,156200,0);c[b>>2]=0;e=c[b>>2]|0;i=a;return e|0}else{f=c[d>>2]|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[b>>2]=c[d>>2];e=c[b>>2]|0;i=a;return e|0}return 0}function KB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=0;if((pC(c[e>>2]|0)|0)<0){c[d>>2]=-1;g=c[d>>2]|0;i=b;return g|0}a=c[e>>2]|0;do if(!(c[(c[e>>2]|0)+24>>2]|0)){if(!(c[a+160>>2]|0)){if((c[(c[e>>2]|0)+36>>2]|0)!=0?(c[(c[e>>2]|0)+40>>2]|0)!=0:0){c[f>>2]=Qf(c[(c[e>>2]|0)+40>>2]|0)|0;break}xB(c[e>>2]|0,155872,155888);c[f>>2]=-1}}else c[f>>2]=tD(a)|0;while(0);qC(c[e>>2]|0);if(!(c[f>>2]|0))c[f>>2]=c[(c[e>>2]|0)+52>>2];c[d>>2]=c[f>>2];
g=c[d>>2]|0;i=b;return g|0}function LB(a,b,e,f,g,h,j,k,l){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;i=i+64|0;n=m+56|0;o=m+52|0;p=m+44|0;q=m+40|0;r=m+36|0;s=m+32|0;t=m+24|0;u=m+20|0;v=m+16|0;w=m+12|0;x=m+8|0;y=m+4|0;z=m;c[n>>2]=a;c[o>>2]=b;c[m+48>>2]=e;c[p>>2]=f;c[q>>2]=g;c[r>>2]=h;c[s>>2]=j;c[m+28>>2]=k;c[t>>2]=l;c[u>>2]=c[n>>2];n=(c[u>>2]|0)+96|0;c[n>>2]=(c[n>>2]|0)+1;if((c[(c[u>>2]|0)+176>>2]|0)!=-1?(c[(c[u>>2]|0)+96>>2]|0)>=(c[(c[u>>2]|0)+176>>2]|0):0){i=m;return}n=(uD(c[u>>2]|0)|0)==-1;l=c[u>>2]|0;a:do if(!n){c[w>>2]=c[l+108>>2];k=NP(c[(c[u>>2]|0)+40>>2]|0)|0;c[(c[w>>2]|0)+8>>2]=k;c[(c[w>>2]|0)+12>>2]=c[o>>2];c[(c[w>>2]|0)+16>>2]=c[p>>2];k=(c[w>>2]|0)+32|0;c[k>>2]=c[k>>2]|32;b:do if(c[q>>2]|0){c[x>>2]=0;c[y>>2]=0;while(1){if((c[x>>2]|0)>=(c[q>>2]|0))break b;if(c[(c[w>>2]|0)+64>>2]|0){if((c[(c[w>>2]|0)+72>>2]|0)<=(c[(c[w>>2]|0)+68>>2]|0)?(k=(c[w>>2]|0)+72|0,c[k>>2]=c[k>>2]<<1,k=Hb[c[135760>>2]&511](c[(c[w>>2]|0)+64>>2]|0,c[(c[w>>2]|0)+72>>2]<<1<<2)|0,c[(c[w>>2]|0)+64>>2]=k,(c[(c[w>>2]|0)+64>>2]|0)==0):0){A=14;break}}else{k=Cb[c[135744>>2]&511](40)|0;c[(c[w>>2]|0)+64>>2]=k;if(!(c[(c[w>>2]|0)+64>>2]|0)){A=10;break}c[(c[w>>2]|0)+68>>2]=0;c[(c[w>>2]|0)+72>>2]=5}c[(c[(c[w>>2]|0)+64>>2]|0)+(c[(c[w>>2]|0)+68>>2]<<1<<2)>>2]=c[(c[r>>2]|0)+(c[y>>2]<<2)>>2];if(!(d[c[(c[r>>2]|0)+((c[y>>2]|0)+1<<2)>>2]>>0]|0))c[(c[(c[w>>2]|0)+64>>2]|0)+((c[(c[w>>2]|0)+68>>2]<<1)+1<<2)>>2]=0;else c[(c[(c[w>>2]|0)+64>>2]|0)+((c[(c[w>>2]|0)+68>>2]<<1)+1<<2)>>2]=c[(c[r>>2]|0)+((c[y>>2]|0)+1<<2)>>2];k=(c[w>>2]|0)+68|0;c[k>>2]=(c[k>>2]|0)+1;c[x>>2]=(c[x>>2]|0)+1;c[y>>2]=(c[y>>2]|0)+2}if((A|0)==10){IB(c[u>>2]|0,144584,0);break a}else if((A|0)==14){IB(c[u>>2]|0,144640,0);break a}}while(0);c:do if(c[s>>2]|0){c[y>>2]=0;c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[s>>2]|0))break c;c[z>>2]=ly(c[(c[t>>2]|0)+((c[y>>2]|0)+3<<2)>>2]|0,(c[(c[t>>2]|0)+((c[y>>2]|0)+4<<2)>>2]|0)-(c[(c[t>>2]|0)+((c[y>>2]|0)+3<<2)>>2]|0)|0)|0;c[v>>2]=vD(c[u>>2]|0,0,c[(c[w>>2]|0)+8>>2]|0,c[(c[t>>2]|0)+(c[y>>2]<<2)>>2]|0,c[(c[t>>2]|0)+((c[y>>2]|0)+2<<2)>>2]|0,0,c[z>>2]|0,1)|0;if((c[v>>2]|0)==-1)break;c[x>>2]=(c[x>>2]|0)+1;c[y>>2]=(c[y>>2]|0)+5}xB(c[u>>2]|0,144504,144696);break a}while(0);c[v>>2]=wD(c[u>>2]|0)|0;if((c[v>>2]|0)!=0&(c[v>>2]|0)==-1){xB(c[u>>2]|0,144504,144744);break}else{i=m;return}}else xB(l,144504,144544);while(0);c[(c[u>>2]|0)+52>>2]=-1;Uf(c[(c[u>>2]|0)+40>>2]|0);i=m;return}function MB(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+8|0;k=f+4|0;l=f;c[g>>2]=a;c[h>>2]=b;c[f+12>>2]=d;c[j>>2]=e;c[k>>2]=c[g>>2];do if((c[(c[k>>2]|0)+176>>2]|0)!=-1){g=c[k>>2]|0;if((c[(c[k>>2]|0)+96>>2]|0)<=(c[(c[k>>2]|0)+176>>2]|0)){c[g+176>>2]=-1;break}e=g+96|0;c[e>>2]=(c[e>>2]|0)+-1;i=f;return}while(0);if(!((qy(c[(c[(c[k>>2]|0)+108>>2]|0)+12>>2]|0,c[h>>2]|0)|0)!=0?(qy(c[(c[(c[k>>2]|0)+108>>2]|0)+16>>2]|0,c[j>>2]|0)|0)!=0:0))xB(c[k>>2]|0,141632,141664);c[l>>2]=xD(c[k>>2]|0)|0;if(!((c[l>>2]|0)!=0&(c[l>>2]|0)<0)){i=f;return}xB(c[k>>2]|0,141632,141688);c[(c[k>>2]|0)+52>>2]=-1;Uf(c[(c[k>>2]|0)+40>>2]|0);i=f;return}function NB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=c[f>>2];if((c[(c[j>>2]|0)+96>>2]|0)<0){i=e;return}if((c[(c[j>>2]|0)+176>>2]|0)!=-1?(c[(c[j>>2]|0)+96>>2]|0)>=(c[(c[j>>2]|0)+176>>2]|0):0){i=e;return}if(c[(c[(c[j>>2]|0)+108>>2]|0)+32>>2]&32){f=(c[(c[j>>2]|0)+108>>2]|0)+32|0;c[f>>2]=c[f>>2]^32}if((yD(c[j>>2]|0,3,c[g>>2]|0,c[h>>2]|0,3,0)|0)!=-1){i=e;return}xB(c[j>>2]|0,141304,141336);c[(c[j>>2]|0)+52>>2]=-1;Uf(c[(c[j>>2]|0)+40>>2]|0);i=e;return}function OB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=c[f>>2];if((c[(c[j>>2]|0)+96>>2]|0)<0){i=e;return}if((c[(c[j>>2]|0)+176>>2]|0)!=-1?(c[(c[j>>2]|0)+96>>2]|0)>=(c[(c[j>>2]|0)+176>>2]|0):0){i=e;return}if(c[(c[(c[j>>2]|0)+108>>2]|0)+32>>2]&32){f=(c[(c[j>>2]|0)+108>>2]|0)+32|0;c[f>>2]=c[f>>2]^32}if((yD(c[j>>2]|0,4,c[g>>2]|0,c[h>>2]|0,3,0)|0)!=-1){i=e;return}xB(c[j>>2]|0,141304,141336);c[(c[j>>2]|0)+52>>2]=-1;Uf(c[(c[j>>2]|0)+40>>2]|0);i=e;return}function PB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d;f=d+16|0;g=d+8|0;c[f>>2]=a;c[d+12>>2]=b;c[g>>2]=c[f>>2];if((c[(c[g>>2]|0)+96>>2]|0)<0){i=d;return}if((c[(c[g>>2]|0)+176>>2]|0)!=-1?(c[(c[g>>2]|0)+96>>2]|0)>=(c[(c[g>>2]|0)+176>>2]|0):0){i=d;return}g=c[33976]|0;f=c[33980]|0;c[e>>2]=140328;c[e+4>>2]=27281;Db[g&511](f,140296,e);i=d;return}function QB(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=c[g>>2];if(!(c[l>>2]|0)){i=f;return}if(!(c[(c[l>>2]|0)+8>>2]|0)){i=f;return}if(!(c[c[(c[l>>2]|0)+8>>2]>>2]|0)){i=f;return}Jb[c[c[(c[l>>2]|0)+8>>2]>>2]&511](c[(c[l>>2]|0)+16>>2]|0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0);i=f;return}function RB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=c[e>>2];if(((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+8>>2]|0)!=0:0)?(c[(c[(c[f>>2]|0)+8>>2]|0)+4>>2]|0)!=0:0){c[d>>2]=Cb[c[(c[(c[f>>2]|0)+8>>2]|0)+4>>2]&511](c[(c[f>>2]|0)+16>>2]|0)|0;g=c[d>>2]|0;i=b;return g|0}c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}function SB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=c[e>>2];if(((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+8>>2]|0)!=0:0)?(c[(c[(c[f>>2]|0)+8>>2]|0)+8>>2]|0)!=0:0){c[d>>2]=Cb[c[(c[(c[f>>2]|0)+8>>2]|0)+8>>2]&511](c[(c[f>>2]|0)+16>>2]|0)|0;g=c[d>>2]|0;i=b;return g|0}c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}function TB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=c[e>>2];if(((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+8>>2]|0)!=0:0)?(c[(c[(c[f>>2]|0)+8>>2]|0)+12>>2]|0)!=0:0){c[d>>2]=Cb[c[(c[(c[f>>2]|0)+8>>2]|0)+12>>2]&511](c[(c[f>>2]|0)+16>>2]|0)|0;g=c[d>>2]|0;i=b;return g|0}c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}function UB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=c[g>>2];if(((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+8>>2]|0)!=0:0)?(c[(c[(c[k>>2]|0)+8>>2]|0)+16>>2]|0)!=0:0){c[f>>2]=vb[c[(c[(c[k>>2]|0)+8>>2]|0)+16>>2]&511](c[(c[k>>2]|0)+16>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;l=c[f>>2]|0;i=e;return l|0}c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}function VB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=c[f>>2];if(((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+8>>2]|0)!=0:0)?(c[(c[(c[h>>2]|0)+8>>2]|0)+20>>2]|0)!=0:0){c[e>>2]=Hb[c[(c[(c[h>>2]|0)+8>>2]|0)+20>>2]&511](c[(c[h>>2]|0)+16>>2]|0,c[g>>2]|0)|0;j=c[e>>2]|0;i=d;return j|0}c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}function WB(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+32|0;j=h+24|0;k=h+20|0;l=h+16|0;m=h+12|0;n=h+8|0;o=h+4|0;p=h;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[p>>2]=c[j>>2];if(!(c[p>>2]|0)){i=h;return}if(!(c[(c[p>>2]|0)+8>>2]|0)){i=h;return}if(!(c[(c[(c[p>>2]|0)+8>>2]|0)+24>>2]|0)){i=h;return}Gb[c[(c[(c[p>>2]|0)+8>>2]|0)+24>>2]&511](c[(c[p>>2]|0)+16>>2]|0,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0);i=h;return}function XB(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=c[g>>2];if(!(c[l>>2]|0)){i=f;return}if(!(c[(c[l>>2]|0)+8>>2]|0)){i=f;return}if(!(c[(c[(c[l>>2]|0)+8>>2]|0)+28>>2]|0)){i=f;return}Jb[c[(c[(c[l>>2]|0)+8>>2]|0)+28>>2]&511](c[(c[l>>2]|0)+16>>2]|0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0);i=f;return}function YB(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+32|0;k=j+28|0;l=j+24|0;m=j+20|0;n=j+16|0;o=j+12|0;p=j+8|0;q=j+4|0;r=j;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=h;c[r>>2]=c[k>>2];if(((c[r>>2]|0)!=0?(c[(c[r>>2]|0)+8>>2]|0)!=0:0)?(c[(c[(c[r>>2]|0)+8>>2]|0)+32>>2]|0)!=0:0){wb[c[(c[(c[r>>2]|0)+8>>2]|0)+32>>2]&511](c[(c[r>>2]|0)+16>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[q>>2]|0);i=j;return}rm(c[q>>2]|0);i=j;return}function ZB(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=c[g>>2];if(!(c[l>>2]|0)){i=f;return}if(!(c[(c[l>>2]|0)+8>>2]|0)){i=f;return}if(!(c[(c[(c[l>>2]|0)+8>>2]|0)+36>>2]|0)){i=f;return}Jb[c[(c[(c[l>>2]|0)+8>>2]|0)+36>>2]&511](c[(c[l>>2]|0)+16>>2]|0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0);i=f;return}function _B(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[n>>2]=c[h>>2];if(!(c[n>>2]|0)){i=g;return}if(!(c[(c[n>>2]|0)+8>>2]|0)){i=g;return}if(!(c[(c[(c[n>>2]|0)+8>>2]|0)+40>>2]|0)){i=g;return}xb[c[(c[(c[n>>2]|0)+8>>2]|0)+40>>2]&511](c[(c[n>>2]|0)+16>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0);i=g;return}function $B(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=c[e>>2];if(!(c[g>>2]|0)){i=d;return}if(!(c[(c[g>>2]|0)+8>>2]|0)){i=d;return}if(!(c[(c[(c[g>>2]|0)+8>>2]|0)+44>>2]|0)){i=d;return}Ab[c[(c[(c[g>>2]|0)+8>>2]|0)+44>>2]&511](c[(c[g>>2]|0)+16>>2]|0,c[f>>2]|0);i=d;return}function aC(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[d>>2];if(!(c[e>>2]|0)){i=b;return}if(!(c[(c[e>>2]|0)+8>>2]|0)){i=b;return}if(!(c[(c[(c[e>>2]|0)+8>>2]|0)+48>>2]|0)){i=b;return}zb[c[(c[(c[e>>2]|0)+8>>2]|0)+48>>2]&511](c[(c[e>>2]|0)+16>>2]|0);i=b;return}function bC(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[d>>2];if(!(c[e>>2]|0)){i=b;return}if(!(c[(c[e>>2]|0)+8>>2]|0)){i=b;return}if(!(c[(c[(c[e>>2]|0)+8>>2]|0)+52>>2]|0)){i=b;return}zb[c[(c[(c[e>>2]|0)+8>>2]|0)+52>>2]&511](c[(c[e>>2]|0)+16>>2]|0);i=b;return}function cC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=c[f>>2];if(!(c[j>>2]|0)){i=e;return}if(!(c[(c[j>>2]|0)+8>>2]|0)){i=e;return}if(!(c[(c[(c[j>>2]|0)+8>>2]|0)+76>>2]|0)){i=e;return}Db[c[(c[(c[j>>2]|0)+8>>2]|0)+76>>2]&511](c[(c[j>>2]|0)+16>>2]|0,c[g>>2]|0,c[h>>2]|0);i=e;return}function dC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=c[e>>2];if(!(c[g>>2]|0)){i=d;return}if(!(c[(c[g>>2]|0)+8>>2]|0)){i=d;return}if(!(c[(c[(c[g>>2]|0)+8>>2]|0)+80>>2]|0)){i=d;return}Ab[c[(c[(c[g>>2]|0)+8>>2]|0)+80>>2]&511](c[(c[g>>2]|0)+16>>2]|0,c[f>>2]|0);i=d;return}function eC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;d=i;i=i+32|0;e=d;f=d+16|0;g=d+8|0;c[f>>2]=a;c[d+12>>2]=b;c[g>>2]=c[f>>2];if(!(c[g>>2]|0)){i=d;return}if(!(c[(c[g>>2]|0)+8>>2]|0)){i=d;return}if(!(c[(c[(c[g>>2]|0)+8>>2]|0)+84>>2]|0)){i=d;return}g=c[33976]|0;f=c[33980]|0;c[e>>2]=140328;c[e+4>>2]=28421;Db[g&511](f,140296,e);i=d;return}function fC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;d=i;i=i+32|0;e=d;f=d+16|0;g=d+8|0;c[f>>2]=a;c[d+12>>2]=b;c[g>>2]=c[f>>2];if(!(c[g>>2]|0)){i=d;return}if(!(c[(c[g>>2]|0)+8>>2]|0)){i=d;return}if(!(c[(c[(c[g>>2]|0)+8>>2]|0)+88>>2]|0)){i=d;return}g=c[33976]|0;f=c[33980]|0;c[e>>2]=140328;c[e+4>>2]=28429;Db[g&511](f,140296,e);i=d;return}function gC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;d=i;i=i+32|0;e=d;f=d+16|0;g=d+8|0;c[f>>2]=a;c[d+12>>2]=b;c[g>>2]=c[f>>2];if(!(c[g>>2]|0)){i=d;return}if(!(c[(c[g>>2]|0)+8>>2]|0)){i=d;return}if(!(c[(c[(c[g>>2]|0)+8>>2]|0)+92>>2]|0)){i=d;return}g=c[33976]|0;f=c[33980]|0;c[e>>2]=140328;c[e+4>>2]=28437;Db[g&511](f,140296,e);i=d;return}function hC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=c[f>>2];if(((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+8>>2]|0)!=0:0)?(c[(c[(c[h>>2]|0)+8>>2]|0)+96>>2]|0)!=0:0){c[e>>2]=Hb[c[(c[(c[h>>2]|0)+8>>2]|0)+96>>2]&511](c[(c[h>>2]|0)+16>>2]|0,c[g>>2]|0)|0;j=c[e>>2]|0;i=d;return j|0}c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}function iC(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=c[g>>2];if(!(c[l>>2]|0)){i=f;return}if(!(c[(c[l>>2]|0)+8>>2]|0)){i=f;return}if(!(c[(c[(c[l>>2]|0)+8>>2]|0)+104>>2]|0)){i=f;return}Jb[c[(c[(c[l>>2]|0)+8>>2]|0)+104>>2]&511](c[(c[l>>2]|0)+16>>2]|0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0);i=f;return}function jC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=c[f>>2];if(!(c[j>>2]|0)){i=e;return}if((c[(c[j>>2]|0)+8>>2]|0)!=0?(c[(c[(c[j>>2]|0)+8>>2]|0)+68>>2]|0)!=0:0)Db[c[(c[(c[j>>2]|0)+8>>2]|0)+68>>2]&511](c[(c[j>>2]|0)+16>>2]|0,c[g>>2]|0,c[h>>2]|0);if(!(c[(c[j>>2]|0)+148>>2]|0)){i=e;return}NB(c[(c[j>>2]|0)+148>>2]|0,c[g>>2]|0,c[h>>2]|0);i=e;return}function kC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=c[f>>2];if(!(c[j>>2]|0)){i=e;return}if((c[(c[j>>2]|0)+8>>2]|0)!=0?(c[(c[(c[j>>2]|0)+8>>2]|0)+72>>2]|0)!=0:0)Db[c[(c[(c[j>>2]|0)+8>>2]|0)+72>>2]&511](c[(c[j>>2]|0)+16>>2]|0,c[g>>2]|0,c[h>>2]|0);if(!(c[(c[j>>2]|0)+148>>2]|0)){i=e;return}NB(c[(c[j>>2]|0)+148>>2]|0,c[g>>2]|0,c[h>>2]|0);i=e;return}function lC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=c[f>>2];if(!(c[j>>2]|0)){i=e;return}if((c[(c[j>>2]|0)+8>>2]|0)!=0?(c[(c[(c[j>>2]|0)+8>>2]|0)+100>>2]|0)!=0:0)Db[c[(c[(c[j>>2]|0)+8>>2]|0)+100>>2]&511](c[(c[j>>2]|0)+16>>2]|0,c[g>>2]|0,c[h>>2]|0);if(!(c[(c[j>>2]|0)+148>>2]|0)){i=e;return}OB(c[(c[j>>2]|0)+148>>2]|0,c[g>>2]|0,c[h>>2]|0);i=e;return}function mC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=c[e>>2];if(!(c[g>>2]|0)){i=d;return}if(((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+8>>2]|0)!=0:0)?(c[(c[(c[g>>2]|0)+8>>2]|0)+64>>2]|0)!=0:0)Ab[c[(c[(c[g>>2]|0)+8>>2]|0)+64>>2]&511](c[(c[g>>2]|0)+16>>2]|0,c[f>>2]|0);if(!(c[(c[g>>2]|0)+148>>2]|0)){i=d;return}PB(c[(c[g>>2]|0)+16>>2]|0,c[f>>2]|0);i=d;return}function nC(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;l=i;i=i+48|0;m=l+36|0;n=l+32|0;o=l+28|0;p=l+24|0;q=l+20|0;r=l+16|0;s=l+12|0;t=l+8|0;u=l+4|0;v=l;c[m>>2]=a;c[n>>2]=b;c[o>>2]=d;c[p>>2]=e;c[q>>2]=f;c[r>>2]=g;c[s>>2]=h;c[t>>2]=j;c[u>>2]=k;c[v>>2]=c[m>>2];if(!(c[v>>2]|0)){i=l;return}if((c[(c[v>>2]|0)+8>>2]|0)!=0?(c[(c[(c[v>>2]|0)+8>>2]|0)+116>>2]|0)!=0:0)Eb[c[(c[(c[v>>2]|0)+8>>2]|0)+116>>2]&511](c[(c[v>>2]|0)+16>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0);if(!(c[(c[v>>2]|0)+148>>2]|0)){i=l;return}LB(c[(c[v>>2]|0)+148>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0);i=l;return}function oC(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=c[g>>2];if(!(c[l>>2]|0)){i=f;return}if((c[(c[l>>2]|0)+8>>2]|0)!=0?(c[(c[(c[l>>2]|0)+8>>2]|0)+120>>2]|0)!=0:0)Jb[c[(c[(c[l>>2]|0)+8>>2]|0)+120>>2]&511](c[(c[l>>2]|0)+16>>2]|0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0);if(!(c[(c[l>>2]|0)+148>>2]|0)){i=f;return}MB(c[(c[l>>2]|0)+148>>2]|0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0);i=f;return}function pC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[(c[e>>2]|0)+52>>2]=0;c[(c[e>>2]|0)+56>>2]=0;c[(c[e>>2]|0)+96>>2]=-1;c[(c[e>>2]|0)+176>>2]=-1;c[(c[e>>2]|0)+92>>2]=0;c[(c[e>>2]|0)+184>>2]=0;c[(c[e>>2]|0)+188>>2]=0;do if(!(c[(c[e>>2]|0)+20>>2]|0)){c[(c[e>>2]|0)+92>>2]=1;if((c[(c[e>>2]|0)+88>>2]|0)==0?(zD(c[e>>2]|0)|0)==-1:0){c[d>>2]=-1;g=c[d>>2]|0;i=b;return g|0}c[f>>2]=c[(c[e>>2]|0)+88>>2];c[(c[f>>2]|0)+104>>2]=1;a=DB(c[f>>2]|0)|0;c[(c[e>>2]|0)+20>>2]=a;if(!(c[(c[e>>2]|0)+20>>2]|0)){c[d>>2]=-1;g=c[d>>2]|0;i=b;return g|0}a=EB(c[(c[f>>2]|0)+80>>2]|0)|0;c[(c[f>>2]|0)+28>>2]=a;if(c[(c[f>>2]|0)+28>>2]|0){c[c[(c[f>>2]|0)+28>>2]>>2]=c[(c[e>>2]|0)+20>>2];c[(c[f>>2]|0)+32>>2]=1;break}c[d>>2]=-1;g=c[d>>2]|0;i=b;return g|0}while(0);Wj(c[(c[(c[e>>2]|0)+20>>2]|0)+48>>2]|0,357,c[e>>2]|0);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}function qC(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[(c[d>>2]|0)+92>>2]|0)!=0?(c[(c[d>>2]|0)+20>>2]|0)!=0:0){WA(c[(c[d>>2]|0)+20>>2]|0);c[(c[d>>2]|0)+20>>2]=0}BD(c[d>>2]|0);i=b;return}function rC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if((c[g>>2]|0)!=0?!((c[h>>2]|0)==0&(c[j>>2]|0)==0):0){if(c[h>>2]|0)c[c[h>>2]>>2]=0;if(c[j>>2]|0)c[c[j>>2]>>2]=0;c[k>>2]=c[g>>2];if(!(c[(c[k>>2]|0)+36>>2]|0)){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}if(c[h>>2]|0)c[c[h>>2]>>2]=c[(c[(c[k>>2]|0)+36>>2]|0)+4>>2];if(c[j>>2]|0)c[c[j>>2]>>2]=c[(c[(c[k>>2]|0)+36>>2]|0)+28>>2];c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}function sC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(!(c[(c[d>>2]|0)+4>>2]|0)){i=b;return}c[f>>2]=c[c[d>>2]>>2];c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[(c[d>>2]|0)+4>>2]|0))break;c[e>>2]=c[(c[f>>2]|0)+(c[g>>2]<<2)>>2];a:do if(c[e>>2]|0)do switch(c[c[e>>2]>>2]|0){case 18:{KD(c[e>>2]|0);break a;break}case 26:{DD(c[e>>2]|0);break a;break}case 8:case 7:case 6:{GD(c[e>>2]|0);break a;break}case 14:{FD(c[e>>2]|0);break a;break}case 2e3:{LD(c[e>>2]|0);break a;break}case 25:{if(c[(c[e>>2]|0)+4>>2]|0)mB(c[(c[e>>2]|0)+4>>2]|0);zb[c[135736>>2]&511](c[e>>2]|0);break a;break}case 5:case 4:{VA(c[e>>2]|0);break a;break}case 15:{CD(c[e>>2]|0);break a;break}case 17:{ID(c[e>>2]|0);break a;break}case 16:{HD(c[e>>2]|0);break a;break}case 2001:{ED(c[e>>2]|0);break a;break}case 24:case 22:case 23:{JD(c[e>>2]|0);break a;break}case 21:case 2:{TA(c[e>>2]|0);break a;break}default:{ND(0,170280,MD(c[e>>2]|0)|0);break a}}while(0);while(0);c[g>>2]=(c[g>>2]|0)+1}c[(c[d>>2]|0)+4>>2]=0;i=b;return}function tC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if(c[f>>2]|0){d=(c[f>>2]|0)+20|0;c[d>>2]=(c[d>>2]|0)+1}ce(16,2,c[h>>2]|0,0,c[g>>2]|0);i=e;return}function uC(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+4>>2]|0)oB(c[(c[d>>2]|0)+4>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function vC(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;while(1){if(!(c[d>>2]|0))break;c[e>>2]=c[d>>2];c[d>>2]=c[c[d>>2]>>2];zb[c[135736>>2]&511](c[e>>2]|0)}i=b;return}function wC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[e>>2]=a;c[f>>2]=b;while(1){if(!(c[f>>2]|0))break;c[g>>2]=c[(c[f>>2]|0)+8>>2];a:do if(c[(c[f>>2]|0)+24>>2]|0){c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[(c[f>>2]|0)+28>>2]|0))break a;if(c[(c[(c[f>>2]|0)+24>>2]|0)+(c[h>>2]<<2)>>2]|0){zb[c[135736>>2]&511](c[(c[(c[f>>2]|0)+24>>2]|0)+(c[h>>2]<<2)>>2]|0);c[(c[(c[f>>2]|0)+24>>2]|0)+(c[h>>2]<<2)>>2]=0}c[h>>2]=(c[h>>2]|0)+1}}while(0);if(c[(c[f>>2]|0)+32>>2]|0){b:do if((c[(c[f>>2]|0)+20>>2]|0)==24){c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[(c[(c[f>>2]|0)+32>>2]|0)+4>>2]|0))break b;c[k>>2]=c[(c[c[(c[f>>2]|0)+32>>2]>>2]|0)+(c[j>>2]<<2)>>2];zb[c[135736>>2]&511](c[(c[k>>2]|0)+4>>2]|0);zb[c[135736>>2]&511](c[k>>2]|0);c[j>>2]=(c[j>>2]|0)+1}}while(0);oB(c[(c[f>>2]|0)+32>>2]|0);c[(c[f>>2]|0)+32>>2]=0}c[(c[f>>2]|0)+8>>2]=0;if(c[(c[e>>2]|0)+124>>2]|0)c[(c[f>>2]|0)+12>>2]=c[(c[e>>2]|0)+124>>2];c[(c[e>>2]|0)+124>>2]=c[f>>2];c[f>>2]=c[g>>2]}i=d;return}function xC(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;while(1){if(!(c[d>>2]|0))break;c[e>>2]=c[d>>2];c[d>>2]=c[c[d>>2]>>2];OD(c[e>>2]|0)}i=b;return}function yC(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[n>>2]=0;if(!(c[h>>2]|0)){i=g;return}c[n>>2]=my(158256)|0;c[n>>2]=By(c[n>>2]|0,c[j>>2]|0)|0;c[n>>2]=By(c[n>>2]|0,144448)|0;c[n>>2]=By(c[n>>2]|0,c[k>>2]|0)|0;c[n>>2]=By(c[n>>2]|0,142704)|0;k=c[h>>2]|0;if((c[c[h>>2]>>2]|0)!=2){if((c[k>>2]|0)==1)PD(c[h>>2]|0,3069,0,c[n>>2]|0,c[l>>2]|0,c[m>>2]|0)}else PD(k,1818,0,c[n>>2]|0,c[l>>2]|0,c[m>>2]|0);if(!(c[n>>2]|0)){i=g;return}zb[c[135736>>2]&511](c[n>>2]|0);c[n>>2]=0;i=g;return}function zC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;b=QD(c[f>>2]|0)|0;if((b|0)==3)c[e>>2]=SH(c[g>>2]|0)|0;else if((b|0)==2)c[e>>2]=RH(c[g>>2]|0)|0;else c[e>>2]=0;i=d;return c[e>>2]|0}function AC(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;h=i;i=i+48|0;j=h+44|0;k=h+40|0;l=h+36|0;m=h+32|0;n=h+28|0;o=h+24|0;p=h+20|0;q=h+16|0;r=h+12|0;s=h+8|0;t=h+4|0;u=h;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;if((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+20>>2]|0)==0:0){xB(c[k>>2]|0,157712,157744);c[j>>2]=-1;v=c[j>>2]|0;i=h;return v|0}c[q>>2]=Fh(c[n>>2]|0,1)|0;if(c[q>>2]|0){c[j>>2]=c[q>>2];v=c[j>>2]|0;i=h;return v|0}c[r>>2]=0;c[s>>2]=0;c[r>>2]=Ch(c[n>>2]|0,s)|0;if(!(c[s>>2]|0)){if(!(SD(c[l>>2]|0,c[n>>2]|0,0)|0)){c[j>>2]=1;v=c[j>>2]|0;i=h;return v|0}if((c[p>>2]|0)!=0&(c[o>>2]|0)!=0?(g=NH(my(c[n>>2]|0)|0,0)|0,c[c[o>>2]>>2]=g,(c[c[o>>2]>>2]|0)==0):0)c[q>>2]=-1}else{c[t>>2]=0;do if(!(c[k>>2]|0))if(c[m>>2]|0){c[u>>2]=cj(c[(c[m>>2]|0)+32>>2]|0,c[m>>2]|0,c[s>>2]|0)|0;if(!(c[u>>2]|0))break;c[t>>2]=c[(c[u>>2]|0)+8>>2];break}else{zb[c[135736>>2]&511](c[s>>2]|0);zb[c[135736>>2]&511](c[r>>2]|0);c[j>>2]=1;v=c[j>>2]|0;i=h;return v|0}else c[t>>2]=RD(c[k>>2]|0,c[s>>2]|0)|0;while(0);if(!(c[t>>2]|0)){zb[c[135736>>2]&511](c[s>>2]|0);zb[c[135736>>2]&511](c[r>>2]|0);c[j>>2]=1;v=c[j>>2]|0;i=h;return v|0}if(SD(c[l>>2]|0,c[r>>2]|0,c[t>>2]|0)|0){if((c[p>>2]|0)!=0&(c[o>>2]|0)!=0?(p=my(c[r>>2]|0)|0,l=NH(p,my(c[t>>2]|0)|0)|0,c[c[o>>2]>>2]=l,(c[c[o>>2]>>2]|0)==0):0)c[q>>2]=-1}else c[q>>2]=1;zb[c[135736>>2]&511](c[s>>2]|0);zb[c[135736>>2]&511](c[r>>2]|0)}c[j>>2]=c[q>>2];v=c[j>>2]|0;i=h;return v|0}function BC(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+48|0;g=f+32|0;h=f+28|0;j=f+24|0;k=f+20|0;l=f+16|0;m=f+12|0;n=f+8|0;o=f+4|0;p=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[p>>2]=0;c[m>>2]=Fh(c[j>>2]|0,1)|0;if(c[m>>2]|0)if((c[m>>2]|0)==-1){xB(c[h>>2]|0,157656,157680);c[g>>2]=-1;q=c[g>>2]|0;i=f;return q|0}else{c[g>>2]=1824;q=c[g>>2]|0;i=f;return q|0}c[o>>2]=Ch(c[j>>2]|0,p)|0;if(!(c[o>>2]|0))c[o>>2]=my(c[j>>2]|0)|0;c[n>>2]=RD(c[h>>2]|0,c[p>>2]|0)|0;if((c[p>>2]|0)!=0?(zb[c[135736>>2]&511](c[p>>2]|0),(c[n>>2]|0)==0):0){c[m>>2]=1824;p=c[h>>2]|0;h=c[m>>2]|0;e=IH(21)|0;AB(p,h,0,e,154112,c[j>>2]|0,0);if(c[o>>2]|0)zb[c[135736>>2]&511](c[o>>2]|0);c[g>>2]=c[m>>2];q=c[g>>2]|0;i=f;return q|0}do if((c[l>>2]|0)!=0&(c[k>>2]|0)!=0)if(c[n>>2]|0){m=my(c[n>>2]|0)|0;j=OH(m,c[o>>2]|0)|0;c[c[k>>2]>>2]=j;break}else{j=OH(0,c[o>>2]|0)|0;c[c[k>>2]>>2]=j;break}else zb[c[135736>>2]&511](c[o>>2]|0);while(0);c[g>>2]=0;q=c[g>>2]|0;i=f;return q|0}function CC(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;k=i;i=i+80|0;l=k+68|0;m=k+64|0;n=k+60|0;o=k+56|0;p=k+52|0;q=k+48|0;r=k+44|0;s=k+40|0;t=k+36|0;u=k+32|0;v=k+28|0;w=k+24|0;x=k+20|0;y=k+16|0;z=k+12|0;A=k+8|0;B=k+4|0;C=k;c[m>>2]=a;c[n>>2]=b;c[o>>2]=d;c[p>>2]=e;c[q>>2]=f;c[r>>2]=g;c[s>>2]=h;c[t>>2]=j;c[v>>2]=0;c[z>>2]=0;if((c[c[o>>2]>>2]|0)==1){c[l>>2]=0;D=c[l>>2]|0;i=k;return D|0}a:do if(c[(c[o>>2]|0)+96>>2]|0){j=c[o>>2]|0;b:do if(c[(c[o>>2]|0)+48>>2]&256){c[w>>2]=TD(j)|0;do if((c[(c[w>>2]|0)+88>>2]|0)==1)E=9;else{if((c[c[w>>2]>>2]|0)==1?(c[(c[w>>2]|0)+88>>2]|0)==46:0){E=9;break}c[A>>2]=3}while(0);if((E|0)==9)c[A>>2]=QD(c[o>>2]|0)|0;if(!(c[r>>2]|0))c[p>>2]=c[p>>2];else c[p>>2]=dI(c[r>>2]|0)|0;c[u>>2]=0;c[x>>2]=c[(c[o>>2]|0)+96>>2];while(1){if(!(c[x>>2]|0))break b;switch(c[c[(c[x>>2]|0)+4>>2]>>2]|0){case 1010:case 1011:case 1009:{c[u>>2]=aI(c[(c[x>>2]|0)+4>>2]|0,c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,z,c[A>>2]|0)|0;E=19;break}case 1007:case 1006:case 1008:break;default:{c[u>>2]=bI(c[(c[x>>2]|0)+4>>2]|0,c[A>>2]|0,c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[A>>2]|0)|0;E=19}}if((E|0)==19){E=0;if((c[u>>2]|0)<0){E=20;break}if((c[u>>2]|0)>0){if(!(c[t>>2]|0)){E=24;break}UD(c[m>>2]|0,c[u>>2]|0,c[n>>2]|0,c[q>>2]|0,c[z>>2]|0,c[o>>2]|0,c[(c[x>>2]|0)+4>>2]|0,0,0,0);if(!(c[v>>2]|0))c[v>>2]=c[u>>2]}c[u>>2]=0}c[x>>2]=c[c[x>>2]>>2]}if((E|0)==20){xB(c[m>>2]|0,156584,156608);c[l>>2]=-1;D=c[l>>2]|0;i=k;return D|0}else if((E|0)==24){c[l>>2]=c[u>>2];D=c[l>>2]|0;i=k;return D|0}}else if(!(c[j+48>>2]&64))break a;while(0);if(c[(c[o>>2]|0)+48>>2]&64){c[u>>2]=0;c[x>>2]=c[(c[o>>2]|0)+96>>2];while(1){if(!(c[x>>2]|0))break a;if(((c[c[(c[x>>2]|0)+4>>2]>>2]|0)+-1009|0)>>>0<3){c[u>>2]=_H(c[(c[x>>2]|0)+4>>2]|0,c[q>>2]|0,c[s>>2]|0,0)|0;if((c[u>>2]|0)<0){E=33;break}if((c[u>>2]|0)>0){if(!(c[t>>2]|0)){E=37;break}UD(c[m>>2]|0,c[u>>2]|0,c[n>>2]|0,c[q>>2]|0,c[s>>2]|0,c[o>>2]|0,c[(c[x>>2]|0)+4>>2]|0,0,0,0);if(!(c[v>>2]|0))c[v>>2]=c[u>>2]}c[u>>2]=0}c[x>>2]=c[c[x>>2]>>2]}if((E|0)==33){xB(c[m>>2]|0,156584,156648);c[l>>2]=-1;D=c[l>>2]|0;i=k;return D|0}else if((E|0)==37){c[l>>2]=c[u>>2];D=c[l>>2]|0;i=k;return D|0}}}while(0);do if((c[v>>2]|0)>=0){c[B>>2]=0;c[u>>2]=0;c[w>>2]=c[o>>2];c:do{c[y>>2]=c[(c[w>>2]|0)+68>>2];while(1){if(!(c[y>>2]|0))break;if((c[c[y>>2]>>2]|0)==1007){c[B>>2]=1;c[u>>2]=VD(c[(c[y>>2]|0)+32>>2]|0,c[r>>2]|0)|0;if((c[u>>2]|0)==1)break;if((c[u>>2]|0)<0){E=48;break c}}c[y>>2]=c[(c[y>>2]|0)+4>>2]}if((c[u>>2]|0)!=0|(c[B>>2]|0)!=0)break;c[w>>2]=c[(c[w>>2]|0)+64>>2];if(!(c[w>>2]|0))break}while((c[c[w>>2]>>2]|0)!=1);if((E|0)==48){xB(c[m>>2]|0,156584,156688);c[l>>2]=-1;D=c[l>>2]|0;i=k;return D|0}if((c[B>>2]|0)!=0&(c[u>>2]|0)==0){c[u>>2]=1840;if(c[t>>2]|0){UD(c[m>>2]|0,c[u>>2]|0,c[n>>2]|0,c[q>>2]|0,0,c[o>>2]|0,0,0,0,0);if(c[v>>2]|0)break;c[v>>2]=c[u>>2];break}else{c[l>>2]=c[u>>2];D=c[l>>2]|0;i=k;return D|0}}}while(0);d:do if((c[v>>2]|0)>=0){c[w>>2]=c[o>>2];c[y>>2]=0;e:while(1){c[C>>2]=0;c[x>>2]=c[(c[w>>2]|0)+96>>2];while(1){if(!(c[x>>2]|0))break;if((c[c[(c[x>>2]|0)+4>>2]>>2]|0)==1006){c[C>>2]=1;c[u>>2]=vz(c[(c[(c[x>>2]|0)+4>>2]|0)+36>>2]|0,c[q>>2]|0)|0;if((c[u>>2]|0)==1)break;if((c[u>>2]|0)<0){E=65;break e}c[y>>2]=c[(c[x>>2]|0)+4>>2]}c[x>>2]=c[c[x>>2]>>2]}if((c[C>>2]|0)!=0&(c[u>>2]|0)!=1)break;c[w>>2]=c[(c[w>>2]|0)+64>>2];if(!(c[w>>2]|0))break d;if((c[c[w>>2]>>2]|0)==1)break d}if((E|0)==65){xB(c[m>>2]|0,156584,156728);c[l>>2]=-1;D=c[l>>2]|0;i=k;return D|0}c[u>>2]=1839;if(c[t>>2]|0){UD(c[m>>2]|0,c[u>>2]|0,c[n>>2]|0,c[q>>2]|0,0,c[o>>2]|0,c[y>>2]|0,0,0,0);if(c[v>>2]|0)break;c[v>>2]=c[u>>2];break}else{c[l>>2]=c[u>>2];D=c[l>>2]|0;i=k;return D|0}}while(0);c[l>>2]=c[v>>2];D=c[l>>2]|0;i=k;return D|0}function DC(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+32|0;j=h+28|0;k=h+24|0;l=h+20|0;m=h+16|0;n=h+12|0;o=h+8|0;p=h+4|0;q=h;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[p>>2]=0;HC(p,c[j>>2]|0,c[l>>2]|0)|0;if((c[o>>2]|0)==0?(WD(c[j>>2]|0,c[l>>2]|0)|0)!=2:0)c[p>>2]=By(c[p>>2]|0,154288)|0;else c[p>>2]=By(c[p>>2]|0,154256)|0;g=(XD(c[n>>2]|0)|0)!=0;f=c[p>>2]|0;if(g)c[p>>2]=By(f,154352)|0;else c[p>>2]=By(f,154336)|0;do if(!(c[(c[n>>2]|0)+48>>2]&256)){if(c[(c[n>>2]|0)+48>>2]&64){c[p>>2]=By(c[p>>2]|0,147936)|0;break}if(c[(c[n>>2]|0)+48>>2]&128)c[p>>2]=By(c[p>>2]|0,147952)|0}else c[p>>2]=By(c[p>>2]|0,147920)|0;while(0);if(XD(c[n>>2]|0)|0){c[q>>2]=0;c[p>>2]=By(c[p>>2]|0,143656)|0;f=c[p>>2]|0;if(c[(c[n>>2]|0)+88>>2]|0){c[p>>2]=By(f,154360)|0;c[p>>2]=By(c[p>>2]|0,c[(c[n>>2]|0)+8>>2]|0)|0}else c[p>>2]=By(f,BB(q,c[(c[n>>2]|0)+112>>2]|0,c[(c[n>>2]|0)+8>>2]|0)|0)|0;c[p>>2]=By(c[p>>2]|0,142568)|0;if(c[q>>2]|0){zb[c[135736>>2]&511](c[q>>2]|0);c[q>>2]=0}}c[p>>2]=By(c[p>>2]|0,142704)|0;if((c[o>>2]|0)==0?(WD(c[j>>2]|0,c[l>>2]|0)|0)!=2:0)PD(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,c[p>>2]|0,0,0);else PD(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,c[p>>2]|0,c[m>>2]|0,0);if(!(c[p>>2]|0)){i=h;return}zb[c[135736>>2]&511](c[p>>2]|0);c[p>>2]=0;i=h;return}function EC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;while(1){if(!(c[e>>2]|0)){f=7;break}if((c[c[e>>2]>>2]|0)!=4){f=7;break}g=c[e>>2]|0;if(c[(c[e>>2]|0)+92>>2]|0){f=5;break}c[e>>2]=c[g+64>>2]}if((f|0)==5){c[d>>2]=c[g+92>>2];h=c[d>>2]|0;i=b;return h|0}else if((f|0)==7){c[d>>2]=0;h=c[d>>2]|0;i=b;return h|0}return 0}function FC(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;do switch(c[c[e>>2]>>2]|0){case 21:case 2:{c[d>>2]=c[(c[e>>2]|0)+12>>2];break}case 15:{c[d>>2]=c[(c[e>>2]|0)+52>>2];break}case 16:{c[d>>2]=c[(c[e>>2]|0)+32>>2];break}case 2e3:{c[d>>2]=c[(c[e>>2]|0)+20>>2];break}case 24:case 23:case 22:{c[d>>2]=c[(c[e>>2]|0)+12>>2];break}case 8:case 7:case 6:{c[d>>2]=c[(c[e>>2]|0)+16>>2];break}case 25:{c[d>>2]=c[(c[e>>2]|0)+24>>2];break}case 26:{c[d>>2]=c[(c[e>>2]|0)+20>>2];break}case 17:{c[d>>2]=c[(c[e>>2]|0)+24>>2];break}case 4:case 5:{c[d>>2]=c[(c[e>>2]|0)+36>>2];break}case 14:{c[d>>2]=c[(c[e>>2]|0)+36>>2];break}default:c[d>>2]=0}while(0);i=b;return c[d>>2]|0}function GC(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;i=i+64|0;g=f+48|0;h=f+44|0;j=f+40|0;k=f+36|0;l=f+32|0;m=f+28|0;n=f+24|0;o=f+20|0;p=f+16|0;q=f+12|0;r=f+8|0;s=f+4|0;t=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=0;c[m>>2]=1;if(c[c[g>>2]>>2]|0){zb[c[135736>>2]&511](c[c[g>>2]>>2]|0);c[c[g>>2]>>2]=0}a:do if(c[h>>2]|0){e=my(c[h>>2]|0)|0;c[c[g>>2]>>2]=e}else{if(!(c[j>>2]|0)){c[m>>2]=0;break}do switch(c[c[j>>2]>>2]|0){case 4:{c[o>>2]=c[j>>2];if(c[(c[o>>2]|0)+48>>2]&8){e=my(142672)|0;c[c[g>>2]>>2]=e}else{e=my(147912)|0;c[c[g>>2]>>2]=e}do if(!(c[(c[o>>2]|0)+48>>2]&256)){if(c[(c[o>>2]|0)+48>>2]&64){e=By(c[c[g>>2]>>2]|0,147936)|0;c[c[g>>2]>>2]=e;break}e=c[c[g>>2]>>2]|0;if(c[(c[o>>2]|0)+48>>2]&128){d=By(e,147952)|0;c[c[g>>2]>>2]=d;break}else{d=By(e,147968)|0;c[c[g>>2]>>2]=d;break}}else{d=By(c[c[g>>2]>>2]|0,147920)|0;c[c[g>>2]>>2]=d}while(0);if(!(c[(c[o>>2]|0)+48>>2]&8))break a;d=By(c[c[g>>2]>>2]|0,143656)|0;c[c[g>>2]>>2]=d;d=By(c[c[g>>2]>>2]|0,c[(c[o>>2]|0)+8>>2]|0)|0;c[c[g>>2]>>2]=d;d=By(c[c[g>>2]>>2]|0,142568)|0;c[c[g>>2]>>2]=d;break a;break}case 15:{c[r>>2]=c[j>>2];d=my(148032)|0;c[c[g>>2]>>2]=d;d=By(c[c[g>>2]>>2]|0,143656)|0;c[c[g>>2]>>2]=d;d=By(c[c[g>>2]>>2]|0,BB(l,c[(c[r>>2]|0)+56>>2]|0,c[(c[r>>2]|0)+8>>2]|0)|0)|0;c[c[g>>2]>>2]=d;if(c[l>>2]|0){zb[c[135736>>2]&511](c[l>>2]|0);c[l>>2]=0}d=By(c[c[g>>2]>>2]|0,142568)|0;c[c[g>>2]>>2]=d;break a;break}case 16:{ZD(c[g>>2]|0,c[j>>2]|0)|0;break a;break}case 5:{c[p>>2]=c[j>>2];if(c[(c[p>>2]|0)+48>>2]&8){d=my(142672)|0;c[c[g>>2]>>2]=d}else{d=my(147912)|0;c[c[g>>2]>>2]=d}d=By(c[c[g>>2]>>2]|0,147984)|0;c[c[g>>2]>>2]=d;if(!(c[(c[p>>2]|0)+48>>2]&8))break a;d=By(c[c[g>>2]>>2]|0,143656)|0;c[c[g>>2]>>2]=d;d=By(c[c[g>>2]>>2]|0,c[(c[p>>2]|0)+8>>2]|0)|0;c[c[g>>2]>>2]=d;d=By(c[c[g>>2]>>2]|0,142568)|0;c[c[g>>2]>>2]=d;break a;break}case 24:case 23:case 22:{do if((c[c[j>>2]>>2]|0)!=22)if((c[c[j>>2]>>2]|0)==23){d=my(148080)|0;c[c[g>>2]>>2]=d;break}else{d=my(148088)|0;c[c[g>>2]>>2]=d;break}else{d=my(148064)|0;c[c[g>>2]>>2]=d}while(0);d=By(c[c[g>>2]>>2]|0,c[(c[j>>2]|0)+16>>2]|0)|0;c[c[g>>2]>>2]=d;d=By(c[c[g>>2]>>2]|0,142568)|0;c[c[g>>2]>>2]=d;break a;break}case 14:{c[s>>2]=c[j>>2];d=my(148048)|0;c[c[g>>2]>>2]=d;d=By(c[c[g>>2]>>2]|0,143656)|0;c[c[g>>2]>>2]=d;d=By(c[c[g>>2]>>2]|0,BB(l,c[(c[s>>2]|0)+52>>2]|0,c[(c[s>>2]|0)+8>>2]|0)|0)|0;c[c[g>>2]>>2]=d;d=By(c[c[g>>2]>>2]|0,142568)|0;c[c[g>>2]>>2]=d;break a;break}case 1:{c[n>>2]=c[j>>2];do if(!(c[(c[n>>2]|0)+48>>2]&256)){if(c[(c[n>>2]|0)+48>>2]&64){d=my(147856)|0;c[c[g>>2]>>2]=d;break}if(c[(c[n>>2]|0)+48>>2]&128){d=my(147872)|0;c[c[g>>2]>>2]=d;break}else{d=my(147888)|0;c[c[g>>2]>>2]=d;break}}else{d=my(147832)|0;c[c[g>>2]>>2]=d}while(0);d=By(c[c[g>>2]>>2]|0,c[(c[n>>2]|0)+8>>2]|0)|0;c[c[g>>2]>>2]=d;d=By(c[c[g>>2]>>2]|0,142568)|0;c[c[g>>2]>>2]=d;break a;break}case 17:{d=my(148128)|0;c[c[g>>2]>>2]=d;d=By(c[c[g>>2]>>2]|0,143656)|0;c[c[g>>2]>>2]=d;d=By(c[c[g>>2]>>2]|0,YD(l,c[j>>2]|0)|0)|0;
c[c[g>>2]>>2]=d;d=By(c[c[g>>2]>>2]|0,142568)|0;c[c[g>>2]>>2]=d;if(!(c[l>>2]|0))break a;zb[c[135736>>2]&511](c[l>>2]|0);c[l>>2]=0;break a;break}case 25:case 8:case 7:case 6:{d=my(MD(c[j>>2]|0)|0)|0;c[c[g>>2]>>2]=d;break a;break}case 21:case 2:{d=my(_D(c[(c[j>>2]|0)+24>>2]|0)|0)|0;c[c[g>>2]>>2]=d;d=By(c[c[g>>2]>>2]|0,148104)|0;c[c[g>>2]>>2]=d;break a;break}case 18:{d=my(MD(c[j>>2]|0)|0)|0;c[c[g>>2]>>2]=d;d=By(c[c[g>>2]>>2]|0,143656)|0;c[c[g>>2]>>2]=d;d=By(c[c[g>>2]>>2]|0,YD(l,c[j>>2]|0)|0)|0;c[c[g>>2]>>2]=d;d=By(c[c[g>>2]>>2]|0,142568)|0;c[c[g>>2]>>2]=d;if(c[l>>2]|0){zb[c[135736>>2]&511](c[l>>2]|0);c[l>>2]=0}break}case 1011:case 1010:case 1009:case 1008:case 1007:case 1006:case 1005:case 1004:case 1003:case 1002:case 1001:case 1e3:{d=my(148120)|0;c[c[g>>2]>>2]=d;d=By(c[c[g>>2]>>2]|0,zB(c[c[j>>2]>>2]|0)|0)|0;c[c[g>>2]>>2]=d;d=By(c[c[g>>2]>>2]|0,142568)|0;c[c[g>>2]>>2]=d;break a;break}case 26:{c[q>>2]=c[j>>2];d=my(148e3)|0;c[c[g>>2]>>2]=d;d=c[c[g>>2]>>2]|0;if(!(c[(c[q>>2]|0)+12>>2]|0)){e=By(d,148016)|0;c[c[g>>2]>>2]=e;break a}e=By(d,142568)|0;c[c[g>>2]>>2]=e;e=By(c[c[g>>2]>>2]|0,YD(l,c[(c[q>>2]|0)+12>>2]|0)|0)|0;c[c[g>>2]>>2]=e;if(c[l>>2]|0){zb[c[135736>>2]&511](c[l>>2]|0);c[l>>2]=0}e=By(c[c[g>>2]>>2]|0,142568)|0;c[c[g>>2]>>2]=e;break a;break}default:{}}while(0);c[m>>2]=0}while(0);if((c[m>>2]|0)==0&(c[k>>2]|0)!=0){m=c[k>>2]|0;if((c[(c[k>>2]|0)+4>>2]|0)==2)c[t>>2]=c[m+20>>2];else c[t>>2]=m;m=my(144464)|0;c[c[g>>2]>>2]=m;m=c[c[g>>2]>>2]|0;q=c[t>>2]|0;if(c[(c[t>>2]|0)+36>>2]|0){j=By(m,BB(l,c[(c[q+36>>2]|0)+8>>2]|0,c[(c[t>>2]|0)+8>>2]|0)|0)|0;c[c[g>>2]>>2]=j;if(c[l>>2]|0){zb[c[135736>>2]&511](c[l>>2]|0);c[l>>2]=0}}else{j=By(m,c[q+8>>2]|0)|0;c[c[g>>2]>>2]=j}j=By(c[c[g>>2]>>2]|0,142568)|0;c[c[g>>2]>>2]=j}if((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+4>>2]|0)==2:0){j=By(c[c[g>>2]>>2]|0,148152)|0;c[c[g>>2]>>2]=j;j=c[c[g>>2]>>2]|0;q=c[k>>2]|0;if(c[(c[k>>2]|0)+36>>2]|0){m=By(j,BB(l,c[(c[q+36>>2]|0)+8>>2]|0,c[(c[k>>2]|0)+8>>2]|0)|0)|0;c[c[g>>2]>>2]=m;if(c[l>>2]|0){zb[c[135736>>2]&511](c[l>>2]|0);c[l>>2]=0}}else{m=By(j,c[q+8>>2]|0)|0;c[c[g>>2]>>2]=m}m=By(c[c[g>>2]>>2]|0,142568)|0;c[c[g>>2]>>2]=m}if(!(c[l>>2]|0)){u=c[g>>2]|0;v=c[u>>2]|0;i=f;return v|0}zb[c[135736>>2]&511](c[l>>2]|0);c[l>>2]=0;u=c[g>>2]|0;v=c[u>>2]|0;i=f;return v|0}function HC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+48|0;f=e;g=e+36|0;h=e+32|0;j=e+28|0;k=e+24|0;l=e+20|0;m=e+16|0;n=e+12|0;o=e+8|0;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=0;c[c[h>>2]>>2]=0;if(((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+4>>2]|0)!=1:0)?(c[(c[k>>2]|0)+4>>2]|0)!=2:0){d=my(142672)|0;c[c[h>>2]>>2]=d;c[g>>2]=c[c[h>>2]>>2];p=c[g>>2]|0;i=e;return p|0}do if(c[k>>2]|0){if((c[(c[k>>2]|0)+4>>2]|0)==2){c[m>>2]=c[(c[k>>2]|0)+20>>2];d=my(144464)|0;c[c[h>>2]>>2]=d;d=c[c[h>>2]>>2]|0;b=c[m>>2]|0;if(c[(c[m>>2]|0)+36>>2]|0){a=By(d,BB(l,c[(c[b+36>>2]|0)+8>>2]|0,c[(c[m>>2]|0)+8>>2]|0)|0)|0;c[c[h>>2]>>2]=a}else{a=By(d,BB(l,0,c[b+8>>2]|0)|0)|0;c[c[h>>2]>>2]=a}if(c[l>>2]|0){zb[c[135736>>2]&511](c[l>>2]|0);c[l>>2]=0}a=By(c[c[h>>2]>>2]|0,142656)|0;c[c[h>>2]>>2]=a;a=By(c[c[h>>2]>>2]|0,144480)|0;c[c[h>>2]>>2]=a}else{a=my(144464)|0;c[c[h>>2]>>2]=a}a=c[c[h>>2]>>2]|0;b=c[k>>2]|0;if(c[(c[k>>2]|0)+36>>2]|0){d=By(a,BB(l,c[(c[b+36>>2]|0)+8>>2]|0,c[(c[k>>2]|0)+8>>2]|0)|0)|0;c[c[h>>2]>>2]=d}else{d=By(a,BB(l,0,c[b+8>>2]|0)|0)|0;c[c[h>>2]>>2]=d}if(c[l>>2]|0){zb[c[135736>>2]&511](c[l>>2]|0);c[l>>2]=0}d=By(c[c[h>>2]>>2]|0,144496)|0;c[c[h>>2]>>2]=d}else{d=c[j>>2]|0;if((c[c[j>>2]>>2]|0)!=2){if((c[d>>2]|0)==1){b=my(142672)|0;c[c[h>>2]>>2]=b;break}b=c[33976]|0;a=c[33980]|0;c[f>>2]=140328;c[f+4>>2]=2246;Db[b&511](a,140296,f);c[g>>2]=0;p=c[g>>2]|0;i=e;return p|0}c[n>>2]=d;if((c[c[(c[n>>2]|0)+108>>2]>>2]|0)==2){c[o>>2]=c[(c[(c[n>>2]|0)+100>>2]|0)+(c[(c[n>>2]|0)+96>>2]<<2)>>2];d=my(144464)|0;c[c[h>>2]>>2]=d;d=c[c[h>>2]>>2]|0;a=By(d,BB(l,c[(c[o>>2]|0)+16>>2]|0,c[(c[o>>2]|0)+12>>2]|0)|0)|0;c[c[h>>2]>>2]=a;if(c[l>>2]|0){zb[c[135736>>2]&511](c[l>>2]|0);c[l>>2]=0}a=By(c[c[h>>2]>>2]|0,142656)|0;c[c[h>>2]>>2]=a;a=By(c[c[h>>2]>>2]|0,144480)|0;c[c[h>>2]>>2]=a}else{a=my(144464)|0;c[c[h>>2]>>2]=a}a=c[c[h>>2]>>2]|0;d=By(a,BB(l,c[(c[(c[n>>2]|0)+108>>2]|0)+16>>2]|0,c[(c[(c[n>>2]|0)+108>>2]|0)+12>>2]|0)|0)|0;c[c[h>>2]>>2]=d;if(c[l>>2]|0){zb[c[135736>>2]&511](c[l>>2]|0);c[l>>2]=0}d=By(c[c[h>>2]>>2]|0,144496)|0;c[c[h>>2]>>2]=d}while(0);c[g>>2]=c[c[h>>2]>>2];p=c[g>>2]|0;i=e;return p|0}function IC(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=i;i=i+32|0;l=k+28|0;m=k+24|0;n=k+20|0;o=k+16|0;p=k+12|0;q=k+8|0;r=k+4|0;s=k;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;c[r>>2]=h;c[s>>2]=j;$D(c[l>>2]|0,2,c[m>>2]|0,c[n>>2]|0,0,c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0);i=k;return}function JC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;c[j>>2]=c[(c[(c[f>>2]|0)+28>>2]|0)+12>>2];if(!(c[(c[j>>2]|0)+4>>2]|0)){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[(c[j>>2]|0)+4>>2]|0)){m=8;break}c[h>>2]=c[(c[c[j>>2]>>2]|0)+(c[k>>2]<<2)>>2];if((c[(c[h>>2]|0)+8>>2]|0)==(c[g>>2]|0)){m=6;break}c[k>>2]=(c[k>>2]|0)+1}if((m|0)==6){c[e>>2]=c[h>>2];l=c[e>>2]|0;i=d;return l|0}else if((m|0)==8){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}return 0}function KC(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=Cb[c[135744>>2]&511](16)|0;if(!(c[d>>2]|0)){tC(0,170048,0);c[b>>2]=0;e=c[b>>2]|0;i=a;return e|0}else{f=c[d>>2]|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[b>>2]=c[d>>2];e=c[b>>2]|0;i=a;return e|0}return 0}function LC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=c[(c[e>>2]|0)+24>>2];if(!(c[g>>2]|0)){c[(c[e>>2]|0)+24>>2]=c[f>>2];i=d;return}while(1){if(!(c[c[g>>2]>>2]|0))break;c[g>>2]=c[c[g>>2]>>2]}c[c[g>>2]>>2]=c[f>>2];i=d;return}function MC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[l>>2]=c[(c[(c[g>>2]|0)+28>>2]|0)+12>>2];if(!(c[(c[l>>2]|0)+4>>2]|0)){c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[(c[l>>2]|0)+4>>2]|0)){o=14;break}c[k>>2]=c[(c[c[l>>2]>>2]|0)+(c[m>>2]<<2)>>2];if(!((c[(c[k>>2]|0)+20>>2]|0)==0?(c[(c[k>>2]|0)+8>>2]|0)!=0:0))o=7;if((o|0)==7?(o=0,(c[(c[k>>2]|0)+12>>2]|0)==(c[h>>2]|0)):0){if((c[j>>2]|0)!=0?(c[(c[k>>2]|0)+36>>2]|0)!=0:0){o=12;break}if((c[j>>2]|0)==0?(c[(c[k>>2]|0)+36>>2]|0)==0:0){o=12;break}}c[m>>2]=(c[m>>2]|0)+1}if((o|0)==12){c[f>>2]=c[k>>2];n=c[f>>2]|0;i=e;return n|0}else if((o|0)==14){c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}return 0}function NC(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=i;i=i+48|0;l=k+32|0;m=k+28|0;n=k+24|0;o=k+16|0;p=k+12|0;q=k+8|0;r=k+4|0;s=k;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[k+20>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=h;c[r>>2]=j;c[s>>2]=0;HC(s,c[l>>2]|0,c[n>>2]|0)|0;c[s>>2]=By(c[s>>2]|0,c[o>>2]|0)|0;c[s>>2]=By(c[s>>2]|0,142704)|0;$D(c[l>>2]|0,1,c[m>>2]|0,c[n>>2]|0,0,c[s>>2]|0,c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,0);if(!(c[s>>2]|0)){i=k;return}zb[c[135736>>2]&511](c[s>>2]|0);c[s>>2]=0;i=k;return}function OC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[l>>2]=c[(c[(c[g>>2]|0)+28>>2]|0)+12>>2];if(!(c[(c[l>>2]|0)+4>>2]|0)){c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[(c[l>>2]|0)+4>>2]|0)){o=10;break}c[k>>2]=c[(c[c[l>>2]>>2]|0)+(c[m>>2]<<2)>>2];if(((c[(c[k>>2]|0)+12>>2]|0)==0?(c[(c[k>>2]|0)+8>>2]|0)==(c[h>>2]|0):0)?(c[(c[k>>2]|0)+16>>2]|0)==(c[j>>2]|0):0){o=8;break}c[m>>2]=(c[m>>2]|0)+1}if((o|0)==8){c[f>>2]=c[k>>2];n=c[f>>2]|0;i=e;return n|0}else if((o|0)==10){c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}return 0}function PC(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+48|0;j=h;k=h+40|0;l=h+36|0;m=h+32|0;n=h+28|0;o=h+24|0;p=h+20|0;q=h+16|0;r=h+12|0;s=h+8|0;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=0;c[r>>2]=0;c[s>>2]=0;if(c[k>>2]|0){g=(c[k>>2]|0)+20|0;c[g>>2]=(c[g>>2]|0)+1;c[(c[k>>2]|0)+16>>2]=c[m>>2];c[q>>2]=c[(c[k>>2]|0)+8>>2];c[s>>2]=c[(c[k>>2]|0)+4>>2];c[r>>2]=c[(c[k>>2]|0)+24>>2]}g=c[r>>2]|0;r=c[q>>2]|0;q=c[s>>2]|0;s=c[k>>2]|0;k=c[l>>2]|0;l=c[m>>2]|0;m=c[o>>2]|0;f=c[p>>2]|0;e=c[n>>2]|0;n=c[p>>2]|0;c[j>>2]=c[o>>2];c[j+4>>2]=n;Xd(g,r,q,s,k,16,l,2,0,0,m,f,0,0,0,e,j);i=h;return}function QC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;if((c[e>>2]|0)==0|(c[f>>2]|0)==0){i=d;return}c[g>>2]=0;c[h>>2]=c[f>>2];a:while(1){j=(c[g>>2]|0)!=0;if(!(c[h>>2]|0))break;if(j){Qh(c[g>>2]|0);Rh(c[g>>2]|0);c[g>>2]=0}e=c[(c[h>>2]|0)+4>>2]|0;if((c[(c[h>>2]|0)+4>>2]|0)==3)if(((e|0)==3?(aE(c[(c[h>>2]|0)+40>>2]|0,-1)|0)!=0:0)?(Vi(c[h>>2]|0)|0)!=1:0){c[g>>2]=c[h>>2];k=14}else k=14;else if((e|0)!=1?(c[(c[h>>2]|0)+4>>2]|0)!=4:0)c[g>>2]=c[h>>2];else k=14;if(((((k|0)==14?(k=0,(c[(c[h>>2]|0)+12>>2]|0)!=0):0)?(c[(c[(c[h>>2]|0)+12>>2]|0)+4>>2]|0)!=17:0)?(c[(c[(c[h>>2]|0)+12>>2]|0)+4>>2]|0)!=5:0)?(c[(c[(c[h>>2]|0)+12>>2]|0)+4>>2]|0)!=6:0){c[h>>2]=c[(c[h>>2]|0)+12>>2];continue}if(c[(c[h>>2]|0)+24>>2]|0){c[h>>2]=c[(c[h>>2]|0)+24>>2];continue}while(1){c[h>>2]=c[(c[h>>2]|0)+20>>2];if(!(c[h>>2]|0))continue a;if((c[h>>2]|0)==(c[f>>2]|0)){k=23;break}l=c[h>>2]|0;if(c[(c[h>>2]|0)+24>>2]|0){k=25;break}if(!l)continue a}if((k|0)==23){k=0;c[h>>2]=0;continue}else if((k|0)==25){k=0;c[h>>2]=c[l+24>>2];continue}}if(!j){i=d;return}Qh(c[g>>2]|0);Rh(c[g>>2]|0);c[g>>2]=0;i=d;return}function RC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=ej(c[h>>2]|0,c[j>>2]|0)|0;if(!(c[k>>2]|0)){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}else{c[l>>2]=AP(c[(c[g>>2]|0)+80>>2]|0,c[k>>2]|0,-1)|0;zb[c[135736>>2]&511](c[k>>2]|0);c[f>>2]=c[l>>2];m=c[f>>2]|0;i=e;return m|0}return 0}function SC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;n=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;d=c[g>>2]|0;if(!(c[c[(c[g>>2]|0)+28>>2]>>2]|0)){xB(d,169824,169848);c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}c[m>>2]=c[c[d+28>>2]>>2];c[l>>2]=56;c[k>>2]=Cb[c[135744>>2]&511](c[l>>2]|0)|0;if(!(c[k>>2]|0)){tC(0,169880,0);c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}cU(c[k>>2]|0,0,c[l>>2]|0)|0;c[(c[k>>2]|0)+16>>2]=c[j>>2];c[c[k>>2]>>2]=c[h>>2];l=JB()|0;c[(c[k>>2]|0)+44>>2]=l;if(!(c[(c[k>>2]|0)+44>>2]|0)){zb[c[135736>>2]&511](c[k>>2]|0);c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}l=JB()|0;c[(c[k>>2]|0)+48>>2]=l;if(!(c[(c[k>>2]|0)+48>>2]|0)){zb[c[135736>>2]&511](c[k>>2]|0);c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}do if((c[(c[(c[g>>2]|0)+28>>2]|0)+12>>2]|0)!=0?(c[(c[(c[(c[g>>2]|0)+28>>2]|0)+12>>2]|0)+4>>2]|0)>0:0){if(!(c[h>>2]|0)){xB(c[g>>2]|0,169824,169960);qB(c[k>>2]|0);c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}if((c[h>>2]|0)==1){l=DB(c[g>>2]|0)|0;c[(c[k>>2]|0)+52>>2]=l;if(c[(c[k>>2]|0)+52>>2]|0){c[(c[(c[k>>2]|0)+52>>2]|0)+4>>2]=c[j>>2];break}qB(c[k>>2]|0);c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}}else p=11;while(0);do if((p|0)==11){if(!((c[h>>2]|0)==2|(c[h>>2]|0)==3)){c[c[k>>2]>>2]=0;c[(c[(c[g>>2]|0)+28>>2]|0)+4>>2]=c[k>>2];c[(c[k>>2]|0)+52>>2]=c[m>>2];c[(c[m>>2]|0)+4>>2]=c[j>>2];break}xB(c[g>>2]|0,169824,169912);qB(c[k>>2]|0);c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}while(0);if((c[h>>2]|0)==0|(c[h>>2]|0)==1){if((c[(c[m>>2]|0)+48>>2]|0)==0?(h=Jj(5,c[(c[(c[g>>2]|0)+28>>2]|0)+8>>2]|0)|0,c[(c[m>>2]|0)+48>>2]=h,(c[(c[m>>2]|0)+48>>2]|0)==0):0){qB(c[k>>2]|0);c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}h=c[(c[m>>2]|0)+48>>2]|0;if(!(c[j>>2]|0))c[n>>2]=Lj(h,145792,c[k>>2]|0)|0;else c[n>>2]=Lj(h,c[j>>2]|0,c[k>>2]|0)|0;if(c[n>>2]|0){xB(c[g>>2]|0,169824,17e4);qB(c[k>>2]|0);c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}}else{if((c[c[(c[(c[g>>2]|0)+28>>2]|0)+16>>2]>>2]|0)!=0?(c[c[(c[(c[g>>2]|0)+28>>2]|0)+16>>2]>>2]|0)!=1:0)c[(c[k>>2]|0)+52>>2]=c[(c[(c[(c[g>>2]|0)+28>>2]|0)+16>>2]|0)+52>>2];else c[(c[k>>2]|0)+52>>2]=c[(c[(c[g>>2]|0)+28>>2]|0)+16>>2];if((c[(c[m>>2]|0)+64>>2]|0)==0?(n=JB()|0,c[(c[m>>2]|0)+64>>2]=n,(c[(c[m>>2]|0)+64>>2]|0)==0):0){qB(c[k>>2]|0);c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}bE(c[(c[m>>2]|0)+64>>2]|0,c[k>>2]|0)|0}if((bE(c[(c[(c[g>>2]|0)+28>>2]|0)+12>>2]|0,c[k>>2]|0)|0)==-1){c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}else{c[f>>2]=c[k>>2];o=c[f>>2]|0;i=e;return o|0}return 0}function TC(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(c[(c[d>>2]|0)+24>>2]&1){a=(c[d>>2]|0)+24|0;c[a>>2]=c[a>>2]^1}if(c[(c[d>>2]|0)+24>>2]&2){a=(c[d>>2]|0)+24|0;c[a>>2]=c[a>>2]^2}if(c[(c[d>>2]|0)+24>>2]&4){a=(c[d>>2]|0)+24|0;c[a>>2]=c[a>>2]^4}if(c[(c[d>>2]|0)+24>>2]&8){a=(c[d>>2]|0)+24|0;c[a>>2]=c[a>>2]^8}if(c[(c[d>>2]|0)+24>>2]&16){a=(c[d>>2]|0)+24|0;c[a>>2]=c[a>>2]^16}if(c[(c[d>>2]|0)+24>>2]&32){a=(c[d>>2]|0)+24|0;c[a>>2]=c[a>>2]^32}if(c[(c[d>>2]|0)+24>>2]&64){a=(c[d>>2]|0)+24|0;c[a>>2]=c[a>>2]^64}if(c[(c[d>>2]|0)+24>>2]&128){a=(c[d>>2]|0)+24|0;c[a>>2]=c[a>>2]^128}if(!(c[(c[d>>2]|0)+24>>2]&256)){i=b;return}a=(c[d>>2]|0)+24|0;c[a>>2]=c[a>>2]^256;i=b;return}function UC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;n=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[m>>2]=0;c[n>>2]=c[(c[g>>2]|0)+20>>2];c[m>>2]=cE(c[g>>2]|0,c[j>>2]|0,161384)|0;do if((c[m>>2]|0)!=-1){c[k>>2]=dE(c[j>>2]|0,168888)|0;if(c[k>>2]|0){d=c[g>>2]|0;b=c[k>>2]|0;c[m>>2]=eE(d,0,b,IH(29)|0,0)|0;if((c[m>>2]|0)==-1)break;if(c[m>>2]|0)c[(c[g>>2]|0)+108>>2]=3037;else o=6}else o=6;if((o|0)==6){c[k>>2]=dE(c[j>>2]|0,168904)|0;if(c[k>>2]|0){c[l>>2]=fE(c[g>>2]|0,c[k>>2]|0)|0;c[m>>2]=gE(c[l>>2]|0,(c[h>>2]|0)+24|0,1)|0;if((c[m>>2]|0)==-1)break;if(c[m>>2]|0)hE(c[g>>2]|0,1705,0,c[k>>2]|0,0,163568,c[l>>2]|0,0,0,0)}c[k>>2]=dE(c[j>>2]|0,168928)|0;if(c[k>>2]|0){c[l>>2]=fE(c[g>>2]|0,c[k>>2]|0)|0;c[m>>2]=gE(c[l>>2]|0,(c[h>>2]|0)+24|0,2)|0;if((c[m>>2]|0)==-1)break;if(c[m>>2]|0)hE(c[g>>2]|0,1701,0,c[k>>2]|0,0,163568,c[l>>2]|0,0,0,0)}c[k>>2]=dE(c[j>>2]|0,168952)|0;if(c[k>>2]|0){c[l>>2]=fE(c[g>>2]|0,c[k>>2]|0)|0;c[m>>2]=iE(c[l>>2]|0,(c[h>>2]|0)+24|0,-1,4,8,-1,16,32)|0;if((c[m>>2]|0)==-1)break;if(c[m>>2]|0)hE(c[g>>2]|0,3037,0,c[k>>2]|0,0,168968,c[l>>2]|0,0,0,0)}c[k>>2]=dE(c[j>>2]|0,169032)|0;if(c[k>>2]|0){c[l>>2]=fE(c[g>>2]|0,c[k>>2]|0)|0;c[m>>2]=iE(c[l>>2]|0,(c[h>>2]|0)+24|0,-1,64,128,256,-1,-1)|0;if((c[m>>2]|0)==-1)break;if(c[m>>2]|0)hE(c[g>>2]|0,3037,0,c[k>>2]|0,0,164576,c[l>>2]|0,0,0,0)}}if((c[n>>2]|0)!=(c[(c[g>>2]|0)+20>>2]|0))c[m>>2]=c[(c[g>>2]|0)+16>>2];c[f>>2]=c[m>>2];p=c[f>>2]|0;i=e;return p|0}while(0);c[f>>2]=-1;p=c[f>>2]|0;i=e;return p|0}function VC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+48|0;f=e+32|0;g=e+28|0;h=e+24|0;j=e+20|0;k=e+16|0;l=e+12|0;m=e+8|0;n=e+4|0;o=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[m>>2]=0;if((c[g>>2]|0)==0|(c[h>>2]|0)==0|(c[j>>2]|0)==0){c[f>>2]=-1;p=c[f>>2]|0;i=e;return p|0}c[n>>2]=c[(c[g>>2]|0)+20>>2];c[k>>2]=c[j>>2];a:while(1){if(!((((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[k>>2]|0)+8>>2]|0,160960)|0)!=0:0)?(qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0))q=8;do if((q|0)==8){q=0;if((((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[k>>2]|0)+8>>2]|0,160968)|0)!=0:0)?(qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0)break;if((((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[k>>2]|0)+8>>2]|0,160976)|0)!=0:0)?(qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0)break;if(!(c[k>>2]|0)){q=49;break a}if(!(c[(c[k>>2]|0)+36>>2]|0)){q=49;break a}if(!(qy(c[(c[k>>2]|0)+8>>2]|0,160992)|0)){q=49;break a}if(!(qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)){q=49;break a}}while(0);do if((((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[k>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){c[l>>2]=jE(c[g>>2]|0,c[k>>2]|0,1)|0;j=c[l>>2]|0;if(!(c[(c[h>>2]|0)+20>>2]|0)){c[(c[h>>2]|0)+20>>2]=j;break}else{mB(j);break}}else q=27;while(0);do if((q|0)==27){q=0;if((((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[k>>2]|0)+8>>2]|0,160968)|0)!=0:0)?(qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){c[o>>2]=c[(c[g>>2]|0)+20>>2];c[m>>2]=kE(c[g>>2]|0,c[h>>2]|0,c[k>>2]|0)|0;if((c[m>>2]|0)==-1){q=97;break a}if(c[(c[g>>2]|0)+108>>2]|0)break a;if((c[o>>2]|0)!=(c[(c[g>>2]|0)+20>>2]|0))break a;else break}if((((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[k>>2]|0)+8>>2]|0,160960)|0)!=0:0)?(qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){c[o>>2]=c[(c[g>>2]|0)+20>>2];c[m>>2]=lE(c[g>>2]|0,c[h>>2]|0,c[k>>2]|0)|0;if((c[m>>2]|0)==-1){q=97;break a}if(c[(c[g>>2]|0)+108>>2]|0)break a;if((c[o>>2]|0)!=(c[(c[g>>2]|0)+20>>2]|0))break a;else break}if((((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[k>>2]|0)+8>>2]|0,160976)|0)!=0:0)?(qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){c[o>>2]=c[(c[g>>2]|0)+20>>2];c[m>>2]=mE(c[g>>2]|0,c[h>>2]|0,c[k>>2]|0)|0;if((c[m>>2]|0)==-1){q=97;break a}if(c[(c[g>>2]|0)+108>>2]|0)break a;if((c[o>>2]|0)!=(c[(c[g>>2]|0)+20>>2]|0))break a}}while(0);c[k>>2]=c[(c[k>>2]|0)+24>>2]}if((q|0)==97){c[f>>2]=-1;p=c[f>>2]|0;i=e;return p|0}b:do if((q|0)==49)c:while(1){q=0;if(!(c[k>>2]|0))break b;if((((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[k>>2]|0)+8>>2]|0,161008)|0)!=0:0)?(qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){nE(c[g>>2]|0,c[h>>2]|0,c[k>>2]|0,1)|0;c[k>>2]=c[(c[k>>2]|0)+24>>2]}else q=55;do if((q|0)==55){q=0;if((((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[k>>2]|0)+8>>2]|0,161024)|0)!=0:0)?(qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){oE(c[g>>2]|0,c[h>>2]|0,c[k>>2]|0,1)|0;c[k>>2]=c[(c[k>>2]|0)+24>>2];break}if((((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[k>>2]|0)+8>>2]|0,161040)|0)!=0:0)?(qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){pE(c[g>>2]|0,c[h>>2]|0,c[k>>2]|0,0,1)|0;c[k>>2]=c[(c[k>>2]|0)+24>>2];break}if((((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[k>>2]|0)+8>>2]|0,161048)|0)!=0:0)?(qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){qE(c[g>>2]|0,c[h>>2]|0,c[k>>2]|0)|0;c[k>>2]=c[(c[k>>2]|0)+24>>2];break}if((((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[k>>2]|0)+8>>2]|0,161064)|0)!=0:0)?(qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){rE(c[g>>2]|0,c[h>>2]|0,c[k>>2]|0)|0;c[k>>2]=c[(c[k>>2]|0)+24>>2];break}if((((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[k>>2]|0)+8>>2]|0,161080)|0)!=0:0)?(qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){sE(c[g>>2]|0,c[h>>2]|0,c[k>>2]|0)|0;c[k>>2]=c[(c[k>>2]|0)+24>>2];break}if((((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[k>>2]|0)+8>>2]|0,161088)|0)!=0:0)?(qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){tE(c[g>>2]|0,c[h>>2]|0,c[k>>2]|0)|0;c[k>>2]=c[(c[k>>2]|0)+24>>2];break}uE(c[g>>2]|0,3033,0,c[(c[k>>2]|0)+20>>2]|0,c[k>>2]|0,0,161104);c[k>>2]=c[(c[k>>2]|0)+24>>2]}while(0);while(1){if(!(c[k>>2]|0)){q=49;continue c}if(!(c[(c[k>>2]|0)+36>>2]|0)){q=49;continue c}if(!(qy(c[(c[k>>2]|0)+8>>2]|0,160992)|0)){q=49;continue c}if(!(qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)){q=49;continue c}c[l>>2]=jE(c[g>>2]|0,c[k>>2]|0,1)|0;o=c[l>>2]|0;if(!(c[(c[h>>2]|0)+20>>2]|0))c[(c[h>>2]|0)+20>>2]=o;else mB(o);c[k>>2]=c[(c[k>>2]|0)+24>>2]}}while(0);c[(c[g>>2]|0)+84>>2]=0;if((c[n>>2]|0)!=(c[(c[g>>2]|0)+20>>2]|0))c[m>>2]=c[(c[g>>2]|0)+16>>2];c[f>>2]=c[m>>2];p=c[f>>2]|0;i=e;return p|0}function WC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+48|0;d=b+40|0;e=b+36|0;f=b+32|0;g=b+28|0;h=b+24|0;j=b+20|0;k=b+16|0;l=b+12|0;m=b+8|0;n=b+4|0;o=b;c[e>>2]=a;c[f>>2]=0;c[g>>2]=c[(c[(c[e>>2]|0)+28>>2]|0)+28>>2];if(!(c[g>>2]|0)){c[d>>2]=0;p=c[d>>2]|0;i=b;return p|0}a:while(1){c[j>>2]=c[(c[g>>2]|0)+4>>2];c[h>>2]=vE(c[(c[g>>2]|0)+24>>2]|0,c[c[j>>2]>>2]|0,c[(c[g>>2]|0)+16>>2]|0,c[(c[g>>2]|0)+20>>2]|0)|0;do if(!(c[h>>2]|0)){c[l>>2]=0;if(c[(c[g>>2]|0)+8>>2]|0)c[m>>2]=FC(c[(c[g>>2]|0)+8>>2]|0)|0;else c[m>>2]=FC(c[j>>2]|0)|0;a=c[e>>2]|0;q=c[m>>2]|0;r=MD(c[j>>2]|0)|0;AB(a,3081,q,0,160712,r,BB(l,c[(c[g>>2]|0)+20>>2]|0,c[(c[g>>2]|0)+16>>2]|0)|0);if(c[l>>2]|0){zb[c[135736>>2]&511](c[l>>2]|0);c[l>>2]=0}c[f>>2]=c[(c[e>>2]|0)+16>>2];c[g>>2]=c[c[g>>2]>>2]}else{c[k>>2]=0;r=c[c[j>>2]>>2]|0;do if((r|0)==4|(r|0)==5)if(c[(c[h>>2]|0)+48>>2]&1073741824){c[k>>2]=1;break}else{q=(c[h>>2]|0)+48|0;c[q>>2]=c[q>>2]|1073741824;c[(c[j>>2]|0)+64>>2]=c[h>>2];break}else if((r|0)==17){if(c[(c[h>>2]|0)+28>>2]&2){c[k>>2]=1;break}q=(c[h>>2]|0)+28|0;c[q>>2]=c[q>>2]|2;if(c[(c[g>>2]|0)+8>>2]|0)c[(c[(c[g>>2]|0)+8>>2]|0)+12>>2]=c[h>>2];c[(c[g>>2]|0)+12>>2]=c[h>>2]}else if((r|0)==16){if(c[(c[h>>2]|0)+36>>2]&8){c[k>>2]=1;break}q=(c[h>>2]|0)+36|0;c[q>>2]=c[q>>2]|8;q=c[h>>2]|0;a=c[g>>2]|0;if(c[(c[g>>2]|0)+8>>2]|0){c[(c[a+8>>2]|0)+4>>2]=q;c[(c[g>>2]|0)+12>>2]=0;break}else{c[a+12>>2]=q;break}}else{s=24;break a}while(0);if(!(c[k>>2]|0)){c[g>>2]=c[c[g>>2]>>2];break}c[n>>2]=0;r=c[g>>2]|0;if(c[(c[g>>2]|0)+8>>2]|0)c[o>>2]=FC(c[r+8>>2]|0)|0;else c[o>>2]=FC(c[r+4>>2]|0)|0;r=c[e>>2]|0;q=c[o>>2]|0;AB(r,3081,q,0,160856,ZD(n,c[h>>2]|0)|0,0);if(c[n>>2]|0){zb[c[135736>>2]&511](c[n>>2]|0);c[n>>2]=0}c[f>>2]=c[(c[e>>2]|0)+16>>2];c[g>>2]=c[c[g>>2]>>2]}while(0);if(!(c[g>>2]|0)){s=34;break}}if((s|0)==24){xB(c[e>>2]|0,160784,160816);c[d>>2]=-1;p=c[d>>2]|0;i=b;return p|0}else if((s|0)==34){c[d>>2]=c[f>>2];p=c[d>>2]|0;i=b;return p|0}return 0}function XC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+48|0;e=d+36|0;f=d+32|0;g=d+28|0;h=d+24|0;j=d+20|0;k=d+16|0;l=d+12|0;m=d+8|0;n=d+4|0;o=d;c[f>>2]=a;c[g>>2]=b;if(!(c[g>>2]|0)){c[e>>2]=-1;p=c[e>>2]|0;i=d;return p|0}if(c[(c[g>>2]|0)+4>>2]&2){c[e>>2]=0;p=c[e>>2]|0;i=d;return p|0}b=(c[g>>2]|0)+4|0;c[b>>2]=c[b>>2]|2;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[(c[(c[g>>2]|0)+44>>2]|0)+4>>2]|0))break;c[h>>2]=c[(c[c[(c[g>>2]|0)+44>>2]>>2]|0)+(c[m>>2]<<2)>>2];c[k>>2]=0;a:do switch(c[c[h>>2]>>2]|0){case 4:case 5:{if(!(c[(c[h>>2]|0)+48>>2]&1073741824)){c[l>>2]=c[(c[h>>2]|0)+8>>2];if((c[c[g>>2]>>2]|0)!=0?(c[c[g>>2]>>2]|0)!=1:0){c[k>>2]=(c[(c[(c[g>>2]|0)+52>>2]|0)+52>>2]|0)+28;q=40;break a}c[k>>2]=(c[(c[g>>2]|0)+52>>2]|0)+28;q=40}break}case 18:{c[l>>2]=c[(c[h>>2]|0)+4>>2];if((c[c[g>>2]>>2]|0)!=0?(c[c[g>>2]>>2]|0)!=1:0){c[k>>2]=(c[(c[(c[g>>2]|0)+52>>2]|0)+52>>2]|0)+44;q=40;break a}c[k>>2]=(c[(c[g>>2]|0)+52>>2]|0)+44;q=40;break}case 14:{c[l>>2]=c[(c[h>>2]|0)+8>>2];if((c[c[g>>2]>>2]|0)!=0?(c[c[g>>2]>>2]|0)!=1:0){c[k>>2]=(c[(c[(c[g>>2]|0)+52>>2]|0)+52>>2]|0)+40;q=40;break a}c[k>>2]=(c[(c[g>>2]|0)+52>>2]|0)+40;q=40;break}case 16:{if(!(c[(c[h>>2]|0)+36>>2]&8)){c[l>>2]=c[(c[h>>2]|0)+8>>2];if((c[c[g>>2]>>2]|0)!=0?(c[c[g>>2]>>2]|0)!=1:0){c[k>>2]=(c[(c[(c[g>>2]|0)+52>>2]|0)+52>>2]|0)+36;q=40;break a}c[k>>2]=(c[(c[g>>2]|0)+52>>2]|0)+36;q=40}break}case 24:case 22:case 23:{c[l>>2]=c[(c[h>>2]|0)+16>>2];if((c[c[g>>2]>>2]|0)!=0?(c[c[g>>2]>>2]|0)!=1:0){c[k>>2]=(c[(c[(c[g>>2]|0)+52>>2]|0)+52>>2]|0)+76;q=40;break a}c[k>>2]=(c[(c[g>>2]|0)+52>>2]|0)+76;q=40;break}case 17:{if(!(c[(c[h>>2]|0)+28>>2]&2)){c[l>>2]=c[(c[h>>2]|0)+16>>2];if((c[c[g>>2]>>2]|0)!=0?(c[c[g>>2]>>2]|0)!=1:0){c[k>>2]=(c[(c[(c[g>>2]|0)+52>>2]|0)+52>>2]|0)+56;q=40;break a}c[k>>2]=(c[(c[g>>2]|0)+52>>2]|0)+56;q=40}break}case 15:{c[l>>2]=c[(c[h>>2]|0)+8>>2];if((c[c[g>>2]>>2]|0)!=0?(c[c[g>>2]>>2]|0)!=1:0){c[k>>2]=(c[(c[(c[g>>2]|0)+52>>2]|0)+52>>2]|0)+32;q=40;break a}c[k>>2]=(c[(c[g>>2]|0)+52>>2]|0)+32;q=40;break}default:xB(c[f>>2]|0,160568,160592)}while(0);if((q|0)==40){q=0;if((c[c[k>>2]>>2]|0)==0?(b=Jj(10,c[(c[f>>2]|0)+80>>2]|0)|0,c[c[k>>2]>>2]=b,(c[c[k>>2]>>2]|0)==0):0){q=42;break}c[j>>2]=Lj(c[c[k>>2]>>2]|0,c[l>>2]|0,c[h>>2]|0)|0;if((c[j>>2]|0)!=0?(c[n>>2]=0,b=c[f>>2]|0,a=FC(c[h>>2]|0)|0,r=c[h>>2]|0,s=MD(c[h>>2]|0)|0,AB(b,1761,a,r,160672,s,YD(n,c[h>>2]|0)|0),(c[n>>2]|0)!=0):0){zb[c[135736>>2]&511](c[n>>2]|0);c[n>>2]=0}}c[m>>2]=(c[m>>2]|0)+1}if((q|0)==42){xB(c[f>>2]|0,160568,160632);c[e>>2]=-1;p=c[e>>2]|0;i=d;return p|0}b:do if(c[(c[g>>2]|0)+24>>2]|0){c[o>>2]=c[(c[g>>2]|0)+24>>2];while(1){if(((c[(c[o>>2]|0)+12>>2]|0)!=0?(c[(c[(c[o>>2]|0)+12>>2]|0)+4>>2]&2|0)==0:0)?(XC(c[f>>2]|0,c[(c[o>>2]|0)+12>>2]|0)|0)==-1:0)break;c[o>>2]=c[c[o>>2]>>2];if(!(c[o>>2]|0))break b}c[e>>2]=-1;p=c[e>>2]|0;i=d;return p|0}while(0);c[e>>2]=0;p=c[e>>2]|0;i=d;return p|0}function YC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;if((c[f>>2]|0)==0|(c[e>>2]|0)==0){i=d;return}if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+48>>2]&256|0)!=0:0){i=d;return}b=(c[e>>2]|0)+48|0;c[b>>2]=c[b>>2]|256;do if((c[(c[e>>2]|0)+28>>2]|0)==0?(c[(c[e>>2]|0)+56>>2]|0)!=0:0){c[g>>2]=wE(c[(c[f>>2]|0)+36>>2]|0,c[(c[e>>2]|0)+56>>2]|0,c[(c[e>>2]|0)+60>>2]|0)|0;if(!(c[g>>2]|0)){xE(c[f>>2]|0,3004,c[e>>2]|0,c[(c[e>>2]|0)+36>>2]|0,155448,c[(c[e>>2]|0)+56>>2]|0,c[(c[e>>2]|0)+60>>2]|0,1,160528);break}else{c[(c[e>>2]|0)+28>>2]=c[g>>2];break}}while(0);do if(c[(c[e>>2]|0)+64>>2]|0){c[h>>2]=yE(c[(c[f>>2]|0)+36>>2]|0,c[(c[e>>2]|0)+64>>2]|0,c[(c[e>>2]|0)+68>>2]|0)|0;if(!(c[h>>2]|0)){xE(c[f>>2]|0,3004,c[e>>2]|0,0,160544,c[(c[e>>2]|0)+64>>2]|0,c[(c[e>>2]|0)+68>>2]|0,14,0);break}YC(c[h>>2]|0,c[f>>2]|0);c[(c[e>>2]|0)+80>>2]=c[h>>2];if(!(c[(c[e>>2]|0)+28>>2]|0))c[(c[e>>2]|0)+28>>2]=c[(c[h>>2]|0)+28>>2]}while(0);if(c[(c[e>>2]|0)+28>>2]|0){i=d;return}if(c[(c[e>>2]|0)+56>>2]|0){i=d;return}if(c[(c[e>>2]|0)+64>>2]|0){i=d;return}h=IH(45)|0;c[(c[e>>2]|0)+28>>2]=h;i=d;return}function ZC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}if((c[(c[e>>2]|0)+64>>2]|0)==0?(b=wE(c[(c[f>>2]|0)+36>>2]|0,c[(c[e>>2]|0)+56>>2]|0,c[(c[e>>2]|0)+60>>2]|0)|0,c[(c[e>>2]|0)+64>>2]=b,(c[(c[e>>2]|0)+64>>2]|0)==0):0){xE(c[f>>2]|0,3004,c[e>>2]|0,c[(c[e>>2]|0)+36>>2]|0,151424,c[(c[e>>2]|0)+56>>2]|0,c[(c[e>>2]|0)+60>>2]|0,4,0);i=d;return}do if((c[c[e>>2]>>2]|0)!=4){if((c[c[e>>2]>>2]|0)==1?(c[(c[e>>2]|0)+88>>2]|0)!=45:0)break;if(!(c[(c[e>>2]|0)+28>>2]|0)){i=d;return}if((c[c[(c[e>>2]|0)+28>>2]>>2]|0)!=25){i=d;return}if(!(c[(c[(c[e>>2]|0)+28>>2]|0)+12>>2]|0)){i=d;return}if((c[c[(c[(c[e>>2]|0)+28>>2]|0)+12>>2]>>2]|0)!=2e3){i=d;return}c[g>>2]=c[(c[(c[e>>2]|0)+28>>2]|0)+12>>2];c[(c[(c[e>>2]|0)+28>>2]|0)+12>>2]=0;c[h>>2]=AE(c[(c[f>>2]|0)+36>>2]|0,c[(c[g>>2]|0)+8>>2]|0,c[(c[g>>2]|0)+12>>2]|0,c[(c[g>>2]|0)+16>>2]|0)|0;if(!(c[h>>2]|0)){b=c[f>>2]|0;a=FC(c[(c[e>>2]|0)+28>>2]|0)|0;xE(b,3004,0,a,160064,c[(c[g>>2]|0)+12>>2]|0,c[(c[g>>2]|0)+16>>2]|0,c[(c[g>>2]|0)+8>>2]|0,0);c[(c[e>>2]|0)+28>>2]=0;i=d;return}if(!(c[(c[h>>2]|0)+12>>2]|0)){c[(c[e>>2]|0)+28>>2]=0;i=d;return}c[(c[(c[e>>2]|0)+28>>2]|0)+12>>2]=c[(c[h>>2]|0)+12>>2];if((c[c[(c[h>>2]|0)+12>>2]>>2]|0)!=8){i=d;return}if((c[(c[(c[e>>2]|0)+28>>2]|0)+20>>2]|0)==1){i=d;return}a=c[f>>2]|0;AB(a,3091,FC(c[(c[e>>2]|0)+28>>2]|0)|0,0,160416,0,0);i=d;return}while(0);if(c[(c[e>>2]|0)+48>>2]&128){zE(c[f>>2]|0,c[e>>2]|0)|0;i=d;return}if(!(c[(c[e>>2]|0)+48>>2]&64)){i=d;return}if(c[(c[e>>2]|0)+28>>2]|0){i=d;return}if(!(c[(c[e>>2]|0)+56>>2]|0)){i=d;return}h=wE(c[(c[f>>2]|0)+36>>2]|0,c[(c[e>>2]|0)+56>>2]|0,c[(c[e>>2]|0)+60>>2]|0)|0;c[(c[e>>2]|0)+28>>2]=h;if(c[(c[e>>2]|0)+28>>2]|0){if((c[c[(c[e>>2]|0)+28>>2]>>2]|0)==4){i=d;return}if((c[c[(c[e>>2]|0)+28>>2]>>2]|0)==1?(c[(c[(c[e>>2]|0)+28>>2]|0)+88>>2]|0)!=45:0){i=d;return}}c[(c[e>>2]|0)+28>>2]=0;xE(c[f>>2]|0,3004,c[e>>2]|0,c[(c[e>>2]|0)+36>>2]|0,160400,c[(c[e>>2]|0)+56>>2]|0,c[(c[e>>2]|0)+60>>2]|0,4,0);i=d;return}function _C(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if(c[(c[f>>2]|0)+60>>2]&256){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}b=(c[f>>2]|0)+60|0;c[b>>2]=c[b>>2]|256;if(c[(c[f>>2]|0)+48>>2]|0){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}a:do if(c[(c[f>>2]|0)+24>>2]|0){c[h>>2]=wE(c[(c[g>>2]|0)+36>>2]|0,c[(c[f>>2]|0)+24>>2]|0,c[(c[f>>2]|0)+28>>2]|0)|0;do if(c[h>>2]|0){if((c[c[h>>2]>>2]|0)!=4){if((c[c[h>>2]>>2]|0)!=1)break;if((c[(c[h>>2]|0)+88>>2]|0)==45)break}c[(c[f>>2]|0)+48>>2]=c[h>>2];break a}while(0);xE(c[g>>2]|0,3004,c[f>>2]|0,c[(c[f>>2]|0)+52>>2]|0,155448,c[(c[f>>2]|0)+24>>2]|0,c[(c[f>>2]|0)+28>>2]|0,4,0);c[e>>2]=c[(c[g>>2]|0)+16>>2];j=c[e>>2]|0;i=d;return j|0}else{b=IH(46)|0;c[(c[f>>2]|0)+48>>2]=b}while(0);c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}function $C(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if((c[g>>2]|0)==0|(c[f>>2]|0)==0){c[e>>2]=-1;j=c[e>>2]|0;i=d;return j|0}if((c[(c[f>>2]|0)+12>>2]|0)!=0?(c[c[(c[f>>2]|0)+12>>2]>>2]|0)==2e3:0){c[h>>2]=c[(c[f>>2]|0)+12>>2];b=BE(c[(c[g>>2]|0)+36>>2]|0,c[(c[h>>2]|0)+12>>2]|0,c[(c[h>>2]|0)+16>>2]|0)|0;c[(c[f>>2]|0)+12>>2]=b;if(!(c[(c[f>>2]|0)+12>>2]|0)){xE(c[g>>2]|0,3004,c[f>>2]|0,c[(c[f>>2]|0)+20>>2]|0,160064,c[(c[h>>2]|0)+12>>2]|0,c[(c[h>>2]|0)+16>>2]|0,15,0);c[e>>2]=c[(c[g>>2]|0)+16>>2];j=c[e>>2]|0;i=d;return j|0}else{c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}}c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}function aD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if(c[(c[f>>2]|0)+4>>2]|0){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}c[h>>2]=CE(c[(c[g>>2]|0)+36>>2]|0,c[(c[f>>2]|0)+12>>2]|0,c[(c[f>>2]|0)+16>>2]|0)|0;if(!(c[h>>2]|0)){xE(c[g>>2]|0,3004,0,c[(c[f>>2]|0)+20>>2]|0,160064,c[(c[f>>2]|0)+12>>2]|0,c[(c[f>>2]|0)+16>>2]|0,c[(c[f>>2]|0)+8>>2]|0,0);c[e>>2]=c[(c[g>>2]|0)+16>>2];j=c[e>>2]|0;i=d;return j|0}else{c[(c[f>>2]|0)+4>>2]=c[h>>2];c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}return 0}function bD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=c[(c[f>>2]|0)+12>>2];while(1){if(!(c[g>>2]|0))break;do if((c[(c[g>>2]|0)+12>>2]|0)!=0?(c[c[(c[g>>2]|0)+12>>2]>>2]|0)==2e3:0){c[h>>2]=c[(c[g>>2]|0)+12>>2];c[(c[g>>2]|0)+12>>2]=0;c[j>>2]=AE(c[(c[e>>2]|0)+36>>2]|0,c[(c[h>>2]|0)+8>>2]|0,c[(c[h>>2]|0)+12>>2]|0,c[(c[h>>2]|0)+16>>2]|0)|0;if(!(c[j>>2]|0)){f=c[e>>2]|0;b=FC(c[g>>2]|0)|0;xE(f,3004,0,b,160064,c[(c[h>>2]|0)+12>>2]|0,c[(c[h>>2]|0)+16>>2]|0,c[(c[h>>2]|0)+8>>2]|0,0);break}b=c[j>>2]|0;if((c[c[j>>2]>>2]|0)!=17){c[(c[g>>2]|0)+12>>2]=b;break}if(c[b+12>>2]|0)if((c[c[(c[j>>2]|0)+12>>2]>>2]|0)==8){b=c[e>>2]|0;AB(b,3091,FC(c[g>>2]|0)|0,0,160280,0,0);break}else{c[(c[g>>2]|0)+12>>2]=c[j>>2];break}}while(0);c[g>>2]=c[(c[g>>2]|0)+8>>2]}i=d;return}function cD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[f>>2]=a;c[g>>2]=b;if((c[c[f>>2]>>2]|0)!=24){c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}if(c[(c[(c[f>>2]|0)+36>>2]|0)+12>>2]|0){b=DE(c[(c[g>>2]|0)+36>>2]|0,c[(c[(c[f>>2]|0)+36>>2]|0)+12>>2]|0,c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0;c[(c[(c[f>>2]|0)+36>>2]|0)+4>>2]=b;if(!(c[(c[(c[f>>2]|0)+36>>2]|0)+4>>2]|0)){xE(c[g>>2]|0,3004,c[f>>2]|0,c[(c[f>>2]|0)+12>>2]|0,160144,c[(c[(c[f>>2]|0)+36>>2]|0)+12>>2]|0,c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0,23,0);c[e>>2]=c[(c[g>>2]|0)+16>>2];k=c[e>>2]|0;i=d;return k|0}if((c[c[(c[(c[f>>2]|0)+36>>2]|0)+4>>2]>>2]|0)==24){AB(c[g>>2]|0,3080,0,c[f>>2]|0,160152,0,0);c[(c[(c[f>>2]|0)+36>>2]|0)+4>>2]=0;c[e>>2]=c[(c[g>>2]|0)+16>>2];k=c[e>>2]|0;i=d;return k|0}if((c[(c[f>>2]|0)+32>>2]|0)!=(c[(c[(c[(c[f>>2]|0)+36>>2]|0)+4>>2]|0)+32>>2]|0)){c[h>>2]=0;c[j>>2]=c[(c[(c[f>>2]|0)+36>>2]|0)+4>>2];b=c[g>>2]|0;a=c[f>>2]|0;AB(b,3080,0,a,160184,BB(h,c[(c[j>>2]|0)+20>>2]|0,c[(c[j>>2]|0)+16>>2]|0)|0,0);if(c[h>>2]|0){zb[c[135736>>2]&511](c[h>>2]|0);c[h>>2]=0}c[e>>2]=c[(c[g>>2]|0)+16>>2];k=c[e>>2]|0;i=d;return k|0}}c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}function dD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if(!(BE(c[(c[g>>2]|0)+36>>2]|0,c[(c[f>>2]|0)+8>>2]|0,c[(c[f>>2]|0)+12>>2]|0)|0)){xE(c[g>>2]|0,3004,0,c[(c[f>>2]|0)+4>>2]|0,160064,c[(c[f>>2]|0)+8>>2]|0,c[(c[f>>2]|0)+12>>2]|0,15,0);c[e>>2]=3004;h=c[e>>2]|0;i=d;return h|0}else{c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}return 0}function eD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}if((c[c[e>>2]>>2]|0)==1){i=d;return;
}if(!(c[(c[e>>2]|0)+64>>2]|0)){i=d;return}EE(c[f>>2]|0,c[e>>2]|0,c[(c[e>>2]|0)+64>>2]|0)|0;i=d;return}function fD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}if((c[c[e>>2]>>2]|0)!=17){i=d;return}if(!(c[(c[e>>2]|0)+12>>2]|0)){i=d;return}c[g>>2]=FE(c[e>>2]|0,c[(c[(c[e>>2]|0)+12>>2]|0)+12>>2]|0)|0;if(!(c[g>>2]|0)){i=d;return}c[h>>2]=0;b=c[f>>2]|0;f=FC(c[g>>2]|0)|0;GE(b,3075,0,f,159968,BB(h,c[(c[e>>2]|0)+20>>2]|0,c[(c[e>>2]|0)+16>>2]|0)|0);if(c[h>>2]|0){zb[c[135736>>2]&511](c[h>>2]|0);c[h>>2]=0}c[(c[g>>2]|0)+12>>2]=0;i=d;return}function gD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[f>>2]=a;c[g>>2]=b;if(!(c[(c[f>>2]|0)+56>>2]|0)){c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}if(!(c[(c[f>>2]|0)+36>>2]&16)){c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}c[h>>2]=HE(c[f>>2]|0,c[(c[f>>2]|0)+56>>2]|0)|0;if(!(c[h>>2]|0)){c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}c[j>>2]=0;b=c[g>>2]|0;a=FC(c[h>>2]|0)|0;GE(b,3073,0,a,159912,YD(j,c[f>>2]|0)|0);if(c[j>>2]|0){zb[c[135736>>2]&511](c[j>>2]|0);c[j>>2]=0}c[(c[h>>2]|0)+4>>2]=0;c[e>>2]=c[(c[g>>2]|0)+16>>2];k=c[e>>2]|0;i=d;return k|0}function hD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[d+8>>2]=a;c[e>>2]=b;c[f>>2]=c[(c[e>>2]|0)+12>>2];while(1){if(!(c[f>>2]|0))break;if((c[(c[f>>2]|0)+12>>2]|0)!=0?(c[c[(c[f>>2]|0)+12>>2]>>2]|0)==17:0){e=(c[f>>2]|0)+12|0;if(!(c[(c[(c[f>>2]|0)+12>>2]|0)+12>>2]|0)){c[e>>2]=0;c[f>>2]=c[(c[f>>2]|0)+8>>2];continue}else{c[(c[f>>2]|0)+12>>2]=c[(c[e>>2]|0)+12>>2];c[f>>2]=c[(c[f>>2]|0)+8>>2];continue}}c[f>>2]=c[(c[f>>2]|0)+8>>2]}i=d;return}function iD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if((c[(c[g>>2]|0)+56>>2]|0)!=0?(c[(c[g>>2]|0)+36>>2]&1|0)==0:0){b=(c[g>>2]|0)+36|0;c[b>>2]=c[b>>2]|1;if((IE(c[f>>2]|0,c[g>>2]|0,(c[g>>2]|0)+40|0,c[(c[g>>2]|0)+56>>2]|0,0)|0)==-1){c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}else{c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}}c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}function jD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if((c[c[g>>2]>>2]|0)!=4){c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}if((c[c[g>>2]>>2]|0)!=1?(c[(c[g>>2]|0)+48>>2]&536870912|0)==0:0){b=(c[g>>2]|0)+48|0;c[b>>2]=c[b>>2]|536870912;b=c[g>>2]|0;do if(c[(c[g>>2]|0)+48>>2]&64){if(!(c[b+28>>2]|0)){xB(c[f>>2]|0,153152,153192);c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}}else{a=c[g>>2]|0;if(c[b+48>>2]&128){if(c[a+92>>2]|0)break;xB(c[f>>2]|0,153152,153232);c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}if(!(c[a+64>>2]|0)){xB(c[f>>2]|0,153152,153272);c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}if(((c[c[(c[g>>2]|0)+64>>2]>>2]|0)!=1?(c[(c[(c[g>>2]|0)+64>>2]|0)+48>>2]&536870912|0)==0:0)?(jD(c[f>>2]|0,c[(c[g>>2]|0)+64>>2]|0)|0)==-1:0){c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}a=c[g>>2]|0;if(c[(c[(c[g>>2]|0)+64>>2]|0)+48>>2]&256){j=a+48|0;c[j>>2]=c[j>>2]|256;break}j=c[g>>2]|0;if(c[(c[a+64>>2]|0)+48>>2]&64){a=j+48|0;c[a>>2]=c[a>>2]|64;c[(c[g>>2]|0)+28>>2]=c[(c[(c[g>>2]|0)+64>>2]|0)+28>>2];break}if(c[(c[j+64>>2]|0)+48>>2]&128){j=(c[g>>2]|0)+48|0;c[j>>2]=c[j>>2]|128}}while(0);c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}function kD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if(c[(c[g>>2]|0)+48>>2]&128){c[e>>2]=JE(c[f>>2]|0,c[g>>2]|0,c[(c[g>>2]|0)+92>>2]|0)|0;h=c[e>>2]|0;i=d;return h|0}else{c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}return 0}function lD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[f>>2]=a;c[g>>2]=b;c[j>>2]=c[(c[f>>2]|0)+20>>2];if((c[c[g>>2]>>2]|0)!=4){c[e>>2]=-1;k=c[e>>2]|0;i=d;return k|0}if((c[c[g>>2]>>2]|0)!=1?(c[(c[g>>2]|0)+48>>2]&4194304|0)==0:0){b=(c[g>>2]|0)+48|0;c[b>>2]=c[b>>2]|4194304;c[(c[g>>2]|0)+52>>2]=4;a:do if(c[(c[g>>2]|0)+64>>2]|0){if((c[c[(c[g>>2]|0)+64>>2]>>2]|0)!=1?(c[(c[(c[g>>2]|0)+64>>2]|0)+48>>2]&4194304|0)==0:0)KE(c[(c[g>>2]|0)+64>>2]|0,c[f>>2]|0)|0;if((c[(c[g>>2]|0)+92>>2]|0)!=0?(LE(c[f>>2]|0,c[g>>2]|0)|0)==-1:0){c[e>>2]=-1;k=c[e>>2]|0;i=d;return k|0}c[h>>2]=ME(c[f>>2]|0,c[g>>2]|0)|0;if((c[h>>2]|0)!=-1){do if(!(c[h>>2]|0)){c[h>>2]=NE(c[f>>2]|0,c[g>>2]|0)|0;if((c[h>>2]|0)==-1)break a;if(!(c[h>>2]|0)){c[h>>2]=OE(c[g>>2]|0,c[f>>2]|0)|0;if((c[h>>2]|0)==-1)break a;if(!(c[h>>2]|0)){if(!((c[(c[g>>2]|0)+96>>2]|0)==0?(c[(c[(c[g>>2]|0)+64>>2]|0)+96>>2]|0)==0:0)){c[h>>2]=PE(c[f>>2]|0,c[g>>2]|0)|0;if((c[h>>2]|0)==-1)break a;if(c[h>>2]|0)break}c[h>>2]=QE(c[g>>2]|0)|0;if((c[h>>2]|0)==-1)break a;if(!(c[h>>2]|0))RE(c[g>>2]|0)}}}while(0);if((c[j>>2]|0)!=(c[(c[f>>2]|0)+20>>2]|0)){c[e>>2]=c[(c[f>>2]|0)+16>>2];k=c[e>>2]|0;i=d;return k|0}else{c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}}}else xB(c[f>>2]|0,147168,147208);while(0);c[e>>2]=-1;k=c[e>>2]|0;i=d;return k|0}c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}function mD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if(!(c[(c[g>>2]|0)+48>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}if(c[(c[g>>2]|0)+44>>2]|0){b=(SE(c[(c[g>>2]|0)+48>>2]|0,23)|0)!=0;a=c[f>>2]|0;k=c[g>>2]|0;if(b){AB(a,3090,0,k,159552,0,0);c[e>>2]=c[(c[f>>2]|0)+16>>2];j=c[e>>2]|0;i=d;return j|0}c[h>>2]=yB(a,c[k+52>>2]|0,c[(c[g>>2]|0)+48>>2]|0,c[(c[g>>2]|0)+44>>2]|0,(c[g>>2]|0)+68|0,1,1,0)|0;if(c[h>>2]|0){k=c[f>>2]|0;if((c[h>>2]|0)<0){xB(k,159840,141832);c[e>>2]=-1;j=c[e>>2]|0;i=d;return j|0}else{AB(k,3079,0,c[g>>2]|0,159680,0,0);c[e>>2]=c[(c[f>>2]|0)+16>>2];j=c[e>>2]|0;i=d;return j|0}}}c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}function nD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){c[e>>2]=-1;j=c[e>>2]|0;i=d;return j|0}if(((c[(c[g>>2]|0)+28>>2]|0)!=0?(c[(c[g>>2]|0)+12>>2]|0)!=0:0)?(c[c[(c[g>>2]|0)+12>>2]>>2]|0)==15:0){if(((c[(c[(c[g>>2]|0)+12>>2]|0)+44>>2]|0)!=0?(c[(c[(c[g>>2]|0)+12>>2]|0)+60>>2]&512|0)!=0:0)?(c[(c[g>>2]|0)+16>>2]&1|0)==0:0){GE(c[f>>2]|0,3078,c[g>>2]|0,0,159424,0);c[e>>2]=c[(c[f>>2]|0)+16>>2];j=c[e>>2]|0;i=d;return j|0}if((c[(c[g>>2]|0)+32>>2]|0)!=0?(c[(c[(c[g>>2]|0)+12>>2]|0)+48>>2]|0)!=0:0){b=(SE(c[(c[(c[g>>2]|0)+12>>2]|0)+48>>2]|0,23)|0)!=0;a=c[f>>2]|0;k=c[g>>2]|0;if(b){AB(a,3089,0,k,159552,0,0);c[e>>2]=c[(c[f>>2]|0)+16>>2];j=c[e>>2]|0;i=d;return j|0}c[h>>2]=yB(a,c[k+20>>2]|0,c[(c[(c[g>>2]|0)+12>>2]|0)+48>>2]|0,c[(c[g>>2]|0)+28>>2]|0,(c[g>>2]|0)+32|0,1,1,0)|0;if(c[h>>2]|0){k=c[f>>2]|0;if((c[h>>2]|0)<0){xB(k,159640,141832);c[e>>2]=-1;j=c[e>>2]|0;i=d;return j|0}else{AB(k,3089,0,c[g>>2]|0,159680,0,0);c[e>>2]=c[(c[f>>2]|0)+16>>2];j=c[e>>2]|0;i=d;return j|0}}}if((c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2]|0)!=0?(c[(c[(c[g>>2]|0)+12>>2]|0)+60>>2]&1|0)==0:0){if(!(VD(c[(c[g>>2]|0)+32>>2]|0,c[(c[(c[g>>2]|0)+12>>2]|0)+68>>2]|0)|0))GE(c[f>>2]|0,3078,c[g>>2]|0,0,159728,c[(c[(c[g>>2]|0)+12>>2]|0)+44>>2]|0);c[e>>2]=c[(c[f>>2]|0)+16>>2];j=c[e>>2]|0;i=d;return j|0}c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}function oD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+48|0;e=d+40|0;f=d+36|0;g=d+32|0;h=d+28|0;j=d+24|0;k=d+20|0;l=d+16|0;m=d+12|0;n=d+8|0;o=d+4|0;p=d;c[f>>2]=a;c[g>>2]=b;a:do if((c[(c[g>>2]|0)+56>>2]|0)!=0?(c[(c[(c[g>>2]|0)+56>>2]|0)+4>>2]|0)>1:0){c[h>>2]=c[(c[g>>2]|0)+56>>2];c[n>>2]=0;c[l>>2]=(c[(c[h>>2]|0)+4>>2]|0)-1;b:while(1){if((c[l>>2]|0)<0)break a;c[j>>2]=c[(c[c[h>>2]>>2]|0)+(c[l>>2]<<2)>>2];c:do if((c[l>>2]|0)>0){c[m>>2]=(c[l>>2]|0)-1;while(1){if((c[m>>2]|0)<0){q=15;break c}c[k>>2]=c[(c[c[h>>2]>>2]|0)+(c[m>>2]<<2)>>2];if((c[(c[(c[j>>2]|0)+12>>2]|0)+8>>2]|0)==(c[(c[(c[k>>2]|0)+12>>2]|0)+8>>2]|0)?(c[(c[(c[j>>2]|0)+12>>2]|0)+56>>2]|0)==(c[(c[(c[k>>2]|0)+12>>2]|0)+56>>2]|0):0)break;c[m>>2]=(c[m>>2]|0)+-1}c[o>>2]=0;b=c[f>>2]|0;a=c[(c[g>>2]|0)+32>>2]|0;r=c[g>>2]|0;AB(b,3087,a,r,152424,ZD(o,c[j>>2]|0)|0,0);if(c[o>>2]|0){zb[c[135736>>2]&511](c[o>>2]|0);c[o>>2]=0}if((TE(c[h>>2]|0,c[l>>2]|0)|0)==-1){q=13;break b}}else q=15;while(0);if(((q|0)==15?(q=0,(c[(c[(c[j>>2]|0)+12>>2]|0)+48>>2]|0)!=0):0)?(SE(c[(c[(c[j>>2]|0)+12>>2]|0)+48>>2]|0,23)|0)!=0:0){if(c[n>>2]|0){c[p>>2]=0;r=c[f>>2]|0;a=c[(c[g>>2]|0)+32>>2]|0;b=c[g>>2]|0;AB(r,3087,a,b,152440,ZD(p,c[j>>2]|0)|0,0);if(c[p>>2]|0){zb[c[135736>>2]&511](c[p>>2]|0);c[p>>2]=0}if((TE(c[h>>2]|0,c[l>>2]|0)|0)==-1){q=21;break}}c[n>>2]=1}c[l>>2]=(c[l>>2]|0)+-1}if((q|0)==13){c[e>>2]=-1;s=c[e>>2]|0;i=d;return s|0}else if((q|0)==21){c[e>>2]=-1;s=c[e>>2]|0;i=d;return s|0}}while(0);c[e>>2]=0;s=c[e>>2]|0;i=d;return s|0}function pD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+32|0;d=b+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[e>>2]=a;c[f>>2]=0;c[g>>2]=c[(c[(c[e>>2]|0)+28>>2]|0)+28>>2];if(!(c[g>>2]|0)){c[d>>2]=0;j=c[d>>2]|0;i=b;return j|0}while(1){a=c[g>>2]|0;if(!(c[(c[g>>2]|0)+12>>2]|0))c[g>>2]=c[a>>2];else{c[h>>2]=c[a+4>>2];a=c[c[h>>2]>>2]|0;if((a|0)==16){c[f>>2]=UE(c[e>>2]|0,1,c[h>>2]|0,c[(c[g>>2]|0)+12>>2]|0,c[(c[h>>2]|0)+56>>2]|0,c[(c[(c[g>>2]|0)+12>>2]|0)+56>>2]|0,c[(c[h>>2]|0)+40>>2]|0,c[(c[(c[g>>2]|0)+12>>2]|0)+40>>2]|0)|0;if((c[f>>2]|0)==-1){k=8;break}}else if((a|0)==5|(a|0)==4)c[(c[(c[g>>2]|0)+12>>2]|0)+8>>2]=0;c[g>>2]=c[c[g>>2]>>2]}if(!(c[g>>2]|0)){k=11;break}}if((k|0)==8){c[d>>2]=-1;j=c[d>>2]|0;i=b;return j|0}else if((k|0)==11){c[d>>2]=0;j=c[d>>2]|0;i=b;return j|0}return 0}function qD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+48|0;e=d+40|0;f=d+36|0;g=d+32|0;h=d+28|0;j=d+24|0;k=d+20|0;l=d+16|0;m=d+12|0;n=d+8|0;o=d+4|0;p=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;c[j>>2]=c[(c[f>>2]|0)+20>>2];c[k>>2]=c[(c[g>>2]|0)+64>>2];if((c[c[g>>2]>>2]|0)!=1?(c[(c[g>>2]|0)+48>>2]&4194304|0)==0:0){b=(c[g>>2]|0)+48|0;c[b>>2]=c[b>>2]|4194304;a:do if(c[k>>2]|0){if((c[c[k>>2]>>2]|0)!=1?(c[(c[k>>2]|0)+48>>2]&4194304|0)==0:0)KE(c[k>>2]|0,c[f>>2]|0)|0;if(c[(c[k>>2]|0)+48>>2]&8388608){c[e>>2]=0;q=c[e>>2]|0;i=d;return q|0}c[h>>2]=VE(c[f>>2]|0,c[g>>2]|0)|0;if((c[h>>2]|0)!=-1){b:do if(!(c[h>>2]|0)){c:do if((c[(c[g>>2]|0)+52>>2]|0)==4){if(!((c[c[k>>2]>>2]|0)!=5?(c[(c[k>>2]|0)+88>>2]|0)!=45:0))r=16;if(((r|0)==16?(c[(c[k>>2]|0)+104>>2]|0)!=0:0)?(c[(c[g>>2]|0)+48>>2]&4|0)!=0:0){if(c[(c[g>>2]|0)+104>>2]|0){c[l>>2]=c[(c[g>>2]|0)+104>>2];c[(c[g>>2]|0)+104>>2]=0}else c[l>>2]=c[(c[k>>2]|0)+104>>2];c[m>>2]=WE(c[f>>2]|0,c[(c[f>>2]|0)+36>>2]|0,4,0,c[(c[g>>2]|0)+112>>2]|0,c[(c[g>>2]|0)+36>>2]|0,0)|0;if(!(c[m>>2]|0))break a;c[c[m>>2]>>2]=4;c[(c[m>>2]|0)+64>>2]=c[l>>2];c[(c[m>>2]|0)+68>>2]=c[(c[g>>2]|0)+68>>2];c[(c[g>>2]|0)+68>>2]=0;c[(c[m>>2]|0)+96>>2]=c[(c[g>>2]|0)+96>>2];c[(c[g>>2]|0)+96>>2]=0;c[(c[g>>2]|0)+104>>2]=c[m>>2];do if((c[c[l>>2]>>2]|0)!=1){if(c[(c[l>>2]|0)+48>>2]&4194304)break;KE(c[l>>2]|0,c[f>>2]|0)|0}while(0);c[h>>2]=jD(c[f>>2]|0,c[m>>2]|0)|0;if((c[h>>2]|0)==-1)break a;if(c[h>>2]|0)break b;c[h>>2]=lD(c[f>>2]|0,c[m>>2]|0)|0;if((c[h>>2]|0)==-1)break a;if(c[h>>2]|0)break b;else break}if(!((c[c[k>>2]>>2]|0)!=5?(c[(c[k>>2]|0)+88>>2]|0)!=45:0))r=31;if(((r|0)==31?(c[(c[k>>2]|0)+52>>2]|0)==3:0)?(c[(c[g>>2]|0)+48>>2]&4|0)!=0:0){if((c[(c[g>>2]|0)+104>>2]|0)!=0?(c[(c[(c[g>>2]|0)+104>>2]|0)+64>>2]|0)!=0:0)break;GE(c[f>>2]|0,3069,c[g>>2]|0,0,149808,c[(c[g>>2]|0)+8>>2]|0);break a}if(!((c[c[k>>2]>>2]|0)!=5?(c[(c[k>>2]|0)+88>>2]|0)!=45:0))r=38;if((r|0)==38?(c[(c[g>>2]|0)+48>>2]&2|0)!=0:0)if(!(c[(c[k>>2]|0)+104>>2]|0)){GE(c[f>>2]|0,3069,c[g>>2]|0,0,149976,c[(c[g>>2]|0)+8>>2]|0);break a}else{c[(c[g>>2]|0)+104>>2]=c[(c[k>>2]|0)+104>>2];break}if((c[c[k>>2]>>2]|0)!=4){if((c[c[k>>2]>>2]|0)==1?(c[(c[k>>2]|0)+88>>2]|0)!=45:0)r=45}else r=45;if((r|0)==45?(c[(c[g>>2]|0)+48>>2]&2|0)!=0:0){c[(c[g>>2]|0)+104>>2]=c[k>>2];break}GE(c[f>>2]|0,3069,c[g>>2]|0,0,150112,c[(c[g>>2]|0)+8>>2]|0);break a}else{c[n>>2]=0;c[o>>2]=c[(c[g>>2]|0)+28>>2];d:do if(!(c[o>>2]|0))r=55;else{do if((c[c[o>>2]>>2]|0)==25){if((c[c[(c[o>>2]|0)+12>>2]>>2]|0)!=8?(c[c[(c[o>>2]|0)+12>>2]>>2]|0)!=6:0){if((c[c[(c[o>>2]|0)+12>>2]>>2]|0)!=7)break;if(c[(c[o>>2]|0)+16>>2]|0)break}if(!(c[(c[(c[o>>2]|0)+12>>2]|0)+12>>2]|0)){r=55;break d}}while(0);c[(c[g>>2]|0)+52>>2]=2}while(0);do if((r|0)==55){if(!(c[(c[g>>2]|0)+48>>2]&1)){c[(c[g>>2]|0)+52>>2]=1;break}if(!((c[o>>2]|0)!=0?(c[c[(c[o>>2]|0)+12>>2]>>2]|0)==6:0)){c[o>>2]=XE(c[f>>2]|0,c[(c[g>>2]|0)+36>>2]|0,1,1)|0;if(!(c[o>>2]|0))break a;b=YE(c[f>>2]|0,c[(c[f>>2]|0)+36>>2]|0,6,c[(c[g>>2]|0)+36>>2]|0)|0;c[(c[o>>2]|0)+12>>2]=b;if(!(c[(c[o>>2]|0)+12>>2]|0))break a;c[(c[g>>2]|0)+28>>2]=c[o>>2]}c[n>>2]=1;c[(c[g>>2]|0)+52>>2]=2}while(0);b=c[(c[g>>2]|0)+52>>2]|0;if(c[(c[g>>2]|0)+48>>2]&4){if((b|0)==1)break;if(!(c[(c[g>>2]|0)+48>>2]&1))break;c[(c[g>>2]|0)+52>>2]=3;break}a=c[(c[k>>2]|0)+52>>2]|0;if((b|0)==1){c[(c[g>>2]|0)+52>>2]=a;c[(c[g>>2]|0)+28>>2]=c[(c[k>>2]|0)+28>>2];c[(c[g>>2]|0)+104>>2]=c[(c[k>>2]|0)+104>>2];break}b=(c[(c[g>>2]|0)+48>>2]&1|0)!=0;if((a|0)==1){if(!b)break;c[(c[g>>2]|0)+52>>2]=3;break}if(b)c[(c[g>>2]|0)+52>>2]=3;do if((c[(c[g>>2]|0)+28>>2]|0)!=0?(c[(c[(c[g>>2]|0)+28>>2]|0)+12>>2]|0)!=0:0){if((c[c[(c[(c[g>>2]|0)+28>>2]|0)+12>>2]>>2]|0)!=8)break;b=c[f>>2]|0;AB(b,3091,FC(c[g>>2]|0)|0,0,150216,0,0);break c}while(0);do if(c[(c[k>>2]|0)+28>>2]|0){if(!(c[(c[(c[k>>2]|0)+28>>2]|0)+12>>2]|0))break;if((c[c[(c[(c[k>>2]|0)+28>>2]|0)+12>>2]>>2]|0)!=8)break;b=c[f>>2]|0;AB(b,3091,FC(c[g>>2]|0)|0,0,150480,0,0);break c}while(0);if(c[n>>2]|0){c[(c[(c[o>>2]|0)+12>>2]|0)+12>>2]=c[(c[k>>2]|0)+28>>2];break}c[p>>2]=c[(c[g>>2]|0)+28>>2];c[o>>2]=XE(c[f>>2]|0,c[(c[g>>2]|0)+36>>2]|0,1,1)|0;if(!(c[o>>2]|0))break a;b=YE(c[f>>2]|0,c[(c[f>>2]|0)+36>>2]|0,6,c[(c[g>>2]|0)+36>>2]|0)|0;c[(c[o>>2]|0)+12>>2]=b;if(!(c[(c[o>>2]|0)+12>>2]|0))break a;c[(c[g>>2]|0)+28>>2]=c[o>>2];b=XE(c[f>>2]|0,c[(c[g>>2]|0)+36>>2]|0,c[(c[(c[k>>2]|0)+28>>2]|0)+16>>2]|0,c[(c[(c[k>>2]|0)+28>>2]|0)+20>>2]|0)|0;c[(c[(c[o>>2]|0)+12>>2]|0)+12>>2]=b;if(!(c[(c[(c[o>>2]|0)+12>>2]|0)+12>>2]|0))break a;c[o>>2]=c[(c[(c[o>>2]|0)+12>>2]|0)+12>>2];c[(c[o>>2]|0)+12>>2]=c[(c[(c[k>>2]|0)+28>>2]|0)+12>>2];c[(c[o>>2]|0)+8>>2]=c[p>>2]}while(0);c[h>>2]=ZE(c[f>>2]|0,c[g>>2]|0)|0;if((c[h>>2]|0)==-1)break a;if(!(c[h>>2]|0)){c[h>>2]=_E(c[f>>2]|0,c[g>>2]|0)|0;if((c[h>>2]|0)==-1)break a;if(!(c[h>>2]|0))if((c[j>>2]|0)!=(c[(c[f>>2]|0)+20>>2]|0)){c[e>>2]=c[(c[f>>2]|0)+16>>2];q=c[e>>2]|0;i=d;return q|0}else{c[e>>2]=0;q=c[e>>2]|0;i=d;return q|0}}}while(0);b=(c[g>>2]|0)+48|0;c[b>>2]=c[b>>2]|8388608;c[e>>2]=c[(c[f>>2]|0)+16>>2];q=c[e>>2]|0;i=d;return q|0}}else xB(c[f>>2]|0,149776,147208);while(0);f=(c[g>>2]|0)+48|0;c[f>>2]=c[f>>2]|8388608;c[e>>2]=-1;q=c[e>>2]|0;i=d;return q|0}c[e>>2]=0;q=c[e>>2]|0;i=d;return q|0}function rD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}if(c[(c[e>>2]|0)+48>>2]&262144){i=d;return}b=(c[e>>2]|0)+48|0;c[b>>2]=c[b>>2]|262144;if($E(c[f>>2]|0,c[e>>2]|0)|0){i=d;return}aF(c[f>>2]|0,c[e>>2]|0);i=d;return}function sD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;g=d+4|0;c[f>>2]=a;c[g>>2]=b;if((c[c[f>>2]>>2]|0)!=5){i=d;return}if(c[(c[f>>2]|0)+108>>2]|0){i=d;return}if((c[(c[f>>2]|0)+52>>2]|0)!=2?(c[(c[f>>2]|0)+52>>2]|0)!=3:0){i=d;return}c[(c[g>>2]|0)+64>>2]=0;b=xz()|0;c[(c[g>>2]|0)+64>>2]=b;if(!(c[(c[g>>2]|0)+64>>2]|0)){b=c[33976]|0;a=c[33980]|0;c[e>>2]=c[(c[f>>2]|0)+8>>2];Db[b&511](a,157984,e);i=d;return}e=Bz(c[(c[g>>2]|0)+64>>2]|0)|0;c[(c[g>>2]|0)+76>>2]=e;bF(c[g>>2]|0,c[(c[f>>2]|0)+28>>2]|0)|0;Cz(c[(c[g>>2]|0)+64>>2]|0,c[(c[g>>2]|0)+76>>2]|0)|0;e=Oz(c[(c[g>>2]|0)+64>>2]|0)|0;c[(c[f>>2]|0)+108>>2]=e;if(c[(c[f>>2]|0)+108>>2]|0){if((wz(c[(c[f>>2]|0)+108>>2]|0)|0)!=1)GE(c[g>>2]|0,3070,c[f>>2]|0,c[(c[f>>2]|0)+36>>2]|0,158072,0)}else GE(c[g>>2]|0,3069,c[f>>2]|0,c[(c[f>>2]|0)+36>>2]|0,158032,0);c[(c[g>>2]|0)+76>>2]=0;yz(c[(c[g>>2]|0)+64>>2]|0);c[(c[g>>2]|0)+64>>2]=0;i=d;return}function tD(a){a=a|0;var b=0,d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;b=i;i=i+32|0;d=b+28|0;f=b+24|0;g=b+20|0;h=b+16|0;j=b+12|0;k=b+8|0;l=b+4|0;m=b;c[f>>2]=a;c[h>>2]=0;c[j>>2]=0;a=c[f>>2]|0;if(c[(c[f>>2]|0)+84>>2]|0)c[l>>2]=c[a+84>>2];else c[l>>2]=Pi(c[a+24>>2]|0)|0;a=c[f>>2]|0;if(!(c[l>>2]|0)){AB(a,1,0,0,141128,0,0);c[d>>2]=1;n=c[d>>2]|0;i=b;return n|0}c[a+96>>2]=-1;c[(c[f>>2]|0)+84>>2]=c[l>>2];c[k>>2]=c[l>>2];a:while(1){if(!(c[k>>2]|0)){o=48;break}if((c[(c[f>>2]|0)+176>>2]|0)!=-1?(c[(c[f>>2]|0)+96>>2]|0)>=(c[(c[f>>2]|0)+176>>2]|0):0)o=45;else o=10;do if((o|0)==10){o=0;if((c[(c[k>>2]|0)+4>>2]|0)==1){a=(c[f>>2]|0)+96|0;c[a>>2]=(c[a>>2]|0)+1;if((uD(c[f>>2]|0)|0)==-1)break a;c[j>>2]=c[(c[f>>2]|0)+108>>2];c[(c[j>>2]|0)+4>>2]=c[k>>2];c[(c[j>>2]|0)+8>>2]=e[(c[k>>2]|0)+56>>1];c[(c[j>>2]|0)+12>>2]=c[(c[k>>2]|0)+8>>2];if(c[(c[k>>2]|0)+36>>2]|0)c[(c[j>>2]|0)+16>>2]=c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2];a=(c[j>>2]|0)+32|0;c[a>>2]=c[a>>2]|32;c[(c[f>>2]|0)+168>>2]=0;if(c[(c[k>>2]|0)+44>>2]|0){c[g>>2]=c[(c[k>>2]|0)+44>>2];do{if(c[(c[g>>2]|0)+36>>2]|0)c[m>>2]=c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2];else c[m>>2]=0;a=c[f>>2]|0;p=c[g>>2]|0;q=c[(c[j>>2]|0)+8>>2]|0;r=c[(c[g>>2]|0)+8>>2]|0;s=c[m>>2]|0;c[h>>2]=vD(a,p,q,r,s,0,_h(c[(c[g>>2]|0)+32>>2]|0,c[(c[g>>2]|0)+12>>2]|0,1)|0,1)|0;if((c[h>>2]|0)==-1){o=20;break a}c[g>>2]=c[(c[g>>2]|0)+24>>2]}while((c[g>>2]|0)!=0)}c[h>>2]=wD(c[f>>2]|0)|0;if(c[h>>2]|0)if((c[h>>2]|0)==-1){o=24;break a}else break;if((c[(c[f>>2]|0)+176>>2]|0)!=-1?(c[(c[f>>2]|0)+96>>2]|0)>=(c[(c[f>>2]|0)+176>>2]|0):0)break}else{if((c[(c[k>>2]|0)+4>>2]|0)!=3?(c[(c[k>>2]|0)+4>>2]|0)!=4:0){if((c[(c[k>>2]|0)+4>>2]|0)==6){o=36;break a}if((c[(c[k>>2]|0)+4>>2]|0)==5){o=36;break a}else break}if((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+32>>2]&32|0)!=0:0){s=(c[j>>2]|0)+32|0;c[s>>2]=c[s>>2]^32}c[h>>2]=yD(c[f>>2]|0,c[(c[k>>2]|0)+4>>2]|0,c[(c[k>>2]|0)+40>>2]|0,-1,1,0)|0;if((c[h>>2]|0)<0){o=33;break a}}if(c[(c[k>>2]|0)+12>>2]|0){c[k>>2]=c[(c[k>>2]|0)+12>>2];continue a}}while(0);while(1){if((o|0)==45){o=0;t=c[k>>2]|0;if(c[(c[k>>2]|0)+24>>2]|0)break;c[k>>2]=c[t+20>>2]}if((c[(c[k>>2]|0)+4>>2]|0)!=1){o=45;continue}u=c[f>>2]|0;if((c[k>>2]|0)!=(c[(c[(c[f>>2]|0)+108>>2]|0)+4>>2]|0)){o=41;break a}c[h>>2]=xD(u)|0;if((c[h>>2]|0)!=0&(c[h>>2]|0)<0){o=43;break a}if((c[k>>2]|0)==(c[l>>2]|0)){o=48;break a}else o=45}c[k>>2]=c[t+24>>2]}if((o|0)==20)xB(c[f>>2]|0,155912,144696);else if((o|0)==24)xB(c[f>>2]|0,155912,144744);else if((o|0)==33)xB(c[f>>2]|0,155936,141336);else if((o|0)==36)xB(c[f>>2]|0,155936,155960);else if((o|0)==41)xB(u,155936,156168);else if((o|0)==43)xB(c[f>>2]|0,155936,141688);else if((o|0)==48){c[d>>2]=c[h>>2];n=c[d>>2]|0;i=b;return n|0}c[d>>2]=-1;n=c[d>>2]|0;i=b;return n|0}function uD(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;a=cF(c[e>>2]|0)|0;c[(c[e>>2]|0)+108>>2]=a;a=c[e>>2]|0;if(!(c[(c[e>>2]|0)+108>>2]|0)){xB(a,155592,155624);c[d>>2]=-1;f=c[d>>2]|0;i=b;return f|0}else{c[a+168>>2]=0;c[d>>2]=0;f=c[d>>2]|0;i=b;return f|0}return 0}function vD(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;i=i+48|0;l=k+36|0;m=k+32|0;n=k+28|0;o=k+24|0;p=k+20|0;q=k+16|0;r=k+12|0;s=k+8|0;t=k+4|0;u=k;c[m>>2]=a;c[n>>2]=b;c[o>>2]=d;c[p>>2]=e;c[q>>2]=f;c[r>>2]=g;c[s>>2]=h;c[t>>2]=j;c[u>>2]=dF(c[m>>2]|0)|0;if(!(c[u>>2]|0)){xB(c[m>>2]|0,155408,145304);c[l>>2]=-1;v=c[l>>2]|0;i=k;return v|0}c[(c[u>>2]|0)+4>>2]=c[n>>2];c[(c[u>>2]|0)+8>>2]=c[o>>2];c[(c[u>>2]|0)+44>>2]=1;c[(c[u>>2]|0)+12>>2]=c[p>>2];c[(c[u>>2]|0)+16>>2]=c[q>>2];if(c[r>>2]|0){r=(c[u>>2]|0)+32|0;c[r>>2]=c[r>>2]|1}do if(c[q>>2]|0){if(qy(c[p>>2]|0,155432)|0){if(!(qy(c[(c[u>>2]|0)+16>>2]|0,c[38860]|0)|0))break;c[(c[u>>2]|0)+48>>2]=2;break}if(qy(c[p>>2]|0,155448)|0){if(!(qy(c[(c[u>>2]|0)+16>>2]|0,c[38860]|0)|0))break;c[(c[u>>2]|0)+48>>2]=1;break}if(qy(c[p>>2]|0,155456)|0){if(!(qy(c[(c[u>>2]|0)+16>>2]|0,c[38860]|0)|0))break;c[(c[u>>2]|0)+48>>2]=3;break}r=(qy(c[p>>2]|0,155472)|0)!=0;o=c[(c[u>>2]|0)+16>>2]|0;if(r){if(!(qy(o,c[38860]|0)|0))break;c[(c[u>>2]|0)+48>>2]=4;break}else{if(!(qy(o,c[38876]|0)|0))break;c[(c[u>>2]|0)+48>>2]=5;break}}while(0);c[(c[u>>2]|0)+20>>2]=c[s>>2];if(c[t>>2]|0){t=(c[u>>2]|0)+32|0;c[t>>2]=c[t>>2]|2}if(c[(c[u>>2]|0)+48>>2]|0)c[(c[u>>2]|0)+44>>2]=17;c[l>>2]=0;v=c[l>>2]|0;i=k;return v|0}function wD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;c[f>>2]=0;if((c[(c[e>>2]|0)+176>>2]|0)!=-1?(c[(c[e>>2]|0)+96>>2]|0)>=(c[(c[e>>2]|0)+176>>2]|0):0)xB(c[e>>2]|0,144776,144800);else h=4;a:do if((h|0)==4){do if(c[(c[e>>2]|0)+92>>2]|0){c[f>>2]=eF(c[e>>2]|0)|0;if(!(c[f>>2]|0)){Wj(c[(c[(c[e>>2]|0)+20>>2]|0)+48>>2]|0,357,c[e>>2]|0);break}if((c[f>>2]|0)==-1)break a;c[(c[e>>2]|0)+176>>2]=0;c[d>>2]=c[f>>2];j=c[d>>2]|0;i=b;return j|0}while(0);a=c[e>>2]|0;do if((c[(c[e>>2]|0)+96>>2]|0)>0){c[f>>2]=fF(a)|0;if(c[f>>2]|0){if((c[f>>2]|0)>=0)break;xB(c[e>>2]|0,144776,144816);break a}if((c[(c[e>>2]|0)+96>>2]|0)!=(c[(c[e>>2]|0)+176>>2]|0))if((c[(c[(c[e>>2]|0)+108>>2]|0)+44>>2]|0)==0?(c[(c[(c[e>>2]|0)+108>>2]|0)+28>>2]|0)==0:0){xB(c[e>>2]|0,144776,144864);break a}else h=19}else{k=yE(c[a+20>>2]|0,c[(c[(c[e>>2]|0)+108>>2]|0)+12>>2]|0,c[(c[(c[e>>2]|0)+108>>2]|0)+16>>2]|0)|0;c[(c[(c[e>>2]|0)+108>>2]|0)+44>>2]=k;if(!(c[(c[(c[e>>2]|0)+108>>2]|0)+44>>2]|0)){c[f>>2]=1845;AB(c[e>>2]|0,c[f>>2]|0,0,0,144944,0,0)}else h=19}while(0);b:do if((h|0)==19){do if(c[(c[(c[e>>2]|0)+108>>2]|0)+44>>2]|0){if((c[c[(c[(c[e>>2]|0)+108>>2]|0)+44>>2]>>2]|0)==2){c[f>>2]=gF(c[e>>2]|0,g)|0;if(c[f>>2]|0){if((c[f>>2]|0)>=0)break b;xB(c[e>>2]|0,144776,145016);break a}a=c[e>>2]|0;if(c[g>>2]|0){c[(c[e>>2]|0)+176>>2]=c[a+96>>2];break b}if((c[c[(c[a+108>>2]|0)+44>>2]>>2]|0)!=14){c[(c[(c[e>>2]|0)+108>>2]|0)+44>>2]=0;break}}c[f>>2]=hF(c[e>>2]|0)|0;if(c[f>>2]|0){if((c[f>>2]|0)>=0)break b;xB(c[e>>2]|0,144776,145056);break a}}while(0);a=c[(c[e>>2]|0)+108>>2]|0;if(!(c[(c[(c[e>>2]|0)+108>>2]|0)+28>>2]|0)){k=a+32|0;c[k>>2]=c[k>>2]|1024;c[f>>2]=1875;AB(c[e>>2]|0,c[f>>2]|0,0,0,145096,0,0);break}k=c[e>>2]|0;if(c[(c[a+28>>2]|0)+48>>2]&1048576){a=(c[k+108>>2]|0)+32|0;c[a>>2]=c[a>>2]|1024;c[f>>2]=1876;AB(c[e>>2]|0,c[f>>2]|0,0,0,145128,0,0);break}if((c[k+116>>2]|0)!=0?(c[f>>2]=iF(c[e>>2]|0,1)|0,c[(c[(c[e>>2]|0)+108>>2]|0)+80>>2]=1,(c[f>>2]|0)==-1):0){xB(c[e>>2]|0,144776,145160);break a}if((c[c[(c[(c[e>>2]|0)+108>>2]|0)+28>>2]>>2]|0)!=5?(c[(c[(c[(c[e>>2]|0)+108>>2]|0)+28>>2]|0)+88>>2]|0)!=45:0){if(c[(c[e>>2]|0)+168>>2]|0)c[f>>2]=kF(c[e>>2]|0)|0}else h=40;do if((h|0)==40){if((c[(c[e>>2]|0)+168>>2]|0)==0?(c[(c[(c[(c[e>>2]|0)+108>>2]|0)+28>>2]|0)+116>>2]|0)==0:0)break;c[f>>2]=jF(c[e>>2]|0)|0}while(0);if(c[(c[e>>2]|0)+168>>2]|0)vB(c[e>>2]|0);if((c[f>>2]|0)==-1){xB(c[e>>2]|0,144776,145200);break a}else{c[f>>2]=0;break}}while(0);if(c[f>>2]|0)c[(c[e>>2]|0)+176>>2]=c[(c[e>>2]|0)+96>>2];c[d>>2]=c[f>>2];j=c[d>>2]|0;i=b;return j|0}while(0);c[d>>2]=-1;j=c[d>>2]|0;i=b;return j|0}function xD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;d=b+76|0;e=b+72|0;f=b+68|0;g=b+64|0;h=b+24|0;j=b+20|0;k=b+16|0;l=b+12|0;m=b+8|0;n=b+4|0;o=b;c[e>>2]=a;c[f>>2]=0;c[g>>2]=c[(c[e>>2]|0)+108>>2];if(c[(c[e>>2]|0)+168>>2]|0)vB(c[e>>2]|0);a:do if(!(c[(c[g>>2]|0)+32>>2]&512))if((c[(c[g>>2]|0)+28>>2]|0)!=0?(c[(c[g>>2]|0)+32>>2]&1024|0)==0:0){if((c[(c[(c[g>>2]|0)+28>>2]|0)+52>>2]|0)!=3?(c[(c[(c[g>>2]|0)+28>>2]|0)+52>>2]|0)!=2:0)p=21;else p=9;b:do if((p|0)==9?(c[(c[(c[g>>2]|0)+28>>2]|0)+88>>2]|0)!=45:0)if(!(c[(c[g>>2]|0)+32>>2]&256)){c[k>>2]=10;if((c[(c[g>>2]|0)+60>>2]|0)==0?(a=oz(c[(c[(c[g>>2]|0)+28>>2]|0)+108>>2]|0,358,c[e>>2]|0)|0,c[(c[g>>2]|0)+60>>2]=a,(c[(c[g>>2]|0)+60>>2]|0)==0):0){xB(c[e>>2]|0,141728,141760);break a}if(c[(c[g>>2]|0)+32>>2]&4){c[f>>2]=0;p=21;break}sz(c[(c[g>>2]|0)+60>>2]|0,k,l,h,j)|0;c[f>>2]=qz(c[(c[g>>2]|0)+60>>2]|0,0,0)|0;do if((c[f>>2]|0)>=0){if((c[f>>2]|0)==0?(c[(c[g>>2]|0)+32>>2]&4|0)==0:0)break;c[f>>2]=0;p=21;break b}while(0);c[f>>2]=1;a=(c[g>>2]|0)+32|0;c[a>>2]=c[a>>2]|256;mF(c[e>>2]|0,1871,0,0,141800,c[k>>2]|0,c[l>>2]|0,h);p=21}else p=21;while(0);if((p|0)==21?(c[(c[(c[g>>2]|0)+28>>2]|0)+52>>2]|0)==2:0){p=81;break}if(c[(c[e>>2]|0)+72>>2]|0){PH(c[(c[e>>2]|0)+72>>2]|0);c[(c[e>>2]|0)+72>>2]=0}a=c[g>>2]|0;if(!(c[(c[g>>2]|0)+44>>2]|0)){do if((c[c[a+28>>2]>>2]|0)==4)p=28;else{if((c[c[(c[g>>2]|0)+28>>2]>>2]|0)==1?(c[(c[(c[g>>2]|0)+28>>2]|0)+88>>2]|0)!=45:0){p=28;break}if((c[(c[(c[g>>2]|0)+28>>2]|0)+52>>2]|0)!=4?(c[(c[(c[g>>2]|0)+28>>2]|0)+52>>2]|0)!=6:0)break;c[f>>2]=nF(c[e>>2]|0,c[g>>2]|0,c[(c[(c[g>>2]|0)+28>>2]|0)+104>>2]|0,c[(c[g>>2]|0)+20>>2]|0)|0}while(0);if((p|0)==28)c[f>>2]=nF(c[e>>2]|0,c[g>>2]|0,c[(c[g>>2]|0)+28>>2]|0,c[(c[g>>2]|0)+20>>2]|0)|0;if((c[f>>2]|0)>=0){p=81;break}xB(c[e>>2]|0,141728,141832);break}if(((c[(c[a+44>>2]|0)+76>>2]|0)!=0?(c[(c[g>>2]|0)+32>>2]&32|0)!=0:0)?(c[(c[g>>2]|0)+32>>2]&4|0)==0:0){if(c[(c[g>>2]|0)+32>>2]&8){c[f>>2]=oF(c[e>>2]|0,c[(c[(c[g>>2]|0)+44>>2]|0)+76>>2]|0,(c[g>>2]|0)+24|0)|0;if(c[f>>2]|0){if((c[f>>2]|0)>=0){p=81;break}xB(c[e>>2]|0,141728,141872);break}}else{do if((c[c[(c[g>>2]|0)+28>>2]>>2]|0)==4)p=44;else{if((c[c[(c[g>>2]|0)+28>>2]>>2]|0)==1?(c[(c[(c[g>>2]|0)+28>>2]|0)+88>>2]|0)!=45:0){p=44;break}if((c[(c[(c[g>>2]|0)+28>>2]|0)+52>>2]|0)!=4?(c[(c[(c[g>>2]|0)+28>>2]|0)+52>>2]|0)!=6:0)break;c[f>>2]=nF(c[e>>2]|0,c[g>>2]|0,c[(c[(c[g>>2]|0)+28>>2]|0)+104>>2]|0,c[(c[(c[g>>2]|0)+44>>2]|0)+76>>2]|0)|0}while(0);if((p|0)==44)c[f>>2]=nF(c[e>>2]|0,c[g>>2]|0,c[(c[g>>2]|0)+28>>2]|0,c[(c[(c[g>>2]|0)+44>>2]|0)+76>>2]|0)|0;if(c[f>>2]|0){if((c[f>>2]|0)>=0){p=81;break}xB(c[e>>2]|0,141728,141832);break}}if(!(c[(c[e>>2]|0)+80>>2]&1)){p=81;break}if(!(c[(c[g>>2]|0)+4>>2]|0)){p=81;break}c[n>>2]=zC(c[(c[g>>2]|0)+28>>2]|0,c[(c[(c[g>>2]|0)+44>>2]|0)+76>>2]|0)|0;if(c[n>>2]|0){c[m>>2]=li(c[n>>2]|0)|0;zb[c[135736>>2]&511](c[n>>2]|0)}else c[m>>2]=li(c[(c[(c[g>>2]|0)+44>>2]|0)+76>>2]|0)|0;if(!(c[m>>2]|0)){xB(c[e>>2]|0,141728,141912);break}else{zi(c[(c[g>>2]|0)+4>>2]|0,c[m>>2]|0)|0;p=81;break}}if(!(c[(c[g>>2]|0)+32>>2]&4)){do if((c[c[(c[g>>2]|0)+28>>2]>>2]|0)==4)p=63;else{if((c[c[(c[g>>2]|0)+28>>2]>>2]|0)==1?(c[(c[(c[g>>2]|0)+28>>2]|0)+88>>2]|0)!=45:0){p=63;break}if((c[(c[(c[g>>2]|0)+28>>2]|0)+52>>2]|0)!=4?(c[(c[(c[g>>2]|0)+28>>2]|0)+52>>2]|0)!=6:0)break;c[f>>2]=nF(c[e>>2]|0,c[g>>2]|0,c[(c[(c[g>>2]|0)+28>>2]|0)+104>>2]|0,c[(c[g>>2]|0)+20>>2]|0)|0}while(0);if((p|0)==63)c[f>>2]=nF(c[e>>2]|0,c[g>>2]|0,c[(c[g>>2]|0)+28>>2]|0,c[(c[g>>2]|0)+20>>2]|0)|0;if(c[f>>2]|0){if((c[f>>2]|0)>=0){p=81;break}xB(c[e>>2]|0,141728,141832);break}if((c[(c[(c[g>>2]|0)+44>>2]|0)+76>>2]|0)!=0?(c[(c[(c[g>>2]|0)+44>>2]|0)+48>>2]&8|0)!=0:0){if(c[(c[g>>2]|0)+32>>2]&128){c[f>>2]=1856;AB(c[e>>2]|0,c[f>>2]|0,0,0,141936,0,0);p=81;break}a=c[g>>2]|0;if((c[(c[(c[g>>2]|0)+28>>2]|0)+52>>2]|0)==3){if(qy(c[a+20>>2]|0,c[(c[(c[g>>2]|0)+44>>2]|0)+76>>2]|0)|0){p=81;break}c[f>>2]=1857;AB(c[e>>2]|0,c[f>>2]|0,0,0,142024,c[(c[g>>2]|0)+20>>2]|0,c[(c[(c[g>>2]|0)+44>>2]|0)+76>>2]|0);p=81;break}if((c[(c[a+28>>2]|0)+52>>2]|0)!=4?(c[(c[(c[g>>2]|0)+28>>2]|0)+52>>2]|0)!=6:0){p=81;break}if(!(qy(c[(c[g>>2]|0)+20>>2]|0,c[(c[(c[g>>2]|0)+44>>2]|0)+76>>2]|0)|0)){c[f>>2]=1858;AB(c[e>>2]|0,c[f>>2]|0,0,0,142096,c[(c[g>>2]|0)+20>>2]|0,c[(c[(c[g>>2]|0)+44>>2]|0)+76>>2]|0);p=81}else p=81}else p=81}else p=81}else p=81;else{c[(c[e>>2]|0)+176>>2]=(c[(c[e>>2]|0)+96>>2]|0)-1;p=81}while(0);c:do if((p|0)==81){if((c[(c[e>>2]|0)+96>>2]|0)<0){c[d>>2]=0;q=c[d>>2]|0;i=b;return q|0}if((c[(c[e>>2]|0)+96>>2]|0)==(c[(c[e>>2]|0)+176>>2]|0))c[(c[e>>2]|0)+176>>2]=-1;if((c[(c[g>>2]|0)+80>>2]|0)!=0?(pF(c[e>>2]|0,c[(c[e>>2]|0)+96>>2]|0)|0)==-1:0)break;do if(c[(c[g>>2]|0)+56>>2]|0){if((c[(c[e>>2]|0)+184>>2]|0)==0?(c[(c[e>>2]|0)+188>>2]|0)==0:0)break;if((qF(c[e>>2]|0,c[g>>2]|0)|0)==-1)break c}while(0);if((c[(c[(c[e>>2]|0)+108>>2]|0)+76>>2]|0)!=0?(rF(c[e>>2]|0)|0)==-1:0)break;do if((c[(c[g>>2]|0)+52>>2]|0)!=0?(c[(c[e>>2]|0)+96>>2]|0)>0:0){if((c[(c[e>>2]|0)+184>>2]|0)==0?(c[(c[e>>2]|0)+188>>2]|0)==0:0)break;if((sF(c[e>>2]|0)|0)==-1)break c}while(0);wB(c[e>>2]|0,c[g>>2]|0);m=c[e>>2]|0;if(!(c[(c[e>>2]|0)+96>>2]|0)){n=m+96|0;c[n>>2]=(c[n>>2]|0)+-1;c[(c[e>>2]|0)+108>>2]=0;c[d>>2]=0;q=c[d>>2]|0;i=b;return q|0}if(c[m+112>>2]|0){c[o>>2]=c[(c[e>>2]|0)+112>>2];do{if((c[(c[o>>2]|0)+8>>2]|0)==(c[(c[e>>2]|0)+96>>2]|0))c[(c[o>>2]|0)+8>>2]=-1;c[o>>2]=c[c[o>>2]>>2]}while((c[o>>2]|0)!=0)}m=(c[e>>2]|0)+96|0;c[m>>2]=(c[m>>2]|0)+-1;c[(c[e>>2]|0)+108>>2]=c[(c[(c[e>>2]|0)+100>>2]|0)+(c[(c[e>>2]|0)+96>>2]<<2)>>2];c[d>>2]=c[f>>2];q=c[d>>2]|0;i=b;return q|0}while(0);c[(c[e>>2]|0)+52>>2]=-1;c[d>>2]=-1;q=c[d>>2]|0;i=b;return q|0}function yD(a,b,e,f,g,h){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+32|0;k=j+24|0;l=j+20|0;m=j+16|0;n=j+12|0;o=j+8|0;p=j+4|0;q=j;c[l>>2]=a;c[m>>2]=b;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=h;if(c[q>>2]|0)c[c[q>>2]>>2]=0;h=c[l>>2]|0;if(c[(c[(c[l>>2]|0)+108>>2]|0)+32>>2]&4){AB(h,1848,0,0,141368,0,0);c[k>>2]=c[(c[l>>2]|0)+52>>2];r=c[k>>2]|0;i=j;return r|0}g=c[l>>2]|0;if((c[(c[(c[h+108>>2]|0)+28>>2]|0)+52>>2]|0)==1){AB(g,1841,0,0,141456,0,0);c[k>>2]=c[(c[l>>2]|0)+52>>2];r=c[k>>2]|0;i=j;return r|0}if((c[(c[(c[g+108>>2]|0)+28>>2]|0)+52>>2]|0)==2){if((c[m>>2]|0)==3?(aE(c[n>>2]|0,c[o>>2]|0)|0)!=0:0){c[k>>2]=0;r=c[k>>2]|0;i=j;return r|0}AB(c[l>>2]|0,1843,0,0,141528,0,0);c[k>>2]=c[(c[l>>2]|0)+52>>2];r=c[k>>2]|0;i=j;return r|0}if((c[n>>2]|0)!=0?(d[c[n>>2]>>0]|0|0)!=0:0){do if((c[(c[(c[(c[l>>2]|0)+108>>2]|0)+28>>2]|0)+52>>2]|0)==3){if((c[(c[(c[l>>2]|0)+108>>2]|0)+44>>2]|0)!=0?(c[(c[(c[(c[l>>2]|0)+108>>2]|0)+44>>2]|0)+76>>2]|0)!=0:0)break;c[k>>2]=0;r=c[k>>2]|0;i=j;return r|0}while(0);do if(!(c[(c[(c[l>>2]|0)+108>>2]|0)+20>>2]|0)){m=c[p>>2]|0;if((m|0)==1){c[(c[(c[l>>2]|0)+108>>2]|0)+20>>2]=c[n>>2];break}else if((m|0)==2){c[(c[(c[l>>2]|0)+108>>2]|0)+20>>2]=c[n>>2];if(c[q>>2]|0)c[c[q>>2]>>2]=1;g=(c[(c[l>>2]|0)+108>>2]|0)+32|0;c[g>>2]=c[g>>2]|2;break}else if((m|0)==3){m=c[n>>2]|0;if((c[o>>2]|0)!=-1){g=ly(m,c[o>>2]|0)|0;c[(c[(c[l>>2]|0)+108>>2]|0)+20>>2]=g}else{g=my(m)|0;c[(c[(c[l>>2]|0)+108>>2]|0)+20>>2]=g}g=(c[(c[l>>2]|0)+108>>2]|0)+32|0;c[g>>2]=c[g>>2]|2;break}else break}else{if((c[o>>2]|0)<0)c[o>>2]=xy(c[n>>2]|0)|0;g=c[(c[(c[l>>2]|0)+108>>2]|0)+20>>2]|0;m=c[n>>2]|0;h=c[o>>2]|0;if(c[(c[(c[l>>2]|0)+108>>2]|0)+32>>2]&2){f=zy(g,m,h)|0;c[(c[(c[l>>2]|0)+108>>2]|0)+20>>2]=f;break}else{f=Ay(g,m,h)|0;c[(c[(c[l>>2]|0)+108>>2]|0)+20>>2]=f;f=(c[(c[l>>2]|0)+108>>2]|0)+32|0;c[f>>2]=c[f>>2]|2;break}}while(0);c[k>>2]=0;r=c[k>>2]|0;i=j;return r|0}c[k>>2]=0;r=c[k>>2]|0;i=j;return r|0}function zD(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;do if(!(c[(c[e>>2]|0)+88>>2]|0)){if(c[(c[e>>2]|0)+20>>2]|0){a=tF(140432,c[(c[(c[e>>2]|0)+20>>2]|0)+60>>2]|0)|0;c[(c[e>>2]|0)+88>>2]=a}else{a=XA(140432)|0;c[(c[e>>2]|0)+88>>2]=a}a=c[e>>2]|0;if(c[(c[e>>2]|0)+88>>2]|0){aB(c[a+88>>2]|0,c[(c[e>>2]|0)+8>>2]|0,c[(c[e>>2]|0)+12>>2]|0,c[(c[e>>2]|0)+4>>2]|0);cB(c[(c[e>>2]|0)+88>>2]|0,c[(c[e>>2]|0)+16>>2]|0,c[(c[e>>2]|0)+4>>2]|0);break}xB(a,141232,141264);c[d>>2]=-1;f=c[d>>2]|0;i=b;return f|0}while(0);c[d>>2]=0;f=c[d>>2]|0;i=b;return f|0}function AD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if(!(c[(c[(c[e>>2]|0)+52>>2]|0)+76>>2]|0)){i=d;return}Wj(c[(c[(c[e>>2]|0)+52>>2]|0)+76>>2]|0,359,c[f>>2]|0);i=d;return}function BD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=b+32|0;e=b+28|0;f=b+24|0;g=b+20|0;h=b+16|0;j=b+12|0;k=b+8|0;l=b+4|0;m=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}c[(c[d>>2]|0)+152>>2]=0;c[(c[d>>2]|0)+84>>2]=0;c[(c[d>>2]|0)+24>>2]=0;c[(c[d>>2]|0)+160>>2]=0;c[(c[d>>2]|0)+184>>2]=0;if(c[(c[d>>2]|0)+72>>2]|0){PH(c[(c[d>>2]|0)+72>>2]|0);c[(c[d>>2]|0)+72>>2]=0}if(c[(c[d>>2]|0)+112>>2]|0){c[e>>2]=c[(c[d>>2]|0)+112>>2];do{c[f>>2]=c[c[e>>2]>>2];zb[c[135736>>2]&511](c[e>>2]|0);c[e>>2]=c[f>>2]}while((c[e>>2]|0)!=0);c[(c[d>>2]|0)+112>>2]=0}if(c[(c[d>>2]|0)+124>>2]|0){c[g>>2]=c[(c[d>>2]|0)+124>>2];while(1){if(!(c[g>>2]|0))break;c[h>>2]=c[g>>2];c[g>>2]=c[(c[g>>2]|0)+12>>2];vF(c[h>>2]|0)}c[(c[d>>2]|0)+124>>2]=0}if(c[(c[d>>2]|0)+128>>2]|0){c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[(c[d>>2]|0)+132>>2]|0))break;c[k>>2]=c[(c[(c[d>>2]|0)+128>>2]|0)+(c[j>>2]<<2)>>2];zb[c[135736>>2]&511](c[(c[k>>2]|0)+4>>2]|0);zb[c[135736>>2]&511](c[k>>2]|0);c[j>>2]=(c[j>>2]|0)+1}zb[c[135736>>2]&511](c[(c[d>>2]|0)+128>>2]|0);c[(c[d>>2]|0)+128>>2]=0;c[(c[d>>2]|0)+132>>2]=0;c[(c[d>>2]|0)+136>>2]=0}if(c[(c[d>>2]|0)+116>>2]|0){uB(c[(c[d>>2]|0)+116>>2]|0);c[(c[d>>2]|0)+116>>2]=0}if(c[(c[d>>2]|0)+168>>2]|0)vB(c[d>>2]|0);a:do if(c[(c[d>>2]|0)+100>>2]|0){
c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[(c[d>>2]|0)+104>>2]|0))break a;c[m>>2]=c[(c[(c[d>>2]|0)+100>>2]|0)+(c[l>>2]<<2)>>2];if(!(c[m>>2]|0))break a;wB(c[d>>2]|0,c[m>>2]|0);c[l>>2]=(c[l>>2]|0)+1}}while(0);wF(c[(c[d>>2]|0)+180>>2]|0);zP(c[(c[d>>2]|0)+156>>2]|0);l=xP()|0;c[(c[d>>2]|0)+156>>2]=l;if(!(c[(c[d>>2]|0)+48>>2]|0)){i=b;return}zb[c[135736>>2]&511](c[(c[d>>2]|0)+48>>2]|0);c[(c[d>>2]|0)+48>>2]=0;i=b;return}function CD(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+32>>2]|0)mB(c[(c[d>>2]|0)+32>>2]|0);if(c[(c[d>>2]|0)+68>>2]|0)PH(c[(c[d>>2]|0)+68>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function DD(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+4>>2]|0)mB(c[(c[d>>2]|0)+4>>2]|0);if(c[(c[d>>2]|0)+32>>2]|0)PH(c[(c[d>>2]|0)+32>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function ED(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function FD(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+24>>2]|0)mB(c[(c[d>>2]|0)+24>>2]|0);if(c[(c[d>>2]|0)+84>>2]|0)zz(c[(c[d>>2]|0)+84>>2]|0);if(c[(c[d>>2]|0)+96>>2]|0)PH(c[(c[d>>2]|0)+96>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function GD(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(c[(c[d>>2]|0)+4>>2]|0)mB(c[(c[d>>2]|0)+4>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function HD(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+24>>2]|0)mB(c[(c[d>>2]|0)+24>>2]|0);if(c[(c[d>>2]|0)+56>>2]|0)oB(c[(c[d>>2]|0)+56>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function ID(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(c[(c[d>>2]|0)+4>>2]|0)mB(c[(c[d>>2]|0)+4>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function JD(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+4>>2]|0)mB(c[(c[d>>2]|0)+4>>2]|0);if(c[(c[d>>2]|0)+24>>2]|0){if(c[(c[(c[d>>2]|0)+24>>2]|0)+16>>2]|0)EQ(c[(c[(c[d>>2]|0)+24>>2]|0)+16>>2]|0);zb[c[135736>>2]&511](c[(c[d>>2]|0)+24>>2]|0)}if(c[(c[d>>2]|0)+28>>2]|0){c[e>>2]=c[(c[d>>2]|0)+28>>2];do{c[f>>2]=c[e>>2];c[e>>2]=c[c[e>>2]>>2];if(c[(c[f>>2]|0)+16>>2]|0)EQ(c[(c[f>>2]|0)+16>>2]|0);zb[c[135736>>2]&511](c[f>>2]|0)}while((c[e>>2]|0)!=0)}zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function KD(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function LD(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function MD(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;a=c[e>>2]|0;do if((c[c[e>>2]>>2]|0)==1){if((c[a>>2]|0)!=5?(c[(c[e>>2]|0)+88>>2]|0)!=45:0){c[d>>2]=143688;break}c[d>>2]=143664}else c[d>>2]=xF(c[a>>2]|0)|0;while(0);i=b;return c[d>>2]|0}function ND(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;ce(16,3069,c[f>>2]|0,c[g>>2]|0,c[h>>2]|0);i=e;return}function OD(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(c[(c[d>>2]|0)+8>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+8>>2]|0);if(c[(c[d>>2]|0)+20>>2]|0)oB(c[(c[d>>2]|0)+20>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function PD(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+32|0;j=h+20|0;k=h+16|0;l=h+12|0;m=h+8|0;n=h+4|0;o=h;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;IC(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,0,0);i=h;return}function QD(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;a=c[e>>2]|0;do if((c[c[e>>2]>>2]|0)!=1){if(c[a+48>>2]&64){c[d>>2]=3;break}if(c[(c[e>>2]|0)+48>>2]&128){c[d>>2]=0;break}if(!(c[(c[e>>2]|0)+48>>2]&256)){c[d>>2]=-1;break}if(c[(c[e>>2]|0)+48>>2]&16777216){c[d>>2]=1;break}if(c[(c[e>>2]|0)+48>>2]&33554432){c[d>>2]=2;break}else{c[d>>2]=3;break}}else{if((c[a+88>>2]|0)!=1?(c[(c[e>>2]|0)+88>>2]|0)!=46:0)if((c[(c[e>>2]|0)+88>>2]|0)==2){c[d>>2]=2;break}else{c[d>>2]=3;break}c[d>>2]=1}while(0);i=b;return c[d>>2]|0}function RD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+48|0;e=d+32|0;f=d+28|0;g=d+24|0;h=d+20|0;j=d+16|0;k=d+12|0;l=d+8|0;m=d+4|0;n=d;c[f>>2]=a;c[g>>2]=b;b=c[f>>2]|0;if(c[(c[f>>2]|0)+36>>2]|0){c[h>>2]=c[b+96>>2];a:while(1){if((c[h>>2]|0)<0){o=14;break}b:do if(c[(c[(c[(c[f>>2]|0)+100>>2]|0)+(c[h>>2]<<2)>>2]|0)+68>>2]|0){c[k>>2]=c[(c[(c[f>>2]|0)+100>>2]|0)+(c[h>>2]<<2)>>2];c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[(c[k>>2]|0)+68>>2]<<1|0))break b;if((c[g>>2]|0)==0?(c[(c[(c[k>>2]|0)+64>>2]|0)+(c[j>>2]<<2)>>2]|0)==0:0){o=11;break a}if((c[g>>2]|0)!=0?(qy(c[g>>2]|0,c[(c[(c[k>>2]|0)+64>>2]|0)+(c[j>>2]<<2)>>2]|0)|0)!=0:0){o=11;break a}c[j>>2]=(c[j>>2]|0)+2}}while(0);c[h>>2]=(c[h>>2]|0)+-1}if((o|0)==11){c[e>>2]=c[(c[(c[k>>2]|0)+64>>2]|0)+((c[j>>2]|0)+1<<2)>>2];p=c[e>>2]|0;i=d;return p|0}else if((o|0)==14){c[e>>2]=0;p=c[e>>2]|0;i=d;return p|0}}else{o=c[f>>2]|0;if(c[b+160>>2]|0){c[l>>2]=WL(c[o+160>>2]|0,c[g>>2]|0)|0;if(c[l>>2]|0){c[m>>2]=AP(c[(c[f>>2]|0)+156>>2]|0,c[l>>2]|0,-1)|0;zb[c[135736>>2]&511](c[l>>2]|0);c[e>>2]=c[m>>2];p=c[e>>2]|0;i=d;return p|0}else{c[e>>2]=0;p=c[e>>2]|0;i=d;return p|0}}if((c[(c[o+108>>2]|0)+4>>2]|0)!=0?(c[(c[(c[(c[f>>2]|0)+108>>2]|0)+4>>2]|0)+32>>2]|0)!=0:0){c[n>>2]=cj(c[(c[(c[(c[f>>2]|0)+108>>2]|0)+4>>2]|0)+32>>2]|0,c[(c[(c[f>>2]|0)+108>>2]|0)+4>>2]|0,c[g>>2]|0)|0;if(c[n>>2]|0){c[e>>2]=c[(c[n>>2]|0)+8>>2];p=c[e>>2]|0;i=d;return p|0}else{c[e>>2]=0;p=c[e>>2]|0;i=d;return p|0}}xB(c[f>>2]|0,154192,154224);c[e>>2]=0;p=c[e>>2]|0;i=d;return p|0}return 0}function SD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=0;if((c[h>>2]|0)==0|(c[g>>2]|0)==0){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}do if(c[g>>2]|0){if((qy(c[j>>2]|0,c[(c[g>>2]|0)+4>>2]|0)|0)!=0?(c[k>>2]=Rj(c[(c[g>>2]|0)+44>>2]|0,c[h>>2]|0)|0,(c[k>>2]|0)!=0):0)break;if(($j(c[(c[g>>2]|0)+48>>2]|0)|0)>1){d=c[(c[g>>2]|0)+48>>2]|0;if(!(c[j>>2]|0))c[l>>2]=Rj(d,145792)|0;else c[l>>2]=Rj(d,c[j>>2]|0)|0;if(c[l>>2]|0)c[k>>2]=Rj(c[(c[(c[l>>2]|0)+52>>2]|0)+44>>2]|0,c[h>>2]|0)|0}}while(0);c[f>>2]=c[k>>2];m=c[f>>2]|0;i=e;return m|0}function TD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;while(1){if(!(c[e>>2]|0)){f=7;break}if((c[(c[e>>2]|0)+88>>2]|0)==46){f=5;break}if(c[(c[e>>2]|0)+48>>2]&16384){f=5;break}c[e>>2]=c[(c[e>>2]|0)+64>>2]}if((f|0)==5){c[d>>2]=c[e>>2];g=c[d>>2]|0;i=b;return g|0}else if((f|0)==7){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}return 0}function UD(a,b,d,e,f,g,h,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;m=i;i=i+112|0;n=m;o=m+56|0;p=m+52|0;q=m+48|0;r=m+44|0;s=m+40|0;t=m+36|0;u=m+32|0;v=m+28|0;w=m+24|0;x=m+20|0;y=m+16|0;z=m+12|0;A=m+8|0;B=m+4|0;C=m+85|0;D=m+60|0;c[o>>2]=a;c[p>>2]=b;c[q>>2]=d;c[r>>2]=e;c[s>>2]=f;c[t>>2]=g;c[u>>2]=h;c[v>>2]=j;c[w>>2]=k;c[x>>2]=l;c[y>>2]=0;c[z>>2]=0;c[B>>2]=WD(c[o>>2]|0,c[q>>2]|0)|0;HC(z,c[o>>2]|0,c[q>>2]|0)|0;if((c[p>>2]|0)==1840)c[A>>2]=1007;else c[A>>2]=c[c[u>>2]>>2];c[z>>2]=By(c[z>>2]|0,142560)|0;c[z>>2]=By(c[z>>2]|0,148120)|0;l=c[z>>2]|0;c[z>>2]=By(l,zB(c[A>>2]|0)|0)|0;c[z>>2]=By(c[z>>2]|0,156768)|0;do if(!(c[v>>2]|0)){if((c[A>>2]|0)==1009|(c[A>>2]|0)==1011|(c[A>>2]|0)==1010){l=c[z>>2]|0;if((c[B>>2]|0)==2)c[z>>2]=By(l,156776)|0;else c[z>>2]=By(l,156816)|0;c[n>>2]=ZH(c[u>>2]|0)|0;JT(C,24,156856,n)|0;c[n>>2]=c[s>>2];JT(D,24,156856,n)|0;do if((c[A>>2]|0)!=1009){if((c[A>>2]|0)==1010){c[z>>2]=By(c[z>>2]|0,156912)|0;break}if((c[A>>2]|0)==1011)c[z>>2]=By(c[z>>2]|0,156968)|0}else c[z>>2]=By(c[z>>2]|0,156864)|0;while(0);l=c[o>>2]|0;k=c[p>>2]|0;j=c[q>>2]|0;h=c[z>>2]|0;if((c[B>>2]|0)==2){yF(l,k,j,h,c[r>>2]|0,D,C);break}else{PD(l,k,j,h,D,C);break}}if((c[A>>2]|0)==1007){c[z>>2]=By(c[z>>2]|0,157024)|0;h=c[o>>2]|0;j=c[p>>2]|0;k=c[q>>2]|0;l=c[z>>2]|0;g=c[r>>2]|0;PD(h,j,k,l,g,zF(c[o>>2]|0,y,c[t>>2]|0)|0);break}if((c[A>>2]|0)==1006){c[z>>2]=By(c[z>>2]|0,157080)|0;PD(c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[z>>2]|0,c[r>>2]|0,c[(c[u>>2]|0)+8>>2]|0);break}if((c[A>>2]|0)==1e3){c[z>>2]=By(c[z>>2]|0,157136)|0;PD(c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[z>>2]|0,c[r>>2]|0,c[(c[u>>2]|0)+8>>2]|0);break}if((c[A>>2]|0)==1002){c[z>>2]=By(c[z>>2]|0,157200)|0;PD(c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[z>>2]|0,c[r>>2]|0,c[(c[u>>2]|0)+8>>2]|0);break}if((c[A>>2]|0)==1001){c[z>>2]=By(c[z>>2]|0,157272)|0;PD(c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[z>>2]|0,c[r>>2]|0,c[(c[u>>2]|0)+8>>2]|0);break}if((c[A>>2]|0)==1003){c[z>>2]=By(c[z>>2]|0,157320)|0;PD(c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[z>>2]|0,c[r>>2]|0,c[(c[u>>2]|0)+8>>2]|0);break}if((c[A>>2]|0)==1004){c[z>>2]=By(c[z>>2]|0,157360)|0;PD(c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[z>>2]|0,c[r>>2]|0,c[(c[u>>2]|0)+8>>2]|0);break}if((c[A>>2]|0)==1005){c[z>>2]=By(c[z>>2]|0,157424)|0;PD(c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[z>>2]|0,c[r>>2]|0,c[(c[u>>2]|0)+8>>2]|0);break}g=c[z>>2]|0;if((c[B>>2]|0)==2){c[z>>2]=By(g,157496)|0;PD(c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[z>>2]|0,c[r>>2]|0,0);break}else{c[z>>2]=By(g,157536)|0;PD(c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[z>>2]|0,0,0);break}}else{c[z>>2]=By(c[z>>2]|0,c[v>>2]|0)|0;c[z>>2]=By(c[z>>2]|0,142704)|0;PD(c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[z>>2]|0,c[w>>2]|0,c[x>>2]|0)}while(0);if(!(c[y>>2]|0)){E=c[33934]|0;F=c[z>>2]|0;zb[E&511](F);i=m;return}zb[c[135736>>2]&511](c[y>>2]|0);c[y>>2]=0;E=c[33934]|0;F=c[z>>2]|0;zb[E&511](F);i=m;return}function VD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d+28|0;f=d+24|0;g=d+20|0;h=d+16|0;j=d+12|0;k=d+8|0;l=d+4|0;m=d;c[f>>2]=a;c[g>>2]=b;a:while(1){if(!(c[f>>2]|0)){n=20;break}c[h>>2]=IH(dI(c[f>>2]|0)|0)|0;c[j>>2]=IH(dI(c[g>>2]|0)|0)|0;c[k>>2]=TD(c[h>>2]|0)|0;c[l>>2]=TD(c[j>>2]|0)|0;if((c[k>>2]|0)!=(c[l>>2]|0)){n=4;break}do if((c[(c[k>>2]|0)+88>>2]|0)!=1){if((c[c[k>>2]>>2]|0)==1?(c[(c[k>>2]|0)+88>>2]|0)==46:0){n=8;break}c[m>>2]=YH(c[f>>2]|0,1,c[g>>2]|0,1)|0;if((c[m>>2]|0)==-2){n=11;break a}if(c[m>>2]|0){n=13;break a}}else n=8;while(0);if((n|0)==8?(n=0,b=LH(c[f>>2]|0)|0,(qy(b,LH(c[g>>2]|0)|0)|0)==0):0){n=9;break}c[f>>2]=KH(c[f>>2]|0)|0;b=(c[f>>2]|0)!=0;o=KH(c[g>>2]|0)|0;if(!b){n=17;break}c[g>>2]=o;if(!(c[g>>2]|0)){n=16;break}}do if((n|0)==4)c[e>>2]=0;else if((n|0)==9)c[e>>2]=0;else if((n|0)==11)c[e>>2]=-1;else if((n|0)==13)c[e>>2]=0;else if((n|0)==16)c[e>>2]=0;else if((n|0)==17)if(o){c[e>>2]=0;break}else{c[e>>2]=1;break}else if((n|0)==20)c[e>>2]=0;while(0);i=d;return c[e>>2]|0}function WD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if(c[g>>2]|0){c[e>>2]=c[(c[g>>2]|0)+4>>2];h=c[e>>2]|0;i=d;return h|0}if((c[c[f>>2]>>2]|0)==2?(c[(c[f>>2]|0)+108>>2]|0)!=0:0){c[e>>2]=c[c[(c[f>>2]|0)+108>>2]>>2];h=c[e>>2]|0;i=d;return h|0}c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}function XD(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;switch(c[c[e>>2]>>2]|0){case 15:{if(c[(c[e>>2]|0)+60>>2]&1)c[d>>2]=1;else f=10;break}case 17:{c[d>>2]=1;break}case 4:case 5:{if(c[(c[e>>2]|0)+48>>2]&8)c[d>>2]=1;else f=10;break}case 14:{if(c[(c[e>>2]|0)+48>>2]&2)c[d>>2]=1;else f=10;break}default:c[d>>2]=1}if((f|0)==10)c[d>>2]=0;i=b;return c[d>>2]|0}function YD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=c[e>>2]|0;e=AF(c[f>>2]|0)|0;a=BB(b,e,BF(c[f>>2]|0)|0)|0;i=d;return a|0}function ZD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=0;b=c[c[e>>2]>>2]|0;a=By(b,MD(c[f>>2]|0)|0)|0;c[c[e>>2]>>2]=a;a=By(c[c[e>>2]>>2]|0,143656)|0;c[c[e>>2]>>2]=a;a=c[c[e>>2]>>2]|0;b=By(a,YD(g,c[f>>2]|0)|0)|0;c[c[e>>2]>>2]=b;b=By(c[c[e>>2]>>2]|0,142568)|0;c[c[e>>2]>>2]=b;if(!(c[g>>2]|0)){h=c[e>>2]|0;j=c[h>>2]|0;i=d;return j|0}zb[c[135736>>2]&511](c[g>>2]|0);c[g>>2]=0;h=c[e>>2]|0;j=c[h>>2]|0;i=d;return j|0}function _D(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;a=c[e>>2]|0;if((a|0)==1)c[d>>2]=148168;else if((a|0)==2)c[d>>2]=148176;else if((a|0)==3)c[d>>2]=148184;else c[d>>2]=148192;i=b;return c[d>>2]|0}function $D(a,b,d,e,f,g,h,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;m=i;i=i+96|0;n=m;o=m+88|0;p=m+84|0;q=m+80|0;r=m+76|0;s=m+72|0;t=m+68|0;u=m+64|0;v=m+60|0;w=m+56|0;x=m+52|0;y=m+48|0;z=m+44|0;A=m+40|0;B=m+36|0;C=m+32|0;D=m+28|0;E=m+24|0;F=m+20|0;G=m+16|0;c[o>>2]=a;c[p>>2]=b;c[q>>2]=d;c[r>>2]=e;c[s>>2]=f;c[t>>2]=g;c[u>>2]=h;c[v>>2]=j;c[w>>2]=k;c[x>>2]=l;c[y>>2]=0;c[z>>2]=0;c[A>>2]=0;if(!(c[o>>2]|0)){i=m;return}l=c[o>>2]|0;if((c[c[o>>2]>>2]|0)!=2){if((c[l>>2]|0)!=1){k=c[33976]|0;j=c[33980]|0;c[n>>2]=140328;c[n+4>>2]=2125;Db[k&511](j,140296,n);i=m;return}c[G>>2]=c[o>>2];j=c[G>>2]|0;if((c[p>>2]|0)!=1){k=j+20|0;c[k>>2]=(c[k>>2]|0)+1;c[(c[G>>2]|0)+16>>2]=c[q>>2];c[z>>2]=c[(c[G>>2]|0)+8>>2]}else c[z>>2]=c[j+12>>2];c[y>>2]=c[(c[G>>2]|0)+24>>2];c[A>>2]=c[(c[G>>2]|0)+4>>2];G=c[y>>2]|0;j=c[z>>2]|0;k=c[A>>2]|0;h=c[o>>2]|0;g=c[r>>2]|0;f=c[q>>2]|0;e=c[p>>2]|0;d=c[u>>2]|0;b=c[v>>2]|0;a=c[w>>2]|0;H=c[t>>2]|0;I=c[v>>2]|0;J=c[w>>2]|0;K=c[x>>2]|0;c[n>>2]=c[u>>2];c[n+4>>2]=I;c[n+8>>2]=J;c[n+12>>2]=K;Xd(G,j,k,h,g,16,f,e,0,0,d,b,a,0,0,H,n);i=m;return}c[B>>2]=l;c[C>>2]=0;c[D>>2]=0;l=c[B>>2]|0;if((c[p>>2]|0)!=1){H=l+56|0;c[H>>2]=(c[H>>2]|0)+1;c[(c[B>>2]|0)+52>>2]=c[q>>2];c[z>>2]=c[(c[B>>2]|0)+8>>2]}else c[z>>2]=c[l+12>>2];c[y>>2]=c[(c[B>>2]|0)+16>>2];c[A>>2]=c[(c[B>>2]|0)+4>>2];do if(!(c[s>>2]|0)){if(((c[r>>2]|0)==0?(c[(c[B>>2]|0)+96>>2]|0)>=0:0)?(c[(c[B>>2]|0)+108>>2]|0)!=0:0)c[r>>2]=c[(c[(c[B>>2]|0)+108>>2]|0)+4>>2];if(((c[r>>2]|0)==0?(c[(c[B>>2]|0)+40>>2]|0)!=0:0)?(c[(c[(c[B>>2]|0)+40>>2]|0)+36>>2]|0)!=0:0){c[C>>2]=c[(c[(c[(c[B>>2]|0)+40>>2]|0)+36>>2]|0)+4>>2];c[s>>2]=c[(c[(c[(c[B>>2]|0)+40>>2]|0)+36>>2]|0)+28>>2];c[D>>2]=c[(c[(c[(c[B>>2]|0)+40>>2]|0)+36>>2]|0)+32>>2]}}else{c[r>>2]=0;l=c[B>>2]|0;if(c[(c[B>>2]|0)+24>>2]|0){c[C>>2]=c[(c[l+24>>2]|0)+72>>2];break}if((c[l+40>>2]|0)!=0?(c[(c[(c[B>>2]|0)+40>>2]|0)+36>>2]|0)!=0:0)c[C>>2]=c[(c[(c[(c[B>>2]|0)+40>>2]|0)+36>>2]|0)+4>>2]}while(0);if((c[(c[B>>2]|0)+196>>2]|0)!=0?(c[C>>2]|0)==0|(c[s>>2]|0)==0:0){vb[c[(c[B>>2]|0)+196>>2]&511](c[(c[B>>2]|0)+200>>2]|0,F,E)|0;if(!(c[C>>2]|0))c[C>>2]=c[F>>2];if(!(c[s>>2]|0))c[s>>2]=c[E>>2]}if((c[C>>2]|0)==0?(c[(c[B>>2]|0)+48>>2]|0)!=0:0)c[C>>2]=c[(c[B>>2]|0)+48>>2];B=c[y>>2]|0;y=c[z>>2]|0;z=c[A>>2]|0;A=c[o>>2]|0;o=c[r>>2]|0;r=c[q>>2]|0;q=c[p>>2]|0;p=c[C>>2]|0;C=c[s>>2]|0;s=c[u>>2]|0;E=c[v>>2]|0;F=c[w>>2]|0;l=c[D>>2]|0;D=c[t>>2]|0;t=c[v>>2]|0;v=c[w>>2]|0;w=c[x>>2]|0;c[n>>2]=c[u>>2];c[n+4>>2]=t;c[n+8>>2]=v;c[n+12>>2]=w;Xd(B,y,z,A,o,17,r,q,p,C,s,E,F,0,l,D,n);i=m;return}function aE(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[g>>2]=a;c[h>>2]=b;if(!(c[g>>2]|0)){c[f>>2]=1;j=c[f>>2]|0;i=e;return j|0}a:do if((c[h>>2]|0)<0){b:while(1){if(!(d[c[g>>2]>>0]|0))break a;do if((d[c[g>>2]>>0]|0|0)!=32){if(9<=(d[c[g>>2]>>0]|0|0)?(d[c[g>>2]>>0]|0|0)<=10:0)break;if((d[c[g>>2]>>0]|0|0)!=13)break b}while(0);c[g>>2]=(c[g>>2]|0)+1}c[f>>2]=0;j=c[f>>2]|0;i=e;return j|0}else{c:while(1){if(!((c[h>>2]|0)!=0?(d[c[g>>2]>>0]|0|0)!=0:0))break a;do if((d[c[g>>2]>>0]|0|0)!=32){if(9<=(d[c[g>>2]>>0]|0|0)?(d[c[g>>2]>>0]|0|0)<=10:0)break;if((d[c[g>>2]>>0]|0|0)!=13)break c}while(0);c[g>>2]=(c[g>>2]|0)+1;c[h>>2]=(c[h>>2]|0)+-1}c[f>>2]=0;j=c[f>>2]|0;i=e;return j|0}while(0);c[f>>2]=1;j=c[f>>2]|0;i=e;return j|0}function bE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;do if(c[c[f>>2]>>2]|0){if((c[(c[f>>2]|0)+8>>2]|0)<=(c[(c[f>>2]|0)+4>>2]|0)?(b=(c[f>>2]|0)+8|0,c[b>>2]=c[b>>2]<<1,b=Hb[c[135760>>2]&511](c[c[f>>2]>>2]|0,c[(c[f>>2]|0)+8>>2]<<2)|0,c[c[f>>2]>>2]=b,(c[c[f>>2]>>2]|0)==0):0){tC(0,142376,0);c[(c[f>>2]|0)+8>>2]=0;c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}}else{b=Cb[c[135744>>2]&511](80)|0;c[c[f>>2]>>2]=b;if(c[c[f>>2]>>2]|0){c[(c[f>>2]|0)+8>>2]=20;break}tC(0,142344,0);c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}while(0);b=c[g>>2]|0;g=(c[f>>2]|0)+4|0;a=c[g>>2]|0;c[g>>2]=a+1;c[(c[c[f>>2]>>2]|0)+(a<<2)>>2]=b;c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}function cE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=dE(c[h>>2]|0,c[j>>2]|0)|0;if(!(c[k>>2]|0)){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}else{c[f>>2]=CF(c[g>>2]|0,c[k>>2]|0)|0;l=c[f>>2]|0;i=e;return l|0}return 0}function dE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}c[h>>2]=c[(c[f>>2]|0)+44>>2];while(1){if(!(c[h>>2]|0)){k=9;break}if((c[(c[h>>2]|0)+36>>2]|0)==0?(qy(c[(c[h>>2]|0)+8>>2]|0,c[g>>2]|0)|0)!=0:0){k=7;break}c[h>>2]=c[(c[h>>2]|0)+24>>2]}if((k|0)==7){c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}else if((k|0)==9){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}return 0}function eE(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+32|0;h=g+24|0;j=g+20|0;k=g+16|0;l=g+12|0;m=g+8|0;n=g+4|0;o=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;if((c[j>>2]|0)==0|(c[m>>2]|0)==0|(c[l>>2]|0)==0){c[h>>2]=-1;p=c[h>>2]|0;i=g;return p|0}c[o>>2]=fE(c[j>>2]|0,c[l>>2]|0)|0;if(c[n>>2]|0)c[c[n>>2]>>2]=c[o>>2];c[h>>2]=DF(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,c[o>>2]|0,c[m>>2]|0)|0;p=c[h>>2]|0;i=g;return p|0}function fE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=_i(c[f>>2]|0)|0;if(!(c[g>>2]|0))c[g>>2]=my(142672)|0;c[h>>2]=AP(c[(c[e>>2]|0)+80>>2]|0,c[g>>2]|0,-1)|0;zb[c[135736>>2]&511](c[g>>2]|0);i=d;return c[h>>2]|0}function gE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(qy(c[g>>2]|0,163536)|0){if(!(c[c[h>>2]>>2]&c[j>>2])){d=c[h>>2]|0;c[d>>2]=c[d>>2]|c[j>>2]}}else if(!(qy(c[g>>2]|0,163552)|0)){c[f>>2]=1;k=c[f>>2]|0;i=e;return k|0}c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}function hE(a,b,d,e,f,g,h,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;m=i;i=i+48|0;n=m+44|0;o=m+40|0;p=m+32|0;q=m+28|0;r=m+24|0;s=m+20|0;t=m+16|0;u=m+12|0;v=m+8|0;w=m+4|0;x=m;c[n>>2]=a;c[o>>2]=b;c[m+36>>2]=d;c[p>>2]=e;c[q>>2]=f;c[r>>2]=g;c[s>>2]=h;c[t>>2]=j;c[u>>2]=k;c[v>>2]=l;c[w>>2]=0;HC(w,c[n>>2]|0,c[p>>2]|0)|0;do if(!(c[t>>2]|0)){l=(c[(c[p>>2]|0)+4>>2]|0)==2;k=c[w>>2]|0;do if(c[q>>2]|0){if(l)c[w>>2]=By(k,154256)|0;else c[w>>2]=By(k,154288)|0;j=(XD(c[q>>2]|0)|0)!=0;h=c[w>>2]|0;if(j)c[w>>2]=By(h,154352)|0;else c[w>>2]=By(h,154336)|0;do if(!(c[(c[q>>2]|0)+48>>2]&256)){if(c[(c[q>>2]|0)+48>>2]&64){c[w>>2]=By(c[w>>2]|0,147936)|0;break}if(c[(c[q>>2]|0)+48>>2]&128)c[w>>2]=By(c[w>>2]|0,147952)|0}else c[w>>2]=By(c[w>>2]|0,147920)|0;while(0);if(XD(c[q>>2]|0)|0){c[x>>2]=0;c[w>>2]=By(c[w>>2]|0,143656)|0;h=c[w>>2]|0;if(c[(c[q>>2]|0)+88>>2]|0){c[w>>2]=By(h,154360)|0;c[w>>2]=By(c[w>>2]|0,c[(c[q>>2]|0)+8>>2]|0)|0}else c[w>>2]=By(h,BB(x,c[(c[q>>2]|0)+112>>2]|0,c[(c[q>>2]|0)+8>>2]|0)|0)|0;c[w>>2]=By(c[w>>2]|0,161528)|0;if(c[x>>2]|0){zb[c[135736>>2]&511](c[x>>2]|0);c[x>>2]=0}}}else if(l){c[w>>2]=By(k,161536)|0;break}else{c[w>>2]=By(k,161568)|0;break}while(0);k=c[w>>2]|0;if(c[r>>2]|0){c[w>>2]=By(k,161608)|0;c[w>>2]=By(c[w>>2]|0,c[r>>2]|0)|0;c[w>>2]=By(c[w>>2]|0,161624)|0}else c[w>>2]=By(k,140352)|0;k=c[n>>2]|0;l=c[p>>2]|0;h=c[o>>2]|0;j=c[w>>2]|0;if((c[(c[p>>2]|0)+4>>2]|0)==2){PC(k,l,h,j,c[s>>2]|0,0);break}else{PC(k,l,h,j,0,0);break}}else{c[w>>2]=By(c[w>>2]|0,c[t>>2]|0)|0;c[w>>2]=By(c[w>>2]|0,142704)|0;EF(c[n>>2]|0,c[p>>2]|0,c[o>>2]|0,0,0,0,c[w>>2]|0,c[u>>2]|0,c[v>>2]|0,0,0,0)}while(0);if(!(c[w>>2]|0)){i=m;return}zb[c[135736>>2]&511](c[w>>2]|0);c[w>>2]=0;i=m;return}function iE(a,b,e,f,g,h,j,k){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;l=i;i=i+64|0;m=l+48|0;n=l+44|0;o=l+40|0;p=l+36|0;q=l+32|0;r=l+28|0;s=l+24|0;t=l+20|0;u=l+16|0;v=l+12|0;w=l+8|0;x=l+4|0;y=l;c[n>>2]=a;c[o>>2]=b;c[p>>2]=e;c[q>>2]=f;c[r>>2]=g;c[s>>2]=h;c[t>>2]=j;c[u>>2]=k;c[v>>2]=0;if((c[o>>2]|0)==0|(c[n>>2]|0)==0){c[m>>2]=-1;z=c[m>>2]|0;i=l;return z|0}if(!(d[c[n>>2]>>0]|0)){c[m>>2]=0;z=c[m>>2]|0;i=l;return z|0}a:do if(qy(c[n>>2]|0,165432)|0){if((c[p>>2]|0)!=-1){k=c[o>>2]|0;c[k>>2]=c[k>>2]|c[p>>2];break}if((c[q>>2]|0)!=-1){k=c[o>>2]|0;c[k>>2]=c[k>>2]|c[q>>2]}if((c[r>>2]|0)!=-1){k=c[o>>2]|0;c[k>>2]=c[k>>2]|c[r>>2]}if((c[s>>2]|0)!=-1){k=c[o>>2]|0;c[k>>2]=c[k>>2]|c[s>>2]}if((c[t>>2]|0)!=-1){k=c[o>>2]|0;c[k>>2]=c[k>>2]|c[t>>2]}if((c[u>>2]|0)!=-1){k=c[o>>2]|0;c[k>>2]=c[k>>2]|c[u>>2]}}else{c[x>>2]=c[n>>2];while(1){do if((d[c[x>>2]>>0]|0|0)==32)A=1;else{if(9<=(d[c[x>>2]>>0]|0|0)?(d[c[x>>2]>>0]|0|0)<=10:0){A=1;break}A=(d[c[x>>2]>>0]|0|0)==13}while(0);k=c[x>>2]|0;if(A){c[x>>2]=k+1;continue}c[w>>2]=k;while(1){if(d[c[w>>2]>>0]|0){do if((d[c[w>>2]>>0]|0|0)==32)B=1;else{if(9<=(d[c[w>>2]>>0]|0|0)?(d[c[w>>2]>>0]|0|0)<=10:0){B=1;break}B=(d[c[w>>2]>>0]|0|0)==13}while(0);C=B^1}else C=0;D=c[w>>2]|0;if(!C)break;c[w>>2]=D+1}if((D|0)==(c[x>>2]|0))break a;c[y>>2]=ly(c[x>>2]|0,(c[w>>2]|0)-(c[x>>2]|0)|0)|0;do if(qy(c[y>>2]|0,165440)|0){if((c[q>>2]|0)==-1){c[v>>2]=1;break}if(!(c[c[o>>2]>>2]&c[q>>2])){k=c[o>>2]|0;c[k>>2]=c[k>>2]|c[q>>2]}}else{if(qy(c[y>>2]|0,165456)|0){if((c[r>>2]|0)==-1){c[v>>2]=1;break}if(c[c[o>>2]>>2]&c[r>>2])break;k=c[o>>2]|0;c[k>>2]=c[k>>2]|c[r>>2];break}if(qy(c[y>>2]|0,165472)|0){if((c[s>>2]|0)==-1){c[v>>2]=1;break}if(c[c[o>>2]>>2]&c[s>>2])break;k=c[o>>2]|0;c[k>>2]=c[k>>2]|c[s>>2];break}if(qy(c[y>>2]|0,165488)|0){if((c[t>>2]|0)==-1){c[v>>2]=1;break}if(c[c[o>>2]>>2]&c[t>>2])break;k=c[o>>2]|0;c[k>>2]=c[k>>2]|c[t>>2];break}if(!(qy(c[y>>2]|0,165496)|0)){c[v>>2]=1;break}if((c[u>>2]|0)==-1){c[v>>2]=1;break}if(!(c[c[o>>2]>>2]&c[u>>2])){k=c[o>>2]|0;c[k>>2]=c[k>>2]|c[u>>2]}}while(0);if(c[y>>2]|0)zb[c[135736>>2]&511](c[y>>2]|0);c[x>>2]=c[w>>2];if(c[v>>2]|0)break a;if(!(d[c[x>>2]>>0]|0))break}}while(0);c[m>>2]=c[v>>2];z=c[m>>2]|0;i=l;return z|0}function jE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;n=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[l>>2]=0;c[n>>2]=0;if((c[g>>2]|0)==0|(c[h>>2]|0)==0){c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}if(c[j>>2]|0)c[k>>2]=FF(c[g>>2]|0,c[h>>2]|0)|0;else c[k>>2]=0;c[m>>2]=c[(c[h>>2]|0)+44>>2];while(1){if(!(c[m>>2]|0))break;if((c[(c[m>>2]|0)+36>>2]|0)==0?(qy(c[(c[m>>2]|0)+8>>2]|0,161384)|0)==0:0)p=12;else p=10;if(((p|0)==10?(p=0,(c[(c[m>>2]|0)+36>>2]|0)!=0):0)?(qy(c[(c[(c[m>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0)p=12;if((p|0)==12){p=0;GF(c[g>>2]|0,3035,0,c[m>>2]|0)}c[m>>2]=c[(c[m>>2]|0)+24>>2]}cE(c[g>>2]|0,c[h>>2]|0,161384)|0;c[l>>2]=c[(c[h>>2]|0)+12>>2];while(1){if(!(c[l>>2]|0))break;if((((c[l>>2]|0)!=0?(c[(c[l>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[l>>2]|0)+8>>2]|0,168752)|0)!=0:0)?(qy(c[(c[(c[l>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){c[m>>2]=c[(c[l>>2]|0)+44>>2];while(1){if(!(c[m>>2]|0))break;if((c[(c[m>>2]|0)+36>>2]|0)==0?(qy(c[(c[m>>2]|0)+8>>2]|0,168760)|0)==0:0)p=26;else p=24;if(((p|0)==24?(p=0,(c[(c[m>>2]|0)+36>>2]|0)!=0):0)?(qy(c[(c[(c[m>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0)p=26;if((p|0)==26){p=0;GF(c[g>>2]|0,3035,0,c[m>>2]|0)}c[m>>2]=c[(c[m>>2]|0)+24>>2]}j=c[g>>2]|0;d=c[l>>2]|0;HF(j,0,d,168760,IH(29)|0,0)|0;c[l>>2]=c[(c[l>>2]|0)+24>>2];continue}if((((c[l>>2]|0)!=0?(c[(c[l>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[l>>2]|0)+8>>2]|0,168768)|0)!=0:0)?(qy(c[(c[(c[l>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){c[m>>2]=c[(c[l>>2]|0)+44>>2];while(1){if(!(c[m>>2]|0))break;d=c[m>>2]|0;do if(!(c[(c[m>>2]|0)+36>>2]|0)){if(!(qy(c[d+8>>2]|0,168760)|0))GF(c[g>>2]|0,3035,0,c[m>>2]|0)}else{if(!(qy(c[(c[d+36>>2]|0)+8>>2]|0,c[38526]|0)|0)){if(!(qy(c[(c[m>>2]|0)+8>>2]|0,168784)|0))break;if(qy(c[(c[(c[m>>2]|0)+36>>2]|0)+8>>2]|0,168792)|0)break}GF(c[g>>2]|0,3035,0,c[m>>2]|0)}while(0);c[m>>2]=c[(c[m>>2]|0)+24>>2]}c[m>>2]=IF(c[l>>2]|0,168792,168784)|0;if(c[m>>2]|0){d=c[g>>2]|0;j=c[m>>2]|0;eE(d,0,j,IH(17)|0,0)|0}c[l>>2]=c[(c[l>>2]|0)+24>>2];continue}if(!(c[n>>2]|0))uE(c[g>>2]|0,3033,0,c[h>>2]|0,c[l>>2]|0,0,168832);c[n>>2]=1;c[l>>2]=c[(c[l>>2]|0)+24>>2]}c[f>>2]=c[k>>2];o=c[f>>2]|0;i=e;return o|0}function kE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+48|0;f=e+40|0;g=e+36|0;h=e+32|0;j=e+28|0;k=e+24|0;l=e+20|0;m=e+16|0;n=e+12|0;o=e+8|0;p=e+4|0;q=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[l>>2]=0;c[m>>2]=0;c[p>>2]=0;c[q>>2]=0;if((c[g>>2]|0)==0|(c[h>>2]|0)==0|(c[j>>2]|0)==0){c[f>>2]=-1;r=c[f>>2]|0;i=e;return r|0}c[o>>2]=c[(c[j>>2]|0)+44>>2];while(1){if(!(c[o>>2]|0))break;d=c[o>>2]|0;if(!(c[(c[o>>2]|0)+36>>2]|0)){if(((qy(c[d+8>>2]|0,161384)|0)==0?(qy(c[(c[o>>2]|0)+8>>2]|0,162304)|0)==0:0)?(qy(c[(c[o>>2]|0)+8>>2]|0,155456)|0)==0:0)GF(c[g>>2]|0,3035,0,c[o>>2]|0)}else if(qy(c[(c[d+36>>2]|0)+8>>2]|0,c[38526]|0)|0)GF(c[g>>2]|0,3035,0,c[o>>2]|0);c[o>>2]=c[(c[o>>2]|0)+24>>2]}o=c[g>>2]|0;d=c[j>>2]|0;b=(HF(o,0,d,162304,IH(29)|0,l)|0)!=0;d=c[g>>2]|0;o=c[j>>2]|0;a=IH(29)|0;if(b){hE(d,3037,0,o,a,0,c[l>>2]|0,0,0,0);c[f>>2]=c[(c[g>>2]|0)+16>>2];r=c[f>>2]|0;i=e;return r|0}if(HF(d,0,o,155456,a,m)|0){a=c[g>>2]|0;o=c[j>>2]|0;d=IH(29)|0;hE(a,3037,0,o,d,0,c[m>>2]|0,0,0,0);c[f>>2]=c[(c[g>>2]|0)+16>>2];r=c[f>>2]|0;i=e;return r|0}c[k>>2]=c[(c[j>>2]|0)+12>>2];if((((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[k>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0)c[k>>2]=c[(c[k>>2]|0)+24>>2];if(c[k>>2]|0)uE(c[g>>2]|0,3033,0,c[j>>2]|0,c[k>>2]|0,0,161392);c[n>>2]=c[(c[(c[(c[g>>2]|0)+28>>2]|0)+16>>2]|0)+12>>2];k=c[n>>2]|0;if(c[l>>2]|0){if(qy(k,c[l>>2]|0)|0){GE(c[g>>2]|0,3064,0,c[j>>2]|0,168408,c[n>>2]|0);c[f>>2]=c[(c[g>>2]|0)+16>>2];r=c[f>>2]|0;i=e;return r|0}}else if(!k){GE(c[g>>2]|0,3065,0,c[j>>2]|0,168512,0);c[f>>2]=c[(c[g>>2]|0)+16>>2];r=c[f>>2]|0;i=e;return r|0}if(c[m>>2]|0)c[m>>2]=JF(c[(c[g>>2]|0)+80>>2]|0,c[m>>2]|0,c[j>>2]|0)|0;c[p>>2]=FB(c[g>>2]|0,1,c[m>>2]|0,0,0,0,c[j>>2]|0,c[n>>2]|0,c[l>>2]|0,q)|0;if(c[p>>2]|0){c[f>>2]=c[p>>2];r=c[f>>2]|0;i=e;return r|0}if((c[q>>2]|0)==0&(c[m>>2]|0)!=0)NC(c[g>>2]|0,3084,c[j>>2]|0,0,168608,c[m>>2]|0,0,0);if(((c[q>>2]|0)!=0?(c[(c[q>>2]|0)+20>>2]|0)!=0:0)?(c[(c[q>>2]|0)+32>>2]|0)==0:0)c[p>>2]=KF(c[g>>2]|0,c[h>>2]|0,c[q>>2]|0)|0;c[f>>2]=c[p>>2];r=c[f>>2]|0;i=e;return r|0}function lE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=LF(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0,2)|0;if(c[k>>2]|0){c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}else{c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}return 0}function mE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=LF(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0,3)|0;if(c[k>>2]|0){c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}else{c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}return 0}function nE(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;i=i+64|0;g=f+52|0;h=f+48|0;j=f+44|0;k=f+40|0;l=f+36|0;m=f+32|0;n=f+28|0;o=f+24|0;p=f+20|0;q=f+16|0;r=f+12|0;s=f+8|0;t=f+4|0;u=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[o>>2]=0;c[p>>2]=0;c[s>>2]=0;c[t>>2]=0;c[u>>2]=0;if((c[h>>2]|0)==0|(c[j>>2]|0)==0|(c[k>>2]|0)==0){c[g>>2]=0;v=c[g>>2]|0;i=f;return v|0}c[n>>2]=c[(c[h>>2]|0)+84>>2];if(c[l>>2]|0){c[q>>2]=dE(c[k>>2]|0,161352)|0;e=c[h>>2]|0;if(!(c[q>>2]|0)){MF(e,3036,0,c[k>>2]|0,161352,0);c[g>>2]=0;v=c[g>>2]|0;i=f;return v|0}d=c[q>>2]|0;if(eE(e,0,d,IH(22)|0,p)|0){c[g>>2]=0;v=c[g>>2]|0;i=f;return v|0}}d=c[h>>2]|0;e=c[j>>2]|0;do if(!(c[l>>2]|0)){c[m>>2]=WE(d,e,5,0,c[(c[h>>2]|0)+112>>2]|0,c[k>>2]|0,0)|0;if(c[m>>2]|0){c[p>>2]=c[(c[m>>2]|0)+8>>2];c[(c[m>>2]|0)+36>>2]=c[k>>2];c[c[m>>2]>>2]=5;break}c[g>>2]=0;v=c[g>>2]|0;i=f;return v|0}else{c[m>>2]=WE(d,e,5,c[p>>2]|0,c[(c[h>>2]|0)+112>>2]|0,c[k>>2]|0,1)|0;if(c[m>>2]|0){c[(c[m>>2]|0)+36>>2]=c[k>>2];c[c[m>>2]>>2]=5;b=(c[m>>2]|0)+48|0;c[b>>2]=c[b>>2]|8;break}c[g>>2]=0;v=c[g>>2]|0;i=f;return v|0}while(0);c[(c[m>>2]|0)+112>>2]=c[(c[h>>2]|0)+112>>2];c[q>>2]=c[(c[k>>2]|0)+44>>2];while(1){if(!(c[q>>2]|0))break;p=c[q>>2]|0;do if(!(c[(c[q>>2]|0)+36>>2]|0)){if(qy(c[p+8>>2]|0,161384)|0){cE(c[h>>2]|0,c[k>>2]|0,161384)|0;break}if(qy(c[(c[q>>2]|0)+8>>2]|0,167064)|0){if(!(NF(c[h>>2]|0,0,c[q>>2]|0)|0))break;e=(c[m>>2]|0)+48|0;c[e>>2]=c[e>>2]|1;break}if(!(c[l>>2]|0)){GF(c[h>>2]|0,3035,0,c[q>>2]|0);break}if(!(qy(c[(c[q>>2]|0)+8>>2]|0,161352)|0)){if(qy(c[(c[q>>2]|0)+8>>2]|0,164512)|0){if(!(NF(c[h>>2]|0,0,c[q>>2]|0)|0))break;e=(c[m>>2]|0)+48|0;c[e>>2]=c[e>>2]|1048576;break}if(qy(c[(c[q>>2]|0)+8>>2]|0,164504)|0){c[r>>2]=fE(c[h>>2]|0,c[q>>2]|0)|0;if(iE(c[r>>2]|0,(c[m>>2]|0)+48|0,-1,512,1024,-1,-1,-1)|0){hE(c[h>>2]|0,3037,0,c[q>>2]|0,0,164528,c[r>>2]|0,0,0,0);break}else{c[s>>2]=1;break}}e=(qy(c[(c[q>>2]|0)+8>>2]|0,164480)|0)!=0;d=c[h>>2]|0;b=c[q>>2]|0;if(!e){GF(d,3035,0,b);break}c[r>>2]=fE(d,b)|0;if(iE(c[r>>2]|0,(c[m>>2]|0)+48|0,-1,262144,524288,-1,-1,-1)|0){hE(c[h>>2]|0,3037,0,c[q>>2]|0,0,167072,c[r>>2]|0,0,0,0);break}else{c[t>>2]=1;break}}}else if(qy(c[(c[p+36>>2]|0)+8>>2]|0,c[38526]|0)|0)GF(c[h>>2]|0,3035,0,c[q>>2]|0);while(0);c[q>>2]=c[(c[q>>2]|0)+24>>2]}if(!(c[t>>2]|0)){if(c[(c[j>>2]|0)+24>>2]&128){t=(c[m>>2]|0)+48|0;c[t>>2]=c[t>>2]|524288}if(c[(c[j>>2]|0)+24>>2]&64){t=(c[m>>2]|0)+48|0;c[t>>2]=c[t>>2]|262144}}if(!(c[s>>2]|0)){if(c[(c[j>>2]|0)+24>>2]&8){s=(c[m>>2]|0)+48|0;c[s>>2]=c[s>>2]|1024}if(c[(c[j>>2]|0)+24>>2]&4){s=(c[m>>2]|0)+48|0;c[s>>2]=c[s>>2]|512}}c[o>>2]=c[(c[k>>2]|0)+12>>2];if((((c[o>>2]|0)!=0?(c[(c[o>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[o>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(qy(c[(c[(c[o>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){s=jE(c[h>>2]|0,c[o>>2]|0,1)|0;c[(c[m>>2]|0)+24>>2]=s;c[o>>2]=c[(c[o>>2]|0)+24>>2]}c[(c[h>>2]|0)+84>>2]=c[m>>2];if((((c[o>>2]|0)!=0?(c[(c[o>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[o>>2]|0)+8>>2]|0,167120)|0)!=0:0)?(qy(c[(c[(c[o>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){if(c[(c[m>>2]|0)+48>>2]&1){s=(c[m>>2]|0)+48|0;c[s>>2]=c[s>>2]^1}OF(c[h>>2]|0,c[j>>2]|0,c[o>>2]|0,u)|0;c[o>>2]=c[(c[o>>2]|0)+24>>2]}else w=63;do if((w|0)==63){if((((c[o>>2]|0)!=0?(c[(c[o>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[o>>2]|0)+8>>2]|0,167136)|0)!=0:0)?(qy(c[(c[(c[o>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){c[(c[m>>2]|0)+52>>2]=1;PF(c[h>>2]|0,c[j>>2]|0,c[o>>2]|0,u)|0;c[o>>2]=c[(c[o>>2]|0)+24>>2];break}s=IH(45)|0;c[(c[m>>2]|0)+64>>2]=s;s=(c[m>>2]|0)+48|0;c[s>>2]=c[s>>2]|4;if((((c[o>>2]|0)!=0?(c[(c[o>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[o>>2]|0)+8>>2]|0,161648)|0)!=0:0)?(qy(c[(c[(c[o>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){s=QF(c[h>>2]|0,c[j>>2]|0,c[o>>2]|0,8,1)|0;c[(c[m>>2]|0)+28>>2]=s;c[o>>2]=c[(c[o>>2]|0)+24>>2]}else w=73;do if((w|0)==73){if((((c[o>>2]|0)!=0?(c[(c[o>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[o>>2]|0)+8>>2]|0,161656)|0)!=0:0)?(qy(c[(c[(c[o>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){s=QF(c[h>>2]|0,c[j>>2]|0,c[o>>2]|0,7,1)|0;c[(c[m>>2]|0)+28>>2]=s;c[o>>2]=c[(c[o>>2]|0)+24>>2];break}if((((c[o>>2]|0)!=0?(c[(c[o>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[o>>2]|0)+8>>2]|0,161664)|0)!=0:0)?(qy(c[(c[(c[o>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){s=QF(c[h>>2]|0,c[j>>2]|0,c[o>>2]|0,6,1)|0;c[(c[m>>2]|0)+28>>2]=s;c[o>>2]=c[(c[o>>2]|0)+24>>2];break}if((((c[o>>2]|0)!=0?(c[(c[o>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[o>>2]|0)+8>>2]|0,161080)|0)!=0:0)?(qy(c[(c[(c[o>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){s=RF(c[h>>2]|0,c[j>>2]|0,c[o>>2]|0)|0;c[(c[m>>2]|0)+28>>2]=s;c[o>>2]=c[(c[o>>2]|0)+24>>2]}}while(0);if((SF(c[h>>2]|0,c[j>>2]|0,o,(c[m>>2]|0)+116|0,12,0)|0)==-1){c[g>>2]=0;v=c[g>>2]|0;i=f;return v|0}if((((c[o>>2]|0)!=0?(c[(c[o>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[o>>2]|0)+8>>2]|0,163328)|0)!=0:0)?(qy(c[(c[(c[o>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){s=TF(c[h>>2]|0,c[j>>2]|0,c[o>>2]|0)|0;c[(c[m>>2]|0)+84>>2]=s;c[o>>2]=c[(c[o>>2]|0)+24>>2]}}while(0);if(c[o>>2]|0)uE(c[h>>2]|0,3033,0,c[k>>2]|0,c[o>>2]|0,0,167152);if((c[l>>2]|0)!=0?!((c[u>>2]|0)!=0?1:(c[(c[h>>2]|0)+100>>2]|0)==0):0)GE(c[h>>2]|0,3081,0,c[k>>2]|0,167288,0);c[(c[h>>2]|0)+84>>2]=c[n>>2];
c[g>>2]=c[m>>2];v=c[g>>2]|0;i=f;return v|0}function oE(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+48|0;g=f+44|0;h=f+40|0;j=f+36|0;k=f+32|0;l=f+28|0;m=f+24|0;n=f+20|0;o=f+16|0;p=f+12|0;q=f+8|0;r=f+4|0;s=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[o>>2]=0;c[p>>2]=0;c[r>>2]=0;if((c[h>>2]|0)==0|(c[j>>2]|0)==0|(c[k>>2]|0)==0){c[g>>2]=0;t=c[g>>2]|0;i=f;return t|0}if(c[l>>2]|0){c[q>>2]=dE(c[k>>2]|0,161352)|0;e=c[h>>2]|0;if(!(c[q>>2]|0)){MF(e,3036,0,c[k>>2]|0,161352,0);c[g>>2]=0;t=c[g>>2]|0;i=f;return t|0}d=c[q>>2]|0;if(eE(e,0,d,IH(22)|0,p)|0){c[g>>2]=0;t=c[g>>2]|0;i=f;return t|0}if(c[(c[h>>2]|0)+96>>2]|0){if(c[(c[h>>2]|0)+100>>2]|0){GE(c[h>>2]|0,3081,0,c[k>>2]|0,165552,0);c[g>>2]=0;t=c[g>>2]|0;i=f;return t|0}c[s>>2]=QH(c[p>>2]|0,c[38526]|0)|0;if(c[s>>2]|0){c[g>>2]=c[s>>2];t=c[g>>2]|0;i=f;return t|0}}}s=c[h>>2]|0;d=c[j>>2]|0;a:do if(c[l>>2]|0){c[m>>2]=WE(s,d,4,c[p>>2]|0,c[(c[h>>2]|0)+112>>2]|0,c[k>>2]|0,1)|0;if(!(c[m>>2]|0)){c[g>>2]=0;t=c[g>>2]|0;i=f;return t|0}c[c[m>>2]>>2]=4;c[(c[m>>2]|0)+52>>2]=4;e=(c[m>>2]|0)+48|0;c[e>>2]=c[e>>2]|8;c[q>>2]=c[(c[k>>2]|0)+44>>2];while(1){if(!(c[q>>2]|0))break;e=c[q>>2]|0;if(!(c[(c[q>>2]|0)+36>>2]|0)){if(((qy(c[e+8>>2]|0,161384)|0)==0?(qy(c[(c[q>>2]|0)+8>>2]|0,161352)|0)==0:0)?(qy(c[(c[q>>2]|0)+8>>2]|0,164504)|0)==0:0)GF(c[h>>2]|0,3035,0,c[q>>2]|0)}else if(qy(c[(c[e+36>>2]|0)+8>>2]|0,c[38526]|0)|0)GF(c[h>>2]|0,3035,0,c[q>>2]|0);c[q>>2]=c[(c[q>>2]|0)+24>>2]}c[q>>2]=dE(c[k>>2]|0,164504)|0;if(c[q>>2]|0){c[p>>2]=RC(c[h>>2]|0,c[k>>2]|0,164504)|0;if(!(iE(c[p>>2]|0,(c[m>>2]|0)+48|0,-1,-1,1024,-1,2048,4096)|0))break;hE(c[h>>2]|0,3037,c[m>>2]|0,c[q>>2]|0,0,165608,c[p>>2]|0,0,0,0);break}if(c[(c[j>>2]|0)+24>>2]&8){e=(c[m>>2]|0)+48|0;c[e>>2]=c[e>>2]|1024}if(c[(c[j>>2]|0)+24>>2]&16){e=(c[m>>2]|0)+48|0;c[e>>2]=c[e>>2]|2048}if(c[(c[j>>2]|0)+24>>2]&32){e=(c[m>>2]|0)+48|0;c[e>>2]=c[e>>2]|4096}}else{c[m>>2]=WE(s,d,4,0,c[(c[h>>2]|0)+112>>2]|0,c[k>>2]|0,0)|0;if(!(c[m>>2]|0)){c[g>>2]=0;t=c[g>>2]|0;i=f;return t|0}c[c[m>>2]>>2]=4;c[(c[m>>2]|0)+52>>2]=4;c[q>>2]=c[(c[k>>2]|0)+44>>2];while(1){if(!(c[q>>2]|0))break a;e=c[q>>2]|0;if(!(c[(c[q>>2]|0)+36>>2]|0)){if(!(qy(c[e+8>>2]|0,161384)|0))GF(c[h>>2]|0,3035,0,c[q>>2]|0)}else if(qy(c[(c[e+36>>2]|0)+8>>2]|0,c[38526]|0)|0)GF(c[h>>2]|0,3035,0,c[q>>2]|0);c[q>>2]=c[(c[q>>2]|0)+24>>2]}}while(0);c[(c[m>>2]|0)+112>>2]=c[(c[h>>2]|0)+112>>2];cE(c[h>>2]|0,c[k>>2]|0,161384)|0;c[n>>2]=c[(c[h>>2]|0)+84>>2];c[(c[h>>2]|0)+84>>2]=c[m>>2];c[o>>2]=c[(c[k>>2]|0)+12>>2];if((((c[o>>2]|0)!=0?(c[(c[o>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[o>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(qy(c[(c[(c[o>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){q=jE(c[h>>2]|0,c[o>>2]|0,1)|0;c[(c[m>>2]|0)+24>>2]=q;c[o>>2]=c[(c[o>>2]|0)+24>>2]}do if(c[o>>2]|0){if((((c[o>>2]|0)!=0?(c[(c[o>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[o>>2]|0)+8>>2]|0,165456)|0)!=0:0)?(qy(c[(c[(c[o>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){UF(c[h>>2]|0,c[j>>2]|0,c[o>>2]|0,4)|0;c[r>>2]=1;c[o>>2]=c[(c[o>>2]|0)+24>>2];break}if((((c[o>>2]|0)!=0?(c[(c[o>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[o>>2]|0)+8>>2]|0,165488)|0)!=0:0)?(qy(c[(c[(c[o>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){VF(c[h>>2]|0,c[j>>2]|0,c[o>>2]|0)|0;c[o>>2]=c[(c[o>>2]|0)+24>>2];break}if((((c[o>>2]|0)!=0?(c[(c[o>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[o>>2]|0)+8>>2]|0,165496)|0)!=0:0)?(qy(c[(c[(c[o>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){WF(c[h>>2]|0,c[j>>2]|0,c[o>>2]|0)|0;c[o>>2]=c[(c[o>>2]|0)+24>>2]}}else uE(c[h>>2]|0,3034,0,c[k>>2]|0,c[o>>2]|0,0,165656);while(0);if(c[o>>2]|0)uE(c[h>>2]|0,3033,0,c[k>>2]|0,c[o>>2]|0,0,165656);if((c[l>>2]|0)!=0?!((c[r>>2]|0)!=0?1:(c[(c[h>>2]|0)+100>>2]|0)==0):0)GE(c[h>>2]|0,3081,0,c[k>>2]|0,165704,0);c[(c[h>>2]|0)+84>>2]=c[n>>2];c[g>>2]=c[m>>2];t=c[g>>2]|0;i=f;return t|0}function pE(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=i;i=i+112|0;h=g+96|0;j=g+92|0;k=g+88|0;l=g+84|0;m=g+80|0;n=g+76|0;o=g+72|0;p=g+68|0;q=g+64|0;r=g+60|0;s=g+56|0;t=g+52|0;u=g+48|0;v=g+44|0;w=g+40|0;x=g+36|0;y=g+32|0;z=g+28|0;A=g+24|0;B=g+20|0;C=g+16|0;D=g+12|0;E=g+8|0;F=g+4|0;G=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=0;c[p>>2]=0;c[q>>2]=0;c[r>>2]=0;c[w>>2]=0;c[x>>2]=0;if((c[j>>2]|0)==0|(c[k>>2]|0)==0|(c[l>>2]|0)==0){c[h>>2]=0;H=c[h>>2]|0;i=g;return H|0}if(c[m>>2]|0)c[c[m>>2]>>2]=0;c[t>>2]=dE(c[l>>2]|0,161352)|0;c[s>>2]=dE(c[l>>2]|0,160064)|0;if((c[n>>2]|0)!=0|(c[s>>2]|0)==0){if(!(c[t>>2]|0)){MF(c[j>>2]|0,3036,0,c[l>>2]|0,161352,0);c[h>>2]=0;H=c[h>>2]|0;i=g;return H|0}}else c[w>>2]=1;cE(c[j>>2]|0,c[l>>2]|0,161384)|0;c[r>>2]=c[(c[l>>2]|0)+12>>2];if((((c[r>>2]|0)!=0?(c[(c[r>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[r>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(qy(c[(c[(c[r>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){c[q>>2]=jE(c[j>>2]|0,c[r>>2]|0,1)|0;c[r>>2]=c[(c[r>>2]|0)+24>>2]}if(!(c[n>>2]|0)){c[u>>2]=XF(c[j>>2]|0,c[l>>2]|0,0,-1,1,161744)|0;c[v>>2]=YF(c[j>>2]|0,c[l>>2]|0,0,1073741824,1,161768)|0;ZF(c[j>>2]|0,0,c[l>>2]|0,c[u>>2]|0,c[v>>2]|0)|0;c[p>>2]=XE(c[j>>2]|0,c[l>>2]|0,c[u>>2]|0,c[v>>2]|0)|0;if(c[p>>2]|0)if(c[w>>2]|0){c[y>>2]=0;c[z>>2]=0;c[A>>2]=0;if(c[m>>2]|0)c[c[m>>2]>>2]=1;_F(c[j>>2]|0,c[k>>2]|0,0,c[s>>2]|0,y,z)|0;$F(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,c[s>>2]|0,c[y>>2]|0)|0;if(c[t>>2]|0)aG(c[j>>2]|0,3039,0,c[t>>2]|0,160064,161352);c[s>>2]=c[(c[l>>2]|0)+44>>2];while(1){if(!(c[s>>2]|0))break;m=c[s>>2]|0;if(c[(c[s>>2]|0)+36>>2]|0){if(qy(c[(c[m+36>>2]|0)+8>>2]|0,c[38526]|0)|0)GF(c[j>>2]|0,3035,0,c[s>>2]|0);c[s>>2]=c[(c[s>>2]|0)+24>>2];continue}if(((((qy(c[m+8>>2]|0,160064)|0)==0?(qy(c[(c[s>>2]|0)+8>>2]|0,161352)|0)==0:0)?(qy(c[(c[s>>2]|0)+8>>2]|0,161384)|0)==0:0)?(qy(c[(c[s>>2]|0)+8>>2]|0,161808)|0)==0:0)?(qy(c[(c[s>>2]|0)+8>>2]|0,161824)|0)==0:0){I=30;break}c[s>>2]=c[(c[s>>2]|0)+24>>2]}if((I|0)==30)bG(c[j>>2]|0,3040,0,0,c[s>>2]|0,164392);if(c[r>>2]|0)uE(c[j>>2]|0,3033,0,c[l>>2]|0,c[r>>2]|0,0,161392);if(!((c[u>>2]|0)==0&(c[v>>2]|0)==0)?(c[A>>2]=cG(c[j>>2]|0,14,c[z>>2]|0,c[y>>2]|0)|0,(c[A>>2]|0)!=0):0){c[(c[p>>2]|0)+12>>2]=c[A>>2];c[(c[p>>2]|0)+4>>2]=c[q>>2];dG((c[(c[j>>2]|0)+28>>2]|0)+20|0,10,c[p>>2]|0)|0;c[h>>2]=c[p>>2];H=c[h>>2]|0;i=g;return H|0}}else I=39}else I=39;if((I|0)==39?(c[B>>2]=0,c[F>>2]=0,c[G>>2]=0,A=c[j>>2]|0,y=c[t>>2]|0,(eE(A,0,y,IH(22)|0,D)|0)==0):0){do if(!(c[n>>2]|0)){c[s>>2]=dE(c[l>>2]|0,163528)|0;if(!(c[s>>2]|0)){if(!(c[(c[k>>2]|0)+24>>2]&1))break;c[B>>2]=c[(c[j>>2]|0)+112>>2];break}c[E>>2]=fE(c[j>>2]|0,c[s>>2]|0)|0;if(qy(c[E>>2]|0,163536)|0){c[B>>2]=c[(c[j>>2]|0)+112>>2];break}if(!(qy(c[E>>2]|0,163552)|0))hE(c[j>>2]|0,3037,0,c[s>>2]|0,0,163568,c[E>>2]|0,0,0,0)}else c[B>>2]=c[(c[j>>2]|0)+112>>2];while(0);c[o>>2]=eG(c[j>>2]|0,c[D>>2]|0,c[B>>2]|0,c[l>>2]|0,c[n>>2]|0)|0;if(c[o>>2]|0){c[s>>2]=c[(c[l>>2]|0)+44>>2];while(1){if(!(c[s>>2]|0))break;B=c[s>>2]|0;do if(!(c[(c[s>>2]|0)+36>>2]|0)){if(((((((qy(c[B+8>>2]|0,161352)|0)==0?(qy(c[(c[s>>2]|0)+8>>2]|0,155448)|0)==0:0)?(qy(c[(c[s>>2]|0)+8>>2]|0,161384)|0)==0:0)?(qy(c[(c[s>>2]|0)+8>>2]|0,159128)|0)==0:0)?(qy(c[(c[s>>2]|0)+8>>2]|0,159120)|0)==0:0)?(qy(c[(c[s>>2]|0)+8>>2]|0,164480)|0)==0:0)?(qy(c[(c[s>>2]|0)+8>>2]|0,164488)|0)==0:0){D=c[(c[s>>2]|0)+8>>2]|0;if(!(c[n>>2]|0)){if(qy(D,161808)|0)break;if(qy(c[(c[s>>2]|0)+8>>2]|0,161824)|0)break;if(qy(c[(c[s>>2]|0)+8>>2]|0,163528)|0)break;GF(c[j>>2]|0,3035,0,c[s>>2]|0);break}else{if(qy(D,164504)|0)break;if(qy(c[(c[s>>2]|0)+8>>2]|0,164512)|0)break;if(qy(c[(c[s>>2]|0)+8>>2]|0,160544)|0)break;GF(c[j>>2]|0,3035,0,c[s>>2]|0);break}}}else if(qy(c[(c[B+36>>2]|0)+8>>2]|0,c[38526]|0)|0)GF(c[j>>2]|0,3035,0,c[s>>2]|0);while(0);c[s>>2]=c[(c[s>>2]|0)+24>>2]}do if(c[n>>2]|0){B=(c[o>>2]|0)+48|0;c[B>>2]=c[B>>2]|2;B=(c[o>>2]|0)+48|0;c[B>>2]=c[B>>2]|32;fG(c[j>>2]|0,c[k>>2]|0,0,c[l>>2]|0,160544,(c[o>>2]|0)+68|0,(c[o>>2]|0)+64|0)|0;if(gG(c[j>>2]|0,c[l>>2]|0,164512,0)|0){B=(c[o>>2]|0)+48|0;c[B>>2]=c[B>>2]|16}c[s>>2]=dE(c[l>>2]|0,164504)|0;if(c[s>>2]|0){c[E>>2]=fE(c[j>>2]|0,c[s>>2]|0)|0;if(!(iE(c[E>>2]|0,(c[o>>2]|0)+48|0,-1,32768,65536,-1,-1,-1)|0))break;hE(c[j>>2]|0,3037,0,c[s>>2]|0,0,164528,c[E>>2]|0,0,0,0);break}if(c[(c[k>>2]|0)+24>>2]&4){B=(c[o>>2]|0)+48|0;c[B>>2]=c[B>>2]|32768}if(c[(c[k>>2]|0)+24>>2]&8){B=(c[o>>2]|0)+48|0;c[B>>2]=c[B>>2]|65536}}while(0);c[s>>2]=dE(c[l>>2]|0,164480)|0;if(!(c[s>>2]|0)){if(c[(c[k>>2]|0)+24>>2]&128){B=(c[o>>2]|0)+48|0;c[B>>2]=c[B>>2]|4096}if(c[(c[k>>2]|0)+24>>2]&64){B=(c[o>>2]|0)+48|0;c[B>>2]=c[B>>2]|2048}if(c[(c[k>>2]|0)+24>>2]&256){B=(c[o>>2]|0)+48|0;c[B>>2]=c[B>>2]|8192}}else{c[E>>2]=fE(c[j>>2]|0,c[s>>2]|0)|0;if(iE(c[E>>2]|0,(c[o>>2]|0)+48|0,-1,2048,4096,8192,-1,-1)|0)hE(c[j>>2]|0,3037,0,c[s>>2]|0,0,164576,c[E>>2]|0,0,0,0)}if(gG(c[j>>2]|0,c[l>>2]|0,164488,0)|0){E=(c[o>>2]|0)+48|0;c[E>>2]=c[E>>2]|1}c[s>>2]=dE(c[l>>2]|0,155448)|0;if(c[s>>2]|0){_F(c[j>>2]|0,c[k>>2]|0,0,c[s>>2]|0,(c[o>>2]|0)+60|0,(c[o>>2]|0)+56|0)|0;$F(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,c[s>>2]|0,c[(c[o>>2]|0)+60>>2]|0)|0}E=RC(c[j>>2]|0,c[l>>2]|0,159128)|0;c[(c[o>>2]|0)+76>>2]=E;c[s>>2]=dE(c[l>>2]|0,159120)|0;do if(c[s>>2]|0){c[C>>2]=fE(c[j>>2]|0,c[s>>2]|0)|0;if(c[(c[o>>2]|0)+76>>2]|0){aG(c[j>>2]|0,3038,0,c[s>>2]|0,159128,159120);break}else{E=(c[o>>2]|0)+48|0;c[E>>2]=c[E>>2]|8;c[(c[o>>2]|0)+76>>2]=c[C>>2];break}}while(0);if((((c[r>>2]|0)!=0?(c[(c[r>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[r>>2]|0)+8>>2]|0,161008)|0)!=0:0)?(qy(c[(c[(c[r>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){C=c[j>>2]|0;if(c[(c[o>>2]|0)+56>>2]|0)uE(C,3041,0,c[l>>2]|0,c[r>>2]|0,164640,0);else{s=nE(C,c[k>>2]|0,c[r>>2]|0,0)|0;c[(c[o>>2]|0)+28>>2]=s}c[r>>2]=c[(c[r>>2]|0)+24>>2]}else I=107;if(((((I|0)==107?(c[r>>2]|0)!=0:0)?(c[(c[r>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[r>>2]|0)+8>>2]|0,161024)|0)!=0:0)?(qy(c[(c[(c[r>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){s=c[j>>2]|0;if(c[(c[o>>2]|0)+56>>2]|0)uE(s,3041,0,c[l>>2]|0,c[r>>2]|0,164128,0);else{C=oE(s,c[k>>2]|0,c[r>>2]|0,0)|0;c[(c[o>>2]|0)+28>>2]=C}c[r>>2]=c[(c[r>>2]|0)+24>>2]}while(1){if((((c[r>>2]|0)!=0?(c[(c[r>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[r>>2]|0)+8>>2]|0,164712)|0)!=0:0)?(qy(c[(c[(c[r>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0)J=1;else I=119;a:do if((I|0)==119){I=0;do if(c[r>>2]|0){if(!(c[(c[r>>2]|0)+36>>2]|0))break;if(!(qy(c[(c[r>>2]|0)+8>>2]|0,164720)|0))break;if(qy(c[(c[(c[r>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0){J=1;break a}}while(0);if(c[r>>2]|0){if(!(c[(c[r>>2]|0)+36>>2]|0)){J=0;break}if(!(qy(c[(c[r>>2]|0)+8>>2]|0,164728)|0)){J=0;break}J=(qy(c[(c[(c[r>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0}else J=0}while(0);K=(c[r>>2]|0)!=0;if(!J)break;do if(K){if(!(c[(c[r>>2]|0)+36>>2]|0)){I=133;break}if(!(qy(c[(c[r>>2]|0)+8>>2]|0,164712)|0)){I=133;break}if(!(qy(c[(c[(c[r>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)){I=133;break}c[F>>2]=hG(c[j>>2]|0,c[k>>2]|0,c[r>>2]|0,22,c[(c[o>>2]|0)+52>>2]|0)|0}else I=133;while(0);b:do if((I|0)==133){I=0;do if(c[r>>2]|0){if(!(c[(c[r>>2]|0)+36>>2]|0))break;if(!(qy(c[(c[r>>2]|0)+8>>2]|0,164720)|0))break;if(!(qy(c[(c[(c[r>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0))break;c[F>>2]=hG(c[j>>2]|0,c[k>>2]|0,c[r>>2]|0,23,c[(c[o>>2]|0)+52>>2]|0)|0;break b}while(0);if(!(c[r>>2]|0))break;if(!(c[(c[r>>2]|0)+36>>2]|0))break;if(!(qy(c[(c[r>>2]|0)+8>>2]|0,164728)|0))break;if(!(qy(c[(c[(c[r>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0))break;c[F>>2]=hG(c[j>>2]|0,c[k>>2]|0,c[r>>2]|0,24,c[(c[o>>2]|0)+52>>2]|0)|0}while(0);C=c[F>>2]|0;if(c[G>>2]|0)c[(c[G>>2]|0)+8>>2]=C;else c[(c[o>>2]|0)+100>>2]=C;c[G>>2]=c[F>>2];c[r>>2]=c[(c[r>>2]|0)+24>>2]}if(K)uE(c[j>>2]|0,3033,0,c[l>>2]|0,c[r>>2]|0,0,164736);c[(c[o>>2]|0)+24>>2]=c[q>>2];if(c[x>>2]|0){zb[c[135736>>2]&511](c[x>>2]|0);c[x>>2]=0}r=c[o>>2]|0;if(c[n>>2]|0){c[h>>2]=r;H=c[h>>2]|0;i=g;return H|0}else{c[(c[p>>2]|0)+12>>2]=r;c[h>>2]=c[p>>2];H=c[h>>2]|0;i=g;return H|0}}}if(c[x>>2]|0){zb[c[135736>>2]&511](c[x>>2]|0);c[x>>2]=0}if(c[q>>2]|0){if(c[p>>2]|0)c[(c[p>>2]|0)+4>>2]=0;if(c[o>>2]|0)c[(c[o>>2]|0)+24>>2]=0;mB(c[q>>2]|0)}c[h>>2]=0;H=c[h>>2]|0;i=g;return H|0}function qE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;n=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[m>>2]=0;if((c[g>>2]|0)==0|(c[h>>2]|0)==0|(c[j>>2]|0)==0){c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}c[n>>2]=dE(c[j>>2]|0,161352)|0;d=c[g>>2]|0;if(!(c[n>>2]|0)){MF(d,3036,0,c[j>>2]|0,161352,0);c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}b=c[n>>2]|0;if(eE(d,0,b,IH(22)|0,k)|0){c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}b=(qy(c[k>>2]|0,163840)|0)!=0;d=c[g>>2]|0;if(b){b=c[n>>2]|0;hE(d,3056,0,b,IH(22)|0,0,0,163848,0,0);c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}if(qy(c[d+112>>2]|0,c[38860]|0)|0)AB(c[g>>2]|0,3057,c[j>>2]|0,0,163792,c[38860]|0,0);c[l>>2]=iG(c[g>>2]|0,c[h>>2]|0,c[k>>2]|0,c[(c[g>>2]|0)+112>>2]|0,c[j>>2]|0,1)|0;if(!(c[l>>2]|0)){c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}k=(c[l>>2]|0)+60|0;c[k>>2]=c[k>>2]|1;c[n>>2]=c[(c[j>>2]|0)+44>>2];while(1){if(!(c[n>>2]|0))break;k=c[n>>2]|0;if(!(c[(c[n>>2]|0)+36>>2]|0)){if(((((qy(c[k+8>>2]|0,161384)|0)==0?(qy(c[(c[n>>2]|0)+8>>2]|0,159128)|0)==0:0)?(qy(c[(c[n>>2]|0)+8>>2]|0,159120)|0)==0:0)?(qy(c[(c[n>>2]|0)+8>>2]|0,161352)|0)==0:0)?(qy(c[(c[n>>2]|0)+8>>2]|0,155448)|0)==0:0)GF(c[g>>2]|0,3035,0,c[n>>2]|0)}else if(qy(c[(c[k+36>>2]|0)+8>>2]|0,c[38526]|0)|0)GF(c[g>>2]|0,3035,0,c[n>>2]|0);c[n>>2]=c[(c[n>>2]|0)+24>>2]}fG(c[g>>2]|0,c[h>>2]|0,0,c[j>>2]|0,155448,(c[l>>2]|0)+28|0,(c[l>>2]|0)+24|0)|0;cE(c[g>>2]|0,c[j>>2]|0,161384)|0;k=RC(c[g>>2]|0,c[j>>2]|0,159120)|0;c[(c[l>>2]|0)+44>>2]=k;if(c[(c[l>>2]|0)+44>>2]|0){k=(c[l>>2]|0)+60|0;c[k>>2]=c[k>>2]|512}c[n>>2]=dE(c[j>>2]|0,159128)|0;do if(c[n>>2]|0){k=c[g>>2]|0;if(c[(c[l>>2]|0)+60>>2]&512){aG(k,3051,c[l>>2]|0,c[n>>2]|0,159128,159120);break}else{d=fE(k,c[n>>2]|0)|0;c[(c[l>>2]|0)+44>>2]=d;break}}while(0);c[m>>2]=c[(c[j>>2]|0)+12>>2];if((((c[m>>2]|0)!=0?(c[(c[m>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[m>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(qy(c[(c[(c[m>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){n=jE(c[g>>2]|0,c[m>>2]|0,1)|0;c[(c[l>>2]|0)+32>>2]=n;c[m>>2]=c[(c[m>>2]|0)+24>>2]}if((((c[m>>2]|0)!=0?(c[(c[m>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[m>>2]|0)+8>>2]|0,161024)|0)!=0:0)?(qy(c[(c[(c[m>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){n=c[g>>2]|0;if(c[(c[l>>2]|0)+24>>2]|0)uE(n,3055,0,c[j>>2]|0,c[m>>2]|0,164128,0);else{d=oE(n,c[h>>2]|0,c[m>>2]|0,0)|0;c[(c[l>>2]|0)+48>>2]=d}c[m>>2]=c[(c[m>>2]|0)+24>>2]}if(c[m>>2]|0)uE(c[g>>2]|0,3033,0,c[j>>2]|0,c[m>>2]|0,0,164200);c[f>>2]=c[l>>2];o=c[f>>2]|0;i=e;return o|0}function rE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+48|0;f=e+32|0;g=e+28|0;h=e+24|0;j=e+20|0;k=e+16|0;l=e+12|0;m=e+8|0;n=e+4|0;o=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[m>>2]=0;c[o>>2]=0;if((c[g>>2]|0)==0|(c[h>>2]|0)==0|(c[j>>2]|0)==0){c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}c[n>>2]=dE(c[j>>2]|0,161352)|0;d=c[g>>2]|0;if(!(c[n>>2]|0)){MF(d,3036,0,c[j>>2]|0,161352,0);c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}b=c[n>>2]|0;if(eE(d,0,b,IH(22)|0,k)|0){c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}c[l>>2]=jG(c[g>>2]|0,c[h>>2]|0,c[k>>2]|0,c[(c[g>>2]|0)+112>>2]|0,c[j>>2]|0)|0;if(!(c[l>>2]|0)){c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}c[n>>2]=c[(c[j>>2]|0)+44>>2];while(1){if(!(c[n>>2]|0))break;k=c[n>>2]|0;if(!(c[(c[n>>2]|0)+36>>2]|0)){if((qy(c[k+8>>2]|0,161352)|0)==0?(qy(c[(c[n>>2]|0)+8>>2]|0,161384)|0)==0:0)GF(c[g>>2]|0,3035,0,c[n>>2]|0)}else if(qy(c[(c[k+36>>2]|0)+8>>2]|0,c[38526]|0)|0)GF(c[g>>2]|0,3035,0,c[n>>2]|0);c[n>>2]=c[(c[n>>2]|0)+24>>2]}cE(c[g>>2]|0,c[j>>2]|0,161384)|0;c[m>>2]=c[(c[j>>2]|0)+12>>2];if((((c[m>>2]|0)!=0?(c[(c[m>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[m>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(qy(c[(c[(c[m>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){n=jE(c[g>>2]|0,c[m>>2]|0,1)|0;c[(c[l>>2]|0)+24>>2]=n;c[m>>2]=c[(c[m>>2]|0)+24>>2]}if((SF(c[g>>2]|0,c[h>>2]|0,m,(c[l>>2]|0)+56|0,16,o)|0)==-1){c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}if(c[o>>2]|0){o=(c[l>>2]|0)+36|0;c[o>>2]=c[o>>2]|16}if((((c[m>>2]|0)!=0?(c[(c[m>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[m>>2]|0)+8>>2]|0,163328)|0)!=0:0)?(qy(c[(c[(c[m>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){o=TF(c[g>>2]|0,c[h>>2]|0,c[m>>2]|0)|0;c[(c[l>>2]|0)+40>>2]=o;c[m>>2]=c[(c[m>>2]|0)+24>>2]}if(c[m>>2]|0)uE(c[g>>2]|0,3033,0,c[j>>2]|0,c[m>>2]|0,0,163344);c[f>>2]=c[l>>2];p=c[f>>2]|0;i=e;return p|0}function sE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;n=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[l>>2]=0;if((c[g>>2]|0)==0|(c[h>>2]|0)==0|(c[j>>2]|0)==0){c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}c[m>>2]=dE(c[j>>2]|0,161352)|0;d=c[g>>2]|0;if(!(c[m>>2]|0)){MF(d,3036,0,c[j>>2]|0,161352,0);c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}b=c[m>>2]|0;if(eE(d,0,b,IH(22)|0,n)|0){c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}c[k>>2]=kG(c[g>>2]|0,c[h>>2]|0,c[n>>2]|0,c[(c[g>>2]|0)+112>>2]|0,c[j>>2]|0)|0;if(!(c[k>>2]|0)){c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}c[m>>2]=c[(c[j>>2]|0)+44>>2];while(1){if(!(c[m>>2]|0))break;n=c[m>>2]|0;if(!(c[(c[m>>2]|0)+36>>2]|0)){if((qy(c[n+8>>2]|0,161352)|0)==0?(qy(c[(c[m>>2]|0)+8>>2]|0,161384)|0)==0:0)GF(c[g>>2]|0,3035,0,c[m>>2]|0)}else if(qy(c[(c[n+36>>2]|0)+8>>2]|0,c[38526]|0)|0)GF(c[g>>2]|0,3035,0,c[m>>2]|0);c[m>>2]=c[(c[m>>2]|0)+24>>2]}cE(c[g>>2]|0,c[j>>2]|0,161384)|0;c[l>>2]=c[(c[j>>2]|0)+12>>2];if((((c[l>>2]|0)!=0?(c[(c[l>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[l>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(qy(c[(c[(c[l>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){m=jE(c[g>>2]|0,c[l>>2]|0,1)|0;c[(c[k>>2]|0)+4>>2]=m;c[l>>2]=c[(c[l>>2]|0)+24>>2]}if((((c[l>>2]|0)!=0?(c[(c[l>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[l>>2]|0)+8>>2]|0,161648)|0)!=0:0)?(qy(c[(c[(c[l>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){m=QF(c[g>>2]|0,c[h>>2]|0,c[l>>2]|0,8,0)|0;c[(c[k>>2]|0)+12>>2]=m;c[l>>2]=c[(c[l>>2]|0)+24>>2]}else p=28;do if((p|0)==28){if((((c[l>>2]|0)!=0?(c[(c[l>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[l>>2]|0)+8>>2]|0,161656)|0)!=0:0)?(qy(c[(c[(c[l>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){m=QF(c[g>>2]|0,c[h>>2]|0,c[l>>2]|0,7,0)|0;c[(c[k>>2]|0)+12>>2]=m;c[l>>2]=c[(c[l>>2]|0)+24>>2];break}if((((c[l>>2]|0)!=0?(c[(c[l>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[l>>2]|0)+8>>2]|0,161664)|0)!=0:0)?(qy(c[(c[(c[l>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){m=QF(c[g>>2]|0,c[h>>2]|0,c[l>>2]|0,6,0)|0;c[(c[k>>2]|0)+12>>2]=m;c[l>>2]=c[(c[l>>2]|0)+24>>2]}}while(0);if(c[l>>2]|0)uE(c[g>>2]|0,3033,0,c[j>>2]|0,c[l>>2]|0,0,161680);c[f>>2]=c[k>>2];o=c[f>>2]|0;i=e;return o|0}function tE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[m>>2]=0;if((c[g>>2]|0)==0|(c[h>>2]|0)==0|(c[j>>2]|0)==0){c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}c[k>>2]=RC(c[g>>2]|0,c[j>>2]|0,161352)|0;d=c[g>>2]|0;if(!(c[k>>2]|0)){lG(d,c[j>>2]|0,c[m>>2]|0,1723,161360,0,0);c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}c[l>>2]=mG(d,c[h>>2]|0,c[k>>2]|0,c[(c[g>>2]|0)+112>>2]|0,c[j>>2]|0)|0;if(!(c[l>>2]|0)){c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}cE(c[g>>2]|0,c[j>>2]|0,161384)|0;c[m>>2]=c[(c[j>>2]|0)+12>>2];if((((c[m>>2]|0)!=0?(c[(c[m>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[m>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(qy(c[(c[(c[m>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){k=jE(c[g>>2]|0,c[m>>2]|0,1)|0;c[(c[l>>2]|0)+8>>2]=k;c[m>>2]=c[(c[m>>2]|0)+24>>2]}if(c[m>>2]|0)uE(c[g>>2]|0,3033,0,c[j>>2]|0,c[m>>2]|0,0,161392);c[f>>2]=c[l>>2];n=c[f>>2]|0;i=e;return n|0}function uE(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+32|0;k=j+28|0;l=j+24|0;m=j+20|0;n=j+16|0;o=j+12|0;p=j+8|0;q=j+4|0;r=j;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=h;c[r>>2]=0;GC(r,0,c[m>>2]|0,c[n>>2]|0)|0;do if(!(c[p>>2]|0)){m=c[k>>2]|0;h=c[n>>2]|0;g=c[o>>2]|0;f=c[l>>2]|0;e=c[r>>2]|0;if(c[q>>2]|0){lG(m,h,g,f,161272,e,c[q>>2]|0);break}else{lG(m,h,g,f,161320,e,0);break}}else lG(c[k>>2]|0,c[n>>2]|0,c[o>>2]|0,c[l>>2]|0,161256,c[r>>2]|0,c[p>>2]|0);while(0);if(!(c[r>>2]|0)){i=j;return}zb[c[135736>>2]&511](c[r>>2]|0);c[r>>2]=0;i=j;return}function vE(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+32|0;g=f+28|0;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f+4|0;o=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if((c[h>>2]|0)==0|(c[k>>2]|0)==0){c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}a:do if((c[(c[h>>2]|0)+44>>2]|0)!=0?(c[(c[(c[h>>2]|0)+44>>2]|0)+4>>2]|0)!=0:0){c[n>>2]=0;b:while(1){if((c[n>>2]|0)>=(c[(c[(c[h>>2]|0)+44>>2]|0)+4>>2]|0))break a;c[m>>2]=c[(c[c[(c[h>>2]|0)+44>>2]>>2]|0)+(c[n>>2]<<2)>>2];do if((c[c[m>>2]>>2]|0)==(c[j>>2]|0)){e=c[j>>2]|0;if((e|0)==4|(e|0)==5){if((c[(c[m>>2]|0)+8>>2]|0)!=(c[k>>2]|0))break;if((c[(c[m>>2]|0)+112>>2]|0)==(c[l>>2]|0)){q=11;break b}else break}else if((e|0)==16){if((c[(c[m>>2]|0)+8>>2]|0)!=(c[k>>2]|0))break;if((c[(c[m>>2]|0)+52>>2]|0)==(c[l>>2]|0)){q=17;break b}else break}else if((e|0)==17){if((c[(c[m>>2]|0)+16>>2]|0)!=(c[k>>2]|0))break;if((c[(c[m>>2]|0)+20>>2]|0)==(c[l>>2]|0)){q=14;break b}else break}else{q=18;break b}}while(0);c[n>>2]=(c[n>>2]|0)+1}if((q|0)==11){c[g>>2]=c[m>>2];p=c[g>>2]|0;i=f;return p|0}else if((q|0)==14){c[g>>2]=c[m>>2];p=c[g>>2]|0;i=f;return p|0}else if((q|0)==17){c[g>>2]=c[m>>2];p=c[g>>2]|0;i=f;return p|0}else if((q|0)==18){c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}}while(0);do if(c[(c[h>>2]|0)+24>>2]|0){c[o>>2]=c[(c[h>>2]|0)+24>>2];n=(c[h>>2]|0)+4|0;c[n>>2]=c[n>>2]|1;while(1){if(((c[(c[o>>2]|0)+12>>2]|0)!=0?(c[(c[(c[o>>2]|0)+12>>2]|0)+4>>2]&1|0)==0:0)?(c[m>>2]=vE(c[(c[o>>2]|0)+12>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0)|0,(c[m>>2]|0)!=0):0)break;c[o>>2]=c[c[o>>2]>>2];if(!(c[o>>2]|0)){q=27;break}}if((q|0)==27){n=(c[h>>2]|0)+4|0;c[n>>2]=c[n>>2]^1;break}c[g>>2]=c[m>>2];p=c[g>>2]|0;i=f;return p|0}while(0);c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}function wE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=0;if(!(c[h>>2]|0)){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}if((c[j>>2]|0)!=0?(qy(c[j>>2]|0,c[38526]|0)|0)!=0:0){c[k>>2]=QH(c[h>>2]|0,c[j>>2]|0)|0;if((c[k>>2]|0)==0&(c[g>>2]|0)!=0)n=7}else n=6;if((n|0)==6?(c[g>>2]|0)!=0:0)n=7;do if((n|0)==7){if((qy(c[j>>2]|0,c[(c[g>>2]|0)+4>>2]|0)|0)!=0?(c[k>>2]=Rj(c[(c[g>>2]|0)+28>>2]|0,c[h>>2]|0)|0,(c[k>>2]|0)!=0):0)break;if(($j(c[(c[g>>2]|0)+48>>2]|0)|0)>1){d=c[(c[g>>2]|0)+48>>2]|0;if(!(c[j>>2]|0))c[l>>2]=Rj(d,145792)|0;else c[l>>2]=Rj(d,c[j>>2]|0)|0;if(c[l>>2]|0)c[k>>2]=Rj(c[(c[(c[l>>2]|0)+52>>2]|0)+28>>2]|0,c[h>>2]|0)|0}}while(0);c[f>>2]=c[k>>2];m=c[f>>2]|0;i=e;return m|0}function xE(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;l=i;i=i+48|0;m=l+40|0;n=l+36|0;o=l+32|0;p=l+28|0;q=l+24|0;r=l+20|0;s=l+16|0;t=l+12|0;u=l+8|0;v=l+4|0;w=l;c[m>>2]=a;c[n>>2]=b;c[o>>2]=d;c[p>>2]=e;c[q>>2]=f;c[r>>2]=g;c[s>>2]=h;c[t>>2]=j;c[u>>2]=k;c[v>>2]=0;c[w>>2]=0;GC(v,0,c[o>>2]|0,c[p>>2]|0)|0;if(!(c[u>>2]|0))c[u>>2]=xF(c[t>>2]|0)|0;t=c[m>>2]|0;m=c[p>>2]|0;p=c[n>>2]|0;n=c[v>>2]|0;o=c[q>>2]|0;q=BB(w,c[s>>2]|0,c[r>>2]|0)|0;EF(t,m,p,0,0,0,160072,n,o,q,c[u>>2]|0,0);if(c[v>>2]|0){zb[c[135736>>2]&511](c[v>>2]|0);c[v>>2]=0}if(!(c[w>>2]|0)){i=l;return}zb[c[135736>>2]&511](c[w>>2]|0);c[w>>2]=0;i=l;return}function yE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=0;if((c[h>>2]|0)==0|(c[g>>2]|0)==0){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}do if(c[g>>2]|0){if((qy(c[j>>2]|0,c[(c[g>>2]|0)+4>>2]|0)|0)!=0?(c[k>>2]=Rj(c[(c[g>>2]|0)+40>>2]|0,c[h>>2]|0)|0,(c[k>>2]|0)!=0):0)break;if(($j(c[(c[g>>2]|0)+48>>2]|0)|0)>1){d=c[(c[g>>2]|0)+48>>2]|0;if(!(c[j>>2]|0))c[l>>2]=Rj(d,145792)|0;else c[l>>2]=Rj(d,c[j>>2]|0)|0;if(c[l>>2]|0)c[k>>2]=Rj(c[(c[(c[l>>2]|0)+52>>2]|0)+40>>2]|0,c[h>>2]|0)|0}}while(0);c[f>>2]=c[k>>2];m=c[f>>2]|0;i=e;return m|0}function zE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+48|0;e=d+32|0;f=d+28|0;g=d+24|0;h=d+20|0;j=d+16|0;k=d+12|0;l=d+8|0;m=d+4|0;n=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=c[(c[g>>2]|0)+92>>2];c[j>>2]=0;a:while(1){if(!(c[h>>2]|0))break;c[m>>2]=c[(c[(c[h>>2]|0)+4>>2]|0)+12>>2];c[n>>2]=c[(c[(c[h>>2]|0)+4>>2]|0)+16>>2];c[l>>2]=wE(c[(c[f>>2]|0)+36>>2]|0,c[m>>2]|0,c[n>>2]|0)|0;do if(c[l>>2]|0){if((c[c[l>>2]>>2]|0)!=4){if((c[c[l>>2]>>2]|0)!=1)break;if((c[(c[l>>2]|0)+88>>2]|0)==45)break}c[(c[h>>2]|0)+4>>2]=c[l>>2];c[j>>2]=c[h>>2];c[h>>2]=c[c[h>>2]>>2];continue a}while(0);xE(c[f>>2]|0,3004,c[g>>2]|0,c[(c[g>>2]|0)+36>>2]|0,160512,c[m>>2]|0,c[n>>2]|0,4,0);b=c[c[h>>2]>>2]|0;if(!(c[j>>2]|0))c[(c[g>>2]|0)+92>>2]=b;else c[c[j>>2]>>2]=b;c[k>>2]=c[h>>2];c[h>>2]=c[c[h>>2]>>2];zb[c[135736>>2]&511](c[k>>2]|0)}c[l>>2]=c[(c[g>>2]|0)+28>>2];while(1){if(!(c[l>>2]|0)){o=20;break}c[h>>2]=Cb[c[135744>>2]&511](8)|0;if(!(c[h>>2]|0)){o=15;break}c[(c[h>>2]|0)+4>>2]=c[l>>2];c[c[h>>2]>>2]=0;k=c[h>>2]|0;if(!(c[j>>2]|0))c[(c[g>>2]|0)+92>>2]=k;else c[c[j>>2]>>2]=k;c[j>>2]=c[h>>2];c[l>>2]=c[(c[l>>2]|0)+4>>2]}if((o|0)==15){tC(c[f>>2]|0,149752,0);c[e>>2]=-1;p=c[e>>2]|0;i=d;return p|0}else if((o|0)==20){c[e>>2]=0;p=c[e>>2]|0;i=d;return p|0}return 0}function AE(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;e=c[k>>2]|0;if((e|0)==17){c[h>>2]=nG(c[j>>2]|0,c[l>>2]|0,c[m>>2]|0)|0;n=c[h>>2]|0;i=f;return n|0}else if((e|0)==14){c[h>>2]=yE(c[j>>2]|0,c[l>>2]|0,c[m>>2]|0)|0;n=c[h>>2]|0;i=f;return n|0}else{m=c[33976]|0;l=c[33980]|0;c[g>>2]=140328;c[g+4>>2]=4984;Db[m&511](l,140296,g);c[h>>2]=0;n=c[h>>2]|0;i=f;return n|0}return 0}function BE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=0;if((c[h>>2]|0)==0|(c[g>>2]|0)==0){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}do if(c[g>>2]|0){if((qy(c[j>>2]|0,c[(c[g>>2]|0)+4>>2]|0)|0)!=0?(c[k>>2]=Rj(c[(c[g>>2]|0)+32>>2]|0,c[h>>2]|0)|0,(c[k>>2]|0)!=0):0)break;if(($j(c[(c[g>>2]|0)+48>>2]|0)|0)>1){d=c[(c[g>>2]|0)+48>>2]|0;if(!(c[j>>2]|0))c[l>>2]=Rj(d,145792)|0;else c[l>>2]=Rj(d,c[j>>2]|0)|0;if(c[l>>2]|0)c[k>>2]=Rj(c[(c[(c[l>>2]|0)+52>>2]|0)+32>>2]|0,c[h>>2]|0)|0}}while(0);c[f>>2]=c[k>>2];m=c[f>>2]|0;i=e;return m|0}function CE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=0;if((c[h>>2]|0)==0|(c[g>>2]|0)==0){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}do if(c[g>>2]|0){if((qy(c[j>>2]|0,c[(c[g>>2]|0)+4>>2]|0)|0)!=0?(c[k>>2]=Rj(c[(c[g>>2]|0)+36>>2]|0,c[h>>2]|0)|0,(c[k>>2]|0)!=0):0)break;if(($j(c[(c[g>>2]|0)+48>>2]|0)|0)>1){d=c[(c[g>>2]|0)+48>>2]|0;if(!(c[j>>2]|0))c[l>>2]=Rj(d,145792)|0;else c[l>>2]=Rj(d,c[j>>2]|0)|0;if(c[l>>2]|0)c[k>>2]=Rj(c[(c[(c[l>>2]|0)+52>>2]|0)+36>>2]|0,c[h>>2]|0)|0}}while(0);c[f>>2]=c[k>>2];m=c[f>>2]|0;i=e;return m|0}function DE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=0;if((c[h>>2]|0)==0|(c[g>>2]|0)==0){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}do if(c[g>>2]|0){if((qy(c[j>>2]|0,c[(c[g>>2]|0)+4>>2]|0)|0)!=0?(c[k>>2]=Rj(c[(c[g>>2]|0)+76>>2]|0,c[h>>2]|0)|0,(c[k>>2]|0)!=0):0)break;if(($j(c[(c[g>>2]|0)+48>>2]|0)|0)>1){d=c[(c[g>>2]|0)+48>>2]|0;if(!(c[j>>2]|0))c[l>>2]=Rj(d,145792)|0;else c[l>>2]=Rj(d,c[j>>2]|0)|0;if(c[l>>2]|0)c[k>>2]=Rj(c[(c[(c[l>>2]|0)+52>>2]|0)+76>>2]|0,c[h>>2]|0)|0}}while(0);c[f>>2]=c[k>>2];m=c[f>>2]|0;i=e;return m|0}function EE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if((c[j>>2]|0)!=0?(c[c[j>>2]>>2]|0)!=1:0){if((c[h>>2]|0)==(c[j>>2]|0)){d=c[g>>2]|0;b=c[h>>2]|0;GE(d,3009,b,FC(c[h>>2]|0)|0,160032,0);c[f>>2]=3009;l=c[f>>2]|0;i=e;return l|0}if(c[(c[j>>2]|0)+48>>2]&65536){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}else{b=(c[j>>2]|0)+48|0;c[b>>2]=c[b>>2]|65536;c[k>>2]=EE(c[g>>2]|0,c[h>>2]|0,c[(c[j>>2]|0)+64>>2]|0)|0;h=(c[j>>2]|0)+48|0;c[h>>2]=c[h>>2]^65536;c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}}c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}function FE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;a:while(1){if(!(c[g>>2]|0)){l=14;break}c[j>>2]=c[(c[g>>2]|0)+12>>2];do if(c[j>>2]|0){b=c[c[j>>2]>>2]|0;if((b|0)==8|(b|0)==7|(b|0)==6){c[h>>2]=FE(c[f>>2]|0,c[(c[j>>2]|0)+12>>2]|0)|0;if(c[h>>2]|0){l=12;break a}else break}else if((b|0)!=17)break;c[k>>2]=c[j>>2];if((c[k>>2]|0)==(c[f>>2]|0)){l=6;break a}if(((c[(c[k>>2]|0)+28>>2]&1|0)==0?(c[(c[k>>2]|0)+12>>2]|0)!=0:0)?(b=(c[k>>2]|0)+28|0,c[b>>2]=c[b>>2]|1,c[h>>2]=FE(c[f>>2]|0,c[(c[(c[k>>2]|0)+12>>2]|0)+12>>2]|0)|0,b=(c[k>>2]|0)+28|0,c[b>>2]=c[b>>2]^1,(c[h>>2]|0)!=0):0){l=10;break a}}while(0);c[g>>2]=c[(c[g>>2]|0)+8>>2]}if((l|0)==6){c[e>>2]=c[g>>2];m=c[e>>2]|0;i=d;return m|0}else if((l|0)==10){c[e>>2]=c[h>>2];m=c[e>>2]|0;i=d;return m|0}else if((l|0)==12){c[e>>2]=c[h>>2];m=c[e>>2]|0;i=d;return m|0}else if((l|0)==14){c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}return 0}function GE(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+32|0;j=h+20|0;k=h+16|0;l=h+12|0;m=h+8|0;n=h+4|0;o=h;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;oG(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,0,0);i=h;return}function HE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[f>>2]=a;c[g>>2]=b;c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[(c[g>>2]|0)+4>>2]|0)){m=14;break}c[j>>2]=c[(c[c[g>>2]>>2]|0)+(c[l>>2]<<2)>>2];if(((c[c[j>>2]>>2]|0)==2e3?(c[(c[j>>2]|0)+8>>2]|0)==16:0)?(c[(c[j>>2]|0)+4>>2]|0)!=0:0){c[h>>2]=c[(c[j>>2]|0)+4>>2];if((c[h>>2]|0)==(c[f>>2]|0)){m=7;break}if((((c[(c[h>>2]|0)+36>>2]&4|0)==0?(c[(c[h>>2]|0)+56>>2]|0)!=0:0)?(c[(c[h>>2]|0)+36>>2]&16|0)!=0:0)?(b=(c[h>>2]|0)+36|0,c[b>>2]=c[b>>2]|4,c[k>>2]=HE(c[f>>2]|0,c[(c[h>>2]|0)+56>>2]|0)|0,b=(c[h>>2]|0)+36|0,c[b>>2]=c[b>>2]^4,(c[k>>2]|0)!=0):0){m=12;break}}c[l>>2]=(c[l>>2]|0)+1}if((m|0)==7){c[e>>2]=c[j>>2];n=c[e>>2]|0;i=d;return n|0}else if((m|0)==12){c[e>>2]=c[k>>2];n=c[e>>2]|0;i=d;return n|0}else if((m|0)==14){c[e>>2]=0;n=c[e>>2]|0;i=d;return n|0}return 0}function IE(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;g=i;i=i+64|0;h=g+56|0;j=g+52|0;k=g+48|0;l=g+44|0;m=g+40|0;n=g+36|0;o=g+32|0;p=g+28|0;q=g+24|0;r=g+20|0;s=g+16|0;t=g+12|0;u=g+8|0;v=g+4|0;w=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[t>>2]=(c[c[l>>2]>>2]|0)==0?0:1;if(c[n>>2]|0)c[(c[n>>2]|0)+4>>2]=0;c[r>>2]=0;a:while(1){if((c[r>>2]|0)>=(c[(c[m>>2]|0)+4>>2]|0)){x=41;break}c[p>>2]=c[(c[c[m>>2]>>2]|0)+(c[r>>2]<<2)>>2];b:do if((c[c[p>>2]>>2]|0)!=2001){if((c[c[p>>2]>>2]|0)==2e3?(c[(c[p>>2]|0)+8>>2]|0)==16:0){if(!(c[(c[p>>2]|0)+4>>2]|0)){x=14;break a}c[o>>2]=c[(c[p>>2]|0)+4>>2];if((c[(c[o>>2]|0)+36>>2]&1|0)==0?(iD(c[j>>2]|0,c[o>>2]|0)|0)==-1:0){x=17;break a}do if(c[(c[o>>2]|0)+40>>2]|0){if(!(c[c[l>>2]>>2]|0)){c[c[l>>2]>>2]=c[(c[o>>2]|0)+40>>2];break}if(!(c[t>>2]|0)){f=c[j>>2]|0;e=c[(c[j>>2]|0)+36>>2]|0;c[u>>2]=qG(f,e,21,FC(c[k>>2]|0)|0)|0;if(!(c[u>>2]|0)){x=23;break a}if((rG(c[j>>2]|0,c[u>>2]|0,c[c[l>>2]>>2]|0)|0)==-1){x=25;break a}c[(c[u>>2]|0)+24>>2]=c[(c[c[l>>2]>>2]|0)+24>>2];c[c[l>>2]>>2]=c[u>>2];c[t>>2]=1}if((sG(c[j>>2]|0,c[c[l>>2]>>2]|0,c[(c[o>>2]|0)+40>>2]|0)|0)==-1){x=28;break a}}while(0);c[q>>2]=c[(c[o>>2]|0)+56>>2];if((c[q>>2]|0)!=0?(c[(c[q>>2]|0)+4>>2]|0)!=0:0){c[(c[c[m>>2]>>2]|0)+(c[r>>2]<<2)>>2]=c[c[c[q>>2]>>2]>>2];if((c[(c[q>>2]|0)+4>>2]|0)==1)break;c[s>>2]=1;while(1){if((c[s>>2]|0)>=(c[(c[q>>2]|0)+4>>2]|0))break b;c[r>>2]=(c[r>>2]|0)+1;if((tG(c[m>>2]|0,c[(c[c[q>>2]>>2]|0)+(c[s>>2]<<2)>>2]|0,c[r>>2]|0)|0)==-1){x=38;break a}c[s>>2]=(c[s>>2]|0)+1}}if((TE(c[m>>2]|0,c[r>>2]|0)|0)==-1){x=32;break a}c[r>>2]=(c[r>>2]|0)+-1}}else{if(!(c[n>>2]|0)){x=7;break a}if((TE(c[m>>2]|0,c[r>>2]|0)|0)==-1){x=9;break a}c[r>>2]=(c[r>>2]|0)+-1;pG(c[n>>2]|0,2,c[p>>2]|0)|0}while(0);c[r>>2]=(c[r>>2]|0)+1}switch(x|0){case 7:{xB(c[j>>2]|0,152800,152840);c[h>>2]=-1;y=c[h>>2]|0;i=g;return y|0}case 9:{c[h>>2]=-1;y=c[h>>2]|0;i=g;return y|0}case 14:{c[h>>2]=-1;y=c[h>>2]|0;i=g;return y|0}case 17:{c[h>>2]=-1;
y=c[h>>2]|0;i=g;return y|0}case 23:{c[h>>2]=-1;y=c[h>>2]|0;i=g;return y|0}case 25:{c[h>>2]=-1;y=c[h>>2]|0;i=g;return y|0}case 28:{c[h>>2]=-1;y=c[h>>2]|0;i=g;return y|0}case 32:{c[h>>2]=-1;y=c[h>>2]|0;i=g;return y|0}case 38:{c[h>>2]=-1;y=c[h>>2]|0;i=g;return y|0}case 41:{c:do if(((c[n>>2]|0)!=0?(c[(c[n>>2]|0)+4>>2]|0)!=0:0)?(c[(c[m>>2]|0)+4>>2]|0)!=0:0){c[r>>2]=(c[(c[n>>2]|0)+4>>2]|0)-1;while(1){if((c[r>>2]|0)<0)break c;c[v>>2]=c[(c[c[n>>2]>>2]|0)+(c[r>>2]<<2)>>2];c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[(c[m>>2]|0)+4>>2]|0))break;c[p>>2]=c[(c[c[m>>2]>>2]|0)+(c[s>>2]<<2)>>2];if((c[(c[v>>2]|0)+8>>2]|0)==(c[(c[(c[p>>2]|0)+12>>2]|0)+8>>2]|0)?(c[(c[v>>2]|0)+12>>2]|0)==(c[(c[(c[p>>2]|0)+12>>2]|0)+56>>2]|0):0){x=50;break}c[s>>2]=(c[s>>2]|0)+1}if((x|0)==50){x=0;c[w>>2]=0;q=c[j>>2]|0;o=c[(c[v>>2]|0)+4>>2]|0;NC(q,3086,o,0,152880,BB(w,c[(c[v>>2]|0)+12>>2]|0,c[(c[v>>2]|0)+8>>2]|0)|0,0,0);if(c[w>>2]|0){zb[c[135736>>2]&511](c[w>>2]|0);c[w>>2]=0}if((TE(c[n>>2]|0,c[r>>2]|0)|0)==-1)break}c[r>>2]=(c[r>>2]|0)+-1}c[h>>2]=-1;y=c[h>>2]|0;i=g;return y|0}while(0);c[h>>2]=0;y=c[h>>2]|0;i=g;return y|0}}return 0}function JE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=c[j>>2];a:while(1){if(!(c[k>>2]|0)){n=14;break}c[l>>2]=c[(c[k>>2]|0)+4>>2];while(1){if(!(c[l>>2]|0))break;if((c[c[l>>2]>>2]|0)==1)break;if((c[l>>2]|0)==(c[h>>2]|0)){n=7;break a}if(((c[(c[l>>2]|0)+48>>2]&128|0)!=0?(c[(c[l>>2]|0)+48>>2]&65536|0)==0:0)?(j=(c[l>>2]|0)+48|0,c[j>>2]=c[j>>2]|65536,j=c[g>>2]|0,d=c[h>>2]|0,c[m>>2]=JE(j,d,EC(c[l>>2]|0)|0)|0,d=(c[l>>2]|0)+48|0,c[d>>2]=c[d>>2]^65536,(c[m>>2]|0)!=0):0){n=11;break a}c[l>>2]=c[(c[l>>2]|0)+64>>2]}c[k>>2]=c[c[k>>2]>>2]}if((n|0)==7){GE(c[g>>2]|0,3003,c[h>>2]|0,0,159872,0);c[f>>2]=3003;o=c[f>>2]|0;i=e;return o|0}else if((n|0)==11){c[f>>2]=c[m>>2];o=c[f>>2]|0;i=e;return o|0}else if((n|0)==14){c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}return 0}function KE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;do if(!(c[f>>2]|0))c[e>>2]=0;else{if((c[c[g>>2]>>2]|0)!=1){xB(c[g>>2]|0,147104,147128);c[e>>2]=-1;break}if((c[c[f>>2]>>2]|0)!=1?(c[(c[f>>2]|0)+48>>2]&4194304|0)==0:0){if((c[c[f>>2]>>2]|0)==5){c[e>>2]=qD(c[g>>2]|0,c[f>>2]|0)|0;break}if((c[c[f>>2]>>2]|0)==4){c[e>>2]=lD(c[g>>2]|0,c[f>>2]|0)|0;break}else{c[e>>2]=0;break}}c[e>>2]=0}while(0);i=d;return c[e>>2]|0}function LE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d+28|0;f=d+24|0;g=d+20|0;h=d+16|0;j=d+12|0;k=d+8|0;l=d+4|0;m=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=c[(c[g>>2]|0)+92>>2];a:while(1){if(!(c[h>>2]|0)){n=15;break}if((c[c[(c[h>>2]|0)+4>>2]>>2]|0)!=1?(c[(c[(c[h>>2]|0)+4>>2]|0)+48>>2]&4194304|0)==0:0)KE(c[(c[h>>2]|0)+4>>2]|0,c[f>>2]|0)|0;b:do if(((c[(c[(c[h>>2]|0)+4>>2]|0)+48>>2]&128|0)!=0?(c[l>>2]=EC(c[(c[h>>2]|0)+4>>2]|0)|0,(c[l>>2]|0)!=0):0)?(c[(c[h>>2]|0)+4>>2]=c[(c[l>>2]|0)+4>>2],(c[c[l>>2]>>2]|0)!=0):0){c[j>>2]=c[c[h>>2]>>2];c[l>>2]=c[c[l>>2]>>2];c[k>>2]=c[h>>2];while(1){if(!(c[l>>2]|0))break b;c[m>>2]=Cb[c[135744>>2]&511](8)|0;if(!(c[m>>2]|0)){n=12;break a}c[(c[m>>2]|0)+4>>2]=c[(c[l>>2]|0)+4>>2];c[c[k>>2]>>2]=c[m>>2];c[k>>2]=c[m>>2];c[c[m>>2]>>2]=c[j>>2];c[l>>2]=c[c[l>>2]>>2]}}while(0);c[h>>2]=c[c[h>>2]>>2]}if((n|0)==12){tC(c[f>>2]|0,149752,0);c[e>>2]=-1;o=c[e>>2]|0;i=d;return o|0}else if((n|0)==15){c[e>>2]=0;o=c[e>>2]|0;i=d;return o|0}return 0}function ME(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=c[(c[g>>2]|0)+64>>2];c[j>>2]=0;if(!(c[h>>2]|0)){GE(c[f>>2]|0,3008,c[g>>2]|0,0,149560,0);c[e>>2]=3008;k=c[e>>2]|0;i=d;return k|0}do if((c[c[h>>2]>>2]|0)!=4){if((c[c[h>>2]>>2]|0)==1?(c[(c[h>>2]|0)+88>>2]|0)!=45:0)break;b=c[f>>2]|0;a=c[g>>2]|0;GE(b,3008,a,0,149584,YD(j,c[h>>2]|0)|0);if(c[j>>2]|0){zb[c[135736>>2]&511](c[j>>2]|0);c[j>>2]=0}c[e>>2]=3008;k=c[e>>2]|0;i=d;return k|0}while(0);if(!((c[(c[g>>2]|0)+48>>2]&64|0)==0?(c[(c[g>>2]|0)+48>>2]&128|0)==0:0))l=11;do if((l|0)==11?(c[(c[g>>2]|0)+48>>2]&4|0)==0:0){if((c[c[h>>2]>>2]|0)==1?(c[(c[h>>2]|0)+88>>2]|0)==46:0)break;if((c[c[h>>2]>>2]|0)!=4){a=c[f>>2]|0;b=c[g>>2]|0;GE(a,3008,b,0,149624,YD(j,c[h>>2]|0)|0);if(c[j>>2]|0){zb[c[135736>>2]&511](c[j>>2]|0);c[j>>2]=0}c[e>>2]=3008;k=c[e>>2]|0;i=d;return k|0}}while(0);if(((c[(c[g>>2]|0)+48>>2]&256|0)==0?(c[(c[g>>2]|0)+48>>2]&128|0)==0:0)?(c[(c[g>>2]|0)+48>>2]&64|0)==0:0){GE(c[f>>2]|0,3008,c[g>>2]|0,0,149728,0);c[e>>2]=3008;k=c[e>>2]|0;i=d;return k|0}if(!(uG(c[h>>2]|0,1024)|0)){c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}l=c[f>>2]|0;f=c[g>>2]|0;GE(l,3010,f,0,149224,YD(j,c[h>>2]|0)|0);if(c[j>>2]|0){zb[c[135736>>2]&511](c[j>>2]|0);c[j>>2]=0}c[e>>2]=3010;k=c[e>>2]|0;i=d;return k|0}function NE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=i;i=i+96|0;e=d+80|0;f=d+76|0;g=d+72|0;h=d+68|0;j=d+64|0;k=d+60|0;l=d+56|0;m=d+52|0;n=d+48|0;o=d+44|0;p=d+40|0;q=d+36|0;r=d+32|0;s=d+28|0;t=d+24|0;u=d+20|0;v=d+16|0;w=d+12|0;x=d+8|0;y=d+4|0;z=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;if((c[c[g>>2]>>2]|0)!=4){xB(c[f>>2]|0,148320,148352);c[e>>2]=-1;A=c[e>>2]|0;i=d;return A|0}b=c[g>>2]|0;a:do if(c[(c[g>>2]|0)+48>>2]&256){if(!(c[(c[b+64>>2]|0)+48>>2]&256)){a=c[f>>2]|0;B=c[g>>2]|0;GE(a,3011,B,0,148400,YD(h,c[(c[g>>2]|0)+64>>2]|0)|0);if(c[h>>2]|0){zb[c[135736>>2]&511](c[h>>2]|0);c[h>>2]=0}c[e>>2]=3011;A=c[e>>2]|0;i=d;return A|0}if(uG(c[(c[g>>2]|0)+64>>2]|0,1024)|0){B=c[f>>2]|0;a=c[g>>2]|0;GE(B,3012,a,0,148448,YD(h,c[(c[g>>2]|0)+64>>2]|0)|0);if(c[h>>2]|0){zb[c[135736>>2]&511](c[h>>2]|0);c[h>>2]=0}c[e>>2]=3012;A=c[e>>2]|0;i=d;return A|0}if(c[(c[g>>2]|0)+68>>2]|0){c[l>>2]=1;c[j>>2]=TD(c[g>>2]|0)|0;if(!(c[j>>2]|0)){xB(c[f>>2]|0,148320,148512);c[e>>2]=-1;A=c[e>>2]|0;i=d;return A|0}c[k>>2]=c[(c[g>>2]|0)+68>>2];do{if(!(HH(c[j>>2]|0,c[c[k>>2]>>2]|0)|0)){c[l>>2]=0;vG(c[f>>2]|0,3013,c[g>>2]|0,c[j>>2]|0,c[k>>2]|0)}c[k>>2]=c[(c[k>>2]|0)+4>>2]}while((c[k>>2]|0)!=0);if(!(c[l>>2]|0)){c[e>>2]=3013;A=c[e>>2]|0;i=d;return A|0}}}else{if(!(c[b+48>>2]&64)){if(!(c[(c[g>>2]|0)+48>>2]&128))break;c[u>>2]=c[(c[g>>2]|0)+92>>2];while(1){if(!(c[u>>2]|0))break;if((c[c[(c[u>>2]|0)+4>>2]>>2]|0)!=1?(c[(c[(c[u>>2]|0)+4>>2]|0)+48>>2]&4194304|0)==0:0)KE(c[(c[u>>2]|0)+4>>2]|0,c[f>>2]|0)|0;if((c[(c[(c[u>>2]|0)+4>>2]|0)+48>>2]&256|0)==0?(c[(c[(c[u>>2]|0)+4>>2]|0)+48>>2]&64|0)==0:0){C=91;break}c[u>>2]=c[c[u>>2]>>2]}if((C|0)==91){a=c[f>>2]|0;B=c[g>>2]|0;GE(a,3023,B,0,149040,YD(h,c[(c[u>>2]|0)+4>>2]|0)|0);if(c[h>>2]|0){zb[c[135736>>2]&511](c[h>>2]|0);c[h>>2]=0}c[e>>2]=3023;A=c[e>>2]|0;i=d;return A|0}B=c[g>>2]|0;if((c[(c[(c[g>>2]|0)+64>>2]|0)+88>>2]|0)==46){c[u>>2]=c[B+92>>2];while(1){if(!(c[u>>2]|0)){C=103;break}if(uG(c[(c[u>>2]|0)+4>>2]|0,4096)|0)break;c[u>>2]=c[c[u>>2]>>2]}if((C|0)==103){if(!(c[(c[g>>2]|0)+96>>2]|0))break;GE(c[f>>2]|0,3025,c[g>>2]|0,0,149160,0);c[e>>2]=3025;A=c[e>>2]|0;i=d;return A|0}a=c[f>>2]|0;D=c[g>>2]|0;GE(a,3024,D,0,149104,YD(h,c[(c[u>>2]|0)+4>>2]|0)|0);if(c[h>>2]|0){zb[c[135736>>2]&511](c[h>>2]|0);c[h>>2]=0}c[e>>2]=3024;A=c[e>>2]|0;i=d;return A|0}if(!(c[(c[B+64>>2]|0)+48>>2]&128)){D=c[f>>2]|0;a=c[g>>2]|0;GE(D,3027,a,0,149184,YD(h,c[(c[g>>2]|0)+64>>2]|0)|0);if(c[h>>2]|0){zb[c[135736>>2]&511](c[h>>2]|0);c[h>>2]=0}c[e>>2]=3027;A=c[e>>2]|0;i=d;return A|0}if(uG(c[(c[g>>2]|0)+64>>2]|0,1024)|0){a=c[f>>2]|0;D=c[g>>2]|0;GE(a,3026,D,0,149224,YD(h,c[(c[g>>2]|0)+64>>2]|0)|0);if(c[h>>2]|0){zb[c[135736>>2]&511](c[h>>2]|0);c[h>>2]=0}c[e>>2]=3026;A=c[e>>2]|0;i=d;return A|0}b:do if(c[(c[g>>2]|0)+92>>2]|0){c[u>>2]=c[(c[g>>2]|0)+92>>2];c[v>>2]=EC(c[(c[g>>2]|0)+64>>2]|0)|0;if((c[u>>2]|0)==0&(c[v>>2]|0)!=0)xB(c[f>>2]|0,148320,149296);while(1){if(!(c[u>>2]|0))break b;if(c[v>>2]|0){if((c[(c[u>>2]|0)+4>>2]|0)!=(c[(c[v>>2]|0)+4>>2]|0)?(xG(c[f>>2]|0,c[(c[u>>2]|0)+4>>2]|0,c[(c[v>>2]|0)+4>>2]|0,0)|0)!=0:0)break}else xB(c[f>>2]|0,148320,149296);c[u>>2]=c[c[u>>2]>>2];if(!(c[v>>2]|0))continue;c[v>>2]=c[c[v>>2]>>2]}c[w>>2]=0;c[x>>2]=0;D=c[f>>2]|0;a=c[g>>2]|0;E=YD(h,c[(c[u>>2]|0)+4>>2]|0)|0;F=YD(w,c[(c[v>>2]|0)+4>>2]|0)|0;oG(D,3028,a,0,149344,E,F,YD(x,c[(c[g>>2]|0)+64>>2]|0)|0);if(c[h>>2]|0){zb[c[135736>>2]&511](c[h>>2]|0);c[h>>2]=0}if(c[w>>2]|0){zb[c[135736>>2]&511](c[w>>2]|0);c[w>>2]=0}if(c[x>>2]|0){zb[c[135736>>2]&511](c[x>>2]|0);c[x>>2]=0}c[e>>2]=3028;A=c[e>>2]|0;i=d;return A|0}while(0);if(!(c[(c[g>>2]|0)+68>>2]|0))break;c[z>>2]=1;c[y>>2]=c[(c[g>>2]|0)+68>>2];do{if((c[c[y>>2]>>2]|0)!=1006?(c[c[y>>2]>>2]|0)!=1007:0){wG(c[f>>2]|0,3029,c[g>>2]|0,c[y>>2]|0);c[z>>2]=0}c[y>>2]=c[(c[y>>2]|0)+4>>2]}while((c[y>>2]|0)!=0);if(c[z>>2]|0)break;c[e>>2]=3029;A=c[e>>2]|0;i=d;return A|0}c[m>>2]=0;c[m>>2]=c[(c[g>>2]|0)+28>>2];do if(c[m>>2]|0){if((c[c[m>>2]>>2]|0)!=4){if((c[c[m>>2]>>2]|0)!=1)break;if((c[(c[m>>2]|0)+88>>2]|0)==45)break}if((c[c[m>>2]>>2]|0)!=1?(c[(c[m>>2]|0)+48>>2]&4194304|0)==0:0)KE(c[m>>2]|0,c[f>>2]|0)|0;if((c[(c[m>>2]|0)+48>>2]&256|0)==0?(c[(c[m>>2]|0)+48>>2]&128|0)==0:0){B=c[f>>2]|0;F=c[g>>2]|0;GE(B,3015,F,0,148584,YD(h,c[m>>2]|0)|0);if(c[h>>2]|0){zb[c[135736>>2]&511](c[h>>2]|0);c[h>>2]=0}c[e>>2]=3015;A=c[e>>2]|0;i=d;return A|0}c:do if(c[(c[m>>2]|0)+48>>2]&128){c[n>>2]=c[(c[m>>2]|0)+92>>2];while(1){if(!(c[n>>2]|0))break c;if(!(c[(c[(c[n>>2]|0)+4>>2]|0)+48>>2]&256))break;c[n>>2]=c[c[n>>2]>>2]}F=c[f>>2]|0;B=c[g>>2]|0;GE(F,3015,B,0,148648,YD(h,c[(c[n>>2]|0)+4>>2]|0)|0);if(c[h>>2]|0){zb[c[135736>>2]&511](c[h>>2]|0);c[h>>2]=0}c[e>>2]=3015;A=c[e>>2]|0;i=d;return A|0}while(0);if((c[c[(c[g>>2]|0)+64>>2]>>2]|0)==1?(c[(c[(c[g>>2]|0)+64>>2]|0)+88>>2]|0)==46:0){if(uG(c[m>>2]|0,2048)|0){B=c[f>>2]|0;F=c[g>>2]|0;GE(B,3016,F,0,148736,YD(h,c[m>>2]|0)|0);if(c[h>>2]|0){zb[c[135736>>2]&511](c[h>>2]|0);c[h>>2]=0}c[e>>2]=3016;A=c[e>>2]|0;i=d;return A|0}if(!(c[(c[g>>2]|0)+68>>2]|0))break a;c[o>>2]=c[(c[g>>2]|0)+68>>2];while(1){if((c[c[o>>2]>>2]|0)!=1008)break;c[o>>2]=c[(c[o>>2]|0)+4>>2];if(!(c[o>>2]|0))break a}wG(c[f>>2]|0,3017,c[g>>2]|0,c[o>>2]|0);c[e>>2]=3017;A=c[e>>2]|0;i=d;return A|0}if(!(c[(c[(c[g>>2]|0)+64>>2]|0)+48>>2]&64)){F=c[f>>2]|0;B=c[g>>2]|0;GE(F,3018,B,0,148792,YD(h,c[(c[g>>2]|0)+64>>2]|0)|0);if(c[h>>2]|0){zb[c[135736>>2]&511](c[h>>2]|0);c[h>>2]=0}c[e>>2]=3018;A=c[e>>2]|0;i=d;return A|0}if(uG(c[(c[g>>2]|0)+64>>2]|0,1024)|0){B=c[f>>2]|0;F=c[g>>2]|0;GE(B,3019,F,0,148832,YD(h,c[(c[g>>2]|0)+64>>2]|0)|0);if(c[h>>2]|0){zb[c[135736>>2]&511](c[h>>2]|0);c[h>>2]=0}c[e>>2]=3019;A=c[e>>2]|0;i=d;return A|0}c[p>>2]=c[(c[(c[g>>2]|0)+64>>2]|0)+28>>2];do if(c[p>>2]|0){if((c[c[p>>2]>>2]|0)!=4){if((c[c[p>>2]>>2]|0)!=1)break;if((c[(c[p>>2]|0)+88>>2]|0)==45)break}if((c[m>>2]|0)!=(c[p>>2]|0)?(xG(c[f>>2]|0,c[m>>2]|0,c[p>>2]|0,0)|0)!=0:0){c[q>>2]=0;c[r>>2]=0;F=c[f>>2]|0;B=c[g>>2]|0;E=YD(h,c[m>>2]|0)|0;a=YD(q,c[p>>2]|0)|0;oG(F,3020,B,0,148952,E,a,YD(r,c[(c[g>>2]|0)+64>>2]|0)|0);if(c[h>>2]|0){zb[c[135736>>2]&511](c[h>>2]|0);c[h>>2]=0}if(c[q>>2]|0){zb[c[135736>>2]&511](c[q>>2]|0);c[q>>2]=0}if(c[r>>2]|0){zb[c[135736>>2]&511](c[r>>2]|0);c[r>>2]=0}c[e>>2]=3020;A=c[e>>2]|0;i=d;return A|0}if(!(c[(c[g>>2]|0)+68>>2]|0))break a;c[t>>2]=1;c[s>>2]=c[(c[g>>2]|0)+68>>2];do{if(((c[c[s>>2]>>2]|0)+-1006|0)>>>0>=6){wG(c[f>>2]|0,3021,c[g>>2]|0,c[s>>2]|0);c[t>>2]=0}c[s>>2]=c[(c[s>>2]|0)+4>>2]}while((c[s>>2]|0)!=0);if(c[t>>2]|0)break a;c[e>>2]=3021;A=c[e>>2]|0;i=d;return A|0}while(0);xB(c[f>>2]|0,148320,148904);c[e>>2]=-1;A=c[e>>2]|0;i=d;return A|0}while(0);xB(c[f>>2]|0,148320,148544);c[e>>2]=-1;A=c[e>>2]|0;i=d;return A|0}while(0);c[e>>2]=0;A=c[e>>2]|0;i=d;return A|0}function OE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[f>>2]=a;c[g>>2]=b;c[j>>2]=c[(c[g>>2]|0)+20>>2];c[k>>2]=c[(c[f>>2]|0)+8>>2];do if(c[(c[f>>2]|0)+68>>2]|0){c[l>>2]=c[(c[f>>2]|0)+68>>2];if((c[(c[g>>2]|0)+92>>2]|0)==0?(yG(c[g>>2]|0)|0)==-1:0){c[e>>2]=-1;m=c[e>>2]|0;i=d;return m|0}c[(c[(c[g>>2]|0)+92>>2]|0)+20>>2]=c[(c[g>>2]|0)+36>>2];while(1){if(!(c[l>>2]|0)){n=9;break}c[h>>2]=_A(c[l>>2]|0,c[f>>2]|0,c[g>>2]|0,c[k>>2]|0)|0;if((c[h>>2]|0)==-1)break;c[l>>2]=c[(c[l>>2]|0)+4>>2]}if((n|0)==9){c[(c[(c[g>>2]|0)+92>>2]|0)+20>>2]=0;break}c[e>>2]=-1;m=c[e>>2]|0;i=d;return m|0}while(0);if((c[j>>2]|0)!=(c[(c[g>>2]|0)+20>>2]|0)){c[e>>2]=c[(c[g>>2]|0)+16>>2];m=c[e>>2]|0;i=d;return m|0}else{c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}return 0}function PE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;d=i;i=i+112|0;e=d+108|0;f=d+104|0;g=d+100|0;h=d+96|0;j=d+92|0;k=d+88|0;l=d+84|0;m=d+80|0;n=d+76|0;o=d+72|0;p=d+68|0;q=d+64|0;r=d+60|0;s=d+56|0;t=d+52|0;u=d+48|0;v=d+44|0;w=d+40|0;x=d+36|0;y=d+32|0;z=d+28|0;A=d+24|0;B=d+20|0;C=d+16|0;D=d+12|0;E=d+8|0;F=d+4|0;G=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=c[(c[g>>2]|0)+64>>2];c[l>>2]=0;c[o>>2]=0;c[p>>2]=0;c[q>>2]=0;c[r>>2]=0;c[s>>2]=0;c[t>>2]=0;c[u>>2]=0;c[v>>2]=0;c[w>>2]=0;c[x>>2]=0;c[y>>2]=0;c[z>>2]=0;c[A>>2]=0;c[B>>2]=0;c[C>>2]=0;c[D>>2]=0;c[E>>2]=0;c[F>>2]=0;if((c[(c[g>>2]|0)+96>>2]|0)==0?(c[(c[h>>2]|0)+96>>2]|0)==0:0){c[e>>2]=0;H=c[e>>2]|0;i=d;return H|0}c[l>>2]=c[(c[g>>2]|0)+96>>2];a:do if(c[l>>2]|0)while(1){if(!(c[c[l>>2]>>2]|0))break a;c[l>>2]=c[c[l>>2]>>2]}while(0);c[k>>2]=c[(c[g>>2]|0)+96>>2];while(1){if(!(c[k>>2]|0))break;c[m>>2]=c[(c[k>>2]|0)+4>>2];switch(c[c[m>>2]>>2]|0){case 1011:{c[s>>2]=c[m>>2];break}case 1005:{c[q>>2]=c[m>>2];break}case 1009:{c[o>>2]=c[m>>2];break}case 1003:{c[w>>2]=c[m>>2];break}case 1004:{c[p>>2]=c[m>>2];break}case 1001:{c[v>>2]=c[m>>2];break}case 1002:{c[u>>2]=c[m>>2];break}case 1e3:{c[t>>2]=c[m>>2];break}case 1010:{c[r>>2]=c[m>>2];break}default:{}}c[k>>2]=c[c[k>>2]>>2]}c[k>>2]=c[(c[h>>2]|0)+96>>2];while(1){if(!(c[k>>2]|0))break;c[m>>2]=c[(c[k>>2]|0)+4>>2];switch(c[c[m>>2]>>2]|0){case 1002:{c[D>>2]=c[m>>2];break}case 1001:{c[E>>2]=c[m>>2];break}case 1005:{c[z>>2]=c[m>>2];break}case 1004:{c[y>>2]=c[m>>2];break}case 1e3:{c[C>>2]=c[m>>2];break}case 1003:{c[F>>2]=c[m>>2];break}case 1011:{c[B>>2]=c[m>>2];break}case 1010:{c[A>>2]=c[m>>2];break}case 1009:{c[x>>2]=c[m>>2];break}default:{}}c[k>>2]=c[c[k>>2]>>2]}if((c[o>>2]|0)!=0?(c[s>>2]|0)!=0|(c[r>>2]|0)!=0:0)GE(c[f>>2]|0,1717,c[o>>2]|0,c[(c[o>>2]|0)+20>>2]|0,147232,0);if((c[u>>2]|0)!=0&(c[w>>2]|0)!=0){b=c[f>>2]|0;a=c[u>>2]|0;I=c[(c[u>>2]|0)+20>>2]|0;J=zB(c[c[u>>2]>>2]|0)|0;oG(b,1717,a,I,147352,J,zB(c[c[w>>2]>>2]|0)|0,0)}if((c[t>>2]|0)!=0&(c[v>>2]|0)!=0){J=c[f>>2]|0;I=c[t>>2]|0;a=c[(c[t>>2]|0)+20>>2]|0;b=zB(c[c[t>>2]>>2]|0)|0;oG(J,1717,I,a,147352,b,zB(c[c[v>>2]>>2]|0)|0,0)}if((c[o>>2]|0)!=0&(c[x>>2]|0)!=0){c[G>>2]=XH(c[(c[o>>2]|0)+32>>2]|0,c[(c[x>>2]|0)+32>>2]|0)|0;if((c[G>>2]|0)!=-2){if(c[G>>2]|0)zG(c[f>>2]|0,c[o>>2]|0,c[x>>2]|0,0,0,1);if((c[G>>2]|0)!=0?(c[(c[x>>2]|0)+24>>2]|0)!=0:0){GE(c[f>>2]|0,1717,c[o>>2]|0,c[(c[o>>2]|0)+20>>2]|0,147440,0);K=47}else K=47}}else K=47;b:do if((K|0)==47){if((c[s>>2]|0)!=0&(c[B>>2]|0)!=0){c[G>>2]=XH(c[(c[s>>2]|0)+32>>2]|0,c[(c[B>>2]|0)+32>>2]|0)|0;if((c[G>>2]|0)==-2)break;if((c[G>>2]|0)==-1)zG(c[f>>2]|0,c[s>>2]|0,c[B>>2]|0,1,1,1);if((c[G>>2]|0)!=0?(c[(c[B>>2]|0)+24>>2]|0)!=0:0)GE(c[f>>2]|0,1717,c[s>>2]|0,c[(c[s>>2]|0)+20>>2]|0,147440,0)}if((c[r>>2]|0)!=0&(c[A>>2]|0)!=0){c[G>>2]=XH(c[(c[r>>2]|0)+32>>2]|0,c[(c[A>>2]|0)+32>>2]|0)|0;if((c[G>>2]|0)==-2)break;if((c[G>>2]|0)==1)zG(c[f>>2]|0,c[r>>2]|0,c[A>>2]|0,-1,1,1);if((c[G>>2]|0)!=0?(c[(c[A>>2]|0)+24>>2]|0)!=0:0)GE(c[f>>2]|0,1717,c[r>>2]|0,c[(c[r>>2]|0)+20>>2]|0,147440,0)}if(!(c[o>>2]|0))c[o>>2]=c[x>>2];if(c[o>>2]|0){if(!(c[s>>2]|0))c[s>>2]=c[B>>2];if(c[s>>2]|0){c[G>>2]=XH(c[(c[o>>2]|0)+32>>2]|0,c[(c[s>>2]|0)+32>>2]|0)|0;if((c[G>>2]|0)==-2)break;if((c[G>>2]|0)==-1)zG(c[f>>2]|0,c[o>>2]|0,c[s>>2]|0,1,1,0)}if(!(c[r>>2]|0))c[r>>2]=c[A>>2];if(c[r>>2]|0){c[G>>2]=XH(c[(c[o>>2]|0)+32>>2]|0,c[(c[r>>2]|0)+32>>2]|0)|0;if((c[G>>2]|0)==-2)break;if((c[G>>2]|0)==1)zG(c[f>>2]|0,c[o>>2]|0,c[r>>2]|0,-1,1,0)}}if(c[u>>2]|0){if(c[t>>2]|0){c[G>>2]=XH(c[(c[u>>2]|0)+32>>2]|0,c[(c[t>>2]|0)+32>>2]|0)|0;if((c[G>>2]|0)==-2)break;if((c[G>>2]|0)==-1)zG(c[f>>2]|0,c[u>>2]|0,c[t>>2]|0,1,1,0)}if(c[D>>2]|0){c[G>>2]=XH(c[(c[u>>2]|0)+32>>2]|0,c[(c[D>>2]|0)+32>>2]|0)|0;if((c[G>>2]|0)==-2)break;if((c[G>>2]|0)==1)zG(c[f>>2]|0,c[u>>2]|0,c[D>>2]|0,-1,1,1);if((c[G>>2]|0)!=0?(c[(c[D>>2]|0)+24>>2]|0)!=0:0)GE(c[f>>2]|0,1717,c[u>>2]|0,c[(c[u>>2]|0)+20>>2]|0,147440,0)}if(c[F>>2]|0){c[G>>2]=XH(c[(c[u>>2]|0)+32>>2]|0,c[(c[F>>2]|0)+32>>2]|0)|0;if((c[G>>2]|0)==-2)break;if((c[G>>2]|0)!=-1)zG(c[f>>2]|0,c[u>>2]|0,c[F>>2]|0,-1,0,1)}if(c[C>>2]|0){c[G>>2]=XH(c[(c[u>>2]|0)+32>>2]|0,c[(c[C>>2]|0)+32>>2]|0)|0;if((c[G>>2]|0)==-2)break;if((c[G>>2]|0)==-1)zG(c[f>>2]|0,c[u>>2]|0,c[C>>2]|0,1,1,1)}if(c[E>>2]|0){c[G>>2]=XH(c[(c[u>>2]|0)+32>>2]|0,c[(c[E>>2]|0)+32>>2]|0)|0;if((c[G>>2]|0)==-2)break;if((c[G>>2]|0)!=1)zG(c[f>>2]|0,c[u>>2]|0,c[E>>2]|0,1,0,1)}}do if(c[w>>2]|0){if(c[v>>2]|0){c[G>>2]=XH(c[(c[w>>2]|0)+32>>2]|0,c[(c[v>>2]|0)+32>>2]|0)|0;if((c[G>>2]|0)==-2)break b;if((c[G>>2]|0)==-1)zG(c[f>>2]|0,c[w>>2]|0,c[v>>2]|0,1,1,0)}do if(c[F>>2]|0){c[G>>2]=XH(c[(c[w>>2]|0)+32>>2]|0,c[(c[F>>2]|0)+32>>2]|0)|0;if((c[G>>2]|0)==-2)break b;if((c[G>>2]|0)==1)zG(c[f>>2]|0,c[w>>2]|0,c[F>>2]|0,-1,1,1);if(c[G>>2]|0){if(!(c[(c[F>>2]|0)+24>>2]|0))break;GE(c[f>>2]|0,1717,c[w>>2]|0,c[(c[w>>2]|0)+20>>2]|0,147440,0)}}while(0);if(c[D>>2]|0){c[G>>2]=XH(c[(c[w>>2]|0)+32>>2]|0,c[(c[D>>2]|0)+32>>2]|0)|0;if((c[G>>2]|0)==-2)break b;if((c[G>>2]|0)==1)zG(c[f>>2]|0,c[w>>2]|0,c[D>>2]|0,-1,1,1)}do if(c[C>>2]|0){c[G>>2]=XH(c[(c[w>>2]|0)+32>>2]|0,c[(c[C>>2]|0)+32>>2]|0)|0;if((c[G>>2]|0)==-2)break b;if((c[G>>2]|0)==1)break;zG(c[f>>2]|0,c[w>>2]|0,c[C>>2]|0,1,0,1)}while(0);if(c[E>>2]|0){c[G>>2]=XH(c[(c[w>>2]|0)+32>>2]|0,c[(c[E>>2]|0)+32>>2]|0)|0;if((c[G>>2]|0)==-2)break b;if((c[G>>2]|0)==1)break;zG(c[f>>2]|0,c[w>>2]|0,c[E>>2]|0,1,0,1)}}while(0);do if(c[v>>2]|0){if(c[u>>2]|0){c[G>>2]=XH(c[(c[v>>2]|0)+32>>2]|0,c[(c[u>>2]|0)+32>>2]|0)|0;if((c[G>>2]|0)==-2)break b;if((c[G>>2]|0)!=-1)zG(c[f>>2]|0,c[v>>2]|0,c[u>>2]|0,-1,0,0)}do if(c[E>>2]|0){c[G>>2]=XH(c[(c[v>>2]|0)+32>>2]|0,c[(c[E>>2]|0)+32>>2]|0)|0;if((c[G>>2]|0)==-2)break b;if((c[G>>2]|0)==-1)zG(c[f>>2]|0,c[v>>2]|0,c[E>>2]|0,1,1,1);if(!(c[G>>2]|0))break;if(!(c[(c[E>>2]|0)+24>>2]|0))break;GE(c[f>>2]|0,1717,c[v>>2]|0,c[(c[v>>2]|0)+20>>2]|0,147440,0)}while(0);do if(c[D>>2]|0){c[G>>2]=XH(c[(c[v>>2]|0)+32>>2]|0,c[(c[D>>2]|0)+32>>2]|0)|0;if((c[G>>2]|0)==-2)break b;if((c[G>>2]|0)!=1)break;zG(c[f>>2]|0,c[v>>2]|0,c[D>>2]|0,-1,1,1)}while(0);do if(c[C>>2]|0){c[G>>2]=XH(c[(c[v>>2]|0)+32>>2]|0,c[(c[C>>2]|0)+32>>2]|0)|0;if((c[G>>2]|0)==-2)break b;if((c[G>>2]|0)!=-1)break;zG(c[f>>2]|0,c[v>>2]|0,c[C>>2]|0,1,1,1)}while(0);if(c[F>>2]|0){c[G>>2]=XH(c[(c[v>>2]|0)+32>>2]|0,c[(c[F>>2]|0)+32>>2]|0)|0;if((c[G>>2]|0)==-2)break b;if((c[G>>2]|0)==-1)break;zG(c[f>>2]|0,c[v>>2]|0,c[F>>2]|0,-1,0,1)}}while(0);do if(c[t>>2]|0){if(c[w>>2]|0){c[G>>2]=XH(c[(c[t>>2]|0)+32>>2]|0,c[(c[w>>2]|0)+32>>2]|0)|0;if((c[G>>2]|0)==-2)break b;if((c[G>>2]|0)!=-1)zG(c[f>>2]|0,c[t>>2]|0,c[w>>2]|0,-1,0,0)}do if(c[C>>2]|0){c[G>>2]=XH(c[(c[t>>2]|0)+32>>2]|0,c[(c[C>>2]|0)+32>>2]|0)|0;if((c[G>>2]|0)==-2)break b;if((c[G>>2]|0)==-1)zG(c[f>>2]|0,c[t>>2]|0,c[C>>2]|0,1,1,1);if(!(c[G>>2]|0))break;if(!(c[(c[C>>2]|0)+24>>2]|0))break;GE(c[f>>2]|0,1717,c[t>>2]|0,c[(c[t>>2]|0)+20>>2]|0,147440,0)}while(0);do if(c[D>>2]|0){c[G>>2]=XH(c[(c[t>>2]|0)+32>>2]|0,c[(c[D>>2]|0)+32>>2]|0)|0;if((c[G>>2]|0)==-2)break b;if((c[G>>2]|0)!=1)break;zG(c[f>>2]|0,c[t>>2]|0,c[D>>2]|0,-1,1,1)}while(0);do if(c[E>>2]|0){c[G>>2]=XH(c[(c[t>>2]|0)+32>>2]|0,c[(c[E>>2]|0)+32>>2]|0)|0;if((c[G>>2]|0)==-2)break b;if((c[G>>2]|0)==1)break;zG(c[f>>2]|0,c[t>>2]|0,c[E>>2]|0,1,0,1)}while(0);if(!(c[F>>2]|0))break;c[G>>2]=XH(c[(c[t>>2]|0)+32>>2]|0,c[(c[F>>2]|0)+32>>2]|0)|0;if((c[G>>2]|0)==-2)break b;if((c[G>>2]|0)==-1)break;zG(c[f>>2]|0,c[t>>2]|0,c[F>>2]|0,-1,0,1)}while(0);do if((c[p>>2]|0)!=0&(c[y>>2]|0)!=0){c[G>>2]=XH(c[(c[p>>2]|0)+32>>2]|0,c[(c[y>>2]|0)+32>>2]|0)|0;if((c[G>>2]|0)==-2)break b;if((c[G>>2]|0)==1)zG(c[f>>2]|0,c[p>>2]|0,c[y>>2]|0,-1,1,1);if(c[G>>2]|0){if(!(c[(c[y>>2]|0)+24>>2]|0))break;GE(c[f>>2]|0,1717,c[p>>2]|0,c[(c[p>>2]|0)+20>>2]|0,147440,0)}}while(0);do if((c[q>>2]|0)!=0&(c[z>>2]|0)!=0){c[G>>2]=XH(c[(c[q>>2]|0)+32>>2]|0,c[(c[z>>2]|0)+32>>2]|0)|0;if((c[G>>2]|0)==-2)break b;if((c[G>>2]|0)==1)zG(c[f>>2]|0,c[q>>2]|0,c[z>>2]|0,-1,1,1);if(!(c[G>>2]|0))break;if(!(c[(c[z>>2]|0)+24>>2]|0))break;GE(c[f>>2]|0,1717,c[q>>2]|0,c[(c[q>>2]|0)+20>>2]|0,147440,0)}while(0);if(!(c[p>>2]|0))c[p>>2]=c[y>>2];if(!(c[q>>2]|0))c[q>>2]=c[z>>2];do if((c[p>>2]|0)!=0&(c[q>>2]|0)!=0){c[G>>2]=XH(c[(c[q>>2]|0)+32>>2]|0,c[(c[p>>2]|0)+32>>2]|0)|0;if((c[G>>2]|0)==-2)break b;if((c[G>>2]|0)!=1)break;zG(c[f>>2]|0,c[q>>2]|0,c[p>>2]|0,-1,1,0)}while(0);c[k>>2]=c[(c[h>>2]|0)+96>>2];c:while(1){if(!(c[k>>2]|0)){K=216;break}c[n>>2]=c[(c[k>>2]|0)+4>>2];do if((c[c[n>>2]>>2]|0)!=1006){if((c[c[n>>2]>>2]|0)==1007)break;c[j>>2]=c[(c[g>>2]|0)+96>>2];while(1){if(!(c[j>>2]|0))break;c[m>>2]=c[(c[j>>2]|0)+4>>2];if((c[c[m>>2]>>2]|0)==(c[c[n>>2]>>2]|0)){K=201;break}c[j>>2]=c[c[j>>2]>>2]}do if((K|0)==201){K=0;if((c[c[m>>2]>>2]|0)!=1008)break;if((c[(c[m>>2]|0)+28>>2]|0)<(c[(c[n>>2]|0)+28>>2]|0))GE(c[f>>2]|0,1717,c[m>>2]|0,c[(c[m>>2]|0)+20>>2]|0,147512,0);if(!(c[(c[n>>2]|0)+24>>2]|0))break;if((c[(c[m>>2]|0)+28>>2]|0)==(c[(c[n>>2]|0)+28>>2]|0))break;GE(c[f>>2]|0,1717,c[m>>2]|0,c[(c[m>>2]|0)+20>>2]|0,147440,0)}while(0);if(c[j>>2]|0)break;c[j>>2]=Cb[c[135744>>2]&511](8)|0;if(!(c[j>>2]|0)){K=210;break c}c[(c[j>>2]|0)+4>>2]=c[(c[k>>2]|0)+4>>2];c[c[j>>2]>>2]=0;b=c[j>>2]|0;if(!(c[l>>2]|0))c[(c[g>>2]|0)+96>>2]=b;else c[c[l>>2]>>2]=b;c[l>>2]=c[j>>2]}while(0);c[k>>2]=c[c[k>>2]>>2]}if((K|0)==210){tC(c[f>>2]|0,147616,0);c[e>>2]=-1;H=c[e>>2]|0;i=d;return H|0}else if((K|0)==216){c[e>>2]=0;H=c[e>>2]|0;i=d;return H|0}}while(0);xB(c[f>>2]|0,147656,147696);c[e>>2]=-1;H=c[e>>2]|0;i=d;return H|0}function QE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;a=(c[e>>2]|0)+48|0;h=c[a>>2]|0;if(c[(c[e>>2]|0)+48>>2]&64){c[a>>2]=h|67108864;c[d>>2]=0;j=c[d>>2]|0;i=b;return j|0}if(h&128){c[d>>2]=0;j=c[d>>2]|0;i=b;return j|0}a:do if(c[(c[e>>2]|0)+96>>2]|0){c[f>>2]=c[(c[e>>2]|0)+96>>2];while(1){if(!(c[f>>2]|0))break a;k=c[f>>2]|0;if((c[c[(c[f>>2]|0)+4>>2]>>2]|0)==1008)break;c[f>>2]=c[k>>2]}h=c[(c[k+4>>2]|0)+28>>2]|0;if((h|0)==2){a=(c[e>>2]|0)+48|0;c[a>>2]=c[a>>2]|33554432}else if((h|0)==1){a=(c[e>>2]|0)+48|0;c[a>>2]=c[a>>2]|16777216}else if((h|0)==3){h=(c[e>>2]|0)+48|0;c[h>>2]=c[h>>2]|67108864}else{c[d>>2]=-1;j=c[d>>2]|0;i=b;return j|0}c[d>>2]=0;j=c[d>>2]|0;i=b;return j|0}while(0);c[g>>2]=c[(c[e>>2]|0)+64>>2];while(1){if(!(c[g>>2]|0))break;if((c[(c[g>>2]|0)+88>>2]|0)==45)break;l=c[g>>2]|0;if((c[c[g>>2]>>2]|0)==1){m=20;break}c[g>>2]=c[l+64>>2]}do if((m|0)==20){if((c[l+88>>2]|0)==2){k=(c[e>>2]|0)+48|0;c[k>>2]=c[k>>2]|33554432;break}if((c[(c[g>>2]|0)+88>>2]|0)!=1?(c[(c[g>>2]|0)+88>>2]|0)!=46:0){k=(c[e>>2]|0)+48|0;c[k>>2]=c[k>>2]|67108864;break}k=(c[e>>2]|0)+48|0;c[k>>2]=c[k>>2]|16777216}while(0);c[d>>2]=0;j=c[d>>2]|0;i=b;return j|0}function RE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;d=b+20|0;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;j=b;c[d>>2]=a;c[e>>2]=0;c[f>>2]=0;c[g>>2]=0;c[e>>2]=(c[(c[(c[d>>2]|0)+64>>2]|0)+48>>2]&134217728|0)!=0?1:0;if(c[e>>2]|0){c[f>>2]=(c[(c[(c[d>>2]|0)+64>>2]|0)+48>>2]&2097152|0)!=0?1:0;c[g>>2]=(c[(c[(c[d>>2]|0)+64>>2]|0)+48>>2]&268435456|0)!=0?1:0}a:do if(c[(c[d>>2]|0)+68>>2]|0){c[h>>2]=c[(c[d>>2]|0)+68>>2];while(1){if(!(c[h>>2]|0))break a;a=c[c[h>>2]>>2]|0;if((a|0)==1007){c[f>>2]=1;c[g>>2]=1;c[e>>2]=1}else if((a|0)==1006){c[g>>2]=1;c[e>>2]=1}else if((a|0)!=1008)c[e>>2]=1;c[h>>2]=c[(c[h>>2]|0)+4>>2]}}while(0);if(c[g>>2]|0){g=(c[d>>2]|0)+48|0;c[g>>2]=c[g>>2]|268435456}if(c[f>>2]|0){g=(c[d>>2]|0)+48|0;c[g>>2]=c[g>>2]|2097152}if(c[e>>2]|0){g=(c[d>>2]|0)+48|0;c[g>>2]=c[g>>2]|134217728}if((c[e>>2]|0)==0|(c[f>>2]|0)!=0){i=b;return}if(!(c[(c[d>>2]|0)+48>>2]&256)){i=b;return}c[j>>2]=TD(c[d>>2]|0)|0;if((c[(c[j>>2]|0)+88>>2]|0)==46){i=b;return}if((c[(c[j>>2]|0)+88>>2]|0)==1){i=b;return}j=(c[d>>2]|0)+48|0;c[j>>2]=c[j>>2]|2097152;i=b;return}function SE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;do if(!(c[f>>2]|0))c[e>>2]=0;else{if((c[c[f>>2]>>2]|0)!=5?(c[(c[f>>2]|0)+88>>2]|0)!=45:0){b=c[f>>2]|0;if((c[c[f>>2]>>2]|0)!=1){c[e>>2]=SE(c[b+28>>2]|0,c[g>>2]|0)|0;break}if((c[b+88>>2]|0)==(c[g>>2]|0)){c[e>>2]=1;break}if((c[(c[f>>2]|0)+88>>2]|0)!=46?(c[(c[f>>2]|0)+88>>2]|0)!=45:0){c[e>>2]=SE(c[(c[f>>2]|0)+28>>2]|0,c[g>>2]|0)|0;break}c[e>>2]=0;break}c[e>>2]=0}while(0);i=d;return c[e>>2]|0}function TE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if((c[c[f>>2]>>2]|0)!=0?(c[g>>2]|0)<(c[(c[f>>2]|0)+4>>2]|0):0){do if((c[(c[f>>2]|0)+4>>2]|0)==1){zb[c[135736>>2]&511](c[c[f>>2]>>2]|0);c[c[f>>2]>>2]=0;c[(c[f>>2]|0)+4>>2]=0;c[(c[f>>2]|0)+8>>2]=0}else{if(((c[(c[f>>2]|0)+4>>2]|0)-1|0)==(c[g>>2]|0)){b=(c[f>>2]|0)+4|0;c[b>>2]=(c[b>>2]|0)+-1;break}c[h>>2]=c[g>>2];while(1){if((c[h>>2]|0)>=((c[(c[f>>2]|0)+4>>2]|0)-1|0))break;c[(c[c[f>>2]>>2]|0)+(c[h>>2]<<2)>>2]=c[(c[c[f>>2]>>2]|0)+((c[h>>2]|0)+1<<2)>>2];c[h>>2]=(c[h>>2]|0)+1}b=(c[f>>2]|0)+4|0;c[b>>2]=(c[b>>2]|0)+-1}while(0);c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}AG(152576);c[e>>2]=-1;j=c[e>>2]|0;i=d;return j|0}function UE(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;k=i;i=i+112|0;l=k+108|0;m=k+104|0;n=k+100|0;o=k+96|0;p=k+92|0;q=k+88|0;r=k+84|0;s=k+80|0;t=k+76|0;u=k+72|0;v=k+68|0;w=k+64|0;x=k+60|0;y=k+56|0;z=k+52|0;A=k+48|0;B=k+44|0;C=k+40|0;D=k+36|0;E=k+32|0;F=k+28|0;G=k+24|0;H=k+20|0;I=k+16|0;J=k+12|0;K=k+8|0;L=k+4|0;M=k;c[m>>2]=a;c[n>>2]=b;c[o>>2]=d;c[p>>2]=e;c[q>>2]=f;c[r>>2]=g;c[s>>2]=h;c[t>>2]=j;c[u>>2]=0;a:do if(c[q>>2]|0){c[w>>2]=0;while(1){if((c[w>>2]|0)>=(c[(c[q>>2]|0)+4>>2]|0))break a;c[u>>2]=c[(c[c[q>>2]>>2]|0)+(c[w>>2]<<2)>>2];c[y>>2]=0;b:do if(c[r>>2]|0){c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[(c[r>>2]|0)+4>>2]|0))break b;c[v>>2]=c[(c[c[r>>2]>>2]|0)+(c[x>>2]<<2)>>2];if((c[(c[(c[u>>2]|0)+12>>2]|0)+8>>2]|0)==(c[(c[(c[v>>2]|0)+12>>2]|0)+8>>2]|0)?(c[(c[(c[u>>2]|0)+12>>2]|0)+56>>2]|0)==(c[(c[(c[v>>2]|0)+12>>2]|0)+56>>2]|0):0)break;c[x>>2]=(c[x>>2]|0)+1}c[y>>2]=1;if((c[(c[u>>2]|0)+24>>2]|0)==2?(c[(c[v>>2]|0)+24>>2]|0)==1:0){c[B>>2]=0;j=c[m>>2]|0;h=FC(c[o>>2]|0)|0;g=c[o>>2]|0;f=c[u>>2]|0;e=(c[n>>2]|0)==0?151424:151432;BG(j,1788,h,g,f,151312,e,ZD(B,c[p>>2]|0)|0,0,0);if(!(c[B>>2]|0))break;zb[c[135736>>2]&511](c[B>>2]|0);c[B>>2]=0;break}if(!(xG(c[m>>2]|0,c[(c[(c[u>>2]|0)+12>>2]|0)+48>>2]|0,c[(c[(c[v>>2]|0)+12>>2]|0)+48>>2]|0,0)|0)){CG(c[v>>2]|0,A,z,0)|0;if(!((c[z>>2]|0)!=0&(c[A>>2]|0)==1))break;c[F>>2]=0;CG(c[v>>2]|0,A,F,0)|0;if((c[A>>2]|0)!=0?(c[F>>2]|0)==(c[z>>2]|0):0)break;c[G>>2]=0;e=c[m>>2]|0;f=FC(c[o>>2]|0)|0;g=c[o>>2]|0;h=c[u>>2]|0;j=(c[n>>2]|0)==0?151424:151432;BG(e,3077,f,g,h,151576,j,ZD(G,c[p>>2]|0)|0,0,0);if(!(c[G>>2]|0))break;zb[c[135736>>2]&511](c[G>>2]|0);c[G>>2]=0;break}c[C>>2]=0;c[D>>2]=0;c[E>>2]=0;j=c[m>>2]|0;h=FC(c[o>>2]|0)|0;g=c[o>>2]|0;f=c[u>>2]|0;e=ZD(C,c[(c[(c[u>>2]|0)+12>>2]|0)+48>>2]|0)|0;d=ZD(D,c[(c[(c[v>>2]|0)+12>>2]|0)+48>>2]|0)|0;b=(c[n>>2]|0)==0?151424:151432;BG(j,1789,h,g,f,151448,e,d,b,ZD(E,c[p>>2]|0)|0);if(c[C>>2]|0){zb[c[135736>>2]&511](c[C>>2]|0);c[C>>2]=0}if(c[D>>2]|0){zb[c[135736>>2]&511](c[D>>2]|0);c[D>>2]=0}if(c[E>>2]|0){zb[c[135736>>2]&511](c[E>>2]|0);c[E>>2]=0}}while(0);do if(!(c[y>>2]|0)){if((c[t>>2]|0)!=0?(DG(c[t>>2]|0,c[(c[(c[u>>2]|0)+12>>2]|0)+56>>2]|0)|0)==0:0)break;c[H>>2]=0;b=c[m>>2]|0;d=FC(c[o>>2]|0)|0;e=c[o>>2]|0;f=c[u>>2]|0;g=(c[n>>2]|0)==0?151424:151432;BG(b,1790,d,e,f,151680,g,ZD(H,c[p>>2]|0)|0,0,0);if(c[H>>2]|0){zb[c[135736>>2]&511](c[H>>2]|0);c[H>>2]=0}}while(0);c[w>>2]=(c[w>>2]|0)+1}}while(0);c:do if(c[r>>2]|0){c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[(c[r>>2]|0)+4>>2]|0))break c;c[v>>2]=c[(c[c[r>>2]>>2]|0)+(c[x>>2]<<2)>>2];if((c[(c[v>>2]|0)+24>>2]|0)==1){c[y>>2]=0;d:do if(c[q>>2]|0){c[w>>2]=0;while(1){if((c[w>>2]|0)>=(c[(c[q>>2]|0)+4>>2]|0))break d;c[u>>2]=c[(c[c[q>>2]>>2]|0)+(c[w>>2]<<2)>>2];if((c[(c[(c[u>>2]|0)+12>>2]|0)+8>>2]|0)==(c[(c[(c[v>>2]|0)+12>>2]|0)+8>>2]|0)?(c[(c[(c[u>>2]|0)+12>>2]|0)+56>>2]|0)==(c[(c[(c[v>>2]|0)+12>>2]|0)+56>>2]|0):0)break;c[w>>2]=(c[w>>2]|0)+1}c[y>>2]=1}while(0);if(!(c[y>>2]|0)){c[I>>2]=0;c[J>>2]=0;H=c[m>>2]|0;E=c[o>>2]|0;D=ZD(I,c[v>>2]|0)|0;C=(c[n>>2]|0)==0?151424:151432;CB(H,1791,0,E,151760,D,C,ZD(J,c[p>>2]|0)|0,0);if(c[I>>2]|0){zb[c[135736>>2]&511](c[I>>2]|0);c[I>>2]=0}if(c[J>>2]|0){zb[c[135736>>2]&511](c[J>>2]|0);c[J>>2]=0}}}c[x>>2]=(c[x>>2]|0)+1}}while(0);do if(c[s>>2]|0){if(!(c[t>>2]|0)){c[K>>2]=0;x=c[m>>2]|0;J=c[o>>2]|0;I=MD(c[o>>2]|0)|0;v=(c[n>>2]|0)==0?151424:151432;y=MD(c[p>>2]|0)|0;CB(x,1797,0,J,151832,I,v,y,YD(K,c[p>>2]|0)|0);if(c[K>>2]|0){zb[c[135736>>2]&511](c[K>>2]|0);c[K>>2]=0}c[l>>2]=c[(c[m>>2]|0)+16>>2];N=c[l>>2]|0;i=k;return N|0}if((c[(c[t>>2]|0)+28>>2]|0)==0?(EG(c[s>>2]|0,c[t>>2]|0)|0)!=0:0){c[L>>2]=0;y=c[m>>2]|0;v=c[o>>2]|0;I=(c[n>>2]|0)==0?151424:151432;J=MD(c[p>>2]|0)|0;CB(y,1798,0,v,151904,I,J,YD(L,c[p>>2]|0)|0,0);if(c[L>>2]|0){zb[c[135736>>2]&511](c[L>>2]|0);c[L>>2]=0}c[l>>2]=c[(c[m>>2]|0)+16>>2];N=c[l>>2]|0;i=k;return N|0}if((c[c[p>>2]>>2]|0)==1?(c[(c[p>>2]|0)+88>>2]|0)==45:0)break;if((c[(c[s>>2]|0)+24>>2]|0)<(c[(c[t>>2]|0)+24>>2]|0)){c[M>>2]=0;J=c[m>>2]|0;I=c[p>>2]|0;v=(c[n>>2]|0)==0?151424:151432;y=MD(c[p>>2]|0)|0;CB(J,1799,0,I,151984,v,y,YD(M,c[p>>2]|0)|0,0);if(c[M>>2]|0){zb[c[135736>>2]&511](c[M>>2]|0);c[M>>2]=0}c[l>>2]=c[(c[m>>2]|0)+16>>2];N=c[l>>2]|0;i=k;return N|0}}while(0);c[l>>2]=0;N=c[l>>2]|0;i=k;return N|0}function VE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+48|0;e=d+32|0;f=d+28|0;g=d+24|0;h=d+20|0;j=d+16|0;k=d+12|0;l=d+8|0;m=d+4|0;n=d;c[f>>2]=a;c[g>>2]=b;c[j>>2]=0;c[h>>2]=c[(c[g>>2]|0)+64>>2];if((c[(c[g>>2]|0)+52>>2]|0)!=4?(c[(c[g>>2]|0)+52>>2]|0)!=6:0){if((c[c[h>>2]>>2]|0)!=5?(c[(c[h>>2]|0)+88>>2]|0)!=45:0){c[k>>2]=0;b=c[f>>2]|0;a=c[g>>2]|0;o=c[(c[g>>2]|0)+36>>2]|0;GE(b,3076,a,o,153352,BB(k,c[(c[h>>2]|0)+112>>2]|0,c[(c[h>>2]|0)+8>>2]|0)|0);if(c[k>>2]|0){zb[c[135736>>2]&511](c[k>>2]|0);c[k>>2]=0}c[e>>2]=3076;p=c[e>>2]|0;i=d;return p|0}}else{do if((c[c[h>>2]>>2]|0)!=4){if((c[c[h>>2]>>2]|0)==1?(c[(c[h>>2]|0)+88>>2]|0)!=45:0){q=11;break}if((c[(c[h>>2]|0)+52>>2]|0)!=4?(c[(c[h>>2]|0)+52>>2]|0)!=6:0){if((c[(c[h>>2]|0)+52>>2]|0)==3?(c[(c[g>>2]|0)+48>>2]&4|0)!=0:0){if(!(FG(c[(c[h>>2]|0)+28>>2]|0)|0)){c[j>>2]=3076;break}if(c[(c[g>>2]|0)+104>>2]|0)break;c[m>>2]=0;k=c[f>>2]|0;o=c[g>>2]|0;GE(k,3076,o,0,153664,BB(m,c[(c[h>>2]|0)+112>>2]|0,c[(c[h>>2]|0)+8>>2]|0)|0);if(c[m>>2]|0){zb[c[135736>>2]&511](c[m>>2]|0);c[m>>2]=0}c[e>>2]=3076;p=c[e>>2]|0;i=d;return p|0}c[j>>2]=3076;break}if(!(c[(c[h>>2]|0)+104>>2]|0)){GE(c[f>>2]|0,3069,c[g>>2]|0,0,153584,c[(c[g>>2]|0)+8>>2]|0);c[e>>2]=-1;p=c[e>>2]|0;i=d;return p|0}}else q=11;while(0);if((q|0)==11?(c[(c[g>>2]|0)+48>>2]&2|0)==0:0){c[l>>2]=0;q=c[f>>2]|0;m=c[g>>2]|0;GE(q,3076,m,0,153464,BB(l,c[(c[h>>2]|0)+112>>2]|0,c[(c[h>>2]|0)+8>>2]|0)|0);if(c[l>>2]|0){zb[c[135736>>2]&511](c[l>>2]|0);c[l>>2]=0}c[e>>2]=3076;p=c[e>>2]|0;i=d;return p|0}if((c[j>>2]|0)>0){c[n>>2]=0;l=(c[(c[g>>2]|0)+48>>2]&4|0)!=0;m=c[f>>2]|0;f=c[g>>2]|0;g=BB(n,c[(c[h>>2]|0)+112>>2]|0,c[(c[h>>2]|0)+8>>2]|0)|0;if(l)GE(m,3076,f,0,153800,g);else GE(m,3076,f,0,153984,g);if(c[n>>2]|0){zb[c[135736>>2]&511](c[n>>2]|0);c[n>>2]=0}}}c[e>>2]=c[j>>2];p=c[e>>2]|0;i=d;return p|0}function WE(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;j=i;i=i+48|0;k=j+32|0;l=j+28|0;m=j+24|0;n=j+20|0;o=j+16|0;p=j+12|0;q=j+8|0;r=j+4|0;s=j;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;c[r>>2]=h;c[s>>2]=0;if((c[l>>2]|0)==0|(c[m>>2]|0)==0){c[k>>2]=0;t=c[k>>2]|0;i=j;return t|0}c[s>>2]=Cb[c[135744>>2]&511](120)|0;if(!(c[s>>2]|0)){tC(c[l>>2]|0,153304,0);c[k>>2]=0;t=c[k>>2]|0;i=j;return t|0}m=(c[s>>2]|0)+0|0;h=m+120|0;do{c[m>>2]=0;m=m+4|0}while((m|0)<(h|0));c[c[s>>2]>>2]=c[n>>2];c[(c[s>>2]|0)+8>>2]=c[o>>2];c[(c[s>>2]|0)+112>>2]=c[p>>2];c[(c[s>>2]|0)+36>>2]=c[q>>2];q=c[l>>2]|0;if(c[r>>2]|0){do if(c[q+100>>2]|0){r=GG(c[l>>2]|0,c[(c[l>>2]|0)+116>>2]|0,c[s>>2]|0,c[o>>2]|0,c[p>>2]|0)|0;
c[(c[l>>2]|0)+120>>2]=r;if(c[(c[l>>2]|0)+120>>2]|0){c[(c[l>>2]|0)+124>>2]=0;break}zb[c[135736>>2]&511](c[s>>2]|0);c[k>>2]=0;t=c[k>>2]|0;i=j;return t|0}while(0);dG((c[(c[(c[l>>2]|0)+28>>2]|0)+16>>2]|0)+44|0,5,c[s>>2]|0)|0}else dG((c[(c[q+28>>2]|0)+16>>2]|0)+48|0,10,c[s>>2]|0)|0;dG((c[(c[l>>2]|0)+28>>2]|0)+20|0,10,c[s>>2]|0)|0;c[k>>2]=c[s>>2];t=c[k>>2]|0;i=j;return t|0}function XE(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=0;if(!(c[h>>2]|0)){c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}c[m>>2]=Cb[c[135744>>2]&511](28)|0;if(!(c[m>>2]|0)){tC(c[h>>2]|0,153120,0);c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}else{c[c[m>>2]>>2]=25;c[(c[m>>2]|0)+4>>2]=0;c[(c[m>>2]|0)+24>>2]=c[j>>2];c[(c[m>>2]|0)+16>>2]=c[k>>2];c[(c[m>>2]|0)+20>>2]=c[l>>2];c[(c[m>>2]|0)+8>>2]=0;c[(c[m>>2]|0)+12>>2]=0;dG((c[(c[(c[h>>2]|0)+28>>2]|0)+16>>2]|0)+48|0,10,c[m>>2]|0)|0;c[g>>2]=c[m>>2];n=c[g>>2]|0;i=f;return n|0}return 0}function YE(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=0;if((c[h>>2]|0)==0|(c[j>>2]|0)==0){c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}c[m>>2]=Cb[c[135744>>2]&511](20)|0;if(!(c[m>>2]|0)){tC(c[h>>2]|0,153080,0);c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}j=c[m>>2]|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[j+16>>2]=0;c[c[m>>2]>>2]=c[k>>2];c[(c[m>>2]|0)+16>>2]=c[l>>2];dG((c[(c[(c[h>>2]|0)+28>>2]|0)+16>>2]|0)+48|0,10,c[m>>2]|0)|0;if((c[k>>2]|0)==6|(c[k>>2]|0)==7)dG((c[(c[h>>2]|0)+28>>2]|0)+20|0,10,c[m>>2]|0)|0;c[g>>2]=c[m>>2];n=c[g>>2]|0;i=f;return n|0}function ZE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+64|0;e=d+48|0;f=d+44|0;g=d+40|0;h=d+36|0;j=d+32|0;k=d+28|0;l=d+24|0;m=d+20|0;n=d+16|0;o=d+12|0;p=d+8|0;q=d+4|0;r=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;c[m>>2]=0;if(!(c[(c[g>>2]|0)+64>>2]|0)){xB(c[f>>2]|0,152632,152664);c[e>>2]=-1;s=c[e>>2]|0;i=d;return s|0}c[h>>2]=c[(c[g>>2]|0)+64>>2];if(((c[c[h>>2]>>2]|0)!=1?(c[(c[h>>2]|0)+48>>2]&4194304|0)==0:0)?(KE(c[h>>2]|0,c[f>>2]|0)|0)==-1:0){c[e>>2]=-1;s=c[e>>2]|0;i=d;return s|0}c[k>>2]=c[(c[g>>2]|0)+116>>2];c[l>>2]=c[(c[h>>2]|0)+116>>2];do if(c[k>>2]|0){b=c[f>>2]|0;a=c[g>>2]|0;t=(c[g>>2]|0)+84|0;u=c[k>>2]|0;if(!(c[(c[g>>2]|0)+48>>2]&4)){if((IE(b,a,t,u,0)|0)!=-1)break;xB(c[f>>2]|0,152632,152680);break}if((IE(b,a,t,u,c[(c[f>>2]|0)+128>>2]|0)|0)==-1)xB(c[f>>2]|0,152632,152680);if(c[(c[(c[f>>2]|0)+128>>2]|0)+4>>2]|0)c[m>>2]=c[(c[f>>2]|0)+128>>2]}while(0);a:do if(c[l>>2]|0){if(!(c[(c[g>>2]|0)+48>>2]&4)){c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[(c[l>>2]|0)+4>>2]|0)){v=45;break a}c[j>>2]=c[(c[c[l>>2]>>2]|0)+(c[n>>2]<<2)>>2];if(!(c[k>>2]|0)){u=JB()|0;c[(c[g>>2]|0)+116>>2]=u;if(!(c[(c[g>>2]|0)+116>>2]|0))break a;c[k>>2]=c[(c[g>>2]|0)+116>>2]}pG(c[k>>2]|0,c[(c[l>>2]|0)+4>>2]|0,c[j>>2]|0)|0;c[n>>2]=(c[n>>2]|0)+1}}if(c[k>>2]|0)c[q>>2]=c[(c[k>>2]|0)+4>>2];else c[q>>2]=0;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[(c[l>>2]|0)+4>>2]|0)){v=45;break a}c[j>>2]=c[(c[c[l>>2]>>2]|0)+(c[n>>2]<<2)>>2];b:do if(c[m>>2]|0){c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[(c[m>>2]|0)+4>>2]|0)){v=28;break b}c[p>>2]=c[(c[c[m>>2]>>2]|0)+(c[o>>2]<<2)>>2];if((c[(c[(c[j>>2]|0)+12>>2]|0)+8>>2]|0)==(c[(c[p>>2]|0)+8>>2]|0)?(c[(c[(c[j>>2]|0)+12>>2]|0)+56>>2]|0)==(c[(c[p>>2]|0)+12>>2]|0):0)break b;c[o>>2]=(c[o>>2]|0)+1}}else v=28;while(0);c:do if((v|0)==28){v=0;d:do if(c[q>>2]|0){c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[q>>2]|0))break d;c[r>>2]=c[(c[c[k>>2]>>2]|0)+(c[o>>2]<<2)>>2];if((c[(c[(c[j>>2]|0)+12>>2]|0)+8>>2]|0)==(c[(c[(c[r>>2]|0)+12>>2]|0)+8>>2]|0)?(c[(c[(c[j>>2]|0)+12>>2]|0)+56>>2]|0)==(c[(c[(c[r>>2]|0)+12>>2]|0)+56>>2]|0):0)break c;c[o>>2]=(c[o>>2]|0)+1}}while(0);if(!(c[k>>2]|0)){u=JB()|0;c[(c[g>>2]|0)+116>>2]=u;if(!(c[(c[g>>2]|0)+116>>2]|0))break a;c[k>>2]=c[(c[g>>2]|0)+116>>2]}pG(c[k>>2]|0,2,c[j>>2]|0)|0}while(0);c[n>>2]=(c[n>>2]|0)+1}}else v=45;while(0);e:do if((v|0)==45){if((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+4>>2]|0)==0:0){oB(c[k>>2]|0);c[(c[g>>2]|0)+116>>2]=0}do if((c[(c[g>>2]|0)+48>>2]&2|0)!=0?(c[(c[h>>2]|0)+84>>2]|0)!=0:0)if(c[(c[g>>2]|0)+84>>2]|0)if((HG(c[f>>2]|0,c[(c[g>>2]|0)+84>>2]|0,c[(c[h>>2]|0)+84>>2]|0)|0)==-1)break e;else break;else{c[(c[g>>2]|0)+84>>2]=c[(c[h>>2]|0)+84>>2];break}while(0);c[e>>2]=0;s=c[e>>2]|0;i=d;return s|0}while(0);c[e>>2]=-1;s=c[e>>2]|0;i=d;return s|0}function _E(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=IG(c[f>>2]|0,c[g>>2]|0)|0;if(c[h>>2]|0){c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}b=c[f>>2]|0;f=c[g>>2]|0;if(c[(c[g>>2]|0)+48>>2]&2)c[h>>2]=JG(b,f)|0;else c[h>>2]=KG(b,f)|0;c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}function $E(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+64|0;e=d+56|0;f=d+52|0;g=d+48|0;h=d+44|0;j=d+40|0;k=d+36|0;l=d+32|0;m=d+28|0;n=d+24|0;o=d+20|0;p=d+16|0;q=d+12|0;r=d+8|0;s=d+4|0;t=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;c[j>>2]=c[(c[g>>2]|0)+28>>2];if(c[(c[g>>2]|0)+80>>2]|0){c[k>>2]=c[(c[g>>2]|0)+80>>2];rD(c[k>>2]|0,c[f>>2]|0);if(!(c[(c[g>>2]|0)+48>>2]&2)){GE(c[f>>2]|0,3046,c[g>>2]|0,0,158528,0);c[h>>2]=3046}b=c[k>>2]|0;do if((c[k>>2]|0)!=(c[g>>2]|0))if(c[b+80>>2]|0){c[l>>2]=LG(c[k>>2]|0,c[k>>2]|0)|0;break}else{c[l>>2]=0;break}else c[l>>2]=b;while(0);if(c[l>>2]|0){c[m>>2]=0;c[n>>2]=0;b=c[f>>2]|0;a=c[l>>2]|0;u=YD(m,c[l>>2]|0)|0;oG(b,3049,a,0,158608,u,YD(n,c[k>>2]|0)|0,0);if(c[m>>2]|0){zb[c[135736>>2]&511](c[m>>2]|0);c[m>>2]=0}if(c[n>>2]|0){zb[c[135736>>2]&511](c[n>>2]|0);c[n>>2]=0}c[h>>2]=3049}if((c[j>>2]|0)!=(c[(c[(c[g>>2]|0)+80>>2]|0)+28>>2]|0)){c[o>>2]=0;if(c[(c[k>>2]|0)+48>>2]&32768)c[o>>2]=c[o>>2]|2;if(c[(c[k>>2]|0)+48>>2]&65536)c[o>>2]=c[o>>2]|1;if(MG(c[f>>2]|0,c[j>>2]|0,c[(c[k>>2]|0)+28>>2]|0,c[o>>2]|0)|0){c[p>>2]=0;c[q>>2]=0;c[r>>2]=0;c[h>>2]=3047;o=c[f>>2]|0;n=c[g>>2]|0;m=YD(p,c[j>>2]|0)|0;u=YD(q,c[k>>2]|0)|0;oG(o,3047,n,0,158704,m,u,YD(r,c[(c[k>>2]|0)+28>>2]|0)|0);if(c[p>>2]|0){zb[c[135736>>2]&511](c[p>>2]|0);c[p>>2]=0}if(c[q>>2]|0){zb[c[135736>>2]&511](c[q>>2]|0);c[q>>2]=0}if(c[r>>2]|0){zb[c[135736>>2]&511](c[r>>2]|0);c[r>>2]=0}}}}do if(c[(c[g>>2]|0)+76>>2]|0){if((c[c[j>>2]>>2]|0)!=4)if((c[c[j>>2]>>2]|0)==1?(c[(c[j>>2]|0)+88>>2]|0)!=45:0)v=31;else v=32;else v=31;if((v|0)==31?(SE(c[j>>2]|0,23)|0)==0:0)v=32;if((v|0)==32){if((c[c[j>>2]>>2]|0)!=5?(c[(c[j>>2]|0)+88>>2]|0)!=45:0){v=38;break}if((c[(c[j>>2]|0)+52>>2]|0)!=4?(c[(c[j>>2]|0)+52>>2]|0)!=6:0){v=38;break}if(!(SE(c[(c[j>>2]|0)+104>>2]|0,23)|0)){v=38;break}}c[h>>2]=3048;GE(c[f>>2]|0,3048,c[g>>2]|0,0,158848,0)}else v=38;while(0);if((v|0)==38?(c[(c[g>>2]|0)+76>>2]|0)!=0:0){c[t>>2]=0;if(!(c[j>>2]|0)){PC(c[f>>2]|0,c[(c[g>>2]|0)+36>>2]|0,3069,159008,0,0);c[e>>2]=-1;w=c[e>>2]|0;i=d;return w|0}do if(c[(c[g>>2]|0)+36>>2]|0){v=c[(c[g>>2]|0)+36>>2]|0;if(c[(c[g>>2]|0)+48>>2]&8){c[t>>2]=dj(v,159120)|0;break}else{c[t>>2]=dj(v,159128)|0;break}}while(0);c[s>>2]=NG(c[f>>2]|0,c[t>>2]|0,c[j>>2]|0,c[(c[g>>2]|0)+76>>2]|0,(c[g>>2]|0)+96|0)|0;if(c[s>>2]|0)if((c[s>>2]|0)<0){xB(c[f>>2]|0,159136,159168);c[e>>2]=-1;w=c[e>>2]|0;i=d;return w|0}else{c[e>>2]=c[s>>2];w=c[e>>2]|0;i=d;return w|0}}c[e>>2]=c[h>>2];w=c[e>>2]|0;i=d;return w|0}function aF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[e>>2]=a;c[f>>2]=b;if(!(c[(c[f>>2]|0)+80>>2]|0)){i=d;return}if(c[(c[f>>2]|0)+48>>2]&16){i=d;return}c[g>>2]=c[(c[f>>2]|0)+80>>2];while(1){if(!(c[g>>2]|0))break;c[k>>2]=0;c[l>>2]=0;do if(!(c[(c[g>>2]|0)+48>>2]&8192)){c[h>>2]=c[(c[g>>2]|0)+28>>2];c[j>>2]=c[(c[f>>2]|0)+28>>2];if((c[h>>2]|0)!=(c[j>>2]|0)){if(c[(c[g>>2]|0)+48>>2]&4096)c[k>>2]=c[k>>2]|524288;if(c[(c[g>>2]|0)+48>>2]&2048)c[k>>2]=c[k>>2]|262144;while(1){if(!(c[j>>2]|0))break;if((c[j>>2]|0)==(c[h>>2]|0))break;if((c[(c[j>>2]|0)+48>>2]&2|0)!=0?(c[l>>2]&524288|0)==0:0)c[l>>2]=c[l>>2]|262144;if((c[(c[j>>2]|0)+48>>2]&4|0)!=0?(c[l>>2]&524288|0)==0:0)c[l>>2]=c[l>>2]|524288;c[j>>2]=c[(c[j>>2]|0)+64>>2]}c[j>>2]=c[(c[(c[f>>2]|0)+28>>2]|0)+64>>2];while(1){if(!(c[j>>2]|0))break;if((c[c[j>>2]>>2]|0)!=5?(c[(c[j>>2]|0)+88>>2]|0)!=45:0)break;if((c[(c[j>>2]|0)+48>>2]&262144|0)!=0?(c[k>>2]&262144|0)==0:0)c[k>>2]=c[k>>2]|262144;if((c[(c[j>>2]|0)+48>>2]&524288|0)!=0?(c[k>>2]&524288|0)==0:0)c[k>>2]=c[k>>2]|524288;if((c[j>>2]|0)==(c[h>>2]|0))break;c[j>>2]=c[(c[j>>2]|0)+64>>2]}if(c[k>>2]|0){if((c[k>>2]&262144|0)!=0?(c[l>>2]&262144|0)!=0:0)break;if((c[k>>2]&524288|0)!=0?(c[l>>2]&524288|0)!=0:0)break}}OG(c[e>>2]|0,c[g>>2]|0,c[f>>2]|0)|0;if(!(c[(c[g>>2]|0)+48>>2]&131072)){b=(c[g>>2]|0)+48|0;c[b>>2]=c[b>>2]|131072}}while(0);c[g>>2]=c[(c[g>>2]|0)+80>>2]}i=d;return}function bF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;d=i;i=i+128|0;e=d+124|0;f=d+120|0;g=d+116|0;h=d+112|0;j=d+108|0;k=d+104|0;l=d+100|0;m=d+96|0;n=d+92|0;o=d+88|0;p=d+84|0;q=d+80|0;r=d+76|0;s=d+72|0;t=d+68|0;u=d+64|0;v=d+60|0;w=d+56|0;x=d+52|0;y=d+48|0;z=d+44|0;A=d+40|0;B=d+36|0;C=d+32|0;D=d+28|0;E=d+24|0;F=d+20|0;G=d+16|0;H=d+12|0;I=d+8|0;J=d+4|0;K=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;if(!(c[g>>2]|0)){xB(c[f>>2]|0,158112,158144);c[e>>2]=1;L=c[e>>2]|0;i=d;return L|0}if(!(c[(c[g>>2]|0)+12>>2]|0)){c[e>>2]=1;L=c[e>>2]|0;i=d;return L|0}a:do switch(c[c[(c[g>>2]|0)+12>>2]>>2]|0){case 8:{c[h>>2]=1;c[I>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+12>>2];if(c[I>>2]|0){c[h>>2]=0;c[G>>2]=c[(c[f>>2]|0)+76>>2];c[H>>2]=Iz(c[(c[f>>2]|0)+64>>2]|0)|0;Jz(c[(c[f>>2]|0)+64>>2]|0,c[(c[f>>2]|0)+76>>2]|0,c[H>>2]|0)|0;c[(c[f>>2]|0)+76>>2]=c[H>>2];while(1){if(!(c[I>>2]|0)){M=103;break}c[(c[f>>2]|0)+76>>2]=c[H>>2];c[J>>2]=c[(c[I>>2]|0)+12>>2];if(!(c[J>>2]|0)){M=93;break}do if(!(c[(c[J>>2]|0)+48>>2]&131072)){if((c[(c[I>>2]|0)+16>>2]|0)==1?(c[(c[I>>2]|0)+20>>2]|0)==1:0){Hz(c[(c[f>>2]|0)+64>>2]|0,c[(c[f>>2]|0)+76>>2]|0,c[(c[f>>2]|0)+76>>2]|0,c[(c[J>>2]|0)+8>>2]|0,c[(c[J>>2]|0)+52>>2]|0,1,1,c[J>>2]|0)|0;break}if((c[(c[I>>2]|0)+16>>2]|0)==0?(c[(c[I>>2]|0)+20>>2]|0)==1:0)Gz(c[(c[f>>2]|0)+64>>2]|0,c[(c[f>>2]|0)+76>>2]|0,c[(c[f>>2]|0)+76>>2]|0,c[(c[J>>2]|0)+8>>2]|0,c[(c[J>>2]|0)+52>>2]|0,0,1,c[J>>2]|0)|0}else{c[K>>2]=Lz(c[(c[f>>2]|0)+64>>2]|0,c[(c[I>>2]|0)+16>>2]|0,c[(c[I>>2]|0)+20>>2]|0)|0;QG(c[f>>2]|0,c[I>>2]|0,c[K>>2]|0,c[(c[f>>2]|0)+76>>2]|0)|0}while(0);c[I>>2]=c[(c[I>>2]|0)+8>>2]}if((M|0)==93){xB(c[f>>2]|0,158112,158168);c[e>>2]=c[h>>2];L=c[e>>2]|0;i=d;return L|0}else if((M|0)==103){b=Kz(c[(c[f>>2]|0)+64>>2]|0,c[(c[f>>2]|0)+76>>2]|0,0,0)|0;c[(c[f>>2]|0)+76>>2]=b;if(c[(c[g>>2]|0)+16>>2]|0)break a;Jz(c[(c[f>>2]|0)+64>>2]|0,c[G>>2]|0,c[(c[f>>2]|0)+76>>2]|0)|0;c[h>>2]=1;break a}}break}case 2:{c[m>>2]=c[(c[g>>2]|0)+12>>2];c[k>>2]=c[(c[f>>2]|0)+76>>2];c[l>>2]=Iz(c[(c[f>>2]|0)+64>>2]|0)|0;do if((c[(c[g>>2]|0)+20>>2]|0)==1){if((c[(c[m>>2]|0)+28>>2]|0)==1){b=Ez(c[(c[f>>2]|0)+64>>2]|0,c[k>>2]|0,0,140432,140432,c[m>>2]|0)|0;c[(c[f>>2]|0)+76>>2]=b;Jz(c[(c[f>>2]|0)+64>>2]|0,c[(c[f>>2]|0)+76>>2]|0,c[l>>2]|0)|0;b=Ez(c[(c[f>>2]|0)+64>>2]|0,c[k>>2]|0,0,140432,0,c[m>>2]|0)|0;c[(c[f>>2]|0)+76>>2]=b;Jz(c[(c[f>>2]|0)+64>>2]|0,c[(c[f>>2]|0)+76>>2]|0,c[l>>2]|0)|0;break}b=c[m>>2]|0;if(c[(c[m>>2]|0)+32>>2]|0){c[n>>2]=c[b+32>>2];do{c[(c[f>>2]|0)+76>>2]=c[k>>2];a=Ez(c[(c[f>>2]|0)+64>>2]|0,c[(c[f>>2]|0)+76>>2]|0,0,140432,c[(c[n>>2]|0)+4>>2]|0,c[m>>2]|0)|0;c[(c[f>>2]|0)+76>>2]=a;Jz(c[(c[f>>2]|0)+64>>2]|0,c[(c[f>>2]|0)+76>>2]|0,c[l>>2]|0)|0;c[n>>2]=c[c[n>>2]>>2]}while((c[n>>2]|0)!=0)}else{if(!(c[b+36>>2]|0))break;a=Fz(c[(c[f>>2]|0)+64>>2]|0,c[k>>2]|0,c[l>>2]|0,140432,c[(c[(c[m>>2]|0)+36>>2]|0)+4>>2]|0,c[m>>2]|0)|0;c[(c[f>>2]|0)+76>>2]=a;break}}else{if((c[(c[g>>2]|0)+20>>2]|0)==1073741824)N=1073741824;else N=(c[(c[g>>2]|0)+20>>2]|0)-1|0;c[q>>2]=N;if((c[(c[g>>2]|0)+16>>2]|0)<1)O=0;else O=(c[(c[g>>2]|0)+16>>2]|0)-1|0;c[r>>2]=O;c[o>>2]=Lz(c[(c[f>>2]|0)+64>>2]|0,c[r>>2]|0,c[q>>2]|0)|0;c[p>>2]=Iz(c[(c[f>>2]|0)+64>>2]|0)|0;do if((c[(c[m>>2]|0)+28>>2]|0)!=1){a=c[m>>2]|0;if(c[(c[m>>2]|0)+32>>2]|0){c[n>>2]=c[a+32>>2];do{P=Ez(c[(c[f>>2]|0)+64>>2]|0,c[k>>2]|0,0,140432,c[(c[n>>2]|0)+4>>2]|0,c[m>>2]|0)|0;c[(c[f>>2]|0)+76>>2]=P;Jz(c[(c[f>>2]|0)+64>>2]|0,c[(c[f>>2]|0)+76>>2]|0,c[p>>2]|0)|0;c[n>>2]=c[c[n>>2]>>2]}while((c[n>>2]|0)!=0)}else{if(!(c[a+36>>2]|0))break;P=Fz(c[(c[f>>2]|0)+64>>2]|0,c[k>>2]|0,c[p>>2]|0,140432,c[(c[(c[m>>2]|0)+36>>2]|0)+4>>2]|0,c[m>>2]|0)|0;c[(c[f>>2]|0)+76>>2]=P;break}}else{P=Ez(c[(c[f>>2]|0)+64>>2]|0,c[k>>2]|0,0,140432,140432,c[m>>2]|0)|0;c[(c[f>>2]|0)+76>>2]=P;Jz(c[(c[f>>2]|0)+64>>2]|0,c[(c[f>>2]|0)+76>>2]|0,c[p>>2]|0)|0;P=Ez(c[(c[f>>2]|0)+64>>2]|0,c[k>>2]|0,0,140432,0,c[m>>2]|0)|0;c[(c[f>>2]|0)+76>>2]=P;Jz(c[(c[f>>2]|0)+64>>2]|0,c[(c[f>>2]|0)+76>>2]|0,c[p>>2]|0)|0}while(0);Mz(c[(c[f>>2]|0)+64>>2]|0,c[p>>2]|0,c[k>>2]|0,c[o>>2]|0)|0;Nz(c[(c[f>>2]|0)+64>>2]|0,c[p>>2]|0,c[l>>2]|0,c[o>>2]|0)|0}while(0);if(!(c[(c[g>>2]|0)+16>>2]|0)){Jz(c[(c[f>>2]|0)+64>>2]|0,c[k>>2]|0,c[l>>2]|0)|0;c[h>>2]=1}c[(c[f>>2]|0)+76>>2]=c[l>>2];break}case 14:{c[h>>2]=PG(c[f>>2]|0,c[g>>2]|0)|0;break}case 17:{c[h>>2]=1;break}case 7:{c[h>>2]=0;c[z>>2]=c[(c[f>>2]|0)+76>>2];c[A>>2]=Iz(c[(c[f>>2]|0)+64>>2]|0)|0;b=c[g>>2]|0;b:do if((c[(c[g>>2]|0)+20>>2]|0)!=1){if((c[b+20>>2]|0)==1073741824)Q=1073741824;else Q=(c[(c[g>>2]|0)+20>>2]|0)-1|0;c[E>>2]=Q;if((c[(c[g>>2]|0)+16>>2]|0)<1)R=0;else R=(c[(c[g>>2]|0)+16>>2]|0)-1|0;c[F>>2]=R;c[B>>2]=Lz(c[(c[f>>2]|0)+64>>2]|0,c[F>>2]|0,c[E>>2]|0)|0;c[C>>2]=Iz(c[(c[f>>2]|0)+64>>2]|0)|0;c[D>>2]=Iz(c[(c[f>>2]|0)+64>>2]|0)|0;c[y>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+12>>2];while(1){if(!(c[y>>2]|0))break;c[(c[f>>2]|0)+76>>2]=c[D>>2];c[j>>2]=bF(c[f>>2]|0,c[y>>2]|0)|0;if((c[j>>2]|0)==1)c[h>>2]=1;Jz(c[(c[f>>2]|0)+64>>2]|0,c[(c[f>>2]|0)+76>>2]|0,c[C>>2]|0)|0;c[y>>2]=c[(c[y>>2]|0)+8>>2]}Jz(c[(c[f>>2]|0)+64>>2]|0,c[z>>2]|0,c[D>>2]|0)|0;Mz(c[(c[f>>2]|0)+64>>2]|0,c[C>>2]|0,c[D>>2]|0,c[B>>2]|0)|0;Nz(c[(c[f>>2]|0)+64>>2]|0,c[C>>2]|0,c[A>>2]|0,c[B>>2]|0)|0;if((c[h>>2]|0)==1)Jz(c[(c[f>>2]|0)+64>>2]|0,c[D>>2]|0,c[A>>2]|0)|0}else{c[y>>2]=c[(c[b+12>>2]|0)+12>>2];while(1){if(!(c[y>>2]|0))break b;c[(c[f>>2]|0)+76>>2]=c[z>>2];c[j>>2]=bF(c[f>>2]|0,c[y>>2]|0)|0;if((c[j>>2]|0)==1)c[h>>2]=1;Jz(c[(c[f>>2]|0)+64>>2]|0,c[(c[f>>2]|0)+76>>2]|0,c[A>>2]|0)|0;c[y>>2]=c[(c[y>>2]|0)+8>>2]}}while(0);if(!(c[(c[g>>2]|0)+16>>2]|0)){Jz(c[(c[f>>2]|0)+64>>2]|0,c[z>>2]|0,c[A>>2]|0)|0;c[h>>2]=1}c[(c[f>>2]|0)+76>>2]=c[A>>2];break}case 6:{c[h>>2]=1;if((c[(c[g>>2]|0)+16>>2]|0)==1?(c[(c[g>>2]|0)+20>>2]|0)==1:0){c[s>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+12>>2];while(1){if(!(c[s>>2]|0))break a;c[j>>2]=bF(c[f>>2]|0,c[s>>2]|0)|0;if((c[j>>2]|0)!=1)c[h>>2]=0;c[s>>2]=c[(c[s>>2]|0)+8>>2]}}c[t>>2]=c[(c[f>>2]|0)+76>>2];b=c[g>>2]|0;if((c[(c[g>>2]|0)+20>>2]|0)>=1073741824){P=(c[b+16>>2]|0)>1;S=Jz(c[(c[f>>2]|0)+64>>2]|0,c[t>>2]|0,0)|0;c[(c[f>>2]|0)+76>>2]=S;c[t>>2]=c[(c[f>>2]|0)+76>>2];if(P){c[v>>2]=Lz(c[(c[f>>2]|0)+64>>2]|0,(c[(c[g>>2]|0)+16>>2]|0)-1|0,1073741824)|0;c[s>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+12>>2];while(1){T=c[f>>2]|0;if(!(c[s>>2]|0))break;c[j>>2]=bF(T,c[s>>2]|0)|0;if((c[j>>2]|0)!=1)c[h>>2]=0;c[s>>2]=c[(c[s>>2]|0)+8>>2]}c[u>>2]=c[T+76>>2];Mz(c[(c[f>>2]|0)+64>>2]|0,c[u>>2]|0,c[t>>2]|0,c[v>>2]|0)|0;P=Nz(c[(c[f>>2]|0)+64>>2]|0,c[u>>2]|0,0,c[v>>2]|0)|0;c[(c[f>>2]|0)+76>>2]=P;if((c[h>>2]|0)!=1)break a;Jz(c[(c[f>>2]|0)+64>>2]|0,c[t>>2]|0,c[(c[f>>2]|0)+76>>2]|0)|0;break a}else{c[s>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+12>>2];while(1){U=c[f>>2]|0;if(!(c[s>>2]|0))break;c[j>>2]=bF(U,c[s>>2]|0)|0;if((c[j>>2]|0)!=1)c[h>>2]=0;c[s>>2]=c[(c[s>>2]|0)+8>>2]}Jz(c[U+64>>2]|0,c[(c[f>>2]|0)+76>>2]|0,c[t>>2]|0)|0;P=Jz(c[(c[f>>2]|0)+64>>2]|0,c[(c[f>>2]|0)+76>>2]|0,0)|0;c[(c[f>>2]|0)+76>>2]=P;if(c[(c[g>>2]|0)+16>>2]|0)break a;Jz(c[(c[f>>2]|0)+64>>2]|0,c[t>>2]|0,c[(c[f>>2]|0)+76>>2]|0)|0;c[h>>2]=1;break a}}if((c[b+20>>2]|0)<=1?(c[(c[g>>2]|0)+16>>2]|0)<=1:0){c[s>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+12>>2];while(1){V=c[f>>2]|0;if(!(c[s>>2]|0))break;c[j>>2]=bF(V,c[s>>2]|0)|0;if((c[j>>2]|0)!=1)c[h>>2]=0;c[s>>2]=c[(c[s>>2]|0)+8>>2]}b=Jz(c[V+64>>2]|0,c[(c[f>>2]|0)+76>>2]|0,0)|0;c[(c[f>>2]|0)+76>>2]=b;if(c[(c[g>>2]|0)+16>>2]|0)break a;Jz(c[(c[f>>2]|0)+64>>2]|0,c[t>>2]|0,c[(c[f>>2]|0)+76>>2]|0)|0;c[h>>2]=1;break a}b=Jz(c[(c[f>>2]|0)+64>>2]|0,c[t>>2]|0,0)|0;c[(c[f>>2]|0)+76>>2]=b;c[t>>2]=c[(c[f>>2]|0)+76>>2];c[x>>2]=Lz(c[(c[f>>2]|0)+64>>2]|0,(c[(c[g>>2]|0)+16>>2]|0)-1|0,(c[(c[g>>2]|0)+20>>2]|0)-1|0)|0;c[s>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+12>>2];while(1){W=c[f>>2]|0;if(!(c[s>>2]|0))break;c[j>>2]=bF(W,c[s>>2]|0)|0;if((c[j>>2]|0)!=1)c[h>>2]=0;c[s>>2]=c[(c[s>>2]|0)+8>>2]}c[w>>2]=c[W+76>>2];Mz(c[(c[f>>2]|0)+64>>2]|0,c[w>>2]|0,c[t>>2]|0,c[x>>2]|0)|0;b=Nz(c[(c[f>>2]|0)+64>>2]|0,c[w>>2]|0,0,c[x>>2]|0)|0;c[(c[f>>2]|0)+76>>2]=b;if((c[h>>2]|0)==1?1:(c[(c[g>>2]|0)+16>>2]|0)==0){Jz(c[(c[f>>2]|0)+64>>2]|0,c[t>>2]|0,c[(c[f>>2]|0)+76>>2]|0)|0;c[h>>2]=1}break}default:{b=c[f>>2]|0;yC(b,158112,158200,MD(c[(c[g>>2]|0)+12>>2]|0)|0,0);c[e>>2]=c[h>>2];L=c[e>>2]|0;i=d;return L|0}}while(0);c[e>>2]=c[h>>2];L=c[e>>2]|0;i=d;return L|0}function cF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;c[f>>2]=0;a=c[e>>2]|0;if((c[(c[e>>2]|0)+96>>2]|0)>(c[(c[e>>2]|0)+104>>2]|0)){xB(a,155664,155696);c[d>>2]=0;h=c[d>>2]|0;i=b;return h|0}a:do if(c[a+100>>2]|0){j=c[e>>2]|0;if((c[(c[e>>2]|0)+104>>2]|0)>(c[(c[e>>2]|0)+96>>2]|0)){c[f>>2]=c[(c[(c[e>>2]|0)+100>>2]|0)+(c[j+96>>2]<<2)>>2];break}c[g>>2]=c[j+104>>2];j=(c[e>>2]|0)+104|0;c[j>>2]=c[j>>2]<<1;j=Hb[c[135760>>2]&511](c[(c[e>>2]|0)+100>>2]|0,c[(c[e>>2]|0)+104>>2]<<2)|0;c[(c[e>>2]|0)+100>>2]=j;if(!(c[(c[e>>2]|0)+100>>2]|0)){IB(c[e>>2]|0,155768,0);c[d>>2]=0;h=c[d>>2]|0;i=b;return h|0}else while(1){if((c[g>>2]|0)>=(c[(c[e>>2]|0)+104>>2]|0))break a;c[(c[(c[e>>2]|0)+100>>2]|0)+(c[g>>2]<<2)>>2]=0;c[g>>2]=(c[g>>2]|0)+1}}else{j=Cb[c[135744>>2]&511](40)|0;c[(c[e>>2]|0)+100>>2]=j;j=c[e>>2]|0;if(c[(c[e>>2]|0)+100>>2]|0){k=(c[j+100>>2]|0)+0|0;l=k+40|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(l|0));c[(c[e>>2]|0)+104>>2]=10;break}IB(j,155728,0);c[d>>2]=0;h=c[d>>2]|0;i=b;return h|0}while(0);do if(c[f>>2]|0){if(c[(c[f>>2]|0)+12>>2]|0){xB(c[e>>2]|0,155664,155840);c[d>>2]=0;h=c[d>>2]|0;i=b;return h|0}}else{c[f>>2]=Cb[c[135744>>2]&511](84)|0;if(c[f>>2]|0){c[(c[(c[e>>2]|0)+100>>2]|0)+(c[(c[e>>2]|0)+96>>2]<<2)>>2]=c[f>>2];break}IB(c[e>>2]|0,155808,0);c[d>>2]=0;h=c[d>>2]|0;i=b;return h|0}while(0);k=(c[f>>2]|0)+0|0;l=k+84|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(l|0));c[c[f>>2]>>2]=1;c[(c[f>>2]|0)+48>>2]=c[(c[e>>2]|0)+96>>2];c[d>>2]=c[f>>2];h=c[d>>2]|0;i=b;return h|0}function dF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;do if(!(c[(c[e>>2]|0)+164>>2]|0)){a=Cb[c[135744>>2]&511](4)|0;c[(c[e>>2]|0)+164>>2]=a;c[(c[e>>2]|0)+172>>2]=1;if(!(c[(c[e>>2]|0)+164>>2]|0)){IB(c[e>>2]|0,145800,0);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}}else{a=c[e>>2]|0;if((c[(c[e>>2]|0)+172>>2]|0)<=(c[(c[e>>2]|0)+168>>2]|0)){h=a+172|0;c[h>>2]=(c[h>>2]|0)+1;h=Hb[c[135760>>2]&511](c[(c[e>>2]|0)+164>>2]|0,c[(c[e>>2]|0)+172>>2]<<2)|0;c[(c[e>>2]|0)+164>>2]=h;if(c[(c[e>>2]|0)+164>>2]|0)break;IB(c[e>>2]|0,145832,0);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}h=a+168|0;a=c[h>>2]|0;c[h>>2]=a+1;c[f>>2]=c[(c[(c[e>>2]|0)+164>>2]|0)+(a<<2)>>2];if(c[(c[f>>2]|0)+12>>2]|0){xB(c[e>>2]|0,145872,145904);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{c[c[f>>2]>>2]=2;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}}while(0);c[f>>2]=Cb[c[135744>>2]&511](60)|0;if(!(c[f>>2]|0)){IB(c[e>>2]|0,145928,0);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{a=(c[f>>2]|0)+0|0;h=a+60|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(h|0));c[c[f>>2]>>2]=2;a=c[f>>2]|0;h=(c[e>>2]|0)+168|0;j=c[h>>2]|0;c[h>>2]=j+1;c[(c[(c[e>>2]|0)+164>>2]|0)+(j<<2)>>2]=a;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function eF(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+48|0;e=b+32|0;f=b+28|0;g=b+24|0;h=b+20|0;j=b+16|0;k=b+12|0;l=b+8|0;m=b+4|0;n=b;c[f>>2]=a;c[j>>2]=0;c[l>>2]=0;c[m>>2]=0;c[n>>2]=RG(c[f>>2]|0,3)|0;if(!(c[n>>2]|0))c[n>>2]=RG(c[f>>2]|0,4)|0;if(!(c[n>>2]|0)){c[e>>2]=0;o=c[e>>2]|0;i=b;return o|0}c[g>>2]=c[(c[n>>2]|0)+20>>2];do{if((c[(c[n>>2]|0)+48>>2]|0)==3){while(1){do if((d[c[g>>2]>>0]|0|0)==32)p=1;else{if(9<=(d[c[g>>2]>>0]|0|0)?(d[c[g>>2]>>0]|0|0)<=10:0){p=1;break}p=(d[c[g>>2]>>0]|0|0)==13}while(0);q=c[g>>2]|0;if(!p)break;c[g>>2]=q+1}c[h>>2]=q;while(1){if(d[c[h>>2]>>0]|0){do if((d[c[h>>2]>>0]|0|0)==32)r=1;else{if(9<=(d[c[h>>2]>>0]|0|0)?(d[c[h>>2]>>0]|0|0)<=10:0){r=1;break}r=(d[c[h>>2]>>0]|0|0)==13}while(0);s=r^1}else s=0;t=c[h>>2]|0;if(!s)break;c[h>>2]=t+1}if((t|0)==(c[g>>2]|0))break;c[l>>2]=(c[l>>2]|0)+1;c[j>>2]=AP(c[(c[(c[f>>2]|0)+20>>2]|0)+60>>2]|0,c[g>>2]|0,(c[h>>2]|0)-(c[g>>2]|0)|0)|0;c[g>>2]=c[h>>2]}while(1){do if((d[c[g>>2]>>0]|0|0)==32)u=1;else{if(9<=(d[c[g>>2]>>0]|0|0)?(d[c[g>>2]>>0]|0|0)<=10:0){u=1;break}u=(d[c[g>>2]>>0]|0|0)==13}while(0);v=c[g>>2]|0;if(!u)break;c[g>>2]=v+1}c[h>>2]=v;while(1){if(d[c[h>>2]>>0]|0){do if((d[c[h>>2]>>0]|0|0)==32)w=1;else{if(9<=(d[c[h>>2]>>0]|0|0)?(d[c[h>>2]>>0]|0|0)<=10:0){w=1;break}w=(d[c[h>>2]>>0]|0|0)==13}while(0);x=w^1}else x=0;y=c[h>>2]|0;if(!x)break;c[h>>2]=y+1}if((y|0)==(c[g>>2]|0)){z=40;break}c[l>>2]=(c[l>>2]|0)+1;c[k>>2]=AP(c[(c[(c[f>>2]|0)+20>>2]|0)+60>>2]|0,c[g>>2]|0,(c[h>>2]|0)-(c[g>>2]|0)|0)|0;c[g>>2]=c[h>>2];c[m>>2]=SG(c[f>>2]|0,c[(c[f>>2]|0)+20>>2]|0,c[(c[n>>2]|0)+4>>2]|0,c[j>>2]|0,c[k>>2]|0)|0;if((c[m>>2]|0)==-1){z=43;break}}while((d[c[g>>2]>>0]|0|0)!=0);if((z|0)==40){if((c[(c[n>>2]|0)+48>>2]|0)==3)NC(c[f>>2]|0,1879,c[(c[n>>2]|0)+4>>2]|0,0,155136,0,0,0)}else if((z|0)==43){xB(c[f>>2]|0,155224,155248);c[e>>2]=-1;o=c[e>>2]|0;i=b;return o|0}c[e>>2]=c[m>>2];o=c[e>>2]|0;i=b;return o|0}function fF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+96|0;d=b+80|0;e=b+76|0;f=b+72|0;g=b+68|0;h=b+64|0;j=b+60|0;k=b+56|0;l=b+16|0;m=b+8|0;n=b+4|0;o=b;c[e>>2]=a;c[h>>2]=0;a=c[e>>2]|0;if((c[(c[e>>2]|0)+96>>2]|0)<=0){xB(a,154576,154608);c[d>>2]=-1;p=c[d>>2]|0;i=b;return p|0}c[f>>2]=c[(c[(c[e>>2]|0)+100>>2]|0)+((c[a+96>>2]|0)-1<<2)>>2];if(c[(c[f>>2]|0)+32>>2]&32){a=(c[f>>2]|0)+32|0;c[a>>2]=c[a>>2]^32}a:do if(c[(c[f>>2]|0)+32>>2]&4){c[(c[e>>2]|0)+108>>2]=c[(c[(c[e>>2]|0)+100>>2]|0)+((c[(c[e>>2]|0)+96>>2]|0)-1<<2)>>2];c[h>>2]=1848;AB(c[e>>2]|0,c[h>>2]|0,0,0,154648,0,0);c[(c[e>>2]|0)+108>>2]=c[(c[(c[e>>2]|0)+100>>2]|0)+(c[(c[e>>2]|0)+96>>2]<<2)>>2]}else{c[g>>2]=c[(c[f>>2]|0)+28>>2];if((c[(c[g>>2]|0)+88>>2]|0)==45){a=yE(c[(c[e>>2]|0)+20>>2]|0,c[(c[(c[e>>2]|0)+108>>2]|0)+12>>2]|0,c[(c[(c[e>>2]|0)+108>>2]|0)+16>>2]|0)|0;c[(c[(c[e>>2]|0)+108>>2]|0)+44>>2]=a;do if(!(c[(c[(c[e>>2]|0)+108>>2]|0)+44>>2]|0)){c[j>>2]=RG(c[e>>2]|0,1)|0;if(!(c[j>>2]|0)){a=IH(45)|0;c[(c[(c[e>>2]|0)+108>>2]|0)+28>>2]=a;break}c[h>>2]=TG(c[e>>2]|0,c[j>>2]|0,(c[(c[e>>2]|0)+108>>2]|0)+28|0,0)|0;if(c[h>>2]|0)if((c[h>>2]|0)==-1){xB(c[e>>2]|0,154576,154504);c[d>>2]=-1;p=c[d>>2]|0;i=b;return p|0}else{c[d>>2]=c[h>>2];p=c[d>>2]|0;i=b;return p|0}}while(0);c[d>>2]=0;p=c[d>>2]|0;i=b;return p|0}b:do switch(c[(c[g>>2]|0)+52>>2]|0){case 2:case 3:{c[n>>2]=10;if(!(c[(c[g>>2]|0)+108>>2]|0)){xB(c[e>>2]|0,154576,154808);c[d>>2]=-1;p=c[d>>2]|0;i=b;return p|0}if(c[(c[f>>2]|0)+32>>2]&256){xB(c[e>>2]|0,154576,154856);c[d>>2]=-1;p=c[d>>2]|0;i=b;return p|0}c[k>>2]=c[(c[f>>2]|0)+60>>2];do if(!(c[k>>2]|0)){c[k>>2]=oz(c[(c[g>>2]|0)+108>>2]|0,358,c[e>>2]|0)|0;if(c[k>>2]|0){c[(c[f>>2]|0)+60>>2]=c[k>>2];break}xB(c[e>>2]|0,154576,141760);c[d>>2]=-1;p=c[d>>2]|0;i=b;return p|0}while(0);c[h>>2]=rz(c[k>>2]|0,c[(c[(c[e>>2]|0)+108>>2]|0)+12>>2]|0,c[(c[(c[e>>2]|0)+108>>2]|0)+16>>2]|0,c[(c[e>>2]|0)+108>>2]|0)|0;if((c[(c[e>>2]|0)+52>>2]|0)==1818){xB(c[e>>2]|0,154576,154912);c[d>>2]=-1;p=c[d>>2]|0;i=b;return p|0}if((c[h>>2]|0)<0){tz(c[k>>2]|0,0,n,o,l,m)|0;mF(c[e>>2]|0,1871,0,0,154944,c[n>>2]|0,c[o>>2]|0,l);c[h>>2]=c[(c[e>>2]|0)+52>>2];break a}else{c[h>>2]=0;break b}break}case 1:{c[(c[e>>2]|0)+108>>2]=c[(c[(c[e>>2]|0)+100>>2]|0)+((c[(c[e>>2]|0)+96>>2]|0)-1<<2)>>2];c[h>>2]=1841;AB(c[e>>2]|0,c[h>>2]|0,0,0,154736,0,0);c[(c[e>>2]|0)+108>>2]=c[(c[(c[e>>2]|0)+100>>2]|0)+(c[(c[e>>2]|0)+96>>2]<<2)>>2];break a;break}case 6:case 4:{c[(c[e>>2]|0)+108>>2]=c[(c[(c[e>>2]|0)+100>>2]|0)+((c[(c[e>>2]|0)+96>>2]|0)-1<<2)>>2];if((c[c[g>>2]>>2]|0)!=5?(c[(c[g>>2]|0)+88>>2]|0)!=45:0){c[h>>2]=1828;AB(c[e>>2]|0,c[h>>2]|0,0,0,155064,0,0)}else{c[h>>2]=1842;AB(c[e>>2]|0,c[h>>2]|0,0,0,154976,0,0)}c[(c[e>>2]|0)+108>>2]=c[(c[(c[e>>2]|0)+100>>2]|0)+(c[(c[e>>2]|0)+96>>2]<<2)>>2];c[h>>2]=c[(c[e>>2]|0)+52>>2];break a;break}default:{}}while(0);c[d>>2]=c[h>>2];p=c[d>>2]|0;i=b;return p|0}while(0);c[(c[e>>2]|0)+176>>2]=c[(c[e>>2]|0)+96>>2];g=(c[(c[e>>2]|0)+108>>2]|0)+32|0;c[g>>2]=c[g>>2]|512;g=(c[f>>2]|0)+32|0;c[g>>2]=c[g>>2]|256;c[d>>2]=c[h>>2];p=c[d>>2]|0;i=b;return p|0}function gF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=c[(c[(c[f>>2]|0)+108>>2]|0)+44>>2];if(!((c[g>>2]|0)==0|(c[h>>2]|0)==0)?(c[c[h>>2]>>2]|0)==2:0){c[c[g>>2]>>2]=0;if((c[(c[h>>2]|0)+24>>2]|0)==1){c[c[g>>2]>>2]=1;c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}c[j>>2]=0;c[j>>2]=yE(c[(c[f>>2]|0)+20>>2]|0,c[(c[(c[f>>2]|0)+108>>2]|0)+12>>2]|0,c[(c[(c[f>>2]|0)+108>>2]|0)+16>>2]|0)|0;if(c[j>>2]|0){c[(c[(c[f>>2]|0)+108>>2]|0)+44>>2]=c[j>>2];c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}j=c[f>>2]|0;if((c[(c[h>>2]|0)+24>>2]|0)==3){AB(j,1845,0,0,154416,0,0);c[e>>2]=c[(c[f>>2]|0)+52>>2];l=c[e>>2]|0;i=d;return l|0}if((c[j+168>>2]|0)!=0?(c[k>>2]=RG(c[f>>2]|0,1)|0,(c[k>>2]|0)!=0):0)if((TG(c[f>>2]|0,c[k>>2]|0,(c[(c[f>>2]|0)+108>>2]|0)+28|0,0)|0)==-1){xB(c[f>>2]|0,154368,154504);c[e>>2]=-1;l=c[e>>2]|0;i=d;return l|0}else{c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}k=IH(45)|0;c[(c[(c[f>>2]|0)+108>>2]|0)+28>>2]=k;c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}xB(c[f>>2]|0,154368,154400);c[e>>2]=-1;l=c[e>>2]|0;i=d;return l|0}function hF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+32|0;d=b+24|0;e=b+20|0;f=b+16|0;g=b+12|0;h=b+8|0;j=b+4|0;k=b;c[e>>2]=a;c[f>>2]=c[(c[(c[e>>2]|0)+108>>2]|0)+44>>2];if(!(c[f>>2]|0)){AB(c[e>>2]|0,1845,0,0,146200,0,0);c[d>>2]=c[(c[e>>2]|0)+52>>2];l=c[d>>2]|0;i=b;return l|0}c[g>>2]=c[(c[f>>2]|0)+28>>2];if(c[(c[f>>2]|0)+48>>2]&16){AB(c[e>>2]|0,1846,0,0,146240,0,0);c[d>>2]=c[(c[e>>2]|0)+52>>2];l=c[d>>2]|0;i=b;return l|0}a=c[e>>2]|0;if(!(c[g>>2]|0)){AB(a,1875,0,0,145096,0,0);c[d>>2]=1875;l=c[d>>2]|0;i=b;return l|0}do if(c[a+168>>2]|0){c[j>>2]=RG(c[e>>2]|0,2)|0;do if(c[j>>2]|0){c[(c[e>>2]|0)+108>>2]=c[j>>2];m=c[e>>2]|0;n=IH(15)|0;c[h>>2]=yB(m,0,n,c[(c[j>>2]|0)+20>>2]|0,(c[j>>2]|0)+24|0,1,0,0)|0;c[(c[e>>2]|0)+108>>2]=c[(c[(c[e>>2]|0)+100>>2]|0)+(c[(c[e>>2]|0)+96>>2]<<2)>>2];if((c[h>>2]|0)<0){xB(c[e>>2]|0,146280,146312);c[d>>2]=-1;l=c[d>>2]|0;i=b;return l|0}if(!(c[h>>2]|0)){if(!(c[(c[f>>2]|0)+48>>2]&1)){AB(c[e>>2]|0,1847,0,0,146392,0,0);break}if(MH(c[(c[j>>2]|0)+24>>2]|0)|0){if((c[(c[f>>2]|0)+48>>2]&8|0)!=0?(c[(c[f>>2]|0)+76>>2]|0)!=0:0){AB(c[e>>2]|0,1849,0,0,146424,0,0);break}n=(c[(c[e>>2]|0)+108>>2]|0)+32|0;c[n>>2]=c[n>>2]|4}}}while(0);c[j>>2]=RG(c[e>>2]|0,1)|0;if(c[j>>2]|0){c[k>>2]=0;c[h>>2]=TG(c[e>>2]|0,c[j>>2]|0,k,c[f>>2]|0)|0;if((c[h>>2]|0)!=0&(c[h>>2]|0)==-1){xB(c[e>>2]|0,146280,146512);c[d>>2]=-1;l=c[d>>2]|0;i=b;return l|0}else{if(!(c[k>>2]|0))break;n=(c[(c[e>>2]|0)+108>>2]|0)+32|0;c[n>>2]=c[n>>2]|8;c[g>>2]=c[k>>2];break}}}while(0);if((c[(c[f>>2]|0)+100>>2]|0)!=0?(UG(c[e>>2]|0,c[f>>2]|0)|0)==-1:0){c[d>>2]=-1;l=c[d>>2]|0;i=b;return l|0}if(!(c[g>>2]|0)){AB(c[e>>2]|0,1875,0,0,145096,0,0);c[d>>2]=1875;l=c[d>>2]|0;i=b;return l|0}else{c[(c[(c[e>>2]|0)+108>>2]|0)+28>>2]=c[g>>2];c[d>>2]=0;l=c[d>>2]|0;i=b;return l|0}return 0}function iF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+48|0;e=d+36|0;f=d+32|0;g=d+28|0;h=d+24|0;j=d+20|0;k=d+16|0;l=d+12|0;m=d+8|0;n=d+4|0;o=d;c[f>>2]=a;c[g>>2]=b;c[j>>2]=0;c[m>>2]=0;c[n>>2]=c[(c[f>>2]|0)+96>>2];if(!(c[(c[f>>2]|0)+116>>2]|0)){c[e>>2]=0;p=c[e>>2]|0;i=d;return p|0}if((c[g>>2]|0)==2)c[n>>2]=(c[n>>2]|0)+1;c[k>>2]=c[(c[f>>2]|0)+116>>2];c[h>>2]=c[k>>2];a:while(1){if((c[h>>2]|0)==(c[j>>2]|0)){q=34;break}b=c[(c[h>>2]|0)+32>>2]|0;a=c[(c[(c[f>>2]|0)+108>>2]|0)+12>>2]|0;r=c[(c[(c[f>>2]|0)+108>>2]|0)+16>>2]|0;if((c[g>>2]|0)==1)c[l>>2]=HQ(b,a,r)|0;else c[l>>2]=JQ(b,a,r)|0;if((c[l>>2]|0)==-1){q=11;break}b:do if(c[l>>2]|0){if(c[(c[h>>2]|0)+12>>2]|0){if((c[(c[h>>2]|0)+20>>2]|0)<=(c[(c[h>>2]|0)+16>>2]|0)?(r=(c[h>>2]|0)+20|0,c[r>>2]=c[r>>2]<<1,r=Hb[c[135760>>2]&511](c[(c[h>>2]|0)+12>>2]|0,c[(c[h>>2]|0)+20>>2]<<2)|0,c[(c[h>>2]|0)+12>>2]=r,(c[(c[h>>2]|0)+12>>2]|0)==0):0){q=19;break a}}else{r=Cb[c[135744>>2]&511](20)|0;c[(c[h>>2]|0)+12>>2]=r;if(!(c[(c[h>>2]|0)+12>>2]|0)){q=15;break a}c[(c[h>>2]|0)+20>>2]=5}r=c[n>>2]|0;a=(c[h>>2]|0)+16|0;b=c[a>>2]|0;c[a>>2]=b+1;c[(c[(c[h>>2]|0)+12>>2]|0)+(b<<2)>>2]=r;r=c[h>>2]|0;if((c[c[h>>2]>>2]|0)==1){c[o>>2]=c[(c[(c[(c[r+24>>2]|0)+16>>2]|0)+4>>2]|0)+28>>2];while(1){if(!(c[o>>2]|0))break b;if((VG(c[f>>2]|0,c[(c[h>>2]|0)+24>>2]|0,c[o>>2]|0,2)|0)==-1){q=24;break a}c[o>>2]=c[c[o>>2]>>2]}}if((c[r>>2]|0)==2){if((c[m>>2]|0)==0?(c[(c[(c[f>>2]|0)+108>>2]|0)+32>>2]&16|0)==0:0){b=(c[(c[f>>2]|0)+108>>2]|0)+32|0;c[b>>2]=c[b>>2]|16}c[m>>2]=(c[m>>2]|0)+1}}while(0);if(!(c[(c[h>>2]|0)+4>>2]|0)){c[j>>2]=c[k>>2];c[h>>2]=c[(c[f>>2]|0)+116>>2];continue}else{c[h>>2]=c[(c[h>>2]|0)+4>>2];continue}}if((q|0)==11){xB(c[f>>2]|0,145960,145984);c[e>>2]=-1;p=c[e>>2]|0;i=d;return p|0}else if((q|0)==15){IB(0,146008,0);c[e>>2]=-1;p=c[e>>2]|0;i=d;return p|0}else if((q|0)==19){IB(0,146048,0);c[e>>2]=-1;p=c[e>>2]|0;i=d;return p|0}else if((q|0)==24){c[e>>2]=-1;p=c[e>>2]|0;i=d;return p|0}else if((q|0)==34){c[e>>2]=c[m>>2];p=c[e>>2]|0;i=d;return p|0}return 0}function jF(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;b=i;i=i+128|0;e=b;f=b+100|0;g=b+96|0;h=b+92|0;j=b+88|0;k=b+84|0;l=b+80|0;m=b+76|0;n=b+72|0;o=b+68|0;p=b+64|0;q=b+60|0;r=b+56|0;s=b+52|0;t=b+48|0;u=b+44|0;v=b+40|0;w=b+36|0;x=b+32|0;y=b+28|0;z=b+24|0;A=b+20|0;B=b+16|0;C=b+104|0;D=b+12|0;E=b+8|0;c[g>>2]=a;c[h>>2]=c[(c[(c[g>>2]|0)+108>>2]|0)+28>>2];c[k>>2]=0;c[l>>2]=0;c[t>>2]=0;c[v>>2]=0;c[x>>2]=0;c[j>>2]=c[(c[h>>2]|0)+116>>2];c[r>>2]=c[(c[g>>2]|0)+168>>2];if(c[j>>2]|0)c[s>>2]=c[(c[j>>2]|0)+4>>2];else c[s>>2]=0;c[o>>2]=0;a:while(1){if((c[o>>2]|0)>=(c[s>>2]|0)){F=26;break}c[q>>2]=0;c[k>>2]=c[(c[c[j>>2]>>2]|0)+(c[o>>2]<<2)>>2];c[l>>2]=c[(c[k>>2]|0)+12>>2];c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[r>>2]|0))break;c[m>>2]=c[(c[(c[g>>2]|0)+164>>2]|0)+(c[p>>2]<<2)>>2];if((((c[(c[m>>2]|0)+48>>2]|0)==0?(d[c[(c[m>>2]|0)+12>>2]>>0]|0|0)==(d[c[(c[l>>2]|0)+8>>2]>>0]|0|0):0)?(qy(c[(c[m>>2]|0)+12>>2]|0,c[(c[l>>2]|0)+8>>2]|0)|0)!=0:0)?(qy(c[(c[m>>2]|0)+16>>2]|0,c[(c[l>>2]|0)+56>>2]|0)|0)!=0:0){F=12;break}c[p>>2]=(c[p>>2]|0)+1}if((F|0)==12){F=0;c[q>>2]=1;c[(c[m>>2]|0)+44>>2]=2;c[(c[m>>2]|0)+40>>2]=c[k>>2];c[(c[m>>2]|0)+36>>2]=c[l>>2];c[(c[m>>2]|0)+28>>2]=c[(c[l>>2]|0)+48>>2]}do if(!(c[q>>2]|0)){if((c[(c[k>>2]|0)+24>>2]|0)==1){c[n>>2]=dF(c[g>>2]|0)|0;if(!(c[n>>2]|0)){F=17;break a}c[(c[n>>2]|0)+44>>2]=4;c[(c[n>>2]|0)+40>>2]=c[k>>2];c[(c[n>>2]|0)+36>>2]=c[l>>2];break}if((c[(c[k>>2]|0)+24>>2]|0)==2){if((c[(c[k>>2]|0)+28>>2]|0)==0?(c[(c[l>>2]|0)+44>>2]|0)==0:0)break;c[n>>2]=dF(c[g>>2]|0)|0;if(!(c[n>>2]|0)){F=23;break a}c[(c[n>>2]|0)+44>>2]=8;c[(c[n>>2]|0)+40>>2]=c[k>>2];c[(c[n>>2]|0)+36>>2]=c[l>>2];c[(c[n>>2]|0)+28>>2]=c[(c[l>>2]|0)+48>>2];c[(c[n>>2]|0)+12>>2]=c[(c[l>>2]|0)+8>>2];c[(c[n>>2]|0)+16>>2]=c[(c[l>>2]|0)+56>>2]}}while(0);c[o>>2]=(c[o>>2]|0)+1}if((F|0)==17){xB(c[g>>2]|0,145272,145304);c[f>>2]=-1;G=c[f>>2]|0;i=b;return G|0}else if((F|0)==23){xB(c[g>>2]|0,145272,145304);c[f>>2]=-1;G=c[f>>2]|0;i=b;return G|0}else if((F|0)==26){if(!(c[(c[g>>2]|0)+168>>2]|0)){c[f>>2]=0;G=c[f>>2]|0;i=b;return G|0}b:do if(c[(c[h>>2]|0)+84>>2]|0){c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[r>>2]|0))break b;c[m>>2]=c[(c[(c[g>>2]|0)+164>>2]|0)+(c[o>>2]<<2)>>2];c:do if((c[(c[m>>2]|0)+44>>2]|0)==1?(DG(c[(c[h>>2]|0)+84>>2]|0,c[(c[m>>2]|0)+16>>2]|0)|0)==0:0){if((c[(c[(c[h>>2]|0)+84>>2]|0)+24>>2]|0)==1){c[(c[m>>2]|0)+44>>2]=13;break}l=BE(c[(c[g>>2]|0)+20>>2]|0,c[(c[m>>2]|0)+12>>2]|0,c[(c[m>>2]|0)+16>>2]|0)|0;c[(c[m>>2]|0)+36>>2]=l;
if(!(c[(c[m>>2]|0)+36>>2]|0)){l=(c[m>>2]|0)+44|0;if((c[(c[(c[h>>2]|0)+84>>2]|0)+24>>2]|0)==2){c[l>>2]=14;break}else{c[l>>2]=10;break}}c[(c[m>>2]|0)+44>>2]=2;c[(c[m>>2]|0)+28>>2]=c[(c[(c[m>>2]|0)+36>>2]|0)+48>>2];if(SE(c[(c[m>>2]|0)+28>>2]|0,23)|0){if(c[v>>2]|0){c[(c[m>>2]|0)+44>>2]=15;l=c[33976]|0;n=c[33980]|0;c[e>>2]=140328;c[e+4>>2]=25406;Db[l&511](n,140296,e);break}c[v>>2]=(c[v>>2]|0)+1;if(c[j>>2]|0){c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[(c[j>>2]|0)+4>>2]|0))break c;if(SE(c[(c[(c[(c[c[j>>2]>>2]|0)+(c[p>>2]<<2)>>2]|0)+12>>2]|0)+48>>2]|0,23)|0)break;c[p>>2]=(c[p>>2]|0)+1}c[(c[m>>2]|0)+44>>2]=16;n=c[33976]|0;l=c[33980]|0;c[e>>2]=140328;c[e+4>>2]=25424;Db[n&511](l,140296,e)}}}while(0);c[o>>2]=(c[o>>2]|0)+1}}while(0);if(!(c[(c[g>>2]|0)+168>>2]|0)){c[f>>2]=0;G=c[f>>2]|0;i=b;return G|0}if((((c[(c[g>>2]|0)+80>>2]&1|0)!=0?(c[y>>2]=c[(c[(c[g>>2]|0)+100>>2]|0)+(c[(c[g>>2]|0)+96>>2]<<2)>>2],(c[y>>2]|0)!=0):0)?(c[(c[y>>2]|0)+4>>2]|0)!=0:0)?(c[(c[(c[y>>2]|0)+4>>2]|0)+32>>2]|0)!=0:0)c[x>>2]=c[(c[y>>2]|0)+4>>2];c[o>>2]=0;d:while(1){if((c[o>>2]|0)>=(c[(c[g>>2]|0)+168>>2]|0)){F=124;break}c[m>>2]=c[(c[(c[g>>2]|0)+164>>2]|0)+(c[o>>2]<<2)>>2];if(!((c[(c[m>>2]|0)+44>>2]|0)!=2?(c[(c[m>>2]|0)+44>>2]|0)!=8:0))F=60;do if((F|0)==60){F=0;y=c[m>>2]|0;if(!(c[(c[m>>2]|0)+28>>2]|0)){c[y+44>>2]=6;break}c[(c[g>>2]|0)+108>>2]=y;c[w>>2]=0;c[t>>2]=0;if((c[(c[g>>2]|0)+116>>2]|0)!=0?(c[t>>2]=iF(c[g>>2]|0,2)|0,(c[t>>2]|0)==-1):0){F=64;break d}e:do if((c[(c[m>>2]|0)+44>>2]|0)==8){if((c[t>>2]|0)!=0|(c[x>>2]|0)!=0){y=c[m>>2]|0;if(c[(c[(c[m>>2]|0)+40>>2]|0)+28>>2]|0){c[(c[m>>2]|0)+20>>2]=c[(c[y+40>>2]|0)+28>>2];c[(c[m>>2]|0)+24>>2]=c[(c[(c[m>>2]|0)+40>>2]|0)+32>>2]}else{c[(c[m>>2]|0)+20>>2]=c[(c[y+36>>2]|0)+44>>2];c[(c[m>>2]|0)+24>>2]=c[(c[(c[m>>2]|0)+36>>2]|0)+68>>2]}if(!(c[(c[m>>2]|0)+24>>2]|0)){F=71;break d}y=WH(c[(c[m>>2]|0)+24>>2]|0)|0;c[(c[m>>2]|0)+24>>2]=y;if(!(c[(c[m>>2]|0)+24>>2]|0)){F=73;break d}}if(c[x>>2]|0){c[A>>2]=c[(c[m>>2]|0)+20>>2];c[z>>2]=zC(c[(c[m>>2]|0)+28>>2]|0,c[(c[m>>2]|0)+20>>2]|0)|0;if(c[z>>2]|0)c[A>>2]=c[z>>2];y=c[x>>2]|0;if(!(c[(c[m>>2]|0)+16>>2]|0)){if(!($h(y,c[(c[m>>2]|0)+12>>2]|0,c[A>>2]|0)|0)){F=79;break d}}else{c[B>>2]=Ri(c[y+32>>2]|0,c[x>>2]|0,c[(c[m>>2]|0)+16>>2]|0)|0;if(!(c[B>>2]|0)){c[D>>2]=0;do{y=c[D>>2]|0;c[D>>2]=y+1;c[e>>2]=y;JT(C,12,145464,e)|0;c[B>>2]=cj(c[(c[x>>2]|0)+32>>2]|0,c[x>>2]|0,C)|0;if((c[D>>2]|0)>1e3){F=84;break d}}while((c[B>>2]|0)!=0);c[B>>2]=Ih(c[(c[g>>2]|0)+84>>2]|0,c[(c[m>>2]|0)+16>>2]|0,C)|0}ai(c[x>>2]|0,c[B>>2]|0,c[(c[m>>2]|0)+12>>2]|0,c[A>>2]|0)|0}if(c[z>>2]|0)zb[c[135736>>2]&511](c[z>>2]|0)}}else{if(c[(c[g>>2]|0)+72>>2]|0){PH(c[(c[g>>2]|0)+72>>2]|0);c[(c[g>>2]|0)+72>>2]=0}do if(c[(c[(c[m>>2]|0)+36>>2]|0)+60>>2]&512)F=96;else{if((c[(c[m>>2]|0)+40>>2]|0)!=0?(c[(c[(c[m>>2]|0)+40>>2]|0)+16>>2]&512|0)!=0:0){F=96;break}c[w>>2]=0}while(0);if((F|0)==96){F=0;c[w>>2]=1}if((c[t>>2]|0)!=0|(c[w>>2]|0)!=0){y=(c[m>>2]|0)+32|0;c[y>>2]=c[y>>2]|16;c[u>>2]=yB(c[g>>2]|0,c[(c[m>>2]|0)+4>>2]|0,c[(c[m>>2]|0)+28>>2]|0,c[(c[m>>2]|0)+20>>2]|0,(c[m>>2]|0)+24|0,1,1,0)|0}else c[u>>2]=yB(c[g>>2]|0,c[(c[m>>2]|0)+4>>2]|0,c[(c[m>>2]|0)+28>>2]|0,c[(c[m>>2]|0)+20>>2]|0,0,1,0,0)|0;if(c[u>>2]|0){if((c[u>>2]|0)==-1){F=103;break d}c[(c[m>>2]|0)+44>>2]=5;break}if(c[w>>2]|0){if(!(c[(c[m>>2]|0)+24>>2]|0)){y=c[33976]|0;p=c[33980]|0;c[e>>2]=140328;c[e+4>>2]=25678;Db[y&511](p,140296,e);break}do if(c[(c[m>>2]|0)+40>>2]|0){if(!(c[(c[(c[m>>2]|0)+40>>2]|0)+28>>2]|0))break;if(!(c[(c[(c[m>>2]|0)+40>>2]|0)+32>>2]|0)){p=c[33976]|0;y=c[33980]|0;c[e>>2]=140328;c[e+4>>2]=25685;Db[p&511](y,140296,e);break e}c[(c[m>>2]|0)+52>>2]=c[(c[(c[m>>2]|0)+40>>2]|0)+28>>2];if(VD(c[(c[m>>2]|0)+24>>2]|0,c[(c[(c[m>>2]|0)+40>>2]|0)+32>>2]|0)|0)break e;c[(c[m>>2]|0)+44>>2]=7;break e}while(0);if(!(c[(c[(c[m>>2]|0)+36>>2]|0)+68>>2]|0)){y=c[33976]|0;p=c[33980]|0;c[e>>2]=140328;c[e+4>>2]=25700;Db[y&511](p,140296,e);break}c[(c[m>>2]|0)+52>>2]=c[(c[(c[m>>2]|0)+36>>2]|0)+44>>2];if(VD(c[(c[m>>2]|0)+24>>2]|0,c[(c[(c[m>>2]|0)+36>>2]|0)+68>>2]|0)|0)break;c[(c[m>>2]|0)+44>>2]=7}}while(0);p=c[g>>2]|0;if(c[t>>2]|0)if((pF(p,(c[(c[g>>2]|0)+96>>2]|0)+1|0)|0)==-1){F=120;break d}else break;if(c[p+116>>2]|0)WG(c[g>>2]|0)|0}while(0);c[o>>2]=(c[o>>2]|0)+1}if((F|0)==64)xB(c[g>>2]|0,145272,145160);else if((F|0)==71)xB(c[g>>2]|0,145272,145344);else if((F|0)==73)xB(c[g>>2]|0,145272,145408);else if((F|0)==79){xB(c[g>>2]|0,145272,145440);if(c[z>>2]|0)zb[c[135736>>2]&511](c[z>>2]|0)}else if((F|0)==84){xB(c[g>>2]|0,145272,145472);if(c[z>>2]|0)zb[c[135736>>2]&511](c[z>>2]|0)}else if((F|0)==103)xB(c[g>>2]|0,145272,145536);else if((F|0)==120)xB(c[g>>2]|0,145272,145160);else if((F|0)==124){c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[(c[g>>2]|0)+168>>2]|0))break;c[m>>2]=c[(c[(c[g>>2]|0)+164>>2]|0)+(c[o>>2]<<2)>>2];f:do if((((c[(c[m>>2]|0)+44>>2]|0)!=17?(c[(c[m>>2]|0)+44>>2]|0)!=2:0)?(c[(c[m>>2]|0)+44>>2]|0)!=13:0)?(c[(c[m>>2]|0)+44>>2]|0)!=14:0){c[(c[g>>2]|0)+108>>2]=c[m>>2];switch(c[(c[m>>2]|0)+44>>2]|0){case 6:{AB(c[g>>2]|0,1862,0,0,145096,0,0);break f;break}case 4:{c[E>>2]=0;c[(c[g>>2]|0)+108>>2]=c[(c[(c[g>>2]|0)+100>>2]|0)+(c[(c[g>>2]|0)+96>>2]<<2)>>2];AB(c[g>>2]|0,1868,0,0,145592,BB(E,c[(c[(c[m>>2]|0)+36>>2]|0)+56>>2]|0,c[(c[(c[m>>2]|0)+36>>2]|0)+8>>2]|0)|0,0);if(!(c[E>>2]|0))break f;zb[c[135736>>2]&511](c[E>>2]|0);c[E>>2]=0;break f;break}case 7:{AB(c[g>>2]|0,1874,0,0,145640,c[(c[m>>2]|0)+20>>2]|0,c[(c[m>>2]|0)+52>>2]|0);break f;break}case 10:{AB(c[g>>2]|0,1878,0,0,145704,0,0);break f;break}case 1:{if(c[(c[m>>2]|0)+48>>2]|0)break f;F=c[g>>2]|0;z=c[m>>2]|0;if(!(c[(c[h>>2]|0)+84>>2]|0)){XG(F,1866,z,0);break f}else{XG(F,1867,z,0);break f}break}default:break f}}while(0);c[o>>2]=(c[o>>2]|0)+1}c[(c[g>>2]|0)+108>>2]=c[(c[(c[g>>2]|0)+100>>2]|0)+(c[(c[g>>2]|0)+96>>2]<<2)>>2];c[f>>2]=0;G=c[f>>2]|0;i=b;return G|0}c[(c[g>>2]|0)+108>>2]=c[(c[(c[g>>2]|0)+100>>2]|0)+(c[(c[g>>2]|0)+96>>2]<<2)>>2];c[f>>2]=-1;G=c[f>>2]|0;i=b;return G|0}return 0}function kF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;d=b+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[e>>2]=a;c[g>>2]=0;if(!(c[(c[e>>2]|0)+168>>2]|0)){c[d>>2]=0;j=c[d>>2]|0;i=b;return j|0}c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[(c[e>>2]|0)+168>>2]|0))break;c[f>>2]=c[(c[(c[e>>2]|0)+164>>2]|0)+(c[h>>2]<<2)>>2];if(!(c[(c[f>>2]|0)+48>>2]|0)){c[(c[e>>2]|0)+108>>2]=c[f>>2];XG(c[e>>2]|0,1827,c[f>>2]|0,0);c[g>>2]=1827}c[h>>2]=(c[h>>2]|0)+1}c[(c[e>>2]|0)+108>>2]=c[(c[(c[e>>2]|0)+100>>2]|0)+(c[(c[e>>2]|0)+96>>2]<<2)>>2];c[d>>2]=c[g>>2];j=c[d>>2]|0;i=b;return j|0}function lF(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f+4|0;h=f;c[f+12>>2]=a;c[f+8>>2]=b;c[g>>2]=d;c[h>>2]=e;c[(c[h>>2]|0)+44>>2]=c[g>>2];i=f;return}function mF(a,b,e,f,g,h,j,k){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;l=i;i=i+64|0;m=l+56|0;n=l+52|0;o=l+48|0;p=l+40|0;q=l+36|0;r=l+32|0;s=l+28|0;t=l+24|0;u=l+20|0;v=l+16|0;w=l+12|0;x=l+8|0;y=l+4|0;z=l;c[m>>2]=a;c[n>>2]=b;c[o>>2]=e;c[l+44>>2]=f;c[p>>2]=g;c[q>>2]=h;c[r>>2]=j;c[s>>2]=k;c[t>>2]=0;c[u>>2]=0;HC(u,c[m>>2]|0,c[o>>2]|0)|0;c[u>>2]=By(c[u>>2]|0,c[p>>2]|0)|0;c[u>>2]=By(c[u>>2]|0,144352)|0;if(((c[q>>2]|0)+(c[r>>2]|0)|0)<=0){c[u>>2]=By(c[u>>2]|0,140352)|0;A=c[m>>2]|0;B=c[n>>2]|0;C=c[o>>2]|0;D=c[u>>2]|0;PD(A,B,C,D,0,0);E=c[33934]|0;F=c[u>>2]|0;zb[E&511](F);i=l;return}if(((c[q>>2]|0)+(c[r>>2]|0)|0)>1)c[t>>2]=my(144360)|0;else c[t>>2]=my(144384)|0;c[w>>2]=0;c[z>>2]=0;while(1){if((c[z>>2]|0)>=((c[q>>2]|0)+(c[r>>2]|0)|0))break;c[x>>2]=c[(c[s>>2]|0)+(c[z>>2]<<2)>>2];do if(c[x>>2]|0){if((((d[c[x>>2]>>0]|0|0)==110?(d[(c[x>>2]|0)+1>>0]|0|0)==111:0)?(d[(c[x>>2]|0)+2>>0]|0|0)==116:0)?(d[(c[x>>2]|0)+3>>0]|0|0)==32:0){c[x>>2]=(c[x>>2]|0)+4;c[t>>2]=By(c[t>>2]|0,144400)|0}c[v>>2]=0;c[y>>2]=c[x>>2];if((d[c[y>>2]>>0]|0|0)==42){c[v>>2]=my(140432)|0;c[y>>2]=(c[y>>2]|0)+1}else{while(1){if(!(d[c[y>>2]>>0]|0))break;if((d[c[y>>2]>>0]|0|0)==124)break;c[y>>2]=(c[y>>2]|0)+1}c[v>>2]=zy(c[v>>2]|0,c[x>>2]|0,(c[y>>2]|0)-(c[x>>2]|0)|0)|0}if(d[c[y>>2]>>0]|0){c[y>>2]=(c[y>>2]|0)+1;if(((c[r>>2]|0)!=0?(d[c[y>>2]>>0]|0|0)==42:0)?(d[c[v>>2]>>0]|0|0)==42:0){if(!(c[v>>2]|0))break;zb[c[135736>>2]&511](c[v>>2]|0);c[v>>2]=0;break}c[x>>2]=c[y>>2];if((d[c[y>>2]>>0]|0|0)==42)c[w>>2]=my(144408)|0;else{while(1){if(!(d[c[y>>2]>>0]|0))break;c[y>>2]=(c[y>>2]|0)+1}if((c[z>>2]|0)>=(c[q>>2]|0))c[w>>2]=my(144416)|0;else c[w>>2]=my(144432)|0;c[w>>2]=zy(c[w>>2]|0,c[x>>2]|0,(c[y>>2]|0)-(c[x>>2]|0)|0)|0;c[w>>2]=By(c[w>>2]|0,144440)|0}c[t>>2]=By(c[t>>2]|0,c[w>>2]|0)|0;if(c[w>>2]|0){zb[c[135736>>2]&511](c[w>>2]|0);c[w>>2]=0}}c[t>>2]=By(c[t>>2]|0,c[v>>2]|0)|0;if(c[v>>2]|0){zb[c[135736>>2]&511](c[v>>2]|0);c[v>>2]=0}if((c[z>>2]|0)<((c[q>>2]|0)+(c[r>>2]|0)-1|0))c[t>>2]=By(c[t>>2]|0,144448)|0}while(0);c[z>>2]=(c[z>>2]|0)+1}c[t>>2]=By(c[t>>2]|0,144456)|0;c[u>>2]=By(c[u>>2]|0,c[t>>2]|0)|0;if(!(c[t>>2]|0)){A=c[m>>2]|0;B=c[n>>2]|0;C=c[o>>2]|0;D=c[u>>2]|0;PD(A,B,C,D,0,0);E=c[33934]|0;F=c[u>>2]|0;zb[E&511](F);i=l;return}zb[c[135736>>2]&511](c[t>>2]|0);c[t>>2]=0;A=c[m>>2]|0;B=c[n>>2]|0;C=c[o>>2]|0;D=c[u>>2]|0;PD(A,B,C,D,0,0);E=c[33934]|0;F=c[u>>2]|0;zb[E&511](F);i=l;return}function nF(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;e=c[h>>2]|0;h=c[k>>2]|0;k=c[l>>2]|0;if(c[(c[j>>2]|0)+32>>2]&16){c[g>>2]=yB(e,0,h,k,(c[j>>2]|0)+24|0,1,1,0)|0;m=c[g>>2]|0;i=f;return m|0}else{c[g>>2]=yB(e,0,h,k,0,1,0,0)|0;m=c[g>>2]|0;i=f;return m|0}return 0}function oF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=0;c[l>>2]=c[(c[g>>2]|0)+108>>2];if(!((c[c[(c[l>>2]|0)+28>>2]>>2]|0)!=5?(c[(c[(c[l>>2]|0)+28>>2]|0)+88>>2]|0)!=45:0))m=3;do if(((m|0)==3?(c[(c[(c[l>>2]|0)+28>>2]|0)+52>>2]|0)!=4:0)?(c[(c[(c[l>>2]|0)+28>>2]|0)+52>>2]|0)!=6:0){if((c[(c[(c[l>>2]|0)+28>>2]|0)+52>>2]|0)==3?(FG(c[(c[(c[l>>2]|0)+28>>2]|0)+28>>2]|0)|0)!=0:0)break;c[k>>2]=3059;AB(c[g>>2]|0,c[k>>2]|0,0,0,144160,0,0);c[f>>2]=c[k>>2];n=c[f>>2]|0;i=e;return n|0}while(0);do if((c[c[(c[l>>2]|0)+28>>2]>>2]|0)==4)m=11;else{if((c[c[(c[l>>2]|0)+28>>2]>>2]|0)==1?(c[(c[(c[l>>2]|0)+28>>2]|0)+88>>2]|0)!=45:0){m=11;break}if((c[(c[(c[l>>2]|0)+28>>2]|0)+52>>2]|0)!=4?(c[(c[(c[l>>2]|0)+28>>2]|0)+52>>2]|0)!=6:0)break;c[k>>2]=yB(c[g>>2]|0,0,c[(c[(c[l>>2]|0)+28>>2]|0)+104>>2]|0,c[h>>2]|0,c[j>>2]|0,1,1,0)|0}while(0);if((m|0)==11)c[k>>2]=yB(c[g>>2]|0,0,c[(c[l>>2]|0)+28>>2]|0,c[h>>2]|0,c[j>>2]|0,1,1,0)|0;if((c[k>>2]|0)<0)xB(c[g>>2]|0,144320,141832);c[f>>2]=c[k>>2];n=c[f>>2]|0;i=e;return n|0}function pF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=i;i=i+128|0;e=d+124|0;f=d+120|0;g=d+116|0;h=d+112|0;j=d+108|0;k=d+104|0;l=d+100|0;m=d+96|0;n=d+92|0;o=d+88|0;p=d+84|0;q=d+80|0;r=d+76|0;s=d+72|0;t=d+68|0;u=d+64|0;v=d+60|0;w=d+56|0;x=d+52|0;y=d+48|0;z=d+44|0;A=d+40|0;B=d+36|0;C=d+32|0;D=d+28|0;E=d+24|0;F=d+20|0;G=d+16|0;H=d+12|0;I=d+8|0;J=d+4|0;K=d;c[f>>2]=a;c[g>>2]=b;c[m>>2]=0;c[n>>2]=c[(c[(c[f>>2]|0)+108>>2]|0)+28>>2];c[o>>2]=0;if(!(c[(c[f>>2]|0)+116>>2]|0)){c[e>>2]=0;L=c[e>>2]|0;i=d;return L|0}c[h>>2]=c[(c[f>>2]|0)+116>>2];a:while(1){if(!(c[h>>2]|0)){M=103;break}c[k>>2]=KQ(c[(c[h>>2]|0)+32>>2]|0)|0;if((c[k>>2]|0)==-1){M=6;break}do if(c[(c[h>>2]|0)+16>>2]|0){c[l>>2]=c[(c[(c[h>>2]|0)+12>>2]|0)+((c[(c[h>>2]|0)+16>>2]|0)-1<<2)>>2];b=c[h>>2]|0;if((c[l>>2]|0)!=(c[g>>2]|0)){c[h>>2]=c[b+4>>2];continue a}if((c[b>>2]|0)!=2){if((c[c[h>>2]>>2]|0)==1){c[w>>2]=0;c[y>>2]=c[(c[h>>2]|0)+24>>2];c[z>>2]=c[(c[(c[y>>2]|0)+16>>2]|0)+4>>2];c[E>>2]=c[(c[z>>2]|0)+32>>2];c[B>>2]=(c[g>>2]|0)-(c[(c[y>>2]|0)+4>>2]|0);do if((c[(c[y>>2]|0)+24>>2]|0)!=0?(c[(c[y>>2]|0)+28>>2]|0)>(c[B>>2]|0):0){c[w>>2]=(c[(c[y>>2]|0)+24>>2]|0)+(c[B>>2]<<2);if(!(c[c[w>>2]>>2]|0))if((c[c[z>>2]>>2]|0)==23){M=91;break}else break;c[C>>2]=0;while(1){if((c[C>>2]|0)>=(c[E>>2]|0))break;if(!(c[(c[c[w>>2]>>2]|0)+(c[C>>2]<<2)>>2]|0)){M=61;break}c[C>>2]=(c[C>>2]|0)+1}if((M|0)==61){M=0;if((c[c[z>>2]>>2]|0)==23){M=91;break}else break}c[A>>2]=_G(c[f>>2]|0,c[y>>2]|0)|0;if((c[c[z>>2]>>2]|0)!=24?(c[(c[A>>2]|0)+4>>2]|0)!=0:0){c[C>>2]=0;c[k>>2]=0;do{c[H>>2]=c[(c[(c[c[A>>2]>>2]|0)+(c[C>>2]<<2)>>2]|0)+4>>2];c[D>>2]=0;while(1){if((c[D>>2]|0)>=(c[E>>2]|0))break;c[F>>2]=c[(c[c[w>>2]>>2]|0)+(c[D>>2]<<2)>>2];c[G>>2]=c[(c[H>>2]|0)+(c[D>>2]<<2)>>2];c[k>>2]=VD(c[(c[F>>2]|0)+4>>2]|0,c[(c[G>>2]|0)+4>>2]|0)|0;if((c[k>>2]|0)==-1){M=69;break a}if(!(c[k>>2]|0))break;c[D>>2]=(c[D>>2]|0)+1}if((c[k>>2]|0)==1)break;c[C>>2]=(c[C>>2]|0)+1}while((c[C>>2]|0)<(c[(c[A>>2]|0)+4>>2]|0));if((c[C>>2]|0)!=(c[(c[A>>2]|0)+4>>2]|0)){c[I>>2]=0;c[J>>2]=0;b=c[f>>2]|0;a=c[z>>2]|0;N=$G(c[f>>2]|0,I,c[c[w>>2]>>2]|0,c[E>>2]|0)|0;AB(b,1877,0,a,143312,N,YG(J,c[z>>2]|0)|0);if(c[I>>2]|0){zb[c[135736>>2]&511](c[I>>2]|0);c[I>>2]=0}if(!(c[J>>2]|0))break;zb[c[135736>>2]&511](c[J>>2]|0);c[J>>2]=0;break}}c[x>>2]=Cb[c[135744>>2]&511](16)|0;if(!(c[x>>2]|0)){M=80;break a}N=c[x>>2]|0;c[N+0>>2]=0;c[N+4>>2]=0;c[N+8>>2]=0;c[N+12>>2]=0;N=c[f>>2]|0;if((c[c[z>>2]>>2]|0)==24){a=bH(N,c[(c[(c[f>>2]|0)+108>>2]|0)+12>>2]|0,c[(c[(c[f>>2]|0)+108>>2]|0)+16>>2]|0)|0;c[(c[x>>2]|0)+12>>2]=a;if((c[(c[x>>2]|0)+12>>2]|0)==-1){M=86;break a}}else{if((aH(N,c[x>>2]|0)|0)==-1){M=83;break a}c[(c[x>>2]|0)+12>>2]=-1}c[c[x>>2]>>2]=c[(c[f>>2]|0)+60>>2];c[(c[x>>2]|0)+8>>2]=c[(c[(c[f>>2]|0)+108>>2]|0)+8>>2];c[(c[x>>2]|0)+4>>2]=c[c[w>>2]>>2];c[c[w>>2]>>2]=0;if((bE(c[A>>2]|0,c[x>>2]|0)|0)==-1){M=88;break a}}else M=55;while(0);if((M|0)==55?(M=0,(c[c[z>>2]>>2]|0)==23):0)M=91;if((M|0)==91?(M=0,c[K>>2]=0,N=c[f>>2]|0,a=c[z>>2]|0,AB(N,1877,0,a,143384,YG(K,c[z>>2]|0)|0,0),(c[K>>2]|0)!=0):0){zb[c[135736>>2]&511](c[K>>2]|0);c[K>>2]=0}if((c[w>>2]|0)!=0?(c[c[w>>2]>>2]|0)!=0:0){zb[c[135736>>2]&511](c[c[w>>2]>>2]|0);c[c[w>>2]>>2]=0}}}else{if((c[c[n>>2]>>2]|0)!=5?(c[(c[n>>2]|0)+88>>2]|0)!=45:0)c[o>>2]=c[n>>2];else M=13;do if((M|0)==13){M=0;if((c[(c[n>>2]|0)+52>>2]|0)!=4?(c[(c[n>>2]|0)+52>>2]|0)!=6:0){c[o>>2]=0;break}c[o>>2]=c[(c[n>>2]|0)+104>>2];if(!(c[o>>2]|0)){M=16;break a}}while(0);if(!(c[o>>2]|0)){c[p>>2]=0;a=c[f>>2]|0;N=c[(c[(c[(c[h>>2]|0)+24>>2]|0)+16>>2]|0)+4>>2]|0;b=c[(c[(c[h>>2]|0)+28>>2]|0)+12>>2]|0;AB(a,1877,0,N,142904,b,YG(p,c[(c[(c[(c[h>>2]|0)+24>>2]|0)+16>>2]|0)+4>>2]|0)|0);if(c[p>>2]|0){zb[c[135736>>2]&511](c[p>>2]|0);c[p>>2]=0}b=(c[h>>2]|0)+16|0;c[b>>2]=(c[b>>2]|0)+-1;break}if((c[m>>2]|0)==0?(c[(c[(c[f>>2]|0)+108>>2]|0)+24>>2]|0)==0:0){AB(c[f>>2]|0,1877,0,c[(c[(c[(c[h>>2]|0)+24>>2]|0)+16>>2]|0)+4>>2]|0,142984,0,0);b=(c[h>>2]|0)+16|0;c[b>>2]=(c[b>>2]|0)+-1;break}c[q>>2]=c[(c[h>>2]|0)+24>>2];c[s>>2]=(c[(c[h>>2]|0)+8>>2]|0)-(c[(c[q>>2]|0)+4>>2]|0);c[t>>2]=c[(c[(c[h>>2]|0)+28>>2]|0)+8>>2];b=c[s>>2]|0;b:do if(c[(c[q>>2]|0)+24>>2]|0){if((b|0)>=(c[(c[q>>2]|0)+28>>2]|0)){c[u>>2]=c[(c[q>>2]|0)+28>>2];N=(c[q>>2]|0)+28|0;c[N>>2]=c[N>>2]<<1;N=Hb[c[135760>>2]&511](c[(c[q>>2]|0)+24>>2]|0,c[(c[q>>2]|0)+28>>2]<<2)|0;c[(c[q>>2]|0)+24>>2]=N;if(!(c[(c[q>>2]|0)+24>>2]|0)){M=35;break a}while(1){if((c[u>>2]|0)>=(c[(c[q>>2]|0)+28>>2]|0))break b;c[(c[(c[q>>2]|0)+24>>2]|0)+(c[u>>2]<<2)>>2]=0;c[u>>2]=(c[u>>2]|0)+1}}}else{if((b|0)>9)c[(c[q>>2]|0)+28>>2]=c[s>>2]<<1;else c[(c[q>>2]|0)+28>>2]=10;N=Cb[c[135744>>2]&511](c[(c[q>>2]|0)+28>>2]<<2)|0;c[(c[q>>2]|0)+24>>2]=N;if(!(c[(c[q>>2]|0)+24>>2]|0)){M=31;break a}cU(c[(c[q>>2]|0)+24>>2]|0,0,c[(c[q>>2]|0)+28>>2]<<2|0)|0}while(0);c[r>>2]=c[(c[(c[q>>2]|0)+24>>2]|0)+(c[s>>2]<<2)>>2];if(c[r>>2]|0){if(c[(c[r>>2]|0)+(c[t>>2]<<2)>>2]|0){c[v>>2]=0;b=c[f>>2]|0;N=c[(c[(c[q>>2]|0)+16>>2]|0)+4>>2]|0;a=c[(c[(c[h>>2]|0)+28>>2]|0)+12>>2]|0;AB(b,1877,0,N,143168,a,YG(v,c[(c[(c[q>>2]|0)+16>>2]|0)+4>>2]|0)|0);if(c[v>>2]|0){zb[c[135736>>2]&511](c[v>>2]|0);c[v>>2]=0}a=(c[h>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+-1;break}}else{c[r>>2]=Cb[c[135744>>2]&511](c[(c[(c[(c[q>>2]|0)+16>>2]|0)+4>>2]|0)+32>>2]<<2)|0;if(!(c[r>>2]|0)){M=44;break a}cU(c[r>>2]|0,0,c[(c[(c[(c[q>>2]|0)+16>>2]|0)+4>>2]|0)+32>>2]<<2|0)|0;c[(c[(c[q>>2]|0)+24>>2]|0)+(c[s>>2]<<2)>>2]=c[r>>2]}if(!(c[m>>2]|0)){c[m>>2]=Cb[c[135744>>2]&511](8)|0;if(!(c[m>>2]|0)){M=48;break a}c[c[m>>2]>>2]=c[o>>2];c[(c[m>>2]|0)+4>>2]=c[(c[(c[f>>2]|0)+108>>2]|0)+24>>2];c[(c[(c[f>>2]|0)+108>>2]|0)+24>>2]=0;if((ZG(c[f>>2]|0,c[m>>2]|0)|0)==-1){M=50;break a}}c[(c[r>>2]|0)+(c[t>>2]<<2)>>2]=c[m>>2]}a=(c[h>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+-1}while(0);if((c[(c[h>>2]|0)+16>>2]|0)==0?(c[(c[h>>2]|0)+8>>2]|0)==(c[g>>2]|0):0){if((c[(c[f>>2]|0)+116>>2]|0)!=(c[h>>2]|0))xB(c[f>>2]|0,142760,143424);c[j>>2]=c[(c[h>>2]|0)+4>>2];c[(c[f>>2]|0)+116>>2]=c[(c[h>>2]|0)+4>>2];c[(c[h>>2]|0)+4>>2]=c[(c[f>>2]|0)+120>>2];c[(c[f>>2]|0)+120>>2]=c[h>>2];c[h>>2]=c[j>>2];continue}c[h>>2]=c[(c[h>>2]|0)+4>>2]}switch(M|0){case 6:{xB(c[f>>2]|0,142760,142792);c[e>>2]=-1;L=c[e>>2]|0;i=d;return L|0}case 16:{xB(c[f>>2]|0,142760,142816);c[e>>2]=-1;L=c[e>>2]|0;i=d;return L|0}case 31:{IB(0,143088,0);c[e>>2]=-1;L=c[e>>2]|0;i=d;return L|0}case 35:{IB(0,143128,0);c[e>>2]=-1;L=c[e>>2]|0;i=d;return L|0}case 44:{IB(0,143256,0);c[e>>2]=-1;L=c[e>>2]|0;i=d;return L|0}case 48:{IB(0,143288,0);zb[c[135736>>2]&511](c[r>>2]|0);c[(c[(c[q>>2]|0)+24>>2]|0)+(c[s>>2]<<2)>>2]=0;c[e>>2]=-1;L=c[e>>2]|0;i=d;return L|0}case 50:{tB(c[m>>2]|0);c[e>>2]=-1;L=c[e>>2]|0;i=d;return L|0}case 69:{c[e>>2]=-1;L=c[e>>2]|0;i=d;return L|0}case 80:{IB(0,143344,0);zb[c[135736>>2]&511](c[c[w>>2]>>2]|0);c[c[w>>2]>>2]=0;c[e>>2]=-1;L=c[e>>2]|0;i=d;return L|0}case 83:{zb[c[135736>>2]&511](c[x>>2]|0);zb[c[135736>>2]&511](c[c[w>>2]>>2]|0);c[c[w>>2]>>2]=0;c[e>>2]=-1;L=c[e>>2]|0;i=d;return L|0}case 86:{zb[c[135736>>2]&511](c[x>>2]|0);zb[c[135736>>2]&511](c[c[w>>2]>>2]|0);c[c[w>>2]>>2]=0;c[e>>2]=-1;L=c[e>>2]|0;i=d;return L|0}case 88:{if((c[c[z>>2]>>2]|0)==24){zb[c[135736>>2]&511](c[(c[x>>2]|0)+4>>2]|0);zb[c[135736>>2]&511](c[x>>2]|0)}c[e>>2]=-1;L=c[e>>2]|0;i=d;return L|0}case 103:{c[e>>2]=0;L=c[e>>2]|0;i=d;return L|0}}return 0}function qF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+80|0;e=d+64|0;f=d+60|0;g=d+56|0;h=d+52|0;j=d+48|0;k=d+44|0;l=d+40|0;m=d+36|0;n=d+32|0;o=d+28|0;p=d+24|0;q=d+20|0;r=d+16|0;s=d+12|0;t=d+8|0;u=d+4|0;v=d;c[f>>2]=a;c[g>>2]=b;c[v>>2]=c[(c[g>>2]|0)+56>>2];a:while(1){if(!(c[v>>2]|0)){w=51;break}if(((c[c[(c[(c[v>>2]|0)+16>>2]|0)+4>>2]>>2]|0)!=24?(c[(c[v>>2]|0)+32>>2]|0)!=0:0)?(c[(c[(c[v>>2]|0)+32>>2]|0)+4>>2]|0)!=0:0){do if(!(c[(c[f>>2]|0)+188>>2]|0)){if((c[(c[(c[v>>2]|0)+16>>2]|0)+8>>2]|0)!=-1?(c[(c[(c[v>>2]|0)+16>>2]|0)+8>>2]|0)<=(c[(c[f>>2]|0)+96>>2]|0):0)break;c[v>>2]=c[(c[v>>2]|0)+8>>2];continue a}while(0);c[h>>2]=cH(c[f>>2]|0,c[v>>2]|0)|0;if((c[(c[h>>2]|0)+20>>2]|0)!=0?(c[(c[(c[h>>2]|0)+20>>2]|0)+4>>2]|0)!=0:0){c[u>>2]=c[c[(c[h>>2]|0)+20>>2]>>2];c[p>>2]=c[(c[(c[h>>2]|0)+20>>2]|0)+4>>2]}else{c[u>>2]=0;c[p>>2]=0}if(c[(c[h>>2]|0)+8>>2]|0)c[q>>2]=c[(c[h>>2]|0)+12>>2];else c[q>>2]=0;g=c[(c[v>>2]|0)+32>>2]|0;if((c[q>>2]|0)==0&(c[p>>2]|0)==0){c[(c[h>>2]|0)+8>>2]=c[g>>2];c[(c[h>>2]|0)+16>>2]=c[(c[(c[v>>2]|0)+32>>2]|0)+8>>2];c[(c[h>>2]|0)+12>>2]=c[(c[(c[v>>2]|0)+32>>2]|0)+4>>2];c[c[(c[v>>2]|0)+32>>2]>>2]=0;c[(c[(c[v>>2]|0)+32>>2]|0)+8>>2]=0;c[(c[(c[v>>2]|0)+32>>2]|0)+4>>2]=0}else{c[n>>2]=c[g+4>>2];c[t>>2]=c[c[(c[v>>2]|0)+32>>2]>>2];c[o>>2]=c[(c[(c[(c[v>>2]|0)+16>>2]|0)+4>>2]|0)+32>>2];c[k>>2]=0;do{c[r>>2]=c[(c[(c[t>>2]|0)+(c[k>>2]<<2)>>2]|0)+4>>2];b:do if(c[p>>2]|0){c[l>>2]=0;while(1){if((c[o>>2]|0)==1){c[j>>2]=VD(c[(c[c[r>>2]>>2]|0)+4>>2]|0,c[(c[c[(c[(c[u>>2]|0)+(c[l>>2]<<2)>>2]|0)+4>>2]>>2]|0)+4>>2]|0)|0;if((c[j>>2]|0)==-1){w=52;break a}if((c[j>>2]|0)==1)break b}else{c[j>>2]=0;c[s>>2]=c[(c[(c[u>>2]|0)+(c[l>>2]<<2)>>2]|0)+4>>2];c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[o>>2]|0))break;c[j>>2]=VD(c[(c[(c[r>>2]|0)+(c[m>>2]<<2)>>2]|0)+4>>2]|0,c[(c[(c[s>>2]|0)+(c[m>>2]<<2)>>2]|0)+4>>2]|0)|0;if((c[j>>2]|0)==-1){w=52;break a}if(!(c[j>>2]|0))break;c[m>>2]=(c[m>>2]|0)+1}if((c[j>>2]|0)==1)break b}c[l>>2]=(c[l>>2]|0)+1;if((c[l>>2]|0)>=(c[p>>2]|0)){w=33;break}}}else w=33;while(0);c:do if((w|0)==33){w=0;d:do if(c[q>>2]|0){c[l>>2]=0;e:while(1){f:do if((c[o>>2]|0)==1){c[j>>2]=VD(c[(c[c[r>>2]>>2]|0)+4>>2]|0,c[(c[c[(c[(c[(c[h>>2]|0)+8>>2]|0)+(c[l>>2]<<2)>>2]|0)+4>>2]>>2]|0)+4>>2]|0)|0;if((c[j>>2]|0)==-1){w=52;break a}if(c[j>>2]|0)break e}else{c[j>>2]=0;c[s>>2]=c[(c[(c[(c[h>>2]|0)+8>>2]|0)+(c[l>>2]<<2)>>2]|0)+4>>2];c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[o>>2]|0))break e;c[j>>2]=VD(c[(c[(c[r>>2]|0)+(c[m>>2]<<2)>>2]|0)+4>>2]|0,c[(c[(c[s>>2]|0)+(c[m>>2]<<2)>>2]|0)+4>>2]|0)|0;if((c[j>>2]|0)==-1){w=52;break a}if(!(c[j>>2]|0))break f;c[m>>2]=(c[m>>2]|0)+1}}while(0);c[l>>2]=(c[l>>2]|0)+1;if((c[l>>2]|0)>=(c[q>>2]|0))break d}if((c[(c[h>>2]|0)+20>>2]|0)==0?(g=JB()|0,c[(c[h>>2]|0)+20>>2]=g,(c[(c[h>>2]|0)+20>>2]|0)==0):0){w=52;break a}if((bE(c[(c[h>>2]|0)+20>>2]|0,c[(c[(c[h>>2]|0)+8>>2]|0)+(c[l>>2]<<2)>>2]|0)|0)==-1){w=52;break a}c[(c[(c[h>>2]|0)+8>>2]|0)+(c[l>>2]<<2)>>2]=c[(c[(c[h>>2]|0)+8>>2]|0)+((c[(c[h>>2]|0)+12>>2]|0)-1<<2)>>2];g=(c[h>>2]|0)+12|0;c[g>>2]=(c[g>>2]|0)+-1;break c}while(0);if((dH(c[h>>2]|0,c[(c[t>>2]|0)+(c[k>>2]<<2)>>2]|0)|0)==-1){w=52;break a}}while(0);c[k>>2]=(c[k>>2]|0)+1}while((c[k>>2]|0)<(c[n>>2]|0))}c[v>>2]=c[(c[v>>2]|0)+8>>2];continue}c[v>>2]=c[(c[v>>2]|0)+8>>2]}if((w|0)==51){c[e>>2]=0;x=c[e>>2]|0;i=d;return x|0}else if((w|0)==52){c[e>>2]=-1;x=c[e>>2]|0;i=d;return x|0}return 0}function Kb(a){a=a|0;var b=0;b=i;i=i+a|0;i=i+15&-16;return b|0}function Lb(){return i|0}function Mb(a){a=a|0;i=a}function Nb(a,b){a=a|0;b=b|0;if(!r){r=a;s=b}}function Ob(b){b=b|0;a[k>>0]=a[b>>0];a[k+1>>0]=a[b+1>>0];a[k+2>>0]=a[b+2>>0];a[k+3>>0]=a[b+3>>0]}function Pb(b){b=b|0;a[k>>0]=a[b>>0];a[k+1>>0]=a[b+1>>0];a[k+2>>0]=a[b+2>>0];a[k+3>>0]=a[b+3>>0];a[k+4>>0]=a[b+4>>0];a[k+5>>0]=a[b+5>>0];a[k+6>>0]=a[b+6>>0];a[k+7>>0]=a[b+7>>0]}function Qb(a){a=a|0;G=a}function Rb(){return G|0}function Sb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+64|0;f=e;g=e+52|0;h=e+48|0;j=e+44|0;k=e+40|0;l=e+36|0;m=e+32|0;n=e+28|0;p=e+24|0;q=e+20|0;r=e+16|0;s=e+12|0;t=e+8|0;u=e+4|0;c[g>>2]=0;c[h>>2]=b;c[j>>2]=d;c[m>>2]=0;c[n>>2]=0;if((c[h>>2]|0)<=1){Tb(c[c[j>>2]>>2]|0);c[g>>2]=1;v=c[g>>2]|0;i=e;return v|0}he(20902);c[k>>2]=1;a:while(1){if((c[k>>2]|0)>=(c[h>>2]|0))break;if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,144)|0))break;b:do if((a[c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]>>0]|0)==45){if((PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,152)|0)!=0?(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,160)|0)!=0:0){if((PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,176)|0)!=0?(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,184)|0)!=0:0){if((PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,208)|0)!=0?(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,216)|0)!=0:0){if((PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,232)|0)!=0?(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,248)|0)!=0:0){do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,280)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,288)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,296)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,304)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,320)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,328)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,344)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,360)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,376)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,392)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,408)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,416)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,432)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,448)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,464)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,472)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,480)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,488)|0))break;if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,496)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,520)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,536)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,560)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,568)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,592)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,600)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,616)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,624)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,648)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,664)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,688)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,704)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,728)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,744)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,768)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,776)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,792)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,808)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,832)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,848)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,872)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,888)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,912)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,928)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,952)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,960)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,984)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,992)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1016)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1024)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1040)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1048)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1072)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1080)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1096)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1112)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1136)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1144)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1168)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1176)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1200)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1216)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1240)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1256)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1280)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1304)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1328)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1344)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1360)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1376)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1392)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1408)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1432)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1440)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1456)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1464)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1488)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1504)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1528)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1544)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1568)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1584)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1608)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1616)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1656)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1672)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1696)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1704)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1736)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1744)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1768)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1776)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1792)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1800)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1824)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1832)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1856)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1864)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1880)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1888)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1904)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1920)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1944)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1960)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1984)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1992)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,2016)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,2032)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,2056)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,2064)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,2072)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,2088)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,2104)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,2120)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,2144)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,2152)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,2160)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,2176)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,2200)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,2208)|0))break;if((PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,2224)|0)!=0?(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,2240)|0)!=0:0){w=206;break a}c[564]=(c[564]|0)+1;c[68]=c[68]|131072;break b}while(0);c[k>>2]=(c[k>>2]|0)+1;c[50]=(c[50]|0)+1;c[554]=c[(c[j>>2]|0)+(c[k>>2]<<2)>>2];break b}while(0);c[k>>2]=(c[k>>2]|0)+1;c[548]=c[(c[j>>2]|0)+(c[k>>2]<<2)>>2];break b}while(0);c[k>>2]=(c[k>>2]|0)+1;Zb(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0);break b}while(0);c[534]=(c[534]|0)+1;break b}while(0);c[68]=c[68]&-65537;break b}while(0);c[68]=c[68]|2048;Tk(199);break b}while(0);c[k>>2]=(c[k>>2]|0)+1;c[512]=c[(c[j>>2]|0)+(c[k>>2]<<2)>>2];c[78]=(c[78]|0)+1;break b}while(0);c[k>>2]=(c[k>>2]|0)+1;c[502]=c[(c[j>>2]|0)+(c[k>>2]<<2)>>2];c[78]=(c[78]|0)+1;break b}while(0);c[k>>2]=(c[k>>2]|0)+1;c[494]=c[(c[j>>2]|0)+(c[k>>2]<<2)>>2];c[78]=(c[78]|0)+1;c[68]=c[68]|2;break b}while(0);c[484]=(c[484]|0)+1;break b}while(0);c[474]=(c[474]|0)+1;break b}while(0);c[468]=(c[468]|0)+1;c[68]=c[68]|512;break b}while(0);c[462]=(c[462]|0)+1;c[50]=(c[50]|0)+1;break b}while(0);c[454]=(c[454]|0)+1;break b}while(0);c[k>>2]=(c[k>>2]|0)+1;if(!(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0))break b;c[440]=MT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0)|0;if((c[440]|0)!=1)break b;c[422]=(c[422]|0)+1;He(0)|0;break b}while(0);c[422]=(c[422]|0)+1;c[440]=1;He(0)|0;break b}while(0);c[k>>2]=(c[k>>2]|0)+1;d=c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0;c[f>>2]=1728;if((bT(d,1720,f)|0)==1){wl(195,196,197,198)|0;break b}else{c[432]=0;break b}}while(0);c[422]=(c[422]|0)+1;He(0)|0;c[68]=c[68]|256;break b}while(0);c[k>>2]=(c[k>>2]|0)+1;c[408]=c[(c[j>>2]|0)+(c[k>>2]<<2)>>2];vd(1640,1648)|0;break b}while(0);c[400]=(c[400]|0)+1;break b}while(0);c[390]=(c[390]|0)+1;break b}while(0);c[380]=(c[380]|0)+1;c[68]=c[68]|14;break b}while(0);c[370]=(c[370]|0)+1;c[68]=c[68]|14;break b}while(0);c[362]=(c[362]|0)+1;c[68]=c[68]|14;break b}while(0);c[356]=(c[356]|0)+1;c[33952]=1;break b}while(0);c[33956]=1;Ee(1)|0;c[68]=c[68]|128;break b}while(0);c[33956]=0;Ee(0)|0;c[68]=c[68]|64;break b}while(0);c[308]=(c[308]|0)+1;c[68]=c[68]|1024;c[68]=c[68]|262144;break b}while(0);c[308]=(c[308]|0)+1;c[68]=c[68]|1024;c[68]=c[68]|32768;break b}while(0);c[308]=(c[308]|0)+1;c[68]=c[68]|1024;break b}while(0);c[298]=(c[298]|0)+1;break b}while(0);c[290]=(c[290]|0)+1;break b}while(0);c[272]=(c[272]|0)+1;c[282]=10;break b}while(0);c[272]=(c[272]|0)+1;break b}while(0);if(c[266]|0){c[266]=(c[266]|0)*10;break b}else{c[266]=100;break b}}while(0);c[258]=(c[258]|0)+1;break b}while(0);c[252]=(c[252]|0)+1;break b}while(0);c[244]=(c[244]|0)+1;break b}while(0);c[236]=(c[236]|0)+1;break b}while(0);c[k>>2]=(c[k>>2]|0)+1;c[226]=c[(c[j>>2]|0)+(c[k>>2]<<2)>>2];c[180]=(c[180]|0)+1;c[68]=c[68]|4;break b}while(0);c[k>>2]=(c[k>>2]|0)+1;c[216]=c[(c[j>>2]|0)+(c[k>>2]<<2)>>2];c[180]=(c[180]|0)+1;c[68]=c[68]|4;break b}while(0);c[206]=(c[206]|0)+1;c[180]=(c[180]|0)+1;c[68]=c[68]|4;break b}while(0);c[196]=(c[196]|0)+1;c[68]=c[68]|16;break b}while(0);c[180]=(c[180]|0)+1;c[190]=(c[190]|0)+1;c[68]=c[68]|8;break b}while(0);c[180]=(c[180]|0)+1;c[68]=c[68]|4;break b}while(0);c[170]=(c[170]|0)+1;c[68]=c[68]|4;break b}while(0);c[160]=(c[160]|0)+1;
break b}while(0);c[152]=(c[152]|0)+1;break b}while(0);c[146]=(c[146]|0)+1;break b}while(0);c[138]=(c[138]|0)+1;break b}while(0);c[k>>2]=(c[k>>2]|0)+1;c[128]=c[(c[j>>2]|0)+(c[k>>2]<<2)>>2];break b}while(0);c[50]=(c[50]|0)+1;break b}while(0);Ub(c[c[j>>2]>>2]|0);c[n>>2]=1;break b}while(0);c[68]=c[68]|4096;break b}while(0);c[68]=c[68]|16384;break b}while(0);c[68]=c[68]|8192;break b}while(0);c[84]=(c[84]|0)+1;c[68]=c[68]|2097152;break b}while(0);c[78]=(c[78]|0)+1;c[68]=c[68]|2;break b}while(0);c[68]=c[68]|524288;break}c[66]=(c[66]|0)+1;c[68]=c[68]|1;break}c[56]=(c[56]|0)+1;break}c[48]=(c[48]|0)+1;c[50]=1;break}c[42]=(c[42]|0)+1}while(0);c[k>>2]=(c[k>>2]|0)+1}if((w|0)==206){d=c[o>>2]|0;c[f>>2]=c[(c[j>>2]|0)+(c[k>>2]<<2)>>2];Ka(d|0,2264,f|0)|0;Tb(c[c[j>>2]>>2]|0);c[g>>2]=1;v=c[g>>2]|0;i=e;return v|0}do if((c[400]|0)==0&(c[390]|0)!=0){c[q>>2]=cb(2288)|0;if(c[q>>2]|0){Cw(c[q>>2]|0);break}else{Ka(c[o>>2]|0,2312,f|0)|0;break}}while(0);if(c[468]|0)nQ(1)|0;else nQ(2)|0;if(c[484]|0){nx(200)|0;ox(201)|0}c[p>>2]=cb(2352)|0;if(c[p>>2]|0)c[33988]=c[p>>2];c[592]=Uk()|0;Tk(202);Fe(1)|0;if(c[180]|0)c[33958]=c[33958]|2;if(c[190]|0)c[33958]=c[33958]|4;if(c[78]|0)Ge(1)|0;if(c[196]|0)c[33954]=1;if(!((c[138]|0)==0|(c[146]|0)!=0)){Db[c[135904>>2]&511](c[33980]|0,2376,f);Db[c[135904>>2]&511](c[33980]|0,2440,f);p=c[33976]|0;q=c[33980]|0;c[f>>2]=c[c[j>>2]>>2];Db[p&511](q,2488,f);q=c[33976]|0;p=c[33980]|0;c[f>>2]=c[c[j>>2]>>2];Db[q&511](p,2536,f)}if((c[512]|0)!=0&(c[474]|0)==0&(c[454]|0)==0){c[33958]=c[33958]|1;c[68]=c[68]|4;if(c[252]|0)bc();c[r>>2]=iS(c[512]|0)|0;c[650]=kS(c[r>>2]|0)|0;if(!(c[650]|0)){p=c[33976]|0;q=c[33980]|0;c[f>>2]=c[512];Db[p&511](q,2608,f);c[662]=5;c[512]=0}jS(c[r>>2]|0);if(c[252]|0)cc(2656,f)}if((c[494]|0)!=0&(c[474]|0)==0&(c[454]|0)==0){c[33958]=c[33958]|1;c[68]=c[68]|4;if(c[252]|0)bc();c[s>>2]=YM(c[494]|0)|0;$M(c[s>>2]|0,203,203,c[o>>2]|0);c[670]=_M(c[s>>2]|0)|0;if(!(c[670]|0)){r=c[33976]|0;q=c[33980]|0;c[f>>2]=c[494];Db[r&511](q,2688,f);c[662]=5;c[494]=0}ZM(c[s>>2]|0);if(c[252]|0)cc(2656,f)}else if((c[502]|0)!=0&(c[454]|0)==0){if(c[252]|0)bc();c[t>>2]=XA(c[502]|0)|0;aB(c[t>>2]|0,203,203,c[o>>2]|0);c[682]=$A(c[t>>2]|0)|0;if(!(c[682]|0)){s=c[33976]|0;q=c[33980]|0;c[f>>2]=c[502];Db[s&511](q,2736,f);c[662]=5;c[502]=0}YA(c[t>>2]|0);if(c[252]|0)cc(2656,f)}if((c[548]|0)!=0&(c[462]|0)==0?(c[694]=MQ(c[548]|0,0,0,0)|0,(c[694]|0)==0):0){t=c[33976]|0;q=c[33980]|0;c[f>>2]=c[548];Db[t&511](q,2784,f);c[662]=7;c[548]=0}c[k>>2]=1;while(1){if((c[k>>2]|0)>=(c[h>>2]|0))break;c:do if((PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1608)|0)!=0?(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1616)|0)!=0:0){do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,480)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,488)|0))break;if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,496)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,832)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,848)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,2144)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,2152)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,872)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,888)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1944)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1960)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1696)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1704)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1768)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1776)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1984)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,1992)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,2016)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,2032)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,2160)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,2176)|0))break;do if(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,2200)|0){if(!(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,2208)|0))break;if((c[252]|0)!=0&(c[266]|0)!=0)bc();if((a[c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]>>0]|0)==45?(PT(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,144)|0)!=0:0)break c;do if(c[266]|0){c[u>>2]=0;c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[266]|0))break;do if(c[454]|0)dc(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0);else{if(c[474]|0){ec(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0);break}if(!(c[u>>2]|0))c[u>>2]=Be()|0;fc(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0,c[u>>2]|0)}while(0);c[l>>2]=(c[l>>2]|0)+1}if(!(c[u>>2]|0))break;Ae(c[u>>2]|0)}else{c[704]=0;do if(!(c[454]|0)){q=c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0;if(c[474]|0){ec(q);break}else{fc(q,0);break}}else dc(c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0);while(0);if(!((c[484]|0)!=0&(c[704]|0)!=0))break;q=c[o>>2]|0;c[f>>2]=c[704];Ka(q|0,2824,f|0)|0;c[662]=8}while(0);c[m>>2]=(c[m>>2]|0)+1;if(!((c[252]|0)!=0&(c[266]|0)!=0))break c;c[f>>2]=c[266];cc(2856,f);break c}while(0);c[k>>2]=(c[k>>2]|0)+1;break c}while(0);c[k>>2]=(c[k>>2]|0)+1;break c}while(0);c[k>>2]=(c[k>>2]|0)+1;break c}while(0);c[k>>2]=(c[k>>2]|0)+1;break c}while(0);c[k>>2]=(c[k>>2]|0)+1;break c}while(0);c[k>>2]=(c[k>>2]|0)+1;break c}while(0);c[k>>2]=(c[k>>2]|0)+1;break c}while(0);c[k>>2]=(c[k>>2]|0)+1;break c}while(0);c[k>>2]=(c[k>>2]|0)+1;break c}while(0);c[k>>2]=(c[k>>2]|0)+1;break c}while(0);c[k>>2]=(c[k>>2]|0)+1}else w=257;while(0);if((w|0)==257){w=0;c[k>>2]=(c[k>>2]|0)+1}c[k>>2]=(c[k>>2]|0)+1}if(c[258]|0)fc(0,0);if(!((c[138]|0)==0|(c[146]|0)!=0))Db[c[135904>>2]&511](c[33980]|0,2872,f);if((((c[m>>2]|0)!=0|(c[258]|0)!=0)^1)&(c[n>>2]|0)==0)Tb(c[c[j>>2]>>2]|0);if(c[650]|0)hS(c[650]|0);if(c[670]|0)VM(c[670]|0);if(c[682]|0)WA(c[682]|0);XM();if(c[694]|0)EQ(c[694]|0);dg();ml();c[g>>2]=c[662];v=c[g>>2]|0;i=e;return v|0}function Tb(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;e=b+4|0;c[e>>2]=a;c[d>>2]=c[e>>2];Wa(56872,d|0)|0;Wa(56912,d|0)|0;Wa(56976,d|0)|0;Wa(57040,d|0)|0;Wa(57096,d|0)|0;Wa(57136,d|0)|0;Wa(57200,d|0)|0;Wa(57264,d|0)|0;Wa(57328,d|0)|0;Wa(57384,d|0)|0;Wa(57440,d|0)|0;Wa(57504,d|0)|0;Wa(57552,d|0)|0;Wa(57608,d|0)|0;Wa(57672,d|0)|0;Wa(57736,d|0)|0;Wa(57792,d|0)|0;Wa(57832,d|0)|0;Wa(57880,d|0)|0;Wa(57952,d|0)|0;Wa(58016,d|0)|0;Wa(58088,d|0)|0;Wa(58160,d|0)|0;Wa(58192,d|0)|0;Wa(58248,d|0)|0;Wa(58304,d|0)|0;Wa(58352,d|0)|0;Wa(58384,d|0)|0;Wa(58448,d|0)|0;Wa(58496,d|0)|0;Wa(58544,d|0)|0;Wa(58616,d|0)|0;Wa(58648,d|0)|0;Wa(58712,d|0)|0;Wa(58776,d|0)|0;Wa(58824,d|0)|0;Wa(58880,d|0)|0;Wa(58928,d|0)|0;Wa(58984,d|0)|0;Wa(59040,d|0)|0;Wa(59096,d|0)|0;Wa(59144,d|0)|0;Wa(59208,d|0)|0;Wa(59280,d|0)|0;Wa(59344,d|0)|0;Wa(59408,d|0)|0;Wa(59480,d|0)|0;Wa(59536,d|0)|0;Wa(59576,d|0)|0;Wa(59640,d|0)|0;c[d>>2]=59736;Wa(59696,d|0)|0;Wa(59760,d|0)|0;Wa(59800,d|0)|0;Wa(59848,d|0)|0;Wa(59888,d|0)|0;Wa(59952,d|0)|0;Wa(60008,d|0)|0;Wa(60048,d|0)|0;Wa(60120,d|0)|0;Wa(60192,d|0)|0;Wa(60256,d|0)|0;Wa(60312,d|0)|0;Wa(60368,d|0)|0;Wa(60432,d|0)|0;Wa(60496,d|0)|0;Wa(60560,d|0)|0;Wa(60616,d|0)|0;Wa(60680,d|0)|0;Wa(60744,d|0)|0;Wa(60808,d|0)|0;Wa(60856,d|0)|0;i=b;return}function Ub(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b;e=b+8|0;c[e>>2]=a;a=c[o>>2]|0;f=c[33946]|0;c[d>>2]=c[e>>2];c[d+4>>2]=f;Ka(a|0,56440,d|0)|0;Ka(c[o>>2]|0,56472,d|0)|0;if(Me(1)|0)Ka(c[o>>2]|0,56496,d|0)|0;if(Me(2)|0)Ka(c[o>>2]|0,56512,d|0)|0;if(Me(3)|0)Ka(c[o>>2]|0,56520,d|0)|0;if(Me(4)|0)Ka(c[o>>2]|0,56528,d|0)|0;if(Me(5)|0)Ka(c[o>>2]|0,56536,d|0)|0;if(Me(6)|0)Ka(c[o>>2]|0,56544,d|0)|0;if(Me(7)|0)Ka(c[o>>2]|0,56560,d|0)|0;if(Me(8)|0)Ka(c[o>>2]|0,56568,d|0)|0;if(Me(9)|0)Ka(c[o>>2]|0,56576,d|0)|0;if(Me(10)|0)Ka(c[o>>2]|0,56584,d|0)|0;if(Me(11)|0)Ka(c[o>>2]|0,56592,d|0)|0;if(Me(12)|0)Ka(c[o>>2]|0,56608,d|0)|0;if(Me(13)|0)Ka(c[o>>2]|0,56616,d|0)|0;if(Me(14)|0)Ka(c[o>>2]|0,56624,d|0)|0;if(Me(15)|0)Ka(c[o>>2]|0,56632,d|0)|0;if(Me(16)|0)Ka(c[o>>2]|0,56648,d|0)|0;if(Me(17)|0)Ka(c[o>>2]|0,56656,d|0)|0;if(Me(18)|0)Ka(c[o>>2]|0,56672,d|0)|0;if(Me(19)|0)Ka(c[o>>2]|0,56688,d|0)|0;if(Me(20)|0)Ka(c[o>>2]|0,56696,d|0)|0;if(Me(21)|0)Ka(c[o>>2]|0,56712,d|0)|0;if(Me(22)|0)Ka(c[o>>2]|0,56728,d|0)|0;if(Me(23)|0)Ka(c[o>>2]|0,56744,d|0)|0;if(Me(24)|0)Ka(c[o>>2]|0,56760,d|0)|0;if(Me(25)|0)Ka(c[o>>2]|0,56768,d|0)|0;if(Me(26)|0)Ka(c[o>>2]|0,56784,d|0)|0;if(Me(27)|0)Ka(c[o>>2]|0,56800,d|0)|0;if(Me(28)|0)Ka(c[o>>2]|0,56816,d|0)|0;if(Me(29)|0)Ka(c[o>>2]|0,56824,d|0)|0;if(Me(30)|0)Ka(c[o>>2]|0,56840,d|0)|0;if(Me(31)|0)Ka(c[o>>2]|0,56856,d|0)|0;if(!(Me(33)|0)){g=c[o>>2]|0;Ka(g|0,3760,d|0)|0;i=b;return}Ka(c[o>>2]|0,56864,d|0)|0;g=c[o>>2]|0;Ka(g|0,3760,d|0)|0;i=b;return}function Vb(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;ql(c[d>>2]|0);i=b;return}function Wb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=nl(c[e>>2]|0)|0;if((c[f>>2]|0)!=0?(e=tl()|0,(e|0)>(c[432]|0)):0){Vc();ql(c[f>>2]|0);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}function Xb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=pl(c[f>>2]|0,c[g>>2]|0)|0;if((c[h>>2]|0)!=0?(g=tl()|0,(g|0)>(c[432]|0)):0){Vc();ql(c[h>>2]|0);c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}function Yb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=sl(c[e>>2]|0)|0;if((c[f>>2]|0)!=0?(e=tl()|0,(e|0)>(c[432]|0)):0){Vc();zb[c[135736>>2]&511](c[f>>2]|0);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}function Zb(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;e=b;f=b+8|0;g=b+4|0;c[f>>2]=a;if(!(c[f>>2]|0)){i=b;return}while(1){if(!(d[c[f>>2]>>0]|0)){h=20;break}if((c[13962]|0)>=64)break;c[g>>2]=c[f>>2];while(1){if((d[c[g>>2]>>0]|0|0)==32)j=1;else j=(d[c[g>>2]>>0]|0|0)==58;k=c[g>>2]|0;if(!j)break;c[g>>2]=k+1}c[f>>2]=k;while(1){if((d[c[g>>2]>>0]|0|0)!=0?(d[c[g>>2]>>0]|0|0)!=32:0)l=(d[c[g>>2]>>0]|0|0)!=58;else l=0;m=c[g>>2]|0;if(!l)break;c[g>>2]=m+1}if((m|0)==(c[f>>2]|0))continue;a=ly(c[f>>2]|0,(c[g>>2]|0)-(c[f>>2]|0)|0)|0;c[55888+(c[13962]<<2)>>2]=a;if(c[55888+(c[13962]<<2)>>2]|0)c[13962]=(c[13962]|0)+1;c[f>>2]=c[g>>2]}if((h|0)==20){i=b;return}Ka(c[o>>2]|0,56360,e|0)|0;i=b;return}function _b(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b+4|0;c[d>>2]=a;a=iT(4)|0;c[c[d>>2]>>2]=a;if(!(c[c[d>>2]>>2]|0)){Ka(c[o>>2]|0,56312,b|0)|0;qb(9)}else{c[c[c[d>>2]>>2]>>2]=-2123209900;c[704]=(c[704]|0)+1;i=b;return}}function $b(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[c[d>>2]>>2]|0))Ea(56200,56224,3119,56248);if((c[c[c[d>>2]>>2]>>2]|0)==-2123209900){jT(c[c[d>>2]>>2]|0);c[704]=(c[704]|0)+-1;i=b;return}else Ea(56264,56224,3120,56248)}function ac(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;i=i+64|0;g=f;h=f+48|0;j=f+44|0;k=f+40|0;l=f+36|0;m=f+32|0;n=f+28|0;p=f+24|0;q=f+20|0;r=f+16|0;s=f+12|0;t=f+8|0;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[n>>2]=0;c[p>>2]=0;c[r>>2]=c[j>>2];c[s>>2]=c[j>>2];a:do if((c[13962]|0)>0&(c[s>>2]|0)!=0)while(1){if(!(a[c[s>>2]>>0]|0))break a;if((a[c[s>>2]>>0]|0)==47)c[r>>2]=(c[s>>2]|0)+1;c[s>>2]=(c[s>>2]|0)+1}while(0);if((c[l>>2]|0)!=0?(c[c[l>>2]>>2]|0)!=0:0){c[n>>2]=c[(c[c[l>>2]>>2]|0)+84>>2];c[p>>2]=c[(c[c[l>>2]>>2]|0)+88>>2];c[(c[c[l>>2]>>2]|0)+84>>2]=0;c[(c[c[l>>2]>>2]|0)+88>>2]=0}if((c[592]|0)!=0?(c[m>>2]=vb[c[2368>>2]&511](c[j>>2]|0,c[k>>2]|0,c[l>>2]|0)|0,(c[m>>2]|0)!=0):0){if(c[n>>2]|0)c[(c[c[l>>2]>>2]|0)+84>>2]=c[n>>2];if(c[p>>2]|0)c[(c[c[l>>2]>>2]|0)+88>>2]=c[p>>2];if(c[534]|0){s=c[o>>2]|0;e=(c[k>>2]|0)!=0?c[k>>2]|0:55152;c[g>>2]=(c[j>>2]|0)!=0?c[j>>2]|0:55152;c[g+4>>2]=e;Ka(s|0,55856,g|0)|0}c[h>>2]=c[m>>2];u=c[h>>2]|0;i=f;return u|0}c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[13962]|0))break;c[t>>2]=my(c[55888+(c[q>>2]<<2)>>2]|0)|0;c[t>>2]=By(c[t>>2]|0,56152)|0;c[t>>2]=By(c[t>>2]|0,c[r>>2]|0)|0;if(c[t>>2]|0){c[m>>2]=vb[c[2368>>2]&511](c[t>>2]|0,c[k>>2]|0,c[l>>2]|0)|0;if(c[m>>2]|0){v=22;break}zb[c[135736>>2]&511](c[t>>2]|0)}c[q>>2]=(c[q>>2]|0)+1}if((v|0)==22){if(c[n>>2]|0)c[(c[c[l>>2]>>2]|0)+84>>2]=c[n>>2];if(c[p>>2]|0)c[(c[c[l>>2]>>2]|0)+88>>2]=c[p>>2];if(c[534]|0){v=c[o>>2]|0;q=(c[k>>2]|0)!=0?c[k>>2]|0:55152;c[g>>2]=c[t>>2];c[g+4>>2]=q;Ka(v|0,55856,g|0)|0}zb[c[135736>>2]&511](c[t>>2]|0);c[h>>2]=c[m>>2];u=c[h>>2]|0;i=f;return u|0}if(c[p>>2]|0)c[(c[c[l>>2]>>2]|0)+88>>2]=c[p>>2];do if(c[n>>2]|0){c[(c[c[l>>2]>>2]|0)+84>>2]=c[n>>2];if(c[j>>2]|0){p=c[n>>2]|0;m=c[l>>2]|0;c[g>>2]=c[j>>2];Db[p&511](m,56160,g);break}if(c[k>>2]|0){m=c[n>>2]|0;p=c[l>>2]|0;c[g>>2]=c[k>>2];Db[m&511](p,56160,g)}}while(0);c[h>>2]=0;u=c[h>>2]|0;i=f;return u|0}function bc(){var a=0;a=i;mb(55824,0)|0;i=a;return}function cc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+32|0;e=d;f=d+28|0;g=d+24|0;h=d+8|0;c[f>>2]=a;mb(55816,0)|0;c[g>>2]=(c[13954]|0)-(c[13956]|0);c[g>>2]=(c[g>>2]|0)*1e3;c[g>>2]=(c[g>>2]|0)+(((c[13955]|0)-(c[13957]|0)|0)/1e3|0);c[h>>2]=b;Ca(c[o>>2]|0,c[f>>2]|0,h|0)|0;h=c[o>>2]|0;c[e>>2]=c[g>>2];Ka(h|0,55832,e|0)|0;i=d;return}function dc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+112|0;d=b;e=b+100|0;f=b+96|0;g=b+92|0;h=b+88|0;j=b+12|0;k=b+8|0;l=b+4|0;c[e>>2]=a;c[h>>2]=-1;c[k>>2]=0;c[l>>2]=0;a=c[e>>2]|0;do if(c[290]|0){if(($a(a|0,j|0)|0)<0){i=b;return}m=La(c[e>>2]|0,0,d|0)|0;c[h>>2]=m;if((m|0)<0){i=b;return}c[k>>2]=ob(0,c[j+36>>2]|0,1,1,c[h>>2]|0,0)|0;if((c[k>>2]|0)!=(-1|0)){c[f>>2]=kM(c[k>>2]|0,c[j+36>>2]|0,c[e>>2]|0,0,c[68]|0)|0;break}Ra(c[h>>2]|0)|0;m=c[o>>2]|0;c[d>>2]=c[e>>2];Ka(m|0,2920,d|0)|0;c[662]=4;i=b;return}else c[f>>2]=lM(a,0,c[68]|0)|0;while(0);if((c[548]|0)!=0?(c[694]=MQ(c[548]|0,0,0,0)|0,(c[694]|0)==0):0){a=c[33976]|0;m=c[33980]|0;c[d>>2]=c[548];Db[a&511](m,2784,d);c[662]=7;c[548]=0}if(((c[694]|0)!=0?(c[898]=OQ(c[694]|0)|0,(c[898]|0)!=0):0)?(c[g>>2]=HQ(c[898]|0,0,0)|0,(c[g>>2]|0)<0):0){Ka(c[o>>2]|0,3600,d|0)|0;GQ(c[898]|0);c[898]=0}if(c[f>>2]|0){if(!(c[196]|0)){if(c[180]|0)dM(c[f>>2]|0,1,1)|0}else dM(c[f>>2]|0,3,1)|0;if(c[494]|0){if(!((c[252]|0)==0|(c[266]|0)!=0))bc();c[g>>2]=gM(c[f>>2]|0,c[494]|0)|0;if((c[g>>2]|0)<0){m=c[33976]|0;a=c[33980]|0;c[d>>2]=c[494];Db[m&511](a,2688,d);c[662]=5;c[494]=0}if(!((c[252]|0)==0|(c[266]|0)!=0))cc(2656,d)}if(c[502]|0){if(!((c[252]|0)==0|(c[266]|0)!=0))bc();c[g>>2]=fM(c[f>>2]|0,c[502]|0)|0;if((c[g>>2]|0)<0){a=c[33976]|0;m=c[33980]|0;c[d>>2]=c[502];Db[a&511](m,55704,d);c[662]=5;c[502]=0}if(!((c[252]|0)==0|(c[266]|0)!=0))cc(2656,d)}if(!((c[252]|0)==0|(c[266]|0)!=0))bc();c[g>>2]=QL(c[f>>2]|0)|0;while(1){if((c[g>>2]|0)!=1)break;if((c[42]|0)!=0|(c[694]|0)!=0)pc(c[f>>2]|0);c[g>>2]=QL(c[f>>2]|0)|0}do if(!((c[252]|0)==0|(c[266]|0)!=0)){if(c[494]|0){cc(55744,d);break}if(c[196]|0){cc(55744,d);break}else{cc(2952,d);break}}while(0);if((c[196]|0)!=0?(hM(c[f>>2]|0)|0)!=1:0){m=c[33976]|0;a=c[33980]|0;c[d>>2]=c[e>>2];Db[m&511](a,3448,d);c[662]=3}do if((c[494]|0)!=0|(c[502]|0)!=0){a=(hM(c[f>>2]|0)|0)!=1;m=c[o>>2]|0;n=c[e>>2]|0;if(a){c[d>>2]=n;Ka(m|0,3512,d|0)|0;c[662]=3;break}else{c[d>>2]=n;Ka(m|0,3496,d|0)|0;break}}while(0);VL(c[f>>2]|0);if(c[g>>2]|0){g=c[o>>2]|0;c[d>>2]=c[e>>2];Ka(g|0,55768,d|0)|0;c[662]=1}}else{g=c[o>>2]|0;c[d>>2]=c[e>>2];Ka(g|0,55792,d|0)|0;c[662]=1}if(c[898]|0){GQ(c[898]|0);c[898]=0}if(!(c[290]|0)){i=b;return}yk(c[l>>2]|0);Ta(c[k>>2]|0,c[j+36>>2]|0)|0;Ra(c[h>>2]|0)|0;i=b;return}function ec(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,p=0;b=i;i=i+48|0;d=b;e=b+36|0;f=b+32|0;g=b+28|0;h=b+24|0;j=b+20|0;k=b+16|0;l=b+12|0;m=b+8|0;n=b+4|0;c[e>>2]=a;c[g>>2]=54320;c[h>>2]=0;c[k>>2]=0;c[l>>2]=0;c[13584]=0;do if(!(c[50]|0))if(c[468]|0){c[f>>2]=c[34];break}else{c[f>>2]=c[13588];break}else c[f>>2]=c[13586];while(0);c[h>>2]=Ck(c[e>>2]|0,0)|0;do if(c[h>>2]|0){if(!(c[682]|0)){c[k>>2]=Be()|0;if(!(c[k>>2]|0)){yk(c[h>>2]|0);break}c[l>>2]=c[c[k>>2]>>2];c[c[k>>2]>>2]=c[f>>2];c[(c[k>>2]|0)+4>>2]=c[g>>2];c[j>>2]=ve(c[k>>2]|0,c[h>>2]|0,0)|0;if(!(c[j>>2]|0)){yk(c[h>>2]|0);break}Oe(c[k>>2]|0,c[j>>2]|0)|0;Qf(c[k>>2]|0)|0;if(!(c[(c[k>>2]|0)+8>>2]|0))break;Ka(c[o>>2]|0,54360,d|0)|0;Th(c[(c[k>>2]|0)+8>>2]|0);c[(c[k>>2]|0)+8>>2]=0;break}c[n>>2]=eB(c[682]|0)|0;bB(c[n>>2]|0,203,203,c[o>>2]|0);fB(c[n>>2]|0,c[e>>2]|0);c[m>>2]=lB(c[n>>2]|0,c[h>>2]|0,0,c[f>>2]|0,c[g>>2]|0)|0;do if(!(c[266]|0)){if(!(c[m>>2]|0)){a=c[o>>2]|0;c[d>>2]=c[e>>2];Ka(a|0,3496,d|0)|0;break}a=c[o>>2]|0;p=c[e>>2]|0;if((c[m>>2]|0)>0){c[d>>2]=p;Ka(a|0,3512,d|0)|0;c[662]=3;break}else{c[d>>2]=p;Ka(a|0,3536,d|0)|0;c[662]=3;break}}while(0);ZA(c[n>>2]|0)}while(0);if(!(c[k>>2]|0)){i=b;return}c[c[k>>2]>>2]=c[l>>2];Ae(c[k>>2]|0);i=b;return}function fc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;e=i;i=i+6512|0;f=e;g=e+1376|0;h=e+1372|0;j=e+1368|0;k=e+1364|0;l=e+1360|0;m=e+1356|0;n=e+1352|0;r=e+2408|0;s=e+1348|0;t=e+1344|0;u=e+1268|0;v=e+1264|0;w=e+1260|0;x=e+1256|0;y=e+1252|0;z=e+1248|0;A=e+1384|0;B=e+1244|0;C=e+1240|0;D=e+1236|0;E=e+1232|0;F=e+1156|0;G=e+1152|0;H=e+1148|0;I=e+1144|0;J=e+120|0;K=e+112|0;L=e+108|0;M=e+104|0;N=e+100|0;O=e+96|0;P=e+92|0;Q=e+88|0;R=e+84|0;S=e+80|0;T=e+76|0;U=e+72|0;V=e+68|0;W=e+64|0;X=e+60|0;Y=e+56|0;Z=e+52|0;_=e+48|0;$=e+44|0;aa=e+40|0;ba=e+36|0;ca=e+32|0;da=e+28|0;ea=e+24|0;fa=e+20|0;ga=e+16|0;ha=e+12|0;ia=e+8|0;c[g>>2]=b;c[h>>2]=d;c[j>>2]=0;if(!((c[252]|0)==0|(c[266]|0)!=0))bc();do if(!(c[g>>2]|0)){if(c[258]|0){c[j>>2]=Sh(2888)|0;c[l>>2]=ji(c[j>>2]|0,0,2896,0)|0;vi(c[l>>2]|0,2904);Qi(c[j>>2]|0,c[l>>2]|0)|0}}else{if((c[152]|0)!=0&(c[272]|0)!=0){c[m>>2]=pb(c[g>>2]|0,2912)|0;if(!(c[m>>2]|0))break;c[n>>2]=Aa(r|0,1,4,c[m>>2]|0)|0;if((c[n>>2]|0)>0){c[s>>2]=po(0,0,r,c[n>>2]|0,c[g>>2]|0,0)|0;fg(c[s>>2]|0,c[68]|0)|0;while(1){d=Aa(r|0,1,c[282]|0,c[m>>2]|0)|0;c[n>>2]=d;ja=c[s>>2]|0;if((d|0)<=0)break;oo(ja,r,c[n>>2]|0,0)|0}oo(ja,r,0,1)|0;c[j>>2]=c[(c[s>>2]|0)+8>>2];lo(c[s>>2]|0)}Xa(c[m>>2]|0)|0;break}if((c[152]|0)!=0&(c[290]|0)!=0){if(($a(c[g>>2]|0,u|0)|0)<0){i=e;return}d=La(c[g>>2]|0,0,f|0)|0;c[t>>2]=d;if((d|0)<0){i=e;return}c[v>>2]=ob(0,c[u+36>>2]|0,1,1,c[t>>2]|0,0)|0;if((c[v>>2]|0)!=(-1|0)){c[j>>2]=vo(c[v>>2]|0,c[u+36>>2]|0,c[g>>2]|0,0,c[68]|0)|0;Ta(c[v>>2]|0,c[u+36>>2]|0)|0;Ra(c[t>>2]|0)|0;break}Ra(c[t>>2]|0)|0;d=c[o>>2]|0;c[f>>2]=c[g>>2];Ka(d|0,2920,f|0)|0;c[662]=4;i=e;return}if(c[152]|0){c[j>>2]=uo(c[g>>2]|0,0,c[68]|0)|0;break}if(c[272]|0){if((a[c[g>>2]>>0]|0)==45?(a[(c[g>>2]|0)+1>>0]|0)==0:0)c[w>>2]=c[p>>2];else c[w>>2]=pb(c[g>>2]|0,2912)|0;if(!(c[w>>2]|0))break;c[z>>2]=1024;c[y>>2]=Aa(A|0,1,4,c[w>>2]|0)|0;if((c[y>>2]|0)>0){c[B>>2]=Tf(0,0,A,c[y>>2]|0,c[g>>2]|0)|0;fg(c[B>>2]|0,c[68]|0)|0;while(1){d=Aa(A|0,1,c[z>>2]|0,c[w>>2]|0)|0;c[y>>2]=d;ka=c[B>>2]|0;if((d|0)<=0)break;Sf(ka,A,c[y>>2]|0,0)|0}Sf(ka,A,0,1)|0;c[j>>2]=c[(c[B>>2]|0)+8>>2];c[x>>2]=c[(c[B>>2]|0)+12>>2];Ae(c[B>>2]|0);if(!(c[x>>2]|0)){Th(c[j>>2]|0);c[j>>2]=0}}if((c[w>>2]|0)==(c[p>>2]|0))break;Xa(c[w>>2]|0)|0;break}if(c[298]|0){if((a[c[g>>2]>>0]|0)==45?(a[(c[g>>2]|0)+1>>0]|0)==0:0){c[j>>2]=ig(0,0,0,c[68]|0)|0;break}c[C>>2]=pb(c[g>>2]|0,2912)|0;if(!(c[C>>2]|0)){c[j>>2]=0;break}if(!(c[h>>2]|0)){c[j>>2]=jg(204,205,c[C>>2]|0,c[g>>2]|0,0,c[68]|0)|0;break}else{c[j>>2]=mg(c[h>>2]|0,204,205,c[C>>2]|0,c[g>>2]|0,0,c[68]|0)|0;break}}if(c[138]|0){if(!(c[h>>2]|0))c[D>>2]=Be()|0;else c[D>>2]=c[h>>2];if(!(c[D>>2]|0)){c[j>>2]=0;break}c[(c[c[D>>2]>>2]|0)+88>>2]=206;c[(c[c[D>>2]>>2]|0)+84>>2]=207;c[(c[D>>2]|0)+112>>2]=208;c[(c[D>>2]|0)+116>>2]=209;c[j>>2]=kg(c[D>>2]|0,c[g>>2]|0,0,c[68]|0)|0;if(c[h>>2]|0)break;Ae(c[D>>2]|0);break}if(c[290]|0){if(($a(c[g>>2]|0,F|0)|0)<0){i=e;return}d=La(c[g>>2]|0,0,f|0)|0;c[E>>2]=d;if((d|0)<0){i=e;return}c[G>>2]=ob(0,c[F+36>>2]|0,1,1,c[E>>2]|0,0)|0;if((c[G>>2]|0)==(-1|0)){Ra(c[E>>2]|0)|0;d=c[o>>2]|0;c[f>>2]=c[g>>2];Ka(d|0,2920,f|0)|0;c[662]=4;i=e;return}if(!(c[h>>2]|0))c[j>>2]=hg(c[G>>2]|0,c[F+36>>2]|0,c[g>>2]|0,0,c[68]|0)|0;else c[j>>2]=lg(c[h>>2]|0,c[G>>2]|0,c[F+36>>2]|0,c[g>>2]|0,0,c[68]|0)|0;Ta(c[G>>2]|0,c[F+36>>2]|0)|0;Ra(c[E>>2]|0)|0;break}if(!(c[196]|0)){if(c[h>>2]|0){c[j>>2]=kg(c[h>>2]|0,c[g>>2]|0,0,c[68]|0)|0;break}d=c[g>>2]|0;if(c[468]|0){c[j>>2]=cg(d)|0;break}else{c[j>>2]=gg(d,0,c[68]|0)|0;break}}c[H>>2]=0;if(!(c[h>>2]|0))c[H>>2]=Be()|0;else c[H>>2]=c[h>>2];if(!(c[H>>2]|0)){c[j>>2]=0;break}c[j>>2]=kg(c[H>>2]|0,c[g>>2]|0,0,c[68]|0)|0;if(!(c[(c[H>>2]|0)+100>>2]|0))c[662]=4;if(!(c[h>>2]|0))Ae(c[H>>2]|0)}while(0);if(!(c[j>>2]|0)){c[662]=1;i=e;return}if(!((c[252]|0)==0|(c[266]|0)!=0))cc(2952,f);if((c[236]|0)!=0?(c[I>>2]=Nh(c[j>>2]|0)|0,(c[I>>2]|0)!=0):0){Qh(c[I>>2]|0);Ph(c[I>>2]|0)}if(c[308]|0){if(!((c[252]|0)==0|(c[266]|0)!=0))bc();if((Vv(c[j>>2]|0,c[68]|0)|0)<0)c[662]=1;if(!((c[252]|0)==0|(c[266]|0)!=0))cc(2960,f)}if(c[554]|0)mc(c[j>>2]|0,c[554]|0);if(c[48]|0){Xq(c[j>>2]|0)|0;Zp(c[j>>2]|0,c[g>>2]|0,210,c[q>>2]|0)}if(c[56]|0){c[k>>2]=c[j>>2];if(c[252]|0)bc();c[j>>2]=Mi(c[j>>2]|0,1)|0;if(c[252]|0)cc(2984,f);if(c[252]|0)bc();Th(c[k>>2]|0);if(c[252]|0)cc(2992,f)}a:do if((c[244]|0)==0|(c[152]|0)!=0){if(c[462]|0)oc(c[j>>2]|0)}else if(c[(c[j>>2]|0)+12>>2]|0){c[M>>2]=c[(c[j>>2]|0)+12>>2];while(1){if(c[M>>2]|0)la=(c[(c[M>>2]|0)+16>>2]|0)==0;else la=0;ma=c[M>>2]|0;if(!la)break;c[M>>2]=c[ma+24>>2]}if(ma){c[K>>2]=hn(c[(c[M>>2]|0)+16>>2]|0,0,J,256)|0;if((c[K>>2]|0)<0){Ka(c[o>>2]|0,3016,f|0)|0;break}k=c[o>>2]|0;if(!(c[K>>2]|0)){Ka(k|0,3056,f|0)|0;break}c[f>>2]=c[K>>2];Ka(k|0,3096,f|0)|0;c[L>>2]=0;while(1){if((c[L>>2]|0)>=(c[K>>2]|0))break a;k=c[o>>2]|0;c[f>>2]=c[J+(c[L>>2]<<2)>>2];Ka(k|0,3144,f|0)|0;c[L>>2]=(c[L>>2]|0)+1}}}while(0);do if(!(c[50]|0)){if(c[42]|0){if(!(c[128]|0))c[_>>2]=c[q>>2];else c[_>>2]=pb(c[128]|0,3160)|0;if(!(c[_>>2]|0)){L=c[o>>2]|0;c[f>>2]=c[128];Ka(L|0,3168,f|0)|0;c[662]=6;break}Mp(c[_>>2]|0,c[j>>2]|0);if(!(c[128]|0))break;Xa(c[_>>2]|0)|0;break}if(!((c[252]|0)==0|(c[266]|0)!=0))bc();do if(!((c[152]|0)==0|(c[160]|0)!=0)){do if(c[788]|0)Ap((c[128]|0)!=0?c[128]|0:144,c[j>>2]|0)|0;else{L=(c[440]|0)==1;J=c[128]|0;if(c[408]|0){K=(J|0)!=0?c[128]|0:144;M=c[j>>2]|0;ma=c[408]|0;if(L){Bp(K,M,ma,1)|0;break}else{Bp(K,M,ma,0)|0;break}}if(L){Bp((J|0)!=0?c[128]|0:144,c[j>>2]|0,0,1)|0;break}if(!J)c[O>>2]=c[q>>2];else c[O>>2]=pb(c[128]|0,3160)|0;if(!(c[O>>2]|0)){J=c[o>>2]|0;c[f>>2]=c[128];Ka(J|0,3168,f|0)|0;c[662]=6;break}if((zp(c[O>>2]|0,c[j>>2]|0)|0)<0)c[662]=6;if(!(c[128]|0))break;Xa(c[O>>2]|0)|0}while(0);if(!((c[252]|0)==0|(c[266]|0)!=0))cc(3192,f)}else{if(c[362]|0){c[P>>2]=0;c[Q>>2]=Dx(c[j>>2]|0,0,0,0,1,P)|0;if((c[Q>>2]|0)<0){Ka(c[o>>2]|0,3224,f|0)|0;c[662]=6;break}if((Ya(1,c[P>>2]|0,c[Q>>2]|0)|0)==-1)Ka(c[o>>2]|0,3200,f|0)|0;zb[c[135736>>2]&511](c[P>>2]|0);break}if(c[370]|0){c[R>>2]=0;c[S>>2]=Dx(c[j>>2]|0,0,2,0,1,R)|0;if((c[S>>2]|0)<0){Ka(c[o>>2]|0,3224,f|0)|0;c[662]=6;break}if((Ya(1,c[R>>2]|0,c[S>>2]|0)|0)==-1)Ka(c[o>>2]|0,3200,f|0)|0;zb[c[135736>>2]&511](c[R>>2]|0);break}if(c[380]|0){c[T>>2]=0;c[U>>2]=Dx(c[j>>2]|0,0,1,0,1,T)|0;if((c[U>>2]|0)<0){Ka(c[o>>2]|0,3224,f|0)|0;c[662]=6;break}if((Ya(1,c[T>>2]|0,c[U>>2]|0)|0)==-1)Ka(c[o>>2]|0,3200,f|0)|0;zb[c[135736>>2]&511](c[T>>2]|0);break}if(c[290]|0){J=(c[440]|0)==1;L=c[j>>2]|0;do if(c[408]|0){ma=c[408]|0;if(J){AR(L,V,W,ma,1);break}else{DR(L,V,W,ma);break}}else if(J){CR(L,V,W,1);break}else{BR(L,V,W);break}while(0);if(!(c[V>>2]|0)){Ka(c[o>>2]|0,3248,f|0)|0;c[662]=6;break}if((Ya(1,c[V>>2]|0,c[W>>2]|0)|0)==-1)Ka(c[o>>2]|0,3200,f|0)|0;zb[c[135736>>2]&511](c[V>>2]|0);break}if(c[788]|0){JR((c[128]|0)!=0?c[128]|0:144,c[j>>2]|0)|0;break}if(!(c[816]|0)){c[Z>>2]=0;do if((c[440]|0)==1)c[Z>>2]=c[Z>>2]|1;else{if((c[440]|0)!=2)break;c[Z>>2]=c[Z>>2]|128}while(0);if(c[160]|0)c[Z>>2]=c[Z>>2]|32;if(!(c[128]|0))c[Y>>2]=rR(1,c[408]|0,c[Z>>2]|0)|0;else c[Y>>2]=sR(c[128]|0,c[408]|0,c[Z>>2]|0)|0;if(!(c[Y>>2]|0)){c[662]=6;break}if((tR(c[Y>>2]|0,c[j>>2]|0)|0)<0){L=c[o>>2]|0;c[f>>2]=(c[128]|0)!=0?c[128]|0:144;Ka(L|0,3272,f|0)|0;c[662]=6}wR(c[Y>>2]|0)|0;break}L=(c[440]|0)==1;J=c[128]|0;if(c[408]|0){ma=(J|0)!=0?c[128]|0:144;M=c[j>>2]|0;K=c[408]|0;if(L)c[N>>2]=GR(ma,M,K,1)|0;else c[N>>2]=HR(ma,M,K)|0;if((c[N>>2]|0)>=0)break;K=c[o>>2]|0;c[f>>2]=(c[128]|0)!=0?c[128]|0:144;Ka(K|0,3272,f|0)|0;c[662]=6;break}if(L){c[N>>2]=IR((J|0)!=0?c[128]|0:144,c[j>>2]|0,1)|0;if((c[N>>2]|0)>=0)break;L=c[o>>2]|0;c[f>>2]=(c[128]|0)!=0?c[128]|0:144;Ka(L|0,3272,f|0)|0;c[662]=6;break}if(!J)c[X>>2]=c[q>>2];else c[X>>2]=pb(c[128]|0,3160)|0;if(!(c[X>>2]|0)){J=c[o>>2]|0;c[f>>2]=c[128];Ka(J|0,3168,f|0)|0;c[662]=6;break}if((FR(c[X>>2]|0,c[j>>2]|0)|0)<0)c[662]=6;if(!(c[128]|0))break;Xa(c[X>>2]|0)|0}while(0);if(!((c[252]|0)==0|(c[266]|0)!=0))cc(3192,f)}while(0);do if(!((c[216]|0)!=0|(c[226]|0)!=0)){if(c[206]|0){X=gm()|0;c[ba>>2]=X;if(!X){Db[c[135904>>2]&511](c[33980]|0,3336,f);qb(-1)}if(!((c[252]|0)==0|(c[266]|0)!=0))bc();c[c[ba>>2]>>2]=c[o>>2];c[(c[ba>>2]|0)+4>>2]=203;c[(c[ba>>2]|0)+8>>2]=203;if(!(fn(c[ba>>2]|0,c[j>>2]|0)|0)){X=c[33976]|0;N=c[33980]|0;c[f>>2]=c[g>>2];Db[X&511](N,3448,f);c[662]=3}if(!((c[252]|0)==0|(c[266]|0)!=0))cc(3480,f);hm(c[ba>>2]|0)}}else{if(!((c[252]|0)==0|(c[266]|0)!=0))bc();if(c[216]|0)c[$>>2]=Wf(0,c[216]|0)|0;else c[$>>2]=Wf(c[226]|0,0)|0;if(!((c[252]|0)==0|(c[266]|0)!=0))cc(3296,f);if(!(c[$>>2]|0)){N=c[33976]|0;X=c[33980]|0;if(c[216]|0){c[f>>2]=c[216];Db[N&511](X,3312,f)}else{c[f>>2]=c[226];Db[N&511](X,3312,f)}c[662]=2;break}X=gm()|0;c[aa>>2]=X;if(!X){Db[c[135904>>2]&511](c[33980]|0,3336,f);qb(-1)}c[c[aa>>2]>>2]=c[o>>2];c[(c[aa>>2]|0)+4>>2]=203;c[(c[aa>>2]|0)+8>>2]=203;if(!((c[252]|0)==0|(c[266]|0)!=0))bc();if(!(dn(c[aa>>2]|0,c[j>>2]|0,c[$>>2]|0)|0)){X=c[33976]|0;N=c[33980]|0;Y=c[g>>2]|0;if(c[216]|0){Z=c[216]|0;c[f>>2]=Y;c[f+4>>2]=Z;Db[X&511](N,3376,f)}else{Z=c[226]|0;c[f>>2]=Y;c[f+4>>2]=Z;Db[X&511](N,3376,f)}c[662]=3}if(!((c[252]|0)==0|(c[266]|0)!=0))cc(3424,f);hm(c[aa>>2]|0);Ph(c[$>>2]|0)}while(0);if(c[650]|0){if(!((c[252]|0)==0|(c[266]|0)!=0))bc();if(c[42]|0)c[ea>>2]=4;else c[ea>>2]=2;if(c[50]|0)c[ea>>2]=c[ea>>2]|1;c[ca>>2]=lS(c[650]|0,c[ea>>2]|0)|0;c[da>>2]=nS(c[ca>>2]|0,c[j>>2]|0)|0;do if(c[da>>2]|0){ea=c[o>>2]|0;$=c[g>>2]|0;if((c[da>>2]|0)>0){c[f>>2]=$;Ka(ea|0,3512,f|0)|0;c[662]=3;break}else{c[f>>2]=$;Ka(ea|0,3536,f|0)|0;c[662]=3;break}}else{ea=c[o>>2]|0;c[f>>2]=c[g>>2];Ka(ea|0,3496,f|0)|0}while(0);mS(c[ca>>2]|0);if(!((c[252]|0)==0|(c[266]|0)!=0))cc(3480,f)}if(c[670]|0){if(!((c[252]|0)==0|(c[266]|0)!=0))bc();c[fa>>2]=eN(c[670]|0)|0;gN(c[fa>>2]|0,203,203,c[o>>2]|0);c[ga>>2]=iN(c[fa>>2]|0,c[j>>2]|0)|0;do if(c[ga>>2]|0){ca=c[o>>2]|0;da=c[g>>2]|0;if((c[ga>>2]|0)>0){c[f>>2]=da;Ka(ca|0,3512,f|0)|0;c[662]=3;break}else{c[f>>2]=da;Ka(ca|0,3536,f|0)|0;c[662]=3;break}}else{ca=c[o>>2]|0;c[f>>2]=c[g>>2];Ka(ca|0,3496,f|0)|0}while(0);fN(c[fa>>2]|0);if(!((c[252]|0)==0|(c[266]|0)!=0))cc(3480,f)}else if(c[682]|0){if(!((c[252]|0)==0|(c[266]|0)!=0))bc();c[ha>>2]=eB(c[682]|0)|0;bB(c[ha>>2]|0,203,203,c[o>>2]|0);c[ia>>2]=hB(c[ha>>2]|0,c[j>>2]|0)|0;do if(c[ia>>2]|0){fa=c[o>>2]|0;ga=c[g>>2]|0;if((c[ia>>2]|0)>0){c[f>>2]=ga;Ka(fa|0,3512,f|0)|0;c[662]=3;break}else{c[f>>2]=ga;Ka(fa|0,3536,f|0)|0;c[662]=3;break}}else{fa=c[o>>2]|0;c[f>>2]=c[g>>2];Ka(fa|0,3496,f|0)|0}while(0);ZA(c[ha>>2]|0);if(!((c[252]|0)==0|(c[266]|0)!=0))cc(3480,f)}if(!((c[356]|0)==0|(c[152]|0)!=0))Jp(c[o>>2]|0,c[j>>2]|0);if(!((c[252]|0)==0|(c[266]|0)!=0))bc();Th(c[j>>2]|0);if((c[252]|0)==0|(c[266]|0)!=0){i=e;return}cc(3584,f);i=e;return}function gc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=Aa(c[g>>2]|0,1,c[h>>2]|0,c[f>>2]|0)|0;i=e;return d|0}function hc(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)==(c[p>>2]|0)){i=b;return}Xa(c[d>>2]|0)|0;i=b;return}function ic(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+48|0;g=f;h=f+36|0;j=f+32|0;k=f+28|0;l=f+24|0;m=f+8|0;n=f+4|0;c[h>>2]=b;c[j>>2]=d;c[k>>2]=c[h>>2];a[4136]=0;c[l>>2]=c[(c[k>>2]|0)+36>>2];if(((c[l>>2]|0)!=0?(c[(c[l>>2]|0)+4>>2]|0)==0:0)?(c[(c[k>>2]|0)+40>>2]|0)>1:0)c[l>>2]=c[(c[(c[k>>2]|0)+48>>2]|0)+((c[(c[k>>2]|0)+40>>2]|0)-2<<2)>>2];rc(c[l>>2]|0);Db[c[135904>>2]&511](c[33980]|0,54304,g);c[m>>2]=e;c[n>>2]=ZT(4136)|0;LT(4136+(c[n>>2]|0)|0,5e4-(c[n>>2]|0)|0,c[j>>2]|0,m)|0;sc();Db[c[135904>>2]&511](c[33980]|0,54168,g);tc(c[l>>2]|0);sc();i=f;return}function jc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+48|0;g=f;h=f+36|0;j=f+32|0;k=f+28|0;l=f+24|0;m=f+8|0;n=f+4|0;c[h>>2]=b;c[j>>2]=d;c[k>>2]=c[h>>2];a[4136]=0;c[l>>2]=c[(c[k>>2]|0)+36>>2];if(((c[l>>2]|0)!=0?(c[(c[l>>2]|0)+4>>2]|0)==0:0)?(c[(c[k>>2]|0)+40>>2]|0)>1:0)c[l>>2]=c[(c[(c[k>>2]|0)+48>>2]|0)+((c[(c[k>>2]|0)+40>>2]|0)-2<<2)>>2];rc(c[l>>2]|0);Db[c[135904>>2]&511](c[33980]|0,54280,g);c[m>>2]=e;c[n>>2]=ZT(4136)|0;LT(4136+(c[n>>2]|0)|0,5e4-(c[n>>2]|0)|0,c[j>>2]|0,m)|0;sc();Db[c[135904>>2]&511](c[33980]|0,54168,g);tc(c[l>>2]|0);sc();i=f;return}function kc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+48|0;g=f;h=f+36|0;j=f+32|0;k=f+28|0;l=f+24|0;m=f+8|0;n=f+4|0;c[h>>2]=b;c[j>>2]=d;c[k>>2]=c[h>>2];a[4136]=0;c[l>>2]=c[(c[k>>2]|0)+36>>2];if((c[(c[l>>2]|0)+4>>2]|0)==0?(c[(c[k>>2]|0)+40>>2]|0)>1:0)c[l>>2]=c[(c[(c[k>>2]|0)+48>>2]|0)+((c[(c[k>>2]|0)+40>>2]|0)-2<<2)>>2];rc(c[l>>2]|0);Db[c[135904>>2]&511](c[33980]|0,54256,g);c[n>>2]=ZT(4136)|0;c[m>>2]=e;LT(4136+(c[n>>2]|0)|0,5e4-(c[n>>2]|0)|0,c[j>>2]|0,m)|0;sc();Db[c[135904>>2]&511](c[33980]|0,54168,g);tc(c[l>>2]|0);sc();c[662]=3;i=f;return}function lc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+48|0;g=f;h=f+36|0;j=f+32|0;k=f+28|0;l=f+24|0;m=f+8|0;n=f+4|0;c[h>>2]=b;c[j>>2]=d;c[k>>2]=c[h>>2];a[4136]=0;c[l>>2]=c[(c[k>>2]|0)+36>>2];if((c[(c[l>>2]|0)+4>>2]|0)==0?(c[(c[k>>2]|0)+40>>2]|0)>1:0)c[l>>2]=c[(c[(c[k>>2]|0)+48>>2]|0)+((c[(c[k>>2]|0)+40>>2]|0)-2<<2)>>2];rc(c[l>>2]|0);Db[c[135904>>2]&511](c[33980]|0,54136,g);c[m>>2]=e;c[n>>2]=ZT(4136)|0;LT(4136+(c[n>>2]|0)|0,5e4-(c[n>>2]|0)|0,c[j>>2]|0,m)|0;sc();Db[c[135904>>2]&511](c[33980]|0,54168,g);tc(c[l>>2]|0);sc();i=f;return}function mc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;c[f>>2]=a;c[g>>2]=b;c[h>>2]=Lr(c[f>>2]|0)|0;if(!(c[h>>2]|0)){Ka(c[o>>2]|0,3912,e|0)|0;c[662]=9;i=d;return}c[(c[h>>2]|0)+4>>2]=c[f>>2];c[j>>2]=Rs(c[g>>2]|0,c[h>>2]|0)|0;Nr(c[h>>2]|0);if(!(c[j>>2]|0)){Ka(c[o>>2]|0,3944,e|0)|0;c[662]=10;i=d;return}else{qc(c[j>>2]|0);Qq(c[j>>2]|0);i=d;return}}function nc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+528|0;e=d;f=d+16|0;g=d+12|0;h=d+20|0;j=d+8|0;k=d+4|0;c[g>>2]=b;if(c[g>>2]|0){b=c[q>>2]|0;c[e>>2]=c[g>>2];Ka(b|0,3904,e|0)|0}if(!(nb(h|0,500,c[p>>2]|0)|0)){c[f>>2]=0;l=c[f>>2]|0;i=d;return l|0}a[h+500>>0]=0;c[k>>2]=ZT(h|0)|0;c[j>>2]=iT((c[k>>2]|0)+1|0)|0;if(c[j>>2]|0)eU(c[j>>2]|0,h|0,(c[k>>2]|0)+1|0)|0;c[f>>2]=c[j>>2];l=c[f>>2]|0;i=d;return l|0}function oc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+128|0;d=b;e=b+116|0;f=b+112|0;g=b+108|0;h=b+104|0;j=b+16|0;k=b+8|0;l=b+4|0;c[e>>2]=a;c[h>>2]=Pi(c[e>>2]|0)|0;c[l>>2]=c[(c[h>>2]|0)+48>>2];c[k>>2]=0;while(1){if(!((c[l>>2]|0)!=0&(c[k>>2]|0)<20))break;h=c[(c[l>>2]|0)+8>>2]|0;a=c[k>>2]|0;c[k>>2]=a+1;c[j+(a<<2)>>2]=h;h=c[(c[l>>2]|0)+12>>2]|0;a=c[k>>2]|0;c[k>>2]=a+1;c[j+(a<<2)>>2]=h;c[l>>2]=c[c[l>>2]>>2]}l=c[k>>2]|0;c[k>>2]=l+1;c[j+(l<<2)>>2]=0;c[j+(c[k>>2]<<2)>>2]=0;if((c[548]|0)!=0?(c[694]=MQ(c[548]|0,c[(c[e>>2]|0)+80>>2]|0,0,j)|0,(c[694]|0)==0):0){j=c[33976]|0;k=c[33980]|0;c[d>>2]=c[548];Db[j&511](k,2784,d);c[662]=7;c[548]=0}if(((c[694]|0)!=0?(c[898]=OQ(c[694]|0)|0,(c[898]|0)!=0):0)?(c[g>>2]=HQ(c[898]|0,0,0)|0,(c[g>>2]|0)<0):0){Ka(c[o>>2]|0,3600,d|0)|0;GQ(c[898]|0);c[898]=0}c[f>>2]=jM(c[e>>2]|0)|0;if(c[f>>2]|0){if(!((c[252]|0)==0|(c[266]|0)!=0))bc();c[g>>2]=QL(c[f>>2]|0)|0;while(1){if((c[g>>2]|0)!=1)break;if((c[42]|0)!=0|(c[694]|0)!=0)pc(c[f>>2]|0);c[g>>2]=QL(c[f>>2]|0)|0}if(!((c[252]|0)==0|(c[266]|0)!=0))cc(3632,d);VL(c[f>>2]|0);if(c[g>>2]|0){Ka(c[o>>2]|0,3656,d|0)|0;c[662]=1}}else{Ka(c[o>>2]|0,3688,d|0)|0;c[662]=1}if(!(c[898]|0)){i=b;return}GQ(c[898]|0);c[898]=0;i=b;return}function pc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0;b=i;i=i+64|0;d=b;e=b+48|0;f=b+44|0;g=b+40|0;h=b+36|0;j=b+32|0;k=b+28|0;l=b+24|0;m=b+20|0;c[e>>2]=a;c[h>>2]=XL(c[e>>2]|0)|0;c[j>>2]=YL(c[e>>2]|0)|0;do if(c[42]|0){a=_L(c[e>>2]|0)|0;c[f>>2]=a;c[f>>2]=(c[f>>2]|0)==0?3736:a;c[g>>2]=cM(c[e>>2]|0)|0;a=aM(c[e>>2]|0)|0;n=c[h>>2]|0;p=c[f>>2]|0;q=c[j>>2]|0;r=bM(c[e>>2]|0)|0;c[d>>2]=a;c[d+4>>2]=n;c[d+8>>2]=p;c[d+12>>2]=q;c[d+16>>2]=r;Wa(3744,d|0)|0;if(!(c[g>>2]|0)){Wa(3760,d|0)|0;break}else{c[d>>2]=c[g>>2];Wa(3768,d|0)|0;break}}while(0);if(!(c[694]|0)){i=b;return}c[k>>2]=0;c[l>>2]=-1;if((c[h>>2]|0)==1?(g=c[694]|0,
c[l>>2]=NQ(g,eM(c[e>>2]|0)|0)|0,(c[l>>2]|0)!=0):0){c[k>>2]=Oi(eM(c[e>>2]|0)|0)|0;g=c[548]|0;c[d>>2]=c[k>>2];c[d+4>>2]=g;Wa(3776,d|0)|0}do if(c[898]|0){do if((c[h>>2]|0)==1){g=c[898]|0;f=ZL(c[e>>2]|0)|0;c[m>>2]=HQ(g,f,$L(c[e>>2]|0)|0)|0;if((c[m>>2]|0)<0){Ka(c[o>>2]|0,3600,d|0)|0;GQ(c[898]|0);c[898]=0;break}if((c[m>>2]|0)!=(c[l>>2]|0)){if(!(c[k>>2]|0))c[k>>2]=Oi(eM(c[e>>2]|0)|0)|0;Ka(c[o>>2]|0,3808,d|0)|0;f=c[o>>2]|0;g=c[548]|0;if(c[k>>2]|0){r=c[k>>2]|0;c[d>>2]=g;c[d+4>>2]=r;Ka(f|0,3856,d|0)|0;break}else{r=_L(c[e>>2]|0)|0;c[d>>2]=g;c[d+4>>2]=r;Ka(f|0,3856,d|0)|0;break}}}while(0);if((c[h>>2]|0)!=15?!((c[h>>2]|0)==1&(c[j>>2]|0)!=0):0)break;c[m>>2]=KQ(c[898]|0)|0;if((c[m>>2]|0)<0){Ka(c[o>>2]|0,3880,d|0)|0;GQ(c[898]|0);c[898]=0}}while(0);if(!(c[k>>2]|0)){i=b;return}zb[c[135736>>2]&511](c[k>>2]|0);i=b;return}function qc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+20|0;f=b+16|0;g=b+12|0;j=b+8|0;c[e>>2]=a;switch(c[c[e>>2]>>2]|0){case 4:{c[d>>2]=c[(c[e>>2]|0)+24>>2];Wa(3904,d|0)|0;i=b;return}case 3:{a=Mq(+h[(c[e>>2]|0)+16>>3])|0;if((a|0)==-1){Wa(4032,d|0)|0;i=b;return}else if((a|0)!=1)if(Lq(+h[(c[e>>2]|0)+16>>3])|0){Wa(4048,d|0)|0;i=b;return}else{h[k>>3]=+h[(c[e>>2]|0)+16>>3];c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];Wa(4056,d|0)|0;i=b;return}else{Wa(4016,d|0)|0;i=b;return}break}case 1:{if((c[(c[e>>2]|0)+4>>2]|0)!=0?(c[c[(c[e>>2]|0)+4>>2]>>2]|0)>0:0){c[j>>2]=rR(1,0,0)|0;if(!(c[j>>2]|0)){Ka(c[o>>2]|0,3912,d|0)|0;c[662]=9;i=b;return}c[f>>2]=0;while(1){if((c[f>>2]|0)>=(c[c[(c[e>>2]|0)+4>>2]>>2]|0))break;c[g>>2]=c[(c[(c[(c[e>>2]|0)+4>>2]|0)+8>>2]|0)+(c[f>>2]<<2)>>2];uR(c[j>>2]|0,c[g>>2]|0)|0;c[f>>2]=(c[f>>2]|0)+1}wR(c[j>>2]|0)|0;i=b;return}Ka(c[o>>2]|0,3976,d|0)|0;c[662]=10;i=b;return}case 2:{if(c[(c[e>>2]|0)+8>>2]|0){Wa(4e3,d|0)|0;i=b;return}else{Wa(4008,d|0)|0;i=b;return}break}case 0:{Ka(c[o>>2]|0,4064,d|0)|0;c[662]=10;i=b;return}default:{Ka(c[o>>2]|0,4096,d|0)|0;c[662]=10;i=b;return}}}function rc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b;e=b+12|0;f=b+8|0;c[e>>2]=a;Db[c[135904>>2]&511](c[33980]|0,54216,d);c[f>>2]=ZT(4136)|0;if(!(c[e>>2]|0)){sc();i=b;return}a=4136+(c[f>>2]|0)|0;g=5e4-(c[f>>2]|0)|0;f=c[e>>2]|0;if(c[(c[e>>2]|0)+4>>2]|0){h=c[(c[e>>2]|0)+28>>2]|0;c[d>>2]=c[f+4>>2];c[d+4>>2]=h;JT(a,g,54224,d)|0;sc();i=b;return}else{c[d>>2]=c[f+28>>2];JT(a,g,54232,d)|0;sc();i=b;return}}function sc(){var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b;e=b+4|0;c[e>>2]=cd(0,4136)|0;if(!(c[e>>2]|0)){a[4136]=0;i=b;return}f=c[33976]|0;g=c[33980]|0;c[d>>2]=c[e>>2];Db[f&511](g,3904,d);zb[c[135736>>2]&511](c[e>>2]|0);a[4136]=0;i=b;return}function tc(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+32|0;e=b;f=b+20|0;g=b+16|0;h=b+12|0;j=b+8|0;k=b+4|0;c[f>>2]=a;if(!(c[f>>2]|0)){i=b;return}Db[c[135904>>2]&511](c[33980]|0,54176,e);c[g>>2]=c[(c[f>>2]|0)+16>>2];c[h>>2]=c[(c[f>>2]|0)+12>>2];while(1){if((c[g>>2]|0)>>>0<=(c[h>>2]|0)>>>0)break;if((d[c[g>>2]>>0]|0|0)!=10?(d[c[g>>2]>>0]|0|0)!=13:0)break;c[g>>2]=(c[g>>2]|0)+-1}c[k>>2]=0;while(1){a=c[k>>2]|0;c[k>>2]=a+1;if(((a|0)<80?(c[g>>2]|0)>>>0>(c[h>>2]|0)>>>0:0)?(d[c[g>>2]>>0]|0|0)!=10:0)l=(d[c[g>>2]>>0]|0|0)!=13;else l=0;m=c[g>>2]|0;if(!l)break;c[g>>2]=m+-1}if(!((d[m>>0]|0|0)!=10?(d[c[g>>2]>>0]|0|0)!=13:0))c[g>>2]=(c[g>>2]|0)+1;c[h>>2]=c[g>>2];c[k>>2]=0;while(1){if(((d[c[g>>2]>>0]|0|0)!=0?(d[c[g>>2]>>0]|0|0)!=10:0)?(d[c[g>>2]>>0]|0|0)!=13:0)n=(c[k>>2]|0)<79;else n=0;c[j>>2]=ZT(4136)|0;o=4136+(c[j>>2]|0)|0;p=5e4-(c[j>>2]|0)|0;if(!n)break;m=c[g>>2]|0;c[g>>2]=m+1;c[e>>2]=d[m>>0];JT(o,p,54184,e)|0;c[k>>2]=(c[k>>2]|0)+1}JT(o,p,3760,e)|0;c[g>>2]=c[(c[f>>2]|0)+16>>2];while(1){if((d[c[g>>2]>>0]|0|0)!=10?(d[c[g>>2]>>0]|0|0)!=13:0)break;c[g>>2]=(c[g>>2]|0)+-1}c[k>>2]=0;while(1){if((c[g>>2]|0)!=(c[h>>2]|0)){f=c[k>>2]|0;c[k>>2]=f+1;q=(f|0)<80}else q=0;c[j>>2]=ZT(4136)|0;r=4136+(c[j>>2]|0)|0;s=5e4-(c[j>>2]|0)|0;if(!q)break;JT(r,s,54192,e)|0;c[h>>2]=(c[h>>2]|0)+1}JT(r,s,54200,e)|0;sc();Db[c[135904>>2]&511](c[33980]|0,54208,e);i=b;return}function uc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+32|0;g=f;h=f+12|0;j=f+8|0;k=f+4|0;c[f+16>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[13584]=(c[13584]|0)+1;if(c[50]|0){i=f;return}e=c[q>>2]|0;c[g>>2]=c[h>>2];Ka(e|0,55552,g|0)|0;e=c[q>>2]|0;if(!(c[j>>2]|0))Ka(e|0,54736,g|0)|0;else{c[g>>2]=c[j>>2];Ka(e|0,54744,g|0)|0}e=c[q>>2]|0;if(!(c[k>>2]|0)){Ka(e|0,54752,g|0)|0;i=f;return}else{c[g>>2]=c[k>>2];Ka(e|0,54760,g|0)|0;i=f;return}}function vc(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+8|0;c[b+4>>2]=a;c[13584]=(c[13584]|0)+1;if(c[50]|0){c[d>>2]=0;e=c[d>>2]|0;i=b;return e|0}else{Ka(c[q>>2]|0,55528,b|0)|0;c[d>>2]=0;e=c[d>>2]|0;i=b;return e|0}return 0}function wc(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+8|0;c[b+4>>2]=a;c[13584]=(c[13584]|0)+1;if(c[50]|0){c[d>>2]=0;e=c[d>>2]|0;i=b;return e|0}else{Ka(c[q>>2]|0,55496,b|0)|0;c[d>>2]=0;e=c[d>>2]|0;i=b;return e|0}return 0}function xc(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+8|0;c[b+4>>2]=a;c[13584]=(c[13584]|0)+1;if(c[50]|0){c[d>>2]=0;e=c[d>>2]|0;i=b;return e|0}else{Ka(c[q>>2]|0,55464,b|0)|0;c[d>>2]=0;e=c[d>>2]|0;i=b;return e|0}return 0}function yc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e;g=e+16|0;h=e+8|0;j=e+4|0;c[e+12>>2]=a;c[h>>2]=b;c[j>>2]=d;c[13584]=(c[13584]|0)+1;if(c[50]|0){c[g>>2]=0;k=c[g>>2]|0;i=e;return k|0}Ka(c[q>>2]|0,55424,f|0)|0;d=c[q>>2]|0;if(c[h>>2]|0){c[f>>2]=c[h>>2];Ka(d|0,3904,f|0)|0}else Ka(d|0,54192,f|0)|0;d=c[q>>2]|0;if(c[j>>2]|0){c[f>>2]=c[j>>2];Ka(d|0,55448,f|0)|0}else Ka(d|0,55456,f|0)|0;c[g>>2]=0;k=c[g>>2]|0;i=e;return k|0}function zc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=d+12|0;g=d+4|0;c[d+8>>2]=a;c[g>>2]=b;c[13584]=(c[13584]|0)+1;if(c[50]|0){c[f>>2]=0;h=c[f>>2]|0;i=d;return h|0}else{b=c[q>>2]|0;c[e>>2]=c[g>>2];Ka(b|0,55400,e|0)|0;c[f>>2]=0;h=c[f>>2]|0;i=d;return h|0}return 0}function Ac(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+48|0;j=h;k=h+40|0;l=h+36|0;m=h+32|0;n=h+28|0;o=h+24|0;p=h+20|0;c[h+44>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[p>>2]=55152;if(!(c[m>>2]|0))c[m>>2]=c[p>>2];if(!(c[n>>2]|0))c[n>>2]=c[p>>2];if(!(c[o>>2]|0))c[o>>2]=c[p>>2];c[13584]=(c[13584]|0)+1;if(c[50]|0){i=h;return}p=c[q>>2]|0;g=c[l>>2]|0;l=c[m>>2]|0;m=c[n>>2]|0;n=c[o>>2]|0;c[j>>2]=c[k>>2];c[j+4>>2]=g;c[j+8>>2]=l;c[j+12>>2]=m;c[j+16>>2]=n;Ka(p|0,55360,j|0)|0;i=h;return}function Bc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+32|0;g=f;h=f+20|0;j=f+16|0;k=f+12|0;c[f+24>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[13584]=(c[13584]|0)+1;if(c[50]|0){i=f;return}e=c[q>>2]|0;d=c[j>>2]|0;j=c[k>>2]|0;c[g>>2]=c[h>>2];c[g+4>>2]=d;c[g+8>>2]=j;Ka(e|0,55328,g|0)|0;i=f;return}function Cc(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,r=0;j=i;i=i+48|0;k=j;l=j+40|0;m=j+36|0;n=j+32|0;o=j+28|0;p=j+24|0;r=j+20|0;c[j+44>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[r>>2]=h;c[13584]=(c[13584]|0)+1;if(c[50]|0){i=j;return}h=c[q>>2]|0;g=c[l>>2]|0;l=c[m>>2]|0;m=c[n>>2]|0;n=c[o>>2]|0;if(!(c[p>>2]|0)){c[k>>2]=g;c[k+4>>2]=l;c[k+8>>2]=m;c[k+12>>2]=n;Ka(h|0,55232,k|0)|0}else{o=c[p>>2]|0;c[k>>2]=g;c[k+4>>2]=l;c[k+8>>2]=m;c[k+12>>2]=n;c[k+16>>2]=o;Ka(h|0,55280,k|0)|0}rm(c[r>>2]|0);i=j;return}function Dc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+32|0;g=f;h=f+16|0;j=f+12|0;c[f+20>>2]=a;c[h>>2]=b;c[j>>2]=d;c[f+8>>2]=e;c[13584]=(c[13584]|0)+1;if(c[50]|0){i=f;return}e=c[q>>2]|0;d=c[j>>2]|0;c[g>>2]=c[h>>2];c[g+4>>2]=d;Ka(e|0,55200,g|0)|0;i=f;return}function Ec(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+48|0;h=g;j=g+32|0;k=g+28|0;l=g+24|0;m=g+20|0;n=g+16|0;c[g+36>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[n>>2]=55152;if(!(c[k>>2]|0))c[k>>2]=c[n>>2];if(!(c[l>>2]|0))c[l>>2]=c[n>>2];if(!(c[m>>2]|0))c[m>>2]=c[n>>2];c[13584]=(c[13584]|0)+1;if(c[50]|0){i=g;return}n=c[q>>2]|0;f=c[k>>2]|0;k=c[l>>2]|0;l=c[m>>2]|0;c[h>>2]=c[j>>2];c[h+4>>2]=f;c[h+8>>2]=k;c[h+12>>2]=l;Ka(n|0,55160,h|0)|0;i=g;return}function Fc(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+16|0;c[d+8>>2]=a;c[d+4>>2]=b;c[13584]=(c[13584]|0)+1;if(c[50]|0){i=d;return}Ka(c[q>>2]|0,55120,d|0)|0;i=d;return}function Gc(a){a=a|0;var b=0;b=i;i=i+16|0;c[b+4>>2]=a;c[13584]=(c[13584]|0)+1;if(c[50]|0){i=b;return}Ka(c[q>>2]|0,55096,b|0)|0;i=b;return}function Hc(a){a=a|0;var b=0;b=i;i=i+16|0;c[b+4>>2]=a;c[13584]=(c[13584]|0)+1;if(c[50]|0){i=b;return}Ka(c[q>>2]|0,55072,b|0)|0;i=b;return}function Ic(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=d+4|0;c[d+8>>2]=a;c[f>>2]=b;c[13584]=(c[13584]|0)+1;if(c[50]|0){i=d;return}b=c[q>>2]|0;c[e>>2]=c[f>>2];Ka(b|0,55048,e|0)|0;i=d;return}function Jc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+64|0;g=f;h=f+16|0;j=f+12|0;k=f+24|0;l=f+8|0;c[f+20>>2]=b;c[h>>2]=d;c[j>>2]=e;c[13584]=(c[13584]|0)+1;if(c[50]|0){i=f;return}c[l>>2]=0;while(1){m=c[l>>2]|0;if(!((c[l>>2]|0)<30?(c[l>>2]|0)<(c[j>>2]|0):0))break;a[k+(c[l>>2]|0)>>0]=a[(c[h>>2]|0)+m>>0]|0;c[l>>2]=(c[l>>2]|0)+1}a[k+m>>0]=0;m=c[q>>2]|0;l=c[j>>2]|0;c[g>>2]=k;c[g+4>>2]=l;Ka(m|0,55024,g|0)|0;i=f;return}function Kc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+64|0;g=f;h=f+16|0;j=f+12|0;k=f+24|0;l=f+8|0;c[f+20>>2]=b;c[h>>2]=d;c[j>>2]=e;c[13584]=(c[13584]|0)+1;if(c[50]|0){i=f;return}c[l>>2]=0;while(1){m=c[l>>2]|0;if(!((c[l>>2]|0)<30?(c[l>>2]|0)<(c[j>>2]|0):0))break;a[k+(c[l>>2]|0)>>0]=a[(c[h>>2]|0)+m>>0]|0;c[l>>2]=(c[l>>2]|0)+1}a[k+m>>0]=0;m=c[q>>2]|0;l=c[j>>2]|0;c[g>>2]=k;c[g+4>>2]=l;Ka(m|0,54984,g|0)|0;i=f;return}function Lc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+32|0;f=e;g=e+12|0;h=e+8|0;c[e+16>>2]=a;c[g>>2]=b;c[h>>2]=d;c[13584]=(c[13584]|0)+1;if(c[50]|0){i=e;return}d=c[q>>2]|0;b=c[g>>2]|0;if(c[h>>2]|0){g=c[h>>2]|0;c[f>>2]=b;c[f+4>>2]=g;Ka(d|0,54904,f|0)|0;i=e;return}else{c[f>>2]=b;Ka(d|0,54944,f|0)|0;i=e;return}}function Mc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=d+4|0;c[d+8>>2]=a;c[f>>2]=b;c[13584]=(c[13584]|0)+1;if(c[50]|0){i=d;return}b=c[q>>2]|0;c[e>>2]=c[f>>2];Ka(b|0,54880,e|0)|0;i=d;return}function Nc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+32|0;f=e+24|0;g=e+8|0;c[e+28>>2]=a;c[f>>2]=b;c[13584]=(c[13584]|0)+1;if(c[50]|0){i=e;return}c[g>>2]=d;Ka(c[q>>2]|0,54864,e|0)|0;Ca(c[q>>2]|0,c[f>>2]|0,g|0)|0;i=e;return}function Oc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+32|0;f=e+24|0;g=e+8|0;c[e+28>>2]=a;c[f>>2]=b;c[13584]=(c[13584]|0)+1;if(c[50]|0){i=e;return}c[g>>2]=d;Ka(c[q>>2]|0,54848,e|0)|0;Ca(c[q>>2]|0,c[f>>2]|0,g|0)|0;i=e;return}function Pc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+32|0;f=e+24|0;g=e+8|0;c[e+28>>2]=a;c[f>>2]=b;c[13584]=(c[13584]|0)+1;if(c[50]|0){i=e;return}c[g>>2]=d;Ka(c[q>>2]|0,54824,e|0)|0;Ca(c[q>>2]|0,c[f>>2]|0,g|0)|0;i=e;return}function Qc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=d+12|0;g=d+4|0;c[d+8>>2]=a;c[g>>2]=b;c[13584]=(c[13584]|0)+1;if(c[50]|0){c[f>>2]=0;h=c[f>>2]|0;i=d;return h|0}else{b=c[q>>2]|0;c[e>>2]=c[g>>2];Ka(b|0,54792,e|0)|0;c[f>>2]=0;h=c[f>>2]|0;i=d;return h|0}return 0}function Rc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+32|0;f=e;g=e+12|0;h=e+8|0;c[e+16>>2]=a;c[g>>2]=b;c[h>>2]=d;c[13584]=(c[13584]|0)+1;if(c[50]|0){i=e;return}d=c[q>>2]|0;b=c[h>>2]|0;c[f>>2]=c[g>>2];c[f+4>>2]=b;Ka(d|0,54768,f|0)|0;i=e;return}function Sc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+32|0;g=f;h=f+12|0;j=f+8|0;k=f+4|0;c[f+16>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[13584]=(c[13584]|0)+1;if(c[50]|0){i=f;return}e=c[q>>2]|0;c[g>>2]=c[h>>2];Ka(e|0,54712,g|0)|0;e=c[q>>2]|0;if(!(c[j>>2]|0))Ka(e|0,54736,g|0)|0;else{c[g>>2]=c[j>>2];Ka(e|0,54744,g|0)|0}e=c[q>>2]|0;if(!(c[k>>2]|0)){Ka(e|0,54752,g|0)|0;i=f;return}else{c[g>>2]=c[k>>2];Ka(e|0,54760,g|0)|0;i=f;return}}function Tc(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,r=0,s=0,t=0,u=0,v=0,w=0;l=i;i=i+48|0;m=l;n=l+40|0;o=l+36|0;p=l+32|0;r=l+28|0;s=l+24|0;t=l+20|0;u=l+16|0;v=l+12|0;w=l+8|0;c[l+44>>2]=a;c[n>>2]=b;c[o>>2]=d;c[p>>2]=e;c[r>>2]=f;c[s>>2]=g;c[t>>2]=h;c[u>>2]=j;c[v>>2]=k;c[13584]=(c[13584]|0)+1;if(c[50]|0){i=l;return}k=c[q>>2]|0;c[m>>2]=c[n>>2];Ka(k|0,54584,m|0)|0;k=c[q>>2]|0;if(!(c[o>>2]|0))Ka(k|0,54536,m|0)|0;else{c[m>>2]=c[o>>2];Ka(k|0,54544,m|0)|0}k=c[q>>2]|0;if(!(c[p>>2]|0))Ka(k|0,54536,m|0)|0;else{c[m>>2]=c[p>>2];Ka(k|0,54608,m|0)|0}k=c[q>>2]|0;c[m>>2]=c[r>>2];Ka(k|0,54616,m|0)|0;a:do if(c[s>>2]|0){c[w>>2]=0;while(1){if((c[w>>2]|0)>=(c[r>>2]<<1|0))break a;Ka(c[q>>2]|0,54624,m|0)|0;if(c[(c[s>>2]|0)+(c[w>>2]<<2)>>2]|0){k=c[q>>2]|0;c[m>>2]=c[(c[s>>2]|0)+(c[w>>2]<<2)>>2];Ka(k|0,54632,m|0)|0}c[w>>2]=(c[w>>2]|0)+1;k=c[q>>2]|0;c[m>>2]=c[(c[s>>2]|0)+(c[w>>2]<<2)>>2];Ka(k|0,54640,m|0)|0;c[w>>2]=(c[w>>2]|0)+1}}while(0);s=c[q>>2]|0;r=c[u>>2]|0;c[m>>2]=c[t>>2];c[m+4>>2]=r;Ka(s|0,54648,m|0)|0;b:do if(c[v>>2]|0){c[w>>2]=0;while(1){if((c[w>>2]|0)>=((c[t>>2]|0)*5|0))break b;s=c[q>>2]|0;r=c[w>>2]|0;if(c[(c[v>>2]|0)+((c[w>>2]|0)+1<<2)>>2]|0){u=c[(c[v>>2]|0)+(c[w>>2]<<2)>>2]|0;c[m>>2]=c[(c[v>>2]|0)+(r+1<<2)>>2];c[m+4>>2]=u;Ka(s|0,54664,m|0)|0}else{c[m>>2]=c[(c[v>>2]|0)+(r<<2)>>2];Ka(s|0,54680,m|0)|0}s=c[q>>2]|0;r=(c[(c[v>>2]|0)+((c[w>>2]|0)+4<<2)>>2]|0)-(c[(c[v>>2]|0)+((c[w>>2]|0)+3<<2)>>2]|0)|0;c[m>>2]=c[(c[v>>2]|0)+((c[w>>2]|0)+3<<2)>>2];c[m+4>>2]=r;Ka(s|0,54688,m|0)|0;c[w>>2]=(c[w>>2]|0)+5}}while(0);Ka(c[q>>2]|0,54704,m|0)|0;i=l;return}function Uc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+32|0;g=f;h=f+12|0;j=f+8|0;k=f+4|0;c[f+16>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[13584]=(c[13584]|0)+1;if(c[50]|0){i=f;return}e=c[q>>2]|0;c[g>>2]=c[h>>2];Ka(e|0,54512,g|0)|0;e=c[q>>2]|0;if(!(c[j>>2]|0))Ka(e|0,54536,g|0)|0;else{c[g>>2]=c[j>>2];Ka(e|0,54544,g|0)|0}e=c[q>>2]|0;if(!(c[k>>2]|0)){Ka(e|0,54552,g|0)|0;i=f;return}else{c[g>>2]=c[k>>2];Ka(e|0,54568,g|0)|0;i=f;return}}function Vc(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a;d=c[o>>2]|0;c[b>>2]=c[432];Ka(d|0,56400,b|0)|0;c[662]=9;i=a;return}function Wc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+32|0;f=e;g=e+12|0;h=e+8|0;j=e+4|0;c[e+16>>2]=a;c[g>>2]=b;c[h>>2]=d;c[13584]=(c[13584]|0)+1;if(c[50]|0){i=e;return}d=c[q>>2]|0;c[f>>2]=c[g>>2];Ka(d|0,60952,f|0)|0;a:do if(c[h>>2]|0){c[j>>2]=0;while(1){if(!(c[(c[h>>2]|0)+(c[j>>2]<<2)>>2]|0))break a;d=c[q>>2]|0;g=c[j>>2]|0;c[j>>2]=g+1;c[f>>2]=c[(c[h>>2]|0)+(g<<2)>>2];Ka(d|0,54680,f|0)|0;if(c[(c[h>>2]|0)+(c[j>>2]<<2)>>2]|0){d=c[q>>2]|0;c[f>>2]=c[(c[h>>2]|0)+(c[j>>2]<<2)>>2];Ka(d|0,60976,f|0)|0}c[j>>2]=(c[j>>2]|0)+1}}while(0);Ka(c[q>>2]|0,54704,f|0)|0;i=e;return}function Xc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=d+4|0;c[d+8>>2]=a;c[f>>2]=b;c[13584]=(c[13584]|0)+1;if(c[50]|0){i=d;return}b=c[q>>2]|0;c[e>>2]=c[f>>2];Ka(b|0,60928,e|0)|0;i=d;return}function Yc(a){a=a|0;var b=0,e=0,f=0;b=i;i=i+16|0;e=b+4|0;f=b;c[f>>2]=a;do if(!(c[f>>2]|0))c[e>>2]=0;else{a=d[c[f>>2]>>0]|0;if((a|0)==103){if(qy(c[f>>2]|0,61072)|0){c[e>>2]=61080;break}}else if((a|0)==97){if(qy(c[f>>2]|0,61160)|0){c[e>>2]=61168;break}if(qy(c[f>>2]|0,61248)|0){c[e>>2]=61256;break}}else if((a|0)==108){if(qy(c[f>>2]|0,60984)|0){c[e>>2]=60992;break}}else if((a|0)==113?(qy(c[f>>2]|0,61336)|0)!=0:0){c[e>>2]=61344;break}c[e>>2]=0}while(0);i=b;return c[e>>2]|0}function Zc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+48|0;j=h+32|0;k=h+28|0;l=h+24|0;m=h+20|0;n=h+16|0;o=h+12|0;p=h+8|0;q=h+4|0;r=h;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;if(!(c[k>>2]|0)){gd(521,61424);c[j>>2]=0;s=c[j>>2]|0;i=h;return s|0}if(!(c[(c[k>>2]|0)+48>>2]|0)){gd(522,61464);c[j>>2]=0;s=c[j>>2]|0;i=h;return s|0}c[r>>2]=c[(c[k>>2]|0)+48>>2];c[q>>2]=hd(c[r>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0)|0;if(!(c[q>>2]|0)){c[j>>2]=0;s=c[j>>2]|0;i=h;return s|0}c[(c[q>>2]|0)+20>>2]=c[r>>2];c[(c[q>>2]|0)+32>>2]=c[(c[r>>2]|0)+32>>2];p=c[q>>2]|0;o=(c[r>>2]|0)+16|0;if(!(c[(c[r>>2]|0)+16>>2]|0)){c[o>>2]=p;c[(c[r>>2]|0)+12>>2]=p}else{c[(c[o>>2]|0)+24>>2]=p;c[(c[q>>2]|0)+28>>2]=c[(c[r>>2]|0)+16>>2];c[(c[r>>2]|0)+16>>2]=c[q>>2]}c[j>>2]=c[q>>2];s=c[j>>2]|0;i=h;return s|0}function _c(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+48|0;j=h+32|0;k=h+28|0;l=h+24|0;m=h+20|0;n=h+16|0;o=h+12|0;p=h+8|0;q=h+4|0;r=h;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;if(!(c[k>>2]|0)){gd(521,61520);c[j>>2]=0;s=c[j>>2]|0;i=h;return s|0}if(!(c[(c[k>>2]|0)+44>>2]|0)){gd(522,61560);c[j>>2]=0;s=c[j>>2]|0;i=h;return s|0}c[r>>2]=c[(c[k>>2]|0)+44>>2];c[q>>2]=hd(c[r>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0)|0;if(!(c[q>>2]|0)){c[j>>2]=0;s=c[j>>2]|0;i=h;return s|0}c[(c[q>>2]|0)+20>>2]=c[r>>2];c[(c[q>>2]|0)+32>>2]=c[(c[r>>2]|0)+32>>2];p=c[q>>2]|0;o=(c[r>>2]|0)+16|0;if(!(c[(c[r>>2]|0)+16>>2]|0)){c[o>>2]=p;c[(c[r>>2]|0)+12>>2]=p}else{c[(c[o>>2]|0)+24>>2]=p;c[(c[q>>2]|0)+28>>2]=c[(c[r>>2]|0)+16>>2];c[(c[r>>2]|0)+16>>2]=c[q>>2]}c[j>>2]=c[q>>2];s=c[j>>2]|0;i=h;return s|0}function $c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[f>>2]=a;c[g>>2]=b;if(!(c[f>>2]|0)){c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}if(((c[(c[f>>2]|0)+44>>2]|0)!=0?(c[(c[(c[f>>2]|0)+44>>2]|0)+60>>2]|0)!=0:0)?(c[h>>2]=c[(c[(c[f>>2]|0)+44>>2]|0)+60>>2],c[j>>2]=jd(c[h>>2]|0,c[g>>2]|0)|0,(c[j>>2]|0)!=0):0){c[e>>2]=c[j>>2];k=c[e>>2]|0;i=d;return k|0}if((c[(c[f>>2]|0)+48>>2]|0)!=0?(c[(c[(c[f>>2]|0)+48>>2]|0)+60>>2]|0)!=0:0){c[h>>2]=c[(c[(c[f>>2]|0)+48>>2]|0)+60>>2];c[e>>2]=jd(c[h>>2]|0,c[g>>2]|0)|0;k=c[e>>2]|0;i=d;return k|0}c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}function ad(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[f>>2]=a;c[g>>2]=b;if(c[f>>2]|0){if(((c[(c[f>>2]|0)+44>>2]|0)!=0?(c[(c[(c[f>>2]|0)+44>>2]|0)+48>>2]|0)!=0:0)?(c[j>>2]=c[(c[(c[f>>2]|0)+44>>2]|0)+48>>2],c[h>>2]=jd(c[j>>2]|0,c[g>>2]|0)|0,(c[h>>2]|0)!=0):0){c[e>>2]=c[h>>2];k=c[e>>2]|0;i=d;return k|0}if((((c[(c[f>>2]|0)+40>>2]|0)!=1?(c[(c[f>>2]|0)+48>>2]|0)!=0:0)?(c[(c[(c[f>>2]|0)+48>>2]|0)+48>>2]|0)!=0:0)?(c[j>>2]=c[(c[(c[f>>2]|0)+48>>2]|0)+48>>2],c[h>>2]=jd(c[j>>2]|0,c[g>>2]|0)|0,(c[h>>2]|0)!=0):0){c[e>>2]=c[h>>2];k=c[e>>2]|0;i=d;return k|0}}c[e>>2]=Yc(c[g>>2]|0)|0;k=c[e>>2]|0;i=d;return k|0}function bd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=kd(c[e>>2]|0,c[f>>2]|0,1)|0;i=d;return b|0}function cd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=kd(c[e>>2]|0,c[f>>2]|0,0)|0;i=d;return b|0}function dd(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;Kj(c[d>>2]|0,211);i=b;return}function ed(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=_j(c[d>>2]|0,212)|0;i=b;return a|0}function fd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if((c[e>>2]|0)==0|(c[f>>2]|0)==0){i=d;return}switch(c[(c[f>>2]|0)+48>>2]|0){case 2:{rj(c[e>>2]|0,61616);qj(c[e>>2]|0,c[(c[f>>2]|0)+8>>2]|0);b=c[e>>2]|0;if(c[(c[f>>2]|0)+52>>2]|0){rj(b,61648);sj(c[e>>2]|0,c[(c[f>>2]|0)+52>>2]|0);rj(c[e>>2]|0,61632);sj(c[e>>2]|0,c[(c[f>>2]|0)+56>>2]|0)}else{rj(b,61664);sj(c[e>>2]|0,c[(c[f>>2]|0)+56>>2]|0)}rj(c[e>>2]|0,61640);i=d;return}case 1:{rj(c[e>>2]|0,61616);qj(c[e>>2]|0,c[(c[f>>2]|0)+8>>2]|0);rj(c[e>>2]|0,61632);b=c[e>>2]|0;a=c[f>>2]|0;if(c[(c[f>>2]|0)+36>>2]|0)sj(b,c[a+36>>2]|0);else od(b,c[a+40>>2]|0);rj(c[e>>2]|0,61640);i=d;return}case 5:{rj(c[e>>2]|0,61688);qj(c[e>>2]|0,c[(c[f>>2]|0)+8>>2]|0);a=c[e>>2]|0;if(c[(c[f>>2]|0)+52>>2]|0){rj(a,61648);sj(c[e>>2]|0,c[(c[f>>2]|0)+52>>2]|0);rj(c[e>>2]|0,61632);sj(c[e>>2]|0,c[(c[f>>2]|0)+56>>2]|0)}else{rj(a,61664);sj(c[e>>2]|0,c[(c[f>>2]|0)+56>>2]|0)}rj(c[e>>2]|0,61640);i=d;return}case 3:{rj(c[e>>2]|0,61616);qj(c[e>>2]|0,c[(c[f>>2]|0)+8>>2]|0);a=c[e>>2]|0;if(c[(c[f>>2]|0)+52>>2]|0){rj(a,61648);sj(c[e>>2]|0,c[(c[f>>2]|0)+52>>2]|0);rj(c[e>>2]|0,61632);sj(c[e>>2]|0,c[(c[f>>2]|0)+56>>2]|0)}else{rj(a,61664);sj(c[e>>2]|0,c[(c[f>>2]|0)+56>>2]|0)}do if(c[(c[f>>2]|0)+40>>2]|0){rj(c[e>>2]|0,61680);a=c[e>>2]|0;b=c[f>>2]|0;if(c[(c[f>>2]|0)+36>>2]|0){qj(a,c[b+36>>2]|0);break}else{qj(a,c[b+40>>2]|0);break}}while(0);rj(c[e>>2]|0,61640);i=d;return}case 4:{rj(c[e>>2]|0,61688);qj(c[e>>2]|0,c[(c[f>>2]|0)+8>>2]|0);rj(c[e>>2]|0,61632);b=c[e>>2]|0;a=c[f>>2]|0;if(!(c[(c[f>>2]|0)+36>>2]|0))od(b,c[a+40>>2]|0);else sj(b,c[a+36>>2]|0);rj(c[e>>2]|0,61640);i=d;return}default:{gd(535,61704);i=d;return}}}function gd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;ce(2,c[e>>2]|0,0,c[f>>2]|0,0);i=d;return}function hd(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=h+36|0;k=h+32|0;l=h+28|0;m=h+24|0;n=h+20|0;o=h+16|0;p=h+12|0;q=h+8|0;r=h+4|0;s=h;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=0;c[r>>2]=0;if(!(c[l>>2]|0)){c[j>>2]=0;t=c[j>>2]|0;i=h;return t|0}if(!(c[k>>2]|0)){c[j>>2]=0;t=c[j>>2]|0;i=h;return t|0}if(c[(c[k>>2]|0)+32>>2]|0)c[q>>2]=c[(c[(c[k>>2]|0)+32>>2]|0)+80>>2];switch(c[m>>2]|0){case 6:{c[j>>2]=0;t=c[j>>2]|0;i=h;return t|0}case 3:case 2:case 1:{if(!(c[(c[k>>2]|0)+48>>2]|0)){g=Jj(0,c[q>>2]|0)|0;c[(c[k>>2]|0)+48>>2]=g}c[r>>2]=c[(c[k>>2]|0)+48>>2];break}case 5:case 4:{if(!(c[(c[k>>2]|0)+60>>2]|0)){g=Jj(0,c[q>>2]|0)|0;c[(c[k>>2]|0)+60>>2]=g}c[r>>2]=c[(c[k>>2]|0)+60>>2];break}default:{}}if(!(c[r>>2]|0)){c[j>>2]=0;t=c[j>>2]|0;i=h;return t|0}c[s>>2]=id(c[q>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0)|0;if(!(c[s>>2]|0)){c[j>>2]=0;t=c[j>>2]|0;i=h;return t|0}c[(c[s>>2]|0)+32>>2]=c[(c[k>>2]|0)+32>>2];k=(Lj(c[r>>2]|0,c[l>>2]|0,c[s>>2]|0)|0)!=0;l=c[s>>2]|0;if(k){pd(l);c[j>>2]=0;t=c[j>>2]|0;i=h;return t|0}else{c[j>>2]=l;t=c[j>>2]|0;i=h;return t|0}return 0}function id(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+32|0;j=h+28|0;k=h+24|0;l=h+20|0;m=h+16|0;n=h+12|0;o=h+8|0;p=h+4|0;q=h;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=Cb[c[135744>>2]&511](76)|0;if(!(c[q>>2]|0)){ld(62016);c[j>>2]=0;r=c[j>>2]|0;i=h;return r|0}g=(c[q>>2]|0)+0|0;f=g+76|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(f|0));c[(c[q>>2]|0)+4>>2]=17;c[(c[q>>2]|0)+72>>2]=0;c[(c[q>>2]|0)+48>>2]=c[m>>2];if(!(c[k>>2]|0)){m=my(c[l>>2]|0)|0;c[(c[q>>2]|0)+8>>2]=m;if(c[n>>2]|0){m=my(c[n>>2]|0)|0;c[(c[q>>2]|0)+52>>2]=m}if(c[o>>2]|0){m=my(c[o>>2]|0)|0;c[(c[q>>2]|0)+56>>2]=m}}else{m=AP(c[k>>2]|0,c[l>>2]|0,-1)|0;c[(c[q>>2]|0)+8>>2]=m;if(c[n>>2]|0){m=AP(c[k>>2]|0,c[n>>2]|0,-1)|0;c[(c[q>>2]|0)+52>>2]=m}if(c[o>>2]|0){m=AP(c[k>>2]|0,c[o>>2]|0,-1)|0;c[(c[q>>2]|0)+56>>2]=m}}do if(c[p>>2]|0){m=xy(c[p>>2]|0)|0;c[(c[q>>2]|0)+44>>2]=m;if((c[k>>2]|0)!=0?(c[(c[q>>2]|0)+44>>2]|0)<5:0){m=AP(c[k>>2]|0,c[p>>2]|0,c[(c[q>>2]|0)+44>>2]|0)|0;c[(c[q>>2]|0)+40>>2]=m;break}m=ly(c[p>>2]|0,c[(c[q>>2]|0)+44>>2]|0)|0;c[(c[q>>2]|0)+40>>2]=m}else{c[(c[q>>2]|0)+44>>2]=0;c[(c[q>>2]|0)+40>>2]=0}while(0);c[(c[q>>2]|0)+64>>2]=0;c[(c[q>>2]|0)+36>>2]=0;c[(c[q>>2]|0)+68>>2]=0;c[j>>2]=c[q>>2];r=c[j>>2]|0;i=h;return r|0}function jd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=Rj(c[e>>2]|0,c[f>>2]|0)|0;i=d;return b|0}function kd(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=i;i=i+112|0;h=g;j=g+84|0;k=g+80|0;l=g+76|0;m=g+72|0;n=g+68|0;o=g+64|0;p=g+60|0;q=g+56|0;r=g+52|0;s=g+48|0;t=g+44|0;u=g+40|0;v=g+36|0;w=g+32|0;x=g+28|0;y=g+24|0;z=g+20|0;A=g+99|0;B=g+16|0;C=g+12|0;D=g+8|0;E=g+88|0;F=g+4|0;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=c[l>>2];c[o>>2]=0;c[p>>2]=0;c[q>>2]=0;c[r>>2]=0;if(!(c[l>>2]|0)){c[j>>2]=0;G=c[j>>2]|0;i=g;return G|0}if(c[k>>2]|0)c[r>>2]=(c[(c[k>>2]|0)+4>>2]|0)==13&1;c[q>>2]=1e3;c[o>>2]=Cb[c[135744>>2]&511](c[q>>2]|0)|0;if(!(c[o>>2]|0)){ld(61816);c[j>>2]=0;G=c[j>>2]|0;i=g;return G|0}c[p>>2]=c[o>>2];a:while(1){H=c[p>>2]|0;if(!(d[c[n>>2]>>0]|0)){I=87;break}c[s>>2]=H-(c[o>>2]|0);if(((c[s>>2]|0)+100|0)>>>0>(c[q>>2]|0)>>>0){c[u>>2]=c[q>>2]<<1;if((c[u>>2]|0)>>>0<(c[q>>2]|0)>>>0){I=88;break}c[t>>2]=Hb[c[135760>>2]&511](c[o>>2]|0,c[u>>2]|0)|0;if(!(c[t>>2]|0)){I=88;break}c[o>>2]=c[t>>2];c[q>>2]=c[u>>2];c[p>>2]=(c[o>>2]|0)+(c[s>>2]|0)}b:do if((d[c[n>>2]>>0]|0)==60){if(((((c[r>>2]|0)!=0&(c[m>>2]|0)!=0?(d[(c[n>>2]|0)+1>>0]|0)==33:0)?(d[(c[n>>2]|0)+2>>0]|0)==45:0)?(d[(c[n>>2]|0)+3>>0]|0)==45:0)?(l=wy(c[n>>2]|0,61856)|0,c[v>>2]=l,(l|0)!=0):0){while(1){l=(c[n>>2]|0)!=(c[v>>2]|0);f=c[n>>2]|0;c[n>>2]=f+1;e=a[f>>0]|0;f=c[p>>2]|0;c[p>>2]=f+1;a[f>>0]=e;if(!l)break;c[s>>2]=(c[p>>2]|0)-(c[o>>2]|0);if(((c[s>>2]|0)+100|0)>>>0<=(c[q>>2]|0)>>>0)continue;c[x>>2]=c[q>>2]<<1;if((c[x>>2]|0)>>>0<(c[q>>2]|0)>>>0){I=88;break a}c[w>>2]=Hb[c[135760>>2]&511](c[o>>2]|0,c[x>>2]|0)|0;if(!(c[w>>2]|0)){I=88;break a}c[o>>2]=c[w>>2];c[q>>2]=c[x>>2];c[p>>2]=(c[o>>2]|0)+(c[s>>2]|0)}l=c[n>>2]|0;c[n>>2]=l+1;e=a[l>>0]|0;l=c[p>>2]|0;c[p>>2]=l+1;a[l>>0]=e;e=c[n>>2]|0;c[n>>2]=e+1;l=a[e>>0]|0;e=c[p>>2]|0;c[p>>2]=e+1;a[e>>0]=l;continue a}l=c[p>>2]|0;c[p>>2]=l+1;a[l>>0]=38;l=c[p>>2]|0;c[p>>2]=l+1;a[l>>0]=108;l=c[p>>2]|0;c[p>>2]=l+1;a[l>>0]=116;l=c[p>>2]|0;c[p>>2]=l+1;a[l>>0]=59}else{if((d[c[n>>2]>>0]|0)==62){l=c[p>>2]|0;c[p>>2]=l+1;a[l>>0]=38;l=c[p>>2]|0;c[p>>2]=l+1;a[l>>0]=103;l=c[p>>2]|0;c[p>>2]=l+1;a[l>>0]=116;l=c[p>>2]|0;c[p>>2]=l+1;a[l>>0]=59;break}if((d[c[n>>2]>>0]|0)==38){if(((c[r>>2]|0)!=0&(c[m>>2]|0)!=0?(d[(c[n>>2]|0)+1>>0]|0)==123:0)?(eT(c[n>>2]|0,125)|0)!=0:0)while(1){l=(d[c[n>>2]>>0]|0)!=125;e=c[n>>2]|0;c[n>>2]=e+1;f=a[e>>0]|0;e=c[p>>2]|0;c[p>>2]=e+1;a[e>>0]=f;if(!l)continue a;c[s>>2]=(c[p>>2]|0)-(c[o>>2]|0);if(((c[s>>2]|0)+100|0)>>>0<=(c[q>>2]|0)>>>0)continue;c[z>>2]=c[q>>2]<<1;if((c[z>>2]|0)>>>0<(c[q>>2]|0)>>>0){I=88;break a}c[y>>2]=Hb[c[135760>>2]&511](c[o>>2]|0,c[z>>2]|0)|0;if(!(c[y>>2]|0)){I=88;break a}c[o>>2]=c[y>>2];c[q>>2]=c[z>>2];c[p>>2]=(c[o>>2]|0)+(c[s>>2]|0)}l=c[p>>2]|0;c[p>>2]=l+1;a[l>>0]=38;l=c[p>>2]|0;c[p>>2]=l+1;a[l>>0]=97;l=c[p>>2]|0;c[p>>2]=l+1;a[l>>0]=109;l=c[p>>2]|0;c[p>>2]=l+1;a[l>>0]=112;l=c[p>>2]|0;c[p>>2]=l+1;a[l>>0]=59;break}if(!((d[c[n>>2]>>0]|0)>=32?(d[c[n>>2]>>0]|0)<128:0))I=40;do if(((I|0)==40?(I=0,(d[c[n>>2]>>0]|0)!=10):0)?(d[c[n>>2]>>0]|0)!=9:0){if((c[r>>2]|0)!=0?(d[c[n>>2]>>0]|0)==13:0)break;if((d[c[n>>2]>>0]|0)<128){if(!(9<=(d[c[n>>2]>>0]|0)?(d[c[n>>2]>>0]|0)<=10:0))I=81;if(((I|0)==81?(I=0,(d[c[n>>2]>>0]|0)!=13):0)?32>(d[c[n>>2]>>0]|0):0)break b;c[h>>2]=d[c[n>>2]>>0];JT(E,11,61920,h)|0;a[E+10>>0]=0;c[F>>2]=E;while(1){if(!(a[c[F>>2]>>0]|0))break b;l=c[F>>2]|0;c[F>>2]=l+1;f=a[l>>0]|0;l=c[p>>2]|0;c[p>>2]=l+1;a[l>>0]=f}}if(c[k>>2]|0){if((c[r>>2]|0)!=0?1:(c[(c[k>>2]|0)+60>>2]|0)!=0)I=49}else if(c[r>>2]|0)I=49;if((I|0)==49){I=0;f=a[c[n>>2]>>0]|0;l=c[p>>2]|0;c[p>>2]=l+1;a[l>>0]=f;break b}c[C>>2]=0;c[D>>2]=1;if((d[c[n>>2]>>0]|0)<192){gd(5032,61864);if(c[k>>2]|0){f=my(61904)|0;c[(c[k>>2]|0)+60>>2]=f}c[h>>2]=d[c[n>>2]>>0];JT(A,11,61920,h)|0;a[A+10>>0]=0;c[B>>2]=A;while(1){if(!(a[c[B>>2]>>0]|0))break;f=c[B>>2]|0;c[B>>2]=f+1;l=a[f>>0]|0;f=c[p>>2]|0;c[p>>2]=f+1;a[f>>0]=l}c[n>>2]=(c[n>>2]|0)+1;continue a}l=c[n>>2]|0;do if((d[c[n>>2]>>0]|0)<224){c[C>>2]=d[l>>0]&31;c[C>>2]=c[C>>2]<<6;c[C>>2]=c[C>>2]|d[(c[n>>2]|0)+1>>0]&63;c[D>>2]=2}else{f=c[n>>2]|0;if((d[l>>0]|0)<240){c[C>>2]=d[f>>0]&15;c[C>>2]=c[C>>2]<<6;c[C>>2]=c[C>>2]|d[(c[n>>2]|0)+1>>0]&63;c[C>>2]=c[C>>2]<<6;c[C>>2]=c[C>>2]|d[(c[n>>2]|0)+2>>0]&63;c[D>>2]=3;break}if((d[f>>0]|0)>=248)break;c[C>>2]=d[c[n>>2]>>0]&7;c[C>>2]=c[C>>2]<<6;c[C>>2]=c[C>>2]|d[(c[n>>2]|0)+1>>0]&63;c[C>>2]=c[C>>2]<<6;c[C>>2]=c[C>>2]|d[(c[n>>2]|0)+2>>0]&63;c[C>>2]=c[C>>2]<<6;c[C>>2]=c[C>>2]|d[(c[n>>2]|0)+3>>0]&63;c[D>>2]=4}while(0);c:do if((c[D>>2]|0)!=1){l=c[C>>2]|0;do if((c[C>>2]|0)<256){if(!(9<=(l|0)&(c[C>>2]|0)<=10|(c[C>>2]|0)==13|32<=(c[C>>2]|0)))break c}else{if(256<=(l|0)&(c[C>>2]|0)<=55295)break;if(57344<=(c[C>>2]|0)&(c[C>>2]|0)<=65533)break;if(!(65536<=(c[C>>2]|0)&(c[C>>2]|0)<=1114111))break c}while(0);c[h>>2]=c[C>>2];JT(A,11,61968,h)|0;a[A+10>>0]=0;c[B>>2]=A;while(1){if(!(a[c[B>>2]>>0]|0))break;l=c[B>>2]|0;c[B>>2]=l+1;f=a[l>>0]|0;l=c[p>>2]|0;c[p>>2]=l+1;a[l>>0]=f}c[n>>2]=(c[n>>2]|0)+(c[D>>2]|0);continue a}while(0);gd(9,61928);if(c[k>>2]|0){f=my(61904)|0;c[(c[k>>2]|0)+60>>2]=f}c[h>>2]=d[c[n>>2]>>0];JT(A,11,61920,h)|0;a[A+10>>0]=0;c[B>>2]=A;while(1){if(!(a[c[B>>2]>>0]|0))break;f=c[B>>2]|0;c[B>>2]=f+1;l=a[f>>0]|0;f=c[p>>2]|0;c[p>>2]=f+1;a[f>>0]=l}c[n>>2]=(c[n>>2]|0)+1;continue a}while(0);l=a[c[n>>2]>>0]|0;f=c[p>>2]|0;c[p>>2]=f+1;a[f>>0]=l}while(0);c[n>>2]=(c[n>>2]|0)+1}if((I|0)==87){a[H>>0]=0;c[j>>2]=c[o>>2];G=c[j>>2]|0;i=g;return G|0}else if((I|0)==88){ld(61976);zb[c[135736>>2]&511](c[o>>2]|0);c[j>>2]=0;G=c[j>>2]|0;i=g;return G|0}return 0}function ld(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;ce(2,2,0,0,c[d>>2]|0);i=b;return}function md(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d+4|0;c[e>>2]=a;c[d>>2]=b;if(!(c[e>>2]|0)){i=d;return}pd(c[e>>2]|0);i=d;return}function nd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](76)|0;if(!(c[f>>2]|0)){ld(61784);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}a=(c[f>>2]|0)+0|0;h=a+76|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(h|0));c[(c[f>>2]|0)+4>>2]=17;c[(c[f>>2]|0)+48>>2]=c[(c[e>>2]|0)+48>>2];if(c[(c[e>>2]|0)+8>>2]|0){a=my(c[(c[e>>2]|0)+8>>2]|0)|0;c[(c[f>>2]|0)+8>>2]=a}if(c[(c[e>>2]|0)+52>>2]|0){a=my(c[(c[e>>2]|0)+52>>2]|0)|0;c[(c[f>>2]|0)+52>>2]=a}if(c[(c[e>>2]|0)+56>>2]|0){a=my(c[(c[e>>2]|0)+56>>2]|0)|0;c[(c[f>>2]|0)+56>>2]=a}if(c[(c[e>>2]|0)+40>>2]|0){a=my(c[(c[e>>2]|0)+40>>2]|0)|0;c[(c[f>>2]|0)+40>>2]=a}if(c[(c[e>>2]|0)+36>>2]|0){a=my(c[(c[e>>2]|0)+36>>2]|0)|0;c[(c[f>>2]|0)+36>>2]=a}if(c[(c[e>>2]|0)+64>>2]|0){a=my(c[(c[e>>2]|0)+64>>2]|0)|0;c[(c[f>>2]|0)+64>>2]=a}c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}function od(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;if((c[(c[f>>2]|0)+12>>2]|0)==2){i=e;return}b=(vy(c[g>>2]|0,37)|0)!=0;a=c[f>>2]|0;if(!b){sj(a,c[g>>2]|0);i=e;return}pj(a,61760)|0;a=c[g>>2]|0;c[j>>2]=a;c[h>>2]=a;while(1){if(!(d[c[j>>2]>>0]|0))break;if((d[c[j>>2]>>0]|0|0)==34){if((c[h>>2]|0)!=(c[j>>2]|0))nj(c[f>>2]|0,c[h>>2]|0,(c[j>>2]|0)-(c[h>>2]|0)|0)|0;nj(c[f>>2]|0,61768,6)|0;c[j>>2]=(c[j>>2]|0)+1;c[h>>2]=c[j>>2];continue}if((d[c[j>>2]>>0]|0|0)!=37){c[j>>2]=(c[j>>2]|0)+1;continue}if((c[h>>2]|0)!=(c[j>>2]|0))nj(c[f>>2]|0,c[h>>2]|0,(c[j>>2]|0)-(c[h>>2]|0)|0)|0;nj(c[f>>2]|0,61776,6)|0;c[j>>2]=(c[j>>2]|0)+1;c[h>>2]=c[j>>2]}if((c[h>>2]|0)!=(c[j>>2]|0))nj(c[f>>2]|0,c[h>>2]|0,(c[j>>2]|0)-(c[h>>2]|0)|0)|0;pj(c[f>>2]|0,61760)|0;i=e;return}function pd(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=0;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+32>>2]|0)c[e>>2]=c[(c[(c[d>>2]|0)+32>>2]|0)+80>>2];if(((c[(c[d>>2]|0)+12>>2]|0)!=0?(c[(c[d>>2]|0)+68>>2]|0)==1:0)?(c[d>>2]|0)==(c[(c[(c[d>>2]|0)+12>>2]|0)+20>>2]|0):0)Uh(c[(c[d>>2]|0)+12>>2]|0);a=(c[(c[d>>2]|0)+8>>2]|0)!=0;if(c[e>>2]|0){if(a?(CP(c[e>>2]|0,c[(c[d>>2]|0)+8>>2]|0)|0)==0:0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+8>>2]|0);if((c[(c[d>>2]|0)+52>>2]|0)!=0?(CP(c[e>>2]|0,c[(c[d>>2]|0)+52>>2]|0)|0)==0:0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+52>>2]|0);if((c[(c[d>>2]|0)+56>>2]|0)!=0?(CP(c[e>>2]|0,c[(c[d>>2]|0)+56>>2]|0)|0)==0:0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+56>>2]|0);if((c[(c[d>>2]|0)+64>>2]|0)!=0?(CP(c[e>>2]|0,c[(c[d>>2]|0)+64>>2]|0)|0)==0:0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+64>>2]|0);if((c[(c[d>>2]|0)+40>>2]|0)!=0?(CP(c[e>>2]|0,c[(c[d>>2]|0)+40>>2]|0)|0)==0:0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+40>>2]|0);if((c[(c[d>>2]|0)+36>>2]|0)!=0?(CP(c[e>>2]|0,c[(c[d>>2]|0)+36>>2]|0)|0)==0:0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+36>>2]|0)}else{if(a)zb[c[135736>>2]&511](c[(c[d>>2]|0)+8>>2]|0);if(c[(c[d>>2]|0)+52>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+52>>2]|0);if(c[(c[d>>2]|0)+56>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+56>>2]|0);if(c[(c[d>>2]|0)+64>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+64>>2]|0);if(c[(c[d>>2]|0)+40>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+40>>2]|0);if(c[(c[d>>2]|0)+36>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+36>>2]|0)}zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function qd(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;h=i;i=i+48|0;j=h+36|0;k=h+32|0;l=h+28|0;m=h+24|0;n=h+20|0;o=h+16|0;p=h+12|0;q=h+8|0;r=h+4|0;s=h;c[k>>2]=b;c[l>>2]=e;
c[m>>2]=f;c[n>>2]=g;c[o>>2]=c[k>>2];c[p>>2]=c[m>>2];if((c[k>>2]|0)==0|(c[m>>2]|0)==0|(c[l>>2]|0)==0|(c[n>>2]|0)==0){c[j>>2]=-1;t=c[j>>2]|0;i=h;return t|0}c[q>>2]=(c[k>>2]|0)+(c[c[l>>2]>>2]|0);c[r>>2]=(c[m>>2]|0)+(c[c[n>>2]>>2]|0);c[s>>2]=c[r>>2];a:while(1){if((c[m>>2]|0)>>>0<(c[r>>2]|0)>>>0)u=(c[k>>2]|0)>>>0<((c[q>>2]|0)+-1|0)>>>0;else u=0;v=c[m>>2]|0;if(!u)break;if((d[v>>0]|0|0)>=128){g=((d[c[m>>2]>>0]|0)>>6&31|192)&255;f=c[k>>2]|0;c[k>>2]=f+1;a[f>>0]=g;g=((d[c[m>>2]>>0]|0)&63|128)&255;f=c[k>>2]|0;c[k>>2]=f+1;a[f>>0]=g;c[m>>2]=(c[m>>2]|0)+1}if(((c[s>>2]|0)-(c[m>>2]|0)|0)>((c[q>>2]|0)-(c[k>>2]|0)|0))c[s>>2]=(c[m>>2]|0)+((c[q>>2]|0)-(c[k>>2]|0));while(1){if((c[m>>2]|0)>>>0>=(c[s>>2]|0)>>>0)continue a;if((d[c[m>>2]>>0]|0|0)>=128)continue a;g=c[m>>2]|0;c[m>>2]=g+1;f=a[g>>0]|0;g=c[k>>2]|0;c[k>>2]=g+1;a[g>>0]=f}}if((v>>>0<(c[r>>2]|0)>>>0?(c[k>>2]|0)>>>0<(c[q>>2]|0)>>>0:0)?(d[c[m>>2]>>0]|0|0)<128:0){q=c[m>>2]|0;c[m>>2]=q+1;r=a[q>>0]|0;q=c[k>>2]|0;c[k>>2]=q+1;a[q>>0]=r}c[c[l>>2]>>2]=(c[k>>2]|0)-(c[o>>2]|0);c[c[n>>2]>>2]=(c[m>>2]|0)-(c[p>>2]|0);c[j>>2]=c[c[l>>2]>>2];t=c[j>>2]|0;i=h;return t|0}function rd(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;h=i;i=i+64|0;j=h+48|0;k=h+44|0;l=h+40|0;m=h+36|0;n=h+32|0;o=h+28|0;p=h+24|0;q=h+20|0;r=h+16|0;s=h+12|0;t=h+8|0;u=h+4|0;v=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;c[o>>2]=c[m>>2];c[q>>2]=c[k>>2];c[r>>2]=c[m>>2];if((c[k>>2]|0)==0|(c[l>>2]|0)==0|(c[n>>2]|0)==0){c[j>>2]=-1;w=c[j>>2]|0;i=h;return w|0}if(!(c[m>>2]|0)){c[c[l>>2]>>2]=0;c[c[n>>2]>>2]=0;c[j>>2]=0;w=c[j>>2]|0;i=h;return w|0}c[s>>2]=(c[m>>2]|0)+(c[c[n>>2]>>2]|0);c[p>>2]=(c[k>>2]|0)+(c[c[l>>2]>>2]|0);a:while(1){if((c[m>>2]|0)>>>0>=(c[s>>2]|0)>>>0){x=28;break}g=c[m>>2]|0;c[m>>2]=g+1;c[u>>2]=d[g>>0];g=c[u>>2]|0;do if((c[u>>2]|0)>>>0<128){c[t>>2]=g;c[v>>2]=0}else{if(g>>>0<192){x=10;break a}f=c[u>>2]|0;if((c[u>>2]|0)>>>0<224){c[t>>2]=f&31;c[v>>2]=1;break}e=c[u>>2]|0;if(f>>>0<240){c[t>>2]=e&15;c[v>>2]=2;break}if(e>>>0>=248){x=17;break a}c[t>>2]=c[u>>2]&7;c[v>>2]=3}while(0);if(((c[s>>2]|0)-(c[m>>2]|0)|0)<(c[v>>2]|0)){x=28;break}while(1){if(!(c[v>>2]|0))break;if((c[m>>2]|0)>>>0>=(c[s>>2]|0)>>>0)break;g=c[m>>2]|0;c[m>>2]=g+1;e=d[g>>0]|0;c[u>>2]=e;if((e&192|0)!=128){x=22;break a}c[t>>2]=c[t>>2]<<6;c[t>>2]=c[t>>2]|c[u>>2]&63;c[v>>2]=(c[v>>2]|0)+-1}y=c[k>>2]|0;if((c[t>>2]|0)>>>0>255){x=27;break}if(y>>>0>=(c[p>>2]|0)>>>0){x=28;break}e=c[t>>2]&255;g=c[k>>2]|0;c[k>>2]=g+1;a[g>>0]=e;c[o>>2]=c[m>>2]}if((x|0)==10){c[c[l>>2]>>2]=(c[k>>2]|0)-(c[q>>2]|0);c[c[n>>2]>>2]=(c[o>>2]|0)-(c[r>>2]|0);c[j>>2]=-2;w=c[j>>2]|0;i=h;return w|0}else if((x|0)==17){c[c[l>>2]>>2]=(c[k>>2]|0)-(c[q>>2]|0);c[c[n>>2]>>2]=(c[o>>2]|0)-(c[r>>2]|0);c[j>>2]=-2;w=c[j>>2]|0;i=h;return w|0}else if((x|0)==22){c[c[l>>2]>>2]=(c[k>>2]|0)-(c[q>>2]|0);c[c[n>>2]>>2]=(c[o>>2]|0)-(c[r>>2]|0);c[j>>2]=-2;w=c[j>>2]|0;i=h;return w|0}else if((x|0)==27){c[c[l>>2]>>2]=y-(c[q>>2]|0);c[c[n>>2]>>2]=(c[o>>2]|0)-(c[r>>2]|0);c[j>>2]=-2;w=c[j>>2]|0;i=h;return w|0}else if((x|0)==28){c[c[l>>2]>>2]=(c[k>>2]|0)-(c[q>>2]|0);c[c[n>>2]>>2]=(c[o>>2]|0)-(c[r>>2]|0);c[j>>2]=c[c[l>>2]>>2];w=c[j>>2]|0;i=h;return w|0}return 0}function sd(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[g>>2]=a;c[h>>2]=b;if(!(c[g>>2]|0)){c[f>>2]=0;j=c[f>>2]|0;i=e;return j|0}if((c[h>>2]|0)>=4){if((((d[c[g>>2]>>0]|0|0)==0?(d[(c[g>>2]|0)+1>>0]|0|0)==0:0)?(d[(c[g>>2]|0)+2>>0]|0|0)==0:0)?(d[(c[g>>2]|0)+3>>0]|0|0)==60:0){c[f>>2]=5;j=c[f>>2]|0;i=e;return j|0}if((((d[c[g>>2]>>0]|0|0)==60?(d[(c[g>>2]|0)+1>>0]|0|0)==0:0)?(d[(c[g>>2]|0)+2>>0]|0|0)==0:0)?(d[(c[g>>2]|0)+3>>0]|0|0)==0:0){c[f>>2]=4;j=c[f>>2]|0;i=e;return j|0}if((((d[c[g>>2]>>0]|0|0)==0?(d[(c[g>>2]|0)+1>>0]|0|0)==0:0)?(d[(c[g>>2]|0)+2>>0]|0|0)==60:0)?(d[(c[g>>2]|0)+3>>0]|0|0)==0:0){c[f>>2]=7;j=c[f>>2]|0;i=e;return j|0}if((((d[c[g>>2]>>0]|0|0)==0?(d[(c[g>>2]|0)+1>>0]|0|0)==60:0)?(d[(c[g>>2]|0)+2>>0]|0|0)==0:0)?(d[(c[g>>2]|0)+3>>0]|0|0)==0:0){c[f>>2]=8;j=c[f>>2]|0;i=e;return j|0}if((((d[c[g>>2]>>0]|0|0)==76?(d[(c[g>>2]|0)+1>>0]|0|0)==111:0)?(d[(c[g>>2]|0)+2>>0]|0|0)==167:0)?(d[(c[g>>2]|0)+3>>0]|0|0)==148:0){c[f>>2]=6;j=c[f>>2]|0;i=e;return j|0}if((((d[c[g>>2]>>0]|0|0)==60?(d[(c[g>>2]|0)+1>>0]|0|0)==63:0)?(d[(c[g>>2]|0)+2>>0]|0|0)==120:0)?(d[(c[g>>2]|0)+3>>0]|0|0)==109:0){c[f>>2]=1;j=c[f>>2]|0;i=e;return j|0}if((((d[c[g>>2]>>0]|0|0)==60?(d[(c[g>>2]|0)+1>>0]|0|0)==0:0)?(d[(c[g>>2]|0)+2>>0]|0|0)==63:0)?(d[(c[g>>2]|0)+3>>0]|0|0)==0:0){c[f>>2]=2;j=c[f>>2]|0;i=e;return j|0}if((((d[c[g>>2]>>0]|0|0)==0?(d[(c[g>>2]|0)+1>>0]|0|0)==60:0)?(d[(c[g>>2]|0)+2>>0]|0|0)==0:0)?(d[(c[g>>2]|0)+3>>0]|0|0)==63:0){c[f>>2]=3;j=c[f>>2]|0;i=e;return j|0}}if((((c[h>>2]|0)>=3?(d[c[g>>2]>>0]|0|0)==239:0)?(d[(c[g>>2]|0)+1>>0]|0|0)==187:0)?(d[(c[g>>2]|0)+2>>0]|0|0)==191:0){c[f>>2]=1;j=c[f>>2]|0;i=e;return j|0}if((c[h>>2]|0)>=2){if((d[c[g>>2]>>0]|0|0)==254?(d[(c[g>>2]|0)+1>>0]|0|0)==255:0){c[f>>2]=3;j=c[f>>2]|0;i=e;return j|0}if((d[c[g>>2]>>0]|0|0)==255?(d[(c[g>>2]|0)+1>>0]|0|0)==254:0){c[f>>2]=2;j=c[f>>2]|0;i=e;return j|0}}c[f>>2]=0;j=c[f>>2]|0;i=e;return j|0}function td(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(c[15520]|0)){i=a;return}c[b>>2]=0;while(1){if((c[b>>2]|0)>=(c[15522]|0))break;if(c[(c[15520]|0)+(c[b>>2]<<3)>>2]|0)zb[c[135736>>2]&511](c[(c[15520]|0)+(c[b>>2]<<3)>>2]|0);if(c[(c[15520]|0)+(c[b>>2]<<3)+4>>2]|0)zb[c[135736>>2]&511](c[(c[15520]|0)+(c[b>>2]<<3)+4>>2]|0);c[b>>2]=(c[b>>2]|0)+1}c[15522]=0;c[15524]=0;zb[c[135736>>2]&511](c[15520]|0);c[15520]=0;i=a;return}function ud(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+112|0;e=d+8|0;f=d+4|0;g=d;h=d+12|0;c[f>>2]=b;if(!(c[f>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}if(!(c[15520]|0)){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}c[g>>2]=0;while(1){if((c[g>>2]|0)>=99)break;b=(WS(a[(c[f>>2]|0)+(c[g>>2]|0)>>0]|0)|0)&255;a[h+(c[g>>2]|0)>>0]=b;if(!(a[h+(c[g>>2]|0)>>0]|0))break;c[g>>2]=(c[g>>2]|0)+1}a[h+(c[g>>2]|0)>>0]=0;c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[15522]|0)){k=14;break}f=(PT(c[(c[15520]|0)+(c[g>>2]<<3)+4>>2]|0,h)|0)!=0;l=c[g>>2]|0;if(!f){k=12;break}c[g>>2]=l+1}if((k|0)==12){c[e>>2]=c[(c[15520]|0)+(l<<3)>>2];j=c[e>>2]|0;i=d;return j|0}else if((k|0)==14){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}return 0}function vd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+128|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;k=e+16|0;c[g>>2]=b;c[h>>2]=d;if((c[g>>2]|0)==0|(c[h>>2]|0)==0){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}c[j>>2]=0;while(1){if((c[j>>2]|0)>=99)break;d=(WS(a[(c[h>>2]|0)+(c[j>>2]|0)>>0]|0)|0)&255;a[k+(c[j>>2]|0)>>0]=d;if(!(a[k+(c[j>>2]|0)>>0]|0))break;c[j>>2]=(c[j>>2]|0)+1}a[k+(c[j>>2]|0)>>0]=0;if(!(c[15520]|0)){c[15522]=0;c[15524]=20;c[15520]=Cb[c[135744>>2]&511](c[15524]<<3)|0;if(!(c[15520]|0)){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}}else if((c[15522]|0)>=(c[15524]|0)){c[15524]=c[15524]<<1;c[15520]=Hb[c[135760>>2]&511](c[15520]|0,c[15524]<<3)|0}c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[15522]|0)){m=17;break}if(!(PT(c[(c[15520]|0)+(c[j>>2]<<3)+4>>2]|0,k)|0)){m=15;break}c[j>>2]=(c[j>>2]|0)+1}if((m|0)==15){zb[c[135736>>2]&511](c[(c[15520]|0)+(c[j>>2]<<3)>>2]|0);h=Cb[c[135768>>2]&511](c[g>>2]|0)|0;c[(c[15520]|0)+(c[j>>2]<<3)>>2]=h;c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}else if((m|0)==17){m=Cb[c[135768>>2]&511](c[g>>2]|0)|0;c[(c[15520]|0)+(c[15522]<<3)>>2]=m;m=Cb[c[135768>>2]&511](k)|0;c[(c[15520]|0)+(c[15522]<<3)+4>>2]=m;c[15522]=(c[15522]|0)+1;c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}return 0}function wd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+528|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d+16|0;j=d;c[f>>2]=b;do if(c[f>>2]|0){c[g>>2]=ud(c[f>>2]|0)|0;if(c[g>>2]|0)c[f>>2]=c[g>>2];c[j>>2]=0;while(1){if((c[j>>2]|0)>=499)break;b=(WS(a[(c[f>>2]|0)+(c[j>>2]|0)>>0]|0)|0)&255;a[h+(c[j>>2]|0)>>0]=b;if(!(a[h+(c[j>>2]|0)>>0]|0))break;c[j>>2]=(c[j>>2]|0)+1}a[h+(c[j>>2]|0)>>0]=0;if(!(PT(h,62104)|0)){c[e>>2]=0;break}if(!(PT(h,62112)|0)){c[e>>2]=1;break}if(!(PT(h,62120)|0)){c[e>>2]=1;break}if(!(PT(h,62128)|0)){c[e>>2]=2;break}if(!(PT(h,62136)|0)){c[e>>2]=2;break}if(!(PT(h,62144)|0)){c[e>>2]=9;break}if(!(PT(h,62160)|0)){c[e>>2]=9;break}if(!(PT(h,62168)|0)){c[e>>2]=9;break}if(!(PT(h,62176)|0)){c[e>>2]=4;break}if(!(PT(h,62192)|0)){c[e>>2]=4;break}if(!(PT(h,62200)|0)){c[e>>2]=4;break}if(!(PT(h,62208)|0)){c[e>>2]=10;break}if(!(PT(h,62224)|0)){c[e>>2]=10;break}if(!(PT(h,62240)|0)){c[e>>2]=10;break}if(!(PT(h,62256)|0)){c[e>>2]=11;break}if(!(PT(h,62272)|0)){c[e>>2]=11;break}if(!(PT(h,62288)|0)){c[e>>2]=11;break}if(!(PT(h,62304)|0)){c[e>>2]=12;break}if(!(PT(h,62320)|0)){c[e>>2]=13;break}if(!(PT(h,62336)|0)){c[e>>2]=14;break}if(!(PT(h,62352)|0)){c[e>>2]=15;break}if(!(PT(h,62368)|0)){c[e>>2]=16;break}if(!(PT(h,62384)|0)){c[e>>2]=17;break}if(!(PT(h,62400)|0)){c[e>>2]=18;break}if(!(PT(h,62416)|0)){c[e>>2]=19;break}if(!(PT(h,62432)|0)){c[e>>2]=20;break}if(PT(h,62448)|0){c[e>>2]=-1;break}else{c[e>>2]=21;break}}else c[e>>2]=0;while(0);i=d;return c[e>>2]|0}function xd(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;do switch(c[e>>2]|0){case 4:{c[d>>2]=62176;break}case 10:{c[d>>2]=62208;break}case 20:{c[d>>2]=62464;break}case 3:{c[d>>2]=62128;break}case 15:{c[d>>2]=62352;break}case 12:{c[d>>2]=62304;break}case 6:{c[d>>2]=62456;break}case 21:{c[d>>2]=62448;break}case 13:{c[d>>2]=62320;break}case 19:{c[d>>2]=62416;break}case 7:{c[d>>2]=62176;break}case 5:{c[d>>2]=62176;break}case 1:{c[d>>2]=62112;break}case 9:{c[d>>2]=62144;break}case 11:{c[d>>2]=62256;break}case 8:{c[d>>2]=62176;break}case 17:{c[d>>2]=62384;break}case 14:{c[d>>2]=62336;break}case 18:{c[d>>2]=62400;break}case-1:{c[d>>2]=0;break}case 16:{c[d>>2]=62368;break}case 22:{c[d>>2]=0;break}case 0:{c[d>>2]=0;break}case 2:{c[d>>2]=62128;break}default:c[d>>2]=0}while(0);i=b;return c[d>>2]|0}function yd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+544|0;g=f+28|0;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f+32|0;o=f+4|0;p=f;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[p>>2]=0;c[m>>2]=ud(c[h>>2]|0)|0;if(c[m>>2]|0)c[h>>2]=c[m>>2];if(!(c[h>>2]|0)){Id(6e3,62480,0);c[g>>2]=0;q=c[g>>2]|0;i=f;return q|0}c[o>>2]=0;while(1){if((c[o>>2]|0)>=499)break;m=(WS(a[(c[h>>2]|0)+(c[o>>2]|0)>>0]|0)|0)&255;a[n+(c[o>>2]|0)>>0]=m;if(!(a[n+(c[o>>2]|0)>>0]|0))break;c[o>>2]=(c[o>>2]|0)+1}a[n+(c[o>>2]|0)>>0]=0;c[p>>2]=Cb[c[135768>>2]&511](n)|0;if(!(c[p>>2]|0)){Jd(62520);c[g>>2]=0;q=c[g>>2]|0;i=f;return q|0}c[l>>2]=Cb[c[135744>>2]&511](20)|0;if(!(c[l>>2]|0)){zb[c[135736>>2]&511](c[p>>2]|0);Jd(62520);c[g>>2]=0;q=c[g>>2]|0;i=f;return q|0}else{n=c[l>>2]|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[n+16>>2]=0;c[(c[l>>2]|0)+4>>2]=c[j>>2];c[(c[l>>2]|0)+8>>2]=c[k>>2];c[c[l>>2]>>2]=c[p>>2];c[(c[l>>2]|0)+12>>2]=0;c[(c[l>>2]|0)+16>>2]=0;zd(c[l>>2]|0);c[g>>2]=c[l>>2];q=c[g>>2]|0;i=f;return q|0}return 0}function zd(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[15642]|0))Ad();if((c[d>>2]|0)==0|(c[15642]|0)==0){Id(6001,62768,0);i=b;return}if((c[15688]|0)>=50){Id(6002,62816,62888);i=b;return}else{a=c[d>>2]|0;d=c[15688]|0;c[15688]=d+1;c[(c[15642]|0)+(d<<2)>>2]=a;i=b;return}}function Ad(){var a=0,e=0,f=0;a=i;i=i+16|0;e=a+4|0;f=a;b[e>>1]=4660;c[f>>2]=e;if(c[15642]|0){i=a;return}c[15642]=Cb[c[135744>>2]&511](200)|0;do if((d[c[f>>2]>>0]|0|0)!=18)if((d[c[f>>2]>>0]|0|0)==52){c[15644]=1;break}else{Id(1,62584,0);break}else c[15644]=0;while(0);if(!(c[15642]|0)){Jd(62624);i=a;return}else{yd(62112,213,213)|0;c[15672]=yd(62672,214,215)|0;c[15678]=yd(62696,216,217)|0;yd(62128,214,218)|0;yd(62208,219,220)|0;yd(62720,221,222)|0;yd(62728,221,222)|0;yd(62744,0,223)|0;i=a;return}}function Bd(){var a=0;a=i;td();if(!(c[15642]|0)){i=a;return}while(1){if((c[15688]|0)<=0)break;c[15688]=(c[15688]|0)+-1;if(!(c[(c[15642]|0)+(c[15688]<<2)>>2]|0))continue;if(c[c[(c[15642]|0)+(c[15688]<<2)>>2]>>2]|0)zb[c[135736>>2]&511](c[c[(c[15642]|0)+(c[15688]<<2)>>2]>>2]|0);zb[c[135736>>2]&511](c[(c[15642]|0)+(c[15688]<<2)>>2]|0)}zb[c[135736>>2]&511](c[15642]|0);c[15642]=0;c[15688]=0;c[15690]=0;i=a;return}function Cd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if(!(c[15642]|0))Ad();a:do switch(c[e>>2]|0){case 6:{c[f>>2]=Dd(62456)|0;if(c[f>>2]|0){c[d>>2]=c[f>>2];break a}c[f>>2]=Dd(62912)|0;if(c[f>>2]|0){c[d>>2]=c[f>>2];break a}c[f>>2]=Dd(62920)|0;if(c[f>>2]|0){c[d>>2]=c[f>>2];break a}c[f>>2]=Dd(62936)|0;if(c[f>>2]|0)c[d>>2]=c[f>>2];else g=63;break}case 2:{c[d>>2]=c[15672];break}case 9:{c[f>>2]=Dd(62144)|0;if(c[f>>2]|0){c[d>>2]=c[f>>2];break a}c[f>>2]=Dd(62160)|0;if(c[f>>2]|0){c[d>>2]=c[f>>2];break a}c[f>>2]=Dd(62168)|0;if(c[f>>2]|0)c[d>>2]=c[f>>2];else g=63;break}case 18:{c[f>>2]=Dd(62400)|0;if(c[f>>2]|0)c[d>>2]=c[f>>2];else g=63;break}case 3:{c[d>>2]=c[15678];break}case 10:{c[f>>2]=Dd(62208)|0;if(c[f>>2]|0)c[d>>2]=c[f>>2];else g=63;break}case-1:{c[d>>2]=0;break}case 12:{c[f>>2]=Dd(62304)|0;if(c[f>>2]|0)c[d>>2]=c[f>>2];else g=63;break}case 5:{c[f>>2]=Dd(62176)|0;if(c[f>>2]|0){c[d>>2]=c[f>>2];break a}c[f>>2]=Dd(62192)|0;if(c[f>>2]|0){c[d>>2]=c[f>>2];break a}c[f>>2]=Dd(62200)|0;if(c[f>>2]|0)c[d>>2]=c[f>>2];else g=63;break}case 14:{c[f>>2]=Dd(62336)|0;if(c[f>>2]|0)c[d>>2]=c[f>>2];else g=63;break}case 19:{c[f>>2]=Dd(62416)|0;if(c[f>>2]|0)c[d>>2]=c[f>>2];else g=63;break}case 20:{c[f>>2]=Dd(62944)|0;if(c[f>>2]|0){c[d>>2]=c[f>>2];break a}c[f>>2]=Dd(62432)|0;if(c[f>>2]|0){c[d>>2]=c[f>>2];break a}c[f>>2]=Dd(62960)|0;if(c[f>>2]|0)c[d>>2]=c[f>>2];else g=63;break}case 11:{c[f>>2]=Dd(62256)|0;if(c[f>>2]|0)c[d>>2]=c[f>>2];else g=63;break}case 0:{c[d>>2]=0;break}case 17:{c[f>>2]=Dd(62384)|0;if(c[f>>2]|0)c[d>>2]=c[f>>2];else g=63;break}case 15:{c[f>>2]=Dd(62352)|0;if(c[f>>2]|0)c[d>>2]=c[f>>2];else g=63;break}case 16:{c[f>>2]=Dd(62368)|0;if(c[f>>2]|0)c[d>>2]=c[f>>2];else g=63;break}case 13:{c[f>>2]=Dd(62320)|0;if(c[f>>2]|0)c[d>>2]=c[f>>2];else g=63;break}case 21:{c[f>>2]=Dd(62448)|0;if(c[f>>2]|0)c[d>>2]=c[f>>2];else g=63;break}case 1:{c[d>>2]=0;break}case 4:{c[f>>2]=Dd(62176)|0;if(c[f>>2]|0){c[d>>2]=c[f>>2];break a}c[f>>2]=Dd(62192)|0;if(c[f>>2]|0){c[d>>2]=c[f>>2];break a}c[f>>2]=Dd(62200)|0;if(c[f>>2]|0)c[d>>2]=c[f>>2];else g=63;break}default:g=63}while(0);if((g|0)==63)c[d>>2]=0;i=b;return c[d>>2]|0}function Dd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+144|0;e=d+36|0;f=d+32|0;g=d+28|0;h=d+24|0;j=d+20|0;k=d+16|0;l=d+12|0;m=d+8|0;n=d+40|0;o=d+4|0;p=d;c[f>>2]=b;if(!(c[15642]|0))Ad();if(!(c[f>>2]|0)){c[e>>2]=c[15690];q=c[e>>2]|0;i=d;return q|0}if(!(a[c[f>>2]>>0]|0)){c[e>>2]=c[15690];q=c[e>>2]|0;i=d;return q|0}c[h>>2]=c[f>>2];c[g>>2]=ud(c[f>>2]|0)|0;if(c[g>>2]|0)c[f>>2]=c[g>>2];c[o>>2]=0;while(1){if((c[o>>2]|0)>=99)break;g=(WS(a[(c[f>>2]|0)+(c[o>>2]|0)>>0]|0)|0)&255;a[n+(c[o>>2]|0)>>0]=g;if(!(a[n+(c[o>>2]|0)>>0]|0))break;c[o>>2]=(c[o>>2]|0)+1}a[n+(c[o>>2]|0)>>0]=0;a:do if(c[15642]|0){c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[15688]|0))break a;g=(PT(n,c[c[(c[15642]|0)+(c[o>>2]<<2)>>2]>>2]|0)|0)!=0;r=c[o>>2]|0;if(!g)break;c[o>>2]=r+1}c[e>>2]=c[(c[15642]|0)+(r<<2)>>2];q=c[e>>2]|0;i=d;return q|0}while(0);c[l>>2]=XS(62112,c[f>>2]|0)|0;c[m>>2]=XS(c[f>>2]|0,62112)|0;if((c[l>>2]|0)==(-1|0))c[l>>2]=XS(62112,n)|0;if((c[m>>2]|0)==(-1|0))c[m>>2]=XS(n,62112)|0;if((c[l>>2]|0)!=(-1|0)&(c[m>>2]|0)!=(-1|0)){c[k>>2]=Cb[c[135744>>2]&511](20)|0;if(!(c[k>>2]|0)){c[e>>2]=0;q=c[e>>2]|0;i=d;return q|0}else{n=c[k>>2]|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[n+16>>2]=0;n=Cb[c[135768>>2]&511](c[f>>2]|0)|0;c[c[k>>2]>>2]=n;c[(c[k>>2]|0)+4>>2]=0;c[(c[k>>2]|0)+8>>2]=0;c[(c[k>>2]|0)+12>>2]=c[l>>2];c[(c[k>>2]|0)+16>>2]=c[m>>2];c[e>>2]=c[k>>2];q=c[e>>2]|0;i=d;return q|0}}if((c[l>>2]|0)!=(-1|0)|(c[m>>2]|0)!=(-1|0))Id(1,62976,c[f>>2]|0);c[j>>2]=wd(c[h>>2]|0)|0;if(((c[j>>2]|0)!=-1?(c[p>>2]=xd(c[j>>2]|0)|0,(c[p>>2]|0)!=0):0)?(PT(c[f>>2]|0,c[p>>2]|0)|0)!=0:0){c[e>>2]=Dd(c[p>>2]|0)|0;q=c[e>>2]|0;i=d;return q|0}c[e>>2]=0;q=c[e>>2]|0;i=d;return q|0}function Ed(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+112|0;g=f;h=f+56|0;j=f+52|0;k=f+48|0;l=f+44|0;m=f+40|0;n=f+36|0;o=f+32|0;p=f+28|0;q=f+24|0;r=f+20|0;s=f+60|0;t=f+16|0;c[j>>2]=b;c[k>>2]=e;c[l>>2]=-2;if((((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+12>>2]|0)!=0:0)?(c[(c[j>>2]|0)+16>>2]|0)!=0:0)?(c[(c[j>>2]|0)+20>>2]|0)!=0:0){c[r>>2]=c[(c[j>>2]|0)+16>>2];c[q>>2]=c[(c[j>>2]|0)+20>>2];c[n>>2]=_y(c[q>>2]|0)|0;if(!(c[n>>2]|0)){c[h>>2]=0;u=c[h>>2]|0;i=f;return u|0}c[m>>2]=($y(c[r>>2]|0)|0)-1;e=c[n>>2]|0;if((c[k>>2]|0)>=0){if(e>>>0>(c[k>>2]|0)>>>0)c[n>>2]=c[k>>2]}else if(e>>>0>180)c[n>>2]=180;if(c[n>>2]<<1>>>0>=(c[m>>2]|0)>>>0){Uy(c[r>>2]|0,c[n>>2]<<1)|0;c[m>>2]=($y(c[r>>2]|0)|0)-1}if((c[m>>2]|0)>>>0>360)c[m>>2]=360;c[o>>2]=c[n>>2];c[p>>2]=c[m>>2];m=c[(c[j>>2]|0)+12>>2]|0;if(!(c[(c[(c[j>>2]|0)+12>>2]|0)+4>>2]|0)){if((c[m+12>>2]|0)!=0?(n=c[(c[(c[j>>2]|0)+12>>2]|0)+12>>2]|0,j=Wy(c[r>>2]|0)|0,c[l>>2]=Sd(n,j,p,Vy(c[q>>2]|0)|0,o)|0,Ty(c[q>>2]|0,c[o>>2]|0)|0,Xy(c[r>>2]|0,c[p>>2]|0)|0,(c[l>>2]|0)==-1):0)c[l>>2]=-3}else{j=c[m+4>>2]|0;m=Wy(c[r>>2]|0)|0;n=Vy(c[q>>2]|0)|0;c[l>>2]=Fb[j&511](m,p,n,o)|0;Ty(c[q>>2]|0,c[o>>2]|0)|0;Xy(c[r>>2]|0,c[p>>2]|0)|0}if((c[l>>2]|0)==-2){c[t>>2]=Vy(c[q>>2]|0)|0;q=d[(c[t>>2]|0)+1>>0]|0;p=d[(c[t>>2]|0)+2>>0]|0;r=d[(c[t>>2]|0)+3>>0]|0;c[g>>2]=d[c[t>>2]>>0];c[g+4>>2]=q;c[g+8>>2]=p;c[g+12>>2]=r;JT(s,49,63016,g)|0;a[s+49>>0]=0;Id(6003,63048,s)}if((c[l>>2]|0)==-3)c[l>>2]=0;if((c[l>>2]|0)==-1)c[l>>2]=0;c[h>>2]=c[l>>2];u=c[h>>2]|0;i=f;return u|0}c[h>>2]=-1;u=c[h>>2]|0;i=f;return u|0}function Fd(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+112|0;g=f;h=f+56|0;j=f+52|0;k=f+48|0;l=f+44|0;m=f+40|0;n=f+36|0;o=f+32|0;p=f+28|0;q=f+24|0;r=f+20|0;s=f+60|0;t=f+16|0;c[j>>2]=b;c[k>>2]=e;c[l>>2]=-2;if((((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+12>>2]|0)!=0:0)?(c[(c[j>>2]|0)+16>>2]|0)!=0:0)?(c[(c[j>>2]|0)+20>>2]|0)!=0:0){c[r>>2]=c[(c[j>>2]|0)+16>>2];c[q>>2]=c[(c[j>>2]|0)+20>>2];c[n>>2]=_y(c[q>>2]|0)|0;if(!(c[n>>2]|0)){c[h>>2]=0;u=c[h>>2]|0;i=f;return u|0}if((c[n>>2]|0)>>>0>65536&(c[k>>2]|0)==0)c[n>>2]=65536;c[m>>2]=$y(c[r>>2]|0)|0;if((c[m>>2]|0)>>>0>0)c[m>>2]=(c[m>>2]|0)+-1;if(c[n>>2]<<1>>>0>=(c[m>>2]|0)>>>0?(Uy(c[r>>2]|0,c[n>>2]<<1)|0,c[m>>2]=$y(c[r>>2]|0)|0,(c[m>>2]|0)>>>0>0):0)c[m>>2]=(c[m>>2]|0)+-1;if((c[m>>2]|0)>>>0>131072&(c[k>>2]|0)==0)c[m>>2]=131072;c[o>>2]=c[n>>2];c[p>>2]=c[m>>2];m=c[(c[j>>2]|0)+12>>2]|0;if(!(c[(c[(c[j>>2]|0)+12>>2]|0)+4>>2]|0)){if((c[m+12>>2]|0)!=0?(n=c[(c[(c[j>>2]|0)+12>>2]|0)+12>>2]|0,j=Wy(c[r>>2]|0)|0,c[l>>2]=Sd(n,j,p,Vy(c[q>>2]|0)|0,o)|0,Ty(c[q>>2]|0,c[o>>2]|0)|0,Xy(c[r>>2]|0,c[p>>2]|0)|0,(c[l>>2]|0)==-1):0)c[l>>2]=-3}else{j=c[m+4>>2]|0;m=Wy(c[r>>2]|0)|0;n=Vy(c[q>>2]|0)|0;c[l>>2]=Fb[j&511](m,p,n,o)|0;Ty(c[q>>2]|0,c[o>>2]|0)|0;Xy(c[r>>2]|0,c[p>>2]|0)|0}if((c[l>>2]|0)==-2){c[t>>2]=Vy(c[q>>2]|0)|0;q=d[(c[t>>2]|0)+1>>0]|0;r=d[(c[t>>2]|0)+2>>0]|0;o=d[(c[t>>2]|0)+3>>0]|0;c[g>>2]=d[c[t>>2]>>0];c[g+4>>2]=q;c[g+8>>2]=r;c[g+12>>2]=o;JT(s,49,63016,g)|0;a[s+49>>0]=0;Id(6003,63048,s)}if((c[l>>2]|0)==-3)c[l>>2]=0;c[h>>2]=(c[p>>2]|0)!=0?c[p>>2]|0:c[l>>2]|0;u=c[h>>2]|0;i=f;return u|0}c[h>>2]=-1;u=c[h>>2]|0;i=f;return u|0}function Gd(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;f=i;i=i+160|0;g=f;h=f+72|0;j=f+68|0;k=f+64|0;l=f+60|0;m=f+56|0;n=f+52|0;o=f+48|0;p=f+44|0;q=f+40|0;r=f+36|0;s=f+32|0;t=f+28|0;u=f+24|0;v=f+20|0;w=f+16|0;x=f+128|0;y=f+76|0;c[j>>2]=b;c[k>>2]=e;c[l>>2]=-2;c[n>>2]=0;c[t>>2]=0;if((((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+12>>2]|0)!=0:0)?(c[(c[j>>2]|0)+16>>2]|0)!=0:0)?(c[(c[j>>2]|0)+20>>2]|0)!=0:0){c[s>>2]=c[(c[j>>2]|0)+20>>2];c[r>>2]=c[(c[j>>2]|0)+16>>2];a:while(1){c[m>>2]=$y(c[s>>2]|0)|0;if((c[m>>2]|0)>>>0>0)c[m>>2]=(c[m>>2]|0)+-1;if(c[k>>2]|0){z=10;break}c[o>>2]=_y(c[r>>2]|0)|0;if(!(c[o>>2]|0)){z=17;break}if((c[o>>2]|0)>>>0>65536)c[o>>2]=65536;if(c[o>>2]<<2>>>0>=(c[m>>2]|0)>>>0){Uy(c[s>>2]|0,c[o>>2]<<2)|0;c[m>>2]=($y(c[s>>2]|0)|0)-1}if((c[m>>2]|0)>>>0>262144)c[m>>2]=262144;c[p>>2]=c[o>>2];c[q>>2]=c[m>>2];e=c[(c[j>>2]|0)+12>>2]|0;do if(c[(c[(c[j>>2]|0)+12>>2]|0)+8>>2]|0){b=c[e+8>>2]|0;A=Wy(c[s>>2]|0)|0;B=Vy(c[r>>2]|0)|0;c[l>>2]=Fb[b&511](A,q,B,p)|0;if((c[q>>2]|0)>0){Ty(c[r>>2]|0,c[p>>2]|0)|0;Xy(c[s>>2]|0,c[q>>2]|0)|0;c[n>>2]=(c[n>>2]|0)+(c[q>>2]|0)}}else{if(!(c[e+16>>2]|0)){z=32;break a}B=c[(c[(c[j>>2]|0)+12>>2]|0)+16>>2]|0;A=Wy(c[s>>2]|0)|0;c[l>>2]=Sd(B,A,q,Vy(c[r>>2]|0)|0,p)|0;Ty(c[r>>2]|0,c[p>>2]|0)|0;Xy(c[s>>2]|0,c[q>>2]|0)|0;c[n>>2]=(c[n>>2]|0)+(c[q>>2]|0);if((c[l>>2]|0)==-1)if((c[q>>2]|0)>0){c[t>>2]=0;continue a}else{c[l>>2]=-3;break}}while(0);if((c[l>>2]|0)>=0)c[j>>2]=(c[j>>2]|0)+(c[l>>2]<<5);if((c[l>>2]|0)!=-2)break;c[u>>2]=_y(c[r>>2]|0)|0;c[v>>2]=Vy(c[r>>2]|0)|0;c[w>>2]=Ey(c[v>>2]|0,u)|0;if((c[t>>2]|0)!=0?(c[q>>2]|0)<(c[t>>2]|0):0){z=38;break}if((c[w>>2]|0)<=0){z=41;break}c[g>>2]=c[w>>2];c[t>>2]=JT(x,20,63152,g)|0;Ty(c[r>>2]|0,c[u>>2]|0)|0;dz(c[r>>2]|0,x,-1)|0}if((z|0)==10){c[p>>2]=0;c[q>>2]=c[m>>2];m=c[(c[j>>2]|0)+12>>2]|0;if(c[(c[(c[j>>2]|0)+12>>2]|0)+8>>2]|0){x=c[m+8>>2]|0;u=Wy(c[s>>2]|0)|0;c[l>>2]=Fb[x&511](u,q,0,p)|0;if((c[l>>2]|0)>0)Xy(c[s>>2]|0,c[q>>2]|0)|0}else if(c[m+16>>2]|0){m=c[(c[(c[j>>2]|0)+12>>2]|0)+16>>2]|0;c[l>>2]=Sd(m,Wy(c[s>>2]|0)|0,q,0,p)|0;Xy(c[s>>2]|0,c[q>>2]|0)|0}c[h>>2]=0;C=c[h>>2]|0;i=f;return C|0}else if((z|0)==17){c[h>>2]=0;C=c[h>>2]|0;i=f;return C|0}else if((z|0)==32){Id(6004,63104,0);c[h>>2]=-1;C=c[h>>2]|0;i=f;return C|0}else if((z|0)==38){Yy(c[s>>2]|0,c[q>>2]|0)|0;c[n>>2]=(c[n>>2]|0)-(c[q>>2]|0);Ty(c[r>>2]|0,(c[t>>2]|0)-(c[q>>2]|0)|0)|0;c[t>>2]=0;c[l>>2]=-1}else if((z|0)==41?(z=d[(c[v>>2]|0)+1>>0]|0,t=d[(c[v>>2]|0)+2>>0]|0,q=d[(c[v>>2]|0)+3>>0]|0,c[g>>2]=d[c[v>>2]>>0],c[g+4>>2]=z,c[g+8>>2]=t,c[g+12>>2]=q,JT(y,49,63016,g)|0,a[y+49>>0]=0,Id(6003,63160,y),(Py(c[r>>2]|0)|0)!=2):0)a[c[v>>2]>>0]=32;c[h>>2]=c[l>>2];C=c[h>>2]|0;i=f;return C|0}c[h>>2]=-1;C=c[h>>2]|0;i=f;return C|0}function Hd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+32|0;d=b+20|0;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;j=b;c[e>>2]=a;c[f>>2]=0;c[g>>2]=0;c[j>>2]=0;if(!(c[e>>2]|0)){c[d>>2]=-1;k=c[d>>2]|0;i=b;return k|0}if(!(c[c[e>>2]>>2]|0)){c[d>>2]=-1;k=c[d>>2]|0;i=b;return k|0}a:do if(c[15642]|0){c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[15688]|0))break a;if((c[e>>2]|0)==(c[(c[15642]|0)+(c[h>>2]<<2)>>2]|0))break;c[h>>2]=(c[h>>2]|0)+1}c[j>>2]=1}while(0);do if(!(c[j>>2]|0)){if((c[(c[e>>2]|0)+16>>2]|0)==0?(c[(c[e>>2]|0)+12>>2]|0)==0:0)break;c[g>>2]=1;if(c[(c[e>>2]|0)+16>>2]|0){if(YS(c[(c[e>>2]|0)+16>>2]|0)|0)c[f>>2]=-1;c[(c[e>>2]|0)+16>>2]=0}if(c[(c[e>>2]|0)+12>>2]|0){if(YS(c[(c[e>>2]|0)+12>>2]|0)|0)c[f>>2]=-1;c[(c[e>>2]|0)+12>>2]=0}}while(0);if(c[g>>2]|0){if(c[c[e>>2]>>2]|0)zb[c[135736>>2]&511](c[c[e>>2]>>2]|0);c[c[e>>2]>>2]=0;zb[c[135736>>2]&511](c[e>>2]|0)}c[d>>2]=c[f>>2];k=c[d>>2]|0;i=b;return k|0}function Id(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;g=e+12|0;h=e+8|0;j=e+4|0;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;d=c[g>>2]|0;g=c[j>>2]|0;b=c[h>>2]|0;c[f>>2]=c[j>>2];Xd(0,0,0,0,0,27,d,3,0,0,g,0,0,0,0,b,f);i=e;return}function Jd(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;ce(27,2,0,0,c[d>>2]|0);i=b;return}function Kd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if((c[h>>2]|0)==0|(c[k>>2]|0)==0|(c[j>>2]|0)==0|(c[l>>2]|0)==0){c[g>>2]=-1;n=c[g>>2]|0;i=f;return n|0}if((c[c[j>>2]>>2]|0)>(c[c[l>>2]>>2]|0))c[m>>2]=c[c[l>>2]>>2];else c[m>>2]=c[c[j>>2]>>2];if((c[m>>2]|0)<0){c[g>>2]=-1;n=c[g>>2]|0;i=f;return n|0}else{eU(c[h>>2]|0,c[k>>2]|0,c[m>>2]|0)|0;c[c[j>>2]>>2]=c[m>>2];c[c[l>>2]>>2]=c[m>>2];c[g>>2]=c[c[j>>2]>>2];n=c[g>>2]|0;i=f;return n|0}return 0}function Ld(b,f,g,h){b=b|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;j=i;i=i+64|0;k=j+56|0;l=j+52|0;m=j+48|0;n=j+44|0;o=j+40|0;p=j+36|0;q=j+32|0;r=j+28|0;s=j+24|0;t=j+20|0;u=j+16|0;v=j+12|0;w=j+8|0;x=j+4|0;y=j;c[l>>2]=b;c[m>>2]=f;c[n>>2]=g;c[o>>2]=h;c[p>>2]=c[l>>2];c[q>>2]=c[n>>2];c[r>>2]=(c[l>>2]|0)+(c[c[m>>2]>>2]|0);c[s>>2]=c[n>>2];if(((c[c[o>>2]>>2]|0)%2|0|0)==1){h=c[o>>2]|0;c[h>>2]=(c[h>>2]|0)+-1}c[w>>2]=(c[c[o>>2]>>2]|0)/2|0;c[t>>2]=(c[s>>2]|0)+(c[w>>2]<<1);while(1){if((c[s>>2]|0)>>>0>=(c[t>>2]|0)>>>0){z=29;break}if(((c[l>>2]|0)-(c[p>>2]|0)+5|0)>=(c[c[m>>2]>>2]|0)){z=29;break}w=c[s>>2]|0;if(c[15644]|0){c[s>>2]=w+2;c[u>>2]=e[w>>1]}else{c[x>>2]=w;w=c[x>>2]|0;c[x>>2]=w+1;c[u>>2]=d[w>>0];c[u>>2]=c[u>>2]|(d[c[x>>2]>>0]|0)<<8;c[s>>2]=(c[s>>2]|0)+2}if((c[u>>2]&64512|0)==55296){if((c[s>>2]|0)>>>0>=(c[t>>2]|0)>>>0){z=29;break}w=c[s>>2]|0;if(c[15644]|0){c[s>>2]=w+2;c[v>>2]=e[w>>1]}else{c[x>>2]=w;w=c[x>>2]|0;c[x>>2]=w+1;c[v>>2]=d[w>>0];c[v>>2]=c[v>>2]|(d[c[x>>2]>>0]|0)<<8;c[s>>2]=(c[s>>2]|0)+2}if((c[v>>2]&64512|0)!=56320){z=16;break}c[u>>2]=c[u>>2]&1023;c[u>>2]=c[u>>2]<<10;c[u>>2]=c[u>>2]|c[v>>2]&1023;c[u>>2]=(c[u>>2]|0)+65536}if((c[l>>2]|0)>>>0>=(c[r>>2]|0)>>>0){z=29;break}w=c[u>>2]|0;do if((c[u>>2]|0)>>>0>=128){h=c[u>>2]|0;if(w>>>0<2048){g=c[l>>2]|0;c[l>>2]=g+1;a[g>>0]=h>>>6&31|192;c[y>>2]=0;break}g=c[u>>2]|0;if(h>>>0<65536){h=c[l>>2]|0;c[l>>2]=h+1;a[h>>0]=g>>>12&15|224;c[y>>2]=6;break}else{h=c[l>>2]|0;c[l>>2]=h+1;a[h>>0]=g>>>18&7|240;c[y>>2]=12;break}}else{g=c[l>>2]|0;c[l>>2]=g+1;a[g>>0]=w;c[y>>2]=-6}while(0);while(1){if((c[y>>2]|0)<0)break;if((c[l>>2]|0)>>>0>=(c[r>>2]|0)>>>0)break;w=((c[u>>2]|0)>>>(c[y>>2]|0)&63|128)&255;g=c[l>>2]|0;c[l>>2]=g+1;a[g>>0]=w;c[y>>2]=(c[y>>2]|0)-6}c[q>>2]=c[s>>2]}if((z|0)==16){c[c[m>>2]>>2]=(c[l>>2]|0)-(c[p>>2]|0);c[c[o>>2]>>2]=(c[q>>2]|0)-(c[n>>2]|0);c[k>>2]=-2;A=c[k>>2]|0;i=j;return A|0}else if((z|0)==29){c[c[m>>2]>>2]=(c[l>>2]|0)-(c[p>>2]|0);c[c[o>>2]>>2]=(c[q>>2]|0)-(c[n>>2]|0);c[k>>2]=c[c[m>>2]>>2];A=c[k>>2]|0;i=j;return A|0}return 0}function Md(f,g,h,j){f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;k=i;i=i+64|0;l=k+56|0;m=k+52|0;n=k+48|0;o=k+44|0;p=k+40|0;q=k+36|0;r=k+32|0;s=k+28|0;t=k+24|0;u=k+20|0;v=k+16|0;w=k+12|0;x=k+8|0;y=k+4|0;z=k;A=k+62|0;B=k+60|0;c[m>>2]=f;c[n>>2]=g;c[o>>2]=h;c[p>>2]=j;c[q>>2]=c[m>>2];c[r>>2]=c[o>>2];c[s>>2]=c[o>>2];c[t>>2]=c[q>>2];if((c[q>>2]|0)==0|(c[n>>2]|0)==0|(c[p>>2]|0)==0){c[l>>2]=-1;C=c[l>>2]|0;i=k;return C|0}if(!(c[o>>2]|0)){c[c[n>>2]>>2]=0;c[c[p>>2]>>2]=0;c[l>>2]=0;C=c[l>>2]|0;i=k;return C|0}c[v>>2]=(c[o>>2]|0)+(c[c[p>>2]>>2]|0);c[u>>2]=(c[q>>2]|0)+(((c[c[n>>2]>>2]|0)/2|0)<<1);a:while(1){if((c[o>>2]|0)>>>0>=(c[v>>2]|0)>>>0){D=34;break}m=c[o>>2]|0;c[o>>2]=m+1;c[x>>2]=d[m>>0];m=c[x>>2]|0;do if((c[x>>2]|0)>>>0<128){c[w>>2]=m;c[y>>2]=0}else{if(m>>>0<192){D=10;break a}j=c[x>>2]|0;if((c[x>>2]|0)>>>0<224){c[w>>2]=j&31;c[y>>2]=1;break}h=c[x>>2]|0;if(j>>>0<240){c[w>>2]=h&15;c[y>>2]=2;break}if(h>>>0>=248){D=17;break a}c[w>>2]=c[x>>2]&7;c[y>>2]=3}while(0);if(((c[v>>2]|0)-(c[o>>2]|0)|0)<(c[y>>2]|0)){D=34;break}while(1){if(!(c[y>>2]|0))break;if((c[o>>2]|0)>>>0>=(c[v>>2]|0)>>>0)break;m=c[o>>2]|0;c[o>>2]=m+1;h=d[m>>0]|0;c[x>>2]=h;if((h&192|0)!=128)break;c[w>>2]=c[w>>2]<<6;c[w>>2]=c[w>>2]|c[x>>2]&63;c[y>>2]=(c[y>>2]|0)+-1}do if((c[w>>2]|0)>>>0<65536){if((c[q>>2]|0)>>>0>=(c[u>>2]|0)>>>0){D=34;break a}if(c[15644]|0){h=c[w>>2]&65535;m=c[q>>2]|0;c[q>>2]=m+2;b[m>>1]=h;break}else{c[z>>2]=c[q>>2];a[c[z>>2]>>0]=c[w>>2];a[(c[z>>2]|0)+1>>0]=(c[w>>2]|0)>>>8;c[q>>2]=(c[q>>2]|0)+2;break}}else{if((c[w>>2]|0)>>>0>=1114112){D=34;break a}if(((c[q>>2]|0)+2|0)>>>0>=(c[u>>2]|0)>>>0){D=34;break a}c[w>>2]=(c[w>>2]|0)-65536;h=(55296|(c[w>>2]|0)>>>10)&65535;if(c[15644]|0){m=c[q>>2]|0;c[q>>2]=m+2;b[m>>1]=h;m=(56320|c[w>>2]&1023)&65535;j=c[q>>2]|0;c[q>>2]=j+2;b[j>>1]=m;break}else{b[A>>1]=h;c[z>>2]=c[q>>2];a[c[z>>2]>>0]=b[A>>1];a[(c[z>>2]|0)+1>>0]=(e[A>>1]|0)>>8;c[q>>2]=(c[q>>2]|0)+2;b[B>>1]=56320|c[w>>2]&1023;c[z>>2]=c[q>>2];a[c[z>>2]>>0]=b[B>>1];a[(c[z>>2]|0)+1>>0]=(e[B>>1]|0)>>8;c[q>>2]=(c[q>>2]|0)+2;break}}while(0);c[r>>2]=c[o>>2]}if((D|0)==10){c[c[n>>2]>>2]=(((c[q>>2]|0)-(c[t>>2]|0)|0)/2|0)<<1;c[c[p>>2]>>2]=(c[r>>2]|0)-(c[s>>2]|0);c[l>>2]=-2;C=c[l>>2]|0;i=k;return C|0}else if((D|0)==17){c[c[n>>2]>>2]=(((c[q>>2]|0)-(c[t>>2]|0)|0)/2|0)<<1;c[c[p>>2]>>2]=(c[r>>2]|0)-(c[s>>2]|0);c[l>>2]=-2;C=c[l>>2]|0;i=k;return C|0}else if((D|0)==34){c[c[n>>2]>>2]=(((c[q>>2]|0)-(c[t>>2]|0)|0)/2|0)<<1;c[c[p>>2]>>2]=(c[r>>2]|0)-(c[s>>2]|0);c[l>>2]=c[c[n>>2]>>2];C=c[l>>2]|0;i=k;return C|0}return 0}function Nd(b,f,g,h){b=b|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;j=i;i=i+64|0;k=j+56|0;l=j+52|0;m=j+48|0;n=j+44|0;o=j+40|0;p=j+36|0;q=j+32|0;r=j+28|0;s=j+24|0;t=j+20|0;u=j+16|0;v=j+12|0;w=j+8|0;x=j+4|0;y=j;c[l>>2]=b;c[m>>2]=f;c[n>>2]=g;c[o>>2]=h;c[p>>2]=c[l>>2];c[q>>2]=c[n>>2];c[r>>2]=(c[l>>2]|0)+(c[c[m>>2]>>2]|0);c[s>>2]=c[n>>2];if(((c[c[o>>2]>>2]|0)%2|0|0)==1){h=c[o>>2]|0;c[h>>2]=(c[h>>2]|0)+-1}c[w>>2]=(c[c[o>>2]>>2]|0)/2|0;c[t>>2]=(c[s>>2]|0)+(c[w>>2]<<1);while(1){if((c[s>>2]|0)>>>0>=(c[t>>2]|0)>>>0){z=29;break}w=c[s>>2]|0;if(c[15644]|0){c[x>>2]=w;h=c[x>>2]|0;c[x>>2]=h+1;c[u>>2]=d[h>>0];c[u>>2]=c[u>>2]<<8;c[u>>2]=c[u>>2]|(d[c[x>>2]>>0]|0);c[s>>2]=(c[s>>2]|0)+2}else{c[s>>2]=w+2;c[u>>2]=e[w>>1]}if((c[u>>2]&64512|0)==55296){if((c[s>>2]|0)>>>0>=(c[t>>2]|0)>>>0){z=10;break}w=c[s>>2]|0;if(c[15644]|0){c[x>>2]=w;h=c[x>>2]|0;c[x>>2]=h+1;c[v>>2]=d[h>>0];c[v>>2]=c[v>>2]<<8;c[v>>2]=c[v>>2]|(d[c[x>>2]>>0]|0);c[s>>2]=(c[s>>2]|0)+2}else{c[s>>2]=w+2;c[v>>2]=e[w>>1]}if((c[v>>2]&64512|0)!=56320){z=16;break}c[u>>2]=c[u>>2]&1023;c[u>>2]=c[u>>2]<<10;c[u>>2]=c[u>>2]|c[v>>2]&1023;c[u>>2]=(c[u>>2]|0)+65536}if((c[l>>2]|0)>>>0>=(c[r>>2]|0)>>>0){z=29;break}w=c[u>>2]|0;do if((c[u>>2]|0)>>>0>=128){h=c[u>>2]|0;if(w>>>0<2048){g=c[l>>2]|0;c[l>>2]=g+1;a[g>>0]=h>>>6&31|192;c[y>>2]=0;break}g=c[u>>2]|0;if(h>>>0<65536){h=c[l>>2]|0;c[l>>2]=h+1;a[h>>0]=g>>>12&15|224;c[y>>2]=6;break}else{h=c[l>>2]|0;c[l>>2]=h+1;a[h>>0]=g>>>18&7|240;c[y>>2]=12;break}}else{g=c[l>>2]|0;c[l>>2]=g+1;a[g>>0]=w;c[y>>2]=-6}while(0);while(1){if((c[y>>2]|0)<0)break;if((c[l>>2]|0)>>>0>=(c[r>>2]|0)>>>0)break;w=((c[u>>2]|0)>>>(c[y>>2]|0)&63|128)&255;g=c[l>>2]|0;c[l>>2]=g+1;a[g>>0]=w;c[y>>2]=(c[y>>2]|0)-6}c[q>>2]=c[s>>2]}if((z|0)==10){c[c[m>>2]>>2]=(c[l>>2]|0)-(c[p>>2]|0);c[c[o>>2]>>2]=(c[q>>2]|0)-(c[n>>2]|0);c[k>>2]=-2;A=c[k>>2]|0;i=j;return A|0}else if((z|0)==16){c[c[m>>2]>>2]=(c[l>>2]|0)-(c[p>>2]|0);c[c[o>>2]>>2]=(c[q>>2]|0)-(c[n>>2]|0);c[k>>2]=-2;A=c[k>>2]|0;i=j;return A|0}else if((z|0)==29){c[c[m>>2]>>2]=(c[l>>2]|0)-(c[p>>2]|0);c[c[o>>2]>>2]=(c[q>>2]|0)-(c[n>>2]|0);c[k>>2]=c[c[m>>2]>>2];A=c[k>>2]|0;i=j;return A|0}return 0}function Od(f,g,h,j){f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;k=i;i=i+64|0;l=k+56|0;m=k+52|0;n=k+48|0;o=k+44|0;p=k+40|0;q=k+36|0;r=k+32|0;s=k+28|0;t=k+24|0;u=k+20|0;v=k+16|0;w=k+12|0;x=k+8|0;y=k+4|0;z=k;A=k+62|0;B=k+60|0;c[m>>2]=f;c[n>>2]=g;c[o>>2]=h;c[p>>2]=j;c[q>>2]=c[m>>2];c[r>>2]=c[o>>2];c[s>>2]=c[o>>2];c[t>>2]=c[q>>2];if((c[m>>2]|0)==0|(c[n>>2]|0)==0|(c[p>>2]|0)==0){c[l>>2]=-1;C=c[l>>2]|0;i=k;return C|0}if(!(c[o>>2]|0)){c[c[n>>2]>>2]=0;c[c[p>>2]>>2]=0;c[l>>2]=0;C=c[l>>2]|0;i=k;return C|0}c[v>>2]=(c[o>>2]|0)+(c[c[p>>2]>>2]|0);c[u>>2]=(c[q>>2]|0)+(((c[c[n>>2]>>2]|0)/2|0)<<1);a:while(1){if((c[o>>2]|0)>>>0>=(c[v>>2]|0)>>>0){D=34;break}m=c[o>>2]|0;c[o>>2]=m+1;c[x>>2]=d[m>>0];m=c[x>>2]|0;do if((c[x>>2]|0)>>>0<128){c[w>>2]=m;c[y>>2]=0}else{if(m>>>0<192){D=10;break a}j=c[x>>2]|0;if((c[x>>2]|0)>>>0<224){c[w>>2]=j&31;c[y>>2]=1;break}h=c[x>>2]|0;if(j>>>0<240){c[w>>2]=h&15;c[y>>2]=2;break}if(h>>>0>=248){D=17;break a}c[w>>2]=c[x>>2]&7;c[y>>2]=3}while(0);if(((c[v>>2]|0)-(c[o>>2]|0)|0)<(c[y>>2]|0)){D=34;break}while(1){if(!(c[y>>2]|0))break;if((c[o>>2]|0)>>>0>=(c[v>>2]|0)>>>0)break;m=c[o>>2]|0;c[o>>2]=m+1;h=d[m>>0]|0;c[x>>2]=h;if((h&192|0)!=128)break;c[w>>2]=c[w>>2]<<6;c[w>>2]=c[w>>2]|c[x>>2]&63;c[y>>2]=(c[y>>2]|0)+-1}do if((c[w>>2]|0)>>>0<65536){if((c[q>>2]|0)>>>0>=(c[u>>2]|0)>>>0){D=34;break a}if(c[15644]|0){c[z>>2]=c[q>>2];a[c[z>>2]>>0]=(c[w>>2]|0)>>>8;a[(c[z>>2]|0)+1>>0]=c[w>>2];c[q>>2]=(c[q>>2]|0)+2;break}else{h=c[w>>2]&65535;m=c[q>>2]|0;c[q>>2]=m+2;b[m>>1]=h;break}}else{if((c[w>>2]|0)>>>0>=1114112){D=34;break a}if(((c[q>>2]|0)+2|0)>>>0>=(c[u>>2]|0)>>>0){D=34;break a}c[w>>2]=(c[w>>2]|0)-65536;h=(55296|(c[w>>2]|0)>>>10)&65535;if(c[15644]|0){b[A>>1]=h;c[z>>2]=c[q>>2];a[c[z>>2]>>0]=(e[A>>1]|0)>>8;a[(c[z>>2]|0)+1>>0]=b[A>>1];c[q>>2]=(c[q>>2]|0)+2;b[B>>1]=56320|c[w>>2]&1023;c[z>>2]=c[q>>2];a[c[z>>2]>>0]=(e[B>>1]|0)>>8;
a[(c[z>>2]|0)+1>>0]=b[B>>1];c[q>>2]=(c[q>>2]|0)+2;break}else{m=c[q>>2]|0;c[q>>2]=m+2;b[m>>1]=h;h=(56320|c[w>>2]&1023)&65535;m=c[q>>2]|0;c[q>>2]=m+2;b[m>>1]=h;break}}while(0);c[r>>2]=c[o>>2]}if((D|0)==10){c[c[n>>2]>>2]=((c[q>>2]|0)-(c[t>>2]|0)|0)/2|0;c[c[p>>2]>>2]=(c[r>>2]|0)-(c[s>>2]|0);c[l>>2]=-2;C=c[l>>2]|0;i=k;return C|0}else if((D|0)==17){c[c[n>>2]>>2]=((c[q>>2]|0)-(c[t>>2]|0)|0)/2|0;c[c[p>>2]>>2]=(c[r>>2]|0)-(c[s>>2]|0);c[l>>2]=-2;C=c[l>>2]|0;i=k;return C|0}else if((D|0)==34){c[c[n>>2]>>2]=(((c[q>>2]|0)-(c[t>>2]|0)|0)/2|0)<<1;c[c[p>>2]>>2]=(c[r>>2]|0)-(c[s>>2]|0);c[l>>2]=c[c[n>>2]>>2];C=c[l>>2]|0;i=k;return C|0}return 0}function Pd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+32|0;h=g+16|0;j=g+12|0;k=g+8|0;l=g+4|0;m=g;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;if(c[l>>2]|0){c[h>>2]=Md(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0)|0;n=c[h>>2]|0;i=g;return n|0}if((c[c[k>>2]>>2]|0)>=2){a[c[j>>2]>>0]=-1;a[(c[j>>2]|0)+1>>0]=-2;c[c[k>>2]>>2]=2;c[c[m>>2]>>2]=0;c[h>>2]=2;n=c[h>>2]|0;i=g;return n|0}else{c[c[k>>2]>>2]=0;c[c[m>>2]>>2]=0;c[h>>2]=0;n=c[h>>2]|0;i=g;return n|0}return 0}function Qd(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;h=i;i=i+48|0;j=h+40|0;k=h+36|0;l=h+32|0;m=h+28|0;n=h+24|0;o=h+20|0;p=h+16|0;q=h+12|0;r=h+8|0;s=h+4|0;t=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;c[o>>2]=c[k>>2];c[p>>2]=c[m>>2];c[q>>2]=c[m>>2];c[r>>2]=(c[k>>2]|0)+(c[c[l>>2]>>2]|0);c[s>>2]=(c[m>>2]|0)+(c[c[n>>2]>>2]|0);while(1){if((c[m>>2]|0)>>>0>=(c[s>>2]|0)>>>0){u=8;break}if(((c[k>>2]|0)-(c[o>>2]|0)+5|0)>=(c[c[l>>2]>>2]|0)){u=8;break}g=c[m>>2]|0;c[m>>2]=g+1;c[t>>2]=d[g>>0];if((c[k>>2]|0)>>>0>=(c[r>>2]|0)>>>0){u=8;break}if((c[t>>2]|0)>>>0>=128){u=7;break}g=c[t>>2]&255;f=c[k>>2]|0;c[k>>2]=f+1;a[f>>0]=g;c[q>>2]=c[m>>2]}if((u|0)==7){c[c[l>>2]>>2]=(c[k>>2]|0)-(c[o>>2]|0);c[c[n>>2]>>2]=(c[q>>2]|0)-(c[p>>2]|0);c[j>>2]=-1;v=c[j>>2]|0;i=h;return v|0}else if((u|0)==8){c[c[l>>2]>>2]=(c[k>>2]|0)-(c[o>>2]|0);c[c[n>>2]>>2]=(c[q>>2]|0)-(c[p>>2]|0);c[j>>2]=c[c[l>>2]>>2];v=c[j>>2]|0;i=h;return v|0}return 0}function Rd(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;h=i;i=i+64|0;j=h+48|0;k=h+44|0;l=h+40|0;m=h+36|0;n=h+32|0;o=h+28|0;p=h+24|0;q=h+20|0;r=h+16|0;s=h+12|0;t=h+8|0;u=h+4|0;v=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;c[o>>2]=c[m>>2];c[q>>2]=c[k>>2];c[r>>2]=c[m>>2];if((c[k>>2]|0)==0|(c[l>>2]|0)==0|(c[n>>2]|0)==0){c[j>>2]=-1;w=c[j>>2]|0;i=h;return w|0}if(!(c[m>>2]|0)){c[c[l>>2]>>2]=0;c[c[n>>2]>>2]=0;c[j>>2]=0;w=c[j>>2]|0;i=h;return w|0}c[s>>2]=(c[m>>2]|0)+(c[c[n>>2]>>2]|0);c[p>>2]=(c[k>>2]|0)+(c[c[l>>2]>>2]|0);a:while(1){if((c[m>>2]|0)>>>0>=(c[s>>2]|0)>>>0){x=27;break}g=c[m>>2]|0;c[m>>2]=g+1;c[u>>2]=d[g>>0];g=c[u>>2]|0;do if((c[u>>2]|0)>>>0<128){c[t>>2]=g;c[v>>2]=0}else{if(g>>>0<192){x=10;break a}f=c[u>>2]|0;if((c[u>>2]|0)>>>0<224){c[t>>2]=f&31;c[v>>2]=1;break}e=c[u>>2]|0;if(f>>>0<240){c[t>>2]=e&15;c[v>>2]=2;break}if(e>>>0>=248){x=17;break a}c[t>>2]=c[u>>2]&7;c[v>>2]=3}while(0);if(((c[s>>2]|0)-(c[m>>2]|0)|0)<(c[v>>2]|0)){x=27;break}while(1){if(!(c[v>>2]|0))break;if((c[m>>2]|0)>>>0>=(c[s>>2]|0)>>>0)break;g=c[m>>2]|0;c[m>>2]=g+1;e=d[g>>0]|0;c[u>>2]=e;if((e&192|0)!=128)break;c[t>>2]=c[t>>2]<<6;c[t>>2]=c[t>>2]|c[u>>2]&63;c[v>>2]=(c[v>>2]|0)+-1}y=c[k>>2]|0;if((c[t>>2]|0)>>>0>=128){x=26;break}if(y>>>0>=(c[p>>2]|0)>>>0){x=27;break}e=c[t>>2]&255;g=c[k>>2]|0;c[k>>2]=g+1;a[g>>0]=e;c[o>>2]=c[m>>2]}if((x|0)==10){c[c[l>>2]>>2]=(c[k>>2]|0)-(c[q>>2]|0);c[c[n>>2]>>2]=(c[o>>2]|0)-(c[r>>2]|0);c[j>>2]=-2;w=c[j>>2]|0;i=h;return w|0}else if((x|0)==17){c[c[l>>2]>>2]=(c[k>>2]|0)-(c[q>>2]|0);c[c[n>>2]>>2]=(c[o>>2]|0)-(c[r>>2]|0);c[j>>2]=-2;w=c[j>>2]|0;i=h;return w|0}else if((x|0)==26){c[c[l>>2]>>2]=y-(c[q>>2]|0);c[c[n>>2]>>2]=(c[o>>2]|0)-(c[r>>2]|0);c[j>>2]=-2;w=c[j>>2]|0;i=h;return w|0}else if((x|0)==27){c[c[l>>2]>>2]=(c[k>>2]|0)-(c[q>>2]|0);c[c[n>>2]>>2]=(c[o>>2]|0)-(c[r>>2]|0);c[j>>2]=c[c[l>>2]>>2];w=c[j>>2]|0;i=h;return w|0}return 0}function Sd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+48|0;h=g+40|0;j=g+36|0;k=g+32|0;l=g+28|0;m=g+24|0;n=g+20|0;o=g+16|0;p=g+12|0;q=g+8|0;r=g+4|0;s=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[q>>2]=c[m>>2];c[r>>2]=c[k>>2];if((c[k>>2]|0)==0|(c[l>>2]|0)==0|(c[n>>2]|0)==0|(c[m>>2]|0)==0){if(c[l>>2]|0)c[c[l>>2]>>2]=0;c[h>>2]=-1;t=c[h>>2]|0;i=g;return t|0}c[o>>2]=c[c[n>>2]>>2];c[p>>2]=c[c[l>>2]>>2];c[s>>2]=ZS(c[j>>2]|0,q,o,r,p)|0;r=c[n>>2]|0;c[r>>2]=(c[r>>2]|0)-(c[o>>2]|0);r=c[l>>2]|0;c[r>>2]=(c[r>>2]|0)-(c[p>>2]|0);if(!((c[o>>2]|0)!=0|(c[s>>2]|0)==-1)){c[h>>2]=0;t=c[h>>2]|0;i=g;return t|0}if((c[(_a()|0)>>2]|0)==84){c[h>>2]=-2;t=c[h>>2]|0;i=g;return t|0}if((c[(_a()|0)>>2]|0)==7){c[h>>2]=-1;t=c[h>>2]|0;i=g;return t|0}else{c[h>>2]=-3;t=c[h>>2]|0;i=g;return t|0}return 0}function Td(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+32|0;f=e+16|0;g=e;c[e+20>>2]=a;c[f>>2]=b;if(!(c[33980]|0))c[33980]=c[o>>2];c[g>>2]=d;Ca(c[33980]|0,c[f>>2]|0,g|0)|0;i=e;return}function Ud(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){c[33976]=35;i=b;return}else{c[33976]=c[c[d>>2]>>2];i=b;return}}function Vd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b;e=b+8|0;c[e>>2]=a;if(!(c[e>>2]|0)){i=b;return}a=c[33976]|0;f=c[33980]|0;g=c[e>>2]|0;if(c[(c[e>>2]|0)+4>>2]|0){h=c[(c[e>>2]|0)+28>>2]|0;c[d>>2]=c[g+4>>2];c[d+4>>2]=h;Db[a&511](f,63216,d);i=b;return}else{c[d>>2]=c[g+28>>2];Db[a&511](f,63224,d);i=b;return}}function Wd(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;fe(c[d>>2]|0,c[33976]|0,c[33980]|0);i=b;return}function Xd(a,b,d,f,g,h,j,k,l,m,n,o,p,q,r,s,t){a=a|0;b=b|0;d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;var u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;u=i;i=i+144|0;v=u;w=u+132|0;x=u+128|0;y=u+124|0;z=u+120|0;A=u+116|0;B=u+112|0;C=u+108|0;D=u+104|0;E=u+100|0;F=u+96|0;G=u+92|0;H=u+88|0;I=u+84|0;J=u+80|0;K=u+76|0;L=u+72|0;M=u+68|0;N=u+64|0;O=u+60|0;P=u+56|0;Q=u+52|0;R=u+48|0;S=u+44|0;T=u+40|0;U=u+36|0;V=u+32|0;W=u+16|0;X=u+12|0;Y=u+8|0;Z=u+4|0;c[w>>2]=a;c[x>>2]=b;c[y>>2]=d;c[z>>2]=f;c[A>>2]=g;c[B>>2]=h;c[C>>2]=j;c[D>>2]=k;c[E>>2]=l;c[F>>2]=m;c[G>>2]=n;c[H>>2]=o;c[I>>2]=p;c[J>>2]=q;c[K>>2]=r;c[L>>2]=s;c[M>>2]=0;c[N>>2]=c[A>>2];c[O>>2]=0;c[P>>2]=0;c[Q>>2]=136208;c[R>>2]=0;if(!(c[C>>2]|0)){i=u;return}if((c[33956]|0)==0&(c[D>>2]|0)==1){i=u;return}if(((((c[B>>2]|0)==1|(c[B>>2]|0)==5|(c[B>>2]|0)==4|(c[B>>2]|0)==3|(c[B>>2]|0)==8|(c[B>>2]|0)==23?(c[M>>2]=c[z>>2],(c[w>>2]|0)==0&(c[M>>2]|0)!=0):0)?(c[c[M>>2]>>2]|0)!=0:0)?(c[(c[c[M>>2]>>2]|0)+108>>2]|0)==-554844497:0)?(c[(c[c[M>>2]>>2]|0)+124>>2]|0)!=0:0){c[w>>2]=c[(c[c[M>>2]>>2]|0)+124>>2];c[y>>2]=c[(c[M>>2]|0)+4>>2]}if((c[w>>2]|0)==0?(c[w>>2]=c[33978],(c[w>>2]|0)!=0):0)c[y>>2]=c[33982];a:do if(c[L>>2]|0){c[T>>2]=-1;c[O>>2]=Cb[c[135744>>2]&511](150)|0;if(c[O>>2]|0){c[S>>2]=150;while(1){if((c[S>>2]|0)>=64e3)break a;c[W>>2]=t;c[U>>2]=LT(c[O>>2]|0,c[S>>2]|0,c[L>>2]|0,W)|0;if((c[U>>2]|0)>-1?(c[U>>2]|0)<(c[S>>2]|0):0){if((c[T>>2]|0)==(c[U>>2]|0))break a;c[T>>2]=c[U>>2]}if((c[U>>2]|0)>-1)c[S>>2]=(c[S>>2]|0)+((c[U>>2]|0)+1);else c[S>>2]=(c[S>>2]|0)+100;A=Hb[c[135760>>2]&511](c[O>>2]|0,c[S>>2]|0)|0;c[V>>2]=A;if(!A)break a;c[O>>2]=c[V>>2]}}}else c[O>>2]=my(63248)|0;while(0);if(!(c[M>>2]|0)){if((c[N>>2]|0)!=0&(c[E>>2]|0)==0){if((c[(c[N>>2]|0)+32>>2]|0)!=0?(c[(c[(c[N>>2]|0)+32>>2]|0)+72>>2]|0)!=0:0)c[R>>2]=c[N>>2];c[X>>2]=0;while(1){if(!((c[X>>2]|0)<10&(c[N>>2]|0)!=0))break;if((c[(c[N>>2]|0)+4>>2]|0)==1)break;c[N>>2]=c[(c[N>>2]|0)+20>>2];c[X>>2]=(c[X>>2]|0)+1}if(((c[R>>2]|0)==0&(c[N>>2]|0)!=0?(c[(c[N>>2]|0)+32>>2]|0)!=0:0)?(c[(c[(c[N>>2]|0)+32>>2]|0)+72>>2]|0)!=0:0)c[R>>2]=c[N>>2];if((c[N>>2]|0)!=0?(c[(c[N>>2]|0)+4>>2]|0)==1:0)c[F>>2]=e[(c[N>>2]|0)+56>>1];if((c[F>>2]|0)==0|(c[F>>2]|0)==65535)c[F>>2]=Ni(c[N>>2]|0)|0}}else{if(!(c[E>>2]|0)){c[P>>2]=c[(c[M>>2]|0)+36>>2];if(((c[P>>2]|0)!=0?(c[(c[P>>2]|0)+4>>2]|0)==0:0)?(c[(c[M>>2]|0)+40>>2]|0)>1:0)c[P>>2]=c[(c[(c[M>>2]|0)+48>>2]|0)+((c[(c[M>>2]|0)+40>>2]|0)-2<<2)>>2];if(c[P>>2]|0){c[E>>2]=c[(c[P>>2]|0)+4>>2];c[F>>2]=c[(c[P>>2]|0)+28>>2];c[K>>2]=c[(c[P>>2]|0)+32>>2]}}c[Q>>2]=(c[M>>2]|0)+384}Yd(c[Q>>2]|0);c[c[Q>>2]>>2]=c[B>>2];c[(c[Q>>2]|0)+4>>2]=c[C>>2];c[(c[Q>>2]|0)+8>>2]=c[O>>2];c[(c[Q>>2]|0)+12>>2]=c[D>>2];if(!(c[E>>2]|0)){if(c[R>>2]|0){c[Y>>2]=c[R>>2];c[Z>>2]=0;b:while(1){if(!(c[Y>>2]|0))break;while(1){_=c[Y>>2]|0;if(!(c[(c[Y>>2]|0)+28>>2]|0)){$=58;break}c[Y>>2]=c[_+28>>2];if((c[(c[Y>>2]|0)+4>>2]|0)!=19)break;C=(c[Z>>2]|0)+-1|0;c[Z>>2]=C;if(!((C|0)>=0&(c[Y>>2]|0)!=0))break b}if(($|0)==58){$=0;c[Y>>2]=c[_+20>>2];continue}if((c[(c[Y>>2]|0)+4>>2]|0)!=20)continue;c[Z>>2]=(c[Z>>2]|0)+1}do if(c[Y>>2]|0){Z=c[Y>>2]|0;if((c[(c[Y>>2]|0)+4>>2]|0)==19){c[Z+4>>2]=1;_=Yi(c[Y>>2]|0,63280)|0;c[(c[Q>>2]|0)+16>>2]=_;c[(c[Y>>2]|0)+4>>2]=19;break}else{_=Yi(Z,63280)|0;c[(c[Q>>2]|0)+16>>2]=_;break}}else{_=my(c[(c[(c[R>>2]|0)+32>>2]|0)+72>>2]|0)|0;c[(c[Q>>2]|0)+16>>2]=_}while(0);if(((c[N>>2]|0)!=0?(c[(c[Q>>2]|0)+16>>2]|0)==0:0)?(c[(c[N>>2]|0)+32>>2]|0)!=0:0){R=my(c[(c[(c[N>>2]|0)+32>>2]|0)+72>>2]|0)|0;c[(c[Q>>2]|0)+16>>2]=R}}}else{R=my(c[E>>2]|0)|0;c[(c[Q>>2]|0)+16>>2]=R}c[(c[Q>>2]|0)+20>>2]=c[F>>2];if(c[G>>2]|0){F=my(c[G>>2]|0)|0;c[(c[Q>>2]|0)+24>>2]=F}if(c[H>>2]|0){F=my(c[H>>2]|0)|0;c[(c[Q>>2]|0)+28>>2]=F}if(c[I>>2]|0){F=my(c[I>>2]|0)|0;c[(c[Q>>2]|0)+32>>2]=F}c[(c[Q>>2]|0)+36>>2]=c[J>>2];c[(c[Q>>2]|0)+40>>2]=c[K>>2];c[(c[Q>>2]|0)+48>>2]=c[N>>2];c[(c[Q>>2]|0)+44>>2]=c[z>>2];if((c[Q>>2]|0)!=136208)Zd(c[Q>>2]|0,136208)|0;if(c[w>>2]|0){Ab[c[w>>2]&511](c[y>>2]|0,c[Q>>2]|0);i=u;return}if((c[M>>2]|0)!=0&(c[x>>2]|0)==0&(c[33978]|0)==0?(c[c[M>>2]>>2]|0)!=0:0){w=c[c[M>>2]>>2]|0;if((c[D>>2]|0)==1)c[x>>2]=c[w+84>>2];else c[x>>2]=c[w+88>>2];c[y>>2]=c[(c[M>>2]|0)+4>>2]}else $=87;do if(($|0)==87?(c[x>>2]|0)==0:0){c[x>>2]=c[33976];if(c[M>>2]|0){c[y>>2]=c[M>>2];break}else{c[y>>2]=c[33980];break}}while(0);if(!(c[x>>2]|0)){i=u;return}if((c[x>>2]|0)==57|(c[x>>2]|0)==56|(c[x>>2]|0)==224|(c[x>>2]|0)==225){ge(c[Q>>2]|0,c[M>>2]|0,c[O>>2]|0,0,0);i=u;return}if((c[x>>2]|0)==203|(c[x>>2]|0)==35){ge(c[Q>>2]|0,c[M>>2]|0,c[O>>2]|0,c[x>>2]|0,c[y>>2]|0);i=u;return}else{M=c[x>>2]|0;x=c[y>>2]|0;c[v>>2]=c[O>>2];Db[M&511](x,63288,v);i=u;return}}function Yd(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(!(c[(c[d>>2]|0)+4>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+8>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+8>>2]|0);if(c[(c[d>>2]|0)+16>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+16>>2]|0);if(c[(c[d>>2]|0)+24>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+24>>2]|0);if(c[(c[d>>2]|0)+28>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+28>>2]|0);if(c[(c[d>>2]|0)+32>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+32>>2]|0);a=(c[d>>2]|0)+0|0;e=a+52|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(e|0));c[(c[d>>2]|0)+4>>2]=0;i=b;return}function Zd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+28|0;f=d+24|0;g=d+20|0;h=d+16|0;j=d+12|0;k=d+8|0;l=d+4|0;m=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){c[e>>2]=-1;n=c[e>>2]|0;i=d;return n|0}c[h>>2]=my(c[(c[f>>2]|0)+8>>2]|0)|0;c[j>>2]=my(c[(c[f>>2]|0)+16>>2]|0)|0;c[k>>2]=my(c[(c[f>>2]|0)+24>>2]|0)|0;c[l>>2]=my(c[(c[f>>2]|0)+28>>2]|0)|0;c[m>>2]=my(c[(c[f>>2]|0)+32>>2]|0)|0;if(c[(c[g>>2]|0)+8>>2]|0)zb[c[135736>>2]&511](c[(c[g>>2]|0)+8>>2]|0);if(c[(c[g>>2]|0)+16>>2]|0)zb[c[135736>>2]&511](c[(c[g>>2]|0)+16>>2]|0);if(c[(c[g>>2]|0)+24>>2]|0)zb[c[135736>>2]&511](c[(c[g>>2]|0)+24>>2]|0);if(c[(c[g>>2]|0)+28>>2]|0)zb[c[135736>>2]&511](c[(c[g>>2]|0)+28>>2]|0);if(c[(c[g>>2]|0)+32>>2]|0)zb[c[135736>>2]&511](c[(c[g>>2]|0)+32>>2]|0);c[c[g>>2]>>2]=c[c[f>>2]>>2];c[(c[g>>2]|0)+4>>2]=c[(c[f>>2]|0)+4>>2];c[(c[g>>2]|0)+12>>2]=c[(c[f>>2]|0)+12>>2];c[(c[g>>2]|0)+20>>2]=c[(c[f>>2]|0)+20>>2];c[(c[g>>2]|0)+48>>2]=c[(c[f>>2]|0)+48>>2];c[(c[g>>2]|0)+36>>2]=c[(c[f>>2]|0)+36>>2];c[(c[g>>2]|0)+40>>2]=c[(c[f>>2]|0)+40>>2];c[(c[g>>2]|0)+48>>2]=c[(c[f>>2]|0)+48>>2];c[(c[g>>2]|0)+44>>2]=c[(c[f>>2]|0)+44>>2];c[(c[g>>2]|0)+8>>2]=c[h>>2];c[(c[g>>2]|0)+16>>2]=c[j>>2];c[(c[g>>2]|0)+24>>2]=c[k>>2];c[(c[g>>2]|0)+28>>2]=c[l>>2];c[(c[g>>2]|0)+32>>2]=c[m>>2];c[e>>2]=0;n=c[e>>2]|0;i=d;return n|0}function _d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+64|0;f=e;g=e+60|0;h=e+56|0;j=e+52|0;k=e+48|0;l=e+44|0;m=e+40|0;n=e+36|0;o=e+32|0;p=e+28|0;q=e+24|0;r=e+8|0;c[g>>2]=a;c[h>>2]=b;c[j>>2]=c[g>>2];c[k>>2]=0;c[l>>2]=0;if(c[j>>2]|0){c[k>>2]=c[(c[j>>2]|0)+36>>2];if(((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+4>>2]|0)==0:0)?(c[(c[j>>2]|0)+40>>2]|0)>1:0){c[l>>2]=c[k>>2];c[k>>2]=c[(c[(c[j>>2]|0)+48>>2]|0)+((c[(c[j>>2]|0)+40>>2]|0)-2<<2)>>2]}Vd(c[k>>2]|0)}Db[c[135904>>2]&511](c[33980]|0,63360,f);c[o>>2]=-1;c[m>>2]=Cb[c[135744>>2]&511](150)|0;a:do if(c[m>>2]|0){c[n>>2]=150;while(1){if((c[n>>2]|0)>=64e3)break a;c[r>>2]=d;c[p>>2]=LT(c[m>>2]|0,c[n>>2]|0,c[h>>2]|0,r)|0;if((c[p>>2]|0)>-1?(c[p>>2]|0)<(c[n>>2]|0):0){if((c[o>>2]|0)==(c[p>>2]|0))break a;c[o>>2]=c[p>>2]}if((c[p>>2]|0)>-1)c[n>>2]=(c[n>>2]|0)+((c[p>>2]|0)+1);else c[n>>2]=(c[n>>2]|0)+100;g=Hb[c[135760>>2]&511](c[m>>2]|0,c[n>>2]|0)|0;c[q>>2]=g;if(!g)break a;c[m>>2]=c[q>>2]}}while(0);q=c[33976]|0;n=c[33980]|0;c[f>>2]=c[m>>2];Db[q&511](n,63288,f);if(c[m>>2]|0)zb[c[135736>>2]&511](c[m>>2]|0);if(!(c[j>>2]|0)){i=e;return}Wd(c[k>>2]|0);if(!(c[l>>2]|0)){i=e;return}Vd(c[l>>2]|0);Db[c[135904>>2]&511](c[33980]|0,63368,f);Wd(c[l>>2]|0);i=e;return}function $d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+64|0;f=e;g=e+60|0;h=e+56|0;j=e+52|0;k=e+48|0;l=e+44|0;m=e+40|0;n=e+36|0;o=e+32|0;p=e+28|0;q=e+24|0;r=e+8|0;c[g>>2]=a;c[h>>2]=b;c[j>>2]=c[g>>2];c[k>>2]=0;c[l>>2]=0;if(c[j>>2]|0){c[k>>2]=c[(c[j>>2]|0)+36>>2];if(((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+4>>2]|0)==0:0)?(c[(c[j>>2]|0)+40>>2]|0)>1:0){c[l>>2]=c[k>>2];c[k>>2]=c[(c[(c[j>>2]|0)+48>>2]|0)+((c[(c[j>>2]|0)+40>>2]|0)-2<<2)>>2]}Vd(c[k>>2]|0)}Db[c[135904>>2]&511](c[33980]|0,63376,f);c[o>>2]=-1;c[m>>2]=Cb[c[135744>>2]&511](150)|0;a:do if(c[m>>2]|0){c[n>>2]=150;while(1){if((c[n>>2]|0)>=64e3)break a;c[r>>2]=d;c[p>>2]=LT(c[m>>2]|0,c[n>>2]|0,c[h>>2]|0,r)|0;if((c[p>>2]|0)>-1?(c[p>>2]|0)<(c[n>>2]|0):0){if((c[o>>2]|0)==(c[p>>2]|0))break a;c[o>>2]=c[p>>2]}if((c[p>>2]|0)>-1)c[n>>2]=(c[n>>2]|0)+((c[p>>2]|0)+1);else c[n>>2]=(c[n>>2]|0)+100;g=Hb[c[135760>>2]&511](c[m>>2]|0,c[n>>2]|0)|0;c[q>>2]=g;if(!g)break a;c[m>>2]=c[q>>2]}}while(0);q=c[33976]|0;n=c[33980]|0;c[f>>2]=c[m>>2];Db[q&511](n,63288,f);if(c[m>>2]|0)zb[c[135736>>2]&511](c[m>>2]|0);if(!(c[j>>2]|0)){i=e;return}Wd(c[k>>2]|0);if(!(c[l>>2]|0)){i=e;return}Vd(c[l>>2]|0);Db[c[135904>>2]&511](c[33980]|0,63368,f);Wd(c[l>>2]|0);i=e;return}function ae(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+64|0;g=f;h=f+60|0;j=f+56|0;k=f+52|0;l=f+48|0;m=f+44|0;n=f+40|0;o=f+36|0;p=f+32|0;q=f+28|0;r=f+24|0;s=f+8|0;c[h>>2]=b;c[j>>2]=d;c[k>>2]=c[h>>2];c[l>>2]=0;c[n>>2]=xy(c[j>>2]|0)|0;if((c[n>>2]|0)>1?(a[(c[j>>2]|0)+((c[n>>2]|0)-2)>>0]|0)!=58:0){if(c[k>>2]|0){c[l>>2]=c[(c[k>>2]|0)+36>>2];if((c[(c[l>>2]|0)+4>>2]|0)==0?(c[(c[k>>2]|0)+40>>2]|0)>1:0)c[l>>2]=c[(c[(c[k>>2]|0)+48>>2]|0)+((c[(c[k>>2]|0)+40>>2]|0)-2<<2)>>2];if(!(c[15848]|0))Vd(c[l>>2]|0)}Db[c[135904>>2]&511](c[33980]|0,63400,g);c[15848]=0}else c[15848]=1;c[p>>2]=-1;c[m>>2]=Cb[c[135744>>2]&511](150)|0;a:do if(c[m>>2]|0){c[o>>2]=150;while(1){if((c[o>>2]|0)>=64e3)break a;c[s>>2]=e;c[q>>2]=LT(c[m>>2]|0,c[o>>2]|0,c[j>>2]|0,s)|0;if((c[q>>2]|0)>-1?(c[q>>2]|0)<(c[o>>2]|0):0){if((c[p>>2]|0)==(c[q>>2]|0))break a;c[p>>2]=c[q>>2]}if((c[q>>2]|0)>-1)c[o>>2]=(c[o>>2]|0)+((c[q>>2]|0)+1);else c[o>>2]=(c[o>>2]|0)+100;n=Hb[c[135760>>2]&511](c[m>>2]|0,c[o>>2]|0)|0;c[r>>2]=n;if(!n)break a;c[m>>2]=c[r>>2]}}while(0);r=c[33976]|0;o=c[33980]|0;c[g>>2]=c[m>>2];Db[r&511](o,63288,g);if(c[m>>2]|0)zb[c[135736>>2]&511](c[m>>2]|0);if(!((c[k>>2]|0)!=0&(c[l>>2]|0)!=0)){i=f;return}Wd(c[l>>2]|0);i=f;return}function be(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+64|0;g=f;h=f+60|0;j=f+56|0;k=f+52|0;l=f+48|0;m=f+44|0;n=f+40|0;o=f+36|0;p=f+32|0;q=f+28|0;r=f+24|0;s=f+8|0;c[h>>2]=b;c[j>>2]=d;c[k>>2]=c[h>>2];c[l>>2]=0;c[n>>2]=xy(c[j>>2]|0)|0;if((c[k>>2]|0)!=0&(c[n>>2]|0)!=0?(a[(c[j>>2]|0)+((c[n>>2]|0)-1)>>0]|0)!=58:0){c[l>>2]=c[(c[k>>2]|0)+36>>2];if((c[(c[l>>2]|0)+4>>2]|0)==0?(c[(c[k>>2]|0)+40>>2]|0)>1:0)c[l>>2]=c[(c[(c[k>>2]|0)+48>>2]|0)+((c[(c[k>>2]|0)+40>>2]|0)-2<<2)>>2];Vd(c[l>>2]|0)}Db[c[135904>>2]&511](c[33980]|0,63424,g);c[p>>2]=-1;c[m>>2]=Cb[c[135744>>2]&511](150)|0;a:do if(c[m>>2]|0){c[o>>2]=150;while(1){if((c[o>>2]|0)>=64e3)break a;c[s>>2]=e;c[q>>2]=LT(c[m>>2]|0,c[o>>2]|0,c[j>>2]|0,s)|0;if((c[q>>2]|0)>-1?(c[q>>2]|0)<(c[o>>2]|0):0){if((c[p>>2]|0)==(c[q>>2]|0))break a;c[p>>2]=c[q>>2]}if((c[q>>2]|0)>-1)c[o>>2]=(c[o>>2]|0)+((c[q>>2]|0)+1);else c[o>>2]=(c[o>>2]|0)+100;n=Hb[c[135760>>2]&511](c[m>>2]|0,c[o>>2]|0)|0;c[r>>2]=n;if(!n)break a;c[m>>2]=c[r>>2]}}while(0);r=c[33976]|0;o=c[33980]|0;c[g>>2]=c[m>>2];Db[r&511](o,63288,g);if(c[m>>2]|0)zb[c[135736>>2]&511](c[m>>2]|0);if(!(c[k>>2]|0)){i=f;return}Wd(c[l>>2]|0);i=f;return}function ce(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+32|0;h=g;j=g+20|0;k=g+16|0;l=g+12|0;m=g+8|0;n=g+4|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;if((c[k>>2]|0)!=2){f=c[l>>2]|0;e=c[j>>2]|0;d=c[k>>2]|0;k=c[n>>2]|0;b=c[m>>2]|0;c[h>>2]=c[n>>2];Xd(0,0,0,0,f,e,d,2,0,0,k,0,0,0,0,b,h);i=g;return}b=c[l>>2]|0;l=c[j>>2]|0;if(c[n>>2]|0){j=c[n>>2]|0;c[h>>2]=c[n>>2];Xd(0,0,0,0,b,l,2,3,0,0,j,0,0,0,0,63296,h);i=g;return}else{Xd(0,0,0,0,b,l,2,3,0,0,0,0,0,0,0,63328,h);i=g;return}}function de(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(c[34053]|0))c[b>>2]=0;else c[b>>2]=136208;i=a;return c[b>>2]|0}function ee(){var a=0;a=i;if(c[34053]|0)Yd(136208);i=a;return}function fe(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+128|0;h=g;j=g+32|0;k=g+28|0;l=g+24|0;m=g+20|0;n=g+16|0;o=g+12|0;p=g+8|0;q=g+36|0;r=g+4|0;c[j>>2]=b;c[k>>2]=e;c[l>>2]=f;if(!(c[j>>2]|0)){i=g;return}c[m>>2]=c[(c[j>>2]|0)+16>>2];c[n>>2]=c[(c[j>>2]|0)+12>>2];while(1){if((c[m>>2]|0)>>>0<=(c[n>>2]|0)>>>0)break;if((d[c[m>>2]>>0]|0|0)!=10?(d[c[m>>2]>>0]|0|0)!=13:0)break;c[m>>2]=(c[m>>2]|0)+-1}c[o>>2]=0;while(1){f=c[o>>2]|0;c[o>>2]=f+1;if((f>>>0<80?(c[m>>2]|0)>>>0>(c[n>>2]|0)>>>0:0)?(d[c[m>>2]>>0]|0|0)!=10:0)s=(d[c[m>>2]>>0]|0|0)!=13;else s=0;t=c[m>>2]|0;if(!s)break;c[m>>2]=t+-1}if(!((d[t>>0]|0|0)!=10?(d[c[m>>2]>>0]|0|0)!=13:0))c[m>>2]=(c[m>>2]|0)+1;c[p>>2]=(c[(c[j>>2]|0)+16>>2]|0)-(c[m>>2]|0);c[o>>2]=0;c[r>>2]=q;while(1){if(!(d[c[m>>2]>>0]|0))break;if((d[c[m>>2]>>0]|0|0)==10)break;if(!((c[o>>2]|0)>>>0<80?(d[c[m>>2]>>0]|0|0)!=13:0))break;j=c[m>>2]|0;c[m>>2]=j+1;t=a[j>>0]|0;j=c[r>>2]|0;c[r>>2]=j+1;a[j>>0]=t;c[o>>2]=(c[o>>2]|0)+1}a[c[r>>2]>>0]=0;m=c[k>>2]|0;t=c[l>>2]|0;c[h>>2]=q;Db[m&511](t,63808,h);c[o>>2]=0;c[r>>2]=q;while(1){if((c[o>>2]|0)>>>0<(c[p>>2]|0)>>>0?(t=c[o>>2]|0,c[o>>2]=t+1,t>>>0<79):0)u=(d[c[r>>2]>>0]|0|0)!=0;else u=0;v=c[r>>2]|0;if(!u)break;if((d[v>>0]|0|0)!=9)a[c[r>>2]>>0]=32;c[r>>2]=(c[r>>2]|0)+1}c[r>>2]=v+1;a[v>>0]=94;a[c[r>>2]>>0]=0;r=c[k>>2]|0;k=c[l>>2]|0;c[h>>2]=q;Db[r&511](k,63808,h);i=g;return}function ge(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;h=i;i=i+224|0;j=h;k=h+68|0;l=h+64|0;m=h+60|0;n=h+56|0;o=h+52|0;p=h+48|0;q=h+44|0;r=h+40|0;s=h+36|0;t=h+32|0;u=h+28|0;v=h+24|0;w=h+20|0;x=h+16|0;y=h+12|0;z=h+72|0;A=h+8|0;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[p>>2]=0;c[q>>2]=0;c[r>>2]=-1;c[t>>2]=0;c[w>>2]=0;c[x>>2]=0;if(!(c[k>>2]|0)){i=h;return}if(!(c[n>>2]|0)){c[n>>2]=c[33976];c[o>>2]=c[33980]}c[p>>2]=c[(c[k>>2]|0)+16>>2];c[q>>2]=c[(c[k>>2]|0)+20>>2];c[r>>2]=c[(c[k>>2]|0)+4>>2];c[s>>2]=c[c[k>>2]>>2];c[v>>2]=c[(c[k>>2]|0)+12>>2];c[u>>2]=c[(c[k>>2]|0)+48>>2];if(!(c[r>>2]|0)){i=h;return}if((c[u>>2]|0)!=0?(c[(c[u>>2]|0)+4>>2]|0)==1:0)c[t>>2]=c[(c[u>>2]|0)+8>>2];do if(c[l>>2]|0){c[w>>2]=c[(c[l>>2]|0)+36>>2];if(((c[w>>2]|0)!=0?(c[(c[w>>2]|0)+4>>2]|0)==0:0)?(c[(c[l>>2]|0)+40>>2]|0)>1:0){c[x>>2]=c[w>>2];c[w>>2]=c[(c[(c[l>>2]|0)+48>>2]|0)+((c[(c[l>>2]|0)+40>>2]|0)-2<<2)>>2]}if(c[w>>2]|0){if(c[(c[w>>2]|0)+4>>2]|0){u=c[n>>2]|0;r=c[o>>2]|0;g=c[(c[w>>2]|0)+28>>2]|0;c[j>>2]=c[(c[w>>2]|0)+4>>2];c[j+4>>2]=g;Db[u&511](r,63216,j);break}if((c[q>>2]|0)!=0&(c[s>>2]|0)==1){r=c[n>>2]|0;u=c[o>>2]|0;c[j>>2]=c[(c[w>>2]|0)+28>>2];Db[r&511](u,63224,j)}}}else{if(c[p>>2]|0){u=c[n>>2]|0;r=c[o>>2]|0;g=c[q>>2]|0;c[j>>2]=c[p>>2];c[j+4>>2]=g;Db[u&511](r,63216,j);break}if((c[q>>2]|0)!=0?(c[s>>2]|0)==1|(c[s>>2]|0)==17|(c[s>>2]|0)==16|(c[s>>2]|0)==4|(c[s>>2]|0)==18|(c[s>>2]|0)==19:0){r=c[n>>2]|0;u=c[o>>2]|0;c[j>>2]=c[q>>2];Db[r&511](u,63224,j)}}while(0);if(c[t>>2]|0){p=c[n>>2]|0;u=c[o>>2]|0;c[j>>2]=c[t>>2];Db[p&511](u,63448,j)}do switch(c[s>>2]|0){case 29:{Db[c[n>>2]&511](c[o>>2]|0,63736,j);break}case 30:{Db[c[n>>2]&511](c[o>>2]|0,63760,j);break}case 20:{Db[c[n>>2]&511](c[o>>2]|0,63672,j);break}case 5:{Db[c[n>>2]&511](c[o>>2]|0,63504,j);break}case 1:{Db[c[n>>2]&511](c[o>>2]|0,63464,j);break}case 13:{Db[c[n>>2]&511](c[o>>2]|0,63464,j);break}case 18:{Db[c[n>>2]&511](c[o>>2]|0,63624,j);break}case 19:{Db[c[n>>2]&511](c[o>>2]|0,63648,j);break}case 14:{Db[c[n>>2]&511](c[o>>2]|0,63568,j);break}case 26:{Db[c[n>>2]&511](c[o>>2]|0,63576,j);break}case 23:case 4:{Db[c[n>>2]&511](c[o>>2]|0,63488,j);break}case 3:{Db[c[n>>2]&511](c[o>>2]|0,63472,j);break}case 17:{Db[c[n>>2]&511](c[o>>2]|0,63584,j);break}case 16:{Db[c[n>>2]&511](c[o>>2]|0,63608,j);break}case 21:{Db[c[n>>2]&511](c[o>>2]|0,63688,j);break}case 22:{Db[c[n>>2]&511](c[o>>2]|0,63696,j);break}case 27:{Db[c[n>>2]&511](c[o>>2]|0,63704,j);break}case 28:{Db[c[n>>2]&511](c[o>>2]|0,63720,j);break}case 6:{Db[c[n>>2]&511](c[o>>2]|0,63520,j);break}case 7:{Db[c[n>>2]&511](c[o>>2]|0,63528,j);break}case 8:{Db[c[n>>2]&511](c[o>>2]|0,63536,j);break}case 11:{Db[c[n>>2]&511](c[o>>2]|0,63544,j);break}case 12:{Db[c[n>>2]&511](c[o>>2]|0,63560,j);break}default:{}}while(0);u=c[v>>2]|0;if((u|0)==1)Db[c[n>>2]&511](c[o>>2]|0,63776,j);else if((u|0)==2)Db[c[n>>2]&511](c[o>>2]|0,63792,j);else if((u|0)==3)Db[c[n>>2]&511](c[o>>2]|0,63792,j);else if(!u)Db[c[n>>2]&511](c[o>>2]|0,63768,j);do if(c[m>>2]|0){c[y>>2]=xy(c[m>>2]|0)|0;if((c[y>>2]|0)>0?(a[(c[m>>2]|0)+((c[y>>2]|0)-1)>>0]|0)!=10:0){u=c[n>>2]|0;v=c[o>>2]|0;c[j>>2]=c[m>>2];Db[u&511](v,63808,j);break}v=c[n>>2]|0;u=c[o>>2]|0;c[j>>2]=c[m>>2];Db[v&511](u,63288,j)}else{u=c[n>>2]|0;v=c[o>>2]|0;c[j>>2]=63816;Db[u&511](v,63808,j)}while(0);if((c[l>>2]|0)!=0?(fe(c[w>>2]|0,c[n>>2]|0,c[o>>2]|0),(c[x>>2]|0)!=0):0){if(!(c[(c[x>>2]|0)+4>>2]|0)){if((c[q>>2]|0)!=0&(c[s>>2]|0)==1){q=c[n>>2]|0;w=c[o>>2]|0;c[j>>2]=c[(c[x>>2]|0)+28>>2];Db[q&511](w,63856,j)}}else{w=c[n>>2]|0;q=c[o>>2]|0;l=c[(c[x>>2]|0)+28>>2]|0;c[j>>2]=c[(c[x>>2]|0)+4>>2];c[j+4>>2]=l;Db[w&511](q,63840,j)}fe(c[x>>2]|0,c[n>>2]|0,c[o>>2]|0)}if((c[s>>2]|0)!=12){i=h;return}if(!(c[(c[k>>2]|0)+24>>2]|0)){i=h;return}if((c[(c[k>>2]|0)+36>>2]|0)>=100){i=h;return}s=c[(c[k>>2]|0)+36>>2]|0;if((s|0)>=(xy(c[(c[k>>2]|0)+24>>2]|0)|0)){i=h;return}s=c[n>>2]|0;x=c[o>>2]|0;c[j>>2]=c[(c[k>>2]|0)+24>>2];Db[s&511](x,63808,j);c[A>>2]=0;while(1){B=c[A>>2]|0;if((c[A>>2]|0)>=(c[(c[k>>2]|0)+36>>2]|0))break;a[z+B>>0]=32;c[A>>2]=(c[A>>2]|0)+1}c[A>>2]=B+1;a[z+B>>0]=94;a[z+(c[A>>2]|0)>>0]=0;A=c[n>>2]|0;n=c[o>>2]|0;c[j>>2]=z;Db[A&511](n,63808,j);i=h;return}function he(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b;e=b+12|0;f=b+8|0;c[e>>2]=a;c[f>>2]=20902;Rf();if(((c[f>>2]|0)/1e4|0|0)!=((c[e>>2]|0)/1e4|0|0)){a=c[33976]|0;g=c[33980]|0;h=(c[f>>2]|0)/1e4|0;c[d>>2]=(c[e>>2]|0)/1e4|0;c[d+4>>2]=h;Db[a&511](g,63880,d);g=c[o>>2]|0;a=(c[f>>2]|0)/1e4|0;c[d>>2]=(c[e>>2]|0)/1e4|0;c[d+4>>2]=a;Ka(g|0,63880,d|0)|0}if(((c[f>>2]|0)/100|0|0)>=((c[e>>2]|0)/100|0|0)){i=b;return}g=c[33976]|0;a=c[33980]|0;h=(c[f>>2]|0)/100|0;c[d>>2]=(c[e>>2]|0)/100|0;c[d+4>>2]=h;Db[g&511](a,63944,d);i=b;return}function ie(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;g=d+4|0;c[f>>2]=a;c[g>>2]=b;if(((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+212>>2]|0)!=0:0)?(c[(c[f>>2]|0)+172>>2]|0)==-1:0){i=d;return}if(c[f>>2]|0){c[(c[f>>2]|0)+84>>2]=2;c[(c[f>>2]|0)+172>>2]=-1;c[(c[f>>2]|0)+212>>2]=1}b=c[f>>2]|0;if(c[g>>2]|0){f=c[g>>2]|0;c[e>>2]=c[g>>2];Xd(0,0,0,b,0,1,2,3,0,0,f,0,0,0,0,64008,e);i=d;return}else{Xd(0,0,0,b,0,1,2,3,0,0,0,0,0,0,0,64040,e);i=d;return}}function je(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+32|0;h=g;j=g+24|0;k=g+20|0;l=g+16|0;m=g+12|0;n=g+8|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;if(((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+212>>2]|0)!=0:0)?(c[(c[j>>2]|0)+172>>2]|0)==-1:0){i=g;return}if(c[j>>2]|0)c[(c[j>>2]|0)+84>>2]=c[k>>2];f=c[j>>2]|0;e=c[k>>2]|0;k=c[m>>2]|0;d=c[n>>2]|0;b=c[l>>2]|0;l=c[n>>2]|0;c[h>>2]=c[m>>2];c[h+4>>2]=l;Xd(0,0,0,f,0,1,e,3,0,0,k,d,0,0,0,b,h);if(!(c[j>>2]|0)){i=g;return}c[(c[j>>2]|0)+12>>2]=0;if(c[(c[j>>2]|0)+288>>2]|0){i=g;return}c[(c[j>>2]|0)+212>>2]=1;i=g;return}function ke(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)==0|(c[g>>2]|0)<0){c[e>>2]=-1;l=c[e>>2]|0;i=d;return l|0}if(!(c[c[f>>2]>>2]|0)){c[e>>2]=-1;l=c[e>>2]|0;i=d;return l|0}if(!(c[(c[f>>2]|0)+12>>2]|0)){c[e>>2]=-1;l=c[e>>2]|0;i=d;return l|0}if(!(c[(c[f>>2]|0)+16>>2]|0)){c[e>>2]=-1;l=c[e>>2]|0;i=d;return l|0}if(!(c[(c[c[f>>2]>>2]|0)+16>>2]|0)){c[e>>2]=-1;l=c[e>>2]|0;i=d;return l|0}c[j>>2]=(c[(c[f>>2]|0)+16>>2]|0)-(c[(c[f>>2]|0)+12>>2]|0);b=_y(c[(c[c[f>>2]>>2]|0)+16>>2]|0)|0;if(b>>>0>((c[j>>2]|0)+250|0)>>>0){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}if(!(c[(c[c[f>>2]>>2]|0)+4>>2]|0)){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}c[h>>2]=Mk(c[c[f>>2]>>2]|0,c[g>>2]|0)|0;c[k>>2]=Vy(c[(c[c[f>>2]>>2]|0)+16>>2]|0)|0;if((c[(c[f>>2]|0)+12>>2]|0)!=(c[k>>2]|0)){c[j>>2]=(c[(c[f>>2]|0)+16>>2]|0)-(c[(c[f>>2]|0)+12>>2]|0);c[(c[f>>2]|0)+12>>2]=c[k>>2];c[(c[f>>2]|0)+16>>2]=(c[k>>2]|0)+(c[j>>2]|0)}j=Wy(c[(c[c[f>>2]>>2]|0)+16>>2]|0)|0;c[(c[f>>2]|0)+20>>2]=j;c[e>>2]=c[h>>2];l=c[e>>2]|0;i=d;return l|0}function le(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+32|0;d=b+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(!(c[c[d>>2]>>2]|0)){i=b;return}if(!(c[(c[d>>2]|0)+12>>2]|0)){i=b;return}if(!(c[(c[d>>2]|0)+16>>2]|0)){i=b;return}if(!(c[(c[c[d>>2]>>2]|0)+16>>2]|0)){i=b;return}a=c[(c[d>>2]|0)+16>>2]|0;c[e>>2]=a-(Vy(c[(c[c[d>>2]>>2]|0)+16>>2]|0)|0);if((c[e>>2]|0)>>>0>250){c[f>>2]=Ty(c[(c[c[d>>2]>>2]|0)+16>>2]|0,(c[e>>2]|0)-80|0)|0;if((c[f>>2]|0)>>>0>0){e=(c[d>>2]|0)+16|0;c[e>>2]=(c[e>>2]|0)+(0-(c[f>>2]|0));e=(c[d>>2]|0)+36|0;c[e>>2]=(c[e>>2]|0)+(c[f>>2]|0)}f=Wy(c[(c[c[d>>2]>>2]|0)+16>>2]|0)|0;c[(c[d>>2]|0)+20>>2]=f}if((_y(c[(c[c[d>>2]>>2]|0)+16>>2]|0)|0)>>>0>250){i=b;return}Nk(c[c[d>>2]>>2]|0,500)|0;c[h>>2]=Vy(c[(c[c[d>>2]>>2]|0)+16>>2]|0)|0;if((c[(c[d>>2]|0)+12>>2]|0)!=(c[h>>2]|0)){c[g>>2]=(c[(c[d>>2]|0)+16>>2]|0)-(c[(c[d>>2]|0)+12>>2]|0);c[(c[d>>2]|0)+12>>2]=c[h>>2];c[(c[d>>2]|0)+16>>2]=(c[h>>2]|0)+(c[g>>2]|0)}g=Wy(c[(c[c[d>>2]>>2]|0)+16>>2]|0)|0;c[(c[d>>2]|0)+20>>2]=g;i=b;return}function me(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+192|0;f=e;g=e+24|0;h=e+20|0;j=e+178|0;k=e+16|0;l=e+28|0;c[g>>2]=b;if(!(c[g>>2]|0)){i=e;return}if((c[(c[g>>2]|0)+172>>2]|0)==-1){i=e;return}if(!(c[(c[g>>2]|0)+36>>2]|0)){i=e;return}b=d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0;do if((c[(c[g>>2]|0)+256>>2]|0)==1){if(((b|0)==0?(ke(c[(c[g>>2]|0)+36>>2]|0,250)|0)<=0:0)?(c[(c[g>>2]|0)+172>>2]|0)!=5:0){Ve(c[g>>2]|0)|0;break}m=c[(c[g>>2]|0)+36>>2]|0;if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){n=m+28|0;c[n>>2]=(c[n>>2]|0)+1;c[(c[(c[g>>2]|0)+36>>2]|0)+32>>2]=1}else{n=m+32|0;c[n>>2]=(c[n>>2]|0)+1}c[h>>2]=c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2];a[j>>0]=a[c[h>>2]>>0]|0;a:do if((d[j>>0]|0)&128){do if((d[j>>0]|0|0)!=192){if(!(d[(c[h>>2]|0)+1>>0]|0)){ke(c[(c[g>>2]|0)+36>>2]|0,250)|0;c[h>>2]=c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]}if(((d[(c[h>>2]|0)+1>>0]|0)&192|0)==128){if(((d[j>>0]|0)&224|0)!=224){n=(c[(c[g>>2]|0)+36>>2]|0)+16|0;c[n>>2]=(c[n>>2]|0)+2;break a}if(!(d[(c[h>>2]|0)+2>>0]|0)){ke(c[(c[g>>2]|0)+36>>2]|0,250)|0;c[h>>2]=c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]}if(((d[(c[h>>2]|0)+2>>0]|0)&192|0)==128){if(((d[j>>0]|0)&240|0)==240){if(!(d[(c[h>>2]|0)+3>>0]|0)){ke(c[(c[g>>2]|0)+36>>2]|0,250)|0;c[h>>2]=c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]}if(((d[j>>0]|0)&248|0)!=240)break;if(((d[(c[h>>2]|0)+3>>0]|0)&192|0)!=128)break;n=(c[(c[g>>2]|0)+36>>2]|0)+16|0;c[n>>2]=(c[n>>2]|0)+4;c[k>>2]=((d[c[h>>2]>>0]|0)&7)<<18;c[k>>2]=c[k>>2]|((d[(c[h>>2]|0)+1>>0]|0)&63)<<12;c[k>>2]=c[k>>2]|((d[(c[h>>2]|0)+2>>0]|0)&63)<<6;c[k>>2]=c[k>>2]|(d[(c[h>>2]|0)+3>>0]|0)&63}else{n=(c[(c[g>>2]|0)+36>>2]|0)+16|0;c[n>>2]=(c[n>>2]|0)+3;c[k>>2]=((d[c[h>>2]>>0]|0)&15)<<12;c[k>>2]=c[k>>2]|((d[(c[h>>2]|0)+1>>0]|0)&63)<<6;c[k>>2]=c[k>>2]|(d[(c[h>>2]|0)+2>>0]|0)&63}if(!((c[k>>2]|0)>>>0>55295&(c[k>>2]|0)>>>0<57344)?!((c[k>>2]|0)>>>0>65533&(c[k>>2]|0)>>>0<65536|(c[k>>2]|0)>>>0>=1114112):0)break a;Ie(c[g>>2]|0,9,64072,c[k>>2]|0);break a}}}while(0);if(((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+36>>2]|0)!=0:0)?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=4:0){n=d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0;m=d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0;o=d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0;c[f>>2]=d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0];c[f+4>>2]=n;c[f+8>>2]=m;c[f+12>>2]=o;JT(l,149,64152,f)|0;je(c[g>>2]|0,9,64192,l,0)}else je(c[g>>2]|0,9,64104,0,0);c[(c[g>>2]|0)+256>>2]=10;o=(c[(c[g>>2]|0)+36>>2]|0)+16|0;c[o>>2]=(c[o>>2]|0)+1;i=e;return}else{o=(c[(c[g>>2]|0)+36>>2]|0)+16|0;c[o>>2]=(c[o>>2]|0)+1}while(0);o=(c[g>>2]|0)+200|0;c[o>>2]=(c[o>>2]|0)+1;if(!(d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0))ke(c[(c[g>>2]|0)+36>>2]|0,250)|0}else{o=c[(c[g>>2]|0)+36>>2]|0;if((b|0)==10){m=o+28|0;c[m>>2]=(c[m>>2]|0)+1;c[(c[(c[g>>2]|0)+36>>2]|0)+32>>2]=1}else{m=o+32|0;c[m>>2]=(c[m>>2]|0)+1}m=(c[(c[g>>2]|0)+36>>2]|0)+16|0;c[m>>2]=(c[m>>2]|0)+1;m=(c[g>>2]|0)+200|0;c[m>>2]=(c[m>>2]|0)+1;if(!(d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0))ke(c[(c[g>>2]|0)+36>>2]|0,250)|0}while(0);if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37?(c[(c[g>>2]|0)+32>>2]|0)==0:0)We(c[g>>2]|0);if(d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0){i=e;return}if((ke(c[(c[g>>2]|0)+36>>2]|0,250)|0)>0){i=e;return}Ve(c[g>>2]|0)|0;i=e;return}function ne(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+192|0;g=f;h=f+32|0;j=f+28|0;k=f+24|0;l=f+20|0;m=f+186|0;n=f+16|0;o=f+36|0;c[j>>2]=b;c[k>>2]=e;if(!((c[j>>2]|0)==0|(c[k>>2]|0)==0)?(c[(c[j>>2]|0)+36>>2]|0)!=0:0){if((c[(c[j>>2]|0)+172>>2]|0)==-1){c[h>>2]=0;p=c[h>>2]|0;i=f;return p|0}if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)>=32?(d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=127:0){c[c[k>>2]>>2]=1;c[h>>2]=d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0];p=c[h>>2]|0;i=f;return p|0}if((c[(c[j>>2]|0)+256>>2]|0)!=1){c[c[k>>2]>>2]=1;e=c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0;if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13){c[h>>2]=d[e>>0];p=c[h>>2]|0;i=f;return p|0}if((d[e+1>>0]|0|0)==10){e=(c[j>>2]|0)+200|0;c[e>>2]=(c[e>>2]|0)+1;e=(c[(c[j>>2]|0)+36>>2]|0)+16|0;c[e>>2]=(c[e>>2]|0)+1}c[h>>2]=10;p=c[h>>2]|0;i=f;return p|0}c[l>>2]=c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2];a[m>>0]=a[c[l>>2]>>0]|0;if(!((d[m>>0]|0)&128)){c[c[k>>2]>>2]=1;if(!(d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0))ke(c[(c[j>>2]|0)+36>>2]|0,250)|0;if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(c[(c[(c[j>>2]|0)+36>>2]|0)+20>>2]|0)>>>0>(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)>>>0:0)Ie(c[j>>2]|0,9,64248,0);e=c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0;if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13){c[h>>2]=d[e>>0];p=c[h>>2]|0;i=f;return p|0}if((d[e+1>>0]|0|0)==10){e=(c[j>>2]|0)+200|0;c[e>>2]=(c[e>>2]|0)+1;e=(c[(c[j>>2]|0)+36>>2]|0)+16|0;c[e>>2]=(c[e>>2]|0)+1}c[h>>2]=10;p=c[h>>2]|0;i=f;return p|0}a:do if(((d[m>>0]|0)&64|0)!=0?(d[m>>0]|0|0)!=192:0){if(!(d[(c[l>>2]|0)+1>>0]|0)){ke(c[(c[j>>2]|0)+36>>2]|0,250)|0;c[l>>2]=c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]}if(((d[(c[l>>2]|0)+1>>0]|0)&192|0)==128){do if(((d[m>>0]|0)&224|0)==224){if(!(d[(c[l>>2]|0)+2>>0]|0)){ke(c[(c[j>>2]|0)+36>>2]|0,250)|0;
c[l>>2]=c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]}if(((d[(c[l>>2]|0)+2>>0]|0)&192|0)!=128)break a;if(((d[m>>0]|0)&240|0)!=240){c[c[k>>2]>>2]=3;c[n>>2]=((d[c[l>>2]>>0]|0)&15)<<12;c[n>>2]=c[n>>2]|((d[(c[l>>2]|0)+1>>0]|0)&63)<<6;c[n>>2]=c[n>>2]|(d[(c[l>>2]|0)+2>>0]|0)&63;if((c[n>>2]|0)>>>0<2048)break a;else break}if(!(d[(c[l>>2]|0)+3>>0]|0)){ke(c[(c[j>>2]|0)+36>>2]|0,250)|0;c[l>>2]=c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]}if(((d[m>>0]|0)&248|0)!=240)break a;if(((d[(c[l>>2]|0)+3>>0]|0)&192|0)!=128)break a;c[c[k>>2]>>2]=4;c[n>>2]=((d[c[l>>2]>>0]|0)&7)<<18;c[n>>2]=c[n>>2]|((d[(c[l>>2]|0)+1>>0]|0)&63)<<12;c[n>>2]=c[n>>2]|((d[(c[l>>2]|0)+2>>0]|0)&63)<<6;c[n>>2]=c[n>>2]|(d[(c[l>>2]|0)+3>>0]|0)&63;if((c[n>>2]|0)>>>0<65536)break a}else{c[c[k>>2]>>2]=2;c[n>>2]=((d[c[l>>2]>>0]|0)&31)<<6;c[n>>2]=c[n>>2]|(d[(c[l>>2]|0)+1>>0]|0)&63;if((c[n>>2]|0)>>>0<128)break a}while(0);e=c[n>>2]|0;if((c[n>>2]|0)>>>0<256){if(!(9<=e>>>0&(c[n>>2]|0)>>>0<=10|(c[n>>2]|0)==13|32<=(c[n>>2]|0)>>>0))q=33}else if((!(256<=e>>>0&(c[n>>2]|0)>>>0<=55295)?!(57344<=(c[n>>2]|0)>>>0&(c[n>>2]|0)>>>0<=65533):0)?!(65536<=(c[n>>2]|0)>>>0&(c[n>>2]|0)>>>0<=1114111):0)q=33;if((q|0)==33)Ie(c[j>>2]|0,9,64072,c[n>>2]|0);c[h>>2]=c[n>>2];p=c[h>>2]|0;i=f;return p|0}}while(0);if(((c[(c[(c[j>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)|0)<4){c[c[k>>2]>>2]=0;c[h>>2]=0;p=c[h>>2]|0;i=f;return p|0}else{n=d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0;q=d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0;l=d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0;c[g>>2]=d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0];c[g+4>>2]=n;c[g+8>>2]=q;c[g+12>>2]=l;JT(o,149,64152,g)|0;je(c[j>>2]|0,9,64192,o,0);c[(c[j>>2]|0)+256>>2]=10;c[c[k>>2]>>2]=1;c[h>>2]=d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0];p=c[h>>2]|0;i=f;return p|0}}c[h>>2]=0;p=c[h>>2]|0;i=f;return p|0}function oe(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+192|0;h=g;j=g+32|0;k=g+28|0;l=g+24|0;m=g+20|0;n=g+186|0;o=g+16|0;p=g+36|0;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;if((c[m>>2]|0)==0|(c[l>>2]|0)==0){c[j>>2]=0;q=c[j>>2]|0;i=g;return q|0}if((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+256>>2]|0)!=1:0){c[c[m>>2]>>2]=1;c[j>>2]=d[c[l>>2]>>0];q=c[j>>2]|0;i=g;return q|0}a[n>>0]=a[c[l>>2]>>0]|0;if(!((d[n>>0]|0)&128)){c[c[m>>2]>>2]=1;c[j>>2]=d[c[l>>2]>>0];q=c[j>>2]|0;i=g;return q|0}a:do if(((d[(c[l>>2]|0)+1>>0]|0)&192|0)==128){do if(((d[n>>0]|0)&224|0)==224){if(((d[(c[l>>2]|0)+2>>0]|0)&192|0)!=128)break a;if(((d[n>>0]|0)&240|0)!=240){c[c[m>>2]>>2]=3;c[o>>2]=((d[c[l>>2]>>0]|0)&15)<<12;c[o>>2]=c[o>>2]|((d[(c[l>>2]|0)+1>>0]|0)&63)<<6;c[o>>2]=c[o>>2]|(d[(c[l>>2]|0)+2>>0]|0)&63;break}if(((d[n>>0]|0)&248|0)!=240)break a;if(((d[(c[l>>2]|0)+3>>0]|0)&192|0)!=128)break a;c[c[m>>2]>>2]=4;c[o>>2]=((d[c[l>>2]>>0]|0)&7)<<18;c[o>>2]=c[o>>2]|((d[(c[l>>2]|0)+1>>0]|0)&63)<<12;c[o>>2]=c[o>>2]|((d[(c[l>>2]|0)+2>>0]|0)&63)<<6;c[o>>2]=c[o>>2]|(d[(c[l>>2]|0)+3>>0]|0)&63}else{c[c[m>>2]>>2]=2;c[o>>2]=((d[c[l>>2]>>0]|0)&31)<<6;c[o>>2]=c[o>>2]|(d[(c[l>>2]|0)+1>>0]|0)&63}while(0);f=c[o>>2]|0;if((c[o>>2]|0)>>>0<256){if(!(9<=f>>>0&(c[o>>2]|0)>>>0<=10|(c[o>>2]|0)==13|32<=(c[o>>2]|0)>>>0))r=20}else if((!(256<=f>>>0&(c[o>>2]|0)>>>0<=55295)?!(57344<=(c[o>>2]|0)>>>0&(c[o>>2]|0)>>>0<=65533):0)?!(65536<=(c[o>>2]|0)>>>0&(c[o>>2]|0)>>>0<=1114111):0)r=20;if((r|0)==20)Ie(c[k>>2]|0,9,64072,c[o>>2]|0);c[j>>2]=c[o>>2];q=c[j>>2]|0;i=g;return q|0}while(0);if(((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+36>>2]|0)!=0:0)?((c[(c[(c[k>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[k>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=4:0){o=d[(c[(c[(c[k>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0;r=d[(c[(c[(c[k>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0;n=d[(c[(c[(c[k>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0;c[h>>2]=d[c[(c[(c[k>>2]|0)+36>>2]|0)+16>>2]>>0];c[h+4>>2]=o;c[h+8>>2]=r;c[h+12>>2]=n;JT(p,149,64152,h)|0;je(c[k>>2]|0,9,64192,p,0);c[c[m>>2]>>2]=1;c[j>>2]=d[c[l>>2]>>0];q=c[j>>2]|0;i=g;return q|0}c[c[m>>2]>>2]=0;c[j>>2]=0;q=c[j>>2]|0;i=g;return q|0}function pe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=b;c[h>>2]=d;if(!(c[g>>2]|0)){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}if((c[h>>2]|0)<128){a[c[g>>2]>>0]=c[h>>2];c[f>>2]=1;l=c[f>>2]|0;i=e;return l|0}c[j>>2]=c[g>>2];d=c[h>>2]|0;do if((c[h>>2]|0)<2048){b=c[g>>2]|0;c[g>>2]=b+1;a[b>>0]=d>>6|192;c[k>>2]=0}else{b=c[h>>2]|0;if((d|0)<65536){m=c[g>>2]|0;c[g>>2]=m+1;a[m>>0]=b>>12|224;c[k>>2]=6;break}m=c[h>>2]|0;if((b|0)<1114112){b=c[g>>2]|0;c[g>>2]=b+1;a[b>>0]=m>>18|240;c[k>>2]=12;break}Ie(0,9,64280,m);c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}while(0);while(1){if((c[k>>2]|0)<0)break;d=(c[h>>2]>>c[k>>2]&63|128)&255;m=c[g>>2]|0;c[g>>2]=m+1;a[m>>0]=d;c[k>>2]=(c[k>>2]|0)-6}c[f>>2]=(c[g>>2]|0)-(c[j>>2]|0);l=c[f>>2]|0;i=e;return l|0}function qe(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f+12|0;h=f+4|0;j=f;c[f+8>>2]=b;c[h>>2]=d;c[j>>2]=e;do if(c[h>>2]|0)if((c[j>>2]|0)>=128){c[g>>2]=pe(c[h>>2]|0,c[j>>2]|0)|0;break}else{a[c[h>>2]>>0]=c[j>>2];c[g>>2]=1;break}else c[g>>2]=0;while(0);i=f;return c[g>>2]|0}function re(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[k>>2]=-1;if(!(c[g>>2]|0)){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}switch(c[h>>2]|0){case 1:{c[(c[g>>2]|0)+256>>2]=1;if((((c[(c[g>>2]|0)+36>>2]|0)!=0?(d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==239:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==187:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==191:0){b=(c[(c[g>>2]|0)+36>>2]|0)+16|0;c[b>>2]=(c[b>>2]|0)+3}c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}case 21:case 20:case 19:case 22:case 18:case 17:case 16:case 15:case 14:case 13:case 12:case 11:case 10:case 6:{c[k>>2]=45;break}case-1:{je(c[g>>2]|0,31,64336,0,0);c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}case 0:{c[(c[g>>2]|0)+256>>2]=1;c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}case 9:{c[k>>2]=90;break}case 8:case 7:case 4:case 5:{c[k>>2]=180;break}case 3:case 2:{if(((((c[(c[g>>2]|0)+36>>2]|0)!=0?(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)!=0:0)?(d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==239:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==187:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==191:0){b=(c[(c[g>>2]|0)+36>>2]|0)+16|0;c[b>>2]=(c[b>>2]|0)+3}c[k>>2]=90;break}default:{}}c[j>>2]=Cd(c[h>>2]|0)|0;a:do if(!(c[j>>2]|0))do switch(c[h>>2]|0){case 8:{je(c[g>>2]|0,32,64360,64456,0);break a;break}case 9:{je(c[g>>2]|0,32,64360,64472,0);break a;break}case 7:{je(c[g>>2]|0,32,64360,64440,0);break a;break}case 18:case 17:case 16:case 15:case 14:case 13:case 12:case 11:case 10:{if((((c[(c[g>>2]|0)+40>>2]|0)==1?(c[(c[g>>2]|0)+24>>2]|0)==0:0)?(c[(c[g>>2]|0)+36>>2]|0)!=0:0)?(c[(c[(c[g>>2]|0)+36>>2]|0)+44>>2]|0)!=0:0){b=my(c[(c[(c[g>>2]|0)+36>>2]|0)+44>>2]|0)|0;c[(c[g>>2]|0)+24>>2]=b}c[(c[g>>2]|0)+256>>2]=c[h>>2];c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}case 19:{je(c[g>>2]|0,32,64360,64480,0);break a;break}case 20:{je(c[g>>2]|0,32,64360,64496,0);break a;break}case 22:{c[(c[g>>2]|0)+256>>2]=1;c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}case 4:{je(c[g>>2]|0,32,64360,64392,0);break a;break}case 5:{je(c[g>>2]|0,32,64360,64416,0);break a;break}case 21:{je(c[g>>2]|0,32,64360,64512,0);break a;break}case 6:{je(c[g>>2]|0,32,64360,64432,0);break a;break}default:break a}while(0);while(0);if(!(c[j>>2]|0)){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}else{c[(c[g>>2]|0)+256>>2]=1;c[f>>2]=Je(c[g>>2]|0,c[j>>2]|0,c[k>>2]|0)|0;l=c[f>>2]|0;i=e;return l|0}return 0}function se(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=Je(c[e>>2]|0,c[f>>2]|0,-1)|0;i=d;return b|0}function te(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+4>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+4>>2]|0);if(c[(c[d>>2]|0)+8>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+8>>2]|0);if(c[(c[d>>2]|0)+44>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+44>>2]|0);if(c[(c[d>>2]|0)+48>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+48>>2]|0);if((c[(c[d>>2]|0)+40>>2]|0)!=0?(c[(c[d>>2]|0)+12>>2]|0)!=0:0)zb[c[(c[d>>2]|0)+40>>2]&511](c[(c[d>>2]|0)+12>>2]|0);if(c[c[d>>2]>>2]|0)yk(c[c[d>>2]>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function ue(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](60)|0;if(!(c[f>>2]|0)){ie(c[e>>2]|0,64520);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}a=(c[f>>2]|0)+0|0;h=a+60|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(h|0));c[(c[f>>2]|0)+28>>2]=1;c[(c[f>>2]|0)+32>>2]=1;c[(c[f>>2]|0)+52>>2]=-1;if(c[e>>2]|0){a=(c[e>>2]|0)+464|0;e=c[a>>2]|0;c[a>>2]=e+1;c[(c[f>>2]|0)+56>>2]=e}c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}function ve(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(!(c[h>>2]|0)){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}if(c[33952]|0)Db[c[135904>>2]&511](c[33980]|0,64560,e);c[k>>2]=ue(c[g>>2]|0)|0;if(!(c[k>>2]|0)){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}c[(c[k>>2]|0)+4>>2]=0;c[c[k>>2]>>2]=c[h>>2];iz(c[(c[c[k>>2]>>2]|0)+16>>2]|0,c[k>>2]|0)|0;if(c[j>>2]|0)re(c[g>>2]|0,c[j>>2]|0)|0;c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}function we(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;c[g>>2]=a;c[h>>2]=b;if(!(c[h>>2]|0)){Le(c[g>>2]|0,64584,0);c[f>>2]=0;k=c[f>>2]|0;i=d;return k|0}if(c[33952]|0){b=c[33976]|0;a=c[33980]|0;c[e>>2]=c[(c[h>>2]|0)+8>>2];Db[b&511](a,64624,e)}if(c[(c[h>>2]|0)+40>>2]|0){c[j>>2]=ue(c[g>>2]|0)|0;if(!(c[j>>2]|0)){c[f>>2]=0;k=c[f>>2]|0;i=d;return k|0}if(c[(c[h>>2]|0)+64>>2]|0){e=my(c[(c[h>>2]|0)+64>>2]|0)|0;c[(c[j>>2]|0)+4>>2]=e}c[(c[j>>2]|0)+12>>2]=c[(c[h>>2]|0)+40>>2];c[(c[j>>2]|0)+16>>2]=c[(c[h>>2]|0)+40>>2];c[(c[j>>2]|0)+24>>2]=c[(c[h>>2]|0)+44>>2];c[(c[j>>2]|0)+20>>2]=(c[(c[h>>2]|0)+40>>2]|0)+(c[(c[j>>2]|0)+24>>2]|0);c[f>>2]=c[j>>2];k=c[f>>2]|0;i=d;return k|0}switch(c[(c[h>>2]|0)+48>>2]|0){case 4:{Le(c[g>>2]|0,64720,c[(c[h>>2]|0)+8>>2]|0);break}case 1:{Le(c[g>>2]|0,64680,c[(c[h>>2]|0)+8>>2]|0);break}case 6:{Le(c[g>>2]|0,64768,c[(c[h>>2]|0)+8>>2]|0);break}case 3:{Le(c[g>>2]|0,64656,c[(c[h>>2]|0)+8>>2]|0);break}case 5:case 2:{c[f>>2]=Vk(c[(c[h>>2]|0)+64>>2]|0,c[(c[h>>2]|0)+52>>2]|0,c[g>>2]|0)|0;k=c[f>>2]|0;i=d;return k|0}default:{}}c[f>>2]=0;k=c[f>>2]|0;i=d;return k|0}function xe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d;f=d+28|0;g=d+24|0;h=d+20|0;j=d+16|0;k=d+12|0;l=d+8|0;m=d+4|0;c[g>>2]=a;c[h>>2]=b;c[l>>2]=0;c[m>>2]=0;if(c[33952]|0){b=c[33976]|0;a=c[33980]|0;c[e>>2]=c[h>>2];Db[b&511](a,64808,e)}if(!(c[g>>2]|0)){c[f>>2]=0;n=c[f>>2]|0;i=d;return n|0}c[j>>2]=Ck(c[h>>2]|0,0)|0;if(!(c[j>>2]|0)){e=c[g>>2]|0;if(!(c[h>>2]|0))ik(e,64840,0);else ik(e,64888,c[h>>2]|0);c[f>>2]=0;n=c[f>>2]|0;i=d;return n|0}c[k>>2]=ue(c[g>>2]|0)|0;if(!(c[k>>2]|0)){c[f>>2]=0;n=c[f>>2]|0;i=d;return n|0}c[c[k>>2]>>2]=c[j>>2];c[k>>2]=Sk(c[g>>2]|0,c[k>>2]|0)|0;if(!(c[k>>2]|0)){c[f>>2]=0;n=c[f>>2]|0;i=d;return n|0}if(!(c[(c[k>>2]|0)+4>>2]|0))c[m>>2]=my(c[h>>2]|0)|0;else c[m>>2]=my(c[(c[k>>2]|0)+4>>2]|0)|0;c[l>>2]=Rk(c[m>>2]|0)|0;if(c[(c[k>>2]|0)+4>>2]|0)zb[c[135736>>2]&511](c[(c[k>>2]|0)+4>>2]|0);h=Jl(c[m>>2]|0)|0;c[(c[k>>2]|0)+4>>2]=h;if(c[m>>2]|0)zb[c[135736>>2]&511](c[m>>2]|0);c[(c[k>>2]|0)+8>>2]=c[l>>2];iz(c[(c[c[k>>2]>>2]|0)+16>>2]|0,c[k>>2]|0)|0;if((c[l>>2]|0)!=0?(c[(c[g>>2]|0)+180>>2]|0)==0:0){m=my(c[l>>2]|0)|0;c[(c[g>>2]|0)+180>>2]=m}c[f>>2]=c[k>>2];n=c[f>>2]|0;i=d;return n|0}function ye(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if(!(c[e>>2]|0)){Le(0,64928,0);c[d>>2]=-1;g=c[d>>2]|0;i=b;return g|0}pQ();if(!(c[(c[e>>2]|0)+296>>2]|0)){a=xP()|0;c[(c[e>>2]|0)+296>>2]=a}if(!(c[(c[e>>2]|0)+296>>2]|0)){ie(0,64960);c[d>>2]=-1;g=c[d>>2]|0;i=b;return g|0}DP(c[(c[e>>2]|0)+296>>2]|0,1e7)|0;if(!(c[c[e>>2]>>2]|0)){a=Cb[c[135744>>2]&511](128)|0;c[c[e>>2]>>2]=a}if(!(c[c[e>>2]>>2]|0)){ie(0,64960);c[d>>2]=-1;g=c[d>>2]|0;i=b;return g|0}oQ(c[c[e>>2]>>2]|0,2)|0;c[(c[e>>2]|0)+304>>2]=0;c[(c[e>>2]|0)+300>>2]=0;if(!(c[(c[e>>2]|0)+48>>2]|0)){a=Cb[c[135744>>2]&511](20)|0;c[(c[e>>2]|0)+48>>2]=a;c[(c[e>>2]|0)+44>>2]=5}if(!(c[(c[e>>2]|0)+48>>2]|0)){ie(0,64960);c[(c[e>>2]|0)+40>>2]=0;c[(c[e>>2]|0)+44>>2]=0;c[(c[e>>2]|0)+36>>2]=0;c[d>>2]=-1;g=c[d>>2]|0;i=b;return g|0}while(1){a=Pe(c[e>>2]|0)|0;c[f>>2]=a;if(!a)break;te(c[f>>2]|0)}c[(c[e>>2]|0)+40>>2]=0;c[(c[e>>2]|0)+36>>2]=0;c[(c[e>>2]|0)+20>>2]=0;c[(c[e>>2]|0)+24>>2]=0;c[(c[e>>2]|0)+28>>2]=-1;c[(c[e>>2]|0)+88>>2]=0;c[(c[e>>2]|0)+92>>2]=0;c[(c[e>>2]|0)+32>>2]=0;c[(c[e>>2]|0)+96>>2]=0;c[(c[e>>2]|0)+172>>2]=0;c[(c[e>>2]|0)+176>>2]=0;c[(c[e>>2]|0)+180>>2]=0;if(!(c[(c[e>>2]|0)+64>>2]|0)){f=Cb[c[135744>>2]&511](40)|0;c[(c[e>>2]|0)+64>>2]=f;c[(c[e>>2]|0)+60>>2]=10}if(!(c[(c[e>>2]|0)+64>>2]|0)){ie(0,64960);c[(c[e>>2]|0)+56>>2]=0;c[(c[e>>2]|0)+60>>2]=0;c[(c[e>>2]|0)+52>>2]=0;c[(c[e>>2]|0)+40>>2]=0;c[(c[e>>2]|0)+44>>2]=0;c[(c[e>>2]|0)+36>>2]=0;c[d>>2]=-1;g=c[d>>2]|0;i=b;return g|0}c[(c[e>>2]|0)+56>>2]=0;c[(c[e>>2]|0)+52>>2]=0;if(!(c[(c[e>>2]|0)+196>>2]|0)){f=Cb[c[135744>>2]&511](40)|0;c[(c[e>>2]|0)+196>>2]=f;c[(c[e>>2]|0)+192>>2]=10}if(!(c[(c[e>>2]|0)+196>>2]|0)){ie(0,64960);c[(c[e>>2]|0)+56>>2]=0;c[(c[e>>2]|0)+60>>2]=0;c[(c[e>>2]|0)+52>>2]=0;c[(c[e>>2]|0)+40>>2]=0;c[(c[e>>2]|0)+44>>2]=0;c[(c[e>>2]|0)+36>>2]=0;c[(c[e>>2]|0)+188>>2]=0;c[(c[e>>2]|0)+192>>2]=0;c[(c[e>>2]|0)+184>>2]=0;c[d>>2]=-1;g=c[d>>2]|0;i=b;return g|0}c[(c[e>>2]|0)+188>>2]=0;c[(c[e>>2]|0)+184>>2]=0;if(!(c[(c[e>>2]|0)+244>>2]|0)){f=Cb[c[135744>>2]&511](40)|0;c[(c[e>>2]|0)+244>>2]=f;c[(c[e>>2]|0)+240>>2]=10}if(!(c[(c[e>>2]|0)+244>>2]|0)){ie(0,64960);c[(c[e>>2]|0)+56>>2]=0;c[(c[e>>2]|0)+60>>2]=0;c[(c[e>>2]|0)+52>>2]=0;c[(c[e>>2]|0)+40>>2]=0;c[(c[e>>2]|0)+44>>2]=0;c[(c[e>>2]|0)+36>>2]=0;c[(c[e>>2]|0)+188>>2]=0;c[(c[e>>2]|0)+192>>2]=0;c[(c[e>>2]|0)+184>>2]=0;c[(c[e>>2]|0)+236>>2]=0;c[(c[e>>2]|0)+240>>2]=0;c[(c[e>>2]|0)+232>>2]=0;c[d>>2]=-1;g=c[d>>2]|0;i=b;return g|0}c[(c[e>>2]|0)+236>>2]=1;c[(c[e>>2]|0)+240>>2]=10;c[c[(c[e>>2]|0)+244>>2]>>2]=-1;c[(c[e>>2]|0)+232>>2]=c[(c[e>>2]|0)+244>>2];c[(c[e>>2]|0)+4>>2]=c[e>>2];c[(c[e>>2]|0)+8>>2]=0;c[(c[e>>2]|0)+12>>2]=1;c[(c[e>>2]|0)+356>>2]=1;c[(c[e>>2]|0)+100>>2]=1;c[(c[e>>2]|0)+276>>2]=c[33958];if(c[(c[e>>2]|0)+276>>2]|0){f=(c[e>>2]|0)+360|0;c[f>>2]=c[f>>2]|4}c[(c[e>>2]|0)+104>>2]=c[33954];c[(c[e>>2]|0)+268>>2]=c[33960];if(c[(c[e>>2]|0)+268>>2]|0){f=(c[e>>2]|0)+360|0;c[f>>2]=c[f>>2]|128}c[(c[e>>2]|0)+280>>2]=c[33962];c[(c[e>>2]|0)+208>>2]=c[33964];if(!(c[(c[e>>2]|0)+208>>2]|0)){c[(c[c[e>>2]>>2]|0)+72>>2]=65;f=(c[e>>2]|0)+360|0;c[f>>2]=c[f>>2]|256}c[(c[e>>2]|0)+136>>2]=-1412623820;c[(c[e>>2]|0)+108>>2]=c[e>>2];c[(c[e>>2]|0)+112>>2]=224;c[(c[e>>2]|0)+116>>2]=225;if(c[(c[e>>2]|0)+104>>2]|0){f=(c[e>>2]|0)+116|0;if(!(c[33956]|0))c[f>>2]=0;else c[f>>2]=225;c[(c[e>>2]|0)+128>>2]=0;f=(c[e>>2]|0)+360|0;c[f>>2]=c[f>>2]|16}c[(c[e>>2]|0)+16>>2]=c[33966];if(c[(c[e>>2]|0)+16>>2]|0){f=(c[e>>2]|0)+360|0;c[f>>2]=c[f>>2]|2}c[(c[e>>2]|0)+68>>2]=0;c[(c[e>>2]|0)+200>>2]=0;c[(c[e>>2]|0)+204>>2]=0;c[(c[e>>2]|0)+216>>2]=0;c[(c[e>>2]|0)+84>>2]=0;c[(c[e>>2]|0)+248>>2]=0;c[(c[e>>2]|0)+256>>2]=1;c[(c[e>>2]|0)+284>>2]=0;c[(c[e>>2]|0)+440>>2]=0;c[(c[e>>2]|0)+444>>2]=0;c[(c[e>>2]|0)+468>>2]=0;c[(c[e>>2]|0)+464>>2]=1;ze((c[e>>2]|0)+72|0);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}function ze(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}c[(c[d>>2]|0)+4>>2]=0;c[c[d>>2]>>2]=0;c[(c[d>>2]|0)+8>>2]=0;i=b;return}function Ae(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;d=b+20|0;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;j=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}while(1){a=Pe(c[d>>2]|0)|0;c[e>>2]=a;if(!a)break;te(c[e>>2]|0)}if(c[(c[d>>2]|0)+244>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+244>>2]|0);if(c[(c[d>>2]|0)+196>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+196>>2]|0);if(c[(c[d>>2]|0)+64>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+64>>2]|0);if(c[(c[d>>2]|0)+460>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+460>>2]|0);if(c[(c[d>>2]|0)+48>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+48>>2]|0);if(c[(c[d>>2]|0)+20>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+20>>2]|0);if(c[(c[d>>2]|0)+24>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+24>>2]|0);if(c[(c[d>>2]|0)+224>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+224>>2]|0);if(c[(c[d>>2]|0)+228>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+228>>2]|0);if((c[c[d>>2]>>2]|0)!=0?(c[c[d>>2]>>2]|0)!=135968:0)zb[c[135736>>2]&511](c[c[d>>2]>>2]|0);if(c[(c[d>>2]|0)+180>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+180>>2]|0);if(c[(c[d>>2]|0)+132>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+132>>2]|0);if(c[(c[d>>2]|0)+300>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+300>>2]|0);if(c[(c[d>>2]|0)+296>>2]|0)zP(c[(c[d>>2]|0)+296>>2]|0);if(c[(c[d>>2]|0)+336>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+336>>2]|0);if(c[(c[d>>2]|0)+344>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+344>>2]|0);if(c[(c[d>>2]|0)+340>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+340>>2]|0);if(c[(c[d>>2]|0)+348>>2]|0)Kj(c[(c[d>>2]|0)+348>>2]|0,c[33934]|0);if(c[(c[d>>2]|0)+352>>2]|0)Kj(c[(c[d>>2]|0)+352>>2]|0,0);a:do if(c[(c[d>>2]|0)+372>>2]|0){c[f>>2]=c[(c[d>>2]|0)+372>>2];while(1){if(!(c[f>>2]|0))break a;c[g>>2]=c[(c[f>>2]|0)+24>>2];zb[c[135736>>2]&511](c[f>>2]|0);c[f>>2]=c[g>>2]}}while(0);b:do if(c[(c[d>>2]|0)+380>>2]|0){c[h>>2]=c[(c[d>>2]|0)+380>>2];while(1){if(!(c[h>>2]|0))break b;c[j>>2]=c[(c[h>>2]|0)+24>>2];zb[c[135736>>2]&511](c[h>>2]|0);c[h>>2]=c[j>>2]}}while(0);if(c[(c[d>>2]|0)+392>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+392>>2]|0);if(c[(c[d>>2]|0)+400>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+400>>2]|0);if(c[(c[d>>2]|0)+408>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+408>>2]|0);if(c[(c[d>>2]|0)+412>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+412>>2]|0);if(c[(c[d>>2]|0)+416>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+416>>2]|0);if(c[(c[d>>2]|0)+284>>2]|0)Hw(c[(c[d>>2]|0)+284>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function Be(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=Cb[c[135744>>2]&511](472)|0;do if(c[d>>2]|0){cU(c[d>>2]|0,0,472)|0;e=(ye(c[d>>2]|0)|0)<0;f=c[d>>2]|0;if(e){Ae(f);c[b>>2]=0;break}else{c[b>>2]=f;break}}else{ie(0,65e3);c[b>>2]=0}while(0);i=a;return c[b>>2]|0}function Ce(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[f>>2]=a;c[g>>2]=b;c[l>>2]=0;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){c[e>>2]=-1;m=c[e>>2]|0;i=d;return m|0}c[j>>2]=1;c[h>>2]=c[(c[f>>2]|0)+4>>2];c[k>>2]=0;while(1){if((c[j>>2]|0)>>>0>(c[h>>2]|0)>>>0)break;if(!((c[l>>2]|0)!=0^1))break;c[k>>2]=(c[j>>2]|0)+((((c[h>>2]|0)-(c[j>>2]|0)|0)>>>0)/2|0);if((c[g>>2]|0)==(c[(c[(c[f>>2]|0)+8>>2]|0)+(((c[k>>2]|0)-1|0)*20|0)>>2]|0)){c[l>>2]=1;continue}b=c[k>>2]|0;if((c[g>>2]|0)>>>0<(c[(c[(c[f>>2]|0)+8>>2]|0)+(((c[k>>2]|0)-1|0)*20|0)>>2]|0)>>>0){c[h>>2]=b-1;continue}else{c[j>>2]=b+1;continue}}if((c[k>>2]|0)!=0?(c[(c[(c[f>>2]|0)+8>>2]|0)+(((c[k>>2]|0)-1|0)*20|0)>>2]|0)>>>0>=(c[g>>2]|0)>>>0:0){c[e>>2]=(c[k>>2]|0)-1;m=c[e>>2]|0;i=d;return m|0}c[e>>2]=c[k>>2];m=c[e>>2]|0;i=d;return m|0}function De(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[e>>2]=a;c[f>>2]=b;if((c[e>>2]|0)==0|(c[f>>2]|0)==0){i=d;return}c[g>>2]=Ce((c[e>>2]|0)+72|0,c[c[f>>2]>>2]|0)|0;if(((c[g>>2]|0)>>>0<(c[(c[e>>2]|0)+76>>2]|0)>>>0?(c[(c[e>>2]|0)+80>>2]|0)!=0:0)?(c[(c[(c[e>>2]|0)+80>>2]|0)+((c[g>>2]|0)*20|0)>>2]|0)==(c[c[f>>2]>>2]|0):0){b=(c[(c[e>>2]|0)+80>>2]|0)+((c[g>>2]|0)*20|0)|0;a=c[f>>2]|0;c[b+0>>2]=c[a+0>>2];c[b+4>>2]=c[a+4>>2];c[b+8>>2]=c[a+8>>2];c[b+12>>2]=c[a+12>>2];c[b+16>>2]=c[a+16>>2];i=d;return}if(!(((c[(c[e>>2]|0)+76>>2]|0)+1|0)>>>0<=(c[(c[e>>2]|0)+72>>2]|0)>>>0?(c[(c[e>>2]|0)+80>>2]|0)!=0:0))l=8;do if((l|0)==8){if(!(c[(c[e>>2]|0)+72>>2]|0))c[(c[e>>2]|0)+72>>2]=2;c[j>>2]=(c[(c[e>>2]|0)+72>>2]<<1)*20;if(!(c[(c[e>>2]|0)+80>>2]|0))c[h>>2]=Cb[c[135744>>2]&511](c[j>>2]|0)|0;else c[h>>2]=Hb[c[135760>>2]&511](c[(c[e>>2]|0)+80>>2]|0,c[j>>2]|0)|0;if(c[h>>2]|0){c[(c[e>>2]|0)+80>>2]=c[h>>2];a=(c[e>>2]|0)+72|0;c[a>>2]=c[a>>2]<<1;break}ie(c[e>>2]|0,65032);i=d;return}while(0);a:do if((c[g>>2]|0)!=(c[(c[e>>2]|0)+76>>2]|0)){c[k>>2]=c[(c[e>>2]|0)+76>>2];while(1){if((c[k>>2]|0)>>>0<=(c[g>>2]|0)>>>0)break a;h=(c[(c[e>>2]|0)+80>>2]|0)+((c[k>>2]|0)*20|0)|0;j=(c[(c[e>>2]|0)+80>>2]|0)+(((c[k>>2]|0)-1|0)*20|0)|0;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[k>>2]=(c[k>>2]|0)+-1}}while(0);k=(c[(c[e>>2]|0)+80>>2]|0)+((c[g>>2]|0)*20|0)|0;g=c[f>>2]|0;c[k+0>>2]=c[g+0>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];c[k+12>>2]=c[g+12>>2];c[k+16>>2]=c[g+16>>2];g=(c[e>>2]|0)+76|0;c[g>>2]=(c[g>>2]|0)+1;i=d;return}function Ee(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[33960];c[33960]=c[d>>2];i=b;return c[e>>2]|0}function Fe(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[33962];c[33962]=c[d>>2];i=b;return c[e>>2]|0}function Ge(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[33966];c[33966]=c[d>>2];i=b;return c[e>>2]|0}function He(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[33964];c[33964]=c[d>>2];if(!(c[d>>2]|0))c[33984]=1;i=b;return c[e>>2]|0}function Ie(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if(((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+212>>2]|0)!=0:0)?(c[(c[h>>2]|0)+172>>2]|0)==-1:0){i=f;return}if(c[h>>2]|0)c[(c[h>>2]|0)+84>>2]=c[j>>2];e=c[h>>2]|0;d=c[j>>2]|0;j=c[l>>2]|0;b=c[k>>2]|0;c[g>>2]=c[l>>2];Xd(0,0,0,e,0,1,d,3,0,0,0,0,0,j,0,b,g);if(!(c[h>>2]|0)){i=f;return}c[(c[h>>2]|0)+12>>2]=0;if(c[(c[h>>2]|0)+288>>2]|0){i=f;return}c[(c[h>>2]|0)+212>>2]=1;i=f;return}function Je(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=0;if(!(c[h>>2]|0)){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}d=c[g>>2]|0;if(c[(c[g>>2]|0)+36>>2]|0){c[k>>2]=Ke(d,c[(c[g>>2]|0)+36>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;c[(c[g>>2]|0)+256>>2]=1;c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}else{Le(d,65064,0);c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}return 0}function Ke(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+32|0;h=g+28|0;j=g+24|0;k=g+20|0;l=g+16|0;m=g+12|0;n=g+8|0;o=g+4|0;p=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;if(!(c[l>>2]|0)){c[h>>2]=-1;q=c[h>>2]|0;i=g;return q|0}if(!(c[k>>2]|0)){c[h>>2]=-1;q=c[h>>2]|0;i=g;return q|0}f=c[k>>2]|0;if(!(c[c[k>>2]>>2]|0))if(!(c[f+24>>2]|0)){Le(c[j>>2]|0,65184,0);c[h>>2]=-1;q=c[h>>2]|0;i=g;return q|0}else{c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}if(c[(c[f>>2]|0)+12>>2]|0)if((c[(c[c[k>>2]>>2]|0)+12>>2]|0)==(c[l>>2]|0)){c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}else{Hd(c[(c[c[k>>2]>>2]|0)+12>>2]|0)|0;c[(c[c[k>>2]>>2]|0)+12>>2]=c[l>>2];c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}c[(c[c[k>>2]>>2]|0)+12>>2]=c[l>>2];do if(!(az(c[(c[c[k>>2]>>2]|0)+16>>2]|0)|0)){do if(c[c[l>>2]>>2]|0){if((PT(c[c[l>>2]>>2]|0,65096)|0)!=0?(PT(c[c[l>>2]>>2]|0,65112)|0)!=0:0)break;if((d[c[(c[k>>2]|0)+16>>2]>>0]|0|0)==255?(d[(c[(c[k>>2]|0)+16>>2]|0)+1>>0]|0|0)==254:0){f=(c[k>>2]|0)+16|0;c[f>>2]=(c[f>>2]|0)+2}}while(0);if((((c[c[l>>2]>>2]|0)!=0?(PT(c[c[l>>2]>>2]|0,65120)|0)==0:0)?(d[c[(c[k>>2]|0)+16>>2]>>0]|0|0)==254:0)?(d[(c[(c[k>>2]|0)+16>>2]|0)+1>>0]|0|0)==255:0){f=(c[k>>2]|0)+16|0;c[f>>2]=(c[f>>2]|0)+2}if(((((c[c[l>>2]>>2]|0)!=0?(PT(c[c[l>>2]>>2]|0,65136)|0)==0:0)?(d[c[(c[k>>2]|0)+16>>2]>>0]|0|0)==239:0)?(d[(c[(c[k>>2]|0)+16>>2]|0)+1>>0]|0|0)==187:0)?(d[(c[(c[k>>2]|0)+16>>2]|0)+2>>0]|0|0)==191:0){f=(c[k>>2]|0)+16|0;c[f>>2]=(c[f>>2]|0)+3}c[o>>2]=(c[(c[k>>2]|0)+16>>2]|0)-(c[(c[k>>2]|0)+12>>2]|0);Ty(c[(c[c[k>>2]>>2]|0)+16>>2]|0,c[o>>2]|0)|0;c[(c[c[k>>2]>>2]|0)+20>>2]=c[(c[c[k>>2]>>2]|0)+16>>2];f=Ly()|0;c[(c[c[k>>2]>>2]|0)+16>>2]=f;c[(c[c[k>>2]>>2]|0)+32>>2]=c[o>>2];c[p>>2]=_y(c[(c[c[k>>2]>>2]|0)+20>>2]|0)|0;f=c[c[k>>2]>>2]|0;if(c[(c[j>>2]|0)+32>>2]|0)c[n>>2]=Fd(f,1)|0;else c[n>>2]=Ed(f,c[m>>2]|0)|0;if((c[n>>2]|0)>=0){f=c[p>>2]|0;e=f-(_y(c[(c[c[k>>2]>>2]|0)+20>>2]|0)|0)|0;f=(c[c[k>>2]>>2]|0)+32|0;c[f>>2]=(c[f>>2]|0)+e;iz(c[(c[c[k>>2]>>2]|0)+16>>2]|0,c[k>>2]|0)|0;break}Le(c[j>>2]|0,65144,0);c[h>>2]=-1;q=c[h>>2]|0;i=g;return q|0}while(0);c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}function Le(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;g=e+12|0;h=e+8|0;j=e+4|0;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+212>>2]|0)!=0:0)?(c[(c[g>>2]|0)+172>>2]|0)==-1:0){i=e;return}if(c[g>>2]|0)c[(c[g>>2]|0)+84>>2]=1;d=c[g>>2]|0;b=c[j>>2]|0;a=c[h>>2]|0;c[f>>2]=c[j>>2];Xd(0,0,0,d,0,1,1,3,0,0,b,0,0,0,0,a,f);if(!(c[g>>2]|0)){i=e;return}c[(c[g>>2]|0)+12>>2]=0;if(c[(c[g>>2]|0)+288>>2]|0){i=e;return}c[(c[g>>2]|0)+212>>2]=1;i=e;return}function Me(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;do switch(c[e>>2]|0){case 21:{c[d>>2]=1;break}case 18:{c[d>>2]=1;break}case 30:{c[d>>2]=0;break}case 29:{c[d>>2]=0;break}case 33:{c[d>>2]=0;break}case 10:{c[d>>2]=0;break}case 16:{c[d>>2]=1;break}case 14:{c[d>>2]=1;break}case 28:{c[d>>2]=1;break}case 8:{c[d>>2]=1;break}case 15:{c[d>>2]=1;break}case 27:{c[d>>2]=1;break}case 13:{c[d>>2]=1;break}case 20:{c[d>>2]=1;break}case 3:{c[d>>2]=1;break}case 17:{c[d>>2]=1;break}case 4:{c[d>>2]=1;break}case 12:{c[d>>2]=1;break}case 2:{c[d>>2]=1;break}case 11:{c[d>>2]=1;break}case 19:{c[d>>2]=1;break}case 9:{c[d>>2]=0;break}case 24:{c[d>>2]=1;break}case 26:{c[d>>2]=1;break}case 1:{c[d>>2]=0;break}case 22:{c[d>>2]=1;break}case 5:{c[d>>2]=1;break}case 23:{c[d>>2]=1;break}case 32:{c[d>>2]=0;break}case 25:{c[d>>2]=1;break}case 6:{c[d>>2]=1;break}case 31:{c[d>>2]=0;break}case 7:{c[d>>2]=1;break}default:c[d>>2]=0}while(0);i=b;return c[d>>2]|0}function Ne(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;b=i;i=i+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[f>>2]=a;c[g>>2]=c[f>>2];if(!(c[g>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=b;return j|0}if(!((d[c[g>>2]>>0]|0|0)==105?(d[(c[g>>2]|0)+1>>0]|0|0)==45:0))k=5;do if((k|0)==5){if((d[c[g>>2]>>0]|0|0)==73?(d[(c[g>>2]|0)+1>>0]|0|0)==45:0)break;if((d[c[g>>2]>>0]|0|0)==120?(d[(c[g>>2]|0)+1>>0]|0|0)==45:0)break;if((d[c[g>>2]>>0]|0|0)==88?(d[(c[g>>2]|0)+1>>0]|0|0)==45:0)break;c[h>>2]=c[g>>2];while(1){if((d[c[h>>2]>>0]|0|0)>=65?(d[c[h>>2]>>0]|0|0)<=90:0)l=1;else if((d[c[h>>2]>>0]|0|0)>=97)l=(d[c[h>>2]>>0]|0|0)<=122;else l=0;m=c[h>>2]|0;if(!l)break;c[h>>2]=m+1}f=(c[h>>2]|0)-(c[g>>2]|0)|0;if((m-(c[g>>2]|0)|0)>=4){if((f|0)<=8?(d[c[h>>2]>>0]|0|0)==0:0){c[e>>2]=1;j=c[e>>2]|0;i=b;return j|0}c[e>>2]=0;j=c[e>>2]|0;i=b;return j|0}if((f|0)<2){c[e>>2]=0;j=c[e>>2]|0;i=b;return j|0}if(!(d[c[h>>2]>>0]|0)){c[e>>2]=1;j=c[e>>2]|0;i=b;return j|0}if((d[c[h>>2]>>0]|0|0)!=45){c[e>>2]=0;j=c[e>>2]|0;i=b;return j|0}c[h>>2]=(c[h>>2]|0)+1;c[g>>2]=c[h>>2];if((d[c[h>>2]>>0]|0|0)>=48?(d[c[h>>2]>>0]|0|0)<=57:0)k=103;else k=39;a:do if((k|0)==39){while(1){k=0;if((d[c[h>>2]>>0]|0|0)>=65?(d[c[h>>2]>>0]|0|0)<=90:0)n=1;else if((d[c[h>>2]>>0]|0|0)>=97)n=(d[c[h>>2]>>0]|0|0)<=122;else n=0;o=c[h>>2]|0;if(!n)break;c[h>>2]=o+1;k=39}do if((o-(c[g>>2]|0)|0)!=4){if(((c[h>>2]|0)-(c[g>>2]|0)|0)==2){k=84;break a}if(((c[h>>2]|0)-(c[g>>2]|0)|0)>=5?((c[h>>2]|0)-(c[g>>2]|0)|0)<=8:0)break a;if(((c[h>>2]|0)-(c[g>>2]|0)|0)!=3){c[e>>2]=0;j=c[e>>2]|0;i=b;return j|0}if(!(d[c[h>>2]>>0]|0)){c[e>>2]=1;j=c[e>>2]|0;i=b;return j|0}if((d[c[h>>2]>>0]|0|0)!=45){c[e>>2]=0;j=c[e>>2]|0;i=b;return j|0}c[h>>2]=(c[h>>2]|0)+1;c[g>>2]=c[h>>2];if((d[c[h>>2]>>0]|0|0)>=48?(d[c[h>>2]>>0]|0|0)<=57:0){k=103;break a}while(1){if((d[c[h>>2]>>0]|0|0)>=65?(d[c[h>>2]>>0]|0|0)<=90:0)p=1;else k=59;do if((k|0)==59){k=0;if((d[c[h>>2]>>0]|0|0)<97){p=0;break}p=(d[c[h>>2]>>0]|0|0)<=122}while(0);q=c[h>>2]|0;if(!p)break;c[h>>2]=q+1}if((q-(c[g>>2]|0)|0)==2){k=84;break a}if(((c[h>>2]|0)-(c[g>>2]|0)|0)>=5?((c[h>>2]|0)-(c[g>>2]|0)|0)<=8:0)break a;if(((c[h>>2]|0)-(c[g>>2]|0)|0)==4)break;c[e>>2]=0;j=c[e>>2]|0;i=b;return j|0}while(0);if(!(d[c[h>>2]>>0]|0)){c[e>>2]=1;j=c[e>>2]|0;i=b;return j|0}if((d[c[h>>2]>>0]|0|0)!=45){c[e>>2]=0;j=c[e>>2]|0;i=b;return j|0}c[h>>2]=(c[h>>2]|0)+1;c[g>>2]=c[h>>2];if((d[c[h>>2]>>0]|0|0)>=48?(d[c[h>>2]>>0]|0|0)<=57:0){k=103;break}while(1){if((d[c[h>>2]>>0]|0|0)>=65?(d[c[h>>2]>>0]|0|0)<=90:0)r=1;else if((d[c[h>>2]>>0]|0|0)>=97)r=(d[c[h>>2]>>0]|0|0)<=122;else r=0;s=c[h>>2]|0;if(!r)break;c[h>>2]=s+1}if((s-(c[g>>2]|0)|0)>=5?((c[h>>2]|0)-(c[g>>2]|0)|0)<=8:0)break;if(((c[h>>2]|0)-(c[g>>2]|0)|0)!=2){c[e>>2]=0;j=c[e>>2]|0;i=b;return j|0}else k=84}while(0);do if((k|0)==103){if((((d[(c[h>>2]|0)+1>>0]|0|0)>=48?(d[(c[h>>2]|0)+1>>0]|0|0)<=57:0)?(d[(c[h>>2]|0)+2>>0]|0|0)>=48:0)?(d[(c[h>>2]|0)+2>>0]|0|0)<=57:0){c[h>>2]=(c[h>>2]|0)+3;k=84;break}c[e>>2]=0;j=c[e>>2]|0;i=b;return j|0}while(0);do if((k|0)==84){if(!(d[c[h>>2]>>0]|0)){c[e>>2]=1;j=c[e>>2]|0;i=b;return j|0}if((d[c[h>>2]>>0]|0|0)!=45){c[e>>2]=0;j=c[e>>2]|0;i=b;return j|0}c[h>>2]=(c[h>>2]|0)+1;c[g>>2]=c[h>>2];while(1){if((d[c[h>>2]>>0]|0|0)>=65?(d[c[h>>2]>>0]|0|0)<=90:0)t=1;else if((d[c[h>>2]>>0]|0|0)>=97)t=(d[c[h>>2]>>0]|0|0)<=122;else t=0;u=c[h>>2]|0;if(!t)break;c[h>>2]=u+1}if((u-(c[g>>2]|0)|0)>=5?((c[h>>2]|0)-(c[g>>2]|0)|0)<=8:0)break;c[e>>2]=0;j=c[e>>2]|0;i=b;return j|0}while(0);if(!(d[c[h>>2]>>0]|0)){c[e>>2]=1;j=c[e>>2]|0;i=b;return j|0}if((d[c[h>>2]>>0]|0|0)!=45){c[e>>2]=0;j=c[e>>2]|0;i=b;return j|0}else{c[e>>2]=1;j=c[e>>2]|0;i=b;return j|0}}while(0);c[g>>2]=(c[g>>2]|0)+2;while(1){if((d[c[g>>2]>>0]|0|0)>=65?(d[c[g>>2]>>0]|0|0)<=90:0)v=1;else if((d[c[g>>2]>>0]|0|0)>=97)v=(d[c[g>>2]>>0]|0|0)<=122;else v=0;w=c[g>>2]|0;if(!v)break;c[g>>2]=w+1}c[e>>2]=(d[w>>0]|0|0)==0&1;j=c[e>>2]|0;i=b;return j|0}function Oe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}if((c[(c[f>>2]|0)+40>>2]|0)>=(c[(c[f>>2]|0)+44>>2]|0)?(b=(c[f>>2]|0)+44|0,c[b>>2]=c[b>>2]<<1,b=Hb[c[135760>>2]&511](c[(c[f>>2]|0)+48>>2]|0,c[(c[f>>2]|0)+44>>2]<<2)|0,c[(c[f>>2]|0)+48>>2]=b,(c[(c[f>>2]|0)+48>>2]|0)==0):0){ie(c[f>>2]|0,0);te(c[g>>2]|0);b=(c[f>>2]|0)+44|0;c[b>>2]=(c[b>>2]|0)/2|0;c[g>>2]=0;c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}c[(c[(c[f>>2]|0)+48>>2]|0)+(c[(c[f>>2]|0)+40>>2]<<2)>>2]=c[g>>2];c[(c[f>>2]|0)+36>>2]=c[g>>2];g=(c[f>>2]|0)+40|0;f=c[g>>2]|0;c[g>>2]=f+1;c[e>>2]=f;h=c[e>>2]|0;i=d;return h|0}function Pe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if(!(c[e>>2]|0)){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}if((c[(c[e>>2]|0)+40>>2]|0)<=0){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}a=(c[e>>2]|0)+40|0;c[a>>2]=(c[a>>2]|0)+-1;a=c[e>>2]|0;if((c[(c[e>>2]|0)+40>>2]|0)>0)c[(c[e>>2]|0)+36>>2]=c[(c[(c[e>>2]|0)+48>>2]|0)+((c[a+40>>2]|0)-1<<2)>>2];else c[a+36>>2]=0;c[f>>2]=c[(c[(c[e>>2]|0)+48>>2]|0)+(c[(c[e>>2]|0)+40>>2]<<2)>>2];c[(c[(c[e>>2]|0)+48>>2]|0)+(c[(c[e>>2]|0)+40>>2]<<2)>>2]=0;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}function Qe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if(!(c[f>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}do if((c[(c[f>>2]|0)+56>>2]|0)>=(c[(c[f>>2]|0)+60>>2]|0)){c[h>>2]=Hb[c[135760>>2]&511](c[(c[f>>2]|0)+64>>2]|0,c[(c[f>>2]|0)+60>>2]<<1<<2)|0;if(c[h>>2]|0){c[(c[f>>2]|0)+64>>2]=c[h>>2];b=(c[f>>2]|0)+60|0;c[b>>2]=c[b>>2]<<1;break}ie(c[f>>2]|0,0);c[e>>2]=-1;j=c[e>>2]|0;i=d;return j|0}while(0);if((c[(c[f>>2]|0)+56>>2]|0)>>>0>(c[16304]|0)>>>0?(c[(c[f>>2]|0)+360>>2]&524288|0)==0:0){ng(c[f>>2]|0,1,65224,c[16304]|0);c[(c[f>>2]|0)+172>>2]=-1;c[e>>2]=-1;j=c[e>>2]|0;i=d;return j|0}c[(c[(c[f>>2]|0)+64>>2]|0)+(c[(c[f>>2]|0)+56>>2]<<2)>>2]=c[g>>2];c[(c[f>>2]|0)+52>>2]=c[g>>2];g=(c[f>>2]|0)+56|0;f=c[g>>2]|0;c[g>>2]=f+1;c[e>>2]=f;j=c[e>>2]|0;i=d;return j|0}function Re(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if(!(c[e>>2]|0)){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}if((c[(c[e>>2]|0)+56>>2]|0)<=0){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}a=(c[e>>2]|0)+56|0;c[a>>2]=(c[a>>2]|0)+-1;a=c[e>>2]|0;if((c[(c[e>>2]|0)+56>>2]|0)>0)c[(c[e>>2]|0)+52>>2]=c[(c[(c[e>>2]|0)+64>>2]|0)+((c[a+56>>2]|0)-1<<2)>>2];else c[a+52>>2]=0;c[f>>2]=c[(c[(c[e>>2]|0)+64>>2]|0)+(c[(c[e>>2]|0)+56>>2]<<2)>>2];c[(c[(c[e>>2]|0)+64>>2]|0)+(c[(c[e>>2]|0)+56>>2]<<2)>>2]=0;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}function Se(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;
e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if(!(c[f>>2]|0)){c[e>>2]=-1;j=c[e>>2]|0;i=d;return j|0}do if((c[(c[f>>2]|0)+188>>2]|0)>=(c[(c[f>>2]|0)+192>>2]|0)){c[h>>2]=Hb[c[135760>>2]&511](c[(c[f>>2]|0)+196>>2]|0,c[(c[f>>2]|0)+192>>2]<<1<<2)|0;if(c[h>>2]|0){c[(c[f>>2]|0)+196>>2]=c[h>>2];b=(c[f>>2]|0)+192|0;c[b>>2]=c[b>>2]<<1;break}ie(c[f>>2]|0,0);c[e>>2]=-1;j=c[e>>2]|0;i=d;return j|0}while(0);c[(c[(c[f>>2]|0)+196>>2]|0)+(c[(c[f>>2]|0)+188>>2]<<2)>>2]=c[g>>2];c[(c[f>>2]|0)+184>>2]=c[g>>2];g=(c[f>>2]|0)+188|0;f=c[g>>2]|0;c[g>>2]=f+1;c[e>>2]=f;j=c[e>>2]|0;i=d;return j|0}function Te(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+188>>2]|0)>0:0){a=(c[e>>2]|0)+188|0;c[a>>2]=(c[a>>2]|0)+-1;a=c[e>>2]|0;if((c[(c[e>>2]|0)+188>>2]|0)>0)c[(c[e>>2]|0)+184>>2]=c[(c[(c[e>>2]|0)+196>>2]|0)+((c[a+188>>2]|0)-1<<2)>>2];else c[a+184>>2]=0;c[f>>2]=c[(c[(c[e>>2]|0)+196>>2]|0)+(c[(c[e>>2]|0)+188>>2]<<2)>>2];c[(c[(c[e>>2]|0)+196>>2]|0)+(c[(c[e>>2]|0)+188>>2]<<2)>>2]=0;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}function Ue(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[e>>2]=a;c[f>>2]=0;if((c[(c[e>>2]|0)+40>>2]|0)==1?(c[(c[e>>2]|0)+172>>2]|0)!=3:0){c[g>>2]=c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2];while(1){do if((d[c[g>>2]>>0]|0|0)==32)j=1;else{if(9<=(d[c[g>>2]>>0]|0|0)?(d[c[g>>2]>>0]|0|0)<=10:0){j=1;break}j=(d[c[g>>2]>>0]|0|0)==13}while(0);k=c[g>>2]|0;if(!j)break;a=c[(c[e>>2]|0)+36>>2]|0;if((d[k>>0]|0|0)==10){l=a+28|0;c[l>>2]=(c[l>>2]|0)+1;c[(c[(c[e>>2]|0)+36>>2]|0)+32>>2]=1}else{l=a+32|0;c[l>>2]=(c[l>>2]|0)+1}c[g>>2]=(c[g>>2]|0)+1;c[f>>2]=(c[f>>2]|0)+1;if(d[c[g>>2]>>0]|0)continue;c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]=c[g>>2];ke(c[(c[e>>2]|0)+36>>2]|0,250)|0;c[g>>2]=c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]}c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]=k;m=c[f>>2]|0;i=b;return m|0}do{c[h>>2]=d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0];while(1){if((c[h>>2]|0)!=32?!(9<=(c[h>>2]|0)&(c[h>>2]|0)<=10|(c[h>>2]|0)==13):0)break;me(c[e>>2]|0);c[h>>2]=d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0];c[f>>2]=(c[f>>2]|0)+1}while(1){if((c[h>>2]|0)==0?(c[(c[e>>2]|0)+40>>2]|0)>1:0)n=(c[(c[e>>2]|0)+172>>2]|0)!=5;else n=0;o=c[e>>2]|0;if(!n)break;Ve(o)|0;c[h>>2]=d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]}if((d[c[(c[o+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[e>>2]|0);if((c[h>>2]|0)<256){if((c[h>>2]|0)!=32?!(9<=(c[h>>2]|0)&(c[h>>2]|0)<=10):0)p=(c[h>>2]|0)==13;else p=1;q=p&1}else q=0}while((q|0)!=0);m=c[f>>2]|0;i=b;return m|0}function Ve(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=e+8|0;h=e+4|0;c[h>>2]=b;if((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+40>>2]|0)>1:0){if(c[33952]|0){b=c[33976]|0;j=c[33980]|0;c[f>>2]=c[(c[h>>2]|0)+40>>2];Db[b&511](j,65288,f)}te(Pe(c[h>>2]|0)|0);if((d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[h>>2]|0)+36>>2]|0,250)|0)<=0:0){a[g>>0]=Ve(c[h>>2]|0)|0;k=a[g>>0]|0;i=e;return k|0}a[g>>0]=a[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0;k=a[g>>0]|0;i=e;return k|0}a[g>>0]=0;k=a[g>>0]|0;i=e;return k|0}function We(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+24|0;m=e+4|0;c[g>>2]=b;c[j>>2]=0;if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=37){i=e;return}switch(c[(c[g>>2]|0)+172>>2]|0){case 14:{og(c[g>>2]|0,20,0);i=e;return}case 3:{if((c[(c[g>>2]|0)+96>>2]|0)==0?(c[(c[g>>2]|0)+40>>2]|0)==1:0){i=e;return}if((d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==32){i=e;return}if(9<=(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)<=10:0){i=e;return}if((d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==13){i=e;return}if(!(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0)){i=e;return}break}case 15:case 11:case 16:case 13:case 2:case 12:case 7:case 10:case 9:case 6:case 5:case 8:{i=e;return}case 1:case 0:case 4:{og(c[g>>2]|0,19,0);i=e;return}case-1:{og(c[g>>2]|0,18,0);i=e;return}default:{}}me(c[g>>2]|0);c[h>>2]=Ze(c[g>>2]|0)|0;if(c[33952]|0){b=c[33976]|0;n=c[33980]|0;c[f>>2]=c[h>>2];Db[b&511](n,65408,f)}f=c[g>>2]|0;if(!(c[h>>2]|0)){og(f,24,0);i=e;return}n=c[g>>2]|0;if((d[c[(c[f+36>>2]|0)+16>>2]>>0]|0|0)!=59){og(n,25,0);i=e;return}me(n);if((c[c[g>>2]>>2]|0)!=0?(c[(c[c[g>>2]>>2]|0)+96>>2]|0)!=0:0)c[j>>2]=Hb[c[(c[c[g>>2]>>2]|0)+96>>2]&511](c[(c[g>>2]|0)+4>>2]|0,c[h>>2]|0)|0;if((c[(c[g>>2]|0)+172>>2]|0)==-1){i=e;return}n=c[g>>2]|0;if(!(c[j>>2]|0)){do if((c[n+28>>2]|0)==1)o=26;else{if((c[(c[g>>2]|0)+88>>2]|0)==0?(c[(c[g>>2]|0)+92>>2]|0)==0:0){o=26;break}if((c[(c[g>>2]|0)+104>>2]|0)!=0?(c[(c[g>>2]|0)+112>>2]|0)!=0:0)qg(c[g>>2]|0,27,65432,c[h>>2]|0,0);else rg(c[g>>2]|0,27,65432,c[h>>2]|0,0);c[(c[g>>2]|0)+100>>2]=0}while(0);if((o|0)==26)pg(c[g>>2]|0,26,65432,c[h>>2]|0);sg(c[g>>2]|0,0,0,0)|0;i=e;return}if((c[(c[n+36>>2]|0)+40>>2]|0)!=226){c[k>>2]=ug(c[g>>2]|0,c[j>>2]|0)|0;Xe(c[g>>2]|0,c[k>>2]|0)|0;i=e;return}if((c[(c[j>>2]|0)+48>>2]|0)!=4?(c[(c[j>>2]|0)+48>>2]|0)!=5:0){pg(c[g>>2]|0,30,65464,c[h>>2]|0);i=e;return}if(((((((c[(c[j>>2]|0)+48>>2]|0)==5?(c[(c[g>>2]|0)+360>>2]&2|0)==0:0)?(c[(c[g>>2]|0)+360>>2]&16|0)==0:0)?(c[(c[g>>2]|0)+360>>2]&4|0)==0:0)?(c[(c[g>>2]|0)+360>>2]&8|0)==0:0)?(c[(c[g>>2]|0)+16>>2]|0)==0:0)?(c[(c[g>>2]|0)+104>>2]|0)==0:0){i=e;return}c[k>>2]=we(c[g>>2]|0,c[j>>2]|0)|0;if((Xe(c[g>>2]|0,c[k>>2]|0)|0)<0){i=e;return}if((c[(c[g>>2]|0)+292>>2]|0)==0?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[g>>2]|0);if((c[(c[g>>2]|0)+172>>2]|0)==-1){i=e;return}if(((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=4?(a[l>>0]=a[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0,a[l+1>>0]=a[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0,a[l+2>>0]=a[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0,a[l+3>>0]=a[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0,c[m>>2]=sd(l,4)|0,(c[m>>2]|0)!=0):0)re(c[g>>2]|0,c[m>>2]|0)|0;if((c[(c[j>>2]|0)+48>>2]|0)!=5){i=e;return}if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=60){i=e;return}if((d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=63){i=e;return}if((d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)!=120){i=e;return}if((d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)!=109){i=e;return}if((d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)!=108){i=e;return}do if((d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=32){if(9<=(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)<=10:0)break;if((d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==13)break;i=e;return}while(0);_e(c[g>>2]|0);i=e;return}function Xe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;c[g>>2]=a;c[h>>2]=b;if(!(c[h>>2]|0)){c[f>>2]=-1;k=c[f>>2]|0;i=d;return k|0}if(c[33952]|0){if((c[(c[g>>2]|0)+36>>2]|0)!=0?(c[(c[(c[g>>2]|0)+36>>2]|0)+4>>2]|0)!=0:0){b=c[33976]|0;a=c[33980]|0;l=c[(c[(c[g>>2]|0)+36>>2]|0)+28>>2]|0;c[e>>2]=c[(c[(c[g>>2]|0)+36>>2]|0)+4>>2];c[e+4>>2]=l;Db[b&511](a,65312,e)}a=c[33976]|0;b=c[33980]|0;l=c[(c[h>>2]|0)+16>>2]|0;c[e>>2]=(c[(c[g>>2]|0)+40>>2]|0)+1;c[e+4>>2]=l;Db[a&511](b,65328,e)}c[j>>2]=Oe(c[g>>2]|0,c[h>>2]|0)|0;if((c[(c[g>>2]|0)+172>>2]|0)==-1){c[f>>2]=-1;k=c[f>>2]|0;i=d;return k|0}if((c[(c[g>>2]|0)+292>>2]|0)==0?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[g>>2]|0);c[f>>2]=c[j>>2];k=c[f>>2]|0;i=d;return k|0}function Ye(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;j=b;c[f>>2]=a;c[g>>2]=0;c[h>>2]=0;c[j>>2]=0;if(((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==38?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==35:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==120:0){a=(c[f>>2]|0)+200|0;c[a>>2]=(c[a>>2]|0)+3;a=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+3;a=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[a>>2]=(c[a>>2]|0)+3;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[f>>2]|0);if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[f>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[f>>2]|0)|0;if((c[(c[f>>2]|0)+292>>2]|0)==0?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[f>>2]|0);a:while(1){if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==59)break;a=c[h>>2]|0;c[h>>2]=a+1;if((a|0)>20){c[h>>2]=0;if((c[(c[f>>2]|0)+292>>2]|0)==0?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[f>>2]|0);if((c[(c[f>>2]|0)+172>>2]|0)==-1){k=18;break}}if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)>=48?(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=57:0)c[g>>2]=(c[g>>2]<<4)+((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0)-48);else k=22;do if((k|0)==22){k=0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)>=97?(c[h>>2]|0)<20?(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=102:0:0){c[g>>2]=(c[g>>2]<<4)+((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0)-97)+10;break}if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<65){k=28;break a}if(!((c[h>>2]|0)<20?(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=70:0)){k=28;break a}c[g>>2]=(c[g>>2]<<4)+((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0)-65)+10}while(0);if((c[g>>2]|0)>>>0>1114111)c[j>>2]=c[g>>2];me(c[f>>2]|0);c[h>>2]=(c[h>>2]|0)+1}if((k|0)==18){c[e>>2]=0;l=c[e>>2]|0;i=b;return l|0}else if((k|0)==28){og(c[f>>2]|0,6,0);c[g>>2]=0}if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==59){a=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[a>>2]=(c[a>>2]|0)+1;a=(c[f>>2]|0)+200|0;c[a>>2]=(c[a>>2]|0)+1;a=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+1}}else k=34;do if((k|0)==34){if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==38?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==35:0){a=(c[f>>2]|0)+200|0;c[a>>2]=(c[a>>2]|0)+2;a=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+2;a=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[a>>2]=(c[a>>2]|0)+2;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[f>>2]|0);if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[f>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[f>>2]|0)|0;if((c[(c[f>>2]|0)+292>>2]|0)==0?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[f>>2]|0);while(1){if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==59)break;a=c[h>>2]|0;c[h>>2]=a+1;if((a|0)>20){c[h>>2]=0;if((c[(c[f>>2]|0)+292>>2]|0)==0?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[f>>2]|0);if((c[(c[f>>2]|0)+172>>2]|0)==-1){k=50;break}}if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<48){k=54;break}if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)>57){k=54;break}c[g>>2]=((c[g>>2]|0)*10|0)+((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0)-48);if((c[g>>2]|0)>>>0>1114111)c[j>>2]=c[g>>2];me(c[f>>2]|0);c[h>>2]=(c[h>>2]|0)+1}if((k|0)==50){c[e>>2]=0;l=c[e>>2]|0;i=b;return l|0}else if((k|0)==54){og(c[f>>2]|0,7,0);c[g>>2]=0}if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=59)break;a=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[a>>2]=(c[a>>2]|0)+1;a=(c[f>>2]|0)+200|0;c[a>>2]=(c[a>>2]|0)+1;a=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+1;break}og(c[f>>2]|0,8,0)}while(0);h=c[g>>2]|0;do if((c[g>>2]|0)>>>0<256)if((9<=h>>>0&(c[g>>2]|0)>>>0<=10|(c[g>>2]|0)==13|32<=(c[g>>2]|0)>>>0)&(c[j>>2]|0)==0)k=66;else k=67;else{if(!(256<=h>>>0&(c[g>>2]|0)>>>0<=55295)?!(57344<=(c[g>>2]|0)>>>0&(c[g>>2]|0)>>>0<=65533):0)if(65536<=(c[g>>2]|0)>>>0&(c[g>>2]|0)>>>0<=1114111&(c[j>>2]|0)==0){k=66;break}else{k=67;break}if(!(c[j>>2]|0))k=66;else k=67}while(0);if((k|0)==66){c[e>>2]=c[g>>2];l=c[e>>2]|0;i=b;return l|0}else if((k|0)==67){ng(c[f>>2]|0,9,65360,c[g>>2]|0);c[e>>2]=0;l=c[e>>2]|0;i=b;return l|0}return 0}function Ze(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+32|0;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;j=b;c[f>>2]=a;c[j>>2]=0;if((c[(c[f>>2]|0)+292>>2]|0)==0?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[f>>2]|0);c[g>>2]=c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2];if((d[c[g>>2]>>0]|0|0)>=97?(d[c[g>>2]>>0]|0|0)<=122:0)k=10;else k=6;do if((k|0)==6){if((d[c[g>>2]>>0]|0|0)>=65?(d[c[g>>2]>>0]|0|0)<=90:0){k=10;break}if(!((d[c[g>>2]>>0]|0|0)!=95?(d[c[g>>2]>>0]|0|0)!=58:0))k=10}while(0);if((k|0)==10){c[g>>2]=(c[g>>2]|0)+1;while(1){if((d[c[g>>2]>>0]|0|0)>=97?(d[c[g>>2]>>0]|0|0)<=122:0)l=1;else k=13;do if((k|0)==13){k=0;if((d[c[g>>2]>>0]|0|0)>=65?(d[c[g>>2]>>0]|0|0)<=90:0){l=1;break}if((d[c[g>>2]>>0]|0|0)>=48?(d[c[g>>2]>>0]|0|0)<=57:0){l=1;break}if(((d[c[g>>2]>>0]|0|0)!=95?(d[c[g>>2]>>0]|0|0)!=45:0)?(d[c[g>>2]>>0]|0|0)!=58:0)l=(d[c[g>>2]>>0]|0|0)==46;else l=1}while(0);m=c[g>>2]|0;if(!l)break;c[g>>2]=m+1}if((d[m>>0]|0|0)>0?(d[c[g>>2]>>0]|0|0)<128:0){c[j>>2]=(c[g>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0);if((c[j>>2]|0)>5e4?(c[(c[f>>2]|0)+360>>2]&524288|0)==0:0){og(c[f>>2]|0,110,65688);c[e>>2]=0;n=c[e>>2]|0;i=b;return n|0}c[h>>2]=AP(c[(c[f>>2]|0)+296>>2]|0,c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0,c[j>>2]|0)|0;c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]=c[g>>2];g=(c[f>>2]|0)+200|0;c[g>>2]=(c[g>>2]|0)+(c[j>>2]|0);g=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[g>>2]=(c[g>>2]|0)+(c[j>>2]|0);if(!(c[h>>2]|0))ie(c[f>>2]|0,0);c[e>>2]=c[h>>2];n=c[e>>2]|0;i=b;return n|0}}c[e>>2]=wg(c[f>>2]|0)|0;n=c[e>>2]|0;i=b;return n|0}function _e(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;a:do if(((((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==63:0)?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==120:0)?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==109:0)?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==108:0){do if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=32){if(9<=(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)<=10:0)break;if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=13)break a}while(0);a=(c[e>>2]|0)+200|0;c[a>>2]=(c[a>>2]|0)+5;a=(c[(c[e>>2]|0)+36>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+5;a=(c[(c[e>>2]|0)+36>>2]|0)+32|0;c[a>>2]=(c[a>>2]|0)+5;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[e>>2]|0);if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[e>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[e>>2]|0)|0;do if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13)xg(c[e>>2]|0,65,68456)}while(0);Ue(c[e>>2]|0)|0;c[f>>2]=Af(c[e>>2]|0)|0;do if(c[f>>2]|0){if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13)xg(c[e>>2]|0,65,68496)}}else c[f>>2]=oy(68488)|0;while(0);c[(c[(c[e>>2]|0)+36>>2]|0)+48>>2]=c[f>>2];c[g>>2]=Bf(c[e>>2]|0)|0;if((c[(c[e>>2]|0)+84>>2]|0)==32){i=b;return}if((c[g>>2]|0)==0?(c[(c[e>>2]|0)+84>>2]|0)==0:0)xg(c[e>>2]|0,101,68520);Ue(c[e>>2]|0)|0;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==63?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==62:0){a=(c[e>>2]|0)+200|0;c[a>>2]=(c[a>>2]|0)+2;a=(c[(c[e>>2]|0)+36>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+2;a=(c[(c[e>>2]|0)+36>>2]|0)+32|0;c[a>>2]=(c[a>>2]|0)+2;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[e>>2]|0);if(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0){i=b;return}if((ke(c[(c[e>>2]|0)+36>>2]|0,250)|0)>0){i=b;return}Ve(c[e>>2]|0)|0;i=b;return}a=(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==62;og(c[e>>2]|0,57,0);if(a){me(c[e>>2]|0);i=b;return}while(1){if(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0)h=(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=62;else h=0;j=c[e>>2]|0;if(!h)break;a=(c[j+36>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+1}me(j);i=b;return}while(0);og(c[e>>2]|0,56,0);i=b;return}function $e(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;l=i;i=i+128|0;m=l;n=l+116|0;o=l+112|0;p=l+108|0;q=l+104|0;r=l+100|0;s=l+122|0;t=l+121|0;u=l+120|0;v=l+96|0;w=l+92|0;x=l+88|0;y=l+84|0;z=l+80|0;A=l+76|0;B=l+72|0;C=l+68|0;D=l+64|0;E=l+60|0;F=l+56|0;G=l+52|0;H=l+48|0;I=l+44|0;J=l+40|0;K=l+36|0;L=l+32|0;M=l+28|0;N=l+24|0;O=l+20|0;P=l+16|0;Q=l+12|0;R=l+8|0;S=l+4|0;c[o>>2]=b;c[p>>2]=e;c[q>>2]=f;c[r>>2]=g;a[s>>0]=h;a[t>>0]=j;a[u>>0]=k;c[v>>2]=0;c[w>>2]=0;c[x>>2]=0;c[y>>2]=0;c[z>>2]=0;if((c[o>>2]|0)==0|(c[p>>2]|0)==0|(c[q>>2]|0)<0){c[n>>2]=0;T=c[n>>2]|0;i=l;return T|0}c[A>>2]=(c[p>>2]|0)+(c[q>>2]|0);if(!((c[(c[o>>2]|0)+248>>2]|0)>40?(c[(c[o>>2]|0)+360>>2]&524288|0)==0:0))U=5;if((U|0)==5?(c[(c[o>>2]|0)+248>>2]|0)<=1024:0){c[w>>2]=300;c[v>>2]=Cb[c[135752>>2]&511](c[w>>2]|0)|0;a:do if(!(c[v>>2]|0))U=88;else{if((c[p>>2]|0)>>>0<(c[A>>2]|0)>>>0)c[C>>2]=oe(c[o>>2]|0,c[p>>2]|0,D)|0;else c[C>>2]=0;while(1){if(!(c[C>>2]|0))break;if((c[C>>2]|0)==(d[s>>0]|0|0))break;if((c[C>>2]|0)==(d[t>>0]|0|0))break;if((c[C>>2]|0)==0?1:(c[C>>2]|0)==(d[u>>0]|0|0))break;if((c[C>>2]|0)==38?(d[(c[p>>2]|0)+1>>0]|0|0)==35:0){c[E>>2]=yg(c[o>>2]|0,p)|0;if(c[E>>2]|0){q=pe((c[v>>2]|0)+(c[x>>2]|0)|0,c[E>>2]|0)|0;c[x>>2]=(c[x>>2]|0)+q}if(((c[x>>2]|0)+100|0)>>>0>(c[w>>2]|0)>>>0){c[G>>2]=(c[w>>2]<<1)+100;if((c[G>>2]|0)>>>0<(c[w>>2]|0)>>>0){U=88;break a}c[F>>2]=Hb[c[135760>>2]&511](c[v>>2]|0,c[G>>2]|0)|0;if(!(c[F>>2]|0)){U=88;break a}c[v>>2]=c[F>>2];c[w>>2]=c[G>>2]}}else U=23;b:do if((U|0)==23){U=0;if((c[C>>2]|0)==38?(c[r>>2]&1|0)!=0:0){if(c[33952]|0){q=c[33976]|0;k=c[33980]|0;c[m>>2]=c[p>>2];Db[q&511](k,65512,m)}c[B>>2]=zg(c[o>>2]|0,p)|0;if((c[(c[o>>2]|0)+388>>2]|0)==89)break a;if((c[(c[o>>2]|0)+388>>2]|0)==1)break a;sg(c[o>>2]|0,0,c[B>>2]|0,0)|0;if(c[B>>2]|0){k=(c[o>>2]|0)+440|0;c[k>>2]=(c[k>>2]|0)+((c[(c[B>>2]|0)+72>>2]|0)/2|0)}do if(c[B>>2]|0){if((c[(c[B>>2]|0)+48>>2]|0)!=6)break;if(!(c[(c[B>>2]|0)+40>>2]|0)){xg(c[o>>2]|0,1,65560);break b}k=pe((c[v>>2]|0)+(c[x>>2]|0)|0,d[c[(c[B>>2]|0)+40>>2]>>0]|0)|0;c[x>>2]=(c[x>>2]|0)+k;if(((c[x>>2]|0)+100|0)>>>0<=(c[w>>2]|0)>>>0)break b;c[I>>2]=(c[w>>2]<<1)+100;if((c[I>>2]|0)>>>0<(c[w>>2]|0)>>>0){U=88;break a}c[H>>2]=Hb[c[135760>>2]&511](c[v>>2]|0,c[I>>2]|0)|0;if(!(c[H>>2]|0)){U=88;break a}c[v>>2]=c[H>>2];c[w>>2]=c[I>>2];break b}while(0);do if(c[B>>2]|0){if(!(c[(c[B>>2]|0)+40>>2]|0))break;k=(c[o>>2]|0)+248|0;c[k>>2]=(c[k>>2]|0)+1;c[z>>2]=af(c[o>>2]|0,c[(c[B>>2]|0)+40>>2]|0,c[r>>2]|0,0,0,0)|0;k=(c[o>>2]|0)+248|0;c[k>>2]=(c[k>>2]|0)+-1;if(!(c[z>>2]|0))break b;c[y>>2]=c[z>>2];while(1){if(!(d[c[y>>2]>>0]|0))break;k=c[y>>2]|0;c[y>>2]=k+1;q=a[k>>0]|0;k=c[x>>2]|0;c[x>>2]=k+1;a[(c[v>>2]|0)+k>>0]=q;if(((c[x>>2]|0)+100|0)>>>0<=(c[w>>2]|0)>>>0)continue;if(sg(c[o>>2]|0,c[x>>2]|0,c[B>>2]|0,0)|0)break a;c[K>>2]=(c[w>>2]<<1)+100;if((c[K>>2]|0)>>>0<(c[w>>2]|0)>>>0){U=88;break a}c[J>>2]=Hb[c[135760>>2]&511](c[v>>2]|0,c[K>>2]|0)|0;if(!(c[J>>2]|0)){U=88;break a}c[v>>2]=c[J>>2];c[w>>2]=c[K>>2]}zb[c[135736>>2]&511](c[z>>2]|0);c[z>>2]=0;break b}while(0);if(!(c[B>>2]|0))break;c[L>>2]=xy(c[(c[B>>2]|0)+8>>2]|0)|0;c[M>>2]=c[(c[B>>2]|0)+8>>2];q=c[x>>2]|0;c[x>>2]=q+1;a[(c[v>>2]|0)+q>>0]=38;if(((c[x>>2]|0)+(c[L>>2]|0)+100|0)>>>0>(c[w>>2]|0)>>>0){c[O>>2]=(c[w>>2]<<1)+(c[L>>2]|0)+100;if((c[O>>2]|0)>>>0<(c[w>>2]|0)>>>0){U=88;break a}c[N>>2]=Hb[c[135760>>2]&511](c[v>>2]|0,c[O>>2]|0)|0;if(!(c[N>>2]|0)){U=88;break a}c[v>>2]=c[N>>2];c[w>>2]=c[O>>2]}while(1){if((c[L>>2]|0)<=0)break;q=c[M>>2]|0;c[M>>2]=q+1;k=a[q>>0]|0;q=c[x>>2]|0;c[x>>2]=q+1;a[(c[v>>2]|0)+q>>0]=k;c[L>>2]=(c[L>>2]|0)+-1}k=c[x>>2]|0;c[x>>2]=k+1;a[(c[v>>2]|0)+k>>0]=59;break}if((c[C>>2]|0)==37?(c[r>>2]&2|0)!=0:0){if(c[33952]|0){k=c[33976]|0;q=c[33980]|0;c[m>>2]=c[p>>2];Db[k&511](q,65600,m)}c[B>>2]=Ag(c[o>>2]|0,p)|0;if((c[(c[o>>2]|0)+388>>2]|0)==89)break a;sg(c[o>>2]|0,0,c[B>>2]|0,0)|0;if(c[B>>2]|0){q=(c[o>>2]|0)+440|0;c[q>>2]=(c[q>>2]|0)+((c[(c[B>>2]|0)+72>>2]|0)/2|0)}if(!(c[B>>2]|0))break;if(!(c[(c[B>>2]|0)+40>>2]|0))Bg(c[o>>2]|0,c[B>>2]|0)|0;q=(c[o>>2]|0)+248|0;c[q>>2]=(c[q>>2]|0)+1;c[z>>2]=af(c[o>>2]|0,c[(c[B>>2]|0)+40>>2]|0,c[r>>2]|0,0,0,0)|0;q=(c[o>>2]|0)+248|0;c[q>>2]=(c[q>>2]|0)+-1;if(!(c[z>>2]|0))break;c[y>>2]=c[z>>2];while(1){if(!(d[c[y>>2]>>0]|0))break;q=c[y>>2]|0;c[y>>2]=q+1;k=a[q>>0]|0;q=c[x>>2]|0;c[x>>2]=q+1;a[(c[v>>2]|0)+q>>0]=k;if(((c[x>>2]|0)+100|0)>>>0<=(c[w>>2]|0)>>>0)continue;if(sg(c[o>>2]|0,c[x>>2]|0,c[B>>2]|0,0)|0)break a;c[Q>>2]=(c[w>>2]<<1)+100;if((c[Q>>2]|0)>>>0<(c[w>>2]|0)>>>0){U=88;break a}c[P>>2]=Hb[c[135760>>2]&511](c[v>>2]|0,c[Q>>2]|0)|0;if(!(c[P>>2]|0)){U=88;break a}c[v>>2]=c[P>>2];c[w>>2]=c[Q>>2]}zb[c[135736>>2]&511](c[z>>2]|0);c[z>>2]=0;break}if((c[D>>2]|0)==1){k=c[C>>2]&255;q=c[x>>2]|0;c[x>>2]=q+1;a[(c[v>>2]|0)+q>>0]=k}else{k=pe((c[v>>2]|0)+(c[x>>2]|0)|0,c[C>>2]|0)|0;c[x>>2]=(c[x>>2]|0)+k}c[p>>2]=(c[p>>2]|0)+(c[D>>2]|0);if(((c[x>>2]|0)+100|0)>>>0>(c[w>>2]|0)>>>0){c[S>>2]=(c[w>>2]<<1)+100;if((c[S>>2]|0)>>>0<(c[w>>2]|0)>>>0){U=88;break a}c[R>>2]=Hb[c[135760>>2]&511](c[v>>2]|0,c[S>>2]|0)|0;if(!(c[R>>2]|0)){U=88;break a}c[v>>2]=c[R>>2];c[w>>2]=c[S>>2]}}while(0);if((c[p>>2]|0)>>>0<(c[A>>2]|0)>>>0){c[C>>2]=oe(c[o>>2]|0,c[p>>2]|0,D)|0;continue}else{c[C>>2]=0;continue}}a[(c[v>>2]|0)+(c[x>>2]|0)>>0]=0;c[n>>2]=c[v>>2];T=c[n>>2]|0;i=l;return T|0}while(0);if((U|0)==88)ie(c[o>>2]|0,0);if(c[z>>2]|0)zb[c[135736>>2]&511](c[z>>2]|0);if(c[v>>2]|0)zb[c[135736>>2]&511](c[v>>2]|0);c[n>>2]=0;T=c[n>>2]|0;i=l;return T|0}og(c[o>>2]|0,89,0);c[n>>2]=0;T=c[n>>2]|0;i=l;return T|0}function af(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+32|0;k=j+12|0;l=j+8|0;m=j+4|0;n=j;o=j+18|0;p=j+17|0;q=j+16|0;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;a[o>>0]=f;a[p>>0]=g;a[q>>0]=h;if((c[l>>2]|0)==0|(c[m>>2]|0)==0){c[k>>2]=0;r=c[k>>2]|0;i=j;return r|0}else{h=c[l>>2]|0;l=c[m>>2]|0;g=xy(c[m>>2]|0)|0;c[k>>2]=$e(h,l,g,c[n>>2]|0,a[o>>0]|0,a[p>>0]|0,a[q>>0]|0)|0;r=c[k>>2]|0;i=j;return r|0}return 0}function bf(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;i=i+176|0;h=g+52|0;j=g+48|0;k=g+44|0;l=g+40|0;m=g+56|0;n=g+36|0;o=g+32|0;p=g+28|0;q=g+24|0;r=g+20|0;s=g+16|0;t=g+12|0;u=g+8|0;v=g+4|0;w=g;c[j>>2]=b;c[k>>2]=e;c[l>>2]=f;c[n>>2]=0;c[o>>2]=0;c[p>>2]=100;c[q>>2]=0;c[r>>2]=c[k>>2];if(!(c[l>>2]|0)){c[h>>2]=0;x=c[h>>2]|0;i=g;return x|0}c[c[l>>2]>>2]=0;if(!(c[r>>2]|0)){c[h>>2]=0;x=c[h>>2]|0;i=g;return x|0}if((d[c[r>>2]>>0]|0|0)==58){c[h>>2]=my(c[k>>2]|0)|0;x=c[h>>2]|0;i=g;return x|0}f=c[r>>2]|0;c[r>>2]=f+1;c[s>>2]=d[f>>0];while(1){if(!((c[s>>2]|0)!=0&(c[s>>2]|0)!=58))break;if((c[o>>2]|0)>=(c[p>>2]|0))break;f=c[s>>2]&255;e=c[o>>2]|0;c[o>>2]=e+1;a[m+e>>0]=f;f=c[r>>2]|0;c[r>>2]=f+1;c[s>>2]=d[f>>0]}do if((c[o>>2]|0)>=(c[p>>2]|0)){c[p>>2]=c[o>>2]<<1;c[n>>2]=Cb[c[135752>>2]&511](c[p>>2]|0)|0;if(!(c[n>>2]|0)){ie(c[j>>2]|0,0);c[h>>2]=0;x=c[h>>2]|0;i=g;return x|0}eU(c[n>>2]|0,m|0,c[o>>2]|0)|0;while(1){if(c[s>>2]|0)y=(c[s>>2]|0)!=58;else y=0;z=c[o>>2]|0;if(!y){A=23;break}if((z+10|0)>(c[p>>2]|0)){c[p>>2]=c[p>>2]<<1;c[t>>2]=Hb[c[135760>>2]&511](c[n>>2]|0,c[p>>2]|0)|0;if(!(c[t>>2]|0))break;c[n>>2]=c[t>>2]}f=c[s>>2]&255;e=c[o>>2]|0;c[o>>2]=e+1;a[(c[n>>2]|0)+e>>0]=f;f=c[r>>2]|0;c[r>>2]=f+1;c[s>>2]=d[f>>0]}if((A|0)==23){a[(c[n>>2]|0)+z>>0]=0;break}zb[c[135736>>2]&511](c[n>>2]|0);ie(c[j>>2]|0,0);c[h>>2]=0;x=c[h>>2]|0;i=g;return x|0}while(0);if((c[s>>2]|0)==58?(d[c[r>>2]>>0]|0|0)==0:0){if(c[n>>2]|0)zb[c[135736>>2]&511](c[n>>2]|0);c[c[l>>2]>>2]=0;c[h>>2]=my(c[k>>2]|0)|0;x=c[h>>2]|0;i=g;return x|0}if(!(c[n>>2]|0))c[q>>2]=ly(m,c[o>>2]|0)|0;else{c[q>>2]=c[n>>2];c[n>>2]=0;c[p>>2]=100}do if((c[s>>2]|0)==58){c[s>>2]=d[c[r>>2]>>0];c[c[l>>2]>>2]=c[q>>2];if(!(c[s>>2]|0)){c[h>>2]=ly(65640,0)|0;x=c[h>>2]|0;i=g;return x|0}c[o>>2]=0;do if(!((c[s>>2]|0)>=97&(c[s>>2]|0)<=122)?!((c[s>>2]|0)>=65&(c[s>>2]|0)<=90|(c[s>>2]|0)==95|(c[s>>2]|0)==58):0){c[v>>2]=oe(c[j>>2]|0,c[r>>2]|0,u)|0;z=c[v>>2]|0;if((c[v>>2]|0)<256){if(65<=(z|0)&(c[v>>2]|0)<=90)break;if(97<=(c[v>>2]|0)&(c[v>>2]|0)<=122)break;if(192<=(c[v>>2]|0)&(c[v>>2]|0)<=214)break;if(216<=(c[v>>2]|0)&(c[v>>2]|0)<=246|248<=(c[v>>2]|0))break}else if(DQ(z,199744)|0)break;z=c[v>>2]|0;if((c[v>>2]|0)<256){if((z|0)==95)break}else{if(19968<=(z|0)&(c[v>>2]|0)<=40869|(c[v>>2]|0)==12295)break;if(!((12321<=(c[v>>2]|0)&(c[v>>2]|0)<=12329^1)&(c[v>>2]|0)!=95))break}pg(c[j>>2]|0,202,65648,c[k>>2]|0)}while(0);c[r>>2]=(c[r>>2]|0)+1;while(1){if(!(c[s>>2]|0))break;if((c[o>>2]|0)>=(c[p>>2]|0))break;z=c[s>>2]&255;t=c[o>>2]|0;c[o>>2]=t+1;a[m+t>>0]=z;z=c[r>>2]|0;c[r>>2]=z+1;c[s>>2]=d[z>>0]}do if((c[o>>2]|0)>=(c[p>>2]|0)){c[p>>2]=c[o>>2]<<1;c[n>>2]=Cb[c[135752>>2]&511](c[p>>2]|0)|0;if(!(c[n>>2]|0)){ie(c[j>>2]|0,0);c[h>>2]=0;x=c[h>>2]|0;i=g;return x|0}eU(c[n>>2]|0,m|0,c[o>>2]|0)|0;while(1){B=c[o>>2]|0;if(!(c[s>>2]|0)){A=62;break}if((B+10|0)>(c[p>>2]|0)){c[p>>2]=c[p>>2]<<1;c[w>>2]=Hb[c[135760>>2]&511](c[n>>2]|0,c[p>>2]|0)|0;if(!(c[w>>2]|0))break;c[n>>2]=c[w>>2]}z=c[s>>2]&255;t=c[o>>2]|0;c[o>>2]=t+1;a[(c[n>>2]|0)+t>>0]=z;z=c[r>>2]|0;c[r>>2]=z+1;c[s>>2]=d[z>>0]}if((A|0)==62){a[(c[n>>2]|0)+B>>0]=0;break}ie(c[j>>2]|0,0);zb[c[135736>>2]&511](c[n>>2]|0);c[h>>2]=0;x=c[h>>2]|0;i=g;return x|0}while(0);if(!(c[n>>2]|0)){c[q>>2]=ly(m,c[o>>2]|0)|0;break}else{c[q>>2]=c[n>>2];break}}while(0);c[h>>2]=c[q>>2];x=c[h>>2]|0;i=g;return x|0}function cf(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+144|0;f=e+32|0;g=e+28|0;h=e+36|0;j=e+24|0;k=e+20|0;l=e+16|0;m=e+12|0;n=e+8|0;o=e+4|0;p=e;c[g>>2]=b;c[j>>2]=0;c[m>>2]=0;if((c[(c[g>>2]|0)+292>>2]|0)==0?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[g>>2]|0);if((c[(c[g>>2]|0)+172>>2]|0)==-1){c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}c[l>>2]=ne(c[g>>2]|0,k)|0;while(1){if(!(Cg(c[g>>2]|0,c[l>>2]|0)|0)){r=55;break}b=c[m>>2]|0;c[m>>2]=b+1;if(((b|0)>100?(c[m>>2]=0,(c[(c[g>>2]|0)+292>>2]|0)==0):0)?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[g>>2]|0);if((c[k>>2]|0)==1){b=c[l>>2]&255;s=c[j>>2]|0;c[j>>2]=s+1;a[h+s>>0]=b}else{b=pe(h+(c[j>>2]|0)|0,c[l>>2]|0)|0;c[j>>2]=(c[j>>2]|0)+b}b=c[(c[g>>2]|0)+36>>2]|0;if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){s=b+28|0;c[s>>2]=(c[s>>2]|0)+1;c[(c[(c[g>>2]|0)+36>>2]|0)+32>>2]=1}else{s=b+32|0;c[s>>2]=(c[s>>2]|0)+1}s=(c[(c[g>>2]|0)+36>>2]|0)+16|0;c[s>>2]=(c[s>>2]|0)+(c[k>>2]|0);if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[g>>2]|0);c[l>>2]=ne(c[g>>2]|0,k)|0;if(!(c[l>>2]|0)){c[m>>2]=0;if((c[(c[g>>2]|0)+292>>2]|0)==0?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[g>>2]|0);if((c[(c[g>>2]|0)+172>>2]|0)==-1){r=25;break}c[l>>2]=ne(c[g>>2]|0,k)|0}if((c[j>>2]|0)>=100){r=28;break}}if((r|0)==25){c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}else if((r|0)==28){c[o>>2]=c[j>>2]<<1;c[n>>2]=Cb[c[135752>>2]&511](c[o>>2]|0)|0;if(!(c[n>>2]|0)){ie(c[g>>2]|0,0);c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}eU(c[n>>2]|0,h|0,c[j>>2]|0)|0;while(1){if(!(Cg(c[g>>2]|0,c[l>>2]|0)|0)){r=54;break}s=c[m>>2]|0;c[m>>2]=s+1;if((s|0)>100){c[m>>2]=0;if((c[(c[g>>2]|0)+292>>2]|0)==0?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[g>>2]|0);if((c[(c[g>>2]|0)+172>>2]|0)==-1){r=37;break}}if(((c[j>>2]|0)+10|0)>(c[o>>2]|0)){if((c[o>>2]|0)>5e4?(c[(c[g>>2]|0)+360>>2]&524288|0)==0:0){r=41;break}c[o>>2]=c[o>>2]<<1;c[p>>2]=Hb[c[135760>>2]&511](c[n>>2]|0,c[o>>2]|0)|0;if(!(c[p>>2]|0)){r=43;break}c[n>>2]=c[p>>2]}if((c[k>>2]|0)==1){s=c[l>>2]&255;b=c[j>>2]|0;c[j>>2]=b+1;a[(c[n>>2]|0)+b>>0]=s}else{s=pe((c[n>>2]|0)+(c[j>>2]|0)|0,c[l>>2]|0)|0;c[j>>2]=(c[j>>2]|0)+s}s=c[(c[g>>2]|0)+36>>2]|0;if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){b=s+28|0;c[b>>2]=(c[b>>2]|0)+1;c[(c[(c[g>>2]|0)+36>>2]|0)+32>>2]=1}else{b=s+32|0;c[b>>2]=(c[b>>2]|0)+1}b=(c[(c[g>>2]|0)+36>>2]|0)+16|0;c[b>>2]=(c[b>>2]|0)+(c[k>>2]|0);if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[g>>2]|0);c[l>>2]=ne(c[g>>2]|0,k)|0}if((r|0)==37){zb[c[135736>>2]&511](c[n>>2]|0);c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}else if((r|0)==41){og(c[g>>2]|0,110,65696);zb[c[135736>>2]&511](c[n>>2]|0);c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}else if((r|0)==43){ie(c[g>>2]|0,0);zb[c[135736>>2]&511](c[n>>2]|0);c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}else if((r|0)==54){a[(c[n>>2]|0)+(c[j>>2]|0)>>0]=0;c[f>>2]=c[n>>2];q=c[f>>2]|0;i=e;return q|0}}else if((r|0)==55){if(!(c[j>>2]|0)){c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}if((c[j>>2]|0)>5e4?(c[(c[g>>2]|0)+360>>2]&524288|0)==0:0){og(c[g>>2]|0,110,65696);c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}c[f>>2]=ly(h,c[j>>2]|0)|0;q=c[f>>2]|0;i=e;return q|0}return 0}function df(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+64|0;g=f+48|0;h=f+44|0;j=f+40|0;k=f+36|0;l=f+32|0;m=f+28|0;n=f+24|0;o=f+20|0;p=f+53|0;q=f+16|0;r=f+12|0;s=f+8|0;t=f+4|0;u=f;v=f+52|0;c[h>>2]=b;c[j>>2]=e;c[k>>2]=0;c[l>>2]=0;c[m>>2]=100;c[q>>2]=0;c[r>>2]=0;do if((d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==34)a[p>>0]=34;else{if((d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==39){a[p>>0]=39;break}og(c[h>>2]|0,36,0);c[g>>2]=0;w=c[g>>2]|0;i=f;return w|0}while(0);c[k>>2]=Cb[c[135752>>2]&511](c[m>>2]|0)|0;e=c[h>>2]|0;if(!(c[k>>2]|0)){ie(e,0);c[g>>2]=0;w=c[g>>2]|0;i=f;return w|0}c[e+172>>2]=11;c[s>>2]=c[(c[h>>2]|0)+36>>2];if((c[(c[h>>2]|0)+292>>2]|0)==0?((c[(c[(c[h>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[h>>2]|0);if((c[(c[h>>2]|0)+172>>2]|0)==-1){zb[c[135736>>2]&511](c[k>>2]|0);c[g>>2]=0;w=c[g>>2]|0;i=f;return w|0}me(c[h>>2]|0);c[n>>2]=ne(c[h>>2]|0,o)|0;while(1){e=c[n>>2]|0;if((c[n>>2]|0)<256)if(9<=(e|0)&(c[n>>2]|0)<=10|(c[n>>2]|0)==13|32<=(c[n>>2]|0))x=19;else y=0;else if((!(256<=(e|0)&(c[n>>2]|0)<=55295)?!(57344<=(c[n>>2]|0)&(c[n>>2]|0)<=65533):0)?!(65536<=(c[n>>2]|0)&(c[n>>2]|0)<=1114111):0)y=0;else x=19;do if((x|0)==19){x=0;if((c[n>>2]|0)==(d[p>>0]|0|0)?(c[(c[h>>2]|0)+36>>2]|0)==(c[s>>2]|0):0){y=0;break}y=(c[(c[h>>2]|0)+172>>2]|0)!=-1}while(0);z=c[l>>2]|0;if(!y)break;if((z+5|0)>=(c[m>>2]|0)){c[m>>2]=c[m>>2]<<1;c[t>>2]=Hb[c[135760>>2]&511](c[k>>2]|0,c[m>>2]|0)|0;if(!(c[t>>2]|0)){x=25;break}c[k>>2]=c[t>>2]}if((c[o>>2]|0)==1){e=c[n>>2]&255;b=c[l>>2]|0;c[l>>2]=b+1;a[(c[k>>2]|0)+b>>0]=e}else{e=pe((c[k>>2]|0)+(c[l>>2]|0)|0,c[n>>2]|0)|0;c[l>>2]=(c[l>>2]|0)+e}e=c[(c[h>>2]|0)+36>>2]|0;if((d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){b=e+28|0;c[b>>2]=(c[b>>2]|0)+1;c[(c[(c[h>>2]|0)+36>>2]|0)+32>>2]=1}else{b=e+32|0;c[b>>2]=(c[b>>2]|0)+1}b=(c[(c[h>>2]|0)+36>>2]|0)+16|0;c[b>>2]=(c[b>>2]|0)+(c[o>>2]|0);if((d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[h>>2]|0);while(1){if(!(d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0))A=(c[(c[h>>2]|0)+40>>2]|0)>1;else A=0;B=c[h>>2]|0;if(!A)break;Ve(B)|0}if((c[B+292>>2]|0)==0?((c[(c[(c[h>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[h>>2]|0);c[n>>2]=ne(c[h>>2]|0,o)|0;if(c[n>>2]|0)continue;if((c[(c[h>>2]|0)+292>>2]|0)==0?((c[(c[(c[h>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[h>>2]|0);c[n>>2]=ne(c[h>>2]|0,o)|0}if((x|0)==25){ie(c[h>>2]|0,0);zb[c[135736>>2]&511](c[k>>2]|0);c[g>>2]=0;w=c[g>>2]|0;i=f;return w|0}a[(c[k>>2]|0)+z>>0]=0;if((c[(c[h>>2]|0)+172>>2]|0)==-1){zb[c[135736>>2]&511](c[k>>2]|0);c[g>>2]=0;w=c[g>>2]|0;i=f;return w|0}c[r>>2]=c[k>>2];while(1){if(!(d[c[r>>2]>>0]|0))break;if((d[c[r>>2]>>0]|0|0)!=37){if((d[c[r>>2]>>0]|0|0)==38?(d[(c[r>>2]|0)+1>>0]|0|0)!=35:0)x=54}else x=54;if((x|0)==54){x=0;a[v>>0]=a[c[r>>2]>>0]|0;c[r>>2]=(c[r>>2]|0)+1;c[u>>2]=Dg(c[h>>2]|0,r)|0;if(!((c[u>>2]|0)!=0?(d[c[r>>2]>>0]|0|0)==59:0))ng(c[h>>2]|0,87,65704,d[v>>0]|0);if(((d[v>>0]|0|0)==37?(c[(c[h>>2]|0)+216>>2]|0)==1:0)?(c[(c[h>>2]|0)+40>>2]|0)==1:0)og(c[h>>2]|0,88,0);if(c[u>>2]|0)zb[c[135736>>2]&511](c[u>>2]|0);if(!(d[c[r>>2]>>0]|0))break}c[r>>2]=(c[r>>2]|0)+1}r=c[h>>2]|0;do if((c[n>>2]|0)==(d[p>>0]|0|0)){me(r);c[q>>2]=af(c[h>>2]|0,c[k>>2]|0,2,0,0,0)|0;if(c[j>>2]|0){c[c[j>>2]>>2]=c[k>>2];break}else{zb[c[135736>>2]&511](c[k>>2]|0);break}}else{og(r,37,0);zb[c[135736>>2]&511](c[k>>2]|0)}while(0);c[g>>2]=c[q>>2];w=c[g>>2]|0;i=f;return w|0}function ef(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+36>>2]|0)!=0:0){c[d>>2]=Eg(c[e>>2]|0,0,0,0)|0;f=c[d>>2]|0;i=b;return f|0}c[d>>2]=0;f=c[d>>2]|0;i=b;return f|0}function ff(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;
e=i;i=i+48|0;f=e+36|0;g=e+32|0;h=e+28|0;j=e+24|0;k=e+20|0;l=e+16|0;m=e+12|0;n=e+40|0;o=e+8|0;p=e+4|0;q=e;c[g>>2]=b;c[h>>2]=0;c[j>>2]=0;c[k>>2]=100;c[o>>2]=c[(c[g>>2]|0)+172>>2];c[p>>2]=0;if(((c[(c[g>>2]|0)+292>>2]|0)==0?((c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)Fg(c[g>>2]|0);b=c[g>>2]|0;do if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==34){me(b);a[n>>0]=34}else{r=c[g>>2]|0;if((d[c[(c[b+36>>2]|0)+16>>2]>>0]|0|0)==39){me(r);a[n>>0]=39;break}og(r,43,0);c[f>>2]=0;s=c[f>>2]|0;i=e;return s|0}while(0);c[h>>2]=Cb[c[135752>>2]&511](c[k>>2]|0)|0;b=c[g>>2]|0;if(!(c[h>>2]|0)){ie(b,0);c[f>>2]=0;s=c[f>>2]|0;i=e;return s|0}c[b+172>>2]=13;c[l>>2]=ne(c[g>>2]|0,m)|0;while(1){b=c[l>>2]|0;if((c[l>>2]|0)<256)if(9<=(b|0)&(c[l>>2]|0)<=10|(c[l>>2]|0)==13|32<=(c[l>>2]|0))t=18;else u=0;else if((!(256<=(b|0)&(c[l>>2]|0)<=55295)?!(57344<=(c[l>>2]|0)&(c[l>>2]|0)<=65533):0)?!(65536<=(c[l>>2]|0)&(c[l>>2]|0)<=1114111):0)u=0;else t=18;if((t|0)==18){t=0;u=(c[l>>2]|0)!=(d[n>>0]|0|0)}v=c[j>>2]|0;if(!u){t=50;break}if((v+5|0)>=(c[k>>2]|0)){if((c[k>>2]|0)>5e4?(c[(c[g>>2]|0)+360>>2]&524288|0)==0:0){t=23;break}c[k>>2]=c[k>>2]<<1;c[q>>2]=Hb[c[135760>>2]&511](c[h>>2]|0,c[k>>2]|0)|0;if(!(c[q>>2]|0)){t=25;break}c[h>>2]=c[q>>2]}c[p>>2]=(c[p>>2]|0)+1;if((c[p>>2]|0)>50){if((c[(c[g>>2]|0)+292>>2]|0)==0?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[g>>2]|0);c[p>>2]=0;if((c[(c[g>>2]|0)+172>>2]|0)==-1){t=32;break}}if((c[m>>2]|0)==1){b=c[l>>2]&255;r=c[j>>2]|0;c[j>>2]=r+1;a[(c[h>>2]|0)+r>>0]=b}else{b=pe((c[h>>2]|0)+(c[j>>2]|0)|0,c[l>>2]|0)|0;c[j>>2]=(c[j>>2]|0)+b}b=c[(c[g>>2]|0)+36>>2]|0;if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){r=b+28|0;c[r>>2]=(c[r>>2]|0)+1;c[(c[(c[g>>2]|0)+36>>2]|0)+32>>2]=1}else{r=b+32|0;c[r>>2]=(c[r>>2]|0)+1}r=(c[(c[g>>2]|0)+36>>2]|0)+16|0;c[r>>2]=(c[r>>2]|0)+(c[m>>2]|0);if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[g>>2]|0);c[l>>2]=ne(c[g>>2]|0,m)|0;if(c[l>>2]|0)continue;if((c[(c[g>>2]|0)+292>>2]|0)==0?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[g>>2]|0);if(((c[(c[g>>2]|0)+292>>2]|0)==0?((c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)Fg(c[g>>2]|0);c[l>>2]=ne(c[g>>2]|0,m)|0}if((t|0)==23){og(c[g>>2]|0,110,65768);zb[c[135736>>2]&511](c[h>>2]|0);c[(c[g>>2]|0)+172>>2]=c[o>>2];c[f>>2]=0;s=c[f>>2]|0;i=e;return s|0}else if((t|0)==25){zb[c[135736>>2]&511](c[h>>2]|0);ie(c[g>>2]|0,0);c[(c[g>>2]|0)+172>>2]=c[o>>2];c[f>>2]=0;s=c[f>>2]|0;i=e;return s|0}else if((t|0)==32){zb[c[135736>>2]&511](c[h>>2]|0);c[f>>2]=0;s=c[f>>2]|0;i=e;return s|0}else if((t|0)==50){a[(c[h>>2]|0)+v>>0]=0;c[(c[g>>2]|0)+172>>2]=c[o>>2];o=c[l>>2]|0;if((c[l>>2]|0)<256)if(9<=(o|0)&(c[l>>2]|0)<=10|(c[l>>2]|0)==13|32<=(c[l>>2]|0))t=56;else t=55;else if((!(256<=(o|0)&(c[l>>2]|0)<=55295)?!(57344<=(c[l>>2]|0)&(c[l>>2]|0)<=65533):0)?!(65536<=(c[l>>2]|0)&(c[l>>2]|0)<=1114111):0)t=55;else t=56;if((t|0)==55)og(c[g>>2]|0,44,0);else if((t|0)==56)me(c[g>>2]|0);c[f>>2]=c[h>>2];s=c[f>>2]|0;i=e;return s|0}return 0}function gf(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+48|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e+33|0;m=e+32|0;n=e+8|0;o=e+4|0;p=e;c[g>>2]=b;c[h>>2]=0;c[j>>2]=0;c[k>>2]=100;c[n>>2]=0;c[o>>2]=c[(c[g>>2]|0)+172>>2];if(((c[(c[g>>2]|0)+292>>2]|0)==0?((c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)Fg(c[g>>2]|0);b=c[g>>2]|0;do if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==34){me(b);a[m>>0]=34}else{q=c[g>>2]|0;if((d[c[(c[b+36>>2]|0)+16>>2]>>0]|0|0)==39){me(q);a[m>>0]=39;break}og(q,43,0);c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}while(0);c[h>>2]=Cb[c[135752>>2]&511](c[k>>2]|0)|0;b=c[g>>2]|0;if(!(c[h>>2]|0)){ie(b,0);c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}c[b+172>>2]=16;a[l>>0]=a[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0;while(1){if(d[198696+(d[l>>0]|0)>>0]|0)s=(d[l>>0]|0|0)!=(d[m>>0]|0|0);else s=0;t=c[j>>2]|0;if(!s){u=38;break}if((t+1|0)>=(c[k>>2]|0)){if((c[k>>2]|0)>5e4?(c[(c[g>>2]|0)+360>>2]&524288|0)==0:0){u=19;break}c[k>>2]=c[k>>2]<<1;c[p>>2]=Hb[c[135760>>2]&511](c[h>>2]|0,c[k>>2]|0)|0;if(!(c[p>>2]|0)){u=21;break}c[h>>2]=c[p>>2]}b=a[l>>0]|0;q=c[j>>2]|0;c[j>>2]=q+1;a[(c[h>>2]|0)+q>>0]=b;c[n>>2]=(c[n>>2]|0)+1;if((c[n>>2]|0)>50){if((c[(c[g>>2]|0)+292>>2]|0)==0?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[g>>2]|0);c[n>>2]=0;if((c[(c[g>>2]|0)+172>>2]|0)==-1){u=28;break}}me(c[g>>2]|0);a[l>>0]=a[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0;if(d[l>>0]|0)continue;if((c[(c[g>>2]|0)+292>>2]|0)==0?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[g>>2]|0);if(((c[(c[g>>2]|0)+292>>2]|0)==0?((c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)Fg(c[g>>2]|0);a[l>>0]=a[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0}if((u|0)==19){og(c[g>>2]|0,110,65784);zb[c[135736>>2]&511](c[h>>2]|0);c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}else if((u|0)==21){ie(c[g>>2]|0,0);zb[c[135736>>2]&511](c[h>>2]|0);c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}else if((u|0)==28){zb[c[135736>>2]&511](c[h>>2]|0);c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}else if((u|0)==38){a[(c[h>>2]|0)+t>>0]=0;t=c[g>>2]|0;if((d[l>>0]|0|0)!=(d[m>>0]|0|0))og(t,44,0);else me(t);c[(c[g>>2]|0)+172>>2]=c[o>>2];c[f>>2]=c[h>>2];r=c[f>>2]|0;i=e;return r|0}return 0}function hf(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+48|0;g=f+32|0;h=f+28|0;j=f+24|0;k=f+20|0;l=f+16|0;m=f+12|0;n=f+8|0;o=f+4|0;p=f;c[g>>2]=b;c[h>>2]=e;c[k>>2]=0;c[l>>2]=c[(c[(c[g>>2]|0)+36>>2]|0)+28>>2];c[m>>2]=c[(c[(c[g>>2]|0)+36>>2]|0)+32>>2];if(((c[(c[g>>2]|0)+292>>2]|0)==0?((c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)Fg(c[g>>2]|0);if((c[(c[g>>2]|0)+292>>2]|0)==0?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[g>>2]|0);do if(!(c[h>>2]|0)){c[j>>2]=c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2];a:while(1){e=c[j>>2]|0;if((d[c[j>>2]>>0]|0)==32){c[j>>2]=e+1;b=(c[(c[g>>2]|0)+36>>2]|0)+32|0;c[b>>2]=(c[b>>2]|0)+1;continue}if((d[e>>0]|0)==10)while(1){e=(c[(c[g>>2]|0)+36>>2]|0)+28|0;c[e>>2]=(c[e>>2]|0)+1;c[(c[(c[g>>2]|0)+36>>2]|0)+32>>2]=1;c[j>>2]=(c[j>>2]|0)+1;if((d[c[j>>2]>>0]|0)!=10)continue a}if((d[c[j>>2]>>0]|0)==60){q=15;break}b:while(1){c[n>>2]=c[(c[(c[g>>2]|0)+36>>2]|0)+32>>2];while(1){if(!(a[65800+(d[c[j>>2]>>0]|0)>>0]|0))break;c[j>>2]=(c[j>>2]|0)+1;c[n>>2]=(c[n>>2]|0)+1}c[(c[(c[g>>2]|0)+36>>2]|0)+32>>2]=c[n>>2];if((d[c[j>>2]>>0]|0)==10)while(1){e=(c[(c[g>>2]|0)+36>>2]|0)+28|0;c[e>>2]=(c[e>>2]|0)+1;c[(c[(c[g>>2]|0)+36>>2]|0)+32>>2]=1;c[j>>2]=(c[j>>2]|0)+1;if((d[c[j>>2]>>0]|0)!=10)continue b}r=c[j>>2]|0;if((d[c[j>>2]>>0]|0)!=93)break;if((d[r+1>>0]|0)==93?(d[(c[j>>2]|0)+2>>0]|0)==62:0){q=36;break a}c[j>>2]=(c[j>>2]|0)+1;e=(c[(c[g>>2]|0)+36>>2]|0)+32|0;c[e>>2]=(c[e>>2]|0)+1}c[k>>2]=r-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0);if((c[k>>2]|0)>0){c:do if((c[c[g>>2]>>2]|0)!=0?(c[(c[c[g>>2]>>2]|0)+72>>2]|0)!=(c[(c[c[g>>2]>>2]|0)+68>>2]|0):0){do if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0)!=32){if(9<=(d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0)?(d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0)<=10:0)break;if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0)!=13){q=53;break c}}while(0);c[p>>2]=c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2];c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]=c[j>>2];e=(Gg(c[g>>2]|0,c[p>>2]|0,c[k>>2]|0,0)|0)!=0;b=c[c[g>>2]>>2]|0;if(e){if(c[b+72>>2]|0)Db[c[(c[c[g>>2]>>2]|0)+72>>2]&511](c[(c[g>>2]|0)+4>>2]|0,c[p>>2]|0,c[k>>2]|0)}else{if(c[b+68>>2]|0)Db[c[(c[c[g>>2]>>2]|0)+68>>2]&511](c[(c[g>>2]|0)+4>>2]|0,c[p>>2]|0,c[k>>2]|0);if((c[c[(c[g>>2]|0)+232>>2]>>2]|0)==-1)c[c[(c[g>>2]|0)+232>>2]>>2]=-2}c[l>>2]=c[(c[(c[g>>2]|0)+36>>2]|0)+28>>2];c[m>>2]=c[(c[(c[g>>2]|0)+36>>2]|0)+32>>2]}else q=53;while(0);if((q|0)==53?(q=0,(c[c[g>>2]>>2]|0)!=0):0){if(c[(c[c[g>>2]>>2]|0)+68>>2]|0)Db[c[(c[c[g>>2]>>2]|0)+68>>2]&511](c[(c[g>>2]|0)+4>>2]|0,c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0,c[k>>2]|0);c[l>>2]=c[(c[(c[g>>2]|0)+36>>2]|0)+28>>2];c[m>>2]=c[(c[(c[g>>2]|0)+36>>2]|0)+32>>2]}if((c[(c[g>>2]|0)+172>>2]|0)!=7){q=78;break}}c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]=c[j>>2];do if((d[c[j>>2]>>0]|0)==13){c[j>>2]=(c[j>>2]|0)+1;b=c[j>>2]|0;if((d[c[j>>2]>>0]|0)==10){c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]=b;c[j>>2]=(c[j>>2]|0)+1;e=(c[(c[g>>2]|0)+36>>2]|0)+28|0;c[e>>2]=(c[e>>2]|0)+1;c[(c[(c[g>>2]|0)+36>>2]|0)+32>>2]=1;break}else{c[j>>2]=b+-1;q=62;break}}else q=62;while(0);if((q|0)==62){q=0;if((d[c[j>>2]>>0]|0)==60){q=78;break}if((d[c[j>>2]>>0]|0)==38){q=78;break}if(((c[(c[g>>2]|0)+292>>2]|0)==0?((c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)Fg(c[g>>2]|0);if((c[(c[g>>2]|0)+292>>2]|0)==0?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[g>>2]|0);if((c[(c[g>>2]|0)+172>>2]|0)==-1){q=78;break}c[j>>2]=c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]}if((d[c[j>>2]>>0]|0)>=32?(d[c[j>>2]>>0]|0)<=127:0)continue;if((d[c[j>>2]>>0]|0)!=9){q=76;break}}if((q|0)==15){c[k>>2]=(c[j>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0);if((c[k>>2]|0)<=0){i=f;return}c[o>>2]=c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2];c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]=c[j>>2];if((c[c[g>>2]>>2]|0)!=0?(c[(c[c[g>>2]>>2]|0)+72>>2]|0)!=(c[(c[c[g>>2]>>2]|0)+68>>2]|0):0){b=(Gg(c[g>>2]|0,c[o>>2]|0,c[k>>2]|0,1)|0)!=0;e=c[c[g>>2]>>2]|0;if(b){if(!(c[e+72>>2]|0)){i=f;return}Db[c[(c[c[g>>2]>>2]|0)+72>>2]&511](c[(c[g>>2]|0)+4>>2]|0,c[o>>2]|0,c[k>>2]|0);i=f;return}if(c[e+68>>2]|0)Db[c[(c[c[g>>2]>>2]|0)+68>>2]&511](c[(c[g>>2]|0)+4>>2]|0,c[o>>2]|0,c[k>>2]|0);if((c[c[(c[g>>2]|0)+232>>2]>>2]|0)!=-1){i=f;return}c[c[(c[g>>2]|0)+232>>2]>>2]=-2;i=f;return}if(!(c[c[g>>2]>>2]|0)){i=f;return}if(!(c[(c[c[g>>2]>>2]|0)+68>>2]|0)){i=f;return}Db[c[(c[c[g>>2]>>2]|0)+68>>2]&511](c[(c[g>>2]|0)+4>>2]|0,c[o>>2]|0,c[k>>2]|0);i=f;return}else if((q|0)==36){og(c[g>>2]|0,62,0);c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]=c[j>>2];i=f;return}else if((q|0)==76){c[k>>2]=0;break}else if((q|0)==78){i=f;return}}while(0);c[(c[(c[g>>2]|0)+36>>2]|0)+28>>2]=c[l>>2];c[(c[(c[g>>2]|0)+36>>2]|0)+32>>2]=c[m>>2];Hg(c[g>>2]|0,c[h>>2]|0);i=f;return}function jf(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=e;c[l>>2]=0;if(((c[(c[h>>2]|0)+292>>2]|0)==0?((c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[h>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((c[(c[(c[h>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)Fg(c[h>>2]|0);c[c[j>>2]>>2]=0;if((((((d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==83?(d[(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==89:0)?(d[(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==83:0)?(d[(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==84:0)?(d[(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==69:0)?(d[(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==77:0){e=(c[h>>2]|0)+200|0;c[e>>2]=(c[e>>2]|0)+6;e=(c[(c[h>>2]|0)+36>>2]|0)+16|0;c[e>>2]=(c[e>>2]|0)+6;e=(c[(c[h>>2]|0)+36>>2]|0)+32|0;c[e>>2]=(c[e>>2]|0)+6;if((d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[h>>2]|0);if((d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[h>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[h>>2]|0)|0;do if((d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13)xg(c[h>>2]|0,65,66056)}while(0);Ue(c[h>>2]|0)|0;c[l>>2]=ff(c[h>>2]|0)|0;if(!(c[l>>2]|0))og(c[h>>2]|0,70,0)}else n=23;if(((((((n|0)==23?(d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==80:0)?(d[(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==85:0)?(d[(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==66:0)?(d[(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==76:0)?(d[(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==73:0)?(d[(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==67:0){n=(c[h>>2]|0)+200|0;c[n>>2]=(c[n>>2]|0)+6;n=(c[(c[h>>2]|0)+36>>2]|0)+16|0;c[n>>2]=(c[n>>2]|0)+6;n=(c[(c[h>>2]|0)+36>>2]|0)+32|0;c[n>>2]=(c[n>>2]|0)+6;if((d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[h>>2]|0);if((d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[h>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[h>>2]|0)|0;do if((d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13)xg(c[h>>2]|0,65,66088)}while(0);Ue(c[h>>2]|0)|0;n=gf(c[h>>2]|0)|0;c[c[j>>2]>>2]=n;if(!(c[c[j>>2]>>2]|0))og(c[h>>2]|0,71,0);j=c[h>>2]|0;do if(c[k>>2]|0){if((d[c[(c[j+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13)xg(c[h>>2]|0,65,66120)}}else{if((c[j+292>>2]|0)==0?((c[(c[(c[h>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[h>>2]|0);c[m>>2]=c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2];do if((d[c[m>>2]>>0]|0|0)!=32){if(9<=(d[c[m>>2]>>0]|0|0)?(d[c[m>>2]>>0]|0|0)<=10:0)break;if((d[c[m>>2]>>0]|0|0)!=13){c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}}while(0);while(1){do if((d[c[m>>2]>>0]|0|0)==32)p=1;else{if(9<=(d[c[m>>2]>>0]|0|0)?(d[c[m>>2]>>0]|0|0)<=10:0){p=1;break}p=(d[c[m>>2]>>0]|0|0)==13}while(0);q=c[m>>2]|0;if(!p)break;c[m>>2]=q+1}if((d[q>>0]|0|0)!=39?(d[c[m>>2]>>0]|0|0)!=34:0){c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}}while(0);Ue(c[h>>2]|0)|0;c[l>>2]=ff(c[h>>2]|0)|0;if(!(c[l>>2]|0))og(c[h>>2]|0,70,0)}c[g>>2]=c[l>>2];o=c[g>>2]|0;i=f;return o|0}function kf(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+48|0;f=e+36|0;g=e+32|0;h=e+28|0;j=e+24|0;k=e+20|0;l=e+16|0;m=e+12|0;n=e+8|0;o=e+4|0;p=e;c[f>>2]=b;c[g>>2]=0;c[h>>2]=100;c[j>>2]=0;c[m>>2]=0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=60){i=e;return}if((d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=33){i=e;return}if((d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)!=45){i=e;return}if((d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)!=45){i=e;return}c[k>>2]=c[(c[f>>2]|0)+172>>2];c[(c[f>>2]|0)+172>>2]=5;c[o>>2]=c[(c[(c[f>>2]|0)+36>>2]|0)+56>>2];b=(c[f>>2]|0)+200|0;c[b>>2]=(c[b>>2]|0)+4;b=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[b>>2]=(c[b>>2]|0)+4;b=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[b>>2]=(c[b>>2]|0)+4;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[f>>2]|0);if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[f>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[f>>2]|0)|0;if(((c[(c[f>>2]|0)+292>>2]|0)==0?((c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)Fg(c[f>>2]|0);if((c[(c[f>>2]|0)+292>>2]|0)==0?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[f>>2]|0);c[l>>2]=c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2];a:while(1){if((d[c[l>>2]>>0]|0|0)==10)do{b=(c[(c[f>>2]|0)+36>>2]|0)+28|0;c[b>>2]=(c[b>>2]|0)+1;c[(c[(c[f>>2]|0)+36>>2]|0)+32>>2]=1;c[l>>2]=(c[l>>2]|0)+1}while((d[c[l>>2]>>0]|0|0)==10);b:while(1){c[n>>2]=c[(c[(c[f>>2]|0)+36>>2]|0)+32>>2];c:while(1){if(!((d[c[l>>2]>>0]|0|0)>45?(d[c[l>>2]>>0]|0|0)<=127:0))q=23;do if((q|0)==23){q=0;if((d[c[l>>2]>>0]|0|0)>=32?(d[c[l>>2]>>0]|0|0)<45:0)break;if((d[c[l>>2]>>0]|0|0)!=9)break c}while(0);c[l>>2]=(c[l>>2]|0)+1;c[n>>2]=(c[n>>2]|0)+1}c[(c[(c[f>>2]|0)+36>>2]|0)+32>>2]=c[n>>2];if((d[c[l>>2]>>0]|0|0)==10)while(1){b=(c[(c[f>>2]|0)+36>>2]|0)+28|0;c[b>>2]=(c[b>>2]|0)+1;c[(c[(c[f>>2]|0)+36>>2]|0)+32>>2]=1;c[l>>2]=(c[l>>2]|0)+1;if((d[c[l>>2]>>0]|0|0)!=10)continue b}c[m>>2]=(c[l>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0);if(((c[m>>2]|0)>>>0>0?(c[c[f>>2]>>2]|0)!=0:0)?(c[(c[c[f>>2]>>2]|0)+80>>2]|0)!=0:0){if(c[g>>2]|0){if(((c[j>>2]|0)+(c[m>>2]|0)+1|0)>>>0>=(c[h>>2]|0)>>>0){c[h>>2]=(c[h>>2]|0)+((c[j>>2]|0)+(c[m>>2]|0)+100);c[p>>2]=Hb[c[135760>>2]&511](c[g>>2]|0,c[h>>2]|0)|0;if(!(c[p>>2]|0)){q=42;break a}c[g>>2]=c[p>>2]}}else{do if((d[c[l>>2]>>0]|0|0)==45){if((d[(c[l>>2]|0)+1>>0]|0|0)!=45){q=36;break}c[h>>2]=(c[m>>2]|0)+1}else q=36;while(0);if((q|0)==36){q=0;c[h>>2]=100+(c[m>>2]|0)}c[g>>2]=Cb[c[135752>>2]&511](c[h>>2]|0)|0;if(!(c[g>>2]|0)){q=38;break a}c[j>>2]=0}eU((c[g>>2]|0)+(c[j>>2]|0)|0,c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0,c[m>>2]|0)|0;c[j>>2]=(c[j>>2]|0)+(c[m>>2]|0);a[(c[g>>2]|0)+(c[j>>2]|0)>>0]=0}if((c[j>>2]|0)>>>0>1e7?(c[(c[f>>2]|0)+360>>2]&524288|0)==0:0){q=47;break a}c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]=c[l>>2];if((d[c[l>>2]>>0]|0|0)==10){c[l>>2]=(c[l>>2]|0)+1;b=(c[(c[f>>2]|0)+36>>2]|0)+28|0;c[b>>2]=(c[b>>2]|0)+1;c[(c[(c[f>>2]|0)+36>>2]|0)+32>>2]=1}if((d[c[l>>2]>>0]|0|0)==13){c[l>>2]=(c[l>>2]|0)+1;r=c[l>>2]|0;if((d[c[l>>2]>>0]|0|0)==10){q=52;break}c[l>>2]=r+-1}if(((c[(c[f>>2]|0)+292>>2]|0)==0?((c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)Fg(c[f>>2]|0);if((c[(c[f>>2]|0)+292>>2]|0)==0?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[f>>2]|0);if((c[(c[f>>2]|0)+172>>2]|0)==-1){q=62;break a}c[l>>2]=c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2];if((d[c[l>>2]>>0]|0|0)!=45)break;if((d[(c[l>>2]|0)+1>>0]|0|0)==45){if((d[(c[l>>2]|0)+2>>0]|0|0)==62){q=66;break a}b=c[f>>2]|0;if(c[g>>2]|0)pg(b,80,66248,c[g>>2]|0);else pg(b,80,66296,0);c[l>>2]=(c[l>>2]|0)+1;b=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[b>>2]=(c[b>>2]|0)+1}c[l>>2]=(c[l>>2]|0)+1;b=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[b>>2]=(c[b>>2]|0)+1}if((q|0)==52){q=0;c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]=r;c[l>>2]=(c[l>>2]|0)+1;b=(c[(c[f>>2]|0)+36>>2]|0)+28|0;c[b>>2]=(c[b>>2]|0)+1;c[(c[(c[f>>2]|0)+36>>2]|0)+32>>2]=1}if((d[c[l>>2]>>0]|0|0)>=32?(d[c[l>>2]>>0]|0|0)<=127:0)continue;if((d[c[l>>2]>>0]|0|0)!=9){q=91;break}}if((q|0)==38){ie(c[f>>2]|0,0);c[(c[f>>2]|0)+172>>2]=c[k>>2];i=e;return}else if((q|0)==42){zb[c[135736>>2]&511](c[g>>2]|0);ie(c[f>>2]|0,0);c[(c[f>>2]|0)+172>>2]=c[k>>2];i=e;return}else if((q|0)==47){pg(c[f>>2]|0,45,66168,0);zb[c[135736>>2]&511](c[g>>2]|0);i=e;return}else if((q|0)==62){zb[c[135736>>2]&511](c[g>>2]|0);i=e;return}else if((q|0)==66){if((c[(c[(c[f>>2]|0)+36>>2]|0)+56>>2]|0)!=(c[o>>2]|0))xg(c[f>>2]|0,90,66192);o=(c[f>>2]|0)+200|0;c[o>>2]=(c[o>>2]|0)+3;o=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[o>>2]=(c[o>>2]|0)+3;o=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[o>>2]=(c[o>>2]|0)+3;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[f>>2]|0);if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[f>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[f>>2]|0)|0;do if(((c[c[f>>2]>>2]|0)!=0?(c[(c[c[f>>2]>>2]|0)+80>>2]|0)!=0:0)?(c[(c[f>>2]|0)+212>>2]|0)==0:0){o=c[(c[c[f>>2]>>2]|0)+80>>2]|0;l=c[(c[f>>2]|0)+4>>2]|0;if(c[g>>2]|0){Ab[o&511](l,c[g>>2]|0);break}else{Ab[o&511](l,65640);break}}while(0);if(c[g>>2]|0)zb[c[135736>>2]&511](c[g>>2]|0);if((c[(c[f>>2]|0)+172>>2]|0)==-1){i=e;return}c[(c[f>>2]|0)+172>>2]=c[k>>2];i=e;return}else if((q|0)==91){Ig(c[f>>2]|0,c[g>>2]|0,c[j>>2]|0,c[h>>2]|0);c[(c[f>>2]|0)+172>>2]=c[k>>2];i=e;return}}function lf(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[f>>2]=a;c[g>>2]=Ze(c[f>>2]|0)|0;do if(c[g>>2]|0){if((d[c[g>>2]>>0]|0|0)!=120?(d[c[g>>2]>>0]|0|0)!=88:0)break;if((d[(c[g>>2]|0)+1>>0]|0|0)!=109?(d[(c[g>>2]|0)+1>>0]|0|0)!=77:0)break;if((d[(c[g>>2]|0)+2>>0]|0|0)!=108?(d[(c[g>>2]|0)+2>>0]|0|0)!=76:0)break;if((((d[c[g>>2]>>0]|0|0)==120?(d[(c[g>>2]|0)+1>>0]|0|0)==109:0)?(d[(c[g>>2]|0)+2>>0]|0|0)==108:0)?(d[(c[g>>2]|0)+3>>0]|0|0)==0:0){xg(c[f>>2]|0,64,66328);c[e>>2]=c[g>>2];j=c[e>>2]|0;i=b;return j|0}if(!(d[(c[g>>2]|0)+3>>0]|0)){og(c[f>>2]|0,64,0);c[e>>2]=c[g>>2];j=c[e>>2]|0;i=b;return j|0}c[h>>2]=0;while(1){if(!(c[66392+(c[h>>2]<<2)>>2]|0)){k=20;break}if(qy(c[g>>2]|0,c[66392+(c[h>>2]<<2)>>2]|0)|0)break;c[h>>2]=(c[h>>2]|0)+1}if((k|0)==20){rg(c[f>>2]|0,64,66408,0,0);break}c[e>>2]=c[g>>2];j=c[e>>2]|0;i=b;return j|0}while(0);if((c[g>>2]|0)!=0?(vy(c[g>>2]|0,58)|0)!=0:0)Jg(c[f>>2]|0,205,66456,c[g>>2]|0,0,0);c[e>>2]=c[g>>2];j=c[e>>2]|0;i=b;return j|0}function mf(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;i=i+64|0;f=e+48|0;g=e+44|0;h=e+40|0;j=e+36|0;k=e+32|0;l=e+28|0;m=e+24|0;n=e+20|0;o=e+16|0;p=e+12|0;q=e+8|0;r=e+4|0;s=e;c[f>>2]=b;c[g>>2]=0;c[h>>2]=0;c[j>>2]=100;c[o>>2]=0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=60){i=e;return}if((d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=63){i=e;return}c[p>>2]=c[(c[f>>2]|0)+36>>2];c[n>>2]=c[(c[f>>2]|0)+172>>2];c[(c[f>>2]|0)+172>>2]=2;b=(c[f>>2]|0)+200|0;c[b>>2]=(c[b>>2]|0)+2;b=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[b>>2]=(c[b>>2]|0)+2;b=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[b>>2]=(c[b>>2]|0)+2;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[f>>2]|0);if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[f>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[f>>2]|0)|0;if(((c[(c[f>>2]|0)+292>>2]|0)==0?((c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)Fg(c[f>>2]|0);c[m>>2]=lf(c[f>>2]|0)|0;b=c[f>>2]|0;do if(c[m>>2]|0){if((d[c[(c[b+36>>2]|0)+16>>2]>>0]|0|0)==63?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==62:0){if((c[p>>2]|0)!=(c[(c[f>>2]|0)+36>>2]|0))xg(c[f>>2]|0,90,66504);t=(c[f>>2]|0)+200|0;c[t>>2]=(c[t>>2]|0)+2;t=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[t>>2]=(c[t>>2]|0)+2;t=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[t>>2]=(c[t>>2]|0)+2;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[f>>2]|0);if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[f>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[f>>2]|0)|0;if(((c[c[f>>2]>>2]|0)!=0?(c[(c[f>>2]|0)+212>>2]|0)==0:0)?(c[(c[c[f>>2]>>2]|0)+76>>2]|0)!=0:0)Db[c[(c[c[f>>2]>>2]|0)+76>>2]&511](c[(c[f>>2]|0)+4>>2]|0,c[m>>2]|0,0);if((c[(c[f>>2]|0)+172>>2]|0)==-1){i=e;return}c[(c[f>>2]|0)+172>>2]=c[n>>2];i=e;return}c[g>>2]=Cb[c[135752>>2]&511](c[j>>2]|0)|0;t=c[f>>2]|0;if(!(c[g>>2]|0)){ie(t,0);c[(c[f>>2]|0)+172>>2]=c[n>>2];i=e;return}c[k>>2]=d[c[(c[t+36>>2]|0)+16>>2]>>0];if((c[k>>2]|0)<256){if((c[k>>2]|0)!=32?!(9<=(c[k>>2]|0)&(c[k>>2]|0)<=10|(c[k>>2]|0)==13):0)u=33}else u=33;if((u|0)==33)pg(c[f>>2]|0,65,66568,c[m>>2]|0);Ue(c[f>>2]|0)|0;c[k>>2]=ne(c[f>>2]|0,l)|0;while(1){t=c[k>>2]|0;if((c[k>>2]|0)<256)if(9<=(t|0)&(c[k>>2]|0)<=10|(c[k>>2]|0)==13|32<=(c[k>>2]|0))u=40;else v=0;else if((!(256<=(t|0)&(c[k>>2]|0)<=55295)?!(57344<=(c[k>>2]|0)&(c[k>>2]|0)<=65533):0)?!(65536<=(c[k>>2]|0)&(c[k>>2]|0)<=1114111):0)v=0;else u=40;if((u|0)==40){u=0;if((c[k>>2]|0)!=63)v=1;else v=(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=62}w=c[h>>2]|0;if(!v){u=73;break}if((w+5|0)>>>0>=(c[j>>2]|0)>>>0){c[r>>2]=c[j>>2]<<1;c[q>>2]=Hb[c[135760>>2]&511](c[g>>2]|0,c[r>>2]|0)|0;if(!(c[q>>2]|0)){u=45;break}c[g>>2]=c[q>>2];c[j>>2]=c[r>>2]}c[o>>2]=(c[o>>2]|0)+1;if((c[o>>2]|0)>50){if((c[(c[f>>2]|0)+292>>2]|0)==0?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[f>>2]|0);if((c[(c[f>>2]|0)+172>>2]|0)==-1){u=52;break}c[o>>2]=0;if((c[h>>2]|0)>>>0>1e7?(c[(c[f>>2]|0)+360>>2]&524288|0)==0:0){u=55;break}}if((c[l>>2]|0)==1){t=c[k>>2]&255;x=c[h>>2]|0;c[h>>2]=x+1;a[(c[g>>2]|0)+x>>0]=t}else{t=pe((c[g>>2]|0)+(c[h>>2]|0)|0,c[k>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+t}t=c[(c[f>>2]|0)+36>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){x=t+28|0;c[x>>2]=(c[x>>2]|0)+1;c[(c[(c[f>>2]|0)+36>>2]|0)+32>>2]=1}else{x=t+32|0;c[x>>2]=(c[x>>2]|0)+1}x=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[x>>2]=(c[x>>2]|0)+(c[l>>2]|0);if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[f>>2]|0);c[k>>2]=ne(c[f>>2]|0,l)|0;if(c[k>>2]|0)continue;do if(!(c[(c[f>>2]|0)+292>>2]|0)){if(((c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+12>>2]|0)|0)<=500)break;if(((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=500)break;Fg(c[f>>2]|0)}while(0);do if(!(c[(c[f>>2]|0)+292>>2]|0)){if(((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=250)break;vg(c[f>>2]|0)}while(0);c[k>>2]=ne(c[f>>2]|0,l)|0}if((u|0)==45){ie(c[f>>2]|0,0);zb[c[135736>>2]&511](c[g>>2]|0);c[(c[f>>2]|0)+172>>2]=c[n>>2];i=e;return}else if((u|0)==52){zb[c[135736>>2]&511](c[g>>2]|0);i=e;return}else if((u|0)==55){pg(c[f>>2]|0,47,66600,c[m>>2]|0);zb[c[135736>>2]&511](c[g>>2]|0);c[(c[f>>2]|0)+172>>2]=c[n>>2];i=e;return}else if((u|0)==73){if(w>>>0>1e7?(c[(c[f>>2]|0)+360>>2]&524288|0)==0:0){pg(c[f>>2]|0,47,66600,c[m>>2]|0);zb[c[135736>>2]&511](c[g>>2]|0);c[(c[f>>2]|0)+172>>2]=c[n>>2];i=e;return}a[(c[g>>2]|0)+(c[h>>2]|0)>>0]=0;do if((c[k>>2]|0)==63){if((c[p>>2]|0)!=(c[(c[f>>2]|0)+36>>2]|0))xg(c[f>>2]|0,65,66504);x=(c[f>>2]|0)+200|0;c[x>>2]=(c[x>>2]|0)+2;x=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[x>>2]=(c[x>>2]|0)+2;x=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[x>>2]=(c[x>>2]|0)+2;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[f>>2]|0);if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[f>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[f>>2]|0)|0;do if((c[n>>2]|0)==1|(c[n>>2]|0)==0?(qy(c[m>>2]|0,66656)|0)!=0:0){c[s>>2]=Gw()|0;if(!((c[s>>2]|0)==2|(c[s>>2]|0)==3))break;Kg(c[f>>2]|0,c[g>>2]|0)}while(0);if((c[c[f>>2]>>2]|0)!=0?(c[(c[f>>2]|0)+212>>2]|0)==0:0){if(!(c[(c[c[f>>2]>>2]|0)+76>>2]|0))break;Db[c[(c[c[f>>2]>>2]|0)+76>>2]&511](c[(c[f>>2]|0)+4>>2]|0,c[m>>2]|0,c[g>>2]|0)}}else pg(c[f>>2]|0,47,66624,c[m>>2]|0);while(0);zb[c[135736>>2]&511](c[g>>2]|0);break}}else og(b,46,0);while(0);if((c[(c[f>>2]|0)+172>>2]|0)==-1){i=e;return}c[(c[f>>2]|0)+172>>2]=c[n>>2];i=e;return}function nf(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;j=b;c[e>>2]=a;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=60){i=b;return}if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=33){i=b;return}if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)!=78){i=b;return}if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)!=79){i=b;return}if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)!=84){i=b;return}if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=65){i=b;return}if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)!=84){i=b;return}if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0|0)!=73){i=b;return}if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+8>>0]|0|0)!=79){i=b;return}if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+9>>0]|0|0)!=78){i=b;return}c[j>>2]=c[(c[e>>2]|0)+36>>2];if(((c[(c[e>>2]|0)+292>>2]|0)==0?((c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[e>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((c[(c[(c[e>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)Fg(c[e>>2]|0);a=(c[e>>2]|0)+200|0;c[a>>2]=(c[a>>2]|0)+10;a=(c[(c[e>>2]|0)+36>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+10;a=(c[(c[e>>2]|0)+36>>2]|0)+32|0;c[a>>2]=(c[a>>2]|0)+10;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[e>>2]|0);if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[e>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[e>>2]|0)|0;do if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13){xg(c[e>>2]|0,65,66680);i=b;return}}while(0);Ue(c[e>>2]|0)|0;c[f>>2]=Ze(c[e>>2]|0)|0;a=c[e>>2]|0;if(!(c[f>>2]|0)){og(a,48,0);i=b;return}do if((d[c[(c[a+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13){xg(c[e>>2]|0,65,66720);i=b;return}}while(0);if(vy(c[f>>2]|0,58)|0)Jg(c[e>>2]|0,205,66768,c[f>>2]|0,0,0);Ue(c[e>>2]|0)|0;c[h>>2]=jf(c[e>>2]|0,g,0)|0;Ue(c[e>>2]|0)|0;do if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==62){if((c[j>>2]|0)!=(c[(c[e>>2]|0)+36>>2]|0))xg(c[e>>2]|0,65,66816);me(c[e>>2]|0);if(!(c[c[e>>2]>>2]|0))break;if(c[(c[e>>2]|0)+212>>2]|0)break;if(!(c[(c[c[e>>2]>>2]|0)+28>>2]|0))break;Jb[c[(c[c[e>>2]>>2]|0)+28>>2]&511](c[(c[e>>2]|0)+4>>2]|0,c[f>>2]|0,c[g>>2]|0,c[h>>2]|0)}else og(c[e>>2]|0,49,0);while(0);if(c[h>>2]|0)zb[c[135736>>2]&511](c[h>>2]|0);if(!(c[g>>2]|0)){i=b;return}zb[c[135736>>2]&511](c[g>>2]|0);i=b;return}function of(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+64|0;e=b+48|0;f=b+44|0;g=b+40|0;h=b+36|0;j=b+32|0;k=b+28|0;l=b+24|0;m=b+20|0;n=b+16|0;o=b+12|0;p=b+8|0;q=b+4|0;r=b;c[e>>2]=a;c[f>>2]=0;c[g>>2]=0;c[h>>2]=0;c[j>>2]=0;c[k>>2]=0;c[l>>2]=0;c[m>>2]=0;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=60){i=b;return}if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=33){i=b;return}if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)!=69){i=b;return}if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)!=78){i=b;return}if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)!=84){i=b;return}if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=73){i=b;return}if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)!=84){i=b;return}if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0|0)!=89){i=b;return}c[o>>2]=c[(c[e>>2]|0)+36>>2];if(((c[(c[e>>2]|0)+292>>2]|0)==0?((c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[e>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((c[(c[(c[e>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)Fg(c[e>>2]|0);a=(c[e>>2]|0)+200|0;c[a>>2]=(c[a>>2]|0)+8;a=(c[(c[e>>2]|0)+36>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+8;a=(c[(c[e>>2]|0)+36>>2]|0)+32|0;c[a>>2]=(c[a>>2]|0)+8;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[e>>2]|0);if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[e>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[e>>2]|0)|0;c[n>>2]=Ue(c[e>>2]|0)|0;if(!(c[n>>2]|0))xg(c[e>>2]|0,65,66880);if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37){me(c[e>>2]|0);c[n>>2]=Ue(c[e>>2]|0)|0;if(!(c[n>>2]|0))xg(c[e>>2]|0,65,66920);c[l>>2]=1}c[f>>2]=Ze(c[e>>2]|0)|0;if(!(c[f>>2]|0)){xg(c[e>>2]|0,68,66952);i=b;return}if(vy(c[f>>2]|0,58)|0)Jg(c[e>>2]|0,205,66984,c[f>>2]|0,0,0);c[n>>2]=Ue(c[e>>2]|0)|0;if(!(c[n>>2]|0))xg(c[e>>2]|0,65,67032);c[(c[e>>2]|0)+172>>2]=10;n=(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==34;a:do if(c[l>>2]|0){do if(!n){if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==39)break;c[h>>2]=jf(c[e>>2]|0,j,1)|0;if((c[h>>2]|0)==0&(c[j>>2]|0)==0)og(c[e>>2]|0,84,0);if(!(c[h>>2]|0))break a;c[p>>2]=yl(c[h>>2]|0)|0;if(!(c[p>>2]|0)){Lg(c[e>>2]|0,91,67072,c[h>>2]|0);break a}a=c[e>>2]|0;do if(c[(c[p>>2]|0)+32>>2]|0)og(a,92,0);else{if(!(c[a>>2]|0))break;if(c[(c[e>>2]|0)+212>>2]|0)break;if(!(c[(c[c[e>>2]>>2]|0)+24>>2]|0))break;Gb[c[(c[c[e>>2]>>2]|0)+24>>2]&511](c[(c[e>>2]|0)+4>>2]|0,c[f>>2]|0,5,c[j>>2]|0,c[h>>2]|0,0)}while(0);Al(c[p>>2]|0);break a}while(0);c[g>>2]=df(c[e>>2]|0,m)|0;if(c[g>>2]|0){if(!(c[c[e>>2]>>2]|0))break;if(c[(c[e>>2]|0)+212>>2]|0)break;if(!(c[(c[c[e>>2]>>2]|0)+24>>2]|0))break;Gb[c[(c[c[e>>2]>>2]|0)+24>>2]&511](c[(c[e>>2]|0)+4>>2]|0,c[f>>2]|0,4,0,0,c[g>>2]|0)}}else{do if(!n){if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==39)break;c[h>>2]=jf(c[e>>2]|0,j,1)|0;if((c[h>>2]|0)==0&(c[j>>2]|0)==0)og(c[e>>2]|0,84,0);do if(c[h>>2]|0){c[q>>2]=yl(c[h>>2]|0)|0;if(!(c[q>>2]|0)){Lg(c[e>>2]|0,91,67072,c[h>>2]|0);break}if(c[(c[q>>2]|0)+32>>2]|0)og(c[e>>2]|0,92,0);Al(c[q>>2]|0)}while(0);do if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=62){if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==32)break;if(9<=(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==13)break;xg(c[e>>2]|0,65,67152)}while(0);Ue(c[e>>2]|0)|0;do if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==78){if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=68)break;if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)!=65)break;
if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)!=84)break;if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)!=65)break;a=(c[e>>2]|0)+200|0;c[a>>2]=(c[a>>2]|0)+5;a=(c[(c[e>>2]|0)+36>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+5;a=(c[(c[e>>2]|0)+36>>2]|0)+32|0;c[a>>2]=(c[a>>2]|0)+5;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[e>>2]|0);do if(!(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0)){if((ke(c[(c[e>>2]|0)+36>>2]|0,250)|0)>0)break;Ve(c[e>>2]|0)|0}while(0);do if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==13)break;xg(c[e>>2]|0,65,67184)}while(0);Ue(c[e>>2]|0)|0;c[k>>2]=Ze(c[e>>2]|0)|0;if(!(c[c[e>>2]>>2]|0))break a;if(c[(c[e>>2]|0)+212>>2]|0)break a;if(!(c[(c[c[e>>2]>>2]|0)+40>>2]|0))break a;xb[c[(c[c[e>>2]>>2]|0)+40>>2]&511](c[(c[e>>2]|0)+4>>2]|0,c[f>>2]|0,c[j>>2]|0,c[h>>2]|0,c[k>>2]|0);break a}while(0);do if(c[c[e>>2]>>2]|0){if(c[(c[e>>2]|0)+212>>2]|0)break;if(!(c[(c[c[e>>2]>>2]|0)+24>>2]|0))break;Gb[c[(c[c[e>>2]>>2]|0)+24>>2]&511](c[(c[e>>2]|0)+4>>2]|0,c[f>>2]|0,2,c[j>>2]|0,c[h>>2]|0,0)}while(0);if(!(c[(c[e>>2]|0)+16>>2]|0))break a;if((c[(c[e>>2]|0)+8>>2]|0)!=0?(qy(c[(c[(c[e>>2]|0)+8>>2]|0)+56>>2]|0,67096)|0)==0:0)break a;do if(!(c[(c[e>>2]|0)+8>>2]|0)){a=Sh(67096)|0;c[(c[e>>2]|0)+8>>2]=a;a=c[e>>2]|0;if(c[(c[e>>2]|0)+8>>2]|0){c[(c[a+8>>2]|0)+92>>2]=64;break}ie(a,67128);i=b;return}while(0);if(!(c[(c[(c[e>>2]|0)+8>>2]|0)+44>>2]|0)){a=Mh(c[(c[e>>2]|0)+8>>2]|0,67144,0,0)|0;c[(c[(c[e>>2]|0)+8>>2]|0)+44>>2]=a}XP(c[e>>2]|0,c[f>>2]|0,2,c[j>>2]|0,c[h>>2]|0,0);break a}while(0);c[g>>2]=df(c[e>>2]|0,m)|0;do if(c[c[e>>2]>>2]|0){if(c[(c[e>>2]|0)+212>>2]|0)break;if(!(c[(c[c[e>>2]>>2]|0)+24>>2]|0))break;Gb[c[(c[c[e>>2]>>2]|0)+24>>2]&511](c[(c[e>>2]|0)+4>>2]|0,c[f>>2]|0,1,0,0,c[g>>2]|0)}while(0);if((c[(c[e>>2]|0)+8>>2]|0)!=0?(qy(c[(c[(c[e>>2]|0)+8>>2]|0)+56>>2]|0,67096)|0)==0:0)break;do if(!(c[(c[e>>2]|0)+8>>2]|0)){a=Sh(67096)|0;c[(c[e>>2]|0)+8>>2]=a;a=c[e>>2]|0;if(c[(c[e>>2]|0)+8>>2]|0){c[(c[a+8>>2]|0)+92>>2]=64;break}ie(a,67128);i=b;return}while(0);if(!(c[(c[(c[e>>2]|0)+8>>2]|0)+44>>2]|0)){a=Mh(c[(c[e>>2]|0)+8>>2]|0,67144,0,0)|0;c[(c[(c[e>>2]|0)+8>>2]|0)+44>>2]=a}XP(c[e>>2]|0,c[f>>2]|0,1,0,0,c[g>>2]|0)}while(0);if((c[(c[e>>2]|0)+172>>2]|0)==-1){i=b;return}Ue(c[e>>2]|0)|0;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=62)pg(c[e>>2]|0,37,67216,c[f>>2]|0);else{if((c[o>>2]|0)!=(c[(c[e>>2]|0)+36>>2]|0))xg(c[e>>2]|0,90,67264);me(c[e>>2]|0)}do if(c[m>>2]|0){c[r>>2]=0;o=(c[c[e>>2]>>2]|0)!=0;do if(c[l>>2]|0){if(!o)break;if(!(c[(c[c[e>>2]>>2]|0)+96>>2]|0))break;c[r>>2]=Hb[c[(c[c[e>>2]>>2]|0)+96>>2]&511](c[(c[e>>2]|0)+4>>2]|0,c[f>>2]|0)|0}else{do if(o){if(!(c[(c[c[e>>2]>>2]|0)+20>>2]|0))break;c[r>>2]=Hb[c[(c[c[e>>2]>>2]|0)+20>>2]&511](c[(c[e>>2]|0)+4>>2]|0,c[f>>2]|0)|0}while(0);if(c[r>>2]|0)break;if((c[(c[e>>2]|0)+4>>2]|0)!=(c[e>>2]|0))break;c[r>>2]=VP(c[e>>2]|0,c[f>>2]|0)|0}while(0);if(!(c[r>>2]|0)){zb[c[135736>>2]&511](c[m>>2]|0);break}if(c[(c[r>>2]|0)+36>>2]|0){zb[c[135736>>2]&511](c[m>>2]|0);break}else{c[(c[r>>2]|0)+36>>2]=c[m>>2];break}}while(0);if(c[g>>2]|0)zb[c[135736>>2]&511](c[g>>2]|0);if(c[h>>2]|0)zb[c[135736>>2]&511](c[h>>2]|0);if(!(c[j>>2]|0)){i=b;return}zb[c[135736>>2]&511](c[j>>2]|0);i=b;return}function pf(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[c[h>>2]>>2]=0;if(((((((((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==35?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==82:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==69:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==81:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==85:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==73:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)==82:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0|0)==69:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+8>>0]|0|0)==68:0){b=(c[g>>2]|0)+200|0;c[b>>2]=(c[b>>2]|0)+9;b=(c[(c[g>>2]|0)+36>>2]|0)+16|0;c[b>>2]=(c[b>>2]|0)+9;b=(c[(c[g>>2]|0)+36>>2]|0)+32|0;c[b>>2]=(c[b>>2]|0)+9;if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[g>>2]|0);if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[g>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[g>>2]|0)|0;c[f>>2]=2;l=c[f>>2]|0;i=e;return l|0}if((((((((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==35?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==73:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==77:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==80:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==76:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==73:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)==69:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0|0)==68:0){b=(c[g>>2]|0)+200|0;c[b>>2]=(c[b>>2]|0)+8;b=(c[(c[g>>2]|0)+36>>2]|0)+16|0;c[b>>2]=(c[b>>2]|0)+8;b=(c[(c[g>>2]|0)+36>>2]|0)+32|0;c[b>>2]=(c[b>>2]|0)+8;if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[g>>2]|0);if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[g>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[g>>2]|0)|0;c[f>>2]=3;l=c[f>>2]|0;i=e;return l|0}c[j>>2]=1;if((((((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==35?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==70:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==73:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==88:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==69:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==68:0){b=(c[g>>2]|0)+200|0;c[b>>2]=(c[b>>2]|0)+6;b=(c[(c[g>>2]|0)+36>>2]|0)+16|0;c[b>>2]=(c[b>>2]|0)+6;b=(c[(c[g>>2]|0)+36>>2]|0)+32|0;c[b>>2]=(c[b>>2]|0)+6;if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[g>>2]|0);if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[g>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[g>>2]|0)|0;c[j>>2]=4;do if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13)xg(c[g>>2]|0,65,67328)}while(0);Ue(c[g>>2]|0)|0}c[k>>2]=ef(c[g>>2]|0)|0;c[(c[g>>2]|0)+172>>2]=3;if(!(c[k>>2]|0))xg(c[g>>2]|0,c[(c[g>>2]|0)+84>>2]|0,67360);else c[c[h>>2]>>2]=c[k>>2];c[f>>2]=c[j>>2];l=c[f>>2]|0;i=e;return l|0}function qf(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+32|0;e=b+24|0;f=b+20|0;g=b+16|0;h=b+12|0;j=b+8|0;k=b+4|0;l=b;c[f>>2]=a;c[h>>2]=0;c[j>>2]=0;a=c[f>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=40){og(a,48,0);c[e>>2]=0;m=c[e>>2]|0;i=b;return m|0}if(((c[a+292>>2]|0)==0?((c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)Fg(c[f>>2]|0);a:while(1){me(c[f>>2]|0);Ue(c[f>>2]|0)|0;c[g>>2]=Ze(c[f>>2]|0)|0;if(!(c[g>>2]|0)){n=8;break}c[l>>2]=c[h>>2];while(1){if(!(c[l>>2]|0))break;if(qy(c[g>>2]|0,c[(c[l>>2]|0)+4>>2]|0)|0){n=12;break}c[l>>2]=c[c[l>>2]>>2]}if((n|0)==12?(n=0,qg(c[f>>2]|0,541,67448,c[g>>2]|0,0),(CP(c[(c[f>>2]|0)+296>>2]|0,c[g>>2]|0)|0)==0):0)zb[c[135736>>2]&511](c[g>>2]|0);do if(!(c[l>>2]|0)){c[k>>2]=qm(c[g>>2]|0)|0;if(!(c[k>>2]|0)){n=17;break a}a=c[k>>2]|0;if(!(c[j>>2]|0)){c[j>>2]=a;c[h>>2]=a;break}else{c[c[j>>2]>>2]=a;c[j>>2]=c[k>>2];break}}while(0);Ue(c[f>>2]|0)|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=124){n=22;break}}if((n|0)==8){xg(c[f>>2]|0,68,67408);rm(c[h>>2]|0);c[e>>2]=0;m=c[e>>2]|0;i=b;return m|0}else if((n|0)==17){rm(c[h>>2]|0);c[e>>2]=0;m=c[e>>2]|0;i=b;return m|0}else if((n|0)==22){n=c[f>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=41){og(n,49,0);rm(c[h>>2]|0);c[e>>2]=0;m=c[e>>2]|0;i=b;return m|0}else{me(n);c[e>>2]=c[h>>2];m=c[e>>2]|0;i=b;return m|0}}return 0}function rf(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+32|0;e=b+24|0;f=b+20|0;g=b+16|0;h=b+12|0;j=b+8|0;k=b+4|0;l=b;c[f>>2]=a;c[h>>2]=0;c[j>>2]=0;a=c[f>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=40){og(a,50,0);c[e>>2]=0;m=c[e>>2]|0;i=b;return m|0}if(((c[a+292>>2]|0)==0?((c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)Fg(c[f>>2]|0);a:while(1){me(c[f>>2]|0);Ue(c[f>>2]|0)|0;c[g>>2]=cf(c[f>>2]|0)|0;if(!(c[g>>2]|0)){n=8;break}c[l>>2]=c[h>>2];while(1){if(!(c[l>>2]|0))break;if(qy(c[g>>2]|0,c[(c[l>>2]|0)+4>>2]|0)|0){n=12;break}c[l>>2]=c[c[l>>2]>>2]}if((n|0)==12?(n=0,qg(c[f>>2]|0,541,67512,c[g>>2]|0,0),(CP(c[(c[f>>2]|0)+296>>2]|0,c[g>>2]|0)|0)==0):0)zb[c[135736>>2]&511](c[g>>2]|0);do if(!(c[l>>2]|0)){c[k>>2]=qm(c[g>>2]|0)|0;if(!(CP(c[(c[f>>2]|0)+296>>2]|0,c[g>>2]|0)|0))zb[c[135736>>2]&511](c[g>>2]|0);if(!(c[k>>2]|0)){n=19;break a}a=c[k>>2]|0;if(!(c[j>>2]|0)){c[j>>2]=a;c[h>>2]=a;break}else{c[c[j>>2]>>2]=a;c[j>>2]=c[k>>2];break}}while(0);Ue(c[f>>2]|0)|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=124){n=24;break}}if((n|0)==8){og(c[f>>2]|0,67,0);c[e>>2]=c[h>>2];m=c[e>>2]|0;i=b;return m|0}else if((n|0)==19){rm(c[h>>2]|0);c[e>>2]=0;m=c[e>>2]|0;i=b;return m|0}else if((n|0)==24){n=c[f>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=41){og(n,51,0);c[e>>2]=c[h>>2];m=c[e>>2]|0;i=b;return m|0}else{me(n);c[e>>2]=c[h>>2];m=c[e>>2]|0;i=b;return m|0}}return 0}function sf(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[g>>2]=a;c[h>>2]=b;if((((((((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==78?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==79:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==84:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==65:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==84:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==73:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)==79:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0|0)==78:0){b=(c[g>>2]|0)+200|0;c[b>>2]=(c[b>>2]|0)+8;b=(c[(c[g>>2]|0)+36>>2]|0)+16|0;c[b>>2]=(c[b>>2]|0)+8;b=(c[(c[g>>2]|0)+36>>2]|0)+32|0;c[b>>2]=(c[b>>2]|0)+8;if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[g>>2]|0);if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[g>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[g>>2]|0)|0;do if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13){xg(c[g>>2]|0,65,67576);c[f>>2]=0;j=c[f>>2]|0;i=e;return j|0}}while(0);Ue(c[g>>2]|0)|0;b=qf(c[g>>2]|0)|0;c[c[h>>2]>>2]=b;if(!(c[c[h>>2]>>2]|0)){c[f>>2]=0;j=c[f>>2]|0;i=e;return j|0}else{c[f>>2]=10;j=c[f>>2]|0;i=e;return j|0}}b=rf(c[g>>2]|0)|0;c[c[h>>2]>>2]=b;if(!(c[c[h>>2]>>2]|0)){c[f>>2]=0;j=c[f>>2]|0;i=e;return j|0}else{c[f>>2]=9;j=c[f>>2]|0;i=e;return j|0}return 0}function tf(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[g>>2]=a;c[h>>2]=b;if(((c[(c[g>>2]|0)+292>>2]|0)==0?((c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)Fg(c[g>>2]|0);if(((((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==67?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==68:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==65:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==84:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==65:0){b=(c[g>>2]|0)+200|0;c[b>>2]=(c[b>>2]|0)+5;b=(c[(c[g>>2]|0)+36>>2]|0)+16|0;c[b>>2]=(c[b>>2]|0)+5;b=(c[(c[g>>2]|0)+36>>2]|0)+32|0;c[b>>2]=(c[b>>2]|0)+5;if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[g>>2]|0);if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[g>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[g>>2]|0)|0;c[f>>2]=1;j=c[f>>2]|0;i=e;return j|0}if((((((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==73?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==68:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==82:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==69:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==70:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==83:0){b=(c[g>>2]|0)+200|0;c[b>>2]=(c[b>>2]|0)+6;b=(c[(c[g>>2]|0)+36>>2]|0)+16|0;c[b>>2]=(c[b>>2]|0)+6;b=(c[(c[g>>2]|0)+36>>2]|0)+32|0;c[b>>2]=(c[b>>2]|0)+6;if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[g>>2]|0);if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[g>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[g>>2]|0)|0;c[f>>2]=4;j=c[f>>2]|0;i=e;return j|0}if(((((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==73?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==68:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==82:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==69:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==70:0){b=(c[g>>2]|0)+200|0;c[b>>2]=(c[b>>2]|0)+5;b=(c[(c[g>>2]|0)+36>>2]|0)+16|0;c[b>>2]=(c[b>>2]|0)+5;b=(c[(c[g>>2]|0)+36>>2]|0)+32|0;c[b>>2]=(c[b>>2]|0)+5;if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[g>>2]|0);if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[g>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[g>>2]|0)|0;c[f>>2]=3;j=c[f>>2]|0;i=e;return j|0}if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==73?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==68:0){b=(c[g>>2]|0)+200|0;c[b>>2]=(c[b>>2]|0)+2;b=(c[(c[g>>2]|0)+36>>2]|0)+16|0;c[b>>2]=(c[b>>2]|0)+2;b=(c[(c[g>>2]|0)+36>>2]|0)+32|0;c[b>>2]=(c[b>>2]|0)+2;if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[g>>2]|0);if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[g>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[g>>2]|0)|0;c[f>>2]=2;j=c[f>>2]|0;i=e;return j|0}if((((((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==69?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==78:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==84:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==73:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==84:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==89:0){b=(c[g>>2]|0)+200|0;c[b>>2]=(c[b>>2]|0)+6;b=(c[(c[g>>2]|0)+36>>2]|0)+16|0;c[b>>2]=(c[b>>2]|0)+6;b=(c[(c[g>>2]|0)+36>>2]|0)+32|0;c[b>>2]=(c[b>>2]|0)+6;if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[g>>2]|0);if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[g>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[g>>2]|0)|0;c[f>>2]=5;j=c[f>>2]|0;i=e;return j|0}if((((((((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==69?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==78:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==84:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==73:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==84:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==73:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)==69:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0|0)==83:0){b=(c[g>>2]|0)+200|0;c[b>>2]=(c[b>>2]|0)+8;b=(c[(c[g>>2]|0)+36>>2]|0)+16|0;c[b>>2]=(c[b>>2]|0)+8;b=(c[(c[g>>2]|0)+36>>2]|0)+32|0;c[b>>2]=(c[b>>2]|0)+8;if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[g>>2]|0);if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[g>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[g>>2]|0)|0;c[f>>2]=6;j=c[f>>2]|0;i=e;return j|0}if((((((((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==78?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==77:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==84:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==79:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==75:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==69:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)==78:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0|0)==83:0){b=(c[g>>2]|0)+200|0;c[b>>2]=(c[b>>2]|0)+8;b=(c[(c[g>>2]|0)+36>>2]|0)+16|0;c[b>>2]=(c[b>>2]|0)+8;b=(c[(c[g>>2]|0)+36>>2]|0)+32|0;c[b>>2]=(c[b>>2]|0)+8;if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[g>>2]|0);if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[g>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[g>>2]|0)|0;c[f>>2]=8;j=c[f>>2]|0;i=e;return j|0}if(((((((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==78?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==77:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==84:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==79:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==75:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==69:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)==78:0){b=(c[g>>2]|0)+200|0;c[b>>2]=(c[b>>2]|0)+7;b=(c[(c[g>>2]|0)+36>>2]|0)+16|0;c[b>>2]=(c[b>>2]|0)+7;b=(c[(c[g>>2]|0)+36>>2]|0)+32|0;c[b>>2]=(c[b>>2]|0)+7;if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[g>>2]|0);if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[g>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[g>>2]|0)|0;c[f>>2]=7;j=c[f>>2]|0;i=e;return j|0}c[f>>2]=sf(c[g>>2]|0,c[h>>2]|0)|0;j=c[f>>2]|0;i=e;return j|0}function uf(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+48|0;e=b+32|0;f=b+28|0;g=b+24|0;h=b+20|0;j=b+16|0;k=b+12|0;l=b+8|0;m=b+4|0;n=b;c[e>>2]=a;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=60){i=b;return}if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=33){i=b;return}if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)!=65){i=b;return}if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)!=84){i=b;return}if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)!=84){i=b;return}if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=76){i=b;return}if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)!=73){i=b;return}if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0|0)!=83){i=b;return}if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+8>>0]|0|0)!=84){i=b;return}c[j>>2]=c[(c[e>>2]|0)+36>>2];a=(c[e>>2]|0)+200|0;c[a>>2]=(c[a>>2]|0)+9;a=(c[(c[e>>2]|0)+36>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+9;a=(c[(c[e>>2]|0)+36>>2]|0)+32|0;c[a>>2]=(c[a>>2]|0)+9;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[e>>2]|0);if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[e>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[e>>2]|0)|0;do if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13)xg(c[e>>2]|0,65,67616)}while(0);Ue(c[e>>2]|0)|0;c[f>>2]=Ze(c[e>>2]|0)|0;a=c[e>>2]|0;if(!(c[f>>2]|0)){xg(a,68,67656);i=b;return}Ue(a)|0;if((c[(c[e>>2]|0)+292>>2]|0)==0?((c[(c[(c[e>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[e>>2]|0);a:while(1){if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==62)break;if((c[(c[e>>2]|0)+172>>2]|0)==-1)break;c[k>>2]=c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2];c[n>>2]=0;if((c[(c[e>>2]|0)+292>>2]|0)==0?((c[(c[(c[e>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[e>>2]|0);c[h>>2]=0;c[g>>2]=Ze(c[e>>2]|0)|0;o=c[e>>2]|0;if(!(c[g>>2]|0)){p=31;break}do if(!(c[o+292>>2]|0)){if(((c[(c[(c[e>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=250)break;vg(c[e>>2]|0)}while(0);do if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13){p=39;break a}}while(0);Ue(c[e>>2]|0)|0;c[l>>2]=tf(c[e>>2]|0,h)|0;if((c[l>>2]|0)<=0)break;do if(!(c[(c[e>>2]|0)+292>>2]|0)){if(((c[(c[(c[e>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=250)break;vg(c[e>>2]|0)}while(0);do if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13){p=48;break a}}while(0);Ue(c[e>>2]|0)|0;c[m>>2]=pf(c[e>>2]|0,n)|0;if((c[m>>2]|0)<=0){p=51;break}if((c[l>>2]|0)!=1&(c[n>>2]|0)!=0)Mg(c[n>>2]|0,c[n>>2]|0)|0;do if(!(c[(c[e>>2]|0)+292>>2]|0)){if(((c[(c[(c[e>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=250)break;vg(c[e>>2]|0)}while(0);if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=62){do if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13){p=65;break a}}while(0);Ue(c[e>>2]|0)|0}q=c[e>>2]|0;if((c[k>>2]|0)==(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)){p=71;break}do if(c[q>>2]|0){if(c[(c[e>>2]|0)+212>>2]|0){p=79;break}if(!(c[(c[c[e>>2]>>2]|0)+32>>2]|0)){p=79;break}wb[c[(c[c[e>>2]>>2]|0)+32>>2]&511](c[(c[e>>2]|0)+4>>2]|0,c[f>>2]|0,c[g>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,c[h>>2]|0)}else p=79;while(0);do if((p|0)==79){p=0;if(!(c[h>>2]|0))break;rm(c[h>>2]|0)}while(0);if(((c[n>>2]|0)!=0?(c[(c[e>>2]|0)+324>>2]|0)!=0:0)&(c[m>>2]|0)!=3&(c[m>>2]|0)!=2)Ng(c[e>>2]|0,c[f>>2]|0,c[g>>2]|0,c[n>>2]|0);if(c[(c[e>>2]|0)+324>>2]|0)Og(c[e>>2]|0,c[f>>2]|0,c[g>>2]|0,c[l>>2]|0);if(c[n>>2]|0)zb[c[135736>>2]&511](c[n>>2]|0);if(c[(c[e>>2]|0)+292>>2]|0)continue;if(((c[(c[(c[e>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=250)continue;vg(c[e>>2]|0)}if((p|0)==31)xg(o,68,67688);else if((p|0)==39)xg(c[e>>2]|0,65,67720);else if((p|0)==48){xg(c[e>>2]|0,65,67768);if(c[h>>2]|0)rm(c[h>>2]|0)}else if((p|0)==51){if(c[n>>2]|0)zb[c[135736>>2]&511](c[n>>2]|0);if(c[h>>2]|0)rm(c[h>>2]|0)}else if((p|0)==65){xg(c[e>>2]|0,65,67816);if(c[n>>2]|0)zb[c[135736>>2]&511](c[n>>2]|0);if(c[h>>2]|0)rm(c[h>>2]|0)}else if((p|0)==71){og(q,1,67872);if(c[n>>2]|0)zb[c[135736>>2]&511](c[n>>2]|0);if(c[h>>2]|0)rm(c[h>>2]|0)}if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=62){i=b;return}if((c[j>>2]|0)!=(c[(c[e>>2]|0)+36>>2]|0))qg(c[e>>2]|0,90,67904,0,0);me(c[e>>2]|0);i=b;return}function vf(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=0;c[k>>2]=0;c[m>>2]=0;if((c[(c[g>>2]|0)+292>>2]|0)==0?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[g>>2]|0);do if(((((((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==35?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==80:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==67:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==68:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==65:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==84:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)==65:0){b=(c[g>>2]|0)+200|0;c[b>>2]=(c[b>>2]|0)+7;b=(c[(c[g>>2]|0)+36>>2]|0)+16|0;c[b>>2]=(c[b>>2]|0)+7;b=(c[(c[g>>2]|0)+36>>2]|0)+32|0;c[b>>2]=(c[b>>2]|0)+7;if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[g>>2]|0);if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[g>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[g>>2]|0)|0;Ue(c[g>>2]|0)|0;if(((c[(c[g>>2]|0)+292>>2]|0)==0?((c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)Fg(c[g>>2]|0);b=c[g>>2]|0;if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==41){if((c[b+104>>2]|0)!=0?(c[(c[(c[g>>2]|0)+36>>2]|0)+56>>2]|0)!=(c[h>>2]|0):0)qg(c[g>>2]|0,90,67976,0,0);me(c[g>>2]|0);c[j>>2]=im(c[(c[g>>2]|0)+8>>2]|0,0,1)|0;if(!(c[j>>2]|0)){c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==42){c[(c[j>>2]|0)+4>>2]=3;me(c[g>>2]|0)}c[f>>2]=c[j>>2];n=c[f>>2]|0;i=e;return n|0}if(!((d[c[(c[b+36>>2]|0)+16>>2]>>0]|0|0)!=40?(d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=124:0))o=31;if((o|0)==31?(b=im(c[(c[g>>2]|0)+8>>2]|0,0,1)|0,c[k>>2]=b,c[j>>2]=b,(c[j>>2]|0)==0):0){c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}while(1){if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==124)p=(c[(c[g>>2]|0)+172>>2]|0)!=-1;else p=0;q=c[g>>2]|0;if(!p){o=54;break}me(q);b=(c[m>>2]|0)==0;a=im(c[(c[g>>2]|0)+8>>2]|0,0,4)|0;if(b){c[j>>2]=a;if(!(c[j>>2]|0)){o=38;break}c[(c[j>>2]|0)+12>>2]=c[k>>2];if(c[k>>2]|0)c[(c[k>>2]|0)+20>>2]=c[j>>2];c[k>>2]=c[j>>2]}else{c[l>>2]=a;if(!(c[l>>2]|0)){o=43;break}a=im(c[(c[g>>2]|0)+8>>2]|0,c[m>>2]|0,2)|0;c[(c[l>>2]|0)+12>>2]=a;if(c[(c[l>>2]|0)+12>>2]|0)c[(c[(c[l>>2]|0)+12>>2]|0)+20>>2]=c[l>>2];c[(c[k>>2]|0)+16>>2]=c[l>>2];if(c[l>>2]|0)c[(c[l>>2]|0)+20>>2]=c[k>>2];c[k>>2]=c[l>>2]}Ue(c[g>>2]|0)|0;c[m>>2]=Ze(c[g>>2]|0)|0;r=c[g>>2]|0;if(!(c[m>>2]|0)){o=50;break}Ue(r)|0;if(c[(c[g>>2]|0)+292>>2]|0)continue;if(((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=250)continue;vg(c[g>>2]|0)}if((o|0)==38){c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}else if((o|0)==43){c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}else if((o|0)==50){xg(r,68,68048);lm(c[(c[g>>2]|0)+8>>2]|0,c[k>>2]|0);c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}else if((o|0)==54){if((d[c[(c[q+36>>2]|0)+16>>2]>>0]|0|0)==41?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==42:0){do if(c[m>>2]|0){a=im(c[(c[g>>2]|0)+8>>2]|0,c[m>>2]|0,2)|0;c[(c[k>>2]|0)+16>>2]=a;if(!(c[(c[k>>2]|0)+16>>2]|0))break;c[(c[(c[k>>2]|0)+16>>2]|0)+20>>2]=c[k>>2]}while(0);if(c[j>>2]|0)c[(c[j>>2]|0)+4>>2]=3;do if(c[(c[g>>2]|0)+104>>2]|0){if((c[(c[(c[g>>2]|0)+36>>2]|0)+56>>2]|0)==(c[h>>2]|0))break;qg(c[g>>2]|0,90,67976,0,0)}while(0);a=(c[g>>2]|0)+200|0;c[a>>2]=(c[a>>2]|0)+2;a=(c[(c[g>>2]|0)+36>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+2;a=(c[(c[g>>2]|0)+36>>2]|0)+32|0;c[a>>2]=(c[a>>2]|0)+2;if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[g>>2]|0);if(d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0)break;if((ke(c[(c[g>>2]|0)+36>>2]|0,250)|0)>0)break;Ve(c[g>>2]|0)|0;break}lm(c[(c[g>>2]|0)+8>>2]|0,c[j>>2]|0);og(c[g>>2]|0,52,0);c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}}else o=70;while(0);if((o|0)==70)og(c[g>>2]|0,69,0);c[f>>2]=c[j>>2];n=c[f>>2]|0;i=e;return n|0}function wf(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=e;c[l>>2]=0;c[m>>2]=c[(c[(c[h>>2]|0)+36>>2]|0)+56>>2];c[c[k>>2]>>2]=0;e=c[h>>2]|0;if((d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=40){pg(e,54,68104,c[j>>2]|0);c[g>>2]=-1;o=c[g>>2]|0;i=f;return o|0}me(e);if((c[(c[h>>2]|0)+292>>2]|0)==0?((c[(c[(c[h>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[h>>2]|0);if((c[(c[h>>2]|0)+172>>2]|0)==-1){c[g>>2]=-1;o=c[g>>2]|0;i=f;return o|0}Ue(c[h>>2]|0)|0;if(((((((d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==35?(d[(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==80:0)?(d[(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==67:0)?(d[(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==68:0)?(d[(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==65:0)?(d[(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==84:0)?(d[(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)==65:0){c[l>>2]=vf(c[h>>2]|0,c[m>>2]|0)|0;c[n>>2]=3}else{c[l>>2]=Pg(c[h>>2]|0,c[m>>2]|0,1)|0;c[n>>2]=4}Ue(c[h>>2]|0)|0;c[c[k>>2]>>2]=c[l>>2];c[g>>2]=c[n>>2];o=c[g>>2]|0;i=f;return o|0}function xf(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+32|0;e=b+20|0;f=b+16|0;g=b+12|0;h=b+8|0;j=b+4|0;k=b;c[f>>2]=a;c[h>>2]=-1;c[j>>2]=0;a:do if(((((((((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==33:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==69:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==76:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==69:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==77:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)==69:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0|0)==78:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+8>>0]|0|0)==84:0){c[k>>2]=c[(c[f>>2]|0)+36>>2];a=(c[f>>2]|0)+200|0;c[a>>2]=(c[a>>2]|0)+9;a=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+9;a=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[a>>2]=(c[a>>2]|0)+9;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[f>>2]|0);if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[f>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[f>>2]|0)|0;do if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13)xg(c[f>>2]|0,65,68152)}while(0);Ue(c[f>>2]|0)|0;c[g>>2]=Ze(c[f>>2]|0)|0;if(!(c[g>>2]|0)){xg(c[f>>2]|0,68,68184);c[e>>2]=-1;l=c[e>>2]|0;i=b;return l|0}while(1){if(!(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0))m=(c[(c[f>>2]|0)+40>>2]|0)>1;else m=0;n=c[f>>2]|0;if(!m)break;Ve(n)|0}do if((d[c[(c[n+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13)xg(c[f>>2]|0,65,68232)}while(0);Ue(c[f>>2]|0)|0;do if((((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==69?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==77:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==80:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==84:0){if((d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)!=89){o=42;break}a=(c[f>>2]|0)+200|0;c[a>>2]=(c[a>>2]|0)+5;a=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+5;a=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[a>>2]=(c[a>>2]|0)+5;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[f>>2]|0);do if(!(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0)){if((ke(c[(c[f>>2]|0)+36>>2]|0,250)|0)>0)break;Ve(c[f>>2]|0)|0}while(0);c[h>>2]=1}else o=42;while(0);b:do if((o|0)==42){do if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==65?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==78:0){if((d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)!=89)break;a=(c[f>>2]|0)+200|0;c[a>>2]=(c[a>>2]|0)+3;a=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+3;a=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[a>>2]=(c[a>>2]|0)+3;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[f>>2]|0);do if(!(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0)){if((ke(c[(c[f>>2]|0)+36>>2]|0,250)|0)>0)break;Ve(c[f>>2]|0)|0}while(0);c[h>>2]=2;break b}while(0);a=c[f>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==40){c[h>>2]=wf(a,c[g>>2]|0,j)|0;break}do if((d[c[(c[a+36>>2]|0)+16>>2]>>0]|0|0)==37){if(c[(c[f>>2]|0)+96>>2]|0){o=57;break}if((c[(c[f>>2]|0)+40>>2]|0)!=1){o=57;break}xg(c[f>>2]|0,21,68272)}else o=57;while(0);if((o|0)==57)xg(c[f>>2]|0,54,68336);c[e>>2]=-1;l=c[e>>2]|0;i=b;return l|0}while(0);Ue(c[f>>2]|0)|0;while(1){if(!(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0))p=(c[(c[f>>2]|0)+40>>2]|0)>1;else p=0;q=c[f>>2]|0;if(!p)break;Ve(q)|0}Ue(q)|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=62){og(c[f>>2]|0,73,0);if(!(c[j>>2]|0))break;lm(c[(c[f>>2]|0)+8>>2]|0,c[j>>2]|0);break}if((c[k>>2]|0)!=(c[(c[f>>2]|0)+36>>2]|0))xg(c[f>>2]|0,90,68392);me(c[f>>2]|0);do if(c[c[f>>2]>>2]|0){if(c[(c[f>>2]|0)+212>>2]|0)break;if(!(c[(c[c[f>>2]>>2]|0)+36>>2]|0))break;if(c[j>>2]|0)c[(c[j>>2]|0)+20>>2]=0;Jb[c[(c[c[f>>2]>>2]|0)+36>>2]&511](c[(c[f>>2]|0)+4>>2]|0,c[g>>2]|0,c[h>>2]|0,c[j>>2]|0);if(!(c[j>>2]|0))break a;if(c[(c[j>>2]|0)+20>>2]|0)break a;lm(c[(c[f>>2]|0)+8>>2]|0,c[j>>2]|0);break a}while(0);if(c[j>>2]|0)lm(c[(c[f>>2]|0)+8>>2]|0,c[j>>2]|0)}while(0);c[e>>2]=c[h>>2];l=c[e>>2]|0;i=b;return l|0}function yf(a){a=a|0;var b=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;e=b;c[e>>2]=a;if((c[(c[e>>2]|0)+292>>2]|0)==0?((c[(c[(c[e>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[e>>2]|0);do if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60){a=c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0;if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=33){if((d[a+1>>0]|0|0)!=63)break;mf(c[e>>2]|0);break}f=d[a+2>>0]|0;if((f|0)==78){nf(c[e>>2]|0);break}else if((f|0)==65){uf(c[e>>2]|0);break}else if((f|0)==45){kf(c[e>>2]|0);break}else if((f|0)==69){f=c[e>>2]|0;if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==76){xf(f)|0;break}if((d[(c[(c[f+36>>2]|0)+16>>2]|0)+3>>0]|0|0)!=78)break;of(c[e>>2]|0);break}else break}while(0);if((c[(c[e>>2]|0)+96>>2]|0)==0?(c[(c[e>>2]|0)+40>>2]|0)==1:0)zf(c[e>>2]|0);if(c[(c[e>>2]|0)+96>>2]|0){g=c[e>>2]|0;h=g+172|0;c[h>>2]=3;i=b;return}if((c[(c[e>>2]|0)+40>>2]|0)<=1){g=c[e>>2]|0;h=g+172|0;c[h>>2]=3;i=b;return;
}if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=60){g=c[e>>2]|0;h=g+172|0;c[h>>2]=3;i=b;return}if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=33){g=c[e>>2]|0;h=g+172|0;c[h>>2]=3;i=b;return}if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)!=91){g=c[e>>2]|0;h=g+172|0;c[h>>2]=3;i=b;return}Qg(c[e>>2]|0);g=c[e>>2]|0;h=g+172|0;c[h>>2]=3;i=b;return}function zf(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[e>>2]=a;c[g>>2]=0;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=37){i=b;return}me(c[e>>2]|0);c[f>>2]=Ze(c[e>>2]|0)|0;a=c[e>>2]|0;if(!(c[f>>2]|0)){xg(a,68,68904);i=b;return}j=c[e>>2]|0;if((d[c[(c[a+36>>2]|0)+16>>2]>>0]|0|0)!=59){og(j,23,0);i=b;return}me(j);j=(c[e>>2]|0)+440|0;c[j>>2]=(c[j>>2]|0)+1;if((c[c[e>>2]>>2]|0)!=0?(c[(c[c[e>>2]>>2]|0)+96>>2]|0)!=0:0)c[g>>2]=Hb[c[(c[c[e>>2]>>2]|0)+96>>2]&511](c[(c[e>>2]|0)+4>>2]|0,c[f>>2]|0)|0;if((c[(c[e>>2]|0)+172>>2]|0)==-1){i=b;return}a:do if(c[g>>2]|0){if((c[(c[g>>2]|0)+48>>2]|0)!=4?(c[(c[g>>2]|0)+48>>2]|0)!=5:0){rg(c[e>>2]|0,27,68936,c[f>>2]|0,0);break}j=c[e>>2]|0;a=c[g>>2]|0;if((c[(c[(c[e>>2]|0)+36>>2]|0)+40>>2]|0)!=226){c[h>>2]=ug(j,a)|0;if((Xe(c[e>>2]|0,c[h>>2]|0)|0)>=0)break;i=b;return}c[h>>2]=we(j,a)|0;if((Xe(c[e>>2]|0,c[h>>2]|0)|0)<0){i=b;return}if((((((c[(c[g>>2]|0)+48>>2]|0)==5?(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60:0)?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==63:0)?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==120:0)?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==109:0)?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==108:0){do if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=32){if(9<=(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)<=10:0)break;if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=13)break a}while(0);_e(c[e>>2]|0);if((c[(c[e>>2]|0)+84>>2]|0)==32){c[(c[e>>2]|0)+172>>2]=-1;i=b;return}}}else{do if((c[(c[e>>2]|0)+28>>2]|0)==1)k=14;else{if((c[(c[e>>2]|0)+88>>2]|0)==0?(c[(c[e>>2]|0)+92>>2]|0)==0:0){k=14;break}rg(c[e>>2]|0,27,65432,c[f>>2]|0,0);c[(c[e>>2]|0)+100>>2]=0}while(0);if((k|0)==14)pg(c[e>>2]|0,26,65432,c[f>>2]|0);sg(c[e>>2]|0,0,0,0)|0}while(0);c[(c[e>>2]|0)+92>>2]=1;i=b;return}function Af(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;e=b+8|0;f=b+4|0;g=b;c[f>>2]=a;c[g>>2]=0;do if(((((((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==118?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==101:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==114:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==115:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==105:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==111:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)==110:0){a=(c[f>>2]|0)+200|0;c[a>>2]=(c[a>>2]|0)+7;a=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+7;a=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[a>>2]=(c[a>>2]|0)+7;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[f>>2]|0);if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[f>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[f>>2]|0)|0;Ue(c[f>>2]|0)|0;a=c[f>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=61){og(a,75,0);c[e>>2]=0;h=c[e>>2]|0;i=b;return h|0}me(a);Ue(c[f>>2]|0)|0;a=c[f>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==34){me(a);c[g>>2]=Lf(c[f>>2]|0)|0;j=c[f>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=34){og(j,34,0);break}else{me(j);break}}j=c[f>>2]|0;if((d[c[(c[a+36>>2]|0)+16>>2]>>0]|0|0)!=39){og(j,33,0);break}me(j);c[g>>2]=Lf(c[f>>2]|0)|0;j=c[f>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=39){og(j,34,0);break}else{me(j);break}}while(0);c[e>>2]=c[g>>2];h=c[e>>2]|0;i=b;return h|0}function Bf(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[f>>2]=a;c[g>>2]=0;Ue(c[f>>2]|0)|0;a:do if((((((((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==101?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==110:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==99:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==111:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==100:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==105:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)==110:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0|0)==103:0){a=(c[f>>2]|0)+200|0;c[a>>2]=(c[a>>2]|0)+8;a=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+8;a=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[a>>2]=(c[a>>2]|0)+8;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[f>>2]|0);if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[f>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[f>>2]|0)|0;Ue(c[f>>2]|0)|0;a=c[f>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=61){og(a,75,0);c[e>>2]=0;j=c[e>>2]|0;i=b;return j|0}me(a);Ue(c[f>>2]|0)|0;a=c[f>>2]|0;do if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==34){me(a);c[g>>2]=Mf(c[f>>2]|0)|0;k=c[f>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=34){og(k,34,0);break}else{me(k);break}}else{k=c[f>>2]|0;if((d[c[(c[a+36>>2]|0)+16>>2]>>0]|0|0)!=39){og(k,33,0);break}me(k);c[g>>2]=Mf(c[f>>2]|0)|0;k=c[f>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=39){og(k,34,0);break}else{me(k);break}}while(0);if(c[(c[f>>2]|0)+360>>2]&2097152){zb[c[135736>>2]&511](c[g>>2]|0);c[e>>2]=0;j=c[e>>2]|0;i=b;return j|0}do if(c[g>>2]|0){if((ty(c[g>>2]|0,69608)|0)!=0?(ty(c[g>>2]|0,69616)|0)!=0:0)break;do if((c[(c[f>>2]|0)+24>>2]|0)==0?(c[c[(c[f>>2]|0)+36>>2]>>2]|0)!=0:0){if(c[(c[c[(c[f>>2]|0)+36>>2]>>2]|0)+12>>2]|0)break;xg(c[f>>2]|0,81,69624)}while(0);if(c[(c[f>>2]|0)+24>>2]|0)zb[c[135736>>2]&511](c[(c[f>>2]|0)+24>>2]|0);c[(c[f>>2]|0)+24>>2]=c[g>>2];break a}while(0);do if(c[g>>2]|0){if((ty(c[g>>2]|0,69672)|0)!=0?(ty(c[g>>2]|0,69680)|0)!=0:0)break;if(c[(c[f>>2]|0)+24>>2]|0)zb[c[135736>>2]&511](c[(c[f>>2]|0)+24>>2]|0);c[(c[f>>2]|0)+24>>2]=c[g>>2];break a}while(0);if(c[g>>2]|0){if(c[(c[(c[f>>2]|0)+36>>2]|0)+44>>2]|0)zb[c[135736>>2]&511](c[(c[(c[f>>2]|0)+36>>2]|0)+44>>2]|0);c[(c[(c[f>>2]|0)+36>>2]|0)+44>>2]=c[g>>2];c[h>>2]=Dd(c[g>>2]|0)|0;a=c[f>>2]|0;if(c[h>>2]|0){se(a,c[h>>2]|0)|0;break}pg(a,32,69688,c[g>>2]|0);c[e>>2]=0;j=c[e>>2]|0;i=b;return j|0}}while(0);c[e>>2]=c[g>>2];j=c[e>>2]|0;i=b;return j|0}function Cf(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g+24|0;m=g+8|0;n=g+4|0;o=g;c[h>>2]=b;c[j>>2]=e;c[k>>2]=f;Rg(c[h>>2]|0);if((c[(c[h>>2]|0)+292>>2]|0)==0?((c[(c[(c[h>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[h>>2]|0);if(((c[(c[h>>2]|0)+24>>2]|0)==0?((c[(c[(c[h>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=4:0)?(a[l>>0]=a[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0,a[l+1>>0]=a[(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0,a[l+2>>0]=a[(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0,a[l+3>>0]=a[(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0,c[m>>2]=sd(l,4)|0,(c[m>>2]|0)!=0):0)re(c[h>>2]|0,c[m>>2]|0)|0;if((((((d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(d[(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==63:0)?(d[(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==120:0)?(d[(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==109:0)?(d[(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==108:0)?(_e(c[h>>2]|0),(c[(c[h>>2]|0)+84>>2]|0)==32):0){c[(c[h>>2]|0)+172>>2]=-1;i=g;return}do if(!(c[(c[h>>2]|0)+8>>2]|0)){m=Sh(68488)|0;c[(c[h>>2]|0)+8>>2]=m;m=c[h>>2]|0;if(c[(c[h>>2]|0)+8>>2]|0){c[(c[m+8>>2]|0)+92>>2]=64;break}ie(m,67128);i=g;return}while(0);if((c[(c[h>>2]|0)+8>>2]|0)!=0?(c[(c[(c[h>>2]|0)+8>>2]|0)+44>>2]|0)==0:0)Oh(c[(c[h>>2]|0)+8>>2]|0,0,c[j>>2]|0,c[k>>2]|0)|0;c[(c[h>>2]|0)+172>>2]=3;c[(c[h>>2]|0)+96>>2]=1;a:while(1){if(!((d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(d[(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==63:0))p=25;do if((p|0)==25){p=0;if((d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(d[(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==33:0)break;if((d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=37?(d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32:0){if(9<=(d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13)break a}}while(0);c[n>>2]=c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2];c[o>>2]=c[(c[(c[h>>2]|0)+36>>2]|0)+36>>2];if((c[(c[h>>2]|0)+292>>2]|0)==0?((c[(c[(c[h>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[h>>2]|0);if(((d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(d[(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==33:0)?(d[(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==91:0)Qg(c[h>>2]|0);else p=39;b:do if((p|0)==39){p=0;do if((d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13){k=c[h>>2]|0;if((d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37){zf(k);break b}else{yf(k);break b}}}while(0);me(c[h>>2]|0)}while(0);while(1){if(!(d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0))q=(c[(c[h>>2]|0)+40>>2]|0)>1;else q=0;r=c[h>>2]|0;if(!q)break;Ve(r)|0}if((c[(c[r+36>>2]|0)+16>>2]|0)!=(c[n>>2]|0))continue;if((c[o>>2]|0)==(c[(c[(c[h>>2]|0)+36>>2]|0)+36>>2]|0)){p=53;break}}if((p|0)==53)og(c[h>>2]|0,60,0);if(!(d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0)){i=g;return}og(c[h>>2]|0,60,0);i=g;return}function Df(e){e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;f=i;i=i+112|0;g=f;h=f+84|0;j=f+80|0;k=f+76|0;l=f+72|0;m=f+68|0;n=f+64|0;o=f+60|0;p=f+88|0;q=f+56|0;r=f+52|0;s=f+48|0;t=f+44|0;u=f+40|0;v=f+36|0;w=f+32|0;x=f+28|0;y=f+24|0;z=f+20|0;A=f+16|0;B=f+12|0;C=f+8|0;D=f+4|0;c[h>>2]=e;c[m>>2]=0;c[n>>2]=0;if((d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=38){i=f;return}if((d[(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==35){c[o>>2]=0;c[q>>2]=d[(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0];c[r>>2]=Ye(c[h>>2]|0)|0;if(!(c[r>>2]|0)){i=f;return}if((c[(c[h>>2]|0)+256>>2]|0)==1){e=pe(p+(c[o>>2]|0)|0,c[r>>2]|0)|0;c[o>>2]=(c[o>>2]|0)+e;a[p+(c[o>>2]|0)>>0]=0;if(!(c[c[h>>2]>>2]|0)){i=f;return}if(!(c[(c[c[h>>2]>>2]|0)+68>>2]|0)){i=f;return}if(c[(c[h>>2]|0)+212>>2]|0){i=f;return}Db[c[(c[c[h>>2]>>2]|0)+68>>2]&511](c[(c[h>>2]|0)+4>>2]|0,p,c[o>>2]|0);i=f;return}if((c[r>>2]|0)<=255){a[p>>0]=c[r>>2];a[p+1>>0]=0;if(!(c[c[h>>2]>>2]|0)){i=f;return}if(!(c[(c[c[h>>2]>>2]|0)+68>>2]|0)){i=f;return}if(c[(c[h>>2]|0)+212>>2]|0){i=f;return}Db[c[(c[c[h>>2]>>2]|0)+68>>2]&511](c[(c[h>>2]|0)+4>>2]|0,p,1);i=f;return}o=c[r>>2]|0;if((c[q>>2]|0)==120|(c[q>>2]|0)==88){c[g>>2]=o;JT(p,10,68560,g)|0}else{c[g>>2]=o;JT(p,10,68568,g)|0}if(!(c[c[h>>2]>>2]|0)){i=f;return}if(!(c[(c[c[h>>2]>>2]|0)+64>>2]|0)){i=f;return}if(c[(c[h>>2]|0)+212>>2]|0){i=f;return}Ab[c[(c[c[h>>2]>>2]|0)+64>>2]&511](c[(c[h>>2]|0)+4>>2]|0,p);i=f;return}c[j>>2]=Ef(c[h>>2]|0)|0;if(!(c[j>>2]|0)){i=f;return}if(!(c[(c[h>>2]|0)+12>>2]|0)){i=f;return}c[l>>2]=c[(c[j>>2]|0)+72>>2];if((c[(c[j>>2]|0)+8>>2]|0)!=0?(c[(c[j>>2]|0)+48>>2]|0)!=6:0){do if(!(c[(c[j>>2]|0)+72>>2]|0)){if((c[(c[j>>2]|0)+48>>2]|0)==2?(c[(c[h>>2]|0)+360>>2]&18|0)==0:0){E=76;break}c[s>>2]=c[(c[h>>2]|0)+440>>2];if((c[(c[h>>2]|0)+4>>2]|0)==(c[h>>2]|0))c[t>>2]=0;else c[t>>2]=c[(c[h>>2]|0)+4>>2];do if((c[(c[j>>2]|0)+48>>2]|0)!=1)if((c[(c[j>>2]|0)+48>>2]|0)==2){p=(c[h>>2]|0)+248|0;c[p>>2]=(c[p>>2]|0)+1;c[n>>2]=Tg(c[(c[h>>2]|0)+8>>2]|0,c[h>>2]|0,c[c[h>>2]>>2]|0,c[t>>2]|0,c[(c[h>>2]|0)+248>>2]|0,c[(c[j>>2]|0)+64>>2]|0,c[(c[j>>2]|0)+52>>2]|0,m)|0;p=(c[h>>2]|0)+248|0;c[p>>2]=(c[p>>2]|0)+-1;break}else{c[n>>2]=88;Lg(c[h>>2]|0,1,68576,0);break}else{p=(c[h>>2]|0)+248|0;c[p>>2]=(c[p>>2]|0)+1;c[n>>2]=Sg(c[h>>2]|0,c[(c[j>>2]|0)+40>>2]|0,c[t>>2]|0,m)|0;p=(c[h>>2]|0)+248|0;c[p>>2]=(c[p>>2]|0)+-1}while(0);c[(c[j>>2]|0)+72>>2]=(c[(c[h>>2]|0)+440>>2]|0)-(c[s>>2]|0)+1<<1;if((c[(c[j>>2]|0)+40>>2]|0)!=0?(vy(c[(c[j>>2]|0)+40>>2]|0,60)|0)!=0:0){p=(c[j>>2]|0)+72|0;c[p>>2]=c[p>>2]|1}p=c[h>>2]|0;if((c[n>>2]|0)==89){og(p,89,0);Uh(c[m>>2]|0);i=f;return}if(sg(p,0,c[j>>2]|0,0)|0){Uh(c[m>>2]|0);i=f;return}a:do if(!((c[n>>2]|0)==0&(c[m>>2]|0)!=0)){if((c[n>>2]|0)!=0&(c[n>>2]|0)!=27){pg(c[h>>2]|0,26,68608,c[(c[j>>2]|0)+8>>2]|0);sg(c[h>>2]|0,0,c[j>>2]|0,0)|0;break}if(c[m>>2]|0){Uh(c[m>>2]|0);c[m>>2]=0}}else{if(!((c[(c[j>>2]|0)+48>>2]|0)!=1?(c[(c[j>>2]|0)+48>>2]|0)!=2:0))E=51;if((E|0)==51?(c[(c[j>>2]|0)+12>>2]|0)==0:0){c[(c[j>>2]|0)+12>>2]=c[m>>2];if(!(c[(c[h>>2]|0)+16>>2]|0)){c[(c[j>>2]|0)+68>>2]=1;while(1){if(!(c[m>>2]|0))break a;c[(c[m>>2]|0)+20>>2]=c[j>>2];ri(c[m>>2]|0,c[(c[j>>2]|0)+32>>2]|0);if(!(c[(c[m>>2]|0)+24>>2]|0))c[(c[j>>2]|0)+16>>2]=c[m>>2];c[m>>2]=c[(c[m>>2]|0)+24>>2]}}if(!((c[(c[m>>2]|0)+4>>2]|0)==3?(c[(c[m>>2]|0)+24>>2]|0)==0:0))E=55;do if((E|0)==55){if((c[(c[h>>2]|0)+436>>2]|0)==5)break;c[(c[j>>2]|0)+68>>2]=0;while(1){if(!(c[m>>2]|0))break;c[(c[m>>2]|0)+20>>2]=c[(c[h>>2]|0)+52>>2];c[(c[m>>2]|0)+32>>2]=c[(c[h>>2]|0)+8>>2];if(!(c[(c[m>>2]|0)+24>>2]|0))c[(c[j>>2]|0)+16>>2]=c[m>>2];c[m>>2]=c[(c[m>>2]|0)+24>>2]}c[m>>2]=c[(c[j>>2]|0)+12>>2];if((c[(c[j>>2]|0)+48>>2]|0)!=2)break a;Ug(c[j>>2]|0,c[m>>2]|0,0);break a}while(0);c[(c[m>>2]|0)+20>>2]=c[j>>2];c[m>>2]=0;c[(c[j>>2]|0)+68>>2]=1;break}Uh(c[m>>2]|0);c[m>>2]=0}while(0);if(!(c[(c[j>>2]|0)+72>>2]|0))c[(c[j>>2]|0)+72>>2]=2}else E=76;while(0);if((E|0)==76?(c[(c[j>>2]|0)+72>>2]|0)!=1:0){s=(c[h>>2]|0)+440|0;c[s>>2]=(c[s>>2]|0)+((c[(c[j>>2]|0)+72>>2]|0)/2|0)}if(!(c[(c[j>>2]|0)+12>>2]|0)){if(c[l>>2]|0){if((c[(c[h>>2]|0)+4>>2]|0)==(c[h>>2]|0))c[u>>2]=0;else c[u>>2]=c[(c[h>>2]|0)+4>>2];do if((c[(c[j>>2]|0)+48>>2]|0)!=1)if((c[(c[j>>2]|0)+48>>2]|0)==2){l=(c[h>>2]|0)+248|0;c[l>>2]=(c[l>>2]|0)+1;c[n>>2]=Tg(c[(c[h>>2]|0)+8>>2]|0,c[h>>2]|0,c[c[h>>2]>>2]|0,c[u>>2]|0,c[(c[h>>2]|0)+248>>2]|0,c[(c[j>>2]|0)+64>>2]|0,c[(c[j>>2]|0)+52>>2]|0,0)|0;l=(c[h>>2]|0)+248|0;c[l>>2]=(c[l>>2]|0)+-1;break}else{c[n>>2]=88;Lg(c[h>>2]|0,1,68576,0);break}else{l=(c[h>>2]|0)+248|0;c[l>>2]=(c[l>>2]|0)+1;c[n>>2]=Sg(c[h>>2]|0,c[(c[j>>2]|0)+40>>2]|0,c[u>>2]|0,0)|0;l=(c[h>>2]|0)+248|0;c[l>>2]=(c[l>>2]|0)+-1}while(0);if((c[n>>2]|0)==89){og(c[h>>2]|0,89,0);i=f;return}}if(!(c[c[h>>2]>>2]|0)){i=f;return}if(!(c[(c[c[h>>2]>>2]|0)+64>>2]|0)){i=f;return}if(c[(c[h>>2]|0)+16>>2]|0){i=f;return}if(c[(c[h>>2]|0)+212>>2]|0){i=f;return}Ab[c[(c[c[h>>2]>>2]|0)+64>>2]&511](c[(c[h>>2]|0)+4>>2]|0,c[(c[j>>2]|0)+8>>2]|0);i=f;return}if((((c[c[h>>2]>>2]|0)!=0?(c[(c[c[h>>2]>>2]|0)+64>>2]|0)!=0:0)?(c[(c[h>>2]|0)+16>>2]|0)==0:0)?(c[(c[h>>2]|0)+212>>2]|0)==0:0){Ab[c[(c[c[h>>2]>>2]|0)+64>>2]&511](c[(c[h>>2]|0)+4>>2]|0,c[(c[j>>2]|0)+8>>2]|0);i=f;return}if((c[(c[h>>2]|0)+16>>2]|0)==0?(c[(c[j>>2]|0)+12>>2]|0)!=0:0){i=f;return}if(!(c[(c[h>>2]|0)+52>>2]|0)){i=f;return}if(!(c[(c[j>>2]|0)+12>>2]|0)){i=f;return}if((c[m>>2]|0)==0?(c[(c[j>>2]|0)+68>>2]|0)==0:0)E=107;else E=106;do if((E|0)==106)if((c[(c[h>>2]|0)+436>>2]|0)!=5){if((c[m>>2]|0)!=0?(c[(c[h>>2]|0)+40>>2]|0)<=0:0){c[D>>2]=AP(c[(c[h>>2]|0)+296>>2]|0,68640,-1)|0;if((c[(c[(c[j>>2]|0)+12>>2]|0)+4>>2]|0)==3)c[(c[(c[j>>2]|0)+12>>2]|0)+8>>2]=c[D>>2];do if((c[(c[j>>2]|0)+16>>2]|0)!=(c[(c[j>>2]|0)+12>>2]|0)){if((c[(c[(c[j>>2]|0)+16>>2]|0)+4>>2]|0)!=3)break;c[(c[(c[j>>2]|0)+16>>2]|0)+8>>2]=c[D>>2]}while(0);yi(c[(c[h>>2]|0)+52>>2]|0,c[(c[j>>2]|0)+12>>2]|0)|0;break}c[y>>2]=0;c[C>>2]=0;n=(c[h>>2]|0)+468|0;c[n>>2]=(c[n>>2]|0)+((c[(c[j>>2]|0)+44>>2]|0)+5);if(sg(c[h>>2]|0,0,c[j>>2]|0,c[(c[h>>2]|0)+468>>2]|0)|0){i=f;return}c[z>>2]=c[(c[j>>2]|0)+12>>2];c[(c[j>>2]|0)+12>>2]=0;c[B>>2]=c[(c[j>>2]|0)+16>>2];c[(c[j>>2]|0)+16>>2]=0;while(1){if(!(c[z>>2]|0))break;c[A>>2]=c[(c[z>>2]|0)+24>>2];c[(c[z>>2]|0)+24>>2]=0;c[(c[z>>2]|0)+20>>2]=0;c[y>>2]=Ii(c[z>>2]|0,c[(c[h>>2]|0)+8>>2]|0,1)|0;if(c[y>>2]|0){if(!(c[c[y>>2]>>2]|0))c[c[y>>2]>>2]=c[c[z>>2]>>2];if(!(c[C>>2]|0))c[C>>2]=c[z>>2];zi(c[j>>2]|0,c[y>>2]|0)|0;zi(c[(c[h>>2]|0)+52>>2]|0,c[z>>2]|0)|0}if((c[z>>2]|0)==(c[B>>2]|0))break;c[z>>2]=c[A>>2]}if(!(c[(c[j>>2]|0)+68>>2]|0))c[(c[j>>2]|0)+68>>2]=1;if((c[(c[j>>2]|0)+48>>2]|0)==2)Ug(c[j>>2]|0,c[C>>2]|0,c[y>>2]|0)}else E=107;while(0);if((E|0)==107){c[v>>2]=0;c[x>>2]=0;y=(c[h>>2]|0)+468|0;c[y>>2]=(c[y>>2]|0)+((c[(c[j>>2]|0)+44>>2]|0)+5);if(sg(c[h>>2]|0,0,c[j>>2]|0,c[(c[h>>2]|0)+468>>2]|0)|0){i=f;return}c[w>>2]=c[(c[j>>2]|0)+12>>2];while(1){if(!(c[w>>2]|0))break;c[v>>2]=Ii(c[w>>2]|0,c[(c[h>>2]|0)+8>>2]|0,1)|0;if(c[v>>2]|0){if(!(c[c[v>>2]>>2]|0))c[c[v>>2]>>2]=c[c[w>>2]>>2];if(!(c[x>>2]|0))c[x>>2]=c[v>>2];c[v>>2]=zi(c[(c[h>>2]|0)+52>>2]|0,c[v>>2]|0)|0}if((c[w>>2]|0)==(c[(c[j>>2]|0)+16>>2]|0)){E=117;break}c[w>>2]=c[(c[w>>2]|0)+24>>2]}if((((E|0)==117?(c[v>>2]|0)!=0?(c[(c[h>>2]|0)+436>>2]|0)==5:0:0)?(c[(c[v>>2]|0)+4>>2]|0)==1:0)?(c[(c[v>>2]|0)+12>>2]|0)==0:0)b[(c[v>>2]|0)+58>>1]=1;if((c[(c[j>>2]|0)+48>>2]|0)==2)Ug(c[j>>2]|0,c[x>>2]|0,c[v>>2]|0)}c[(c[h>>2]|0)+264>>2]=0;c[(c[h>>2]|0)+260>>2]=0;i=f;return}c[k>>2]=c[(c[j>>2]|0)+40>>2];if(!(c[k>>2]|0)){i=f;return}if(!(c[c[h>>2]>>2]|0)){i=f;return}if(!(c[(c[c[h>>2]>>2]|0)+68>>2]|0)){i=f;return}if(c[(c[h>>2]|0)+212>>2]|0){i=f;return}j=c[(c[c[h>>2]>>2]|0)+68>>2]|0;v=c[(c[h>>2]|0)+4>>2]|0;h=c[k>>2]|0;x=xy(c[k>>2]|0)|0;Db[j&511](v,h,x);i=f;return}function Ef(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[f>>2]=a;c[h>>2]=0;if((c[(c[f>>2]|0)+292>>2]|0)==0?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[f>>2]|0);if((c[(c[f>>2]|0)+172>>2]|0)==-1){c[e>>2]=0;j=c[e>>2]|0;i=b;return j|0}if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=38){c[e>>2]=0;j=c[e>>2]|0;i=b;return j|0}me(c[f>>2]|0);c[g>>2]=Ze(c[f>>2]|0)|0;a=c[f>>2]|0;if(!(c[g>>2]|0)){xg(a,68,68648);c[e>>2]=0;j=c[e>>2]|0;i=b;return j|0}k=c[f>>2]|0;if((d[c[(c[a+36>>2]|0)+16>>2]>>0]|0|0)!=59){og(k,23,0);c[e>>2]=0;j=c[e>>2]|0;i=b;return j|0}me(k);if((c[(c[f>>2]|0)+360>>2]&1048576|0)==0?(c[h>>2]=Yc(c[g>>2]|0)|0,(c[h>>2]|0)!=0):0){c[e>>2]=c[h>>2];j=c[e>>2]|0;i=b;return j|0}k=(c[f>>2]|0)+440|0;c[k>>2]=(c[k>>2]|0)+1;if(c[c[f>>2]>>2]|0){if(c[(c[c[f>>2]>>2]|0)+20>>2]|0)c[h>>2]=Hb[c[(c[c[f>>2]>>2]|0)+20>>2]&511](c[(c[f>>2]|0)+4>>2]|0,c[g>>2]|0)|0;if(((c[h>>2]|0)==0?(c[(c[f>>2]|0)+12>>2]|0)==1:0)?(c[(c[f>>2]|0)+360>>2]&1048576|0)!=0:0)c[h>>2]=Yc(c[g>>2]|0)|0;if(((c[h>>2]|0)==0?(c[(c[f>>2]|0)+12>>2]|0)==1:0)?(c[(c[f>>2]|0)+4>>2]|0)==(c[f>>2]|0):0)c[h>>2]=VP(c[f>>2]|0,c[g>>2]|0)|0}if((c[(c[f>>2]|0)+172>>2]|0)==-1){c[e>>2]=0;j=c[e>>2]|0;i=b;return j|0}do if(c[h>>2]|0){k=c[f>>2]|0;if((c[(c[h>>2]|0)+48>>2]|0)==3){pg(k,28,68712,c[g>>2]|0);break}if((c[k+172>>2]|0)==12?(c[(c[h>>2]|0)+48>>2]|0)==2:0){pg(c[f>>2]|0,29,68752,c[g>>2]|0);break}if(((c[h>>2]|0)!=0?(c[(c[f>>2]|0)+172>>2]|0)==12:0)?(c[(c[h>>2]|0)+48>>2]|0)!=6:0){if((c[(c[h>>2]|0)+72>>2]&1|0)==0?(c[(c[h>>2]|0)+72>>2]|0)!=0:0)break;if(!(c[(c[h>>2]|0)+40>>2]|0))break;if(!(vy(c[(c[h>>2]|0)+40>>2]|0,60)|0))break;pg(c[f>>2]|0,38,68800,c[g>>2]|0);break}if(((c[(c[h>>2]|0)+48>>2]|0)+-4|0)>>>0<2)pg(c[f>>2]|0,30,68856,c[g>>2]|0)}else{do if((c[(c[f>>2]|0)+28>>2]|0)!=1){if((c[(c[f>>2]|0)+88>>2]|0)==0?(c[(c[f>>2]|0)+92>>2]|0)==0:0){l=30;break}Lg(c[f>>2]|0,27,68680,c[g>>2]|0);if(((c[(c[f>>2]|0)+216>>2]|0)==0?(c[c[f>>2]>>2]|0)!=0:0)?(c[(c[c[f>>2]>>2]|0)+64>>2]|0)!=0:0)Ab[c[(c[c[f>>2]>>2]|0)+64>>2]&511](c[(c[f>>2]|0)+4>>2]|0,c[g>>2]|0)}else l=30;while(0);if((l|0)==30)pg(c[f>>2]|0,26,68680,c[g>>2]|0);sg(c[f>>2]|0,0,c[h>>2]|0,0)|0;c[(c[f>>2]|0)+100>>2]=0}while(0);c[e>>2]=c[h>>2];j=c[e>>2]|0;i=b;return j|0}function Ff(a){a=a|0;var b=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[e>>2]=a;c[f>>2]=0;c[g>>2]=0;c[h>>2]=0;a=(c[e>>2]|0)+200|0;c[a>>2]=(c[a>>2]|0)+9;a=(c[(c[e>>2]|0)+36>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+9;a=(c[(c[e>>2]|0)+36>>2]|0)+32|0;c[a>>2]=(c[a>>2]|0)+9;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[e>>2]|0);if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[e>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[e>>2]|0)|0;Ue(c[e>>2]|0)|0;c[f>>2]=Ze(c[e>>2]|0)|0;if(!(c[f>>2]|0))xg(c[e>>2]|0,68,68984);c[(c[e>>2]|0)+220>>2]=c[f>>2];Ue(c[e>>2]|0)|0;c[h>>2]=jf(c[e>>2]|0,g,1)|0;if((c[h>>2]|0)!=0|(c[g>>2]|0)!=0)c[(c[e>>2]|0)+88>>2]=1;c[(c[e>>2]|0)+224>>2]=c[h>>2];c[(c[e>>2]|0)+228>>2]=c[g>>2];Ue(c[e>>2]|0)|0;if(((c[c[e>>2]>>2]|0)!=0?(c[c[c[e>>2]>>2]>>2]|0)!=0:0)?(c[(c[e>>2]|0)+212>>2]|0)==0:0)Jb[c[c[c[e>>2]>>2]>>2]&511](c[(c[e>>2]|0)+4>>2]|0,c[f>>2]|0,c[g>>2]|0,c[h>>2]|0);if((c[(c[e>>2]|0)+172>>2]|0)==-1){i=b;return}if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==91){i=b;return}if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=62)og(c[e>>2]|0,61,0);me(c[e>>2]|0);i=b;return}function Gf(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[c[h>>2]>>2]=0;if((c[(c[g>>2]|0)+292>>2]|0)==0?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[g>>2]|0);c[j>>2]=Ze(c[g>>2]|0)|0;b=c[g>>2]|0;if(!(c[j>>2]|0)){xg(b,68,69032);c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}Ue(b)|0;b=c[g>>2]|0;if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=61){pg(b,41,69064,c[j>>2]|0);c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}me(b);Ue(c[g>>2]|0)|0;c[k>>2]=ef(c[g>>2]|0)|0;c[(c[g>>2]|0)+172>>2]=7;if(((c[(c[g>>2]|0)+268>>2]|0)!=0?(qy(c[j>>2]|0,69112)|0)!=0:0)?(Ne(c[k>>2]|0)|0)==0:0)rg(c[g>>2]|0,98,69128,c[k>>2]|0,0);do if(qy(c[j>>2]|0,69168)|0){if(qy(c[k>>2]|0,69184)|0){c[c[(c[g>>2]|0)+232>>2]>>2]=0;break}b=(qy(c[k>>2]|0,69192)|0)!=0;a=c[g>>2]|0;if(b){c[c[a+232>>2]>>2]=1;break}else{rg(a,102,69208,c[k>>2]|0,0);break}}while(0);c[c[h>>2]>>2]=c[k>>2];c[f>>2]=c[j>>2];l=c[f>>2]|0;i=e;return l|0}function Hf(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+48|0;e=b+44|0;f=b+40|0;g=b+36|0;h=b+32|0;j=b+28|0;k=b+24|0;l=b+20|0;m=b+16|0;n=b+12|0;o=b+8|0;p=b+4|0;q=b;c[f>>2]=a;c[k>>2]=c[(c[f>>2]|0)+300>>2];c[l>>2]=0;c[m>>2]=c[(c[f>>2]|0)+304>>2];if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=60){c[e>>2]=0;r=c[e>>2]|0;i=b;return r|0}a=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[a>>2]=(c[a>>2]|0)+1;a=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+1;a=(c[f>>2]|0)+200|0;c[a>>2]=(c[a>>2]|0)+1;if(!(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0))ke(c[(c[f>>2]|0)+36>>2]|0,250)|0;c[g>>2]=Ze(c[f>>2]|0)|0;a=c[f>>2]|0;if(!(c[g>>2]|0)){xg(a,68,69280);c[e>>2]=0;r=c[e>>2]|0;i=b;return r|0}Ue(a)|0;if((c[(c[f>>2]|0)+292>>2]|0)==0?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[f>>2]|0);while(1){if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==62)break;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==47?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==62:0)break;if(!(9<=(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0))s=15;if(((s|0)==15?(s=0,(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13):0)?32>(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0):0)break;if((c[(c[f>>2]|0)+172>>2]|0)==-1)break;c[o>>2]=c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2];c[p>>2]=c[(c[(c[f>>2]|0)+36>>2]|0)+36>>2];c[h>>2]=Gf(c[f>>2]|0,j)|0;a:do if(!((c[h>>2]|0)!=0&(c[j>>2]|0)!=0)){if(c[j>>2]|0)zb[c[135736>>2]&511](c[j>>2]|0)}else{c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[l>>2]|0))break;if(qy(c[(c[k>>2]|0)+(c[n>>2]<<2)>>2]|0,c[h>>2]|0)|0){s=22;break}c[n>>2]=(c[n>>2]|0)+2}if((s|0)==22){s=0;Vg(c[f>>2]|0,0,c[h>>2]|0);zb[c[135736>>2]&511](c[j>>2]|0);break}do if(c[k>>2]|0){if(((c[l>>2]|0)+4|0)>(c[m>>2]|0)){c[m>>2]=c[m>>2]<<1;c[q>>2]=Hb[c[135760>>2]&511](c[k>>2]|0,c[m>>2]<<2)|0;if(c[q>>2]|0){c[k>>2]=c[q>>2];c[(c[f>>2]|0)+300>>2]=c[k>>2];c[(c[f>>2]|0)+304>>2]=c[m>>2];break}ie(c[f>>2]|0,0);if(!(c[j>>2]|0))break a;zb[c[135736>>2]&511](c[j>>2]|0);break a}}else{c[m>>2]=22;c[k>>2]=Cb[c[135744>>2]&511](c[m>>2]<<2)|0;if(c[k>>2]|0){c[(c[f>>2]|0)+300>>2]=c[k>>2];c[(c[f>>2]|0)+304>>2]=c[m>>2];break}ie(c[f>>2]|0,0);if(!(c[j>>2]|0))break a;zb[c[135736>>2]&511](c[j>>2]|0);break a}while(0);a=c[h>>2]|0;t=c[l>>2]|0;c[l>>2]=t+1;c[(c[k>>2]|0)+(t<<2)>>2]=a;a=c[j>>2]|0;t=c[l>>2]|0;c[l>>2]=t+1;c[(c[k>>2]|0)+(t<<2)>>2]=a;c[(c[k>>2]|0)+(c[l>>2]<<2)>>2]=0;c[(c[k>>2]|0)+((c[l>>2]|0)+1<<2)>>2]=0}while(0);if((c[(c[f>>2]|0)+292>>2]|0)==0?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[f>>2]|0);if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==62)break;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==47?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==62:0)break;do if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13)xg(c[f>>2]|0,65,69320)}while(0);Ue(c[f>>2]|0)|0;if((c[p>>2]|0)==(c[(c[(c[f>>2]|0)+36>>2]|0)+36>>2]|0)?((c[h>>2]|0)==0?(c[o>>2]|0)==(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0):0)&(c[j>>2]|0)==0:0){s=50;break}if(((c[(c[f>>2]|0)+292>>2]|0)==0?((c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)Fg(c[f>>2]|0);if(c[(c[f>>2]|0)+292>>2]|0)continue;if(((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=250)continue;vg(c[f>>2]|0)}if((s|0)==50)xg(c[f>>2]|0,1,69352);do if(((c[c[f>>2]>>2]|0)!=0?(c[(c[c[f>>2]>>2]|0)+56>>2]|0)!=0:0)?(c[(c[f>>2]|0)+212>>2]|0)==0:0){s=c[(c[c[f>>2]>>2]|0)+56>>2]|0;j=c[(c[f>>2]|0)+4>>2]|0;o=c[g>>2]|0;if((c[l>>2]|0)>0){Db[s&511](j,o,c[k>>2]|0);break}else{Db[s&511](j,o,0);break}}while(0);b:do if(c[k>>2]|0){c[n>>2]=1;while(1){if((c[n>>2]|0)>=(c[l>>2]|0))break b;if(c[(c[k>>2]|0)+(c[n>>2]<<2)>>2]|0)zb[c[135736>>2]&511](c[(c[k>>2]|0)+(c[n>>2]<<2)>>2]|0);c[n>>2]=(c[n>>2]|0)+2}}while(0);c[e>>2]=c[g>>2];r=c[e>>2]|0;i=b;return r|0}function If(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;i=i+48|0;f=e+44|0;g=e+40|0;h=e+36|0;j=e+32|0;k=e+28|0;l=e+24|0;m=e+20|0;n=e+16|0;o=e+12|0;p=e+8|0;q=e+4|0;r=e;c[f>>2]=b;c[g>>2]=0;c[h>>2]=0;c[j>>2]=100;c[q>>2]=0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=60){i=e;return}if((d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=33){i=e;return}if((d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)!=91){i=e;return}if((d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)!=67){i=e;return}if((d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)!=68){i=e;return}if((d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=65){i=e;return}if((d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)!=84){i=e;return}if((d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0|0)!=65){i=e;return}if((d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+8>>0]|0|0)!=91){i=e;return}b=(c[f>>2]|0)+200|0;c[b>>2]=(c[b>>2]|0)+9;b=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[b>>2]=(c[b>>2]|0)+9;b=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[b>>2]=(c[b>>2]|0)+9;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[f>>2]|0);if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[f>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[f>>2]|0)|0;c[(c[f>>2]|0)+172>>2]=8;c[k>>2]=ne(c[f>>2]|0,l)|0;b=c[k>>2]|0;if((c[k>>2]|0)<256){if(!(9<=(b|0)&(c[k>>2]|0)<=10|(c[k>>2]|0)==13|32<=(c[k>>2]|0)))s=20}else if((!(256<=(b|0)&(c[k>>2]|0)<=55295)?!(57344<=(c[k>>2]|0)&(c[k>>2]|0)<=65533):0)?!(65536<=(c[k>>2]|0)&(c[k>>2]|0)<=1114111):0)s=20;if((s|0)==20){og(c[f>>2]|0,63,0);c[(c[f>>2]|0)+172>>2]=7;i=e;return}b=c[(c[f>>2]|0)+36>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){t=b+28|0;c[t>>2]=(c[t>>2]|0)+1;c[(c[(c[f>>2]|0)+36>>2]|0)+32>>2]=1}else{t=b+32|0;c[t>>2]=(c[t>>2]|0)+1}t=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[t>>2]=(c[t>>2]|0)+(c[l>>2]|0);if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[f>>2]|0);c[m>>2]=ne(c[f>>2]|0,n)|0;t=c[m>>2]|0;if((c[m>>2]|0)<256){if(!(9<=(t|0)&(c[m>>2]|0)<=10|(c[m>>2]|0)==13|32<=(c[m>>2]|0)))s=31}else if((!(256<=(t|0)&(c[m>>2]|0)<=55295)?!(57344<=(c[m>>2]|0)&(c[m>>2]|0)<=65533):0)?!(65536<=(c[m>>2]|0)&(c[m>>2]|0)<=1114111):0)s=31;if((s|0)==31){og(c[f>>2]|0,63,0);c[(c[f>>2]|0)+172>>2]=7;i=e;return}t=c[(c[f>>2]|0)+36>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){b=t+28|0;c[b>>2]=(c[b>>2]|0)+1;c[(c[(c[f>>2]|0)+36>>2]|0)+32>>2]=1}else{b=t+32|0;c[b>>2]=(c[b>>2]|0)+1}b=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[b>>2]=(c[b>>2]|0)+(c[n>>2]|0);if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[f>>2]|0);c[o>>2]=ne(c[f>>2]|0,p)|0;c[g>>2]=Cb[c[135752>>2]&511](c[j>>2]|0)|0;if(!(c[g>>2]|0)){ie(c[f>>2]|0,0);i=e;return}while(1){b=c[o>>2]|0;do if((c[o>>2]|0)<256)if(9<=(b|0)&(c[o>>2]|0)<=10|(c[o>>2]|0)==13|32<=(c[o>>2]|0))s=44;else u=0;else{if(256<=(b|0)&(c[o>>2]|0)<=55295){s=44;break}if(57344<=(c[o>>2]|0)&(c[o>>2]|0)<=65533){s=44;break}if(65536<=(c[o>>2]|0)&(c[o>>2]|0)<=1114111)s=44;else u=0}while(0);do if((s|0)==44){s=0;if((c[k>>2]|0)!=93|(c[m>>2]|0)!=93){u=1;break}u=(c[o>>2]|0)!=62}while(0);v=c[h>>2]|0;if(!u){s=70;break}if((v+5|0)>=(c[j>>2]|0)){if((c[j>>2]|0)>1e7?(c[(c[f>>2]|0)+360>>2]&524288|0)==0:0){s=50;break}c[r>>2]=Hb[c[135760>>2]&511](c[g>>2]|0,c[j>>2]<<1)|0;if(!(c[r>>2]|0)){s=52;break}c[g>>2]=c[r>>2];c[j>>2]=c[j>>2]<<1}if((c[l>>2]|0)==1){b=c[k>>2]&255;t=c[h>>2]|0;c[h>>2]=t+1;a[(c[g>>2]|0)+t>>0]=b}else{b=pe((c[g>>2]|0)+(c[h>>2]|0)|0,c[k>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+b}c[k>>2]=c[m>>2];c[l>>2]=c[n>>2];c[m>>2]=c[o>>2];c[n>>2]=c[p>>2];c[q>>2]=(c[q>>2]|0)+1;if((c[q>>2]|0)>50){do if(!(c[(c[f>>2]|0)+292>>2]|0)){if(((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=250)break;vg(c[f>>2]|0)}while(0);if((c[(c[f>>2]|0)+172>>2]|0)==-1){s=62;break}c[q>>2]=0}b=c[(c[f>>2]|0)+36>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){t=b+28|0;c[t>>2]=(c[t>>2]|0)+1;c[(c[(c[f>>2]|0)+36>>2]|0)+32>>2]=1}else{t=b+32|0;c[t>>2]=(c[t>>2]|0)+1}t=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[t>>2]=(c[t>>2]|0)+(c[p>>2]|0);if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[f>>2]|0);c[o>>2]=ne(c[f>>2]|0,p)|0}if((s|0)==50){pg(c[f>>2]|0,63,69400,0);zb[c[135736>>2]&511](c[g>>2]|0);i=e;return}else if((s|0)==52){zb[c[135736>>2]&511](c[g>>2]|0);ie(c[f>>2]|0,0);i=e;return}else if((s|0)==62){zb[c[135736>>2]&511](c[g>>2]|0);i=e;return}else if((s|0)==70){a[(c[g>>2]|0)+v>>0]=0;c[(c[f>>2]|0)+172>>2]=7;v=c[f>>2]|0;if((c[o>>2]|0)!=62){pg(v,63,69432,c[g>>2]|0);zb[c[135736>>2]&511](c[g>>2]|0);i=e;return}o=c[(c[f>>2]|0)+36>>2]|0;if((d[c[(c[v+36>>2]|0)+16>>2]>>0]|0|0)==10){v=o+28|0;c[v>>2]=(c[v>>2]|0)+1;c[(c[(c[f>>2]|0)+36>>2]|0)+32>>2]=1}else{v=o+32|0;c[v>>2]=(c[v>>2]|0)+1}v=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[v>>2]=(c[v>>2]|0)+(c[p>>2]|0);if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[f>>2]|0);do if(c[c[f>>2]>>2]|0){if(c[(c[f>>2]|0)+212>>2]|0)break;p=c[c[f>>2]>>2]|0;if(c[(c[c[f>>2]>>2]|0)+100>>2]|0){Db[c[p+100>>2]&511](c[(c[f>>2]|0)+4>>2]|0,c[g>>2]|0,c[h>>2]|0);break}if(!(c[p+68>>2]|0))break;Db[c[(c[c[f>>2]>>2]|0)+68>>2]&511](c[(c[f>>2]|0)+4>>2]|0,c[g>>2]|0,c[h>>2]|0)}while(0);zb[c[135736>>2]&511](c[g>>2]|0);i=e;return}}function Jf(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[e>>2]=a;if((c[(c[e>>2]|0)+292>>2]|0)==0?((c[(c[(c[e>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[e>>2]|0);while(1){if(!(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0)){j=45;break}if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==47:0){j=45;break}if((c[(c[e>>2]|0)+172>>2]|0)==-1){j=45;break}c[f>>2]=c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2];c[g>>2]=c[(c[(c[e>>2]|0)+36>>2]|0)+36>>2];c[h>>2]=c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2];if((d[c[h>>2]>>0]|0|0)==60?(d[(c[h>>2]|0)+1>>0]|0|0)==63:0)mf(c[e>>2]|0);else j=11;do if((j|0)==11){j=0;if(((((((((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==33:0)?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==91:0)?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==67:0)?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==68:0)?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==65:0)?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)==84:0)?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0|0)==65:0)?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+8>>0]|0|0)==91:0){If(c[e>>2]|0);break}if((((d[c[h>>2]>>0]|0|0)==60?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==33:0)?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==45:0)?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==45:0){
kf(c[e>>2]|0);c[(c[e>>2]|0)+172>>2]=7;break}if((d[c[h>>2]>>0]|0|0)==60){Kf(c[e>>2]|0);break}a=c[e>>2]|0;if((d[c[h>>2]>>0]|0|0)==38){Df(a);break}else{hf(a,0);break}}while(0);if((c[(c[e>>2]|0)+292>>2]|0)==0?((c[(c[(c[e>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[e>>2]|0);while(1){if(!(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0))k=(c[(c[e>>2]|0)+40>>2]|0)>1;else k=0;l=c[e>>2]|0;if(!k)break;Ve(l)|0}if(((c[l+292>>2]|0)==0?((c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[e>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((c[(c[(c[e>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)Fg(c[e>>2]|0);if((c[g>>2]|0)!=(c[(c[(c[e>>2]|0)+36>>2]|0)+36>>2]|0))continue;if((c[f>>2]|0)==(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)){j=44;break}}if((j|0)==44){og(c[e>>2]|0,1,69472);c[(c[e>>2]|0)+172>>2]=-1;i=b;return}else if((j|0)==45){i=b;return}}function Kf(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+64|0;e=b+48|0;f=b+44|0;g=b+40|0;h=b+36|0;j=b+16|0;k=b+12|0;l=b+8|0;m=b+4|0;n=b;c[e>>2]=a;c[g>>2]=0;c[h>>2]=0;c[l>>2]=0;c[n>>2]=c[(c[e>>2]|0)+328>>2];if((c[(c[e>>2]|0)+188>>2]|0)>>>0>(c[16304]|0)>>>0?(c[(c[e>>2]|0)+360>>2]&524288|0)==0:0){ng(c[e>>2]|0,1,65224,c[16304]|0);c[(c[e>>2]|0)+172>>2]=-1;i=b;return}if(c[(c[e>>2]|0)+68>>2]|0){c[j+4>>2]=(c[(c[(c[e>>2]|0)+36>>2]|0)+36>>2]|0)+((c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[e>>2]|0)+36>>2]|0)+12>>2]|0));c[j+8>>2]=c[(c[(c[e>>2]|0)+36>>2]|0)+28>>2]}a=c[e>>2]|0;do if(c[(c[e>>2]|0)+236>>2]|0){o=c[e>>2]|0;if((c[c[a+232>>2]>>2]|0)==-2){Xg(o,-1)|0;break}else{Xg(o,c[c[(c[e>>2]|0)+232>>2]>>2]|0)|0;break}}else Xg(a,-1)|0;while(0);c[k>>2]=c[(c[(c[e>>2]|0)+36>>2]|0)+28>>2];a=c[e>>2]|0;if(c[(c[e>>2]|0)+324>>2]|0)c[f>>2]=Yg(a,g,h,l)|0;else c[f>>2]=Hf(a)|0;if((c[(c[e>>2]|0)+172>>2]|0)==-1){i=b;return}a=c[e>>2]|0;if(!(c[f>>2]|0)){Zg(a)|0;i=b;return}Se(a,c[f>>2]|0)|0;c[m>>2]=c[(c[e>>2]|0)+52>>2];if(((((c[(c[e>>2]|0)+104>>2]|0)!=0?(c[(c[e>>2]|0)+12>>2]|0)!=0:0)?(c[(c[e>>2]|0)+8>>2]|0)!=0:0)?(c[(c[e>>2]|0)+52>>2]|0)!=0:0)?(c[(c[e>>2]|0)+52>>2]|0)==(c[(c[(c[e>>2]|0)+8>>2]|0)+12>>2]|0):0){a=an((c[e>>2]|0)+108|0,c[(c[e>>2]|0)+8>>2]|0)|0;o=(c[e>>2]|0)+100|0;c[o>>2]=c[o>>2]&a}if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==47?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==62:0){a=(c[e>>2]|0)+200|0;c[a>>2]=(c[a>>2]|0)+2;a=(c[(c[e>>2]|0)+36>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+2;a=(c[(c[e>>2]|0)+36>>2]|0)+32|0;c[a>>2]=(c[a>>2]|0)+2;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[e>>2]|0);if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[e>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[e>>2]|0)|0;a=(c[c[e>>2]>>2]|0)!=0;if(c[(c[e>>2]|0)+324>>2]|0){if((a?(c[(c[c[e>>2]>>2]|0)+120>>2]|0)!=0:0)?(c[(c[e>>2]|0)+212>>2]|0)==0:0)Jb[c[(c[c[e>>2]>>2]|0)+120>>2]&511](c[(c[e>>2]|0)+4>>2]|0,c[f>>2]|0,c[g>>2]|0,c[h>>2]|0)}else if((a?(c[(c[c[e>>2]>>2]|0)+60>>2]|0)!=0:0)?(c[(c[e>>2]|0)+212>>2]|0)==0:0)Ab[c[(c[c[e>>2]>>2]|0)+60>>2]&511](c[(c[e>>2]|0)+4>>2]|0,c[f>>2]|0);Te(c[e>>2]|0)|0;Zg(c[e>>2]|0)|0;if((c[n>>2]|0)!=(c[(c[e>>2]|0)+328>>2]|0))_g(c[e>>2]|0,(c[(c[e>>2]|0)+328>>2]|0)-(c[n>>2]|0)|0)|0;if(!(c[m>>2]|0)){i=b;return}if(!(c[(c[e>>2]|0)+68>>2]|0)){i=b;return}c[j+12>>2]=(c[(c[(c[e>>2]|0)+36>>2]|0)+36>>2]|0)+((c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[e>>2]|0)+36>>2]|0)+12>>2]|0));c[j+16>>2]=c[(c[(c[e>>2]|0)+36>>2]|0)+28>>2];c[j>>2]=c[m>>2];De(c[e>>2]|0,j);i=b;return}a=c[e>>2]|0;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=62){$g(a,73,69512,c[f>>2]|0,c[k>>2]|0,0);Re(c[e>>2]|0)|0;Te(c[e>>2]|0)|0;Zg(c[e>>2]|0)|0;if((c[n>>2]|0)!=(c[(c[e>>2]|0)+328>>2]|0))_g(c[e>>2]|0,(c[(c[e>>2]|0)+328>>2]|0)-(c[n>>2]|0)|0)|0;if(!(c[m>>2]|0)){i=b;return}if(!(c[(c[e>>2]|0)+68>>2]|0)){i=b;return}c[j+12>>2]=(c[(c[(c[e>>2]|0)+36>>2]|0)+36>>2]|0)+((c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[e>>2]|0)+36>>2]|0)+12>>2]|0));c[j+16>>2]=c[(c[(c[e>>2]|0)+36>>2]|0)+28>>2];c[j>>2]=c[m>>2];De(c[e>>2]|0,j);i=b;return}o=(c[a+36>>2]|0)+32|0;c[o>>2]=(c[o>>2]|0)+1;o=(c[(c[e>>2]|0)+36>>2]|0)+16|0;c[o>>2]=(c[o>>2]|0)+1;o=(c[e>>2]|0)+200|0;c[o>>2]=(c[o>>2]|0)+1;if(!(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0))ke(c[(c[e>>2]|0)+36>>2]|0,250)|0;Jf(c[e>>2]|0);if((c[(c[e>>2]|0)+172>>2]|0)==-1){i=b;return}if(!(9<=(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0))p=55;if(((p|0)==55?(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13:0)?32>(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0):0){$g(c[e>>2]|0,77,69560,c[f>>2]|0,c[k>>2]|0,0);Re(c[e>>2]|0)|0;Te(c[e>>2]|0)|0;Zg(c[e>>2]|0)|0;if((c[n>>2]|0)==(c[(c[e>>2]|0)+328>>2]|0)){i=b;return}_g(c[e>>2]|0,(c[(c[e>>2]|0)+328>>2]|0)-(c[n>>2]|0)|0)|0;i=b;return}f=c[e>>2]|0;if(c[(c[e>>2]|0)+324>>2]|0){ah(f,c[g>>2]|0,c[h>>2]|0,c[k>>2]|0,(c[(c[e>>2]|0)+328>>2]|0)-(c[n>>2]|0)|0,c[l>>2]|0);Te(c[e>>2]|0)|0}else Wg(f,c[k>>2]|0);if(!(c[m>>2]|0)){i=b;return}if(!(c[(c[e>>2]|0)+68>>2]|0)){i=b;return}c[j+12>>2]=(c[(c[(c[e>>2]|0)+36>>2]|0)+36>>2]|0)+((c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[e>>2]|0)+36>>2]|0)+12>>2]|0));c[j+16>>2]=c[(c[(c[e>>2]|0)+36>>2]|0)+28>>2];c[j>>2]=c[m>>2];De(c[e>>2]|0,j);i=b;return}function Lf(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e+24|0;m=e;c[g>>2]=b;c[h>>2]=0;c[j>>2]=0;c[k>>2]=10;c[h>>2]=Cb[c[135752>>2]&511](c[k>>2]|0)|0;b=c[g>>2]|0;if(!(c[h>>2]|0)){ie(b,0);c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}a[l>>0]=a[c[(c[b+36>>2]|0)+16>>2]>>0]|0;if((d[l>>0]|0|0)>=48?(d[l>>0]|0|0)<=57:0){b=a[l>>0]|0;o=c[j>>2]|0;c[j>>2]=o+1;a[(c[h>>2]|0)+o>>0]=b;me(c[g>>2]|0);a[l>>0]=a[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0;if((d[l>>0]|0|0)!=46){zb[c[135736>>2]&511](c[h>>2]|0);c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}b=a[l>>0]|0;o=c[j>>2]|0;c[j>>2]=o+1;a[(c[h>>2]|0)+o>>0]=b;me(c[g>>2]|0);a[l>>0]=a[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0;while(1){if((d[l>>0]|0|0)>=48)p=(d[l>>0]|0|0)<=57;else p=0;q=c[j>>2]|0;if(!p){r=17;break}if((q+1|0)>=(c[k>>2]|0)){c[k>>2]=c[k>>2]<<1;c[m>>2]=Hb[c[135760>>2]&511](c[h>>2]|0,c[k>>2]|0)|0;if(!(c[m>>2]|0)){r=14;break}c[h>>2]=c[m>>2]}b=a[l>>0]|0;o=c[j>>2]|0;c[j>>2]=o+1;a[(c[h>>2]|0)+o>>0]=b;me(c[g>>2]|0);a[l>>0]=a[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0}if((r|0)==14){zb[c[135736>>2]&511](c[h>>2]|0);ie(c[g>>2]|0,0);c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}else if((r|0)==17){a[(c[h>>2]|0)+q>>0]=0;c[f>>2]=c[h>>2];n=c[f>>2]|0;i=e;return n|0}}zb[c[135736>>2]&511](c[h>>2]|0);c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}function Mf(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e+24|0;m=e;c[g>>2]=b;c[h>>2]=0;c[j>>2]=0;c[k>>2]=10;a[l>>0]=a[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0;if((d[l>>0]|0|0)>=97?(d[l>>0]|0|0)<=122:0)n=5;else n=3;do if((n|0)==3){if((d[l>>0]|0|0)>=65?(d[l>>0]|0|0)<=90:0){n=5;break}og(c[g>>2]|0,79,0)}while(0);do if((n|0)==5){c[h>>2]=Cb[c[135752>>2]&511](c[k>>2]|0)|0;if(!(c[h>>2]|0)){ie(c[g>>2]|0,0);c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}b=a[l>>0]|0;p=c[j>>2]|0;c[j>>2]=p+1;a[(c[h>>2]|0)+p>>0]=b;me(c[g>>2]|0);a[l>>0]=a[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0;while(1){if((d[l>>0]|0|0)>=97?(d[l>>0]|0|0)<=122:0)q=1;else n=10;do if((n|0)==10){n=0;if((d[l>>0]|0|0)>=65?(d[l>>0]|0|0)<=90:0){q=1;break}if((d[l>>0]|0|0)>=48?(d[l>>0]|0|0)<=57:0){q=1;break}if((d[l>>0]|0|0)!=46?(d[l>>0]|0|0)!=95:0)q=(d[l>>0]|0|0)==45;else q=1}while(0);r=c[j>>2]|0;if(!q){n=31;break}if((r+1|0)>=(c[k>>2]|0)){c[k>>2]=c[k>>2]<<1;c[m>>2]=Hb[c[135760>>2]&511](c[h>>2]|0,c[k>>2]|0)|0;if(!(c[m>>2]|0))break;c[h>>2]=c[m>>2]}b=a[l>>0]|0;p=c[j>>2]|0;c[j>>2]=p+1;a[(c[h>>2]|0)+p>>0]=b;me(c[g>>2]|0);a[l>>0]=a[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0;if(d[l>>0]|0)continue;if(((c[(c[g>>2]|0)+292>>2]|0)==0?((c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)Fg(c[g>>2]|0);if((c[(c[g>>2]|0)+292>>2]|0)==0?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[g>>2]|0);a[l>>0]=a[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0}if((n|0)==31){a[(c[h>>2]|0)+r>>0]=0;break}ie(c[g>>2]|0,0);zb[c[135736>>2]&511](c[h>>2]|0);c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}while(0);c[f>>2]=c[h>>2];o=c[f>>2]|0;i=e;return o|0}function Nf(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=b+8|0;f=b+4|0;g=b;c[f>>2]=a;c[g>>2]=-2;Ue(c[f>>2]|0)|0;do if((((((((((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==115?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==116:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==97:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==110:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==100:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==97:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)==108:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0|0)==111:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+8>>0]|0|0)==110:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+9>>0]|0|0)==101:0){a=(c[f>>2]|0)+200|0;c[a>>2]=(c[a>>2]|0)+10;a=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+10;a=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[a>>2]=(c[a>>2]|0)+10;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[f>>2]|0);if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[f>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[f>>2]|0)|0;Ue(c[f>>2]|0)|0;a=c[f>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=61){og(a,75,0);c[e>>2]=c[g>>2];h=c[e>>2]|0;i=b;return h|0}me(a);Ue(c[f>>2]|0)|0;a=c[f>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==39){me(a);do if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==110?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==111:0){c[g>>2]=0;j=(c[f>>2]|0)+200|0;c[j>>2]=(c[j>>2]|0)+2;j=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[j>>2]=(c[j>>2]|0)+2;j=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[j>>2]=(c[j>>2]|0)+2;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[f>>2]|0);if(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0)break;if((ke(c[(c[f>>2]|0)+36>>2]|0,250)|0)>0)break;Ve(c[f>>2]|0)|0}else k=26;while(0);a:do if((k|0)==26){do if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==121){if((d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=101)break;if((d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)!=115)break;c[g>>2]=1;j=(c[f>>2]|0)+200|0;c[j>>2]=(c[j>>2]|0)+3;j=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[j>>2]=(c[j>>2]|0)+3;j=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[j>>2]=(c[j>>2]|0)+3;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[f>>2]|0);if(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0)break a;if((ke(c[(c[f>>2]|0)+36>>2]|0,250)|0)>0)break a;Ve(c[f>>2]|0)|0;break a}while(0);og(c[f>>2]|0,78,0)}while(0);j=c[f>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=39){og(j,34,0);break}else{me(j);break}}j=c[f>>2]|0;if((d[c[(c[a+36>>2]|0)+16>>2]>>0]|0|0)!=34){og(j,33,0);break}me(j);do if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==110?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==111:0){c[g>>2]=0;j=(c[f>>2]|0)+200|0;c[j>>2]=(c[j>>2]|0)+2;j=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[j>>2]=(c[j>>2]|0)+2;j=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[j>>2]=(c[j>>2]|0)+2;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[f>>2]|0);if(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0)break;if((ke(c[(c[f>>2]|0)+36>>2]|0,250)|0)>0)break;Ve(c[f>>2]|0)|0}else k=46;while(0);b:do if((k|0)==46){do if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==121){if((d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=101)break;if((d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)!=115)break;c[g>>2]=1;a=(c[f>>2]|0)+200|0;c[a>>2]=(c[a>>2]|0)+3;a=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+3;a=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[a>>2]=(c[a>>2]|0)+3;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[f>>2]|0);if(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0)break b;if((ke(c[(c[f>>2]|0)+36>>2]|0,250)|0)>0)break b;Ve(c[f>>2]|0)|0;break b}while(0);og(c[f>>2]|0,78,0)}while(0);a=c[f>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=34){og(a,34,0);break}else{me(a);break}}while(0);c[e>>2]=c[g>>2];h=c[e>>2]|0;i=b;return h|0}function Of(a){a=a|0;var b=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;e=b+4|0;f=b;c[e>>2]=a;c[(c[(c[e>>2]|0)+36>>2]|0)+52>>2]=-2;a=(c[e>>2]|0)+200|0;c[a>>2]=(c[a>>2]|0)+5;a=(c[(c[e>>2]|0)+36>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+5;a=(c[(c[e>>2]|0)+36>>2]|0)+32|0;c[a>>2]=(c[a>>2]|0)+5;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[e>>2]|0);if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[e>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[e>>2]|0)|0;do if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13)xg(c[e>>2]|0,65,69720)}while(0);Ue(c[e>>2]|0)|0;c[f>>2]=Af(c[e>>2]|0)|0;if(!(c[f>>2]|0))og(c[e>>2]|0,96,0);else{do if(!(qy(c[f>>2]|0,68488)|0)){if(c[(c[e>>2]|0)+360>>2]&131072){pg(c[e>>2]|0,108,69752,c[f>>2]|0);break}if((d[c[f>>2]>>0]|0|0)==49?(d[(c[f>>2]|0)+1>>0]|0|0)==46:0){rg(c[e>>2]|0,97,69752,c[f>>2]|0,0);break}pg(c[e>>2]|0,108,69752,c[f>>2]|0)}while(0);if(c[(c[e>>2]|0)+20>>2]|0)zb[c[135736>>2]&511](c[(c[e>>2]|0)+20>>2]|0);c[(c[e>>2]|0)+20>>2]=c[f>>2]}do if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13){if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==63?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==62:0){f=(c[e>>2]|0)+200|0;c[f>>2]=(c[f>>2]|0)+2;f=(c[(c[e>>2]|0)+36>>2]|0)+16|0;c[f>>2]=(c[f>>2]|0)+2;f=(c[(c[e>>2]|0)+36>>2]|0)+32|0;c[f>>2]=(c[f>>2]|0)+2;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[e>>2]|0);if(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0){i=b;return}if((ke(c[(c[e>>2]|0)+36>>2]|0,250)|0)>0){i=b;return}Ve(c[e>>2]|0)|0;i=b;return}xg(c[e>>2]|0,65,69784)}}while(0);Bf(c[e>>2]|0)|0;if((c[(c[e>>2]|0)+84>>2]|0)==32){i=b;return}do if((c[(c[(c[e>>2]|0)+36>>2]|0)+44>>2]|0)!=0?(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32:0){if(9<=(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13){if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==63?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==62:0){f=(c[e>>2]|0)+200|0;c[f>>2]=(c[f>>2]|0)+2;f=(c[(c[e>>2]|0)+36>>2]|0)+16|0;c[f>>2]=(c[f>>2]|0)+2;f=(c[(c[e>>2]|0)+36>>2]|0)+32|0;c[f>>2]=(c[f>>2]|0)+2;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[e>>2]|0);if(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0){i=b;return}if((ke(c[(c[e>>2]|0)+36>>2]|0,250)|0)>0){i=b;return}Ve(c[e>>2]|0)|0;i=b;return}xg(c[e>>2]|0,65,69784)}}while(0);if((c[(c[e>>2]|0)+292>>2]|0)==0?((c[(c[(c[e>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[e>>2]|0);Ue(c[e>>2]|0)|0;f=Nf(c[e>>2]|0)|0;c[(c[(c[e>>2]|0)+36>>2]|0)+52>>2]=f;Ue(c[e>>2]|0)|0;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==63?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==62:0){f=(c[e>>2]|0)+200|0;c[f>>2]=(c[f>>2]|0)+2;f=(c[(c[e>>2]|0)+36>>2]|0)+16|0;c[f>>2]=(c[f>>2]|0)+2;f=(c[(c[e>>2]|0)+36>>2]|0)+32|0;c[f>>2]=(c[f>>2]|0)+2;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[e>>2]|0);if(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0){i=b;return}if((ke(c[(c[e>>2]|0)+36>>2]|0,250)|0)>0){i=b;return}Ve(c[e>>2]|0)|0;i=b;return}f=(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==62;og(c[e>>2]|0,57,0);if(f){me(c[e>>2]|0);i=b;return}while(1){if(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0)g=(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=62;else g=0;h=c[e>>2]|0;if(!g)break;f=(c[h+36>>2]|0)+16|0;c[f>>2]=(c[f>>2]|0)+1}me(h);i=b;return}function Pf(a){a=a|0;var b=0,e=0,f=0;b=i;i=i+16|0;e=b;c[e>>2]=a;a:while(1){if((c[(c[e>>2]|0)+172>>2]|0)==-1){f=22;break}if(!((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==63:0))f=5;do if((f|0)==5){f=0;if((((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==33:0)?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==45:0)?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==45:0)break;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13){f=22;break a}}}while(0);if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==63:0){mf(c[e>>2]|0);continue}do if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13){kf(c[e>>2]|0);continue a}}while(0);me(c[e>>2]|0)}if((f|0)==22){i=b;return}}function Qf(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e+12|0;j=e;c[g>>2]=b;Rf();if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+36>>2]|0)!=0:0){if((c[(c[g>>2]|0)+292>>2]|0)==0?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[g>>2]|0);Rg(c[g>>2]|0);if((c[c[g>>2]>>2]|0)!=0?(c[(c[c[g>>2]>>2]|0)+44>>2]|0)!=0:0)Ab[c[(c[c[g>>2]>>2]|0)+44>>2]&511](c[(c[g>>2]|0)+4>>2]|0,136080);if((c[(c[g>>2]|0)+172>>2]|0)==-1){c[f>>2]=-1;k=c[f>>2]|0;i=e;return k|0}if(((c[(c[g>>2]|0)+24>>2]|0)==0?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=4:0)?(a[h>>0]=a[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0,a[h+1>>0]=a[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0,a[h+2>>0]=a[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0,a[h+3>>0]=a[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0,c[j>>2]=sd(h,4)|0,(c[j>>2]|0)!=0):0)re(c[g>>2]|0,c[j>>2]|0)|0;if(!(d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0))og(c[g>>2]|0,4,0);if((((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<35?(c[(c[g>>2]|0)+292>>2]|0)==0:0)?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[g>>2]|0);a:do if(((((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==63:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==120:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==109:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==108:0){do if((d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=32){if(9<=(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)<=10:0)break;if((d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=13){l=34;break a}}while(0);Of(c[g>>2]|0);if((c[(c[g>>2]|0)+84>>2]|0)!=32){c[(c[g>>2]|0)+28>>2]=c[(c[(c[g>>2]|0)+36>>2]|0)+52>>2];Ue(c[g>>2]|0)|0;break}c[f>>2]=-1;k=c[f>>2]|0;i=e;return k|0}else l=34;while(0);if((l|0)==34){l=oy(68488)|0;c[(c[g>>2]|0)+20>>2]=l}if(((c[c[g>>2]>>2]|0)!=0?(c[(c[c[g>>2]>>2]|0)+48>>2]|0)!=0:0)?(c[(c[g>>2]|0)+212>>2]|0)==0:0)zb[c[(c[c[g>>2]>>2]|0)+48>>2]&511](c[(c[g>>2]|0)+4>>2]|0);if((c[(c[g>>2]|0)+172>>2]|0)==-1){c[f>>2]=-1;k=c[f>>2]|0;i=e;return k|0}if((((c[(c[g>>2]|0)+8>>2]|0)!=0?(c[(c[g>>2]|0)+36>>2]|0)!=0:0)?(c[c[(c[g>>2]|0)+36>>2]>>2]|0)!=0:0)?(c[(c[c[(c[g>>2]|0)+36>>2]>>2]|0)+24>>2]|0)>=0:0)c[(c[(c[g>>2]|0)+8>>2]|0)+36>>2]=c[(c[c[(c[g>>2]|0)+36>>2]>>2]|0)+24>>2];if((c[(c[g>>2]|0)+292>>2]|0)==0?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[g>>2]|0);Pf(c[g>>2]|0);if((c[(c[g>>2]|0)+292>>2]|0)==0?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[g>>2]|0);do if((((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==33:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==68:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==79:0){if((d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)!=67)break;if((d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=84)break;if((d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)!=89)break;if((d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0|0)!=80)break;if((d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+8>>0]|0|0)!=69)break;c[(c[g>>2]|0)+216>>2]=1;Ff(c[g>>2]|0);do if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==91){c[(c[g>>2]|0)+172>>2]=3;bh(c[g>>2]|0);if((c[(c[g>>2]|0)+172>>2]|0)!=-1)break;c[f>>2]=-1;k=c[f>>2]|0;i=e;return k|0}while(0);c[(c[g>>2]|0)+216>>2]=2;do if(c[c[g>>2]>>2]|0){if(!(c[(c[c[g>>2]>>2]|0)+104>>2]|0))break;if(c[(c[g>>2]|0)+212>>2]|0)break;Jb[c[(c[c[g>>2]>>2]|0)+104>>2]&511](c[(c[g>>2]|0)+4>>2]|0,c[(c[g>>2]|0)+220>>2]|0,c[(c[g>>2]|0)+228>>2]|0,c[(c[g>>2]|0)+224>>2]|0)}while(0);if((c[(c[g>>2]|0)+172>>2]|0)!=-1){c[(c[g>>2]|0)+216>>2]=0;ch(c[g>>2]|0);c[(c[g>>2]|0)+172>>2]=4;Pf(c[g>>2]|0);break}c[f>>2]=-1;k=c[f>>2]|0;i=e;return k|0}while(0);if((c[(c[g>>2]|0)+292>>2]|0)==0?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[g>>2]|0);l=c[g>>2]|0;if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=60)xg(l,4,69808);else{c[l+172>>2]=7;Kf(c[g>>2]|0);c[(c[g>>2]|0)+172>>2]=14;Pf(c[g>>2]|0);if(d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0)og(c[g>>2]|0,5,0);c[(c[g>>2]|0)+172>>2]=-1}do if(c[c[g>>2]>>2]|0){if(!(c[(c[c[g>>2]>>2]|0)+52>>2]|0))break;zb[c[(c[c[g>>2]>>2]|0)+52>>2]&511](c[(c[g>>2]|0)+4>>2]|0)}while(0);do if(c[(c[g>>2]|0)+8>>2]|0){if(!(qy(c[(c[(c[g>>2]|0)+8>>2]|0)+56>>2]|0,67096)|0))break;Th(c[(c[g>>2]|0)+8>>2]|0);c[(c[g>>2]|0)+8>>2]=0}while(0);do if(c[(c[g>>2]|0)+12>>2]|0){if(!(c[(c[g>>2]|0)+8>>2]|0))break;l=(c[(c[g>>2]|0)+8>>2]|0)+92|0;c[l>>2]=c[l>>2]|1;if(c[(c[g>>2]|0)+100>>2]|0){l=(c[(c[g>>2]|0)+8>>2]|0)+92|0;c[l>>2]=c[l>>2]|8}if(c[(c[g>>2]|0)+356>>2]|0){l=(c[(c[g>>2]|0)+8>>2]|0)+92|0;c[l>>2]=c[l>>2]|2}if(!(c[(c[g>>2]|0)+360>>2]&131072))break;l=(c[(c[g>>2]|0)+8>>2]|0)+92|0;c[l>>2]=c[l>>2]|4}while(0);if(c[(c[g>>2]|0)+12>>2]|0){c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}else{c[(c[g>>2]|0)+100>>2]=0;c[f>>2]=-1;k=c[f>>2]|0;i=e;return k|0}}c[f>>2]=-1;k=c[f>>2]|0;i=e;return k|0}function Rf(){var a=0;a=i;if(c[17532]|0){i=a;return}zx();lx();if((c[33976]|0)==35|(c[33976]|0)==0)Ud(0);ll()|0;tP()|0;Ad();pQ();tk();uk();ao();rQ();Kq();Aw();c[17532]=1;i=a;return}function Sf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;g=i;i=i+96|0;h=g;j=g+80|0;k=g+76|0;l=g+72|0;m=g+68|0;n=g+64|0;o=g+60|0;p=g+56|0;q=g+52|0;r=g+48|0;s=g+44|0;t=g+40|0;u=g+36|0;v=g+32|0;w=g+28|0;x=g+24|0;y=g+20|0;z=g+16|0;A=g+12|0;B=g+8|0;C=g+4|0;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=0;c[p>>2]=0;c[q>>2]=0;c[r>>2]=0;if(!(c[k>>2]|0)){c[j>>2]=1;D=c[j>>2]|0;i=g;return D|0}if((c[(c[k>>2]|0)+84>>2]|0)!=0?(c[(c[k>>2]|0)+212>>2]|0)==1:0){c[j>>2]=c[(c[k>>2]|0)+84>>2];D=c[j>>2]|0;i=g;return D|0}if((c[(c[k>>2]|0)+172>>2]|0)==-1){c[j>>2]=-1;D=c[j>>2]|0;i=g;return D|0}if(!(c[(c[k>>2]|0)+172>>2]|0))Rg(c[k>>2]|0);if(!((c[m>>2]|0)>0&(c[l>>2]|0)!=0^1|(c[n>>2]|0)!=0)?(a[(c[l>>2]|0)+((c[m>>2]|0)-1)>>0]|0)==13:0){c[o>>2]=1;c[m>>2]=(c[m>>2]|0)+-1}while(1){if((((c[m>>2]|0)>0&(c[l>>2]|0)!=0?(c[(c[k>>2]|0)+36>>2]|0)!=0:0)?(c[c[(c[k>>2]|0)+36>>2]>>2]|0)!=0:0)?(c[(c[k>>2]|0)+172>>2]|0)!=-1:0){c[s>>2]=jz(c[(c[c[(c[k>>2]|0)+36>>2]>>2]|0)+16>>2]|0,c[(c[k>>2]|0)+36>>2]|0)|0;c[t>>2]=(c[(c[(c[k>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[k>>2]|0)+36>>2]|0)+12>>2]|0);c[q>>2]=_y(c[(c[c[(c[k>>2]|0)+36>>2]>>2]|0)+16>>2]|0)|0;do if((((c[(c[k>>2]|0)+172>>2]|0)==0?(c[(c[k>>2]|0)+36>>2]|0)!=0:0)?(c[c[(c[k>>2]|0)+36>>2]>>2]|0)!=0:0)?(c[(c[c[(c[k>>2]|0)+36>>2]>>2]|0)+12>>2]|0)!=0:0){c[v>>2]=45;do if((yy(c[c[(c[c[(c[k>>2]|0)+36>>2]>>2]|0)+12>>2]>>2]|0,69608)|0)==0?(yy(c[c[(c[c[(c[k>>2]|0)+36>>2]>>2]|0)+12>>2]>>2]|0,69616)|0)==0:0){if((yy(c[c[(c[c[(c[k>>2]|0)+36>>2]>>2]|0)+12>>2]>>2]|0,69848)|0)==0?(yy(c[c[(c[c[(c[k>>2]|0)+36>>2]>>2]|0)+12>>2]>>2]|0,69856)|0)==0:0)break;c[v>>2]=180}else E=23;while(0);if((E|0)==23){E=0;c[v>>2]=90}if((c[(c[c[(c[k>>2]|0)+36>>2]>>2]|0)+32>>2]|0)>>>0<(c[v>>2]|0)>>>0)c[v>>2]=(c[v>>2]|0)-(c[(c[c[(c[k>>2]|0)+36>>2]>>2]|0)+32>>2]|0);if((c[m>>2]|0)>>>0>(c[v>>2]|0)>>>0){c[p>>2]=(c[m>>2]|0)-(c[v>>2]|0);c[m>>2]=c[v>>2];break}else{c[p>>2]=0;break}}while(0);c[u>>2]=Lk(c[c[(c[k>>2]|0)+36>>2]>>2]|0,c[m>>2]|0,c[l>>2]|0)|0;F=c[k>>2]|0;if((c[u>>2]|0)<0){E=33;break}kz(c[(c[c[F+36>>2]>>2]|0)+16>>2]|0,c[(c[k>>2]|0)+36>>2]|0,c[s>>2]|0,c[t>>2]|0)|0}else E=35;if(((((((E|0)==35?(E=0,(c[(c[k>>2]|0)+172>>2]|0)!=-1):0)?(c[(c[k>>2]|0)+36>>2]|0)!=0:0)?(c[c[(c[k>>2]|0)+36>>2]>>2]|0)!=0:0)?(c[w>>2]=c[c[(c[k>>2]|0)+36>>2]>>2],(c[(c[w>>2]|0)+12>>2]|0)!=0):0)?(c[(c[w>>2]|0)+16>>2]|0)!=0:0)?(c[(c[w>>2]|0)+20>>2]|0)!=0:0){c[y>>2]=jz(c[(c[w>>2]|0)+16>>2]|0,c[(c[k>>2]|0)+36>>2]|0)|0;c[z>>2]=(c[(c[(c[k>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[k>>2]|0)+36>>2]|0)+12>>2]|0);c[x>>2]=Fd(c[w>>2]|0,c[n>>2]|0)|0;if((c[x>>2]|0)<0){E=42;break}kz(c[(c[w>>2]|0)+16>>2]|0,c[(c[k>>2]|0)+36>>2]|0,c[y>>2]|0,c[z>>2]|0)|0}f=c[k>>2]|0;do if(c[p>>2]|0)dh(f,0)|0;else{if((c[f+36>>2]|0)!=0?(c[c[(c[k>>2]|0)+36>>2]>>2]|0)!=0:0)c[r>>2]=_y(c[(c[c[(c[k>>2]|0)+36>>2]>>2]|0)+16>>2]|0)|0;if(!((c[n>>2]|0)!=0|(c[r>>2]|0)>>>0>1e7|(c[q>>2]|0)==0|(c[r>>2]|0)==0)?(eh(c[k>>2]|0,(c[(c[(c[k>>2]|0)+36>>2]|0)+12>>2]|0)+(c[q>>2]|0)|0,(c[r>>2]|0)-(c[q>>2]|0)|0)|0)==0:0)break;dh(c[k>>2]|0,c[n>>2]|0)|0}while(0);G=c[k>>2]|0;if((c[(c[k>>2]|0)+172>>2]|0)==-1){E=53;break}do if(c[G+36>>2]|0){if(((c[(c[(c[k>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[k>>2]|0)+36>>2]|0)+16>>2]|0)|0)<=1e7?((c[(c[(c[k>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[k>>2]|0)+36>>2]|0)+12>>2]|0)|0)<=1e7:0)break;if(!(c[(c[k>>2]|0)+360>>2]&524288)){og(c[k>>2]|0,1,69896);c[(c[k>>2]|0)+172>>2]=-1}}while(0);if((c[(c[k>>2]|0)+84>>2]|0)!=0?(c[(c[k>>2]|0)+212>>2]|0)==1:0){E=61;break}if(!(c[p>>2]|0)){E=64;break}c[l>>2]=(c[l>>2]|0)+(c[m>>2]|0);c[m>>2]=c[p>>2];c[p>>2]=0}if((E|0)==33){c[F+84>>2]=-1;c[(c[k>>2]|0)+212>>2]=1;c[j>>2]=-1;D=c[j>>2]|0;i=g;return D|0}else if((E|0)==42){Db[c[135904>>2]&511](c[33980]|0,69864,h);c[j>>2]=81;D=c[j>>2]|0;i=g;return D|0}else if((E|0)==53){c[j>>2]=c[G+84>>2];D=c[j>>2]|0;i=g;return D|0}else if((E|0)==61){c[j>>2]=c[(c[k>>2]|0)+84>>2];D=c[j>>2]|0;i=g;return D|0}else if((E|0)==64){if(((c[o>>2]|0)==1?(c[(c[k>>2]|0)+36>>2]|0)!=0:0)?(c[c[(c[k>>2]|0)+36>>2]>>2]|0)!=0:0){c[A>>2]=jz(c[(c[c[(c[k>>2]|0)+36>>2]>>2]|0)+16>>2]|0,c[(c[k>>2]|0)+36>>2]|0)|0;c[B>>2]=(c[(c[(c[k>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[k>>2]|0)+36>>2]|0)+12>>2]|0);Lk(c[c[(c[k>>2]|0)+36>>2]>>2]|0,1,69920)|0;kz(c[(c[c[(c[k>>2]|0)+36>>2]>>2]|0)+16>>2]|0,c[(c[k>>2]|0)+36>>2]|0,c[A>>2]|0,c[B>>2]|0)|0}if(c[n>>2]|0){c[C>>2]=0;do if(c[(c[k>>2]|0)+36>>2]|0){n=c[(c[k>>2]|0)+36>>2]|0;if(!(c[c[(c[k>>2]|0)+36>>2]>>2]|0)){c[C>>2]=(c[n+24>>2]|0)-((c[(c[(c[k>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[k>>2]|0)+36>>2]|0)+12>>2]|0));break}else{B=_y(c[(c[n>>2]|0)+16>>2]|0)|0;c[C>>2]=B-((c[(c[(c[k>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[k>>2]|0)+36>>2]|0)+12>>2]|0));break}}while(0);if((c[(c[k>>2]|0)+172>>2]|0)!=-1?(c[(c[k>>2]|0)+172>>2]|0)!=14:0)og(c[k>>2]|0,5,0);if((c[C>>2]|0)>0?(c[(c[k>>2]|0)+172>>2]|0)==14:0)og(c[k>>2]|0,5,0);if(((c[(c[k>>2]|0)+172>>2]|0)!=-1?(c[c[k>>2]>>2]|0)!=0:0)?(c[(c[c[k>>2]>>2]|0)+52>>2]|0)!=0:0)zb[c[(c[c[k>>2]>>2]|0)+52>>2]&511](c[(c[k>>2]|0)+4>>2]|0);c[(c[k>>2]|0)+172>>2]=-1}if(!(c[(c[k>>2]|0)+12>>2]|0)){c[j>>2]=c[(c[k>>2]|0)+84>>2];D=c[j>>2]|0;i=g;return D|0}else{c[j>>2]=0;D=c[j>>2]|0;i=g;return D|0}}return 0}function Tf(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+48|0;h=g+44|0;j=g+40|0;k=g+36|0;l=g+32|0;m=g+28|0;n=g+24|0;o=g+20|0;p=g+16|0;q=g+12|0;r=g+8|0;s=g+4|0;t=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[r>>2]=0;if((c[l>>2]|0)!=0&(c[m>>2]|0)>=4)c[r>>2]=sd(c[l>>2]|0,c[m>>2]|0)|0;c[q>>2]=vk(c[r>>2]|0)|0;if(!(c[q>>2]|0)){c[h>>2]=0;u=c[h>>2]|0;i=g;return u|0}c[o>>2]=Be()|0;if(!(c[o>>2]|0)){ie(0,69928);yk(c[q>>2]|0);c[h>>2]=0;u=c[h>>2]|0;i=g;return u|0}c[(c[o>>2]|0)+364>>2]=1;f=Cb[c[135744>>2]&511]((c[(c[o>>2]|0)+192>>2]|0)*3<<2)|0;c[(c[o>>2]|0)+344>>2]=f;if(!(c[(c[o>>2]|0)+344>>2]|0)){ie(c[o>>2]|0,0);yk(c[q>>2]|0);Ae(c[o>>2]|0);c[h>>2]=0;u=c[h>>2]|0;i=g;return u|0}if(c[j>>2]|0){if((c[c[o>>2]>>2]|0)!=135968)zb[c[135736>>2]&511](c[c[o>>2]>>2]|0);f=Cb[c[135744>>2]&511](128)|0;c[c[o>>2]>>2]=f;f=c[o>>2]|0;if(!(c[c[o>>2]>>2]|0)){ie(f,0);yk(c[q>>2]|0);Ae(c[o>>2]|0);c[h>>2]=0;u=c[h>>2]|0;i=g;return u|0}e=(c[f>>2]|0)+0|0;f=e+128|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));d=c[c[o>>2]>>2]|0;b=c[j>>2]|0;if((c[(c[j>>2]|0)+108>>2]|0)==-554844497){e=d+0|0;v=b+0|0;f=e+128|0;do{c[e>>2]=c[v>>2];e=e+4|0;v=v+4|0}while((e|0)<(f|0))}else{e=d+0|0;v=b+0|0;f=e+112|0;do{c[e>>2]=c[v>>2];e=e+4|0;v=v+4|0}while((e|0)<(f|0))}if(c[k>>2]|0)c[(c[o>>2]|0)+4>>2]=c[k>>2]}if(!(c[n>>2]|0))c[(c[o>>2]|0)+180>>2]=0;else{k=Rk(c[n>>2]|0)|0;c[(c[o>>2]|0)+180>>2]=k}c[p>>2]=ue(c[o>>2]|0)|0;if(!(c[p>>2]|0)){Ae(c[o>>2]|0);yk(c[q>>2]|0);c[h>>2]=0;u=c[h>>2]|0;i=g;return u|0}if(c[n>>2]|0){k=Jl(c[n>>2]|0)|0;c[(c[p>>2]|0)+4>>2]=k;if(!(c[(c[p>>2]|0)+4>>2]|0)){Ae(c[o>>2]|0);yk(c[q>>2]|0);c[h>>2]=0;u=c[h>>2]|0;i=g;return u|0}}else c[(c[p>>2]|0)+4>>2]=0;c[c[p>>2]>>2]=c[q>>2];iz(c[(c[c[p>>2]>>2]|0)+16>>2]|0,c[p>>2]|0)|0;Oe(c[o>>2]|0,c[p>>2]|0)|0;p=c[o>>2]|0;if(!((c[m>>2]|0)==0|(c[l>>2]|0)==0)){if((c[p+36>>2]|0)!=0?(c[c[(c[o>>2]|0)+36>>2]>>2]|0)!=0:0){c[s>>2]=jz(c[(c[c[(c[o>>2]|0)+36>>2]>>2]|0)+16>>2]|0,c[(c[o>>2]|0)+36>>2]|0)|0;c[t>>2]=(c[(c[(c[o>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[o>>2]|0)+36>>2]|0)+12>>2]|0);Lk(c[c[(c[o>>2]|0)+36>>2]>>2]|0,c[m>>2]|0,c[l>>2]|0)|0;kz(c[(c[c[(c[o>>2]|0)+36>>2]>>2]|0)+16>>2]|0,c[(c[o>>2]|0)+36>>2]|0,c[s>>2]|0,c[t>>2]|0)|0}}else c[p+256>>2]=0;if(c[r>>2]|0)re(c[o>>2]|0,c[r>>2]|0)|0;c[h>>2]=c[o>>2];u=c[h>>2]|0;i=g;return u|0}function Uf(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}c[(c[d>>2]|0)+172>>2]=-1;c[(c[d>>2]|0)+84>>2]=111;c[(c[d>>2]|0)+212>>2]=1;if(!(c[(c[d>>2]|0)+36>>2]|0)){i=b;return}c[(c[(c[d>>2]|0)+36>>2]|0)+16>>2]=65640;c[(c[(c[d>>2]|0)+36>>2]|0)+12>>2]=c[(c[(c[d>>2]|0)+36>>2]|0)+16>>2];i=b;return}function Vf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+48|0;f=e+36|0;g=e+32|0;h=e+28|0;j=e+24|0;k=e+20|0;l=e+16|0;m=e+12|0;n=e+8|0;o=e+4|0;p=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=0;c[m>>2]=0;if((c[h>>2]|0)==0&(c[j>>2]|0)==0){c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}c[l>>2]=Be()|0;if(!(c[l>>2]|0)){c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}d=(c[l>>2]|0)+360|0;c[d>>2]=c[d>>2]|4;if(c[g>>2]|0){if(c[c[l>>2]>>2]|0)zb[c[135736>>2]&511](c[c[l>>2]>>2]|0);c[c[l>>2]>>2]=c[g>>2];c[(c[l>>2]|0)+4>>2]=c[l>>2]}c[o>>2]=Jl(c[j>>2]|0)|0;d=c[l>>2]|0;if((c[j>>2]|0)!=0&(c[o>>2]|0)==0){Ae(d);c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}if((c[d>>2]|0)!=0?(c[(c[c[l>>2]>>2]|0)+16>>2]|0)!=0:0)c[m>>2]=vb[c[(c[c[l>>2]>>2]|0)+16>>2]&511](c[(c[l>>2]|0)+4>>2]|0,c[h>>2]|0,c[o>>2]|0)|0;if(!(c[m>>2]|0)){if(c[g>>2]|0)c[c[l>>2]>>2]=0;Ae(c[l>>2]|0);if(c[o>>2]|0)zb[c[135736>>2]&511](c[o>>2]|0);c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}if((Xe(c[l>>2]|0,c[m>>2]|0)|0)<0){if(c[g>>2]|0)c[c[l>>2]>>2]=0;Ae(c[l>>2]|0);if(c[o>>2]|0)zb[c[135736>>2]&511](c[o>>2]|0);c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}if(((c[(c[(c[l>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[l>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=4){c[n>>2]=sd(c[(c[(c[l>>2]|0)+36>>2]|0)+16>>2]|0,4)|0;re(c[l>>2]|0,c[n>>2]|0)|0}if(!(c[(c[m>>2]|0)+4>>2]|0))c[(c[m>>2]|0)+4>>2]=c[o>>2];else zb[c[135736>>2]&511](c[o>>2]|0);c[(c[m>>2]|0)+28>>2]=1;c[(c[m>>2]|0)+32>>2]=1;c[(c[m>>2]|0)+12>>2]=c[(c[(c[l>>2]|0)+36>>2]|0)+16>>2];c[(c[m>>2]|0)+16>>2]=c[(c[(c[l>>2]|0)+36>>2]|0)+16>>2];c[(c[m>>2]|0)+40>>2]=0;c[(c[l>>2]|0)+216>>2]=2;m=Sh(68488)|0;c[(c[l>>2]|0)+8>>2]=m;m=c[l>>2]|0;if(!(c[(c[l>>2]|0)+8>>2]|0)){ie(m,67128);if(c[g>>2]|0)c[c[l>>2]>>2]=0;Ae(c[l>>2]|0);c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}c[(c[m+8>>2]|0)+92>>2]=64;m=Mh(c[(c[l>>2]|0)+8>>2]|0,69960,c[h>>2]|0,c[j>>2]|0)|0;c[(c[(c[l>>2]|0)+8>>2]|0)+48>>2]=m;Cf(c[l>>2]|0,c[h>>2]|0,c[j>>2]|0);if(c[(c[l>>2]|0)+8>>2]|0){a:do if(c[(c[l>>2]|0)+12>>2]|0){c[k>>2]=c[(c[(c[l>>2]|0)+8>>2]|0)+48>>2];c[(c[(c[l>>2]|0)+8>>2]|0)+48>>2]=0;if(c[k>>2]|0){c[(c[k>>2]|0)+32>>2]=0;c[p>>2]=c[(c[k>>2]|0)+12>>2];while(1){if(!(c[p>>2]|0))break a;c[(c[p>>2]|0)+32>>2]=0;c[p>>2]=c[(c[p>>2]|0)+24>>2];
}}}else c[k>>2]=0;while(0);Th(c[(c[l>>2]|0)+8>>2]|0);c[(c[l>>2]|0)+8>>2]=0}if(c[g>>2]|0)c[c[l>>2]>>2]=0;Ae(c[l>>2]|0);c[f>>2]=c[k>>2];q=c[f>>2]|0;i=e;return q|0}function Wf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=Vf(0,c[e>>2]|0,c[f>>2]|0)|0;i=d;return b|0}function Xf(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+64|0;j=h+44|0;k=h+40|0;l=h+36|0;m=h+32|0;n=h+28|0;o=h+24|0;p=h+20|0;q=h+16|0;r=h+12|0;s=h+8|0;t=h+48|0;u=h+4|0;v=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;c[r>>2]=0;c[s>>2]=0;if(!(c[k>>2]|0)){c[j>>2]=-1;w=c[j>>2]|0;i=h;return w|0}if(!((c[(c[k>>2]|0)+248>>2]|0)>40?(c[(c[k>>2]|0)+360>>2]&524288|0)==0:0))x=5;if((x|0)==5?(c[(c[k>>2]|0)+248>>2]|0)<=1024:0){if(c[n>>2]|0)c[c[n>>2]>>2]=0;if((c[l>>2]|0)==0&(c[m>>2]|0)==0){c[j>>2]=-1;w=c[j>>2]|0;i=h;return w|0}if(!(c[(c[k>>2]|0)+8>>2]|0)){c[j>>2]=-1;w=c[j>>2]|0;i=h;return w|0}c[o>>2]=fh(c[l>>2]|0,c[m>>2]|0,0,c[k>>2]|0)|0;if(!(c[o>>2]|0)){c[j>>2]=-1;w=c[j>>2]|0;i=h;return w|0}c[r>>2]=c[c[o>>2]>>2];c[c[o>>2]>>2]=c[c[k>>2]>>2];Rg(c[o>>2]|0);c[p>>2]=Sh(68488)|0;if(!(c[p>>2]|0)){Ae(c[o>>2]|0);c[j>>2]=-1;w=c[j>>2]|0;i=h;return w|0}c[(c[p>>2]|0)+92>>2]=64;if(c[(c[(c[k>>2]|0)+8>>2]|0)+80>>2]|0){c[(c[p>>2]|0)+80>>2]=c[(c[(c[k>>2]|0)+8>>2]|0)+80>>2];yP(c[(c[p>>2]|0)+80>>2]|0)|0}if(c[(c[k>>2]|0)+8>>2]|0){c[(c[p>>2]|0)+44>>2]=c[(c[(c[k>>2]|0)+8>>2]|0)+44>>2];c[(c[p>>2]|0)+48>>2]=c[(c[(c[k>>2]|0)+8>>2]|0)+48>>2]}if(c[(c[(c[k>>2]|0)+8>>2]|0)+72>>2]|0){m=my(c[(c[(c[k>>2]|0)+8>>2]|0)+72>>2]|0)|0;c[(c[p>>2]|0)+72>>2]=m}c[q>>2]=ji(c[p>>2]|0,0,69968,0)|0;if(!(c[q>>2]|0)){c[c[o>>2]>>2]=c[r>>2];Ae(c[o>>2]|0);c[(c[p>>2]|0)+44>>2]=0;c[(c[p>>2]|0)+48>>2]=0;Th(c[p>>2]|0);c[j>>2]=-1;w=c[j>>2]|0;i=h;return w|0}zi(c[p>>2]|0,c[q>>2]|0)|0;Qe(c[o>>2]|0,c[(c[p>>2]|0)+12>>2]|0)|0;if(!(c[(c[k>>2]|0)+8>>2]|0))c[(c[o>>2]|0)+8>>2]=c[p>>2];else{c[(c[o>>2]|0)+8>>2]=c[(c[k>>2]|0)+8>>2];c[(c[(c[p>>2]|0)+12>>2]|0)+32>>2]=c[(c[k>>2]|0)+8>>2]}if((c[(c[o>>2]|0)+292>>2]|0)==0?((c[(c[(c[o>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[o>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[o>>2]|0);if(((c[(c[(c[o>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[o>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=4?(a[t>>0]=a[c[(c[(c[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0,a[t+1>>0]=a[(c[(c[(c[o>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0,a[t+2>>0]=a[(c[(c[(c[o>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0,a[t+3>>0]=a[(c[(c[(c[o>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0,c[u>>2]=sd(t,4)|0,(c[u>>2]|0)!=0):0)re(c[o>>2]|0,c[u>>2]|0)|0;a:do if(((d[c[(c[(c[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(d[(c[(c[(c[o>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==63:0)?(d[(c[(c[(c[o>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==120:0){if((d[(c[(c[(c[o>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)!=109)break;if((d[(c[(c[(c[o>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)!=108)break;do if((d[(c[(c[(c[o>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=32){if(9<=(d[(c[(c[(c[o>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)?(d[(c[(c[(c[o>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)<=10:0)break;if((d[(c[(c[(c[o>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=13)break a}while(0);_e(c[o>>2]|0);if(!(qy(c[(c[k>>2]|0)+20>>2]|0,68488)|0))break;if(qy(c[(c[(c[o>>2]|0)+36>>2]|0)+48>>2]|0,68488)|0)break;xg(c[o>>2]|0,109,69984)}while(0);if((c[(c[k>>2]|0)+4>>2]|0)==(c[k>>2]|0))c[(c[o>>2]|0)+4>>2]=c[o>>2];else c[(c[o>>2]|0)+4>>2]=c[(c[k>>2]|0)+4>>2];c[(c[o>>2]|0)+172>>2]=7;c[(c[o>>2]|0)+104>>2]=c[(c[k>>2]|0)+104>>2];c[(c[o>>2]|0)+100>>2]=c[(c[k>>2]|0)+100>>2];c[(c[o>>2]|0)+276>>2]=c[(c[k>>2]|0)+276>>2];c[(c[o>>2]|0)+248>>2]=(c[(c[k>>2]|0)+248>>2]|0)+1;c[(c[o>>2]|0)+16>>2]=c[(c[k>>2]|0)+16>>2];if(c[(c[o>>2]|0)+104>>2]|0){c[(c[o>>2]|0)+112>>2]=c[(c[k>>2]|0)+112>>2];c[(c[o>>2]|0)+116>>2]=c[(c[k>>2]|0)+116>>2]}else{c[(c[o>>2]|0)+112>>2]=0;c[(c[o>>2]|0)+116>>2]=0}c[(c[o>>2]|0)+132>>2]=0;c[(c[o>>2]|0)+124>>2]=0;c[(c[o>>2]|0)+128>>2]=0;c[(c[o>>2]|0)+120>>2]=0;if(c[(c[o>>2]|0)+296>>2]|0)zP(c[(c[o>>2]|0)+296>>2]|0);c[(c[o>>2]|0)+296>>2]=c[(c[k>>2]|0)+296>>2];u=AP(c[(c[o>>2]|0)+296>>2]|0,70032,3)|0;c[(c[o>>2]|0)+312>>2]=u;u=AP(c[(c[o>>2]|0)+296>>2]|0,70040,5)|0;c[(c[o>>2]|0)+316>>2]=u;u=AP(c[(c[o>>2]|0)+296>>2]|0,70048,36)|0;c[(c[o>>2]|0)+320>>2]=u;c[(c[o>>2]|0)+364>>2]=c[(c[k>>2]|0)+364>>2];c[(c[o>>2]|0)+348>>2]=c[(c[k>>2]|0)+348>>2];c[(c[o>>2]|0)+352>>2]=c[(c[k>>2]|0)+352>>2];c[(c[o>>2]|0)+280>>2]=c[(c[k>>2]|0)+280>>2];Jf(c[o>>2]|0);c[(c[k>>2]|0)+104>>2]=c[(c[o>>2]|0)+104>>2];c[(c[k>>2]|0)+100>>2]=c[(c[o>>2]|0)+100>>2];do if((d[c[(c[(c[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60){if((d[(c[(c[(c[o>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=47){x=57;break}og(c[o>>2]|0,85,0)}else x=57;while(0);do if((x|0)==57){if(!(d[c[(c[(c[o>>2]|0)+36>>2]|0)+16>>2]>>0]|0))break;og(c[o>>2]|0,86,0)}while(0);if((c[(c[o>>2]|0)+52>>2]|0)!=(c[(c[p>>2]|0)+12>>2]|0))og(c[o>>2]|0,85,0);do if(!(c[(c[o>>2]|0)+12>>2]|0))if(!(c[(c[o>>2]|0)+84>>2]|0)){c[s>>2]=1;break}else{c[s>>2]=c[(c[o>>2]|0)+84>>2];break}else{if(c[n>>2]|0){c[v>>2]=c[(c[(c[p>>2]|0)+12>>2]|0)+12>>2];c[c[n>>2]>>2]=c[v>>2];while(1){if(!(c[v>>2]|0))break;c[(c[v>>2]|0)+20>>2]=0;c[v>>2]=c[(c[v>>2]|0)+24>>2]}c[(c[(c[p>>2]|0)+12>>2]|0)+12>>2]=0}c[s>>2]=0}while(0);c[c[o>>2]>>2]=c[r>>2];c[(c[o>>2]|0)+296>>2]=0;c[(c[o>>2]|0)+348>>2]=0;c[(c[o>>2]|0)+352>>2]=0;Ae(c[o>>2]|0);c[(c[p>>2]|0)+44>>2]=0;c[(c[p>>2]|0)+48>>2]=0;Th(c[p>>2]|0);c[j>>2]=c[s>>2];w=c[j>>2]|0;i=h;return w|0}c[j>>2]=89;w=c[j>>2]|0;i=h;return w|0}function Yf(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;i=i+64|0;j=h+60|0;k=h+56|0;l=h+52|0;m=h+48|0;n=h+44|0;o=h+40|0;p=h+36|0;q=h+32|0;r=h+28|0;s=h+24|0;t=h+20|0;u=h+16|0;v=h+12|0;w=h+8|0;x=h+4|0;y=h;c[k>>2]=a;c[l>>2]=b;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[q>>2]=0;c[t>>2]=0;c[u>>2]=0;if((c[o>>2]|0)==0|(c[k>>2]|0)==0|(c[l>>2]|0)==0|(c[m>>2]|0)<0){c[j>>2]=1;z=c[j>>2]|0;i=h;return z|0}switch(c[(c[k>>2]|0)+4>>2]|0){case 13:case 9:case 8:case 7:case 5:case 4:case 3:case 2:case 1:break;default:{c[j>>2]=1;z=c[j>>2]|0;i=h;return z|0}}while(1){if(((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+4>>2]|0)!=1:0)?(c[(c[k>>2]|0)+4>>2]|0)!=9:0)A=(c[(c[k>>2]|0)+4>>2]|0)!=13;else A=0;B=c[k>>2]|0;if(!A)break;c[k>>2]=c[B+20>>2]}if(!B){c[j>>2]=1;z=c[j>>2]|0;i=h;return z|0}B=c[k>>2]|0;if((c[(c[k>>2]|0)+4>>2]|0)==1)c[q>>2]=c[B+32>>2];else c[q>>2]=B;if(!(c[q>>2]|0)){c[j>>2]=1;z=c[j>>2]|0;i=h;return z|0}do if((c[(c[q>>2]|0)+4>>2]|0)==9)c[p>>2]=Zf(c[l>>2]|0,c[m>>2]|0)|0;else{if((c[(c[q>>2]|0)+4>>2]|0)==13){c[p>>2]=no(c[l>>2]|0,c[m>>2]|0)|0;c[n>>2]=c[n>>2]|8192;break}c[j>>2]=1;z=c[j>>2]|0;i=h;return z|0}while(0);if(!(c[p>>2]|0)){c[j>>2]=2;z=c[j>>2]|0;i=h;return z|0}if(c[(c[q>>2]|0)+80>>2]|0){if(c[(c[p>>2]|0)+296>>2]|0)zP(c[(c[p>>2]|0)+296>>2]|0);c[(c[p>>2]|0)+296>>2]=c[(c[q>>2]|0)+80>>2]}else c[n>>2]=c[n>>2]|4096;do if(c[(c[q>>2]|0)+60>>2]|0){if(c[(c[p>>2]|0)+24>>2]|0)zb[c[135736>>2]&511](c[(c[p>>2]|0)+24>>2]|0);m=my(c[(c[q>>2]|0)+60>>2]|0)|0;c[(c[p>>2]|0)+24>>2]=m;c[v>>2]=Dd(c[(c[q>>2]|0)+60>>2]|0)|0;if(c[v>>2]|0){se(c[p>>2]|0,c[v>>2]|0)|0;break}c[j>>2]=32;z=c[j>>2]|0;i=h;return z|0}while(0);gh(c[p>>2]|0,c[n>>2]|0,0)|0;Rg(c[p>>2]|0);c[(c[p>>2]|0)+8>>2]=c[q>>2];c[(c[p>>2]|0)+172>>2]=7;c[r>>2]=oi(0)|0;if(!(c[r>>2]|0)){Ae(c[p>>2]|0);c[j>>2]=2;z=c[j>>2]|0;i=h;return z|0}zi(c[k>>2]|0,c[r>>2]|0)|0;a:do if((c[(c[k>>2]|0)+4>>2]|0)==1){Qe(c[p>>2]|0,c[k>>2]|0)|0;c[s>>2]=c[k>>2];while(1){if(!(c[s>>2]|0))break a;if((c[(c[s>>2]|0)+4>>2]|0)!=1)break a;c[w>>2]=c[(c[s>>2]|0)+48>>2];while(1){if(!(c[w>>2]|0))break;if(c[(c[p>>2]|0)+296>>2]|0){c[x>>2]=AP(c[(c[p>>2]|0)+296>>2]|0,c[(c[w>>2]|0)+12>>2]|0,-1)|0;c[y>>2]=AP(c[(c[p>>2]|0)+296>>2]|0,c[(c[w>>2]|0)+8>>2]|0,-1)|0}else{c[x>>2]=c[(c[w>>2]|0)+12>>2];c[y>>2]=c[(c[w>>2]|0)+8>>2]}if(!(hh(c[p>>2]|0,c[x>>2]|0)|0)){ih(c[p>>2]|0,c[x>>2]|0,c[y>>2]|0)|0;c[t>>2]=(c[t>>2]|0)+1}c[w>>2]=c[c[w>>2]>>2]}c[s>>2]=c[(c[s>>2]|0)+20>>2]}}while(0);if(!((c[(c[p>>2]|0)+104>>2]|0)==0?(c[(c[p>>2]|0)+16>>2]|0)==0:0)){w=(c[p>>2]|0)+276|0;c[w>>2]=c[w>>2]|8}w=c[p>>2]|0;if((c[(c[q>>2]|0)+4>>2]|0)==13)jo(w);else Jf(w);_g(c[p>>2]|0,c[t>>2]|0)|0;if((d[c[(c[(c[p>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(d[(c[(c[(c[p>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==47:0)og(c[p>>2]|0,85,0);else C=60;if((C|0)==60?(d[c[(c[(c[p>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=0:0)og(c[p>>2]|0,86,0);if((c[(c[p>>2]|0)+52>>2]|0)!=0?(c[(c[p>>2]|0)+52>>2]|0)!=(c[k>>2]|0):0){og(c[p>>2]|0,85,0);c[(c[p>>2]|0)+12>>2]=0}do if(!(c[(c[p>>2]|0)+12>>2]|0))if(!(c[(c[p>>2]|0)+84>>2]|0)){c[u>>2]=1;break}else{c[u>>2]=c[(c[p>>2]|0)+84>>2];break}else c[u>>2]=0;while(0);c[s>>2]=c[(c[r>>2]|0)+24>>2];c[(c[r>>2]|0)+24>>2]=0;c[(c[k>>2]|0)+16>>2]=c[r>>2];if(c[s>>2]|0)c[(c[s>>2]|0)+28>>2]=0;c[c[o>>2]>>2]=c[s>>2];while(1){if(!(c[s>>2]|0))break;c[(c[s>>2]|0)+20>>2]=0;c[s>>2]=c[(c[s>>2]|0)+24>>2]}Qh(c[r>>2]|0);Rh(c[r>>2]|0);if(c[u>>2]|0){Uh(c[c[o>>2]>>2]|0);c[c[o>>2]>>2]=0}if(c[(c[q>>2]|0)+80>>2]|0)c[(c[p>>2]|0)+296>>2]=0;Ae(c[p>>2]|0);c[j>>2]=c[u>>2];z=c[j>>2]|0;i=h;return z|0}function Zf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;if(!(c[f>>2]|0)){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}if((c[g>>2]|0)<=0){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}c[h>>2]=Be()|0;if(!(c[h>>2]|0)){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}c[k>>2]=Hk(c[f>>2]|0,c[g>>2]|0,0)|0;g=c[h>>2]|0;if(!(c[k>>2]|0)){Ae(g);c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}c[j>>2]=ue(g)|0;if(!(c[j>>2]|0)){yk(c[k>>2]|0);Ae(c[h>>2]|0);c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}else{c[(c[j>>2]|0)+4>>2]=0;c[c[j>>2]>>2]=c[k>>2];iz(c[(c[c[j>>2]>>2]|0)+16>>2]|0,c[j>>2]|0)|0;Oe(c[h>>2]|0,c[j>>2]|0)|0;c[e>>2]=c[h>>2];l=c[e>>2]|0;i=d;return l|0}return 0}function _f(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=$f(c[d>>2]|0,0)|0;i=b;return a|0}function $f(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;c[k>>2]=0;c[h>>2]=Be()|0;if(!(c[h>>2]|0)){ie(0,70088);c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}if(c[g>>2]|0)gh(c[h>>2]|0,c[g>>2]|0,0)|0;c[(c[h>>2]|0)+280>>2]=1;c[j>>2]=Vk(c[f>>2]|0,0,c[h>>2]|0)|0;g=c[h>>2]|0;if(!(c[j>>2]|0)){Ae(g);c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}Oe(g,c[j>>2]|0)|0;if((c[k>>2]|0)==0?(c[(c[h>>2]|0)+180>>2]|0)==0:0)c[k>>2]=Rk(c[f>>2]|0)|0;if((c[k>>2]|0)!=0?(c[(c[h>>2]|0)+180>>2]|0)==0:0)c[(c[h>>2]|0)+180>>2]=c[k>>2];c[e>>2]=c[h>>2];l=c[e>>2]|0;i=d;return l|0}function ag(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;Rf();c[n>>2]=_f(c[j>>2]|0)|0;if(!(c[n>>2]|0)){c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}if(c[h>>2]|0){if(c[c[n>>2]>>2]|0)zb[c[135736>>2]&511](c[c[n>>2]>>2]|0);c[c[n>>2]>>2]=c[h>>2]}Rg(c[n>>2]|0);if(c[l>>2]|0)c[(c[n>>2]|0)+272>>2]=c[l>>2];if(!(c[(c[n>>2]|0)+180>>2]|0)){l=Rk(c[j>>2]|0)|0;c[(c[n>>2]|0)+180>>2]=l}c[(c[n>>2]|0)+288>>2]=c[k>>2];Qf(c[n>>2]|0)|0;do if((c[k>>2]|0)!=0?1:(c[(c[n>>2]|0)+12>>2]|0)!=0){c[m>>2]=c[(c[n>>2]|0)+8>>2];if(c[m>>2]|0)if((c[(c[c[(c[n>>2]|0)+36>>2]>>2]|0)+24>>2]|0)>0){c[(c[m>>2]|0)+36>>2]=9;break}else{c[(c[m>>2]|0)+36>>2]=c[(c[c[(c[n>>2]|0)+36>>2]>>2]|0)+24>>2];break}}else{c[m>>2]=0;Th(c[(c[n>>2]|0)+8>>2]|0);c[(c[n>>2]|0)+8>>2]=0}while(0);if(c[h>>2]|0)c[c[n>>2]>>2]=0;Ae(c[n>>2]|0);c[g>>2]=c[m>>2];o=c[g>>2]|0;i=f;return o|0}function bg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=ag(c[f>>2]|0,c[g>>2]|0,c[h>>2]|0,0)|0;i=e;return d|0}function cg(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=bg(0,c[d>>2]|0,0)|0;i=b;return a|0}function dg(){var a=0;a=i;if(!(c[17532]|0)){i=a;return}Bd();Dw();wP();jk();kk();GH();XM();ee();mx();Ax();vl();c[17532]=0;i=a;return}function eg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}c[f>>2]=c[(c[d>>2]|0)+296>>2];while(1){a=Pe(c[d>>2]|0)|0;c[e>>2]=a;if(!a)break;te(c[e>>2]|0)}c[(c[d>>2]|0)+40>>2]=0;c[(c[d>>2]|0)+36>>2]=0;c[(c[d>>2]|0)+236>>2]=0;e=c[d>>2]|0;if(c[(c[d>>2]|0)+244>>2]|0){c[c[e+244>>2]>>2]=-1;c[(c[d>>2]|0)+232>>2]=c[(c[d>>2]|0)+244>>2]}else c[e+232>>2]=0;c[(c[d>>2]|0)+56>>2]=0;c[(c[d>>2]|0)+52>>2]=0;c[(c[d>>2]|0)+188>>2]=0;c[(c[d>>2]|0)+184>>2]=0;do if(c[(c[d>>2]|0)+20>>2]|0){if((c[f>>2]|0)!=0?(CP(c[f>>2]|0,c[(c[d>>2]|0)+20>>2]|0)|0)!=0:0)break;zb[c[135736>>2]&511](c[(c[d>>2]|0)+20>>2]|0)}while(0);c[(c[d>>2]|0)+20>>2]=0;do if(c[(c[d>>2]|0)+24>>2]|0){if((c[f>>2]|0)!=0?(CP(c[f>>2]|0,c[(c[d>>2]|0)+24>>2]|0)|0)!=0:0)break;zb[c[135736>>2]&511](c[(c[d>>2]|0)+24>>2]|0)}while(0);c[(c[d>>2]|0)+24>>2]=0;do if(c[(c[d>>2]|0)+180>>2]|0){if((c[f>>2]|0)!=0?(CP(c[f>>2]|0,c[(c[d>>2]|0)+180>>2]|0)|0)!=0:0)break;zb[c[135736>>2]&511](c[(c[d>>2]|0)+180>>2]|0)}while(0);c[(c[d>>2]|0)+180>>2]=0;do if(c[(c[d>>2]|0)+224>>2]|0){if((c[f>>2]|0)!=0?(CP(c[f>>2]|0,c[(c[d>>2]|0)+224>>2]|0)|0)!=0:0)break;zb[c[135736>>2]&511](c[(c[d>>2]|0)+224>>2]|0)}while(0);c[(c[d>>2]|0)+224>>2]=0;do if(c[(c[d>>2]|0)+228>>2]|0){if((c[f>>2]|0)!=0?(CP(c[f>>2]|0,c[(c[d>>2]|0)+228>>2]|0)|0)!=0:0)break;zb[c[135736>>2]&511](c[(c[d>>2]|0)+228>>2]|0)}while(0);c[(c[d>>2]|0)+228>>2]=0;if(c[(c[d>>2]|0)+8>>2]|0)Th(c[(c[d>>2]|0)+8>>2]|0);c[(c[d>>2]|0)+8>>2]=0;c[(c[d>>2]|0)+28>>2]=-1;c[(c[d>>2]|0)+88>>2]=0;c[(c[d>>2]|0)+92>>2]=0;c[(c[d>>2]|0)+32>>2]=0;c[(c[d>>2]|0)+96>>2]=0;c[(c[d>>2]|0)+172>>2]=0;c[(c[d>>2]|0)+176>>2]=0;c[(c[d>>2]|0)+12>>2]=1;c[(c[d>>2]|0)+356>>2]=1;c[(c[d>>2]|0)+212>>2]=0;c[(c[d>>2]|0)+100>>2]=1;c[(c[d>>2]|0)+68>>2]=0;c[(c[d>>2]|0)+200>>2]=0;c[(c[d>>2]|0)+204>>2]=0;c[(c[d>>2]|0)+216>>2]=0;c[(c[d>>2]|0)+84>>2]=0;c[(c[d>>2]|0)+248>>2]=0;c[(c[d>>2]|0)+256>>2]=1;c[(c[d>>2]|0)+284>>2]=0;c[(c[d>>2]|0)+440>>2]=0;c[(c[d>>2]|0)+444>>2]=0;c[(c[d>>2]|0)+468>>2]=0;ze((c[d>>2]|0)+72|0);if(c[(c[d>>2]|0)+348>>2]|0){Kj(c[(c[d>>2]|0)+348>>2]|0,c[33934]|0);c[(c[d>>2]|0)+348>>2]=0}if(c[(c[d>>2]|0)+352>>2]|0){Kj(c[(c[d>>2]|0)+352>>2]|0,0);c[(c[d>>2]|0)+352>>2]=0}if(c[(c[d>>2]|0)+284>>2]|0)Hw(c[(c[d>>2]|0)+284>>2]|0);if(!(c[(c[d>>2]|0)+388>>2]|0)){i=b;return}Yd((c[d>>2]|0)+384|0);i=b;return}function fg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=gh(c[e>>2]|0,c[f>>2]|0,0)|0;i=d;return b|0}function gg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;Rf();c[k>>2]=$f(c[g>>2]|0,c[j>>2]|0)|0;if(!(c[k>>2]|0)){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}else{c[f>>2]=jh(c[k>>2]|0,0,c[h>>2]|0,c[j>>2]|0,0)|0;l=c[f>>2]|0;i=e;return l|0}return 0}function hg(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+32|0;h=g+24|0;j=g+20|0;k=g+16|0;l=g+12|0;m=g+8|0;n=g+4|0;o=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;Rf();c[o>>2]=Zf(c[j>>2]|0,c[k>>2]|0)|0;if(!(c[o>>2]|0)){c[h>>2]=0;p=c[h>>2]|0;i=g;return p|0}else{c[h>>2]=jh(c[o>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,0)|0;p=c[h>>2]|0;i=g;return p|0}return 0}function ig(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f+28|0;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f+4|0;o=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if((c[h>>2]|0)<0){c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}Rf();c[n>>2]=Gk(c[h>>2]|0,0)|0;if(!(c[n>>2]|0)){c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}c[(c[n>>2]|0)+8>>2]=0;c[m>>2]=Be()|0;if(!(c[m>>2]|0)){yk(c[n>>2]|0);c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}c[o>>2]=ve(c[m>>2]|0,c[n>>2]|0,0)|0;if(!(c[o>>2]|0)){yk(c[n>>2]|0);Ae(c[m>>2]|0);c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}else{Oe(c[m>>2]|0,c[o>>2]|0)|0;c[g>>2]=jh(c[m>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,0)|0;p=c[g>>2]|0;i=f;return p|0}return 0}function jg(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=h+36|0;k=h+32|0;l=h+28|0;m=h+24|0;n=h+20|0;o=h+16|0;p=h+12|0;q=h+8|0;r=h+4|0;s=h;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;if(!(c[k>>2]|0)){c[j>>2]=0;t=c[j>>2]|0;i=h;return t|0}Rf();c[r>>2]=Kk(c[k>>2]|0,c[l>>2]|0,c[m>>2]|0,0)|0;if(!(c[r>>2]|0)){if(c[l>>2]|0)Cb[c[l>>2]&511](c[m>>2]|0)|0;c[j>>2]=0;t=c[j>>2]|0;i=h;return t|0}c[q>>2]=Be()|0;if(!(c[q>>2]|0)){yk(c[r>>2]|0);c[j>>2]=0;t=c[j>>2]|0;i=h;return t|0}c[s>>2]=ve(c[q>>2]|0,c[r>>2]|0,0)|0;if(!(c[s>>2]|0)){yk(c[r>>2]|0);Ae(c[q>>2]|0);c[j>>2]=0;t=c[j>>2]|0;i=h;return t|0}else{Oe(c[q>>2]|0,c[s>>2]|0)|0;c[j>>2]=jh(c[q>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,0)|0;t=c[j>>2]|0;i=h;return t|0}return 0}function kg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if(!(c[j>>2]|0)){c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}if(!(c[h>>2]|0)){c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}Rf();eg(c[h>>2]|0);c[m>>2]=Vk(c[j>>2]|0,0,c[h>>2]|0)|0;if(!(c[m>>2]|0)){c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}else{Oe(c[h>>2]|0,c[m>>2]|0)|0;c[g>>2]=jh(c[h>>2]|0,0,c[k>>2]|0,c[l>>2]|0,1)|0;n=c[g>>2]|0;i=f;return n|0}return 0}function lg(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+48|0;j=h+32|0;k=h+28|0;l=h+24|0;m=h+20|0;n=h+16|0;o=h+12|0;p=h+8|0;q=h+4|0;r=h;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;if(!(c[k>>2]|0)){c[j>>2]=0;s=c[j>>2]|0;i=h;return s|0}if(!(c[l>>2]|0)){c[j>>2]=0;s=c[j>>2]|0;i=h;return s|0}Rf();eg(c[k>>2]|0);c[q>>2]=Hk(c[l>>2]|0,c[m>>2]|0,0)|0;if(!(c[q>>2]|0)){c[j>>2]=0;s=c[j>>2]|0;i=h;return s|0}c[r>>2]=ve(c[k>>2]|0,c[q>>2]|0,0)|0;if(!(c[r>>2]|0)){yk(c[q>>2]|0);c[j>>2]=0;s=c[j>>2]|0;i=h;return s|0}else{Oe(c[k>>2]|0,c[r>>2]|0)|0;c[j>>2]=jh(c[k>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,1)|0;s=c[j>>2]|0;i=h;return s|0}return 0}function mg(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+48|0;k=j+36|0;l=j+32|0;m=j+28|0;n=j+24|0;o=j+20|0;p=j+16|0;q=j+12|0;r=j+8|0;s=j+4|0;t=j;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;c[r>>2]=h;if(!(c[m>>2]|0)){c[k>>2]=0;u=c[k>>2]|0;i=j;return u|0}if(!(c[l>>2]|0)){c[k>>2]=0;u=c[k>>2]|0;i=j;return u|0}Rf();eg(c[l>>2]|0);c[s>>2]=Kk(c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,0)|0;if(!(c[s>>2]|0)){if(c[n>>2]|0)Cb[c[n>>2]&511](c[o>>2]|0)|0;c[k>>2]=0;u=c[k>>2]|0;i=j;return u|0}c[t>>2]=ve(c[l>>2]|0,c[s>>2]|0,0)|0;if(!(c[t>>2]|0)){yk(c[s>>2]|0);c[k>>2]=0;u=c[k>>2]|0;i=j;return u|0}else{Oe(c[l>>2]|0,c[t>>2]|0)|0;c[k>>2]=jh(c[l>>2]|0,c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,1)|0;u=c[k>>2]|0;i=j;return u|0}return 0}function ng(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if(((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+212>>2]|0)!=0:0)?(c[(c[h>>2]|0)+172>>2]|0)==-1:0){i=f;return}if(c[h>>2]|0)c[(c[h>>2]|0)+84>>2]=c[j>>2];e=c[h>>2]|0;d=c[j>>2]|0;j=c[l>>2]|0;b=c[k>>2]|0;c[g>>2]=c[l>>2];Xd(0,0,0,e,0,1,d,3,0,0,0,0,0,j,0,b,g);if(!(c[h>>2]|0)){i=f;return}c[(c[h>>2]|0)+12>>2]=0;if(c[(c[h>>2]|0)+288>>2]|0){i=f;return}c[(c[h>>2]|0)+212>>2]=1;i=f;return}function og(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+160|0;f=e;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e+20|0;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;cU(l|0,0,129)|0;if(((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+212>>2]|0)!=0:0)?(c[(c[g>>2]|0)+172>>2]|0)==-1:0){i=e;return}do switch(c[h>>2]|0){case 69:{c[k>>2]=74048;break}case 33:{c[k>>2]=74696;break}case 55:{c[k>>2]=74128;break}case 34:{c[k>>2]=74656;break}case 71:{c[k>>2]=73600;break}case 89:{c[k>>2]=73240;break}case 52:{c[k>>2]=74008;break}case 19:{c[k>>2]=73136;break}case 67:{c[k>>2]=73920;break}case 79:{c[k>>2]=74736;break}case 38:{c[k>>2]=73392;break}case 82:{c[k>>2]=74504;break}case 50:{c[k>>2]=73872;break}case 73:{c[k>>2]=74232;break}case 18:{c[k>>2]=73104;break}case 80:{c[k>>2]=73648;break}case 49:{c[k>>2]=73776;break}case 44:{c[k>>2]=73472;break}case 85:{c[k>>2]=74880;break}case 4:{c[k>>2]=74808;break}case 48:{c[k>>2]=73744;break}case 84:{c[k>>2]=73824;break}case 46:{c[k>>2]=73696;break}case 110:{c[k>>2]=75e3;break}case 74:{c[k>>2]=74616;break}case 7:{c[k>>2]=73032;break}case 8:{c[k>>2]=73064;break}case 88:{c[k>>2]=73312;break}case 70:{c[k>>2]=73560;break}case 25:{c[k>>2]=73208;break}case 20:{c[k>>2]=73160;break}case 5:{c[k>>2]=74832;break}case 61:{c[k>>2]=74584;break}case 54:{c[k>>2]=74088;break}case 78:{c[k>>2]=74768;break}case 62:{c[k>>2]=73520;break}case 96:{c[k>>2]=74960;break}case 23:{c[k>>2]=74552;break}case 36:{c[k>>2]=73280;break}case 6:{c[k>>2]=72992;break}case 51:{c[k>>2]=73960;break}case 1:{c[k>>2]=73088;break}case 56:{c[k>>2]=74424;break}case 75:{c[k>>2]=74640;break}case 60:{c[k>>2]=74288;break}case 83:{c[k>>2]=74248;break}case 57:{c[k>>2]=74464;break}case 21:{c[k>>2]=74168;break}case 95:{c[k>>2]=74328;break}case 59:{c[k>>2]=74384;break}case 64:{c[k>>2]=73728;break}case 43:{c[k>>2]=73440;break}case 24:{c[k>>2]=73184;break}case 92:{c[k>>2]=73848;break}case 37:{c[k>>2]=73280;break}case 86:{c[k>>2]=74912;break}case 39:{c[k>>2]=73360;break}default:c[k>>2]=75040}while(0);d=c[k>>2]|0;if(!(c[j>>2]|0)){c[f>>2]=d;JT(l,128,75072,f)|0}else{c[f>>2]=d;JT(l,128,75080,f)|0}if(c[g>>2]|0)c[(c[g>>2]|0)+84>>2]=c[h>>2];d=c[g>>2]|0;k=c[h>>2]|0;h=c[j>>2]|0;c[f>>2]=c[j>>2];Xd(0,0,0,d,0,1,k,3,0,0,h,0,0,0,0,l,f);if(!(c[g>>2]|0)){i=e;return}c[(c[g>>2]|0)+12>>2]=0;if(c[(c[g>>2]|0)+288>>2]|0){i=e;return}c[(c[g>>2]|0)+212>>2]=1;i=e;return}function pg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if(((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+212>>2]|0)!=0:0)?(c[(c[h>>2]|0)+172>>2]|0)==-1:0){i=f;return}if(c[h>>2]|0)c[(c[h>>2]|0)+84>>2]=c[j>>2];e=c[h>>2]|0;d=c[j>>2]|0;j=c[l>>2]|0;b=c[k>>2]|0;c[g>>2]=c[l>>2];Xd(0,0,0,e,0,1,d,3,0,0,j,0,0,0,0,b,g);if(!(c[h>>2]|0)){i=f;return}c[(c[h>>2]|0)+12>>2]=0;if(c[(c[h>>2]|0)+288>>2]|0){i=f;return}c[(c[h>>2]|0)+212>>2]=1;i=f;return}function qg(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+32|0;h=g;j=g+28|0;k=g+24|0;l=g+20|0;m=g+16|0;n=g+12|0;o=g+8|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=0;if(((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+212>>2]|0)!=0:0)?(c[(c[j>>2]|0)+172>>2]|0)==-1:0){i=g;return}if(((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+84>>2]=c[k>>2],(c[c[j>>2]>>2]|0)!=0):0)?(c[(c[c[j>>2]>>2]|0)+108>>2]|0)==-554844497:0)c[o>>2]=c[(c[c[j>>2]>>2]|0)+124>>2];f=c[o>>2]|0;o=c[j>>2]|0;if(c[j>>2]|0){e=c[o+112>>2]|0;d=c[(c[j>>2]|0)+108>>2]|0;b=c[j>>2]|0;a=c[k>>2]|0;p=c[m>>2]|0;q=c[n>>2]|0;r=c[l>>2]|0;s=c[n>>2]|0;c[h>>2]=c[m>>2];c[h+4>>2]=s;Xd(f,e,d,b,0,4,a,2,0,0,p,q,0,0,0,r,h);c[(c[j>>2]|0)+100>>2]=0;i=g;return}else{j=c[k>>2]|0;k=c[m>>2]|0;r=c[n>>2]|0;q=c[l>>2]|0;l=c[n>>2]|0;c[h>>2]=c[m>>2];c[h+4>>2]=l;Xd(f,0,0,o,0,4,j,2,0,0,k,r,0,0,0,q,h);i=g;return}}function rg(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+32|0;h=g;j=g+28|0;k=g+24|0;l=g+20|0;m=g+16|0;n=g+12|0;o=g+8|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=0;if(((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+212>>2]|0)!=0:0)?(c[(c[j>>2]|0)+172>>2]|0)==-1:0){i=g;return}if(((c[j>>2]|0)!=0?(c[c[j>>2]>>2]|0)!=0:0)?(c[(c[c[j>>2]>>2]|0)+108>>2]|0)==-554844497:0)c[o>>2]=c[(c[c[j>>2]>>2]|0)+124>>2];f=c[o>>2]|0;o=c[j>>2]|0;if(!(c[j>>2]|0)){e=c[k>>2]|0;d=c[m>>2]|0;b=c[n>>2]|0;a=c[l>>2]|0;p=c[n>>2]|0;c[h>>2]=c[m>>2];c[h+4>>2]=p;Xd(f,0,0,o,0,1,e,1,0,0,d,b,0,0,0,a,h);i=g;return}if(c[o>>2]|0)q=c[(c[c[j>>2]>>2]|0)+84>>2]|0;else q=0;o=c[(c[j>>2]|0)+4>>2]|0;a=c[j>>2]|0;j=c[k>>2]|0;k=c[m>>2]|0;b=c[n>>2]|0;d=c[l>>2]|0;l=c[n>>2]|0;c[h>>2]=c[m>>2];c[h+4>>2]=l;Xd(f,q,o,a,0,1,j,1,0,0,k,b,0,0,0,d,h);i=g;return}function sg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+32|0;g=f+28|0;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f+4|0;o=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=0;if((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+360>>2]&524288|0)==0:0){if((c[(c[h>>2]|0)+388>>2]|0)==89){c[g>>2]=1;p=c[g>>2]|0;i=f;return p|0}if(((((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+48>>2]|0)!=6:0)?(c[(c[k>>2]|0)+40>>2]|0)!=0:0)?(c[(c[k>>2]|0)+72>>2]|0)==0:0)?(c[n>>2]=c[(c[h>>2]|0)+440>>2],c[(c[k>>2]|0)+72>>2]=1,c[o>>2]=af(c[h>>2]|0,c[(c[k>>2]|0)+40>>2]|0,1,0,0,0)|0,c[(c[k>>2]|0)+72>>2]=(c[(c[h>>2]|0)+440>>2]|0)-(c[n>>2]|0)+1<<1,(c[o>>2]|0)!=0):0){if(vy(c[o>>2]|0,60)|0){n=(c[k>>2]|0)+72|0;c[n>>2]=c[n>>2]|1}zb[c[135736>>2]&511](c[o>>2]|0);c[o>>2]=0}do if(c[l>>2]|0){if((c[l>>2]|0)>>>0<1e7){c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}if(c[(c[h>>2]|0)+36>>2]|0)c[m>>2]=(c[(c[(c[h>>2]|0)+36>>2]|0)+36>>2]|0)+((c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[h>>2]|0)+36>>2]|0)+12>>2]|0));c[m>>2]=(c[m>>2]|0)+(c[(c[h>>2]|0)+444>>2]|0);if((c[l>>2]|0)>>>0<((c[m>>2]|0)*10|0)>>>0){c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}}else{if(c[j>>2]|0){if((c[j>>2]|0)>>>0<1e3){c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}if(c[(c[h>>2]|0)+36>>2]|0)c[m>>2]=(c[(c[(c[h>>2]|0)+36>>2]|0)+36>>2]|0)+((c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[h>>2]|0)+36>>2]|0)+12>>2]|0));c[m>>2]=(c[m>>2]|0)+(c[(c[h>>2]|0)+444>>2]|0);if((c[j>>2]|0)>>>0>=((c[m>>2]|0)*10|0)>>>0)break;if(((c[(c[h>>2]|0)+440>>2]|0)*3|0)>>>0>=((c[m>>2]|0)*10|0)>>>0)break;c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}if(c[k>>2]|0){c[j>>2]=(c[(c[k>>2]|0)+72>>2]|0)/2|0;if(c[(c[h>>2]|0)+36>>2]|0)c[m>>2]=(c[(c[(c[h>>2]|0)+36>>2]|0)+36>>2]|0)+((c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[h>>2]|0)+36>>2]|0)+12>>2]|0));c[m>>2]=(c[m>>2]|0)+(c[(c[h>>2]|0)+444>>2]|0);if(((c[j>>2]|0)*3|0)>>>0>=((c[m>>2]|0)*10|0)>>>0)break;c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}else{if(!((c[(c[h>>2]|0)+388>>2]|0)!=26?(c[(c[h>>2]|0)+388>>2]|0)!=27:0))q=36;if((q|0)==36?(c[(c[h>>2]|0)+440>>2]|0)>>>0>1e4:0)break;c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}}while(0);og(c[h>>2]|0,89,0);c[g>>2]=1;p=c[g>>2]|0;i=f;return p|0}c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}function tg(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function ug(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e;g=e+24|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;c[h>>2]=b;c[j>>2]=d;if(!(c[j>>2]|0)){og(c[h>>2]|0,1,72912);c[g>>2]=0;n=c[g>>2]|0;i=e;return n|0}if(c[33952]|0){d=c[33976]|0;b=c[33980]|0;c[f>>2]=c[(c[j>>2]|0)+8>>2];Db[d&511](b,72952,f)}c[k>>2]=ue(c[h>>2]|0)|0;if(!(c[k>>2]|0)){c[g>>2]=0;n=c[g>>2]|0;i=e;return n|0}c[m>>2]=(xy(c[(c[j>>2]|0)+8>>2]|0)|0)+5;c[l>>2]=Cb[c[135752>>2]&511](c[m>>2]|0)|0;if(!(c[l>>2]|0)){ie(c[h>>2]|0,0);zb[c[135736>>2]&511](c[k>>2]|0);c[g>>2]=0;n=c[g>>2]|0;i=e;return n|0}else{a[c[l>>2]>>0]=32;a[(c[l>>2]|0)+1>>0]=37;a[(c[l>>2]|0)+((c[m>>2]|0)-3)>>0]=59;a[(c[l>>2]|0)+((c[m>>2]|0)-2)>>0]=32;a[(c[l>>2]|0)+((c[m>>2]|0)-1)>>0]=0;eU((c[l>>2]|0)+2|0,c[(c[j>>2]|0)+8>>2]|0,(c[m>>2]|0)-5|0)|0;c[(c[k>>2]|0)+40>>2]=226;c[(c[k>>2]|0)+12>>2]=c[l>>2];c[(c[k>>2]|0)+16>>2]=c[l>>2];c[(c[k>>2]|0)+24>>2]=c[m>>2];c[(c[k>>2]|0)+20>>2]=(c[l>>2]|0)+(c[m>>2]|0);c[g>>2]=c[k>>2];n=c[g>>2]|0;i=e;return n|0}return 0}function vg(a){a=a|0;var b=0,e=0,f=0,g=0;b=i;i=i+16|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;c[f>>2]=(c[(c[(c[e>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0);c[g>>2]=(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[e>>2]|0)+36>>2]|0)+12>>2]|0);if((((c[f>>2]|0)>>>0>1e7|(c[g>>2]|0)>>>0>1e7?(c[c[(c[e>>2]|0)+36>>2]>>2]|0)!=0:0)?(c[(c[c[(c[e>>2]|0)+36>>2]>>2]|0)+4>>2]|0)!=227:0)?(c[(c[e>>2]|0)+360>>2]&524288|0)==0:0){og(c[e>>2]|0,1,69896);c[(c[e>>2]|0)+172>>2]=-1}ke(c[(c[e>>2]|0)+36>>2]|0,250)|0;if(!(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)){i=b;return}if(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0){i=b;return}if((ke(c[(c[e>>2]|0)+36>>2]|0,250)|0)>0){i=b;return}Ve(c[e>>2]|0)|0;i=b;return}function wg(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+32|0;e=b+20|0;f=b+16|0;g=b+12|0;h=b+8|0;j=b+4|0;k=b;c[f>>2]=a;c[g>>2]=0;c[k>>2]=0;if((c[(c[f>>2]|0)+292>>2]|0)==0?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[f>>2]|0);if((c[(c[f>>2]|0)+172>>2]|0)==-1){c[e>>2]=0;l=c[e>>2]|0;i=b;return l|0}c[j>>2]=ne(c[f>>2]|0,h)|0;a=(c[j>>2]|0)==32|(c[j>>2]|0)==62|(c[j>>2]|0)==47;a:do if(!(c[(c[f>>2]|0)+360>>2]&131072)){do if(!a){if(((((((((((((!((c[j>>2]|0)>=97&(c[j>>2]|0)<=122)?!((c[j>>2]|0)>=65&(c[j>>2]|0)<=90|(c[j>>2]|0)==95|(c[j>>2]|0)==58):0)?!((c[j>>2]|0)>=192&(c[j>>2]|0)<=214):0)?!((c[j>>2]|0)>=216&(c[j>>2]|0)<=246):0)?!((c[j>>2]|0)>=248&(c[j>>2]|0)<=767):0)?!((c[j>>2]|0)>=880&(c[j>>2]|0)<=893):0)?!((c[j>>2]|0)>=895&(c[j>>2]|0)<=8191):0)?!((c[j>>2]|0)>=8204&(c[j>>2]|0)<=8205):0)?!((c[j>>2]|0)>=8304&(c[j>>2]|0)<=8591):0)?!((c[j>>2]|0)>=11264&(c[j>>2]|0)<=12271):0)?!((c[j>>2]|0)>=12289&(c[j>>2]|0)<=55295):0)?!((c[j>>2]|0)>=63744&(c[j>>2]|0)<=64975):0)?!((c[j>>2]|0)>=65008&(c[j>>2]|0)<=65533):0)?!((c[j>>2]|0)>=65536&(c[j>>2]|0)<=983039):0)break;c[g>>2]=(c[g>>2]|0)+(c[h>>2]|0);m=c[(c[f>>2]|0)+36>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){n=m+28|0;c[n>>2]=(c[n>>2]|0)+1;c[(c[(c[f>>2]|0)+36>>2]|0)+32>>2]=1}else{n=m+32|0;c[n>>2]=(c[n>>2]|0)+1}n=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[n>>2]=(c[n>>2]|0)+(c[h>>2]|0);if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[f>>2]|0);c[j>>2]=ne(c[f>>2]|0,h)|0;while(1){if(!((c[j>>2]|0)!=32&(c[j>>2]|0)!=62&(c[j>>2]|0)!=47))break a;do if(((((((!((c[j>>2]|0)>=97&(c[j>>2]|0)<=122)?!((c[j>>2]|0)>=65&(c[j>>2]|0)<=90):0)?!((c[j>>2]|0)>=48&(c[j>>2]|0)<=57|(c[j>>2]|0)==95|(c[j>>2]|0)==58|(c[j>>2]|0)==45|(c[j>>2]|0)==46|(c[j>>2]|0)==183):0)?!((c[j>>2]|0)>=192&(c[j>>2]|0)<=214):0)?!((c[j>>2]|0)>=216&(c[j>>2]|0)<=246):0)?!((c[j>>2]|0)>=248&(c[j>>2]|0)<=767):0)?!((c[j>>2]|0)>=768&(c[j>>2]|0)<=879):0)?!((c[j>>2]|0)>=880&(c[j>>2]|0)<=893):0){if((c[j>>2]|0)>=895&(c[j>>2]|0)<=8191)break;if((c[j>>2]|0)>=8204&(c[j>>2]|0)<=8205)break;if((c[j>>2]|0)>=8255&(c[j>>2]|0)<=8256)break;if((c[j>>2]|0)>=8304&(c[j>>2]|0)<=8591)break;if((c[j>>2]|0)>=11264&(c[j>>2]|0)<=12271)break;if((c[j>>2]|0)>=12289&(c[j>>2]|0)<=55295)break;if((c[j>>2]|0)>=63744&(c[j>>2]|0)<=64975)break;if((c[j>>2]|0)>=65008&(c[j>>2]|0)<=65533)break;if(!((c[j>>2]|0)>=65536&(c[j>>2]|0)<=983039))break a}while(0);n=c[k>>2]|0;c[k>>2]=n+1;if((n|0)>100){c[k>>2]=0;if((c[(c[f>>2]|0)+292>>2]|0)==0?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[f>>2]|0);if((c[(c[f>>2]|0)+172>>2]|0)==-1)break}c[g>>2]=(c[g>>2]|0)+(c[h>>2]|0);n=c[(c[f>>2]|0)+36>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){m=n+28|0;c[m>>2]=(c[m>>2]|0)+1;c[(c[(c[f>>2]|0)+36>>2]|0)+32>>2]=1}else{m=n+32|0;c[m>>2]=(c[m>>2]|0)+1}m=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[m>>2]=(c[m>>2]|0)+(c[h>>2]|0);if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[f>>2]|0);c[j>>2]=ne(c[f>>2]|0,h)|0}c[e>>2]=0;l=c[e>>2]|0;i=b;return l|0}while(0);c[e>>2]=0;l=c[e>>2]|0;i=b;return l|0}else{b:do if(!a){m=c[j>>2]|0;if((c[j>>2]|0)<256){if(((!(65<=(m|0)&(c[j>>2]|0)<=90)?!(97<=(c[j>>2]|0)&(c[j>>2]|0)<=122):0)?!(192<=(c[j>>2]|0)&(c[j>>2]|0)<=214):0)?!(216<=(c[j>>2]|0)&(c[j>>2]|0)<=246|248<=(c[j>>2]|0)):0)o=66}else if(!(DQ(m,199744)|0))o=66;do if((o|0)==66){m=c[j>>2]|0;if((c[j>>2]|0)<256)if((m|0)!=95&(c[j>>2]|0)!=58)break b;else break;if(!(19968<=(m|0)&(c[j>>2]|0)<=40869|(c[j>>2]|0)==12295)?(12321<=(c[j>>2]|0)&(c[j>>2]|0)<=12329^1)&(c[j>>2]|0)!=95&(c[j>>2]|0)!=58:0)break b}while(0);c[g>>2]=(c[g>>2]|0)+(c[h>>2]|0);m=c[(c[f>>2]|0)+36>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){n=m+28|0;c[n>>2]=(c[n>>2]|0)+1;c[(c[(c[f>>2]|0)+36>>2]|0)+32>>2]=1}else{n=m+32|0;c[n>>2]=(c[n>>2]|0)+1}n=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[n>>2]=(c[n>>2]|0)+(c[h>>2]|0);if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[f>>2]|0);c[j>>2]=ne(c[f>>2]|0,h)|0;while(1){if(!((c[j>>2]|0)!=32&(c[j>>2]|0)!=62&(c[j>>2]|0)!=47))break a;n=c[j>>2]|0;if((c[j>>2]|0)<256){if(((!(65<=(n|0)&(c[j>>2]|0)<=90)?!(97<=(c[j>>2]|0)&(c[j>>2]|0)<=122):0)?!(192<=(c[j>>2]|0)&(c[j>>2]|0)<=214):0)?!(216<=(c[j>>2]|0)&(c[j>>2]|0)<=246|248<=(c[j>>2]|0)):0)o=84}else if(!(DQ(n,199744)|0))o=84;do if((o|0)==84){o=0;if((c[j>>2]|0)>=256){if(19968<=(c[j>>2]|0)&(c[j>>2]|0)<=40869|(c[j>>2]|0)==12295)break;if(12321<=(c[j>>2]|0)&(c[j>>2]|0)<=12329)break}n=c[j>>2]|0;if((c[j>>2]|0)<256){if(48<=(n|0)&(c[j>>2]|0)<=57|(c[j>>2]|0)==46|(c[j>>2]|0)==45|(c[j>>2]|0)==95|(c[j>>2]|0)==58)break}else{m=(DQ(n,200216)|0)!=0;if(m|(c[j>>2]|0)==46|(c[j>>2]|0)==45|(c[j>>2]|0)==95|(c[j>>2]|0)==58)break}if((c[j>>2]|0)>=256?(DQ(c[j>>2]|0,200144)|0)!=0:0)break;
m=c[j>>2]|0;if((c[j>>2]|0)<256)p=(m|0)==183&1;else p=DQ(m,200272)|0;if(!p)break a}while(0);m=c[k>>2]|0;c[k>>2]=m+1;if((m|0)>100){c[k>>2]=0;if((c[(c[f>>2]|0)+292>>2]|0)==0?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[f>>2]|0);if((c[(c[f>>2]|0)+172>>2]|0)==-1){o=101;break}}c[g>>2]=(c[g>>2]|0)+(c[h>>2]|0);m=c[(c[f>>2]|0)+36>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){n=m+28|0;c[n>>2]=(c[n>>2]|0)+1;c[(c[(c[f>>2]|0)+36>>2]|0)+32>>2]=1}else{n=m+32|0;c[n>>2]=(c[n>>2]|0)+1}n=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[n>>2]=(c[n>>2]|0)+(c[h>>2]|0);if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[f>>2]|0);c[j>>2]=ne(c[f>>2]|0,h)|0;if(c[j>>2]|0)continue;c[k>>2]=0;if((c[(c[f>>2]|0)+292>>2]|0)==0?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[f>>2]|0);if((c[(c[f>>2]|0)+172>>2]|0)==-1){o=112;break}c[j>>2]=ne(c[f>>2]|0,h)|0}if((o|0)==101){c[e>>2]=0;l=c[e>>2]|0;i=b;return l|0}else if((o|0)==112){c[e>>2]=0;l=c[e>>2]|0;i=b;return l|0}}while(0);c[e>>2]=0;l=c[e>>2]|0;i=b;return l|0}while(0);if((c[g>>2]|0)>5e4?(c[(c[f>>2]|0)+360>>2]&524288|0)==0:0){og(c[f>>2]|0,110,65688);c[e>>2]=0;l=c[e>>2]|0;i=b;return l|0}if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+-1>>0]|0|0)==13:0){c[e>>2]=AP(c[(c[f>>2]|0)+296>>2]|0,(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+(0-((c[g>>2]|0)+1))|0,c[g>>2]|0)|0;l=c[e>>2]|0;i=b;return l|0}c[e>>2]=AP(c[(c[f>>2]|0)+296>>2]|0,(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+(0-(c[g>>2]|0))|0,c[g>>2]|0)|0;l=c[e>>2]|0;i=b;return l|0}function xg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;g=e+12|0;h=e+8|0;j=e+4|0;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+212>>2]|0)!=0:0)?(c[(c[g>>2]|0)+172>>2]|0)==-1:0){i=e;return}if(c[g>>2]|0)c[(c[g>>2]|0)+84>>2]=c[h>>2];d=c[g>>2]|0;b=c[h>>2]|0;c[f>>2]=c[j>>2];Xd(0,0,0,d,0,1,b,3,0,0,0,0,0,0,0,72848,f);if(!(c[g>>2]|0)){i=e;return}c[(c[g>>2]|0)+12>>2]=0;if(c[(c[g>>2]|0)+288>>2]|0){i=e;return}c[(c[g>>2]|0)+212>>2]=1;i=e;return}function yg(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+24|0;m=f+4|0;n=f;c[h>>2]=b;c[j>>2]=e;c[m>>2]=0;c[n>>2]=0;if((c[j>>2]|0)!=0?(c[c[j>>2]>>2]|0)!=0:0){c[k>>2]=c[c[j>>2]>>2];a[l>>0]=a[c[k>>2]>>0]|0;if(((d[l>>0]|0|0)==38?(d[(c[k>>2]|0)+1>>0]|0|0)==35:0)?(d[(c[k>>2]|0)+2>>0]|0|0)==120:0){c[k>>2]=(c[k>>2]|0)+3;a[l>>0]=a[c[k>>2]>>0]|0;a:while(1){if((d[l>>0]|0|0)==59)break;if((d[l>>0]|0|0)>=48?(d[l>>0]|0|0)<=57:0)c[m>>2]=(c[m>>2]<<4)+((d[l>>0]|0)-48);else o=12;do if((o|0)==12){o=0;if((d[l>>0]|0|0)>=97?(d[l>>0]|0|0)<=102:0){c[m>>2]=(c[m>>2]<<4)+((d[l>>0]|0)-97)+10;break}if((d[l>>0]|0|0)<65){o=18;break a}if((d[l>>0]|0|0)>70){o=18;break a}c[m>>2]=(c[m>>2]<<4)+((d[l>>0]|0)-65)+10}while(0);if((c[m>>2]|0)>>>0>1114111)c[n>>2]=c[m>>2];c[k>>2]=(c[k>>2]|0)+1;a[l>>0]=a[c[k>>2]>>0]|0}if((o|0)==18){og(c[h>>2]|0,6,0);c[m>>2]=0}if((d[l>>0]|0|0)==59)c[k>>2]=(c[k>>2]|0)+1}else o=24;do if((o|0)==24){if((d[l>>0]|0|0)==38?(d[(c[k>>2]|0)+1>>0]|0|0)==35:0){c[k>>2]=(c[k>>2]|0)+2;a[l>>0]=a[c[k>>2]>>0]|0;while(1){if((d[l>>0]|0|0)==59)break;if((d[l>>0]|0|0)<48){o=31;break}if((d[l>>0]|0|0)>57){o=31;break}c[m>>2]=((c[m>>2]|0)*10|0)+((d[l>>0]|0)-48);if((c[m>>2]|0)>>>0>1114111)c[n>>2]=c[m>>2];c[k>>2]=(c[k>>2]|0)+1;a[l>>0]=a[c[k>>2]>>0]|0}if((o|0)==31){og(c[h>>2]|0,7,0);c[m>>2]=0}if((d[l>>0]|0|0)!=59)break;c[k>>2]=(c[k>>2]|0)+1;break}og(c[h>>2]|0,8,0);c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}while(0);c[c[j>>2]>>2]=c[k>>2];k=c[m>>2]|0;do if((c[m>>2]|0)>>>0<256)if((9<=k>>>0&(c[m>>2]|0)>>>0<=10|(c[m>>2]|0)==13|32<=(c[m>>2]|0)>>>0)&(c[n>>2]|0)==0)o=43;else o=44;else{if(!(256<=k>>>0&(c[m>>2]|0)>>>0<=55295)?!(57344<=(c[m>>2]|0)>>>0&(c[m>>2]|0)>>>0<=65533):0)if(65536<=(c[m>>2]|0)>>>0&(c[m>>2]|0)>>>0<=1114111&(c[n>>2]|0)==0){o=43;break}else{o=44;break}if(!(c[n>>2]|0))o=43;else o=44}while(0);if((o|0)==43){c[g>>2]=c[m>>2];p=c[g>>2]|0;i=f;return p|0}else if((o|0)==44){ng(c[h>>2]|0,9,72856,c[m>>2]|0);c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}}c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}function zg(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f+24|0;n=f;c[h>>2]=b;c[j>>2]=e;c[n>>2]=0;if((c[j>>2]|0)!=0?(c[c[j>>2]>>2]|0)!=0:0){c[l>>2]=c[c[j>>2]>>2];a[m>>0]=a[c[l>>2]>>0]|0;if((d[m>>0]|0|0)!=38){c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}c[l>>2]=(c[l>>2]|0)+1;c[k>>2]=Dg(c[h>>2]|0,l)|0;if(!(c[k>>2]|0)){xg(c[h>>2]|0,68,72152);c[c[j>>2]>>2]=c[l>>2];c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}if((d[c[l>>2]>>0]|0|0)!=59){og(c[h>>2]|0,23,0);zb[c[135736>>2]&511](c[k>>2]|0);c[c[j>>2]>>2]=c[l>>2];c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}c[l>>2]=(c[l>>2]|0)+1;if((c[(c[h>>2]|0)+360>>2]&1048576|0)==0?(c[n>>2]=Yc(c[k>>2]|0)|0,(c[n>>2]|0)!=0):0){zb[c[135736>>2]&511](c[k>>2]|0);c[c[j>>2]>>2]=c[l>>2];c[g>>2]=c[n>>2];o=c[g>>2]|0;i=f;return o|0}m=(c[h>>2]|0)+440|0;c[m>>2]=(c[m>>2]|0)+1;if(c[c[h>>2]>>2]|0){if(c[(c[c[h>>2]>>2]|0)+20>>2]|0)c[n>>2]=Hb[c[(c[c[h>>2]>>2]|0)+20>>2]&511](c[(c[h>>2]|0)+4>>2]|0,c[k>>2]|0)|0;if((c[n>>2]|0)==0?(c[(c[h>>2]|0)+360>>2]&1048576|0)!=0:0)c[n>>2]=Yc(c[k>>2]|0)|0;if((c[n>>2]|0)==0?(c[(c[h>>2]|0)+4>>2]|0)==(c[h>>2]|0):0)c[n>>2]=VP(c[h>>2]|0,c[k>>2]|0)|0}if((c[(c[h>>2]|0)+172>>2]|0)==-1){zb[c[135736>>2]&511](c[k>>2]|0);c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}do if(c[n>>2]|0){m=c[h>>2]|0;if((c[(c[n>>2]|0)+48>>2]|0)==3){pg(m,28,68712,c[k>>2]|0);break}if((c[m+172>>2]|0)==12?(c[(c[n>>2]|0)+48>>2]|0)==2:0){pg(c[h>>2]|0,29,68752,c[k>>2]|0);break}if(((((c[n>>2]|0)!=0?(c[(c[h>>2]|0)+172>>2]|0)==12:0)?(c[(c[n>>2]|0)+40>>2]|0)!=0:0)?(c[(c[n>>2]|0)+48>>2]|0)!=6:0)?(vy(c[(c[n>>2]|0)+40>>2]|0,60)|0)!=0:0){pg(c[h>>2]|0,38,68800,c[k>>2]|0);break}if(((c[(c[n>>2]|0)+48>>2]|0)+-4|0)>>>0<2)pg(c[h>>2]|0,30,68856,c[k>>2]|0)}else{do if((c[(c[h>>2]|0)+28>>2]|0)==1)p=28;else{if((c[(c[h>>2]|0)+88>>2]|0)==0?(c[(c[h>>2]|0)+92>>2]|0)==0:0){p=28;break}Lg(c[h>>2]|0,27,68680,c[k>>2]|0)}while(0);if((p|0)==28)pg(c[h>>2]|0,26,68680,c[k>>2]|0);sg(c[h>>2]|0,0,c[n>>2]|0,0)|0}while(0);zb[c[135736>>2]&511](c[k>>2]|0);c[c[j>>2]>>2]=c[l>>2];c[g>>2]=c[n>>2];o=c[g>>2]|0;i=f;return o|0}c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}function Ag(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+24|0;m=f+4|0;n=f;c[h>>2]=b;c[j>>2]=e;c[n>>2]=0;if((c[j>>2]|0)!=0?(c[c[j>>2]>>2]|0)!=0:0){c[k>>2]=c[c[j>>2]>>2];a[l>>0]=a[c[k>>2]>>0]|0;if((d[l>>0]|0|0)!=37){c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}c[k>>2]=(c[k>>2]|0)+1;c[m>>2]=Dg(c[h>>2]|0,k)|0;if(!(c[m>>2]|0)){xg(c[h>>2]|0,68,71904);c[c[j>>2]>>2]=c[k>>2];c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}a[l>>0]=a[c[k>>2]>>0]|0;if((d[l>>0]|0|0)!=59){og(c[h>>2]|0,23,0);zb[c[135736>>2]&511](c[m>>2]|0);c[c[j>>2]>>2]=c[k>>2];c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}c[k>>2]=(c[k>>2]|0)+1;l=(c[h>>2]|0)+440|0;c[l>>2]=(c[l>>2]|0)+1;if((c[c[h>>2]>>2]|0)!=0?(c[(c[c[h>>2]>>2]|0)+96>>2]|0)!=0:0)c[n>>2]=Hb[c[(c[c[h>>2]>>2]|0)+96>>2]&511](c[(c[h>>2]|0)+4>>2]|0,c[m>>2]|0)|0;if((c[(c[h>>2]|0)+172>>2]|0)==-1){zb[c[135736>>2]&511](c[m>>2]|0);c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}if(c[n>>2]|0){if((c[(c[n>>2]|0)+48>>2]|0)!=4?(c[(c[n>>2]|0)+48>>2]|0)!=5:0)rg(c[h>>2]|0,27,71944,c[m>>2]|0,0)}else{do if((c[(c[h>>2]|0)+28>>2]|0)==1)p=19;else{if((c[(c[h>>2]|0)+88>>2]|0)==0?(c[(c[h>>2]|0)+92>>2]|0)==0:0){p=19;break}rg(c[h>>2]|0,27,65432,c[m>>2]|0,0);c[(c[h>>2]|0)+100>>2]=0}while(0);if((p|0)==19)pg(c[h>>2]|0,26,65432,c[m>>2]|0);sg(c[h>>2]|0,0,0,0)|0}c[(c[h>>2]|0)+92>>2]=1;zb[c[135736>>2]&511](c[m>>2]|0);c[c[j>>2]>>2]=c[k>>2];c[g>>2]=c[n>>2];o=c[g>>2]|0;i=f;return o|0}c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}function Bg(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+48|0;f=e;g=e+32|0;h=e+28|0;j=e+24|0;k=e+20|0;l=e+16|0;m=e+12|0;n=e+8|0;o=e+4|0;c[h>>2]=a;c[j>>2]=b;c[o>>2]=0;do if(!((c[h>>2]|0)==0|(c[j>>2]|0)==0)){if((c[(c[j>>2]|0)+48>>2]|0)!=5?(c[(c[j>>2]|0)+48>>2]|0)!=2:0)break;if(!(c[(c[j>>2]|0)+40>>2]|0)){if(c[33952]|0){b=c[33976]|0;a=c[33980]|0;c[f>>2]=c[(c[j>>2]|0)+8>>2];Db[b&511](a,72024,f)}c[l>>2]=kj()|0;a=c[h>>2]|0;if(!(c[l>>2]|0)){og(a,1,71984);c[g>>2]=-1;p=c[g>>2]|0;i=e;return p|0}c[k>>2]=we(a,c[j>>2]|0)|0;a=c[h>>2]|0;if(!(c[k>>2]|0)){og(a,1,72064);lj(c[l>>2]|0);c[g>>2]=-1;p=c[g>>2]|0;i=e;return p|0}if((Xe(a,c[k>>2]|0)|0)<0){lj(c[l>>2]|0);c[g>>2]=-1;p=c[g>>2]|0;i=e;return p|0}if((c[(c[h>>2]|0)+292>>2]|0)==0?((c[(c[(c[h>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[h>>2]|0);c[n>>2]=ne(c[h>>2]|0,m)|0;while(1){if((c[(c[h>>2]|0)+36>>2]|0)!=(c[k>>2]|0)){q=46;break}if((c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)>>>0>=(c[(c[(c[h>>2]|0)+36>>2]|0)+20>>2]|0)>>>0){q=46;break}a=c[n>>2]|0;if((c[n>>2]|0)<256)if(9<=(a|0)&(c[n>>2]|0)<=10|(c[n>>2]|0)==13)r=1;else r=32<=(c[n>>2]|0);else if(!(256<=(a|0)&(c[n>>2]|0)<=55295)?!(57344<=(c[n>>2]|0)&(c[n>>2]|0)<=65533):0)if(65536<=(c[n>>2]|0))r=(c[n>>2]|0)<=1114111;else r=0;else r=1;if(!(r&1)){q=46;break}nj(c[l>>2]|0,c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0,c[m>>2]|0)|0;a=c[o>>2]|0;c[o>>2]=a+1;if((a|0)>100){c[o>>2]=0;if((c[(c[h>>2]|0)+292>>2]|0)==0?((c[(c[(c[h>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[h>>2]|0);if((c[(c[h>>2]|0)+172>>2]|0)==-1){q=33;break}}a=c[(c[h>>2]|0)+36>>2]|0;if((d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){b=a+28|0;c[b>>2]=(c[b>>2]|0)+1;c[(c[(c[h>>2]|0)+36>>2]|0)+32>>2]=1}else{b=a+32|0;c[b>>2]=(c[b>>2]|0)+1}b=(c[(c[h>>2]|0)+36>>2]|0)+16|0;c[b>>2]=(c[b>>2]|0)+(c[m>>2]|0);if((d[c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[h>>2]|0);c[n>>2]=ne(c[h>>2]|0,m)|0;if(c[n>>2]|0)continue;c[o>>2]=0;do if(!(c[(c[h>>2]|0)+292>>2]|0)){if(((c[(c[(c[h>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=250)break;vg(c[h>>2]|0)}while(0);if((c[(c[h>>2]|0)+172>>2]|0)==-1){q=44;break}c[n>>2]=ne(c[h>>2]|0,m)|0}if((q|0)==33){lj(c[l>>2]|0);c[g>>2]=-1;p=c[g>>2]|0;i=e;return p|0}else if((q|0)==44){lj(c[l>>2]|0);c[g>>2]=-1;p=c[g>>2]|0;i=e;return p|0}else if((q|0)==46){if((c[(c[h>>2]|0)+36>>2]|0)==(c[k>>2]|0)?(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)>>>0>=(c[(c[(c[h>>2]|0)+36>>2]|0)+20>>2]|0)>>>0:0)Ve(c[h>>2]|0)|0;else q=49;do if((q|0)==49){b=c[n>>2]|0;if((c[n>>2]|0)<256){if(9<=(b|0)&(c[n>>2]|0)<=10|(c[n>>2]|0)==13|32<=(c[n>>2]|0))break}else{if(256<=(b|0)&(c[n>>2]|0)<=55295)break;if(57344<=(c[n>>2]|0)&(c[n>>2]|0)<=65533)break;if(65536<=(c[n>>2]|0)&(c[n>>2]|0)<=1114111)break}ng(c[h>>2]|0,9,72104,c[n>>2]|0);lj(c[l>>2]|0);c[g>>2]=-1;p=c[g>>2]|0;i=e;return p|0}while(0);c[(c[j>>2]|0)+40>>2]=c[c[l>>2]>>2];c[c[l>>2]>>2]=0;lj(c[l>>2]|0);c[g>>2]=0;p=c[g>>2]|0;i=e;return p|0}}}while(0);og(c[h>>2]|0,1,71984);c[g>>2]=-1;p=c[g>>2]|0;i=e;return p|0}function Cg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;b=c[g>>2]|0;a:do if(!(c[(c[f>>2]|0)+360>>2]&131072)){if((b|0)!=32&(c[g>>2]|0)!=62&(c[g>>2]|0)!=47){if((((((((((((((((!((c[g>>2]|0)>=97&(c[g>>2]|0)<=122)?!((c[g>>2]|0)>=65&(c[g>>2]|0)<=90):0)?!((c[g>>2]|0)>=48&(c[g>>2]|0)<=57|(c[g>>2]|0)==95|(c[g>>2]|0)==58|(c[g>>2]|0)==45|(c[g>>2]|0)==46|(c[g>>2]|0)==183):0)?!((c[g>>2]|0)>=192&(c[g>>2]|0)<=214):0)?!((c[g>>2]|0)>=216&(c[g>>2]|0)<=246):0)?!((c[g>>2]|0)>=248&(c[g>>2]|0)<=767):0)?!((c[g>>2]|0)>=768&(c[g>>2]|0)<=879):0)?!((c[g>>2]|0)>=880&(c[g>>2]|0)<=893):0)?!((c[g>>2]|0)>=895&(c[g>>2]|0)<=8191):0)?!((c[g>>2]|0)>=8204&(c[g>>2]|0)<=8205):0)?!((c[g>>2]|0)>=8255&(c[g>>2]|0)<=8256):0)?!((c[g>>2]|0)>=8304&(c[g>>2]|0)<=8591):0)?!((c[g>>2]|0)>=11264&(c[g>>2]|0)<=12271):0)?!((c[g>>2]|0)>=12289&(c[g>>2]|0)<=55295):0)?!((c[g>>2]|0)>=63744&(c[g>>2]|0)<=64975):0)?!((c[g>>2]|0)>=65008&(c[g>>2]|0)<=65533):0)?!((c[g>>2]|0)>=65536&(c[g>>2]|0)<=983039):0)break;c[e>>2]=1;h=c[e>>2]|0;i=d;return h|0}}else{a=c[g>>2]|0;if((b|0)<256){if(((!(65<=(a|0)&(c[g>>2]|0)<=90)?!(97<=(c[g>>2]|0)&(c[g>>2]|0)<=122):0)?!(192<=(c[g>>2]|0)&(c[g>>2]|0)<=214):0)?!(216<=(c[g>>2]|0)&(c[g>>2]|0)<=246|248<=(c[g>>2]|0)):0)j=27}else if(!(DQ(a,199744)|0))j=27;do if((j|0)==27){if((c[g>>2]|0)>=256){if(19968<=(c[g>>2]|0)&(c[g>>2]|0)<=40869|(c[g>>2]|0)==12295)break;if(12321<=(c[g>>2]|0)&(c[g>>2]|0)<=12329)break}a=c[g>>2]|0;if((c[g>>2]|0)<256){if(48<=(a|0)&(c[g>>2]|0)<=57|(c[g>>2]|0)==46|(c[g>>2]|0)==45|(c[g>>2]|0)==95|(c[g>>2]|0)==58)break}else{k=(DQ(a,200216)|0)!=0;if(k|(c[g>>2]|0)==46|(c[g>>2]|0)==45|(c[g>>2]|0)==95|(c[g>>2]|0)==58)break}if((c[g>>2]|0)>=256?(DQ(c[g>>2]|0,200144)|0)!=0:0)break;k=c[g>>2]|0;if((c[g>>2]|0)<256)if((k|0)==183)break;else break a;else if(DQ(k,200272)|0)break;else break a}while(0);c[e>>2]=1;h=c[e>>2]|0;i=d;return h|0}while(0);c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}function Dg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+160|0;f=e+36|0;g=e+32|0;h=e+28|0;j=e+40|0;k=e+24|0;l=e+20|0;m=e+16|0;n=e+12|0;o=e+8|0;p=e+4|0;q=e;c[g>>2]=b;c[h>>2]=d;c[k>>2]=c[c[h>>2]>>2];c[l>>2]=0;c[n>>2]=oe(c[g>>2]|0,c[k>>2]|0,m)|0;if(!(kh(c[g>>2]|0,c[n>>2]|0)|0)){c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}if((c[m>>2]|0)==1){d=c[n>>2]&255;b=c[l>>2]|0;c[l>>2]=b+1;a[j+b>>0]=d}else{d=pe(j+(c[l>>2]|0)|0,c[n>>2]|0)|0;c[l>>2]=(c[l>>2]|0)+d}c[k>>2]=(c[k>>2]|0)+(c[m>>2]|0);c[n>>2]=oe(c[g>>2]|0,c[k>>2]|0,m)|0;do{if(!(Cg(c[g>>2]|0,c[n>>2]|0)|0)){s=28;break}if((c[m>>2]|0)==1){d=c[n>>2]&255;b=c[l>>2]|0;c[l>>2]=b+1;a[j+b>>0]=d}else{d=pe(j+(c[l>>2]|0)|0,c[n>>2]|0)|0;c[l>>2]=(c[l>>2]|0)+d}c[k>>2]=(c[k>>2]|0)+(c[m>>2]|0);c[n>>2]=oe(c[g>>2]|0,c[k>>2]|0,m)|0}while((c[l>>2]|0)<100);if((s|0)==28){if((c[l>>2]|0)>5e4?(c[(c[g>>2]|0)+360>>2]&524288|0)==0:0){og(c[g>>2]|0,110,70920);c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}c[c[h>>2]>>2]=c[k>>2];c[f>>2]=ly(j,c[l>>2]|0)|0;r=c[f>>2]|0;i=e;return r|0}c[p>>2]=c[l>>2]<<1;c[o>>2]=Cb[c[135752>>2]&511](c[p>>2]|0)|0;if(!(c[o>>2]|0)){ie(c[g>>2]|0,0);c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}eU(c[o>>2]|0,j|0,c[l>>2]|0)|0;while(1){j=(Cg(c[g>>2]|0,c[n>>2]|0)|0)!=0;t=c[l>>2]|0;if(!j){s=27;break}if((t+10|0)>(c[p>>2]|0)){if((c[l>>2]|0)>5e4?(c[(c[g>>2]|0)+360>>2]&524288|0)==0:0){s=19;break}c[p>>2]=c[p>>2]<<1;c[q>>2]=Hb[c[135760>>2]&511](c[o>>2]|0,c[p>>2]|0)|0;if(!(c[q>>2]|0)){s=21;break}c[o>>2]=c[q>>2]}if((c[m>>2]|0)==1){j=c[n>>2]&255;d=c[l>>2]|0;c[l>>2]=d+1;a[(c[o>>2]|0)+d>>0]=j}else{j=pe((c[o>>2]|0)+(c[l>>2]|0)|0,c[n>>2]|0)|0;c[l>>2]=(c[l>>2]|0)+j}c[k>>2]=(c[k>>2]|0)+(c[m>>2]|0);c[n>>2]=oe(c[g>>2]|0,c[k>>2]|0,m)|0}if((s|0)==19){og(c[g>>2]|0,110,70920);zb[c[135736>>2]&511](c[o>>2]|0);c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}else if((s|0)==21){ie(c[g>>2]|0,0);zb[c[135736>>2]&511](c[o>>2]|0);c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}else if((s|0)==27){a[(c[o>>2]|0)+t>>0]=0;c[c[h>>2]>>2]=c[k>>2];c[f>>2]=c[o>>2];r=c[f>>2]|0;i=e;return r|0}return 0}function Eg(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;h=i;i=i+96|0;j=h+84|0;k=h+80|0;l=h+76|0;m=h+72|0;n=h+68|0;o=h+88|0;p=h+64|0;q=h+60|0;r=h+56|0;s=h+52|0;t=h+48|0;u=h+44|0;v=h+40|0;w=h+36|0;x=h+32|0;y=h+28|0;z=h+24|0;A=h+20|0;B=h+16|0;C=h+12|0;D=h+8|0;E=h+4|0;F=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;a[o>>0]=0;c[p>>2]=0;c[t>>2]=0;if((c[(c[k>>2]|0)+292>>2]|0)==0?((c[(c[(c[k>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[k>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[k>>2]|0);c[p>>2]=c[(c[(c[k>>2]|0)+36>>2]|0)+16>>2];c[u>>2]=c[(c[(c[k>>2]|0)+36>>2]|0)+28>>2];c[v>>2]=c[(c[(c[k>>2]|0)+36>>2]|0)+32>>2];if((d[c[p>>2]>>0]|0|0)!=34?(d[c[p>>2]>>0]|0|0)!=39:0){og(c[k>>2]|0,39,0);c[j>>2]=0;G=c[j>>2]|0;i=h;return G|0}c[(c[k>>2]|0)+172>>2]=12;g=c[p>>2]|0;c[p>>2]=g+1;a[o>>0]=a[g>>0]|0;c[v>>2]=(c[v>>2]|0)+1;c[r>>2]=c[(c[(c[k>>2]|0)+36>>2]|0)+20>>2];c[q>>2]=c[p>>2];if((c[p>>2]|0)>>>0>=(c[r>>2]|0)>>>0){c[w>>2]=c[(c[(c[k>>2]|0)+36>>2]|0)+12>>2];if((c[(c[k>>2]|0)+292>>2]|0)==0?((c[(c[(c[k>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[k>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[k>>2]|0);if((c[w>>2]|0)!=(c[(c[(c[k>>2]|0)+36>>2]|0)+12>>2]|0)){c[x>>2]=(c[(c[(c[k>>2]|0)+36>>2]|0)+12>>2]|0)-(c[w>>2]|0);c[q>>2]=(c[q>>2]|0)+(c[x>>2]|0);c[p>>2]=(c[p>>2]|0)+(c[x>>2]|0)}c[r>>2]=c[(c[(c[k>>2]|0)+36>>2]|0)+20>>2]}do if(c[n>>2]|0){while(1){if((c[p>>2]|0)>>>0>=(c[r>>2]|0)>>>0){H=35;break}if((d[c[p>>2]>>0]|0|0)==(d[o>>0]|0|0)){H=35;break}if((((d[c[p>>2]>>0]|0|0)!=32?(d[c[p>>2]>>0]|0|0)!=9:0)?(d[c[p>>2]>>0]|0|0)!=10:0)?(d[c[p>>2]>>0]|0|0)!=13:0){H=35;break}if((d[c[p>>2]>>0]|0|0)==10){c[u>>2]=(c[u>>2]|0)+1;c[v>>2]=1}else c[v>>2]=(c[v>>2]|0)+1;c[p>>2]=(c[p>>2]|0)+1;c[q>>2]=c[p>>2];if((c[p>>2]|0)>>>0<(c[r>>2]|0)>>>0)continue;c[y>>2]=c[(c[(c[k>>2]|0)+36>>2]|0)+12>>2];if((c[(c[k>>2]|0)+292>>2]|0)==0?((c[(c[(c[k>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[k>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[k>>2]|0);if((c[(c[k>>2]|0)+172>>2]|0)==-1){H=29;break}if((c[y>>2]|0)!=(c[(c[(c[k>>2]|0)+36>>2]|0)+12>>2]|0)){c[z>>2]=(c[(c[(c[k>>2]|0)+36>>2]|0)+12>>2]|0)-(c[y>>2]|0);c[q>>2]=(c[q>>2]|0)+(c[z>>2]|0);c[p>>2]=(c[p>>2]|0)+(c[z>>2]|0)}c[r>>2]=c[(c[(c[k>>2]|0)+36>>2]|0)+20>>2];if(((c[p>>2]|0)-(c[q>>2]|0)|0)<=1e7)continue;if(!(c[(c[k>>2]|0)+360>>2]&524288)){H=34;break}}if((H|0)==29){c[j>>2]=0;G=c[j>>2]|0;i=h;return G|0}else if((H|0)==34){xg(c[k>>2]|0,40,71720);c[j>>2]=0;G=c[j>>2]|0;i=h;return G|0}else if((H|0)==35){while(1){H=0;if((c[p>>2]|0)>>>0>=(c[r>>2]|0)>>>0){H=54;break}if((d[c[p>>2]>>0]|0|0)==(d[o>>0]|0|0)){H=54;break}if((d[c[p>>2]>>0]|0|0)<32){H=54;break}if((d[c[p>>2]>>0]|0|0)>127){H=54;break}if((d[c[p>>2]>>0]|0|0)==38){H=54;break}if((d[c[p>>2]>>0]|0|0)==60){H=54;break}c[v>>2]=(c[v>>2]|0)+1;x=c[p>>2]|0;c[p>>2]=x+1;if((d[x>>0]|0|0)==32?(d[c[p>>2]>>0]|0|0)==32:0){H=54;break}if((c[p>>2]|0)>>>0<(c[r>>2]|0)>>>0){H=35;continue}c[A>>2]=c[(c[(c[k>>2]|0)+36>>2]|0)+12>>2];if((c[(c[k>>2]|0)+292>>2]|0)==0?((c[(c[(c[k>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[k>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[k>>2]|0);if((c[(c[k>>2]|0)+172>>2]|0)==-1){H=48;break}if((c[A>>2]|0)!=(c[(c[(c[k>>2]|0)+36>>2]|0)+12>>2]|0)){c[B>>2]=(c[(c[(c[k>>2]|0)+36>>2]|0)+12>>2]|0)-(c[A>>2]|0);c[q>>2]=(c[q>>2]|0)+(c[B>>2]|0);c[p>>2]=(c[p>>2]|0)+(c[B>>2]|0)}c[r>>2]=c[(c[(c[k>>2]|0)+36>>2]|0)+20>>2];if(((c[p>>2]|0)-(c[q>>2]|0)|0)<=1e7){H=35;continue}if(!(c[(c[k>>2]|0)+360>>2]&524288)){H=53;break}else H=35}if((H|0)==48){c[j>>2]=0;G=c[j>>2]|0;i=h;return G|0}else if((H|0)==53){xg(c[k>>2]|0,40,71720);c[j>>2]=0;G=c[j>>2]|0;i=h;return G|0}else if((H|0)==54){c[s>>2]=c[p>>2];while(1){if((d[(c[s>>2]|0)+-1>>0]|0|0)!=32)break;if((c[s>>2]|0)>>>0<=(c[q>>2]|0)>>>0)break;c[s>>2]=(c[s>>2]|0)+-1}while(1){if((c[p>>2]|0)>>>0<(c[r>>2]|0)>>>0?(d[c[p>>2]>>0]|0|0)!=(d[o>>0]|0|0):0)if(((d[c[p>>2]>>0]|0|0)!=32?(d[c[p>>2]>>0]|0|0)!=9:0)?(d[c[p>>2]>>0]|0|0)!=10:0)I=(d[c[p>>2]>>0]|0|0)==13;else I=1;else I=0;J=c[p>>2]|0;if(!I){H=79;break}if((d[J>>0]|0|0)==10){c[u>>2]=(c[u>>2]|0)+1;c[v>>2]=1}else c[v>>2]=(c[v>>2]|0)+1;c[p>>2]=(c[p>>2]|0)+1;if((c[p>>2]|0)>>>0<(c[r>>2]|0)>>>0)continue;c[C>>2]=c[(c[(c[k>>2]|0)+36>>2]|0)+12>>2];if((c[(c[k>>2]|0)+292>>2]|0)==0?((c[(c[(c[k>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[k>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[k>>2]|0);if((c[(c[k>>2]|0)+172>>2]|0)==-1){H=73;break}if((c[C>>2]|0)!=(c[(c[(c[k>>2]|0)+36>>2]|0)+12>>2]|0)){c[D>>2]=(c[(c[(c[k>>2]|0)+36>>2]|0)+12>>2]|0)-(c[C>>2]|0);c[q>>2]=(c[q>>2]|0)+(c[D>>2]|0);c[p>>2]=(c[p>>2]|0)+(c[D>>2]|0);c[s>>2]=(c[s>>2]|0)+(c[D>>2]|0)}c[r>>2]=c[(c[(c[k>>2]|0)+36>>2]|0)+20>>2];if(((c[p>>2]|0)-(c[q>>2]|0)|0)<=1e7)continue;if(!(c[(c[k>>2]|0)+360>>2]&524288)){H=78;break}}if((H|0)==73){c[j>>2]=0;G=c[j>>2]|0;i=h;return G|0}else if((H|0)==78){xg(c[k>>2]|0,40,71720);c[j>>2]=0;G=c[j>>2]|0;i=h;return G|0}else if((H|0)==79){if((J-(c[q>>2]|0)|0)>1e7?(c[(c[k>>2]|0)+360>>2]&524288|0)==0:0){xg(c[k>>2]|0,40,71720);c[j>>2]=0;G=c[j>>2]|0;i=h;return G|0}if((d[c[p>>2]>>0]|0|0)!=(d[o>>0]|0|0)){H=113;break}else break}}}}else{while(1){if(((((c[p>>2]|0)>>>0<(c[r>>2]|0)>>>0?(d[c[p>>2]>>0]|0|0)!=(d[o>>0]|0|0):0)?(d[c[p>>2]>>0]|0|0)>=32:0)?(d[c[p>>2]>>0]|0|0)<=127:0)?(d[c[p>>2]>>0]|0|0)!=38:0)K=(d[c[p>>2]>>0]|0|0)!=60;else K=0;L=c[p>>2]|0;if(!K){H=101;break}c[p>>2]=L+1;c[v>>2]=(c[v>>2]|0)+1;if((c[p>>2]|0)>>>0<(c[r>>2]|0)>>>0)continue;c[E>>2]=c[(c[(c[k>>2]|0)+36>>2]|0)+12>>2];if((c[(c[k>>2]|0)+292>>2]|0)==0?((c[(c[(c[k>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[k>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[k>>2]|0);if((c[(c[k>>2]|0)+172>>2]|0)==-1){H=95;break}if((c[E>>2]|0)!=(c[(c[(c[k>>2]|0)+36>>2]|0)+12>>2]|0)){c[F>>2]=(c[(c[(c[k>>2]|0)+36>>2]|0)+12>>2]|0)-(c[E>>2]|0);c[q>>2]=(c[q>>2]|0)+(c[F>>2]|0);c[p>>2]=(c[p>>2]|0)+(c[F>>2]|0)}c[r>>2]=c[(c[(c[k>>2]|0)+36>>2]|0)+20>>2];if(((c[p>>2]|0)-(c[q>>2]|0)|0)<=1e7)continue;if(!(c[(c[k>>2]|0)+360>>2]&524288)){H=100;break}}if((H|0)==95){c[j>>2]=0;G=c[j>>2]|0;i=h;return G|0}else if((H|0)==100){xg(c[k>>2]|0,40,71720);c[j>>2]=0;G=c[j>>2]|0;i=h;return G|0}else if((H|0)==101){c[s>>2]=L;if(((c[p>>2]|0)-(c[q>>2]|0)|0)>1e7?(c[(c[k>>2]|0)+360>>2]&524288|0)==0:0){xg(c[k>>2]|0,40,71720);c[j>>2]=0;G=c[j>>2]|0;i=h;return G|0}if((d[c[p>>2]>>0]|0|0)!=(d[o>>0]|0|0)){H=113;break}else break}}while(0);if((H|0)==113){if(c[m>>2]|0)c[c[m>>2]>>2]=1;c[j>>2]=lh(c[k>>2]|0,c[l>>2]|0,c[n>>2]|0)|0;G=c[j>>2]|0;i=h;return G|0}c[p>>2]=(c[p>>2]|0)+1;c[v>>2]=(c[v>>2]|0)+1;if(c[l>>2]|0){c[c[l>>2]>>2]=(c[s>>2]|0)-(c[q>>2]|0);c[t>>2]=c[q>>2]}else{if(c[m>>2]|0)c[c[m>>2]>>2]=1;c[t>>2]=ly(c[q>>2]|0,(c[s>>2]|0)-(c[q>>2]|0)|0)|0}c[(c[(c[k>>2]|0)+36>>2]|0)+16>>2]=c[p>>2];c[(c[(c[k>>2]|0)+36>>2]|0)+28>>2]=c[u>>2];c[(c[(c[k>>2]|0)+36>>2]|0)+32>>2]=c[v>>2];if(c[m>>2]|0)c[c[m>>2]>>2]=0;c[j>>2]=c[t>>2];G=c[j>>2]|0;i=h;return G|0}function Fg(a){a=a|0;var b=0,e=0;b=i;i=i+16|0;e=b;c[e>>2]=a;le(c[(c[e>>2]|0)+36>>2]|0);if(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0){i=b;return}if((ke(c[(c[e>>2]|0)+36>>2]|0,250)|0)>0){i=b;return}Ve(c[e>>2]|0)|0;i=b;return}function Gg(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+32|0;h=g+28|0;j=g+24|0;k=g+20|0;l=g+16|0;m=g+12|0;n=g+8|0;o=g+4|0;p=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;if((c[(c[c[j>>2]>>2]|0)+72>>2]|0)==(c[(c[c[j>>2]>>2]|0)+68>>2]|0)){c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}if(((c[(c[j>>2]|0)+232>>2]|0)!=0?(c[c[(c[j>>2]|0)+232>>2]>>2]|0)!=1:0)?(c[c[(c[j>>2]|0)+232>>2]>>2]|0)!=-2:0){a:do if(!(c[m>>2]|0)){c[n>>2]=0;b:while(1){if((c[n>>2]|0)>=(c[l>>2]|0))break a;do if((d[(c[k>>2]|0)+(c[n>>2]|0)>>0]|0|0)!=32){if(9<=(d[(c[k>>2]|0)+(c[n>>2]|0)>>0]|0|0)?(d[(c[k>>2]|0)+(c[n>>2]|0)>>0]|0|0)<=10:0)break;if((d[(c[k>>2]|0)+(c[n>>2]|0)>>0]|0|0)!=13)break b}while(0);c[n>>2]=(c[n>>2]|0)+1}c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}while(0);if(!(c[(c[j>>2]|0)+52>>2]|0)){c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}if(c[(c[j>>2]|0)+8>>2]|0){c[o>>2]=Qm(c[(c[j>>2]|0)+8>>2]|0,c[(c[(c[j>>2]|0)+52>>2]|0)+8>>2]|0)|0;if(!(c[o>>2]|0)){c[h>>2]=1;q=c[h>>2]|0;i=g;return q|0}if((c[o>>2]|0)==1){c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}}if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=60?(d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13:0){c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}if(((c[(c[(c[j>>2]|0)+52>>2]|0)+12>>2]|0)==0?(d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60:0)?(d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==47:0){c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}c[p>>2]=Bi(c[(c[j>>2]|0)+52>>2]|0)|0;if(!(c[p>>2]|0)){if((c[(c[(c[j>>2]|0)+52>>2]|0)+4>>2]|0)!=1?(c[(c[(c[j>>2]|0)+52>>2]|0)+40>>2]|0)!=0:0){c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}}else{if(hj(c[p>>2]|0)|0){c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}if((c[(c[(c[j>>2]|0)+52>>2]|0)+12>>2]|0)!=0?(hj(c[(c[(c[j>>2]|0)+52>>2]|0)+12>>2]|0)|0)!=0:0){c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}}c[h>>2]=1;q=c[h>>2]|0;i=g;return q|0}c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}function Hg(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+336|0;g=f+20|0;h=f+16|0;j=f+24|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f;c[g>>2]=b;c[h>>2]=e;c[k>>2]=0;c[n>>2]=0;if(((c[(c[g>>2]|0)+292>>2]|0)==0?((c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)Fg(c[g>>2]|0);if((c[(c[g>>2]|0)+292>>2]|0)==0?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[g>>2]|0);c[l>>2]=ne(c[g>>2]|0,m)|0;while(1){if(!((c[l>>2]|0)!=60&(c[l>>2]|0)!=38)){o=49;break}e=c[l>>2]|0;if((c[l>>2]|0)<256)if(9<=(e|0)&(c[l>>2]|0)<=10|(c[l>>2]|0)==13)p=1;else p=32<=(c[l>>2]|0);else if(!(256<=(e|0)&(c[l>>2]|0)<=55295)?!(57344<=(c[l>>2]|0)&(c[l>>2]|0)<=65533):0)if(65536<=(c[l>>2]|0))p=(c[l>>2]|0)<=1114111;else p=0;else p=1;if(!(p&1)){o=49;break}if(((c[l>>2]|0)==93?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==93:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==62:0){if(c[h>>2]|0){o=49;break}og(c[g>>2]|0,62,0)}if((c[m>>2]|0)==1){e=c[l>>2]&255;b=c[k>>2]|0;c[k>>2]=b+1;a[j+b>>0]=e}else{e=pe(j+(c[k>>2]|0)|0,c[l>>2]|0)|0;c[k>>2]=(c[k>>2]|0)+e}if((c[k>>2]|0)>=300){a[j+(c[k>>2]|0)>>0]=0;do if((c[c[g>>2]>>2]|0)!=0?(c[(c[g>>2]|0)+212>>2]|0)==0:0){e=(Gg(c[g>>2]|0,j,c[k>>2]|0,0)|0)!=0;b=c[c[g>>2]>>2]|0;if(e){if(!(c[b+72>>2]|0))break;Db[c[(c[c[g>>2]>>2]|0)+72>>2]&511](c[(c[g>>2]|0)+4>>2]|0,j,c[k>>2]|0);break}if(c[b+68>>2]|0)Db[c[(c[c[g>>2]>>2]|0)+68>>2]&511](c[(c[g>>2]|0)+4>>2]|0,j,c[k>>2]|0);if((c[(c[c[g>>2]>>2]|0)+68>>2]|0)!=(c[(c[c[g>>2]>>2]|0)+72>>2]|0)?(c[c[(c[g>>2]|0)+232>>2]>>2]|0)==-1:0)c[c[(c[g>>2]|0)+232>>2]>>2]=-2}while(0);c[k>>2]=0;if((c[(c[g>>2]|0)+172>>2]|0)!=7){o=71;break}}c[n>>2]=(c[n>>2]|0)+1;if((c[n>>2]|0)>50){if((c[(c[g>>2]|0)+292>>2]|0)==0?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[g>>2]|0);c[n>>2]=0;if((c[(c[g>>2]|0)+172>>2]|0)==-1){o=71;break}}b=c[(c[g>>2]|0)+36>>2]|0;if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){e=b+28|0;c[e>>2]=(c[e>>2]|0)+1;c[(c[(c[g>>2]|0)+36>>2]|0)+32>>2]=1}else{e=b+32|0;c[e>>2]=(c[e>>2]|0)+1}e=(c[(c[g>>2]|0)+36>>2]|0)+16|0;c[e>>2]=(c[e>>2]|0)+(c[m>>2]|0);if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[g>>2]|0);c[l>>2]=ne(c[g>>2]|0,m)|0}if((o|0)==49){do if(((c[k>>2]|0)!=0?(a[j+(c[k>>2]|0)>>0]=0,(c[c[g>>2]>>2]|0)!=0):0)?(c[(c[g>>2]|0)+212>>2]|0)==0:0){n=(Gg(c[g>>2]|0,j,c[k>>2]|0,0)|0)!=0;h=c[c[g>>2]>>2]|0;if(n){if(!(c[h+72>>2]|0))break;Db[c[(c[c[g>>2]>>2]|0)+72>>2]&511](c[(c[g>>2]|0)+4>>2]|0,j,c[k>>2]|0);break}if(c[h+68>>2]|0)Db[c[(c[c[g>>2]>>2]|0)+68>>2]&511](c[(c[g>>2]|0)+4>>2]|0,j,c[k>>2]|0);if((c[(c[c[g>>2]>>2]|0)+68>>2]|0)!=(c[(c[c[g>>2]>>2]|0)+72>>2]|0)?(c[c[(c[g>>2]|0)+232>>2]>>2]|0)==-1:0)c[c[(c[g>>2]|0)+232>>2]>>2]=-2}while(0);if(!(c[l>>2]|0)){i=f;return}k=c[l>>2]|0;if((c[l>>2]|0)<256){if(9<=(k|0)&(c[l>>2]|0)<=10|(c[l>>2]|0)==13|32<=(c[l>>2]|0)){i=f;return}}else{if(256<=(k|0)&(c[l>>2]|0)<=55295){i=f;return}if(57344<=(c[l>>2]|0)&(c[l>>2]|0)<=65533){i=f;return}if(65536<=(c[l>>2]|0)&(c[l>>2]|0)<=1114111){i=f;return}}ng(c[g>>2]|0,9,72816,c[l>>2]|0);l=c[(c[g>>2]|0)+36>>2]|0;if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){k=l+28|0;c[k>>2]=(c[k>>2]|0)+1;c[(c[(c[g>>2]|0)+36>>2]|0)+32>>2]=1}else{k=l+32|0;c[k>>2]=(c[k>>2]|0)+1}k=(c[(c[g>>2]|0)+36>>2]|0)+16|0;c[k>>2]=(c[k>>2]|0)+(c[m>>2]|0);if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=37){i=f;return}We(c[g>>2]|0);i=f;return}else if((o|0)==71){i=f;return}}function Ig(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+64|0;j=h+52|0;k=h+48|0;l=h+44|0;m=h+40|0;n=h+36|0;o=h+32|0;p=h+28|0;q=h+24|0;r=h+20|0;s=h+16|0;t=h+12|0;u=h+8|0;v=h+4|0;w=h;c[j>>2]=b;c[k>>2]=e;c[l>>2]=f;c[m>>2]=g;c[t>>2]=0;c[u>>2]=c[(c[(c[j>>2]|0)+36>>2]|0)+56>>2];if((c[k>>2]|0)==0?(c[l>>2]=0,c[m>>2]=100,c[k>>2]=Cb[c[135752>>2]&511](c[m>>2]|0)|0,(c[k>>2]|0)==0):0){ie(c[j>>2]|0,0);i=h;return}if((c[(c[j>>2]|0)+292>>2]|0)==0?((c[(c[(c[j>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[j>>2]|0);c[n>>2]=ne(c[j>>2]|0,o)|0;if(c[n>>2]|0){g=c[n>>2]|0;if((c[n>>2]|0)<256){if(!(9<=(g|0)&(c[n>>2]|0)<=10|(c[n>>2]|0)==13|32<=(c[n>>2]|0)))x=13}else if((!(256<=(g|0)&(c[n>>2]|0)<=55295)?!(57344<=(c[n>>2]|0)&(c[n>>2]|0)<=65533):0)?!(65536<=(c[n>>2]|0)&(c[n>>2]|0)<=1114111):0)x=13;if((x|0)==13){ng(c[j>>2]|0,9,72648,c[n>>2]|0);zb[c[135736>>2]&511](c[k>>2]|0);i=h;return}g=c[(c[j>>2]|0)+36>>2]|0;if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){f=g+28|0;c[f>>2]=(c[f>>2]|0)+1;c[(c[(c[j>>2]|0)+36>>2]|0)+32>>2]=1}else{f=g+32|0;c[f>>2]=(c[f>>2]|0)+1}f=(c[(c[j>>2]|0)+36>>2]|0)+16|0;c[f>>2]=(c[f>>2]|0)+(c[o>>2]|0);if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[j>>2]|0);c[p>>2]=ne(c[j>>2]|0,q)|0;if(c[p>>2]|0){f=c[p>>2]|0;if((c[p>>2]|0)<256){if(!(9<=(f|0)&(c[p>>2]|0)<=10|(c[p>>2]|0)==13|32<=(c[p>>2]|0)))x=25}else if((!(256<=(f|0)&(c[p>>2]|0)<=55295)?!(57344<=(c[p>>2]|0)&(c[p>>2]|0)<=65533):0)?!(65536<=(c[p>>2]|0)&(c[p>>2]|0)<=1114111):0)x=25;if((x|0)==25){ng(c[j>>2]|0,9,72648,c[n>>2]|0);zb[c[135736>>2]&511](c[k>>2]|0);i=h;return}f=c[(c[j>>2]|0)+36>>2]|0;if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){g=f+28|0;c[g>>2]=(c[g>>2]|0)+1;c[(c[(c[j>>2]|0)+36>>2]|0)+32>>2]=1}else{g=f+32|0;c[g>>2]=(c[g>>2]|0)+1}g=(c[(c[j>>2]|0)+36>>2]|0)+16|0;c[g>>2]=(c[g>>2]|0)+(c[q>>2]|0);if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[j>>2]|0);c[r>>2]=ne(c[j>>2]|0,s)|0;if(c[r>>2]|0){while(1){g=c[r>>2]|0;if((c[r>>2]|0)<256){if(!(9<=(g|0)&(c[r>>2]|0)<=10|(c[r>>2]|0)==13|32<=(c[r>>2]|0))){x=70;break}}else if((!(256<=(g|0)&(c[r>>2]|0)<=55295)?!(57344<=(c[r>>2]|0)&(c[r>>2]|0)<=65533):0)?!(65536<=(c[r>>2]|0)&(c[r>>2]|0)<=1114111):0){x=70;break}if(!((c[r>>2]|0)!=62|(c[p>>2]|0)!=45|(c[n>>2]|0)!=45)){x=70;break}if((c[p>>2]|0)==45&(c[n>>2]|0)==45)og(c[j>>2]|0,80,0);if((c[l>>2]|0)>>>0>1e7?(c[(c[j>>2]|0)+360>>2]&524288|0)==0:0){x=42;break}if(((c[l>>2]|0)+5|0)>>>0>=(c[m>>2]|0)>>>0){c[w>>2]=c[m>>2]<<1;c[v>>2]=Hb[c[135760>>2]&511](c[k>>2]|0,c[w>>2]|0)|0;if(!(c[v>>2]|0)){x=45;break}c[k>>2]=c[v>>2];c[m>>2]=c[w>>2]}if((c[o>>2]|0)==1){g=c[n>>2]&255;f=c[l>>2]|0;c[l>>2]=f+1;a[(c[k>>2]|0)+f>>0]=g}else{g=pe((c[k>>2]|0)+(c[l>>2]|0)|0,c[n>>2]|0)|0;c[l>>2]=(c[l>>2]|0)+g}c[n>>2]=c[p>>2];c[o>>2]=c[q>>2];c[p>>2]=c[r>>2];c[q>>2]=c[s>>2];c[t>>2]=(c[t>>2]|0)+1;if((c[t>>2]|0)>>>0>50){do if(!(c[(c[j>>2]|0)+292>>2]|0)){if(((c[(c[(c[j>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=250)break;vg(c[j>>2]|0)}while(0);c[t>>2]=0;if((c[(c[j>>2]|0)+172>>2]|0)==-1){x=55;break}}g=c[(c[j>>2]|0)+36>>2]|0;if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){f=g+28|0;c[f>>2]=(c[f>>2]|0)+1;c[(c[(c[j>>2]|0)+36>>2]|0)+32>>2]=1}else{f=g+32|0;c[f>>2]=(c[f>>2]|0)+1}f=(c[(c[j>>2]|0)+36>>2]|0)+16|0;c[f>>2]=(c[f>>2]|0)+(c[s>>2]|0);if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[j>>2]|0);c[r>>2]=ne(c[j>>2]|0,s)|0;if(c[r>>2]|0)continue;do if(!(c[(c[j>>2]|0)+292>>2]|0)){if(((c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2]|0)|0)<=500)break;if(((c[(c[(c[j>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=500)break;Fg(c[j>>2]|0)}while(0);do if(!(c[(c[j>>2]|0)+292>>2]|0)){if(((c[(c[(c[j>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=250)break;vg(c[j>>2]|0)}while(0);c[r>>2]=ne(c[j>>2]|0,s)|0}if((x|0)==42){pg(c[j>>2]|0,45,66168,0);zb[c[135736>>2]&511](c[k>>2]|0);i=h;return}else if((x|0)==45){zb[c[135736>>2]&511](c[k>>2]|0);ie(c[j>>2]|0,0);i=h;return}else if((x|0)==55){zb[c[135736>>2]&511](c[k>>2]|0);i=h;return}else if((x|0)==70){a[(c[k>>2]|0)+(c[l>>2]|0)>>0]=0;do if(c[r>>2]|0){l=c[r>>2]|0;if((c[r>>2]|0)<256){if(!(9<=(l|0)&(c[r>>2]|0)<=10|(c[r>>2]|0)==13|32<=(c[r>>2]|0)))x=77}else if((!(256<=(l|0)&(c[r>>2]|0)<=55295)?!(57344<=(c[r>>2]|0)&(c[r>>2]|0)<=65533):0)?!(65536<=(c[r>>2]|0)&(c[r>>2]|0)<=1114111):0)x=77;if((x|0)==77){ng(c[j>>2]|0,9,72648,c[r>>2]|0);break}if((c[u>>2]|0)!=(c[(c[(c[j>>2]|0)+36>>2]|0)+56>>2]|0))xg(c[j>>2]|0,90,72736);me(c[j>>2]|0);if(((c[c[j>>2]>>2]|0)!=0?(c[(c[c[j>>2]>>2]|0)+80>>2]|0)!=0:0)?(c[(c[j>>2]|0)+212>>2]|0)==0:0)Ab[c[(c[c[j>>2]>>2]|0)+80>>2]&511](c[(c[j>>2]|0)+4>>2]|0,c[k>>2]|0)}else pg(c[j>>2]|0,45,72696,c[k>>2]|0);while(0);zb[c[135736>>2]&511](c[k>>2]|0);i=h;return}}}}pg(c[j>>2]|0,45,72792,0);zb[c[135736>>2]&511](c[k>>2]|0);i=h;return}function Jg(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+48|0;j=h;k=h+32|0;l=h+28|0;m=h+24|0;n=h+20|0;o=h+16|0;p=h+12|0;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;
if(((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+212>>2]|0)!=0:0)?(c[(c[k>>2]|0)+172>>2]|0)==-1:0){i=h;return}if(c[k>>2]|0)c[(c[k>>2]|0)+84>>2]=c[l>>2];g=c[k>>2]|0;f=c[l>>2]|0;l=c[n>>2]|0;e=c[o>>2]|0;d=c[p>>2]|0;b=c[m>>2]|0;m=c[o>>2]|0;o=c[p>>2]|0;c[j>>2]=c[n>>2];c[j+4>>2]=m;c[j+8>>2]=o;Xd(0,0,0,g,0,3,f,2,0,0,l,e,d,0,0,b,j);if(!(c[k>>2]|0)){i=h;return}c[(c[k>>2]|0)+356>>2]=0;i=h;return}function Kg(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;m=f+20|0;c[g>>2]=b;c[h>>2]=e;c[j>>2]=0;c[k>>2]=c[h>>2];while(1){do if((d[c[k>>2]>>0]|0|0)==32)n=1;else{if(9<=(d[c[k>>2]>>0]|0|0)?(d[c[k>>2]>>0]|0|0)<=10:0){n=1;break}n=(d[c[k>>2]>>0]|0|0)==13}while(0);o=c[k>>2]|0;if(!n)break;c[k>>2]=o+1}do if(!(sy(o,72576,7)|0)){c[k>>2]=(c[k>>2]|0)+7;while(1){do if((d[c[k>>2]>>0]|0|0)==32)p=1;else{if(9<=(d[c[k>>2]>>0]|0|0)?(d[c[k>>2]>>0]|0|0)<=10:0){p=1;break}p=(d[c[k>>2]>>0]|0|0)==13}while(0);q=c[k>>2]|0;if(!p)break;c[k>>2]=q+1}if((d[q>>0]|0|0)!=61){i=f;return}c[k>>2]=(c[k>>2]|0)+1;while(1){do if((d[c[k>>2]>>0]|0|0)==32)r=1;else{if(9<=(d[c[k>>2]>>0]|0|0)?(d[c[k>>2]>>0]|0|0)<=10:0){r=1;break}r=(d[c[k>>2]>>0]|0|0)==13}while(0);s=c[k>>2]|0;if(!r)break;c[k>>2]=s+1}a[m>>0]=a[s>>0]|0;if((d[m>>0]|0|0)!=39?(d[m>>0]|0|0)!=34:0)break;c[k>>2]=(c[k>>2]|0)+1;c[l>>2]=c[k>>2];while(1){if(d[c[k>>2]>>0]|0)t=(d[c[k>>2]>>0]|0|0)!=(d[m>>0]|0|0);else t=0;u=c[k>>2]|0;if(!t)break;c[k>>2]=u+1}if(d[u>>0]|0){c[j>>2]=ly(c[l>>2]|0,(c[k>>2]|0)-(c[l>>2]|0)|0)|0;c[k>>2]=(c[k>>2]|0)+1;while(1){do if((d[c[k>>2]>>0]|0|0)==32)v=1;else{if(9<=(d[c[k>>2]>>0]|0|0)?(d[c[k>>2]>>0]|0|0)<=10:0){v=1;break}v=(d[c[k>>2]>>0]|0|0)==13}while(0);w=c[k>>2]|0;if(!v)break;c[k>>2]=w+1}if(!(d[w>>0]|0)){if(!(c[j>>2]|0)){i=f;return}n=Iw(c[(c[g>>2]|0)+284>>2]|0,c[j>>2]|0)|0;c[(c[g>>2]|0)+284>>2]=n;zb[c[135736>>2]&511](c[j>>2]|0);i=f;return}}}while(0);rg(c[g>>2]|0,93,72584,c[h>>2]|0,0);if(!(c[j>>2]|0)){i=f;return}zb[c[135736>>2]&511](c[j>>2]|0);i=f;return}function Lg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if(((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+212>>2]|0)!=0:0)?(c[(c[h>>2]|0)+172>>2]|0)==-1:0){i=f;return}if(c[h>>2]|0)c[(c[h>>2]|0)+84>>2]=c[j>>2];e=c[h>>2]|0;h=c[j>>2]|0;j=c[l>>2]|0;d=c[k>>2]|0;c[g>>2]=c[l>>2];Xd(0,0,0,e,0,1,h,2,0,0,j,0,0,0,0,d,g);i=f;return}function Mg(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;c[h>>2]=b;c[j>>2]=e;if((c[h>>2]|0)==0|(c[j>>2]|0)==0){c[g>>2]=0;k=c[g>>2]|0;i=f;return k|0}while(1){if((d[c[h>>2]>>0]|0|0)!=32)break;c[h>>2]=(c[h>>2]|0)+1}while(1){if(!(d[c[h>>2]>>0]|0))break;if((d[c[h>>2]>>0]|0|0)!=32){e=c[h>>2]|0;c[h>>2]=e+1;b=a[e>>0]|0;e=c[j>>2]|0;c[j>>2]=e+1;a[e>>0]=b;continue}while(1){l=c[h>>2]|0;if((d[c[h>>2]>>0]|0|0)!=32)break;c[h>>2]=l+1}if(!(d[l>>0]|0))continue;b=c[j>>2]|0;c[j>>2]=b+1;a[b>>0]=32}a[c[j>>2]>>0]=0;if((c[j>>2]|0)==(c[h>>2]|0)){c[g>>2]=0;k=c[g>>2]|0;i=f;return k|0}else{c[g>>2]=c[j>>2];k=c[g>>2]|0;i=f;return k|0}return 0}function Ng(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+48|0;g=f+32|0;h=f+28|0;j=f+24|0;k=f+20|0;l=f+16|0;m=f+12|0;n=f+8|0;o=f+4|0;p=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;if((c[(c[g>>2]|0)+352>>2]|0)!=0?(Tj(c[(c[g>>2]|0)+352>>2]|0,c[h>>2]|0,c[j>>2]|0)|0)!=0:0){i=f;return}if(!((c[(c[g>>2]|0)+348>>2]|0)==0?(e=Jj(10,c[(c[g>>2]|0)+296>>2]|0)|0,c[(c[g>>2]|0)+348>>2]=e,(c[(c[g>>2]|0)+348>>2]|0)==0):0))q=5;do if((q|0)==5){c[n>>2]=Dh(c[h>>2]|0,m)|0;e=c[(c[g>>2]|0)+296>>2]|0;if(!(c[n>>2]|0)){c[n>>2]=AP(e,c[h>>2]|0,-1)|0;c[o>>2]=0}else{c[n>>2]=AP(e,c[n>>2]|0,-1)|0;c[o>>2]=AP(c[(c[g>>2]|0)+296>>2]|0,c[h>>2]|0,c[m>>2]|0)|0}c[l>>2]=Tj(c[(c[g>>2]|0)+348>>2]|0,c[n>>2]|0,c[o>>2]|0)|0;if(!(c[l>>2]|0)){c[l>>2]=Cb[c[135744>>2]&511](108)|0;if(!(c[l>>2]|0))break;c[c[l>>2]>>2]=0;c[(c[l>>2]|0)+4>>2]=4;if((Qj(c[(c[g>>2]|0)+348>>2]|0,c[n>>2]|0,c[o>>2]|0,c[l>>2]|0,0)|0)<0){zb[c[135736>>2]&511](c[l>>2]|0);break}}else if((c[c[l>>2]>>2]|0)>=(c[(c[l>>2]|0)+4>>2]|0)){c[p>>2]=Hb[c[135760>>2]&511](c[l>>2]|0,28+((c[(c[l>>2]|0)+4>>2]<<1)*5<<2)|0)|0;if(!(c[p>>2]|0))break;c[l>>2]=c[p>>2];e=(c[l>>2]|0)+4|0;c[e>>2]=c[e>>2]<<1;if((Qj(c[(c[g>>2]|0)+348>>2]|0,c[n>>2]|0,c[o>>2]|0,c[l>>2]|0,0)|0)<0){zb[c[135736>>2]&511](c[l>>2]|0);break}}c[n>>2]=Dh(c[j>>2]|0,m)|0;e=c[(c[g>>2]|0)+296>>2]|0;if(!(c[n>>2]|0)){c[n>>2]=AP(e,c[j>>2]|0,-1)|0;c[o>>2]=0}else{c[n>>2]=AP(e,c[n>>2]|0,-1)|0;c[o>>2]=AP(c[(c[g>>2]|0)+296>>2]|0,c[j>>2]|0,c[m>>2]|0)|0}c[(c[l>>2]|0)+8+((c[c[l>>2]>>2]|0)*5<<2)>>2]=c[n>>2];c[(c[l>>2]|0)+8+(((c[c[l>>2]>>2]|0)*5|0)+1<<2)>>2]=c[o>>2];c[m>>2]=xy(c[k>>2]|0)|0;c[k>>2]=AP(c[(c[g>>2]|0)+296>>2]|0,c[k>>2]|0,c[m>>2]|0)|0;c[(c[l>>2]|0)+8+(((c[c[l>>2]>>2]|0)*5|0)+2<<2)>>2]=c[k>>2];c[(c[l>>2]|0)+8+(((c[c[l>>2]>>2]|0)*5|0)+3<<2)>>2]=(c[k>>2]|0)+(c[m>>2]|0);e=(c[l>>2]|0)+8+(((c[c[l>>2]>>2]|0)*5|0)+4<<2)|0;if(c[(c[g>>2]|0)+96>>2]|0)c[e>>2]=72560;else c[e>>2]=0;e=c[l>>2]|0;c[e>>2]=(c[e>>2]|0)+1;i=f;return}while(0);ie(c[g>>2]|0,0);i=f;return}function Og(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;if((c[(c[g>>2]|0)+352>>2]|0)==0?(e=Jj(10,c[(c[g>>2]|0)+296>>2]|0)|0,c[(c[g>>2]|0)+352>>2]=e,(c[(c[g>>2]|0)+352>>2]|0)==0):0){ie(c[g>>2]|0,0);i=f;return}if(Tj(c[(c[g>>2]|0)+352>>2]|0,c[h>>2]|0,c[j>>2]|0)|0){i=f;return}Nj(c[(c[g>>2]|0)+352>>2]|0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0)|0;i=f;return}function Pg(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;i=i+64|0;h=g+44|0;j=g+40|0;k=g+36|0;l=g+32|0;m=g+28|0;n=g+24|0;o=g+20|0;p=g+16|0;q=g+12|0;r=g+48|0;s=g+8|0;t=g+4|0;u=g;c[j>>2]=b;c[k>>2]=e;c[l>>2]=f;c[m>>2]=0;c[n>>2]=0;c[o>>2]=0;c[p>>2]=0;a[r>>0]=0;if((c[l>>2]|0)>128){if((c[l>>2]|0)>2048?1:(c[(c[j>>2]|0)+360>>2]&524288|0)==0)v=4}else if((c[l>>2]|0)>2048)v=4;if((v|0)==4){ng(c[j>>2]|0,55,72424,c[l>>2]|0);c[h>>2]=0;w=c[h>>2]|0;i=g;return w|0}Ue(c[j>>2]|0)|0;if((c[(c[j>>2]|0)+292>>2]|0)==0?((c[(c[(c[j>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[j>>2]|0);f=c[j>>2]|0;if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==40){c[s>>2]=c[(c[f+36>>2]|0)+56>>2];me(c[j>>2]|0);Ue(c[j>>2]|0)|0;e=Pg(c[j>>2]|0,c[s>>2]|0,(c[l>>2]|0)+1|0)|0;c[m>>2]=e;c[n>>2]=e;Ue(c[j>>2]|0)|0;if((c[(c[j>>2]|0)+292>>2]|0)==0?((c[(c[(c[j>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[j>>2]|0)}else{c[q>>2]=Ze(f)|0;f=c[j>>2]|0;if(!(c[q>>2]|0)){og(f,54,0);c[h>>2]=0;w=c[h>>2]|0;i=g;return w|0}e=im(c[f+8>>2]|0,c[q>>2]|0,2)|0;c[m>>2]=e;c[n>>2]=e;e=c[j>>2]|0;if(!(c[n>>2]|0)){ie(e,0);c[h>>2]=0;w=c[h>>2]|0;i=g;return w|0}if((c[e+292>>2]|0)==0?((c[(c[(c[j>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[j>>2]|0);do if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=63){if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==42){c[(c[n>>2]|0)+4>>2]=3;me(c[j>>2]|0);break}e=(c[n>>2]|0)+4|0;if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==43){c[e>>2]=4;me(c[j>>2]|0);break}else{c[e>>2]=1;break}}else{c[(c[n>>2]|0)+4>>2]=2;me(c[j>>2]|0)}while(0);if((c[(c[j>>2]|0)+292>>2]|0)==0?((c[(c[(c[j>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[j>>2]|0)}Ue(c[j>>2]|0)|0;if(((c[(c[j>>2]|0)+292>>2]|0)==0?((c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((c[(c[(c[j>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)Fg(c[j>>2]|0);a:while(1){if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==41){v=117;break}if((c[(c[j>>2]|0)+172>>2]|0)==-1){v=117;break}do if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==44){if(d[r>>0]|0){if((d[r>>0]|0|0)!=(d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)){v=39;break a}}else a[r>>0]=a[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0;me(c[j>>2]|0);c[p>>2]=im(c[(c[j>>2]|0)+8>>2]|0,0,3)|0;x=c[o>>2]|0;if(!(c[p>>2]|0)){v=46;break a}if(!x){c[(c[p>>2]|0)+12>>2]=c[m>>2];if(c[m>>2]|0)c[(c[m>>2]|0)+20>>2]=c[p>>2];e=c[p>>2]|0;c[n>>2]=e;c[m>>2]=e;break}c[(c[n>>2]|0)+16>>2]=c[p>>2];if(c[p>>2]|0)c[(c[p>>2]|0)+20>>2]=c[n>>2];c[(c[p>>2]|0)+12>>2]=c[o>>2];if(c[o>>2]|0)c[(c[o>>2]|0)+20>>2]=c[p>>2];c[n>>2]=c[p>>2];c[o>>2]=0}else{if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=124){v=85;break a}if(d[r>>0]|0){if((d[r>>0]|0|0)!=(d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)){v=63;break a}}else a[r>>0]=a[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0;me(c[j>>2]|0);c[p>>2]=im(c[(c[j>>2]|0)+8>>2]|0,0,4)|0;y=c[o>>2]|0;if(!(c[p>>2]|0)){v=70;break a}if(!y){c[(c[p>>2]|0)+12>>2]=c[m>>2];if(c[m>>2]|0)c[(c[m>>2]|0)+20>>2]=c[p>>2];e=c[p>>2]|0;c[n>>2]=e;c[m>>2]=e;break}c[(c[n>>2]|0)+16>>2]=c[p>>2];if(c[p>>2]|0)c[(c[p>>2]|0)+20>>2]=c[n>>2];c[(c[p>>2]|0)+12>>2]=c[o>>2];if(c[o>>2]|0)c[(c[o>>2]|0)+20>>2]=c[p>>2];c[n>>2]=c[p>>2];c[o>>2]=0}while(0);if((c[(c[j>>2]|0)+292>>2]|0)==0?((c[(c[(c[j>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[j>>2]|0);Ue(c[j>>2]|0)|0;if((c[(c[j>>2]|0)+292>>2]|0)==0?((c[(c[(c[j>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[j>>2]|0);e=c[j>>2]|0;do if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=40){c[q>>2]=Ze(e)|0;z=c[j>>2]|0;if(!(c[q>>2]|0)){v=100;break a}c[o>>2]=im(c[z+8>>2]|0,c[q>>2]|0,2)|0;if(!(c[o>>2]|0)){v=104;break a}if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==63){c[(c[o>>2]|0)+4>>2]=2;me(c[j>>2]|0);break}if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==42){c[(c[o>>2]|0)+4>>2]=3;me(c[j>>2]|0);break}f=(c[o>>2]|0)+4|0;if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==43){c[f>>2]=4;me(c[j>>2]|0);break}else{c[f>>2]=1;break}}else{c[t>>2]=c[(c[e+36>>2]|0)+56>>2];me(c[j>>2]|0);Ue(c[j>>2]|0)|0;c[o>>2]=Pg(c[j>>2]|0,c[t>>2]|0,(c[l>>2]|0)+1|0)|0;Ue(c[j>>2]|0)|0}while(0);Ue(c[j>>2]|0)|0;if(c[(c[j>>2]|0)+292>>2]|0)continue;if(((c[(c[(c[j>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=250)continue;vg(c[j>>2]|0)}if((v|0)==39){ng(c[j>>2]|0,66,72504,d[r>>0]|0);if((c[o>>2]|0)!=0?(c[o>>2]|0)!=(c[m>>2]|0):0)lm(c[(c[j>>2]|0)+8>>2]|0,c[o>>2]|0);if(c[m>>2]|0)lm(c[(c[j>>2]|0)+8>>2]|0,c[m>>2]|0);c[h>>2]=0;w=c[h>>2]|0;i=g;return w|0}else if((v|0)==46){if((x|0)!=0?(c[o>>2]|0)!=(c[m>>2]|0):0)lm(c[(c[j>>2]|0)+8>>2]|0,c[o>>2]|0);lm(c[(c[j>>2]|0)+8>>2]|0,c[m>>2]|0);c[h>>2]=0;w=c[h>>2]|0;i=g;return w|0}else if((v|0)==63){ng(c[j>>2]|0,66,72504,d[r>>0]|0);if((c[o>>2]|0)!=0?(c[o>>2]|0)!=(c[m>>2]|0):0)lm(c[(c[j>>2]|0)+8>>2]|0,c[o>>2]|0);if(c[m>>2]|0)lm(c[(c[j>>2]|0)+8>>2]|0,c[m>>2]|0);c[h>>2]=0;w=c[h>>2]|0;i=g;return w|0}else if((v|0)==70){if((y|0)!=0?(c[o>>2]|0)!=(c[m>>2]|0):0)lm(c[(c[j>>2]|0)+8>>2]|0,c[o>>2]|0);if(c[m>>2]|0)lm(c[(c[j>>2]|0)+8>>2]|0,c[m>>2]|0);c[h>>2]=0;w=c[h>>2]|0;i=g;return w|0}else if((v|0)==85){og(c[j>>2]|0,55,0);if((c[o>>2]|0)!=0?(c[o>>2]|0)!=(c[m>>2]|0):0)lm(c[(c[j>>2]|0)+8>>2]|0,c[o>>2]|0);if(c[m>>2]|0)lm(c[(c[j>>2]|0)+8>>2]|0,c[m>>2]|0);c[h>>2]=0;w=c[h>>2]|0;i=g;return w|0}else if((v|0)==100){og(z,54,0);if(c[m>>2]|0)lm(c[(c[j>>2]|0)+8>>2]|0,c[m>>2]|0);c[h>>2]=0;w=c[h>>2]|0;i=g;return w|0}else if((v|0)==104){if(c[m>>2]|0)lm(c[(c[j>>2]|0)+8>>2]|0,c[m>>2]|0);c[h>>2]=0;w=c[h>>2]|0;i=g;return w|0}else if((v|0)==117){if((c[n>>2]|0)!=0&(c[o>>2]|0)!=0?(c[(c[n>>2]|0)+16>>2]=c[o>>2],(c[o>>2]|0)!=0):0)c[(c[o>>2]|0)+20>>2]=c[n>>2];if((c[(c[j>>2]|0)+104>>2]|0)!=0?(c[(c[(c[j>>2]|0)+36>>2]|0)+56>>2]|0)!=(c[k>>2]|0):0)qg(c[j>>2]|0,90,67976,0,0);me(c[j>>2]|0);do if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=63){if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==42){b:do if(c[m>>2]|0){c[(c[m>>2]|0)+4>>2]=3;c[n>>2]=c[m>>2];while(1){if(!(c[n>>2]|0))break b;if((c[c[n>>2]>>2]|0)!=4)break b;do if(c[(c[n>>2]|0)+12>>2]|0){if((c[(c[(c[n>>2]|0)+12>>2]|0)+4>>2]|0)!=2?(c[(c[(c[n>>2]|0)+12>>2]|0)+4>>2]|0)!=3:0)break;c[(c[(c[n>>2]|0)+12>>2]|0)+4>>2]=1}while(0);do if(c[(c[n>>2]|0)+16>>2]|0){if((c[(c[(c[n>>2]|0)+16>>2]|0)+4>>2]|0)!=2?(c[(c[(c[n>>2]|0)+16>>2]|0)+4>>2]|0)!=3:0)break;c[(c[(c[n>>2]|0)+16>>2]|0)+4>>2]=1}while(0);c[n>>2]=c[(c[n>>2]|0)+16>>2]}}while(0);me(c[j>>2]|0);break}if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==43){if(c[m>>2]|0){c[u>>2]=0;if((c[(c[m>>2]|0)+4>>2]|0)!=2?(c[(c[m>>2]|0)+4>>2]|0)!=3:0)c[(c[m>>2]|0)+4>>2]=4;else c[(c[m>>2]|0)+4>>2]=3;while(1){if(!(c[n>>2]|0))break;if((c[c[n>>2]>>2]|0)!=4)break;do if(c[(c[n>>2]|0)+12>>2]|0){if((c[(c[(c[n>>2]|0)+12>>2]|0)+4>>2]|0)!=2?(c[(c[(c[n>>2]|0)+12>>2]|0)+4>>2]|0)!=3:0)break;c[(c[(c[n>>2]|0)+12>>2]|0)+4>>2]=1;c[u>>2]=1}while(0);do if(c[(c[n>>2]|0)+16>>2]|0){if((c[(c[(c[n>>2]|0)+16>>2]|0)+4>>2]|0)!=2?(c[(c[(c[n>>2]|0)+16>>2]|0)+4>>2]|0)!=3:0)break;c[(c[(c[n>>2]|0)+16>>2]|0)+4>>2]=1;c[u>>2]=1}while(0);c[n>>2]=c[(c[n>>2]|0)+16>>2]}if(c[u>>2]|0)c[(c[m>>2]|0)+4>>2]=3}me(c[j>>2]|0)}}else{do if(c[m>>2]|0){if((c[(c[m>>2]|0)+4>>2]|0)!=4?(c[(c[m>>2]|0)+4>>2]|0)!=3:0){c[(c[m>>2]|0)+4>>2]=2;break}c[(c[m>>2]|0)+4>>2]=3}while(0);me(c[j>>2]|0)}while(0);c[h>>2]=c[m>>2];w=c[h>>2]|0;i=g;return w|0}return 0}function Qg(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+48|0;e=b;f=b+32|0;g=b+28|0;h=b+24|0;j=b+20|0;k=b+16|0;l=b+12|0;m=b+8|0;c[f>>2]=a;c[g>>2]=c[(c[(c[f>>2]|0)+36>>2]|0)+56>>2];a=(c[f>>2]|0)+200|0;c[a>>2]=(c[a>>2]|0)+3;a=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+3;a=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[a>>2]=(c[a>>2]|0)+3;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[f>>2]|0);if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[f>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[f>>2]|0)|0;Ue(c[f>>2]|0)|0;if(((((((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==73?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==78:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==67:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==76:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==85:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==68:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)==69:0){a=(c[f>>2]|0)+200|0;c[a>>2]=(c[a>>2]|0)+7;a=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+7;a=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[a>>2]=(c[a>>2]|0)+7;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[f>>2]|0);if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[f>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[f>>2]|0)|0;Ue(c[f>>2]|0)|0;a=c[f>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=91)og(a,83,0);else{if((c[(c[a+36>>2]|0)+56>>2]|0)!=(c[g>>2]|0))qg(c[f>>2]|0,90,72192,0,0);me(c[f>>2]|0)}if(c[33952]|0){if((c[(c[f>>2]|0)+36>>2]|0)!=0?(c[(c[(c[f>>2]|0)+36>>2]|0)+4>>2]|0)!=0:0){a=c[33976]|0;n=c[33980]|0;o=c[(c[(c[f>>2]|0)+36>>2]|0)+28>>2]|0;c[e>>2]=c[(c[(c[f>>2]|0)+36>>2]|0)+4>>2];c[e+4>>2]=o;Db[a&511](n,65312,e)}Db[c[135904>>2]&511](c[33980]|0,72264,e)}while(1){if(!(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0))break;if(((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==93?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==93:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==62:0)break;if((c[(c[f>>2]|0)+172>>2]|0)==-1)break;c[h>>2]=c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2];c[j>>2]=c[(c[(c[f>>2]|0)+36>>2]|0)+36>>2];do if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60){if((d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=33){p=37;break}if((d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)!=91){p=37;break}Qg(c[f>>2]|0)}else p=37;while(0);a:do if((p|0)==37){p=0;do if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==13)break;n=c[f>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37){zf(n);break a}else{yf(n);break a}}while(0);me(c[f>>2]|0)}while(0);while(1){if(!(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0))q=(c[(c[f>>2]|0)+40>>2]|0)>1;else q=0;r=c[f>>2]|0;if(!q)break;Ve(r)|0}if((c[(c[r+36>>2]|0)+16>>2]|0)!=(c[h>>2]|0))continue;if((c[j>>2]|0)==(c[(c[(c[f>>2]|0)+36>>2]|0)+36>>2]|0)){p=51;break}}if((p|0)==51)og(c[f>>2]|0,60,0);if(c[33952]|0){if((c[(c[f>>2]|0)+36>>2]|0)!=0?(c[(c[(c[f>>2]|0)+36>>2]|0)+4>>2]|0)!=0:0){j=c[33976]|0;h=c[33980]|0;r=c[(c[(c[f>>2]|0)+36>>2]|0)+28>>2]|0;c[e>>2]=c[(c[(c[f>>2]|0)+36>>2]|0)+4>>2];c[e+4>>2]=r;Db[j&511](h,65312,e)}Db[c[135904>>2]&511](c[33980]|0,72304,e)}}else p=57;do if((p|0)==57){if((((((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==73?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==71:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==78:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==79:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==82:0)?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==69:0){c[m>>2]=0;h=(c[f>>2]|0)+200|0;c[h>>2]=(c[h>>2]|0)+6;h=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[h>>2]=(c[h>>2]|0)+6;h=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[h>>2]=(c[h>>2]|0)+6;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[f>>2]|0);if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[f>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[f>>2]|0)|0;Ue(c[f>>2]|0)|0;h=c[f>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=91)og(h,83,0);else{if((c[(c[h+36>>2]|0)+56>>2]|0)!=(c[g>>2]|0))qg(c[f>>2]|0,90,72192,0,0);me(c[f>>2]|0)}if(c[33952]|0){if((c[(c[f>>2]|0)+36>>2]|0)!=0?(c[(c[(c[f>>2]|0)+36>>2]|0)+4>>2]|0)!=0:0){h=c[33976]|0;j=c[33980]|0;r=c[(c[(c[f>>2]|0)+36>>2]|0)+28>>2]|0;c[e>>2]=c[(c[(c[f>>2]|0)+36>>2]|0)+4>>2];c[e+4>>2]=r;Db[h&511](j,65312,e)}Db[c[135904>>2]&511](c[33980]|0,72344,e)}c[k>>2]=c[(c[f>>2]|0)+212>>2];c[l>>2]=c[(c[f>>2]|0)+172>>2];if(!(c[(c[f>>2]|0)+288>>2]|0))c[(c[f>>2]|0)+212>>2]=1;c[(c[f>>2]|0)+172>>2]=15;b:while(1){if((c[m>>2]|0)<0)break;if(!(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0))break;if((c[(c[f>>2]|0)+172>>2]|0)==-1)break;do if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60){if((d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=33)break;if((d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)!=91)break;c[m>>2]=(c[m>>2]|0)+1;j=(c[f>>2]|0)+200|0;c[j>>2]=(c[j>>2]|0)+3;j=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[j>>2]=(c[j>>2]|0)+3;j=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[j>>2]=(c[j>>2]|0)+3;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[f>>2]|0);if(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0)continue b;if((ke(c[(c[f>>2]|0)+36>>2]|0,250)|0)>0)continue b;Ve(c[f>>2]|0)|0;continue b}while(0);do if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==93){if((d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=93)break;if((d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)!=62)break;j=(c[m>>2]|0)+-1|0;c[m>>2]=j;if((j|0)<0)continue b;j=(c[f>>2]|0)+200|0;c[j>>2]=(c[j>>2]|0)+3;j=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[j>>2]=(c[j>>2]|0)+3;j=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[j>>2]=(c[j>>2]|0)+3;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[f>>2]|0);if(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0)continue b;if((ke(c[(c[f>>2]|0)+36>>2]|0,250)|0)>0)continue b;Ve(c[f>>2]|0)|0;continue b}while(0);me(c[f>>2]|0)}c[(c[f>>2]|0)+212>>2]=c[k>>2];c[(c[f>>2]|0)+172>>2]=c[l>>2];if(!(c[33952]|0))break;if((c[(c[f>>2]|0)+36>>2]|0)!=0?(c[(c[(c[f>>2]|0)+36>>2]|0)+4>>2]|0)!=0:0){j=c[33976]|0;h=c[33980]|0;r=c[(c[(c[f>>2]|0)+36>>2]|0)+28>>2]|0;c[e>>2]=c[(c[(c[f>>2]|0)+36>>2]|0)+4>>2];c[e+4>>2]=r;Db[j&511](h,65312,e)}Db[c[135904>>2]&511](c[33980]|0,72384,e);break}og(c[f>>2]|0,95,0)}while(0);if((((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(c[(c[f>>2]|0)+292>>2]|0)==0:0)?((c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)Fg(c[f>>2]|0);e=c[f>>2]|0;if(!(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0)){og(e,59,0);i=b;return}if((c[(c[e+36>>2]|0)+56>>2]|0)!=(c[g>>2]|0))qg(c[f>>2]|0,90,72192,0,0);g=(c[f>>2]|0)+200|0;c[g>>2]=(c[g>>2]|0)+3;g=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[g>>2]=(c[g>>2]|0)+3;g=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[g>>2]=(c[g>>2]|0)+3;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[f>>2]|0);if(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0){i=b;return}if((ke(c[(c[f>>2]|0)+36>>2]|0,250)|0)>0){i=b;return}Ve(c[f>>2]|0)|0;i=b;return}function Rg(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}do if((c[c[d>>2]>>2]|0)!=0?(c[(c[c[d>>2]>>2]|0)+108>>2]|0)==-554844497:0){if((c[(c[c[d>>2]>>2]|0)+116>>2]|0)==0?(c[(c[c[d>>2]>>2]|0)+120>>2]|0)==0:0)break;c[(c[d>>2]|0)+324>>2]=1}while(0);a=AP(c[(c[d>>2]|0)+296>>2]|0,70032,3)|0;c[(c[d>>2]|0)+312>>2]=a;a=AP(c[(c[d>>2]|0)+296>>2]|0,70040,5)|0;c[(c[d>>2]|0)+316>>2]=a;a=AP(c[(c[d>>2]|0)+296>>2]|0,70048,36)|0;c[(c[d>>2]|0)+320>>2]=a;if(((c[(c[d>>2]|0)+312>>2]|0)!=0?(c[(c[d>>2]|0)+316>>2]|0)!=0:0)?(c[(c[d>>2]|0)+320>>2]|0)!=0:0){i=b;return}ie(c[d>>2]|0,0);i=b;return}function Sg(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;i=i+64|0;h=g+56|0;j=g+52|0;k=g+48|0;l=g+44|0;m=g+40|0;n=g+36|0;o=g+32|0;p=g+28|0;q=g+24|0;r=g+20|0;s=g+16|0;t=g+12|0;u=g+8|0;v=g+4|0;w=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[o>>2]=0;c[q>>2]=0;c[r>>2]=0;c[s>>2]=0;c[u>>2]=0;if(!((c[(c[j>>2]|0)+248>>2]|0)>40?(c[(c[j>>2]|0)+360>>2]&524288|0)==0:0))x=3;if((x|0)==3?(c[(c[j>>2]|0)+248>>2]|0)<=1024:0){if(c[m>>2]|0)c[c[m>>2]>>2]=0;if(!(c[k>>2]|0)){c[h>>2]=1;y=c[h>>2]|0;i=g;return y|0}c[t>>2]=xy(c[k>>2]|0)|0;c[n>>2]=Zf(c[k>>2]|0,c[t>>2]|0)|0;if(!(c[n>>2]|0)){c[h>>2]=27;y=c[h>>2]|0;i=g;return y|0}if(c[l>>2]|0)c[(c[n>>2]|0)+4>>2]=c[l>>2];else c[(c[n>>2]|0)+4>>2]=c[n>>2];if(c[(c[n>>2]|0)+296>>2]|0)zP(c[(c[n>>2]|0)+296>>2]|0);c[(c[n>>2]|0)+296>>2]=c[(c[j>>2]|0)+296>>2];l=AP(c[(c[n>>2]|0)+296>>2]|0,70032,3)|0;c[(c[n>>2]|0)+312>>2]=l;l=AP(c[(c[n>>2]|0)+296>>2]|0,70040,5)|0;c[(c[n>>2]|0)+316>>2]=l;l=AP(c[(c[n>>2]|0)+296>>2]|0,70048,36)|0;c[(c[n>>2]|0)+320>>2]=l;c[v>>2]=0;while(1){z=c[n>>2]|0;if((c[v>>2]|0)>=(c[(c[j>>2]|0)+328>>2]|0))break;ih(z,c[(c[(c[j>>2]|0)+336>>2]|0)+(c[v>>2]<<2)>>2]|0,c[(c[(c[j>>2]|0)+336>>2]|0)+((c[v>>2]|0)+1<<2)>>2]|0)|0;c[v>>2]=(c[v>>2]|0)+2}c[q>>2]=c[z>>2];c[c[n>>2]>>2]=c[c[j>>2]>>2];Rg(c[n>>2]|0);c[(c[n>>2]|0)+16>>2]=c[(c[j>>2]|0)+16>>2];c[(c[n>>2]|0)+360>>2]=c[(c[j>>2]|0)+360>>2];c[(c[n>>2]|0)+272>>2]=c[(c[j>>2]|0)+272>>2];do if(!(c[(c[j>>2]|0)+8>>2]|0)){c[o>>2]=Sh(68488)|0;if(c[o>>2]|0){c[(c[o>>2]|0)+92>>2]=64;c[(c[o>>2]|0)+80>>2]=c[(c[n>>2]|0)+296>>2];yP(c[(c[o>>2]|0)+80>>2]|0)|0;c[(c[n>>2]|0)+8>>2]=c[o>>2];break}c[c[n>>2]>>2]=c[q>>2];c[(c[n>>2]|0)+296>>2]=0;Ae(c[n>>2]|0);c[h>>2]=1;y=c[h>>2]|0;i=g;return y|0}else{c[(c[n>>2]|0)+8>>2]=c[(c[j>>2]|0)+8>>2];c[r>>2]=c[(c[(c[n>>2]|0)+8>>2]|0)+12>>2];c[s>>2]=c[(c[(c[n>>2]|0)+8>>2]|0)+16>>2]}while(0);c[p>>2]=ji(c[(c[n>>2]|0)+8>>2]|0,0,69968,0)|0;if(!(c[p>>2]|0)){c[c[n>>2]>>2]=c[q>>2];c[(c[n>>2]|0)+296>>2]=0;Ae(c[n>>2]|0);if(c[o>>2]|0)Th(c[o>>2]|0);c[h>>2]=1;y=c[h>>2]|0;i=g;return y|0}c[(c[(c[n>>2]|0)+8>>2]|0)+12>>2]=0;c[(c[(c[n>>2]|0)+8>>2]|0)+16>>2]=0;zi(c[(c[n>>2]|0)+8>>2]|0,c[p>>2]|0)|0;Qe(c[n>>2]|0,c[(c[(c[n>>2]|0)+8>>2]|0)+12>>2]|0)|0;c[(c[n>>2]|0)+172>>2]=7;c[(c[n>>2]|0)+248>>2]=(c[(c[j>>2]|0)+248>>2]|0)+1;c[(c[n>>2]|0)+104>>2]=0;c[(c[n>>2]|0)+276>>2]=c[(c[j>>2]|0)+276>>2];if(!((c[(c[j>>2]|0)+104>>2]|0)==0?(c[(c[j>>2]|0)+16>>2]|0)==0:0)){p=(c[n>>2]|0)+276|0;c[p>>2]=c[p>>2]|8}c[(c[n>>2]|0)+364>>2]=c[(c[j>>2]|0)+364>>2];c[(c[n>>2]|0)+348>>2]=c[(c[j>>2]|0)+348>>2];c[(c[n>>2]|0)+352>>2]=c[(c[j>>2]|0)+352>>2];Jf(c[n>>2]|0);if((d[c[(c[(c[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(d[(c[(c[(c[n>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==47:0)og(c[n>>2]|0,85,0);else x=34;if((x|0)==34?(d[c[(c[(c[n>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=0:0)og(c[n>>2]|0,86,0);if((c[(c[n>>2]|0)+52>>2]|0)!=(c[(c[(c[n>>2]|0)+8>>2]|0)+12>>2]|0))og(c[n>>2]|0,85,0);do if(!(c[(c[n>>2]|0)+12>>2]|0))if(!(c[(c[n>>2]|0)+84>>2]|0)){c[u>>2]=1;break}else{c[u>>2]=c[(c[n>>2]|0)+84>>2];break}else c[u>>2]=0;while(0);if((c[m>>2]|0)!=0&(c[u>>2]|0)==0){c[w>>2]=c[(c[(c[(c[n>>2]|0)+8>>2]|0)+12>>2]|0)+12>>2];c[c[m>>2]>>2]=c[w>>2];while(1){if(!(c[w>>2]|0))break;do if(c[(c[j>>2]|0)+104>>2]|0){if(!(c[(c[j>>2]|0)+12>>2]|0))break;if(!(c[(c[j>>2]|0)+8>>2]|0))break;if(!(c[(c[(c[j>>2]|0)+8>>2]|0)+44>>2]|0))break;if((c[(c[w>>2]|0)+4>>2]|0)!=1)break;m=bn((c[j>>2]|0)+108|0,c[(c[j>>2]|0)+8>>2]|0,c[w>>2]|0)|0;x=(c[j>>2]|0)+100|0;c[x>>2]=c[x>>2]&m}while(0);c[(c[w>>2]|0)+20>>2]=0;c[w>>2]=c[(c[w>>2]|0)+24>>2]}c[(c[(c[(c[n>>2]|0)+8>>2]|0)+12>>2]|0)+12>>2]=0}if(c[(c[n>>2]|0)+8>>2]|0){Rh(c[(c[(c[n>>2]|0)+8>>2]|0)+12>>2]|0);c[(c[(c[n>>2]|0)+8>>2]|0)+12>>2]=c[r>>2];c[(c[(c[n>>2]|0)+8>>2]|0)+16>>2]=c[s>>2]}if(c[j>>2]|0){s=(c[j>>2]|0)+440|0;c[s>>2]=(c[s>>2]|0)+(c[(c[n>>2]|0)+440>>2]|0)}if(c[(c[n>>2]|0)+388>>2]|0)Zd((c[n>>2]|0)+384|0,(c[j>>2]|0)+384|0)|0;c[c[n>>2]>>2]=c[q>>2];c[(c[n>>2]|0)+296>>2]=0;c[(c[n>>2]|0)+348>>2]=0;c[(c[n>>2]|0)+352>>2]=0;Ae(c[n>>2]|0);if(c[o>>2]|0)Th(c[o>>2]|0);c[h>>2]=c[u>>2];y=c[h>>2]|0;i=g;return y|0}c[h>>2]=89;y=c[h>>2]|0;i=g;return y|0}function Tg(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;m=i;i=i+80|0;n=m+60|0;o=m+56|0;p=m+52|0;q=m+48|0;r=m+44|0;s=m+40|0;t=m+36|0;u=m+32|0;v=m+28|0;w=m+24|0;x=m+20|0;y=m+16|0;z=m+12|0;A=m+8|0;B=m+64|0;C=m+4|0;D=m;c[o>>2]=b;c[p>>2]=e;c[q>>2]=f;c[r>>2]=g;c[s>>2]=h;c[t>>2]=j;c[u>>2]=k;c[v>>2]=l;c[z>>2]=0;c[A>>2]=0;if((c[s>>2]|0)>40){if(!((c[p>>2]|0)!=0?!((c[s>>2]|0)>1024?1:(c[(c[p>>2]|0)+360>>2]&524288|0)==0):0))E=5}else if((c[s>>2]|0)>1024)E=5;if((E|0)==5){c[n>>2]=89;F=c[n>>2]|0;i=m;return F|0}if(c[v>>2]|0)c[c[v>>2]>>2]=0;if((c[t>>2]|0)==0&(c[u>>2]|0)==0){c[n>>2]=1;F=c[n>>2]|0;i=m;return F|0}if(!(c[o>>2]|0)){c[n>>2]=1;F=c[n>>2]|0;i=m;return F|0}c[w>>2]=fh(c[t>>2]|0,c[u>>2]|0,0,c[p>>2]|0)|0;if(!(c[w>>2]|0)){c[n>>2]=27;F=c[n>>2]|0;i=m;return F|0}c[(c[w>>2]|0)+4>>2]=c[w>>2];if(c[p>>2]|0){c[(c[w>>2]|0)+272>>2]=c[(c[p>>2]|0)+272>>2];c[(c[w>>2]|0)+276>>2]=c[(c[p>>2]|0)+276>>2];c[(c[w>>2]|0)+104>>2]=c[(c[p>>2]|0)+104>>2];c[(c[w>>2]|0)+96>>2]=c[(c[p>>2]|0)+96>>2];c[(c[w>>2]|0)+68>>2]=c[(c[p>>2]|0)+68>>2];c[(c[w>>2]|0)+72>>2]=c[(c[p>>2]|0)+72>>2];c[(c[w>>2]|0)+76>>2]=c[(c[p>>2]|0)+76>>2];c[(c[w>>2]|0)+80>>2]=c[(c[p>>2]|0)+80>>2]}else{c[(c[w>>2]|0)+272>>2]=0;c[(c[w>>2]|0)+104>>2]=0;c[(c[w>>2]|0)+96>>2]=2;c[(c[w>>2]|0)+276>>2]=0}if((c[q>>2]|0)!=0?(c[z>>2]=c[c[w>>2]>>2],c[c[w>>2]>>2]=c[q>>2],(c[r>>2]|0)!=0):0)c[(c[w>>2]|0)+4>>2]=c[r>>2];Rg(c[w>>2]|0);c[x>>2]=Sh(68488)|0;if(!(c[x>>2]|0)){c[(c[w>>2]|0)+72>>2]=0;c[(c[w>>2]|0)+76>>2]=0;c[(c[w>>2]|0)+80>>2]=0;Ae(c[w>>2]|0);c[n>>2]=1;F=c[n>>2]|0;i=m;return F|0}c[(c[x>>2]|0)+92>>2]=64;c[(c[x>>2]|0)+44>>2]=c[(c[o>>2]|0)+44>>2];c[(c[x>>2]|0)+48>>2]=c[(c[o>>2]|0)+48>>2];c[(c[x>>2]|0)+80>>2]=c[(c[o>>2]|0)+80>>2];yP(c[(c[x>>2]|0)+80>>2]|0)|0;if(c[(c[o>>2]|0)+72>>2]|0){r=my(c[(c[o>>2]|0)+72>>2]|0)|0;c[(c[x>>2]|0)+72>>2]=r}c[y>>2]=ji(c[x>>2]|0,0,69968,0)|0;if(!(c[y>>2]|0)){if(c[q>>2]|0)c[c[w>>2]>>2]=c[z>>2];c[(c[w>>2]|0)+72>>2]=0;c[(c[w>>2]|0)+76>>2]=0;c[(c[w>>2]|0)+80>>2]=0;Ae(c[w>>2]|0);c[(c[x>>2]|0)+44>>2]=0;c[(c[x>>2]|0)+48>>2]=0;Th(c[x>>2]|0);c[n>>2]=1;F=c[n>>2]|0;i=m;return F|0}zi(c[x>>2]|0,c[y>>2]|0)|0;Qe(c[w>>2]|0,c[(c[x>>2]|0)+12>>2]|0)|0;c[(c[w>>2]|0)+8>>2]=c[o>>2];c[(c[y>>2]|0)+32>>2]=c[o>>2];if((c[(c[w>>2]|0)+292>>2]|0)==0?((c[(c[(c[w>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[w>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[w>>2]|0);if(((c[(c[(c[w>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[w>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=4?(a[B>>0]=a[c[(c[(c[w>>2]|0)+36>>2]|0)+16>>2]>>0]|0,a[B+1>>0]=a[(c[(c[(c[w>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0,a[B+2>>0]=a[(c[(c[(c[w>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0,a[B+3>>0]=a[(c[(c[(c[w>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0,c[C>>2]=sd(B,4)|0,(c[C>>2]|0)!=0):0)re(c[w>>2]|0,c[C>>2]|0)|0;a:do if(((((d[c[(c[(c[w>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(d[(c[(c[(c[w>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==63:0)?(d[(c[(c[(c[w>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==120:0)?(d[(c[(c[(c[w>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==109:0)?(d[(c[(c[(c[w>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==108:0){do if((d[(c[(c[(c[w>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=32){if(9<=(d[(c[(c[(c[w>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)?(d[(c[(c[(c[w>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)<=10:0)break;if((d[(c[(c[(c[w>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=13)break a}while(0);_e(c[w>>2]|0)}while(0);c[(c[w>>2]|0)+172>>2]=7;c[(c[w>>2]|0)+248>>2]=c[s>>2];Jf(c[w>>2]|0);if((d[c[(c[(c[w>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(d[(c[(c[(c[w>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==47:0)og(c[w>>2]|0,85,0);else E=47;if((E|0)==47?(d[c[(c[(c[w>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=0:0)og(c[w>>2]|0,86,0);if((c[(c[w>>2]|0)+52>>2]|0)!=(c[(c[x>>2]|0)+12>>2]|0))og(c[w>>2]|0,85,0);do if(!(c[(c[w>>2]|0)+12>>2]|0))if(!(c[(c[w>>2]|0)+84>>2]|0)){c[A>>2]=1;break}else{c[A>>2]=c[(c[w>>2]|0)+84>>2];break}else{if(c[v>>2]|0){c[D>>2]=c[(c[(c[x>>2]|0)+12>>2]|0)+12>>2];c[c[v>>2]>>2]=c[D>>2];while(1){if(!(c[D>>2]|0))break;c[(c[D>>2]|0)+20>>2]=0;c[D>>2]=c[(c[D>>2]|0)+24>>2]}c[(c[(c[x>>2]|0)+12>>2]|0)+12>>2]=0}c[A>>2]=0}while(0);if(c[p>>2]|0){D=(c[p>>2]|0)+440|0;c[D>>2]=(c[D>>2]|0)+(c[(c[w>>2]|0)+440>>2]|0)}if(c[(c[w>>2]|0)+36>>2]|0){D=(c[p>>2]|0)+444|0;c[D>>2]=(c[D>>2]|0)+(c[(c[(c[w>>2]|0)+36>>2]|0)+36>>2]|0);D=(c[p>>2]|0)+444|0;c[D>>2]=(c[D>>2]|0)+((c[(c[(c[w>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[w>>2]|0)+36>>2]|0)+12>>2]|0))}if(c[(c[w>>2]|0)+388>>2]|0)Zd((c[w>>2]|0)+384|0,(c[p>>2]|0)+384|0)|0;if(c[q>>2]|0)c[c[w>>2]>>2]=c[z>>2];c[(c[p>>2]|0)+72>>2]=c[(c[w>>2]|0)+72>>2];c[(c[p>>2]|0)+76>>2]=c[(c[w>>2]|0)+76>>2];c[(c[p>>2]|0)+80>>2]=c[(c[w>>2]|0)+80>>2];c[(c[w>>2]|0)+72>>2]=0;c[(c[w>>2]|0)+76>>2]=0;c[(c[w>>2]|0)+80>>2]=0;Ae(c[w>>2]|0);c[(c[x>>2]|0)+44>>2]=0;c[(c[x>>2]|0)+48>>2]=0;Th(c[x>>2]|0);c[n>>2]=c[A>>2];F=c[n>>2]|0;i=m;return F|0}function Ug(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if(!(c[17530]|0)){i=e;return}Db[c[70120>>2]&511](c[f>>2]|0,c[g>>2]|0,c[h>>2]|0);i=e;return}function Vg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e;g=e+16|0;h=e+12|0;j=e+8|0;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+212>>2]|0)!=0:0)?(c[(c[g>>2]|0)+172>>2]|0)==-1:0){i=e;return}if(c[g>>2]|0)c[(c[g>>2]|0)+84>>2]=42;d=c[g>>2]|0;if(!(c[h>>2]|0)){b=c[j>>2]|0;c[f>>2]=c[j>>2];Xd(0,0,0,d,0,1,42,3,0,0,b,0,0,0,0,71848,f)}else{b=c[h>>2]|0;a=c[j>>2]|0;k=c[j>>2]|0;c[f>>2]=c[h>>2];c[f+4>>2]=k;Xd(0,0,0,d,0,1,42,3,0,0,b,a,0,0,0,71872,f)}if(!(c[g>>2]|0)){i=e;return}c[(c[g>>2]|0)+12>>2]=0;if(c[(c[g>>2]|0)+288>>2]|0){i=e;return}c[(c[g>>2]|0)+212>>2]=1;i=e;return}function Wg(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;if((c[(c[f>>2]|0)+292>>2]|0)==0?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[f>>2]|0);if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==47:0){b=(c[f>>2]|0)+200|0;c[b>>2]=(c[b>>2]|0)+2;b=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[b>>2]=(c[b>>2]|0)+2;b=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[b>>2]=(c[b>>2]|0)+2;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[f>>2]|0);if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[f>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[f>>2]|0)|0;c[h>>2]=mh(c[f>>2]|0,c[(c[f>>2]|0)+184>>2]|0)|0;if((c[(c[f>>2]|0)+292>>2]|0)==0?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[f>>2]|0);Ue(c[f>>2]|0)|0;if(9<=(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)j=19;else if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13?32>(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0):0)j=20;else j=19;if((j|0)==19)if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==62){b=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[b>>2]=(c[b>>2]|0)+1;b=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[b>>2]=(c[b>>2]|0)+1;b=(c[f>>2]|0)+200|0;c[b>>2]=(c[b>>2]|0)+1;if(!(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0))ke(c[(c[f>>2]|0)+36>>2]|0,250)|0}else j=20;if((j|0)==20)og(c[f>>2]|0,73,0);if((c[h>>2]|0)!=1){if(!(c[h>>2]|0))c[h>>2]=70752;$g(c[f>>2]|0,76,70768,c[(c[f>>2]|0)+184>>2]|0,c[g>>2]|0,c[h>>2]|0)}if(((c[c[f>>2]>>2]|0)!=0?(c[(c[c[f>>2]>>2]|0)+60>>2]|0)!=0:0)?(c[(c[f>>2]|0)+212>>2]|0)==0:0)Ab[c[(c[c[f>>2]>>2]|0)+60>>2]&511](c[(c[f>>2]|0)+4>>2]|0,c[(c[f>>2]|0)+184>>2]|0);Te(c[f>>2]|0)|0;Zg(c[f>>2]|0)|0;i=e;return;
}xg(c[f>>2]|0,74,71816);i=e;return}function Xg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;do if((c[(c[f>>2]|0)+236>>2]|0)>=(c[(c[f>>2]|0)+240>>2]|0)){b=(c[f>>2]|0)+240|0;c[b>>2]=c[b>>2]<<1;c[h>>2]=Hb[c[135760>>2]&511](c[(c[f>>2]|0)+244>>2]|0,c[(c[f>>2]|0)+240>>2]<<2)|0;if(c[h>>2]|0){c[(c[f>>2]|0)+244>>2]=c[h>>2];break}ie(c[f>>2]|0,0);b=(c[f>>2]|0)+240|0;c[b>>2]=(c[b>>2]|0)/2|0;c[e>>2]=-1;j=c[e>>2]|0;i=d;return j|0}while(0);c[(c[(c[f>>2]|0)+244>>2]|0)+(c[(c[f>>2]|0)+236>>2]<<2)>>2]=c[g>>2];c[(c[f>>2]|0)+232>>2]=(c[(c[f>>2]|0)+244>>2]|0)+(c[(c[f>>2]|0)+236>>2]<<2);g=(c[f>>2]|0)+236|0;f=c[g>>2]|0;c[g>>2]=f+1;c[e>>2]=f;j=c[e>>2]|0;i=d;return j|0}function Yg(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;g=i;i=i+144|0;h=g+132|0;j=g+128|0;k=g+124|0;l=g+120|0;m=g+116|0;n=g+112|0;o=g+108|0;p=g+104|0;q=g+100|0;r=g+96|0;s=g+92|0;t=g+88|0;u=g+84|0;v=g+80|0;w=g+76|0;x=g+72|0;y=g+68|0;z=g+64|0;A=g+60|0;B=g+56|0;C=g+52|0;D=g+48|0;E=g+44|0;F=g+40|0;G=g+36|0;H=g+32|0;I=g+28|0;J=g+24|0;K=g+20|0;L=g+16|0;M=g+12|0;N=g+8|0;O=g+4|0;P=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[t>>2]=c[(c[j>>2]|0)+300>>2];c[u>>2]=c[(c[j>>2]|0)+304>>2];c[G>>2]=c[(c[j>>2]|0)+328>>2];if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=60){c[h>>2]=0;Q=c[h>>2]|0;i=g;return Q|0}f=(c[(c[j>>2]|0)+36>>2]|0)+32|0;c[f>>2]=(c[f>>2]|0)+1;f=(c[(c[j>>2]|0)+36>>2]|0)+16|0;c[f>>2]=(c[f>>2]|0)+1;f=(c[j>>2]|0)+200|0;c[f>>2]=(c[f>>2]|0)+1;if(!(d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0))ke(c[(c[j>>2]|0)+36>>2]|0,250)|0;a:while(1){if(((c[(c[j>>2]|0)+292>>2]|0)==0?((c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500:0)?((c[(c[(c[j>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)Fg(c[j>>2]|0);c[E>>2]=c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2];c[F>>2]=(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2]|0);c[C>>2]=c[(c[(c[j>>2]|0)+36>>2]|0)+28>>2];c[D>>2]=c[(c[(c[j>>2]|0)+36>>2]|0)+32>>2];c[w>>2]=0;c[v>>2]=0;c[x>>2]=0;c[A>>2]=0;c[B>>2]=0;c[(c[j>>2]|0)+328>>2]=c[G>>2];c[n>>2]=nh(c[j>>2]|0,o)|0;R=c[j>>2]|0;if(!(c[n>>2]|0)){S=10;break}c[c[m>>2]>>2]=(c[(c[R+36>>2]|0)+16>>2]|0)-(c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2]|0)-(c[F>>2]|0);Ue(c[j>>2]|0)|0;if((c[(c[j>>2]|0)+292>>2]|0)==0?((c[(c[(c[j>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[j>>2]|0);b:do if((c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2]|0)==(c[E>>2]|0)){c:while(1){if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==62)break a;if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==47?(d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==62:0)break a;if(!(9<=(d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0))S=20;if(((S|0)==20?(S=0,(d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13):0)?32>(d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0):0)break a;if((c[(c[j>>2]|0)+172>>2]|0)==-1)break a;c[H>>2]=c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2];c[I>>2]=c[(c[(c[j>>2]|0)+36>>2]|0)+36>>2];c[J>>2]=-1;c[K>>2]=0;c[p>>2]=oh(c[j>>2]|0,c[o>>2]|0,c[n>>2]|0,q,s,J,K)|0;if((c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2]|0)!=(c[E>>2]|0))break;d:do if((c[p>>2]|0)!=0&(c[s>>2]|0)!=0){if((c[J>>2]|0)<0)c[J>>2]=xy(c[s>>2]|0)|0;if((c[q>>2]|0)==0?(c[p>>2]|0)==(c[(c[j>>2]|0)+316>>2]|0):0){c[L>>2]=AP(c[(c[j>>2]|0)+296>>2]|0,c[s>>2]|0,c[J>>2]|0)|0;if(!(c[L>>2]|0)){S=32;break a}do if(d[c[L>>2]>>0]|0){c[M>>2]=yl(c[L>>2]|0)|0;if(!(c[M>>2]|0))Jg(c[j>>2]|0,99,71016,c[L>>2]|0,0,0);else{if(!(c[c[M>>2]>>2]|0))ph(c[j>>2]|0,100,71048,c[L>>2]|0,0,0);Al(c[M>>2]|0)}if((c[L>>2]|0)==(c[(c[j>>2]|0)+320>>2]|0)){if((c[p>>2]|0)==(c[(c[j>>2]|0)+312>>2]|0))break;Jg(c[j>>2]|0,200,71080,0,0,0);break}if((c[J>>2]|0)!=29){S=47;break}if(!(qy(c[L>>2]|0,71136)|0)){S=47;break}Jg(c[j>>2]|0,200,71168,0,0,0)}else S=47;while(0);do if((S|0)==47){S=0;c[z>>2]=1;while(1){if((c[z>>2]|0)>(c[A>>2]|0))break;if(!(c[(c[(c[j>>2]|0)+336>>2]|0)+((c[(c[j>>2]|0)+328>>2]|0)-(c[z>>2]<<1)<<2)>>2]|0))break;c[z>>2]=(c[z>>2]|0)+1}f=c[j>>2]|0;if((c[z>>2]|0)<=(c[A>>2]|0)){Vg(f,0,c[p>>2]|0);break}if((ih(f,0,c[L>>2]|0)|0)<=0)break;c[A>>2]=(c[A>>2]|0)+1}while(0);if(c[K>>2]|0)zb[c[135736>>2]&511](c[s>>2]|0);if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==62)break a;if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==47?(d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==62:0)break a;do if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13){S=64;break a}}while(0);Ue(c[j>>2]|0)|0;continue c}if((c[q>>2]|0)!=(c[(c[j>>2]|0)+316>>2]|0)){if(!((c[t>>2]|0)!=0?((c[w>>2]|0)+5|0)<=(c[u>>2]|0):0))S=108;do if((S|0)==108){S=0;if((qh(c[j>>2]|0,(c[w>>2]|0)+5|0)|0)>=0){c[u>>2]=c[(c[j>>2]|0)+304>>2];c[t>>2]=c[(c[j>>2]|0)+300>>2];break}if(d[(c[s>>2]|0)+(c[J>>2]|0)>>0]|0)break d;zb[c[135736>>2]&511](c[s>>2]|0);break d}while(0);f=c[K>>2]|0;e=c[v>>2]|0;c[v>>2]=e+1;c[(c[(c[j>>2]|0)+340>>2]|0)+(e<<2)>>2]=f;f=c[p>>2]|0;e=c[w>>2]|0;c[w>>2]=e+1;c[(c[t>>2]|0)+(e<<2)>>2]=f;f=c[q>>2]|0;e=c[w>>2]|0;c[w>>2]=e+1;c[(c[t>>2]|0)+(e<<2)>>2]=f;f=c[w>>2]|0;c[w>>2]=f+1;c[(c[t>>2]|0)+(f<<2)>>2]=0;f=c[s>>2]|0;e=c[w>>2]|0;c[w>>2]=e+1;c[(c[t>>2]|0)+(e<<2)>>2]=f;c[s>>2]=(c[s>>2]|0)+(c[J>>2]|0);f=c[s>>2]|0;e=c[w>>2]|0;c[w>>2]=e+1;c[(c[t>>2]|0)+(e<<2)>>2]=f;if(!(c[K>>2]|0))break;c[B>>2]=1;break}c[N>>2]=AP(c[(c[j>>2]|0)+296>>2]|0,c[s>>2]|0,c[J>>2]|0)|0;f=c[N>>2]|0;e=c[(c[j>>2]|0)+320>>2]|0;e:do if((c[p>>2]|0)==(c[(c[j>>2]|0)+312>>2]|0)){if((f|0)==(e|0))break;Jg(c[j>>2]|0,200,71216,0,0,0)}else{b=c[p>>2]|0;a=c[j>>2]|0;if((f|0)==(e|0)){if((b|0)==(c[a+312>>2]|0))break;Jg(c[j>>2]|0,200,71264,0,0,0);break}if((b|0)==(c[a+316>>2]|0)){Jg(c[j>>2]|0,200,71312,0,0,0);break}do if((c[J>>2]|0)==29){if(!(qy(c[N>>2]|0,71136)|0))break;Jg(c[j>>2]|0,200,71168,0,0,0);break e}while(0);do if(c[N>>2]|0){if(!(d[c[N>>2]>>0]|0))break;c[O>>2]=yl(c[N>>2]|0)|0;a=c[j>>2]|0;if(!(c[O>>2]|0))Jg(a,99,71408,c[p>>2]|0,c[N>>2]|0,0);else{do if(c[a+268>>2]|0){if(c[c[O>>2]>>2]|0)break;ph(c[j>>2]|0,100,71448,c[p>>2]|0,c[N>>2]|0,0)}while(0);Al(c[O>>2]|0)}c[z>>2]=1;while(1){if((c[z>>2]|0)>(c[A>>2]|0))break;if((c[(c[(c[j>>2]|0)+336>>2]|0)+((c[(c[j>>2]|0)+328>>2]|0)-(c[z>>2]<<1)<<2)>>2]|0)==(c[p>>2]|0))break;c[z>>2]=(c[z>>2]|0)+1}a=c[j>>2]|0;if((c[z>>2]|0)<=(c[A>>2]|0)){Vg(a,c[q>>2]|0,c[p>>2]|0);break e}if((ih(a,c[p>>2]|0,c[N>>2]|0)|0)<=0)break e;c[A>>2]=(c[A>>2]|0)+1;break e}while(0);Jg(c[j>>2]|0,200,71360,c[p>>2]|0,0,0)}while(0);if(c[K>>2]|0)zb[c[135736>>2]&511](c[s>>2]|0);if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==62)break a;if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==47?(d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==62:0)break a;do if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13){S=104;break a}}while(0);Ue(c[j>>2]|0)|0;if((c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2]|0)!=(c[E>>2]|0))break b;else continue c}else if((c[s>>2]|0)!=0?(d[(c[s>>2]|0)+(c[J>>2]|0)>>0]|0|0)==0:0)zb[c[135736>>2]&511](c[s>>2]|0);while(0);if((c[(c[j>>2]|0)+292>>2]|0)==0?((c[(c[(c[j>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[j>>2]|0);if((c[(c[j>>2]|0)+172>>2]|0)==-1)break a;if((c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2]|0)!=(c[E>>2]|0))break b;if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==62)break a;if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==47?(d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==62:0)break a;do if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13){S=129;break a}}while(0);Ue(c[j>>2]|0)|0;if((c[I>>2]|0)==(c[(c[(c[j>>2]|0)+36>>2]|0)+36>>2]|0)?((c[p>>2]|0)==0?(c[H>>2]|0)==(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0):0)&(c[s>>2]|0)==0:0){S=132;break a}do if(!(c[(c[j>>2]|0)+292>>2]|0)){if(((c[(c[(c[j>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=250)break;vg(c[j>>2]|0)}while(0);if((c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2]|0)!=(c[E>>2]|0))break b}if((c[s>>2]|0)!=0&(c[K>>2]|0)!=0)zb[c[135736>>2]&511](c[s>>2]|0);c[s>>2]=0}while(0);f:do if(c[B>>2]|0){c[y>>2]=3;c[z>>2]=0;while(1){if((c[z>>2]|0)>=(c[v>>2]|0))break f;if((c[(c[(c[j>>2]|0)+340>>2]|0)+(c[z>>2]<<2)>>2]|0)!=0?(c[(c[t>>2]|0)+(c[y>>2]<<2)>>2]|0)!=0:0)zb[c[135736>>2]&511](c[(c[t>>2]|0)+(c[y>>2]<<2)>>2]|0);c[y>>2]=(c[y>>2]|0)+5;c[z>>2]=(c[z>>2]|0)+1}}while(0);c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]=(c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2]|0)+(c[F>>2]|0);c[(c[(c[j>>2]|0)+36>>2]|0)+28>>2]=c[C>>2];c[(c[(c[j>>2]|0)+36>>2]|0)+32>>2]=c[D>>2];if((c[(c[j>>2]|0)+12>>2]|0)!=1){S=219;break}}if((S|0)==10){xg(R,68,70952);c[h>>2]=0;Q=c[h>>2]|0;i=g;return Q|0}else if((S|0)==32){ie(c[j>>2]|0,70984);if((c[s>>2]|0)!=0&(c[K>>2]|0)!=0)zb[c[135736>>2]&511](c[s>>2]|0);c[h>>2]=0;Q=c[h>>2]|0;i=g;return Q|0}else if((S|0)==64)xg(c[j>>2]|0,65,69320);else if((S|0)==104)xg(c[j>>2]|0,65,69320);else if((S|0)==129)xg(c[j>>2]|0,65,69320);else if((S|0)==132)og(c[j>>2]|0,1,69352);else if((S|0)==219){c[h>>2]=0;Q=c[h>>2]|0;i=g;return Q|0}g:do if((c[(c[j>>2]|0)+348>>2]|0)!=0?(c[P>>2]=Tj(c[(c[j>>2]|0)+348>>2]|0,c[n>>2]|0,c[o>>2]|0)|0,(c[P>>2]|0)!=0):0){c[y>>2]=0;h:while(1){if((c[y>>2]|0)>=(c[c[P>>2]>>2]|0))break g;c[p>>2]=c[(c[P>>2]|0)+8+((c[y>>2]|0)*5<<2)>>2];c[q>>2]=c[(c[P>>2]|0)+8+(((c[y>>2]|0)*5|0)+1<<2)>>2];do if((c[q>>2]|0)==0?(c[p>>2]|0)==(c[(c[j>>2]|0)+316>>2]|0):0){c[z>>2]=1;while(1){if((c[z>>2]|0)>(c[A>>2]|0))break;if(!(c[(c[(c[j>>2]|0)+336>>2]|0)+((c[(c[j>>2]|0)+328>>2]|0)-(c[z>>2]<<1)<<2)>>2]|0))break;c[z>>2]=(c[z>>2]|0)+1}if(((c[z>>2]|0)>(c[A>>2]|0)?(c[r>>2]=hh(c[j>>2]|0,0)|0,(c[r>>2]|0)!=(c[(c[P>>2]|0)+8+(((c[y>>2]|0)*5|0)+2<<2)>>2]|0)):0)?(ih(c[j>>2]|0,0,c[(c[P>>2]|0)+8+(((c[y>>2]|0)*5|0)+2<<2)>>2]|0)|0)>0:0)c[A>>2]=(c[A>>2]|0)+1}else{if((c[q>>2]|0)==(c[(c[j>>2]|0)+316>>2]|0)){c[z>>2]=1;while(1){if((c[z>>2]|0)>(c[A>>2]|0))break;if((c[(c[(c[j>>2]|0)+336>>2]|0)+((c[(c[j>>2]|0)+328>>2]|0)-(c[z>>2]<<1)<<2)>>2]|0)==(c[p>>2]|0))break;c[z>>2]=(c[z>>2]|0)+1}if((c[z>>2]|0)<=(c[A>>2]|0))break;c[r>>2]=hh(c[j>>2]|0,c[p>>2]|0)|0;if((c[r>>2]|0)==(c[(c[P>>2]|0)+16>>2]|0))break;if((ih(c[j>>2]|0,c[p>>2]|0,c[(c[P>>2]|0)+8+(((c[y>>2]|0)*5|0)+2<<2)>>2]|0)|0)<=0)break;c[A>>2]=(c[A>>2]|0)+1;break}c[z>>2]=0;while(1){if((c[z>>2]|0)>=(c[w>>2]|0))break;if((c[p>>2]|0)==(c[(c[t>>2]|0)+(c[z>>2]<<2)>>2]|0)?(c[q>>2]|0)==(c[(c[t>>2]|0)+((c[z>>2]|0)+1<<2)>>2]|0):0)break;c[z>>2]=(c[z>>2]|0)+5}if((c[z>>2]|0)>=(c[w>>2]|0)){if(!((c[t>>2]|0)!=0?((c[w>>2]|0)+5|0)<=(c[u>>2]|0):0)){if((qh(c[j>>2]|0,(c[w>>2]|0)+5|0)|0)<0)break h;c[u>>2]=c[(c[j>>2]|0)+304>>2];c[t>>2]=c[(c[j>>2]|0)+300>>2]}s=c[p>>2]|0;K=c[w>>2]|0;c[w>>2]=K+1;c[(c[t>>2]|0)+(K<<2)>>2]=s;s=c[q>>2]|0;K=c[w>>2]|0;c[w>>2]=K+1;c[(c[t>>2]|0)+(K<<2)>>2]=s;if(!(c[q>>2]|0)){s=c[w>>2]|0;c[w>>2]=s+1;c[(c[t>>2]|0)+(s<<2)>>2]=0}else{s=hh(c[j>>2]|0,c[q>>2]|0)|0;K=c[w>>2]|0;c[w>>2]=K+1;c[(c[t>>2]|0)+(K<<2)>>2]=s}s=c[(c[P>>2]|0)+8+(((c[y>>2]|0)*5|0)+2<<2)>>2]|0;K=c[w>>2]|0;c[w>>2]=K+1;c[(c[t>>2]|0)+(K<<2)>>2]=s;s=c[(c[P>>2]|0)+8+(((c[y>>2]|0)*5|0)+3<<2)>>2]|0;K=c[w>>2]|0;c[w>>2]=K+1;c[(c[t>>2]|0)+(K<<2)>>2]=s;if((c[(c[j>>2]|0)+28>>2]|0)==1?(c[(c[P>>2]|0)+8+(((c[y>>2]|0)*5|0)+4<<2)>>2]|0)!=0:0)qg(c[j>>2]|0,538,71488,c[p>>2]|0,c[n>>2]|0);c[x>>2]=(c[x>>2]|0)+1}}while(0);c[y>>2]=(c[y>>2]|0)+1}c[h>>2]=0;Q=c[h>>2]|0;i=g;return Q|0}while(0);c[y>>2]=0;while(1){if((c[y>>2]|0)>=(c[w>>2]|0))break;if(c[(c[t>>2]|0)+((c[y>>2]|0)+1<<2)>>2]|0){c[r>>2]=hh(c[j>>2]|0,c[(c[t>>2]|0)+((c[y>>2]|0)+1<<2)>>2]|0)|0;if(!(c[r>>2]|0))Jg(c[j>>2]|0,201,71552,c[(c[t>>2]|0)+((c[y>>2]|0)+1<<2)>>2]|0,c[(c[t>>2]|0)+(c[y>>2]<<2)>>2]|0,c[n>>2]|0);c[(c[t>>2]|0)+((c[y>>2]|0)+2<<2)>>2]=c[r>>2]}else c[r>>2]=0;c[z>>2]=0;while(1){if((c[z>>2]|0)>=(c[y>>2]|0))break;if((c[(c[t>>2]|0)+(c[y>>2]<<2)>>2]|0)==(c[(c[t>>2]|0)+(c[z>>2]<<2)>>2]|0)){if((c[(c[t>>2]|0)+((c[y>>2]|0)+1<<2)>>2]|0)==(c[(c[t>>2]|0)+((c[z>>2]|0)+1<<2)>>2]|0)){S=189;break}if((c[r>>2]|0)!=0?(c[(c[t>>2]|0)+((c[z>>2]|0)+2<<2)>>2]|0)==(c[r>>2]|0):0){S=192;break}}c[z>>2]=(c[z>>2]|0)+5}if((S|0)==189){S=0;Vg(c[j>>2]|0,c[(c[t>>2]|0)+((c[y>>2]|0)+1<<2)>>2]|0,c[(c[t>>2]|0)+(c[y>>2]<<2)>>2]|0)}else if((S|0)==192){S=0;Jg(c[j>>2]|0,203,71608,c[(c[t>>2]|0)+(c[y>>2]<<2)>>2]|0,c[r>>2]|0,0)}c[y>>2]=(c[y>>2]|0)+5}c[r>>2]=hh(c[j>>2]|0,c[o>>2]|0)|0;if((c[o>>2]|0)!=0&(c[r>>2]|0)==0)Jg(c[j>>2]|0,201,71656,c[o>>2]|0,c[n>>2]|0,0);c[c[k>>2]>>2]=c[o>>2];c[c[l>>2]>>2]=c[r>>2];do if(((c[c[j>>2]>>2]|0)!=0?(c[(c[c[j>>2]>>2]|0)+116>>2]|0)!=0:0)?(c[(c[j>>2]|0)+212>>2]|0)==0:0){l=c[(c[c[j>>2]>>2]|0)+116>>2]|0;k=c[(c[j>>2]|0)+4>>2]|0;S=c[n>>2]|0;p=c[o>>2]|0;P=c[r>>2]|0;if((c[A>>2]|0)>0){Eb[l&511](k,S,p,P,c[A>>2]|0,(c[(c[j>>2]|0)+336>>2]|0)+((c[(c[j>>2]|0)+328>>2]|0)-(c[A>>2]<<1)<<2)|0,(c[w>>2]|0)/5|0,c[x>>2]|0,c[t>>2]|0);break}else{Eb[l&511](k,S,p,P,0,0,(c[w>>2]|0)/5|0,c[x>>2]|0,c[t>>2]|0);break}}while(0);i:do if(c[B>>2]|0){c[y>>2]=3;c[z>>2]=0;while(1){if((c[z>>2]|0)>=(c[v>>2]|0))break i;if((c[(c[(c[j>>2]|0)+340>>2]|0)+(c[z>>2]<<2)>>2]|0)!=0?(c[(c[t>>2]|0)+(c[y>>2]<<2)>>2]|0)!=0:0)zb[c[135736>>2]&511](c[(c[t>>2]|0)+(c[y>>2]<<2)>>2]|0);c[y>>2]=(c[y>>2]|0)+5;c[z>>2]=(c[z>>2]|0)+1}}while(0);c[h>>2]=c[n>>2];Q=c[h>>2]|0;i=g;return Q|0}function Zg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if((c[(c[e>>2]|0)+236>>2]|0)<=0){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}a=(c[e>>2]|0)+236|0;c[a>>2]=(c[a>>2]|0)+-1;a=c[e>>2]|0;if((c[(c[e>>2]|0)+236>>2]|0)>0)c[(c[e>>2]|0)+232>>2]=(c[(c[e>>2]|0)+244>>2]|0)+((c[a+236>>2]|0)-1<<2);else c[(c[e>>2]|0)+232>>2]=c[a+244>>2];c[f>>2]=c[(c[(c[e>>2]|0)+244>>2]|0)+(c[(c[e>>2]|0)+236>>2]<<2)>>2];c[(c[(c[e>>2]|0)+244>>2]|0)+(c[(c[e>>2]|0)+236>>2]<<2)>>2]=-1;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}function _g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;c[g>>2]=a;c[h>>2]=b;if(!(c[(c[g>>2]|0)+336>>2]|0)){c[f>>2]=0;k=c[f>>2]|0;i=d;return k|0}if((c[(c[g>>2]|0)+328>>2]|0)<(c[h>>2]|0)){b=c[33976]|0;a=c[33980]|0;c[e>>2]=c[h>>2];Db[b&511](a,70928,e);c[h>>2]=c[(c[g>>2]|0)+328>>2]}if((c[(c[g>>2]|0)+328>>2]|0)<=0){c[f>>2]=0;k=c[f>>2]|0;i=d;return k|0}c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[h>>2]|0))break;e=(c[g>>2]|0)+328|0;c[e>>2]=(c[e>>2]|0)+-1;c[(c[(c[g>>2]|0)+336>>2]|0)+(c[(c[g>>2]|0)+328>>2]<<2)>>2]=0;c[j>>2]=(c[j>>2]|0)+1}c[f>>2]=c[h>>2];k=c[f>>2]|0;i=d;return k|0}function $g(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+48|0;j=h;k=h+32|0;l=h+28|0;m=h+24|0;n=h+20|0;o=h+16|0;p=h+12|0;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;if(((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+212>>2]|0)!=0:0)?(c[(c[k>>2]|0)+172>>2]|0)==-1:0){i=h;return}if(c[k>>2]|0)c[(c[k>>2]|0)+84>>2]=c[l>>2];g=c[k>>2]|0;f=c[l>>2]|0;l=c[n>>2]|0;e=c[p>>2]|0;d=c[o>>2]|0;b=c[m>>2]|0;m=c[o>>2]|0;o=c[p>>2]|0;c[j>>2]=c[n>>2];c[j+4>>2]=m;c[j+8>>2]=o;Xd(0,0,0,g,0,1,f,3,0,0,l,e,0,d,0,b,j);if(!(c[k>>2]|0)){i=h;return}c[(c[k>>2]|0)+12>>2]=0;if(c[(c[k>>2]|0)+288>>2]|0){i=h;return}c[(c[k>>2]|0)+212>>2]=1;i=h;return}function ah(a,b,f,g,h,j){a=a|0;b=b|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=i;i=i+32|0;l=k+24|0;m=k+20|0;n=k+16|0;o=k+12|0;p=k+8|0;q=k+4|0;r=k;c[l>>2]=a;c[m>>2]=b;c[n>>2]=f;c[o>>2]=g;c[p>>2]=h;c[q>>2]=j;if((c[(c[l>>2]|0)+292>>2]|0)==0?((c[(c[(c[l>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[l>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[l>>2]|0);if((d[c[(c[(c[l>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(d[(c[(c[(c[l>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==47:0){j=(c[l>>2]|0)+200|0;c[j>>2]=(c[j>>2]|0)+2;j=(c[(c[l>>2]|0)+36>>2]|0)+16|0;c[j>>2]=(c[j>>2]|0)+2;j=(c[(c[l>>2]|0)+36>>2]|0)+32|0;c[j>>2]=(c[j>>2]|0)+2;if((d[c[(c[(c[l>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[l>>2]|0);if((d[c[(c[(c[l>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[l>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[l>>2]|0)|0;do if((c[q>>2]|0)>0?(sy(c[(c[(c[l>>2]|0)+36>>2]|0)+16>>2]|0,c[(c[l>>2]|0)+184>>2]|0,c[q>>2]|0)|0)==0:0){j=c[q>>2]|0;if((d[(c[(c[(c[l>>2]|0)+36>>2]|0)+16>>2]|0)+(c[q>>2]|0)>>0]|0|0)==62){h=(c[(c[l>>2]|0)+36>>2]|0)+16|0;c[h>>2]=(c[h>>2]|0)+(j+1);h=(c[(c[l>>2]|0)+36>>2]|0)+32|0;c[h>>2]=(c[h>>2]|0)+((c[q>>2]|0)+1);break}else{h=(c[(c[l>>2]|0)+36>>2]|0)+16|0;c[h>>2]=(c[h>>2]|0)+j;j=(c[(c[l>>2]|0)+36>>2]|0)+32|0;c[j>>2]=(c[j>>2]|0)+(c[q>>2]|0);c[r>>2]=1;s=20;break}}else s=17;while(0);do if((s|0)==17){q=c[l>>2]|0;j=c[(c[l>>2]|0)+184>>2]|0;if(!(c[m>>2]|0)){c[r>>2]=mh(q,j)|0;s=20;break}else{c[r>>2]=rh(q,j,c[m>>2]|0)|0;s=20;break}}while(0);if((s|0)==20){if((c[(c[l>>2]|0)+292>>2]|0)==0?((c[(c[(c[l>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[l>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[l>>2]|0);if((c[(c[l>>2]|0)+172>>2]|0)==-1){i=k;return}Ue(c[l>>2]|0)|0;if(9<=(d[c[(c[(c[l>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[l>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)s=28;else if((d[c[(c[(c[l>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13?32>(d[c[(c[(c[l>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0):0)s=29;else s=28;if((s|0)==28)if((d[c[(c[(c[l>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==62){j=(c[(c[l>>2]|0)+36>>2]|0)+32|0;c[j>>2]=(c[j>>2]|0)+1;j=(c[(c[l>>2]|0)+36>>2]|0)+16|0;c[j>>2]=(c[j>>2]|0)+1;j=(c[l>>2]|0)+200|0;c[j>>2]=(c[j>>2]|0)+1;if(!(d[c[(c[(c[l>>2]|0)+36>>2]|0)+16>>2]>>0]|0))ke(c[(c[l>>2]|0)+36>>2]|0,250)|0}else s=29;if((s|0)==29)og(c[l>>2]|0,73,0);if((c[r>>2]|0)!=1){if(!(c[r>>2]|0))c[r>>2]=70752;if((c[o>>2]|0)==0?(c[(c[l>>2]|0)+52>>2]|0)!=0:0)c[o>>2]=e[(c[(c[l>>2]|0)+52>>2]|0)+56>>1];$g(c[l>>2]|0,76,70768,c[(c[l>>2]|0)+184>>2]|0,c[o>>2]|0,c[r>>2]|0)}}if(((c[c[l>>2]>>2]|0)!=0?(c[(c[c[l>>2]>>2]|0)+120>>2]|0)!=0:0)?(c[(c[l>>2]|0)+212>>2]|0)==0:0)Jb[c[(c[c[l>>2]>>2]|0)+120>>2]&511](c[(c[l>>2]|0)+4>>2]|0,c[(c[l>>2]|0)+184>>2]|0,c[m>>2]|0,c[n>>2]|0);Zg(c[l>>2]|0)|0;if(!(c[p>>2]|0)){i=k;return}_g(c[l>>2]|0,c[p>>2]|0)|0;i=k;return}og(c[l>>2]|0,74,0);i=k;return}function bh(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+16|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==91){c[(c[e>>2]|0)+172>>2]=3;me(c[e>>2]|0);while(1){if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==93)break;if((c[(c[e>>2]|0)+172>>2]|0)==-1)break;c[f>>2]=c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2];c[g>>2]=c[(c[(c[e>>2]|0)+36>>2]|0)+36>>2];Ue(c[e>>2]|0)|0;yf(c[e>>2]|0);zf(c[e>>2]|0);while(1){if(!(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0))h=(c[(c[e>>2]|0)+40>>2]|0)>1;else h=0;j=c[e>>2]|0;if(!h)break;Ve(j)|0}if((c[(c[j+36>>2]|0)+16>>2]|0)!=(c[f>>2]|0))continue;if((c[g>>2]|0)==(c[(c[(c[e>>2]|0)+36>>2]|0)+36>>2]|0)){k=12;break}}if((k|0)==12)og(c[e>>2]|0,1,70688);if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==93){me(c[e>>2]|0);Ue(c[e>>2]|0)|0}}if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==62){l=c[e>>2]|0;me(l);i=b;return}og(c[e>>2]|0,61,0);l=c[e>>2]|0;me(l);i=b;return}function ch(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[(c[d>>2]|0)+352>>2]|0)){i=b;return}Xj(c[(c[d>>2]|0)+352>>2]|0,228,c[d>>2]|0);if($j(c[(c[d>>2]|0)+352>>2]|0)|0){i=b;return}Kj(c[(c[d>>2]|0)+352>>2]|0,0);c[(c[d>>2]|0)+352>>2]=0;i=b;return}function dh(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;f=i;i=i+288|0;g=f;h=f+124|0;j=f+120|0;k=f+116|0;l=f+112|0;m=f+108|0;n=f+104|0;o=f+285|0;p=f+284|0;q=f+100|0;r=f+96|0;s=f+92|0;t=f+88|0;u=f+280|0;v=f+84|0;w=f+80|0;x=f+76|0;y=f+72|0;z=f+68|0;A=f+64|0;B=f+60|0;C=f+56|0;D=f+52|0;E=f+48|0;F=f+44|0;G=f+40|0;H=f+36|0;I=f+32|0;J=f+28|0;K=f+24|0;L=f+278|0;M=f+20|0;N=f+16|0;O=f+128|0;c[j>>2]=b;c[k>>2]=e;c[l>>2]=0;if(!(c[(c[j>>2]|0)+36>>2]|0)){c[h>>2]=0;P=c[h>>2]|0;i=f;return P|0}if((c[(c[j>>2]|0)+36>>2]|0)!=0?((c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2]|0)|0)>4096:0){Fg(c[j>>2]|0);c[(c[j>>2]|0)+204>>2]=0}th(c[j>>2]|0,q,r);a:while(1){if((c[(c[j>>2]|0)+172>>2]|0)==-1){Q=407;break}if((c[(c[j>>2]|0)+84>>2]|0)!=0?(c[(c[j>>2]|0)+212>>2]|0)==1:0){Q=10;break}while(1){if(!(d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0))R=(c[(c[j>>2]|0)+40>>2]|0)>1;else R=0;S=c[j>>2]|0;if(!R)break;Ve(S)|0}if(!(c[S+36>>2]|0)){Q=407;break}e=c[j>>2]|0;if(!(c[c[(c[j>>2]|0)+36>>2]>>2]|0))c[m>>2]=(c[(c[e+36>>2]|0)+24>>2]|0)-((c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2]|0));else{if(((c[e+172>>2]|0)!=0?(c[(c[c[(c[j>>2]|0)+36>>2]>>2]|0)+20>>2]|0)!=0:0)?(az(c[(c[c[(c[j>>2]|0)+36>>2]>>2]|0)+20>>2]|0)|0)==0:0){c[s>>2]=jz(c[(c[c[(c[j>>2]|0)+36>>2]>>2]|0)+16>>2]|0,c[(c[j>>2]|0)+36>>2]|0)|0;c[t>>2]=(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2]|0);Lk(c[c[(c[j>>2]|0)+36>>2]>>2]|0,0,65640)|0;kz(c[(c[c[(c[j>>2]|0)+36>>2]>>2]|0)+16>>2]|0,c[(c[j>>2]|0)+36>>2]|0,c[s>>2]|0,c[t>>2]|0)|0}e=_y(c[(c[c[(c[j>>2]|0)+36>>2]>>2]|0)+16>>2]|0)|0;c[m>>2]=e-((c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2]|0))}if((c[m>>2]|0)<1){Q=407;break}do switch(c[(c[j>>2]|0)+172>>2]|0){case 1:{Ue(c[j>>2]|0)|0;e=c[(c[j>>2]|0)+36>>2]|0;if(!(c[c[(c[j>>2]|0)+36>>2]>>2]|0))c[m>>2]=(c[e+24>>2]|0)-((c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2]|0));else{b=_y(c[(c[e>>2]|0)+16>>2]|0)|0;c[m>>2]=b-((c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2]|0))}if((c[m>>2]|0)<2){Q=407;break a}a[o>>0]=a[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0;a[p>>0]=a[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0;if((d[o>>0]|0|0)==60?(d[p>>0]|0|0)==63:0){if((c[k>>2]|0)==0?(uh(c[j>>2]|0,63,62,0)|0)<0:0){Q=265;break a}mf(c[j>>2]|0);if((c[(c[j>>2]|0)+172>>2]|0)==-1){Q=407;break a}c[(c[j>>2]|0)+172>>2]=1;c[(c[j>>2]|0)+292>>2]=1;c[(c[j>>2]|0)+204>>2]=0;continue a}if((((d[o>>0]|0|0)==60?(d[p>>0]|0|0)==33:0)?(d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==45:0)?(d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==45:0){if((c[k>>2]|0)==0?(uh(c[j>>2]|0,45,45,62)|0)<0:0){Q=274;break a}kf(c[j>>2]|0);if((c[(c[j>>2]|0)+172>>2]|0)==-1){Q=407;break a}c[(c[j>>2]|0)+172>>2]=1;c[(c[j>>2]|0)+292>>2]=1;c[(c[j>>2]|0)+204>>2]=0;continue a}do if((((((d[o>>0]|0|0)==60?(d[p>>0]|0|0)==33:0)?(d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==68:0)?(d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==79:0)?(d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)==67:0)?(d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)==84:0){if((d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)!=89)break;if((d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0|0)!=80)break;if((d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+8>>0]|0|0)!=69)break;if((c[k>>2]|0)==0?(uh(c[j>>2]|0,62,0,0)|0)<0:0){Q=288;break a}c[(c[j>>2]|0)+216>>2]=1;c[(c[j>>2]|0)+292>>2]=0;c[(c[j>>2]|0)+204>>2]=0;Ff(c[j>>2]|0);if((c[(c[j>>2]|0)+172>>2]|0)==-1){Q=407;break a}b=c[j>>2]|0;if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==91){c[b+172>>2]=3;continue a}c[b+216>>2]=2;do if(c[c[j>>2]>>2]|0){if(c[(c[j>>2]|0)+212>>2]|0)break;if(!(c[(c[c[j>>2]>>2]|0)+104>>2]|0))break;Jb[c[(c[c[j>>2]>>2]|0)+104>>2]&511](c[(c[j>>2]|0)+4>>2]|0,c[(c[j>>2]|0)+220>>2]|0,c[(c[j>>2]|0)+228>>2]|0,c[(c[j>>2]|0)+224>>2]|0)}while(0);c[(c[j>>2]|0)+216>>2]=0;ch(c[j>>2]|0);c[(c[j>>2]|0)+172>>2]=4;continue a}while(0);if((d[o>>0]|0|0)==60?(d[p>>0]|0|0)==33&(c[m>>2]|0)<9:0){Q=407;break a}c[(c[j>>2]|0)+172>>2]=6;c[(c[j>>2]|0)+292>>2]=6;th(c[j>>2]|0,q,r);continue a;break}case 9:{if((c[m>>2]|0)<2){Q=407;break a}do if(!(c[k>>2]|0)){if(!(c[(c[j>>2]|0)+292>>2]|0))if((uh(c[j>>2]|0,62,0,0)|0)<0){Q=407;break a}else break;if(!(c[r>>2]|0)){Q=407;break a}if((c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)>>>0>=(c[r>>2]|0)>>>0){Q=407;break a}}while(0);b=c[j>>2]|0;if(c[(c[j>>2]|0)+324>>2]|0){ah(b,c[(c[(c[j>>2]|0)+344>>2]|0)+(((c[(c[j>>2]|0)+188>>2]|0)*3|0)-3<<2)>>2]|0,c[(c[(c[j>>2]|0)+344>>2]|0)+(((c[(c[j>>2]|0)+188>>2]|0)*3|0)-2<<2)>>2]|0,0,c[(c[(c[j>>2]|0)+344>>2]|0)+(((c[(c[j>>2]|0)+188>>2]|0)*3|0)-1<<2)>>2]|0,0);wh(c[j>>2]|0)|0}else Wg(b,0);if((c[(c[j>>2]|0)+172>>2]|0)==-1)continue a;b=(c[j>>2]|0)+172|0;if(!(c[(c[j>>2]|0)+188>>2]|0)){c[b>>2]=14;continue a}else{c[b>>2]=7;continue a}break}case 8:{c[D>>2]=uh(c[j>>2]|0,93,93,62)|0;if((c[D>>2]|0)<0){Q=207;break a}c[G>>2]=xh(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0,c[D>>2]|0)|0;if((c[G>>2]|0)<0){Q=231;break a}if((c[G>>2]|0)!=(c[D>>2]|0)){Q=231;break a}if((((c[D>>2]|0)==0?(c[c[j>>2]>>2]|0)!=0:0)?(c[(c[c[j>>2]>>2]|0)+100>>2]|0)!=0:0)?(c[(c[j>>2]|0)+212>>2]|0)==0:0){if(((c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2]|0)|0)>=9?(QT((c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+-9|0,70176,9)|0)==0:0)Db[c[(c[c[j>>2]>>2]|0)+100>>2]&511](c[(c[j>>2]|0)+4>>2]|0,65640,0)}else Q=238;do if(((Q|0)==238?(Q=0,(c[D>>2]|0)>0?(c[c[j>>2]>>2]|0)!=0:0):0)?(c[(c[j>>2]|0)+212>>2]|0)==0:0){b=c[c[j>>2]>>2]|0;if(c[(c[c[j>>2]>>2]|0)+100>>2]|0){Db[c[b+100>>2]&511](c[(c[j>>2]|0)+4>>2]|0,c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0,c[D>>2]|0);break}if(c[b+68>>2]|0)Db[c[(c[c[j>>2]>>2]|0)+68>>2]&511](c[(c[j>>2]|0)+4>>2]|0,c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0,c[D>>2]|0)}while(0);if((c[(c[j>>2]|0)+172>>2]|0)==-1){Q=407;break a}c[H>>2]=0;while(1){T=d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0;if((c[H>>2]|0)>=((c[D>>2]|0)+3|0))break;b=c[(c[j>>2]|0)+36>>2]|0;if((T|0)==10){e=b+28|0;c[e>>2]=(c[e>>2]|0)+1;c[(c[(c[j>>2]|0)+36>>2]|0)+32>>2]=1}else{e=b+32|0;c[e>>2]=(c[e>>2]|0)+1}e=(c[j>>2]|0)+200|0;c[e>>2]=(c[e>>2]|0)+1;e=(c[(c[j>>2]|0)+36>>2]|0)+16|0;c[e>>2]=(c[e>>2]|0)+1;c[H>>2]=(c[H>>2]|0)+1}if((T|0)==37)We(c[j>>2]|0);if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[j>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[j>>2]|0)|0;c[(c[j>>2]|0)+204>>2]=0;c[(c[j>>2]|0)+172>>2]=7;continue a;break}case 0:{e=c[m>>2]|0;if(!(c[(c[j>>2]|0)+256>>2]|0)){if((e|0)<4){Q=407;break a}a[u>>0]=a[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0;a[u+1>>0]=a[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0;a[u+2>>0]=a[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0;a[u+3>>0]=a[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0;c[v>>2]=sd(u,4)|0;re(c[j>>2]|0,c[v>>2]|0)|0;continue a}if((e|0)<2){Q=407;break a}a[o>>0]=a[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0;a[p>>0]=a[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0;if(!(d[o>>0]|0)){Q=30;break a}if((d[o>>0]|0|0)==60?(d[p>>0]|0|0)==63:0){if((c[m>>2]|0)<5){Q=39;break a}if((c[k>>2]|0)==0?(uh(c[j>>2]|0,63,62,0)|0)<0:0){Q=42;break a}if((c[c[j>>2]>>2]|0)!=0?(c[(c[c[j>>2]>>2]|0)+44>>2]|0)!=0:0)Ab[c[(c[c[j>>2]>>2]|0)+44>>2]&511](c[(c[j>>2]|0)+4>>2]|0,136080);b:do if((d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==120){if((d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)!=109)break;if((d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)!=108)break;do if((d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=32){if(9<=(d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)?(d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)<=10:0)break;if((d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=13)break b}while(0);c[l>>2]=(c[l>>2]|0)+5;Of(c[j>>2]|0);U=c[j>>2]|0;if((c[(c[j>>2]|0)+84>>2]|0)==32){Q=54;break a}c[(c[j>>2]|0)+28>>2]=c[(c[U+36>>2]|0)+52>>2];do if(!(c[(c[j>>2]|0)+24>>2]|0)){if(!(c[(c[(c[j>>2]|0)+36>>2]|0)+44>>2]|0))break;e=my(c[(c[(c[j>>2]|0)+36>>2]|0)+44>>2]|0)|0;c[(c[j>>2]|0)+24>>2]=e}while(0);do if(c[c[j>>2]>>2]|0){if(!(c[(c[c[j>>2]>>2]|0)+48>>2]|0))break;if(c[(c[j>>2]|0)+212>>2]|0)break;zb[c[(c[c[j>>2]>>2]|0)+48>>2]&511](c[(c[j>>2]|0)+4>>2]|0)}while(0);c[(c[j>>2]|0)+172>>2]=1;continue a}while(0);e=oy(68488)|0;c[(c[j>>2]|0)+20>>2]=e;do if(c[c[j>>2]>>2]|0){if(!(c[(c[c[j>>2]>>2]|0)+48>>2]|0))break;if(c[(c[j>>2]|0)+212>>2]|0)break;zb[c[(c[c[j>>2]>>2]|0)+48>>2]&511](c[(c[j>>2]|0)+4>>2]|0)}while(0);c[(c[j>>2]|0)+172>>2]=1;continue a}if((c[c[j>>2]>>2]|0)!=0?(c[(c[c[j>>2]>>2]|0)+44>>2]|0)!=0:0)Ab[c[(c[c[j>>2]>>2]|0)+44>>2]&511](c[(c[j>>2]|0)+4>>2]|0,136080);e=oy(68488)|0;c[(c[j>>2]|0)+20>>2]=e;e=c[j>>2]|0;if(!(c[(c[j>>2]|0)+20>>2]|0)){ie(e,0);continue a}if(((c[e>>2]|0)!=0?(c[(c[c[j>>2]>>2]|0)+48>>2]|0)!=0:0)?(c[(c[j>>2]|0)+212>>2]|0)==0:0)zb[c[(c[c[j>>2]>>2]|0)+48>>2]&511](c[(c[j>>2]|0)+4>>2]|0);c[(c[j>>2]|0)+172>>2]=1;continue a;break}case 7:{if((c[m>>2]|0)<2?(c[(c[j>>2]|0)+40>>2]|0)==1:0){Q=407;break a}a[o>>0]=a[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0;a[p>>0]=a[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0;c[A>>2]=c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2];c[B>>2]=c[(c[(c[j>>2]|0)+36>>2]|0)+36>>2];if((d[o>>0]|0|0)==60?(d[p>>0]|0|0)==47:0){c[(c[j>>2]|0)+172>>2]=9;continue a}if((d[o>>0]|0|0)==60?(d[p>>0]|0|0)==63:0){if((c[k>>2]|0)==0?(uh(c[j>>2]|0,63,62,0)|0)<0:0){Q=147;break a}mf(c[j>>2]|0);c[(c[j>>2]|0)+172>>2]=7;c[(c[j>>2]|0)+292>>2]=1}else Q=149;do if((Q|0)==149){Q=0;if((d[o>>0]|0|0)==60?(d[p>>0]|0|0)!=33:0){c[(c[j>>2]|0)+172>>2]=6;continue a}if((((d[o>>0]|0|0)==60?(d[p>>0]|0|0)==33:0)?(d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==45:0)?(d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==45:0){if((c[m>>2]|0)<4){Q=407;break a}e=(c[(c[j>>2]|0)+36>>2]|0)+16|0;c[e>>2]=(c[e>>2]|0)+4;c[C>>2]=uh(c[j>>2]|0,45,45,62)|0;e=(c[(c[j>>2]|0)+36>>2]|0)+16|0;c[e>>2]=(c[e>>2]|0)+-4;V=c[j>>2]|0;if((c[k>>2]|0)==0&(c[C>>2]|0)<0){Q=158;break a}kf(V);c[(c[j>>2]|0)+172>>2]=7;c[(c[j>>2]|0)+292>>2]=1;break}do if((((d[o>>0]|0|0)==60?(d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==33:0)?(d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==91:0)?(d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==67:0){if((d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0|0)!=68)break;if((d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0|0)!=65)break;if((d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0|0)!=84)break;if((d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0|0)!=65)break;if((d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+8>>0]|0|0)!=91)break;e=(c[j>>2]|0)+200|0;c[e>>2]=(c[e>>2]|0)+9;e=(c[(c[j>>2]|0)+36>>2]|0)+16|0;c[e>>2]=(c[e>>2]|0)+9;e=(c[(c[j>>2]|0)+36>>2]|0)+32|0;c[e>>2]=(c[e>>2]|0)+9;if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[j>>2]|0);do if(!(d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0)){if((ke(c[(c[j>>2]|0)+36>>2]|0,250)|0)>0)break;Ve(c[j>>2]|0)|0}while(0);c[(c[j>>2]|0)+172>>2]=8;continue a}while(0);if((d[o>>0]|0|0)==60?(d[p>>0]|0|0)==33&(c[m>>2]|0)<9:0){Q=407;break a}if((d[o>>0]|0|0)==38){if((c[k>>2]|0)==0?(uh(c[j>>2]|0,59,0,0)|0)<0:0){Q=407;break a}Df(c[j>>2]|0);break}do if(!(((c[m>>2]|0)<300?(c[(c[j>>2]|0)+40>>2]|0)==1:0)^1|(c[k>>2]|0)!=0)){if(!(c[(c[j>>2]|0)+292>>2]|0))if((uh(c[j>>2]|0,60,0,0)|0)<0){Q=407;break a}else break;if(!(c[q>>2]|0)){Q=407;break a}if((c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)>>>0>(c[q>>2]|0)>>>0){Q=407;break a}}while(0);c[(c[j>>2]|0)+204>>2]=0;hf(c[j>>2]|0,0)}while(0);while(1){if(d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0)break;if((c[(c[j>>2]|0)+40>>2]|0)<=1)break;Ve(c[j>>2]|0)|0}if((c[B>>2]|0)!=(c[(c[(c[j>>2]|0)+36>>2]|0)+36>>2]|0))continue a;if((c[A>>2]|0)!=(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0))continue a;og(c[j>>2]|0,1,69472);c[(c[j>>2]|0)+172>>2]=-1;continue a;break}case 6:{c[x>>2]=0;c[y>>2]=0;c[z>>2]=c[(c[j>>2]|0)+328>>2];if((c[m>>2]|0)<2?(c[(c[j>>2]|0)+40>>2]|0)==1:0){Q=407;break a}a[o>>0]=a[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0;if((d[o>>0]|0|0)!=60){Q=81;break a}do if(!(c[k>>2]|0)){if(!(c[(c[j>>2]|0)+292>>2]|0))if((uh(c[j>>2]|0,62,0,0)|0)<0){Q=407;break a}else break;if(!(c[r>>2]|0)){Q=407;break a}if((c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)>>>0>=(c[r>>2]|0)>>>0){Q=407;break a}}while(0);e=c[j>>2]|0;do if(c[(c[j>>2]|0)+236>>2]|0){b=c[j>>2]|0;if((c[c[e+232>>2]>>2]|0)==-2){Xg(b,-1)|0;break}else{Xg(b,c[c[(c[j>>2]|0)+232>>2]>>2]|0)|0;break}}else Xg(e,-1)|0;while(0);e=c[j>>2]|0;if(c[(c[j>>2]|0)+324>>2]|0)c[w>>2]=Yg(e,x,y,n)|0;else c[w>>2]=Hf(e)|0;if((c[(c[j>>2]|0)+172>>2]|0)==-1){Q=407;break a}W=c[j>>2]|0;if(!(c[w>>2]|0)){Q=99;break a}do if(((c[W+104>>2]|0)!=0?(c[(c[j>>2]|0)+12>>2]|0)!=0:0)?(c[(c[j>>2]|0)+8>>2]|0)!=0:0){if(!(c[(c[j>>2]|0)+52>>2]|0))break;if((c[(c[j>>2]|0)+52>>2]|0)!=(c[(c[(c[j>>2]|0)+8>>2]|0)+12>>2]|0))break;e=an((c[j>>2]|0)+108|0,c[(c[j>>2]|0)+8>>2]|0)|0;b=(c[j>>2]|0)+100|0;c[b>>2]=c[b>>2]&e}while(0);if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==47?(d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==62:0){e=(c[j>>2]|0)+200|0;c[e>>2]=(c[e>>2]|0)+2;
e=(c[(c[j>>2]|0)+36>>2]|0)+16|0;c[e>>2]=(c[e>>2]|0)+2;e=(c[(c[j>>2]|0)+36>>2]|0)+32|0;c[e>>2]=(c[e>>2]|0)+2;if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[j>>2]|0);do if(!(d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0)){if((ke(c[(c[j>>2]|0)+36>>2]|0,250)|0)>0)break;Ve(c[j>>2]|0)|0}while(0);e=(c[c[j>>2]>>2]|0)!=0;do if(c[(c[j>>2]|0)+324>>2]|0){do if(e){if(!(c[(c[c[j>>2]>>2]|0)+120>>2]|0))break;if(c[(c[j>>2]|0)+212>>2]|0)break;Jb[c[(c[c[j>>2]>>2]|0)+120>>2]&511](c[(c[j>>2]|0)+4>>2]|0,c[w>>2]|0,c[x>>2]|0,c[y>>2]|0)}while(0);if(((c[(c[j>>2]|0)+328>>2]|0)-(c[z>>2]|0)|0)<=0)break;_g(c[j>>2]|0,(c[(c[j>>2]|0)+328>>2]|0)-(c[z>>2]|0)|0)|0}else{if(!e)break;if(!(c[(c[c[j>>2]>>2]|0)+60>>2]|0))break;if(c[(c[j>>2]|0)+212>>2]|0)break;Ab[c[(c[c[j>>2]>>2]|0)+60>>2]&511](c[(c[j>>2]|0)+4>>2]|0,c[w>>2]|0)}while(0);if((c[(c[j>>2]|0)+172>>2]|0)==-1){Q=407;break a}Zg(c[j>>2]|0)|0;e=(c[j>>2]|0)+172|0;if(!(c[(c[j>>2]|0)+188>>2]|0))c[e>>2]=14;else c[e>>2]=7;c[(c[j>>2]|0)+292>>2]=1;continue a}e=c[j>>2]|0;if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==62)me(e);else{pg(e,73,70136,c[w>>2]|0);Re(c[j>>2]|0)|0;Zg(c[j>>2]|0)|0}e=c[j>>2]|0;b=c[w>>2]|0;if(c[(c[j>>2]|0)+324>>2]|0)vh(e,b,c[x>>2]|0,c[y>>2]|0,(c[(c[j>>2]|0)+328>>2]|0)-(c[z>>2]|0)|0)|0;else Se(e,b)|0;c[(c[j>>2]|0)+172>>2]=7;c[(c[j>>2]|0)+292>>2]=1;continue a;break}case 4:{Ue(c[j>>2]|0)|0;b=c[(c[j>>2]|0)+36>>2]|0;if(!(c[c[(c[j>>2]|0)+36>>2]>>2]|0))c[m>>2]=(c[b+24>>2]|0)-((c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2]|0));else{e=_y(c[(c[b>>2]|0)+16>>2]|0)|0;c[m>>2]=e-((c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2]|0))}if((c[m>>2]|0)<2){Q=407;break a}a[o>>0]=a[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0;a[p>>0]=a[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0;if((d[o>>0]|0|0)==60?(d[p>>0]|0|0)==63:0){if((c[k>>2]|0)==0?(uh(c[j>>2]|0,63,62,0)|0)<0:0){Q=308;break a}mf(c[j>>2]|0);if((c[(c[j>>2]|0)+172>>2]|0)==-1){Q=407;break a}c[(c[j>>2]|0)+172>>2]=4;c[(c[j>>2]|0)+292>>2]=1;continue a}if((((d[o>>0]|0|0)==60?(d[p>>0]|0|0)==33:0)?(d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==45:0)?(d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==45:0){if((c[k>>2]|0)==0?(uh(c[j>>2]|0,45,45,62)|0)<0:0){Q=317;break a}kf(c[j>>2]|0);if((c[(c[j>>2]|0)+172>>2]|0)==-1){Q=407;break a}c[(c[j>>2]|0)+172>>2]=4;c[(c[j>>2]|0)+292>>2]=1;continue a}if((d[o>>0]|0|0)==60?(d[p>>0]|0|0)==33&(c[m>>2]|0)<4:0){Q=407;break a}c[(c[j>>2]|0)+172>>2]=6;if(!(c[(c[j>>2]|0)+292>>2]|0))c[(c[j>>2]|0)+292>>2]=6;th(c[j>>2]|0,q,r);continue a;break}case 14:{Ue(c[j>>2]|0)|0;e=c[(c[j>>2]|0)+36>>2]|0;if(!(c[c[(c[j>>2]|0)+36>>2]>>2]|0))c[m>>2]=(c[e+24>>2]|0)-((c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2]|0));else{b=_y(c[(c[e>>2]|0)+16>>2]|0)|0;c[m>>2]=b-((c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2]|0))}if((c[m>>2]|0)<2){Q=407;break a}a[o>>0]=a[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0;a[p>>0]=a[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0;if((d[o>>0]|0|0)==60?(d[p>>0]|0|0)==63:0){if((c[k>>2]|0)==0?(uh(c[j>>2]|0,63,62,0)|0)<0:0){Q=333;break a}mf(c[j>>2]|0);if((c[(c[j>>2]|0)+172>>2]|0)==-1){Q=407;break a}c[(c[j>>2]|0)+172>>2]=14;c[(c[j>>2]|0)+292>>2]=1;continue a}if((d[o>>0]|0|0)!=60){Q=345;break a}if((d[p>>0]|0|0)!=33){Q=345;break a}if((d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)!=45){Q=345;break a}if((d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)!=45){Q=345;break a}if((c[k>>2]|0)==0?(uh(c[j>>2]|0,45,45,62)|0)<0:0){Q=342;break a}kf(c[j>>2]|0);if((c[(c[j>>2]|0)+172>>2]|0)==-1){Q=407;break a}c[(c[j>>2]|0)+172>>2]=14;c[(c[j>>2]|0)+292>>2]=1;continue a;break}case 3:{a[L>>0]=0;c[I>>2]=(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2]|0);if((c[I>>2]|0)<0){Q=351;break a}if((c[(c[j>>2]|0)+204>>2]|0)>(c[I>>2]|0))c[I>>2]=c[(c[j>>2]|0)+204>>2];c[K>>2]=Vy(c[(c[c[(c[j>>2]|0)+36>>2]>>2]|0)+16>>2]|0)|0;c[M>>2]=_y(c[(c[c[(c[j>>2]|0)+36>>2]>>2]|0)+16>>2]|0)|0;c:while(1){if((c[I>>2]|0)>>>0>=(c[M>>2]|0)>>>0){Q=389;break a}d:do if(d[L>>0]|0){if((d[(c[K>>2]|0)+(c[I>>2]|0)>>0]|0|0)==(d[L>>0]|0|0))a[L>>0]=0}else{do if((((d[L>>0]|0|0)==0?(d[(c[K>>2]|0)+(c[I>>2]|0)>>0]|0|0)==60:0)?(c[N>>2]=0,((c[I>>2]|0)+4|0)>>>0<(c[M>>2]|0)>>>0):0)?(d[(c[K>>2]|0)+((c[I>>2]|0)+1)>>0]|0|0)==33:0){if((d[(c[K>>2]|0)+((c[I>>2]|0)+2)>>0]|0|0)!=45)break;if((d[(c[K>>2]|0)+((c[I>>2]|0)+3)>>0]|0|0)!=45)break;e:while(1){if(((c[I>>2]|0)+3|0)>>>0>=(c[M>>2]|0)>>>0)break;do if((d[(c[K>>2]|0)+(c[I>>2]|0)>>0]|0|0)==45){if((d[(c[K>>2]|0)+((c[I>>2]|0)+1)>>0]|0|0)!=45)break;if((d[(c[K>>2]|0)+((c[I>>2]|0)+2)>>0]|0|0)==62){Q=369;break e}}while(0);c[I>>2]=(c[I>>2]|0)+1}if((Q|0)==369){Q=0;c[N>>2]=1;c[I>>2]=(c[I>>2]|0)+2}if(c[N>>2]|0)break d;else{Q=389;break a}}while(0);if((d[(c[K>>2]|0)+(c[I>>2]|0)>>0]|0|0)==34){a[L>>0]=34;break}if((d[(c[K>>2]|0)+(c[I>>2]|0)>>0]|0|0)==39){a[L>>0]=39;break}if((d[(c[K>>2]|0)+(c[I>>2]|0)>>0]|0|0)==93){if(((c[I>>2]|0)+1|0)>>>0>=(c[M>>2]|0)>>>0){Q=389;break a}if((d[(c[K>>2]|0)+((c[I>>2]|0)+1)>>0]|0|0)==93){c[I>>2]=(c[I>>2]|0)+1;break}c[J>>2]=1;while(1){if(((c[I>>2]|0)+(c[J>>2]|0)|0)>>>0>=(c[M>>2]|0)>>>0){Q=389;break a}if((d[(c[K>>2]|0)+((c[I>>2]|0)+(c[J>>2]|0))>>0]|0|0)==62)break c;do if((d[(c[K>>2]|0)+((c[I>>2]|0)+(c[J>>2]|0))>>0]|0|0)!=32){if(9<=(d[(c[K>>2]|0)+((c[I>>2]|0)+(c[J>>2]|0))>>0]|0|0)?(d[(c[K>>2]|0)+((c[I>>2]|0)+(c[J>>2]|0))>>0]|0|0)<=10:0)break;if((d[(c[K>>2]|0)+((c[I>>2]|0)+(c[J>>2]|0))>>0]|0|0)!=13)break d}while(0);c[J>>2]=(c[J>>2]|0)+1}}}while(0);c[I>>2]=(c[I>>2]|0)+1}c[(c[j>>2]|0)+204>>2]=0;bh(c[j>>2]|0);if((c[(c[j>>2]|0)+172>>2]|0)==-1){Q=407;break a}c[(c[j>>2]|0)+216>>2]=2;if(((c[c[j>>2]>>2]|0)!=0?(c[(c[j>>2]|0)+212>>2]|0)==0:0)?(c[(c[c[j>>2]>>2]|0)+104>>2]|0)!=0:0)Jb[c[(c[c[j>>2]>>2]|0)+104>>2]&511](c[(c[j>>2]|0)+4>>2]|0,c[(c[j>>2]|0)+220>>2]|0,c[(c[j>>2]|0)+228>>2]|0,c[(c[j>>2]|0)+224>>2]|0);c[(c[j>>2]|0)+216>>2]=0;ch(c[j>>2]|0);if((c[(c[j>>2]|0)+172>>2]|0)==-1){Q=407;break a}c[(c[j>>2]|0)+172>>2]=4;c[(c[j>>2]|0)+204>>2]=0;continue a;break}case 5:{Db[c[135904>>2]&511](c[33980]|0,70192,g);c[(c[j>>2]|0)+172>>2]=7;continue a;break}case 15:{Db[c[135904>>2]&511](c[33980]|0,70232,g);c[(c[j>>2]|0)+172>>2]=3;continue a;break}case 2:{Db[c[135904>>2]&511](c[33980]|0,70272,g);c[(c[j>>2]|0)+172>>2]=7;continue a;break}case 10:{Db[c[135904>>2]&511](c[33980]|0,70312,g);c[(c[j>>2]|0)+172>>2]=3;continue a;break}case 11:{Db[c[135904>>2]&511](c[33980]|0,70360,g);c[(c[j>>2]|0)+172>>2]=7;continue a;break}case 12:{Db[c[135904>>2]&511](c[33980]|0,70408,g);c[(c[j>>2]|0)+172>>2]=6;continue a;break}case 13:{Db[c[135904>>2]&511](c[33980]|0,70456,g);c[(c[j>>2]|0)+172>>2]=6;continue a;break}case 16:{Db[c[135904>>2]&511](c[33980]|0,70504,g);c[(c[j>>2]|0)+172>>2]=6;continue a;break}case-1:{Q=407;break a;break}default:continue a}while(0)}switch(Q|0){case 10:{c[h>>2]=0;P=c[h>>2]|0;i=f;return P|0}case 30:{if((c[c[j>>2]>>2]|0)!=0?(c[(c[c[j>>2]>>2]|0)+44>>2]|0)!=0:0)Ab[c[(c[c[j>>2]>>2]|0)+44>>2]&511](c[(c[j>>2]|0)+4>>2]|0,136080);og(c[j>>2]|0,4,0);c[(c[j>>2]|0)+172>>2]=-1;if((c[c[j>>2]>>2]|0)!=0?(c[(c[c[j>>2]>>2]|0)+52>>2]|0)!=0:0){zb[c[(c[c[j>>2]>>2]|0)+52>>2]&511](c[(c[j>>2]|0)+4>>2]|0);Q=407}else Q=407;break}case 39:{c[h>>2]=c[l>>2];P=c[h>>2]|0;i=f;return P|0}case 42:{c[h>>2]=c[l>>2];P=c[h>>2]|0;i=f;return P|0}case 54:{c[U+172>>2]=-1;c[h>>2]=0;P=c[h>>2]|0;i=f;return P|0}case 81:{og(c[j>>2]|0,4,0);c[(c[j>>2]|0)+172>>2]=-1;if((c[c[j>>2]>>2]|0)!=0?(c[(c[c[j>>2]>>2]|0)+52>>2]|0)!=0:0){zb[c[(c[c[j>>2]>>2]|0)+52>>2]&511](c[(c[j>>2]|0)+4>>2]|0);Q=407}else Q=407;break}case 99:{Zg(W)|0;c[(c[j>>2]|0)+172>>2]=-1;if((c[c[j>>2]>>2]|0)!=0?(c[(c[c[j>>2]>>2]|0)+52>>2]|0)!=0:0){zb[c[(c[c[j>>2]>>2]|0)+52>>2]&511](c[(c[j>>2]|0)+4>>2]|0);Q=407}else Q=407;break}case 147:{c[(c[j>>2]|0)+292>>2]=2;Q=407;break}case 158:{c[V+292>>2]=5;Q=407;break}case 207:{if((c[m>>2]|0)>=302){c[E>>2]=xh(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0,300)|0;if((c[E>>2]|0)<0){c[E>>2]=0-(c[E>>2]|0);V=(c[(c[j>>2]|0)+36>>2]|0)+16|0;c[V>>2]=(c[V>>2]|0)+(c[E>>2]|0);Q=408;break}do if((c[c[j>>2]>>2]|0)!=0?(c[(c[j>>2]|0)+212>>2]|0)==0:0){V=c[c[j>>2]>>2]|0;if(c[(c[c[j>>2]>>2]|0)+100>>2]|0){Db[c[V+100>>2]&511](c[(c[j>>2]|0)+4>>2]|0,c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0,c[E>>2]|0);break}if(c[V+68>>2]|0)Db[c[(c[c[j>>2]>>2]|0)+68>>2]&511](c[(c[j>>2]|0)+4>>2]|0,c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0,c[E>>2]|0)}while(0);if((c[(c[j>>2]|0)+172>>2]|0)!=-1){c[F>>2]=0;while(1){X=d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0;if((c[F>>2]|0)>=(c[E>>2]|0))break;V=c[(c[j>>2]|0)+36>>2]|0;if((X|0)==10){W=V+28|0;c[W>>2]=(c[W>>2]|0)+1;c[(c[(c[j>>2]|0)+36>>2]|0)+32>>2]=1}else{W=V+32|0;c[W>>2]=(c[W>>2]|0)+1}W=(c[j>>2]|0)+200|0;c[W>>2]=(c[W>>2]|0)+1;W=(c[(c[j>>2]|0)+36>>2]|0)+16|0;c[W>>2]=(c[W>>2]|0)+1;c[F>>2]=(c[F>>2]|0)+1}if((X|0)==37)We(c[j>>2]|0);if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[j>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[j>>2]|0)|0;c[(c[j>>2]|0)+204>>2]=0;Q=407}else Q=407}else Q=407;break}case 231:{c[G>>2]=0-(c[G>>2]|0);X=(c[(c[j>>2]|0)+36>>2]|0)+16|0;c[X>>2]=(c[X>>2]|0)+(c[G>>2]|0);Q=408;break}case 265:{c[(c[j>>2]|0)+292>>2]=2;Q=407;break}case 274:{c[(c[j>>2]|0)+292>>2]=5;Q=407;break}case 288:{c[(c[j>>2]|0)+292>>2]=3;Q=407;break}case 308:{c[(c[j>>2]|0)+292>>2]=2;Q=407;break}case 317:{c[(c[j>>2]|0)+292>>2]=5;Q=407;break}case 333:{c[(c[j>>2]|0)+292>>2]=2;Q=407;break}case 342:{c[(c[j>>2]|0)+292>>2]=5;Q=407;break}case 345:{if((d[o>>0]|0|0)==60?(d[p>>0]|0|0)==33&(c[m>>2]|0)<4:0){Q=407;break}og(c[j>>2]|0,5,0);c[(c[j>>2]|0)+172>>2]=-1;if((c[c[j>>2]>>2]|0)!=0?(c[(c[c[j>>2]>>2]|0)+52>>2]|0)!=0:0){zb[c[(c[c[j>>2]>>2]|0)+52>>2]&511](c[(c[j>>2]|0)+4>>2]|0);Q=407}else Q=407;break}case 351:{c[h>>2]=0;P=c[h>>2]|0;i=f;return P|0}case 389:{if(!(d[L>>0]|0)){c[(c[j>>2]|0)+204>>2]=c[I>>2];Q=407;break}else{c[(c[j>>2]|0)+204>>2]=0;Q=407;break}break}}if((Q|0)==407){c[h>>2]=c[l>>2];P=c[h>>2]|0;i=f;return P|0}else if((Q|0)==408){Q=d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0;l=d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0;I=d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0;c[g>>2]=d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0];c[g+4>>2]=Q;c[g+8>>2]=l;c[g+12>>2]=I;JT(O,149,70552,g)|0;je(c[j>>2]|0,9,70592,O,0);c[h>>2]=0;P=c[h>>2]|0;i=f;return P|0}return 0}function eh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;do if(!((c[g>>2]|0)==0|(c[h>>2]|0)==0|(c[j>>2]|0)<0)){if((c[(c[g>>2]|0)+172>>2]|0)==6)if(NT(c[h>>2]|0,62,c[j>>2]|0)|0){c[f>>2]=1;break}else{c[f>>2]=0;break}if((c[(c[g>>2]|0)+292>>2]|0)==5)if(NT(c[h>>2]|0,62,c[j>>2]|0)|0){c[f>>2]=1;break}else{c[f>>2]=0;break}if((c[(c[g>>2]|0)+172>>2]|0)==8)if(NT(c[h>>2]|0,62,c[j>>2]|0)|0){c[f>>2]=1;break}else{c[f>>2]=0;break}if((c[(c[g>>2]|0)+292>>2]|0)==2)if(NT(c[h>>2]|0,62,c[j>>2]|0)|0){c[f>>2]=1;break}else{c[f>>2]=0;break}if((c[(c[g>>2]|0)+172>>2]|0)==9)if(NT(c[h>>2]|0,62,c[j>>2]|0)|0){c[f>>2]=1;break}else{c[f>>2]=0;break}if((c[(c[g>>2]|0)+292>>2]|0)!=3?(c[(c[g>>2]|0)+172>>2]|0)!=3:0){c[f>>2]=1;break}if(NT(c[h>>2]|0,62,c[j>>2]|0)|0){c[f>>2]=1;break}else{c[f>>2]=0;break}}else c[f>>2]=-1;while(0);i=e;return c[f>>2]|0}function fh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+48|0;g=f+32|0;h=f+28|0;j=f+24|0;k=f+20|0;l=f+16|0;m=f+12|0;n=f+8|0;o=f+4|0;p=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[o>>2]=0;c[m>>2]=Be()|0;if(!(c[m>>2]|0)){c[g>>2]=0;q=c[g>>2]|0;i=f;return q|0}if(c[l>>2]|0){c[(c[m>>2]|0)+360>>2]=c[(c[l>>2]|0)+360>>2];c[(c[m>>2]|0)+272>>2]=c[(c[l>>2]|0)+272>>2]}c[p>>2]=Hl(c[h>>2]|0,c[k>>2]|0)|0;if(!(c[p>>2]|0)){c[n>>2]=Vk(c[h>>2]|0,c[j>>2]|0,c[m>>2]|0)|0;k=c[m>>2]|0;if(!(c[n>>2]|0)){Ae(k);c[g>>2]=0;q=c[g>>2]|0;i=f;return q|0}Oe(k,c[n>>2]|0)|0;if((c[o>>2]|0)==0?(c[(c[m>>2]|0)+180>>2]|0)==0:0)c[o>>2]=Rk(c[h>>2]|0)|0;if((c[o>>2]|0)!=0?(c[(c[m>>2]|0)+180>>2]|0)==0:0)c[(c[m>>2]|0)+180>>2]=c[o>>2]}else{c[n>>2]=Vk(c[p>>2]|0,c[j>>2]|0,c[m>>2]|0)|0;if(!(c[n>>2]|0)){zb[c[135736>>2]&511](c[p>>2]|0);Ae(c[m>>2]|0);c[g>>2]=0;q=c[g>>2]|0;i=f;return q|0}Oe(c[m>>2]|0,c[n>>2]|0)|0;if((c[o>>2]|0)==0?(c[(c[m>>2]|0)+180>>2]|0)==0:0)c[o>>2]=Rk(c[p>>2]|0)|0;if((c[o>>2]|0)!=0?(c[(c[m>>2]|0)+180>>2]|0)==0:0)c[(c[m>>2]|0)+180>>2]=c[o>>2];zb[c[135736>>2]&511](c[p>>2]|0)}c[g>>2]=c[m>>2];q=c[g>>2]|0;i=f;return q|0}function gh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(!(c[g>>2]|0)){c[f>>2]=-1;k=c[f>>2]|0;i=e;return k|0}if(c[j>>2]|0){if(c[(c[g>>2]|0)+24>>2]|0)zb[c[135736>>2]&511](c[(c[g>>2]|0)+24>>2]|0);d=my(c[j>>2]|0)|0;c[(c[g>>2]|0)+24>>2]=d}d=(c[g>>2]|0)+288|0;if(c[h>>2]&1){c[d>>2]=1;c[h>>2]=(c[h>>2]|0)-1;j=(c[g>>2]|0)+360|0;c[j>>2]=c[j>>2]|1}else c[d>>2]=0;d=(c[g>>2]|0)+276|0;if(c[h>>2]&4){c[d>>2]=2;c[h>>2]=(c[h>>2]|0)-4;j=(c[g>>2]|0)+360|0;c[j>>2]=c[j>>2]|4}else c[d>>2]=0;if(c[h>>2]&8){d=(c[g>>2]|0)+276|0;c[d>>2]=c[d>>2]|4;c[h>>2]=(c[h>>2]|0)-8;d=(c[g>>2]|0)+360|0;c[d>>2]=c[d>>2]|8}d=(c[g>>2]|0)+16|0;if(c[h>>2]&2){c[d>>2]=1;c[h>>2]=(c[h>>2]|0)-2;j=(c[g>>2]|0)+360|0;c[j>>2]=c[j>>2]|2}else c[d>>2]=0;d=(c[g>>2]|0)+268|0;if(c[h>>2]&128){c[d>>2]=1;c[h>>2]=(c[h>>2]|0)-128;j=(c[g>>2]|0)+360|0;c[j>>2]=c[j>>2]|128}else c[d>>2]=0;d=(c[g>>2]|0)+208|0;if(c[h>>2]&256){c[d>>2]=0;c[(c[c[g>>2]>>2]|0)+72>>2]=65;c[h>>2]=(c[h>>2]|0)-256;j=(c[g>>2]|0)+360|0;c[j>>2]=c[j>>2]|256}else c[d>>2]=1;d=(c[g>>2]|0)+104|0;if(c[h>>2]&16){c[d>>2]=1;if(c[h>>2]&64)c[(c[g>>2]|0)+116>>2]=0;if(c[h>>2]&32)c[(c[g>>2]|0)+112>>2]=0;c[h>>2]=(c[h>>2]|0)-16;j=(c[g>>2]|0)+360|0;c[j>>2]=c[j>>2]|16}else c[d>>2]=0;if(c[h>>2]&64){c[(c[c[g>>2]>>2]|0)+84>>2]=0;c[h>>2]=(c[h>>2]|0)-64}if(c[h>>2]&32){c[(c[c[g>>2]>>2]|0)+88>>2]=0;c[(c[c[g>>2]>>2]|0)+92>>2]=0;c[h>>2]=(c[h>>2]|0)-32}if(c[h>>2]&512){c[(c[c[g>>2]>>2]|0)+56>>2]=50;c[(c[c[g>>2]>>2]|0)+60>>2]=51;c[(c[c[g>>2]>>2]|0)+116>>2]=0;c[(c[c[g>>2]>>2]|0)+120>>2]=0;c[(c[c[g>>2]>>2]|0)+108>>2]=1;c[h>>2]=(c[h>>2]|0)-512;d=(c[g>>2]|0)+360|0;c[d>>2]=c[d>>2]|512}d=(c[g>>2]|0)+364|0;if(c[h>>2]&4096){c[d>>2]=0;c[h>>2]=(c[h>>2]|0)-4096;j=(c[g>>2]|0)+360|0;c[j>>2]=c[j>>2]|4096}else c[d>>2]=1;if(c[h>>2]&16384){c[(c[c[g>>2]>>2]|0)+100>>2]=0;c[h>>2]=(c[h>>2]|0)-16384;d=(c[g>>2]|0)+360|0;c[d>>2]=c[d>>2]|16384}if(c[h>>2]&8192){d=(c[g>>2]|0)+360|0;c[d>>2]=c[d>>2]|8192;c[h>>2]=(c[h>>2]|0)-8192}if(c[h>>2]&2048){d=(c[g>>2]|0)+360|0;c[d>>2]=c[d>>2]|2048;c[h>>2]=(c[h>>2]|0)-2048}if(c[h>>2]&65536){d=(c[g>>2]|0)+360|0;c[d>>2]=c[d>>2]|65536;c[h>>2]=(c[h>>2]|0)-65536}if(c[h>>2]&131072){d=(c[g>>2]|0)+360|0;c[d>>2]=c[d>>2]|131072;c[h>>2]=(c[h>>2]|0)-131072}if(c[h>>2]&262144){d=(c[g>>2]|0)+360|0;c[d>>2]=c[d>>2]|262144;c[h>>2]=(c[h>>2]|0)-262144}do if(c[h>>2]&524288){d=(c[g>>2]|0)+360|0;c[d>>2]=c[d>>2]|524288;c[h>>2]=(c[h>>2]|0)-524288;if(!(c[(c[g>>2]|0)+296>>2]|0))break;DP(c[(c[g>>2]|0)+296>>2]|0,0)|0}while(0);if(c[h>>2]&1048576){d=(c[g>>2]|0)+360|0;c[d>>2]=c[d>>2]|1048576;c[h>>2]=(c[h>>2]|0)-1048576}if(c[h>>2]&2097152){d=(c[g>>2]|0)+360|0;c[d>>2]=c[d>>2]|2097152;c[h>>2]=(c[h>>2]|0)-2097152}if(c[h>>2]&4194304){d=(c[g>>2]|0)+360|0;c[d>>2]=c[d>>2]|4194304;c[h>>2]=(c[h>>2]|0)-4194304}c[(c[g>>2]|0)+280>>2]=1;c[f>>2]=c[h>>2];k=c[f>>2]|0;i=e;return k|0}function hh(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=a;c[h>>2]=b;b=c[g>>2]|0;if((c[h>>2]|0)==(c[(c[g>>2]|0)+312>>2]|0)){c[f>>2]=c[b+320>>2];k=c[f>>2]|0;i=e;return k|0}c[j>>2]=(c[b+328>>2]|0)-2;while(1){if((c[j>>2]|0)<0){l=11;break}if((c[(c[(c[g>>2]|0)+336>>2]|0)+(c[j>>2]<<2)>>2]|0)==(c[h>>2]|0))break;c[j>>2]=(c[j>>2]|0)-2}if((l|0)==11){c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}if((c[h>>2]|0)==0?(d[c[(c[(c[g>>2]|0)+336>>2]|0)+((c[j>>2]|0)+1<<2)>>2]>>0]|0|0)==0:0){c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}c[f>>2]=c[(c[(c[g>>2]|0)+336>>2]|0)+((c[j>>2]|0)+1<<2)>>2];k=c[f>>2]|0;i=e;return k|0}function ih(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;a:do if(c[(c[g>>2]|0)+360>>2]&8192){c[k>>2]=(c[(c[g>>2]|0)+328>>2]|0)-2;while(1){if((c[k>>2]|0)<0)break a;m=c[k>>2]|0;if((c[(c[(c[g>>2]|0)+336>>2]|0)+(c[k>>2]<<2)>>2]|0)==(c[h>>2]|0))break;c[k>>2]=m-2}if((c[(c[(c[g>>2]|0)+336>>2]|0)+(m+1<<2)>>2]|0)==(c[j>>2]|0)){c[f>>2]=-2;n=c[f>>2]|0;i=e;return n|0}}while(0);do if((c[(c[g>>2]|0)+332>>2]|0)!=0?(c[(c[g>>2]|0)+336>>2]|0)!=0:0){if((c[(c[g>>2]|0)+328>>2]|0)>=(c[(c[g>>2]|0)+332>>2]|0)){m=(c[g>>2]|0)+332|0;c[m>>2]=c[m>>2]<<1;c[l>>2]=Hb[c[135760>>2]&511](c[(c[g>>2]|0)+336>>2]|0,c[(c[g>>2]|0)+332>>2]<<2)|0;if(c[l>>2]|0){c[(c[g>>2]|0)+336>>2]=c[l>>2];break}ie(c[g>>2]|0,0);m=(c[g>>2]|0)+332|0;c[m>>2]=(c[m>>2]|0)/2|0;c[f>>2]=-1;n=c[f>>2]|0;i=e;return n|0}}else o=10;while(0);if((o|0)==10?(c[(c[g>>2]|0)+332>>2]=10,c[(c[g>>2]|0)+328>>2]=0,o=Cb[c[135744>>2]&511](c[(c[g>>2]|0)+332>>2]<<2)|0,c[(c[g>>2]|0)+336>>2]=o,(c[(c[g>>2]|0)+336>>2]|0)==0):0){ie(c[g>>2]|0,0);c[(c[g>>2]|0)+332>>2]=0;c[f>>2]=-1;n=c[f>>2]|0;i=e;return n|0}o=c[h>>2]|0;h=(c[g>>2]|0)+328|0;l=c[h>>2]|0;c[h>>2]=l+1;c[(c[(c[g>>2]|0)+336>>2]|0)+(l<<2)>>2]=o;o=c[j>>2]|0;j=(c[g>>2]|0)+328|0;l=c[j>>2]|0;c[j>>2]=l+1;c[(c[(c[g>>2]|0)+336>>2]|0)+(l<<2)>>2]=o;c[f>>2]=c[(c[g>>2]|0)+328>>2];n=c[f>>2]|0;i=e;return n|0}function jh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+32|0;h=g+24|0;j=g+20|0;k=g+16|0;l=g+12|0;m=g+8|0;n=g+4|0;o=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;gh(c[h>>2]|0,c[l>>2]|0,c[k>>2]|0)|0;if((c[k>>2]|0)!=0?(c[o>>2]=Dd(c[k>>2]|0)|0,(c[o>>2]|0)!=0):0)se(c[h>>2]|0,c[o>>2]|0)|0;if(((c[j>>2]|0)!=0?(c[(c[h>>2]|0)+36>>2]|0)!=0:0)?(c[(c[(c[h>>2]|0)+36>>2]|0)+4>>2]|0)==0:0){o=my(c[j>>2]|0)|0;c[(c[(c[h>>2]|0)+36>>2]|0)+4>>2]=o}Qf(c[h>>2]|0)|0;if((c[(c[h>>2]|0)+12>>2]|0)==0?(c[(c[h>>2]|0)+288>>2]|0)==0:0){c[n>>2]=0;if(c[(c[h>>2]|0)+8>>2]|0)Th(c[(c[h>>2]|0)+8>>2]|0)}else c[n>>2]=c[(c[h>>2]|0)+8>>2];c[(c[h>>2]|0)+8>>2]=0;if(c[m>>2]|0){p=c[n>>2]|0;i=g;return p|0}Ae(c[h>>2]|0);p=c[n>>2]|0;i=g;return p|0}function kh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;b=c[g>>2]|0;a:do if(!(c[(c[f>>2]|0)+360>>2]&131072)){if((b|0)!=32&(c[g>>2]|0)!=62&(c[g>>2]|0)!=47){if(((((((((((((!((c[g>>2]|0)>=97&(c[g>>2]|0)<=122)?!((c[g>>2]|0)>=65&(c[g>>2]|0)<=90|(c[g>>2]|0)==95|(c[g>>2]|0)==58):0)?!((c[g>>2]|0)>=192&(c[g>>2]|0)<=214):0)?!((c[g>>2]|0)>=216&(c[g>>2]|0)<=246):0)?!((c[g>>2]|0)>=248&(c[g>>2]|0)<=767):0)?!((c[g>>2]|0)>=880&(c[g>>2]|0)<=893):0)?!((c[g>>2]|0)>=895&(c[g>>2]|0)<=8191):0)?!((c[g>>2]|0)>=8204&(c[g>>2]|0)<=8205):0)?!((c[g>>2]|0)>=8304&(c[g>>2]|0)<=8591):0)?!((c[g>>2]|0)>=11264&(c[g>>2]|0)<=12271):0)?!((c[g>>2]|0)>=12289&(c[g>>2]|0)<=55295):0)?!((c[g>>2]|0)>=63744&(c[g>>2]|0)<=64975):0)?!((c[g>>2]|0)>=65008&(c[g>>2]|0)<=65533):0)?!((c[g>>2]|0)>=65536&(c[g>>2]|0)<=983039):0)break;c[e>>2]=1;h=c[e>>2]|0;i=d;return h|0}}else{a=c[g>>2]|0;if((b|0)<256){if(((!(65<=(a|0)&(c[g>>2]|0)<=90)?!(97<=(c[g>>2]|0)&(c[g>>2]|0)<=122):0)?!(192<=(c[g>>2]|0)&(c[g>>2]|0)<=214):0)?!(216<=(c[g>>2]|0)&(c[g>>2]|0)<=246|248<=(c[g>>2]|0)):0)j=24}else if(!(DQ(a,199744)|0))j=24;do if((j|0)==24){a=c[g>>2]|0;if((c[g>>2]|0)<256)if((a|0)==95|(c[g>>2]|0)==58)break;else break a;if(!(19968<=(a|0)&(c[g>>2]|0)<=40869|(c[g>>2]|0)==12295)?!(12321<=(c[g>>2]|0)&(c[g>>2]|0)<=12329|(c[g>>2]|0)==95|(c[g>>2]|0)==58):0)break a}while(0);c[e>>2]=1;h=c[e>>2]|0;i=d;return h|0}while(0);c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}function lh(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;g=i;i=i+144|0;h=g+136|0;j=g+132|0;k=g+128|0;l=g+124|0;m=g+140|0;n=g+120|0;o=g+116|0;p=g+112|0;q=g+108|0;r=g+104|0;s=g+100|0;t=g+96|0;u=g+92|0;v=g+88|0;w=g+84|0;x=g+80|0;y=g+76|0;z=g+72|0;A=g+68|0;B=g+64|0;C=g+60|0;D=g+56|0;E=g+52|0;F=g+48|0;G=g+44|0;H=g+40|0;I=g+36|0;J=g+32|0;K=g+28|0;L=g+24|0;M=g+20|0;N=g+16|0;O=g+12|0;P=g+8|0;Q=g+4|0;R=g;c[j>>2]=b;c[k>>2]=e;c[l>>2]=f;a[m>>0]=0;c[n>>2]=0;c[o>>2]=0;c[p>>2]=0;c[q>>2]=0;c[t>>2]=0;c[u>>2]=0;f=c[j>>2]|0;do if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==34){c[f+172>>2]=12;a[m>>0]=34;me(c[j>>2]|0)}else{if((d[c[(c[f+36>>2]|0)+16>>2]>>0]|0|0)==39){a[m>>0]=39;c[(c[j>>2]|0)+172>>2]=12;me(c[j>>2]|0);break}og(c[j>>2]|0,39,0);c[h>>2]=0;S=c[h>>2]|0;i=g;return S|0}while(0);c[q>>2]=100;c[n>>2]=Cb[c[135752>>2]&511](c[q>>2]|0)|0;a:do if(c[n>>2]|0){c[r>>2]=ne(c[j>>2]|0,s)|0;b:while(1){if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==(d[m>>0]|0|0))break;f=c[r>>2]|0;do if((c[r>>2]|0)<256){if(!((9<=(f|0)&(c[r>>2]|0)<=10|(c[r>>2]|0)==13|32<=(c[r>>2]|0))&(c[r>>2]|0)!=60))break b}else{if(!(256<=(f|0)&(c[r>>2]|0)<=55295)?!(57344<=(c[r>>2]|0)&(c[r>>2]|0)<=65533):0)if(65536<=(c[r>>2]|0)&(c[r>>2]|0)<=1114111&(c[r>>2]|0)!=60)break;else break b;if((c[r>>2]|0)==60)break b}while(0);if((c[(c[j>>2]|0)+172>>2]|0)==-1)break;if((c[p>>2]|0)>>>0>1e7?(c[(c[j>>2]|0)+360>>2]&524288|0)==0:0){T=18;break}if(!(c[r>>2]|0))break;do if((c[r>>2]|0)==38){c[t>>2]=0;f=c[j>>2]|0;if((d[(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==35){c[w>>2]=Ye(f)|0;if((c[w>>2]|0)!=38){if(!(c[w>>2]|0))break;if(((c[p>>2]|0)+10|0)>>>0>(c[q>>2]|0)>>>0){c[C>>2]=(c[q>>2]<<1)+10;if((c[C>>2]|0)>>>0<(c[q>>2]|0)>>>0){T=138;break a}c[B>>2]=Hb[c[135760>>2]&511](c[n>>2]|0,c[C>>2]|0)|0;if(!(c[B>>2]|0)){T=138;break a}c[n>>2]=c[B>>2];c[q>>2]=c[C>>2]}e=qe(0,(c[n>>2]|0)+(c[p>>2]|0)|0,c[w>>2]|0)|0;c[p>>2]=(c[p>>2]|0)+e;break}e=((c[p>>2]|0)+10|0)>>>0>(c[q>>2]|0)>>>0;if(c[(c[j>>2]|0)+16>>2]|0){if(e){c[y>>2]=(c[q>>2]<<1)+10;if((c[y>>2]|0)>>>0<(c[q>>2]|0)>>>0){T=138;break a}c[x>>2]=Hb[c[135760>>2]&511](c[n>>2]|0,c[y>>2]|0)|0;if(!(c[x>>2]|0)){T=138;break a}c[n>>2]=c[x>>2];c[q>>2]=c[y>>2]}b=c[p>>2]|0;c[p>>2]=b+1;a[(c[n>>2]|0)+b>>0]=38;break}else{if(e){c[A>>2]=(c[q>>2]<<1)+10;if((c[A>>2]|0)>>>0<(c[q>>2]|0)>>>0){T=138;break a}c[z>>2]=Hb[c[135760>>2]&511](c[n>>2]|0,c[A>>2]|0)|0;if(!(c[z>>2]|0)){T=138;break a}c[n>>2]=c[z>>2];c[q>>2]=c[A>>2]}e=c[p>>2]|0;c[p>>2]=e+1;a[(c[n>>2]|0)+e>>0]=38;e=c[p>>2]|0;c[p>>2]=e+1;a[(c[n>>2]|0)+e>>0]=35;e=c[p>>2]|0;c[p>>2]=e+1;a[(c[n>>2]|0)+e>>0]=51;e=c[p>>2]|0;c[p>>2]=e+1;a[(c[n>>2]|0)+e>>0]=56;e=c[p>>2]|0;c[p>>2]=e+1;a[(c[n>>2]|0)+e>>0]=59;break}}c[v>>2]=Ef(f)|0;f=(c[j>>2]|0)+440|0;c[f>>2]=(c[f>>2]|0)+1;if(c[v>>2]|0){f=(c[j>>2]|0)+440|0;c[f>>2]=(c[f>>2]|0)+(c[(c[v>>2]|0)+68>>2]|0)}if((c[v>>2]|0)!=0?(c[(c[v>>2]|0)+48>>2]|0)==6:0){if(((c[p>>2]|0)+10|0)>>>0>(c[q>>2]|0)>>>0){c[E>>2]=(c[q>>2]<<1)+10;if((c[E>>2]|0)>>>0<(c[q>>2]|0)>>>0){T=138;break a}c[D>>2]=Hb[c[135760>>2]&511](c[n>>2]|0,c[E>>2]|0)|0;if(!(c[D>>2]|0)){T=138;break a}c[n>>2]=c[D>>2];c[q>>2]=c[E>>2]}if((c[(c[j>>2]|0)+16>>2]|0)==0?(d[c[(c[v>>2]|0)+40>>2]>>0]|0|0)==38:0){f=c[p>>2]|0;c[p>>2]=f+1;a[(c[n>>2]|0)+f>>0]=38;f=c[p>>2]|0;c[p>>2]=f+1;a[(c[n>>2]|0)+f>>0]=35;f=c[p>>2]|0;c[p>>2]=f+1;a[(c[n>>2]|0)+f>>0]=51;f=c[p>>2]|0;c[p>>2]=f+1;a[(c[n>>2]|0)+f>>0]=56;f=c[p>>2]|0;c[p>>2]=f+1;a[(c[n>>2]|0)+f>>0]=59;break}f=a[c[(c[v>>2]|0)+40>>2]>>0]|0;e=c[p>>2]|0;c[p>>2]=e+1;a[(c[n>>2]|0)+e>>0]=f;break}if((c[v>>2]|0)!=0?(c[(c[j>>2]|0)+16>>2]|0)!=0:0){if((c[(c[v>>2]|0)+48>>2]|0)==6){if(((c[p>>2]|0)+10|0)>>>0>(c[q>>2]|0)>>>0){c[I>>2]=(c[q>>2]<<1)+10;if((c[I>>2]|0)>>>0<(c[q>>2]|0)>>>0){T=138;break a}c[H>>2]=Hb[c[135760>>2]&511](c[n>>2]|0,c[I>>2]|0)|0;if(!(c[H>>2]|0)){T=138;break a}c[n>>2]=c[H>>2];c[q>>2]=c[I>>2]}if(!(c[(c[v>>2]|0)+40>>2]|0))break;f=a[c[(c[v>>2]|0)+40>>2]>>0]|0;e=c[p>>2]|0;c[p>>2]=e+1;a[(c[n>>2]|0)+e>>0]=f;break}c[o>>2]=af(c[j>>2]|0,c[(c[v>>2]|0)+40>>2]|0,1,0,0,0)|0;if(!(c[o>>2]|0))break;c[u>>2]=c[o>>2];while(1){if(!(d[c[u>>2]>>0]|0))break;do if((d[c[u>>2]>>0]|0|0)==13)T=61;else{if((d[c[u>>2]>>0]|0|0)==10){T=61;break}if((d[c[u>>2]>>0]|0|0)==9){T=61;break}f=c[u>>2]|0;c[u>>2]=f+1;e=a[f>>0]|0;f=c[p>>2]|0;c[p>>2]=f+1;a[(c[n>>2]|0)+f>>0]=e}while(0);if((T|0)==61){T=0;e=c[p>>2]|0;c[p>>2]=e+1;a[(c[n>>2]|0)+e>>0]=32;c[u>>2]=(c[u>>2]|0)+1}if(((c[p>>2]|0)+10|0)>>>0<=(c[q>>2]|0)>>>0)continue;c[G>>2]=(c[q>>2]<<1)+10;if((c[G>>2]|0)>>>0<(c[q>>2]|0)>>>0){T=138;break a}c[F>>2]=Hb[c[135760>>2]&511](c[n>>2]|0,c[G>>2]|0)|0;if(!(c[F>>2]|0)){T=138;break a}c[n>>2]=c[F>>2];c[q>>2]=c[G>>2]}zb[c[135736>>2]&511](c[o>>2]|0);c[o>>2]=0;break}if(c[v>>2]|0){c[J>>2]=xy(c[(c[v>>2]|0)+8>>2]|0)|0;c[K>>2]=c[(c[v>>2]|0)+8>>2];do if(((c[(c[v>>2]|0)+48>>2]|0)!=6?(c[(c[v>>2]|0)+40>>2]|0)!=0:0)?(c[(c[v>>2]|0)+72>>2]|0)==0:0){c[L>>2]=c[(c[j>>2]|0)+440>>2];c[o>>2]=af(c[j>>2]|0,c[(c[v>>2]|0)+40>>2]|0,1,0,0,0)|0;c[(c[v>>2]|0)+72>>2]=(c[(c[j>>2]|0)+440>>2]|0)-(c[L>>2]|0)+1<<1;if(!(c[o>>2]|0))break;if(vy(c[o>>2]|0,60)|0){e=(c[v>>2]|0)+72|0;c[e>>2]=c[e>>2]|1}zb[c[135736>>2]&511](c[o>>2]|0);c[o>>2]=0}while(0);e=c[p>>2]|0;c[p>>2]=e+1;a[(c[n>>2]|0)+e>>0]=38;while(1){if(((c[p>>2]|0)+(c[J>>2]|0)+10|0)>>>0<=(c[q>>2]|0)>>>0)break;c[N>>2]=(c[q>>2]<<1)+(c[J>>2]|0)+10;if((c[N>>2]|0)>>>0<(c[q>>2]|0)>>>0){T=138;break a}c[M>>2]=Hb[c[135760>>2]&511](c[n>>2]|0,c[N>>2]|0)|0;if(!(c[M>>2]|0)){T=138;break a}c[n>>2]=c[M>>2];c[q>>2]=c[N>>2]}while(1){if((c[J>>2]|0)<=0)break;e=c[K>>2]|0;c[K>>2]=e+1;f=a[e>>0]|0;e=c[p>>2]|0;c[p>>2]=e+1;a[(c[n>>2]|0)+e>>0]=f;c[J>>2]=(c[J>>2]|0)+-1}f=c[p>>2]|0;c[p>>2]=f+1;a[(c[n>>2]|0)+f>>0]=59}}else{if((c[r>>2]|0)==32|(c[r>>2]|0)==13|(c[r>>2]|0)==10|(c[r>>2]|0)==9){if(!((c[p>>2]|0)==0&(c[l>>2]|0)!=0)){c:do if(!((c[l>>2]|0)!=0&(c[t>>2]|0)!=0)){f=c[p>>2]|0;if((c[s>>2]|0)==1){c[p>>2]=f+1;a[(c[n>>2]|0)+f>>0]=32}else{e=pe((c[n>>2]|0)+f|0,32)|0;c[p>>2]=(c[p>>2]|0)+e}while(1){if(((c[p>>2]|0)+10|0)>>>0<=(c[q>>2]|0)>>>0)break c;c[P>>2]=(c[q>>2]<<1)+10;if((c[P>>2]|0)>>>0<(c[q>>2]|0)>>>0){T=138;break a}c[O>>2]=Hb[c[135760>>2]&511](c[n>>2]|0,c[P>>2]|0)|0;if(!(c[O>>2]|0)){T=138;break a}c[n>>2]=c[O>>2];c[q>>2]=c[P>>2]}}while(0);c[t>>2]=1}}else{c[t>>2]=0;if((c[s>>2]|0)==1){e=c[r>>2]&255;f=c[p>>2]|0;c[p>>2]=f+1;a[(c[n>>2]|0)+f>>0]=e}else{e=pe((c[n>>2]|0)+(c[p>>2]|0)|0,c[r>>2]|0)|0;c[p>>2]=(c[p>>2]|0)+e}if(((c[p>>2]|0)+10|0)>>>0>(c[q>>2]|0)>>>0){c[R>>2]=(c[q>>2]<<1)+10;if((c[R>>2]|0)>>>0<(c[q>>2]|0)>>>0){T=138;break a}c[Q>>2]=Hb[c[135760>>2]&511](c[n>>2]|0,c[R>>2]|0)|0;if(!(c[Q>>2]|0)){T=138;break a}c[n>>2]=c[Q>>2];c[q>>2]=c[R>>2]}}e=c[(c[j>>2]|0)+36>>2]|0;if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){f=e+28|0;c[f>>2]=(c[f>>2]|0)+1;c[(c[(c[j>>2]|0)+36>>2]|0)+32>>2]=1}else{f=e+32|0;c[f>>2]=(c[f>>2]|0)+1}f=(c[(c[j>>2]|0)+36>>2]|0)+16|0;c[f>>2]=(c[f>>2]|0)+(c[s>>2]|0);if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[j>>2]|0)}while(0);if((c[(c[j>>2]|0)+292>>2]|0)==0?((c[(c[(c[j>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[j>>2]|0);c[r>>2]=ne(c[j>>2]|0,s)|0}if((T|0)==18){xg(c[j>>2]|0,40,71720);T=138;break}if((c[(c[j>>2]|0)+172>>2]|0)!=-1){d:do if((c[t>>2]|0)!=0&(c[l>>2]|0)!=0&(c[p>>2]|0)>>>0>0)do{if((d[(c[n>>2]|0)+((c[p>>2]|0)-1)>>0]|0|0)!=32)break d;c[p>>2]=(c[p>>2]|0)+-1}while((c[p>>2]|0)>>>0>0);while(0);a[(c[n>>2]|0)+(c[p>>2]|0)>>0]=0;f=c[j>>2]|0;e:do if((d[c[(c[(c[j>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60)og(f,38,0);else{if((d[c[(c[f+36>>2]|0)+16>>2]>>0]|0|0)==(d[m>>0]|0|0)){me(c[j>>2]|0);break}do if(c[r>>2]|0){e=c[r>>2]|0;if((c[r>>2]|0)<256){if(9<=(e|0)&(c[r>>2]|0)<=10|(c[r>>2]|0)==13|32<=(c[r>>2]|0))break}else{if(256<=(e|0)&(c[r>>2]|0)<=55295)break;if(57344<=(c[r>>2]|0)&(c[r>>2]|0)<=65533)break;if(65536<=(c[r>>2]|0)&(c[r>>2]|0)<=1114111)break}xg(c[j>>2]|0,9,71752);break e}while(0);xg(c[j>>2]|0,40,71792)}while(0);if((c[p>>2]|0)>>>0>=2147483647){xg(c[j>>2]|0,40,71720);T=138;break}if(c[k>>2]|0)c[c[k>>2]>>2]=c[p>>2];c[h>>2]=c[n>>2];S=c[h>>2]|0;i=g;return S|0}}else T=138;while(0);if((T|0)==138)ie(c[j>>2]|0,0);if(c[n>>2]|0)zb[c[135736>>2]&511](c[n>>2]|0);if(c[o>>2]|0)zb[c[135736>>2]&511](c[o>>2]|0);c[h>>2]=0;S=c[h>>2]|0;i=g;return S|0}function mh(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=c[h>>2];if((c[(c[g>>2]|0)+292>>2]|0)==0?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[g>>2]|0);if((c[(c[g>>2]|0)+172>>2]|0)==-1){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}c[k>>2]=c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2];while(1){if(!(d[c[k>>2]>>0]|0))break;if((d[c[k>>2]>>0]|0|0)!=(d[c[j>>2]>>0]|0|0))break;c[k>>2]=(c[k>>2]|0)+1;c[j>>2]=(c[j>>2]|0)+1;b=(c[(c[g>>2]|0)+36>>2]|0)+32|0;c[b>>2]=(c[b>>2]|0)+1}a:do if(!(d[c[j>>2]>>0]|0)){do if((d[c[k>>2]>>0]|0|0)!=62?(d[c[k>>2]>>0]|0|0)!=32:0){if(9<=(d[c[k>>2]>>0]|0|0)?(d[c[k>>2]>>0]|0|0)<=10:0)break;if((d[c[k>>2]>>0]|0|0)!=13)break a}while(0);c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]=c[k>>2];c[f>>2]=1;m=c[f>>2]|0;i=e;return m|0}while(0);c[l>>2]=Ze(c[g>>2]|0)|0;if((c[l>>2]|0)==(c[h>>2]|0)){c[f>>2]=1;m=c[f>>2]|0;i=e;return m|0}else{c[f>>2]=c[l>>2];m=c[f>>2]|0;i=e;return m|0}return 0}function nh(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[g>>2]=a;c[h>>2]=b;if((c[(c[g>>2]|0)+292>>2]|0)==0?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[g>>2]|0);c[j>>2]=yh(c[g>>2]|0)|0;b=(d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==58;if(!(c[j>>2]|0)){if(b?(c[j>>2]=Ze(c[g>>2]|0)|0,(c[j>>2]|0)!=0):0){Jg(c[g>>2]|0,202,70824,c[j>>2]|0,0,0);c[c[h>>2]>>2]=0;c[f>>2]=c[j>>2];n=c[f>>2]|0;i=e;return n|0}c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}do if(b){me(c[g>>2]|0);c[k>>2]=c[j>>2];c[j>>2]=yh(c[g>>2]|0)|0;a=c[g>>2]|0;if(!(c[j>>2]|0)){Jg(a,202,70856,c[k>>2]|0,0,0);c[j>>2]=cf(c[g>>2]|0)|0;if(!(c[j>>2]|0))c[l>>2]=Bh(65640,c[k>>2]|0,0,0)|0;else{c[l>>2]=Bh(c[j>>2]|0,c[k>>2]|0,0,0)|0;zb[c[135736>>2]&511](c[j>>2]|0)}c[k>>2]=AP(c[(c[g>>2]|0)+296>>2]|0,c[l>>2]|0,-1)|0;if(c[l>>2]|0)zb[c[135736>>2]&511](c[l>>2]|0);c[c[h>>2]>>2]=0;c[f>>2]=c[k>>2];n=c[f>>2]|0;i=e;return n|0}if((d[c[(c[a+36>>2]|0)+16>>2]>>0]|0|0)!=58){c[c[h>>2]>>2]=c[k>>2];break}Jg(c[g>>2]|0,202,70888,c[k>>2]|0,c[j>>2]|0,0);me(c[g>>2]|0);c[m>>2]=Ze(c[g>>2]|0)|0;if(c[m>>2]|0){c[m>>2]=Bh(c[m>>2]|0,c[j>>2]|0,0,0)|0;c[j>>2]=AP(c[(c[g>>2]|0)+296>>2]|0,c[m>>2]|0,-1)|0;if(c[m>>2]|0)zb[c[135736>>2]&511](c[m>>2]|0);c[c[h>>2]>>2]=c[k>>2];c[f>>2]=c[j>>2];n=c[f>>2]|0;i=e;return n|0}else{c[m>>2]=Bh(65640,c[j>>2]|0,0,0)|0;c[j>>2]=AP(c[(c[g>>2]|0)+296>>2]|0,c[m>>2]|0,-1)|0;if(c[m>>2]|0)zb[c[135736>>2]&511](c[m>>2]|0);c[c[h>>2]>>2]=c[k>>2];c[f>>2]=c[j>>2];n=c[f>>2]|0;i=e;return n|0}}else c[c[h>>2]>>2]=0;while(0);c[f>>2]=c[j>>2];n=c[f>>2]|0;i=e;return n|0}function oh(a,b,e,f,g,h,j){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;k=i;i=i+64|0;l=k+52|0;m=k+48|0;n=k+44|0;o=k+40|0;p=k+36|0;q=k+32|0;r=k+28|0;s=k+24|0;t=k+20|0;u=k+16|0;v=k+12|0;w=k+8|0;x=k+4|0;y=k;c[m>>2]=a;c[n>>2]=b;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;c[r>>2]=h;c[s>>2]=j;c[v>>2]=0;c[w>>2]=0;c[c[q>>2]>>2]=0;if((c[(c[m>>2]|0)+292>>2]|0)==0?((c[(c[(c[m>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[m>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[m>>2]|0);c[t>>2]=nh(c[m>>2]|0,c[p>>2]|0)|0;j=c[m>>2]|0;if(!(c[t>>2]|0)){xg(j,68,69032);c[l>>2]=0;z=c[l>>2]|0;i=k;return z|0}if((c[j+352>>2]|0)!=0?(c[x>>2]=Vj(c[(c[m>>2]|0)+352>>2]|0,c[n>>2]|0,c[o>>2]|0,c[c[p>>2]>>2]|0,c[t>>2]|0)|0,(c[x>>2]|0)!=0):0)c[w>>2]=1;Ue(c[m>>2]|0)|0;x=c[m>>2]|0;if((d[c[(c[(c[m>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=61){pg(x,41,69064,c[t>>2]|0);c[l>>2]=0;z=c[l>>2]|0;i=k;return z|0}me(x);Ue(c[m>>2]|0)|0;c[u>>2]=Eg(c[m>>2]|0,c[r>>2]|0,c[s>>2]|0,c[w>>2]|0)|0;if((((c[w>>2]|0)!=0?(c[c[s>>2]>>2]|0)!=0:0)?(c[y>>2]=zh(c[m>>2]|0,c[u>>2]|0,c[r>>2]|0)|0,(c[y>>2]|0)!=0):0)?(c[y>>2]|0)!=(c[u>>2]|0):0){zb[c[135736>>2]&511](c[u>>2]|0);c[u>>2]=c[y>>2]}c[(c[m>>2]|0)+172>>2]=7;if((c[c[p>>2]>>2]|0)==(c[(c[m>>2]|0)+312>>2]|0)){if(((c[(c[m>>2]|0)+268>>2]|0)!=0?(qy(c[t>>2]|0,71704)|0)!=0:0)?(c[v>>2]=ly(c[u>>2]|0,c[c[r>>2]>>2]|0)|0,(Ne(c[v>>2]|0)|0)==0):0)rg(c[m>>2]|0,98,69128,c[v>>2]|0,0);do if(qy(c[t>>2]|0,71712)|0){c[v>>2]=ly(c[u>>2]|0,c[c[r>>2]>>2]|0)|0;if(qy(c[v>>2]|0,69184)|0){c[c[(c[m>>2]|0)+232>>2]>>2]=0;break}p=(qy(c[v>>2]|0,69192)|0)!=0;y=c[m>>2]|0;if(p){c[c[y+232>>2]>>2]=1;break}else{rg(y,102,69208,c[v>>2]|0,0);break}}while(0);if(c[v>>2]|0)zb[c[135736>>2]&511](c[v>>2]|0)}c[c[q>>2]>>2]=c[u>>2];c[l>>2]=c[t>>2];z=c[l>>2]|0;i=k;return z|0}function ph(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+48|0;j=h;k=h+32|0;l=h+28|0;m=h+24|0;n=h+20|0;
o=h+16|0;p=h+12|0;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;if(((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+212>>2]|0)!=0:0)?(c[(c[k>>2]|0)+172>>2]|0)==-1:0){i=h;return}g=c[k>>2]|0;k=c[l>>2]|0;l=c[n>>2]|0;f=c[o>>2]|0;e=c[p>>2]|0;d=c[m>>2]|0;m=c[o>>2]|0;o=c[p>>2]|0;c[j>>2]=c[n>>2];c[j+4>>2]=m;c[j+8>>2]=o;Xd(0,0,0,g,0,3,k,1,0,0,l,f,e,0,0,d,j);i=h;return}function qh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;if(!(c[(c[f>>2]|0)+300>>2]|0)){c[k>>2]=55;c[h>>2]=Cb[c[135744>>2]&511](c[k>>2]<<2)|0;if((c[h>>2]|0)!=0?(c[(c[f>>2]|0)+300>>2]=c[h>>2],c[j>>2]=Cb[c[135744>>2]&511](((c[k>>2]|0)/5|0)<<2)|0,(c[j>>2]|0)!=0):0){c[(c[f>>2]|0)+340>>2]=c[j>>2];c[(c[f>>2]|0)+304>>2]=c[k>>2];l=9}else l=10}else if(((c[g>>2]|0)+5|0)>(c[(c[f>>2]|0)+304>>2]|0)){c[k>>2]=(c[g>>2]|0)+5<<1;c[h>>2]=Hb[c[135760>>2]&511](c[(c[f>>2]|0)+300>>2]|0,c[k>>2]<<2)|0;if((c[h>>2]|0)!=0?(c[(c[f>>2]|0)+300>>2]=c[h>>2],c[j>>2]=Hb[c[135760>>2]&511](c[(c[f>>2]|0)+340>>2]|0,((c[k>>2]|0)/5|0)<<2)|0,(c[j>>2]|0)!=0):0){c[(c[f>>2]|0)+340>>2]=c[j>>2];c[(c[f>>2]|0)+304>>2]=c[k>>2];l=9}else l=10}else l=9;if((l|0)==9){c[e>>2]=c[(c[f>>2]|0)+304>>2];m=c[e>>2]|0;i=d;return m|0}else if((l|0)==10){ie(c[f>>2]|0,0);c[e>>2]=-1;m=c[e>>2]|0;i=d;return m|0}return 0}function rh(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f+28|0;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f+4|0;o=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=e;e=c[h>>2]|0;if(!(c[k>>2]|0)){c[g>>2]=mh(e,c[j>>2]|0)|0;p=c[g>>2]|0;i=f;return p|0}if((c[e+292>>2]|0)==0?((c[(c[(c[h>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[h>>2]|0);c[m>>2]=c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2];c[l>>2]=c[k>>2];while(1){if(!(d[c[m>>2]>>0]|0))break;if((d[c[m>>2]>>0]|0|0)!=(d[c[l>>2]>>0]|0|0))break;c[m>>2]=(c[m>>2]|0)+1;c[l>>2]=(c[l>>2]|0)+1}a:do if((d[c[l>>2]>>0]|0|0)==0?(d[c[m>>2]>>0]|0|0)==58:0){c[m>>2]=(c[m>>2]|0)+1;c[l>>2]=c[j>>2];while(1){if(!(d[c[m>>2]>>0]|0))break;if((d[c[m>>2]>>0]|0|0)!=(d[c[l>>2]>>0]|0|0))break;c[m>>2]=(c[m>>2]|0)+1;c[l>>2]=(c[l>>2]|0)+1}if(!(d[c[l>>2]>>0]|0)){do if((d[c[m>>2]>>0]|0|0)!=62?(d[c[m>>2]>>0]|0|0)!=32:0){if(9<=(d[c[m>>2]>>0]|0|0)?(d[c[m>>2]>>0]|0|0)<=10:0)break;if((d[c[m>>2]>>0]|0|0)!=13)break a}while(0);c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]=c[m>>2];c[g>>2]=1;p=c[g>>2]|0;i=f;return p|0}}while(0);c[n>>2]=nh(c[h>>2]|0,o)|0;if((c[n>>2]|0)==(c[j>>2]|0)?(c[k>>2]|0)==(c[o>>2]|0):0){c[g>>2]=1;p=c[g>>2]|0;i=f;return p|0}c[g>>2]=c[n>>2];p=c[g>>2]|0;i=f;return p|0}function sh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[g+4>>2]=f;c[m>>2]=c[j>>2];if((c[h>>2]|0)!=1){i=g;return}ck(c[(c[m>>2]|0)+352>>2]|0,c[k>>2]|0,c[l>>2]|0,0)|0;i=g;return}function th(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;c[g>>2]=a;c[h>>2]=b;c[j>>2]=e;if((c[g>>2]|0)==0|(c[h>>2]|0)==0|(c[j>>2]|0)==0){Db[c[135904>>2]&511](c[33980]|0,70648,f);i=f;return}if((c[(c[g>>2]|0)+292>>2]|0)!=0?(c[(c[g>>2]|0)+40>>2]|0)==1:0){c[k>>2]=c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2];c[k>>2]=(c[k>>2]|0)+-1;while(1){if((c[k>>2]|0)>>>0>=(c[(c[(c[g>>2]|0)+36>>2]|0)+12>>2]|0)>>>0)l=(d[c[k>>2]>>0]|0|0)!=60;else l=0;m=c[k>>2]|0;if(!l)break;c[k>>2]=m+-1}if(m>>>0<(c[(c[(c[g>>2]|0)+36>>2]|0)+12>>2]|0)>>>0){c[c[h>>2]>>2]=0;c[c[j>>2]>>2]=0;i=f;return}c[c[h>>2]>>2]=c[k>>2];c[k>>2]=(c[k>>2]|0)+1;while(1){if((c[k>>2]|0)>>>0<(c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)>>>0)n=(d[c[k>>2]>>0]|0|0)!=62;else n=0;o=c[k>>2]|0;if(!n)break;m=c[k>>2]|0;if((d[o>>0]|0|0)==39){c[k>>2]=m+1;while(1){if((c[k>>2]|0)>>>0<(c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)>>>0)p=(d[c[k>>2]>>0]|0|0)!=39;else p=0;q=c[k>>2]|0;if(!p)break;c[k>>2]=q+1}if(q>>>0>=(c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)>>>0)continue;c[k>>2]=(c[k>>2]|0)+1;continue}else{l=(d[m>>0]|0|0)==34;c[k>>2]=(c[k>>2]|0)+1;if(!l)continue;while(1){if((c[k>>2]|0)>>>0<(c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)>>>0)r=(d[c[k>>2]>>0]|0|0)!=34;else r=0;s=c[k>>2]|0;if(!r)break;c[k>>2]=s+1}if(s>>>0>=(c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)>>>0)continue;c[k>>2]=(c[k>>2]|0)+1;continue}}if(o>>>0<(c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)>>>0){c[c[j>>2]>>2]=c[k>>2];i=f;return}c[k>>2]=c[c[h>>2]>>2];c[k>>2]=(c[k>>2]|0)+-1;while(1){if((c[k>>2]|0)>>>0>=(c[(c[(c[g>>2]|0)+36>>2]|0)+12>>2]|0)>>>0)t=(d[c[k>>2]>>0]|0|0)!=62;else t=0;u=c[k>>2]|0;if(!t)break;c[k>>2]=u+-1}if(u>>>0>=(c[(c[(c[g>>2]|0)+36>>2]|0)+12>>2]|0)>>>0){c[c[j>>2]>>2]=c[k>>2];i=f;return}else{c[c[j>>2]>>2]=0;i=f;return}}c[c[h>>2]>>2]=0;c[c[j>>2]>>2]=0;i=f;return}function uh(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+32|0;j=h+20|0;k=h+16|0;l=h+26|0;m=h+25|0;n=h+24|0;o=h+12|0;p=h+8|0;q=h+4|0;r=h;c[k>>2]=b;a[l>>0]=e;a[m>>0]=f;a[n>>0]=g;c[q>>2]=c[(c[k>>2]|0)+36>>2];if(!(c[q>>2]|0)){c[j>>2]=-1;s=c[j>>2]|0;i=h;return s|0}c[o>>2]=(c[(c[q>>2]|0)+16>>2]|0)-(c[(c[q>>2]|0)+12>>2]|0);if((c[o>>2]|0)<0){c[j>>2]=-1;s=c[j>>2]|0;i=h;return s|0}if((c[(c[k>>2]|0)+204>>2]|0)>(c[o>>2]|0))c[o>>2]=c[(c[k>>2]|0)+204>>2];g=c[q>>2]|0;if(!(c[c[q>>2]>>2]|0)){c[r>>2]=c[g+12>>2];c[p>>2]=c[(c[q>>2]|0)+24>>2]}else{c[r>>2]=Vy(c[(c[g>>2]|0)+16>>2]|0)|0;c[p>>2]=_y(c[(c[c[q>>2]>>2]|0)+16>>2]|0)|0}if(!(a[n>>0]|0)){if(a[m>>0]|0)c[p>>2]=(c[p>>2]|0)+-1}else c[p>>2]=(c[p>>2]|0)-2;a:while(1){t=c[o>>2]|0;if((c[o>>2]|0)>=(c[p>>2]|0)){u=23;break}do if((d[(c[r>>2]|0)+t>>0]|0)==(d[l>>0]|0))if(d[n>>0]|0){if((d[(c[r>>2]|0)+((c[o>>2]|0)+1)>>0]|0)!=(d[m>>0]|0))break;if((d[(c[r>>2]|0)+((c[o>>2]|0)+2)>>0]|0)!=(d[n>>0]|0))break;else{u=21;break a}}else{if(!(d[m>>0]|0)){u=21;break a}if((d[(c[r>>2]|0)+((c[o>>2]|0)+1)>>0]|0)!=(d[m>>0]|0))break;else{u=21;break a}}while(0);c[o>>2]=(c[o>>2]|0)+1}if((u|0)==21){c[(c[k>>2]|0)+204>>2]=0;c[j>>2]=(c[o>>2]|0)-((c[(c[q>>2]|0)+16>>2]|0)-(c[(c[q>>2]|0)+12>>2]|0));s=c[j>>2]|0;i=h;return s|0}else if((u|0)==23){c[(c[k>>2]|0)+204>>2]=t;c[j>>2]=-1;s=c[j>>2]|0;i=h;return s|0}return 0}function vh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+32|0;h=g+28|0;j=g+24|0;k=g+20|0;l=g+16|0;m=g+12|0;n=g+8|0;o=g+4|0;p=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;a:do if((c[(c[j>>2]|0)+188>>2]|0)>=(c[(c[j>>2]|0)+192>>2]|0)){f=(c[j>>2]|0)+192|0;c[f>>2]=c[f>>2]<<1;c[o>>2]=Hb[c[135760>>2]&511](c[(c[j>>2]|0)+196>>2]|0,c[(c[j>>2]|0)+192>>2]<<2)|0;do if(c[o>>2]|0){c[(c[j>>2]|0)+196>>2]=c[o>>2];c[p>>2]=Hb[c[135760>>2]&511](c[(c[j>>2]|0)+344>>2]|0,(c[(c[j>>2]|0)+192>>2]|0)*3<<2)|0;if(!(c[p>>2]|0)){f=(c[j>>2]|0)+192|0;c[f>>2]=(c[f>>2]|0)/2|0;break}else{c[(c[j>>2]|0)+344>>2]=c[p>>2];break a}}else{f=(c[j>>2]|0)+192|0;c[f>>2]=(c[f>>2]|0)/2|0}while(0);ie(c[j>>2]|0,0);c[h>>2]=-1;q=c[h>>2]|0;i=g;return q|0}while(0);c[(c[(c[j>>2]|0)+196>>2]|0)+(c[(c[j>>2]|0)+188>>2]<<2)>>2]=c[k>>2];c[(c[j>>2]|0)+184>>2]=c[k>>2];c[(c[(c[j>>2]|0)+344>>2]|0)+((c[(c[j>>2]|0)+188>>2]|0)*3<<2)>>2]=c[l>>2];c[(c[(c[j>>2]|0)+344>>2]|0)+(((c[(c[j>>2]|0)+188>>2]|0)*3|0)+1<<2)>>2]=c[m>>2];c[(c[(c[j>>2]|0)+344>>2]|0)+(((c[(c[j>>2]|0)+188>>2]|0)*3|0)+2<<2)>>2]=c[n>>2];n=(c[j>>2]|0)+188|0;j=c[n>>2]|0;c[n>>2]=j+1;c[h>>2]=j;q=c[h>>2]|0;i=g;return q|0}function wh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if((c[(c[e>>2]|0)+188>>2]|0)<=0){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}a=(c[e>>2]|0)+188|0;c[a>>2]=(c[a>>2]|0)+-1;a=c[e>>2]|0;if((c[(c[e>>2]|0)+188>>2]|0)>0)c[(c[e>>2]|0)+184>>2]=c[(c[(c[e>>2]|0)+196>>2]|0)+((c[a+188>>2]|0)-1<<2)>>2];else c[a+184>>2]=0;c[f>>2]=c[(c[(c[e>>2]|0)+196>>2]|0)+(c[(c[e>>2]|0)+188>>2]<<2)>>2];c[(c[(c[e>>2]|0)+196>>2]|0)+(c[(c[e>>2]|0)+188>>2]<<2)>>2]=0;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}function xh(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f+20|0;m=f;c[h>>2]=b;c[j>>2]=e;if((c[h>>2]|0)==0|(c[j>>2]|0)<=0){c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}c[k>>2]=0;while(1){o=c[k>>2]|0;if((c[k>>2]|0)>=(c[j>>2]|0)){p=53;break}a[l>>0]=a[(c[h>>2]|0)+o>>0]|0;e=d[l>>0]|0;if(!((d[l>>0]|0)&128)){if((e|0)>=32){c[k>>2]=(c[k>>2]|0)+1;continue}if(((d[l>>0]|0|0)!=10?(d[l>>0]|0|0)!=13:0)?(d[l>>0]|0|0)!=9:0){p=12;break}c[k>>2]=(c[k>>2]|0)+1;continue}if((e&224|0)==192){q=c[k>>2]|0;if(((c[k>>2]|0)+2|0)>(c[j>>2]|0)){p=15;break}r=c[k>>2]|0;if(((d[(c[h>>2]|0)+(q+1)>>0]|0)&192|0)!=128){p=17;break}c[m>>2]=((d[(c[h>>2]|0)+r>>0]|0)&31)<<6;c[m>>2]=c[m>>2]|(d[(c[h>>2]|0)+((c[k>>2]|0)+1)>>0]|0)&63;e=c[m>>2]|0;if((c[m>>2]|0)<256){if(!(9<=(e|0)&(c[m>>2]|0)<=10|(c[m>>2]|0)==13|32<=(c[m>>2]|0))){p=23;break}}else if((!(256<=(e|0)&(c[m>>2]|0)<=55295)?!(57344<=(c[m>>2]|0)&(c[m>>2]|0)<=65533):0)?!(65536<=(c[m>>2]|0)&(c[m>>2]|0)<=1114111):0){p=23;break}c[k>>2]=(c[k>>2]|0)+2;continue}if(((d[l>>0]|0)&240|0)==224){s=c[k>>2]|0;if(((c[k>>2]|0)+3|0)>(c[j>>2]|0)){p=27;break}if(((d[(c[h>>2]|0)+(s+1)>>0]|0)&192|0)!=128){p=30;break}if(((d[(c[h>>2]|0)+((c[k>>2]|0)+2)>>0]|0)&192|0)!=128){p=30;break}c[m>>2]=((d[(c[h>>2]|0)+(c[k>>2]|0)>>0]|0)&15)<<12;c[m>>2]=c[m>>2]|((d[(c[h>>2]|0)+((c[k>>2]|0)+1)>>0]|0)&63)<<6;c[m>>2]=c[m>>2]|(d[(c[h>>2]|0)+((c[k>>2]|0)+2)>>0]|0)&63;e=c[m>>2]|0;if((c[m>>2]|0)<256){if(!(9<=(e|0)&(c[m>>2]|0)<=10|(c[m>>2]|0)==13|32<=(c[m>>2]|0))){p=36;break}}else if((!(256<=(e|0)&(c[m>>2]|0)<=55295)?!(57344<=(c[m>>2]|0)&(c[m>>2]|0)<=65533):0)?!(65536<=(c[m>>2]|0)&(c[m>>2]|0)<=1114111):0){p=36;break}c[k>>2]=(c[k>>2]|0)+3;continue}t=c[k>>2]|0;if(((d[l>>0]|0)&248|0)!=240){p=52;break}u=c[k>>2]|0;if((t+4|0)>(c[j>>2]|0)){p=40;break}if(((d[(c[h>>2]|0)+(u+1)>>0]|0)&192|0)!=128){p=44;break}if(((d[(c[h>>2]|0)+((c[k>>2]|0)+2)>>0]|0)&192|0)!=128){p=44;break}if(((d[(c[h>>2]|0)+((c[k>>2]|0)+3)>>0]|0)&192|0)!=128){p=44;break}c[m>>2]=((d[(c[h>>2]|0)+(c[k>>2]|0)>>0]|0)&7)<<18;c[m>>2]=c[m>>2]|((d[(c[h>>2]|0)+((c[k>>2]|0)+1)>>0]|0)&63)<<12;c[m>>2]=c[m>>2]|((d[(c[h>>2]|0)+((c[k>>2]|0)+2)>>0]|0)&63)<<6;c[m>>2]=c[m>>2]|(d[(c[h>>2]|0)+((c[k>>2]|0)+3)>>0]|0)&63;e=c[m>>2]|0;if((c[m>>2]|0)<256){if(!(9<=(e|0)&(c[m>>2]|0)<=10|(c[m>>2]|0)==13|32<=(c[m>>2]|0))){p=50;break}}else if((!(256<=(e|0)&(c[m>>2]|0)<=55295)?!(57344<=(c[m>>2]|0)&(c[m>>2]|0)<=65533):0)?!(65536<=(c[m>>2]|0)&(c[m>>2]|0)<=1114111):0){p=50;break}c[k>>2]=(c[k>>2]|0)+4}switch(p|0){case 12:{c[g>>2]=0-(c[k>>2]|0);n=c[g>>2]|0;i=f;return n|0}case 15:{c[g>>2]=q;n=c[g>>2]|0;i=f;return n|0}case 17:{c[g>>2]=0-r;n=c[g>>2]|0;i=f;return n|0}case 23:{c[g>>2]=0-(c[k>>2]|0);n=c[g>>2]|0;i=f;return n|0}case 27:{c[g>>2]=s;n=c[g>>2]|0;i=f;return n|0}case 30:{c[g>>2]=0-(c[k>>2]|0);n=c[g>>2]|0;i=f;return n|0}case 36:{c[g>>2]=0-(c[k>>2]|0);n=c[g>>2]|0;i=f;return n|0}case 40:{c[g>>2]=u;n=c[g>>2]|0;i=f;return n|0}case 44:{c[g>>2]=0-(c[k>>2]|0);n=c[g>>2]|0;i=f;return n|0}case 50:{c[g>>2]=0-(c[k>>2]|0);n=c[g>>2]|0;i=f;return n|0}case 52:{c[g>>2]=0-t;n=c[g>>2]|0;i=f;return n|0}case 53:{c[g>>2]=o;n=c[g>>2]|0;i=f;return n|0}}return 0}function yh(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+32|0;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;j=b;c[f>>2]=a;c[j>>2]=0;c[g>>2]=c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2];if((d[c[g>>2]>>0]|0|0)>=97?(d[c[g>>2]>>0]|0|0)<=122:0)k=6;else k=3;do if((k|0)==3){if((d[c[g>>2]>>0]|0|0)>=65?(d[c[g>>2]>>0]|0|0)<=90:0){k=6;break}if((d[c[g>>2]>>0]|0|0)==95)k=6}while(0);if((k|0)==6){c[g>>2]=(c[g>>2]|0)+1;while(1){if((d[c[g>>2]>>0]|0|0)>=97?(d[c[g>>2]>>0]|0|0)<=122:0)l=1;else k=9;do if((k|0)==9){k=0;if((d[c[g>>2]>>0]|0|0)>=65?(d[c[g>>2]>>0]|0|0)<=90:0){l=1;break}if((d[c[g>>2]>>0]|0|0)>=48?(d[c[g>>2]>>0]|0|0)<=57:0){l=1;break}if((d[c[g>>2]>>0]|0|0)!=95?(d[c[g>>2]>>0]|0|0)!=45:0)l=(d[c[g>>2]>>0]|0|0)==46;else l=1}while(0);m=c[g>>2]|0;if(!l)break;c[g>>2]=m+1}if((d[m>>0]|0|0)>0?(d[c[g>>2]>>0]|0|0)<128:0){c[j>>2]=(c[g>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0);if((c[j>>2]|0)>5e4?(c[(c[f>>2]|0)+360>>2]&524288|0)==0:0){og(c[f>>2]|0,110,70920);c[e>>2]=0;n=c[e>>2]|0;i=b;return n|0}c[h>>2]=AP(c[(c[f>>2]|0)+296>>2]|0,c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0,c[j>>2]|0)|0;c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]=c[g>>2];g=(c[f>>2]|0)+200|0;c[g>>2]=(c[g>>2]|0)+(c[j>>2]|0);g=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[g>>2]=(c[g>>2]|0)+(c[j>>2]|0);if(!(c[h>>2]|0))ie(c[f>>2]|0,0);c[e>>2]=c[h>>2];n=c[e>>2]|0;i=b;return n|0}}c[e>>2]=Ah(c[f>>2]|0)|0;n=c[e>>2]|0;i=b;return n|0}function zh(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+48|0;g=f+32|0;h=f+28|0;j=f+24|0;k=f+20|0;l=f+16|0;m=f+12|0;n=f+8|0;o=f+4|0;p=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=e;c[m>>2]=0;c[n>>2]=0;if((c[h>>2]|0)==0|(c[j>>2]|0)==0|(c[k>>2]|0)==0){c[g>>2]=0;q=c[g>>2]|0;i=f;return q|0}c[l>>2]=c[c[k>>2]>>2];if((c[l>>2]|0)<=0){c[g>>2]=0;q=c[g>>2]|0;i=f;return q|0}c[o>>2]=c[j>>2];while(1){if((d[c[o>>2]>>0]|0|0)!=32)break;c[o>>2]=(c[o>>2]|0)+1;c[m>>2]=(c[m>>2]|0)+1}while(1){if(!(d[c[o>>2]>>0]|0))break;e=(d[c[o>>2]>>0]|0|0)==32;c[o>>2]=(c[o>>2]|0)+1;if(!e)continue;if((d[c[o>>2]>>0]|0|0)==32){r=12;break}if(!(d[c[o>>2]>>0]|0)){r=12;break}}if((r|0)==12)c[n>>2]=1;if(c[n>>2]|0){c[p>>2]=ly((c[j>>2]|0)+(c[m>>2]|0)|0,(c[l>>2]|0)-(c[m>>2]|0)+1|0)|0;if(!(c[p>>2]|0)){ie(c[h>>2]|0,0);c[g>>2]=0;q=c[g>>2]|0;i=f;return q|0}else{Mg(c[p>>2]|0,c[p>>2]|0)|0;h=ZT(c[p>>2]|0)|0;c[c[k>>2]>>2]=h;c[g>>2]=c[p>>2];q=c[g>>2]|0;i=f;return q|0}}else if(c[m>>2]|0){p=c[k>>2]|0;c[p>>2]=(c[p>>2]|0)-(c[m>>2]|0);fU(c[j>>2]|0,(c[j>>2]|0)+(c[m>>2]|0)|0,1+(c[c[k>>2]>>2]|0)|0)|0;c[g>>2]=c[j>>2];q=c[g>>2]|0;i=f;return q|0}else{c[g>>2]=0;q=c[g>>2]|0;i=f;return q|0}return 0}function Ah(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+32|0;e=b+24|0;f=b+20|0;g=b+16|0;h=b+12|0;j=b+8|0;k=b+4|0;l=b;c[f>>2]=a;c[g>>2]=0;c[k>>2]=0;if((c[(c[f>>2]|0)+292>>2]|0)==0?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[f>>2]|0);c[l>>2]=c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2];c[j>>2]=ne(c[f>>2]|0,h)|0;if(!((c[j>>2]|0)==32|(c[j>>2]|0)==62|(c[j>>2]|0)==47)?(a=(kh(c[f>>2]|0,c[j>>2]|0)|0)==0,!(a|(c[j>>2]|0)==58)):0){while(1){if(!((c[j>>2]|0)!=32&(c[j>>2]|0)!=62&(c[j>>2]|0)!=47)){m=30;break}a=(Cg(c[f>>2]|0,c[j>>2]|0)|0)!=0;if(!(a&(c[j>>2]|0)!=58)){m=30;break}a=c[k>>2]|0;c[k>>2]=a+1;if((a|0)>100){if((c[g>>2]|0)>5e4?(c[(c[f>>2]|0)+360>>2]&524288|0)==0:0){m=12;break}c[k>>2]=0;if((c[(c[f>>2]|0)+292>>2]|0)==0?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[f>>2]|0);if((c[(c[f>>2]|0)+172>>2]|0)==-1){m=17;break}}c[g>>2]=(c[g>>2]|0)+(c[h>>2]|0);a=c[(c[f>>2]|0)+36>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){n=a+28|0;c[n>>2]=(c[n>>2]|0)+1;c[(c[(c[f>>2]|0)+36>>2]|0)+32>>2]=1}else{n=a+32|0;c[n>>2]=(c[n>>2]|0)+1}n=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[n>>2]=(c[n>>2]|0)+(c[h>>2]|0);if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==37)We(c[f>>2]|0);c[l>>2]=c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2];c[j>>2]=ne(c[f>>2]|0,h)|0;if(c[j>>2]|0)continue;c[k>>2]=0;if((c[(c[f>>2]|0)+292>>2]|0)==0?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)vg(c[f>>2]|0);if((c[(c[f>>2]|0)+172>>2]|0)==-1){m=28;break}c[l>>2]=c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2];c[j>>2]=ne(c[f>>2]|0,h)|0}if((m|0)==12){og(c[f>>2]|0,110,70920);c[e>>2]=0;o=c[e>>2]|0;i=b;return o|0}else if((m|0)==17){c[e>>2]=0;o=c[e>>2]|0;i=b;return o|0}else if((m|0)==28){c[e>>2]=0;o=c[e>>2]|0;i=b;return o|0}else if((m|0)==30){if((c[g>>2]|0)>5e4?(c[(c[f>>2]|0)+360>>2]&524288|0)==0:0){og(c[f>>2]|0,110,70920);c[e>>2]=0;o=c[e>>2]|0;i=b;return o|0}c[e>>2]=AP(c[(c[f>>2]|0)+296>>2]|0,(c[l>>2]|0)+(0-(c[g>>2]|0))|0,c[g>>2]|0)|0;o=c[e>>2]|0;i=b;return o|0}}c[e>>2]=0;o=c[e>>2]|0;i=b;return o|0}function Bh(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+32|0;h=g+28|0;j=g+24|0;k=g+20|0;l=g+16|0;m=g+12|0;n=g+8|0;o=g+4|0;p=g;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;if(!(c[j>>2]|0)){c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}f=c[j>>2]|0;if(!(c[k>>2]|0)){c[h>>2]=f;q=c[h>>2]|0;i=g;return q|0}c[n>>2]=ZT(f|0)|0;c[o>>2]=ZT(c[k>>2]|0)|0;if((c[l>>2]|0)!=0?(c[m>>2]|0)>=((c[n>>2]|0)+(c[o>>2]|0)+2|0):0)c[p>>2]=c[l>>2];else r=7;if((r|0)==7?(c[p>>2]=Cb[c[135752>>2]&511]((c[n>>2]|0)+(c[o>>2]|0)+2|0)|0,(c[p>>2]|0)==0):0){tj(75136);c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}eU(c[p>>2]|0,c[k>>2]|0,c[o>>2]|0)|0;a[(c[p>>2]|0)+(c[o>>2]|0)>>0]=58;eU((c[p>>2]|0)+((c[o>>2]|0)+1)|0,c[j>>2]|0,c[n>>2]|0)|0;a[(c[p>>2]|0)+((c[n>>2]|0)+(c[o>>2]|0)+1)>>0]=0;c[h>>2]=c[p>>2];q=c[h>>2]|0;i=g;return q|0}function Ch(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=0;c[k>>2]=0;if(!(c[h>>2]|0)){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}c[c[h>>2]>>2]=0;if(!(c[g>>2]|0)){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}if((d[c[g>>2]>>0]|0|0)==58){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}while(1){if(d[(c[g>>2]|0)+(c[j>>2]|0)>>0]|0)m=(d[(c[g>>2]|0)+(c[j>>2]|0)>>0]|0|0)!=58;else m=0;n=c[j>>2]|0;if(!m)break;c[j>>2]=n+1}if(!(d[(c[g>>2]|0)+n>>0]|0)){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}n=ly(c[g>>2]|0,c[j>>2]|0)|0;c[c[h>>2]>>2]=n;if(!(c[c[h>>2]>>2]|0)){tj(75152);c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}c[k>>2]=my((c[g>>2]|0)+((c[j>>2]|0)+1)|0)|0;if(c[k>>2]|0){c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}tj(75152);if(c[c[h>>2]>>2]|0){zb[c[135736>>2]&511](c[c[h>>2]>>2]|0);c[c[h>>2]>>2]=0}c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}function Dh(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=0;do if(c[g>>2]|0){if(!(c[h>>2]|0)){c[f>>2]=0;break}if((d[c[g>>2]>>0]|0|0)==58){c[f>>2]=0;break}while(1){if(d[(c[g>>2]|0)+(c[j>>2]|0)>>0]|0)k=(d[(c[g>>2]|0)+(c[j>>2]|0)>>0]|0|0)!=58;else k=0;l=c[j>>2]|0;if(!k)break;c[j>>2]=l+1}if(!(d[(c[g>>2]|0)+l>>0]|0)){c[f>>2]=0;break}else{c[c[h>>2]>>2]=c[j>>2];c[f>>2]=(c[g>>2]|0)+((c[j>>2]|0)+1);break}}else c[f>>2]=0;while(0);i=e;return c[f>>2]|0}function Eh(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=c[g>>2];if(!(c[g>>2]|0)){c[f>>2]=-1;m=c[f>>2]|0;i=e;return m|0}a:do if(c[h>>2]|0)while(1){do if((d[c[j>>2]>>0]|0|0)!=32){if(9<=(d[c[j>>2]>>0]|0|0)?(d[c[j>>2]>>0]|0|0)<=10:0)break;if((d[c[j>>2]>>0]|0|0)!=13)break a}while(0);c[j>>2]=(c[j>>2]|0)+1}while(0);if((d[c[j>>2]>>0]|0|0)>=97?(d[c[j>>2]>>0]|0|0)<=122:0)n=14;else n=11;do if((n|0)==11){if((d[c[j>>2]>>0]|0|0)>=65?(d[c[j>>2]>>0]|0|0)<=90:0){n=14;break}if((d[c[j>>2]>>0]|0|0)==95)n=14}while(0);if((n|0)==14){c[j>>2]=(c[j>>2]|0)+1;b:while(1){if(!((d[c[j>>2]>>0]|0|0)>=97?(d[c[j>>2]>>0]|0|0)<=122:0))n=17;do if((n|0)==17){n=0;if((d[c[j>>2]>>0]|0|0)>=65?(d[c[j>>2]>>0]|0|0)<=90:0)break;if((d[c[j>>2]>>0]|0|0)>=48?(d[c[j>>2]>>0]|0|0)<=57:0)break;if(((d[c[j>>2]>>0]|0|0)!=95?(d[c[j>>2]>>0]|0|0)!=45:0)?(d[c[j>>2]>>0]|0|0)!=46:0)break b}while(0);c[j>>2]=(c[j>>2]|0)+1}c:do if(c[h>>2]|0)while(1){do if((d[c[j>>2]>>0]|0|0)!=32){if(9<=(d[c[j>>2]>>0]|0|0)?(d[c[j>>2]>>0]|0|0)<=10:0)break;if((d[c[j>>2]>>0]|0|0)!=13)break c}while(0);c[j>>2]=(c[j>>2]|0)+1}while(0);if(!(d[c[j>>2]>>0]|0)){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}}c[j>>2]=c[g>>2];c[k>>2]=oe(0,c[j>>2]|0,l)|0;d:do if(c[h>>2]|0)while(1){if((c[k>>2]|0)<256){if((c[k>>2]|0)!=32?!(9<=(c[k>>2]|0)&(c[k>>2]|0)<=10):0)o=(c[k>>2]|0)==13;else o=1;p=o&1}else p=0;if(!p)break d;c[j>>2]=(c[j>>2]|0)+(c[l>>2]|0);c[k>>2]=oe(0,c[j>>2]|0,l)|0}while(0);p=c[k>>2]|0;if((c[k>>2]|0)<256){if(((!(65<=(p|0)&(c[k>>2]|0)<=90)?!(97<=(c[k>>2]|0)&(c[k>>2]|0)<=122):0)?!(192<=(c[k>>2]|0)&(c[k>>2]|0)<=214):0)?!(216<=(c[k>>2]|0)&(c[k>>2]|0)<=246|248<=(c[k>>2]|0)):0)n=47}else if(!(DQ(p,199744)|0))n=47;do if((n|0)==47){p=c[k>>2]|0;if((c[k>>2]|0)<256){if((p|0)==95)break}else{if(19968<=(p|0)&(c[k>>2]|0)<=40869|(c[k>>2]|0)==12295)break;if(!((12321<=(c[k>>2]|0)&(c[k>>2]|0)<=12329^1)&(c[k>>2]|0)!=95))break}c[f>>2]=1;m=c[f>>2]|0;i=e;return m|0}while(0);c[j>>2]=(c[j>>2]|0)+(c[l>>2]|0);c[k>>2]=oe(0,c[j>>2]|0,l)|0;e:while(1){p=c[k>>2]|0;if((c[k>>2]|0)<256){if(((!(65<=(p|0)&(c[k>>2]|0)<=90)?!(97<=(c[k>>2]|0)&(c[k>>2]|0)<=122):0)?!(192<=(c[k>>2]|0)&(c[k>>2]|0)<=214):0)?!(216<=(c[k>>2]|0)&(c[k>>2]|0)<=246|248<=(c[k>>2]|0)):0)n=59}else if(!(DQ(p,199744)|0))n=59;do if((n|0)==59){n=0;if((c[k>>2]|0)>=256){if(19968<=(c[k>>2]|0)&(c[k>>2]|0)<=40869|(c[k>>2]|0)==12295)break;if(12321<=(c[k>>2]|0)&(c[k>>2]|0)<=12329)break}p=c[k>>2]|0;if((c[k>>2]|0)<256){if(48<=(p|0)&(c[k>>2]|0)<=57|(c[k>>2]|0)==46|(c[k>>2]|0)==45|(c[k>>2]|0)==95)break}else{o=(DQ(p,200216)|0)!=0;if(o|(c[k>>2]|0)==46|(c[k>>2]|0)==45|(c[k>>2]|0)==95)break}if((c[k>>2]|0)>=256?(DQ(c[k>>2]|0,200144)|0)!=0:0)break;o=c[k>>2]|0;if((c[k>>2]|0)<256)q=(o|0)==183&1;else q=DQ(o,200272)|0;if(!q)break e}while(0);c[j>>2]=(c[j>>2]|0)+(c[l>>2]|0);c[k>>2]=oe(0,c[j>>2]|0,l)|0}f:do if(c[h>>2]|0)while(1){if((c[k>>2]|0)<256){if((c[k>>2]|0)!=32?!(9<=(c[k>>2]|0)&(c[k>>2]|0)<=10):0)r=(c[k>>2]|0)==13;else r=1;s=r&1}else s=0;if(!s)break f;c[j>>2]=(c[j>>2]|0)+(c[l>>2]|0);c[k>>2]=oe(0,c[j>>2]|0,l)|0}while(0);if(c[k>>2]|0){c[f>>2]=1;m=c[f>>2]|0;i=e;return m|0}else{c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}return 0}function Fh(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=c[g>>2];if(!(c[g>>2]|0)){c[f>>2]=-1;m=c[f>>2]|0;i=e;return m|0}a:do if(c[h>>2]|0)while(1){do if((d[c[j>>2]>>0]|0|0)!=32){if(9<=(d[c[j>>2]>>0]|0|0)?(d[c[j>>2]>>0]|0|0)<=10:0)break;if((d[c[j>>2]>>0]|0|0)!=13)break a}while(0);c[j>>2]=(c[j>>2]|0)+1}while(0);if((d[c[j>>2]>>0]|0|0)>=97?(d[c[j>>2]>>0]|0|0)<=122:0)n=14;else n=11;do if((n|0)==11){if((d[c[j>>2]>>0]|0|0)>=65?(d[c[j>>2]>>0]|0|0)<=90:0){n=14;break}if((d[c[j>>2]>>0]|0|0)==95)n=14}while(0);b:do if((n|0)==14){c[j>>2]=(c[j>>2]|0)+1;while(1){if((d[c[j>>2]>>0]|0|0)>=97?(d[c[j>>2]>>0]|0|0)<=122:0)o=1;else n=17;do if((n|0)==17){n=0;if((d[c[j>>2]>>0]|0|0)>=65?(d[c[j>>2]>>0]|0|0)<=90:0){o=1;break}if((d[c[j>>2]>>0]|0|0)>=48?(d[c[j>>2]>>0]|0|0)<=57:0){o=1;break}if((d[c[j>>2]>>0]|0|0)!=95?(d[c[j>>2]>>0]|0|0)!=45:0)o=(d[c[j>>2]>>0]|0|0)==46;else o=1}while(0);p=c[j>>2]|0;if(!o)break;c[j>>2]=p+1}c:do if((d[p>>0]|0|0)==58){c[j>>2]=(c[j>>2]|0)+1;if(!((d[c[j>>2]>>0]|0|0)>=97?(d[c[j>>2]>>0]|0|0)<=122:0))n=29;do if((n|0)==29){if((d[c[j>>2]>>0]|0|0)>=65?(d[c[j>>2]>>0]|0|0)<=90:0)break;if((d[c[j>>2]>>0]|0|0)!=95)break b}while(0);c[j>>2]=(c[j>>2]|0)+1;while(1){if(!((d[c[j>>2]>>0]|0|0)>=97?(d[c[j>>2]>>0]|0|0)<=122:0))n=35;do if((n|0)==35){n=0;if((d[c[j>>2]>>0]|0|0)>=65?(d[c[j>>2]>>0]|0|0)<=90:0)break;if((d[c[j>>2]>>0]|0|0)>=48?(d[c[j>>2]>>0]|0|0)<=57:0)break;if(((d[c[j>>2]>>0]|0|0)!=95?(d[c[j>>2]>>0]|0|0)!=45:0)?(d[c[j>>2]>>0]|0|0)!=46:0)break c}while(0);c[j>>2]=(c[j>>2]|0)+1}}while(0);d:do if(c[h>>2]|0)while(1){do if((d[c[j>>2]>>0]|0|0)!=32){if(9<=(d[c[j>>2]>>0]|0|0)?(d[c[j>>2]>>0]|0|0)<=10:0)break;if((d[c[j>>2]>>0]|0|0)!=13)break d}while(0);c[j>>2]=(c[j>>2]|0)+1}while(0);if(!(d[c[j>>2]>>0]|0)){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}}while(0);c[j>>2]=c[g>>2];c[k>>2]=oe(0,c[j>>2]|0,l)|0;e:do if(c[h>>2]|0)while(1){if((c[k>>2]|0)<256){if((c[k>>2]|0)!=32?!(9<=(c[k>>2]|0)&(c[k>>2]|0)<=10):0)q=(c[k>>2]|0)==13;else q=1;r=q&1}else r=0;if(!r)break e;c[j>>2]=(c[j>>2]|0)+(c[l>>2]|0);c[k>>2]=oe(0,c[j>>2]|0,l)|0}while(0);r=c[k>>2]|0;if((c[k>>2]|0)<256){if(((!(65<=(r|0)&(c[k>>2]|0)<=90)?!(97<=(c[k>>2]|0)&(c[k>>2]|0)<=122):0)?!(192<=(c[k>>2]|0)&(c[k>>2]|0)<=214):0)?!(216<=(c[k>>2]|0)&(c[k>>2]|0)<=246|248<=(c[k>>2]|0)):0)n=65}else if(!(DQ(r,199744)|0))n=65;do if((n|0)==65){r=c[k>>2]|0;if((c[k>>2]|0)<256){if((r|0)==95)break}else{if(19968<=(r|0)&(c[k>>2]|0)<=40869|(c[k>>2]|0)==12295)break;if(!((12321<=(c[k>>2]|0)&(c[k>>2]|0)<=12329^1)&(c[k>>2]|0)!=95))break}c[f>>2]=1;m=c[f>>2]|0;i=e;return m|0}while(0);c[j>>2]=(c[j>>2]|0)+(c[l>>2]|0);c[k>>2]=oe(0,c[j>>2]|0,l)|0;f:while(1){r=c[k>>2]|0;if((c[k>>2]|0)<256){if(((!(65<=(r|0)&(c[k>>2]|0)<=90)?!(97<=(c[k>>2]|0)&(c[k>>2]|0)<=122):0)?!(192<=(c[k>>2]|0)&(c[k>>2]|0)<=214):0)?!(216<=(c[k>>2]|0)&(c[k>>2]|0)<=246|248<=(c[k>>2]|0)):0)n=77}else if(!(DQ(r,199744)|0))n=77;do if((n|0)==77){n=0;if((c[k>>2]|0)>=256){if(19968<=(c[k>>2]|0)&(c[k>>2]|0)<=40869|(c[k>>2]|0)==12295)break;if(12321<=(c[k>>2]|0)&(c[k>>2]|0)<=12329)break}r=c[k>>2]|0;if((c[k>>2]|0)<256){if(48<=(r|0)&(c[k>>2]|0)<=57|(c[k>>2]|0)==46|(c[k>>2]|0)==45|(c[k>>2]|0)==95)break}else{q=(DQ(r,200216)|0)!=0;if(q|(c[k>>2]|0)==46|(c[k>>2]|0)==45|(c[k>>2]|0)==95)break}if((c[k>>2]|0)>=256?(DQ(c[k>>2]|0,200144)|0)!=0:0)break;q=c[k>>2]|0;if((c[k>>2]|0)<256)s=(q|0)==183&1;else s=DQ(q,200272)|0;if(!s)break f}while(0);c[j>>2]=(c[j>>2]|0)+(c[l>>2]|0);c[k>>2]=oe(0,c[j>>2]|0,l)|0}g:do if((c[k>>2]|0)==58){c[j>>2]=(c[j>>2]|0)+(c[l>>2]|0);c[k>>2]=oe(0,c[j>>2]|0,l)|0;s=c[k>>2]|0;if((c[k>>2]|0)<256){if(((!(65<=(s|0)&(c[k>>2]|0)<=90)?!(97<=(c[k>>2]|0)&(c[k>>2]|0)<=122):0)?!(192<=(c[k>>2]|0)&(c[k>>2]|0)<=214):0)?!(216<=(c[k>>2]|0)&(c[k>>2]|0)<=246|248<=(c[k>>2]|0)):0)n=97}else if(!(DQ(s,199744)|0))n=97;do if((n|0)==97){s=c[k>>2]|0;if((c[k>>2]|0)<256){if((s|0)==95)break}else{if(19968<=(s|0)&(c[k>>2]|0)<=40869|(c[k>>2]|0)==12295)break;if(!((12321<=(c[k>>2]|0)&(c[k>>2]|0)<=12329^1)&(c[k>>2]|0)!=95))break}c[f>>2]=1;m=c[f>>2]|0;i=e;return m|0}while(0);c[j>>2]=(c[j>>2]|0)+(c[l>>2]|0);c[k>>2]=oe(0,c[j>>2]|0,l)|0;while(1){s=c[k>>2]|0;if((c[k>>2]|0)<256){if(((!(65<=(s|0)&(c[k>>2]|0)<=90)?!(97<=(c[k>>2]|0)&(c[k>>2]|0)<=122):0)?!(192<=(c[k>>2]|0)&(c[k>>2]|0)<=214):0)?!(216<=(c[k>>2]|0)&(c[k>>2]|0)<=246|248<=(c[k>>2]|0)):0)n=109}else if(!(DQ(s,199744)|0))n=109;do if((n|0)==109){n=0;if((c[k>>2]|0)>=256){if(19968<=(c[k>>2]|0)&(c[k>>2]|0)<=40869|(c[k>>2]|0)==12295)break;if(12321<=(c[k>>2]|0)&(c[k>>2]|0)<=12329)break}s=c[k>>2]|0;if((c[k>>2]|0)<256){if(48<=(s|0)&(c[k>>2]|0)<=57|(c[k>>2]|0)==46|(c[k>>2]|0)==45|(c[k>>2]|0)==95)break}else{q=(DQ(s,200216)|0)!=0;if(q|(c[k>>2]|0)==46|(c[k>>2]|0)==45|(c[k>>2]|0)==95)break}if((c[k>>2]|0)>=256?(DQ(c[k>>2]|0,200144)|0)!=0:0)break;q=c[k>>2]|0;if((c[k>>2]|0)<256)t=(q|0)==183&1;else t=DQ(q,200272)|0;if(!t)break g}while(0);c[j>>2]=(c[j>>2]|0)+(c[l>>2]|0);c[k>>2]=oe(0,c[j>>2]|0,l)|0}}while(0);h:do if(c[h>>2]|0)while(1){if((c[k>>2]|0)<256){if((c[k>>2]|0)!=32?!(9<=(c[k>>2]|0)&(c[k>>2]|0)<=10):0)u=(c[k>>2]|0)==13;else u=1;v=u&1}else v=0;if(!v)break h;c[j>>2]=(c[j>>2]|0)+(c[l>>2]|0);c[k>>2]=oe(0,c[j>>2]|0,l)|0}while(0);if(c[k>>2]|0){c[f>>2]=1;m=c[f>>2]|0;i=e;return m|0}else{c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}return 0}function Gh(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=c[g>>2];if(!(c[g>>2]|0)){c[f>>2]=-1;m=c[f>>2]|0;i=e;return m|0}a:do if(c[h>>2]|0)while(1){do if((d[c[j>>2]>>0]|0|0)!=32){if(9<=(d[c[j>>2]>>0]|0|0)?(d[c[j>>2]>>0]|0|0)<=10:0)break;if((d[c[j>>2]>>0]|0|0)!=13)break a}while(0);c[j>>2]=(c[j>>2]|0)+1}while(0);if((d[c[j>>2]>>0]|0|0)>=97?(d[c[j>>2]>>0]|0|0)<=122:0)n=15;else n=11;do if((n|0)==11){if((d[c[j>>2]>>0]|0|0)>=65?(d[c[j>>2]>>0]|0|0)<=90:0){n=15;break}if(!((d[c[j>>2]>>0]|0|0)!=95?(d[c[j>>2]>>0]|0|0)!=58:0))n=15}while(0);if((n|0)==15){c[j>>2]=(c[j>>2]|0)+1;b:while(1){if(!((d[c[j>>2]>>0]|0|0)>=97?(d[c[j>>2]>>0]|0|0)<=122:0))n=18;do if((n|0)==18){n=0;if((d[c[j>>2]>>0]|0|0)>=65?(d[c[j>>2]>>0]|0|0)<=90:0)break;if((d[c[j>>2]>>0]|0|0)>=48?(d[c[j>>2]>>0]|0|0)<=57:0)break;if((((d[c[j>>2]>>0]|0|0)!=95?(d[c[j>>2]>>0]|0|0)!=45:0)?(d[c[j>>2]>>0]|0|0)!=46:0)?(d[c[j>>2]>>0]|0|0)!=58:0)break b}while(0);c[j>>2]=(c[j>>2]|0)+1}c:do if(c[h>>2]|0)while(1){do if((d[c[j>>2]>>0]|0|0)!=32){if(9<=(d[c[j>>2]>>0]|0|0)?(d[c[j>>2]>>0]|0|0)<=10:0)break;if((d[c[j>>2]>>0]|0|0)!=13)break c}while(0);c[j>>2]=(c[j>>2]|0)+1}while(0);if(!(d[c[j>>2]>>0]|0)){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}}c[j>>2]=c[g>>2];c[k>>2]=oe(0,c[j>>2]|0,l)|0;d:do if(c[h>>2]|0)while(1){if((c[k>>2]|0)<256){if((c[k>>2]|0)!=32?!(9<=(c[k>>2]|0)&(c[k>>2]|0)<=10):0)o=(c[k>>2]|0)==13;else o=1;p=o&1}else p=0;if(!p)break d;c[j>>2]=(c[j>>2]|0)+(c[l>>2]|0);c[k>>2]=oe(0,c[j>>2]|0,l)|0}while(0);p=c[k>>2]|0;if((c[k>>2]|0)<256){if(((!(65<=(p|0)&(c[k>>2]|0)<=90)?!(97<=(c[k>>2]|0)&(c[k>>2]|0)<=122):0)?!(192<=(c[k>>2]|0)&(c[k>>2]|0)<=214):0)?!(216<=(c[k>>2]|0)&(c[k>>2]|0)<=246|248<=(c[k>>2]|0)):0)n=49}else if(!(DQ(p,199744)|0))n=49;do if((n|0)==49){p=c[k>>2]|0;if((c[k>>2]|0)<256){if(!((p|0)!=95&(c[k>>2]|0)!=58))break}else{if(19968<=(p|0)&(c[k>>2]|0)<=40869|(c[k>>2]|0)==12295)break;if(!((12321<=(c[k>>2]|0)&(c[k>>2]|0)<=12329^1)&(c[k>>2]|0)!=95&(c[k>>2]|0)!=58))break}c[f>>2]=1;m=c[f>>2]|0;i=e;return m|0}while(0);c[j>>2]=(c[j>>2]|0)+(c[l>>2]|0);c[k>>2]=oe(0,c[j>>2]|0,l)|0;e:while(1){p=c[k>>2]|0;if((c[k>>2]|0)<256){if(((!(65<=(p|0)&(c[k>>2]|0)<=90)?!(97<=(c[k>>2]|0)&(c[k>>2]|0)<=122):0)?!(192<=(c[k>>2]|0)&(c[k>>2]|0)<=214):0)?!(216<=(c[k>>2]|0)&(c[k>>2]|0)<=246|248<=(c[k>>2]|0)):0)n=61}else if(!(DQ(p,199744)|0))n=61;do if((n|0)==61){n=0;if((c[k>>2]|0)>=256){if(19968<=(c[k>>2]|0)&(c[k>>2]|0)<=40869|(c[k>>2]|0)==12295)break;if(12321<=(c[k>>2]|0)&(c[k>>2]|0)<=12329)break}p=c[k>>2]|0;if((c[k>>2]|0)<256){if(48<=(p|0)&(c[k>>2]|0)<=57|(c[k>>2]|0)==46|(c[k>>2]|0)==58|(c[k>>2]|0)==45|(c[k>>2]|0)==95)break}else{o=(DQ(p,200216)|0)!=0;if(o|(c[k>>2]|0)==46|(c[k>>2]|0)==58|(c[k>>2]|0)==45|(c[k>>2]|0)==95)break}if((c[k>>2]|0)>=256?(DQ(c[k>>2]|0,200144)|0)!=0:0)break;o=c[k>>2]|0;if((c[k>>2]|0)<256)q=(o|0)==183&1;else q=DQ(o,200272)|0;if(!q)break e}while(0);c[j>>2]=(c[j>>2]|0)+(c[l>>2]|0);c[k>>2]=oe(0,c[j>>2]|0,l)|0}f:do if(c[h>>2]|0)while(1){if((c[k>>2]|0)<256){if((c[k>>2]|0)!=32?!(9<=(c[k>>2]|0)&(c[k>>2]|0)<=10):0)r=(c[k>>2]|0)==13;else r=1;s=r&1}else s=0;if(!s)break f;c[j>>2]=(c[j>>2]|0)+(c[l>>2]|0);c[k>>2]=oe(0,c[j>>2]|0,l)|0}while(0);if(c[k>>2]|0){c[f>>2]=1;m=c[f>>2]|0;i=e;return m|0}else{c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}return 0}function Hh(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=c[g>>2];if(!(c[g>>2]|0)){c[f>>2]=-1;m=c[f>>2]|0;i=e;return m|0}a:do if(c[h>>2]|0)while(1){do if((d[c[j>>2]>>0]|0|0)!=32){if(9<=(d[c[j>>2]>>0]|0|0)?(d[c[j>>2]>>0]|0|0)<=10:0)break;if((d[c[j>>2]>>0]|0|0)!=13)break a}while(0);c[j>>2]=(c[j>>2]|0)+1}while(0);if((d[c[j>>2]>>0]|0|0)>=97?(d[c[j>>2]>>0]|0|0)<=122:0)n=19;else n=11;do if((n|0)==11){if((d[c[j>>2]>>0]|0|0)>=65?(d[c[j>>2]>>0]|0|0)<=90:0){n=19;break}if((d[c[j>>2]>>0]|0|0)>=48?(d[c[j>>2]>>0]|0|0)<=57:0){n=19;break}if(!((((d[c[j>>2]>>0]|0|0)!=95?(d[c[j>>2]>>0]|0|0)!=45:0)?(d[c[j>>2]>>0]|0|0)!=46:0)?(d[c[j>>2]>>0]|0|0)!=58:0))n=19}while(0);if((n|0)==19){c[j>>2]=(c[j>>2]|0)+1;b:while(1){if(!((d[c[j>>2]>>0]|0|0)>=97?(d[c[j>>2]>>0]|0|0)<=122:0))n=22;do if((n|0)==22){n=0;if((d[c[j>>2]>>0]|0|0)>=65?(d[c[j>>2]>>0]|0|0)<=90:0)break;if((d[c[j>>2]>>0]|0|0)>=48?(d[c[j>>2]>>0]|0|0)<=57:0)break;if((((d[c[j>>2]>>0]|0|0)!=95?(d[c[j>>2]>>0]|0|0)!=45:0)?(d[c[j>>2]>>0]|0|0)!=46:0)?(d[c[j>>2]>>0]|0|0)!=58:0)break b}while(0);c[j>>2]=(c[j>>2]|0)+1}c:do if(c[h>>2]|0)while(1){do if((d[c[j>>2]>>0]|0|0)!=32){if(9<=(d[c[j>>2]>>0]|0|0)?(d[c[j>>2]>>0]|0|0)<=10:0)break;if((d[c[j>>2]>>0]|0|0)!=13)break c}while(0);c[j>>2]=(c[j>>2]|0)+1}while(0);if(!(d[c[j>>2]>>0]|0)){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}}c[j>>2]=c[g>>2];c[k>>2]=oe(0,c[j>>2]|0,l)|0;d:do if(c[h>>2]|0)while(1){if((c[k>>2]|0)<256){if((c[k>>2]|0)!=32?!(9<=(c[k>>2]|0)&(c[k>>2]|0)<=10):0)o=(c[k>>2]|0)==13;else o=1;p=o&1}else p=0;if(!p)break d;c[j>>2]=(c[j>>2]|0)+(c[l>>2]|0);c[k>>2]=oe(0,c[j>>2]|0,l)|0}while(0);p=c[k>>2]|0;if((c[k>>2]|0)<256){if(((!(65<=(p|0)&(c[k>>2]|0)<=90)?!(97<=(c[k>>2]|0)&(c[k>>2]|0)<=122):0)?!(192<=(c[k>>2]|0)&(c[k>>2]|0)<=214):0)?!(216<=(c[k>>2]|0)&(c[k>>2]|0)<=246|248<=(c[k>>2]|0)):0)n=53}else if(!(DQ(p,199744)|0))n=53;do if((n|0)==53){if((c[k>>2]|0)>=256){if(19968<=(c[k>>2]|0)&(c[k>>2]|0)<=40869|(c[k>>2]|0)==12295)break;if(12321<=(c[k>>2]|0)&(c[k>>2]|0)<=12329)break}p=c[k>>2]|0;if((c[k>>2]|0)<256){if(48<=(p|0)&(c[k>>2]|0)<=57|(c[k>>2]|0)==46|(c[k>>2]|0)==58|(c[k>>2]|0)==45|(c[k>>2]|0)==95)break}else{o=(DQ(p,200216)|0)!=0;if(o|(c[k>>2]|0)==46|(c[k>>2]|0)==58|(c[k>>2]|0)==45|(c[k>>2]|0)==95)break}if((c[k>>2]|0)>=256?(DQ(c[k>>2]|0,200144)|0)!=0:0)break;o=c[k>>2]|0;if((c[k>>2]|0)<256){if((o|0)==183)break}else if(DQ(o,200272)|0)break;c[f>>2]=1;m=c[f>>2]|0;
i=e;return m|0}while(0);c[j>>2]=(c[j>>2]|0)+(c[l>>2]|0);c[k>>2]=oe(0,c[j>>2]|0,l)|0;e:while(1){o=c[k>>2]|0;if((c[k>>2]|0)<256){if(((!(65<=(o|0)&(c[k>>2]|0)<=90)?!(97<=(c[k>>2]|0)&(c[k>>2]|0)<=122):0)?!(192<=(c[k>>2]|0)&(c[k>>2]|0)<=214):0)?!(216<=(c[k>>2]|0)&(c[k>>2]|0)<=246|248<=(c[k>>2]|0)):0)n=72}else if(!(DQ(o,199744)|0))n=72;do if((n|0)==72){n=0;if((c[k>>2]|0)>=256){if(19968<=(c[k>>2]|0)&(c[k>>2]|0)<=40869|(c[k>>2]|0)==12295)break;if(12321<=(c[k>>2]|0)&(c[k>>2]|0)<=12329)break}o=c[k>>2]|0;if((c[k>>2]|0)<256){if(48<=(o|0)&(c[k>>2]|0)<=57|(c[k>>2]|0)==46|(c[k>>2]|0)==58|(c[k>>2]|0)==45|(c[k>>2]|0)==95)break}else{p=(DQ(o,200216)|0)!=0;if(p|(c[k>>2]|0)==46|(c[k>>2]|0)==58|(c[k>>2]|0)==45|(c[k>>2]|0)==95)break}if((c[k>>2]|0)>=256?(DQ(c[k>>2]|0,200144)|0)!=0:0)break;p=c[k>>2]|0;if((c[k>>2]|0)<256)q=(p|0)==183&1;else q=DQ(p,200272)|0;if(!q)break e}while(0);c[j>>2]=(c[j>>2]|0)+(c[l>>2]|0);c[k>>2]=oe(0,c[j>>2]|0,l)|0}f:do if(c[h>>2]|0)while(1){if((c[k>>2]|0)<256){if((c[k>>2]|0)!=32?!(9<=(c[k>>2]|0)&(c[k>>2]|0)<=10):0)r=(c[k>>2]|0)==13;else r=1;s=r&1}else s=0;if(!s)break f;c[j>>2]=(c[j>>2]|0)+(c[l>>2]|0);c[k>>2]=oe(0,c[j>>2]|0,l)|0}while(0);if(c[k>>2]|0){c[f>>2]=1;m=c[f>>2]|0;i=e;return m|0}else{c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}return 0}function Ih(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+4>>2]|0)!=1:0){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}if(((c[j>>2]|0)!=0?(qy(c[j>>2]|0,75168)|0)!=0:0)?(qy(c[h>>2]|0,75176)|0)!=0:0){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}c[k>>2]=Cb[c[135744>>2]&511](24)|0;if(!(c[k>>2]|0)){tj(75216);c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}d=c[k>>2]|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[(c[k>>2]|0)+4>>2]=18;if(c[h>>2]|0){d=my(c[h>>2]|0)|0;c[(c[k>>2]|0)+8>>2]=d}if(c[j>>2]|0){d=my(c[j>>2]|0)|0;c[(c[k>>2]|0)+12>>2]=d}do if(c[g>>2]|0){if(!(c[(c[g>>2]|0)+48>>2]|0)){c[(c[g>>2]|0)+48>>2]=c[k>>2];break}c[l>>2]=c[(c[g>>2]|0)+48>>2];if(!((c[(c[l>>2]|0)+12>>2]|0)==0?(c[(c[k>>2]|0)+12>>2]|0)==0:0))n=19;if((n|0)==19?(qy(c[(c[l>>2]|0)+12>>2]|0,c[(c[k>>2]|0)+12>>2]|0)|0)==0:0){do{if(!(c[c[l>>2]>>2]|0)){n=26;break}c[l>>2]=c[c[l>>2]>>2];if((c[(c[l>>2]|0)+12>>2]|0)==0?(c[(c[k>>2]|0)+12>>2]|0)==0:0)break}while((qy(c[(c[l>>2]|0)+12>>2]|0,c[(c[k>>2]|0)+12>>2]|0)|0)==0);if((n|0)==26){c[c[l>>2]>>2]=c[k>>2];break}Jh(c[k>>2]|0);c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}Jh(c[k>>2]|0);c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}while(0);c[f>>2]=c[k>>2];m=c[f>>2]|0;i=e;return m|0}function Jh(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+8>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+8>>2]|0);if(c[(c[d>>2]|0)+12>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+12>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function Kh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}if((c[(c[e>>2]|0)+4>>2]|0)!=1?(c[(c[e>>2]|0)+4>>2]|0)!=2:0){i=d;return}c[(c[e>>2]|0)+36>>2]=c[f>>2];i=d;return}function Lh(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;if(!((c[d>>2]|0)!=0&(c[d>>2]|0)!=0)){i=b;return}do{c[e>>2]=c[c[d>>2]>>2];Jh(c[d>>2]|0);c[d>>2]=c[e>>2]}while((c[d>>2]|0)!=0);i=b;return}function Mh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+48>>2]|0)!=0:0){c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}c[m>>2]=Cb[c[135744>>2]&511](64)|0;if(!(c[m>>2]|0)){tj(75240);c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}e=(c[m>>2]|0)+0|0;d=e+64|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(d|0));c[(c[m>>2]|0)+4>>2]=14;if(c[j>>2]|0){e=my(c[j>>2]|0)|0;c[(c[m>>2]|0)+8>>2]=e}if(c[k>>2]|0){e=my(c[k>>2]|0)|0;c[(c[m>>2]|0)+52>>2]=e}if(c[l>>2]|0){e=my(c[l>>2]|0)|0;c[(c[m>>2]|0)+56>>2]=e}if(c[h>>2]|0)c[(c[h>>2]|0)+48>>2]=c[m>>2];c[(c[m>>2]|0)+32>>2]=c[h>>2];if((c[18774]|0)!=0&(c[33968]|0)!=0)zb[c[135872>>2]&511](c[m>>2]|0);c[g>>2]=c[m>>2];n=c[g>>2]|0;i=f;return n|0}function Nh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if(!(c[e>>2]|0)){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}c[f>>2]=c[(c[e>>2]|0)+12>>2];while(1){if(!(c[f>>2]|0)){h=8;break}j=c[f>>2]|0;if((c[(c[f>>2]|0)+4>>2]|0)==14){h=6;break}c[f>>2]=c[j+24>>2]}if((h|0)==6){c[d>>2]=j;g=c[d>>2]|0;i=b;return g|0}else if((h|0)==8){c[d>>2]=c[(c[e>>2]|0)+44>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function Oh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+32|0;g=f+28|0;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f+4|0;o=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if((c[h>>2]|0)!=0?(Nh(c[h>>2]|0)|0)!=0:0){c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}c[m>>2]=Cb[c[135744>>2]&511](64)|0;if(!(c[m>>2]|0)){tj(75256);c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}e=(c[m>>2]|0)+0|0;d=e+64|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(d|0));c[(c[m>>2]|0)+4>>2]=14;if((c[j>>2]|0)!=0?(e=my(c[j>>2]|0)|0,c[(c[m>>2]|0)+8>>2]=e,(c[(c[m>>2]|0)+8>>2]|0)==0):0){tj(75256);zb[c[135736>>2]&511](c[m>>2]|0);c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}if((c[k>>2]|0)!=0?(e=my(c[k>>2]|0)|0,c[(c[m>>2]|0)+52>>2]=e,(c[(c[m>>2]|0)+52>>2]|0)==0):0){tj(75256);if(c[(c[m>>2]|0)+8>>2]|0)zb[c[135736>>2]&511](c[(c[m>>2]|0)+8>>2]|0);zb[c[135736>>2]&511](c[m>>2]|0);c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}if((c[l>>2]|0)!=0?(e=my(c[l>>2]|0)|0,c[(c[m>>2]|0)+56>>2]=e,(c[(c[m>>2]|0)+56>>2]|0)==0):0){tj(75256);if(c[(c[m>>2]|0)+8>>2]|0)zb[c[135736>>2]&511](c[(c[m>>2]|0)+8>>2]|0);if(c[(c[m>>2]|0)+52>>2]|0)zb[c[135736>>2]&511](c[(c[m>>2]|0)+52>>2]|0);zb[c[135736>>2]&511](c[m>>2]|0);c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}do if(c[h>>2]|0){c[(c[h>>2]|0)+44>>2]=c[m>>2];c[(c[m>>2]|0)+20>>2]=c[h>>2];c[(c[m>>2]|0)+32>>2]=c[h>>2];if(!(c[(c[h>>2]|0)+12>>2]|0)){c[(c[h>>2]|0)+12>>2]=c[m>>2];c[(c[h>>2]|0)+16>>2]=c[m>>2];break}e=c[(c[h>>2]|0)+12>>2]|0;if((c[(c[h>>2]|0)+4>>2]|0)==13){c[n>>2]=e;c[(c[n>>2]|0)+28>>2]=c[m>>2];c[(c[m>>2]|0)+24>>2]=c[n>>2];c[(c[h>>2]|0)+12>>2]=c[m>>2];break}c[o>>2]=e;while(1){if(c[o>>2]|0)q=(c[(c[o>>2]|0)+4>>2]|0)!=1;else q=0;r=c[o>>2]|0;if(!q)break;c[o>>2]=c[r+24>>2]}if(!r){c[(c[m>>2]|0)+28>>2]=c[(c[h>>2]|0)+16>>2];c[(c[(c[m>>2]|0)+28>>2]|0)+24>>2]=c[m>>2];c[(c[m>>2]|0)+24>>2]=0;c[(c[h>>2]|0)+16>>2]=c[m>>2];break}c[(c[m>>2]|0)+24>>2]=c[o>>2];c[(c[m>>2]|0)+28>>2]=c[(c[o>>2]|0)+28>>2];e=c[m>>2]|0;if(!(c[(c[m>>2]|0)+28>>2]|0))c[(c[h>>2]|0)+12>>2]=e;else c[(c[(c[m>>2]|0)+28>>2]|0)+24>>2]=e;c[(c[o>>2]|0)+28>>2]=c[m>>2]}while(0);if((c[18774]|0)!=0&(c[33968]|0)!=0)zb[c[135872>>2]&511](c[m>>2]|0);c[g>>2]=c[m>>2];p=c[g>>2]|0;i=f;return p|0}function Ph(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[d>>2]=a;c[e>>2]=0;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+32>>2]|0)c[e>>2]=c[(c[(c[d>>2]|0)+32>>2]|0)+80>>2];if((c[18774]|0)!=0&(c[33970]|0)!=0)zb[c[135880>>2]&511](c[d>>2]|0);a:do if(c[(c[d>>2]|0)+12>>2]|0){c[g>>2]=c[(c[d>>2]|0)+12>>2];while(1){if(!(c[g>>2]|0))break a;c[f>>2]=c[(c[g>>2]|0)+24>>2];if((((c[(c[g>>2]|0)+4>>2]|0)!=12?(c[(c[g>>2]|0)+4>>2]|0)!=15:0)?(c[(c[g>>2]|0)+4>>2]|0)!=16:0)?(c[(c[g>>2]|0)+4>>2]|0)!=17:0){Qh(c[g>>2]|0);Rh(c[g>>2]|0)}c[g>>2]=c[f>>2]}}while(0);do if(c[(c[d>>2]|0)+8>>2]|0){if((c[e>>2]|0)!=0?(CP(c[e>>2]|0,c[(c[d>>2]|0)+8>>2]|0)|0)!=0:0)break;zb[c[135736>>2]&511](c[(c[d>>2]|0)+8>>2]|0)}while(0);do if(c[(c[d>>2]|0)+56>>2]|0){if((c[e>>2]|0)!=0?(CP(c[e>>2]|0,c[(c[d>>2]|0)+56>>2]|0)|0)!=0:0)break;zb[c[135736>>2]&511](c[(c[d>>2]|0)+56>>2]|0)}while(0);do if(c[(c[d>>2]|0)+52>>2]|0){if((c[e>>2]|0)!=0?(CP(c[e>>2]|0,c[(c[d>>2]|0)+52>>2]|0)|0)!=0:0)break;zb[c[135736>>2]&511](c[(c[d>>2]|0)+52>>2]|0)}while(0);if(c[(c[d>>2]|0)+36>>2]|0)ym(c[(c[d>>2]|0)+36>>2]|0);if(c[(c[d>>2]|0)+40>>2]|0)nm(c[(c[d>>2]|0)+40>>2]|0);if(c[(c[d>>2]|0)+44>>2]|0)um(c[(c[d>>2]|0)+44>>2]|0);if(c[(c[d>>2]|0)+48>>2]|0)dd(c[(c[d>>2]|0)+48>>2]|0);if(c[(c[d>>2]|0)+60>>2]|0)dd(c[(c[d>>2]|0)+60>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function Qh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if((c[(c[d>>2]|0)+4>>2]|0)==18){i=b;return}if((c[(c[d>>2]|0)+4>>2]|0)==14?(c[e>>2]=c[(c[d>>2]|0)+32>>2],(c[e>>2]|0)!=0):0){if((c[(c[e>>2]|0)+44>>2]|0)==(c[d>>2]|0))c[(c[e>>2]|0)+44>>2]=0;if((c[(c[e>>2]|0)+48>>2]|0)==(c[d>>2]|0))c[(c[e>>2]|0)+48>>2]=0}if((c[(c[d>>2]|0)+4>>2]|0)==17?(c[f>>2]=c[(c[d>>2]|0)+32>>2],(c[f>>2]|0)!=0):0){if(c[(c[f>>2]|0)+44>>2]|0){e=Rj(c[(c[(c[f>>2]|0)+44>>2]|0)+48>>2]|0,c[(c[d>>2]|0)+8>>2]|0)|0;if((e|0)==(c[d>>2]|0))ak(c[(c[(c[f>>2]|0)+44>>2]|0)+48>>2]|0,c[(c[d>>2]|0)+8>>2]|0,0)|0;e=Rj(c[(c[(c[f>>2]|0)+44>>2]|0)+60>>2]|0,c[(c[d>>2]|0)+8>>2]|0)|0;if((e|0)==(c[d>>2]|0))ak(c[(c[(c[f>>2]|0)+44>>2]|0)+60>>2]|0,c[(c[d>>2]|0)+8>>2]|0,0)|0}if(c[(c[f>>2]|0)+48>>2]|0){e=Rj(c[(c[(c[f>>2]|0)+48>>2]|0)+48>>2]|0,c[(c[d>>2]|0)+8>>2]|0)|0;if((e|0)==(c[d>>2]|0))ak(c[(c[(c[f>>2]|0)+48>>2]|0)+48>>2]|0,c[(c[d>>2]|0)+8>>2]|0,0)|0;e=Rj(c[(c[(c[f>>2]|0)+48>>2]|0)+60>>2]|0,c[(c[d>>2]|0)+8>>2]|0)|0;if((e|0)==(c[d>>2]|0))ak(c[(c[(c[f>>2]|0)+48>>2]|0)+60>>2]|0,c[(c[d>>2]|0)+8>>2]|0,0)|0}}if(c[(c[d>>2]|0)+20>>2]|0){c[g>>2]=c[(c[d>>2]|0)+20>>2];f=c[g>>2]|0;if((c[(c[d>>2]|0)+4>>2]|0)==2){if((c[f+44>>2]|0)==(c[d>>2]|0))c[(c[g>>2]|0)+44>>2]=c[(c[d>>2]|0)+24>>2]}else{if((c[f+12>>2]|0)==(c[d>>2]|0))c[(c[g>>2]|0)+12>>2]=c[(c[d>>2]|0)+24>>2];if((c[(c[g>>2]|0)+16>>2]|0)==(c[d>>2]|0))c[(c[g>>2]|0)+16>>2]=c[(c[d>>2]|0)+28>>2]}c[(c[d>>2]|0)+20>>2]=0}if(c[(c[d>>2]|0)+24>>2]|0)c[(c[(c[d>>2]|0)+24>>2]|0)+28>>2]=c[(c[d>>2]|0)+28>>2];if(c[(c[d>>2]|0)+28>>2]|0)c[(c[(c[d>>2]|0)+28>>2]|0)+24>>2]=c[(c[d>>2]|0)+24>>2];c[(c[d>>2]|0)+28>>2]=0;c[(c[d>>2]|0)+24>>2]=0;i=b;return}function Rh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[e>>2]=0;if(!(c[d>>2]|0)){i=b;return}a=c[d>>2]|0;if((c[(c[d>>2]|0)+4>>2]|0)==14){Ph(a);i=b;return}g=c[d>>2]|0;if((c[a+4>>2]|0)==18){Jh(g);i=b;return}if((c[g+4>>2]|0)==2){ei(c[d>>2]|0);i=b;return}if((c[18774]|0)!=0&(c[33970]|0)!=0)zb[c[135880>>2]&511](c[d>>2]|0);if(c[(c[d>>2]|0)+32>>2]|0)c[e>>2]=c[(c[(c[d>>2]|0)+32>>2]|0)+80>>2];do if((c[(c[d>>2]|0)+4>>2]|0)==17){c[f>>2]=c[d>>2];do if(c[(c[f>>2]|0)+56>>2]|0){if((c[e>>2]|0)!=0?(CP(c[e>>2]|0,c[(c[f>>2]|0)+56>>2]|0)|0)!=0:0)break;zb[c[135736>>2]&511](c[(c[f>>2]|0)+56>>2]|0)}while(0);if(c[(c[f>>2]|0)+52>>2]|0){if((c[e>>2]|0)!=0?(CP(c[e>>2]|0,c[(c[f>>2]|0)+52>>2]|0)|0)!=0:0)break;zb[c[135736>>2]&511](c[(c[f>>2]|0)+52>>2]|0)}}while(0);if((c[(c[d>>2]|0)+12>>2]|0)!=0?(c[(c[d>>2]|0)+4>>2]|0)!=5:0)Uh(c[(c[d>>2]|0)+12>>2]|0);if(!(((c[(c[d>>2]|0)+4>>2]|0)!=1?(c[(c[d>>2]|0)+4>>2]|0)!=19:0)?(c[(c[d>>2]|0)+4>>2]|0)!=20:0))h=27;if((h|0)==27?(c[(c[d>>2]|0)+44>>2]|0)!=0:0)di(c[(c[d>>2]|0)+44>>2]|0);do if(((((((c[(c[d>>2]|0)+4>>2]|0)!=1?(c[(c[d>>2]|0)+40>>2]|0)!=0:0)?(c[(c[d>>2]|0)+4>>2]|0)!=5:0)?(c[(c[d>>2]|0)+4>>2]|0)!=20:0)?(c[(c[d>>2]|0)+4>>2]|0)!=19:0)?(c[(c[d>>2]|0)+40>>2]|0)!=((c[d>>2]|0)+44|0):0)?(c[(c[d>>2]|0)+40>>2]|0)!=0:0){if((c[e>>2]|0)!=0?(CP(c[e>>2]|0,c[(c[d>>2]|0)+40>>2]|0)|0)!=0:0)break;zb[c[135736>>2]&511](c[(c[d>>2]|0)+40>>2]|0)}while(0);do if((((c[(c[d>>2]|0)+8>>2]|0)!=0?(c[(c[d>>2]|0)+4>>2]|0)!=3:0)?(c[(c[d>>2]|0)+4>>2]|0)!=8:0)?(c[(c[d>>2]|0)+8>>2]|0)!=0:0){if((c[e>>2]|0)!=0?(CP(c[e>>2]|0,c[(c[d>>2]|0)+8>>2]|0)|0)!=0:0)break;zb[c[135736>>2]&511](c[(c[d>>2]|0)+8>>2]|0)}while(0);if(!(((c[(c[d>>2]|0)+4>>2]|0)!=1?(c[(c[d>>2]|0)+4>>2]|0)!=19:0)?(c[(c[d>>2]|0)+4>>2]|0)!=20:0))h=49;if((h|0)==49?(c[(c[d>>2]|0)+48>>2]|0)!=0:0)Lh(c[(c[d>>2]|0)+48>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function Sh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[e>>2]=(c[e>>2]|0)==0?75288:a;c[f>>2]=Cb[c[135744>>2]&511](96)|0;if(!(c[f>>2]|0)){tj(75296);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}a=(c[f>>2]|0)+0|0;h=a+96|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(h|0));c[(c[f>>2]|0)+4>>2]=9;a=my(c[e>>2]|0)|0;c[(c[f>>2]|0)+56>>2]=a;if(!(c[(c[f>>2]|0)+56>>2]|0)){tj(75296);zb[c[135736>>2]&511](c[f>>2]|0);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}c[(c[f>>2]|0)+40>>2]=-1;c[(c[f>>2]|0)+36>>2]=-1;c[(c[f>>2]|0)+32>>2]=c[f>>2];c[(c[f>>2]|0)+88>>2]=0;c[(c[f>>2]|0)+92>>2]=32;c[(c[f>>2]|0)+76>>2]=1;if((c[18774]|0)!=0&(c[33968]|0)!=0)zb[c[135872>>2]&511](c[f>>2]|0);c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}function Th(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[d>>2]=a;c[g>>2]=0;if(!(c[d>>2]|0)){i=b;return}if(c[d>>2]|0)c[g>>2]=c[(c[d>>2]|0)+80>>2];if((c[18774]|0)!=0&(c[33970]|0)!=0)zb[c[135880>>2]&511](c[d>>2]|0);if(c[(c[d>>2]|0)+64>>2]|0)Dm(c[(c[d>>2]|0)+64>>2]|0);c[(c[d>>2]|0)+64>>2]=0;if(c[(c[d>>2]|0)+68>>2]|0)Jm(c[(c[d>>2]|0)+68>>2]|0);c[(c[d>>2]|0)+68>>2]=0;c[e>>2]=c[(c[d>>2]|0)+48>>2];c[f>>2]=c[(c[d>>2]|0)+44>>2];if((c[f>>2]|0)==(c[e>>2]|0))c[e>>2]=0;if(c[e>>2]|0){Qh(c[(c[d>>2]|0)+48>>2]|0);c[(c[d>>2]|0)+48>>2]=0;Ph(c[e>>2]|0)}if(c[f>>2]|0){Qh(c[(c[d>>2]|0)+44>>2]|0);c[(c[d>>2]|0)+44>>2]=0;Ph(c[f>>2]|0)}if(c[(c[d>>2]|0)+12>>2]|0)Uh(c[(c[d>>2]|0)+12>>2]|0);if(c[(c[d>>2]|0)+52>>2]|0)Lh(c[(c[d>>2]|0)+52>>2]|0);do if(c[(c[d>>2]|0)+56>>2]|0){if((c[g>>2]|0)!=0?(CP(c[g>>2]|0,c[(c[d>>2]|0)+56>>2]|0)|0)!=0:0)break;zb[c[135736>>2]&511](c[(c[d>>2]|0)+56>>2]|0)}while(0);do if(c[(c[d>>2]|0)+8>>2]|0){if((c[g>>2]|0)!=0?(CP(c[g>>2]|0,c[(c[d>>2]|0)+8>>2]|0)|0)!=0:0)break;zb[c[135736>>2]&511](c[(c[d>>2]|0)+8>>2]|0)}while(0);do if(c[(c[d>>2]|0)+60>>2]|0){if((c[g>>2]|0)!=0?(CP(c[g>>2]|0,c[(c[d>>2]|0)+60>>2]|0)|0)!=0:0)break;zb[c[135736>>2]&511](c[(c[d>>2]|0)+60>>2]|0)}while(0);do if(c[(c[d>>2]|0)+72>>2]|0){if((c[g>>2]|0)!=0?(CP(c[g>>2]|0,c[(c[d>>2]|0)+72>>2]|0)|0)!=0:0)break;zb[c[135736>>2]&511](c[(c[d>>2]|0)+72>>2]|0)}while(0);zb[c[135736>>2]&511](c[d>>2]|0);if(!(c[g>>2]|0)){i=b;return}zP(c[g>>2]|0);i=b;return}function Uh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[f>>2]=0;if(!(c[d>>2]|0)){i=b;return}a=c[d>>2]|0;if((c[(c[d>>2]|0)+4>>2]|0)==18){Lh(a);i=b;return}if(((c[a+4>>2]|0)!=9?(c[(c[d>>2]|0)+4>>2]|0)!=21:0)?(c[(c[d>>2]|0)+4>>2]|0)!=13:0){if(c[(c[d>>2]|0)+32>>2]|0)c[f>>2]=c[(c[(c[d>>2]|0)+32>>2]|0)+80>>2];while(1){if(!(c[d>>2]|0))break;c[e>>2]=c[(c[d>>2]|0)+24>>2];if((c[(c[d>>2]|0)+4>>2]|0)!=14){if((c[18774]|0)!=0&(c[33970]|0)!=0)zb[c[135880>>2]&511](c[d>>2]|0);if((c[(c[d>>2]|0)+12>>2]|0)!=0?(c[(c[d>>2]|0)+4>>2]|0)!=5:0)Uh(c[(c[d>>2]|0)+12>>2]|0);if(!(((c[(c[d>>2]|0)+4>>2]|0)!=1?(c[(c[d>>2]|0)+4>>2]|0)!=19:0)?(c[(c[d>>2]|0)+4>>2]|0)!=20:0))g=20;if((g|0)==20?(g=0,(c[(c[d>>2]|0)+44>>2]|0)!=0):0)di(c[(c[d>>2]|0)+44>>2]|0);do if(((((c[(c[d>>2]|0)+4>>2]|0)!=1?(c[(c[d>>2]|0)+4>>2]|0)!=19:0)?(c[(c[d>>2]|0)+4>>2]|0)!=20:0)?(c[(c[d>>2]|0)+4>>2]|0)!=5:0)?(c[(c[d>>2]|0)+40>>2]|0)!=((c[d>>2]|0)+44|0):0){if(!(c[(c[d>>2]|0)+40>>2]|0))break;if((c[f>>2]|0)!=0?(CP(c[f>>2]|0,c[(c[d>>2]|0)+40>>2]|0)|0)!=0:0)break;zb[c[135736>>2]&511](c[(c[d>>2]|0)+40>>2]|0)}while(0);if(!(((c[(c[d>>2]|0)+4>>2]|0)!=1?(c[(c[d>>2]|0)+4>>2]|0)!=19:0)?(c[(c[d>>2]|0)+4>>2]|0)!=20:0))g=34;if((g|0)==34?(g=0,(c[(c[d>>2]|0)+48>>2]|0)!=0):0)Lh(c[(c[d>>2]|0)+48>>2]|0);do if(((c[(c[d>>2]|0)+8>>2]|0)!=0?(c[(c[d>>2]|0)+4>>2]|0)!=3:0)?(c[(c[d>>2]|0)+4>>2]|0)!=8:0){if(!(c[(c[d>>2]|0)+8>>2]|0))break;if((c[f>>2]|0)!=0?(CP(c[f>>2]|0,c[(c[d>>2]|0)+8>>2]|0)|0)!=0:0)break;zb[c[135736>>2]&511](c[(c[d>>2]|0)+8>>2]|0)}while(0);zb[c[135736>>2]&511](c[d>>2]|0)}c[d>>2]=c[e>>2]}i=b;return}Th(c[d>>2]|0);i=b;return}function Vh(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;g=i;i=i+80|0;h=g+60|0;j=g+56|0;k=g+52|0;l=g+48|0;m=g+44|0;n=g+40|0;o=g+36|0;p=g+32|0;q=g+28|0;r=g+24|0;s=g+20|0;t=g+16|0;u=g+12|0;v=g+8|0;w=g+74|0;x=g+4|0;y=g+64|0;z=g;c[j>>2]=b;c[k>>2]=e;c[l>>2]=f;c[m>>2]=0;c[n>>2]=0;c[q>>2]=c[k>>2];c[r>>2]=(c[q>>2]|0)+(c[l>>2]|0);if(!(c[k>>2]|0)){c[h>>2]=0;A=c[h>>2]|0;i=g;return A|0}c[u>>2]=My(0)|0;if(!(c[u>>2]|0)){c[h>>2]=0;A=c[h>>2]|0;i=g;return A|0}Qy(c[u>>2]|0,4)|0;c[s>>2]=c[q>>2];a:while(1){if((c[q>>2]|0)>>>0<(c[r>>2]|0)>>>0)B=(d[c[q>>2]>>0]|0|0)!=0;else B=0;C=c[q>>2]|0;if(!B){D=87;break}if((d[C>>0]|0|0)!=38){c[q>>2]=(c[q>>2]|0)+1;continue}c[v>>2]=0;if((c[q>>2]|0)!=(c[s>>2]|0)?(cz(c[u>>2]|0,c[s>>2]|0,(c[q>>2]|0)-(c[s>>2]|0)|0)|0)!=0:0)break;c[s>>2]=c[q>>2];if((((c[q>>2]|0)+2|0)>>>0<(c[r>>2]|0)>>>0?(d[(c[q>>2]|0)+1>>0]|0|0)==35:0)?(d[(c[q>>2]|0)+2>>0]|0|0)==120:0){c[q>>2]=(c[q>>2]|0)+3;if((c[q>>2]|0)>>>0<(c[r>>2]|0)>>>0)a[w>>0]=a[c[q>>2]>>0]|0;else a[w>>0]=0;b:while(1){if((d[w>>0]|0|0)==59)break;if((d[w>>0]|0|0)>=48?(d[w>>0]|0|0)<=57:0)c[v>>2]=(c[v>>2]<<4)+((d[w>>0]|0)-48);else D=22;do if((D|0)==22){D=0;if((d[w>>0]|0|0)>=97?(d[w>>0]|0|0)<=102:0){c[v>>2]=(c[v>>2]<<4)+((d[w>>0]|0)-97)+10;break}if((d[w>>0]|0|0)<65){D=28;break b}if((d[w>>0]|0|0)>70){D=28;break b}c[v>>2]=(c[v>>2]<<4)+((d[w>>0]|0)-65)+10}while(0);c[q>>2]=(c[q>>2]|0)+1;if((c[q>>2]|0)>>>0<(c[r>>2]|0)>>>0){a[w>>0]=a[c[q>>2]>>0]|0;continue}else{a[w>>0]=0;continue}}if((D|0)==28){D=0;uj(1300,c[j>>2]|0,0);c[v>>2]=0}if((d[w>>0]|0|0)==59)c[q>>2]=(c[q>>2]|0)+1;c[s>>2]=c[q>>2]}else D=35;do if((D|0)==35){D=0;if(((c[q>>2]|0)+1|0)>>>0<(c[r>>2]|0)>>>0?(d[(c[q>>2]|0)+1>>0]|0|0)==35:0){c[q>>2]=(c[q>>2]|0)+2;if((c[q>>2]|0)>>>0<(c[r>>2]|0)>>>0)a[w>>0]=a[c[q>>2]>>0]|0;else a[w>>0]=0;while(1){if((d[w>>0]|0|0)==59)break;if((d[w>>0]|0|0)<48){D=44;break}if((d[w>>0]|0|0)>57){D=44;break}c[v>>2]=((c[v>>2]|0)*10|0)+((d[w>>0]|0)-48);c[q>>2]=(c[q>>2]|0)+1;if((c[q>>2]|0)>>>0<(c[r>>2]|0)>>>0){a[w>>0]=a[c[q>>2]>>0]|0;continue}else{a[w>>0]=0;continue}}if((D|0)==44){D=0;uj(1301,c[j>>2]|0,0);c[v>>2]=0}if((d[w>>0]|0|0)==59)c[q>>2]=(c[q>>2]|0)+1;c[s>>2]=c[q>>2];break}c[q>>2]=(c[q>>2]|0)+1;c[s>>2]=c[q>>2];while(1){if((c[q>>2]|0)>>>0<(c[r>>2]|0)>>>0?(d[c[q>>2]>>0]|0|0)!=0:0)E=(d[c[q>>2]>>0]|0|0)!=59;else E=0;F=c[q>>2]|0;if(!E)break;c[q>>2]=F+1}if(F>>>0>=(c[r>>2]|0)>>>0){D=58;break a}if(!(d[c[q>>2]>>0]|0)){D=58;break a}if((c[q>>2]|0)!=(c[s>>2]|0)){c[p>>2]=ly(c[s>>2]|0,(c[q>>2]|0)-(c[s>>2]|0)|0)|0;c[t>>2]=ad(c[j>>2]|0,c[p>>2]|0)|0;if((c[t>>2]|0)!=0?(c[(c[t>>2]|0)+48>>2]|0)==6:0){if(ez(c[u>>2]|0,c[(c[t>>2]|0)+40>>2]|0)|0)break a}else D=63;do if((D|0)==63){D=0;do if(!(az(c[u>>2]|0)|0)){c[o>>2]=Wh(c[j>>2]|0,0)|0;if(!(c[o>>2]|0)){D=65;break a}k=Ny(c[u>>2]|0)|0;c[(c[o>>2]|0)+40>>2]=k;if(!(c[n>>2]|0)){k=c[o>>2]|0;c[m>>2]=k;c[n>>2]=k;break}else{c[n>>2]=Xh(c[n>>2]|0,c[o>>2]|0)|0;break}}while(0);c[o>>2]=Yh(c[j>>2]|0,c[p>>2]|0)|0;if(!(c[o>>2]|0)){D=71;break a}c:do if(c[t>>2]|0){if(c[(c[t>>2]|0)+12>>2]|0)break;k=Zh(c[j>>2]|0,c[(c[o>>2]|0)+40>>2]|0)|0;c[(c[t>>2]|0)+12>>2]=k;c[(c[t>>2]|0)+68>>2]=1;c[x>>2]=c[(c[t>>2]|0)+12>>2];while(1){if(!(c[x>>2]|0))break c;c[(c[x>>2]|0)+20>>2]=c[t>>2];c[(c[t>>2]|0)+16>>2]=c[x>>2];c[x>>2]=c[(c[x>>2]|0)+24>>2]}}while(0);if(!(c[n>>2]|0)){k=c[o>>2]|0;c[m>>2]=k;c[n>>2]=k;break}else{c[n>>2]=Xh(c[n>>2]|0,c[o>>2]|0)|0;break}}while(0);zb[c[135736>>2]&511](c[p>>2]|0)}c[q>>2]=(c[q>>2]|0)+1;c[s>>2]=c[q>>2]}while(0);if(!(c[v>>2]|0))continue;c[z>>2]=pe(y,c[v>>2]|0)|0;a[y+(c[z>>2]|0)>>0]=0;if(ez(c[u>>2]|0,y)|0)break;c[v>>2]=0}do if((D|0)==58)uj(1302,c[j>>2]|0,c[s>>2]|0);else if((D|0)==65){if(c[p>>2]|0)zb[c[135736>>2]&511](c[p>>2]|0)}else if((D|0)==71){if(c[p>>2]|0)zb[c[135736>>2]&511](c[p>>2]|0)}else if((D|0)==87){if((C|0)!=(c[s>>2]|0)?(cz(c[u>>2]|0,c[s>>2]|0,(c[q>>2]|0)-(c[s>>2]|0)|0)|0)!=0:0)break;if(az(c[u>>2]|0)|0){if(c[m>>2]|0)break;c[m>>2]=Wh(c[j>>2]|0,75312)|0;break}c[o>>2]=Wh(c[j>>2]|0,0)|0;if(c[o>>2]|0){v=Ny(c[u>>2]|0)|0;c[(c[o>>2]|0)+40>>2]=v;if(!(c[n>>2]|0)){v=c[o>>2]|0;c[m>>2]=v;c[n>>2]=v;break}else{c[n>>2]=Xh(c[n>>2]|0,c[o>>2]|0)|0;break}}}while(0);Ry(c[u>>2]|0);c[h>>2]=c[m>>2];A=c[h>>2]|0;i=g;return A|0}function Wh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=li(c[f>>2]|0)|0;if(!(c[g>>2]|0)){h=c[g>>2]|0;i=d;return h|0}c[(c[g>>2]|0)+32>>2]=c[e>>2];h=c[g>>2]|0;i=d;return h|0}function Xh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+4>>2]|0)!=18:0){if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+4>>2]|0)!=18:0){if((c[f>>2]|0)==(c[g>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}Qh(c[g>>2]|0);if((c[(c[g>>2]|0)+4>>2]|0)==3){b=c[f>>2]|0;if((c[(c[f>>2]|0)+4>>2]|0)==3){ui(b,c[(c[g>>2]|0)+40>>2]|0);Rh(c[g>>2]|0);c[e>>2]=c[f>>2];j=c[e>>2]|0;i=d;return j|0}if(((c[b+24>>2]|0)!=0?(c[(c[(c[f>>2]|0)+24>>2]|0)+4>>2]|0)==3:0)?(c[(c[f>>2]|0)+8>>2]|0)==(c[(c[(c[f>>2]|0)+24>>2]|0)+8>>2]|0):0){c[h>>2]=my(c[(c[g>>2]|0)+40>>2]|0)|0;c[h>>2]=By(c[h>>2]|0,c[(c[(c[f>>2]|0)+24>>2]|0)+40>>2]|0)|0;vi(c[(c[f>>2]|0)+24>>2]|0,c[h>>2]|0);zb[c[135736>>2]&511](c[h>>2]|0);Rh(c[g>>2]|0);c[e>>2]=c[(c[f>>2]|0)+24>>2];j=c[e>>2]|0;i=d;return j|0}}else if((c[(c[g>>2]|0)+4>>2]|0)==2){c[e>>2]=vj(c[f>>2]|0,c[f>>2]|0,c[g>>2]|0)|0;j=c[e>>2]|0;i=d;return j|0}if((c[(c[g>>2]|0)+32>>2]|0)!=(c[(c[f>>2]|0)+32>>2]|0))ri(c[g>>2]|0,c[(c[f>>2]|0)+32>>2]|0);c[(c[g>>2]|0)+20>>2]=c[(c[f>>2]|0)+20>>2];c[(c[g>>2]|0)+28>>2]=c[f>>2];c[(c[g>>2]|0)+24>>2]=c[(c[f>>2]|0)+24>>2];c[(c[f>>2]|0)+24>>2]=c[g>>2];if(c[(c[g>>2]|0)+24>>2]|0)c[(c[(c[g>>2]|0)+24>>2]|0)+28>>2]=c[g>>2];if((c[(c[g>>2]|0)+20>>2]|0)!=0?(c[(c[(c[g>>2]|0)+20>>2]|0)+16>>2]|0)==(c[f>>2]|0):0)c[(c[(c[g>>2]|0)+20>>2]|0)+16>>2]=c[g>>2];c[e>>2]=c[g>>2];j=c[e>>2]|0;i=d;return j|0}c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}function Yh(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;if(!(c[h>>2]|0)){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}c[j>>2]=Cb[c[135744>>2]&511](60)|0;if(!(c[j>>2]|0)){tj(75424);c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}b=(c[j>>2]|0)+0|0;a=b+60|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(a|0));c[(c[j>>2]|0)+4>>2]=5;c[(c[j>>2]|0)+32>>2]=c[g>>2];b=c[h>>2]|0;do if((d[c[h>>2]>>0]|0|0)==38){c[h>>2]=b+1;c[l>>2]=xy(c[h>>2]|0)|0;a=c[h>>2]|0;n=c[l>>2]|0;if((d[(c[h>>2]|0)+((c[l>>2]|0)-1)>>0]|0|0)==59){o=ly(a,n-1|0)|0;c[(c[j>>2]|0)+8>>2]=o;break}else{o=ly(a,n)|0;c[(c[j>>2]|0)+8>>2]=o;break}}else{o=my(b)|0;c[(c[j>>2]|0)+8>>2]=o}while(0);c[k>>2]=ad(c[g>>2]|0,c[(c[j>>2]|0)+8>>2]|0)|0;if(c[k>>2]|0){c[(c[j>>2]|0)+40>>2]=c[(c[k>>2]|0)+40>>2];c[(c[j>>2]|0)+12>>2]=c[k>>2];c[(c[j>>2]|0)+16>>2]=c[k>>2]}if((c[18774]|0)!=0&(c[33968]|0)!=0)zb[c[135872>>2]&511](c[j>>2]|0);c[f>>2]=c[j>>2];m=c[f>>2]|0;i=e;return m|0}function Zh(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+80|0;g=f+52|0;h=f+48|0;j=f+44|0;k=f+40|0;l=f+36|0;m=f+32|0;n=f+28|0;o=f+24|0;p=f+20|0;q=f+16|0;r=f+12|0;s=f+8|0;t=f+66|0;u=f+4|0;v=f+56|0;w=f;c[h>>2]=b;c[j>>2]=e;c[k>>2]=0;c[l>>2]=0;c[o>>2]=c[j>>2];if(!(c[j>>2]|0)){c[g>>2]=0;x=c[g>>2]|0;i=f;return x|0}c[r>>2]=My(0)|0;if(!(c[r>>2]|0)){c[g>>2]=0;x=c[g>>2]|0;i=f;return x|0}Qy(c[r>>2]|0,4)|0;c[p>>2]=c[o>>2];a:while(1){y=c[o>>2]|0;if(!(d[c[o>>2]>>0]|0)){z=70;break}if((d[y>>0]|0|0)!=38){c[o>>2]=(c[o>>2]|0)+1;continue}c[s>>2]=0;if((c[o>>2]|0)!=(c[p>>2]|0)?(cz(c[r>>2]|0,c[p>>2]|0,(c[o>>2]|0)-(c[p>>2]|0)|0)|0)!=0:0)break;c[p>>2]=c[o>>2];if((d[(c[o>>2]|0)+1>>0]|0|0)==35?(d[(c[o>>2]|0)+2>>0]|0|0)==120:0){c[o>>2]=(c[o>>2]|0)+3;a[t>>0]=a[c[o>>2]>>0]|0;b:while(1){if((d[t>>0]|0|0)==59)break;if((d[t>>0]|0|0)>=48?(d[t>>0]|0|0)<=57:0)c[s>>2]=(c[s>>2]<<4)+((d[t>>0]|0)-48);else z=17;do if((z|0)==17){z=0;if((d[t>>0]|0|0)>=97?(d[t>>0]|0|0)<=102:0){c[s>>2]=(c[s>>2]<<4)+((d[t>>0]|0)-97)+10;break}if((d[t>>0]|0|0)<65){z=23;break b}if((d[t>>0]|0|0)>70){z=23;break b}c[s>>2]=(c[s>>2]<<4)+((d[t>>0]|0)-65)+10}while(0);c[o>>2]=(c[o>>2]|0)+1;a[t>>0]=a[c[o>>2]>>0]|0}if((z|0)==23){z=0;uj(1300,c[h>>2]|0,0);c[s>>2]=0}if((d[t>>0]|0|0)==59)c[o>>2]=(c[o>>2]|0)+1;c[p>>2]=c[o>>2]}else z=28;do if((z|0)==28){z=0;j=c[o>>2]|0;if((d[(c[o>>2]|0)+1>>0]|0|0)==35){c[o>>2]=j+2;a[t>>0]=a[c[o>>2]>>0]|0;while(1){if((d[t>>0]|0|0)==59)break;if((d[t>>0]|0|0)<48){z=34;break}if((d[t>>0]|0|0)>57){z=34;break}c[s>>2]=((c[s>>2]|0)*10|0)+((d[t>>0]|0)-48);c[o>>2]=(c[o>>2]|0)+1;a[t>>0]=a[c[o>>2]>>0]|0}if((z|0)==34){z=0;uj(1301,c[h>>2]|0,0);c[s>>2]=0}if((d[t>>0]|0|0)==59)c[o>>2]=(c[o>>2]|0)+1;c[p>>2]=c[o>>2];break}c[o>>2]=j+1;c[p>>2]=c[o>>2];while(1){if(d[c[o>>2]>>0]|0)A=(d[c[o>>2]>>0]|0|0)!=59;else A=0;B=c[o>>2]|0;if(!A)break;c[o>>2]=B+1}if(!(d[B>>0]|0)){z=44;break a}if((c[o>>2]|0)!=(c[p>>2]|0)){c[n>>2]=ly(c[p>>2]|0,(c[o>>2]|0)-(c[p>>2]|0)|0)|0;c[q>>2]=ad(c[h>>2]|0,c[n>>2]|0)|0;if((c[q>>2]|0)!=0?(c[(c[q>>2]|0)+48>>2]|0)==6:0){if(ez(c[r>>2]|0,c[(c[q>>2]|0)+40>>2]|0)|0)break a}else z=49;do if((z|0)==49){z=0;do if(!(az(c[r>>2]|0)|0)){c[m>>2]=Wh(c[h>>2]|0,0)|0;j=Ny(c[r>>2]|0)|0;c[(c[m>>2]|0)+40>>2]=j;if(!(c[l>>2]|0)){j=c[m>>2]|0;c[k>>2]=j;c[l>>2]=j;break}else{c[l>>2]=Xh(c[l>>2]|0,c[m>>2]|0)|0;break}}while(0);c[m>>2]=Yh(c[h>>2]|0,c[n>>2]|0)|0;if(!(c[m>>2]|0)){z=54;break a}c:do if((c[q>>2]|0)!=0?(c[(c[q>>2]|0)+12>>2]|0)==0:0){j=Zh(c[h>>2]|0,c[(c[m>>2]|0)+40>>2]|0)|0;c[(c[q>>2]|0)+12>>2]=j;c[(c[q>>2]|0)+68>>2]=1;c[u>>2]=c[(c[q>>2]|0)+12>>2];while(1){if(!(c[u>>2]|0))break c;c[(c[u>>2]|0)+20>>2]=c[q>>2];c[u>>2]=c[(c[u>>2]|0)+24>>2]}}while(0);if(!(c[l>>2]|0)){j=c[m>>2]|0;c[k>>2]=j;c[l>>2]=j;break}else{c[l>>2]=Xh(c[l>>2]|0,c[m>>2]|0)|0;break}}while(0);zb[c[135736>>2]&511](c[n>>2]|0)}c[o>>2]=(c[o>>2]|0)+1;c[p>>2]=c[o>>2]}while(0);if(!(c[s>>2]|0))continue;c[w>>2]=pe(v,c[s>>2]|0)|0;a[v+(c[w>>2]|0)>>0]=0;if(ez(c[r>>2]|0,v)|0)break;c[s>>2]=0}do if((z|0)==44)uj(1302,c[h>>2]|0,c[p>>2]|0);else if((z|0)==54){if(c[n>>2]|0)zb[c[135736>>2]&511](c[n>>2]|0)}else if((z|0)==70){if((c[k>>2]|0)==0?1:(y|0)!=(c[p>>2]|0))cz(c[r>>2]|0,c[p>>2]|0,(c[o>>2]|0)-(c[p>>2]|0)|0)|0;if(!(az(c[r>>2]|0)|0)){c[m>>2]=Wh(c[h>>2]|0,0)|0;s=Ny(c[r>>2]|0)|0;c[(c[m>>2]|0)+40>>2]=s;if(!(c[l>>2]|0)){s=c[m>>2]|0;c[k>>2]=s;c[l>>2]=s;break}else{c[l>>2]=Xh(c[l>>2]|0,c[m>>2]|0)|0;break}}}while(0);Ry(c[r>>2]|0);c[g>>2]=c[k>>2];x=c[g>>2]|0;i=f;return x|0}function _h(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+48|0;g=f+36|0;h=f+32|0;j=f+28|0;k=f+24|0;l=f+20|0;m=f+16|0;n=f+12|0;o=f+8|0;p=f+4|0;q=f;r=f+40|0;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=c[j>>2];c[m>>2]=0;if(!(c[j>>2]|0)){c[g>>2]=0;s=c[g>>2]|0;i=f;return s|0}if((c[(c[j>>2]|0)+20>>2]|0)!=0?(c[(c[(c[j>>2]|0)+20>>2]|0)+4>>2]|0)==2:0)c[o>>2]=1;else c[o>>2]=0;while(1){if(!(c[l>>2]|0))break;do if((c[(c[l>>2]|0)+4>>2]|0)!=3?(c[(c[l>>2]|0)+4>>2]|0)!=4:0){if((c[(c[l>>2]|0)+4>>2]|0)==5){if(!(c[k>>2]|0)){a[r>>0]=38;a[r+1>>0]=0;c[m>>2]=zy(c[m>>2]|0,r,1)|0;c[m>>2]=By(c[m>>2]|0,c[(c[l>>2]|0)+8>>2]|0)|0;a[r>>0]=59;a[r+1>>0]=0;c[m>>2]=zy(c[m>>2]|0,r,1)|0;break}c[n>>2]=ad(c[h>>2]|0,c[(c[l>>2]|0)+8>>2]|0)|0;if(!(c[n>>2]|0)){c[m>>2]=By(c[m>>2]|0,c[(c[l>>2]|0)+40>>2]|0)|0;break}c[q>>2]=_h(c[h>>2]|0,c[(c[n>>2]|0)+12>>2]|0,1)|0;if(c[q>>2]|0){c[m>>2]=By(c[m>>2]|0,c[q>>2]|0)|0;zb[c[135736>>2]&511](c[q>>2]|0)}}}else t=10;while(0);do if((t|0)==10){t=0;if(c[k>>2]|0){c[m>>2]=By(c[m>>2]|0,c[(c[l>>2]|0)+40>>2]|0)|0;break}j=c[h>>2]|0;e=c[(c[l>>2]|0)+40>>2]|0;if(c[o>>2]|0)c[p>>2]=bd(j,e)|0;else c[p>>2]=cd(j,e)|0;if(c[p>>2]|0){c[m>>2]=By(c[m>>2]|0,c[p>>2]|0)|0;zb[c[135736>>2]&511](c[p>>2]|0)}}while(0);c[l>>2]=c[(c[l>>2]|0)+24>>2]}c[g>>2]=c[m>>2];s=c[g>>2]|0;i=f;return s|0}function $h(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(!(c[h>>2]|0)){c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}else{c[f>>2]=wj(c[g>>2]|0,0,c[h>>2]|0,c[j>>2]|0,0)|0;k=c[f>>2]|0;i=e;return k|0}return 0}function ai(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if(!(c[k>>2]|0)){c[g>>2]=0;m=c[g>>2]|0;i=f;return m|0}else{c[g>>2]=wj(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,0)|0;m=c[g>>2]|0;i=f;return m|0}return 0}function bi(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if(!(c[k>>2]|0)){c[g>>2]=0;m=c[g>>2]|0;i=f;return m|0}else{c[g>>2]=wj(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,1)|0;m=c[g>>2]|0;i=f;return m|0}return 0}function ci(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(!(c[h>>2]|0)){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}c[k>>2]=Cb[c[135744>>2]&511](48)|0;if(!(c[k>>2]|0)){tj(75320);c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}d=(c[k>>2]|0)+0|0;b=d+48|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(b|0));c[(c[k>>2]|0)+4>>2]=2;if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+80>>2]|0)!=0:0){d=AP(c[(c[g>>2]|0)+80>>2]|0,c[h>>2]|0,-1)|0;c[(c[k>>2]|0)+8>>2]=d}else{d=my(c[h>>2]|0)|0;c[(c[k>>2]|0)+8>>2]=d}c[(c[k>>2]|0)+32>>2]=c[g>>2];a:do if(c[j>>2]|0){d=Zh(c[g>>2]|0,c[j>>2]|0)|0;c[(c[k>>2]|0)+12>>2]=d;c[(c[k>>2]|0)+16>>2]=0;c[l>>2]=c[(c[k>>2]|0)+12>>2];while(1){if(!(c[l>>2]|0))break a;c[(c[l>>2]|0)+20>>2]=c[k>>2];if(!(c[(c[l>>2]|0)+24>>2]|0))c[(c[k>>2]|0)+16>>2]=c[l>>2];c[l>>2]=c[(c[l>>2]|0)+24>>2]}}while(0);if((c[18774]|0)!=0&(c[33968]|0)!=0)zb[c[135872>>2]&511](c[k>>2]|0);c[f>>2]=c[k>>2];m=c[f>>2]|0;i=e;return m|0}function di(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;if(!((c[d>>2]|0)!=0&(c[d>>2]|0)!=0)){i=b;return}do{c[e>>2]=c[(c[d>>2]|0)+24>>2];ei(c[d>>2]|0);c[d>>2]=c[e>>2]}while((c[d>>2]|0)!=0);i=b;return}function ei(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=0;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+32>>2]|0)c[e>>2]=c[(c[(c[d>>2]|0)+32>>2]|0)+80>>2];if((c[18774]|0)!=0&(c[33970]|0)!=0)zb[c[135880>>2]&511](c[d>>2]|0);if((c[(c[d>>2]|0)+32>>2]|0)!=0?(c[(c[d>>2]|0)+40>>2]|0)==2:0)Gm(c[(c[d>>2]|0)+32>>2]|0,c[d>>2]|0)|0;if(c[(c[d>>2]|0)+12>>2]|0)Uh(c[(c[d>>2]|0)+12>>2]|0);do if(c[(c[d>>2]|0)+8>>2]|0){if((c[e>>2]|0)!=0?(CP(c[e>>2]|0,c[(c[d>>2]|0)+8>>2]|0)|0)!=0:0)break;zb[c[135736>>2]&511](c[(c[d>>2]|0)+8>>2]|0)}while(0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function fi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if(!(c[e>>2]|0)){c[d>>2]=-1;g=c[d>>2]|0;i=b;return g|0}if(!(c[(c[e>>2]|0)+20>>2]|0)){c[d>>2]=-1;g=c[d>>2]|0;i=b;return g|0}c[f>>2]=c[(c[(c[e>>2]|0)+20>>2]|0)+44>>2];if((c[f>>2]|0)==(c[e>>2]|0)){c[(c[(c[e>>2]|0)+20>>2]|0)+44>>2]=c[(c[e>>2]|0)+24>>2];if(c[(c[e>>2]|0)+24>>2]|0)c[(c[(c[e>>2]|0)+24>>2]|0)+28>>2]=0;ei(c[e>>2]|0);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}while(1){if(!(c[f>>2]|0)){h=15;break}if((c[(c[f>>2]|0)+24>>2]|0)==(c[e>>2]|0))break;c[f>>2]=c[(c[f>>2]|0)+24>>2]}if((h|0)==15){c[d>>2]=-1;g=c[d>>2]|0;i=b;return g|0}c[(c[f>>2]|0)+24>>2]=c[(c[e>>2]|0)+24>>2];if(c[(c[f>>2]|0)+24>>2]|0)c[(c[(c[f>>2]|0)+24>>2]|0)+28>>2]=c[f>>2];ei(c[e>>2]|0);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}function gi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(!(c[h>>2]|0)){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}c[k>>2]=Cb[c[135744>>2]&511](60)|0;if(!(c[k>>2]|0)){tj(75344);c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}d=(c[k>>2]|0)+0|0;b=d+60|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(b|0));c[(c[k>>2]|0)+4>>2]=7;if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+80>>2]|0)!=0:0){d=AP(c[(c[g>>2]|0)+80>>2]|0,c[h>>2]|0,-1)|0;c[(c[k>>2]|0)+8>>2]=d}else{d=my(c[h>>2]|0)|0;c[(c[k>>2]|0)+8>>2]=d}if(c[j>>2]|0){d=my(c[j>>2]|0)|0;c[(c[k>>2]|0)+40>>2]=d}c[(c[k>>2]|0)+32>>2]=c[g>>2];if((c[18774]|0)!=0&(c[33968]|0)!=0)zb[c[135872>>2]&511](c[k>>2]|0);c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}function hi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if(!(c[g>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}c[h>>2]=Cb[c[135744>>2]&511](60)|0;if(!(c[h>>2]|0)){tj(75360);c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}b=(c[h>>2]|0)+0|0;a=b+60|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(a|0));c[(c[h>>2]|0)+4>>2]=1;b=my(c[g>>2]|0)|0;c[(c[h>>2]|0)+8>>2]=b;c[(c[h>>2]|0)+36>>2]=c[f>>2];if((c[18774]|0)!=0&(c[33968]|0)!=0)zb[c[135872>>2]&511](c[h>>2]|0);c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}function ii(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if(!(c[g>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}c[h>>2]=Cb[c[135744>>2]&511](60)|0;if(!(c[h>>2]|0)){
tj(75360);c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}b=(c[h>>2]|0)+0|0;a=b+60|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(a|0));c[(c[h>>2]|0)+4>>2]=1;c[(c[h>>2]|0)+8>>2]=c[g>>2];c[(c[h>>2]|0)+36>>2]=c[f>>2];if((c[18774]|0)!=0&(c[33968]|0)!=0)zb[c[135872>>2]&511](c[h>>2]|0);c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}function ji(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+80>>2]|0)!=0:0){e=c[h>>2]|0;c[l>>2]=ii(e,AP(c[(c[g>>2]|0)+80>>2]|0,c[j>>2]|0,-1)|0)|0}else c[l>>2]=hi(c[h>>2]|0,c[j>>2]|0)|0;if(!(c[l>>2]|0)){n=c[l>>2]|0;i=f;return n|0}c[(c[l>>2]|0)+32>>2]=c[g>>2];if(!(c[k>>2]|0)){n=c[l>>2]|0;i=f;return n|0}j=Zh(c[g>>2]|0,c[k>>2]|0)|0;c[(c[l>>2]|0)+12>>2]=j;if(!(c[l>>2]|0)){n=c[l>>2]|0;i=f;return n|0}c[m>>2]=c[(c[l>>2]|0)+12>>2];if(!(c[m>>2]|0)){c[(c[l>>2]|0)+16>>2]=0;n=c[l>>2]|0;i=f;return n|0}while(1){j=(c[(c[m>>2]|0)+24>>2]|0)!=0;c[(c[m>>2]|0)+20>>2]=c[l>>2];o=c[m>>2]|0;if(!j)break;c[m>>2]=c[o+24>>2]}c[(c[l>>2]|0)+16>>2]=o;n=c[l>>2]|0;i=f;return n|0}function ki(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=ii(c[h>>2]|0,c[j>>2]|0)|0;do if(c[l>>2]|0){c[(c[l>>2]|0)+32>>2]=c[g>>2];if((c[k>>2]|0)!=0?(h=Zh(c[g>>2]|0,c[k>>2]|0)|0,c[(c[l>>2]|0)+12>>2]=h,(c[l>>2]|0)!=0):0){c[m>>2]=c[(c[l>>2]|0)+12>>2];if(!(c[m>>2]|0)){c[(c[l>>2]|0)+16>>2]=0;break}while(1){h=(c[(c[m>>2]|0)+24>>2]|0)!=0;c[(c[m>>2]|0)+20>>2]=c[l>>2];n=c[m>>2]|0;if(!h)break;c[m>>2]=c[n+24>>2]}c[(c[l>>2]|0)+16>>2]=n}}else if((c[j>>2]|0)!=0&(c[g>>2]|0)!=0?(CP(c[(c[g>>2]|0)+80>>2]|0,c[j>>2]|0)|0)==0:0)zb[c[135736>>2]&511](c[j>>2]|0);while(0);i=f;return c[l>>2]|0}function li(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](60)|0;if(!(c[f>>2]|0)){tj(75376);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}a=(c[f>>2]|0)+0|0;h=a+60|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(h|0));c[(c[f>>2]|0)+4>>2]=3;c[(c[f>>2]|0)+8>>2]=75104;if(c[e>>2]|0){a=my(c[e>>2]|0)|0;c[(c[f>>2]|0)+40>>2]=a}if((c[18774]|0)!=0&(c[33968]|0)!=0)zb[c[135872>>2]&511](c[f>>2]|0);c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}function mi(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;if(!(c[h>>2]|0)){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}c[j>>2]=Cb[c[135744>>2]&511](60)|0;if(!(c[j>>2]|0)){tj(75392);c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}b=(c[j>>2]|0)+0|0;a=b+60|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(a|0));c[(c[j>>2]|0)+4>>2]=5;c[(c[j>>2]|0)+32>>2]=c[g>>2];g=c[h>>2]|0;do if((d[c[h>>2]>>0]|0|0)==38){c[h>>2]=g+1;c[k>>2]=xy(c[h>>2]|0)|0;b=c[h>>2]|0;a=c[k>>2]|0;if((d[(c[h>>2]|0)+((c[k>>2]|0)-1)>>0]|0|0)==59){m=ly(b,a-1|0)|0;c[(c[j>>2]|0)+8>>2]=m;break}else{m=ly(b,a)|0;c[(c[j>>2]|0)+8>>2]=m;break}}else{m=my(g)|0;c[(c[j>>2]|0)+8>>2]=m}while(0);if((c[18774]|0)!=0&(c[33968]|0)!=0)zb[c[135872>>2]&511](c[j>>2]|0);c[f>>2]=c[j>>2];l=c[f>>2]|0;i=e;return l|0}function ni(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=Cb[c[135744>>2]&511](60)|0;if(!(c[h>>2]|0)){tj(75376);c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}b=(c[h>>2]|0)+0|0;a=b+60|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(a|0));c[(c[h>>2]|0)+4>>2]=3;c[(c[h>>2]|0)+8>>2]=75104;if(c[f>>2]|0){b=ly(c[f>>2]|0,c[g>>2]|0)|0;c[(c[h>>2]|0)+40>>2]=b}if((c[18774]|0)!=0&(c[33968]|0)!=0)zb[c[135872>>2]&511](c[h>>2]|0);c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}function oi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](60)|0;if(!(c[f>>2]|0)){tj(75448);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}a=(c[f>>2]|0)+0|0;h=a+60|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(h|0));c[(c[f>>2]|0)+4>>2]=8;c[(c[f>>2]|0)+8>>2]=75128;if(c[e>>2]|0){a=my(c[e>>2]|0)|0;c[(c[f>>2]|0)+40>>2]=a}if((c[18774]|0)!=0&(c[33968]|0)!=0)zb[c[135872>>2]&511](c[f>>2]|0);c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}function pi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=Cb[c[135744>>2]&511](60)|0;if(!(c[k>>2]|0)){tj(75472);c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}d=(c[k>>2]|0)+0|0;b=d+60|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(b|0));c[(c[k>>2]|0)+4>>2]=4;c[(c[k>>2]|0)+32>>2]=c[g>>2];if(c[h>>2]|0){g=ly(c[h>>2]|0,c[j>>2]|0)|0;c[(c[k>>2]|0)+40>>2]=g}if((c[18774]|0)!=0&(c[33968]|0)!=0)zb[c[135872>>2]&511](c[k>>2]|0);c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}function qi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=oi(c[f>>2]|0)|0;if(!(c[g>>2]|0)){h=c[g>>2]|0;i=d;return h|0}c[(c[g>>2]|0)+32>>2]=c[e>>2];h=c[g>>2]|0;i=d;return h|0}function ri(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}if((c[(c[e>>2]|0)+4>>2]|0)==18){i=d;return}if((c[(c[e>>2]|0)+32>>2]|0)==(c[f>>2]|0)){i=d;return}a:do if((c[(c[e>>2]|0)+4>>2]|0)==1){c[g>>2]=c[(c[e>>2]|0)+44>>2];while(1){if(!(c[g>>2]|0))break a;c[(c[g>>2]|0)+32>>2]=c[f>>2];si(c[(c[g>>2]|0)+12>>2]|0,c[f>>2]|0);c[g>>2]=c[(c[g>>2]|0)+24>>2]}}while(0);if(c[(c[e>>2]|0)+12>>2]|0)si(c[(c[e>>2]|0)+12>>2]|0,c[f>>2]|0);c[(c[e>>2]|0)+32>>2]=c[f>>2];i=d;return}function si(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}if((c[(c[e>>2]|0)+4>>2]|0)==18){i=d;return}c[g>>2]=c[e>>2];while(1){if(!(c[g>>2]|0))break;if((c[(c[g>>2]|0)+32>>2]|0)!=(c[f>>2]|0))ri(c[g>>2]|0,c[f>>2]|0);c[g>>2]=c[(c[g>>2]|0)+24>>2]}i=d;return}function ti(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if(!(c[h>>2]|0)){c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}if(!(c[k>>2]|0)){c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}do if((c[(c[h>>2]|0)+4>>2]|0)==1){e=c[(c[h>>2]|0)+32>>2]|0;if(!(c[j>>2]|0)){c[m>>2]=ji(e,c[(c[h>>2]|0)+36>>2]|0,c[k>>2]|0,c[l>>2]|0)|0;break}else{c[m>>2]=ji(e,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0)|0;break}}else{if((c[(c[h>>2]|0)+4>>2]|0)!=9?(c[(c[h>>2]|0)+4>>2]|0)!=13:0){if((c[(c[h>>2]|0)+4>>2]|0)==11){c[m>>2]=ji(c[(c[h>>2]|0)+32>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0)|0;break}c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}e=c[h>>2]|0;if(!(c[j>>2]|0)){c[m>>2]=ji(e,0,c[k>>2]|0,c[l>>2]|0)|0;break}else{c[m>>2]=ji(e,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0)|0;break}}while(0);if(!(c[m>>2]|0)){c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}c[(c[m>>2]|0)+4>>2]=1;c[(c[m>>2]|0)+20>>2]=c[h>>2];c[(c[m>>2]|0)+32>>2]=c[(c[h>>2]|0)+32>>2];if(!(c[(c[h>>2]|0)+12>>2]|0)){c[(c[h>>2]|0)+12>>2]=c[m>>2];c[(c[h>>2]|0)+16>>2]=c[m>>2]}else{c[n>>2]=c[(c[h>>2]|0)+16>>2];c[(c[n>>2]|0)+24>>2]=c[m>>2];c[(c[m>>2]|0)+28>>2]=c[n>>2];c[(c[h>>2]|0)+16>>2]=c[m>>2]}c[g>>2]=c[m>>2];o=c[g>>2]|0;i=f;return o|0}function ui(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;if((c[e>>2]|0)==0|(c[f>>2]|0)==0){i=d;return}c[g>>2]=xy(c[f>>2]|0)|0;$i(c[e>>2]|0,c[f>>2]|0,c[g>>2]|0);i=d;return}function vi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}switch(c[(c[e>>2]|0)+4>>2]|0){case 8:case 7:case 6:case 5:case 4:case 3:{do if((c[(c[e>>2]|0)+40>>2]|0)!=0?(c[(c[e>>2]|0)+40>>2]|0)!=((c[e>>2]|0)+44|0):0){if(((c[(c[e>>2]|0)+32>>2]|0)!=0?(c[(c[(c[e>>2]|0)+32>>2]|0)+80>>2]|0)!=0:0)?(CP(c[(c[(c[e>>2]|0)+32>>2]|0)+80>>2]|0,c[(c[e>>2]|0)+40>>2]|0)|0)!=0:0)break;zb[c[135736>>2]&511](c[(c[e>>2]|0)+40>>2]|0)}while(0);if(c[(c[e>>2]|0)+12>>2]|0)Uh(c[(c[e>>2]|0)+12>>2]|0);c[(c[e>>2]|0)+12>>2]=0;c[(c[e>>2]|0)+16>>2]=0;if(c[f>>2]|0){b=my(c[f>>2]|0)|0;c[(c[e>>2]|0)+40>>2]=b}else c[(c[e>>2]|0)+40>>2]=0;c[(c[e>>2]|0)+44>>2]=0;c[(c[e>>2]|0)+48>>2]=0;i=d;return}case 2:case 1:case 11:{if(c[(c[e>>2]|0)+12>>2]|0)Uh(c[(c[e>>2]|0)+12>>2]|0);b=Zh(c[(c[e>>2]|0)+32>>2]|0,c[f>>2]|0)|0;c[(c[e>>2]|0)+12>>2]=b;if(!(c[e>>2]|0)){i=d;return}c[g>>2]=c[(c[e>>2]|0)+12>>2];if(!(c[g>>2]|0)){c[(c[e>>2]|0)+16>>2]=0;i=d;return}while(1){b=(c[(c[g>>2]|0)+24>>2]|0)!=0;c[(c[g>>2]|0)+20>>2]=c[e>>2];h=c[g>>2]|0;if(!b)break;c[g>>2]=c[h+24>>2]}c[(c[e>>2]|0)+16>>2]=h;i=d;return}default:{i=d;return}}}function wi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+4>>2]|0)!=18:0){if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+4>>2]|0)!=18:0){if((c[f>>2]|0)==(c[g>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}Qh(c[g>>2]|0);if((c[(c[g>>2]|0)+4>>2]|0)==3){if((c[(c[f>>2]|0)+4>>2]|0)==3){c[h>>2]=my(c[(c[g>>2]|0)+40>>2]|0)|0;c[h>>2]=By(c[h>>2]|0,c[(c[f>>2]|0)+40>>2]|0)|0;vi(c[f>>2]|0,c[h>>2]|0);zb[c[135736>>2]&511](c[h>>2]|0);Rh(c[g>>2]|0);c[e>>2]=c[f>>2];j=c[e>>2]|0;i=d;return j|0}if(((c[(c[f>>2]|0)+28>>2]|0)!=0?(c[(c[(c[f>>2]|0)+28>>2]|0)+4>>2]|0)==3:0)?(c[(c[f>>2]|0)+8>>2]|0)==(c[(c[(c[f>>2]|0)+28>>2]|0)+8>>2]|0):0){ui(c[(c[f>>2]|0)+28>>2]|0,c[(c[g>>2]|0)+40>>2]|0);Rh(c[g>>2]|0);c[e>>2]=c[(c[f>>2]|0)+28>>2];j=c[e>>2]|0;i=d;return j|0}}else if((c[(c[g>>2]|0)+4>>2]|0)==2){c[e>>2]=vj(c[(c[f>>2]|0)+28>>2]|0,c[f>>2]|0,c[g>>2]|0)|0;j=c[e>>2]|0;i=d;return j|0}if((c[(c[g>>2]|0)+32>>2]|0)!=(c[(c[f>>2]|0)+32>>2]|0))ri(c[g>>2]|0,c[(c[f>>2]|0)+32>>2]|0);c[(c[g>>2]|0)+20>>2]=c[(c[f>>2]|0)+20>>2];c[(c[g>>2]|0)+24>>2]=c[f>>2];c[(c[g>>2]|0)+28>>2]=c[(c[f>>2]|0)+28>>2];c[(c[f>>2]|0)+28>>2]=c[g>>2];if(c[(c[g>>2]|0)+28>>2]|0)c[(c[(c[g>>2]|0)+28>>2]|0)+24>>2]=c[g>>2];if((c[(c[g>>2]|0)+20>>2]|0)!=0?(c[(c[(c[g>>2]|0)+20>>2]|0)+12>>2]|0)==(c[f>>2]|0):0)c[(c[(c[g>>2]|0)+20>>2]|0)+12>>2]=c[g>>2];c[e>>2]=c[g>>2];j=c[e>>2]|0;i=d;return j|0}c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}function xi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+4>>2]|0)!=18:0){if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+4>>2]|0)!=18:0){if((c[f>>2]|0)==(c[g>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}if(((((c[(c[f>>2]|0)+4>>2]|0)!=2?(c[(c[f>>2]|0)+20>>2]|0)!=0:0)?(c[(c[(c[f>>2]|0)+20>>2]|0)+12>>2]|0)!=0:0)?(c[(c[(c[f>>2]|0)+20>>2]|0)+16>>2]|0)!=0:0)?(c[(c[(c[(c[f>>2]|0)+20>>2]|0)+16>>2]|0)+24>>2]|0)==0:0)c[f>>2]=c[(c[(c[f>>2]|0)+20>>2]|0)+16>>2];else k=15;a:do if((k|0)==15)while(1){k=0;if(!(c[(c[f>>2]|0)+24>>2]|0))break a;c[f>>2]=c[(c[f>>2]|0)+24>>2];k=15}while(0);Qh(c[g>>2]|0);if(((c[(c[f>>2]|0)+4>>2]|0)==3?(c[(c[g>>2]|0)+4>>2]|0)==3:0)?(c[(c[f>>2]|0)+8>>2]|0)==(c[(c[g>>2]|0)+8>>2]|0):0){ui(c[f>>2]|0,c[(c[g>>2]|0)+40>>2]|0);Rh(c[g>>2]|0);c[e>>2]=c[f>>2];j=c[e>>2]|0;i=d;return j|0}if((c[(c[g>>2]|0)+4>>2]|0)==2){c[e>>2]=vj(c[f>>2]|0,c[f>>2]|0,c[g>>2]|0)|0;j=c[e>>2]|0;i=d;return j|0}if((c[(c[g>>2]|0)+32>>2]|0)!=(c[(c[f>>2]|0)+32>>2]|0))ri(c[g>>2]|0,c[(c[f>>2]|0)+32>>2]|0);c[h>>2]=c[(c[f>>2]|0)+20>>2];c[(c[g>>2]|0)+28>>2]=c[f>>2];c[(c[g>>2]|0)+24>>2]=0;c[(c[g>>2]|0)+20>>2]=c[h>>2];c[(c[f>>2]|0)+24>>2]=c[g>>2];if(c[h>>2]|0)c[(c[h>>2]|0)+16>>2]=c[g>>2];c[e>>2]=c[g>>2];j=c[e>>2]|0;i=d;return j|0}c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}function yi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+4>>2]|0)!=18:0){if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+4>>2]|0)!=18:0){b=c[g>>2]|0;if(!(c[(c[f>>2]|0)+12>>2]|0))c[(c[f>>2]|0)+12>>2]=b;else{do if(((c[b+4>>2]|0)==3?(c[(c[(c[f>>2]|0)+16>>2]|0)+4>>2]|0)==3:0)?(c[(c[g>>2]|0)+8>>2]|0)==(c[(c[(c[f>>2]|0)+16>>2]|0)+8>>2]|0):0){ui(c[(c[f>>2]|0)+16>>2]|0,c[(c[g>>2]|0)+40>>2]|0);a=c[g>>2]|0;if(c[(c[g>>2]|0)+24>>2]|0){c[h>>2]=a;c[g>>2]=c[(c[g>>2]|0)+24>>2];Rh(c[h>>2]|0);break}Rh(a);c[e>>2]=c[(c[f>>2]|0)+16>>2];j=c[e>>2]|0;i=d;return j|0}while(0);c[h>>2]=c[(c[f>>2]|0)+16>>2];c[(c[h>>2]|0)+24>>2]=c[g>>2];c[(c[g>>2]|0)+28>>2]=c[h>>2]}while(1){h=(c[(c[g>>2]|0)+24>>2]|0)!=0;c[(c[g>>2]|0)+20>>2]=c[f>>2];k=(c[(c[g>>2]|0)+32>>2]|0)!=(c[(c[f>>2]|0)+32>>2]|0);if(!h)break;if(k)ri(c[g>>2]|0,c[(c[f>>2]|0)+32>>2]|0);c[g>>2]=c[(c[g>>2]|0)+24>>2]}if(k)ri(c[g>>2]|0,c[(c[f>>2]|0)+32>>2]|0);c[(c[f>>2]|0)+16>>2]=c[g>>2];c[e>>2]=c[g>>2];j=c[e>>2]|0;i=d;return j|0}c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}function zi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+4>>2]|0)!=18:0){if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+4>>2]|0)!=18:0){if((c[f>>2]|0)==(c[g>>2]|0)){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}if((c[(c[g>>2]|0)+4>>2]|0)==3){if(((c[(c[f>>2]|0)+4>>2]|0)==3?(c[(c[f>>2]|0)+40>>2]|0)!=0:0)?(c[(c[f>>2]|0)+8>>2]|0)==(c[(c[g>>2]|0)+8>>2]|0):0){ui(c[f>>2]|0,c[(c[g>>2]|0)+40>>2]|0);Rh(c[g>>2]|0);c[e>>2]=c[f>>2];l=c[e>>2]|0;i=d;return l|0}if((((c[(c[f>>2]|0)+16>>2]|0)!=0?(c[(c[(c[f>>2]|0)+16>>2]|0)+4>>2]|0)==3:0)?(c[(c[(c[f>>2]|0)+16>>2]|0)+8>>2]|0)==(c[(c[g>>2]|0)+8>>2]|0):0)?(c[(c[f>>2]|0)+16>>2]|0)!=(c[g>>2]|0):0){ui(c[(c[f>>2]|0)+16>>2]|0,c[(c[g>>2]|0)+40>>2]|0);Rh(c[g>>2]|0);c[e>>2]=c[(c[f>>2]|0)+16>>2];l=c[e>>2]|0;i=d;return l|0}}c[h>>2]=c[(c[g>>2]|0)+20>>2];c[(c[g>>2]|0)+20>>2]=c[f>>2];if((c[(c[g>>2]|0)+32>>2]|0)!=(c[(c[f>>2]|0)+32>>2]|0))ri(c[g>>2]|0,c[(c[f>>2]|0)+32>>2]|0);if((c[h>>2]|0)==(c[f>>2]|0)){c[e>>2]=c[g>>2];l=c[e>>2]|0;i=d;return l|0}if(((c[(c[f>>2]|0)+4>>2]|0)==3?(c[(c[f>>2]|0)+40>>2]|0)!=0:0)?(c[f>>2]|0)!=(c[g>>2]|0):0){ui(c[f>>2]|0,c[(c[g>>2]|0)+40>>2]|0);Rh(c[g>>2]|0);c[e>>2]=c[f>>2];l=c[e>>2]|0;i=d;return l|0}b=c[f>>2]|0;do if((c[(c[g>>2]|0)+4>>2]|0)!=2)if(!(c[b+12>>2]|0)){c[(c[f>>2]|0)+12>>2]=c[g>>2];c[(c[f>>2]|0)+16>>2]=c[g>>2];break}else{c[h>>2]=c[(c[f>>2]|0)+16>>2];c[(c[h>>2]|0)+24>>2]=c[g>>2];c[(c[g>>2]|0)+28>>2]=c[h>>2];c[(c[f>>2]|0)+16>>2]=c[g>>2];break}else{if((c[b+4>>2]|0)!=1){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}if(c[(c[f>>2]|0)+44>>2]|0){a=c[f>>2]|0;m=c[(c[g>>2]|0)+8>>2]|0;if(!(c[(c[g>>2]|0)+36>>2]|0))c[j>>2]=Ai(a,m,0)|0;else c[j>>2]=Ai(a,m,c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0)|0;do if((c[j>>2]|0)!=0?(c[j>>2]|0)!=(c[g>>2]|0):0){if((c[(c[j>>2]|0)+4>>2]|0)==16)break;Qh(c[j>>2]|0);ei(c[j>>2]|0)}while(0);if((c[j>>2]|0)==(c[g>>2]|0)){c[e>>2]=c[g>>2];l=c[e>>2]|0;i=d;return l|0}}if(!(c[(c[f>>2]|0)+44>>2]|0)){c[(c[f>>2]|0)+44>>2]=c[g>>2];break}c[k>>2]=c[(c[f>>2]|0)+44>>2];while(1){if(!(c[(c[k>>2]|0)+24>>2]|0))break;c[k>>2]=c[(c[k>>2]|0)+24>>2]}c[(c[k>>2]|0)+24>>2]=c[g>>2];c[(c[g>>2]|0)+28>>2]=c[k>>2]}while(0);c[e>>2]=c[g>>2];l=c[e>>2]|0;i=d;return l|0}c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}function Ai(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=xj(c[f>>2]|0,c[g>>2]|0,c[h>>2]|0,c[18946]|0)|0;i=e;return d|0}function Bi(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+4>>2]|0)!=18:0){c[d>>2]=c[(c[e>>2]|0)+16>>2];f=c[d>>2]|0;i=b;return f|0}c[d>>2]=0;f=c[d>>2]|0;i=b;return f|0}function Ci(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)==(c[g>>2]|0)){c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}if(((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+4>>2]|0)!=18:0)?(c[(c[f>>2]|0)+20>>2]|0)!=0:0){if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+4>>2]|0)!=18:0){b=c[f>>2]|0;if((c[g>>2]|0)==(c[f>>2]|0)){c[e>>2]=b;h=c[e>>2]|0;i=d;return h|0}if((c[b+4>>2]|0)==2?(c[(c[g>>2]|0)+4>>2]|0)!=2:0){c[e>>2]=c[f>>2];h=c[e>>2]|0;i=d;return h|0}if((c[(c[g>>2]|0)+4>>2]|0)==2?(c[(c[f>>2]|0)+4>>2]|0)!=2:0){c[e>>2]=c[f>>2];h=c[e>>2]|0;i=d;return h|0}Qh(c[g>>2]|0);ri(c[g>>2]|0,c[(c[f>>2]|0)+32>>2]|0);c[(c[g>>2]|0)+20>>2]=c[(c[f>>2]|0)+20>>2];c[(c[g>>2]|0)+24>>2]=c[(c[f>>2]|0)+24>>2];if(c[(c[g>>2]|0)+24>>2]|0)c[(c[(c[g>>2]|0)+24>>2]|0)+28>>2]=c[g>>2];c[(c[g>>2]|0)+28>>2]=c[(c[f>>2]|0)+28>>2];if(c[(c[g>>2]|0)+28>>2]|0)c[(c[(c[g>>2]|0)+28>>2]|0)+24>>2]=c[g>>2];do if(c[(c[g>>2]|0)+20>>2]|0){b=c[(c[g>>2]|0)+20>>2]|0;if((c[(c[g>>2]|0)+4>>2]|0)==2){if((c[b+44>>2]|0)!=(c[f>>2]|0))break;c[(c[(c[g>>2]|0)+20>>2]|0)+44>>2]=c[g>>2];break}if((c[b+12>>2]|0)==(c[f>>2]|0))c[(c[(c[g>>2]|0)+20>>2]|0)+12>>2]=c[g>>2];if((c[(c[(c[g>>2]|0)+20>>2]|0)+16>>2]|0)==(c[f>>2]|0))c[(c[(c[g>>2]|0)+20>>2]|0)+16>>2]=c[g>>2]}while(0);c[(c[f>>2]|0)+28>>2]=0;c[(c[f>>2]|0)+24>>2]=0;c[(c[f>>2]|0)+20>>2]=0;c[e>>2]=c[f>>2];h=c[e>>2]|0;i=d;return h|0}Qh(c[f>>2]|0);c[e>>2]=c[f>>2];h=c[e>>2]|0;i=d;return h|0}c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}function Di(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;do if(c[e>>2]|0)if((c[(c[e>>2]|0)+4>>2]|0)==18){c[f>>2]=Ih(0,c[(c[e>>2]|0)+8>>2]|0,c[(c[e>>2]|0)+12>>2]|0)|0;c[d>>2]=c[f>>2];break}else{c[d>>2]=0;break}else c[d>>2]=0;while(0);i=b;return c[d>>2]|0}function Ei(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[d>>2]=a;c[e>>2]=0;c[f>>2]=0;while(1){if(!(c[d>>2]|0))break;c[g>>2]=Di(c[d>>2]|0)|0;a=c[g>>2]|0;if(!(c[f>>2]|0)){c[f>>2]=a;c[e>>2]=a}else{c[c[f>>2]>>2]=a;c[f>>2]=c[g>>2]}c[d>>2]=c[c[d>>2]>>2]}i=b;return c[e>>2]|0}function Fi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=yj(0,c[e>>2]|0,c[f>>2]|0)|0;i=d;return b|0}function Gi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;c[j>>2]=0;if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+4>>2]|0)!=1:0){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}while(1){if(!(c[g>>2]|0)){m=11;break}c[k>>2]=Fi(c[f>>2]|0,c[g>>2]|0)|0;if(!(c[k>>2]|0)){m=6;break}b=c[k>>2]|0;if(!(c[j>>2]|0)){c[j>>2]=b;c[h>>2]=b}else{c[(c[j>>2]|0)+24>>2]=b;c[(c[k>>2]|0)+28>>2]=c[j>>2];c[j>>2]=c[k>>2]}c[g>>2]=c[(c[g>>2]|0)+24>>2]}if((m|0)==6){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}else if((m|0)==11){c[e>>2]=c[h>>2];l=c[e>>2]|0;i=d;return l|0}return 0}function Hi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=zj(c[e>>2]|0,0,0,c[f>>2]|0)|0;i=d;return c[g>>2]|0}function Ii(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=zj(c[f>>2]|0,c[g>>2]|0,0,c[h>>2]|0)|0;i=e;return c[j>>2]|0}function Ji(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=Aj(c[f>>2]|0,c[e>>2]|0,0)|0;i=d;return c[g>>2]|0}function Ki(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=Aj(c[d>>2]|0,0,0)|0;i=b;return c[e>>2]|0}function Li(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+48|0;d=b+32|0;e=b+28|0;f=b+24|0;g=b+20|0;h=b+16|0;j=b+12|0;k=b+8|0;l=b+4|0;m=b;c[e>>2]=a;c[h>>2]=0;if(!(c[e>>2]|0)){c[d>>2]=0;n=c[d>>2]|0;i=b;return n|0}c[f>>2]=Mh(0,c[(c[e>>2]|0)+8>>2]|0,c[(c[e>>2]|0)+52>>2]|0,c[(c[e>>2]|0)+56>>2]|0)|0;if(!(c[f>>2]|0)){c[d>>2]=0;n=c[d>>2]|0;i=b;return n|0}if(c[(c[e>>2]|0)+48>>2]|0){a=ed(c[(c[e>>2]|0)+48>>2]|0)|0;c[(c[f>>2]|0)+48>>2]=a}if(c[(c[e>>2]|0)+36>>2]|0){a=zm(c[(c[e>>2]|0)+36>>2]|0)|0;c[(c[f>>2]|0)+36>>2]=a}if(c[(c[e>>2]|0)+40>>2]|0){a=om(c[(c[e>>2]|0)+40>>2]|0)|0;c[(c[f>>2]|0)+40>>2]=a}if(c[(c[e>>2]|0)+44>>2]|0){a=vm(c[(c[e>>2]|0)+44>>2]|0)|0;c[(c[f>>2]|0)+44>>2]=a}if(c[(c[e>>2]|0)+60>>2]|0){a=ed(c[(c[e>>2]|0)+60>>2]|0)|0;c[(c[f>>2]|0)+60>>2]=a}c[g>>2]=c[(c[e>>2]|0)+12>>2];while(1){if(!(c[g>>2]|0))break;c[j>>2]=0;e=c[g>>2]|0;a:do if((c[(c[g>>2]|0)+4>>2]|0)!=17){a=c[g>>2]|0;if((c[e+4>>2]|0)==15){c[l>>2]=a;c[j>>2]=Mm(c[f>>2]|0,c[(c[l>>2]|0)+8>>2]|0,c[(c[l>>2]|0)+48>>2]|0)|0;break}o=c[g>>2]|0;if((c[a+4>>2]|0)==16){c[m>>2]=o;c[j>>2]=Nm(c[f>>2]|0,c[(c[m>>2]|0)+60>>2]|0,c[(c[m>>2]|0)+8>>2]|0,c[(c[m>>2]|0)+56>>2]|0)|0;break}if((c[o+4>>2]|0)==8)c[j>>2]=Hi(c[g>>2]|0,0)|0}else{c[k>>2]=e;switch(c[(c[k>>2]|0)+48>>2]|0){case 3:case 2:case 1:{c[j>>2]=Bj(c[f>>2]|0,c[(c[k>>2]|0)+8>>2]|0)|0;break a;break}case 5:case 4:{c[j>>2]=Cj(c[f>>2]|0,c[(c[k>>2]|0)+8>>2]|0)|0;break a;break}default:break a}}while(0);if(!(c[j>>2]|0)){c[g>>2]=c[(c[g>>2]|0)+24>>2];continue}e=c[j>>2]|0;if(!(c[h>>2]|0))c[(c[f>>2]|0)+12>>2]=e;else c[(c[h>>2]|0)+24>>2]=e;c[(c[j>>2]|0)+28>>2]=c[h>>2];c[(c[j>>2]|0)+20>>2]=c[f>>2];c[(c[j>>2]|0)+24>>2]=0;c[(c[f>>2]|0)+16>>2]=c[j>>2];c[h>>2]=c[j>>2];c[g>>2]=c[(c[g>>2]|0)+24>>2]}c[d>>2]=c[f>>2];n=c[d>>2]|0;i=b;return n|0}function Mi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[f>>2]=a;c[g>>2]=b;if(!(c[f>>2]|0)){c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}c[h>>2]=Sh(c[(c[f>>2]|0)+56>>2]|0)|0;if(!(c[h>>2]|0)){c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}if(c[(c[f>>2]|0)+8>>2]|0){b=Cb[c[135768>>2]&511](c[(c[f>>2]|0)+8>>2]|0)|0;c[(c[h>>2]|0)+8>>2]=b}if(c[(c[f>>2]|0)+60>>2]|0){b=my(c[(c[f>>2]|0)+60>>2]|0)|0;c[(c[h>>2]|0)+60>>2]=b}if(c[(c[f>>2]|0)+72>>2]|0){b=my(c[(c[f>>2]|0)+72>>2]|0)|0;c[(c[h>>2]|0)+72>>2]=b}c[(c[h>>2]|0)+76>>2]=c[(c[f>>2]|0)+76>>2];c[(c[h>>2]|0)+36>>2]=c[(c[f>>2]|0)+36>>2];c[(c[h>>2]|0)+40>>2]=c[(c[f>>2]|0)+40>>2];b=c[h>>2]|0;if(!(c[g>>2]|0)){c[e>>2]=b;k=c[e>>2]|0;i=d;return k|0}c[b+16>>2]=0;c[(c[h>>2]|0)+12>>2]=0;do if(c[(c[f>>2]|0)+44>>2]|0){b=Li(c[(c[f>>2]|0)+44>>2]|0)|0;c[(c[h>>2]|0)+44>>2]=b;b=c[h>>2]|0;if(c[(c[h>>2]|0)+44>>2]|0){ri(c[b+44>>2]|0,c[h>>2]|0);c[(c[(c[h>>2]|0)+44>>2]|0)+20>>2]=c[h>>2];break}Th(b);c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}while(0);if(c[(c[f>>2]|0)+52>>2]|0){b=Ei(c[(c[f>>2]|0)+52>>2]|0)|0;c[(c[h>>2]|0)+52>>2]=b}a:do if(c[(c[f>>2]|0)+12>>2]|0){b=Aj(c[(c[f>>2]|0)+12>>2]|0,c[h>>2]|0,c[h>>2]|0)|0;c[(c[h>>2]|0)+12>>2]=b;c[(c[h>>2]|0)+16>>2]=0;c[j>>2]=c[(c[h>>2]|0)+12>>2];while(1){if(!(c[j>>2]|0))break a;if(!(c[(c[j>>2]|0)+24>>2]|0))c[(c[h>>2]|0)+16>>2]=c[j>>2];c[j>>2]=c[(c[j>>2]|0)+24>>2]}}while(0);c[e>>2]=c[h>>2];k=c[e>>2]|0;i=d;return k|0}function Ni(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=Dj(c[d>>2]|0,0)|0;i=b;return a|0}function Oi(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=i;i=i+176|0;f=e;g=e+64|0;h=e+60|0;j=e+56|0;k=e+52|0;l=e+48|0;m=e+44|0;n=e+40|0;o=e+36|0;p=e+32|0;q=e+28|0;r=e+24|0;s=e+68|0;t=e+20|0;u=e+16|0;c[h>>2]=b;c[m>>2]=0;c[t>>2]=0;if((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+4>>2]|0)!=18:0){c[o>>2]=500;c[m>>2]=Cb[c[135752>>2]&511](c[o>>2]|0)|0;if(!(c[m>>2]|0)){tj(75488);c[g>>2]=0;v=c[g>>2]|0;i=e;return v|0}c[p>>2]=Cb[c[135752>>2]&511](c[o>>2]|0)|0;if(!(c[p>>2]|0)){tj(75488);zb[c[135736>>2]&511](c[m>>2]|0);c[g>>2]=0;v=c[g>>2]|0;i=e;return v|0}a[c[m>>2]>>0]=0;c[j>>2]=c[h>>2];while(1){c[r>>2]=75312;c[q>>2]=75512;c[t>>2]=0;a:do if((c[(c[j>>2]|0)+4>>2]|0)!=9?(c[(c[j>>2]|0)+4>>2]|0)!=13:0){if((c[(c[j>>2]|0)+4>>2]|0)==1){c[u>>2]=0;c[q>>2]=75520;c[r>>2]=c[(c[j>>2]|0)+8>>2];do if(c[(c[j>>2]|0)+36>>2]|0)if(c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2]|0){h=c[(c[j>>2]|0)+8>>2]|0;c[f>>2]=c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2];c[f+4>>2]=h;JT(s,99,75528,f)|0;a[s+99>>0]=0;c[r>>2]=s;break}else{c[u>>2]=1;c[r>>2]=75536;break}while(0);c[l>>2]=c[(c[j>>2]|0)+20>>2];c[k>>2]=c[(c[j>>2]|0)+28>>2];while(1){if(!(c[k>>2]|0))break;do if((c[(c[k>>2]|0)+4>>2]|0)==1){if(!(c[u>>2]|0)){if(!(qy(c[(c[j>>2]|0)+8>>2]|0,c[(c[k>>2]|0)+8>>2]|0)|0))break;if((c[(c[k>>2]|0)+36>>2]|0)!=(c[(c[j>>2]|0)+36>>2]|0)){if(!(c[(c[k>>2]|0)+36>>2]|0))break;if(!(c[(c[j>>2]|0)+36>>2]|0))break;if(!(qy(c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2]|0,c[(c[(c[k>>2]|0)+36>>2]|0)+12>>2]|0)|0))break}}c[t>>2]=(c[t>>2]|0)+1}while(0);c[k>>2]=c[(c[k>>2]|0)+28>>2]}if(c[t>>2]|0){c[t>>2]=(c[t>>2]|0)+1;break}c[k>>2]=c[(c[j>>2]|0)+24>>2];while(1){if(!((c[k>>2]|0)!=0&(c[t>>2]|0)==0))break;b:do if((c[(c[k>>2]|0)+4>>2]|0)==1){do if(!(c[u>>2]|0)){if(!(qy(c[(c[j>>2]|0)+8>>2]|0,c[(c[k>>2]|0)+8>>2]|0)|0))break b;if((c[(c[k>>2]|0)+36>>2]|0)==(c[(c[j>>2]|0)+36>>2]|0))break;if(!(c[(c[k>>2]|0)+36>>2]|0))break b;if(!(c[(c[j>>2]|0)+36>>2]|0))break b;if(!(qy(c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2]|0,c[(c[(c[k>>2]|0)+36>>2]|0)+12>>2]|0)|0))break b}while(0);c[t>>2]=(c[t>>2]|0)+1}while(0);c[k>>2]=c[(c[k>>2]|0)+24>>2]}if(!(c[t>>2]|0))break;c[t>>2]=1;break}if((c[(c[j>>2]|0)+4>>2]|0)==8){c[q>>2]=75520;c[r>>2]=75544;c[l>>2]=c[(c[j>>2]|0)+20>>2];c[k>>2]=c[(c[j>>2]|0)+28>>2];while(1){if(!(c[k>>2]|0))break;if((c[(c[k>>2]|0)+4>>2]|0)==8)c[t>>2]=(c[t>>2]|0)+1;c[k>>2]=c[(c[k>>2]|0)+28>>2]}if(c[t>>2]|0){c[t>>2]=(c[t>>2]|0)+1;break}c[k>>2]=c[(c[j>>2]|0)+24>>2];while(1){if(!((c[k>>2]|0)!=0&(c[t>>2]|0)==0))break;if((c[(c[k>>2]|0)+4>>2]|0)==8)c[t>>2]=(c[t>>2]|0)+1;c[k>>2]=c[(c[k>>2]|0)+24>>2]}if(!(c[t>>2]|0))break;c[t>>2]=1;break}if((c[(c[j>>2]|0)+4>>2]|0)!=3?(c[(c[j>>2]|0)+4>>2]|0)!=4:0){if((c[(c[j>>2]|0)+4>>2]|0)!=7){if((c[(c[j>>2]|0)+4>>2]|0)!=2){c[l>>2]=c[(c[j>>2]|0)+20>>2];break}c[q>>2]=75600;c[r>>2]=c[(c[j>>2]|0)+8>>2];if(c[(c[j>>2]|0)+36>>2]|0){h=c[j>>2]|0;if(c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2]|0){b=c[(c[j>>2]|0)+8>>2]|0;c[f>>2]=c[(c[h+36>>2]|0)+12>>2];c[f+4>>2]=b;JT(s,99,75528,f)|0}else{c[f>>2]=c[h+8>>2];JT(s,99,75608,f)|0}a[s+99>>0]=0;c[r>>2]=s}c[l>>2]=c[(c[j>>2]|0)+20>>2];break}c[q>>2]=75520;c[f>>2]=c[(c[j>>2]|0)+8>>2];JT(s,99,75568,f)|0;a[s+99>>0]=0;c[r>>2]=s;c[l>>2]=c[(c[j>>2]|0)+20>>2];c[k>>2]=c[(c[j>>2]|0)+28>>2];while(1){if(!(c[k>>2]|0))break;if((c[(c[k>>2]|0)+4>>2]|0)==7?(qy(c[(c[j>>2]|0)+8>>2]|0,c[(c[k>>2]|0)+8>>2]|0)|0)!=0:0)c[t>>2]=(c[t>>2]|0)+1;c[k>>2]=c[(c[k>>2]|0)+28>>2]}if(c[t>>2]|0){c[t>>2]=(c[t>>2]|0)+1;break}c[k>>2]=c[(c[j>>2]|0)+24>>2];while(1){if(!((c[k>>2]|0)!=0&(c[t>>2]|0)==0))break;do if((c[(c[k>>2]|0)+4>>2]|0)==7){if(!(qy(c[(c[j>>2]|0)+8>>2]|0,c[(c[k>>2]|0)+8>>2]|0)|0))break;c[t>>2]=(c[t>>2]|0)+1}while(0);c[k>>2]=c[(c[k>>2]|0)+24>>2]}if(!(c[t>>2]|0))break;c[t>>2]=1;break}c[q>>2]=75520;c[r>>2]=75560;c[l>>2]=c[(c[j>>2]|0)+20>>2];c[k>>2]=c[(c[j>>2]|0)+28>>2];while(1){if(!(c[k>>2]|0))break;if(!((c[(c[k>>2]|0)+4>>2]|0)!=3?(c[(c[k>>2]|0)+4>>2]|0)!=4:0))c[t>>2]=(c[t>>2]|0)+1;c[k>>2]=c[(c[k>>2]|0)+28>>2]}if(c[t>>2]|0){c[t>>2]=(c[t>>2]|0)+1;break}c[k>>2]=c[(c[j>>2]|0)+24>>2];while(1){if(!(c[k>>2]|0))break a;if((c[(c[k>>2]|0)+4>>2]|0)==3)break;if((c[(c[k>>2]|0)+4>>2]|0)==4)break;c[k>>2]=c[(c[k>>2]|0)+24>>2]}c[t>>2]=1}else w=11;while(0);if((w|0)==11){w=0;if((d[c[m>>2]>>0]|0|0)==47){w=110;break}c[q>>2]=75520;c[l>>2]=0}h=(xy(c[m>>2]|0)|0)+120|0;if(h>>>0>(c[o>>2]|0)>>>0){h=c[o>>2]<<1;c[o>>2]=h+(xy(c[m>>2]|0)|0)+120;c[n>>2]=Hb[c[135760>>2]&511](c[m>>2]|0,c[o>>2]|0)|0;if(!(c[n>>2]|0)){w=102;break}c[m>>2]=c[n>>2];c[n>>2]=Hb[c[135760>>2]&511](c[p>>2]|0,c[o>>2]|0)|0;if(!(c[n>>2]|0)){w=104;break}c[p>>2]=c[n>>2]}h=c[p>>2]|0;b=c[o>>2]|0;x=c[q>>2]|0;y=c[r>>2]|0;if(!(c[t>>2]|0)){z=c[m>>2]|0;c[f>>2]=x;c[f+4>>2]=y;c[f+8>>2]=z;JT(h,b,75616,f)|0}else{z=c[t>>2]|0;A=c[m>>2]|0;c[f>>2]=x;c[f+4>>2]=y;c[f+8>>2]=z;c[f+12>>2]=A;JT(h,b,75624,f)|0}b=c[m>>2]|0;h=c[o>>2]|0;c[f>>2]=c[p>>2];JT(b,h,75608,f)|0;c[j>>2]=c[l>>2];if(!(c[j>>2]|0)){w=110;break}}if((w|0)==102){tj(75488);zb[c[135736>>2]&511](c[p>>2]|0);zb[c[135736>>2]&511](c[m>>2]|0);c[g>>2]=0;v=c[g>>2]|0;i=e;return v|0}else if((w|0)==104){tj(75488);zb[c[135736>>2]&511](c[p>>2]|0);zb[c[135736>>2]&511](c[m>>2]|0);c[g>>2]=0;v=c[g>>2]|0;i=e;return v|0}else if((w|0)==110){zb[c[135736>>2]&511](c[p>>2]|0);c[g>>2]=c[m>>2];v=c[g>>2]|0;i=e;return v|0}}c[g>>2]=0;v=c[g>>2]|0;i=e;return v|0}function Pi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if(!(c[e>>2]|0)){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}c[f>>2]=c[(c[e>>2]|0)+12>>2];while(1){h=c[f>>2]|0;if(!(c[f>>2]|0)){j=8;break}k=c[f>>2]|0;if((c[h+4>>2]|0)==1){j=6;break}c[f>>2]=c[k+24>>2]}if((j|0)==6){c[d>>2]=k;g=c[d>>2]|0;i=b;return g|0}else if((j|0)==8){c[d>>2]=h;g=c[d>>2]|0;i=b;return g|0}return 0}function Qi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;if(!(c[f>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+4>>2]|0)!=18:0){Qh(c[g>>2]|0);ri(c[g>>2]|0,c[f>>2]|0);c[(c[g>>2]|0)+20>>2]=c[f>>2];c[h>>2]=c[(c[f>>2]|0)+12>>2];while(1){if(!(c[h>>2]|0))break;if((c[(c[h>>2]|0)+4>>2]|0)==1)break;c[h>>2]=c[(c[h>>2]|0)+24>>2]}do if(!(c[h>>2]|0))if(!(c[(c[f>>2]|0)+12>>2]|0)){c[(c[f>>2]|0)+12>>2]=c[g>>2];c[(c[f>>2]|0)+16>>2]=c[g>>2];break}else{xi(c[(c[f>>2]|0)+12>>2]|0,c[g>>2]|0)|0;break}else Ci(c[h>>2]|0,c[g>>2]|0)|0;while(0);c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}function Ri(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[l>>2]=c[h>>2];if((c[h>>2]|0)!=0?!((c[j>>2]|0)==0?1:(c[(c[h>>2]|0)+4>>2]|0)==18):0){if(qy(c[j>>2]|0,75176)|0){if((c[g>>2]|0)==0?(c[(c[h>>2]|0)+4>>2]|0)==1:0){c[k>>2]=Cb[c[135744>>2]&511](24)|0;if(!(c[k>>2]|0)){tj(75760);c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}else{d=c[k>>2]|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[(c[k>>2]|0)+4>>2]=18;d=my(75176)|0;c[(c[k>>2]|0)+8>>2]=d;d=my(75168)|0;c[(c[k>>2]|0)+12>>2]=d;c[c[k>>2]>>2]=c[(c[h>>2]|0)+48>>2];c[(c[h>>2]|0)+48>>2]=c[k>>2];c[f>>2]=c[k>>2];n=c[f>>2]|0;i=e;return n|0}}if((c[g>>2]|0)==0?(c[g>>2]=c[(c[h>>2]|0)+32>>2],(c[g>>2]|0)==0):0){c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}d=c[g>>2]|0;if(!(c[(c[g>>2]|0)+52>>2]|0)){c[f>>2]=Ej(d)|0;n=c[f>>2]|0;i=e;return n|0}else{c[f>>2]=c[d+52>>2];n=c[f>>2]|0;i=e;return n|0}}c[m>>2]=(c[(c[h>>2]|0)+4>>2]|0)==2&1;a:while(1){if(!(c[h>>2]|0)){o=41;break}if((c[(c[h>>2]|0)+4>>2]|0)==5){o=21;break}if((c[(c[h>>2]|0)+4>>2]|0)==6){o=21;break}if((c[(c[h>>2]|0)+4>>2]|0)==17){o=21;break}do if((c[(c[h>>2]|0)+4>>2]|0)==1){c[k>>2]=c[(c[h>>2]|0)+48>>2];while(1){if(!(c[k>>2]|0))break;do if(((c[j>>2]|0)!=0?(c[(c[k>>2]|0)+8>>2]|0)!=0:0)?(qy(c[(c[k>>2]|0)+8>>2]|0,c[j>>2]|0)|0)!=0:0){if((c[m>>2]|0)!=0?(c[(c[k>>2]|0)+12>>2]|0)==0:0)break;if((Fj(c[g>>2]|0,c[l>>2]|0,c[h>>2]|0,c[(c[k>>2]|0)+12>>2]|0)|0)==1){o=30;break a}}while(0);c[k>>2]=c[c[k>>2]>>2]}if((((c[l>>2]|0)!=(c[h>>2]|0)?(c[k>>2]=c[(c[h>>2]|0)+36>>2],(c[k>>2]|0)!=0):0)?(c[j>>2]|0)!=0?(c[(c[k>>2]|0)+8>>2]|0)!=0:0:0)?(qy(c[(c[k>>2]|0)+8>>2]|0,c[j>>2]|0)|0)!=0:0){if((c[m>>2]|0)!=0?(c[(c[k>>2]|0)+12>>2]|0)==0:0)break;if((Fj(c[g>>2]|0,c[l>>2]|0,c[h>>2]|0,c[(c[k>>2]|0)+12>>2]|0)|0)==1){o=39;break a}}}while(0);c[h>>2]=c[(c[h>>2]|0)+20>>2]}if((o|0)==21){c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}else if((o|0)==30){c[f>>2]=c[k>>2];n=c[f>>2]|0;i=e;return n|0}else if((o|0)==39){c[f>>2]=c[k>>2];n=c[f>>2]|0;i=e;return n|0}else if((o|0)==41){c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}}c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}function Si(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+8>>2]|0)==0:0){c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}if(c[j>>2]|0)p=c[(c[j>>2]|0)+8>>2]|0;else p=0;c[m>>2]=xj(c[h>>2]|0,c[k>>2]|0,p,0)|0;if(!(c[m>>2]|0)){c[g>>2]=wj(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,0)|0;o=c[g>>2]|0;i=f;return o|0}if((c[(c[m>>2]|0)+40>>2]|0)==2){Gm(c[(c[h>>2]|0)+32>>2]|0,c[m>>2]|0)|0;c[(c[m>>2]|0)+40>>2]=2}if(c[(c[m>>2]|0)+12>>2]|0)Uh(c[(c[m>>2]|0)+12>>2]|0);c[(c[m>>2]|0)+12>>2]=0;c[(c[m>>2]|0)+16>>2]=0;c[(c[m>>2]|0)+36>>2]=c[j>>2];a:do if(c[l>>2]|0){if((Fy(c[l>>2]|0)|0)==0?(uj(1303,c[(c[h>>2]|0)+32>>2]|0,0),(c[(c[h>>2]|0)+32>>2]|0)!=0):0){j=my(75792)|0;c[(c[(c[h>>2]|0)+32>>2]|0)+60>>2]=j}j=Wh(c[(c[h>>2]|0)+32>>2]|0,c[l>>2]|0)|0;c[(c[m>>2]|0)+12>>2]=j;c[(c[m>>2]|0)+16>>2]=0;c[n>>2]=c[(c[m>>2]|0)+12>>2];while(1){if(!(c[n>>2]|0))break a;c[(c[n>>2]|0)+20>>2]=c[m>>2];if(!(c[(c[n>>2]|0)+24>>2]|0))c[(c[m>>2]|0)+16>>2]=c[n>>2];c[n>>2]=c[(c[n>>2]|0)+24>>2]}}while(0);if((c[(c[m>>2]|0)+40>>2]|0)==2)Cm(0,c[(c[h>>2]|0)+32>>2]|0,c[l>>2]|0,c[m>>2]|0)|0;c[g>>2]=c[m>>2];o=c[g>>2]|0;i=f;return o|0}function Ti(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+4>>2]|0)!=18:0){while(1){if(!(c[e>>2]|0)){g=8;break}c[f>>2]=Ui(c[e>>2]|0,75640,75176)|0;if(c[f>>2]|0){g=6;break}c[e>>2]=c[(c[e>>2]|0)+20>>2]}if((g|0)==6){c[d>>2]=c[f>>2];h=c[d>>2]|0;i=b;return h|0}else if((g|0)==8){c[d>>2]=0;h=c[d>>2]|0;i=b;return h|0}}c[d>>2]=0;h=c[d>>2]|0;i=b;return h|0}function Ui(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;
c[k>>2]=xj(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0,c[18946]|0)|0;if(!(c[k>>2]|0)){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}else{c[f>>2]=Gj(c[k>>2]|0)|0;l=c[f>>2]|0;i=e;return l|0}return 0}function Vi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+4>>2]|0)==1:0){while(1){if(!(c[e>>2]|0)){g=11;break}c[f>>2]=Ui(c[e>>2]|0,75648,75176)|0;if(c[f>>2]|0){if(qy(c[f>>2]|0,75664)|0){g=7;break}a=(qy(c[f>>2]|0,75656)|0)!=0;zb[c[135736>>2]&511](c[f>>2]|0);if(a){g=9;break}}c[e>>2]=c[(c[e>>2]|0)+20>>2]}if((g|0)==7){zb[c[135736>>2]&511](c[f>>2]|0);c[d>>2]=1;h=c[d>>2]|0;i=b;return h|0}else if((g|0)==9){c[d>>2]=0;h=c[d>>2]|0;i=b;return h|0}else if((g|0)==11){c[d>>2]=-1;h=c[d>>2]|0;i=b;return h|0}}c[d>>2]=-1;h=c[d>>2]|0;i=b;return h|0}function Wi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}switch(c[(c[e>>2]|0)+4>>2]|0){case 9:case 21:case 13:{c[j>>2]=c[e>>2];if(c[(c[j>>2]|0)+72>>2]|0)zb[c[135736>>2]&511](c[(c[j>>2]|0)+72>>2]|0);if(!(c[f>>2]|0)){c[(c[j>>2]|0)+72>>2]=0;i=d;return}else{b=Kl(c[f>>2]|0)|0;c[(c[j>>2]|0)+72>>2]=b;i=d;return}break}case 20:case 19:case 18:case 6:case 5:case 7:case 17:case 16:case 15:case 14:case 12:case 11:case 10:case 8:case 4:case 3:{i=d;return}default:{c[g>>2]=Ri(c[(c[e>>2]|0)+32>>2]|0,c[e>>2]|0,75176)|0;if(!(c[g>>2]|0)){i=d;return}c[h>>2]=Kl(c[f>>2]|0)|0;b=c[e>>2]|0;e=c[g>>2]|0;if(c[h>>2]|0){Si(b,e,75680,c[h>>2]|0)|0;zb[c[135736>>2]&511](c[h>>2]|0);i=d;return}else{Si(b,e,75680,c[f>>2]|0)|0;i=d;return}}}}function Xi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;if((c[g>>2]|0)==0&(c[f>>2]|0)==0){c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+4>>2]|0)==18:0){c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}if(!(c[f>>2]|0))c[f>>2]=c[(c[g>>2]|0)+32>>2];if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+4>>2]|0)==13:0){c[g>>2]=c[(c[f>>2]|0)+12>>2];while(1){if(!(c[g>>2]|0)){n=22;break}if(!(c[(c[g>>2]|0)+8>>2]|0)){n=22;break}b=c[g>>2]|0;if((c[(c[g>>2]|0)+4>>2]|0)!=1){c[g>>2]=c[b+24>>2];continue}a=(ty(c[b+8>>2]|0,75688)|0)!=0;b=c[g>>2]|0;if(!a){c[g>>2]=c[b+12>>2];continue}a=(ty(c[b+8>>2]|0,75696)|0)!=0;b=c[g>>2]|0;if(!a){c[g>>2]=c[b+12>>2];continue}a=(ty(c[b+8>>2]|0,75680)|0)!=0;o=c[g>>2]|0;if(!a){n=20;break}c[g>>2]=c[o+24>>2]}if((n|0)==20){c[e>>2]=Yi(o,75704)|0;m=c[e>>2]|0;i=d;return m|0}else if((n|0)==22){c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}}while(1){if(!(c[g>>2]|0)){n=38;break}p=c[g>>2]|0;if((c[(c[g>>2]|0)+4>>2]|0)==17){n=25;break}if((c[p+4>>2]|0)==1?(c[j>>2]=Ui(c[g>>2]|0,75680,75176)|0,(c[j>>2]|0)!=0):0){if(c[h>>2]|0){c[k>>2]=Hl(c[h>>2]|0,c[j>>2]|0)|0;o=(c[k>>2]|0)!=0;zb[c[135736>>2]&511](c[h>>2]|0);zb[c[135736>>2]&511](c[j>>2]|0);if(!o){n=31;break}c[h>>2]=c[k>>2]}else c[h>>2]=c[j>>2];if(!(sy(c[h>>2]|0,75712,7)|0)){n=36;break}if(!(sy(c[h>>2]|0,75720,6)|0)){n=36;break}if(!(sy(c[h>>2]|0,75728,4)|0)){n=36;break}}c[g>>2]=c[(c[g>>2]|0)+20>>2]}if((n|0)==25){c[l>>2]=p;c[e>>2]=my(c[(c[l>>2]|0)+64>>2]|0)|0;m=c[e>>2]|0;i=d;return m|0}else if((n|0)==31){c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}else if((n|0)==36){c[e>>2]=c[h>>2];m=c[e>>2]|0;i=d;return m|0}else if((n|0)==38){if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+72>>2]|0)!=0:0)if(!(c[h>>2]|0)){c[e>>2]=my(c[(c[f>>2]|0)+72>>2]|0)|0;m=c[e>>2]|0;i=d;return m|0}else{c[k>>2]=Hl(c[h>>2]|0,c[(c[f>>2]|0)+72>>2]|0)|0;zb[c[135736>>2]&511](c[h>>2]|0);c[e>>2]=c[k>>2];m=c[e>>2]|0;i=d;return m|0}c[e>>2]=c[h>>2];m=c[e>>2]|0;i=d;return m|0}return 0}function Yi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=dj(c[f>>2]|0,c[g>>2]|0)|0;if(!(c[h>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}else{c[e>>2]=Gj(c[h>>2]|0)|0;j=c[e>>2]|0;i=d;return j|0}return 0}function Zi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+32|0;e=d+28|0;f=d+24|0;g=d+20|0;h=d+16|0;j=d+12|0;k=d+8|0;l=d+4|0;m=d;c[f>>2]=a;c[g>>2]=b;if((c[g>>2]|0)==0|(c[f>>2]|0)==0){c[e>>2]=-1;n=c[e>>2]|0;i=d;return n|0}a:do switch(c[(c[g>>2]|0)+4>>2]|0){case 1:case 11:{c[h>>2]=c[g>>2];b:while(1){if(!(c[h>>2]|0))break a;b=c[(c[h>>2]|0)+4>>2]|0;if((b|0)==5)Zi(c[f>>2]|0,c[h>>2]|0)|0;else if((b|0)==3|(b|0)==4?(c[(c[h>>2]|0)+40>>2]|0)!=0:0)ez(c[f>>2]|0,c[(c[h>>2]|0)+40>>2]|0)|0;if((c[(c[h>>2]|0)+12>>2]|0)!=0?(c[(c[(c[h>>2]|0)+12>>2]|0)+4>>2]|0)!=17:0){c[h>>2]=c[(c[h>>2]|0)+12>>2];continue}if((c[h>>2]|0)==(c[g>>2]|0))break a;if(c[(c[h>>2]|0)+24>>2]|0){c[h>>2]=c[(c[h>>2]|0)+24>>2];continue}while(1){c[h>>2]=c[(c[h>>2]|0)+20>>2];if(!(c[h>>2]|0))continue b;if((c[h>>2]|0)==(c[g>>2]|0)){o=19;break}p=c[h>>2]|0;if(c[(c[h>>2]|0)+24>>2]|0){o=21;break}if(!p)continue b}if((o|0)==19){o=0;c[h>>2]=0;continue}else if((o|0)==21){o=0;c[h>>2]=c[p+24>>2];continue}}break}case 3:case 4:{ez(c[f>>2]|0,c[(c[g>>2]|0)+40>>2]|0)|0;break}case 9:case 21:case 13:{c[g>>2]=c[(c[g>>2]|0)+12>>2];while(1){if(!(c[g>>2]|0))break a;if(!(((c[(c[g>>2]|0)+4>>2]|0)!=1?(c[(c[g>>2]|0)+4>>2]|0)!=3:0)?(c[(c[g>>2]|0)+4>>2]|0)!=4:0))Zi(c[f>>2]|0,c[g>>2]|0)|0;c[g>>2]=c[(c[g>>2]|0)+24>>2]}break}case 18:{ez(c[f>>2]|0,c[(c[g>>2]|0)+8>>2]|0)|0;break}case 2:{c[j>>2]=c[g>>2];c[k>>2]=c[(c[j>>2]|0)+12>>2];while(1){if(!(c[k>>2]|0))break a;b=c[f>>2]|0;a=c[k>>2]|0;if((c[(c[k>>2]|0)+4>>2]|0)==3)ez(b,c[a+40>>2]|0)|0;else Zi(b,a)|0;c[k>>2]=c[(c[k>>2]|0)+24>>2]}break}case 7:case 8:{ez(c[f>>2]|0,c[(c[g>>2]|0)+40>>2]|0)|0;break}case 5:{c[l>>2]=ad(c[(c[g>>2]|0)+32>>2]|0,c[(c[g>>2]|0)+8>>2]|0)|0;if(!(c[l>>2]|0)){c[e>>2]=-1;n=c[e>>2]|0;i=d;return n|0}c[m>>2]=c[(c[l>>2]|0)+12>>2];while(1){if(!(c[m>>2]|0))break a;Zi(c[f>>2]|0,c[m>>2]|0)|0;c[m>>2]=c[(c[m>>2]|0)+24>>2]}break}default:{}}while(0);c[e>>2]=0;n=c[e>>2]|0;i=d;return n|0}function _i(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+48|0;d=b+36|0;e=b+32|0;f=b+28|0;g=b+24|0;h=b+20|0;j=b+16|0;k=b+12|0;l=b+8|0;m=b+4|0;n=b;c[e>>2]=a;a:do if(!(c[e>>2]|0))c[d>>2]=0;else do switch(c[(c[e>>2]|0)+4>>2]|0){case 13:case 21:case 9:{c[l>>2]=Ly()|0;if(!(c[l>>2]|0)){c[d>>2]=0;break a}else{Zi(c[l>>2]|0,c[e>>2]|0)|0;c[m>>2]=Ny(c[l>>2]|0)|0;Ry(c[l>>2]|0);c[d>>2]=c[m>>2];break a}break}case 2:{c[d>>2]=Gj(c[e>>2]|0)|0;break a;break}case 5:{c[h>>2]=ad(c[(c[e>>2]|0)+32>>2]|0,c[(c[e>>2]|0)+8>>2]|0)|0;if(!(c[h>>2]|0)){c[d>>2]=0;break a}c[j>>2]=Ly()|0;if(!(c[j>>2]|0)){c[d>>2]=0;break a}else{Zi(c[j>>2]|0,c[e>>2]|0)|0;c[k>>2]=Ny(c[j>>2]|0)|0;Ry(c[j>>2]|0);c[d>>2]=c[k>>2];break a}break}case 1:case 11:{c[f>>2]=My(64)|0;if(!(c[f>>2]|0)){c[d>>2]=0;break a}else{Zi(c[f>>2]|0,c[e>>2]|0)|0;c[g>>2]=Ny(c[f>>2]|0)|0;Ry(c[f>>2]|0);c[d>>2]=c[g>>2];break a}break}case 15:{c[d>>2]=0;break a;break}case 3:case 4:{if(c[(c[e>>2]|0)+40>>2]|0){c[d>>2]=my(c[(c[e>>2]|0)+40>>2]|0)|0;break a}else{c[d>>2]=0;break a}break}case 18:{c[n>>2]=my(c[(c[e>>2]|0)+8>>2]|0)|0;c[d>>2]=c[n>>2];break a;break}case 17:{c[d>>2]=0;break a;break}case 20:case 19:case 14:case 12:case 10:case 6:{c[d>>2]=0;break a;break}case 16:{c[d>>2]=0;break a;break}case 7:case 8:{if(c[(c[e>>2]|0)+40>>2]|0){c[d>>2]=my(c[(c[e>>2]|0)+40>>2]|0)|0;break a}else{c[d>>2]=0;break a}break}default:{c[d>>2]=0;break a}}while(0);while(0);i=b;return c[d>>2]|0}function $i(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if((c[f>>2]|0)==0|(c[h>>2]|0)<=0){i=e;return}switch(c[(c[f>>2]|0)+4>>2]|0){case 8:case 7:case 6:case 5:case 4:case 3:case 12:{if(!(c[g>>2]|0)){i=e;return}do if((c[(c[f>>2]|0)+40>>2]|0)!=((c[f>>2]|0)+44|0)){if(((c[(c[f>>2]|0)+32>>2]|0)!=0?(c[(c[(c[f>>2]|0)+32>>2]|0)+80>>2]|0)!=0:0)?(CP(c[(c[(c[f>>2]|0)+32>>2]|0)+80>>2]|0,c[(c[f>>2]|0)+40>>2]|0)|0)!=0:0)break;d=zy(c[(c[f>>2]|0)+40>>2]|0,c[g>>2]|0,c[h>>2]|0)|0;c[(c[f>>2]|0)+40>>2]=d;i=e;return}while(0);d=Ay(c[(c[f>>2]|0)+40>>2]|0,c[g>>2]|0,c[h>>2]|0)|0;c[(c[f>>2]|0)+40>>2]=d;c[(c[f>>2]|0)+44>>2]=0;c[(c[f>>2]|0)+48>>2]=0;i=e;return}case 1:case 11:{c[j>>2]=c[(c[f>>2]|0)+16>>2];c[k>>2]=ni(c[g>>2]|0,c[h>>2]|0)|0;if(!(c[k>>2]|0)){i=e;return}c[l>>2]=zi(c[f>>2]|0,c[k>>2]|0)|0;if(!((c[j>>2]|0)!=0?(c[l>>2]|0)==(c[k>>2]|0):0)){i=e;return}if((c[(c[j>>2]|0)+24>>2]|0)!=(c[k>>2]|0)){i=e;return}aj(c[j>>2]|0,c[k>>2]|0)|0;i=e;return}default:{i=e;return}}}function aj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;b=c[g>>2]|0;do if(c[f>>2]|0){a=c[f>>2]|0;if(!b){c[e>>2]=a;break}if((c[a+4>>2]|0)!=3){c[e>>2]=c[f>>2];break}if((c[(c[g>>2]|0)+4>>2]|0)!=3){c[e>>2]=c[f>>2];break}a=c[f>>2]|0;if((c[(c[g>>2]|0)+8>>2]|0)!=(c[(c[f>>2]|0)+8>>2]|0)){c[e>>2]=a;break}else{ui(a,c[(c[g>>2]|0)+40>>2]|0);Qh(c[g>>2]|0);Rh(c[g>>2]|0);c[e>>2]=c[f>>2];break}}else c[e>>2]=b;while(0);i=d;return c[e>>2]|0}function bj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+28|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[d+24>>2]=a;c[f>>2]=b;c[h>>2]=0;c[j>>2]=0;c[k>>2]=10;if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+4>>2]|0)!=18:0){a:while(1){if(!(c[f>>2]|0)){m=24;break}b:do if((c[(c[f>>2]|0)+4>>2]|0)==1){c[g>>2]=c[(c[f>>2]|0)+48>>2];while(1){if(!(c[g>>2]|0))break b;if(!(c[h>>2]|0)){c[h>>2]=Cb[c[135744>>2]&511]((c[k>>2]|0)+1<<2)|0;if(!(c[h>>2]|0)){m=10;break a}c[(c[h>>2]|0)+(c[j>>2]<<2)>>2]=0}c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[j>>2]|0))break;if((c[(c[g>>2]|0)+12>>2]|0)==(c[(c[(c[h>>2]|0)+(c[l>>2]<<2)>>2]|0)+12>>2]|0))break;if(qy(c[(c[g>>2]|0)+12>>2]|0,c[(c[(c[h>>2]|0)+(c[l>>2]<<2)>>2]|0)+12>>2]|0)|0)break;c[l>>2]=(c[l>>2]|0)+1}if((c[l>>2]|0)>=(c[j>>2]|0)){if((c[j>>2]|0)>=(c[k>>2]|0)?(c[k>>2]=c[k>>2]<<1,c[h>>2]=Hb[c[135760>>2]&511](c[h>>2]|0,(c[k>>2]|0)+1<<2)|0,(c[h>>2]|0)==0):0){m=20;break a}b=c[g>>2]|0;a=c[j>>2]|0;c[j>>2]=a+1;c[(c[h>>2]|0)+(a<<2)>>2]=b;c[(c[h>>2]|0)+(c[j>>2]<<2)>>2]=0}c[g>>2]=c[c[g>>2]>>2]}}while(0);c[f>>2]=c[(c[f>>2]|0)+20>>2]}if((m|0)==10){tj(75736);c[e>>2]=0;n=c[e>>2]|0;i=d;return n|0}else if((m|0)==20){tj(75736);c[e>>2]=0;n=c[e>>2]|0;i=d;return n|0}else if((m|0)==24){c[e>>2]=c[h>>2];n=c[e>>2]|0;i=d;return n|0}}c[e>>2]=0;n=c[e>>2]|0;i=d;return n|0}function cj(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[l>>2]=c[h>>2];if((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+4>>2]|0)!=18:0){if((c[j>>2]|0)!=0?(qy(c[j>>2]|0,75168)|0)!=0:0){if((c[g>>2]|0)==0?(c[(c[h>>2]|0)+4>>2]|0)==1:0){c[k>>2]=Cb[c[135744>>2]&511](24)|0;if(!(c[k>>2]|0)){tj(75760);c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}else{d=c[k>>2]|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[(c[k>>2]|0)+4>>2]=18;d=my(75176)|0;c[(c[k>>2]|0)+8>>2]=d;d=my(75168)|0;c[(c[k>>2]|0)+12>>2]=d;c[c[k>>2]>>2]=c[(c[h>>2]|0)+48>>2];c[(c[h>>2]|0)+48>>2]=c[k>>2];c[f>>2]=c[k>>2];m=c[f>>2]|0;i=e;return m|0}}if((c[g>>2]|0)==0?(c[g>>2]=c[(c[h>>2]|0)+32>>2],(c[g>>2]|0)==0):0){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}d=c[g>>2]|0;if(!(c[(c[g>>2]|0)+52>>2]|0)){c[f>>2]=Ej(d)|0;m=c[f>>2]|0;i=e;return m|0}else{c[f>>2]=c[d+52>>2];m=c[f>>2]|0;i=e;return m|0}}a:while(1){if(!(c[h>>2]|0)){n=43;break}if((c[(c[h>>2]|0)+4>>2]|0)==5){n=21;break}if((c[(c[h>>2]|0)+4>>2]|0)==6){n=21;break}if((c[(c[h>>2]|0)+4>>2]|0)==17){n=21;break}if((c[(c[h>>2]|0)+4>>2]|0)==1){c[k>>2]=c[(c[h>>2]|0)+48>>2];while(1){if(!(c[k>>2]|0))break;if(((c[j>>2]|0)==0?(c[(c[k>>2]|0)+12>>2]|0)==0:0)?(c[(c[k>>2]|0)+8>>2]|0)!=0:0){n=27;break a}if((((c[j>>2]|0)!=0?(c[(c[k>>2]|0)+12>>2]|0)!=0:0)?(c[(c[k>>2]|0)+8>>2]|0)!=0:0)?(qy(c[(c[k>>2]|0)+12>>2]|0,c[j>>2]|0)|0)!=0:0){n=31;break a}c[k>>2]=c[c[k>>2]>>2]}if((c[l>>2]|0)!=(c[h>>2]|0)?(c[k>>2]=c[(c[h>>2]|0)+36>>2],(c[k>>2]|0)!=0):0){if(((c[j>>2]|0)==0?(c[(c[k>>2]|0)+12>>2]|0)==0:0)?(c[(c[k>>2]|0)+8>>2]|0)!=0:0){n=37;break}if((((c[j>>2]|0)!=0?(c[(c[k>>2]|0)+12>>2]|0)!=0:0)?(c[(c[k>>2]|0)+8>>2]|0)!=0:0)?(qy(c[(c[k>>2]|0)+12>>2]|0,c[j>>2]|0)|0)!=0:0){n=41;break}}}c[h>>2]=c[(c[h>>2]|0)+20>>2]}if((n|0)==21){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}else if((n|0)==27){c[f>>2]=c[k>>2];m=c[f>>2]|0;i=e;return m|0}else if((n|0)==31){c[f>>2]=c[k>>2];m=c[f>>2]|0;i=e;return m|0}else if((n|0)==37){c[f>>2]=c[k>>2];m=c[f>>2]|0;i=e;return m|0}else if((n|0)==41){c[f>>2]=c[k>>2];m=c[f>>2]|0;i=e;return m|0}else if((n|0)==43){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}}c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}function dj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)!=0?!((c[g>>2]|0)==0?1:(c[(c[f>>2]|0)+4>>2]|0)!=1):0){c[h>>2]=c[(c[f>>2]|0)+44>>2];while(1){if(!(c[h>>2]|0))break;b=(qy(c[(c[h>>2]|0)+8>>2]|0,c[g>>2]|0)|0)!=0;l=c[h>>2]|0;if(b){m=7;break}c[h>>2]=c[l+24>>2]}if((m|0)==7){c[e>>2]=l;n=c[e>>2]|0;i=d;return n|0}if(!(c[18946]|0)){c[e>>2]=0;n=c[e>>2]|0;i=d;return n|0}c[j>>2]=c[(c[f>>2]|0)+32>>2];if((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+44>>2]|0)!=0:0){c[k>>2]=Fm(c[(c[j>>2]|0)+44>>2]|0,c[(c[f>>2]|0)+8>>2]|0,c[g>>2]|0)|0;if((c[k>>2]|0)==0?(c[(c[j>>2]|0)+48>>2]|0)!=0:0)c[k>>2]=Fm(c[(c[j>>2]|0)+48>>2]|0,c[(c[f>>2]|0)+8>>2]|0,c[g>>2]|0)|0;if((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+48>>2]|0)!=0:0){c[e>>2]=c[k>>2];n=c[e>>2]|0;i=d;return n|0}}c[e>>2]=0;n=c[e>>2]|0;i=d;return n|0}c[e>>2]=0;n=c[e>>2]|0;i=d;return n|0}function ej(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=xj(c[f>>2]|0,c[g>>2]|0,0,c[18946]|0)|0;if(!(c[h>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}else{c[e>>2]=Gj(c[h>>2]|0)|0;j=c[e>>2]|0;i=d;return j|0}return 0}function fj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=xj(c[f>>2]|0,c[g>>2]|0,0,0)|0;if(!(c[h>>2]|0)){c[e>>2]=-1;j=c[e>>2]|0;i=d;return j|0}else{Qh(c[h>>2]|0);ei(c[h>>2]|0);c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}return 0}function gj(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;n=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(!((c[g>>2]|0)==0|(c[h>>2]|0)==0)?(c[(c[g>>2]|0)+4>>2]|0)==1:0){c[l>>2]=Dh(c[h>>2]|0,k)|0;if(c[l>>2]|0){c[n>>2]=ly(c[h>>2]|0,c[k>>2]|0)|0;c[m>>2]=cj(c[(c[g>>2]|0)+32>>2]|0,c[g>>2]|0,c[n>>2]|0)|0;if(c[n>>2]|0)zb[c[135736>>2]&511](c[n>>2]|0);if(c[m>>2]|0){c[f>>2]=Si(c[g>>2]|0,c[m>>2]|0,c[l>>2]|0,c[j>>2]|0)|0;o=c[f>>2]|0;i=e;return o|0}}c[f>>2]=Si(c[g>>2]|0,0,c[h>>2]|0,c[j>>2]|0)|0;o=c[f>>2]|0;i=e;return o|0}c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}function hj(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;do if(c[e>>2]|0)if((c[(c[e>>2]|0)+4>>2]|0)==3){c[d>>2]=1;break}else{c[d>>2]=0;break}else c[d>>2]=0;while(0);i=b;return c[d>>2]|0}function ij(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;e=b+8|0;f=b+4|0;g=b;c[f>>2]=a;if(!(c[f>>2]|0)){c[e>>2]=0;h=c[e>>2]|0;i=b;return h|0}if((c[(c[f>>2]|0)+4>>2]|0)!=3?(c[(c[f>>2]|0)+4>>2]|0)!=4:0){c[e>>2]=0;h=c[e>>2]|0;i=b;return h|0}if(!(c[(c[f>>2]|0)+40>>2]|0)){c[e>>2]=1;h=c[e>>2]|0;i=b;return h|0}c[g>>2]=c[(c[f>>2]|0)+40>>2];a:while(1){if(!(d[c[g>>2]>>0]|0)){j=16;break}do if((d[c[g>>2]>>0]|0|0)!=32){if(9<=(d[c[g>>2]>>0]|0|0)?(d[c[g>>2]>>0]|0|0)<=10:0)break;if((d[c[g>>2]>>0]|0|0)!=13){j=14;break a}}while(0);c[g>>2]=(c[g>>2]|0)+1}if((j|0)==14){c[e>>2]=0;h=c[e>>2]|0;i=b;return h|0}else if((j|0)==16){c[e>>2]=1;h=c[e>>2]|0;i=b;return h|0}return 0}function jj(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(!(c[g>>2]|0)){c[f>>2]=-1;k=c[f>>2]|0;i=e;return k|0}if((((c[(c[g>>2]|0)+4>>2]|0)!=3?(c[(c[g>>2]|0)+4>>2]|0)!=4:0)?(c[(c[g>>2]|0)+4>>2]|0)!=8:0)?(c[(c[g>>2]|0)+4>>2]|0)!=7:0){c[f>>2]=-1;k=c[f>>2]|0;i=e;return k|0}do if((c[(c[g>>2]|0)+40>>2]|0)==((c[g>>2]|0)+44|0))l=12;else{if(((c[(c[g>>2]|0)+32>>2]|0)!=0?(c[(c[(c[g>>2]|0)+32>>2]|0)+80>>2]|0)!=0:0)?(CP(c[(c[(c[g>>2]|0)+32>>2]|0)+80>>2]|0,c[(c[g>>2]|0)+40>>2]|0)|0)!=0:0){l=12;break}d=zy(c[(c[g>>2]|0)+40>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;c[(c[g>>2]|0)+40>>2]=d}while(0);if((l|0)==12){l=Ay(c[(c[g>>2]|0)+40>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;c[(c[g>>2]|0)+40>>2]=l}c[(c[g>>2]|0)+44>>2]=0;if(!(c[(c[g>>2]|0)+40>>2]|0)){c[f>>2]=-1;k=c[f>>2]|0;i=e;return k|0}else{c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}return 0}function kj(){var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=Cb[c[135744>>2]&511](20)|0;if(!(c[e>>2]|0)){tj(75808);c[d>>2]=0;f=c[d>>2]|0;i=b;return f|0}c[(c[e>>2]|0)+4>>2]=0;c[(c[e>>2]|0)+8>>2]=c[33950];c[(c[e>>2]|0)+12>>2]=c[33948];g=Cb[c[135752>>2]&511](c[(c[e>>2]|0)+8>>2]|0)|0;c[c[e>>2]>>2]=g;if(!(c[c[e>>2]>>2]|0)){tj(75808);zb[c[135736>>2]&511](c[e>>2]|0);c[d>>2]=0;f=c[d>>2]|0;i=b;return f|0}else{a[c[c[e>>2]>>2]>>0]=0;c[(c[e>>2]|0)+16>>2]=0;c[d>>2]=c[e>>2];f=c[d>>2]|0;i=b;return f|0}return 0}function lj(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if((c[(c[d>>2]|0)+12>>2]|0)==3?(c[(c[d>>2]|0)+16>>2]|0)!=0:0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+16>>2]|0);else e=5;if(((e|0)==5?(c[c[d>>2]>>2]|0)!=0:0)?(c[(c[d>>2]|0)+12>>2]|0)!=2:0)zb[c[135736>>2]&511](c[c[d>>2]>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function mj(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=b;c[h>>2]=d;c[k>>2]=0;if(!(c[g>>2]|0)){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}if((c[(c[g>>2]|0)+12>>2]|0)==2){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}if((c[h>>2]|0)>>>0<(c[(c[g>>2]|0)+8>>2]|0)>>>0){c[f>>2]=1;m=c[f>>2]|0;i=e;return m|0}d=c[(c[g>>2]|0)+12>>2]|0;a:do if((d|0)==4){if((c[(c[g>>2]|0)+4>>2]|0)>>>0<4096){c[j>>2]=c[h>>2];break}c[j>>2]=c[(c[g>>2]|0)+8>>2]<<1;while(1){if((c[h>>2]|0)>>>0<=(c[j>>2]|0)>>>0)break a;if((c[j>>2]|0)>>>0>2147483647)break;c[j>>2]=c[j>>2]<<1}tj(75824);c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}else if((d|0)==1)c[j>>2]=(c[h>>2]|0)+10;else if((d|0)==0|(d|0)==3){if(c[(c[g>>2]|0)+8>>2]|0)n=c[(c[g>>2]|0)+8>>2]<<1;else n=(c[h>>2]|0)+10|0;c[j>>2]=n;while(1){if((c[h>>2]|0)>>>0<=(c[j>>2]|0)>>>0)break a;if((c[j>>2]|0)>>>0>2147483647)break;c[j>>2]=c[j>>2]<<1}tj(75824);c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}else c[j>>2]=(c[h>>2]|0)+10;while(0);do if((c[(c[g>>2]|0)+12>>2]|0)==3?(c[(c[g>>2]|0)+16>>2]|0)!=0:0){c[l>>2]=(c[c[g>>2]>>2]|0)-(c[(c[g>>2]|0)+16>>2]|0);if((c[l>>2]|0)>>>0>(c[j>>2]|0)>>>0){fU(c[(c[g>>2]|0)+16>>2]|0,c[c[g>>2]>>2]|0,c[(c[g>>2]|0)+4>>2]|0)|0;c[c[g>>2]>>2]=c[(c[g>>2]|0)+16>>2];a[(c[c[g>>2]>>2]|0)+(c[(c[g>>2]|0)+4>>2]|0)>>0]=0;h=(c[g>>2]|0)+8|0;c[h>>2]=(c[h>>2]|0)+(c[l>>2]|0);break}c[k>>2]=Hb[c[135760>>2]&511](c[(c[g>>2]|0)+16>>2]|0,(c[l>>2]|0)+(c[j>>2]|0)|0)|0;if(c[k>>2]|0){c[(c[g>>2]|0)+16>>2]=c[k>>2];c[c[g>>2]>>2]=(c[k>>2]|0)+(c[l>>2]|0);break}tj(75824);c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}else o=32;while(0);do if((o|0)==32){do if(c[c[g>>2]>>2]|0){if(((c[(c[g>>2]|0)+8>>2]|0)-(c[(c[g>>2]|0)+4>>2]|0)|0)>>>0<100){c[k>>2]=Hb[c[135760>>2]&511](c[c[g>>2]>>2]|0,c[j>>2]|0)|0;break}c[k>>2]=Cb[c[135752>>2]&511](c[j>>2]|0)|0;if(c[k>>2]|0){eU(c[k>>2]|0,c[c[g>>2]>>2]|0,c[(c[g>>2]|0)+4>>2]|0)|0;zb[c[135736>>2]&511](c[c[g>>2]>>2]|0);a[(c[k>>2]|0)+(c[(c[g>>2]|0)+4>>2]|0)>>0]=0}}else c[k>>2]=Cb[c[135752>>2]&511](c[j>>2]|0)|0;while(0);if(c[k>>2]|0){c[c[g>>2]>>2]=c[k>>2];break}tj(75824);c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}while(0);c[(c[g>>2]|0)+8>>2]=c[j>>2];c[f>>2]=1;m=c[f>>2]|0;i=e;return m|0}function nj(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;do if((c[j>>2]|0)==0|(c[h>>2]|0)==0)c[g>>2]=-1;else{if((c[(c[h>>2]|0)+12>>2]|0)==2){c[g>>2]=-1;break}if((c[k>>2]|0)<-1){c[g>>2]=-1;break}if(!(c[k>>2]|0)){c[g>>2]=0;break}if((c[k>>2]|0)<0)c[k>>2]=xy(c[j>>2]|0)|0;if((c[k>>2]|0)<0){c[g>>2]=-1;break}if(!(c[k>>2]|0)){c[g>>2]=0;break}c[l>>2]=(c[(c[h>>2]|0)+4>>2]|0)+(c[k>>2]|0)+2;if((c[l>>2]|0)>>>0>(c[(c[h>>2]|0)+8>>2]|0)>>>0?(mj(c[h>>2]|0,c[l>>2]|0)|0)==0:0){tj(75824);c[g>>2]=2;break}fU((c[c[h>>2]>>2]|0)+(c[(c[h>>2]|0)+4>>2]|0)|0,c[j>>2]|0,c[k>>2]|0)|0;e=(c[h>>2]|0)+4|0;c[e>>2]=(c[e>>2]|0)+(c[k>>2]|0);a[(c[c[h>>2]>>2]|0)+(c[(c[h>>2]|0)+4>>2]|0)>>0]=0;c[g>>2]=0}while(0);i=f;return c[g>>2]|0}function oj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;do if(c[f>>2]|0){if((c[(c[f>>2]|0)+12>>2]|0)==2){c[e>>2]=-1;break}if(!(c[g>>2]|0)){c[e>>2]=-1;break}else{c[e>>2]=nj(c[f>>2]|0,c[g>>2]|0,-1)|0;break}}else c[e>>2]=-1;while(0);i=d;return c[e>>2]|0}function pj(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=b;c[h>>2]=d;if(!(c[g>>2]|0)){c[f>>2]=-1;k=c[f>>2]|0;i=e;return k|0}if((c[(c[g>>2]|0)+12>>2]|0)==2){c[f>>2]=-1;k=c[f>>2]|0;i=e;return k|0}if(!(c[h>>2]|0)){c[f>>2]=-1;k=c[f>>2]|0;i=e;return k|0}c[j>>2]=c[h>>2];while(1){l=c[(c[g>>2]|0)+4>>2]|0;if(!(a[c[j>>2]>>0]|0)){m=13;break}if((l+10|0)>>>0>=(c[(c[g>>2]|0)+8>>2]|0)>>>0?(mj(c[g>>2]|0,(c[(c[g>>2]|0)+4>>2]|0)+10|0)|0)==0:0){m=11;break}h=a[c[j>>2]>>0]|0;d=(c[g>>2]|0)+4|0;b=c[d>>2]|0;c[d>>2]=b+1;a[(c[c[g>>2]>>2]|0)+b>>0]=h;c[j>>2]=(c[j>>2]|0)+1}if((m|0)==11){tj(75824);c[f>>2]=2;k=c[f>>2]|0;i=e;return k|0}else if((m|0)==13){a[(c[c[g>>2]>>2]|0)+l>>0]=0;c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}return 0}function qj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}if((c[(c[e>>2]|0)+12>>2]|0)==2){i=d;return}oj(c[e>>2]|0,c[f>>2]|0)|0;i=d;return}function rj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}if((c[(c[e>>2]|0)+12>>2]|0)==2){i=d;return}pj(c[e>>2]|0,c[f>>2]|0)|0;i=d;return}function sj(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;if(!(c[f>>2]|0)){i=e;return}if((c[(c[f>>2]|0)+12>>2]|0)==2){i=e;return}if(!(vy(c[g>>2]|0,34)|0)){pj(c[f>>2]|0,75840)|0;oj(c[f>>2]|0,c[g>>2]|0)|0;pj(c[f>>2]|0,75840)|0;i=e;return}b=(vy(c[g>>2]|0,39)|0)!=0;a=c[f>>2]|0;if(!b){pj(a,75856)|0;oj(c[f>>2]|0,c[g>>2]|0)|0;pj(c[f>>2]|0,75856)|0;i=e;return}pj(a,75840)|0;a=c[g>>2]|0;c[h>>2]=a;c[j>>2]=a;while(1){if(!(d[c[h>>2]>>0]|0))break;if((d[c[h>>2]>>0]|0|0)!=34){c[h>>2]=(c[h>>2]|0)+1;continue}if((c[j>>2]|0)!=(c[h>>2]|0))nj(c[f>>2]|0,c[j>>2]|0,(c[h>>2]|0)-(c[j>>2]|0)|0)|0;nj(c[f>>2]|0,75848,6)|0;c[h>>2]=(c[h>>2]|0)+1;c[j>>2]=c[h>>2]}if((c[j>>2]|0)!=(c[h>>2]|0))nj(c[f>>2]|0,c[j>>2]|0,(c[h>>2]|0)-(c[j>>2]|0)|0)|0;pj(c[f>>2]|0,75840)|0;i=e;return}function tj(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;ce(2,2,0,0,c[d>>2]|0);i=b;return}function uj(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=0;d=c[f>>2]|0;if((d|0)==1302)c[j>>2]=76032;else if((d|0)==1300)c[j>>2]=75952;else if((d|0)==1301)c[j>>2]=75992;else if((d|0)==1303)c[j>>2]=76072;else c[j>>2]=76096;ce(2,c[f>>2]|0,c[g>>2]|0,c[j>>2]|0,c[h>>2]|0);i=e;return}function vj(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;do if(((c[h>>2]|0)!=0?!((c[j>>2]|0)==0?1:(c[(c[h>>2]|0)+4>>2]|0)!=2):0)?(c[(c[j>>2]|0)+4>>2]|0)==2:0){if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+4>>2]|0)!=2:0)break;d=c[(c[h>>2]|0)+20>>2]|0;b=c[(c[j>>2]|0)+8>>2]|0;if(!(c[(c[j>>2]|0)+36>>2]|0))c[k>>2]=Ai(d,b,0)|0;else c[k>>2]=Ai(d,b,c[(c[(c[j>>2]|0)+36>>2]|0)+8>>2]|0)|0;if((c[(c[j>>2]|0)+32>>2]|0)!=(c[(c[h>>2]|0)+32>>2]|0))ri(c[j>>2]|0,c[(c[h>>2]|0)+32>>2]|0);c[(c[j>>2]|0)+20>>2]=c[(c[h>>2]|0)+20>>2];c[(c[j>>2]|0)+28>>2]=c[g>>2];if(c[g>>2]|0){c[(c[j>>2]|0)+24>>2]=c[(c[g>>2]|0)+24>>2];c[(c[g>>2]|0)+24>>2]=c[j>>2];if(c[(c[j>>2]|0)+24>>2]|0)c[(c[(c[j>>2]|0)+24>>2]|0)+28>>2]=c[j>>2]}else{c[(c[j>>2]|0)+24>>2]=c[h>>2];c[(c[h>>2]|0)+28>>2]=c[j>>2]}if((c[(c[j>>2]|0)+28>>2]|0)==0?(c[(c[j>>2]|0)+20>>2]|0)!=0:0)c[(c[(c[j>>2]|0)+20>>2]|0)+44>>2]=c[j>>2];if((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+4>>2]|0)!=16:0)fi(c[k>>2]|0)|0;c[f>>2]=c[j>>2];l=c[f>>2]|0;i=e;return l|0}while(0);c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}function wj(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+48|0;h=g+36|0;j=g+32|0;k=g+28|0;l=g+24|0;m=g+20|0;n=g+16|0;o=g+12|0;p=g+8|0;q=g+4|0;r=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[p>>2]=0;if((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+4>>2]|0)!=1:0){do if((c[n>>2]|0)==1){if((c[(c[j>>2]|0)+32>>2]|0)!=0?(CP(c[(c[(c[j>>2]|0)+32>>2]|0)+80>>2]|0,c[l>>2]|0)|0)!=0:0)break;zb[c[135736>>2]&511](c[l>>2]|0)}while(0);c[h>>2]=0;s=c[h>>2]|0;i=g;return s|0}c[o>>2]=Cb[c[135744>>2]&511](48)|0;if(!(c[o>>2]|0)){do if((c[n>>2]|0)==1){if(((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+32>>2]|0)!=0:0)?(CP(c[(c[(c[j>>2]|0)+32>>2]|0)+80>>2]|0,c[l>>2]|0)|0)!=0:0)break;zb[c[135736>>2]&511](c[l>>2]|0)}while(0);tj(75320);c[h>>2]=0;s=c[h>>2]|0;i=g;return s|0}f=(c[o>>2]|0)+0|0;e=f+48|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(e|0));c[(c[o>>2]|0)+4>>2]=2;c[(c[o>>2]|0)+20>>2]=c[j>>2];if(c[j>>2]|0){c[p>>2]=c[(c[j>>2]|0)+32>>2];c[(c[o>>2]|0)+32>>2]=c[p>>2]}c[(c[o>>2]|0)+36>>2]=c[k>>2];do if(!(c[n>>2]|0)){if((c[p>>2]|0)!=0?(c[(c[p>>2]|0)+80>>2]|0)!=0:0){k=AP(c[(c[p>>2]|0)+80>>2]|0,c[l>>2]|0,-1)|0;c[(c[o>>2]|0)+8>>2]=k;break}k=my(c[l>>2]|0)|0;c[(c[o>>2]|0)+8>>2]=k}else c[(c[o>>2]|0)+8>>2]=c[l>>2];while(0);a:do if(c[m>>2]|0){if((Fy(c[m>>2]|0)|0)==0?(uj(1303,c[p>>2]|0,0),(c[p>>2]|0)!=0):0){l=my(75792)|0;c[(c[p>>2]|0)+60>>2]=l}l=Wh(c[p>>2]|0,c[m>>2]|0)|0;c[(c[o>>2]|0)+12>>2]=l;c[(c[o>>2]|0)+16>>2]=0;c[q>>2]=c[(c[o>>2]|0)+12>>2];while(1){if(!(c[q>>2]|0))break a;c[(c[q>>2]|0)+20>>2]=c[o>>2];if(!(c[(c[q>>2]|0)+24>>2]|0))c[(c[o>>2]|0)+16>>2]=c[q>>2];c[q>>2]=c[(c[q>>2]|0)+24>>2]}}while(0);do if(c[j>>2]|0){if(!(c[(c[j>>2]|0)+44>>2]|0)){c[(c[j>>2]|0)+44>>2]=c[o>>2];break}c[r>>2]=c[(c[j>>2]|0)+44>>2];while(1){if(!(c[(c[r>>2]|0)+24>>2]|0))break;c[r>>2]=c[(c[r>>2]|0)+24>>2]}c[(c[r>>2]|0)+24>>2]=c[o>>2];c[(c[o>>2]|0)+28>>2]=c[r>>2]}while(0);if((c[m>>2]|0)!=0&(c[j>>2]|0)!=0?(Em(c[(c[j>>2]|0)+32>>2]|0,c[j>>2]|0,c[o>>2]|0)|0)==1:0)Cm(0,c[(c[j>>2]|0)+32>>2]|0,c[m>>2]|0,c[o>>2]|0)|0;if((c[18774]|0)!=0&(c[33968]|0)!=0)zb[c[135872>>2]&511](c[o>>2]|0);c[h>>2]=c[o>>2];s=c[h>>2]|0;i=g;return s|0}function xj(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+48|0;g=f+44|0;h=f+40|0;j=f+36|0;k=f+32|0;l=f+28|0;m=f+24|0;n=f+20|0;o=f+16|0;p=f+12|0;q=f+8|0;r=f+4|0;s=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if((c[h>>2]|0)!=0?!((c[j>>2]|0)==0?1:(c[(c[h>>2]|0)+4>>2]|0)!=1):0){a:do if(c[(c[h>>2]|0)+44>>2]|0){c[m>>2]=c[(c[h>>2]|0)+44>>2];if(!(c[k>>2]|0)){while(1){if((c[(c[m>>2]|0)+36>>2]|0)==0?(qy(c[(c[m>>2]|0)+8>>2]|0,c[j>>2]|0)|0)!=0:0)break;c[m>>2]=c[(c[m>>2]|0)+24>>2];if(!(c[m>>2]|0))break a}c[g>>2]=c[m>>2];t=c[g>>2]|0;i=f;return t|0}while(1){if((c[(c[m>>2]|0)+36>>2]|0)!=0?(qy(c[(c[m>>2]|0)+8>>2]|0,c[j>>2]|0)|0)!=0:0){if((c[(c[(c[m>>2]|0)+36>>2]|0)+8>>2]|0)==(c[k>>2]|0))break;if(qy(c[(c[(c[m>>2]|0)+36>>2]|0)+8>>2]|0,c[k>>2]|0)|0)break}c[m>>2]=c[(c[m>>2]|0)+24>>2];if(!(c[m>>2]|0))break a}c[g>>2]=c[m>>2];t=c[g>>2]|0;i=f;return t|0}while(0);if(!(c[l>>2]|0)){c[g>>2]=0;t=c[g>>2]|0;i=f;return t|0}if((c[(c[h>>2]|0)+32>>2]|0)!=0?(c[(c[(c[h>>2]|0)+32>>2]|0)+44>>2]|0)!=0:0){c[n>>2]=c[(c[h>>2]|0)+32>>2];c[o>>2]=0;c[q>>2]=0;do if((c[(c[h>>2]|0)+36>>2]|0)!=0?(c[(c[(c[h>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){c[q>>2]=my(c[(c[(c[h>>2]|0)+36>>2]|0)+12>>2]|0)|0;c[q>>2]=By(c[q>>2]|0,75864)|0;c[q>>2]=By(c[q>>2]|0,c[(c[h>>2]|0)+8>>2]|0)|0;if(c[q>>2]|0){c[p>>2]=c[q>>2];break}c[g>>2]=0;t=c[g>>2]|0;i=f;return t|0}else u=25;while(0);if((u|0)==25)c[p>>2]=c[(c[h>>2]|0)+8>>2];if(!(c[k>>2]|0)){c[o>>2]=Nm(c[(c[n>>2]|0)+44>>2]|0,c[p>>2]|0,c[j>>2]|0,0)|0;if((c[o>>2]|0)==0?(c[(c[n>>2]|0)+48>>2]|0)!=0:0)c[o>>2]=Nm(c[(c[n>>2]|0)+48>>2]|0,c[p>>2]|0,c[j>>2]|0,0)|0}else{c[r>>2]=bj(c[(c[h>>2]|0)+32>>2]|0,c[h>>2]|0)|0;if(!(c[r>>2]|0)){if(c[q>>2]|0)zb[c[135736>>2]&511](c[q>>2]|0);c[g>>2]=0;t=c[g>>2]|0;i=f;return t|0}c[s>>2]=c[r>>2];while(1){if(!(c[c[s>>2]>>2]|0))break;if(qy(c[(c[c[s>>2]>>2]|0)+8>>2]|0,c[k>>2]|0)|0){c[o>>2]=Nm(c[(c[n>>2]|0)+44>>2]|0,c[p>>2]|0,c[j>>2]|0,c[(c[c[s>>2]>>2]|0)+12>>2]|0)|0;if(c[o>>2]|0)break;if((c[(c[n>>2]|0)+48>>2]|0)!=0?(c[o>>2]=Nm(c[(c[n>>2]|0)+48>>2]|0,c[p>>2]|0,c[j>>2]|0,c[(c[c[s>>2]>>2]|0)+12>>2]|0)|0,(c[o>>2]|0)!=0):0)break}c[s>>2]=(c[s>>2]|0)+4}zb[c[135736>>2]&511](c[r>>2]|0)}if(c[q>>2]|0)zb[c[135736>>2]&511](c[q>>2]|0);if((c[o>>2]|0)!=0?(c[(c[o>>2]|0)+48>>2]|0)!=0:0){c[g>>2]=c[o>>2];t=c[g>>2]|0;i=f;return t|0}}c[g>>2]=0;t=c[g>>2]|0;i=f;return t|0}c[g>>2]=0;t=c[g>>2]|0;i=f;return t|0}function yj(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+48|0;f=e+36|0;g=e+32|0;h=e+28|0;j=e+24|0;k=e+20|0;l=e+16|0;m=e+12|0;n=e+8|0;o=e+4|0;p=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(!(c[j>>2]|0)){c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}if((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+4>>2]|0)!=1:0){c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}do if(!(c[h>>2]|0)){if(c[g>>2]|0){c[k>>2]=ci(c[g>>2]|0,c[(c[j>>2]|0)+8>>2]|0,0)|0;break}d=c[j>>2]|0;if(c[(c[j>>2]|0)+20>>2]|0){c[k>>2]=ci(c[(c[d+20>>2]|0)+32>>2]|0,c[(c[j>>2]|0)+8>>2]|0,0)|0;break}b=c[j>>2]|0;if(c[d+12>>2]|0){c[k>>2]=ci(c[(c[b+12>>2]|0)+32>>2]|0,c[(c[j>>2]|0)+8>>2]|0,0)|0;break}else{c[k>>2]=ci(0,c[b+8>>2]|0,0)|0;break}}else c[k>>2]=ci(c[(c[h>>2]|0)+32>>2]|0,c[(c[j>>2]|0)+8>>2]|0,0)|0;while(0);if(!(c[k>>2]|0)){c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}c[(c[k>>2]|0)+20>>2]=c[h>>2];do if((c[h>>2]|0)!=0?(c[(c[j>>2]|0)+36>>2]|0)!=0:0){c[l>>2]=cj(c[(c[h>>2]|0)+32>>2]|0,c[h>>2]|0,c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2]|0)|0;if(c[l>>2]|0)if(qy(c[(c[l>>2]|0)+8>>2]|0,c[(c[(c[j>>2]|0)+36>>2]|0)+8>>2]|0)|0){c[(c[k>>2]|0)+36>>2]=c[l>>2];break}else{g=Hj(c[(c[h>>2]|0)+32>>2]|0,c[h>>2]|0,c[(c[j>>2]|0)+36>>2]|0)|0;c[(c[k>>2]|0)+36>>2]=g;break}c[l>>2]=cj(c[(c[j>>2]|0)+32>>2]|0,c[(c[j>>2]|0)+20>>2]|0,c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2]|0)|0;if(c[l>>2]|0){c[m>>2]=c[h>>2];c[n>>2]=0;while(1){r=c[m>>2]|0;if(!(c[(c[m>>2]|0)+20>>2]|0))break;c[n>>2]=r;c[m>>2]=c[(c[m>>2]|0)+20>>2]}if((r|0)==(c[(c[h>>2]|0)+32>>2]|0))c[m>>2]=c[n>>2];g=Ih(c[m>>2]|0,c[(c[l>>2]|0)+8>>2]|0,c[(c[l>>2]|0)+12>>2]|0)|0;c[(c[k>>2]|0)+36>>2]=g}}else c[(c[k>>2]|0)+36>>2]=0;while(0);a:do if(c[(c[j>>2]|0)+12>>2]|0){l=Aj(c[(c[j>>2]|0)+12>>2]|0,c[(c[k>>2]|0)+32>>2]|0,c[k>>2]|0)|0;c[(c[k>>2]|0)+12>>2]=l;c[(c[k>>2]|0)+16>>2]=0;c[o>>2]=c[(c[k>>2]|0)+12>>2];while(1){if(!(c[o>>2]|0))break a;if(!(c[(c[o>>2]|0)+24>>2]|0))c[(c[k>>2]|0)+16>>2]=c[o>>2];c[o>>2]=c[(c[o>>2]|0)+24>>2]}}while(0);if(((((((c[h>>2]|0)!=0&(c[j>>2]|0)!=0?(c[(c[h>>2]|0)+32>>2]|0)!=0:0)?(c[(c[j>>2]|0)+32>>2]|0)!=0:0)?(c[(c[(c[j>>2]|0)+32>>2]|0)+64>>2]|0)!=0:0)?(c[(c[j>>2]|0)+20>>2]|0)!=0:0)?(Em(c[(c[j>>2]|0)+32>>2]|0,c[(c[j>>2]|0)+20>>2]|0,c[j>>2]|0)|0)!=0:0)?(c[p>>2]=_h(c[(c[j>>2]|0)+32>>2]|0,c[(c[j>>2]|0)+12>>2]|0,1)|0,(c[p>>2]|0)!=0):0){Cm(0,c[(c[h>>2]|0)+32>>2]|0,c[p>>2]|0,c[k>>2]|0)|0;zb[c[135736>>2]&511](c[p>>2]|0)}c[f>>2]=c[k>>2];q=c[f>>2]|0;i=e;return q|0}function zj(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+48|0;h=g+36|0;j=g+32|0;k=g+28|0;l=g+24|0;m=g+20|0;n=g+16|0;o=g+12|0;p=g+8|0;q=g+4|0;r=g;c[j>>2]=a;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;if(!(c[j>>2]|0)){c[h>>2]=0;s=c[h>>2]|0;i=g;return s|0}switch(c[(c[j>>2]|0)+4>>2]|0){case 18:{c[h>>2]=Ei(c[j>>2]|0)|0;s=c[h>>2]|0;i=g;return s|0}case 10:case 12:case 14:case 15:case 16:case 17:{c[h>>2]=0;s=c[h>>2]|0;i=g;return s|0}case 2:{c[h>>2]=yj(c[k>>2]|0,c[l>>2]|0,c[j>>2]|0)|0;s=c[h>>2]|0;i=g;return s|0}case 9:case 13:case 21:{c[h>>2]=Mi(c[j>>2]|0,c[m>>2]|0)|0;s=c[h>>2]|0;i=g;return s|0}default:{c[n>>2]=Cb[c[135744>>2]&511](60)|0;if(!(c[n>>2]|0)){tj(75936);c[h>>2]=0;s=c[h>>2]|0;i=g;return s|0}f=(c[n>>2]|0)+0|0;e=f+60|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(e|0));c[(c[n>>2]|0)+4>>2]=c[(c[j>>2]|0)+4>>2];c[(c[n>>2]|0)+32>>2]=c[k>>2];c[(c[n>>2]|0)+20>>2]=c[l>>2];do if((c[(c[j>>2]|0)+8>>2]|0)!=75104){if((c[(c[j>>2]|0)+8>>2]|0)==75112){c[(c[n>>2]|0)+8>>2]=75112;break}if((c[(c[j>>2]|0)+8>>2]|0)==75128){c[(c[n>>2]|0)+8>>2]=75128;break}if(c[(c[j>>2]|0)+8>>2]|0){if((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+80>>2]|0)!=0:0){f=AP(c[(c[k>>2]|0)+80>>2]|0,c[(c[j>>2]|0)+8>>2]|0,-1)|0;c[(c[n>>2]|0)+8>>2]=f;break}f=my(c[(c[j>>2]|0)+8>>2]|0)|0;c[(c[n>>2]|0)+8>>2]=f}}else c[(c[n>>2]|0)+8>>2]=75104;while(0);if(((((c[(c[j>>2]|0)+4>>2]|0)!=1?(c[(c[j>>2]|0)+40>>2]|0)!=0:0)?(c[(c[j>>2]|0)+4>>2]|0)!=5:0)?(c[(c[j>>2]|0)+4>>2]|0)!=20:0)?(c[(c[j>>2]|0)+4>>2]|0)!=19:0){
f=my(c[(c[j>>2]|0)+40>>2]|0)|0;c[(c[n>>2]|0)+40>>2]=f}else t=27;if((t|0)==27?(c[(c[j>>2]|0)+4>>2]|0)==1:0)b[(c[n>>2]|0)+56>>1]=b[(c[j>>2]|0)+56>>1]|0;if(c[l>>2]|0){if((c[18774]|0)!=0&(c[33968]|0)!=0)zb[c[135872>>2]&511](c[n>>2]|0);c[o>>2]=zi(c[l>>2]|0,c[n>>2]|0)|0;if((c[o>>2]|0)!=(c[n>>2]|0)){c[h>>2]=c[o>>2];s=c[h>>2]|0;i=g;return s|0}}do if(c[m>>2]|0){if(!((c[(c[j>>2]|0)+4>>2]|0)!=1?(c[(c[j>>2]|0)+4>>2]|0)!=19:0))t=37;if((t|0)==37?(c[(c[j>>2]|0)+48>>2]|0)!=0:0){o=Ei(c[(c[j>>2]|0)+48>>2]|0)|0;c[(c[n>>2]|0)+48>>2]=o}do if(c[(c[j>>2]|0)+36>>2]|0){c[p>>2]=cj(c[k>>2]|0,c[n>>2]|0,c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2]|0)|0;if(c[p>>2]|0){c[(c[n>>2]|0)+36>>2]=c[p>>2];break}c[p>>2]=cj(c[(c[j>>2]|0)+32>>2]|0,c[j>>2]|0,c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2]|0)|0;if(!(c[p>>2]|0)){o=Hj(c[k>>2]|0,c[n>>2]|0,c[(c[j>>2]|0)+36>>2]|0)|0;c[(c[n>>2]|0)+36>>2]=o;break}c[q>>2]=c[n>>2];while(1){u=c[q>>2]|0;if(!(c[(c[q>>2]|0)+20>>2]|0))break;c[q>>2]=c[u+20>>2]}o=Ih(u,c[(c[p>>2]|0)+8>>2]|0,c[(c[p>>2]|0)+12>>2]|0)|0;c[(c[n>>2]|0)+36>>2]=o}while(0);if(!((c[(c[j>>2]|0)+4>>2]|0)!=1?(c[(c[j>>2]|0)+4>>2]|0)!=19:0))t=50;if((t|0)==50?(c[(c[j>>2]|0)+44>>2]|0)!=0:0){o=Gi(c[n>>2]|0,c[(c[j>>2]|0)+44>>2]|0)|0;c[(c[n>>2]|0)+44>>2]=o}if((c[(c[j>>2]|0)+4>>2]|0)==5){if((c[k>>2]|0)!=0?(c[(c[j>>2]|0)+32>>2]|0)==(c[k>>2]|0):0)c[(c[n>>2]|0)+12>>2]=c[(c[j>>2]|0)+12>>2];else{o=ad(c[k>>2]|0,c[(c[n>>2]|0)+8>>2]|0)|0;c[(c[n>>2]|0)+12>>2]=o}c[(c[n>>2]|0)+16>>2]=c[(c[n>>2]|0)+12>>2];break}if(((c[m>>2]|0)!=2?(c[(c[j>>2]|0)+12>>2]|0)!=0:0)?(o=Aj(c[(c[j>>2]|0)+12>>2]|0,c[k>>2]|0,c[n>>2]|0)|0,c[(c[n>>2]|0)+12>>2]=o,(c[n>>2]|0)!=0):0){c[r>>2]=c[(c[n>>2]|0)+12>>2];if(!(c[r>>2]|0)){c[(c[n>>2]|0)+16>>2]=0;break}while(1){o=(c[(c[r>>2]|0)+24>>2]|0)!=0;c[(c[r>>2]|0)+20>>2]=c[n>>2];v=c[r>>2]|0;if(!o)break;c[r>>2]=c[v+24>>2]}c[(c[n>>2]|0)+16>>2]=v}}while(0);if((c[l>>2]|0)==0&(c[18774]|0)!=0&(c[33968]|0)!=0)zb[c[135872>>2]&511](c[n>>2]|0);c[h>>2]=c[n>>2];s=c[h>>2]|0;i=g;return s|0}}return 0}function Aj(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=0;c[l>>2]=0;a:while(1){if(!(c[g>>2]|0)){n=19;break}do if((c[(c[g>>2]|0)+4>>2]|0)==14){if(!(c[h>>2]|0)){c[g>>2]=c[(c[g>>2]|0)+24>>2];continue a}if(c[(c[h>>2]|0)+44>>2]|0){c[m>>2]=c[(c[h>>2]|0)+44>>2];zi(c[j>>2]|0,c[m>>2]|0)|0;break}c[m>>2]=Li(c[g>>2]|0)|0;if(!(c[m>>2]|0)){n=8;break a}c[(c[m>>2]|0)+32>>2]=c[h>>2];c[(c[m>>2]|0)+20>>2]=c[j>>2];c[(c[h>>2]|0)+44>>2]=c[m>>2];zi(c[j>>2]|0,c[m>>2]|0)|0}else c[m>>2]=zj(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0,1)|0;while(0);if(!(c[m>>2]|0)){n=13;break}if(c[k>>2]|0){if((c[l>>2]|0)!=(c[m>>2]|0)){c[(c[l>>2]|0)+24>>2]=c[m>>2];c[(c[m>>2]|0)+28>>2]=c[l>>2];c[l>>2]=c[m>>2]}}else{c[(c[m>>2]|0)+28>>2]=0;d=c[m>>2]|0;c[l>>2]=d;c[k>>2]=d}c[g>>2]=c[(c[g>>2]|0)+24>>2]}if((n|0)==8){c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}else if((n|0)==13){c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}else if((n|0)==19){c[f>>2]=c[k>>2];o=c[f>>2]|0;i=e;return o|0}return 0}function Bj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+48>>2]|0)!=0:0){c[h>>2]=c[(c[f>>2]|0)+48>>2];c[e>>2]=Rj(c[h>>2]|0,c[g>>2]|0)|0;j=c[e>>2]|0;i=d;return j|0}c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}function Cj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+60>>2]|0)!=0:0){c[h>>2]=c[(c[f>>2]|0)+60>>2];c[e>>2]=Rj(c[h>>2]|0,c[g>>2]|0)|0;j=c[e>>2]|0;i=d;return j|0}c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}function Dj(a,b){a=a|0;b=b|0;var d=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[g>>2]=a;c[h>>2]=b;c[j>>2]=-1;if((c[h>>2]|0)>=5){c[f>>2]=-1;k=c[f>>2]|0;i=d;return k|0}if(!(c[g>>2]|0)){c[f>>2]=c[j>>2];k=c[f>>2]|0;i=d;return k|0}a:do if((((c[(c[g>>2]|0)+4>>2]|0)!=1?(c[(c[g>>2]|0)+4>>2]|0)!=3:0)?(c[(c[g>>2]|0)+4>>2]|0)!=8:0)?(c[(c[g>>2]|0)+4>>2]|0)!=7:0){do if(c[(c[g>>2]|0)+28>>2]|0){if((((c[(c[(c[g>>2]|0)+28>>2]|0)+4>>2]|0)!=1?(c[(c[(c[g>>2]|0)+28>>2]|0)+4>>2]|0)!=3:0)?(c[(c[(c[g>>2]|0)+28>>2]|0)+4>>2]|0)!=8:0)?(c[(c[(c[g>>2]|0)+28>>2]|0)+4>>2]|0)!=7:0)break;c[j>>2]=Dj(c[(c[g>>2]|0)+28>>2]|0,(c[h>>2]|0)+1|0)|0;break a}while(0);if((c[(c[g>>2]|0)+20>>2]|0)!=0?(c[(c[(c[g>>2]|0)+20>>2]|0)+4>>2]|0)==1:0)c[j>>2]=Dj(c[(c[g>>2]|0)+20>>2]|0,(c[h>>2]|0)+1|0)|0}else l=9;while(0);if((l|0)==9){do if((e[(c[g>>2]|0)+56>>1]|0|0)==65535){if((c[(c[g>>2]|0)+4>>2]|0)==3?(c[(c[g>>2]|0)+52>>2]|0)!=0:0){c[j>>2]=c[(c[g>>2]|0)+52>>2];break}if((c[(c[g>>2]|0)+4>>2]|0)==1?(c[(c[g>>2]|0)+12>>2]|0)!=0:0){c[j>>2]=Dj(c[(c[g>>2]|0)+12>>2]|0,(c[h>>2]|0)+1|0)|0;break}l=c[g>>2]|0;if(c[(c[g>>2]|0)+24>>2]|0){c[j>>2]=Dj(c[l+24>>2]|0,(c[h>>2]|0)+1|0)|0;break}if(c[l+28>>2]|0)c[j>>2]=Dj(c[(c[g>>2]|0)+28>>2]|0,(c[h>>2]|0)+1|0)|0}while(0);if((c[j>>2]|0)==-1|(c[j>>2]|0)==65535)c[j>>2]=e[(c[g>>2]|0)+56>>1]}c[f>>2]=c[j>>2];k=c[f>>2]|0;i=d;return k|0}function Ej(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if(!(c[e>>2]|0)){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}if(c[(c[e>>2]|0)+52>>2]|0){c[d>>2]=c[(c[e>>2]|0)+52>>2];g=c[d>>2]|0;i=b;return g|0}c[f>>2]=Cb[c[135744>>2]&511](24)|0;if(!(c[f>>2]|0)){tj(75904);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{a=c[f>>2]|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;c[(c[f>>2]|0)+4>>2]=18;a=my(75176)|0;c[(c[f>>2]|0)+8>>2]=a;a=my(75168)|0;c[(c[f>>2]|0)+12>>2]=a;c[(c[e>>2]|0)+52>>2]=c[f>>2];c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function Fj(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f+20|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[f+16>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;a:while(1){if(c[h>>2]|0)m=(c[h>>2]|0)!=(c[j>>2]|0);else m=0;n=c[h>>2]|0;if(!m){o=19;break}if((c[n+4>>2]|0)==5){o=8;break}if((c[(c[h>>2]|0)+4>>2]|0)==6){o=8;break}if((c[(c[h>>2]|0)+4>>2]|0)==17){o=8;break}b:do if((c[(c[h>>2]|0)+4>>2]|0)==1){c[l>>2]=c[(c[h>>2]|0)+48>>2];while(1){if(!(c[l>>2]|0))break b;if((c[k>>2]|0)==0?(c[(c[l>>2]|0)+12>>2]|0)==0:0){o=13;break a}if(((c[k>>2]|0)!=0?(c[(c[l>>2]|0)+12>>2]|0)!=0:0)?(qy(c[(c[l>>2]|0)+12>>2]|0,c[k>>2]|0)|0)!=0:0){o=16;break a}c[l>>2]=c[c[l>>2]>>2]}}while(0);c[h>>2]=c[(c[h>>2]|0)+20>>2]}if((o|0)==8){c[g>>2]=-1;p=c[g>>2]|0;i=f;return p|0}else if((o|0)==13){c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}else if((o|0)==16){c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}else if((o|0)==19)if((n|0)!=(c[j>>2]|0)){c[g>>2]=-1;p=c[g>>2]|0;i=f;return p|0}else{c[g>>2]=1;p=c[g>>2]|0;i=f;return p|0}return 0}function Gj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if(!(c[e>>2]|0)){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}a=c[e>>2]|0;if((c[(c[e>>2]|0)+4>>2]|0)!=2)if((c[a+4>>2]|0)==16){c[d>>2]=my(c[(c[e>>2]|0)+48>>2]|0)|0;g=c[d>>2]|0;i=b;return g|0}else{c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}if(c[a+12>>2]|0){do if(!(c[(c[(c[e>>2]|0)+12>>2]|0)+24>>2]|0)){if((c[(c[(c[e>>2]|0)+12>>2]|0)+4>>2]|0)!=3?(c[(c[(c[e>>2]|0)+12>>2]|0)+4>>2]|0)!=4:0)break;c[d>>2]=my(c[(c[(c[e>>2]|0)+12>>2]|0)+40>>2]|0)|0;g=c[d>>2]|0;i=b;return g|0}while(0);c[f>>2]=_h(c[(c[e>>2]|0)+32>>2]|0,c[(c[e>>2]|0)+12>>2]|0,1)|0;if(c[f>>2]|0){c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}}c[d>>2]=my(75312)|0;g=c[d>>2]|0;i=b;return g|0}function Hj(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+96|0;f=e;g=e+28|0;h=e+24|0;j=e+20|0;k=e+16|0;l=e+12|0;m=e+32|0;n=e+8|0;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[n>>2]=1;if((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+4>>2]|0)==1:0){if((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+4>>2]|0)==18:0){c[l>>2]=Ri(c[h>>2]|0,c[j>>2]|0,c[(c[k>>2]|0)+8>>2]|0)|0;if(c[l>>2]|0){c[g>>2]=c[l>>2];o=c[g>>2]|0;i=e;return o|0}if(!(c[(c[k>>2]|0)+12>>2]|0))JT(m,50,75656,f)|0;else{c[f>>2]=c[(c[k>>2]|0)+12>>2];JT(m,50,75872,f)|0}c[l>>2]=cj(c[h>>2]|0,c[j>>2]|0,m)|0;while(1){if(!(c[l>>2]|0)){p=20;break}if((c[n>>2]|0)>1e3){p=15;break}if(!(c[(c[k>>2]|0)+12>>2]|0)){d=c[n>>2]|0;c[n>>2]=d+1;c[f>>2]=d;JT(m,50,75880,f)|0}else{d=c[(c[k>>2]|0)+12>>2]|0;b=c[n>>2]|0;c[n>>2]=b+1;c[f>>2]=d;c[f+4>>2]=b;JT(m,50,75896,f)|0}c[l>>2]=cj(c[h>>2]|0,c[j>>2]|0,m)|0}if((p|0)==15){c[g>>2]=0;o=c[g>>2]|0;i=e;return o|0}else if((p|0)==20){c[l>>2]=Ih(c[j>>2]|0,c[(c[k>>2]|0)+8>>2]|0,m)|0;c[g>>2]=c[l>>2];o=c[g>>2]|0;i=e;return o|0}}c[g>>2]=0;o=c[g>>2]|0;i=e;return o|0}c[g>>2]=0;o=c[g>>2]|0;i=e;return o|0}function Ij(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[e>>2]=(c[e>>2]|0)<=0?256:a;c[f>>2]=Cb[c[135744>>2]&511](20)|0;do if(c[f>>2]|0){c[(c[f>>2]|0)+12>>2]=0;c[(c[f>>2]|0)+4>>2]=c[e>>2];c[(c[f>>2]|0)+8>>2]=0;a=Cb[c[135744>>2]&511]((c[e>>2]|0)*24|0)|0;c[c[f>>2]>>2]=a;if(!(c[c[f>>2]>>2]|0)){zb[c[135736>>2]&511](c[f>>2]|0);break}cU(c[c[f>>2]>>2]|0,0,(c[e>>2]|0)*24|0)|0;a=vP()|0;c[(c[f>>2]|0)+16>>2]=a;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}while(0);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}function Jj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=Ij(c[e>>2]|0)|0;if(!(c[g>>2]|0)){h=c[g>>2]|0;i=d;return h|0}c[(c[g>>2]|0)+12>>2]=c[f>>2];yP(c[f>>2]|0)|0;h=c[g>>2]|0;i=d;return h|0}function Kj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[e>>2]=a;c[f>>2]=b;c[k>>2]=0;if(!(c[e>>2]|0)){i=d;return}if(c[c[e>>2]>>2]|0){c[l>>2]=c[(c[e>>2]|0)+8>>2];c[g>>2]=0;while(1){if(!((c[l>>2]|0)>0?(c[g>>2]|0)<(c[(c[e>>2]|0)+4>>2]|0):0))break;c[h>>2]=(c[c[e>>2]>>2]|0)+((c[g>>2]|0)*24|0);a:do if(c[(c[h>>2]|0)+20>>2]|0){c[k>>2]=1;while(1){if(!(c[h>>2]|0))break a;c[j>>2]=c[c[h>>2]>>2];if((c[f>>2]|0)!=0?(c[(c[h>>2]|0)+16>>2]|0)!=0:0)Ab[c[f>>2]&511](c[(c[h>>2]|0)+16>>2]|0,c[(c[h>>2]|0)+4>>2]|0);if(!(c[(c[e>>2]|0)+12>>2]|0)){if(c[(c[h>>2]|0)+4>>2]|0)zb[c[135736>>2]&511](c[(c[h>>2]|0)+4>>2]|0);if(c[(c[h>>2]|0)+8>>2]|0)zb[c[135736>>2]&511](c[(c[h>>2]|0)+8>>2]|0);if(c[(c[h>>2]|0)+12>>2]|0)zb[c[135736>>2]&511](c[(c[h>>2]|0)+12>>2]|0)}c[(c[h>>2]|0)+16>>2]=0;if(!(c[k>>2]|0))zb[c[135736>>2]&511](c[h>>2]|0);c[l>>2]=(c[l>>2]|0)+-1;c[k>>2]=0;c[h>>2]=c[j>>2]}}while(0);c[g>>2]=(c[g>>2]|0)+1}zb[c[135736>>2]&511](c[c[e>>2]>>2]|0)}if(c[(c[e>>2]|0)+12>>2]|0)zP(c[(c[e>>2]|0)+12>>2]|0);zb[c[135736>>2]&511](c[e>>2]|0);i=d;return}function Lj(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=Mj(c[f>>2]|0,c[g>>2]|0,0,0,c[h>>2]|0)|0;i=e;return d|0}function Mj(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+48|0;h=g+36|0;j=g+32|0;k=g+28|0;l=g+24|0;m=g+20|0;n=g+16|0;o=g+12|0;p=g+8|0;q=g+4|0;r=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[p>>2]=0;if((c[j>>2]|0)==0|(c[k>>2]|0)==0){c[h>>2]=-1;s=c[h>>2]|0;i=g;return s|0}if(c[(c[j>>2]|0)+12>>2]|0){if((CP(c[(c[j>>2]|0)+12>>2]|0,c[k>>2]|0)|0)==0?(c[k>>2]=AP(c[(c[j>>2]|0)+12>>2]|0,c[k>>2]|0,-1)|0,(c[k>>2]|0)==0):0){c[h>>2]=-1;s=c[h>>2]|0;i=g;return s|0}if(((c[l>>2]|0)!=0?(CP(c[(c[j>>2]|0)+12>>2]|0,c[l>>2]|0)|0)==0:0)?(c[l>>2]=AP(c[(c[j>>2]|0)+12>>2]|0,c[l>>2]|0,-1)|0,(c[l>>2]|0)==0):0){c[h>>2]=-1;s=c[h>>2]|0;i=g;return s|0}if(((c[m>>2]|0)!=0?(CP(c[(c[j>>2]|0)+12>>2]|0,c[m>>2]|0)|0)==0:0)?(c[m>>2]=AP(c[(c[j>>2]|0)+12>>2]|0,c[m>>2]|0,-1)|0,(c[m>>2]|0)==0):0){c[h>>2]=-1;s=c[h>>2]|0;i=g;return s|0}}c[o>>2]=dk(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0)|0;do if(c[(c[c[j>>2]>>2]|0)+((c[o>>2]|0)*24|0)+20>>2]|0){f=(c[(c[j>>2]|0)+12>>2]|0)!=0;c[r>>2]=(c[c[j>>2]>>2]|0)+((c[o>>2]|0)*24|0);if(f){while(1){t=(c[(c[r>>2]|0)+4>>2]|0)==(c[k>>2]|0);if(!(c[c[r>>2]>>2]|0))break;if((t?(c[(c[r>>2]|0)+8>>2]|0)==(c[l>>2]|0):0)?(c[(c[r>>2]|0)+12>>2]|0)==(c[m>>2]|0):0){u=22;break}c[p>>2]=(c[p>>2]|0)+1;c[r>>2]=c[c[r>>2]>>2]}if((u|0)==22){c[h>>2]=-1;s=c[h>>2]|0;i=g;return s|0}if(!t)break;if((c[(c[r>>2]|0)+8>>2]|0)!=(c[l>>2]|0))break;if((c[(c[r>>2]|0)+12>>2]|0)!=(c[m>>2]|0))break;c[h>>2]=-1;s=c[h>>2]|0;i=g;return s|0}else{while(1){f=(c[c[r>>2]>>2]|0)!=0;v=(qy(c[(c[r>>2]|0)+4>>2]|0,c[k>>2]|0)|0)!=0;if(!f)break;if((v?(qy(c[(c[r>>2]|0)+8>>2]|0,c[l>>2]|0)|0)!=0:0)?(qy(c[(c[r>>2]|0)+12>>2]|0,c[m>>2]|0)|0)!=0:0){u=32;break}c[p>>2]=(c[p>>2]|0)+1;c[r>>2]=c[c[r>>2]>>2]}if((u|0)==32){c[h>>2]=-1;s=c[h>>2]|0;i=g;return s|0}if(!v)break;if(!(qy(c[(c[r>>2]|0)+8>>2]|0,c[l>>2]|0)|0))break;if(!(qy(c[(c[r>>2]|0)+12>>2]|0,c[m>>2]|0)|0))break;c[h>>2]=-1;s=c[h>>2]|0;i=g;return s|0}}else c[r>>2]=0;while(0);if(c[r>>2]|0){c[q>>2]=Cb[c[135744>>2]&511](24)|0;if(!(c[q>>2]|0)){c[h>>2]=-1;s=c[h>>2]|0;i=g;return s|0}}else c[q>>2]=(c[c[j>>2]>>2]|0)+((c[o>>2]|0)*24|0);o=c[k>>2]|0;if(c[(c[j>>2]|0)+12>>2]|0){c[(c[q>>2]|0)+4>>2]=o;c[(c[q>>2]|0)+8>>2]=c[l>>2];c[(c[q>>2]|0)+12>>2]=c[m>>2]}else{k=my(o)|0;c[(c[q>>2]|0)+4>>2]=k;k=my(c[l>>2]|0)|0;c[(c[q>>2]|0)+8>>2]=k;k=my(c[m>>2]|0)|0;c[(c[q>>2]|0)+12>>2]=k}c[(c[q>>2]|0)+16>>2]=c[n>>2];c[c[q>>2]>>2]=0;c[(c[q>>2]|0)+20>>2]=1;if(c[r>>2]|0)c[c[r>>2]>>2]=c[q>>2];q=(c[j>>2]|0)+8|0;c[q>>2]=(c[q>>2]|0)+1;if((c[p>>2]|0)>>>0>8)ek(c[j>>2]|0,c[(c[j>>2]|0)+4>>2]<<3)|0;c[h>>2]=0;s=c[h>>2]|0;i=g;return s|0}function Nj(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;e=Mj(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0,0,c[k>>2]|0)|0;i=f;return e|0}function Oj(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;e=Pj(c[g>>2]|0,c[h>>2]|0,0,0,c[j>>2]|0,c[k>>2]|0)|0;i=f;return e|0}function Pj(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+48|0;j=h+36|0;k=h+32|0;l=h+28|0;m=h+24|0;n=h+20|0;o=h+16|0;p=h+12|0;q=h+8|0;r=h+4|0;s=h;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;if((c[k>>2]|0)==0|(c[l>>2]|0)==0){c[j>>2]=-1;t=c[j>>2]|0;i=h;return t|0}if(c[(c[k>>2]|0)+12>>2]|0){if((CP(c[(c[k>>2]|0)+12>>2]|0,c[l>>2]|0)|0)==0?(c[l>>2]=AP(c[(c[k>>2]|0)+12>>2]|0,c[l>>2]|0,-1)|0,(c[l>>2]|0)==0):0){c[j>>2]=-1;t=c[j>>2]|0;i=h;return t|0}if(((c[m>>2]|0)!=0?(CP(c[(c[k>>2]|0)+12>>2]|0,c[m>>2]|0)|0)==0:0)?(c[m>>2]=AP(c[(c[k>>2]|0)+12>>2]|0,c[m>>2]|0,-1)|0,(c[m>>2]|0)==0):0){c[j>>2]=-1;t=c[j>>2]|0;i=h;return t|0}if(((c[n>>2]|0)!=0?(CP(c[(c[k>>2]|0)+12>>2]|0,c[n>>2]|0)|0)==0:0)?(c[n>>2]=AP(c[(c[k>>2]|0)+12>>2]|0,c[n>>2]|0,-1)|0,(c[n>>2]|0)==0):0){c[j>>2]=-1;t=c[j>>2]|0;i=h;return t|0}}c[q>>2]=dk(c[k>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0)|0;do if(c[(c[c[k>>2]>>2]|0)+((c[q>>2]|0)*24|0)+20>>2]|0){g=(c[(c[k>>2]|0)+12>>2]|0)!=0;c[s>>2]=(c[c[k>>2]>>2]|0)+((c[q>>2]|0)*24|0);if(g){while(1){u=(c[(c[s>>2]|0)+4>>2]|0)==(c[l>>2]|0);if(!(c[c[s>>2]>>2]|0))break;if((u?(c[(c[s>>2]|0)+8>>2]|0)==(c[m>>2]|0):0)?(c[(c[s>>2]|0)+12>>2]|0)==(c[n>>2]|0):0){v=22;break}c[s>>2]=c[c[s>>2]>>2]}if((v|0)==22){if(c[p>>2]|0)Ab[c[p>>2]&511](c[(c[s>>2]|0)+16>>2]|0,c[(c[s>>2]|0)+4>>2]|0);c[(c[s>>2]|0)+16>>2]=c[o>>2];c[j>>2]=0;t=c[j>>2]|0;i=h;return t|0}if(!u)break;if((c[(c[s>>2]|0)+8>>2]|0)!=(c[m>>2]|0))break;if((c[(c[s>>2]|0)+12>>2]|0)!=(c[n>>2]|0))break;if(c[p>>2]|0)Ab[c[p>>2]&511](c[(c[s>>2]|0)+16>>2]|0,c[(c[s>>2]|0)+4>>2]|0);c[(c[s>>2]|0)+16>>2]=c[o>>2];c[j>>2]=0;t=c[j>>2]|0;i=h;return t|0}else{while(1){g=(c[c[s>>2]>>2]|0)!=0;w=(qy(c[(c[s>>2]|0)+4>>2]|0,c[l>>2]|0)|0)!=0;if(!g)break;if((w?(qy(c[(c[s>>2]|0)+8>>2]|0,c[m>>2]|0)|0)!=0:0)?(qy(c[(c[s>>2]|0)+12>>2]|0,c[n>>2]|0)|0)!=0:0){v=36;break}c[s>>2]=c[c[s>>2]>>2]}if((v|0)==36){if(c[p>>2]|0)Ab[c[p>>2]&511](c[(c[s>>2]|0)+16>>2]|0,c[(c[s>>2]|0)+4>>2]|0);c[(c[s>>2]|0)+16>>2]=c[o>>2];c[j>>2]=0;t=c[j>>2]|0;i=h;return t|0}if(!w)break;if(!(qy(c[(c[s>>2]|0)+8>>2]|0,c[m>>2]|0)|0))break;if(!(qy(c[(c[s>>2]|0)+12>>2]|0,c[n>>2]|0)|0))break;if(c[p>>2]|0)Ab[c[p>>2]&511](c[(c[s>>2]|0)+16>>2]|0,c[(c[s>>2]|0)+4>>2]|0);c[(c[s>>2]|0)+16>>2]=c[o>>2];c[j>>2]=0;t=c[j>>2]|0;i=h;return t|0}}else c[s>>2]=0;while(0);if(c[s>>2]|0){c[r>>2]=Cb[c[135744>>2]&511](24)|0;if(!(c[r>>2]|0)){c[j>>2]=-1;t=c[j>>2]|0;i=h;return t|0}}else c[r>>2]=(c[c[k>>2]>>2]|0)+((c[q>>2]|0)*24|0);q=c[l>>2]|0;if(c[(c[k>>2]|0)+12>>2]|0){c[(c[r>>2]|0)+4>>2]=q;c[(c[r>>2]|0)+8>>2]=c[m>>2];c[(c[r>>2]|0)+12>>2]=c[n>>2]}else{l=my(q)|0;c[(c[r>>2]|0)+4>>2]=l;l=my(c[m>>2]|0)|0;c[(c[r>>2]|0)+8>>2]=l;l=my(c[n>>2]|0)|0;c[(c[r>>2]|0)+12>>2]=l}c[(c[r>>2]|0)+16>>2]=c[o>>2];c[c[r>>2]>>2]=0;c[(c[r>>2]|0)+20>>2]=1;o=(c[k>>2]|0)+8|0;c[o>>2]=(c[o>>2]|0)+1;if(c[s>>2]|0)c[c[s>>2]>>2]=c[r>>2];c[j>>2]=0;t=c[j>>2]|0;i=h;return t|0}function Qj(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+32|0;h=g+16|0;j=g+12|0;k=g+8|0;l=g+4|0;m=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;f=Pj(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,0,c[l>>2]|0,c[m>>2]|0)|0;i=g;return f|0}function Rj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=Sj(c[e>>2]|0,c[f>>2]|0,0,0)|0;i=d;return b|0}function Sj(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if(!(c[h>>2]|0)){c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}if(!(c[j>>2]|0)){c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}c[m>>2]=dk(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0)|0;if(!(c[(c[c[h>>2]>>2]|0)+((c[m>>2]|0)*24|0)+20>>2]|0)){c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}a:do if(c[(c[h>>2]|0)+12>>2]|0){c[n>>2]=(c[c[h>>2]>>2]|0)+((c[m>>2]|0)*24|0);while(1){if(!(c[n>>2]|0))break a;if(((c[(c[n>>2]|0)+4>>2]|0)==(c[j>>2]|0)?(c[(c[n>>2]|0)+8>>2]|0)==(c[k>>2]|0):0)?(c[(c[n>>2]|0)+12>>2]|0)==(c[l>>2]|0):0)break;c[n>>2]=c[c[n>>2]>>2]}c[g>>2]=c[(c[n>>2]|0)+16>>2];o=c[g>>2]|0;i=f;return o|0}while(0);c[n>>2]=(c[c[h>>2]>>2]|0)+((c[m>>2]|0)*24|0);while(1){if(!(c[n>>2]|0)){p=22;break}if(((qy(c[(c[n>>2]|0)+4>>2]|0,c[j>>2]|0)|0)!=0?(qy(c[(c[n>>2]|0)+8>>2]|0,c[k>>2]|0)|0)!=0:0)?(qy(c[(c[n>>2]|0)+12>>2]|0,c[l>>2]|0)|0)!=0:0){p=20;break}c[n>>2]=c[c[n>>2]>>2]}if((p|0)==20){c[g>>2]=c[(c[n>>2]|0)+16>>2];o=c[g>>2]|0;i=f;return o|0}else if((p|0)==22){c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}return 0}function Tj(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=Sj(c[f>>2]|0,c[g>>2]|0,c[h>>2]|0,0)|0;i=e;return d|0}function Uj(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=i;i=i+48|0;k=j+36|0;l=j+32|0;m=j+28|0;n=j+24|0;o=j+20|0;p=j+16|0;q=j+12|0;r=j+8|0;s=j+4|0;t=j;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;c[r>>2]=h;if(!(c[l>>2]|0)){c[k>>2]=0;u=c[k>>2]|0;i=j;return u|0}if(!(c[n>>2]|0)){c[k>>2]=0;u=c[k>>2]|0;i=j;return u|0}c[s>>2]=fk(c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[r>>2]|0)|0;if(!(c[(c[c[l>>2]>>2]|0)+((c[s>>2]|0)*24|0)+20>>2]|0)){c[k>>2]=0;u=c[k>>2]|0;i=j;return u|0}c[t>>2]=(c[c[l>>2]>>2]|0)+((c[s>>2]|0)*24|0);while(1){if(!(c[t>>2]|0)){v=14;break}if(((ry(c[m>>2]|0,c[n>>2]|0,c[(c[t>>2]|0)+4>>2]|0)|0)!=0?(ry(c[o>>2]|0,c[p>>2]|0,c[(c[t>>2]|0)+8>>2]|0)|0)!=0:0)?(ry(c[q>>2]|0,c[r>>2]|0,c[(c[t>>2]|0)+12>>2]|0)|0)!=0:0){v=12;break}c[t>>2]=c[c[t>>2]>>2]}if((v|0)==12){c[k>>2]=c[(c[t>>2]|0)+16>>2];u=c[k>>2]|0;i=j;return u|0}else if((v|0)==14){c[k>>2]=0;u=c[k>>2]|0;i=j;return u|0}return 0}function Vj(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+32|0;h=g+16|0;j=g+12|0;k=g+8|0;l=g+4|0;m=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;f=Uj(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0,0,0)|0;i=g;return f|0}function Wj(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j+4>>2]=c[h>>2];c[j>>2]=c[g>>2];Xj(c[f>>2]|0,229,j);i=e;return}function Xj(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){i=e;return}if(!(c[c[f>>2]>>2]|0)){i=e;return}c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[(c[f>>2]|0)+4>>2]|0))break;a:do if(c[(c[c[f>>2]>>2]|0)+((c[j>>2]|0)*24|0)+20>>2]|0){c[l>>2]=(c[c[f>>2]>>2]|0)+((c[j>>2]|0)*24|0);while(1){if(!(c[l>>2]|0))break a;c[m>>2]=c[c[l>>2]>>2];c[k>>2]=c[(c[f>>2]|0)+8>>2];if((c[g>>2]|0)!=0?(c[(c[l>>2]|0)+16>>2]|0)!=0:0)xb[c[g>>2]&511](c[(c[l>>2]|0)+16>>2]|0,c[h>>2]|0,c[(c[l>>2]|0)+4>>2]|0,c[(c[l>>2]|0)+8>>2]|0,c[(c[l>>2]|0)+12>>2]|0);if((c[k>>2]|0)==(c[(c[f>>2]|0)+8>>2]|0)){c[l>>2]=c[m>>2];continue}if((c[l>>2]|0)!=((c[c[f>>2]>>2]|0)+((c[j>>2]|0)*24|0)|0)){c[l>>2]=c[m>>2];continue}if(!(c[(c[c[f>>2]>>2]|0)+((c[j>>2]|0)*24|0)+20>>2]|0))c[l>>2]=0;if((c[(c[c[f>>2]>>2]|0)+((c[j>>2]|0)*24|0)>>2]|0)==(c[m>>2]|0))continue;c[l>>2]=(c[c[f>>2]>>2]|0)+((c[j>>2]|0)*24|0)}}while(0);c[j>>2]=(c[j>>2]|0)+1}i=e;return}function Yj(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+32|0;j=h+20|0;k=h+16|0;l=h+12|0;m=h+8|0;n=h+4|0;o=h;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;Zj(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0);i=h;return}function Zj(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+48|0;j=h+32|0;k=h+28|0;l=h+24|0;m=h+20|0;n=h+16|0;o=h+12|0;p=h+8|0;q=h+4|0;r=h;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;if((c[j>>2]|0)==0|(c[n>>2]|0)==0){i=h;return}if(!(c[c[j>>2]>>2]|0)){i=h;return}c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[(c[j>>2]|0)+4>>2]|0))break;a:do if(c[(c[c[j>>2]>>2]|0)+((c[p>>2]|0)*24|0)+20>>2]|0){c[q>>2]=(c[c[j>>2]>>2]|0)+((c[p>>2]|0)*24|0);while(1){if(!(c[q>>2]|0))break a;c[r>>2]=c[c[q>>2]>>2];if(!((c[k>>2]|0)!=0?(qy(c[k>>2]|0,c[(c[q>>2]|0)+4>>2]|0)|0)==0:0))s=10;do if((s|0)==10){s=0;if((c[l>>2]|0)!=0?(qy(c[l>>2]|0,c[(c[q>>2]|0)+8>>2]|0)|0)==0:0)break;if((c[m>>2]|0)!=0?(qy(c[m>>2]|0,c[(c[q>>2]|0)+12>>2]|0)|0)==0:0)break;if(c[(c[q>>2]|0)+16>>2]|0)xb[c[n>>2]&511](c[(c[q>>2]|0)+16>>2]|0,c[o>>2]|0,c[(c[q>>2]|0)+4>>2]|0,c[(c[q>>2]|0)+8>>2]|0,c[(c[q>>2]|0)+12>>2]|0)}while(0);c[q>>2]=c[r>>2]}}while(0);c[p>>2]=(c[p>>2]|0)+1}i=h;return}function _j(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[f>>2]=a;c[g>>2]=b;if(!(c[f>>2]|0)){c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}if(!(c[g>>2]|0)){c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}c[l>>2]=Ij(c[(c[f>>2]|0)+4>>2]|0)|0;if(!(c[l>>2]|0)){c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}a:do if(c[c[f>>2]>>2]|0){c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[(c[f>>2]|0)+4>>2]|0))break a;b:do if(c[(c[c[f>>2]>>2]|0)+((c[h>>2]|0)*24|0)+20>>2]|0){c[j>>2]=(c[c[f>>2]>>2]|0)+((c[h>>2]|0)*24|0);while(1){if(!(c[j>>2]|0))break b;c[k>>2]=c[c[j>>2]>>2];b=c[l>>2]|0;a=c[(c[j>>2]|0)+4>>2]|0;n=c[(c[j>>2]|0)+8>>2]|0;o=c[(c[j>>2]|0)+12>>2]|0;Mj(b,a,n,o,Hb[c[g>>2]&511](c[(c[j>>2]|0)+16>>2]|0,c[(c[j>>2]|0)+4>>2]|0)|0)|0;c[j>>2]=c[k>>2]}}while(0);c[h>>2]=(c[h>>2]|0)+1}}while(0);c[(c[l>>2]|0)+8>>2]=c[(c[f>>2]|0)+8>>2];c[e>>2]=c[l>>2];m=c[e>>2]|0;i=d;return m|0}function $j(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;if(!(c[e>>2]|0))c[d>>2]=-1;else c[d>>2]=c[(c[e>>2]|0)+8>>2];i=b;return c[d>>2]|0}function ak(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=bk(c[f>>2]|0,c[g>>2]|0,0,0,c[h>>2]|0)|0;i=e;return d|0}function bk(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+48|0;h=g+32|0;j=g+28|0;k=g+24|0;l=g+20|0;m=g+16|0;n=g+12|0;o=g+8|0;p=g+4|0;q=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[q>>2]=0;if((c[j>>2]|0)==0|(c[k>>2]|0)==0){c[h>>2]=-1;r=c[h>>2]|0;i=g;return r|0}c[o>>2]=dk(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0)|0;if(!(c[(c[c[j>>2]>>2]|0)+((c[o>>2]|0)*24|0)+20>>2]|0)){c[h>>2]=-1;r=c[h>>2]|0;i=g;return r|0}c[p>>2]=(c[c[j>>2]>>2]|0)+((c[o>>2]|0)*24|0);while(1){if(!(c[p>>2]|0)){s=27;break}if(((qy(c[(c[p>>2]|0)+4>>2]|0,c[k>>2]|0)|0)!=0?(qy(c[(c[p>>2]|0)+8>>2]|0,c[l>>2]|0)|0)!=0:0)?(qy(c[(c[p>>2]|0)+12>>2]|0,c[m>>2]|0)|0)!=0:0)break;c[q>>2]=c[p>>2];c[p>>2]=c[c[p>>2]>>2]}if((s|0)==27){c[h>>2]=-1;r=c[h>>2]|0;i=g;return r|0}if((c[n>>2]|0)!=0?(c[(c[p>>2]|0)+16>>2]|0)!=0:0)Ab[c[n>>2]&511](c[(c[p>>2]|0)+16>>2]|0,c[(c[p>>2]|0)+4>>2]|0);c[(c[p>>2]|0)+16>>2]=0;if(!(c[(c[j>>2]|0)+12>>2]|0)){if(c[(c[p>>2]|0)+4>>2]|0)zb[c[135736>>2]&511](c[(c[p>>2]|0)+4>>2]|0);if(c[(c[p>>2]|0)+8>>2]|0)zb[c[135736>>2]&511](c[(c[p>>2]|0)+8>>2]|0);if(c[(c[p>>2]|0)+12>>2]|0)zb[c[135736>>2]&511](c[(c[p>>2]|0)+12>>2]|0)}n=c[c[p>>2]>>2]|0;do if(!(c[q>>2]|0)){s=c[p>>2]|0;if(!n){c[s+20>>2]=0;break}else{c[p>>2]=c[s>>2];s=(c[c[j>>2]>>2]|0)+((c[o>>2]|0)*24|0)|0;m=c[p>>2]|0;c[s+0>>2]=c[m+0>>2];c[s+4>>2]=c[m+4>>2];c[s+8>>2]=c[m+8>>2];c[s+12>>2]=c[m+12>>2];c[s+16>>2]=c[m+16>>2];c[s+20>>2]=c[m+20>>2];zb[c[135736>>2]&511](c[p>>2]|0);break}}else{c[c[q>>2]>>2]=n;zb[c[135736>>2]&511](c[p>>2]|0)}while(0);p=(c[j>>2]|0)+8|0;c[p>>2]=(c[p>>2]|0)+-1;c[h>>2]=0;r=c[h>>2]|0;i=g;return r|0}function ck(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;e=bk(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0,0,c[k>>2]|0)|0;i=f;return e|0}function dk(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+32|0;j=h+16|0;k=h+12|0;l=h+8|0;m=h+4|0;n=h;o=h+20|0;c[j>>2]=b;c[k>>2]=e;c[l>>2]=f;c[m>>2]=g;c[n>>2]=0;c[n>>2]=c[(c[j>>2]|0)+16>>2];a:do if(c[k>>2]|0){c[n>>2]=(c[n>>2]|0)+((d[c[k>>2]>>0]|0)*30|0);while(1){g=c[k>>2]|0;c[k>>2]=g+1;f=a[g>>0]|0;a[o>>0]=f;if(!(f<<24>>24))break a;c[n>>2]=c[n>>2]^(c[n>>2]<<5)+((c[n>>2]|0)>>>3)+(a[o>>0]|0)}}while(0);c[n>>2]=c[n>>2]^(c[n>>2]<<5)+((c[n>>2]|0)>>>3);b:do if(c[l>>2]|0)while(1){k=c[l>>2]|0;c[l>>2]=k+1;f=a[k>>0]|0;a[o>>0]=f;if(!(f<<24>>24))break b;c[n>>2]=c[n>>2]^(c[n>>2]<<5)+((c[n>>2]|0)>>>3)+(a[o>>0]|0)}while(0);c[n>>2]=c[n>>2]^(c[n>>2]<<5)+((c[n>>2]|0)>>>3);if(!(c[m>>2]|0)){p=c[n>>2]|0;q=c[j>>2]|0;r=q+4|0;s=c[r>>2]|0;t=(p>>>0)%(s>>>0)|0;i=h;return t|0}while(1){l=c[m>>2]|0;c[m>>2]=l+1;f=a[l>>0]|0;a[o>>0]=f;if(!(f<<24>>24))break;c[n>>2]=c[n>>2]^(c[n>>2]<<5)+((c[n>>2]|0)>>>3)+(a[o>>0]|0)}p=c[n>>2]|0;q=c[j>>2]|0;r=q+4|0;s=c[r>>2]|0;t=(p>>>0)%(s>>>0)|0;i=h;return t|0}function ek(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+48|0;e=d+32|0;f=d+28|0;g=d+24|0;h=d+20|0;j=d+16|0;k=d+12|0;l=d+8|0;m=d+4|0;n=d;c[f>>2]=a;c[g>>2]=b;if(!(c[f>>2]|0)){c[e>>2]=-1;o=c[e>>2]|0;i=d;return o|0}if((c[g>>2]|0)<8){c[e>>2]=-1;o=c[e>>2]|0;i=d;return o|0}if((c[g>>2]|0)>16384){c[e>>2]=-1;o=c[e>>2]|0;i=d;return o|0}c[j>>2]=c[(c[f>>2]|0)+4>>2];c[n>>2]=c[c[f>>2]>>2];if(!(c[n>>2]|0)){c[e>>2]=-1;o=c[e>>2]|0;i=d;return o|0}b=Cb[c[135744>>2]&511]((c[g>>2]|0)*24|0)|0;c[c[f>>2]>>2]=b;if(!(c[c[f>>2]>>2]|0)){c[c[f>>2]>>2]=c[n>>2];c[e>>2]=-1;o=c[e>>2]|0;i=d;return o|0}cU(c[c[f>>2]>>2]|0,0,(c[g>>2]|0)*24|0)|0;c[(c[f>>2]|0)+4>>2]=c[g>>2];c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[j>>2]|0))break;if(c[(c[n>>2]|0)+((c[k>>2]|0)*24|0)+20>>2]|0){c[h>>2]=dk(c[f>>2]|0,c[(c[n>>2]|0)+((c[k>>2]|0)*24|0)+4>>2]|0,c[(c[n>>2]|0)+((c[k>>2]|0)*24|0)+8>>2]|0,c[(c[n>>2]|0)+((c[k>>2]|0)*24|0)+12>>2]|0)|0;g=(c[c[f>>2]>>2]|0)+((c[h>>2]|0)*24|0)|0;b=(c[n>>2]|0)+((c[k>>2]|0)*24|0)|0;c[g+0>>2]=c[b+0>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];c[g+16>>2]=c[b+16>>2];c[g+20>>2]=c[b+20>>2];c[(c[c[f>>2]>>2]|0)+((c[h>>2]|0)*24|0)>>2]=0}c[k>>2]=(c[k>>2]|0)+1}c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[j>>2]|0))break;c[l>>2]=c[(c[n>>2]|0)+((c[k>>2]|0)*24|0)>>2];while(1){if(!(c[l>>2]|0))break;c[m>>2]=c[c[l>>2]>>2];c[h>>2]=dk(c[f>>2]|0,c[(c[l>>2]|0)+4>>2]|0,c[(c[l>>2]|0)+8>>2]|0,c[(c[l>>2]|0)+12>>2]|0)|0;b=(c[c[f>>2]>>2]|0)+((c[h>>2]|0)*24|0)|0;if(!(c[(c[c[f>>2]>>2]|0)+((c[h>>2]|0)*24|0)+20>>2]|0)){g=c[l>>2]|0;c[b+0>>2]=c[g+0>>2];c[b+4>>2]=c[g+4>>2];c[b+8>>2]=c[g+8>>2];c[b+12>>2]=c[g+12>>2];c[b+16>>2]=c[g+16>>2];c[b+20>>2]=c[g+20>>2];c[(c[c[f>>2]>>2]|0)+((c[h>>2]|0)*24|0)>>2]=0;zb[c[135736>>2]&511](c[l>>2]|0)}else{c[c[l>>2]>>2]=c[b>>2];c[(c[c[f>>2]>>2]|0)+((c[h>>2]|0)*24|0)>>2]=c[l>>2]}c[l>>2]=c[m>>2]}c[k>>2]=(c[k>>2]|0)+1}zb[c[135736>>2]&511](c[n>>2]|0);c[e>>2]=0;o=c[e>>2]|0;i=d;return o|0}function fk(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;l=i;i=i+48|0;m=l+28|0;n=l+24|0;o=l+20|0;p=l+16|0;q=l+12|0;r=l+8|0;s=l+4|0;t=l;u=l+32|0;c[m>>2]=b;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=h;c[r>>2]=j;c[s>>2]=k;c[t>>2]=0;c[t>>2]=c[(c[m>>2]|0)+16>>2];if(c[n>>2]|0)c[t>>2]=(c[t>>2]|0)+((d[c[n>>2]>>0]|0)*30|0);else c[t>>2]=(c[t>>2]|0)+((d[c[o>>2]>>0]|0)*30|0);if(c[n>>2]|0){while(1){k=c[n>>2]|0;c[n>>2]=k+1;j=a[k>>0]|0;a[u>>0]=j;v=c[t>>2]|0;w=(c[t>>2]<<5)+((c[t>>2]|0)>>>3)|0;if(!(j<<24>>24))break;c[t>>2]=v^w+(a[u>>0]|0)}c[t>>2]=v^w+58}a:do if(c[o>>2]|0)while(1){w=c[o>>2]|0;c[o>>2]=w+1;v=a[w>>0]|0;a[u>>0]=v;if(!(v<<24>>24))break a;c[t>>2]=c[t>>2]^(c[t>>2]<<5)+((c[t>>2]|0)>>>3)+(a[u>>0]|0)}while(0);c[t>>2]=c[t>>2]^(c[t>>2]<<5)+((c[t>>2]|0)>>>3);if(c[p>>2]|0){while(1){o=c[p>>2]|0;c[p>>2]=o+1;v=a[o>>0]|0;a[u>>0]=v;x=c[t>>2]|0;y=(c[t>>2]<<5)+((c[t>>2]|0)>>>3)|0;if(!(v<<24>>24))break;c[t>>2]=x^y+(a[u>>0]|0)}c[t>>2]=x^y+58}b:do if(c[q>>2]|0)while(1){y=c[q>>2]|0;c[q>>2]=y+1;x=a[y>>0]|0;a[u>>0]=x;if(!(x<<24>>24))break b;c[t>>2]=c[t>>2]^(c[t>>2]<<5)+((c[t>>2]|0)>>>3)+(a[u>>0]|0)}while(0);c[t>>2]=c[t>>2]^(c[t>>2]<<5)+((c[t>>2]|0)>>>3);if(c[r>>2]|0){while(1){q=c[r>>2]|0;c[r>>2]=q+1;x=a[q>>0]|0;a[u>>0]=x;z=c[t>>2]|0;A=(c[t>>2]<<5)+((c[t>>2]|0)>>>3)|0;if(!(x<<24>>24))break;c[t>>2]=z^A+(a[u>>0]|0)}c[t>>2]=z^A+58}if(!(c[s>>2]|0)){B=c[t>>2]|0;C=c[m>>2]|0;D=C+4|0;E=c[D>>2]|0;F=(B>>>0)%(E>>>0)|0;i=l;return F|0}while(1){A=c[s>>2]|0;c[s>>2]=A+1;z=a[A>>0]|0;a[u>>0]=z;if(!(z<<24>>24))break;c[t>>2]=c[t>>2]^(c[t>>2]<<5)+((c[t>>2]|0)>>>3)+(a[u>>0]|0)}B=c[t>>2]|0;C=c[m>>2]|0;D=C+4|0;E=c[D>>2]|0;F=(B>>>0)%(E>>>0)|0;i=l;return F|0}function gk(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[g+8>>2]=e;c[g+4>>2]=f;c[l>>2]=c[j>>2];Db[c[c[l>>2]>>2]&511](c[h>>2]|0,c[(c[l>>2]|0)+4>>2]|0,c[k>>2]|0);i=g;return}function hk(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;do if(!(c[g>>2]|0)){if(!(c[(_a()|0)>>2]|0)){c[g>>2]=0;break}if((c[(_a()|0)>>2]|0)==13){c[g>>2]=1501;break}if((c[(_a()|0)>>2]|0)==11){c[g>>2]=1502;break}if((c[(_a()|0)>>2]|0)==9){c[g>>2]=1503;break}if((c[(_a()|0)>>2]|0)==74){c[g>>2]=1504;break}if((c[(_a()|0)>>2]|0)==16){c[g>>2]=1505;break}if((c[(_a()|0)>>2]|0)==125){c[g>>2]=1506;break}if((c[(_a()|0)>>2]|0)==10){c[g>>2]=1507;break}if((c[(_a()|0)>>2]|0)==35){c[g>>2]=1508;break}if((c[(_a()|0)>>2]|0)==33){c[g>>2]=1509;break}if((c[(_a()|0)>>2]|0)==17){c[g>>2]=1510;break}if((c[(_a()|0)>>2]|0)==14){c[g>>2]=1511;break}if((c[(_a()|0)>>2]|0)==27){c[g>>2]=1512;break}if((c[(_a()|0)>>2]|0)==115){c[g>>2]=1513;break}if((c[(_a()|0)>>2]|0)==4){c[g>>2]=1514;break}if((c[(_a()|0)>>2]|0)==22){c[g>>2]=1515;break}if((c[(_a()|0)>>2]|0)==5){c[g>>2]=1516;break}if((c[(_a()|0)>>2]|0)==21){c[g>>2]=1517;break}if((c[(_a()|0)>>2]|0)==24){c[g>>2]=1518;break}if((c[(_a()|0)>>2]|0)==31){c[g>>2]=1519;break}if((c[(_a()|0)>>2]|0)==90){c[g>>2]=1520;break}if((c[(_a()|0)>>2]|0)==36){c[g>>2]=1521;break}if((c[(_a()|0)>>2]|0)==23){c[g>>2]=1522;break}if((c[(_a()|0)>>2]|0)==19){c[g>>2]=1523;break}if((c[(_a()|0)>>2]|0)==2){c[g>>2]=1524;break}if((c[(_a()|0)>>2]|0)==8){c[g>>2]=1525;break}if((c[(_a()|0)>>2]|0)==37){c[g>>2]=1526;break}if((c[(_a()|0)>>2]|0)==12){c[g>>2]=1527;break}if((c[(_a()|0)>>2]|0)==28){c[g>>2]=1528;break}if((c[(_a()|0)>>2]|0)==38){c[g>>2]=1529;break}if((c[(_a()|0)>>2]|0)==20){c[g>>2]=1530;break}if((c[(_a()|0)>>2]|0)==39){c[g>>2]=1531;break}if((c[(_a()|0)>>2]|0)==95){c[g>>2]=1532;break}if((c[(_a()|0)>>2]|0)==25){c[g>>2]=1533;break}if((c[(_a()|0)>>2]|0)==6){c[g>>2]=1534;break}if((c[(_a()|0)>>2]|0)==1){c[g>>2]=1535;break}if((c[(_a()|0)>>2]|0)==32){c[g>>2]=1536;break}if((c[(_a()|0)>>2]|0)==34){c[g>>2]=1537;break}if((c[(_a()|0)>>2]|0)==30){c[g>>2]=1538;break}if((c[(_a()|0)>>2]|0)==29){c[g>>2]=1539;break}if((c[(_a()|0)>>2]|0)==3){c[g>>2]=1540;break}if((c[(_a()|0)>>2]|0)==110){c[g>>2]=1541;break}if((c[(_a()|0)>>2]|0)==18){c[g>>2]=1542;break}if((c[(_a()|0)>>2]|0)==88){
c[g>>2]=1550;break}if((c[(_a()|0)>>2]|0)==106){c[g>>2]=1551;break}if((c[(_a()|0)>>2]|0)==111){c[g>>2]=1552;break}if((c[(_a()|0)>>2]|0)==110){c[g>>2]=1541;break}if((c[(_a()|0)>>2]|0)==101){c[g>>2]=1553;break}if((c[(_a()|0)>>2]|0)==98){c[g>>2]=1554;break}if((c[(_a()|0)>>2]|0)==115){c[g>>2]=1513;break}if((c[(_a()|0)>>2]|0)==114){c[g>>2]=1555;break}if((c[(_a()|0)>>2]|0)==97){c[g>>2]=1556;break}else{c[g>>2]=1500;break}}while(0);c[j>>2]=0;if((c[g>>2]|0)>=1500)c[j>>2]=(c[g>>2]|0)-1500;if((c[j>>2]|0)>>>0<57){k=c[f>>2]|0;l=c[g>>2]|0;m=c[j>>2]|0;n=76128+(m<<2)|0;o=c[n>>2]|0;p=c[h>>2]|0;ce(k,l,0,o,p);i=e;return}c[j>>2]=0;k=c[f>>2]|0;l=c[g>>2]|0;m=c[j>>2]|0;n=76128+(m<<2)|0;o=c[n>>2]|0;p=c[h>>2]|0;ce(k,l,0,o,p);i=e;return}function ik(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+48|0;f=e;g=e+32|0;h=e+28|0;j=e+24|0;k=e+20|0;l=e+16|0;m=e+12|0;n=e+8|0;o=e+4|0;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=c[g>>2];c[l>>2]=0;c[m>>2]=0;c[n>>2]=0;c[o>>2]=2;if(((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+212>>2]|0)!=0:0)?(c[(c[k>>2]|0)+172>>2]|0)==-1:0){i=e;return}if((c[k>>2]|0)!=0?(c[c[k>>2]>>2]|0)!=0:0){g=c[c[k>>2]>>2]|0;if(c[(c[k>>2]|0)+104>>2]|0){c[m>>2]=c[g+88>>2];c[o>>2]=2}else{c[m>>2]=c[g+84>>2];c[o>>2]=1}if((c[(c[c[k>>2]>>2]|0)+108>>2]|0)==-554844497)c[l>>2]=c[(c[c[k>>2]>>2]|0)+124>>2];c[n>>2]=c[(c[k>>2]|0)+4>>2]}g=c[l>>2]|0;l=c[m>>2]|0;m=c[n>>2]|0;n=c[k>>2]|0;k=c[o>>2]|0;o=c[j>>2]|0;d=c[h>>2]|0;c[f>>2]=c[j>>2];Xd(g,l,m,n,0,8,1549,k,0,0,o,0,0,0,0,d,f);i=e;return}function jk(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(c[19090]|0)){i=a;return}c[b>>2]=(c[19092]|0)-1;while(1){if((c[b>>2]|0)<0)break;c[76376+(c[b>>2]<<4)>>2]=0;c[76380+(c[b>>2]<<4)>>2]=0;c[76384+(c[b>>2]<<4)>>2]=0;c[76388+(c[b>>2]<<4)>>2]=0;c[b>>2]=(c[b>>2]|0)+-1}c[19092]=0;c[19090]=0;i=a;return}function kk(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(c[19154]|0)){i=a;return}c[b>>2]=(c[19156]|0)-1;while(1){if((c[b>>2]|0)<0)break;c[76632+(c[b>>2]<<4)>>2]=0;c[76636+(c[b>>2]<<4)>>2]=0;c[76640+(c[b>>2]<<4)>>2]=0;c[76644+(c[b>>2]<<4)>>2]=0;c[b>>2]=(c[b>>2]|0)+-1}c[19156]=0;c[19154]=0;i=a;return}function lk(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+96|0;d=b+80|0;e=b+76|0;f=b;c[e>>2]=a;do if(c[e>>2]|0){if(($a(c[e>>2]|0,f|0)|0)==-1){c[d>>2]=0;break}if((c[f+12>>2]&61440|0)==16384){c[d>>2]=2;break}else{c[d>>2]=1;break}}else c[d>>2]=0;while(0);i=b;return c[d>>2]|0}function mk(){return 0}function nk(a){a=a|0;var b=0;b=i;i=i+16|0;c[b>>2]=a;i=b;return 1}function ok(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[f>>2]=Yk(c[d>>2]|0)|0;if(c[f>>2]|0){g=c[f>>2]|0;i=b;return g|0}c[e>>2]=El(c[d>>2]|0,0,0)|0;if(!(c[e>>2]|0)){g=c[f>>2]|0;i=b;return g|0}c[f>>2]=Yk(c[e>>2]|0)|0;zb[c[135736>>2]&511](c[e>>2]|0);g=c[f>>2]|0;i=b;return g|0}function pk(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if((c[g>>2]|0)==0|(c[h>>2]|0)==0){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}c[k>>2]=Aa(c[h>>2]|0,1,c[j>>2]|0,c[g>>2]|0)|0;if((c[k>>2]|0)<0)Zk(0,76872);c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}function qk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;if(!(c[e>>2]|0)){c[d>>2]=-1;h=c[d>>2]|0;i=b;return h|0}c[f>>2]=c[e>>2];if((c[f>>2]|0)!=(c[q>>2]|0)?(c[f>>2]|0)!=(c[o>>2]|0):0){if((c[f>>2]|0)==(c[p>>2]|0)){c[d>>2]=0;h=c[d>>2]|0;i=b;return h|0}a=(Xa(c[e>>2]|0)|0)==-1;c[g>>2]=a?-1:0;if((c[g>>2]|0)<0)Zk(0,76896);c[d>>2]=c[g>>2];h=c[d>>2]|0;i=b;return h|0}c[g>>2]=Ga(c[f>>2]|0)|0;if((c[g>>2]|0)<0)Zk(0,76880);c[d>>2]=0;h=c[d>>2]|0;i=b;return h|0}function rk(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if((c[19092]|0)>=15){c[g>>2]=-1;m=c[g>>2]|0;i=f;return m|0}else{c[76376+(c[19092]<<4)>>2]=c[h>>2];c[76380+(c[19092]<<4)>>2]=c[j>>2];c[76384+(c[19092]<<4)>>2]=c[k>>2];c[76388+(c[19092]<<4)>>2]=c[l>>2];c[19090]=1;l=c[19092]|0;c[19092]=l+1;c[g>>2]=l;m=c[g>>2]|0;i=f;return m|0}return 0}function sk(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if((c[19156]|0)>=15){c[g>>2]=-1;m=c[g>>2]|0;i=f;return m|0}else{c[76632+(c[19156]<<4)>>2]=c[h>>2];c[76636+(c[19156]<<4)>>2]=c[j>>2];c[76640+(c[19156]<<4)>>2]=c[k>>2];c[76644+(c[19156]<<4)>>2]=c[l>>2];c[19154]=1;l=c[19156]|0;c[19156]=l+1;c[g>>2]=l;m=c[g>>2]|0;i=f;return m|0}return 0}function tk(){var a=0;a=i;if(c[19090]|0){i=a;return}rk(230,231,232,233)|0;c[19090]=1;i=a;return}function uk(){var a=0;a=i;if(c[19154]|0){i=a;return}sk(230,234,235,233)|0;c[19154]=1;i=a;return}function vk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](36)|0;if(!(c[f>>2]|0)){al(76912);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}a=(c[f>>2]|0)+0|0;h=a+36|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(h|0));a=My(c[33950]<<1)|0;c[(c[f>>2]|0)+16>>2]=a;if(!(c[(c[f>>2]|0)+16>>2]|0)){zb[c[135736>>2]&511](c[f>>2]|0);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}Qy(c[(c[f>>2]|0)+16>>2]|0,0)|0;a=Cd(c[e>>2]|0)|0;c[(c[f>>2]|0)+12>>2]=a;if(c[(c[f>>2]|0)+12>>2]|0){a=My(c[33950]<<1)|0;c[(c[f>>2]|0)+20>>2]=a}else c[(c[f>>2]|0)+20>>2]=0;c[(c[f>>2]|0)+4>>2]=0;c[(c[f>>2]|0)+8>>2]=0;c[c[f>>2]>>2]=0;c[(c[f>>2]|0)+24>>2]=-1;c[(c[f>>2]|0)+32>>2]=0;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}function wk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](32)|0;if(!(c[f>>2]|0)){al(76936);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}a=c[f>>2]|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;c[a+24>>2]=0;c[a+28>>2]=0;a=Ly()|0;c[(c[f>>2]|0)+16>>2]=a;if(!(c[(c[f>>2]|0)+16>>2]|0)){zb[c[135736>>2]&511](c[f>>2]|0);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}if((Py(c[(c[f>>2]|0)+16>>2]|0)|0)==1)Qy(c[(c[f>>2]|0)+16>>2]|0,0)|0;c[(c[f>>2]|0)+12>>2]=c[e>>2];do if(c[e>>2]|0){a=My(4e3)|0;c[(c[f>>2]|0)+20>>2]=a;if(c[(c[f>>2]|0)+20>>2]|0){Gd(c[f>>2]|0,1)|0;break}zb[c[135736>>2]&511](c[f>>2]|0);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else c[(c[f>>2]|0)+20>>2]=0;while(0);c[(c[f>>2]|0)+4>>2]=0;c[(c[f>>2]|0)+8>>2]=0;c[c[f>>2]>>2]=0;c[(c[f>>2]|0)+24>>2]=0;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}function xk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](32)|0;if(!(c[f>>2]|0)){al(76936);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}a=c[f>>2]|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;c[a+24>>2]=0;c[a+28>>2]=0;a=Ly()|0;c[(c[f>>2]|0)+16>>2]=a;if(!(c[(c[f>>2]|0)+16>>2]|0)){zb[c[135736>>2]&511](c[f>>2]|0);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}Qy(c[(c[f>>2]|0)+16>>2]|0,3)|0;c[(c[f>>2]|0)+12>>2]=c[e>>2];do if(c[e>>2]|0){a=My(4e3)|0;c[(c[f>>2]|0)+20>>2]=a;if(c[(c[f>>2]|0)+20>>2]|0){Gd(c[f>>2]|0,1)|0;break}zb[c[135736>>2]&511](c[f>>2]|0);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else c[(c[f>>2]|0)+20>>2]=0;while(0);c[(c[f>>2]|0)+4>>2]=0;c[(c[f>>2]|0)+8>>2]=0;c[c[f>>2]>>2]=0;c[(c[f>>2]|0)+24>>2]=0;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}function yk(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+20>>2]|0){Ry(c[(c[d>>2]|0)+20>>2]|0);c[(c[d>>2]|0)+20>>2]=0}if(c[(c[d>>2]|0)+12>>2]|0)Hd(c[(c[d>>2]|0)+12>>2]|0)|0;if(c[(c[d>>2]|0)+8>>2]|0)Cb[c[(c[d>>2]|0)+8>>2]&511](c[c[d>>2]>>2]|0)|0;if(c[(c[d>>2]|0)+16>>2]|0){Ry(c[(c[d>>2]|0)+16>>2]|0);c[(c[d>>2]|0)+16>>2]=0}zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function zk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;c[g>>2]=0;if(!(c[e>>2]|0)){c[d>>2]=-1;h=c[d>>2]|0;i=b;return h|0}if(c[(c[e>>2]|0)+4>>2]|0)Ak(c[e>>2]|0)|0;if(c[(c[e>>2]|0)+8>>2]|0)c[g>>2]=Cb[c[(c[e>>2]|0)+8>>2]&511](c[c[e>>2]>>2]|0)|0;c[f>>2]=c[(c[e>>2]|0)+24>>2];if(c[(c[e>>2]|0)+20>>2]|0){Ry(c[(c[e>>2]|0)+20>>2]|0);c[(c[e>>2]|0)+20>>2]=0}if(c[(c[e>>2]|0)+12>>2]|0)Hd(c[(c[e>>2]|0)+12>>2]|0)|0;if(c[(c[e>>2]|0)+16>>2]|0){Ry(c[(c[e>>2]|0)+16>>2]|0);c[(c[e>>2]|0)+16>>2]=0}if(c[(c[e>>2]|0)+28>>2]|0)c[g>>2]=-1;zb[c[135736>>2]&511](c[e>>2]|0);c[d>>2]=(c[g>>2]|0)==0?c[f>>2]|0:c[g>>2]|0;h=c[d>>2]|0;i=b;return h|0}function Ak(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;c[f>>2]=0;c[g>>2]=0;if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+28>>2]|0)==0:0){a:do if((c[(c[e>>2]|0)+20>>2]|0)!=0?(c[(c[e>>2]|0)+12>>2]|0)!=0:0){while(1){c[f>>2]=Gd(c[e>>2]|0,0)|0;if((c[f>>2]|0)<0)break;if(!(c[f>>2]|0))break a}Zk(1544,0);c[(c[e>>2]|0)+28>>2]=1544;c[d>>2]=-1;h=c[d>>2]|0;i=b;return h|0}while(0);if(((c[(c[e>>2]|0)+20>>2]|0)!=0?(c[(c[e>>2]|0)+12>>2]|0)!=0:0)?(c[(c[e>>2]|0)+4>>2]|0)!=0:0){f=c[(c[e>>2]|0)+4>>2]|0;a=c[c[e>>2]>>2]|0;j=Vy(c[(c[e>>2]|0)+20>>2]|0)|0;k=_y(c[(c[e>>2]|0)+20>>2]|0)|0;c[g>>2]=vb[f&511](a,j,k)|0;if((c[g>>2]|0)>=0)Ty(c[(c[e>>2]|0)+20>>2]|0,c[g>>2]|0)|0}else l=14;if(((l|0)==14?(c[(c[e>>2]|0)+4>>2]|0)!=0:0)?(l=c[(c[e>>2]|0)+4>>2]|0,k=c[c[e>>2]>>2]|0,j=Vy(c[(c[e>>2]|0)+16>>2]|0)|0,a=_y(c[(c[e>>2]|0)+16>>2]|0)|0,c[g>>2]=vb[l&511](k,j,a)|0,(c[g>>2]|0)>=0):0)Ty(c[(c[e>>2]|0)+16>>2]|0,c[g>>2]|0)|0;if((c[g>>2]|0)<0){Zk(1545,0);c[(c[e>>2]|0)+28>>2]=1545;c[d>>2]=c[g>>2];h=c[d>>2]|0;i=b;return h|0}else{a=(c[e>>2]|0)+24|0;c[a>>2]=(c[a>>2]|0)+(c[g>>2]|0);c[d>>2]=c[g>>2];h=c[d>>2]|0;i=b;return h|0}}c[d>>2]=-1;h=c[d>>2]|0;i=b;return h|0}function Bk(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;c[j>>2]=0;c[k>>2]=0;if(!(c[19090]|0))tk();if(!(c[f>>2]|0)){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}a:do if(!(c[k>>2]|0)){c[j>>2]=(c[19092]|0)-1;while(1){if((c[j>>2]|0)<0)break a;if(((c[76376+(c[j>>2]<<4)>>2]|0)!=0?(Cb[c[76376+(c[j>>2]<<4)>>2]&511](c[f>>2]|0)|0)!=0:0)?(c[k>>2]=Cb[c[76376+(c[j>>2]<<4)+4>>2]&511](c[f>>2]|0)|0,(c[k>>2]|0)!=0):0)break a;c[j>>2]=(c[j>>2]|0)+-1}}while(0);if(!(c[k>>2]|0)){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}c[h>>2]=vk(c[g>>2]|0)|0;if(c[h>>2]|0){c[c[h>>2]>>2]=c[k>>2];c[(c[h>>2]|0)+4>>2]=c[76384+(c[j>>2]<<4)>>2];c[(c[h>>2]|0)+8>>2]=c[76388+(c[j>>2]<<4)>>2]}else Cb[c[76376+(c[j>>2]<<4)+12>>2]&511](c[k>>2]|0)|0;c[e>>2]=c[h>>2];l=c[e>>2]|0;i=d;return l|0}function Ck(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if(c[33972]|0){c[e>>2]=Hb[c[135888>>2]&511](c[f>>2]|0,c[g>>2]|0)|0;h=c[e>>2]|0;i=d;return h|0}else{c[e>>2]=Bk(c[f>>2]|0,c[g>>2]|0)|0;h=c[e>>2]|0;i=d;return h|0}return 0}function Dk(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+48|0;f=e+32|0;g=e+28|0;h=e+24|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;n=e;c[g>>2]=a;c[h>>2]=b;c[e+20>>2]=d;c[l>>2]=0;c[m>>2]=0;c[n>>2]=0;if(!(c[19154]|0))uk();if(!(c[g>>2]|0)){c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}c[k>>2]=yl(c[g>>2]|0)|0;if(c[k>>2]|0){if(!((c[c[k>>2]>>2]|0)!=0?(qy(c[c[k>>2]>>2]|0,76960)|0)==0:0))c[n>>2]=El(c[g>>2]|0,0,0)|0;Al(c[k>>2]|0)}if(c[n>>2]|0){c[l>>2]=(c[19156]|0)-1;while(1){if((c[l>>2]|0)<0)break;if(((c[76632+(c[l>>2]<<4)>>2]|0)!=0?(Cb[c[76632+(c[l>>2]<<4)>>2]&511](c[n>>2]|0)|0)!=0:0)?(c[m>>2]=Cb[c[76632+(c[l>>2]<<4)+4>>2]&511](c[n>>2]|0)|0,(c[m>>2]|0)!=0):0)break;c[l>>2]=(c[l>>2]|0)+-1}zb[c[135736>>2]&511](c[n>>2]|0)}a:do if(!(c[m>>2]|0)){c[l>>2]=(c[19156]|0)-1;while(1){if((c[l>>2]|0)<0)break a;if(((c[76632+(c[l>>2]<<4)>>2]|0)!=0?(Cb[c[76632+(c[l>>2]<<4)>>2]&511](c[g>>2]|0)|0)!=0:0)?(c[m>>2]=Cb[c[76632+(c[l>>2]<<4)+4>>2]&511](c[g>>2]|0)|0,(c[m>>2]|0)!=0):0)break a;c[l>>2]=(c[l>>2]|0)+-1}}while(0);if(!(c[m>>2]|0)){c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}c[j>>2]=xk(c[h>>2]|0)|0;if(c[j>>2]|0){c[c[j>>2]>>2]=c[m>>2];c[(c[j>>2]|0)+4>>2]=c[76640+(c[l>>2]<<4)>>2];c[(c[j>>2]|0)+8>>2]=c[76644+(c[l>>2]<<4)>>2]}c[f>>2]=c[j>>2];o=c[f>>2]|0;i=e;return o|0}function Ek(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(c[33974]|0){c[f>>2]=vb[c[135896>>2]&511](c[g>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;k=c[f>>2]|0;i=e;return k|0}else{c[f>>2]=Dk(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;k=c[f>>2]|0;i=e;return k|0}return 0}function Fk(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if(!(c[19154]|0))uk();if(!(c[f>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}c[h>>2]=xk(c[g>>2]|0)|0;if(c[h>>2]|0){c[c[h>>2]>>2]=c[f>>2];c[(c[h>>2]|0)+4>>2]=235;c[(c[h>>2]|0)+8>>2]=236}c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}function Gk(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)<0){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}c[h>>2]=vk(c[g>>2]|0)|0;if(c[h>>2]|0){c[c[h>>2]>>2]=c[f>>2];c[(c[h>>2]|0)+4>>2]=237;c[(c[h>>2]|0)+8>>2]=238}c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}function Hk(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if((c[h>>2]|0)<=0){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}if(!(c[g>>2]|0)){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}c[k>>2]=vk(c[j>>2]|0)|0;if((c[k>>2]|0)!=0?(c[c[k>>2]>>2]=c[g>>2],c[(c[k>>2]|0)+4>>2]=227,c[(c[k>>2]|0)+8>>2]=0,c[l>>2]=cz(c[(c[k>>2]|0)+16>>2]|0,c[g>>2]|0,c[h>>2]|0)|0,(c[l>>2]|0)!=0):0){zb[c[135736>>2]&511](c[k>>2]|0);c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}c[f>>2]=c[k>>2];m=c[f>>2]|0;i=e;return m|0}function Ik(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if((c[h>>2]|0)<=0){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}if(!(c[g>>2]|0)){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}c[k>>2]=Cb[c[135744>>2]&511](36)|0;if(!(c[k>>2]|0)){al(76912);c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}d=(c[k>>2]|0)+0|0;b=d+36|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(b|0));d=Oy(c[g>>2]|0,c[h>>2]|0)|0;c[(c[k>>2]|0)+16>>2]=d;if(!(c[(c[k>>2]|0)+16>>2]|0)){zb[c[135736>>2]&511](c[k>>2]|0);c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}d=Cd(c[j>>2]|0)|0;c[(c[k>>2]|0)+12>>2]=d;if(c[(c[k>>2]|0)+12>>2]|0){d=My(c[33950]<<1)|0;c[(c[k>>2]|0)+20>>2]=d}else c[(c[k>>2]|0)+20>>2]=0;c[(c[k>>2]|0)+24>>2]=-1;c[c[k>>2]>>2]=c[g>>2];c[(c[k>>2]|0)+4>>2]=0;c[(c[k>>2]|0)+8>>2]=0;c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}function Jk(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)<0){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}c[h>>2]=xk(c[g>>2]|0)|0;if(c[h>>2]|0){c[c[h>>2]>>2]=c[f>>2];c[(c[h>>2]|0)+4>>2]=239;c[(c[h>>2]|0)+8>>2]=0}c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}function Kk(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if(!(c[h>>2]|0)){c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}c[m>>2]=vk(c[l>>2]|0)|0;if(c[m>>2]|0){c[c[m>>2]>>2]=c[k>>2];c[(c[m>>2]|0)+4>>2]=c[h>>2];c[(c[m>>2]|0)+8>>2]=c[j>>2]}c[g>>2]=c[m>>2];n=c[g>>2]|0;i=f;return n|0}function Lk(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=0;if((c[h>>2]|0)<0){c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+28>>2]|0)==0:0){do if(!(c[(c[g>>2]|0)+12>>2]|0)){c[k>>2]=c[h>>2];c[l>>2]=cz(c[(c[g>>2]|0)+16>>2]|0,c[j>>2]|0,c[k>>2]|0)|0;if(c[l>>2]|0){c[f>>2]=-1;n=c[f>>2]|0;i=e;return n|0}}else{if(!(c[(c[g>>2]|0)+20>>2]|0)){d=Ly()|0;c[(c[g>>2]|0)+20>>2]=d}c[l>>2]=cz(c[(c[g>>2]|0)+20>>2]|0,c[j>>2]|0,c[h>>2]|0)|0;if(c[l>>2]|0){c[f>>2]=-1;n=c[f>>2]|0;i=e;return n|0}c[m>>2]=_y(c[(c[g>>2]|0)+20>>2]|0)|0;c[k>>2]=Fd(c[g>>2]|0,1)|0;if((c[k>>2]|0)>=0){d=c[m>>2]|0;b=d-(_y(c[(c[g>>2]|0)+20>>2]|0)|0)|0;d=(c[g>>2]|0)+32|0;c[d>>2]=(c[d>>2]|0)+b;break}Zk(1544,0);c[(c[g>>2]|0)+28>>2]=1544;c[f>>2]=-1;n=c[f>>2]|0;i=e;return n|0}while(0);c[f>>2]=c[k>>2];n=c[f>>2]|0;i=e;return n|0}c[f>>2]=-1;n=c[f>>2]|0;i=e;return n|0}function Mk(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;c[j>>2]=0;c[k>>2]=0;if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+28>>2]|0)==0:0){if((c[g>>2]|0)<=4e3&(c[g>>2]|0)!=4)c[g>>2]=4e3;if(($y(c[(c[f>>2]|0)+16>>2]|0)|0)>>>0<=0){Zk(1548,0);c[(c[f>>2]|0)+28>>2]=1548;c[e>>2]=-1;m=c[e>>2]|0;i=d;return m|0}if((Uy(c[(c[f>>2]|0)+16>>2]|0,(c[g>>2]|0)+1|0)|0)<0){al(76968);c[(c[f>>2]|0)+28>>2]=2;c[e>>2]=-1;m=c[e>>2]|0;i=d;return m|0}c[h>>2]=Wy(c[(c[f>>2]|0)+16>>2]|0)|0;if(!(c[(c[f>>2]|0)+4>>2]|0)){Zk(1547,0);c[(c[f>>2]|0)+28>>2]=1547;c[e>>2]=-1;m=c[e>>2]|0;i=d;return m|0}c[j>>2]=vb[c[(c[f>>2]|0)+4>>2]&511](c[c[f>>2]>>2]|0,c[h>>2]|0,c[g>>2]|0)|0;if((c[j>>2]|0)<=0)c[(c[f>>2]|0)+4>>2]=240;if((c[j>>2]|0)<0){c[e>>2]=-1;m=c[e>>2]|0;i=d;return m|0}c[g>>2]=c[j>>2];do if(c[(c[f>>2]|0)+12>>2]|0){if(!(c[(c[f>>2]|0)+20>>2]|0)){b=Ly()|0;c[(c[f>>2]|0)+20>>2]=b}c[j>>2]=cz(c[(c[f>>2]|0)+20>>2]|0,c[h>>2]|0,c[g>>2]|0)|0;if(c[j>>2]|0){c[e>>2]=-1;m=c[e>>2]|0;i=d;return m|0}c[l>>2]=_y(c[(c[f>>2]|0)+20>>2]|0)|0;c[k>>2]=Fd(c[f>>2]|0,1)|0;if((c[k>>2]|0)>=0){b=c[l>>2]|0;a=b-(_y(c[(c[f>>2]|0)+20>>2]|0)|0)|0;b=(c[f>>2]|0)+32|0;c[b>>2]=(c[b>>2]|0)+a;break}Zk(1544,0);c[(c[f>>2]|0)+28>>2]=1544;c[e>>2]=-1;m=c[e>>2]|0;i=d;return m|0}else{c[k>>2]=c[g>>2];Xy(c[(c[f>>2]|0)+16>>2]|0,c[k>>2]|0)|0}while(0);c[e>>2]=c[k>>2];m=c[e>>2]|0;i=d;return m|0}c[e>>2]=-1;m=c[e>>2]|0;i=d;return m|0}function Nk(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;do if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+28>>2]|0)==0:0){b=c[f>>2]|0;if(c[(c[f>>2]|0)+4>>2]|0){c[e>>2]=Mk(b,c[g>>2]|0)|0;break}if((Py(c[b+16>>2]|0)|0)==2){c[e>>2]=0;break}else{c[e>>2]=-1;break}}else h=3;while(0);if((h|0)==3)c[e>>2]=-1;i=d;return c[e>>2]|0}function Ok(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;n=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=0;c[m>>2]=0;if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+28>>2]|0)==0:0){if((c[h>>2]|0)<0){c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}if(c[(c[g>>2]|0)+28>>2]|0){c[f>>2]=-1;o=c[f>>2]|0;i=e;return o|0}while(1){d=c[h>>2]|0;c[n>>2]=d;c[n>>2]=(c[n>>2]|0)>16e3?16e3:d;d=c[g>>2]|0;if(c[(c[g>>2]|0)+12>>2]|0){if(!(c[d+20>>2]|0)){b=Ly()|0;c[(c[g>>2]|0)+20>>2]=b}c[l>>2]=cz(c[(c[g>>2]|0)+16>>2]|0,c[j>>2]|0,c[n>>2]|0)|0;if(c[l>>2]|0){p=12;break}if((_y(c[(c[g>>2]|0)+16>>2]|0)|0)>>>0<4e3?(c[n>>2]|0)==(c[h>>2]|0):0){p=32;break}c[l>>2]=Gd(c[g>>2]|0,0)|0;if((c[l>>2]|0)<0&(c[l>>2]|0)!=-3){p=16;break}c[k>>2]=_y(c[(c[g>>2]|0)+20>>2]|0)|0}else{c[l>>2]=cz(c[d+16>>2]|0,c[j>>2]|0,c[n>>2]|0)|0;if(c[l>>2]|0){p=19;break}c[k>>2]=_y(c[(c[g>>2]|0)+16>>2]|0)|0}c[j>>2]=(c[j>>2]|0)+(c[n>>2]|0);c[h>>2]=(c[h>>2]|0)-(c[n>>2]|0);if((c[k>>2]|0)<4e3&(c[h>>2]|0)<=0){p=32;break}if(c[(c[g>>2]|0)+4>>2]|0){d=c[(c[g>>2]|0)+4>>2]|0;b=c[c[g>>2]>>2]|0;a=c[g>>2]|0;if(c[(c[g>>2]|0)+12>>2]|0){q=Vy(c[a+20>>2]|0)|0;c[l>>2]=vb[d&511](b,q,c[k>>2]|0)|0;if((c[l>>2]|0)>=0)Ty(c[(c[g>>2]|0)+20>>2]|0,c[l>>2]|0)|0}else{q=Vy(c[a+16>>2]|0)|0;c[l>>2]=vb[d&511](b,q,c[k>>2]|0)|0;if((c[l>>2]|0)>=0)Ty(c[(c[g>>2]|0)+16>>2]|0,c[l>>2]|0)|0}if((c[l>>2]|0)<0){p=29;break}q=(c[g>>2]|0)+24|0;c[q>>2]=(c[q>>2]|0)+(c[l>>2]|0)}c[m>>2]=(c[m>>2]|0)+(c[k>>2]|0);if((c[h>>2]|0)<=0){p=32;break}}if((p|0)==12){c[f>>2]=-1;o=c[f>>2]|0;i=e;return o|0}else if((p|0)==16){Zk(1544,0);c[(c[g>>2]|0)+28>>2]=1544;c[f>>2]=-1;o=c[f>>2]|0;i=e;return o|0}else if((p|0)==19){c[f>>2]=-1;o=c[f>>2]|0;i=e;return o|0}else if((p|0)==29){Zk(1546,0);c[(c[g>>2]|0)+28>>2]=1546;c[f>>2]=c[l>>2];o=c[f>>2]|0;i=e;return o|0}else if((p|0)==32){c[f>>2]=c[m>>2];o=c[f>>2]|0;i=e;return o|0}}c[f>>2]=-1;o=c[f>>2]|0;i=e;return o|0}function Pk(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+48|0;f=e+40|0;g=e+36|0;h=e+32|0;j=e+28|0;k=e+24|0;l=e+20|0;m=e+16|0;n=e+12|0;o=e+8|0;p=e+4|0;q=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=0;c[m>>2]=0;c[n>>2]=0;if((((c[g>>2]|0)!=0?!((c[h>>2]|0)==0?1:(c[(c[g>>2]|0)+28>>2]|0)!=0):0)?(c[(c[g>>2]|0)+16>>2]|0)!=0:0)?(Py(c[(c[g>>2]|0)+16>>2]|0)|0)!=2:0){c[p>>2]=ZT(c[h>>2]|0)|0;if((c[p>>2]|0)<0){c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}if(c[(c[g>>2]|0)+28>>2]|0){c[f>>2]=-1;r=c[f>>2]|0;i=e;return r|0}if(!(c[j>>2]|0))c[j>>2]=241;while(1){c[n>>2]=c[m>>2];c[q>>2]=c[p>>2];c[o>>2]=($y(c[(c[g>>2]|0)+16>>2]|0)|0)-1;d=c[g>>2]|0;if((c[o>>2]|0)<40){if((Uy(c[d+16>>2]|0,100)|0)<0){s=14;break}c[n>>2]=-1}else{if(c[d+12>>2]|0){if(!(c[(c[g>>2]|0)+20>>2]|0)){d=Ly()|0;c[(c[g>>2]|0)+20>>2]=d}d=c[j>>2]|0;b=Wy(c[(c[g>>2]|0)+16>>2]|0)|0;c[l>>2]=Fb[d&511](b,o,c[h>>2]|0,q)|0;if((c[l>>2]|0)<0|(c[o>>2]|0)==0){s=20;break}Xy(c[(c[g>>2]|0)+16>>2]|0,c[o>>2]|0)|0;if((_y(c[(c[g>>2]|0)+16>>2]|0)|0)>>>0<4e3?(c[q>>2]|0)==(c[p>>2]|0):0){s=44;break}c[l>>2]=Gd(c[g>>2]|0,0)|0;if((c[l>>2]|0)<0&(c[l>>2]|0)!=-3){s=24;break}c[k>>2]=_y(c[(c[g>>2]|0)+20>>2]|0)|0}else{b=c[j>>2]|0;d=Wy(c[(c[g>>2]|0)+16>>2]|0)|0;c[l>>2]=Fb[b&511](d,o,c[h>>2]|0,q)|0;if((c[l>>2]|0)<0|(c[o>>2]|0)==0){s=27;break}Xy(c[(c[g>>2]|0)+16>>2]|0,c[o>>2]|0)|0;c[k>>2]=_y(c[(c[g>>2]|0)+16>>2]|0)|0}c[h>>2]=(c[h>>2]|0)+(c[q>>2]|0);c[p>>2]=(c[p>>2]|0)-(c[q>>2]|0);if((c[k>>2]|0)<4e3&(c[p>>2]|0)<=0){s=44;break}d=c[g>>2]|0;if(!(c[(c[g>>2]|0)+4>>2]|0)){if(($y(c[d+16>>2]|0)|0)>>>0<4e3)Uy(c[(c[g>>2]|0)+16>>2]|0,4e3)|0}else{b=c[(c[g>>2]|0)+4>>2]|0;a=c[c[g>>2]>>2]|0;t=c[g>>2]|0;if(c[d+12>>2]|0){d=Vy(c[t+20>>2]|0)|0;c[l>>2]=vb[b&511](a,d,c[k>>2]|0)|0;if((c[l>>2]|0)>=0)Ty(c[(c[g>>2]|0)+20>>2]|0,c[l>>2]|0)|0}else{d=Vy(c[t+16>>2]|0)|0;c[l>>2]=vb[b&511](a,d,c[k>>2]|0)|0;if((c[l>>2]|0)>=0)Ty(c[(c[g>>2]|0)+16>>2]|0,c[l>>2]|0)|0}if((c[l>>2]|0)<0){s=37;break}d=(c[g>>2]|0)+24|0;c[d>>2]=(c[d>>2]|0)+(c[l>>2]|0)}c[m>>2]=(c[m>>2]|0)+(c[k>>2]|0)}if((c[p>>2]|0)<=0){s=44;break}if((c[n>>2]|0)==(c[m>>2]|0)){s=44;break}}if((s|0)==14){c[f>>2]=-1;r=c[f>>2]|0;i=e;return r|0}else if((s|0)==20){c[f>>2]=-1;r=c[f>>2]|0;i=e;return r|0}else if((s|0)==24){Zk(1544,0);c[(c[g>>2]|0)+28>>2]=1544;c[f>>2]=-1;r=c[f>>2]|0;i=e;return r|0}else if((s|0)==27){c[f>>2]=-1;r=c[f>>2]|0;i=e;return r|0}else if((s|0)==37){Zk(1546,0);c[(c[g>>2]|0)+28>>2]=1546;c[f>>2]=c[l>>2];r=c[f>>2]|0;i=e;return r|0}else if((s|0)==44){c[f>>2]=c[m>>2];r=c[f>>2]|0;i=e;return r|0}}c[f>>2]=-1;r=c[f>>2]|0;i=e;return r|0}function Qk(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;do if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+28>>2]|0)==0:0){if(!(c[g>>2]|0)){c[e>>2]=-1;break}c[h>>2]=ZT(c[g>>2]|0)|0;if((c[h>>2]|0)>0){c[e>>2]=Ok(c[f>>2]|0,c[h>>2]|0,c[g>>2]|0)|0;break}else{c[e>>2]=c[h>>2];break}}else j=3;while(0);if((j|0)==3)c[e>>2]=-1;i=d;return c[e>>2]|0}function Rk(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+1040|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d+16|0;j=d;c[f>>2]=b;c[g>>2]=0;if(!(c[19090]|0))tk();if(!(c[f>>2]|0)){c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}aU(h|0,c[f>>2]|0,1023)|0;a[h+1023>>0]=0;c[j>>2]=h+(ZT(h|0)|0);while(1){if((c[j>>2]|0)>>>0<=h>>>0)break;if((a[c[j>>2]>>0]|0)==47)break;c[j>>2]=(c[j>>2]|0)+-1}if((a[c[j>>2]>>0]|0)!=47){if(za(h|0,1024)|0){a[h+1023>>0]=0;c[g>>2]=Cb[c[135768>>2]&511](h)|0}}else{if((c[j>>2]|0)==(h|0))a[h+1>>0]=0;else a[c[j>>2]>>0]=0;c[g>>2]=Cb[c[135768>>2]&511](h)|0}c[e>>2]=c[g>>2];k=c[e>>2]|0;i=d;return k|0}function Sk(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[d+4>>2]=a;c[e>>2]=b;i=d;return c[e>>2]|0}function Tk(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;c[19248]=c[d>>2];i=b;return}function Uk(){return c[19248]|0}function Vk(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if((c[g>>2]|0)!=0?(hl(c[g>>2]|0)|0)==0:0){c[k>>2]=Jl(c[g>>2]|0)|0;if(!(c[k>>2]|0)){al(77e3);c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}else{c[l>>2]=vb[c[76992>>2]&511](c[k>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;zb[c[135736>>2]&511](c[k>>2]|0);c[f>>2]=c[l>>2];m=c[f>>2]|0;i=e;return m|0}}c[f>>2]=vb[c[76992>>2]&511](c[g>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;m=c[f>>2]|0;i=e;return m|0}function Wk(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=0;c[l>>2]=0;c[l>>2]=il(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;if(!(c[l>>2]|0))c[l>>2]=c[g>>2];do if(c[l>>2]|0){if((uy(c[l>>2]|0,77032,6)|0)!=0?(uy(c[l>>2]|0,77040,7)|0)!=0:0)break;Zk(1543,c[l>>2]|0);if((c[l>>2]|0)!=(c[g>>2]|0))zb[c[135736>>2]&511](c[l>>2]|0);c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}while(0);c[k>>2]=Xk(c[l>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;if((c[l>>2]|0)!=(c[g>>2]|0))zb[c[135736>>2]&511](c[l>>2]|0);c[f>>2]=c[k>>2];m=c[f>>2]|0;i=e;return m|0}function Xk(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=0;c[l>>2]=0;if((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+360>>2]&2048|0)!=0:0){c[m>>2]=c[(c[j>>2]|0)+360>>2];d=(c[j>>2]|0)+360|0;c[d>>2]=(c[d>>2]|0)-2048;c[k>>2]=Wk(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;c[(c[j>>2]|0)+360>>2]=c[m>>2];c[f>>2]=c[k>>2];n=c[f>>2]|0;i=e;return n|0}c[l>>2]=il(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;if(!(c[l>>2]|0))c[l>>2]=c[g>>2];if(!(c[l>>2]|0)){if(!(c[h>>2]|0))c[h>>2]=77048;ik(c[j>>2]|0,77056,c[h>>2]|0);c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}c[k>>2]=xe(c[j>>2]|0,c[l>>2]|0)|0;if((c[l>>2]|0)!=0?(c[l>>2]|0)!=(c[g>>2]|0):0)zb[c[135736>>2]&511](c[l>>2]|0);c[f>>2]=c[k>>2];n=c[f>>2]|0;i=e;return n|0}function Yk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;c[f>>2]=c[e>>2];if(!(c[e>>2]|0)){c[d>>2]=0;h=c[d>>2]|0;i=b;return h|0}if(!(PT(c[e>>2]|0,77176)|0)){c[g>>2]=c[p>>2];c[d>>2]=c[g>>2];h=c[d>>2]|0;i=b;return h|0}a=(uy(c[e>>2]|0,77096,17)|0)!=0;j=c[e>>2]|0;do if(a){k=(uy(j,77120,8)|0)!=0;l=c[e>>2]|0;if(!k){c[f>>2]=l+7;break}if(!(uy(l,77192,6)|0))c[f>>2]=(c[e>>2]|0)+5}else c[f>>2]=j+16;while(0);if(!(lk(c[f>>2]|0)|0)){c[d>>2]=0;h=c[d>>2]|0;i=b;return h|0}c[g>>2]=pb(c[f>>2]|0,77200)|0;if(!(c[g>>2]|0))Zk(0,c[f>>2]|0);c[d>>2]=c[g>>2];h=c[d>>2]|0;i=b;return h|0}function Zk(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;hk(8,c[e>>2]|0,c[f>>2]|0);i=d;return}function _k(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;c[f>>2]=0;if(!(PT(c[e>>2]|0,77176)|0)){c[g>>2]=c[q>>2];c[d>>2]=c[g>>2];h=c[d>>2]|0;i=b;return h|0}a=(uy(c[e>>2]|0,77096,17)|0)!=0;j=c[e>>2]|0;do if(a){k=(uy(j,77120,8)|0)!=0;l=c[e>>2]|0;if(k){c[f>>2]=l;break}else{c[f>>2]=l+7;break}}else c[f>>2]=j+16;while(0);if(!(c[f>>2]|0)){c[d>>2]=0;h=c[d>>2]|0;i=b;return h|0}c[g>>2]=pb(c[f>>2]|0,77184)|0;if(!(c[g>>2]|0))Zk(0,c[f>>2]|0);c[d>>2]=c[g>>2];h=c[d>>2]|0;i=b;return h|0}function $k(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if((c[g>>2]|0)==0|(c[h>>2]|0)==0){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}c[k>>2]=ib(c[h>>2]|0,c[j>>2]|0,1,c[g>>2]|0)|0;if((c[k>>2]|0)==0?(Sa(c[g>>2]|0)|0)!=0:0){Zk(0,77160);c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}c[f>>2]=ca(c[k>>2]|0,c[j>>2]|0)|0;l=c[f>>2]|0;i=e;return l|0}function al(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;ce(8,2,0,0,c[d>>2]|0);i=b;return}function bl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if(!(c[e>>2]|0)){c[d>>2]=-1;g=c[d>>2]|0;i=b;return g|0}a=(Ga(c[e>>2]|0)|0)==-1;c[f>>2]=a?-1:0;if((c[f>>2]|0)<0)Zk(0,76880);c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}function cl(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=eb(c[f>>2]|0,c[g>>2]|0,c[h>>2]|0)|0;if((c[j>>2]|0)>=0){k=c[j>>2]|0;i=e;return k|0}Zk(0,77152);k=c[j>>2]|0;i=e;return k|0}function dl(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=Ra(c[d>>2]|0)|0;if((c[e>>2]|0)<0)Zk(0,77144);i=b;return c[e>>2]|0}function el(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=0;if((c[h>>2]|0)>0?(c[j>>2]=Ya(c[f>>2]|0,c[g>>2]|0,c[h>>2]|0)|0,(c[j>>2]|0)<0):0)Zk(0,77136);i=e;return c[j>>2]|0}function fl(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;i=i+16|0;c[e+8>>2]=a;c[e+4>>2]=b;c[e>>2]=d;i=e;return 0}function gl(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+32|0;j=h+28|0;k=h+24|0;l=h+20|0;m=h+16|0;n=h+12|0;o=h+8|0;p=h+4|0;q=h;c[j>>2]=b;c[k>>2]=e;c[l>>2]=f;c[m>>2]=g;c[n>>2]=c[j>>2];c[o>>2]=c[l>>2];c[p>>2]=(c[j>>2]|0)+(c[c[k>>2]>>2]|0);c[q>>2]=(c[l>>2]|0)+(c[c[m>>2]>>2]|0);a:while(1){if((c[l>>2]|0)>>>0>=(c[q>>2]|0)>>>0)break;if((c[j>>2]|0)>>>0>=(c[p>>2]|0)>>>0)break;do if((d[c[l>>2]>>0]|0|0)==60){if(((c[p>>2]|0)-(c[j>>2]|0)|0)<4)break a;g=c[j>>2]|0;c[j>>2]=g+1;a[g>>0]=38;g=c[j>>2]|0;c[j>>2]=g+1;a[g>>0]=108;g=c[j>>2]|0;c[j>>2]=g+1;a[g>>0]=116;g=c[j>>2]|0;c[j>>2]=g+1;a[g>>0]=59}else{if((d[c[l>>2]>>0]|0|0)==62){if(((c[p>>2]|0)-(c[j>>2]|0)|0)<4)break a;g=c[j>>2]|0;c[j>>2]=g+1;a[g>>0]=38;g=c[j>>2]|0;c[j>>2]=g+1;a[g>>0]=103;g=c[j>>2]|0;c[j>>2]=g+1;a[g>>0]=116;g=c[j>>2]|0;c[j>>2]=g+1;a[g>>0]=59;break}if((d[c[l>>2]>>0]|0|0)==38){if(((c[p>>2]|0)-(c[j>>2]|0)|0)<5)break a;g=c[j>>2]|0;c[j>>2]=g+1;a[g>>0]=38;g=c[j>>2]|0;c[j>>2]=g+1;a[g>>0]=97;g=c[j>>2]|0;c[j>>2]=g+1;a[g>>0]=109;g=c[j>>2]|0;c[j>>2]=g+1;a[g>>0]=112;g=c[j>>2]|0;c[j>>2]=g+1;a[g>>0]=59;break}if((d[c[l>>2]>>0]|0|0)!=13){g=a[c[l>>2]>>0]|0;f=c[j>>2]|0;c[j>>2]=f+1;a[f>>0]=g;break}if(((c[p>>2]|0)-(c[j>>2]|0)|0)<5)break a;g=c[j>>2]|0;c[j>>2]=g+1;a[g>>0]=38;g=c[j>>2]|0;c[j>>2]=g+1;a[g>>0]=35;g=c[j>>2]|0;c[j>>2]=g+1;a[g>>0]=49;g=c[j>>2]|0;c[j>>2]=g+1;a[g>>0]=51;g=c[j>>2]|0;c[j>>2]=g+1;a[g>>0]=59}while(0);c[l>>2]=(c[l>>2]|0)+1}c[c[k>>2]>>2]=(c[j>>2]|0)-(c[n>>2]|0);c[c[m>>2]>>2]=(c[l>>2]|0)-(c[o>>2]|0);i=h;return 0}function hl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if(!(c[e>>2]|0)){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}a=(uy(c[e>>2]|0,77096,17)|0)!=0;h=c[e>>2]|0;do if(a){j=(uy(h,77120,8)|0)!=0;k=c[e>>2]|0;if(j){c[f>>2]=k;break}else{c[f>>2]=k+7;break}}else c[f>>2]=h+16;while(0);c[d>>2]=lk(c[f>>2]|0)|0;g=c[d>>2]|0;i=b;return g|0}function il(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=0;c[k>>2]=Gw()|0;if(!(c[k>>2]|0)){m=c[j>>2]|0;i=e;return m|0}if(hl(c[f>>2]|0)|0){m=c[j>>2]|0;i=e;return m|0}if(((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+284>>2]|0)!=0:0)?(c[k>>2]|0)==3|(c[k>>2]|0)==2:0)c[j>>2]=Jw(c[(c[h>>2]|0)+284>>2]|0,c[g>>2]|0,c[f>>2]|0)|0;if((c[j>>2]|0)==0?(c[k>>2]|0)==3|(c[k>>2]|0)==1:0)c[j>>2]=Ew(c[g>>2]|0,c[f>>2]|0)|0;if((c[j>>2]|0)==0&(c[f>>2]|0)!=0)c[j>>2]=my(c[f>>2]|0)|0;if(!(c[j>>2]|0)){m=c[j>>2]|0;i=e;return m|0}if(hl(c[j>>2]|0)|0){m=c[j>>2]|0;i=e;return m|0}c[l>>2]=0;if(((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+284>>2]|0)!=0:0)?(c[k>>2]|0)==3|(c[k>>2]|0)==2:0)c[l>>2]=Kw(c[(c[h>>2]|0)+284>>2]|0,c[j>>2]|0)|0;if((c[l>>2]|0)==0?(c[k>>2]|0)==3|(c[k>>2]|0)==1:0)c[l>>2]=Fw(c[j>>2]|0)|0;if(!(c[l>>2]|0)){m=c[j>>2]|0;i=e;return m|0}zb[c[135736>>2]&511](c[j>>2]|0);c[j>>2]=c[l>>2];m=c[j>>2]|0;i=e;return m|0}function jl(){var a=0,b=0,d=0,e=0;a=i;i=i+16|0;b=a;d=c[33976]|0;e=c[33980]|0;c[b>>2]=c[19636];Db[d&511](e,78496,b);i=a;return}function kl(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e;g=e+28|0;h=e+24|0;j=e+20|0;k=e+16|0;l=e+12|0;m=e+8|0;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;if(!(c[19638]|0))ll()|0;c[l>>2]=iT(24+(c[h>>2]|0)|0)|0;if(!(c[l>>2]|0)){Db[c[135904>>2]&511](c[33980]|0,78560,f);ml();c[g>>2]=0;n=c[g>>2]|0;i=e;return n|0}c[c[l>>2]>>2]=23205;c[(c[l>>2]|0)+12>>2]=c[h>>2];c[(c[l>>2]|0)+4>>2]=1;c[(c[l>>2]|0)+16>>2]=c[j>>2];c[(c[l>>2]|0)+20>>2]=c[k>>2];rx(c[19650]|0);k=(c[19652]|0)+1|0;c[19652]=k;c[(c[l>>2]|0)+8>>2]=k;c[19654]=(c[19654]|0)+(c[h>>2]|0);c[19656]=(c[19656]|0)+1;if((c[19654]|0)>>>0>(c[19658]|0)>>>0)c[19658]=c[19654];sx(c[19650]|0);if((c[19636]|0)==(c[(c[l>>2]|0)+8>>2]|0))jl();c[m>>2]=(c[l>>2]|0)+24;if((c[19660]|0)==(c[m>>2]|0)){l=c[33976]|0;k=c[33980]|0;j=c[h>>2]|0;c[f>>2]=c[19660];c[f+4>>2]=j;Db[l&511](k,78648,f);jl()}c[g>>2]=c[m>>2];n=c[g>>2]|0;i=e;return n|0}function ll(){var a=0,b=0,d=0,e=0,f=0,g=0;a=i;i=i+16|0;b=a;d=a+8|0;e=a+4|0;if(c[19638]|0){c[d>>2]=-1;f=c[d>>2]|0;
i=a;return f|0}c[19638]=1;c[19650]=px()|0;c[e>>2]=cb(78864)|0;if(c[e>>2]|0){g=c[e>>2]|0;c[b>>2]=78544;bT(g,78888,b)|0}c[e>>2]=cb(78896)|0;if(c[e>>2]|0){g=c[e>>2]|0;c[b>>2]=78640;bT(g,78912,b)|0}c[d>>2]=0;f=c[d>>2]|0;i=a;return f|0}function ml(){return}function nl(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=kl(c[d>>2]|0,78672,0)|0;i=b;return a|0}function ol(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+48|0;g=f;h=f+40|0;j=f+36|0;k=f+32|0;l=f+28|0;m=f+24|0;n=f+20|0;o=f+16|0;p=f+12|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;if(!(c[j>>2]|0)){c[h>>2]=kl(c[k>>2]|0,c[l>>2]|0,c[m>>2]|0)|0;q=c[h>>2]|0;i=f;return q|0}if(!(c[19638]|0))ll()|0;c[n>>2]=(c[j>>2]|0)+-24;c[p>>2]=c[(c[n>>2]|0)+8>>2];if((c[19636]|0)==(c[p>>2]|0))jl();e=c[n>>2]|0;do if((c[c[n>>2]>>2]|0)!=23205)xl(e);else{c[e>>2]=-23206;rx(c[19650]|0);c[19654]=(c[19654]|0)-(c[(c[n>>2]|0)+12>>2]|0);c[19656]=(c[19656]|0)+-1;sx(c[19650]|0);c[o>>2]=kT(c[n>>2]|0,24+(c[k>>2]|0)|0)|0;if(!(c[o>>2]|0)){jT(c[n>>2]|0);break}c[n>>2]=c[o>>2];if((c[19660]|0)==(c[j>>2]|0)){d=c[33976]|0;b=c[33980]|0;a=c[(c[n>>2]|0)+12>>2]|0;r=c[k>>2]|0;c[g>>2]=c[19660];c[g+4>>2]=a;c[g+8>>2]=r;Db[d&511](b,78680,g);jl()}c[c[n>>2]>>2]=23205;c[(c[n>>2]|0)+8>>2]=c[p>>2];c[(c[n>>2]|0)+4>>2]=2;c[(c[n>>2]|0)+12>>2]=c[k>>2];c[(c[n>>2]|0)+16>>2]=c[l>>2];c[(c[n>>2]|0)+20>>2]=c[m>>2];rx(c[19650]|0);c[19654]=(c[19654]|0)+(c[k>>2]|0);c[19656]=(c[19656]|0)+1;if((c[19654]|0)>>>0>(c[19658]|0)>>>0)c[19658]=c[19654];sx(c[19650]|0);c[h>>2]=(c[n>>2]|0)+24;q=c[h>>2]|0;i=f;return q|0}while(0);c[h>>2]=0;q=c[h>>2]|0;i=f;return q|0}function pl(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=ol(c[e>>2]|0,c[f>>2]|0,78672,0)|0;i=d;return b|0}function ql(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b;e=b+12|0;f=b+8|0;g=b+4|0;c[e>>2]=a;if(!(c[e>>2]|0)){i=b;return}do if((c[e>>2]|0)==(-1|0))Db[c[135904>>2]&511](c[33980]|0,78712,d);else{if((c[19660]|0)==(c[e>>2]|0)){a=c[33976]|0;h=c[33980]|0;c[d>>2]=c[19660];Db[a&511](h,78752,d);jl()}c[g>>2]=c[e>>2];c[f>>2]=(c[e>>2]|0)+-24;if((c[c[f>>2]>>2]|0)!=23205){xl(c[f>>2]|0);break}if((c[19636]|0)==(c[(c[f>>2]|0)+8>>2]|0))jl();c[c[f>>2]>>2]=-23206;cU(c[g>>2]|0,-1,c[(c[f>>2]|0)+12>>2]|0)|0;rx(c[19650]|0);c[19654]=(c[19654]|0)-(c[(c[f>>2]|0)+12>>2]|0);c[19656]=(c[19656]|0)+-1;sx(c[19650]|0);jT(c[f>>2]|0);i=b;return}while(0);f=c[33976]|0;g=c[33980]|0;c[d>>2]=c[e>>2];Db[f&511](g,78768,d);jl();i=b;return}function rl(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e;g=e+28|0;h=e+24|0;j=e+20|0;k=e+16|0;l=e+12|0;m=e+8|0;n=e+4|0;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[m>>2]=(ZT(c[h>>2]|0)|0)+1;if(!(c[19638]|0))ll()|0;c[n>>2]=iT(24+(c[m>>2]|0)|0)|0;if(!(c[n>>2]|0)){c[g>>2]=0;o=c[g>>2]|0;i=e;return o|0}c[c[n>>2]>>2]=23205;c[(c[n>>2]|0)+12>>2]=c[m>>2];c[(c[n>>2]|0)+4>>2]=3;c[(c[n>>2]|0)+16>>2]=c[j>>2];c[(c[n>>2]|0)+20>>2]=c[k>>2];rx(c[19650]|0);k=(c[19652]|0)+1|0;c[19652]=k;c[(c[n>>2]|0)+8>>2]=k;c[19654]=(c[19654]|0)+(c[m>>2]|0);c[19656]=(c[19656]|0)+1;if((c[19654]|0)>>>0>(c[19658]|0)>>>0)c[19658]=c[19654];sx(c[19650]|0);c[l>>2]=(c[n>>2]|0)+24;if((c[19636]|0)==(c[(c[n>>2]|0)+8>>2]|0))jl();gU(c[l>>2]|0,c[h>>2]|0)|0;if((c[19660]|0)==(c[l>>2]|0)){h=c[33976]|0;n=c[33980]|0;c[f>>2]=c[19660];Db[h&511](n,78792,f);jl()}c[g>>2]=c[l>>2];o=c[g>>2]|0;i=e;return o|0}function sl(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=rl(c[d>>2]|0,78672,0)|0;i=b;return a|0}function tl(){return c[19654]|0}function ul(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=d+12|0;c[f>>2]=a;c[d+8>>2]=b;if(!(c[f>>2]|0)){i=d;return}b=c[f>>2]|0;f=c[19658]|0;c[e>>2]=c[19654];c[e+4>>2]=f;Ka(b|0,78816,e|0)|0;i=d;return}function vl(){var a=0;a=i;if(!(c[19638]|0)){i=a;return}qx(c[19650]|0);c[19650]=0;c[19638]=0;i=a;return}function wl(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;do if(c[h>>2]|0){if(!(c[j>>2]|0)){c[g>>2]=-1;break}if(!(c[k>>2]|0)){c[g>>2]=-1;break}if(!(c[l>>2]|0)){c[g>>2]=-1;break}else{c[33934]=c[h>>2];c[33936]=c[j>>2];c[33938]=c[j>>2];c[33940]=c[k>>2];c[33942]=c[l>>2];c[g>>2]=0;break}}else c[g>>2]=-1;while(0);i=f;return c[g>>2]|0}function xl(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=b+4|0;c[e>>2]=a;a=c[33976]|0;f=c[33980]|0;c[d>>2]=c[e>>2];Db[a&511](f,78920,d);i=b;return}function yl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;if(!(c[e>>2]|0)){c[d>>2]=0;h=c[d>>2]|0;i=b;return h|0}c[f>>2]=zl()|0;if((c[f>>2]|0)!=0?(c[g>>2]=Ll(c[f>>2]|0,c[e>>2]|0)|0,(c[g>>2]|0)!=0):0){Al(c[f>>2]|0);c[d>>2]=0;h=c[d>>2]|0;i=b;return h|0}c[d>>2]=c[f>>2];h=c[d>>2]|0;i=b;return h|0}function zl(){var a=0,b=0,d=0,e=0,f=0,g=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=Cb[c[135744>>2]&511](44)|0;if(!(c[d>>2]|0)){Ml(78960);c[b>>2]=0;e=c[b>>2]|0;i=a;return e|0}else{f=(c[d>>2]|0)+0|0;g=f+44|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));c[b>>2]=c[d>>2];e=c[b>>2]|0;i=a;return e|0}return 0}function Al(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[c[d>>2]>>2]|0)zb[c[135736>>2]&511](c[c[d>>2]>>2]|0);if(c[(c[d>>2]|0)+12>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+12>>2]|0);if(c[(c[d>>2]|0)+16>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+16>>2]|0);if(c[(c[d>>2]|0)+24>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+24>>2]|0);if(c[(c[d>>2]|0)+32>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+32>>2]|0);if(c[(c[d>>2]|0)+4>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+4>>2]|0);if(c[(c[d>>2]|0)+8>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+8>>2]|0);if(c[(c[d>>2]|0)+28>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+28>>2]|0);if(c[(c[d>>2]|0)+40>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+40>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function Bl(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=Ll(c[e>>2]|0,c[f>>2]|0)|0;i=d;return b|0}function Cl(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;e=i;i=i+112|0;f=e;g=e+100|0;h=e+96|0;j=e+92|0;k=e+88|0;l=e+84|0;m=e+80|0;n=e+76|0;o=e+72|0;p=e+68|0;q=e+64|0;r=e+60|0;s=e+56|0;t=e+52|0;u=e+48|0;v=e+44|0;w=e+40|0;x=e+36|0;y=e+32|0;z=e+28|0;A=e+24|0;B=e+20|0;C=e+16|0;D=e+12|0;E=e+8|0;F=e+4|0;c[h>>2]=b;c[j>>2]=0;if(!(c[h>>2]|0)){c[g>>2]=0;G=c[g>>2]|0;i=e;return G|0}c[n>>2]=80;c[j>>2]=Cb[c[135752>>2]&511]((c[n>>2]|0)+1|0)|0;if(!(c[j>>2]|0)){Ml(78984);c[g>>2]=0;G=c[g>>2]|0;i=e;return G|0}c[m>>2]=0;a:do if(c[c[h>>2]>>2]|0){c[l>>2]=c[c[h>>2]>>2];while(1){H=(c[m>>2]|0)>=(c[n>>2]|0);if(!(a[c[l>>2]>>0]|0))break;if(H){c[k>>2]=Nl(c[j>>2]|0,n)|0;if(!(c[k>>2]|0))break a;c[j>>2]=c[k>>2]}b=c[l>>2]|0;c[l>>2]=b+1;I=a[b>>0]|0;b=c[m>>2]|0;c[m>>2]=b+1;a[(c[j>>2]|0)+b>>0]=I}if(H){c[k>>2]=Nl(c[j>>2]|0,n)|0;if(!(c[k>>2]|0))break;c[j>>2]=c[k>>2]}I=c[m>>2]|0;c[m>>2]=I+1;a[(c[j>>2]|0)+I>>0]=58;J=16}else J=16;while(0);b:do if((J|0)==16){H=c[h>>2]|0;c:do if(!(c[(c[h>>2]|0)+4>>2]|0)){d:do if((c[H+12>>2]|0)==0?(c[(c[h>>2]|0)+20>>2]|0)!=-1:0){if(!(c[(c[h>>2]|0)+8>>2]|0)){if(!(c[c[h>>2]>>2]|0))break;if(((c[m>>2]|0)+3|0)<(c[n>>2]|0))break;c[k>>2]=Nl(c[j>>2]|0,n)|0;if(!(c[k>>2]|0))break b;c[j>>2]=c[k>>2];break}if(((c[m>>2]|0)+3|0)>=(c[n>>2]|0)){c[k>>2]=Nl(c[j>>2]|0,n)|0;if(!(c[k>>2]|0))break b;c[j>>2]=c[k>>2]}I=c[m>>2]|0;c[m>>2]=I+1;a[(c[j>>2]|0)+I>>0]=47;I=c[m>>2]|0;c[m>>2]=I+1;a[(c[j>>2]|0)+I>>0]=47;c[l>>2]=c[(c[h>>2]|0)+8>>2];e:while(1){if(!(a[c[l>>2]>>0]|0))break d;if(((c[m>>2]|0)+3|0)>=(c[n>>2]|0)){c[k>>2]=Nl(c[j>>2]|0,n)|0;if(!(c[k>>2]|0))break b;c[j>>2]=c[k>>2]}if(!((a[c[l>>2]>>0]|0)>=97?(a[c[l>>2]>>0]|0)<=122:0))J=113;do if((J|0)==113){J=0;if((a[c[l>>2]>>0]|0)>=65?(a[c[l>>2]>>0]|0)<=90:0)break;if((a[c[l>>2]>>0]|0)>=48?(a[c[l>>2]>>0]|0)<=57:0)break;if((a[c[l>>2]>>0]|0)!=45?(a[c[l>>2]>>0]|0)!=95:0){if((a[c[l>>2]>>0]|0)==46)break;if((a[c[l>>2]>>0]|0)==33)break;if((a[c[l>>2]>>0]|0)==126)break;if((a[c[l>>2]>>0]|0)==42)break;if((a[c[l>>2]>>0]|0)==39)break;if((a[c[l>>2]>>0]|0)==40)break;if((a[c[l>>2]>>0]|0)==41)break;if((a[c[l>>2]>>0]|0)==36)break;if((a[c[l>>2]>>0]|0)==44)break;if((a[c[l>>2]>>0]|0)==59)break;if((a[c[l>>2]>>0]|0)==58)break;if((a[c[l>>2]>>0]|0)==64)break;if((a[c[l>>2]>>0]|0)==38)break;if((a[c[l>>2]>>0]|0)==61)break;if((a[c[l>>2]>>0]|0)==43)break;I=c[l>>2]|0;c[l>>2]=I+1;c[u>>2]=d[I>>0];c[v>>2]=(c[u>>2]|0)/16|0;c[w>>2]=(c[u>>2]|0)%16|0;I=c[m>>2]|0;c[m>>2]=I+1;a[(c[j>>2]|0)+I>>0]=37;I=(c[v>>2]|0)+((c[v>>2]|0)>9?55:48)&255;b=c[m>>2]|0;c[m>>2]=b+1;a[(c[j>>2]|0)+b>>0]=I;I=(c[w>>2]|0)+((c[w>>2]|0)>9?55:48)&255;b=c[m>>2]|0;c[m>>2]=b+1;a[(c[j>>2]|0)+b>>0]=I;continue e}}while(0);I=c[l>>2]|0;c[l>>2]=I+1;b=a[I>>0]|0;I=c[m>>2]|0;c[m>>2]=I+1;a[(c[j>>2]|0)+I>>0]=b}}else J=53;while(0);if((J|0)==53){if(((c[m>>2]|0)+3|0)>=(c[n>>2]|0)){c[k>>2]=Nl(c[j>>2]|0,n)|0;if(!(c[k>>2]|0))break b;c[j>>2]=c[k>>2]}b=c[m>>2]|0;c[m>>2]=b+1;a[(c[j>>2]|0)+b>>0]=47;b=c[m>>2]|0;c[m>>2]=b+1;a[(c[j>>2]|0)+b>>0]=47;if(c[(c[h>>2]|0)+16>>2]|0){c[l>>2]=c[(c[h>>2]|0)+16>>2];f:while(1){K=((c[m>>2]|0)+3|0)>=(c[n>>2]|0);if(!(a[c[l>>2]>>0]|0))break;if(K){c[k>>2]=Nl(c[j>>2]|0,n)|0;if(!(c[k>>2]|0))break b;c[j>>2]=c[k>>2]}if(!((a[c[l>>2]>>0]|0)>=97?(a[c[l>>2]>>0]|0)<=122:0))J=64;do if((J|0)==64){J=0;if((a[c[l>>2]>>0]|0)>=65?(a[c[l>>2]>>0]|0)<=90:0)break;if((a[c[l>>2]>>0]|0)>=48?(a[c[l>>2]>>0]|0)<=57:0)break;if((a[c[l>>2]>>0]|0)!=45?(a[c[l>>2]>>0]|0)!=95:0){if((a[c[l>>2]>>0]|0)==46)break;if((a[c[l>>2]>>0]|0)==33)break;if((a[c[l>>2]>>0]|0)==126)break;if((a[c[l>>2]>>0]|0)==42)break;if((a[c[l>>2]>>0]|0)==39)break;if((a[c[l>>2]>>0]|0)==40)break;if((a[c[l>>2]>>0]|0)==41)break;if((a[c[l>>2]>>0]|0)==59)break;if((a[c[l>>2]>>0]|0)==58)break;if((a[c[l>>2]>>0]|0)==38)break;if((a[c[l>>2]>>0]|0)==61)break;if((a[c[l>>2]>>0]|0)==43)break;if((a[c[l>>2]>>0]|0)==36)break;if((a[c[l>>2]>>0]|0)==44)break;b=c[l>>2]|0;c[l>>2]=b+1;c[r>>2]=d[b>>0];c[s>>2]=(c[r>>2]|0)/16|0;c[t>>2]=(c[r>>2]|0)%16|0;b=c[m>>2]|0;c[m>>2]=b+1;a[(c[j>>2]|0)+b>>0]=37;b=(c[s>>2]|0)+((c[s>>2]|0)>9?55:48)&255;I=c[m>>2]|0;c[m>>2]=I+1;a[(c[j>>2]|0)+I>>0]=b;b=(c[t>>2]|0)+((c[t>>2]|0)>9?55:48)&255;I=c[m>>2]|0;c[m>>2]=I+1;a[(c[j>>2]|0)+I>>0]=b;continue f}}while(0);b=c[l>>2]|0;c[l>>2]=b+1;I=a[b>>0]|0;b=c[m>>2]|0;c[m>>2]=b+1;a[(c[j>>2]|0)+b>>0]=I}if(K){c[k>>2]=Nl(c[j>>2]|0,n)|0;if(!(c[k>>2]|0))break b;c[j>>2]=c[k>>2]}I=c[m>>2]|0;c[m>>2]=I+1;a[(c[j>>2]|0)+I>>0]=64}if(c[(c[h>>2]|0)+12>>2]|0){c[l>>2]=c[(c[h>>2]|0)+12>>2];while(1){if(!(a[c[l>>2]>>0]|0))break;if((c[m>>2]|0)>=(c[n>>2]|0)){c[k>>2]=Nl(c[j>>2]|0,n)|0;if(!(c[k>>2]|0))break b;c[j>>2]=c[k>>2]}I=c[l>>2]|0;c[l>>2]=I+1;b=a[I>>0]|0;I=c[m>>2]|0;c[m>>2]=I+1;a[(c[j>>2]|0)+I>>0]=b}if((c[(c[h>>2]|0)+20>>2]|0)>0){if(((c[m>>2]|0)+10|0)>=(c[n>>2]|0)){c[k>>2]=Nl(c[j>>2]|0,n)|0;if(!(c[k>>2]|0))break b;c[j>>2]=c[k>>2]}b=(c[j>>2]|0)+(c[m>>2]|0)|0;I=(c[n>>2]|0)-(c[m>>2]|0)|0;c[f>>2]=c[(c[h>>2]|0)+20>>2];L=JT(b,I,79e3,f)|0;c[m>>2]=(c[m>>2]|0)+L}}}g:do if(c[(c[h>>2]|0)+24>>2]|0){c[l>>2]=c[(c[h>>2]|0)+24>>2];do if((c[c[h>>2]>>2]|0)!=0?(a[c[l>>2]>>0]|0)==47:0){if(!((a[(c[l>>2]|0)+1>>0]|0)>=97?(a[(c[l>>2]|0)+1>>0]|0)<=122:0)){if((a[(c[l>>2]|0)+1>>0]|0)<65)break;if((a[(c[l>>2]|0)+1>>0]|0)>90)break}if((a[(c[l>>2]|0)+2>>0]|0)==58?(qy(c[c[h>>2]>>2]|0,79008)|0)!=0:0){if(((c[m>>2]|0)+3|0)>=(c[n>>2]|0)){c[k>>2]=Nl(c[j>>2]|0,n)|0;if(!(c[k>>2]|0))break b;c[j>>2]=c[k>>2]}L=c[l>>2]|0;c[l>>2]=L+1;I=a[L>>0]|0;L=c[m>>2]|0;c[m>>2]=L+1;a[(c[j>>2]|0)+L>>0]=I;I=c[l>>2]|0;c[l>>2]=I+1;L=a[I>>0]|0;I=c[m>>2]|0;c[m>>2]=I+1;a[(c[j>>2]|0)+I>>0]=L;L=c[l>>2]|0;c[l>>2]=L+1;I=a[L>>0]|0;L=c[m>>2]|0;c[m>>2]=L+1;a[(c[j>>2]|0)+L>>0]=I}}while(0);h:while(1){if(!(a[c[l>>2]>>0]|0))break g;if(((c[m>>2]|0)+3|0)>=(c[n>>2]|0)){c[k>>2]=Nl(c[j>>2]|0,n)|0;if(!(c[k>>2]|0))break b;c[j>>2]=c[k>>2]}if(!((a[c[l>>2]>>0]|0)>=97?(a[c[l>>2]>>0]|0)<=122:0))J=159;do if((J|0)==159){J=0;if((a[c[l>>2]>>0]|0)>=65?(a[c[l>>2]>>0]|0)<=90:0)break;if((a[c[l>>2]>>0]|0)>=48?(a[c[l>>2]>>0]|0)<=57:0)break;if(((a[c[l>>2]>>0]|0)!=45?(a[c[l>>2]>>0]|0)!=95:0)?(a[c[l>>2]>>0]|0)!=46:0){if((a[c[l>>2]>>0]|0)==33)break;if((a[c[l>>2]>>0]|0)==126)break;if((a[c[l>>2]>>0]|0)==42)break;if((a[c[l>>2]>>0]|0)==39)break;if((a[c[l>>2]>>0]|0)==40)break;if((a[c[l>>2]>>0]|0)==41)break;if((a[c[l>>2]>>0]|0)==47)break;if((a[c[l>>2]>>0]|0)==59)break;if((a[c[l>>2]>>0]|0)==64)break;if((a[c[l>>2]>>0]|0)==38)break;if((a[c[l>>2]>>0]|0)==61)break;if((a[c[l>>2]>>0]|0)==43)break;if((a[c[l>>2]>>0]|0)==36)break;if((a[c[l>>2]>>0]|0)==44)break;I=c[l>>2]|0;c[l>>2]=I+1;c[x>>2]=d[I>>0];c[y>>2]=(c[x>>2]|0)/16|0;c[z>>2]=(c[x>>2]|0)%16|0;I=c[m>>2]|0;c[m>>2]=I+1;a[(c[j>>2]|0)+I>>0]=37;I=(c[y>>2]|0)+((c[y>>2]|0)>9?55:48)&255;L=c[m>>2]|0;c[m>>2]=L+1;a[(c[j>>2]|0)+L>>0]=I;I=(c[z>>2]|0)+((c[z>>2]|0)>9?55:48)&255;L=c[m>>2]|0;c[m>>2]=L+1;a[(c[j>>2]|0)+L>>0]=I;continue h}}while(0);I=c[l>>2]|0;c[l>>2]=I+1;L=a[I>>0]|0;I=c[m>>2]|0;c[m>>2]=I+1;a[(c[j>>2]|0)+I>>0]=L}}while(0);if(c[(c[h>>2]|0)+40>>2]|0){if(((c[m>>2]|0)+1|0)>=(c[n>>2]|0)){c[k>>2]=Nl(c[j>>2]|0,n)|0;if(!(c[k>>2]|0))break b;c[j>>2]=c[k>>2]}L=c[m>>2]|0;c[m>>2]=L+1;a[(c[j>>2]|0)+L>>0]=63;c[l>>2]=c[(c[h>>2]|0)+40>>2];while(1){if(!(a[c[l>>2]>>0]|0))break c;if(((c[m>>2]|0)+1|0)>=(c[n>>2]|0)){c[k>>2]=Nl(c[j>>2]|0,n)|0;if(!(c[k>>2]|0))break b;c[j>>2]=c[k>>2]}L=c[l>>2]|0;c[l>>2]=L+1;I=a[L>>0]|0;L=c[m>>2]|0;c[m>>2]=L+1;a[(c[j>>2]|0)+L>>0]=I}}if(c[(c[h>>2]|0)+28>>2]|0){if(((c[m>>2]|0)+3|0)>=(c[n>>2]|0)){c[k>>2]=Nl(c[j>>2]|0,n)|0;if(!(c[k>>2]|0))break b;c[j>>2]=c[k>>2]}I=c[m>>2]|0;c[m>>2]=I+1;a[(c[j>>2]|0)+I>>0]=63;c[l>>2]=c[(c[h>>2]|0)+28>>2];i:while(1){if(!(a[c[l>>2]>>0]|0))break c;if(((c[m>>2]|0)+3|0)>=(c[n>>2]|0)){c[k>>2]=Nl(c[j>>2]|0,n)|0;if(!(c[k>>2]|0))break b;c[j>>2]=c[k>>2]}if(!((a[c[l>>2]>>0]|0)>=97?(a[c[l>>2]>>0]|0)<=122:0))J=203;do if((J|0)==203){J=0;if((a[c[l>>2]>>0]|0)>=65?(a[c[l>>2]>>0]|0)<=90:0)break;if((a[c[l>>2]>>0]|0)>=48?(a[c[l>>2]>>0]|0)<=57:0)break;if((a[c[l>>2]>>0]|0)!=45?(a[c[l>>2]>>0]|0)!=95:0){if((a[c[l>>2]>>0]|0)==46)break;if((a[c[l>>2]>>0]|0)==33)break;if((a[c[l>>2]>>0]|0)==126)break;if((a[c[l>>2]>>0]|0)==42)break;if((a[c[l>>2]>>0]|0)==39)break;if((a[c[l>>2]>>0]|0)==40)break;if((a[c[l>>2]>>0]|0)==41)break;if((a[c[l>>2]>>0]|0)==59)break;if((a[c[l>>2]>>0]|0)==47)break;if((a[c[l>>2]>>0]|0)==63)break;if((a[c[l>>2]>>0]|0)==58)break;if((a[c[l>>2]>>0]|0)==64)break;if((a[c[l>>2]>>0]|0)==38)break;if((a[c[l>>2]>>0]|0)==61)break;if((a[c[l>>2]>>0]|0)==43)break;if((a[c[l>>2]>>0]|0)==36)break;if((a[c[l>>2]>>0]|0)==44)break;if((a[c[l>>2]>>0]|0)==91)break;if((a[c[l>>2]>>0]|0)==93)break;I=c[l>>2]|0;c[l>>2]=I+1;c[A>>2]=d[I>>0];c[B>>2]=(c[A>>2]|0)/16|0;c[C>>2]=(c[A>>2]|0)%16|0;I=c[m>>2]|0;c[m>>2]=I+1;a[(c[j>>2]|0)+I>>0]=37;I=(c[B>>2]|0)+((c[B>>2]|0)>9?55:48)&255;L=c[m>>2]|0;c[m>>2]=L+1;a[(c[j>>2]|0)+L>>0]=I;I=(c[C>>2]|0)+((c[C>>2]|0)>9?55:48)&255;L=c[m>>2]|0;c[m>>2]=L+1;a[(c[j>>2]|0)+L>>0]=I;continue i}}while(0);I=c[l>>2]|0;c[l>>2]=I+1;L=a[I>>0]|0;I=c[m>>2]|0;c[m>>2]=I+1;a[(c[j>>2]|0)+I>>0]=L}}}else{c[l>>2]=c[H+4>>2];j:while(1){if(!(a[c[l>>2]>>0]|0))break c;if(((c[m>>2]|0)+3|0)>=(c[n>>2]|0)){c[k>>2]=Nl(c[j>>2]|0,n)|0;if(!(c[k>>2]|0))break b;c[j>>2]=c[k>>2]}do if((((((((((a[c[l>>2]>>0]|0)!=59?(a[c[l>>2]>>0]|0)!=47:0)?(a[c[l>>2]>>0]|0)!=63:0)?(a[c[l>>2]>>0]|0)!=58:0)?(a[c[l>>2]>>0]|0)!=64:0)?(a[c[l>>2]>>0]|0)!=38:0)?(a[c[l>>2]>>0]|0)!=61:0)?(a[c[l>>2]>>0]|0)!=43:0)?(a[c[l>>2]>>0]|0)!=36:0)?(a[c[l>>2]>>0]|0)!=44:0){if((a[c[l>>2]>>0]|0)==91)break;if((a[c[l>>2]>>0]|0)==93)break;if((a[c[l>>2]>>0]|0)>=97?(a[c[l>>2]>>0]|0)<=122:0)break;if((a[c[l>>2]>>0]|0)>=65?(a[c[l>>2]>>0]|0)<=90:0)break;if((a[c[l>>2]>>0]|0)>=48?(a[c[l>>2]>>0]|0)<=57:0)break;if((a[c[l>>2]>>0]|0)==45)break;if((a[c[l>>2]>>0]|0)==95)break;if((a[c[l>>2]>>0]|0)==46)break;if((a[c[l>>2]>>0]|0)==33)break;if((a[c[l>>2]>>0]|0)==126)break;if((a[c[l>>2]>>0]|0)==42)break;if((a[c[l>>2]>>0]|0)==39)break;if((a[c[l>>2]>>0]|0)==40)break;if((a[c[l>>2]>>0]|0)==41)break;L=c[l>>2]|0;c[l>>2]=L+1;c[o>>2]=d[L>>0];c[p>>2]=(c[o>>2]|0)/16|0;c[q>>2]=(c[o>>2]|0)%16|0;L=c[m>>2]|0;c[m>>2]=L+1;a[(c[j>>2]|0)+L>>0]=37;L=(c[p>>2]|0)+((c[p>>2]|0)>9?55:48)&255;I=c[m>>2]|0;c[m>>2]=I+1;a[(c[j>>2]|0)+I>>0]=L;L=(c[q>>2]|0)+((c[q>>2]|0)>9?55:48)&255;I=c[m>>2]|0;c[m>>2]=I+1;a[(c[j>>2]|0)+I>>0]=L;continue j}while(0);L=c[l>>2]|0;c[l>>2]=L+1;I=a[L>>0]|0;L=c[m>>2]|0;c[m>>2]=L+1;a[(c[j>>2]|0)+L>>0]=I}}while(0);k:do if(c[(c[h>>2]|0)+32>>2]|0){if(((c[m>>2]|0)+3|0)>=(c[n>>2]|0)){c[k>>2]=Nl(c[j>>2]|0,n)|0;if(!(c[k>>2]|0))break b;c[j>>2]=c[k>>2]}H=c[m>>2]|0;c[m>>2]=H+1;a[(c[j>>2]|0)+H>>0]=35;c[l>>2]=c[(c[h>>2]|0)+32>>2];l:while(1){if(!(a[c[l>>2]>>0]|0))break k;if(((c[m>>2]|0)+3|0)>=(c[n>>2]|0)){c[k>>2]=Nl(c[j>>2]|0,n)|0;if(!(c[k>>2]|0))break b;c[j>>2]=c[k>>2]}if(!((a[c[l>>2]>>0]|0)>=97?(a[c[l>>2]>>0]|0)<=122:0))J=241;do if((J|0)==241){J=0;if((a[c[l>>2]>>0]|0)>=65?(a[c[l>>2]>>0]|0)<=90:0)break;if((a[c[l>>2]>>0]|0)>=48?(a[c[l>>2]>>0]|0)<=57:0)break;if(((((a[c[l>>2]>>0]|0)!=45?(a[c[l>>2]>>0]|0)!=95:0)?(a[c[l>>2]>>0]|0)!=46:0)?(a[c[l>>2]>>0]|0)!=33:0)?(a[c[l>>2]>>0]|0)!=126:0){if((a[c[l>>2]>>0]|0)==42)break;if((a[c[l>>2]>>0]|0)==39)break;if((a[c[l>>2]>>0]|0)==40)break;if((a[c[l>>2]>>0]|0)==41)break;if((a[c[l>>2]>>0]|0)==59)break;if((a[c[l>>2]>>0]|0)==47)break;if((a[c[l>>2]>>0]|0)==63)break;if((a[c[l>>2]>>0]|0)==58)break;if((a[c[l>>2]>>0]|0)==64)break;if((a[c[l>>2]>>0]|0)==38)break;if((a[c[l>>2]>>0]|0)==61)break;if((a[c[l>>2]>>0]|0)==43)break;if((a[c[l>>2]>>0]|0)==36)break;if((a[c[l>>2]>>0]|0)==44)break;if((a[c[l>>2]>>0]|0)==91)break;if((a[c[l>>2]>>0]|0)==93)break;H=c[l>>2]|0;c[l>>2]=H+1;c[D>>2]=d[H>>0];c[E>>2]=(c[D>>2]|0)/16|0;c[F>>2]=(c[D>>2]|0)%16|0;H=c[m>>2]|0;c[m>>2]=H+1;a[(c[j>>2]|0)+H>>0]=37;H=(c[E>>2]|0)+((c[E>>2]|0)>9?55:48)&255;I=c[m>>2]|0;c[m>>2]=I+1;a[(c[j>>2]|0)+I>>0]=H;H=(c[F>>2]|0)+((c[F>>2]|0)>9?55:48)&255;I=c[m>>2]|0;c[m>>2]=I+1;a[(c[j>>2]|0)+I>>0]=H;continue l}}while(0);H=c[l>>2]|0;c[l>>2]=H+1;I=a[H>>0]|0;H=c[m>>2]|0;c[m>>2]=H+1;a[(c[j>>2]|0)+H>>0]=I}}while(0);if((c[m>>2]|0)>=(c[n>>2]|0)){c[k>>2]=Nl(c[j>>2]|0,n)|0;if(!(c[k>>2]|0))break;c[j>>2]=c[k>>2]}a[(c[j>>2]|0)+(c[m>>2]|0)>>0]=0;c[g>>2]=c[j>>2];G=c[g>>2]|0;i=e;return G|0}while(0);zb[c[135736>>2]&511](c[j>>2]|0);c[g>>2]=0;G=c[g>>2]|0;i=e;return G|0}function Dl(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=b;if(!(c[f>>2]|0)){c[e>>2]=-1;l=c[e>>2]|0;i=d;return l|0}c[g>>2]=c[f>>2];while(1){m=c[g>>2]|0;if((a[c[g>>2]>>0]|0)!=47)break;c[g>>2]=m+1}if(!(a[m>>0]|0)){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}c[h>>2]=c[g>>2];a:while(1){if(!(a[c[g>>2]>>0]|0))break;if((a[c[g>>2]>>0]|0)==46?(a[(c[g>>2]|0)+1>>0]|0)==47:0){c[g>>2]=(c[g>>2]|0)+2;while(1){if((a[c[g>>2]>>0]|0)!=47)continue a;c[g>>2]=(c[g>>2]|0)+1}}if((a[c[g>>2]>>0]|0)==46?(a[(c[g>>2]|0)+1>>0]|0)==0:0)break;while(1){if((a[c[g>>2]>>0]|0)==47)break;if(!(a[c[g>>2]>>0]|0))break a;m=c[g>>2]|0;c[g>>2]=m+1;b=a[m>>0]|0;m=c[h>>2]|0;c[h>>2]=m+1;a[m>>0]=b}do{if((a[c[g>>2]>>0]|0)==47)n=(a[(c[g>>2]|0)+1>>0]|0)==47;else n=0;o=c[g>>2]|0;c[g>>2]=o+1}while(n);b=a[o>>0]|0;m=c[h>>2]|0;c[h>>2]=m+1;a[m>>0]=b}a[c[h>>2]>>0]=0;c[g>>2]=c[f>>2];while(1){p=c[g>>2]|0;if((a[c[g>>2]>>0]|0)!=47)break;c[g>>2]=p+1}if(!(a[p>>0]|0)){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}b:while(1){c[j>>2]=c[g>>2];while(1){if((a[c[j>>2]>>0]|0)!=47)q=(a[c[j>>2]>>0]|0)!=0;else q=0;r=c[j>>2]|0;if(!q)break;c[j>>2]=r+1}if(!(a[r>>0]|0))break;c[j>>2]=(c[j>>2]|0)+1;if(!(((a[c[g>>2]>>0]|0)==46?(a[(c[g>>2]|0)+1>>0]|0)==46:0)?(c[j>>2]|0)==((c[g>>2]|0)+3|0):0))s=38;do if(((s|0)==38?(s=0,(a[c[j>>2]>>0]|0)==46):0)?(a[(c[j>>2]|0)+1>>0]|0)==46:0){if((a[(c[j>>2]|0)+2>>0]|0)!=47?(a[(c[j>>2]|0)+2>>0]|0)!=0:0)break;t=c[g>>2]|0;if(!(a[(c[j>>2]|0)+2>>0]|0)){s=44;break b}c[k>>2]=t;c[j>>2]=(c[j>>2]|0)+3;do{p=c[j>>2]|0;c[j>>2]=p+1;o=a[p>>0]|0;p=c[k>>2]|0;c[k>>2]=p+1;a[p>>0]=o}while((o<<24>>24|0)!=0);c[j>>2]=c[g>>2];do{if((c[j>>2]|0)>>>0<=(c[f>>2]|0)>>>0)break;o=(c[j>>2]|0)+-1|0;c[j>>2]=o}while((a[o>>0]|0)==47);if((c[j>>2]|0)==(c[f>>2]|0))continue b;c[g>>2]=c[j>>2];while(1){if((c[g>>2]|0)>>>0<=(c[f>>2]|0)>>>0)continue b;if((a[(c[g>>2]|0)+-1>>0]|0)==47)continue b;c[g>>2]=(c[g>>2]|0)+-1}}while(0);c[g>>2]=c[j>>2]}if((s|0)==44)a[t>>0]=0;a[c[h>>2]>>0]=0;if((a[c[f>>2]>>0]|0)==47){c[g>>2]=c[f>>2];while(1){if(((a[c[g>>2]>>0]|0)==47?(a[(c[g>>2]|0)+1>>0]|0)==46:0)?(a[(c[g>>2]|0)+2>>0]|0)==46:0)if((a[(c[g>>2]|0)+3>>0]|0)==47)u=1;else u=(a[(c[g>>2]|0)+3>>0]|0)==0;else u=0;v=c[g>>2]|0;if(!u)break;c[g>>2]=v+3}if((v|0)!=(c[f>>2]|0)){c[h>>2]=c[f>>2];while(1){if(!(a[c[g>>2]>>0]|0))break;f=c[g>>2]|0;c[g>>2]=f+1;v=a[f>>0]|0;f=c[h>>2]|0;c[h>>2]=f+1;a[f>>0]=v}a[c[h>>2]>>0]=0}}c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}function El(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;if(!(c[h>>2]|0)){c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}if((c[j>>2]|0)<=0)c[j>>2]=ZT(c[h>>2]|0)|0;if((c[j>>2]|0)<0){c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}if(!(c[k>>2]|0)){c[l>>2]=Cb[c[135752>>2]&511]((c[j>>2]|0)+1|0)|0;if(!(c[l>>2]|0)){Ml(79016);c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}}else c[l>>2]=c[k>>2];c[n>>2]=c[h>>2];c[m>>2]=c[l>>2];while(1){if((c[j>>2]|0)<=0)break;if((((c[j>>2]|0)>2?(a[c[n>>2]>>0]|0)==37:0)?(Ol(a[(c[n>>2]|0)+1>>0]|0)|0)!=0:0)?(Ol(a[(c[n>>2]|0)+2>>0]|0)|0)!=0:0){c[n>>2]=(c[n>>2]|0)+1;if((a[c[n>>2]>>0]|0)>=48?(a[c[n>>2]>>0]|0)<=57:0)a[c[m>>2]>>0]=(a[c[n>>2]>>0]|0)-48;else p=20;do if((p|0)==20){p=0;if((a[c[n>>2]>>0]|0)>=97?(a[c[n>>2]>>0]|0)<=102:0){a[c[m>>2]>>0]=(a[c[n>>2]>>0]|0)-97+10;break}if((a[c[n>>2]>>0]|0)>=65?(a[c[n>>2]>>0]|0)<=70:0)a[c[m>>2]>>0]=(a[c[n>>2]>>0]|0)-65+10}while(0);c[n>>2]=(c[n>>2]|0)+1;if((a[c[n>>2]>>0]|0)>=48?(a[c[n>>2]>>0]|0)<=57:0)a[c[m>>2]>>0]=(a[c[m>>2]>>0]<<4)+((a[c[n>>2]>>0]|0)-48);else p=29;do if((p|0)==29){p=0;if((a[c[n>>2]>>0]|0)>=97?(a[c[n>>2]>>0]|0)<=102:0){a[c[m>>2]>>0]=(a[c[m>>2]>>0]<<4)+((a[c[n>>2]>>0]|0)-97)+10;break}if((a[c[n>>2]>>0]|0)>=65?(a[c[n>>2]>>0]|0)<=70:0)a[c[m>>2]>>0]=(a[c[m>>2]>>0]<<4)+((a[c[n>>2]>>0]|0)-65)+10}while(0);c[n>>2]=(c[n>>2]|0)+1;c[j>>2]=(c[j>>2]|0)-3;c[m>>2]=(c[m>>2]|0)+1;continue}h=c[n>>2]|0;c[n>>2]=h+1;k=a[h>>0]|0;h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=k;c[j>>2]=(c[j>>2]|0)+-1}a[c[m>>2]>>0]=0;c[g>>2]=c[l>>2];o=c[g>>2]|0;i=f;return o|0}function Fl(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+48|0;g=f+28|0;h=f+24|0;j=f+20|0;k=f+16|0;l=f+33|0;m=f+12|0;n=f+8|0;o=f+4|0;p=f;q=f+32|0;c[h>>2]=b;c[j>>2]=e;if(!(c[h>>2]|0)){c[g>>2]=0;r=c[g>>2]|0;i=f;return r|0}e=c[h>>2]|0;if(!(d[c[h>>2]>>0]|0)){c[g>>2]=my(e)|0;r=c[g>>2]|0;i=f;return r|0}c[o>>2]=xy(e)|0;if((c[o>>2]|0)<=0){c[g>>2]=0;r=c[g>>2]|0;i=f;return r|0}c[o>>2]=(c[o>>2]|0)+20;c[k>>2]=Cb[c[135752>>2]&511](c[o>>2]|0)|0;if(!(c[k>>2]|0)){Ml(79040);c[g>>2]=0;r=c[g>>2]|0;i=f;return r|0}c[n>>2]=c[h>>2];c[p>>2]=0;a:while(1){if(!(d[c[n>>2]>>0]|0)){s=40;break}if(((c[o>>2]|0)-(c[p>>2]|0)|0)<=3){c[m>>2]=Nl(c[k>>2]|0,o)|0;if(!(c[m>>2]|0)){s=13;break}c[k>>2]=c[m>>2]}a[l>>0]=a[c[n>>2]>>0]|0;do if((d[l>>0]|0|0)!=64){if((d[l>>0]|0|0)>=97?(d[l>>0]|0|0)<=122:0)break;if((d[l>>0]|0|0)>=65?(d[l>>0]|0|0)<=90:0)break;if((d[l>>0]|0|0)>=48?(d[l>>0]|0|0)<=57:0)break;if((((((((d[l>>0]|0|0)!=45?(d[l>>0]|0|0)!=95:0)?(d[l>>0]|0|0)!=46:0)?(d[l>>0]|0|0)!=33:0)?(d[l>>0]|0|0)!=126:0)?(d[l>>0]|0|0)!=42:0)?(d[l>>0]|0|0)!=39:0)?(d[l>>0]|0|0)!=40:0){if((d[l>>0]|0|0)==41)break;if(vy(c[j>>2]|0,a[l>>0]|0)|0)break;h=c[p>>2]|0;c[p>>2]=h+1;a[(c[k>>2]|0)+h>>0]=37;a[q>>0]=(d[l>>0]|0)>>4;h=d[q>>0]|0;if((d[q>>0]|0|0)<=9){e=c[p>>2]|0;c[p>>2]=e+1;a[(c[k>>2]|0)+e>>0]=48+h}else{e=c[p>>2]|0;c[p>>2]=e+1;a[(c[k>>2]|0)+e>>0]=65+h-10}a[q>>0]=(d[l>>0]|0)&15;h=d[q>>0]|0;if((d[q>>0]|0|0)<=9){e=c[p>>2]|0;c[p>>2]=e+1;a[(c[k>>2]|0)+e>>0]=48+h}else{e=c[p>>2]|0;c[p>>2]=e+1;a[(c[k>>2]|0)+e>>0]=65+h-10}c[n>>2]=(c[n>>2]|0)+1;continue a}}while(0);h=c[n>>2]|0;c[n>>2]=h+1;e=a[h>>0]|0;h=c[p>>2]|0;c[p>>2]=h+1;a[(c[k>>2]|0)+h>>0]=e}if((s|0)==13){Ml(79040);zb[c[135736>>2]&511](c[k>>2]|0);c[g>>2]=0;r=c[g>>2]|0;i=f;return r|0}else if((s|0)==40){a[(c[k>>2]|0)+(c[p>>2]|0)>>0]=0;c[g>>2]=c[k>>2];r=c[g>>2]|0;i=f;return r|0}return 0}function Gl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=b;e=b+24|0;f=b+20|0;g=b+16|0;h=b+12|0;j=b+8|0;k=b+4|0;l=b+28|0;c[f>>2]=a;c[h>>2]=0;if(!(c[f>>2]|0)){c[e>>2]=0;m=c[e>>2]|0;i=b;return m|0}c[j>>2]=zl()|0;if((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+36>>2]=1,c[k>>2]=Bl(c[j>>2]|0,c[f>>2]|0)|0,(c[k>>2]|0)!=0):0){Al(c[j>>2]|0);c[e>>2]=0;m=c[e>>2]|0;i=b;return m|0}if(!(c[j>>2]|0)){c[e>>2]=0;m=c[e>>2]|0;i=b;return m|0}c[g>>2]=0;do if(c[c[j>>2]>>2]|0){c[h>>2]=Fl(c[c[j>>2]>>2]|0,79064)|0;if(c[h>>2]|0){c[g>>2]=By(c[g>>2]|0,c[h>>2]|0)|0;c[g>>2]=By(c[g>>2]|0,79072)|0;zb[c[135736>>2]&511](c[h>>2]|0);break}Ml(79040);Al(c[j>>2]|0);c[e>>2]=0;m=c[e>>2]|0;i=b;return m|0}while(0);do if(c[(c[j>>2]|0)+8>>2]|0){c[h>>2]=Fl(c[(c[j>>2]|0)+8>>2]|0,79080)|0;if(c[h>>2]|0){c[g>>2]=By(c[g>>2]|0,79088)|0;c[g>>2]=By(c[g>>2]|0,c[h>>2]|0)|0;zb[c[135736>>2]&511](c[h>>2]|0);break}Ml(79040);Al(c[j>>2]|0);c[e>>2]=0;m=c[e>>2]|0;i=b;return m|0}while(0);do if(c[(c[j>>2]|0)+16>>2]|0){c[h>>2]=Fl(c[(c[j>>2]|0)+16>>2]|0,79096)|0;if(c[h>>2]|0){c[g>>2]=By(c[g>>2]|0,79088)|0;c[g>>2]=By(c[g>>2]|0,c[h>>2]|0)|0;c[g>>2]=By(c[g>>2]|0,79104)|0;zb[c[135736>>2]&511](c[h>>2]|0);break}Ml(79040);Al(c[j>>2]|0);c[e>>2]=0;m=c[e>>2]|0;i=b;return m|0}while(0);if(c[(c[j>>2]|0)+12>>2]|0){c[h>>2]=Fl(c[(c[j>>2]|0)+12>>2]|0,79080)|0;if(!(c[h>>2]|0)){Ml(79040);Al(c[j>>2]|0);c[e>>2]=0;m=c[e>>2]|0;i=b;return m|0}if(!(c[(c[j>>2]|0)+16>>2]|0))c[g>>2]=By(c[g>>2]|0,79088)|0;c[g>>2]=By(c[g>>2]|0,c[h>>2]|0)|0;zb[c[135736>>2]&511](c[h>>2]|0)}if(c[(c[j>>2]|0)+20>>2]|0){c[d>>2]=c[(c[j>>2]|0)+20>>2];JT(l,10,79112,d)|0;c[g>>2]=By(c[g>>2]|0,79072)|0;c[g>>2]=By(c[g>>2]|0,l)|0}do if(c[(c[j>>2]|0)+24>>2]|0){c[h>>2]=Fl(c[(c[j>>2]|0)+24>>2]|0,79120)|0;if(c[h>>2]|0){c[g>>2]=By(c[g>>2]|0,c[h>>2]|0)|0;zb[c[135736>>2]&511](c[h>>2]|0);break}Ml(79040);Al(c[j>>2]|0);c[e>>2]=0;m=c[e>>2]|0;i=b;return m|0}while(0);do if(!(c[(c[j>>2]|0)+40>>2]|0)){if(c[(c[j>>2]|0)+28>>2]|0){c[h>>2]=Fl(c[(c[j>>2]|0)+28>>2]|0,79144)|0;if(c[h>>2]|0){c[g>>2]=By(c[g>>2]|0,79136)|0;c[g>>2]=By(c[g>>2]|0,c[h>>2]|0)|0;zb[c[135736>>2]&511](c[h>>2]|0);break}Ml(79040);Al(c[j>>2]|0);c[e>>2]=0;m=c[e>>2]|0;i=b;return m|0}}else{c[g>>2]=By(c[g>>2]|0,79136)|0;c[g>>2]=By(c[g>>2]|0,c[(c[j>>2]|0)+40>>2]|0)|0}while(0);do if(c[(c[j>>2]|0)+4>>2]|0){c[h>>2]=Fl(c[(c[j>>2]|0)+4>>2]|0,79160)|0;if(c[h>>2]|0){c[g>>2]=By(c[g>>2]|0,c[h>>2]|0)|0;zb[c[135736>>2]&511](c[h>>2]|0);break}Ml(79040);Al(c[j>>2]|0);c[e>>2]=0;m=c[e>>2]|0;i=b;return m|0}while(0);do if(c[(c[j>>2]|0)+32>>2]|0){c[h>>2]=Fl(c[(c[j>>2]|0)+32>>2]|0,79168)|0;if(c[h>>2]|0){c[g>>2]=By(c[g>>2]|0,79168)|0;c[g>>2]=By(c[g>>2]|0,c[h>>2]|0)|0;zb[c[135736>>2]&511](c[h>>2]|0);break}Ml(79040);Al(c[j>>2]|0);c[e>>2]=0;m=c[e>>2]|0;i=b;return m|0}while(0);Al(c[j>>2]|0);c[e>>2]=c[g>>2];m=c[e>>2]|0;i=b;return m|0}function Hl(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;i=i+48|0;f=e+40|0;g=e+36|0;h=e+32|0;j=e+28|0;k=e+24|0;l=e+20|0;m=e+16|0;n=e+12|0;o=e+8|0;p=e+4|0;q=e;c[f>>2]=b;c[g>>2]=d;c[h>>2]=0;c[o>>2]=0;c[p>>2]=0;c[q>>2]=0;do if(c[f>>2]|0){if(!(a[c[f>>2]>>0]|0)){c[j>>2]=0;r=7;break}c[o>>2]=zl()|0;if(c[o>>2]|0){c[j>>2]=Bl(c[o>>2]|0,c[f>>2]|0)|0;r=7}}else{c[j>>2]=-1;r=7}while(0);a:do if((r|0)==7?(c[j>>2]|0)==0:0){if((c[o>>2]|0)!=0?(c[c[o>>2]>>2]|0)!=0:0){c[h>>2]=my(c[f>>2]|0)|0;break}if(!(c[g>>2]|0))c[j>>2]=-1;else{c[p>>2]=zl()|0;if(!(c[p>>2]|0))break;c[j>>2]=Bl(c[p>>2]|0,c[g>>2]|0)|0}d=c[o>>2]|0;if(c[j>>2]|0){if(!d)break;c[h>>2]=Cl(c[o>>2]|0)|0;break}if(!d){if(c[(c[p>>2]|0)+32>>2]|0){zb[c[135736>>2]&511](c[(c[p>>2]|0)+32>>2]|0);c[(c[p>>2]|0)+32>>2]=0}c[h>>2]=Cl(c[p>>2]|0)|0;break}c[q>>2]=zl()|0;if(c[q>>2]|0){if((((c[c[o>>2]>>2]|0)==0?(c[(c[o>>2]|0)+24>>2]|0)==0:0)?(c[(c[o>>2]|0)+8>>2]|0)==0:0)?(c[(c[o>>2]|0)+12>>2]|0)==0:0){if(c[c[p>>2]>>2]|0){d=Cb[c[135768>>2]&511](c[c[p>>2]>>2]|0)|0;c[c[q>>2]>>2]=d}if(!(c[(c[p>>2]|0)+8>>2]|0)){if(c[(c[p>>2]|0)+12>>2]|0){d=Cb[c[135768>>2]&511](c[(c[p>>2]|0)+12>>2]|0)|0;c[(c[q>>2]|0)+12>>2]=d;if(c[(c[p>>2]|0)+16>>2]|0){d=Cb[c[135768>>2]&511](c[(c[p>>2]|0)+16>>2]|0)|0;c[(c[q>>2]|0)+16>>2]=d}c[(c[q>>2]|0)+20>>2]=c[(c[p>>2]|0)+20>>2]}}else{d=Cb[c[135768>>2]&511](c[(c[p>>2]|0)+8>>2]|0)|0;c[(c[q>>2]|0)+8>>2]=d}if(c[(c[p>>2]|0)+24>>2]|0){d=Cb[c[135768>>2]&511](c[(c[p>>2]|0)+24>>2]|0)|0;c[(c[q>>2]|0)+24>>2]=d}do if(c[(c[o>>2]|0)+40>>2]|0){d=Cb[c[135768>>2]&511](c[(c[o>>2]|0)+40>>2]|0)|0;c[(c[q>>2]|0)+40>>2]=d}else{if(c[(c[o>>2]|0)+28>>2]|0){d=Cb[c[135768>>2]&511](c[(c[o>>2]|0)+28>>2]|0)|0;c[(c[q>>2]|0)+28>>2]=d;break}if(c[(c[p>>2]|0)+40>>2]|0){d=Cb[c[135768>>2]&511](c[(c[p>>2]|0)+40>>2]|0)|0;c[(c[q>>2]|0)+40>>2]=d;break}if(!(c[(c[p>>2]|0)+28>>2]|0))break;d=Cb[c[135768>>2]&511](c[(c[p>>2]|0)+28>>2]|0)|0;c[(c[q>>2]|0)+28>>2]=d}while(0);if(c[(c[o>>2]|0)+32>>2]|0){d=Cb[c[135768>>2]&511](c[(c[o>>2]|0)+32>>2]|0)|0;c[(c[q>>2]|0)+32>>2]=d}}else r=47;b:do if((r|0)==47){if(c[c[o>>2]>>2]|0){c[h>>2]=Cl(c[o>>2]|0)|0;break a}if(c[c[p>>2]>>2]|0){d=Cb[c[135768>>2]&511](c[c[p>>2]>>2]|0)|0;c[c[q>>2]>>2]=d}if(!(c[(c[o>>2]|0)+40>>2]|0)){if(c[(c[o>>2]|0)+28>>2]|0){d=Cb[c[135768>>2]&511](c[(c[o>>2]|0)+28>>2]|0)|0;c[(c[q>>2]|0)+28>>2]=d}}else{d=Cb[c[135768>>2]&511](c[(c[o>>2]|0)+40>>2]|0)|0;c[(c[q>>2]|0)+40>>2]=d}if(c[(c[o>>2]|0)+32>>2]|0){d=Cb[c[135768>>2]&511](c[(c[o>>2]|0)+32>>2]|0)|0;c[(c[q>>2]|0)+32>>2]=d}if((c[(c[o>>2]|0)+8>>2]|0)==0?(c[(c[o>>2]|0)+12>>2]|0)==0:0){if(!(c[(c[p>>2]|0)+8>>2]|0)){if(c[(c[p>>2]|0)+12>>2]|0){d=Cb[c[135768>>2]&511](c[(c[p>>2]|0)+12>>2]|0)|0;c[(c[q>>2]|0)+12>>2]=d;if(c[(c[p>>2]|0)+16>>2]|0){d=Cb[c[135768>>2]&511](c[(c[p>>2]|0)+16>>2]|0)|0;c[(c[q>>2]|0)+16>>2]=d}c[(c[q>>2]|0)+20>>2]=c[(c[p>>2]|0)+20>>2]}}else{d=Cb[c[135768>>2]&511](c[(c[p>>2]|0)+8>>2]|0)|0;c[(c[q>>2]|0)+8>>2]=d}do if(c[(c[o>>2]|0)+24>>2]|0){if((a[c[(c[o>>2]|0)+24>>2]>>0]|0)!=47)break;d=Cb[c[135768>>2]&511](c[(c[o>>2]|0)+24>>2]|0)|0;c[(c[q>>2]|0)+24>>2]=d;break b}while(0);c[k>>2]=2;if(c[(c[o>>2]|0)+24>>2]|0){d=ZT(c[(c[o>>2]|0)+24>>2]|0)|0;c[k>>2]=(c[k>>2]|0)+d}if(c[(c[p>>2]|0)+24>>2]|0){d=ZT(c[(c[p>>2]|0)+24>>2]|0)|0;c[k>>2]=(c[k>>2]|0)+d}d=Cb[c[135752>>2]&511](c[k>>2]|0)|0;c[(c[q>>2]|0)+24>>2]=d;if(!(c[(c[q>>2]|0)+24>>2]|0)){Ml(79176);break a}a[c[(c[q>>2]|0)+24>>2]>>0]=0;c[m>>2]=0;c[n>>2]=0;c:do if(c[(c[p>>2]|0)+24>>2]|0)d:while(1){if(!(a[(c[(c[p>>2]|0)+24>>2]|0)+(c[m>>2]|0)>>0]|0))break c;while(1){if(a[(c[(c[p>>2]|0)+24>>2]|0)+(c[m>>2]|0)>>0]|0)s=(a[(c[(c[p>>2]|0)+24>>2]|0)+(c[m>>2]|0)>>0]|0)!=47;else s=0;t=c[m>>2]|0;if(!s)break;c[m>>2]=t+1}if(!(a[(c[(c[p>>2]|0)+24>>2]|0)+t>>0]|0))break c;c[m>>2]=(c[m>>2]|0)+1;while(1){if((c[n>>2]|0)>=(c[m>>2]|0))continue d;a[(c[(c[q>>2]|0)+24>>2]|0)+(c[n>>2]|0)>>0]=a[(c[(c[p>>2]|0)+24>>2]|0)+(c[n>>2]|0)>>0]|0;c[n>>2]=(c[n>>2]|0)+1}}while(0);a[(c[(c[q>>2]|0)+24>>2]|0)+(c[n>>2]|0)>>0]=0;e:do if(c[(c[o>>2]|0)+24>>2]|0){if(!(a[c[(c[o>>2]|0)+24>>2]>>0]|0))break;c[l>>2]=0;do if(!(c[n>>2]|0)){if(!(c[(c[p>>2]|0)+12>>2]|0))break;d=c[n>>2]|0;c[n>>2]=d+1;a[(c[(c[q>>2]|0)+24>>2]|0)+d>>0]=47}while(0);while(1){if(!(a[(c[(c[o>>2]|0)+24>>2]|0)+(c[l>>2]|0)>>0]|0))break e;d=c[l>>2]|0;c[l>>2]=d+1;b=a[(c[(c[o>>2]|0)+24>>2]|0)+d>>0]|0;d=c[n>>2]|0;c[n>>2]=d+1;a[(c[(c[q>>2]|0)+24>>2]|0)+d>>0]=b}}while(0);a[(c[(c[q>>2]|0)+24>>2]|0)+(c[n>>2]|0)>>0]=0;Dl(c[(c[q>>2]|0)+24>>2]|0)|0;break}b=c[33942]|0;d=c[o>>2]|0;if(c[(c[o>>2]|0)+8>>2]|0){u=Cb[b&511](c[d+8>>2]|0)|0;c[(c[q>>2]|0)+8>>2]=u}else{u=Cb[b&511](c[d+12>>2]|0)|0;c[(c[q>>2]|0)+12>>2]=u;if(c[(c[o>>2]|0)+16>>2]|0){u=Cb[c[135768>>2]&511](c[(c[o>>2]|0)+16>>2]|0)|0;c[(c[q>>2]|0)+16>>2]=u}c[(c[q>>2]|0)+20>>2]=c[(c[o>>2]|0)+20>>2]}if(c[(c[o>>2]|0)+24>>2]|0){u=Cb[c[135768>>2]&511](c[(c[o>>2]|0)+24>>2]|0)|0;c[(c[q>>2]|0)+24>>2]=u}}while(0);c[h>>2]=Cl(c[q>>2]|0)|0}}while(0);if(c[o>>2]|0)Al(c[o>>2]|0);if(c[p>>2]|0)Al(c[p>>2]|0);if(!(c[q>>2]|0)){v=c[h>>2]|0;i=e;return v|0}Al(c[q>>2]|0);v=c[h>>2]|0;i=e;return v|0}function Il(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;f=i;i=i+64|0;g=f+56|0;h=f+52|0;j=f+48|0;k=f+44|0;l=f+40|0;m=f+36|0;n=f+32|0;o=f+28|0;p=f+24|0;q=f+20|0;r=f+16|0;s=f+12|0;t=f+8|0;u=f+4|0;v=f;c[h>>2]=b;c[j>>2]=e;c[k>>2]=0;c[n>>2]=0;c[o>>2]=0;c[q>>2]=0;c[r>>2]=0;c[v>>2]=0;if((c[h>>2]|0)!=0?(d[c[h>>2]>>0]|0)!=0:0){
c[q>>2]=zl()|0;if(!(c[q>>2]|0)){c[g>>2]=0;w=c[g>>2]|0;i=f;return w|0}if((d[c[h>>2]>>0]|0)!=46){c[l>>2]=Bl(c[q>>2]|0,c[h>>2]|0)|0;if(!(c[l>>2]|0))x=9}else{e=my(c[h>>2]|0)|0;c[(c[q>>2]|0)+24>>2]=e;x=9}a:do if((x|0)==9){if((c[j>>2]|0)!=0?(d[c[j>>2]>>0]|0)!=0:0){c[r>>2]=zl()|0;if(!(c[r>>2]|0))break;if((d[c[j>>2]>>0]|0)!=46){c[l>>2]=Bl(c[r>>2]|0,c[j>>2]|0)|0;if(c[l>>2]|0)break}else{e=my(c[j>>2]|0)|0;c[(c[r>>2]|0)+24>>2]=e}do if(c[c[q>>2]>>2]|0){if(((c[c[r>>2]>>2]|0)!=0?(py(c[c[r>>2]>>2]|0,c[c[q>>2]>>2]|0)|0)==0:0)?(py(c[(c[r>>2]|0)+12>>2]|0,c[(c[q>>2]|0)+12>>2]|0)|0)==0:0)break;c[k>>2]=my(c[h>>2]|0)|0;break a}while(0);if(qy(c[(c[r>>2]|0)+24>>2]|0,c[(c[q>>2]|0)+24>>2]|0)|0){c[k>>2]=my(79160)|0;break}e=c[(c[q>>2]|0)+24>>2]|0;if(!(c[(c[r>>2]|0)+24>>2]|0)){c[k>>2]=my(e)|0;break}if(!e){c[(c[q>>2]|0)+24>>2]=79208;c[v>>2]=1}if(!(c[(c[r>>2]|0)+24>>2]|0)){if(!(c[(c[q>>2]|0)+24>>2]|0))break;c[t>>2]=c[(c[q>>2]|0)+24>>2];if((d[c[t>>2]>>0]|0)==47)c[t>>2]=(c[t>>2]|0)+1;c[k>>2]=Fl(c[t>>2]|0,79216)|0;break}c[s>>2]=c[(c[r>>2]|0)+24>>2];if(!(c[(c[q>>2]|0)+24>>2]|0)){c[m>>2]=0;while(1){if(!(d[(c[s>>2]|0)+(c[m>>2]|0)>>0]|0))break;if((d[(c[s>>2]|0)+(c[m>>2]|0)>>0]|0)==47)c[o>>2]=(c[o>>2]|0)+1;c[m>>2]=(c[m>>2]|0)+1}c[t>>2]=0;c[p>>2]=1}else{do if((a[(c[(c[q>>2]|0)+24>>2]|0)+(c[n>>2]|0)>>0]|0)==46){if((a[(c[(c[q>>2]|0)+24>>2]|0)+((c[n>>2]|0)+1)>>0]|0)!=47)break;c[n>>2]=(c[n>>2]|0)+2}while(0);do if((d[c[s>>2]>>0]|0)==46){if((d[(c[s>>2]|0)+1>>0]|0)!=47){x=45;break}c[s>>2]=(c[s>>2]|0)+2}else x=45;while(0);do if((x|0)==45){if((d[c[s>>2]>>0]|0)!=47)break;if((a[(c[(c[q>>2]|0)+24>>2]|0)+(c[n>>2]|0)>>0]|0)==47)break;c[s>>2]=(c[s>>2]|0)+1}while(0);while(1){if((d[(c[s>>2]|0)+(c[n>>2]|0)>>0]|0)==(a[(c[(c[q>>2]|0)+24>>2]|0)+(c[n>>2]|0)>>0]|0))y=(d[(c[s>>2]|0)+(c[n>>2]|0)>>0]|0)!=0;else y=0;z=c[n>>2]|0;if(!y)break;c[n>>2]=z+1}if((d[(c[s>>2]|0)+z>>0]|0)==(a[(c[(c[q>>2]|0)+24>>2]|0)+(c[n>>2]|0)>>0]|0)){c[k>>2]=my(79160)|0;break}c[m>>2]=c[n>>2];e=c[m>>2]|0;do if((c[m>>2]|0)>0?(a[(c[(c[q>>2]|0)+24>>2]|0)+(c[m>>2]|0)>>0]|0)==47:0)c[m>>2]=e+-1;else{if(!((c[m>>2]|0)>1?(a[(c[(c[q>>2]|0)+24>>2]|0)+e>>0]|0)==0:0))break;if((a[(c[(c[q>>2]|0)+24>>2]|0)+((c[m>>2]|0)-1)>>0]|0)!=47)break;c[m>>2]=(c[m>>2]|0)-2}while(0);while(1){if((c[m>>2]|0)<=0)break;if((a[(c[(c[q>>2]|0)+24>>2]|0)+(c[m>>2]|0)>>0]|0)==47)break;c[m>>2]=(c[m>>2]|0)+-1}if(!(c[m>>2]|0))c[t>>2]=c[(c[q>>2]|0)+24>>2];else{c[m>>2]=(c[m>>2]|0)+1;c[t>>2]=(c[(c[q>>2]|0)+24>>2]|0)+(c[m>>2]|0)}b:do if((d[(c[s>>2]|0)+(c[n>>2]|0)>>0]|0)!=(a[(c[(c[q>>2]|0)+24>>2]|0)+(c[n>>2]|0)>>0]|0))while(1){if(!(d[(c[s>>2]|0)+(c[m>>2]|0)>>0]|0))break b;if((d[(c[s>>2]|0)+(c[m>>2]|0)>>0]|0)==47)c[o>>2]=(c[o>>2]|0)+1;c[m>>2]=(c[m>>2]|0)+1}while(0);c[p>>2]=(xy(c[t>>2]|0)|0)+1}if(!(c[o>>2]|0)){if(!(c[t>>2]|0))break;c[k>>2]=Fl(c[t>>2]|0,79216)|0;break}c[k>>2]=Cb[c[135744>>2]&511]((c[p>>2]|0)+((c[o>>2]|0)*3|0)|0)|0;if(!(c[k>>2]|0)){Ml(79224);break}c[u>>2]=c[k>>2];while(1){if((c[o>>2]|0)<=0)break;e=c[u>>2]|0;c[u>>2]=e+1;a[e>>0]=46;e=c[u>>2]|0;c[u>>2]=e+1;a[e>>0]=46;e=c[u>>2]|0;c[u>>2]=e+1;a[e>>0]=47;c[o>>2]=(c[o>>2]|0)+-1}c:do if(c[t>>2]|0){do if((c[p>>2]|0)>0?(c[u>>2]|0)>>>0>(c[k>>2]|0)>>>0:0){if((d[c[t>>2]>>0]|0)!=47)break;if((d[(c[u>>2]|0)+-1>>0]|0)!=47)break;eU(c[u>>2]|0,(c[t>>2]|0)+1|0,(c[p>>2]|0)-1|0)|0;a[(c[u>>2]|0)+((c[p>>2]|0)-2)>>0]=0;break c}while(0);eU(c[u>>2]|0,c[t>>2]|0,c[p>>2]|0)|0;a[(c[u>>2]|0)+((c[p>>2]|0)-1)>>0]=0}else a[(c[u>>2]|0)+((c[p>>2]|0)-1)>>0]=0;while(0);c[u>>2]=c[k>>2];c[k>>2]=Fl(c[u>>2]|0,79216)|0;zb[c[135736>>2]&511](c[u>>2]|0);break}c[k>>2]=my(c[h>>2]|0)|0}while(0);if(c[v>>2]|0)c[(c[q>>2]|0)+24>>2]=0;if(c[q>>2]|0)Al(c[q>>2]|0);if(c[r>>2]|0)Al(c[r>>2]|0);c[g>>2]=c[k>>2];w=c[g>>2]|0;i=f;return w|0}c[g>>2]=0;w=c[g>>2]|0;i=f;return w|0}function Jl(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+48|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;n=e+32|0;o=e;c[g>>2]=b;if(!(c[g>>2]|0)){c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}if(((d[c[g>>2]>>0]|0|0)==47?(d[(c[g>>2]|0)+1>>0]|0|0)==47:0)?(d[(c[g>>2]|0)+2>>0]|0|0)!=47:0)c[g>>2]=(c[g>>2]|0)+1;b=yl(c[g>>2]|0)|0;c[h>>2]=b;if(b){Al(c[h>>2]|0);c[f>>2]=my(c[g>>2]|0)|0;p=c[f>>2]|0;i=e;return p|0}c[k>>2]=wy(c[g>>2]|0,79248)|0;a:do if((c[k>>2]|0)!=0?(c[l>>2]=(c[k>>2]|0)-(c[g>>2]|0),!((c[l>>2]|0)<=0|(c[l>>2]|0)>20)):0){c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[l>>2]|0))break;a[n>>0]=a[(c[g>>2]|0)+(c[m>>2]|0)>>0]|0;if(!((d[n>>0]|0|0)>=97?(d[n>>0]|0|0)<=122:0)){if((d[n>>0]|0|0)<65)break a;if((d[n>>0]|0|0)>90)break a}c[m>>2]=(c[m>>2]|0)+1}c[o>>2]=Fl(c[g>>2]|0,79256)|0;if((c[o>>2]|0)!=0?(c[h>>2]=yl(c[o>>2]|0)|0,(c[h>>2]|0)!=0):0){Al(c[h>>2]|0);c[f>>2]=c[o>>2];p=c[f>>2]|0;i=e;return p|0}}while(0);c[j>>2]=my(c[g>>2]|0)|0;c[f>>2]=c[j>>2];p=c[f>>2]|0;i=e;return p|0}function Kl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+64|0;d=b+60|0;e=b+56|0;f=b+52|0;g=b+8|0;h=b+4|0;j=b;c[e>>2]=a;if(!(c[e>>2]|0)){c[d>>2]=0;k=c[d>>2]|0;i=b;return k|0}a=yl(c[e>>2]|0)|0;c[f>>2]=a;if(a){Al(c[f>>2]|0);c[d>>2]=my(c[e>>2]|0)|0;k=c[d>>2]|0;i=b;return k|0}c[j>>2]=Jl(c[e>>2]|0)|0;if(!(c[j>>2]|0)){c[d>>2]=0;k=c[d>>2]|0;i=b;return k|0}else{e=g+0|0;f=e+44|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));c[g+24>>2]=c[j>>2];c[h>>2]=Cl(g)|0;zb[c[135736>>2]&511](c[j>>2]|0);c[d>>2]=c[h>>2];k=c[d>>2]|0;i=b;return k|0}return 0}function Ll(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if(!(c[g>>2]|0)){c[e>>2]=-1;j=c[e>>2]|0;i=d;return j|0}Pl(c[f>>2]|0);c[h>>2]=Ql(c[f>>2]|0,c[g>>2]|0)|0;if((c[h>>2]|0)!=0?(Pl(c[f>>2]|0),c[h>>2]=Rl(c[f>>2]|0,c[g>>2]|0)|0,(c[h>>2]|0)!=0):0){Pl(c[f>>2]|0);c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}function Ml(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;e=b+4|0;c[e>>2]=a;if(c[e>>2]|0){a=c[e>>2]|0;c[d>>2]=c[e>>2];Xd(0,0,0,0,0,30,2,3,0,0,a,0,0,0,0,79320,d);i=b;return}else{Xd(0,0,0,0,0,30,2,3,0,0,0,0,0,0,0,79352,d);i=b;return}}function Nl(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[f>>2]=a;c[g>>2]=b;if((c[c[g>>2]>>2]|0)>1048576){Ml(79272);c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}c[j>>2]=c[c[g>>2]>>2]<<1;c[h>>2]=Hb[c[135760>>2]&511](c[f>>2]|0,(c[j>>2]|0)+1|0)|0;if(!(c[h>>2]|0)){Ml(78984);c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}else{c[c[g>>2]>>2]=c[j>>2];c[e>>2]=c[h>>2];k=c[e>>2]|0;i=d;return k|0}return 0}function Ol(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=d+4|0;a[f>>0]=b;if(!((a[f>>0]|0)>=48?(a[f>>0]|0)<=57:0))g=3;do if((g|0)==3){if((a[f>>0]|0)>=97?(a[f>>0]|0)<=102:0)break;if((a[f>>0]|0)>=65?(a[f>>0]|0)<=70:0)break;c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}while(0);c[e>>2]=1;h=c[e>>2]|0;i=d;return h|0}function Pl(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[c[d>>2]>>2]|0)zb[c[135736>>2]&511](c[c[d>>2]>>2]|0);c[c[d>>2]>>2]=0;if(c[(c[d>>2]|0)+12>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+12>>2]|0);c[(c[d>>2]|0)+12>>2]=0;if(c[(c[d>>2]|0)+16>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+16>>2]|0);c[(c[d>>2]|0)+16>>2]=0;if(c[(c[d>>2]|0)+24>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+24>>2]|0);c[(c[d>>2]|0)+24>>2]=0;if(c[(c[d>>2]|0)+32>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+32>>2]|0);c[(c[d>>2]|0)+32>>2]=0;if(c[(c[d>>2]|0)+4>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+4>>2]|0);c[(c[d>>2]|0)+4>>2]=0;if(c[(c[d>>2]|0)+8>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+8>>2]|0);c[(c[d>>2]|0)+8>>2]=0;if(c[(c[d>>2]|0)+28>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+28>>2]|0);c[(c[d>>2]|0)+28>>2]=0;if(c[(c[d>>2]|0)+40>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+40>>2]|0);c[(c[d>>2]|0)+40>>2]=0;i=b;return}function Ql(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=b;c[h>>2]=d;c[j>>2]=Sl(c[g>>2]|0,h)|0;do if(!(c[j>>2]|0)){if((a[c[h>>2]>>0]|0)!=58){c[f>>2]=1;break}c[h>>2]=(c[h>>2]|0)+1;c[j>>2]=Tl(c[g>>2]|0,h)|0;if(c[j>>2]|0){c[f>>2]=c[j>>2];break}if((a[c[h>>2]>>0]|0)==63?(c[h>>2]=(c[h>>2]|0)+1,c[j>>2]=Ul(c[g>>2]|0,h)|0,(c[j>>2]|0)!=0):0){c[f>>2]=c[j>>2];break}if((a[c[h>>2]>>0]|0)==35?(c[h>>2]=(c[h>>2]|0)+1,c[j>>2]=Vl(c[g>>2]|0,h)|0,(c[j>>2]|0)!=0):0){c[f>>2]=c[j>>2];break}if(a[c[h>>2]>>0]|0){Pl(c[g>>2]|0);c[f>>2]=1;break}else{c[f>>2]=0;break}}else c[f>>2]=c[j>>2];while(0);i=e;return c[f>>2]|0}function Rl(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=b;c[h>>2]=d;if((a[c[h>>2]>>0]|0)==47?(a[(c[h>>2]|0)+1>>0]|0)==47:0){c[h>>2]=(c[h>>2]|0)+2;c[j>>2]=Wl(c[g>>2]|0,h)|0;if(c[j>>2]|0){c[f>>2]=c[j>>2];k=c[f>>2]|0;i=e;return k|0}c[j>>2]=Xl(c[g>>2]|0,h)|0;if(c[j>>2]|0){c[f>>2]=c[j>>2];k=c[f>>2]|0;i=e;return k|0}}else l=7;a:do if((l|0)==7){if((a[c[h>>2]>>0]|0)==47){c[j>>2]=Yl(c[g>>2]|0,h)|0;if(!(c[j>>2]|0))break;c[f>>2]=c[j>>2];k=c[f>>2]|0;i=e;return k|0}if(!((a[c[h>>2]>>0]|0)>=97?(a[c[h>>2]>>0]|0)<=122:0))l=12;b:do if((l|0)==12){if((a[c[h>>2]>>0]|0)>=65?(a[c[h>>2]>>0]|0)<=90:0)break;if((a[c[h>>2]>>0]|0)>=48?(a[c[h>>2]>>0]|0)<=57:0)break;if((((a[c[h>>2]>>0]|0)!=45?(a[c[h>>2]>>0]|0)!=46:0)?(a[c[h>>2]>>0]|0)!=95:0)?(a[c[h>>2]>>0]|0)!=126:0){c:do if((a[c[h>>2]>>0]|0)==37){if(!((a[(c[h>>2]|0)+1>>0]|0)>=48?(a[(c[h>>2]|0)+1>>0]|0)<=57:0))l=23;do if((l|0)==23){if((a[(c[h>>2]|0)+1>>0]|0)>=97?(a[(c[h>>2]|0)+1>>0]|0)<=102:0)break;if((a[(c[h>>2]|0)+1>>0]|0)<65)break c;if((a[(c[h>>2]|0)+1>>0]|0)>70)break c}while(0);if((a[(c[h>>2]|0)+2>>0]|0)>=48?(a[(c[h>>2]|0)+2>>0]|0)<=57:0)break b;if((a[(c[h>>2]|0)+2>>0]|0)>=97?(a[(c[h>>2]|0)+2>>0]|0)<=102:0)break b;if((a[(c[h>>2]|0)+2>>0]|0)>=65?(a[(c[h>>2]|0)+2>>0]|0)<=70:0)break b}while(0);if((((((((a[c[h>>2]>>0]|0)!=33?(a[c[h>>2]>>0]|0)!=36:0)?(a[c[h>>2]>>0]|0)!=38:0)?(a[c[h>>2]>>0]|0)!=40:0)?(a[c[h>>2]>>0]|0)!=41:0)?(a[c[h>>2]>>0]|0)!=42:0)?(a[c[h>>2]>>0]|0)!=43:0)?(a[c[h>>2]>>0]|0)!=44:0){if((a[c[h>>2]>>0]|0)==59)break;if((a[c[h>>2]>>0]|0)==61)break;if((a[c[h>>2]>>0]|0)==39)break;if((a[c[h>>2]>>0]|0)==58)break;if((a[c[h>>2]>>0]|0)==64)break;if(!(c[g>>2]|0))break a;if(c[(c[g>>2]|0)+24>>2]|0)zb[c[135736>>2]&511](c[(c[g>>2]|0)+24>>2]|0);c[(c[g>>2]|0)+24>>2]=0;break a}}}while(0);c[j>>2]=Zl(c[g>>2]|0,h)|0;if(c[j>>2]|0){c[f>>2]=c[j>>2];k=c[f>>2]|0;i=e;return k|0}}while(0);if((a[c[h>>2]>>0]|0)==63?(c[h>>2]=(c[h>>2]|0)+1,c[j>>2]=Ul(c[g>>2]|0,h)|0,(c[j>>2]|0)!=0):0){c[f>>2]=c[j>>2];k=c[f>>2]|0;i=e;return k|0}if((a[c[h>>2]>>0]|0)==35?(c[h>>2]=(c[h>>2]|0)+1,c[j>>2]=Vl(c[g>>2]|0,h)|0,(c[j>>2]|0)!=0):0){c[f>>2]=c[j>>2];k=c[f>>2]|0;i=e;return k|0}if(a[c[h>>2]>>0]|0){Pl(c[g>>2]|0);c[f>>2]=1;k=c[f>>2]|0;i=e;return k|0}else{c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}return 0}function Sl(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=b;c[h>>2]=d;if(!(c[h>>2]|0)){c[f>>2]=-1;k=c[f>>2]|0;i=e;return k|0}c[j>>2]=c[c[h>>2]>>2];if(!((a[c[j>>2]>>0]|0)>=97?(a[c[j>>2]>>0]|0)<=122:0))l=5;do if((l|0)==5){if((a[c[j>>2]>>0]|0)>=65?(a[c[j>>2]>>0]|0)<=90:0)break;c[f>>2]=2;k=c[f>>2]|0;i=e;return k|0}while(0);c[j>>2]=(c[j>>2]|0)+1;a:while(1){if(!((a[c[j>>2]>>0]|0)>=97?(a[c[j>>2]>>0]|0)<=122:0))l=11;do if((l|0)==11){l=0;if((a[c[j>>2]>>0]|0)>=65?(a[c[j>>2]>>0]|0)<=90:0)break;if((a[c[j>>2]>>0]|0)>=48?(a[c[j>>2]>>0]|0)<=57:0)break;if(((a[c[j>>2]>>0]|0)!=43?(a[c[j>>2]>>0]|0)!=45:0)?(a[c[j>>2]>>0]|0)!=46:0)break a}while(0);c[j>>2]=(c[j>>2]|0)+1}if(c[g>>2]|0){if(c[c[g>>2]>>2]|0)zb[c[135736>>2]&511](c[c[g>>2]>>2]|0);l=ly(c[c[h>>2]>>2]|0,(c[j>>2]|0)-(c[c[h>>2]>>2]|0)|0)|0;c[c[g>>2]>>2]=l}c[c[h>>2]>>2]=c[j>>2];c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}function Tl(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=b;c[h>>2]=d;c[j>>2]=c[c[h>>2]>>2];if((a[c[j>>2]>>0]|0)==47?(a[(c[j>>2]|0)+1>>0]|0)==47:0){c[j>>2]=(c[j>>2]|0)+2;c[k>>2]=Wl(c[g>>2]|0,j)|0;if(c[k>>2]|0){c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}if(!(c[(c[g>>2]|0)+12>>2]|0))c[(c[g>>2]|0)+20>>2]=-1;c[k>>2]=Xl(c[g>>2]|0,j)|0;if(c[k>>2]|0){c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}else{c[c[h>>2]>>2]=c[j>>2];c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}}a:do if((a[c[j>>2]>>0]|0)==47){c[k>>2]=Yl(c[g>>2]|0,j)|0;if(c[k>>2]|0){c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}}else{if(!((a[c[j>>2]>>0]|0)>=97?(a[c[j>>2]>>0]|0)<=122:0))m=15;b:do if((m|0)==15){if((a[c[j>>2]>>0]|0)>=65?(a[c[j>>2]>>0]|0)<=90:0)break;if((a[c[j>>2]>>0]|0)>=48?(a[c[j>>2]>>0]|0)<=57:0)break;if((((a[c[j>>2]>>0]|0)!=45?(a[c[j>>2]>>0]|0)!=46:0)?(a[c[j>>2]>>0]|0)!=95:0)?(a[c[j>>2]>>0]|0)!=126:0){c:do if((a[c[j>>2]>>0]|0)==37){if(!((a[(c[j>>2]|0)+1>>0]|0)>=48?(a[(c[j>>2]|0)+1>>0]|0)<=57:0))m=26;do if((m|0)==26){if((a[(c[j>>2]|0)+1>>0]|0)>=97?(a[(c[j>>2]|0)+1>>0]|0)<=102:0)break;if((a[(c[j>>2]|0)+1>>0]|0)<65)break c;if((a[(c[j>>2]|0)+1>>0]|0)>70)break c}while(0);if((a[(c[j>>2]|0)+2>>0]|0)>=48?(a[(c[j>>2]|0)+2>>0]|0)<=57:0)break b;if((a[(c[j>>2]|0)+2>>0]|0)>=97?(a[(c[j>>2]|0)+2>>0]|0)<=102:0)break b;if((a[(c[j>>2]|0)+2>>0]|0)>=65?(a[(c[j>>2]|0)+2>>0]|0)<=70:0)break b}while(0);if((((((((a[c[j>>2]>>0]|0)!=33?(a[c[j>>2]>>0]|0)!=36:0)?(a[c[j>>2]>>0]|0)!=38:0)?(a[c[j>>2]>>0]|0)!=40:0)?(a[c[j>>2]>>0]|0)!=41:0)?(a[c[j>>2]>>0]|0)!=42:0)?(a[c[j>>2]>>0]|0)!=43:0)?(a[c[j>>2]>>0]|0)!=44:0){if((a[c[j>>2]>>0]|0)==59)break;if((a[c[j>>2]>>0]|0)==61)break;if((a[c[j>>2]>>0]|0)==39)break;if((a[c[j>>2]>>0]|0)==58)break;if((a[c[j>>2]>>0]|0)==64)break;if(!(c[g>>2]|0))break a;if(c[(c[g>>2]|0)+24>>2]|0)zb[c[135736>>2]&511](c[(c[g>>2]|0)+24>>2]|0);c[(c[g>>2]|0)+24>>2]=0;break a}}}while(0);c[k>>2]=_l(c[g>>2]|0,j)|0;if(c[k>>2]|0){c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}}while(0);c[c[h>>2]>>2]=c[j>>2];c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}function Ul(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=b;c[h>>2]=d;if(!(c[h>>2]|0)){c[f>>2]=-1;k=c[f>>2]|0;i=e;return k|0}c[j>>2]=c[c[h>>2]>>2];a:while(1){if(!((a[c[j>>2]>>0]|0)>=97?(a[c[j>>2]>>0]|0)<=122:0))l=6;b:do if((l|0)==6){l=0;if((a[c[j>>2]>>0]|0)>=65?(a[c[j>>2]>>0]|0)<=90:0)break;if((a[c[j>>2]>>0]|0)>=48?(a[c[j>>2]>>0]|0)<=57:0)break;if((((a[c[j>>2]>>0]|0)!=45?(a[c[j>>2]>>0]|0)!=46:0)?(a[c[j>>2]>>0]|0)!=95:0)?(a[c[j>>2]>>0]|0)!=126:0){c:do if((a[c[j>>2]>>0]|0)==37){if(!((a[(c[j>>2]|0)+1>>0]|0)>=48?(a[(c[j>>2]|0)+1>>0]|0)<=57:0))l=17;do if((l|0)==17){l=0;if((a[(c[j>>2]|0)+1>>0]|0)>=97?(a[(c[j>>2]|0)+1>>0]|0)<=102:0)break;if((a[(c[j>>2]|0)+1>>0]|0)<65)break c;if((a[(c[j>>2]|0)+1>>0]|0)>70)break c}while(0);if((a[(c[j>>2]|0)+2>>0]|0)>=48?(a[(c[j>>2]|0)+2>>0]|0)<=57:0)break b;if((a[(c[j>>2]|0)+2>>0]|0)>=97?(a[(c[j>>2]|0)+2>>0]|0)<=102:0)break b;if((a[(c[j>>2]|0)+2>>0]|0)>=65?(a[(c[j>>2]|0)+2>>0]|0)<=70:0)break b}while(0);if(((((((((a[c[j>>2]>>0]|0)!=33?(a[c[j>>2]>>0]|0)!=36:0)?(a[c[j>>2]>>0]|0)!=38:0)?(a[c[j>>2]>>0]|0)!=40:0)?(a[c[j>>2]>>0]|0)!=41:0)?(a[c[j>>2]>>0]|0)!=42:0)?(a[c[j>>2]>>0]|0)!=43:0)?(a[c[j>>2]>>0]|0)!=44:0)?(a[c[j>>2]>>0]|0)!=59:0){if((a[c[j>>2]>>0]|0)==61)break;if((a[c[j>>2]>>0]|0)==39)break;if((a[c[j>>2]>>0]|0)==58)break;if((a[c[j>>2]>>0]|0)==64)break;if((a[c[j>>2]>>0]|0)==47)break;if((a[c[j>>2]>>0]|0)==63)break;if(!(c[g>>2]|0))break a;if(!(c[(c[g>>2]|0)+36>>2]&1))break a;if((a[c[j>>2]>>0]|0)==123)break;if((a[c[j>>2]>>0]|0)==125)break;if((a[c[j>>2]>>0]|0)==124)break;if((a[c[j>>2]>>0]|0)==92)break;if((a[c[j>>2]>>0]|0)==94)break;if((a[c[j>>2]>>0]|0)==91)break;if((a[c[j>>2]>>0]|0)==93)break;if((a[c[j>>2]>>0]|0)!=96)break a}}}while(0);d=c[j>>2]|0;if((a[c[j>>2]>>0]|0)==37){c[j>>2]=d+3;continue}else{c[j>>2]=d+1;continue}}if(c[g>>2]|0){if(c[(c[g>>2]|0)+28>>2]|0)zb[c[135736>>2]&511](c[(c[g>>2]|0)+28>>2]|0);l=c[c[h>>2]>>2]|0;d=(c[j>>2]|0)-(c[c[h>>2]>>2]|0)|0;if(c[(c[g>>2]|0)+36>>2]&2){b=ly(l,d)|0;c[(c[g>>2]|0)+28>>2]=b}else{b=El(l,d,0)|0;c[(c[g>>2]|0)+28>>2]=b}if(c[(c[g>>2]|0)+40>>2]|0)zb[c[135736>>2]&511](c[(c[g>>2]|0)+40>>2]|0);b=ly(c[c[h>>2]>>2]|0,(c[j>>2]|0)-(c[c[h>>2]>>2]|0)|0)|0;c[(c[g>>2]|0)+40>>2]=b}c[c[h>>2]>>2]=c[j>>2];c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}function Vl(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=b;c[h>>2]=d;if(!(c[h>>2]|0)){c[f>>2]=-1;k=c[f>>2]|0;i=e;return k|0}c[j>>2]=c[c[h>>2]>>2];a:while(1){if(!((a[c[j>>2]>>0]|0)>=97?(a[c[j>>2]>>0]|0)<=122:0))l=6;b:do if((l|0)==6){l=0;if((a[c[j>>2]>>0]|0)>=65?(a[c[j>>2]>>0]|0)<=90:0)break;if((a[c[j>>2]>>0]|0)>=48?(a[c[j>>2]>>0]|0)<=57:0)break;if((((a[c[j>>2]>>0]|0)!=45?(a[c[j>>2]>>0]|0)!=46:0)?(a[c[j>>2]>>0]|0)!=95:0)?(a[c[j>>2]>>0]|0)!=126:0){c:do if((a[c[j>>2]>>0]|0)==37){if(!((a[(c[j>>2]|0)+1>>0]|0)>=48?(a[(c[j>>2]|0)+1>>0]|0)<=57:0))l=17;do if((l|0)==17){l=0;if((a[(c[j>>2]|0)+1>>0]|0)>=97?(a[(c[j>>2]|0)+1>>0]|0)<=102:0)break;if((a[(c[j>>2]|0)+1>>0]|0)<65)break c;if((a[(c[j>>2]|0)+1>>0]|0)>70)break c}while(0);if((a[(c[j>>2]|0)+2>>0]|0)>=48?(a[(c[j>>2]|0)+2>>0]|0)<=57:0)break b;if((a[(c[j>>2]|0)+2>>0]|0)>=97?(a[(c[j>>2]|0)+2>>0]|0)<=102:0)break b;if((a[(c[j>>2]|0)+2>>0]|0)>=65?(a[(c[j>>2]|0)+2>>0]|0)<=70:0)break b}while(0);if(((((((((a[c[j>>2]>>0]|0)!=33?(a[c[j>>2]>>0]|0)!=36:0)?(a[c[j>>2]>>0]|0)!=38:0)?(a[c[j>>2]>>0]|0)!=40:0)?(a[c[j>>2]>>0]|0)!=41:0)?(a[c[j>>2]>>0]|0)!=42:0)?(a[c[j>>2]>>0]|0)!=43:0)?(a[c[j>>2]>>0]|0)!=44:0)?(a[c[j>>2]>>0]|0)!=59:0){if((a[c[j>>2]>>0]|0)==61)break;if((a[c[j>>2]>>0]|0)==39)break;if((a[c[j>>2]>>0]|0)==58)break;if((a[c[j>>2]>>0]|0)==64)break;if((a[c[j>>2]>>0]|0)==47)break;if((a[c[j>>2]>>0]|0)==63)break;if((a[c[j>>2]>>0]|0)==91)break;if((a[c[j>>2]>>0]|0)==93)break;if(!(c[g>>2]|0))break a;if(!(c[(c[g>>2]|0)+36>>2]&1))break a;if((a[c[j>>2]>>0]|0)==123)break;if((a[c[j>>2]>>0]|0)==125)break;if((a[c[j>>2]>>0]|0)==124)break;if((a[c[j>>2]>>0]|0)==92)break;if((a[c[j>>2]>>0]|0)==94)break;if((a[c[j>>2]>>0]|0)==91)break;if((a[c[j>>2]>>0]|0)==93)break;if((a[c[j>>2]>>0]|0)!=96)break a}}}while(0);d=c[j>>2]|0;if((a[c[j>>2]>>0]|0)==37){c[j>>2]=d+3;continue}else{c[j>>2]=d+1;continue}}do if(c[g>>2]|0){if(c[(c[g>>2]|0)+32>>2]|0)zb[c[135736>>2]&511](c[(c[g>>2]|0)+32>>2]|0);l=c[c[h>>2]>>2]|0;d=(c[j>>2]|0)-(c[c[h>>2]>>2]|0)|0;if(c[(c[g>>2]|0)+36>>2]&2){b=ly(l,d)|0;c[(c[g>>2]|0)+32>>2]=b;break}else{b=El(l,d,0)|0;c[(c[g>>2]|0)+32>>2]=b;break}}while(0);c[c[h>>2]>>2]=c[j>>2];c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}function Wl(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=b;c[h>>2]=d;c[j>>2]=c[c[h>>2]>>2];c[k>>2]=$l(c[g>>2]|0,j)|0;if((c[k>>2]|0)==0?(a[c[j>>2]>>0]|0)==64:0)c[j>>2]=(c[j>>2]|0)+1;else c[j>>2]=c[c[h>>2]>>2];c[k>>2]=am(c[g>>2]|0,j)|0;if(c[k>>2]|0){c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}if((a[c[j>>2]>>0]|0)==58?(c[j>>2]=(c[j>>2]|0)+1,c[k>>2]=bm(c[g>>2]|0,j)|0,(c[k>>2]|0)!=0):0){c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}c[c[h>>2]>>2]=c[j>>2];c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}function Xl(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=b;c[h>>2]=d;c[j>>2]=c[c[h>>2]>>2];while(1){if((a[c[j>>2]>>0]|0)!=47)break;c[j>>2]=(c[j>>2]|0)+1;c[k>>2]=cm(j,0,1)|0;if(c[k>>2]|0){l=4;break}}if((l|0)==4){c[f>>2]=c[k>>2];m=c[f>>2]|0;i=e;return m|0}do if(c[g>>2]|0){if(c[(c[g>>2]|0)+24>>2]|0)zb[c[135736>>2]&511](c[(c[g>>2]|0)+24>>2]|0);k=c[g>>2]|0;if((c[c[h>>2]>>2]|0)==(c[j>>2]|0)){c[k+24>>2]=0;break}l=c[c[h>>2]>>2]|0;d=(c[j>>2]|0)-(c[c[h>>2]>>2]|0)|0;if(c[k+36>>2]&2){k=ly(l,d)|0;c[(c[g>>2]|0)+24>>2]=k;break}else{k=El(l,d,0)|0;c[(c[g>>2]|0)+24>>2]=k;break}}while(0);c[c[h>>2]>>2]=c[j>>2];c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}function Yl(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=b;c[h>>2]=d;c[j>>2]=c[c[h>>2]>>2];if((a[c[j>>2]>>0]|0)!=47){c[f>>2]=1;l=c[f>>2]|0;i=e;return l|0}c[j>>2]=(c[j>>2]|0)+1;c[k>>2]=cm(j,0,0)|0;a:do if(!(c[k>>2]|0)){do{if((a[c[j>>2]>>0]|0)!=47)break a;c[j>>2]=(c[j>>2]|0)+1;c[k>>2]=cm(j,0,1)|0}while((c[k>>2]|0)==0);c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}while(0);do if(c[g>>2]|0){if(c[(c[g>>2]|0)+24>>2]|0)zb[c[135736>>2]&511](c[(c[g>>2]|0)+24>>2]|0);k=c[g>>2]|0;if((c[j>>2]|0)==(c[c[h>>2]>>2]|0)){c[k+24>>2]=0;break}d=c[c[h>>2]>>2]|0;b=(c[j>>2]|0)-(c[c[h>>2]>>2]|0)|0;if(c[k+36>>2]&2){k=ly(d,b)|0;c[(c[g>>2]|0)+24>>2]=k;break}else{k=El(d,b,0)|0;c[(c[g>>2]|0)+24>>2]=k;break}}while(0);c[c[h>>2]>>2]=c[j>>2];c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}function Zl(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=b;c[h>>2]=d;c[j>>2]=c[c[h>>2]>>2];c[k>>2]=cm(j,58,0)|0;if(c[k>>2]|0){c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}while(1){if((a[c[j>>2]>>0]|0)!=47)break;c[j>>2]=(c[j>>2]|0)+1;c[k>>2]=cm(j,0,1)|0;if(c[k>>2]|0){m=5;break}}if((m|0)==5){c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}do if(c[g>>2]|0){if(c[(c[g>>2]|0)+24>>2]|0)zb[c[135736>>2]&511](c[(c[g>>2]|0)+24>>2]|0);k=c[g>>2]|0;if((c[j>>2]|0)==(c[c[h>>2]>>2]|0)){c[k+24>>2]=0;break}m=c[c[h>>2]>>2]|0;d=(c[j>>2]|0)-(c[c[h>>2]>>2]|0)|0;if(c[k+36>>2]&2){k=ly(m,d)|0;c[(c[g>>2]|0)+24>>2]=k;break}else{k=El(m,d,0)|0;c[(c[g>>2]|0)+24>>2]=k;break}}while(0);c[c[h>>2]>>2]=c[j>>2];c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}function _l(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=b;c[h>>2]=d;c[j>>2]=c[c[h>>2]>>2];c[k>>2]=cm(j,0,0)|0;if(c[k>>2]|0){c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}while(1){if((a[c[j>>2]>>0]|0)!=47)break;c[j>>2]=(c[j>>2]|0)+1;c[k>>2]=cm(j,0,1)|0;if(c[k>>2]|0){m=5;break}}if((m|0)==5){c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}do if(c[g>>2]|0){if(c[(c[g>>2]|0)+24>>2]|0)zb[c[135736>>2]&511](c[(c[g>>2]|0)+24>>2]|0);k=c[g>>2]|0;if((c[j>>2]|0)==(c[c[h>>2]>>2]|0)){c[k+24>>2]=0;break}m=c[c[h>>2]>>2]|0;d=(c[j>>2]|0)-(c[c[h>>2]>>2]|0)|0;if(c[k+36>>2]&2){k=ly(m,d)|0;c[(c[g>>2]|0)+24>>2]=k;break}else{k=El(m,d,0)|0;c[(c[g>>2]|0)+24>>2]=k;break}}while(0);c[c[h>>2]>>2]=c[j>>2];c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}function $l(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=b;c[h>>2]=d;c[j>>2]=c[c[h>>2]>>2];while(1){if((a[c[j>>2]>>0]|0)>=97?(a[c[j>>2]>>0]|0)<=122:0)k=1;else l=4;a:do if((l|0)==4){l=0;if((a[c[j>>2]>>0]|0)>=65?(a[c[j>>2]>>0]|0)<=90:0){k=1;break}if((a[c[j>>2]>>0]|0)>=48?(a[c[j>>2]>>0]|0)<=57:0){k=1;break}if((((a[c[j>>2]>>0]|0)!=45?(a[c[j>>2]>>0]|0)!=46:0)?(a[c[j>>2]>>0]|0)!=95:0)?(a[c[j>>2]>>0]|0)!=126:0){b:do if((a[c[j>>2]>>0]|0)==37){if(!((a[(c[j>>2]|0)+1>>0]|0)>=48?(a[(c[j>>2]|0)+1>>0]|0)<=57:0))l=15;do if((l|0)==15){l=0;if((a[(c[j>>2]|0)+1>>0]|0)>=97?(a[(c[j>>2]|0)+1>>0]|0)<=102:0)break;if((a[(c[j>>2]|0)+1>>0]|0)<65)break b;if((a[(c[j>>2]|0)+1>>0]|0)>70)break b}while(0);if((a[(c[j>>2]|0)+2>>0]|0)>=48?(a[(c[j>>2]|0)+2>>0]|0)<=57:0){k=1;break a}if((a[(c[j>>2]|0)+2>>0]|0)>=97?(a[(c[j>>2]|0)+2>>0]|0)<=102:0){k=1;break a}if((a[(c[j>>2]|0)+2>>0]|0)>=65?(a[(c[j>>2]|0)+2>>0]|0)<=70:0){k=1;break a}}while(0);if((((((((((a[c[j>>2]>>0]|0)!=33?(a[c[j>>2]>>0]|0)!=36:0)?(a[c[j>>2]>>0]|0)!=38:0)?(a[c[j>>2]>>0]|0)!=40:0)?(a[c[j>>2]>>0]|0)!=41:0)?(a[c[j>>2]>>0]|0)!=42:0)?(a[c[j>>2]>>0]|0)!=43:0)?(a[c[j>>2]>>0]|0)!=44:0)?(a[c[j>>2]>>0]|0)!=59:0)?(a[c[j>>2]>>0]|0)!=61:0){if((a[c[j>>2]>>0]|0)==39){k=1;break}k=(a[c[j>>2]>>0]|0)==58}else k=1}else k=1}while(0);m=a[c[j>>2]>>0]|0;if(!k)break;d=c[j>>2]|0;if((m|0)==37){c[j>>2]=d+3;continue}else{c[j>>2]=d+1;continue}}if((m|0)!=64){c[f>>2]=1;n=c[f>>2]|0;i=e;return n|0}do if(c[g>>2]|0){if(c[(c[g>>2]|0)+16>>2]|0)zb[c[135736>>2]&511](c[(c[g>>2]|0)+16>>2]|0);m=c[c[h>>2]>>2]|0;k=(c[j>>2]|0)-(c[c[h>>2]>>2]|0)|0;if(c[(c[g>>2]|0)+36>>2]&2){l=ly(m,k)|0;c[(c[g>>2]|0)+16>>2]=l;break}else{l=El(m,k,0)|0;c[(c[g>>2]|0)+16>>2]=l;break}}while(0);c[c[h>>2]>>2]=c[j>>2];c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}function am(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=b;c[h>>2]=d;c[j>>2]=c[c[h>>2]>>2];c[k>>2]=c[j>>2];d=c[j>>2]|0;a:do if((a[c[j>>2]>>0]|0)==91){c[j>>2]=d+1;while(1){if((a[c[j>>2]>>0]|0)!=93)l=(a[c[j>>2]>>0]|0)!=0;else l=0;m=c[j>>2]|0;if(!l)break;c[j>>2]=m+1}if((a[m>>0]|0)==93){c[j>>2]=(c[j>>2]|0)+1;break}c[f>>2]=1;n=c[f>>2]|0;i=e;return n|0}else{if((a[d>>0]|0)>=48?(a[c[j>>2]>>0]|0)<=57:0){if(((((((dm(j)|0)==0?(a[c[j>>2]>>0]|0)==46:0)?(c[j>>2]=(c[j>>2]|0)+1,(dm(j)|0)==0):0)?(a[c[j>>2]>>0]|0)==46:0)?(dm(j)|0)==0:0)?(a[c[j>>2]>>0]|0)==46:0)?(dm(j)|0)==0:0)break;c[j>>2]=c[c[h>>2]>>2]}while(1){if(!((a[c[j>>2]>>0]|0)>=97?(a[c[j>>2]>>0]|0)<=122:0))o=22;b:do if((o|0)==22){o=0;if((a[c[j>>2]>>0]|0)>=65?(a[c[j>>2]>>0]|0)<=90:0)break;if((a[c[j>>2]>>0]|0)>=48?(a[c[j>>2]>>0]|0)<=57:0)break;if((((a[c[j>>2]>>0]|0)!=45?(a[c[j>>2]>>0]|0)!=46:0)?(a[c[j>>2]>>0]|0)!=95:0)?(a[c[j>>2]>>0]|0)!=126:0){c:do if((a[c[j>>2]>>0]|0)==37){if(!((a[(c[j>>2]|0)+1>>0]|0)>=48?(a[(c[j>>2]|0)+1>>0]|0)<=57:0))o=33;do if((o|0)==33){o=0;if((a[(c[j>>2]|0)+1>>0]|0)>=97?(a[(c[j>>2]|0)+1>>0]|0)<=102:0)break;if((a[(c[j>>2]|0)+1>>0]|0)<65)break c;if((a[(c[j>>2]|0)+1>>0]|0)>70)break c}while(0);if((a[(c[j>>2]|0)+2>>0]|0)>=48?(a[(c[j>>2]|0)+2>>0]|0)<=57:0)break b;if((a[(c[j>>2]|0)+2>>0]|0)>=97?(a[(c[j>>2]|0)+2>>0]|0)<=102:0)break b;if((a[(c[j>>2]|0)+2>>0]|0)>=65?(a[(c[j>>2]|0)+2>>0]|0)<=70:0)break b}while(0);if(((((((a[c[j>>2]>>0]|0)!=33?(a[c[j>>2]>>0]|0)!=36:0)?(a[c[j>>2]>>0]|0)!=38:0)?(a[c[j>>2]>>0]|0)!=40:0)?(a[c[j>>2]>>0]|0)!=41:0)?(a[c[j>>2]>>0]|0)!=42:0)?(a[c[j>>2]>>0]|0)!=43:0){if((a[c[j>>2]>>0]|0)==44)break;if((a[c[j>>2]>>0]|0)==59)break;if((a[c[j>>2]>>0]|0)==61)break;if((a[c[j>>2]>>0]|0)!=39)break a}}}while(0);b=c[j>>2]|0;if((a[c[j>>2]>>0]|0)==37){c[j>>2]=b+3;continue}else{c[j>>2]=b+1;continue}}}while(0);do if(c[g>>2]|0){if(c[(c[g>>2]|0)+8>>2]|0)zb[c[135736>>2]&511](c[(c[g>>2]|0)+8>>2]|0);c[(c[g>>2]|0)+8>>2]=0;if(c[(c[g>>2]|0)+12>>2]|0)zb[c[135736>>2]&511](c[(c[g>>2]|0)+12>>2]|0);o=c[g>>2]|0;if((c[j>>2]|0)==(c[k>>2]|0)){c[o+12>>2]=0;break}d=c[k>>2]|0;m=(c[j>>2]|0)-(c[k>>2]|0)|0;if(c[o+36>>2]&2){o=ly(d,m)|0;c[(c[g>>2]|0)+12>>2]=o;break}else{o=El(d,m,0)|0;c[(c[g>>2]|0)+12>>2]=o;break}}while(0);c[c[h>>2]>>2]=c[j>>2];c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}function bm(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=b;c[h>>2]=d;c[j>>2]=c[c[h>>2]>>2];if((a[c[j>>2]>>0]|0)>=48?(a[c[j>>2]>>0]|0)<=57:0){if(c[g>>2]|0)c[(c[g>>2]|0)+20>>2]=0;while(1){if((a[c[j>>2]>>0]|0)<48)break;if((a[c[j>>2]>>0]|0)>57)break;if(c[g>>2]|0)c[(c[g>>2]|0)+20>>2]=((c[(c[g>>2]|0)+20>>2]|0)*10|0)+((a[c[j>>2]>>0]|0)-48);c[j>>2]=(c[j>>2]|0)+1}c[c[h>>2]>>2]=c[j>>2];c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}c[f>>2]=1;k=c[f>>2]|0;i=e;return k|0}function cm(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f+12|0;h=f+8|0;j=f+16|0;k=f+4|0;l=f;c[h>>2]=b;a[j>>0]=d;c[k>>2]=e;c[l>>2]=c[c[h>>2]>>2];if(!((a[c[l>>2]>>0]|0)>=97?(a[c[l>>2]>>0]|0)<=122:0))m=3;a:do if((m|0)==3){if((a[c[l>>2]>>0]|0)>=65?(a[c[l>>2]>>0]|0)<=90:0)break;if((a[c[l>>2]>>0]|0)>=48?(a[c[l>>2]>>0]|0)<=57:0)break;if((((a[c[l>>2]>>0]|0)!=45?(a[c[l>>2]>>0]|0)!=46:0)?(a[c[l>>2]>>0]|0)!=95:0)?(a[c[l>>2]>>0]|0)!=126:0){b:do if((a[c[l>>2]>>0]|0)==37){if(!((a[(c[l>>2]|0)+1>>0]|0)>=48?(a[(c[l>>2]|0)+1>>0]|0)<=57:0))m=14;do if((m|0)==14){if((a[(c[l>>2]|0)+1>>0]|0)>=97?(a[(c[l>>2]|0)+1>>0]|0)<=102:0)break;if((a[(c[l>>2]|0)+1>>0]|0)<65)break b;if((a[(c[l>>2]|0)+1>>0]|0)>70)break b}while(0);if((a[(c[l>>2]|0)+2>>0]|0)>=48?(a[(c[l>>2]|0)+2>>0]|0)<=57:0)break a;if((a[(c[l>>2]|0)+2>>0]|0)>=97?(a[(c[l>>2]|0)+2>>0]|0)<=102:0)break a;if((a[(c[l>>2]|0)+2>>0]|0)>=65?(a[(c[l>>2]|0)+2>>0]|0)<=70:0)break a}while(0);if(((((((((((a[c[l>>2]>>0]|0)!=33?(a[c[l>>2]>>0]|0)!=36:0)?(a[c[l>>2]>>0]|0)!=38:0)?(a[c[l>>2]>>0]|0)!=40:0)?(a[c[l>>2]>>0]|0)!=41:0)?(a[c[l>>2]>>0]|0)!=42:0)?(a[c[l>>2]>>0]|0)!=43:0)?(a[c[l>>2]>>0]|0)!=44:0)?(a[c[l>>2]>>0]|0)!=59:0)?(a[c[l>>2]>>0]|0)!=61:0)?(a[c[l>>2]>>0]|0)!=39:0){if((a[c[l>>2]>>0]|0)==58)break;if((a[c[l>>2]>>0]|0)==64)break;if(c[k>>2]|0){c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}else{c[g>>2]=1;n=c[g>>2]|0;i=f;return n|0}}}}while(0);while(1){if((a[c[l>>2]>>0]|0)>=97?(a[c[l>>2]>>0]|0)<=122:0)m=76;else m=42;c:do if((m|0)==42){m=0;if((a[c[l>>2]>>0]|0)>=65?(a[c[l>>2]>>0]|0)<=90:0){m=76;break}if((a[c[l>>2]>>0]|0)>=48?(a[c[l>>2]>>0]|0)<=57:0){m=76;break}if((((a[c[l>>2]>>0]|0)!=45?(a[c[l>>2]>>0]|0)!=46:0)?(a[c[l>>2]>>0]|0)!=95:0)?(a[c[l>>2]>>0]|0)!=126:0){d:do if((a[c[l>>2]>>0]|0)==37){if(!((a[(c[l>>2]|0)+1>>0]|0)>=48?(a[(c[l>>2]|0)+1>>0]|0)<=57:0))m=53;do if((m|0)==53){m=0;if((a[(c[l>>2]|0)+1>>0]|0)>=97?(a[(c[l>>2]|0)+1>>0]|0)<=102:0)break;if((a[(c[l>>2]|0)+1>>0]|0)<65)break d;if((a[(c[l>>2]|0)+1>>0]|0)>70)break d}while(0);if((a[(c[l>>2]|0)+2>>0]|0)>=48?(a[(c[l>>2]|0)+2>>0]|0)<=57:0){m=76;break c}if((a[(c[l>>2]|0)+2>>0]|0)>=97?(a[(c[l>>2]|0)+2>>0]|0)<=102:0){m=76;break c}if((a[(c[l>>2]|0)+2>>0]|0)>=65?(a[(c[l>>2]|0)+2>>0]|0)<=70:0){m=76;break c}}while(0);if(((((((((a[c[l>>2]>>0]|0)!=33?(a[c[l>>2]>>0]|0)!=36:0)?(a[c[l>>2]>>0]|0)!=38:0)?(a[c[l>>2]>>0]|0)!=40:0)?(a[c[l>>2]>>0]|0)!=41:0)?(a[c[l>>2]>>0]|0)!=42:0)?(a[c[l>>2]>>0]|0)!=43:0)?(a[c[l>>2]>>0]|0)!=44:0)?(a[c[l>>2]>>0]|0)!=59:0){if((a[c[l>>2]>>0]|0)==61){m=76;break}if((a[c[l>>2]>>0]|0)==39){m=76;break}if((a[c[l>>2]>>0]|0)==58){m=76;break}if((a[c[l>>2]>>0]|0)!=64)o=0;else m=76}else m=76}else m=76}while(0);if((m|0)==76){m=0;o=(a[c[l>>2]>>0]|0)!=(a[j>>0]|0)}p=c[l>>2]|0;if(!o)break;k=c[l>>2]|0;if((a[p>>0]|0)==37){c[l>>2]=k+3;continue}else{c[l>>2]=k+1;continue}}c[c[h>>2]>>2]=p;c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}function dm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=b;c[g>>2]=c[c[f>>2]>>2];if((a[c[g>>2]>>0]|0)>=48?(a[c[g>>2]>>0]|0)<=57:0){a:do if((a[(c[g>>2]|0)+1>>0]|0)>=48?(a[(c[g>>2]|0)+1>>0]|0)<=57:0){do if(((a[c[g>>2]>>0]|0)!=48?(a[(c[g>>2]|0)+1>>0]|0)>=48:0)?(a[(c[g>>2]|0)+1>>0]|0)<=57:0){if((a[(c[g>>2]|0)+2>>0]|0)>=48?(a[(c[g>>2]|0)+2>>0]|0)<=57:0)break;c[g>>2]=(c[g>>2]|0)+2;break a}while(0);if(((((a[c[g>>2]>>0]|0)==49?(a[(c[g>>2]|0)+1>>0]|0)>=48:0)?(a[(c[g>>2]|0)+1>>0]|0)<=57:0)?(a[(c[g>>2]|0)+2>>0]|0)>=48:0)?(a[(c[g>>2]|0)+2>>0]|0)<=57:0){c[g>>2]=(c[g>>2]|0)+3;break}if(((((a[c[g>>2]>>0]|0)==50?(a[(c[g>>2]|0)+1>>0]|0)>=48:0)?(a[(c[g>>2]|0)+1>>0]|0)<=52:0)?(a[(c[g>>2]|0)+2>>0]|0)>=48:0)?(a[(c[g>>2]|0)+2>>0]|0)<=57:0){c[g>>2]=(c[g>>2]|0)+3;break}if((((a[c[g>>2]>>0]|0)==50?(a[(c[g>>2]|0)+1>>0]|0)==53:0)?(a[(c[g>>2]|0)+2>>0]|0)>=48:0)?(a[(c[g>>2]|0)+1>>0]|0)<=53:0){c[g>>2]=(c[g>>2]|0)+3;break}c[e>>2]=1;h=c[e>>2]|0;i=d;return h|0}else j=6;while(0);if((j|0)==6)c[g>>2]=(c[g>>2]|0)+1;c[c[f>>2]>>2]=c[g>>2];c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}c[e>>2]=1;h=c[e>>2]|0;i=d;return h|0}function em(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+5024|0;f=e+8|0;g=e+4|0;h=e;j=e+16|0;c[g>>2]=b;c[h>>2]=d;if((c[g>>2]|0)==0|(c[h>>2]|0)==0){c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}if((c[(c[h>>2]|0)+4>>2]|0)!=15){c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}if((c[(c[h>>2]|0)+36>>2]|0)!=4){c[f>>2]=1;k=c[f>>2]|0;i=e;return k|0}if(c[(c[h>>2]|0)+52>>2]|0)if(wz(c[(c[h>>2]|0)+52>>2]|0)|0){c[f>>2]=1;k=c[f>>2]|0;i=e;return k|0}else{c[(c[g>>2]|0)+36>>2]=0;c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}d=xz()|0;c[(c[g>>2]|0)+56>>2]=d;d=c[g>>2]|0;if(!(c[(c[g>>2]|0)+56>>2]|0)){jn(d,c[h>>2]|0,1,79384,c[(c[h>>2]|0)+8>>2]|0,0,0);c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}b=Bz(c[d+56>>2]|0)|0;c[(c[g>>2]|0)+60>>2]=b;kn(c[(c[h>>2]|0)+40>>2]|0,c[g>>2]|0,c[(c[h>>2]|0)+8>>2]|0)|0;Cz(c[(c[g>>2]|0)+56>>2]|0,c[(c[g>>2]|0)+60>>2]|0)|0;b=Oz(c[(c[g>>2]|0)+56>>2]|0)|0;c[(c[h>>2]|0)+52>>2]=b;if((wz(c[(c[h>>2]|0)+52>>2]|0)|0)!=1){a[j>>0]=0;fm(j,5e3,c[(c[h>>2]|0)+40>>2]|0,1);jn(c[g>>2]|0,c[h>>2]|0,505,79424,c[(c[h>>2]|0)+8>>2]|0,j,0);c[(c[g>>2]|0)+36>>2]=0;c[(c[g>>2]|0)+60>>2]=0;yz(c[(c[g>>2]|0)+56>>2]|0);c[(c[g>>2]|0)+56>>2]=0;c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}else{c[(c[g>>2]|0)+60>>2]=0;yz(c[(c[g>>2]|0)+56>>2]|0);c[(c[g>>2]|0)+56>>2]=0;c[f>>2]=1;k=c[f>>2]|0;i=e;return k|0}return 0}function fm(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+32|0;h=g+16|0;j=g+12|0;k=g+8|0;l=g+4|0;m=g;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=f;if(!(c[k>>2]|0)){i=g;return}c[m>>2]=ZT(c[h>>2]|0)|0;if(((c[j>>2]|0)-(c[m>>2]|0)|0)<50){if(((c[j>>2]|0)-(c[m>>2]|0)|0)<=4){i=g;return}if((a[(c[h>>2]|0)+((c[m>>2]|0)-1)>>0]|0)==46){i=g;return}_T(c[h>>2]|0,79624)|0;i=g;return}if(c[l>>2]|0)_T(c[h>>2]|0,79632)|0;f=c[c[k>>2]>>2]|0;do if((f|0)==4){if((c[c[(c[k>>2]|0)+12>>2]>>2]|0)!=4?(c[c[(c[k>>2]|0)+12>>2]>>2]|0)!=3:0)fm(c[h>>2]|0,c[j>>2]|0,c[(c[k>>2]|0)+12>>2]|0,0);else fm(c[h>>2]|0,c[j>>2]|0,c[(c[k>>2]|0)+12>>2]|0,1);
c[m>>2]=ZT(c[h>>2]|0)|0;if(((c[j>>2]|0)-(c[m>>2]|0)|0)>=50){_T(c[h>>2]|0,79664)|0;if(!((c[c[(c[k>>2]|0)+16>>2]>>2]|0)!=3?(c[(c[(c[k>>2]|0)+16>>2]|0)+4>>2]|0)==1:0))n=41;if((n|0)==41?(c[c[(c[k>>2]|0)+16>>2]>>2]|0)!=2:0){fm(c[h>>2]|0,c[j>>2]|0,c[(c[k>>2]|0)+16>>2]|0,1);break}fm(c[h>>2]|0,c[j>>2]|0,c[(c[k>>2]|0)+16>>2]|0,0);break}if(((c[j>>2]|0)-(c[m>>2]|0)|0)<=4){i=g;return}if((a[(c[h>>2]|0)+((c[m>>2]|0)-1)>>0]|0)==46){i=g;return}_T(c[h>>2]|0,79624)|0;i=g;return}else if((f|0)==1)_T(c[h>>2]|0,79640)|0;else if((f|0)==3){if((c[c[(c[k>>2]|0)+12>>2]>>2]|0)!=4?(c[c[(c[k>>2]|0)+12>>2]>>2]|0)!=3:0)fm(c[h>>2]|0,c[j>>2]|0,c[(c[k>>2]|0)+12>>2]|0,0);else fm(c[h>>2]|0,c[j>>2]|0,c[(c[k>>2]|0)+12>>2]|0,1);c[m>>2]=ZT(c[h>>2]|0)|0;if(((c[j>>2]|0)-(c[m>>2]|0)|0)>=50){_T(c[h>>2]|0,79656)|0;if(!((c[c[(c[k>>2]|0)+16>>2]>>2]|0)!=4?(c[(c[(c[k>>2]|0)+16>>2]|0)+4>>2]|0)==1:0))n=28;if((n|0)==28?(c[c[(c[k>>2]|0)+16>>2]>>2]|0)!=2:0){fm(c[h>>2]|0,c[j>>2]|0,c[(c[k>>2]|0)+16>>2]|0,1);break}fm(c[h>>2]|0,c[j>>2]|0,c[(c[k>>2]|0)+16>>2]|0,0);break}if(((c[j>>2]|0)-(c[m>>2]|0)|0)<=4){i=g;return}if((a[(c[h>>2]|0)+((c[m>>2]|0)-1)>>0]|0)==46){i=g;return}_T(c[h>>2]|0,79624)|0;i=g;return}else if((f|0)==2){do if(c[(c[k>>2]|0)+24>>2]|0){e=(c[j>>2]|0)-(c[m>>2]|0)|0;d=(e|0)<((xy(c[(c[k>>2]|0)+24>>2]|0)|0)+10|0);e=c[h>>2]|0;if(!d){_T(e|0,c[(c[k>>2]|0)+24>>2]|0)|0;_T(c[h>>2]|0,79648)|0;break}_T(e|0,79624)|0;i=g;return}while(0);e=(c[j>>2]|0)-(c[m>>2]|0)|0;if((e|0)<((xy(c[(c[k>>2]|0)+8>>2]|0)|0)+10|0)){_T(c[h>>2]|0,79624)|0;i=g;return}else{if(!(c[(c[k>>2]|0)+8>>2]|0))break;_T(c[h>>2]|0,c[(c[k>>2]|0)+8>>2]|0)|0;break}}while(0);if(c[l>>2]|0)_T(c[h>>2]|0,79672)|0;l=c[(c[k>>2]|0)+4>>2]|0;if((l|0)==3){_T(c[h>>2]|0,79688)|0;i=g;return}else if((l|0)==4){_T(c[h>>2]|0,79696)|0;i=g;return}else if((l|0)==2){_T(c[h>>2]|0,79680)|0;i=g;return}else{i=g;return}}function gm(){var a=0,b=0,d=0,e=0,f=0,g=0;a=i;i=i+16|0;b=a+4|0;d=a;e=Cb[c[135744>>2]&511](64)|0;c[d>>2]=e;if(!e){ln(0,79472);c[b>>2]=0;f=c[b>>2]|0;i=a;return f|0}else{e=(c[d>>2]|0)+0|0;g=e+64|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(g|0));c[b>>2]=c[d>>2];f=c[b>>2]|0;i=a;return f|0}return 0}function hm(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(c[(c[d>>2]|0)+52>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+52>>2]|0);if(!(c[(c[d>>2]|0)+24>>2]|0)){e=c[33934]|0;f=c[d>>2]|0;zb[e&511](f);i=b;return}zb[c[135736>>2]&511](c[(c[d>>2]|0)+24>>2]|0);e=c[33934]|0;f=c[d>>2]|0;zb[e&511](f);i=b;return}function im(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;n=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[l>>2]=0;if(c[g>>2]|0)c[l>>2]=c[(c[g>>2]|0)+80>>2];g=c[j>>2]|0;if((g|0)==4|(g|0)==3|(g|0)==1){if(c[h>>2]|0)mn(0,1,79528,0)}else if((g|0)==2){if(!(c[h>>2]|0))mn(0,1,79488,0)}else{mn(0,1,79568,0);c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}c[k>>2]=Cb[c[135744>>2]&511](28)|0;if(!(c[k>>2]|0)){ln(0,79472);c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}g=c[k>>2]|0;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;c[g+16>>2]=0;c[g+20>>2]=0;c[g+24>>2]=0;c[c[k>>2]>>2]=c[j>>2];c[(c[k>>2]|0)+4>>2]=1;do if(c[h>>2]|0){c[n>>2]=Dh(c[h>>2]|0,m)|0;j=(c[l>>2]|0)==0;if(!(c[n>>2]|0))if(j){g=my(c[h>>2]|0)|0;c[(c[k>>2]|0)+8>>2]=g;break}else{g=AP(c[l>>2]|0,c[h>>2]|0,-1)|0;c[(c[k>>2]|0)+8>>2]=g;break}else if(j){j=ly(c[h>>2]|0,c[m>>2]|0)|0;c[(c[k>>2]|0)+24>>2]=j;j=my(c[n>>2]|0)|0;c[(c[k>>2]|0)+8>>2]=j;break}else{j=AP(c[l>>2]|0,c[h>>2]|0,c[m>>2]|0)|0;c[(c[k>>2]|0)+24>>2]=j;j=AP(c[l>>2]|0,c[n>>2]|0,-1)|0;c[(c[k>>2]|0)+8>>2]=j;break}}while(0);c[f>>2]=c[k>>2];o=c[f>>2]|0;i=e;return o|0}function jm(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;c[j>>2]=0;c[l>>2]=0;if(!(c[g>>2]|0)){c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}if(c[f>>2]|0)c[l>>2]=c[(c[f>>2]|0)+80>>2];c[h>>2]=Cb[c[135744>>2]&511](28)|0;if(!(c[h>>2]|0)){ln(0,79472);c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}b=c[h>>2]|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;c[c[h>>2]>>2]=c[c[g>>2]>>2];c[(c[h>>2]|0)+4>>2]=c[(c[g>>2]|0)+4>>2];do if(c[(c[g>>2]|0)+8>>2]|0)if(c[l>>2]|0){b=AP(c[l>>2]|0,c[(c[g>>2]|0)+8>>2]|0,-1)|0;c[(c[h>>2]|0)+8>>2]=b;break}else{b=my(c[(c[g>>2]|0)+8>>2]|0)|0;c[(c[h>>2]|0)+8>>2]=b;break}while(0);do if(c[(c[g>>2]|0)+24>>2]|0)if(c[l>>2]|0){b=AP(c[l>>2]|0,c[(c[g>>2]|0)+24>>2]|0,-1)|0;c[(c[h>>2]|0)+24>>2]=b;break}else{b=my(c[(c[g>>2]|0)+24>>2]|0)|0;c[(c[h>>2]|0)+24>>2]=b;break}while(0);if(c[(c[g>>2]|0)+12>>2]|0){b=jm(c[f>>2]|0,c[(c[g>>2]|0)+12>>2]|0)|0;c[(c[h>>2]|0)+12>>2]=b}if(c[(c[h>>2]|0)+12>>2]|0)c[(c[(c[h>>2]|0)+12>>2]|0)+20>>2]=c[h>>2];a:do if(c[(c[g>>2]|0)+16>>2]|0){c[j>>2]=c[h>>2];c[g>>2]=c[(c[g>>2]|0)+16>>2];while(1){if(!(c[g>>2]|0))break a;c[k>>2]=Cb[c[135744>>2]&511](28)|0;if(!(c[k>>2]|0))break;b=c[k>>2]|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;c[c[k>>2]>>2]=c[c[g>>2]>>2];c[(c[k>>2]|0)+4>>2]=c[(c[g>>2]|0)+4>>2];c[(c[j>>2]|0)+16>>2]=c[k>>2];do if(c[(c[g>>2]|0)+8>>2]|0)if(c[l>>2]|0){b=AP(c[l>>2]|0,c[(c[g>>2]|0)+8>>2]|0,-1)|0;c[(c[k>>2]|0)+8>>2]=b;break}else{b=my(c[(c[g>>2]|0)+8>>2]|0)|0;c[(c[k>>2]|0)+8>>2]=b;break}while(0);do if(c[(c[g>>2]|0)+24>>2]|0)if(c[l>>2]|0){b=AP(c[l>>2]|0,c[(c[g>>2]|0)+24>>2]|0,-1)|0;c[(c[k>>2]|0)+24>>2]=b;break}else{b=my(c[(c[g>>2]|0)+24>>2]|0)|0;c[(c[k>>2]|0)+24>>2]=b;break}while(0);if(c[(c[g>>2]|0)+12>>2]|0){b=jm(c[f>>2]|0,c[(c[g>>2]|0)+12>>2]|0)|0;c[(c[k>>2]|0)+12>>2]=b}if(c[(c[k>>2]|0)+12>>2]|0)c[(c[(c[k>>2]|0)+12>>2]|0)+20>>2]=c[h>>2];c[j>>2]=c[k>>2];c[g>>2]=c[(c[g>>2]|0)+16>>2]}ln(0,79472);c[e>>2]=c[h>>2];m=c[e>>2]|0;i=d;return m|0}while(0);c[e>>2]=c[h>>2];m=c[e>>2]|0;i=d;return m|0}function km(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=jm(0,c[d>>2]|0)|0;i=b;return a|0}function lm(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;c[h>>2]=0;if(c[e>>2]|0)c[h>>2]=c[(c[e>>2]|0)+80>>2];while(1){if(!(c[f>>2]|0)){j=20;break}c[g>>2]=c[(c[f>>2]|0)+16>>2];if(((c[c[f>>2]>>2]|0)+-1|0)>>>0>=4)break;if(c[(c[f>>2]|0)+12>>2]|0)lm(c[e>>2]|0,c[(c[f>>2]|0)+12>>2]|0);b=(c[(c[f>>2]|0)+8>>2]|0)!=0;if(c[h>>2]|0){if(b?(CP(c[h>>2]|0,c[(c[f>>2]|0)+8>>2]|0)|0)==0:0)zb[c[135736>>2]&511](c[(c[f>>2]|0)+8>>2]|0);if((c[(c[f>>2]|0)+24>>2]|0)!=0?(CP(c[h>>2]|0,c[(c[f>>2]|0)+24>>2]|0)|0)==0:0)zb[c[135736>>2]&511](c[(c[f>>2]|0)+24>>2]|0)}else{if(b)zb[c[135736>>2]&511](c[(c[f>>2]|0)+8>>2]|0);if(c[(c[f>>2]|0)+24>>2]|0)zb[c[135736>>2]&511](c[(c[f>>2]|0)+24>>2]|0)}zb[c[135736>>2]&511](c[f>>2]|0);c[f>>2]=c[g>>2]}if((j|0)==20){i=d;return}mn(0,1,79568,0);i=d;return}function mm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+48|0;h=g+44|0;j=g+40|0;k=g+36|0;l=g+32|0;m=g+28|0;n=g+24|0;o=g+20|0;p=g+16|0;q=g+12|0;r=g+8|0;s=g+4|0;t=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[q>>2]=0;if(!(c[k>>2]|0)){c[h>>2]=0;u=c[h>>2]|0;i=g;return u|0}if(!(c[l>>2]|0)){c[h>>2]=0;u=c[h>>2]|0;i=g;return u|0}f=c[m>>2]|0;if((f|0)==1){if(c[n>>2]|0){mn(c[j>>2]|0,1,79704,0);c[h>>2]=0;u=c[h>>2]|0;i=g;return u|0}}else if((f|0)==4){if(!(c[n>>2]|0)){mn(c[j>>2]|0,1,79848,0);c[h>>2]=0;u=c[h>>2]|0;i=g;return u|0}}else if((f|0)==3){if(!(c[n>>2]|0)){mn(c[j>>2]|0,1,79800,0);c[h>>2]=0;u=c[h>>2]|0;i=g;return u|0}}else if((f|0)==2){if(c[n>>2]|0){mn(c[j>>2]|0,1,79752,0);c[h>>2]=0;u=c[h>>2]|0;i=g;return u|0}}else{mn(c[j>>2]|0,1,79896,0);c[h>>2]=0;u=c[h>>2]|0;i=g;return u|0}c[s>>2]=Ch(c[l>>2]|0,r)|0;if(c[s>>2]|0)c[l>>2]=c[s>>2];c[p>>2]=c[(c[k>>2]|0)+40>>2];if(!(c[p>>2]|0)){c[t>>2]=0;if(c[(c[k>>2]|0)+32>>2]|0)c[t>>2]=c[(c[(c[k>>2]|0)+32>>2]|0)+80>>2];c[p>>2]=Jj(0,c[t>>2]|0)|0;c[(c[k>>2]|0)+40>>2]=c[p>>2]}if(!(c[p>>2]|0)){ln(c[j>>2]|0,79944);if(c[s>>2]|0)zb[c[135736>>2]&511](c[s>>2]|0);if(c[r>>2]|0)zb[c[135736>>2]&511](c[r>>2]|0);c[h>>2]=0;u=c[h>>2]|0;i=g;return u|0}if((((c[(c[k>>2]|0)+32>>2]|0)!=0?(c[(c[(c[k>>2]|0)+32>>2]|0)+44>>2]|0)!=0:0)?(c[o>>2]=Tj(c[(c[(c[(c[k>>2]|0)+32>>2]|0)+44>>2]|0)+40>>2]|0,c[l>>2]|0,c[r>>2]|0)|0,(c[o>>2]|0)!=0):0)?(c[(c[o>>2]|0)+36>>2]|0)==0:0){c[q>>2]=c[(c[o>>2]|0)+44>>2];c[(c[o>>2]|0)+44>>2]=0;ck(c[(c[(c[(c[k>>2]|0)+32>>2]|0)+44>>2]|0)+40>>2]|0,c[l>>2]|0,c[r>>2]|0,0)|0;nn(c[o>>2]|0)}c[o>>2]=Tj(c[p>>2]|0,c[l>>2]|0,c[r>>2]|0)|0;do if(!(c[o>>2]|0)){c[o>>2]=Cb[c[135744>>2]&511](56)|0;if(!(c[o>>2]|0)){ln(c[j>>2]|0,79472);if(c[s>>2]|0)zb[c[135736>>2]&511](c[s>>2]|0);if(c[r>>2]|0)zb[c[135736>>2]&511](c[r>>2]|0);c[h>>2]=0;u=c[h>>2]|0;i=g;return u|0}t=(c[o>>2]|0)+0|0;f=t+56|0;do{c[t>>2]=0;t=t+4|0}while((t|0)<(f|0));c[(c[o>>2]|0)+4>>2]=15;t=my(c[l>>2]|0)|0;c[(c[o>>2]|0)+8>>2]=t;if(!(c[(c[o>>2]|0)+8>>2]|0)){ln(c[j>>2]|0,79472);if(c[s>>2]|0)zb[c[135736>>2]&511](c[s>>2]|0);if(c[r>>2]|0)zb[c[135736>>2]&511](c[r>>2]|0);zb[c[135736>>2]&511](c[o>>2]|0);c[h>>2]=0;u=c[h>>2]|0;i=g;return u|0}else{c[(c[o>>2]|0)+48>>2]=c[r>>2];if(!(Nj(c[p>>2]|0,c[l>>2]|0,c[r>>2]|0,c[o>>2]|0)|0)){c[(c[o>>2]|0)+44>>2]=c[q>>2];break}jn(c[j>>2]|0,c[k>>2]|0,509,79992,c[l>>2]|0,0,0);nn(c[o>>2]|0);if(c[s>>2]|0)zb[c[135736>>2]&511](c[s>>2]|0);c[h>>2]=0;u=c[h>>2]|0;i=g;return u|0}}else{if(!(c[(c[o>>2]|0)+36>>2]|0)){if(!(c[r>>2]|0))break;zb[c[135736>>2]&511](c[r>>2]|0);c[r>>2]=0;break}jn(c[j>>2]|0,c[k>>2]|0,509,79992,c[l>>2]|0,0,0);if(c[s>>2]|0)zb[c[135736>>2]&511](c[s>>2]|0);if(c[r>>2]|0)zb[c[135736>>2]&511](c[r>>2]|0);c[h>>2]=0;u=c[h>>2]|0;i=g;return u|0}while(0);c[(c[o>>2]|0)+36>>2]=c[m>>2];do if(c[j>>2]|0){if((c[(c[j>>2]|0)+28>>2]|0)!=-1412623820?(c[(c[j>>2]|0)+28>>2]|0)!=-1412623819:0){v=63;break}c[(c[o>>2]|0)+40>>2]=c[n>>2];if(c[n>>2]|0)c[(c[n>>2]|0)+20>>2]=1}else v=63;while(0);if((v|0)==63){v=jm(c[(c[k>>2]|0)+32>>2]|0,c[n>>2]|0)|0;c[(c[o>>2]|0)+40>>2]=v}c[(c[o>>2]|0)+20>>2]=c[k>>2];c[(c[o>>2]|0)+32>>2]=c[(c[k>>2]|0)+32>>2];v=c[o>>2]|0;n=(c[k>>2]|0)+16|0;if(!(c[(c[k>>2]|0)+16>>2]|0)){c[n>>2]=v;c[(c[k>>2]|0)+12>>2]=v}else{c[(c[n>>2]|0)+24>>2]=v;c[(c[o>>2]|0)+28>>2]=c[(c[k>>2]|0)+16>>2];c[(c[k>>2]|0)+16>>2]=c[o>>2]}if(c[s>>2]|0)zb[c[135736>>2]&511](c[s>>2]|0);c[h>>2]=c[o>>2];u=c[h>>2]|0;i=g;return u|0}function nm(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;Kj(c[d>>2]|0,242);i=b;return}function om(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=_j(c[d>>2]|0,243)|0;i=b;return a|0}function pm(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if((c[e>>2]|0)==0|(c[f>>2]|0)==0){i=d;return}b=c[(c[f>>2]|0)+36>>2]|0;if((b|0)==3){rj(c[e>>2]|0,80024);if(c[(c[f>>2]|0)+48>>2]|0){qj(c[e>>2]|0,c[(c[f>>2]|0)+48>>2]|0);rj(c[e>>2]|0,79648)}qj(c[e>>2]|0,c[(c[f>>2]|0)+8>>2]|0);rj(c[e>>2]|0,80064);pn(c[e>>2]|0,c[(c[f>>2]|0)+40>>2]|0,1);rj(c[e>>2]|0,80072);i=d;return}else if((b|0)==4){rj(c[e>>2]|0,80024);if(c[(c[f>>2]|0)+48>>2]|0){qj(c[e>>2]|0,c[(c[f>>2]|0)+48>>2]|0);rj(c[e>>2]|0,79648)}qj(c[e>>2]|0,c[(c[f>>2]|0)+8>>2]|0);rj(c[e>>2]|0,80064);pn(c[e>>2]|0,c[(c[f>>2]|0)+40>>2]|0,1);rj(c[e>>2]|0,80072);i=d;return}else if((b|0)==1){rj(c[e>>2]|0,80024);if(c[(c[f>>2]|0)+48>>2]|0){qj(c[e>>2]|0,c[(c[f>>2]|0)+48>>2]|0);rj(c[e>>2]|0,79648)}qj(c[e>>2]|0,c[(c[f>>2]|0)+8>>2]|0);rj(c[e>>2]|0,80040);i=d;return}else if((b|0)==2){rj(c[e>>2]|0,80024);if(c[(c[f>>2]|0)+48>>2]|0){qj(c[e>>2]|0,c[(c[f>>2]|0)+48>>2]|0);rj(c[e>>2]|0,79648)}qj(c[e>>2]|0,c[(c[f>>2]|0)+8>>2]|0);rj(c[e>>2]|0,80056);i=d;return}else{mn(0,1,80080,0);i=d;return}}function qm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](8)|0;if(!(c[f>>2]|0)){ln(0,79472);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}a=c[f>>2]|0;c[a+0>>2]=0;c[a+4>>2]=0;if(c[e>>2]|0){a=my(c[e>>2]|0)|0;c[(c[f>>2]|0)+4>>2]=a}c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}function rm(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[c[d>>2]>>2]|0)rm(c[c[d>>2]>>2]|0);if(c[(c[d>>2]|0)+4>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+4>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function sm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if(!(c[e>>2]|0)){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}c[f>>2]=qm(c[(c[e>>2]|0)+4>>2]|0)|0;if(!(c[f>>2]|0)){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}if(c[c[e>>2]>>2]|0){a=sm(c[c[e>>2]>>2]|0)|0;c[c[f>>2]>>2]=a}else c[c[f>>2]>>2]=0;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}function tm(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;l=i;i=i+64|0;m=l+56|0;n=l+52|0;o=l+48|0;p=l+44|0;q=l+40|0;r=l+36|0;s=l+32|0;t=l+28|0;u=l+24|0;v=l+20|0;w=l+16|0;x=l+12|0;y=l+8|0;z=l+4|0;A=l;c[n>>2]=a;c[o>>2]=b;c[p>>2]=d;c[q>>2]=e;c[r>>2]=f;c[s>>2]=g;c[t>>2]=h;c[u>>2]=j;c[v>>2]=k;c[z>>2]=0;if(!(c[o>>2]|0)){rm(c[v>>2]|0);c[m>>2]=0;B=c[m>>2]|0;i=l;return B|0}if(!(c[q>>2]|0)){rm(c[v>>2]|0);c[m>>2]=0;B=c[m>>2]|0;i=l;return B|0}if(!(c[p>>2]|0)){rm(c[v>>2]|0);c[m>>2]=0;B=c[m>>2]|0;i=l;return B|0}if(c[(c[o>>2]|0)+32>>2]|0)c[z>>2]=c[(c[(c[o>>2]|0)+32>>2]|0)+80>>2];if(((c[s>>2]|0)+-1|0)>>>0>=10){mn(c[n>>2]|0,1,80136,0);rm(c[v>>2]|0);c[m>>2]=0;B=c[m>>2]|0;i=l;return B|0}if(((c[u>>2]|0)!=0?(qn(c[(c[o>>2]|0)+32>>2]|0,c[s>>2]|0,c[u>>2]|0)|0)==0:0)?(jn(c[n>>2]|0,c[o>>2]|0,500,80192,c[p>>2]|0,c[q>>2]|0,c[u>>2]|0),c[u>>2]=0,(c[n>>2]|0)!=0):0)c[(c[n>>2]|0)+36>>2]=0;if(((((c[(c[o>>2]|0)+32>>2]|0)!=0?(c[(c[(c[o>>2]|0)+32>>2]|0)+48>>2]|0)==(c[o>>2]|0):0)?(c[(c[(c[o>>2]|0)+32>>2]|0)+44>>2]|0)!=0:0)?(c[(c[(c[(c[o>>2]|0)+32>>2]|0)+44>>2]|0)+44>>2]|0)!=0:0)?(c[w>>2]=Sj(c[(c[(c[(c[o>>2]|0)+32>>2]|0)+44>>2]|0)+44>>2]|0,c[q>>2]|0,c[r>>2]|0,c[p>>2]|0)|0,(c[w>>2]|0)!=0):0){rm(c[v>>2]|0);c[m>>2]=0;B=c[m>>2]|0;i=l;return B|0}c[x>>2]=c[(c[o>>2]|0)+44>>2];if(!(c[x>>2]|0)){c[x>>2]=Jj(0,c[z>>2]|0)|0;c[(c[o>>2]|0)+44>>2]=c[x>>2]}if(!(c[x>>2]|0)){ln(c[n>>2]|0,80240);rm(c[v>>2]|0);c[m>>2]=0;B=c[m>>2]|0;i=l;return B|0}c[w>>2]=Cb[c[135744>>2]&511](64)|0;if(!(c[w>>2]|0)){ln(c[n>>2]|0,79472);rm(c[v>>2]|0);c[m>>2]=0;B=c[m>>2]|0;i=l;return B|0}k=(c[w>>2]|0)+0|0;j=k+64|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(j|0));c[(c[w>>2]|0)+4>>2]=16;c[(c[w>>2]|0)+40>>2]=c[s>>2];c[(c[w>>2]|0)+32>>2]=c[(c[o>>2]|0)+32>>2];if(c[z>>2]|0){k=AP(c[z>>2]|0,c[q>>2]|0,-1)|0;c[(c[w>>2]|0)+8>>2]=k;k=AP(c[z>>2]|0,c[r>>2]|0,-1)|0;c[(c[w>>2]|0)+56>>2]=k;k=AP(c[z>>2]|0,c[p>>2]|0,-1)|0;c[(c[w>>2]|0)+60>>2]=k}else{k=my(c[q>>2]|0)|0;c[(c[w>>2]|0)+8>>2]=k;k=my(c[r>>2]|0)|0;c[(c[w>>2]|0)+56>>2]=k;k=my(c[p>>2]|0)|0;c[(c[w>>2]|0)+60>>2]=k}c[(c[w>>2]|0)+44>>2]=c[t>>2];c[(c[w>>2]|0)+52>>2]=c[v>>2];do if(c[u>>2]|0)if(c[z>>2]|0){v=AP(c[z>>2]|0,c[u>>2]|0,-1)|0;c[(c[w>>2]|0)+48>>2]=v;break}else{v=my(c[u>>2]|0)|0;c[(c[w>>2]|0)+48>>2]=v;break}while(0);if((Mj(c[x>>2]|0,c[(c[w>>2]|0)+8>>2]|0,c[(c[w>>2]|0)+56>>2]|0,c[(c[w>>2]|0)+60>>2]|0,c[w>>2]|0)|0)<0){rn(c[n>>2]|0,c[o>>2]|0,501,80288,c[q>>2]|0,c[p>>2]|0,0);sn(c[w>>2]|0);c[m>>2]=0;B=c[m>>2]|0;i=l;return B|0}c[y>>2]=tn(c[o>>2]|0,c[p>>2]|0,1)|0;a:do if(c[y>>2]|0){if(((c[s>>2]|0)==2?(un(0,c[y>>2]|0,1)|0)!=0:0)?(jn(c[n>>2]|0,c[o>>2]|0,520,80336,c[p>>2]|0,c[q>>2]|0,0),(c[n>>2]|0)!=0):0)c[(c[n>>2]|0)+36>>2]=0;do if(!(qy(c[(c[w>>2]|0)+8>>2]|0,80392)|0)){if((c[(c[w>>2]|0)+56>>2]|0)!=0?(qy(c[(c[w>>2]|0)+56>>2]|0,80392)|0)!=0:0)break;c[A>>2]=c[(c[y>>2]|0)+44>>2];while(1){if(!(c[A>>2]|0))break;if(!(qy(c[(c[A>>2]|0)+8>>2]|0,80392)|0)){if(!(c[(c[w>>2]|0)+56>>2]|0))break;if(!(qy(c[(c[w>>2]|0)+56>>2]|0,80392)|0))break}if(!(c[(c[A>>2]|0)+36>>2]|0))break;c[A>>2]=c[(c[A>>2]|0)+36>>2]}if(c[A>>2]|0){c[(c[w>>2]|0)+36>>2]=c[(c[A>>2]|0)+36>>2];c[(c[A>>2]|0)+36>>2]=c[w>>2];break a}else{c[(c[w>>2]|0)+36>>2]=c[(c[y>>2]|0)+44>>2];c[(c[y>>2]|0)+44>>2]=c[w>>2];break a}}while(0);c[(c[w>>2]|0)+36>>2]=c[(c[y>>2]|0)+44>>2];c[(c[y>>2]|0)+44>>2]=c[w>>2]}while(0);c[(c[w>>2]|0)+20>>2]=c[o>>2];y=c[w>>2]|0;A=(c[o>>2]|0)+16|0;if(!(c[(c[o>>2]|0)+16>>2]|0)){c[A>>2]=y;c[(c[o>>2]|0)+12>>2]=y}else{c[(c[A>>2]|0)+24>>2]=y;c[(c[w>>2]|0)+28>>2]=c[(c[o>>2]|0)+16>>2];c[(c[o>>2]|0)+16>>2]=c[w>>2]}c[m>>2]=c[w>>2];B=c[m>>2]|0;i=l;return B|0}function um(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;Kj(c[d>>2]|0,244);i=b;return}function vm(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=_j(c[d>>2]|0,245)|0;i=b;return a|0}function wm(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if((c[e>>2]|0)==0|(c[f>>2]|0)==0){i=d;return}rj(c[e>>2]|0,80400);qj(c[e>>2]|0,c[(c[f>>2]|0)+60>>2]|0);rj(c[e>>2]|0,80064);if(c[(c[f>>2]|0)+56>>2]|0){qj(c[e>>2]|0,c[(c[f>>2]|0)+56>>2]|0);rj(c[e>>2]|0,79648)}qj(c[e>>2]|0,c[(c[f>>2]|0)+8>>2]|0);do switch(c[(c[f>>2]|0)+40>>2]|0){case 9:{rj(c[e>>2]|0,80504);wn(c[e>>2]|0,c[(c[f>>2]|0)+52>>2]|0);break}case 5:{rj(c[e>>2]|0,80448);break}case 6:{rj(c[e>>2]|0,80456);break}case 7:{rj(c[e>>2]|0,80472);break}case 2:{rj(c[e>>2]|0,80424);break}case 10:{rj(c[e>>2]|0,80512);wn(c[e>>2]|0,c[(c[f>>2]|0)+52>>2]|0);break}case 4:{rj(c[e>>2]|0,80440);break}case 8:{rj(c[e>>2]|0,80488);break}case 1:{rj(c[e>>2]|0,80416);break}case 3:{rj(c[e>>2]|0,80432);break}default:mn(0,1,80136,0)}while(0);b=c[(c[f>>2]|0)+44>>2]|0;if((b|0)==2)rj(c[e>>2]|0,80528);else if((b|0)==3)rj(c[e>>2]|0,80544);else if((b|0)==4)rj(c[e>>2]|0,80560);else if((b|0)!=1)mn(0,1,80568,0);if(c[(c[f>>2]|0)+48>>2]|0){rj(c[e>>2]|0,80064);sj(c[e>>2]|0,c[(c[f>>2]|0)+48>>2]|0)}rj(c[e>>2]|0,80072);i=d;return}function xm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+48|0;h=g+32|0;j=g+28|0;k=g+24|0;l=g+20|0;m=g+16|0;n=g+12|0;o=g+8|0;p=g+4|0;q=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;if(!(c[k>>2]|0)){c[h>>2]=0;r=c[h>>2]|0;i=g;return r|0}if(!(c[l>>2]|0)){c[h>>2]=0;r=c[h>>2]|0;i=g;return r|0}if((c[m>>2]|0)==0&(c[n>>2]|0)==0){c[h>>2]=0;r=c[h>>2]|0;i=g;return r|0}c[p>>2]=c[(c[k>>2]|0)+36>>2];if(!(c[p>>2]|0)){c[q>>2]=0;if(c[(c[k>>2]|0)+32>>2]|0)c[q>>2]=c[(c[(c[k>>2]|0)+32>>2]|0)+80>>2];f=Jj(0,c[q>>2]|0)|0;c[p>>2]=f;c[(c[k>>2]|0)+36>>2]=f}if(!(c[p>>2]|0)){ln(c[j>>2]|0,80624);c[h>>2]=0;r=c[h>>2]|0;i=g;return r|0}c[o>>2]=Cb[c[135744>>2]&511](12)|0;if(!(c[o>>2]|0)){ln(c[j>>2]|0,79472);c[h>>2]=0;r=c[h>>2]|0;i=g;return r|0}j=c[o>>2]|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;j=my(c[l>>2]|0)|0;c[c[o>>2]>>2]=j;if(c[n>>2]|0){j=my(c[n>>2]|0)|0;c[(c[o>>2]|0)+8>>2]=j}if(c[m>>2]|0){j=my(c[m>>2]|0)|0;c[(c[o>>2]|0)+4>>2]=j}if(Lj(c[p>>2]|0,c[l>>2]|0,c[o>>2]|0)|0){mn(0,526,80672,c[l>>2]|0);xn(c[o>>2]|0);c[h>>2]=0;r=c[h>>2]|0;i=g;return r|0}else{c[h>>2]=c[o>>2];r=c[h>>2]|0;i=g;return r|0}return 0}function ym(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;Kj(c[d>>2]|0,246);i=b;return}function zm(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=_j(c[d>>2]|0,247)|0;i=b;return a|0}function Am(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if((c[e>>2]|0)==0|(c[f>>2]|0)==0){i=d;return}rj(c[e>>2]|0,80712);qj(c[e>>2]|0,c[c[f>>2]>>2]|0);b=c[e>>2]|0;if(c[(c[f>>2]|0)+4>>2]|0){rj(b,80728);sj(c[e>>2]|0,c[(c[f>>2]|0)+4>>2]|0);if(c[(c[f>>2]|0)+8>>2]|0){rj(c[e>>2]|0,80064);sj(c[e>>2]|0,c[(c[f>>2]|0)+8>>2]|0)}}else{rj(b,80744);sj(c[e>>2]|0,c[(c[f>>2]|0)+8>>2]|0)}rj(c[e>>2]|0,80760);i=d;return}function Bm(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if((c[e>>2]|0)==0|(c[f>>2]|0)==0){i=d;return}Wj(c[f>>2]|0,248,c[e>>2]|0);i=d;return}function Cm(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if(!(c[j>>2]|0)){c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}if(!(c[k>>2]|0)){c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}if(!(c[l>>2]|0)){c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}c[n>>2]=c[(c[j>>2]|0)+64>>2];if(!(c[n>>2]|0)){e=Jj(0,c[(c[j>>2]|0)+80>>2]|0)|0;c[n>>2]=e;c[(c[j>>2]|0)+64>>2]=e}if(!(c[n>>2]|0)){ln(c[h>>2]|0,80768);c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}c[m>>2]=Cb[c[135744>>2]&511](24)|0;if(!(c[m>>2]|0)){ln(c[h>>2]|0,79472);c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}e=my(c[k>>2]|0)|0;c[(c[m>>2]|0)+4>>2]=e;c[(c[m>>2]|0)+20>>2]=c[j>>2];if((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+44>>2]|0)!=0:0){if(c[(c[j>>2]|0)+80>>2]|0){e=AP(c[(c[j>>2]|0)+80>>2]|0,c[(c[l>>2]|0)+8>>2]|0,-1)|0;c[(c[m>>2]|0)+12>>2]=e}else{e=my(c[(c[l>>2]|0)+8>>2]|0)|0;c[(c[m>>2]|0)+12>>2]=e}c[(c[m>>2]|0)+8>>2]=0}else{c[(c[m>>2]|0)+8>>2]=c[l>>2];c[(c[m>>2]|0)+12>>2]=0}e=Ni(c[(c[l>>2]|0)+20>>2]|0)|0;c[(c[m>>2]|0)+16>>2]=e;if((Lj(c[n>>2]|0,c[k>>2]|0,c[m>>2]|0)|0)<0){jn(c[h>>2]|0,c[(c[l>>2]|0)+20>>2]|0,513,80808,c[k>>2]|0,0,0);An(c[m>>2]|0);c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}if(c[l>>2]|0)c[(c[l>>2]|0)+40>>2]=2;c[g>>2]=c[m>>2];o=c[g>>2]|0;i=f;return o|0}function Dm(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;Kj(c[d>>2]|0,249);i=b;return}function Em(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+128|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+78|0;m=e+28|0;n=e+4|0;o=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+8>>2]|0)!=0:0){if((((c[(c[j>>2]|0)+36>>2]|0)!=0?(c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0)?(PT(c[(c[j>>2]|0)+8>>2]|0,80832)|0)==0:0)?(PT(c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2]|0,80840)|0)==0:0){c[f>>2]=1;p=c[f>>2]|0;i=e;return p|0}if(!(c[g>>2]|0)){c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}if(((c[(c[g>>2]|0)+44>>2]|0)==0?(c[(c[g>>2]|0)+48>>2]|0)==0:0)?(c[(c[g>>2]|0)+4>>2]|0)!=13:0){c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}if((c[(c[g>>2]|0)+4>>2]|0)==13){do if(!(qy(80832,c[(c[j>>2]|0)+8>>2]|0)|0)){if(qy(80848,c[(c[j>>2]|0)+8>>2]|0)|0){if(!(c[h>>2]|0))break;if(qy(c[(c[h>>2]|0)+8>>2]|0,80856)|0)break}c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}while(0);c[f>>2]=1;p=c[f>>2]|0;i=e;return p|0}if(!(c[h>>2]|0)){c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}c[k>>2]=0;if((c[(c[h>>2]|0)+36>>2]|0)!=0?(c[(c[(c[h>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0)q=Bh(c[(c[h>>2]|0)+8>>2]|0,c[(c[(c[h>>2]|0)+36>>2]|0)+12>>2]|0,l,50)|0;else q=c[(c[h>>2]|0)+8>>2]|0;c[n>>2]=q;if((c[(c[j>>2]|0)+36>>2]|0)!=0?(c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0)r=Bh(c[(c[j>>2]|0)+8>>2]|0,c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2]|0,m,50)|0;else r=c[(c[j>>2]|0)+8>>2]|0;c[o>>2]=r;if(((c[n>>2]|0)!=0&(c[o>>2]|0)!=0?(c[k>>2]=Fm(c[(c[g>>2]|0)+44>>2]|0,c[n>>2]|0,c[o>>2]|0)|0,(c[k>>2]|0)==0):0)?(c[(c[g>>2]|0)+48>>2]|0)!=0:0)c[k>>2]=Fm(c[(c[g>>2]|0)+48>>2]|0,c[n>>2]|0,c[o>>2]|0)|0;if((c[o>>2]|0)!=(m|0)?(c[o>>2]|0)!=(c[(c[j>>2]|0)+8>>2]|0):0)zb[c[135736>>2]&511](c[o>>2]|0);if((c[n>>2]|0)!=(l|0)?(c[n>>2]|0)!=(c[(c[h>>2]|0)+8>>2]|0):0)zb[c[135736>>2]&511](c[n>>2]|0);if((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+40>>2]|0)==2:0){c[f>>2]=1;p=c[f>>2]|0;i=e;return p|0}c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}function Fm(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;n=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[m>>2]=0;c[n>>2]=0;if(!(c[g>>2]|0)){c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}if(!(c[(c[g>>2]|0)+44>>2]|0)){c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}c[k>>2]=c[(c[g>>2]|0)+44>>2];if(!(c[k>>2]|0)){c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}c[m>>2]=Ch(c[j>>2]|0,n)|0;g=c[k>>2]|0;if(c[m>>2]|0){c[l>>2]=Sj(g,c[m>>2]|0,c[n>>2]|0,c[h>>2]|0)|0;if(c[n>>2]|0)zb[c[135736>>2]&511](c[n>>2]|0);if(c[m>>2]|0)zb[c[135736>>2]&511](c[m>>2]|0)}else c[l>>2]=Sj(g,c[j>>2]|0,0,c[h>>2]|0)|0;c[f>>2]=c[l>>2];o=c[f>>2]|0;i=e;return o|0}function Gm(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;if(!(c[f>>2]|0)){c[e>>2]=-1;l=c[e>>2]|0;i=d;return l|0}if(!(c[g>>2]|0)){c[e>>2]=-1;l=c[e>>2]|0;i=d;return l|0}c[h>>2]=c[(c[f>>2]|0)+64>>2];if(!(c[h>>2]|0)){c[e>>2]=-1;l=c[e>>2]|0;i=d;return l|0}c[k>>2]=_h(c[f>>2]|0,c[(c[g>>2]|0)+12>>2]|0,1)|0;if(!(c[k>>2]|0)){c[e>>2]=-1;l=c[e>>2]|0;i=d;return l|0}c[j>>2]=Rj(c[h>>2]|0,c[k>>2]|0)|0;if((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+8>>2]|0)==(c[g>>2]|0):0){ak(c[h>>2]|0,c[k>>2]|0,249)|0;zb[c[135736>>2]&511](c[k>>2]|0);c[(c[g>>2]|0)+40>>2]=0;c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}zb[c[135736>>2]&511](c[k>>2]|0);c[e>>2]=-1;l=c[e>>2]|0;i=d;return l|0}function Hm(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[f>>2]=a;c[g>>2]=b;do if(c[f>>2]|0){if(!(c[g>>2]|0)){c[e>>2]=0;break}c[h>>2]=c[(c[f>>2]|0)+64>>2];if(!(c[h>>2]|0)){c[e>>2]=0;break}c[j>>2]=Rj(c[h>>2]|0,c[g>>2]|0)|0;if(!(c[j>>2]|0)){c[e>>2]=0;break}if(!(c[(c[j>>2]|0)+8>>2]|0)){c[e>>2]=c[f>>2];break}else{c[e>>2]=c[(c[j>>2]|0)+8>>2];break}}else c[e>>2]=0;while(0);i=d;return c[e>>2]|0}function Im(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+32|0;g=f+28|0;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f+4|0;o=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if(!(c[j>>2]|0)){c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}if(!(c[k>>2]|0)){c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}if(!(c[l>>2]|0)){c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}c[n>>2]=c[(c[j>>2]|0)+68>>2];if(!(c[n>>2]|0)){e=Jj(0,c[(c[j>>2]|0)+80>>2]|0)|0;c[n>>2]=e;c[(c[j>>2]|0)+68>>2]=e}if(!(c[n>>2]|0)){ln(c[h>>2]|0,80864);c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}c[m>>2]=Cb[c[135744>>2]&511](20)|0;if(!(c[m>>2]|0)){ln(c[h>>2]|0,79472);c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}e=my(c[k>>2]|0)|0;c[(c[m>>2]|0)+4>>2]=e;if((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+44>>2]|0)!=0:0){h=my(c[(c[l>>2]|0)+8>>2]|0)|0;c[(c[m>>2]|0)+12>>2]=h;c[(c[m>>2]|0)+8>>2]=0}else{c[(c[m>>2]|0)+12>>2]=0;c[(c[m>>2]|0)+8>>2]=c[l>>2]}h=Ni(c[(c[l>>2]|0)+20>>2]|0)|0;c[(c[m>>2]|0)+16>>2]=h;h=Rj(c[n>>2]|0,c[k>>2]|0)|0;c[o>>2]=h;do if(!h){l=IS(250,251)|0;c[o>>2]=l;if(!l){mn(0,1,80904,0);break}if((Lj(c[n>>2]|0,c[k>>2]|0,c[o>>2]|0)|0)<0){MS(c[o>>2]|0);mn(0,1,80952,0)}else q=22}else q=22;while(0);do if((q|0)==22){if(LS(c[o>>2]|0,c[m>>2]|0)|0){mn(0,1,80952,0);break}c[g>>2]=c[m>>2];p=c[g>>2]|0;i=f;return p|0}while(0);if(c[m>>2]|0){if(c[(c[m>>2]|0)+4>>2]|0)zb[c[135736>>2]&511](c[(c[m>>2]|0)+4>>2]|0);if(c[(c[m>>2]|0)+12>>2]|0)zb[c[135736>>2]&511](c[(c[m>>2]|0)+12>>2]|0);zb[c[135736>>2]&511](c[m>>2]|0)}c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}function Jm(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;Kj(c[d>>2]|0,252);i=b;return}function Km(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(!(c[j>>2]|0)){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}if((c[g>>2]|0)==0?(c[g>>2]=c[(c[j>>2]|0)+32>>2],(c[g>>2]|0)==0):0){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}if((c[(c[g>>2]|0)+44>>2]|0)==0?(c[(c[g>>2]|0)+48>>2]|0)==0:0){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}if((c[(c[g>>2]|0)+4>>2]|0)==13){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}if(!(c[h>>2]|0)){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}c[k>>2]=Fm(c[(c[g>>2]|0)+44>>2]|0,c[(c[h>>2]|0)+8>>2]|0,c[(c[j>>2]|0)+8>>2]|0)|0;if((c[k>>2]|0)==0?(c[(c[g>>2]|0)+48>>2]|0)!=0:0)c[k>>2]=Fm(c[(c[g>>2]|0)+48>>2]|0,c[(c[h>>2]|0)+8>>2]|0,c[(c[j>>2]|0)+8>>2]|0)|0;do if(c[k>>2]|0){if((c[(c[k>>2]|0)+40>>2]|0)!=3?(c[(c[k>>2]|0)+40>>2]|0)!=4:0)break;c[f>>2]=1;l=c[f>>2]|0;i=e;return l|0}while(0);c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}function Lm(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[f>>2]=a;c[g>>2]=b;c[k>>2]=0;c[l>>2]=0;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}if(!(c[(c[f>>2]|0)+40>>2]|0)){c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}c[h>>2]=c[(c[f>>2]|0)+40>>2];c[k>>2]=Ch(c[g>>2]|0,l)|0;if(c[k>>2]|0)c[g>>2]=c[k>>2];c[j>>2]=Tj(c[h>>2]|0,c[g>>2]|0,c[l>>2]|0)|0;if(c[l>>2]|0)zb[c[135736>>2]&511](c[l>>2]|0);if(c[k>>2]|0)zb[c[135736>>2]&511](c[k>>2]|0);c[e>>2]=c[j>>2];m=c[e>>2]|0;i=d;return m|0}function Mm(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(!(c[g>>2]|0)){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}if(!(c[(c[g>>2]|0)+40>>2]|0)){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}else{c[k>>2]=c[(c[g>>2]|0)+40>>2];c[f>>2]=Tj(c[k>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;l=c[f>>2]|0;i=e;return l|0}return 0}function Nm(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if(!(c[h>>2]|0)){c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}if(!(c[(c[h>>2]|0)+44>>2]|0)){c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}else{c[m>>2]=c[(c[h>>2]|0)+44>>2];c[g>>2]=Sj(c[m>>2]|0,c[k>>2]|0,c[l>>2]|0,c[j>>2]|0)|0;n=c[g>>2]|0;i=f;return n|0}return 0}function Om(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;do if(c[f>>2]|0)if(!(c[(c[f>>2]|0)+36>>2]|0)){c[e>>2]=0;break}else{c[h>>2]=c[(c[f>>2]|0)+36>>2];c[e>>2]=Rj(c[h>>2]|0,c[g>>2]|0)|0;break}else c[e>>2]=0;while(0);i=d;return c[e>>2]|0}function Pm(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if((c[h>>2]|0)!=0?!((c[j>>2]|0)==0?1:(c[(c[h>>2]|0)+44>>2]|0)==0):0){c[k>>2]=Om(c[(c[h>>2]|0)+44>>2]|0,c[j>>2]|0)|0;if((c[k>>2]|0)==0?(c[(c[h>>2]|0)+48>>2]|0)!=0:0)c[k>>2]=Om(c[(c[h>>2]|0)+48>>2]|0,c[j>>2]|0)|0;if((c[k>>2]|0)==0&(c[g>>2]|0)!=0){jn(c[g>>2]|0,c[h>>2]|0,537,81e3,c[j>>2]|0,0,0);c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}else{c[f>>2]=1;l=c[f>>2]|0;i=e;return l|0}}c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}function Qm(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;a:do if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+44>>2]|0)!=0:0){c[h>>2]=Lm(c[(c[f>>2]|0)+44>>2]|0,c[g>>2]|0)|0;if((c[h>>2]|0)==0?(c[(c[f>>2]|0)+48>>2]|0)!=0:0)c[h>>2]=Lm(c[(c[f>>2]|0)+48>>2]|0,c[g>>2]|0)|0;if(!(c[h>>2]|0)){c[e>>2]=-1;break}switch(c[(c[h>>2]|0)+36>>2]|0){case 4:{c[e>>2]=0;break a;break}case 0:{c[e>>2]=-1;break a;break}case 3:case 2:case 1:{c[e>>2]=1;break a;break}default:{c[e>>2]=1;break a}}}else j=3;while(0);if((j|0)==3)c[e>>2]=-1;i=d;return c[e>>2]|0}function Rm(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[e+12>>2]=a;c[e+8>>2]=b;c[e+4>>2]=d;c[f>>2]=1;i=e;return c[f>>2]|0}function Sm(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;i=i+112|0;k=j+44|0;l=j+40|0;m=j+36|0;n=j+32|0;o=j+28|0;p=j+24|0;q=j+20|0;r=j+16|0;s=j+12|0;t=j+8|0;u=j+4|0;v=j+48|0;w=j;c[l>>2]=b;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[p>>2]=h;c[t>>2]=0;c[u>>2]=0;if(!(c[m>>2]|0)){c[k>>2]=0;x=c[k>>2]|0;i=j;return x|0}if(!(c[n>>2]|0)){c[k>>2]=0;x=c[k>>2]|0;i=j;return x|0}if(!(c[o>>2]|0)){c[k>>2]=0;x=c[k>>2]|0;i=j;return x|0}if(!(c[p>>2]|0)){c[k>>2]=0;x=c[k>>2]|0;i=j;return x|0}if((c[(c[n>>2]|0)+36>>2]|0)!=0?(c[(c[(c[n>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){c[w>>2]=Bh(c[(c[n>>2]|0)+8>>2]|0,c[(c[(c[n>>2]|0)+36>>2]|0)+12>>2]|0,v,50)|0;if(!(c[w>>2]|0)){c[k>>2]=0;x=c[k>>2]|0;i=j;return x|0}c[t>>2]=Fm(c[(c[m>>2]|0)+44>>2]|0,c[w>>2]|0,c[o>>2]|0)|0;if(((c[t>>2]|0)==0?(c[(c[m>>2]|0)+48>>2]|0)!=0:0)?(c[t>>2]=Fm(c[(c[m>>2]|0)+48>>2]|0,c[w>>2]|0,c[o>>2]|0)|0,(c[t>>2]|0)!=0):0)c[u>>2]=1;if((c[w>>2]|0)!=(v|0)?(c[w>>2]|0)!=(c[(c[n>>2]|0)+8>>2]|0):0)zb[c[135736>>2]&511](c[w>>2]|0)}if((c[t>>2]|0)==0?(c[(c[m>>2]|0)+44>>2]|0)!=0:0)c[t>>2]=Fm(c[(c[m>>2]|0)+44>>2]|0,c[(c[n>>2]|0)+8>>2]|0,c[o>>2]|0)|0;if(((c[t>>2]|0)==0?(c[(c[m>>2]|0)+48>>2]|0)!=0:0)?(c[t>>2]=Fm(c[(c[m>>2]|0)+48>>2]|0,c[(c[n>>2]|0)+8>>2]|0,c[o>>2]|0)|0,(c[t>>2]|0)!=0):0)c[u>>2]=1;if(!(c[t>>2]|0)){c[k>>2]=0;x=c[k>>2]|0;i=j;return x|0}if((c[(c[t>>2]|0)+40>>2]|0)==1){c[k>>2]=0;x=c[k>>2]|0;i=j;return x|0}c[q>>2]=my(c[p>>2]|0)|0;if(!(c[q>>2]|0)){c[k>>2]=0;x=c[k>>2]|0;i=j;return x|0}c[s>>2]=c[p>>2];c[r>>2]=c[q>>2];while(1){if((d[c[s>>2]>>0]|0|0)!=32)break;c[s>>2]=(c[s>>2]|0)+1}while(1){if(!(d[c[s>>2]>>0]|0))break;if((d[c[s>>2]>>0]|0|0)!=32){t=c[s>>2]|0;c[s>>2]=t+1;w=a[t>>0]|0;t=c[r>>2]|0;c[r>>2]=t+1;a[t>>0]=w;continue}while(1){y=c[s>>2]|0;if((d[c[s>>2]>>0]|0|0)!=32)break;c[s>>2]=y+1}if(!(d[y>>0]|0))continue;w=c[r>>2]|0;c[r>>2]=w+1;a[w>>0]=32}a[c[r>>2]>>0]=0;if(((c[u>>2]|0)==1?(c[(c[m>>2]|0)+40>>2]|0)!=0:0)?(qy(c[p>>2]|0,c[q>>2]|0)|0)==0:0){jn(c[l>>2]|0,c[n>>2]|0,530,81032,c[o>>2]|0,c[(c[n>>2]|0)+8>>2]|0,0);c[(c[l>>2]|0)+36>>2]=0}c[k>>2]=c[q>>2];x=c[k>>2]|0;i=j;return x|0}function Tm(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;h=i;i=i+96|0;j=h+36|0;k=h+32|0;l=h+28|0;m=h+24|0;n=h+20|0;o=h+16|0;p=h+12|0;q=h+8|0;r=h+4|0;s=h+40|0;t=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;c[r>>2]=0;if(!(c[k>>2]|0)){c[j>>2]=0;
u=c[j>>2]|0;i=h;return u|0}if(!(c[l>>2]|0)){c[j>>2]=0;u=c[j>>2]|0;i=h;return u|0}if(!(c[m>>2]|0)){c[j>>2]=0;u=c[j>>2]|0;i=h;return u|0}if(!(c[n>>2]|0)){c[j>>2]=0;u=c[j>>2]|0;i=h;return u|0}if((c[(c[l>>2]|0)+36>>2]|0)!=0?(c[(c[(c[l>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){c[t>>2]=Bh(c[(c[l>>2]|0)+8>>2]|0,c[(c[(c[l>>2]|0)+36>>2]|0)+12>>2]|0,s,50)|0;if(!(c[t>>2]|0)){c[j>>2]=0;u=c[j>>2]|0;i=h;return u|0}if((c[t>>2]|0)!=(s|0)?(c[t>>2]|0)!=(c[(c[l>>2]|0)+8>>2]|0):0)zb[c[135736>>2]&511](c[t>>2]|0)}c[r>>2]=Fm(c[(c[k>>2]|0)+44>>2]|0,c[(c[l>>2]|0)+8>>2]|0,c[m>>2]|0)|0;if((c[r>>2]|0)==0?(c[(c[k>>2]|0)+48>>2]|0)!=0:0)c[r>>2]=Fm(c[(c[k>>2]|0)+48>>2]|0,c[(c[l>>2]|0)+8>>2]|0,c[m>>2]|0)|0;if(!(c[r>>2]|0)){c[j>>2]=0;u=c[j>>2]|0;i=h;return u|0}if((c[(c[r>>2]|0)+40>>2]|0)==1){c[j>>2]=0;u=c[j>>2]|0;i=h;return u|0}c[o>>2]=my(c[n>>2]|0)|0;if(!(c[o>>2]|0)){c[j>>2]=0;u=c[j>>2]|0;i=h;return u|0}c[q>>2]=c[n>>2];c[p>>2]=c[o>>2];while(1){if((d[c[q>>2]>>0]|0|0)!=32)break;c[q>>2]=(c[q>>2]|0)+1}while(1){if(!(d[c[q>>2]>>0]|0))break;if((d[c[q>>2]>>0]|0|0)!=32){n=c[q>>2]|0;c[q>>2]=n+1;r=a[n>>0]|0;n=c[p>>2]|0;c[p>>2]=n+1;a[n>>0]=r;continue}while(1){v=c[q>>2]|0;if((d[c[q>>2]>>0]|0|0)!=32)break;c[q>>2]=v+1}if(!(d[v>>0]|0))continue;r=c[p>>2]|0;c[p>>2]=r+1;a[r>>0]=32}a[c[p>>2]>>0]=0;c[j>>2]=c[o>>2];u=c[j>>2]|0;i=h;return u|0}function Um(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+48|0;f=e+40|0;g=e+36|0;h=e+32|0;j=e+28|0;k=e+24|0;l=e+20|0;m=e+16|0;n=e+12|0;o=e+8|0;p=e+4|0;q=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=1;if(!(c[h>>2]|0)){c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}if((c[(c[h>>2]|0)+44>>2]|0)==0?(c[(c[h>>2]|0)+48>>2]|0)==0:0){c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}if(!(c[j>>2]|0)){c[f>>2]=1;r=c[f>>2]|0;i=e;return r|0}if(c[(c[j>>2]|0)+48>>2]|0){c[l>>2]=qn(c[h>>2]|0,c[(c[j>>2]|0)+40>>2]|0,c[(c[j>>2]|0)+48>>2]|0)|0;if(!(c[l>>2]|0))jn(c[g>>2]|0,c[j>>2]|0,500,81120,c[(c[j>>2]|0)+8>>2]|0,c[(c[j>>2]|0)+60>>2]|0,0);c[k>>2]=c[k>>2]&c[l>>2]}if(((c[(c[j>>2]|0)+40>>2]|0)==2?(c[(c[j>>2]|0)+44>>2]|0)!=3:0)?(c[(c[j>>2]|0)+44>>2]|0)!=2:0){jn(c[g>>2]|0,c[j>>2]|0,512,81184,c[(c[j>>2]|0)+8>>2]|0,c[(c[j>>2]|0)+60>>2]|0,0);c[k>>2]=0}do if((c[(c[j>>2]|0)+40>>2]|0)==2){c[n>>2]=Lm(c[(c[h>>2]|0)+44>>2]|0,c[(c[j>>2]|0)+60>>2]|0)|0;if(!(c[n>>2]|0)){c[m>>2]=0;if(c[(c[h>>2]|0)+44>>2]|0){c[o>>2]=c[(c[(c[h>>2]|0)+44>>2]|0)+44>>2];Yj(c[o>>2]|0,0,0,c[(c[j>>2]|0)+60>>2]|0,253,m)}}else c[m>>2]=un(0,c[n>>2]|0,0)|0;if((c[m>>2]|0)>1){Jn(c[g>>2]|0,c[j>>2]|0,514,81256,c[(c[j>>2]|0)+60>>2]|0,c[m>>2]|0,c[(c[j>>2]|0)+8>>2]|0);break}if(c[(c[h>>2]|0)+48>>2]|0){c[p>>2]=0;c[n>>2]=Lm(c[(c[h>>2]|0)+48>>2]|0,c[(c[j>>2]|0)+60>>2]|0)|0;if(c[n>>2]|0)c[p>>2]=un(0,c[n>>2]|0,0)|0;if((c[p>>2]|0)>1){Jn(c[g>>2]|0,c[j>>2]|0,514,81328,c[(c[j>>2]|0)+60>>2]|0,c[p>>2]|0,c[(c[j>>2]|0)+8>>2]|0);break}if(((c[p>>2]|0)+(c[m>>2]|0)|0)>1)jn(c[g>>2]|0,c[j>>2]|0,514,81400,c[(c[j>>2]|0)+60>>2]|0,c[(c[j>>2]|0)+8>>2]|0,0)}}while(0);if((c[(c[j>>2]|0)+48>>2]|0)!=0?(c[(c[j>>2]|0)+52>>2]|0)!=0:0){c[q>>2]=c[(c[j>>2]|0)+52>>2];while(1){if(!(c[q>>2]|0))break;if(qy(c[(c[q>>2]|0)+4>>2]|0,c[(c[j>>2]|0)+48>>2]|0)|0)break;c[q>>2]=c[c[q>>2]>>2]}if(!(c[q>>2]|0)){jn(c[g>>2]|0,c[j>>2]|0,502,81480,c[(c[j>>2]|0)+48>>2]|0,c[(c[j>>2]|0)+8>>2]|0,c[(c[j>>2]|0)+60>>2]|0);c[k>>2]=0}}c[f>>2]=c[k>>2];r=c[f>>2]|0;i=e;return r|0}function Vm(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+48|0;f=e+32|0;g=e+28|0;h=e+24|0;j=e+20|0;k=e+16|0;l=e+12|0;m=e+8|0;n=e+4|0;o=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=1;if(!(c[h>>2]|0)){c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}if((c[(c[h>>2]|0)+44>>2]|0)==0?(c[(c[h>>2]|0)+48>>2]|0)==0:0){c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}if(!(c[j>>2]|0)){c[f>>2]=1;p=c[f>>2]|0;i=e;return p|0}a:do if((c[(c[j>>2]|0)+36>>2]|0)==3){c[m>>2]=c[(c[j>>2]|0)+40>>2];while(1){if(!(c[m>>2]|0))break a;if((c[c[m>>2]>>2]|0)!=4)break a;if(!(c[(c[m>>2]|0)+12>>2]|0))break a;b:do if((c[c[(c[m>>2]|0)+12>>2]>>2]|0)==2){c[o>>2]=c[(c[(c[m>>2]|0)+12>>2]|0)+8>>2];c[n>>2]=c[(c[m>>2]|0)+16>>2];while(1){if(!(c[n>>2]|0))break b;q=c[n>>2]|0;if((c[c[n>>2]>>2]|0)==2)break;if(!(c[q+12>>2]|0))break b;if((c[c[(c[n>>2]|0)+12>>2]>>2]|0)!=2)break b;if((qy(c[(c[(c[n>>2]|0)+12>>2]|0)+8>>2]|0,c[o>>2]|0)|0)!=0?(qy(c[(c[(c[n>>2]|0)+12>>2]|0)+24>>2]|0,c[(c[(c[m>>2]|0)+12>>2]|0)+24>>2]|0)|0)!=0:0){d=c[g>>2]|0;b=c[j>>2]|0;a=c[(c[j>>2]|0)+8>>2]|0;if(!(c[(c[(c[m>>2]|0)+12>>2]|0)+24>>2]|0))jn(d,b,503,81672,a,c[o>>2]|0,0);else jn(d,b,503,81728,a,c[(c[(c[m>>2]|0)+12>>2]|0)+24>>2]|0,c[o>>2]|0);c[k>>2]=0}c[n>>2]=c[(c[n>>2]|0)+16>>2]}if((qy(c[q+8>>2]|0,c[o>>2]|0)|0)!=0?(qy(c[(c[n>>2]|0)+24>>2]|0,c[(c[(c[m>>2]|0)+12>>2]|0)+24>>2]|0)|0)!=0:0){a=c[g>>2]|0;b=c[j>>2]|0;d=c[(c[j>>2]|0)+8>>2]|0;if(!(c[(c[(c[m>>2]|0)+12>>2]|0)+24>>2]|0))jn(a,b,503,81560,d,c[o>>2]|0,0);else jn(a,b,503,81616,d,c[(c[(c[m>>2]|0)+12>>2]|0)+24>>2]|0,c[o>>2]|0);c[k>>2]=0}}while(0);c[m>>2]=c[(c[m>>2]|0)+16>>2]}}while(0);c[l>>2]=Lm(c[(c[h>>2]|0)+44>>2]|0,c[(c[j>>2]|0)+8>>2]|0)|0;do if((c[l>>2]|0)!=0?(c[l>>2]|0)!=(c[j>>2]|0):0){if((c[(c[l>>2]|0)+48>>2]|0)!=(c[(c[j>>2]|0)+48>>2]|0)?(qy(c[(c[l>>2]|0)+48>>2]|0,c[(c[j>>2]|0)+48>>2]|0)|0)==0:0)break;if(c[(c[l>>2]|0)+36>>2]|0){jn(c[g>>2]|0,c[j>>2]|0,509,79992,c[(c[j>>2]|0)+8>>2]|0,0,0);c[k>>2]=0}}while(0);c[l>>2]=Lm(c[(c[h>>2]|0)+48>>2]|0,c[(c[j>>2]|0)+8>>2]|0)|0;do if((c[l>>2]|0)!=0?(c[l>>2]|0)!=(c[j>>2]|0):0){if((c[(c[l>>2]|0)+48>>2]|0)!=(c[(c[j>>2]|0)+48>>2]|0)?(qy(c[(c[l>>2]|0)+48>>2]|0,c[(c[j>>2]|0)+48>>2]|0)|0)==0:0)break;if(c[(c[l>>2]|0)+36>>2]|0){jn(c[g>>2]|0,c[j>>2]|0,509,79992,c[(c[j>>2]|0)+8>>2]|0,0,0);c[k>>2]=0}}while(0);c[f>>2]=c[k>>2];p=c[f>>2]|0;i=e;return p|0}function Wm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;i=i+112|0;h=g+48|0;j=g+44|0;k=g+40|0;l=g+36|0;m=g+32|0;n=g+28|0;o=g+24|0;p=g+20|0;q=g+16|0;r=g+52|0;s=g+12|0;t=g+8|0;u=g+4|0;v=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=0;c[q>>2]=1;if(!(c[k>>2]|0)){c[h>>2]=0;w=c[h>>2]|0;i=g;return w|0}if((c[(c[k>>2]|0)+44>>2]|0)==0?(c[(c[k>>2]|0)+48>>2]|0)==0:0){c[h>>2]=0;w=c[h>>2]|0;i=g;return w|0}if((c[l>>2]|0)!=0?(c[(c[l>>2]|0)+8>>2]|0)!=0:0){if((c[m>>2]|0)!=0?(c[(c[m>>2]|0)+8>>2]|0)!=0:0){if((c[(c[l>>2]|0)+36>>2]|0)!=0?(c[(c[(c[l>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){c[s>>2]=Bh(c[(c[l>>2]|0)+8>>2]|0,c[(c[(c[l>>2]|0)+36>>2]|0)+12>>2]|0,r,50)|0;if(!(c[s>>2]|0)){c[h>>2]=0;w=c[h>>2]|0;i=g;return w|0}f=c[(c[k>>2]|0)+44>>2]|0;e=c[s>>2]|0;d=c[(c[m>>2]|0)+8>>2]|0;if(c[(c[m>>2]|0)+36>>2]|0){c[o>>2]=Nm(f,e,d,c[(c[(c[m>>2]|0)+36>>2]|0)+12>>2]|0)|0;if((c[o>>2]|0)==0?(c[(c[k>>2]|0)+48>>2]|0)!=0:0)c[o>>2]=Nm(c[(c[k>>2]|0)+48>>2]|0,c[s>>2]|0,c[(c[m>>2]|0)+8>>2]|0,c[(c[(c[m>>2]|0)+36>>2]|0)+12>>2]|0)|0}else{c[o>>2]=Fm(f,e,d)|0;if((c[o>>2]|0)==0?(c[(c[k>>2]|0)+48>>2]|0)!=0:0)c[o>>2]=Fm(c[(c[k>>2]|0)+48>>2]|0,c[s>>2]|0,c[(c[m>>2]|0)+8>>2]|0)|0}if((c[s>>2]|0)!=(r|0)?(c[s>>2]|0)!=(c[(c[l>>2]|0)+8>>2]|0):0)zb[c[135736>>2]&511](c[s>>2]|0)}do if(!(c[o>>2]|0)){s=c[(c[k>>2]|0)+44>>2]|0;r=c[(c[l>>2]|0)+8>>2]|0;d=c[(c[m>>2]|0)+8>>2]|0;if(c[(c[m>>2]|0)+36>>2]|0){c[o>>2]=Nm(s,r,d,c[(c[(c[m>>2]|0)+36>>2]|0)+12>>2]|0)|0;if(c[o>>2]|0)break;if(!(c[(c[k>>2]|0)+48>>2]|0))break;c[o>>2]=Nm(c[(c[k>>2]|0)+48>>2]|0,c[(c[l>>2]|0)+8>>2]|0,c[(c[m>>2]|0)+8>>2]|0,c[(c[(c[m>>2]|0)+36>>2]|0)+12>>2]|0)|0;break}else{c[o>>2]=Fm(s,r,d)|0;if(c[o>>2]|0)break;if(!(c[(c[k>>2]|0)+48>>2]|0))break;c[o>>2]=Fm(c[(c[k>>2]|0)+48>>2]|0,c[(c[l>>2]|0)+8>>2]|0,c[(c[m>>2]|0)+8>>2]|0)|0;break}}while(0);if(!(c[o>>2]|0)){jn(c[j>>2]|0,c[l>>2]|0,533,81784,c[(c[m>>2]|0)+8>>2]|0,c[(c[l>>2]|0)+8>>2]|0,0);c[h>>2]=0;w=c[h>>2]|0;i=g;return w|0}c[(c[m>>2]|0)+40>>2]=c[(c[o>>2]|0)+40>>2];c[p>>2]=qn(c[k>>2]|0,c[(c[o>>2]|0)+40>>2]|0,c[n>>2]|0)|0;if(!(c[p>>2]|0)){jn(c[j>>2]|0,c[l>>2]|0,502,81832,c[(c[m>>2]|0)+8>>2]|0,c[(c[l>>2]|0)+8>>2]|0,0);c[q>>2]=0}if((c[(c[o>>2]|0)+44>>2]|0)==4?(qy(c[n>>2]|0,c[(c[o>>2]|0)+48>>2]|0)|0)==0:0){jn(c[j>>2]|0,c[l>>2]|0,500,81888,c[(c[m>>2]|0)+8>>2]|0,c[(c[l>>2]|0)+8>>2]|0,c[(c[o>>2]|0)+48>>2]|0);c[q>>2]=0}if((c[(c[o>>2]|0)+40>>2]|0)==2?(Cm(c[j>>2]|0,c[k>>2]|0,c[n>>2]|0,c[m>>2]|0)|0)==0:0)c[q>>2]=0;if(!((c[(c[o>>2]|0)+40>>2]|0)!=3?(c[(c[o>>2]|0)+40>>2]|0)!=4:0))x=46;if((x|0)==46?(Im(c[j>>2]|0,c[k>>2]|0,c[n>>2]|0,c[m>>2]|0)|0)==0:0)c[q>>2]=0;if((c[(c[o>>2]|0)+40>>2]|0)==10){c[t>>2]=c[(c[o>>2]|0)+52>>2];c[u>>2]=Om(c[(c[k>>2]|0)+44>>2]|0,c[n>>2]|0)|0;if(!(c[u>>2]|0))c[u>>2]=Om(c[(c[k>>2]|0)+48>>2]|0,c[n>>2]|0)|0;if(!(c[u>>2]|0)){jn(c[j>>2]|0,c[l>>2]|0,537,81952,c[n>>2]|0,c[(c[m>>2]|0)+8>>2]|0,c[(c[l>>2]|0)+8>>2]|0);c[q>>2]=0}while(1){if(!(c[t>>2]|0))break;if(qy(c[(c[t>>2]|0)+4>>2]|0,c[n>>2]|0)|0)break;c[t>>2]=c[c[t>>2]>>2]}if(!(c[t>>2]|0)){jn(c[j>>2]|0,c[l>>2]|0,527,82016,c[n>>2]|0,c[(c[m>>2]|0)+8>>2]|0,c[(c[l>>2]|0)+8>>2]|0);c[q>>2]=0}}if((c[(c[o>>2]|0)+40>>2]|0)==9){c[v>>2]=c[(c[o>>2]|0)+52>>2];while(1){if(!(c[v>>2]|0))break;if(qy(c[(c[v>>2]|0)+4>>2]|0,c[n>>2]|0)|0)break;c[v>>2]=c[c[v>>2]>>2]}if(!(c[v>>2]|0)){jn(c[j>>2]|0,c[l>>2]|0,502,82096,c[n>>2]|0,c[(c[m>>2]|0)+8>>2]|0,c[(c[l>>2]|0)+8>>2]|0);c[q>>2]=0}}if((c[(c[o>>2]|0)+44>>2]|0)==4?(qy(c[(c[o>>2]|0)+48>>2]|0,c[n>>2]|0)|0)==0:0){jn(c[j>>2]|0,c[l>>2]|0,502,82168,c[(c[m>>2]|0)+8>>2]|0,c[(c[l>>2]|0)+8>>2]|0,c[(c[o>>2]|0)+48>>2]|0);c[q>>2]=0}l=Kn(c[j>>2]|0,c[k>>2]|0,c[(c[m>>2]|0)+8>>2]|0,c[(c[o>>2]|0)+40>>2]|0,c[n>>2]|0)|0;c[q>>2]=c[q>>2]&l;c[h>>2]=c[q>>2];w=c[h>>2]|0;i=g;return w|0}c[h>>2]=0;w=c[h>>2]|0;i=g;return w|0}c[h>>2]=0;w=c[h>>2]|0;i=g;return w|0}function Xm(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;h=i;i=i+112|0;j=h+52|0;k=h+48|0;l=h+44|0;m=h+40|0;n=h+36|0;o=h+32|0;p=h+28|0;q=h+24|0;r=h+20|0;s=h+16|0;t=h+56|0;u=h+12|0;v=h+8|0;w=h+4|0;x=h;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=0;c[s>>2]=1;if(!(c[l>>2]|0)){c[j>>2]=0;y=c[j>>2]|0;i=h;return y|0}if((c[(c[l>>2]|0)+44>>2]|0)==0?(c[(c[l>>2]|0)+48>>2]|0)==0:0){c[j>>2]=0;y=c[j>>2]|0;i=h;return y|0}if((c[m>>2]|0)!=0?(c[(c[m>>2]|0)+8>>2]|0)!=0:0){if((c[o>>2]|0)!=0?(c[(c[o>>2]|0)+8>>2]|0)!=0:0){if(c[n>>2]|0){c[u>>2]=Bh(c[(c[m>>2]|0)+8>>2]|0,c[n>>2]|0,t,50)|0;if(!(c[u>>2]|0)){ln(c[k>>2]|0,82216);c[j>>2]=0;y=c[j>>2]|0;i=h;return y|0}n=c[(c[l>>2]|0)+44>>2]|0;g=c[u>>2]|0;if(c[(c[o>>2]|0)+12>>2]|0){c[q>>2]=Nm(n,g,c[(c[o>>2]|0)+12>>2]|0,80392)|0;if((c[q>>2]|0)==0?(c[(c[l>>2]|0)+48>>2]|0)!=0:0)c[q>>2]=Nm(c[(c[l>>2]|0)+48>>2]|0,c[u>>2]|0,c[(c[o>>2]|0)+12>>2]|0,80392)|0}else{c[q>>2]=Fm(n,g,80392)|0;if((c[q>>2]|0)==0?(c[(c[l>>2]|0)+48>>2]|0)!=0:0)c[q>>2]=Fm(c[(c[l>>2]|0)+48>>2]|0,c[u>>2]|0,80392)|0}if((c[u>>2]|0)!=(t|0)?(c[u>>2]|0)!=(c[(c[m>>2]|0)+8>>2]|0):0)zb[c[135736>>2]&511](c[u>>2]|0)}do if(!(c[q>>2]|0)){u=c[(c[l>>2]|0)+44>>2]|0;t=c[(c[m>>2]|0)+8>>2]|0;if(c[(c[o>>2]|0)+12>>2]|0){c[q>>2]=Nm(u,t,c[(c[o>>2]|0)+12>>2]|0,80392)|0;if(c[q>>2]|0)break;if(!(c[(c[l>>2]|0)+48>>2]|0))break;c[q>>2]=Nm(c[(c[l>>2]|0)+48>>2]|0,c[(c[m>>2]|0)+8>>2]|0,c[(c[o>>2]|0)+12>>2]|0,80392)|0;break}else{c[q>>2]=Fm(u,t,80392)|0;if(c[q>>2]|0)break;if(!(c[(c[l>>2]|0)+48>>2]|0))break;c[q>>2]=Fm(c[(c[l>>2]|0)+48>>2]|0,c[(c[m>>2]|0)+8>>2]|0,80392)|0;break}}while(0);if(!(c[q>>2]|0)){t=c[k>>2]|0;u=c[m>>2]|0;if(c[(c[o>>2]|0)+12>>2]|0)jn(t,u,533,82240,c[(c[o>>2]|0)+12>>2]|0,c[(c[m>>2]|0)+8>>2]|0,0);else jn(t,u,533,82296,c[(c[m>>2]|0)+8>>2]|0,0,0);c[j>>2]=0;y=c[j>>2]|0;i=h;return y|0}c[r>>2]=qn(c[l>>2]|0,c[(c[q>>2]|0)+40>>2]|0,c[p>>2]|0)|0;if(!(c[r>>2]|0)){r=c[k>>2]|0;u=c[m>>2]|0;if(c[(c[o>>2]|0)+12>>2]|0)jn(r,u,516,82352,c[(c[o>>2]|0)+12>>2]|0,c[(c[m>>2]|0)+8>>2]|0,0);else jn(r,u,516,82416,c[(c[m>>2]|0)+8>>2]|0,0,0);c[s>>2]=0}if((c[(c[q>>2]|0)+44>>2]|0)==4?(qy(c[p>>2]|0,c[(c[q>>2]|0)+48>>2]|0)|0)==0:0){u=c[k>>2]|0;r=c[m>>2]|0;if(c[(c[o>>2]|0)+12>>2]|0)jn(u,r,500,82472,c[(c[o>>2]|0)+12>>2]|0,c[(c[m>>2]|0)+8>>2]|0,c[(c[q>>2]|0)+48>>2]|0);else jn(u,r,500,82544,c[(c[m>>2]|0)+8>>2]|0,c[(c[q>>2]|0)+48>>2]|0,0);c[s>>2]=0}if((c[(c[q>>2]|0)+40>>2]|0)==2?(Cm(c[k>>2]|0,c[l>>2]|0,c[p>>2]|0,c[o>>2]|0)|0)==0:0)c[s>>2]=0;if(!((c[(c[q>>2]|0)+40>>2]|0)!=3?(c[(c[q>>2]|0)+40>>2]|0)!=4:0))z=54;if((z|0)==54?(Im(c[k>>2]|0,c[l>>2]|0,c[p>>2]|0,c[o>>2]|0)|0)==0:0)c[s>>2]=0;if((c[(c[q>>2]|0)+40>>2]|0)==10){c[v>>2]=c[(c[q>>2]|0)+52>>2];c[w>>2]=Om(c[(c[l>>2]|0)+44>>2]|0,c[p>>2]|0)|0;if(!(c[w>>2]|0))c[w>>2]=Om(c[(c[l>>2]|0)+48>>2]|0,c[p>>2]|0)|0;if(!(c[w>>2]|0)){w=c[k>>2]|0;z=c[m>>2]|0;r=c[p>>2]|0;if(c[(c[o>>2]|0)+12>>2]|0)jn(w,z,537,82608,r,c[(c[o>>2]|0)+12>>2]|0,c[(c[m>>2]|0)+8>>2]|0);else jn(w,z,537,82680,r,c[(c[m>>2]|0)+8>>2]|0,0);c[s>>2]=0}while(1){if(!(c[v>>2]|0))break;if(qy(c[(c[v>>2]|0)+4>>2]|0,c[p>>2]|0)|0)break;c[v>>2]=c[c[v>>2]>>2]}if(!(c[v>>2]|0)){v=c[k>>2]|0;r=c[m>>2]|0;z=c[p>>2]|0;if(c[(c[o>>2]|0)+12>>2]|0)jn(v,r,527,82752,z,c[(c[o>>2]|0)+12>>2]|0,c[(c[m>>2]|0)+8>>2]|0);else jn(v,r,527,82832,z,c[(c[m>>2]|0)+8>>2]|0,0);c[s>>2]=0}}if((c[(c[q>>2]|0)+40>>2]|0)==9){c[x>>2]=c[(c[q>>2]|0)+52>>2];while(1){if(!(c[x>>2]|0))break;if(qy(c[(c[x>>2]|0)+4>>2]|0,c[p>>2]|0)|0)break;c[x>>2]=c[c[x>>2]>>2]}if(!(c[x>>2]|0)){x=c[k>>2]|0;z=c[m>>2]|0;r=c[p>>2]|0;if(c[(c[o>>2]|0)+12>>2]|0)jn(x,z,502,82912,r,c[(c[o>>2]|0)+12>>2]|0,c[(c[m>>2]|0)+8>>2]|0);else jn(x,z,502,82992,r,c[(c[m>>2]|0)+8>>2]|0,0);c[s>>2]=0}}if((c[(c[q>>2]|0)+44>>2]|0)==4?(qy(c[(c[q>>2]|0)+48>>2]|0,c[p>>2]|0)|0)==0:0){r=c[k>>2]|0;z=c[m>>2]|0;if(c[(c[o>>2]|0)+12>>2]|0)jn(r,z,508,83064,c[(c[o>>2]|0)+12>>2]|0,c[(c[m>>2]|0)+8>>2]|0,c[(c[q>>2]|0)+48>>2]|0);else jn(r,z,508,83120,c[(c[m>>2]|0)+8>>2]|0,c[(c[q>>2]|0)+48>>2]|0,0);c[s>>2]=0}m=c[k>>2]|0;k=c[l>>2]|0;if(c[(c[o>>2]|0)+12>>2]|0){l=Kn(m,k,c[(c[o>>2]|0)+12>>2]|0,c[(c[q>>2]|0)+40>>2]|0,c[p>>2]|0)|0;c[s>>2]=c[s>>2]&l}else{l=Kn(m,k,80392,c[(c[q>>2]|0)+40>>2]|0,c[p>>2]|0)|0;c[s>>2]=c[s>>2]&l}c[j>>2]=c[s>>2];y=c[j>>2]|0;i=h;return y|0}c[j>>2]=0;y=c[j>>2]|0;i=h;return y|0}c[j>>2]=0;y=c[j>>2]|0;i=h;return y|0}function Ym(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+48|0;g=f+36|0;h=f+32|0;j=f+28|0;k=f+24|0;l=f+20|0;m=f+16|0;n=f+12|0;o=f+8|0;p=f+4|0;q=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=1;c[o>>2]=0;if(!(c[h>>2]|0)){c[g>>2]=0;r=c[g>>2]|0;i=f;return r|0}do if(((c[(c[h>>2]|0)+44>>2]|0)>0?(c[(c[h>>2]|0)+40>>2]|0)!=0:0)?(c[p>>2]=c[(c[h>>2]|0)+40>>2],(c[c[p>>2]>>2]|0)!=0):0){c[q>>2]=c[c[p>>2]>>2];e=c[(c[q>>2]|0)+36>>2]|0;if((e|0)==4){if(!(c[(c[p>>2]|0)+8>>2]|0))break;c[m>>2]=qz(c[(c[p>>2]|0)+8>>2]|0,c[l>>2]|0,0)|0;if((c[m>>2]|0)<0){jn(c[h>>2]|0,c[(c[p>>2]|0)+4>>2]|0,504,83352,c[(c[(c[p>>2]|0)+4>>2]|0)+8>>2]|0,c[l>>2]|0,0);c[m>>2]=0;break}else{c[m>>2]=1;break}}else if((e|0)==1){jn(c[h>>2]|0,c[(c[p>>2]|0)+4>>2]|0,528,83168,c[(c[(c[p>>2]|0)+4>>2]|0)+8>>2]|0,0,0);c[m>>2]=0;break}else if((e|0)==3){if((c[(c[q>>2]|0)+40>>2]|0)!=0?(c[c[(c[q>>2]|0)+40>>2]>>2]|0)==1:0){jn(c[h>>2]|0,c[(c[p>>2]|0)+4>>2]|0,529,83224,c[(c[(c[p>>2]|0)+4>>2]|0)+8>>2]|0,0,0);c[m>>2]=0;break}c[m>>2]=Ln(c[h>>2]|0,c[(c[q>>2]|0)+40>>2]|0,c[l>>2]|0)|0;if((c[m>>2]|0)==1)break;jn(c[h>>2]|0,c[(c[p>>2]|0)+4>>2]|0,515,83288,c[l>>2]|0,c[(c[(c[p>>2]|0)+4>>2]|0)+8>>2]|0,0);break}else if(!e){c[m>>2]=0;break}else break}while(0);c[n>>2]=Mn(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,o)|0;Nn(c[h>>2]|0,c[n>>2]|0,c[k>>2]|0)|0;c[g>>2]=c[m>>2];r=c[g>>2]|0;i=f;return r|0}function Zm(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f+28|0;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f+4|0;o=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=e;c[l>>2]=1;if(!(c[h>>2]|0)){c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}if((c[k>>2]|0)<=0){c[g>>2]=c[l>>2];p=c[g>>2]|0;i=f;return p|0}a:do if(((c[(c[h>>2]|0)+44>>2]|0)>0?(c[(c[h>>2]|0)+40>>2]|0)!=0:0)?(c[m>>2]=c[(c[h>>2]|0)+40>>2],(c[c[m>>2]>>2]|0)!=0):0){c[n>>2]=c[c[m>>2]>>2];e=c[(c[n>>2]|0)+36>>2]|0;if((e|0)==1){jn(c[h>>2]|0,c[(c[m>>2]|0)+4>>2]|0,528,83168,c[(c[(c[m>>2]|0)+4>>2]|0)+8>>2]|0,0,0);c[l>>2]=0;break}else if(!e){c[l>>2]=0;break}else if((e|0)==4){if((c[k>>2]|0)<=0)break;c[o>>2]=0;b:while(1){if((c[o>>2]|0)>=(c[k>>2]|0))break a;do if((d[(c[j>>2]|0)+(c[o>>2]|0)>>0]|0|0)!=32){if(9<=(d[(c[j>>2]|0)+(c[o>>2]|0)>>0]|0|0)?(d[(c[j>>2]|0)+(c[o>>2]|0)>>0]|0|0)<=10:0)break;if((d[(c[j>>2]|0)+(c[o>>2]|0)>>0]|0|0)!=13)break b}while(0);c[o>>2]=(c[o>>2]|0)+1}jn(c[h>>2]|0,c[(c[m>>2]|0)+4>>2]|0,504,83416,c[(c[(c[m>>2]|0)+4>>2]|0)+8>>2]|0,0,0);c[l>>2]=0;break}else break}while(0);c[g>>2]=c[l>>2];p=c[g>>2]|0;i=f;return p|0}function _m(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+28|0;h=f+24|0;j=f+8|0;k=f+4|0;l=f;c[h>>2]=a;c[f+20>>2]=b;c[f+16>>2]=d;c[f+12>>2]=e;c[j>>2]=1;if(!(c[h>>2]|0)){c[g>>2]=0;m=c[g>>2]|0;i=f;return m|0}if((c[(c[h>>2]|0)+44>>2]|0)>0?(c[(c[h>>2]|0)+40>>2]|0)!=0:0){c[k>>2]=c[(c[h>>2]|0)+40>>2];do if(((c[c[k>>2]>>2]|0)!=0?(c[l>>2]=c[c[k>>2]>>2],(c[(c[l>>2]|0)+36>>2]|0)==4):0)?(c[(c[k>>2]|0)+8>>2]|0)!=0:0){c[j>>2]=qz(c[(c[k>>2]|0)+8>>2]|0,0,0)|0;if(!(c[j>>2]|0)){jn(c[h>>2]|0,c[(c[k>>2]|0)+4>>2]|0,504,83480,c[(c[(c[k>>2]|0)+4>>2]|0)+8>>2]|0,0,0);break}else{c[j>>2]=1;break}}while(0);On(c[h>>2]|0)|0}c[g>>2]=c[j>>2];m=c[g>>2]|0;i=f;return m|0}function $m(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;i=i+144|0;g=f+80|0;h=f+76|0;j=f+72|0;k=f+68|0;l=f+64|0;m=f+60|0;n=f+56|0;o=f+52|0;p=f+48|0;q=f+44|0;r=f+40|0;s=f+36|0;t=f+84|0;u=f+32|0;v=f+28|0;w=f+24|0;x=f+20|0;y=f+16|0;z=f+12|0;A=f+8|0;B=f+4|0;C=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=e;c[l>>2]=0;c[p>>2]=1;c[s>>2]=0;if(!(c[j>>2]|0)){c[g>>2]=0;D=c[g>>2]|0;i=f;return D|0}if((c[(c[j>>2]|0)+44>>2]|0)==0?(c[(c[j>>2]|0)+48>>2]|0)==0:0){c[g>>2]=0;D=c[g>>2]|0;i=f;return D|0}if(!(c[k>>2]|0)){c[g>>2]=0;D=c[g>>2]|0;i=f;return D|0}do switch(c[(c[k>>2]|0)+4>>2]|0){case 8:case 7:case 5:case 4:{c[g>>2]=1;D=c[g>>2]|0;i=f;return D|0}case 6:{jn(c[h>>2]|0,c[k>>2]|0,1,83680,0,0,0);c[g>>2]=0;D=c[g>>2]|0;i=f;return D|0}case 11:case 10:case 9:{jn(c[h>>2]|0,c[k>>2]|0,1,83744,0,0,0);c[g>>2]=0;D=c[g>>2]|0;i=f;return D|0}case 20:case 19:{c[g>>2]=1;D=c[g>>2]|0;i=f;return D|0}case 1:{c[l>>2]=Mn(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,s)|0;if(!(c[l>>2]|0)){c[g>>2]=0;D=c[g>>2]|0;i=f;return D|0}a:do if(!(c[(c[h>>2]|0)+44>>2]|0)){e=c[(c[l>>2]|0)+36>>2]|0;if(!e){jn(c[h>>2]|0,c[k>>2]|0,534,83832,c[(c[k>>2]|0)+8>>2]|0,0,0);c[g>>2]=0;D=c[g>>2]|0;i=f;return D|0}else if((e|0)==4){b:do if((c[s>>2]|0)==1?(c[(c[j>>2]|0)+40>>2]|0)==1:0){c[o>>2]=c[(c[k>>2]|0)+12>>2];while(1){if(!(c[o>>2]|0))break b;if((c[(c[o>>2]|0)+4>>2]|0)==3){c[v>>2]=c[(c[o>>2]|0)+40>>2];while(1){do if((d[c[v>>2]>>0]|0|0)==32)E=1;else{if(9<=(d[c[v>>2]>>0]|0|0)?(d[c[v>>2]>>0]|0|0)<=10:0){E=1;break}E=(d[c[v>>2]>>0]|0|0)==13}while(0);F=c[v>>2]|0;if(!E)break;c[v>>2]=F+1}if(!(d[F>>0]|0))break}c[o>>2]=c[(c[o>>2]|0)+24>>2]}jn(c[h>>2]|0,c[k>>2]|0,532,83904,c[(c[k>>2]|0)+8>>2]|0,0,0);c[p>>2]=0}while(0);c[o>>2]=c[(c[k>>2]|0)+12>>2];c[m>>2]=c[(c[l>>2]|0)+40>>2];c[q>>2]=Qn(c[h>>2]|0,c[o>>2]|0,c[l>>2]|0,1,c[k>>2]|0)|0;if((c[q>>2]|0)>0)break;c[p>>2]=c[q>>2];break}else if((e|0)==3){if((c[(c[l>>2]|0)+40>>2]|0)!=0?(c[c[(c[l>>2]|0)+40>>2]>>2]|0)==1:0){c[p>>2]=Pn(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0)|0;if(c[p>>2]|0)break;jn(c[h>>2]|0,c[k>>2]|0,529,83224,c[(c[k>>2]|0)+8>>2]|0,0,0);break}c[o>>2]=c[(c[k>>2]|0)+12>>2];c:while(1){if(!(c[o>>2]|0))break a;do if((c[(c[o>>2]|0)+4>>2]|0)==1){c[r>>2]=c[(c[o>>2]|0)+8>>2];if((c[(c[o>>2]|0)+36>>2]|0)!=0?(c[(c[(c[o>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){c[u>>2]=Bh(c[(c[o>>2]|0)+8>>2]|0,c[(c[(c[o>>2]|0)+36>>2]|0)+12>>2]|0,t,50)|0;if(!(c[u>>2]|0))break c;c[m>>2]=c[(c[l>>2]|0)+40>>2];d:while(1){if(!(c[m>>2]|0))break;b=c[m>>2]|0;e:do if((c[c[m>>2]>>2]|0)==2){if(qy(c[b+8>>2]|0,c[u>>2]|0)|0)break d}else{do if((c[b>>2]|0)==4){if(!(c[(c[m>>2]|0)+12>>2]|0))break;if((c[c[(c[m>>2]|0)+12>>2]>>2]|0)!=2)break;if(qy(c[(c[(c[m>>2]|0)+12>>2]|0)+8>>2]|0,c[u>>2]|0)|0)break d;else break e}while(0);if((c[c[m>>2]>>2]|0)!=4){G=53;break d}if(!(c[(c[m>>2]|0)+12>>2]|0)){G=53;break d}if((c[c[(c[m>>2]|0)+12>>2]>>2]|0)!=1){G=53;break d}}while(0);c[m>>2]=c[(c[m>>2]|0)+16>>2]}if((G|0)==53){G=0;mn(0,519,83864,0)}if((c[u>>2]|0)!=(t|0)?(c[u>>2]|0)!=(c[(c[o>>2]|0)+8>>2]|0):0)zb[c[135736>>2]&511](c[u>>2]|0);if(c[m>>2]|0)break}c[m>>2]=c[(c[l>>2]|0)+40>>2];f:while(1){if(!(c[m>>2]|0))break;b=c[m>>2]|0;g:do if((c[c[m>>2]>>2]|0)==2){if(qy(c[b+8>>2]|0,c[r>>2]|0)|0)break f}else{do if((c[b>>2]|0)==4){if(!(c[(c[m>>2]|0)+12>>2]|0))break;if((c[c[(c[m>>2]|0)+12>>2]>>2]|0)!=2)break;if(qy(c[(c[(c[m>>2]|0)+12>>2]|0)+8>>2]|0,c[r>>2]|0)|0)break f;else break g}while(0);if((c[c[m>>2]>>2]|0)!=4){G=70;break f}if(!(c[(c[m>>2]|0)+12>>2]|0)){G=70;break f}if((c[c[(c[m>>2]|0)+12>>2]>>2]|0)!=1){G=70;break f}}while(0);c[m>>2]=c[(c[m>>2]|0)+16>>2]}if((G|0)==70){G=0;mn(c[h>>2]|0,519,83864,0)}if(!(c[m>>2]|0)){jn(c[h>>2]|0,c[k>>2]|0,515,83288,c[r>>2]|0,c[(c[k>>2]|0)+8>>2]|0,0);c[p>>2]=0}}while(0);c[o>>2]=c[(c[o>>2]|0)+24>>2]}c[g>>2]=0;D=c[g>>2]|0;i=f;return D|0}else if((e|0)==1){if(!(c[(c[k>>2]|0)+12>>2]|0))break;jn(c[h>>2]|0,c[k>>2]|0,528,83168,c[(c[k>>2]|0)+8>>2]|0,0,0);c[p>>2]=0;break}else break}while(0);c[n>>2]=c[(c[l>>2]|0)+44>>2];while(1){if(!(c[n>>2]|0))break;h:do if((c[(c[n>>2]|0)+44>>2]|0)==2){c[w>>2]=-1;i:do if((c[(c[n>>2]|0)+56>>2]|0)==0?(qy(c[(c[n>>2]|0)+8>>2]|0,80392)|0)!=0:0){c[x>>2]=c[(c[k>>2]|0)+48>>2];while(1){if(!(c[x>>2]|0))break i;if(!(c[(c[x>>2]|0)+12>>2]|0))break h;c[x>>2]=c[c[x>>2]>>2]}}else G=100;while(0);j:do if((G|0)==100){G=0;b=(qy(c[(c[n>>2]|0)+56>>2]|0,80392)|0)!=0;a=c[k>>2]|0;if(b){c[y>>2]=c[a+48>>2];while(1){if(!(c[y>>2]|0))break j;if(qy(c[(c[n>>2]|0)+8>>2]|0,c[(c[y>>2]|0)+12>>2]|0)|0)break h;c[y>>2]=c[c[y>>2]>>2]}}c[z>>2]=c[a+44>>2];while(1){if(!(c[z>>2]|0))break j;do if(qy(c[(c[z>>2]|0)+8>>2]|0,c[(c[n>>2]|0)+8>>2]|0)|0){if(!(c[(c[n>>2]|0)+56>>2]|0))break h;c[A>>2]=c[(c[z>>2]|0)+36>>2];if(!(c[A>>2]|0))c[A>>2]=c[(c[k>>2]|0)+36>>2];if(!(c[A>>2]|0)){if((c[w>>2]|0)>=0)break;c[w>>2]=0;break}if(qy(c[(c[A>>2]|0)+12>>2]|0,c[(c[n>>2]|0)+56>>2]|0)|0)break h;if((c[w>>2]|0)>=1)break;c[w>>2]=1}while(0);c[z>>2]=c[(c[z>>2]|0)+24>>2]}}while(0);if((c[w>>2]|0)==-1){a=c[h>>2]|0;b=c[k>>2]|0;H=c[(c[k>>2]|0)+8>>2]|0;I=c[n>>2]|0;if(!(c[(c[n>>2]|0)+56>>2]|0)){jn(a,b,518,83984,H,c[I+8>>2]|0,0);c[p>>2]=0;break}else{jn(a,b,518,84024,H,c[I+56>>2]|0,c[(c[n>>2]|0)+8>>2]|0);c[p>>2]=0;break}}if(!(c[w>>2]|0)){rn(c[h>>2]|0,c[k>>2]|0,524,84072,c[(c[k>>2]|0)+8>>2]|0,c[(c[n>>2]|0)+56>>2]|0,c[(c[n>>2]|0)+8>>2]|0);break}if((c[w>>2]|0)==1)rn(c[h>>2]|0,c[k>>2]|0,506,84128,c[(c[k>>2]|0)+8>>2]|0,c[(c[n>>2]|0)+56>>2]|0,c[(c[n>>2]|0)+8>>2]|0)}else if((c[(c[n>>2]|0)+44>>2]|0)==4){if((c[(c[n>>2]|0)+56>>2]|0)==0?(qy(c[(c[n>>2]|0)+8>>2]|0,80392)|0)!=0:0){c[B>>2]=c[(c[k>>2]|0)+48>>2];while(1){if(!(c[B>>2]|0))break h;if(!(c[(c[B>>2]|0)+12>>2]|0))break;c[B>>2]=c[c[B>>2]>>2]}if(qy(c[(c[n>>2]|0)+48>>2]|0,c[(c[B>>2]|0)+8>>2]|0)|0)break;jn(c[h>>2]|0,c[k>>2]|0,507,84192,c[(c[k>>2]|0)+8>>2]|0,0,0);c[p>>2]=0;break}if(qy(c[(c[n>>2]|0)+56>>2]|0,80392)|0){c[C>>2]=c[(c[k>>2]|0)+48>>2];while(1){if(!(c[C>>2]|0))break h;if(qy(c[(c[n>>2]|0)+8>>2]|0,c[(c[C>>2]|0)+12>>2]|0)|0)break;c[C>>2]=c[c[C>>2]>>2]}if(!(qy(c[(c[n>>2]|0)+48>>2]|0,c[(c[C>>2]|0)+8>>2]|0)|0)){jn(c[h>>2]|0,c[k>>2]|0,508,84264,c[(c[k>>2]|0)+8>>2]|0,c[(c[C>>2]|0)+12>>2]|0,0);c[p>>2]=0}}}while(0);c[n>>2]=c[(c[n>>2]|0)+36>>2]}c[g>>2]=c[p>>2];D=c[g>>2]|0;i=f;return D|0}case 3:{if(c[(c[k>>2]|0)+12>>2]|0){jn(c[h>>2]|0,c[k>>2]|0,1,83584,0,0,0);c[g>>2]=0;D=c[g>>2]|0;i=f;return D|0}if(c[(c[k>>2]|0)+36>>2]|0){jn(c[h>>2]|0,c[k>>2]|0,1,83616,0,0,0);c[g>>2]=0;D=c[g>>2]|0;i=f;return D|0}if(!(c[(c[k>>2]|0)+40>>2]|0)){jn(c[h>>2]|0,c[k>>2]|0,1,83648,0,0,0);c[g>>2]=0;D=c[g>>2]|0;i=f;return D|0}else{c[g>>2]=1;D=c[g>>2]|0;i=f;return D|0}break}case 2:{jn(c[h>>2]|0,c[k>>2]|0,1,83552,0,0,0);c[g>>2]=0;D=c[g>>2]|0;i=f;return D|0}case 13:{jn(c[h>>2]|0,c[k>>2]|0,1,83776,0,0,0);c[g>>2]=0;D=c[g>>2]|0;i=f;return D|0}case 12:{jn(c[h>>2]|0,c[k>>2]|0,1,83712,0,0,0);c[g>>2]=0;D=c[g>>2]|0;i=f;return D|0}default:{jn(c[h>>2]|0,c[k>>2]|0,1,83808,0,0,0);c[g>>2]=0;D=c[g>>2]|0;i=f;return D|0}}while(0);return 0}function an(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+80|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d+24|0;l=d;c[f>>2]=a;c[g>>2]=b;if(!(c[g>>2]|0)){c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}c[h>>2]=Pi(c[g>>2]|0)|0;if((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+8>>2]|0)!=0:0){do if(((c[(c[g>>2]|0)+44>>2]|0)!=0?(c[(c[(c[g>>2]|0)+44>>2]|0)+8>>2]|0)!=0:0)?(qy(c[(c[(c[g>>2]|0)+44>>2]|0)+8>>2]|0,c[(c[h>>2]|0)+8>>2]|0)|0)==0:0){if((c[(c[h>>2]|0)+36>>2]|0)!=0?(c[(c[(c[h>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){c[l>>2]=Bh(c[(c[h>>2]|0)+8>>2]|0,c[(c[(c[h>>2]|0)+36>>2]|0)+12>>2]|0,k,50)|0;if(!(c[l>>2]|0)){ln(c[f>>2]|0,0);c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}c[j>>2]=qy(c[(c[(c[g>>2]|0)+44>>2]|0)+8>>2]|0,c[l>>2]|0)|0;if((c[l>>2]|0)!=(k|0)?(c[l>>2]|0)!=(c[(c[h>>2]|0)+8>>2]|0):0)zb[c[135736>>2]&511](c[l>>2]|0);if((c[j>>2]|0)==1)break}if((qy(c[(c[(c[g>>2]|0)+44>>2]|0)+8>>2]|0,84352)|0)!=0?(qy(c[(c[h>>2]|0)+8>>2]|0,84360)|0)!=0:0)break;jn(c[f>>2]|0,c[h>>2]|0,531,84368,c[(c[h>>2]|0)+8>>2]|0,c[(c[(c[g>>2]|0)+44>>2]|0)+8>>2]|0,0);c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}while(0);c[e>>2]=1;m=c[e>>2]|0;i=d;return m|0}mn(c[f>>2]|0,525,84328,0);c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}function bn(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+48|0;f=e+32|0;g=e+28|0;h=e+24|0;j=e+20|0;k=e+16|0;l=e+12|0;m=e+8|0;n=e+4|0;o=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[o>>2]=1;if(!(c[j>>2]|0)){c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}if(((c[(c[j>>2]|0)+4>>2]|0)!=19?(c[(c[j>>2]|0)+4>>2]|0)!=20:0)?(c[(c[j>>2]|0)+4>>2]|0)!=18:0){if(!(c[h>>2]|0)){c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}if((c[(c[h>>2]|0)+44>>2]|0)==0?(c[(c[h>>2]|0)+48>>2]|0)==0:0){c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}if((c[(c[j>>2]|0)+4>>2]|0)==5){c[f>>2]=1;p=c[f>>2]|0;i=e;return p|0}d=$m(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;c[o>>2]=c[o>>2]&d;a:do if((c[(c[j>>2]|0)+4>>2]|0)==1){c[l>>2]=c[(c[j>>2]|0)+44>>2];while(1){if(!(c[l>>2]|0))break;c[n>>2]=_h(c[h>>2]|0,c[(c[l>>2]|0)+12>>2]|0,0)|0;d=Wm(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0,c[l>>2]|0,c[n>>2]|0)|0;c[o>>2]=c[o>>2]&d;if(c[n>>2]|0)zb[c[135736>>2]&511](c[n>>2]|0);c[l>>2]=c[(c[l>>2]|0)+24>>2]}c[m>>2]=c[(c[j>>2]|0)+48>>2];while(1){if(!(c[m>>2]|0))break a;d=c[g>>2]|0;b=c[h>>2]|0;a=c[j>>2]|0;if(!(c[(c[j>>2]|0)+36>>2]|0)){q=Xm(d,b,a,0,c[m>>2]|0,c[(c[m>>2]|0)+8>>2]|0)|0;c[o>>2]=c[o>>2]&q}else{q=Xm(d,b,a,c[(c[(c[j>>2]|0)+36>>2]|0)+12>>2]|0,c[m>>2]|0,c[(c[m>>2]|0)+8>>2]|0)|0;c[o>>2]=c[o>>2]&q}c[m>>2]=c[c[m>>2]>>2]}}while(0);c[k>>2]=c[(c[j>>2]|0)+12>>2];while(1){if(!(c[k>>2]|0))break;j=bn(c[g>>2]|0,c[h>>2]|0,c[k>>2]|0)|0;c[o>>2]=c[o>>2]&j;c[k>>2]=c[(c[k>>2]|0)+24>>2]}c[f>>2]=c[o>>2];p=c[f>>2]|0;i=e;return p|0}c[f>>2]=1;p=c[f>>2]|0;i=e;return p|0}function cn(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[f>>2]=a;c[g>>2]=b;if(!(c[f>>2]|0)){c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}b=c[f>>2]|0;if(!(c[g>>2]|0)){mn(b,521,84416,0);c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}else{c[j>>2]=c[b+28>>2];c[(c[f>>2]|0)+28>>2]=0;c[h>>2]=c[(c[g>>2]|0)+68>>2];c[(c[f>>2]|0)+32>>2]=c[g>>2];c[(c[f>>2]|0)+36>>2]=1;Wj(c[h>>2]|0,254,c[f>>2]|0);c[(c[f>>2]|0)+28>>2]=c[j>>2];c[e>>2]=c[(c[f>>2]|0)+36>>2];k=c[e>>2]|0;i=d;return k|0}return 0}function dn(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;n=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(!(c[j>>2]|0)){c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}if(!(c[h>>2]|0)){c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}c[l>>2]=c[(c[h>>2]|0)+48>>2];c[m>>2]=c[(c[h>>2]|0)+44>>2];c[(c[h>>2]|0)+48>>2]=c[j>>2];c[(c[h>>2]|0)+44>>2]=0;c[k>>2]=an(c[g>>2]|0,c[h>>2]|0)|0;if(!(c[k>>2]|0)){c[(c[h>>2]|0)+48>>2]=c[l>>2];c[(c[h>>2]|0)+44>>2]=c[m>>2];c[f>>2]=c[k>>2];o=c[f>>2]|0;i=e;return o|0}if(c[(c[h>>2]|0)+64>>2]|0){Dm(c[(c[h>>2]|0)+64>>2]|0);c[(c[h>>2]|0)+64>>2]=0}if(c[(c[h>>2]|0)+68>>2]|0){Jm(c[(c[h>>2]|0)+68>>2]|0);c[(c[h>>2]|0)+68>>2]=0}c[n>>2]=Pi(c[h>>2]|0)|0;c[k>>2]=bn(c[g>>2]|0,c[h>>2]|0,c[n>>2]|0)|0;n=cn(c[g>>2]|0,c[h>>2]|0)|0;c[k>>2]=c[k>>2]&n;c[(c[h>>2]|0)+48>>2]=c[l>>2];c[(c[h>>2]|0)+44>>2]=c[m>>2];c[f>>2]=c[k>>2];o=c[f>>2]|0;i=e;return o|0}function en(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;if((c[g>>2]|0)==0|(c[f>>2]|0)==0){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}if((c[(c[g>>2]|0)+44>>2]|0)==0?(c[(c[g>>2]|0)+48>>2]|0)==0:0){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}c[(c[f>>2]|0)+32>>2]=c[g>>2];c[(c[f>>2]|0)+36>>2]=1;c[h>>2]=c[(c[g>>2]|0)+44>>2];if((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+44>>2]|0)!=0:0){c[j>>2]=c[(c[h>>2]|0)+44>>2];Wj(c[j>>2]|0,255,c[f>>2]|0)}if((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+48>>2]|0)!=0:0){c[k>>2]=c[(c[h>>2]|0)+48>>2];Wj(c[k>>2]|0,256,c[f>>2]|0)}c[h>>2]=c[(c[g>>2]|0)+48>>2];if((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+44>>2]|0)!=0:0){c[j>>2]=c[(c[h>>2]|0)+44>>2];Wj(c[j>>2]|0,255,c[f>>2]|0)}if((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+48>>2]|0)!=0:0){c[k>>2]=c[(c[h>>2]|0)+48>>2];Wj(c[k>>2]|0,256,c[f>>2]|0)}c[e>>2]=c[(c[f>>2]|0)+36>>2];l=c[e>>2]|0;i=d;return l|0}function fn(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;if(!(c[g>>2]|0)){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}if((c[(c[g>>2]|0)+44>>2]|0)==0?(c[(c[g>>2]|0)+48>>2]|0)==0:0){mn(c[f>>2]|0,522,84456,0);c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}do if(c[(c[g>>2]|0)+44>>2]|0){if((c[(c[(c[g>>2]|0)+44>>2]|0)+56>>2]|0)==0?(c[(c[(c[g>>2]|0)+44>>2]|0)+52>>2]|0)==0:0)break;if(!(c[(c[g>>2]|0)+48>>2]|0)){if(c[(c[(c[g>>2]|0)+44>>2]|0)+56>>2]|0){c[k>>2]=Hl(c[(c[(c[g>>2]|0)+44>>2]|0)+56>>2]|0,c[(c[g>>2]|0)+72>>2]|0)|0;if(!(c[k>>2]|0)){mn(c[f>>2]|0,517,84472,c[(c[(c[g>>2]|0)+44>>2]|0)+56>>2]|0);c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}}else c[k>>2]=0;b=Wf(c[(c[(c[g>>2]|0)+44>>2]|0)+52>>2]|0,c[k>>2]|0)|0;c[(c[g>>2]|0)+48>>2]=b;if(c[k>>2]|0)zb[c[135736>>2]&511](c[k>>2]|0);if(!(c[(c[g>>2]|0)+48>>2]|0)){b=c[f>>2]|0;a=c[(c[g>>2]|0)+44>>2]|0;if(c[(c[(c[g>>2]|0)+44>>2]|0)+56>>2]|0)mn(b,517,84520,c[a+56>>2]|0);else mn(b,517,84520,c[a+52>>2]|0);c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}}}while(0);if(c[(c[g>>2]|0)+64>>2]|0){Dm(c[(c[g>>2]|0)+64>>2]|0);c[(c[g>>2]|0)+64>>2]=0}if(c[(c[g>>2]|0)+68>>2]|0){Jm(c[(c[g>>2]|0)+68>>2]|0);c[(c[g>>2]|0)+68>>2]=0}c[h>>2]=en(c[f>>2]|0,c[g>>2]|0)|0;if(an(c[f>>2]|0,c[g>>2]|0)|0){c[j>>2]=Pi(c[g>>2]|0)|0;k=bn(c[f>>2]|0,c[g>>2]|0,c[j>>2]|0)|0;c[h>>2]=c[h>>2]&k;k=cn(c[f>>2]|0,c[g>>2]|0)|0;c[h>>2]=c[h>>2]&k;c[e>>2]=c[h>>2];l=c[e>>2]|0;i=d;return l|0}else{c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}return 0}function gn(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if((c[h>>2]|0)==0|(c[j>>2]|0)==0|(c[k>>2]|0)==0){c[g>>2]=-1;n=c[g>>2]|0;i=f;return n|0}if((c[c[k>>2]>>2]|0)>=(c[l>>2]|0)){c[g>>2]=c[c[k>>2]>>2];n=c[g>>2]|0;i=f;return n|0}e=c[c[h>>2]>>2]|0;do if((e|0)==4){gn(c[(c[h>>2]|0)+12>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0)|0;gn(c[(c[h>>2]|0)+16>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0)|0}else if((e|0)==2){c[m>>2]=0;while(1){o=c[(c[h>>2]|0)+8>>2]|0;if((c[m>>2]|0)>=(c[c[k>>2]>>2]|0)){p=17;break}if(qy(o,c[(c[j>>2]|0)+(c[m>>2]<<2)>>2]|0)|0)break;c[m>>2]=(c[m>>2]|0)+1}if((p|0)==17){d=c[k>>2]|0;b=c[d>>2]|0;c[d>>2]=b+1;c[(c[j>>2]|0)+(b<<2)>>2]=o;break}c[g>>2]=c[c[k>>2]>>2];n=c[g>>2]|0;i=f;return n|0}else if((e|0)==1){c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[c[k>>2]>>2]|0)){p=11;break}if(qy(79640,c[(c[j>>2]|0)+(c[m>>2]<<2)>>2]|0)|0)break;c[m>>2]=(c[m>>2]|0)+1}if((p|0)==11){b=c[k>>2]|0;d=c[b>>2]|0;c[b>>2]=d+1;c[(c[j>>2]|0)+(d<<2)>>2]=79640;break}c[g>>2]=c[c[k>>2]>>2];n=c[g>>2]|0;i=f;return n|0}else if((e|0)==3){gn(c[(c[h>>2]|0)+12>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0)|0;gn(c[(c[h>>2]|0)+16>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0)|0}while(0);c[g>>2]=c[c[k>>2]>>2];n=c[g>>2]|0;i=f;return n|0}function hn(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;f=i;i=i+1168|0;g=f+1160|0;h=f+1156|0;j=f+1152|0;k=f+1148|0;l=f+1144|0;m=f+1080|0;n=f+1072|0;o=f+48|0;p=f+44|0;q=f+40|0;r=f+36|0;s=f+32|0;t=f+28|0;u=f+24|0;v=f+20|0;w=f+16|0;x=f+12|0;y=f+8|0;z=f+4|0;A=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[n>>2]=0;cU(o|0,0,1024)|0;c[p>>2]=0;
if((c[h>>2]|0)==0&(c[j>>2]|0)==0){c[g>>2]=-1;B=c[g>>2]|0;i=f;return B|0}if(!(c[k>>2]|0)){c[g>>2]=-1;B=c[g>>2]|0;i=f;return B|0}if((c[l>>2]|0)<=0){c[g>>2]=-1;B=c[g>>2]|0;i=f;return B|0}e=m+0|0;d=e+64|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(d|0));c[m+4>>2]=257;c[n>>2]=0;c[s>>2]=(c[h>>2]|0)!=0?c[h>>2]|0:c[j>>2]|0;c[t>>2]=c[(c[s>>2]|0)+20>>2];c[z>>2]=Lm(c[(c[(c[t>>2]|0)+32>>2]|0)+44>>2]|0,c[(c[t>>2]|0)+8>>2]|0)|0;if((c[z>>2]|0)==0?(c[(c[(c[t>>2]|0)+32>>2]|0)+48>>2]|0)!=0:0)c[z>>2]=Lm(c[(c[(c[t>>2]|0)+32>>2]|0)+48>>2]|0,c[(c[t>>2]|0)+8>>2]|0)|0;if(!(c[z>>2]|0)){c[g>>2]=-1;B=c[g>>2]|0;i=f;return B|0}if(c[h>>2]|0)C=c[(c[h>>2]|0)+24>>2]|0;else C=0;c[v>>2]=C;if(c[j>>2]|0)D=c[(c[j>>2]|0)+28>>2]|0;else D=0;c[w>>2]=D;c[x>>2]=c[(c[t>>2]|0)+12>>2];c[y>>2]=c[(c[t>>2]|0)+16>>2];c[u>>2]=ji(c[(c[s>>2]|0)+32>>2]|0,0,84568,0)|0;if(!(c[u>>2]|0)){c[g>>2]=-1;B=c[g>>2]|0;i=f;return B|0}c[(c[u>>2]|0)+20>>2]=c[t>>2];c[(c[u>>2]|0)+28>>2]=c[h>>2];c[(c[u>>2]|0)+24>>2]=c[j>>2];c[r>>2]=c[(c[u>>2]|0)+8>>2];s=c[u>>2]|0;if(c[h>>2]|0)c[(c[h>>2]|0)+24>>2]=s;else c[(c[t>>2]|0)+12>>2]=s;s=c[u>>2]|0;if(c[j>>2]|0)c[(c[j>>2]|0)+28>>2]=s;else c[(c[t>>2]|0)+16>>2]=s;c[p>>2]=gn(c[(c[z>>2]|0)+40>>2]|0,o,p,256)|0;c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[p>>2]|0))break;c[(c[u>>2]|0)+8>>2]=c[o+(c[q>>2]<<2)>>2];if($m(m,c[(c[t>>2]|0)+32>>2]|0,c[t>>2]|0)|0){c[A>>2]=0;while(1){if((c[A>>2]|0)>=(c[n>>2]|0))break;if(qy(c[o+(c[q>>2]<<2)>>2]|0,c[(c[k>>2]|0)+(c[A>>2]<<2)>>2]|0)|0)break;c[A>>2]=(c[A>>2]|0)+1}z=c[o+(c[q>>2]<<2)>>2]|0;s=c[n>>2]|0;c[n>>2]=s+1;c[(c[k>>2]|0)+(s<<2)>>2]=z;if((c[n>>2]|0)>=(c[l>>2]|0))break}c[q>>2]=(c[q>>2]|0)+1}if(c[h>>2]|0)c[(c[h>>2]|0)+24>>2]=c[v>>2];if(c[j>>2]|0)c[(c[j>>2]|0)+28>>2]=c[w>>2];c[(c[t>>2]|0)+12>>2]=c[x>>2];c[(c[t>>2]|0)+16>>2]=c[y>>2];c[(c[u>>2]|0)+8>>2]=c[r>>2];Rh(c[u>>2]|0);c[g>>2]=c[n>>2];B=c[g>>2]|0;i=f;return B|0}function jn(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=i;i=i+64|0;k=j;l=j+56|0;m=j+52|0;n=j+48|0;o=j+44|0;p=j+40|0;q=j+36|0;r=j+32|0;s=j+28|0;t=j+24|0;u=j+20|0;v=j+16|0;w=j+12|0;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;c[r>>2]=h;c[s>>2]=0;c[t>>2]=0;c[u>>2]=0;c[v>>2]=0;do if(c[l>>2]|0){c[t>>2]=c[(c[l>>2]|0)+4>>2];c[v>>2]=c[c[l>>2]>>2];if((c[(c[l>>2]|0)+28>>2]|0)!=-1412623820?(c[(c[l>>2]|0)+28>>2]|0)!=-1412623819:0)break;c[w>>2]=(c[l>>2]|0)-(c[c[l>>2]>>2]|0);if((c[w>>2]|0)>0&(c[w>>2]|0)<250)c[u>>2]=c[c[l>>2]>>2]}while(0);l=c[s>>2]|0;s=c[t>>2]|0;t=c[v>>2]|0;v=c[u>>2]|0;u=c[m>>2]|0;m=c[n>>2]|0;n=c[p>>2]|0;w=c[p>>2]|0;h=c[r>>2]|0;g=c[o>>2]|0;o=c[q>>2]|0;q=c[r>>2]|0;c[k>>2]=c[p>>2];c[k+4>>2]=o;c[k+8>>2]=q;Xd(l,s,t,v,u,23,m,2,0,0,n,w,h,0,0,g,k);i=j;return}function kn(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+112|0;f=e+44|0;g=e+40|0;h=e+36|0;j=e+32|0;k=e+28|0;l=e+48|0;m=e+24|0;n=e+20|0;o=e+16|0;p=e+12|0;q=e+8|0;r=e+4|0;s=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(!(c[g>>2]|0)){jn(c[h>>2]|0,0,1,85712,c[j>>2]|0,0,0);c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}d=c[c[g>>2]>>2]|0;do if((d|0)==2){c[k>>2]=c[(c[h>>2]|0)+60>>2];c[m>>2]=Bh(c[(c[g>>2]|0)+8>>2]|0,c[(c[g>>2]|0)+24>>2]|0,l,50)|0;if(!(c[m>>2]|0)){ln(c[h>>2]|0,85800);c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}b=c[(c[g>>2]|0)+4>>2]|0;if((b|0)==4){a=Dz(c[(c[h>>2]|0)+56>>2]|0,c[(c[h>>2]|0)+60>>2]|0,0,c[m>>2]|0,0)|0;c[(c[h>>2]|0)+60>>2]=a;Dz(c[(c[h>>2]|0)+56>>2]|0,c[(c[h>>2]|0)+60>>2]|0,c[(c[h>>2]|0)+60>>2]|0,c[m>>2]|0,0)|0}else if((b|0)==1){a=Dz(c[(c[h>>2]|0)+56>>2]|0,c[(c[h>>2]|0)+60>>2]|0,0,c[m>>2]|0,0)|0;c[(c[h>>2]|0)+60>>2]=a}else if((b|0)==2){a=Dz(c[(c[h>>2]|0)+56>>2]|0,c[(c[h>>2]|0)+60>>2]|0,0,c[m>>2]|0,0)|0;c[(c[h>>2]|0)+60>>2]=a;Jz(c[(c[h>>2]|0)+56>>2]|0,c[k>>2]|0,c[(c[h>>2]|0)+60>>2]|0)|0}else if((b|0)==3){b=Jz(c[(c[h>>2]|0)+56>>2]|0,c[(c[h>>2]|0)+60>>2]|0,0)|0;c[(c[h>>2]|0)+60>>2]=b;Dz(c[(c[h>>2]|0)+56>>2]|0,c[(c[h>>2]|0)+60>>2]|0,c[(c[h>>2]|0)+60>>2]|0,c[m>>2]|0,0)|0}if((c[m>>2]|0)!=(l|0)?(c[m>>2]|0)!=(c[(c[g>>2]|0)+8>>2]|0):0)zb[c[135736>>2]&511](c[m>>2]|0)}else if((d|0)==4){c[s>>2]=c[(c[g>>2]|0)+4>>2];if((c[s>>2]|0)==4|(c[s>>2]|0)==3){b=Jz(c[(c[h>>2]|0)+56>>2]|0,c[(c[h>>2]|0)+60>>2]|0,0)|0;c[(c[h>>2]|0)+60>>2]=b}c[q>>2]=c[(c[h>>2]|0)+60>>2];c[r>>2]=Iz(c[(c[h>>2]|0)+56>>2]|0)|0;do{c[(c[h>>2]|0)+60>>2]=c[q>>2];kn(c[(c[g>>2]|0)+12>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;Jz(c[(c[h>>2]|0)+56>>2]|0,c[(c[h>>2]|0)+60>>2]|0,c[r>>2]|0)|0;c[g>>2]=c[(c[g>>2]|0)+16>>2];if((c[c[g>>2]>>2]|0)!=4)break}while((c[(c[g>>2]|0)+4>>2]|0)==1);c[(c[h>>2]|0)+60>>2]=c[q>>2];kn(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;Jz(c[(c[h>>2]|0)+56>>2]|0,c[(c[h>>2]|0)+60>>2]|0,c[r>>2]|0)|0;b=Jz(c[(c[h>>2]|0)+56>>2]|0,c[r>>2]|0,0)|0;c[(c[h>>2]|0)+60>>2]=b;b=c[s>>2]|0;if((b|0)==3){Jz(c[(c[h>>2]|0)+56>>2]|0,c[q>>2]|0,c[(c[h>>2]|0)+60>>2]|0)|0;Jz(c[(c[h>>2]|0)+56>>2]|0,c[r>>2]|0,c[q>>2]|0)|0;break}else if((b|0)==4){Jz(c[(c[h>>2]|0)+56>>2]|0,c[r>>2]|0,c[q>>2]|0)|0;break}else if((b|0)==2){Jz(c[(c[h>>2]|0)+56>>2]|0,c[q>>2]|0,c[(c[h>>2]|0)+60>>2]|0)|0;break}else break}else if((d|0)==1){jn(c[h>>2]|0,0,1,85760,c[j>>2]|0,0,0);c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}else if((d|0)==3){c[n>>2]=c[(c[h>>2]|0)+60>>2];c[p>>2]=c[(c[g>>2]|0)+4>>2];if((c[p>>2]|0)!=1){b=Jz(c[(c[h>>2]|0)+56>>2]|0,c[n>>2]|0,0)|0;c[(c[h>>2]|0)+60>>2]=b;c[n>>2]=c[(c[h>>2]|0)+60>>2]}do{kn(c[(c[g>>2]|0)+12>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;c[g>>2]=c[(c[g>>2]|0)+16>>2];if((c[c[g>>2]>>2]|0)!=3)break}while((c[(c[g>>2]|0)+4>>2]|0)==1);kn(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;c[o>>2]=c[(c[h>>2]|0)+60>>2];b=Jz(c[(c[h>>2]|0)+56>>2]|0,c[o>>2]|0,0)|0;c[(c[h>>2]|0)+60>>2]=b;b=c[p>>2]|0;if((b|0)==3){Jz(c[(c[h>>2]|0)+56>>2]|0,c[n>>2]|0,c[(c[h>>2]|0)+60>>2]|0)|0;Jz(c[(c[h>>2]|0)+56>>2]|0,c[o>>2]|0,c[n>>2]|0)|0;break}else if((b|0)==2){Jz(c[(c[h>>2]|0)+56>>2]|0,c[n>>2]|0,c[(c[h>>2]|0)+60>>2]|0)|0;break}else if((b|0)==4){Jz(c[(c[h>>2]|0)+56>>2]|0,c[o>>2]|0,c[n>>2]|0)|0;break}else break}else{mn(c[h>>2]|0,1,85824,c[j>>2]|0);c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}while(0);c[f>>2]=1;t=c[f>>2]|0;i=e;return t|0}function ln(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d;f=d+24|0;g=d+20|0;h=d+16|0;j=d+12|0;k=d+8|0;l=d+4|0;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;c[j>>2]=0;c[k>>2]=0;do if(c[f>>2]|0){c[h>>2]=c[(c[f>>2]|0)+4>>2];c[k>>2]=c[c[f>>2]>>2];if((c[(c[f>>2]|0)+28>>2]|0)!=-1412623820?(c[(c[f>>2]|0)+28>>2]|0)!=-1412623819:0)break;c[l>>2]=(c[f>>2]|0)-(c[c[f>>2]>>2]|0);if((c[l>>2]|0)>0&(c[l>>2]|0)<250)c[j>>2]=c[c[f>>2]>>2]}while(0);f=c[h>>2]|0;h=c[k>>2]|0;k=c[j>>2]|0;if(c[g>>2]|0){j=c[g>>2]|0;c[e>>2]=c[g>>2];Xd(0,f,h,k,0,23,2,3,0,0,j,0,0,0,0,85648,e);i=d;return}else{Xd(0,f,h,k,0,23,2,3,0,0,0,0,0,0,0,85680,e);i=d;return}}function mn(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+48|0;g=f;h=f+32|0;j=f+28|0;k=f+24|0;l=f+20|0;m=f+16|0;n=f+12|0;o=f+8|0;p=f+4|0;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=0;c[n>>2]=0;c[o>>2]=0;do if(c[h>>2]|0){c[m>>2]=c[(c[h>>2]|0)+4>>2];c[o>>2]=c[c[h>>2]>>2];if((c[(c[h>>2]|0)+28>>2]|0)!=-1412623820?(c[(c[h>>2]|0)+28>>2]|0)!=-1412623819:0)break;c[p>>2]=(c[h>>2]|0)-(c[c[h>>2]>>2]|0);if((c[p>>2]|0)>0&(c[p>>2]|0)<250)c[n>>2]=c[c[h>>2]>>2]}while(0);h=c[m>>2]|0;m=c[o>>2]|0;o=c[n>>2]|0;n=c[j>>2]|0;if(c[l>>2]|0){j=c[l>>2]|0;p=c[k>>2]|0;c[g>>2]=c[l>>2];Xd(0,h,m,o,0,23,n,2,0,0,j,0,0,0,0,p,g);i=f;return}else{c[g>>2]=c[k>>2];Xd(0,h,m,o,0,23,n,2,0,0,0,0,0,0,0,85640,g);i=f;return}}function nn(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}Qh(c[d>>2]|0);lm(c[(c[d>>2]|0)+32>>2]|0,c[(c[d>>2]|0)+40>>2]|0);if(c[(c[d>>2]|0)+8>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+8>>2]|0);if(c[(c[d>>2]|0)+48>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+48>>2]|0);if(c[(c[d>>2]|0)+52>>2]|0)zz(c[(c[d>>2]|0)+52>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function on(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](56)|0;if(!(c[f>>2]|0)){ln(0,79472);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}a=(c[f>>2]|0)+0|0;h=a+56|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(h|0));c[(c[f>>2]|0)+4>>2]=15;c[(c[f>>2]|0)+36>>2]=c[(c[e>>2]|0)+36>>2];if(c[(c[e>>2]|0)+8>>2]|0){a=my(c[(c[e>>2]|0)+8>>2]|0)|0;c[(c[f>>2]|0)+8>>2]=a}else c[(c[f>>2]|0)+8>>2]=0;if(c[(c[e>>2]|0)+48>>2]|0){a=my(c[(c[e>>2]|0)+48>>2]|0)|0;c[(c[f>>2]|0)+48>>2]=a}else c[(c[f>>2]|0)+48>>2]=0;a=km(c[(c[e>>2]|0)+40>>2]|0)|0;c[(c[f>>2]|0)+40>>2]=a;c[(c[f>>2]|0)+44>>2]=0;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}function pn(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if(!(c[g>>2]|0)){i=e;return}if(c[h>>2]|0)rj(c[f>>2]|0,79632);d=c[c[g>>2]>>2]|0;a:do if((d|0)==1)rj(c[f>>2]|0,79640);else if((d|0)==4){if((c[c[(c[g>>2]|0)+12>>2]>>2]|0)!=4?(c[c[(c[g>>2]|0)+12>>2]>>2]|0)!=3:0)pn(c[f>>2]|0,c[(c[g>>2]|0)+12>>2]|0,0);else pn(c[f>>2]|0,c[(c[g>>2]|0)+12>>2]|0,1);rj(c[f>>2]|0,79664);do if((c[c[(c[g>>2]|0)+16>>2]>>2]|0)!=3){if((c[c[(c[g>>2]|0)+16>>2]>>2]|0)==4?(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]|0)!=1:0)break;pn(c[f>>2]|0,c[(c[g>>2]|0)+16>>2]|0,0);break a}while(0);pn(c[f>>2]|0,c[(c[g>>2]|0)+16>>2]|0,1)}else if((d|0)==2){if(c[(c[g>>2]|0)+24>>2]|0){qj(c[f>>2]|0,c[(c[g>>2]|0)+24>>2]|0);rj(c[f>>2]|0,79648)}qj(c[f>>2]|0,c[(c[g>>2]|0)+8>>2]|0)}else if((d|0)==3){if((c[c[(c[g>>2]|0)+12>>2]>>2]|0)!=4?(c[c[(c[g>>2]|0)+12>>2]>>2]|0)!=3:0)pn(c[f>>2]|0,c[(c[g>>2]|0)+12>>2]|0,0);else pn(c[f>>2]|0,c[(c[g>>2]|0)+12>>2]|0,1);rj(c[f>>2]|0,79656);do if((c[c[(c[g>>2]|0)+16>>2]>>2]|0)!=4){if((c[c[(c[g>>2]|0)+16>>2]>>2]|0)==3?(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]|0)!=1:0)break;pn(c[f>>2]|0,c[(c[g>>2]|0)+16>>2]|0,0);break a}while(0);pn(c[f>>2]|0,c[(c[g>>2]|0)+16>>2]|0,1)}else mn(0,1,79568,0);while(0);if(c[h>>2]|0)rj(c[f>>2]|0,79672);h=c[(c[g>>2]|0)+4>>2]|0;if((h|0)==2){rj(c[f>>2]|0,79680);i=e;return}else if((h|0)==3){rj(c[f>>2]|0,79688);i=e;return}else if((h|0)==4){rj(c[f>>2]|0,79696);i=e;return}else{i=e;return}}function qn(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;switch(c[h>>2]|0){case 10:case 2:case 3:case 5:{c[f>>2]=En(c[g>>2]|0,c[j>>2]|0)|0;break}case 7:{c[f>>2]=Gn(c[g>>2]|0,c[j>>2]|0)|0;break}case 4:case 6:{c[f>>2]=Fn(c[g>>2]|0,c[j>>2]|0)|0;break}case 9:case 8:{c[f>>2]=Hn(c[g>>2]|0,c[j>>2]|0)|0;break}default:c[f>>2]=1}i=e;return c[f>>2]|0}function rn(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=i;i=i+64|0;k=j;l=j+56|0;m=j+52|0;n=j+48|0;o=j+44|0;p=j+40|0;q=j+36|0;r=j+32|0;s=j+28|0;t=j+24|0;u=j+20|0;v=j+16|0;w=j+12|0;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;c[r>>2]=h;c[s>>2]=0;c[t>>2]=0;c[u>>2]=0;c[v>>2]=0;do if(c[l>>2]|0){c[t>>2]=c[(c[l>>2]|0)+8>>2];c[v>>2]=c[c[l>>2]>>2];if((c[(c[l>>2]|0)+28>>2]|0)!=-1412623820?(c[(c[l>>2]|0)+28>>2]|0)!=-1412623819:0)break;c[w>>2]=(c[l>>2]|0)-(c[c[l>>2]>>2]|0);if((c[w>>2]|0)>0&(c[w>>2]|0)<250)c[u>>2]=c[c[l>>2]>>2]}while(0);l=c[s>>2]|0;s=c[t>>2]|0;t=c[v>>2]|0;v=c[u>>2]|0;u=c[m>>2]|0;m=c[n>>2]|0;n=c[p>>2]|0;w=c[p>>2]|0;h=c[r>>2]|0;g=c[o>>2]|0;o=c[q>>2]|0;q=c[r>>2]|0;c[k>>2]=c[p>>2];c[k+4>>2]=o;c[k+8>>2]=q;Xd(l,s,t,v,u,23,m,1,0,0,n,w,h,0,0,g,k);i=j;return}function sn(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+32>>2]|0)c[e>>2]=c[(c[(c[d>>2]|0)+32>>2]|0)+80>>2];else c[e>>2]=0;Qh(c[d>>2]|0);if(c[(c[d>>2]|0)+52>>2]|0)rm(c[(c[d>>2]|0)+52>>2]|0);a=(c[(c[d>>2]|0)+60>>2]|0)!=0;if(c[e>>2]|0){if(a?(CP(c[e>>2]|0,c[(c[d>>2]|0)+60>>2]|0)|0)==0:0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+60>>2]|0);if((c[(c[d>>2]|0)+8>>2]|0)!=0?(CP(c[e>>2]|0,c[(c[d>>2]|0)+8>>2]|0)|0)==0:0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+8>>2]|0);if((c[(c[d>>2]|0)+56>>2]|0)!=0?(CP(c[e>>2]|0,c[(c[d>>2]|0)+56>>2]|0)|0)==0:0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+56>>2]|0);if((c[(c[d>>2]|0)+48>>2]|0)!=0?(CP(c[e>>2]|0,c[(c[d>>2]|0)+48>>2]|0)|0)==0:0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+48>>2]|0)}else{if(a)zb[c[135736>>2]&511](c[(c[d>>2]|0)+60>>2]|0);if(c[(c[d>>2]|0)+8>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+8>>2]|0);if(c[(c[d>>2]|0)+48>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+48>>2]|0);if(c[(c[d>>2]|0)+56>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+56>>2]|0)}zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function tn(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+48|0;f=e+32|0;g=e+28|0;h=e+24|0;j=e+20|0;k=e+16|0;l=e+12|0;m=e+8|0;n=e+4|0;o=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[m>>2]=0;c[n>>2]=0;if(!(c[g>>2]|0)){c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}if(!(c[(c[g>>2]|0)+40>>2]|0)){c[o>>2]=0;if(c[(c[g>>2]|0)+32>>2]|0)c[o>>2]=c[(c[(c[g>>2]|0)+32>>2]|0)+80>>2];if(!(c[j>>2]|0)){c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}c[k>>2]=c[(c[g>>2]|0)+40>>2];if(!(c[k>>2]|0)){c[k>>2]=Jj(0,c[o>>2]|0)|0;c[(c[g>>2]|0)+40>>2]=c[k>>2]}if(!(c[k>>2]|0)){ln(0,85552);c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}}c[k>>2]=c[(c[g>>2]|0)+40>>2];c[m>>2]=Ch(c[h>>2]|0,n)|0;if(c[m>>2]|0)c[h>>2]=c[m>>2];c[l>>2]=Tj(c[k>>2]|0,c[h>>2]|0,c[n>>2]|0)|0;do if((c[l>>2]|0)==0&(c[j>>2]|0)!=0){c[l>>2]=Cb[c[135744>>2]&511](56)|0;if(c[l>>2]|0){g=(c[l>>2]|0)+0|0;o=g+56|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(o|0));c[(c[l>>2]|0)+4>>2]=15;g=my(c[h>>2]|0)|0;c[(c[l>>2]|0)+8>>2]=g;g=my(c[n>>2]|0)|0;c[(c[l>>2]|0)+48>>2]=g;c[(c[l>>2]|0)+36>>2]=0;Nj(c[k>>2]|0,c[h>>2]|0,c[n>>2]|0,c[l>>2]|0)|0;break}ln(0,79472);c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}while(0);if(c[n>>2]|0)zb[c[135736>>2]&511](c[n>>2]|0);if(c[m>>2]|0)zb[c[135736>>2]&511](c[m>>2]|0);c[f>>2]=c[l>>2];p=c[f>>2]|0;i=e;return p|0}function un(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[l>>2]=0;if(!(c[h>>2]|0)){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}c[k>>2]=c[(c[h>>2]|0)+44>>2];while(1){if(!(c[k>>2]|0))break;if((c[(c[k>>2]|0)+40>>2]|0)==2?(c[l>>2]=(c[l>>2]|0)+1,(c[l>>2]|0)>1&(c[j>>2]|0)!=0):0)jn(c[g>>2]|0,c[h>>2]|0,520,85584,c[(c[h>>2]|0)+8>>2]|0,c[(c[k>>2]|0)+8>>2]|0,0);c[k>>2]=c[(c[k>>2]|0)+36>>2]}c[f>>2]=c[l>>2];m=c[f>>2]|0;i=e;return m|0}function vn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](64)|0;if(!(c[f>>2]|0)){ln(0,79472);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}a=(c[f>>2]|0)+0|0;h=a+64|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(h|0));c[(c[f>>2]|0)+4>>2]=16;c[(c[f>>2]|0)+40>>2]=c[(c[e>>2]|0)+40>>2];c[(c[f>>2]|0)+44>>2]=c[(c[e>>2]|0)+44>>2];a=sm(c[(c[e>>2]|0)+52>>2]|0)|0;c[(c[f>>2]|0)+52>>2]=a;if(c[(c[e>>2]|0)+60>>2]|0){a=my(c[(c[e>>2]|0)+60>>2]|0)|0;c[(c[f>>2]|0)+60>>2]=a}if(c[(c[e>>2]|0)+8>>2]|0){a=my(c[(c[e>>2]|0)+8>>2]|0)|0;c[(c[f>>2]|0)+8>>2]=a}if(c[(c[e>>2]|0)+56>>2]|0){a=my(c[(c[e>>2]|0)+56>>2]|0)|0;c[(c[f>>2]|0)+56>>2]=a}if(c[(c[e>>2]|0)+48>>2]|0){a=my(c[(c[e>>2]|0)+48>>2]|0)|0;c[(c[f>>2]|0)+48>>2]=a}c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}function wn(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if((c[e>>2]|0)==0|(c[f>>2]|0)==0){i=d;return}qj(c[e>>2]|0,c[(c[f>>2]|0)+4>>2]|0);b=c[e>>2]|0;if(!(c[c[f>>2]>>2]|0)){rj(b,79672);i=d;return}else{rj(b,79664);wn(c[e>>2]|0,c[c[f>>2]>>2]|0);i=d;return}}function xn(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[c[d>>2]>>2]|0)zb[c[135736>>2]&511](c[c[d>>2]>>2]|0);if(c[(c[d>>2]|0)+4>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+4>>2]|0);if(c[(c[d>>2]|0)+8>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+8>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function yn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](12)|0;if(!(c[f>>2]|0)){ln(0,79472);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}if(c[c[e>>2]>>2]|0){a=my(c[c[e>>2]>>2]|0)|0;c[c[f>>2]>>2]=a}else c[c[f>>2]>>2]=0;if(c[(c[e>>2]|0)+4>>2]|0){a=my(c[(c[e>>2]|0)+4>>2]|0)|0;c[(c[f>>2]|0)+4>>2]=a}else c[(c[f>>2]|0)+4>>2]=0;if(c[(c[e>>2]|0)+8>>2]|0){a=my(c[(c[e>>2]|0)+8>>2]|0)|0;c[(c[f>>2]|0)+8>>2]=a}else c[(c[f>>2]|0)+8>>2]=0;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}function zn(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;Am(c[f>>2]|0,c[e>>2]|0);i=d;return}function An(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=0;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+20>>2]|0)c[e>>2]=c[(c[(c[d>>2]|0)+20>>2]|0)+80>>2];do if((c[(c[d>>2]|0)+4>>2]|0)!=0?(c[(c[d>>2]|0)+4>>2]|0)!=0:0){if((c[e>>2]|0)!=0?(CP(c[e>>2]|0,c[(c[d>>2]|0)+4>>2]|0)|0)!=0:0)break;zb[c[135736>>2]&511](c[(c[d>>2]|0)+4>>2]|0)}while(0);do if((c[(c[d>>2]|0)+12>>2]|0)!=0?(c[(c[d>>2]|0)+12>>2]|0)!=0:0){if((c[e>>2]|0)!=0?(CP(c[e>>2]|0,c[(c[d>>2]|0)+12>>2]|0)|0)!=0:0)break;zb[c[135736>>2]&511](c[(c[d>>2]|0)+12>>2]|0)}while(0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function Bn(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=OS(c[d>>2]|0)|0;if(!(c[e>>2]|0)){i=b;return}if(c[(c[e>>2]|0)+4>>2]|0)zb[c[135736>>2]&511](c[(c[e>>2]|0)+4>>2]|0);if(c[(c[e>>2]|0)+12>>2]|0)zb[c[135736>>2]&511](c[(c[e>>2]|0)+12>>2]|0);zb[c[135736>>2]&511](c[e>>2]|0);i=b;return}function Cn(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+16|0;c[d+4>>2]=a;c[d>>2]=b;i=d;return 0}function Dn(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}MS(c[d>>2]|0);i=b;return}function En(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;if(!(c[g>>2]|0)){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}c[h>>2]=c[g>>2];c[j>>2]=oe(0,c[h>>2]|0,k)|0;c[h>>2]=(c[h>>2]|0)+(c[k>>2]|0);if(!(Vn(c[f>>2]|0,c[j>>2]|0)|0)){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}c[j>>2]=oe(0,c[h>>2]|0,k)|0;c[h>>2]=(c[h>>2]|0)+(c[k>>2]|0);while(1){if(!(Wn(c[f>>2]|0,c[j>>2]|0)|0))break;c[j>>2]=oe(0,c[h>>2]|0,k)|0;c[h>>2]=(c[h>>2]|0)+(c[k>>2]|0)}if(c[j>>2]|0){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}else{c[e>>2]=1;l=c[e>>2]|0;i=d;return l|0}return 0}function Fn(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;if(!(c[g>>2]|0)){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}c[h>>2]=c[g>>2];c[j>>2]=oe(0,c[h>>2]|0,k)|0;c[h>>2]=(c[h>>2]|0)+(c[k>>2]|0);if(!(Vn(c[f>>2]|0,c[j>>2]|0)|0)){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}c[j>>2]=oe(0,c[h>>2]|0,k)|0;c[h>>2]=(c[h>>2]|0)+(c[k>>2]|0);while(1){if(!(Wn(c[f>>2]|0,c[j>>2]|0)|0))break;c[j>>2]=oe(0,c[h>>2]|0,k)|0;c[h>>2]=(c[h>>2]|0)+(c[k>>2]|0)}a:while(1){if((c[j>>2]|0)!=32)break;while(1){if((c[j>>2]|0)!=32)break;c[j>>2]=oe(0,c[h>>2]|0,k)|0;c[h>>2]=(c[h>>2]|0)+(c[k>>2]|0)}if(!(Vn(c[f>>2]|0,c[j>>2]|0)|0)){m=12;break}c[j>>2]=oe(0,c[h>>2]|0,k)|0;c[h>>2]=(c[h>>2]|0)+(c[k>>2]|0);while(1){if(!(Wn(c[f>>2]|0,c[j>>2]|0)|0))continue a;c[j>>2]=oe(0,c[h>>2]|0,k)|0;c[h>>2]=(c[h>>2]|0)+(c[k>>2]|0)}}if((m|0)==12){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}if(c[j>>2]|0){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}else{c[e>>2]=1;l=c[e>>2]|0;i=d;return l|0}return 0}function Gn(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;if(!(c[g>>2]|0)){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}c[h>>2]=c[g>>2];c[j>>2]=oe(0,c[h>>2]|0,k)|0;c[h>>2]=(c[h>>2]|0)+(c[k>>2]|0);if(!(Wn(c[f>>2]|0,c[j>>2]|0)|0)){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}c[j>>2]=oe(0,c[h>>2]|0,k)|0;c[h>>2]=(c[h>>2]|0)+(c[k>>2]|0);while(1){if(!(Wn(c[f>>2]|0,c[j>>2]|0)|0))break;c[j>>2]=oe(0,c[h>>2]|0,k)|0;c[h>>2]=(c[h>>2]|0)+(c[k>>2]|0)}if(c[j>>2]|0){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}else{c[e>>2]=1;l=c[e>>2]|0;i=d;return l|0}return 0}function Hn(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;if(!(c[g>>2]|0)){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}c[h>>2]=c[g>>2];c[j>>2]=oe(0,c[h>>2]|0,k)|0;c[h>>2]=(c[h>>2]|0)+(c[k>>2]|0);while(1){if((c[j>>2]|0)<256){if((c[j>>2]|0)!=32?!(9<=(c[j>>2]|0)&(c[j>>2]|0)<=10):0)m=(c[j>>2]|0)==13;else m=1;n=m&1}else n=0;if(!n)break;c[j>>2]=oe(0,c[h>>2]|0,k)|0;c[h>>2]=(c[h>>2]|0)+(c[k>>2]|0)}if(!(Wn(c[f>>2]|0,c[j>>2]|0)|0)){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}while(1){if(!(Wn(c[f>>2]|0,c[j>>2]|0)|0))break;c[j>>2]=oe(0,c[h>>2]|0,k)|0;c[h>>2]=(c[h>>2]|0)+(c[k>>2]|0)}a:while(1){if((c[j>>2]|0)!=32){o=25;break}while(1){if((c[j>>2]|0)!=32)break;c[j>>2]=oe(0,c[h>>2]|0,k)|0;c[h>>2]=(c[h>>2]|0)+(c[k>>2]|0)}if(!(c[j>>2]|0)){o=19;break}if(!(Wn(c[f>>2]|0,c[j>>2]|0)|0)){o=21;break}c[j>>2]=oe(0,c[h>>2]|0,k)|0;c[h>>2]=(c[h>>2]|0)+(c[k>>2]|0);while(1){if(!(Wn(c[f>>2]|0,c[j>>2]|0)|0))continue a;c[j>>2]=oe(0,c[h>>2]|0,k)|0;c[h>>2]=(c[h>>2]|0)+(c[k>>2]|0)}}if((o|0)==19){c[e>>2]=1;l=c[e>>2]|0;i=d;return l|0}else if((o|0)==21){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}else if((o|0)==25)if(c[j>>2]|0){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}else{c[e>>2]=1;l=c[e>>2]|0;i=d;return l|0}return 0}function In(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;c[f>>2]=a;c[g>>2]=b;c[e>>2]=d;if((c[(c[f>>2]|0)+40>>2]|0)!=2){i=e;return}f=c[g>>2]|0;c[f>>2]=(c[f>>2]|0)+1;i=e;return}function Jn(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=i;i=i+64|0;k=j;l=j+56|0;m=j+52|0;n=j+48|0;o=j+44|0;p=j+40|0;q=j+36|0;r=j+32|0;s=j+28|0;t=j+24|0;u=j+20|0;v=j+16|0;w=j+12|0;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;c[r>>2]=h;c[s>>2]=0;c[t>>2]=0;c[u>>2]=0;c[v>>2]=0;do if(c[l>>2]|0){c[t>>2]=c[(c[l>>2]|0)+4>>2];c[v>>2]=c[c[l>>2]>>2];if((c[(c[l>>2]|0)+28>>2]|0)!=-1412623820?(c[(c[l>>2]|0)+28>>2]|0)!=-1412623819:0)break;c[w>>2]=(c[l>>2]|0)-(c[c[l>>2]>>2]|0);if((c[w>>2]|0)>0&(c[w>>2]|0)<250)c[u>>2]=c[c[l>>2]>>2]}while(0);l=c[s>>2]|0;s=c[t>>2]|0;t=c[v>>2]|0;v=c[u>>2]|0;u=c[m>>2]|0;m=c[n>>2]|0;n=c[p>>2]|0;w=c[r>>2]|0;h=c[q>>2]|0;g=c[o>>2]|0;o=c[q>>2]|0;q=c[r>>2]|0;c[k>>2]=c[p>>2];c[k+4>>2]=o;c[k+8>>2]=q;Xd(l,s,t,v,u,23,m,2,0,0,n,w,0,h,0,g,k);i=j;return}function Kn(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;j=i;i=i+64|0;k=j+48|0;l=j+44|0;m=j+40|0;n=j+36|0;o=j+32|0;p=j+28|0;q=j+24|0;r=j+20|0;s=j+16|0;t=j+12|0;u=j+8|0;v=j+52|0;w=j+4|0;x=j;c[l>>2]=b;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[p>>2]=h;c[q>>2]=1;h=c[o>>2]|0;do if((h|0)==5){c[r>>2]=ad(c[m>>2]|0,c[p>>2]|0)|0;if((c[r>>2]|0)==0?(c[(c[m>>2]|0)+40>>2]|0)==1:0){c[(c[m>>2]|0)+40>>2]=0;c[r>>2]=ad(c[m>>2]|0,c[p>>2]|0)|0}if(!(c[r>>2]|0)){jn(c[l>>2]|0,c[m>>2]|0,535,85248,c[n>>2]|0,c[p>>2]|0,0);c[q>>2]=0;break}if((c[(c[r>>2]|0)+48>>2]|0)!=3){jn(c[l>>2]|0,c[m>>2]|0,511,85304,c[n>>2]|0,c[p>>2]|0,0);c[q>>2]=0}}else if((h|0)==10){c[x>>2]=Om(c[(c[m>>2]|0)+44>>2]|0,c[p>>2]|0)|0;if((c[x>>2]|0)==0?(c[(c[m>>2]|0)+48>>2]|0)!=0:0)c[x>>2]=Om(c[(c[m>>2]|0)+48>>2]|0,c[p>>2]|0)|0;if(!(c[x>>2]|0)){jn(c[l>>2]|0,c[m>>2]|0,537,85488,c[n>>2]|0,c[p>>2]|0,0);c[q>>2]=0}}else if((h|0)==6){c[t>>2]=0;c[s>>2]=my(c[p>>2]|0)|0;if(!(c[s>>2]|0)){c[k>>2]=0;y=c[k>>2]|0;i=j;return y|0}c[u>>2]=c[s>>2];a:while(1){if(!(d[c[u>>2]>>0]|0))break;c[t>>2]=c[u>>2];while(1){if(d[c[u>>2]>>0]|0){do if((d[c[u>>2]>>0]|0|0)==32)z=1;else{if(9<=(d[c[u>>2]>>0]|0|0)?(d[c[u>>2]>>0]|0|0)<=10:0){z=1;break}z=(d[c[u>>2]>>0]|0|0)==13}while(0);A=z^1}else A=0;B=c[u>>2]|0;if(!A)break;c[u>>2]=B+1}a[v>>0]=a[B>>0]|0;a[c[u>>2]>>0]=0;c[w>>2]=ad(c[m>>2]|0,c[t>>2]|0)|0;if(c[w>>2]|0){if((c[(c[w>>2]|0)+48>>2]|0)!=3){jn(c[l>>2]|0,c[m>>2]|0,511,85424,c[n>>2]|0,c[t>>2]|0,0);c[q>>2]=0}}else{jn(c[l>>2]|0,c[m>>2]|0,535,85368,c[n>>2]|0,c[t>>2]|0,0);c[q>>2]=0}if(!(d[v>>0]|0))break;a[c[u>>2]>>0]=a[v>>0]|0;while(1){do if((d[c[u>>2]>>0]|0|0)!=32){if(9<=(d[c[u>>2]>>0]|0|0)?(d[c[u>>2]>>0]|0|0)<=10:0)break;if((d[c[u>>2]>>0]|0|0)!=13)continue a}while(0);c[u>>2]=(c[u>>2]|0)+1}}zb[c[135736>>2]&511](c[s>>2]|0)}while(0);c[k>>2]=c[q>>2];y=c[k>>2]|0;i=j;return y|0}function Ln(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=Dh(c[j>>2]|0,l)|0;a:do if(!(c[k>>2]|0)){b:while(1){if(!(c[h>>2]|0))break a;d=c[h>>2]|0;do if((c[c[h>>2]>>2]|0)==2){if((c[d+24>>2]|0)==0?(qy(c[(c[h>>2]|0)+8>>2]|0,c[j>>2]|0)|0)!=0:0){m=6;break b}}else{if(((c[d>>2]|0)==4?(c[(c[h>>2]|0)+12>>2]|0)!=0:0)?(c[c[(c[h>>2]|0)+12>>2]>>2]|0)==2:0){if(c[(c[(c[h>>2]|0)+12>>2]|0)+24>>2]|0)break;if(qy(c[(c[(c[h>>2]|0)+12>>2]|0)+8>>2]|0,c[j>>2]|0)|0){m=12;break b}else break}if((c[c[h>>2]>>2]|0)!=4){m=16;break b}if(!(c[(c[h>>2]|0)+12>>2]|0)){m=16;break b}if((c[c[(c[h>>2]|0)+12>>2]>>2]|0)!=1){m=16;break b}}while(0);c[h>>2]=c[(c[h>>2]|0)+16>>2]}if((m|0)==6){c[f>>2]=1;n=c[f>>2]|0;i=e;return n|0}else if((m|0)==12){c[f>>2]=1;n=c[f>>2]|0;i=e;return n|0}else if((m|0)==16){mn(0,519,83864,0);break}}else{c:while(1){if(!(c[h>>2]|0))break a;d=c[h>>2]|0;do if((c[c[h>>2]>>2]|0)==2){if(((c[d+24>>2]|0)!=0?(sy(c[(c[h>>2]|0)+24>>2]|0,c[j>>2]|0,c[l>>2]|0)|0)==0:0)?(qy(c[(c[h>>2]|0)+8>>2]|0,c[k>>2]|0)|0)!=0:0){m=23;break c}}else{if(((c[d>>2]|0)==4?(c[(c[h>>2]|0)+12>>2]|0)!=0:0)?(c[c[(c[h>>2]|0)+12>>2]>>2]|0)==2:0){if(!(c[(c[(c[h>>2]|0)+12>>2]|0)+24>>2]|0))break;if(sy(c[(c[(c[h>>2]|0)+12>>2]|0)+24>>2]|0,c[j>>2]|0,c[l>>2]|0)|0)break;if(qy(c[(c[(c[h>>2]|0)+12>>2]|0)+8>>2]|0,c[k>>2]|0)|0){m=30;break c}else break}if((c[c[h>>2]>>2]|0)!=4){m=34;break c}if(!(c[(c[h>>2]|0)+12>>2]|0)){m=34;break c}if((c[c[(c[h>>2]|0)+12>>2]>>2]|0)!=1){m=34;break c}}while(0);c[h>>2]=c[(c[h>>2]|0)+16>>2]}if((m|0)==23){c[f>>2]=1;n=c[f>>2]|0;i=e;return n|0}else if((m|0)==30){c[f>>2]=1;n=c[f>>2]|0;i=e;return n|0}else if((m|0)==34){mn(c[g>>2]|0,519,83864,0);break}}while(0);c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}function Mn(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=0;c[n>>2]=0;if(!((c[h>>2]|0)==0|(c[j>>2]|0)==0|(c[k>>2]|0)==0)?(c[(c[k>>2]|0)+8>>2]|0)!=0:0){if(c[l>>2]|0)c[c[l>>2]>>2]=0;if((c[(c[k>>2]|0)+36>>2]|0)!=0?(c[(c[(c[k>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0)c[n>>2]=c[(c[(c[k>>2]|0)+36>>2]|0)+12>>2];if((((c[n>>2]|0)!=0?(c[m>>2]=Mm(c[(c[j>>2]|0)+44>>2]|0,c[(c[k>>2]|0)+8>>2]|0,c[n>>2]|0)|0,(c[m>>2]|0)==0):0)?(c[(c[j>>2]|0)+48>>2]|0)!=0:0)?(c[m>>2]=Mm(c[(c[j>>2]|0)+48>>2]|0,c[(c[k>>2]|0)+8>>2]|0,c[n>>2]|0)|0,(c[m>>2]|0)!=0&(c[l>>2]|0)!=0):0)c[c[l>>2]>>2]=1;if((((c[m>>2]|0)==0?(c[m>>2]=Lm(c[(c[j>>2]|0)+44>>2]|0,c[(c[k>>2]|0)+8>>2]|0)|0,(c[m>>2]|0)==0):0)?(c[(c[j>>2]|0)+48>>2]|0)!=0:0)?(c[m>>2]=Lm(c[(c[j>>2]|0)+48>>2]|0,c[(c[k>>2]|0)+8>>2]|0)|0,(c[m>>2]|0)!=0&(c[l>>2]|0)!=0):0)c[c[l>>2]>>2]=1;if(!(c[m>>2]|0))jn(c[h>>2]|0,c[k>>2]|0,534,83832,c[(c[k>>2]|0)+8>>2]|0,0,0);c[g>>2]=c[m>>2];o=c[g>>2]|0;i=f;return o|0}c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}function Nn(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(!((c[(c[g>>2]|0)+48>>2]|0)!=0?(c[(c[g>>2]|0)+52>>2]|0)!=0:0))l=3;if((l|0)==3?(c[(c[g>>2]|0)+48>>2]=10,l=Cb[c[135744>>2]&511]((c[(c[g>>2]|0)+48>>2]|0)*12|0)|0,c[(c[g>>2]|0)+52>>2]=l,(c[(c[g>>2]|0)+52>>2]|0)==0):0){ln(c[g>>2]|0,79472);c[f>>2]=-1;m=c[f>>2]|0;i=e;return m|0}do if((c[(c[g>>2]|0)+44>>2]|0)>=(c[(c[g>>2]|0)+48>>2]|0)){c[k>>2]=Hb[c[135760>>2]&511](c[(c[g>>2]|0)+52>>2]|0,(c[(c[g>>2]|0)+48>>2]<<1)*12|0)|0;l=c[g>>2]|0;if(c[k>>2]|0){d=l+48|0;c[d>>2]=c[d>>2]<<1;c[(c[g>>2]|0)+52>>2]=c[k>>2];break}ln(l,85184);c[f>>2]=-1;m=c[f>>2]|0;i=e;return m|0}while(0);c[(c[g>>2]|0)+40>>2]=(c[(c[g>>2]|0)+52>>2]|0)+((c[(c[g>>2]|0)+44>>2]|0)*12|0);c[(c[(c[g>>2]|0)+52>>2]|0)+((c[(c[g>>2]|0)+44>>2]|0)*12|0)>>2]=c[h>>2];c[(c[(c[g>>2]|0)+52>>2]|0)+((c[(c[g>>2]|0)+44>>2]|0)*12|0)+4>>2]=c[j>>2];do if((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+36>>2]|0)==4:0){if(!(c[(c[h>>2]|0)+52>>2]|0))em(c[g>>2]|0,c[h>>2]|0)|0;if(c[(c[h>>2]|0)+52>>2]|0){k=oz(c[(c[h>>2]|0)+52>>2]|0,0,0)|0;c[(c[(c[g>>2]|0)+52>>2]|0)+((c[(c[g>>2]|0)+44>>2]|0)*12|0)+8>>2]=k;break}else{c[(c[(c[g>>2]|0)+52>>2]|0)+((c[(c[g>>2]|0)+44>>2]|0)*12|0)+8>>2]=0;jn(c[g>>2]|0,c[h>>2]|0,1,85200,c[(c[j>>2]|0)+8>>2]|0,0,0);break}}while(0);j=(c[g>>2]|0)+44|0;g=c[j>>2]|0;c[j>>2]=g+1;c[f>>2]=g;m=c[f>>2]|0;i=e;return m|0}function On(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if((c[(c[e>>2]|0)+44>>2]|0)<1){c[d>>2]=-1;g=c[d>>2]|0;i=b;return g|0}a=(c[e>>2]|0)+44|0;c[a>>2]=(c[a>>2]|0)+-1;c[f>>2]=c[(c[(c[e>>2]|0)+52>>2]|0)+((c[(c[e>>2]|0)+44>>2]|0)*12|0)>>2];c[(c[(c[e>>2]|0)+52>>2]|0)+((c[(c[e>>2]|0)+44>>2]|0)*12|0)>>2]=0;c[(c[(c[e>>2]|0)+52>>2]|0)+((c[(c[e>>2]|0)+44>>2]|0)*12|0)+4>>2]=0;if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+36>>2]|0)==4:0)pz(c[(c[(c[e>>2]|0)+52>>2]|0)+((c[(c[e>>2]|0)+44>>2]|0)*12|0)+8>>2]|0);c[(c[(c[e>>2]|0)+52>>2]|0)+((c[(c[e>>2]|0)+44>>2]|0)*12|0)+8>>2]=0;f=c[e>>2]|0;if((c[(c[e>>2]|0)+44>>2]|0)>=1)c[(c[e>>2]|0)+40>>2]=(c[(c[e>>2]|0)+52>>2]|0)+(((c[f+44>>2]|0)-1|0)*12|0);else c[f+40>>2]=0;c[d>>2]=c[(c[e>>2]|0)+44>>2];g=c[d>>2]|0;i=b;return g|0}function Pn(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=1;if(!((c[g>>2]|0)==0|(c[h>>2]|0)==0|(c[j>>2]|0)==0)?(c[(c[j>>2]|0)+4>>2]|0)==1:0){c[m>>2]=c[(c[j>>2]|0)+12>>2];c[l>>2]=c[m>>2];a:while(1){if(!(c[l>>2]|0))break;switch(c[(c[l>>2]|0)+4>>2]|0){case 4:case 3:case 7:case 8:break;case 5:{if((c[(c[l>>2]|0)+12>>2]|0)!=0?(c[(c[(c[l>>2]|0)+12>>2]|0)+12>>2]|0)!=0:0){Xn(c[g>>2]|0,c[l>>2]|0)|0;c[l>>2]=c[(c[(c[l>>2]|0)+12>>2]|0)+12>>2];continue a}break}default:{n=10;break a}}c[l>>2]=c[(c[l>>2]|0)+24>>2];while(1){if(c[l>>2]|0)continue a;c[l>>2]=Yn(c[g>>2]|0)|0;if(!(c[l>>2]|0))continue a;c[l>>2]=c[(c[l>>2]|0)+24>>2]}}if((n|0)==10)c[k>>2]=0;c[(c[g>>2]|0)+20>>2]=0;c[(c[g>>2]|0)+16>>2]=0;if(c[(c[g>>2]|0)+24>>2]|0){zb[c[135736>>2]&511](c[(c[g>>2]|0)+24>>2]|0);c[(c[g>>2]|0)+24>>2]=0}c[f>>2]=c[k>>2];o=c[f>>2]|0;i=e;return o|0}c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}function Qn(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;h=i;i=i+10112|0;j=h+44|0;k=h+40|0;l=h+36|0;m=h+32|0;n=h+28|0;o=h+24|0;p=h+20|0;q=h+16|0;r=h+12|0;s=h+8|0;t=h+4|0;u=h+10048|0;v=h;w=h+5048|0;x=h+48|0;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[p>>2]=1;if((c[m>>2]|0)==0|(c[o>>2]|0)==0|(c[k>>2]|0)==0){c[j>>2]=-1;y=c[j>>2]|0;i=h;return y|0}c[r>>2]=c[(c[m>>2]|0)+40>>2];c[s>>2]=c[(c[m>>2]|0)+8>>2];if(!(c[(c[m>>2]|0)+52>>2]|0))c[p>>2]=em(c[k>>2]|0,c[m>>2]|0)|0;if(!(c[(c[m>>2]|0)+52>>2]|0)){c[j>>2]=-1;y=c[j>>2]|0;i=h;return y|0}if(!(wz(c[(c[m>>2]|0)+52>>2]|0)|0)){c[j>>2]=-1;y=c[j>>2]|0;i=h;return y|0}c[(c[k>>2]|0)+20>>2]=0;c[(c[k>>2]|0)+16>>2]=0;c[(c[k>>2]|0)+24>>2]=0;c[t>>2]=oz(c[(c[m>>2]|0)+52>>2]|0,0,0)|0;if(c[t>>2]|0){c[q>>2]=c[l>>2];a:while(1){if(!(c[q>>2]|0)){z=31;break}m=c[(c[q>>2]|0)+4>>2]|0;do if((m|0)==3){if(!(ij(c[q>>2]|0)|0)){z=17;break a}}else if((m|0)==1){if((c[(c[q>>2]|0)+36>>2]|0)!=0?(c[(c[(c[q>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){c[v>>2]=Bh(c[(c[q>>2]|0)+8>>2]|0,c[(c[(c[q>>2]|0)+36>>2]|0)+12>>2]|0,u,50)|0;if(!(c[v>>2]|0)){z=22;break a}c[p>>2]=qz(c[t>>2]|0,c[v>>2]|0,0)|0;if((c[v>>2]|0)==(u|0))break;if((c[v>>2]|0)==(c[(c[q>>2]|0)+8>>2]|0))break;zb[c[135736>>2]&511](c[v>>2]|0);break}c[p>>2]=qz(c[t>>2]|0,c[(c[q>>2]|0)+8>>2]|0,0)|0}else if((m|0)==4){z=18;break a}else if(((m|0)==5?(c[(c[q>>2]|0)+12>>2]|0)!=0:0)?(c[(c[(c[q>>2]|0)+12>>2]|0)+12>>2]|0)!=0:0){Xn(c[k>>2]|0,c[q>>2]|0)|0;c[q>>2]=c[(c[(c[q>>2]|0)+12>>2]|0)+12>>2];continue a}while(0);c[q>>2]=c[(c[q>>2]|0)+24>>2];while(1){if(c[q>>2]|0)continue a;c[q>>2]=Yn(c[k>>2]|0)|0;if(!(c[q>>2]|0))continue a;c[q>>2]=c[(c[q>>2]|0)+24>>2]}}if((z|0)==17)c[p>>2]=0;else if((z|0)==18)c[p>>2]=0;else if((z|0)==22)c[p>>2]=-1;else if((z|0)==31)c[p>>2]=qz(c[t>>2]|0,0,0)|0;pz(c[t>>2]|0)}if((c[n>>2]|0)!=0&(c[p>>2]|0)!=1&(c[p>>2]|0)!=-3){do if(c[k>>2]|0){a[w>>0]=0;fm(w,5e3,c[r>>2]|0,1);a[x>>0]=0;Zn(x,5e3,c[l>>2]|0,1);n=c[k>>2]|0;t=c[o>>2]|0;if(c[s>>2]|0){jn(n,t,504,84936,c[s>>2]|0,w,x);break}else{jn(n,t,504,85008,w,x,0);break}}else{t=c[k>>2]|0;n=c[o>>2]|0;if(c[s>>2]|0){jn(t,n,504,85072,c[s>>2]|0,0,0);break}else{jn(t,n,504,85120,0,0,0);break}}while(0);c[p>>2]=0}if((c[p>>2]|0)==-3)c[p>>2]=1;c[(c[k>>2]|0)+20>>2]=0;c[(c[k>>2]|0)+16>>2]=0;if(c[(c[k>>2]|0)+24>>2]|0){zb[c[135736>>2]&511](c[(c[k>>2]|0)+24>>2]|0);c[(c[k>>2]|0)+24>>2]=0}c[j>>2]=c[p>>2];y=c[j>>2]|0;i=h;return y|0;
}function Rn(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if(!(c[f>>2]|0)){i=e;return}c[j>>2]=c[g>>2];c[j+4>>2]=c[h>>2];PS(c[f>>2]|0,258,j);i=e;return}function Sn(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[f>>2]=a;c[g>>2]=b;c[e+16>>2]=d;c[k>>2]=0;if(!(c[f>>2]|0)){i=e;return}d=c[(c[f>>2]|0)+40>>2]|0;a:do if((d|0)==5|(d|0)==6|(d|0)==10){if(((c[(c[f>>2]|0)+48>>2]|0)!=0?(c[h>>2]=Kn(c[g>>2]|0,c[(c[g>>2]|0)+32>>2]|0,c[(c[f>>2]|0)+8>>2]|0,c[(c[f>>2]|0)+40>>2]|0,c[(c[f>>2]|0)+48>>2]|0)|0,(c[h>>2]|0)==0):0)?(c[(c[g>>2]|0)+36>>2]|0)==1:0)c[(c[g>>2]|0)+36>>2]=0;if(c[(c[f>>2]|0)+52>>2]|0){c[l>>2]=c[(c[f>>2]|0)+52>>2];while(1){if(!(c[l>>2]|0))break a;c[h>>2]=Kn(c[g>>2]|0,c[(c[g>>2]|0)+32>>2]|0,c[(c[f>>2]|0)+8>>2]|0,c[(c[f>>2]|0)+40>>2]|0,c[(c[l>>2]|0)+4>>2]|0)|0;if((c[h>>2]|0)==0?(c[(c[g>>2]|0)+36>>2]|0)==1:0)c[(c[g>>2]|0)+36>>2]=0;c[l>>2]=c[c[l>>2]>>2]}}}while(0);if((c[(c[f>>2]|0)+40>>2]|0)!=10){i=e;return}c[j>>2]=c[(c[f>>2]|0)+32>>2];if(!(c[(c[f>>2]|0)+60>>2]|0)){mn(c[g>>2]|0,1,84584,c[(c[f>>2]|0)+8>>2]|0);i=e;return}if(c[j>>2]|0)c[k>>2]=Lm(c[(c[j>>2]|0)+44>>2]|0,c[(c[f>>2]|0)+60>>2]|0)|0;if((c[k>>2]|0)==0&(c[j>>2]|0)!=0)c[k>>2]=Lm(c[(c[j>>2]|0)+48>>2]|0,c[(c[f>>2]|0)+60>>2]|0)|0;if(((c[k>>2]|0)==0?(c[(c[f>>2]|0)+20>>2]|0)!=0:0)?(c[(c[(c[f>>2]|0)+20>>2]|0)+4>>2]|0)==14:0)c[k>>2]=Lm(c[(c[f>>2]|0)+20>>2]|0,c[(c[f>>2]|0)+60>>2]|0)|0;if(!(c[k>>2]|0)){jn(c[g>>2]|0,0,534,84640,c[(c[f>>2]|0)+8>>2]|0,c[(c[f>>2]|0)+60>>2]|0,0);i=e;return}if((c[(c[k>>2]|0)+36>>2]|0)!=1){i=e;return}jn(c[g>>2]|0,0,510,84696,c[(c[f>>2]|0)+8>>2]|0,c[(c[f>>2]|0)+60>>2]|0,0);c[(c[g>>2]|0)+36>>2]=0;i=e;return}function Tn(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[e+8>>2]=d;if(!(c[f>>2]|0)){i=e;return}if((c[(c[f>>2]|0)+48>>2]|0)!=3){i=e;return}c[h>>2]=c[(c[f>>2]|0)+40>>2];if(!(c[h>>2]|0)){i=e;return}c[j>>2]=Pm(c[g>>2]|0,c[(c[f>>2]|0)+32>>2]|0,c[h>>2]|0)|0;if((c[j>>2]|0)==1){i=e;return}c[(c[g>>2]|0)+36>>2]=0;i=e;return}function Un(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+16|0;c[d+4>>2]=a;c[d>>2]=b;i=d;return}function Vn(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;a:do if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+92>>2]&4|0)!=0:0){b=c[g>>2]|0;if((c[g>>2]|0)<256){if(((!(65<=(b|0)&(c[g>>2]|0)<=90)?!(97<=(c[g>>2]|0)&(c[g>>2]|0)<=122):0)?!(192<=(c[g>>2]|0)&(c[g>>2]|0)<=214):0)?!(216<=(c[g>>2]|0)&(c[g>>2]|0)<=246|248<=(c[g>>2]|0)):0)h=24}else if(!(DQ(b,199744)|0))h=24;do if((h|0)==24){b=c[g>>2]|0;if((c[g>>2]|0)<256)if((b|0)==95|(c[g>>2]|0)==58)break;else break a;if(!(19968<=(b|0)&(c[g>>2]|0)<=40869|(c[g>>2]|0)==12295)?!(12321<=(c[g>>2]|0)&(c[g>>2]|0)<=12329|(c[g>>2]|0)==95|(c[g>>2]|0)==58):0)break a}while(0);c[e>>2]=1;j=c[e>>2]|0;i=d;return j|0}else h=3;while(0);do if((h|0)==3){if(((((((((((((!((c[g>>2]|0)>=97&(c[g>>2]|0)<=122)?!((c[g>>2]|0)>=65&(c[g>>2]|0)<=90|(c[g>>2]|0)==95|(c[g>>2]|0)==58):0)?!((c[g>>2]|0)>=192&(c[g>>2]|0)<=214):0)?!((c[g>>2]|0)>=216&(c[g>>2]|0)<=246):0)?!((c[g>>2]|0)>=248&(c[g>>2]|0)<=767):0)?!((c[g>>2]|0)>=880&(c[g>>2]|0)<=893):0)?!((c[g>>2]|0)>=895&(c[g>>2]|0)<=8191):0)?!((c[g>>2]|0)>=8204&(c[g>>2]|0)<=8205):0)?!((c[g>>2]|0)>=8304&(c[g>>2]|0)<=8591):0)?!((c[g>>2]|0)>=11264&(c[g>>2]|0)<=12271):0)?!((c[g>>2]|0)>=12289&(c[g>>2]|0)<=55295):0)?!((c[g>>2]|0)>=63744&(c[g>>2]|0)<=64975):0)?!((c[g>>2]|0)>=65008&(c[g>>2]|0)<=65533):0)?!((c[g>>2]|0)>=65536&(c[g>>2]|0)<=983039):0)break;c[e>>2]=1;j=c[e>>2]|0;i=d;return j|0}while(0);c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}function Wn(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;a:do if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+92>>2]&4|0)!=0:0){b=c[g>>2]|0;if((c[g>>2]|0)<256){if(((!(65<=(b|0)&(c[g>>2]|0)<=90)?!(97<=(c[g>>2]|0)&(c[g>>2]|0)<=122):0)?!(192<=(c[g>>2]|0)&(c[g>>2]|0)<=214):0)?!(216<=(c[g>>2]|0)&(c[g>>2]|0)<=246|248<=(c[g>>2]|0)):0)h=27}else if(!(DQ(b,199744)|0))h=27;do if((h|0)==27){if((c[g>>2]|0)>=256){if(19968<=(c[g>>2]|0)&(c[g>>2]|0)<=40869|(c[g>>2]|0)==12295)break;if(12321<=(c[g>>2]|0)&(c[g>>2]|0)<=12329)break}b=c[g>>2]|0;if((c[g>>2]|0)<256){if(48<=(b|0)&(c[g>>2]|0)<=57|(c[g>>2]|0)==46|(c[g>>2]|0)==45|(c[g>>2]|0)==95|(c[g>>2]|0)==58)break}else{a=(DQ(b,200216)|0)!=0;if(a|(c[g>>2]|0)==46|(c[g>>2]|0)==45|(c[g>>2]|0)==95|(c[g>>2]|0)==58)break}if((c[g>>2]|0)>=256?(DQ(c[g>>2]|0,200144)|0)!=0:0)break;a=c[g>>2]|0;if((c[g>>2]|0)<256)if((a|0)==183)break;else break a;else if(DQ(a,200272)|0)break;else break a}while(0);c[e>>2]=1;j=c[e>>2]|0;i=d;return j|0}else h=3;while(0);do if((h|0)==3){if((((((((((((((((!((c[g>>2]|0)>=97&(c[g>>2]|0)<=122)?!((c[g>>2]|0)>=65&(c[g>>2]|0)<=90):0)?!((c[g>>2]|0)>=48&(c[g>>2]|0)<=57|(c[g>>2]|0)==95|(c[g>>2]|0)==58|(c[g>>2]|0)==45|(c[g>>2]|0)==46|(c[g>>2]|0)==183):0)?!((c[g>>2]|0)>=192&(c[g>>2]|0)<=214):0)?!((c[g>>2]|0)>=216&(c[g>>2]|0)<=246):0)?!((c[g>>2]|0)>=248&(c[g>>2]|0)<=767):0)?!((c[g>>2]|0)>=768&(c[g>>2]|0)<=879):0)?!((c[g>>2]|0)>=880&(c[g>>2]|0)<=893):0)?!((c[g>>2]|0)>=895&(c[g>>2]|0)<=8191):0)?!((c[g>>2]|0)>=8204&(c[g>>2]|0)<=8205):0)?!((c[g>>2]|0)>=8255&(c[g>>2]|0)<=8256):0)?!((c[g>>2]|0)>=8304&(c[g>>2]|0)<=8591):0)?!((c[g>>2]|0)>=11264&(c[g>>2]|0)<=12271):0)?!((c[g>>2]|0)>=12289&(c[g>>2]|0)<=55295):0)?!((c[g>>2]|0)>=63744&(c[g>>2]|0)<=64975):0)?!((c[g>>2]|0)>=65008&(c[g>>2]|0)<=65533):0)?!((c[g>>2]|0)>=65536&(c[g>>2]|0)<=983039):0)break;c[e>>2]=1;j=c[e>>2]|0;i=d;return j|0}while(0);c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}function Xn(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if((c[(c[f>>2]|0)+20>>2]|0)<=0?(c[(c[f>>2]|0)+20>>2]=4,b=Cb[c[135744>>2]&511](c[(c[f>>2]|0)+20>>2]<<2)|0,c[(c[f>>2]|0)+24>>2]=b,(c[(c[f>>2]|0)+24>>2]|0)==0):0){ln(c[f>>2]|0,79472);c[(c[f>>2]|0)+20>>2]=0;c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}do if((c[(c[f>>2]|0)+16>>2]|0)>=(c[(c[f>>2]|0)+20>>2]|0)){c[h>>2]=Hb[c[135760>>2]&511](c[(c[f>>2]|0)+24>>2]|0,c[(c[f>>2]|0)+20>>2]<<1<<2)|0;b=c[f>>2]|0;if(c[h>>2]|0){a=b+20|0;c[a>>2]=c[a>>2]<<1;c[(c[f>>2]|0)+24>>2]=c[h>>2];break}ln(b,85184);c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}while(0);c[(c[(c[f>>2]|0)+24>>2]|0)+(c[(c[f>>2]|0)+16>>2]<<2)>>2]=c[g>>2];c[(c[f>>2]|0)+12>>2]=c[g>>2];g=(c[f>>2]|0)+16|0;f=c[g>>2]|0;c[g>>2]=f+1;c[e>>2]=f;j=c[e>>2]|0;i=d;return j|0}function Yn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if((c[(c[e>>2]|0)+16>>2]|0)<=0){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}a=(c[e>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+-1;a=c[e>>2]|0;if((c[(c[e>>2]|0)+16>>2]|0)>0)c[(c[e>>2]|0)+12>>2]=c[(c[(c[e>>2]|0)+24>>2]|0)+((c[a+16>>2]|0)-1<<2)>>2];else c[a+12>>2]=0;c[f>>2]=c[(c[(c[e>>2]|0)+24>>2]|0)+(c[(c[e>>2]|0)+16>>2]<<2)>>2];c[(c[(c[e>>2]|0)+24>>2]|0)+(c[(c[e>>2]|0)+16>>2]<<2)>>2]=0;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}function Zn(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=f;if(!(c[k>>2]|0)){i=g;return}if(c[l>>2]|0)_T(c[h>>2]|0,79632)|0;c[m>>2]=c[k>>2];a:while(1){if(!(c[m>>2]|0)){o=30;break}c[n>>2]=ZT(c[h>>2]|0)|0;if(((c[j>>2]|0)-(c[n>>2]|0)|0)<50){o=7;break}switch(c[(c[m>>2]|0)+4>>2]|0){case 3:{if(!(ij(c[m>>2]|0)|0))o=25;break}case 1:{if((c[(c[m>>2]|0)+36>>2]|0)!=0?(c[(c[(c[m>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){k=(c[j>>2]|0)-(c[n>>2]|0)|0;if((k|0)<((xy(c[(c[(c[m>>2]|0)+36>>2]|0)+12>>2]|0)|0)+10|0)){o=14;break a}_T(c[h>>2]|0,c[(c[(c[m>>2]|0)+36>>2]|0)+12>>2]|0)|0;_T(c[h>>2]|0,79648)|0}if(((c[j>>2]|0)-(c[n>>2]|0)|0)<((xy(c[(c[m>>2]|0)+8>>2]|0)|0)+10|0)){o=19;break a}_T(c[h>>2]|0,c[(c[m>>2]|0)+8>>2]|0)|0;if(c[(c[m>>2]|0)+24>>2]|0)_T(c[h>>2]|0,80064)|0;break}case 18:case 12:case 11:case 10:case 13:case 21:case 9:case 2:{_T(c[h>>2]|0,85176)|0;if(c[(c[m>>2]|0)+24>>2]|0)_T(c[h>>2]|0,80064)|0;break}case 5:case 4:{o=25;break}default:{}}if((o|0)==25?(o=0,_T(c[h>>2]|0,85168)|0,(c[(c[m>>2]|0)+24>>2]|0)!=0):0)_T(c[h>>2]|0,80064)|0;c[m>>2]=c[(c[m>>2]|0)+24>>2]}if((o|0)==7){if(((c[j>>2]|0)-(c[n>>2]|0)|0)<=4){i=g;return}if((a[(c[h>>2]|0)+((c[n>>2]|0)-1)>>0]|0)==46){i=g;return}_T(c[h>>2]|0,79624)|0;i=g;return}else if((o|0)==14){if(((c[j>>2]|0)-(c[n>>2]|0)|0)<=4){i=g;return}if((a[(c[h>>2]|0)+((c[n>>2]|0)-1)>>0]|0)==46){i=g;return}_T(c[h>>2]|0,79624)|0;i=g;return}else if((o|0)==19){if(((c[j>>2]|0)-(c[n>>2]|0)|0)<=4){i=g;return}if((a[(c[h>>2]|0)+((c[n>>2]|0)-1)>>0]|0)==46){i=g;return}_T(c[h>>2]|0,79624)|0;i=g;return}else if((o|0)==30){if(!(c[l>>2]|0)){i=g;return}_T(c[h>>2]|0,79672)|0;i=g;return}}function _n(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=c[f>>2];$n(c[e>>2]|0,c[c[g>>2]>>2]|0,c[(c[g>>2]|0)+4>>2]|0);i=d;return 1}function $n(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;i=i+48|0;h=g+40|0;j=g+36|0;k=g+32|0;l=g+28|0;m=g+24|0;n=g+20|0;o=g+16|0;p=g+12|0;q=g+45|0;r=g+8|0;s=g+4|0;t=g;u=g+44|0;c[h>>2]=b;c[j>>2]=e;c[k>>2]=f;if(!(c[h>>2]|0)){i=g;return}if((c[(c[h>>2]|0)+8>>2]|0)==0?(c[(c[h>>2]|0)+12>>2]|0)==0:0){i=g;return}c[m>>2]=c[(c[h>>2]|0)+8>>2];if(!(c[m>>2]|0)){c[o>>2]=0;c[n>>2]=my(c[k>>2]|0)|0;if(!(c[n>>2]|0)){c[(c[j>>2]|0)+36>>2]=0;i=g;return}c[p>>2]=c[n>>2];a:while(1){if(!(d[c[p>>2]>>0]|0))break;c[o>>2]=c[p>>2];while(1){if(d[c[p>>2]>>0]|0){do if((d[c[p>>2]>>0]|0|0)==32)v=1;else{if(9<=(d[c[p>>2]>>0]|0|0)?(d[c[p>>2]>>0]|0|0)<=10:0){v=1;break}v=(d[c[p>>2]>>0]|0|0)==13}while(0);w=v^1}else w=0;x=c[p>>2]|0;if(!w)break;c[p>>2]=x+1}a[q>>0]=a[x>>0]|0;a[c[p>>2]>>0]=0;c[l>>2]=Hm(c[(c[j>>2]|0)+32>>2]|0,c[o>>2]|0)|0;if(!(c[l>>2]|0)){Jn(c[j>>2]|0,0,536,84752,c[(c[h>>2]|0)+12>>2]|0,c[(c[h>>2]|0)+16>>2]|0,c[o>>2]|0);c[(c[j>>2]|0)+36>>2]=0}if(!(d[q>>0]|0))break;a[c[p>>2]>>0]=a[q>>0]|0;while(1){do if((d[c[p>>2]>>0]|0|0)!=32){if(9<=(d[c[p>>2]>>0]|0|0)?(d[c[p>>2]>>0]|0|0)<=10:0)break;if((d[c[p>>2]>>0]|0|0)!=13)continue a}while(0);c[p>>2]=(c[p>>2]|0)+1}}zb[c[135736>>2]&511](c[n>>2]|0);i=g;return}if((c[(c[m>>2]|0)+40>>2]|0)==3){c[l>>2]=Hm(c[(c[j>>2]|0)+32>>2]|0,c[k>>2]|0)|0;if(c[l>>2]|0){i=g;return}jn(c[j>>2]|0,c[(c[m>>2]|0)+20>>2]|0,536,84808,c[(c[m>>2]|0)+8>>2]|0,c[k>>2]|0,0);c[(c[j>>2]|0)+36>>2]=0;i=g;return}if((c[(c[m>>2]|0)+40>>2]|0)!=4){i=g;return}c[s>>2]=0;c[r>>2]=my(c[k>>2]|0)|0;if(!(c[r>>2]|0)){ln(c[j>>2]|0,84864);c[(c[j>>2]|0)+36>>2]=0;i=g;return}c[t>>2]=c[r>>2];b:while(1){if(!(d[c[t>>2]>>0]|0))break;c[s>>2]=c[t>>2];while(1){if(d[c[t>>2]>>0]|0){do if((d[c[t>>2]>>0]|0|0)==32)y=1;else{if(9<=(d[c[t>>2]>>0]|0|0)?(d[c[t>>2]>>0]|0|0)<=10:0){y=1;break}y=(d[c[t>>2]>>0]|0|0)==13}while(0);z=y^1}else z=0;A=c[t>>2]|0;if(!z)break;c[t>>2]=A+1}a[u>>0]=a[A>>0]|0;a[c[t>>2]>>0]=0;c[l>>2]=Hm(c[(c[j>>2]|0)+32>>2]|0,c[s>>2]|0)|0;if(!(c[l>>2]|0)){jn(c[j>>2]|0,c[(c[m>>2]|0)+20>>2]|0,536,84880,c[(c[m>>2]|0)+8>>2]|0,c[s>>2]|0,0);c[(c[j>>2]|0)+36>>2]=0}if(!(d[u>>0]|0))break;a[c[t>>2]>>0]=a[u>>0]|0;while(1){do if((d[c[t>>2]>>0]|0|0)!=32){if(9<=(d[c[t>>2]>>0]|0|0)?(d[c[t>>2]>>0]|0|0)<=10:0)break;if((d[c[t>>2]>>0]|0|0)!=13)continue b}while(0);c[t>>2]=(c[t>>2]|0)+1}}zb[c[135736>>2]&511](c[r>>2]|0);i=g;return}function ao(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=0;if(c[21466]|0){i=a;return}c[b>>2]=0;while(1){if((c[b>>2]|0)>=100)break;c[85872+(c[b>>2]<<2)>>2]=0;c[b>>2]=(c[b>>2]|0)+1}c[b>>2]=0;a:while(1){if(!((c[b>>2]|0)<99?(c[86272+(c[d>>2]<<2)>>2]|0)!=0:0))break;e=86272+(c[d>>2]<<2)|0;f=c[b>>2]|0;c[b>>2]=f+1;c[85872+(f<<2)>>2]=e;while(1){e=(c[86272+(c[d>>2]<<2)>>2]|0)!=0;c[d>>2]=(c[d>>2]|0)+1;if(!e)continue a}}c[21466]=1;i=a;return}function bo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=0;while(1){if((c[f>>2]|0)>>>0>=92){g=6;break}a=(ty(c[e>>2]|0,c[87848+((c[f>>2]|0)*36|0)>>2]|0)|0)!=0;h=c[f>>2]|0;if(!a){g=4;break}c[f>>2]=h+1}if((g|0)==4){c[d>>2]=87848+(h*36|0);j=c[d>>2]|0;i=b;return j|0}else if((g|0)==6){c[d>>2]=0;j=c[d>>2]|0;i=b;return j|0}return 0}function co(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=0;while(1){if((c[f>>2]|0)>>>0>=253){g=6;break}a=(qy(c[e>>2]|0,c[91164+((c[f>>2]|0)*12|0)>>2]|0)|0)!=0;h=c[f>>2]|0;if(a){g=4;break}c[f>>2]=h+1}if((g|0)==4){c[d>>2]=91160+(h*12|0);j=c[d>>2]|0;i=b;return j|0}else if((g|0)==6){c[d>>2]=0;j=c[d>>2]|0;i=b;return j|0}return 0}function eo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=0;while(1){if((c[f>>2]|0)>>>0>=253)break;g=c[f>>2]|0;if((c[91160+((c[f>>2]|0)*12|0)>>2]|0)>>>0>=(c[e>>2]|0)>>>0){h=4;break}c[f>>2]=g+1}if((h|0)==4?(c[91160+(g*12|0)>>2]|0)>>>0<=(c[e>>2]|0)>>>0:0){c[d>>2]=91160+((c[f>>2]|0)*12|0);j=c[d>>2]|0;i=b;return j|0}c[d>>2]=0;j=c[d>>2]|0;i=b;return j|0}function fo(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;i=i+96|0;j=h;k=h+64|0;l=h+60|0;m=h+56|0;n=h+52|0;o=h+48|0;p=h+44|0;q=h+40|0;r=h+36|0;s=h+32|0;t=h+28|0;u=h+24|0;v=h+20|0;w=h+16|0;x=h+12|0;y=h+8|0;z=h+4|0;A=h+72|0;c[l>>2]=b;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[p>>2]=c[n>>2];c[r>>2]=c[l>>2];c[s>>2]=c[n>>2];if((c[l>>2]|0)==0|(c[m>>2]|0)==0|(c[o>>2]|0)==0){c[k>>2]=-1;B=c[k>>2]|0;i=h;return B|0}if(!(c[n>>2]|0)){c[c[m>>2]>>2]=0;c[c[o>>2]>>2]=0;c[k>>2]=0;B=c[k>>2]|0;i=h;return B|0}c[t>>2]=(c[n>>2]|0)+(c[c[o>>2]>>2]|0);c[q>>2]=(c[l>>2]|0)+(c[c[m>>2]>>2]|0);a:while(1){if((c[n>>2]|0)>>>0>=(c[t>>2]|0)>>>0){C=32;break}g=c[n>>2]|0;c[n>>2]=g+1;c[v>>2]=d[g>>0];g=c[v>>2]|0;do if((c[v>>2]|0)>>>0<128){c[u>>2]=g;c[w>>2]=0}else{if(g>>>0<192){C=10;break a}f=c[v>>2]|0;if((c[v>>2]|0)>>>0<224){c[u>>2]=f&31;c[w>>2]=1;break}e=c[v>>2]|0;if(f>>>0<240){c[u>>2]=e&15;c[w>>2]=2;break}if(e>>>0>=248){C=17;break a}c[u>>2]=c[v>>2]&7;c[w>>2]=3}while(0);if(((c[t>>2]|0)-(c[n>>2]|0)|0)<(c[w>>2]|0)){C=32;break}while(1){if(!(c[w>>2]|0))break;if((c[n>>2]|0)>>>0>=(c[t>>2]|0)>>>0)break;g=c[n>>2]|0;c[n>>2]=g+1;e=d[g>>0]|0;c[v>>2]=e;if((e&192|0)!=128)break;c[u>>2]=c[u>>2]<<6;c[u>>2]=c[u>>2]|c[v>>2]&63;c[w>>2]=(c[w>>2]|0)+-1}if((c[u>>2]|0)>>>0<128){if(((c[l>>2]|0)+1|0)>>>0>=(c[q>>2]|0)>>>0){C=32;break}e=c[u>>2]&255;g=c[l>>2]|0;c[l>>2]=g+1;a[g>>0]=e}else{c[y>>2]=eo(c[u>>2]|0)|0;if(!(c[y>>2]|0)){c[j>>2]=c[u>>2];JT(A,16,94200,j)|0;c[z>>2]=A}else c[z>>2]=c[(c[y>>2]|0)+4>>2];c[x>>2]=ZT(c[z>>2]|0)|0;if(((c[l>>2]|0)+2+(c[x>>2]|0)|0)>>>0>=(c[q>>2]|0)>>>0){C=32;break}e=c[l>>2]|0;c[l>>2]=e+1;a[e>>0]=38;eU(c[l>>2]|0,c[z>>2]|0,c[x>>2]|0)|0;c[l>>2]=(c[l>>2]|0)+(c[x>>2]|0);e=c[l>>2]|0;c[l>>2]=e+1;a[e>>0]=59}c[p>>2]=c[n>>2]}if((C|0)==10){c[c[m>>2]>>2]=(c[l>>2]|0)-(c[r>>2]|0);c[c[o>>2]>>2]=(c[p>>2]|0)-(c[s>>2]|0);c[k>>2]=-2;B=c[k>>2]|0;i=h;return B|0}else if((C|0)==17){c[c[m>>2]>>2]=(c[l>>2]|0)-(c[r>>2]|0);c[c[o>>2]>>2]=(c[p>>2]|0)-(c[s>>2]|0);c[k>>2]=-2;B=c[k>>2]|0;i=h;return B|0}else if((C|0)==32){c[c[m>>2]>>2]=(c[l>>2]|0)-(c[r>>2]|0);c[c[o>>2]>>2]=(c[p>>2]|0)-(c[s>>2]|0);c[k>>2]=0;B=c[k>>2]|0;i=h;return B|0}return 0}function go(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=Cb[c[135744>>2]&511](96)|0;if(!(c[h>>2]|0)){xo(0,94208);c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}b=(c[h>>2]|0)+0|0;a=b+96|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(a|0));c[(c[h>>2]|0)+4>>2]=13;c[(c[h>>2]|0)+56>>2]=0;c[(c[h>>2]|0)+44>>2]=0;c[(c[h>>2]|0)+32>>2]=c[h>>2];c[(c[h>>2]|0)+8>>2]=0;c[(c[h>>2]|0)+12>>2]=0;c[(c[h>>2]|0)+48>>2]=0;c[(c[h>>2]|0)+52>>2]=0;c[(c[h>>2]|0)+60>>2]=0;c[(c[h>>2]|0)+40>>2]=1;c[(c[h>>2]|0)+36>>2]=0;c[(c[h>>2]|0)+64>>2]=0;c[(c[h>>2]|0)+68>>2]=0;c[c[h>>2]>>2]=0;c[(c[h>>2]|0)+76>>2]=1;c[(c[h>>2]|0)+92>>2]=160;if((c[g>>2]|0)!=0|(c[f>>2]|0)!=0)Oh(c[h>>2]|0,94240,c[g>>2]|0,c[f>>2]|0)|0;c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}function ho(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[k>>2]=0;if(c[h>>2]|0)c[c[h>>2]>>2]=0;if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+36>>2]|0)!=0:0){do if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==38){me(c[g>>2]|0);c[j>>2]=yo(c[g>>2]|0)|0;b=c[g>>2]|0;if(!(c[j>>2]|0)){zo(b,68,94336,0,0);break}if((c[b+292>>2]|0)==0?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)ke(c[(c[g>>2]|0)+36>>2]|0,250)|0;if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=59){zo(c[g>>2]|0,23,94368,0,0);if(!(c[h>>2]|0))break;c[c[h>>2]>>2]=c[j>>2];break}if(c[h>>2]|0)c[c[h>>2]>>2]=c[j>>2];c[k>>2]=co(c[j>>2]|0)|0;if(c[k>>2]|0)me(c[g>>2]|0)}while(0);c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}function io(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;e=b+8|0;f=b+4|0;g=b;c[f>>2]=a;c[g>>2]=0;if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+36>>2]|0)!=0:0){do if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==38?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==35:0){if((d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)!=120?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)!=88:0){h=23;break}a=(c[f>>2]|0)+200|0;c[a>>2]=(c[a>>2]|0)+3;a=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+3;a=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[a>>2]=(c[a>>2]|0)+3;a:while(1){if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==59)break;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)>=48?(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=57:0)c[g>>2]=(c[g>>2]<<4)+((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0)-48);else h=13;do if((h|0)==13){h=0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)>=97?(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=102:0){c[g>>2]=(c[g>>2]<<4)+((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0)-97)+10;break}if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<65){h=19;break a}if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)>70){h=19;break a}c[g>>2]=(c[g>>2]<<4)+((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0)-65)+10}while(0);me(c[f>>2]|0)}if((h|0)==19)zo(c[f>>2]|0,6,94448,0,0);if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==59)me(c[f>>2]|0)}else h=23;while(0);do if((h|0)==23){if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==38?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==35:0){a=(c[f>>2]|0)+200|0;c[a>>2]=(c[a>>2]|0)+2;a=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+2;a=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[a>>2]=(c[a>>2]|0)+2;while(1){if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==59)break;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<48){h=30;break}if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)>57){h=30;break}c[g>>2]=((c[g>>2]|0)*10|0)+((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0)-48);me(c[f>>2]|0)}if((h|0)==30)zo(c[f>>2]|0,7,94448,0,0);if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=59)break;me(c[f>>2]|0);break}zo(c[f>>2]|0,8,94488,0,0)}while(0);a=c[g>>2]|0;if((c[g>>2]|0)<256)if(9<=(a|0)&(c[g>>2]|0)<=10|(c[g>>2]|0)==13|32<=(c[g>>2]|0))h=39;else h=40;else if((!(256<=(a|0)&(c[g>>2]|0)<=55295)?!(57344<=(c[g>>2]|0)&(c[g>>2]|0)<=65533):0)?!(65536<=(c[g>>2]|0)&(c[g>>2]|0)<=1114111):0)h=40;else h=39;if((h|0)==39){c[e>>2]=c[g>>2];j=c[e>>2]|0;i=b;return j|0}else if((h|0)==40){Ao(c[f>>2]|0,9,94528,c[g>>2]|0);c[e>>2]=0;j=c[e>>2]|0;i=b;return j|0}}zo(c[f>>2]|0,1,94408,0,0);c[e>>2]=0;j=c[e>>2]|0;i=b;return j|0}function jo(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}Eo(c[d>>2]|0);i=b;return}function ko(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+32|0;f=e+12|0;g=e+8|0;h=e+16|0;j=e+4|0;k=e;c[g>>2]=b;Rf();rQ();if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+36>>2]|0)!=0:0){c[(c[g>>2]|0)+32>>2]=1;c[(c[g>>2]|0)+280>>2]=1;if((c[(c[g>>2]|0)+292>>2]|0)==0?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)ke(c[(c[g>>2]|0)+36>>2]|0,250)|0;if((c[c[g>>2]>>2]|0)!=0?(c[(c[c[g>>2]>>2]|0)+44>>2]|0)!=0:0)Ab[c[(c[c[g>>2]>>2]|0)+44>>2]&511](c[(c[g>>2]|0)+4>>2]|0,136080);if((c[(c[g>>2]|0)+24>>2]|0)==0?((c[(c[(c[g>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=4:0){if(c[(c[g>>2]|0)+176>>2]|0)l=-1;else l=d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0;a[h>>0]=l;a[h+1>>0]=a[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0;a[h+2>>0]=a[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0;a[h+3>>0]=a[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0;c[j>>2]=sd(h,4)|0;if(c[j>>2]|0)re(c[g>>2]|0,c[j>>2]|0)|0}Fo(c[g>>2]|0)|0;if(!(d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0))zo(c[g>>2]|0,4,94672,0,0);if(((c[c[g>>2]>>2]|0)!=0?(c[(c[c[g>>2]>>2]|0)+48>>2]|0)!=0:0)?(c[(c[g>>2]|0)+212>>2]|0)==0:0)zb[c[(c[c[g>>2]>>2]|0)+48>>2]&511](c[(c[g>>2]|0)+4>>2]|0);while(1){if((((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==33:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==45:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==45:0)m=1;else if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60)m=(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==63;else m=0;n=c[g>>2]|0;if(!m)break;Go(n);Ho(c[g>>2]|0);Fo(c[g>>2]|0)|0}if(((((((((d[c[(c[n+36>>2]|0)+16>>2]>>0]|0|0)==60?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==33:0)?(WS(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0)|0)==68:0)?(WS(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0)|0)==79:0)?(WS(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0)|0)==67:0)?(WS(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0)|0)==84:0)?(WS(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0)|0)==89:0)?(WS(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0)|0)==80:0)?(WS(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+8>>0]|0)|0)==69:0)Io(c[g>>2]|0);Fo(c[g>>2]|0)|0;while(1){if((((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==33:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==45:0)?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==45:0)o=1;else if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60)o=(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==63;else o=0;p=c[g>>2]|0;if(!o)break;Go(p);Ho(c[g>>2]|0);Fo(c[g>>2]|0)|0}Eo(p);if(!(d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0))Do(c[g>>2]|0);if((c[c[g>>2]>>2]|0)!=0?(c[(c[c[g>>2]>>2]|0)+52>>2]|0)!=0:0)zb[c[(c[c[g>>2]>>2]|0)+52>>2]&511](c[(c[g>>2]|0)+4>>2]|0);if(((c[(c[g>>2]|0)+360>>2]&4|0)==0?(c[(c[g>>2]|0)+8>>2]|0)!=0:0)?(c[k>>2]=Nh(c[(c[g>>2]|0)+8>>2]|0)|0,(c[k>>2]|0)==0):0){k=Oh(c[(c[g>>2]|0)+8>>2]|0,94240,94296,94248)|0;c[(c[(c[g>>2]|0)+8>>2]|0)+44>>2]=k}if(c[(c[g>>2]|0)+12>>2]|0){c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}else{c[f>>2]=-1;q=c[f>>2]|0;i=e;return q|0}}zo(c[g>>2]|0,1,94632,0,0);c[f>>2]=1;q=c[f>>2]|0;i=e;return q|0}function lo(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;Ae(c[d>>2]|0);i=b;return}function mo(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=Cb[c[135744>>2]&511](472)|0;do if(c[d>>2]|0){cU(c[d>>2]|0,0,472)|0;e=(Jo(c[d>>2]|0)|0)<0;f=c[d>>2]|0;if(e){lo(f);c[b>>2]=0;break}else{c[b>>2]=f;break}}else{xo(0,94696);c[b>>2]=0}while(0);i=a;return c[b>>2]|0}function no(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;do if(c[f>>2]|0){if((c[g>>2]|0)<=0){c[e>>2]=0;break}c[h>>2]=mo()|0;if(!(c[h>>2]|0)){c[e>>2]=0;break}c[k>>2]=Hk(c[f>>2]|0,c[g>>2]|0,0)|0;if(!(c[k>>2]|0)){c[e>>2]=0;break}c[j>>2]=ue(c[h>>2]|0)|0;if(!(c[j>>2]|0)){Ae(c[h>>2]|0);c[e>>2]=0;break}else{c[(c[j>>2]|0)+4>>2]=0;c[c[j>>2]>>2]=c[k>>2];iz(c[(c[k>>2]|0)+16>>2]|0,c[j>>2]|0)|0;Oe(c[h>>2]|0,c[j>>2]|0)|0;c[e>>2]=c[h>>2];break}}else c[e>>2]=0;while(0);i=d;return c[e>>2]|0}function oo(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+48|0;g=f+44|0;h=f+40|0;j=f+36|0;k=f+32|0;l=f+28|0;m=f+24|0;n=f+20|0;o=f+16|0;p=f+12|0;q=f+8|0;r=f+4|0;s=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+36>>2]|0)!=0:0){do if((((c[k>>2]|0)>0&(c[j>>2]|0)!=0?(c[(c[h>>2]|0)+36>>2]|0)!=0:0)?(c[c[(c[h>>2]|0)+36>>2]>>2]|0)!=0:0)?(c[(c[h>>2]|0)+172>>2]|0)!=-1:0){c[m>>2]=jz(c[(c[c[(c[h>>2]|0)+36>>2]>>2]|0)+16>>2]|0,c[(c[h>>2]|0)+36>>2]|0)|0;c[n>>2]=(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[h>>2]|0)+36>>2]|0)+12>>2]|0);c[o>>2]=Lk(c[c[(c[h>>2]|0)+36>>2]>>2]|0,c[k>>2]|0,c[j>>2]|0)|0;e=c[h>>2]|0;if((c[o>>2]|0)>=0){kz(c[(c[c[e+36>>2]>>2]|0)+16>>2]|0,c[(c[h>>2]|0)+36>>2]|0,c[m>>2]|0,c[n>>2]|0)|0;break}c[e+84>>2]=-1;c[(c[h>>2]|0)+212>>2]=1;c[g>>2]=-1;t=c[g>>2]|0;i=f;return t|0}else u=11;while(0);do if(((((((u|0)==11?(c[(c[h>>2]|0)+172>>2]|0)!=-1:0)?(c[(c[h>>2]|0)+36>>2]|0)!=0:0)?(c[c[(c[h>>2]|0)+36>>2]>>2]|0)!=0:0)?(c[p>>2]=c[c[(c[h>>2]|0)+36>>2]>>2],(c[(c[p>>2]|0)+12>>2]|0)!=0):0)?(c[(c[p>>2]|0)+16>>2]|0)!=0:0)?(c[(c[p>>2]|0)+20>>2]|0)!=0:0){c[r>>2]=jz(c[(c[p>>2]|0)+16>>2]|0,c[(c[h>>2]|0)+36>>2]|0)|0;c[s>>2]=(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[h>>2]|0)+36>>2]|0)+12>>2]|0);c[q>>2]=Fd(c[p>>2]|0,c[l>>2]|0)|0;if((c[q>>2]|0)>=0){kz(c[(c[p>>2]|0)+16>>2]|0,c[(c[h>>2]|0)+36>>2]|0,c[r>>2]|0,c[s>>2]|0)|0;break}zo(c[h>>2]|0,81,94760,0,0);c[g>>2]=81;t=c[g>>2]|0;i=f;return t|0}while(0);Ko(c[h>>2]|0,c[l>>2]|0)|0;if(c[l>>2]|0){if(((c[(c[h>>2]|0)+172>>2]|0)!=-1?(c[(c[h>>2]|0)+172>>2]|0)!=14:0)?(c[(c[h>>2]|0)+172>>2]|0)!=1:0){c[(c[h>>2]|0)+84>>2]=5;c[(c[h>>2]|0)+12>>2]=0}if(((c[(c[h>>2]|0)+172>>2]|0)!=-1?(c[c[h>>2]>>2]|0)!=0:0)?(c[(c[c[h>>2]>>2]|0)+52>>2]|0)!=0:0)zb[c[(c[c[h>>2]>>2]|0)+52>>2]&511](c[(c[h>>2]|0)+4>>2]|0);c[(c[h>>2]|0)+172>>2]=-1}c[g>>2]=c[(c[h>>2]|0)+84>>2];t=c[g>>2]|0;i=f;return t|0}zo(c[h>>2]|0,1,94728,0,0);c[g>>2]=1;t=c[g>>2]|0;i=f;return t|0}function po(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;h=i;i=i+48|0;j=h+44|0;k=h+40|0;l=h+36|0;m=h+32|0;n=h+28|0;o=h+24|0;p=h+20|0;q=h+16|0;r=h+12|0;s=h+8|0;t=h+4|0;u=h;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;Rf();c[s>>2]=vk(c[p>>2]|0)|0;if(!(c[s>>2]|0)){c[j>>2]=0;v=c[j>>2]|0;i=h;return v|0}c[q>>2]=mo()|0;if(!(c[q>>2]|0)){yk(c[s>>2]|0);c[j>>2]=0;v=c[j>>2]|0;i=h;return v|0}if(!((c[p>>2]|0)!=1?(c[(c[s>>2]|0)+12>>2]|0)==0:0))c[(c[q>>2]|0)+256>>2]=1;do if(c[k>>2]|0){if((c[c[q>>2]>>2]|0)!=136096)zb[c[135736>>2]&511](c[c[q>>2]>>2]|0);p=Cb[c[135744>>2]&511](128)|0;c[c[q>>2]>>2]=p;if(!(c[c[q>>2]>>2]|0)){zb[c[135736>>2]&511](c[s>>2]|0);zb[c[135736>>2]&511](c[q>>2]|0);c[j>>2]=0;v=c[j>>2]|0;i=h;return v|0}else{p=(c[c[q>>2]>>2]|0)+0|0;g=(c[k>>2]|0)+0|0;f=p+128|0;do{c[p>>2]=c[g>>2];p=p+4|0;g=g+4|0}while((p|0)<(f|0));if(!(c[l>>2]|0))break;c[(c[q>>2]|0)+4>>2]=c[l>>2];break}}while(0);if(!(c[o>>2]|0))c[(c[q>>2]|0)+180>>2]=0;else{l=Rk(c[o>>2]|0)|0;c[(c[q>>2]|0)+180>>2]=l}c[r>>2]=Lo(c[q>>2]|0)|0;if(!(c[r>>2]|0)){Ae(c[q>>2]|0);zb[c[135736>>2]&511](c[s>>2]|0);c[j>>2]=0;v=c[j>>2]|0;i=h;return v|0}if(!(c[o>>2]|0))c[(c[r>>2]|0)+4>>2]=0;else{l=Jl(c[o>>2]|0)|0;c[(c[r>>2]|0)+4>>2]=l}c[c[r>>2]>>2]=c[s>>2];iz(c[(c[s>>2]|0)+16>>2]|0,c[r>>2]|0)|0;Oe(c[q>>2]|0,c[r>>2]|0)|0;if(((c[n>>2]|0)>0&(c[m>>2]|0)!=0?(c[(c[q>>2]|0)+36>>2]|0)!=0:0)?(c[c[(c[q>>2]|0)+36>>2]>>2]|0)!=0:0){c[t>>2]=jz(c[(c[c[(c[q>>2]|0)+36>>2]>>2]|0)+16>>2]|0,c[(c[q>>2]|0)+36>>2]|0)|0;c[u>>2]=(c[(c[(c[q>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[q>>2]|0)+36>>2]|0)+12>>2]|0);Lk(c[c[(c[q>>2]|0)+36>>2]>>2]|0,c[n>>2]|0,c[m>>2]|0)|0;kz(c[(c[c[(c[q>>2]|0)+36>>2]>>2]|0)+16>>2]|0,c[(c[q>>2]|0)+36>>2]|0,c[t>>2]|0,c[u>>2]|0)|0}c[(c[q>>2]|0)+292>>2]=1;c[j>>2]=c[q>>2];v=c[j>>2]|0;i=h;return v|0}function qo(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+48|0;e=d;f=d+36|0;g=d+32|0;h=d+28|0;j=d+24|0;k=d+20|0;l=d+16|0;m=d+12|0;n=d+8|0;o=d+4|0;c[g>>2]=a;c[h>>2]=b;c[n>>2]=94776;if(!(c[g>>2]|0)){c[f>>2]=0;p=c[f>>2]|0;i=d;return p|0}c[j>>2]=mo()|0;if(!(c[j>>2]|0)){c[f>>2]=0;p=c[f>>2]|0;i=d;return p|0}c[l>>2]=Jl(c[g>>2]|0)|0;if(!(c[l>>2]|0)){if(c[34014]|0)Db[c[135968+88>>2]&511](0,94792,e);Ae(c[j>>2]|0);c[f>>2]=0;p=c[f>>2]|0;i=d;return p|0}c[k>>2]=Vk(c[l>>2]|0,0,c[j>>2]|0)|0;zb[c[135736>>2]&511](c[l>>2]|0);l=c[j>>2]|0;if(!(c[k>>2]|0)){Ae(l);c[f>>2]=0;p=c[f>>2]|0;i=d;return p|0}Oe(l,c[k>>2]|0)|0;if(((c[h>>2]|0)!=0?(c[o>>2]=ZT(c[h>>2]|0)|0,(c[o>>2]|0)>>>0<1e3):0)?(k=c[33938]|0,l=xy(c[n>>2]|0)|0,c[m>>2]=Cb[k&511](l+(c[o>>2]|0)+1|0)|0,(c[m>>2]|0)!=0):0){gU(c[m>>2]|0,c[n>>2]|0)|0;_T(c[m>>2]|0,c[h>>2]|0)|0;Mo(c[j>>2]|0,c[m>>2]|0);zb[c[135736>>2]&511](c[m>>2]|0)}c[f>>2]=c[j>>2];p=c[f>>2]|0;i=d;return p|0}function ro(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f+28|0;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f+4|0;o=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[o>>2]=0;Rf();c[n>>2]=qo(c[h>>2]|0,c[j>>2]|0)|0;if(!(c[n>>2]|0)){c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}if(c[k>>2]|0){c[o>>2]=c[c[n>>2]>>2];c[c[n>>2]>>2]=c[k>>2];c[(c[n>>2]|0)+4>>2]=c[l>>2]}ko(c[n>>2]|0)|0;c[m>>2]=c[(c[n>>2]|0)+8>>2];if(c[k>>2]|0){c[c[n>>2]>>2]=c[o>>2];c[(c[n>>2]|0)+4>>2]=0}lo(c[n>>2]|0);c[g>>2]=c[m>>2];p=c[g>>2]|0;i=f;return p|0}function so(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=ro(c[e>>2]|0,c[f>>2]|0,0,0)|0;i=d;return b|0}function to(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if(!(c[f>>2]|0)){c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}if(c[g>>2]&64){c[(c[c[f>>2]>>2]|0)+84>>2]=0;c[(c[f>>2]|0)+116>>2]=0;c[g>>2]=(c[g>>2]|0)-64;b=(c[f>>2]|0)+360|0;c[b>>2]=c[b>>2]|64}if(c[g>>2]&32){c[(c[c[f>>2]>>2]|0)+88>>2]=0;c[(c[f>>2]|0)+112>>2]=0;c[(c[c[f>>2]>>2]|0)+92>>2]=0;c[g>>2]=(c[g>>2]|0)-32;b=(c[f>>2]|0)+360|0;c[b>>2]=c[b>>2]|32}b=(c[f>>2]|0)+268|0;if(c[g>>2]&128){c[b>>2]=1;c[g>>2]=(c[g>>2]|0)-128;a=(c[f>>2]|0)+360|0;c[a>>2]=c[a>>2]|128}else c[b>>2]=0;b=(c[f>>2]|0)+208|0;if(c[g>>2]&256){c[b>>2]=0;c[(c[c[f>>2]>>2]|0)+72>>2]=65;c[g>>2]=(c[g>>2]|0)-256;a=(c[f>>2]|0)+360|0;c[a>>2]=c[a>>2]|256}else c[b>>2]=1;b=(c[f>>2]|0)+288|0;if(c[g>>2]&1){c[b>>2]=1;c[g>>2]=(c[g>>2]|0)-1}else c[b>>2]=0;if(c[g>>2]&65536){b=(c[f>>2]|0)+360|0;c[b>>2]=c[b>>2]|65536;c[g>>2]=(c[g>>2]|0)-65536}if(c[g>>2]&524288){b=(c[f>>2]|0)+360|0;c[b>>2]=c[b>>2]|524288;c[g>>2]=(c[g>>2]|0)-524288}if(c[g>>2]&4){b=(c[f>>2]|0)+360|0;c[b>>2]=c[b>>2]|4;c[g>>2]=(c[g>>2]|0)-4}if(c[g>>2]&2097152){b=(c[f>>2]|0)+360|0;c[b>>2]=c[b>>2]|2097152;c[g>>2]=(c[g>>2]|0)-2097152}if(c[g>>2]&8192){b=(c[f>>2]|0)+360|0;c[b>>2]=c[b>>2]|8192;c[g>>2]=(c[g>>2]|0)-8192}c[(c[f>>2]|0)+364>>2]=0;c[e>>2]=c[g>>2];h=c[e>>2]|0;i=d;return h|0}function uo(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;Rf();c[k>>2]=qo(c[g>>2]|0,c[h>>2]|0)|0;if(!(c[k>>2]|0)){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}else{c[f>>2]=No(c[k>>2]|0,0,0,c[j>>2]|0,0)|0;l=c[f>>2]|0;i=e;return l|0}return 0}function vo(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+32|0;h=g+24|0;j=g+20|0;k=g+16|0;l=g+12|0;m=g+8|0;n=g+4|0;o=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;Rf();c[o>>2]=Zf(c[j>>2]|0,c[k>>2]|0)|0;if(!(c[o>>2]|0)){c[h>>2]=0;p=c[h>>2]|0;i=g;return p|0}rQ();if(c[c[o>>2]>>2]|0){k=(c[c[o>>2]>>2]|0)+0|0;j=136096|0;f=k+112|0;do{c[k>>2]=c[j>>2];k=k+4|0;j=j+4|0}while((k|0)<(f|0))}c[h>>2]=No(c[o>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,0)|0;p=c[h>>2]|0;i=g;return p|0}function wo(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;c[k>>2]=0;if(!(c[21466]|0))ao();c[j>>2]=0;while(1){if((c[j>>2]|0)>=100)break;c[k>>2]=c[85872+(c[j>>2]<<2)>>2];if(!(c[k>>2]|0)){l=6;break}if(qy(c[c[k>>2]>>2]|0,c[f>>2]|0)|0)break;c[j>>2]=(c[j>>2]|0)+1}if((l|0)==6){c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}c[h>>2]=((c[k>>2]|0)-86272|0)/4|0;c[h>>2]=(c[h>>2]|0)+1;while(1){if(!(c[86272+(c[h>>2]<<2)>>2]|0)){l=14;break}if(qy(c[86272+(c[h>>2]<<2)>>2]|0,c[g>>2]|0)|0){l=12;break}c[h>>2]=(c[h>>2]|0)+1}if((l|0)==12){c[e>>2]=1;m=c[e>>2]|0;i=d;return m|0}else if((l|0)==14){c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}return 0}function xo(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;g=d+4|0;c[f>>2]=a;c[g>>2]=b;if(((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+212>>2]|0)!=0:0)?(c[(c[f>>2]|0)+172>>2]|0)==-1:0){i=d;return}if(c[f>>2]|0){c[(c[f>>2]|0)+84>>2]=2;c[(c[f>>2]|0)+172>>2]=-1;c[(c[f>>2]|0)+212>>2]=1}b=c[f>>2]|0;if(c[g>>2]|0){f=c[g>>2]|0;c[e>>2]=c[g>>2];Xd(0,0,0,b,0,1,2,3,0,0,f,0,0,0,0,98040,e);i=d;return}else{Xd(0,0,0,b,0,1,2,3,0,0,0,0,0,0,0,98072,e);i=d;return}}function yo(a){
a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+32|0;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;j=b;c[f>>2]=a;c[j>>2]=0;if((c[(c[f>>2]|0)+292>>2]|0)==0?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)ke(c[(c[f>>2]|0)+36>>2]|0,250)|0;c[g>>2]=c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2];if((d[c[g>>2]>>0]|0|0)>=97?(d[c[g>>2]>>0]|0|0)<=122:0)k=10;else k=6;do if((k|0)==6){if((d[c[g>>2]>>0]|0|0)>=65?(d[c[g>>2]>>0]|0|0)<=90:0){k=10;break}if(!((d[c[g>>2]>>0]|0|0)!=95?(d[c[g>>2]>>0]|0|0)!=58:0))k=10}while(0);if((k|0)==10){c[g>>2]=(c[g>>2]|0)+1;while(1){if((d[c[g>>2]>>0]|0|0)>=97?(d[c[g>>2]>>0]|0|0)<=122:0)l=1;else k=13;do if((k|0)==13){k=0;if((d[c[g>>2]>>0]|0|0)>=65?(d[c[g>>2]>>0]|0|0)<=90:0){l=1;break}if((d[c[g>>2]>>0]|0|0)>=48?(d[c[g>>2]>>0]|0|0)<=57:0){l=1;break}if(((d[c[g>>2]>>0]|0|0)!=95?(d[c[g>>2]>>0]|0|0)!=45:0)?(d[c[g>>2]>>0]|0|0)!=58:0)l=(d[c[g>>2]>>0]|0|0)==46;else l=1}while(0);m=c[g>>2]|0;if(!l)break;c[g>>2]=m+1}if((d[m>>0]|0|0)>0?(d[c[g>>2]>>0]|0|0)<128:0){c[j>>2]=(c[g>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0);c[h>>2]=AP(c[(c[f>>2]|0)+296>>2]|0,c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0,c[j>>2]|0)|0;c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]=c[g>>2];g=(c[f>>2]|0)+200|0;c[g>>2]=(c[g>>2]|0)+(c[j>>2]|0);g=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[g>>2]=(c[g>>2]|0)+(c[j>>2]|0);c[e>>2]=c[h>>2];n=c[e>>2]|0;i=b;return n|0}}c[e>>2]=Oo(c[f>>2]|0)|0;n=c[e>>2]|0;i=b;return n|0}function zo(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+32|0;h=g;j=g+24|0;k=g+20|0;l=g+16|0;m=g+12|0;n=g+8|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;if(((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+212>>2]|0)!=0:0)?(c[(c[j>>2]|0)+172>>2]|0)==-1:0){i=g;return}if(c[j>>2]|0)c[(c[j>>2]|0)+84>>2]=c[k>>2];f=c[j>>2]|0;e=c[k>>2]|0;k=c[m>>2]|0;d=c[n>>2]|0;b=c[l>>2]|0;l=c[n>>2]|0;c[h>>2]=c[m>>2];c[h+4>>2]=l;Xd(0,0,0,f,0,5,e,2,0,0,k,d,0,0,0,b,h);if(!(c[j>>2]|0)){i=g;return}c[(c[j>>2]|0)+12>>2]=0;i=g;return}function Ao(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if(((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+212>>2]|0)!=0:0)?(c[(c[h>>2]|0)+172>>2]|0)==-1:0){i=f;return}if(c[h>>2]|0)c[(c[h>>2]|0)+84>>2]=c[j>>2];e=c[h>>2]|0;d=c[j>>2]|0;j=c[l>>2]|0;b=c[k>>2]|0;c[g>>2]=c[l>>2];Xd(0,0,0,e,0,5,d,2,0,0,0,0,0,j,0,b,g);if(!(c[h>>2]|0)){i=f;return}c[(c[h>>2]|0)+12>>2]=0;i=f;return}function Bo(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;b=i;i=i+64|0;e=b+52|0;f=b+48|0;g=b+44|0;h=b+40|0;j=b+36|0;k=b+32|0;l=b+28|0;m=b+24|0;n=b+20|0;o=b+16|0;p=b+12|0;q=b+8|0;r=b+4|0;s=b;c[f>>2]=a;c[l>>2]=0;c[n>>2]=0;c[p>>2]=0;if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+36>>2]|0)!=0:0){if((c[(c[f>>2]|0)+172>>2]|0)==-1){c[e>>2]=-1;t=c[e>>2]|0;i=b;return t|0}if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=60){c[e>>2]=-1;t=c[e>>2]|0;i=b;return t|0}me(c[f>>2]|0);c[k>>2]=c[(c[f>>2]|0)+300>>2];c[m>>2]=c[(c[f>>2]|0)+304>>2];if((c[(c[f>>2]|0)+292>>2]|0)==0?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)ke(c[(c[f>>2]|0)+36>>2]|0,250)|0;c[g>>2]=Po(c[f>>2]|0)|0;if(!(c[g>>2]|0)){zo(c[f>>2]|0,68,97520,0,0);while(1){if(!(9<=(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0))u=15;if(((u|0)==15?(u=0,(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13):0)?32>(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0):0)break;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==62)break;if((c[(c[f>>2]|0)+172>>2]|0)==-1)break;me(c[f>>2]|0)}c[e>>2]=-1;t=c[e>>2]|0;i=b;return t|0}if(qy(c[g>>2]|0,96200)|0)c[n>>2]=1;Qo(c[f>>2]|0,c[g>>2]|0);Ro(c[f>>2]|0,c[g>>2]|0);if((c[(c[f>>2]|0)+188>>2]|0)>0?(qy(c[g>>2]|0,94240)|0)!=0:0){zo(c[f>>2]|0,800,97656,c[g>>2]|0,0);c[p>>2]=1;a=(c[f>>2]|0)+248|0;c[a>>2]=(c[a>>2]|0)+1}if((c[(c[f>>2]|0)+188>>2]|0)!=1?(qy(c[g>>2]|0,95656)|0)!=0:0){zo(c[f>>2]|0,800,97704,c[g>>2]|0,0);c[p>>2]=1;a=(c[f>>2]|0)+248|0;c[a>>2]=(c[a>>2]|0)+1}a:do if(qy(c[g>>2]|0,95648)|0){c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[(c[f>>2]|0)+188>>2]|0))break a;if(qy(c[(c[(c[f>>2]|0)+196>>2]|0)+(c[q>>2]<<2)>>2]|0,95648)|0){zo(c[f>>2]|0,800,97752,c[g>>2]|0,0);c[p>>2]=1;a=(c[f>>2]|0)+248|0;c[a>>2]=(c[a>>2]|0)+1}c[q>>2]=(c[q>>2]|0)+1}}while(0);Fo(c[f>>2]|0)|0;while(1){if(!(9<=(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0))u=38;if(((u|0)==38?(u=0,(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13):0)?32>(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0):0)break;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==62)break;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==47?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==62:0)break;c[r>>2]=c[(c[f>>2]|0)+200>>2];if((c[(c[f>>2]|0)+292>>2]|0)==0?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)ke(c[(c[f>>2]|0)+36>>2]|0,250)|0;c[h>>2]=So(c[f>>2]|0,j)|0;b:do if(c[h>>2]|0){c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[l>>2]|0))break;if(qy(c[(c[k>>2]|0)+(c[o>>2]<<2)>>2]|0,c[h>>2]|0)|0){u=50;break}c[o>>2]=(c[o>>2]|0)+2}if((u|0)==50){u=0;zo(c[f>>2]|0,42,97800,c[h>>2]|0,0);if(!(c[j>>2]|0))break;zb[c[135736>>2]&511](c[j>>2]|0);break}do if(!(c[k>>2]|0)){c[m>>2]=22;c[k>>2]=Cb[c[135744>>2]&511](c[m>>2]<<2)|0;if(c[k>>2]|0){c[(c[f>>2]|0)+300>>2]=c[k>>2];c[(c[f>>2]|0)+304>>2]=c[m>>2];break}xo(c[f>>2]|0,0);if(!(c[j>>2]|0))break b;zb[c[135736>>2]&511](c[j>>2]|0);break b}else{if(((c[l>>2]|0)+4|0)<=(c[m>>2]|0))break;c[m>>2]=c[m>>2]<<1;c[s>>2]=Hb[c[135760>>2]&511](c[k>>2]|0,c[m>>2]<<2)|0;if(c[s>>2]|0){c[k>>2]=c[s>>2];c[(c[f>>2]|0)+300>>2]=c[k>>2];c[(c[f>>2]|0)+304>>2]=c[m>>2];break}xo(c[f>>2]|0,0);if(!(c[j>>2]|0))break b;zb[c[135736>>2]&511](c[j>>2]|0);break b}while(0);q=c[h>>2]|0;a=c[l>>2]|0;c[l>>2]=a+1;c[(c[k>>2]|0)+(a<<2)>>2]=q;q=c[j>>2]|0;a=c[l>>2]|0;c[l>>2]=a+1;c[(c[k>>2]|0)+(a<<2)>>2]=q;c[(c[k>>2]|0)+(c[l>>2]<<2)>>2]=0;c[(c[k>>2]|0)+((c[l>>2]|0)+1<<2)>>2]=0}else{if(c[j>>2]|0)zb[c[135736>>2]&511](c[j>>2]|0);while(1){if(!(9<=(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0))u=68;do if((u|0)==68){u=0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==13)break;if(32>(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0))break b}while(0);if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==32)break b;if(9<=(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break b;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==13)break b;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==62)break b;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==47?(d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==62:0)break b;me(c[f>>2]|0)}}while(0);Fo(c[f>>2]|0)|0;if((c[r>>2]|0)==(c[(c[f>>2]|0)+200>>2]|0)){u=79;break}}if((u|0)==79)zo(c[f>>2]|0,1,97824,0,0);if((c[n>>2]|0)!=0&(c[l>>2]|0)!=0)To(c[f>>2]|0,c[k>>2]|0);do if(((c[p>>2]|0)==0?(Uo(c[f>>2]|0,c[g>>2]|0)|0,(c[c[f>>2]>>2]|0)!=0):0)?(c[(c[c[f>>2]>>2]|0)+56>>2]|0)!=0:0){n=c[(c[c[f>>2]>>2]|0)+56>>2]|0;u=c[(c[f>>2]|0)+4>>2]|0;r=c[g>>2]|0;if(c[l>>2]|0){Db[n&511](u,r,c[k>>2]|0);break}else{Db[n&511](u,r,0);break}}while(0);c:do if(c[k>>2]|0){c[o>>2]=1;while(1){if((c[o>>2]|0)>=(c[l>>2]|0))break c;if(c[(c[k>>2]|0)+(c[o>>2]<<2)>>2]|0)zb[c[135736>>2]&511](c[(c[k>>2]|0)+(c[o>>2]<<2)>>2]|0);c[o>>2]=(c[o>>2]|0)+2}}while(0);c[e>>2]=c[p>>2];t=c[e>>2]|0;i=b;return t|0}zo(c[f>>2]|0,1,97616,0,0);c[e>>2]=-1;t=c[e>>2]|0;i=b;return t|0}function Co(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if((c[(c[e>>2]|0)+188>>2]|0)<=0){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}a=(c[e>>2]|0)+188|0;c[a>>2]=(c[a>>2]|0)+-1;if((c[(c[e>>2]|0)+188>>2]|0)<0){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}a=c[e>>2]|0;if((c[(c[e>>2]|0)+188>>2]|0)>0)c[(c[e>>2]|0)+184>>2]=c[(c[(c[e>>2]|0)+196>>2]|0)+((c[a+188>>2]|0)-1<<2)>>2];else c[a+184>>2]=0;c[f>>2]=c[(c[(c[e>>2]|0)+196>>2]|0)+(c[(c[e>>2]|0)+188>>2]<<2)>>2];c[(c[(c[e>>2]|0)+196>>2]|0)+(c[(c[e>>2]|0)+188>>2]<<2)>>2]=0;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}function Do(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;if(!(c[(c[d>>2]|0)+188>>2]|0)){i=b;return}c[e>>2]=(c[(c[d>>2]|0)+188>>2]|0)-1;while(1){if((c[e>>2]|0)<0)break;if((c[c[d>>2]>>2]|0)!=0?(c[(c[c[d>>2]>>2]|0)+60>>2]|0)!=0:0)Ab[c[(c[c[d>>2]>>2]|0)+60>>2]&511](c[(c[d>>2]|0)+4>>2]|0,c[(c[d>>2]|0)+184>>2]|0);Co(c[d>>2]|0)|0;c[e>>2]=(c[e>>2]|0)+-1}i=b;return}function Eo(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+32|0;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;j=b;c[e>>2]=a;c[f>>2]=my(c[(c[e>>2]|0)+184>>2]|0)|0;c[g>>2]=c[(c[e>>2]|0)+188>>2];a:while(1){c[j>>2]=c[(c[e>>2]|0)+200>>2];if((c[(c[e>>2]|0)+292>>2]|0)==0?((c[(c[(c[e>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)ke(c[(c[e>>2]|0)+36>>2]|0,250)|0;if((c[(c[e>>2]|0)+172>>2]|0)==-1)break;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==47:0){if(!(Vo(c[e>>2]|0)|0))continue;if((c[f>>2]|0)==0?(c[(c[e>>2]|0)+188>>2]|0)!=0:0)continue;if(c[f>>2]|0)zb[c[135736>>2]&511](c[f>>2]|0);c[f>>2]=my(c[(c[e>>2]|0)+184>>2]|0)|0;c[g>>2]=c[(c[e>>2]|0)+188>>2];continue}b:do if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60){if(!(65<=(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)<=90:0))k=17;do if((k|0)==17){k=0;if(97<=(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)<=122:0)break;if((d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=95?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=58:0)break b}while(0);c[h>>2]=Wo(c[e>>2]|0)|0;a=c[e>>2]|0;if(c[h>>2]|0){if(!(c[a+184>>2]|0))break;if((wo(c[h>>2]|0,c[(c[e>>2]|0)+184>>2]|0)|0)!=1)break;Qo(c[e>>2]|0,c[h>>2]|0);continue a}zo(a,68,97520,0,0);while(1){if(9<=(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)k=27;else if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13?32>(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0):0)l=0;else k=27;if((k|0)==27){k=0;l=(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=62}m=c[e>>2]|0;if(!l)break;me(m)}_o(m);if(c[f>>2]|0)zb[c[135736>>2]&511](c[f>>2]|0);c[f>>2]=my(c[(c[e>>2]|0)+184>>2]|0)|0;c[g>>2]=c[(c[e>>2]|0)+188>>2];continue a}while(0);if(((c[(c[e>>2]|0)+188>>2]|0)>0?(c[g>>2]|0)>=(c[(c[e>>2]|0)+188>>2]|0):0)?(qy(c[f>>2]|0,c[(c[e>>2]|0)+184>>2]|0)|0)==0:0){_o(c[e>>2]|0);if(c[f>>2]|0)zb[c[135736>>2]&511](c[f>>2]|0);c[f>>2]=my(c[(c[e>>2]|0)+184>>2]|0)|0;c[g>>2]=c[(c[e>>2]|0)+188>>2];continue}do if(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0){if((qy(c[f>>2]|0,94992)|0)==0?(qy(c[f>>2]|0,95e3)|0)==0:0){k=46;break}Xo(c[e>>2]|0)}else k=46;while(0);if((k|0)==46){k=0;if(((((((((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==33:0)?(WS(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0)|0)==68:0)?(WS(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0)|0)==79:0)?(WS(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0)|0)==67:0)?(WS(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0)|0)==84:0)?(WS(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0)|0)==89:0)?(WS(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0)|0)==80:0)?(WS(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+8>>0]|0)|0)==69:0){zo(c[e>>2]|0,800,95008,95040,0);Io(c[e>>2]|0)}if((((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==33:0)?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)==45:0)?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)==45:0)Go(c[e>>2]|0);else k=61;do if((k|0)==61){k=0;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60?(d[(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==63:0){Ho(c[e>>2]|0);break}a=c[e>>2]|0;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==60){$o(a);if(c[f>>2]|0)zb[c[135736>>2]&511](c[f>>2]|0);c[f>>2]=my(c[(c[e>>2]|0)+184>>2]|0)|0;c[g>>2]=c[(c[e>>2]|0)+188>>2];break}n=c[e>>2]|0;if((d[c[(c[a+36>>2]|0)+16>>2]>>0]|0|0)==38){Yo(n);break}o=c[e>>2]|0;if(!(d[c[(c[n+36>>2]|0)+16>>2]>>0]|0)){k=71;break a}Zo(o)}while(0);if((c[j>>2]|0)==(c[(c[e>>2]|0)+200>>2]|0)){k=74;break}}if(c[(c[e>>2]|0)+292>>2]|0)continue;if(((c[(c[(c[e>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=250)continue;ke(c[(c[e>>2]|0)+36>>2]|0,250)|0}if((k|0)==71)Do(o);else if((k|0)==74?(c[(c[e>>2]|0)+52>>2]|0)!=0:0)zo(c[e>>2]|0,1,95064,0,0);if(!(c[f>>2]|0)){i=b;return}zb[c[135736>>2]&511](c[f>>2]|0);i=b;return}function Fo(a){a=a|0;var b=0,e=0,f=0,g=0;b=i;i=i+16|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=0;a:while(1){do if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=32){if(9<=(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=10:0)break;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=13)break a}while(0);if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==0?(ke(c[(c[e>>2]|0)+36>>2]|0,250)|0)<=0:0)Ve(c[e>>2]|0)|0;else{a=c[(c[e>>2]|0)+36>>2]|0;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){g=a+28|0;c[g>>2]=(c[g>>2]|0)+1;c[(c[(c[e>>2]|0)+36>>2]|0)+32>>2]=1}else{g=a+32|0;c[g>>2]=(c[g>>2]|0)+1}g=(c[(c[e>>2]|0)+36>>2]|0)+16|0;c[g>>2]=(c[g>>2]|0)+1;g=(c[e>>2]|0)+200|0;c[g>>2]=(c[g>>2]|0)+1;if(!(d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0))ke(c[(c[e>>2]|0)+36>>2]|0,250)|0}c[f>>2]=(c[f>>2]|0)+1}i=b;return c[f>>2]|0}function Go(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;i=i+48|0;f=e+44|0;g=e+40|0;h=e+36|0;j=e+32|0;k=e+28|0;l=e+24|0;m=e+20|0;n=e+16|0;o=e+12|0;p=e+8|0;q=e+4|0;r=e;c[f>>2]=b;c[g>>2]=0;c[j>>2]=100;if(c[(c[f>>2]|0)+176>>2]|0)s=-1;else s=d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0;if((s|0)!=60){i=e;return}if((d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=33){i=e;return}if((d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0|0)!=45){i=e;return}if((d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0|0)!=45){i=e;return}c[q>>2]=c[(c[f>>2]|0)+172>>2];c[(c[f>>2]|0)+172>>2]=5;if(((c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)le(c[(c[f>>2]|0)+36>>2]|0);s=(c[f>>2]|0)+200|0;c[s>>2]=(c[s>>2]|0)+4;s=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[s>>2]=(c[s>>2]|0)+4;s=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[s>>2]=(c[s>>2]|0)+4;c[g>>2]=Cb[c[135752>>2]&511](c[j>>2]|0)|0;s=c[f>>2]|0;if(!(c[g>>2]|0)){xo(s,97424);c[(c[f>>2]|0)+172>>2]=c[q>>2];i=e;return}c[k>>2]=ap(s,l)|0;s=c[(c[f>>2]|0)+36>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){b=s+28|0;c[b>>2]=(c[b>>2]|0)+1;c[(c[(c[f>>2]|0)+36>>2]|0)+32>>2]=1}else{b=s+32|0;c[b>>2]=(c[b>>2]|0)+1}c[(c[f>>2]|0)+176>>2]=0;b=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[b>>2]=(c[b>>2]|0)+(c[l>>2]|0);b=(c[f>>2]|0)+200|0;c[b>>2]=(c[b>>2]|0)+1;c[m>>2]=ap(c[f>>2]|0,n)|0;b=c[(c[f>>2]|0)+36>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){s=b+28|0;c[s>>2]=(c[s>>2]|0)+1;c[(c[(c[f>>2]|0)+36>>2]|0)+32>>2]=1}else{s=b+32|0;c[s>>2]=(c[s>>2]|0)+1}c[(c[f>>2]|0)+176>>2]=0;s=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[s>>2]=(c[s>>2]|0)+(c[n>>2]|0);s=(c[f>>2]|0)+200|0;c[s>>2]=(c[s>>2]|0)+1;c[o>>2]=ap(c[f>>2]|0,p)|0;c[h>>2]=0;while(1){s=c[o>>2]|0;if((c[o>>2]|0)<256)if(9<=(s|0)&(c[o>>2]|0)<=10|(c[o>>2]|0)==13|32<=(c[o>>2]|0))t=24;else u=0;else if((!(256<=(s|0)&(c[o>>2]|0)<=55295)?!(57344<=(c[o>>2]|0)&(c[o>>2]|0)<=65533):0)?!(65536<=(c[o>>2]|0)&(c[o>>2]|0)<=1114111):0)u=0;else t=24;if((t|0)==24){t=0;if((c[o>>2]|0)!=62|(c[m>>2]|0)!=45)u=1;else u=(c[k>>2]|0)!=45}v=c[h>>2]|0;if(!u)break;if((v+5|0)>=(c[j>>2]|0)){c[j>>2]=c[j>>2]<<1;c[r>>2]=Hb[c[135760>>2]&511](c[g>>2]|0,c[j>>2]|0)|0;if(!(c[r>>2]|0)){t=29;break}c[g>>2]=c[r>>2]}if((c[l>>2]|0)==1){s=c[k>>2]&255;b=c[h>>2]|0;c[h>>2]=b+1;a[(c[g>>2]|0)+b>>0]=s}else{s=qe(c[l>>2]|0,(c[g>>2]|0)+(c[h>>2]|0)|0,c[k>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+s}c[k>>2]=c[m>>2];c[l>>2]=c[n>>2];c[m>>2]=c[o>>2];c[n>>2]=c[p>>2];s=c[(c[f>>2]|0)+36>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){b=s+28|0;c[b>>2]=(c[b>>2]|0)+1;c[(c[(c[f>>2]|0)+36>>2]|0)+32>>2]=1}else{b=s+32|0;c[b>>2]=(c[b>>2]|0)+1}c[(c[f>>2]|0)+176>>2]=0;b=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[b>>2]=(c[b>>2]|0)+(c[p>>2]|0);b=(c[f>>2]|0)+200|0;c[b>>2]=(c[b>>2]|0)+1;c[o>>2]=ap(c[f>>2]|0,p)|0;if(c[o>>2]|0)continue;if(((c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)le(c[(c[f>>2]|0)+36>>2]|0);if((c[(c[f>>2]|0)+292>>2]|0)==0?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)ke(c[(c[f>>2]|0)+36>>2]|0,250)|0;c[o>>2]=ap(c[f>>2]|0,p)|0}if((t|0)==29){zb[c[135736>>2]&511](c[g>>2]|0);xo(c[f>>2]|0,97456);c[(c[f>>2]|0)+172>>2]=c[q>>2];i=e;return}a[(c[g>>2]|0)+v>>0]=0;v=c[o>>2]|0;if((c[o>>2]|0)<256)if(9<=(v|0)&(c[o>>2]|0)<=10|(c[o>>2]|0)==13|32<=(c[o>>2]|0))t=51;else t=50;else if((!(256<=(v|0)&(c[o>>2]|0)<=55295)?!(57344<=(c[o>>2]|0)&(c[o>>2]|0)<=65533):0)?!(65536<=(c[o>>2]|0)&(c[o>>2]|0)<=1114111):0)t=50;else t=51;if((t|0)==50){zo(c[f>>2]|0,45,97480,c[g>>2]|0,0);zb[c[135736>>2]&511](c[g>>2]|0)}else if((t|0)==51){me(c[f>>2]|0);if(((c[c[f>>2]>>2]|0)!=0?(c[(c[c[f>>2]>>2]|0)+80>>2]|0)!=0:0)?(c[(c[f>>2]|0)+212>>2]|0)==0:0)Ab[c[(c[c[f>>2]>>2]|0)+80>>2]&511](c[(c[f>>2]|0)+4>>2]|0,c[g>>2]|0);zb[c[135736>>2]&511](c[g>>2]|0)}c[(c[f>>2]|0)+172>>2]=c[q>>2];i=e;return}function Ho(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+48|0;f=e+36|0;g=e+32|0;h=e+28|0;j=e+24|0;k=e+20|0;l=e+16|0;m=e+12|0;n=e+8|0;o=e+4|0;p=e;c[f>>2]=b;c[g>>2]=0;c[h>>2]=0;c[j>>2]=100;c[o>>2]=0;if(c[(c[f>>2]|0)+176>>2]|0)q=-1;else q=d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0;if((q|0)!=60){i=e;return}if((d[(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)!=63){i=e;return}c[n>>2]=c[(c[f>>2]|0)+172>>2];c[(c[f>>2]|0)+172>>2]=2;q=(c[f>>2]|0)+200|0;c[q>>2]=(c[q>>2]|0)+2;q=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[q>>2]=(c[q>>2]|0)+2;q=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[q>>2]=(c[q>>2]|0)+2;if(((c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<500:0)le(c[(c[f>>2]|0)+36>>2]|0);c[m>>2]=yo(c[f>>2]|0)|0;q=c[f>>2]|0;if(c[m>>2]|0){if(c[q+176>>2]|0)r=-1;else r=d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0;if((r|0)==62){r=(c[f>>2]|0)+200|0;c[r>>2]=(c[r>>2]|0)+1;r=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[r>>2]=(c[r>>2]|0)+1;r=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[r>>2]=(c[r>>2]|0)+1;if(((c[c[f>>2]>>2]|0)!=0?(c[(c[f>>2]|0)+212>>2]|0)==0:0)?(c[(c[c[f>>2]>>2]|0)+76>>2]|0)!=0:0)Db[c[(c[c[f>>2]>>2]|0)+76>>2]&511](c[(c[f>>2]|0)+4>>2]|0,c[m>>2]|0,0);c[(c[f>>2]|0)+172>>2]=c[n>>2];i=e;return}c[g>>2]=Cb[c[135752>>2]&511](c[j>>2]|0)|0;r=c[f>>2]|0;if(!(c[g>>2]|0)){xo(r,0);c[(c[f>>2]|0)+172>>2]=c[n>>2];i=e;return}c[k>>2]=d[c[(c[r+36>>2]|0)+16>>2]>>0];if((c[k>>2]|0)<256){if((c[k>>2]|0)!=32?!(9<=(c[k>>2]|0)&(c[k>>2]|0)<=10|(c[k>>2]|0)==13):0)s=22}else s=22;if((s|0)==22)zo(c[f>>2]|0,65,97328,c[m>>2]|0,0);Fo(c[f>>2]|0)|0;c[k>>2]=ap(c[f>>2]|0,l)|0;while(1){r=c[k>>2]|0;if((c[k>>2]|0)<256)if(9<=(r|0)&(c[k>>2]|0)<=10|(c[k>>2]|0)==13|32<=(c[k>>2]|0))s=29;else t=0;else if((!(256<=(r|0)&(c[k>>2]|0)<=55295)?!(57344<=(c[k>>2]|0)&(c[k>>2]|0)<=65533):0)?!(65536<=(c[k>>2]|0)&(c[k>>2]|0)<=1114111):0)t=0;else s=29;if((s|0)==29){s=0;t=(c[k>>2]|0)!=62}u=c[h>>2]|0;if(!t)break;if((u+5|0)>=(c[j>>2]|0)){c[j>>2]=c[j>>2]<<1;c[p>>2]=Hb[c[135760>>2]&511](c[g>>2]|0,c[j>>2]|0)|0;if(!(c[p>>2]|0)){s=33;break}c[g>>2]=c[p>>2]}c[o>>2]=(c[o>>2]|0)+1;if((c[o>>2]|0)>50){if((c[(c[f>>2]|0)+292>>2]|0)==0?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)ke(c[(c[f>>2]|0)+36>>2]|0,250)|0;c[o>>2]=0}if((c[l>>2]|0)==1){r=c[k>>2]&255;b=c[h>>2]|0;c[h>>2]=b+1;a[(c[g>>2]|0)+b>>0]=r}else{r=qe(c[l>>2]|0,(c[g>>2]|0)+(c[h>>2]|0)|0,c[k>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+r}r=c[(c[f>>2]|0)+36>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){b=r+28|0;c[b>>2]=(c[b>>2]|0)+1;c[(c[(c[f>>2]|0)+36>>2]|0)+32>>2]=1}else{b=r+32|0;c[b>>2]=(c[b>>2]|0)+1}c[(c[f>>2]|0)+176>>2]=0;b=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[b>>2]=(c[b>>2]|0)+(c[l>>2]|0);b=(c[f>>2]|0)+200|0;c[b>>2]=(c[b>>2]|0)+1;c[k>>2]=ap(c[f>>2]|0,l)|0;if(c[k>>2]|0)continue;do if(((c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+12>>2]|0)|0)>500){if(((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=500)break;le(c[(c[f>>2]|0)+36>>2]|0)}while(0);do if(!(c[(c[f>>2]|0)+292>>2]|0)){if(((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)>=250)break;ke(c[(c[f>>2]|0)+36>>2]|0,250)|0}while(0);c[k>>2]=ap(c[f>>2]|0,l)|0}if((s|0)==33){xo(c[f>>2]|0,0);zb[c[135736>>2]&511](c[g>>2]|0);c[(c[f>>2]|0)+172>>2]=c[n>>2];i=e;return}a[(c[g>>2]|0)+u>>0]=0;u=c[f>>2]|0;if((c[k>>2]|0)==62){k=u+200|0;c[k>>2]=(c[k>>2]|0)+1;k=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[k>>2]=(c[k>>2]|0)+1;k=(c[(c[f>>2]|0)+36>>2]|0)+32|0;c[k>>2]=(c[k>>2]|0)+1;if(((c[c[f>>2]>>2]|0)!=0?(c[(c[f>>2]|0)+212>>2]|0)==0:0)?(c[(c[c[f>>2]>>2]|0)+76>>2]|0)!=0:0)Db[c[(c[c[f>>2]>>2]|0)+76>>2]&511](c[(c[f>>2]|0)+4>>2]|0,c[m>>2]|0,c[g>>2]|0)}else zo(u,47,97360,c[m>>2]|0,0);zb[c[135736>>2]&511](c[g>>2]|0)}else zo(q,46,97392,0,0);c[(c[f>>2]|0)+172>>2]=c[n>>2];i=e;return}function Io(a){a=a|0;var b=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[e>>2]=a;c[g>>2]=0;c[h>>2]=0;a=(c[e>>2]|0)+200|0;c[a>>2]=(c[a>>2]|0)+9;a=(c[(c[e>>2]|0)+36>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+9;a=(c[(c[e>>2]|0)+36>>2]|0)+32|0;c[a>>2]=(c[a>>2]|0)+9;Fo(c[e>>2]|0)|0;c[f>>2]=yo(c[e>>2]|0)|0;if(!(c[f>>2]|0))zo(c[e>>2]|0,68,96976,0,0);Fo(c[e>>2]|0)|0;c[h>>2]=bp(c[e>>2]|0,g)|0;Fo(c[e>>2]|0)|0;if((d[c[(c[(c[e>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=62)zo(c[e>>2]|0,61,97024,0,0);me(c[e>>2]|0);if(((c[c[e>>2]>>2]|0)!=0?(c[c[c[e>>2]>>2]>>2]|0)!=0:0)?(c[(c[e>>2]|0)+212>>2]|0)==0:0)Jb[c[c[c[e>>2]>>2]>>2]&511](c[(c[e>>2]|0)+4>>2]|0,c[f>>2]|0,c[g>>2]|0,c[h>>2]|0);if(c[h>>2]|0)zb[c[135736>>2]&511](c[h>>2]|0);if(!(c[g>>2]|0)){i=b;return}zb[c[135736>>2]&511](c[g>>2]|0);i=b;return}function Jo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if(!(c[e>>2]|0)){c[d>>2]=-1;g=c[d>>2]|0;i=b;return g|0}cU(c[e>>2]|0,0,472)|0;a=xP()|0;c[(c[e>>2]|0)+296>>2]=a;if(!(c[(c[e>>2]|0)+296>>2]|0)){xo(0,96936);c[d>>2]=-1;g=c[d>>2]|0;i=b;return g|0}c[f>>2]=Cb[c[135744>>2]&511](128)|0;if(!(c[f>>2]|0)){xo(0,96936);c[d>>2]=-1;g=c[d>>2]|0;i=b;return g|0}a=(c[f>>2]|0)+0|0;h=a+128|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(h|0));j=Cb[c[135744>>2]&511](20)|0;c[(c[e>>2]|0)+48>>2]=j;if(!(c[(c[e>>2]|0)+48>>2]|0)){xo(0,96936);c[(c[e>>2]|0)+40>>2]=0;c[(c[e>>2]|0)+44>>2]=0;c[(c[e>>2]|0)+36>>2]=0;c[d>>2]=-1;g=c[d>>2]|0;i=b;return g|0}c[(c[e>>2]|0)+40>>2]=0;c[(c[e>>2]|0)+44>>2]=5;c[(c[e>>2]|0)+36>>2]=0;c[(c[e>>2]|0)+20>>2]=0;c[(c[e>>2]|0)+24>>2]=0;c[(c[e>>2]|0)+28>>2]=-1;c[(c[e>>2]|0)+172>>2]=0;j=Cb[c[135744>>2]&511](40)|0;c[(c[e>>2]|0)+64>>2]=j;if(!(c[(c[e>>2]|0)+64>>2]|0)){xo(0,96936);c[(c[e>>2]|0)+56>>2]=0;c[(c[e>>2]|0)+60>>2]=0;c[(c[e>>2]|0)+52>>2]=0;c[(c[e>>2]|0)+40>>2]=0;c[(c[e>>2]|0)+44>>2]=0;c[(c[e>>2]|0)+36>>2]=0;c[d>>2]=-1;g=c[d>>2]|0;i=b;return g|0}c[(c[e>>2]|0)+56>>2]=0;c[(c[e>>2]|0)+60>>2]=10;c[(c[e>>2]|0)+52>>2]=0;j=Cb[c[135744>>2]&511](40)|0;c[(c[e>>2]|0)+196>>2]=j;if(!(c[(c[e>>2]|0)+196>>2]|0)){xo(0,96936);c[(c[e>>2]|0)+188>>2]=0;c[(c[e>>2]|0)+192>>2]=0;c[(c[e>>2]|0)+184>>2]=0;c[(c[e>>2]|0)+56>>2]=0;c[(c[e>>2]|0)+60>>2]=0;c[(c[e>>2]|0)+52>>2]=0;c[(c[e>>2]|0)+40>>2]=0;c[(c[e>>2]|0)+44>>2]=0;c[(c[e>>2]|0)+36>>2]=0;c[d>>2]=-1;g=c[d>>2]|0;i=b;return g|0}c[(c[e>>2]|0)+188>>2]=0;c[(c[e>>2]|0)+192>>2]=10;c[(c[e>>2]|0)+184>>2]=0;c[(c[e>>2]|0)+460>>2]=0;c[(c[e>>2]|0)+452>>2]=0;c[(c[e>>2]|0)+456>>2]=0;if(!(c[f>>2]|0))c[c[e>>2]>>2]=136096;else{c[c[e>>2]>>2]=c[f>>2];a=(c[f>>2]|0)+0|0;f=136096|0;h=a+112|0;do{c[a>>2]=c[f>>2];a=a+4|0;f=f+4|0}while((a|0)<(h|0))}c[(c[e>>2]|0)+4>>2]=c[e>>2];c[(c[e>>2]|0)+8>>2]=0;c[(c[e>>2]|0)+12>>2]=1;c[(c[e>>2]|0)+16>>2]=0;c[(c[e>>2]|0)+280>>2]=c[33962];c[(c[e>>2]|0)+32>>2]=1;c[(c[e>>2]|0)+136>>2]=-1412623820;c[(c[e>>2]|0)+108>>2]=c[e>>2];c[(c[e>>2]|0)+112>>2]=224;c[(c[e>>2]|0)+116>>2]=225;c[(c[e>>2]|0)+68>>2]=0;c[(c[e>>2]|0)+104>>2]=0;c[(c[e>>2]|0)+200>>2]=0;c[(c[e>>2]|0)+204>>2]=0;c[(c[e>>2]|0)+284>>2]=0;ze((c[e>>2]|0)+72|0);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}function Ko(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;f=i;i=i+80|0;g=f+60|0;h=f+56|0;j=f+52|0;k=f+48|0;l=f+44|0;m=f+69|0;n=f+68|0;o=f+24|0;p=f+20|0;q=f+16|0;r=f+12|0;s=f+8|0;t=f+66|0;u=f+4|0;v=f+64|0;w=f;c[g>>2]=b;c[h>>2]=e;c[j>>2]=0;c[l>>2]=0;a:while(1){c[k>>2]=c[(c[g>>2]|0)+36>>2];if(!(c[k>>2]|0))break;e=c[k>>2]|0;if(!(c[c[k>>2]>>2]|0))c[l>>2]=(c[e+24>>2]|0)-((c[(c[k>>2]|0)+16>>2]|0)-(c[(c[k>>2]|0)+12>>2]|0));else{b=_y(c[(c[e>>2]|0)+16>>2]|0)|0;c[l>>2]=b-((c[(c[k>>2]|0)+16>>2]|0)-(c[(c[k>>2]|0)+12>>2]|0))}if(((((c[l>>2]|0)==0&(c[h>>2]|0)!=0?(Do(c[g>>2]|0),(c[(c[g>>2]|0)+188>>2]|0)==0):0)?(c[(c[g>>2]|0)+172>>2]|0)!=-1:0)?(c[(c[g>>2]|0)+172>>2]=-1,(c[c[g>>2]>>2]|0)!=0):0)?(c[(c[c[g>>2]>>2]|0)+52>>2]|0)!=0:0)zb[c[(c[c[g>>2]>>2]|0)+52>>2]&511](c[(c[g>>2]|0)+4>>2]|0);if((c[l>>2]|0)<1)break;a[m>>0]=a[c[(c[k>>2]|0)+16>>2]>>0]|0;b=c[g>>2]|0;if(!(d[m>>0]|0)){e=b+200|0;c[e>>2]=(c[e>>2]|0)+1;e=(c[(c[g>>2]|0)+36>>2]|0)+16|0;c[e>>2]=(c[e>>2]|0)+1;e=(c[(c[g>>2]|0)+36>>2]|0)+32|0;c[e>>2]=(c[e>>2]|0)+1;continue}do switch(c[b+172>>2]|0){case 1:{Fo(c[g>>2]|0)|0;e=c[k>>2]|0;if(!(c[c[k>>2]>>2]|0))c[l>>2]=(c[e+24>>2]|0)-((c[(c[k>>2]|0)+16>>2]|0)-(c[(c[k>>2]|0)+12>>2]|0));else{x=_y(c[(c[e>>2]|0)+16>>2]|0)|0;c[l>>2]=x-((c[(c[k>>2]|0)+16>>2]|0)-(c[(c[k>>2]|0)+12>>2]|0))}if((c[l>>2]|0)<1)break a;if((c[l>>2]|0)<2){if(!(c[h>>2]|0))break a;a[n>>0]=32}else a[n>>0]=a[(c[(c[k>>2]|0)+16>>2]|0)+1>>0]|0;a[m>>0]=a[c[(c[k>>2]|0)+16>>2]>>0]|0;if((((d[m>>0]|0)==60?(d[n>>0]|0)==33:0)?(d[(c[(c[k>>2]|0)+16>>2]|0)+2>>0]|0)==45:0)?(d[(c[(c[k>>2]|0)+16>>2]|0)+3>>0]|0)==45:0){if((c[h>>2]|0)==0?(cp(c[g>>2]|0,45,45,62,1,1)|0)<0:0)break a;Go(c[g>>2]|0);c[(c[g>>2]|0)+172>>2]=1;continue a}if((d[m>>0]|0)==60?(d[n>>0]|0)==63:0){if((c[h>>2]|0)==0?(cp(c[g>>2]|0,62,0,0,0,1)|0)<0:0)break a;Ho(c[g>>2]|0);c[(c[g>>2]|0)+172>>2]=1;continue a}do if(((((((d[m>>0]|0)==60?(d[n>>0]|0)==33:0)?(WS(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0)|0)==68:0)?(WS(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0)|0)==79:0)?(WS(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0)|0)==67:0)?(WS(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0)|0)==84:0)?(WS(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0)|0)==89:0){if((WS(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0)|0)!=80)break;if((WS(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+8>>0]|0)|0)!=69)break;if((c[h>>2]|0)==0?(cp(c[g>>2]|0,62,0,0,0,1)|0)<0:0)break a;Io(c[g>>2]|0);c[(c[g>>2]|0)+172>>2]=4;continue a}while(0);if((d[m>>0]|0)==60?(d[n>>0]|0)==33&(c[l>>2]|0)<9:0)break a;c[(c[g>>2]|0)+172>>2]=6;continue a;break}case 9:{if((c[l>>2]|0)<2)break a;if((c[h>>2]|0)==0?(cp(c[g>>2]|0,62,0,0,0,1)|0)<0:0)break a;Vo(c[g>>2]|0)|0;x=(c[g>>2]|0)+172|0;if(!(c[(c[g>>2]|0)+188>>2]|0))c[x>>2]=14;else c[x>>2]=7;c[(c[g>>2]|0)+204>>2]=0;continue a;break}case 8:{zo(c[g>>2]|0,1,95104,0,0);c[(c[g>>2]|0)+172>>2]=7;c[(c[g>>2]|0)+204>>2]=0;continue a;break}case 3:{zo(c[g>>2]|0,1,95144,0,0);c[(c[g>>2]|0)+172>>2]=7;c[(c[g>>2]|0)+204>>2]=0;continue a;break}case 7:{if(c[(c[g>>2]|0)+176>>2]|0){a[t+0>>0]=0;a[t+1>>0]=0;a[t>>0]=c[(c[g>>2]|0)+176>>2];ep(c[g>>2]|0)|0;if((c[c[g>>2]>>2]|0)!=0?(c[(c[c[g>>2]>>2]|0)+68>>2]|0)!=0:0)Db[c[(c[c[g>>2]>>2]|0)+68>>2]&511](c[(c[g>>2]|0)+4>>2]|0,t,1);c[(c[g>>2]|0)+176>>2]=0;c[(c[g>>2]|0)+204>>2]=0}if(((c[l>>2]|0)==1&(c[h>>2]|0)!=0?(a[m>>0]=a[c[(c[k>>2]|0)+16>>2]>>0]|0,(d[m>>0]|0)!=60):0)?(d[m>>0]|0)!=38:0){b:do if(c[c[g>>2]>>2]|0){do if((d[m>>0]|0)!=32){if(9<=(d[m>>0]|0)?(d[m>>0]|0)<=10:0)break;if((d[m>>0]|0)!=13){ep(c[g>>2]|0)|0;if(!(c[(c[c[g>>2]>>2]|0)+68>>2]|0))break b;Db[c[(c[c[g>>2]>>2]|0)+68>>2]&511](c[(c[g>>2]|0)+4>>2]|0,m,1);break b}}while(0);x=c[c[g>>2]>>2]|0;if(c[(c[g>>2]|0)+208>>2]|0){if(!(c[x+68>>2]|0))break;Db[c[(c[c[g>>2]>>2]|0)+68>>2]&511](c[(c[g>>2]|0)+4>>2]|0,m,1);break}else{if(!(c[x+72>>2]|0))break;Db[c[(c[c[g>>2]>>2]|0)+72>>2]&511](c[(c[g>>2]|0)+4>>2]|0,m,1);break}}while(0);c[(c[g>>2]|0)+176>>2]=0;c[(c[g>>2]|0)+204>>2]=0;x=(c[k>>2]|0)+16|0;c[x>>2]=(c[x>>2]|0)+1;continue a}if((c[l>>2]|0)<2)break a;a[m>>0]=a[c[(c[k>>2]|0)+16>>2]>>0]|0;a[n>>0]=a[(c[(c[k>>2]|0)+16>>2]|0)+1>>0]|0;c[s>>2]=c[(c[g>>2]|0)+200>>2];c:do if((qy(c[(c[g>>2]|0)+184>>2]|0,94992)|0)==0?(qy(c[(c[g>>2]|0)+184>>2]|0,95e3)|0)==0:0){do if((((((d[m>>0]|0)==60?(d[n>>0]|0)==33:0)?(WS(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0)|0)==68:0)?(WS(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0)|0)==79:0)?(WS(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0)|0)==67:0)?(WS(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0)|0)==84:0){if((WS(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0)|0)!=89)break;if((WS(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0)|0)!=80)break;if((WS(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+8>>0]|0)|0)!=69)break;if((c[h>>2]|0)==0?(cp(c[g>>2]|0,62,0,0,0,1)|0)<0:0)break a;zo(c[g>>2]|0,800,95008,95040,0);Io(c[g>>2]|0);break c}while(0);if((((d[m>>0]|0)==60?(d[n>>0]|0)==33:0)?(d[(c[(c[k>>2]|0)+16>>2]|0)+2>>0]|0)==45:0)?(d[(c[(c[k>>2]|0)+16>>2]|0)+3>>0]|0)==45:0){if((c[h>>2]|0)==0?(cp(c[g>>2]|0,45,45,62,1,1)|0)<0:0)break a;Go(c[g>>2]|0);c[(c[g>>2]|0)+172>>2]=7;break}if((d[m>>0]|0)==60?(d[n>>0]|0)==63:0){if((c[h>>2]|0)==0?(cp(c[g>>2]|0,62,0,0,0,1)|0)<0:0)break a;Ho(c[g>>2]|0);c[(c[g>>2]|0)+172>>2]=7;break}if((d[m>>0]|0)==60?(d[n>>0]|0)==33&(c[l>>2]|0)<4:0)break a;if((d[m>>0]|0)==60?(d[n>>0]|0)==47:0){c[(c[g>>2]|0)+172>>2]=9;c[(c[g>>2]|0)+204>>2]=0;continue a}if((d[m>>0]|0)==60){c[(c[g>>2]|0)+172>>2]=6;c[(c[g>>2]|0)+204>>2]=0;continue a}x=(c[h>>2]|0)!=0;if((d[m>>0]|0)==38){if(!x?(fp(c[g>>2]|0,95048,4)|0)<0:0)break a;Yo(c[g>>2]|0);break}else{if(!x?(fp(c[g>>2]|0,95056,2)|0)<0:0)break a;c[(c[g>>2]|0)+204>>2]=0;Zo(c[g>>2]|0);break}}else y=187;while(0);if((y|0)==187){y=0;if(!(c[h>>2]|0)){c[u>>2]=cp(c[g>>2]|0,60,47,0,0,0)|0;if((c[u>>2]|0)<0)break a;a[v>>0]=a[(c[(c[k>>2]|0)+16>>2]|0)+((c[u>>2]|0)+2)>>0]|0;if(!(d[v>>0]|0))break a}Xo(c[g>>2]|0);if((d[m>>0]|0)==60?(d[n>>0]|0)==47:0){c[(c[g>>2]|0)+172>>2]=9;c[(c[g>>2]|0)+204>>2]=0;continue a}}if((c[s>>2]|0)!=(c[(c[g>>2]|0)+200>>2]|0))continue a;if(c[(c[g>>2]|0)+52>>2]|0)zo(c[g>>2]|0,1,95064,0,0);me(c[g>>2]|0);continue a;break}case 6:{if((c[l>>2]|0)<1)break a;if((c[l>>2]|0)<2){if(!(c[h>>2]|0))break a;a[n>>0]=32}else a[n>>0]=a[(c[(c[k>>2]|0)+16>>2]|0)+1>>0]|0;a[m>>0]=a[c[(c[k>>2]|0)+16>>2]>>0]|0;if((d[m>>0]|0)!=60){c[(c[g>>2]|0)+172>>2]=7;continue a}if((d[n>>0]|0)==47){c[(c[g>>2]|0)+172>>2]=9;c[(c[g>>2]|0)+204>>2]=0;continue a}if((c[h>>2]|0)==0?(cp(c[g>>2]|0,62,0,0,0,1)|0)<0:0)break a;if(c[(c[g>>2]|0)+68>>2]|0){c[o+4>>2]=(c[(c[(c[g>>2]|0)+36>>2]|0)+36>>2]|0)+((c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[g>>2]|0)+36>>2]|0)+12>>2]|0));c[o+8>>2]=c[(c[(c[g>>2]|0)+36>>2]|0)+28>>2]}c[q>>2]=Bo(c[g>>2]|0)|0;c[p>>2]=c[(c[g>>2]|0)+184>>2];if((c[q>>2]|0)==-1|(c[p>>2]|0)==0){if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0)!=62)continue a;me(c[g>>2]|0);continue a}c[r>>2]=bo(c[p>>2]|0)|0;if(!(c[r>>2]|0))zo(c[g>>2]|0,801,94576,c[p>>2]|0,0);if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0)==47?(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0)==62:0){x=(c[g>>2]|0)+200|0;c[x>>2]=(c[x>>2]|0)+2;x=(c[(c[g>>2]|0)+36>>2]|0)+16|0;c[x>>2]=(c[x>>2]|0)+2;x=(c[(c[g>>2]|0)+36>>2]|0)+32|0;c[x>>2]=(c[x>>2]|0)+2;do if(c[c[g>>2]>>2]|0){if(!(c[(c[c[g>>2]>>2]|0)+60>>2]|0))break;Ab[c[(c[c[g>>2]>>2]|0)+60>>2]&511](c[(c[g>>2]|0)+4>>2]|0,c[p>>2]|0)}while(0);Co(c[g>>2]|0)|0;c[(c[g>>2]|0)+172>>2]=7;continue a}x=c[g>>2]|0;if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0)!=62){zo(x,73,94592,c[p>>2]|0,0);if(qy(c[p>>2]|0,c[(c[g>>2]|0)+184>>2]|0)|0){Re(c[g>>2]|0)|0;Co(c[g>>2]|0)|0}if(c[(c[g>>2]|0)+68>>2]|0)dp(c[g>>2]|0,o)|0;c[(c[g>>2]|0)+172>>2]=7;continue a}me(x);if((c[r>>2]|0)!=0?(a[(c[r>>2]|0)+7>>0]|0)!=0:0){do if(c[c[g>>2]>>2]|0){if(!(c[(c[c[g>>2]>>2]|0)+60>>2]|0))break;Ab[c[(c[c[g>>2]>>2]|0)+60>>2]&511](c[(c[g>>2]|0)+4>>2]|0,c[p>>2]|0)}while(0);Co(c[g>>2]|0)|0}if(c[(c[g>>2]|0)+68>>2]|0)dp(c[g>>2]|0,o)|0;c[(c[g>>2]|0)+172>>2]=7;continue a;break;
}case 0:{a[m>>0]=a[c[(c[k>>2]|0)+16>>2]>>0]|0;do if((d[m>>0]|0)!=32){if(9<=(d[m>>0]|0)?(d[m>>0]|0)<=10:0){y=20;break}if((d[m>>0]|0)==13)y=20}else y=20;while(0);do if((y|0)==20){y=0;Fo(c[g>>2]|0)|0;x=c[k>>2]|0;if(!(c[c[k>>2]>>2]|0)){c[l>>2]=(c[x+24>>2]|0)-((c[(c[k>>2]|0)+16>>2]|0)-(c[(c[k>>2]|0)+12>>2]|0));break}else{e=_y(c[(c[x>>2]|0)+16>>2]|0)|0;c[l>>2]=e-((c[(c[k>>2]|0)+16>>2]|0)-(c[(c[k>>2]|0)+12>>2]|0));break}}while(0);if((c[c[g>>2]>>2]|0)!=0?(c[(c[c[g>>2]>>2]|0)+44>>2]|0)!=0:0)Ab[c[(c[c[g>>2]>>2]|0)+44>>2]&511](c[(c[g>>2]|0)+4>>2]|0,136080);if(((c[c[g>>2]>>2]|0)!=0?(c[(c[c[g>>2]>>2]|0)+48>>2]|0)!=0:0)?(c[(c[g>>2]|0)+212>>2]|0)==0:0)zb[c[(c[c[g>>2]>>2]|0)+48>>2]&511](c[(c[g>>2]|0)+4>>2]|0);a[m>>0]=a[c[(c[k>>2]|0)+16>>2]>>0]|0;a[n>>0]=a[(c[(c[k>>2]|0)+16>>2]|0)+1>>0]|0;if(((((((((d[m>>0]|0)==60?(d[n>>0]|0)==33:0)?(WS(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+2>>0]|0)|0)==68:0)?(WS(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+3>>0]|0)|0)==79:0)?(WS(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+4>>0]|0)|0)==67:0)?(WS(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+5>>0]|0)|0)==84:0)?(WS(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+6>>0]|0)|0)==89:0)?(WS(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+7>>0]|0)|0)==80:0)?(WS(d[(c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]|0)+8>>0]|0)|0)==69:0){if((c[h>>2]|0)==0?(cp(c[g>>2]|0,62,0,0,0,1)|0)<0:0)break a;Io(c[g>>2]|0);c[(c[g>>2]|0)+172>>2]=4;continue a}c[(c[g>>2]|0)+172>>2]=1;continue a;break}case 14:{e=c[k>>2]|0;if(!(c[c[k>>2]>>2]|0))c[l>>2]=(c[e+24>>2]|0)-((c[(c[k>>2]|0)+16>>2]|0)-(c[(c[k>>2]|0)+12>>2]|0));else{x=_y(c[(c[e>>2]|0)+16>>2]|0)|0;c[l>>2]=x-((c[(c[k>>2]|0)+16>>2]|0)-(c[(c[k>>2]|0)+12>>2]|0))}if((c[l>>2]|0)<1)break a;a[m>>0]=a[c[(c[k>>2]|0)+16>>2]>>0]|0;if((d[m>>0]|0)==32){y=105;break a}if(9<=(d[m>>0]|0)?(d[m>>0]|0)<=10:0){y=105;break a}if((d[m>>0]|0)==13){y=105;break a}if((c[l>>2]|0)<2)break a;a[n>>0]=a[(c[(c[k>>2]|0)+16>>2]|0)+1>>0]|0;if((((d[m>>0]|0)==60?(d[n>>0]|0)==33:0)?(d[(c[(c[k>>2]|0)+16>>2]|0)+2>>0]|0)==45:0)?(d[(c[(c[k>>2]|0)+16>>2]|0)+3>>0]|0)==45:0){if((c[h>>2]|0)==0?(cp(c[g>>2]|0,45,45,62,1,1)|0)<0:0)break a;Go(c[g>>2]|0);c[(c[g>>2]|0)+172>>2]=14;continue a}if((d[m>>0]|0)!=60){y=119;break a}if((d[n>>0]|0)!=63){y=119;break a}if((c[h>>2]|0)==0?(cp(c[g>>2]|0,62,0,0,0,1)|0)<0:0)break a;Ho(c[g>>2]|0);c[(c[g>>2]|0)+172>>2]=14;continue a;break}case 4:{Fo(c[g>>2]|0)|0;x=c[k>>2]|0;if(!(c[c[k>>2]>>2]|0))c[l>>2]=(c[x+24>>2]|0)-((c[(c[k>>2]|0)+16>>2]|0)-(c[(c[k>>2]|0)+12>>2]|0));else{e=_y(c[(c[x>>2]|0)+16>>2]|0)|0;c[l>>2]=e-((c[(c[k>>2]|0)+16>>2]|0)-(c[(c[k>>2]|0)+12>>2]|0))}if((c[l>>2]|0)<2)break a;a[m>>0]=a[c[(c[k>>2]|0)+16>>2]>>0]|0;a[n>>0]=a[(c[(c[k>>2]|0)+16>>2]|0)+1>>0]|0;if((((d[m>>0]|0)==60?(d[n>>0]|0)==33:0)?(d[(c[(c[k>>2]|0)+16>>2]|0)+2>>0]|0)==45:0)?(d[(c[(c[k>>2]|0)+16>>2]|0)+3>>0]|0)==45:0){if((c[h>>2]|0)==0?(cp(c[g>>2]|0,45,45,62,1,1)|0)<0:0)break a;Go(c[g>>2]|0);c[(c[g>>2]|0)+172>>2]=4;continue a}if((d[m>>0]|0)==60?(d[n>>0]|0)==63:0){if((c[h>>2]|0)==0?(cp(c[g>>2]|0,62,0,0,0,1)|0)<0:0)break a;Ho(c[g>>2]|0);c[(c[g>>2]|0)+172>>2]=4;continue a}if((d[m>>0]|0)==60?(d[n>>0]|0)==33&(c[l>>2]|0)<4:0)break a;c[(c[g>>2]|0)+172>>2]=6;continue a;break}case 5:{zo(c[g>>2]|0,1,95184,0,0);c[(c[g>>2]|0)+172>>2]=7;c[(c[g>>2]|0)+204>>2]=0;continue a;break}case 2:{zo(c[g>>2]|0,1,95224,0,0);c[(c[g>>2]|0)+172>>2]=7;c[(c[g>>2]|0)+204>>2]=0;continue a;break}case 10:{zo(c[g>>2]|0,1,95264,0,0);c[(c[g>>2]|0)+172>>2]=7;c[(c[g>>2]|0)+204>>2]=0;continue a;break}case 11:{zo(c[g>>2]|0,1,95312,0,0);c[(c[g>>2]|0)+172>>2]=7;c[(c[g>>2]|0)+204>>2]=0;continue a;break}case 12:{zo(c[g>>2]|0,1,95360,0,0);c[(c[g>>2]|0)+172>>2]=6;c[(c[g>>2]|0)+204>>2]=0;continue a;break}case 13:{zo(c[g>>2]|0,1,95408,0,0);c[(c[g>>2]|0)+172>>2]=7;c[(c[g>>2]|0)+204>>2]=0;continue a;break}case 15:{zo(c[g>>2]|0,1,95472,0,0);c[(c[g>>2]|0)+172>>2]=7;c[(c[g>>2]|0)+204>>2]=0;continue a;break}case 16:{zo(c[g>>2]|0,1,95528,0,0);c[(c[g>>2]|0)+172>>2]=7;c[(c[g>>2]|0)+204>>2]=0;continue a;break}case-1:{break a;break}default:continue a}while(0)}do if((y|0)==105)Zo(c[g>>2]|0);else if((y|0)==119){if((d[m>>0]|0)==60?(d[n>>0]|0)==33&(c[l>>2]|0)<4:0)break;c[(c[g>>2]|0)+84>>2]=5;c[(c[g>>2]|0)+12>>2]=0;c[(c[g>>2]|0)+172>>2]=-1;if((c[c[g>>2]>>2]|0)!=0?(c[(c[c[g>>2]>>2]|0)+52>>2]|0)!=0:0)zb[c[(c[c[g>>2]>>2]|0)+52>>2]&511](c[(c[g>>2]|0)+4>>2]|0)}while(0);if(((((c[l>>2]|0)==0&(c[h>>2]|0)!=0?(Do(c[g>>2]|0),(c[(c[g>>2]|0)+188>>2]|0)==0):0)?(c[(c[g>>2]|0)+172>>2]|0)!=-1:0)?(c[(c[g>>2]|0)+172>>2]=-1,(c[c[g>>2]>>2]|0)!=0):0)?(c[(c[c[g>>2]>>2]|0)+52>>2]|0)!=0:0)zb[c[(c[c[g>>2]>>2]|0)+52>>2]&511](c[(c[g>>2]|0)+4>>2]|0);if(c[(c[g>>2]|0)+360>>2]&4){z=c[j>>2]|0;i=f;return z|0}if(!(c[(c[g>>2]|0)+8>>2]|0)){z=c[j>>2]|0;i=f;return z|0}if(((c[h>>2]|0)==0?(c[(c[g>>2]|0)+172>>2]|0)!=-1:0)?(c[(c[g>>2]|0)+172>>2]|0)!=14:0){z=c[j>>2]|0;i=f;return z|0}c[w>>2]=Nh(c[(c[g>>2]|0)+8>>2]|0)|0;if(c[w>>2]|0){z=c[j>>2]|0;i=f;return z|0}w=Oh(c[(c[g>>2]|0)+8>>2]|0,94240,94296,94248)|0;c[(c[(c[g>>2]|0)+8>>2]|0)+44>>2]=w;z=c[j>>2]|0;i=f;return z|0}function Lo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](60)|0;if(!(c[f>>2]|0)){xo(c[e>>2]|0,94952);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{e=(c[f>>2]|0)+0|0;a=e+60|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(a|0));c[(c[f>>2]|0)+4>>2]=0;c[(c[f>>2]|0)+8>>2]=0;c[(c[f>>2]|0)+12>>2]=0;c[(c[f>>2]|0)+16>>2]=0;c[c[f>>2]>>2]=0;c[(c[f>>2]|0)+28>>2]=1;c[(c[f>>2]|0)+32>>2]=1;c[c[f>>2]>>2]=0;c[(c[f>>2]|0)+40>>2]=0;c[(c[f>>2]|0)+48>>2]=0;c[(c[f>>2]|0)+36>>2]=0;c[(c[f>>2]|0)+24>>2]=0;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function Mo(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;if(!(c[g>>2]|0)){i=e;return}c[h>>2]=yy(c[g>>2]|0,94816)|0;if(c[h>>2]|0)c[h>>2]=(c[h>>2]|0)+7;a:do if(c[h>>2]|0){do if((d[c[h>>2]>>0]|0|0)!=32){if(9<=(d[c[h>>2]>>0]|0|0)?(d[c[h>>2]>>0]|0|0)<=10:0)break;if((d[c[h>>2]>>0]|0|0)!=13)break a}while(0);c[h>>2]=yy(c[g>>2]|0,94824)|0}while(0);if(!(c[h>>2]|0)){i=e;return}if((d[c[h>>2]>>0]|0|0)!=61){i=e;return}c[h>>2]=(c[h>>2]|0)+1;gp(c[f>>2]|0,c[h>>2]|0);i=e;return}function No(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+32|0;h=g+24|0;j=g+20|0;k=g+16|0;l=g+12|0;m=g+8|0;n=g+4|0;o=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;to(c[h>>2]|0,c[l>>2]|0)|0;c[(c[h>>2]|0)+32>>2]=1;if((c[k>>2]|0)!=0?(c[o>>2]=Dd(c[k>>2]|0)|0,(c[o>>2]|0)!=0):0){se(c[h>>2]|0,c[o>>2]|0)|0;if(c[(c[(c[h>>2]|0)+36>>2]|0)+44>>2]|0)zb[c[135736>>2]&511](c[(c[(c[h>>2]|0)+36>>2]|0)+44>>2]|0);o=my(c[k>>2]|0)|0;c[(c[(c[h>>2]|0)+36>>2]|0)+44>>2]=o}if(((c[j>>2]|0)!=0?(c[(c[h>>2]|0)+36>>2]|0)!=0:0)?(c[(c[(c[h>>2]|0)+36>>2]|0)+4>>2]|0)==0:0){o=my(c[j>>2]|0)|0;c[(c[(c[h>>2]|0)+36>>2]|0)+4>>2]=o}ko(c[h>>2]|0)|0;c[n>>2]=c[(c[h>>2]|0)+8>>2];c[(c[h>>2]|0)+8>>2]=0;if(c[m>>2]|0){p=c[n>>2]|0;i=g;return p|0}if(((c[n>>2]|0)!=0?(c[(c[h>>2]|0)+364>>2]|0)!=0:0)?(c[(c[n>>2]|0)+80>>2]|0)==(c[(c[h>>2]|0)+296>>2]|0):0)c[(c[h>>2]|0)+296>>2]=0;Ae(c[h>>2]|0);p=c[n>>2]|0;i=g;return p|0}function Oo(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+32|0;e=b+20|0;f=b+16|0;g=b+12|0;h=b+8|0;j=b+4|0;k=b;c[f>>2]=a;c[g>>2]=0;c[k>>2]=0;if((c[(c[f>>2]|0)+292>>2]|0)==0?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)ke(c[(c[f>>2]|0)+36>>2]|0,250)|0;c[j>>2]=ap(c[f>>2]|0,h)|0;a:do if(!((c[j>>2]|0)==32|(c[j>>2]|0)==62|(c[j>>2]|0)==47)){a=c[j>>2]|0;if((c[j>>2]|0)<256){if(((!(65<=(a|0)&(c[j>>2]|0)<=90)?!(97<=(c[j>>2]|0)&(c[j>>2]|0)<=122):0)?!(192<=(c[j>>2]|0)&(c[j>>2]|0)<=214):0)?!(216<=(c[j>>2]|0)&(c[j>>2]|0)<=246|248<=(c[j>>2]|0)):0)l=11}else if(!(DQ(a,199744)|0))l=11;do if((l|0)==11){a=c[j>>2]|0;if((c[j>>2]|0)<256)if((a|0)!=95&(c[j>>2]|0)!=58)break a;else break;if(!(19968<=(a|0)&(c[j>>2]|0)<=40869|(c[j>>2]|0)==12295)?(12321<=(c[j>>2]|0)&(c[j>>2]|0)<=12329^1)&(c[j>>2]|0)!=95&(c[j>>2]|0)!=58:0)break a}while(0);b:while(1){if(!((c[j>>2]|0)!=32&(c[j>>2]|0)!=62&(c[j>>2]|0)!=47))break;a=c[j>>2]|0;if((c[j>>2]|0)<256){if(((!(65<=(a|0)&(c[j>>2]|0)<=90)?!(97<=(c[j>>2]|0)&(c[j>>2]|0)<=122):0)?!(192<=(c[j>>2]|0)&(c[j>>2]|0)<=214):0)?!(216<=(c[j>>2]|0)&(c[j>>2]|0)<=246|248<=(c[j>>2]|0)):0)l=23}else if(!(DQ(a,199744)|0))l=23;do if((l|0)==23){l=0;if((c[j>>2]|0)>=256){if(19968<=(c[j>>2]|0)&(c[j>>2]|0)<=40869|(c[j>>2]|0)==12295)break;if(12321<=(c[j>>2]|0)&(c[j>>2]|0)<=12329)break}a=c[j>>2]|0;if((c[j>>2]|0)<256){if(48<=(a|0)&(c[j>>2]|0)<=57|(c[j>>2]|0)==46|(c[j>>2]|0)==45|(c[j>>2]|0)==95|(c[j>>2]|0)==58)break}else{m=(DQ(a,200216)|0)!=0;if(m|(c[j>>2]|0)==46|(c[j>>2]|0)==45|(c[j>>2]|0)==95|(c[j>>2]|0)==58)break}if((c[j>>2]|0)>=256?(DQ(c[j>>2]|0,200144)|0)!=0:0)break;m=c[j>>2]|0;if((c[j>>2]|0)<256)n=(m|0)==183&1;else n=DQ(m,200272)|0;if(!n)break b}while(0);m=c[k>>2]|0;c[k>>2]=m+1;if(((m|0)>100?(c[k>>2]=0,(c[(c[f>>2]|0)+292>>2]|0)==0):0)?((c[(c[(c[f>>2]|0)+36>>2]|0)+20>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)|0)<250:0)ke(c[(c[f>>2]|0)+36>>2]|0,250)|0;c[g>>2]=(c[g>>2]|0)+(c[h>>2]|0);m=c[(c[f>>2]|0)+36>>2]|0;if((d[c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==10){a=m+28|0;c[a>>2]=(c[a>>2]|0)+1;c[(c[(c[f>>2]|0)+36>>2]|0)+32>>2]=1}else{a=m+32|0;c[a>>2]=(c[a>>2]|0)+1}c[(c[f>>2]|0)+176>>2]=0;a=(c[(c[f>>2]|0)+36>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+(c[h>>2]|0);a=(c[f>>2]|0)+200|0;c[a>>2]=(c[a>>2]|0)+1;c[j>>2]=ap(c[f>>2]|0,h)|0}c[e>>2]=AP(c[(c[f>>2]|0)+296>>2]|0,(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)+(0-(c[g>>2]|0))|0,c[g>>2]|0)|0;o=c[e>>2]|0;i=b;return o|0}while(0);c[e>>2]=0;o=c[e>>2]|0;i=b;return o|0}function Po(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+112|0;f=e+8|0;g=e+4|0;h=e;j=e+12|0;c[g>>2]=b;c[h>>2]=0;if(!(65<=(d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=90:0))k=3;do if((k|0)==3){if(97<=(d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=122:0)break;if(((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=95?(d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=58:0)?(d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=46:0){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}}while(0);while(1){do if((c[h>>2]|0)<100){if(65<=(d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=90:0){m=1;break}if(97<=(d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=122:0){m=1;break}if(48<=(d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)?(d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=57:0){m=1;break}if(((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=58?(d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=45:0)?(d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)!=95:0)m=(d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==46;else m=1}else m=0;while(0);n=c[g>>2]|0;if(!m)break;if((d[c[(c[n+36>>2]|0)+16>>2]>>0]|0|0)>=65?(d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)<=90:0)a[j+(c[h>>2]|0)>>0]=(d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0)+32;else a[j+(c[h>>2]|0)>>0]=d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0;c[h>>2]=(c[h>>2]|0)+1;me(c[g>>2]|0)}c[f>>2]=AP(c[n+296>>2]|0,j,c[h>>2]|0)|0;l=c[f>>2]|0;i=e;return l|0}function Qo(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;while(1){if(!(c[f>>2]|0))break;if(!(c[(c[e>>2]|0)+184>>2]|0))break;if(!(wo(c[f>>2]|0,c[(c[e>>2]|0)+184>>2]|0)|0))break;if((c[c[e>>2]>>2]|0)!=0?(c[(c[c[e>>2]>>2]|0)+60>>2]|0)!=0:0)Ab[c[(c[c[e>>2]>>2]|0)+60>>2]&511](c[(c[e>>2]|0)+4>>2]|0,c[(c[e>>2]|0)+184>>2]|0);Co(c[e>>2]|0)|0}if(!(c[f>>2]|0)){Do(c[e>>2]|0);i=d;return}while(1){if(c[f>>2]|0){g=20;break}if(!(c[(c[e>>2]|0)+184>>2]|0)){g=20;break}if(((qy(c[(c[e>>2]|0)+184>>2]|0,95656)|0)==0?(qy(c[(c[e>>2]|0)+184>>2]|0,95648)|0)==0:0)?(qy(c[(c[e>>2]|0)+184>>2]|0,94240)|0)==0:0){g=20;break}if((c[c[e>>2]>>2]|0)!=0?(c[(c[c[e>>2]>>2]|0)+60>>2]|0)!=0:0)Ab[c[(c[c[e>>2]>>2]|0)+60>>2]&511](c[(c[e>>2]|0)+4>>2]|0,c[(c[e>>2]|0)+184>>2]|0);Co(c[e>>2]|0)|0}if((g|0)==20){i=d;return}}function Ro(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;if(!((c[23702]|0)!=0?(c[(c[e>>2]|0)+360>>2]&8192|0)==0:0)){i=d;return}if(qy(c[f>>2]|0,94240)|0){i=d;return}if(((c[(c[e>>2]|0)+188>>2]|0)<=0?(Uo(c[e>>2]|0,94240)|0,(c[c[e>>2]>>2]|0)!=0):0)?(c[(c[c[e>>2]>>2]|0)+56>>2]|0)!=0:0)Db[c[(c[c[e>>2]>>2]|0)+56>>2]&511](c[(c[e>>2]|0)+4>>2]|0,94240,0);if(qy(c[f>>2]|0,95648)|0){i=d;return}if(qy(c[f>>2]|0,95656)|0){i=d;return}do if((c[(c[e>>2]|0)+188>>2]|0)<=1){if((((((qy(c[f>>2]|0,94992)|0)==0?(qy(c[f>>2]|0,95e3)|0)==0:0)?(qy(c[f>>2]|0,96200)|0)==0:0)?(qy(c[f>>2]|0,96208)|0)==0:0)?(qy(c[f>>2]|0,96216)|0)==0:0)?(qy(c[f>>2]|0,96224)|0)==0:0)break;if((c[(c[e>>2]|0)+32>>2]|0)>=3){i=d;return}Uo(c[e>>2]|0,95656)|0;if(!(c[c[e>>2]>>2]|0)){i=d;return}if(!(c[(c[c[e>>2]>>2]|0)+56>>2]|0)){i=d;return}Db[c[(c[c[e>>2]>>2]|0)+56>>2]&511](c[(c[e>>2]|0)+4>>2]|0,95656,0);i=d;return}while(0);if(qy(c[f>>2]|0,96232)|0){i=d;return}if(qy(c[f>>2]|0,96248)|0){i=d;return}if(qy(c[f>>2]|0,96256)|0){i=d;return}if((c[(c[e>>2]|0)+32>>2]|0)>=10){i=d;return}c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[(c[e>>2]|0)+188>>2]|0)){h=29;break}if(qy(c[(c[(c[e>>2]|0)+196>>2]|0)+(c[g>>2]<<2)>>2]|0,95648)|0){h=32;break}if(qy(c[(c[(c[e>>2]|0)+196>>2]|0)+(c[g>>2]<<2)>>2]|0,95656)|0){h=32;break}c[g>>2]=(c[g>>2]|0)+1}if((h|0)==29){Uo(c[e>>2]|0,95648)|0;if(!(c[c[e>>2]>>2]|0)){i=d;return}if(!(c[(c[c[e>>2]>>2]|0)+56>>2]|0)){i=d;return}Db[c[(c[c[e>>2]>>2]|0)+56>>2]&511](c[(c[e>>2]|0)+4>>2]|0,95648,0);i=d;return}else if((h|0)==32){i=d;return}}function So(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[k>>2]=0;c[c[h>>2]>>2]=0;c[j>>2]=Po(c[g>>2]|0)|0;b=c[g>>2]|0;if(!(c[j>>2]|0)){zo(b,68,97912,0,0);c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}Fo(b)|0;if((d[c[(c[(c[g>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==61){me(c[g>>2]|0);Fo(c[g>>2]|0)|0;c[k>>2]=hp(c[g>>2]|0)|0}c[c[h>>2]>>2]=c[k>>2];c[f>>2]=c[j>>2];l=c[f>>2]|0;i=e;return l|0}function To(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[e>>2]=a;c[f>>2]=b;c[k>>2]=0;c[l>>2]=0;if((c[e>>2]|0)==0|(c[f>>2]|0)==0){i=d;return}c[g>>2]=0;b=c[g>>2]|0;c[g>>2]=b+1;c[h>>2]=c[(c[f>>2]|0)+(b<<2)>>2];while(1){if(!(c[h>>2]|0))break;b=c[g>>2]|0;c[g>>2]=b+1;c[j>>2]=c[(c[f>>2]|0)+(b<<2)>>2];if(((c[j>>2]|0)!=0?(ty(c[h>>2]|0,97872)|0)==0:0)?(ty(c[j>>2]|0,97888)|0)==0:0)c[k>>2]=1;else m=8;do if((m|0)==8){m=0;if((c[j>>2]|0)!=0?(ty(c[h>>2]|0,94816)|0)==0:0){gp(c[e>>2]|0,c[j>>2]|0);break}if((c[j>>2]|0)!=0?(ty(c[h>>2]|0,97904)|0)==0:0)c[l>>2]=c[j>>2]}while(0);b=c[g>>2]|0;c[g>>2]=b+1;c[h>>2]=c[(c[f>>2]|0)+(b<<2)>>2]}if(!((c[k>>2]|0)!=0&(c[l>>2]|0)!=0)){i=d;return}Mo(c[e>>2]|0,c[l>>2]|0);i=d;return}function Uo(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if((c[(c[f>>2]|0)+32>>2]|0)<3?(qy(c[g>>2]|0,95656)|0)!=0:0)c[(c[f>>2]|0)+32>>2]=3;if((c[(c[f>>2]|0)+32>>2]|0)<10?(qy(c[g>>2]|0,95648)|0)!=0:0)c[(c[f>>2]|0)+32>>2]=10;if((c[(c[f>>2]|0)+188>>2]|0)>=(c[(c[f>>2]|0)+192>>2]|0)?(b=(c[f>>2]|0)+192|0,c[b>>2]=c[b>>2]<<1,b=Hb[c[135760>>2]&511](c[(c[f>>2]|0)+196>>2]|0,c[(c[f>>2]|0)+192>>2]<<2)|0,c[(c[f>>2]|0)+196>>2]=b,(c[(c[f>>2]|0)+196>>2]|0)==0):0){xo(c[f>>2]|0,0);c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}c[(c[(c[f>>2]|0)+196>>2]|0)+(c[(c[f>>2]|0)+188>>2]<<2)>>2]=c[g>>2];c[(c[f>>2]|0)+184>>2]=c[g>>2];g=(c[f>>2]|0)+188|0;f=c[g>>2]|0;c[g>>2]=f+1;c[e>>2]=f;h=c[e>>2]|0;i=d;return h|0}function rF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;b=i;i=i+80|0;d=b+64|0;e=b+60|0;f=b+56|0;g=b+52|0;h=b+48|0;j=b+44|0;k=b+40|0;l=b+36|0;m=b+32|0;n=b+28|0;o=b+24|0;p=b+20|0;q=b+16|0;r=b+12|0;s=b+8|0;t=b+4|0;u=b;c[e>>2]=a;c[f>>2]=c[(c[(c[e>>2]|0)+108>>2]|0)+56>>2];a:while(1){if(!(c[f>>2]|0)){v=48;break}b:do if(((c[(c[f>>2]|0)+20>>2]|0)==24?(c[(c[f>>2]|0)+32>>2]|0)!=0:0)?(c[(c[(c[f>>2]|0)+32>>2]|0)+4>>2]|0)!=0:0){c[q>>2]=0;c[m>>2]=c[(c[(c[(c[f>>2]|0)+16>>2]|0)+4>>2]|0)+32>>2];c[g>>2]=c[(c[(c[e>>2]|0)+108>>2]|0)+52>>2];while(1){if(!(c[g>>2]|0))break;if((c[(c[(c[(c[(c[f>>2]|0)+16>>2]|0)+4>>2]|0)+36>>2]|0)+4>>2]|0)==(c[(c[g>>2]|0)+4>>2]|0))break;c[g>>2]=c[c[g>>2]>>2]}if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+20>>2]|0)!=0:0)w=(c[(c[(c[g>>2]|0)+20>>2]|0)+4>>2]|0)!=0;else w=0;c[n>>2]=w?1:0;c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[(c[(c[f>>2]|0)+32>>2]|0)+4>>2]|0))break b;c[l>>2]=0;c[q>>2]=c[(c[c[(c[f>>2]|0)+32>>2]>>2]|0)+(c[h>>2]<<2)>>2];c:do if(c[g>>2]|0){c[o>>2]=c[(c[q>>2]|0)+4>>2];c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[(c[g>>2]|0)+12>>2]|0))break;c[p>>2]=c[(c[(c[(c[g>>2]|0)+8>>2]|0)+(c[j>>2]<<2)>>2]|0)+4>>2];c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[m>>2]|0))break;c[l>>2]=VD(c[(c[(c[p>>2]|0)+(c[k>>2]<<2)>>2]|0)+4>>2]|0,c[(c[(c[o>>2]|0)+(c[k>>2]<<2)>>2]|0)+4>>2]|0)|0;if(!(c[l>>2]|0))break;if((c[l>>2]|0)==-1){v=22;break a}c[k>>2]=(c[k>>2]|0)+1}if((c[l>>2]|0)==1)break;c[j>>2]=(c[j>>2]|0)+1}if((c[l>>2]|0)==0&(c[n>>2]|0)!=0){c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[(c[(c[g>>2]|0)+20>>2]|0)+4>>2]|0))break c;c[p>>2]=c[(c[(c[c[(c[g>>2]|0)+20>>2]>>2]|0)+(c[j>>2]<<2)>>2]|0)+4>>2];c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[m>>2]|0))break;c[l>>2]=VD(c[(c[(c[p>>2]|0)+(c[k>>2]<<2)>>2]|0)+4>>2]|0,c[(c[(c[o>>2]|0)+(c[k>>2]<<2)>>2]|0)+4>>2]|0)|0;if(!(c[l>>2]|0))break;if((c[l>>2]|0)==-1){v=33;break a}c[k>>2]=(c[k>>2]|0)+1}if((c[l>>2]|0)==1)break;c[j>>2]=(c[j>>2]|0)+1}c[r>>2]=0;c[s>>2]=0;a=c[e>>2]|0;x=c[q>>2]|0;y=c[(c[(c[f>>2]|0)+16>>2]|0)+4>>2]|0;z=$G(c[e>>2]|0,r,c[(c[q>>2]|0)+4>>2]|0,c[m>>2]|0)|0;eH(a,1877,x,y,142400,z,YD(s,c[(c[(c[f>>2]|0)+16>>2]|0)+4>>2]|0)|0);if(c[r>>2]|0){zb[c[135736>>2]&511](c[r>>2]|0);c[r>>2]=0}if(c[s>>2]|0){zb[c[135736>>2]&511](c[s>>2]|0);c[s>>2]=0}}}while(0);if(!(c[l>>2]|0)){c[t>>2]=0;c[u>>2]=0;z=c[e>>2]|0;y=c[q>>2]|0;x=c[(c[(c[f>>2]|0)+16>>2]|0)+4>>2]|0;a=$G(c[e>>2]|0,t,c[(c[q>>2]|0)+4>>2]|0,c[m>>2]|0)|0;eH(z,1877,y,x,142464,a,YD(u,c[(c[(c[f>>2]|0)+16>>2]|0)+4>>2]|0)|0);if(c[t>>2]|0){zb[c[135736>>2]&511](c[t>>2]|0);c[t>>2]=0}if(c[u>>2]|0){zb[c[135736>>2]&511](c[u>>2]|0);c[u>>2]=0}}c[h>>2]=(c[h>>2]|0)+1}}while(0);c[f>>2]=c[(c[f>>2]|0)+8>>2]}if((v|0)==22){c[d>>2]=-1;A=c[d>>2]|0;i=b;return A|0}else if((v|0)==33){c[d>>2]=-1;A=c[d>>2]|0;i=b;return A|0}else if((v|0)==48){c[d>>2]=0;A=c[d>>2]|0;i=b;return A|0}return 0}function sF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;i=i+80|0;d=b+64|0;e=b+60|0;f=b+56|0;g=b+52|0;h=b+48|0;j=b+44|0;k=b+40|0;l=b+36|0;m=b+32|0;n=b+28|0;o=b+24|0;p=b+20|0;q=b+16|0;r=b+12|0;s=b+8|0;t=b+4|0;u=b;c[e>>2]=a;c[h>>2]=0;c[k>>2]=0;c[r>>2]=0;c[f>>2]=c[(c[(c[e>>2]|0)+108>>2]|0)+52>>2];if(!(c[f>>2]|0)){c[d>>2]=0;v=c[d>>2]|0;i=b;return v|0}c[g>>2]=(c[(c[(c[e>>2]|0)+100>>2]|0)+((c[(c[e>>2]|0)+96>>2]|0)-1<<2)>>2]|0)+52;a:while(1){if(!(c[f>>2]|0)){w=87;break}if(!(c[(c[f>>2]|0)+12>>2]|0)){if((c[(c[f>>2]|0)+20>>2]|0)!=0?(c[(c[(c[f>>2]|0)+20>>2]|0)+4>>2]|0)!=0:0)w=8}else w=8;b:do if((w|0)==8){w=0;c:do if(!(c[(c[e>>2]|0)+188>>2]|0)){c[n>>2]=c[(c[e>>2]|0)+112>>2];while(1){x=c[n>>2]|0;if((c[(c[n>>2]|0)+4>>2]|0)==(c[(c[f>>2]|0)+4>>2]|0))break;c[n>>2]=c[x>>2];if(!(c[n>>2]|0))break c}if((c[x+8>>2]|0)==-1)break b;if((c[(c[n>>2]|0)+8>>2]|0)>=(c[(c[e>>2]|0)+96>>2]|0))break b}while(0);if(c[g>>2]|0)c[h>>2]=c[c[g>>2]>>2];while(1){if(!(c[h>>2]|0))break;if((c[(c[h>>2]|0)+4>>2]|0)==(c[(c[f>>2]|0)+4>>2]|0))break;c[h>>2]=c[c[h>>2]>>2]}if(!(c[h>>2]|0)){c[h>>2]=fH(c[(c[f>>2]|0)+4>>2]|0)|0;if(!(c[h>>2]|0))break a;do if(c[(c[f>>2]|0)+12>>2]|0){if(!(c[(c[e>>2]|0)+192>>2]|0)){c[(c[h>>2]|0)+8>>2]=c[(c[f>>2]|0)+8>>2];c[(c[f>>2]|0)+8>>2]=0;c[(c[h>>2]|0)+16>>2]=c[(c[f>>2]|0)+16>>2];c[(c[f>>2]|0)+16>>2]=0;c[(c[h>>2]|0)+12>>2]=c[(c[f>>2]|0)+12>>2];c[(c[f>>2]|0)+12>>2]=0;break}a=Cb[c[135744>>2]&511](c[(c[f>>2]|0)+12>>2]<<2)|0;c[(c[h>>2]|0)+8>>2]=a;if(!(c[(c[h>>2]|0)+8>>2]|0)){w=76;break a}c[(c[h>>2]|0)+16>>2]=c[(c[f>>2]|0)+12>>2];c[(c[h>>2]|0)+12>>2]=c[(c[f>>2]|0)+12>>2];eU(c[(c[h>>2]|0)+8>>2]|0,c[(c[f>>2]|0)+8>>2]|0,c[(c[f>>2]|0)+12>>2]<<2|0)|0}while(0);if(c[(c[f>>2]|0)+20>>2]|0){if(c[(c[h>>2]|0)+20>>2]|0)oB(c[(c[h>>2]|0)+20>>2]|0);c[(c[h>>2]|0)+20>>2]=c[(c[f>>2]|0)+20>>2];c[(c[f>>2]|0)+20>>2]=0}if(!(c[g>>2]|0))break;if(!(c[c[g>>2]>>2]|0)){c[c[g>>2]>>2]=c[h>>2];break}else{c[c[h>>2]>>2]=c[c[g>>2]>>2];c[c[g>>2]>>2]=c[h>>2];break}}c[t>>2]=c[(c[h>>2]|0)+12>>2];if((c[(c[h>>2]|0)+20>>2]|0)!=0?(c[(c[(c[h>>2]|0)+20>>2]|0)+4>>2]|0)!=0:0){c[u>>2]=c[(c[(c[h>>2]|0)+20>>2]|0)+4>>2];c[l>>2]=c[c[(c[h>>2]|0)+20>>2]>>2]}else{c[l>>2]=0;c[u>>2]=0}c[m>>2]=c[(c[h>>2]|0)+8>>2];c[s>>2]=c[(c[(c[f>>2]|0)+4>>2]|0)+32>>2];c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[(c[f>>2]|0)+12>>2]|0))break b;c[j>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+(c[o>>2]<<2)>>2];do if(c[j>>2]|0){if(c[u>>2]|0){c[p>>2]=0;d:while(1){if((c[p>>2]|0)>=(c[u>>2]|0))break;e:do if((c[s>>2]|0)==1){c[r>>2]=VD(c[(c[c[(c[j>>2]|0)+4>>2]>>2]|0)+4>>2]|0,c[(c[c[(c[(c[l>>2]|0)+(c[p>>2]<<2)>>2]|0)+4>>2]>>2]|0)+4>>2]|0)|0;if((c[r>>2]|0)==-1)break a;if(c[r>>2]|0)break;c[p>>2]=(c[p>>2]|0)+1;continue d}else{c[k>>2]=c[(c[l>>2]|0)+(c[p>>2]<<2)>>2];c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[s>>2]|0))break e;c[r>>2]=VD(c[(c[(c[(c[j>>2]|0)+4>>2]|0)+(c[q>>2]<<2)>>2]|0)+4>>2]|0,c[(c[(c[(c[k>>2]|0)+4>>2]|0)+(c[q>>2]<<2)>>2]|0)+4>>2]|0)|0;if((c[r>>2]|0)==-1)break a;if(!(c[r>>2]|0))break e;c[q>>2]=(c[q>>2]|0)+1}}while(0);if((c[r>>2]|0)==1)break;c[p>>2]=(c[p>>2]|0)+1}if(!((c[t>>2]|0)!=0?(c[p>>2]|0)==(c[u>>2]|0):0))break}else if(!(c[t>>2]|0))break;c[p>>2]=0;f:while(1){if((c[p>>2]|0)>=(c[t>>2]|0))break;c[k>>2]=c[(c[m>>2]|0)+(c[p>>2]<<2)>>2];g:do if((c[s>>2]|0)==1){c[r>>2]=VD(c[(c[c[(c[j>>2]|0)+4>>2]>>2]|0)+4>>2]|0,c[(c[c[(c[k>>2]|0)+4>>2]>>2]|0)+4>>2]|0)|0;if((c[r>>2]|0)==-1)break a;if(!(c[r>>2]|0)){c[p>>2]=(c[p>>2]|0)+1;continue f}}else{c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[s>>2]|0))break g;c[r>>2]=VD(c[(c[(c[(c[j>>2]|0)+4>>2]|0)+(c[q>>2]<<2)>>2]|0)+4>>2]|0,c[(c[(c[(c[k>>2]|0)+4>>2]|0)+(c[q>>2]<<2)>>2]|0)+4>>2]|0)|0;if((c[r>>2]|0)==-1)break a;if(!(c[r>>2]|0))break g;c[q>>2]=(c[q>>2]|0)+1}}while(0);if((c[r>>2]|0)==1)break;c[p>>2]=(c[p>>2]|0)+1}if((c[p>>2]|0)!=(c[t>>2]|0)){c[t>>2]=(c[t>>2]|0)+-1;a=(c[h>>2]|0)+12|0;c[a>>2]=(c[a>>2]|0)+-1;c[(c[m>>2]|0)+(c[p>>2]<<2)>>2]=c[(c[m>>2]|0)+(c[t>>2]<<2)>>2];if((c[(c[h>>2]|0)+12>>2]|0)!=(c[t>>2]|0))c[(c[m>>2]|0)+(c[t>>2]<<2)>>2]=c[(c[m>>2]|0)+(c[(c[h>>2]|0)+12>>2]<<2)>>2];if((c[(c[h>>2]|0)+20>>2]|0)==0?(a=JB()|0,c[(c[h>>2]|0)+20>>2]=a,(c[(c[h>>2]|0)+20>>2]|0)==0):0)break a;bE(c[(c[h>>2]|0)+20>>2]|0,c[k>>2]|0)|0;break}if(c[(c[h>>2]|0)+8>>2]|0){if((c[(c[h>>2]|0)+12>>2]|0)>=(c[(c[h>>2]|0)+16>>2]|0)?(a=(c[h>>2]|0)+16|0,c[a>>2]=c[a>>2]<<1,a=Hb[c[135760>>2]&511](c[(c[h>>2]|0)+8>>2]|0,c[(c[h>>2]|0)+16>>2]<<2)|0,c[(c[h>>2]|0)+8>>2]=a,(c[(c[h>>2]|0)+8>>2]|0)==0):0){w=68;break a}}else{a=Cb[c[135744>>2]&511](40)|0;c[(c[h>>2]|0)+8>>2]=a;if(!(c[(c[h>>2]|0)+8>>2]|0)){w=64;break a}c[(c[h>>2]|0)+16>>2]=1}c[m>>2]=c[(c[h>>2]|0)+8>>2];a=c[j>>2]|0;y=(c[h>>2]|0)+12|0;z=c[y>>2]|0;c[y>>2]=z+1;c[(c[m>>2]|0)+(z<<2)>>2]=a}while(0);c[o>>2]=(c[o>>2]|0)+1}}while(0);c[f>>2]=c[c[f>>2]>>2]}if((w|0)==64)IB(0,142168,0);else if((w|0)==68)IB(0,142208,0);else if((w|0)==76){IB(0,142256,0);OD(c[h>>2]|0)}else if((w|0)==87){c[d>>2]=0;v=c[d>>2]|0;i=b;return v|0}c[d>>2]=-1;v=c[d>>2]|0;i=b;return v|0}function tF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=rB()|0;if(!(c[h>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}c[(c[h>>2]|0)+80>>2]=c[g>>2];yP(c[g>>2]|0)|0;if(c[f>>2]|0){b=AP(c[g>>2]|0,c[f>>2]|0,-1)|0;c[(c[h>>2]|0)+44>>2]=b}c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}function uF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=Cb[c[135744>>2]&511](12)|0;if(!(c[g>>2]|0)){IB(c[f>>2]|0,141168,0);i=d;return}c[(c[g>>2]|0)+8>>2]=-1;c[(c[g>>2]|0)+4>>2]=c[e>>2];c[c[g>>2]>>2]=0;if(!(c[(c[f>>2]|0)+112>>2]|0))c[(c[f>>2]|0)+112>>2]=c[g>>2];else{c[c[g>>2]>>2]=c[(c[f>>2]|0)+112>>2];c[(c[f>>2]|0)+112>>2]=c[g>>2]}if(c[(c[f>>2]|0)+184>>2]|0){i=d;return}if((c[c[e>>2]>>2]|0)!=24){i=d;return}c[(c[f>>2]|0)+184>>2]=1;i=d;return}function vF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+32|0;d=b+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[d>>2]=a;while(1){if(!(c[d>>2]|0))break;c[e>>2]=c[(c[d>>2]|0)+8>>2];if(c[(c[d>>2]|0)+24>>2]|0){c[f>>2]=0;while(1){if((c[f>>2]|0)>=(c[(c[d>>2]|0)+28>>2]|0))break;if(c[(c[(c[d>>2]|0)+24>>2]|0)+(c[f>>2]<<2)>>2]|0)zb[c[135736>>2]&511](c[(c[(c[d>>2]|0)+24>>2]|0)+(c[f>>2]<<2)>>2]|0);c[f>>2]=(c[f>>2]|0)+1}zb[c[135736>>2]&511](c[(c[d>>2]|0)+24>>2]|0)}if(c[(c[d>>2]|0)+32>>2]|0){a:do if((c[(c[d>>2]|0)+20>>2]|0)==24){c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[(c[(c[d>>2]|0)+32>>2]|0)+4>>2]|0))break a;c[h>>2]=c[(c[c[(c[d>>2]|0)+32>>2]>>2]|0)+(c[g>>2]<<2)>>2];zb[c[135736>>2]&511](c[(c[h>>2]|0)+4>>2]|0);zb[c[135736>>2]&511](c[h>>2]|0);c[g>>2]=(c[g>>2]|0)+1}}while(0);oB(c[(c[d>>2]|0)+32>>2]|0)}zb[c[135736>>2]&511](c[d>>2]|0);c[d>>2]=c[e>>2]}i=b;return}function wF(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(c[c[d>>2]>>2]|0){zb[c[135736>>2]&511](c[c[d>>2]>>2]|0);c[c[d>>2]>>2]=0}c[(c[d>>2]|0)+4>>2]=0;c[(c[d>>2]|0)+8>>2]=0;i=b;return}function xF(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;do switch(c[e>>2]|0){case 18:{c[d>>2]=143832;break}case 17:{c[d>>2]=143776;break}case 24:{c[d>>2]=144e3;break}case 6:{c[d>>2]=143856;break}case 8:{c[d>>2]=143904;break}case 22:{c[d>>2]=143944;break}case 23:{c[d>>2]=143976;break}case 16:{c[d>>2]=143800;break}case 26:{c[d>>2]=143736;break}case 14:{c[d>>2]=143712;break}case 1:{c[d>>2]=143688;break}case 2e3:{c[d>>2]=144048;break}case 7:{c[d>>2]=143880;break}case 2001:{c[d>>2]=144088;break}case 4:{c[d>>2]=143688;break}case 25:{c[d>>2]=143928;break}case 5:{c[d>>2]=143664;break}case 2:{c[d>>2]=144032;break}case 15:{c[d>>2]=143752;break}default:c[d>>2]=144136}while(0);i=b;return c[d>>2]|0}function yF(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+32|0;k=j+24|0;l=j+20|0;m=j+16|0;n=j+12|0;o=j+8|0;p=j+4|0;q=j;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=h;$D(c[k>>2]|0,2,c[l>>2]|0,c[m>>2]|0,0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,0);i=j;return}function zF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+48|0;f=e+32|0;g=e+28|0;h=e+24|0;j=e+20|0;k=e+16|0;l=e+12|0;m=e+8|0;n=e+4|0;o=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[m>>2]=0;c[o>>2]=0;if(c[c[h>>2]>>2]|0)zb[c[135736>>2]&511](c[c[h>>2]>>2]|0);c[c[h>>2]>>2]=0;a:while(1){c[l>>2]=QD(c[(c[j>>2]|0)+64>>2]|0)|0;c[k>>2]=c[(c[j>>2]|0)+68>>2];while(1){if(!(c[k>>2]|0))break;if((c[c[k>>2]>>2]|0)==1007){c[o>>2]=1;c[n>>2]=gH(c[(c[k>>2]|0)+32>>2]|0,c[l>>2]|0,m)|0;if((c[n>>2]|0)==-1)break a;if(!(c[c[h>>2]>>2]|0)){d=my(142568)|0;c[c[h>>2]>>2]=d}else{d=By(c[c[h>>2]>>2]|0,157648)|0;c[c[h>>2]>>2]=d}d=By(c[c[h>>2]>>2]|0,c[m>>2]|0)|0;c[c[h>>2]>>2]=d;d=By(c[c[h>>2]>>2]|0,142568)|0;c[c[h>>2]>>2]=d;if(c[m>>2]|0){zb[c[135736>>2]&511](c[m>>2]|0);c[m>>2]=0}}c[k>>2]=c[(c[k>>2]|0)+4>>2]}if(c[o>>2]|0){p=20;break}c[j>>2]=c[(c[j>>2]|0)+64>>2];if(!(c[j>>2]|0)){p=20;break}if((c[c[j>>2]>>2]|0)==1){p=20;break}}if((p|0)==20){c[f>>2]=c[c[h>>2]>>2];q=c[f>>2]|0;i=e;return q|0}xB(c[g>>2]|0,157568,157600);if(c[c[h>>2]>>2]|0)zb[c[135736>>2]&511](c[c[h>>2]>>2]|0);c[c[h>>2]>>2]=0;c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}function AF(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;do switch(c[c[e>>2]>>2]|0){case 14:{c[d>>2]=c[(c[e>>2]|0)+52>>2];break}case 2e3:{c[d>>2]=c[(c[e>>2]|0)+16>>2];break}case 15:{c[d>>2]=c[(c[e>>2]|0)+56>>2];break}case 18:{c[d>>2]=c[(c[e>>2]|0)+16>>2];break}case 26:{if(c[(c[e>>2]|0)+12>>2]|0)c[d>>2]=AF(c[(c[e>>2]|0)+12>>2]|0)|0;else f=13;break}case 24:case 22:case 23:{c[d>>2]=c[(c[e>>2]|0)+20>>2];break}case 1:{c[d>>2]=142520;break}case 16:{c[d>>2]=c[(c[e>>2]|0)+52>>2];break}case 5:case 4:{c[d>>2]=c[(c[e>>2]|0)+112>>2];break}case 17:{c[d>>2]=c[(c[e>>2]|0)+20>>2];break}default:f=13}while(0);if((f|0)==13)c[d>>2]=0;i=b;return c[d>>2]|0}function BF(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;a:do switch(c[c[e>>2]>>2]|0){case 17:{c[d>>2]=c[(c[e>>2]|0)+16>>2];break}case 18:{c[d>>2]=c[(c[e>>2]|0)+4>>2];break}case 14:{c[d>>2]=c[(c[e>>2]|0)+8>>2];break}case 16:{c[d>>2]=c[(c[e>>2]|0)+8>>2];break}case 5:case 4:case 1:{c[d>>2]=c[(c[e>>2]|0)+8>>2];break}case 2e3:{c[d>>2]=c[(c[e>>2]|0)+12>>2];break}case 26:{if(c[(c[e>>2]|0)+12>>2]|0){c[d>>2]=BF(c[(c[e>>2]|0)+12>>2]|0)|0;break a}else{c[d>>2]=0;break a}break}case 15:{c[d>>2]=c[(c[e>>2]|0)+8>>2];break}case 24:case 22:case 23:{c[d>>2]=c[(c[e>>2]|0)+16>>2];break}default:c[d>>2]=0}while(0);i=b;return c[d>>2]|0}function CF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[f>>2]=a;c[g>>2]=b;if(!(c[g>>2]|0)){c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}c[j>>2]=hH(c[g>>2]|0)|0;c[h>>2]=Eh(c[j>>2]|0,1)|0;do if(!(c[h>>2]|0)){if((c[(c[g>>2]|0)+40>>2]|0)!=2){c[l>>2]=SH(c[j>>2]|0)|0;if(c[l>>2]|0){zb[c[135736>>2]&511](c[j>>2]|0);c[j>>2]=c[l>>2]}c[k>>2]=Cm(0,c[(c[g>>2]|0)+32>>2]|0,c[j>>2]|0,c[g>>2]|0)|0;if(!(c[k>>2]|0)){c[h>>2]=3037;b=c[f>>2]|0;a=c[g>>2]|0;n=IH(23)|0;hE(b,3037,0,a,n,0,0,161408,c[j>>2]|0,0);break}else{c[(c[g>>2]|0)+40>>2]=2;break}}}else if((c[h>>2]|0)>0){c[h>>2]=3037;n=c[f>>2]|0;a=c[g>>2]|0;b=IH(23)|0;hE(n,3037,0,a,b,0,0,161456,c[j>>2]|0,0)}while(0);if(c[j>>2]|0)zb[c[135736>>2]&511](c[j>>2]|0);c[e>>2]=c[h>>2];m=c[e>>2]|0;i=d;return m|0}function DF(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+32|0;h=g+24|0;j=g+20|0;k=g+16|0;l=g+12|0;m=g+8|0;n=g+4|0;o=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=0;if((c[j>>2]|0)==0|(c[n>>2]|0)==0|(c[l>>2]|0)==0){c[h>>2]=-1;p=c[h>>2]|0;i=g;return p|0}if((c[c[n>>2]>>2]|0)!=1){xB(c[j>>2]|0,162480,162512);c[h>>2]=-1;p=c[h>>2]|0;i=g;return p|0}switch(c[(c[n>>2]|0)+88>>2]|0){case 17:case 16:case 29:case 21:case 22:break;default:{xB(c[j>>2]|0,162480,162552);c[h>>2]=-1;p=c[h>>2]|0;i=g;return p|0}}c[o>>2]=TH(c[n>>2]|0,c[m>>2]|0,0,c[l>>2]|0)|0;if((c[o>>2]|0)<0){xB(c[j>>2]|0,162480,162624);c[h>>2]=-1;p=c[h>>2]|0;i=g;return p|0}if((c[o>>2]|0)>0){if(c[(c[n>>2]|0)+48>>2]&64)c[o>>2]=1825;else c[o>>2]=1824;hE(c[j>>2]|0,c[o>>2]|0,c[k>>2]|0,c[l>>2]|0,c[n>>2]|0,0,c[m>>2]|0,0,0,0)}c[h>>2]=c[o>>2];p=c[h>>2]|0;i=g;return p|0}function EF(a,b,d,e,f,g,h,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;o=i;i=i+80|0;p=o;q=o+76|0;r=o+72|0;s=o+68|0;t=o+64|0;u=o+60|0;v=o+56|0;w=o+52|0;x=o+48|0;y=o+44|0;z=o+40|0;A=o+36|0;B=o+32|0;C=o+28|0;D=o+24|0;E=o+20|0;c[q>>2]=a;c[r>>2]=b;c[s>>2]=d;c[t>>2]=e;c[u>>2]=f;c[v>>2]=g;c[w>>2]=h;c[x>>2]=j;c[y>>2]=k;c[z>>2]=l;c[A>>2]=m;c[B>>2]=n;c[C>>2]=0;c[D>>2]=0;c[E>>2]=0;if(c[q>>2]|0){n=(c[q>>2]|0)+20|0;c[n>>2]=(c[n>>2]|0)+1;c[(c[q>>2]|0)+16>>2]=c[s>>2];c[C>>2]=c[(c[q>>2]|0)+8>>2];c[E>>2]=c[(c[q>>2]|0)+4>>2];c[D>>2]=c[(c[q>>2]|0)+24>>2]}n=c[D>>2]|0;D=c[C>>2]|0;C=c[E>>2]|0;E=c[q>>2]|0;q=c[r>>2]|0;r=c[s>>2]|0;s=c[t>>2]|0;t=c[u>>2]|0;u=c[v>>2]|0;v=c[w>>2]|0;w=c[y>>2]|0;y=c[z>>2]|0;z=c[A>>2]|0;A=c[B>>2]|0;c[p>>2]=c[x>>2];c[p+4>>2]=w;c[p+8>>2]=y;c[p+12>>2]=z;c[p+16>>2]=A;Xd(n,D,C,E,q,16,r,2,0,0,s,t,u,0,0,v,p);i=o;return}function FF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=Cb[c[135744>>2]&511](8)|0;if(!(c[h>>2]|0)){tC(c[f>>2]|0,168864,c[g>>2]|0);c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}else{f=c[h>>2]|0;c[f+0>>2]=0;c[f+4>>2]=0;c[(c[h>>2]|0)+4>>2]=c[g>>2];c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}return 0}function GF(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+8|0;k=f+4|0;l=f;c[g>>2]=a;c[h>>2]=b;c[f+12>>2]=d;c[j>>2]=e;c[k>>2]=0;c[l>>2]=0;HC(k,c[g>>2]|0,c[(c[j>>2]|0)+20>>2]|0)|0;e=c[g>>2]|0;g=c[h>>2]|0;h=c[j>>2]|0;d=c[k>>2]|0;IC(e,g,h,163216,d,iH(l,c[(c[j>>2]|0)+36>>2]|0,c[(c[j>>2]|0)+8>>2]|0)|0,0,0);if(c[k>>2]|0){zb[c[135736>>2]&511](c[k>>2]|0);c[k>>2]=0}if(!(c[l>>2]|0)){i=f;return}zb[c[135736>>2]&511](c[l>>2]|0);c[l>>2]=0;i=f;return}function HF(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+32|0;j=h+28|0;k=h+24|0;l=h+20|0;m=h+16|0;
n=h+12|0;o=h+8|0;p=h+4|0;q=h;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;if((c[k>>2]|0)==0|(c[o>>2]|0)==0){if(c[p>>2]|0)c[c[p>>2]>>2]=0;c[j>>2]=-1;r=c[j>>2]|0;i=h;return r|0}if((c[c[o>>2]>>2]|0)!=1){if(c[p>>2]|0)c[c[p>>2]>>2]=0;PC(c[k>>2]|0,c[m>>2]|0,3069,168672,c[(c[o>>2]|0)+8>>2]|0,0);c[j>>2]=-1;r=c[j>>2]|0;i=h;return r|0}c[q>>2]=dE(c[m>>2]|0,c[n>>2]|0)|0;if(c[q>>2]|0){c[j>>2]=eE(c[k>>2]|0,c[l>>2]|0,c[q>>2]|0,c[o>>2]|0,c[p>>2]|0)|0;r=c[j>>2]|0;i=h;return r|0}if(c[p>>2]|0)c[c[p>>2]>>2]=0;c[j>>2]=0;r=c[j>>2]|0;i=h;return r|0}function IF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if((c[g>>2]|0)==0|(c[j>>2]|0)==0){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}c[k>>2]=c[(c[g>>2]|0)+44>>2];while(1){if(!(c[k>>2]|0)){m=10;break}if(((c[(c[k>>2]|0)+36>>2]|0)!=0?(qy(c[(c[k>>2]|0)+8>>2]|0,c[j>>2]|0)|0)!=0:0)?(qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[h>>2]|0)|0)!=0:0){m=8;break}c[k>>2]=c[(c[k>>2]|0)+24>>2]}if((m|0)==8){c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}else if((m|0)==10){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}return 0}function JF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(c[h>>2]|0){if(!(c[j>>2]|0)){c[f>>2]=c[h>>2];n=c[f>>2]|0;i=e;return n|0}c[m>>2]=0;c[k>>2]=Xi(c[(c[j>>2]|0)+32>>2]|0,c[j>>2]|0)|0;d=c[h>>2]|0;if(!(c[k>>2]|0))c[l>>2]=Hl(d,c[(c[(c[j>>2]|0)+32>>2]|0)+72>>2]|0)|0;else{c[l>>2]=Hl(d,c[k>>2]|0)|0;zb[c[135736>>2]&511](c[k>>2]|0)}if(c[l>>2]|0){c[m>>2]=AP(c[g>>2]|0,c[l>>2]|0,-1)|0;zb[c[135736>>2]&511](c[l>>2]|0);c[f>>2]=c[m>>2];n=c[f>>2]|0;i=e;return n|0}}c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}function KF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[l>>2]=0;if(!(c[j>>2]|0)){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}if(c[(c[j>>2]|0)+32>>2]|0){xB(c[g>>2]|0,168128,168152);c[f>>2]=-1;m=c[f>>2]|0;i=e;return m|0}d=c[g>>2]|0;if(!(c[(c[j>>2]|0)+20>>2]|0)){xB(d,168128,168176);c[f>>2]=-1;m=c[f>>2]|0;i=e;return m|0}if(!(c[d+28>>2]|0)){xB(c[g>>2]|0,168128,155336);c[f>>2]=-1;m=c[f>>2]|0;i=e;return m|0}c[k>>2]=tF(c[(c[j>>2]|0)+8>>2]|0,c[(c[g>>2]|0)+80>>2]|0)|0;if(!(c[k>>2]|0)){c[f>>2]=-1;m=c[f>>2]|0;i=e;return m|0}c[(c[k>>2]|0)+28>>2]=c[(c[g>>2]|0)+28>>2];c[(c[k>>2]|0)+36>>2]=c[h>>2];aB(c[k>>2]|0,c[(c[g>>2]|0)+8>>2]|0,c[(c[g>>2]|0)+12>>2]|0,c[(c[g>>2]|0)+4>>2]|0);cB(c[k>>2]|0,c[(c[g>>2]|0)+24>>2]|0,c[(c[g>>2]|0)+4>>2]|0);c[(c[k>>2]|0)+40>>2]=c[(c[g>>2]|0)+40>>2];c[l>>2]=GB(c[k>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;if(c[l>>2]|0)c[(c[g>>2]|0)+16>>2]=c[l>>2];j=(c[g>>2]|0)+20|0;c[j>>2]=(c[j>>2]|0)+(c[(c[k>>2]|0)+20>>2]|0);c[(c[g>>2]|0)+40>>2]=c[(c[k>>2]|0)+40>>2];c[(c[k>>2]|0)+28>>2]=0;YA(c[k>>2]|0);c[f>>2]=c[l>>2];m=c[f>>2]|0;i=e;return m|0}function LF(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+48|0;g=f+40|0;h=f+36|0;j=f+32|0;k=f+28|0;l=f+24|0;m=f+20|0;n=f+16|0;o=f+12|0;p=f+8|0;q=f+4|0;r=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=0;c[n>>2]=0;c[o>>2]=0;c[p>>2]=0;c[q>>2]=0;c[r>>2]=0;if((c[h>>2]|0)==0|(c[j>>2]|0)==0|(c[k>>2]|0)==0){c[g>>2]=-1;s=c[g>>2]|0;i=f;return s|0}c[o>>2]=jH(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,n,c[l>>2]|0)|0;if(c[o>>2]|0){c[g>>2]=c[o>>2];s=c[g>>2]|0;i=f;return s|0}c[o>>2]=FB(c[h>>2]|0,c[l>>2]|0,c[n>>2]|0,0,0,0,c[k>>2]|0,c[(c[h>>2]|0)+112>>2]|0,0,r)|0;if(c[o>>2]|0){c[g>>2]=c[o>>2];s=c[g>>2]|0;i=f;return s|0}a:do if((c[r>>2]|0)!=0?(c[(c[r>>2]|0)+20>>2]|0)!=0:0){e=c[(c[h>>2]|0)+112>>2]|0;do if(c[(c[r>>2]|0)+12>>2]|0){if(!e){AB(c[h>>2]|0,3050,c[k>>2]|0,0,167648,c[n>>2]|0,0);break}if(qy(c[(c[r>>2]|0)+12>>2]|0,c[(c[h>>2]|0)+112>>2]|0)|0)break a;oG(c[h>>2]|0,3050,0,c[k>>2]|0,167792,c[(c[r>>2]|0)+12>>2]|0,c[n>>2]|0,c[(c[h>>2]|0)+112>>2]|0)}else{if(!e)break a;c[p>>2]=1;if((c[(c[r>>2]|0)+32>>2]|0)!=0?(c[(c[r>>2]|0)+12>>2]|0)!=0:0){AB(c[h>>2]|0,3050,c[k>>2]|0,0,167912,c[n>>2]|0,0);break}c[(c[r>>2]|0)+16>>2]=c[(c[h>>2]|0)+112>>2];break a}while(0);c[g>>2]=c[(c[h>>2]|0)+16>>2];s=c[g>>2]|0;i=f;return s|0}else t=9;while(0);do if((t|0)==9)if((c[l>>2]|0)==2){c[o>>2]=3050;AB(c[h>>2]|0,c[o>>2]|0,c[k>>2]|0,0,167544,c[n>>2]|0,0);break}else{c[o>>2]=3081;AB(c[h>>2]|0,c[o>>2]|0,c[k>>2]|0,0,167592,c[n>>2]|0,0);break}while(0);if(((c[r>>2]|0)!=0?(c[(c[r>>2]|0)+32>>2]|0)==0:0)?(c[(c[r>>2]|0)+20>>2]|0)!=0:0){do if(c[p>>2]|0)if(!(c[(c[j>>2]|0)+24>>2]&512)){n=(c[j>>2]|0)+24|0;c[n>>2]=c[n>>2]|512;break}else{c[q>>2]=1;break}while(0);KF(c[h>>2]|0,c[j>>2]|0,c[r>>2]|0)|0;if(!((c[p>>2]|0)==0|(c[q>>2]|0)!=0)){q=(c[j>>2]|0)+24|0;c[q>>2]=c[q>>2]^512}}c[m>>2]=c[(c[k>>2]|0)+12>>2];if((c[l>>2]|0)!=3){if((((c[m>>2]|0)!=0?(c[(c[m>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[m>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(qy(c[(c[(c[m>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0)c[m>>2]=c[(c[m>>2]|0)+24>>2]}else{c[(c[h>>2]|0)+116>>2]=c[r>>2];c[(c[h>>2]|0)+100>>2]=1;b:while(1){if(!((((c[m>>2]|0)!=0?(c[(c[m>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[m>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(qy(c[(c[(c[m>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0))t=37;do if((t|0)==37){t=0;if((((c[m>>2]|0)!=0?(c[(c[m>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[m>>2]|0)+8>>2]|0,161024)|0)!=0:0)?(qy(c[(c[(c[m>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0)break;if((((c[m>>2]|0)!=0?(c[(c[m>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[m>>2]|0)+8>>2]|0,161008)|0)!=0:0)?(qy(c[(c[(c[m>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0)break;if((((c[m>>2]|0)!=0?(c[(c[m>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[m>>2]|0)+8>>2]|0,161080)|0)!=0:0)?(qy(c[(c[(c[m>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0)break;if(!(c[m>>2]|0))break b;if(!(c[(c[m>>2]|0)+36>>2]|0))break b;if(!(qy(c[(c[m>>2]|0)+8>>2]|0,161064)|0))break b;if(!(qy(c[(c[(c[m>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0))break b}while(0);if(!((((c[m>>2]|0)!=0?(c[(c[m>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[m>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(qy(c[(c[(c[m>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0))t=57;do if((t|0)==57){t=0;if((((c[m>>2]|0)!=0?(c[(c[m>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[m>>2]|0)+8>>2]|0,161024)|0)!=0:0)?(qy(c[(c[(c[m>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){oE(c[h>>2]|0,c[j>>2]|0,c[m>>2]|0,1)|0;break}if((((c[m>>2]|0)!=0?(c[(c[m>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[m>>2]|0)+8>>2]|0,161008)|0)!=0:0)?(qy(c[(c[(c[m>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){nE(c[h>>2]|0,c[j>>2]|0,c[m>>2]|0,1)|0;break}if((((c[m>>2]|0)!=0?(c[(c[m>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[m>>2]|0)+8>>2]|0,161080)|0)!=0:0)?(qy(c[(c[(c[m>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){sE(c[h>>2]|0,c[j>>2]|0,c[m>>2]|0)|0;break}if((((c[m>>2]|0)!=0?(c[(c[m>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[m>>2]|0)+8>>2]|0,161064)|0)!=0:0)?(qy(c[(c[(c[m>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0)rE(c[h>>2]|0,c[j>>2]|0,c[m>>2]|0)|0}while(0);c[m>>2]=c[(c[m>>2]|0)+24>>2]}c[(c[h>>2]|0)+116>>2]=0;c[(c[h>>2]|0)+100>>2]=0}do if(c[m>>2]|0){c[o>>2]=3033;j=c[h>>2]|0;t=c[o>>2]|0;r=c[k>>2]|0;q=c[m>>2]|0;if((c[l>>2]|0)==3){uE(j,t,0,r,q,0,168056);break}else{uE(j,t,0,r,q,0,161392);break}}while(0);c[g>>2]=c[o>>2];s=c[g>>2]|0;i=f;return s|0}function MF(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+32|0;j=h+24|0;k=h+20|0;l=h+16|0;m=h+12|0;n=h+8|0;o=h+4|0;p=h;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[p>>2]=0;GC(p,0,c[l>>2]|0,c[m>>2]|0)|0;l=c[j>>2]|0;j=c[m>>2]|0;m=c[k>>2]|0;k=c[p>>2]|0;if(c[o>>2]|0)PC(l,j,m,161256,k,c[o>>2]|0);else PC(l,j,m,163272,k,c[n>>2]|0);if(!(c[p>>2]|0)){i=h;return}zb[c[135736>>2]&511](c[p>>2]|0);c[p>>2]=0;i=h;return}function NF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=0;c[k>>2]=0;c[j>>2]=_i(c[h>>2]|0)|0;do if(!(qy(c[j>>2]|0,165504)|0)){if(qy(c[j>>2]|0,165512)|0){c[k>>2]=0;break}if(qy(c[j>>2]|0,161736)|0){c[k>>2]=1;break}if(qy(c[j>>2]|0,165520)|0){c[k>>2]=0;break}else{d=c[f>>2]|0;b=c[g>>2]|0;a=c[h>>2]|0;l=IH(15)|0;hE(d,1714,b,a,l,0,c[j>>2]|0,0,0,0);break}}else c[k>>2]=1;while(0);if(!(c[j>>2]|0)){m=c[k>>2]|0;i=e;return m|0}zb[c[135736>>2]&511](c[j>>2]|0);m=c[k>>2]|0;i=e;return m|0}function OF(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+32|0;g=f+28|0;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f+4|0;o=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[n>>2]=0;if((c[h>>2]|0)==0|(c[j>>2]|0)==0|(c[k>>2]|0)==0|(c[l>>2]|0)==0){c[g>>2]=-1;p=c[g>>2]|0;i=f;return p|0}c[c[l>>2]>>2]=0;c[m>>2]=c[(c[h>>2]|0)+84>>2];c[(c[m>>2]|0)+52>>2]=4;c[o>>2]=c[(c[k>>2]|0)+44>>2];while(1){if(!(c[o>>2]|0))break;e=c[o>>2]|0;if(!(c[(c[o>>2]|0)+36>>2]|0)){if(!(qy(c[e+8>>2]|0,161384)|0))GF(c[h>>2]|0,3035,0,c[o>>2]|0)}else if(qy(c[(c[e+36>>2]|0)+8>>2]|0,c[38526]|0)|0)GF(c[h>>2]|0,3035,0,c[o>>2]|0);c[o>>2]=c[(c[o>>2]|0)+24>>2]}cE(c[h>>2]|0,c[k>>2]|0,161384)|0;c[n>>2]=c[(c[k>>2]|0)+12>>2];if((((c[n>>2]|0)!=0?(c[(c[n>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[n>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(qy(c[(c[(c[n>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){o=c[m>>2]|0;kH(o,jE(c[h>>2]|0,c[n>>2]|0,1)|0)|0;c[n>>2]=c[(c[n>>2]|0)+24>>2]}if(!(c[n>>2]|0))uE(c[h>>2]|0,3034,0,c[k>>2]|0,0,0,167392);if(!(c[n>>2]|0))uE(c[h>>2]|0,3034,0,c[k>>2]|0,0,0,167392);if((((c[n>>2]|0)!=0?(c[(c[n>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[n>>2]|0)+8>>2]|0,165456)|0)!=0:0)?(qy(c[(c[(c[n>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){UF(c[h>>2]|0,c[j>>2]|0,c[n>>2]|0,9)|0;c[c[l>>2]>>2]=1;c[n>>2]=c[(c[n>>2]|0)+24>>2]}else q=25;if(((((q|0)==25?(c[n>>2]|0)!=0:0)?(c[(c[n>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[n>>2]|0)+8>>2]|0,165440)|0)!=0:0)?(qy(c[(c[(c[n>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){lH(c[h>>2]|0,c[j>>2]|0,c[n>>2]|0,9)|0;c[c[l>>2]>>2]=1;c[n>>2]=c[(c[n>>2]|0)+24>>2]}if(c[n>>2]|0)uE(c[h>>2]|0,3033,0,c[k>>2]|0,c[n>>2]|0,0,167392);c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}function PF(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+32|0;g=f+28|0;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f+4|0;o=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[n>>2]=0;if((c[h>>2]|0)==0|(c[j>>2]|0)==0|(c[k>>2]|0)==0|(c[l>>2]|0)==0){c[g>>2]=-1;p=c[g>>2]|0;i=f;return p|0}c[c[l>>2]>>2]=0;c[m>>2]=c[(c[h>>2]|0)+84>>2];c[o>>2]=c[(c[k>>2]|0)+44>>2];while(1){if(!(c[o>>2]|0))break;e=c[o>>2]|0;if(!(c[(c[o>>2]|0)+36>>2]|0)){if((qy(c[e+8>>2]|0,161384)|0)==0?(qy(c[(c[o>>2]|0)+8>>2]|0,167064)|0)==0:0)GF(c[h>>2]|0,3035,0,c[o>>2]|0)}else if(qy(c[(c[e+36>>2]|0)+8>>2]|0,c[38526]|0)|0)GF(c[h>>2]|0,3035,0,c[o>>2]|0);c[o>>2]=c[(c[o>>2]|0)+24>>2]}cE(c[h>>2]|0,c[k>>2]|0,161384)|0;if((gG(c[h>>2]|0,c[k>>2]|0,167064,0)|0)!=0?(c[(c[m>>2]|0)+48>>2]&1|0)==0:0){o=(c[m>>2]|0)+48|0;c[o>>2]=c[o>>2]|1}c[n>>2]=c[(c[k>>2]|0)+12>>2];if((((c[n>>2]|0)!=0?(c[(c[n>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[n>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(qy(c[(c[(c[n>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){o=c[m>>2]|0;kH(o,jE(c[h>>2]|0,c[n>>2]|0,1)|0)|0;c[n>>2]=c[(c[n>>2]|0)+24>>2]}if(!(c[n>>2]|0))uE(c[h>>2]|0,3034,0,c[k>>2]|0,0,0,167392);if(!(c[n>>2]|0))uE(c[h>>2]|0,3034,0,c[k>>2]|0,0,0,167392);if((((c[n>>2]|0)!=0?(c[(c[n>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[n>>2]|0)+8>>2]|0,165456)|0)!=0:0)?(qy(c[(c[(c[n>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){UF(c[h>>2]|0,c[j>>2]|0,c[n>>2]|0,10)|0;c[c[l>>2]>>2]=1;c[n>>2]=c[(c[n>>2]|0)+24>>2]}else q=29;if(((((q|0)==29?(c[n>>2]|0)!=0:0)?(c[(c[n>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[n>>2]|0)+8>>2]|0,165440)|0)!=0:0)?(qy(c[(c[(c[n>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){lH(c[h>>2]|0,c[j>>2]|0,c[n>>2]|0,10)|0;c[c[l>>2]>>2]=1;c[n>>2]=c[(c[n>>2]|0)+24>>2]}if(c[n>>2]|0)uE(c[h>>2]|0,3033,0,c[k>>2]|0,c[n>>2]|0,0,167392);c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}function QF(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;g=i;i=i+80|0;h=g+76|0;j=g+72|0;k=g+68|0;l=g+64|0;m=g+60|0;n=g+56|0;o=g+52|0;p=g+48|0;q=g+44|0;r=g+40|0;s=g+36|0;t=g+32|0;u=g+28|0;v=g+24|0;w=g+20|0;x=g+16|0;y=g+12|0;z=g+8|0;A=g+4|0;B=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[p>>2]=0;c[q>>2]=0;c[s>>2]=1;c[t>>2]=1;c[v>>2]=0;if((c[j>>2]|0)==0|(c[k>>2]|0)==0|(c[l>>2]|0)==0){c[h>>2]=0;C=c[h>>2]|0;i=g;return C|0}c[o>>2]=YE(c[j>>2]|0,c[k>>2]|0,c[m>>2]|0,c[l>>2]|0)|0;if(!(c[o>>2]|0)){c[h>>2]=0;C=c[h>>2]|0;i=g;return C|0}a:do if(c[n>>2]|0){f=c[j>>2]|0;e=c[l>>2]|0;if((c[m>>2]|0)==8){c[s>>2]=XF(f,e,0,1,1,161728)|0;c[t>>2]=YF(c[j>>2]|0,c[l>>2]|0,1,1,1,161736)|0}else{c[s>>2]=XF(f,e,0,-1,1,161744)|0;c[t>>2]=YF(c[j>>2]|0,c[l>>2]|0,0,1073741824,1,161768)|0}ZF(c[j>>2]|0,0,c[l>>2]|0,c[s>>2]|0,c[t>>2]|0)|0;c[p>>2]=XE(c[j>>2]|0,c[l>>2]|0,c[s>>2]|0,c[t>>2]|0)|0;if(!(c[p>>2]|0)){c[h>>2]=0;C=c[h>>2]|0;i=g;return C|0}c[(c[p>>2]|0)+12>>2]=c[o>>2];c[r>>2]=c[(c[l>>2]|0)+44>>2];while(1){if(!(c[r>>2]|0))break a;e=c[r>>2]|0;if(!(c[(c[r>>2]|0)+36>>2]|0)){if(((qy(c[e+8>>2]|0,161384)|0)==0?(qy(c[(c[r>>2]|0)+8>>2]|0,161808)|0)==0:0)?(qy(c[(c[r>>2]|0)+8>>2]|0,161824)|0)==0:0)GF(c[j>>2]|0,3035,0,c[r>>2]|0)}else if(qy(c[(c[e+36>>2]|0)+8>>2]|0,c[38526]|0)|0)GF(c[j>>2]|0,3035,0,c[r>>2]|0);c[r>>2]=c[(c[r>>2]|0)+24>>2]}}else{c[r>>2]=c[(c[l>>2]|0)+44>>2];while(1){if(!(c[r>>2]|0))break a;e=c[r>>2]|0;if(!(c[(c[r>>2]|0)+36>>2]|0)){if(!(qy(c[e+8>>2]|0,161384)|0))GF(c[j>>2]|0,3035,0,c[r>>2]|0)}else if(qy(c[(c[e+36>>2]|0)+8>>2]|0,c[38526]|0)|0)GF(c[j>>2]|0,3035,0,c[r>>2]|0);c[r>>2]=c[(c[r>>2]|0)+24>>2]}}while(0);cE(c[j>>2]|0,c[l>>2]|0,161384)|0;c[q>>2]=c[(c[l>>2]|0)+12>>2];if((((c[q>>2]|0)!=0?(c[(c[q>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[q>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(qy(c[(c[(c[q>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){r=jE(c[j>>2]|0,c[q>>2]|0,1)|0;c[(c[o>>2]|0)+4>>2]=r;c[q>>2]=c[(c[q>>2]|0)+24>>2]}if((c[m>>2]|0)==8){c[x>>2]=0;while(1){if(!(c[q>>2]|0))break;if(!(c[(c[q>>2]|0)+36>>2]|0))break;if(!(qy(c[(c[q>>2]|0)+8>>2]|0,161040)|0))break;if(!(qy(c[(c[(c[q>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0))break;c[w>>2]=pE(c[j>>2]|0,c[k>>2]|0,c[q>>2]|0,u,0)|0;if(c[w>>2]|0){if(c[u>>2]|0)c[v>>2]=(c[v>>2]|0)+1;if((c[(c[w>>2]|0)+16>>2]|0)>1){GE(c[j>>2]|0,3091,0,c[q>>2]|0,161840,0);c[(c[w>>2]|0)+16>>2]=1}if((c[(c[w>>2]|0)+20>>2]|0)>1){GE(c[j>>2]|0,3091,0,c[q>>2]|0,161888,0);c[(c[w>>2]|0)+20>>2]=1}m=c[w>>2]|0;if(!(c[x>>2]|0))c[(c[o>>2]|0)+12>>2]=m;else c[(c[x>>2]|0)+8>>2]=m;c[x>>2]=c[w>>2]}c[q>>2]=c[(c[q>>2]|0)+24>>2]}if(c[q>>2]|0)uE(c[j>>2]|0,3033,0,c[l>>2]|0,c[q>>2]|0,0,161936)}else{c[y>>2]=0;c[z>>2]=0;while(1){if((((c[q>>2]|0)!=0?(c[(c[q>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[q>>2]|0)+8>>2]|0,161040)|0)!=0:0)?(qy(c[(c[(c[q>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0)D=1;else E=59;do if((E|0)==59){E=0;if((((c[q>>2]|0)!=0?(c[(c[q>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[q>>2]|0)+8>>2]|0,161080)|0)!=0:0)?(qy(c[(c[(c[q>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){D=1;break}if((((c[q>>2]|0)!=0?(c[(c[q>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[q>>2]|0)+8>>2]|0,161976)|0)!=0:0)?(qy(c[(c[(c[q>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){D=1;break}if((((c[q>>2]|0)!=0?(c[(c[q>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[q>>2]|0)+8>>2]|0,161656)|0)!=0:0)?(qy(c[(c[(c[q>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){D=1;break}if(((c[q>>2]|0)!=0?(c[(c[q>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[q>>2]|0)+8>>2]|0,161664)|0)!=0:0)D=(qy(c[(c[(c[q>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0;else D=0}while(0);F=(c[q>>2]|0)!=0;if(!D)break;if(((F?(c[(c[q>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[q>>2]|0)+8>>2]|0,161040)|0)!=0:0)?(qy(c[(c[(c[q>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){c[y>>2]=pE(c[j>>2]|0,c[k>>2]|0,c[q>>2]|0,u,0)|0;if((c[y>>2]|0)!=0&(c[u>>2]|0)!=0)c[v>>2]=(c[v>>2]|0)+1}else E=82;do if((E|0)==82){E=0;if((((c[q>>2]|0)!=0?(c[(c[q>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[q>>2]|0)+8>>2]|0,161080)|0)!=0:0)?(qy(c[(c[(c[q>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){c[y>>2]=RF(c[j>>2]|0,c[k>>2]|0,c[q>>2]|0)|0;if(c[y>>2]|0)c[v>>2]=(c[v>>2]|0)+1;if(!(c[(c[j>>2]|0)+100>>2]|0))break;if(!(c[(c[j>>2]|0)+120>>2]|0))break;if(!((c[y>>2]|0)!=0?(c[c[(c[(c[j>>2]|0)+120>>2]|0)+4>>2]>>2]|0)==17:0))break;if(!(c[(c[y>>2]|0)+12>>2]|0))break;if((c[(c[(c[y>>2]|0)+12>>2]|0)+12>>2]|0)!=(c[(c[(c[j>>2]|0)+120>>2]|0)+16>>2]|0))break;if((c[(c[(c[y>>2]|0)+12>>2]|0)+16>>2]|0)!=(c[(c[(c[j>>2]|0)+120>>2]|0)+20>>2]|0))break;do if(c[(c[j>>2]|0)+124>>2]|0){c[A>>2]=0;w=c[j>>2]|0;x=c[q>>2]|0;AB(w,3081,x,0,161984,BB(A,c[(c[(c[j>>2]|0)+120>>2]|0)+20>>2]|0,c[(c[(c[j>>2]|0)+120>>2]|0)+16>>2]|0)|0,0);if(c[A>>2]|0){zb[c[135736>>2]&511](c[A>>2]|0);c[A>>2]=0}c[y>>2]=0}else{if((c[(c[y>>2]|0)+16>>2]|0)==1?(c[(c[y>>2]|0)+20>>2]|0)==1:0)break;c[B>>2]=0;x=c[j>>2]|0;w=c[q>>2]|0;AB(x,3081,w,0,162096,BB(B,c[(c[(c[j>>2]|0)+120>>2]|0)+20>>2]|0,c[(c[(c[j>>2]|0)+120>>2]|0)+16>>2]|0)|0,0);if(c[B>>2]|0){zb[c[135736>>2]&511](c[B>>2]|0);c[B>>2]=0}c[y>>2]=0}while(0);c[(c[(c[j>>2]|0)+120>>2]|0)+8>>2]=c[y>>2];w=(c[j>>2]|0)+124|0;c[w>>2]=(c[w>>2]|0)+1;break}if((((c[q>>2]|0)!=0?(c[(c[q>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[q>>2]|0)+8>>2]|0,161976)|0)!=0:0)?(qy(c[(c[(c[q>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){c[y>>2]=mH(c[j>>2]|0,c[k>>2]|0,c[q>>2]|0)|0;break}if((((c[q>>2]|0)!=0?(c[(c[q>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[q>>2]|0)+8>>2]|0,161656)|0)!=0:0)?(qy(c[(c[(c[q>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){c[y>>2]=QF(c[j>>2]|0,c[k>>2]|0,c[q>>2]|0,7,1)|0;break}if((((c[q>>2]|0)!=0?(c[(c[q>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[q>>2]|0)+8>>2]|0,161664)|0)!=0:0)?(qy(c[(c[(c[q>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0)c[y>>2]=QF(c[j>>2]|0,c[k>>2]|0,c[q>>2]|0,6,1)|0}while(0);if(c[y>>2]|0){w=c[y>>2]|0;if(!(c[z>>2]|0))c[(c[o>>2]|0)+12>>2]=w;else c[(c[z>>2]|0)+8>>2]=w;c[z>>2]=c[y>>2]}c[q>>2]=c[(c[q>>2]|0)+24>>2]}if(F)uE(c[j>>2]|0,3033,0,c[l>>2]|0,c[q>>2]|0,0,162240)}if((c[t>>2]|0)==0&(c[s>>2]|0)==0){c[h>>2]=0;C=c[h>>2]|0;i=g;return C|0}if(c[v>>2]|0)dG((c[(c[j>>2]|0)+28>>2]|0)+20|0,10,c[o>>2]|0)|0;if(c[n>>2]|0){c[h>>2]=c[p>>2];C=c[h>>2]|0;i=g;return C|0}else{c[h>>2]=c[o>>2];C=c[h>>2]|0;i=g;return C|0}return 0}function RF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+48|0;f=e+40|0;g=e+36|0;h=e+32|0;j=e+28|0;k=e+24|0;l=e+20|0;m=e+16|0;n=e+12|0;o=e+8|0;p=e+4|0;q=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[l>>2]=0;c[n>>2]=0;c[o>>2]=0;if((c[g>>2]|0)==0|(c[h>>2]|0)==0|(c[j>>2]|0)==0){c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}c[m>>2]=dE(c[j>>2]|0,160064)|0;d=c[g>>2]|0;if(!(c[m>>2]|0)){MF(d,3036,0,c[j>>2]|0,160064,0);c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}if(_F(d,c[h>>2]|0,0,c[m>>2]|0,o,n)|0){c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}$F(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0,c[m>>2]|0,c[o>>2]|0)|0;c[p>>2]=XF(c[g>>2]|0,c[j>>2]|0,0,-1,1,161744)|0;c[q>>2]=YF(c[g>>2]|0,c[j>>2]|0,0,1073741824,1,161768)|0;c[m>>2]=c[(c[j>>2]|0)+44>>2];while(1){if(!(c[m>>2]|0))break;h=c[m>>2]|0;if(!(c[(c[m>>2]|0)+36>>2]|0)){if((((qy(c[h+8>>2]|0,160064)|0)==0?(qy(c[(c[m>>2]|0)+8>>2]|0,161384)|0)==0:0)?(qy(c[(c[m>>2]|0)+8>>2]|0,161824)|0)==0:0)?(qy(c[(c[m>>2]|0)+8>>2]|0,161808)|0)==0:0)GF(c[g>>2]|0,3035,0,c[m>>2]|0)}else if(qy(c[(c[h+36>>2]|0)+8>>2]|0,c[38526]|0)|0)GF(c[g>>2]|0,3035,0,c[m>>2]|0);c[m>>2]=c[(c[m>>2]|0)+24>>2]}cE(c[g>>2]|0,c[j>>2]|0,161384)|0;c[k>>2]=XE(c[g>>2]|0,c[j>>2]|0,c[p>>2]|0,c[q>>2]|0)|0;if(!(c[k>>2]|0)){c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}m=cG(c[g>>2]|0,17,c[n>>2]|0,c[o>>2]|0)|0;c[(c[k>>2]|0)+12>>2]=m;ZF(c[g>>2]|0,c[k>>2]|0,c[j>>2]|0,c[p>>2]|0,c[q>>2]|0)|0;c[l>>2]=c[(c[j>>2]|0)+12>>2];if((((c[l>>2]|0)!=0?(c[(c[l>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[l>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(qy(c[(c[(c[l>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){m=jE(c[g>>2]|0,c[l>>2]|0,1)|0;c[(c[k>>2]|0)+4>>2]=m;c[l>>2]=c[(c[l>>2]|0)+24>>2]}if(c[l>>2]|0)uE(c[g>>2]|0,3033,0,c[j>>2]|0,c[l>>2]|0,0,161392);if((c[p>>2]|0)==0&(c[q>>2]|0)==0){c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}else{c[f>>2]=c[k>>2];r=c[f>>2]|0;i=e;return r|0}return 0}function SF(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+32|0;j=h+28|0;k=h+24|0;l=h+20|0;m=h+16|0;n=h+12|0;o=h+8|0;p=h+4|0;q=h;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;while(1){if(!((((c[c[m>>2]>>2]|0)!=0?(c[(c[c[m>>2]>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[c[m>>2]>>2]|0)+8>>2]|0,161048)|0)!=0:0)?(qy(c[(c[(c[c[m>>2]>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0)){if(!(c[c[m>>2]>>2]|0)){r=24;break}if(!(c[(c[c[m>>2]>>2]|0)+36>>2]|0)){r=24;break}if(!(qy(c[(c[c[m>>2]>>2]|0)+8>>2]|0,161064)|0)){r=24;break}if(!(qy(c[(c[(c[c[m>>2]>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)){r=24;break}}if((((c[c[m>>2]>>2]|0)!=0?(c[(c[c[m>>2]>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[c[m>>2]>>2]|0)+8>>2]|0,161048)|0)!=0:0)?(qy(c[(c[(c[c[m>>2]>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0)c[q>>2]=nH(c[k>>2]|0,c[l>>2]|0,c[c[m>>2]>>2]|0,c[c[n>>2]>>2]|0,c[o>>2]|0)|0;else r=15;if((r|0)==15?(r=0,c[q>>2]=oH(c[k>>2]|0,c[l>>2]|0,c[c[m>>2]>>2]|0)|0,(c[q>>2]|0)!=0&(c[p>>2]|0)!=0):0)c[c[p>>2]>>2]=1;if(c[q>>2]|0){if((c[c[n>>2]>>2]|0)==0?(g=JB()|0,c[c[n>>2]>>2]=g,(c[c[n>>2]>>2]|0)==0):0){r=20;break}if((pG(c[c[n>>2]>>2]|0,2,c[q>>2]|0)|0)==-1){r=22;break}}c[c[m>>2]>>2]=c[(c[c[m>>2]>>2]|0)+24>>2]}if((r|0)==20){c[j>>2]=-1;s=c[j>>2]|0;i=h;return s|0}else if((r|0)==22){c[j>>2]=-1;s=c[j>>2]|0;i=h;return s|0}else if((r|0)==24){c[j>>2]=0;s=c[j>>2]|0;i=h;return s|0}return 0}function TF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[l>>2]=0;if((c[g>>2]|0)==0|(c[h>>2]|0)==0|(c[j>>2]|0)==0){c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}c[k>>2]=qG(c[g>>2]|0,c[h>>2]|0,21,c[j>>2]|0)|0;if(!(c[k>>2]|0)){c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}c[m>>2]=c[(c[j>>2]|0)+44>>2];while(1){if(!(c[m>>2]|0))break;d=c[m>>2]|0;if(!(c[(c[m>>2]|0)+36>>2]|0)){if(((qy(c[d+8>>2]|0,161384)|0)==0?(qy(c[(c[m>>2]|0)+8>>2]|0,162304)|0)==0:0)?(qy(c[(c[m>>2]|0)+8>>2]|0,162320)|0)==0:0)GF(c[g>>2]|0,3035,0,c[m>>2]|0)}else if(qy(c[(c[d+36>>2]|0)+8>>2]|0,c[38526]|0)|0)GF(c[g>>2]|0,3035,0,c[m>>2]|0);c[m>>2]=c[(c[m>>2]|0)+24>>2]}cE(c[g>>2]|0,c[j>>2]|0,161384)|0;if(pH(c[g>>2]|0,c[h>>2]|0,c[k>>2]|0,c[j>>2]|0)|0){c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}c[l>>2]=c[(c[j>>2]|0)+12>>2];if((((c[l>>2]|0)!=0?(c[(c[l>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[l>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(qy(c[(c[(c[l>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){h=jE(c[g>>2]|0,c[l>>2]|0,1)|0;c[(c[k>>2]|0)+8>>2]=h;c[l>>2]=c[(c[l>>2]|0)+24>>2]}if(c[l>>2]|0)uE(c[g>>2]|0,3033,0,c[j>>2]|0,c[l>>2]|0,0,161392);c[f>>2]=c[k>>2];n=c[f>>2]|0;i=e;return n|0}function UF(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;i=i+64|0;g=f+52|0;h=f+48|0;j=f+44|0;k=f+40|0;l=f+36|0;m=f+32|0;n=f+28|0;o=f+24|0;p=f+20|0;q=f+16|0;r=f+12|0;s=f+8|0;t=f+4|0;u=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[n>>2]=0;if((c[h>>2]|0)==0|(c[j>>2]|0)==0|(c[k>>2]|0)==0){c[g>>2]=0;v=c[g>>2]|0;i=f;return v|0}c[m>>2]=c[(c[h>>2]|0)+84>>2];e=(c[m>>2]|0)+48|0;c[e>>2]=c[e>>2]|4;c[o>>2]=c[(c[k>>2]|0)+44>>2];while(1){if(!(c[o>>2]|0))break;e=c[o>>2]|0;if(!(c[(c[o>>2]|0)+36>>2]|0)){if((qy(c[e+8>>2]|0,161384)|0)==0?(qy(c[(c[o>>2]|0)+8>>2]|0,151424)|0)==0:0)GF(c[h>>2]|0,3035,0,c[o>>2]|0)}else if(qy(c[(c[e+36>>2]|0)+8>>2]|0,c[38526]|0)|0)GF(c[h>>2]|0,3035,0,c[o>>2]|0);c[o>>2]=c[(c[o>>2]|0)+24>>2]}cE(c[h>>2]|0,c[k>>2]|0,161384)|0;do if(!(fG(c[h>>2]|0,c[j>>2]|0,0,c[k>>2]|0,151424,(c[m>>2]|0)+60|0,(c[m>>2]|0)+56|0)|0)){if((c[(c[m>>2]|0)+56>>2]|0)==0?(c[c[m>>2]>>2]|0)==5:0){MF(c[h>>2]|0,3036,0,c[k>>2]|0,151424,0);break}if((c[(c[h>>2]|0)+100>>2]|0)!=0?(c[(c[m>>2]|0)+48>>2]&8|0)!=0:0){if(!(c[(c[m>>2]|0)+56>>2]|0)){MF(c[h>>2]|0,3036,0,c[k>>2]|0,151424,0);break}if((qy(c[(c[m>>2]|0)+56>>2]|0,c[(c[m>>2]|0)+8>>2]|0)|0)!=0?(qy(c[(c[m>>2]|0)+60>>2]|0,c[(c[m>>2]|0)+112>>2]|0)|0)!=0:0)break;c[p>>2]=0;c[q>>2]=0;o=c[h>>2]|0;e=c[k>>2]|0;d=BB(p,c[(c[m>>2]|0)+60>>2]|0,c[(c[m>>2]|0)+56>>2]|0)|0;oG(o,3081,0,e,166112,d,BB(q,c[(c[m>>2]|0)+112>>2]|0,c[(c[m>>2]|0)+8>>2]|0)|0,0);if(c[p>>2]|0){zb[c[135736>>2]&511](c[p>>2]|0);c[p>>2]=0}if(c[q>>2]|0){zb[c[135736>>2]&511](c[q>>2]|0);c[q>>2]=0}c[(c[m>>2]|0)+56>>2]=0;c[(c[m>>2]|0)+60>>2]=0}}while(0);c[n>>2]=c[(c[k>>2]|0)+12>>2];if((((c[n>>2]|0)!=0?(c[(c[n>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[n>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(qy(c[(c[(c[n>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){q=c[m>>2]|0;kH(q,jE(c[h>>2]|0,c[n>>2]|0,1)|0)|0;c[n>>2]=c[(c[n>>2]|0)+24>>2]}do if((c[l>>2]|0)==4){if((((c[n>>2]|0)!=0?(c[(c[n>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[n>>2]|0)+8>>2]|0,161024)|0)!=0:0)?(qy(c[(c[(c[n>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){q=c[h>>2]|0;if(c[(c[m>>2]|0)+56>>2]|0)uE(q,3005,0,c[k>>2]|0,c[n>>2]|0,166232,0);else{p=oE(q,c[j>>2]|0,c[n>>2]|0,0)|0;c[(c[m>>2]|0)+64>>2]=p}c[n>>2]=c[(c[n>>2]|0)+24>>2];break}if(!(c[(c[m>>2]|0)+56>>2]|0))uE(c[h>>2]|0,3005,0,c[k>>2]|0,c[n>>2]|0,166304,0)}else{if((c[l>>2]|0)!=10){if(!((c[l>>2]|0)==9&(c[n>>2]|0)!=0))break;if(!(c[(c[n>>2]|0)+36>>2]|0))break;if(!(qy(c[(c[n>>2]|0)+8>>2]|0,161024)|0))break;if(!(qy(c[(c[(c[n>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0))break;p=oE(c[h>>2]|0,c[j>>2]|0,c[n>>2]|0,0)|0;c[(c[m>>2]|0)+104>>2]=p;if(c[(c[m>>2]|0)+104>>2]|0){c[n>>2]=c[(c[n>>2]|0)+24>>2];break}c[g>>2]=0;v=c[g>>2]|0;i=f;return v|0}if((((c[n>>2]|0)!=0?(c[(c[n>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[n>>2]|0)+8>>2]|0,161648)|0)!=0:0)?(qy(c[(c[(c[n>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){p=QF(c[h>>2]|0,c[j>>2]|0,c[n>>2]|0,8,1)|0;c[(c[m>>2]|0)+28>>2]=p;c[n>>2]=c[(c[n>>2]|0)+24>>2];break}if((((c[n>>2]|0)!=0?(c[(c[n>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[n>>2]|0)+8>>2]|0,161656)|0)!=0:0)?(qy(c[(c[(c[n>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){p=QF(c[h>>2]|0,c[j>>2]|0,c[n>>2]|0,7,1)|0;c[(c[m>>2]|0)+28>>2]=p;c[n>>2]=c[(c[n>>2]|0)+24>>2];break}if((((c[n>>2]|0)!=0?(c[(c[n>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[n>>2]|0)+8>>2]|0,161664)|0)!=0:0)?(qy(c[(c[(c[n>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){p=QF(c[h>>2]|0,c[j>>2]|0,c[n>>2]|0,6,1)|0;c[(c[m>>2]|0)+28>>2]=p;c[n>>2]=c[(c[n>>2]|0)+24>>2];break}if((((c[n>>2]|0)!=0?(c[(c[n>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[n>>2]|0)+8>>2]|0,161080)|0)!=0:0)?(qy(c[(c[(c[n>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){p=RF(c[h>>2]|0,c[j>>2]|0,c[n>>2]|0)|0;c[(c[m>>2]|0)+28>>2]=p;c[n>>2]=c[(c[n>>2]|0)+24>>2]}}while(0);a:do if((c[l>>2]|0)==4|(c[l>>2]|0)==9){c[s>>2]=0;b:while(1){if(!((((c[n>>2]|0)!=0?(c[(c[n>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[n>>2]|0)+8>>2]|0,157848)|0)!=0:0)?(qy(c[(c[(c[n>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0))w=77;c:do if((w|0)==77){w=0;if((((c[n>>2]|0)!=0?(c[(c[n>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[n>>2]|0)+8>>2]|0,157832)|0)!=0:0)?(qy(c[(c[(c[n>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0)break;if((((c[n>>2]|0)!=0?(c[(c[n>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[n>>2]|0)+8>>2]|0,157816)|0)!=0:0)?(qy(c[(c[(c[n>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0)break;if((((c[n>>2]|0)!=0?(c[(c[n>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[n>>2]|0)+8>>2]|0,157800)|0)!=0:0)?(qy(c[(c[(c[n>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0)break;if((((c[n>>2]|0)!=0?(c[(c[n>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[n>>2]|0)+8>>2]|0,157936)|0)!=0:0)?(qy(c[(c[(c[n>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0)break;if((((c[n>>2]|0)!=0?(c[(c[n>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[n>>2]|0)+8>>2]|0,157952)|0)!=0:0)?(qy(c[(c[(c[n>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0)break;if((((c[n>>2]|0)!=0?(c[(c[n>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[n>>2]|0)+8>>2]|0,157792)|0)!=0:0)?(qy(c[(c[(c[n>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0)break;if((((c[n>>2]|0)!=0?(c[(c[n>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[n>>2]|0)+8>>2]|0,157880)|0)!=0:0)?(qy(c[(c[(c[n>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0)break;if((((c[n>>2]|0)!=0?(c[(c[n>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[n>>2]|0)+8>>2]|0,157864)|0)!=0:0)?(qy(c[(c[(c[n>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0)break;do if((c[n>>2]|0)!=0?(c[(c[n>>2]|0)+36>>2]|0)!=0:0){if(!(qy(c[(c[n>>2]|0)+8>>2]|0,157896)|0))break;if(qy(c[(c[(c[n>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)break c}while(0);do if(c[n>>2]|0){if(!(c[(c[n>>2]|0)+36>>2]|0))break;if(!(qy(c[(c[n>>2]|0)+8>>2]|0,157904)|0))break;if(qy(c[(c[(c[n>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)break c}while(0);if(!(c[n>>2]|0))break b;if(!(c[(c[n>>2]|0)+36>>2]|0))break b;if(!(qy(c[(c[n>>2]|0)+8>>2]|0,157920)|0))break b;if(!(qy(c[(c[(c[n>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0))break b}while(0);c[r>>2]=qH(c[h>>2]|0,c[j>>2]|0,c[n>>2]|0)|0;if(c[r>>2]|0){p=c[r>>2]|0;if(!(c[s>>2]|0))c[(c[m>>2]|0)+68>>2]=p;else c[(c[s>>2]|0)+4>>2]=p;c[s>>2]=c[r>>2];c[(c[s>>2]|0)+4>>2]=0}c[n>>2]=c[(c[n>>2]|0)+24>>2]}if(c[(c[m>>2]|0)+68>>2]|0){c[u>>2]=0;c[r>>2]=c[(c[m>>2]|0)+68>>2];while(1){c[t>>2]=Cb[c[135744>>2]&511](8)|0;if(!(c[t>>2]|0))break;c[(c[t>>2]|0)+4>>2]=c[r>>2];c[c[t>>2]>>2]=0;p=c[t>>2]|0;if(!(c[u>>2]|0))c[(c[m>>2]|0)+96>>2]=p;else c[c[u>>2]>>2]=p;c[u>>2]=c[t>>2];c[r>>2]=c[(c[r>>2]|0)+4>>2];if(!(c[r>>2]|0))break a}tC(c[h>>2]|0,166376,0);zb[c[135736>>2]&511](c[t>>2]|0);c[g>>2]=0;v=c[g>>2]|0;i=f;return v|0}}while(0);if((c[c[m>>2]>>2]|0)==5){if((SF(c[h>>2]|0,c[j>>2]|0,n,(c[m>>2]|0)+116|0,12,0)|0)==-1){c[g>>2]=0;v=c[g>>2]|0;i=f;return v|0}if((((c[n>>2]|0)!=0?(c[(c[n>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[n>>2]|0)+8>>2]|0,163328)|0)!=0:0)?(qy(c[(c[(c[n>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){t=TF(c[h>>2]|0,c[j>>2]|0,c[n>>2]|0)|0;c[(c[m>>2]|0)+84>>2]=t;c[n>>2]=c[(c[n>>2]|0)+24>>2]}}do if(c[n>>2]|0){if((c[l>>2]|0)==10){uE(c[h>>2]|0,3033,0,c[k>>2]|0,c[n>>2]|0,0,166400);break}t=c[h>>2]|0;m=c[k>>2]|0;j=c[n>>2]|0;if((c[l>>2]|0)==9){uE(t,3033,0,m,j,0,166504);break}else{uE(t,3033,0,m,j,0,166752);break}}while(0);c[g>>2]=0;v=c[g>>2]|0;i=f;return v|0}function VF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[l>>2]=0;if((c[g>>2]|0)==0|(c[h>>2]|0)==0|(c[j>>2]|0)==0){c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}c[k>>2]=c[(c[g>>2]|0)+84>>2];d=(c[k>>2]|0)+48|0;c[d>>2]=c[d>>2]|64;d=IH(46)|0;c[(c[k>>2]|0)+64>>2]=d;c[m>>2]=c[(c[j>>2]|0)+44>>2];while(1){if(!(c[m>>2]|0))break;d=c[m>>2]|0;if(!(c[(c[m>>2]|0)+36>>2]|0)){if((qy(c[d+8>>2]|0,161384)|0)==0?(qy(c[(c[m>>2]|0)+8>>2]|0,160400)|0)==0:0)GF(c[g>>2]|0,3035,0,c[m>>2]|0)}else if(qy(c[(c[d+36>>2]|0)+8>>2]|0,c[38526]|0)|0)GF(c[g>>2]|0,3035,0,c[m>>2]|0);c[m>>2]=c[(c[m>>2]|0)+24>>2]}cE(c[g>>2]|0,c[j>>2]|0,161384)|0;fG(c[g>>2]|0,c[h>>2]|0,0,c[j>>2]|0,160400,(c[k>>2]|0)+60|0,(c[k>>2]|0)+56|0)|0;c[l>>2]=c[(c[j>>2]|0)+12>>2];if((((c[l>>2]|0)!=0?(c[(c[l>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[l>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(qy(c[(c[(c[l>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){m=c[k>>2]|0;kH(m,jE(c[g>>2]|0,c[l>>2]|0,1)|0)|0;c[l>>2]=c[(c[l>>2]|0)+24>>2]}if((((c[l>>2]|0)!=0?(c[(c[l>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[l>>2]|0)+8>>2]|0,161024)|0)!=0:0)?(qy(c[(c[(c[l>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){m=c[g>>2]|0;if(c[(c[k>>2]|0)+56>>2]|0)GE(m,3e3,0,c[j>>2]|0,165952,0);else{d=oE(m,c[h>>2]|0,c[l>>2]|0,0)|0;c[(c[k>>2]|0)+28>>2]=d}c[l>>2]=c[(c[l>>2]|0)+24>>2]}else o=25;if((o|0)==25?(c[(c[k>>2]|0)+56>>2]|0)==0:0)GE(c[g>>2]|0,3e3,0,c[j>>2]|0,166032,0);if(c[l>>2]|0)uE(c[g>>2]|0,3033,0,c[j>>2]|0,c[l>>2]|0,0,164200);if(((c[(c[k>>2]|0)+56>>2]|0)==0?(c[(c[k>>2]|0)+28>>2]|0)==0:0)?(dE(c[j>>2]|0,160400)|0)==0:0)GE(c[g>>2]|0,3e3,0,c[j>>2]|0,166032,0);c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}function WF(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;f=i;i=i+80|0;g=f+64|0;h=f+60|0;j=f+56|0;k=f+52|0;l=f+48|0;m=f+44|0;n=f+40|0;o=f+36|0;p=f+32|0;q=f+28|0;r=f+24|0;s=f+20|0;t=f+16|0;u=f+12|0;v=f+8|0;w=f+4|0;x=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=e;c[m>>2]=0;c[o>>2]=0;if((c[h>>2]|0)==0|(c[j>>2]|0)==0|(c[k>>2]|0)==0){c[g>>2]=-1;y=c[g>>2]|0;i=f;return y|0}c[l>>2]=c[(c[h>>2]|0)+84>>2];e=(c[l>>2]|0)+48|0;c[e>>2]=c[e>>2]|128;e=IH(46)|0;c[(c[l>>2]|0)+64>>2]=e;c[n>>2]=c[(c[k>>2]|0)+44>>2];while(1){if(!(c[n>>2]|0))break;e=c[n>>2]|0;if(!(c[(c[n>>2]|0)+36>>2]|0)){if((qy(c[e+8>>2]|0,161384)|0)==0?(qy(c[(c[n>>2]|0)+8>>2]|0,160512)|0)==0:0)GF(c[h>>2]|0,3035,0,c[n>>2]|0)}else if(qy(c[(c[e+36>>2]|0)+8>>2]|0,c[38526]|0)|0)GF(c[h>>2]|0,3035,0,c[n>>2]|0);c[n>>2]=c[(c[n>>2]|0)+24>>2]}cE(c[h>>2]|0,c[k>>2]|0,161384)|0;c[n>>2]=dE(c[k>>2]|0,160512)|0;a:do if(c[n>>2]|0){c[u>>2]=0;c[o>>2]=fE(c[h>>2]|0,c[n>>2]|0)|0;c[(c[l>>2]|0)+56>>2]=c[o>>2];while(1){do if((d[c[o>>2]>>0]|0|0)==32)z=1;else{if(9<=(d[c[o>>2]>>0]|0|0)?(d[c[o>>2]>>0]|0|0)<=10:0){
z=1;break}z=(d[c[o>>2]>>0]|0|0)==13}while(0);e=c[o>>2]|0;if(z){c[o>>2]=e+1;continue}c[p>>2]=e;while(1){if(d[c[p>>2]>>0]|0){do if((d[c[p>>2]>>0]|0|0)==32)A=1;else{if(9<=(d[c[p>>2]>>0]|0|0)?(d[c[p>>2]>>0]|0|0)<=10:0){A=1;break}A=(d[c[p>>2]>>0]|0|0)==13}while(0);B=A^1}else B=0;C=c[p>>2]|0;if(!B)break;c[p>>2]=C+1}if((C|0)==(c[o>>2]|0))break a;c[q>>2]=ly(c[o>>2]|0,(c[p>>2]|0)-(c[o>>2]|0)|0)|0;if(!(rH(c[h>>2]|0,c[j>>2]|0,0,c[n>>2]|0,c[q>>2]|0,s,r)|0)){c[t>>2]=Cb[c[135744>>2]&511](8)|0;if(!(c[t>>2]|0)){D=32;break}c[(c[t>>2]|0)+4>>2]=0;c[c[t>>2]>>2]=0;e=c[t>>2]|0;if(!(c[u>>2]|0))c[(c[l>>2]|0)+92>>2]=e;else c[c[u>>2]>>2]=e;c[u>>2]=c[t>>2];c[v>>2]=cG(c[h>>2]|0,4,c[r>>2]|0,c[s>>2]|0)|0;if(!(c[v>>2]|0))break;c[(c[t>>2]|0)+4>>2]=c[v>>2]}if(c[q>>2]|0){zb[c[135736>>2]&511](c[q>>2]|0);c[q>>2]=0}c[o>>2]=c[p>>2];if(!(d[c[o>>2]>>0]|0))break a}if((D|0)==32){tC(c[h>>2]|0,165784,0);c[g>>2]=-1;y=c[g>>2]|0;i=f;return y|0}if(c[q>>2]|0){zb[c[135736>>2]&511](c[q>>2]|0);c[q>>2]=0}c[g>>2]=-1;y=c[g>>2]|0;i=f;return y|0}while(0);c[m>>2]=c[(c[k>>2]|0)+12>>2];if((((c[m>>2]|0)!=0?(c[(c[m>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[m>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(qy(c[(c[(c[m>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){q=c[l>>2]|0;kH(q,jE(c[h>>2]|0,c[m>>2]|0,1)|0)|0;c[m>>2]=c[(c[m>>2]|0)+24>>2]}b:do if((((c[m>>2]|0)!=0?(c[(c[m>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[m>>2]|0)+8>>2]|0,161024)|0)!=0:0)?(qy(c[(c[(c[m>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){c[x>>2]=0;while(1){if(!(c[m>>2]|0))break b;if(!(c[(c[m>>2]|0)+36>>2]|0))break b;if(!(qy(c[(c[m>>2]|0)+8>>2]|0,161024)|0))break b;if(!(qy(c[(c[(c[m>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0))break b;c[w>>2]=oE(c[h>>2]|0,c[j>>2]|0,c[m>>2]|0,0)|0;if(c[w>>2]|0){q=c[w>>2]|0;if(!(c[x>>2]|0)){c[(c[l>>2]|0)+28>>2]=q;c[x>>2]=c[w>>2]}else{c[(c[x>>2]|0)+4>>2]=q;c[x>>2]=c[w>>2]}c[(c[x>>2]|0)+4>>2]=0}c[m>>2]=c[(c[m>>2]|0)+24>>2]}}while(0);if(c[m>>2]|0)uE(c[h>>2]|0,3033,0,c[k>>2]|0,c[m>>2]|0,0,165832);if((c[n>>2]|0)==0?(c[(c[l>>2]|0)+28>>2]|0)==0:0)GE(c[h>>2]|0,3007,0,c[k>>2]|0,165864,0);c[g>>2]=0;y=c[g>>2]|0;i=f;return y|0}function XF(a,b,e,f,g,h){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;j=i;i=i+48|0;k=j+40|0;l=j+36|0;m=j+32|0;n=j+28|0;o=j+24|0;p=j+20|0;q=j+16|0;r=j+12|0;s=j+8|0;t=j+4|0;u=j;c[l>>2]=a;c[m>>2]=b;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=h;c[t>>2]=0;c[u>>2]=dE(c[m>>2]|0,161824)|0;if(!(c[u>>2]|0)){c[k>>2]=c[p>>2];v=c[k>>2]|0;i=j;return v|0}c[r>>2]=fE(c[l>>2]|0,c[u>>2]|0)|0;c[s>>2]=c[r>>2];while(1){do if((d[c[s>>2]>>0]|0|0)==32)w=1;else{if(9<=(d[c[s>>2]>>0]|0|0)?(d[c[s>>2]>>0]|0|0)<=10:0){w=1;break}w=(d[c[s>>2]>>0]|0|0)==13}while(0);x=c[s>>2]|0;if(!w)break;c[s>>2]=x+1}if(!(d[x>>0]|0)){hE(c[l>>2]|0,3037,0,c[u>>2]|0,0,c[q>>2]|0,c[r>>2]|0,0,0,0);c[k>>2]=c[p>>2];v=c[k>>2]|0;i=j;return v|0}while(1){if((d[c[s>>2]>>0]|0|0)<48)break;if((d[c[s>>2]>>0]|0|0)>57)break;c[t>>2]=((c[t>>2]|0)*10|0)+((d[c[s>>2]>>0]|0)-48);c[s>>2]=(c[s>>2]|0)+1}while(1){do if((d[c[s>>2]>>0]|0|0)==32)y=1;else{if(9<=(d[c[s>>2]>>0]|0|0)?(d[c[s>>2]>>0]|0|0)<=10:0){y=1;break}y=(d[c[s>>2]>>0]|0|0)==13}while(0);z=c[s>>2]|0;if(!y)break;c[s>>2]=z+1}do if((d[z>>0]|0|0)==0?(c[t>>2]|0)>=(c[n>>2]|0):0){if((c[o>>2]|0)!=-1?(c[t>>2]|0)>(c[o>>2]|0):0)break;c[k>>2]=c[t>>2];v=c[k>>2]|0;i=j;return v|0}while(0);hE(c[l>>2]|0,3037,0,c[u>>2]|0,0,c[q>>2]|0,c[r>>2]|0,0,0,0);c[k>>2]=c[p>>2];v=c[k>>2]|0;i=j;return v|0}function YF(a,b,e,f,g,h){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;j=i;i=i+48|0;k=j+40|0;l=j+36|0;m=j+32|0;n=j+28|0;o=j+24|0;p=j+20|0;q=j+16|0;r=j+12|0;s=j+8|0;t=j+4|0;u=j;c[l>>2]=a;c[m>>2]=b;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=h;c[t>>2]=0;c[u>>2]=dE(c[m>>2]|0,161808)|0;if(!(c[u>>2]|0)){c[k>>2]=c[p>>2];v=c[k>>2]|0;i=j;return v|0}c[r>>2]=fE(c[l>>2]|0,c[u>>2]|0)|0;if(qy(c[r>>2]|0,163200)|0)if((c[o>>2]|0)!=1073741824){hE(c[l>>2]|0,3037,0,c[u>>2]|0,0,c[q>>2]|0,c[r>>2]|0,0,0,0);c[k>>2]=c[p>>2];v=c[k>>2]|0;i=j;return v|0}else{c[k>>2]=1073741824;v=c[k>>2]|0;i=j;return v|0}c[s>>2]=c[r>>2];while(1){do if((d[c[s>>2]>>0]|0|0)==32)w=1;else{if(9<=(d[c[s>>2]>>0]|0|0)?(d[c[s>>2]>>0]|0|0)<=10:0){w=1;break}w=(d[c[s>>2]>>0]|0|0)==13}while(0);x=c[s>>2]|0;if(!w)break;c[s>>2]=x+1}if(!(d[x>>0]|0)){hE(c[l>>2]|0,3037,0,c[u>>2]|0,0,c[q>>2]|0,c[r>>2]|0,0,0,0);c[k>>2]=c[p>>2];v=c[k>>2]|0;i=j;return v|0}while(1){if((d[c[s>>2]>>0]|0|0)<48)break;if((d[c[s>>2]>>0]|0|0)>57)break;c[t>>2]=((c[t>>2]|0)*10|0)+((d[c[s>>2]>>0]|0)-48);c[s>>2]=(c[s>>2]|0)+1}while(1){do if((d[c[s>>2]>>0]|0|0)==32)y=1;else{if(9<=(d[c[s>>2]>>0]|0|0)?(d[c[s>>2]>>0]|0|0)<=10:0){y=1;break}y=(d[c[s>>2]>>0]|0|0)==13}while(0);z=c[s>>2]|0;if(!y)break;c[s>>2]=z+1}do if((d[z>>0]|0|0)==0?(c[t>>2]|0)>=(c[n>>2]|0):0){if((c[o>>2]|0)!=-1?(c[t>>2]|0)>(c[o>>2]|0):0)break;c[k>>2]=c[t>>2];v=c[k>>2]|0;i=j;return v|0}while(0);hE(c[l>>2]|0,3037,0,c[u>>2]|0,0,c[q>>2]|0,c[r>>2]|0,0,0,0);c[k>>2]=c[p>>2];v=c[k>>2]|0;i=j;return v|0}function ZF(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+8|0;l=g+4|0;m=g;c[j>>2]=a;c[g+12>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;if((c[m>>2]|0)==0&(c[l>>2]|0)==0){c[h>>2]=0;n=c[h>>2]|0;i=g;return n|0}if((c[m>>2]|0)!=1073741824){if((c[m>>2]|0)<1){f=c[j>>2]|0;bG(f,3044,0,0,dE(c[k>>2]|0,161808)|0,163048);c[h>>2]=3044;n=c[h>>2]|0;i=g;return n|0}if((c[l>>2]|0)>(c[m>>2]|0)){m=c[j>>2]|0;bG(m,3043,0,0,dE(c[k>>2]|0,161824)|0,163096);c[h>>2]=3043;n=c[h>>2]|0;i=g;return n|0}}c[h>>2]=0;n=c[h>>2]|0;i=g;return n|0}function _F(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+32|0;j=h+24|0;k=h+20|0;l=h+16|0;m=h+12|0;n=h+8|0;o=h+4|0;p=h;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[p>>2]=fE(c[j>>2]|0,c[m>>2]|0)|0;g=rH(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0,c[p>>2]|0,c[n>>2]|0,c[o>>2]|0)|0;i=h;return g|0}function $F(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+32|0;h=g+28|0;j=g+24|0;k=g+16|0;l=g+12|0;m=g+8|0;n=g+4|0;o=g;c[j>>2]=a;c[g+20>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;if(qy(c[(c[j>>2]|0)+112>>2]|0,c[m>>2]|0)|0){c[h>>2]=0;p=c[h>>2]|0;i=g;return p|0}if(qy(c[38526]|0,c[m>>2]|0)|0){c[h>>2]=0;p=c[h>>2]|0;i=g;return p|0}a:do if(c[(c[(c[(c[j>>2]|0)+28>>2]|0)+16>>2]|0)+24>>2]|0){c[n>>2]=c[(c[(c[(c[j>>2]|0)+28>>2]|0)+16>>2]|0)+24>>2];while(1){if(!((c[(c[n>>2]|0)+4>>2]|0)!=0?(c[(c[n>>2]|0)+4>>2]|0)!=1:0))q=9;if((q|0)==9?(q=0,(qy(c[m>>2]|0,c[(c[n>>2]|0)+8>>2]|0)|0)!=0):0)break;c[n>>2]=c[c[n>>2]>>2];if(!(c[n>>2]|0))break a}c[h>>2]=0;p=c[h>>2]|0;i=g;return p|0}while(0);if(c[l>>2]|0)r=c[l>>2]|0;else r=c[k>>2]|0;c[o>>2]=r;r=c[j>>2]|0;j=c[o>>2]|0;if(!(c[m>>2]|0))AB(r,3004,j,0,162704,0,0);else AB(r,3004,j,0,162824,c[m>>2]|0,0);c[h>>2]=3004;p=c[h>>2]|0;i=g;return p|0}function aG(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+32|0;j=h+24|0;k=h+20|0;l=h+16|0;m=h+12|0;n=h+8|0;o=h+4|0;p=h;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[p>>2]=0;GC(p,0,c[l>>2]|0,c[(c[m>>2]|0)+20>>2]|0)|0;EF(c[j>>2]|0,c[m>>2]|0,c[k>>2]|0,0,0,0,164296,c[p>>2]|0,c[n>>2]|0,c[o>>2]|0,0,0);if(!(c[p>>2]|0)){i=h;return}zb[c[135736>>2]&511](c[p>>2]|0);c[p>>2]=0;i=h;return}function bG(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+32|0;j=h+24|0;k=h+20|0;l=h+16|0;m=h+12|0;n=h+8|0;o=h+4|0;p=h;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[p>>2]=0;do if(c[l>>2]|0){g=c[l>>2]|0;if(!(c[c[l>>2]>>2]|0)){GC(g,0,c[m>>2]|0,c[(c[n>>2]|0)+20>>2]|0)|0;c[p>>2]=c[c[l>>2]>>2];break}else{c[p>>2]=c[g>>2];break}}else GC(p,0,c[m>>2]|0,c[(c[n>>2]|0)+20>>2]|0)|0;while(0);m=c[j>>2]|0;if(!(c[n>>2]|0))EF(m,0,c[k>>2]|0,0,0,0,163160,c[p>>2]|0,163192,c[o>>2]|0,0,0);else EF(m,c[n>>2]|0,c[k>>2]|0,0,0,0,163160,c[p>>2]|0,c[(c[n>>2]|0)+8>>2]|0,c[o>>2]|0,0,0);if(!((c[l>>2]|0)==0&(c[p>>2]|0)!=0)){i=h;return}zb[c[135736>>2]&511](c[p>>2]|0);c[p>>2]=0;i=h;return}function cG(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=Cb[c[135744>>2]&511](24)|0;if(!(c[m>>2]|0)){tC(c[h>>2]|0,162672,0);c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}else{c[(c[m>>2]|0)+20>>2]=0;c[c[m>>2]>>2]=2e3;c[(c[m>>2]|0)+12>>2]=c[k>>2];c[(c[m>>2]|0)+16>>2]=c[l>>2];c[(c[m>>2]|0)+4>>2]=0;c[(c[m>>2]|0)+8>>2]=c[j>>2];dG((c[(c[(c[h>>2]|0)+28>>2]|0)+16>>2]|0)+48|0,10,c[m>>2]|0)|0;c[g>>2]=c[m>>2];n=c[g>>2]|0;i=f;return n|0}return 0}function dG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if((c[c[g>>2]>>2]|0)==0?(d=JB()|0,c[c[g>>2]>>2]=d,(c[c[g>>2]>>2]|0)==0):0){c[f>>2]=-1;k=c[f>>2]|0;i=e;return k|0}pG(c[c[g>>2]>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}function eG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+32|0;h=g+24|0;j=g+20|0;k=g+16|0;l=g+12|0;m=g+8|0;n=g+4|0;o=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=0;if((c[j>>2]|0)==0|(c[k>>2]|0)==0){c[h>>2]=0;p=c[h>>2]|0;i=g;return p|0}c[o>>2]=Cb[c[135744>>2]&511](104)|0;if(!(c[o>>2]|0)){tC(c[j>>2]|0,165528,0);c[h>>2]=0;p=c[h>>2]|0;i=g;return p|0}f=(c[o>>2]|0)+0|0;e=f+104|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(e|0));c[c[o>>2]>>2]=14;c[(c[o>>2]|0)+8>>2]=c[k>>2];c[(c[o>>2]|0)+52>>2]=c[l>>2];c[(c[o>>2]|0)+36>>2]=c[m>>2];m=c[(c[(c[j>>2]|0)+28>>2]|0)+16>>2]|0;if(c[n>>2]|0)dG(m+44|0,5,c[o>>2]|0)|0;else dG(m+48|0,10,c[o>>2]|0)|0;dG((c[(c[j>>2]|0)+28>>2]|0)+20|0,10,c[o>>2]|0)|0;c[h>>2]=c[o>>2];p=c[h>>2]|0;i=g;return p|0}function fG(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;j=i;i=i+48|0;k=j+32|0;l=j+28|0;m=j+24|0;n=j+20|0;o=j+16|0;p=j+12|0;q=j+8|0;r=j+4|0;s=j;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;c[r>>2]=h;c[s>>2]=dE(c[o>>2]|0,c[p>>2]|0)|0;if(!(c[s>>2]|0)){c[c[r>>2]>>2]=0;c[c[q>>2]>>2]=0;c[k>>2]=0;t=c[k>>2]|0;i=j;return t|0}else{c[k>>2]=_F(c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,c[s>>2]|0,c[q>>2]|0,c[r>>2]|0)|0;t=c[k>>2]|0;i=j;return t|0}return 0}function gG(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=RC(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0)|0;if(!(c[m>>2]|0)){c[g>>2]=c[l>>2];n=c[g>>2]|0;i=f;return n|0}do if(!(qy(c[m>>2]|0,165504)|0)){if(qy(c[m>>2]|0,165512)|0){c[l>>2]=0;break}if(qy(c[m>>2]|0,161736)|0){c[l>>2]=1;break}if(qy(c[m>>2]|0,165520)|0){c[l>>2]=0;break}else{e=c[h>>2]|0;d=dE(c[j>>2]|0,c[k>>2]|0)|0;b=IH(15)|0;hE(e,1714,0,d,b,0,c[m>>2]|0,0,0,0);break}}else c[l>>2]=1;while(0);c[g>>2]=c[l>>2];n=c[g>>2]|0;i=f;return n|0}function hG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=i;i=i+48|0;h=g+44|0;j=g+40|0;k=g+36|0;l=g+32|0;m=g+28|0;n=g+24|0;o=g+20|0;p=g+16|0;q=g+12|0;r=g+8|0;s=g+4|0;t=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=0;c[p>>2]=0;c[r>>2]=0;c[s>>2]=0;c[t>>2]=0;c[q>>2]=c[(c[l>>2]|0)+44>>2];while(1){if(!(c[q>>2]|0))break;f=c[q>>2]|0;do if(!(c[(c[q>>2]|0)+36>>2]|0)){if((qy(c[f+8>>2]|0,161384)|0)==0?(qy(c[(c[q>>2]|0)+8>>2]|0,161352)|0)==0:0){if((c[m>>2]|0)==24?(qy(c[(c[q>>2]|0)+8>>2]|0,160144)|0)!=0:0)break;GF(c[j>>2]|0,3035,0,c[q>>2]|0)}}else if(qy(c[(c[f+36>>2]|0)+8>>2]|0,c[38526]|0)|0)GF(c[j>>2]|0,3035,0,c[q>>2]|0);while(0);c[q>>2]=c[(c[q>>2]|0)+24>>2]}c[q>>2]=dE(c[l>>2]|0,161352)|0;f=c[j>>2]|0;if(!(c[q>>2]|0)){MF(f,3036,0,c[l>>2]|0,161352,0);c[h>>2]=0;u=c[h>>2]|0;i=g;return u|0}e=c[q>>2]|0;if(eE(f,0,e,IH(22)|0,r)|0){c[h>>2]=0;u=c[h>>2]|0;i=g;return u|0}c[o>>2]=sH(c[j>>2]|0,c[k>>2]|0,c[r>>2]|0,c[n>>2]|0,c[m>>2]|0,c[l>>2]|0)|0;if(!(c[o>>2]|0)){c[h>>2]=0;u=c[h>>2]|0;i=g;return u|0}cE(c[j>>2]|0,c[l>>2]|0,161384)|0;do if((c[m>>2]|0)==24){c[q>>2]=dE(c[l>>2]|0,160144)|0;n=c[j>>2]|0;if(!(c[q>>2]|0)){MF(n,3036,0,c[l>>2]|0,160144,0);break}r=cG(n,23,0,0)|0;c[(c[o>>2]|0)+36>>2]=r;if(c[(c[o>>2]|0)+36>>2]|0){_F(c[j>>2]|0,c[k>>2]|0,0,c[q>>2]|0,(c[(c[o>>2]|0)+36>>2]|0)+16|0,(c[(c[o>>2]|0)+36>>2]|0)+12|0)|0;$F(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,c[q>>2]|0,c[(c[(c[o>>2]|0)+36>>2]|0)+16>>2]|0)|0;break}c[h>>2]=0;u=c[h>>2]|0;i=g;return u|0}while(0);c[p>>2]=c[(c[l>>2]|0)+12>>2];if((((c[p>>2]|0)!=0?(c[(c[p>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[p>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(qy(c[(c[(c[p>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){q=jE(c[j>>2]|0,c[p>>2]|0,1)|0;c[(c[o>>2]|0)+4>>2]=q;c[p>>2]=c[(c[p>>2]|0)+24>>2]}if(!(c[p>>2]|0))uE(c[j>>2]|0,3034,0,c[l>>2]|0,c[p>>2]|0,164808,164840);a:do if((((c[p>>2]|0)!=0?(c[(c[p>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[p>>2]|0)+8>>2]|0,164880)|0)!=0:0)?(qy(c[(c[(c[p>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){q=tH(c[j>>2]|0,c[o>>2]|0,c[p>>2]|0,0)|0;c[(c[o>>2]|0)+24>>2]=q;c[p>>2]=c[(c[p>>2]|0)+24>>2];if((((c[p>>2]|0)!=0?(c[(c[p>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[p>>2]|0)+8>>2]|0,164896)|0)!=0:0)?(qy(c[(c[(c[p>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0)while(1){c[s>>2]=tH(c[j>>2]|0,c[o>>2]|0,c[p>>2]|0,1)|0;if(c[s>>2]|0){c[(c[s>>2]|0)+8>>2]=c[(c[o>>2]|0)+32>>2];q=(c[o>>2]|0)+32|0;c[q>>2]=(c[q>>2]|0)+1;q=c[s>>2]|0;if(c[t>>2]|0)c[c[t>>2]>>2]=q;else c[(c[o>>2]|0)+28>>2]=q;c[t>>2]=c[s>>2]}c[p>>2]=c[(c[p>>2]|0)+24>>2];if(!(c[p>>2]|0))break a;if(!(c[(c[p>>2]|0)+36>>2]|0))break a;if(!(qy(c[(c[p>>2]|0)+8>>2]|0,164896)|0))break a;if(!(qy(c[(c[(c[p>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0))break a}uE(c[j>>2]|0,3033,0,c[l>>2]|0,c[p>>2]|0,0,164840)}while(0);if(c[p>>2]|0)uE(c[j>>2]|0,3033,0,c[l>>2]|0,c[p>>2]|0,0,164840);c[h>>2]=c[o>>2];u=c[h>>2]|0;i=g;return u|0}function iG(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+32|0;j=h+28|0;k=h+24|0;l=h+20|0;m=h+16|0;n=h+12|0;o=h+8|0;p=h+4|0;q=h;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=0;if((c[k>>2]|0)==0|(c[l>>2]|0)==0){c[j>>2]=0;r=c[j>>2]|0;i=h;return r|0}c[q>>2]=Cb[c[135744>>2]&511](76)|0;if(!(c[q>>2]|0)){tC(c[k>>2]|0,164272,0);c[j>>2]=0;r=c[j>>2]|0;i=h;return r|0}l=(c[q>>2]|0)+0|0;g=l+76|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(g|0));c[c[q>>2]>>2]=15;c[(c[q>>2]|0)+52>>2]=c[o>>2];c[(c[q>>2]|0)+8>>2]=c[m>>2];c[(c[q>>2]|0)+56>>2]=c[n>>2];n=c[(c[(c[k>>2]|0)+28>>2]|0)+16>>2]|0;if(c[p>>2]|0)dG(n+44|0,5,c[q>>2]|0)|0;else dG(n+48|0,10,c[q>>2]|0)|0;dG((c[(c[k>>2]|0)+28>>2]|0)+20|0,10,c[q>>2]|0)|0;c[j>>2]=c[q>>2];r=c[j>>2]|0;i=h;return r|0}function jG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g+24|0;j=g+20|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;c[j>>2]=a;c[g+16>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[n>>2]=0;if((c[j>>2]|0)==0|(c[k>>2]|0)==0){c[h>>2]=0;o=c[h>>2]|0;i=g;return o|0}c[n>>2]=Cb[c[135744>>2]&511](60)|0;if(!(c[n>>2]|0)){tC(c[j>>2]|0,164360,0);c[h>>2]=0;o=c[h>>2]|0;i=g;return o|0}f=(c[n>>2]|0)+0|0;e=f+60|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(e|0));c[c[n>>2]>>2]=16;c[(c[n>>2]|0)+8>>2]=c[k>>2];c[(c[n>>2]|0)+52>>2]=c[l>>2];c[(c[n>>2]|0)+32>>2]=c[m>>2];m=(c[n>>2]|0)+36|0;c[m>>2]=c[m>>2]|2;do if(c[(c[j>>2]|0)+100>>2]|0){m=GG(c[j>>2]|0,c[(c[j>>2]|0)+116>>2]|0,c[n>>2]|0,c[k>>2]|0,c[l>>2]|0)|0;c[(c[j>>2]|0)+120>>2]=m;if(c[(c[j>>2]|0)+120>>2]|0){c[(c[j>>2]|0)+124>>2]=0;break}zb[c[135736>>2]&511](c[n>>2]|0);c[h>>2]=0;o=c[h>>2]|0;i=g;return o|0}while(0);dG((c[(c[(c[j>>2]|0)+28>>2]|0)+16>>2]|0)+44|0,5,c[n>>2]|0)|0;dG((c[(c[j>>2]|0)+28>>2]|0)+20|0,10,c[n>>2]|0)|0;c[h>>2]=c[n>>2];o=c[h>>2]|0;i=g;return o|0}function kG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+32|0;h=g+24|0;j=g+20|0;k=g+16|0;l=g+12|0;m=g+8|0;n=g+4|0;o=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=0;if((c[j>>2]|0)==0|(c[k>>2]|0)==0|(c[l>>2]|0)==0){c[h>>2]=0;p=c[h>>2]|0;i=g;return p|0}c[o>>2]=Cb[c[135744>>2]&511](32)|0;if(!(c[o>>2]|0)){tC(c[j>>2]|0,163256,0);c[h>>2]=0;p=c[h>>2]|0;i=g;return p|0}k=c[o>>2]|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[k+24>>2]=0;c[k+28>>2]=0;c[(c[o>>2]|0)+16>>2]=c[l>>2];c[c[o>>2]>>2]=17;c[(c[o>>2]|0)+24>>2]=c[n>>2];c[(c[o>>2]|0)+20>>2]=c[m>>2];do if(c[(c[j>>2]|0)+100>>2]|0){n=GG(c[j>>2]|0,c[(c[j>>2]|0)+116>>2]|0,c[o>>2]|0,c[l>>2]|0,c[m>>2]|0)|0;c[(c[j>>2]|0)+120>>2]=n;if(c[(c[j>>2]|0)+120>>2]|0){c[(c[j>>2]|0)+124>>2]=0;break}zb[c[135736>>2]&511](c[o>>2]|0);c[h>>2]=0;p=c[h>>2]|0;i=g;return p|0}while(0);dG((c[(c[(c[j>>2]|0)+28>>2]|0)+16>>2]|0)+44|0,5,c[o>>2]|0)|0;dG((c[(c[j>>2]|0)+28>>2]|0)+20|0,10,c[o>>2]|0)|0;c[h>>2]=c[o>>2];p=c[h>>2]|0;i=g;return p|0}function lG(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+32|0;k=j+24|0;l=j+20|0;m=j+16|0;n=j+12|0;o=j+8|0;p=j+4|0;q=j;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=h;h=c[k>>2]|0;if(c[m>>2]|0){PC(h,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[q>>2]|0);i=j;return}else{PC(h,c[l>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[q>>2]|0);i=j;return}}function mG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g+24|0;j=g+20|0;k=g+16|0;l=g+12|0;m=g+8|0;n=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[g+4>>2]=f;c[n>>2]=0;if((c[j>>2]|0)==0|(c[k>>2]|0)==0|(c[l>>2]|0)==0){c[h>>2]=0;o=c[h>>2]|0;i=g;return o|0}c[n>>2]=Cb[c[135744>>2]&511](20)|0;if(!(c[n>>2]|0)){tC(c[j>>2]|0,161632,0);c[h>>2]=0;o=c[h>>2]|0;i=g;return o|0}else{k=c[n>>2]|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[c[n>>2]>>2]=18;c[(c[n>>2]|0)+4>>2]=c[l>>2];c[(c[n>>2]|0)+16>>2]=c[m>>2];dG((c[(c[(c[j>>2]|0)+28>>2]|0)+16>>2]|0)+44|0,5,c[n>>2]|0)|0;c[h>>2]=c[n>>2];o=c[h>>2]|0;i=g;return o|0}return 0}function nG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=0;if((c[h>>2]|0)==0|(c[g>>2]|0)==0){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}do if(c[g>>2]|0){if((qy(c[j>>2]|0,c[(c[g>>2]|0)+4>>2]|0)|0)!=0?(c[k>>2]=Rj(c[(c[g>>2]|0)+56>>2]|0,c[h>>2]|0)|0,(c[k>>2]|0)!=0):0)break;if(($j(c[(c[g>>2]|0)+48>>2]|0)|0)>1){d=c[(c[g>>2]|0)+48>>2]|0;if(!(c[j>>2]|0))c[l>>2]=Rj(d,145792)|0;else c[l>>2]=Rj(d,c[j>>2]|0)|0;if(c[l>>2]|0)c[k>>2]=Rj(c[(c[(c[l>>2]|0)+52>>2]|0)+56>>2]|0,c[h>>2]|0)|0}}while(0);c[f>>2]=c[k>>2];m=c[f>>2]|0;i=e;return m|0}function oG(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=i;i=i+48|0;l=k+36|0;m=k+32|0;n=k+28|0;o=k+24|0;p=k+20|0;q=k+16|0;r=k+12|0;s=k+8|0;t=k+4|0;u=k;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;c[r>>2]=h;c[s>>2]=j;c[t>>2]=0;c[u>>2]=0;GC(t,0,c[n>>2]|0,c[o>>2]|0)|0;c[u>>2]=my(147824)|0;c[u>>2]=By(c[u>>2]|0,c[p>>2]|0)|0;c[u>>2]=By(c[u>>2]|0,142704)|0;if((c[o>>2]|0)==0&(c[n>>2]|0)!=0)c[o>>2]=FC(c[n>>2]|0)|0;EF(c[l>>2]|0,c[o>>2]|0,c[m>>2]|0,0,0,0,c[u>>2]|0,c[t>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,0);if(c[t>>2]|0){zb[c[135736>>2]&511](c[t>>2]|0);c[t>>2]=0}if(!(c[u>>2]|0)){i=k;return}zb[c[135736>>2]&511](c[u>>2]|0);c[u>>2]=0;i=k;return}function pG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;do if(c[c[g>>2]>>2]|0){if((c[(c[g>>2]|0)+8>>2]|0)<=(c[(c[g>>2]|0)+4>>2]|0)?(d=(c[g>>2]|0)+8|0,c[d>>2]=c[d>>2]<<1,d=Hb[c[135760>>2]&511](c[c[g>>2]>>2]|0,c[(c[g>>2]|0)+8>>2]<<2)|0,c[c[g>>2]>>2]=d,(c[c[g>>2]>>2]|0)==0):0){tC(0,142376,0);c[(c[g>>2]|0)+8>>2]=0;c[f>>2]=-1;k=c[f>>2]|0;i=e;return k|0}}else{if((c[h>>2]|0)<=0)c[h>>2]=1;d=Cb[c[135744>>2]&511](c[h>>2]<<2)|0;c[c[g>>2]>>2]=d;if(c[c[g>>2]>>2]|0){c[(c[g>>2]|0)+8>>2]=c[h>>2];break}tC(0,142344,0);c[f>>2]=-1;k=c[f>>2]|0;i=e;return k|0}while(0);h=c[j>>2]|0;j=(c[g>>2]|0)+4|0;d=c[j>>2]|0;c[j>>2]=d+1;c[(c[c[g>>2]>>2]|0)+(d<<2)>>2]=h;c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}function qG(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=0;if((c[h>>2]|0)==0|(c[j>>2]|0)==0){c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}c[m>>2]=Cb[c[135744>>2]&511](44)|0;if(!(c[m>>2]|0)){tC(c[h>>2]|0,153064,0);c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}else{j=(c[m>>2]|0)+0|0;e=j+44|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(e|0));c[c[m>>2]>>2]=c[k>>2];c[(c[m>>2]|0)+12>>2]=c[l>>2];dG((c[(c[(c[h>>2]|0)+28>>2]|0)+16>>2]|0)+48|0,10,c[m>>2]|0)|0;c[g>>2]=c[m>>2];n=c[g>>2]|0;i=f;return n|0}return 0}function rG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if((c[j>>2]|0)==0|(c[h>>2]|0)==0){c[f>>2]=-1;n=c[f>>2]|0;i=e;return n|0}c[(c[h>>2]|0)+28>>2]=c[(c[j>>2]|0)+28>>2];c[k>>2]=c[(c[j>>2]|0)+32>>2];c[m>>2]=0;while(1){if(!(c[k>>2]|0))break;c[l>>2]=uH(c[g>>2]|0)|0;if(!(c[l>>2]|0)){o=6;break}c[(c[l>>2]|0)+4>>2]=c[(c[k>>2]|0)+4>>2];d=c[l>>2]|0;if(!(c[m>>2]|0))c[(c[h>>2]|0)+32>>2]=d;else c[c[m>>2]>>2]=d;c[m>>2]=c[l>>2];c[k>>2]=c[c[k>>2]>>2]}if((o|0)==6){c[f>>2]=-1;n=c[f>>2]|0;i=e;return n|0}if(c[(c[h>>2]|0)+36>>2]|0)nB(c[(c[h>>2]|0)+36>>2]|0);do if(c[(c[j>>2]|0)+36>>2]|0){o=uH(c[g>>2]|0)|0;c[(c[h>>2]|0)+36>>2]=o;if(c[(c[h>>2]|0)+36>>2]|0){c[(c[(c[h>>2]|0)+36>>2]|0)+4>>2]=c[(c[(c[j>>2]|0)+36>>2]|0)+4>>2];break}c[f>>2]=-1;n=c[f>>2]|0;i=e;return n|0}else c[(c[h>>2]|0)+36>>2]=0;while(0);c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}function sG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+48|0;f=e+40|0;g=e+36|0;h=e+32|0;j=e+28|0;k=e+24|0;l=e+20|0;m=e+16|0;n=e+12|0;o=e+8|0;p=e+4|0;q=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;do if(((c[(c[h>>2]|0)+28>>2]|0)==(c[(c[j>>2]|0)+28>>2]|0)?((c[(c[h>>2]|0)+32>>2]|0)==0|0)==((c[(c[j>>2]|0)+32>>2]|0)==0|0):0)?((c[(c[h>>2]|0)+36>>2]|0)==0|0)==((c[(c[j>>2]|0)+36>>2]|0)==0|0):0){if((c[(c[h>>2]|0)+36>>2]|0)!=0?(c[(c[(c[h>>2]|0)+36>>2]|0)+4>>2]|0)!=(c[(c[(c[j>>2]|0)+36>>2]|0)+4>>2]|0):0)break;if(!(c[(c[h>>2]|0)+32>>2]|0)){c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}c[o>>2]=0;c[k>>2]=c[(c[h>>2]|0)+32>>2];while(1){if(!(c[k>>2]|0))break;c[o>>2]=0;c[l>>2]=c[(c[j>>2]|0)+32>>2];while(1){if(!(c[l>>2]|0))break;if((c[(c[k>>2]|0)+4>>2]|0)==(c[(c[l>>2]|0)+4>>2]|0)){s=12;break}c[l>>2]=c[c[l>>2]>>2]}if((s|0)==12){s=0;c[o>>2]=1}if(!(c[o>>2]|0))break;c[k>>2]=c[c[k>>2]>>2]}if(c[o>>2]|0){c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}}while(0);if((c[(c[h>>2]|0)+28>>2]|0)!=(c[(c[j>>2]|0)+28>>2]|0)?(c[(c[h>>2]|0)+28>>2]|0)!=0:0)if((rG(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0)|0)==-1){c[f>>2]=-1;r=c[f>>2]|0;i=e;return r|0}else{c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}if(!((c[(c[h>>2]|0)+36>>2]|0)!=0?(c[(c[j>>2]|0)+32>>2]|0)!=0:0))s=26;do if((s|0)==26){if((c[(c[j>>2]|0)+36>>2]|0)!=0?(c[(c[h>>2]|0)+32>>2]|0)!=0:0)break;if((c[(c[h>>2]|0)+32>>2]|0)!=0?(c[(c[j>>2]|0)+32>>2]|0)!=0:0){c[k>>2]=c[(c[h>>2]|0)+32>>2];c[m>>2]=0;while(1){if(!(c[k>>2]|0))break;c[q>>2]=0;c[l>>2]=c[(c[j>>2]|0)+32>>2];while(1){if(!(c[l>>2]|0))break;if((c[(c[k>>2]|0)+4>>2]|0)==(c[(c[l>>2]|0)+4>>2]|0)){s=57;break}c[l>>2]=c[c[l>>2]>>2]}if((s|0)==57){s=0;c[q>>2]=1}if(c[q>>2]|0){c[m>>2]=c[k>>2];c[k>>2]=c[c[k>>2]>>2];continue}o=c[c[k>>2]>>2]|0;if(!(c[m>>2]|0))c[(c[h>>2]|0)+32>>2]=o;else c[c[m>>2]>>2]=o;c[n>>2]=c[c[k>>2]>>2];zb[c[135736>>2]&511](c[k>>2]|0);c[k>>2]=c[n>>2]}c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}if(((((c[(c[h>>2]|0)+36>>2]|0)!=0?(c[(c[j>>2]|0)+36>>2]|0)!=0:0)?(c[(c[(c[h>>2]|0)+36>>2]|0)+4>>2]|0)!=(c[(c[(c[j>>2]|0)+36>>2]|0)+4>>2]|0):0)?(c[(c[(c[h>>2]|0)+36>>2]|0)+4>>2]|0)!=0:0)?(c[(c[(c[j>>2]|0)+36>>2]|0)+4>>2]|0)!=0:0){PC(c[g>>2]|0,c[(c[h>>2]|0)+12>>2]|0,1793,153008,0,0);c[f>>2]=1793;r=c[f>>2]|0;i=e;return r|0}if((((c[(c[h>>2]|0)+36>>2]|0)!=0?(c[(c[j>>2]|0)+36>>2]|0)!=0:0)?(c[(c[(c[h>>2]|0)+36>>2]|0)+4>>2]|0)!=(c[(c[(c[j>>2]|0)+36>>2]|0)+4>>2]|0):0)?(c[(c[(c[h>>2]|0)+36>>2]|0)+4>>2]|0)==0:0)c[(c[(c[h>>2]|0)+36>>2]|0)+4>>2]=c[(c[(c[j>>2]|0)+36>>2]|0)+4>>2];c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}while(0);if(!(c[(c[h>>2]|0)+32>>2]|0)){c[p>>2]=c[(c[(c[h>>2]|0)+36>>2]|0)+4>>2];if((rG(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0)|0)==-1){c[f>>2]=-1;r=c[f>>2]|0;i=e;return r|0}}else c[p>>2]=c[(c[(c[j>>2]|0)+36>>2]|0)+4>>2];c[m>>2]=0;c[k>>2]=c[(c[h>>2]|0)+32>>2];while(1){if(!(c[k>>2]|0))break;if(!(c[(c[k>>2]|0)+4>>2]|0)){s=35;break}c[m>>2]=c[k>>2];c[k>>2]=c[c[k>>2]>>2]}if((s|0)==35){s=c[c[k>>2]>>2]|0;if(!(c[m>>2]|0))c[(c[h>>2]|0)+32>>2]=s;else c[c[m>>2]>>2]=s;zb[c[135736>>2]&511](c[k>>2]|0)}a:do if(c[p>>2]|0){c[m>>2]=0;c[k>>2]=c[(c[h>>2]|0)+32>>2];while(1){if(!(c[k>>2]|0))break a;if((c[(c[k>>2]|0)+4>>2]|0)==(c[p>>2]|0))break;c[m>>2]=c[k>>2];c[k>>2]=c[c[k>>2]>>2]}s=c[c[k>>2]>>2]|0;if(!(c[m>>2]|0))c[(c[h>>2]|0)+32>>2]=s;else c[c[m>>2]>>2]=s;zb[c[135736>>2]&511](c[k>>2]|0)}while(0);c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}function tG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;do if(c[c[g>>2]>>2]|0){if((c[(c[g>>2]|0)+8>>2]|0)<=(c[(c[g>>2]|0)+4>>2]|0)?(d=(c[g>>2]|0)+8|0,c[d>>2]=c[d>>2]<<1,d=Hb[c[135760>>2]&511](c[c[g>>2]>>2]|0,c[(c[g>>2]|0)+8>>2]<<2)|0,c[c[g>>2]>>2]=d,(c[c[g>>2]>>2]|0)==0):0){tC(0,142376,0);c[(c[g>>2]|0)+8>>2]=0;c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}}else{d=Cb[c[135744>>2]&511](80)|0;c[c[g>>2]>>2]=d;if(c[c[g>>2]>>2]|0){c[(c[g>>2]|0)+8>>2]=20;break}tC(0,142344,0);c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}while(0);if((c[j>>2]|0)>=(c[(c[g>>2]|0)+4>>2]|0)){d=c[h>>2]|0;b=(c[g>>2]|0)+4|0;a=c[b>>2]|0;c[b>>2]=a+1;c[(c[c[g>>2]>>2]|0)+(a<<2)>>2]=d}else{c[k>>2]=c[(c[g>>2]|0)+4>>2];while(1){if((c[k>>2]|0)<=(c[j>>2]|0))break;c[(c[c[g>>2]>>2]|0)+(c[k>>2]<<2)>>2]=c[(c[c[g>>2]>>2]|0)+((c[k>>2]|0)-1<<2)>>2];c[k>>2]=(c[k>>2]|0)+-1}c[(c[c[g>>2]>>2]|0)+(c[j>>2]<<2)>>2]=c[h>>2];h=(c[g>>2]|0)+4|0;c[h>>2]=(c[h>>2]|0)+1}c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}function uG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;do if(c[f>>2]|0)if(c[(c[f>>2]|0)+48>>2]&c[g>>2]){c[e>>2]=1;break}else{c[e>>2]=0;break}else c[e>>2]=0;while(0);i=d;return c[e>>2]|0}function vG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g+24|0;j=g+20|0;k=g+16|0;l=g+12|0;m=g+8|0;n=g+4|0;o=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[n>>2]=0;c[o>>2]=0;GC(n,0,c[k>>2]|0,c[(c[k>>2]|0)+36>>2]|0)|0;f=c[h>>2]|0;h=c[(c[k>>2]|0)+36>>2]|0;k=c[j>>2]|0;j=c[n>>2]|0;e=zB(c[c[m>>2]>>2]|0)|0;EF(f,h,k,0,0,0,149488,j,e,GC(o,0,c[l>>2]|0,0)|0,0,0);if(c[n>>2]|0){zb[c[135736>>2]&511](c[n>>2]|0);c[n>>2]=0}if(!(c[o>>2]|0)){i=g;return}zb[c[135736>>2]&511](c[o>>2]|0);c[o>>2]=0;i=g;return}function wG(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=0;GC(l,0,c[j>>2]|0,c[(c[j>>2]|0)+36>>2]|0)|0;e=c[g>>2]|0;g=c[(c[j>>2]|0)+36>>2]|0;j=c[h>>2]|0;h=c[l>>2]|0;PC(e,g,j,149448,h,zB(c[c[k>>2]>>2]|0)|0);if(!(c[l>>2]|0)){i=f;return}zb[c[135736>>2]&511](c[l>>2]|0);c[l>>2]=0;i=f;return}function xG(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if((c[j>>2]|0)==(c[k>>2]|0)){c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}if(((c[c[j>>2]>>2]|0)!=1?(c[(c[j>>2]|0)+48>>2]&4194304|0)==0:0)?(KE(c[j>>2]|0,c[h>>2]|0)|0)==-1:0){c[g>>2]=-1;n=c[g>>2]|0;i=f;return n|0}if(((c[c[k>>2]>>2]|0)!=1?(c[(c[k>>2]|0)+48>>2]&4194304|0)==0:0)?(KE(c[k>>2]|0,c[h>>2]|0)|0)==-1:0){c[g>>2]=-1;n=c[g>>2]|0;i=f;return n|0}if((c[l>>2]&1|0)==0?(uG(c[(c[j>>2]|0)+64>>2]|0,1024)|0)==0:0){if((c[(c[j>>2]|0)+64>>2]|0)==(c[k>>2]|0)){c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}if(!((c[c[(c[j>>2]|0)+64>>2]>>2]|0)==1?(c[(c[(c[j>>2]|0)+64>>2]|0)+88>>2]|0)==45:0))o=18;if((o|0)==18?(xG(c[h>>2]|0,c[(c[j>>2]|0)+64>>2]|0,c[k>>2]|0,c[l>>2]|0)|0)==0:0){c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}do if((c[c[k>>2]>>2]|0)==1?(c[(c[k>>2]|0)+88>>2]|0)==46:0){if((c[(c[j>>2]|0)+48>>2]&64|0)==0?(c[(c[j>>2]|0)+48>>2]&128|0)==0:0)break;c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}while(0);a:do if(c[(c[k>>2]|0)+48>>2]&128){c[m>>2]=c[(c[k>>2]|0)+92>>2];while(1){if(!(c[m>>2]|0))break a;if(((c[c[(c[m>>2]|0)+4>>2]>>2]|0)!=1?(c[(c[(c[m>>2]|0)+4>>2]|0)+48>>2]&4194304|0)==0:0)?(KE(c[(c[m>>2]|0)+4>>2]|0,c[h>>2]|0)|0)==-1:0){o=31;break}if(!(xG(c[h>>2]|0,c[j>>2]|0,c[(c[m>>2]|0)+4>>2]|0,c[l>>2]|0)|0)){o=33;break}c[m>>2]=c[c[m>>2]>>2]}if((o|0)==31){c[g>>2]=-1;n=c[g>>2]|0;i=f;return n|0}else if((o|0)==33){c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}}while(0);c[g>>2]=3032;n=c[g>>2]|0;i=f;return n|0}c[g>>2]=3031;n=c[g>>2]|0;i=f;return n|0}function yG(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;do if(!(c[(c[e>>2]|0)+92>>2]|0)){a=eB(0)|0;c[(c[e>>2]|0)+92>>2]=a;a=c[e>>2]|0;if(c[(c[e>>2]|0)+92>>2]|0){bB(c[a+92>>2]|0,c[(c[e>>2]|0)+8>>2]|0,c[(c[e>>2]|0)+12>>2]|0,c[(c[e>>2]|0)+4>>2]|0);dB(c[(c[e>>2]|0)+92>>2]|0,c[(c[e>>2]|0)+24>>2]|0,c[(c[e>>2]|0)+4>>2]|0);break}PC(a,0,3069,148224,0,0);c[d>>2]=-1;f=c[d>>2]|0;i=b;return f|0}while(0);c[d>>2]=0;f=c[d>>2]|0;i=b;return f|0}function zG(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+32|0;j=h+24|0;k=h+20|0;l=h+16|0;m=h+12|0;n=h+8|0;o=h+4|0;p=h;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[p>>2]=0;c[p>>2]=my(142568)|0;g=c[p>>2]|0;c[p>>2]=By(g,zB(c[c[k>>2]>>2]|0)|0)|0;c[p>>2]=By(c[p>>2]|0,147720)|0;if(!(c[m>>2]|0))c[p>>2]=By(c[p>>2]|0,147736)|0;g=c[p>>2]|0;if((c[m>>2]|0)==1)c[p>>2]=By(g,147752)|0;else c[p>>2]=By(g,147768)|0;if(c[n>>2]|0)c[p>>2]=By(c[p>>2]|0,147784)|0;c[p>>2]=By(c[p>>2]|0,143656)|0;n=c[p>>2]|0;c[p>>2]=By(n,zB(c[c[l>>2]>>2]|0)|0)|0;l=c[p>>2]|0;if(c[o>>2]|0)c[p>>2]=By(l,147800)|0;else c[p>>2]=By(l,142568)|0;GE(c[j>>2]|0,1717,c[k>>2]|0,0,c[p>>2]|0,0);if(!(c[p>>2]|0)){i=h;return}zb[c[135736>>2]&511](c[p>>2]|0);i=h;return}function AG(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;ce(16,2,0,0,c[d>>2]|0);i=b;return}function BG(a,b,d,e,f,g,h,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;m=i;i=i+48|0;n=m+44|0;o=m+40|0;p=m+36|0;q=m+32|0;r=m+28|0;s=m+24|0;t=m+20|0;u=m+16|0;v=m+12|0;w=m+8|0;x=m+4|0;y=m;c[n>>2]=a;c[o>>2]=b;c[p>>2]=d;c[q>>2]=e;c[r>>2]=f;c[s>>2]=g;c[t>>2]=h;c[u>>2]=j;c[v>>2]=k;c[w>>2]=l;c[x>>2]=0;c[y>>2]=0;GC(y,0,c[q>>2]|0,0)|0;c[y>>2]=By(c[y>>2]|0,144448)|0;q=c[y>>2]|0;c[y>>2]=By(q,GC(x,0,c[r>>2]|0,0)|0)|0;if(c[x>>2]|0){zb[c[135736>>2]&511](c[x>>2]|0);c[x>>2]=0}c[y>>2]=By(c[y>>2]|0,152080)|0;c[y>>2]=By(c[y>>2]|0,c[s>>2]|0)|0;c[y>>2]=By(c[y>>2]|0,142704)|0;IC(c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[y>>2]|0,c[t>>2]|0,c[u>>2]|0,c[v>>2]|0,c[w>>2]|0);zb[c[135736>>2]&511](c[y>>2]|0);i=m;return}function CG(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[c[j>>2]>>2]=0;c[c[k>>2]>>2]=0;if(c[l>>2]|0)c[c[l>>2]>>2]=0;e=c[h>>2]|0;if(c[(c[h>>2]|0)+28>>2]|0){c[c[k>>2]>>2]=c[e+28>>2];if(c[l>>2]|0)c[c[l>>2]>>2]=c[(c[h>>2]|0)+32>>2];if(c[(c[h>>2]|0)+16>>2]&1)c[c[j>>2]>>2]=1;c[g>>2]=1;m=c[g>>2]|0;i=f;return m|0}if((c[e+12>>2]|0)!=0?(c[(c[(c[h>>2]|0)+12>>2]|0)+44>>2]|0)!=0:0){c[c[k>>2]>>2]=c[(c[(c[h>>2]|0)+12>>2]|0)+44>>2];if(c[l>>2]|0)c[c[l>>2]>>2]=c[(c[(c[h>>2]|0)+12>>2]|0)+68>>2];if(c[(c[(c[h>>2]|0)+12>>2]|0)+60>>2]&512)c[c[j>>2]>>2]=1;c[g>>2]=1;m=c[g>>2]|0;i=f;return m|0}c[g>>2]=0;m=c[g>>2]|0;i=f;return m|0}function DG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if(!(c[f>>2]|0)){c[e>>2]=-1;j=c[e>>2]|0;i=d;return j|0}if(c[(c[f>>2]|0)+28>>2]|0){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}b=c[f>>2]|0;a:do if(!(c[(c[f>>2]|0)+32>>2]|0)){if((c[b+36>>2]|0)!=0&(c[g>>2]|0)!=0?(qy(c[(c[(c[f>>2]|0)+36>>2]|0)+4>>2]|0,c[g>>2]|0)|0)==0:0){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}}else{c[h>>2]=c[b+32>>2];while(1){if(!(c[h>>2]|0))break a;if(qy(c[(c[h>>2]|0)+4>>2]|0,c[g>>2]|0)|0)break;c[h>>2]=c[c[h>>2]>>2]}c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}while(0);c[e>>2]=1;j=c[e>>2]|0;i=d;return j|0}function EG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[f>>2]=a;c[g>>2]=b;if(c[(c[g>>2]|0)+28>>2]|0){c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}if(((c[(c[f>>2]|0)+36>>2]|0)!=0?(c[(c[g>>2]|0)+36>>2]|0)!=0:0)?(c[(c[(c[f>>2]|0)+36>>2]|0)+4>>2]|0)==(c[(c[(c[g>>2]|0)+36>>2]|0)+4>>2]|0):0){
c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}do if(c[(c[f>>2]|0)+32>>2]|0){if(!(c[(c[g>>2]|0)+32>>2]|0)){if(!(c[(c[g>>2]|0)+36>>2]|0))break;c[l>>2]=c[(c[f>>2]|0)+32>>2];while(1){if(!(c[l>>2]|0)){n=27;break}if((c[(c[l>>2]|0)+4>>2]|0)==(c[(c[(c[g>>2]|0)+36>>2]|0)+4>>2]|0)){n=25;break}c[l>>2]=c[c[l>>2]>>2]}if((n|0)==25){c[e>>2]=1;m=c[e>>2]|0;i=d;return m|0}else if((n|0)==27){c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}}c[k>>2]=0;c[h>>2]=c[(c[f>>2]|0)+32>>2];while(1){if(!(c[h>>2]|0))break;c[k>>2]=0;c[j>>2]=c[(c[g>>2]|0)+32>>2];while(1){if(!(c[j>>2]|0))break;if((c[(c[h>>2]|0)+4>>2]|0)==(c[(c[j>>2]|0)+4>>2]|0)){n=14;break}c[j>>2]=c[c[j>>2]>>2]}if((n|0)==14){n=0;c[k>>2]=1}if(!(c[k>>2]|0)){n=17;break}c[h>>2]=c[c[h>>2]>>2]}if((n|0)==17){c[e>>2]=1;m=c[e>>2]|0;i=d;return m|0}if(c[k>>2]|0){c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}}while(0);c[e>>2]=1;m=c[e>>2]|0;i=d;return m|0}function FG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;if(((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+16>>2]|0)!=0:0)?(c[(c[e>>2]|0)+12>>2]|0)!=0:0){if(!(((c[c[(c[e>>2]|0)+12>>2]>>2]|0)!=6?(c[c[(c[e>>2]|0)+12>>2]>>2]|0)!=7:0)?(c[c[(c[e>>2]|0)+12>>2]>>2]|0)!=8:0))f=8;if((f|0)==8?(vH(c[e>>2]|0)|0)==0:0){c[d>>2]=1;g=c[d>>2]|0;i=b;return g|0}c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}c[d>>2]=1;g=c[d>>2]|0;i=b;return g|0}function GG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+32|0;h=g+24|0;j=g+20|0;k=g+16|0;l=g+12|0;m=g+8|0;n=g+4|0;o=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=Cb[c[135744>>2]&511](28)|0;if(!(c[o>>2]|0)){tC(c[j>>2]|0,153320,0);c[h>>2]=0;p=c[h>>2]|0;i=g;return p|0}f=c[o>>2]|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=0;c[(c[o>>2]|0)+4>>2]=c[l>>2];c[(c[o>>2]|0)+24>>2]=c[k>>2];c[(c[o>>2]|0)+16>>2]=c[m>>2];c[(c[o>>2]|0)+20>>2]=c[n>>2];n=c[o>>2]|0;m=c[(c[j>>2]|0)+28>>2]|0;if(!(c[(c[(c[j>>2]|0)+28>>2]|0)+28>>2]|0))c[m+28>>2]=n;else c[c[m+32>>2]>>2]=n;c[(c[(c[j>>2]|0)+28>>2]|0)+32>>2]=c[o>>2];c[h>>2]=c[o>>2];p=c[h>>2]|0;i=g;return p|0}function HG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+48|0;f=e+44|0;g=e+40|0;h=e+36|0;j=e+32|0;k=e+28|0;l=e+24|0;m=e+20|0;n=e+16|0;o=e+12|0;p=e+8|0;q=e+4|0;r=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;do if(((c[(c[h>>2]|0)+28>>2]|0)==(c[(c[j>>2]|0)+28>>2]|0)?((c[(c[h>>2]|0)+32>>2]|0)==0|0)==((c[(c[j>>2]|0)+32>>2]|0)==0|0):0)?((c[(c[h>>2]|0)+36>>2]|0)==0|0)==((c[(c[j>>2]|0)+36>>2]|0)==0|0):0){if((c[(c[h>>2]|0)+36>>2]|0)!=0?(c[(c[(c[h>>2]|0)+36>>2]|0)+4>>2]|0)!=(c[(c[(c[j>>2]|0)+36>>2]|0)+4>>2]|0):0)break;if(!(c[(c[h>>2]|0)+32>>2]|0)){c[f>>2]=0;s=c[f>>2]|0;i=e;return s|0}c[n>>2]=0;c[k>>2]=c[(c[h>>2]|0)+32>>2];while(1){if(!(c[k>>2]|0))break;c[n>>2]=0;c[l>>2]=c[(c[j>>2]|0)+32>>2];while(1){if(!(c[l>>2]|0))break;if((c[(c[k>>2]|0)+4>>2]|0)==(c[(c[l>>2]|0)+4>>2]|0)){t=12;break}c[l>>2]=c[c[l>>2]>>2]}if((t|0)==12){t=0;c[n>>2]=1}if(!(c[n>>2]|0))break;c[k>>2]=c[c[k>>2]>>2]}if(c[n>>2]|0){c[f>>2]=0;s=c[f>>2]|0;i=e;return s|0}}while(0);n=c[h>>2]|0;if((c[(c[h>>2]|0)+28>>2]|0)!=(c[(c[j>>2]|0)+28>>2]|0)){if(!(c[n+28>>2]|0)){c[(c[h>>2]|0)+28>>2]=1;if(c[(c[h>>2]|0)+32>>2]|0){nB(c[(c[h>>2]|0)+32>>2]|0);c[(c[h>>2]|0)+32>>2]=0}if(c[(c[h>>2]|0)+36>>2]|0){zb[c[135736>>2]&511](c[(c[h>>2]|0)+36>>2]|0);c[(c[h>>2]|0)+36>>2]=0}}c[f>>2]=0;s=c[f>>2]|0;i=e;return s|0}if((c[n+32>>2]|0)!=0?(c[(c[j>>2]|0)+32>>2]|0)!=0:0){c[k>>2]=c[(c[j>>2]|0)+32>>2];c[p>>2]=c[(c[h>>2]|0)+32>>2];while(1){if(!(c[k>>2]|0)){t=40;break}c[o>>2]=0;c[l>>2]=c[p>>2];while(1){if(!(c[l>>2]|0))break;if((c[(c[k>>2]|0)+4>>2]|0)==(c[(c[l>>2]|0)+4>>2]|0)){t=33;break}c[l>>2]=c[c[l>>2]>>2]}if((t|0)==33){t=0;c[o>>2]=1}if(!(c[o>>2]|0)){c[m>>2]=uH(c[g>>2]|0)|0;if(!(c[m>>2]|0)){t=37;break}c[(c[m>>2]|0)+4>>2]=c[(c[k>>2]|0)+4>>2];c[c[m>>2]>>2]=c[(c[h>>2]|0)+32>>2];c[(c[h>>2]|0)+32>>2]=c[m>>2]}c[k>>2]=c[c[k>>2]>>2]}if((t|0)==37){c[f>>2]=-1;s=c[f>>2]|0;i=e;return s|0}else if((t|0)==40){c[f>>2]=0;s=c[f>>2]|0;i=e;return s|0}}if(((c[(c[h>>2]|0)+36>>2]|0)!=0?(c[(c[j>>2]|0)+36>>2]|0)!=0:0)?(c[(c[(c[h>>2]|0)+36>>2]|0)+4>>2]|0)!=(c[(c[(c[j>>2]|0)+36>>2]|0)+4>>2]|0):0){c[(c[(c[h>>2]|0)+36>>2]|0)+4>>2]=0;c[f>>2]=0;s=c[f>>2]|0;i=e;return s|0}if(!(((c[(c[h>>2]|0)+36>>2]|0)!=0?(c[(c[(c[h>>2]|0)+36>>2]|0)+4>>2]|0)!=0:0)?(c[(c[j>>2]|0)+32>>2]|0)!=0:0))t=48;do if((t|0)==48){if(((c[(c[j>>2]|0)+36>>2]|0)!=0?(c[(c[(c[j>>2]|0)+36>>2]|0)+4>>2]|0)!=0:0)?(c[(c[h>>2]|0)+32>>2]|0)!=0:0)break;if(!(((c[(c[h>>2]|0)+36>>2]|0)!=0?(c[(c[(c[h>>2]|0)+36>>2]|0)+4>>2]|0)==0:0)?(c[(c[j>>2]|0)+32>>2]|0)!=0:0))t=87;do if((t|0)==87){if(((c[(c[j>>2]|0)+36>>2]|0)!=0?(c[(c[(c[j>>2]|0)+36>>2]|0)+4>>2]|0)==0:0)?(c[(c[h>>2]|0)+32>>2]|0)!=0:0)break;c[f>>2]=0;s=c[f>>2]|0;i=e;return s|0}while(0);if(c[(c[h>>2]|0)+32>>2]|0)c[k>>2]=c[(c[h>>2]|0)+32>>2];else c[k>>2]=c[(c[j>>2]|0)+32>>2];while(1){if(!(c[k>>2]|0))break;if(!(c[(c[k>>2]|0)+4>>2]|0)){t=95;break}c[k>>2]=c[c[k>>2]>>2]}if((t|0)==95){c[(c[h>>2]|0)+28>>2]=1;if(c[(c[h>>2]|0)+32>>2]|0){nB(c[(c[h>>2]|0)+32>>2]|0);c[(c[h>>2]|0)+32>>2]=0}if(c[(c[h>>2]|0)+36>>2]|0){zb[c[135736>>2]&511](c[(c[h>>2]|0)+36>>2]|0);c[(c[h>>2]|0)+36>>2]=0}c[f>>2]=0;s=c[f>>2]|0;i=e;return s|0}do if(!(c[(c[h>>2]|0)+36>>2]|0)){if(c[(c[h>>2]|0)+32>>2]|0){nB(c[(c[h>>2]|0)+32>>2]|0);c[(c[h>>2]|0)+32>>2]=0}m=uH(c[g>>2]|0)|0;c[(c[h>>2]|0)+36>>2]=m;if(c[(c[h>>2]|0)+36>>2]|0){c[(c[(c[h>>2]|0)+36>>2]|0)+4>>2]=0;break}c[f>>2]=-1;s=c[f>>2]|0;i=e;return s|0}while(0);c[f>>2]=0;s=c[f>>2]|0;i=e;return s|0}while(0);c[r>>2]=0;if(c[(c[h>>2]|0)+32>>2]|0){c[k>>2]=c[(c[h>>2]|0)+32>>2];c[l>>2]=c[(c[j>>2]|0)+36>>2]}else{c[k>>2]=c[(c[j>>2]|0)+32>>2];c[l>>2]=c[(c[h>>2]|0)+36>>2]}c[q>>2]=0;while(1){if(!(c[k>>2]|0))break;if(c[(c[k>>2]|0)+4>>2]|0){if((c[(c[k>>2]|0)+4>>2]|0)==(c[(c[l>>2]|0)+4>>2]|0))c[q>>2]=1}else c[r>>2]=1;if((c[q>>2]|0)!=0&(c[r>>2]|0)!=0)break;c[k>>2]=c[c[k>>2]>>2]}do if((c[q>>2]|0)!=0&(c[r>>2]|0)!=0){c[(c[h>>2]|0)+28>>2]=1;if(c[(c[h>>2]|0)+32>>2]|0){nB(c[(c[h>>2]|0)+32>>2]|0);c[(c[h>>2]|0)+32>>2]=0}if(c[(c[h>>2]|0)+36>>2]|0){zb[c[135736>>2]&511](c[(c[h>>2]|0)+36>>2]|0);c[(c[h>>2]|0)+36>>2]=0}}else{if(!((c[q>>2]|0)==0|(c[r>>2]|0)!=0)){if(c[(c[h>>2]|0)+32>>2]|0){nB(c[(c[h>>2]|0)+32>>2]|0);c[(c[h>>2]|0)+32>>2]=0}if((c[(c[h>>2]|0)+36>>2]|0)==0?(k=uH(c[g>>2]|0)|0,c[(c[h>>2]|0)+36>>2]=k,(c[(c[h>>2]|0)+36>>2]|0)==0):0){c[f>>2]=-1;s=c[f>>2]|0;i=e;return s|0}c[(c[(c[h>>2]|0)+36>>2]|0)+4>>2]=0;break}if((c[q>>2]|0)==0&(c[r>>2]|0)!=0){PC(c[g>>2]|0,c[(c[h>>2]|0)+12>>2]|0,1794,152712,0,0);c[f>>2]=1794;s=c[f>>2]|0;i=e;return s|0}if(!((c[q>>2]|0)!=0|(c[r>>2]|0)!=0)?(c[(c[h>>2]|0)+36>>2]|0)==0:0){if(c[(c[h>>2]|0)+32>>2]|0){nB(c[(c[h>>2]|0)+32>>2]|0);c[(c[h>>2]|0)+32>>2]=0}k=uH(c[g>>2]|0)|0;c[(c[h>>2]|0)+36>>2]=k;if(c[(c[h>>2]|0)+36>>2]|0){c[(c[(c[h>>2]|0)+36>>2]|0)+4>>2]=c[(c[(c[j>>2]|0)+36>>2]|0)+4>>2];break}c[f>>2]=-1;s=c[f>>2]|0;i=e;return s|0}}while(0);c[f>>2]=0;s=c[f>>2]|0;i=e;return s|0}function IG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+48|0;e=d+40|0;f=d+36|0;g=d+32|0;h=d+28|0;j=d+24|0;k=d+20|0;l=d+16|0;m=d+12|0;n=d+8|0;o=d+4|0;p=d;c[f>>2]=a;c[g>>2]=b;do if(c[(c[g>>2]|0)+64>>2]|0){if((c[c[(c[g>>2]|0)+64>>2]>>2]|0)!=4){if((c[c[(c[g>>2]|0)+64>>2]>>2]|0)!=1)break;if((c[(c[(c[g>>2]|0)+64>>2]|0)+88>>2]|0)==45)break}if(!(c[(c[g>>2]|0)+48>>2]&2)){AB(c[f>>2]|0,3076,0,c[g>>2]|0,152344,0,0);c[e>>2]=3076;q=c[e>>2]|0;i=d;return q|0}}while(0);a:do if((c[(c[g>>2]|0)+116>>2]|0)!=0?(c[(c[(c[g>>2]|0)+116>>2]|0)+4>>2]|0)>1:0){c[h>>2]=c[(c[g>>2]|0)+116>>2];c[n>>2]=0;c[l>>2]=(c[(c[h>>2]|0)+4>>2]|0)-1;b:while(1){if((c[l>>2]|0)<0)break a;c[j>>2]=c[(c[c[h>>2]>>2]|0)+(c[l>>2]<<2)>>2];c:do if((c[l>>2]|0)>0){c[m>>2]=(c[l>>2]|0)-1;while(1){if((c[m>>2]|0)<0){r=20;break c}c[k>>2]=c[(c[c[h>>2]>>2]|0)+(c[m>>2]<<2)>>2];if((c[(c[(c[j>>2]|0)+12>>2]|0)+8>>2]|0)==(c[(c[(c[k>>2]|0)+12>>2]|0)+8>>2]|0)?(c[(c[(c[j>>2]|0)+12>>2]|0)+56>>2]|0)==(c[(c[(c[k>>2]|0)+12>>2]|0)+56>>2]|0):0)break;c[m>>2]=(c[m>>2]|0)+-1}c[o>>2]=0;b=c[f>>2]|0;a=c[g>>2]|0;AB(b,3087,0,a,152424,ZD(o,c[j>>2]|0)|0,0);if(c[o>>2]|0){zb[c[135736>>2]&511](c[o>>2]|0);c[o>>2]=0}if((TE(c[h>>2]|0,c[l>>2]|0)|0)==-1)break b}else r=20;while(0);if(((r|0)==20?(r=0,(c[(c[(c[j>>2]|0)+12>>2]|0)+48>>2]|0)!=0):0)?(SE(c[(c[(c[j>>2]|0)+12>>2]|0)+48>>2]|0,23)|0)!=0:0){if(c[n>>2]|0){c[p>>2]=0;a=c[f>>2]|0;b=c[g>>2]|0;AB(a,3087,0,b,152440,ZD(p,c[j>>2]|0)|0,0);if(c[p>>2]|0){zb[c[135736>>2]&511](c[p>>2]|0);c[p>>2]=0}if((TE(c[h>>2]|0,c[l>>2]|0)|0)==-1)break}c[n>>2]=1}c[l>>2]=(c[l>>2]|0)+-1}c[e>>2]=-1;q=c[e>>2]|0;i=d;return q|0}while(0);c[e>>2]=0;q=c[e>>2]|0;i=d;return q|0}function JG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=c[(c[g>>2]|0)+64>>2];if((c[c[h>>2]>>2]|0)!=5?(c[(c[h>>2]|0)+88>>2]|0)!=45:0){if((c[(c[g>>2]|0)+104>>2]|0)!=(c[h>>2]|0)){GE(c[f>>2]|0,3063,c[g>>2]|0,0,152296,0);c[e>>2]=3063;j=c[e>>2]|0;i=d;return j|0}if(c[(c[h>>2]|0)+48>>2]&512){GE(c[f>>2]|0,3063,c[g>>2]|0,0,152088,0);c[e>>2]=3063;j=c[e>>2]|0;i=d;return j|0}}else k=3;do if((k|0)==3){if(c[(c[h>>2]|0)+48>>2]&512){GE(c[f>>2]|0,3063,c[g>>2]|0,0,152088,0);c[e>>2]=3063;j=c[e>>2]|0;i=d;return j|0}if((c[(c[g>>2]|0)+104>>2]|0)!=0?(c[(c[g>>2]|0)+104>>2]|0)==(c[(c[h>>2]|0)+104>>2]|0):0)break;if((c[(c[g>>2]|0)+52>>2]|0)==1?(c[(c[h>>2]|0)+52>>2]|0)==1:0)break;if(!(c[(c[g>>2]|0)+28>>2]|0)){GE(c[f>>2]|0,3063,c[g>>2]|0,0,152152,0);c[e>>2]=3063;j=c[e>>2]|0;i=d;return j|0}if((c[(c[h>>2]|0)+52>>2]|0)!=1){if((c[(c[g>>2]|0)+52>>2]|0)==(c[(c[h>>2]|0)+52>>2]|0)){if((c[(c[g>>2]|0)+52>>2]|0)==3)break;if((c[(c[g>>2]|0)+52>>2]|0)==2)break}GE(c[f>>2]|0,3063,c[g>>2]|0,0,152200,0);c[e>>2]=3063;j=c[e>>2]|0;i=d;return j|0}}while(0);c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}function KG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=c[(c[g>>2]|0)+64>>2];if((c[c[h>>2]>>2]|0)!=5?(c[(c[h>>2]|0)+88>>2]|0)!=45:0){AB(c[f>>2]|0,1787,c[(c[g>>2]|0)+36>>2]|0,c[g>>2]|0,150744,0,0);c[e>>2]=c[(c[f>>2]|0)+16>>2];m=c[e>>2]|0;i=d;return m|0}b=c[f>>2]|0;if(c[(c[h>>2]|0)+48>>2]&1024){AB(b,1787,c[(c[g>>2]|0)+36>>2]|0,c[g>>2]|0,150784,0,0);c[e>>2]=c[(c[f>>2]|0)+16>>2];m=c[e>>2]|0;i=d;return m|0}if((UE(b,0,c[g>>2]|0,c[h>>2]|0,c[(c[g>>2]|0)+116>>2]|0,c[(c[h>>2]|0)+116>>2]|0,c[(c[g>>2]|0)+84>>2]|0,c[(c[h>>2]|0)+84>>2]|0)|0)==-1){c[e>>2]=-1;m=c[e>>2]|0;i=d;return m|0}do if((c[(c[h>>2]|0)+88>>2]|0)!=45){if((c[(c[g>>2]|0)+52>>2]|0)!=4?(c[(c[g>>2]|0)+52>>2]|0)!=6:0){if((c[(c[g>>2]|0)+52>>2]|0)==1){if((c[(c[h>>2]|0)+52>>2]|0)==1)break;if(!((c[(c[h>>2]|0)+52>>2]|0)!=2?(c[(c[h>>2]|0)+52>>2]|0)!=3:0))n=28;if((n|0)==28?(FG(c[(c[h>>2]|0)+28>>2]|0)|0)!=0:0)break;GE(c[f>>2]|0,1787,c[g>>2]|0,0,151040,0);c[e>>2]=c[(c[f>>2]|0)+16>>2];m=c[e>>2]|0;i=d;return m|0}if((c[(c[g>>2]|0)+52>>2]|0)!=2?(c[(c[g>>2]|0)+52>>2]|0)!=3:0){GE(c[f>>2]|0,1787,c[g>>2]|0,0,151256,0);c[e>>2]=c[(c[f>>2]|0)+16>>2];m=c[e>>2]|0;i=d;return m|0}if((c[(c[g>>2]|0)+52>>2]|0)!=3)break;if((c[(c[h>>2]|0)+52>>2]|0)==3)break;GE(c[f>>2]|0,1787,c[g>>2]|0,0,151160,0);c[e>>2]=c[(c[f>>2]|0)+16>>2];m=c[e>>2]|0;i=d;return m|0}if((c[(c[h>>2]|0)+52>>2]|0)!=4?(c[(c[h>>2]|0)+52>>2]|0)!=6:0){if((c[(c[h>>2]|0)+52>>2]|0)==3?(FG(c[(c[h>>2]|0)+28>>2]|0)|0)!=0:0)break;GE(c[f>>2]|0,1787,c[g>>2]|0,0,150936,0);c[e>>2]=c[(c[f>>2]|0)+16>>2];m=c[e>>2]|0;i=d;return m|0}c[j>>2]=xG(c[f>>2]|0,c[(c[g>>2]|0)+104>>2]|0,c[(c[h>>2]|0)+104>>2]|0,0)|0;if(c[j>>2]|0){c[k>>2]=0;c[l>>2]=0;if((c[j>>2]|0)==-1){c[e>>2]=-1;m=c[e>>2]|0;i=d;return m|0}b=c[f>>2]|0;a=c[g>>2]|0;o=ZD(k,c[(c[g>>2]|0)+104>>2]|0)|0;AB(b,1787,0,a,150848,o,ZD(l,c[(c[h>>2]|0)+104>>2]|0)|0);if(c[k>>2]|0){zb[c[135736>>2]&511](c[k>>2]|0);c[k>>2]=0}if(c[l>>2]|0){zb[c[135736>>2]&511](c[l>>2]|0);c[l>>2]=0}c[e>>2]=c[(c[f>>2]|0)+16>>2];m=c[e>>2]|0;i=d;return m|0}}while(0);c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}function LG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if(!(c[(c[g>>2]|0)+80>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}b=c[g>>2]|0;if((c[(c[g>>2]|0)+80>>2]|0)==(c[f>>2]|0)){c[e>>2]=b;j=c[e>>2]|0;i=d;return j|0}if(c[(c[b+80>>2]|0)+48>>2]&512){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}else{b=(c[(c[g>>2]|0)+80>>2]|0)+48|0;c[b>>2]=c[b>>2]|512;c[h>>2]=LG(c[f>>2]|0,c[(c[g>>2]|0)+80>>2]|0)|0;f=(c[(c[g>>2]|0)+80>>2]|0)+48|0;c[f>>2]=c[f>>2]^512;c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}return 0}function MG(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;do if((c[c[j>>2]>>2]|0)!=4){if((c[c[j>>2]>>2]|0)==1?(c[(c[j>>2]|0)+88>>2]|0)!=45:0)break;c[g>>2]=wH(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0)|0;m=c[g>>2]|0;i=f;return m|0}while(0);c[g>>2]=xG(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0)|0;m=c[g>>2]|0;i=f;return m|0}function NG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+32|0;h=g+24|0;j=g+20|0;k=g+16|0;l=g+12|0;m=g+8|0;n=g+4|0;o=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=0;if(!((c[c[l>>2]>>2]|0)!=5?(c[(c[l>>2]|0)+88>>2]|0)!=45:0))p=3;do if(((p|0)==3?(c[(c[l>>2]|0)+52>>2]|0)!=4:0)?(c[(c[l>>2]|0)+52>>2]|0)!=6:0){if((c[(c[l>>2]|0)+52>>2]|0)==3?(FG(c[(c[l>>2]|0)+28>>2]|0)|0)!=0:0)break;GE(c[j>>2]|0,3059,c[l>>2]|0,c[(c[l>>2]|0)+36>>2]|0,159240,0);c[h>>2]=3059;q=c[h>>2]|0;i=g;return q|0}while(0);do if((c[c[l>>2]>>2]|0)==4)p=11;else{if((c[c[l>>2]>>2]|0)==1?(c[(c[l>>2]|0)+88>>2]|0)!=45:0){p=11;break}if((c[(c[l>>2]|0)+52>>2]|0)!=4?(c[(c[l>>2]|0)+52>>2]|0)!=6:0){c[h>>2]=c[o>>2];q=c[h>>2]|0;i=g;return q|0}c[o>>2]=yB(c[j>>2]|0,c[k>>2]|0,c[(c[l>>2]|0)+104>>2]|0,c[m>>2]|0,c[n>>2]|0,1,1,0)|0}while(0);if((p|0)==11)c[o>>2]=yB(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,1,1,0)|0;if((c[o>>2]|0)<0)xB(c[j>>2]|0,159384,141832);c[h>>2]=c[o>>2];q=c[h>>2]|0;i=g;return q|0}function OG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=0;if((c[g>>2]|0)==0|(c[h>>2]|0)==0|(c[j>>2]|0)==0){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}c[k>>2]=xH(c[g>>2]|0,c[h>>2]|0)|0;if(!(c[k>>2]|0))c[k>>2]=yH(c[g>>2]|0,c[h>>2]|0)|0;if(!(c[k>>2]|0)){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}if((bE(c[(c[k>>2]|0)+4>>2]|0,c[j>>2]|0)|0)==-1){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}else{c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}return 0}function PG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+48|0;e=d+32|0;f=d+28|0;g=d+24|0;h=d+20|0;j=d+16|0;k=d+12|0;l=d+8|0;m=d+4|0;n=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;if(!(c[(c[(c[g>>2]|0)+12>>2]|0)+48>>2]&131072)){c[j>>2]=c[(c[g>>2]|0)+12>>2];if(c[(c[j>>2]|0)+48>>2]&16){c[e>>2]=0;o=c[e>>2]|0;i=d;return o|0}do if((c[(c[g>>2]|0)+20>>2]|0)==1){c[k>>2]=c[(c[f>>2]|0)+76>>2];b=Ez(c[(c[f>>2]|0)+64>>2]|0,c[k>>2]|0,0,c[(c[j>>2]|0)+8>>2]|0,c[(c[j>>2]|0)+52>>2]|0,c[j>>2]|0)|0;c[(c[f>>2]|0)+76>>2]=b}else{if((c[(c[g>>2]|0)+20>>2]|0)>=1073741824?(c[(c[g>>2]|0)+16>>2]|0)<2:0){c[k>>2]=c[(c[f>>2]|0)+76>>2];b=Ez(c[(c[f>>2]|0)+64>>2]|0,c[k>>2]|0,0,c[(c[j>>2]|0)+8>>2]|0,c[(c[j>>2]|0)+52>>2]|0,c[j>>2]|0)|0;c[(c[f>>2]|0)+76>>2]=b;b=Ez(c[(c[f>>2]|0)+64>>2]|0,c[(c[f>>2]|0)+76>>2]|0,c[(c[f>>2]|0)+76>>2]|0,c[(c[j>>2]|0)+8>>2]|0,c[(c[j>>2]|0)+52>>2]|0,c[j>>2]|0)|0;c[(c[f>>2]|0)+76>>2]=b;break}if((c[(c[g>>2]|0)+20>>2]|0)==1073741824)p=1073741824;else p=(c[(c[g>>2]|0)+20>>2]|0)-1|0;c[m>>2]=p;if((c[(c[g>>2]|0)+16>>2]|0)<1)q=0;else q=(c[(c[g>>2]|0)+16>>2]|0)-1|0;c[n>>2]=q;c[k>>2]=Jz(c[(c[f>>2]|0)+64>>2]|0,c[(c[f>>2]|0)+76>>2]|0,0)|0;c[l>>2]=Lz(c[(c[f>>2]|0)+64>>2]|0,c[n>>2]|0,c[m>>2]|0)|0;b=Ez(c[(c[f>>2]|0)+64>>2]|0,c[k>>2]|0,0,c[(c[j>>2]|0)+8>>2]|0,c[(c[j>>2]|0)+52>>2]|0,c[j>>2]|0)|0;c[(c[f>>2]|0)+76>>2]=b;Mz(c[(c[f>>2]|0)+64>>2]|0,c[(c[f>>2]|0)+76>>2]|0,c[k>>2]|0,c[l>>2]|0)|0;b=Nz(c[(c[f>>2]|0)+64>>2]|0,c[(c[f>>2]|0)+76>>2]|0,0,c[l>>2]|0)|0;c[(c[f>>2]|0)+76>>2]=b}while(0);if(!(c[(c[g>>2]|0)+16>>2]|0)){Jz(c[(c[f>>2]|0)+64>>2]|0,c[k>>2]|0,c[(c[f>>2]|0)+76>>2]|0)|0;c[h>>2]=1}}else c[h>>2]=QG(c[f>>2]|0,c[g>>2]|0,-1,0)|0;c[e>>2]=c[h>>2];o=c[e>>2]|0;i=d;return o|0}function QG(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+64|0;g=f+56|0;h=f+52|0;j=f+48|0;k=f+44|0;l=f+40|0;m=f+36|0;n=f+32|0;o=f+28|0;p=f+24|0;q=f+20|0;r=f+16|0;s=f+12|0;t=f+8|0;u=f+4|0;v=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[s>>2]=0;c[o>>2]=c[(c[j>>2]|0)+12>>2];c[m>>2]=c[(c[h>>2]|0)+76>>2];if(!(c[l>>2]|0))c[l>>2]=Iz(c[(c[h>>2]|0)+64>>2]|0)|0;c[q>>2]=xH(c[h>>2]|0,c[o>>2]|0)|0;if(!(c[q>>2]|0)){e=c[h>>2]|0;d=FC(c[j>>2]|0)|0;PC(e,d,3069,158280,c[(c[o>>2]|0)+8>>2]|0,0);c[g>>2]=0;w=c[g>>2]|0;i=f;return w|0}a:do if((c[k>>2]|0)>=0){c[n>>2]=Mz(c[(c[h>>2]|0)+64>>2]|0,c[m>>2]|0,0,c[k>>2]|0)|0;Ez(c[(c[h>>2]|0)+64>>2]|0,c[n>>2]|0,c[l>>2]|0,c[(c[o>>2]|0)+8>>2]|0,c[(c[o>>2]|0)+52>>2]|0,c[o>>2]|0)|0;c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[(c[(c[q>>2]|0)+4>>2]|0)+4>>2]|0))break a;c[p>>2]=c[(c[c[(c[q>>2]|0)+4>>2]>>2]|0)+(c[r>>2]<<2)>>2];Ez(c[(c[h>>2]|0)+64>>2]|0,c[n>>2]|0,c[l>>2]|0,c[(c[p>>2]|0)+8>>2]|0,c[(c[p>>2]|0)+52>>2]|0,c[p>>2]|0)|0;c[r>>2]=(c[r>>2]|0)+1}}else{if((c[(c[j>>2]|0)+20>>2]|0)==1){d=c[(c[h>>2]|0)+64>>2]|0;e=Ez(c[(c[h>>2]|0)+64>>2]|0,c[m>>2]|0,0,c[(c[o>>2]|0)+8>>2]|0,c[(c[o>>2]|0)+52>>2]|0,c[o>>2]|0)|0;Jz(d,e,c[l>>2]|0)|0;c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[(c[(c[q>>2]|0)+4>>2]|0)+4>>2]|0))break a;c[p>>2]=c[(c[c[(c[q>>2]|0)+4>>2]>>2]|0)+(c[r>>2]<<2)>>2];c[n>>2]=Ez(c[(c[h>>2]|0)+64>>2]|0,c[m>>2]|0,0,c[(c[p>>2]|0)+8>>2]|0,c[(c[p>>2]|0)+52>>2]|0,c[p>>2]|0)|0;Jz(c[(c[h>>2]|0)+64>>2]|0,c[n>>2]|0,c[l>>2]|0)|0;c[r>>2]=(c[r>>2]|0)+1}}if((c[(c[j>>2]|0)+20>>2]|0)==1073741824)x=1073741824;else x=(c[(c[j>>2]|0)+20>>2]|0)-1|0;c[u>>2]=x;if((c[(c[j>>2]|0)+16>>2]|0)<1)y=0;else y=(c[(c[j>>2]|0)+16>>2]|0)-1|0;c[v>>2]=y;c[k>>2]=Lz(c[(c[h>>2]|0)+64>>2]|0,c[v>>2]|0,c[u>>2]|0)|0;c[t>>2]=Iz(c[(c[h>>2]|0)+64>>2]|0)|0;e=c[(c[h>>2]|0)+64>>2]|0;d=Ez(c[(c[h>>2]|0)+64>>2]|0,c[m>>2]|0,0,c[(c[o>>2]|0)+8>>2]|0,c[(c[o>>2]|0)+52>>2]|0,c[o>>2]|0)|0;Jz(e,d,c[t>>2]|0)|0;c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[(c[(c[q>>2]|0)+4>>2]|0)+4>>2]|0))break;c[p>>2]=c[(c[c[(c[q>>2]|0)+4>>2]>>2]|0)+(c[r>>2]<<2)>>2];d=c[(c[h>>2]|0)+64>>2]|0;e=Ez(c[(c[h>>2]|0)+64>>2]|0,c[m>>2]|0,0,c[(c[p>>2]|0)+8>>2]|0,c[(c[p>>2]|0)+52>>2]|0,c[p>>2]|0)|0;Jz(d,e,c[t>>2]|0)|0;c[r>>2]=(c[r>>2]|0)+1}Mz(c[(c[h>>2]|0)+64>>2]|0,c[t>>2]|0,c[m>>2]|0,c[k>>2]|0)|0;Nz(c[(c[h>>2]|0)+64>>2]|0,c[t>>2]|0,c[l>>2]|0,c[k>>2]|0)|0}while(0);if(!(c[(c[j>>2]|0)+16>>2]|0)){Jz(c[(c[h>>2]|0)+64>>2]|0,c[m>>2]|0,c[l>>2]|0)|0;c[s>>2]=1}c[(c[h>>2]|0)+76>>2]=c[l>>2];c[g>>2]=c[s>>2];w=c[g>>2]|0;i=f;return w|0}function RG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[f>>2]=a;c[g>>2]=b;if(!(c[(c[f>>2]|0)+168>>2]|0)){c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[(c[f>>2]|0)+168>>2]|0)){l=8;break}c[j>>2]=c[(c[(c[f>>2]|0)+164>>2]|0)+(c[h>>2]<<2)>>2];if((c[(c[j>>2]|0)+48>>2]|0)==(c[g>>2]|0)){l=6;break}c[h>>2]=(c[h>>2]|0)+1}if((l|0)==6){c[e>>2]=c[j>>2];k=c[e>>2]|0;i=d;return k|0}else if((l|0)==8){c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}return 0}function SG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+48|0;h=g+32|0;j=g+28|0;k=g+24|0;l=g+20|0;m=g+16|0;n=g+12|0;o=g+8|0;p=g+4|0;q=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=0;c[q>>2]=0;if((c[j>>2]|0)==0|(c[k>>2]|0)==0){c[h>>2]=-1;r=c[h>>2]|0;i=g;return r|0}f=c[j>>2]|0;if(!(c[(c[j>>2]|0)+88>>2]|0)){xB(f,155272,155304);c[h>>2]=-1;r=c[h>>2]|0;i=g;return r|0}c[p>>2]=c[f+88>>2];f=c[p>>2]|0;if(!(c[(c[p>>2]|0)+28>>2]|0)){xB(f,155272,155336);c[h>>2]=-1;r=c[h>>2]|0;i=g;return r|0}c[n>>2]=JF(c[f+80>>2]|0,c[n>>2]|0,c[l>>2]|0)|0;c[o>>2]=FB(c[p>>2]|0,1,c[n>>2]|0,0,0,0,c[l>>2]|0,0,c[m>>2]|0,q)|0;if(c[o>>2]|0){c[h>>2]=c[o>>2];r=c[h>>2]|0;i=g;return r|0}if(!(c[q>>2]|0)){NC(c[j>>2]|0,1879,c[l>>2]|0,0,155352,c[n>>2]|0,0,0);c[h>>2]=c[o>>2];r=c[h>>2]|0;i=g;return r|0}if((c[q>>2]|0)!=0?(c[(c[(c[p>>2]|0)+28>>2]|0)+16>>2]|0)==0:0)c[(c[(c[p>>2]|0)+28>>2]|0)+16>>2]=c[q>>2];if(((c[q>>2]|0)!=0?(c[(c[q>>2]|0)+20>>2]|0)!=0:0)?(c[(c[q>>2]|0)+32>>2]|0)==0:0){c[(c[p>>2]|0)+20>>2]=0;c[(c[p>>2]|0)+16>>2]=0;c[(c[p>>2]|0)+48>>2]=c[(c[q>>2]|0)+20>>2];c[o>>2]=GB(c[p>>2]|0,c[k>>2]|0,c[q>>2]|0)|0;if((c[o>>2]|0)==-1){c[(c[p>>2]|0)+48>>2]=0;c[(c[p>>2]|0)+48>>2]=0;c[h>>2]=-1;r=c[h>>2]|0;i=g;return r|0}if((c[o>>2]|0)==0?(c[(c[p>>2]|0)+20>>2]|0)!=0:0)c[o>>2]=c[(c[p>>2]|0)+16>>2];k=c[p>>2]|0;if(!(c[(c[p>>2]|0)+20>>2]|0)){HB(k,c[q>>2]|0)|0;c[o>>2]=c[(c[p>>2]|0)+16>>2];if((c[o>>2]|0)!=0?(c[(c[j>>2]|0)+52>>2]|0)==0:0)c[(c[j>>2]|0)+52>>2]=c[o>>2];q=(c[j>>2]|0)+56|0;c[q>>2]=(c[q>>2]|0)+(c[(c[p>>2]|0)+20>>2]|0)}else{q=(c[j>>2]|0)+56|0;c[q>>2]=(c[q>>2]|0)+(c[k+20>>2]|0)}c[(c[p>>2]|0)+48>>2]=0;c[h>>2]=c[o>>2];r=c[h>>2]|0;i=g;return r|0}c[h>>2]=0;r=c[h>>2]|0;i=g;return r|0}function TG(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+48|0;g=f+40|0;h=f+36|0;j=f+32|0;k=f+28|0;l=f+24|0;m=f+20|0;n=f+16|0;o=f+12|0;p=f+8|0;q=f+4|0;r=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=0;if(!(c[k>>2]|0)){c[g>>2]=-1;s=c[g>>2]|0;i=f;return s|0}c[c[k>>2]>>2]=0;if(!(c[j>>2]|0)){c[g>>2]=0;s=c[g>>2]|0;i=f;return s|0}c[n>>2]=0;c[o>>2]=0;c[(c[h>>2]|0)+108>>2]=c[j>>2];c[m>>2]=zH(c[h>>2]|0,c[(c[j>>2]|0)+20>>2]|0,n,o)|0;do if(c[m>>2]|0){if((c[m>>2]|0)<0){xB(c[h>>2]|0,146768,146808);c[(c[h>>2]|0)+108>>2]=c[(c[(c[h>>2]|0)+100>>2]|0)+(c[(c[h>>2]|0)+96>>2]<<2)>>2];c[g>>2]=-1;s=c[g>>2]|0;i=f;return s|0}}else{j=wE(c[(c[h>>2]|0)+20>>2]|0,c[o>>2]|0,c[n>>2]|0)|0;c[c[k>>2]>>2]=j;if(!(c[c[k>>2]>>2]|0)){c[p>>2]=0;j=c[h>>2]|0;e=IH(21)|0;AB(j,1851,0,e,146880,BB(p,c[n>>2]|0,c[o>>2]|0)|0,0);if(c[p>>2]|0){zb[c[135736>>2]&511](c[p>>2]|0);c[p>>2]=0}c[m>>2]=c[(c[h>>2]|0)+52>>2];break}if(c[l>>2]|0){c[q>>2]=0;if(!((c[(c[l>>2]|0)+48>>2]&2048|0)==0?(c[(c[(c[l>>2]|0)+28>>2]|0)+48>>2]&262144|0)==0:0))c[q>>2]=c[q>>2]|2;if(!((c[(c[l>>2]|0)+48>>2]&4096|0)==0?(c[(c[(c[l>>2]|0)+28>>2]|0)+48>>2]&524288|0)==0:0))c[q>>2]=c[q>>2]|1;if(MG(c[h>>2]|0,c[c[k>>2]>>2]|0,c[(c[l>>2]|0)+28>>2]|0,c[q>>2]|0)|0){c[r>>2]=0;e=c[h>>2]|0;AB(e,1852,0,0,146968,BB(r,c[(c[c[k>>2]>>2]|0)+112>>2]|0,c[(c[c[k>>2]>>2]|0)+8>>2]|0)|0,0);if(c[r>>2]|0){zb[c[135736>>2]&511](c[r>>2]|0);c[r>>2]=0}c[m>>2]=c[(c[h>>2]|0)+52>>2];c[c[k>>2]>>2]=0}}}while(0);c[(c[h>>2]|0)+108>>2]=c[(c[(c[h>>2]|0)+100>>2]|0)+(c[(c[h>>2]|0)+96>>2]<<2)>>2];c[g>>2]=c[m>>2];s=c[g>>2]|0;i=f;return s|0}function UG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+32|0;e=d+28|0;f=d+24|0;g=d+20|0;h=d+16|0;j=d+12|0;k=d+8|0;l=d+4|0;m=d;c[f>>2]=a;c[g>>2]=b;c[j>>2]=0;c[k>>2]=c[(c[g>>2]|0)+100>>2];if(!(c[k>>2]|0)){c[e>>2]=0;n=c[e>>2]|0;i=d;return n|0}if(c[(c[(c[f>>2]|0)+108>>2]|0)+56>>2]|0){xB(c[f>>2]|0,146584,146616);c[e>>2]=-1;n=c[e>>2]|0;i=d;return n|0}a:while(1){do if((c[c[k>>2]>>2]|0)==24?(c[l>>2]=c[(c[(c[k>>2]|0)+36>>2]|0)+4>>2],(c[l>>2]|0)!=0):0){c[(c[(c[f>>2]|0)+108>>2]|0)+76>>2]=1;c[m>>2]=c[(c[f>>2]|0)+112>>2];while(1){if(!(c[m>>2]|0))break;if((c[(c[m>>2]|0)+4>>2]|0)==(c[l>>2]|0))break;c[m>>2]=c[c[m>>2]>>2]}if(!(c[m>>2]|0)){o=12;break a}if((c[(c[m>>2]|0)+8>>2]|0)!=-1?(c[(c[f>>2]|0)+96>>2]|0)>=(c[(c[m>>2]|0)+8>>2]|0):0)break;c[(c[m>>2]|0)+8>>2]=c[(c[f>>2]|0)+96>>2]}while(0);c[m>>2]=c[(c[f>>2]|0)+112>>2];while(1){if(!(c[m>>2]|0))break;if((c[(c[m>>2]|0)+4>>2]|0)==(c[k>>2]|0))break;c[m>>2]=c[c[m>>2]>>2]}p=c[f>>2]|0;if(!(c[m>>2]|0)){o=21;break}if(c[p+124>>2]|0){c[h>>2]=c[(c[f>>2]|0)+124>>2];c[(c[f>>2]|0)+124>>2]=c[(c[h>>2]|0)+12>>2];c[(c[h>>2]|0)+12>>2]=0}else{c[h>>2]=Cb[c[135744>>2]&511](36)|0;if(!(c[h>>2]|0)){o=25;break}g=(c[h>>2]|0)+0|0;b=g+36|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(b|0))}g=c[h>>2]|0;if(!(c[j>>2]|0))c[(c[(c[f>>2]|0)+108>>2]|0)+56>>2]=g;else c[(c[j>>2]|0)+8>>2]=g;c[j>>2]=c[h>>2];c[c[h>>2]>>2]=0;c[(c[h>>2]|0)+4>>2]=c[(c[f>>2]|0)+96>>2];c[(c[h>>2]|0)+16>>2]=c[m>>2];c[(c[h>>2]|0)+20>>2]=c[c[(c[m>>2]|0)+4>>2]>>2];if((VG(c[f>>2]|0,c[h>>2]|0,c[(c[k>>2]|0)+24>>2]|0,1)|0)==-1){o=31;break}c[k>>2]=c[(c[k>>2]|0)+8>>2];if(!(c[k>>2]|0)){o=33;break}}if((o|0)==12){xB(c[f>>2]|0,146584,146672);c[e>>2]=-1;n=c[e>>2]|0;i=d;return n|0}else if((o|0)==21){xB(p,146584,146672);c[e>>2]=-1;n=c[e>>2]|0;i=d;return n|0}else if((o|0)==25){IB(c[f>>2]|0,146736,0);c[e>>2]=-1;n=c[e>>2]|0;i=d;return n|0}else if((o|0)==31){c[e>>2]=-1;n=c[e>>2]|0;i=d;return n|0}else if((o|0)==33){c[e>>2]=0;n=c[e>>2]|0;i=d;return n|0}return 0}function VG(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;do if(c[(c[h>>2]|0)+120>>2]|0){c[m>>2]=c[(c[h>>2]|0)+120>>2];c[(c[h>>2]|0)+120>>2]=c[(c[m>>2]|0)+4>>2];c[(c[m>>2]|0)+4>>2]=0}else{c[m>>2]=Cb[c[135744>>2]&511](36)|0;if(c[m>>2]|0){e=(c[m>>2]|0)+0|0;d=e+36|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(d|0));break}IB(0,146088,0);c[g>>2]=-1;n=c[g>>2]|0;i=f;return n|0}while(0);if(c[(c[h>>2]|0)+116>>2]|0)c[(c[m>>2]|0)+4>>2]=c[(c[h>>2]|0)+116>>2];c[(c[h>>2]|0)+116>>2]=c[m>>2];if(c[(c[m>>2]|0)+32>>2]|0)GQ(c[(c[m>>2]|0)+32>>2]|0);e=OQ(c[(c[k>>2]|0)+16>>2]|0)|0;c[(c[m>>2]|0)+32>>2]=e;if(!(c[(c[m>>2]|0)+32>>2]|0)){xB(c[h>>2]|0,146120,146152);c[g>>2]=-1;n=c[g>>2]|0;i=f;return n|0}else{c[c[m>>2]>>2]=c[l>>2];c[(c[m>>2]|0)+8>>2]=c[(c[h>>2]|0)+96>>2];c[(c[m>>2]|0)+24>>2]=c[j>>2];c[(c[m>>2]|0)+28>>2]=c[k>>2];c[(c[m>>2]|0)+16>>2]=0;c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}return 0}function WG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;if(!(c[(c[e>>2]|0)+116>>2]|0)){c[d>>2]=0;h=c[d>>2]|0;i=b;return h|0}c[f>>2]=c[(c[e>>2]|0)+116>>2];while(1){c[g>>2]=KQ(c[(c[f>>2]|0)+32>>2]|0)|0;if((c[g>>2]|0)==-1){j=5;break}c[f>>2]=c[(c[f>>2]|0)+4>>2];if(!(c[f>>2]|0)){j=7;break}}if((j|0)==5){c[d>>2]=-1;h=c[d>>2]|0;i=b;return h|0}else if((j|0)==7){c[d>>2]=0;h=c[d>>2]|0;i=b;return h|0}return 0}function XG(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=0;c[m>>2]=0;HC(l,c[g>>2]|0,c[k>>2]|0)|0;c[l>>2]=By(c[l>>2]|0,145232)|0;e=c[g>>2]|0;g=c[h>>2]|0;h=c[k>>2]|0;d=c[l>>2]|0;PD(e,g,h,d,AH(m,c[j>>2]|0,c[k>>2]|0)|0,0);if(c[m>>2]|0){zb[c[135736>>2]&511](c[m>>2]|0);c[m>>2]=0}if(!(c[l>>2]|0)){i=f;return}zb[c[135736>>2]&511](c[l>>2]|0);c[l>>2]=0;i=f;return}function YG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=ZD(c[e>>2]|0,c[f>>2]|0)|0;i=d;return b|0}function ZG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;do if(c[(c[f>>2]|0)+140>>2]|0){if((c[(c[f>>2]|0)+148>>2]|0)<=(c[(c[f>>2]|0)+144>>2]|0)?(b=(c[f>>2]|0)+148|0,c[b>>2]=c[b>>2]<<1,b=Hb[c[135760>>2]&511](c[(c[f>>2]|0)+140>>2]|0,c[(c[f>>2]|0)+148>>2]<<2)|0,c[(c[f>>2]|0)+140>>2]=b,(c[(c[f>>2]|0)+140>>2]|0)==0):0){IB(c[f>>2]|0,143616,0);c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}}else{b=Cb[c[135744>>2]&511](160)|0;c[(c[f>>2]|0)+140>>2]=b;b=c[f>>2]|0;if(c[(c[f>>2]|0)+140>>2]|0){c[b+148>>2]=40;break}IB(b,143576,0);c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}while(0);b=c[g>>2]|0;g=(c[f>>2]|0)+144|0;a=c[g>>2]|0;c[g>>2]=a+1;c[(c[(c[f>>2]|0)+140>>2]|0)+(a<<2)>>2]=b;c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}function _G(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[d+4>>2]=a;c[e>>2]=b;if(!(c[(c[e>>2]|0)+32>>2]|0)){b=JB()|0;c[(c[e>>2]|0)+32>>2]=b}i=d;return c[(c[e>>2]|0)+32>>2]|0}function $G(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[n>>2]=0;e=my(142560)|0;c[c[h>>2]>>2]=e;c[l>>2]=0;while(1){o=c[c[h>>2]>>2]|0;if((c[l>>2]|0)>=(c[k>>2]|0))break;e=By(o,142568)|0;c[c[h>>2]>>2]=e;e=c[(c[(c[j>>2]|0)+(c[l>>2]<<2)>>2]|0)+4>>2]|0;c[m>>2]=gH(e,QD(c[c[(c[j>>2]|0)+(c[l>>2]<<2)>>2]>>2]|0)|0,n)|0;if(!(c[m>>2]|0)){e=By(c[c[h>>2]>>2]|0,c[n>>2]|0)|0;c[c[h>>2]>>2]=e}else{xB(c[g>>2]|0,142576,142608);e=By(c[c[h>>2]>>2]|0,142648)|0;c[c[h>>2]>>2]=e}e=c[c[h>>2]>>2]|0;if((c[l>>2]|0)<((c[k>>2]|0)-1|0)){d=By(e,142656)|0;c[c[h>>2]>>2]=d}else{d=By(e,142568)|0;c[c[h>>2]>>2]=d}if(c[n>>2]|0){zb[c[135736>>2]&511](c[n>>2]|0);c[n>>2]=0}c[l>>2]=(c[l>>2]|0)+1}l=By(o,142664)|0;c[c[h>>2]>>2]=l;i=f;return c[c[h>>2]>>2]|0}function aH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;do if(c[(c[f>>2]|0)+128>>2]|0){if((c[(c[f>>2]|0)+136>>2]|0)<=(c[(c[f>>2]|0)+132>>2]|0)?(b=(c[f>>2]|0)+136|0,c[b>>2]=c[b>>2]<<1,b=Hb[c[135760>>2]&511](c[(c[f>>2]|0)+128>>2]|0,c[(c[f>>2]|0)+136>>2]<<2)|0,c[(c[f>>2]|0)+128>>2]=b,(c[(c[f>>2]|0)+128>>2]|0)==0):0){IB(c[f>>2]|0,143528,0);c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}}else{b=Cb[c[135744>>2]&511](80)|0;c[(c[f>>2]|0)+128>>2]=b;b=c[f>>2]|0;if(c[(c[f>>2]|0)+128>>2]|0){c[b+136>>2]=20;break}IB(b,143488,0);c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}while(0);b=c[g>>2]|0;g=(c[f>>2]|0)+132|0;a=c[g>>2]|0;c[g>>2]=a+1;c[(c[(c[f>>2]|0)+128>>2]|0)+(a<<2)>>2]=b;c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}function bH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[h>>2]=AP(c[(c[g>>2]|0)+156>>2]|0,c[h>>2]|0,-1)|0;if(!(c[h>>2]|0)){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}if((c[j>>2]|0)!=0?(c[j>>2]=AP(c[(c[g>>2]|0)+156>>2]|0,c[j>>2]|0,-1)|0,(c[j>>2]|0)==0):0){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[(c[(c[g>>2]|0)+180>>2]|0)+4>>2]|0)){m=12;break}if((c[(c[c[(c[g>>2]|0)+180>>2]>>2]|0)+(c[k>>2]<<2)>>2]|0)==(c[h>>2]|0)?(c[(c[c[(c[g>>2]|0)+180>>2]>>2]|0)+((c[k>>2]|0)+1<<2)>>2]|0)==(c[j>>2]|0):0){m=10;break}c[k>>2]=(c[k>>2]|0)+2}if((m|0)==10){c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}else if((m|0)==12){c[k>>2]=c[(c[(c[g>>2]|0)+180>>2]|0)+4>>2];bE(c[(c[g>>2]|0)+180>>2]|0,c[h>>2]|0)|0;bE(c[(c[g>>2]|0)+180>>2]|0,c[j>>2]|0)|0;c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}return 0}function cH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=c[(c[(c[f>>2]|0)+100>>2]|0)+(c[(c[g>>2]|0)+4>>2]<<2)>>2];if(!(c[(c[h>>2]|0)+52>>2]|0)){f=fH(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]|0)|0;c[(c[h>>2]|0)+52>>2]=f;if(!(c[(c[h>>2]|0)+52>>2]|0)){c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}else{c[e>>2]=c[(c[h>>2]|0)+52>>2];k=c[e>>2]|0;i=d;return k|0}}c[j>>2]=0;c[j>>2]=c[(c[h>>2]|0)+52>>2];while(1){l=c[j>>2]|0;if((c[(c[j>>2]|0)+4>>2]|0)==(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]|0)){m=7;break}if(!(c[l>>2]|0)){m=9;break}c[j>>2]=c[c[j>>2]>>2];if(!(c[j>>2]|0)){m=13;break}}if((m|0)==7){c[e>>2]=l;k=c[e>>2]|0;i=d;return k|0}else if((m|0)==9){l=fH(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]|0)|0;c[c[j>>2]>>2]=l;if(!(c[c[j>>2]>>2]|0)){c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}else{c[e>>2]=c[c[j>>2]>>2];k=c[e>>2]|0;i=d;return k|0}}else if((m|0)==13){c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}return 0}function dH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;b=(c[f>>2]|0)+16|0;if(!(c[(c[f>>2]|0)+8>>2]|0)){c[b>>2]=10;a=Cb[c[135744>>2]&511](40)|0;c[(c[f>>2]|0)+8>>2]=a;if(!(c[(c[f>>2]|0)+8>>2]|0)){IB(0,142256,0);c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}}else if((c[b>>2]|0)<=(c[(c[f>>2]|0)+12>>2]|0)?(b=(c[f>>2]|0)+16|0,c[b>>2]=c[b>>2]<<1,b=Hb[c[135760>>2]&511](c[(c[f>>2]|0)+8>>2]|0,c[(c[f>>2]|0)+16>>2]<<2)|0,c[(c[f>>2]|0)+8>>2]=b,(c[(c[f>>2]|0)+8>>2]|0)==0):0){IB(0,142712,0);c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}b=c[g>>2]|0;g=(c[f>>2]|0)+12|0;a=c[g>>2]|0;c[g>>2]=a+1;c[(c[(c[f>>2]|0)+8>>2]|0)+(a<<2)>>2]=b;c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}function eH(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+48|0;k=j+32|0;l=j+28|0;m=j+24|0;n=j+16|0;o=j+12|0;p=j+8|0;q=j+4|0;r=j;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[j+20>>2]=e;c[n>>2]=f;c[o>>2]=g;c[p>>2]=h;c[q>>2]=0;c[r>>2]=0;c[q>>2]=my(142688)|0;c[q>>2]=By(c[q>>2]|0,c[n>>2]|0)|0;c[q>>2]=By(c[q>>2]|0,142704)|0;n=c[k>>2]|0;h=c[l>>2]|0;l=c[(c[m>>2]|0)+8>>2]|0;g=c[q>>2]|0;f=BB(r,c[(c[c[(c[k>>2]|0)+180>>2]>>2]|0)+((c[(c[m>>2]|0)+12>>2]|0)+1<<2)>>2]|0,c[(c[c[(c[k>>2]|0)+180>>2]>>2]|0)+(c[(c[m>>2]|0)+12>>2]<<2)>>2]|0)|0;$D(n,2,h,0,l,g,f,c[o>>2]|0,c[p>>2]|0,0);
if(c[r>>2]|0){zb[c[135736>>2]&511](c[r>>2]|0);c[r>>2]=0}if(!(c[q>>2]|0)){i=j;return}zb[c[135736>>2]&511](c[q>>2]|0);c[q>>2]=0;i=j;return}function fH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](24)|0;if(!(c[f>>2]|0)){IB(0,142304,0);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{a=c[f>>2]|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;c[(c[f>>2]|0)+4>>2]=c[e>>2];c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function gH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;n=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[n>>2]=0;if((c[j>>2]|0)==0|(c[g>>2]|0)==0){c[f>>2]=-1;o=c[f>>2]|0;i=e;return o|0}d=(KH(c[g>>2]|0)|0)!=0;c[k>>2]=d?1:0;c[c[j>>2]>>2]=0;while(1){c[m>>2]=0;c[l>>2]=dI(c[g>>2]|0)|0;d=c[l>>2]|0;if((d|0)==46|(d|0)==2|(d|0)==1){c[m>>2]=LH(c[g>>2]|0)|0;if(c[m>>2]|0){if((c[h>>2]|0)!=3){if((c[h>>2]|0)==2)c[n>>2]=RH(c[m>>2]|0)|0}else c[n>>2]=SH(c[m>>2]|0)|0;if(c[n>>2]|0)c[m>>2]=c[n>>2]}}else{d=(cI(c[g>>2]|0,n)|0)==-1;p=c[n>>2]|0;if(d)break;c[m>>2]=p}d=c[m>>2]|0;do if(!(c[c[j>>2]>>2]|0)){if(d){b=my(c[m>>2]|0)|0;c[c[j>>2]>>2]=b;break}if(!(c[k>>2]|0)){b=my(142672)|0;c[c[j>>2]>>2]=b}}else if(d){b=By(c[c[j>>2]>>2]|0,142680)|0;c[c[j>>2]>>2]=b;b=By(c[c[j>>2]>>2]|0,c[m>>2]|0)|0;c[c[j>>2]>>2]=b}while(0);if(c[n>>2]|0){zb[c[135736>>2]&511](c[n>>2]|0);c[n>>2]=0}c[g>>2]=KH(c[g>>2]|0)|0;if(!(c[g>>2]|0)){q=26;break}}if((q|0)==26){c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}if(p)zb[c[135736>>2]&511](c[n>>2]|0);if(c[c[j>>2]>>2]|0)zb[c[135736>>2]&511](c[c[j>>2]>>2]|0);if(c[n>>2]|0)zb[c[135736>>2]&511](c[n>>2]|0);c[f>>2]=-1;o=c[f>>2]|0;i=e;return o|0}function hH(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=_i(c[d>>2]|0)|0;i=b;return a|0}function iH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;d=c[g>>2]|0;if(c[h>>2]|0){c[f>>2]=BB(d,c[(c[h>>2]|0)+8>>2]|0,c[j>>2]|0)|0;k=c[f>>2]|0;i=e;return k|0}else{c[f>>2]=BB(d,0,c[j>>2]|0)|0;k=c[f>>2]|0;i=e;return k|0}return 0}function jH(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+48|0;h=g+32|0;j=g+28|0;k=g+24|0;l=g+20|0;m=g+16|0;n=g+12|0;o=g+8|0;p=g+4|0;q=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;if((c[j>>2]|0)==0|(c[k>>2]|0)==0|(c[l>>2]|0)==0|(c[m>>2]|0)==0){c[h>>2]=-1;r=c[h>>2]|0;i=g;return r|0}c[c[m>>2]>>2]=0;c[o>>2]=c[(c[l>>2]|0)+44>>2];while(1){if(!(c[o>>2]|0))break;k=c[o>>2]|0;if(!(c[(c[o>>2]|0)+36>>2]|0)){if((qy(c[k+8>>2]|0,161384)|0)==0?(qy(c[(c[o>>2]|0)+8>>2]|0,155456)|0)==0:0)GF(c[j>>2]|0,3035,0,c[o>>2]|0)}else if(qy(c[(c[k+36>>2]|0)+8>>2]|0,c[38526]|0)|0)GF(c[j>>2]|0,3035,0,c[o>>2]|0);c[o>>2]=c[(c[o>>2]|0)+24>>2]}cE(c[j>>2]|0,c[l>>2]|0,161384)|0;c[o>>2]=dE(c[l>>2]|0,155456)|0;do if(c[o>>2]|0){c[p>>2]=0;c[q>>2]=0;k=c[j>>2]|0;f=c[o>>2]|0;e=IH(29)|0;if(!(eE(k,0,f,e,c[m>>2]|0)|0)){c[p>>2]=Xi(c[(c[l>>2]|0)+32>>2]|0,c[l>>2]|0)|0;e=c[c[m>>2]>>2]|0;if(!(c[p>>2]|0))c[q>>2]=Hl(e,c[(c[(c[l>>2]|0)+32>>2]|0)+72>>2]|0)|0;else{c[q>>2]=Hl(e,c[p>>2]|0)|0;zb[c[135736>>2]&511](c[p>>2]|0)}e=c[j>>2]|0;if(!(c[q>>2]|0)){xB(e,168224,168256);c[h>>2]=-1;r=c[h>>2]|0;i=g;return r|0}f=AP(c[e+80>>2]|0,c[q>>2]|0,-1)|0;c[c[m>>2]>>2]=f;zb[c[135736>>2]&511](c[q>>2]|0);if(!(qy(c[c[m>>2]>>2]|0,c[(c[j>>2]|0)+44>>2]|0)|0)){c[h>>2]=0;r=c[h>>2]|0;i=g;return r|0}f=c[j>>2]|0;e=c[l>>2]|0;k=c[c[m>>2]>>2]|0;if((c[n>>2]|0)==3){GE(f,3081,0,e,168304,k);break}else{GE(f,3050,0,e,168360,k);break}}}else MF(c[j>>2]|0,3036,0,c[l>>2]|0,155456,0);while(0);c[h>>2]=c[(c[j>>2]|0)+16>>2];r=c[h>>2]|0;i=g;return r|0}function kH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=i;i=i+96|0;e=d+88|0;f=d+84|0;g=d+80|0;h=d+76|0;j=d+72|0;k=d+68|0;l=d+64|0;m=d+60|0;n=d+56|0;o=d+52|0;p=d+48|0;q=d+44|0;r=d+40|0;s=d+36|0;t=d+32|0;u=d+28|0;v=d+24|0;w=d+20|0;x=d+16|0;y=d+12|0;z=d+8|0;A=d+4|0;B=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){c[e>>2]=0;C=c[e>>2]|0;i=d;return C|0}do switch(c[c[f>>2]>>2]|0){case 16:{c[q>>2]=c[f>>2];c[r>>2]=c[(c[q>>2]|0)+24>>2];if(!(c[(c[q>>2]|0)+24>>2]|0)){c[(c[q>>2]|0)+24>>2]=c[g>>2];c[e>>2]=c[g>>2];C=c[e>>2]|0;i=d;return C|0}c[r>>2]=c[(c[q>>2]|0)+24>>2];if(c[c[r>>2]>>2]|0)c[r>>2]=c[c[r>>2]>>2];c[c[r>>2]>>2]=c[g>>2];break}case 2:case 21:{c[m>>2]=c[f>>2];c[n>>2]=c[(c[m>>2]|0)+8>>2];if(!(c[(c[m>>2]|0)+8>>2]|0)){c[(c[m>>2]|0)+8>>2]=c[g>>2];c[e>>2]=c[g>>2];C=c[e>>2]|0;i=d;return C|0}c[n>>2]=c[(c[m>>2]|0)+8>>2];if(c[c[n>>2]>>2]|0)c[n>>2]=c[c[n>>2]>>2];c[c[n>>2]>>2]=c[g>>2];break}case 18:{c[s>>2]=c[f>>2];c[t>>2]=c[(c[s>>2]|0)+8>>2];if(!(c[(c[s>>2]|0)+8>>2]|0)){c[(c[s>>2]|0)+8>>2]=c[g>>2];c[e>>2]=c[g>>2];C=c[e>>2]|0;i=d;return C|0}c[t>>2]=c[(c[s>>2]|0)+8>>2];if(c[c[t>>2]>>2]|0)c[t>>2]=c[c[t>>2]>>2];c[c[t>>2]>>2]=c[g>>2];break}case 5:case 4:{c[w>>2]=c[f>>2];c[x>>2]=c[(c[w>>2]|0)+24>>2];if(!(c[(c[w>>2]|0)+24>>2]|0)){c[(c[w>>2]|0)+24>>2]=c[g>>2];c[e>>2]=c[g>>2];C=c[e>>2]|0;i=d;return C|0}c[x>>2]=c[(c[w>>2]|0)+24>>2];if(c[c[x>>2]>>2]|0)c[x>>2]=c[c[x>>2]>>2];c[c[x>>2]>>2]=c[g>>2];break}case 1011:case 1010:case 1009:case 1008:case 1007:case 1006:case 1005:case 1004:case 1003:case 1002:case 1001:case 1e3:{c[u>>2]=c[f>>2];c[v>>2]=c[(c[u>>2]|0)+16>>2];if(!(c[(c[u>>2]|0)+16>>2]|0)){c[(c[u>>2]|0)+16>>2]=c[g>>2];c[e>>2]=c[g>>2];C=c[e>>2]|0;i=d;return C|0}c[v>>2]=c[(c[u>>2]|0)+16>>2];if(c[c[v>>2]>>2]|0)c[v>>2]=c[c[v>>2]>>2];c[c[v>>2]>>2]=c[g>>2];break}case 17:{c[y>>2]=c[f>>2];c[z>>2]=c[(c[y>>2]|0)+4>>2];if(!(c[(c[y>>2]|0)+4>>2]|0)){c[(c[y>>2]|0)+4>>2]=c[g>>2];c[e>>2]=c[g>>2];C=c[e>>2]|0;i=d;return C|0}c[z>>2]=c[(c[y>>2]|0)+4>>2];if(c[c[z>>2]>>2]|0)c[z>>2]=c[c[z>>2]>>2];c[c[z>>2]>>2]=c[g>>2];break}case 15:{c[k>>2]=c[f>>2];c[l>>2]=c[(c[k>>2]|0)+32>>2];if(!(c[(c[k>>2]|0)+32>>2]|0)){c[(c[k>>2]|0)+32>>2]=c[g>>2];c[e>>2]=c[g>>2];C=c[e>>2]|0;i=d;return C|0}c[l>>2]=c[(c[k>>2]|0)+32>>2];if(c[c[l>>2]>>2]|0)c[l>>2]=c[c[l>>2]>>2];c[c[l>>2]>>2]=c[g>>2];break}case 22:case 24:case 23:case 25:{c[o>>2]=c[f>>2];c[p>>2]=c[(c[o>>2]|0)+4>>2];if(!(c[(c[o>>2]|0)+4>>2]|0)){c[(c[o>>2]|0)+4>>2]=c[g>>2];c[e>>2]=c[g>>2];C=c[e>>2]|0;i=d;return C|0}c[p>>2]=c[(c[o>>2]|0)+4>>2];if(c[c[p>>2]>>2]|0)c[p>>2]=c[c[p>>2]>>2];c[c[p>>2]>>2]=c[g>>2];break}case 8:case 7:case 6:{c[A>>2]=c[f>>2];c[B>>2]=c[(c[A>>2]|0)+4>>2];if(!(c[(c[A>>2]|0)+4>>2]|0)){c[(c[A>>2]|0)+4>>2]=c[g>>2];c[e>>2]=c[g>>2];C=c[e>>2]|0;i=d;return C|0}c[B>>2]=c[(c[A>>2]|0)+4>>2];if(c[c[B>>2]>>2]|0)c[B>>2]=c[c[B>>2]>>2];c[c[B>>2]>>2]=c[g>>2];break}case 14:{c[h>>2]=c[f>>2];c[j>>2]=c[(c[h>>2]|0)+24>>2];if(!(c[(c[h>>2]|0)+24>>2]|0)){c[(c[h>>2]|0)+24>>2]=c[g>>2];c[e>>2]=c[g>>2];C=c[e>>2]|0;i=d;return C|0}c[j>>2]=c[(c[h>>2]|0)+24>>2];if(c[c[j>>2]>>2]|0)c[j>>2]=c[c[j>>2]>>2];c[c[j>>2]>>2]=c[g>>2];break}default:GE(0,3069,0,0,165080,0)}while(0);c[e>>2]=c[g>>2];C=c[e>>2]|0;i=d;return C|0}function lH(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f+28|0;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f+4|0;o=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[n>>2]=0;if((c[h>>2]|0)==0|(c[j>>2]|0)==0|(c[k>>2]|0)==0){c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}c[m>>2]=c[(c[h>>2]|0)+84>>2];e=(c[m>>2]|0)+48|0;c[e>>2]=c[e>>2]|2;c[o>>2]=c[(c[k>>2]|0)+44>>2];while(1){if(!(c[o>>2]|0))break;e=c[o>>2]|0;if(!(c[(c[o>>2]|0)+36>>2]|0)){if((qy(c[e+8>>2]|0,161384)|0)==0?(qy(c[(c[o>>2]|0)+8>>2]|0,151424)|0)==0:0)GF(c[h>>2]|0,3035,0,c[o>>2]|0)}else if(qy(c[(c[e+36>>2]|0)+8>>2]|0,c[38526]|0)|0)GF(c[h>>2]|0,3035,0,c[o>>2]|0);c[o>>2]=c[(c[o>>2]|0)+24>>2]}cE(c[h>>2]|0,c[k>>2]|0,161384)|0;if((fG(c[h>>2]|0,c[j>>2]|0,0,c[k>>2]|0,151424,(c[m>>2]|0)+60|0,(c[m>>2]|0)+56|0)|0)==0?(c[(c[m>>2]|0)+56>>2]|0)==0:0)MF(c[h>>2]|0,3036,0,c[k>>2]|0,151424,0);c[n>>2]=c[(c[k>>2]|0)+12>>2];if((((c[n>>2]|0)!=0?(c[(c[n>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[n>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(qy(c[(c[(c[n>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){o=c[m>>2]|0;kH(o,jE(c[h>>2]|0,c[n>>2]|0,1)|0)|0;c[n>>2]=c[(c[n>>2]|0)+24>>2]}do if((c[l>>2]|0)==10){if((((c[n>>2]|0)!=0?(c[(c[n>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[n>>2]|0)+8>>2]|0,161648)|0)!=0:0)?(qy(c[(c[(c[n>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){o=QF(c[h>>2]|0,c[j>>2]|0,c[n>>2]|0,8,1)|0;c[(c[m>>2]|0)+28>>2]=o;c[n>>2]=c[(c[n>>2]|0)+24>>2];break}if((((c[n>>2]|0)!=0?(c[(c[n>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[n>>2]|0)+8>>2]|0,161656)|0)!=0:0)?(qy(c[(c[(c[n>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){o=QF(c[h>>2]|0,c[j>>2]|0,c[n>>2]|0,7,1)|0;c[(c[m>>2]|0)+28>>2]=o;c[n>>2]=c[(c[n>>2]|0)+24>>2];break}if((((c[n>>2]|0)!=0?(c[(c[n>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[n>>2]|0)+8>>2]|0,161664)|0)!=0:0)?(qy(c[(c[(c[n>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){o=QF(c[h>>2]|0,c[j>>2]|0,c[n>>2]|0,6,1)|0;c[(c[m>>2]|0)+28>>2]=o;c[n>>2]=c[(c[n>>2]|0)+24>>2];break}if((((c[n>>2]|0)!=0?(c[(c[n>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[n>>2]|0)+8>>2]|0,161080)|0)!=0:0)?(qy(c[(c[(c[n>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){o=RF(c[h>>2]|0,c[j>>2]|0,c[n>>2]|0)|0;c[(c[m>>2]|0)+28>>2]=o;c[n>>2]=c[(c[n>>2]|0)+24>>2]}}while(0);if(c[n>>2]|0){if((SF(c[h>>2]|0,c[j>>2]|0,n,(c[m>>2]|0)+116|0,13,0)|0)==-1){c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}if((((c[n>>2]|0)!=0?(c[(c[n>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[n>>2]|0)+8>>2]|0,163328)|0)!=0:0)?(qy(c[(c[(c[n>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){m=TF(c[h>>2]|0,c[j>>2]|0,c[n>>2]|0)|0;c[(c[(c[h>>2]|0)+84>>2]|0)+84>>2]=m;c[n>>2]=c[(c[n>>2]|0)+24>>2]}}do if(c[n>>2]|0){m=c[h>>2]|0;j=c[k>>2]|0;o=c[n>>2]|0;if((c[l>>2]|0)==10){uE(m,3033,0,j,o,0,167440);break}else{uE(m,3033,0,j,o,0,163344);break}}while(0);c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}function mH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+48|0;f=e+40|0;g=e+36|0;h=e+32|0;j=e+28|0;k=e+24|0;l=e+20|0;m=e+16|0;n=e+12|0;o=e+8|0;p=e+4|0;q=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[l>>2]=0;c[q>>2]=0;if((c[g>>2]|0)==0|(c[h>>2]|0)==0|(c[j>>2]|0)==0){c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}c[p>>2]=c[(c[j>>2]|0)+44>>2];while(1){if(!(c[p>>2]|0))break;d=c[p>>2]|0;if(!(c[(c[p>>2]|0)+36>>2]|0)){if(((((qy(c[d+8>>2]|0,161384)|0)==0?(qy(c[(c[p>>2]|0)+8>>2]|0,161824)|0)==0:0)?(qy(c[(c[p>>2]|0)+8>>2]|0,161808)|0)==0:0)?(qy(c[(c[p>>2]|0)+8>>2]|0,162304)|0)==0:0)?(qy(c[(c[p>>2]|0)+8>>2]|0,162320)|0)==0:0)GF(c[g>>2]|0,3035,0,c[p>>2]|0)}else if(qy(c[(c[d+36>>2]|0)+8>>2]|0,c[38526]|0)|0)GF(c[g>>2]|0,3035,0,c[p>>2]|0);c[p>>2]=c[(c[p>>2]|0)+24>>2]}cE(c[g>>2]|0,c[j>>2]|0,161384)|0;c[o>>2]=YF(c[g>>2]|0,c[j>>2]|0,0,1073741824,1,161768)|0;c[n>>2]=XF(c[g>>2]|0,c[j>>2]|0,0,-1,1,161744)|0;ZF(c[g>>2]|0,0,c[j>>2]|0,c[n>>2]|0,c[o>>2]|0)|0;c[m>>2]=qG(c[g>>2]|0,c[h>>2]|0,2,c[j>>2]|0)|0;if(!(c[m>>2]|0)){c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}pH(c[g>>2]|0,c[h>>2]|0,c[m>>2]|0,c[j>>2]|0)|0;c[l>>2]=c[(c[j>>2]|0)+12>>2];if((((c[l>>2]|0)!=0?(c[(c[l>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[l>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(qy(c[(c[(c[l>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){c[q>>2]=jE(c[g>>2]|0,c[l>>2]|0,1)|0;c[l>>2]=c[(c[l>>2]|0)+24>>2]}if(c[l>>2]|0)uE(c[g>>2]|0,3033,0,c[j>>2]|0,c[l>>2]|0,0,161392);if((c[n>>2]|0)==0&(c[o>>2]|0)==0){c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}c[k>>2]=XE(c[g>>2]|0,c[j>>2]|0,c[n>>2]|0,c[o>>2]|0)|0;if(!(c[k>>2]|0)){c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}else{c[(c[k>>2]|0)+4>>2]=c[q>>2];c[(c[k>>2]|0)+12>>2]=c[m>>2];c[f>>2]=c[k>>2];r=c[f>>2]|0;i=e;return r|0}return 0}function nH(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=i;i=i+112|0;h=g+96|0;j=g+92|0;k=g+88|0;l=g+84|0;m=g+80|0;n=g+76|0;o=g+72|0;p=g+68|0;q=g+64|0;r=g+60|0;s=g+56|0;t=g+52|0;u=g+48|0;v=g+44|0;w=g+40|0;x=g+36|0;y=g+32|0;z=g+28|0;A=g+24|0;B=g+20|0;C=g+16|0;D=g+12|0;E=g+8|0;F=g+4|0;G=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[p>>2]=0;c[q>>2]=0;c[r>>2]=0;c[s>>2]=0;c[u>>2]=0;c[v>>2]=0;c[w>>2]=0;c[x>>2]=0;c[y>>2]=2;c[A>>2]=0;c[B>>2]=0;if((c[j>>2]|0)==0|(c[k>>2]|0)==0|(c[l>>2]|0)==0){c[h>>2]=0;H=c[h>>2]|0;i=g;return H|0}c[t>>2]=dE(c[l>>2]|0,160064)|0;do if(c[t>>2]|0){if(_F(c[j>>2]|0,c[k>>2]|0,0,c[t>>2]|0,u,v)|0){c[h>>2]=0;H=c[h>>2]|0;i=g;return H|0}if(!($F(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,c[t>>2]|0,c[u>>2]|0)|0)){c[x>>2]=1;break}c[h>>2]=0;H=c[h>>2]|0;i=g;return H|0}while(0);c[z>>2]=c[(c[j>>2]|0)+20>>2];c[t>>2]=c[(c[l>>2]|0)+44>>2];while(1){if(!(c[t>>2]|0))break;a:do if(!(c[(c[t>>2]|0)+36>>2]|0)){f=c[(c[t>>2]|0)+8>>2]|0;do if(c[x>>2]|0)if(!(qy(f,161384)|0))if(qy(c[(c[t>>2]|0)+8>>2]|0,160064)|0)break a;else break;else{CF(c[j>>2]|0,c[t>>2]|0)|0;break a}else{if(qy(f,161352)|0)break a;if(qy(c[(c[t>>2]|0)+8>>2]|0,161384)|0){CF(c[j>>2]|0,c[t>>2]|0)|0;break a}if(qy(c[(c[t>>2]|0)+8>>2]|0,155448)|0){_F(c[j>>2]|0,c[k>>2]|0,0,c[t>>2]|0,u,v)|0;break a}if(qy(c[(c[t>>2]|0)+8>>2]|0,163528)|0){c[A>>2]=1;c[o>>2]=fE(c[j>>2]|0,c[t>>2]|0)|0;if(qy(c[o>>2]|0,163536)|0){c[q>>2]=c[(c[j>>2]|0)+112>>2];break a}if(qy(c[o>>2]|0,163552)|0)break a;hE(c[j>>2]|0,3037,0,c[t>>2]|0,0,163568,c[o>>2]|0,0,0,0);break a}}while(0);if(qy(c[(c[t>>2]|0)+8>>2]|0,163600)|0){c[o>>2]=fE(c[j>>2]|0,c[t>>2]|0)|0;if(qy(c[o>>2]|0,163608)|0){c[y>>2]=2;break}if(qy(c[o>>2]|0,163624)|0){c[y>>2]=0;break}if(qy(c[o>>2]|0,163640)|0){c[y>>2]=1;break}else{hE(c[j>>2]|0,1774,0,c[t>>2]|0,0,163656,c[o>>2]|0,0,0,0);break}}if(qy(c[(c[t>>2]|0)+8>>2]|0,159128)|0){f=c[j>>2]|0;e=c[t>>2]|0;if(c[w>>2]|0){aG(f,3051,0,e,159128,159120);break}else{c[w>>2]=fE(f,e)|0;c[B>>2]=1;break}}if(qy(c[(c[t>>2]|0)+8>>2]|0,159120)|0){e=c[j>>2]|0;f=c[t>>2]|0;if(c[w>>2]|0){aG(e,3051,0,f,159128,159120);break}else{c[w>>2]=fE(e,f)|0;c[B>>2]=2;break}}else I=43}else if(qy(c[(c[(c[t>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)I=43;while(0);if((I|0)==43){I=0;GF(c[j>>2]|0,3035,0,c[t>>2]|0)}c[t>>2]=c[(c[t>>2]|0)+24>>2]}if((c[B>>2]|0)==1&(c[y>>2]|0)!=2)hE(c[j>>2]|0,3052,0,c[l>>2]|0,0,163656,0,163696,0,0);if((c[z>>2]|0)!=(c[(c[j>>2]|0)+20>>2]|0)){c[h>>2]=0;H=c[h>>2]|0;i=g;return H|0}if(c[x>>2]|0){if(c[y>>2]|0){c[r>>2]=BH(c[j>>2]|0,c[l>>2]|0)|0;if(!(c[r>>2]|0)){c[h>>2]=0;H=c[h>>2]|0;i=g;return H|0}dG((c[(c[j>>2]|0)+28>>2]|0)+20|0,10,c[r>>2]|0)|0;c[(c[r>>2]|0)+24>>2]=c[y>>2];c[D>>2]=cG(c[j>>2]|0,15,c[v>>2]|0,c[u>>2]|0)|0;if(!(c[D>>2]|0)){c[h>>2]=0;H=c[h>>2]|0;i=g;return H|0}c[(c[r>>2]|0)+12>>2]=c[D>>2];if(c[w>>2]|0)c[(c[r>>2]|0)+28>>2]=c[w>>2];if((c[B>>2]|0)==2){D=(c[r>>2]|0)+16|0;c[D>>2]=c[D>>2]|1}}}else{if((c[A>>2]|0)==0?(c[(c[k>>2]|0)+24>>2]&2|0)!=0:0)c[q>>2]=c[(c[j>>2]|0)+112>>2];if(qy(c[q>>2]|0,c[38860]|0)|0)AB(c[j>>2]|0,3057,c[l>>2]|0,0,163792,c[38860]|0,0);c[t>>2]=dE(c[l>>2]|0,161352)|0;A=c[j>>2]|0;if(!(c[t>>2]|0)){MF(A,3036,0,c[l>>2]|0,161352,0);c[h>>2]=0;H=c[h>>2]|0;i=g;return H|0}D=c[t>>2]|0;if(eE(A,0,D,IH(22)|0,p)|0){c[h>>2]=0;H=c[h>>2]|0;i=g;return H|0}if(qy(c[p>>2]|0,163840)|0){D=c[j>>2]|0;A=c[t>>2]|0;hE(D,3056,0,A,IH(22)|0,0,0,163848,0,0);c[h>>2]=0;H=c[h>>2]|0;i=g;return H|0}if(c[y>>2]|0){c[r>>2]=BH(c[j>>2]|0,c[l>>2]|0)|0;if(!(c[r>>2]|0)){c[h>>2]=0;H=c[h>>2]|0;i=g;return H|0}c[(c[r>>2]|0)+24>>2]=c[y>>2];c[C>>2]=iG(c[j>>2]|0,c[k>>2]|0,c[p>>2]|0,c[q>>2]|0,c[l>>2]|0,0)|0;if(!(c[C>>2]|0)){c[h>>2]=0;H=c[h>>2]|0;i=g;return H|0}if(c[v>>2]|0){c[(c[C>>2]|0)+24>>2]=c[v>>2];c[(c[C>>2]|0)+28>>2]=c[u>>2]}c[(c[r>>2]|0)+12>>2]=c[C>>2];if((c[w>>2]|0)!=0?(c[(c[C>>2]|0)+44>>2]=c[w>>2],(c[B>>2]|0)==2):0){B=(c[C>>2]|0)+60|0;c[B>>2]=c[B>>2]|512}}}c[s>>2]=c[(c[l>>2]|0)+12>>2];B=(c[s>>2]|0)!=0;if(c[y>>2]|0){if(((B?(c[(c[s>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[s>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(qy(c[(c[(c[s>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){y=jE(c[j>>2]|0,c[s>>2]|0,1)|0;c[(c[r>>2]|0)+4>>2]=y;c[s>>2]=c[(c[s>>2]|0)+24>>2]}y=(c[s>>2]|0)!=0;do if(c[x>>2]|0){if(y){if((((c[s>>2]|0)!=0?(c[(c[s>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[s>>2]|0)+8>>2]|0,161024)|0)!=0:0)?(qy(c[(c[(c[s>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){uE(c[j>>2]|0,3054,0,c[l>>2]|0,c[s>>2]|0,0,161392);break}uE(c[j>>2]|0,3033,0,c[l>>2]|0,c[s>>2]|0,0,161392)}}else{if(((y?(c[(c[s>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[s>>2]|0)+8>>2]|0,161024)|0)!=0:0)?(qy(c[(c[(c[s>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){C=c[j>>2]|0;if(c[(c[(c[r>>2]|0)+12>>2]|0)+24>>2]|0)uE(C,3055,0,c[l>>2]|0,c[s>>2]|0,164128,0);else{w=oE(C,c[k>>2]|0,c[s>>2]|0,0)|0;c[(c[(c[r>>2]|0)+12>>2]|0)+48>>2]=w}c[s>>2]=c[(c[s>>2]|0)+24>>2]}if(c[s>>2]|0)uE(c[j>>2]|0,3033,0,c[l>>2]|0,c[s>>2]|0,0,164200)}while(0);c[h>>2]=c[r>>2];H=c[h>>2]|0;i=g;return H|0}if(((B?(c[(c[s>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[s>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(qy(c[(c[(c[s>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){jE(c[j>>2]|0,c[s>>2]|0,0)|0;c[s>>2]=c[(c[s>>2]|0)+24>>2]}if(c[s>>2]|0)uE(c[j>>2]|0,3033,0,c[l>>2]|0,c[s>>2]|0,0,161392);if((c[n>>2]|0)==16){NC(c[j>>2]|0,3086,c[l>>2]|0,0,163904,0,0,0);c[h>>2]=0;H=c[h>>2]|0;i=g;return H|0}if((c[n>>2]|0)==13){NC(c[j>>2]|0,3086,c[l>>2]|0,0,163992,0,0,0);c[h>>2]=0;H=c[h>>2]|0;i=g;return H|0}if(!(c[x>>2]|0)){c[v>>2]=c[p>>2];c[u>>2]=c[q>>2]}b:do if(c[m>>2]|0){c[F>>2]=0;while(1){if((c[F>>2]|0)>=(c[(c[m>>2]|0)+4>>2]|0))break b;c[r>>2]=c[(c[c[m>>2]>>2]|0)+(c[F>>2]<<2)>>2];if(((c[c[r>>2]>>2]|0)==2001?(c[v>>2]|0)==(c[(c[r>>2]|0)+8>>2]|0):0)?(c[u>>2]|0)==(c[(c[r>>2]|0)+12>>2]|0):0)break;c[F>>2]=(c[F>>2]|0)+1}c[G>>2]=0;q=c[j>>2]|0;p=c[l>>2]|0;NC(q,3086,p,0,164072,BB(G,c[u>>2]|0,c[v>>2]|0)|0,0,0);if(c[G>>2]|0){zb[c[135736>>2]&511](c[G>>2]|0);c[G>>2]=0}c[h>>2]=0;H=c[h>>2]|0;i=g;return H|0}while(0);c[E>>2]=CH(c[j>>2]|0)|0;if(!(c[E>>2]|0)){c[h>>2]=0;H=c[h>>2]|0;i=g;return H|0}c[(c[E>>2]|0)+4>>2]=c[l>>2];c[(c[E>>2]|0)+8>>2]=c[v>>2];c[(c[E>>2]|0)+12>>2]=c[u>>2];if(c[x>>2]|0)dG((c[(c[j>>2]|0)+28>>2]|0)+20|0,10,c[E>>2]|0)|0;c[h>>2]=c[E>>2];H=c[h>>2]|0;i=g;return H|0}function oH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+48|0;f=e+36|0;g=e+32|0;h=e+28|0;j=e+24|0;k=e+20|0;l=e+16|0;m=e+12|0;n=e+8|0;o=e+4|0;p=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[l>>2]=0;c[n>>2]=0;c[o>>2]=0;if((c[g>>2]|0)==0|(c[h>>2]|0)==0|(c[j>>2]|0)==0){c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}c[m>>2]=dE(c[j>>2]|0,160064)|0;d=c[g>>2]|0;if(!(c[m>>2]|0)){MF(d,3036,0,c[j>>2]|0,160064,0);c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}_F(d,c[h>>2]|0,0,c[m>>2]|0,n,o)|0;if($F(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0,c[m>>2]|0,c[n>>2]|0)|0){c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}c[m>>2]=c[(c[j>>2]|0)+44>>2];while(1){if(!(c[m>>2]|0))break;h=c[m>>2]|0;if(!(c[(c[m>>2]|0)+36>>2]|0)){if((qy(c[h+8>>2]|0,160064)|0)==0?(qy(c[(c[m>>2]|0)+8>>2]|0,161384)|0)==0:0)GF(c[g>>2]|0,3035,0,c[m>>2]|0)}else if(qy(c[(c[h+36>>2]|0)+8>>2]|0,c[38526]|0)|0)GF(c[g>>2]|0,3035,0,c[m>>2]|0);c[m>>2]=c[(c[m>>2]|0)+24>>2]}cE(c[g>>2]|0,c[j>>2]|0,161384)|0;c[l>>2]=c[(c[j>>2]|0)+12>>2];if((((c[l>>2]|0)!=0?(c[(c[l>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[l>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(qy(c[(c[(c[l>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){jE(c[g>>2]|0,c[l>>2]|0,0)|0;c[l>>2]=c[(c[l>>2]|0)+24>>2]}if(c[l>>2]|0)uE(c[g>>2]|0,3033,0,c[j>>2]|0,c[l>>2]|0,0,161392);do if(((((c[(c[g>>2]|0)+100>>2]|0)!=0?(c[(c[g>>2]|0)+120>>2]|0)!=0:0)?(c[c[(c[(c[g>>2]|0)+120>>2]|0)+4>>2]>>2]|0)==16:0)?(c[o>>2]|0)==(c[(c[(c[g>>2]|0)+120>>2]|0)+16>>2]|0):0)?(c[n>>2]|0)==(c[(c[(c[g>>2]|0)+120>>2]|0)+20>>2]|0):0)if(c[(c[g>>2]|0)+124>>2]|0){c[p>>2]=0;l=c[g>>2]|0;m=c[j>>2]|0;AB(l,3081,m,0,163408,BB(p,c[n>>2]|0,c[o>>2]|0)|0,0);if(c[p>>2]|0){zb[c[135736>>2]&511](c[p>>2]|0);c[p>>2]=0}c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}else{m=(c[g>>2]|0)+124|0;c[m>>2]=(c[m>>2]|0)+1;c[k>>2]=cG(c[g>>2]|0,16,c[o>>2]|0,c[n>>2]|0)|0;if(c[k>>2]|0){c[(c[k>>2]|0)+20>>2]=c[j>>2];c[(c[(c[g>>2]|0)+120>>2]|0)+8>>2]=c[k>>2];break}c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}else r=35;while(0);do if((r|0)==35){c[k>>2]=cG(c[g>>2]|0,16,c[o>>2]|0,c[n>>2]|0)|0;if(c[k>>2]|0){c[(c[k>>2]|0)+20>>2]=c[j>>2];dG((c[(c[g>>2]|0)+28>>2]|0)+20|0,10,c[k>>2]|0)|0;break}c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}while(0);c[f>>2]=c[k>>2];q=c[f>>2]|0;i=e;return q|0}function pH(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;i=i+64|0;h=g+56|0;j=g+52|0;k=g+44|0;l=g+40|0;m=g+36|0;n=g+32|0;o=g+28|0;p=g+24|0;q=g+20|0;r=g+16|0;s=g+12|0;t=g+8|0;u=g+4|0;v=g;c[j>>2]=a;c[g+48>>2]=b;c[k>>2]=e;c[l>>2]=f;c[p>>2]=0;c[s>>2]=0;c[m>>2]=RC(c[j>>2]|0,c[l>>2]|0,162320)|0;do if((c[m>>2]|0)!=0?(qy(c[m>>2]|0,148184)|0)==0:0){if(qy(c[m>>2]|0,148168)|0){c[(c[k>>2]|0)+24>>2]=1;break}if(qy(c[m>>2]|0,148176)|0){c[(c[k>>2]|0)+24>>2]=2;break}else{hE(c[j>>2]|0,3037,0,c[l>>2]|0,0,162336,c[m>>2]|0,0,0,0);c[(c[k>>2]|0)+24>>2]=3;c[p>>2]=3037;break}}else w=3;while(0);if((w|0)==3)c[(c[k>>2]|0)+24>>2]=3;c[t>>2]=dE(c[l>>2]|0,162304)|0;c[n>>2]=fE(c[j>>2]|0,c[t>>2]|0)|0;a:do if((c[t>>2]|0)!=0?(qy(c[n>>2]|0,162360)|0)==0:0){if(qy(c[n>>2]|0,144400)|0){l=uH(c[j>>2]|0)|0;c[(c[k>>2]|0)+36>>2]=l;if(c[(c[k>>2]|0)+36>>2]|0){c[(c[(c[k>>2]|0)+36>>2]|0)+4>>2]=c[(c[j>>2]|0)+112>>2];break}c[h>>2]=-1;x=c[h>>2]|0;i=g;return x|0}c[v>>2]=c[n>>2];while(1){do if((d[c[v>>2]>>0]|0|0)==32)y=1;else{if(9<=(d[c[v>>2]>>0]|0|0)?(d[c[v>>2]>>0]|0|0)<=10:0){y=1;break}y=(d[c[v>>2]>>0]|0|0)==13}while(0);l=c[v>>2]|0;if(y){c[v>>2]=l+1;continue}c[u>>2]=l;while(1){if(d[c[u>>2]>>0]|0){do if((d[c[u>>2]>>0]|0|0)==32)z=1;else{if(9<=(d[c[u>>2]>>0]|0|0)?(d[c[u>>2]>>0]|0|0)<=10:0){z=1;break}z=(d[c[u>>2]>>0]|0|0)==13}while(0);A=z^1}else A=0;B=c[u>>2]|0;if(!A)break;c[u>>2]=B+1}if((B|0)==(c[v>>2]|0))break a;c[q>>2]=ly(c[v>>2]|0,(c[u>>2]|0)-(c[v>>2]|0)|0)|0;if((qy(c[q>>2]|0,144400)|0)==0?(qy(c[q>>2]|0,162360)|0)==0:0){do if(!(qy(c[q>>2]|0,162448)|0))if(qy(c[q>>2]|0,162472)|0){c[o>>2]=0;break}else{l=c[j>>2]|0;m=c[t>>2]|0;f=c[q>>2]|0;DF(l,0,m,f,IH(29)|0)|0;c[o>>2]=AP(c[(c[j>>2]|0)+80>>2]|0,c[q>>2]|0,-1)|0;break}else c[o>>2]=c[(c[j>>2]|0)+112>>2];while(0);c[r>>2]=c[(c[k>>2]|0)+32>>2];while(1){if(!(c[r>>2]|0))break;if((c[o>>2]|0)==(c[(c[r>>2]|0)+4>>2]|0))break;c[r>>2]=c[c[r>>2]>>2]}if(!(c[r>>2]|0)){c[r>>2]=uH(c[j>>2]|0)|0;if(!(c[r>>2]|0))break;c[(c[r>>2]|0)+4>>2]=c[o>>2];c[c[r>>2]>>2]=0;if(c[(c[k>>2]|0)+32>>2]|0){if(c[s>>2]|0)c[c[s>>2]>>2]=c[r>>2]}else c[(c[k>>2]|0)+32>>2]=c[r>>2];c[s>>2]=c[r>>2]}}else{hE(c[j>>2]|0,1792,0,c[t>>2]|0,0,162368,c[q>>2]|0,0,0,0);c[p>>2]=1792}zb[c[135736>>2]&511](c[q>>2]|0);c[v>>2]=c[u>>2];if(!(d[c[v>>2]>>0]|0))break a}zb[c[135736>>2]&511](c[q>>2]|0);c[h>>2]=-1;x=c[h>>2]|0;i=g;return x|0}else w=11;while(0);if((w|0)==11)c[(c[k>>2]|0)+28>>2]=1;c[h>>2]=c[p>>2];x=c[h>>2]|0;i=g;return x|0}function qH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;n=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[l>>2]=0;if((c[g>>2]|0)==0|(c[h>>2]|0)==0|(c[j>>2]|0)==0){c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}c[k>>2]=SA()|0;if(!(c[k>>2]|0)){tC(c[g>>2]|0,166944,c[j>>2]|0);c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}c[(c[k>>2]|0)+20>>2]=c[j>>2];c[m>>2]=RC(c[g>>2]|0,c[j>>2]|0,166968)|0;if(!(c[m>>2]|0)){lG(c[g>>2]|0,c[j>>2]|0,c[l>>2]|0,1708,166976,c[(c[j>>2]|0)+8>>2]|0,0);UA(c[k>>2]|0);c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}if((((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[j>>2]|0)+8>>2]|0,157848)|0)!=0:0)?(qy(c[(c[(c[j>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0)c[c[k>>2]>>2]=1e3;else p=12;do if((p|0)==12){if((((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[j>>2]|0)+8>>2]|0,157832)|0)!=0:0)?(qy(c[(c[(c[j>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){c[c[k>>2]>>2]=1001;break}if((((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[j>>2]|0)+8>>2]|0,157816)|0)!=0:0)?(qy(c[(c[(c[j>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){c[c[k>>2]>>2]=1002;break}if((((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[j>>2]|0)+8>>2]|0,157800)|0)!=0:0)?(qy(c[(c[(c[j>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){c[c[k>>2]>>2]=1003;break}if((((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[j>>2]|0)+8>>2]|0,157936)|0)!=0:0)?(qy(c[(c[(c[j>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){c[c[k>>2]>>2]=1004;break}if((((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[j>>2]|0)+8>>2]|0,157952)|0)!=0:0)?(qy(c[(c[(c[j>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){c[c[k>>2]>>2]=1005;break}if((((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[j>>2]|0)+8>>2]|0,157792)|0)!=0:0)?(qy(c[(c[(c[j>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){c[c[k>>2]>>2]=1006;break}if((((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[j>>2]|0)+8>>2]|0,157880)|0)!=0:0)?(qy(c[(c[(c[j>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){c[c[k>>2]>>2]=1007;break}if((((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[j>>2]|0)+8>>2]|0,157864)|0)!=0:0)?(qy(c[(c[(c[j>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){c[c[k>>2]>>2]=1008;break}if((((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[j>>2]|0)+8>>2]|0,157896)|0)!=0:0)?(qy(c[(c[(c[j>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){c[c[k>>2]>>2]=1009;break}if((((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[j>>2]|0)+8>>2]|0,157904)|0)!=0:0)?(qy(c[(c[(c[j>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){c[c[k>>2]>>2]=1010;break}if((((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[j>>2]|0)+8>>2]|0,157920)|0)!=0:0)?(qy(c[(c[(c[j>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){c[c[k>>2]>>2]=1011;break}lG(c[g>>2]|0,c[j>>2]|0,c[l>>2]|0,1741,167e3,c[(c[j>>2]|0)+8>>2]|0,0);UA(c[k>>2]|0);c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}while(0);cE(c[g>>2]|0,c[j>>2]|0,161384)|0;c[(c[k>>2]|0)+8>>2]=c[m>>2];if((((c[c[k>>2]>>2]|0)!=1006?(c[c[k>>2]>>2]|0)!=1007:0)?(c[n>>2]=RC(c[g>>2]|0,c[j>>2]|0,159120)|0,(c[n>>2]|0)!=0):0)?(qy(c[n>>2]|0,165504)|0)!=0:0)c[(c[k>>2]|0)+24>>2]=1;c[l>>2]=c[(c[j>>2]|0)+12>>2];if((((c[l>>2]|0)!=0?(c[(c[l>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[l>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(qy(c[(c[(c[l>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){n=jE(c[g>>2]|0,c[l>>2]|0,1)|0;c[(c[k>>2]|0)+16>>2]=n;c[l>>2]=c[(c[l>>2]|0)+24>>2]}if(c[l>>2]|0)lG(c[g>>2]|0,c[j>>2]|0,c[l>>2]|0,1740,167024,c[(c[j>>2]|0)+8>>2]|0,0);c[f>>2]=c[k>>2];o=c[f>>2]|0;i=e;return o|0}function rH(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=i;i=i+48|0;k=j+44|0;l=j+40|0;m=j+36|0;n=j+32|0;o=j+28|0;p=j+24|0;q=j+20|0;r=j+16|0;s=j+12|0;t=j+8|0;u=j+4|0;v=j;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;c[r>>2]=h;c[c[q>>2]>>2]=0;c[c[r>>2]>>2]=0;c[v>>2]=Fh(c[p>>2]|0,1)|0;if((c[v>>2]|0)>0){h=c[l>>2]|0;g=c[n>>2]|0;f=c[o>>2]|0;e=IH(21)|0;hE(h,3037,g,f,e,0,c[p>>2]|0,0,0,0);c[c[r>>2]>>2]=c[p>>2];c[k>>2]=c[(c[l>>2]|0)+16>>2];w=c[k>>2]|0;i=j;return w|0}if((c[v>>2]|0)<0){c[k>>2]=-1;w=c[k>>2]|0;i=j;return w|0}if(eT(c[p>>2]|0,58)|0){v=Dh(c[p>>2]|0,u)|0;c[c[r>>2]>>2]=v;v=AP(c[(c[l>>2]|0)+80>>2]|0,c[c[r>>2]>>2]|0,-1)|0;c[c[r>>2]>>2]=v;c[s>>2]=AP(c[(c[l>>2]|0)+80>>2]|0,c[p>>2]|0,c[u>>2]|0)|0;c[t>>2]=cj(c[(c[o>>2]|0)+32>>2]|0,c[(c[o>>2]|0)+20>>2]|0,c[s>>2]|0)|0;s=c[l>>2]|0;if(!(c[t>>2]|0)){u=c[n>>2]|0;n=c[o>>2]|0;v=IH(21)|0;hE(s,3037,u,n,v,0,c[p>>2]|0,162952,c[p>>2]|0,0);c[k>>2]=c[(c[l>>2]|0)+16>>2];w=c[k>>2]|0;i=j;return w|0}else{v=AP(c[s+80>>2]|0,c[(c[t>>2]|0)+8>>2]|0,-1)|0;c[c[q>>2]>>2]=v;c[k>>2]=0;w=c[k>>2]|0;i=j;return w|0}}c[t>>2]=cj(c[(c[o>>2]|0)+32>>2]|0,c[(c[o>>2]|0)+20>>2]|0,0)|0;if(!(c[t>>2]|0)){if(c[(c[m>>2]|0)+24>>2]&512)c[c[q>>2]>>2]=c[(c[l>>2]|0)+112>>2]}else{m=AP(c[(c[l>>2]|0)+80>>2]|0,c[(c[t>>2]|0)+8>>2]|0,-1)|0;c[c[q>>2]>>2]=m}m=AP(c[(c[l>>2]|0)+80>>2]|0,c[p>>2]|0,-1)|0;c[c[r>>2]>>2]=m;c[k>>2]=0;w=c[k>>2]|0;i=j;return w|0}function sH(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+32|0;j=h+28|0;k=h+24|0;l=h+20|0;m=h+16|0;n=h+12|0;o=h+8|0;p=h+4|0;q=h;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=0;if((c[k>>2]|0)==0|(c[l>>2]|0)==0|(c[m>>2]|0)==0){c[j>>2]=0;r=c[j>>2]|0;i=h;return r|0}c[q>>2]=Cb[c[135744>>2]&511](40)|0;if(!(c[q>>2]|0)){tC(c[k>>2]|0,165384,0);c[j>>2]=0;r=c[j>>2]|0;i=h;return r|0}l=(c[q>>2]|0)+0|0;g=l+40|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(g|0));c[(c[q>>2]|0)+20>>2]=c[n>>2];c[(c[q>>2]|0)+16>>2]=c[m>>2];c[c[q>>2]>>2]=c[o>>2];c[(c[q>>2]|0)+12>>2]=c[p>>2];dG((c[(c[(c[k>>2]|0)+28>>2]|0)+16>>2]|0)+44|0,5,c[q>>2]|0)|0;if((c[o>>2]|0)==24)dG((c[(c[k>>2]|0)+28>>2]|0)+20|0,10,c[q>>2]|0)|0;c[j>>2]=c[q>>2];r=c[j>>2]|0;i=h;return r|0}function tH(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f+28|0;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f+4|0;o=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[n>>2]=0;c[o>>2]=c[(c[k>>2]|0)+44>>2];while(1){if(!(c[o>>2]|0))break;e=c[o>>2]|0;if(!(c[(c[o>>2]|0)+36>>2]|0)){if((qy(c[e+8>>2]|0,161384)|0)==0?(qy(c[(c[o>>2]|0)+8>>2]|0,164904)|0)==0:0)GF(c[h>>2]|0,3035,0,c[o>>2]|0)}else if(qy(c[(c[e+36>>2]|0)+8>>2]|0,c[38526]|0)|0)GF(c[h>>2]|0,3035,0,c[o>>2]|0);c[o>>2]=c[(c[o>>2]|0)+24>>2]}c[m>>2]=Cb[c[135744>>2]&511](20)|0;if(!(c[m>>2]|0)){tC(c[h>>2]|0,164912,0);c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}e=c[m>>2]|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[o>>2]=dE(c[k>>2]|0,164904)|0;e=c[h>>2]|0;if(c[o>>2]|0){d=fE(e,c[o>>2]|0)|0;c[(c[m>>2]|0)+12>>2]=d;if((DH(c[h>>2]|0,c[j>>2]|0,c[m>>2]|0,c[o>>2]|0,c[l>>2]|0)|0)==-1)PC(c[h>>2]|0,c[o>>2]|0,3069,164976,0,0)}else MF(e,3036,0,c[k>>2]|0,161352,0);cE(c[h>>2]|0,c[k>>2]|0,161384)|0;c[n>>2]=c[(c[k>>2]|0)+12>>2];if((((c[n>>2]|0)!=0?(c[(c[n>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[n>>2]|0)+8>>2]|0,160992)|0)!=0:0)?(qy(c[(c[(c[n>>2]|0)+36>>2]|0)+8>>2]|0,c[38526]|0)|0)!=0:0){e=c[j>>2]|0;kH(e,jE(c[h>>2]|0,c[n>>2]|0,1)|0)|0;c[n>>2]=c[(c[n>>2]|0)+24>>2]}if(c[n>>2]|0)uE(c[h>>2]|0,3033,0,c[k>>2]|0,c[n>>2]|0,0,161392);c[g>>2]=c[m>>2];p=c[g>>2]|0;i=f;return p|0}function uH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](8)|0;if(!(c[f>>2]|0)){tC(c[e>>2]|0,152760,0);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{c[(c[f>>2]|0)+4>>2]=0;c[c[f>>2]>>2]=0;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function vH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+32|0;d=b+24|0;e=b+20|0;f=b+16|0;g=b+12|0;h=b+8|0;j=b+4|0;k=b;c[e>>2]=a;if((c[(c[e>>2]|0)+12>>2]|0)!=0?(c[(c[e>>2]|0)+16>>2]|0)!=0:0){if((c[c[(c[e>>2]|0)+12>>2]>>2]|0)!=7){c[j>>2]=0;c[k>>2]=c[(c[(c[e>>2]|0)+12>>2]|0)+12>>2];if(!(c[k>>2]|0)){c[d>>2]=0;l=c[d>>2]|0;i=b;return l|0}do{if((c[c[(c[k>>2]|0)+12>>2]>>2]|0)!=14?(c[c[(c[k>>2]|0)+12>>2]>>2]|0)!=2:0){a=vH(c[k>>2]|0)|0;c[j>>2]=(c[j>>2]|0)+a}else c[j>>2]=(c[j>>2]|0)+(c[(c[k>>2]|0)+16>>2]|0);c[k>>2]=c[(c[k>>2]|0)+8>>2]}while((c[k>>2]|0)!=0);c[d>>2]=ca(c[(c[e>>2]|0)+16>>2]|0,c[j>>2]|0)|0;l=c[d>>2]|0;i=b;return l|0}c[f>>2]=-1;c[h>>2]=c[(c[(c[e>>2]|0)+12>>2]|0)+12>>2];if(!(c[h>>2]|0)){c[d>>2]=0;l=c[d>>2]|0;i=b;return l|0}while(1){if(!(c[h>>2]|0)){m=17;break}if((c[c[(c[h>>2]|0)+12>>2]>>2]|0)!=14?(c[c[(c[h>>2]|0)+12>>2]>>2]|0)!=2:0)c[g>>2]=vH(c[h>>2]|0)|0;else c[g>>2]=c[(c[h>>2]|0)+16>>2];if(!(c[g>>2]|0)){m=13;break}if((c[f>>2]|0)==-1?1:(c[f>>2]|0)>(c[g>>2]|0))c[f>>2]=c[g>>2];c[h>>2]=c[(c[h>>2]|0)+8>>2]}if((m|0)==13){c[d>>2]=0;l=c[d>>2]|0;i=b;return l|0}else if((m|0)==17){c[d>>2]=ca(c[(c[e>>2]|0)+16>>2]|0,c[f>>2]|0)|0;l=c[d>>2]|0;i=b;return l|0}}c[d>>2]=0;l=c[d>>2]|0;i=b;return l|0}function wH(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=EH(c[j>>2]|0,c[k>>2]|0)|0;if(c[m>>2]|0){c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}if(!((c[l>>2]&2|0)!=0?(c[(c[j>>2]|0)+48>>2]&2|0)!=0:0))o=4;do if((o|0)==4){if((c[l>>2]&1|0)!=0?(c[(c[j>>2]|0)+48>>2]&4|0)!=0:0)break;if((c[(c[j>>2]|0)+64>>2]|0)==(c[k>>2]|0)){c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}if((c[c[(c[j>>2]|0)+64>>2]>>2]|0)==1?(c[(c[(c[j>>2]|0)+64>>2]|0)+88>>2]|0)==45:0){c[g>>2]=1;n=c[g>>2]|0;i=f;return n|0}if((c[c[(c[j>>2]|0)+64>>2]>>2]|0)!=5?(c[(c[(c[j>>2]|0)+64>>2]|0)+88>>2]|0)!=45:0){c[g>>2]=xG(c[h>>2]|0,c[(c[j>>2]|0)+64>>2]|0,c[k>>2]|0,c[l>>2]|0)|0;n=c[g>>2]|0;i=f;return n|0}c[g>>2]=wH(c[h>>2]|0,c[(c[j>>2]|0)+64>>2]|0,c[k>>2]|0,c[l>>2]|0)|0;n=c[g>>2]|0;i=f;return n|0}while(0);c[g>>2]=1;n=c[g>>2]|0;i=f;return n|0}function xH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if(!(c[(c[(c[f>>2]|0)+28>>2]|0)+24>>2]|0)){c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}else{c[e>>2]=Tj(c[(c[(c[f>>2]|0)+28>>2]|0)+24>>2]|0,c[(c[g>>2]|0)+8>>2]|0,c[(c[g>>2]|0)+52>>2]|0)|0;
h=c[e>>2]|0;i=d;return h|0}return 0}function yH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if((c[(c[(c[f>>2]|0)+28>>2]|0)+24>>2]|0)==0?(b=Jj(10,c[(c[f>>2]|0)+80>>2]|0)|0,c[(c[(c[f>>2]|0)+28>>2]|0)+24>>2]=b,(c[(c[(c[f>>2]|0)+28>>2]|0)+24>>2]|0)==0):0){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}c[h>>2]=Cb[c[135744>>2]&511](8)|0;if(!(c[h>>2]|0)){tC(0,158408,0);c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}b=c[h>>2]|0;c[b+0>>2]=0;c[b+4>>2]=0;c[c[h>>2]>>2]=c[g>>2];b=JB()|0;c[(c[h>>2]|0)+4>>2]=b;if(!(c[(c[h>>2]|0)+4>>2]|0)){uC(c[h>>2]|0);c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}if(Nj(c[(c[(c[f>>2]|0)+28>>2]|0)+24>>2]|0,c[(c[g>>2]|0)+8>>2]|0,c[(c[g>>2]|0)+52>>2]|0,c[h>>2]|0)|0){xB(c[f>>2]|0,158456,158480);uC(c[h>>2]|0);c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}else{c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}return 0}function zH(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f+28|0;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f+4|0;o=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=0;if((c[k>>2]|0)==0|(c[l>>2]|0)==0){c[g>>2]=-1;p=c[g>>2]|0;i=f;return p|0}c[c[k>>2]>>2]=0;c[c[l>>2]>>2]=0;c[m>>2]=Fh(c[j>>2]|0,1)|0;if((c[m>>2]|0)==-1){c[g>>2]=-1;p=c[g>>2]|0;i=f;return p|0}if((c[m>>2]|0)>0){m=c[h>>2]|0;e=c[j>>2]|0;DC(m,1824,0,e,IH(21)|0,1);c[g>>2]=1;p=c[g>>2]|0;i=f;return p|0}c[n>>2]=0;c[n>>2]=Ch(c[j>>2]|0,o)|0;e=c[(c[h>>2]|0)+156>>2]|0;if(!(c[n>>2]|0)){m=AP(e,c[j>>2]|0,-1)|0;c[c[l>>2]>>2]=m}else{m=AP(e,c[n>>2]|0,-1)|0;c[c[l>>2]>>2]=m;zb[c[135736>>2]&511](c[n>>2]|0)}n=RD(c[h>>2]|0,c[o>>2]|0)|0;c[c[k>>2]>>2]=n;if((c[o>>2]|0)!=0?(zb[c[135736>>2]&511](c[o>>2]|0),(c[c[k>>2]>>2]|0)==0):0){k=c[h>>2]|0;h=IH(21)|0;AB(k,1824,0,h,154112,c[j>>2]|0,0);c[g>>2]=2;p=c[g>>2]|0;i=f;return p|0}c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}function AH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(c[j>>2]|0){d=c[g>>2]|0;b=c[j>>2]|0;if(c[(c[j>>2]|0)+36>>2]|0){c[f>>2]=BB(d,c[(c[b+36>>2]|0)+8>>2]|0,c[(c[j>>2]|0)+8>>2]|0)|0;k=c[f>>2]|0;i=e;return k|0}else{c[f>>2]=BB(d,0,c[b+8>>2]|0)|0;k=c[f>>2]|0;i=e;return k|0}}else if(c[h>>2]|0){c[f>>2]=BB(c[g>>2]|0,c[(c[h>>2]|0)+16>>2]|0,c[(c[h>>2]|0)+12>>2]|0)|0;k=c[f>>2]|0;i=e;return k|0}else{c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}return 0}function BH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;if(!(c[f>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}c[h>>2]=Cb[c[135744>>2]&511](36)|0;if(!(c[h>>2]|0)){tC(c[f>>2]|0,164272,0);c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}else{b=(c[h>>2]|0)+0|0;a=b+36|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(a|0));c[c[h>>2]>>2]=26;c[(c[h>>2]|0)+20>>2]=c[g>>2];dG((c[(c[(c[f>>2]|0)+28>>2]|0)+16>>2]|0)+48|0,10,c[h>>2]|0)|0;c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}return 0}function CH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](20)|0;if(!(c[f>>2]|0)){tC(c[e>>2]|0,164232,0);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{a=c[f>>2]|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[c[f>>2]>>2]=2001;dG((c[(c[(c[e>>2]|0)+28>>2]|0)+16>>2]|0)+48|0,10,c[f>>2]|0)|0;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function DH(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+48|0;h=g+40|0;j=g+36|0;k=g+32|0;l=g+28|0;m=g+24|0;n=g+20|0;o=g+16|0;p=g+12|0;q=g+8|0;r=g+4|0;s=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;if(!(c[l>>2]|0)){PC(c[j>>2]|0,c[(c[k>>2]|0)+12>>2]|0,3069,165168,0,0);c[h>>2]=-1;t=c[h>>2]|0;i=g;return t|0}if(!(c[m>>2]|0))c[o>>2]=c[(c[k>>2]|0)+12>>2];else c[o>>2]=c[m>>2];if(!(c[(c[l>>2]|0)+12>>2]|0)){GE(c[j>>2]|0,3037,0,c[o>>2]|0,165248,0);c[h>>2]=3037;t=c[h>>2]|0;i=g;return t|0}c[p>>2]=0;c[q>>2]=0;if(!(c[m>>2]|0))c[q>>2]=0;else c[q>>2]=bj(c[(c[m>>2]|0)+32>>2]|0,c[(c[m>>2]|0)+20>>2]|0)|0;if(c[q>>2]|0){c[s>>2]=0;c[r>>2]=0;while(1){if(!(c[(c[q>>2]|0)+(c[r>>2]<<2)>>2]|0))break;c[s>>2]=(c[s>>2]|0)+1;c[r>>2]=(c[r>>2]|0)+1}c[p>>2]=Cb[c[135744>>2]&511]((c[s>>2]<<1)+1<<2)|0;if(!(c[p>>2]|0)){tC(c[j>>2]|0,165304,0);zb[c[135736>>2]&511](c[q>>2]|0);c[h>>2]=-1;t=c[h>>2]|0;i=g;return t|0}c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[s>>2]|0))break;c[(c[p>>2]|0)+(c[r>>2]<<1<<2)>>2]=c[(c[(c[q>>2]|0)+(c[r>>2]<<2)>>2]|0)+8>>2];c[(c[p>>2]|0)+((c[r>>2]<<1)+1<<2)>>2]=c[(c[(c[q>>2]|0)+(c[r>>2]<<2)>>2]|0)+12>>2];c[r>>2]=(c[r>>2]|0)+1}c[(c[p>>2]|0)+(c[s>>2]<<1<<2)>>2]=0;zb[c[135736>>2]&511](c[q>>2]|0)}q=c[(c[l>>2]|0)+12>>2]|0;s=c[p>>2]|0;if(c[n>>2]|0){n=MQ(q,0,4,s)|0;c[(c[l>>2]|0)+16>>2]=n}else{n=MQ(q,0,2,s)|0;c[(c[l>>2]|0)+16>>2]=n}if(c[p>>2]|0)zb[c[135736>>2]&511](c[p>>2]|0);if(!(c[(c[l>>2]|0)+16>>2]|0)){GE(c[j>>2]|0,3037,0,c[o>>2]|0,165336,c[(c[l>>2]|0)+12>>2]|0);c[h>>2]=3037;t=c[h>>2]|0;i=g;return t|0}else{c[h>>2]=0;t=c[h>>2]|0;i=g;return t|0}return 0}function EH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}else{c[e>>2]=(c[f>>2]|0)==(c[g>>2]|0)&1;h=c[e>>2]|0;i=d;return h|0}return 0}function FH(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+8|0;d=a+4|0;e=a;if(c[42590]|0){i=a;return}c[42592]=Ij(40)|0;c[42596]=eI(170376,45,0)|0;c[(c[42596]|0)+64>>2]=c[42596];c[(c[42596]|0)+52>>2]=3;c[(c[42596]|0)+52>>2]=3;c[b>>2]=fI()|0;if(!(c[b>>2]|0)){i=a;return}c[(c[42596]|0)+28>>2]=c[b>>2];c[d>>2]=Cb[c[135744>>2]&511](20)|0;if(!(c[d>>2]|0)){gI(0,170392);i=a;return}f=c[d>>2]|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[c[d>>2]>>2]=6;c[(c[b>>2]|0)+12>>2]=c[d>>2];c[b>>2]=fI()|0;if(!(c[b>>2]|0)){i=a;return}c[(c[b>>2]|0)+16>>2]=0;c[(c[b>>2]|0)+20>>2]=1073741824;c[(c[d>>2]|0)+12>>2]=c[b>>2];c[e>>2]=Cb[c[135744>>2]&511](44)|0;if(!(c[e>>2]|0)){gI(0,170432);i=a;return}d=(c[e>>2]|0)+0|0;f=d+44|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(f|0));c[c[e>>2]>>2]=2;c[(c[e>>2]|0)+28>>2]=1;c[(c[e>>2]|0)+24>>2]=2;c[(c[b>>2]|0)+12>>2]=c[e>>2];c[e>>2]=Cb[c[135744>>2]&511](44)|0;if(!(c[e>>2]|0)){gI(0,170464);i=a;return}else{d=(c[e>>2]|0)+0|0;f=d+44|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(f|0));c[(c[e>>2]|0)+28>>2]=1;c[(c[e>>2]|0)+24>>2]=2;c[(c[42596]|0)+84>>2]=c[e>>2];c[42634]=eI(170520,46,c[42596]|0)|0;c[42638]=eI(170544,1,c[42634]|0)|0;c[42642]=eI(170560,3,c[42634]|0)|0;c[42646]=eI(170576,10,c[42634]|0)|0;c[42652]=eI(170592,11,c[42634]|0)|0;c[42656]=eI(170616,4,c[42634]|0)|0;c[42660]=eI(170632,8,c[42634]|0)|0;c[42666]=eI(170648,9,c[42634]|0)|0;c[42670]=eI(170672,6,c[42634]|0)|0;c[42676]=eI(170688,7,c[42634]|0)|0;c[42680]=eI(170712,5,c[42634]|0)|0;c[42686]=eI(170728,12,c[42634]|0)|0;c[42690]=eI(170752,13,c[42634]|0)|0;c[42694]=eI(170768,14,c[42634]|0)|0;c[42698]=eI(170784,15,c[42634]|0)|0;c[42702]=eI(170800,29,c[42634]|0)|0;c[42708]=eI(170816,43,c[42634]|0)|0;c[42714]=eI(170840,44,c[42634]|0)|0;c[42720]=eI(170864,28,c[42634]|0)|0;c[42724]=eI(170888,21,c[42634]|0)|0;c[42728]=eI(170904,30,c[42642]|0)|0;c[42736]=eI(170920,31,c[42728]|0)|0;c[42742]=eI(170952,32,c[42736]|0)|0;c[42746]=eI(170976,37,c[42728]|0)|0;c[42750]=eI(170992,35,c[42746]|0)|0;c[42754]=eI(171008,39,c[42750]|0)|0;c[42758]=eI(171024,41,c[42754]|0)|0;c[42766]=eI(171040,33,c[42728]|0)|0;c[42772]=eI(171072,38,c[42766]|0)|0;c[42778]=eI(171096,36,c[42772]|0)|0;c[42784]=eI(171120,40,c[42778]|0)|0;c[42790]=eI(171144,42,c[42784]|0)|0;c[42796]=eI(171168,34,c[42766]|0)|0;c[42804]=eI(171192,2,c[42638]|0)|0;c[42808]=eI(171224,16,c[42804]|0)|0;c[42814]=eI(171240,17,c[42808]|0)|0;c[42818]=eI(171264,20,c[42808]|0)|0;c[42822]=eI(171280,18,c[42808]|0)|0;c[42826]=eI(171296,22,c[42818]|0)|0;c[42830]=eI(171312,23,c[42826]|0)|0;c[42834]=eI(171328,24,c[42826]|0)|0;c[42838]=eI(171344,26,c[42826]|0)|0;c[42844]=eI(171360,27,c[42634]|0)|0;c[(c[42844]|0)+28>>2]=c[42838];c[42848]=eI(171384,25,c[42634]|0)|0;c[(c[42848]|0)+28>>2]=c[42834];c[42854]=eI(171400,19,c[42634]|0)|0;c[(c[42854]|0)+28>>2]=c[42822];c[42590]=1;i=a;return}}function GH(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(c[42590]|0)){i=a;return}TA(c[(c[42596]|0)+84>>2]|0);c[b>>2]=c[(c[42596]|0)+28>>2];TA(c[(c[(c[(c[b>>2]|0)+12>>2]|0)+12>>2]|0)+12>>2]|0);zb[c[135736>>2]&511](c[(c[(c[b>>2]|0)+12>>2]|0)+12>>2]|0);zb[c[135736>>2]&511](c[(c[b>>2]|0)+12>>2]|0);zb[c[135736>>2]&511](c[b>>2]|0);c[(c[42596]|0)+28>>2]=0;Kj(c[42592]|0,360);c[42590]=0;i=a;return}function HH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;a:do if(!(c[f>>2]|0))c[e>>2]=-1;else{if((c[c[f>>2]>>2]|0)!=1){c[e>>2]=-1;break}switch(c[(c[f>>2]|0)+88>>2]|0){case 15:{if((c[g>>2]|0)==1006|(c[g>>2]|0)==1008){c[e>>2]=1;break a}else{c[e>>2]=0;break a}break}case 3:{if((c[g>>2]|0)==1004|(c[g>>2]|0)==1005|(c[g>>2]|0)==1006|(c[g>>2]|0)==1008|(c[g>>2]|0)==1007|(c[g>>2]|0)==1002|(c[g>>2]|0)==1003|(c[g>>2]|0)==1e3|(c[g>>2]|0)==1001){c[e>>2]=1;break a}else{c[e>>2]=0;break a}break}case 14:case 13:case 12:case 11:case 10:case 9:case 8:case 7:case 6:case 5:case 4:{if((c[g>>2]|0)==1006|(c[g>>2]|0)==1007|(c[g>>2]|0)==1008|(c[g>>2]|0)==1002|(c[g>>2]|0)==1003|(c[g>>2]|0)==1e3|(c[g>>2]|0)==1001){c[e>>2]=1;break a}else{c[e>>2]=0;break a}break}case 43:case 44:case 29:case 21:case 28:case 1:{if((c[g>>2]|0)==1009|(c[g>>2]|0)==1011|(c[g>>2]|0)==1010|(c[g>>2]|0)==1006|(c[g>>2]|0)==1007|(c[g>>2]|0)==1008){c[e>>2]=1;break a}else{c[e>>2]=0;break a}break}default:{c[e>>2]=0;break a}}}while(0);i=d;return c[e>>2]|0}function IH(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;if(!(c[42590]|0))FH();do switch(c[e>>2]|0){case 46:{c[d>>2]=c[42634];break}case 38:{c[d>>2]=c[42772];break}case 23:{c[d>>2]=c[42830];break}case 22:{c[d>>2]=c[42826];break}case 3:{c[d>>2]=c[42642];break}case 34:{c[d>>2]=c[42796];break}case 36:{c[d>>2]=c[42778];break}case 16:{c[d>>2]=c[42808];break}case 37:{c[d>>2]=c[42746];break}case 44:{c[d>>2]=c[42714];break}case 26:{c[d>>2]=c[42838];break}case 29:{c[d>>2]=c[42702];break}case 32:{c[d>>2]=c[42742];break}case 15:{c[d>>2]=c[42698];break}case 10:{c[d>>2]=c[42646];break}case 18:{c[d>>2]=c[42822];break}case 8:{c[d>>2]=c[42660];break}case 5:{c[d>>2]=c[42680];break}case 12:{c[d>>2]=c[42686];break}case 24:{c[d>>2]=c[42834];break}case 11:{c[d>>2]=c[42652];break}case 30:{c[d>>2]=c[42728];break}case 1:{c[d>>2]=c[42638];break}case 17:{c[d>>2]=c[42814];break}case 21:{c[d>>2]=c[42724];break}case 28:{c[d>>2]=c[42720];break}case 35:{c[d>>2]=c[42750];break}case 2:{c[d>>2]=c[42804];break}case 6:{c[d>>2]=c[42670];break}case 27:{c[d>>2]=c[42844];break}case 39:{c[d>>2]=c[42754];break}case 33:{c[d>>2]=c[42766];break}case 42:{c[d>>2]=c[42790];break}case 4:{c[d>>2]=c[42656];break}case 41:{c[d>>2]=c[42758];break}case 9:{c[d>>2]=c[42666];break}case 31:{c[d>>2]=c[42736];break}case 45:{c[d>>2]=c[42596];break}case 40:{c[d>>2]=c[42784];break}case 43:{c[d>>2]=c[42708];break}case 19:{c[d>>2]=c[42854];break}case 7:{c[d>>2]=c[42676];break}case 13:{c[d>>2]=c[42690];break}case 20:{c[d>>2]=c[42818];break}case 25:{c[d>>2]=c[42848];break}case 14:{c[d>>2]=c[42694];break}default:c[d>>2]=0}while(0);i=b;return c[d>>2]|0}function JH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}else{c[(c[f>>2]|0)+4>>2]=c[g>>2];c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}return 0}function KH(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;if(!(c[e>>2]|0))c[d>>2]=0;else c[d>>2]=c[(c[e>>2]|0)+4>>2];i=b;return c[d>>2]|0}function LH(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;a:do if(!(c[e>>2]|0))c[d>>2]=0;else switch(c[c[e>>2]>>2]|0){case 29:case 26:case 24:case 23:case 22:case 20:case 18:case 17:case 16:case 46:case 2:case 1:{c[d>>2]=c[(c[e>>2]|0)+8>>2];break a;break}default:{c[d>>2]=0;break a}}while(0);i=b;return c[d>>2]|0}function MH(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;if((c[e>>2]|0)!=0?(c[c[e>>2]>>2]|0)==15:0){c[d>>2]=c[(c[e>>2]|0)+8>>2];f=c[d>>2]|0;i=b;return f|0}c[d>>2]=0;f=c[d>>2]|0;i=b;return f|0}function NH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=hI(28)|0;if(!(c[h>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}c[(c[h>>2]|0)+8>>2]=c[f>>2];if(c[g>>2]|0)c[(c[h>>2]|0)+12>>2]=c[g>>2];c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}function OH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=hI(21)|0;if(!(c[h>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}else{c[(c[h>>2]|0)+8>>2]=c[g>>2];c[(c[h>>2]|0)+12>>2]=c[f>>2];c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}return 0}function PH(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;while(1){if(!(c[d>>2]|0))break;switch(c[c[d>>2]>>2]|0){case 46:case 29:case 27:case 26:case 25:case 24:case 23:case 22:case 20:case 19:case 18:case 17:case 16:case 2:case 1:{if(c[(c[d>>2]|0)+8>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+8>>2]|0);break}case 21:case 28:{if(c[(c[d>>2]|0)+12>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+12>>2]|0);if(c[(c[d>>2]|0)+8>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+8>>2]|0);break}case 44:{if(c[(c[d>>2]|0)+8>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+8>>2]|0);break}case 43:{if(c[(c[d>>2]|0)+8>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+8>>2]|0);break}default:{}}c[e>>2]=c[d>>2];c[d>>2]=c[(c[d>>2]|0)+4>>2];zb[c[135736>>2]&511](c[e>>2]|0)}i=b;return}function QH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if(!(c[42590]|0))FH();if(!(c[f>>2]|0)){c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}else{c[e>>2]=Tj(c[42592]|0,c[f>>2]|0,c[g>>2]|0)|0;h=c[e>>2]|0;i=d;return h|0}return 0}function RH(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=b;c[h>>2]=c[g>>2];c[j>>2]=0;if(!(c[g>>2]|0)){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}while(1){if(((d[c[h>>2]>>0]|0|0)!=0?(d[c[h>>2]>>0]|0|0)!=13:0)?(d[c[h>>2]>>0]|0|0)!=9:0)m=(d[c[h>>2]>>0]|0|0)!=10;else m=0;n=c[h>>2]|0;if(!m)break;c[h>>2]=n+1}if(!(d[n>>0]|0)){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}c[j>>2]=my(c[g>>2]|0)|0;c[k>>2]=(c[j>>2]|0)+((c[h>>2]|0)-(c[g>>2]|0));do{if(!(((d[c[k>>2]>>0]|0|0)!=13?(d[c[k>>2]>>0]|0|0)!=9:0)?(d[c[k>>2]>>0]|0|0)!=10:0))a[c[k>>2]>>0]=32;c[k>>2]=(c[k>>2]|0)+1}while((d[c[k>>2]>>0]|0|0)!=0);c[f>>2]=c[j>>2];l=c[f>>2]|0;i=e;return l|0}function SH(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[g>>2]=b;c[h>>2]=c[g>>2];c[m>>2]=0;if(!(c[g>>2]|0)){c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}while(1){do if(d[c[h>>2]>>0]|0)if((d[c[h>>2]>>0]|0|0)==32)o=1;else{if(9<=(d[c[h>>2]>>0]|0|0)?(d[c[h>>2]>>0]|0|0)<=10:0){o=1;break}o=(d[c[h>>2]>>0]|0|0)==13}else o=0;while(0);p=c[h>>2]|0;if(!o)break;c[h>>2]=p+1}c[j>>2]=p;while(1){if(!(d[c[j>>2]>>0]|0))break;if((d[c[j>>2]>>0]|0|0)==32){if((d[(c[j>>2]|0)+1>>0]|0|0)==32){q=17;break}if(9<=(d[(c[j>>2]|0)+1>>0]|0|0)?(d[(c[j>>2]|0)+1>>0]|0|0)<=10:0){q=17;break}if((d[(c[j>>2]|0)+1>>0]|0|0)==13){q=17;break}}if((d[c[j>>2]>>0]|0|0)==10){q=21;break}if((d[c[j>>2]>>0]|0|0)==9){q=21;break}if((d[c[j>>2]>>0]|0|0)==13){q=21;break}c[j>>2]=(c[j>>2]|0)+1}if((q|0)==17)c[m>>2]=(c[j>>2]|0)-(c[h>>2]|0);else if((q|0)==21)c[m>>2]=(c[j>>2]|0)-(c[h>>2]|0);if(!(c[m>>2]|0)){c[k>>2]=c[j>>2];c[j>>2]=(c[j>>2]|0)+-1;while(1){do if((c[j>>2]|0)>>>0>(c[h>>2]|0)>>>0)if((d[c[j>>2]>>0]|0|0)==32)r=1;else{if(9<=(d[c[j>>2]>>0]|0|0)?(d[c[j>>2]>>0]|0|0)<=10:0){r=1;break}r=(d[c[j>>2]>>0]|0|0)==13}else r=0;while(0);s=c[j>>2]|0;if(!r)break;c[j>>2]=s+-1}c[j>>2]=s+1;if((c[h>>2]|0)==(c[g>>2]|0)?(c[k>>2]|0)==(c[j>>2]|0):0){c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}c[f>>2]=ly(c[h>>2]|0,(c[j>>2]|0)-(c[h>>2]|0)|0)|0;n=c[f>>2]|0;i=e;return n|0}c[h>>2]=my(c[h>>2]|0)|0;if(!(c[h>>2]|0)){c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}c[l>>2]=(c[h>>2]|0)+(c[m>>2]|0);c[j>>2]=c[l>>2];a:while(1){if(!(d[c[j>>2]>>0]|0))break;do if((d[c[j>>2]>>0]|0|0)!=32){if(9<=(d[c[j>>2]>>0]|0|0)?(d[c[j>>2]>>0]|0|0)<=10:0)break;if((d[c[j>>2]>>0]|0|0)!=13){m=c[j>>2]|0;c[j>>2]=m+1;k=a[m>>0]|0;m=c[l>>2]|0;c[l>>2]=m+1;a[m>>0]=k;continue a}}while(0);c[j>>2]=(c[j>>2]|0)+1;while(1){do if((d[c[j>>2]>>0]|0|0)==32)t=1;else{if(9<=(d[c[j>>2]>>0]|0|0)?(d[c[j>>2]>>0]|0|0)<=10:0){t=1;break}t=(d[c[j>>2]>>0]|0|0)==13}while(0);u=c[j>>2]|0;if(!t)break;c[j>>2]=u+1}if(!(d[u>>0]|0))continue;k=c[l>>2]|0;c[l>>2]=k+1;a[k>>0]=32}a[c[l>>2]>>0]=0;c[f>>2]=c[h>>2];n=c[f>>2]|0;i=e;return n|0}function TH(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;e=iI(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,0,0,1,1,0)|0;i=f;return e|0}function UH(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;e=iI(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,1,0,1,0,1)|0;i=f;return e|0}function VH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=TH(c[f>>2]|0,c[g>>2]|0,c[h>>2]|0,0)|0;i=e;return d|0}function WH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+32|0;d=b+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[e>>2]=a;c[f>>2]=0;c[g>>2]=0;a:while(1){if(!(c[e>>2]|0)){j=20;break}switch(c[c[e>>2]>>2]|0){case 43:{c[h>>2]=jI(c[e>>2]|0)|0;if(c[(c[e>>2]|0)+8>>2]|0){a=my(c[(c[e>>2]|0)+8>>2]|0)|0;c[(c[h>>2]|0)+8>>2]=a}break}case 29:case 18:case 26:case 24:case 23:case 22:case 20:case 17:case 16:case 2:case 1:case 46:{c[h>>2]=jI(c[e>>2]|0)|0;if(c[(c[e>>2]|0)+8>>2]|0){a=my(c[(c[e>>2]|0)+8>>2]|0)|0;c[(c[h>>2]|0)+8>>2]=a}break}case 19:case 27:case 25:case 45:{j=4;break a;break}case 28:case 21:{c[h>>2]=jI(c[e>>2]|0)|0;if(c[(c[e>>2]|0)+8>>2]|0){a=my(c[(c[e>>2]|0)+8>>2]|0)|0;c[(c[h>>2]|0)+8>>2]=a}if(c[(c[e>>2]|0)+12>>2]|0){a=my(c[(c[e>>2]|0)+12>>2]|0)|0;c[(c[h>>2]|0)+12>>2]=a}break}case 44:{c[h>>2]=jI(c[e>>2]|0)|0;if(c[(c[e>>2]|0)+8>>2]|0){a=my(c[(c[e>>2]|0)+8>>2]|0)|0;c[(c[h>>2]|0)+8>>2]=a}break}default:c[h>>2]=jI(c[e>>2]|0)|0}a=c[h>>2]|0;if(!(c[f>>2]|0))c[f>>2]=a;else c[(c[g>>2]|0)+4>>2]=a;c[g>>2]=c[h>>2];c[e>>2]=c[(c[e>>2]|0)+4>>2]}if((j|0)==4){PH(c[f>>2]|0);c[d>>2]=0;k=c[d>>2]|0;i=b;return k|0}else if((j|0)==20){c[d>>2]=c[f>>2];k=c[d>>2]|0;i=b;return k|0}return 0}function XH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){c[e>>2]=-2;k=c[e>>2]|0;i=d;return k|0}do if((c[c[f>>2]>>2]|0)!=1)if((c[c[f>>2]>>2]|0)==2){c[h>>2]=2;break}else{c[h>>2]=3;break}else c[h>>2]=1;while(0);do if((c[c[g>>2]>>2]|0)!=1)if((c[c[g>>2]>>2]|0)==2){c[j>>2]=2;break}else{c[j>>2]=3;break}else c[j>>2]=1;while(0);c[e>>2]=kI(c[c[f>>2]>>2]|0,c[f>>2]|0,0,c[h>>2]|0,c[c[g>>2]>>2]|0,c[g>>2]|0,0,c[j>>2]|0)|0;k=c[e>>2]|0;i=d;return k|0}function YH(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if((c[h>>2]|0)==0|(c[k>>2]|0)==0){c[g>>2]=-2;m=c[g>>2]|0;i=f;return m|0}else{c[g>>2]=kI(c[c[h>>2]>>2]|0,c[h>>2]|0,0,c[j>>2]|0,c[c[k>>2]>>2]|0,c[k>>2]|0,0,c[l>>2]|0)|0;m=c[g>>2]|0;i=f;return m|0}return 0}function ZH(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;if(!(c[e>>2]|0)){c[d>>2]=0;f=c[d>>2]|0;i=b;return f|0}else{c[d>>2]=c[(c[(c[e>>2]|0)+32>>2]|0)+8>>2];f=c[d>>2]|0;i=b;return f|0}return 0}function _H(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if(!(c[h>>2]|0)){c[g>>2]=-1;m=c[g>>2]|0;i=f;return m|0}do if((c[c[h>>2]>>2]|0)==1009){if((c[k>>2]|0)!=(c[(c[(c[h>>2]|0)+32>>2]|0)+8>>2]|0)){if(c[l>>2]|0)c[c[l>>2]>>2]=c[(c[(c[h>>2]|0)+32>>2]|0)+8>>2];c[g>>2]=1830;m=c[g>>2]|0;i=f;return m|0}}else{if((c[c[h>>2]>>2]|0)==1011){if((c[k>>2]|0)>>>0>=(c[(c[(c[h>>2]|0)+32>>2]|0)+8>>2]|0)>>>0)break;if(c[l>>2]|0)c[c[l>>2]>>2]=c[(c[(c[h>>2]|0)+32>>2]|0)+8>>2];c[g>>2]=1831;m=c[g>>2]|0;i=f;return m|0}if((c[c[h>>2]>>2]|0)!=1010){c[g>>2]=$H(0,c[h>>2]|0,c[j>>2]|0,0)|0;m=c[g>>2]|0;i=f;return m|0}if((c[k>>2]|0)>>>0>(c[(c[(c[h>>2]|0)+32>>2]|0)+8>>2]|0)>>>0){if(c[l>>2]|0)c[c[l>>2]>>2]=c[(c[(c[h>>2]|0)+32>>2]|0)+8>>2];c[g>>2]=1832;m=c[g>>2]|0;i=f;return m|0}}while(0);c[g>>2]=0;m=c[g>>2]|0;i=f;return m|0}function $H(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if(c[l>>2]|0){c[g>>2]=lI(c[j>>2]|0,0,c[c[l>>2]>>2]|0,c[k>>2]|0,c[l>>2]|0,0)|0;m=c[g>>2]|0;i=f;return m|0}if(c[h>>2]|0){c[g>>2]=lI(c[j>>2]|0,0,c[(c[h>>2]|0)+88>>2]|0,c[k>>2]|0,c[l>>2]|0,0)|0;m=c[g>>2]|0;i=f;return m|0}else{c[g>>2]=-1;m=c[g>>2]|0;i=f;return m|0}return 0}function aI(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+32|0;j=h+20|0;k=h+16|0;l=h+12|0;m=h+8|0;n=h+4|0;o=h;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;g=mI(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0)|0;i=h;return g|0}function bI(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+32|0;j=h+20|0;k=h+16|0;l=h+12|0;m=h+8|0;n=h+4|0;o=h;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;g=lI(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0)|0;i=h;return g|0}function cI(d,f){d=d|0;f=f|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,S=0,T=0,U=0,V=0,W=0;j=i;i=i+512|0;l=j+16|0;m=j+148|0;n=j+144|0;o=j+140|0;p=j+120|0;q=j+116|0;r=j+112|0;s=j+108|0;t=j+104|0;u=j+100|0;v=j+80|0;w=j+76|0;x=j+400|0;y=j+72|0;z=j+68|0;A=j+64|0;B=j+60|0;C=j+56|0;D=j+8|0;E=j;F=j+368|0;G=j+332|0;H=j+302|0;I=j+52|0;J=j+272|0;K=j+48|0;L=j+222|0;M=j+44|0;N=j+192|0;O=j+152|0;c[n>>2]=d;c[o>>2]=f;if((c[o>>2]|0)==0|(c[n>>2]|0)==0){c[m>>2]=-1;P=c[m>>2]|0;i=j;return P|0}c[c[o>>2]>>2]=0;a:do switch(c[c[n>>2]>>2]|0){case 9:{f=c[(c[n>>2]|0)+8>>2]|0;if((c[(c[n>>2]|0)+8>>2]|0)<0){d=R(f|0)|0;S=c[(c[n>>2]|0)+12>>2]&15;c[l>>2]=d;c[l+4>>2]=S;JT(G,35,171648,l)|0}else{S=c[(c[n>>2]|0)+12>>2]&15;c[l>>2]=f;c[l+4>>2]=S;JT(G,35,171664,l)|0}S=my(G)|0;c[c[o>>2]>>2]=S;break}case 8:{c[l>>2]=c[(c[n>>2]|0)+8>>2];JT(F,30,171608,l)|0;S=my(F)|0;c[c[o>>2]>>2]=S;break}case 2:{if(!(c[(c[n>>2]|0)+8>>2]|0)){S=my(171424)|0;c[c[o>>2]>>2]=S;break a}S=RH(c[(c[n>>2]|0)+8>>2]|0)|0;c[c[o>>2]>>2]=S;if(!(c[c[o>>2]>>2]|0)){S=my(c[(c[n>>2]|0)+8>>2]|0)|0;c[c[o>>2]>>2]=S}break}case 3:{if(((e[(c[n>>2]|0)+24>>1]|0)>>>8&65535|0)==1?(c[(c[n>>2]|0)+8>>2]|0)==0:0){S=my(171448)|0;c[c[o>>2]>>2]=S;break a}S=(c[n>>2]|0)+8|0;c[p+0>>2]=c[S+0>>2];c[p+4>>2]=c[S+4>>2];c[p+8>>2]=c[S+8>>2];c[p+12>>2]=c[S+12>>2];c[p+16>>2]=c[S+16>>2];c[r>>2]=0;c[q>>2]=((e[p+16>>1]|0)>>>8&65535)+2;if(b[p+16>>1]&1)c[q>>2]=(c[q>>2]|0)+1;if(!(((e[p+16>>1]|0)>>>1&127|0)!=0?((e[p+16>>1]|0)>>>1&127|0)!=((e[p+16>>1]|0)>>>8&65535|0):0))c[q>>2]=(c[q>>2]|0)+1;c[r>>2]=Cb[c[135744>>2]&511](c[q>>2]|0)|0;if(!(c[r>>2]|0)){c[m>>2]=-1;P=c[m>>2]|0;i=j;return P|0}c[s>>2]=c[r>>2];if(b[p+16>>1]&1){S=c[s>>2]|0;c[s>>2]=S+1;a[S>>0]=45}if(((e[p+16>>1]|0)>>>1&127|0)==((e[p+16>>1]|0)>>>8&65535|0)){S=c[s>>2]|0;c[s>>2]=S+1;a[S>>0]=48;S=c[s>>2]|0;c[s>>2]=S+1;a[S>>0]=46}do if(!(c[p+8>>2]|0)){S=c[s>>2]|0;f=(c[q>>2]|0)-((c[s>>2]|0)-(c[r>>2]|0))|0;if(c[p+4>>2]|0){d=c[p>>2]|0;c[l>>2]=c[p+4>>2];c[l+4>>2]=d;JT(S,f,171472,l)|0;break}else{c[l>>2]=c[p>>2];JT(S,f,171480,l)|0;break}}else{f=c[s>>2]|0;S=(c[q>>2]|0)-((c[s>>2]|0)-(c[r>>2]|0))|0;d=c[p+4>>2]|0;T=c[p>>2]|0;c[l>>2]=c[p+8>>2];c[l+4>>2]=d;c[l+8>>2]=T;JT(f,S,171456,l)|0}while(0);do if((e[p+16>>1]|0)>>>1&127){if(((e[p+16>>1]|0)>>>1&127|0)!=((e[p+16>>1]|0)>>>8&65535|0)){c[t>>2]=((e[p+16>>1]|0)>>>8&65535)-((e[p+16>>1]|0)>>>1&127);fU((c[s>>2]|0)+(c[t>>2]|0)+1|0,(c[s>>2]|0)+(c[t>>2]|0)|0,((e[p+16>>1]|0)>>>1&127)+1|0)|0;a[(c[s>>2]|0)+(c[t>>2]|0)>>0]=46;break}c[u>>2]=0;while(1){U=c[u>>2]|0;if(!(a[(c[s>>2]|0)+(c[u>>2]|0)>>0]|0))break;c[u>>2]=U+1}if(U>>>0<((e[p+16>>1]|0)>>>8&65535)>>>0){fU((c[s>>2]|0)+(((e[p+16>>1]|0)>>>8&65535)-(c[u>>2]|0))|0,c[s>>2]|0,(c[u>>2]|0)+1|0)|0;cU(c[s>>2]|0,48,((e[p+16>>1]|0)>>>8&65535)-(c[u>>2]|0)|0)|0}}else{c[s>>2]=(c[r>>2]|0)+(c[q>>2]|0)+-1;S=c[s>>2]|0;c[s>>2]=S+-1;a[S>>0]=0;S=c[s>>2]|0;c[s>>2]=S+-1;a[S>>0]=48;S=c[s>>2]|0;c[s>>2]=S+-1;a[S>>0]=46}while(0);c[c[o>>2]>>2]=c[r>>2];break}case 7:{S=Cb[c[135744>>2]&511](8)|0;c[c[o>>2]>>2]=S;if(c[c[o>>2]>>2]|0){S=c[c[o>>2]>>2]|0;f=(c[(c[n>>2]|0)+12>>2]|0)>>>4&31;c[l>>2]=c[(c[n>>2]|0)+12>>2]&15;c[l+4>>2]=f;JT(S,8,171632,l)|0;break a}c[m>>2]=-1;P=c[m>>2]|0;i=j;return P|0}case 15:{if(c[(c[n>>2]|0)+8>>2]|0){S=my(171528)|0;c[c[o>>2]>>2]=S;break a}else{S=my(171536)|0;c[c[o>>2]>>2]=S;break a}break}case 5:{S=Cb[c[135744>>2]&511](6)|0;c[c[o>>2]>>2]=S;if(c[c[o>>2]>>2]|0){S=c[c[o>>2]>>2]|0;c[l>>2]=(c[(c[n>>2]|0)+12>>2]|0)>>>4&31;JT(S,6,171624,l)|0;break a}c[m>>2]=-1;P=c[m>>2]|0;i=j;return P|0}case 42:case 40:case 38:case 36:case 35:case 39:case 41:case 37:case 33:case 32:case 31:case 34:case 30:{if(((e[(c[n>>2]|0)+24>>1]|0)>>>8&65535|0)==1?(c[(c[n>>2]|0)+8>>2]|0)==0:0){S=my(171488)|0;c[c[o>>2]>>2]=S;break a}S=(c[n>>2]|0)+8|0;c[v+0>>2]=c[S+0>>2];c[v+4>>2]=c[S+4>>2];c[v+8>>2]=c[S+8>>2];c[v+12>>2]=c[S+12>>2];c[v+16>>2]=c[S+16>>2];c[w>>2]=((e[v+16>>1]|0)>>>8&65535)+1;if(b[v+16>>1]&1)c[w>>2]=(c[w>>2]|0)+1;S=Cb[c[135744>>2]&511](c[w>>2]|0)|0;c[c[o>>2]>>2]=S;if(!(c[c[o>>2]>>2]|0)){c[m>>2]=-1;P=c[m>>2]|0;i=j;return P|0}if(c[v+8>>2]|0){S=c[c[o>>2]>>2]|0;f=c[w>>2]|0;T=c[v+8>>2]|0;d=c[v+4>>2]|0;V=c[v>>2]|0;if(b[v+16>>1]&1){c[l>>2]=T;c[l+4>>2]=d;c[l+8>>2]=V;JT(S,f,171496,l)|0;break a}else{c[l>>2]=T;c[l+4>>2]=d;c[l+8>>2]=V;JT(S,f,171456,l)|0;break a}}f=(b[v+16>>1]&1|0)!=0;S=c[c[o>>2]>>2]|0;V=c[w>>2]|0;if(c[v+4>>2]|0){d=c[v+4>>2]|0;T=c[v>>2]|0;if(f){c[l>>2]=d;c[l+4>>2]=T;JT(S,V,171512,l)|0;break a}else{c[l>>2]=d;c[l+4>>2]=T;JT(S,V,171472,l)|0;break a}}else{T=c[v>>2]|0;if(f){c[l>>2]=T;JT(S,V,171520,l)|0;break a}else{c[l>>2]=T;JT(S,V,171480,l)|0;break a}}break}case 12:{c[B>>2]=0;c[C>>2]=0;h[D>>3]=0;c[y>>2]=~~+Q(+(+(R(c[(c[n>>2]|0)+8>>2]|0)|0)/12))>>>0;V=R(c[(c[n>>2]|0)+8>>2]|0)|0;c[z>>2]=V-((c[y>>2]|0)*12|0);c[A>>2]=~~+Q(+(+R(+ +h[(c[n>>2]|0)+16>>3])/86400))>>>0;W=+R(+ +h[(c[n>>2]|0)+16>>3]);h[E>>3]=W-+(((c[A>>2]|0)*86400|0)>>>0);if(+h[E>>3]>0?(c[B>>2]=~~+Q(+(+h[E>>3]/3600))>>>0,h[E>>3]=+h[E>>3]-+(((c[B>>2]|0)*3600|0)>>>0),+h[E>>3]>0):0){c[C>>2]=~~+Q(+(+h[E>>3]/60))>>>0;h[D>>3]=+h[E>>3]-+(((c[C>>2]|0)*60|0)>>>0)}if((c[(c[n>>2]|0)+8>>2]|0)>=0?!(+h[(c[n>>2]|0)+16>>3]<0):0){V=c[z>>2]|0;S=c[A>>2]|0;T=c[B>>2]|0;f=c[C>>2]|0;W=+h[D>>3];c[l>>2]=c[y>>2];c[l+4>>2]=V;c[l+8>>2]=S;c[l+12>>2]=T;c[l+16>>2]=f;f=l+20|0;h[k>>3]=W;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];JT(x,100,171576,l)|0}else{f=c[z>>2]|0;T=c[A>>2]|0;S=c[B>>2]|0;V=c[C>>2]|0;W=+h[D>>3];c[l>>2]=c[y>>2];c[l+4>>2]=f;c[l+8>>2]=T;c[l+12>>2]=S;c[l+16>>2]=V;V=l+20|0;h[k>>3]=W;c[V>>2]=c[k>>2];c[V+4>>2]=c[k+4>>2];JT(x,100,171544,l)|0}V=my(x)|0;c[c[o>>2]>>2]=V;break}case 10:{do if(b[(c[n>>2]|0)+24>>1]&1){c[K>>2]=nI(c[n>>2]|0,0)|0;if(c[K>>2]|0){V=c[(c[K>>2]|0)+12>>2]&15;S=(c[(c[K>>2]|0)+12>>2]|0)>>>4&31;c[l>>2]=c[(c[K>>2]|0)+8>>2];c[l+4>>2]=V;c[l+8>>2]=S;JT(J,30,171728,l)|0;PH(c[K>>2]|0);break}c[m>>2]=-1;P=c[m>>2]|0;i=j;return P|0}else{S=c[(c[n>>2]|0)+12>>2]&15;V=(c[(c[n>>2]|0)+12>>2]|0)>>>4&31;c[l>>2]=c[(c[n>>2]|0)+8>>2];c[l+4>>2]=S;c[l+8>>2]=V;JT(J,30,171752,l)|0}while(0);V=my(J)|0;c[c[o>>2]>>2]=V;break}case 29:case 28:case 26:case 24:case 23:case 22:case 20:case 18:case 17:case 16:{if(!(c[(c[n>>2]|0)+8>>2]|0)){c[m>>2]=-1;P=c[m>>2]|0;i=j;return P|0}else{V=SH(c[(c[n>>2]|0)+8>>2]|0)|0;c[c[o>>2]>>2]=V;if(c[c[o>>2]>>2]|0)break a;V=my(c[(c[n>>2]|0)+8>>2]|0)|0;c[c[o>>2]>>2]=V;break a}break}case 4:{do if(b[(c[n>>2]|0)+24>>1]&1){c[I>>2]=nI(c[n>>2]|0,0)|0;if(c[I>>2]|0){V=(c[(c[I>>2]|0)+12>>2]|0)>>>14&63;W=+h[(c[I>>2]|0)+16>>3];c[l>>2]=(c[(c[I>>2]|0)+12>>2]|0)>>>9&31;c[l+4>>2]=V;V=l+8|0;h[k>>3]=W;c[V>>2]=c[k>>2];c[V+4>>2]=c[k+4>>2];JT(H,30,171680,l)|0;PH(c[I>>2]|0);break}c[m>>2]=-1;P=c[m>>2]|0;i=j;return P|0}else{V=(c[(c[n>>2]|0)+12>>2]|0)>>>14&63;W=+h[(c[n>>2]|0)+16>>3];c[l>>2]=(c[(c[n>>2]|0)+12>>2]|0)>>>9&31;c[l+4>>2]=V;V=l+8|0;h[k>>3]=W;c[V>>2]=c[k>>2];c[V+4>>2]=c[k+4>>2];JT(H,30,171704,l)|0}while(0);V=my(H)|0;c[c[o>>2]>>2]=V;break}case 6:{V=Cb[c[135744>>2]&511](6)|0;c[c[o>>2]>>2]=V;if(c[c[o>>2]>>2]|0){V=c[c[o>>2]>>2]|0;c[l>>2]=c[(c[n>>2]|0)+12>>2]&15;JT(V,6,171616,l)|0;break a}c[m>>2]=-1;P=c[m>>2]|0;i=j;return P|0}case 43:{V=my(c[(c[n>>2]|0)+8>>2]|0)|0;c[c[o>>2]>>2]=V;break}case 44:{V=my(c[(c[n>>2]|0)+8>>2]|0)|0;c[c[o>>2]>>2]=V;break}case 13:{h[k>>3]=+g[(c[n>>2]|0)+8>>2];c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];JT(N,30,171848,l)|0;V=my(N)|0;c[c[o>>2]>>2]=V;break}case 14:{h[k>>3]=+h[(c[n>>2]|0)+8>>3];c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];JT(O,40,171848,l)|0;V=my(O)|0;c[c[o>>2]>>2]=V;break}case 11:{do if(b[(c[n>>2]|0)+24>>1]&1){c[M>>2]=nI(c[n>>2]|0,0)|0;if(c[M>>2]|0){V=c[(c[M>>2]|0)+12>>2]&15;S=(c[(c[M>>2]|0)+12>>2]|0)>>>4&31;T=(c[(c[M>>2]|0)+12>>2]|0)>>>9&31;f=(c[(c[M>>2]|0)+12>>2]|0)>>>14&63;W=+h[(c[M>>2]|0)+16>>3];c[l>>2]=c[(c[M>>2]|0)+8>>2];c[l+4>>2]=V;c[l+8>>2]=S;c[l+12>>2]=T;c[l+16>>2]=f;f=l+20|0;h[k>>3]=W;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];JT(L,50,171768,l)|0;PH(c[M>>2]|0);break}c[m>>2]=-1;P=c[m>>2]|0;i=j;return P|0}else{f=c[(c[n>>2]|0)+12>>2]&15;T=(c[(c[n>>2]|0)+12>>2]|0)>>>4&31;S=(c[(c[n>>2]|0)+12>>2]|0)>>>9&31;V=(c[(c[n>>2]|0)+12>>2]|0)>>>14&63;W=+h[(c[n>>2]|0)+16>>3];c[l>>2]=c[(c[n>>2]|0)+8>>2];c[l+4>>2]=f;c[l+8>>2]=T;c[l+12>>2]=S;c[l+16>>2]=V;V=l+20|0;h[k>>3]=W;c[V>>2]=c[k>>2];c[V+4>>2]=c[k+4>>2];JT(L,50,171808,l)|0}while(0);V=my(L)|0;c[c[o>>2]>>2]=V;break}case 1:{if(!(c[(c[n>>2]|0)+8>>2]|0)){V=my(171424)|0;c[c[o>>2]>>2]=V;break a}else{V=my(c[(c[n>>2]|0)+8>>2]|0)|0;c[c[o>>2]>>2]=V;break a}break}case 21:{if(c[(c[n>>2]|0)+12>>2]|0){V=my(171432)|0;c[c[o>>2]>>2]=V;V=By(c[c[o>>2]>>2]|0,c[(c[n>>2]|0)+12>>2]|0)|0;c[c[o>>2]>>2]=V;V=By(c[c[o>>2]>>2]|0,171440)|0;c[c[o>>2]>>2]=V;V=By(c[c[o>>2]>>2]|0,c[(c[n>>2]|0)+12>>2]|0)|0;c[c[o>>2]>>2]=V;break a}V=my(c[(c[n>>2]|0)+8>>2]|0)|0;c[c[o>>2]>>2]=V;c[m>>2]=0;P=c[m>>2]|0;i=j;return P|0}default:{V=my(171856)|0;c[c[o>>2]>>2]=V;c[m>>2]=1;P=c[m>>2]|0;i=j;return P|0}}while(0);if(!(c[c[o>>2]>>2]|0)){c[m>>2]=-1;P=c[m>>2]|0;i=j;return P|0}else{c[m>>2]=0;P=c[m>>2]|0;i=j;return P|0}return 0}function dI(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;if(!(c[e>>2]|0))c[d>>2]=0;else c[d>>2]=c[c[e>>2]>>2];i=b;return c[d>>2]|0}function eI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=Cb[c[135744>>2]&511](120)|0;if(!(c[k>>2]|0)){gI(0,172376);c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}d=(c[k>>2]|0)+0|0;b=d+120|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(b|0));c[(c[k>>2]|0)+8>>2]=c[g>>2];c[(c[k>>2]|0)+112>>2]=172416;c[c[k>>2]>>2]=1;c[(c[k>>2]|0)+64>>2]=c[j>>2];c[(c[k>>2]|0)+52>>2]=6;switch(c[h>>2]|0){case 28:case 21:case 44:case 43:case 29:case 15:case 14:case 13:case 12:case 5:case 7:case 6:case 9:case 8:case 4:case 11:case 10:case 3:case 1:{j=(c[k>>2]|0)+48|0;c[j>>2]=c[j>>2]|16384;break}default:{}}switch(c[h>>2]|0){case 46:case 45:break;case 27:case 19:case 25:{j=(c[k>>2]|0)+48|0;c[j>>2]=c[j>>2]|64;j=oI(1)|0;c[(c[k>>2]|0)+68>>2]=j;j=(c[k>>2]|0)+48|0;c[j>>2]=c[j>>2]|134217728;break}default:{j=(c[k>>2]|0)+48|0;c[j>>2]=c[j>>2]|256}}Nj(c[42592]|0,c[(c[k>>2]|0)+8>>2]|0,172416,c[k>>2]|0)|0;c[(c[k>>2]|0)+88>>2]=c[h>>2];c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}function fI(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=0;c[d>>2]=Cb[c[135744>>2]&511](28)|0;if(!(c[d>>2]|0)){gI(0,172344);c[b>>2]=0;e=c[b>>2]|0;i=a;return e|0}else{f=c[d>>2]|0;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=0;c[c[d>>2]>>2]=25;c[(c[d>>2]|0)+16>>2]=1;c[(c[d>>2]|0)+20>>2]=1;c[b>>2]=c[d>>2];e=c[b>>2]|0;i=a;return e|0}return 0}function gI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;ce(15,2,c[e>>2]|0,0,c[f>>2]|0);i=d;return}function hI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](32)|0;if(!(c[f>>2]|0)){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{a=c[f>>2]|0;c[a+0>>2]=0;
c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;c[a+24>>2]=0;c[a+28>>2]=0;c[c[f>>2]>>2]=c[e>>2];c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function iI(e,f,j,k,l,m,n,o,p){e=e|0;f=f|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0;q=i;i=i+352|0;r=q;s=q+316|0;t=q+312|0;u=q+308|0;v=q+304|0;w=q+300|0;x=q+296|0;y=q+292|0;z=q+288|0;A=q+284|0;B=q+280|0;C=q+276|0;D=q+272|0;E=q+268|0;F=q+264|0;G=q+260|0;H=q+256|0;I=q+252|0;J=q+248|0;K=q+244|0;L=q+240|0;M=q+320|0;N=q+236|0;O=q+232|0;P=q+228|0;Q=q+224|0;R=q+220|0;S=q+216|0;T=q+212|0;U=q+208|0;V=q+204|0;W=q+200|0;X=q+196|0;Y=q+192|0;Z=q+188|0;_=q+184|0;$=q+180|0;aa=q+176|0;ba=q+172|0;ca=q+168|0;da=q+164|0;ea=q+160|0;fa=q+156|0;ga=q+152|0;ha=q+148|0;ia=q+144|0;ja=q+140|0;ka=q+136|0;la=q+132|0;ma=q+128|0;na=q+124|0;oa=q+120|0;pa=q+116|0;qa=q+112|0;ra=q+108|0;sa=q+104|0;ta=q+100|0;ua=q+96|0;va=q+92|0;wa=q+88|0;xa=q+84|0;ya=q+80|0;za=q+76|0;Aa=q+72|0;Ba=q+68|0;Ca=q+64|0;Da=q+60|0;Ea=q+56|0;Fa=q+52|0;Ga=q+48|0;Ha=q+44|0;Ia=q+40|0;Ja=q+36|0;Ka=q+32|0;La=q+28|0;Ma=q+24|0;Na=q+20|0;Oa=q+16|0;Pa=q+12|0;Qa=q+8|0;c[t>>2]=e;c[u>>2]=f;c[v>>2]=j;c[w>>2]=k;c[x>>2]=l;c[y>>2]=m;c[z>>2]=n;c[A>>2]=o;c[B>>2]=p;c[D>>2]=0;c[E>>2]=0;if(!(c[42590]|0))FH();if(!(c[t>>2]|0)){c[s>>2]=-1;Ra=c[s>>2]|0;i=q;return Ra|0}if(!(c[u>>2]|0))c[u>>2]=171424;if(c[v>>2]|0)c[c[v>>2]>>2]=0;if((((c[x>>2]|0)==0&(c[u>>2]|0)!=0?(c[(c[t>>2]|0)+88>>2]|0)!=1:0)?(c[(c[t>>2]|0)+88>>2]|0)!=45:0)?(c[(c[t>>2]|0)+88>>2]|0)!=46:0){x=c[u>>2]|0;if((c[(c[t>>2]|0)+88>>2]|0)==2)c[D>>2]=RH(x)|0;else c[D>>2]=SH(x)|0;if(c[D>>2]|0)c[u>>2]=c[D>>2]}a:do switch(c[(c[t>>2]|0)+88>>2]|0){case 11:case 10:case 9:case 8:case 7:case 6:case 5:case 4:{c[E>>2]=qI(c[(c[t>>2]|0)+88>>2]|0,c[u>>2]|0,c[v>>2]|0,c[z>>2]|0)|0;Sa=571;break}case 14:case 13:{c[O>>2]=c[u>>2];c[P>>2]=0;c[Q>>2]=0;c[R>>2]=0;b:do if(c[z>>2]|0)while(1){do if((d[c[O>>2]>>0]|0)!=32){if(9<=(d[c[O>>2]>>0]|0)?(d[c[O>>2]>>0]|0)<=10:0)break;if((d[c[O>>2]>>0]|0)!=13)break b}while(0);c[O>>2]=(c[O>>2]|0)+1}while(0);if(((d[c[O>>2]>>0]|0)==78?(d[(c[O>>2]|0)+1>>0]|0)==97:0)?(d[(c[O>>2]|0)+2>>0]|0)==78:0){c[O>>2]=(c[O>>2]|0)+3;if(d[c[O>>2]>>0]|0){Sa=577;break a}if(!(c[v>>2]|0)){Sa=580;break a}do if((c[t>>2]|0)==(c[42690]|0)){c[C>>2]=hI(13)|0;if(c[C>>2]|0){g[(c[C>>2]|0)+8>>2]=+h[15984];break}else{PH(c[C>>2]|0);Sa=583;break a}}else{c[C>>2]=hI(14)|0;if(c[C>>2]|0){h[(c[C>>2]|0)+8>>3]=+h[15984];break}else{PH(c[C>>2]|0);Sa=583;break a}}while(0);c[c[v>>2]>>2]=c[C>>2];Sa=580;break a}if((d[c[O>>2]>>0]|0)==45){c[P>>2]=1;c[O>>2]=(c[O>>2]|0)+1}if(((d[c[O>>2]>>0]|0)==73?(d[(c[O>>2]|0)+1>>0]|0)==78:0)?(d[(c[O>>2]|0)+2>>0]|0)==70:0){c[O>>2]=(c[O>>2]|0)+3;if(d[c[O>>2]>>0]|0){Sa=577;break a}if(!(c[v>>2]|0)){Sa=580;break a}do if((c[t>>2]|0)==(c[42690]|0)){c[C>>2]=hI(13)|0;if(!(c[C>>2]|0)){PH(c[C>>2]|0);Sa=583;break a}if(c[P>>2]|0){g[(c[C>>2]|0)+8>>2]=+h[15986];break}else{g[(c[C>>2]|0)+8>>2]=+h[15985];break}}else{c[C>>2]=hI(14)|0;if(!(c[C>>2]|0)){PH(c[C>>2]|0);Sa=583;break a}if(c[P>>2]|0){h[(c[C>>2]|0)+8>>3]=+h[15986];break}else{h[(c[C>>2]|0)+8>>3]=+h[15985];break}}while(0);c[c[v>>2]>>2]=c[C>>2];Sa=580;break a}if((c[P>>2]|0)==0?(d[c[O>>2]>>0]|0)==43:0)c[O>>2]=(c[O>>2]|0)+1;if(((d[c[O>>2]>>0]|0)!=0?(d[c[O>>2]>>0]|0)!=43:0)?(d[c[O>>2]>>0]|0)!=45:0){while(1){if((d[c[O>>2]>>0]|0)>=48)Ta=(d[c[O>>2]>>0]|0)<=57;else Ta=0;Ua=c[O>>2]|0;if(!Ta)break;c[O>>2]=Ua+1;c[Q>>2]=(c[Q>>2]|0)+1}c:do if((d[Ua>>0]|0)==46){c[O>>2]=(c[O>>2]|0)+1;while(1){if((d[c[O>>2]>>0]|0)<48)break c;if((d[c[O>>2]>>0]|0)>57)break c;c[O>>2]=(c[O>>2]|0)+1;c[R>>2]=(c[R>>2]|0)+1}}while(0);if(!((c[Q>>2]|0)==0&(c[R>>2]|0)==0)){if(!((d[c[O>>2]>>0]|0)!=101?(d[c[O>>2]>>0]|0)!=69:0))Sa=168;d:do if((Sa|0)==168){c[O>>2]=(c[O>>2]|0)+1;if(!((d[c[O>>2]>>0]|0)!=45?(d[c[O>>2]>>0]|0)!=43:0))c[O>>2]=(c[O>>2]|0)+1;while(1){if((d[c[O>>2]>>0]|0)<48)break d;if((d[c[O>>2]>>0]|0)>57)break d;c[O>>2]=(c[O>>2]|0)+1}}while(0);e:do if(c[z>>2]|0)while(1){do if((d[c[O>>2]>>0]|0)!=32){if(9<=(d[c[O>>2]>>0]|0)?(d[c[O>>2]>>0]|0)<=10:0)break;if((d[c[O>>2]>>0]|0)!=13)break e}while(0);c[O>>2]=(c[O>>2]|0)+1}while(0);if(!(d[c[O>>2]>>0]|0))if(c[v>>2]|0)if((c[t>>2]|0)==(c[42690]|0)){c[C>>2]=hI(13)|0;if(!(c[C>>2]|0)){Sa=583;break a}x=c[u>>2]|0;c[r>>2]=(c[C>>2]|0)+8;p=(bT(x,172216,r)|0)==1;x=c[C>>2]|0;if(p){c[c[v>>2]>>2]=x;Sa=580;break a}else{PH(x);Sa=577;break a}}else{c[C>>2]=hI(14)|0;if(!(c[C>>2]|0)){Sa=583;break a}x=c[u>>2]|0;c[r>>2]=(c[C>>2]|0)+8;p=(bT(x,172224,r)|0)==1;x=c[C>>2]|0;if(p){c[c[v>>2]>>2]=x;Sa=580;break a}else{PH(x);Sa=577;break a}}else Sa=580;else Sa=577}else Sa=577}else Sa=577;break}case 2:{f:do if(c[z>>2]|0){if(c[A>>2]|0){x=c[u>>2]|0;if((c[y>>2]|0)==3)c[D>>2]=SH(x)|0;else c[D>>2]=RH(x)|0;if(c[D>>2]|0)c[u>>2]=c[D>>2]}}else{c[G>>2]=c[u>>2];while(1){if(!(d[c[G>>2]>>0]|0))break f;if((d[c[G>>2]>>0]|0)==13){Sa=577;break a}if((d[c[G>>2]>>0]|0)==10){Sa=577;break a}if((d[c[G>>2]>>0]|0)==9){Sa=577;break a}c[G>>2]=(c[G>>2]|0)+1}}while(0);if(c[v>>2]|0){c[C>>2]=hI(2)|0;if(c[C>>2]|0){x=my(c[u>>2]|0)|0;c[(c[C>>2]|0)+8>>2]=x;c[c[v>>2]>>2]=c[C>>2];Sa=580}else Sa=583}else Sa=580;break}case 46:case 45:{if((c[B>>2]|0)!=0&(c[v>>2]|0)!=0){c[C>>2]=hI(46)|0;if(c[C>>2]|0){x=my(c[u>>2]|0)|0;c[(c[C>>2]|0)+8>>2]=x;c[c[v>>2]>>2]=c[C>>2];Sa=580}else Sa=583}else Sa=580;break}case 3:{c[H>>2]=c[u>>2];c[N>>2]=M;if((c[H>>2]|0)!=0?(d[c[H>>2]>>0]|0)!=0:0){g:do if(c[z>>2]|0)while(1){do if((d[c[H>>2]>>0]|0)!=32){if(9<=(d[c[H>>2]>>0]|0)?(d[c[H>>2]>>0]|0)<=10:0)break;if((d[c[H>>2]>>0]|0)!=13)break g}while(0);c[H>>2]=(c[H>>2]|0)+1}while(0);c[J>>2]=0;if((d[c[H>>2]>>0]|0)!=45){if((d[c[H>>2]>>0]|0)==43)c[H>>2]=(c[H>>2]|0)+1}else{c[J>>2]=1;c[H>>2]=(c[H>>2]|0)+1}if(d[c[H>>2]>>0]|0){c[I>>2]=0;c[K>>2]=-1;c[L>>2]=0;while(1){Va=c[H>>2]|0;if((d[c[H>>2]>>0]|0)!=48)break;c[H>>2]=Va+1;c[L>>2]=1}h:do if(d[Va>>0]|0){while(1){if((d[c[H>>2]>>0]|0)<48)break;if((d[c[H>>2]>>0]|0)>57)break;x=c[H>>2]|0;c[H>>2]=x+1;p=a[x>>0]|0;x=c[N>>2]|0;c[N>>2]=x+1;a[x>>0]=p;c[I>>2]=(c[I>>2]|0)+1;if((c[I>>2]|0)>>>0>=24)break h}if((d[c[H>>2]>>0]|0)==46){c[H>>2]=(c[H>>2]|0)+1;c[K>>2]=c[I>>2];do{if((d[c[H>>2]>>0]|0)<48)break;if((d[c[H>>2]>>0]|0)>57)break;p=c[H>>2]|0;c[H>>2]=p+1;x=a[p>>0]|0;p=c[N>>2]|0;c[N>>2]=p+1;a[p>>0]=x;c[I>>2]=(c[I>>2]|0)+1}while((c[I>>2]|0)>>>0<24);if(!((c[I>>2]|0)!=0|(c[L>>2]|0)!=0)){Sa=577;break a}}}while(0);i:do if(c[z>>2]|0)while(1){do if((d[c[H>>2]>>0]|0)!=32){if(9<=(d[c[H>>2]>>0]|0)?(d[c[H>>2]>>0]|0)<=10:0)break;if((d[c[H>>2]>>0]|0)!=13)break i}while(0);c[H>>2]=(c[H>>2]|0)+1}while(0);if(!(d[c[H>>2]>>0]|0))if((c[v>>2]|0)!=0?(c[C>>2]=hI(3)|0,(c[C>>2]|0)!=0):0){if(c[I>>2]|0){j:do if((c[K>>2]|0)!=-1)while(1){if((c[I>>2]|0)==(c[K>>2]|0))break j;if((d[(c[N>>2]|0)+-1>>0]|0)!=48)break j;c[N>>2]=(c[N>>2]|0)+-1;c[I>>2]=(c[I>>2]|0)+-1}while(0);if(c[I>>2]|0){a[c[N>>2]>>0]=0;c[N>>2]=M;pI(N,(c[C>>2]|0)+8|0,(c[C>>2]|0)+12|0,(c[C>>2]|0)+16|0)|0}}x=(c[C>>2]|0)+24|0;b[x>>1]=b[x>>1]&-2|c[J>>2]&1;do if(c[I>>2]|0){x=(c[C>>2]|0)+24|0;b[x>>1]=b[x>>1]&255|(c[I>>2]&255)<<8&65535;if((c[K>>2]|0)==-1){x=(c[C>>2]|0)+24|0;b[x>>1]=b[x>>1]&-255;break}else{x=(c[C>>2]|0)+24|0;b[x>>1]=b[x>>1]&-255|((c[I>>2]|0)-(c[K>>2]|0)&127)<<1&65535;break}}else{x=(c[C>>2]|0)+24|0;b[x>>1]=b[x>>1]&255|256}while(0);c[c[v>>2]>>2]=c[C>>2];Sa=580}else Sa=580;else Sa=577}else Sa=577}else Sa=577;break}case 1:{k:do if(!(c[z>>2]|0)){c[F>>2]=c[u>>2];if((c[y>>2]|0)==2)while(1){if(!(d[c[F>>2]>>0]|0))break k;if((d[c[F>>2]>>0]|0)==13){Sa=577;break a}if((d[c[F>>2]>>0]|0)==10){Sa=577;break a}if((d[c[F>>2]>>0]|0)==9){Sa=577;break a}c[F>>2]=(c[F>>2]|0)+1}if((c[y>>2]|0)==3)while(1){if(!(d[c[F>>2]>>0]|0))break k;if((d[c[F>>2]>>0]|0)==13){Sa=577;break a}if((d[c[F>>2]>>0]|0)==10){Sa=577;break a}if((d[c[F>>2]>>0]|0)==9){Sa=577;break a}x=(d[c[F>>2]>>0]|0)==32;c[F>>2]=(c[F>>2]|0)+1;if(!x)continue;if((d[c[F>>2]>>0]|0)==32){Sa=577;break a}}}while(0);if((c[B>>2]|0)!=0&(c[v>>2]|0)!=0){if(c[A>>2]|0){if((c[y>>2]|0)!=3){if((c[y>>2]|0)==2)c[D>>2]=RH(c[u>>2]|0)|0}else c[D>>2]=SH(c[u>>2]|0)|0;if(c[D>>2]|0)c[u>>2]=c[D>>2]}c[C>>2]=hI(1)|0;if(c[C>>2]|0){x=my(c[u>>2]|0)|0;c[(c[C>>2]|0)+8>>2]=x;c[c[v>>2]>>2]=c[C>>2];Sa=580}else Sa=583}else Sa=580;break}case 12:{c[E>>2]=rI(c[t>>2]|0,c[u>>2]|0,c[v>>2]|0,c[z>>2]|0)|0;Sa=571;break}case 15:{c[S>>2]=c[u>>2];do if(c[z>>2]|0){while(1){do if((d[c[S>>2]>>0]|0)==32)Wa=1;else{if(9<=(d[c[S>>2]>>0]|0)?(d[c[S>>2]>>0]|0)<=10:0){Wa=1;break}Wa=(d[c[S>>2]>>0]|0)==13}while(0);Xa=c[S>>2]|0;if(!Wa)break;c[S>>2]=Xa+1}do if((d[Xa>>0]|0)==48){c[E>>2]=0;c[S>>2]=(c[S>>2]|0)+1}else{if((d[c[S>>2]>>0]|0)==49){c[E>>2]=1;c[S>>2]=(c[S>>2]|0)+1;break}x=c[S>>2]|0;if((d[c[S>>2]>>0]|0)==116){c[S>>2]=x+1;p=c[S>>2]|0;c[S>>2]=p+1;if((d[p>>0]|0)!=114){Sa=577;break a}p=c[S>>2]|0;c[S>>2]=p+1;if((d[p>>0]|0)!=117){Sa=577;break a}p=c[S>>2]|0;c[S>>2]=p+1;if((d[p>>0]|0)!=101){Sa=577;break a}c[E>>2]=1;break}if((d[x>>0]|0)!=102){Sa=577;break a}c[S>>2]=(c[S>>2]|0)+1;x=c[S>>2]|0;c[S>>2]=x+1;if((d[x>>0]|0)!=97){Sa=577;break a}x=c[S>>2]|0;c[S>>2]=x+1;if((d[x>>0]|0)!=108){Sa=577;break a}x=c[S>>2]|0;c[S>>2]=x+1;if((d[x>>0]|0)!=115){Sa=577;break a}x=c[S>>2]|0;c[S>>2]=x+1;if((d[x>>0]|0)!=101){Sa=577;break a}c[E>>2]=0}while(0);if(d[c[S>>2]>>0]|0){while(1){do if((d[c[S>>2]>>0]|0)==32)Ya=1;else{if(9<=(d[c[S>>2]>>0]|0)?(d[c[S>>2]>>0]|0)<=10:0){Ya=1;break}Ya=(d[c[S>>2]>>0]|0)==13}while(0);Za=c[S>>2]|0;if(!Ya)break;c[S>>2]=Za+1}if(d[Za>>0]|0){Sa=577;break a}}}else{if((d[c[S>>2]>>0]|0)==48?(d[(c[S>>2]|0)+1>>0]|0)==0:0){c[E>>2]=0;break}if((d[c[S>>2]>>0]|0)==49?(d[(c[S>>2]|0)+1>>0]|0)==0:0){c[E>>2]=1;break}if(((((d[c[S>>2]>>0]|0)==116?(d[(c[S>>2]|0)+1>>0]|0)==114:0)?(d[(c[S>>2]|0)+2>>0]|0)==117:0)?(d[(c[S>>2]|0)+3>>0]|0)==101:0)?(d[(c[S>>2]|0)+4>>0]|0)==0:0){c[E>>2]=1;break}if((d[c[S>>2]>>0]|0)!=102){Sa=577;break a}if((d[(c[S>>2]|0)+1>>0]|0)!=97){Sa=577;break a}if((d[(c[S>>2]|0)+2>>0]|0)!=108){Sa=577;break a}if((d[(c[S>>2]|0)+3>>0]|0)!=115){Sa=577;break a}if((d[(c[S>>2]|0)+4>>0]|0)!=101){Sa=577;break a}if(d[(c[S>>2]|0)+5>>0]|0){Sa=577;break a}c[E>>2]=0}while(0);if(c[v>>2]|0){c[C>>2]=hI(15)|0;if(c[C>>2]|0){c[(c[C>>2]|0)+8>>2]=c[E>>2];c[c[v>>2]>>2]=c[C>>2];Sa=580}else Sa=583}else Sa=580;break}case 16:{c[T>>2]=c[u>>2];l:do if(!(c[z>>2]|0))while(1){if(!(d[c[T>>2]>>0]|0))break l;if((d[c[T>>2]>>0]|0)==13){Sa=577;break a}if((d[c[T>>2]>>0]|0)==10){Sa=577;break a}if((d[c[T>>2]>>0]|0)==9){Sa=577;break a}x=(d[c[T>>2]>>0]|0)==32;c[T>>2]=(c[T>>2]|0)+1;if(!x)continue;if(!(d[c[T>>2]>>0]|0)){Sa=577;break a}if((d[c[T>>2]>>0]|0)==32){Sa=577;break a}}while(0);if(c[v>>2]|0){c[C>>2]=hI(16)|0;if(c[C>>2]|0){x=my(c[u>>2]|0)|0;c[(c[C>>2]|0)+8>>2]=x;c[c[v>>2]>>2]=c[C>>2];Sa=580}else Sa=583}else Sa=580;break}case 17:{if((c[z>>2]|0)!=0?(c[D>>2]=SH(c[u>>2]|0)|0,(c[D>>2]|0)!=0):0)c[u>>2]=c[D>>2];if((Ne(c[u>>2]|0)|0)==1)if(c[v>>2]|0){c[C>>2]=hI(17)|0;if(c[C>>2]|0){x=my(c[u>>2]|0)|0;c[(c[C>>2]|0)+8>>2]=x;c[c[v>>2]>>2]=c[C>>2];Sa=580}else Sa=583}else Sa=580;else Sa=577;break}case 18:{if(!(Hh(c[u>>2]|0,1)|0))if(c[v>>2]|0){c[C>>2]=hI(18)|0;if(c[C>>2]|0){x=my(c[u>>2]|0)|0;c[(c[C>>2]|0)+8>>2]=x;c[c[v>>2]>>2]=c[C>>2];Sa=580}else Sa=583}else Sa=580;else Sa=577;break}case 20:{c[E>>2]=Gh(c[u>>2]|0,1)|0;if((c[E>>2]|0)==0&(c[v>>2]|0)!=0&(c[u>>2]|0)!=0){c[C>>2]=hI(20)|0;if(c[C>>2]|0){c[U>>2]=c[u>>2];while(1){do if((d[c[U>>2]>>0]|0)==32)_a=1;else{if(9<=(d[c[U>>2]>>0]|0)?(d[c[U>>2]>>0]|0)<=10:0){_a=1;break}_a=(d[c[U>>2]>>0]|0)==13}while(0);$a=c[U>>2]|0;if(!_a)break;c[U>>2]=$a+1}c[V>>2]=$a;while(1){if(!(d[c[V>>2]>>0]|0))break;do if((d[c[V>>2]>>0]|0)==32)ab=1;else{if(9<=(d[c[V>>2]>>0]|0)?(d[c[V>>2]>>0]|0)<=10:0){ab=1;break}ab=(d[c[V>>2]>>0]|0)==13}while(0);if(!(ab^1))break;c[V>>2]=(c[V>>2]|0)+1}x=ly(c[U>>2]|0,(c[V>>2]|0)-(c[U>>2]|0)|0)|0;c[(c[C>>2]|0)+8>>2]=x;c[c[v>>2]>>2]=c[C>>2];Sa=571}else Sa=583}else Sa=571;break}case 19:{c[E>>2]=sI(c[42822]|0,c[u>>2]|0,c[v>>2]|0,c[w>>2]|0)|0;if((c[E>>2]|0)>0){c[E>>2]=0;Sa=571;break a}else{c[E>>2]=1;Sa=571;break a}break}case 21:{c[W>>2]=0;c[X>>2]=0;c[E>>2]=Fh(c[u>>2]|0,1)|0;if(c[E>>2]|0)Sa=571;else{if(c[w>>2]|0){c[X>>2]=Ch(c[u>>2]|0,Y)|0;c[Z>>2]=cj(c[(c[w>>2]|0)+32>>2]|0,c[w>>2]|0,c[Y>>2]|0)|0;if((c[Z>>2]|0)==0&(c[Y>>2]|0)!=0){zb[c[135736>>2]&511](c[Y>>2]|0);if(!(c[X>>2]|0)){Sa=577;break a}zb[c[135736>>2]&511](c[X>>2]|0);Sa=577;break a}if(c[Z>>2]|0)c[W>>2]=c[(c[Z>>2]|0)+8>>2];if(c[Y>>2]|0)zb[c[135736>>2]&511](c[Y>>2]|0)}if(!(c[v>>2]|0)){if(!(c[X>>2]|0)){Sa=571;break a}zb[c[135736>>2]&511](c[X>>2]|0);Sa=571;break a}c[C>>2]=hI(21)|0;x=(c[X>>2]|0)!=0;if(!(c[C>>2]|0)){if(!x){Sa=583;break a}zb[c[135736>>2]&511](c[X>>2]|0);Sa=583;break a}if(x)c[(c[C>>2]|0)+8>>2]=c[X>>2];else{x=my(c[u>>2]|0)|0;c[(c[C>>2]|0)+8>>2]=x}if(c[W>>2]|0){x=my(c[W>>2]|0)|0;c[(c[C>>2]|0)+12>>2]=x}c[c[v>>2]>>2]=c[C>>2];Sa=571}break}case 23:{c[E>>2]=Eh(c[u>>2]|0,1)|0;if((c[E>>2]|0)==0&(c[v>>2]|0)!=0){c[C>>2]=hI(23)|0;if(!(c[C>>2]|0)){Sa=583;break a}x=my(c[u>>2]|0)|0;c[(c[C>>2]|0)+8>>2]=x;c[c[v>>2]>>2]=c[C>>2]}if(((c[E>>2]|0)==0&(c[w>>2]|0)!=0?(c[(c[w>>2]|0)+4>>2]|0)==2:0)?(c[_>>2]=c[w>>2],(c[(c[_>>2]|0)+40>>2]|0)!=2):0){c[aa>>2]=tI(c[u>>2]|0)|0;x=c[(c[w>>2]|0)+32>>2]|0;if(c[aa>>2]|0){c[$>>2]=Cm(0,x,c[aa>>2]|0,c[_>>2]|0)|0;zb[c[135736>>2]&511](c[aa>>2]|0)}else c[$>>2]=Cm(0,x,c[u>>2]|0,c[_>>2]|0)|0;if(!(c[$>>2]|0)){c[E>>2]=2;Sa=571;break a}else{c[(c[_>>2]|0)+40>>2]=2;Sa=571;break a}}else Sa=571;break}case 22:{c[E>>2]=Eh(c[u>>2]|0,1)|0;if((c[E>>2]|0)==0&(c[v>>2]|0)!=0){c[C>>2]=hI(22)|0;if(c[C>>2]|0){x=my(c[u>>2]|0)|0;c[(c[C>>2]|0)+8>>2]=x;c[c[v>>2]>>2]=c[C>>2];Sa=571}else Sa=583}else Sa=571;break}case 24:{c[E>>2]=Eh(c[u>>2]|0,1)|0;if((c[E>>2]|0)==0&(c[v>>2]|0)!=0){c[C>>2]=hI(24)|0;if(!(c[C>>2]|0)){Sa=583;break a}x=my(c[u>>2]|0)|0;c[(c[C>>2]|0)+8>>2]=x;c[c[v>>2]>>2]=c[C>>2]}if((c[E>>2]|0)==0&(c[w>>2]|0)!=0?(c[(c[w>>2]|0)+4>>2]|0)==2:0){c[ba>>2]=c[w>>2];c[ca>>2]=tI(c[u>>2]|0)|0;x=c[(c[w>>2]|0)+32>>2]|0;if(c[ca>>2]|0){Im(0,x,c[ca>>2]|0,c[ba>>2]|0)|0;zb[c[135736>>2]&511](c[ca>>2]|0)}else Im(0,x,c[u>>2]|0,c[ba>>2]|0)|0;c[(c[ba>>2]|0)+40>>2]=3;Sa=571}else Sa=571;break}case 25:{c[E>>2]=sI(c[42834]|0,c[u>>2]|0,c[v>>2]|0,c[w>>2]|0)|0;if((c[E>>2]|0)<0)c[E>>2]=2;else c[E>>2]=0;if((c[E>>2]|0)==0&(c[w>>2]|0)!=0?(c[(c[w>>2]|0)+4>>2]|0)==2:0){c[da>>2]=c[w>>2];c[(c[da>>2]|0)+40>>2]=4;Sa=571}else Sa=571;break}case 26:{c[E>>2]=Eh(c[u>>2]|0,1)|0;if(!((c[w>>2]|0)!=0?(c[(c[w>>2]|0)+32>>2]|0)!=0:0))c[E>>2]=3;do if(!(c[E>>2]|0)){c[ea>>2]=tI(c[u>>2]|0)|0;x=c[(c[w>>2]|0)+32>>2]|0;if(c[ea>>2]|0){c[fa>>2]=ad(x,c[ea>>2]|0)|0;zb[c[135736>>2]&511](c[ea>>2]|0)}else c[fa>>2]=ad(x,c[u>>2]|0)|0;if((c[fa>>2]|0)!=0?(c[(c[fa>>2]|0)+48>>2]|0)==3:0)break;c[E>>2]=4}while(0);if((c[E>>2]|0)==0&(c[v>>2]|0)!=0){x=c[33976]|0;p=c[33980]|0;c[r>>2]=171992;c[r+4>>2]=2831;Db[x&511](p,171960,r)}if((c[E>>2]|0)==0&(c[w>>2]|0)!=0?(c[(c[w>>2]|0)+4>>2]|0)==2:0){c[ga>>2]=c[w>>2];c[(c[ga>>2]|0)+40>>2]=5;Sa=571}else Sa=571;break}case 27:{if((c[w>>2]|0)!=0?(c[(c[w>>2]|0)+32>>2]|0)!=0:0){c[E>>2]=sI(c[42838]|0,c[u>>2]|0,c[v>>2]|0,c[w>>2]|0)|0;if((c[E>>2]|0)<=0)c[E>>2]=1;else c[E>>2]=0;if(!((c[E>>2]|0)==0&(c[w>>2]|0)!=0)){Sa=571;break a}if((c[(c[w>>2]|0)+4>>2]|0)!=2){Sa=571;break a}c[ha>>2]=c[w>>2];c[(c[ha>>2]|0)+40>>2]=6;Sa=571;break a}if(c[D>>2]|0)zb[c[135736>>2]&511](c[D>>2]|0);c[s>>2]=3;Ra=c[s>>2]|0;i=q;return Ra|0}case 28:{c[ia>>2]=0;c[ja>>2]=0;c[E>>2]=Fh(c[u>>2]|0,1)|0;if((c[E>>2]|0)==0&(c[w>>2]|0)!=0){c[ja>>2]=Ch(c[u>>2]|0,ka)|0;do if(c[ka>>2]|0){c[la>>2]=cj(c[(c[w>>2]|0)+32>>2]|0,c[w>>2]|0,c[ka>>2]|0)|0;if(!(c[la>>2]|0)){c[E>>2]=1;break}if(c[v>>2]|0)c[ia>>2]=my(c[(c[la>>2]|0)+8>>2]|0)|0}while(0);if((c[ja>>2]|0)!=0?(c[v>>2]|0)==0|(c[E>>2]|0)!=0:0)zb[c[135736>>2]&511](c[ja>>2]|0);if(c[ka>>2]|0)zb[c[135736>>2]&511](c[ka>>2]|0)}if(!((c[w>>2]|0)!=0?(c[(c[w>>2]|0)+32>>2]|0)!=0:0))c[E>>2]=3;do if(!(c[E>>2]|0)){c[E>>2]=Pm(0,c[(c[w>>2]|0)+32>>2]|0,c[u>>2]|0)|0;if((c[E>>2]|0)==1){c[E>>2]=0;break}else{c[E>>2]=1;break}}while(0);if((c[E>>2]|0)==0&(c[v>>2]|0)!=0){c[C>>2]=hI(28)|0;p=(c[ja>>2]|0)!=0;if(!(c[C>>2]|0)){if(p)zb[c[135736>>2]&511](c[ja>>2]|0);if(!(c[ia>>2]|0)){Sa=583;break a}zb[c[135736>>2]&511](c[ia>>2]|0);Sa=583;break a}if(p)c[(c[C>>2]|0)+8>>2]=c[ja>>2];else{p=my(c[u>>2]|0)|0;c[(c[C>>2]|0)+8>>2]=p}if(c[ia>>2]|0)c[(c[C>>2]|0)+12>>2]=c[ia>>2];c[c[v>>2]>>2]=c[C>>2];Sa=571}else Sa=571;break}case 29:{if(d[c[u>>2]>>0]|0){if((c[z>>2]|0)!=0?(c[D>>2]=SH(c[u>>2]|0)|0,(c[D>>2]|0)!=0):0)c[u>>2]=c[D>>2];c[na>>2]=my(c[u>>2]|0)|0;c[oa>>2]=c[na>>2];while(1){if(!(a[c[oa>>2]>>0]|0))break;do if((((((((d[c[oa>>2]>>0]|0)>=32?(d[c[oa>>2]>>0]|0)<127:0)?(d[c[oa>>2]>>0]|0)!=32:0)?(d[c[oa>>2]>>0]|0)!=60:0)?(d[c[oa>>2]>>0]|0)!=62:0)?(d[c[oa>>2]>>0]|0)!=34:0)?(d[c[oa>>2]>>0]|0)!=123:0)?(d[c[oa>>2]>>0]|0)!=125:0){if((d[c[oa>>2]>>0]|0)==124){Sa=409;break}if((d[c[oa>>2]>>0]|0)==92){Sa=409;break}if((d[c[oa>>2]>>0]|0)==94){Sa=409;break}if((d[c[oa>>2]>>0]|0)==96){Sa=409;break}if((d[c[oa>>2]>>0]|0)==39)Sa=409}else Sa=409;while(0);if((Sa|0)==409){Sa=0;a[c[oa>>2]>>0]=95}c[oa>>2]=(c[oa>>2]|0)+1}c[ma>>2]=yl(c[na>>2]|0)|0;zb[c[135736>>2]&511](c[na>>2]|0);if(!(c[ma>>2]|0)){Sa=577;break a}Al(c[ma>>2]|0)}if(c[v>>2]|0){c[C>>2]=hI(29)|0;if(!(c[C>>2]|0))Sa=583;else{p=my(c[u>>2]|0)|0;c[(c[C>>2]|0)+8>>2]=p;c[c[v>>2]>>2]=c[C>>2];Sa=580}}else Sa=580;break}case 43:{c[pa>>2]=c[u>>2];c[ta>>2]=0;if(c[pa>>2]|0){m:do if(c[z>>2]|0)while(1){do if((d[c[pa>>2]>>0]|0)!=32){if(9<=(d[c[pa>>2]>>0]|0)?(d[c[pa>>2]>>0]|0)<=10:0)break;if((d[c[pa>>2]>>0]|0)!=13)break m}while(0);c[pa>>2]=(c[pa>>2]|0)+1}while(0);c[qa>>2]=c[pa>>2];n:while(1){if(!((d[c[pa>>2]>>0]|0)>=48?(d[c[pa>>2]>>0]|0)<=57:0))Sa=426;do if((Sa|0)==426){Sa=0;if((d[c[pa>>2]>>0]|0)>=65?(d[c[pa>>2]>>0]|0)<=70:0)break;if((d[c[pa>>2]>>0]|0)<97)break n;if((d[c[pa>>2]>>0]|0)>102)break n}while(0);c[ta>>2]=(c[ta>>2]|0)+1;c[pa>>2]=(c[pa>>2]|0)+1}o:do if(c[z>>2]|0)while(1){do if((d[c[pa>>2]>>0]|0)!=32){if(9<=(d[c[pa>>2]>>0]|0)?(d[c[pa>>2]>>0]|0)<=10:0)break;if((d[c[pa>>2]>>0]|0)!=13)break o}while(0);c[pa>>2]=(c[pa>>2]|0)+1}while(0);if((d[c[pa>>2]>>0]|0)==0?((c[ta>>2]|0)%2|0|0)==0:0)if(c[v>>2]|0){c[C>>2]=hI(43)|0;if(!(c[C>>2]|0))Sa=583;else{c[pa>>2]=ly(c[qa>>2]|0,c[ta>>2]|0)|0;if(!(c[pa>>2]|0)){gI(c[w>>2]|0,172232);zb[c[135736>>2]&511](c[C>>2]|0);Sa=577;break a}c[sa>>2]=(c[ta>>2]|0)/2|0;c[ra>>2]=c[pa>>2];while(1){p=c[ta>>2]|0;c[ta>>2]=p+-1;if((p|0)<=0)break;if((d[c[ra>>2]>>0]|0)>=97)a[c[ra>>2]>>0]=(d[c[ra>>2]>>0]|0)-32;c[ra>>2]=(c[ra>>2]|0)+1}c[(c[C>>2]|0)+8>>2]=c[pa>>2];c[(c[C>>2]|0)+12>>2]=c[sa>>2];c[c[v>>2]>>2]=c[C>>2];Sa=580}}else Sa=580;else Sa=577}else Sa=577;break}case 44:{c[ua>>2]=c[u>>2];c[xa>>2]=0;c[ya>>2]=0;if(c[ua>>2]|0){while(1){if(!(a[c[ua>>2]>>0]|0))break;c[za>>2]=uI(a[c[ua>>2]>>0]|0)|0;if((c[za>>2]|0)>=0){if((c[za>>2]|0)>=64)break;c[xa>>2]=(c[xa>>2]|0)+1}c[ua>>2]=(c[ua>>2]|0)+1}while(1){if(!(a[c[ua>>2]>>0]|0))break;c[Aa>>2]=uI(a[c[ua>>2]>>0]|0)|0;if((c[Aa>>2]|0)>=0&(c[Aa>>2]|0)<64){Sa=577;break a}if((c[Aa>>2]|0)==64)c[ya>>2]=(c[ya>>2]|0)+1;c[ua>>2]=(c[ua>>2]|0)+1}c[wa>>2]=((c[xa>>2]|0)/4|0)*3;do if(!(c[ya>>2]|0)){if((c[xa>>2]|0)%4|0){Sa=577;break a}}else{if((c[ya>>2]|0)==1){if(((c[xa>>2]|0)%4|0|0)!=3){Sa=577;break a}c[Ba>>2]=uI(a[c[ua>>2]>>0]|0)|0;while(1){if(!((c[Ba>>2]|0)<0|(c[Ba>>2]|0)>63))break;c[ua>>2]=(c[ua>>2]|0)+-1;c[Ba>>2]=uI(a[c[ua>>2]>>0]|0)|0}if(c[Ba>>2]&-61){Sa=577;break a}c[wa>>2]=(c[wa>>2]|0)+2;break}if((c[ya>>2]|0)!=2){Sa=577;break a}if(((c[xa>>2]|0)%4|0|0)!=2){Sa=577;break a}c[Ca>>2]=uI(a[c[ua>>2]>>0]|0)|0;while(1){if(!((c[Ca>>2]|0)<0|(c[Ca>>2]|0)>63))break;c[ua>>2]=(c[ua>>2]|0)+-1;c[Ca>>2]=uI(a[c[ua>>2]>>0]|0)|0}if(c[Ca>>2]&-49){Sa=577;break a}c[wa>>2]=(c[wa>>2]|0)+1}while(0);if(c[v>>2]|0){c[C>>2]=hI(44)|0;if(!(c[C>>2]|0))Sa=583;else{c[va>>2]=Cb[c[135752>>2]&511]((c[xa>>2]|0)+(c[ya>>2]|0)+1|0)|0;if(!(c[va>>2]|0)){gI(c[w>>2]|0,172256);zb[c[135736>>2]&511](c[C>>2]|0);Sa=577;break a}c[(c[C>>2]|0)+8>>2]=c[va>>2];c[ua>>2]=c[u>>2];while(1){if(!(a[c[ua>>2]>>0]|0))break;if((uI(a[c[ua>>2]>>0]|0)|0)>=0){a[c[va>>2]>>0]=a[c[ua>>2]>>0]|0;c[va>>2]=(c[va>>2]|0)+1}c[ua>>2]=(c[ua>>2]|0)+1}a[c[va>>2]>>0]=0;c[(c[C>>2]|0)+12>>2]=c[wa>>2];c[c[v>>2]>>2]=c[C>>2];Sa=580}}else Sa=580}else Sa=577;break}case 33:case 32:case 31:case 34:case 30:{c[Da>>2]=c[u>>2];c[Ha>>2]=0;if(c[Da>>2]|0){p:do if(c[z>>2]|0)while(1){do if((d[c[Da>>2]>>0]|0)!=32){if(9<=(d[c[Da>>2]>>0]|0)?(d[c[Da>>2]>>0]|0)<=10:0)break;if((d[c[Da>>2]>>0]|0)!=13)break p}while(0);c[Da>>2]=(c[Da>>2]|0)+1}while(0);if((d[c[Da>>2]>>0]|0)!=45){if((d[c[Da>>2]>>0]|0)==43)c[Da>>2]=(c[Da>>2]|0)+1}else{c[Ha>>2]=1;c[Da>>2]=(c[Da>>2]|0)+1}c[E>>2]=pI(Da,Ea,Fa,Ga)|0;if((c[E>>2]|0)>=0){q:do if(c[z>>2]|0)while(1){do if((d[c[Da>>2]>>0]|0)!=32){if(9<=(d[c[Da>>2]>>0]|0)?(d[c[Da>>2]>>0]|0)<=10:0)break;if((d[c[Da>>2]>>0]|0)!=13)break q}while(0);c[Da>>2]=(c[Da>>2]|0)+1}while(0);if(!(d[c[Da>>2]>>0]|0)){do if((c[(c[t>>2]|0)+88>>2]|0)==31){if((c[Ha>>2]|0)==0?(c[Ga>>2]|0)!=0|(c[Fa>>2]|0)!=0|(c[Ea>>2]|0)!=0:0){Sa=577;break a}}else{if((c[(c[t>>2]|0)+88>>2]|0)==34){if((c[Ha>>2]|0)==1){Sa=577;break a}if((c[Ga>>2]|0)==0&(c[Fa>>2]|0)==0&(c[Ea>>2]|0)==0){Sa=577;break a}else break}if((c[(c[t>>2]|0)+88>>2]|0)==32){if(!(c[Ha>>2]|0)){Sa=577;break a}if((c[Ga>>2]|0)==0&(c[Fa>>2]|0)==0&(c[Ea>>2]|0)==0){Sa=577;break a}else break}else{if(!((c[Ha>>2]|0)==1?(c[(c[t>>2]|0)+88>>2]|0)==33:0))break;if((c[Ga>>2]|0)!=0|(c[Fa>>2]|0)!=0|(c[Ea>>2]|0)!=0){Sa=577;break a}else break}}while(0);if((c[v>>2]|0)!=0?(c[C>>2]=hI(c[(c[t>>2]|0)+88>>2]|0)|0,(c[C>>2]|0)!=0):0){if(!(c[E>>2]|0))c[E>>2]=(c[E>>2]|0)+1;c[(c[C>>2]|0)+8>>2]=c[Ea>>2];c[(c[C>>2]|0)+12>>2]=c[Fa>>2];c[(c[C>>2]|0)+16>>2]=c[Ga>>2];p=(c[C>>2]|0)+24|0;b[p>>1]=b[p>>1]&-2|c[Ha>>2]&1;p=(c[C>>2]|0)+24|0;b[p>>1]=b[p>>1]&-255;p=(c[C>>2]|0)+24|0;b[p>>1]=b[p>>1]&255|(c[E>>2]&255)<<8&65535;c[c[v>>2]>>2]=c[C>>2];Sa=580}else Sa=580}else Sa=577}else Sa=577}else Sa=577;break}case 35:case 39:case 41:case 37:{c[Ia>>2]=c[u>>2];c[Ma>>2]=0;if(c[Ia>>2]|0){if((d[c[Ia>>2]>>0]|0)!=45){if((d[c[Ia>>2]>>0]|0)==43)c[Ia>>2]=(c[Ia>>2]|0)+1}else{c[Ma>>2]=1;c[Ia>>2]=(c[Ia>>2]|0)+1}c[E>>2]=pI(Ia,Ja,Ka,La)|0;if((c[E>>2]|0)>=0?(d[c[Ia>>2]>>0]|0)==0:0){do if((c[(c[t>>2]|0)+88>>2]|0)==37){if((c[La>>2]|0)>>>0>=922){if((c[La>>2]|0)>>>0>922){Sa=577;break a}if((c[Ka>>2]|0)>>>0>=33720368){if((c[Ka>>2]|0)>>>0>33720368){Sa=577;break a}if((c[Ma>>2]|0)==0&(c[Ja>>2]|0)>>>0>54775807){Sa=577;break a}if((c[Ma>>2]|0)==1&(c[Ja>>2]|0)>>>0>54775808){Sa=577;break a}}}}else{if((c[(c[t>>2]|0)+88>>2]|0)==35){if(c[La>>2]|0){Sa=577;break a}if((c[Ka>>2]|0)>>>0<21)break;if((c[Ka>>2]|0)>>>0>21){Sa=577;break a}if((c[Ma>>2]|0)==0&(c[Ja>>2]|0)>>>0>47483647){Sa=577;break a}if((c[Ma>>2]|0)==1&(c[Ja>>2]|0)>>>0>47483648){Sa=577;break a}else break}if((c[(c[t>>2]|0)+88>>2]|0)==39){if((c[Ka>>2]|0)!=0|(c[La>>2]|0)!=0){Sa=577;break a}if((c[Ma>>2]|0)==1&(c[Ja>>2]|0)>>>0>32768){Sa=577;break a}if((c[Ma>>2]|0)==0&(c[Ja>>2]|0)>>>0>32767){Sa=577;break a}else break}if((c[(c[t>>2]|0)+88>>2]|0)==41){if((c[Ka>>2]|0)!=0|(c[La>>2]|0)!=0){Sa=577;break a}if((c[Ma>>2]|0)==1&(c[Ja>>2]|0)>>>0>128){Sa=577;break a}if((c[Ma>>2]|0)==0&(c[Ja>>2]|0)>>>0>127){Sa=577;break a}}}while(0);if((c[v>>2]|0)!=0?(c[C>>2]=hI(c[(c[t>>2]|0)+88>>2]|0)|0,(c[C>>2]|0)!=0):0){c[(c[C>>2]|0)+8>>2]=c[Ja>>2];c[(c[C>>2]|0)+12>>2]=c[Ka>>2];c[(c[C>>2]|0)+16>>2]=c[La>>2];p=(c[C>>2]|0)+24|0;b[p>>1]=b[p>>1]&-2|c[Ma>>2]&1;p=(c[C>>2]|0)+24|0;b[p>>1]=b[p>>1]&-255;p=(c[C>>2]|0)+24|0;b[p>>1]=b[p>>1]&255|(c[E>>2]&255)<<8&65535;c[c[v>>2]>>2]=c[C>>2];Sa=580}else Sa=580}else Sa=577}else Sa=577;break}case 42:case 40:case 38:case 36:{c[Na>>2]=c[u>>2];if(((c[Na>>2]|0)!=0?(c[E>>2]=pI(Na,Oa,Pa,Qa)|0,(c[E>>2]|0)>=0):0)?(d[c[Na>>2]>>0]|0)==0:0){do if((c[(c[t>>2]|0)+88>>2]|0)==38){if((c[Qa>>2]|0)>>>0>=1844){if((c[Qa>>2]|0)>>>0>1844){Sa=577;break a}if((c[Pa>>2]|0)>>>0>=67440737?(c[Pa>>2]|0)>>>0>67440737|(c[Oa>>2]|0)>>>0>9551615:0){Sa=577;break a}}}else{if((c[(c[t>>2]|0)+88>>2]|0)==36){if(c[Qa>>2]|0){Sa=577;break a}if((c[Pa>>2]|0)>>>0<42)break;if((c[Pa>>2]|0)>>>0>42|(c[Oa>>2]|0)>>>0>94967295){Sa=577;break a}else break}if((c[(c[t>>2]|0)+88>>2]|0)==40)if((c[Pa>>2]|0)!=0|(c[Qa>>2]|0)!=0|(c[Oa>>2]|0)>>>0>65535){Sa=577;break a}else break;if((c[(c[t>>2]|0)+88>>2]|0)==42?(c[Pa>>2]|0)!=0|(c[Qa>>2]|0)!=0|(c[Oa>>2]|0)>>>0>255:0){Sa=577;break a}}while(0);if((c[v>>2]|0)!=0?(c[C>>2]=hI(c[(c[t>>2]|0)+88>>2]|0)|0,(c[C>>2]|0)!=0):0){c[(c[C>>2]|0)+8>>2]=c[Oa>>2];c[(c[C>>2]|0)+12>>2]=c[Pa>>2];c[(c[C>>2]|0)+16>>2]=c[Qa>>2];p=(c[C>>2]|0)+24|0;b[p>>1]=b[p>>1]&-2;p=(c[C>>2]|0)+24|0;b[p>>1]=b[p>>1]&-255;p=(c[C>>2]|0)+24|0;b[p>>1]=b[p>>1]&255|(c[E>>2]&255)<<8&65535;c[c[v>>2]>>2]=c[C>>2];Sa=580}else Sa=580}else Sa=577;break}case 0:{Sa=583;break}default:Sa=571}while(0);if((Sa|0)==571){if(c[D>>2]|0)zb[c[135736>>2]&511](c[D>>2]|0);c[s>>2]=c[E>>2];Ra=c[s>>2]|0;i=q;return Ra|0}else if((Sa|0)==577){if(c[D>>2]|0)zb[c[135736>>2]&511](c[D>>2]|0);c[s>>2]=1;Ra=c[s>>2]|0;i=q;return Ra|0}else if((Sa|0)==580){if(c[D>>2]|0)zb[c[135736>>2]&511](c[D>>2]|0);c[s>>2]=0;Ra=c[s>>2]|0;i=q;return Ra|0}else if((Sa|0)==583){if(c[D>>2]|0)zb[c[135736>>2]&511](c[D>>2]|0);c[s>>2]=-1;Ra=c[s>>2]|0;i=q;return Ra|0}return 0}function jI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=hI(c[c[e>>2]>>2]|0)|0;if(!(c[f>>2]|0)){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{a=c[f>>2]|0;h=c[e>>2]|0;c[a+0>>2]=c[h+0>>2];c[a+4>>2]=c[h+4>>2];c[a+8>>2]=c[h+8>>2];c[a+12>>2]=c[h+12>>2];c[a+16>>2]=c[h+16>>2];c[a+20>>2]=c[h+20>>2];c[a+24>>2]=c[h+24>>2];c[a+28>>2]=c[h+28>>2];c[(c[f>>2]|0)+4>>2]=0;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function kI(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;k=i;i=i+64|0;l=k;m=k+56|0;n=k+52|0;o=k+48|0;p=k+44|0;q=k+40|0;r=k+36|0;s=k+32|0;t=k+28|0;u=k+24|0;v=k+20|0;w=k+16|0;x=k+12|0;y=k+8|0;c[n>>2]=a;c[o>>2]=b;c[p>>2]=d;c[q>>2]=e;c[r>>2]=f;c[s>>2]=g;c[t>>2]=h;c[u>>2]=j;a:do switch(c[n>>2]|0){case 11:case 10:case 9:case 8:case 7:case 6:case 5:case 4:{if((c[o>>2]|0)==0|(c[s>>2]|0)==0){c[m>>2]=-2;break a}if((c[r>>2]|0)==11|(c[r>>2]|0)==4|(c[r>>2]|0)==5|(c[r>>2]|0)==6|(c[r>>2]|0)==7|(c[r>>2]|0)==8|(c[r>>2]|0)==10|(c[r>>2]|0)==9){c[m>>2]=xI(c[o>>2]|0,c[s>>2]|0)|0;break a}else{c[m>>2]=-2;break a}break}case 12:{if((c[o>>2]|0)==0|(c[s>>2]|0)==0){c[m>>2]=-2;break a}if((c[r>>2]|0)==12){c[m>>2]=wI(c[o>>2]|0,c[s>>2]|0)|0;break a}else{c[m>>2]=-2;break a}break}case 28:case 21:{if((c[o>>2]|0)==0|(c[s>>2]|0)==0){c[m>>2]=-2;break a}if(!((c[r>>2]|0)==21|(c[r>>2]|0)==28)){c[m>>2]=-2;break a}if((qy(c[(c[o>>2]|0)+8>>2]|0,c[(c[s>>2]|0)+8>>2]|0)|0)!=0?(qy(c[(c[o>>2]|0)+12>>2]|0,c[(c[s>>2]|0)+12>>2]|0)|0)!=0:0){c[m>>2]=0;break a}c[m>>2]=2;break}case 3:case 42:case 41:case 40:case 39:case 38:case 37:case 36:case 35:case 34:case 33:case 32:case 31:case 30:{if((c[o>>2]|0)==0|(c[s>>2]|0)==0){c[m>>2]=-2;break a}if((c[r>>2]|0)==(c[n>>2]|0)){c[m>>2]=vI(c[o>>2]|0,c[s>>2]|0)|0;break a}if((c[r>>2]|0)==3|(c[r>>2]|0)==30|(c[r>>2]|0)==31|(c[r>>2]|0)==32|(c[r>>2]|0)==33|(c[r>>2]|0)==34|(c[r>>2]|0)==35|(c[r>>2]|0)==36|(c[r>>2]|0)==37|(c[r>>2]|0)==38|(c[r>>2]|0)==39|(c[r>>2]|0)==40|(c[r>>2]|0)==41|(c[r>>2]|0)==42){c[m>>2]=vI(c[o>>2]|0,c[s>>2]|0)|0;break a}else{c[m>>2]=-2;break a}break}case 14:case 13:{if((c[o>>2]|0)==0|(c[s>>2]|0)==0){c[m>>2]=-2;break a}if((c[r>>2]|0)==13|(c[r>>2]|0)==14){c[m>>2]=DI(c[o>>2]|0,c[s>>2]|0)|0;break a}else{c[m>>2]=-2;break a}break}case 44:{if((c[o>>2]|0)==0|(c[s>>2]|0)==0){c[m>>2]=-2;break a}if((c[r>>2]|0)!=44){c[m>>2]=-2;break a}j=(c[o>>2]|0)+8|0;if((c[(c[o>>2]|0)+12>>2]|0)!=(c[(c[s>>2]|0)+12>>2]|0))if((c[j+4>>2]|0)>>>0>(c[(c[s>>2]|0)+12>>2]|0)>>>0){c[m>>2]=1;break a}else{c[m>>2]=-1;break a}c[y>>2]=py(c[j>>2]|0,c[(c[s>>2]|0)+8>>2]|0)|0;if((c[y>>2]|0)>0){c[m>>2]=1;break a}if(!(c[y>>2]|0)){c[m>>2]=0;break a}else{c[m>>2]=-1;break a}break}case 29:case 26:case 24:case 23:case 22:case 20:case 18:case 17:case 16:case 2:case 1:case 46:{if(!(c[o>>2]|0))c[v>>2]=c[p>>2];else c[v>>2]=c[(c[o>>2]|0)+8>>2];if(!(c[s>>2]|0))c[w>>2]=c[t>>2];else c[w>>2]=c[(c[s>>2]|0)+8>>2];if((c[r>>2]|0)==21){j=c[33976]|0;h=c[33980]|0;c[l>>2]=171992;c[l+4>>2]=4781;Db[j&511](h,171960,l);c[m>>2]=-2;break a}do if((c[r>>2]|0)==46|(c[r>>2]|0)==1|(c[r>>2]|0)==2|(c[r>>2]|0)==16|(c[r>>2]|0)==17|(c[r>>2]|0)==18|(c[r>>2]|0)==20|(c[r>>2]|0)==22|(c[r>>2]|0)==23|(c[r>>2]|0)==24|(c[r>>2]|0)==26|(c[r>>2]|0)==29){if((c[q>>2]|0)==1){if((c[u>>2]|0)==1)if(qy(c[v>>2]|0,c[w>>2]|0)|0){c[m>>2]=0;break a}else{c[m>>2]=2;break a}if((c[u>>2]|0)==2){c[m>>2]=yI(c[v>>2]|0,c[w>>2]|0,0)|0;break a}if((c[u>>2]|0)!=3)break;c[m>>2]=zI(c[v>>2]|0,c[w>>2]|0,0)|0;break a}if((c[q>>2]|0)==2){if((c[u>>2]|0)==1){c[m>>2]=yI(c[w>>2]|0,c[v>>2]|0,1)|0;break a}if((c[u>>2]|0)==2){c[m>>2]=AI(c[v>>2]|0,c[w>>2]|0)|0;break a}if((c[u>>2]|0)!=3)break;c[m>>2]=BI(c[v>>2]|0,c[w>>2]|0,0)|0;break a}if((c[q>>2]|0)!=3){c[m>>2]=-2;break a}if((c[u>>2]|0)==1){c[m>>2]=zI(c[w>>2]|0,c[v>>2]|0,1)|0;break a}if((c[u>>2]|0)==2){c[m>>2]=BI(c[w>>2]|0,c[v>>2]|0,1)|0;break a}if((c[u>>2]|0)==3){c[m>>2]=CI(c[v>>2]|0,c[w>>2]|0)|0;break a}}while(0);c[m>>2]=-2;break}case 45:case 0:{c[m>>2]=-2;break}case 19:case 27:case 25:{h=c[33976]|0;j=c[33980]|0;c[l>>2]=171992;c[l+4>>2]=4906;Db[h&511](j,171960,l);z=102;break}case 43:{if((c[o>>2]|0)==0|(c[s>>2]|0)==0){c[m>>2]=-2;break a}if((c[r>>2]|0)!=43){c[m>>2]=-2;break a}j=(c[o>>2]|0)+8|0;if((c[(c[o>>2]|0)+12>>2]|0)==(c[(c[s>>2]|0)+12>>2]|0)){c[x>>2]=py(c[j>>2]|0,c[(c[s>>2]|0)+8>>2]|0)|0;if((c[x>>2]|0)>0){c[m>>2]=1;break a}if(!(c[x>>2]|0)){c[m>>2]=0;break a}}else if((c[j+4>>2]|0)>>>0>(c[(c[s>>2]|0)+12>>2]|0)>>>0){c[m>>2]=1;break a}c[m>>2]=-1;break}case 15:{if((c[o>>2]|0)==0|(c[s>>2]|0)==0){c[m>>2]=-2;break a}if((c[r>>2]|0)!=15){c[m>>2]=-2;break a}if((c[(c[o>>2]|0)+8>>2]|0)==(c[(c[s>>2]|0)+8>>2]|0)){c[m>>2]=0;break a}if(!(c[(c[o>>2]|0)+8>>2]|0)){c[m>>2]=-1;break a}else{c[m>>2]=1;break a}break}default:z=102}while(0);if((z|0)==102)c[m>>2]=-2;i=k;return c[m>>2]|0}function lI(a,b,d,f,g,h){a=a|0;b=b|0;d=d|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+48|0;k=j;l=j+40|0;m=j+36|0;n=j+32|0;o=j+28|0;p=j+24|0;q=j+20|0;r=j+16|0;s=j+12|0;t=j+8|0;c[m>>2]=a;c[n>>2]=b;c[o>>2]=d;c[p>>2]=f;c[q>>2]=g;c[r>>2]=h;a:do if(!(c[m>>2]|0))c[l>>2]=-1;else{b:do switch(c[c[m>>2]>>2]|0){case 1008:{c[l>>2]=0;break a;break}case 1006:{if(!(c[p>>2]|0)){c[l>>2]=-1;break a}c[s>>2]=vz(c[(c[m>>2]|0)+36>>2]|0,c[p>>2]|0)|0;if((c[s>>2]|0)==1){c[l>>2]=0;break a}if(!(c[s>>2]|0)){c[l>>2]=1839;break a}else{c[l>>2]=c[s>>2];break a}break}case 1007:{h=c[m>>2]|0;if(!(c[r>>2]|0)){if((c[h+8>>2]|0)!=0?(qy(c[(c[m>>2]|0)+8>>2]|0,c[p>>2]|0)|0)!=0:0){c[l>>2]=0;break a}}else{c[s>>2]=EI(c[c[h+32>>2]>>2]|0,c[(c[m>>2]|0)+32>>2]|0,c[(c[m>>2]|0)+8>>2]|0,c[n>>2]|0,c[o>>2]|0,c[q>>2]|0,c[p>>2]|0,c[r>>2]|0)|0;if((c[s>>2]|0)==-2){c[l>>2]=-1;break a}if(!(c[s>>2]|0)){c[l>>2]=0;break a}}c[l>>2]=1840;break a;break}case 1011:case 1010:{u=43;break}case 1009:{if((c[o>>2]|0)==21|(c[o>>2]|0)==28){c[l>>2]=0;break a}else u=43;break}case 1005:case 1004:{do if(c[(c[m>>2]|0)+32>>2]|0){if((c[c[(c[m>>2]|0)+32>>2]>>2]|0)!=34?(c[c[(c[m>>2]|0)+32>>2]>>2]|0)!=33:0)break;if(!((e[(c[(c[m>>2]|0)+32>>2]|0)+24>>1]|0)>>>1&127)){c:do if(c[q>>2]|0){do if((((((((((c[c[q>>2]>>2]|0)!=3?(c[c[q>>2]>>2]|0)!=30:0)?(c[c[q>>2]>>2]|0)!=31:0)?(c[c[q>>2]>>2]|0)!=32:0)?(c[c[q>>2]>>2]|0)!=33:0)?(c[c[q>>2]>>2]|0)!=34:0)?(c[c[q>>2]>>2]|0)!=35:0)?(c[c[q>>2]>>2]|0)!=36:0)?(c[c[q>>2]>>2]|0)!=37:0)?(c[c[q>>2]>>2]|0)!=38:0){if((c[c[q>>2]>>2]|0)==39)break;if((c[c[q>>2]>>2]|0)==40)break;if((c[c[q>>2]>>2]|0)==41)break;if((c[c[q>>2]>>2]|0)!=42)break c}while(0);if((c[c[m>>2]>>2]|0)==1004){if(((e[(c[q>>2]|0)+24>>1]|0)>>>8&65535)>>>0<=(c[(c[(c[m>>2]|0)+32>>2]|0)+8>>2]|0)>>>0)break b;c[l>>2]=1837;break a}if((c[c[m>>2]>>2]|0)!=1005)break b;if(((e[(c[q>>2]|0)+24>>1]|0)>>>1&127)>>>0<=(c[(c[(c[m>>2]|0)+32>>2]|0)+8>>2]|0)>>>0)break b;c[l>>2]=1838;break a}while(0);c[l>>2]=-1;break a}}while(0);c[l>>2]=-1;break a;break}case 1e3:{c[s>>2]=XH(c[q>>2]|0,c[(c[m>>2]|0)+32>>2]|0)|0;if((c[s>>2]|0)==-2){c[l>>2]=-1;break a}if((c[s>>2]|0)==1|(c[s>>2]|0)==0){c[l>>2]=0;
break a}else{c[l>>2]=1833;break a}break}case 1002:{c[s>>2]=XH(c[q>>2]|0,c[(c[m>>2]|0)+32>>2]|0)|0;if((c[s>>2]|0)==-2){c[l>>2]=-1;break a}if((c[s>>2]|0)==-1|(c[s>>2]|0)==0){c[l>>2]=0;break a}else{c[l>>2]=1834;break a}break}case 1001:{c[s>>2]=XH(c[q>>2]|0,c[(c[m>>2]|0)+32>>2]|0)|0;if((c[s>>2]|0)==-2){c[l>>2]=-1;break a}if((c[s>>2]|0)==1){c[l>>2]=0;break a}else{c[l>>2]=1835;break a}break}case 1003:{c[s>>2]=XH(c[q>>2]|0,c[(c[m>>2]|0)+32>>2]|0)|0;if((c[s>>2]|0)==-2){c[l>>2]=-1;break a}if((c[s>>2]|0)==-1){c[l>>2]=0;break a}else{c[l>>2]=1836;break a}break}default:{h=c[33976]|0;g=c[33980]|0;c[k>>2]=171992;c[k+4>>2]=5498;Db[h&511](g,171960,k)}}while(0);d:do if((u|0)==43){c[t>>2]=0;if((c[o>>2]|0)==21|(c[o>>2]|0)==28){c[l>>2]=0;break a}do if(c[(c[m>>2]|0)+32>>2]|0){if((c[c[(c[m>>2]|0)+32>>2]>>2]|0)!=3?(c[c[(c[m>>2]|0)+32>>2]>>2]|0)!=33:0)break;if(!((e[(c[(c[m>>2]|0)+32>>2]|0)+24>>1]|0)>>>1&127)){if((c[q>>2]|0)!=0?(c[c[q>>2]>>2]|0)==43:0)c[t>>2]=c[(c[q>>2]|0)+12>>2];else u=53;e:do if((u|0)==53){if((c[q>>2]|0)!=0?(c[c[q>>2]>>2]|0)==44:0){c[t>>2]=c[(c[q>>2]|0)+12>>2];break}switch(c[o>>2]|0){case 29:case 23:case 22:case 20:case 18:case 17:case 16:case 24:{if(!(c[p>>2]|0))break e;c[t>>2]=FI(c[p>>2]|0)|0;break e;break}case 2:case 1:{if(!(c[r>>2]|0)){g=c[p>>2]|0;if((c[o>>2]|0)==1){c[t>>2]=Dy(g)|0;break e}else{c[t>>2]=FI(g)|0;break e}}if(!(c[p>>2]|0))break e;g=c[p>>2]|0;if((c[r>>2]|0)==3){c[t>>2]=FI(g)|0;break e}else{c[t>>2]=Dy(g)|0;break e}break}default:{g=c[33976]|0;h=c[33980]|0;c[k>>2]=171992;c[k+4>>2]=5447;Db[g&511](h,171960,k);break e}}}while(0);if((c[c[m>>2]>>2]|0)==1009){if((c[t>>2]|0)==(c[(c[(c[m>>2]|0)+32>>2]|0)+8>>2]|0))break d;c[l>>2]=1830;break a}h=c[t>>2]|0;g=c[(c[(c[m>>2]|0)+32>>2]|0)+8>>2]|0;if((c[c[m>>2]>>2]|0)==1011){if(h>>>0>=g>>>0)break d;c[l>>2]=1831;break a}else{if(h>>>0<=g>>>0)break d;c[l>>2]=1832;break a}}}while(0);c[l>>2]=-1;break a}while(0);c[l>>2]=0}while(0);i=j;return c[l>>2]|0}function mI(a,b,d,f,g,h){a=a|0;b=b|0;d=d|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+48|0;k=j;l=j+36|0;m=j+32|0;n=j+28|0;o=j+24|0;p=j+20|0;q=j+16|0;r=j+12|0;s=j+8|0;c[m>>2]=a;c[n>>2]=b;c[o>>2]=d;c[p>>2]=f;c[q>>2]=g;c[r>>2]=h;c[s>>2]=0;if((c[q>>2]|0)==0|(c[m>>2]|0)==0){c[l>>2]=-1;t=c[l>>2]|0;i=j;return t|0}c[c[q>>2]>>2]=0;if(((c[c[m>>2]>>2]|0)!=1009?(c[c[m>>2]>>2]|0)!=1010:0)?(c[c[m>>2]>>2]|0)!=1011:0){c[l>>2]=-1;t=c[l>>2]|0;i=j;return t|0}do if(c[(c[m>>2]|0)+32>>2]|0){if((c[c[(c[m>>2]|0)+32>>2]>>2]|0)!=3?(c[c[(c[m>>2]|0)+32>>2]>>2]|0)!=33:0)break;if(!((e[(c[(c[m>>2]|0)+32>>2]|0)+24>>1]|0)>>>1&127)){if((c[p>>2]|0)!=0?(c[c[p>>2]>>2]|0)==43:0)c[s>>2]=c[(c[p>>2]|0)+12>>2];else u=15;a:do if((u|0)==15){if((c[p>>2]|0)!=0?(c[c[p>>2]>>2]|0)==44:0){c[s>>2]=c[(c[p>>2]|0)+12>>2];break}switch(c[n>>2]|0){case 28:case 21:{c[l>>2]=0;t=c[l>>2]|0;i=j;return t|0}case 29:case 23:case 22:case 20:case 18:case 17:case 16:case 24:{if(!(c[o>>2]|0))break a;c[s>>2]=FI(c[o>>2]|0)|0;break a;break}case 2:case 1:{if(!(c[r>>2]|0)){h=c[o>>2]|0;if((c[n>>2]|0)==1){c[s>>2]=Dy(h)|0;break a}else{c[s>>2]=FI(h)|0;break a}}if(!(c[o>>2]|0))break a;h=c[o>>2]|0;if((c[r>>2]|0)==3){c[s>>2]=FI(h)|0;break a}else{c[s>>2]=Dy(h)|0;break a}break}default:{h=c[33976]|0;g=c[33980]|0;c[k>>2]=171992;c[k+4>>2]=5207;Db[h&511](g,171960,k);break a}}}while(0);c[c[q>>2]>>2]=c[s>>2];do if((c[c[m>>2]>>2]|0)==1009){if((c[s>>2]|0)!=(c[(c[(c[m>>2]|0)+32>>2]|0)+8>>2]|0)){c[l>>2]=1830;t=c[l>>2]|0;i=j;return t|0}}else{g=c[s>>2]|0;h=c[(c[(c[m>>2]|0)+32>>2]|0)+8>>2]|0;if((c[c[m>>2]>>2]|0)==1011){if(g>>>0>=h>>>0)break;c[l>>2]=1831;t=c[l>>2]|0;i=j;return t|0}else{if(g>>>0<=h>>>0)break;c[l>>2]=1832;t=c[l>>2]|0;i=j;return t|0}}while(0);c[l>>2]=0;t=c[l>>2]|0;i=j;return t|0}}while(0);c[l>>2]=-1;t=c[l>>2]|0;i=j;return t|0}function nI(a,d){a=a|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;j=e;k=e+12|0;l=e+8|0;c[g>>2]=a;h[j>>3]=d;if(!(c[g>>2]|0)){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}if(!(((c[c[g>>2]>>2]|0)!=4?(c[c[g>>2]>>2]|0)!=11:0)?(c[c[g>>2]>>2]|0)!=10:0))n=6;if((n|0)==6?((b[(c[g>>2]|0)+24>>1]<<3&65535)<<16>>16>>4<<16>>16|0)!=0:0){c[k>>2]=hI(12)|0;if(!(c[k>>2]|0)){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}n=(c[k>>2]|0)+16|0;h[n>>3]=+h[n>>3]-+h[j>>3];c[l>>2]=GI(c[g>>2]|0,c[k>>2]|0)|0;if(!(c[l>>2]|0)){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}else{PH(c[k>>2]|0);c[f>>2]=c[l>>2];m=c[f>>2]|0;i=e;return m|0}}c[f>>2]=jI(c[g>>2]|0)|0;m=c[f>>2]|0;i=e;return m|0}function oI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=SA()|0;if(!(c[f>>2]|0)){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}c[c[f>>2]>>2]=1011;a=hI(33)|0;c[(c[f>>2]|0)+32>>2]=a;if(!(c[(c[f>>2]|0)+32>>2]|0)){zb[c[135736>>2]&511](c[f>>2]|0);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{c[(c[(c[f>>2]|0)+32>>2]|0)+8>>2]=c[e>>2];c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function pI(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;i=i+48|0;h=g+44|0;j=g+40|0;k=g+36|0;l=g+32|0;m=g+28|0;n=g+24|0;o=g+20|0;p=g+16|0;q=g+12|0;r=g+8|0;s=g+4|0;t=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=0;c[o>>2]=0;c[p>>2]=0;c[r>>2]=c[c[j>>2]>>2];c[s>>2]=0;c[t>>2]=0;if((d[c[r>>2]>>0]|0|0)>=48?(d[c[r>>2]>>0]|0|0)<=57:0){while(1){u=c[r>>2]|0;if((d[c[r>>2]>>0]|0|0)!=48)break;c[r>>2]=u+1}c[q>>2]=u;while(1){if((d[c[q>>2]>>0]|0|0)!=0?(d[c[q>>2]>>0]|0|0)>=48:0)v=(d[c[q>>2]>>0]|0|0)<=57;else v=0;w=c[t>>2]|0;if(!v)break;c[t>>2]=w+1;c[q>>2]=(c[q>>2]|0)+1;c[s>>2]=(c[s>>2]|0)+1}if((w|0)>24){c[c[j>>2]>>2]=c[q>>2];c[h>>2]=-1;x=c[h>>2]|0;i=g;return x|0}while(1){if((c[t>>2]|0)<=16)break;q=(c[p>>2]|0)*10|0;w=c[r>>2]|0;c[r>>2]=w+1;c[p>>2]=q+((d[w>>0]|0)-48);c[t>>2]=(c[t>>2]|0)+-1}while(1){if((c[t>>2]|0)<=8)break;w=(c[o>>2]|0)*10|0;q=c[r>>2]|0;c[r>>2]=q+1;c[o>>2]=w+((d[q>>0]|0)-48);c[t>>2]=(c[t>>2]|0)+-1}while(1){if((c[t>>2]|0)<=0)break;q=(c[n>>2]|0)*10|0;w=c[r>>2]|0;c[r>>2]=w+1;c[n>>2]=q+((d[w>>0]|0)-48);c[t>>2]=(c[t>>2]|0)+-1}c[c[j>>2]>>2]=c[r>>2];c[c[k>>2]>>2]=c[n>>2];c[c[l>>2]>>2]=c[o>>2];c[c[m>>2]>>2]=c[p>>2];c[h>>2]=c[s>>2];x=c[h>>2]|0;i=g;return x|0}c[h>>2]=-2;x=c[h>>2]|0;i=g;return x|0}function qI(a,e,f,g){a=a|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+48|0;k=j+32|0;l=j+28|0;m=j+24|0;n=j+20|0;o=j+16|0;p=j+12|0;q=j+8|0;r=j+4|0;s=j;c[l>>2]=a;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[r>>2]=c[m>>2];if(!(c[m>>2]|0)){c[k>>2]=-1;t=c[k>>2]|0;i=j;return t|0}a:do if(c[o>>2]|0)while(1){do if((d[c[r>>2]>>0]|0|0)!=32){if(9<=(d[c[r>>2]>>0]|0|0)?(d[c[r>>2]>>0]|0|0)<=10:0)break;if((d[c[r>>2]>>0]|0|0)!=13)break a}while(0);c[r>>2]=(c[r>>2]|0)+1}while(0);if(((d[c[r>>2]>>0]|0|0)!=45?(d[c[r>>2]>>0]|0|0)<48:0)?(d[c[r>>2]>>0]|0|0)>57:0){c[k>>2]=1;t=c[k>>2]|0;i=j;return t|0}c[p>>2]=hI(0)|0;if(!(c[p>>2]|0)){c[k>>2]=-1;t=c[k>>2]|0;i=j;return t|0}b:do if((d[c[r>>2]>>0]|0|0)==45?(d[(c[r>>2]|0)+1>>0]|0|0)==45:0){c[r>>2]=(c[r>>2]|0)+2;if((d[c[r>>2]>>0]|0|0)==45){if((c[l>>2]|0)==6)break;c[r>>2]=(c[r>>2]|0)+1;c[q>>2]=HI((c[p>>2]|0)+8|0,r)|0;if(c[q>>2]|0)break;if((((d[c[r>>2]>>0]|0|0)!=0?(d[c[r>>2]>>0]|0|0)!=90:0)?(d[c[r>>2]>>0]|0|0)!=43:0)?(d[c[r>>2]>>0]|0|0)!=45:0)break;c[q>>2]=II((c[p>>2]|0)+8|0,r)|0;if(c[q>>2]|0)break;if(d[c[r>>2]>>0]|0)break;c[c[p>>2]>>2]=5;u=123;break}c[q>>2]=JI((c[p>>2]|0)+8|0,r)|0;if(!(c[q>>2]|0)){if((d[c[r>>2]>>0]|0|0)==45){c[s>>2]=c[r>>2];c[r>>2]=(c[r>>2]|0)+1;c[q>>2]=HI((c[p>>2]|0)+8|0,r)|0;do if(!(c[q>>2]|0)){if((d[c[r>>2]>>0]|0|0)!=0?(d[c[r>>2]>>0]|0|0)==58:0)break;if(((c[(c[p>>2]|0)+8>>2]|0)%4|0|0)==0?((c[(c[p>>2]|0)+8>>2]|0)%100|0|0)!=0:0)u=35;else if((c[(c[p>>2]|0)+8>>2]|0)%400|0){if(((c[(c[p>>2]|0)+12>>2]|0)>>>4&31)>>>0>(c[171912+((c[(c[p>>2]|0)+12>>2]&15)-1<<2)>>2]|0)>>>0)break}else u=35;if((u|0)==35?((c[(c[p>>2]|0)+12>>2]|0)>>>4&31)>>>0>(c[171864+((c[(c[p>>2]|0)+12>>2]&15)-1<<2)>>2]|0)>>>0:0)break;if((((d[c[r>>2]>>0]|0|0)!=0?(d[c[r>>2]>>0]|0|0)!=90:0)?(d[c[r>>2]>>0]|0|0)!=43:0)?(d[c[r>>2]>>0]|0|0)!=45:0)break b;c[q>>2]=II((c[p>>2]|0)+8|0,r)|0;if(c[q>>2]|0)break b;if(d[c[r>>2]>>0]|0)break b;c[c[p>>2]>>2]=7;u=123;break b}while(0);c[r>>2]=c[s>>2]}if((((d[c[r>>2]>>0]|0|0)!=0?(d[c[r>>2]>>0]|0|0)!=90:0)?(d[c[r>>2]>>0]|0|0)!=43:0)?(d[c[r>>2]>>0]|0|0)!=45:0)break;c[q>>2]=II((c[p>>2]|0)+8|0,r)|0;if((c[q>>2]|0)==0?(d[c[r>>2]>>0]|0|0)==0:0){c[c[p>>2]>>2]=6;u=123}}}else u=52;while(0);c:do if((u|0)==52){do if(((d[c[r>>2]>>0]|0|0)>=48?(d[c[r>>2]>>0]|0|0)<=57:0)?(c[q>>2]=KI((c[p>>2]|0)+8|0,r)|0,(c[q>>2]|0)==0):0){if((((d[c[r>>2]>>0]|0|0)!=0?(d[c[r>>2]>>0]|0|0)!=90:0)?(d[c[r>>2]>>0]|0|0)!=43:0)?(d[c[r>>2]>>0]|0|0)!=45:0)break;c[q>>2]=II((c[p>>2]|0)+8|0,r)|0;if(!(c[q>>2]|0)){if(d[c[r>>2]>>0]|0)break c;c[c[p>>2]>>2]=4;u=123;break c}}while(0);c[r>>2]=c[m>>2];c[q>>2]=LI((c[p>>2]|0)+8|0,r)|0;if(!(c[q>>2]|0)){if(!((((d[c[r>>2]>>0]|0|0)!=0?(d[c[r>>2]>>0]|0|0)!=90:0)?(d[c[r>>2]>>0]|0|0)!=43:0)?(d[c[r>>2]>>0]|0|0)!=45:0))u=67;if((u|0)==67?(c[q>>2]=II((c[p>>2]|0)+8|0,r)|0,(c[q>>2]|0)==0):0){if(d[c[r>>2]>>0]|0)break;c[c[p>>2]>>2]=8;u=123;break}if((d[c[r>>2]>>0]|0|0)==45?(c[r>>2]=(c[r>>2]|0)+1,c[q>>2]=JI((c[p>>2]|0)+8|0,r)|0,(c[q>>2]|0)==0):0){if(!((((d[c[r>>2]>>0]|0|0)!=0?(d[c[r>>2]>>0]|0|0)!=90:0)?(d[c[r>>2]>>0]|0|0)!=43:0)?(d[c[r>>2]>>0]|0|0)!=45:0))u=76;if((u|0)==76?(c[q>>2]=II((c[p>>2]|0)+8|0,r)|0,(c[q>>2]|0)==0):0){if(d[c[r>>2]>>0]|0)break;c[c[p>>2]>>2]=9;u=123;break}if(((((d[c[r>>2]>>0]|0|0)==45?(c[r>>2]=(c[r>>2]|0)+1,c[q>>2]=HI((c[p>>2]|0)+8|0,r)|0,(c[q>>2]|0)==0):0)?(c[(c[p>>2]|0)+8>>2]|0)!=0:0)?(c[(c[p>>2]|0)+12>>2]&15|0)>=1:0)?(c[(c[p>>2]|0)+12>>2]&15|0)<=12:0){if(((c[(c[p>>2]|0)+8>>2]|0)%4|0|0)==0?((c[(c[p>>2]|0)+8>>2]|0)%100|0|0)!=0:0)u=87;else if((c[(c[p>>2]|0)+8>>2]|0)%400|0){if(((c[(c[p>>2]|0)+12>>2]|0)>>>4&31)>>>0>(c[171912+((c[(c[p>>2]|0)+12>>2]&15)-1<<2)>>2]|0)>>>0)break}else u=87;if((u|0)==87?((c[(c[p>>2]|0)+12>>2]|0)>>>4&31)>>>0>(c[171864+((c[(c[p>>2]|0)+12>>2]&15)-1<<2)>>2]|0)>>>0:0)break;do if(d[c[r>>2]>>0]|0){if((d[c[r>>2]>>0]|0|0)==90){u=93;break}if((d[c[r>>2]>>0]|0|0)==43){u=93;break}if((d[c[r>>2]>>0]|0|0)==45)u=93}else u=93;while(0);do if((u|0)==93){c[q>>2]=II((c[p>>2]|0)+8|0,r)|0;if(c[q>>2]|0)break;if(d[c[r>>2]>>0]|0)break c;c[c[p>>2]>>2]=10;u=123;break c}while(0);if((d[c[r>>2]>>0]|0|0)==84){c[r>>2]=(c[r>>2]|0)+1;c[q>>2]=KI((c[p>>2]|0)+8|0,r)|0;if(c[q>>2]|0)break;c[q>>2]=II((c[p>>2]|0)+8|0,r)|0;d:do if(c[o>>2]|0)while(1){do if((d[c[r>>2]>>0]|0|0)!=32){if(9<=(d[c[r>>2]>>0]|0|0)?(d[c[r>>2]>>0]|0|0)<=10:0)break;if((d[c[r>>2]>>0]|0|0)!=13)break d}while(0);c[r>>2]=(c[r>>2]|0)+1}while(0);if(c[q>>2]|0)break;if(d[c[r>>2]>>0]|0)break;if(!(c[(c[p>>2]|0)+8>>2]|0))break;if((c[(c[p>>2]|0)+12>>2]&15|0)<1)break;if((c[(c[p>>2]|0)+12>>2]&15|0)>12)break;if(((c[(c[p>>2]|0)+8>>2]|0)%4|0|0)==0?((c[(c[p>>2]|0)+8>>2]|0)%100|0|0)!=0:0)u=112;else u=111;do if((u|0)==111){if(!((c[(c[p>>2]|0)+8>>2]|0)%400|0)){u=112;break}if(((c[(c[p>>2]|0)+12>>2]|0)>>>4&31)>>>0>(c[171912+((c[(c[p>>2]|0)+12>>2]&15)-1<<2)>>2]|0)>>>0)break c}while(0);if((u|0)==112?((c[(c[p>>2]|0)+12>>2]|0)>>>4&31)>>>0>(c[171864+((c[(c[p>>2]|0)+12>>2]&15)-1<<2)>>2]|0)>>>0:0)break;if(((c[(c[p>>2]|0)+12>>2]|0)>>>9&31|0)<0)break;if(((c[(c[p>>2]|0)+12>>2]|0)>>>9&31|0)>23)break;if(((c[(c[p>>2]|0)+12>>2]|0)>>>14&63|0)<0)break;if(((c[(c[p>>2]|0)+12>>2]|0)>>>14&63|0)>59)break;if(!(+h[(c[p>>2]|0)+16>>3]>=0))break;if(!(+h[(c[p>>2]|0)+16>>3]<60))break;if(((b[(c[p>>2]|0)+24>>1]<<3&65535)<<16>>16>>4<<16>>16|0)<=-840)break;if(((b[(c[p>>2]|0)+24>>1]<<3&65535)<<16>>16>>4<<16>>16|0)>=840)break;c[c[p>>2]>>2]=11;u=123}}}}}while(0);do if((u|0)==123){if((c[l>>2]|0)!=0?(c[l>>2]|0)!=(c[c[p>>2]>>2]|0):0)break;r=c[p>>2]|0;if(c[n>>2]|0)c[c[n>>2]>>2]=r;else PH(r);c[k>>2]=0;t=c[k>>2]|0;i=j;return t|0}while(0);if(c[p>>2]|0)PH(c[p>>2]|0);c[k>>2]=1;t=c[k>>2]|0;i=j;return t|0}function rI(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+64|0;j=g+52|0;k=g+44|0;l=g+40|0;m=g+36|0;n=g+32|0;o=g+28|0;p=g+24|0;q=g+20|0;r=g+8|0;s=g+16|0;t=g;c[g+48>>2]=a;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=c[k>>2];c[p>>2]=0;c[q>>2]=0;c[s>>2]=0;if(!(c[k>>2]|0)){c[j>>2]=-1;u=c[j>>2]|0;i=g;return u|0}a:do if(c[m>>2]|0)while(1){do if((d[c[n>>2]>>0]|0|0)!=32){if(9<=(d[c[n>>2]>>0]|0|0)?(d[c[n>>2]>>0]|0|0)<=10:0)break;if((d[c[n>>2]>>0]|0|0)!=13)break a}while(0);c[n>>2]=(c[n>>2]|0)+1}while(0);if((d[c[n>>2]>>0]|0|0)==45){c[p>>2]=1;c[n>>2]=(c[n>>2]|0)+1}k=c[n>>2]|0;c[n>>2]=k+1;if((d[k>>0]|0|0)!=80){c[j>>2]=1;u=c[j>>2]|0;i=g;return u|0}if(!(d[c[n>>2]>>0]|0)){c[j>>2]=1;u=c[j>>2]|0;i=g;return u|0}c[o>>2]=hI(12)|0;if(!(c[o>>2]|0)){c[j>>2]=-1;u=c[j>>2]|0;i=g;return u|0}b:while(1){if(!(d[c[n>>2]>>0]|0)){v=55;break}if((c[q>>2]|0)>>>0>=6){v=61;break}k=c[q>>2]|0;if((d[c[n>>2]>>0]|0|0)!=84){if((k|0)==3){v=61;break}}else{if(k>>>0>3){v=22;break}c[q>>2]=3;c[n>>2]=(c[n>>2]|0)+1}h[r>>3]=0;c:do if((d[c[n>>2]>>0]|0|0)>=48?(d[c[n>>2]>>0]|0|0)<=57:0)while(1){if((d[c[n>>2]>>0]|0|0)<48)break c;if((d[c[n>>2]>>0]|0|0)>57)break c;h[r>>3]=+h[r>>3]*10+ +((d[c[n>>2]>>0]|0)-48|0);c[n>>2]=(c[n>>2]|0)+1}else v=26;while(0);if((v|0)==26){v=0;c[s>>2]=-1}d:do if((c[s>>2]|0)==0?(d[c[n>>2]>>0]|0|0)==46:0){h[t>>3]=1;c[n>>2]=(c[n>>2]|0)+1;if((d[c[n>>2]>>0]|0|0)>=48?(d[c[n>>2]>>0]|0|0)<=57:0)c[s>>2]=1;else c[s>>2]=-1;while(1){if((d[c[n>>2]>>0]|0|0)<48)break d;if((d[c[n>>2]>>0]|0|0)>57)break d;h[t>>3]=+h[t>>3]/10;h[r>>3]=+h[r>>3]+ +((d[c[n>>2]>>0]|0)-48|0)*+h[t>>3];c[n>>2]=(c[n>>2]|0)+1}}while(0);if((c[s>>2]|0)==-1){v=61;break}if(!(d[c[n>>2]>>0]|0)){v=61;break}while(1){if((c[q>>2]|0)>>>0>=6)break;if((d[c[n>>2]>>0]|0|0)==(d[172280+(c[q>>2]|0)>>0]|0|0)){v=43;break}k=(c[q>>2]|0)+1|0;c[q>>2]=k;if((k|0)==3|(c[q>>2]|0)==6){v=61;break b}}do if((v|0)==43){v=0;if((c[s>>2]|0)!=0&(c[q>>2]|0)>>>0<5){v=61;break b}k=c[q>>2]|0;if((k|0)==1){f=(c[o>>2]|0)+8|0;c[f>>2]=(c[f>>2]|0)+~~+h[r>>3];break}else if(!k){c[(c[o>>2]|0)+8>>2]=~~+h[r>>3]*12;break}else{k=(c[o>>2]|0)+16|0;h[k>>3]=+h[k>>3]+ +h[r>>3]*+h[172288+(c[q>>2]<<3)>>3];c[q>>2]=(c[q>>2]|0)+1;break}}while(0);c[n>>2]=(c[n>>2]|0)+1;if(!(c[m>>2]|0))continue;while(1){do if((d[c[n>>2]>>0]|0|0)!=32){if(9<=(d[c[n>>2]>>0]|0|0)?(d[c[n>>2]>>0]|0|0)<=10:0)break;if((d[c[n>>2]>>0]|0|0)!=13)continue b}while(0);c[n>>2]=(c[n>>2]|0)+1}}if((v|0)==22){c[j>>2]=1;u=c[j>>2]|0;i=g;return u|0}else if((v|0)==55){if(c[p>>2]|0){c[(c[o>>2]|0)+8>>2]=0-(c[(c[o>>2]|0)+8>>2]|0);c[(c[o>>2]|0)+12>>2]=0-(c[(c[o>>2]|0)+12>>2]|0);h[(c[o>>2]|0)+16>>3]=-+h[(c[o>>2]|0)+16>>3]}p=c[o>>2]|0;if(c[l>>2]|0)c[c[l>>2]>>2]=p;else PH(p);c[j>>2]=0;u=c[j>>2]|0;i=g;return u|0}else if((v|0)==61){if(c[o>>2]|0)PH(c[o>>2]|0);c[j>>2]=1;u=c[j>>2]|0;i=g;return u|0}return 0}function sI(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+48|0;j=h+36|0;k=h+32|0;l=h+28|0;m=h+24|0;n=h+20|0;o=h+16|0;p=h+12|0;q=h+8|0;r=h+4|0;s=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;c[r>>2]=0;c[s>>2]=0;if(!(c[l>>2]|0)){c[j>>2]=-1;t=c[j>>2]|0;i=h;return t|0}c[o>>2]=my(c[l>>2]|0)|0;if(!(c[o>>2]|0)){c[j>>2]=-1;t=c[j>>2]|0;i=h;return t|0}if(c[m>>2]|0)c[c[m>>2]>>2]=0;c[p>>2]=c[o>>2];a:while(1){do if((d[c[p>>2]>>0]|0|0)!=32){if(9<=(d[c[p>>2]>>0]|0|0)?(d[c[p>>2]>>0]|0|0)<=10:0)break;if((d[c[p>>2]>>0]|0|0)!=13)break a}while(0);m=c[p>>2]|0;c[p>>2]=m+1;a[m>>0]=0}b:while(1){if(!(d[c[p>>2]>>0]|0))break;do if((d[c[p>>2]>>0]|0|0)!=32){if(9<=(d[c[p>>2]>>0]|0|0)?(d[c[p>>2]>>0]|0|0)<=10:0)break;if((d[c[p>>2]>>0]|0|0)!=13){c[r>>2]=(c[r>>2]|0)+1;c[p>>2]=(c[p>>2]|0)+1;while(1){if(!(d[c[p>>2]>>0]|0))continue b;do if((d[c[p>>2]>>0]|0|0)==32)u=1;else{if(9<=(d[c[p>>2]>>0]|0|0)?(d[c[p>>2]>>0]|0|0)<=10:0){u=1;break}u=(d[c[p>>2]>>0]|0|0)==13}while(0);if(!(u^1))continue b;c[p>>2]=(c[p>>2]|0)+1}}}while(0);a[c[p>>2]>>0]=0;c[p>>2]=(c[p>>2]|0)+1;while(1){do if((d[c[p>>2]>>0]|0|0)!=32){if(9<=(d[c[p>>2]>>0]|0|0)?(d[c[p>>2]>>0]|0|0)<=10:0)break;if((d[c[p>>2]>>0]|0|0)!=13)continue b}while(0);m=c[p>>2]|0;c[p>>2]=m+1;a[m>>0]=0}}if(!(c[r>>2]|0)){zb[c[135736>>2]&511](c[o>>2]|0);c[j>>2]=c[r>>2];t=c[j>>2]|0;i=h;return t|0}c[q>>2]=c[p>>2];c[p>>2]=c[o>>2];while(1){if(d[c[p>>2]>>0]|0)break;if((c[p>>2]|0)==(c[q>>2]|0))break;c[p>>2]=(c[p>>2]|0)+1}c:while(1){if((c[p>>2]|0)==(c[q>>2]|0))break;c[s>>2]=TH(c[k>>2]|0,c[p>>2]|0,0,c[n>>2]|0)|0;if(c[s>>2]|0)break;while(1){if(!(d[c[p>>2]>>0]|0))break;c[p>>2]=(c[p>>2]|0)+1}while(1){if(d[c[p>>2]>>0]|0)continue c;if((c[p>>2]|0)==(c[q>>2]|0))continue c;c[p>>2]=(c[p>>2]|0)+1}}zb[c[135736>>2]&511](c[o>>2]|0);if(!(c[s>>2]|0)){c[j>>2]=c[r>>2];t=c[j>>2]|0;i=h;return t|0}else{c[j>>2]=-1;t=c[j>>2]|0;i=h;return t|0}return 0}function tI(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+32|0;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;j=b;c[f>>2]=a;c[g>>2]=c[f>>2];if(!(c[f>>2]|0)){c[e>>2]=0;k=c[e>>2]|0;i=b;return k|0}while(1){do if(d[c[g>>2]>>0]|0)if((d[c[g>>2]>>0]|0|0)==32)l=1;else{if(9<=(d[c[g>>2]>>0]|0|0)?(d[c[g>>2]>>0]|0|0)<=10:0){l=1;break}l=(d[c[g>>2]>>0]|0|0)==13}else l=0;while(0);m=c[g>>2]|0;if(!l)break;c[g>>2]=m+1}c[h>>2]=m;while(1){n=c[h>>2]|0;if(!(d[c[h>>2]>>0]|0))break;c[h>>2]=n+1}c[j>>2]=n;c[h>>2]=(c[h>>2]|0)+-1;while(1){do if((c[h>>2]|0)>>>0>(c[g>>2]|0)>>>0)if((d[c[h>>2]>>0]|0|0)==32)o=1;else{if(9<=(d[c[h>>2]>>0]|0|0)?(d[c[h>>2]>>0]|0|0)<=10:0){o=1;break}o=(d[c[h>>2]>>0]|0|0)==13}else o=0;while(0);p=c[h>>2]|0;if(!o)break;c[h>>2]=p+-1}c[h>>2]=p+1;if((c[g>>2]|0)==(c[f>>2]|0)?(c[j>>2]|0)==(c[h>>2]|0):0){c[e>>2]=0;k=c[e>>2]|0;i=b;return k|0}c[e>>2]=ly(c[g>>2]|0,(c[h>>2]|0)-(c[g>>2]|0)|0)|0;k=c[e>>2]|0;i=b;return k|0}function uI(b){b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+4|0;a[g>>0]=b;if(65<=(d[g>>0]|0|0)?(d[g>>0]|0|0)<=90:0)c[f>>2]=(d[g>>0]|0)-65;else h=4;do if((h|0)==4){if(97<=(d[g>>0]|0|0)?(d[g>>0]|0|0)<=122:0){c[f>>2]=(d[g>>0]|0)-97+26;break}if(48<=(d[g>>0]|0|0)?(d[g>>0]|0|0)<=57:0){c[f>>2]=(d[g>>0]|0)-48+52;break}if(43==(d[g>>0]|0|0)){c[f>>2]=62;break}if(47==(d[g>>0]|0|0)){c[f>>2]=63;break}if(61==(d[g>>0]|0|0)){c[f>>2]=64;break}else{c[f>>2]=-1;break}}while(0);i=e;return c[f>>2]|0}function vI(a,d){a=a|0;d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;i=i+64|0;g=f+48|0;h=f+44|0;j=f+40|0;k=f+36|0;l=f+32|0;m=f+28|0;n=f+24|0;o=f+20|0;p=f+16|0;q=f+12|0;r=f+8|0;s=f+4|0;t=f;c[h>>2]=a;c[j>>2]=d;c[l>>2]=1;a:do if(b[(c[h>>2]|0)+24>>1]&1){if(((c[(c[h>>2]|0)+8>>2]|0)==0?(c[(c[h>>2]|0)+12>>2]|0)==0:0)?(c[(c[h>>2]|0)+16>>2]|0)==0:0){u=11;break}do if(b[(c[j>>2]|0)+24>>1]&1){if(((c[(c[j>>2]|0)+8>>2]|0)==0?(c[(c[j>>2]|0)+12>>2]|0)==0:0)?(c[(c[j>>2]|0)+16>>2]|0)==0:0)break;c[l>>2]=-1;break a}while(0);c[g>>2]=-1;v=c[g>>2]|0;i=f;return v|0}else u=11;while(0);do if((u|0)==11?(b[(c[j>>2]|0)+24>>1]&1|0)!=0:0){if(((c[(c[j>>2]|0)+8>>2]|0)==0?(c[(c[j>>2]|0)+12>>2]|0)==0:0)?(c[(c[j>>2]|0)+16>>2]|0)==0:0)break;c[g>>2]=1;v=c[g>>2]|0;i=f;return v|0}while(0);c[m>>2]=((e[(c[h>>2]|0)+24>>1]|0)>>>8&65535)-((e[(c[h>>2]|0)+24>>1]|0)>>>1&127);c[n>>2]=((e[(c[j>>2]|0)+24>>1]|0)>>>8&65535)-((e[(c[j>>2]|0)+24>>1]|0)>>>1&127);if((c[m>>2]|0)==1?(c[(c[h>>2]|0)+8>>2]|0)==0:0){if((c[n>>2]|0)!=1){c[g>>2]=0-(c[l>>2]|0);v=c[g>>2]|0;i=f;return v|0}if(c[(c[j>>2]|0)+8>>2]|0){c[g>>2]=0-(c[l>>2]|0);v=c[g>>2]|0;i=f;return v|0}else{c[g>>2]=0;v=c[g>>2]|0;i=f;return v|0}}if((c[n>>2]|0)==1?(c[(c[j>>2]|0)+8>>2]|0)==0:0){if((c[m>>2]|0)!=1){c[g>>2]=c[l>>2];v=c[g>>2]|0;i=f;return v|0}if(c[(c[h>>2]|0)+8>>2]|0){c[g>>2]=c[l>>2];v=c[g>>2]|0;i=f;return v|0}else{c[g>>2]=0;v=c[g>>2]|0;i=f;return v|0}}if((c[m>>2]|0)>(c[n>>2]|0)){c[g>>2]=c[l>>2];v=c[g>>2]|0;i=f;return v|0}if((c[n>>2]|0)>(c[m>>2]|0)){c[g>>2]=0-(c[l>>2]|0);v=c[g>>2]|0;i=f;return v|0}c[o>>2]=((e[(c[h>>2]|0)+24>>1]|0)>>>8&65535)-((e[(c[j>>2]|0)+24>>1]|0)>>>8&65535);if((c[o>>2]|0)<0){c[k>>2]=c[h>>2];c[p>>2]=c[(c[j>>2]|0)+16>>2];c[q>>2]=c[(c[j>>2]|0)+12>>2];c[r>>2]=c[(c[j>>2]|0)+8>>2];c[o>>2]=0-(c[o>>2]|0);c[l>>2]=0-(c[l>>2]|0)}else{c[k>>2]=c[j>>2];c[p>>2]=c[(c[h>>2]|0)+16>>2];c[q>>2]=c[(c[h>>2]|0)+12>>2];c[r>>2]=c[(c[h>>2]|0)+8>>2]}while(1){if((c[o>>2]|0)<=8)break;c[r>>2]=c[q>>2];c[q>>2]=c[p>>2];c[p>>2]=0;c[o>>2]=(c[o>>2]|0)-8}while(1){w=c[p>>2]|0;if((c[o>>2]|0)<=0)break;c[s>>2]=ca((w>>>0)%10|0,1e8)|0;c[p>>2]=((c[p>>2]|0)>>>0)/10|0;c[t>>2]=ca(((c[q>>2]|0)>>>0)%10|0,1e8)|0;c[q>>2]=(((c[q>>2]|0)+(c[s>>2]|0)|0)>>>0)/10|0;c[r>>2]=(((c[r>>2]|0)+(c[t>>2]|0)|0)>>>0)/10|0;c[o>>2]=(c[o>>2]|0)+-1}if(w>>>0>(c[(c[k>>2]|0)+16>>2]|0)>>>0){c[g>>2]=c[l>>2];v=c[g>>2]|0;i=f;return v|0}if((c[p>>2]|0)==(c[(c[k>>2]|0)+16>>2]|0)){if((c[q>>2]|0)>>>0>(c[(c[k>>2]|0)+12>>2]|0)>>>0){c[g>>2]=c[l>>2];v=c[g>>2]|0;i=f;return v|0}if((c[q>>2]|0)==(c[(c[k>>2]|0)+12>>2]|0)){if((c[r>>2]|0)>>>0>(c[(c[k>>2]|0)+8>>2]|0)>>>0){c[g>>2]=c[l>>2];v=c[g>>2]|0;i=f;return v|0}if((c[r>>2]|0)==(c[(c[k>>2]|0)+8>>2]|0))if(((e[(c[h>>2]|0)+24>>1]|0)>>>8&65535|0)==((e[(c[j>>2]|0)+24>>1]|0)>>>8&65535|0)){c[g>>2]=0;v=c[g>>2]|0;i=f;return v|0}else{c[g>>2]=c[l>>2];v=c[g>>2]|0;i=f;return v|0}}}c[g>>2]=0-(c[l>>2]|0);v=c[g>>2]|0;i=f;return v|0}function wI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+64|0;e=d+52|0;f=d+48|0;g=d+44|0;j=d+40|0;k=d+36|0;l=d+32|0;m=d;n=d+28|0;o=d+24|0;p=d+20|0;q=d+16|0;r=d+12|0;s=d+8|0;c[f>>2]=a;c[g>>2]=b;c[n>>2]=1;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){c[e>>2]=-2;t=c[e>>2]|0;i=d;return t|0}c[k>>2]=(c[(c[f>>2]|0)+8>>2]|0)-(c[(c[g>>2]|0)+8>>2]|0);h[m>>3]=+h[(c[f>>2]|0)+16>>3]-+h[(c[g>>2]|0)+16>>3];c[j>>2]=~~(+h[m>>3]/86400);h[m>>3]=+h[m>>3]-+(c[j>>2]|0)*86400;c[l>>2]=(c[(c[f>>2]|0)+12>>2]|0)-(c[(c[g>>2]|0)+12>>2]|0)+(c[j>>2]|0);if(!(c[k>>2]|0)){if(c[l>>2]|0)if((c[l>>2]|0)<0){c[e>>2]=-1;t=c[e>>2]|0;i=d;return t|0}else{c[e>>2]=1;t=c[e>>2]|0;i=d;return t|0}if(+h[m>>3]==0){c[e>>2]=0;t=c[e>>2]|0;i=d;return t|0}if(+h[m>>3]<0){c[e>>2]=-1;t=c[e>>2]|0;i=d;return t|0}else{c[e>>2]=1;t=c[e>>2]|0;i=d;return t|0}}j=c[l>>2]|0;do if((c[k>>2]|0)>0){if(!((j|0)>=0&+h[m>>3]>=0)){c[o>>2]=c[k>>2];c[p>>2]=0-(c[l>>2]|0);break}c[e>>2]=1;t=c[e>>2]|0;i=d;return t|0}else{if(!((j|0)<=0&+h[m>>3]<=0)){c[n>>2]=-1;c[o>>2]=0-(c[k>>2]|0);c[p>>2]=c[l>>2];break}c[e>>2]=-1;t=c[e>>2]|0;i=d;return t|0}while(0);c[q>>2]=(c[o>>2]|0)/12|0;if(!(c[q>>2]|0)){c[r>>2]=0;c[s>>2]=0}else{c[s>>2]=((((c[q>>2]|0)+3|0)/4|0)*366|0)+((((c[q>>2]|0)-1|0)%4|0)*365|0);c[r>>2]=(c[s>>2]|0)-1}c[o>>2]=(c[o>>2]|0)%12|0;c[r>>2]=(c[r>>2]|0)+(c[172120+(c[o>>2]<<2)>>2]|0);c[s>>2]=(c[s>>2]|0)+(c[172168+(c[o>>2]<<2)>>2]|0);if((c[s>>2]|0)==(c[r>>2]|0)?(c[s>>2]|0)==(c[p>>2]|0):0){c[e>>2]=0;t=c[e>>2]|0;i=d;return t|0}if((c[s>>2]|0)<(c[p>>2]|0)){c[e>>2]=0-(c[n>>2]|0);t=c[e>>2]|0;i=d;return t|0}if((c[r>>2]|0)>(c[p>>2]|0)){c[e>>2]=c[n>>2];t=c[e>>2]|0;i=d;return t|0}else{c[e>>2]=2;t=c[e>>2]|0;i=d;return t|0}return 0}function xI(e,f){e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=i;i=i+96|0;j=g+76|0;k=g+72|0;l=g+68|0;m=g+83|0;n=g+82|0;o=g+81|0;p=g+80|0;q=g+64|0;r=g+60|0;s=g+56|0;t=g+52|0;u=g+48|0;v=g+44|0;w=g+40|0;x=g+36|0;y=g+16|0;z=g+32|0;A=g+8|0;B=g+28|0;C=g+24|0;D=g;c[k>>2]=e;c[l>>2]=f;if((c[k>>2]|0)==0|(c[l>>2]|0)==0){c[j>>2]=-2;E=c[j>>2]|0;i=g;return E|0}f=(b[(c[l>>2]|0)+24>>1]&1|0)!=0;do if(b[(c[k>>2]|0)+24>>1]&1){if(!f){c[q>>2]=nI(c[k>>2]|0,0)|0;e=MI(c[q>>2]|0)|0;c[u>>2]=e+((c[(c[q>>2]|0)+12>>2]|0)>>>4&31);c[s>>2]=nI(c[l>>2]|0,50400)|0;e=MI(c[s>>2]|0)|0;c[w>>2]=e+((c[(c[s>>2]|0)+12>>2]|0)>>>4&31);if((c[u>>2]|0)<(c[w>>2]|0)){PH(c[q>>2]|0);PH(c[s>>2]|0);c[j>>2]=-1;E=c[j>>2]|0;i=g;return E|0}e=c[q>>2]|0;if((c[u>>2]|0)!=(c[w>>2]|0)){PH(e);PH(c[s>>2]|0);break}h[y>>3]=+((((c[e+12>>2]|0)>>>9&31)*3600|0)+(((c[(c[q>>2]|0)+12>>2]|0)>>>14&63)*60|0)+(((b[(c[q>>2]|0)+24>>1]<<3&65535)<<16>>16>>4<<16>>16)*60|0)|0)+ +h[(c[q>>2]|0)+16>>3]-(+((((c[(c[s>>2]|0)+12>>2]|0)>>>9&31)*3600|0)+(((c[(c[s>>2]|0)+12>>2]|0)>>>14&63)*60|0)+(((b[(c[s>>2]|0)+24>>1]<<3&65535)<<16>>16>>4<<16>>16)*60|0)|0)+ +h[(c[s>>2]|0)+16>>3]);if(+h[y>>3]<0){PH(c[q>>2]|0);PH(c[s>>2]|0);c[j>>2]=-1;E=c[j>>2]|0;i=g;return E|0}c[z>>2]=0;c[t>>2]=nI(c[l>>2]|0,-50400)|0;e=MI(c[t>>2]|0)|0;c[x>>2]=e+((c[(c[t>>2]|0)+12>>2]|0)>>>4&31);do if((c[u>>2]|0)<=(c[x>>2]|0)){if((c[u>>2]|0)==(c[x>>2]|0)){h[y>>3]=+((((c[(c[q>>2]|0)+12>>2]|0)>>>9&31)*3600|0)+(((c[(c[q>>2]|0)+12>>2]|0)>>>14&63)*60|0)+(((b[(c[q>>2]|0)+24>>1]<<3&65535)<<16>>16>>4<<16>>16)*60|0)|0)+ +h[(c[q>>2]|0)+16>>3]-(+((((c[(c[t>>2]|0)+12>>2]|0)>>>9&31)*3600|0)+(((c[(c[t>>2]|0)+12>>2]|0)>>>14&63)*60|0)+(((b[(c[t>>2]|0)+24>>1]<<3&65535)<<16>>16>>4<<16>>16)*60|0)|0)+ +h[(c[t>>2]|0)+16>>3]);if(+h[y>>3]>0){c[z>>2]=1;break}else{c[z>>2]=2;break}}}else c[z>>2]=1;while(0);PH(c[q>>2]|0);PH(c[s>>2]|0);PH(c[t>>2]|0);if(c[z>>2]|0){c[j>>2]=c[z>>2];E=c[j>>2]|0;i=g;return E|0}}}else if(f){c[s>>2]=nI(c[l>>2]|0,0)|0;e=MI(c[s>>2]|0)|0;c[w>>2]=e+((c[(c[s>>2]|0)+12>>2]|0)>>>4&31);c[q>>2]=nI(c[k>>2]|0,-50400)|0;e=MI(c[q>>2]|0)|0;c[u>>2]=e+((c[(c[q>>2]|0)+12>>2]|0)>>>4&31);if((c[u>>2]|0)<(c[w>>2]|0)){PH(c[q>>2]|0);PH(c[s>>2]|0);c[j>>2]=-1;E=c[j>>2]|0;i=g;return E|0}e=c[q>>2]|0;if((c[u>>2]|0)!=(c[w>>2]|0)){PH(e);PH(c[s>>2]|0);break}h[A>>3]=+((((c[e+12>>2]|0)>>>9&31)*3600|0)+(((c[(c[q>>2]|0)+12>>2]|0)>>>14&63)*60|0)+(((b[(c[q>>2]|0)+24>>1]<<3&65535)<<16>>16>>4<<16>>16)*60|0)|0)+ +h[(c[q>>2]|0)+16>>3]-(+((((c[(c[s>>2]|0)+12>>2]|0)>>>9&31)*3600|0)+(((c[(c[s>>2]|0)+12>>2]|0)>>>14&63)*60|0)+(((b[(c[s>>2]|0)+24>>1]<<3&65535)<<16>>16>>4<<16>>16)*60|0)|0)+ +h[(c[s>>2]|0)+16>>3]);if(+h[A>>3]<0){PH(c[q>>2]|0);PH(c[s>>2]|0);c[j>>2]=-1;E=c[j>>2]|0;i=g;return E|0}c[B>>2]=0;c[r>>2]=nI(c[k>>2]|0,50400)|0;e=MI(c[r>>2]|0)|0;c[v>>2]=e+((c[(c[r>>2]|0)+12>>2]|0)>>>4&31);do if((c[v>>2]|0)<=(c[w>>2]|0)){if((c[v>>2]|0)==(c[w>>2]|0)){h[A>>3]=+((((c[(c[r>>2]|0)+12>>2]|0)>>>9&31)*3600|0)+(((c[(c[r>>2]|0)+12>>2]|0)>>>14&63)*60|0)+(((b[(c[r>>2]|0)+24>>1]<<3&65535)<<16>>16>>4<<16>>16)*60|0)|0)+ +h[(c[r>>2]|0)+16>>3]-(+((((c[(c[s>>2]|0)+12>>2]|0)>>>9&31)*3600|0)+(((c[(c[s>>2]|0)+12>>2]|0)>>>14&63)*60|0)+(((b[(c[s>>2]|0)+24>>1]<<3&65535)<<16>>16>>4<<16>>16)*60|0)|0)+ +h[(c[s>>2]|0)+16>>3]);if(+h[A>>3]>0){c[B>>2]=1;break}else{c[B>>2]=2;break}}}else c[B>>2]=1;while(0);PH(c[q>>2]|0);PH(c[s>>2]|0);PH(c[r>>2]|0);if(c[B>>2]|0){c[j>>2]=c[B>>2];E=c[j>>2]|0;i=g;return E|0}}while(0);if((c[c[k>>2]>>2]|0)==(c[c[l>>2]>>2]|0)){c[C>>2]=0;c[s>>2]=nI(c[l>>2]|0,0)|0;B=MI(c[s>>2]|0)|0;c[w>>2]=B+((c[(c[s>>2]|0)+12>>2]|0)>>>4&31);c[q>>2]=nI(c[k>>2]|0,0)|0;B=MI(c[q>>2]|0)|0;c[u>>2]=B+((c[(c[q>>2]|0)+12>>2]|0)>>>4&31);do if((c[u>>2]|0)>=(c[w>>2]|0)){if((c[u>>2]|0)>(c[w>>2]|0)){c[C>>2]=1;break}h[D>>3]=+((((c[(c[q>>2]|0)+12>>2]|0)>>>9&31)*3600|0)+(((c[(c[q>>2]|0)+12>>2]|0)>>>14&63)*60|0)+(((b[(c[q>>2]|0)+24>>1]<<3&65535)<<16>>16>>4<<16>>16)*60|0)|0)+ +h[(c[q>>2]|0)+16>>3]-(+((((c[(c[s>>2]|0)+12>>2]|0)>>>9&31)*3600|0)+(((c[(c[s>>2]|0)+12>>2]|0)>>>14&63)*60|0)+(((b[(c[s>>2]|0)+24>>1]<<3&65535)<<16>>16>>4<<16>>16)*60|0)|0)+ +h[(c[s>>2]|0)+16>>3]);if(+h[D>>3]<0){c[C>>2]=-1;break}if(+h[D>>3]>0)c[C>>2]=1}else c[C>>2]=-1;while(0);PH(c[q>>2]|0);PH(c[s>>2]|0);c[j>>2]=c[C>>2];E=c[j>>2]|0;i=g;return E|0}switch(c[c[k>>2]>>2]|0){case 6:{a[m>>0]=2;break}case 5:{a[m>>0]=3;break}case 9:{a[m>>0]=3;break}case 7:{a[m>>0]=6;break}case 4:{a[m>>0]=8;break}case 11:{a[m>>0]=15;break}case 10:{a[m>>0]=7;break}case 8:{a[m>>0]=1;break}default:a[m>>0]=0}switch(c[c[l>>2]>>2]|0){case 11:{a[n>>0]=15;break}case 10:{a[n>>0]=7;break}case 8:{a[n>>0]=1;break}case 6:{a[n>>0]=2;break}case 5:{a[n>>0]=3;break}case 9:{a[n>>0]=3;break}case 7:{a[n>>0]=6;break}case 4:{a[n>>0]=8;break}default:a[n>>0]=0}a[o>>0]=(d[m>>0]|0)^(d[n>>0]|0);a[p>>0]=(d[m>>0]|0)&(d[n>>0]|0);if((d[o>>0]|0)&1){c[j>>2]=2;E=c[j>>2]|0;i=g;return E|0}if((d[p>>0]|0)&1){if((c[(c[k>>2]|0)+8>>2]|0)<(c[(c[l>>2]|0)+8>>2]|0)){c[j>>2]=-1;E=c[j>>2]|0;i=g;return E|0}if((c[(c[k>>2]|0)+8>>2]|0)>(c[(c[l>>2]|0)+8>>2]|0)){c[j>>2]=1;E=c[j>>2]|0;i=g;return E|0}}if((d[o>>0]|0)&2){c[j>>2]=2;E=c[j>>2]|0;i=g;return E|0}if((d[p>>0]|0)&2){if((c[(c[k>>2]|0)+12>>2]&15|0)<(c[(c[l>>2]|0)+12>>2]&15|0)){c[j>>2]=-1;E=c[j>>2]|0;i=g;return E|0}if((c[(c[k>>2]|0)+12>>2]&15|0)>(c[(c[l>>2]|0)+12>>2]&15|0)){c[j>>2]=1;E=c[j>>2]|0;i=g;return E|0}}if((d[o>>0]|0)&4){c[j>>2]=2;E=c[j>>2]|0;i=g;return E|0}if((d[p>>0]|0)&4){if(((c[(c[k>>2]|0)+12>>2]|0)>>>4&31|0)<((c[(c[l>>2]|0)+12>>2]|0)>>>4&31|0)){c[j>>2]=-1;E=c[j>>2]|0;i=g;return E|0}if(((c[(c[k>>2]|0)+12>>2]|0)>>>4&31|0)>((c[(c[l>>2]|0)+12>>2]|0)>>>4&31|0)){c[j>>2]=1;E=c[j>>2]|0;i=g;return E|0}}if((d[o>>0]|0)&8){c[j>>2]=2;E=c[j>>2]|0;i=g;return E|0}if((d[p>>0]|0)&8){if(((c[(c[k>>2]|0)+12>>2]|0)>>>9&31|0)<((c[(c[l>>2]|0)+12>>2]|0)>>>9&31|0)){c[j>>2]=-1;E=c[j>>2]|0;i=g;return E|0}if(((c[(c[k>>2]|0)+12>>2]|0)>>>9&31|0)>((c[(c[l>>2]|0)+12>>2]|0)>>>9&31|0)){c[j>>2]=1;E=c[j>>2]|0;i=g;return E|0}if(((c[(c[k>>2]|0)+12>>2]|0)>>>14&63|0)<((c[(c[l>>2]|0)+12>>2]|0)>>>14&63|0)){c[j>>2]=-1;E=c[j>>2]|0;i=g;return E|0}if(((c[(c[k>>2]|0)+12>>2]|0)>>>14&63|0)>((c[(c[l>>2]|0)+12>>2]|0)>>>14&63|0)){c[j>>2]=1;E=c[j>>2]|0;i=g;return E|0}if(+h[(c[k>>2]|0)+16>>3]<+h[(c[l>>2]|0)+16>>3]){c[j>>2]=-1;E=c[j>>2]|0;i=g;return E|0}if(+h[(c[k>>2]|0)+16>>3]>+h[(c[l>>2]|0)+16>>3]){c[j>>2]=1;E=c[j>>2]|0;i=g;return E|0}}c[j>>2]=0;E=c[j>>2]|0;i=g;return E|0}function yI(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=e;while(1){if(!(d[c[h>>2]>>0]|0)){m=24;break}if(!(d[c[j>>2]>>0]|0)){m=24;break}if(((d[c[j>>2]>>0]|0|0)!=9?(d[c[j>>2]>>0]|0|0)!=10:0)?(d[c[j>>2]>>0]|0|0)!=13:0){c[l>>2]=(d[c[h>>2]>>0]|0)-(d[c[j>>2]>>0]|0);if((c[l>>2]|0)<0){m=16;break}if((c[l>>2]|0)>0){m=20;break}}else m=7;if((m|0)==7?(m=0,(d[c[h>>2]>>0]|0|0)!=32):0){m=8;break}c[h>>2]=(c[h>>2]|0)+1;c[j>>2]=(c[j>>2]|0)+1}do if((m|0)==8){l=(c[k>>2]|0)!=0;if(((d[c[h>>2]>>0]|0)-32|0)<0)if(l){c[g>>2]=1;break}else{c[g>>2]=-1;break}else if(l){c[g>>2]=-1;break}else{c[g>>2]=1;break}}else if((m|0)==16)if(c[k>>2]|0){c[g>>2]=1;break}else{c[g>>2]=-1;break}else if((m|0)==20)if(c[k>>2]|0){c[g>>2]=-1;break}else{c[g>>2]=1;break}else if((m|0)==24){if(d[c[h>>2]>>0]|0)if(c[k>>2]|0){c[g>>2]=-1;break}else{c[g>>2]=1;break}if(!(d[c[j>>2]>>0]|0)){c[g>>2]=0;break}if(c[k>>2]|0){c[g>>2]=1;break}else{c[g>>2]=-1;break}}while(0);i=f;return c[g>>2]|0}function zI(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=e;a:while(1){do if((d[c[j>>2]>>0]|0|0)!=32){if(9<=(d[c[j>>2]>>0]|0|0)?(d[c[j>>2]>>0]|0|0)<=10:0)break;if((d[c[j>>2]>>0]|0|0)!=13)break a}while(0);c[j>>2]=(c[j>>2]|0)+1}b:while(1){if(!(d[c[h>>2]>>0]|0)){m=35;break}if(!(d[c[j>>2]>>0]|0)){m=35;break}do if((d[c[j>>2]>>0]|0|0)!=32){if(9<=(d[c[j>>2]>>0]|0|0)?(d[c[j>>2]>>0]|0|0)<=10:0)break;if((d[c[j>>2]>>0]|0|0)!=13){e=c[h>>2]|0;c[h>>2]=e+1;b=d[e>>0]|0;e=c[j>>2]|0;c[j>>2]=e+1;c[l>>2]=b-(d[e>>0]|0);if((c[l>>2]|0)<0){m=28;break b}if((c[l>>2]|0)>0){m=32;break b}else continue b}}while(0);n=c[h>>2]|0;if((d[c[h>>2]>>0]|0|0)!=32){m=14;break}c[h>>2]=n+1;c[j>>2]=(c[j>>2]|0)+1;while(1){do if((d[c[j>>2]>>0]|0|0)!=32){if(9<=(d[c[j>>2]>>0]|0|0)?(d[c[j>>2]>>0]|0|0)<=10:0)break;if((d[c[j>>2]>>0]|0|0)!=13)continue b}while(0);c[j>>2]=(c[j>>2]|0)+1}}do if((m|0)==14){l=(c[k>>2]|0)!=0;if(((d[n>>0]|0)-32|0)<0)if(l){c[g>>2]=1;break}else{c[g>>2]=-1;break}else if(l){c[g>>2]=-1;break}else{c[g>>2]=1;break}}else if((m|0)==28)if(c[k>>2]|0){c[g>>2]=1;break}else{c[g>>2]=-1;break}else if((m|0)==32)if(c[k>>2]|0){c[g>>2]=-1;break}else{c[g>>2]=1;break}else if((m|0)==35){if(d[c[h>>2]>>0]|0)if(c[k>>2]|0){c[g>>2]=-1;break}else{c[g>>2]=1;break}if(d[c[j>>2]>>0]|0){while(1){do if((d[c[j>>2]>>0]|0|0)==32)o=1;else{if(9<=(d[c[j>>2]>>0]|0|0)?(d[c[j>>2]>>0]|0|0)<=10:0){o=1;break}o=(d[c[j>>2]>>0]|0|0)==13}while(0);p=c[j>>2]|0;if(!o)break;c[j>>2]=p+1}if(d[p>>0]|0)if(c[k>>2]|0){c[g>>2]=1;break}else{c[g>>2]=-1;break}}c[g>>2]=0}while(0);i=f;return c[g>>2]|0}function AI(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=a;c[h>>2]=b;a:while(1){if(!(d[c[g>>2]>>0]|0)){k=27;break}if(!(d[c[h>>2]>>0]|0)){k=27;break}do if((d[c[h>>2]>>0]|0|0)!=32){if(9<=(d[c[h>>2]>>0]|0|0)?(d[c[h>>2]>>0]|0|0)<=10:0){k=8;break}if((d[c[h>>2]>>0]|0|0)!=13){if((d[c[g>>2]>>0]|0|0)==32){k=19;break a}if(9<=(d[c[g>>2]>>0]|0|0)?(d[c[g>>2]>>0]|0|0)<=10:0){k=19;break a}if((d[c[g>>2]>>0]|0|0)==13){k=19;break a}c[j>>2]=(d[c[g>>2]>>0]|0)-(d[c[h>>2]>>0]|0);if((c[j>>2]|0)<0){k=23;break a}if((c[j>>2]|0)>0){k=25;break a}}else k=8}else k=8;while(0);do if((k|0)==8?(k=0,(d[c[g>>2]>>0]|0|0)!=32):0){if(9<=(d[c[g>>2]>>0]|0|0)?(d[c[g>>2]>>0]|0|0)<=10:0)break;
if((d[c[g>>2]>>0]|0|0)!=13){k=12;break a}}while(0);c[g>>2]=(c[g>>2]|0)+1;c[h>>2]=(c[h>>2]|0)+1}if((k|0)==12)if(((d[c[g>>2]>>0]|0)-32|0)<0){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}else{c[f>>2]=1;l=c[f>>2]|0;i=e;return l|0}else if((k|0)==19)if((32-(d[c[h>>2]>>0]|0)|0)<0){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}else{c[f>>2]=1;l=c[f>>2]|0;i=e;return l|0}else if((k|0)==23){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}else if((k|0)==25){c[f>>2]=1;l=c[f>>2]|0;i=e;return l|0}else if((k|0)==27){if(d[c[g>>2]>>0]|0){c[f>>2]=1;l=c[f>>2]|0;i=e;return l|0}if(d[c[h>>2]>>0]|0){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}else{c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}}return 0}function BI(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=e;a:while(1){do if((d[c[j>>2]>>0]|0|0)!=32){if(9<=(d[c[j>>2]>>0]|0|0)?(d[c[j>>2]>>0]|0|0)<=10:0)break;if((d[c[j>>2]>>0]|0|0)!=13)break a}while(0);c[j>>2]=(c[j>>2]|0)+1}b:while(1){if(!(d[c[h>>2]>>0]|0)){m=45;break}if(!(d[c[j>>2]>>0]|0)){m=45;break}do if((d[c[j>>2]>>0]|0|0)!=32){if(9<=(d[c[j>>2]>>0]|0|0)?(d[c[j>>2]>>0]|0|0)<=10:0)break;if((d[c[j>>2]>>0]|0|0)!=13){if((d[c[h>>2]>>0]|0|0)==32){m=34;break b}if(9<=(d[c[h>>2]>>0]|0|0)?(d[c[h>>2]>>0]|0|0)<=10:0){m=34;break b}if((d[c[h>>2]>>0]|0|0)==13){m=34;break b}e=c[h>>2]|0;c[h>>2]=e+1;b=d[e>>0]|0;e=c[j>>2]|0;c[j>>2]=e+1;c[l>>2]=b-(d[e>>0]|0);if((c[l>>2]|0)<0){m=42;break b}if((c[l>>2]|0)>0){m=44;break b}else continue b}}while(0);do if((d[c[h>>2]>>0]|0|0)!=32){if(9<=(d[c[h>>2]>>0]|0|0)?(d[c[h>>2]>>0]|0|0)<=10:0)break;if((d[c[h>>2]>>0]|0|0)!=13){m=17;break b}}while(0);c[h>>2]=(c[h>>2]|0)+1;c[j>>2]=(c[j>>2]|0)+1;while(1){do if((d[c[j>>2]>>0]|0|0)!=32){if(9<=(d[c[j>>2]>>0]|0|0)?(d[c[j>>2]>>0]|0|0)<=10:0)break;if((d[c[j>>2]>>0]|0|0)!=13)continue b}while(0);c[j>>2]=(c[j>>2]|0)+1}}if((m|0)==17){l=(c[k>>2]|0)!=0;if(((d[c[h>>2]>>0]|0)-32|0)<0)if(l){c[g>>2]=1;n=c[g>>2]|0;i=f;return n|0}else{c[g>>2]=-1;n=c[g>>2]|0;i=f;return n|0}else if(l){c[g>>2]=-1;n=c[g>>2]|0;i=f;return n|0}else{c[g>>2]=1;n=c[g>>2]|0;i=f;return n|0}}else if((m|0)==34){l=(c[k>>2]|0)!=0;if((32-(d[c[j>>2]>>0]|0)|0)<0)if(l){c[g>>2]=1;n=c[g>>2]|0;i=f;return n|0}else{c[g>>2]=-1;n=c[g>>2]|0;i=f;return n|0}else if(l){c[g>>2]=-1;n=c[g>>2]|0;i=f;return n|0}else{c[g>>2]=1;n=c[g>>2]|0;i=f;return n|0}}else if((m|0)==42){c[g>>2]=-1;n=c[g>>2]|0;i=f;return n|0}else if((m|0)==44){c[g>>2]=1;n=c[g>>2]|0;i=f;return n|0}else if((m|0)==45){if(d[c[h>>2]>>0]|0)if(c[k>>2]|0){c[g>>2]=-1;n=c[g>>2]|0;i=f;return n|0}else{c[g>>2]=1;n=c[g>>2]|0;i=f;return n|0}if(d[c[j>>2]>>0]|0){while(1){do if((d[c[j>>2]>>0]|0|0)==32)o=1;else{if(9<=(d[c[j>>2]>>0]|0|0)?(d[c[j>>2]>>0]|0|0)<=10:0){o=1;break}o=(d[c[j>>2]>>0]|0|0)==13}while(0);p=c[j>>2]|0;if(!o)break;c[j>>2]=p+1}if(d[p>>0]|0)if(c[k>>2]|0){c[g>>2]=1;n=c[g>>2]|0;i=f;return n|0}else{c[g>>2]=-1;n=c[g>>2]|0;i=f;return n|0}}c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}return 0}function CI(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=a;c[h>>2]=b;a:while(1){do if((d[c[g>>2]>>0]|0|0)!=32){if(9<=(d[c[g>>2]>>0]|0|0)?(d[c[g>>2]>>0]|0|0)<=10:0)break;if((d[c[g>>2]>>0]|0|0)!=13)break a}while(0);c[g>>2]=(c[g>>2]|0)+1}b:while(1){do if((d[c[h>>2]>>0]|0|0)!=32){if(9<=(d[c[h>>2]>>0]|0|0)?(d[c[h>>2]>>0]|0|0)<=10:0)break;if((d[c[h>>2]>>0]|0|0)!=13)break b}while(0);c[h>>2]=(c[h>>2]|0)+1}c:while(1){if(d[c[g>>2]>>0]|0)k=(d[c[h>>2]>>0]|0|0)!=0;else k=0;l=d[c[g>>2]>>0]|0;if(!k){m=38;break}do if((l|0)!=32){if(9<=(d[c[g>>2]>>0]|0|0)?(d[c[g>>2]>>0]|0|0)<=10:0)break;if((d[c[g>>2]>>0]|0|0)!=13){b=c[g>>2]|0;c[g>>2]=b+1;a=d[b>>0]|0;b=c[h>>2]|0;c[h>>2]=b+1;c[j>>2]=a-(d[b>>0]|0);if((c[j>>2]|0)<0){m=35;break c}if((c[j>>2]|0)>0){m=37;break c}else continue c}}while(0);do if((d[c[h>>2]>>0]|0|0)!=32){if(9<=(d[c[h>>2]>>0]|0|0)?(d[c[h>>2]>>0]|0|0)<=10:0)break;if((d[c[h>>2]>>0]|0|0)!=13){m=23;break c}}while(0);d:while(1){do if((d[c[g>>2]>>0]|0|0)!=32){if(9<=(d[c[g>>2]>>0]|0|0)?(d[c[g>>2]>>0]|0|0)<=10:0)break;if((d[c[g>>2]>>0]|0|0)!=13)break d}while(0);c[g>>2]=(c[g>>2]|0)+1}while(1){do if((d[c[h>>2]>>0]|0|0)!=32){if(9<=(d[c[h>>2]>>0]|0|0)?(d[c[h>>2]>>0]|0|0)<=10:0)break;if((d[c[h>>2]>>0]|0|0)!=13)continue c}while(0);c[h>>2]=(c[h>>2]|0)+1}}if((m|0)==23){c[j>>2]=(d[c[g>>2]>>0]|0)-(d[c[h>>2]>>0]|0);c[f>>2]=c[j>>2];n=c[f>>2]|0;i=e;return n|0}else if((m|0)==35){c[f>>2]=-1;n=c[f>>2]|0;i=e;return n|0}else if((m|0)==37){c[f>>2]=1;n=c[f>>2]|0;i=e;return n|0}else if((m|0)==38){if(l){while(1){do if((d[c[g>>2]>>0]|0|0)==32)o=1;else{if(9<=(d[c[g>>2]>>0]|0|0)?(d[c[g>>2]>>0]|0|0)<=10:0){o=1;break}o=(d[c[g>>2]>>0]|0|0)==13}while(0);p=c[g>>2]|0;if(!o)break;c[g>>2]=p+1}if(d[p>>0]|0){c[f>>2]=1;n=c[f>>2]|0;i=e;return n|0}}if(d[c[h>>2]>>0]|0){while(1){do if((d[c[h>>2]>>0]|0|0)==32)q=1;else{if(9<=(d[c[h>>2]>>0]|0|0)?(d[c[h>>2]>>0]|0|0)<=10:0){q=1;break}q=(d[c[h>>2]>>0]|0|0)==13}while(0);r=c[h>>2]|0;if(!q)break;c[h>>2]=r+1}if(d[r>>0]|0){c[f>>2]=-1;n=c[f>>2]|0;i=e;return n|0}}c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}return 0}function DI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;j=d+16|0;k=d+8|0;l=d;c[f>>2]=a;c[j>>2]=b;a:do if(!((c[f>>2]|0)==0|(c[j>>2]|0)==0)){b=c[f>>2]|0;do if((c[c[f>>2]>>2]|0)!=14)if((c[b>>2]|0)==13){h[k>>3]=+g[(c[f>>2]|0)+8>>2];break}else{c[e>>2]=-2;break a}else h[k>>3]=+h[b+8>>3];while(0);b=c[j>>2]|0;do if((c[c[j>>2]>>2]|0)!=14)if((c[b>>2]|0)==13){h[l>>3]=+g[(c[j>>2]|0)+8>>2];break}else{c[e>>2]=-2;break a}else h[l>>3]=+h[b+8>>3];while(0);b=(Lq(+h[k>>3])|0)!=0;a=(Lq(+h[l>>3])|0)!=0;if(b)if(a){c[e>>2]=0;break}else{c[e>>2]=1;break}if(a){c[e>>2]=-1;break}a=+h[l>>3]==+h[15985];if(+h[k>>3]==+h[15985])if(a){c[e>>2]=0;break}else{c[e>>2]=1;break}if(a){c[e>>2]=-1;break}a=+h[l>>3]==+h[15986];if(+h[k>>3]==+h[15986])if(a){c[e>>2]=0;break}else{c[e>>2]=-1;break}if(a){c[e>>2]=1;break}if(+h[k>>3]<+h[l>>3]){c[e>>2]=-1;break}if(+h[k>>3]>+h[l>>3]){c[e>>2]=1;break}if(+h[k>>3]==+h[l>>3]){c[e>>2]=0;break}else{c[e>>2]=2;break}}else c[e>>2]=-2;while(0);i=d;return c[e>>2]|0}function EI(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=i;i=i+32|0;l=k+28|0;m=k+24|0;n=k+20|0;o=k+16|0;p=k+12|0;q=k+8|0;r=k+4|0;s=k;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;c[r>>2]=h;c[s>>2]=j;j=kI(c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0)|0;i=k;return j|0}function FI(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[f>>2]=a;c[h>>2]=0;if(!(c[f>>2]|0)){c[e>>2]=-1;j=c[e>>2]|0;i=b;return j|0}c[g>>2]=c[f>>2];a:while(1){do if((d[c[g>>2]>>0]|0|0)!=32){if(9<=(d[c[g>>2]>>0]|0|0)?(d[c[g>>2]>>0]|0|0)<=10:0)break;if((d[c[g>>2]>>0]|0|0)!=13)break a}while(0);c[g>>2]=(c[g>>2]|0)+1}b:while(1){if(!(d[c[g>>2]>>0]|0)){k=36;break}f=c[g>>2]|0;c:do if(!((d[c[g>>2]>>0]|0)&128)){do if((d[f>>0]|0|0)!=32){if(9<=(d[c[g>>2]>>0]|0|0)?(d[c[g>>2]>>0]|0|0)<=10:0)break;if((d[c[g>>2]>>0]|0|0)!=13){c[g>>2]=(c[g>>2]|0)+1;break c}}while(0);while(1){do if((d[c[g>>2]>>0]|0|0)==32)l=1;else{if(9<=(d[c[g>>2]>>0]|0|0)?(d[c[g>>2]>>0]|0|0)<=10:0){l=1;break}l=(d[c[g>>2]>>0]|0|0)==13}while(0);m=c[g>>2]|0;if(!l)break;c[g>>2]=m+1}if(!(d[m>>0]|0)){k=36;break b}}else{if(((d[f+1>>0]|0)&192|0)!=128){k=12;break b}a=(c[g>>2]|0)+2|0;if(((d[c[g>>2]>>0]|0)&224|0)!=224){c[g>>2]=a;break}if(((d[a>>0]|0)&192|0)!=128){k=15;break b}a=c[g>>2]|0;if(((d[c[g>>2]>>0]|0)&240|0)!=240){c[g>>2]=a+3;break}if(((d[a>>0]|0)&248|0)!=240){k=19;break b}if(((d[(c[g>>2]|0)+3>>0]|0)&192|0)!=128){k=19;break b}c[g>>2]=(c[g>>2]|0)+4}while(0);c[h>>2]=(c[h>>2]|0)+1}if((k|0)==12){c[e>>2]=-1;j=c[e>>2]|0;i=b;return j|0}else if((k|0)==15){c[e>>2]=-1;j=c[e>>2]|0;i=b;return j|0}else if((k|0)==19){c[e>>2]=-1;j=c[e>>2]|0;i=b;return j|0}else if((k|0)==36){c[e>>2]=c[h>>2];j=c[e>>2]|0;i=b;return j|0}return 0}function GI(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+64|0;f=e+48|0;g=e+44|0;j=e+40|0;k=e+36|0;l=e+32|0;m=e+28|0;n=e+24|0;o=e+20|0;p=e+16|0;q=e+12|0;r=e+8|0;s=e+4|0;t=e;c[g>>2]=a;c[j>>2]=d;if((c[g>>2]|0)==0|(c[j>>2]|0)==0){c[f>>2]=0;u=c[f>>2]|0;i=e;return u|0}c[k>>2]=hI(c[c[g>>2]>>2]|0)|0;if(!(c[k>>2]|0)){c[f>>2]=0;u=c[f>>2]|0;i=e;return u|0}c[l>>2]=jI(c[g>>2]|0)|0;g=c[k>>2]|0;if(!(c[l>>2]|0)){PH(g);c[f>>2]=0;u=c[f>>2]|0;i=e;return u|0}c[p>>2]=g+8;c[q>>2]=(c[l>>2]|0)+8;c[r>>2]=(c[j>>2]|0)+8;if(!(c[(c[q>>2]|0)+4>>2]&15)){j=(c[q>>2]|0)+4|0;c[j>>2]=c[j>>2]&-16|1}j=(c[r>>2]|0)+8|0;h[j>>3]=+h[j>>3]-+(((b[(c[q>>2]|0)+16>>1]<<3&65535)<<16>>16>>4<<16>>16)*60|0);j=(c[q>>2]|0)+16|0;b[j>>1]=b[j>>1]&-8191;if(!((c[(c[q>>2]|0)+4>>2]|0)>>>4&31)){j=(c[q>>2]|0)+4|0;c[j>>2]=c[j>>2]&-497|16}c[m>>2]=(c[(c[q>>2]|0)+4>>2]&15)+(c[c[r>>2]>>2]|0);j=~~(+((c[m>>2]|0)-1|0)-+Q(+(+((c[m>>2]|0)-1|0)/12))*12+1)>>>0;g=(c[p>>2]|0)+4|0;c[g>>2]=c[g>>2]&-16|j&15;c[m>>2]=~~+Q(+(+((c[m>>2]|0)-1|0)/12));c[c[p>>2]>>2]=(c[c[q>>2]>>2]|0)+(c[m>>2]|0);do if(!(c[c[p>>2]>>2]|0)){j=c[p>>2]|0;g=c[j>>2]|0;if((c[c[q>>2]>>2]|0)>0){c[j>>2]=g+-1;break}else{c[j>>2]=g+1;break}}while(0);g=(c[p>>2]|0)+16|0;b[g>>1]=b[g>>1]&-8191|((b[(c[q>>2]|0)+16>>1]<<3&65535)<<16>>16>>4<<16>>16&4095)<<1&65535;g=(c[p>>2]|0)+16|0;b[g>>1]=b[g>>1]&-2|b[(c[q>>2]|0)+16>>1]&1;h[(c[p>>2]|0)+8>>3]=+h[(c[q>>2]|0)+8>>3]+ +h[(c[r>>2]|0)+8>>3];c[m>>2]=~~+Q(+(+(~~+h[(c[p>>2]|0)+8>>3]|0)/60));if(+h[(c[p>>2]|0)+8>>3]!=0){v=+h[(c[p>>2]|0)+8>>3]-+Q(+(+h[(c[p>>2]|0)+8>>3]/60))*60;h[(c[p>>2]|0)+8>>3]=v}c[m>>2]=(c[m>>2]|0)+((c[(c[q>>2]|0)+4>>2]|0)>>>14&63);g=~~(+(c[m>>2]|0)-+Q(+(+(c[m>>2]|0)/60))*60)>>>0;j=(c[p>>2]|0)+4|0;c[j>>2]=c[j>>2]&-1032193|(g&63)<<14;c[m>>2]=~~+Q(+(+(c[m>>2]|0)/60));c[m>>2]=(c[m>>2]|0)+((c[(c[q>>2]|0)+4>>2]|0)>>>9&31);g=~~(+(c[m>>2]|0)-+Q(+(+(c[m>>2]|0)/24))*24)>>>0;j=(c[p>>2]|0)+4|0;c[j>>2]=c[j>>2]&-15873|(g&31)<<9;c[m>>2]=~~+Q(+(+(c[m>>2]|0)/24));if(((c[c[p>>2]>>2]|0)!=0?(c[(c[p>>2]|0)+4>>2]&15|0)>=1:0)?(c[(c[p>>2]|0)+4>>2]&15|0)<=12:0){g=(c[(c[q>>2]|0)+4>>2]|0)>>>4&31;if(((c[c[p>>2]>>2]|0)%4|0|0)==0?((c[c[p>>2]>>2]|0)%100|0|0)!=0:0)w=23;else if(!((c[c[p>>2]>>2]|0)%400|0))w=23;else x=c[171912+((c[(c[p>>2]|0)+4>>2]&15)-1<<2)>>2]|0;if((w|0)==23)x=c[171864+((c[(c[p>>2]|0)+4>>2]&15)-1<<2)>>2]|0;if(g>>>0>x>>>0){if(((c[c[p>>2]>>2]|0)%4|0|0)==0?((c[c[p>>2]>>2]|0)%100|0|0)!=0:0)w=29;else if(!((c[c[p>>2]>>2]|0)%400|0))w=29;else y=c[171912+((c[(c[p>>2]|0)+4>>2]&15)-1<<2)>>2]|0;if((w|0)==29)y=c[171864+((c[(c[p>>2]|0)+4>>2]&15)-1<<2)>>2]|0;c[n>>2]=y}else w=32}else w=32;do if((w|0)==32)if(((c[(c[q>>2]|0)+4>>2]|0)>>>4&31|0)<1){c[n>>2]=1;break}else{c[n>>2]=(c[(c[q>>2]|0)+4>>2]|0)>>>4&31;break}while(0);c[n>>2]=(c[n>>2]|0)+((c[(c[r>>2]|0)+4>>2]|0)+(c[m>>2]|0));while(1){r=c[p>>2]|0;if((c[n>>2]|0)<1){c[s>>2]=~~(+((c[r+4>>2]&15)-1-1|0)-+Q(+(+((c[(c[p>>2]|0)+4>>2]&15)-1-1|0)/12))*12+1);c[t>>2]=(c[c[p>>2]>>2]|0)+~~+Q(+(+((c[(c[p>>2]|0)+4>>2]&15)-1-1|0)/12));if(!(c[t>>2]|0))c[t>>2]=(c[t>>2]|0)+-1;if((c[s>>2]|0)<1)c[s>>2]=1;if((c[s>>2]|0)>12)c[s>>2]=12;if(((c[t>>2]|0)%4|0|0)==0?((c[t>>2]|0)%100|0|0)!=0:0)w=46;else if(!((c[t>>2]|0)%400|0))w=46;else z=c[171912+((c[s>>2]|0)-1<<2)>>2]|0;if((w|0)==46){w=0;z=c[171864+((c[s>>2]|0)-1<<2)>>2]|0}c[n>>2]=(c[n>>2]|0)+z;c[m>>2]=-1}else{if(!(c[r>>2]|0))break;if((c[(c[p>>2]|0)+4>>2]&15|0)<1)break;if((c[(c[p>>2]|0)+4>>2]&15|0)>12)break;r=c[n>>2]|0;if(((c[c[p>>2]>>2]|0)%4|0|0)==0?((c[c[p>>2]>>2]|0)%100|0|0)!=0:0)w=55;else if(!((c[c[p>>2]>>2]|0)%400|0))w=55;else A=c[171912+((c[(c[p>>2]|0)+4>>2]&15)-1<<2)>>2]|0;if((w|0)==55){w=0;A=c[171864+((c[(c[p>>2]|0)+4>>2]&15)-1<<2)>>2]|0}if((r|0)<=(A|0))break;r=c[n>>2]|0;if(((c[c[p>>2]>>2]|0)%4|0|0)==0?((c[c[p>>2]>>2]|0)%100|0|0)!=0:0)w=61;else if(!((c[c[p>>2]>>2]|0)%400|0))w=61;else B=c[171912+((c[(c[p>>2]|0)+4>>2]&15)-1<<2)>>2]|0;if((w|0)==61){w=0;B=c[171864+((c[(c[p>>2]|0)+4>>2]&15)-1<<2)>>2]|0}c[n>>2]=r-B;c[m>>2]=1}c[o>>2]=(c[(c[p>>2]|0)+4>>2]&15)+(c[m>>2]|0);r=~~(+((c[o>>2]|0)-1|0)-+Q(+(+((c[o>>2]|0)-1|0)/12))*12+1)>>>0;q=(c[p>>2]|0)+4|0;c[q>>2]=c[q>>2]&-16|r&15;r=(c[c[p>>2]>>2]|0)+(~~+Q(+(+((c[o>>2]|0)-1|0)/12))>>>0)|0;c[c[p>>2]>>2]=r;if(c[c[p>>2]>>2]|0)continue;r=c[p>>2]|0;q=c[r>>2]|0;if((c[o>>2]|0)<1){c[r>>2]=q+-1;continue}else{c[r>>2]=q+1;continue}}o=(c[p>>2]|0)+4|0;c[o>>2]=c[o>>2]&-497|(c[n>>2]&31)<<4;do if((c[c[k>>2]>>2]|0)!=11){if((((c[(c[p>>2]|0)+4>>2]|0)>>>9&31|0)==0?((c[(c[p>>2]|0)+4>>2]|0)>>>14&63|0)==0:0)?!(+h[(c[p>>2]|0)+8>>3]!=0):0){if((c[c[k>>2]>>2]|0)==10)break;if((c[(c[p>>2]|0)+4>>2]&15|0)!=1?((c[(c[p>>2]|0)+4>>2]|0)>>>4&31|0)!=1:0){c[c[k>>2]>>2]=10;break}if((c[c[k>>2]>>2]|0)==9)break;if((c[(c[p>>2]|0)+4>>2]&15|0)==1)break;c[c[k>>2]>>2]=9;break}c[c[k>>2]>>2]=11}while(0);PH(c[l>>2]|0);c[f>>2]=c[k>>2];u=c[f>>2]|0;i=e;return u|0}function HI(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=c[c[h>>2]>>2];c[k>>2]=0;c[l>>2]=0;if((((d[c[j>>2]>>0]|0|0)>=48?(d[c[j>>2]>>0]|0|0)<=57:0)?(d[(c[j>>2]|0)+1>>0]|0|0)>=48:0)?(d[(c[j>>2]|0)+1>>0]|0|0)<=57:0)c[l>>2]=(((d[c[j>>2]>>0]|0)-48|0)*10|0)+((d[(c[j>>2]|0)+1>>0]|0)-48);else c[k>>2]=1;c[j>>2]=(c[j>>2]|0)+2;if(c[k>>2]|0){c[f>>2]=c[k>>2];m=c[f>>2]|0;i=e;return m|0}if((c[l>>2]|0)>>>0>=1&(c[l>>2]|0)>>>0<=31){k=(c[g>>2]|0)+4|0;c[k>>2]=c[k>>2]&-497|(c[l>>2]&31)<<4;c[c[h>>2]>>2]=c[j>>2];c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}else{c[f>>2]=2;m=c[f>>2]|0;i=e;return m|0}return 0}function II(a,e){a=a|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f;c[h>>2]=a;c[j>>2]=e;c[l>>2]=0;if(!(c[j>>2]|0)){c[g>>2]=-1;o=c[g>>2]|0;i=f;return o|0}c[k>>2]=c[c[j>>2]>>2];e=d[c[k>>2]>>0]|0;do if((e|0)==45|(e|0)==43){c[m>>2]=0;c[n>>2]=0;c[m>>2]=(d[c[k>>2]>>0]|0|0)==45&1;c[k>>2]=(c[k>>2]|0)+1;if((((d[c[k>>2]>>0]|0|0)>=48?(d[c[k>>2]>>0]|0|0)<=57:0)?(d[(c[k>>2]|0)+1>>0]|0|0)>=48:0)?(d[(c[k>>2]|0)+1>>0]|0|0)<=57:0)c[n>>2]=(((d[c[k>>2]>>0]|0)-48|0)*10|0)+((d[(c[k>>2]|0)+1>>0]|0)-48);else c[l>>2]=1;c[k>>2]=(c[k>>2]|0)+2;if(c[l>>2]|0){c[g>>2]=c[l>>2];o=c[g>>2]|0;i=f;return o|0}if(!((c[n>>2]|0)>=0&(c[n>>2]|0)<=23)){c[g>>2]=2;o=c[g>>2]|0;i=f;return o|0}if((d[c[k>>2]>>0]|0|0)!=58){c[g>>2]=1;o=c[g>>2]|0;i=f;return o|0}c[k>>2]=(c[k>>2]|0)+1;a=(c[h>>2]|0)+16|0;b[a>>1]=b[a>>1]&-8191|((c[n>>2]|0)*60&4095)<<1&65535;if((((d[c[k>>2]>>0]|0|0)>=48?(d[c[k>>2]>>0]|0|0)<=57:0)?(d[(c[k>>2]|0)+1>>0]|0|0)>=48:0)?(d[(c[k>>2]|0)+1>>0]|0|0)<=57:0)c[n>>2]=(((d[c[k>>2]>>0]|0)-48|0)*10|0)+((d[(c[k>>2]|0)+1>>0]|0)-48);else c[l>>2]=1;c[k>>2]=(c[k>>2]|0)+2;if(c[l>>2]|0){c[g>>2]=c[l>>2];o=c[g>>2]|0;i=f;return o|0}if(!((c[n>>2]|0)>=0&(c[n>>2]|0)<=59)){c[g>>2]=2;o=c[g>>2]|0;i=f;return o|0}a=(c[h>>2]|0)+16|0;b[a>>1]=b[a>>1]&-8191|(((b[a>>1]<<3&65535)<<16>>16>>4<<16>>16)+(c[n>>2]|0)&4095)<<1&65535;if(c[m>>2]|0){a=(c[h>>2]|0)+16|0;b[a>>1]=b[a>>1]&-8191|(0-((b[(c[h>>2]|0)+16>>1]<<3&65535)<<16>>16>>4<<16>>16)&4095)<<1&65535}if(((b[(c[h>>2]|0)+16>>1]<<3&65535)<<16>>16>>4<<16>>16|0)>-840?((b[(c[h>>2]|0)+16>>1]<<3&65535)<<16>>16>>4<<16>>16|0)<840:0){a=(c[h>>2]|0)+16|0;b[a>>1]=b[a>>1]&-2|1;break}c[g>>2]=2;o=c[g>>2]|0;i=f;return o|0}else if(!e){a=(c[h>>2]|0)+16|0;b[a>>1]=b[a>>1]&-2;a=(c[h>>2]|0)+16|0;b[a>>1]=b[a>>1]&-8191}else if((e|0)==90){a=(c[h>>2]|0)+16|0;b[a>>1]=b[a>>1]&-2|1;a=(c[h>>2]|0)+16|0;b[a>>1]=b[a>>1]&-8191;c[k>>2]=(c[k>>2]|0)+1}else{c[g>>2]=1;o=c[g>>2]|0;i=f;return o|0}while(0);c[c[j>>2]>>2]=c[k>>2];c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}function JI(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=c[c[h>>2]>>2];c[k>>2]=0;c[l>>2]=0;if((((d[c[j>>2]>>0]|0|0)>=48?(d[c[j>>2]>>0]|0|0)<=57:0)?(d[(c[j>>2]|0)+1>>0]|0|0)>=48:0)?(d[(c[j>>2]|0)+1>>0]|0|0)<=57:0)c[l>>2]=(((d[c[j>>2]>>0]|0)-48|0)*10|0)+((d[(c[j>>2]|0)+1>>0]|0)-48);else c[k>>2]=1;c[j>>2]=(c[j>>2]|0)+2;if(c[k>>2]|0){c[f>>2]=c[k>>2];m=c[f>>2]|0;i=e;return m|0}if((c[l>>2]|0)>>>0>=1&(c[l>>2]|0)>>>0<=12){k=(c[g>>2]|0)+4|0;c[k>>2]=c[k>>2]&-16|c[l>>2]&15;c[c[h>>2]>>2]=c[j>>2];c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}else{c[f>>2]=2;m=c[f>>2]|0;i=e;return m|0}return 0}function KI(a,e){a=a|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f+28|0;j=f+24|0;k=f+20|0;l=f+16|0;m=f+12|0;n=f+8|0;o=f;c[j>>2]=a;c[k>>2]=e;c[l>>2]=c[c[k>>2]>>2];c[m>>2]=0;c[n>>2]=0;if((((d[c[l>>2]>>0]|0|0)>=48?(d[c[l>>2]>>0]|0|0)<=57:0)?(d[(c[l>>2]|0)+1>>0]|0|0)>=48:0)?(d[(c[l>>2]|0)+1>>0]|0|0)<=57:0)c[n>>2]=(((d[c[l>>2]>>0]|0)-48|0)*10|0)+((d[(c[l>>2]|0)+1>>0]|0)-48);else c[m>>2]=1;c[l>>2]=(c[l>>2]|0)+2;if(c[m>>2]|0){c[g>>2]=c[m>>2];p=c[g>>2]|0;i=f;return p|0}if((d[c[l>>2]>>0]|0|0)!=58){c[g>>2]=1;p=c[g>>2]|0;i=f;return p|0}if(!((c[n>>2]|0)>=0&(c[n>>2]|0)<=23)){c[g>>2]=2;p=c[g>>2]|0;i=f;return p|0}c[l>>2]=(c[l>>2]|0)+1;e=(c[j>>2]|0)+4|0;c[e>>2]=c[e>>2]&-15873|(c[n>>2]&31)<<9;if((((d[c[l>>2]>>0]|0|0)>=48?(d[c[l>>2]>>0]|0|0)<=57:0)?(d[(c[l>>2]|0)+1>>0]|0|0)>=48:0)?(d[(c[l>>2]|0)+1>>0]|0|0)<=57:0)c[n>>2]=(((d[c[l>>2]>>0]|0)-48|0)*10|0)+((d[(c[l>>2]|0)+1>>0]|0)-48);else c[m>>2]=1;c[l>>2]=(c[l>>2]|0)+2;if(c[m>>2]|0){c[g>>2]=c[m>>2];p=c[g>>2]|0;i=f;return p|0}if(!((c[n>>2]|0)>=0&(c[n>>2]|0)<=59)){c[g>>2]=2;p=c[g>>2]|0;i=f;return p|0}e=(c[j>>2]|0)+4|0;c[e>>2]=c[e>>2]&-1032193|(c[n>>2]&63)<<14;if((d[c[l>>2]>>0]|0|0)!=58){c[g>>2]=1;p=c[g>>2]|0;i=f;return p|0}c[l>>2]=(c[l>>2]|0)+1;if((((d[c[l>>2]>>0]|0|0)>=48?(d[c[l>>2]>>0]|0|0)<=57:0)?(d[(c[l>>2]|0)+1>>0]|0|0)>=48:0)?(d[(c[l>>2]|0)+1>>0]|0|0)<=57:0)h[(c[j>>2]|0)+8>>3]=+((((d[c[l>>2]>>0]|0)-48|0)*10|0)+((d[(c[l>>2]|0)+1>>0]|0)-48)|0);else c[m>>2]=1;c[l>>2]=(c[l>>2]|0)+2;a:do if((c[m>>2]|0)==0?(d[c[l>>2]>>0]|0|0)==46:0){h[o>>3]=1;c[l>>2]=(c[l>>2]|0)+1;if(!((d[c[l>>2]>>0]|0|0)>=48?(d[c[l>>2]>>0]|0|0)<=57:0))c[m>>2]=1;while(1){if((d[c[l>>2]>>0]|0|0)<48)break a;if((d[c[l>>2]>>0]|0|0)>57)break a;h[o>>3]=+h[o>>3]/10;n=(c[j>>2]|0)+8|0;h[n>>3]=+h[n>>3]+ +((d[c[l>>2]>>0]|0)-48|0)*+h[o>>3];c[l>>2]=(c[l>>2]|0)+1}}while(0);if(c[m>>2]|0){c[g>>2]=c[m>>2];p=c[g>>2]|0;i=f;return p|0}if(((+h[(c[j>>2]|0)+8>>3]>=0?+h[(c[j>>2]|0)+8>>3]<60:0)?((b[(c[j>>2]|0)+16>>1]<<3&65535)<<16>>16>>4<<16>>16|0)>-840:0)?((b[(c[j>>2]|0)+16>>1]<<3&65535)<<16>>16>>4<<16>>16|0)<840:0){c[c[k>>2]>>2]=c[l>>2];c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}c[g>>2]=2;p=c[g>>2]|0;i=f;return p|0}function LI(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=c[c[h>>2]>>2];c[l>>2]=0;c[m>>2]=0;if(!((d[c[j>>2]>>0]|0|0)>=48?(d[c[j>>2]>>0]|0|0)<=57:0))n=3;if(((n|0)==3?(d[c[j>>2]>>0]|0|0)!=45:0)?(d[c[j>>2]>>0]|0|0)!=43:0){c[f>>2]=-1;o=c[f>>2]|0;i=e;return o|0}if((d[c[j>>2]>>0]|0|0)==45){c[l>>2]=1;c[j>>2]=(c[j>>2]|0)+1}c[k>>2]=c[j>>2];while(1){if((d[c[j>>2]>>0]|0|0)<48)break;if((d[c[j>>2]>>0]|0|0)>57)break;c[c[g>>2]>>2]=((c[c[g>>2]>>2]|0)*10|0)+((d[c[j>>2]>>0]|0)-48);c[j>>2]=(c[j>>2]|0)+1;c[m>>2]=(c[m>>2]|0)+1}do if((c[m>>2]|0)>=4){if((c[m>>2]|0)>4?(d[c[k>>2]>>0]|0|0)==48:0)break;if(c[l>>2]|0)c[c[g>>2]>>2]=0-(c[c[g>>2]>>2]|0);if(c[c[g>>2]>>2]|0){c[c[h>>2]>>2]=c[j>>2];c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}else{c[f>>2]=2;o=c[f>>2]|0;i=e;return o|0}}while(0);c[f>>2]=1;o=c[f>>2]|0;i=e;return o|0}function MI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;a=c[(c[d>>2]|0)+12>>2]&15;c[f>>2]=a;c[f>>2]=(c[f>>2]|0)<=0?1:a;a=c[(c[d>>2]|0)+8>>2]|0;if((c[(c[d>>2]|0)+8>>2]|0)<=0){g=(a*365|0)+((((c[(c[d>>2]|0)+8>>2]|0)+1|0)/4|0)-(((c[(c[d>>2]|0)+8>>2]|0)+1|0)/100|0)+(((c[(c[d>>2]|0)+8>>2]|0)+1|0)/400|0))|0;if(((c[(c[d>>2]|0)+8>>2]|0)%4|0|0)==0?((c[(c[d>>2]|0)+8>>2]|0)%100|0|0)!=0:0)h=5;else if(!((c[(c[d>>2]|0)+8>>2]|0)%400|0))h=5;else j=c[172072+((c[f>>2]|0)-1<<2)>>2]|0;if((h|0)==5)j=c[172024+((c[f>>2]|0)-1<<2)>>2]|0;c[e>>2]=g+(j+0);k=c[e>>2]|0;i=b;return k|0}else{j=((a-1|0)*365|0)+((((c[(c[d>>2]|0)+8>>2]|0)-1|0)/4|0)-(((c[(c[d>>2]|0)+8>>2]|0)-1|0)/100|0)+(((c[(c[d>>2]|0)+8>>2]|0)-1|0)/400|0))|0;if(((c[(c[d>>2]|0)+8>>2]|0)%4|0|0)==0?((c[(c[d>>2]|0)+8>>2]|0)%100|0|0)!=0:0)h=11;else if(!((c[(c[d>>2]|0)+8>>2]|0)%400|0))h=11;else l=c[172072+((c[f>>2]|0)-1<<2)>>2]|0;if((h|0)==11)l=c[172024+((c[f>>2]|0)-1<<2)>>2]|0;c[e>>2]=j+(l+0);k=c[e>>2]|0;i=b;return k|0}return 0}function NI(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=65792)e=(c[d>>2]|0)<=65855;else e=0;i=b;return e&1|0}function OI(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=64256)e=(c[d>>2]|0)<=64335;else e=0;i=b;return e&1|0}function PI(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=1536)e=(c[d>>2]|0)<=1791;else e=0;i=b;return e&1|0}function QI(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=64336)e=(c[d>>2]|0)<=65023;else e=0;i=b;return e&1|0}function RI(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=65136)e=(c[d>>2]|0)<=65279;else e=0;i=b;return e&1|0}function SI(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=1328)e=(c[d>>2]|0)<=1423;else e=0;i=b;return e&1|0}function TI(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=8592)e=(c[d>>2]|0)<=8703;else e=0;i=b;return e&1|0}function UI(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=0)e=(c[d>>2]|0)<=127;else e=0;i=b;return e&1|0}function VI(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=2432)e=(c[d>>2]|0)<=2559;else e=0;i=b;return e&1|0}function WI(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=9600)e=(c[d>>2]|0)<=9631;else e=0;i=b;return e&1|0}function XI(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=12544)e=(c[d>>2]|0)<=12591;else e=0;i=b;return e&1|0}function YI(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=12704)e=(c[d>>2]|0)<=12735;else e=0;i=b;return e&1|0}function ZI(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=9472)e=(c[d>>2]|0)<=9599;else e=0;i=b;return e&1|0}function _I(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=10240)e=(c[d>>2]|0)<=10495;else e=0;i=b;return e&1|0}function $I(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=5952)e=(c[d>>2]|0)<=5983;else e=0;i=b;return e&1|0}function aJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=118784)e=(c[d>>2]|0)<=119039;else e=0;i=b;return e&1|0}function bJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=13056)e=(c[d>>2]|0)<=13311;else e=0;i=b;return e&1|0}function cJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=65072)e=(c[d>>2]|0)<=65103;else e=0;i=b;return e&1|0}function dJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=63744)e=(c[d>>2]|0)<=64255;else e=0;i=b;return e&1|0}function eJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=194560)e=(c[d>>2]|0)<=195103;else e=0;i=b;return e&1|0}function fJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=11904)e=(c[d>>2]|0)<=12031;else e=0;i=b;return e&1|0}function gJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=12288)e=(c[d>>2]|0)<=12351;else e=0;i=b;return e&1|0}function hJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=19968)e=(c[d>>2]|0)<=40959;else e=0;i=b;return e&1|0}function iJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=13312)e=(c[d>>2]|0)<=19903;else e=0;i=b;return e&1|0}function jJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=131072)e=(c[d>>2]|0)<=173791;else e=0;i=b;return e&1|0}function kJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=5024)e=(c[d>>2]|0)<=5119;else e=0;i=b;return e&1|0}function lJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=768)e=(c[d>>2]|0)<=879;else e=0;i=b;return e&1|0}function mJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=8400)e=(c[d>>2]|0)<=8447;else e=0;i=b;return e&1|0}function nJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=65056)e=(c[d>>2]|0)<=65071;else e=0;i=b;return e&1|0}function oJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=8400)e=(c[d>>2]|0)<=8447;else e=0;i=b;return e&1|0}function pJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=9216)e=(c[d>>2]|0)<=9279;else e=0;i=b;return e&1|0}function qJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=8352)e=(c[d>>2]|0)<=8399;else e=0;i=b;return e&1|0}function rJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=67584)e=(c[d>>2]|0)<=67647;else e=0;i=b;return e&1|0}function sJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=1024)e=(c[d>>2]|0)<=1279;else e=0;i=b;return e&1|0}function tJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=1280)e=(c[d>>2]|0)<=1327;else e=0;i=b;return e&1|0}function uJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=66560)e=(c[d>>2]|0)<=66639;else e=0;i=b;return e&1|0}function vJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=2304)e=(c[d>>2]|0)<=2431;else e=0;i=b;return e&1|0}function wJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=9984)e=(c[d>>2]|0)<=10175;else e=0;i=b;return e&1|0}function xJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=9312)e=(c[d>>2]|0)<=9471;else e=0;i=b;return e&1|0}function yJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=12800)e=(c[d>>2]|0)<=13055;else e=0;i=b;return e&1|0}function zJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=4608)e=(c[d>>2]|0)<=4991;else e=0;i=b;return e&1|0}function AJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=8192)e=(c[d>>2]|0)<=8303;else e=0;i=b;return e&1|0}function BJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=9632)e=(c[d>>2]|0)<=9727;else e=0;i=b;return e&1|0}function CJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=4256)e=(c[d>>2]|0)<=4351;else e=0;i=b;return e&1|0}function DJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=66352)e=(c[d>>2]|0)<=66383;else e=0;i=b;return e&1|0}function EJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=880)e=(c[d>>2]|0)<=1023;else e=0;i=b;return e&1|0}function FJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=7936)e=(c[d>>2]|0)<=8191;else e=0;i=b;return e&1|0}function GJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=880)e=(c[d>>2]|0)<=1023;else e=0;i=b;return e&1|0}function HJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=2688)e=(c[d>>2]|0)<=2815;else e=0;i=b;return e&1|0}function IJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=2560)e=(c[d>>2]|0)<=2687;else e=0;i=b;return e&1|0}function JJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=65280)e=(c[d>>2]|0)<=65519;else e=0;i=b;return e&1|0}function KJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=12592)e=(c[d>>2]|0)<=12687;else e=0;i=b;return e&1|0}function LJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=4352)e=(c[d>>2]|0)<=4607;else e=0;i=b;return e&1|0}function MJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=44032)e=(c[d>>2]|0)<=55215;else e=0;i=b;return e&1|0}function NJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=5920)e=(c[d>>2]|0)<=5951;else e=0;i=b;return e&1|0}function OJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=1424)e=(c[d>>2]|0)<=1535;else e=0;i=b;return e&1|0}function PJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=56192)e=(c[d>>2]|0)<=56319;else e=0;i=b;return e&1|0}function QJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=55296)e=(c[d>>2]|0)<=56191;else e=0;i=b;return e&1|0}function RJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=12352)e=(c[d>>2]|0)<=12447;else e=0;i=b;return e&1|0}function SJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=592)e=(c[d>>2]|0)<=687;else e=0;i=b;return e&1|0}function TJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=12272)e=(c[d>>2]|0)<=12287;else e=0;i=b;return e&1|0}function UJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=12688)e=(c[d>>2]|0)<=12703;else e=0;i=b;return e&1|0}function VJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=12032)e=(c[d>>2]|0)<=12255;else e=0;i=b;return e&1|0}function WJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=3200)e=(c[d>>2]|0)<=3327;else e=0;i=b;return e&1|0}function XJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=12448)e=(c[d>>2]|0)<=12543;else e=0;i=b;return e&1|0}function YJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=12784)e=(c[d>>2]|0)<=12799;else e=0;i=b;return e&1|0}function ZJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=6016)e=(c[d>>2]|0)<=6143;else e=0;i=b;return e&1|0}function _J(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=6624)e=(c[d>>2]|0)<=6655;else e=0;i=b;return e&1|0}function $J(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=3712)e=(c[d>>2]|0)<=3839;else e=0;i=b;return e&1|0}function aK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=128)e=(c[d>>2]|0)<=255;else e=0;i=b;return e&1|0}function bK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=256)e=(c[d>>2]|0)<=383;else e=0;i=b;return e&1|0}function cK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=384)e=(c[d>>2]|0)<=591;else e=0;i=b;return e&1|0}function dK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=7680)e=(c[d>>2]|0)<=7935;else e=0;i=b;return e&1|0}function eK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=8448)e=(c[d>>2]|0)<=8527;else e=0;i=b;return e&1|0}function fK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=6400)e=(c[d>>2]|0)<=6479;else e=0;i=b;return e&1|0}function gK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=65664)e=(c[d>>2]|0)<=65791;else e=0;i=b;return e&1|0}function hK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=65536)e=(c[d>>2]|0)<=65663;else e=0;i=b;return e&1|0}function iK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=56320)e=(c[d>>2]|0)<=57343;else e=0;i=b;return e&1|0}function jK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=3328)e=(c[d>>2]|0)<=3455;else e=0;i=b;return e&1|0}function kK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=119808)e=(c[d>>2]|0)<=120831;else e=0;i=b;return e&1|0}function lK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=8704)e=(c[d>>2]|0)<=8959;else e=0;i=b;return e&1|0}function mK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=10176)e=(c[d>>2]|0)<=10223;else e=0;i=b;return e&1|0}function nK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=10624)e=(c[d>>2]|0)<=10751;else e=0;i=b;return e&1|0}function oK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=9728)e=(c[d>>2]|0)<=9983;else e=0;i=b;return e&1|0}function pK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=11008)e=(c[d>>2]|0)<=11263;else e=0;i=b;return e&1|0}function qK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=8960)e=(c[d>>2]|0)<=9215;else e=0;i=b;return e&1|0}function rK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=6144)e=(c[d>>2]|0)<=6319;else e=0;i=b;return e&1|0}function sK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=119040)e=(c[d>>2]|0)<=119295;else e=0;i=b;return e&1|0}function tK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=4096)e=(c[d>>2]|0)<=4255;else e=0;i=b;return e&1|0}function uK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=8528)e=(c[d>>2]|0)<=8591;else e=0;i=b;return e&1|0}function vK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=5760)e=(c[d>>2]|0)<=5791;else e=0;
i=b;return e&1|0}function wK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=66304)e=(c[d>>2]|0)<=66351;else e=0;i=b;return e&1|0}function xK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=9280)e=(c[d>>2]|0)<=9311;else e=0;i=b;return e&1|0}function yK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=2816)e=(c[d>>2]|0)<=2943;else e=0;i=b;return e&1|0}function zK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=66688)e=(c[d>>2]|0)<=66735;else e=0;i=b;return e&1|0}function AK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=7424)e=(c[d>>2]|0)<=7551;else e=0;i=b;return e&1|0}function BK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!((c[d>>2]|0)>=57344&(c[d>>2]|0)<=63743)?!((c[d>>2]|0)>=983040&(c[d>>2]|0)<=1048575):0)if((c[d>>2]|0)>=1048576)e=(c[d>>2]|0)<=1114111;else e=0;else e=1;i=b;return e&1|0}function CK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=57344)e=(c[d>>2]|0)<=63743;else e=0;i=b;return e&1|0}function DK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=5792)e=(c[d>>2]|0)<=5887;else e=0;i=b;return e&1|0}function EK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=66640)e=(c[d>>2]|0)<=66687;else e=0;i=b;return e&1|0}function FK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=3456)e=(c[d>>2]|0)<=3583;else e=0;i=b;return e&1|0}function GK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=65104)e=(c[d>>2]|0)<=65135;else e=0;i=b;return e&1|0}function HK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=688)e=(c[d>>2]|0)<=767;else e=0;i=b;return e&1|0}function IK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=65520)e=(c[d>>2]|0)<=65535;else e=0;i=b;return e&1|0}function JK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=8304)e=(c[d>>2]|0)<=8351;else e=0;i=b;return e&1|0}function KK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=10224)e=(c[d>>2]|0)<=10239;else e=0;i=b;return e&1|0}function LK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=10496)e=(c[d>>2]|0)<=10623;else e=0;i=b;return e&1|0}function MK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=10752)e=(c[d>>2]|0)<=11007;else e=0;i=b;return e&1|0}function NK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=983040)e=(c[d>>2]|0)<=1048575;else e=0;i=b;return e&1|0}function OK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=1048576)e=(c[d>>2]|0)<=1114111;else e=0;i=b;return e&1|0}function PK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=1792)e=(c[d>>2]|0)<=1871;else e=0;i=b;return e&1|0}function QK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=5888)e=(c[d>>2]|0)<=5919;else e=0;i=b;return e&1|0}function RK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=5984)e=(c[d>>2]|0)<=6015;else e=0;i=b;return e&1|0}function SK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=917504)e=(c[d>>2]|0)<=917631;else e=0;i=b;return e&1|0}function TK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=6480)e=(c[d>>2]|0)<=6527;else e=0;i=b;return e&1|0}function UK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=119552)e=(c[d>>2]|0)<=119647;else e=0;i=b;return e&1|0}function VK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=2944)e=(c[d>>2]|0)<=3071;else e=0;i=b;return e&1|0}function WK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=3072)e=(c[d>>2]|0)<=3199;else e=0;i=b;return e&1|0}function XK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=1920)e=(c[d>>2]|0)<=1983;else e=0;i=b;return e&1|0}function YK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=3584)e=(c[d>>2]|0)<=3711;else e=0;i=b;return e&1|0}function ZK(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=3840)e=(c[d>>2]|0)<=4095;else e=0;i=b;return e&1|0}function _K(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=66432)e=(c[d>>2]|0)<=66463;else e=0;i=b;return e&1|0}function $K(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=5120)e=(c[d>>2]|0)<=5759;else e=0;i=b;return e&1|0}function aL(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=65024)e=(c[d>>2]|0)<=65039;else e=0;i=b;return e&1|0}function bL(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=917760)e=(c[d>>2]|0)<=917999;else e=0;i=b;return e&1|0}function cL(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=42128)e=(c[d>>2]|0)<=42191;else e=0;i=b;return e&1|0}function dL(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=40960)e=(c[d>>2]|0)<=42127;else e=0;i=b;return e&1|0}function eL(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>=19904)e=(c[d>>2]|0)<=19967;else e=0;i=b;return e&1|0}function fL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=PL(172456,c[g>>2]|0)|0;if(!(c[h>>2]|0)){c[e>>2]=-1;j=c[e>>2]|0;i=d;return j|0}else{c[e>>2]=Cb[c[h>>2]&511](c[f>>2]|0)|0;j=c[e>>2]|0;i=d;return j|0}return 0}function gL(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=DQ(c[d>>2]|0,172464)|0;i=b;return a|0}function hL(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!((c[d>>2]|0)>=0&(c[d>>2]|0)<=31))if((c[d>>2]|0)>=127)e=(c[d>>2]|0)<=159;else e=0;else e=1;i=b;return e&1|0}function iL(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=DQ(c[d>>2]|0,172480)|0;i=b;return a|0}function jL(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)==57344|(c[d>>2]|0)==63743|(c[d>>2]|0)==983040|(c[d>>2]|0)==1048573|(c[d>>2]|0)==1048576){e=1;f=e&1;i=b;return f|0}e=(c[d>>2]|0)==1114109;f=e&1;i=b;return f|0}function kL(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=DQ(c[d>>2]|0,172496)|0;i=b;return a|0}function lL(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=DQ(c[d>>2]|0,172512)|0;i=b;return a|0}function mL(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=DQ(c[d>>2]|0,172528)|0;i=b;return a|0}function nL(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=DQ(c[d>>2]|0,172544)|0;i=b;return a|0}function oL(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=DQ(c[d>>2]|0,172560)|0;i=b;return a|0}function pL(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=DQ(c[d>>2]|0,172576)|0;i=b;return a|0}function qL(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=DQ(c[d>>2]|0,172592)|0;i=b;return a|0}function rL(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=DQ(c[d>>2]|0,172608)|0;i=b;return a|0}function sL(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!((c[d>>2]|0)>=1160&(c[d>>2]|0)<=1161|(c[d>>2]|0)==1758)?!((c[d>>2]|0)>=8413&(c[d>>2]|0)<=8416):0)if((c[d>>2]|0)>=8418)e=(c[d>>2]|0)<=8420;else e=0;else e=1;i=b;return e&1|0}function tL(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=DQ(c[d>>2]|0,172624)|0;i=b;return a|0}function uL(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=DQ(c[d>>2]|0,172640)|0;i=b;return a|0}function vL(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=DQ(c[d>>2]|0,172656)|0;i=b;return a|0}function wL(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(((!((c[d>>2]|0)>=5870&(c[d>>2]|0)<=5872)?!((c[d>>2]|0)>=8544&(c[d>>2]|0)<=8579|(c[d>>2]|0)==12295):0)?!((c[d>>2]|0)>=12321&(c[d>>2]|0)<=12329):0)?!((c[d>>2]|0)>=12344&(c[d>>2]|0)<=12346):0)e=(c[d>>2]|0)==66378;else e=1;i=b;return e&1|0}function xL(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=DQ(c[d>>2]|0,172672)|0;i=b;return a|0}function yL(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=DQ(c[d>>2]|0,172688)|0;i=b;return a|0}function zL(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((((c[d>>2]|0)!=95?!((c[d>>2]|0)>=8255&(c[d>>2]|0)<=8256|(c[d>>2]|0)==8276|(c[d>>2]|0)==12539):0)?!((c[d>>2]|0)>=65075&(c[d>>2]|0)<=65076):0)?!((c[d>>2]|0)>=65101&(c[d>>2]|0)<=65103|(c[d>>2]|0)==65343):0)e=(c[d>>2]|0)==65381;else e=1;i=b;return e&1|0}function AL(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=DQ(c[d>>2]|0,172704)|0;i=b;return a|0}function BL(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=DQ(c[d>>2]|0,172720)|0;i=b;return a|0}function CL(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)==187|(c[d>>2]|0)==8217|(c[d>>2]|0)==8221){e=1;f=e&1;i=b;return f|0}e=(c[d>>2]|0)==8250;f=e&1;i=b;return f|0}function DL(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!((c[d>>2]|0)==171|(c[d>>2]|0)==8216)?!((c[d>>2]|0)>=8219&(c[d>>2]|0)<=8220|(c[d>>2]|0)==8223):0)e=(c[d>>2]|0)==8249;else e=1;i=b;return e&1|0}function EL(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=DQ(c[d>>2]|0,172736)|0;i=b;return a|0}function FL(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=DQ(c[d>>2]|0,172752)|0;i=b;return a|0}function GL(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=DQ(c[d>>2]|0,172768)|0;i=b;return a|0}function HL(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=DQ(c[d>>2]|0,172784)|0;i=b;return a|0}function IL(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=DQ(c[d>>2]|0,172800)|0;i=b;return a|0}function JL(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=DQ(c[d>>2]|0,172816)|0;i=b;return a|0}function KL(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=DQ(c[d>>2]|0,172832)|0;i=b;return a|0}function LL(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=DQ(c[d>>2]|0,172848)|0;i=b;return a|0}function ML(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;i=b;return(c[d>>2]|0)==8232|0}function NL(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;i=b;return(c[d>>2]|0)==8233|0}function OL(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)==32|(c[d>>2]|0)==160|(c[d>>2]|0)==5760|(c[d>>2]|0)==6158){e=1;f=e&1;i=b;return f|0}if((c[d>>2]|0)>=8192&(c[d>>2]|0)<=8202|(c[d>>2]|0)==8239|(c[d>>2]|0)==8287){e=1;f=e&1;i=b;return f|0}e=(c[d>>2]|0)==12288;f=e&1;i=b;return f|0}function PL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d+28|0;f=d+24|0;g=d+20|0;h=d+16|0;j=d+12|0;k=d+8|0;l=d+4|0;m=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){c[e>>2]=0;n=c[e>>2]|0;i=d;return n|0}c[h>>2]=0;c[j>>2]=(c[(c[f>>2]|0)+4>>2]|0)-1;c[m>>2]=c[c[f>>2]>>2];while(1){if((c[h>>2]|0)>(c[j>>2]|0)){o=10;break}c[k>>2]=((c[h>>2]|0)+(c[j>>2]|0)|0)/2|0;f=PT(c[g>>2]|0,c[(c[m>>2]|0)+(c[k>>2]<<3)>>2]|0)|0;c[l>>2]=f;if(!f){o=6;break}f=c[k>>2]|0;if((c[l>>2]|0)<0){c[j>>2]=f-1;continue}else{c[h>>2]=f+1;continue}}if((o|0)==6){c[e>>2]=c[(c[m>>2]|0)+(c[k>>2]<<3)+4>>2];n=c[e>>2]|0;i=d;return n|0}else if((o|0)==10){c[e>>2]=0;n=c[e>>2]|0;i=d;return n|0}return 0}function QL(a){a=a|0;var b=0,d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+48|0;d=b+36|0;f=b+32|0;g=b+28|0;h=b+24|0;j=b+20|0;k=b+16|0;l=b+12|0;m=b+8|0;n=b+4|0;o=b;c[f>>2]=a;c[h>>2]=0;c[j>>2]=0;c[k>>2]=0;if(!(c[f>>2]|0)){c[d>>2]=-1;p=c[d>>2]|0;i=b;return p|0}c[(c[f>>2]|0)+68>>2]=0;a=c[f>>2]|0;if(c[(c[f>>2]|0)+4>>2]|0){c[d>>2]=mM(a)|0;p=c[d>>2]|0;i=b;return p|0}if(!(c[a+20>>2]|0)){c[d>>2]=-1;p=c[d>>2]|0;i=b;return p|0}a=c[f>>2]|0;if(!(c[c[f>>2]>>2]|0)){c[a>>2]=1;do{c[g>>2]=nM(c[f>>2]|0)|0;q=c[f>>2]|0;if((c[g>>2]|0)<0){r=10;break}if(c[(c[q+20>>2]|0)+52>>2]|0)break;if((c[c[f>>2]>>2]|0)==3)break}while((c[(c[f>>2]|0)+16>>2]|0)!=5);if((r|0)==10){c[q>>2]=2;c[(c[f>>2]|0)+16>>2]=6;c[d>>2]=-1;p=c[d>>2]|0;i=b;return p|0}q=(c[(c[(c[f>>2]|0)+20>>2]|0)+8>>2]|0)!=0;do if(!(c[(c[(c[f>>2]|0)+20>>2]|0)+52>>2]|0)){if(q)c[(c[f>>2]|0)+64>>2]=c[(c[(c[(c[f>>2]|0)+20>>2]|0)+8>>2]|0)+12>>2];s=c[f>>2]|0;if(c[(c[f>>2]|0)+64>>2]|0){c[s+16>>2]=1;break}c[s>>2]=2;c[(c[f>>2]|0)+16>>2]=6;c[d>>2]=-1;p=c[d>>2]|0;i=b;return p|0}else{if(q)c[(c[f>>2]|0)+64>>2]=c[(c[(c[(c[f>>2]|0)+20>>2]|0)+8>>2]|0)+12>>2];if(!(c[(c[f>>2]|0)+64>>2]|0))c[(c[f>>2]|0)+64>>2]=c[c[(c[(c[f>>2]|0)+20>>2]|0)+64>>2]>>2];c[(c[f>>2]|0)+16>>2]=1}while(0);c[(c[f>>2]|0)+72>>2]=0;c[(c[(c[f>>2]|0)+20>>2]|0)+436>>2]=5;r=108}else{c[j>>2]=c[a+16>>2];c[h>>2]=c[(c[(c[f>>2]|0)+20>>2]|0)+56>>2];c[k>>2]=c[(c[f>>2]|0)+64>>2]}a:while(1){if((r|0)==108){r=0;do if((c[(c[f>>2]|0)+64>>2]|0)!=0?(c[(c[(c[f>>2]|0)+64>>2]|0)+24>>2]|0)==0:0){if((c[(c[(c[f>>2]|0)+64>>2]|0)+4>>2]|0)!=3?(c[(c[(c[f>>2]|0)+64>>2]|0)+4>>2]|0)!=4:0)break;if(!(RL(c[f>>2]|0)|0)){r=113;break a}}while(0);do if((((c[(c[f>>2]|0)+156>>2]|0)!=0?(c[(c[f>>2]|0)+64>>2]|0)!=0:0)?(c[(c[(c[f>>2]|0)+64>>2]|0)+4>>2]|0)==1:0)?(c[(c[(c[f>>2]|0)+64>>2]|0)+36>>2]|0)!=0:0){if((qy(c[(c[(c[(c[f>>2]|0)+64>>2]|0)+36>>2]|0)+8>>2]|0,187376)|0)==0?(qy(c[(c[(c[(c[f>>2]|0)+64>>2]|0)+36>>2]|0)+8>>2]|0,187408)|0)==0:0)break;if(!(c[(c[f>>2]|0)+164>>2]|0)){a=Qv(c[(c[(c[f>>2]|0)+20>>2]|0)+8>>2]|0)|0;c[(c[f>>2]|0)+164>>2]=a;Sv(c[(c[f>>2]|0)+164>>2]|0,c[(c[f>>2]|0)+188>>2]&-32769)|0}if(!(RL(c[f>>2]|0)|0)){r=123;break a}Wv(c[(c[f>>2]|0)+164>>2]|0,c[(c[f>>2]|0)+64>>2]|0)|0}while(0);if((c[(c[f>>2]|0)+64>>2]|0)!=0?(c[(c[(c[f>>2]|0)+64>>2]|0)+4>>2]|0)==19:0){a=(c[f>>2]|0)+168|0;c[a>>2]=(c[a>>2]|0)+1;continue}if((c[(c[f>>2]|0)+64>>2]|0)!=0?(c[(c[(c[f>>2]|0)+64>>2]|0)+4>>2]|0)==20:0){a=(c[f>>2]|0)+168|0;c[a>>2]=(c[a>>2]|0)+-1;continue}if((((c[(c[f>>2]|0)+64>>2]|0)!=0?(c[(c[(c[f>>2]|0)+64>>2]|0)+4>>2]|0)==5:0)?(c[(c[f>>2]|0)+20>>2]|0)!=0:0)?(c[(c[(c[f>>2]|0)+20>>2]|0)+16>>2]|0)==1:0){if(((c[(c[(c[f>>2]|0)+64>>2]|0)+12>>2]|0)==0?(c[c[(c[f>>2]|0)+20>>2]>>2]|0)!=0:0)?(c[(c[c[(c[f>>2]|0)+20>>2]>>2]|0)+20>>2]|0)!=0:0){a=Hb[c[(c[c[(c[f>>2]|0)+20>>2]>>2]|0)+20>>2]&511](c[(c[f>>2]|0)+20>>2]|0,c[(c[(c[f>>2]|0)+64>>2]|0)+8>>2]|0)|0;c[(c[(c[f>>2]|0)+64>>2]|0)+12>>2]=a}if(((c[(c[(c[f>>2]|0)+64>>2]|0)+12>>2]|0)!=0?(c[(c[(c[(c[f>>2]|0)+64>>2]|0)+12>>2]|0)+4>>2]|0)==17:0)?(c[(c[(c[(c[f>>2]|0)+64>>2]|0)+12>>2]|0)+12>>2]|0)!=0:0){qM(c[f>>2]|0,c[(c[f>>2]|0)+64>>2]|0)|0;c[(c[f>>2]|0)+64>>2]=c[(c[(c[(c[f>>2]|0)+64>>2]|0)+12>>2]|0)+12>>2]}}else r=143;if(((((r|0)==143?(r=0,(c[(c[f>>2]|0)+64>>2]|0)!=0):0)?(c[(c[(c[f>>2]|0)+64>>2]|0)+4>>2]|0)==5:0)?(c[(c[f>>2]|0)+20>>2]|0)!=0:0)?(c[(c[f>>2]|0)+8>>2]|0)!=0:0)rM(c[f>>2]|0);if(!(c[(c[f>>2]|0)+64>>2]|0)){r=153;break}if((c[(c[(c[f>>2]|0)+64>>2]|0)+4>>2]|0)!=17){r=153;break}if(!(c[(c[f>>2]|0)+92>>2]|0)){r=153;break}if((c[(c[(c[f>>2]|0)+92>>2]|0)+12>>2]|0)!=(c[(c[f>>2]|0)+64>>2]|0)){r=153;break}a=sM(c[f>>2]|0)|0;c[(c[f>>2]|0)+64>>2]=a;a=(c[f>>2]|0)+72|0;c[a>>2]=(c[a>>2]|0)+1}if(!(c[(c[f>>2]|0)+64>>2]|0)){r=28;break}b:while(1){if(!(c[(c[f>>2]|0)+64>>2]|0))break;if(c[(c[(c[f>>2]|0)+64>>2]|0)+24>>2]|0)break;if((c[(c[(c[f>>2]|0)+20>>2]|0)+56>>2]|0)!=(c[h>>2]|0))break;do if(((c[j>>2]|0)!=4?(c[(c[(c[f>>2]|0)+64>>2]|0)+12>>2]|0)!=0:0)?(c[(c[(c[f>>2]|0)+64>>2]|0)+4>>2]|0)!=5:0){if(((c[(c[(c[f>>2]|0)+64>>2]|0)+12>>2]|0)!=0?(c[(c[(c[(c[f>>2]|0)+64>>2]|0)+12>>2]|0)+4>>2]|0)==3:0)?(c[(c[(c[(c[f>>2]|0)+64>>2]|0)+12>>2]|0)+24>>2]|0)==0:0)break;if(((c[(c[(c[f>>2]|0)+64>>2]|0)+4>>2]|0)!=14?(c[(c[(c[f>>2]|0)+64>>2]|0)+4>>2]|0)!=9:0)?(c[(c[(c[f>>2]|0)+64>>2]|0)+4>>2]|0)!=13:0)break b}while(0);if(((c[(c[(c[f>>2]|0)+20>>2]|0)+52>>2]|0)!=0?(c[(c[(c[f>>2]|0)+20>>2]|0)+52>>2]|0)!=(c[(c[f>>2]|0)+64>>2]|0):0)?(c[(c[(c[f>>2]|0)+20>>2]|0)+52>>2]|0)!=(c[(c[(c[f>>2]|0)+64>>2]|0)+20>>2]|0):0)break;if((c[(c[(c[f>>2]|0)+20>>2]|0)+172>>2]|0)==-1)break;c[g>>2]=nM(c[f>>2]|0)|0;t=c[f>>2]|0;if((c[g>>2]|0)<0){r=48;break a}if(!(c[t+64>>2]|0))break a}if(((((c[j>>2]|0)!=4?(c[(c[(c[f>>2]|0)+64>>2]|0)+12>>2]|0)!=0:0)?(c[(c[(c[f>>2]|0)+64>>2]|0)+4>>2]|0)!=5:0)?(c[(c[(c[f>>2]|0)+64>>2]|0)+4>>2]|0)!=19:0)?(c[(c[(c[f>>2]|0)+64>>2]|0)+4>>2]|0)!=14:0){c[(c[f>>2]|0)+64>>2]=c[(c[(c[f>>2]|0)+64>>2]|0)+12>>2];a=(c[f>>2]|0)+72|0;c[a>>2]=(c[a>>2]|0)+1;c[(c[f>>2]|0)+16>>2]=1;r=108;continue}a=(c[j>>2]|0)==1;if(c[(c[(c[f>>2]|0)+64>>2]|0)+24>>2]|0){if((((a?(c[(c[(c[f>>2]|0)+64>>2]|0)+4>>2]|0)==1:0)?(c[(c[(c[f>>2]|0)+64>>2]|0)+12>>2]|0)==0:0)?((e[(c[(c[f>>2]|0)+64>>2]|0)+58>>1]|0)&1|0)==0:0)?(c[(c[f>>2]|0)+168>>2]|0)<=0:0){c[(c[f>>2]|0)+16>>2]=2;r=108;continue}if((c[(c[f>>2]|0)+8>>2]|0)!=0?(c[(c[(c[f>>2]|0)+64>>2]|0)+4>>2]|0)==1:0)oM(c[f>>2]|0);if((c[(c[f>>2]|0)+184>>2]|0)>0?((e[(c[(c[f>>2]|0)+64>>2]|0)+58>>1]|0)&4|0)!=0:0){q=(c[f>>2]|0)+184|0;c[q>>2]=(c[q>>2]|0)+-1}c[(c[f>>2]|0)+64>>2]=c[(c[(c[f>>2]|0)+64>>2]|0)+24>>2];c[(c[f>>2]|0)+16>>2]=1;if(c[(c[f>>2]|0)+184>>2]|0){r=108;continue}if(c[(c[f>>2]|0)+168>>2]|0){r=108;continue}if(c[(c[f>>2]|0)+96>>2]|0){r=108;continue}if(!(c[(c[(c[f>>2]|0)+64>>2]|0)+28>>2]|0)){r=108;continue}if((c[(c[(c[(c[f>>2]|0)+64>>2]|0)+28>>2]|0)+4>>2]|0)==14){r=108;continue}c[l>>2]=c[(c[(c[f>>2]|0)+64>>2]|0)+28>>2];if((e[(c[l>>2]|0)+58>>1]|0)&2){r=108;continue}Qh(c[l>>2]|0);pM(c[f>>2]|0,c[l>>2]|0);r=108;continue}if(((a?(c[(c[(c[f>>2]|0)+64>>2]|0)+4>>2]|0)==1:0)?(c[(c[(c[f>>2]|0)+64>>2]|0)+12>>2]|0)==0:0)?((e[(c[(c[f>>2]|0)+64>>2]|0)+58>>1]|0)&1|0)==0:0){c[(c[f>>2]|0)+16>>2]=2;r=108;continue}if((c[(c[f>>2]|0)+8>>2]|0)!=0?(c[(c[(c[f>>2]|0)+64>>2]|0)+4>>2]|0)==1:0)oM(c[f>>2]|0);if((c[(c[f>>2]|0)+184>>2]|0)>0?((e[(c[(c[f>>2]|0)+64>>2]|0)+58>>1]|0)&4|0)!=0:0){a=(c[f>>2]|0)+184|0;c[a>>2]=(c[a>>2]|0)+-1}c[(c[f>>2]|0)+64>>2]=c[(c[(c[f>>2]|0)+64>>2]|0)+20>>2];if(!(c[(c[f>>2]|0)+64>>2]|0)){r=91;break}if((c[(c[(c[f>>2]|0)+64>>2]|0)+4>>2]|0)==9){r=91;break}if((c[(c[(c[f>>2]|0)+64>>2]|0)+4>>2]|0)==21){r=91;break}if((c[(c[(c[f>>2]|0)+64>>2]|0)+4>>2]|0)==13){r=91;break}do if((((c[(c[f>>2]|0)+184>>2]|0)==0?(c[(c[f>>2]|0)+168>>2]|0)==0:0)?(c[(c[f>>2]|0)+96>>2]|0)==0:0)?(c[(c[(c[f>>2]|0)+64>>2]|0)+16>>2]|0)!=0:0){if((e[(c[(c[(c[f>>2]|0)+64>>2]|0)+16>>2]|0)+58>>1]|0)&2)break;c[m>>2]=c[(c[(c[f>>2]|0)+64>>2]|0)+16>>2];Qh(c[m>>2]|0);pM(c[f>>2]|0,c[m>>2]|0)}while(0);a=(c[f>>2]|0)+72|0;c[a>>2]=(c[a>>2]|0)+-1;c[(c[f>>2]|0)+16>>2]=4;r=108}if((r|0)==28)if((c[c[f>>2]>>2]|0)==3){c[d>>2]=0;p=c[d>>2]|0;i=b;return p|0}else{c[d>>2]=-1;p=c[d>>2]|0;i=b;return p|0}else if((r|0)==48){c[t>>2]=2;c[(c[f>>2]|0)+16>>2]=6;c[d>>2]=-1;p=c[d>>2]|0;i=b;return p|0}else if((r|0)==91){if((c[c[f>>2]>>2]|0)!=3?(c[g>>2]=Sf(c[(c[f>>2]|0)+20>>2]|0,187368,0,1)|0,c[(c[f>>2]|0)+16>>2]=5,(c[g>>2]|0)!=0):0){c[d>>2]=-1;p=c[d>>2]|0;i=b;return p|0}c[(c[f>>2]|0)+64>>2]=0;c[(c[f>>2]|0)+72>>2]=-1;if((((((c[k>>2]|0)!=0?(c[(c[f>>2]|0)+184>>2]|0)==0:0)?(c[(c[f>>2]|0)+168>>2]|0)==0:0)?(c[(c[f>>2]|0)+96>>2]|0)==0:0)?(c[(c[k>>2]|0)+4>>2]|0)!=14:0)?((e[(c[k>>2]|0)+58>>1]|0)&2|0)==0:0){Qh(c[k>>2]|0);pM(c[f>>2]|0,c[k>>2]|0)}}else if((r|0)==113){c[d>>2]=-1;p=c[d>>2]|0;i=b;return p|0}else if((r|0)==123){c[d>>2]=-1;p=c[d>>2]|0;i=b;return p|0}else if((r|0)==153){do if((c[(c[f>>2]|0)+8>>2]|0)!=0?(c[(c[f>>2]|0)+64>>2]|0)!=0:0){c[n>>2]=c[(c[f>>2]|0)+64>>2];if(((c[(c[n>>2]|0)+4>>2]|0)==1?(c[(c[f>>2]|0)+16>>2]|0)!=2:0)?(c[(c[f>>2]|0)+16>>2]|0)!=4:0){tM(c[f>>2]|0);break}if((c[(c[n>>2]|0)+4>>2]|0)!=3?(c[(c[n>>2]|0)+4>>2]|0)!=4:0)break;r=c[f>>2]|0;k=c[(c[n>>2]|0)+40>>2]|0;uM(r,k,xy(c[(c[n>>2]|0)+40>>2]|0)|0)}while(0);c:do if(((c[(c[f>>2]|0)+172>>2]|0)>0?(c[(c[f>>2]|0)+16>>2]|0)!=2:0)?(c[(c[f>>2]|0)+16>>2]|0)!=4:0){c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[(c[f>>2]|0)+172>>2]|0))break c;if((NQ(c[(c[(c[f>>2]|0)+180>>2]|0)+(c[o>>2]<<2)>>2]|0,c[(c[f>>2]|0)+64>>2]|0)|0)==1)break;c[o>>2]=(c[o>>2]|0)+1}SL(c[f>>2]|0)|0}while(0);if(((c[(c[f>>2]|0)+8>>2]|0)==4?(c[(c[f>>2]|0)+148>>2]|0)==0:0)?(c[(c[f>>2]|0)+140>>2]|0)!=0:0){o=((gB(c[(c[f>>2]|0)+140>>2]|0)|0)!=0^1)&1;c[(c[f>>2]|0)+148>>2]=o}c[d>>2]=1;p=c[d>>2]|0;i=b;return p|0}c[(c[f>>2]|0)+16>>2]=5;c[d>>2]=0;p=c[d>>2]|0;i=b;return p|0}function RL(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;do if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+64>>2]|0)!=0:0){a=c[e>>2]|0;if(c[(c[e>>2]|0)+4>>2]|0){c[d>>2]=c[a+64>>2];break}if(!(c[a+20>>2]|0)){c[d>>2]=0;break}if((vM(c[e>>2]|0)|0)<0){c[d>>2]=0;break}else{c[d>>2]=c[(c[e>>2]|0)+64>>2];break}}else f=3;while(0);if((f|0)==3)c[d>>2]=0;i=b;return c[d>>2]|0}function SL(a){a=a|0;var d=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[g>>2]=a;if(!(c[g>>2]|0)){c[f>>2]=0;k=c[f>>2]|0;i=d;return k|0}a=c[g>>2]|0;if(c[(c[g>>2]|0)+68>>2]|0)c[h>>2]=c[a+68>>2];else c[h>>2]=c[a+64>>2];if(!(c[h>>2]|0)){c[f>>2]=0;k=c[f>>2]|0;i=d;return k|0}if((c[(c[h>>2]|0)+4>>2]|0)!=9?(c[(c[h>>2]|0)+4>>2]|0)!=14:0){a=(c[h>>2]|0)+58|0;b[a>>1]=e[a>>1]|0|2;a=(c[h>>2]|0)+58|0;b[a>>1]=e[a>>1]|0|4}a=(c[g>>2]|0)+184|0;c[a>>2]=(c[a>>2]|0)+1;c[j>>2]=c[(c[h>>2]|0)+20>>2];while(1){if(!(c[j>>2]|0))break;if((c[(c[j>>2]|0)+4>>2]|0)==1){a=(c[j>>2]|0)+58|0;b[a>>1]=e[a>>1]|0|2}c[j>>2]=c[(c[j>>2]|0)+20>>2]}c[f>>2]=c[h>>2];k=c[f>>2]|0;i=d;return k|0}function TL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;c[g>>2]=a;c[h>>2]=b;if(!(c[g>>2]|0)){c[f>>2]=0;k=c[f>>2]|0;i=d;return k|0}c[j>>2]=Cb[c[135744>>2]&511](196)|0;if(!(c[j>>2]|0)){Db[c[135904>>2]&511](c[33980]|0,187440,e);c[f>>2]=0;k=c[f>>2]|0;i=d;return k|0}cU(c[j>>2]|0,0,196)|0;c[(c[j>>2]|0)+4>>2]=0;c[(c[j>>2]|0)+104>>2]=0;c[(c[j>>2]|0)+100>>2]=0;c[(c[j>>2]|0)+96>>2]=0;c[(c[j>>2]|0)+28>>2]=c[g>>2];b=My(100)|0;c[(c[j>>2]|0)+84>>2]=b;if(!(c[(c[j>>2]|0)+84>>2]|0)){zb[c[135736>>2]&511](c[j>>2]|0);Db[c[135904>>2]&511](c[33980]|0,187440,e);c[f>>2]=0;k=c[f>>2]|0;i=d;return k|0}b=Cb[c[135744>>2]&511](128)|0;c[(c[j>>2]|0)+24>>2]=b;b=c[j>>2]|0;if(!(c[(c[j>>2]|0)+24>>2]|0)){Ry(c[b+84>>2]|0);zb[c[135736>>2]&511](c[j>>2]|0);Db[c[135904>>2]&511](c[33980]|0,187440,e);c[f>>2]=0;k=c[f>>2]|0;i=d;return k|0}oQ(c[b+24>>2]|0,2)|0;c[(c[j>>2]|0)+32>>2]=c[(c[(c[j>>2]|0)+24>>2]|0)+56>>2];c[(c[(c[j>>2]|0)+24>>2]|0)+56>>2]=361;c[(c[j>>2]|0)+36>>2]=c[(c[(c[j>>2]|0)+24>>2]|0)+60>>2];c[(c[(c[j>>2]|0)+24>>2]|0)+60>>2]=362;b=c[j>>2]|0;if((c[(c[(c[j>>2]|0)+24>>2]|0)+108>>2]|0)==-554844497){c[(c[j>>2]|0)+40>>2]=c[(c[b+24>>2]|0)+116>>2];c[(c[(c[j>>2]|0)+24>>2]|0)+116>>2]=363;c[(c[j>>2]|0)+44>>2]=c[(c[(c[j>>2]|0)+24>>2]|0)+120>>2];c[(c[(c[j>>2]|0)+24>>2]|0)+120>>2]=364}else{c[b+40>>2]=0;c[(c[j>>2]|0)+44>>2]=0}c[(c[j>>2]|0)+48>>2]=c[(c[(c[j>>2]|0)+24>>2]|0)+68>>2];c[(c[(c[j>>2]|0)+24>>2]|0)+68>>2]=365;c[(c[(c[j>>2]|0)+24>>2]|0)+72>>2]=365;c[(c[j>>2]|0)+52>>2]=c[(c[(c[j>>2]|0)+24>>2]|0)+100>>2];c[(c[(c[j>>2]|0)+24>>2]|0)+100>>2]=366;c[c[j>>2]>>2]=0;c[(c[j>>2]|0)+64>>2]=0;c[(c[j>>2]|0)+68>>2]=0;if((_y(c[(c[(c[j>>2]|0)+28>>2]|0)+16>>2]|0)|0)>>>0<4)Nk(c[g>>2]|0,4)|0;g=(_y(c[(c[(c[j>>2]|0)+28>>2]|0)+16>>2]|0)|0)>>>0>=4;b=c[(c[j>>2]|0)+24>>2]|0;if(g){g=Vy(c[(c[(c[j>>2]|0)+28>>2]|0)+16>>2]|0)|0;a=Tf(b,0,g,4,c[h>>2]|0)|0;c[(c[j>>2]|0)+20>>2]=a;c[(c[j>>2]|0)+56>>2]=0;c[(c[j>>2]|0)+60>>2]=4}else{a=Tf(b,0,0,0,c[h>>2]|0)|0;c[(c[j>>2]|0)+20>>2]=a;c[(c[j>>2]|0)+56>>2]=0;c[(c[j>>2]|0)+60>>2]=0}if(!(c[(c[j>>2]|0)+20>>2]|0)){Db[c[135904>>2]&511](c[33980]|0,187440,e);Ry(c[(c[j>>2]|0)+84>>2]|0);zb[c[135736>>2]&511](c[(c[j>>2]|0)+24>>2]|0);zb[c[135736>>2]&511](c[j>>2]|0);c[f>>2]=0;k=c[f>>2]|0;i=d;return k|0}else{c[(c[(c[j>>2]|0)+20>>2]|0)+436>>2]=5;c[(c[(c[j>>2]|0)+20>>2]|0)+272>>2]=c[j>>2];c[(c[(c[j>>2]|0)+20>>2]|0)+280>>2]=1;c[(c[(c[j>>2]|0)+20>>2]|0)+364>>2]=1;c[(c[j>>2]|0)+12>>2]=2;c[(c[(c[j>>2]|0)+20>>2]|0)+308>>2]=1;c[(c[j>>2]|0)+88>>2]=c[(c[(c[j>>2]|0)+20>>2]|0)+296>>2];c[(c[j>>2]|0)+156>>2]=0;c[(c[j>>2]|0)+176>>2]=0;c[(c[j>>2]|0)+180>>2]=0;c[f>>2]=c[j>>2];k=c[f>>2]|0;i=d;return k|0}return 0}function UL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;d=b+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[e>>2]=a;c[h>>2]=0;c[f>>2]=Ck(c[e>>2]|0,0)|0;if(!(c[f>>2]|0)){c[d>>2]=0;j=c[d>>2]|0;i=b;return j|0}c[g>>2]=TL(c[f>>2]|0,c[e>>2]|0)|0;if(!(c[g>>2]|0)){yk(c[f>>2]|0);c[d>>2]=0;j=c[d>>2]|0;i=b;return j|0}f=(c[g>>2]|0)+12|0;c[f>>2]=c[f>>2]|1;if(!(c[(c[(c[g>>2]|0)+20>>2]|0)+180>>2]|0))c[h>>2]=Rk(c[e>>2]|0)|0;if((c[h>>2]|0)!=0?(c[(c[(c[g>>2]|0)+20>>2]|0)+180>>2]|0)==0:0){e=my(c[h>>2]|0)|0;c[(c[(c[g>>2]|0)+20>>2]|0)+180>>2]=e}if(c[h>>2]|0)zb[c[135736>>2]&511](c[h>>2]|0);c[d>>2]=c[g>>2];j=c[d>>2]|0;i=b;return j|0}function VL(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+116>>2]|0){VM(c[(c[d>>2]|0)+116>>2]|0);c[(c[d>>2]|0)+116>>2]=0}if(c[(c[d>>2]|0)+120>>2]|0){if(!(c[(c[d>>2]|0)+124>>2]|0))fN(c[(c[d>>2]|0)+120>>2]|0);c[(c[d>>2]|0)+120>>2]=0}if(c[(c[d>>2]|0)+152>>2]|0){jB(c[(c[d>>2]|0)+152>>2]|0)|0;c[(c[d>>2]|0)+152>>2]=0}if(c[(c[d>>2]|0)+140>>2]|0){if(!(c[(c[d>>2]|0)+144>>2]|0))ZA(c[(c[d>>2]|0)+140>>2]|0);c[(c[d>>2]|0)+140>>2]=0}if(c[(c[d>>2]|0)+136>>2]|0){WA(c[(c[d>>2]|0)+136>>2]|0);c[(c[d>>2]|0)+136>>2]=0}if(c[(c[d>>2]|0)+164>>2]|0)Rv(c[(c[d>>2]|0)+164>>2]|0);if(c[(c[d>>2]|0)+180>>2]|0){c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[(c[d>>2]|0)+172>>2]|0))break;if(c[(c[(c[d>>2]|0)+180>>2]|0)+(c[e>>2]<<2)>>2]|0)EQ(c[(c[(c[d>>2]|0)+180>>2]|0)+(c[e>>2]<<2)>>2]|0);c[e>>2]=(c[e>>2]|0)+1}zb[c[135736>>2]&511](c[(c[d>>2]|0)+180>>2]|0)}if(c[(c[d>>2]|0)+76>>2]|0)Rh(c[(c[d>>2]|0)+76>>2]|0);if(c[(c[d>>2]|0)+20>>2]|0){if((c[(c[d>>2]|0)+88>>2]|0)==(c[(c[(c[d>>2]|0)+20>>2]|0)+296>>2]|0))c[(c[d>>2]|0)+88>>2]=0;if(c[(c[(c[d>>2]|0)+20>>2]|0)+8>>2]|0){if(!(c[(c[d>>2]|0)+80>>2]|0))CM(c[d>>2]|0,c[(c[(c[d>>2]|0)+20>>2]|0)+8>>2]|0);c[(c[(c[d>>2]|0)+20>>2]|0)+8>>2]=0}if((c[(c[(c[d>>2]|0)+20>>2]|0)+160>>2]|0)!=0?(c[(c[(c[d>>2]|0)+20>>2]|0)+156>>2]|0)>0:0){zb[c[135736>>2]&511](c[(c[(c[d>>2]|0)+20>>2]|0)+160>>2]|0);c[(c[(c[d>>2]|0)+20>>2]|0)+160>>2]=0;c[(c[(c[d>>2]|0)+20>>2]|0)+156>>2]=0}if(c[(c[d>>2]|0)+12>>2]&2)Ae(c[(c[d>>2]|0)+20>>2]|0)}if(c[(c[d>>2]|0)+24>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+24>>2]|0);if((c[(c[d>>2]|0)+28>>2]|0)!=0?(c[(c[d>>2]|0)+12>>2]&1|0)!=0:0)yk(c[(c[d>>2]|0)+28>>2]|0);if(c[(c[d>>2]|0)+84>>2]|0)Ry(c[(c[d>>2]|0)+84>>2]|0);if(c[(c[d>>2]|0)+104>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+104>>2]|0);if(c[(c[d>>2]|0)+88>>2]|0)zP(c[(c[d>>2]|0)+88>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function WL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;do if(c[f>>2]|0){if(!(c[(c[f>>2]|0)+64>>2]|0)){c[e>>2]=0;break}c[h>>2]=cj(c[(c[(c[f>>2]|0)+64>>2]|0)+32>>2]|0,c[(c[f>>2]|0)+64>>2]|0,c[g>>2]|0)|0;if(!(c[h>>2]|0)){c[e>>2]=0;break}else{c[e>>2]=my(c[(c[h>>2]|0)+8>>2]|0)|0;break}}else c[e>>2]=0;while(0);i=d;return c[e>>2]|0}function XL(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;a:do if(!(c[e>>2]|0))c[d>>2]=-1;else{if(!(c[(c[e>>2]|0)+64>>2]|0)){c[d>>2]=0;break}a=c[e>>2]|0;if(c[(c[e>>2]|0)+68>>2]|0)c[f>>2]=c[a+68>>2];else c[f>>2]=c[a+64>>2];do switch(c[(c[f>>2]|0)+4>>2]|0){case 7:{c[d>>2]=7;break a;break}case 2:case 18:{c[d>>2]=2;break a;break}case 1:{if((c[(c[e>>2]|0)+16>>2]|0)!=2?(c[(c[e>>2]|0)+16>>2]|0)!=4:0){c[d>>2]=1;break a}c[d>>2]=15;break a;break}case 5:{c[d>>2]=5;break a;break}case 12:{c[d>>2]=12;break a;break}case 21:case 13:case 9:{c[d>>2]=9;break a;break}case 6:{c[d>>2]=6;break a;break}case 11:{c[d>>2]=11;break a;break}case 3:{if(!(ij(c[(c[e>>2]|0)+64>>2]|0)|0)){c[d>>2]=3;break a}if(Vi(c[(c[e>>2]|0)+64>>2]|0)|0){c[d>>2]=14;break a}else{c[d>>2]=13;break a}break}case 14:case 10:{c[d>>2]=10;break a;break}case 4:{c[d>>2]=4;break a;break}case 20:case 19:case 17:case 16:case 15:{c[d>>2]=0;break a;break}case 8:{c[d>>2]=8;break a;break}default:{c[d>>2]=-1;break a}}while(0)}while(0);i=b;return c[d>>2]|0}function YL(a){a=a|0;var b=0,d=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;f=b;c[f>>2]=a;do if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+64>>2]|0)!=0:0){if((c[(c[(c[f>>2]|0)+64>>2]|0)+4>>2]|0)!=1){c[d>>2]=0;break}if(c[(c[f>>2]|0)+68>>2]|0){c[d>>2]=0;break}if(c[(c[(c[f>>2]|0)+64>>2]|0)+12>>2]|0){c[d>>2]=0;break}if((c[(c[f>>2]|0)+16>>2]|0)==2){c[d>>2]=0;break}if(c[(c[f>>2]|0)+4>>2]|0){c[d>>2]=1;break}if((c[(c[f>>2]|0)+168>>2]|0)>0){c[d>>2]=1;break}else{c[d>>2]=((e[(c[(c[f>>2]|0)+64>>2]|0)+58>>1]|0)&1|0)!=0&1;break}}else g=3;while(0);if((g|0)==3)c[d>>2]=-1;i=b;return c[d>>2]|0}function ZL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+64>>2]|0)!=0:0){a=c[e>>2]|0;if(c[(c[e>>2]|0)+68>>2]|0)c[f>>2]=c[a+68>>2];else c[f>>2]=c[a+64>>2];a=c[f>>2]|0;if((c[(c[f>>2]|0)+4>>2]|0)==18){c[g>>2]=a;if(!(c[(c[g>>2]|0)+12>>2]|0)){c[d>>2]=AP(c[(c[e>>2]|0)+88>>2]|0,187480,-1)|0;h=c[d>>2]|0;i=b;return h|0}else{c[d>>2]=c[(c[g>>2]|0)+12>>2];h=c[d>>2]|0;i=b;return h|0}}if((c[a+4>>2]|0)!=1?(c[(c[f>>2]|0)+4>>2]|0)!=2:0){c[d>>2]=_L(c[e>>2]|0)|0;h=c[d>>2]|0;i=b;return h|0}c[d>>2]=c[(c[f>>2]|0)+8>>2];h=c[d>>2]|0;i=b;return h|0}c[d>>2]=0;h=c[d>>2]|0;i=b;return h|0}function _L(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;a:do if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+64>>2]|0)!=0:0){a=c[e>>2]|0;if(c[(c[e>>2]|0)+68>>2]|0)c[f>>2]=c[a+68>>2];else c[f>>2]=c[a+64>>2];do switch(c[(c[f>>2]|0)+4>>2]|0){case 20:case 19:case 17:case 16:case 15:{c[d>>2]=0;break a;break}case 11:{c[d>>2]=AP(c[(c[e>>2]|0)+88>>2]|0,187584,-1)|0;break a;break}case 18:{c[g>>2]=c[f>>2];a=c[(c[e>>2]|0)+88>>2]|0;if(!(c[(c[g>>2]|0)+12>>2]|0)){c[d>>2]=AP(a,187480,-1)|0;break a}else{c[d>>2]=BP(a,187480,c[(c[g>>2]|0)+12>>2]|0)|0;break a}break}case 21:case 13:case 9:{c[d>>2]=AP(c[(c[e>>2]|0)+88>>2]|0,187568,-1)|0;break a;break}case 4:{c[d>>2]=AP(c[(c[e>>2]|0)+88>>2]|0,187536,-1)|0;break a;break}case 2:case 1:{if((c[(c[f>>2]|0)+36>>2]|0)!=0?(c[(c[(c[f>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){c[d>>2]=BP(c[(c[e>>2]|0)+88>>2]|0,c[(c[(c[f>>2]|0)+36>>2]|0)+12>>2]|0,c[(c[f>>2]|0)+8>>2]|0)|0;break a}c[d>>2]=c[(c[f>>2]|0)+8>>2];break a;break}case 12:{c[d>>2]=AP(c[(c[e>>2]|0)+88>>2]|0,c[(c[f>>2]|0)+8>>2]|0,-1)|0;break a;break}case 5:case 6:{c[d>>2]=AP(c[(c[e>>2]|0)+88>>2]|0,c[(c[f>>2]|0)+8>>2]|0,-1)|0;break a;break}case 3:{c[d>>2]=AP(c[(c[e>>2]|0)+88>>2]|0,187528,-1)|0;break a;break}case 8:{c[d>>2]=AP(c[(c[e>>2]|0)+88>>2]|0,187552,-1)|0;break a;break}case 7:{c[d>>2]=AP(c[(c[e>>2]|0)+88>>2]|0,c[(c[f>>2]|0)+8>>2]|0,-1)|0;break a;break}case 14:case 10:{c[d>>2]=AP(c[(c[e>>2]|0)+88>>2]|0,c[(c[f>>2]|0)+8>>2]|0,-1)|0;break a;break}default:{c[d>>2]=0;break a}}while(0)}else h=3;while(0);if((h|0)==3)c[d>>2]=0;i=b;return c[d>>2]|0}function $L(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+64>>2]|0)!=0:0){a=c[e>>2]|0;if(c[(c[e>>2]|0)+68>>2]|0)c[f>>2]=c[a+68>>2];else c[f>>2]=c[a+64>>2];if((c[(c[f>>2]|0)+4>>2]|0)==18){c[d>>2]=AP(c[(c[e>>2]|0)+88>>2]|0,187488,-1)|0;g=c[d>>2]|0;i=b;return g|0}if((c[(c[f>>2]|0)+4>>2]|0)!=1?(c[(c[f>>2]|0)+4>>2]|0)!=2:0){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}if(c[(c[f>>2]|0)+36>>2]|0){c[d>>2]=AP(c[(c[e>>2]|0)+88>>2]|0,c[(c[(c[f>>2]|0)+36>>2]|0)+8>>2]|0,-1)|0;g=c[d>>2]|0;i=b;return g|0}else{c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}}c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}function aM(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;do if(!(c[e>>2]|0))c[d>>2]=-1;else{if(!(c[(c[e>>2]|0)+64>>2]|0)){c[d>>2]=0;break}a=c[e>>2]|0;if(!(c[(c[e>>2]|0)+68>>2]|0)){c[d>>2]=c[a+72>>2];break}if((c[(c[a+68>>2]|0)+4>>2]|0)!=2?(c[(c[(c[e>>2]|0)+68>>2]|0)+4>>2]|0)!=18:0){c[d>>2]=(c[(c[e>>2]|0)+72>>2]|0)+2;break}c[d>>2]=(c[(c[e>>2]|0)+72>>2]|0)+1}while(0);i=b;return c[d>>2]|0}function bM(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;a:do if(!(c[e>>2]|0))c[d>>2]=-1;else{if(!(c[(c[e>>2]|0)+64>>2]|0)){c[d>>2]=0;break}a=c[e>>2]|0;if(c[(c[e>>2]|0)+68>>2]|0)c[f>>2]=c[a+68>>2];else c[f>>2]=c[a+64>>2];switch(c[(c[f>>2]|0)+4>>2]|0){case 18:case 8:case 7:case 4:case 3:case 2:{c[d>>2]=1;break a;break}default:{c[d>>2]=0;break a}}}while(0);i=b;return c[d>>2]|0}function cM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;d=b;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;c[f>>2]=a;if(!(c[f>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=b;return j|0}if(!(c[(c[f>>2]|0)+64>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=b;return j|0}a=c[f>>2]|0;if(c[(c[f>>2]|0)+68>>2]|0)c[g>>2]=c[a+68>>2];else c[g>>2]=c[a+64>>2];switch(c[(c[g>>2]|0)+4>>2]|0){case 8:case 7:case 4:case 3:{c[e>>2]=c[(c[g>>2]|0)+40>>2];j=c[e>>2]|0;i=b;return j|0}case 2:{c[h>>2]=c[g>>2];if(((c[(c[h>>2]|0)+12>>2]|0)!=0?(c[(c[(c[h>>2]|0)+12>>2]|0)+4>>2]|0)==3:0)?(c[(c[(c[h>>2]|0)+12>>2]|0)+24>>2]|0)==0:0){c[e>>2]=c[(c[(c[h>>2]|0)+12>>2]|0)+40>>2];j=c[e>>2]|0;i=b;return j|0}if(!(c[(c[f>>2]|0)+84>>2]|0)){h=My(100)|0;c[(c[f>>2]|0)+84>>2]=h;if(!(c[(c[f>>2]|0)+84>>2]|0)){Db[c[135904>>2]&511](c[33980]|0,187608,d);c[e>>2]=0;j=c[e>>2]|0;i=b;return j|0}}else Sy(c[(c[f>>2]|0)+84>>2]|0);Zi(c[(c[f>>2]|0)+84>>2]|0,c[g>>2]|0)|0;c[e>>2]=Vy(c[(c[f>>2]|0)+84>>2]|0)|0;j=c[e>>2]|0;i=b;return j|0;
}case 18:{c[e>>2]=c[(c[g>>2]|0)+8>>2];j=c[e>>2]|0;i=b;return j|0}default:{c[e>>2]=0;j=c[e>>2]|0;i=b;return j|0}}return 0}function dM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=c[h>>2];a:do if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+20>>2]|0)!=0:0){c[l>>2]=c[(c[g>>2]|0)+20>>2];h=c[k>>2]|0;if((h|0)==4){d=(c[l>>2]|0)+16|0;if(c[j>>2]|0)c[d>>2]=1;else c[d>>2]=0;c[f>>2]=0;break}else if((h|0)==2){d=(c[l>>2]|0)+276|0;b=c[d>>2]|0;if(!(c[j>>2]|0)){if(b&4){a=(c[l>>2]|0)+276|0;c[a>>2]=(c[a>>2]|0)-4}}else c[d>>2]=b|4;c[f>>2]=0;break}else if((h|0)==1){b=(c[l>>2]|0)+276|0;do if(c[j>>2]|0){if(!(c[b>>2]|0))if(c[c[g>>2]>>2]|0){c[f>>2]=-1;break a}else{c[(c[l>>2]|0)+276>>2]=2;break}}else c[b>>2]=0;while(0);c[f>>2]=0;break}else if((h|0)==3){b=(c[l>>2]|0)+104|0;if(c[j>>2]|0){c[b>>2]=1;c[(c[g>>2]|0)+8>>2]=1}else c[b>>2]=0;c[f>>2]=0;break}else{c[f>>2]=-1;break}}else m=3;while(0);if((m|0)==3)c[f>>2]=-1;i=e;return c[f>>2]|0}function eM(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;do if(c[e>>2]|0){a=c[e>>2]|0;if(c[(c[e>>2]|0)+68>>2]|0){c[d>>2]=c[a+68>>2];break}else{c[d>>2]=c[a+64>>2];break}}else c[d>>2]=0;while(0);i=b;return c[d>>2]|0}function fM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=HM(c[e>>2]|0,c[f>>2]|0,0,0)|0;i=d;return b|0}function gM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=IM(c[e>>2]|0,c[f>>2]|0,0,0)|0;i=d;return b|0}function hM(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;do if(!(c[e>>2]|0))c[d>>2]=-1;else{a=c[e>>2]|0;if((c[(c[e>>2]|0)+8>>2]|0)==2){c[d>>2]=(c[a+128>>2]|0)==0&1;break}f=c[e>>2]|0;if((c[a+8>>2]|0)==4){c[d>>2]=(c[f+148>>2]|0)==0&1;break}if((c[f+20>>2]|0)!=0?(c[(c[(c[e>>2]|0)+20>>2]|0)+104>>2]|0)==1:0){c[d>>2]=c[(c[(c[e>>2]|0)+20>>2]|0)+100>>2];break}c[d>>2]=0}while(0);i=b;return c[d>>2]|0}function iM(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+48|0;h=g;j=g+40|0;k=g+36|0;l=g+32|0;m=g+28|0;n=g+24|0;o=g+20|0;p=g+16|0;q=g+12|0;r=g+8|0;s=g+4|0;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;if(!(c[k>>2]|0)){if(c[l>>2]|0)yk(c[l>>2]|0);c[j>>2]=-1;t=c[j>>2]|0;i=g;return t|0}c[o>>2]=c[o>>2]|65536;c[(c[k>>2]|0)+4>>2]=0;c[(c[k>>2]|0)+96>>2]=0;c[(c[k>>2]|0)+188>>2]=c[o>>2];c[(c[k>>2]|0)+8>>2]=0;if(((c[l>>2]|0)!=0?(c[(c[k>>2]|0)+28>>2]|0)!=0:0)?(c[(c[k>>2]|0)+12>>2]&1|0)!=0:0){yk(c[(c[k>>2]|0)+28>>2]|0);c[(c[k>>2]|0)+28>>2]=0;f=(c[k>>2]|0)+12|0;c[f>>2]=(c[f>>2]|0)-1}if(c[l>>2]|0){c[(c[k>>2]|0)+28>>2]=c[l>>2];f=(c[k>>2]|0)+12|0;c[f>>2]=c[f>>2]|1}if(!(c[(c[k>>2]|0)+84>>2]|0)){f=My(100)|0;c[(c[k>>2]|0)+84>>2]=f}if(!(c[(c[k>>2]|0)+84>>2]|0)){Db[c[135904>>2]&511](c[33980]|0,187608,h);c[j>>2]=-1;t=c[j>>2]|0;i=g;return t|0}if(!(c[(c[k>>2]|0)+24>>2]|0)){f=Cb[c[135744>>2]&511](128)|0;c[(c[k>>2]|0)+24>>2]=f}if(!(c[(c[k>>2]|0)+24>>2]|0)){Db[c[135904>>2]&511](c[33980]|0,187608,h);c[j>>2]=-1;t=c[j>>2]|0;i=g;return t|0}oQ(c[(c[k>>2]|0)+24>>2]|0,2)|0;c[(c[k>>2]|0)+32>>2]=c[(c[(c[k>>2]|0)+24>>2]|0)+56>>2];c[(c[(c[k>>2]|0)+24>>2]|0)+56>>2]=361;c[(c[k>>2]|0)+36>>2]=c[(c[(c[k>>2]|0)+24>>2]|0)+60>>2];c[(c[(c[k>>2]|0)+24>>2]|0)+60>>2]=362;f=c[k>>2]|0;if((c[(c[(c[k>>2]|0)+24>>2]|0)+108>>2]|0)==-554844497){c[(c[k>>2]|0)+40>>2]=c[(c[f+24>>2]|0)+116>>2];c[(c[(c[k>>2]|0)+24>>2]|0)+116>>2]=363;c[(c[k>>2]|0)+44>>2]=c[(c[(c[k>>2]|0)+24>>2]|0)+120>>2];c[(c[(c[k>>2]|0)+24>>2]|0)+120>>2]=364}else{c[f+40>>2]=0;c[(c[k>>2]|0)+44>>2]=0}c[(c[k>>2]|0)+48>>2]=c[(c[(c[k>>2]|0)+24>>2]|0)+68>>2];c[(c[(c[k>>2]|0)+24>>2]|0)+68>>2]=365;c[(c[(c[k>>2]|0)+24>>2]|0)+72>>2]=365;c[(c[k>>2]|0)+52>>2]=c[(c[(c[k>>2]|0)+24>>2]|0)+100>>2];c[(c[(c[k>>2]|0)+24>>2]|0)+100>>2]=366;c[c[k>>2]>>2]=0;c[(c[k>>2]|0)+64>>2]=0;c[(c[k>>2]|0)+68>>2]=0;if(c[l>>2]|0){if((_y(c[(c[(c[k>>2]|0)+28>>2]|0)+16>>2]|0)|0)>>>0<4)Nk(c[l>>2]|0,4)|0;do if(!(c[(c[k>>2]|0)+20>>2]|0)){l=(_y(c[(c[(c[k>>2]|0)+28>>2]|0)+16>>2]|0)|0)>>>0>=4;f=c[(c[k>>2]|0)+24>>2]|0;if(l){l=Vy(c[(c[(c[k>>2]|0)+28>>2]|0)+16>>2]|0)|0;e=Tf(f,0,l,4,c[m>>2]|0)|0;c[(c[k>>2]|0)+20>>2]=e;c[(c[k>>2]|0)+56>>2]=0;c[(c[k>>2]|0)+60>>2]=4;break}else{e=Tf(f,0,0,0,c[m>>2]|0)|0;c[(c[k>>2]|0)+20>>2]=e;c[(c[k>>2]|0)+56>>2]=0;c[(c[k>>2]|0)+60>>2]=0;break}}else{c[r>>2]=0;eg(c[(c[k>>2]|0)+20>>2]|0);c[q>>2]=vk(c[r>>2]|0)|0;if(!(c[q>>2]|0)){c[j>>2]=-1;t=c[j>>2]|0;i=g;return t|0}c[p>>2]=ue(c[(c[k>>2]|0)+20>>2]|0)|0;if(!(c[p>>2]|0)){yk(c[q>>2]|0);c[j>>2]=-1;t=c[j>>2]|0;i=g;return t|0}if(!(c[m>>2]|0))c[(c[p>>2]|0)+4>>2]=0;else{e=Jl(c[m>>2]|0)|0;c[(c[p>>2]|0)+4>>2]=e}c[c[p>>2]>>2]=c[q>>2];iz(c[(c[q>>2]|0)+16>>2]|0,c[p>>2]|0)|0;Oe(c[(c[k>>2]|0)+20>>2]|0,c[p>>2]|0)|0;c[(c[k>>2]|0)+60>>2]=0}while(0);if(!(c[(c[k>>2]|0)+20>>2]|0)){Db[c[135904>>2]&511](c[33980]|0,187608,h);c[j>>2]=-1;t=c[j>>2]|0;i=g;return t|0}}h=c[(c[(c[k>>2]|0)+20>>2]|0)+296>>2]|0;do if(c[(c[k>>2]|0)+88>>2]|0){p=c[(c[k>>2]|0)+88>>2]|0;q=(c[(c[k>>2]|0)+20>>2]|0)+296|0;if(!h){c[q>>2]=p;break}if((p|0)!=(c[q>>2]|0)){zP(c[(c[k>>2]|0)+88>>2]|0);c[(c[k>>2]|0)+88>>2]=c[(c[(c[k>>2]|0)+20>>2]|0)+296>>2]}}else{if(!h){q=xP()|0;c[(c[(c[k>>2]|0)+20>>2]|0)+296>>2]=q}c[(c[k>>2]|0)+88>>2]=c[(c[(c[k>>2]|0)+20>>2]|0)+296>>2]}while(0);c[(c[(c[k>>2]|0)+20>>2]|0)+272>>2]=c[k>>2];c[(c[(c[k>>2]|0)+20>>2]|0)+280>>2]=1;c[(c[(c[k>>2]|0)+20>>2]|0)+364>>2]=1;c[(c[(c[k>>2]|0)+20>>2]|0)+308>>2]=1;c[(c[(c[k>>2]|0)+20>>2]|0)+436>>2]=5;if(c[(c[k>>2]|0)+164>>2]|0){Rv(c[(c[k>>2]|0)+164>>2]|0);c[(c[k>>2]|0)+164>>2]=0}h=(c[k>>2]|0)+156|0;if(c[o>>2]&1024){c[h>>2]=1;q=AP(c[(c[k>>2]|0)+88>>2]|0,187696,-1)|0;c[(c[k>>2]|0)+160>>2]=q;c[o>>2]=(c[o>>2]|0)-1024}else c[h>>2]=0;c[(c[k>>2]|0)+168>>2]=0;if(!(c[(c[k>>2]|0)+180>>2]|0)){c[(c[k>>2]|0)+172>>2]=0;c[(c[k>>2]|0)+176>>2]=0}while(1){if((c[(c[k>>2]|0)+172>>2]|0)<=0)break;h=(c[k>>2]|0)+172|0;c[h>>2]=(c[h>>2]|0)+-1;if(!(c[(c[(c[k>>2]|0)+180>>2]|0)+(c[(c[k>>2]|0)+172>>2]<<2)>>2]|0))continue;EQ(c[(c[(c[k>>2]|0)+180>>2]|0)+(c[(c[k>>2]|0)+172>>2]<<2)>>2]|0);c[(c[(c[k>>2]|0)+180>>2]|0)+(c[(c[k>>2]|0)+172>>2]<<2)>>2]=0}if(c[o>>2]&16)c[(c[k>>2]|0)+8>>2]=1;fg(c[(c[k>>2]|0)+20>>2]|0,c[o>>2]|0)|0;if((c[n>>2]|0)!=0?(c[s>>2]=Dd(c[n>>2]|0)|0,(c[s>>2]|0)!=0):0)se(c[(c[k>>2]|0)+20>>2]|0,c[s>>2]|0)|0;if(((c[m>>2]|0)!=0?(c[(c[(c[k>>2]|0)+20>>2]|0)+36>>2]|0)!=0:0)?(c[(c[(c[(c[k>>2]|0)+20>>2]|0)+36>>2]|0)+4>>2]|0)==0:0){s=my(c[m>>2]|0)|0;c[(c[(c[(c[k>>2]|0)+20>>2]|0)+36>>2]|0)+4>>2]=s}c[(c[k>>2]|0)+4>>2]=0;c[j>>2]=0;t=c[j>>2]|0;i=g;return t|0}function jM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;c[e>>2]=a;if(!(c[e>>2]|0)){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}c[f>>2]=Cb[c[135744>>2]&511](196)|0;if(!(c[f>>2]|0)){Db[c[135904>>2]&511](c[33980]|0,187440,b);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{cU(c[f>>2]|0,0,196)|0;c[(c[f>>2]|0)+96>>2]=0;c[(c[f>>2]|0)+28>>2]=0;c[c[f>>2]>>2]=0;c[(c[f>>2]|0)+64>>2]=0;c[(c[f>>2]|0)+68>>2]=0;c[(c[f>>2]|0)+56>>2]=0;c[(c[f>>2]|0)+60>>2]=0;c[(c[f>>2]|0)+12>>2]=2;c[(c[f>>2]|0)+4>>2]=c[e>>2];c[(c[f>>2]|0)+16>>2]=0;e=xP()|0;c[(c[f>>2]|0)+88>>2]=e;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function kM(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+32|0;h=g+28|0;j=g+24|0;k=g+20|0;l=g+16|0;m=g+12|0;n=g+8|0;o=g+4|0;p=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[p>>2]=Ik(c[j>>2]|0,c[k>>2]|0,0)|0;if(!(c[p>>2]|0)){c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}c[o>>2]=TL(c[p>>2]|0,c[l>>2]|0)|0;if(!(c[o>>2]|0)){yk(c[p>>2]|0);c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}else{p=(c[o>>2]|0)+12|0;c[p>>2]=c[p>>2]|1;iM(c[o>>2]|0,0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0)|0;c[h>>2]=c[o>>2];q=c[h>>2]|0;i=g;return q|0}return 0}function lM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=UL(c[g>>2]|0)|0;if(!(c[k>>2]|0)){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}else{iM(c[k>>2]|0,0,0,c[h>>2]|0,c[j>>2]|0)|0;c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}return 0}function mM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;if((c[(c[e>>2]|0)+16>>2]|0)==2){c[d>>2]=0;f=c[d>>2]|0;i=b;return f|0}a:while(1){a=c[e>>2]|0;do if(!(c[(c[e>>2]|0)+64>>2]|0)){g=c[e>>2]|0;if(!(c[(c[a+4>>2]|0)+12>>2]|0)){h=5;break a}c[(c[e>>2]|0)+64>>2]=c[(c[g+4>>2]|0)+12>>2];c[(c[e>>2]|0)+16>>2]=0}else{if((((c[a+16>>2]|0)!=4?(c[(c[(c[e>>2]|0)+64>>2]|0)+4>>2]|0)!=14:0)?(c[(c[(c[e>>2]|0)+64>>2]|0)+4>>2]|0)!=19:0)?(c[(c[(c[e>>2]|0)+64>>2]|0)+4>>2]|0)!=5:0){j=c[(c[e>>2]|0)+64>>2]|0;if(c[(c[(c[e>>2]|0)+64>>2]|0)+12>>2]|0){c[(c[e>>2]|0)+64>>2]=c[j+12>>2];k=(c[e>>2]|0)+72|0;c[k>>2]=(c[k>>2]|0)+1;c[(c[e>>2]|0)+16>>2]=0;break}if((c[j+4>>2]|0)==2){c[(c[e>>2]|0)+16>>2]=4;break}}j=c[(c[e>>2]|0)+64>>2]|0;if(c[(c[(c[e>>2]|0)+64>>2]|0)+24>>2]|0){c[(c[e>>2]|0)+64>>2]=c[j+24>>2];c[(c[e>>2]|0)+16>>2]=0;break}k=c[e>>2]|0;if(!(c[j+20>>2]|0)){c[k+16>>2]=2;break}if((c[(c[(c[k+64>>2]|0)+20>>2]|0)+4>>2]|0)==9){h=20;break a}if((c[(c[(c[(c[e>>2]|0)+64>>2]|0)+20>>2]|0)+4>>2]|0)==13){h=20;break a}c[(c[e>>2]|0)+64>>2]=c[(c[(c[e>>2]|0)+64>>2]|0)+20>>2];k=(c[e>>2]|0)+72|0;c[k>>2]=(c[k>>2]|0)+-1;c[(c[e>>2]|0)+16>>2]=4}while(0);if((c[(c[(c[e>>2]|0)+64>>2]|0)+4>>2]|0)==19)continue;if((c[(c[(c[e>>2]|0)+64>>2]|0)+4>>2]|0)!=20){h=25;break}}if((h|0)==5){c[g+16>>2]=2;c[d>>2]=0;f=c[d>>2]|0;i=b;return f|0}else if((h|0)==20){c[(c[e>>2]|0)+16>>2]=2;c[d>>2]=0;f=c[d>>2]|0;i=b;return f|0}else if((h|0)==25){c[d>>2]=1;f=c[d>>2]|0;i=b;return f|0}return 0}function nM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+32|0;d=b+24|0;e=b+20|0;f=b+16|0;g=b+12|0;h=b+8|0;j=b+4|0;k=b;c[e>>2]=a;if((c[(c[e>>2]|0)+28>>2]|0)!=0?(c[(c[(c[e>>2]|0)+28>>2]|0)+16>>2]|0)!=0:0){c[j>>2]=c[(c[e>>2]|0)+16>>2];c[(c[e>>2]|0)+16>>2]=-1;c[f>>2]=c[(c[(c[e>>2]|0)+28>>2]|0)+16>>2];c[k>>2]=Py(c[f>>2]|0)|0;a:do{if((c[(c[e>>2]|0)+16>>2]|0)!=-1)break;a=_y(c[f>>2]|0)|0;do if(a>>>0<((c[(c[e>>2]|0)+60>>2]|0)+512|0)>>>0){if((c[c[e>>2]>>2]|0)==3)break a;c[g>>2]=Nk(c[(c[e>>2]|0)+28>>2]|0,4096)|0;if((c[g>>2]|0)==0&(c[k>>2]|0)==2){l=_y(c[f>>2]|0)|0;if((l|0)!=(c[(c[e>>2]|0)+60>>2]|0))break;c[c[e>>2]>>2]=3;c[(c[e>>2]|0)+16>>2]=c[j>>2];break}if((c[g>>2]|0)>=0)if(!(c[g>>2]|0)){m=16;break a}else break;c[c[e>>2]>>2]=3;c[(c[e>>2]|0)+16>>2]=c[j>>2];if(c[j>>2]|0){m=14;break a}if(c[(c[(c[e>>2]|0)+20>>2]|0)+8>>2]|0){m=14;break a}}while(0);a=_y(c[f>>2]|0)|0;if(a>>>0<((c[(c[e>>2]|0)+60>>2]|0)+512|0)>>>0){m=21;break}a=c[(c[e>>2]|0)+20>>2]|0;l=Vy(c[f>>2]|0)|0;c[g>>2]=Sf(a,l+(c[(c[e>>2]|0)+60>>2]|0)|0,512,0)|0;l=(c[e>>2]|0)+60|0;c[l>>2]=(c[l>>2]|0)+512;if(c[g>>2]|0)c[(c[(c[e>>2]|0)+20>>2]|0)+12>>2]=0}while((c[(c[(c[e>>2]|0)+20>>2]|0)+12>>2]|0)!=0);if((m|0)==14){c[d>>2]=c[g>>2];n=c[d>>2]|0;i=b;return n|0}else if((m|0)==16)c[c[e>>2]>>2]=3;else if((m|0)==21?(m=_y(c[f>>2]|0)|0,c[h>>2]=m-(c[(c[e>>2]|0)+60>>2]|0),m=c[(c[e>>2]|0)+20>>2]|0,l=Vy(c[f>>2]|0)|0,c[g>>2]=Sf(m,l+(c[(c[e>>2]|0)+60>>2]|0)|0,c[h>>2]|0,0)|0,l=(c[e>>2]|0)+60|0,c[l>>2]=(c[l>>2]|0)+(c[h>>2]|0),(c[g>>2]|0)!=0):0)c[(c[(c[e>>2]|0)+20>>2]|0)+12>>2]=0;do if((c[c[e>>2]>>2]|0)==1){if((((c[k>>2]|0)!=2?(c[(c[e>>2]|0)+60>>2]|0)>>>0>=4096:0)?(l=_y(c[f>>2]|0)|0,(l-(c[(c[e>>2]|0)+60>>2]|0)|0)>>>0<=512):0)?(c[g>>2]=Ty(c[f>>2]|0,c[(c[e>>2]|0)+60>>2]|0)|0,(c[g>>2]|0)>=0):0){l=(c[e>>2]|0)+60|0;c[l>>2]=(c[l>>2]|0)-(c[g>>2]|0)}}else if(((c[c[e>>2]>>2]|0)==3?(c[(c[e>>2]|0)+16>>2]|0)!=5:0)?(l=_y(c[f>>2]|0)|0,c[h>>2]=l-(c[(c[e>>2]|0)+60>>2]|0),l=c[(c[e>>2]|0)+20>>2]|0,m=Vy(c[f>>2]|0)|0,c[g>>2]=Sf(l,m+(c[(c[e>>2]|0)+60>>2]|0)|0,c[h>>2]|0,1)|0,m=_y(c[f>>2]|0)|0,c[(c[e>>2]|0)+60>>2]=m,c[(c[e>>2]|0)+16>>2]=5,(c[g>>2]|0)!=0):0){if(c[(c[(c[e>>2]|0)+20>>2]|0)+12>>2]|0){c[(c[(c[e>>2]|0)+20>>2]|0)+12>>2]=0;break}c[d>>2]=-1;n=c[d>>2]|0;i=b;return n|0}while(0);c[(c[e>>2]|0)+16>>2]=c[j>>2];if(!(c[(c[(c[e>>2]|0)+20>>2]|0)+12>>2]|0)){c[c[e>>2]>>2]=3;c[d>>2]=-1;n=c[d>>2]|0;i=b;return n|0}else{c[d>>2]=0;n=c[d>>2]|0;i=b;return n|0}}c[d>>2]=-1;n=c[d>>2]|0;i=b;return n|0}function oM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[d>>2]=a;c[e>>2]=c[(c[d>>2]|0)+64>>2];do if(((c[(c[d>>2]|0)+8>>2]|0)==1?(c[(c[d>>2]|0)+20>>2]|0)!=0:0)?(c[(c[(c[d>>2]|0)+20>>2]|0)+104>>2]|0)==1:0){if((c[(c[e>>2]|0)+36>>2]|0)!=0?(c[(c[(c[e>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){c[f>>2]=my(c[(c[(c[e>>2]|0)+36>>2]|0)+12>>2]|0)|0;c[f>>2]=By(c[f>>2]|0,187520)|0;c[f>>2]=By(c[f>>2]|0,c[(c[e>>2]|0)+8>>2]|0)|0;a=_m((c[(c[d>>2]|0)+20>>2]|0)+108|0,c[(c[(c[d>>2]|0)+20>>2]|0)+8>>2]|0,c[e>>2]|0,c[f>>2]|0)|0;h=(c[(c[d>>2]|0)+20>>2]|0)+100|0;c[h>>2]=c[h>>2]&a;if(!(c[f>>2]|0))break;zb[c[135736>>2]&511](c[f>>2]|0);break}a=_m((c[(c[d>>2]|0)+20>>2]|0)+108|0,c[(c[(c[d>>2]|0)+20>>2]|0)+8>>2]|0,c[e>>2]|0,c[(c[e>>2]|0)+8>>2]|0)|0;h=(c[(c[d>>2]|0)+20>>2]|0)+100|0;c[h>>2]=c[h>>2]&a}while(0);if((c[(c[d>>2]|0)+8>>2]|0)!=2){i=b;return}if(!(c[(c[d>>2]|0)+120>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+132>>2]|0){if((c[e>>2]|0)!=(c[(c[d>>2]|0)+132>>2]|0)){i=b;return}c[(c[d>>2]|0)+132>>2]=0;i=b;return}else{c[g>>2]=cN(c[(c[d>>2]|0)+120>>2]|0,c[(c[(c[d>>2]|0)+20>>2]|0)+8>>2]|0,c[e>>2]|0)|0;if((c[g>>2]|0)==1){i=b;return}g=(c[d>>2]|0)+128|0;c[g>>2]=(c[g>>2]|0)+1;i=b;return}}function pM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+20>>2]|0)!=0:0)c[g>>2]=c[(c[(c[e>>2]|0)+20>>2]|0)+296>>2];else c[g>>2]=0;b=c[f>>2]|0;if((c[(c[f>>2]|0)+4>>2]|0)==14){Ph(b);i=d;return}a=c[f>>2]|0;if((c[b+4>>2]|0)==18){Jh(a);i=d;return}if((c[a+4>>2]|0)==2){MM(c[e>>2]|0,c[f>>2]|0);i=d;return}if((c[(c[f>>2]|0)+12>>2]|0)!=0?(c[(c[f>>2]|0)+4>>2]|0)!=5:0){if((c[(c[(c[f>>2]|0)+12>>2]|0)+20>>2]|0)==(c[f>>2]|0))NM(c[e>>2]|0,c[(c[f>>2]|0)+12>>2]|0);c[(c[f>>2]|0)+12>>2]=0}if((c[18774]|0)!=0&(c[33970]|0)!=0)zb[c[135880>>2]&511](c[f>>2]|0);if(!(((c[(c[f>>2]|0)+4>>2]|0)!=1?(c[(c[f>>2]|0)+4>>2]|0)!=19:0)?(c[(c[f>>2]|0)+4>>2]|0)!=20:0))h=21;if((h|0)==21?(c[(c[f>>2]|0)+44>>2]|0)!=0:0)OM(c[e>>2]|0,c[(c[f>>2]|0)+44>>2]|0);do if((((((c[(c[f>>2]|0)+40>>2]|0)!=((c[f>>2]|0)+44|0)?(c[(c[f>>2]|0)+4>>2]|0)!=1:0)?(c[(c[f>>2]|0)+4>>2]|0)!=19:0)?(c[(c[f>>2]|0)+4>>2]|0)!=20:0)?(c[(c[f>>2]|0)+4>>2]|0)!=5:0)?(c[(c[f>>2]|0)+40>>2]|0)!=0:0){if((c[g>>2]|0)!=0?(CP(c[g>>2]|0,c[(c[f>>2]|0)+40>>2]|0)|0)!=0:0)break;zb[c[135736>>2]&511](c[(c[f>>2]|0)+40>>2]|0)}while(0);if(!(((c[(c[f>>2]|0)+4>>2]|0)!=1?(c[(c[f>>2]|0)+4>>2]|0)!=19:0)?(c[(c[f>>2]|0)+4>>2]|0)!=20:0))h=35;if((h|0)==35?(c[(c[f>>2]|0)+48>>2]|0)!=0:0)Lh(c[(c[f>>2]|0)+48>>2]|0);do if(((c[(c[f>>2]|0)+4>>2]|0)!=3?(c[(c[f>>2]|0)+4>>2]|0)!=8:0)?(c[(c[f>>2]|0)+8>>2]|0)!=0:0){if((c[g>>2]|0)!=0?(CP(c[g>>2]|0,c[(c[f>>2]|0)+8>>2]|0)|0)!=0:0)break;zb[c[135736>>2]&511](c[(c[f>>2]|0)+8>>2]|0)}while(0);if((c[(c[f>>2]|0)+4>>2]|0)==1){if(c[e>>2]|0)h=46}else if((c[e>>2]|0)!=0?(c[(c[f>>2]|0)+4>>2]|0)==3:0)h=46;if(((h|0)==46?(c[(c[e>>2]|0)+20>>2]|0)!=0:0)?(c[(c[(c[e>>2]|0)+20>>2]|0)+368>>2]|0)<100:0){c[(c[f>>2]|0)+24>>2]=c[(c[(c[e>>2]|0)+20>>2]|0)+372>>2];c[(c[(c[e>>2]|0)+20>>2]|0)+372>>2]=c[f>>2];h=(c[(c[e>>2]|0)+20>>2]|0)+368|0;c[h>>2]=(c[h>>2]|0)+1;i=d;return}zb[c[135736>>2]&511](c[f>>2]|0);i=d;return}function qM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+12|0;g=d+8|0;h=d+4|0;c[g>>2]=a;c[h>>2]=b;if((c[(c[g>>2]|0)+100>>2]|0)<=0?(c[(c[g>>2]|0)+100>>2]=10,b=Cb[c[135744>>2]&511](c[(c[g>>2]|0)+100>>2]<<2)|0,c[(c[g>>2]|0)+104>>2]=b,(c[(c[g>>2]|0)+104>>2]|0)==0):0){Db[c[135904>>2]&511](c[33980]|0,187648,e);c[f>>2]=0;j=c[f>>2]|0;i=d;return j|0}if((c[(c[g>>2]|0)+96>>2]|0)>=(c[(c[g>>2]|0)+100>>2]|0)?(b=(c[g>>2]|0)+100|0,c[b>>2]=c[b>>2]<<1,b=Hb[c[135760>>2]&511](c[(c[g>>2]|0)+104>>2]|0,c[(c[g>>2]|0)+100>>2]<<2)|0,c[(c[g>>2]|0)+104>>2]=b,(c[(c[g>>2]|0)+104>>2]|0)==0):0){Db[c[135904>>2]&511](c[33980]|0,187672,e);c[f>>2]=0;j=c[f>>2]|0;i=d;return j|0}c[(c[(c[g>>2]|0)+104>>2]|0)+(c[(c[g>>2]|0)+96>>2]<<2)>>2]=c[h>>2];c[(c[g>>2]|0)+92>>2]=c[h>>2];h=(c[g>>2]|0)+96|0;g=c[h>>2]|0;c[h>>2]=g+1;c[f>>2]=g;j=c[f>>2]|0;i=d;return j|0}function rM(a){a=a|0;var b=0,d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+32|0;d=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;j=b;c[d>>2]=a;c[f>>2]=c[(c[d>>2]|0)+64>>2];c[g>>2]=c[(c[d>>2]|0)+64>>2];c[h>>2]=c[(c[d>>2]|0)+20>>2];a:while(1){a=c[g>>2]|0;do if((c[(c[g>>2]|0)+4>>2]|0)==5){if(((c[a+12>>2]|0)==0?(c[c[h>>2]>>2]|0)!=0:0)?(c[(c[c[h>>2]>>2]|0)+20>>2]|0)!=0:0){k=Hb[c[(c[c[h>>2]>>2]|0)+20>>2]&511](c[h>>2]|0,c[(c[g>>2]|0)+8>>2]|0)|0;c[(c[g>>2]|0)+12>>2]=k}if(((c[(c[g>>2]|0)+12>>2]|0)!=0?(c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]|0)==17:0)?(c[(c[(c[g>>2]|0)+12>>2]|0)+12>>2]|0)!=0:0){qM(c[d>>2]|0,c[g>>2]|0)|0;c[g>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+12>>2];break}if((c[g>>2]|0)==(c[f>>2]|0)){l=41;break a}c[g>>2]=c[(c[g>>2]|0)+24>>2];l=18}else{k=c[g>>2]|0;if((c[a+4>>2]|0)==1){c[(c[d>>2]|0)+64>>2]=k;tM(c[d>>2]|0);l=18;break}if((c[k+4>>2]|0)!=3?(c[(c[g>>2]|0)+4>>2]|0)!=4:0){l=18;break}k=c[d>>2]|0;m=c[(c[g>>2]|0)+40>>2]|0;uM(k,m,xy(c[(c[g>>2]|0)+40>>2]|0)|0);l=18}while(0);b:do if((l|0)==18){l=0;a=c[g>>2]|0;if(c[(c[g>>2]|0)+12>>2]|0){c[g>>2]=c[a+12>>2];break}if((c[a+4>>2]|0)==1)oM(c[d>>2]|0);if(c[(c[g>>2]|0)+24>>2]|0){c[g>>2]=c[(c[g>>2]|0)+24>>2];break}while(1){c[g>>2]=c[(c[g>>2]|0)+20>>2];if((c[(c[g>>2]|0)+4>>2]|0)==1){c:do if(!(c[(c[d>>2]|0)+96>>2]|0))while(1){a=c[(c[g>>2]|0)+16>>2]|0;c[j>>2]=a;if(!a)break c;if((e[(c[j>>2]|0)+58>>1]|0)&2)break c;Qh(c[j>>2]|0);pM(c[d>>2]|0,c[j>>2]|0)}while(0);c[(c[d>>2]|0)+64>>2]=c[g>>2];oM(c[d>>2]|0)}if(((c[(c[g>>2]|0)+4>>2]|0)==17?(c[(c[d>>2]|0)+92>>2]|0)!=0:0)?(c[(c[(c[d>>2]|0)+92>>2]|0)+12>>2]|0)==(c[g>>2]|0):0)c[g>>2]=sM(c[d>>2]|0)|0;if((c[g>>2]|0)==(c[f>>2]|0))break b;n=c[g>>2]|0;if(c[(c[g>>2]|0)+24>>2]|0)break;if(!n)break b;if((c[g>>2]|0)==(c[f>>2]|0))break b}c[g>>2]=c[n+24>>2]}while(0);if(!(c[g>>2]|0)){l=41;break}if((c[g>>2]|0)==(c[f>>2]|0)){l=41;break}}if((l|0)==41){c[(c[d>>2]|0)+64>>2]=c[f>>2];i=b;return}}function sM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if((c[(c[e>>2]|0)+96>>2]|0)<=0){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}a=(c[e>>2]|0)+96|0;c[a>>2]=(c[a>>2]|0)+-1;a=c[e>>2]|0;if((c[(c[e>>2]|0)+96>>2]|0)>0)c[(c[e>>2]|0)+92>>2]=c[(c[(c[e>>2]|0)+104>>2]|0)+((c[a+96>>2]|0)-1<<2)>>2];else c[a+92>>2]=0;c[f>>2]=c[(c[(c[e>>2]|0)+104>>2]|0)+(c[(c[e>>2]|0)+96>>2]<<2)>>2];c[(c[(c[e>>2]|0)+104>>2]|0)+(c[(c[e>>2]|0)+96>>2]<<2)>>2]=0;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}function tM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;d=b;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;c[e>>2]=a;c[f>>2]=c[(c[e>>2]|0)+64>>2];do if(((c[(c[e>>2]|0)+8>>2]|0)==1?(c[(c[e>>2]|0)+20>>2]|0)!=0:0)?(c[(c[(c[e>>2]|0)+20>>2]|0)+104>>2]|0)==1:0){if((c[(c[f>>2]|0)+36>>2]|0)!=0?(c[(c[(c[f>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){c[g>>2]=my(c[(c[(c[f>>2]|0)+36>>2]|0)+12>>2]|0)|0;c[g>>2]=By(c[g>>2]|0,187520)|0;c[g>>2]=By(c[g>>2]|0,c[(c[f>>2]|0)+8>>2]|0)|0;a=Ym((c[(c[e>>2]|0)+20>>2]|0)+108|0,c[(c[(c[e>>2]|0)+20>>2]|0)+8>>2]|0,c[f>>2]|0,c[g>>2]|0)|0;j=(c[(c[e>>2]|0)+20>>2]|0)+100|0;c[j>>2]=c[j>>2]&a;if(!(c[g>>2]|0))break;zb[c[135736>>2]&511](c[g>>2]|0);break}a=Ym((c[(c[e>>2]|0)+20>>2]|0)+108|0,c[(c[(c[e>>2]|0)+20>>2]|0)+8>>2]|0,c[f>>2]|0,c[(c[f>>2]|0)+8>>2]|0)|0;j=(c[(c[e>>2]|0)+20>>2]|0)+100|0;c[j>>2]=c[j>>2]&a}while(0);if((c[(c[e>>2]|0)+8>>2]|0)!=2){i=b;return}if(!(c[(c[e>>2]|0)+120>>2]|0)){i=b;return}if(c[(c[e>>2]|0)+132>>2]|0){i=b;return}c[h>>2]=aN(c[(c[e>>2]|0)+120>>2]|0,c[(c[(c[e>>2]|0)+20>>2]|0)+8>>2]|0,c[f>>2]|0)|0;do if(!(c[h>>2]|0)){c[f>>2]=RL(c[e>>2]|0)|0;if(!(c[f>>2]|0)){Wa(187736,d|0)|0;c[h>>2]=-1;break}else{c[h>>2]=dN(c[(c[e>>2]|0)+120>>2]|0,c[(c[(c[e>>2]|0)+20>>2]|0)+8>>2]|0,c[f>>2]|0)|0;c[(c[e>>2]|0)+132>>2]=c[f>>2];break}}while(0);if((c[h>>2]|0)==1){i=b;return}h=(c[e>>2]|0)+128|0;c[h>>2]=(c[h>>2]|0)+1;i=b;return}function uM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if(((c[(c[f>>2]|0)+8>>2]|0)==1?(c[(c[f>>2]|0)+20>>2]|0)!=0:0)?(c[(c[(c[f>>2]|0)+20>>2]|0)+104>>2]|0)==1:0){d=Zm((c[(c[f>>2]|0)+20>>2]|0)+108|0,c[g>>2]|0,c[h>>2]|0)|0;b=(c[(c[f>>2]|0)+20>>2]|0)+100|0;c[b>>2]=c[b>>2]&d}if((c[(c[f>>2]|0)+8>>2]|0)!=2){i=e;return}if(!(c[(c[f>>2]|0)+120>>2]|0)){i=e;return}if(c[(c[f>>2]|0)+132>>2]|0){i=e;return}c[j>>2]=bN(c[(c[f>>2]|0)+120>>2]|0,c[g>>2]|0,c[h>>2]|0)|0;if((c[j>>2]|0)==1){i=e;return}j=(c[f>>2]|0)+128|0;c[j>>2]=(c[j>>2]|0)+1;i=e;return}function vM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;do if(((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+64>>2]|0)!=0:0)?(c[(c[e>>2]|0)+20>>2]|0)!=0:0){while(1){if((c[(c[(c[e>>2]|0)+20>>2]|0)+172>>2]|0)==-1){g=6;break}if(PM(c[(c[e>>2]|0)+64>>2]|0)|0){g=8;break}if((c[(c[(c[e>>2]|0)+20>>2]|0)+56>>2]|0)<(c[(c[e>>2]|0)+72>>2]|0)){g=10;break}if((c[c[e>>2]>>2]|0)==3){g=12;break}c[f>>2]=nM(c[e>>2]|0)|0;h=c[e>>2]|0;if((c[f>>2]|0)<0){g=14;break}if((c[h>>2]|0)==3){g=16;break}}if((g|0)==6){c[d>>2]=1;break}else if((g|0)==8){c[d>>2]=1;break}else if((g|0)==10){c[d>>2]=1;break}else if((g|0)==12){c[d>>2]=1;break}else if((g|0)==14){c[h>>2]=2;c[d>>2]=-1;break}else if((g|0)==16){c[d>>2]=1;break}}else g=4;while(0);if((g|0)==4)c[d>>2]=-1;i=b;return c[d>>2]|0}function wM(a,e,f){a=a|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+32|0;h=g+16|0;j=g+12|0;k=g+8|0;l=g+4|0;m=g;c[h>>2]=a;c[j>>2]=e;c[k>>2]=f;c[l>>2]=c[h>>2];c[m>>2]=c[(c[l>>2]|0)+272>>2];if(((((((c[m>>2]|0)!=0?(c[(c[m>>2]|0)+32>>2]|0)!=0:0)?(Db[c[(c[m>>2]|0)+32>>2]&511](c[h>>2]|0,c[j>>2]|0,c[k>>2]|0),(c[(c[l>>2]|0)+52>>2]|0)!=0):0)?(c[(c[l>>2]|0)+36>>2]|0)!=0:0)?(c[(c[(c[l>>2]|0)+36>>2]|0)+16>>2]|0)!=0:0)?(d[c[(c[(c[l>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==47:0)?(d[(c[(c[(c[l>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==62:0)b[(c[(c[l>>2]|0)+52>>2]|0)+58>>1]=1;if(!(c[m>>2]|0)){i=g;return}c[(c[m>>2]|0)+16>>2]=1;i=g;return}function xM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=c[e>>2];c[h>>2]=c[(c[g>>2]|0)+272>>2];if(!(c[h>>2]|0)){i=d;return}if(!(c[(c[h>>2]|0)+36>>2]|0)){i=d;return}Ab[c[(c[h>>2]|0)+36>>2]&511](c[e>>2]|0,c[f>>2]|0);i=d;return}function yM(a,e,f,g,h,j,k,l,m){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;n=i;i=i+48|0;o=n+40|0;p=n+36|0;q=n+32|0;r=n+28|0;s=n+24|0;t=n+20|0;u=n+16|0;v=n+12|0;w=n+8|0;x=n+4|0;y=n;c[o>>2]=a;c[p>>2]=e;c[q>>2]=f;c[r>>2]=g;c[s>>2]=h;c[t>>2]=j;c[u>>2]=k;c[v>>2]=l;c[w>>2]=m;c[x>>2]=c[o>>2];c[y>>2]=c[(c[x>>2]|0)+272>>2];if(((((((c[y>>2]|0)!=0?(c[(c[y>>2]|0)+40>>2]|0)!=0:0)?(Eb[c[(c[y>>2]|0)+40>>2]&511](c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[v>>2]|0,c[w>>2]|0),(c[(c[x>>2]|0)+52>>2]|0)!=0):0)?(c[(c[x>>2]|0)+36>>2]|0)!=0:0)?(c[(c[(c[x>>2]|0)+36>>2]|0)+16>>2]|0)!=0:0)?(d[c[(c[(c[x>>2]|0)+36>>2]|0)+16>>2]>>0]|0|0)==47:0)?(d[(c[(c[(c[x>>2]|0)+36>>2]|0)+16>>2]|0)+1>>0]|0|0)==62:0)b[(c[(c[x>>2]|0)+52>>2]|0)+58>>1]=1;if(!(c[y>>2]|0)){i=n;return}c[(c[y>>2]|0)+16>>2]=1;i=n;return}function zM(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=c[g>>2];c[m>>2]=c[(c[l>>2]|0)+272>>2];if(!(c[m>>2]|0)){i=f;return}if(!(c[(c[m>>2]|0)+44>>2]|0)){i=f;return}Jb[c[(c[m>>2]|0)+44>>2]&511](c[g>>2]|0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0);i=f;return}function AM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=c[f>>2];c[k>>2]=c[(c[j>>2]|0)+272>>2];if(!(c[k>>2]|0)){i=e;return}if(!(c[(c[k>>2]|0)+48>>2]|0)){i=e;return}Db[c[(c[k>>2]|0)+48>>2]&511](c[f>>2]|0,c[g>>2]|0,c[h>>2]|0);i=e;return}function BM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=c[f>>2];c[k>>2]=c[(c[j>>2]|0)+272>>2];if(!(c[k>>2]|0)){i=e;return}if(!(c[(c[k>>2]|0)+52>>2]|0)){i=e;return}Db[c[(c[k>>2]|0)+52>>2]&511](c[f>>2]|0,c[g>>2]|0,c[h>>2]|0);i=e;return}function CM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;if(!(c[f>>2]|0)){i=d;return}if((c[18774]|0)!=0&(c[33970]|0)!=0)zb[c[135880>>2]&511](c[f>>2]|0);if(c[(c[f>>2]|0)+64>>2]|0)QM(c[(c[f>>2]|0)+64>>2]|0);c[(c[f>>2]|0)+64>>2]=0;if(c[(c[f>>2]|0)+68>>2]|0)Jm(c[(c[f>>2]|0)+68>>2]|0);c[(c[f>>2]|0)+68>>2]=0;c[g>>2]=c[(c[f>>2]|0)+48>>2];c[h>>2]=c[(c[f>>2]|0)+44>>2];if((c[h>>2]|0)==(c[g>>2]|0))c[g>>2]=0;if(c[g>>2]|0){Qh(c[(c[f>>2]|0)+48>>2]|0);c[(c[f>>2]|0)+48>>2]=0;Ph(c[g>>2]|0)}if(c[h>>2]|0){Qh(c[(c[f>>2]|0)+44>>2]|0);c[(c[f>>2]|0)+44>>2]=0;Ph(c[h>>2]|0)}if(c[(c[f>>2]|0)+12>>2]|0)NM(c[e>>2]|0,c[(c[f>>2]|0)+12>>2]|0);if(c[(c[f>>2]|0)+56>>2]|0)zb[c[135736>>2]&511](c[(c[f>>2]|0)+56>>2]|0);if(c[(c[f>>2]|0)+8>>2]|0)zb[c[135736>>2]&511](c[(c[f>>2]|0)+8>>2]|0);if(c[(c[f>>2]|0)+60>>2]|0)zb[c[135736>>2]&511](c[(c[f>>2]|0)+60>>2]|0);if(c[(c[f>>2]|0)+52>>2]|0)Lh(c[(c[f>>2]|0)+52>>2]|0);if(c[(c[f>>2]|0)+72>>2]|0)zb[c[135736>>2]&511](c[(c[f>>2]|0)+72>>2]|0);if(c[(c[f>>2]|0)+80>>2]|0)zP(c[(c[f>>2]|0)+80>>2]|0);zb[c[135736>>2]&511](c[f>>2]|0);i=d;return}function DM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+48|0;f=e;g=e+36|0;h=e+32|0;j=e+28|0;k=e+24|0;l=e+8|0;c[g>>2]=a;c[h>>2]=b;c[j>>2]=c[g>>2];c[l>>2]=d;c[k>>2]=RM(c[h>>2]|0,l)|0;if(c[(c[j>>2]|0)+108>>2]|0)Jb[c[(c[j>>2]|0)+108>>2]&511](c[(c[j>>2]|0)+112>>2]|0,c[k>>2]|0,2,0);else{j=c[g>>2]|0;c[f>>2]=c[k>>2];JM(j,187728,f)}if(!(c[k>>2]|0)){i=e;return}zb[c[135736>>2]&511](c[k>>2]|0);i=e;return}function EM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+48|0;f=e;g=e+36|0;h=e+32|0;j=e+28|0;k=e+24|0;l=e+8|0;c[g>>2]=a;c[h>>2]=b;c[j>>2]=c[g>>2];c[l>>2]=d;c[k>>2]=RM(c[h>>2]|0,l)|0;if(c[(c[j>>2]|0)+108>>2]|0)Jb[c[(c[j>>2]|0)+108>>2]&511](c[(c[j>>2]|0)+112>>2]|0,c[k>>2]|0,1,0);else{j=c[g>>2]|0;c[f>>2]=c[k>>2];KM(j,187728,f)}if(!(c[k>>2]|0)){i=e;return}zb[c[135736>>2]&511](c[k>>2]|0);i=e;return}function FM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=c[e>>2];e=c[g>>2]|0;if(c[(c[g>>2]|0)+192>>2]|0){Ab[c[e+192>>2]&511](c[(c[g>>2]|0)+112>>2]|0,c[f>>2]|0);i=d;return}else{LM(e,c[f>>2]|0);i=d;return}}function GM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;n=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if((c[g>>2]|0)!=0?!((c[h>>2]|0)==0&(c[j>>2]|0)==0):0){if(c[h>>2]|0)c[c[h>>2]>>2]=0;if(c[j>>2]|0)c[c[j>>2]>>2]=0;c[k>>2]=c[g>>2];if((c[(c[k>>2]|0)+20>>2]|0)!=0?(c[(c[(c[k>>2]|0)+20>>2]|0)+36>>2]|0)!=0:0){if(c[h>>2]|0)c[c[h>>2]>>2]=c[(c[(c[(c[k>>2]|0)+20>>2]|0)+36>>2]|0)+4>>2];if(c[j>>2]|0)c[c[j>>2]>>2]=c[(c[(c[(c[k>>2]|0)+20>>2]|0)+36>>2]|0)+28>>2];c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}if(!(c[(c[k>>2]|0)+64>>2]|0)){c[f>>2]=-1;o=c[f>>2]|0;i=e;return o|0}c[m>>2]=0;do if(c[j>>2]|0){c[l>>2]=Ni(c[(c[k>>2]|0)+64>>2]|0)|0;if((c[l>>2]|0)>0){c[c[j>>2]>>2]=c[l>>2];break}else{c[m>>2]=-1;break}}while(0);do if(c[h>>2]|0){c[n>>2]=c[(c[(c[k>>2]|0)+64>>2]|0)+32>>2];if((c[n>>2]|0)!=0?(c[(c[n>>2]|0)+72>>2]|0)!=0:0){c[c[h>>2]>>2]=c[(c[n>>2]|0)+72>>2];break}c[m>>2]=-1}while(0);c[f>>2]=c[m>>2];o=c[f>>2]|0;i=e;return o|0}c[f>>2]=-1;o=c[f>>2]|0;i=e;return o|0}function HM(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[f+4>>2]=e;if(!(c[h>>2]|0)){c[g>>2]=-1;m=c[g>>2]|0;i=f;return m|0}if((c[j>>2]|0)!=0&(c[k>>2]|0)!=0){c[g>>2]=-1;m=c[g>>2]|0;i=f;return m|0}do if((c[j>>2]|0)!=0|(c[k>>2]|0)!=0){if((c[c[h>>2]>>2]|0)==0?(c[(c[h>>2]|0)+20>>2]|0)!=0:0)break;c[g>>2]=-1;m=c[g>>2]|0;i=f;return m|0}while(0);if(c[(c[h>>2]|0)+152>>2]|0){jB(c[(c[h>>2]|0)+152>>2]|0)|0;c[(c[h>>2]|0)+152>>2]=0}if(c[(c[h>>2]|0)+140>>2]|0){if(!(c[(c[h>>2]|0)+144>>2]|0))ZA(c[(c[h>>2]|0)+140>>2]|0);c[(c[h>>2]|0)+140>>2]=0}c[(c[h>>2]|0)+144>>2]=0;if(c[(c[h>>2]|0)+136>>2]|0){WA(c[(c[h>>2]|0)+136>>2]|0);c[(c[h>>2]|0)+136>>2]=0}if((c[j>>2]|0)==0&(c[k>>2]|0)==0){c[g>>2]=0;m=c[g>>2]|0;i=f;return m|0}if(c[j>>2]|0){c[l>>2]=XA(c[j>>2]|0)|0;if(c[(c[h>>2]|0)+108>>2]|0)aB(c[l>>2]|0,367,368,c[h>>2]|0);j=$A(c[l>>2]|0)|0;c[(c[h>>2]|0)+136>>2]=j;YA(c[l>>2]|0);if(!(c[(c[h>>2]|0)+136>>2]|0)){c[g>>2]=-1;m=c[g>>2]|0;i=f;return m|0}l=eB(c[(c[h>>2]|0)+136>>2]|0)|0;c[(c[h>>2]|0)+140>>2]=l;l=c[h>>2]|0;if(!(c[(c[h>>2]|0)+140>>2]|0)){WA(c[l+136>>2]|0);c[(c[h>>2]|0)+136>>2]=0;c[g>>2]=-1;m=c[g>>2]|0;i=f;return m|0}j=iB(c[l+140>>2]|0,c[(c[h>>2]|0)+20>>2]|0,(c[(c[h>>2]|0)+20>>2]|0)+4|0)|0;c[(c[h>>2]|0)+152>>2]=j;if(!(c[(c[h>>2]|0)+152>>2]|0)){WA(c[(c[h>>2]|0)+136>>2]|0);c[(c[h>>2]|0)+136>>2]=0;ZA(c[(c[h>>2]|0)+140>>2]|0);c[(c[h>>2]|0)+140>>2]=0;c[g>>2]=-1;m=c[g>>2]|0;i=f;return m|0}}else{c[(c[h>>2]|0)+140>>2]=c[k>>2];c[(c[h>>2]|0)+144>>2]=1;k=iB(c[(c[h>>2]|0)+140>>2]|0,c[(c[h>>2]|0)+20>>2]|0,(c[(c[h>>2]|0)+20>>2]|0)+4|0)|0;c[(c[h>>2]|0)+152>>2]=k;if(!(c[(c[h>>2]|0)+152>>2]|0)){c[(c[h>>2]|0)+140>>2]=0;c[(c[h>>2]|0)+144>>2]=0;c[g>>2]=-1;m=c[g>>2]|0;i=f;return m|0}}kB(c[(c[h>>2]|0)+140>>2]|0,369,c[h>>2]|0);if(c[(c[h>>2]|0)+108>>2]|0)bB(c[(c[h>>2]|0)+140>>2]|0,367,368,c[h>>2]|0);if(c[(c[h>>2]|0)+192>>2]|0)dB(c[(c[h>>2]|0)+140>>2]|0,370,c[h>>2]|0);c[(c[h>>2]|0)+148>>2]=0;c[(c[h>>2]|0)+8>>2]=4;c[g>>2]=0;m=c[g>>2]|0;i=f;return m|0}function IM(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[f+4>>2]=e;if(!(c[h>>2]|0)){c[g>>2]=-1;m=c[g>>2]|0;i=f;return m|0}if((c[j>>2]|0)!=0&(c[k>>2]|0)!=0){c[g>>2]=-1;m=c[g>>2]|0;i=f;return m|0}do if((c[j>>2]|0)!=0|(c[k>>2]|0)!=0){if((c[c[h>>2]>>2]|0)==0?(c[(c[h>>2]|0)+20>>2]|0)!=0:0)break;c[g>>2]=-1;m=c[g>>2]|0;i=f;return m|0}while(0);if(c[(c[h>>2]|0)+120>>2]|0){if(!(c[(c[h>>2]|0)+124>>2]|0))fN(c[(c[h>>2]|0)+120>>2]|0);c[(c[h>>2]|0)+120>>2]=0}c[(c[h>>2]|0)+124>>2]=0;if(c[(c[h>>2]|0)+116>>2]|0){VM(c[(c[h>>2]|0)+116>>2]|0);c[(c[h>>2]|0)+116>>2]=0}if((c[j>>2]|0)==0&(c[k>>2]|0)==0){c[g>>2]=0;m=c[g>>2]|0;i=f;return m|0}if(c[j>>2]|0){c[l>>2]=YM(c[j>>2]|0)|0;if(c[(c[h>>2]|0)+108>>2]|0)$M(c[l>>2]|0,367,368,c[h>>2]|0);if(c[(c[h>>2]|0)+192>>2]|0)hN(c[(c[h>>2]|0)+120>>2]|0,370,c[h>>2]|0);j=_M(c[l>>2]|0)|0;c[(c[h>>2]|0)+116>>2]=j;ZM(c[l>>2]|0);if(!(c[(c[h>>2]|0)+116>>2]|0)){c[g>>2]=-1;m=c[g>>2]|0;i=f;return m|0}l=eN(c[(c[h>>2]|0)+116>>2]|0)|0;c[(c[h>>2]|0)+120>>2]=l;if(!(c[(c[h>>2]|0)+120>>2]|0)){VM(c[(c[h>>2]|0)+116>>2]|0);c[(c[h>>2]|0)+116>>2]=0;c[g>>2]=-1;m=c[g>>2]|0;i=f;return m|0}}else{c[(c[h>>2]|0)+120>>2]=c[k>>2];c[(c[h>>2]|0)+124>>2]=1}if(c[(c[h>>2]|0)+108>>2]|0)gN(c[(c[h>>2]|0)+120>>2]|0,367,368,c[h>>2]|0);if(c[(c[h>>2]|0)+192>>2]|0)hN(c[(c[h>>2]|0)+120>>2]|0,370,c[h>>2]|0);c[(c[h>>2]|0)+128>>2]=0;c[(c[h>>2]|0)+132>>2]=0;c[(c[h>>2]|0)+8>>2]=2;c[g>>2]=0;m=c[g>>2]|0;i=f;return m|0}function JM(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+32|0;g=f+28|0;h=f+24|0;j=f+8|0;k=f;c[g>>2]=b;c[h>>2]=d;c[k>>2]=xy(c[h>>2]|0)|0;if((c[k>>2]|0)<=1){i=f;return}if((a[(c[h>>2]|0)+((c[k>>2]|0)-2)>>0]|0)==58){i=f;return}c[j>>2]=e;e=c[g>>2]|0;SM(e,2,RM(c[h>>2]|0,j)|0);i=f;return}function KM(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+32|0;g=f+28|0;h=f+24|0;j=f+8|0;k=f;c[g>>2]=b;c[h>>2]=d;c[k>>2]=xy(c[h>>2]|0)|0;if(!(c[k>>2]|0)){i=f;return}if((a[(c[h>>2]|0)+((c[k>>2]|0)-1)>>0]|0)==58){i=f;return}c[j>>2]=e;e=c[g>>2]|0;SM(e,1,RM(c[h>>2]|0,j)|0);i=f;return}function LM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=c[e>>2];c[h>>2]=c[(c[g>>2]|0)+272>>2];if(!(c[f>>2]|0)){i=d;return}if(!(c[(c[h>>2]|0)+192>>2]|0)){i=d;return}Ab[c[(c[h>>2]|0)+192>>2]&511](c[(c[h>>2]|0)+112>>2]|0,c[f>>2]|0);i=d;return}function MM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+20>>2]|0)!=0:0)c[g>>2]=c[(c[(c[e>>2]|0)+20>>2]|0)+296>>2];else c[g>>2]=0;if(!(c[f>>2]|0)){i=d;return}if((c[18774]|0)!=0&(c[33970]|0)!=0)zb[c[135880>>2]&511](c[f>>2]|0);do if((c[(c[f>>2]|0)+20>>2]|0)!=0?(c[(c[(c[f>>2]|0)+20>>2]|0)+32>>2]|0)!=0:0){if((c[(c[(c[(c[f>>2]|0)+20>>2]|0)+32>>2]|0)+44>>2]|0)==0?(c[(c[(c[(c[f>>2]|0)+20>>2]|0)+32>>2]|0)+48>>2]|0)==0:0)break;if(Em(c[(c[(c[f>>2]|0)+20>>2]|0)+32>>2]|0,c[(c[f>>2]|0)+20>>2]|0,c[f>>2]|0)|0)TM(c[(c[(c[f>>2]|0)+20>>2]|0)+32>>2]|0,c[f>>2]|0)|0;
}while(0);if(c[(c[f>>2]|0)+12>>2]|0)NM(c[e>>2]|0,c[(c[f>>2]|0)+12>>2]|0);do if(c[(c[f>>2]|0)+8>>2]|0){if((c[g>>2]|0)!=0?(CP(c[g>>2]|0,c[(c[f>>2]|0)+8>>2]|0)|0)!=0:0)break;zb[c[135736>>2]&511](c[(c[f>>2]|0)+8>>2]|0)}while(0);if(((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+20>>2]|0)!=0:0)?(c[(c[(c[e>>2]|0)+20>>2]|0)+376>>2]|0)<100:0){c[(c[f>>2]|0)+24>>2]=c[(c[(c[e>>2]|0)+20>>2]|0)+380>>2];c[(c[(c[e>>2]|0)+20>>2]|0)+380>>2]=c[f>>2];g=(c[(c[e>>2]|0)+20>>2]|0)+376|0;c[g>>2]=(c[g>>2]|0)+1;i=d;return}zb[c[135736>>2]&511](c[f>>2]|0);i=d;return}function NM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+20>>2]|0)!=0:0)c[h>>2]=c[(c[(c[e>>2]|0)+20>>2]|0)+296>>2];else c[h>>2]=0;if(!(c[f>>2]|0)){i=d;return}b=c[f>>2]|0;if((c[(c[f>>2]|0)+4>>2]|0)==18){Lh(b);i=d;return}if((c[b+4>>2]|0)!=9?(c[(c[f>>2]|0)+4>>2]|0)!=13:0){while(1){if(!(c[f>>2]|0))break;c[g>>2]=c[(c[f>>2]|0)+24>>2];do if((c[(c[f>>2]|0)+4>>2]|0)!=14){if((c[(c[f>>2]|0)+12>>2]|0)!=0?(c[(c[f>>2]|0)+4>>2]|0)!=5:0){if((c[(c[(c[f>>2]|0)+12>>2]|0)+20>>2]|0)==(c[f>>2]|0))NM(c[e>>2]|0,c[(c[f>>2]|0)+12>>2]|0);c[(c[f>>2]|0)+12>>2]=0}if((c[18774]|0)!=0&(c[33970]|0)!=0)zb[c[135880>>2]&511](c[f>>2]|0);if(!(((c[(c[f>>2]|0)+4>>2]|0)!=1?(c[(c[f>>2]|0)+4>>2]|0)!=19:0)?(c[(c[f>>2]|0)+4>>2]|0)!=20:0))j=23;if((j|0)==23?(j=0,(c[(c[f>>2]|0)+44>>2]|0)!=0):0)OM(c[e>>2]|0,c[(c[f>>2]|0)+44>>2]|0);do if((((((c[(c[f>>2]|0)+40>>2]|0)!=((c[f>>2]|0)+44|0)?(c[(c[f>>2]|0)+4>>2]|0)!=1:0)?(c[(c[f>>2]|0)+4>>2]|0)!=19:0)?(c[(c[f>>2]|0)+4>>2]|0)!=20:0)?(c[(c[f>>2]|0)+4>>2]|0)!=5:0)?(c[(c[f>>2]|0)+40>>2]|0)!=0:0){if((c[h>>2]|0)!=0?(CP(c[h>>2]|0,c[(c[f>>2]|0)+40>>2]|0)|0)!=0:0)break;zb[c[135736>>2]&511](c[(c[f>>2]|0)+40>>2]|0)}while(0);if(!(((c[(c[f>>2]|0)+4>>2]|0)!=1?(c[(c[f>>2]|0)+4>>2]|0)!=19:0)?(c[(c[f>>2]|0)+4>>2]|0)!=20:0))j=37;if((j|0)==37?(j=0,(c[(c[f>>2]|0)+48>>2]|0)!=0):0)Lh(c[(c[f>>2]|0)+48>>2]|0);do if(((c[(c[f>>2]|0)+4>>2]|0)!=3?(c[(c[f>>2]|0)+4>>2]|0)!=8:0)?(c[(c[f>>2]|0)+8>>2]|0)!=0:0){if((c[h>>2]|0)!=0?(CP(c[h>>2]|0,c[(c[f>>2]|0)+8>>2]|0)|0)!=0:0)break;zb[c[135736>>2]&511](c[(c[f>>2]|0)+8>>2]|0)}while(0);if((c[(c[f>>2]|0)+4>>2]|0)==1){if(c[e>>2]|0)j=48}else if((c[e>>2]|0)!=0?(c[(c[f>>2]|0)+4>>2]|0)==3:0)j=48;if(((j|0)==48?(j=0,(c[(c[e>>2]|0)+20>>2]|0)!=0):0)?(c[(c[(c[e>>2]|0)+20>>2]|0)+368>>2]|0)<100:0){c[(c[f>>2]|0)+24>>2]=c[(c[(c[e>>2]|0)+20>>2]|0)+372>>2];c[(c[(c[e>>2]|0)+20>>2]|0)+372>>2]=c[f>>2];b=(c[(c[e>>2]|0)+20>>2]|0)+368|0;c[b>>2]=(c[b>>2]|0)+1;break}zb[c[135736>>2]&511](c[f>>2]|0)}while(0);c[f>>2]=c[g>>2]}i=d;return}Th(c[f>>2]|0);i=d;return}function OM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;while(1){if(!(c[f>>2]|0))break;c[g>>2]=c[(c[f>>2]|0)+24>>2];MM(c[e>>2]|0,c[f>>2]|0);c[f>>2]=c[g>>2]}i=d;return}function PM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;do if(c[e>>2]|0){if(c[(c[e>>2]|0)+24>>2]|0){c[d>>2]=c[(c[e>>2]|0)+24>>2];break}while(1){c[e>>2]=c[(c[e>>2]|0)+20>>2];if(!(c[e>>2]|0)){f=9;break}g=c[e>>2]|0;if(c[(c[e>>2]|0)+24>>2]|0){f=7;break}if(!g){f=9;break}}if((f|0)==7){c[d>>2]=c[g+24>>2];break}else if((f|0)==9){c[d>>2]=c[e>>2];break}}else c[d>>2]=0;while(0);i=b;return c[d>>2]|0}function QM(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;Kj(c[d>>2]|0,371);i=b;return}function RM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+48|0;g=d+44|0;h=d+40|0;j=d+36|0;k=d+32|0;l=d+28|0;m=d+24|0;n=d+8|0;c[g>>2]=a;c[h>>2]=b;c[j>>2]=0;c[m>>2]=0;while(1){c[n>>2]=c[c[h>>2]>>2];c[k>>2]=LT(c[m>>2]|0,c[j>>2]|0,c[g>>2]|0,n)|0;if((c[k>>2]|0)<0){o=3;break}if((c[j>>2]|0)==64e3?1:(c[k>>2]|0)<(c[j>>2]|0)){o=15;break}if((c[k>>2]|0)<64e3)c[j>>2]=(c[k>>2]|0)+1;else c[j>>2]=64e3;b=Hb[c[135760>>2]&511](c[m>>2]|0,c[j>>2]|0)|0;c[l>>2]=b;if(!b){o=11;break}c[m>>2]=c[l>>2]}if((o|0)==3){Db[c[135904>>2]&511](c[33980]|0,187704,e);if(c[m>>2]|0)zb[c[135736>>2]&511](c[m>>2]|0);c[f>>2]=0;p=c[f>>2]|0;i=d;return p|0}else if((o|0)==11){Db[c[135904>>2]&511](c[33980]|0,187672,e);if(c[m>>2]|0)zb[c[135736>>2]&511](c[m>>2]|0);c[f>>2]=0;p=c[f>>2]|0;i=d;return p|0}else if((o|0)==15){c[f>>2]=c[m>>2];p=c[f>>2]|0;i=d;return p|0}return 0}function SM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=c[f>>2];c[k>>2]=c[(c[j>>2]|0)+272>>2];if(!(c[h>>2]|0)){i=e;return}if(c[(c[k>>2]|0)+108>>2]|0)Jb[c[(c[k>>2]|0)+108>>2]&511](c[(c[k>>2]|0)+112>>2]|0,c[h>>2]|0,c[g>>2]|0,c[j>>2]|0);zb[c[135736>>2]&511](c[h>>2]|0);i=e;return}function TM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;do if(!(c[f>>2]|0))c[e>>2]=-1;else{if(!(c[g>>2]|0)){c[e>>2]=-1;break}c[h>>2]=c[(c[f>>2]|0)+64>>2];if(!(c[h>>2]|0)){c[e>>2]=-1;break}c[k>>2]=_h(c[f>>2]|0,c[(c[g>>2]|0)+12>>2]|0,1)|0;if(!(c[k>>2]|0)){c[e>>2]=-1;break}c[j>>2]=Rj(c[h>>2]|0,c[k>>2]|0)|0;zb[c[135736>>2]&511](c[k>>2]|0);if((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+8>>2]|0)==(c[g>>2]|0):0){c[(c[j>>2]|0)+12>>2]=c[(c[g>>2]|0)+8>>2];c[(c[j>>2]|0)+8>>2]=0;c[e>>2]=0;break}c[e>>2]=-1}while(0);i=d;return c[e>>2]|0}function UM(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=0;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+20>>2]|0)c[e>>2]=c[(c[(c[d>>2]|0)+20>>2]|0)+80>>2];do if((c[(c[d>>2]|0)+4>>2]|0)!=0?(c[(c[d>>2]|0)+4>>2]|0)!=0:0){if((c[e>>2]|0)!=0?(CP(c[e>>2]|0,c[(c[d>>2]|0)+4>>2]|0)|0)!=0:0)break;zb[c[135736>>2]&511](c[(c[d>>2]|0)+4>>2]|0)}while(0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function VM(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+4>>2]|0)jN(c[(c[d>>2]|0)+4>>2]|0);if(c[(c[d>>2]|0)+8>>2]|0)Th(c[(c[d>>2]|0)+8>>2]|0);if(c[(c[d>>2]|0)+24>>2]|0)kN(c[(c[d>>2]|0)+24>>2]|0);if(c[(c[d>>2]|0)+28>>2]|0)lN(c[(c[d>>2]|0)+28>>2]|0);if(c[(c[d>>2]|0)+36>>2]|0){c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[(c[d>>2]|0)+32>>2]|0))break;mN(c[(c[(c[d>>2]|0)+36>>2]|0)+(c[e>>2]<<2)>>2]|0);c[e>>2]=(c[e>>2]|0)+1}zb[c[135736>>2]&511](c[(c[d>>2]|0)+36>>2]|0)}zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function WM(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;if(c[46940]|0){c[b>>2]=0;d=c[b>>2]|0;i=a;return d|0}c[46942]=Ij(10)|0;if(!(c[46942]|0)){Db[c[135904>>2]&511](c[33980]|0,187776,a);c[b>>2]=-1;d=c[b>>2]|0;i=a;return d|0}else{sN(187824,0,372,373,374,375,376)|0;sN(c[46968]|0,0,377,378,379,0,0)|0;c[46940]=1;c[b>>2]=0;d=c[b>>2]|0;i=a;return d|0}return 0}function XM(){var a=0;a=i;GH();if(!(c[46940]|0)){i=a;return}Kj(c[46942]|0,380);c[46940]=0;i=a;return}function YM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if(!(c[e>>2]|0)){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}c[f>>2]=Cb[c[135744>>2]&511](148)|0;if(!(c[f>>2]|0)){xN(0,187880);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{cU(c[f>>2]|0,0,148)|0;a=my(c[e>>2]|0)|0;c[(c[f>>2]|0)+68>>2]=a;c[(c[f>>2]|0)+4>>2]=c[33976];c[c[f>>2]>>2]=c[33980];c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function ZM(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+68>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+68>>2]|0);if(c[(c[d>>2]|0)+96>>2]|0)yN(c[(c[d>>2]|0)+96>>2]|0);if(c[(c[d>>2]|0)+56>>2]|0)Kj(c[(c[d>>2]|0)+56>>2]|0,0);if(c[(c[d>>2]|0)+60>>2]|0)kN(c[(c[d>>2]|0)+60>>2]|0);if(c[(c[d>>2]|0)+64>>2]|0)lN(c[(c[d>>2]|0)+64>>2]|0);if(c[(c[d>>2]|0)+108>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+108>>2]|0);if(c[(c[d>>2]|0)+124>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+124>>2]|0);if(c[(c[d>>2]|0)+84>>2]|0){c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[(c[d>>2]|0)+76>>2]|0))break;mN(c[(c[(c[d>>2]|0)+84>>2]|0)+(c[e>>2]<<2)>>2]|0);c[e>>2]=(c[e>>2]|0)+1}zb[c[135736>>2]&511](c[(c[d>>2]|0)+84>>2]|0)}if((c[(c[d>>2]|0)+72>>2]|0)!=0?(c[(c[d>>2]|0)+144>>2]|0)!=0:0)Th(c[(c[d>>2]|0)+72>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function _M(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+32|0;d=b+20|0;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;j=b;c[e>>2]=a;c[f>>2]=0;WM()|0;if(!(c[e>>2]|0)){c[d>>2]=0;k=c[d>>2]|0;i=b;return k|0}a=c[e>>2]|0;do if(c[(c[e>>2]|0)+68>>2]|0){c[g>>2]=gg(c[a+68>>2]|0,0,0)|0;if(!(c[g>>2]|0)){zN(c[e>>2]|0,0,1065,187904,c[(c[e>>2]|0)+68>>2]|0,0);c[d>>2]=0;k=c[d>>2]|0;i=b;return k|0}}else{l=c[e>>2]|0;if(c[a+88>>2]|0){c[g>>2]=hg(c[l+88>>2]|0,c[(c[e>>2]|0)+92>>2]|0,0,0,0)|0;if(c[g>>2]|0){m=my(187992)|0;c[(c[g>>2]|0)+72>>2]=m;m=my(187992)|0;c[(c[e>>2]|0)+68>>2]=m;break}zN(c[e>>2]|0,0,1065,187944,0,0);c[d>>2]=0;k=c[d>>2]|0;i=b;return k|0}else{m=c[e>>2]|0;if(c[l+72>>2]|0){c[g>>2]=c[m+72>>2];break}zN(m,0,1022,188016,0,0);c[d>>2]=0;k=c[d>>2]|0;i=b;return k|0}}while(0);c[(c[e>>2]|0)+72>>2]=c[g>>2];c[g>>2]=AN(c[e>>2]|0,c[g>>2]|0)|0;if(!(c[g>>2]|0)){Th(c[(c[e>>2]|0)+72>>2]|0);c[(c[e>>2]|0)+72>>2]=0;c[d>>2]=0;k=c[d>>2]|0;i=b;return k|0}c[h>>2]=Pi(c[g>>2]|0)|0;a=c[e>>2]|0;if(!(c[h>>2]|0)){if(c[(c[e>>2]|0)+68>>2]|0)n=c[(c[e>>2]|0)+68>>2]|0;else n=188088;zN(a,c[g>>2]|0,1022,188056,n,0);Th(c[(c[e>>2]|0)+72>>2]|0);c[(c[e>>2]|0)+72>>2]=0;c[d>>2]=0;k=c[d>>2]|0;i=b;return k|0}c[f>>2]=BN(a,c[h>>2]|0)|0;h=c[e>>2]|0;if(!(c[f>>2]|0)){Th(c[h+72>>2]|0);c[(c[e>>2]|0)+72>>2]=0;c[d>>2]=0;k=c[d>>2]|0;i=b;return k|0}if(c[h+56>>2]|0)Wj(c[(c[e>>2]|0)+56>>2]|0,381,c[e>>2]|0);h=c[f>>2]|0;if((c[(c[e>>2]|0)+36>>2]|0)>0){VM(h);c[(c[e>>2]|0)+72>>2]=0;Th(c[g>>2]|0);c[d>>2]=0;k=c[d>>2]|0;i=b;return k|0}if((c[h+4>>2]|0)!=0?(c[(c[(c[f>>2]|0)+4>>2]|0)+12>>2]|0)!=0:0){if((c[c[(c[(c[f>>2]|0)+4>>2]|0)+12>>2]>>2]|0)!=20?(c[j>>2]=DN(c[e>>2]|0,0)|0,(c[j>>2]|0)!=0):0){c[c[j>>2]>>2]=20;c[(c[j>>2]|0)+24>>2]=c[(c[(c[f>>2]|0)+4>>2]|0)+12>>2];c[(c[(c[f>>2]|0)+4>>2]|0)+12>>2]=c[j>>2]}EN(c[e>>2]|0,c[(c[(c[f>>2]|0)+4>>2]|0)+12>>2]|0)|0}c[(c[f>>2]|0)+8>>2]=c[g>>2];c[(c[e>>2]|0)+72>>2]=0;c[(c[f>>2]|0)+24>>2]=c[(c[e>>2]|0)+60>>2];c[(c[e>>2]|0)+60>>2]=0;c[(c[f>>2]|0)+28>>2]=c[(c[e>>2]|0)+64>>2];c[(c[e>>2]|0)+64>>2]=0;c[(c[f>>2]|0)+32>>2]=c[(c[e>>2]|0)+76>>2];c[(c[f>>2]|0)+36>>2]=c[(c[e>>2]|0)+84>>2];c[(c[e>>2]|0)+84>>2]=0;if((c[(c[e>>2]|0)+128>>2]|0)==1)c[(c[f>>2]|0)+12>>2]=1;c[d>>2]=c[f>>2];k=c[d>>2]|0;i=b;return k|0}function $M(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;if(!(c[g>>2]|0)){i=f;return}c[(c[g>>2]|0)+4>>2]=c[h>>2];c[(c[g>>2]|0)+8>>2]=c[j>>2];c[(c[g>>2]|0)+12>>2]=0;c[c[g>>2]>>2]=c[k>>2];i=f;return}function aN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+48|0;f=e+32|0;g=e+28|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;n=e;c[g>>2]=a;c[e+24>>2]=b;c[h>>2]=d;c[j>>2]=1;if((c[g>>2]|0)==0|(c[h>>2]|0)==0){c[f>>2]=-1;o=c[f>>2]|0;i=e;return o|0}do if(!(c[(c[g>>2]|0)+84>>2]|0)){c[k>>2]=c[(c[g>>2]|0)+20>>2];if(!(c[k>>2]|0)){FN(c[g>>2]|0,34,0,0,0);c[f>>2]=-1;o=c[f>>2]|0;i=e;return o|0}c[l>>2]=c[(c[k>>2]|0)+4>>2];if((c[l>>2]|0)!=0?(c[(c[l>>2]|0)+12>>2]|0)!=0:0){c[n>>2]=c[(c[l>>2]|0)+12>>2];d=c[n>>2]|0;if(!(c[(c[n>>2]|0)+52>>2]|0)){c[(c[g>>2]|0)+108>>2]=d;c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}c[m>>2]=oz(c[d+52>>2]|0,382,c[g>>2]|0)|0;if(c[m>>2]|0){HN(c[g>>2]|0,c[m>>2]|0)|0;break}c[f>>2]=-1;o=c[f>>2]|0;i=e;return o|0}FN(c[g>>2]|0,34,0,0,0);c[f>>2]=-1;o=c[f>>2]|0;i=e;return o|0}while(0);c[(c[g>>2]|0)+104>>2]=c[h>>2];c[(c[g>>2]|0)+100>>2]=0;m=c[(c[g>>2]|0)+84>>2]|0;n=c[(c[h>>2]|0)+8>>2]|0;if(c[(c[h>>2]|0)+36>>2]|0)c[j>>2]=rz(m,n,c[(c[(c[h>>2]|0)+36>>2]|0)+8>>2]|0,c[g>>2]|0)|0;else c[j>>2]=qz(m,n,c[g>>2]|0)|0;n=c[g>>2]|0;do if((c[j>>2]|0)>=0){if(!(c[n+100>>2]|0)){c[j>>2]=0;break}if((c[(c[g>>2]|0)+100>>2]|0)<0){c[j>>2]=-1;break}else{c[j>>2]=1;break}}else FN(n,38,c[(c[h>>2]|0)+8>>2]|0,0,0);while(0);c[f>>2]=c[j>>2];o=c[f>>2]|0;i=e;return o|0}function bN(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f;c[h>>2]=a;c[j>>2]=b;c[f+4>>2]=e;c[k>>2]=1;if((c[h>>2]|0)!=0?!((c[j>>2]|0)==0?1:(c[(c[h>>2]|0)+84>>2]|0)==0):0){a:while(1){if(!(d[c[j>>2]>>0]|0))break;do if((d[c[j>>2]>>0]|0|0)!=32){if(9<=(d[c[j>>2]>>0]|0|0)?(d[c[j>>2]>>0]|0|0)<=10:0)break;if((d[c[j>>2]>>0]|0|0)!=13)break a}while(0);c[j>>2]=(c[j>>2]|0)+1}if(!(d[c[j>>2]>>0]|0)){c[g>>2]=1;l=c[g>>2]|0;i=f;return l|0}c[k>>2]=qz(c[(c[h>>2]|0)+84>>2]|0,188096,c[h>>2]|0)|0;if((c[k>>2]|0)<0){FN(c[h>>2]|0,39,188104,0,0);c[g>>2]=-1;l=c[g>>2]|0;i=f;return l|0}else{c[g>>2]=1;l=c[g>>2]|0;i=f;return l|0}}c[g>>2]=-1;l=c[g>>2]|0;i=f;return l|0}function cN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[e+12>>2]=b;c[h>>2]=d;if((c[g>>2]|0)!=0?!((c[h>>2]|0)==0?1:(c[(c[g>>2]|0)+84>>2]|0)==0):0){c[k>>2]=IN(c[g>>2]|0)|0;c[j>>2]=qz(c[k>>2]|0,0,0)|0;do if(c[j>>2]|0)if((c[j>>2]|0)<0){c[j>>2]=-1;break}else{c[j>>2]=1;break}else{FN(c[g>>2]|0,22,188112,0,0);c[j>>2]=-1}while(0);pz(c[k>>2]|0);c[f>>2]=c[j>>2];l=c[f>>2]|0;i=e;return l|0}c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}function dN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[e+12>>2]=b;c[h>>2]=d;if((c[g>>2]|0)!=0?!((c[h>>2]|0)==0?1:(c[(c[g>>2]|0)+108>>2]|0)==0):0){c[k>>2]=JN(c[g>>2]|0,c[(c[h>>2]|0)+20>>2]|0)|0;if(!(c[k>>2]|0)){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}c[(c[k>>2]|0)+4>>2]=c[h>>2];c[(c[g>>2]|0)+60>>2]=c[k>>2];c[(c[g>>2]|0)+40>>2]=0;c[j>>2]=KN(c[g>>2]|0,c[(c[g>>2]|0)+108>>2]|0)|0;if((c[j>>2]|0)==0?(c[(c[g>>2]|0)+40>>2]|0)==0:0)c[j>>2]=1;else c[j>>2]=-1;LN(c[g>>2]|0,c[(c[g>>2]|0)+60>>2]|0);c[(c[g>>2]|0)+60>>2]=0;c[f>>2]=c[j>>2];l=c[f>>2]|0;i=e;return l|0}c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}function eN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](116)|0;if(!(c[f>>2]|0)){MN(0,188120);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}a=(c[f>>2]|0)+0|0;h=a+116|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(h|0));c[(c[f>>2]|0)+20>>2]=c[e>>2];c[(c[f>>2]|0)+4>>2]=c[33976];c[c[f>>2]>>2]=c[33980];c[(c[f>>2]|0)+48>>2]=0;c[(c[f>>2]|0)+52>>2]=0;c[(c[f>>2]|0)+44>>2]=0;c[(c[f>>2]|0)+56>>2]=0;if(c[e>>2]|0)c[(c[f>>2]|0)+36>>2]=c[(c[e>>2]|0)+12>>2];c[(c[f>>2]|0)+64>>2]=0;c[(c[f>>2]|0)+68>>2]=0;c[(c[f>>2]|0)+80>>2]=0;c[(c[f>>2]|0)+40>>2]=0;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}function fN(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+64>>2]|0)NN(0,c[(c[d>>2]|0)+64>>2]|0);if(c[(c[d>>2]|0)+68>>2]|0){c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[c[(c[d>>2]|0)+68>>2]>>2]|0))break;LN(0,c[(c[(c[(c[d>>2]|0)+68>>2]|0)+8>>2]|0)+(c[e>>2]<<2)>>2]|0);c[e>>2]=(c[e>>2]|0)+1}NN(0,c[(c[d>>2]|0)+68>>2]|0)}if(c[(c[d>>2]|0)+80>>2]|0){c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[(c[d>>2]|0)+72>>2]|0))break;NN(0,c[(c[(c[d>>2]|0)+80>>2]|0)+(c[e>>2]<<2)>>2]|0);c[e>>2]=(c[e>>2]|0)+1}zb[c[135736>>2]&511](c[(c[d>>2]|0)+80>>2]|0)}if(c[(c[d>>2]|0)+56>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+56>>2]|0);if(c[(c[d>>2]|0)+96>>2]|0){c[f>>2]=IN(c[d>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;pz(c[f>>2]|0);c[f>>2]=IN(c[d>>2]|0)|0}zb[c[135736>>2]&511](c[(c[d>>2]|0)+96>>2]|0)}zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function gN(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;if(!(c[g>>2]|0)){i=f;return}c[(c[g>>2]|0)+4>>2]=c[h>>2];c[(c[g>>2]|0)+8>>2]=c[j>>2];c[c[g>>2]>>2]=c[k>>2];c[(c[g>>2]|0)+12>>2]=0;i=f;return}function hN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if(!(c[f>>2]|0)){i=e;return}c[(c[f>>2]|0)+12>>2]=c[g>>2];c[(c[f>>2]|0)+4>>2]=0;c[(c[f>>2]|0)+8>>2]=0;c[c[f>>2]>>2]=c[h>>2];i=e;return}function iN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){c[e>>2]=-1;j=c[e>>2]|0;i=d;return j|0}c[(c[f>>2]|0)+24>>2]=c[g>>2];c[h>>2]=ON(c[f>>2]|0,c[g>>2]|0)|0;PN(c[g>>2]|0);if((c[h>>2]|0)==-1){c[e>>2]=1;j=c[e>>2]|0;i=d;return j|0}else{c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}return 0}function jN(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+4>>2]|0)jN(c[(c[d>>2]|0)+4>>2]|0);if(c[(c[d>>2]|0)+8>>2]|0)jN(c[(c[d>>2]|0)+8>>2]|0);if(c[(c[d>>2]|0)+28>>2]|0)Kj(c[(c[d>>2]|0)+28>>2]|0,0);if(c[(c[d>>2]|0)+24>>2]|0)Kj(c[(c[d>>2]|0)+24>>2]|0,0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function kN(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;while(1){if(!(c[d>>2]|0))break;c[e>>2]=c[c[d>>2]>>2];yN(c[d>>2]|0);c[d>>2]=c[e>>2]}i=b;return}function lN(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;while(1){if(!(c[d>>2]|0))break;c[e>>2]=c[c[d>>2]>>2];QN(c[d>>2]|0);c[d>>2]=c[e>>2]}i=b;return}function mN(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if((((c[c[d>>2]>>2]|0)==7?(c[(c[d>>2]|0)+36>>2]|0)!=0:0)?(c[e>>2]=c[(c[d>>2]|0)+20>>2],(c[e>>2]|0)!=0):0)?(c[(c[e>>2]|0)+24>>2]|0)!=0:0)Ab[c[(c[e>>2]|0)+24>>2]&511](c[(c[e>>2]|0)+4>>2]|0,c[(c[d>>2]|0)+36>>2]|0);if((c[(c[d>>2]|0)+20>>2]|0)!=0?(c[c[d>>2]>>2]|0)==19:0)RN(c[(c[d>>2]|0)+20>>2]|0);if((c[(c[d>>2]|0)+20>>2]|0)!=0?(c[c[d>>2]>>2]|0)==17:0)Kj(c[(c[d>>2]|0)+20>>2]|0,0);if(c[(c[d>>2]|0)+8>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+8>>2]|0);if(c[(c[d>>2]|0)+12>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+12>>2]|0);if(c[(c[d>>2]|0)+16>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+16>>2]|0);if(c[(c[d>>2]|0)+52>>2]|0)zz(c[(c[d>>2]|0)+52>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function nN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+12|0;f=d+4|0;g=d;c[d+8>>2]=a;c[f>>2]=b;do if(c[f>>2]|0){c[g>>2]=QH(c[f>>2]|0,196728)|0;if(!(c[g>>2]|0)){c[e>>2]=0;break}else{c[e>>2]=1;break}}else c[e>>2]=-1;while(0);i=d;return c[e>>2]|0}function oN(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g+28|0;j=g+20|0;k=g+16|0;l=g+12|0;m=g+8|0;n=g+4|0;o=g;c[g+24>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;do if(!((c[j>>2]|0)==0|(c[k>>2]|0)==0)){c[n>>2]=QH(c[j>>2]|0,196728)|0;if(!(c[n>>2]|0)){c[h>>2]=-1;break}c[o>>2]=TH(c[n>>2]|0,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0)|0;if((c[o>>2]|0)==2){c[h>>2]=2;break}if(!(c[o>>2]|0)){c[h>>2]=1;break}if((c[o>>2]|0)>0){c[h>>2]=0;break}else{c[h>>2]=-1;break}}else c[h>>2]=-1;while(0);i=g;return c[h>>2]|0}function pN(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=i;i=i+48|0;k=j+44|0;l=j+36|0;m=j+32|0;n=j+28|0;o=j+24|0;p=j+20|0;q=j+16|0;r=j+12|0;s=j+8|0;t=j+4|0;u=j;c[j+40>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=h;c[t>>2]=0;c[u>>2]=0;if((c[l>>2]|0)==0|(c[m>>2]|0)==0|(c[p>>2]|0)==0){c[k>>2]=-1;v=c[k>>2]|0;i=j;return v|0}c[s>>2]=QH(c[l>>2]|0,196728)|0;if(!(c[s>>2]|0)){c[k>>2]=-1;v=c[k>>2]|0;i=j;return v|0}if(!(c[o>>2]|0)){c[r>>2]=TH(c[s>>2]|0,c[m>>2]|0,t,c[n>>2]|0)|0;if(c[r>>2]|0){c[k>>2]=-1;v=c[k>>2]|0;i=j;return v|0}if(!(c[t>>2]|0)){c[k>>2]=-1;v=c[k>>2]|0;i=j;return v|0}}else c[t>>2]=c[o>>2];c[r>>2]=TH(c[s>>2]|0,c[p>>2]|0,u,c[q>>2]|0)|0;q=c[t>>2]|0;if(c[r>>2]|0){if((q|0)!=(c[o>>2]|0))PH(c[t>>2]|0);c[k>>2]=-1;v=c[k>>2]|0;i=j;return v|0}c[r>>2]=XH(q,c[u>>2]|0)|0;if((c[t>>2]|0)!=(c[o>>2]|0))PH(c[t>>2]|0);PH(c[u>>2]|0);if((c[r>>2]|0)==-2){c[k>>2]=-1;v=c[k>>2]|0;i=j;return v|0}if(!(c[r>>2]|0)){c[k>>2]=1;v=c[k>>2]|0;i=j;return v|0}else{c[k>>2]=0;v=c[k>>2]|0;i=j;return v|0}return 0}function qN(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+48|0;j=h+36|0;k=h+28|0;l=h+24|0;m=h+20|0;n=h+16|0;o=h+12|0;p=h+8|0;q=h+4|0;r=h;c[h+32>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;if((c[k>>2]|0)==0|(c[n>>2]|0)==0){c[j>>2]=-1;s=c[j>>2]|0;i=h;return s|0}c[q>>2]=QH(c[k>>2]|0,196728)|0;if(!(c[q>>2]|0)){c[j>>2]=-1;s=c[j>>2]|0;i=h;return s|0}c[p>>2]=SA()|0;if(!(c[p>>2]|0)){c[j>>2]=-1;s=c[j>>2]|0;i=h;return s|0}do if(qy(c[l>>2]|0,196768)|0)c[c[p>>2]>>2]=1e3;else{if(qy(c[l>>2]|0,196784)|0){c[c[p>>2]>>2]=1001;break}if(qy(c[l>>2]|0,196800)|0){c[c[p>>2]>>2]=1002;break}if(qy(c[l>>2]|0,196816)|0){c[c[p>>2]>>2]=1003;break}if(qy(c[l>>2]|0,196832)|0){c[c[p>>2]>>2]=1004;break}if(qy(c[l>>2]|0,196848)|0){c[c[p>>2]>>2]=1005;break}if(qy(c[l>>2]|0,196864)|0){c[c[p>>2]>>2]=1006;break}if(qy(c[l>>2]|0,196872)|0){c[c[p>>2]>>2]=1007;break}if(qy(c[l>>2]|0,196888)|0){c[c[p>>2]>>2]=1008;break}if(qy(c[l>>2]|0,196904)|0){c[c[p>>2]>>2]=1009;break}if(qy(c[l>>2]|0,196912)|0){c[c[p>>2]>>2]=1010;break}g=(qy(c[l>>2]|0,196928)|0)!=0;f=c[p>>2]|0;if(g){c[f>>2]=1011;break}UA(f);c[j>>2]=-1;s=c[j>>2]|0;i=h;return s|0}while(0);c[(c[p>>2]|0)+8>>2]=c[m>>2];c[r>>2]=_A(c[p>>2]|0,c[q>>2]|0,0,c[k>>2]|0)|0;if(c[r>>2]|0){UA(c[p>>2]|0);c[j>>2]=-1;s=c[j>>2]|0;i=h;return s|0}c[r>>2]=$H(c[q>>2]|0,c[p>>2]|0,c[n>>2]|0,c[o>>2]|0)|0;UA(c[p>>2]|0);if(c[r>>2]|0){c[j>>2]=-1;s=c[j>>2]|0;i=h;return s|0}else{c[j>>2]=0;s=c[j>>2]|0;i=h;return s|0}return 0}function rN(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[d+4>>2]=a;c[e>>2]=b;PH(c[e>>2]|0);i=d;return}function sN(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=i;i=i+48|0;k=j;l=j+40|0;m=j+36|0;n=j+32|0;o=j+28|0;p=j+24|0;q=j+20|0;r=j+16|0;s=j+12|0;t=j+8|0;u=j+4|0;c[m>>2]=a;c[n>>2]=b;c[o>>2]=d;c[p>>2]=e;c[q>>2]=f;c[r>>2]=g;c[s>>2]=h;if((c[46942]|0)==0|(c[m>>2]|0)==0|(c[p>>2]|0)==0|(c[q>>2]|0)==0){c[l>>2]=-1;v=c[l>>2]|0;i=j;return v|0}if(Rj(c[46942]|0,c[m>>2]|0)|0){h=c[33976]|0;g=c[33980]|0;c[k>>2]=c[m>>2];Db[h&511](g,196944,k);c[l>>2]=-1;v=c[l>>2]|0;i=j;return v|0}c[t>>2]=Cb[c[135744>>2]&511](28)|0;if(!(c[t>>2]|0)){MN(0,196992);c[l>>2]=-1;v=c[l>>2]|0;i=j;return v|0}g=c[t>>2]|0;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;c[g+16>>2]=0;c[g+20>>2]=0;c[g+24>>2]=0;g=my(c[m>>2]|0)|0;c[c[t>>2]>>2]=g;c[(c[t>>2]|0)+4>>2]=c[n>>2];c[(c[t>>2]|0)+8>>2]=c[o>>2];c[(c[t>>2]|0)+16>>2]=c[q>>2];c[(c[t>>2]|0)+12>>2]=c[p>>2];c[(c[t>>2]|0)+20>>2]=c[r>>2];c[(c[t>>2]|0)+24>>2]=c[s>>2];c[u>>2]=Lj(c[46942]|0,c[m>>2]|0,c[t>>2]|0)|0;if((c[u>>2]|0)<0){u=c[33976]|0;s=c[33980]|0;c[k>>2]=c[m>>2];Db[u&511](s,197016,k);wN(c[t>>2]|0,c[m>>2]|0);c[l>>2]=-1;v=c[l>>2]|0;i=j;return v|0}else{c[l>>2]=0;v=c[l>>2]|0;i=j;return v|0}return 0}function tN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+8|0;f=d;c[d+4>>2]=a;c[f>>2]=b;do if(c[f>>2]|0){if(qy(c[f>>2]|0,196712)|0){c[e>>2]=1;break}if(qy(c[f>>2]|0,196720)|0){c[e>>2]=1;break}else{c[e>>2]=0;break}}else c[e>>2]=-1;while(0);i=d;return c[e>>2]|0}function uN(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+12|0;k=g+8|0;c[g+16>>2]=a;c[j>>2]=b;c[k>>2]=d;c[g+4>>2]=e;c[g>>2]=f;do if(c[k>>2]|0){if(qy(c[j>>2]|0,196712)|0){c[h>>2]=1;break}if(qy(c[j>>2]|0,196720)|0){c[h>>2]=1;break}else{c[h>>2]=0;break}}else c[h>>2]=-1;while(0);i=g;return c[h>>2]|0}function vN(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+48|0;k=j+32|0;l=j+28|0;m=j+16|0;n=j+8|0;o=j+4|0;p=j;c[j+36>>2]=a;c[k>>2]=b;c[l>>2]=d;c[j+24>>2]=e;c[j+20>>2]=f;c[m>>2]=g;c[j+12>>2]=h;c[n>>2]=-1;if(qy(c[k>>2]|0,196712)|0){c[n>>2]=qy(c[l>>2]|0,c[m>>2]|0)|0;q=c[n>>2]|0;i=j;return q|0}if(!(qy(c[k>>2]|0,196720)|0)){q=c[n>>2]|0;i=j;return q|0}if(qy(c[l>>2]|0,c[m>>2]|0)|0){c[n>>2]=1;q=c[n>>2]|0;i=j;return q|0}c[o>>2]=SN(0,c[l>>2]|0)|0;c[p>>2]=SN(0,c[m>>2]|0)|0;do if(!((c[o>>2]|0)==0|(c[p>>2]|0)==0))if(qy(c[o>>2]|0,c[p>>2]|0)|0){c[n>>2]=1;break}else{c[n>>2]=0;break}else c[n>>2]=-1;while(0);if(c[o>>2]|0)zb[c[135736>>2]&511](c[o>>2]|0);if(!(c[p>>2]|0)){q=c[n>>2]|0;i=j;return q|0}zb[c[135736>>2]&511](c[p>>2]|0);q=c[n>>2]|0;i=j;return q|0}function wN(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d+4|0;c[e>>2]=a;c[d>>2]=b;if(!(c[e>>2]|0)){i=d;return}if(c[c[e>>2]>>2]|0)zb[c[135736>>2]&511](c[c[e>>2]>>2]|0);zb[c[135736>>2]&511](c[e>>2]|0);i=d;return}function xN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;c[j>>2]=0;c[k>>2]=0;if(c[f>>2]|0){b=c[f>>2]|0;if(c[(c[f>>2]|0)+12>>2]|0)c[h>>2]=c[b+12>>2];else c[j>>2]=c[b+4>>2];c[k>>2]=c[c[f>>2]>>2];b=(c[f>>2]|0)+36|0;c[b>>2]=(c[b>>2]|0)+1}b=c[h>>2]|0;h=c[j>>2]|0;j=c[k>>2]|0;if(c[g>>2]|0){k=c[g>>2]|0;c[e>>2]=c[g>>2];Xd(b,h,j,0,0,18,2,3,0,0,k,0,0,0,0,189400,e);i=d;return}else{Xd(b,h,j,0,0,18,2,3,0,0,0,0,0,0,0,189432,e);i=d;return}}function yN(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+4>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+4>>2]|0);if(c[(c[d>>2]|0)+8>>2]|0)Th(c[(c[d>>2]|0)+8>>2]|0);if(c[(c[d>>2]|0)+16>>2]|0)TN(c[(c[d>>2]|0)+16>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function zN(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+48|0;j=h;k=h+40|0;l=h+36|0;m=h+32|0;n=h+28|0;o=h+24|0;p=h+20|0;q=h+16|0;r=h+12|0;s=h+8|0;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=0;c[r>>2]=0;c[s>>2]=0;if(c[k>>2]|0){g=c[k>>2]|0;if(c[(c[k>>2]|0)+12>>2]|0)c[q>>2]=c[g+12>>2];else c[r>>2]=c[g+4>>2];c[s>>2]=c[c[k>>2]>>2];g=(c[k>>2]|0)+36|0;c[g>>2]=(c[g>>2]|0)+1}g=c[q>>2]|0;q=c[r>>2]|0;r=c[s>>2]|0;s=c[l>>2]|0;l=c[m>>2]|0;m=c[o>>2]|0;k=c[p>>2]|0;f=c[n>>2]|0;n=c[p>>2]|0;c[j>>2]=c[o>>2];c[j+4>>2]=n;Xd(g,q,r,0,s,18,l,2,0,0,m,k,0,0,0,f,j);i=h;return}function AN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=Pi(c[g>>2]|0)|0;b=c[f>>2]|0;if(!(c[h>>2]|0)){zN(b,c[g>>2]|0,1022,188056,c[(c[f>>2]|0)+68>>2]|0,0);c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}else{UN(b,c[h>>2]|0);c[e>>2]=c[g>>2];j=c[e>>2]|0;i=d;return j|0}return 0}function BN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+28|0;f=d+24|0;g=d+20|0;h=d+16|0;j=d+12|0;k=d+8|0;l=d+4|0;m=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){c[e>>2]=0;n=c[e>>2]|0;i=d;return n|0}c[h>>2]=VN(c[f>>2]|0)|0;if(!(c[h>>2]|0)){c[e>>2]=0;n=c[e>>2]|0;i=d;return n|0}c[j>>2]=c[(c[f>>2]|0)+44>>2];c[(c[f>>2]|0)+44>>2]=0;if(((((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+36>>2]|0)!=0:0)?(c[(c[g>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[g>>2]|0)+8>>2]|0,190264)|0)!=0:0)?(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0){b=WN(c[f>>2]|0,c[(c[g>>2]|0)+12>>2]|0)|0;c[(c[h>>2]|0)+4>>2]=b;if(!(c[(c[h>>2]|0)+4>>2]|0)){VM(c[h>>2]|0);c[e>>2]=0;n=c[e>>2]|0;i=d;return n|0}}else{b=XN(c[f>>2]|0)|0;c[m>>2]=b;c[(c[h>>2]|0)+4>>2]=b;if(!(c[(c[h>>2]|0)+4>>2]|0)){VM(c[h>>2]|0);c[e>>2]=0;n=c[e>>2]|0;i=d;return n|0}c[c[m>>2]>>2]=c[(c[f>>2]|0)+24>>2];do if(c[(c[f>>2]|0)+24>>2]|0){c[l>>2]=c[(c[(c[f>>2]|0)+24>>2]|0)+4>>2];if(!(c[l>>2]|0)){c[(c[(c[f>>2]|0)+24>>2]|0)+4>>2]=c[m>>2];break}while(1){if(!(c[(c[l>>2]|0)+8>>2]|0))break;c[l>>2]=c[(c[l>>2]|0)+8>>2]}c[(c[l>>2]|0)+8>>2]=c[m>>2]}while(0);c[k>>2]=c[(c[f>>2]|0)+24>>2];c[(c[f>>2]|0)+24>>2]=c[m>>2];YN(c[f>>2]|0,c[g>>2]|0)|0;if(c[k>>2]|0)c[(c[f>>2]|0)+24>>2]=c[k>>2]}c[(c[f>>2]|0)+44>>2]=c[j>>2];if((c[(c[(c[h>>2]|0)+4>>2]|0)+12>>2]|0)!=0?(ZN(c[f>>2]|0,c[(c[(c[h>>2]|0)+4>>2]|0)+12>>2]|0,0)|0,(c[(c[f>>2]|0)+32>>2]&128|0)==0):0){_N(c[f>>2]|0,c[(c[(c[h>>2]|0)+4>>2]|0)+12>>2]|0,0);while(1){if(!(c[(c[(c[h>>2]|0)+4>>2]|0)+12>>2]|0))break;if((c[c[(c[(c[h>>2]|0)+4>>2]|0)+12>>2]>>2]|0)!=-1)break;if(!(c[(c[(c[(c[h>>2]|0)+4>>2]|0)+12>>2]|0)+32>>2]|0))break;c[(c[(c[h>>2]|0)+4>>2]|0)+12>>2]=c[(c[(c[(c[h>>2]|0)+4>>2]|0)+12>>2]|0)+24>>2]}$N(c[f>>2]|0,c[(c[(c[h>>2]|0)+4>>2]|0)+12>>2]|0,16,-1)|0}c[e>>2]=c[h>>2];n=c[e>>2]|0;i=d;return n|0}function CN(a,e,f){a=a|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;g=i;i=i+64|0;h=g+60|0;j=g+56|0;k=g+48|0;l=g+44|0;m=g+40|0;n=g+36|0;o=g+32|0;p=g+28|0;q=g+24|0;r=g+20|0;s=g+16|0;t=g+12|0;u=g+8|0;v=g+4|0;w=g;c[h>>2]=a;c[j>>2]=e;c[g+52>>2]=f;c[m>>2]=0;c[n>>2]=0;c[t>>2]=0;c[u>>2]=0;c[v>>2]=0;c[w>>2]=1;if(c[(c[j>>2]|0)+36>>2]|0){i=g;return}c[k>>2]=c[(c[h>>2]|0)+24>>2];while(1){if(!(c[k>>2]|0))break;c[u>>2]=(c[u>>2]|0)+1;c[k>>2]=c[(c[k>>2]|0)+32>>2]}c[n>>2]=Cb[c[135744>>2]&511](c[u>>2]<<2)|0;a:do if(c[n>>2]|0){c[k>>2]=c[(c[h>>2]|0)+24>>2];while(1){x=c[33936]|0;if(!(c[k>>2]|0))break;u=Cb[x&511](12)|0;c[(c[n>>2]|0)+(c[t>>2]<<2)>>2]=u;if(!(c[(c[n>>2]|0)+(c[t>>2]<<2)>>2]|0))break a;if((c[c[k>>2]>>2]|0)==3)c[v>>2]=(c[v>>2]|0)+1;c[c[(c[n>>2]|0)+(c[t>>2]<<2)>>2]>>2]=c[k>>2];u=aO(c[j>>2]|0,c[k>>2]|0,0)|0;c[(c[(c[n>>2]|0)+(c[t>>2]<<2)>>2]|0)+4>>2]=u;u=aO(c[j>>2]|0,c[k>>2]|0,1)|0;c[(c[(c[n>>2]|0)+(c[t>>2]<<2)>>2]|0)+8>>2]=u;c[t>>2]=(c[t>>2]|0)+1;c[k>>2]=c[(c[k>>2]|0)+32>>2]}c[m>>2]=Cb[x&511](16)|0;if(c[m>>2]|0){u=c[m>>2]|0;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[u+12>>2]=0;c[c[m>>2]>>2]=c[t>>2];u=Ij(c[t>>2]|0)|0;c[(c[m>>2]|0)+4>>2]=u;c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[t>>2]|0))break;c[o>>2]=c[(c[n>>2]|0)+(c[p>>2]<<2)>>2];c[q>>2]=(c[p>>2]|0)+1;while(1){if((c[q>>2]|0)>=(c[t>>2]|0))break;if(c[(c[n>>2]|0)+(c[q>>2]<<2)>>2]|0){c[r>>2]=bO(c[j>>2]|0,c[(c[o>>2]|0)+4>>2]|0,c[(c[(c[n>>2]|0)+(c[q>>2]<<2)>>2]|0)+4>>2]|0)|0;if(!(c[r>>2]|0))zN(c[j>>2]|0,c[(c[h>>2]|0)+4>>2]|0,1021,190104,0,0);c[r>>2]=bO(c[j>>2]|0,c[(c[o>>2]|0)+8>>2]|0,c[(c[(c[n>>2]|0)+(c[q>>2]<<2)>>2]|0)+8>>2]|0)|0;if(!(c[r>>2]|0))zN(c[j>>2]|0,c[(c[h>>2]|0)+4>>2]|0,1001,190152,0,0)}c[q>>2]=(c[q>>2]|0)+1}c[l>>2]=c[(c[o>>2]|0)+4>>2];b:do if((c[l>>2]|0)!=0?(c[c[l>>2]>>2]|0)!=0:0)while(1){if(!(c[c[l>>2]>>2]|0))break b;do if((c[c[c[l>>2]>>2]>>2]|0)==3){c[s>>2]=Nj(c[(c[m>>2]|0)+4>>2]|0,188096,0,(c[p>>2]|0)+1|0)|0;if(c[s>>2]|0)c[w>>2]=-1}else{if((c[c[c[l>>2]>>2]>>2]|0)==4?(c[(c[c[l>>2]>>2]|0)+8>>2]|0)!=0:0){if((c[(c[c[l>>2]>>2]|0)+12>>2]|0)!=0?(d[c[(c[c[l>>2]>>2]|0)+12>>2]>>0]|0)!=0:0)c[s>>2]=Nj(c[(c[m>>2]|0)+4>>2]|0,c[(c[c[l>>2]>>2]|0)+8>>2]|0,c[(c[c[l>>2]>>2]|0)+12>>2]|0,(c[p>>2]|0)+1|0)|0;else c[s>>2]=Nj(c[(c[m>>2]|0)+4>>2]|0,c[(c[c[l>>2]>>2]|0)+8>>2]|0,0,(c[p>>2]|0)+1|0)|0;if(!(c[s>>2]|0))break;c[w>>2]=-1;break}if((c[c[c[l>>2]>>2]>>2]|0)!=4){c[w>>2]=-1;break}if((c[(c[c[l>>2]>>2]|0)+12>>2]|0)!=0?(d[c[(c[c[l>>2]>>2]|0)+12>>2]>>0]|0)!=0:0)c[s>>2]=Nj(c[(c[m>>2]|0)+4>>2]|0,189536,c[(c[c[l>>2]>>2]|0)+12>>2]|0,(c[p>>2]|0)+1|0)|0;else c[s>>2]=Nj(c[(c[m>>2]|0)+4>>2]|0,189536,0,(c[p>>2]|0)+1|0)|0;if(c[(c[c[l>>2]>>2]|0)+40>>2]|0)c[w>>2]=2;if(c[s>>2]|0)c[w>>2]=-1}while(0);c[l>>2]=(c[l>>2]|0)+4}else y=48;while(0);if((y|0)==48){y=0;c[w>>2]=0}c[p>>2]=(c[p>>2]|0)+1}c[(c[m>>2]|0)+12>>2]=c[n>>2];c[(c[h>>2]|0)+20>>2]=c[m>>2];if(c[v>>2]|0){u=(c[h>>2]|0)+50|0;b[u>>1]=b[u>>1]|8}if((c[w>>2]|0)==1)c[(c[m>>2]|0)+8>>2]=1;if((c[w>>2]|0)!=2){i=g;return}c[(c[m>>2]|0)+8>>2]=3;i=g;return}}while(0);xN(c[j>>2]|0,190192);if(c[n>>2]|0){c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[t>>2]|0))break;if(c[(c[n>>2]|0)+(c[p>>2]<<2)>>2]|0){if(c[(c[(c[n>>2]|0)+(c[p>>2]<<2)>>2]|0)+4>>2]|0)zb[c[135736>>2]&511](c[(c[(c[n>>2]|0)+(c[p>>2]<<2)>>2]|0)+4>>2]|0);zb[c[135736>>2]&511](c[(c[n>>2]|0)+(c[p>>2]<<2)>>2]|0)}c[p>>2]=(c[p>>2]|0)+1}zb[c[135736>>2]&511](c[n>>2]|0)}RN(c[m>>2]|0);i=g;return}function DN(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=d;d=(c[g>>2]|0)+80|0;do if(!(c[(c[g>>2]|0)+80>>2]|0)){c[d>>2]=16;c[(c[g>>2]|0)+76>>2]=0;a=Cb[c[135744>>2]&511](c[(c[g>>2]|0)+80>>2]<<2)|0;c[(c[g>>2]|0)+84>>2]=a;if(!(c[(c[g>>2]|0)+84>>2]|0)){xN(c[g>>2]|0,190080);c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}}else if((c[d>>2]|0)<=(c[(c[g>>2]|0)+76>>2]|0)){a=(c[g>>2]|0)+80|0;c[a>>2]=c[a>>2]<<1;c[k>>2]=Hb[c[135760>>2]&511](c[(c[g>>2]|0)+84>>2]|0,c[(c[g>>2]|0)+80>>2]<<2)|0;if(c[k>>2]|0){c[(c[g>>2]|0)+84>>2]=c[k>>2];break}xN(c[g>>2]|0,190080);c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}while(0);c[j>>2]=Cb[c[135744>>2]&511](56)|0;if(!(c[j>>2]|0)){xN(c[g>>2]|0,190080);c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}else{k=(c[j>>2]|0)+0|0;d=k+56|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(d|0));k=c[j>>2]|0;d=(c[g>>2]|0)+76|0;a=c[d>>2]|0;c[d>>2]=a+1;c[(c[(c[g>>2]|0)+84>>2]|0)+(a<<2)>>2]=k;c[(c[j>>2]|0)+4>>2]=c[h>>2];b[(c[j>>2]|0)+48>>1]=-1;c[f>>2]=c[j>>2];l=c[f>>2]|0;i=e;return l|0}return 0}function EN(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=d;c[j>>2]=0;if((c[g>>2]|0)==0|(c[h>>2]|0)==0){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}if(!((c[c[h>>2]>>2]|0)!=20?(c[c[h>>2]>>2]|0)!=4:0))m=5;if(((m|0)==5?(c[j>>2]=cO(c[h>>2]|0)|0,(b[(c[h>>2]|0)+50>>1]&64|0)!=0):0)?(b[(c[h>>2]|0)+48>>1]|0)!=-25:0){
c[(c[g>>2]|0)+132>>2]=0;c[j>>2]=dO(c[g>>2]|0,c[h>>2]|0)|0;c[f>>2]=c[j>>2];l=c[f>>2]|0;i=e;return l|0}a:do switch(c[c[h>>2]>>2]|0){case 4:case 0:case 7:case 6:case 8:case 5:case 3:{c[j>>2]=0;break}case 13:case 12:case 11:case 20:case 10:case 18:case 17:case 16:case 15:case 14:{c[k>>2]=c[(c[h>>2]|0)+24>>2];while(1){if(!(c[k>>2]|0))break a;c[j>>2]=EN(c[g>>2]|0,c[k>>2]|0)|0;if(c[j>>2]|0)break a;c[k>>2]=c[(c[k>>2]|0)+32>>2]}break}case-1:{c[j>>2]=EN(c[g>>2]|0,c[(c[h>>2]|0)+24>>2]|0)|0;break}case 1:case 19:case 9:case 2:{c[j>>2]=0;break}default:{}}while(0);c[f>>2]=c[j>>2];l=c[f>>2]|0;i=e;return l|0}function FN(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g+24|0;j=g+20|0;k=g+16|0;l=g+12|0;m=g+8|0;n=g+4|0;o=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;if(!(c[h>>2]|0)){i=g;return}if(c[(c[h>>2]|0)+28>>2]&8){i=g;return}if((c[(c[h>>2]|0)+28>>2]&1|0)!=0?(c[(c[h>>2]|0)+28>>2]&2|0)==0:0){gO(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0)|0;i=g;return}if(c[(c[h>>2]|0)+48>>2]|0)eO(c[h>>2]|0);if(c[(c[h>>2]|0)+60>>2]|0){c[n>>2]=c[c[(c[h>>2]|0)+60>>2]>>2];c[o>>2]=c[(c[(c[h>>2]|0)+60>>2]|0)+4>>2]}else{c[o>>2]=0;c[n>>2]=0}if((c[n>>2]|0)==0&(c[o>>2]|0)==0)c[n>>2]=c[(c[h>>2]|0)+104>>2];fO(c[h>>2]|0,c[j>>2]|0,c[n>>2]|0,c[o>>2]|0,c[k>>2]|0,c[l>>2]|0);i=g;return}function GN(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;g=i;i=i+64|0;h=g;j=g+52|0;k=g+48|0;l=g+44|0;m=g+40|0;n=g+36|0;p=g+32|0;q=g+28|0;r=g+24|0;s=g+20|0;t=g+16|0;u=g+12|0;v=g+8|0;w=g+4|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=c[m>>2];c[p>>2]=c[l>>2];c[t>>2]=0;if(!(c[n>>2]|0)){l=c[o>>2]|0;c[h>>2]=c[k>>2];Ka(l|0,189616,h|0)|0;i=g;return}c[s>>2]=c[(c[n>>2]|0)+104>>2];c[(c[n>>2]|0)+100>>2]=1;if(!(c[p>>2]|0)){if((d[c[k>>2]>>0]|0|0)==35){i=g;return}l=c[o>>2]|0;c[h>>2]=c[k>>2];Ka(l|0,189648,h|0)|0;if((c[n>>2]|0)!=0?(c[(c[n>>2]|0)+40>>2]|0)==0:0)c[(c[n>>2]|0)+40>>2]=37;c[(c[n>>2]|0)+100>>2]=-1;i=g;return}if((c[n>>2]|0)==0|(c[p>>2]|0)==0){l=c[o>>2]|0;c[h>>2]=c[k>>2];Ka(l|0,189680,h|0)|0;if((c[n>>2]|0)!=0?(c[(c[n>>2]|0)+40>>2]|0)==0:0)c[(c[n>>2]|0)+40>>2]=37;c[(c[n>>2]|0)+100>>2]=-1;i=g;return}if((c[c[p>>2]>>2]|0)!=4){l=c[o>>2]|0;c[h>>2]=c[k>>2];Ka(l|0,189712,h|0)|0;if(!(c[(c[n>>2]|0)+40>>2]|0))c[(c[n>>2]|0)+40>>2]=37;c[(c[n>>2]|0)+100>>2]=-1;i=g;return}if((c[(c[s>>2]|0)+4>>2]|0)!=1){FN(c[n>>2]|0,23,0,0,0);if(!(c[(c[n>>2]|0)+28>>2]&1))eO(c[n>>2]|0);c[(c[n>>2]|0)+100>>2]=-1;i=g;return}if(!(c[(c[p>>2]|0)+52>>2]|0)){c[(c[n>>2]|0)+100>>2]=0;c[(c[n>>2]|0)+108>>2]=c[p>>2];i=g;return}c[j>>2]=oz(c[(c[p>>2]|0)+52>>2]|0,382,c[n>>2]|0)|0;h=c[n>>2]|0;if(!(c[j>>2]|0)){c[h+100>>2]=-1;i=g;return}HN(h,c[j>>2]|0)|0;c[q>>2]=JN(c[n>>2]|0,c[s>>2]|0)|0;j=c[n>>2]|0;if(!(c[q>>2]|0)){c[j+100>>2]=-1;i=g;return}c[r>>2]=c[j+60>>2];c[(c[n>>2]|0)+60>>2]=c[q>>2];if((c[(c[p>>2]|0)+36>>2]|0)!=0?(c[t>>2]=hO(c[n>>2]|0,c[(c[p>>2]|0)+36>>2]|0)|0,(c[t>>2]|0)!=0):0){c[(c[n>>2]|0)+100>>2]=-1;FN(c[n>>2]|0,24,c[(c[s>>2]|0)+8>>2]|0,0,0)}s=c[n>>2]|0;if(!(c[(c[n>>2]|0)+60>>2]|0)){if(c[s+64>>2]|0){c[v>>2]=-1;c[u>>2]=c[(c[n>>2]|0)+28>>2];c[w>>2]=0;while(1){if((c[w>>2]|0)>=(c[c[(c[n>>2]|0)+64>>2]>>2]|0))break;c[q>>2]=c[(c[(c[(c[n>>2]|0)+64>>2]|0)+8>>2]|0)+(c[w>>2]<<2)>>2];c[(c[n>>2]|0)+60>>2]=c[q>>2];c[(c[(c[n>>2]|0)+60>>2]|0)+4>>2]=0;if(!(iO(c[n>>2]|0,0)|0)){x=39;break}c[w>>2]=(c[w>>2]|0)+1}if((x|0)==39)c[v>>2]=0;if(c[v>>2]|0){x=(c[n>>2]|0)+28|0;c[x>>2]=c[x>>2]|1;jO(c[n>>2]|0)}c[w>>2]=0;while(1){y=c[n>>2]|0;if((c[w>>2]|0)>=(c[c[(c[n>>2]|0)+64>>2]>>2]|0))break;LN(y,c[(c[(c[(c[n>>2]|0)+64>>2]|0)+8>>2]|0)+(c[w>>2]<<2)>>2]|0);c[w>>2]=(c[w>>2]|0)+1}NN(y,c[(c[n>>2]|0)+64>>2]|0);c[(c[n>>2]|0)+64>>2]=0;if((c[t>>2]|0)==0&(c[v>>2]|0)==-1)c[(c[n>>2]|0)+100>>2]=-1;c[(c[n>>2]|0)+28>>2]=c[u>>2]}}else{c[(c[s+60>>2]|0)+4>>2]=0;c[t>>2]=iO(c[n>>2]|0,1)|0;if(c[t>>2]|0)c[(c[n>>2]|0)+100>>2]=-1;LN(c[n>>2]|0,c[(c[n>>2]|0)+60>>2]|0)}if((c[(c[n>>2]|0)+100>>2]|0)==-1?(c[(c[n>>2]|0)+28>>2]&1|0)==0:0)eO(c[n>>2]|0);c[(c[n>>2]|0)+60>>2]=c[r>>2];i=g;return}function HN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if((c[(c[f>>2]|0)+96>>2]|0)==0?(c[(c[f>>2]|0)+92>>2]=10,b=Cb[c[135744>>2]&511](c[(c[f>>2]|0)+92>>2]<<2)|0,c[(c[f>>2]|0)+96>>2]=b,(c[(c[f>>2]|0)+96>>2]|0)==0):0){MN(c[f>>2]|0,189544);c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}if((c[(c[f>>2]|0)+88>>2]|0)>=(c[(c[f>>2]|0)+92>>2]|0)?(b=(c[f>>2]|0)+92|0,c[b>>2]=c[b>>2]<<1,b=Hb[c[135760>>2]&511](c[(c[f>>2]|0)+96>>2]|0,c[(c[f>>2]|0)+92>>2]<<2)|0,c[(c[f>>2]|0)+96>>2]=b,(c[(c[f>>2]|0)+96>>2]|0)==0):0){MN(c[f>>2]|0,189544);c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}b=c[g>>2]|0;a=(c[f>>2]|0)+88|0;j=c[a>>2]|0;c[a>>2]=j+1;c[(c[(c[f>>2]|0)+96>>2]|0)+(j<<2)>>2]=b;c[(c[f>>2]|0)+84>>2]=c[g>>2];c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}function IN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if((c[(c[e>>2]|0)+88>>2]|0)<=0){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}a=(c[e>>2]|0)+88|0;c[a>>2]=(c[a>>2]|0)+-1;c[f>>2]=c[(c[(c[e>>2]|0)+96>>2]|0)+(c[(c[e>>2]|0)+88>>2]<<2)>>2];c[(c[(c[e>>2]|0)+96>>2]|0)+(c[(c[e>>2]|0)+88>>2]<<2)>>2]=0;a=c[e>>2]|0;if((c[(c[e>>2]|0)+88>>2]|0)>0)c[(c[e>>2]|0)+84>>2]=c[(c[(c[e>>2]|0)+96>>2]|0)+((c[a+88>>2]|0)-1<<2)>>2];else c[a+84>>2]=0;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}function JN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+128|0;e=d+112|0;f=d+108|0;g=d+104|0;h=d+100|0;j=d+96|0;k=d+16|0;l=d+8|0;m=d+4|0;n=d;c[f>>2]=a;c[g>>2]=b;c[l>>2]=0;c[m>>2]=0;a:do if(!(c[g>>2]|0)){c[m>>2]=Pi(c[(c[f>>2]|0)+24>>2]|0)|0;if(!(c[m>>2]|0)){c[e>>2]=0;o=c[e>>2]|0;i=d;return o|0}}else{c[j>>2]=c[(c[g>>2]|0)+44>>2];while(1){if(!(c[j>>2]|0))break a;if((c[l>>2]|0)<20){b=c[j>>2]|0;a=c[l>>2]|0;c[l>>2]=a+1;c[k+(a<<2)>>2]=b}else c[l>>2]=(c[l>>2]|0)+1;c[j>>2]=c[(c[j>>2]|0)+24>>2]}}while(0);if((c[(c[f>>2]|0)+68>>2]|0)!=0?(c[c[(c[f>>2]|0)+68>>2]>>2]|0)>0:0){b=c[(c[f>>2]|0)+68>>2]|0;c[b>>2]=(c[b>>2]|0)+-1;c[h>>2]=c[(c[(c[(c[f>>2]|0)+68>>2]|0)+8>>2]|0)+(c[c[(c[f>>2]|0)+68>>2]>>2]<<2)>>2]}else p=13;do if((p|0)==13){c[h>>2]=Cb[c[135744>>2]&511](32)|0;if(c[h>>2]|0){b=c[h>>2]|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;c[b+28>>2]=0;break}MN(c[f>>2]|0,189568);c[e>>2]=0;o=c[e>>2]|0;i=d;return o|0}while(0);c[(c[h>>2]|0)+20>>2]=0;c[(c[h>>2]|0)+24>>2]=0;if(!(c[g>>2]|0)){c[c[h>>2]>>2]=c[(c[f>>2]|0)+24>>2];c[(c[h>>2]|0)+4>>2]=c[m>>2]}else{c[c[h>>2]>>2]=c[g>>2];c[(c[h>>2]|0)+4>>2]=c[(c[g>>2]|0)+12>>2]}c[(c[h>>2]|0)+8>>2]=0;b:do if((c[l>>2]|0)>0){do if(!(c[(c[h>>2]|0)+28>>2]|0)){if((c[l>>2]|0)<4)c[(c[h>>2]|0)+12>>2]=4;else c[(c[h>>2]|0)+12>>2]=c[l>>2];m=Cb[c[135744>>2]&511](c[(c[h>>2]|0)+12>>2]<<2)|0;c[(c[h>>2]|0)+28>>2]=m;if(!(c[(c[h>>2]|0)+28>>2]|0)){MN(c[f>>2]|0,189568);c[e>>2]=c[h>>2];o=c[e>>2]|0;i=d;return o|0}}else if((c[(c[h>>2]|0)+12>>2]|0)<(c[l>>2]|0)){c[n>>2]=Hb[c[135760>>2]&511](c[(c[h>>2]|0)+28>>2]|0,c[l>>2]<<2)|0;if(c[n>>2]|0){c[(c[h>>2]|0)+28>>2]=c[n>>2];c[(c[h>>2]|0)+12>>2]=c[l>>2];break}MN(c[f>>2]|0,189568);c[e>>2]=c[h>>2];o=c[e>>2]|0;i=d;return o|0}while(0);c[(c[h>>2]|0)+8>>2]=c[l>>2];if((c[l>>2]|0)<20){eU(c[(c[h>>2]|0)+28>>2]|0,k|0,c[l>>2]<<2|0)|0;break}c[j>>2]=c[(c[g>>2]|0)+44>>2];c[l>>2]=0;while(1){if(!(c[j>>2]|0))break b;m=c[j>>2]|0;p=c[l>>2]|0;c[l>>2]=p+1;c[(c[(c[h>>2]|0)+28>>2]|0)+(p<<2)>>2]=m;c[j>>2]=c[(c[j>>2]|0)+24>>2]}}while(0);c[(c[h>>2]|0)+16>>2]=c[(c[h>>2]|0)+8>>2];c[e>>2]=c[h>>2];o=c[e>>2]|0;i=d;return o|0}function KN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+48|0;e=d;f=d+44|0;g=d+40|0;h=d+36|0;j=d+32|0;k=d+28|0;l=d+24|0;m=d+20|0;n=d+16|0;o=d+12|0;p=d+8|0;c[g>>2]=a;c[h>>2]=b;if((c[(c[g>>2]|0)+60>>2]|0)!=0?(c[(c[g>>2]|0)+64>>2]|0)!=0:0){b=c[33976]|0;a=c[33980]|0;c[e>>2]=189496;c[e+4>>2]=10608;Db[b&511](a,189464,e);LN(c[g>>2]|0,c[(c[g>>2]|0)+60>>2]|0);c[(c[g>>2]|0)+60>>2]=0}if((c[(c[g>>2]|0)+64>>2]|0)!=0?(c[c[(c[g>>2]|0)+64>>2]>>2]|0)!=1:0){c[j>>2]=c[(c[g>>2]|0)+64>>2];c[(c[g>>2]|0)+64>>2]=0;c[k>>2]=0;c[m>>2]=0;c[p>>2]=c[(c[g>>2]|0)+28>>2];a=(c[g>>2]|0)+28|0;c[a>>2]=c[a>>2]|1;c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[c[j>>2]>>2]|0))break;c[(c[g>>2]|0)+60>>2]=c[(c[(c[j>>2]|0)+8>>2]|0)+(c[l>>2]<<2)>>2];c[(c[g>>2]|0)+64>>2]=0;c[o>>2]=kO(c[g>>2]|0,c[h>>2]|0)|0;if((c[(c[g>>2]|0)+60>>2]|0)!=0?(c[(c[g>>2]|0)+64>>2]|0)!=0:0){a=c[33976]|0;b=c[33980]|0;c[e>>2]=189496;c[e+4>>2]=10645;Db[a&511](b,189464,e);LN(c[g>>2]|0,c[(c[g>>2]|0)+60>>2]|0);c[(c[g>>2]|0)+60>>2]=0}b=c[g>>2]|0;a:do if(c[o>>2]|0){a=c[g>>2]|0;if(c[b+60>>2]|0){LN(a,c[(c[g>>2]|0)+60>>2]|0);c[(c[g>>2]|0)+60>>2]=0;break}if(c[a+64>>2]|0){c[n>>2]=0;while(1){q=c[g>>2]|0;if((c[n>>2]|0)>=(c[c[(c[g>>2]|0)+64>>2]>>2]|0))break;LN(q,c[(c[(c[(c[g>>2]|0)+64>>2]|0)+8>>2]|0)+(c[n>>2]<<2)>>2]|0);c[n>>2]=(c[n>>2]|0)+1}NN(q,c[(c[g>>2]|0)+64>>2]|0);c[(c[g>>2]|0)+64>>2]=0}}else{a=c[k>>2]|0;if(!(c[b+64>>2]|0)){r=c[g>>2]|0;if(a){lO(r,c[k>>2]|0,c[(c[g>>2]|0)+60>>2]|0)|0;c[(c[g>>2]|0)+60>>2]=0;break}else{s=c[r+60>>2]|0;r=c[m>>2]|0;c[m>>2]=r+1;c[(c[(c[j>>2]|0)+8>>2]|0)+(r<<2)>>2]=s;c[(c[g>>2]|0)+60>>2]=0;break}}if(!a){c[k>>2]=c[(c[g>>2]|0)+64>>2];c[(c[g>>2]|0)+64>>2]=0;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[m>>2]|0))break a;lO(c[g>>2]|0,c[k>>2]|0,c[(c[(c[j>>2]|0)+8>>2]|0)+(c[n>>2]<<2)>>2]|0)|0;c[n>>2]=(c[n>>2]|0)+1}}c[n>>2]=0;while(1){t=c[g>>2]|0;if((c[n>>2]|0)>=(c[c[(c[g>>2]|0)+64>>2]>>2]|0))break;lO(t,c[k>>2]|0,c[(c[(c[(c[g>>2]|0)+64>>2]|0)+8>>2]|0)+(c[n>>2]<<2)>>2]|0)|0;c[n>>2]=(c[n>>2]|0)+1}NN(t,c[(c[g>>2]|0)+64>>2]|0);c[(c[g>>2]|0)+64>>2]=0}while(0);c[l>>2]=(c[l>>2]|0)+1}c[(c[g>>2]|0)+28>>2]=c[p>>2];do if(!(c[k>>2]|0)){p=c[m>>2]|0;if((c[m>>2]|0)>1){c[c[j>>2]>>2]=p;c[(c[g>>2]|0)+64>>2]=c[j>>2];c[o>>2]=0;break}if((p|0)==1){c[(c[g>>2]|0)+60>>2]=c[c[(c[j>>2]|0)+8>>2]>>2];NN(c[g>>2]|0,c[j>>2]|0);c[o>>2]=0;break}c[o>>2]=-1;NN(c[g>>2]|0,c[j>>2]|0);if(c[(c[g>>2]|0)+64>>2]|0){NN(c[g>>2]|0,c[(c[g>>2]|0)+64>>2]|0);c[(c[g>>2]|0)+64>>2]=0}}else{NN(c[g>>2]|0,c[j>>2]|0);c[(c[g>>2]|0)+64>>2]=c[k>>2];c[o>>2]=0}while(0);if((c[(c[g>>2]|0)+60>>2]|0)!=0?(c[(c[g>>2]|0)+64>>2]|0)!=0:0){k=c[33976]|0;j=c[33980]|0;c[e>>2]=189496;c[e+4>>2]=10711;Db[k&511](j,189464,e);LN(c[g>>2]|0,c[(c[g>>2]|0)+60>>2]|0);c[(c[g>>2]|0)+60>>2]=0}c[f>>2]=c[o>>2];u=c[f>>2]|0;i=d;return u|0}if(c[(c[g>>2]|0)+64>>2]|0){c[(c[g>>2]|0)+60>>2]=c[c[(c[(c[g>>2]|0)+64>>2]|0)+8>>2]>>2];NN(c[g>>2]|0,c[(c[g>>2]|0)+64>>2]|0);c[(c[g>>2]|0)+64>>2]=0}c[o>>2]=kO(c[g>>2]|0,c[h>>2]|0)|0;if((c[(c[g>>2]|0)+60>>2]|0)!=0?(c[(c[g>>2]|0)+64>>2]|0)!=0:0){h=c[33976]|0;j=c[33980]|0;c[e>>2]=189496;c[e+4>>2]=10620;Db[h&511](j,189464,e);LN(c[g>>2]|0,c[(c[g>>2]|0)+60>>2]|0);c[(c[g>>2]|0)+60>>2]=0}if((c[(c[g>>2]|0)+64>>2]|0)!=0?(c[c[(c[g>>2]|0)+64>>2]>>2]|0)==1:0){c[(c[g>>2]|0)+60>>2]=c[c[(c[(c[g>>2]|0)+64>>2]|0)+8>>2]>>2];NN(c[g>>2]|0,c[(c[g>>2]|0)+64>>2]|0);c[(c[g>>2]|0)+64>>2]=0}c[f>>2]=c[o>>2];u=c[f>>2]|0;i=d;return u|0}function LN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if(!(c[f>>2]|0)){i=d;return}if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+68>>2]|0)==0:0){b=mO(c[e>>2]|0,40)|0;c[(c[e>>2]|0)+68>>2]=b}if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+68>>2]|0)!=0:0){nO(c[e>>2]|0,c[(c[e>>2]|0)+68>>2]|0,c[f>>2]|0)|0;i=d;return}if(c[(c[f>>2]|0)+28>>2]|0)zb[c[135736>>2]&511](c[(c[f>>2]|0)+28>>2]|0);zb[c[135736>>2]&511](c[f>>2]|0);i=d;return}function MN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;c[j>>2]=0;c[k>>2]=0;if(c[f>>2]|0){b=c[f>>2]|0;if(c[(c[f>>2]|0)+12>>2]|0)c[h>>2]=c[b+12>>2];else c[j>>2]=c[b+4>>2];c[k>>2]=c[c[f>>2]>>2];b=(c[f>>2]|0)+16|0;c[b>>2]=(c[b>>2]|0)+1}b=c[h>>2]|0;h=c[j>>2]|0;j=c[k>>2]|0;if(c[g>>2]|0){k=c[g>>2]|0;c[e>>2]=c[g>>2];Xd(b,h,j,0,0,19,2,3,0,0,k,0,0,0,0,189400,e);i=d;return}else{Xd(b,h,j,0,0,19,2,3,0,0,0,0,0,0,0,189432,e);i=d;return}}function NN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;if(!(c[f>>2]|0)){i=d;return}if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+80>>2]|0)==0:0){c[(c[e>>2]|0)+76>>2]=40;c[(c[e>>2]|0)+72>>2]=0;b=Cb[c[135744>>2]&511](c[(c[e>>2]|0)+76>>2]<<2)|0;c[(c[e>>2]|0)+80>>2]=b;if(!(c[(c[e>>2]|0)+80>>2]|0))MN(c[e>>2]|0,189384)}else h=6;do if(((h|0)==6?(c[e>>2]|0)!=0:0)?(c[(c[e>>2]|0)+72>>2]|0)>=(c[(c[e>>2]|0)+76>>2]|0):0){c[g>>2]=Hb[c[135760>>2]&511](c[(c[e>>2]|0)+80>>2]|0,c[(c[e>>2]|0)+76>>2]<<1<<2)|0;if(c[g>>2]|0){c[(c[e>>2]|0)+80>>2]=c[g>>2];b=(c[e>>2]|0)+76|0;c[b>>2]=c[b>>2]<<1;break}MN(c[e>>2]|0,189384);zb[c[135736>>2]&511](c[(c[f>>2]|0)+8>>2]|0);zb[c[135736>>2]&511](c[f>>2]|0);i=d;return}while(0);if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+80>>2]|0)!=0:0){g=c[f>>2]|0;h=(c[e>>2]|0)+72|0;b=c[h>>2]|0;c[h>>2]=b+1;c[(c[(c[e>>2]|0)+80>>2]|0)+(b<<2)>>2]=g;i=d;return}zb[c[135736>>2]&511](c[(c[f>>2]|0)+8>>2]|0);zb[c[135736>>2]&511](c[f>>2]|0);i=d;return}function ON(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+112|0;e=d+100|0;f=d+96|0;g=d+92|0;h=d+88|0;j=d+84|0;k=d+80|0;l=d+76|0;m=d+72|0;n=d+68|0;o=d+64|0;p=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)!=0?!((c[g>>2]|0)==0?1:(c[(c[f>>2]|0)+20>>2]|0)==0):0){c[(c[f>>2]|0)+40>>2]=0;c[j>>2]=c[(c[f>>2]|0)+20>>2];c[k>>2]=c[(c[j>>2]|0)+4>>2];j=c[f>>2]|0;if(!(c[k>>2]|0)){FN(j,34,0,0,0);c[e>>2]=-1;q=c[e>>2]|0;i=d;return q|0}c[l>>2]=JN(j,0)|0;c[(c[f>>2]|0)+60>>2]=c[l>>2];c[h>>2]=KN(c[f>>2]|0,c[(c[k>>2]|0)+12>>2]|0)|0;if((c[(c[f>>2]|0)+60>>2]|0)!=0?(c[(c[l>>2]|0)+4>>2]|0)!=0:0){c[l>>2]=c[(c[f>>2]|0)+60>>2];c[m>>2]=c[(c[l>>2]|0)+4>>2];c[m>>2]=oO(c[f>>2]|0,c[m>>2]|0)|0;if((c[m>>2]|0)!=0&(c[h>>2]|0)!=-1){FN(c[f>>2]|0,35,0,0,0);c[h>>2]=-1}}else r=10;if((r|0)==10?(c[(c[f>>2]|0)+64>>2]|0)!=0:0){c[o>>2]=-1;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[c[(c[f>>2]|0)+64>>2]>>2]|0))break;c[l>>2]=c[(c[(c[(c[f>>2]|0)+64>>2]|0)+8>>2]|0)+(c[n>>2]<<2)>>2];c[m>>2]=c[(c[l>>2]|0)+4>>2];c[m>>2]=oO(c[f>>2]|0,c[m>>2]|0)|0;if(!(c[m>>2]|0))c[o>>2]=0;LN(c[f>>2]|0,c[l>>2]|0);c[n>>2]=(c[n>>2]|0)+1}if((c[o>>2]|0)==-1&(c[h>>2]|0)!=-1){FN(c[f>>2]|0,35,0,0,0);c[h>>2]=-1}}if(c[(c[f>>2]|0)+60>>2]|0){LN(c[f>>2]|0,c[(c[f>>2]|0)+60>>2]|0);c[(c[f>>2]|0)+60>>2]=0}if(c[h>>2]|0)eO(c[f>>2]|0);if((c[(c[f>>2]|0)+36>>2]|0)==1){o=p+0|0;n=o+64|0;do{c[o>>2]=0;o=o+4|0}while((o|0)<(n|0));c[p+36>>2]=1;c[p+4>>2]=c[(c[f>>2]|0)+4>>2];c[p+8>>2]=c[(c[f>>2]|0)+8>>2];c[p>>2]=c[c[f>>2]>>2];if((cn(p,c[g>>2]|0)|0)!=1)c[h>>2]=-1}if((c[h>>2]|0)==0?(c[(c[f>>2]|0)+40>>2]|0)!=0:0)c[h>>2]=-1;c[e>>2]=c[h>>2];q=c[e>>2]|0;i=d;return q|0}c[e>>2]=-1;q=c[e>>2]|0;i=d;return q|0}function PN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(((c[(c[d>>2]|0)+4>>2]|0)!=1?(c[(c[d>>2]|0)+4>>2]|0)!=9:0)?(c[(c[d>>2]|0)+4>>2]|0)!=13:0){i=b;return}if((c[(c[d>>2]|0)+4>>2]|0)==1)c[(c[d>>2]|0)+52>>2]=0;c[e>>2]=c[(c[d>>2]|0)+12>>2];a:while(1){if(!(c[e>>2]|0))break;if((c[(c[e>>2]|0)+4>>2]|0)==1?(c[(c[e>>2]|0)+52>>2]=0,(c[(c[e>>2]|0)+12>>2]|0)!=0):0){c[e>>2]=c[(c[e>>2]|0)+12>>2];continue}if(c[(c[e>>2]|0)+24>>2]|0){c[e>>2]=c[(c[e>>2]|0)+24>>2];continue}while(1){c[e>>2]=c[(c[e>>2]|0)+20>>2];if(!(c[e>>2]|0))continue a;if((c[e>>2]|0)==(c[d>>2]|0)){f=16;break}g=c[e>>2]|0;if(c[(c[e>>2]|0)+24>>2]|0){f=18;break}if(!g)continue a}if((f|0)==16){f=0;c[e>>2]=0;continue}else if((f|0)==18){f=0;c[e>>2]=c[g+24>>2];continue}}i=b;return}function QN(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+4>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+4>>2]|0);if(c[(c[d>>2]|0)+8>>2]|0)Th(c[(c[d>>2]|0)+8>>2]|0);if(c[(c[d>>2]|0)+16>>2]|0)VM(c[(c[d>>2]|0)+16>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function RN(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+12>>2]|0){c[f>>2]=0;while(1){if((c[f>>2]|0)>=(c[c[d>>2]>>2]|0))break;c[e>>2]=c[(c[(c[d>>2]|0)+12>>2]|0)+(c[f>>2]<<2)>>2];if(c[e>>2]|0){if(c[(c[e>>2]|0)+4>>2]|0)zb[c[135736>>2]&511](c[(c[e>>2]|0)+4>>2]|0);if(c[(c[e>>2]|0)+8>>2]|0)zb[c[135736>>2]&511](c[(c[e>>2]|0)+8>>2]|0);zb[c[135736>>2]&511](c[e>>2]|0)}c[f>>2]=(c[f>>2]|0)+1}zb[c[135736>>2]&511](c[(c[d>>2]|0)+12>>2]|0)}if(c[(c[d>>2]|0)+4>>2]|0)Kj(c[(c[d>>2]|0)+4>>2]|0,0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function SN(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f;c[h>>2]=b;c[j>>2]=e;if(!(c[j>>2]|0)){c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}c[m>>2]=c[j>>2];while(1){p=c[m>>2]|0;if(!(d[c[m>>2]>>0]|0))break;c[m>>2]=p+1}c[n>>2]=p-(c[j>>2]|0);c[k>>2]=Cb[c[135752>>2]&511]((c[n>>2]|0)+1|0)|0;if(!(c[k>>2]|0)){MN(c[h>>2]|0,189544);c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}c[l>>2]=c[k>>2];a:while(1){do if((d[c[j>>2]>>0]|0|0)!=32){if(9<=(d[c[j>>2]>>0]|0|0)?(d[c[j>>2]>>0]|0|0)<=10:0)break;if((d[c[j>>2]>>0]|0|0)!=13)break a}while(0);c[j>>2]=(c[j>>2]|0)+1}b:while(1){if(!(d[c[j>>2]>>0]|0))break;do if((d[c[j>>2]>>0]|0|0)!=32){if(9<=(d[c[j>>2]>>0]|0|0)?(d[c[j>>2]>>0]|0|0)<=10:0)break;if((d[c[j>>2]>>0]|0|0)!=13){h=c[j>>2]|0;c[j>>2]=h+1;n=a[h>>0]|0;h=c[l>>2]|0;c[l>>2]=h+1;a[h>>0]=n;continue b}}while(0);while(1){do if((d[c[j>>2]>>0]|0|0)==32)q=1;else{if(9<=(d[c[j>>2]>>0]|0|0)?(d[c[j>>2]>>0]|0|0)<=10:0){q=1;break}q=(d[c[j>>2]>>0]|0|0)==13}while(0);r=c[j>>2]|0;if(!q)break;c[j>>2]=r+1}if(!(d[r>>0]|0))break;n=c[l>>2]|0;c[l>>2]=n+1;a[n>>0]=32}a[c[l>>2]>>0]=0;c[g>>2]=c[k>>2];o=c[g>>2]|0;i=f;return o|0}function TN(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+8>>2]|0)Th(c[(c[d>>2]|0)+8>>2]|0);if(c[(c[d>>2]|0)+36>>2]|0){c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[(c[d>>2]|0)+32>>2]|0))break;mN(c[(c[(c[d>>2]|0)+36>>2]|0)+(c[e>>2]<<2)>>2]|0);c[e>>2]=(c[e>>2]|0)+1}zb[c[135736>>2]&511](c[(c[d>>2]|0)+36>>2]|0)}zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function UN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+144|0;e=d+128|0;f=d+124|0;g=d+120|0;h=d+116|0;j=d+112|0;k=d+108|0;l=d+104|0;m=d+100|0;n=d+96|0;o=d+92|0;p=d+88|0;q=d+84|0;r=d+80|0;s=d+76|0;t=d+72|0;u=d+68|0;v=d+64|0;w=d+60|0;x=d+56|0;y=d+52|0;z=d+48|0;A=d+44|0;B=d+40|0;C=d+36|0;D=d+32|0;E=d+28|0;F=d+24|0;G=d+20|0;H=d+16|0;I=d+12|0;J=d+8|0;K=d+4|0;L=d;c[e>>2]=a;c[f>>2]=b;c[h>>2]=0;c[g>>2]=c[f>>2];a:while(1){M=(c[h>>2]|0)!=0;if(!(c[g>>2]|0))break;if(M){Qh(c[h>>2]|0);Rh(c[h>>2]|0);c[h>>2]=0}b=c[g>>2]|0;b:do if((c[(c[g>>2]|0)+4>>2]|0)!=1){if((c[b+4>>2]|0)!=3?(c[(c[g>>2]|0)+4>>2]|0)!=4:0){c[h>>2]=c[g>>2];break}if(sO(c[(c[g>>2]|0)+40>>2]|0)|0){if((c[(c[g>>2]|0)+20>>2]|0)!=0?(c[(c[(c[g>>2]|0)+20>>2]|0)+4>>2]|0)==1:0){if(qy(c[(c[(c[g>>2]|0)+20>>2]|0)+8>>2]|0,189888)|0){N=158;break}if(qy(c[(c[(c[g>>2]|0)+20>>2]|0)+8>>2]|0,190064)|0){N=158;break}c[h>>2]=c[g>>2];N=158;break}c[h>>2]=c[g>>2]}else N=158}else{if((c[b+36>>2]|0)!=0?(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0){pO(c[e>>2]|0,c[g>>2]|0);a=(qy(c[(c[g>>2]|0)+8>>2]|0,189936)|0)!=0;O=c[g>>2]|0;c:do if(a){c[k>>2]=Yi(O,192672)|0;d:do if(!(c[k>>2]|0)){c[o>>2]=c[(c[g>>2]|0)+20>>2];while(1){if(!(c[o>>2]|0))break d;if((c[(c[o>>2]|0)+4>>2]|0)!=1)break d;c[k>>2]=Yi(c[o>>2]|0,192672)|0;if(c[k>>2]|0)break d;c[o>>2]=c[(c[o>>2]|0)+20>>2]}}while(0);c[j>>2]=Yi(c[g>>2]|0,195400)|0;if(!(c[j>>2]|0)){zN(c[e>>2]|0,c[g>>2]|0,1052,195408,0,0);if(c[k>>2]|0)zb[c[135736>>2]&511](c[k>>2]|0);c[h>>2]=c[g>>2];break b}c[p>>2]=yl(c[j>>2]|0)|0;if(!(c[p>>2]|0)){zN(c[e>>2]|0,c[g>>2]|0,1041,195464,c[j>>2]|0,0);if(c[k>>2]|0)zb[c[135736>>2]&511](c[k>>2]|0);if(c[j>>2]|0)zb[c[135736>>2]&511](c[j>>2]|0);c[h>>2]=c[g>>2];break b}if(c[(c[p>>2]|0)+32>>2]|0){zN(c[e>>2]|0,c[g>>2]|0,1041,195504,c[j>>2]|0,0);if(c[k>>2]|0)zb[c[135736>>2]&511](c[k>>2]|0);Al(c[p>>2]|0);if(c[j>>2]|0)zb[c[135736>>2]&511](c[j>>2]|0);c[h>>2]=c[g>>2];break b}Al(c[p>>2]|0);c[l>>2]=Xi(c[(c[g>>2]|0)+32>>2]|0,c[g>>2]|0)|0;c[m>>2]=Hl(c[j>>2]|0,c[l>>2]|0)|0;if(!(c[m>>2]|0)){zN(c[e>>2]|0,c[g>>2]|0,1041,195552,c[j>>2]|0,0);if(c[k>>2]|0)zb[c[135736>>2]&511](c[k>>2]|0);if(c[j>>2]|0)zb[c[135736>>2]&511](c[j>>2]|0);if(c[l>>2]|0)zb[c[135736>>2]&511](c[l>>2]|0);c[h>>2]=c[g>>2];break b}if(c[j>>2]|0)zb[c[135736>>2]&511](c[j>>2]|0);if(c[l>>2]|0)zb[c[135736>>2]&511](c[l>>2]|0);c[n>>2]=qO(c[e>>2]|0,c[m>>2]|0,c[k>>2]|0)|0;if(!(c[n>>2]|0)){zN(c[e>>2]|0,c[g>>2]|0,1032,195600,c[m>>2]|0,0);if(c[k>>2]|0)zb[c[135736>>2]&511](c[k>>2]|0);zb[c[135736>>2]&511](c[m>>2]|0);c[h>>2]=c[g>>2];break b}else{if(c[k>>2]|0)zb[c[135736>>2]&511](c[k>>2]|0);zb[c[135736>>2]&511](c[m>>2]|0);c[(c[g>>2]|0)+52>>2]=c[n>>2];break}}else{P=(qy(c[O+8>>2]|0,195024)|0)!=0;Q=c[g>>2]|0;if(P){c[q>>2]=Yi(Q,195400)|0;if(!(c[q>>2]|0)){zN(c[e>>2]|0,c[g>>2]|0,1052,195632,0,0);c[h>>2]=c[g>>2];break b}c[s>>2]=Xi(c[(c[g>>2]|0)+32>>2]|0,c[g>>2]|0)|0;c[t>>2]=Hl(c[q>>2]|0,c[s>>2]|0)|0;if(!(c[t>>2]|0)){zN(c[e>>2]|0,c[g>>2]|0,1041,195680,c[q>>2]|0,0);if(c[q>>2]|0)zb[c[135736>>2]&511](c[q>>2]|0);if(c[s>>2]|0)zb[c[135736>>2]&511](c[s>>2]|0);c[h>>2]=c[g>>2];break b}if(c[q>>2]|0)zb[c[135736>>2]&511](c[q>>2]|0);if(c[s>>2]|0)zb[c[135736>>2]&511](c[s>>2]|0);c[r>>2]=Yi(c[g>>2]|0,192672)|0;e:do if(!(c[r>>2]|0)){c[v>>2]=c[(c[g>>2]|0)+20>>2];while(1){if(!(c[v>>2]|0))break e;if((c[(c[v>>2]|0)+4>>2]|0)!=1)break e;c[r>>2]=Yi(c[v>>2]|0,192672)|0;if(c[r>>2]|0)break e;c[v>>2]=c[(c[v>>2]|0)+20>>2]}}while(0);c[u>>2]=rO(c[e>>2]|0,c[t>>2]|0,c[g>>2]|0,c[r>>2]|0)|0;if(c[r>>2]|0)zb[c[135736>>2]&511](c[r>>2]|0);if(!(c[u>>2]|0)){zN(c[e>>2]|0,c[g>>2]|0,1043,195720,c[t>>2]|0,0);zb[c[135736>>2]&511](c[t>>2]|0);c[h>>2]=c[g>>2];break b}else{zb[c[135736>>2]&511](c[t>>2]|0);c[(c[g>>2]|0)+52>>2]=c[u>>2];break}}if((qy(c[Q+8>>2]|0,189864)|0)==0?(qy(c[(c[g>>2]|0)+8>>2]|0,189904)|0)==0:0){if(((qy(c[(c[g>>2]|0)+8>>2]|0,192176)|0)==0?(qy(c[(c[g>>2]|0)+8>>2]|0,193592)|0)==0:0)?(qy(c[(c[g>>2]|0)+8>>2]|0,189888)|0)==0:0){do if(qy(c[(c[g>>2]|0)+8>>2]|0,189848)|0){if((c[g>>2]|0)==(c[f>>2]|0))break;c[G>>2]=c[(c[e>>2]|0)+32>>2];do if(c[(c[g>>2]|0)+20>>2]|0){if(!(qy(c[(c[(c[g>>2]|0)+20>>2]|0)+8>>2]|0,193584)|0))break;P=(c[e>>2]|0)+32|0;c[P>>2]=c[P>>2]|256;UN(c[e>>2]|0,c[g>>2]|0);c[(c[e>>2]|0)+32>>2]=c[G>>2];break b}while(0);if(!(c[(c[g>>2]|0)+20>>2]|0))break c;if(!(qy(c[(c[(c[g>>2]|0)+20>>2]|0)+8>>2]|0,193592)|0))break c;P=(c[e>>2]|0)+32|0;c[P>>2]=c[P>>2]|512;UN(c[e>>2]|0,c[g>>2]|0);c[(c[e>>2]|0)+32>>2]=c[G>>2];break b}while(0);if(!(qy(c[(c[g>>2]|0)+8>>2]|0,193584)|0))break;Q=c[e>>2]|0;if(c[(c[e>>2]|0)+32>>2]&256){zN(Q,c[g>>2]|0,1066,195896,0,0);break}if(!(c[Q+32>>2]&512))break;zN(c[e>>2]|0,c[g>>2]|0,1084,195952,0,0);break}do if(!(dj(c[g>>2]|0,192672)|0)){c[B>>2]=0;c[A>>2]=c[(c[g>>2]|0)+20>>2];while(1){if(!(c[A>>2]|0))break;if((c[(c[A>>2]|0)+4>>2]|0)!=1)break;c[B>>2]=Yi(c[A>>2]|0,192672)|0;if(c[B>>2]|0)break;c[A>>2]=c[(c[A>>2]|0)+20>>2]}Q=c[g>>2]|0;if(!(c[B>>2]|0)){gj(Q,192672,188112)|0;break}else{gj(Q,192672,c[B>>2]|0)|0;zb[c[135736>>2]&511](c[B>>2]|0);break}}while(0);if((qy(c[(c[g>>2]|0)+8>>2]|0,192176)|0)!=0?(c[C>>2]=_i(c[g>>2]|0)|0,(c[C>>2]|0)!=0):0){c[D>>2]=Ch(c[C>>2]|0,E)|0;if(c[D>>2]|0){c[F>>2]=cj(c[(c[g>>2]|0)+32>>2]|0,c[g>>2]|0,c[E>>2]|0)|0;if(!(c[F>>2]|0))zN(c[e>>2]|0,c[g>>2]|0,1097,195792,c[E>>2]|0,0);else{gj(c[g>>2]|0,192672,c[(c[F>>2]|0)+8>>2]|0)|0;vi(c[g>>2]|0,c[D>>2]|0)}zb[c[135736>>2]&511](c[D>>2]|0);zb[c[135736>>2]&511](c[E>>2]|0)}zb[c[135736>>2]&511](c[C>>2]|0)}if(!(qy(c[(c[g>>2]|0)+8>>2]|0,193592)|0))break;if(!(c[(c[e>>2]|0)+32>>2]&512))break;zN(c[e>>2]|0,c[g>>2]|0,1085,195840,0,0);break}c[y>>2]=0;c[w>>2]=Yi(c[g>>2]|0,192176)|0;if(c[w>>2]|0){Q=c[g>>2]|0;if(c[(c[g>>2]|0)+12>>2]|0){c[z>>2]=ji(c[Q+32>>2]|0,c[(c[g>>2]|0)+36>>2]|0,192176,0)|0;if(c[z>>2]|0){wi(c[(c[g>>2]|0)+12>>2]|0,c[z>>2]|0)|0;c[y>>2]=li(c[w>>2]|0)|0;zi(c[z>>2]|0,c[y>>2]|0)|0;c[y>>2]=c[z>>2]}}else c[y>>2]=ti(Q,c[(c[g>>2]|0)+36>>2]|0,192176,c[w>>2]|0)|0;if(!(c[y>>2]|0))zN(c[e>>2]|0,c[g>>2]|0,1008,195752,c[w>>2]|0,0);fj(c[g>>2]|0,192176)|0;zb[c[135736>>2]&511](c[w>>2]|0);c[x>>2]=Yi(c[g>>2]|0,192672)|0;if(!(c[x>>2]|0)){if(!(qy(c[(c[g>>2]|0)+8>>2]|0,189904)|0))break;gj(c[y>>2]|0,192672,188112)|0;break}if(c[y>>2]|0)gj(c[y>>2]|0,192672,c[x>>2]|0)|0;zb[c[135736>>2]&511](c[x>>2]|0)}}while(0);if(!(qy(c[(c[g>>2]|0)+8>>2]|0,196008)|0)){N=158;break}c[H>>2]=Yi(c[g>>2]|0,192672)|0;c[I>>2]=c[(c[g>>2]|0)+12>>2];c[J>>2]=c[g>>2];while(1){R=(c[H>>2]|0)!=0;if(!(c[I>>2]|0))break;if(R?(dj(c[I>>2]|0,192672)|0)==0:0)gj(c[I>>2]|0,192672,c[H>>2]|0)|0;c[K>>2]=c[(c[I>>2]|0)+24>>2];Qh(c[I>>2]|0);c[J>>2]=Xh(c[J>>2]|0,c[I>>2]|0)|0;c[I>>2]=c[K>>2]}if(R)zb[c[135736>>2]&511](c[H>>2]|0);if((c[(c[g>>2]|0)+48>>2]|0)!=0?(c[(c[g>>2]|0)+20>>2]|0)!=0:0){c[L>>2]=(c[(c[g>>2]|0)+20>>2]|0)+48;while(1){if(!(c[c[L>>2]>>2]|0))break;c[L>>2]=c[c[L>>2]>>2]}c[c[L>>2]>>2]=c[(c[g>>2]|0)+48>>2];c[(c[g>>2]|0)+48>>2]=0}c[h>>2]=c[g>>2];break}do if((c[(c[g>>2]|0)+20>>2]|0)!=0?(c[(c[(c[g>>2]|0)+20>>2]|0)+4>>2]|0)==1:0){if(((qy(c[(c[(c[g>>2]|0)+20>>2]|0)+8>>2]|0,192176)|0)==0?(qy(c[(c[(c[g>>2]|0)+20>>2]|0)+8>>2]|0,189888)|0)==0:0)?(qy(c[(c[(c[g>>2]|0)+20>>2]|0)+8>>2]|0,190064)|0)==0:0)break;zN(c[e>>2]|0,c[g>>2]|0,1035,195352,c[(c[(c[g>>2]|0)+20>>2]|0)+8>>2]|0,0)}while(0);c[h>>2]=c[g>>2]}while(0);if(((((N|0)==158?(N=0,(c[(c[g>>2]|0)+12>>2]|0)!=0):0)?(c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]|0)!=17:0)?(c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]|0)!=5:0)?(c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]|0)!=6:0){c[g>>2]=c[(c[g>>2]|0)+12>>2];continue}if(c[(c[g>>2]|0)+24>>2]|0){c[g>>2]=c[(c[g>>2]|0)+24>>2];continue}while(1){c[g>>2]=c[(c[g>>2]|0)+20>>2];if(!(c[g>>2]|0))continue a;if((c[g>>2]|0)==(c[f>>2]|0)){N=167;break}S=c[g>>2]|0;if(c[(c[g>>2]|0)+24>>2]|0){N=169;break}if(!S)continue a}if((N|0)==167){N=0;c[g>>2]=0;continue}else if((N|0)==169){N=0;c[g>>2]=c[S+24>>2];continue}}if(!M){i=d;return}Qh(c[h>>2]|0);Rh(c[h>>2]|0);c[h>>2]=0;i=d;return}function VN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](40)|0;if(!(c[f>>2]|0)){xN(c[e>>2]|0,0);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{e=(c[f>>2]|0)+0|0;a=e+40|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(a|0));c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function WN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=XN(c[f>>2]|0)|0;if(!(c[h>>2]|0)){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}c[c[h>>2]>>2]=c[(c[f>>2]|0)+24>>2];do if(c[(c[f>>2]|0)+24>>2]|0){c[j>>2]=c[(c[(c[f>>2]|0)+24>>2]|0)+4>>2];if(!(c[j>>2]|0)){c[(c[(c[f>>2]|0)+24>>2]|0)+4>>2]=c[h>>2];break}while(1){if(!(c[(c[j>>2]|0)+8>>2]|0))break;c[j>>2]=c[(c[j>>2]|0)+8>>2]}c[(c[j>>2]|0)+8>>2]=c[h>>2]}while(0);c[k>>2]=c[(c[f>>2]|0)+24>>2];c[(c[f>>2]|0)+24>>2]=c[h>>2];tO(c[f>>2]|0,c[g>>2]|0)|0;c[(c[f>>2]|0)+24>>2]=c[h>>2];j=c[f>>2]|0;if(c[(c[f>>2]|0)+24>>2]|0){if(!(c[(c[j+24>>2]|0)+12>>2]|0))zN(c[f>>2]|0,c[g>>2]|0,1039,194360,0,0)}else zN(j,c[g>>2]|0,1036,194320,0,0);uO(c[f>>2]|0,c[h>>2]|0);if(c[(c[h>>2]|0)+24>>2]|0)Wj(c[(c[h>>2]|0)+24>>2]|0,383,c[f>>2]|0);if(c[(c[h>>2]|0)+28>>2]|0)Wj(c[(c[h>>2]|0)+28>>2]|0,384,c[f>>2]|0);c[(c[f>>2]|0)+24>>2]=c[k>>2];c[e>>2]=c[h>>2];l=c[e>>2]|0;i=d;return l|0}function XN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](32)|0;if(!(c[f>>2]|0)){xN(c[e>>2]|0,0);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{e=c[f>>2]|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;c[e+24>>2]=0;c[e+28>>2]=0;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function YN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;c[j>>2]=0;if(!(c[g>>2]|0)){zN(c[f>>2]|0,c[g>>2]|0,1106,191968,0,0);c[e>>2]=-1;l=c[e>>2]|0;i=d;return l|0}do if(((((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+36>>2]|0)!=0:0)?(c[(c[g>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[g>>2]|0)+8>>2]|0,189824)|0)!=0:0)?(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0){c[j>>2]=DN(c[f>>2]|0,c[g>>2]|0)|0;if(!(c[j>>2]|0)){c[e>>2]=-1;l=c[e>>2]|0;i=d;return l|0}else{c[c[j>>2]>>2]=0;if(!(c[(c[g>>2]|0)+12>>2]|0))break;zN(c[f>>2]|0,c[g>>2]|0,1024,191992,0,0);break}}else m=12;while(0);do if((m|0)==12){if(((((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+36>>2]|0)!=0:0)?(c[(c[g>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[g>>2]|0)+8>>2]|0,189832)|0)!=0:0)?(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0){c[j>>2]=DN(c[f>>2]|0,c[g>>2]|0)|0;if(!(c[j>>2]|0)){c[e>>2]=-1;l=c[e>>2]|0;i=d;return l|0}else{c[c[j>>2]>>2]=1;if(!(c[(c[g>>2]|0)+12>>2]|0))break;zN(c[f>>2]|0,c[g>>2]|0,1055,192024,0,0);break}}c[j>>2]=xO(c[f>>2]|0,c[g>>2]|0,1)|0}while(0);if(c[(c[(c[f>>2]|0)+24>>2]|0)+12>>2]|0){c[k>>2]=c[(c[(c[f>>2]|0)+24>>2]|0)+12>>2];while(1){if(!(c[(c[k>>2]|0)+32>>2]|0))break;c[k>>2]=c[(c[k>>2]|0)+32>>2]}c[(c[k>>2]|0)+32>>2]=c[j>>2]}else c[(c[(c[f>>2]|0)+24>>2]|0)+12>>2]=c[j>>2];c[g>>2]=c[(c[g>>2]|0)+24>>2];if(c[g>>2]|0){zN(c[f>>2]|0,c[g>>2]|0,1105,192064,0,0);c[e>>2]=-1;l=c[e>>2]|0;i=d;return l|0}else{c[e>>2]=c[h>>2];l=c[e>>2]|0;i=d;return l|0}return 0}function ZN(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[h>>2]=a;c[j>>2]=d;c[k>>2]=e;c[l>>2]=0;a:while(1){if(!((c[l>>2]|0)==0&(c[j>>2]|0)!=0)){m=13;break}do if((c[c[j>>2]>>2]|0)!=11?(c[c[j>>2]>>2]|0)!=13:0){e=c[h>>2]|0;d=c[(c[j>>2]|0)+24>>2]|0;a=c[k>>2]|0;if((c[c[j>>2]>>2]|0)==4){c[l>>2]=ZN(e,d,a+1|0)|0;break}else{c[l>>2]=ZN(e,d,a)|0;break}}else m=5;while(0);do if((m|0)==5){m=0;a=c[k>>2]|0;if((b[(c[j>>2]|0)+48>>1]|0)!=-1)if((a|0)==(b[(c[j>>2]|0)+48>>1]|0)){m=8;break a}else break;else{b[(c[j>>2]|0)+48>>1]=a;c[l>>2]=ZN(c[h>>2]|0,c[(c[j>>2]|0)+24>>2]|0,c[k>>2]|0)|0;b[(c[j>>2]|0)+48>>1]=-2;break}}while(0);c[j>>2]=c[(c[j>>2]|0)+32>>2]}if((m|0)==8){zN(c[h>>2]|0,c[(c[j>>2]|0)+4>>2]|0,1099,191928,c[(c[j>>2]|0)+8>>2]|0,0);c[g>>2]=-1;n=c[g>>2]|0;i=f;return n|0}else if((m|0)==13){c[g>>2]=c[l>>2];n=c[g>>2]|0;i=f;return n|0}return 0}function _N(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f;c[g>>2]=a;c[h>>2]=d;c[j>>2]=e;c[k>>2]=0;a:while(1){if(!(c[h>>2]|0)){o=87;break}b:do if((c[c[h>>2]>>2]|0)!=11?(c[c[h>>2]>>2]|0)!=13:0){if((c[c[h>>2]>>2]|0)==1){c[(c[h>>2]|0)+28>>2]=c[j>>2];if(c[j>>2]|0){if((c[c[j>>2]>>2]|0)==9){o=15;break a}if((c[c[j>>2]>>2]|0)==8){o=15;break a}if((c[c[j>>2]>>2]|0)==18){o=15;break a}if((c[c[j>>2]>>2]|0)==19){o=15;break a}if((c[c[j>>2]>>2]|0)==16){o=15;break a}if((c[c[j>>2]>>2]|0)==15){o=15;break a}}if((c[j>>2]|0)!=0?(c[c[j>>2]>>2]|0)==17:0){c[k>>2]=yO(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0)|0;break}c[k>>2]=c[h>>2];break}e=(c[c[h>>2]>>2]|0)==0;c[(c[h>>2]|0)+28>>2]=c[j>>2];if(e){if(c[j>>2]|0){if((c[c[j>>2]>>2]|0)==16){o=24;break a}if((c[c[j>>2]>>2]|0)==15){o=24;break a}}do if(c[j>>2]|0){if((c[c[j>>2]>>2]|0)!=18?(c[c[j>>2]>>2]|0)!=19:0)break;c[k>>2]=yO(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0)|0;break b}while(0);c[k>>2]=c[h>>2];break}if(c[(c[h>>2]|0)+24>>2]|0)_N(c[g>>2]|0,c[(c[h>>2]|0)+24>>2]|0,c[h>>2]|0);if((c[c[h>>2]>>2]|0)!=7?(c[(c[h>>2]|0)+36>>2]|0)!=0:0)_N(c[g>>2]|0,c[(c[h>>2]|0)+36>>2]|0,c[h>>2]|0);if(c[(c[h>>2]|0)+40>>2]|0)_N(c[g>>2]|0,c[(c[h>>2]|0)+40>>2]|0,c[h>>2]|0);c:do if((c[c[h>>2]>>2]|0)==4){while(1){if(!(c[(c[h>>2]|0)+24>>2]|0))break;c[l>>2]=zO(c[g>>2]|0,c[(c[h>>2]|0)+24>>2]|0)|0;if((c[l>>2]|0)!=1)break;c[m>>2]=c[(c[h>>2]|0)+24>>2];c[(c[h>>2]|0)+24>>2]=c[(c[m>>2]|0)+32>>2];c[(c[m>>2]|0)+32>>2]=c[(c[h>>2]|0)+36>>2];c[(c[h>>2]|0)+36>>2]=c[m>>2]}c[n>>2]=c[(c[h>>2]|0)+24>>2];while(1){if(!(c[n>>2]|0))break c;if(!(c[(c[n>>2]|0)+32>>2]|0))break c;c[m>>2]=c[(c[n>>2]|0)+32>>2];c[l>>2]=zO(c[g>>2]|0,c[m>>2]|0)|0;e=c[m>>2]|0;if((c[l>>2]|0)==1){c[(c[n>>2]|0)+32>>2]=c[e+32>>2];c[(c[m>>2]|0)+32>>2]=c[(c[h>>2]|0)+36>>2];c[(c[h>>2]|0)+36>>2]=c[m>>2];continue}else{c[n>>2]=e;continue}}}while(0);if(!((c[c[h>>2]>>2]|0)!=18?(c[c[h>>2]>>2]|0)!=19:0))o=49;do if((o|0)==49){o=0;e=c[h>>2]|0;if(!(c[(c[h>>2]|0)+24>>2]|0)){c[e>>2]=0;break}if(!(c[(c[e+24>>2]|0)+32>>2]|0)){if((c[j>>2]|0)==0&(c[k>>2]|0)==0){c[c[h>>2]>>2]=-1;break}e=c[h>>2]|0;if(!(c[k>>2]|0)){c[(c[j>>2]|0)+24>>2]=c[e+24>>2];c[(c[(c[h>>2]|0)+24>>2]|0)+32>>2]=c[(c[h>>2]|0)+32>>2];c[h>>2]=c[(c[h>>2]|0)+24>>2];break}else{c[(c[(c[h>>2]|0)+24>>2]|0)+32>>2]=c[e+32>>2];c[(c[k>>2]|0)+32>>2]=c[(c[h>>2]|0)+24>>2];c[h>>2]=c[(c[h>>2]|0)+24>>2];
break}}}while(0);if(((c[c[h>>2]>>2]|0)==2?(c[(c[h>>2]|0)+24>>2]|0)!=0:0)?(c[c[(c[h>>2]|0)+24>>2]>>2]|0)==1:0){c[k>>2]=yO(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0)|0;break}if((c[c[h>>2]>>2]|0)==1){if(c[j>>2]|0){if((c[c[j>>2]>>2]|0)==9){o=69;break a}if((c[c[j>>2]>>2]|0)==8){o=69;break a}if((c[c[j>>2]>>2]|0)==18){o=69;break a}if((c[c[j>>2]>>2]|0)==19){o=69;break a}if((c[c[j>>2]>>2]|0)==16){o=69;break a}if((c[c[j>>2]>>2]|0)==15){o=69;break a}}if((c[j>>2]|0)!=0?(c[c[j>>2]>>2]|0)==17:0){c[k>>2]=yO(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0)|0;break}c[k>>2]=c[h>>2];break}else{if(c[c[h>>2]>>2]|0){c[k>>2]=c[h>>2];break}if(c[j>>2]|0){if((c[c[j>>2]>>2]|0)==16){o=78;break a}if((c[c[j>>2]>>2]|0)==15){o=78;break a}}d:do if(c[j>>2]|0){do if((c[c[j>>2]>>2]|0)!=18){if((c[c[j>>2]>>2]|0)==19)break;if((c[c[j>>2]>>2]|0)!=17)break d}while(0);c[k>>2]=yO(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0)|0;break b}while(0);c[k>>2]=c[h>>2];break}}else o=5;while(0);if((o|0)==5?(o=0,(b[(c[h>>2]|0)+48>>1]|0)!=-3):0){b[(c[h>>2]|0)+48>>1]=-3;_N(c[g>>2]|0,c[(c[h>>2]|0)+24>>2]|0,c[h>>2]|0)}c[h>>2]=c[(c[h>>2]|0)+32>>2]}if((o|0)==15){c[c[j>>2]>>2]=1;i=f;return}else if((o|0)==24){c[c[j>>2]>>2]=0;i=f;return}else if((o|0)==69){c[c[j>>2]>>2]=1;i=f;return}else if((o|0)==78){c[c[j>>2]>>2]=0;i=f;return}else if((o|0)==87){i=f;return}}function $N(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+32|0;h=g+28|0;j=g+24|0;k=g+20|0;l=g+16|0;m=g+12|0;n=g+8|0;o=g+4|0;p=g;c[h>>2]=a;c[j>>2]=d;c[k>>2]=e;c[l>>2]=f;c[p>>2]=0;while(1){if(!(c[j>>2]|0))break;c[n>>2]=0;do if((c[c[j>>2]>>2]|0)!=11?(c[c[j>>2]>>2]|0)!=13:0){if((c[c[j>>2]>>2]|0)==4){AO(c[h>>2]|0,c[j>>2]|0);if(c[k>>2]&8)zN(c[h>>2]|0,c[(c[j>>2]|0)+4>>2]|0,1070,190416,0,0);if(c[k>>2]&4)zN(c[h>>2]|0,c[(c[j>>2]|0)+4>>2]|0,1079,190472,0,0);if(c[k>>2]&1)zN(c[h>>2]|0,c[(c[j>>2]|0)+4>>2]|0,1068,190520,0,0);if(c[k>>2]&1)zN(c[h>>2]|0,c[(c[j>>2]|0)+4>>2]|0,1068,190520,0,0);c[m>>2]=0;c[n>>2]=$N(c[h>>2]|0,c[(c[j>>2]|0)+36>>2]|0,c[m>>2]|0,c[c[j>>2]>>2]|0)|0;if(c[n>>2]|0)zN(c[h>>2]|0,c[(c[j>>2]|0)+4>>2]|0,1015,190576,c[(c[j>>2]|0)+8>>2]|0,0);c[n>>2]=$N(c[h>>2]|0,c[(c[j>>2]|0)+24>>2]|0,c[m>>2]|0,c[c[j>>2]>>2]|0)|0;if((c[n>>2]|0)==-1){zN(c[h>>2]|0,c[(c[j>>2]|0)+4>>2]|0,1016,190632,c[(c[j>>2]|0)+8>>2]|0,0);break}else{c[n>>2]=2;break}}if((c[c[j>>2]>>2]|0)==9){if(c[k>>2]&1)zN(c[h>>2]|0,c[(c[j>>2]|0)+4>>2]|0,1067,190672,0,0);if(c[k>>2]&4)zN(c[h>>2]|0,c[(c[j>>2]|0)+4>>2]|0,1078,190720,0,0);if(c[k>>2]&32)zN(c[h>>2]|0,c[(c[j>>2]|0)+4>>2]|0,1086,190768,0,0);if(c[k>>2]&64)zN(c[h>>2]|0,c[(c[j>>2]|0)+4>>2]|0,1087,190824,0,0);if(c[k>>2]&8)zN(c[h>>2]|0,c[(c[j>>2]|0)+4>>2]|0,1069,190888,0,0);if(c[k>>2]&16)zN(c[h>>2]|0,c[(c[j>>2]|0)+4>>2]|0,1088,190936,0,0);do if((c[k>>2]&2|0)==0?(c[(c[j>>2]|0)+8>>2]|0)==0:0){f=c[h>>2]|0;e=c[(c[j>>2]|0)+4>>2]|0;if(!(c[(c[j>>2]|0)+12>>2]|0)){zN(f,e,1e3,190984,0,0);break}else{zN(f,e,1056,191040,0,0);break}}while(0);c[m>>2]=c[k>>2]|1;$N(c[h>>2]|0,c[(c[j>>2]|0)+24>>2]|0,c[m>>2]|0,c[c[j>>2]>>2]|0)|0;c[n>>2]=0;break}if((c[c[j>>2]>>2]|0)!=16?(c[c[j>>2]>>2]|0)!=15:0){if((c[c[j>>2]>>2]|0)==8){if(c[k>>2]&4)zN(c[h>>2]|0,c[(c[j>>2]|0)+4>>2]|0,1081,191192,0,0);if(c[k>>2]&8)zN(c[h>>2]|0,c[(c[j>>2]|0)+4>>2]|0,1074,191232,0,0);if(c[k>>2]&16)zN(c[h>>2]|0,c[(c[j>>2]|0)+4>>2]|0,1093,191280,0,0);c[m>>2]=c[k>>2]|4;c[n>>2]=$N(c[h>>2]|0,c[(c[j>>2]|0)+24>>2]|0,c[m>>2]|0,c[c[j>>2]>>2]|0)|0;break}if((c[c[j>>2]>>2]|0)==18){if(c[k>>2]&8)zN(c[h>>2]|0,c[(c[j>>2]|0)+4>>2]|0,1072,191320,0,0);if(c[k>>2]&16)zN(c[h>>2]|0,c[(c[j>>2]|0)+4>>2]|0,1091,191368,0,0);e=c[k>>2]|0;if(c[k>>2]&2)c[m>>2]=e|32;else c[m>>2]=e;c[n>>2]=$N(c[h>>2]|0,c[(c[j>>2]|0)+24>>2]|0,c[m>>2]|0,c[c[j>>2]>>2]|0)|0;AO(c[h>>2]|0,c[j>>2]|0);break}if((c[c[j>>2]>>2]|0)==19){if(c[k>>2]&4)zN(c[h>>2]|0,c[(c[j>>2]|0)+4>>2]|0,1080,191408,0,0);if(c[k>>2]&8)zN(c[h>>2]|0,c[(c[j>>2]|0)+4>>2]|0,1073,191456,0,0);if(c[k>>2]&16)zN(c[h>>2]|0,c[(c[j>>2]|0)+4>>2]|0,1073,191512,0,0);e=c[k>>2]|0;if(c[k>>2]&2)c[m>>2]=e|64;else c[m>>2]=e;c[n>>2]=$N(c[h>>2]|0,c[(c[j>>2]|0)+24>>2]|0,c[m>>2]|0,c[c[j>>2]>>2]|0)|0;break}e=c[j>>2]|0;if((c[c[j>>2]>>2]|0)==2){if((c[e+28>>2]|0)!=0?(c[c[(c[j>>2]|0)+28>>2]>>2]|0)==5:0)c[m>>2]=c[k>>2]|8;else c[m>>2]=c[k>>2];c[n>>2]=$N(c[h>>2]|0,c[(c[j>>2]|0)+24>>2]|0,c[m>>2]|0,c[c[j>>2]>>2]|0)|0;break}if((c[e>>2]|0)==5){if(c[k>>2]&16)zN(c[h>>2]|0,c[(c[j>>2]|0)+4>>2]|0,1089,191560,0,0);$N(c[h>>2]|0,c[(c[j>>2]|0)+24>>2]|0,c[k>>2]|0,c[c[j>>2]>>2]|0)|0;c[n>>2]=1;break}if((c[c[j>>2]>>2]|0)==7){if(c[k>>2]&16)zN(c[h>>2]|0,c[(c[j>>2]|0)+4>>2]|0,1096,191600,0,0);$N(c[h>>2]|0,c[(c[j>>2]|0)+24>>2]|0,c[k>>2]|0,c[c[j>>2]>>2]|0)|0;c[n>>2]=1;break}if((c[c[j>>2]>>2]|0)==3){if(c[k>>2]&4)zN(c[h>>2]|0,c[(c[j>>2]|0)+4>>2]|0,1083,191640,0,0);if(c[k>>2]&8)zN(c[h>>2]|0,c[(c[j>>2]|0)+4>>2]|0,1077,191680,0,0);if(c[k>>2]&16)zN(c[h>>2]|0,c[(c[j>>2]|0)+4>>2]|0,1095,191728,0,0);c[n>>2]=2;break}if(c[c[j>>2]>>2]|0){e=c[h>>2]|0;f=c[j>>2]|0;if((c[c[j>>2]>>2]|0)==17){CO(e,f);c[n>>2]=$N(c[h>>2]|0,c[(c[j>>2]|0)+24>>2]|0,c[k>>2]|0,c[c[j>>2]>>2]|0)|0;break}else{c[n>>2]=$N(e,c[f+24>>2]|0,c[k>>2]|0,c[c[j>>2]>>2]|0)|0;break}}if(c[k>>2]&8)zN(c[h>>2]|0,c[(c[j>>2]|0)+4>>2]|0,1071,191768,0,0);if(c[k>>2]&16)zN(c[h>>2]|0,c[(c[j>>2]|0)+4>>2]|0,1090,191816,0,0);c[n>>2]=0;break}if(c[k>>2]&8)zN(c[h>>2]|0,c[(c[j>>2]|0)+4>>2]|0,1075,191096,0,0);if(c[k>>2]&16)zN(c[h>>2]|0,c[(c[j>>2]|0)+4>>2]|0,1094,191144,0,0);c[m>>2]=c[k>>2]|2;c[n>>2]=$N(c[h>>2]|0,c[(c[j>>2]|0)+24>>2]|0,c[m>>2]|0,c[c[j>>2]>>2]|0)|0;c[n>>2]=BO(c[n>>2]|0,c[n>>2]|0)|0}else q=5;while(0);do if((q|0)==5){q=0;if(c[k>>2]&8)zN(c[h>>2]|0,c[(c[j>>2]|0)+4>>2]|0,1076,190272,0,0);do if(!(c[(c[j>>2]|0)+24>>2]|0)){f=c[h>>2]|0;e=c[(c[j>>2]|0)+4>>2]|0;if((c[c[j>>2]>>2]|0)==13){zN(f,e,1101,190320,0,0);break}if(c[(c[j>>2]|0)+8>>2]|0)r=c[(c[j>>2]|0)+8>>2]|0;else r=190408;zN(f,e,1101,190368,r,0)}while(0);e=(c[j>>2]|0)+48|0;if((b[(c[j>>2]|0)+48>>1]|0)>-4){b[e>>1]=-4;c[n>>2]=$N(c[h>>2]|0,c[(c[j>>2]|0)+24>>2]|0,c[k>>2]|0,c[c[j>>2]>>2]|0)|0;b[(c[j>>2]|0)+48>>1]=(c[n>>2]|0)-15;break}if((b[e>>1]|0)==-4){c[n>>2]=2;break}else{c[n>>2]=(b[(c[j>>2]|0)+48>>1]|0)+15;break}}while(0);c[j>>2]=c[(c[j>>2]|0)+32>>2];if((c[l>>2]|0)==18){c[p>>2]=BO(c[p>>2]|0,c[n>>2]|0)|0;continue}if((c[l>>2]|0)==19){c[o>>2]=BO(c[p>>2]|0,c[n>>2]|0)|0;if((c[o>>2]|0)==-1)continue;c[o>>2]=DO(c[p>>2]|0,c[n>>2]|0)|0;continue}if((c[l>>2]|0)==17){c[p>>2]=DO(c[p>>2]|0,c[n>>2]|0)|0;continue}if((c[l>>2]|0)==8){c[p>>2]=1;continue}if((c[l>>2]|0)!=2){c[p>>2]=BO(c[p>>2]|0,c[n>>2]|0)|0;continue}if((c[n>>2]|0)==-1){c[p>>2]=-1;continue}else{c[p>>2]=1;continue}}i=g;return c[p>>2]|0}function aO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+48|0;f=e+40|0;g=e+36|0;h=e+32|0;j=e+28|0;k=e+24|0;l=e+20|0;m=e+16|0;n=e+12|0;o=e+8|0;p=e+4|0;q=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=0;c[o>>2]=0;c[p>>2]=0;if(c[(c[g>>2]|0)+36>>2]|0){c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}c[l>>2]=0;c[m>>2]=c[h>>2];a:while(1){if(!(c[m>>2]|0)){s=41;break}if(!(c[j>>2]|0))if((c[c[m>>2]>>2]|0)!=4?(c[c[m>>2]>>2]|0)!=3:0)s=8;else s=10;else s=8;do if((s|0)==8){s=0;if((c[j>>2]|0)==1?(c[c[m>>2]>>2]|0)==9:0){s=10;break}if((((((((((c[c[m>>2]>>2]|0)!=17?(c[c[m>>2]>>2]|0)!=19:0)?(c[c[m>>2]>>2]|0)!=18:0)?(c[c[m>>2]>>2]|0)!=16:0)?(c[c[m>>2]>>2]|0)!=15:0)?(c[c[m>>2]>>2]|0)!=14:0)?(c[c[m>>2]>>2]|0)!=13:0)?(c[c[m>>2]>>2]|0)!=11:0)?(c[c[m>>2]>>2]|0)!=10:0)?(c[c[m>>2]>>2]|0)!=12:0)break;if(c[(c[m>>2]|0)+24>>2]|0){c[l>>2]=c[m>>2];c[m>>2]=c[(c[m>>2]|0)+24>>2];c[n>>2]=c[m>>2];while(1){if(!(c[n>>2]|0))continue a;c[(c[n>>2]|0)+28>>2]=c[l>>2];c[n>>2]=c[(c[n>>2]|0)+32>>2]}}}while(0);if((s|0)==10){s=0;if(!(c[k>>2]|0)){c[p>>2]=10;c[k>>2]=Cb[c[135744>>2]&511]((c[p>>2]|0)+1<<2)|0;if(!(c[k>>2]|0)){s=12;break}}else if((c[p>>2]|0)<=(c[o>>2]|0)){c[p>>2]=c[p>>2]<<1;c[q>>2]=Hb[c[135760>>2]&511](c[k>>2]|0,(c[p>>2]|0)+1<<2)|0;if(!(c[q>>2]|0)){s=15;break}c[k>>2]=c[q>>2]}d=c[m>>2]|0;b=c[o>>2]|0;c[o>>2]=b+1;c[(c[k>>2]|0)+(b<<2)>>2]=d;c[(c[k>>2]|0)+(c[o>>2]<<2)>>2]=0}if((c[m>>2]|0)==(c[h>>2]|0)){s=41;break}if(c[(c[m>>2]|0)+32>>2]|0){c[m>>2]=c[(c[m>>2]|0)+32>>2];continue}while(1){c[m>>2]=c[(c[m>>2]|0)+28>>2];if(!(c[m>>2]|0))continue a;if((c[m>>2]|0)==(c[h>>2]|0)){s=37;break a}t=c[m>>2]|0;if(c[(c[m>>2]|0)+32>>2]|0)break;if(!t)continue a}c[m>>2]=c[t+32>>2]}if((s|0)==12){xN(c[g>>2]|0,190240);c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}else if((s|0)==15){xN(c[g>>2]|0,190240);zb[c[135736>>2]&511](c[k>>2]|0);c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}else if((s|0)==37){c[f>>2]=c[k>>2];r=c[f>>2]|0;i=e;return r|0}else if((s|0)==41){c[f>>2]=c[k>>2];r=c[f>>2]|0;i=e;return r|0}return 0}function bO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+8|0;h=e+4|0;j=e;c[e+12>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=c[h>>2];if((c[g>>2]|0)==0|(c[h>>2]|0)==0){c[f>>2]=1;k=c[f>>2]|0;i=e;return k|0}if((c[c[g>>2]>>2]|0)!=0?(c[c[h>>2]>>2]|0)!=0:0){a:while(1){if(!(c[c[g>>2]>>2]|0)){l=12;break}while(1){if(!(c[c[h>>2]>>2]|0))break;if(!(EO(c[c[g>>2]>>2]|0,c[c[h>>2]>>2]|0)|0)){l=9;break a}c[h>>2]=(c[h>>2]|0)+4}c[h>>2]=c[j>>2];c[g>>2]=(c[g>>2]|0)+4}if((l|0)==9){c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}else if((l|0)==12){c[f>>2]=1;k=c[f>>2]|0;i=e;return k|0}}c[f>>2]=1;k=c[f>>2]|0;i=e;return k|0}function cO(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=-1;if(!(c[f>>2]|0)){c[e>>2]=-1;l=c[e>>2]|0;i=d;return l|0}if((c[c[f>>2]>>2]|0)!=4?(b[(c[f>>2]|0)+50>>1]&64|0)!=0:0){c[e>>2]=1;l=c[e>>2]|0;i=d;return l|0}if((c[c[f>>2]>>2]|0)!=4?(b[(c[f>>2]|0)+50>>1]&128|0)!=0:0){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}a:do switch(c[c[f>>2]>>2]|0){case 1:case 7:case 6:case 8:case 5:case 19:case 9:case 2:{c[g>>2]=0;break}case 13:case 12:case 11:{if((b[(c[f>>2]|0)+48>>1]|0)==-20){c[e>>2]=1;l=c[e>>2]|0;i=d;return l|0}b[(c[f>>2]|0)+48>>1]=-20;c[j>>2]=c[(c[f>>2]|0)+24>>2];while(1){if(!(c[j>>2]|0))break a;c[g>>2]=cO(c[j>>2]|0)|0;if((c[g>>2]|0)!=1)break a;c[j>>2]=c[(c[j>>2]|0)+32>>2]}break}case 4:{if((b[(c[f>>2]|0)+50>>1]&128|0)==0?(b[(c[f>>2]|0)+50>>1]&64|0)==0:0){c[h>>2]=c[(c[f>>2]|0)+24>>2];while(1){if(!(c[h>>2]|0))break;c[g>>2]=cO(c[h>>2]|0)|0;if((c[g>>2]|0)!=1)break;c[h>>2]=c[(c[h>>2]|0)+32>>2]}if(!(c[g>>2]|0)){a=(c[f>>2]|0)+50|0;b[a>>1]=b[a>>1]&-65;a=(c[f>>2]|0)+50|0;b[a>>1]=b[a>>1]|128}if((c[g>>2]|0)==1?(a=(c[f>>2]|0)+50|0,m=b[a>>1]&128,b[a>>1]=m,m<<16>>16==0):0){m=(c[f>>2]|0)+50|0;b[m>>1]=b[m>>1]|64}}if((c[(c[f>>2]|0)+40>>2]|0)==0?(c[(c[f>>2]|0)+8>>2]|0)!=0:0)c[g>>2]=1;else c[g>>2]=0;c[e>>2]=c[g>>2];l=c[e>>2]|0;i=d;return l|0}case 10:case 18:case 17:case 16:case 15:case 14:case 20:{c[k>>2]=c[(c[f>>2]|0)+24>>2];while(1){if(!(c[k>>2]|0))break a;c[g>>2]=cO(c[k>>2]|0)|0;if((c[g>>2]|0)!=1)break a;c[k>>2]=c[(c[k>>2]|0)+32>>2]}break}case-1:{c[g>>2]=cO(c[(c[f>>2]|0)+24>>2]|0)|0;break}case 0:case 3:{c[g>>2]=1;break}default:{}}while(0);if(!(c[g>>2]|0)){k=(c[f>>2]|0)+50|0;b[k>>1]=b[k>>1]|128}if((c[g>>2]|0)==1){k=(c[f>>2]|0)+50|0;b[k>>1]=b[k>>1]|64}c[e>>2]=c[g>>2];l=c[e>>2]|0;i=d;return l|0}function dO(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=i;i=i+80|0;f=e;g=e+64|0;h=e+60|0;j=e+56|0;k=e+52|0;l=e+48|0;m=e+44|0;n=e+40|0;p=e+36|0;q=e+32|0;r=e+28|0;s=e+24|0;t=e+20|0;u=e+16|0;v=e+12|0;w=e+8|0;x=e+4|0;c[h>>2]=a;c[j>>2]=d;c[k>>2]=0;if((c[h>>2]|0)==0|(c[j>>2]|0)==0){c[g>>2]=-1;y=c[g>>2]|0;i=e;return y|0}a:do switch(c[c[j>>2]>>2]|0){case-1:{c[k>>2]=dO(c[h>>2]|0,c[(c[j>>2]|0)+24>>2]|0)|0;break}case 14:{c[s>>2]=c[(c[h>>2]|0)+136>>2];c[l>>2]=c[(c[j>>2]|0)+24>>2];while(1){z=c[h>>2]|0;if(!(c[l>>2]|0))break;dO(z,c[l>>2]|0)|0;c[l>>2]=c[(c[l>>2]|0)+32>>2]}Jz(c[z+132>>2]|0,c[s>>2]|0,c[(c[h>>2]|0)+136>>2]|0)|0;break}case 17:{c[v>>2]=0;c[w>>2]=c[(c[h>>2]|0)+136>>2];c[l>>2]=c[(c[j>>2]|0)+24>>2];while(1){if(!(c[l>>2]|0))break;c[(c[h>>2]|0)+136>>2]=c[w>>2];c[k>>2]=dO(c[h>>2]|0,c[l>>2]|0)|0;if(c[k>>2]|0)break;d=c[h>>2]|0;if(!(c[v>>2]|0))c[v>>2]=c[d+136>>2];else Jz(c[d+132>>2]|0,c[(c[h>>2]|0)+136>>2]|0,c[v>>2]|0)|0;c[l>>2]=c[(c[l>>2]|0)+32>>2]}c[(c[h>>2]|0)+136>>2]=c[v>>2];break}case 20:{if((cO(c[j>>2]|0)|0)==1?(b[(c[j>>2]|0)+48>>1]|0)!=-25:0){c[m>>2]=c[(c[h>>2]|0)+132>>2];c[n>>2]=c[(c[h>>2]|0)+136>>2];b[(c[j>>2]|0)+48>>1]=-25;c[l>>2]=c[(c[j>>2]|0)+24>>2];d=xz()|0;c[(c[h>>2]|0)+132>>2]=d;if(!(c[(c[h>>2]|0)+132>>2]|0)){c[g>>2]=-1;y=c[g>>2]|0;i=e;return y|0}Az(c[(c[h>>2]|0)+132>>2]|0,1);d=Bz(c[(c[h>>2]|0)+132>>2]|0)|0;c[(c[h>>2]|0)+136>>2]=d;while(1){A=c[h>>2]|0;if(!(c[l>>2]|0))break;dO(A,c[l>>2]|0)|0;c[l>>2]=c[(c[l>>2]|0)+32>>2]}Cz(c[A+132>>2]|0,c[(c[h>>2]|0)+136>>2]|0)|0;if(Pz(c[(c[h>>2]|0)+132>>2]|0)|0){d=Oz(c[(c[h>>2]|0)+132>>2]|0)|0;c[(c[j>>2]|0)+52>>2]=d}yz(c[(c[h>>2]|0)+132>>2]|0);c[(c[h>>2]|0)+136>>2]=c[n>>2];c[(c[h>>2]|0)+132>>2]=c[m>>2]}break}case 3:{d=Jz(c[(c[h>>2]|0)+132>>2]|0,c[(c[h>>2]|0)+136>>2]|0,0)|0;c[(c[h>>2]|0)+136>>2]=d;c[x>>2]=c[(c[h>>2]|0)+136>>2];dO(c[h>>2]|0,c[(c[j>>2]|0)+24>>2]|0)|0;Dz(c[(c[h>>2]|0)+132>>2]|0,c[(c[h>>2]|0)+136>>2]|0,c[(c[h>>2]|0)+136>>2]|0,188096,0)|0;d=Jz(c[(c[h>>2]|0)+132>>2]|0,c[x>>2]|0,0)|0;c[(c[h>>2]|0)+136>>2]=d;break}case 10:case 18:case 13:case 12:case 11:{c[l>>2]=c[(c[j>>2]|0)+24>>2];while(1){if(!(c[l>>2]|0))break a;c[k>>2]=dO(c[h>>2]|0,c[l>>2]|0)|0;if(c[k>>2]|0)break a;c[l>>2]=c[(c[l>>2]|0)+32>>2]}break}case 0:{d=Jz(c[(c[h>>2]|0)+132>>2]|0,c[(c[h>>2]|0)+136>>2]|0,0)|0;c[(c[h>>2]|0)+136>>2]=d;break}case 4:{if((c[(c[h>>2]|0)+132>>2]|0)!=0?(c[(c[j>>2]|0)+8>>2]|0)!=0:0){d=Ez(c[(c[h>>2]|0)+132>>2]|0,c[(c[h>>2]|0)+136>>2]|0,0,c[(c[j>>2]|0)+8>>2]|0,c[(c[j>>2]|0)+12>>2]|0,c[j>>2]|0)|0;c[(c[h>>2]|0)+136>>2]=d}if((b[(c[j>>2]|0)+50>>1]&64|0)!=0?(b[(c[j>>2]|0)+48>>1]|0)!=-25:0){c[p>>2]=c[(c[h>>2]|0)+132>>2];c[q>>2]=c[(c[h>>2]|0)+136>>2];b[(c[j>>2]|0)+48>>1]=-25;c[l>>2]=c[(c[j>>2]|0)+24>>2];d=xz()|0;c[(c[h>>2]|0)+132>>2]=d;if(!(c[(c[h>>2]|0)+132>>2]|0)){c[g>>2]=-1;y=c[g>>2]|0;i=e;return y|0}Az(c[(c[h>>2]|0)+132>>2]|0,1);d=Bz(c[(c[h>>2]|0)+132>>2]|0)|0;c[(c[h>>2]|0)+136>>2]=d;while(1){B=c[h>>2]|0;if(!(c[l>>2]|0))break;dO(B,c[l>>2]|0)|0;c[l>>2]=c[(c[l>>2]|0)+32>>2]}Cz(c[B+132>>2]|0,c[(c[h>>2]|0)+136>>2]|0)|0;d=Oz(c[(c[h>>2]|0)+132>>2]|0)|0;c[(c[j>>2]|0)+52>>2]=d;if(!(wz(c[(c[j>>2]|0)+52>>2]|0)|0)){zz(c[(c[j>>2]|0)+52>>2]|0);c[(c[j>>2]|0)+52>>2]=0}yz(c[(c[h>>2]|0)+132>>2]|0);c[(c[h>>2]|0)+136>>2]=c[q>>2];c[(c[h>>2]|0)+132>>2]=c[p>>2];break a}c[r>>2]=c[(c[h>>2]|0)+132>>2];c[k>>2]=EN(c[h>>2]|0,c[j>>2]|0)|0;c[(c[h>>2]|0)+132>>2]=c[r>>2];break}case 7:case 6:case 8:case 5:case 1:case 19:case 9:case 2:{d=c[o>>2]|0;c[f>>2]=FO(c[j>>2]|0)|0;Ka(d|0,189768,f|0)|0;break}case 15:{d=Jz(c[(c[h>>2]|0)+132>>2]|0,c[(c[h>>2]|0)+136>>2]|0,0)|0;c[(c[h>>2]|0)+136>>2]=d;c[t>>2]=c[(c[h>>2]|0)+136>>2];c[l>>2]=c[(c[j>>2]|0)+24>>2];while(1){C=c[h>>2]|0;if(!(c[l>>2]|0))break;dO(C,c[l>>2]|0)|0;c[l>>2]=c[(c[l>>2]|0)+32>>2]}Jz(c[C+132>>2]|0,c[(c[h>>2]|0)+136>>2]|0,c[t>>2]|0)|0;d=Jz(c[(c[h>>2]|0)+132>>2]|0,c[t>>2]|0,0)|0;c[(c[h>>2]|0)+136>>2]=d;break}case 16:{c[l>>2]=c[(c[j>>2]|0)+24>>2];while(1){D=c[h>>2]|0;if(!(c[l>>2]|0))break;dO(D,c[l>>2]|0)|0;c[l>>2]=c[(c[l>>2]|0)+32>>2]}c[u>>2]=c[D+136>>2];c[l>>2]=c[(c[j>>2]|0)+24>>2];while(1){E=c[h>>2]|0;if(!(c[l>>2]|0))break;dO(E,c[l>>2]|0)|0;c[l>>2]=c[(c[l>>2]|0)+32>>2]}Jz(c[E+132>>2]|0,c[(c[h>>2]|0)+136>>2]|0,c[u>>2]|0)|0;d=Jz(c[(c[h>>2]|0)+132>>2]|0,c[u>>2]|0,0)|0;c[(c[h>>2]|0)+136>>2]=d;break}default:{}}while(0);c[g>>2]=c[k>>2];y=c[g>>2]|0;i=e;return y|0}function eO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;d=b+20|0;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;j=b;c[d>>2]=a;c[e>>2]=0;c[g>>2]=0;while(1){if((c[e>>2]|0)>=(c[(c[d>>2]|0)+48>>2]|0))break;c[h>>2]=(c[(c[d>>2]|0)+56>>2]|0)+((c[e>>2]|0)*24|0);a:do if((c[g>>2]|0)<5){c[f>>2]=0;while(1){if((c[f>>2]|0)>=(c[e>>2]|0))break;c[j>>2]=(c[(c[d>>2]|0)+56>>2]|0)+((c[f>>2]|0)*24|0);if((((c[c[h>>2]>>2]|0)==(c[c[j>>2]>>2]|0)?(c[(c[h>>2]|0)+8>>2]|0)==(c[(c[j>>2]|0)+8>>2]|0):0)?(qy(c[(c[h>>2]|0)+16>>2]|0,c[(c[j>>2]|0)+16>>2]|0)|0)!=0:0)?(qy(c[(c[h>>2]|0)+20>>2]|0,c[(c[j>>2]|0)+20>>2]|0)|0)!=0:0)break a;c[f>>2]=(c[f>>2]|0)+1}fO(c[d>>2]|0,c[c[h>>2]>>2]|0,c[(c[h>>2]|0)+8>>2]|0,c[(c[h>>2]|0)+12>>2]|0,c[(c[h>>2]|0)+16>>2]|0,c[(c[h>>2]|0)+20>>2]|0);c[g>>2]=(c[g>>2]|0)+1}while(0);if(c[(c[h>>2]|0)+4>>2]&1){if(c[(c[h>>2]|0)+16>>2]|0)zb[c[135736>>2]&511](c[(c[h>>2]|0)+16>>2]|0);c[(c[h>>2]|0)+16>>2]=0;if(c[(c[h>>2]|0)+20>>2]|0)zb[c[135736>>2]&511](c[(c[h>>2]|0)+20>>2]|0);c[(c[h>>2]|0)+20>>2]=0;c[(c[h>>2]|0)+4>>2]=0}c[e>>2]=(c[e>>2]|0)+1}c[(c[d>>2]|0)+48>>2]=0;i=b;return}function fO(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+32|0;j=h+24|0;k=h+20|0;l=h+16|0;m=h+12|0;n=h+8|0;o=h+4|0;p=h;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;if(c[(c[j>>2]|0)+28>>2]&8){i=h;return}c[p>>2]=GO(c[k>>2]|0,c[n>>2]|0,c[o>>2]|0)|0;if(!(c[p>>2]|0)){i=h;return}if(!(c[(c[j>>2]|0)+40>>2]|0))c[(c[j>>2]|0)+40>>2]=c[k>>2];HO(c[j>>2]|0,(c[m>>2]|0)==0?c[l>>2]|0:c[m>>2]|0,c[k>>2]|0,c[p>>2]|0,c[n>>2]|0,c[o>>2]|0);zb[c[135736>>2]&511](c[p>>2]|0);i=h;return}function gO(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+32|0;h=g+24|0;j=g+20|0;k=g+16|0;l=g+12|0;m=g+8|0;n=g+4|0;o=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;do if(!(c[(c[j>>2]|0)+56>>2]|0)){c[(c[j>>2]|0)+52>>2]=8;c[(c[j>>2]|0)+48>>2]=0;f=Cb[c[135744>>2]&511]((c[(c[j>>2]|0)+52>>2]|0)*24|0)|0;c[(c[j>>2]|0)+56>>2]=f;f=c[j>>2]|0;if(c[(c[j>>2]|0)+56>>2]|0){c[f+44>>2]=0;break}MN(f,189752);c[h>>2]=0;p=c[h>>2]|0;i=g;return p|0}while(0);do if((c[(c[j>>2]|0)+48>>2]|0)>=(c[(c[j>>2]|0)+52>>2]|0)){f=(c[j>>2]|0)+52|0;c[f>>2]=c[f>>2]<<1;f=Hb[c[135760>>2]&511](c[(c[j>>2]|0)+56>>2]|0,(c[(c[j>>2]|0)+52>>2]|0)*24|0)|0;c[(c[j>>2]|0)+56>>2]=f;f=c[j>>2]|0;if(c[(c[j>>2]|0)+56>>2]|0){c[(c[j>>2]|0)+44>>2]=(c[(c[j>>2]|0)+56>>2]|0)+(((c[f+48>>2]|0)-1|0)*24|0);break}MN(f,189752);c[h>>2]=0;p=c[h>>2]|0;i=g;return p|0}while(0);if((((c[(c[j>>2]|0)+44>>2]|0)!=0?(c[(c[j>>2]|0)+60>>2]|0)!=0:0)?(c[(c[(c[j>>2]|0)+44>>2]|0)+8>>2]|0)==(c[c[(c[j>>2]|0)+60>>2]>>2]|0):0)?(c[c[(c[j>>2]|0)+44>>2]>>2]|0)==(c[k>>2]|0):0){c[h>>2]=c[(c[j>>2]|0)+48>>2];p=c[h>>2]|0;i=g;return p|0}c[o>>2]=(c[(c[j>>2]|0)+56>>2]|0)+((c[(c[j>>2]|0)+48>>2]|0)*24|0);c[c[o>>2]>>2]=c[k>>2];k=c[l>>2]|0;if(c[n>>2]|0){n=my(k)|0;c[(c[o>>2]|0)+16>>2]=n;n=my(c[m>>2]|0)|0;c[(c[o>>2]|0)+20>>2]=n;c[(c[o>>2]|0)+4>>2]=1}else{c[(c[o>>2]|0)+16>>2]=k;c[(c[o>>2]|0)+20>>2]=c[m>>2];c[(c[o>>2]|0)+4>>2]=0}if(c[(c[j>>2]|0)+60>>2]|0){c[(c[o>>2]|0)+8>>2]=c[c[(c[j>>2]|0)+60>>2]>>2];c[(c[o>>2]|0)+12>>2]=c[(c[(c[j>>2]|0)+60>>2]|0)+4>>2]}else{c[(c[o>>2]|0)+8>>2]=0;c[(c[o>>2]|0)+12>>2]=0}c[(c[j>>2]|0)+44>>2]=c[o>>2];o=(c[j>>2]|0)+48|0;j=c[o>>2]|0;c[o>>2]=j+1;c[h>>2]=j;p=c[h>>2]|0;i=g;return p|0}function hO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;c[k>>2]=0;c[l>>2]=c[g>>2];while(1){if(!(c[l>>2]|0))break;if((c[c[l>>2]>>2]|0)==9){if(IO(c[f>>2]|0,c[l>>2]|0)|0)c[h>>2]=-1}else c[k>>2]=1;c[l>>2]=c[(c[l>>2]|0)+32>>2]}if(!(c[k>>2]|0)){c[e>>2]=c[h>>2];m=c[e>>2]|0;i=d;return m|0}c[l>>2]=c[g>>2];while(1){if(!(c[l>>2]|0)){n=20;break}if((c[c[l>>2]>>2]|0)!=9){if((c[(c[f>>2]|0)+60>>2]|0)==0?(c[(c[f>>2]|0)+64>>2]|0)==0:0){n=17;break}c[j>>2]=KN(c[f>>2]|0,c[l>>2]|0)|0;if((c[j>>2]|0)<0)c[h>>2]=-1;if((c[j>>2]|0)==-1){n=20;break}}c[l>>2]=c[(c[l>>2]|0)+32>>2]}if((n|0)==17){FN(c[f>>2]|0,6,0,0,0);c[e>>2]=-1;m=c[e>>2]|0;i=d;return m|0}else if((n|0)==20){c[e>>2]=c[h>>2];m=c[e>>2]|0;i=d;return m|0}return 0}function iO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[f>>2]=a;c[g>>2]=b;c[j>>2]=c[(c[f>>2]|0)+60>>2];if((c[(c[j>>2]|0)+4>>2]|0)!=0?(b=oO(c[f>>2]|0,c[(c[j>>2]|0)+4>>2]|0)|0,c[(c[j>>2]|0)+4>>2]=b,(c[(c[j>>2]|0)+4>>2]|0)!=0):0){if(c[g>>2]|0)FN(c[f>>2]|0,26,c[(c[c[j>>2]>>2]|0)+8>>2]|0,c[(c[(c[j>>2]|0)+4>>2]|0)+8>>2]|0,0);c[e>>2]=-1;k=c[e>>2]|0;i=d;return k|0}c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[(c[j>>2]|0)+8>>2]|0)){l=13;break}if(c[(c[(c[j>>2]|0)+28>>2]|0)+(c[h>>2]<<2)>>2]|0)break;c[h>>2]=(c[h>>2]|0)+1}if((l|0)==13){c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}if(c[g>>2]|0)FN(c[f>>2]|0,27,c[(c[(c[(c[j>>2]|0)+28>>2]|0)+(c[h>>2]<<2)>>2]|0)+8>>2]|0,c[(c[c[j>>2]>>2]|0)+8>>2]|0,0);c[e>>2]=-1-(c[h>>2]|0);k=c[e>>2]|0;i=d;return k|0}function jO(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(!(c[(c[d>>2]|0)+64>>2]|0)){i=b;return}if((c[c[(c[d>>2]|0)+64>>2]>>2]|0)<=0){i=b;return}c[e>>2]=JO(c[d>>2]|0)|0;if((c[e>>2]|0)<0){i=b;return}if((c[e>>2]|0)>=(c[c[(c[d>>2]|0)+64>>2]>>2]|0)){i=b;return}c[(c[d>>2]|0)+60>>2]=c[(c[(c[(c[d>>2]|0)+64>>2]|0)+8>>2]|0)+(c[e>>2]<<2)>>2];iO(c[d>>2]|0,1)|0;i=b;return}function kO(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;e=i;i=i+144|0;f=e;g=e+136|0;h=e+132|0;j=e+128|0;k=e+124|0;l=e+120|0;m=e+116|0;n=e+112|0;o=e+108|0;p=e+104|0;q=e+100|0;r=e+96|0;s=e+92|0;t=e+88|0;u=e+84|0;v=e+80|0;w=e+76|0;x=e+72|0;y=e+68|0;z=e+64|0;A=e+60|0;B=e+56|0;C=e+52|0;D=e+48|0;E=e+44|0;F=e+40|0;G=e+36|0;H=e+32|0;I=e+28|0;J=e+24|0;K=e+20|0;L=e+16|0;M=e+12|0;N=e+8|0;c[h>>2]=a;c[j>>2]=d;c[l>>2]=0;c[q>>2]=0;d=c[h>>2]|0;if(!(c[j>>2]|0)){FN(d,7,0,0,0);c[g>>2]=-1;O=c[g>>2]|0;i=e;return O|0}if(c[d+60>>2]|0)c[k>>2]=c[(c[(c[h>>2]|0)+60>>2]|0)+4>>2];else c[k>>2]=0;d=(c[h>>2]|0)+32|0;c[d>>2]=(c[d>>2]|0)+1;a:do switch(c[c[j>>2]>>2]|0){case 1:{c[l>>2]=-1;break}case 3:{while(1){if(c[k>>2]|0)if(((c[(c[k>>2]|0)+4>>2]|0)!=3?(c[(c[k>>2]|0)+4>>2]|0)!=8:0)?(c[(c[k>>2]|0)+4>>2]|0)!=7:0)P=(c[(c[k>>2]|0)+4>>2]|0)==4;else P=1;else P=0;Q=c[k>>2]|0;if(!P)break;c[k>>2]=c[Q+24>>2]}c[(c[(c[h>>2]|0)+60>>2]|0)+4>>2]=Q;break}case 0:{c[k>>2]=oO(c[h>>2]|0,c[k>>2]|0)|0;c[l>>2]=0;break}case 16:{c[p>>2]=c[(c[h>>2]|0)+48>>2];c[l>>2]=OO(c[h>>2]|0,c[(c[j>>2]|0)+24>>2]|0)|0;if(!(c[l>>2]|0))if((c[(c[h>>2]|0)+48>>2]|0)>(c[p>>2]|0)){KO(c[h>>2]|0,c[p>>2]|0);R=124}else R=124;break}case 15:{R=124;break}case 14:{c[p>>2]=c[(c[h>>2]|0)+48>>2];c[o>>2]=c[(c[h>>2]|0)+28>>2];d=(c[h>>2]|0)+28|0;c[d>>2]=c[d>>2]|1;c[q>>2]=PO(c[h>>2]|0,c[(c[h>>2]|0)+60>>2]|0)|0;c[l>>2]=OO(c[h>>2]|0,c[(c[j>>2]|0)+24>>2]|0)|0;d=c[h>>2]|0;if(c[l>>2]|0){if(c[d+60>>2]|0)LN(c[h>>2]|0,c[(c[h>>2]|0)+60>>2]|0);c[(c[h>>2]|0)+60>>2]=c[q>>2];c[(c[h>>2]|0)+28>>2]=c[o>>2];c[l>>2]=0;if((c[(c[h>>2]|0)+48>>2]|0)<=(c[p>>2]|0))break a;KO(c[h>>2]|0,c[p>>2]|0);break a}a=c[h>>2]|0;do if(c[d+64>>2]|0)lO(a,c[(c[h>>2]|0)+64>>2]|0,c[q>>2]|0)|0;else{S=mO(a,1)|0;c[(c[h>>2]|0)+64>>2]=S;S=c[h>>2]|0;if(c[(c[h>>2]|0)+64>>2]|0){lO(S,c[(c[h>>2]|0)+64>>2]|0,c[q>>2]|0)|0;lO(c[h>>2]|0,c[(c[h>>2]|0)+64>>2]|0,c[(c[h>>2]|0)+60>>2]|0)|0;c[(c[h>>2]|0)+60>>2]=0;break}LN(S,c[q>>2]|0);c[(c[h>>2]|0)+28>>2]=c[o>>2];c[l>>2]=-1;if((c[(c[h>>2]|0)+48>>2]|0)<=(c[p>>2]|0))break a;KO(c[h>>2]|0,c[p>>2]|0);break a}while(0);c[(c[h>>2]|0)+28>>2]=c[o>>2];c[l>>2]=0;if((c[(c[h>>2]|0)+48>>2]|0)>(c[p>>2]|0))KO(c[h>>2]|0,c[p>>2]|0);break}case 4:{c[p>>2]=c[(c[h>>2]|0)+48>>2];c[k>>2]=oO(c[h>>2]|0,c[k>>2]|0)|0;if(!(c[k>>2]|0)){FN(c[h>>2]|0,22,c[(c[j>>2]|0)+8>>2]|0,0,0);c[l>>2]=-1;if(c[(c[h>>2]|0)+28>>2]&1)break a;eO(c[h>>2]|0);break a}if((c[(c[k>>2]|0)+4>>2]|0)!=1){FN(c[h>>2]|0,23,0,0,0);c[l>>2]=-1;if(c[(c[h>>2]|0)+28>>2]&1)break a;eO(c[h>>2]|0);break a}a=c[h>>2]|0;if((c[(c[k>>2]|0)+52>>2]|0)==(c[j>>2]|0)){d=oO(a,c[(c[k>>2]|0)+24>>2]|0)|0;c[(c[(c[h>>2]|0)+60>>2]|0)+4>>2]=d;if((c[(c[h>>2]|0)+48>>2]|0)>(c[p>>2]|0))KO(c[h>>2]|0,c[p>>2]|0);if(!(c[(c[h>>2]|0)+48>>2]|0))break a;while(1){if(!(c[(c[h>>2]|0)+44>>2]|0))break a;if(!((c[c[(c[h>>2]|0)+44>>2]>>2]|0)==13?(qy(c[(c[(c[h>>2]|0)+44>>2]|0)+20>>2]|0,c[(c[k>>2]|0)+8>>2]|0)|0)!=0:0))R=30;do if((R|0)==30){R=0;if((c[c[(c[h>>2]|0)+44>>2]>>2]|0)==19?(qy(c[(c[(c[h>>2]|0)+44>>2]|0)+16>>2]|0,c[(c[k>>2]|0)+8>>2]|0)|0)!=0:0)break;if((c[c[(c[h>>2]|0)+44>>2]>>2]|0)!=22?(c[c[(c[h>>2]|0)+44>>2]>>2]|0)!=23:0)break a}while(0);LO(c[h>>2]|0)}}c[l>>2]=MO(a,c[j>>2]|0,c[k>>2]|0)|0;if((c[l>>2]|0)<=0){c[l>>2]=-1;if(c[(c[h>>2]|0)+28>>2]&1)break a;eO(c[h>>2]|0);break a}c[l>>2]=0;b:do if(c[(c[h>>2]|0)+48>>2]|0){if((c[(c[h>>2]|0)+48>>2]|0)>(c[p>>2]|0))KO(c[h>>2]|0,c[p>>2]|0);while(1){if(!(c[(c[h>>2]|0)+44>>2]|0))break b;if(!((c[c[(c[h>>2]|0)+44>>2]>>2]|0)==13?(qy(c[(c[(c[h>>2]|0)+44>>2]|0)+20>>2]|0,c[(c[k>>2]|0)+8>>2]|0)|0)!=0:0))R=44;do if((R|0)==44){R=0;if((c[c[(c[h>>2]|0)+44>>2]>>2]|0)==19?(qy(c[(c[(c[h>>2]|0)+44>>2]|0)+16>>2]|0,c[(c[k>>2]|0)+8>>2]|0)|0)!=0:0)break;if((c[c[(c[h>>2]|0)+44>>2]>>2]|0)!=22?(c[c[(c[h>>2]|0)+44>>2]>>2]|0)!=23:0)break b}while(0);LO(c[h>>2]|0)}}while(0);c[p>>2]=c[(c[h>>2]|0)+48>>2];c[o>>2]=c[(c[h>>2]|0)+28>>2];if(c[(c[h>>2]|0)+28>>2]&4){a=(c[h>>2]|0)+28|0;c[a>>2]=(c[a>>2]|0)-4}c[r>>2]=JN(c[h>>2]|0,c[k>>2]|0)|0;if(!(c[r>>2]|0)){c[l>>2]=-1;if(c[(c[h>>2]|0)+28>>2]&1)break a;eO(c[h>>2]|0);break a}c[q>>2]=c[(c[h>>2]|0)+60>>2];c[(c[h>>2]|0)+60>>2]=c[r>>2];if((c[(c[j>>2]|0)+36>>2]|0)!=0?(c[n>>2]=hO(c[h>>2]|0,c[(c[j>>2]|0)+36>>2]|0)|0,(c[n>>2]|0)!=0):0){c[l>>2]=-1;FN(c[h>>2]|0,24,c[(c[k>>2]|0)+8>>2]|0,0,0)}do if(c[(c[j>>2]|0)+52>>2]|0){c[t>>2]=c[(c[h>>2]|0)+60>>2];c[u>>2]=c[(c[h>>2]|0)+64>>2];c[s>>2]=JN(c[h>>2]|0,c[k>>2]|0)|0;c[(c[h>>2]|0)+60>>2]=c[s>>2];c[(c[h>>2]|0)+64>>2]=0;c[n>>2]=NO(c[h>>2]|0,c[(c[j>>2]|0)+52>>2]|0,c[(c[(c[h>>2]|0)+60>>2]|0)+4>>2]|0)|0;c[v>>2]=c[(c[(c[h>>2]|0)+60>>2]|0)+4>>2];c[(c[h>>2]|0)+60>>2]=c[t>>2];c[(c[h>>2]|0)+64>>2]=c[u>>2];LN(c[h>>2]|0,c[s>>2]|0);if(c[n>>2]|0)c[l>>2]=-1;if(!(c[(c[h>>2]|0)+64>>2]|0)){c[r>>2]=c[(c[h>>2]|0)+60>>2];if(c[(c[h>>2]|0)+60>>2]|0)c[(c[(c[h>>2]|0)+60>>2]|0)+4>>2]=c[v>>2];if(!(c[l>>2]|0))c[l>>2]=iO(c[h>>2]|0,1)|0;LN(c[h>>2]|0,c[r>>2]|0);break}c[n>>2]=-1;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[c[(c[h>>2]|0)+64>>2]>>2]|0))break;c[r>>2]=c[(c[(c[(c[h>>2]|0)+64>>2]|0)+8>>2]|0)+(c[m>>2]<<2)>>2];c[(c[h>>2]|0)+60>>2]=c[r>>2];c[(c[(c[h>>2]|0)+60>>2]|0)+4>>2]=c[v>>2];if(!(iO(c[h>>2]|0,0)|0)){R=64;break}c[m>>2]=(c[m>>2]|0)+1}if((R|0)==64)c[n>>2]=0;if(c[n>>2]|0){a=(c[h>>2]|0)+28|0;c[a>>2]=c[a>>2]|1;jO(c[h>>2]|0)}c[m>>2]=0;while(1){T=c[h>>2]|0;if((c[m>>2]|0)>=(c[c[(c[h>>2]|0)+64>>2]>>2]|0))break;LN(T,c[(c[(c[(c[h>>2]|0)+64>>2]|0)+8>>2]|0)+(c[m>>2]<<2)>>2]|0);c[m>>2]=(c[m>>2]|0)+1}NN(T,c[(c[h>>2]|0)+64>>2]|0);c[(c[h>>2]|0)+28>>2]=c[o>>2];c[(c[h>>2]|0)+64>>2]=0;if((c[l>>2]|0)==0&(c[n>>2]|0)==-1)c[l>>2]=-1}else{do if((c[(c[j>>2]|0)+24>>2]|0)!=0?(c[n>>2]=OO(c[h>>2]|0,c[(c[j>>2]|0)+24>>2]|0)|0,(c[n>>2]|0)!=0):0){c[l>>2]=-1;if(!(c[(c[h>>2]|0)+60>>2]|0)){c[(c[h>>2]|0)+60>>2]=c[q>>2];FN(c[h>>2]|0,25,c[(c[k>>2]|0)+8>>2]|0,0,0);c[(c[h>>2]|0)+60>>2]=0;break}else{FN(c[h>>2]|0,25,c[(c[k>>2]|0)+8>>2]|0,0,0);break}}while(0);if(!(c[(c[h>>2]|0)+64>>2]|0)){c[r>>2]=c[(c[h>>2]|0)+60>>2];if(!(c[l>>2]|0))c[l>>2]=iO(c[h>>2]|0,1)|0;LN(c[h>>2]|0,c[r>>2]|0);break}c[n>>2]=-1;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[c[(c[h>>2]|0)+64>>2]>>2]|0))break;c[r>>2]=c[(c[(c[(c[h>>2]|0)+64>>2]|0)+8>>2]|0)+(c[m>>2]<<2)>>2];c[(c[h>>2]|0)+60>>2]=c[r>>2];if(!(iO(c[h>>2]|0,0)|0)){R=87;break}c[m>>2]=(c[m>>2]|0)+1}if((R|0)==87)c[n>>2]=0;if(c[n>>2]|0){a=(c[h>>2]|0)+28|0;c[a>>2]=c[a>>2]|1;jO(c[h>>2]|0)}c[m>>2]=0;while(1){U=c[h>>2]|0;if((c[m>>2]|0)>=(c[c[(c[h>>2]|0)+64>>2]>>2]|0))break;LN(U,c[(c[(c[(c[h>>2]|0)+64>>2]|0)+8>>2]|0)+(c[m>>2]<<2)>>2]|0);c[(c[(c[(c[h>>2]|0)+64>>2]|0)+8>>2]|0)+(c[m>>2]<<2)>>2]=0;c[m>>2]=(c[m>>2]|0)+1}NN(U,c[(c[h>>2]|0)+64>>2]|0);c[(c[h>>2]|0)+28>>2]=c[o>>2];c[(c[h>>2]|0)+64>>2]=0;if((c[l>>2]|0)==0&(c[n>>2]|0)==-1)c[l>>2]=-1}while(0);if(!(c[l>>2]|0))c[(c[k>>2]|0)+52>>2]=c[j>>2];c[(c[h>>2]|0)+28>>2]=c[o>>2];c[(c[h>>2]|0)+60>>2]=c[q>>2];if(c[q>>2]|0){a=oO(c[h>>2]|0,c[(c[k>>2]|0)+24>>2]|0)|0;c[(c[q>>2]|0)+4>>2]=a}a=c[h>>2]|0;if(c[l>>2]|0){if(c[a+28>>2]&1)break a;eO(c[h>>2]|0);c[l>>2]=0;break a}else{if((c[a+48>>2]|0)<=(c[p>>2]|0))break a;KO(c[h>>2]|0,c[p>>2]|0);break a}break}case 18:case 10:{c[l>>2]=OO(c[h>>2]|0,c[(c[j>>2]|0)+24>>2]|0)|0;break}case 19:{c[l>>2]=QO(c[h>>2]|0,c[j>>2]|0)|0;break}case 9:{c[l>>2]=IO(c[h>>2]|0,c[j>>2]|0)|0;break}case 13:case 12:case 11:case-1:case 20:{c[l>>2]=KN(c[h>>2]|0,c[(c[j>>2]|0)+24>>2]|0)|0;break}case 5:{c[F>>2]=0;c[E>>2]=c[k>>2];while(1){if(!(c[E>>2]|0))break;if((c[(c[E>>2]|0)+4>>2]|0)==1){R=222;break}if(!((c[(c[E>>2]|0)+4>>2]|0)!=3?(c[(c[E>>2]|0)+4>>2]|0)!=4:0))c[F>>2]=By(c[F>>2]|0,c[(c[E>>2]|0)+40>>2]|0)|0;c[E>>2]=c[(c[E>>2]|0)+24>>2]}if((R|0)==222){FN(c[h>>2]|0,28,c[(c[(c[k>>2]|0)+20>>2]|0)+8>>2]|0,0,0);c[l>>2]=-1}a=c[F>>2]|0;if((c[l>>2]|0)==-1){if(!a)break a;zb[c[135736>>2]&511](c[F>>2]|0);break a}if((a|0)==0?(c[F>>2]=my(188112)|0,(c[F>>2]|0)==0):0){MN(c[h>>2]|0,189544);c[l>>2]=-1;break a}c[l>>2]=RO(c[h>>2]|0,c[F>>2]|0,c[j>>2]|0,c[(c[(c[h>>2]|0)+60>>2]|0)+4>>2]|0)|0;if((c[l>>2]|0)!=-1){if(!(c[l>>2]|0))c[(c[(c[h>>2]|0)+60>>2]|0)+4>>2]=0}else FN(c[h>>2]|0,31,c[(c[j>>2]|0)+8>>2]|0,0,0);if(c[F>>2]|0)zb[c[135736>>2]&511](c[F>>2]|0);break}case 7:{c[G>>2]=0;c[I>>2]=c[k>>2];while(1){if(!(c[I>>2]|0))break;if((c[(c[I>>2]|0)+4>>2]|0)==1){R=242;break}if(!((c[(c[I>>2]|0)+4>>2]|0)!=3?(c[(c[I>>2]|0)+4>>2]|0)!=4:0))c[G>>2]=By(c[G>>2]|0,c[(c[I>>2]|0)+40>>2]|0)|0;c[I>>2]=c[(c[I>>2]|0)+24>>2]}if((R|0)==242){FN(c[h>>2]|0,29,c[(c[(c[k>>2]|0)+20>>2]|0)+8>>2]|0,0,0);c[l>>2]=-1}a=c[G>>2]|0;if((c[l>>2]|0)==-1){if(!a)break a;zb[c[135736>>2]&511](c[G>>2]|0);break a}if((a|0)==0?(c[G>>2]=my(188112)|0,(c[G>>2]|0)==0):0){MN(c[h>>2]|0,189544);c[l>>2]=-1;break a}c[H>>2]=c[(c[(c[h>>2]|0)+60>>2]|0)+20>>2];c[(c[(c[h>>2]|0)+60>>2]|0)+20>>2]=c[G>>2];c[l>>2]=SO(c[h>>2]|0,c[j>>2]|0)|0;c[(c[(c[h>>2]|0)+60>>2]|0)+20>>2]=c[H>>2];if((c[l>>2]|0)!=-1){if(!(c[l>>2]|0))c[(c[(c[h>>2]|0)+60>>2]|0)+4>>2]=0}else FN(c[h>>2]|0,32,c[(c[j>>2]|0)+8>>2]|0,0,0);if(c[G>>2]|0)zb[c[135736>>2]&511](c[G>>2]|0);break}case 8:{c[J>>2]=0;c[K>>2]=c[k>>2];while(1){if(!(c[K>>2]|0))break;if((c[(c[K>>2]|0)+4>>2]|0)==1){R=262;break}if(!((c[(c[K>>2]|0)+4>>2]|0)!=3?(c[(c[K>>2]|0)+4>>2]|0)!=4:0))c[J>>2]=By(c[J>>2]|0,c[(c[K>>2]|0)+40>>2]|0)|0;c[K>>2]=c[(c[K>>2]|0)+24>>2]}if((R|0)==262){FN(c[h>>2]|0,30,c[(c[(c[k>>2]|0)+20>>2]|0)+8>>2]|0,0,0);c[l>>2]=-1}a=c[J>>2]|0;if((c[l>>2]|0)==-1){if(!a)break a;zb[c[135736>>2]&511](c[J>>2]|0);break a}if((a|0)==0?(c[J>>2]=my(188112)|0,(c[J>>2]|0)==0):0){MN(c[h>>2]|0,189544);c[l>>2]=-1;break a}c[N>>2]=xy(c[J>>2]|0)|0;c[L>>2]=c[(c[(c[h>>2]|0)+60>>2]|0)+20>>2];c[M>>2]=c[(c[(c[h>>2]|0)+60>>2]|0)+24>>2];c[(c[(c[h>>2]|0)+60>>2]|0)+20>>2]=c[J>>2];c[(c[(c[h>>2]|0)+60>>2]|0)+24>>2]=(c[J>>2]|0)+(c[N>>2]|0);c[l>>2]=SO(c[h>>2]|0,c[j>>2]|0)|0;c[(c[(c[h>>2]|0)+60>>2]|0)+20>>2]=c[L>>2];c[(c[(c[h>>2]|0)+60>>2]|0)+24>>2]=c[M>>2];if((c[l>>2]|0)!=-1){if((c[l>>2]|0)==0&(c[k>>2]|0)!=0)c[(c[(c[h>>2]|0)+60>>2]|0)+4>>2]=c[(c[k>>2]|0)+24>>2]}else FN(c[h>>2]|0,33,0,0,0);if(c[J>>2]|0)zb[c[135736>>2]&511](c[J>>2]|0);break}case 6:case 2:{a=c[33976]|0;d=c[33980]|0;c[f>>2]=189496;c[f+4>>2]=10569;Db[a&511](d,189464,f);c[l>>2]=-1;break}case 17:{c[B>>2]=0;c[C>>2]=0;c[k>>2]=oO(c[h>>2]|0,c[k>>2]|0)|0;c[p>>2]=c[(c[h>>2]|0)+48>>2];if((b[(c[j>>2]|0)+50>>1]&16|0)!=0?(c[k>>2]|0)!=0?(c[(c[j>>2]|0)+20>>2]|0)!=0:0:0){c[D>>2]=c[(c[j>>2]|0)+20>>2];if((c[(c[k>>2]|0)+4>>2]|0)!=3?(c[(c[k>>2]|0)+4>>2]|0)!=4:0){if((c[(c[k>>2]|0)+4>>2]|0)==1){d=c[D>>2]|0;a=c[(c[k>>2]|0)+8>>2]|0;if(c[(c[k>>2]|0)+36>>2]|0){c[B>>2]=Tj(d,a,c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0)|0;if(!(c[B>>2]|0))c[B>>2]=Tj(c[D>>2]|0,189536,c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0)|0}else c[B>>2]=Tj(d,a,0)|0;if(!(c[B>>2]|0))c[B>>2]=Tj(c[D>>2]|0,189536,0)|0}}else c[B>>2]=Tj(c[D>>2]|0,188096,0)|0;if(!(c[B>>2]|0)){c[l>>2]=-1;FN(c[h>>2]|0,38,c[(c[k>>2]|0)+8>>2]|0,0,0);break a}else{c[l>>2]=KN(c[h>>2]|0,c[B>>2]|0)|0;break a}}c[B>>2]=c[(c[j>>2]|0)+24>>2];c[o>>2]=c[(c[h>>2]|0)+28>>2];a=(c[h>>2]|0)+28|0;c[a>>2]=c[a>>2]|1;while(1){if(!(c[B>>2]|0))break;c[q>>2]=PO(c[h>>2]|0,c[(c[h>>2]|0)+60>>2]|0)|0;c[l>>2]=KN(c[h>>2]|0,c[B>>2]|0)|0;do if(!(c[l>>2]|0)){if(!(c[C>>2]|0))c[C>>2]=mO(c[h>>2]|0,1)|0;a=c[h>>2]|0;if(c[(c[h>>2]|0)+60>>2]|0){lO(a,c[C>>2]|0,c[(c[h>>2]|0)+60>>2]|0)|0;break}if(c[a+64>>2]|0){c[m>>2]=0;while(1){V=c[h>>2]|0;if((c[m>>2]|0)>=(c[c[(c[h>>2]|0)+64>>2]>>2]|0))break;lO(V,c[C>>2]|0,c[(c[(c[(c[h>>2]|0)+64>>2]|0)+8>>2]|0)+(c[m>>2]<<2)>>2]|0)|0;c[m>>2]=(c[m>>2]|0)+1}NN(V,c[(c[h>>2]|0)+64>>2]|0);c[(c[h>>2]|0)+64>>2]=0}}else LN(c[h>>2]|0,c[(c[h>>2]|0)+60>>2]|0);while(0);c[(c[h>>2]|0)+60>>2]=c[q>>2];
c[B>>2]=c[(c[B>>2]|0)+32>>2]}a=c[h>>2]|0;if(c[C>>2]|0){LN(a,c[q>>2]|0);c[(c[h>>2]|0)+64>>2]=c[C>>2];c[(c[h>>2]|0)+60>>2]=0;c[l>>2]=0}else c[a+64>>2]=0;c[(c[h>>2]|0)+28>>2]=c[o>>2];a=c[h>>2]|0;if(c[l>>2]|0){if(c[a+28>>2]&1)break a;eO(c[h>>2]|0);break a}else{if((c[a+48>>2]|0)<=(c[p>>2]|0))break a;KO(c[h>>2]|0,c[p>>2]|0);break a}break}default:{}}while(0);do if((R|0)==124){c[x>>2]=0;c[y>>2]=0;c[p>>2]=c[(c[h>>2]|0)+48>>2];c[y>>2]=mO(c[h>>2]|0,1)|0;if(!(c[y>>2]|0)){c[l>>2]=-1;break}c:do if(c[(c[h>>2]|0)+60>>2]|0){C=c[h>>2]|0;q=c[y>>2]|0;lO(C,q,PO(c[h>>2]|0,c[(c[h>>2]|0)+60>>2]|0)|0)|0}else{c[A>>2]=0;while(1){if((c[A>>2]|0)>=(c[c[(c[h>>2]|0)+64>>2]>>2]|0))break c;q=c[h>>2]|0;C=c[y>>2]|0;lO(q,C,PO(c[h>>2]|0,c[(c[(c[(c[h>>2]|0)+64>>2]|0)+8>>2]|0)+(c[A>>2]<<2)>>2]|0)|0)|0;c[A>>2]=(c[A>>2]|0)+1}}while(0);c[o>>2]=c[(c[h>>2]|0)+28>>2];C=(c[h>>2]|0)+28|0;c[C>>2]=c[C>>2]|1;d:do{c[w>>2]=0;c[z>>2]=c[c[y>>2]>>2];C=c[h>>2]|0;e:do if(!(c[(c[h>>2]|0)+64>>2]|0)){c[l>>2]=OO(C,c[(c[j>>2]|0)+24>>2]|0)|0;if(c[l>>2]|0){LN(c[h>>2]|0,c[(c[h>>2]|0)+60>>2]|0);c[(c[h>>2]|0)+60>>2]=0;break}c[z>>2]=c[c[y>>2]>>2];q=c[h>>2]|0;if(c[(c[h>>2]|0)+60>>2]|0){c[n>>2]=lO(q,c[y>>2]|0,c[(c[h>>2]|0)+60>>2]|0)|0;c[(c[h>>2]|0)+60>>2]=0;if((c[n>>2]|0)!=1)break;c[w>>2]=1;break}if(c[q+64>>2]|0){c[A>>2]=0;while(1){if((c[A>>2]|0)>=(c[c[(c[h>>2]|0)+64>>2]>>2]|0))break;c[n>>2]=lO(c[h>>2]|0,c[y>>2]|0,c[(c[(c[(c[h>>2]|0)+64>>2]|0)+8>>2]|0)+(c[A>>2]<<2)>>2]|0)|0;if((c[n>>2]|0)==1)c[w>>2]=1;c[A>>2]=(c[A>>2]|0)+1}q=c[h>>2]|0;if(!(c[x>>2]|0))c[x>>2]=c[q+64>>2];else NN(q,c[(c[h>>2]|0)+64>>2]|0);c[(c[h>>2]|0)+64>>2]=0}}else{c[x>>2]=c[C+64>>2];c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[c[x>>2]>>2]|0))break e;c[(c[h>>2]|0)+60>>2]=c[(c[(c[x>>2]|0)+8>>2]|0)+(c[m>>2]<<2)>>2];c[(c[h>>2]|0)+64>>2]=0;c[l>>2]=OO(c[h>>2]|0,c[(c[j>>2]|0)+24>>2]|0)|0;q=(c[(c[h>>2]|0)+60>>2]|0)!=0;do if(!(c[l>>2]|0)){B=c[h>>2]|0;if(q){c[n>>2]=lO(B,c[y>>2]|0,c[(c[h>>2]|0)+60>>2]|0)|0;c[(c[h>>2]|0)+60>>2]=0;if((c[n>>2]|0)!=1)break;c[w>>2]=1;break}if(c[B+64>>2]|0){c[A>>2]=0;while(1){W=c[h>>2]|0;if((c[A>>2]|0)>=(c[c[(c[h>>2]|0)+64>>2]>>2]|0))break;c[n>>2]=lO(W,c[y>>2]|0,c[(c[(c[(c[h>>2]|0)+64>>2]|0)+8>>2]|0)+(c[A>>2]<<2)>>2]|0)|0;if((c[n>>2]|0)==1)c[w>>2]=1;c[A>>2]=(c[A>>2]|0)+1}NN(W,c[(c[h>>2]|0)+64>>2]|0);c[(c[h>>2]|0)+64>>2]=0}}else if(q){LN(c[h>>2]|0,c[(c[h>>2]|0)+60>>2]|0);c[(c[h>>2]|0)+60>>2]=0}while(0);c[m>>2]=(c[m>>2]|0)+1}}while(0);do if(c[w>>2]|0){if(((c[c[y>>2]>>2]|0)-(c[z>>2]|0)|0)==1){C=PO(c[h>>2]|0,c[(c[(c[y>>2]|0)+8>>2]|0)+(c[z>>2]<<2)>>2]|0)|0;c[(c[h>>2]|0)+60>>2]=C;break}if((c[x>>2]|0)==0?(mO(c[h>>2]|0,(c[c[y>>2]>>2]|0)-(c[z>>2]|0)|0)|0,c[x>>2]=c[(c[h>>2]|0)+64>>2],(c[x>>2]|0)==0):0){R=169;break d}c[c[x>>2]>>2]=0;c[m>>2]=c[z>>2];while(1){if((c[m>>2]|0)>=(c[c[y>>2]>>2]|0))break;C=c[h>>2]|0;q=c[x>>2]|0;lO(C,q,PO(c[h>>2]|0,c[(c[(c[y>>2]|0)+8>>2]|0)+(c[m>>2]<<2)>>2]|0)|0)|0;c[m>>2]=(c[m>>2]|0)+1}c[(c[h>>2]|0)+64>>2]=c[x>>2]}while(0)}while((c[w>>2]|0)==1);if((R|0)==169)c[w>>2]=0;if(c[x>>2]|0)NN(c[h>>2]|0,c[x>>2]|0);c[(c[h>>2]|0)+64>>2]=c[y>>2];c[(c[h>>2]|0)+28>>2]=c[o>>2];c[l>>2]=0}while(0);o=(c[h>>2]|0)+32|0;c[o>>2]=(c[o>>2]|0)+-1;c[g>>2]=c[l>>2];O=c[g>>2]|0;i=e;return O|0}function lO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if((c[j>>2]|0)==0|(c[h>>2]|0)==0){c[f>>2]=-1;n=c[f>>2]|0;i=e;return n|0}do if((c[c[h>>2]>>2]|0)>=(c[(c[h>>2]|0)+4>>2]|0)){c[m>>2]=c[(c[h>>2]|0)+4>>2]<<1;c[l>>2]=Hb[c[135760>>2]&511](c[(c[h>>2]|0)+8>>2]|0,c[m>>2]<<2)|0;if(c[l>>2]|0){c[(c[h>>2]|0)+8>>2]=c[l>>2];c[(c[h>>2]|0)+4>>2]=c[m>>2];break}MN(c[g>>2]|0,189520);c[f>>2]=-1;n=c[f>>2]|0;i=e;return n|0}while(0);c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[c[h>>2]>>2]|0)){o=12;break}if(TO(c[g>>2]|0,c[j>>2]|0,c[(c[(c[h>>2]|0)+8>>2]|0)+(c[k>>2]<<2)>>2]|0)|0){o=10;break}c[k>>2]=(c[k>>2]|0)+1}if((o|0)==10){LN(c[g>>2]|0,c[j>>2]|0);c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}else if((o|0)==12){o=c[j>>2]|0;j=c[h>>2]|0;g=c[j>>2]|0;c[j>>2]=g+1;c[(c[(c[h>>2]|0)+8>>2]|0)+(g<<2)>>2]=o;c[f>>2]=1;n=c[f>>2]|0;i=e;return n|0}return 0}function mO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if(((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+80>>2]|0)!=0:0)?(c[(c[f>>2]|0)+72>>2]|0)>0:0){b=(c[f>>2]|0)+72|0;c[b>>2]=(c[b>>2]|0)+-1;c[h>>2]=c[(c[(c[f>>2]|0)+80>>2]|0)+(c[(c[f>>2]|0)+72>>2]<<2)>>2];c[c[h>>2]>>2]=0;c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}if((c[g>>2]|0)<16)c[g>>2]=16;c[h>>2]=Cb[c[135744>>2]&511](12+((c[g>>2]|0)-1<<2)|0)|0;if(!(c[h>>2]|0)){MN(c[f>>2]|0,189568);c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}c[c[h>>2]>>2]=0;c[(c[h>>2]|0)+4>>2]=c[g>>2];b=Cb[c[135744>>2]&511](c[g>>2]<<2)|0;c[(c[h>>2]|0)+8>>2]=b;if(!(c[(c[h>>2]|0)+8>>2]|0)){MN(c[f>>2]|0,189568);zb[c[135736>>2]&511](c[h>>2]|0);c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}else{c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}return 0}function nO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(!(c[j>>2]|0)){c[f>>2]=-1;m=c[f>>2]|0;i=e;return m|0}do if((c[c[h>>2]>>2]|0)>=(c[(c[h>>2]|0)+4>>2]|0)){c[l>>2]=c[(c[h>>2]|0)+4>>2]<<1;c[k>>2]=Hb[c[135760>>2]&511](c[(c[h>>2]|0)+8>>2]|0,c[l>>2]<<2)|0;if(c[k>>2]|0){c[(c[h>>2]|0)+8>>2]=c[k>>2];c[(c[h>>2]|0)+4>>2]=c[l>>2];break}MN(c[g>>2]|0,189520);c[f>>2]=-1;m=c[f>>2]|0;i=e;return m|0}while(0);g=c[j>>2]|0;j=c[h>>2]|0;l=c[j>>2]|0;c[j>>2]=l+1;c[(c[(c[h>>2]|0)+8>>2]|0)+(l<<2)>>2]=g;c[f>>2]=1;m=c[f>>2]|0;i=e;return m|0}function oO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;while(1){do if(c[f>>2]|0)if((((c[(c[f>>2]|0)+4>>2]|0)!=8?(c[(c[f>>2]|0)+4>>2]|0)!=7:0)?(c[(c[f>>2]|0)+4>>2]|0)!=19:0)?(c[(c[f>>2]|0)+4>>2]|0)!=20:0){if((c[(c[f>>2]|0)+4>>2]|0)!=3?(c[(c[f>>2]|0)+4>>2]|0)!=4:0){g=0;break}if(!(c[(c[e>>2]|0)+28>>2]&4))g=(sO(c[(c[f>>2]|0)+40>>2]|0)|0)!=0;else g=1}else g=1;else g=0;while(0);h=c[f>>2]|0;if(!g)break;c[f>>2]=c[h+24>>2]}i=d;return h|0}function pO(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=c[(c[g>>2]|0)+44>>2];while(1){if(!(c[h>>2]|0))break;c[j>>2]=c[(c[h>>2]|0)+24>>2];if(!((c[(c[h>>2]|0)+36>>2]|0)!=0?(qy(c[(c[(c[h>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)==0:0))m=5;do if((m|0)==5){m=0;if(qy(c[(c[h>>2]|0)+8>>2]|0,192176)|0){if(qy(c[(c[g>>2]|0)+8>>2]|0,189864)|0)break;if(qy(c[(c[g>>2]|0)+8>>2]|0,189904)|0)break;if(qy(c[(c[g>>2]|0)+8>>2]|0,189928)|0)break;if(qy(c[(c[g>>2]|0)+8>>2]|0,189952)|0)break;if(qy(c[(c[g>>2]|0)+8>>2]|0,190064)|0)break;if(qy(c[(c[g>>2]|0)+8>>2]|0,195016)|0)break;zN(c[f>>2]|0,c[g>>2]|0,1034,196520,c[(c[h>>2]|0)+8>>2]|0,c[(c[g>>2]|0)+8>>2]|0);break}if(qy(c[(c[h>>2]|0)+8>>2]|0,192784)|0){if(qy(c[(c[g>>2]|0)+8>>2]|0,189888)|0)break;if(qy(c[(c[g>>2]|0)+8>>2]|0,192360)|0)break;zN(c[f>>2]|0,c[g>>2]|0,1034,196520,c[(c[h>>2]|0)+8>>2]|0,c[(c[g>>2]|0)+8>>2]|0);break}if(qy(c[(c[h>>2]|0)+8>>2]|0,195400)|0){if(qy(c[(c[g>>2]|0)+8>>2]|0,189936)|0)break;if(qy(c[(c[g>>2]|0)+8>>2]|0,195024)|0)break;zN(c[f>>2]|0,c[g>>2]|0,1034,196520,c[(c[h>>2]|0)+8>>2]|0,c[(c[g>>2]|0)+8>>2]|0);break}if(qy(c[(c[h>>2]|0)+8>>2]|0,194568)|0){if(qy(c[(c[g>>2]|0)+8>>2]|0,190048)|0)break;if(qy(c[(c[g>>2]|0)+8>>2]|0,195016)|0)break;zN(c[f>>2]|0,c[g>>2]|0,1034,196520,c[(c[h>>2]|0)+8>>2]|0,c[(c[g>>2]|0)+8>>2]|0);break}if(!(qy(c[(c[h>>2]|0)+8>>2]|0,193160)|0)){if(qy(c[(c[h>>2]|0)+8>>2]|0,192672)|0)break;zN(c[f>>2]|0,c[g>>2]|0,1113,196680,c[(c[h>>2]|0)+8>>2]|0,c[(c[g>>2]|0)+8>>2]|0);break}c[k>>2]=_h(c[(c[g>>2]|0)+32>>2]|0,c[(c[h>>2]|0)+12>>2]|0,1)|0;if(c[k>>2]|0){do if(d[c[k>>2]>>0]|0){c[l>>2]=yl(c[k>>2]|0)|0;if(!(c[l>>2]|0)){zN(c[f>>2]|0,c[g>>2]|0,1050,196560,c[(c[h>>2]|0)+8>>2]|0,c[k>>2]|0);break}if(!(c[c[l>>2]>>2]|0))zN(c[f>>2]|0,c[g>>2]|0,1118,196600,c[(c[h>>2]|0)+8>>2]|0,c[k>>2]|0);if(c[(c[l>>2]|0)+32>>2]|0)zN(c[f>>2]|0,c[g>>2]|0,1117,196640,c[(c[h>>2]|0)+8>>2]|0,c[k>>2]|0);Al(c[l>>2]|0)}while(0);zb[c[135736>>2]&511](c[k>>2]|0)}}while(0);c[h>>2]=c[j>>2]}i=e;return}function qO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;n=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=0;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[(c[g>>2]|0)+100>>2]|0))break;if(qy(c[(c[(c[(c[g>>2]|0)+108>>2]|0)+(c[n>>2]<<2)>>2]|0)+4>>2]|0,c[h>>2]|0)|0){o=4;break}c[n>>2]=(c[n>>2]|0)+1}if((o|0)==4){zN(c[g>>2]|0,0,1033,196408,c[h>>2]|0,0);c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}c[l>>2]=gg(c[h>>2]|0,0,0)|0;if(!(c[l>>2]|0)){zN(c[g>>2]|0,0,1065,196056,c[h>>2]|0,0);c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}c[k>>2]=Cb[c[135744>>2]&511](24)|0;if(!(c[k>>2]|0)){zN(c[g>>2]|0,c[l>>2]|0,2,196456,c[h>>2]|0,0);Th(c[l>>2]|0);c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}o=c[k>>2]|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[o+16>>2]=0;c[o+20>>2]=0;c[(c[k>>2]|0)+8>>2]=c[l>>2];o=my(c[h>>2]|0)|0;c[(c[k>>2]|0)+4>>2]=o;c[c[k>>2]>>2]=c[(c[g>>2]|0)+60>>2];c[(c[k>>2]|0)+20>>2]=1;c[(c[g>>2]|0)+60>>2]=c[k>>2];if(((c[j>>2]|0)!=0?(c[m>>2]=Pi(c[l>>2]|0)|0,(c[m>>2]|0)!=0):0)?(dj(c[m>>2]|0,192672)|0)==0:0)gj(c[m>>2]|0,192672,c[j>>2]|0)|0;UO(c[g>>2]|0,c[k>>2]|0)|0;c[l>>2]=AN(c[g>>2]|0,c[l>>2]|0)|0;j=c[g>>2]|0;if(!(c[l>>2]|0)){c[j+96>>2]=0;c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}else{VO(j)|0;c[f>>2]=c[k>>2];p=c[f>>2]|0;i=e;return p|0}return 0}function rO(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;i=i+64|0;g=f+48|0;h=f+44|0;j=f+40|0;k=f+36|0;l=f+32|0;m=f+28|0;n=f+24|0;o=f+20|0;p=f+16|0;q=f+12|0;r=f+8|0;s=f+4|0;t=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=0;c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[(c[h>>2]|0)+116>>2]|0))break;if(qy(c[(c[(c[(c[h>>2]|0)+124>>2]|0)+(c[o>>2]<<2)>>2]|0)+4>>2]|0,c[j>>2]|0)|0){u=4;break}c[o>>2]=(c[o>>2]|0)+1}if((u|0)==4){zN(c[h>>2]|0,0,1044,196016,c[j>>2]|0,0);c[g>>2]=0;v=c[g>>2]|0;i=f;return v|0}c[n>>2]=gg(c[j>>2]|0,0,0)|0;if(!(c[n>>2]|0)){zN(c[h>>2]|0,c[k>>2]|0,1065,196056,c[j>>2]|0,0);c[g>>2]=0;v=c[g>>2]|0;i=f;return v|0}c[m>>2]=Cb[c[135744>>2]&511](20)|0;if(!(c[m>>2]|0)){xN(c[h>>2]|0,196088);Th(c[n>>2]|0);c[g>>2]=0;v=c[g>>2]|0;i=f;return v|0}o=c[m>>2]|0;c[o+0>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[o+16>>2]=0;c[(c[m>>2]|0)+8>>2]=c[n>>2];o=my(c[j>>2]|0)|0;c[(c[m>>2]|0)+4>>2]=o;c[c[m>>2]>>2]=c[(c[h>>2]|0)+64>>2];c[(c[h>>2]|0)+64>>2]=c[m>>2];if(((c[l>>2]|0)!=0?(c[p>>2]=Pi(c[n>>2]|0)|0,(c[p>>2]|0)!=0):0)?(dj(c[p>>2]|0,192672)|0)==0:0)gj(c[p>>2]|0,192672,c[l>>2]|0)|0;WO(c[h>>2]|0,c[m>>2]|0)|0;c[n>>2]=AN(c[h>>2]|0,c[n>>2]|0)|0;l=c[h>>2]|0;if(!(c[n>>2]|0)){c[l+112>>2]=0;c[g>>2]=0;v=c[g>>2]|0;i=f;return v|0}XO(l)|0;c[p>>2]=Pi(c[n>>2]|0)|0;if(!(c[p>>2]|0)){zN(c[h>>2]|0,c[k>>2]|0,1022,196112,c[j>>2]|0,0);c[g>>2]=0;v=c[g>>2]|0;i=f;return v|0}if(((((c[p>>2]|0)!=0?(c[(c[p>>2]|0)+36>>2]|0)!=0:0)?(c[(c[p>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[p>>2]|0)+8>>2]|0,190264)|0)!=0:0)?(qy(c[(c[(c[p>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0){c[q>>2]=c[(c[k>>2]|0)+12>>2];while(1){if(!(c[q>>2]|0))break;if(((((c[q>>2]|0)!=0?(c[(c[q>>2]|0)+36>>2]|0)!=0:0)?(c[(c[q>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[q>>2]|0)+8>>2]|0,190048)|0)!=0:0)?(qy(c[(c[(c[q>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0){c[r>>2]=0;c[r>>2]=YO(c[h>>2]|0,c[j>>2]|0,c[(c[p>>2]|0)+12>>2]|0,0)|0;if(!(c[r>>2]|0))zN(c[h>>2]|0,c[k>>2]|0,1107,196216,c[j>>2]|0,0)}else u=33;do if((((((u|0)==33?(u=0,(c[q>>2]|0)!=0):0)?(c[(c[q>>2]|0)+36>>2]|0)!=0:0)?(c[(c[q>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[q>>2]|0)+8>>2]|0,195016)|0)!=0:0)?(qy(c[(c[(c[q>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0){c[s>>2]=Yi(c[q>>2]|0,192176)|0;if(!(c[s>>2]|0)){zN(c[h>>2]|0,c[k>>2]|0,1053,196288,c[j>>2]|0,0);break}ZO(c[s>>2]|0);c[t>>2]=YO(c[h>>2]|0,c[j>>2]|0,c[(c[p>>2]|0)+12>>2]|0,c[s>>2]|0)|0;if(!(c[t>>2]|0))zN(c[h>>2]|0,c[k>>2]|0,1013,196336,c[j>>2]|0,c[s>>2]|0);zb[c[135736>>2]&511](c[s>>2]|0)}while(0);c[q>>2]=c[(c[q>>2]|0)+24>>2]}c[g>>2]=c[m>>2];v=c[g>>2]|0;i=f;return v|0}zN(c[h>>2]|0,c[k>>2]|0,1038,196160,c[j>>2]|0,0);c[g>>2]=0;v=c[g>>2]|0;i=f;return v|0}function sO(a){a=a|0;var b=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;e=b+4|0;f=b;c[f>>2]=a;if(!(c[f>>2]|0)){c[e>>2]=1;g=c[e>>2]|0;i=b;return g|0}a:while(1){if(!(d[c[f>>2]>>0]|0)){h=10;break}do if((d[c[f>>2]>>0]|0|0)!=32){if(9<=(d[c[f>>2]>>0]|0|0)?(d[c[f>>2]>>0]|0|0)<=10:0)break;if((d[c[f>>2]>>0]|0|0)!=13){h=8;break a}}while(0);c[f>>2]=(c[f>>2]|0)+1}if((h|0)==8){c[e>>2]=0;g=c[e>>2]|0;i=b;return g|0}else if((h|0)==10){c[e>>2]=1;g=c[e>>2]|0;i=b;return g|0}return 0}function tO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;if(!(c[g>>2]|0)){zN(c[f>>2]|0,c[g>>2]|0,1037,194984,0,0);c[e>>2]=-1;k=c[e>>2]|0;i=d;return k|0}while(1){if(!(c[g>>2]|0))break;do if(((((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+36>>2]|0)!=0:0)?(c[(c[g>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[g>>2]|0)+8>>2]|0,190048)|0)!=0:0)?(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0){b=c[f>>2]|0;a=c[g>>2]|0;if(!(c[(c[g>>2]|0)+12>>2]|0)){zN(b,a,1106,191968,0,0);break}c[j>>2]=YN(b,c[a+12>>2]|0)|0;if(c[j>>2]|0)c[h>>2]=-1}else l=13;while(0);do if((l|0)==13){l=0;if(((((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+36>>2]|0)!=0:0)?(c[(c[g>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[g>>2]|0)+8>>2]|0,195016)|0)!=0:0)?(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0){c[j>>2]=_O(c[f>>2]|0,c[g>>2]|0)|0;if(!(c[j>>2]|0))break;c[h>>2]=-1;break}if(((((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+36>>2]|0)!=0:0)?(c[(c[g>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[g>>2]|0)+8>>2]|0,195024)|0)!=0:0)?(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0){c[j>>2]=$O(c[f>>2]|0,c[g>>2]|0)|0;if(!(c[j>>2]|0))break;c[h>>2]=-1;break}zN(c[f>>2]|0,c[g>>2]|0,1036,195032,c[(c[g>>2]|0)+8>>2]|0,0);c[h>>2]=-1}while(0);c[g>>2]=c[(c[g>>2]|0)+24>>2]}c[e>>2]=c[h>>2];k=c[e>>2]|0;i=d;return k|0}function uO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+64|0;e=d;f=d+28|0;g=d+24|0;h=d+20|0;j=d+16|0;k=d+12|0;l=d+8|0;m=d+4|0;n=d+32|0;c[f>>2]=a;c[g>>2]=b;c[k>>2]=-1;c[l>>2]=0;c[h>>2]=c[(c[g>>2]|0)+12>>2];if(!(c[h>>2]|0)){i=d;return}if(!(c[(c[h>>2]|0)+32>>2]|0)){i=d;return}c[m>>2]=c[h>>2];while(1){if(!(c[m>>2]|0))break;if(((c[(c[m>>2]|0)+4>>2]|0)!=0?(c[(c[(c[m>>2]|0)+4>>2]|0)+20>>2]|0)!=0:0)?(qy(c[(c[(c[(c[m>>2]|0)+4>>2]|0)+20>>2]|0)+8>>2]|0,190048)|0)!=0:0)c[j>>2]=Yi(c[(c[(c[m>>2]|0)+4>>2]|0)+20>>2]|0,194568)|0;else{c[j>>2]=0;zN(c[f>>2]|0,c[(c[m>>2]|0)+4>>2]|0,1107,194784,0,0)}do if(!(c[j>>2]|0))if(!(c[l>>2]|0)){c[l>>2]=1;break}else{zN(c[f>>2]|0,c[(c[m>>2]|0)+4>>2]|0,1054,194928,0,0);break}else{do if(qy(c[j>>2]|0,190016)|0){if((c[k>>2]|0)==-1){c[k>>2]=1;break}if(!(c[k>>2]|0))zN(c[f>>2]|0,c[(c[m>>2]|0)+4>>2]|0,1104,194832,0,0)}else{if(!(qy(c[j>>2]|0,190032)|0)){zN(c[f>>2]|0,c[(c[m>>2]|0)+4>>2]|0,1114,194880,c[j>>2]|0,0);break}if((c[k>>2]|0)==-1){c[k>>2]=0;break}if((c[k>>2]|0)==1)zN(c[f>>2]|0,c[(c[m>>2]|0)+4>>2]|0,1104,194832,0,0)}while(0);zb[c[135736>>2]&511](c[j>>2]|0)}while(0);c[m>>2]=c[(c[m>>2]|0)+32>>2]}if((c[k>>2]|0)==-1)c[k>>2]=0;c[m>>2]=DN(c[f>>2]|0,c[(c[h>>2]|0)+4>>2]|0)|0;if(!(c[m>>2]|0)){i=d;return}h=c[m>>2]|0;if(!(c[k>>2]|0))c[h>>2]=19;else c[h>>2]=17;c[(c[m>>2]|0)+24>>2]=c[(c[g>>2]|0)+12>>2];c[(c[g>>2]|0)+12>>2]=c[m>>2];if(c[k>>2]|0){i=d;return}if(!(c[(c[f>>2]|0)+56>>2]|0)){k=Ij(10)|0;c[(c[f>>2]|0)+56>>2]=k}if(!(c[(c[f>>2]|0)+56>>2]|0)){zN(c[f>>2]|0,c[(c[m>>2]|0)+4>>2]|0,1046,194736,0,0);i=d;return}k=(c[f>>2]|0)+52|0;g=c[k>>2]|0;c[k>>2]=g+1;c[e>>2]=g;JT(n,32,192704,e)|0;if((Lj(c[(c[f>>2]|0)+56>>2]|0,n,c[m>>2]|0)|0)>=0){i=d;return}zN(c[f>>2]|0,c[(c[m>>2]|0)+4>>2]|0,1046,192720,n,0);i=d;return}function vO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+80|0;f=e;g=e+40|0;h=e+36|0;j=e+32|0;k=e+28|0;l=e+24|0;m=e+20|0;n=e+16|0;o=e+12|0;p=e+8|0;q=e+4|0;r=e+48|0;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[l>>2]=-1;c[m>>2]=0;if(!(c[(c[g>>2]|0)+44>>2]|0)){i=e;return}c[n>>2]=c[g>>2];while(1){if(!(c[n>>2]|0))break;c[k>>2]=Yi(c[(c[n>>2]|0)+4>>2]|0,194568)|0;do if(!(c[k>>2]|0))if(!(c[m>>2]|0)){c[m>>2]=1;break}else{zN(c[h>>2]|0,c[(c[g>>2]|0)+4>>2]|0,1054,194680,c[j>>2]|0,0);break}else{do if(qy(c[k>>2]|0,190016)|0){if((c[l>>2]|0)==-1){c[l>>2]=1;break}if(!(c[l>>2]|0))zN(c[h>>2]|0,c[(c[g>>2]|0)+4>>2]|0,1010,194576,c[j>>2]|0,0)}else{if(!(qy(c[k>>2]|0,190032)|0)){zN(c[h>>2]|0,c[(c[g>>2]|0)+4>>2]|0,1114,194632,c[j>>2]|0,c[k>>2]|0);break}if((c[l>>2]|0)==-1){c[l>>2]=0;break}if((c[l>>2]|0)==1)zN(c[h>>2]|0,c[(c[g>>2]|0)+4>>2]|0,1010,194576,c[j>>2]|0,0)}while(0);zb[c[135736>>2]&511](c[k>>2]|0)}while(0);c[n>>2]=c[(c[n>>2]|0)+44>>2]}if((c[l>>2]|0)==-1)c[l>>2]=0;c[n>>2]=DN(c[h>>2]|0,c[(c[g>>2]|0)+4>>2]|0)|0;if(!(c[n>>2]|0)){i=e;return}k=c[n>>2]|0;if(!(c[l>>2]|0))c[k>>2]=19;else c[k>>2]=17;c[p>>2]=c[g>>2];c[o>>2]=0;while(1){if(!(c[p>>2]|0))break;if(c[(c[p>>2]|0)+24>>2]|0){if(c[(c[(c[p>>2]|0)+24>>2]|0)+32>>2]|0){c[q>>2]=DN(c[h>>2]|0,c[(c[(c[p>>2]|0)+24>>2]|0)+4>>2]|0)|0;if(!(c[q>>2]|0))break;c[c[q>>2]>>2]=18;c[(c[q>>2]|0)+24>>2]=c[(c[p>>2]|0)+24>>2]}else c[q>>2]=c[(c[p>>2]|0)+24>>2];k=c[q>>2]|0;if(!(c[o>>2]|0))c[(c[n>>2]|0)+24>>2]=k;else c[(c[o>>2]|0)+32>>2]=k;c[o>>2]=c[q>>2]}c[(c[p>>2]|0)+24>>2]=c[n>>2];c[p>>2]=c[(c[p>>2]|0)+44>>2]}c[(c[g>>2]|0)+24>>2]=c[n>>2];if(c[l>>2]|0){i=e;return}if(!(c[(c[h>>2]|0)+56>>2]|0)){l=Ij(10)|0;c[(c[h>>2]|0)+56>>2]=l}if(!(c[(c[h>>2]|0)+56>>2]|0)){zN(c[h>>2]|0,c[(c[g>>2]|0)+4>>2]|0,1046,194736,0,0);i=e;return}l=(c[h>>2]|0)+52|0;p=c[l>>2]|0;c[l>>2]=p+1;c[f>>2]=p;JT(r,32,192704,f)|0;if((Lj(c[(c[h>>2]|0)+56>>2]|0,r,c[n>>2]|0)|0)>=0){i=e;return}zN(c[h>>2]|0,c[(c[g>>2]|0)+4>>2]|0,1046,192720,r,0);i=e;return}function wO(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[g>>2]=a;c[h>>2]=d;c[j>>2]=e;if(b[(c[g>>2]|0)+50>>1]&256){i=f;return}c[k>>2]=c[(c[h>>2]|0)+24>>2];if(!(c[k>>2]|0)){zN(c[h>>2]|0,c[(c[g>>2]|0)+4>>2]|0,1,194400,c[j>>2]|0,0);i=f;return}if(c[(c[g>>2]|0)+24>>2]|0){zN(c[h>>2]|0,c[(c[g>>2]|0)+4>>2]|0,1,194456,c[j>>2]|0,0);i=f;return}if(!(c[(c[k>>2]|0)+24>>2]|0)){zN(c[h>>2]|0,c[(c[g>>2]|0)+4>>2]|0,1101,194520,c[j>>2]|0,0);i=f;return}c[l>>2]=Rj(c[(c[k>>2]|0)+24>>2]|0,c[j>>2]|0)|0;if(!(c[l>>2]|0)){zN(c[h>>2]|0,c[(c[g>>2]|0)+4>>2]|0,1101,194520,c[j>>2]|0,0);i=f;return}c[m>>2]=c[g>>2];while(1){if(!(c[m>>2]|0))break;c[(c[m>>2]|0)+24>>2]=c[l>>2];c[m>>2]=c[(c[m>>2]|0)+44>>2]}i=f;return}function xO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=0;c[k>>2]=0;c[m>>2]=c[(c[f>>2]|0)+48>>2];while(1){if(!(c[g>>2]|0))break;if(((((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+36>>2]|0)!=0:0)?(c[(c[g>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[g>>2]|0)+8>>2]|0,189864)|0)!=0:0)?(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0){c[l>>2]=aP(c[f>>2]|0,c[g>>2]|0)|0;if(!(c[j>>2]|0)){d=c[l>>2]|0;c[k>>2]=d;c[j>>2]=d}else{if(((c[h>>2]|0)==1?(c[c[j>>2]>>2]|0)==4:0)?(c[j>>2]|0)==(c[k>>2]|0):0){c[j>>2]=DN(c[f>>2]|0,c[g>>2]|0)|0;c[c[j>>2]>>2]=18;c[(c[j>>2]|0)+24>>2]=c[k>>2]}c[(c[k>>2]|0)+32>>2]=c[l>>2];c[k>>2]=c[l>>2]}c[(c[l>>2]|0)+28>>2]=c[m>>2]}else n=16;do if((n|0)==16?(n=0,c[l>>2]=bP(c[f>>2]|0,c[g>>2]|0)|0,(c[l>>2]|0)!=0):0){d=c[l>>2]|0;if(!(c[j>>2]|0)){c[k>>2]=d;c[j>>2]=d;break}else{c[(c[k>>2]|0)+32>>2]=d;c[k>>2]=c[l>>2];break}}while(0);c[g>>2]=c[(c[g>>2]|0)+24>>2]}i=e;return c[j>>2]|0}function yO(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;c[f+12>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=e;do if(!(c[j>>2]|0)){if(!(c[h>>2]|0)){c[c[g>>2]>>2]=-1;c[j>>2]=c[g>>2];break}if((c[(c[h>>2]|0)+24>>2]|0)==(c[g>>2]|0)){c[(c[h>>2]|0)+24>>2]=c[(c[g>>2]|0)+32>>2];break}if((c[(c[h>>2]|0)+36>>2]|0)==(c[g>>2]|0)){c[(c[h>>2]|0)+36>>2]=c[(c[g>>2]|0)+32>>2];break}if((c[(c[h>>2]|0)+40>>2]|0)==(c[g>>2]|0))c[(c[h>>2]|0)+40>>2]=c[(c[g>>2]|0)+32>>2]}else c[(c[j>>2]|0)+32>>2]=c[(c[g>>2]|0)+32>>2];while(0);i=f;return c[j>>2]|0}function zO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;if(c[(c[f>>2]|0)+36>>2]|0){c[e>>2]=-1;l=c[e>>2]|0;i=d;return l|0}c[h>>2]=0;c[j>>2]=c[g>>2];a:while(1){if(!(c[j>>2]|0)){m=36;break}if((c[c[j>>2]>>2]|0)==4){m=12;break}if((c[c[j>>2]>>2]|0)==3){m=12;break}if((c[c[j>>2]>>2]|0)==5){m=12;break}if((c[c[j>>2]>>2]|0)==6){m=12;break}if((c[c[j>>2]>>2]|0)==8){m=12;break}if((c[c[j>>2]>>2]|0)==7){m=12;break}if(!(c[c[j>>2]>>2]|0)){m=12;break}if(!((((((((((c[c[j>>2]>>2]|0)!=17?(c[c[j>>2]>>2]|0)!=19:0)?(c[c[j>>2]>>2]|0)!=18:0)?(c[c[j>>2]>>2]|0)!=16:0)?(c[c[j>>2]>>2]|0)!=15:0)?(c[c[j>>2]>>2]|0)!=14:0)?(c[c[j>>2]>>2]|0)!=13:0)?(c[c[j>>2]>>2]|0)!=12:0)?(c[c[j>>2]>>2]|0)!=11:0)?(c[c[j>>2]>>2]|0)!=10:0))m=23;if((m|0)==23?(m=0,(c[(c[j>>2]|0)+24>>2]|0)!=0):0){c[h>>2]=c[j>>2];c[j>>2]=c[(c[j>>2]|0)+24>>2];c[k>>2]=c[j>>2];while(1){if(!(c[k>>2]|0))continue a;c[(c[k>>2]|0)+28>>2]=c[h>>2];c[k>>2]=c[(c[k>>2]|0)+32>>2]}}if((c[j>>2]|0)==(c[g>>2]|0)){m=36;break}if(c[(c[j>>2]|0)+32>>2]|0){c[j>>2]=c[(c[j>>2]|0)+32>>2];continue}while(1){c[j>>2]=c[(c[j>>2]|0)+28>>2];if(!(c[j>>2]|0))continue a;if((c[j>>2]|0)==(c[g>>2]|0)){m=32;break a}n=c[j>>2]|0;if(c[(c[j>>2]|0)+32>>2]|0)break;if(!n)continue a}c[j>>2]=c[n+32>>2]}if((m|0)==12){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}else if((m|0)==32){c[e>>2]=1;l=c[e>>2]|0;i=d;return l|0}else if((m|0)==36){c[e>>2]=1;l=c[e>>2]|0;i=d;return l|0}return 0}function AO(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;n=e;c[f>>2]=a;c[g>>2]=d;c[k>>2]=0;if(!(c[g>>2]|0)){i=e;return}if((c[c[g>>2]>>2]|0)!=18?(c[c[g>>2]>>2]|0)!=4:0){i=e;return}if(b[(c[g>>2]|0)+50>>1]&32){i=e;return}if(c[(c[f>>2]|0)+36>>2]|0){i=e;return}c[j>>2]=c[(c[g>>2]|0)+36>>2];while(1){if(!(c[j>>2]|0))break;c[k>>2]=(c[k>>2]|0)+1;c[j>>2]=c[(c[j>>2]|0)+32>>2]}c[j>>2]=c[(c[g>>2]|0)+24>>2];while(1){if(!(c[j>>2]|0))break;c[k>>2]=(c[k>>2]|0)+1;c[j>>2]=c[(c[j>>2]|0)+32>>2]}c[h>>2]=Cb[c[135744>>2]&511](c[k>>2]<<2)|0;if(!(c[h>>2]|0)){xN(c[f>>2]|0,191880);i=e;return}c[l>>2]=0;c[j>>2]=c[(c[g>>2]|0)+36>>2];while(1){if(!(c[j>>2]|0))break;d=aO(c[f>>2]|0,c[j>>2]|0,1)|0;c[(c[h>>2]|0)+(c[l>>2]<<2)>>2]=d;c[l>>2]=(c[l>>2]|0)+1;c[j>>2]=c[(c[j>>2]|0)+32>>2]}c[j>>2]=c[(c[g>>2]|0)+24>>2];while(1){if(!(c[j>>2]|0))break;d=aO(c[f>>2]|0,c[j>>2]|0,1)|0;c[(c[h>>2]|0)+(c[l>>2]<<2)>>2]=d;c[l>>2]=(c[l>>2]|0)+1;c[j>>2]=c[(c[j>>2]|0)+32>>2]}c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[k>>2]|0))break;a:do if(c[(c[h>>2]|0)+(c[l>>2]<<2)>>2]|0){c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[l>>2]|0))break a;if((c[(c[h>>2]|0)+(c[m>>2]<<2)>>2]|0)!=0?(c[n>>2]=bO(c[f>>2]|0,c[(c[h>>2]|0)+(c[l>>2]<<2)>>2]|0,c[(c[h>>2]|0)+(c[m>>2]<<2)>>2]|0)|0,(c[n>>2]|0)==0):0)zN(c[f>>2]|0,c[(c[g>>2]|0)+4>>2]|0,1040,191896,0,0);c[m>>2]=(c[m>>2]|0)+1}}while(0);c[l>>2]=(c[l>>2]|0)+1}c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[k>>2]|0))break;if(c[(c[h>>2]|0)+(c[l>>2]<<2)>>2]|0)zb[c[135736>>2]&511](c[(c[h>>2]|0)+(c[l>>2]<<2)>>2]|0);c[l>>2]=(c[l>>2]|0)+1}zb[c[135736>>2]&511](c[h>>2]|0);h=(c[g>>2]|0)+50|0;b[h>>1]=b[h>>1]|32;i=e;return}function BO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;do if(!((c[f>>2]|0)==-1|(c[g>>2]|0)==-1)){b=c[g>>2]|0;if(!(c[f>>2]|0)){c[e>>2]=b;break}a=c[f>>2]|0;if(!b){c[e>>2]=a;break}if((a|0)==2&(c[g>>2]|0)==2){c[e>>2]=2;break}else{c[e>>2]=-1;break}}else c[e>>2]=-1;while(0);i=d;return c[e>>2]|0}function CO(a,e){a=a|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;i=i+64|0;g=f+52|0;h=f+48|0;j=f+44|0;k=f+40|0;l=f+36|0;m=f+32|0;n=f+28|0;o=f+24|0;p=f+20|0;q=f+16|0;r=f+12|0;s=f+8|0;t=f+4|0;u=f;c[g>>2]=a;c[h>>2]=e;c[l>>2]=0;c[p>>2]=0;c[q>>2]=0;c[r>>2]=0;c[s>>2]=1;if(!(c[h>>2]|0)){i=f;return}if((c[c[h>>2]>>2]|0)!=17){i=f;return}if(b[(c[h>>2]|0)+50>>1]&32){i=f;return}if(c[(c[g>>2]|0)+36>>2]|0){i=f;return}c[p>>2]=cP(c[h>>2]|0)|0;c[k>>2]=c[(c[h>>2]|0)+24>>2];while(1){if(!(c[k>>2]|0))break;c[l>>2]=(c[l>>2]|0)+1;c[k>>2]=c[(c[k>>2]|0)+32>>2]}c[j>>2]=Cb[c[135744>>2]&511](c[l>>2]<<2)|0;if(!(c[j>>2]|0)){xN(c[g>>2]|0,191856);i=f;return}c[m>>2]=0;if(!(c[p>>2]|0))c[r>>2]=Ij(10)|0;else c[s>>2]=0;c[k>>2]=c[(c[h>>2]|0)+24>>2];while(1){if(!(c[k>>2]|0))break;p=aO(c[g>>2]|0,c[k>>2]|0,0)|0;c[(c[j>>2]|0)+(c[m>>2]<<2)>>2]=p;a:do if((c[(c[j>>2]|0)+(c[m>>2]<<2)>>2]|0)!=0?(c[c[(c[j>>2]|0)+(c[m>>2]<<2)>>2]>>2]|0)!=0:0){if((c[s>>2]|0)==1){c[t>>2]=c[(c[j>>2]|0)+(c[m>>2]<<2)>>2];while(1){if(!((c[s>>2]|0)==1?(c[c[t>>2]>>2]|0)!=0:0))break a;do if((c[c[c[t>>2]>>2]>>2]|0)==3){c[u>>2]=Nj(c[r>>2]|0,188096,0,c[k>>2]|0)|0;if(c[u>>2]|0)c[s>>2]=-1}else{if((c[c[c[t>>2]>>2]>>2]|0)==4?(c[(c[c[t>>2]>>2]|0)+8>>2]|0)!=0:0){do if(!(c[(c[c[t>>2]>>2]|0)+12>>2]|0))v=28;else{if(!(d[c[(c[c[t>>2]>>2]|0)+12>>2]>>0]|0)){v=28;break}c[u>>2]=Nj(c[r>>2]|0,c[(c[c[t>>2]>>2]|0)+8>>2]|0,c[(c[c[t>>2]>>2]|0)+12>>2]|0,c[k>>2]|0)|0}while(0);if((v|0)==28){v=0;c[u>>2]=Nj(c[r>>2]|0,c[(c[c[t>>2]>>2]|0)+8>>2]|0,0,c[k>>2]|0)|0}if(!(c[u>>2]|0))break;c[s>>2]=-1;break}if((c[c[c[t>>2]>>2]>>2]|0)!=4){c[s>>2]=-1;break}do if(!(c[(c[c[t>>2]>>2]|0)+12>>2]|0))v=35;else{if(!(d[c[(c[c[t>>2]>>2]|0)+12>>2]>>0]|0)){v=35;break}c[u>>2]=Nj(c[r>>2]|0,189536,c[(c[c[t>>2]>>2]|0)+12>>2]|0,c[k>>2]|0)|0}while(0);if((v|0)==35){v=0;c[u>>2]=Nj(c[r>>2]|0,189536,0,c[k>>2]|0)|0}if(c[u>>2]|0)c[s>>2]=-1}while(0);c[t>>2]=(c[t>>2]|0)+4}}}else v=17;while(0);if((v|0)==17){v=0;c[s>>2]=0}c[m>>2]=(c[m>>2]|0)+1;c[k>>2]=c[(c[k>>2]|0)+32>>2]}c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[l>>2]|0))break;b:do if(c[(c[j>>2]|0)+(c[m>>2]<<2)>>2]|0){c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[m>>2]|0))break b;if((c[(c[j>>2]|0)+(c[n>>2]<<2)>>2]|0)!=0?(c[o>>2]=bO(c[g>>2]|0,c[(c[j>>2]|0)+(c[m>>2]<<2)>>2]|0,c[(c[j>>2]|0)+(c[n>>2]<<2)>>2]|0)|0,(c[o>>2]|0)==0):0)c[q>>2]=1;c[n>>2]=(c[n>>2]|0)+1}}while(0);c[m>>2]=(c[m>>2]|0)+1}c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[l>>2]|0))break;if(c[(c[j>>2]|0)+(c[m>>2]<<2)>>2]|0)zb[c[135736>>2]&511](c[(c[j>>2]|0)+(c[m>>2]<<2)>>2]|0);c[m>>2]=(c[m>>2]|0)+1}zb[c[135736>>2]&511](c[j>>2]|0);if(c[q>>2]|0){q=(c[h>>2]|0)+50|0;b[q>>1]=b[q>>1]|4}if((c[s>>2]|0)!=1){if(c[r>>2]|0)Kj(c[r>>2]|0,0)}else{s=(c[h>>2]|0)+50|0;b[s>>1]=b[s>>1]|16;c[(c[h>>2]|0)+20>>2]=c[r>>2]}r=(c[h>>2]|0)+50|0;b[r>>1]=b[r>>1]|32;i=f;return}function DO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;do if(!((c[f>>2]|0)==-1|(c[g>>2]|0)==-1)){if((c[f>>2]|0)==1|(c[g>>2]|0)==1){c[e>>2]=1;break}if((c[f>>2]|0)==2|(c[g>>2]|0)==2){c[e>>2]=2;break}else{c[e>>2]=0;break}}else c[e>>2]=-1;while(0);i=d;return c[e>>2]|0}function EO(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+240|0;f=e;g=e+224|0;h=e+220|0;j=e+216|0;k=e+212|0;l=e+152|0;m=e+128|0;n=e+8|0;c[h>>2]=a;c[j>>2]=b;c[k>>2]=1;b=n+0|0;a=b+116|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(a|0));c[n+28>>2]=9;do if((c[c[h>>2]>>2]|0)!=4?(c[c[h>>2]>>2]|0)!=9:0){if((c[c[h>>2]>>2]|0)!=3){b=c[33976]|0;a=c[33980]|0;if((c[c[h>>2]>>2]|0)==2){c[f>>2]=189496;c[f+4>>2]=3822;Db[b&511](a,189464,f);c[k>>2]=0;break}else{c[f>>2]=189496;c[f+4>>2]=3824;Db[b&511](a,189464,f);c[k>>2]=0;break}}if((c[c[j>>2]>>2]|0)==3){c[g>>2]=0;o=c[g>>2]|0;i=e;return o|0}else{c[g>>2]=1;o=c[g>>2]|0;i=e;return o|0}}else p=3;while(0);do if((p|0)==3){if((c[c[j>>2]>>2]|0)==3){c[g>>2]=1;o=c[g>>2]|0;i=e;return o|0}if(c[(c[h>>2]|0)+8>>2]|0)c[l+8>>2]=c[(c[h>>2]|0)+8>>2];else c[l+8>>2]=c[47556];do if(c[(c[h>>2]|0)+12>>2]|0){a=l+36|0;if(!(d[c[(c[h>>2]|0)+12>>2]>>0]|0)){c[a>>2]=0;break}else{c[a>>2]=m;c[m+8>>2]=c[(c[h>>2]|0)+12>>2];break}}else c[l+36>>2]=0;while(0);if(!(MO(n,c[j>>2]|0,l)|0)){c[k>>2]=1;break}if(c[(c[h>>2]|0)+40>>2]|0){c[k>>2]=EO(c[(c[h>>2]|0)+40>>2]|0,c[j>>2]|0)|0;break}else{c[k>>2]=0;break}}while(0);if(!(c[k>>2]|0)){c[g>>2]=c[k>>2];o=c[g>>2]|0;i=e;return o|0}if((c[c[j>>2]>>2]|0)!=4?(c[c[j>>2]>>2]|0)!=9:0){a=c[33976]|0;b=c[33980]|0;c[f>>2]=189496;c[f+4>>2]=3855;Db[a&511](b,189464,f);c[k>>2]=0}else p=29;do if((p|0)==29){if(c[(c[j>>2]|0)+8>>2]|0)c[l+8>>2]=c[(c[j>>2]|0)+8>>2];else c[l+8>>2]=c[47556];c[l+36>>2]=m;do if(c[(c[j>>2]|0)+12>>2]|0)if(!(d[c[(c[j>>2]|0)+12>>2]>>0]|0)){c[l+36>>2]=0;break}else{c[m+8>>2]=c[(c[j>>2]|0)+12>>2];break}else c[m+8>>2]=c[47556];while(0);if(!(MO(n,c[h>>2]|0,l)|0)){c[k>>2]=1;break}if(c[(c[j>>2]|0)+40>>2]|0){c[k>>2]=EO(c[(c[j>>2]|0)+40>>2]|0,c[h>>2]|0)|0;break}else{c[k>>2]=0;break}}while(0);c[g>>2]=c[k>>2];o=c[g>>2]|0;i=e;return o|0}function FO(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;a:do if(!(c[e>>2]|0))c[d>>2]=189816;else do switch(c[c[e>>2]>>2]|0){case 10:{c[d>>2]=189920;break a;break}case 5:{c[d>>2]=189872;break a;break}case 17:{c[d>>2]=190016;break a;break}case 16:{c[d>>2]=19e4;break a;break}case 8:{c[d>>2]=189896;break a;break}case 13:{c[d>>2]=189952;break a;break}case 12:{c[d>>2]=189936;break a;break}case 6:{c[d>>2]=190064;break a;break}case 2:{c[d>>2]=189848;break a;break}case 19:{c[d>>2]=190032;break a;break}case 0:{c[d>>2]=189824;break a;break}case 15:{c[d>>2]=189984;break a;break}case 18:{c[d>>2]=190024;break a;break}case 11:{c[d>>2]=189928;break a;break}case 20:{c[d>>2]=190048;break a;break}case 9:{c[d>>2]=189904;break a;break}case-1:{c[d>>2]=190056;break a;break}case 3:{c[d>>2]=189856;break a;break}case 1:{c[d>>2]=189832;break a;break}case 14:{c[d>>2]=189968;break a;break}case 7:{c[d>>2]=189888;break a;break}case 4:{c[d>>2]=189864;break a;break}default:{c[d>>2]=190072;break a}}while(0);while(0);i=b;return c[d>>2]|0}function GO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+1024|0;g=f;h=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+24|0;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if(!(c[k>>2]|0))c[k>>2]=188112;if(!(c[l>>2]|0))c[l>>2]=188112;a[m>>0]=0;do switch(c[j>>2]|0){case 34:{c[h>>2]=oy(189280)|0;n=c[h>>2]|0;i=f;return n|0}case 6:{c[h>>2]=oy(188288)|0;n=c[h>>2]|0;i=f;return n|0}case 11:{c[h>>2]=oy(188440)|0;n=c[h>>2]|0;i=f;return n|0}case 19:{c[g>>2]=c[k>>2];JT(m,1e3,188712,g)|0;break}case 13:{e=c[l>>2]|0;c[g>>2]=c[k>>2];c[g+4>>2]=e;JT(m,1e3,188504,g)|0;break}case 12:{c[g>>2]=c[k>>2];JT(m,1e3,188472,g)|0;break}case 27:{e=c[l>>2]|0;c[g>>2]=c[k>>2];c[g+4>>2]=e;JT(m,1e3,188992,g)|0;break}case 4:{c[g>>2]=c[k>>2];JT(m,1e3,188232,g)|0;break}case 8:{c[g>>2]=c[k>>2];JT(m,1e3,188376,g)|0;break}case 23:{c[h>>2]=oy(188832)|0;n=c[h>>2]|0;i=f;return n|0}case 37:{c[g>>2]=c[k>>2];JT(m,1e3,188352,g)|0;break}case 29:{c[g>>2]=c[k>>2];JT(m,1e3,189112,g)|0;break}case 21:{c[g>>2]=c[k>>2];JT(m,1e3,188752,g)|0;break}case 28:{c[g>>2]=c[k>>2];JT(m,1e3,189072,g)|0;break}case 0:{c[h>>2]=0;n=c[h>>2]|0;i=f;return n|0}case 17:{e=c[l>>2]|0;c[g>>2]=c[k>>2];c[g+4>>2]=e;JT(m,1e3,188576,g)|0;break}case 35:{c[h>>2]=oy(189304)|0;n=c[h>>2]|0;i=f;return n|0}case 32:{c[g>>2]=c[k>>2];JT(m,1e3,189224,g)|0;break}case 25:{c[g>>2]=c[k>>2];JT(m,1e3,188912,g)|0;break}case 36:{c[g>>2]=c[k>>2];JT(m,1e3,189032,g)|0;break}case 15:{c[g>>2]=c[k>>2];JT(m,1e3,188536,g)|0;break}case 39:{c[g>>2]=c[k>>2];JT(m,1e3,188664,g)|0;break}case 7:{c[h>>2]=oy(188320)|0;n=c[h>>2]|0;i=f;return n|0}case 33:{c[h>>2]=oy(189256)|0;n=c[h>>2]|0;i=f;return n|0}case 30:{c[g>>2]=c[k>>2];JT(m,1e3,189152,g)|0;break}case 38:{c[g>>2]=c[k>>2];JT(m,1e3,188624,g)|0;break}case 5:{c[g>>2]=c[k>>2];JT(m,1e3,188256,g)|0;break}case 22:{c[g>>2]=c[k>>2];JT(m,1e3,188792,g)|0;break}case 1:{c[h>>2]=oy(188144)|0;n=c[h>>2]|0;i=f;return n|0}case 10:{c[h>>2]=oy(188400)|0;n=c[h>>2]|0;i=f;return n|0}case 31:{c[g>>2]=c[k>>2];JT(m,1e3,189192,g)|0;break}case 3:{e=c[l>>2]|0;c[g>>2]=c[k>>2];c[g+4>>2]=e;JT(m,1e3,188192,g)|0;break}case 2:{c[g>>2]=c[k>>2];JT(m,1e3,188160,g)|0;break}case 24:{c[g>>2]=c[k>>2];JT(m,1e3,188864,g)|0;break}case 26:{e=c[l>>2]|0;c[g>>2]=c[k>>2];c[g+4>>2]=e;JT(m,1e3,188952,g)|0;break}default:{c[h>>2]=oy(189336)|0;n=c[h>>2]|0;i=f;return n|0}}while(0);if(!(a[m>>0]|0)){c[g>>2]=c[j>>2];JT(m,1e3,189360,g)|0}a[m+999>>0]=0;c[h>>2]=my(m)|0;n=c[h>>2]|0;i=f;return n|0}function HO(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+48|0;j=h;k=h+40|0;l=h+36|0;m=h+32|0;n=h+28|0;o=h+24|0;p=h+20|0;q=h+16|0;r=h+12|0;s=h+8|0;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=0;c[r>>2]=0;c[s>>2]=0;if(c[k>>2]|0){g=c[k>>2]|0;if(c[(c[k>>2]|0)+12>>2]|0)c[q>>2]=c[g+12>>2];else c[r>>2]=c[g+4>>2];
c[s>>2]=c[c[k>>2]>>2];g=(c[k>>2]|0)+16|0;c[g>>2]=(c[g>>2]|0)+1}g=c[q>>2]|0;q=c[r>>2]|0;r=c[s>>2]|0;s=c[l>>2]|0;l=c[m>>2]|0;m=c[o>>2]|0;k=c[p>>2]|0;f=c[n>>2]|0;n=c[p>>2]|0;c[j>>2]=c[o>>2];c[j+4>>2]=n;Xd(g,q,r,0,s,19,l,2,0,0,m,k,0,0,0,f,j);i=h;return}function IO(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+48|0;f=e+36|0;g=e+32|0;h=e+28|0;j=e+24|0;k=e+20|0;l=e+16|0;m=e+12|0;n=e+8|0;o=e+4|0;p=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=0;c[n>>2]=0;if((c[(c[(c[g>>2]|0)+60>>2]|0)+16>>2]|0)<=0){c[f>>2]=-1;q=c[f>>2]|0;i=e;return q|0}b=(c[(c[h>>2]|0)+8>>2]|0)!=0;c[k>>2]=0;do if(b){while(1){if((c[k>>2]|0)>=(c[(c[(c[g>>2]|0)+60>>2]|0)+8>>2]|0))break;c[o>>2]=c[(c[(c[(c[g>>2]|0)+60>>2]|0)+28>>2]|0)+(c[k>>2]<<2)>>2];if((c[o>>2]|0)!=0?(qy(c[(c[h>>2]|0)+8>>2]|0,c[(c[o>>2]|0)+8>>2]|0)|0)!=0:0){if(!((c[(c[h>>2]|0)+12>>2]|0)!=0?(d[c[(c[h>>2]|0)+12>>2]>>0]|0|0)!=0:0))r=9;if((r|0)==9?(r=0,(c[(c[o>>2]|0)+36>>2]|0)==0):0){r=12;break}if((c[(c[o>>2]|0)+36>>2]|0)!=0?(qy(c[(c[h>>2]|0)+12>>2]|0,c[(c[(c[o>>2]|0)+36>>2]|0)+8>>2]|0)|0)!=0:0){r=12;break}}c[k>>2]=(c[k>>2]|0)+1}if((r|0)==12)c[n>>2]=c[o>>2];if(!(c[n>>2]|0)){c[j>>2]=-1;break}c[l>>2]=_h(c[(c[n>>2]|0)+32>>2]|0,c[(c[n>>2]|0)+12>>2]|0,1)|0;c[m>>2]=c[(c[(c[g>>2]|0)+60>>2]|0)+20>>2];c[p>>2]=c[(c[(c[g>>2]|0)+60>>2]|0)+4>>2];c[(c[(c[g>>2]|0)+60>>2]|0)+4>>2]=c[n>>2];c[(c[(c[g>>2]|0)+60>>2]|0)+20>>2]=c[l>>2];c[(c[(c[g>>2]|0)+60>>2]|0)+24>>2]=0;c[j>>2]=dP(c[g>>2]|0,c[(c[h>>2]|0)+24>>2]|0)|0;if(c[(c[(c[g>>2]|0)+60>>2]|0)+20>>2]|0)c[l>>2]=c[(c[(c[g>>2]|0)+60>>2]|0)+20>>2];if(c[l>>2]|0)zb[c[135736>>2]&511](c[l>>2]|0);c[(c[(c[g>>2]|0)+60>>2]|0)+20>>2]=c[m>>2];c[(c[(c[g>>2]|0)+60>>2]|0)+4>>2]=c[p>>2];if(!(c[j>>2]|0)){c[(c[(c[(c[g>>2]|0)+60>>2]|0)+28>>2]|0)+(c[k>>2]<<2)>>2]=0;a=(c[(c[g>>2]|0)+60>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+-1}}else{while(1){if((c[k>>2]|0)>=(c[(c[(c[g>>2]|0)+60>>2]|0)+8>>2]|0))break;c[o>>2]=c[(c[(c[(c[g>>2]|0)+60>>2]|0)+28>>2]|0)+(c[k>>2]<<2)>>2];if((c[o>>2]|0)!=0?(eP(c[g>>2]|0,c[h>>2]|0,c[o>>2]|0)|0)==1:0){r=25;break}c[k>>2]=(c[k>>2]|0)+1}if((r|0)==25)c[n>>2]=c[o>>2];if(!(c[n>>2]|0)){c[j>>2]=-1;break}c[l>>2]=_h(c[(c[n>>2]|0)+32>>2]|0,c[(c[n>>2]|0)+12>>2]|0,1)|0;c[m>>2]=c[(c[(c[g>>2]|0)+60>>2]|0)+20>>2];c[p>>2]=c[(c[(c[g>>2]|0)+60>>2]|0)+4>>2];c[(c[(c[g>>2]|0)+60>>2]|0)+4>>2]=c[n>>2];c[(c[(c[g>>2]|0)+60>>2]|0)+20>>2]=c[l>>2];c[j>>2]=dP(c[g>>2]|0,c[(c[h>>2]|0)+24>>2]|0)|0;if(c[(c[(c[g>>2]|0)+60>>2]|0)+20>>2]|0)c[l>>2]=c[(c[(c[g>>2]|0)+60>>2]|0)+20>>2];if(c[l>>2]|0)zb[c[135736>>2]&511](c[l>>2]|0);c[(c[(c[g>>2]|0)+60>>2]|0)+20>>2]=c[m>>2];c[(c[(c[g>>2]|0)+60>>2]|0)+4>>2]=c[p>>2];if(!(c[j>>2]|0)){c[(c[(c[(c[g>>2]|0)+60>>2]|0)+28>>2]|0)+(c[k>>2]<<2)>>2]=0;a=(c[(c[g>>2]|0)+60>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+-1}}while(0);c[f>>2]=c[j>>2];q=c[f>>2]|0;i=e;return q|0}function JO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b+24|0;e=b+20|0;f=b+16|0;g=b+12|0;h=b+8|0;j=b+4|0;k=b;c[e>>2]=a;c[j>>2]=-1;c[k>>2]=1e6;if(((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+64>>2]|0)!=0:0)?(c[c[(c[e>>2]|0)+64>>2]>>2]|0)>0:0){c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[c[(c[e>>2]|0)+64>>2]>>2]|0))break;c[f>>2]=c[(c[(c[(c[e>>2]|0)+64>>2]|0)+8>>2]|0)+(c[g>>2]<<2)>>2];do if(c[f>>2]|0){if(c[(c[f>>2]|0)+4>>2]|0){if(!((c[j>>2]|0)==-1|(c[k>>2]|0)>1e5))break;c[k>>2]=1e5;c[j>>2]=c[g>>2];break}c[h>>2]=c[(c[f>>2]|0)+16>>2];if((c[j>>2]|0)!=-1?(c[k>>2]|0)<=(c[h>>2]|0):0)break;c[k>>2]=c[h>>2];c[j>>2]=c[g>>2]}while(0);c[g>>2]=(c[g>>2]|0)+1}c[d>>2]=c[j>>2];l=c[d>>2]|0;i=b;return l|0}c[d>>2]=-1;l=c[d>>2]|0;i=b;return l|0}function KO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=c[f>>2];while(1){if((c[g>>2]|0)>=(c[(c[e>>2]|0)+48>>2]|0))break;c[h>>2]=(c[(c[e>>2]|0)+56>>2]|0)+((c[g>>2]|0)*24|0);if(c[(c[h>>2]|0)+4>>2]&1){if(c[(c[h>>2]|0)+16>>2]|0)zb[c[135736>>2]&511](c[(c[h>>2]|0)+16>>2]|0);c[(c[h>>2]|0)+16>>2]=0;if(c[(c[h>>2]|0)+20>>2]|0)zb[c[135736>>2]&511](c[(c[h>>2]|0)+20>>2]|0);c[(c[h>>2]|0)+20>>2]=0;c[(c[h>>2]|0)+4>>2]=0}c[g>>2]=(c[g>>2]|0)+1}c[(c[e>>2]|0)+48>>2]=c[f>>2];if((c[(c[e>>2]|0)+48>>2]|0)>0){i=d;return}c[(c[e>>2]|0)+44>>2]=0;i=d;return}function LO(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;a=c[d>>2]|0;if((c[(c[d>>2]|0)+48>>2]|0)<=0){c[a+44>>2]=0;i=b;return}f=a+48|0;c[f>>2]=(c[f>>2]|0)+-1;f=c[d>>2]|0;if((c[(c[d>>2]|0)+48>>2]|0)>0)c[(c[d>>2]|0)+44>>2]=(c[(c[d>>2]|0)+56>>2]|0)+(((c[f+48>>2]|0)-1|0)*24|0);else c[f+44>>2]=0;c[e>>2]=(c[(c[d>>2]|0)+56>>2]|0)+((c[(c[d>>2]|0)+48>>2]|0)*24|0);if(!(c[(c[e>>2]|0)+4>>2]&1)){i=b;return}if(c[(c[e>>2]|0)+16>>2]|0)zb[c[135736>>2]&511](c[(c[e>>2]|0)+16>>2]|0);c[(c[e>>2]|0)+16>>2]=0;if(c[(c[e>>2]|0)+20>>2]|0)zb[c[135736>>2]&511](c[(c[e>>2]|0)+20>>2]|0);c[(c[e>>2]|0)+20>>2]=0;c[(c[e>>2]|0)+4>>2]=0;i=b;return}function MO(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+48|0;g=f;h=f+36|0;j=f+32|0;k=f+28|0;l=f+24|0;m=f+20|0;n=f+16|0;o=f+12|0;p=f+8|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=e;c[m>>2]=0;c[n>>2]=0;if((c[(c[k>>2]|0)+8>>2]|0)!=0?(qy(c[(c[l>>2]|0)+8>>2]|0,c[(c[k>>2]|0)+8>>2]|0)|0)==0:0){FN(c[j>>2]|0,13,c[(c[k>>2]|0)+8>>2]|0,c[(c[l>>2]|0)+8>>2]|0,0);c[h>>2]=0;q=c[h>>2]|0;i=f;return q|0}if((c[(c[k>>2]|0)+12>>2]|0)!=0?(d[c[(c[k>>2]|0)+12>>2]>>0]|0|0)!=0:0){if(!(c[(c[l>>2]|0)+36>>2]|0)){FN(c[j>>2]|0,15,c[(c[l>>2]|0)+8>>2]|0,0,0);c[h>>2]=0;q=c[h>>2]|0;i=f;return q|0}if(!(qy(c[(c[(c[l>>2]|0)+36>>2]|0)+8>>2]|0,c[(c[k>>2]|0)+12>>2]|0)|0)){FN(c[j>>2]|0,17,c[(c[l>>2]|0)+8>>2]|0,c[(c[k>>2]|0)+12>>2]|0,0);c[h>>2]=0;q=c[h>>2]|0;i=f;return q|0}}else{if(((c[(c[l>>2]|0)+36>>2]|0)!=0?(c[(c[k>>2]|0)+12>>2]|0)!=0:0)?(c[(c[k>>2]|0)+8>>2]|0)==0:0){FN(c[j>>2]|0,19,c[(c[l>>2]|0)+8>>2]|0,0,0);c[h>>2]=0;q=c[h>>2]|0;i=f;return q|0}if((c[(c[l>>2]|0)+36>>2]|0)!=0?(c[(c[k>>2]|0)+8>>2]|0)!=0:0){FN(c[j>>2]|0,19,c[(c[k>>2]|0)+8>>2]|0,0,0);c[h>>2]=0;q=c[h>>2]|0;i=f;return q|0}}if(!(c[(c[k>>2]|0)+40>>2]|0)){c[h>>2]=1;q=c[h>>2]|0;i=f;return q|0}c[k>>2]=c[(c[k>>2]|0)+40>>2];do if((c[c[k>>2]>>2]|0)==2){if(c[j>>2]|0){c[n>>2]=c[(c[j>>2]|0)+28>>2];e=(c[j>>2]|0)+28|0;c[e>>2]=c[e>>2]|1}c[o>>2]=c[(c[k>>2]|0)+24>>2];while(1){if(!(c[o>>2]|0)){r=33;break}c[m>>2]=MO(c[j>>2]|0,c[o>>2]|0,c[l>>2]|0)|0;if((c[m>>2]|0)==1){r=25;break}if((c[m>>2]|0)<0){r=29;break}c[o>>2]=c[(c[o>>2]|0)+32>>2]}if((r|0)==25){if(c[j>>2]|0)c[(c[j>>2]|0)+28>>2]=c[n>>2];c[h>>2]=0;q=c[h>>2]|0;i=f;return q|0}else if((r|0)==29){if(c[j>>2]|0)c[(c[j>>2]|0)+28>>2]=c[n>>2];c[h>>2]=c[m>>2];q=c[h>>2]|0;i=f;return q|0}else if((r|0)==33){c[m>>2]=1;if(!(c[j>>2]|0))break;c[(c[j>>2]|0)+28>>2]=c[n>>2];break}}else{if((c[c[k>>2]>>2]|0)!=17){e=c[33976]|0;b=c[33980]|0;c[g>>2]=189496;c[g+4>>2]=9708;Db[e&511](b,189464,g);c[m>>2]=-1;break}if(c[j>>2]|0){c[n>>2]=c[(c[j>>2]|0)+28>>2];b=(c[j>>2]|0)+28|0;c[b>>2]=c[b>>2]|1}c[p>>2]=c[(c[k>>2]|0)+40>>2];while(1){s=c[j>>2]|0;if(!(c[p>>2]|0)){r=49;break}c[m>>2]=MO(s,c[p>>2]|0,c[l>>2]|0)|0;if((c[m>>2]|0)==1){r=41;break}if((c[m>>2]|0)<0){r=45;break}c[p>>2]=c[(c[p>>2]|0)+32>>2]}if((r|0)==41){if(c[j>>2]|0)c[(c[j>>2]|0)+28>>2]=c[n>>2];c[h>>2]=1;q=c[h>>2]|0;i=f;return q|0}else if((r|0)==45){if(c[j>>2]|0)c[(c[j>>2]|0)+28>>2]=c[n>>2];c[h>>2]=c[m>>2];q=c[h>>2]|0;i=f;return q|0}else if((r|0)==49){do if(s){b=c[j>>2]|0;if(c[m>>2]|0){if(c[b+28>>2]&1)break;eO(c[j>>2]|0);break}else{if((c[b+48>>2]|0)<=0)break;KO(c[j>>2]|0,0);break}}while(0);c[m>>2]=0;if(!(c[j>>2]|0))break;c[(c[j>>2]|0)+28>>2]=c[n>>2];break}}while(0);c[h>>2]=c[m>>2];q=c[h>>2]|0;i=f;return q|0}function NO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;n=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[m>>2]=0;if((c[g>>2]|0)==0|(c[h>>2]|0)==0){c[f>>2]=-1;o=c[f>>2]|0;i=e;return o|0}c[n>>2]=c[(c[g>>2]|0)+112>>2];c[k>>2]=oz(c[h>>2]|0,385,c[g>>2]|0)|0;c[(c[g>>2]|0)+112>>2]=0;c[l>>2]=c[j>>2];while(1){if(!(c[l>>2]|0))break;c[(c[(c[g>>2]|0)+60>>2]|0)+4>>2]=c[l>>2];j=c[(c[l>>2]|0)+4>>2]|0;if((j|0)==1){h=c[k>>2]|0;d=c[(c[l>>2]|0)+8>>2]|0;if(c[(c[l>>2]|0)+36>>2]|0)c[m>>2]=rz(h,d,c[(c[(c[l>>2]|0)+36>>2]|0)+8>>2]|0,c[g>>2]|0)|0;else c[m>>2]=qz(h,d,c[g>>2]|0)|0;if((c[m>>2]|0)<0)FN(c[g>>2]|0,38,c[(c[l>>2]|0)+8>>2]|0,0,0)}else if(((j|0)==4|(j|0)==3?(ij(c[l>>2]|0)|0)==0:0)?(c[m>>2]=qz(c[k>>2]|0,188096,c[g>>2]|0)|0,(c[m>>2]|0)<0):0)FN(c[g>>2]|0,39,c[(c[(c[l>>2]|0)+20>>2]|0)+8>>2]|0,0,0);if((c[m>>2]|0)<0)break;c[l>>2]=c[(c[l>>2]|0)+24>>2]}c[m>>2]=qz(c[k>>2]|0,0,0)|0;do if((c[m>>2]|0)!=1){if(c[m>>2]|0){c[m>>2]=-1;break}FN(c[g>>2]|0,22,188112,0,0);c[m>>2]=-1;if(!(c[(c[g>>2]|0)+28>>2]&1))eO(c[g>>2]|0)}else{c[m>>2]=0;c[(c[(c[g>>2]|0)+60>>2]|0)+4>>2]=0}while(0);pz(c[k>>2]|0);if((c[m>>2]|0)==0?(c[(c[g>>2]|0)+112>>2]|0)!=0:0)c[m>>2]=c[(c[g>>2]|0)+112>>2];c[(c[g>>2]|0)+112>>2]=c[n>>2];c[f>>2]=c[m>>2];o=c[f>>2]|0;i=e;return o|0}function OO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;if(!(c[g>>2]|0)){FN(c[f>>2]|0,37,189592,0,0);c[e>>2]=-1;k=c[e>>2]|0;i=d;return k|0}while(1){if(!(c[g>>2]|0)){l=11;break}if((c[(c[f>>2]|0)+60>>2]|0)==0?(c[(c[f>>2]|0)+64>>2]|0)==0:0){l=8;break}c[j>>2]=KN(c[f>>2]|0,c[g>>2]|0)|0;if((c[j>>2]|0)<0)c[h>>2]=-1;if((c[j>>2]|0)==-1){l=11;break}c[g>>2]=c[(c[g>>2]|0)+32>>2]}if((l|0)==8){FN(c[f>>2]|0,6,0,0,0);c[e>>2]=-1;k=c[e>>2]|0;i=d;return k|0}else if((l|0)==11){c[e>>2]=c[h>>2];k=c[e>>2]|0;i=d;return k|0}return 0}function PO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[f>>2]=a;c[g>>2]=b;if(!(c[g>>2]|0)){c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}if((c[(c[f>>2]|0)+68>>2]|0)!=0?(c[c[(c[f>>2]|0)+68>>2]>>2]|0)>0:0){b=c[(c[f>>2]|0)+68>>2]|0;c[b>>2]=(c[b>>2]|0)+-1;c[h>>2]=c[(c[(c[(c[f>>2]|0)+68>>2]|0)+8>>2]|0)+(c[c[(c[f>>2]|0)+68>>2]>>2]<<2)>>2]}else n=6;do if((n|0)==6){c[h>>2]=Cb[c[135744>>2]&511](32)|0;if(c[h>>2]|0){b=c[h>>2]|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;c[b+28>>2]=0;break}MN(c[f>>2]|0,189568);c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}while(0);c[k>>2]=c[(c[h>>2]|0)+28>>2];c[j>>2]=c[(c[h>>2]|0)+12>>2];n=c[h>>2]|0;b=c[g>>2]|0;c[n+0>>2]=c[b+0>>2];c[n+4>>2]=c[b+4>>2];c[n+8>>2]=c[b+8>>2];c[n+12>>2]=c[b+12>>2];c[n+16>>2]=c[b+16>>2];c[n+20>>2]=c[b+20>>2];c[n+24>>2]=c[b+24>>2];c[n+28>>2]=c[b+28>>2];c[(c[h>>2]|0)+28>>2]=c[k>>2];c[(c[h>>2]|0)+12>>2]=c[j>>2];if((c[(c[g>>2]|0)+8>>2]|0)>0){do if(!(c[(c[h>>2]|0)+28>>2]|0)){c[(c[h>>2]|0)+12>>2]=c[(c[g>>2]|0)+12>>2];j=Cb[c[135744>>2]&511](c[(c[h>>2]|0)+12>>2]<<2)|0;c[(c[h>>2]|0)+28>>2]=j;if(!(c[(c[h>>2]|0)+28>>2]|0)){MN(c[f>>2]|0,189568);c[(c[h>>2]|0)+8>>2]=0;c[e>>2]=c[h>>2];m=c[e>>2]|0;i=d;return m|0}}else if((c[(c[h>>2]|0)+12>>2]|0)<(c[(c[g>>2]|0)+8>>2]|0)){c[l>>2]=Hb[c[135760>>2]&511](c[(c[h>>2]|0)+28>>2]|0,c[(c[g>>2]|0)+12>>2]<<2)|0;if(c[l>>2]|0){c[(c[h>>2]|0)+12>>2]=c[(c[g>>2]|0)+12>>2];c[(c[h>>2]|0)+28>>2]=c[l>>2];break}MN(c[f>>2]|0,189568);c[(c[h>>2]|0)+8>>2]=0;c[e>>2]=c[h>>2];m=c[e>>2]|0;i=d;return m|0}while(0);eU(c[(c[h>>2]|0)+28>>2]|0,c[(c[g>>2]|0)+28>>2]|0,c[(c[g>>2]|0)+8>>2]<<2|0)|0}c[e>>2]=c[h>>2];m=c[e>>2]|0;i=d;return m|0}function QO(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=i;i=i+96|0;f=e+88|0;g=e+84|0;h=e+80|0;j=e+76|0;k=e+72|0;l=e+68|0;m=e+64|0;n=e+60|0;o=e+56|0;p=e+52|0;q=e+48|0;r=e+44|0;s=e+40|0;t=e+36|0;u=e+32|0;v=e+28|0;w=e+24|0;x=e+20|0;y=e+16|0;z=e+12|0;A=e+8|0;B=e+4|0;C=e;c[g>>2]=a;c[h>>2]=d;c[j>>2]=0;c[m>>2]=c[(c[g>>2]|0)+48>>2];c[q>>2]=0;c[t>>2]=0;c[u>>2]=0;c[w>>2]=0;c[x>>2]=0;if(!(c[(c[h>>2]|0)+20>>2]|0)){FN(c[g>>2]|0,10,0,0,0);c[f>>2]=-1;D=c[f>>2]|0;i=e;return D|0}c[p>>2]=c[(c[h>>2]|0)+20>>2];c[l>>2]=c[c[p>>2]>>2];c[n>>2]=c[(c[g>>2]|0)+28>>2];if((b[(c[h>>2]|0)+50>>1]&8|0)!=0?(h=(c[g>>2]|0)+28|0,c[h>>2]=c[h>>2]|4,(c[l>>2]|0)==2):0){if(c[(c[g>>2]|0)+60>>2]|0){h=oO(c[g>>2]|0,c[(c[(c[g>>2]|0)+60>>2]|0)+4>>2]|0)|0;c[(c[(c[g>>2]|0)+60>>2]|0)+4>>2]=h}h=c[g>>2]|0;d=c[(c[p>>2]|0)+12>>2]|0;if((c[c[c[c[(c[p>>2]|0)+12>>2]>>2]>>2]>>2]|0)==3)c[j>>2]=KN(h,c[c[d+4>>2]>>2]|0)|0;else c[j>>2]=KN(h,c[c[d>>2]>>2]|0)|0;if((c[j>>2]|0)==0?(c[(c[g>>2]|0)+60>>2]|0)!=0:0){d=oO(c[g>>2]|0,c[(c[(c[g>>2]|0)+60>>2]|0)+4>>2]|0)|0;c[(c[(c[g>>2]|0)+60>>2]|0)+4>>2]=d}c[(c[g>>2]|0)+28>>2]=c[n>>2];c[f>>2]=c[j>>2];D=c[f>>2]|0;i=e;return D|0}c[w>>2]=Cb[c[135744>>2]&511](c[l>>2]<<2)|0;if(!(c[w>>2]|0)){MN(c[g>>2]|0,189544);c[f>>2]=-1;D=c[f>>2]|0;i=e;return D|0}cU(c[w>>2]|0,0,c[l>>2]<<2|0)|0;c[x>>2]=Cb[c[135744>>2]&511](c[l>>2]<<2)|0;if(!(c[x>>2]|0)){MN(c[g>>2]|0,189544);c[f>>2]=-1;D=c[f>>2]|0;i=e;return D|0}cU(c[x>>2]|0,0,c[l>>2]<<2|0)|0;c[r>>2]=c[(c[(c[g>>2]|0)+60>>2]|0)+4>>2];c[r>>2]=oO(c[g>>2]|0,c[r>>2]|0)|0;c[s>>2]=c[r>>2];while(1){if(!(c[r>>2]|0))break;c[(c[(c[g>>2]|0)+60>>2]|0)+4>>2]=c[r>>2];do if((c[(c[p>>2]|0)+4>>2]|0)!=0?(c[(c[p>>2]|0)+8>>2]&1|0)!=0:0){c[y>>2]=0;if((c[(c[r>>2]|0)+4>>2]|0)!=3?(c[(c[r>>2]|0)+4>>2]|0)!=4:0){if((c[(c[r>>2]|0)+4>>2]|0)==1){d=c[(c[p>>2]|0)+4>>2]|0;h=c[(c[r>>2]|0)+8>>2]|0;if(c[(c[r>>2]|0)+36>>2]|0){c[y>>2]=Tj(d,h,c[(c[(c[r>>2]|0)+36>>2]|0)+8>>2]|0)|0;if(!(c[y>>2]|0))c[y>>2]=Tj(c[(c[p>>2]|0)+4>>2]|0,189536,c[(c[(c[r>>2]|0)+36>>2]|0)+8>>2]|0)|0}else c[y>>2]=Tj(d,h,0)|0;if(!(c[y>>2]|0))c[y>>2]=Tj(c[(c[p>>2]|0)+4>>2]|0,189536,0)|0}}else c[y>>2]=Tj(c[(c[p>>2]|0)+4>>2]|0,188096,0)|0;if(!(c[y>>2]|0)){c[k>>2]=c[l>>2];break}c[k>>2]=(c[y>>2]|0)-1;if((c[(c[p>>2]|0)+8>>2]&2|0)!=0?(c[q>>2]=c[(c[(c[p>>2]|0)+12>>2]|0)+(c[k>>2]<<2)>>2],(gP(c[r>>2]|0,c[(c[q>>2]|0)+4>>2]|0)|0)==0):0)c[k>>2]=c[l>>2]}else E=37;while(0);a:do if((E|0)==37){E=0;c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[l>>2]|0))break a;c[q>>2]=c[(c[(c[p>>2]|0)+12>>2]|0)+(c[k>>2]<<2)>>2];if((c[q>>2]|0)!=0?(gP(c[r>>2]|0,c[(c[q>>2]|0)+4>>2]|0)|0)!=0:0)break a;c[k>>2]=(c[k>>2]|0)+1}}while(0);if((c[k>>2]|0)>=(c[l>>2]|0))break;h=c[r>>2]|0;d=c[k>>2]|0;if(c[(c[x>>2]|0)+(c[k>>2]<<2)>>2]|0){c[(c[(c[x>>2]|0)+(d<<2)>>2]|0)+24>>2]=h;c[(c[x>>2]|0)+(c[k>>2]<<2)>>2]=c[r>>2]}else{c[(c[w>>2]|0)+(d<<2)>>2]=h;c[(c[x>>2]|0)+(c[k>>2]<<2)>>2]=c[r>>2]}h=c[r>>2]|0;if(c[(c[r>>2]|0)+24>>2]|0)c[u>>2]=c[h+24>>2];else c[u>>2]=h;c[r>>2]=oO(c[g>>2]|0,c[(c[r>>2]|0)+24>>2]|0)|0}do if(!(c[j>>2]|0)){c[v>>2]=c[r>>2];c[o>>2]=c[(c[g>>2]|0)+60>>2];c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[l>>2]|0))break;y=PO(c[g>>2]|0,c[o>>2]|0)|0;c[(c[g>>2]|0)+60>>2]=y;if(!(c[(c[g>>2]|0)+60>>2]|0)){E=55;break}c[q>>2]=c[(c[(c[p>>2]|0)+12>>2]|0)+(c[k>>2]<<2)>>2];if(c[(c[x>>2]|0)+(c[k>>2]<<2)>>2]|0){c[t>>2]=c[(c[(c[x>>2]|0)+(c[k>>2]<<2)>>2]|0)+24>>2];c[(c[(c[x>>2]|0)+(c[k>>2]<<2)>>2]|0)+24>>2]=0}c[(c[(c[g>>2]|0)+60>>2]|0)+4>>2]=c[(c[w>>2]|0)+(c[k>>2]<<2)>>2];c[j>>2]=KN(c[g>>2]|0,c[c[q>>2]>>2]|0)|0;if(c[j>>2]|0)break;y=c[g>>2]|0;if(c[(c[g>>2]|0)+60>>2]|0){c[r>>2]=c[(c[y+60>>2]|0)+4>>2];c[r>>2]=oO(c[g>>2]|0,c[r>>2]|0)|0;LN(c[g>>2]|0,c[o>>2]|0);c[o>>2]=c[(c[g>>2]|0)+60>>2];c[(c[g>>2]|0)+60>>2]=0;if(c[r>>2]|0){E=61;break}}else{if(!(c[y+64>>2]|0)){E=89;break}c[A>>2]=0;c[B>>2]=-1;c[C>>2]=-1;c[z>>2]=0;b:while(1){if((c[z>>2]|0)>=(c[c[(c[g>>2]|0)+64>>2]>>2]|0))break;c[r>>2]=c[(c[(c[(c[(c[g>>2]|0)+64>>2]|0)+8>>2]|0)+(c[z>>2]<<2)>>2]|0)+4>>2];c[r>>2]=oO(c[g>>2]|0,c[r>>2]|0)|0;y=(c[A>>2]|0)==0;do if(!(c[r>>2]|0)){if(y){c[C>>2]=c[(c[(c[(c[(c[g>>2]|0)+64>>2]|0)+8>>2]|0)+(c[z>>2]<<2)>>2]|0)+16>>2];c[B>>2]=c[z>>2]}c[A>>2]=1;if((c[(c[(c[(c[(c[g>>2]|0)+64>>2]|0)+8>>2]|0)+(c[z>>2]<<2)>>2]|0)+16>>2]|0)<=(c[C>>2]|0)){c[C>>2]=c[(c[(c[(c[(c[g>>2]|0)+64>>2]|0)+8>>2]|0)+(c[z>>2]<<2)>>2]|0)+16>>2];c[B>>2]=c[z>>2]}if(!(c[C>>2]|0))break b}else if(y){h=c[(c[(c[(c[(c[g>>2]|0)+64>>2]|0)+8>>2]|0)+(c[z>>2]<<2)>>2]|0)+16>>2]|0;if((c[C>>2]|0)==-1){c[C>>2]=h;c[B>>2]=c[z>>2];break}if((h|0)>(c[C>>2]|0))break;c[C>>2]=c[(c[(c[(c[(c[g>>2]|0)+64>>2]|0)+8>>2]|0)+(c[z>>2]<<2)>>2]|0)+16>>2];c[B>>2]=c[z>>2]}while(0);c[z>>2]=(c[z>>2]|0)+1}do if((c[c[(c[g>>2]|0)+64>>2]>>2]|0)>0){LN(c[g>>2]|0,c[o>>2]|0);if((c[B>>2]|0)!=-1){c[o>>2]=c[(c[(c[(c[g>>2]|0)+64>>2]|0)+8>>2]|0)+(c[B>>2]<<2)>>2];c[(c[(c[(c[g>>2]|0)+64>>2]|0)+8>>2]|0)+(c[B>>2]<<2)>>2]=0;break}else{c[o>>2]=c[(c[(c[(c[g>>2]|0)+64>>2]|0)+8>>2]|0)+((c[c[(c[g>>2]|0)+64>>2]>>2]|0)-1<<2)>>2];c[(c[(c[(c[g>>2]|0)+64>>2]|0)+8>>2]|0)+((c[c[(c[g>>2]|0)+64>>2]>>2]|0)-1<<2)>>2]=0;y=c[(c[g>>2]|0)+64>>2]|0;c[y>>2]=(c[y>>2]|0)+-1;break}}while(0);c[z>>2]=0;while(1){F=c[g>>2]|0;if((c[z>>2]|0)>=(c[c[(c[g>>2]|0)+64>>2]>>2]|0))break;LN(F,c[(c[(c[(c[g>>2]|0)+64>>2]|0)+8>>2]|0)+(c[z>>2]<<2)>>2]|0);c[z>>2]=(c[z>>2]|0)+1}NN(F,c[(c[g>>2]|0)+64>>2]|0);c[(c[g>>2]|0)+64>>2]=0;if(!(c[A>>2]|0)){E=85;break}}if(c[(c[x>>2]|0)+(c[k>>2]<<2)>>2]|0)c[(c[(c[x>>2]|0)+(c[k>>2]<<2)>>2]|0)+24>>2]=c[t>>2];c[k>>2]=(c[k>>2]|0)+1}if((E|0)==55)c[j>>2]=-1;else if((E|0)==61){FN(c[g>>2]|0,12,c[(c[r>>2]|0)+8>>2]|0,0,0);c[j>>2]=-1;c[(c[g>>2]|0)+60>>2]=c[o>>2];break}else if((E|0)==85){y=c[g>>2]|0;if(!(c[r>>2]|0))FN(y,12,189560,0,0);else FN(y,12,c[(c[r>>2]|0)+8>>2]|0,0,0);c[j>>2]=-1;c[(c[g>>2]|0)+60>>2]=c[o>>2];break}else if((E|0)==89)c[j>>2]=-1;if(c[(c[g>>2]|0)+60>>2]|0)LN(c[g>>2]|0,c[(c[g>>2]|0)+60>>2]|0);c[(c[g>>2]|0)+60>>2]=c[o>>2];c[(c[(c[g>>2]|0)+60>>2]|0)+4>>2]=c[v>>2];if(c[j>>2]|0){FN(c[g>>2]|0,11,0,0,0);c[j>>2]=-1}}else{FN(c[g>>2]|0,11,0,0,0);c[j>>2]=-1}while(0);c[(c[g>>2]|0)+28>>2]=c[n>>2];c[r>>2]=c[u>>2];while(1){if(!(c[r>>2]|0))break;if((c[r>>2]|0)==(c[s>>2]|0))break;if(!(c[(c[r>>2]|0)+28>>2]|0))break;c[(c[(c[r>>2]|0)+28>>2]|0)+24>>2]=c[r>>2];c[r>>2]=c[(c[r>>2]|0)+28>>2]}if((c[j>>2]|0)==0?(c[(c[g>>2]|0)+48>>2]|0)>(c[m>>2]|0):0)KO(c[g>>2]|0,c[m>>2]|0);zb[c[135736>>2]&511](c[w>>2]|0);zb[c[135736>>2]&511](c[x>>2]|0);c[f>>2]=c[j>>2];D=c[f>>2]|0;i=e;return D|0}function RO(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+48|0;g=f+44|0;h=f+40|0;j=f+36|0;k=f+32|0;l=f+28|0;m=f+24|0;n=f+20|0;o=f+16|0;p=f+12|0;q=f+8|0;r=f+4|0;s=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[p>>2]=0;if((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+20>>2]|0)!=0:0){c[o>>2]=c[(c[k>>2]|0)+20>>2];do if(c[(c[o>>2]|0)+12>>2]|0){if((c[(c[k>>2]|0)+36>>2]|0)!=0?(c[c[(c[k>>2]|0)+36>>2]>>2]|0)==6:0){c[m>>2]=Ib[c[(c[o>>2]|0)+12>>2]&511](c[(c[o>>2]|0)+4>>2]|0,c[(c[k>>2]|0)+8>>2]|0,c[j>>2]|0,p,c[l>>2]|0)|0;break}c[m>>2]=Ib[c[(c[o>>2]|0)+12>>2]&511](c[(c[o>>2]|0)+4>>2]|0,c[(c[k>>2]|0)+8>>2]|0,c[j>>2]|0,0,c[l>>2]|0)|0}else c[m>>2]=-1;while(0);if((c[m>>2]|0)<0){FN(c[h>>2]|0,2,c[(c[k>>2]|0)+8>>2]|0,0,0);if((c[p>>2]|0)!=0&(c[o>>2]|0)!=0?(c[(c[o>>2]|0)+24>>2]|0)!=0:0)Ab[c[(c[o>>2]|0)+24>>2]&511](c[(c[o>>2]|0)+4>>2]|0,c[p>>2]|0);c[g>>2]=-1;t=c[g>>2]|0;i=f;return t|0}do if((c[m>>2]|0)!=1){l=c[h>>2]|0;if((c[m>>2]|0)==2){FN(l,4,c[j>>2]|0,0,1);break}else{FN(l,3,c[(c[k>>2]|0)+8>>2]|0,c[j>>2]|0,1);c[m>>2]=-1;break}}else c[m>>2]=0;while(0);c[q>>2]=c[(c[k>>2]|0)+36>>2];while(1){if(!((c[m>>2]|0)==0&(c[q>>2]|0)!=0))break;if((c[c[q>>2]>>2]|0)!=6)break;if((c[(c[o>>2]|0)+20>>2]|0)!=0?(c[n>>2]=Bb[c[(c[o>>2]|0)+20>>2]&511](c[(c[o>>2]|0)+4>>2]|0,c[(c[k>>2]|0)+8>>2]|0,c[(c[q>>2]|0)+8>>2]|0,c[(c[q>>2]|0)+16>>2]|0,c[j>>2]|0,c[p>>2]|0)|0,(c[n>>2]|0)!=0):0)c[m>>2]=-1;c[q>>2]=c[(c[q>>2]|0)+32>>2]}if((c[m>>2]|0)==0?(c[(c[k>>2]|0)+24>>2]|0)!=0:0){c[r>>2]=c[(c[(c[h>>2]|0)+60>>2]|0)+20>>2];c[s>>2]=c[(c[(c[h>>2]|0)+60>>2]|0)+24>>2];c[(c[(c[h>>2]|0)+60>>2]|0)+20>>2]=c[j>>2];c[(c[(c[h>>2]|0)+60>>2]|0)+24>>2]=0;c[m>>2]=SO(c[h>>2]|0,c[(c[k>>2]|0)+24>>2]|0)|0;c[(c[(c[h>>2]|0)+60>>2]|0)+20>>2]=c[r>>2];c[(c[(c[h>>2]|0)+60>>2]|0)+24>>2]=c[s>>2]}if((c[p>>2]|0)!=0&(c[o>>2]|0)!=0?(c[(c[o>>2]|0)+24>>2]|0)!=0:0)Ab[c[(c[o>>2]|0)+24>>2]&511](c[(c[o>>2]|0)+4>>2]|0,c[p>>2]|0);c[g>>2]=c[m>>2];t=c[g>>2]|0;i=f;return t|0}c[g>>2]=-1;t=c[g>>2]|0;i=f;return t|0}function SO(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;f=i;i=i+96|0;g=f;h=f+92|0;j=f+88|0;k=f+84|0;l=f+80|0;m=f+76|0;n=f+72|0;o=f+68|0;p=f+64|0;q=f+60|0;r=f+56|0;s=f+52|0;t=f+48|0;u=f+44|0;v=f+40|0;w=f+36|0;x=f+32|0;y=f+28|0;z=f+24|0;A=f+20|0;B=f+16|0;C=f+12|0;D=f+8|0;c[j>>2]=b;c[k>>2]=e;c[l>>2]=0;c[n>>2]=c[(c[(c[j>>2]|0)+60>>2]|0)+20>>2];a:do switch(c[c[k>>2]>>2]|0){case 17:{c[s>>2]=c[(c[k>>2]|0)+24>>2];c[m>>2]=c[(c[j>>2]|0)+28>>2];e=(c[j>>2]|0)+28|0;c[e>>2]=c[e>>2]|1;c[t>>2]=c[(c[(c[j>>2]|0)+60>>2]|0)+20>>2];while(1){if(!(c[s>>2]|0))break;c[l>>2]=SO(c[j>>2]|0,c[s>>2]|0)|0;if(!(c[l>>2]|0))break;c[(c[(c[j>>2]|0)+60>>2]|0)+20>>2]=c[t>>2];c[s>>2]=c[(c[s>>2]|0)+32>>2]}c[(c[j>>2]|0)+28>>2]=c[m>>2];e=c[j>>2]|0;if(c[l>>2]|0){if(c[e+28>>2]&1)break a;eO(c[j>>2]|0);break a}else{if((c[e+48>>2]|0)<=0)break a;KO(c[j>>2]|0,0);break a}break}case 5:{c[l>>2]=RO(c[j>>2]|0,c[n>>2]|0,c[k>>2]|0,c[(c[(c[j>>2]|0)+60>>2]|0)+4>>2]|0)|0;if(!(c[l>>2]|0))hP(c[j>>2]|0)|0;break}case 16:{c[l>>2]=iP(c[j>>2]|0,c[(c[k>>2]|0)+24>>2]|0)|0;if(!(c[l>>2]|0))E=78;break}case 15:{E=78;break}case 8:{c[u>>2]=c[(c[k>>2]|0)+24>>2];c[v>>2]=c[(c[(c[j>>2]|0)+60>>2]|0)+20>>2];c[w>>2]=c[(c[(c[j>>2]|0)+60>>2]|0)+24>>2];c[x>>2]=my(c[v>>2]|0)|0;if(!(c[x>>2]|0))c[x>>2]=my(188112)|0;if(!(c[x>>2]|0)){FN(c[j>>2]|0,6,0,0,0);c[h>>2]=-1;F=c[h>>2]|0;i=f;return F|0}c[y>>2]=c[x>>2];b:while(1){G=c[y>>2]|0;if(!(d[c[y>>2]>>0]|0))break;do if((d[G>>0]|0|0)!=32){if(9<=(d[c[y>>2]>>0]|0|0)?(d[c[y>>2]>>0]|0|0)<=10:0)break;if((d[c[y>>2]>>0]|0|0)!=13){c[y>>2]=(c[y>>2]|0)+1;continue b}}while(0);a[c[y>>2]>>0]=0;c[y>>2]=(c[y>>2]|0)+1;while(1){do if((d[c[y>>2]>>0]|0|0)!=32){if(9<=(d[c[y>>2]>>0]|0|0)?(d[c[y>>2]>>0]|0|0)<=10:0)break;if((d[c[y>>2]>>0]|0|0)!=13)continue b}while(0);e=c[y>>2]|0;c[y>>2]=e+1;a[e>>0]=0}}c[(c[(c[j>>2]|0)+60>>2]|0)+24>>2]=G;c[y>>2]=c[x>>2];while(1){if(!(d[c[y>>2]>>0]|0))H=(c[y>>2]|0)!=(c[(c[(c[j>>2]|0)+60>>2]|0)+24>>2]|0);else H=0;I=c[y>>2]|0;if(!H)break;c[y>>2]=I+1}c[(c[(c[j>>2]|0)+60>>2]|0)+20>>2]=I;while(1){if(!(c[u>>2]|0))break;if((c[(c[(c[j>>2]|0)+60>>2]|0)+20>>2]|0)==(c[(c[(c[j>>2]|0)+60>>2]|0)+24>>2]|0))c[(c[(c[j>>2]|0)+60>>2]|0)+20>>2]=0;c[l>>2]=SO(c[j>>2]|0,c[u>>2]|0)|0;if(c[l>>2]|0)break;c[u>>2]=c[(c[u>>2]|0)+32>>2]}if(((c[l>>2]|0)==0?(c[(c[(c[j>>2]|0)+60>>2]|0)+20>>2]|0)!=0:0)?(c[(c[(c[j>>2]|0)+60>>2]|0)+20>>2]|0)!=(c[(c[(c[j>>2]|0)+60>>2]|0)+24>>2]|0):0){FN(c[j>>2]|0,8,c[(c[(c[j>>2]|0)+60>>2]|0)+20>>2]|0,0,0);c[l>>2]=-1}zb[c[135736>>2]&511](c[x>>2]|0);c[(c[(c[j>>2]|0)+60>>2]|0)+20>>2]=c[v>>2];c[(c[(c[j>>2]|0)+60>>2]|0)+24>>2]=c[w>>2];break}case 7:{do if(!(qy(c[n>>2]|0,c[(c[k>>2]|0)+16>>2]|0)|0)){if(!(c[(c[k>>2]|0)+8>>2]|0)){c[q>>2]=SN(c[j>>2]|0,c[(c[k>>2]|0)+16>>2]|0)|0;c[r>>2]=SN(c[j>>2]|0,c[n>>2]|0)|0;if(!(!((c[q>>2]|0)==0|(c[r>>2]|0)==0)?(qy(c[q>>2]|0,c[r>>2]|0)|0)!=0:0))c[l>>2]=-1;if(c[q>>2]|0)zb[c[135736>>2]&511](c[q>>2]|0);if(!(c[r>>2]|0))break;zb[c[135736>>2]&511](c[r>>2]|0);break}c[p>>2]=c[(c[k>>2]|0)+20>>2];if((c[p>>2]|0)!=0?(c[(c[p>>2]|0)+16>>2]|0)!=0:0)c[l>>2]=ub[c[(c[p>>2]|0)+16>>2]&511](c[(c[p>>2]|0)+4>>2]|0,c[(c[k>>2]|0)+8>>2]|0,c[(c[k>>2]|0)+16>>2]|0,c[(c[k>>2]|0)+4>>2]|0,c[(c[k>>2]|0)+36>>2]|0,c[n>>2]|0,c[c[(c[j>>2]|0)+60>>2]>>2]|0)|0;else c[l>>2]=-1;if((c[l>>2]|0)<0){FN(c[j>>2]|0,5,c[(c[k>>2]|0)+8>>2]|0,0,0);c[h>>2]=-1;F=c[h>>2]|0;i=f;return F|0}if((c[l>>2]|0)==1){c[l>>2]=0;break}else{c[l>>2]=-1;break}}while(0);if(!(c[l>>2]|0))hP(c[j>>2]|0)|0;break}case 0:{if((c[n>>2]|0)!=0?(d[c[n>>2]>>0]|0|0)!=0:0){c[o>>2]=0;while(1){do if((d[(c[n>>2]|0)+(c[o>>2]|0)>>0]|0|0)==32)J=1;else{if(9<=(d[(c[n>>2]|0)+(c[o>>2]|0)>>0]|0|0)?(d[(c[n>>2]|0)+(c[o>>2]|0)>>0]|0|0)<=10:0){J=1;break}J=(d[(c[n>>2]|0)+(c[o>>2]|0)>>0]|0|0)==13}while(0);K=c[o>>2]|0;if(!J)break;c[o>>2]=K+1}if(d[(c[n>>2]|0)+K>>0]|0)c[l>>2]=-1}break}case 18:case 10:{c[D>>2]=c[(c[k>>2]|0)+24>>2];while(1){if(!(c[D>>2]|0))break a;c[l>>2]=SO(c[j>>2]|0,c[D>>2]|0)|0;if(c[l>>2]|0)break;c[l>>2]=0;c[D>>2]=c[(c[D>>2]|0)+32>>2]}c[l>>2]=-1;break}case 13:case 11:{e=c[j>>2]|0;if(!(c[(c[k>>2]|0)+24>>2]|0)){FN(e,7,0,0,0);c[l>>2]=-1;break a}else{c[l>>2]=SO(e,c[(c[k>>2]|0)+24>>2]|0)|0;break a}break}case 3:break;case 2:{c[C>>2]=c[(c[k>>2]|0)+24>>2];while(1){if(!(c[C>>2]|0))break a;c[l>>2]=SO(c[j>>2]|0,c[C>>2]|0)|0;if(!(c[l>>2]|0))break;c[l>>2]=0;c[C>>2]=c[(c[C>>2]|0)+32>>2]}c[l>>2]=-1;break}case 14:{if((c[(c[(c[j>>2]|0)+60>>2]|0)+20>>2]|0)!=0?(d[c[(c[(c[j>>2]|0)+60>>2]|0)+20>>2]>>0]|0|0)!=0:0){c[m>>2]=c[(c[j>>2]|0)+28>>2];e=(c[j>>2]|0)+28|0;c[e>>2]=c[e>>2]|1;c[B>>2]=c[(c[(c[j>>2]|0)+60>>2]|0)+20>>2];c[l>>2]=SO(c[j>>2]|0,c[(c[k>>2]|0)+24>>2]|0)|0;c[(c[j>>2]|0)+28>>2]=c[m>>2];if(!(c[l>>2]|0)){if((c[(c[j>>2]|0)+48>>2]|0)<=0)break a;KO(c[j>>2]|0,0);break a}c[(c[(c[j>>2]|0)+60>>2]|0)+20>>2]=c[B>>2];if((c[(c[j>>2]|0)+48>>2]|0)>0)KO(c[j>>2]|0,0);c[l>>2]=0;break a}c[l>>2]=0;break}default:{e=c[33976]|0;b=c[33980]|0;c[g>>2]=189496;c[g+4>>2]=8982;Db[e&511](b,189464,g);c[l>>2]=-1}}while(0);do if((E|0)==78){if((c[(c[(c[j>>2]|0)+60>>2]|0)+20>>2]|0)!=0?(d[c[(c[(c[j>>2]|0)+60>>2]|0)+20>>2]>>0]|0|0)!=0:0){c[m>>2]=c[(c[j>>2]|0)+28>>2];g=(c[j>>2]|0)+28|0;c[g>>2]=c[g>>2]|1;c[z>>2]=c[(c[(c[j>>2]|0)+60>>2]|0)+20>>2];c[A>>2]=0;while(1){if(!(c[z>>2]|0))break;if((c[z>>2]|0)==(c[(c[(c[j>>2]|0)+60>>2]|0)+24>>2]|0))break;if((c[A>>2]|0)==(c[z>>2]|0))break;c[A>>2]=c[z>>2];c[l>>2]=iP(c[j>>2]|0,c[(c[k>>2]|0)+24>>2]|0)|0;if(c[l>>2]|0){E=86;break}c[z>>2]=c[(c[(c[j>>2]|0)+60>>2]|0)+20>>2]}if((E|0)==86){c[(c[(c[j>>2]|0)+60>>2]|0)+20>>2]=c[A>>2];c[l>>2]=0}c[(c[j>>2]|0)+28>>2]=c[m>>2];if((c[(c[j>>2]|0)+48>>2]|0)<=0)break;KO(c[j>>2]|0,0);break}c[l>>2]=0}while(0);c[h>>2]=c[l>>2];F=c[h>>2]|0;i=f;return F|0}function TO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+8|0;h=e+4|0;j=e;c[e+12>>2]=a;c[g>>2]=b;c[h>>2]=d;do if(!((c[g>>2]|0)==0|(c[h>>2]|0)==0)){if((c[g>>2]|0)==(c[h>>2]|0)){c[f>>2]=1;break}if((c[c[g>>2]>>2]|0)!=(c[c[h>>2]>>2]|0)){c[f>>2]=0;break}if((c[(c[g>>2]|0)+4>>2]|0)!=(c[(c[h>>2]|0)+4>>2]|0)){c[f>>2]=0;break}if((c[(c[g>>2]|0)+16>>2]|0)!=(c[(c[h>>2]|0)+16>>2]|0)){c[f>>2]=0;break}if((c[(c[g>>2]|0)+8>>2]|0)!=(c[(c[h>>2]|0)+8>>2]|0)){c[f>>2]=0;break}if((c[(c[g>>2]|0)+24>>2]|0)!=(c[(c[h>>2]|0)+24>>2]|0)){c[f>>2]=0;break}if((c[(c[g>>2]|0)+20>>2]|0)!=(c[(c[h>>2]|0)+20>>2]|0)?(qy(c[(c[g>>2]|0)+20>>2]|0,c[(c[h>>2]|0)+20>>2]|0)|0)==0:0){c[f>>2]=0;break}c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[(c[g>>2]|0)+8>>2]|0)){k=23;break}if((c[(c[(c[g>>2]|0)+28>>2]|0)+(c[j>>2]<<2)>>2]|0)!=(c[(c[(c[h>>2]|0)+28>>2]|0)+(c[j>>2]<<2)>>2]|0)){k=21;break}c[j>>2]=(c[j>>2]|0)+1}if((k|0)==21){c[f>>2]=0;break}else if((k|0)==23){c[f>>2]=1;break}}else c[f>>2]=0;while(0);i=e;return c[f>>2]|0}function UO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if((c[(c[f>>2]|0)+108>>2]|0)==0?(c[(c[f>>2]|0)+104>>2]=4,c[(c[f>>2]|0)+100>>2]=0,b=Cb[c[135744>>2]&511](c[(c[f>>2]|0)+104>>2]<<2)|0,c[(c[f>>2]|0)+108>>2]=b,(c[(c[f>>2]|0)+108>>2]|0)==0):0){xN(c[f>>2]|0,196496);c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}if((c[(c[f>>2]|0)+100>>2]|0)>=(c[(c[f>>2]|0)+104>>2]|0)?(b=(c[f>>2]|0)+104|0,c[b>>2]=c[b>>2]<<1,b=Hb[c[135760>>2]&511](c[(c[f>>2]|0)+108>>2]|0,c[(c[f>>2]|0)+104>>2]<<2)|0,c[(c[f>>2]|0)+108>>2]=b,(c[(c[f>>2]|0)+108>>2]|0)==0):0){xN(c[f>>2]|0,196496);c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}c[(c[(c[f>>2]|0)+108>>2]|0)+(c[(c[f>>2]|0)+100>>2]<<2)>>2]=c[g>>2];c[(c[f>>2]|0)+96>>2]=c[g>>2];g=(c[f>>2]|0)+100|0;f=c[g>>2]|0;c[g>>2]=f+1;c[e>>2]=f;h=c[e>>2]|0;i=d;return h|0}function VO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if((c[(c[e>>2]|0)+100>>2]|0)<=0){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}a=(c[e>>2]|0)+100|0;c[a>>2]=(c[a>>2]|0)+-1;a=c[e>>2]|0;if((c[(c[e>>2]|0)+100>>2]|0)>0)c[(c[e>>2]|0)+96>>2]=c[(c[(c[e>>2]|0)+108>>2]|0)+((c[a+100>>2]|0)-1<<2)>>2];else c[a+96>>2]=0;c[f>>2]=c[(c[(c[e>>2]|0)+108>>2]|0)+(c[(c[e>>2]|0)+100>>2]<<2)>>2];c[(c[(c[e>>2]|0)+108>>2]|0)+(c[(c[e>>2]|0)+100>>2]<<2)>>2]=0;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}function WO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if((c[(c[f>>2]|0)+124>>2]|0)==0?(c[(c[f>>2]|0)+120>>2]=4,c[(c[f>>2]|0)+116>>2]=0,b=Cb[c[135744>>2]&511](c[(c[f>>2]|0)+120>>2]<<2)|0,c[(c[f>>2]|0)+124>>2]=b,(c[(c[f>>2]|0)+124>>2]|0)==0):0){xN(c[f>>2]|0,196088);c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}if((c[(c[f>>2]|0)+116>>2]|0)>=(c[(c[f>>2]|0)+120>>2]|0)?(b=(c[f>>2]|0)+120|0,c[b>>2]=c[b>>2]<<1,b=Hb[c[135760>>2]&511](c[(c[f>>2]|0)+124>>2]|0,c[(c[f>>2]|0)+120>>2]<<2)|0,c[(c[f>>2]|0)+124>>2]=b,(c[(c[f>>2]|0)+124>>2]|0)==0):0){xN(c[f>>2]|0,196088);c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}c[(c[(c[f>>2]|0)+124>>2]|0)+(c[(c[f>>2]|0)+116>>2]<<2)>>2]=c[g>>2];c[(c[f>>2]|0)+112>>2]=c[g>>2];g=(c[f>>2]|0)+116|0;f=c[g>>2]|0;c[g>>2]=f+1;c[e>>2]=f;h=c[e>>2]|0;i=d;return h|0}function XO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if((c[(c[e>>2]|0)+116>>2]|0)<=0){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}a=(c[e>>2]|0)+116|0;c[a>>2]=(c[a>>2]|0)+-1;a=c[e>>2]|0;if((c[(c[e>>2]|0)+116>>2]|0)>0)c[(c[e>>2]|0)+112>>2]=c[(c[(c[e>>2]|0)+124>>2]|0)+((c[a+116>>2]|0)-1<<2)>>2];else c[a+112>>2]=0;c[f>>2]=c[(c[(c[e>>2]|0)+124>>2]|0)+(c[(c[e>>2]|0)+116>>2]<<2)>>2];c[(c[(c[e>>2]|0)+124>>2]|0)+(c[(c[e>>2]|0)+116>>2]<<2)>>2]=0;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}function YO(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+48|0;g=f+36|0;h=f+28|0;j=f+24|0;k=f+20|0;l=f+16|0;m=f+12|0;n=f+8|0;o=f+4|0;p=f;c[g>>2]=a;c[f+32>>2]=b;c[h>>2]=d;c[j>>2]=e;c[k>>2]=0;c[l>>2]=c[h>>2];while(1){if(!(c[l>>2]|0))break;c[m>>2]=c[(c[l>>2]|0)+24>>2];if(((((c[j>>2]|0)==0&(c[l>>2]|0)!=0?(c[(c[l>>2]|0)+36>>2]|0)!=0:0)?(c[(c[l>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[l>>2]|0)+8>>2]|0,190048)|0)!=0:0)?(qy(c[(c[(c[l>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0){c[k>>2]=1;Qh(c[l>>2]|0);Rh(c[l>>2]|0)}else q=9;do if((q|0)==9){q=0;if(((((c[j>>2]|0)!=0&(c[l>>2]|0)!=0?(c[(c[l>>2]|0)+36>>2]|0)!=0:0)?(c[(c[l>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[l>>2]|0)+8>>2]|0,195016)|0)!=0:0)?(qy(c[(c[(c[l>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0){c[n>>2]=Yi(c[l>>2]|0,192176)|0;ZO(c[n>>2]|0);if(!(c[n>>2]|0))break;if(qy(c[j>>2]|0,c[n>>2]|0)|0){c[k>>2]=1;Qh(c[l>>2]|0);Rh(c[l>>2]|0)}zb[c[135736>>2]&511](c[n>>2]|0);break}if((((((((((c[l>>2]|0)!=0?(c[(c[l>>2]|0)+36>>2]|0)!=0:0)?(c[(c[l>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[l>>2]|0)+8>>2]|0,195024)|0)!=0:0)?(qy(c[(c[(c[l>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0)?(c[o>>2]=0,c[p>>2]=c[(c[l>>2]|0)+52>>2],(c[p>>2]|0)!=0):0)?(c[(c[p>>2]|0)+8>>2]|0)!=0:0)?(c[(c[(c[p>>2]|0)+8>>2]|0)+12>>2]|0)!=0:0)?(qy(c[(c[(c[(c[p>>2]|0)+8>>2]|0)+12>>2]|0)+8>>2]|0,190264)|0)!=0:0)?(h=c[g>>2]|0,e=c[o>>2]|0,d=c[(Pi(c[(c[p>>2]|0)+8>>2]|0)|0)+12>>2]|0,(YO(h,e,d,c[j>>2]|0)|0)==1):0)c[k>>2]=1}while(0);c[l>>2]=c[m>>2]}i=f;return c[k>>2]|0}function ZO(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=b;c[g>>2]=c[f>>2];c[h>>2]=c[f>>2];if(!(c[f>>2]|0)){i=e;return}while(1){do if((d[c[h>>2]>>0]|0|0)==32)j=1;else{if(9<=(d[c[h>>2]>>0]|0|0)?(d[c[h>>2]>>0]|0|0)<=10:0){j=1;break}j=(d[c[h>>2]>>0]|0|0)==13}while(0);k=c[h>>2]|0;if(!j)break;c[h>>2]=k+1}if((k|0)==(c[g>>2]|0)){while(1){if(d[c[h>>2]>>0]|0){do if((d[c[h>>2]>>0]|0|0)==32)l=1;else{if(9<=(d[c[h>>2]>>0]|0|0)?(d[c[h>>2]>>0]|0|0)<=10:0){l=1;break}l=(d[c[h>>2]>>0]|0|0)==13}while(0);m=l^1}else m=0;k=c[h>>2]|0;if(m){c[h>>2]=k+1;continue}if(!(d[k>>0]|0)){n=46;break}c[g>>2]=c[h>>2];while(1){do if((d[c[h>>2]>>0]|0|0)==32)o=1;else{if(9<=(d[c[h>>2]>>0]|0|0)?(d[c[h>>2]>>0]|0|0)<=10:0){o=1;break}o=(d[c[h>>2]>>0]|0|0)==13}while(0);p=c[h>>2]|0;if(!o)break;c[h>>2]=p+1}if(!(d[p>>0]|0))break}if((n|0)==46){i=e;return}a[c[g>>2]>>0]=0;i=e;return}while(1){if(d[c[h>>2]>>0]|0){do if((d[c[h>>2]>>0]|0|0)==32)q=1;else{if(9<=(d[c[h>>2]>>0]|0|0)?(d[c[h>>2]>>0]|0|0)<=10:0){q=1;break}q=(d[c[h>>2]>>0]|0|0)==13}while(0);r=q^1}else r=0;p=c[h>>2]|0;if(r){c[h>>2]=p+1;o=a[p>>0]|0;m=c[g>>2]|0;c[g>>2]=m+1;a[m>>0]=o;continue}if(!(d[p>>0]|0)){n=36;break}while(1){do if((d[c[h>>2]>>0]|0|0)==32)s=1;else{if(9<=(d[c[h>>2]>>0]|0|0)?(d[c[h>>2]>>0]|0|0)<=10:0){s=1;break}s=(d[c[h>>2]>>0]|0|0)==13}while(0);t=c[h>>2]|0;if(!s)break;c[h>>2]=t+1}if(!(d[t>>0]|0)){n=44;break}p=c[h>>2]|0;c[h>>2]=p+1;o=a[p>>0]|0;p=c[g>>2]|0;c[g>>2]=p+1;a[p>>0]=o}if((n|0)==36){a[c[g>>2]>>0]=0;i=e;return}else if((n|0)==44){a[c[g>>2]>>0]=0;i=e;return}}function _O(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+48|0;e=d+32|0;f=d+28|0;g=d+24|0;h=d+20|0;j=d+16|0;k=d+12|0;l=d+8|0;m=d+4|0;n=d;c[f>>2]=a;c[g>>2]=b;c[j>>2]=0;c[h>>2]=Yi(c[g>>2]|0,192176)|0;
do if(c[h>>2]|0){ZO(c[h>>2]|0);if(Eh(c[h>>2]|0,0)|0)zN(c[f>>2]|0,c[g>>2]|0,1049,195200,c[h>>2]|0,0);c[l>>2]=DN(c[f>>2]|0,c[g>>2]|0)|0;if(!(c[l>>2]|0)){zb[c[135736>>2]&511](c[h>>2]|0);c[e>>2]=-1;o=c[e>>2]|0;i=d;return o|0}c[c[l>>2]>>2]=10;c[(c[l>>2]|0)+8>>2]=c[h>>2];b=c[f>>2]|0;if(!(c[(c[g>>2]|0)+12>>2]|0))zN(b,c[g>>2]|0,1012,195240,0,0);else{c[m>>2]=c[b+44>>2];c[(c[f>>2]|0)+44>>2]=c[h>>2];b=xO(c[f>>2]|0,c[(c[g>>2]|0)+12>>2]|0,0)|0;c[(c[l>>2]|0)+24>>2]=b;c[(c[f>>2]|0)+44>>2]=c[m>>2]}if(!(c[(c[(c[f>>2]|0)+24>>2]|0)+24>>2]|0)){b=Ij(10)|0;c[(c[(c[f>>2]|0)+24>>2]|0)+24>>2]=b}b=c[f>>2]|0;if(!(c[(c[(c[f>>2]|0)+24>>2]|0)+24>>2]|0)){zN(b,c[g>>2]|0,1011,195264,0,0);c[j>>2]=-1;break}c[k>>2]=Lj(c[(c[b+24>>2]|0)+24>>2]|0,c[h>>2]|0,c[l>>2]|0)|0;if((c[k>>2]|0)<0){c[n>>2]=Rj(c[(c[(c[f>>2]|0)+24>>2]|0)+24>>2]|0,c[h>>2]|0)|0;if(!(c[n>>2]|0)){zN(c[f>>2]|0,c[g>>2]|0,1011,195304,c[h>>2]|0,0);c[j>>2]=-1;break}while(1){if(!(c[(c[n>>2]|0)+44>>2]|0))break;c[n>>2]=c[(c[n>>2]|0)+44>>2]}c[(c[n>>2]|0)+44>>2]=c[l>>2]}}else zN(c[f>>2]|0,c[g>>2]|0,1014,195176,0,0);while(0);c[e>>2]=c[j>>2];o=c[e>>2]|0;i=d;return o|0}function $O(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[f>>2]=a;c[g>>2]=b;c[k>>2]=0;c[h>>2]=c[(c[g>>2]|0)+52>>2];if(!(c[h>>2]|0)){zN(c[f>>2]|0,c[g>>2]|0,1042,195072,0,0);c[e>>2]=-1;m=c[e>>2]|0;i=d;return m|0}c[j>>2]=Pi(c[(c[h>>2]|0)+8>>2]|0)|0;if(!(c[j>>2]|0)){zN(c[f>>2]|0,c[g>>2]|0,1022,195104,0,0);c[e>>2]=-1;m=c[e>>2]|0;i=d;return m|0}if(!(qy(c[(c[j>>2]|0)+8>>2]|0,190264)|0)){zN(c[f>>2]|0,c[g>>2]|0,1038,195136,0,0);c[e>>2]=-1;m=c[e>>2]|0;i=d;return m|0}if((c[(c[j>>2]|0)+12>>2]|0)!=0?(c[l>>2]=tO(c[f>>2]|0,c[(c[j>>2]|0)+12>>2]|0)|0,(c[l>>2]|0)!=0):0)c[k>>2]=-1;if((c[(c[g>>2]|0)+12>>2]|0)!=0?(c[l>>2]=tO(c[f>>2]|0,c[(c[g>>2]|0)+12>>2]|0)|0,(c[l>>2]|0)!=0):0)c[k>>2]=-1;c[e>>2]=c[k>>2];m=c[e>>2]|0;i=d;return m|0}function aP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+28|0;f=d+24|0;g=d+20|0;h=d+16|0;j=d+12|0;k=d+8|0;l=d+4|0;m=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=DN(c[f>>2]|0,c[g>>2]|0)|0;if(!(c[h>>2]|0)){c[e>>2]=0;n=c[e>>2]|0;i=d;return n|0}c[c[h>>2]>>2]=4;c[(c[h>>2]|0)+28>>2]=c[(c[f>>2]|0)+48>>2];c[l>>2]=c[(c[g>>2]|0)+12>>2];b=c[f>>2]|0;if(!(c[l>>2]|0)){zN(b,c[g>>2]|0,1017,194024,0,0);c[e>>2]=c[h>>2];n=c[e>>2]|0;i=d;return n|0}c[j>>2]=jP(b,c[l>>2]|0,c[h>>2]|0)|0;if(c[j>>2]|0)c[l>>2]=c[(c[l>>2]|0)+24>>2];b=c[f>>2]|0;if(!(c[l>>2]|0)){zN(b,c[g>>2]|0,1020,194080,0,0);c[e>>2]=c[h>>2];n=c[e>>2]|0;i=d;return n|0}c[m>>2]=c[b+44>>2];c[(c[f>>2]|0)+44>>2]=0;c[k>>2]=0;while(1){if(!(c[l>>2]|0))break;c[j>>2]=bP(c[f>>2]|0,c[l>>2]|0)|0;a:do if(c[j>>2]|0){c[(c[j>>2]|0)+28>>2]=c[h>>2];switch(c[c[j>>2]>>2]|0){case 20:{zN(c[f>>2]|0,c[g>>2]|0,1018,194128,0,0);break a;break}case 9:{c[(c[j>>2]|0)+32>>2]=c[(c[h>>2]|0)+36>>2];c[(c[h>>2]|0)+36>>2]=c[j>>2];break a;break}case 19:case 18:case 17:case 14:case 16:case 15:case 10:case 12:case 13:case 11:case 8:case 7:case 5:case 4:case 3:case 1:case 0:{if(!(c[k>>2]|0)){b=c[j>>2]|0;c[k>>2]=b;c[(c[h>>2]|0)+24>>2]=b;break a}do if((c[c[k>>2]>>2]|0)==4?(c[(c[h>>2]|0)+24>>2]|0)==(c[k>>2]|0):0){b=DN(c[f>>2]|0,c[g>>2]|0)|0;c[(c[h>>2]|0)+24>>2]=b;if(c[(c[h>>2]|0)+24>>2]|0){c[c[(c[h>>2]|0)+24>>2]>>2]=18;c[(c[(c[h>>2]|0)+24>>2]|0)+24>>2]=c[k>>2];break}else{c[(c[h>>2]|0)+24>>2]=c[k>>2];break}}while(0);c[(c[k>>2]|0)+32>>2]=c[j>>2];c[k>>2]=c[j>>2];break a;break}case-1:{zN(c[f>>2]|0,c[g>>2]|0,1018,194272,0,0);break a;break}case 6:{zN(c[f>>2]|0,c[g>>2]|0,1018,194176,0,0);break a;break}case 2:{zN(c[f>>2]|0,c[g>>2]|0,1018,194224,0,0);break a;break}default:break a}}while(0);c[l>>2]=c[(c[l>>2]|0)+24>>2]}c[(c[f>>2]|0)+44>>2]=c[m>>2];c[e>>2]=c[h>>2];n=c[e>>2]|0;i=d;return n|0}function bP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+48|0;e=d+44|0;f=d+40|0;g=d+36|0;h=d+32|0;j=d+28|0;k=d+24|0;l=d+20|0;m=d+16|0;n=d+12|0;o=d+8|0;p=d+4|0;q=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;if(!(c[g>>2]|0)){c[e>>2]=0;r=c[e>>2]|0;i=d;return r|0}if(((((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+36>>2]|0)!=0:0)?(c[(c[g>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[g>>2]|0)+8>>2]|0,189864)|0)!=0:0)?(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0)c[h>>2]=aP(c[f>>2]|0,c[g>>2]|0)|0;else s=9;a:do if((s|0)==9){if(((((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+36>>2]|0)!=0:0)?(c[(c[g>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[g>>2]|0)+8>>2]|0,189904)|0)!=0:0)?(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0){c[h>>2]=kP(c[f>>2]|0,c[g>>2]|0)|0;break}if(((((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+36>>2]|0)!=0:0)?(c[(c[g>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[g>>2]|0)+8>>2]|0,189824)|0)!=0:0)?(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0){c[h>>2]=DN(c[f>>2]|0,c[g>>2]|0)|0;if(!(c[h>>2]|0)){c[e>>2]=0;r=c[e>>2]|0;i=d;return r|0}else{c[c[h>>2]>>2]=0;if(!(c[(c[g>>2]|0)+12>>2]|0))break;zN(c[f>>2]|0,c[g>>2]|0,1025,192096,0,0);break}}if(((((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+36>>2]|0)!=0:0)?(c[(c[g>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[g>>2]|0)+8>>2]|0,189856)|0)!=0:0)?(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0){c[h>>2]=DN(c[f>>2]|0,c[g>>2]|0)|0;if(!(c[h>>2]|0)){c[e>>2]=0;r=c[e>>2]|0;i=d;return r|0}else{c[c[h>>2]>>2]=3;if(!(c[(c[g>>2]|0)+12>>2]|0))break;zN(c[f>>2]|0,c[g>>2]|0,1109,192128,0,0);break}}if(((((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+36>>2]|0)!=0:0)?(c[(c[g>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[g>>2]|0)+8>>2]|0,189984)|0)!=0:0)?(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0){c[h>>2]=DN(c[f>>2]|0,c[g>>2]|0)|0;if(!(c[h>>2]|0)){c[e>>2]=0;r=c[e>>2]|0;i=d;return r|0}c[c[h>>2]>>2]=15;b=c[f>>2]|0;a=c[g>>2]|0;if(!(c[(c[g>>2]|0)+12>>2]|0)){zN(b,a,1023,192152,c[(c[g>>2]|0)+8>>2]|0,0);break}else{t=xO(b,c[a+12>>2]|0,1)|0;c[(c[h>>2]|0)+24>>2]=t;break}}if(((((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+36>>2]|0)!=0:0)?(c[(c[g>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[g>>2]|0)+8>>2]|0,19e4)|0)!=0:0)?(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0){c[h>>2]=DN(c[f>>2]|0,c[g>>2]|0)|0;if(!(c[h>>2]|0)){c[e>>2]=0;r=c[e>>2]|0;i=d;return r|0}c[c[h>>2]>>2]=16;t=c[f>>2]|0;a=c[g>>2]|0;if(!(c[(c[g>>2]|0)+12>>2]|0)){zN(t,a,1023,192152,c[(c[g>>2]|0)+8>>2]|0,0);break}else{b=xO(t,c[a+12>>2]|0,1)|0;c[(c[h>>2]|0)+24>>2]=b;break}}if(((((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+36>>2]|0)!=0:0)?(c[(c[g>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[g>>2]|0)+8>>2]|0,189968)|0)!=0:0)?(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0){c[h>>2]=DN(c[f>>2]|0,c[g>>2]|0)|0;if(!(c[h>>2]|0)){c[e>>2]=0;r=c[e>>2]|0;i=d;return r|0}c[c[h>>2]>>2]=14;b=c[f>>2]|0;a=c[g>>2]|0;if(!(c[(c[g>>2]|0)+12>>2]|0)){zN(b,a,1023,192152,c[(c[g>>2]|0)+8>>2]|0,0);break}else{t=xO(b,c[a+12>>2]|0,1)|0;c[(c[h>>2]|0)+24>>2]=t;break}}if(((((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+36>>2]|0)!=0:0)?(c[(c[g>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[g>>2]|0)+8>>2]|0,190016)|0)!=0:0)?(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0){c[h>>2]=DN(c[f>>2]|0,c[g>>2]|0)|0;if(!(c[h>>2]|0)){c[e>>2]=0;r=c[e>>2]|0;i=d;return r|0}c[c[h>>2]>>2]=17;t=c[f>>2]|0;a=c[g>>2]|0;if(!(c[(c[g>>2]|0)+12>>2]|0)){zN(t,a,1023,192152,c[(c[g>>2]|0)+8>>2]|0,0);break}else{b=xO(t,c[a+12>>2]|0,0)|0;c[(c[h>>2]|0)+24>>2]=b;break}}if(((((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+36>>2]|0)!=0:0)?(c[(c[g>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[g>>2]|0)+8>>2]|0,190024)|0)!=0:0)?(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0){c[h>>2]=DN(c[f>>2]|0,c[g>>2]|0)|0;if(!(c[h>>2]|0)){c[e>>2]=0;r=c[e>>2]|0;i=d;return r|0}c[c[h>>2]>>2]=18;b=c[f>>2]|0;a=c[g>>2]|0;if(!(c[(c[g>>2]|0)+12>>2]|0)){zN(b,a,1023,192152,c[(c[g>>2]|0)+8>>2]|0,0);break}else{t=xO(b,c[a+12>>2]|0,0)|0;c[(c[h>>2]|0)+24>>2]=t;break}}if(((((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+36>>2]|0)!=0:0)?(c[(c[g>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[g>>2]|0)+8>>2]|0,189928)|0)!=0:0)?(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0){c[h>>2]=DN(c[f>>2]|0,c[g>>2]|0)|0;if(!(c[h>>2]|0)){c[e>>2]=0;r=c[e>>2]|0;i=d;return r|0}c[c[h>>2]>>2]=11;t=Yi(c[g>>2]|0,192176)|0;c[(c[h>>2]|0)+8>>2]=t;do if(!(c[(c[h>>2]|0)+8>>2]|0))zN(c[f>>2]|0,c[g>>2]|0,1102,192184,0,0);else{ZO(c[(c[h>>2]|0)+8>>2]|0);if(!(Eh(c[(c[h>>2]|0)+8>>2]|0,0)|0))break;zN(c[f>>2]|0,c[g>>2]|0,1100,192208,c[(c[h>>2]|0)+8>>2]|0,0)}while(0);if(c[(c[g>>2]|0)+12>>2]|0)zN(c[f>>2]|0,c[g>>2]|0,1103,192240,0,0);if(!(c[(c[(c[f>>2]|0)+24>>2]|0)+28>>2]|0)){t=Ij(10)|0;c[(c[(c[f>>2]|0)+24>>2]|0)+28>>2]=t}t=c[f>>2]|0;if(!(c[(c[(c[f>>2]|0)+24>>2]|0)+28>>2]|0)){zN(t,c[g>>2]|0,1098,192264,0,0);c[h>>2]=0;break}c[j>>2]=Lj(c[(c[t+24>>2]|0)+28>>2]|0,c[(c[h>>2]|0)+8>>2]|0,c[h>>2]|0)|0;if((c[j>>2]|0)>=0)break;c[k>>2]=Rj(c[(c[(c[f>>2]|0)+24>>2]|0)+28>>2]|0,c[(c[h>>2]|0)+8>>2]|0)|0;if(c[k>>2]|0){c[(c[h>>2]|0)+44>>2]=c[(c[k>>2]|0)+44>>2];c[(c[k>>2]|0)+44>>2]=c[h>>2];break}t=c[f>>2]|0;a=c[g>>2]|0;if(c[(c[h>>2]|0)+8>>2]|0)zN(t,a,1098,192304,c[(c[h>>2]|0)+8>>2]|0,0);else zN(t,a,1098,192336,0,0);c[h>>2]=0;break}if(((((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+36>>2]|0)!=0:0)?(c[(c[g>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[g>>2]|0)+8>>2]|0,192360)|0)!=0:0)?(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0){c[h>>2]=lP(c[f>>2]|0,c[g>>2]|0)|0;break}if(((((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+36>>2]|0)!=0:0)?(c[(c[g>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[g>>2]|0)+8>>2]|0,189888)|0)!=0:0)?(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0){c[h>>2]=mP(c[f>>2]|0,c[g>>2]|0)|0;break}if(((((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+36>>2]|0)!=0:0)?(c[(c[g>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[g>>2]|0)+8>>2]|0,189896)|0)!=0:0)?(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0){c[h>>2]=DN(c[f>>2]|0,c[g>>2]|0)|0;if(!(c[h>>2]|0)){c[e>>2]=0;r=c[e>>2]|0;i=d;return r|0}c[c[h>>2]>>2]=8;a=c[f>>2]|0;t=c[g>>2]|0;if(!(c[(c[g>>2]|0)+12>>2]|0)){zN(a,t,1023,192152,c[(c[g>>2]|0)+8>>2]|0,0);break}else{b=xO(a,c[t+12>>2]|0,0)|0;c[(c[h>>2]|0)+24>>2]=b;break}}do if((((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+36>>2]|0)!=0:0)?(c[(c[g>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[g>>2]|0)+8>>2]|0,190032)|0)!=0:0){if(!(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0))break;c[h>>2]=nP(c[f>>2]|0,c[g>>2]|0)|0;break a}while(0);do if(((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+36>>2]|0)!=0:0)?(c[(c[g>>2]|0)+4>>2]|0)==1:0){if(!(qy(c[(c[g>>2]|0)+8>>2]|0,189936)|0))break;if(!(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0))break;c[h>>2]=oP(c[f>>2]|0,c[g>>2]|0)|0;break a}while(0);do if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+36>>2]|0)!=0:0){if((c[(c[g>>2]|0)+4>>2]|0)!=1)break;if(!(qy(c[(c[g>>2]|0)+8>>2]|0,189832)|0))break;if(!(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0))break;c[h>>2]=DN(c[f>>2]|0,c[g>>2]|0)|0;if(!(c[h>>2]|0)){c[e>>2]=0;r=c[e>>2]|0;i=d;return r|0}else{c[c[h>>2]>>2]=1;if(!(c[(c[g>>2]|0)+12>>2]|0))break a;zN(c[f>>2]|0,c[g>>2]|0,1055,192368,0,0);break a}}while(0);do if(c[g>>2]|0){if(!(c[(c[g>>2]|0)+36>>2]|0))break;if((c[(c[g>>2]|0)+4>>2]|0)!=1)break;if(!(qy(c[(c[g>>2]|0)+8>>2]|0,190264)|0))break;if(!(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0))break;c[n>>2]=c[(c[f>>2]|0)+28>>2];c[m>>2]=c[(c[f>>2]|0)+24>>2];c[(c[f>>2]|0)+28>>2]=c[m>>2];c[l>>2]=WN(c[f>>2]|0,c[(c[g>>2]|0)+12>>2]|0)|0;if(c[m>>2]|0){c[(c[f>>2]|0)+24>>2]=c[m>>2];c[(c[f>>2]|0)+28>>2]=c[n>>2]}if(c[l>>2]|0){c[h>>2]=c[(c[l>>2]|0)+12>>2];break a}else{c[h>>2]=0;break a}}while(0);do if(c[g>>2]|0){if(!(c[(c[g>>2]|0)+36>>2]|0))break;if((c[(c[g>>2]|0)+4>>2]|0)!=1)break;if(!(qy(c[(c[g>>2]|0)+8>>2]|0,189952)|0))break;if(!(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0))break;b=c[f>>2]|0;t=c[g>>2]|0;if(!(c[(c[f>>2]|0)+28>>2]|0)){zN(b,t,1063,192424,0,0);c[e>>2]=0;r=c[e>>2]|0;i=d;return r|0}c[h>>2]=DN(b,t)|0;if(!(c[h>>2]|0)){c[e>>2]=0;r=c[e>>2]|0;i=d;return r|0}c[c[h>>2]>>2]=13;t=Yi(c[g>>2]|0,192176)|0;c[(c[h>>2]|0)+8>>2]=t;do if(!(c[(c[h>>2]|0)+8>>2]|0))zN(c[f>>2]|0,c[g>>2]|0,1062,192472,0,0);else{ZO(c[(c[h>>2]|0)+8>>2]|0);if(!(Eh(c[(c[h>>2]|0)+8>>2]|0,0)|0))break;zN(c[f>>2]|0,c[g>>2]|0,1061,192496,c[(c[h>>2]|0)+8>>2]|0,0)}while(0);if(c[(c[g>>2]|0)+12>>2]|0)zN(c[f>>2]|0,c[g>>2]|0,1064,192536,0,0);if(!(c[(c[(c[f>>2]|0)+28>>2]|0)+28>>2]|0)){t=Ij(10)|0;c[(c[(c[f>>2]|0)+28>>2]|0)+28>>2]=t}if(!(c[(c[(c[f>>2]|0)+28>>2]|0)+28>>2]|0)){zN(c[f>>2]|0,c[g>>2]|0,1060,192264,0,0);c[h>>2]=0;break a}if(!(c[(c[h>>2]|0)+8>>2]|0))break a;c[o>>2]=Lj(c[(c[(c[f>>2]|0)+28>>2]|0)+28>>2]|0,c[(c[h>>2]|0)+8>>2]|0,c[h>>2]|0)|0;if((c[o>>2]|0)>=0)break a;c[p>>2]=Rj(c[(c[(c[f>>2]|0)+28>>2]|0)+28>>2]|0,c[(c[h>>2]|0)+8>>2]|0)|0;if(!(c[p>>2]|0)){zN(c[f>>2]|0,c[g>>2]|0,1060,192560,c[(c[h>>2]|0)+8>>2]|0,0);c[h>>2]=0;break a}else{c[(c[h>>2]|0)+44>>2]=c[(c[p>>2]|0)+44>>2];c[(c[p>>2]|0)+44>>2]=c[h>>2];break a}}while(0);do if(c[g>>2]|0){if(!(c[(c[g>>2]|0)+36>>2]|0))break;if((c[(c[g>>2]|0)+4>>2]|0)!=1)break;if(!(qy(c[(c[g>>2]|0)+8>>2]|0,192608)|0))break;if(!(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0))break;t=c[f>>2]|0;b=c[g>>2]|0;if(!(c[(c[g>>2]|0)+12>>2]|0)){zN(t,b,1023,192616,0,0);c[h>>2]=0;break a}c[h>>2]=nP(t,b)|0;if(!(c[h>>2]|0))break a;do if(c[(c[h>>2]|0)+24>>2]|0){if(!(c[(c[(c[h>>2]|0)+24>>2]|0)+32>>2]|0))break;c[q>>2]=DN(c[f>>2]|0,c[g>>2]|0)|0;if(!(c[q>>2]|0))break;c[c[q>>2]>>2]=18;c[(c[q>>2]|0)+24>>2]=c[(c[h>>2]|0)+24>>2];c[(c[h>>2]|0)+24>>2]=c[q>>2]}while(0);c[q>>2]=DN(c[f>>2]|0,c[g>>2]|0)|0;if(c[q>>2]|0){c[c[q>>2]>>2]=3;c[(c[q>>2]|0)+32>>2]=c[(c[h>>2]|0)+24>>2];c[(c[h>>2]|0)+24>>2]=c[q>>2];break a}c[e>>2]=c[h>>2];r=c[e>>2]|0;i=d;return r|0}while(0);zN(c[f>>2]|0,c[g>>2]|0,1115,192632,c[(c[g>>2]|0)+8>>2]|0,0);c[h>>2]=0}while(0);c[e>>2]=c[h>>2];r=c[e>>2]|0;i=d;return r|0}function cP(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[f>>2]=a;if(!(c[f>>2]|0)){c[e>>2]=-1;k=c[e>>2]|0;i=d;return k|0}if(b[(c[f>>2]|0)+50>>1]&1){c[e>>2]=1;k=c[e>>2]|0;i=d;return k|0}if(b[(c[f>>2]|0)+50>>1]&2){c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}a:do switch(c[c[f>>2]>>2]|0){case 16:case 13:case 12:case 11:case 10:case-1:{c[g>>2]=cP(c[(c[f>>2]|0)+24>>2]|0)|0;break}case 9:case 8:case 7:case 6:case 5:case 4:case 1:case 2:{c[g>>2]=0;break}case 3:case 0:{c[g>>2]=1;break}case 18:case 19:case 20:{c[j>>2]=c[(c[f>>2]|0)+24>>2];while(1){if(!(c[j>>2]|0))break;c[g>>2]=cP(c[j>>2]|0)|0;if((c[g>>2]|0)!=1)break a;c[j>>2]=c[(c[j>>2]|0)+32>>2]}c[e>>2]=1;k=c[e>>2]|0;i=d;return k|0}case 17:{c[h>>2]=c[(c[f>>2]|0)+24>>2];while(1){if(!(c[h>>2]|0))break;c[g>>2]=cP(c[h>>2]|0)|0;if(c[g>>2]|0)break a;c[h>>2]=c[(c[h>>2]|0)+32>>2]}c[g>>2]=0;break}default:{c[e>>2]=-1;k=c[e>>2]|0;i=d;return k|0}}while(0);if(!(c[g>>2]|0)){h=(c[f>>2]|0)+50|0;b[h>>1]=b[h>>1]|2}if((c[g>>2]|0)==1){h=(c[f>>2]|0)+50|0;b[h>>1]=b[h>>1]|1}c[e>>2]=c[g>>2];k=c[e>>2]|0;i=d;return k|0}function dP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=0;while(1){if(!(c[f>>2]|0)){h=5;break}c[g>>2]=SO(c[e>>2]|0,c[f>>2]|0)|0;if(c[g>>2]|0){h=5;break}c[f>>2]=c[(c[f>>2]|0)+32>>2]}if((h|0)==5){i=d;return c[g>>2]|0}return 0}function eP(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+48|0;g=f;h=f+32|0;j=f+28|0;k=f+24|0;l=f+20|0;m=f+16|0;n=f+12|0;o=f+8|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=e;if((c[(c[k>>2]|0)+8>>2]|0)!=0?(qy(c[(c[k>>2]|0)+8>>2]|0,c[(c[l>>2]|0)+8>>2]|0)|0)==0:0){c[h>>2]=0;p=c[h>>2]|0;i=f;return p|0}do if(c[(c[k>>2]|0)+12>>2]|0){e=c[(c[l>>2]|0)+36>>2]|0;if(!(d[c[(c[k>>2]|0)+12>>2]>>0]|0)){if(!e)break;c[h>>2]=0;p=c[h>>2]|0;i=f;return p|0}if((e|0)!=0?(qy(c[(c[k>>2]|0)+12>>2]|0,c[(c[(c[l>>2]|0)+36>>2]|0)+8>>2]|0)|0)!=0:0)break;c[h>>2]=0;p=c[h>>2]|0;i=f;return p|0}while(0);if(!(c[(c[k>>2]|0)+40>>2]|0)){c[h>>2]=1;p=c[h>>2]|0;i=f;return p|0}c[k>>2]=c[(c[k>>2]|0)+40>>2];e=c[k>>2]|0;a:do if((c[c[k>>2]>>2]|0)==2){c[n>>2]=c[e+24>>2];while(1){if(!(c[n>>2]|0))break a;c[m>>2]=eP(c[j>>2]|0,c[n>>2]|0,c[l>>2]|0)|0;if((c[m>>2]|0)==1){q=17;break}if((c[m>>2]|0)<0){q=19;break}c[n>>2]=c[(c[n>>2]|0)+32>>2]}if((q|0)==17){c[h>>2]=0;p=c[h>>2]|0;i=f;return p|0}else if((q|0)==19){c[h>>2]=c[m>>2];p=c[h>>2]|0;i=f;return p|0}}else{if((c[e>>2]|0)!=17){b=c[33976]|0;a=c[33980]|0;c[g>>2]=189496;c[g+4>>2]=9070;Db[b&511](a,189464,g);break}c[o>>2]=c[(c[k>>2]|0)+40>>2];while(1){if(!(c[o>>2]|0)){q=29;break}c[m>>2]=eP(c[j>>2]|0,c[o>>2]|0,c[l>>2]|0)|0;if((c[m>>2]|0)==1){q=25;break}if((c[m>>2]|0)<0){q=27;break}c[o>>2]=c[(c[o>>2]|0)+32>>2]}if((q|0)==25){c[h>>2]=1;p=c[h>>2]|0;i=f;return p|0}else if((q|0)==27){c[h>>2]=c[m>>2];p=c[h>>2]|0;i=f;return p|0}else if((q|0)==29){c[h>>2]=0;p=c[h>>2]|0;i=f;return p|0}}while(0);c[h>>2]=1;p=c[h>>2]|0;i=f;return p|0}function fP(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,p=0;g=i;i=i+32|0;h=g;j=g+24|0;k=g+20|0;l=g+16|0;m=g+12|0;n=g+8|0;p=g+4|0;c[g+28>>2]=a;c[j>>2]=b;c[k>>2]=e;c[l>>2]=f;c[m>>2]=c[l>>2];c[n>>2]=c[k>>2];if(!(c[m>>2]|0)){k=c[o>>2]|0;c[h>>2]=c[j>>2];Ka(k|0,189616,h|0)|0;i=g;return}if(!(c[n>>2]|0)){if((d[c[j>>2]>>0]|0|0)==35){i=g;return}k=c[o>>2]|0;c[h>>2]=c[j>>2];Ka(k|0,189648,h|0)|0;if(!(c[m>>2]|0)){i=g;return}if(c[(c[m>>2]|0)+40>>2]|0){i=g;return}c[(c[m>>2]|0)+40>>2]=37;i=g;return}if((c[m>>2]|0)==0|(c[n>>2]|0)==0){k=c[o>>2]|0;c[h>>2]=c[j>>2];Ka(k|0,189680,h|0)|0;if(!(c[m>>2]|0)){i=g;return}if(c[(c[m>>2]|0)+40>>2]|0){i=g;return}c[(c[m>>2]|0)+40>>2]=37;i=g;return}if((c[c[n>>2]>>2]|0)!=4){k=c[o>>2]|0;c[h>>2]=c[j>>2];Ka(k|0,189712,h|0)|0;if(c[(c[m>>2]|0)+40>>2]|0){i=g;return}c[(c[m>>2]|0)+40>>2]=37;i=g;return}else{c[p>>2]=KN(c[m>>2]|0,c[n>>2]|0)|0;if(!(c[p>>2]|0)){i=g;return}c[(c[m>>2]|0)+112>>2]=c[p>>2];i=g;return}}function gP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;c[j>>2]=0;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}b=c[j>>2]|0;c[j>>2]=b+1;c[h>>2]=c[(c[g>>2]|0)+(b<<2)>>2];a:while(1){if(!(c[h>>2]|0)){m=14;break}if((c[(c[f>>2]|0)+4>>2]|0)==1?(c[c[h>>2]>>2]|0)==4:0){c[k>>2]=MO(0,c[h>>2]|0,c[f>>2]|0)|0;if((c[k>>2]|0)==1){m=8;break}}else m=9;do if((m|0)==9){m=0;if((c[(c[f>>2]|0)+4>>2]|0)!=3?(c[(c[f>>2]|0)+4>>2]|0)!=4:0)break;if((c[c[h>>2]>>2]|0)==3){m=12;break a}}while(0);b=c[j>>2]|0;c[j>>2]=b+1;c[h>>2]=c[(c[g>>2]|0)+(b<<2)>>2]}if((m|0)==8){c[e>>2]=1;l=c[e>>2]|0;i=d;return l|0}else if((m|0)==12){c[e>>2]=1;l=c[e>>2]|0;i=d;return l|0}else if((m|0)==14){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}return 0}function hP(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=b+8|0;f=b+4|0;g=b;c[f>>2]=a;c[g>>2]=c[(c[(c[f>>2]|0)+60>>2]|0)+20>>2];if((c[g>>2]|0)!=0?(c[(c[(c[f>>2]|0)+60>>2]|0)+24>>2]|0)!=0:0){while(1){if(!(d[c[g>>2]>>0]|0))break;c[g>>2]=(c[g>>2]|0)+1}while(1){if((c[g>>2]|0)!=(c[(c[(c[f>>2]|0)+60>>2]|0)+24>>2]|0))h=(d[c[g>>2]>>0]|0|0)==0;else h=0;j=c[g>>2]|0;if(!h)break;c[g>>2]=j+1}if((j|0)==(c[(c[(c[f>>2]|0)+60>>2]|0)+24>>2]|0))c[(c[(c[f>>2]|0)+60>>2]|0)+20>>2]=0;else c[(c[(c[f>>2]|0)+60>>2]|0)+20>>2]=c[g>>2];c[e>>2]=0;k=c[e>>2]|0;i=b;return k|0}c[(c[(c[f>>2]|0)+60>>2]|0)+20>>2]=0;c[(c[(c[f>>2]|0)+60>>2]|0)+24>>2]=0;c[e>>2]=0;k=c[e>>2]|0;i=b;return k|0}function iP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=0;while(1){if(!(c[f>>2]|0)){h=5;break}c[g>>2]=SO(c[e>>2]|0,c[f>>2]|0)|0;if(c[g>>2]|0){h=5;break}c[f>>2]=c[(c[f>>2]|0)+32>>2]}if((h|0)==5){i=d;return c[g>>2]|0}return 0}function jP(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+48|0;g=f+32|0;h=f+28|0;j=f+24|0;k=f+20|0;l=f+16|0;m=f+12|0;n=f+8|0;o=f+4|0;p=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=e;c[l>>2]=c[k>>2];if(((((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+36>>2]|0)!=0:0)?(c[(c[j>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[j>>2]|0)+8>>2]|0,192176)|0)!=0:0)?(qy(c[(c[(c[j>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0)q=16;else q=6;do if((q|0)==6){if(((((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+36>>2]|0)!=0:0)?(c[(c[j>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[j>>2]|0)+8>>2]|0,193584)|0)!=0:0)?(qy(c[(c[(c[j>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0){q=16;break}if(((((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+36>>2]|0)!=0:0)?(c[(c[j>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[j>>2]|0)+8>>2]|0,193592)|0)!=0:0)?(qy(c[(c[(c[j>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0)q=16}while(0);do if(((q|0)==16?(c[c[k>>2]>>2]|0)!=4:0)?(c[c[k>>2]>>2]|0)!=9:0){c[l>>2]=DN(c[h>>2]|0,c[j>>2]|0)|0;if(!(c[l>>2]|0)){c[g>>2]=0;r=c[g>>2]|0;i=f;return r|0}c[(c[l>>2]|0)+28>>2]=c[k>>2];e=c[l>>2]|0;if(c[(c[h>>2]|0)+32>>2]&1){c[e>>2]=9;break}else{c[e>>2]=4;break}}while(0);if(((((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+36>>2]|0)!=0:0)?(c[(c[j>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[j>>2]|0)+8>>2]|0,192176)|0)!=0:0)?(qy(c[(c[(c[j>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0){c[n>>2]=_i(c[j>>2]|0)|0;ZO(c[n>>2]|0);do if(Eh(c[n>>2]|0,0)|0){e=c[h>>2]|0;b=c[j>>2]|0;if(c[(c[j>>2]|0)+20>>2]|0){zN(e,b,1019,193600,c[(c[(c[j>>2]|0)+20>>2]|0)+8>>2]|0,c[n>>2]|0);break}else{zN(e,b,1019,193640,c[n>>2]|0,0);break}}while(0);c[(c[l>>2]|0)+8>>2]=c[n>>2];c[n>>2]=Yi(c[j>>2]|0,192672)|0;c[(c[l>>2]|0)+12>>2]=c[n>>2];if(((c[n>>2]|0)!=0?(c[(c[h>>2]|0)+32>>2]&1|0)!=0:0)?(qy(c[n>>2]|0,193672)|0)!=0:0)zN(c[h>>2]|0,c[j>>2]|0,1122,193704,c[n>>2]|0,0);if((((c[n>>2]|0)!=0?(c[(c[h>>2]|0)+32>>2]&1|0)!=0:0)?(d[c[n>>2]>>0]|0|0)==0:0)?(qy(c[(c[l>>2]|0)+8>>2]|0,193752)|0)!=0:0)zN(c[h>>2]|0,c[j>>2]|0,1121,193760,c[n>>2]|0,0)}else q=39;a:do if((q|0)==39){if(((((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+36>>2]|0)!=0:0)?(c[(c[j>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[j>>2]|0)+8>>2]|0,193584)|0)!=0:0)?(qy(c[(c[(c[j>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0){c[(c[l>>2]|0)+8>>2]=0;c[(c[l>>2]|0)+12>>2]=0;if(!(c[(c[j>>2]|0)+12>>2]|0))break;n=pP(c[h>>2]|0,c[(c[j>>2]|0)+12>>2]|0,(c[c[k>>2]>>2]|0)==9&1)|0;c[(c[l>>2]|0)+40>>2]=n;break}if(((((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+36>>2]|0)!=0:0)?(c[(c[j>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[j>>2]|0)+8>>2]|0,193592)|0)!=0:0)?(qy(c[(c[(c[j>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0){c[(c[l>>2]|0)+8>>2]=0;n=Yi(c[j>>2]|0,192672)|0;c[(c[l>>2]|0)+12>>2]=n;if(!(c[(c[l>>2]|0)+12>>2]|0))zN(c[h>>2]|0,c[j>>2]|0,1057,193808,0,0);if(((c[(c[h>>2]|0)+32>>2]&1|0)!=0?(c[(c[l>>2]|0)+12>>2]|0)!=0:0)?(qy(c[(c[l>>2]|0)+12>>2]|0,193672)|0)!=0:0)zN(c[h>>2]|0,c[j>>2]|0,1122,193704,c[(c[l>>2]|0)+12>>2]|0,0);if(!(c[(c[j>>2]|0)+12>>2]|0))break;n=pP(c[h>>2]|0,c[(c[j>>2]|0)+12>>2]|0,(c[c[k>>2]>>2]|0)==9&1)|0;c[(c[l>>2]|0)+40>>2]=n;break}if(((((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+36>>2]|0)!=0:0)?(c[(c[j>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[j>>2]|0)+8>>2]|0,190016)|0)!=0:0)?(qy(c[(c[(c[j>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0){c[p>>2]=0;c[l>>2]=DN(c[h>>2]|0,c[j>>2]|0)|0;if(!(c[l>>2]|0)){c[g>>2]=0;r=c[g>>2]|0;i=f;return r|0}c[(c[l>>2]|0)+28>>2]=c[k>>2];c[c[l>>2]>>2]=17;if(!(c[(c[j>>2]|0)+12>>2]|0)){zN(c[h>>2]|0,c[j>>2]|0,1007,193840,0,0);break}c[o>>2]=c[(c[j>>2]|0)+12>>2];while(1){if(!(c[o>>2]|0))break a;c[m>>2]=jP(c[h>>2]|0,c[o>>2]|0,c[l>>2]|0)|0;do if(c[m>>2]|0){n=c[m>>2]|0;if(!(c[p>>2]|0)){c[(c[l>>2]|0)+40>>2]=n;c[p>>2]=n;break}else{c[(c[p>>2]|0)+32>>2]=n;c[p>>2]=c[m>>2];break}}while(0);c[o>>2]=c[(c[o>>2]|0)+24>>2]}}if(!(c[j>>2]|0))s=193928;else s=c[(c[j>>2]|0)+8>>2]|0;zN(c[h>>2]|0,c[j>>2]|0,1006,193872,s,0);c[g>>2]=0;r=c[g>>2]|0;i=f;return r|0}while(0);do if((c[l>>2]|0)!=(c[k>>2]|0)){if(!(c[(c[k>>2]|0)+40>>2]|0)){c[(c[k>>2]|0)+40>>2]=c[l>>2];break}c[m>>2]=c[(c[k>>2]|0)+40>>2];while(1){if(!(c[(c[m>>2]|0)+32>>2]|0))break;c[m>>2]=c[(c[m>>2]|0)+32>>2]}c[(c[m>>2]|0)+32>>2]=c[l>>2]}while(0);c[g>>2]=c[l>>2];r=c[g>>2]|0;i=f;return r|0}function kP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=DN(c[f>>2]|0,c[g>>2]|0)|0;if(!(c[h>>2]|0)){c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}c[c[h>>2]>>2]=9;c[(c[h>>2]|0)+28>>2]=c[(c[f>>2]|0)+48>>2];c[k>>2]=c[(c[g>>2]|0)+12>>2];b=c[f>>2]|0;if(!(c[k>>2]|0)){zN(b,c[g>>2]|0,1004,193408,0,0);c[e>>2]=c[h>>2];m=c[e>>2]|0;i=d;return m|0}c[l>>2]=c[b+32>>2];b=(c[f>>2]|0)+32|0;c[b>>2]=c[b>>2]|1;c[j>>2]=jP(c[f>>2]|0,c[k>>2]|0,c[h>>2]|0)|0;if(c[j>>2]|0)c[k>>2]=c[(c[k>>2]|0)+24>>2];if(c[k>>2]|0){c[j>>2]=bP(c[f>>2]|0,c[k>>2]|0)|0;a:do if(c[j>>2]|0)switch(c[c[j>>2]>>2]|0){case-1:{zN(c[f>>2]|0,c[g>>2]|0,1005,193496,0,0);break a;break}case 2:case 6:case 20:{zN(c[f>>2]|0,c[g>>2]|0,1003,193464,0,0);break a;break}case 9:case 19:case 18:case 17:case 14:case 15:case 16:case 10:case 12:case 13:case 11:case 8:case 7:case 5:case 4:case 3:case 1:case 0:{c[(c[h>>2]|0)+24>>2]=c[j>>2];c[(c[j>>2]|0)+28>>2]=c[h>>2];break a;break}default:break a}while(0);c[k>>2]=c[(c[k>>2]|0)+24>>2]}if(c[k>>2]|0)zN(c[f>>2]|0,c[g>>2]|0,1002,193544,0,0);c[(c[f>>2]|0)+32>>2]=c[l>>2];c[e>>2]=c[h>>2];m=c[e>>2]|0;i=d;return m|0}function lP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+64|0;e=d+56|0;f=d+52|0;g=d+48|0;h=d+44|0;j=d+40|0;k=d+36|0;l=d+32|0;m=d+28|0;n=d+24|0;o=d+20|0;p=d+16|0;q=d+12|0;r=d+8|0;s=d+4|0;t=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;c[l>>2]=0;c[n>>2]=Yi(c[g>>2]|0,192784)|0;if(!(c[n>>2]|0)){zN(c[f>>2]|0,c[g>>2]|0,1110,193184,0,0);c[e>>2]=0;u=c[e>>2]|0;i=d;return u|0}ZO(c[n>>2]|0);if(Eh(c[n>>2]|0,0)|0)zN(c[f>>2]|0,c[g>>2]|0,1112,193208,c[n>>2]|0,0);c[o>>2]=qP(c[f>>2]|0,c[g>>2]|0)|0;if(!(c[o>>2]|0))c[o>>2]=my(192832)|0;c[h>>2]=DN(c[f>>2]|0,c[g>>2]|0)|0;if(!(c[h>>2]|0)){zb[c[135736>>2]&511](c[n>>2]|0);c[e>>2]=0;u=c[e>>2]|0;i=d;return u|0}c[c[h>>2]>>2]=5;c[(c[h>>2]|0)+8>>2]=c[n>>2];c[(c[h>>2]|0)+12>>2]=c[o>>2];c[m>>2]=Rj(c[46942]|0,c[o>>2]|0)|0;do if(c[m>>2]|0){c[(c[h>>2]|0)+20>>2]=c[m>>2];if(!(c[(c[m>>2]|0)+8>>2]|0)){zN(c[f>>2]|0,c[g>>2]|0,1026,192912,c[o>>2]|0,0);break}c[q>>2]=Hb[c[(c[m>>2]|0)+8>>2]&511](c[(c[m>>2]|0)+4>>2]|0,c[(c[h>>2]|0)+8>>2]|0)|0;if((c[q>>2]|0)!=1){zN(c[f>>2]|0,c[g>>2]|0,1111,192968,c[(c[h>>2]|0)+8>>2]|0,c[o>>2]|0);break}if(qy(c[o>>2]|0,187824)|0){if((qy(c[(c[h>>2]|0)+8>>2]|0,193248)|0)==0?(qy(c[(c[h>>2]|0)+8>>2]|0,193256)|0)==0:0)break;c[(c[f>>2]|0)+128>>2]=1}}else{zN(c[f>>2]|0,c[g>>2]|0,1116,192872,c[o>>2]|0,0);c[(c[h>>2]|0)+20>>2]=0}while(0);c[p>>2]=c[(c[g>>2]|0)+12>>2];a:while(1){if(!(c[p>>2]|0))break;if(!(qy(c[(c[p>>2]|0)+8>>2]|0,190064)|0))break;q=(qy(c[o>>2]|0,192832)|0)!=0;m=c[f>>2]|0;n=c[g>>2]|0;if(q){zN(m,n,1058,193264,c[o>>2]|0,0);c[p>>2]=c[(c[p>>2]|0)+24>>2];while(1){if(!(c[p>>2]|0))continue a;if(!(qy(c[(c[p>>2]|0)+8>>2]|0,190064)|0))continue a;c[p>>2]=c[(c[p>>2]|0)+24>>2]}}c[k>>2]=DN(m,n)|0;if(c[k>>2]|0){c[c[k>>2]>>2]=6;q=Yi(c[p>>2]|0,192176)|0;c[(c[k>>2]|0)+8>>2]=q;if(!(c[(c[k>>2]|0)+8>>2]|0))zN(c[f>>2]|0,c[g>>2]|0,1059,193320,0,0);q=_i(c[p>>2]|0)|0;c[(c[k>>2]|0)+16>>2]=q;q=c[k>>2]|0;if(!(c[l>>2]|0)){c[l>>2]=q;c[(c[h>>2]|0)+36>>2]=q}else{c[(c[l>>2]|0)+32>>2]=q;c[l>>2]=c[k>>2]}}c[p>>2]=c[(c[p>>2]|0)+24>>2]}if((c[p>>2]|0)!=0?(qy(c[(c[p>>2]|0)+8>>2]|0,189848)|0)!=0:0){c[t>>2]=0;c[j>>2]=DN(c[f>>2]|0,c[g>>2]|0)|0;if(!(c[j>>2]|0)){c[e>>2]=c[h>>2];u=c[e>>2]|0;i=d;return u|0}c[c[j>>2]>>2]=2;c[r>>2]=c[(c[p>>2]|0)+12>>2];c[(c[h>>2]|0)+24>>2]=c[j>>2];if(!(c[r>>2]|0))zN(c[f>>2]|0,c[p>>2]|0,1030,193344,0,0);while(1){if(!(c[r>>2]|0))break;c[s>>2]=bP(c[f>>2]|0,c[r>>2]|0)|0;do if(c[s>>2]|0){g=c[s>>2]|0;if(!(c[t>>2]|0)){c[t>>2]=g;c[(c[j>>2]|0)+24>>2]=g;break}else{c[(c[t>>2]|0)+32>>2]=g;c[t>>2]=c[s>>2];break}}while(0);c[r>>2]=c[(c[r>>2]|0)+24>>2]}c[p>>2]=c[(c[p>>2]|0)+24>>2]}if(c[p>>2]|0)zN(c[f>>2]|0,c[p>>2]|0,1009,193368,c[(c[p>>2]|0)+8>>2]|0,0);c[e>>2]=c[h>>2];u=c[e>>2]|0;i=d;return u|0}function mP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+48|0;e=d+32|0;f=d+28|0;g=d+24|0;h=d+20|0;j=d+16|0;k=d+12|0;l=d+8|0;m=d+4|0;n=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;c[j>>2]=0;c[m>>2]=0;c[h>>2]=DN(c[f>>2]|0,c[g>>2]|0)|0;if(!(c[h>>2]|0)){c[e>>2]=0;o=c[e>>2]|0;i=d;return o|0}c[c[h>>2]>>2]=7;c[k>>2]=Yi(c[g>>2]|0,192784)|0;do if(c[k>>2]|0){ZO(c[k>>2]|0);if(Eh(c[k>>2]|0,0)|0)zN(c[f>>2]|0,c[g>>2]|0,1112,192792,c[k>>2]|0,0);c[l>>2]=qP(c[f>>2]|0,c[g>>2]|0)|0;if(!(c[l>>2]|0))c[l>>2]=my(192832)|0;c[(c[h>>2]|0)+8>>2]=c[k>>2];c[(c[h>>2]|0)+12>>2]=c[l>>2];c[j>>2]=Rj(c[46942]|0,c[l>>2]|0)|0;if(!(c[j>>2]|0)){zN(c[f>>2]|0,c[g>>2]|0,1116,192872,c[l>>2]|0,0);c[(c[h>>2]|0)+20>>2]=0;break}c[(c[h>>2]|0)+20>>2]=c[j>>2];if(!(c[(c[j>>2]|0)+8>>2]|0)){zN(c[f>>2]|0,c[g>>2]|0,1026,192912,c[l>>2]|0,0);break}c[m>>2]=Hb[c[(c[j>>2]|0)+8>>2]&511](c[(c[j>>2]|0)+4>>2]|0,c[(c[h>>2]|0)+8>>2]|0)|0;if((c[m>>2]|0)!=1)zN(c[f>>2]|0,c[g>>2]|0,1111,192968,c[(c[h>>2]|0)+8>>2]|0,c[l>>2]|0)}while(0);do if(!(c[(c[g>>2]|0)+12>>2]|0)){l=my(188112)|0;c[(c[h>>2]|0)+16>>2]=l}else{if(!((c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]|0)!=3?(c[(c[(c[g>>2]|0)+12>>2]|0)+4>>2]|0)!=4:0))p=18;if((p|0)==18?(c[(c[(c[g>>2]|0)+12>>2]|0)+24>>2]|0)==0:0){if(!(c[h>>2]|0))break;l=_i(c[g>>2]|0)|0;c[(c[h>>2]|0)+16>>2]=l;if(!(c[(c[h>>2]|0)+16>>2]|0)){zN(c[f>>2]|0,c[g>>2]|0,1120,193080,0,0);break}if(!(c[j>>2]|0))break;if(!((c[m>>2]|0)==1?(c[(c[j>>2]|0)+12>>2]|0)!=0:0))break;c[n>>2]=0;c[m>>2]=Ib[c[(c[j>>2]|0)+12>>2]&511](c[(c[j>>2]|0)+4>>2]|0,c[(c[h>>2]|0)+8>>2]|0,c[(c[h>>2]|0)+16>>2]|0,n,c[g>>2]|0)|0;if((c[m>>2]|0)!=1){zN(c[f>>2]|0,c[g>>2]|0,1051,193112,c[(c[h>>2]|0)+16>>2]|0,c[(c[h>>2]|0)+8>>2]|0);break}if(!(c[n>>2]|0))break;c[(c[h>>2]|0)+36>>2]=c[n>>2];break}zN(c[f>>2]|0,c[g>>2]|0,1108,193024,0,0)}while(0);c[e>>2]=c[h>>2];o=c[e>>2]|0;i=d;return o|0}function nP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+64|0;e=d;f=d+28|0;g=d+24|0;h=d+20|0;j=d+16|0;k=d+12|0;l=d+8|0;m=d+4|0;n=d+32|0;c[g>>2]=a;c[h>>2]=b;c[j>>2]=0;c[k>>2]=0;c[j>>2]=DN(c[g>>2]|0,c[h>>2]|0)|0;if(!(c[j>>2]|0)){c[f>>2]=0;o=c[f>>2]|0;i=d;return o|0}c[c[j>>2]>>2]=19;if(!(c[(c[g>>2]|0)+56>>2]|0)){b=Ij(10)|0;c[(c[g>>2]|0)+56>>2]=b}if(c[(c[g>>2]|0)+56>>2]|0){b=(c[g>>2]|0)+52|0;a=c[b>>2]|0;c[b>>2]=a+1;c[e>>2]=a;JT(n,32,192704,e)|0;if((Lj(c[(c[g>>2]|0)+56>>2]|0,n,c[j>>2]|0)|0)<0)zN(c[g>>2]|0,c[h>>2]|0,1045,192720,n,0)}else xN(c[g>>2]|0,192680);c[m>>2]=c[(c[h>>2]|0)+12>>2];if(!(c[m>>2]|0))zN(c[g>>2]|0,c[h>>2]|0,1048,192752,0,0);while(1){if(!(c[m>>2]|0))break;if(((((c[m>>2]|0)!=0?(c[(c[m>>2]|0)+36>>2]|0)!=0:0)?(c[(c[m>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[m>>2]|0)+8>>2]|0,189864)|0)!=0:0)?(qy(c[(c[(c[m>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0)c[l>>2]=aP(c[g>>2]|0,c[m>>2]|0)|0;else c[l>>2]=bP(c[g>>2]|0,c[m>>2]|0)|0;do if(c[l>>2]|0){c[(c[l>>2]|0)+28>>2]=c[j>>2];h=c[l>>2]|0;if(!(c[k>>2]|0)){c[k>>2]=h;c[(c[j>>2]|0)+24>>2]=h;break}else{c[(c[k>>2]|0)+32>>2]=h;c[k>>2]=c[l>>2];break}}while(0);c[m>>2]=c[(c[m>>2]|0)+24>>2]}c[f>>2]=c[j>>2];o=c[f>>2]|0;i=d;return o|0}function oP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+48|0;e=d+36|0;f=d+32|0;g=d+28|0;h=d+24|0;j=d+20|0;k=d+16|0;l=d+12|0;m=d+8|0;n=d+4|0;o=d;c[f>>2]=a;c[g>>2]=b;c[m>>2]=0;c[h>>2]=c[(c[g>>2]|0)+52>>2];if(c[h>>2]|0){c[o>>2]=DN(c[f>>2]|0,c[g>>2]|0)|0;if(!(c[o>>2]|0)){c[e>>2]=0;p=c[e>>2]|0;i=d;return p|0}c[c[o>>2]>>2]=12;if(!(c[(c[h>>2]|0)+12>>2]|0)){c[j>>2]=Pi(c[(c[h>>2]|0)+8>>2]|0)|0;if(!(c[j>>2]|0)){zN(c[f>>2]|0,c[g>>2]|0,1031,188056,c[(c[f>>2]|0)+68>>2]|0,0);c[e>>2]=0;p=c[e>>2]|0;i=d;return p|0}c[l>>2]=Yi(c[j>>2]|0,192672)|0;if(!(c[l>>2]|0)){c[k>>2]=c[g>>2];while(1){if(!(c[k>>2]|0))break;if((c[(c[k>>2]|0)+4>>2]|0)!=1)break;c[l>>2]=Yi(c[k>>2]|0,192672)|0;if(c[l>>2]|0)break;c[k>>2]=c[(c[k>>2]|0)+20>>2]}if(c[l>>2]|0){gj(c[j>>2]|0,192672,c[l>>2]|0)|0;c[m>>2]=1;zb[c[135736>>2]&511](c[l>>2]|0)}}else zb[c[135736>>2]&511](c[l>>2]|0);c[n>>2]=c[(c[f>>2]|0)+32>>2];l=(c[f>>2]|0)+32|0;c[l>>2]=c[l>>2]|128;l=BN(c[f>>2]|0,c[j>>2]|0)|0;c[(c[h>>2]|0)+16>>2]=l;c[(c[f>>2]|0)+32>>2]=c[n>>2];if(((c[(c[h>>2]|0)+16>>2]|0)!=0?(c[(c[(c[h>>2]|0)+16>>2]|0)+4>>2]|0)!=0:0)?(c[(c[h>>2]|0)+12>>2]=c[(c[(c[(c[h>>2]|0)+16>>2]|0)+4>>2]|0)+12>>2],(c[(c[(c[(c[h>>2]|0)+16>>2]|0)+4>>2]|0)+28>>2]|0)!=0):0)rP(c[f>>2]|0,c[(c[(c[h>>2]|0)+16>>2]|0)+4>>2]|0)|0;if((c[m>>2]|0)==1)fj(c[j>>2]|0,192672)|0}c[(c[o>>2]|0)+24>>2]=c[(c[h>>2]|0)+12>>2]}else c[o>>2]=0;c[e>>2]=c[o>>2];p=c[e>>2]|0;i=d;return p|0}function pP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;n=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[m>>2]=0;if(((((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+36>>2]|0)!=0:0)?(c[(c[h>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[h>>2]|0)+8>>2]|0,189848)|0)!=0:0)?(qy(c[(c[(c[h>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0){if(c[(c[h>>2]|0)+24>>2]|0)zN(c[g>>2]|0,c[h>>2]|0,1029,193968,0,0);d=c[g>>2]|0;b=c[h>>2]|0;if(!(c[(c[h>>2]|0)+12>>2]|0)){zN(d,b,1027,193344,0,0);c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}c[k>>2]=DN(d,b)|0;if(!(c[k>>2]|0)){c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}c[c[k>>2]>>2]=2;c[n>>2]=c[(c[h>>2]|0)+12>>2];while(1){if(!(c[n>>2]|0))break;c[l>>2]=DN(c[g>>2]|0,c[n>>2]|0)|0;if(!(c[l>>2]|0))break;b=c[l>>2]|0;if(c[j>>2]|0)c[b>>2]=9;else c[b>>2]=4;
if(jP(c[g>>2]|0,c[n>>2]|0,c[l>>2]|0)|0){b=c[l>>2]|0;if(!(c[m>>2]|0))c[(c[k>>2]|0)+24>>2]=b;else c[(c[m>>2]|0)+32>>2]=b;c[m>>2]=c[l>>2]}c[n>>2]=c[(c[n>>2]|0)+24>>2]}c[f>>2]=c[k>>2];o=c[f>>2]|0;i=e;return o|0}zN(c[g>>2]|0,c[h>>2]|0,1028,193936,0,0);c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}function qP(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+8|0;h=e+4|0;j=e;c[e+12>>2]=a;c[g>>2]=b;if(!(c[g>>2]|0)){c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}if(((((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+36>>2]|0)!=0:0)?(c[(c[g>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[g>>2]|0)+8>>2]|0,192360)|0)!=0:0)?(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0)l=13;else l=8;if((((((l|0)==8?(c[g>>2]|0)!=0:0)?(c[(c[g>>2]|0)+36>>2]|0)!=0:0)?(c[(c[g>>2]|0)+4>>2]|0)==1:0)?(qy(c[(c[g>>2]|0)+8>>2]|0,189888)|0)!=0:0)?(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,c[46968]|0)|0)!=0:0)l=13;if((l|0)==13?(c[h>>2]=Yi(c[g>>2]|0,193160)|0,(c[h>>2]|0)!=0):0){if(!(d[c[h>>2]>>0]|0)){zb[c[135736>>2]&511](c[h>>2]|0);c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}c[j>>2]=Fl(c[h>>2]|0,193176)|0;if(!(c[j>>2]|0)){c[f>>2]=c[h>>2];k=c[f>>2]|0;i=e;return k|0}else{zb[c[135736>>2]&511](c[h>>2]|0);c[f>>2]=c[j>>2];k=c[f>>2]|0;i=e;return k|0}}c[g>>2]=c[(c[g>>2]|0)+20>>2];while(1){if(!(c[g>>2]|0)){l=29;break}if((c[(c[g>>2]|0)+4>>2]|0)!=1){l=29;break}c[h>>2]=Yi(c[g>>2]|0,193160)|0;if(c[h>>2]|0)break;c[g>>2]=c[(c[g>>2]|0)+20>>2]}if((l|0)==29){c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}if(!(d[c[h>>2]>>0]|0)){zb[c[135736>>2]&511](c[h>>2]|0);c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}c[j>>2]=Fl(c[h>>2]|0,193176)|0;if(!(c[j>>2]|0)){c[f>>2]=c[h>>2];k=c[f>>2]|0;i=e;return k|0}else{zb[c[135736>>2]&511](c[h>>2]|0);c[f>>2]=c[j>>2];k=c[f>>2]|0;i=e;return k|0}return 0}function rP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if(!((c[f>>2]|0)==0|(c[g>>2]|0)==0)?(c[(c[f>>2]|0)+24>>2]|0)!=0:0){if(!(c[(c[g>>2]|0)+28>>2]|0)){c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}if(!(c[(c[(c[f>>2]|0)+24>>2]|0)+28>>2]|0)){b=Ij(10)|0;c[(c[(c[f>>2]|0)+24>>2]|0)+28>>2]=b}if(!(c[(c[(c[f>>2]|0)+24>>2]|0)+28>>2]|0)){zN(c[f>>2]|0,0,1098,192264,0,0);c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}else{Wj(c[(c[g>>2]|0)+28>>2]|0,386,c[f>>2]|0);c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}}c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}function sP(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f;c[g>>2]=a;c[h>>2]=d;c[j>>2]=e;c[k>>2]=c[h>>2];c[l>>2]=c[g>>2];g=(c[l>>2]|0)+50|0;b[g>>1]=b[g>>1]|256;c[m>>2]=Lj(c[(c[(c[k>>2]|0)+24>>2]|0)+28>>2]|0,c[j>>2]|0,c[l>>2]|0)|0;if((c[m>>2]|0)>=0){i=f;return}c[n>>2]=Rj(c[(c[(c[k>>2]|0)+24>>2]|0)+28>>2]|0,c[(c[l>>2]|0)+8>>2]|0)|0;if(c[n>>2]|0){c[(c[l>>2]|0)+44>>2]=c[(c[n>>2]|0)+44>>2];c[(c[n>>2]|0)+44>>2]=c[l>>2];i=f;return}n=c[k>>2]|0;if(c[(c[l>>2]|0)+8>>2]|0){zN(n,0,1098,192304,c[(c[l>>2]|0)+8>>2]|0,0);i=f;return}else{zN(n,0,1098,192336,0,0);i=f;return}}function tP(){return 0}function uP(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a;do if(!(c[49266]|0)){d=tx()|0;c[49268]=d;if(!d){c[b>>2]=0;break}else{vx(c[49268]|0);c[49270]=jb(0)|0;ET(197080)|0;c[49266]=1;wx(c[49268]|0);c[b>>2]=1;break}}else c[b>>2]=1;while(0);i=a;return c[b>>2]|0}function vP(){var a=0,b=0;a=i;i=i+16|0;b=a;if(!(c[49266]|0))uP()|0;vx(c[49268]|0);c[b>>2]=ET(197080)|0;wx(c[49268]|0);i=a;return c[b>>2]|0}function wP(){var a=0;a=i;if(!(c[49266]|0)){i=a;return}ux(c[49268]|0);c[49266]=0;i=a;return}function xP(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;if((c[49266]|0)==0?(uP()|0)==0:0){c[b>>2]=0;e=c[b>>2]|0;i=a;return e|0}c[d>>2]=Cb[c[135744>>2]&511](32)|0;do if(c[d>>2]|0){c[c[d>>2]>>2]=1;c[(c[d>>2]|0)+28>>2]=0;c[(c[d>>2]|0)+8>>2]=128;c[(c[d>>2]|0)+12>>2]=0;f=Cb[c[135744>>2]&511](2560)|0;c[(c[d>>2]|0)+4>>2]=f;c[(c[d>>2]|0)+16>>2]=0;c[(c[d>>2]|0)+20>>2]=0;if(!(c[(c[d>>2]|0)+4>>2]|0)){zb[c[135736>>2]&511](c[d>>2]|0);break}cU(c[(c[d>>2]|0)+4>>2]|0,0,2560)|0;f=vP()|0;c[(c[d>>2]|0)+24>>2]=f;c[b>>2]=c[d>>2];e=c[b>>2]|0;i=a;return e|0}while(0);c[b>>2]=0;e=c[b>>2]|0;i=a;return e|0}function yP(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;if((c[49266]|0)==0?(uP()|0)==0:0)c[d>>2]=-1;else f=4;do if((f|0)==4)if(!(c[e>>2]|0)){c[d>>2]=-1;break}else{vx(c[49268]|0);a=c[e>>2]|0;c[a>>2]=(c[a>>2]|0)+1;wx(c[49268]|0);c[d>>2]=0;break}while(0);i=b;return c[d>>2]|0}function zP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+32|0;d=b+24|0;e=b+20|0;f=b+16|0;g=b+12|0;h=b+8|0;j=b+4|0;k=b;c[d>>2]=a;c[h>>2]=0;if(!(c[d>>2]|0)){i=b;return}if((c[49266]|0)==0?(uP()|0)==0:0){i=b;return}vx(c[49268]|0);a=c[d>>2]|0;c[a>>2]=(c[a>>2]|0)+-1;a=(c[c[d>>2]>>2]|0)>0;wx(c[49268]|0);if(a){i=b;return}if(c[(c[d>>2]|0)+20>>2]|0)zP(c[(c[d>>2]|0)+20>>2]|0);if(c[(c[d>>2]|0)+4>>2]|0){c[e>>2]=0;while(1){if((c[e>>2]|0)>>>0>=(c[(c[d>>2]|0)+8>>2]|0)>>>0)break;if((c[(c[d>>2]|0)+12>>2]|0)>>>0<=0)break;c[f>>2]=(c[(c[d>>2]|0)+4>>2]|0)+((c[e>>2]|0)*20|0);a:do if(c[(c[f>>2]|0)+12>>2]|0){c[h>>2]=1;while(1){if(!(c[f>>2]|0))break a;c[g>>2]=c[c[f>>2]>>2];if(!(c[h>>2]|0))zb[c[135736>>2]&511](c[f>>2]|0);a=(c[d>>2]|0)+12|0;c[a>>2]=(c[a>>2]|0)+-1;c[h>>2]=0;c[f>>2]=c[g>>2]}}while(0);c[e>>2]=(c[e>>2]|0)+1}zb[c[135736>>2]&511](c[(c[d>>2]|0)+4>>2]|0)}c[j>>2]=c[(c[d>>2]|0)+16>>2];while(1){if(!(c[j>>2]|0))break;c[k>>2]=c[c[j>>2]>>2];zb[c[135736>>2]&511](c[j>>2]|0);c[j>>2]=c[k>>2]}zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function AP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;i=i+64|0;f=e+48|0;g=e+44|0;h=e+40|0;j=e+36|0;k=e+32|0;l=e+28|0;m=e+24|0;n=e+20|0;o=e+16|0;p=e+12|0;q=e+8|0;r=e+4|0;s=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[m>>2]=0;if((c[g>>2]|0)==0|(c[h>>2]|0)==0){c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}if((c[j>>2]|0)<0)c[q>>2]=ZT(c[h>>2]|0)|0;else c[q>>2]=c[j>>2];j=c[q>>2]|0;if((c[(c[g>>2]|0)+28>>2]|0)>>>0>0){if((c[q>>2]|0)>>>0>1073741823?1:j>>>0>=(c[(c[g>>2]|0)+28>>2]|0)>>>0)u=9}else if(j>>>0>1073741823)u=9;if((u|0)==9){c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}j=c[h>>2]|0;d=c[q>>2]|0;b=c[(c[g>>2]|0)+24>>2]|0;if((c[(c[g>>2]|0)+8>>2]|0)==128)v=EP(j,d,b)|0;else v=FP(j,d,b)|0;c[l>>2]=v;c[k>>2]=((c[l>>2]|0)>>>0)%((c[(c[g>>2]|0)+8>>2]|0)>>>0)|0;if(c[(c[(c[g>>2]|0)+4>>2]|0)+((c[k>>2]|0)*20|0)+12>>2]|0){c[o>>2]=(c[(c[g>>2]|0)+4>>2]|0)+((c[k>>2]|0)*20|0);while(1){w=(c[(c[o>>2]|0)+16>>2]|0)==(c[l>>2]|0);if(!(c[c[o>>2]>>2]|0))break;if((w?(c[(c[o>>2]|0)+8>>2]|0)==(c[q>>2]|0):0)?(OT(c[(c[o>>2]|0)+4>>2]|0,c[h>>2]|0,c[q>>2]|0)|0)==0:0){u=20;break}c[m>>2]=(c[m>>2]|0)+1;c[o>>2]=c[c[o>>2]>>2]}if((u|0)==20){c[f>>2]=c[(c[o>>2]|0)+4>>2];t=c[f>>2]|0;i=e;return t|0}if((w?(c[(c[o>>2]|0)+8>>2]|0)==(c[q>>2]|0):0)?(OT(c[(c[o>>2]|0)+4>>2]|0,c[h>>2]|0,c[q>>2]|0)|0)==0:0){c[f>>2]=c[(c[o>>2]|0)+4>>2];t=c[f>>2]|0;i=e;return t|0}}else c[o>>2]=0;if(c[(c[g>>2]|0)+20>>2]|0){if((c[(c[g>>2]|0)+8>>2]|0)==128?(c[(c[(c[g>>2]|0)+20>>2]|0)+8>>2]|0)!=128:0)u=31;else u=29;do if((u|0)==29){if((c[(c[g>>2]|0)+8>>2]|0)!=128?(c[(c[(c[g>>2]|0)+20>>2]|0)+8>>2]|0)==128:0){u=31;break}c[r>>2]=c[l>>2]}while(0);if((u|0)==31){w=c[h>>2]|0;v=c[q>>2]|0;b=c[(c[(c[g>>2]|0)+20>>2]|0)+24>>2]|0;if((c[(c[(c[g>>2]|0)+20>>2]|0)+8>>2]|0)==128)x=EP(w,v,b)|0;else x=FP(w,v,b)|0;c[r>>2]=x}c[k>>2]=((c[r>>2]|0)>>>0)%((c[(c[(c[g>>2]|0)+20>>2]|0)+8>>2]|0)>>>0)|0;if(c[(c[(c[(c[g>>2]|0)+20>>2]|0)+4>>2]|0)+((c[k>>2]|0)*20|0)+12>>2]|0){c[s>>2]=(c[(c[(c[g>>2]|0)+20>>2]|0)+4>>2]|0)+((c[k>>2]|0)*20|0);while(1){y=(c[(c[s>>2]|0)+16>>2]|0)==(c[r>>2]|0);if(!(c[c[s>>2]>>2]|0))break;if((y?(c[(c[s>>2]|0)+8>>2]|0)==(c[q>>2]|0):0)?(OT(c[(c[s>>2]|0)+4>>2]|0,c[h>>2]|0,c[q>>2]|0)|0)==0:0){u=42;break}c[m>>2]=(c[m>>2]|0)+1;c[s>>2]=c[c[s>>2]>>2]}if((u|0)==42){c[f>>2]=c[(c[s>>2]|0)+4>>2];t=c[f>>2]|0;i=e;return t|0}if((y?(c[(c[s>>2]|0)+8>>2]|0)==(c[q>>2]|0):0)?(OT(c[(c[s>>2]|0)+4>>2]|0,c[h>>2]|0,c[q>>2]|0)|0)==0:0){c[f>>2]=c[(c[s>>2]|0)+4>>2];t=c[f>>2]|0;i=e;return t|0}}c[k>>2]=((c[l>>2]|0)>>>0)%((c[(c[g>>2]|0)+8>>2]|0)>>>0)|0}c[p>>2]=GP(c[g>>2]|0,c[h>>2]|0,c[q>>2]|0)|0;if(!(c[p>>2]|0)){c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}if(c[o>>2]|0){c[n>>2]=Cb[c[135744>>2]&511](20)|0;if(!(c[n>>2]|0)){c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}}else c[n>>2]=(c[(c[g>>2]|0)+4>>2]|0)+((c[k>>2]|0)*20|0);c[(c[n>>2]|0)+4>>2]=c[p>>2];c[(c[n>>2]|0)+8>>2]=c[q>>2];c[c[n>>2]>>2]=0;c[(c[n>>2]|0)+12>>2]=1;c[(c[n>>2]|0)+16>>2]=c[l>>2];if(c[o>>2]|0)c[c[o>>2]>>2]=c[n>>2];n=(c[g>>2]|0)+12|0;c[n>>2]=(c[n>>2]|0)+1;if(((c[m>>2]|0)>>>0>3?(c[(c[g>>2]|0)+8>>2]|0)>>>0<=2730:0)?(HP(c[g>>2]|0,(c[(c[g>>2]|0)+8>>2]|0)*6|0)|0)!=0:0){c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}c[f>>2]=c[p>>2];t=c[f>>2]|0;i=e;return t|0}function BP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+64|0;f=e+56|0;g=e+52|0;h=e+48|0;j=e+44|0;k=e+40|0;l=e+36|0;m=e+32|0;n=e+28|0;o=e+24|0;p=e+20|0;q=e+16|0;r=e+12|0;s=e+8|0;t=e+4|0;u=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[m>>2]=0;if((c[g>>2]|0)==0|(c[j>>2]|0)==0){c[f>>2]=0;v=c[f>>2]|0;i=e;return v|0}if(!(c[h>>2]|0)){c[f>>2]=AP(c[g>>2]|0,c[j>>2]|0,-1)|0;v=c[f>>2]|0;i=e;return v|0}d=ZT(c[j>>2]|0)|0;c[q>>2]=d;c[s>>2]=d;c[r>>2]=ZT(c[h>>2]|0)|0;c[q>>2]=(c[q>>2]|0)+(1+(c[r>>2]|0));d=(c[(c[g>>2]|0)+8>>2]|0)==128;do if(!(c[h>>2]|0)){b=c[j>>2]|0;a=c[s>>2]|0;w=c[(c[g>>2]|0)+24>>2]|0;if(d){x=EP(b,a,w)|0;break}else{x=FP(b,a,w)|0;break}}else{w=c[h>>2]|0;a=c[r>>2]|0;b=c[j>>2]|0;y=c[s>>2]|0;z=c[(c[g>>2]|0)+24>>2]|0;if(d){x=IP(w,a,b,y,z)|0;break}else{x=JP(w,a,b,y,z)|0;break}}while(0);c[k>>2]=x;c[l>>2]=((c[k>>2]|0)>>>0)%((c[(c[g>>2]|0)+8>>2]|0)>>>0)|0;if(c[(c[(c[g>>2]|0)+4>>2]|0)+((c[l>>2]|0)*20|0)+12>>2]|0){c[o>>2]=(c[(c[g>>2]|0)+4>>2]|0)+((c[l>>2]|0)*20|0);while(1){A=(c[(c[o>>2]|0)+16>>2]|0)==(c[k>>2]|0);if(!(c[c[o>>2]>>2]|0))break;if((A?(c[(c[o>>2]|0)+8>>2]|0)==(c[q>>2]|0):0)?(ry(c[h>>2]|0,c[j>>2]|0,c[(c[o>>2]|0)+4>>2]|0)|0)!=0:0){B=19;break}c[m>>2]=(c[m>>2]|0)+1;c[o>>2]=c[c[o>>2]>>2]}if((B|0)==19){c[f>>2]=c[(c[o>>2]|0)+4>>2];v=c[f>>2]|0;i=e;return v|0}if((A?(c[(c[o>>2]|0)+8>>2]|0)==(c[q>>2]|0):0)?(ry(c[h>>2]|0,c[j>>2]|0,c[(c[o>>2]|0)+4>>2]|0)|0)!=0:0){c[f>>2]=c[(c[o>>2]|0)+4>>2];v=c[f>>2]|0;i=e;return v|0}}else c[o>>2]=0;if(c[(c[g>>2]|0)+20>>2]|0){if((c[(c[g>>2]|0)+8>>2]|0)==128?(c[(c[(c[g>>2]|0)+20>>2]|0)+8>>2]|0)!=128:0)B=30;else B=28;do if((B|0)==28){if((c[(c[g>>2]|0)+8>>2]|0)!=128?(c[(c[(c[g>>2]|0)+20>>2]|0)+8>>2]|0)==128:0){B=30;break}c[t>>2]=c[k>>2]}while(0);if((B|0)==30){A=(c[(c[(c[g>>2]|0)+20>>2]|0)+8>>2]|0)==128;do if(!(c[h>>2]|0)){x=c[j>>2]|0;d=c[s>>2]|0;z=c[(c[(c[g>>2]|0)+20>>2]|0)+24>>2]|0;if(A){C=EP(x,d,z)|0;break}else{C=FP(x,d,z)|0;break}}else{z=c[h>>2]|0;d=c[r>>2]|0;x=c[j>>2]|0;y=c[s>>2]|0;b=c[(c[(c[g>>2]|0)+20>>2]|0)+24>>2]|0;if(A){C=IP(z,d,x,y,b)|0;break}else{C=JP(z,d,x,y,b)|0;break}}while(0);c[t>>2]=C}c[l>>2]=((c[t>>2]|0)>>>0)%((c[(c[(c[g>>2]|0)+20>>2]|0)+8>>2]|0)>>>0)|0;if(c[(c[(c[(c[g>>2]|0)+20>>2]|0)+4>>2]|0)+((c[l>>2]|0)*20|0)+12>>2]|0){c[u>>2]=(c[(c[(c[g>>2]|0)+20>>2]|0)+4>>2]|0)+((c[l>>2]|0)*20|0);while(1){D=(c[(c[u>>2]|0)+16>>2]|0)==(c[t>>2]|0);if(!(c[c[u>>2]>>2]|0))break;if((D?(c[(c[u>>2]|0)+8>>2]|0)==(c[q>>2]|0):0)?(ry(c[h>>2]|0,c[j>>2]|0,c[(c[u>>2]|0)+4>>2]|0)|0)!=0:0){B=45;break}c[m>>2]=(c[m>>2]|0)+1;c[u>>2]=c[c[u>>2]>>2]}if((B|0)==45){c[f>>2]=c[(c[u>>2]|0)+4>>2];v=c[f>>2]|0;i=e;return v|0}if((D?(c[(c[u>>2]|0)+8>>2]|0)==(c[q>>2]|0):0)?(ry(c[h>>2]|0,c[j>>2]|0,c[(c[u>>2]|0)+4>>2]|0)|0)!=0:0){c[f>>2]=c[(c[u>>2]|0)+4>>2];v=c[f>>2]|0;i=e;return v|0}}c[l>>2]=((c[k>>2]|0)>>>0)%((c[(c[g>>2]|0)+8>>2]|0)>>>0)|0}c[p>>2]=KP(c[g>>2]|0,c[h>>2]|0,c[r>>2]|0,c[j>>2]|0,c[s>>2]|0)|0;if(!(c[p>>2]|0)){c[f>>2]=0;v=c[f>>2]|0;i=e;return v|0}if(c[o>>2]|0){c[n>>2]=Cb[c[135744>>2]&511](20)|0;if(!(c[n>>2]|0)){c[f>>2]=0;v=c[f>>2]|0;i=e;return v|0}}else c[n>>2]=(c[(c[g>>2]|0)+4>>2]|0)+((c[l>>2]|0)*20|0);c[(c[n>>2]|0)+4>>2]=c[p>>2];c[(c[n>>2]|0)+8>>2]=c[q>>2];c[c[n>>2]>>2]=0;c[(c[n>>2]|0)+12>>2]=1;c[(c[n>>2]|0)+16>>2]=c[k>>2];if(c[o>>2]|0)c[c[o>>2]>>2]=c[n>>2];n=(c[g>>2]|0)+12|0;c[n>>2]=(c[n>>2]|0)+1;if((c[m>>2]|0)>>>0>3?(c[(c[g>>2]|0)+8>>2]|0)>>>0<=2730:0)HP(c[g>>2]|0,(c[(c[g>>2]|0)+8>>2]|0)*6|0)|0;c[f>>2]=c[p>>2];v=c[f>>2]|0;i=e;return v|0}function CP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){c[e>>2]=-1;j=c[e>>2]|0;i=d;return j|0}c[h>>2]=c[(c[f>>2]|0)+16>>2];while(1){if(!(c[h>>2]|0))break;if((c[g>>2]|0)>>>0>=((c[h>>2]|0)+20|0)>>>0?(c[g>>2]|0)>>>0<=(c[(c[h>>2]|0)+4>>2]|0)>>>0:0){k=7;break}c[h>>2]=c[c[h>>2]>>2]}if((k|0)==7){c[e>>2]=1;j=c[e>>2]|0;i=d;return j|0}if(c[(c[f>>2]|0)+20>>2]|0){c[e>>2]=CP(c[(c[f>>2]|0)+20>>2]|0,c[g>>2]|0)|0;j=c[e>>2]|0;i=d;return j|0}else{c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}return 0}function DP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if(!(c[f>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}else{c[h>>2]=c[(c[f>>2]|0)+28>>2];c[(c[f>>2]|0)+28>>2]=c[g>>2];c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}return 0}function EP(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=e;c[l>>2]=c[k>>2];if(!(c[h>>2]|0)){c[g>>2]=0;m=c[g>>2]|0;i=f;return m|0}c[l>>2]=d[c[h>>2]>>0];c[l>>2]=c[l>>2]<<5;if((c[j>>2]|0)>10){c[l>>2]=(c[l>>2]|0)+(d[(c[h>>2]|0)+((c[j>>2]|0)-1)>>0]|0);c[j>>2]=10}switch(c[j>>2]|0){case 7:{n=9;break}case 6:{n=10;break}case 9:{n=7;break}case 3:{n=13;break}case 8:{n=8;break}case 10:{c[l>>2]=(c[l>>2]|0)+(d[(c[h>>2]|0)+9>>0]|0);n=7;break}case 2:{n=14;break}case 4:{n=12;break}case 5:{n=11;break}default:{}}if((n|0)==7){c[l>>2]=(c[l>>2]|0)+(d[(c[h>>2]|0)+8>>0]|0);n=8}if((n|0)==8){c[l>>2]=(c[l>>2]|0)+(d[(c[h>>2]|0)+7>>0]|0);n=9}if((n|0)==9){c[l>>2]=(c[l>>2]|0)+(d[(c[h>>2]|0)+6>>0]|0);n=10}if((n|0)==10){c[l>>2]=(c[l>>2]|0)+(d[(c[h>>2]|0)+5>>0]|0);n=11}if((n|0)==11){c[l>>2]=(c[l>>2]|0)+(d[(c[h>>2]|0)+4>>0]|0);n=12}if((n|0)==12){c[l>>2]=(c[l>>2]|0)+(d[(c[h>>2]|0)+3>>0]|0);n=13}if((n|0)==13){c[l>>2]=(c[l>>2]|0)+(d[(c[h>>2]|0)+2>>0]|0);n=14}if((n|0)==14)c[l>>2]=(c[l>>2]|0)+(d[(c[h>>2]|0)+1>>0]|0);c[g>>2]=c[l>>2];m=c[g>>2]|0;i=f;return m|0}function FP(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=e;if((c[j>>2]|0)<=0|(c[h>>2]|0)==0){c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}c[l>>2]=c[k>>2];c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[j>>2]|0))break;c[l>>2]=(c[l>>2]|0)+(d[(c[h>>2]|0)+(c[m>>2]|0)>>0]|0);c[l>>2]=(c[l>>2]|0)+(c[l>>2]<<10);c[l>>2]=c[l>>2]^(c[l>>2]|0)>>>6;c[m>>2]=(c[m>>2]|0)+1}c[l>>2]=(c[l>>2]|0)+(c[l>>2]<<3);c[l>>2]=c[l>>2]^(c[l>>2]|0)>>>11;c[l>>2]=(c[l>>2]|0)+(c[l>>2]<<15);c[g>>2]=c[l>>2];n=c[g>>2]|0;i=f;return n|0}function GP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+32|0;g=f+28|0;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f+4|0;o=f;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[n>>2]=0;c[o>>2]=0;c[l>>2]=c[(c[h>>2]|0)+16>>2];while(1){p=c[l>>2]|0;if(!(c[l>>2]|0)){q=7;break}if(((c[p+8>>2]|0)-(c[(c[l>>2]|0)+4>>2]|0)|0)>>>0>(c[k>>2]|0)>>>0)break;if((c[(c[l>>2]|0)+12>>2]|0)>>>0>(c[n>>2]|0)>>>0)c[n>>2]=c[(c[l>>2]|0)+12>>2];c[o>>2]=(c[o>>2]|0)+(c[(c[l>>2]|0)+12>>2]|0);c[l>>2]=c[c[l>>2]>>2]}do if((q|0)==7?(p|0)==0:0){if((c[(c[h>>2]|0)+28>>2]|0)>>>0>0?(c[o>>2]|0)>>>0>(c[(c[h>>2]|0)+28>>2]|0)>>>0:0){c[g>>2]=0;r=c[g>>2]|0;i=f;return r|0}if(!(c[n>>2]|0))c[n>>2]=1e3;else c[n>>2]=c[n>>2]<<2;if((c[n>>2]|0)>>>0<c[k>>2]<<2>>>0)c[n>>2]=c[k>>2]<<2;c[l>>2]=Cb[c[135744>>2]&511](24+(c[n>>2]|0)|0)|0;if(c[l>>2]|0){c[(c[l>>2]|0)+12>>2]=c[n>>2];c[(c[l>>2]|0)+16>>2]=0;c[(c[l>>2]|0)+4>>2]=(c[l>>2]|0)+20;c[(c[l>>2]|0)+8>>2]=(c[l>>2]|0)+20+(c[n>>2]|0);c[c[l>>2]>>2]=c[(c[h>>2]|0)+16>>2];c[(c[h>>2]|0)+16>>2]=c[l>>2];break}c[g>>2]=0;r=c[g>>2]|0;i=f;return r|0}while(0);c[m>>2]=c[(c[l>>2]|0)+4>>2];eU(c[(c[l>>2]|0)+4>>2]|0,c[j>>2]|0,c[k>>2]|0)|0;j=(c[l>>2]|0)+4|0;c[j>>2]=(c[j>>2]|0)+(c[k>>2]|0);k=(c[l>>2]|0)+4|0;j=c[k>>2]|0;c[k>>2]=j+1;a[j>>0]=0;j=(c[l>>2]|0)+16|0;c[j>>2]=(c[j>>2]|0)+1;c[g>>2]=c[m>>2];r=c[g>>2]|0;i=f;return r|0}function HP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+64|0;e=d+48|0;f=d+44|0;g=d+40|0;h=d+36|0;j=d+32|0;k=d+28|0;l=d+24|0;m=d+20|0;n=d+16|0;o=d+12|0;p=d+8|0;q=d+4|0;r=d;c[f>>2]=a;c[g>>2]=b;c[p>>2]=0;c[q>>2]=1;if(!(c[f>>2]|0)){c[e>>2]=-1;s=c[e>>2]|0;i=d;return s|0}if((c[g>>2]|0)>>>0<8){c[e>>2]=-1;s=c[e>>2]|0;i=d;return s|0}if((c[g>>2]|0)>>>0>16384){c[e>>2]=-1;s=c[e>>2]|0;i=d;return s|0}c[k>>2]=c[(c[f>>2]|0)+8>>2];c[o>>2]=c[(c[f>>2]|0)+4>>2];if(!(c[o>>2]|0)){c[e>>2]=-1;s=c[e>>2]|0;i=d;return s|0}if((c[k>>2]|0)==128)c[q>>2]=0;b=Cb[c[135744>>2]&511]((c[g>>2]|0)*20|0)|0;c[(c[f>>2]|0)+4>>2]=b;if(!(c[(c[f>>2]|0)+4>>2]|0)){c[(c[f>>2]|0)+4>>2]=c[o>>2];c[e>>2]=-1;s=c[e>>2]|0;i=d;return s|0}cU(c[(c[f>>2]|0)+4>>2]|0,0,(c[g>>2]|0)*20|0)|0;c[(c[f>>2]|0)+8>>2]=c[g>>2];c[l>>2]=0;while(1){if((c[l>>2]|0)>>>0>=(c[k>>2]|0)>>>0)break;do if(c[(c[o>>2]|0)+((c[l>>2]|0)*20|0)+12>>2]|0){if(c[q>>2]|0)c[j>>2]=c[(c[o>>2]|0)+((c[l>>2]|0)*20|0)+16>>2];else{g=c[(c[o>>2]|0)+((c[l>>2]|0)*20|0)+4>>2]|0;b=c[(c[o>>2]|0)+((c[l>>2]|0)*20|0)+8>>2]|0;a=c[(c[f>>2]|0)+24>>2]|0;if((c[(c[f>>2]|0)+8>>2]|0)==128)t=EP(g,b,a)|0;else t=FP(g,b,a)|0;c[j>>2]=t}c[h>>2]=((c[j>>2]|0)>>>0)%((c[(c[f>>2]|0)+8>>2]|0)>>>0)|0;if(!(c[(c[(c[f>>2]|0)+4>>2]|0)+((c[h>>2]|0)*20|0)+12>>2]|0)){a=(c[(c[f>>2]|0)+4>>2]|0)+((c[h>>2]|0)*20|0)|0;b=(c[o>>2]|0)+((c[l>>2]|0)*20|0)|0;c[a+0>>2]=c[b+0>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[a+16>>2]=c[b+16>>2];c[(c[(c[f>>2]|0)+4>>2]|0)+((c[h>>2]|0)*20|0)>>2]=0;c[(c[(c[f>>2]|0)+4>>2]|0)+((c[h>>2]|0)*20|0)+16>>2]=c[j>>2];break}c[r>>2]=Cb[c[135744>>2]&511](20)|0;if(c[r>>2]|0){c[(c[r>>2]|0)+4>>2]=c[(c[o>>2]|0)+((c[l>>2]|0)*20|0)+4>>2];c[(c[r>>2]|0)+8>>2]=c[(c[o>>2]|0)+((c[l>>2]|0)*20|0)+8>>2];c[(c[r>>2]|0)+16>>2]=c[j>>2];c[c[r>>2]>>2]=c[(c[(c[f>>2]|0)+4>>2]|0)+((c[h>>2]|0)*20|0)>>2];c[(c[r>>2]|0)+12>>2]=1;c[(c[(c[f>>2]|0)+4>>2]|0)+((c[h>>2]|0)*20|0)>>2]=c[r>>2];break}else{c[p>>2]=-1;break}}while(0);c[l>>2]=(c[l>>2]|0)+1}c[l>>2]=0;while(1){if((c[l>>2]|0)>>>0>=(c[k>>2]|0)>>>0)break;c[m>>2]=c[(c[o>>2]|0)+((c[l>>2]|0)*20|0)>>2];while(1){if(!(c[m>>2]|0))break;c[n>>2]=c[c[m>>2]>>2];if(c[q>>2]|0)c[j>>2]=c[(c[m>>2]|0)+16>>2];else{r=c[(c[m>>2]|0)+4>>2]|0;t=c[(c[m>>2]|0)+8>>2]|0;b=c[(c[f>>2]|0)+24>>2]|0;if((c[(c[f>>2]|0)+8>>2]|0)==128)u=EP(r,t,b)|0;else u=FP(r,t,b)|0;c[j>>2]=u}c[h>>2]=((c[j>>2]|0)>>>0)%((c[(c[f>>2]|0)+8>>2]|0)>>>0)|0;b=(c[(c[f>>2]|0)+4>>2]|0)+((c[h>>2]|0)*20|0)|0;if(!(c[(c[(c[f>>2]|0)+4>>2]|0)+((c[h>>2]|0)*20|0)+12>>2]|0)){t=c[m>>2]|0;c[b+0>>2]=c[t+0>>2];c[b+4>>2]=c[t+4>>2];c[b+8>>2]=c[t+8>>2];c[b+12>>2]=c[t+12>>2];c[b+16>>2]=c[t+16>>2];c[(c[(c[f>>2]|0)+4>>2]|0)+((c[h>>2]|0)*20|0)>>2]=0;c[(c[(c[f>>2]|0)+4>>2]|0)+((c[h>>2]|0)*20|0)+12>>2]=1;c[(c[(c[f>>2]|0)+4>>2]|0)+((c[h>>2]|0)*20|0)+16>>2]=c[j>>2];zb[c[135736>>2]&511](c[m>>2]|0)}else{c[c[m>>2]>>2]=c[b>>2];c[(c[m>>2]|0)+16>>2]=c[j>>2];c[(c[(c[f>>2]|0)+4>>2]|0)+((c[h>>2]|0)*20|0)>>2]=c[m>>2]}c[m>>2]=c[n>>2]}c[l>>2]=(c[l>>2]|0)+1}zb[c[135736>>2]&511](c[o>>2]|0);c[e>>2]=c[p>>2];s=c[e>>2]|0;i=d;return s|0}function IP(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+32|0;j=h+20|0;k=h+16|0;l=h+12|0;m=h+8|0;n=h+4|0;o=h;c[j>>2]=a;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;c[o>>2]=c[n>>2];if(!(c[k>>2]|0))c[o>>2]=(c[o>>2]|0)+1740;else c[o>>2]=(c[o>>2]|0)+((d[c[j>>2]>>0]|0)*30|0);if((c[m>>2]|0)>10?(c[o>>2]=(c[o>>2]|0)+(d[(c[l>>2]|0)+((c[m>>2]|0)-((c[k>>2]|0)+2))>>0]|0),c[m>>2]=10,(c[k>>2]|0)>10):0)c[k>>2]=10;switch(c[k>>2]|0){case 9:{p=9;break}case 10:{c[o>>2]=(c[o>>2]|0)+(d[(c[j>>2]|0)+9>>0]|0);p=9;break}case 5:{p=13;break}case 1:{p=17;break}case 2:{p=16;break}case 8:{p=10;break}case 4:{p=14;break}case 3:{p=15;break}case 7:{p=11;break}case 6:{p=12;break}default:{}}if((p|0)==9){c[o>>2]=(c[o>>2]|0)+(d[(c[j>>2]|0)+8>>0]|0);p=10}if((p|0)==10){c[o>>2]=(c[o>>2]|0)+(d[(c[j>>2]|0)+7>>0]|0);p=11}if((p|0)==11){c[o>>2]=(c[o>>2]|0)+(d[(c[j>>2]|0)+6>>0]|0);p=12}if((p|0)==12){c[o>>2]=(c[o>>2]|0)+(d[(c[j>>2]|0)+5>>0]|0);p=13}if((p|0)==13){c[o>>2]=(c[o>>2]|0)+(d[(c[j>>2]|0)+4>>0]|0);p=14}if((p|0)==14){c[o>>2]=(c[o>>2]|0)+(d[(c[j>>2]|0)+3>>0]|0);p=15}if((p|0)==15){c[o>>2]=(c[o>>2]|0)+(d[(c[j>>2]|0)+2>>0]|0);p=16}if((p|0)==16){c[o>>2]=(c[o>>2]|0)+(d[(c[j>>2]|0)+1>>0]|0);p=17}if((p|0)==17)c[o>>2]=(c[o>>2]|0)+(d[c[j>>2]>>0]|0);c[m>>2]=(c[m>>2]|0)-(c[k>>2]|0);if((c[m>>2]|0)>0){c[o>>2]=(c[o>>2]|0)+58;c[m>>2]=(c[m>>2]|0)+-1}switch(c[m>>2]|0){case 10:{c[o>>2]=(c[o>>2]|0)+(d[(c[l>>2]|0)+9>>0]|0);p=22;break}case 3:{p=28;break}case 1:break;case 9:{p=22;break}case 5:{p=26;break}case 8:{p=23;break}case 6:{p=25;break}case 7:{p=24;break}case 2:{p=29;break}case 4:{p=27;break}default:{q=c[o>>2]|0;i=h;return q|0}}if((p|0)==22){c[o>>2]=(c[o>>2]|0)+(d[(c[l>>2]|0)+8>>0]|0);p=23}if((p|0)==23){c[o>>2]=(c[o>>2]|0)+(d[(c[l>>2]|0)+7>>0]|0);p=24}if((p|0)==24){c[o>>2]=(c[o>>2]|0)+(d[(c[l>>2]|0)+6>>0]|0);p=25}if((p|0)==25){c[o>>2]=(c[o>>2]|0)+(d[(c[l>>2]|0)+5>>0]|0);p=26}if((p|0)==26){c[o>>2]=(c[o>>2]|0)+(d[(c[l>>2]|0)+4>>0]|0);p=27}if((p|0)==27){c[o>>2]=(c[o>>2]|0)+(d[(c[l>>2]|0)+3>>0]|0);p=28}if((p|0)==28){c[o>>2]=(c[o>>2]|0)+(d[(c[l>>2]|0)+2>>0]|0);p=29}if((p|0)==29)c[o>>2]=(c[o>>2]|0)+(d[(c[l>>2]|0)+1>>0]|0);c[o>>2]=(c[o>>2]|0)+(d[c[l>>2]>>0]|0);q=c[o>>2]|0;i=h;return q|0}function JP(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+32|0;j=h+24|0;k=h+20|0;l=h+16|0;m=h+12|0;n=h+8|0;o=h+4|0;p=h;c[j>>2]=a;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;c[o>>2]=c[n>>2];c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[k>>2]|0))break;c[o>>2]=(c[o>>2]|0)+(d[(c[j>>2]|0)+(c[p>>2]|0)>>0]|0);c[o>>2]=(c[o>>2]|0)+(c[o>>2]<<10);c[o>>2]=c[o>>2]^(c[o>>2]|0)>>>6;c[p>>2]=(c[p>>2]|0)+1}c[o>>2]=(c[o>>2]|0)+58;c[o>>2]=(c[o>>2]|0)+(c[o>>2]<<10);c[o>>2]=c[o>>2]^(c[o>>2]|0)>>>6;c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[m>>2]|0))break;c[o>>2]=(c[o>>2]|0)+(d[(c[l>>2]|0)+(c[p>>2]|0)>>0]|0);c[o>>2]=(c[o>>2]|0)+(c[o>>2]<<10);c[o>>2]=c[o>>2]^(c[o>>2]|0)>>>6;c[p>>2]=(c[p>>2]|0)+1}c[o>>2]=(c[o>>2]|0)+(c[o>>2]<<3);c[o>>2]=c[o>>2]^(c[o>>2]|0)>>>11;c[o>>2]=(c[o>>2]|0)+(c[o>>2]<<15);i=h;return c[o>>2]|0}function KP(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;h=i;i=i+48|0;j=h+36|0;k=h+32|0;l=h+28|0;m=h+24|0;n=h+20|0;o=h+16|0;p=h+12|0;q=h+8|0;r=h+4|0;s=h;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[r>>2]=0;c[s>>2]=0;g=c[k>>2]|0;if(!(c[l>>2]|0)){c[j>>2]=GP(g,c[n>>2]|0,c[o>>2]|0)|0;t=c[j>>2]|0;i=h;return t|0}c[p>>2]=c[g+16>>2];while(1){u=c[p>>2]|0;if(!(c[p>>2]|0)){v=9;break}if(((c[u+8>>2]|0)-(c[(c[p>>2]|0)+4>>2]|0)|0)>>>0>((c[o>>2]|0)+(c[m>>2]|0)+1|0)>>>0)break;if((c[(c[p>>2]|0)+12>>2]|0)>>>0>(c[r>>2]|0)>>>0)c[r>>2]=c[(c[p>>2]|0)+12>>2];c[s>>2]=(c[s>>2]|0)+(c[(c[p>>2]|0)+12>>2]|0);c[p>>2]=c[c[p>>2]>>2]}do if((v|0)==9?(u|0)==0:0){if((c[(c[k>>2]|0)+28>>2]|0)>>>0>0?(c[s>>2]|0)>>>0>(c[(c[k>>2]|0)+28>>2]|0)>>>0:0){c[j>>2]=0;t=c[j>>2]|0;i=h;return t|0}if(!(c[r>>2]|0))c[r>>2]=1e3;else c[r>>2]=c[r>>2]<<2;if((c[r>>2]|0)>>>0<(c[o>>2]|0)+(c[m>>2]|0)+1<<2>>>0)c[r>>2]=(c[o>>2]|0)+(c[m>>2]|0)+1<<2;c[p>>2]=Cb[c[135744>>2]&511](24+(c[r>>2]|0)|0)|0;if(c[p>>2]|0){c[(c[p>>2]|0)+12>>2]=c[r>>2];c[(c[p>>2]|0)+16>>2]=0;c[(c[p>>2]|0)+4>>2]=(c[p>>2]|0)+20;c[(c[p>>2]|0)+8>>2]=(c[p>>2]|0)+20+(c[r>>2]|0);c[c[p>>2]>>2]=c[(c[k>>2]|0)+16>>2];c[(c[k>>2]|0)+16>>2]=c[p>>2];break}c[j>>2]=0;t=c[j>>2]|0;i=h;return t|0}while(0);c[q>>2]=c[(c[p>>2]|0)+4>>2];eU(c[(c[p>>2]|0)+4>>2]|0,c[l>>2]|0,c[m>>2]|0)|0;l=(c[p>>2]|0)+4|0;c[l>>2]=(c[l>>2]|0)+(c[m>>2]|0);m=(c[p>>2]|0)+4|0;l=c[m>>2]|0;c[m>>2]=l+1;a[l>>0]=58;eU(c[(c[p>>2]|0)+4>>2]|0,c[n>>2]|0,c[o>>2]|0)|0;n=(c[p>>2]|0)+4|0;c[n>>2]=(c[n>>2]|0)+(c[o>>2]|0);o=(c[p>>2]|0)+4|0;n=c[o>>2]|0;c[o>>2]=n+1;a[n>>0]=0;n=(c[p>>2]|0)+16|0;c[n>>2]=(c[n>>2]|0)+1;c[j>>2]=c[q>>2];t=c[j>>2]|0;i=h;return t|0}function LP(a){a=a|0;var b=0;b=i;i=i+16|0;c[b>>2]=a;i=b;return 0}function MP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=c[e>>2];if((c[e>>2]|0)!=0?(c[(c[f>>2]|0)+36>>2]|0)!=0:0){c[d>>2]=c[(c[(c[f>>2]|0)+36>>2]|0)+4>>2];g=c[d>>2]|0;i=b;return g|0}c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}function NP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=c[e>>2];if((c[e>>2]|0)!=0?(c[(c[f>>2]|0)+36>>2]|0)!=0:0){c[d>>2]=c[(c[(c[f>>2]|0)+36>>2]|0)+28>>2];g=c[d>>2]|0;i=b;return g|0}c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}function OP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=c[e>>2];if((c[e>>2]|0)!=0?(c[(c[f>>2]|0)+36>>2]|0)!=0:0){c[d>>2]=c[(c[(c[f>>2]|0)+36>>2]|0)+32>>2];g=c[d>>2]|0;i=b;return g|0}c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}function PP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=c[e>>2];if((c[e>>2]|0)!=0?(c[(c[f>>2]|0)+8>>2]|0)!=0:0){c[d>>2]=(c[(c[(c[f>>2]|0)+8>>2]|0)+40>>2]|0)==1&1;g=c[d>>2]|0;i=b;return g|0}c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}function QP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=c[e>>2];if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+8>>2]|0)!=0:0){c[d>>2]=(c[(c[(c[f>>2]|0)+8>>2]|0)+44>>2]|0)!=0&1;g=c[d>>2]|0;i=b;return g|0}c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}function RP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=c[e>>2];if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+8>>2]|0)!=0:0){c[d>>2]=(c[(c[(c[f>>2]|0)+8>>2]|0)+48>>2]|0)!=0&1;g=c[d>>2]|0;i=b;return g|0}c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}function SP(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=c[g>>2];if(!(c[g>>2]|0)){i=f;return}if(!(c[(c[l>>2]|0)+8>>2]|0)){i=f;return}c[m>>2]=Nh(c[(c[l>>2]|0)+8>>2]|0)|0;do if(c[m>>2]|0)if(c[(c[l>>2]|0)+32>>2]|0){i=f;return}else{Qh(c[m>>2]|0);Ph(c[m>>2]|0);c[(c[(c[l>>2]|0)+8>>2]|0)+44>>2]=0;break}while(0);m=Oh(c[(c[l>>2]|0)+8>>2]|0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0)|0;c[(c[(c[l>>2]|0)+8>>2]|0)+44>>2]=m;if(c[(c[(c[l>>2]|0)+8>>2]|0)+44>>2]|0){i=f;return}sQ(c[l>>2]|0,197088);i=f;return}function TP(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+64|0;g=f+48|0;h=f+44|0;j=f+40|0;k=f+36|0;l=f+32|0;m=f+28|0;n=f+24|0;o=f+20|0;p=f+16|0;q=f+12|0;r=f+8|0;s=f+4|0;t=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=c[g>>2];if(!(c[g>>2]|0)){i=f;return}if(!((c[j>>2]|0)!=0|(c[k>>2]|0)!=0)){i=f;return}if((c[(c[l>>2]|0)+104>>2]|0)==0?(c[(c[l>>2]|0)+276>>2]|0)==0:0){i=f;return}if(!(c[(c[l>>2]|0)+12>>2]|0)){i=f;return}if(!(c[(c[l>>2]|0)+8>>2]|0)){i=f;return}c[q>>2]=0;if((c[c[l>>2]>>2]|0)!=0?(c[(c[c[l>>2]>>2]|0)+16>>2]|0)!=0:0)c[q>>2]=vb[c[(c[c[l>>2]>>2]|0)+16>>2]&511](c[(c[l>>2]|0)+4>>2]|0,c[j>>2]|0,c[k>>2]|0)|0;if(!(c[q>>2]|0)){i=f;return}Mh(c[(c[l>>2]|0)+8>>2]|0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0)|0;c[m>>2]=c[(c[l>>2]|0)+36>>2];c[n>>2]=c[(c[l>>2]|0)+40>>2];c[o>>2]=c[(c[l>>2]|0)+44>>2];c[p>>2]=c[(c[l>>2]|0)+48>>2];c[s>>2]=c[(c[l>>2]|0)+256>>2];c[t>>2]=c[(c[l>>2]|0)+24>>2];c[(c[l>>2]|0)+24>>2]=0;h=Cb[c[135744>>2]&511](20)|0;c[(c[l>>2]|0)+48>>2]=h;h=c[l>>2]|0;if(!(c[(c[l>>2]|0)+48>>2]|0)){sQ(h,197112);c[(c[l>>2]|0)+36>>2]=c[m>>2];c[(c[l>>2]|0)+40>>2]=c[n>>2];c[(c[l>>2]|0)+44>>2]=c[o>>2];c[(c[l>>2]|0)+48>>2]=c[p>>2];c[(c[l>>2]|0)+256>>2]=c[s>>2];c[(c[l>>2]|0)+24>>2]=c[t>>2];i=f;return}c[h+40>>2]=0;c[(c[l>>2]|0)+44>>2]=5;c[(c[l>>2]|0)+36>>2]=0;Xe(c[l>>2]|0,c[q>>2]|0)|0;if((c[(c[(c[l>>2]|0)+36>>2]|0)+24>>2]|0)>=4){c[r>>2]=sd(c[(c[(c[l>>2]|0)+36>>2]|0)+16>>2]|0,4)|0;re(c[l>>2]|0,c[r>>2]|0)|0}if(!(c[(c[q>>2]|0)+4>>2]|0)){r=Jl(c[k>>2]|0)|0;c[(c[q>>2]|0)+4>>2]=r}c[(c[q>>2]|0)+28>>2]=1;c[(c[q>>2]|0)+32>>2]=1;c[(c[q>>2]|0)+12>>2]=c[(c[(c[l>>2]|0)+36>>2]|0)+16>>2];c[(c[q>>2]|0)+16>>2]=c[(c[(c[l>>2]|0)+36>>2]|0)+16>>2];c[(c[q>>2]|0)+40>>2]=0;Cf(c[l>>2]|0,c[j>>2]|0,c[k>>2]|0);while(1){u=c[l>>2]|0;if((c[(c[l>>2]|0)+40>>2]|0)<=1)break;Ve(u)|0}te(c[u+36>>2]|0);zb[c[135736>>2]&511](c[(c[l>>2]|0)+48>>2]|0);c[(c[l>>2]|0)+36>>2]=c[m>>2];c[(c[l>>2]|0)+40>>2]=c[n>>2];c[(c[l>>2]|0)+44>>2]=c[o>>2];c[(c[l>>2]|0)+48>>2]=c[p>>2];c[(c[l>>2]|0)+256>>2]=c[s>>2];do if(c[(c[l>>2]|0)+24>>2]|0){if((c[(c[l>>2]|0)+296>>2]|0)!=0?(CP(c[(c[l>>2]|0)+296>>2]|0,c[(c[l>>2]|0)+24>>2]|0)|0)!=0:0)break;zb[c[135736>>2]&511](c[(c[l>>2]|0)+24>>2]|0)}while(0);c[(c[l>>2]|0)+24>>2]=c[t>>2];i=f;return}function UP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;n=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=c[g>>2];c[n>>2]=0;if(!(c[g>>2]|0)){c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}if(c[(c[k>>2]|0)+36>>2]|0)c[n>>2]=c[(c[(c[k>>2]|0)+36>>2]|0)+4>>2];if(!(c[n>>2]|0))c[n>>2]=c[(c[k>>2]|0)+180>>2];c[m>>2]=Hl(c[j>>2]|0,c[n>>2]|0)|0;c[l>>2]=Vk(c[m>>2]|0,c[h>>2]|0,c[k>>2]|0)|0;if(c[m>>2]|0)zb[c[135736>>2]&511](c[m>>2]|0);c[f>>2]=c[l>>2];o=c[f>>2]|0;i=e;return o|0}function VP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d+28|0;f=d+24|0;g=d+20|0;h=d+16|0;j=d+12|0;k=d+8|0;l=d+4|0;m=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=c[f>>2];c[j>>2]=0;if(!(c[f>>2]|0)){c[e>>2]=0;n=c[e>>2]|0;i=d;return n|0}if((c[(c[h>>2]|0)+216>>2]|0)==0?(c[j>>2]=Yc(c[g>>2]|0)|0,(c[j>>2]|0)!=0):0){c[e>>2]=c[j>>2];n=c[e>>2]|0;i=d;return n|0}do if((c[(c[h>>2]|0)+8>>2]|0)!=0?(c[(c[(c[h>>2]|0)+8>>2]|0)+40>>2]|0)==1:0){f=c[(c[h>>2]|0)+8>>2]|0;if((c[(c[h>>2]|0)+216>>2]|0)==2){c[f+40>>2]=0;c[j>>2]=ad(c[(c[h>>2]|0)+8>>2]|0,c[g>>2]|0)|0;c[(c[(c[h>>2]|0)+8>>2]|0)+40>>2]=1;break}c[j>>2]=ad(f,c[g>>2]|0)|0;if(!(c[j>>2]|0)){c[(c[(c[h>>2]|0)+8>>2]|0)+40>>2]=0;c[j>>2]=ad(c[(c[h>>2]|0)+8>>2]|0,c[g>>2]|0)|0;if(c[j>>2]|0)tQ(c[h>>2]|0,103,197136,c[g>>2]|0,0);c[(c[(c[h>>2]|0)+8>>2]|0)+40>>2]=1}}else o=14;while(0);if((o|0)==14)c[j>>2]=ad(c[(c[h>>2]|0)+8>>2]|0,c[g>>2]|0)|0;do if(c[j>>2]|0){if((c[(c[h>>2]|0)+104>>2]|0)==0?(c[(c[h>>2]|0)+16>>2]|0)==0:0)break;if((c[(c[j>>2]|0)+12>>2]|0)==0?(c[(c[j>>2]|0)+48>>2]|0)==2:0){c[m>>2]=c[(c[h>>2]|0)+440>>2];c[k>>2]=Xf(c[h>>2]|0,c[(c[j>>2]|0)+64>>2]|0,c[(c[j>>2]|0)+52>>2]|0,l)|0;if(c[k>>2]|0){tQ(c[h>>2]|0,104,197208,c[g>>2]|0,0);c[(c[h>>2]|0)+104>>2]=0;c[e>>2]=0;n=c[e>>2]|0;i=d;return n|0}yi(c[j>>2]|0,c[l>>2]|0)|0;c[(c[j>>2]|0)+68>>2]=1;if(((c[(c[j>>2]|0)+72>>2]|0)==0?(c[(c[j>>2]|0)+72>>2]=(c[(c[h>>2]|0)+440>>2]|0)-(c[m>>2]|0)+1<<1,(c[(c[j>>2]|0)+40>>2]|0)!=0):0)?(vy(c[(c[j>>2]|0)+40>>2]|0,60)|0)!=0:0){o=(c[j>>2]|0)+72|0;c[o>>2]=c[o>>2]|1}}}while(0);c[e>>2]=c[j>>2];n=c[e>>2]|0;i=d;return n|0}function WP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=c[f>>2];if(!(c[f>>2]|0)){c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}else{c[j>>2]=$c(c[(c[h>>2]|0)+8>>2]|0,c[g>>2]|0)|0;c[e>>2]=c[j>>2];k=c[e>>2]|0;i=d;return k|0}return 0}function XP(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;h=i;i=i+64|0;j=h;k=h+48|0;l=h+44|0;m=h+40|0;n=h+36|0;o=h+32|0;p=h+28|0;q=h+24|0;r=h+20|0;s=h+16|0;t=h+12|0;u=h+8|0;v=h+4|0;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[r>>2]=c[k>>2];if(!(c[k>>2]|0)){i=h;return}k=c[r>>2]|0;if((c[(c[r>>2]|0)+216>>2]|0)==1){c[q>>2]=_c(c[k+8>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0)|0;if((c[q>>2]|0)==0?(c[(c[r>>2]|0)+268>>2]|0)!=0:0)uQ(c[r>>2]|0,107,197240,c[l>>2]|0);if(!(c[q>>2]|0)){i=h;return}if(!((c[o>>2]|0)!=0?(c[(c[q>>2]|0)+64>>2]|0)==0:0)){i=h;return}c[t>>2]=0;if(c[(c[r>>2]|0)+36>>2]|0)c[t>>2]=c[(c[(c[r>>2]|0)+36>>2]|0)+4>>2];if(!(c[t>>2]|0))c[t>>2]=c[(c[r>>2]|0)+180>>2];c[s>>2]=Hl(c[o>>2]|0,c[t>>2]|0)|0;c[(c[q>>2]|0)+64>>2]=c[s>>2];i=h;return}s=c[r>>2]|0;if((c[k+216>>2]|0)!=2){tQ(s,104,197352,c[l>>2]|0,0);i=h;return}c[q>>2]=Zc(c[s+8>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0)|0;if((((c[q>>2]|0)==0?(c[(c[r>>2]|0)+268>>2]|0)!=0:0)?(c[c[r>>2]>>2]|0)!=0:0)?(c[(c[c[r>>2]>>2]|0)+84>>2]|0)!=0:0){p=c[(c[c[r>>2]>>2]|0)+84>>2]|0;n=c[(c[r>>2]|0)+4>>2]|0;c[j>>2]=c[l>>2];Db[p&511](n,197296,j)}if(!(c[q>>2]|0)){i=h;return}if(!((c[o>>2]|0)!=0?(c[(c[q>>2]|0)+64>>2]|0)==0:0)){i=h;return}c[v>>2]=0;if(c[(c[r>>2]|0)+36>>2]|0)c[v>>2]=c[(c[(c[r>>2]|0)+36>>2]|0)+4>>2];if(!(c[v>>2]|0))c[v>>2]=c[(c[r>>2]|0)+180>>2];c[u>>2]=Hl(c[o>>2]|0,c[v>>2]|0)|0;
c[(c[q>>2]|0)+64>>2]=c[u>>2];i=h;return}function YP(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=i;i=i+48|0;k=j+44|0;l=j+40|0;m=j+36|0;n=j+32|0;o=j+28|0;p=j+24|0;q=j+20|0;r=j+16|0;s=j+12|0;t=j+8|0;u=j+4|0;v=j;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=h;c[r>>2]=c[k>>2];c[t>>2]=0;c[u>>2]=0;if(!(c[r>>2]|0)){i=j;return}if(!(c[(c[r>>2]|0)+8>>2]|0)){i=j;return}k=(qy(c[m>>2]|0,197408)|0)!=0;if(k&(c[n>>2]|0)!=2){c[v>>2]=c[(c[r>>2]|0)+100>>2];vQ(c[r>>2]|0,540,197416,0,0);c[(c[r>>2]|0)+100>>2]=c[v>>2]}c[t>>2]=bf(c[r>>2]|0,c[m>>2]|0,u)|0;c[(c[r>>2]|0)+144>>2]=1;m=c[r>>2]|0;do if((c[(c[r>>2]|0)+216>>2]|0)==1)c[s>>2]=tm(m+108|0,c[(c[(c[r>>2]|0)+8>>2]|0)+44>>2]|0,c[l>>2]|0,c[t>>2]|0,c[u>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[q>>2]|0)|0;else{v=c[r>>2]|0;if((c[m+216>>2]|0)==2){c[s>>2]=tm(v+108|0,c[(c[(c[r>>2]|0)+8>>2]|0)+48>>2]|0,c[l>>2]|0,c[t>>2]|0,c[u>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[q>>2]|0)|0;break}tQ(v,1,197456,c[t>>2]|0,0);rm(c[q>>2]|0);i=j;return}while(0);if(!(c[(c[r>>2]|0)+144>>2]|0))c[(c[r>>2]|0)+100>>2]=0;if((((c[s>>2]|0)!=0?(c[(c[r>>2]|0)+104>>2]|0)!=0:0)?(c[(c[r>>2]|0)+12>>2]|0)!=0:0)?(c[(c[(c[r>>2]|0)+8>>2]|0)+44>>2]|0)!=0:0){q=Um((c[r>>2]|0)+108|0,c[(c[r>>2]|0)+8>>2]|0,c[s>>2]|0)|0;s=(c[r>>2]|0)+100|0;c[s>>2]=c[s>>2]&q}if(c[u>>2]|0)zb[c[135736>>2]&511](c[u>>2]|0);if(!(c[t>>2]|0)){i=j;return}zb[c[135736>>2]&511](c[t>>2]|0);i=j;return}function ZP(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=c[g>>2];c[m>>2]=0;if(!(c[l>>2]|0)){i=f;return}if(!(c[(c[l>>2]|0)+8>>2]|0)){i=f;return}g=c[l>>2]|0;do if((c[(c[l>>2]|0)+216>>2]|0)==1)c[m>>2]=mm(g+108|0,c[(c[(c[l>>2]|0)+8>>2]|0)+44>>2]|0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0)|0;else{e=c[l>>2]|0;if((c[g+216>>2]|0)==2){c[m>>2]=mm(e+108|0,c[(c[(c[l>>2]|0)+8>>2]|0)+48>>2]|0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0)|0;break}tQ(e,1,197520,c[h>>2]|0,0);i=f;return}while(0);if(!(c[m>>2]|0))c[(c[l>>2]|0)+100>>2]=0;if(!(c[(c[l>>2]|0)+104>>2]|0)){i=f;return}if(!(c[(c[l>>2]|0)+12>>2]|0)){i=f;return}if(!(c[(c[l>>2]|0)+8>>2]|0)){i=f;return}if(!(c[(c[(c[l>>2]|0)+8>>2]|0)+44>>2]|0)){i=f;return}h=Vm((c[l>>2]|0)+108|0,c[(c[l>>2]|0)+8>>2]|0,c[m>>2]|0)|0;m=(c[l>>2]|0)+100|0;c[m>>2]=c[m>>2]&h;i=f;return}function _P(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=c[g>>2];c[m>>2]=0;if(!(c[l>>2]|0)){i=f;return}if(!(c[(c[l>>2]|0)+8>>2]|0)){i=f;return}g=c[l>>2]|0;if((c[j>>2]|0)==0&(c[k>>2]|0)==0){tQ(g,105,197576,c[h>>2]|0,0);i=f;return}e=c[l>>2]|0;do if((c[g+216>>2]|0)==1)c[m>>2]=xm(e+108|0,c[(c[(c[l>>2]|0)+8>>2]|0)+44>>2]|0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0)|0;else{d=c[l>>2]|0;if((c[e+216>>2]|0)==2){c[m>>2]=xm(d+108|0,c[(c[(c[l>>2]|0)+8>>2]|0)+48>>2]|0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0)|0;break}tQ(d,105,197640,c[h>>2]|0,0);i=f;return}while(0);if(!(c[m>>2]|0))c[(c[l>>2]|0)+100>>2]=0;if(!(c[(c[l>>2]|0)+104>>2]|0)){i=f;return}if(!(c[(c[l>>2]|0)+12>>2]|0)){i=f;return}if(!(c[(c[(c[l>>2]|0)+8>>2]|0)+44>>2]|0)){i=f;return}h=Rm((c[l>>2]|0)+108|0,c[(c[l>>2]|0)+8>>2]|0,c[m>>2]|0)|0;m=(c[l>>2]|0)+100|0;c[m>>2]=c[m>>2]&h;i=f;return}function $P(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+48|0;h=g;j=g+44|0;k=g+40|0;l=g+36|0;m=g+32|0;n=g+28|0;o=g+24|0;p=g+20|0;q=g+16|0;r=g+12|0;s=g+8|0;t=g+4|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[p>>2]=c[j>>2];if(!(c[j>>2]|0)){i=g;return}j=c[p>>2]|0;if((c[(c[p>>2]|0)+216>>2]|0)==1){c[o>>2]=_c(c[j+8>>2]|0,c[k>>2]|0,3,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0)|0;if((((c[o>>2]|0)==0?(c[(c[p>>2]|0)+268>>2]|0)!=0:0)?(c[c[p>>2]>>2]|0)!=0:0)?(c[(c[c[p>>2]>>2]|0)+84>>2]|0)!=0:0){f=c[(c[c[p>>2]>>2]|0)+84>>2]|0;e=c[(c[p>>2]|0)+4>>2]|0;c[h>>2]=c[k>>2];Db[f&511](e,197240,h)}if(!(c[o>>2]|0)){i=g;return}if(!((c[m>>2]|0)!=0?(c[(c[o>>2]|0)+64>>2]|0)==0:0)){i=g;return}c[r>>2]=0;if(c[(c[p>>2]|0)+36>>2]|0)c[r>>2]=c[(c[(c[p>>2]|0)+36>>2]|0)+4>>2];if(!(c[r>>2]|0))c[r>>2]=c[(c[p>>2]|0)+180>>2];c[q>>2]=Hl(c[m>>2]|0,c[r>>2]|0)|0;c[(c[o>>2]|0)+64>>2]=c[q>>2];i=g;return}q=c[p>>2]|0;if((c[j+216>>2]|0)!=2){tQ(q,1,197696,c[k>>2]|0,0);i=g;return}c[o>>2]=Zc(c[q+8>>2]|0,c[k>>2]|0,3,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0)|0;if((((c[o>>2]|0)==0?(c[(c[p>>2]|0)+268>>2]|0)!=0:0)?(c[c[p>>2]>>2]|0)!=0:0)?(c[(c[c[p>>2]>>2]|0)+84>>2]|0)!=0:0){n=c[(c[c[p>>2]>>2]|0)+84>>2]|0;l=c[(c[p>>2]|0)+4>>2]|0;c[h>>2]=c[k>>2];Db[n&511](l,197296,h)}if(!(c[o>>2]|0)){i=g;return}if(!((c[m>>2]|0)!=0?(c[(c[o>>2]|0)+64>>2]|0)==0:0)){i=g;return}c[t>>2]=0;if(c[(c[p>>2]|0)+36>>2]|0)c[t>>2]=c[(c[(c[p>>2]|0)+36>>2]|0)+4>>2];if(!(c[t>>2]|0))c[t>>2]=c[(c[p>>2]|0)+180>>2];c[s>>2]=Hl(c[m>>2]|0,c[t>>2]|0)|0;c[(c[o>>2]|0)+64>>2]=c[s>>2];i=g;return}function aQ(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+16|0;c[d+4>>2]=a;c[d>>2]=b;i=d;return}function bQ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[e>>2]=c[d>>2];if(!(c[d>>2]|0)){i=b;return}d=c[e>>2]|0;do if(!(c[(c[e>>2]|0)+32>>2]|0)){a=Sh(c[d+20>>2]|0)|0;c[(c[e>>2]|0)+8>>2]=a;c[f>>2]=a;if(!(c[f>>2]|0)){sQ(c[e>>2]|0,197760);i=b;return}c[(c[f>>2]|0)+92>>2]=0;if(c[(c[e>>2]|0)+360>>2]&131072){a=(c[f>>2]|0)+92|0;c[a>>2]=c[a>>2]|4}c[(c[f>>2]|0)+88>>2]=c[(c[e>>2]|0)+360>>2];if(c[(c[e>>2]|0)+24>>2]|0){a=my(c[(c[e>>2]|0)+24>>2]|0)|0;c[(c[f>>2]|0)+60>>2]=a}else c[(c[f>>2]|0)+60>>2]=0;c[(c[f>>2]|0)+40>>2]=c[(c[e>>2]|0)+28>>2];if((c[f>>2]|0)!=0?(c[(c[e>>2]|0)+364>>2]|0)!=0:0){c[(c[f>>2]|0)+80>>2]=c[(c[e>>2]|0)+296>>2];yP(c[(c[f>>2]|0)+80>>2]|0)|0}}else{if(!(c[d+8>>2]|0)){a=go(0,0)|0;c[(c[e>>2]|0)+8>>2]=a}a=c[e>>2]|0;if(c[(c[e>>2]|0)+8>>2]|0){c[(c[a+8>>2]|0)+92>>2]=128;c[(c[(c[e>>2]|0)+8>>2]|0)+88>>2]=c[(c[e>>2]|0)+360>>2];break}sQ(a,197760);i=b;return}while(0);if(!(c[(c[e>>2]|0)+8>>2]|0)){i=b;return}if(c[(c[(c[e>>2]|0)+8>>2]|0)+72>>2]|0){i=b;return}if(!(c[(c[e>>2]|0)+36>>2]|0)){i=b;return}if(!(c[(c[(c[e>>2]|0)+36>>2]|0)+4>>2]|0)){i=b;return}d=Kl(c[(c[(c[e>>2]|0)+36>>2]|0)+4>>2]|0)|0;c[(c[(c[e>>2]|0)+8>>2]|0)+72>>2]=d;if(c[(c[(c[e>>2]|0)+8>>2]|0)+72>>2]|0){i=b;return}sQ(c[e>>2]|0,197760);i=b;return}function cQ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[d>>2];if(!(c[d>>2]|0)){i=b;return}if((((c[(c[e>>2]|0)+104>>2]|0)!=0?(c[(c[e>>2]|0)+12>>2]|0)!=0:0)?(c[(c[e>>2]|0)+8>>2]|0)!=0:0)?(c[(c[(c[e>>2]|0)+8>>2]|0)+44>>2]|0)!=0:0){d=cn((c[e>>2]|0)+108|0,c[(c[e>>2]|0)+8>>2]|0)|0;a=(c[e>>2]|0)+100|0;c[a>>2]=c[a>>2]&d}if(((c[(c[e>>2]|0)+24>>2]|0)!=0?(c[(c[e>>2]|0)+8>>2]|0)!=0:0)?(c[(c[(c[e>>2]|0)+8>>2]|0)+60>>2]|0)==0:0){c[(c[(c[e>>2]|0)+8>>2]|0)+60>>2]=c[(c[e>>2]|0)+24>>2];c[(c[e>>2]|0)+24>>2]=0}if((((((c[(c[e>>2]|0)+48>>2]|0)!=0?(c[(c[e>>2]|0)+40>>2]|0)>0:0)?(c[c[(c[e>>2]|0)+48>>2]>>2]|0)!=0:0)?(c[(c[c[(c[e>>2]|0)+48>>2]>>2]|0)+44>>2]|0)!=0:0)?(c[(c[e>>2]|0)+8>>2]|0)!=0:0)?(c[(c[(c[e>>2]|0)+8>>2]|0)+60>>2]|0)==0:0){d=my(c[(c[c[(c[e>>2]|0)+48>>2]>>2]|0)+44>>2]|0)|0;c[(c[(c[e>>2]|0)+8>>2]|0)+60>>2]=d}if(!(c[(c[e>>2]|0)+256>>2]|0)){i=b;return}if(!(c[(c[e>>2]|0)+8>>2]|0)){i=b;return}if(c[(c[(c[e>>2]|0)+8>>2]|0)+76>>2]|0){i=b;return}c[(c[(c[e>>2]|0)+8>>2]|0)+76>>2]=c[(c[e>>2]|0)+256>>2];i=b;return}function dQ(a,e,f){a=a|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+64|0;h=g+48|0;j=g+44|0;k=g+40|0;l=g+36|0;m=g+32|0;n=g+28|0;o=g+24|0;p=g+20|0;q=g+16|0;r=g+12|0;s=g+8|0;t=g+4|0;u=g;c[h>>2]=a;c[j>>2]=e;c[k>>2]=f;c[l>>2]=c[h>>2];if((c[h>>2]|0)==0|(c[j>>2]|0)==0){i=g;return}if(!(c[(c[l>>2]|0)+8>>2]|0)){i=g;return}c[n>>2]=c[(c[l>>2]|0)+52>>2];do if((c[(c[l>>2]|0)+104>>2]|0)!=0?(c[(c[(c[l>>2]|0)+8>>2]|0)+48>>2]|0)==0:0){if(c[(c[(c[l>>2]|0)+8>>2]|0)+44>>2]|0){if(c[(c[(c[(c[l>>2]|0)+8>>2]|0)+44>>2]|0)+36>>2]|0)break;if(c[(c[(c[(c[l>>2]|0)+8>>2]|0)+44>>2]|0)+40>>2]|0)break;if(c[(c[(c[(c[l>>2]|0)+8>>2]|0)+44>>2]|0)+44>>2]|0)break;if(c[(c[(c[(c[l>>2]|0)+8>>2]|0)+44>>2]|0)+48>>2]|0)break}vQ(c[l>>2]|0,94,197784,0,0);c[(c[l>>2]|0)+104>>2]=0}while(0);c[p>>2]=bf(c[l>>2]|0,c[j>>2]|0,q)|0;c[m>>2]=ki(c[(c[l>>2]|0)+8>>2]|0,0,c[p>>2]|0,0)|0;if(!(c[m>>2]|0)){if(c[q>>2]|0)zb[c[135736>>2]&511](c[q>>2]|0);sQ(c[l>>2]|0,197824);i=g;return}if(c[(c[(c[l>>2]|0)+8>>2]|0)+12>>2]|0){if(!(c[n>>2]|0))c[n>>2]=c[(c[(c[l>>2]|0)+8>>2]|0)+12>>2]}else zi(c[(c[l>>2]|0)+8>>2]|0,c[m>>2]|0)|0;c[(c[l>>2]|0)+264>>2]=-1;do if((c[(c[l>>2]|0)+280>>2]|0)!=0?(c[(c[l>>2]|0)+36>>2]|0)!=0:0)if((c[(c[(c[l>>2]|0)+36>>2]|0)+28>>2]|0)<65535){b[(c[m>>2]|0)+56>>1]=c[(c[(c[l>>2]|0)+36>>2]|0)+28>>2];break}else{b[(c[m>>2]|0)+56>>1]=-1;break}while(0);Qe(c[l>>2]|0,c[m>>2]|0)|0;do if(c[n>>2]|0){j=c[n>>2]|0;h=c[m>>2]|0;if((c[(c[n>>2]|0)+4>>2]|0)==1){zi(j,h)|0;break}else{xi(j,h)|0;break}}while(0);do if(!(c[(c[l>>2]|0)+32>>2]|0)){if((c[(c[(c[l>>2]|0)+8>>2]|0)+44>>2]|0)==0?(c[(c[(c[l>>2]|0)+8>>2]|0)+48>>2]|0)==0:0)break;wQ(c[l>>2]|0,c[p>>2]|0,c[q>>2]|0,c[k>>2]|0)}while(0);if((c[k>>2]|0)!=0?(c[t>>2]=0,p=c[t>>2]|0,c[t>>2]=p+1,c[r>>2]=c[(c[k>>2]|0)+(p<<2)>>2],p=c[t>>2]|0,c[t>>2]=p+1,c[s>>2]=c[(c[k>>2]|0)+(p<<2)>>2],((c[r>>2]|0)!=0?(c[(c[l>>2]|0)+32>>2]|0)==0:0)&(c[s>>2]|0)!=0):0)do{if(((((d[c[r>>2]>>0]|0|0)==120?(d[(c[r>>2]|0)+1>>0]|0|0)==109:0)?(d[(c[r>>2]|0)+2>>0]|0|0)==108:0)?(d[(c[r>>2]|0)+3>>0]|0|0)==110:0)?(d[(c[r>>2]|0)+4>>0]|0|0)==115:0)xQ(c[l>>2]|0,c[r>>2]|0,c[s>>2]|0,c[q>>2]|0);p=c[t>>2]|0;c[t>>2]=p+1;c[r>>2]=c[(c[k>>2]|0)+(p<<2)>>2];p=c[t>>2]|0;c[t>>2]=p+1;c[s>>2]=c[(c[k>>2]|0)+(p<<2)>>2]}while((c[r>>2]|0)!=0&(c[s>>2]|0)!=0);c[o>>2]=cj(c[(c[l>>2]|0)+8>>2]|0,c[m>>2]|0,c[q>>2]|0)|0;if((c[o>>2]|0)==0&(c[n>>2]|0)!=0)c[o>>2]=cj(c[(c[l>>2]|0)+8>>2]|0,c[n>>2]|0,c[q>>2]|0)|0;if((c[q>>2]|0)!=0&(c[o>>2]|0)==0){c[o>>2]=Ih(c[m>>2]|0,0,c[q>>2]|0)|0;yQ(c[l>>2]|0,201,197848,c[q>>2]|0,0)}do if((c[o>>2]|0)!=0?(c[(c[o>>2]|0)+8>>2]|0)!=0:0){if((d[c[(c[o>>2]|0)+8>>2]>>0]|0|0)==0?(c[(c[o>>2]|0)+12>>2]|0)==0:0)break;Kh(c[m>>2]|0,c[o>>2]|0)}while(0);a:do if(c[k>>2]|0){c[t>>2]=0;o=c[t>>2]|0;c[t>>2]=o+1;c[r>>2]=c[(c[k>>2]|0)+(o<<2)>>2];o=c[t>>2]|0;c[t>>2]=o+1;c[s>>2]=c[(c[k>>2]|0)+(o<<2)>>2];if(c[(c[l>>2]|0)+32>>2]|0)while(1){if(!(c[r>>2]|0))break a;xQ(c[l>>2]|0,c[r>>2]|0,c[s>>2]|0,0);o=c[t>>2]|0;c[t>>2]=o+1;c[r>>2]=c[(c[k>>2]|0)+(o<<2)>>2];o=c[t>>2]|0;c[t>>2]=o+1;c[s>>2]=c[(c[k>>2]|0)+(o<<2)>>2]}while(1){if(!((c[r>>2]|0)!=0&(c[s>>2]|0)!=0))break a;do if((d[c[r>>2]>>0]|0|0)==120?(d[(c[r>>2]|0)+1>>0]|0|0)==109:0){if((d[(c[r>>2]|0)+2>>0]|0|0)!=108){v=60;break}if((d[(c[r>>2]|0)+3>>0]|0|0)!=110){v=60;break}if((d[(c[r>>2]|0)+4>>0]|0|0)!=115)v=60}else v=60;while(0);if((v|0)==60){v=0;xQ(c[l>>2]|0,c[r>>2]|0,c[s>>2]|0,0)}o=c[t>>2]|0;c[t>>2]=o+1;c[r>>2]=c[(c[k>>2]|0)+(o<<2)>>2];o=c[t>>2]|0;c[t>>2]=o+1;c[s>>2]=c[(c[k>>2]|0)+(o<<2)>>2]}}while(0);if((c[(c[l>>2]|0)+104>>2]|0)!=0?(c[(c[l>>2]|0)+136>>2]|0)==-1412623820:0){c[u>>2]=en((c[l>>2]|0)+108|0,c[(c[l>>2]|0)+8>>2]|0)|0;if((c[u>>2]|0)<=0)c[(c[l>>2]|0)+100>>2]=0;if((c[u>>2]|0)<0)c[(c[l>>2]|0)+12>>2]=0;u=an((c[l>>2]|0)+108|0,c[(c[l>>2]|0)+8>>2]|0)|0;k=(c[l>>2]|0)+100|0;c[k>>2]=c[k>>2]&u;c[(c[l>>2]|0)+136>>2]=-1412623819}if(!(c[q>>2]|0)){i=g;return}zb[c[135736>>2]&511](c[q>>2]|0);i=g;return}function eQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+12|0;f=d+4|0;g=d;c[e>>2]=a;c[d+8>>2]=b;c[f>>2]=c[e>>2];if(!(c[e>>2]|0)){i=d;return}c[g>>2]=c[(c[f>>2]|0)+52>>2];if((c[g>>2]|0)!=0?(c[(c[f>>2]|0)+68>>2]|0)!=0:0){c[(c[(c[f>>2]|0)+448>>2]|0)+12>>2]=(c[(c[(c[f>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[f>>2]|0)+36>>2]|0)+12>>2]|0);c[(c[(c[f>>2]|0)+448>>2]|0)+16>>2]=c[(c[(c[f>>2]|0)+36>>2]|0)+28>>2];c[c[(c[f>>2]|0)+448>>2]>>2]=c[g>>2];De(c[f>>2]|0,c[(c[f>>2]|0)+448>>2]|0)}c[(c[f>>2]|0)+264>>2]=-1;if((((c[(c[f>>2]|0)+104>>2]|0)!=0?(c[(c[f>>2]|0)+12>>2]|0)!=0:0)?(c[(c[f>>2]|0)+8>>2]|0)!=0:0)?(c[(c[(c[f>>2]|0)+8>>2]|0)+44>>2]|0)!=0:0){e=$m((c[f>>2]|0)+108|0,c[(c[f>>2]|0)+8>>2]|0,c[g>>2]|0)|0;g=(c[f>>2]|0)+100|0;c[g>>2]=c[g>>2]&e}Re(c[f>>2]|0)|0;i=d;return}function fQ(a,d,e,f,g,h,j,k,l){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+96|0;n=m+84|0;o=m+80|0;p=m+76|0;q=m+72|0;r=m+68|0;s=m+64|0;t=m+60|0;u=m+56|0;v=m+52|0;w=m+48|0;x=m+44|0;y=m+40|0;z=m+36|0;A=m+32|0;B=m+28|0;C=m+24|0;D=m+20|0;E=m+16|0;F=m+12|0;G=m+8|0;H=m+4|0;I=m;c[n>>2]=a;c[o>>2]=d;c[p>>2]=e;c[q>>2]=f;c[r>>2]=g;c[s>>2]=h;c[t>>2]=j;c[u>>2]=k;c[v>>2]=l;c[w>>2]=c[n>>2];c[z>>2]=0;c[D>>2]=0;if(!(c[n>>2]|0)){i=m;return}c[y>>2]=c[(c[w>>2]|0)+52>>2];do if((c[(c[w>>2]|0)+104>>2]|0)!=0?(c[(c[(c[w>>2]|0)+8>>2]|0)+48>>2]|0)==0:0){if(c[(c[(c[w>>2]|0)+8>>2]|0)+44>>2]|0){if(c[(c[(c[(c[w>>2]|0)+8>>2]|0)+44>>2]|0)+36>>2]|0)break;if(c[(c[(c[(c[w>>2]|0)+8>>2]|0)+44>>2]|0)+40>>2]|0)break;if(c[(c[(c[(c[w>>2]|0)+8>>2]|0)+44>>2]|0)+44>>2]|0)break;if(c[(c[(c[(c[w>>2]|0)+8>>2]|0)+44>>2]|0)+48>>2]|0)break}vQ(c[w>>2]|0,522,197784,0,0);c[(c[w>>2]|0)+104>>2]=0}while(0);do if((c[p>>2]|0)!=0&(c[q>>2]|0)==0){if(!(c[(c[w>>2]|0)+364>>2]|0)){c[D>>2]=Bh(c[o>>2]|0,c[p>>2]|0,0,0)|0;break}c[G>>2]=BP(c[(c[w>>2]|0)+296>>2]|0,c[p>>2]|0,c[o>>2]|0)|0;if(c[G>>2]|0)c[o>>2]=c[G>>2]}while(0);G=c[w>>2]|0;if(c[(c[w>>2]|0)+372>>2]|0){c[x>>2]=c[G+372>>2];c[(c[w>>2]|0)+372>>2]=c[(c[x>>2]|0)+24>>2];n=(c[w>>2]|0)+368|0;c[n>>2]=(c[n>>2]|0)+-1;n=(c[x>>2]|0)+0|0;l=n+60|0;do{c[n>>2]=0;n=n+4|0}while((n|0)<(l|0));c[(c[x>>2]|0)+4>>2]=1;if(!(c[(c[w>>2]|0)+364>>2]|0)){if(!(c[D>>2]|0)){n=my(c[o>>2]|0)|0;c[(c[x>>2]|0)+8>>2]=n}else c[(c[x>>2]|0)+8>>2]=c[D>>2];if(!(c[(c[x>>2]|0)+8>>2]|0)){sQ(c[w>>2]|0,197888);i=m;return}}else c[(c[x>>2]|0)+8>>2]=c[o>>2];if((c[18774]|0)!=0&(c[33968]|0)!=0)zb[c[135872>>2]&511](c[x>>2]|0)}else{do if(!(c[G+364>>2]|0)){n=c[(c[w>>2]|0)+8>>2]|0;if(!(c[D>>2]|0)){c[x>>2]=ji(n,0,c[o>>2]|0,0)|0;break}else{c[x>>2]=ki(n,0,c[D>>2]|0,0)|0;break}}else c[x>>2]=ki(c[(c[w>>2]|0)+8>>2]|0,0,c[o>>2]|0,0)|0;while(0);if(!(c[x>>2]|0)){sQ(c[w>>2]|0,197888);i=m;return}}do if((c[(c[w>>2]|0)+280>>2]|0)!=0?(c[(c[w>>2]|0)+36>>2]|0)!=0:0)if((c[(c[(c[w>>2]|0)+36>>2]|0)+28>>2]|0)<65535){b[(c[x>>2]|0)+56>>1]=c[(c[(c[w>>2]|0)+36>>2]|0)+28>>2];break}else{b[(c[x>>2]|0)+56>>1]=-1;break}while(0);if(!(c[y>>2]|0))zi(c[(c[w>>2]|0)+8>>2]|0,c[x>>2]|0)|0;c[E>>2]=0;c[F>>2]=0;while(1){if((c[F>>2]|0)>=(c[r>>2]|0))break;o=c[E>>2]|0;c[E>>2]=o+1;c[C>>2]=c[(c[s>>2]|0)+(o<<2)>>2];o=c[E>>2]|0;c[E>>2]=o+1;c[B>>2]=c[(c[s>>2]|0)+(o<<2)>>2];c[A>>2]=Ih(0,c[B>>2]|0,c[C>>2]|0)|0;if(c[A>>2]|0){o=c[A>>2]|0;if(!(c[z>>2]|0)){c[z>>2]=o;c[(c[x>>2]|0)+48>>2]=o}else{c[c[z>>2]>>2]=o;c[z>>2]=c[A>>2]}if((c[q>>2]|0)!=0?(c[p>>2]|0)==(c[C>>2]|0):0)c[(c[x>>2]|0)+36>>2]=c[A>>2];if(((((c[(c[w>>2]|0)+32>>2]|0)==0?(c[(c[w>>2]|0)+104>>2]|0)!=0:0)?(c[(c[w>>2]|0)+12>>2]|0)!=0:0)?(c[(c[w>>2]|0)+8>>2]|0)!=0:0)?(c[(c[(c[w>>2]|0)+8>>2]|0)+44>>2]|0)!=0:0){o=Xm((c[w>>2]|0)+108|0,c[(c[w>>2]|0)+8>>2]|0,c[x>>2]|0,c[p>>2]|0,c[A>>2]|0,c[B>>2]|0)|0;G=(c[w>>2]|0)+100|0;c[G>>2]=c[G>>2]&o}}c[F>>2]=(c[F>>2]|0)+1}c[(c[w>>2]|0)+264>>2]=-1;Qe(c[w>>2]|0,c[x>>2]|0)|0;do if(c[y>>2]|0){B=c[y>>2]|0;C=c[x>>2]|0;if((c[(c[y>>2]|0)+4>>2]|0)==1){zi(B,C)|0;break}else{xi(B,C)|0;break}}while(0);if((c[u>>2]|0)!=0?(c[(c[w>>2]|0)+276>>2]&4|0)==0:0)c[t>>2]=(c[t>>2]|0)-(c[u>>2]|0);do if((c[q>>2]|0)!=0?(c[(c[x>>2]|0)+36>>2]|0)==0:0){u=cj(c[(c[w>>2]|0)+8>>2]|0,c[y>>2]|0,c[p>>2]|0)|0;c[(c[x>>2]|0)+36>>2]=u;if((c[(c[x>>2]|0)+36>>2]|0)==0?(qy(c[p>>2]|0,197912)|0)!=0:0){u=cj(c[(c[w>>2]|0)+8>>2]|0,c[x>>2]|0,c[p>>2]|0)|0;c[(c[x>>2]|0)+36>>2]=u}if(!(c[(c[x>>2]|0)+36>>2]|0)){c[A>>2]=Ih(c[x>>2]|0,0,c[p>>2]|0)|0;if(!(c[A>>2]|0)){sQ(c[w>>2]|0,197888);i=m;return}u=c[w>>2]|0;if(c[p>>2]|0){yQ(u,201,197920,c[p>>2]|0,0);break}else{yQ(u,201,197960,0,0);break}}}while(0);a:do if((c[t>>2]|0)>0){c[F>>2]=0;c[E>>2]=0;while(1){if((c[E>>2]|0)>=(c[t>>2]|0))break a;do if((c[(c[v>>2]|0)+((c[F>>2]|0)+1<<2)>>2]|0)!=0?(c[(c[v>>2]|0)+((c[F>>2]|0)+2<<2)>>2]|0)==0:0)if(c[(c[w>>2]|0)+364>>2]|0){c[H>>2]=BP(c[(c[w>>2]|0)+296>>2]|0,c[(c[v>>2]|0)+((c[F>>2]|0)+1<<2)>>2]|0,c[(c[v>>2]|0)+(c[F>>2]<<2)>>2]|0)|0;if(!(c[H>>2]|0)){J=83;break}zQ(c[w>>2]|0,c[H>>2]|0,0,c[(c[v>>2]|0)+((c[F>>2]|0)+3<<2)>>2]|0,c[(c[v>>2]|0)+((c[F>>2]|0)+4<<2)>>2]|0);break}else{c[D>>2]=Bh(c[(c[v>>2]|0)+(c[F>>2]<<2)>>2]|0,c[(c[v>>2]|0)+((c[F>>2]|0)+1<<2)>>2]|0,0,0)|0;if(!(c[D>>2]|0)){J=83;break}zQ(c[w>>2]|0,c[D>>2]|0,0,c[(c[v>>2]|0)+((c[F>>2]|0)+3<<2)>>2]|0,c[(c[v>>2]|0)+((c[F>>2]|0)+4<<2)>>2]|0);zb[c[135736>>2]&511](c[D>>2]|0);break}else J=83;while(0);if((J|0)==83){J=0;zQ(c[w>>2]|0,c[(c[v>>2]|0)+(c[F>>2]<<2)>>2]|0,c[(c[v>>2]|0)+((c[F>>2]|0)+1<<2)>>2]|0,c[(c[v>>2]|0)+((c[F>>2]|0)+3<<2)>>2]|0,c[(c[v>>2]|0)+((c[F>>2]|0)+4<<2)>>2]|0)}c[E>>2]=(c[E>>2]|0)+1;c[F>>2]=(c[F>>2]|0)+5}}while(0);if(!(c[(c[w>>2]|0)+104>>2]|0)){i=m;return}if((c[(c[w>>2]|0)+136>>2]|0)!=-1412623820){i=m;return}c[I>>2]=en((c[w>>2]|0)+108|0,c[(c[w>>2]|0)+8>>2]|0)|0;if((c[I>>2]|0)<=0)c[(c[w>>2]|0)+100>>2]=0;if((c[I>>2]|0)<0)c[(c[w>>2]|0)+12>>2]=0;I=an((c[w>>2]|0)+108|0,c[(c[w>>2]|0)+8>>2]|0)|0;F=(c[w>>2]|0)+100|0;c[F>>2]=c[F>>2]&I;c[(c[w>>2]|0)+136>>2]=-1412623819;i=m;return}function gQ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+48|0;g=f+40|0;h=f+24|0;j=f+4|0;k=f;c[g>>2]=a;c[f+36>>2]=b;c[f+32>>2]=d;c[f+28>>2]=e;c[h>>2]=c[g>>2];if(!(c[g>>2]|0)){i=f;return}c[k>>2]=c[(c[h>>2]|0)+52>>2];if((c[k>>2]|0)!=0?(c[(c[h>>2]|0)+68>>2]|0)!=0:0){c[j+12>>2]=(c[(c[(c[h>>2]|0)+36>>2]|0)+16>>2]|0)-(c[(c[(c[h>>2]|0)+36>>2]|0)+12>>2]|0);c[j+16>>2]=c[(c[(c[h>>2]|0)+36>>2]|0)+28>>2];c[j>>2]=c[k>>2];De(c[h>>2]|0,j)}c[(c[h>>2]|0)+264>>2]=-1;if((((c[(c[h>>2]|0)+104>>2]|0)!=0?(c[(c[h>>2]|0)+12>>2]|0)!=0:0)?(c[(c[h>>2]|0)+8>>2]|0)!=0:0)?(c[(c[(c[h>>2]|0)+8>>2]|0)+44>>2]|0)!=0:0){j=$m((c[h>>2]|0)+108|0,c[(c[h>>2]|0)+8>>2]|0,c[k>>2]|0)|0;k=(c[h>>2]|0)+100|0;c[k>>2]=c[k>>2]&j}Re(c[h>>2]|0)|0;i=f;return}function hQ(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=c[f>>2];if(!(c[f>>2]|0)){i=e;return}f=c[(c[h>>2]|0)+8>>2]|0;b=c[g>>2]|0;if((d[c[g>>2]>>0]|0|0)==35)c[j>>2]=mi(f,b)|0;else c[j>>2]=Yh(f,b)|0;if(zi(c[(c[h>>2]|0)+52>>2]|0,c[j>>2]|0)|0){i=e;return}Rh(c[j>>2]|0);i=e;return}function iQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f+28|0;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f+4|0;o=f;c[g>>2]=b;c[h>>2]=d;c[j>>2]=e;c[k>>2]=c[g>>2];if(!(c[g>>2]|0)){i=f;return}if(!(c[(c[k>>2]|0)+52>>2]|0)){i=f;return}c[l>>2]=c[(c[(c[k>>2]|0)+52>>2]|0)+16>>2];if(!(c[l>>2]|0)){c[l>>2]=AQ(c[k>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;if(c[l>>2]|0){c[(c[(c[k>>2]|0)+52>>2]|0)+12>>2]=c[l>>2];c[(c[(c[k>>2]|0)+52>>2]|0)+16>>2]=c[l>>2];c[(c[l>>2]|0)+20>>2]=c[(c[k>>2]|0)+52>>2];c[(c[l>>2]|0)+32>>2]=c[(c[(c[k>>2]|0)+52>>2]|0)+32>>2];c[(c[k>>2]|0)+260>>2]=c[j>>2];c[(c[k>>2]|0)+264>>2]=(c[j>>2]|0)+1;i=f;return}else{sQ(c[k>>2]|0,198e3);i=f;return}}if((c[l>>2]|0)!=0?(c[(c[l>>2]|0)+4>>2]|0)==3:0)p=(c[(c[l>>2]|0)+8>>2]|0)==75104;else p=0;c[m>>2]=p&1;if((c[m>>2]|0)!=0?(c[(c[k>>2]|0)+264>>2]|0)!=0:0){if((c[(c[l>>2]|0)+40>>2]|0)!=((c[l>>2]|0)+44|0)){if((c[(c[k>>2]|0)+264>>2]|0)==((c[(c[k>>2]|0)+260>>2]|0)+1|0)?(CP(c[(c[k>>2]|0)+296>>2]|0,c[(c[l>>2]|0)+40>>2]|0)|0)!=0:0){p=my(c[(c[l>>2]|0)+40>>2]|0)|0;c[(c[l>>2]|0)+40>>2]=p}}else{p=my(c[(c[l>>2]|0)+40>>2]|0)|0;c[(c[l>>2]|0)+40>>2]=p;c[(c[l>>2]|0)+44>>2]=0}p=c[k>>2]|0;if(!(c[(c[l>>2]|0)+40>>2]|0)){sQ(p,198024);i=f;return}if(((c[p+260>>2]|0)+(c[j>>2]|0)|0)>>>0>1e7?(c[(c[k>>2]|0)+360>>2]&524288|0)==0:0){sQ(c[k>>2]|0,198072);i=f;return}if((c[(c[k>>2]|0)+260>>2]|0)>>>0<=(-1-(c[j>>2]|0)|0)>>>0?((c[(c[k>>2]|0)+264>>2]|0)+(c[j>>2]|0)|0)>>>0<=2147483647:0){do if(((c[(c[k>>2]|0)+260>>2]|0)+(c[j>>2]|0)|0)>=(c[(c[k>>2]|0)+264>>2]|0)){c[o>>2]=(c[(c[k>>2]|0)+264>>2]|0)+(c[j>>2]|0);c[o>>2]=c[o>>2]<<1;c[n>>2]=Hb[c[135760>>2]&511](c[(c[l>>2]|0)+40>>2]|0,c[o>>2]|0)|0;if(c[n>>2]|0){c[(c[k>>2]|0)+264>>2]=c[o>>2];c[(c[l>>2]|0)+40>>2]=c[n>>2];break}sQ(c[k>>2]|0,198e3);i=f;return}while(0);eU((c[(c[l>>2]|0)+40>>2]|0)+(c[(c[k>>2]|0)+260>>2]|0)|0,c[h>>2]|0,c[j>>2]|0)|0;n=(c[k>>2]|0)+260|0;c[n>>2]=(c[n>>2]|0)+(c[j>>2]|0);a[(c[(c[l>>2]|0)+40>>2]|0)+(c[(c[k>>2]|0)+260>>2]|0)>>0]=0;i=f;return}sQ(c[k>>2]|0,198112);i=f;return}if(c[m>>2]|0){if(jj(c[l>>2]|0,c[h>>2]|0,c[j>>2]|0)|0)sQ(c[k>>2]|0,198e3);if(!(c[(c[(c[k>>2]|0)+52>>2]|0)+12>>2]|0)){i=f;return}m=xy(c[(c[l>>2]|0)+40>>2]|0)|0;c[(c[k>>2]|0)+260>>2]=m;c[(c[k>>2]|0)+264>>2]=(c[(c[k>>2]|0)+260>>2]|0)+1;i=f;return}else{c[l>>2]=AQ(c[k>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;if(!(c[l>>2]|0)){i=f;return}zi(c[(c[k>>2]|0)+52>>2]|0,c[l>>2]|0)|0;if(!(c[(c[(c[k>>2]|0)+52>>2]|0)+12>>2]|0)){i=f;return}c[(c[k>>2]|0)+260>>2]=c[j>>2];c[(c[k>>2]|0)+264>>2]=(c[j>>2]|0)+1;i=f;return}}function jQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;i=i+16|0;c[e+8>>2]=a;c[e+4>>2]=b;c[e>>2]=d;i=e;return}function kQ(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[g>>2]=a;c[h>>2]=d;c[j>>2]=e;c[k>>2]=c[g>>2];if(!(c[g>>2]|0)){i=f;return}c[m>>2]=c[(c[k>>2]|0)+52>>2];c[l>>2]=gi(c[(c[k>>2]|0)+8>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;if(!(c[l>>2]|0)){i=f;return}do if((c[(c[k>>2]|0)+280>>2]|0)!=0?(c[(c[k>>2]|0)+36>>2]|0)!=0:0)if((c[(c[(c[k>>2]|0)+36>>2]|0)+28>>2]|0)<65535){b[(c[l>>2]|0)+56>>1]=c[(c[(c[k>>2]|0)+36>>2]|0)+28>>2];break}else{b[(c[l>>2]|0)+56>>1]=-1;break}while(0);j=c[k>>2]|0;if((c[(c[k>>2]|0)+216>>2]|0)==1){zi(c[(c[j+8>>2]|0)+44>>2]|0,c[l>>2]|0)|0;i=f;return}if((c[j+216>>2]|0)==2){zi(c[(c[(c[k>>2]|0)+8>>2]|0)+48>>2]|0,c[l>>2]|0)|0;i=f;return}if(!(c[m>>2]|0)){zi(c[(c[k>>2]|0)+8>>2]|0,c[l>>2]|0)|0;i=f;return}k=c[m>>2]|0;j=c[l>>2]|0;if((c[(c[m>>2]|0)+4>>2]|0)==1){zi(k,j)|0;i=f;return}else{xi(k,j)|0;i=f;return}}function lQ(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=a;c[g>>2]=d;c[h>>2]=c[f>>2];if(!(c[f>>2]|0)){i=e;return}c[k>>2]=c[(c[h>>2]|0)+52>>2];c[j>>2]=qi(c[(c[h>>2]|0)+8>>2]|0,c[g>>2]|0)|0;if(!(c[j>>2]|0)){i=e;return}do if((c[(c[h>>2]|0)+280>>2]|0)!=0?(c[(c[h>>2]|0)+36>>2]|0)!=0:0)if((c[(c[(c[h>>2]|0)+36>>2]|0)+28>>2]|0)<65535){b[(c[j>>2]|0)+56>>1]=c[(c[(c[h>>2]|0)+36>>2]|0)+28>>2];break}else{b[(c[j>>2]|0)+56>>1]=-1;break}while(0);g=c[h>>2]|0;if((c[(c[h>>2]|0)+216>>2]|0)==1){zi(c[(c[g+8>>2]|0)+44>>2]|0,c[j>>2]|0)|0;i=e;return}if((c[g+216>>2]|0)==2){zi(c[(c[(c[h>>2]|0)+8>>2]|0)+48>>2]|0,c[j>>2]|0)|0;i=e;return}if(!(c[k>>2]|0)){zi(c[(c[h>>2]|0)+8>>2]|0,c[j>>2]|0)|0;i=e;return}h=c[k>>2]|0;g=c[j>>2]|0;if((c[(c[k>>2]|0)+4>>2]|0)==1){zi(h,g)|0;i=e;return}else{xi(h,g)|0;i=e;return}}function mQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=c[f>>2];if(!(c[f>>2]|0)){i=e;return}c[l>>2]=Bi(c[(c[j>>2]|0)+52>>2]|0)|0;if((c[l>>2]|0)!=0?(c[(c[l>>2]|0)+4>>2]|0)==4:0){jj(c[l>>2]|0,c[g>>2]|0,c[h>>2]|0)|0;i=e;return}c[k>>2]=pi(c[(c[j>>2]|0)+8>>2]|0,c[g>>2]|0,c[h>>2]|0)|0;zi(c[(c[j>>2]|0)+52>>2]|0,c[k>>2]|0)|0;i=e;return}function nQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=c[49538];if((c[e>>2]|0)!=1&(c[e>>2]|0)!=2){c[d>>2]=-1;g=c[d>>2]|0;i=b;return g|0}else{c[49538]=c[e>>2];c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function oQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if(!(c[f>>2]|0)){c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}do if((c[g>>2]|0)==2){c[(c[f>>2]|0)+56>>2]=0;c[(c[f>>2]|0)+60>>2]=0;c[(c[f>>2]|0)+116>>2]=387;c[(c[f>>2]|0)+120>>2]=388;c[(c[f>>2]|0)+124>>2]=0;c[(c[f>>2]|0)+108>>2]=-554844497}else{if((c[g>>2]|0)==1){c[(c[f>>2]|0)+56>>2]=50;c[(c[f>>2]|0)+60>>2]=51;c[(c[f>>2]|0)+108>>2]=1;break}c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}while(0);c[c[f>>2]>>2]=36;c[(c[f>>2]|0)+104>>2]=60;c[(c[f>>2]|0)+4>>2]=37;c[(c[f>>2]|0)+8>>2]=38;c[(c[f>>2]|0)+12>>2]=39;c[(c[f>>2]|0)+16>>2]=40;c[(c[f>>2]|0)+20>>2]=41;c[(c[f>>2]|0)+96>>2]=58;c[(c[f>>2]|0)+24>>2]=42;c[(c[f>>2]|0)+32>>2]=44;c[(c[f>>2]|0)+36>>2]=45;c[(c[f>>2]|0)+28>>2]=43;c[(c[f>>2]|0)+40>>2]=46;c[(c[f>>2]|0)+44>>2]=47;c[(c[f>>2]|0)+48>>2]=48;c[(c[f>>2]|0)+52>>2]=49;c[(c[f>>2]|0)+64>>2]=52;c[(c[f>>2]|0)+68>>2]=53;c[(c[f>>2]|0)+100>>2]=59;c[(c[f>>2]|0)+72>>2]=53;c[(c[f>>2]|0)+76>>2]=54;c[(c[f>>2]|0)+80>>2]=55;c[(c[f>>2]|0)+84>>2]=56;c[(c[f>>2]|0)+88>>2]=57;c[(c[f>>2]|0)+92>>2]=57;c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}function pQ(){var a=0;a=i;oQ(135968,1)|0;i=a;return}function qQ(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+108>>2]|0){i=b;return}c[c[d>>2]>>2]=36;c[(c[d>>2]|0)+104>>2]=0;c[(c[d>>2]|0)+4>>2]=0;c[(c[d>>2]|0)+8>>2]=0;c[(c[d>>2]|0)+12>>2]=0;c[(c[d>>2]|0)+16>>2]=0;c[(c[d>>2]|0)+20>>2]=41;c[(c[d>>2]|0)+96>>2]=0;c[(c[d>>2]|0)+24>>2]=0;c[(c[d>>2]|0)+32>>2]=0;c[(c[d>>2]|0)+36>>2]=0;c[(c[d>>2]|0)+28>>2]=0;c[(c[d>>2]|0)+40>>2]=0;c[(c[d>>2]|0)+44>>2]=47;c[(c[d>>2]|0)+48>>2]=48;c[(c[d>>2]|0)+52>>2]=49;c[(c[d>>2]|0)+56>>2]=50;c[(c[d>>2]|0)+60>>2]=51;c[(c[d>>2]|0)+64>>2]=0;c[(c[d>>2]|0)+68>>2]=53;c[(c[d>>2]|0)+100>>2]=59;c[(c[d>>2]|0)+72>>2]=65;c[(c[d>>2]|0)+76>>2]=54;c[(c[d>>2]|0)+80>>2]=55;c[(c[d>>2]|0)+84>>2]=56;c[(c[d>>2]|0)+88>>2]=57;c[(c[d>>2]|0)+92>>2]=57;c[(c[d>>2]|0)+108>>2]=1;i=b;return}function rQ(){var a=0;a=i;qQ(136096);i=a;return}function sQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;c[j>>2]=198680;if(!(c[f>>2]|0)){b=c[h>>2]|0;a=c[f>>2]|0;k=c[j>>2]|0;l=c[g>>2]|0;c[e>>2]=c[j>>2];c[e+4>>2]=0;Xd(b,0,0,a,0,1,2,2,0,0,k,0,0,0,0,l,e);i=d;return}c[(c[f>>2]|0)+84>>2]=2;if((c[c[f>>2]>>2]|0)!=0?(c[(c[c[f>>2]>>2]|0)+108>>2]|0)==-554844497:0)c[h>>2]=c[(c[c[f>>2]>>2]|0)+124>>2];l=c[h>>2]|0;h=c[(c[f>>2]|0)+112>>2]|0;k=c[(c[f>>2]|0)+108>>2]|0;a=c[f>>2]|0;b=c[j>>2]|0;m=c[g>>2]|0;c[e>>2]=c[j>>2];c[e+4>>2]=0;Xd(l,h,k,a,0,1,2,2,0,0,b,0,0,0,0,m,e);c[(c[f>>2]|0)+84>>2]=2;c[(c[f>>2]|0)+172>>2]=-1;c[(c[f>>2]|0)+212>>2]=1;i=d;return}function tQ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+32|0;h=g;j=g+24|0;k=g+20|0;l=g+16|0;m=g+12|0;n=g+8|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;if(((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+212>>2]|0)!=0:0)?(c[(c[j>>2]|0)+172>>2]|0)==-1:0){i=g;return}if(c[j>>2]|0)c[(c[j>>2]|0)+84>>2]=c[k>>2];f=c[j>>2]|0;e=c[k>>2]|0;k=c[m>>2]|0;d=c[n>>2]|0;b=c[l>>2]|0;l=c[n>>2]|0;c[h>>2]=c[m>>2];c[h+4>>2]=l;Xd(0,0,0,f,0,1,e,3,0,0,k,d,0,0,0,b,h);if(!(c[j>>2]|0)){i=g;return}c[(c[j>>2]|0)+12>>2]=0;c[(c[j>>2]|0)+100>>2]=0;if(c[(c[j>>2]|0)+288>>2]|0){i=g;return}c[(c[j>>2]|0)+212>>2]=1;i=g;return}function uQ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if(((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+212>>2]|0)!=0:0)?(c[(c[h>>2]|0)+172>>2]|0)==-1:0){i=f;return}if(c[h>>2]|0)c[(c[h>>2]|0)+84>>2]=c[j>>2];e=c[h>>2]|0;h=c[j>>2]|0;j=c[l>>2]|0;d=c[k>>2]|0;c[g>>2]=c[l>>2];Xd(0,0,0,e,0,1,h,1,0,0,j,0,0,0,0,d,g);i=f;return}function vQ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+32|0;h=g;j=g+28|0;k=g+24|0;l=g+20|0;m=g+16|0;n=g+12|0;o=g+8|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=0;if(((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+212>>2]|0)!=0:0)?(c[(c[j>>2]|0)+172>>2]|0)==-1:0){i=g;return}if(!(c[j>>2]|0)){f=c[o>>2]|0;e=c[j>>2]|0;d=c[k>>2]|0;b=c[m>>2]|0;a=c[n>>2]|0;p=c[l>>2]|0;q=c[n>>2]|0;c[h>>2]=c[m>>2];c[h+4>>2]=q;Xd(f,0,0,e,0,4,d,2,0,0,b,a,0,0,0,p,h);i=g;return}c[(c[j>>2]|0)+84>>2]=c[k>>2];if((c[c[j>>2]>>2]|0)!=0?(c[(c[c[j>>2]>>2]|0)+108>>2]|0)==-554844497:0)c[o>>2]=c[(c[c[j>>2]>>2]|0)+124>>2];p=c[o>>2]|0;o=c[(c[j>>2]|0)+112>>2]|0;a=c[(c[j>>2]|0)+108>>2]|0;b=c[j>>2]|0;d=c[k>>2]|0;k=c[m>>2]|0;e=c[n>>2]|0;f=c[l>>2]|0;l=c[n>>2]|0;c[h>>2]=c[m>>2];c[h+4>>2]=l;Xd(p,o,a,b,0,4,d,2,0,0,k,e,0,0,0,f,h);c[(c[j>>2]|0)+100>>2]=0;i=g;return}function wQ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+112|0;g=f+44|0;h=f+40|0;j=f+36|0;k=f+32|0;l=f+28|0;m=f+24|0;n=f+20|0;o=f+16|0;p=f+12|0;q=f+8|0;r=f+4|0;s=f+48|0;t=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[n>>2]=1;c[l>>2]=Mm(c[(c[(c[g>>2]|0)+8>>2]|0)+44>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;if(!(c[l>>2]|0)){c[l>>2]=Mm(c[(c[(c[g>>2]|0)+8>>2]|0)+48>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;c[n>>2]=0}a:while(1){if(!(c[l>>2]|0)){u=48;break}c[p>>2]=c[(c[l>>2]|0)+44>>2];b:do if(((c[(c[(c[g>>2]|0)+8>>2]|0)+40>>2]|0)==1?(c[(c[(c[g>>2]|0)+8>>2]|0)+48>>2]|0)!=0:0)?(c[p>>2]|0)!=0?(c[(c[g>>2]|0)+104>>2]|0)!=0:0:0){while(1){if(((c[(c[p>>2]|0)+48>>2]|0)!=0?(e=Nm(c[(c[(c[g>>2]|0)+8>>2]|0)+48>>2]|0,c[(c[p>>2]|0)+60>>2]|0,c[(c[p>>2]|0)+8>>2]|0,c[(c[p>>2]|0)+56>>2]|0)|0,(e|0)==(c[p>>2]|0)):0)?(Nm(c[(c[(c[g>>2]|0)+8>>2]|0)+44>>2]|0,c[(c[p>>2]|0)+60>>2]|0,c[(c[p>>2]|0)+8>>2]|0,c[(c[p>>2]|0)+56>>2]|0)|0)==0:0){e=c[p>>2]|0;if(c[(c[p>>2]|0)+56>>2]|0){c[q>>2]=my(c[e+56>>2]|0)|0;c[q>>2]=By(c[q>>2]|0,198608)|0;c[q>>2]=By(c[q>>2]|0,c[(c[p>>2]|0)+8>>2]|0)|0}else c[q>>2]=my(c[e+8>>2]|0)|0;if(!(c[q>>2]|0))break;c[m>>2]=0;c:do if(c[k>>2]|0){c[o>>2]=0;c[m>>2]=c[(c[k>>2]|0)+(c[o>>2]<<2)>>2];while(1){if(!(c[m>>2]|0))break c;if(qy(c[m>>2]|0,c[q>>2]|0)|0)break c;c[o>>2]=(c[o>>2]|0)+2;c[m>>2]=c[(c[k>>2]|0)+(c[o>>2]<<2)>>2]}}while(0);if(!(c[m>>2]|0))vQ(c[g>>2]|0,538,198616,c[q>>2]|0,c[(c[p>>2]|0)+60>>2]|0);zb[c[135736>>2]&511](c[q>>2]|0)}c[p>>2]=c[(c[p>>2]|0)+36>>2];if(!(c[p>>2]|0))break b}sQ(c[g>>2]|0,197824)}while(0);c[p>>2]=c[(c[l>>2]|0)+44>>2];while(1){if(!(c[p>>2]|0))break;d:do if(c[(c[p>>2]|0)+48>>2]|0){if(!((c[(c[p>>2]|0)+56>>2]|0)!=0?(qy(c[(c[p>>2]|0)+56>>2]|0,198248)|0)!=0:0))u=29;do if((u|0)==29){u=0;if((c[(c[p>>2]|0)+56>>2]|0)==0?(qy(c[(c[p>>2]|0)+8>>2]|0,198248)|0)!=0:0)break;if(!(c[(c[g>>2]|0)+276>>2]&4))break d}while(0);c[r>>2]=Nm(c[(c[(c[g>>2]|0)+8>>2]|0)+44>>2]|0,c[(c[p>>2]|0)+60>>2]|0,c[(c[p>>2]|0)+8>>2]|0,c[(c[p>>2]|0)+56>>2]|0)|0;if((c[r>>2]|0)==0?1:(c[r>>2]|0)==(c[p>>2]|0)){c[t>>2]=Bh(c[(c[p>>2]|0)+8>>2]|0,c[(c[p>>2]|0)+56>>2]|0,s,50)|0;if(!(c[t>>2]|0)){u=34;break a}c[m>>2]=0;e:do if(c[k>>2]|0){c[o>>2]=0;c[m>>2]=c[(c[k>>2]|0)+(c[o>>2]<<2)>>2];while(1){if(!(c[m>>2]|0))break e;if(qy(c[m>>2]|0,c[t>>2]|0)|0)break e;c[o>>2]=(c[o>>2]|0)+2;c[m>>2]=c[(c[k>>2]|0)+(c[o>>2]<<2)>>2]}}while(0);if(!(c[m>>2]|0))xQ(c[g>>2]|0,c[t>>2]|0,c[(c[p>>2]|0)+48>>2]|0,c[j>>2]|0);if((c[t>>2]|0)!=(s|0)?(c[t>>2]|0)!=(c[(c[p>>2]|0)+8>>2]|0):0)zb[c[135736>>2]&511](c[t>>2]|0)}}while(0);c[p>>2]=c[(c[p>>2]|0)+36>>2]}if((c[n>>2]|0)!=1){u=48;break}c[l>>2]=Mm(c[(c[(c[g>>2]|0)+8>>2]|0)+48>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;c[n>>2]=0}if((u|0)==34){sQ(c[g>>2]|0,197824);i=f;return}else if((u|0)==48){i=f;return}}function xQ(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;g=i;i=i+96|0;h=g;j=g+80|0;k=g+76|0;l=g+72|0;m=g+68|0;n=g+64|0;o=g+60|0;p=g+56|0;q=g+52|0;r=g+48|0;s=g+44|0;t=g+40|0;u=g+36|0;v=g+32|0;w=g+28|0;x=g+24|0;y=g+20|0;z=g+16|0;A=g+12|0;B=g+8|0;C=g+4|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=c[j>>2];if(!(c[(c[n>>2]|0)+32>>2]|0)){c[p>>2]=bf(c[n>>2]|0,c[k>>2]|0,q)|0;if((c[p>>2]|0)!=0?(d[c[p>>2]>>0]|0|0)==0:0){j=(qy(c[q>>2]|0,198248)|0)!=0;f=c[n>>2]|0;e=c[k>>2]|0;if(j)BQ(f,35,198256,e,0);else yQ(f,106,198296,e,0);if(c[q>>2]|0)zb[c[135736>>2]&511](c[q>>2]|0);c[q>>2]=0;zb[c[135736>>2]&511](c[p>>2]|0);c[p>>2]=my(c[k>>2]|0)|0}}else{c[p>>2]=my(c[k>>2]|0)|0;c[q>>2]=0;c[s>>2]=0}e=c[n>>2]|0;if(!(c[p>>2]|0)){sQ(e,197824);if(!(c[q>>2]|0)){i=g;return}zb[c[135736>>2]&511](c[q>>2]|0);i=g;return}if((c[e+32>>2]|0)!=0&(c[l>>2]|0)==0?(sp(c[k>>2]|0)|0)!=0:0){c[r>>2]=my(c[k>>2]|0)|0;c[l>>2]=c[r>>2]}else{c[(c[n>>2]|0)+144>>2]=1;c[r>>2]=Sm((c[n>>2]|0)+108|0,c[(c[n>>2]|0)+8>>2]|0,c[(c[n>>2]|0)+52>>2]|0,c[k>>2]|0,c[l>>2]|0)|0;if((c[(c[n>>2]|0)+144>>2]|0)!=1)c[(c[n>>2]|0)+100>>2]=0;if(c[r>>2]|0)c[l>>2]=c[r>>2]}if((((((((c[q>>2]|0)==0?(c[(c[n>>2]|0)+32>>2]|0)==0:0)?(d[c[p>>2]>>0]|0|0)==120:0)?(d[(c[p>>2]|0)+1>>0]|0|0)==109:0)?(d[(c[p>>2]|0)+2>>0]|0|0)==108:0)?(d[(c[p>>2]|0)+3>>0]|0|0)==110:0)?(d[(c[p>>2]|0)+4>>0]|0|0)==115:0)?(d[(c[p>>2]|0)+5>>0]|0|0)==0:0){if(!(c[(c[n>>2]|0)+16>>2]|0)){e=(c[n>>2]|0)+248|0;c[e>>2]=(c[e>>2]|0)+1;c[u>>2]=af(c[n>>2]|0,c[l>>2]|0,1,0,0,0)|0;e=(c[n>>2]|0)+248|0;c[e>>2]=(c[e>>2]|0)+-1;if(!(c[u>>2]|0)){sQ(c[n>>2]|0,197824);if(!(c[p>>2]|0)){i=g;return}zb[c[135736>>2]&511](c[p>>2]|0);
i=g;return}}else c[u>>2]=c[l>>2];do if(d[c[u>>2]>>0]|0){c[v>>2]=yl(c[u>>2]|0)|0;if(!(c[v>>2]|0)){if(!(c[c[n>>2]>>2]|0))break;if(!(c[(c[c[n>>2]>>2]|0)+84>>2]|0))break;e=c[(c[c[n>>2]>>2]|0)+84>>2]|0;f=c[(c[n>>2]|0)+4>>2]|0;c[h>>2]=c[u>>2];Db[e&511](f,198344,h);break}if(((c[c[v>>2]>>2]|0)==0?(c[c[n>>2]>>2]|0)!=0:0)?(c[(c[c[n>>2]>>2]|0)+84>>2]|0)!=0:0){f=c[(c[c[n>>2]>>2]|0)+84>>2]|0;e=c[(c[n>>2]|0)+4>>2]|0;c[h>>2]=c[u>>2];Db[f&511](e,198376,h)}Al(c[v>>2]|0)}while(0);c[t>>2]=Ih(c[(c[n>>2]|0)+52>>2]|0,c[u>>2]|0,0)|0;if(((((c[t>>2]|0)!=0?(c[(c[n>>2]|0)+104>>2]|0)!=0:0)?(c[(c[n>>2]|0)+12>>2]|0)!=0:0)?(c[(c[n>>2]|0)+8>>2]|0)!=0:0)?(c[(c[(c[n>>2]|0)+8>>2]|0)+44>>2]|0)!=0:0){v=Xm((c[n>>2]|0)+108|0,c[(c[n>>2]|0)+8>>2]|0,c[(c[n>>2]|0)+52>>2]|0,c[m>>2]|0,c[t>>2]|0,c[u>>2]|0)|0;t=(c[n>>2]|0)+100|0;c[t>>2]=c[t>>2]&v}if(c[p>>2]|0)zb[c[135736>>2]&511](c[p>>2]|0);if(c[r>>2]|0)zb[c[135736>>2]&511](c[r>>2]|0);if((c[u>>2]|0)==(c[l>>2]|0)){i=g;return}zb[c[135736>>2]&511](c[u>>2]|0);i=g;return}if((((((((c[q>>2]|0)!=0?(c[(c[n>>2]|0)+32>>2]|0)==0:0)?(d[c[q>>2]>>0]|0|0)==120:0)?(d[(c[q>>2]|0)+1>>0]|0|0)==109:0)?(d[(c[q>>2]|0)+2>>0]|0|0)==108:0)?(d[(c[q>>2]|0)+3>>0]|0|0)==110:0)?(d[(c[q>>2]|0)+4>>0]|0|0)==115:0)?(d[(c[q>>2]|0)+5>>0]|0|0)==0:0){if(!(c[(c[n>>2]|0)+16>>2]|0)){u=(c[n>>2]|0)+248|0;c[u>>2]=(c[u>>2]|0)+1;c[x>>2]=af(c[n>>2]|0,c[l>>2]|0,1,0,0,0)|0;u=(c[n>>2]|0)+248|0;c[u>>2]=(c[u>>2]|0)+-1;if(!(c[x>>2]|0)){sQ(c[n>>2]|0,197824);zb[c[135736>>2]&511](c[q>>2]|0);if(!(c[p>>2]|0)){i=g;return}zb[c[135736>>2]&511](c[p>>2]|0);i=g;return}}else c[x>>2]=c[l>>2];if(!(d[c[x>>2]>>0]|0))BQ(c[n>>2]|0,204,198408,c[p>>2]|0,0);do if((c[(c[n>>2]|0)+268>>2]|0)!=0?(d[c[x>>2]>>0]|0|0)!=0:0){c[y>>2]=yl(c[x>>2]|0)|0;if(!(c[y>>2]|0)){yQ(c[n>>2]|0,99,198448,c[p>>2]|0,c[l>>2]|0);break}if(!(c[c[y>>2]>>2]|0))yQ(c[n>>2]|0,100,198480,c[p>>2]|0,c[l>>2]|0);Al(c[y>>2]|0)}while(0);c[w>>2]=Ih(c[(c[n>>2]|0)+52>>2]|0,c[x>>2]|0,c[p>>2]|0)|0;zb[c[135736>>2]&511](c[q>>2]|0);do if((((c[w>>2]|0)!=0?(c[(c[n>>2]|0)+104>>2]|0)!=0:0)?(c[(c[n>>2]|0)+12>>2]|0)!=0:0)?(c[(c[n>>2]|0)+8>>2]|0)!=0:0){if(!(c[(c[(c[n>>2]|0)+8>>2]|0)+44>>2]|0))break;y=Xm((c[n>>2]|0)+108|0,c[(c[n>>2]|0)+8>>2]|0,c[(c[n>>2]|0)+52>>2]|0,c[m>>2]|0,c[w>>2]|0,c[l>>2]|0)|0;u=(c[n>>2]|0)+100|0;c[u>>2]=c[u>>2]&y}while(0);if(c[p>>2]|0)zb[c[135736>>2]&511](c[p>>2]|0);if(c[r>>2]|0)zb[c[135736>>2]&511](c[r>>2]|0);if((c[x>>2]|0)==(c[l>>2]|0)){i=g;return}zb[c[135736>>2]&511](c[x>>2]|0);i=g;return}a:do if(c[q>>2]|0){c[s>>2]=cj(c[(c[n>>2]|0)+8>>2]|0,c[(c[n>>2]|0)+52>>2]|0,c[q>>2]|0)|0;x=c[n>>2]|0;if(!(c[s>>2]|0)){BQ(x,201,198520,c[q>>2]|0,c[p>>2]|0);D=101;break}c[z>>2]=c[(c[x+52>>2]|0)+44>>2];while(1){if(!(c[z>>2]|0)){D=101;break a}if((c[(c[z>>2]|0)+36>>2]|0)!=0?(qy(c[p>>2]|0,c[(c[z>>2]|0)+8>>2]|0)|0)!=0:0){if((c[s>>2]|0)==(c[(c[z>>2]|0)+36>>2]|0))break;if(qy(c[(c[s>>2]|0)+8>>2]|0,c[(c[(c[z>>2]|0)+36>>2]|0)+8>>2]|0)|0)break}c[z>>2]=c[(c[z>>2]|0)+24>>2]}BQ(c[n>>2]|0,42,198576,c[p>>2]|0,c[(c[s>>2]|0)+8>>2]|0);c[(c[n>>2]|0)+12>>2]=0;if(!(c[(c[n>>2]|0)+288>>2]|0))c[(c[n>>2]|0)+212>>2]=1}else{c[s>>2]=0;D=101}while(0);do if((D|0)==101){c[o>>2]=bi(c[(c[n>>2]|0)+52>>2]|0,c[s>>2]|0,c[p>>2]|0,0)|0;b:do if(c[o>>2]|0){if((c[(c[n>>2]|0)+16>>2]|0)==0?(c[(c[n>>2]|0)+32>>2]|0)==0:0){z=Zh(c[(c[n>>2]|0)+8>>2]|0,c[l>>2]|0)|0;c[(c[o>>2]|0)+12>>2]=z;c[A>>2]=c[(c[o>>2]|0)+12>>2];while(1){if(!(c[A>>2]|0))break b;c[(c[A>>2]|0)+20>>2]=c[o>>2];if(!(c[(c[A>>2]|0)+24>>2]|0))c[(c[o>>2]|0)+16>>2]=c[A>>2];c[A>>2]=c[(c[A>>2]|0)+24>>2]}}if((c[l>>2]|0)!=0?(z=Wh(c[(c[n>>2]|0)+8>>2]|0,c[l>>2]|0)|0,c[(c[o>>2]|0)+12>>2]=z,c[(c[o>>2]|0)+16>>2]=c[(c[o>>2]|0)+12>>2],(c[(c[o>>2]|0)+12>>2]|0)!=0):0)c[(c[(c[o>>2]|0)+12>>2]|0)+20>>2]=c[o>>2]}while(0);if(((((c[(c[n>>2]|0)+32>>2]|0)==0?(c[(c[n>>2]|0)+104>>2]|0)!=0:0)?(c[(c[n>>2]|0)+12>>2]|0)!=0:0)?(c[(c[n>>2]|0)+8>>2]|0)!=0:0)?(c[(c[(c[n>>2]|0)+8>>2]|0)+44>>2]|0)!=0:0){z=c[n>>2]|0;if(c[(c[n>>2]|0)+16>>2]|0){x=Wm(z+108|0,c[(c[n>>2]|0)+8>>2]|0,c[(c[n>>2]|0)+52>>2]|0,c[o>>2]|0,c[l>>2]|0)|0;w=(c[n>>2]|0)+100|0;c[w>>2]=c[w>>2]&x;break}x=z+248|0;c[x>>2]=(c[x>>2]|0)+1;c[B>>2]=af(c[n>>2]|0,c[l>>2]|0,1,0,0,0)|0;x=(c[n>>2]|0)+248|0;c[x>>2]=(c[x>>2]|0)+-1;x=c[n>>2]|0;if(!(c[B>>2]|0)){z=Wm(x+108|0,c[(c[n>>2]|0)+8>>2]|0,c[(c[n>>2]|0)+52>>2]|0,c[o>>2]|0,c[l>>2]|0)|0;w=(c[n>>2]|0)+100|0;c[w>>2]=c[w>>2]&z;break}c[C>>2]=Tm(c[x+8>>2]|0,c[(c[n>>2]|0)+52>>2]|0,c[k>>2]|0,c[B>>2]|0)|0;if(c[C>>2]|0){zb[c[135736>>2]&511](c[B>>2]|0);c[B>>2]=c[C>>2]}x=Wm((c[n>>2]|0)+108|0,c[(c[n>>2]|0)+8>>2]|0,c[(c[n>>2]|0)+52>>2]|0,c[o>>2]|0,c[B>>2]|0)|0;z=(c[n>>2]|0)+100|0;c[z>>2]=c[z>>2]&x;zb[c[135736>>2]&511](c[B>>2]|0);break}if(!(c[(c[n>>2]|0)+276>>2]&8)){if(!((c[(c[n>>2]|0)+16>>2]|0)==0?(c[(c[n>>2]|0)+96>>2]|0)!=2:0)){if(!(c[(c[n>>2]|0)+16>>2]|0))break;if(c[(c[n>>2]|0)+216>>2]|0)break}if(qy(c[k>>2]|0,197408)|0){if(Eh(c[l>>2]|0,1)|0)vQ(c[n>>2]|0,539,198200,c[l>>2]|0,0);Cm((c[n>>2]|0)+108|0,c[(c[n>>2]|0)+8>>2]|0,c[l>>2]|0,c[o>>2]|0)|0;break}x=(Em(c[(c[n>>2]|0)+8>>2]|0,c[(c[n>>2]|0)+52>>2]|0,c[o>>2]|0)|0)!=0;z=c[n>>2]|0;if(x){Cm(z+108|0,c[(c[n>>2]|0)+8>>2]|0,c[l>>2]|0,c[o>>2]|0)|0;break}if(Km(c[z+8>>2]|0,c[(c[n>>2]|0)+52>>2]|0,c[o>>2]|0)|0)Im((c[n>>2]|0)+108|0,c[(c[n>>2]|0)+8>>2]|0,c[l>>2]|0,c[o>>2]|0)|0}}while(0);if(c[r>>2]|0)zb[c[135736>>2]&511](c[r>>2]|0);if(!(c[q>>2]|0)){i=g;return}zb[c[135736>>2]&511](c[q>>2]|0);i=g;return}function yQ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+32|0;h=g;j=g+24|0;k=g+20|0;l=g+16|0;m=g+12|0;n=g+8|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;if(((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+212>>2]|0)!=0:0)?(c[(c[j>>2]|0)+172>>2]|0)==-1:0){i=g;return}if(c[j>>2]|0)c[(c[j>>2]|0)+84>>2]=c[k>>2];f=c[j>>2]|0;j=c[k>>2]|0;k=c[m>>2]|0;e=c[n>>2]|0;d=c[l>>2]|0;l=c[n>>2]|0;c[h>>2]=c[m>>2];c[h+4>>2]=l;Xd(0,0,0,f,0,3,j,1,0,0,k,e,0,0,0,d,h);i=g;return}function zQ(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+112|0;j=h+48|0;k=h+44|0;l=h+40|0;m=h+36|0;n=h+32|0;o=h+28|0;p=h+24|0;q=h+20|0;r=h+16|0;s=h+12|0;t=h+8|0;u=h+4|0;v=h+52|0;w=h;c[j>>2]=a;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;c[p>>2]=0;c[q>>2]=0;if(c[l>>2]|0)c[p>>2]=cj(c[(c[j>>2]|0)+8>>2]|0,c[(c[j>>2]|0)+52>>2]|0,c[l>>2]|0)|0;g=c[j>>2]|0;if(c[(c[j>>2]|0)+380>>2]|0){c[o>>2]=c[g+380>>2];c[(c[j>>2]|0)+380>>2]=c[(c[o>>2]|0)+24>>2];f=(c[j>>2]|0)+376|0;c[f>>2]=(c[f>>2]|0)+-1;f=(c[o>>2]|0)+0|0;e=f+48|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(e|0));c[(c[o>>2]|0)+4>>2]=2;c[(c[o>>2]|0)+20>>2]=c[(c[j>>2]|0)+52>>2];c[(c[o>>2]|0)+32>>2]=c[(c[j>>2]|0)+8>>2];c[(c[o>>2]|0)+36>>2]=c[p>>2];f=c[k>>2]|0;if(c[(c[j>>2]|0)+364>>2]|0)c[(c[o>>2]|0)+8>>2]=f;else{e=my(f)|0;c[(c[o>>2]|0)+8>>2]=e}if(!(c[(c[(c[j>>2]|0)+52>>2]|0)+44>>2]|0))c[(c[(c[j>>2]|0)+52>>2]|0)+44>>2]=c[o>>2];else{c[r>>2]=c[(c[(c[j>>2]|0)+52>>2]|0)+44>>2];while(1){if(!(c[(c[r>>2]|0)+24>>2]|0))break;c[r>>2]=c[(c[r>>2]|0)+24>>2]}c[(c[r>>2]|0)+24>>2]=c[o>>2];c[(c[o>>2]|0)+28>>2]=c[r>>2]}if((c[18774]|0)!=0&(c[33968]|0)!=0)zb[c[135872>>2]&511](c[o>>2]|0)}else{r=c[(c[j>>2]|0)+52>>2]|0;e=c[p>>2]|0;p=c[k>>2]|0;if(c[g+364>>2]|0)c[o>>2]=bi(r,e,p,0)|0;else c[o>>2]=ai(r,e,p,0)|0;if(!(c[o>>2]|0)){ie(c[j>>2]|0,198176);i=h;return}}a:do if((c[(c[j>>2]|0)+16>>2]|0)==0?(c[(c[j>>2]|0)+32>>2]|0)==0:0){p=c[j>>2]|0;if(d[c[n>>2]>>0]|0){c[s>>2]=AQ(p,c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0)|0;c[(c[o>>2]|0)+12>>2]=c[s>>2];c[(c[o>>2]|0)+16>>2]=c[s>>2];if(!(c[s>>2]|0))break;c[(c[s>>2]|0)+32>>2]=c[(c[o>>2]|0)+32>>2];c[(c[s>>2]|0)+20>>2]=c[o>>2];break}e=Vh(c[p+8>>2]|0,c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0)|0;c[(c[o>>2]|0)+12>>2]=e;c[s>>2]=c[(c[o>>2]|0)+12>>2];while(1){if(!(c[s>>2]|0))break a;c[(c[s>>2]|0)+32>>2]=c[(c[o>>2]|0)+32>>2];c[(c[s>>2]|0)+20>>2]=c[o>>2];if(!(c[(c[s>>2]|0)+24>>2]|0))c[(c[o>>2]|0)+16>>2]=c[s>>2];c[s>>2]=c[(c[s>>2]|0)+24>>2]}}else x=30;while(0);if(((x|0)==30?(c[m>>2]|0)!=0:0)?(c[t>>2]=AQ(c[j>>2]|0,c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0)|0,c[(c[o>>2]|0)+12>>2]=c[t>>2],c[(c[o>>2]|0)+16>>2]=c[t>>2],(c[t>>2]|0)!=0):0){c[(c[t>>2]|0)+32>>2]=c[(c[o>>2]|0)+32>>2];c[(c[t>>2]|0)+20>>2]=c[o>>2]}do if(((((c[(c[j>>2]|0)+32>>2]|0)==0?(c[(c[j>>2]|0)+104>>2]|0)!=0:0)?(c[(c[j>>2]|0)+12>>2]|0)!=0:0)?(c[(c[j>>2]|0)+8>>2]|0)!=0:0)?(c[(c[(c[j>>2]|0)+8>>2]|0)+44>>2]|0)!=0:0){if(c[(c[j>>2]|0)+16>>2]|0){c[q>>2]=ly(c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0)|0;t=Wm((c[j>>2]|0)+108|0,c[(c[j>>2]|0)+8>>2]|0,c[(c[j>>2]|0)+52>>2]|0,c[o>>2]|0,c[q>>2]|0)|0;s=(c[j>>2]|0)+100|0;c[s>>2]=c[s>>2]&t;break}c[q>>2]=CQ(c[j>>2]|0,c[m>>2]|0,c[n>>2]|0)|0;if(!(c[q>>2]|0))if(!(d[c[n>>2]>>0]|0)){t=Wm((c[j>>2]|0)+108|0,c[(c[j>>2]|0)+8>>2]|0,c[(c[j>>2]|0)+52>>2]|0,c[o>>2]|0,c[m>>2]|0)|0;s=(c[j>>2]|0)+100|0;c[s>>2]=c[s>>2]&t;break}else{c[q>>2]=ly(c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0)|0;t=Wm((c[j>>2]|0)+108|0,c[(c[j>>2]|0)+8>>2]|0,c[(c[j>>2]|0)+52>>2]|0,c[o>>2]|0,c[q>>2]|0)|0;s=(c[j>>2]|0)+100|0;c[s>>2]=c[s>>2]&t;break}if((c[(c[j>>2]|0)+352>>2]|0)!=0?(c[w>>2]=Bh(c[k>>2]|0,c[l>>2]|0,v,50)|0,(c[w>>2]|0)!=0):0){c[(c[j>>2]|0)+144>>2]=1;c[u>>2]=Sm((c[j>>2]|0)+108|0,c[(c[j>>2]|0)+8>>2]|0,c[(c[j>>2]|0)+52>>2]|0,c[w>>2]|0,c[q>>2]|0)|0;if((c[(c[j>>2]|0)+144>>2]|0)!=1)c[(c[j>>2]|0)+100>>2]=0;if((c[w>>2]|0)!=(v|0)?(c[w>>2]|0)!=(c[k>>2]|0):0)zb[c[135736>>2]&511](c[w>>2]|0);if(c[u>>2]|0){zb[c[135736>>2]&511](c[q>>2]|0);c[q>>2]=c[u>>2]}}t=Wm((c[j>>2]|0)+108|0,c[(c[j>>2]|0)+8>>2]|0,c[(c[j>>2]|0)+52>>2]|0,c[o>>2]|0,c[q>>2]|0)|0;s=(c[j>>2]|0)+100|0;c[s>>2]=c[s>>2]&t}else x=54;while(0);do if((x|0)==54?(c[(c[j>>2]|0)+276>>2]&8|0)==0:0){if(!((c[(c[j>>2]|0)+16>>2]|0)==0?(c[(c[j>>2]|0)+96>>2]|0)!=2:0)){if(!(c[(c[j>>2]|0)+16>>2]|0))break;if(c[(c[j>>2]|0)+216>>2]|0)break}if((((c[l>>2]|0)==(c[(c[j>>2]|0)+312>>2]|0)?(d[c[k>>2]>>0]|0|0)==105:0)?(d[(c[k>>2]|0)+1>>0]|0|0)==100:0)?(d[(c[k>>2]|0)+2>>0]|0|0)==0:0){if(!(c[q>>2]|0))c[q>>2]=ly(c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0)|0;if(Eh(c[q>>2]|0,1)|0)vQ(c[j>>2]|0,539,198200,c[q>>2]|0,0);Cm((c[j>>2]|0)+108|0,c[(c[j>>2]|0)+8>>2]|0,c[q>>2]|0,c[o>>2]|0)|0;break}if(Em(c[(c[j>>2]|0)+8>>2]|0,c[(c[j>>2]|0)+52>>2]|0,c[o>>2]|0)|0){if(!(c[q>>2]|0))c[q>>2]=ly(c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0)|0;Cm((c[j>>2]|0)+108|0,c[(c[j>>2]|0)+8>>2]|0,c[q>>2]|0,c[o>>2]|0)|0;break}if(Km(c[(c[j>>2]|0)+8>>2]|0,c[(c[j>>2]|0)+52>>2]|0,c[o>>2]|0)|0){if(!(c[q>>2]|0))c[q>>2]=ly(c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0)|0;Im((c[j>>2]|0)+108|0,c[(c[j>>2]|0)+8>>2]|0,c[q>>2]|0,c[o>>2]|0)|0}}while(0);if(!(c[q>>2]|0)){i=h;return}zb[c[135736>>2]&511](c[q>>2]|0);i=h;return}function AQ(e,f,g){e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=h+28|0;k=h+24|0;l=h+20|0;m=h+16|0;n=h+12|0;o=h+8|0;p=h+32|0;q=h+4|0;r=h;c[k>>2]=e;c[l>>2]=f;c[m>>2]=g;c[o>>2]=0;if(c[(c[k>>2]|0)+372>>2]|0){c[n>>2]=c[(c[k>>2]|0)+372>>2];c[(c[k>>2]|0)+372>>2]=c[(c[n>>2]|0)+24>>2];g=(c[k>>2]|0)+368|0;c[g>>2]=(c[g>>2]|0)+-1}else c[n>>2]=Cb[c[135744>>2]&511](60)|0;if(!(c[n>>2]|0)){ie(c[k>>2]|0,198e3);c[j>>2]=0;s=c[j>>2]|0;i=h;return s|0}g=(c[n>>2]|0)+0|0;f=g+60|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(f|0));a:do if(c[(c[k>>2]|0)+364>>2]|0){a[p>>0]=a[(c[l>>2]|0)+(c[m>>2]|0)>>0]|0;if((c[m>>2]|0)<8?(c[(c[k>>2]|0)+360>>2]&65536|0)!=0:0){c[q>>2]=(c[n>>2]|0)+44;eU(c[q>>2]|0,c[l>>2]|0,c[m>>2]|0)|0;a[(c[q>>2]|0)+(c[m>>2]|0)>>0]=0;c[o>>2]=c[q>>2];break}do if((c[m>>2]|0)<=3){if((d[p>>0]|0|0)!=34?(d[p>>0]|0|0)!=39:0){if((d[p>>0]|0|0)!=60)break;if((d[(c[l>>2]|0)+((c[m>>2]|0)+1)>>0]|0|0)==33)break}c[o>>2]=AP(c[(c[k>>2]|0)+296>>2]|0,c[l>>2]|0,c[m>>2]|0)|0;break a}while(0);do if((d[c[l>>2]>>0]|0|0)!=32){if(9<=(d[c[l>>2]>>0]|0|0)?(d[c[l>>2]>>0]|0|0)<=10:0){t=20;break}if(!((c[m>>2]|0)<60?(d[c[l>>2]>>0]|0|0)==13:0))break a}else t=20;while(0);if((t|0)==20?(c[m>>2]|0)>=60:0)break;if((d[p>>0]|0|0)==60?(d[(c[l>>2]|0)+((c[m>>2]|0)+1)>>0]|0|0)!=33:0){c[r>>2]=1;while(1){if((c[r>>2]|0)>=(c[m>>2]|0))break;do if((d[(c[l>>2]|0)+(c[r>>2]|0)>>0]|0|0)!=32){if(9<=(d[(c[l>>2]|0)+(c[r>>2]|0)>>0]|0|0)?(d[(c[l>>2]|0)+(c[r>>2]|0)>>0]|0|0)<=10:0)break;if((d[(c[l>>2]|0)+(c[r>>2]|0)>>0]|0|0)!=13)break a}while(0);c[r>>2]=(c[r>>2]|0)+1}c[o>>2]=AP(c[(c[k>>2]|0)+296>>2]|0,c[l>>2]|0,c[m>>2]|0)|0}}while(0);c[(c[n>>2]|0)+4>>2]=3;c[(c[n>>2]|0)+8>>2]=75104;if(!(c[o>>2]|0)){r=ly(c[l>>2]|0,c[m>>2]|0)|0;c[(c[n>>2]|0)+40>>2]=r;if(!(c[(c[n>>2]|0)+40>>2]|0)){sQ(c[k>>2]|0,198160);zb[c[135736>>2]&511](c[n>>2]|0);c[j>>2]=0;s=c[j>>2]|0;i=h;return s|0}}else c[(c[n>>2]|0)+40>>2]=c[o>>2];do if((c[(c[k>>2]|0)+280>>2]|0)!=0?(c[(c[k>>2]|0)+36>>2]|0)!=0:0){if((c[(c[(c[k>>2]|0)+36>>2]|0)+28>>2]|0)<65535){b[(c[n>>2]|0)+56>>1]=c[(c[(c[k>>2]|0)+36>>2]|0)+28>>2];break}b[(c[n>>2]|0)+56>>1]=-1;if(c[(c[k>>2]|0)+360>>2]&4194304)c[(c[n>>2]|0)+52>>2]=c[(c[(c[k>>2]|0)+36>>2]|0)+28>>2]}while(0);if((c[18774]|0)!=0&(c[33968]|0)!=0)zb[c[135872>>2]&511](c[n>>2]|0);c[j>>2]=c[n>>2];s=c[j>>2]|0;i=h;return s|0}function BQ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+32|0;h=g;j=g+24|0;k=g+20|0;l=g+16|0;m=g+12|0;n=g+8|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;if(((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+212>>2]|0)!=0:0)?(c[(c[j>>2]|0)+172>>2]|0)==-1:0){i=g;return}if(c[j>>2]|0)c[(c[j>>2]|0)+84>>2]=c[k>>2];f=c[j>>2]|0;j=c[k>>2]|0;k=c[m>>2]|0;e=c[n>>2]|0;d=c[l>>2]|0;l=c[n>>2]|0;c[h>>2]=c[m>>2];c[h+4>>2]=l;Xd(0,0,0,f,0,3,j,2,0,0,k,e,0,0,0,d,h);i=g;return}function CQ(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=e;c[l>>2]=c[j>>2];while(1){if((c[l>>2]|0)>>>0>=(c[k>>2]|0)>>>0){n=4;break}e=c[l>>2]|0;c[l>>2]=e+1;if((d[e>>0]|0|0)==38){n=5;break}}if((n|0)==4){c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}else if((n|0)==5){n=(c[h>>2]|0)+248|0;c[n>>2]=(c[n>>2]|0)+1;c[m>>2]=$e(c[h>>2]|0,c[j>>2]|0,(c[k>>2]|0)-(c[j>>2]|0)|0,1,0,0,0)|0;j=(c[h>>2]|0)+248|0;c[j>>2]=(c[j>>2]|0)+-1;c[g>>2]=c[m>>2];o=c[g>>2]|0;i=f;return o|0}return 0}function DQ(a,b){a=a|0;b=b|0;var d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;f=d+28|0;g=d+24|0;h=d+20|0;j=d+16|0;k=d+12|0;l=d+8|0;m=d+4|0;n=d;c[g>>2]=a;c[h>>2]=b;if(!(c[h>>2]|0)){c[f>>2]=0;o=c[f>>2]|0;i=d;return o|0}b=c[h>>2]|0;a:do if((c[g>>2]|0)>>>0<65536){if(!(c[b>>2]|0)){c[f>>2]=0;o=c[f>>2]|0;i=d;return o|0}c[j>>2]=0;c[k>>2]=(c[c[h>>2]>>2]|0)-1;c[m>>2]=c[(c[h>>2]|0)+8>>2];while(1){if((c[j>>2]|0)>(c[k>>2]|0))break a;c[l>>2]=((c[j>>2]|0)+(c[k>>2]|0)|0)/2|0;if((c[g>>2]&65535|0)<(e[(c[m>>2]|0)+(c[l>>2]<<2)>>1]|0|0)){c[k>>2]=(c[l>>2]|0)-1;continue}if((c[g>>2]&65535|0)<=(e[(c[m>>2]|0)+(c[l>>2]<<2)+2>>1]|0|0))break;c[j>>2]=(c[l>>2]|0)+1}c[f>>2]=1;o=c[f>>2]|0;i=d;return o|0}else{if(!(c[b+4>>2]|0)){c[f>>2]=0;o=c[f>>2]|0;i=d;return o|0}c[j>>2]=0;c[k>>2]=(c[(c[h>>2]|0)+4>>2]|0)-1;c[n>>2]=c[(c[h>>2]|0)+12>>2];while(1){if((c[j>>2]|0)>(c[k>>2]|0))break a;c[l>>2]=((c[j>>2]|0)+(c[k>>2]|0)|0)/2|0;if((c[g>>2]|0)>>>0<(c[(c[n>>2]|0)+(c[l>>2]<<3)>>2]|0)>>>0){c[k>>2]=(c[l>>2]|0)-1;continue}if((c[g>>2]|0)>>>0<=(c[(c[n>>2]|0)+(c[l>>2]<<3)+4>>2]|0)>>>0)break;c[j>>2]=(c[l>>2]|0)+1}c[f>>2]=1;o=c[f>>2]|0;i=d;return o|0}while(0);c[f>>2]=0;o=c[f>>2]|0;i=d;return o|0}function EQ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+8>>2]|0)EQ(c[(c[d>>2]|0)+8>>2]|0);if(c[(c[d>>2]|0)+32>>2]|0)TQ(c[(c[d>>2]|0)+32>>2]|0);if(c[(c[d>>2]|0)+12>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+12>>2]|0);if(c[(c[d>>2]|0)+28>>2]|0){a:do if(!(c[(c[d>>2]|0)+4>>2]|0)){c[f>>2]=0;while(1){if((c[f>>2]|0)>=(c[(c[d>>2]|0)+20>>2]|0))break a;c[e>>2]=(c[(c[d>>2]|0)+28>>2]|0)+((c[f>>2]|0)*12|0);if(c[(c[e>>2]|0)+4>>2]|0)zb[c[135736>>2]&511](c[(c[e>>2]|0)+4>>2]|0);if(c[(c[e>>2]|0)+8>>2]|0)zb[c[135736>>2]&511](c[(c[e>>2]|0)+8>>2]|0);c[f>>2]=(c[f>>2]|0)+1}}while(0);zb[c[135736>>2]&511](c[(c[d>>2]|0)+28>>2]|0)}if(c[(c[d>>2]|0)+4>>2]|0)zP(c[(c[d>>2]|0)+4>>2]|0);f=(c[d>>2]|0)+0|0;e=f+36|0;do{c[f>>2]=-1;f=f+4|0}while((f|0)<(e|0));zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function FQ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;while(1){if(!(c[d>>2]|0))break;c[e>>2]=c[d>>2];c[d>>2]=c[(c[d>>2]|0)+8>>2];c[(c[e>>2]|0)+8>>2]=0;EQ(c[e>>2]|0)}i=b;return}function GQ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;while(1){if(!(c[d>>2]|0))break;c[e>>2]=c[c[d>>2]>>2];if(c[(c[d>>2]|0)+20>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+20>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);c[d>>2]=c[e>>2]}i=b;return}function HQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=UQ(c[f>>2]|0,c[g>>2]|0,c[h>>2]|0,1)|0;i=e;return d|0}function IQ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;e=UQ(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0)|0;i=f;return e|0}function JQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=UQ(c[f>>2]|0,c[g>>2]|0,c[h>>2]|0,2)|0;i=e;return d|0}function KQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;if(!(c[e>>2]|0)){c[d>>2]=-1;h=c[d>>2]|0;i=b;return h|0}while(1){if(!(c[e>>2]|0))break;if((c[(c[e>>2]|0)+28>>2]|0)==(c[(c[e>>2]|0)+16>>2]|0))c[(c[e>>2]|0)+28>>2]=-1;if(c[(c[e>>2]|0)+16>>2]|0){a=(c[e>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+-1}c[f>>2]=(c[(c[e>>2]|0)+8>>2]|0)-1;while(1){if((c[f>>2]|0)<0)break;c[g>>2]=c[(c[(c[e>>2]|0)+20>>2]|0)+((c[f>>2]<<1)+1<<2)>>2];if((c[g>>2]|0)>(c[(c[e>>2]|0)+16>>2]|0)){a=(c[e>>2]|0)+8|0;c[a>>2]=(c[a>>2]|0)+-1}if((c[g>>2]|0)<=(c[(c[e>>2]|0)+16>>2]|0))break;c[f>>2]=(c[f>>2]|0)+-1}c[e>>2]=c[c[e>>2]>>2]}c[d>>2]=0;h=c[d>>2]|0;i=b;return h|0}function LQ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;do if(c[e>>2]|0){while(1){if(!(c[e>>2]|0)){f=7;break}if(c[(c[(c[e>>2]|0)+4>>2]|0)+16>>2]&16384){f=5;break}c[e>>2]=c[c[e>>2]>>2]}if((f|0)==5){c[d>>2]=1;break}else if((f|0)==7){c[d>>2]=0;break}}else c[d>>2]=-1;while(0);i=b;return c[d>>2]|0}function MQ(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;g=i;i=i+64|0;h=g+48|0;j=g+44|0;k=g+40|0;l=g+36|0;m=g+32|0;n=g+28|0;o=g+24|0;p=g+20|0;q=g+16|0;r=g+12|0;s=g+8|0;t=g+4|0;u=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=0;c[p>>2]=0;c[s>>2]=0;c[t>>2]=0;c[u>>2]=1;if(!(c[j>>2]|0)){c[h>>2]=0;v=c[h>>2]|0;i=g;return v|0}c[r>>2]=c[j>>2];c[q>>2]=c[r>>2];while(1){if(!(d[c[q>>2]>>0]|0)){w=41;break}c[s>>2]=0;while(1){if(d[c[q>>2]>>0]|0)x=(d[c[q>>2]>>0]|0|0)!=124;else x=0;y=c[q>>2]|0;if(!x)break;c[q>>2]=y+1}j=c[r>>2]|0;if(!(d[y>>0]|0))c[p>>2]=VQ(j,c[k>>2]|0,c[m>>2]|0)|0;else{c[s>>2]=ly(j,(c[q>>2]|0)-(c[r>>2]|0)|0)|0;if(c[s>>2]|0)c[p>>2]=VQ(c[s>>2]|0,c[k>>2]|0,c[m>>2]|0)|0;c[q>>2]=(c[q>>2]|0)+1}if(!(c[p>>2]|0)){w=48;break}c[o>>2]=WQ()|0;if(!(c[o>>2]|0)){w=48;break}if(c[k>>2]|0){c[(c[o>>2]|0)+4>>2]=c[k>>2];yP(c[k>>2]|0)|0}if(!(c[n>>2]|0))c[n>>2]=c[o>>2];else{c[(c[o>>2]|0)+8>>2]=c[(c[n>>2]|0)+8>>2];c[(c[n>>2]|0)+8>>2]=c[o>>2]}c[(c[o>>2]|0)+16>>2]=c[l>>2];c[(c[p>>2]|0)+16>>2]=c[o>>2];j=c[p>>2]|0;if(c[(c[o>>2]|0)+16>>2]&6)XQ(j);else YQ(j);if(c[(c[p>>2]|0)+8>>2]|0){w=48;break}ZQ(c[p>>2]|0);c[p>>2]=0;do if(c[u>>2]|0){if(!(c[t>>2]|0)){c[t>>2]=c[(c[o>>2]|0)+16>>2]&768;break}if((c[t>>2]|0)==256){if(!(c[(c[o>>2]|0)+16>>2]&512))break;c[u>>2]=0;break}if((c[t>>2]|0)==512?(c[(c[o>>2]|0)+16>>2]&256|0)!=0:0)c[u>>2]=0}while(0);if(c[u>>2]|0)_Q(c[o>>2]|0)|0;if(($Q(c[o>>2]|0)|0)<0){w=48;break}if(c[s>>2]|0){zb[c[135736>>2]&511](c[s>>2]|0);c[s>>2]=0}c[r>>2]=c[q>>2]}if((w|0)==41){a:do if(!(c[u>>2]|0)){c[o>>2]=c[n>>2];while(1){if(!(c[o>>2]|0))break a;if(c[(c[o>>2]|0)+32>>2]|0){TQ(c[(c[o>>2]|0)+32>>2]|0);c[(c[o>>2]|0)+32>>2]=0}c[o>>2]=c[(c[o>>2]|0)+8>>2]}}while(0);c[h>>2]=c[n>>2];v=c[h>>2]|0;i=g;return v|0}else if((w|0)==48){if(c[p>>2]|0)ZQ(c[p>>2]|0);if(c[n>>2]|0)EQ(c[n>>2]|0);if(c[s>>2]|0)zb[c[135736>>2]&511](c[s>>2]|0);c[h>>2]=0;v=c[h>>2]|0;i=g;return v|0}return 0}function NQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){c[e>>2]=-1;j=c[e>>2]|0;i=d;return j|0}while(1){if(!(c[f>>2]|0)){k=7;break}c[h>>2]=aR(c[f>>2]|0,c[g>>2]|0)|0;if(c[h>>2]|0){k=5;break}c[f>>2]=c[(c[f>>2]|0)+8>>2]}if((k|0)==5){c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}else if((k|0)==7){c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}return 0}function OQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;c[f>>2]=0;if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+32>>2]|0)!=0:0){while(1){if(!(c[e>>2]|0)){h=11;break}if(!(c[(c[e>>2]|0)+32>>2]|0)){h=12;break}c[g>>2]=bR(c[(c[e>>2]|0)+32>>2]|0)|0;if(!(c[g>>2]|0)){h=12;break}if(!(c[f>>2]|0))c[f>>2]=c[g>>2];else{c[c[g>>2]>>2]=c[c[f>>2]>>2];c[c[f>>2]>>2]=c[g>>2]}c[(c[g>>2]|0)+24>>2]=c[(c[e>>2]|0)+16>>2];c[e>>2]=c[(c[e>>2]|0)+8>>2]}if((h|0)==11){c[d>>2]=c[f>>2];j=c[d>>2]|0;i=b;return j|0}else if((h|0)==12){GQ(c[f>>2]|0);c[d>>2]=0;j=c[d>>2]|0;i=b;return j|0}}c[d>>2]=0;j=c[d>>2]|0;i=b;return j|0}function PQ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;do if(c[e>>2]|0){while(1){if(!(c[e>>2]|0)){f=7;break}if(!(c[(c[e>>2]|0)+32>>2]|0)){f=5;break}c[e>>2]=c[(c[e>>2]|0)+8>>2]}if((f|0)==5){c[d>>2]=0;break}else if((f|0)==7){c[d>>2]=1;break}}else c[d>>2]=-1;while(0);i=b;return c[d>>2]|0}function QQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;c[f>>2]=0;if(!(c[e>>2]|0)){c[d>>2]=-1;h=c[d>>2]|0;i=b;return h|0}a:while(1){if(!(c[e>>2]|0)){j=14;break}if(!(c[(c[e>>2]|0)+32>>2]|0)){j=5;break}c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[(c[(c[e>>2]|0)+32>>2]|0)+4>>2]|0))break;if(c[(c[(c[(c[e>>2]|0)+32>>2]|0)+12>>2]|0)+(c[g>>2]<<4)>>2]&1){j=9;break a}c[g>>2]=(c[g>>2]|0)+1}if((c[(c[(c[e>>2]|0)+32>>2]|0)+4>>2]|0)>(c[f>>2]|0))c[f>>2]=c[(c[(c[e>>2]|0)+32>>2]|0)+4>>2];c[e>>2]=c[(c[e>>2]|0)+8>>2]}if((j|0)==5){c[d>>2]=-1;h=c[d>>2]|0;i=b;return h|0}else if((j|0)==9){c[d>>2]=-2;h=c[d>>2]|0;i=b;return h|0}else if((j|0)==14){c[d>>2]=c[f>>2];h=c[d>>2]|0;i=b;return h|0}return 0}function RQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=12345678;if(!(c[e>>2]|0)){c[d>>2]=-1;g=c[d>>2]|0;i=b;return g|0}while(1){if(!(c[e>>2]|0)){h=11;break}if(!(c[(c[e>>2]|0)+32>>2]|0)){h=5;break}if((c[(c[(c[e>>2]|0)+32>>2]|0)+4>>2]|0)<(c[f>>2]|0))c[f>>2]=c[(c[(c[e>>2]|0)+32>>2]|0)+4>>2];if(!(c[f>>2]|0)){h=9;break}c[e>>2]=c[(c[e>>2]|0)+8>>2]}if((h|0)==5){c[d>>2]=-1;g=c[d>>2]|0;i=b;return g|0}else if((h|0)==9){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else if((h|0)==11){c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function SQ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;do if(c[e>>2]|0){while(1){if(!(c[e>>2]|0)){f=9;break}if(!(c[(c[e>>2]|0)+32>>2]|0)){f=5;break}if(c[(c[e>>2]|0)+16>>2]&256){f=7;break}c[e>>2]=c[(c[e>>2]|0)+8>>2]}if((f|0)==5){c[d>>2]=-1;break}else if((f|0)==7){c[d>>2]=1;break}else if((f|0)==9){c[d>>2]=0;break}}else c[d>>2]=-1;while(0);i=b;return c[d>>2]|0}function TQ(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+12>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+12>>2]|0);if(c[c[d>>2]>>2]|0)zP(c[c[d>>2]>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function UQ(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;i=i+80|0;h=g+72|0;j=g+68|0;k=g+64|0;l=g+60|0;m=g+56|0;n=g+52|0;o=g+48|0;p=g+44|0;q=g+40|0;r=g+36|0;s=g+32|0;t=g+28|0;u=g+24|0;v=g+20|0;w=g+16|0;x=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=0;c[o>>2]=0;c[p>>2]=0;if((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+8>>2]|0)>=0:0){a:while(1){if(!(c[j>>2]|0))break;c[w>>2]=c[(c[j>>2]|0)+4>>2];if((c[m>>2]|0)==1&(c[k>>2]|0)==0&(c[l>>2]|0)==0){c[(c[j>>2]|0)+8>>2]=0;c[(c[j>>2]|0)+16>>2]=0;c[(c[j>>2]|0)+28>>2]=-1;do if(c[(c[w>>2]|0)+16>>2]&32768){if(!(c[(c[w>>2]|0)+4>>2]|0)){c[n>>2]=1;break}if(((c[(c[w>>2]|0)+4>>2]|0)==1?(c[(c[(c[w>>2]|0)+12>>2]|0)+12>>2]|0)==100:0)?(c[c[(c[w>>2]|0)+12>>2]>>2]&1|0)!=0:0){c[n>>2]=1;break}if((c[c[(c[w>>2]|0)+12>>2]>>2]&4|0)!=0?(c[q>>2]=cR(c[j>>2]|0,0,0)|0,(c[q>>2]|0)<0):0)c[o>>2]=(c[o>>2]|0)+1}while(0);c[j>>2]=c[c[j>>2]>>2];continue}f=c[j>>2]|0;b:do if(c[(c[w>>2]|0)+4>>2]|0){if((c[f+28>>2]|0)!=-1){e=(c[j>>2]|0)+16|0;c[e>>2]=(c[e>>2]|0)+1;break}if((c[m>>2]|0)!=1&(c[m>>2]|0)!=2?(c[(c[w>>2]|0)+16>>2]&16384|0)==0:0){e=(c[j>>2]|0)+16|0;c[e>>2]=(c[e>>2]|0)+1;break}c[r>>2]=0;c[s>>2]=c[(c[j>>2]|0)+8>>2];while(1){if((c[r>>2]|0)>=(c[s>>2]|0))break;if(c[(c[w>>2]|0)+16>>2]&65536){c[u>>2]=c[(c[(c[j>>2]|0)+20>>2]|0)+(c[r>>2]<<1<<2)>>2];if(((c[u>>2]|0)>=0?(c[q>>2]=c[(c[(c[j>>2]|0)+20>>2]|0)+((c[r>>2]<<1)+1<<2)>>2],(c[q>>2]|0)<=(c[(c[j>>2]|0)+16>>2]|0)):0)?(c[v>>2]=c[(c[(c[w>>2]|0)+12>>2]|0)+(c[u>>2]<<4)>>2]&1,(c[v>>2]|0)!=0?1:(c[q>>2]|0)>=(c[(c[j>>2]|0)+16>>2]|0)):0)y=39}else{c[u>>2]=c[(c[(c[j>>2]|0)+20>>2]|0)+((c[(c[j>>2]|0)+8>>2]|0)-1<<1<<2)>>2];if((c[(c[(c[j>>2]|0)+20>>2]|0)+(((c[(c[j>>2]|0)+8>>2]|0)-1<<1)+1<<2)>>2]|0)<(c[(c[j>>2]|0)+16>>2]|0)){y=34;break a}c[v>>2]=0;c[r>>2]=c[s>>2];y=39}c:do if((y|0)==39){y=0;e=(c[(c[w>>2]|0)+12>>2]|0)+(c[u>>2]<<4)|0;c[x+0>>2]=c[e+0>>2];c[x+4>>2]=c[e+4>>2];c[x+8>>2]=c[e+8>>2];c[x+12>>2]=c[e+12>>2];do if((c[x+12>>2]|0)!=(c[m>>2]|0)){if((c[x+12>>2]|0)!=2)if((c[x+12>>2]|0)!=100)break c;else break;if(c[(c[w>>2]|0)+16>>2]&65536)break c;c[(c[j>>2]|0)+28>>2]=(c[(c[j>>2]|0)+16>>2]|0)+1;break c}while(0);c[t>>2]=0;do if((c[x+12>>2]|0)!=100){e=c[x+8>>2]|0;if(!(c[x+4>>2]|0)){if(!e){c[t>>2]=1;break}if(!(c[l>>2]|0))break;c[t>>2]=qy(c[x+8>>2]|0,c[l>>2]|0)|0;break}if(((c[k>>2]|0)!=0?((e|0)!=0|0)==((c[l>>2]|0)!=0|0):0)?(d[c[x+4>>2]>>0]|0|0)==(d[c[k>>2]>>0]|0|0):0){if(!(qy(c[x+4>>2]|0,c[k>>2]|0)|0))break;if((c[x+8>>2]|0)!=(c[l>>2]|0)?(qy(c[x+8>>2]|0,c[l>>2]|0)|0)==0:0)break;c[t>>2]=1}}else c[t>>2]=1;while(0);do if(c[t>>2]|0){c[p>>2]=c[x>>2]&2;e=(c[p>>2]|0)!=0;do if(c[v>>2]|0)if(e){c[n>>2]=1;break}else{cR(c[j>>2]|0,(c[u>>2]|0)+1|0,(c[(c[j>>2]|0)+16>>2]|0)+1|0)|0;break}else if(e){c[n>>2]=1;break}else{cR(c[j>>2]|0,(c[u>>2]|0)+1|0,(c[(c[j>>2]|0)+16>>2]|0)+1|0)|0;break}while(0);if((c[n>>2]|0)!=1){if(!(c[x>>2]&32))break;c[n>>2]=1}}while(0);if((c[(c[w>>2]|0)+16>>2]&65536|0)==0?(c[t>>2]|0)==0|(c[p>>2]|0)!=0:0)c[(c[j>>2]|0)+28>>2]=(c[(c[j>>2]|0)+16>>2]|0)+1}while(0);c[r>>2]=(c[r>>2]|0)+1}e=(c[j>>2]|0)+16|0;c[e>>2]=(c[e>>2]|0)+1;e=c[(c[w>>2]|0)+12>>2]|0;c[x+0>>2]=c[e+0>>2];c[x+4>>2]=c[e+4>>2];c[x+8>>2]=c[e+8>>2];c[x+12>>2]=c[e+12>>2];if(!(c[x>>2]&4)){c[v>>2]=c[x>>2]&1;do if(c[(c[j>>2]|0)+24>>2]&7){if((c[(c[j>>2]|0)+16>>2]|0)==1)if(c[(c[j>>2]|0)+24>>2]&6)break b;else break;if(!(c[v>>2]|0)){if((c[(c[j>>2]|0)+16>>2]|0)!=2)break b;if(!(c[(c[j>>2]|0)+24>>2]&6))break b}}while(0);if((c[x+12>>2]|0)!=(c[m>>2]|0)){if((c[m>>2]|0)==2)break;if((c[x+12>>2]|0)!=100)break}c[t>>2]=0;do if((c[x+12>>2]|0)!=100){e=c[x+8>>2]|0;if(!(c[x+4>>2]|0)){if(!e){c[t>>2]=1;break}if(!(c[l>>2]|0))break;c[t>>2]=qy(c[x+8>>2]|0,c[l>>2]|0)|0;break}if((((c[k>>2]|0)!=0?((e|0)!=0|0)==((c[l>>2]|0)!=0|0):0)?(d[c[x+4>>2]>>0]|0|0)==(d[c[k>>2]>>0]|0|0):0)?(qy(c[x+4>>2]|0,c[k>>2]|0)|0)!=0:0){if((c[x+8>>2]|0)!=(c[l>>2]|0)?(qy(c[x+8>>2]|0,c[l>>2]|0)|0)==0:0)break;c[t>>2]=1}}else c[t>>2]=1;while(0);c[p>>2]=c[x>>2]&2;if(c[t>>2]|0){if(c[p>>2]|0)c[n>>2]=1;else cR(c[j>>2]|0,1,c[(c[j>>2]|0)+16>>2]|0)|0;if((c[n>>2]|0)!=1?(c[x>>2]&32|0)!=0:0)c[n>>2]=1}if((c[(c[w>>2]|0)+16>>2]&65536|0)==0?(c[t>>2]|0)==0|(c[p>>2]|0)!=0:0)c[(c[j>>2]|0)+28>>2]=c[(c[j>>2]|0)+16>>2]}}else{if(c[f+24>>2]&1){c[j>>2]=c[c[j>>2]>>2];continue a}do if((c[m>>2]|0)!=2){if((c[(c[j>>2]|0)+24>>2]&7|0)!=0?(c[(c[j>>2]|0)+16>>2]|0)!=0:0)break;c[n>>2]=1}while(0);e=(c[j>>2]|0)+16|0;c[e>>2]=(c[e>>2]|0)+1}while(0);c[j>>2]=c[c[j>>2]>>2]}if((y|0)==34){c[h>>2]=-1;z=c[h>>2]|0;i=g;return z|0}if((c[o>>2]|0)>0)c[n>>2]=-1;c[h>>2]=c[n>>2];z=c[h>>2]|0;i=g;return z|0}c[h>>2]=-1;z=c[h>>2]|0;i=g;return z|0}function VQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(!(c[g>>2]|0)){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}c[k>>2]=Cb[c[135744>>2]&511](32)|0;if(!(c[k>>2]|0)){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}d=c[k>>2]|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=0;c[d+28>>2]=0;c[(c[k>>2]|0)+12>>2]=c[h>>2];c[c[k>>2]>>2]=c[g>>2];c[(c[k>>2]|0)+4>>2]=c[g>>2];if(c[j>>2]|0){c[l>>2]=0;while(1){n=c[l>>2]|0;if(!(c[(c[j>>2]|0)+(c[l>>2]<<1<<2)>>2]|0))break;c[l>>2]=n+1}c[(c[k>>2]|0)+28>>2]=n}else c[(c[k>>2]|0)+28>>2]=0;c[(c[k>>2]|0)+24>>2]=c[j>>2];c[f>>2]=c[k>>2];m=c[f>>2]|0;i=e;return m|0}function WQ(){var a=0,b=0,d=0,e=0,f=0,g=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=Cb[c[135744>>2]&511](36)|0;if(!(c[d>>2]|0)){c[b>>2]=0;e=c[b>>2]|0;i=a;return e|0}f=(c[d>>2]|0)+0|0;g=f+36|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));c[(c[d>>2]|0)+24>>2]=10;f=Cb[c[135744>>2]&511]((c[(c[d>>2]|0)+24>>2]|0)*12|0)|0;c[(c[d>>2]|0)+28>>2]=f;if(!(c[(c[d>>2]|0)+28>>2]|0)){zb[c[135736>>2]&511](c[d>>2]|0);c[b>>2]=0;e=c[b>>2]|0;i=a;return e|0}else{c[b>>2]=c[d>>2];e=c[b>>2]|0;i=a;return e|0}return 0}function XQ(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+16|0;e=b;c[e>>2]=a;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)f=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){f=1;break}f=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);g=d[c[c[e>>2]>>2]>>0]|0;if(!f)break;a=c[e>>2]|0;if(!g)continue;c[a>>2]=(c[a>>2]|0)+1}a:do if((g|0)!=47){f=(c[(c[e>>2]|0)+16>>2]|0)+16|0;c[f>>2]=c[f>>2]|512;if((d[c[c[e>>2]>>2]>>0]|0|0)==46){f=c[e>>2]|0;if(d[c[c[e>>2]>>2]>>0]|0)c[f>>2]=(c[f>>2]|0)+1;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)h=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){h=1;break}h=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);j=d[c[c[e>>2]>>2]>>0]|0;if(!h)break;f=c[e>>2]|0;if(!j)continue;c[f>>2]=(c[f>>2]|0)+1}f=c[e>>2]|0;if(!j){if(dR(f,c[(c[e>>2]|0)+16>>2]|0,2,0,0)|0)break;i=b;return}if((d[c[f>>2]>>0]|0|0)!=47)break;f=c[e>>2]|0;if(d[c[c[e>>2]>>2]>>0]|0)c[f>>2]=(c[f>>2]|0)+1;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)k=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){k=1;break}k=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);l=d[c[c[e>>2]>>2]>>0]|0;if(!k)break;f=c[e>>2]|0;if(!l)continue;c[f>>2]=(c[f>>2]|0)+1}b:do if((l|0)==47){if((d[(c[c[e>>2]>>2]|0)+-1>>0]|0|0)==32)break a;if(9<=(d[(c[c[e>>2]>>2]|0)+-1>>0]|0|0)?(d[(c[c[e>>2]>>2]|0)+-1>>0]|0|0)<=10:0)break a;if((d[(c[c[e>>2]>>2]|0)+-1>>0]|0|0)==13)break a;if(dR(c[e>>2]|0,c[(c[e>>2]|0)+16>>2]|0,6,0,0)|0)break a;f=c[e>>2]|0;if(d[c[c[e>>2]>>2]>>0]|0)c[f>>2]=(c[f>>2]|0)+1;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[e>>2]>>2]>>0]|0|0)!=13)break b}while(0);f=c[e>>2]|0;if(!(d[c[c[e>>2]>>2]>>0]|0))continue;c[f>>2]=(c[f>>2]|0)+1}}while(0);if(d[c[c[e>>2]>>2]>>0]|0)m=47}else m=47;c:do if((m|0)==47){while(1){m=0;eR(c[e>>2]|0);if(c[(c[e>>2]|0)+8>>2]|0)break a;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)n=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){n=1;break}n=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);o=d[c[c[e>>2]>>2]>>0]|0;if(!n)break;f=c[e>>2]|0;if(!o)continue;c[f>>2]=(c[f>>2]|0)+1}if((o|0)!=47)break;if(dR(c[e>>2]|0,c[(c[e>>2]|0)+16>>2]|0,5,0,0)|0)break a;f=c[e>>2]|0;if(d[c[c[e>>2]>>2]>>0]|0)c[f>>2]=(c[f>>2]|0)+1;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)p=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){p=1;break}p=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);q=d[c[c[e>>2]>>2]>>0]|0;if(!p)break;f=c[e>>2]|0;if(!q)continue;c[f>>2]=(c[f>>2]|0)+1}if((q|0)==47)break a;if(!(d[c[c[e>>2]>>2]>>0]|0))break c;if(d[c[c[e>>2]>>2]>>0]|0)m=47;else break}if(!(d[c[c[e>>2]>>2]>>0]|0)){i=b;return}c[(c[e>>2]|0)+8>>2]=1;i=b;return}while(0);c[(c[e>>2]|0)+8>>2]=1;i=b;return}while(0);c[(c[e>>2]|0)+8>>2]=1;i=b;return}function YQ(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+16|0;e=b;c[e>>2]=a;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)f=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){f=1;break}f=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);g=d[c[c[e>>2]>>2]>>0]|0;if(!f)break;a=c[e>>2]|0;if(!g)continue;c[a>>2]=(c[a>>2]|0)+1}f=c[e>>2]|0;do if((g|0)==47){a=(c[f+16>>2]|0)+16|0;c[a>>2]=c[a>>2]|256}else{if((d[c[f>>2]>>0]|0|0)!=46?(c[(c[(c[e>>2]|0)+16>>2]|0)+16>>2]&7|0)==0:0)break;a=(c[(c[e>>2]|0)+16>>2]|0)+16|0;
c[a>>2]=c[a>>2]|512}while(0);if((d[c[c[e>>2]>>2]>>0]|0|0)==47?(d[(c[c[e>>2]>>2]|0)+1>>0]|0|0)==47:0){if(dR(c[e>>2]|0,c[(c[e>>2]|0)+16>>2]|0,6,0,0)|0){i=b;return}f=c[e>>2]|0;if(d[c[c[e>>2]>>2]>>0]|0)c[f>>2]=(c[f>>2]|0)+1;f=c[e>>2]|0;if(d[c[c[e>>2]>>2]>>0]|0)c[f>>2]=(c[f>>2]|0)+1}else h=21;if((((h|0)==21?(d[c[c[e>>2]>>2]>>0]|0|0)==46:0)?(d[(c[c[e>>2]>>2]|0)+1>>0]|0|0)==47:0)?(d[(c[c[e>>2]>>2]|0)+2>>0]|0|0)==47:0){if(dR(c[e>>2]|0,c[(c[e>>2]|0)+16>>2]|0,6,0,0)|0){i=b;return}f=c[e>>2]|0;if(d[c[c[e>>2]>>2]>>0]|0)c[f>>2]=(c[f>>2]|0)+1;f=c[e>>2]|0;if(d[c[c[e>>2]>>2]>>0]|0)c[f>>2]=(c[f>>2]|0)+1;f=c[e>>2]|0;if(d[c[c[e>>2]>>2]>>0]|0)c[f>>2]=(c[f>>2]|0)+1;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)j=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){j=1;break}j=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);k=d[c[c[e>>2]>>2]>>0]|0;if(!j)break;f=c[e>>2]|0;if(!k)continue;c[f>>2]=(c[f>>2]|0)+1}if(!k){c[(c[e>>2]|0)+8>>2]=1;i=b;return}}k=d[c[c[e>>2]>>2]>>0]|0;a:do if((d[c[c[e>>2]>>2]>>0]|0|0)==64){j=c[e>>2]|0;if(k)c[j>>2]=(c[j>>2]|0)+1;fR(c[e>>2]|0);while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)l=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){l=1;break}l=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);m=(d[c[c[e>>2]>>2]>>0]|0|0)!=0;if(!l)break;j=c[e>>2]|0;if(!m)continue;c[j>>2]=(c[j>>2]|0)+1}if(m?(eR(c[e>>2]|0),(c[(c[e>>2]|0)+8>>2]|0)!=0):0){i=b;return}}else{if((k|0)==47){if(dR(c[e>>2]|0,c[(c[e>>2]|0)+16>>2]|0,1,0,0)|0){i=b;return}j=c[e>>2]|0;if(d[c[c[e>>2]>>2]>>0]|0)c[j>>2]=(c[j>>2]|0)+1;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)n=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){n=1;break}n=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);o=d[c[c[e>>2]>>2]>>0]|0;if(!n)break;j=c[e>>2]|0;if(!o)continue;c[j>>2]=(c[j>>2]|0)+1}if(!o){c[(c[e>>2]|0)+8>>2]=1;i=b;return}}eR(c[e>>2]|0);if(c[(c[e>>2]|0)+8>>2]|0){i=b;return}b:while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[e>>2]>>2]>>0]|0|0)!=13)break b}while(0);j=c[e>>2]|0;if(!(d[c[c[e>>2]>>2]>>0]|0))continue;c[j>>2]=(c[j>>2]|0)+1}while(1){if((d[c[c[e>>2]>>2]>>0]|0|0)!=47)break a;j=c[e>>2]|0;f=c[(c[e>>2]|0)+16>>2]|0;if((d[(c[c[e>>2]>>2]|0)+1>>0]|0|0)!=47){if(dR(j,f,5,0,0)|0){h=103;break}g=c[e>>2]|0;if(d[c[c[e>>2]>>2]>>0]|0)c[g>>2]=(c[g>>2]|0)+1;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)p=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){p=1;break}p=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);q=d[c[c[e>>2]>>2]>>0]|0;if(!p)break;g=c[e>>2]|0;if(!q)continue;c[g>>2]=(c[g>>2]|0)+1}r=c[e>>2]|0;if(!q){h=99;break}eR(r);if(c[(c[e>>2]|0)+8>>2]|0){h=103;break}else continue}if(dR(j,f,6,0,0)|0){h=103;break}g=c[e>>2]|0;if(d[c[c[e>>2]>>2]>>0]|0)c[g>>2]=(c[g>>2]|0)+1;g=c[e>>2]|0;if(d[c[c[e>>2]>>2]>>0]|0)c[g>>2]=(c[g>>2]|0)+1;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)s=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){s=1;break}s=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);t=c[e>>2]|0;if(!s)break;g=c[e>>2]|0;if(!(d[c[t>>2]>>0]|0))continue;c[g>>2]=(c[g>>2]|0)+1}eR(t);if(c[(c[e>>2]|0)+8>>2]|0){h=103;break}}if((h|0)==99){c[r+8>>2]=1;i=b;return}else if((h|0)==103){i=b;return}}while(0);if(!(d[c[c[e>>2]>>2]>>0]|0)){i=b;return}c[(c[e>>2]|0)+8>>2]=1;i=b;return}function ZQ(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}a=c[d>>2]|0;c[a+0>>2]=-1;c[a+4>>2]=-1;c[a+8>>2]=-1;c[a+12>>2]=-1;c[a+16>>2]=-1;c[a+20>>2]=-1;c[a+24>>2]=-1;c[a+28>>2]=-1;zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function _Q(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+48|0;d=b+40|0;e=b+36|0;f=b+32|0;g=b+28|0;h=b+24|0;j=b+20|0;k=b+16|0;l=b+12|0;m=b;c[e>>2]=a;c[h>>2]=0;c[j>>2]=0;c[k>>2]=0;c[l>>2]=-1;if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+28>>2]|0)!=0:0){if((((c[(c[e>>2]|0)+20>>2]|0)==1?(c[c[(c[e>>2]|0)+28>>2]>>2]|0)==2:0)?(c[(c[(c[e>>2]|0)+28>>2]|0)+4>>2]|0)==0:0)?(c[(c[(c[e>>2]|0)+28>>2]|0)+8>>2]|0)==0:0){c[f>>2]=gR(0)|0;if(!(c[f>>2]|0)){c[d>>2]=-1;n=c[d>>2]|0;i=b;return n|0}else{a=(c[f>>2]|0)+16|0;c[a>>2]=c[a>>2]|16384;c[(c[e>>2]|0)+32>>2]=c[f>>2];c[d>>2]=0;n=c[d>>2]|0;i=b;return n|0}}c[f>>2]=gR(((c[(c[e>>2]|0)+20>>2]|0)/2|0)+1|0)|0;if(!(c[f>>2]|0)){c[d>>2]=-1;n=c[d>>2]|0;i=b;return n|0}if(c[(c[e>>2]|0)+4>>2]|0){c[c[f>>2]>>2]=c[(c[e>>2]|0)+4>>2];yP(c[c[f>>2]>>2]|0)|0}c[g>>2]=0;if(c[(c[e>>2]|0)+16>>2]&256){a=(c[f>>2]|0)+16|0;c[a>>2]=c[a>>2]|32768}a:while(1){if((c[g>>2]|0)>=(c[(c[e>>2]|0)+20>>2]|0)){o=43;break}a=(c[(c[e>>2]|0)+28>>2]|0)+((c[g>>2]|0)*12|0)|0;c[m+0>>2]=c[a+0>>2];c[m+4>>2]=c[a+4>>2];c[m+8>>2]=c[a+8>>2];b:do switch(c[m>>2]|0){case 1:{if(c[g>>2]|0)break a;c[j>>2]=1;break}case 2:{if((c[m+4>>2]|0)==0?(c[m+8>>2]|0)==0:0){if((c[(c[e>>2]|0)+20>>2]|0)!=((c[g>>2]|0)+1|0))break b;if(!(c[k>>2]&1))break b;if((c[(c[e>>2]|0)+20>>2]|0)==((c[g>>2]|0)+1|0)){a=(c[f>>2]|0)+16|0;c[a>>2]=c[a>>2]|16384}c[k>>2]=c[k>>2]|16;c[h>>2]=hR(c[f>>2]|0,0,0,100,c[k>>2]|0)|0;if((c[h>>2]|0)<0)break a;c[k>>2]=0;if((c[l>>2]|0)==-1)break b;a=(c[(c[f>>2]|0)+12>>2]|0)+(c[l>>2]<<4)|0;c[a>>2]=c[a>>2]|32;c[l>>2]=-1;break b}c[h>>2]=hR(c[f>>2]|0,c[m+4>>2]|0,c[m+8>>2]|0,1,c[k>>2]|0)|0;if((c[h>>2]|0)<0)break a;c[l>>2]=c[h>>2];c[k>>2]=0;break}case 6:{if((c[k>>2]&1|0)==0?(c[k>>2]=c[k>>2]|1,(c[(c[f>>2]|0)+16>>2]&65536|0)==0):0){a=(c[f>>2]|0)+16|0;c[a>>2]=c[a>>2]|65536}break}case 4:{c[k>>2]=c[k>>2]|8;c[l>>2]=-1;c[h>>2]=hR(c[f>>2]|0,c[m+4>>2]|0,c[m+8>>2]|0,2,c[k>>2]|0)|0;c[k>>2]=0;if((c[h>>2]|0)<0)break a;break}case 8:{c[h>>2]=hR(c[f>>2]|0,0,0,1,c[k>>2]|0)|0;if((c[h>>2]|0)<0)break a;c[l>>2]=c[h>>2];c[k>>2]=0;break}case 7:{c[h>>2]=hR(c[f>>2]|0,0,c[m+4>>2]|0,1,c[k>>2]|0)|0;if((c[h>>2]|0)<0)break a;c[l>>2]=c[h>>2];c[k>>2]=0;break}case 3:{c[h>>2]=hR(c[f>>2]|0,c[m+4>>2]|0,c[m+8>>2]|0,1,c[k>>2]|0)|0;if((c[h>>2]|0)<0)break a;c[l>>2]=c[h>>2];c[k>>2]=0;break}default:{}}while(0);c[g>>2]=(c[g>>2]|0)+1}if((o|0)==43){if((c[j>>2]|0)==0?(c[(c[e>>2]|0)+16>>2]&7|0)==0:0){if(!(c[(c[f>>2]|0)+16>>2]&65536)){o=(c[f>>2]|0)+16|0;c[o>>2]=c[o>>2]|65536}if((c[(c[f>>2]|0)+4>>2]|0)>0?(c[c[(c[f>>2]|0)+12>>2]>>2]&1|0)==0:0){o=c[(c[f>>2]|0)+12>>2]|0;c[o>>2]=c[o>>2]|1}}if((c[(c[f>>2]|0)+4>>2]|0)>(c[h>>2]|0)){o=(c[(c[f>>2]|0)+12>>2]|0)+(c[h>>2]<<4)|0;c[o>>2]=c[o>>2]|2;if(c[j>>2]|0){j=c[(c[f>>2]|0)+12>>2]|0;c[j>>2]=c[j>>2]|4}c[(c[e>>2]|0)+32>>2]=c[f>>2];c[d>>2]=0;n=c[d>>2]|0;i=b;return n|0}}TQ(c[f>>2]|0);c[d>>2]=0;n=c[d>>2]|0;i=b;return n|0}c[d>>2]=-1;n=c[d>>2]|0;i=b;return n|0}function $Q(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b+24|0;e=b+20|0;f=b+16|0;g=b+12|0;h=b+8|0;j=b+4|0;k=b;c[e>>2]=a;if((c[(c[e>>2]|0)+20>>2]|0)>0?(c[c[(c[e>>2]|0)+28>>2]>>2]|0)==6:0){c[f>>2]=0;c[g>>2]=1;while(1){if((c[g>>2]|0)>=(c[(c[e>>2]|0)+20>>2]|0))break;c[(c[(c[e>>2]|0)+28>>2]|0)+((c[f>>2]|0)*12|0)+4>>2]=c[(c[(c[e>>2]|0)+28>>2]|0)+((c[g>>2]|0)*12|0)+4>>2];c[(c[(c[e>>2]|0)+28>>2]|0)+((c[f>>2]|0)*12|0)+8>>2]=c[(c[(c[e>>2]|0)+28>>2]|0)+((c[g>>2]|0)*12|0)+8>>2];c[(c[(c[e>>2]|0)+28>>2]|0)+((c[f>>2]|0)*12|0)>>2]=c[(c[(c[e>>2]|0)+28>>2]|0)+((c[g>>2]|0)*12|0)>>2];c[f>>2]=(c[f>>2]|0)+1;c[g>>2]=(c[g>>2]|0)+1}a=(c[e>>2]|0)+20|0;c[a>>2]=(c[a>>2]|0)+-1}do if((c[(c[e>>2]|0)+20>>2]|0)>=(c[(c[e>>2]|0)+24>>2]|0)){c[h>>2]=Hb[c[135760>>2]&511](c[(c[e>>2]|0)+28>>2]|0,(c[(c[e>>2]|0)+24>>2]<<1)*12|0)|0;if(c[h>>2]|0){c[(c[e>>2]|0)+28>>2]=c[h>>2];a=(c[e>>2]|0)+24|0;c[a>>2]=c[a>>2]<<1;break}c[d>>2]=-1;l=c[d>>2]|0;i=b;return l|0}while(0);c[f>>2]=0;c[g>>2]=(c[(c[e>>2]|0)+20>>2]|0)-1;while(1){if((c[g>>2]|0)<=(c[f>>2]|0))break;c[j>>2]=c[(c[(c[e>>2]|0)+28>>2]|0)+((c[f>>2]|0)*12|0)+4>>2];c[(c[(c[e>>2]|0)+28>>2]|0)+((c[f>>2]|0)*12|0)+4>>2]=c[(c[(c[e>>2]|0)+28>>2]|0)+((c[g>>2]|0)*12|0)+4>>2];c[(c[(c[e>>2]|0)+28>>2]|0)+((c[g>>2]|0)*12|0)+4>>2]=c[j>>2];c[j>>2]=c[(c[(c[e>>2]|0)+28>>2]|0)+((c[f>>2]|0)*12|0)+8>>2];c[(c[(c[e>>2]|0)+28>>2]|0)+((c[f>>2]|0)*12|0)+8>>2]=c[(c[(c[e>>2]|0)+28>>2]|0)+((c[g>>2]|0)*12|0)+8>>2];c[(c[(c[e>>2]|0)+28>>2]|0)+((c[g>>2]|0)*12|0)+8>>2]=c[j>>2];c[k>>2]=c[(c[(c[e>>2]|0)+28>>2]|0)+((c[f>>2]|0)*12|0)>>2];c[(c[(c[e>>2]|0)+28>>2]|0)+((c[f>>2]|0)*12|0)>>2]=c[(c[(c[e>>2]|0)+28>>2]|0)+((c[g>>2]|0)*12|0)>>2];c[(c[(c[e>>2]|0)+28>>2]|0)+((c[g>>2]|0)*12|0)>>2]=c[k>>2];c[g>>2]=(c[g>>2]|0)+-1;c[f>>2]=(c[f>>2]|0)+1}c[(c[(c[e>>2]|0)+28>>2]|0)+((c[(c[e>>2]|0)+20>>2]|0)*12|0)+4>>2]=0;c[(c[(c[e>>2]|0)+28>>2]|0)+((c[(c[e>>2]|0)+20>>2]|0)*12|0)+8>>2]=0;f=(c[e>>2]|0)+20|0;g=c[f>>2]|0;c[f>>2]=g+1;c[(c[(c[e>>2]|0)+28>>2]|0)+(g*12|0)>>2]=0;c[d>>2]=0;l=c[d>>2]|0;i=b;return l|0}function aR(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+48|0;f=e+32|0;g=e+28|0;h=e+24|0;j=e+20|0;k=e+16|0;l=e+4|0;m=e;c[g>>2]=a;c[h>>2]=b;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;if((c[g>>2]|0)==0|(c[h>>2]|0)==0){c[f>>2]=-1;n=c[f>>2]|0;i=e;return n|0}c[j>>2]=0;a:while(1){if((c[j>>2]|0)>=(c[(c[g>>2]|0)+20>>2]|0)){o=84;break}c[k>>2]=(c[(c[g>>2]|0)+28>>2]|0)+((c[j>>2]|0)*12|0);b:do switch(c[c[k>>2]>>2]|0){case 8:{if((c[(c[h>>2]|0)+4>>2]|0)==1)o=83;break}case 3:{if((((c[(c[h>>2]|0)+4>>2]|0)!=1?(c[(c[h>>2]|0)+4>>2]|0)!=9:0)?(c[(c[h>>2]|0)+4>>2]|0)!=21:0)?(c[(c[h>>2]|0)+4>>2]|0)!=13:0)break b;c[m>>2]=c[(c[h>>2]|0)+12>>2];if(c[(c[k>>2]|0)+4>>2]|0){while(1){if(!(c[m>>2]|0))break;if(((c[(c[m>>2]|0)+4>>2]|0)==1?(d[c[(c[k>>2]|0)+4>>2]>>0]|0|0)==(d[c[(c[m>>2]|0)+8>>2]>>0]|0|0):0)?(qy(c[(c[k>>2]|0)+4>>2]|0,c[(c[m>>2]|0)+8>>2]|0)|0)!=0:0)break;c[m>>2]=c[(c[m>>2]|0)+24>>2]}if(c[m>>2]|0)o=83}break}case 2:{if((c[(c[h>>2]|0)+4>>2]|0)==1)if(c[(c[k>>2]|0)+4>>2]|0){if((d[c[(c[k>>2]|0)+4>>2]>>0]|0|0)==(d[c[(c[h>>2]|0)+8>>2]>>0]|0|0)?(qy(c[(c[k>>2]|0)+4>>2]|0,c[(c[h>>2]|0)+8>>2]|0)|0)!=0:0){if(!(c[(c[h>>2]|0)+36>>2]|0))if(c[(c[k>>2]|0)+8>>2]|0)break b;else{o=83;break b}if(c[(c[(c[h>>2]|0)+36>>2]|0)+8>>2]|0){if((c[(c[k>>2]|0)+8>>2]|0)!=0?(qy(c[(c[k>>2]|0)+8>>2]|0,c[(c[(c[h>>2]|0)+36>>2]|0)+8>>2]|0)|0)!=0:0)o=83}else o=83}}else o=83;break}case 5:{if(((((c[(c[h>>2]|0)+4>>2]|0)!=9?(c[(c[h>>2]|0)+4>>2]|0)!=13:0)?(c[(c[h>>2]|0)+4>>2]|0)!=21:0)?(c[(c[h>>2]|0)+4>>2]|0)!=18:0)?(c[h>>2]=c[(c[h>>2]|0)+20>>2],(c[h>>2]|0)!=0):0)if(c[(c[k>>2]|0)+4>>2]|0){if((d[c[(c[k>>2]|0)+4>>2]>>0]|0|0)==(d[c[(c[h>>2]|0)+8>>2]>>0]|0|0)?(qy(c[(c[k>>2]|0)+4>>2]|0,c[(c[h>>2]|0)+8>>2]|0)|0)!=0:0){if(!(c[(c[h>>2]|0)+36>>2]|0))if(c[(c[k>>2]|0)+8>>2]|0)break b;else{o=83;break b}if(c[(c[(c[h>>2]|0)+36>>2]|0)+8>>2]|0){if((c[(c[k>>2]|0)+8>>2]|0)!=0?(qy(c[(c[k>>2]|0)+8>>2]|0,c[(c[(c[h>>2]|0)+36>>2]|0)+8>>2]|0)|0)!=0:0)o=83}else o=83}}else o=83;break}case 6:{if(!(c[(c[k>>2]|0)+4>>2]|0)){c[j>>2]=(c[j>>2]|0)+1;c[k>>2]=(c[(c[g>>2]|0)+28>>2]|0)+((c[j>>2]|0)*12|0);if((c[c[k>>2]>>2]|0)==1){o=84;break a}if((c[c[k>>2]>>2]|0)!=2)break b;if(!(c[(c[k>>2]|0)+4>>2]|0)){o=55;break a}}if(((((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+4>>2]|0)!=9:0)?(c[(c[h>>2]|0)+4>>2]|0)!=13:0)?(c[(c[h>>2]|0)+4>>2]|0)!=21:0)?(c[(c[h>>2]|0)+4>>2]|0)!=18:0){c[h>>2]=c[(c[h>>2]|0)+20>>2];c:while(1){if(!(c[h>>2]|0))break;do if(((c[(c[h>>2]|0)+4>>2]|0)==1?(d[c[(c[k>>2]|0)+4>>2]>>0]|0|0)==(d[c[(c[h>>2]|0)+8>>2]>>0]|0|0):0)?(qy(c[(c[k>>2]|0)+4>>2]|0,c[(c[h>>2]|0)+8>>2]|0)|0)!=0:0){if(!(c[(c[h>>2]|0)+36>>2]|0))if(!(c[(c[k>>2]|0)+8>>2]|0))break c;else break;if(((c[(c[(c[h>>2]|0)+36>>2]|0)+8>>2]|0)!=0?(c[(c[k>>2]|0)+8>>2]|0)!=0:0)?(qy(c[(c[k>>2]|0)+8>>2]|0,c[(c[(c[h>>2]|0)+36>>2]|0)+8>>2]|0)|0)!=0:0)break c}while(0);c[h>>2]=c[(c[h>>2]|0)+20>>2]}if(c[h>>2]|0){b=c[j>>2]|0;if((c[c[k>>2]>>2]|0)==6){iR(l,b,c[h>>2]|0)|0;o=83;break b}else{iR(l,b-1|0,c[h>>2]|0)|0;o=83;break b}}}break}case 1:{if((c[(c[h>>2]|0)+4>>2]|0)!=18){c[h>>2]=c[(c[h>>2]|0)+20>>2];if(!(((c[(c[h>>2]|0)+4>>2]|0)!=9?(c[(c[h>>2]|0)+4>>2]|0)!=21:0)?(c[(c[h>>2]|0)+4>>2]|0)!=13:0))o=83}break}case 4:{if((c[(c[h>>2]|0)+4>>2]|0)==2){if(c[(c[k>>2]|0)+4>>2]|0){if((d[c[(c[k>>2]|0)+4>>2]>>0]|0|0)!=(d[c[(c[h>>2]|0)+8>>2]>>0]|0|0))break b;if(!(qy(c[(c[k>>2]|0)+4>>2]|0,c[(c[h>>2]|0)+8>>2]|0)|0))break b}b=(c[(c[k>>2]|0)+8>>2]|0)!=0;if(!(c[(c[h>>2]|0)+36>>2]|0))if(b)break b;else{o=83;break b}if(!(b?(qy(c[(c[k>>2]|0)+8>>2]|0,c[(c[(c[h>>2]|0)+36>>2]|0)+8>>2]|0)|0)==0:0))o=83}break}case 7:{if((c[(c[h>>2]|0)+4>>2]|0)==1){if(!(c[(c[h>>2]|0)+36>>2]|0))if(c[(c[k>>2]|0)+4>>2]|0)break b;else{o=83;break b}if(c[(c[(c[h>>2]|0)+36>>2]|0)+8>>2]|0){if((c[(c[k>>2]|0)+4>>2]|0)!=0?(qy(c[(c[k>>2]|0)+4>>2]|0,c[(c[(c[h>>2]|0)+36>>2]|0)+8>>2]|0)|0)!=0:0)o=83}else o=83}break}case 0:{o=84;break a;break}default:o=83}while(0);if((o|0)==83){o=0;c[j>>2]=(c[j>>2]|0)+1;continue}if(!(c[l+8>>2]|0)){o=88;break}if((c[l>>2]|0)<=0){o=90;break}c[l>>2]=(c[l>>2]|0)+-1;c[j>>2]=c[(c[l+8>>2]|0)+(c[l>>2]<<3)>>2];c[h>>2]=c[(c[l+8>>2]|0)+(c[l>>2]<<3)+4>>2]}if((o|0)==55){c[f>>2]=-1;n=c[f>>2]|0;i=e;return n|0}else if((o|0)==84){if(c[l+8>>2]|0)zb[c[135736>>2]&511](c[l+8>>2]|0);c[f>>2]=1;n=c[f>>2]|0;i=e;return n|0}else if((o|0)==88){c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}else if((o|0)==90){zb[c[135736>>2]&511](c[l+8>>2]|0);c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}return 0}function bR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](32)|0;if(!(c[f>>2]|0)){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}a=c[f>>2]|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;c[a+24>>2]=0;c[a+28>>2]=0;a=Cb[c[135744>>2]&511](32)|0;c[(c[f>>2]|0)+20>>2]=a;if(!(c[(c[f>>2]|0)+20>>2]|0)){zb[c[135736>>2]&511](c[f>>2]|0);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{c[(c[f>>2]|0)+8>>2]=0;c[(c[f>>2]|0)+12>>2]=4;c[(c[f>>2]|0)+16>>2]=0;c[(c[f>>2]|0)+4>>2]=c[e>>2];c[(c[f>>2]|0)+28>>2]=-1;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function cR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[(c[g>>2]|0)+8>>2]|0))break;if((c[(c[(c[g>>2]|0)+20>>2]|0)+(c[k>>2]<<1<<2)>>2]|0)<0){m=4;break}c[k>>2]=(c[k>>2]|0)+1}if((m|0)==4){c[(c[(c[g>>2]|0)+20>>2]|0)+(c[k>>2]<<1<<2)>>2]=c[h>>2];c[(c[(c[g>>2]|0)+20>>2]|0)+((c[k>>2]<<1)+1<<2)>>2]=c[j>>2];c[f>>2]=c[k>>2];n=c[f>>2]|0;i=e;return n|0}do if((c[(c[g>>2]|0)+8>>2]|0)>=(c[(c[g>>2]|0)+12>>2]|0)){c[l>>2]=Hb[c[135760>>2]&511](c[(c[g>>2]|0)+20>>2]|0,c[(c[g>>2]|0)+12>>2]<<2<<2)|0;if(c[l>>2]|0){c[(c[g>>2]|0)+20>>2]=c[l>>2];k=(c[g>>2]|0)+12|0;c[k>>2]=c[k>>2]<<1;break}c[f>>2]=-1;n=c[f>>2]|0;i=e;return n|0}while(0);c[(c[(c[g>>2]|0)+20>>2]|0)+(c[(c[g>>2]|0)+8>>2]<<1<<2)>>2]=c[h>>2];h=c[j>>2]|0;j=(c[g>>2]|0)+8|0;l=c[j>>2]|0;c[j>>2]=l+1;c[(c[(c[g>>2]|0)+20>>2]|0)+((l<<1)+1<<2)>>2]=h;c[f>>2]=(c[(c[g>>2]|0)+8>>2]|0)-1;n=c[f>>2]|0;i=e;return n|0}function dR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g+24|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;c[g+20>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;do if((c[(c[j>>2]|0)+20>>2]|0)>=(c[(c[j>>2]|0)+24>>2]|0)){c[n>>2]=Hb[c[135760>>2]&511](c[(c[j>>2]|0)+28>>2]|0,(c[(c[j>>2]|0)+24>>2]<<1)*12|0)|0;if(c[n>>2]|0){c[(c[j>>2]|0)+28>>2]=c[n>>2];f=(c[j>>2]|0)+24|0;c[f>>2]=c[f>>2]<<1;break}c[h>>2]=-1;o=c[h>>2]|0;i=g;return o|0}while(0);c[(c[(c[j>>2]|0)+28>>2]|0)+((c[(c[j>>2]|0)+20>>2]|0)*12|0)>>2]=c[k>>2];c[(c[(c[j>>2]|0)+28>>2]|0)+((c[(c[j>>2]|0)+20>>2]|0)*12|0)+4>>2]=c[l>>2];c[(c[(c[j>>2]|0)+28>>2]|0)+((c[(c[j>>2]|0)+20>>2]|0)*12|0)+8>>2]=c[m>>2];m=(c[j>>2]|0)+20|0;c[m>>2]=(c[m>>2]|0)+1;c[h>>2]=0;o=c[h>>2]|0;i=g;return o|0}function eR(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+48|0;e=b+32|0;f=b+28|0;g=b+24|0;h=b+20|0;j=b+16|0;k=b+12|0;l=b+8|0;m=b+4|0;n=b;c[e>>2]=a;c[f>>2]=0;c[g>>2]=0;c[h>>2]=0;c[j>>2]=0;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)o=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){o=1;break}o=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);p=d[c[c[e>>2]>>2]>>0]|0;if(!o)break;a=c[e>>2]|0;if(!p)continue;c[a>>2]=(c[a>>2]|0)+1}o=d[c[c[e>>2]>>2]>>0]|0;a:do if((p|0)==46){a=c[e>>2]|0;if(o)c[a>>2]=(c[a>>2]|0)+1;if(!(dR(c[e>>2]|0,c[(c[e>>2]|0)+16>>2]|0,2,0,0)|0)){i=b;return}}else{a=c[e>>2]|0;if((o|0)==64){q=c[e>>2]|0;if(c[(c[a+16>>2]|0)+16>>2]&2){c[q+8>>2]=1;i=b;return}r=c[e>>2]|0;if(d[c[q>>2]>>0]|0)c[r>>2]=(c[r>>2]|0)+1;fR(c[e>>2]|0);if(c[(c[e>>2]|0)+8>>2]|0)break;i=b;return}c[g>>2]=jR(a)|0;a=d[c[c[e>>2]>>2]>>0]|0;if(!(c[g>>2]|0)){r=c[e>>2]|0;if((a|0)!=42){c[r+8>>2]=1;i=b;return}q=c[e>>2]|0;if(d[c[r>>2]>>0]|0)c[q>>2]=(c[q>>2]|0)+1;if(dR(c[e>>2]|0,c[(c[e>>2]|0)+16>>2]|0,8,0,0)|0)break;i=b;return}do if((a|0)!=32){if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){s=29;break}if((d[c[c[e>>2]>>2]>>0]|0|0)==13)s=29}else s=29;while(0);b:do if((s|0)==29){c[j>>2]=1;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[e>>2]>>2]>>0]|0|0)!=13)break b}while(0);a=c[e>>2]|0;if(!(d[c[c[e>>2]>>2]>>0]|0))continue;c[a>>2]=(c[a>>2]|0)+1}}while(0);a=d[c[c[e>>2]>>2]>>0]|0;if((d[c[c[e>>2]>>2]>>0]|0|0)!=58){if((a|0)!=42){if(dR(c[e>>2]|0,c[(c[e>>2]|0)+16>>2]|0,2,c[g>>2]|0,0)|0)break;i=b;return}q=c[e>>2]|0;if(c[g>>2]|0){c[q+8>>2]=1;break}r=c[e>>2]|0;if(d[c[q>>2]>>0]|0)c[r>>2]=(c[r>>2]|0)+1;if(dR(c[e>>2]|0,c[(c[e>>2]|0)+16>>2]|0,8,c[f>>2]|0,0)|0)break;i=b;return}r=c[e>>2]|0;if(a)c[r>>2]=(c[r>>2]|0)+1;if((d[c[c[e>>2]>>2]>>0]|0|0)!=58){c[k>>2]=c[g>>2];do if((c[j>>2]|0)==0?(d[c[c[e>>2]>>2]>>0]|0|0)!=32:0){if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[e>>2]>>2]>>0]|0|0)!=13){c[f>>2]=kR(c[e>>2]|0)|0;do if((((d[c[k>>2]>>0]|0|0)==120?(d[(c[k>>2]|0)+1>>0]|0|0)==109:0)?(d[(c[k>>2]|0)+2>>0]|0|0)==108:0)?(d[(c[k>>2]|0)+3>>0]|0|0)==0:0)if(c[(c[(c[e>>2]|0)+16>>2]|0)+4>>2]|0){c[h>>2]=AP(c[(c[(c[e>>2]|0)+16>>2]|0)+4>>2]|0,200288,-1)|0;break}else{c[h>>2]=my(200288)|0;break}else s=53;while(0);if((s|0)==53){c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[(c[e>>2]|0)+28>>2]|0))break;if(qy(c[(c[(c[e>>2]|0)+24>>2]|0)+((c[l>>2]<<1)+1<<2)>>2]|0,c[k>>2]|0)|0){s=56;break}c[l>>2]=(c[l>>2]|0)+1}do if((s|0)==56)if(c[(c[(c[e>>2]|0)+16>>2]|0)+4>>2]|0){c[h>>2]=AP(c[(c[(c[e>>2]|0)+16>>2]|0)+4>>2]|0,c[(c[(c[e>>2]|0)+24>>2]|0)+(c[l>>2]<<1<<2)>>2]|0,-1)|0;break}else{c[h>>2]=my(c[(c[(c[e>>2]|0)+24>>2]|0)+(c[l>>2]<<1<<2)>>2]|0)|0;break}while(0);if((c[l>>2]|0)>=(c[(c[e>>2]|0)+28>>2]|0)){c[(c[e>>2]|0)+8>>2]=1;break a}}if(!(c[(c[(c[e>>2]|0)+16>>2]|0)+4>>2]|0))zb[c[135736>>2]&511](c[k>>2]|0);c[g>>2]=0;r=c[e>>2]|0;if(c[f>>2]|0){if(dR(r,c[(c[e>>2]|0)+16>>2]|0,2,c[f>>2]|0,c[h>>2]|0)|0)break a;i=b;return}a=c[e>>2]|0;if((d[c[r>>2]>>0]|0|0)!=42){c[a+8>>2]=1;break a}r=c[e>>2]|0;if(d[c[a>>2]>>0]|0)c[r>>2]=(c[r>>2]|0)+1;if(dR(c[e>>2]|0,c[(c[e>>2]|0)+16>>2]|0,7,c[h>>2]|0,0)|0)break a;i=b;return}}while(0);c[(c[e>>2]|0)+8>>2]=1;break}r=c[e>>2]|0;if(d[c[c[e>>2]>>2]>>0]|0)c[r>>2]=(c[r>>2]|0)+1;if(!(qy(c[g>>2]|0,200328)|0)){r=(qy(c[g>>2]|0,200336)|0)!=0;a=c[e>>2]|0;if(!r){c[a+8>>2]=1;break}if(!(c[(c[a+16>>2]|0)+4>>2]|0))zb[c[135736>>2]&511](c[g>>2]|0);c[g>>2]=0;a=c[e>>2]|0;if(c[(c[(c[e>>2]|0)+16>>2]|0)+16>>2]&2){c[a+8>>2]=1;break}fR(a);if(c[(c[e>>2]|0)+8>>2]|0)break;i=b;return}if(!(c[(c[(c[e>>2]|0)+16>>2]|0)+4>>2]|0))zb[c[135736>>2]&511](c[g>>2]|0);c[g>>2]=kR(c[e>>2]|0)|0;a=d[c[c[e>>2]>>2]>>0]|0;if(!(c[g>>2]|0)){r=c[e>>2]|0;if((a|0)!=42){c[r+8>>2]=1;break}q=c[e>>2]|0;if(d[c[r>>2]>>0]|0)c[q>>2]=(c[q>>2]|0)+1;if(dR(c[e>>2]|0,c[(c[e>>2]|0)+16>>2]|0,8,0,0)|0)break;i=b;return}if((a|0)!=58){if(dR(c[e>>2]|0,c[(c[e>>2]|0)+16>>2]|0,3,c[g>>2]|0,0)|0)break;i=b;return}c[m>>2]=c[g>>2];a=c[e>>2]|0;if(d[c[c[e>>2]>>2]>>0]|0)c[a>>2]=(c[a>>2]|0)+1;do if((d[c[c[e>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[e>>2]>>2]>>0]|0|0)!=13){c[f>>2]=kR(c[e>>2]|0)|0;do if((d[c[m>>2]>>0]|0|0)==120){if((d[(c[m>>2]|0)+1>>0]|0|0)!=109){s=97;break}if((d[(c[m>>2]|0)+2>>0]|0|0)!=108){s=97;break}if(d[(c[m>>2]|0)+3>>0]|0){s=97;break}if(c[(c[(c[e>>2]|0)+16>>2]|0)+4>>2]|0){c[h>>2]=AP(c[(c[(c[e>>2]|0)+16>>2]|0)+4>>2]|0,200288,-1)|0;break}else{c[h>>2]=my(200288)|0;break}}else s=97;while(0);do if((s|0)==97){c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[(c[e>>2]|0)+28>>2]|0))break;if(qy(c[(c[(c[e>>2]|0)+24>>2]|0)+((c[n>>2]<<1)+1<<2)>>2]|0,c[m>>2]|0)|0){s=100;break}c[n>>2]=(c[n>>2]|0)+1}do if((s|0)==100)if(c[(c[(c[e>>2]|0)+16>>2]|0)+4>>2]|0){c[h>>2]=AP(c[(c[(c[e>>2]|0)+16>>2]|0)+4>>2]|0,c[(c[(c[e>>2]|0)+24>>2]|0)+(c[n>>2]<<1<<2)>>2]|0,-1)|0;break}else{c[h>>2]=my(c[(c[(c[e>>2]|0)+24>>2]|0)+(c[n>>2]<<1<<2)>>2]|0)|0;break}while(0);if((c[n>>2]|0)<(c[(c[e>>2]|0)+28>>2]|0))break;c[(c[e>>2]|0)+8>>2]=1;break a}while(0);if(!(c[(c[(c[e>>2]|0)+16>>2]|0)+4>>2]|0))zb[c[135736>>2]&511](c[m>>2]|0);c[g>>2]=0;a=c[e>>2]|0;if(c[f>>2]|0){if(dR(a,c[(c[e>>2]|0)+16>>2]|0,3,c[f>>2]|0,c[h>>2]|0)|0)break a;i=b;return}q=c[e>>2]|0;if((d[c[a>>2]>>0]|0|0)!=42){c[q+8>>2]=1;break a}a=c[e>>2]|0;if(d[c[q>>2]>>0]|0)c[a>>2]=(c[a>>2]|0)+1;if(dR(c[e>>2]|0,c[(c[e>>2]|0)+16>>2]|0,7,c[h>>2]|0,0)|0)break a;i=b;return}}while(0);c[(c[e>>2]|0)+8>>2]=1}while(0);if((c[h>>2]|0)!=0?(c[(c[(c[e>>2]|0)+16>>2]|0)+4>>2]|0)==0:0)zb[c[135736>>2]&511](c[h>>2]|0);if((c[f>>2]|0)!=0?(c[(c[(c[e>>2]|0)+16>>2]|0)+4>>2]|0)==0:0)zb[c[135736>>2]&511](c[f>>2]|0);if(!(c[g>>2]|0)){i=b;return}if(c[(c[(c[e>>2]|0)+16>>2]|0)+4>>2]|0){i=b;return}zb[c[135736>>2]&511](c[g>>2]|0);i=b;return}function fR(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+32|0;e=b+20|0;f=b+16|0;g=b+12|0;h=b+8|0;j=b+4|0;k=b;c[e>>2]=a;c[f>>2]=0;c[g>>2]=0;c[h>>2]=0;while(1){do if((d[c[c[e>>2]>>2]>>0]|0|0)==32)l=1;else{if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0){l=1;break}l=(d[c[c[e>>2]>>2]>>0]|0|0)==13}while(0);m=c[e>>2]|0;if(!l)break;a=c[e>>2]|0;if(!(d[c[m>>2]>>0]|0))continue;c[a>>2]=(c[a>>2]|0)+1}c[g>>2]=jR(m)|0;m=d[c[c[e>>2]>>2]>>0]|0;a:do if(!(c[g>>2]|0)){l=c[e>>2]|0;if((m|0)!=42){c[l+8>>2]=1;i=b;return}if(!(dR(l,c[(c[e>>2]|0)+16>>2]|0,4,0,0)|0)){l=c[e>>2]|0;if(!(d[c[c[e>>2]>>2]>>0]|0)){i=b;return}c[l>>2]=(c[l>>2]|0)+1;i=b;return}}else{if((m|0)!=58){if(dR(c[e>>2]|0,c[(c[e>>2]|0)+16>>2]|0,4,c[g>>2]|0,0)|0)break;i=b;return}c[k>>2]=c[g>>2];l=c[e>>2]|0;if(d[c[c[e>>2]>>2]>>0]|0)c[l>>2]=(c[l>>2]|0)+1;do if((d[c[c[e>>2]>>2]>>0]|0|0)!=32){if(9<=(d[c[c[e>>2]>>2]>>0]|0|0)?(d[c[c[e>>2]>>2]>>0]|0|0)<=10:0)break;if((d[c[c[e>>2]>>2]>>0]|0|0)!=13){c[f>>2]=kR(c[e>>2]|0)|0;do if((((d[c[k>>2]>>0]|0|0)==120?(d[(c[k>>2]|0)+1>>0]|0|0)==109:0)?(d[(c[k>>2]|0)+2>>0]|0|0)==108:0)?(d[(c[k>>2]|0)+3>>0]|0|0)==0:0)if(c[(c[(c[e>>2]|0)+16>>2]|0)+4>>2]|0){c[h>>2]=AP(c[(c[(c[e>>2]|0)+16>>2]|0)+4>>2]|0,200288,-1)|0;break}else{c[h>>2]=my(200288)|0;break}else n=32;while(0);if((n|0)==32){c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[(c[e>>2]|0)+28>>2]|0))break;if(qy(c[(c[(c[e>>2]|0)+24>>2]|0)+((c[j>>2]<<1)+1<<2)>>2]|0,c[k>>2]|0)|0){n=35;break}c[j>>2]=(c[j>>2]|0)+1}do if((n|0)==35)if(c[(c[(c[e>>2]|0)+16>>2]|0)+4>>2]|0){c[h>>2]=AP(c[(c[(c[e>>2]|0)+16>>2]|0)+4>>2]|0,c[(c[(c[e>>2]|0)+24>>2]|0)+(c[j>>2]<<1<<2)>>2]|0,-1)|0;break}else{c[h>>2]=my(c[(c[(c[e>>2]|0)+24>>2]|0)+(c[j>>2]<<1<<2)>>2]|0)|0;break}while(0);if((c[j>>2]|0)>=(c[(c[e>>2]|0)+28>>2]|0)){c[(c[e>>2]|0)+8>>2]=1;break a}}if(!(c[(c[(c[e>>2]|0)+16>>2]|0)+4>>2]|0))zb[c[135736>>2]&511](c[k>>2]|0);l=c[e>>2]|0;if(c[f>>2]|0){if(dR(l,c[(c[e>>2]|0)+16>>2]|0,4,c[f>>2]|0,c[h>>2]|0)|0)break a;i=b;return}a=c[e>>2]|0;if((d[c[l>>2]>>0]|0|0)!=42){c[a+8>>2]=1;break a}l=c[e>>2]|0;if(d[c[a>>2]>>0]|0)c[l>>2]=(c[l>>2]|0)+1;if(dR(c[e>>2]|0,c[(c[e>>2]|0)+16>>2]|0,4,0,c[h>>2]|0)|0)break a;i=b;return}}while(0);if(!(c[(c[(c[e>>2]|0)+16>>2]|0)+4>>2]|0))zb[c[135736>>2]&511](c[k>>2]|0);c[(c[e>>2]|0)+8>>2]=1}while(0);if((c[h>>2]|0)!=0?(c[(c[(c[e>>2]|0)+16>>2]|0)+4>>2]|0)==0:0)zb[c[135736>>2]&511](c[h>>2]|0);if(!(c[f>>2]|0)){i=b;return}if(c[(c[(c[e>>2]|0)+16>>2]|0)+4>>2]|0){i=b;return}zb[c[135736>>2]&511](c[f>>2]|0);i=b;return}function gR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[e>>2]=(c[e>>2]|0)<4?4:a;c[f>>2]=Cb[c[135744>>2]&511](20)|0;if(!(c[f>>2]|0)){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}a=c[f>>2]|0;c[a+0>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;a=Cb[c[135744>>2]&511](c[e>>2]<<4)|0;c[(c[f>>2]|0)+12>>2]=a;if(!(c[(c[f>>2]|0)+12>>2]|0)){zb[c[135736>>2]&511](c[f>>2]|0);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{c[(c[f>>2]|0)+4>>2]=0;c[(c[f>>2]|0)+8>>2]=c[e>>2];c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function hR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+32|0;h=g+24|0;j=g+20|0;k=g+16|0;l=g+12|0;m=g+8|0;n=g+4|0;o=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;do if((c[(c[j>>2]|0)+4>>2]|0)>=(c[(c[j>>2]|0)+8>>2]|0)){c[o>>2]=Hb[c[135760>>2]&511](c[(c[j>>2]|0)+12>>2]|0,c[(c[j>>2]|0)+8>>2]<<1<<4)|0;if(c[o>>2]|0){c[(c[j>>2]|0)+12>>2]=c[o>>2];f=(c[j>>2]|0)+8|0;c[f>>2]=c[f>>2]<<1;break}c[h>>2]=-1;p=c[h>>2]|0;i=g;return p|0}while(0);f=(c[j>>2]|0)+4|0;e=c[f>>2]|0;c[f>>2]=e+1;c[o>>2]=(c[(c[j>>2]|0)+12>>2]|0)+(e<<4);c[c[o>>2]>>2]=c[n>>2];c[(c[o>>2]|0)+4>>2]=c[k>>2];c[(c[o>>2]|0)+8>>2]=c[l>>2];c[(c[o>>2]|0)+12>>2]=c[m>>2];c[h>>2]=(c[(c[j>>2]|0)+4>>2]|0)-1;p=c[h>>2]|0;i=g;return p|0}function iR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;do if((c[(c[g>>2]|0)+8>>2]|0)!=0?(c[(c[g>>2]|0)+4>>2]|0)>0:0){if((c[(c[g>>2]|0)+4>>2]|0)<=(c[c[g>>2]>>2]|0)){c[k>>2]=Hb[c[135760>>2]&511](c[(c[g>>2]|0)+8>>2]|0,c[(c[g>>2]|0)+4>>2]<<1<<3)|0;if(c[k>>2]|0){c[(c[g>>2]|0)+8>>2]=c[k>>2];d=(c[g>>2]|0)+4|0;c[d>>2]=c[d>>2]<<1;break}c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}}else m=3;while(0);if((m|0)==3){c[(c[g>>2]|0)+4>>2]=4;c[c[g>>2]>>2]=0;m=Cb[c[135744>>2]&511](32)|0;c[(c[g>>2]|0)+8>>2]=m}c[(c[(c[g>>2]|0)+8>>2]|0)+(c[c[g>>2]>>2]<<3)>>2]=c[h>>2];h=c[j>>2]|0;j=c[g>>2]|0;m=c[j>>2]|0;c[j>>2]=m+1;c[(c[(c[g>>2]|0)+8>>2]|0)+(m<<3)+4>>2]=h;c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}function jR(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+32|0;e=b+24|0;f=b+20|0;g=b+16|0;h=b+12|0;j=b+8|0;k=b+4|0;l=b;c[f>>2]=a;c[j>>2]=0;while(1){do if((d[c[c[f>>2]>>2]>>0]|0|0)==32)m=1;else{if(9<=(d[c[c[f>>2]>>2]>>0]|0|0)?(d[c[c[f>>2]>>2]>>0]|0|0)<=10:0){m=1;break}m=(d[c[c[f>>2]>>2]>>0]|0|0)==13}while(0);n=c[c[f>>2]>>2]|0;if(!m)break;a=c[f>>2]|0;if(!(d[n>>0]|0))continue;c[a>>2]=(c[a>>2]|0)+1}c[g>>2]=n;c[h>>2]=n;c[k>>2]=oe(0,c[h>>2]|0,l)|0;n=c[k>>2]|0;if((c[k>>2]|0)<256){if(((!(65<=(n|0)&(c[k>>2]|0)<=90)?!(97<=(c[k>>2]|0)&(c[k>>2]|0)<=122):0)?!(192<=(c[k>>2]|0)&(c[k>>2]|0)<=214):0)?!(216<=(c[k>>2]|0)&(c[k>>2]|0)<=246|248<=(c[k>>2]|0)):0)o=15}else if(!(DQ(n,199744)|0))o=15;do if((o|0)==15){n=c[k>>2]|0;if((c[k>>2]|0)<256){if((n|0)==95)break}else{if(19968<=(n|0)&(c[k>>2]|0)<=40869|(c[k>>2]|0)==12295)break;if(!((12321<=(c[k>>2]|0)&(c[k>>2]|0)<=12329^1)&(c[k>>2]|0)!=95))break}c[e>>2]=0;p=c[e>>2]|0;i=b;return p|0}while(0);a:while(1){n=c[k>>2]|0;if((c[k>>2]|0)<256){if(((!(65<=(n|0)&(c[k>>2]|0)<=90)?!(97<=(c[k>>2]|0)&(c[k>>2]|0)<=122):0)?!(192<=(c[k>>2]|0)&(c[k>>2]|0)<=214):0)?!(216<=(c[k>>2]|0)&(c[k>>2]|0)<=246|248<=(c[k>>2]|0)):0)o=26}else if(!(DQ(n,199744)|0))o=26;do if((o|0)==26){o=0;if((c[k>>2]|0)>=256){if(19968<=(c[k>>2]|0)&(c[k>>2]|0)<=40869|(c[k>>2]|0)==12295)break;if(12321<=(c[k>>2]|0)&(c[k>>2]|0)<=12329)break}n=c[k>>2]|0;if((c[k>>2]|0)<256){if(48<=(n|0)&(c[k>>2]|0)<=57|(c[k>>2]|0)==46|(c[k>>2]|0)==45|(c[k>>2]|0)==95)break}else{m=(DQ(n,200216)|0)!=0;if(m|(c[k>>2]|0)==46|(c[k>>2]|0)==45|(c[k>>2]|0)==95)break}if((c[k>>2]|0)>=256?(DQ(c[k>>2]|0,200144)|0)!=0:0)break;m=c[k>>2]|0;if((c[k>>2]|0)<256)q=(m|0)==183&1;else q=DQ(m,200272)|0;if(!q)break a}while(0);c[h>>2]=(c[h>>2]|0)+(c[l>>2]|0);c[k>>2]=oe(0,c[h>>2]|0,l)|0}if(c[(c[f>>2]|0)+12>>2]|0)c[j>>2]=AP(c[(c[f>>2]|0)+12>>2]|0,c[g>>2]|0,(c[h>>2]|0)-(c[g>>2]|0)|0)|0;else c[j>>2]=ly(c[g>>2]|0,(c[h>>2]|0)-(c[g>>2]|0)|0)|0;c[c[f>>2]>>2]=c[h>>2];c[e>>2]=c[j>>2];p=c[e>>2]|0;i=b;return p|0}function kR(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+32|0;e=b+24|0;f=b+20|0;g=b+16|0;h=b+12|0;j=b+8|0;k=b+4|0;l=b;c[f>>2]=a;c[j>>2]=0;while(1){do if((d[c[c[f>>2]>>2]>>0]|0|0)==32)m=1;else{if(9<=(d[c[c[f>>2]>>2]>>0]|0|0)?(d[c[c[f>>2]>>2]>>0]|0|0)<=10:0){m=1;break}m=(d[c[c[f>>2]>>2]>>0]|0|0)==13}while(0);n=c[c[f>>2]>>2]|0;if(!m)break;a=c[f>>2]|0;if(!(d[n>>0]|0))continue;c[a>>2]=(c[a>>2]|0)+1}c[g>>2]=n;c[h>>2]=n;c[k>>2]=oe(0,c[h>>2]|0,l)|0;n=c[k>>2]|0;if((c[k>>2]|0)<256){if(((!(65<=(n|0)&(c[k>>2]|0)<=90)?!(97<=(c[k>>2]|0)&(c[k>>2]|0)<=122):0)?!(192<=(c[k>>2]|0)&(c[k>>2]|0)<=214):0)?!(216<=(c[k>>2]|0)&(c[k>>2]|0)<=246|248<=(c[k>>2]|0)):0)o=15}else if(!(DQ(n,199744)|0))o=15;do if((o|0)==15){n=c[k>>2]|0;if((c[k>>2]|0)<256){if(!((n|0)!=95&(c[k>>2]|0)!=58))break}else{if(19968<=(n|0)&(c[k>>2]|0)<=40869|(c[k>>2]|0)==12295)break;if(!((12321<=(c[k>>2]|0)&(c[k>>2]|0)<=12329^1)&(c[k>>2]|0)!=95&(c[k>>2]|0)!=58))break}c[e>>2]=0;p=c[e>>2]|0;i=b;return p|0}while(0);a:while(1){n=c[k>>2]|0;if((c[k>>2]|0)<256){if(((!(65<=(n|0)&(c[k>>2]|0)<=90)?!(97<=(c[k>>2]|0)&(c[k>>2]|0)<=122):0)?!(192<=(c[k>>2]|0)&(c[k>>2]|0)<=214):0)?!(216<=(c[k>>2]|0)&(c[k>>2]|0)<=246|248<=(c[k>>2]|0)):0)o=26}else if(!(DQ(n,199744)|0))o=26;do if((o|0)==26){o=0;if((c[k>>2]|0)>=256){if(19968<=(c[k>>2]|0)&(c[k>>2]|0)<=40869|(c[k>>2]|0)==12295)break;if(12321<=(c[k>>2]|0)&(c[k>>2]|0)<=12329)break}n=c[k>>2]|0;if((c[k>>2]|0)<256){if(48<=(n|0)&(c[k>>2]|0)<=57|(c[k>>2]|0)==46|(c[k>>2]|0)==45|(c[k>>2]|0)==95)break}else{m=(DQ(n,200216)|0)!=0;if(m|(c[k>>2]|0)==46|(c[k>>2]|0)==45|(c[k>>2]|0)==95)break}if((c[k>>2]|0)>=256?(DQ(c[k>>2]|0,200144)|0)!=0:0)break;m=c[k>>2]|0;if((c[k>>2]|0)<256)q=(m|0)==183&1;else q=DQ(m,200272)|0;if(!q)break a}while(0);c[h>>2]=(c[h>>2]|0)+(c[l>>2]|0);c[k>>2]=oe(0,c[h>>2]|0,l)|0}if(c[(c[f>>2]|0)+12>>2]|0)c[j>>2]=AP(c[(c[f>>2]|0)+12>>2]|0,c[g>>2]|0,(c[h>>2]|0)-(c[g>>2]|0)|0)|0;else c[j>>2]=ly(c[g>>2]|0,(c[h>>2]|0)-(c[g>>2]|0)|0)|0;c[c[f>>2]>>2]=c[h>>2];c[e>>2]=c[j>>2];p=c[e>>2]|0;i=b;return p|0}function lR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;do if((c[f>>2]|0)==0&(c[g>>2]|0)==0)c[e>>2]=-1;else{if(c[g>>2]|0){if(qy(c[g>>2]|0,200352)|0){c[e>>2]=1;break}if(qy(c[g>>2]|0,200392)|0){c[e>>2]=1;break}if(qy(c[g>>2]|0,200432)|0){c[e>>2]=1;break}}if(c[f>>2]|0){if(qy(c[f>>2]|0,200472)|0){c[e>>2]=1;break}if(qy(c[f>>2]|0,200528)|0){c[e>>2]=1;break}if(qy(c[f>>2]|0,200584)|0){c[e>>2]=1;break}}c[e>>2]=0}while(0);i=d;return c[e>>2]|0}function mR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=kj()|0;if(!(c[g>>2]|0)){i=d;return}Bm(c[g>>2]|0,c[f>>2]|0);hz(c[e>>2]|0,c[g>>2]|0)|0;i=d;return}function nR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=kj()|0;if(!(c[g>>2]|0)){i=d;return}pm(c[g>>2]|0,c[f>>2]|0);hz(c[e>>2]|0,c[g>>2]|0)|0;i=d;return}function oR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=kj()|0;if(!(c[g>>2]|0)){i=d;return}wm(c[g>>2]|0,c[f>>2]|0);hz(c[e>>2]|0,c[g>>2]|0)|0;i=d;return}function pR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=kj()|0;if(!(c[g>>2]|0)){i=d;return}fd(c[g>>2]|0,c[f>>2]|0);hz(c[e>>2]|0,c[g>>2]|0)|0;i=d;return}function qR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;while(1){if(!(c[f>>2]|0))break;KR(c[e>>2]|0,c[f>>2]|0,0);c[f>>2]=c[c[f>>2]>>2]}i=d;return}function rR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=LR(c[h>>2]|0,c[j>>2]|0)|0;if(!(c[k>>2]|0)){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}j=Jk(c[g>>2]|0,c[(c[k>>2]|0)+20>>2]|0)|0;c[(c[k>>2]|0)+24>>2]=j;j=c[k>>2]|0;if(!(c[(c[k>>2]|0)+24>>2]|0)){MR(j);c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}else{c[f>>2]=j;l=c[f>>2]|0;i=e;return l|0}return 0}function sR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[l>>2]=0;c[k>>2]=LR(c[h>>2]|0,c[j>>2]|0)|0;if(!(c[k>>2]|0)){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}j=Ek(c[g>>2]|0,c[(c[k>>2]|0)+20>>2]|0,c[l>>2]|0)|0;c[(c[k>>2]|0)+24>>2]=j;j=c[k>>2]|0;if(!(c[(c[k>>2]|0)+24>>2]|0)){MR(j);c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}else{c[f>>2]=j;m=c[f>>2]|0;i=e;return m|0}return 0}function tR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;do if(!((c[f>>2]|0)==0|(c[g>>2]|0)==0))if((NR(c[f>>2]|0,c[g>>2]|0)|0)<0){
c[e>>2]=-1;break}else{c[e>>2]=c[h>>2];break}else c[e>>2]=-1;while(0);i=d;return c[e>>2]|0}function uR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){c[e>>2]=-1;j=c[e>>2]|0;i=d;return j|0}else{OR(c[f>>2]|0,c[g>>2]|0);c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}return 0}function vR(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;do if(c[e>>2]|0)if(!(c[(c[e>>2]|0)+24>>2]|0)){c[d>>2]=-1;break}else{c[d>>2]=Ak(c[(c[e>>2]|0)+24>>2]|0)|0;break}else c[d>>2]=-1;while(0);i=b;return c[d>>2]|0}function wR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if(!(c[e>>2]|0)){c[d>>2]=-1;g=c[d>>2]|0;i=b;return g|0}else{c[f>>2]=vR(c[e>>2]|0)|0;MR(c[e>>2]|0);c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function xR(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+48|0;h=g+28|0;j=g+24|0;k=g+20|0;l=g+16|0;m=g+12|0;n=g+8|0;o=g+32|0;p=g+4|0;q=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=e;c[l>>2]=f;if(!(c[l>>2]|0)){i=g;return}f=c[l>>2]|0;c[n>>2]=f;c[m>>2]=f;a:while(1){if(!(d[c[n>>2]>>0]|0))break;if((d[c[n>>2]>>0]|0|0)==10){if((c[m>>2]|0)!=(c[n>>2]|0))cz(c[h>>2]|0,c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0)|0;cz(c[h>>2]|0,200640,5)|0;c[n>>2]=(c[n>>2]|0)+1;c[m>>2]=c[n>>2];continue}if((d[c[n>>2]>>0]|0|0)==13){if((c[m>>2]|0)!=(c[n>>2]|0))cz(c[h>>2]|0,c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0)|0;cz(c[h>>2]|0,200648,5)|0;c[n>>2]=(c[n>>2]|0)+1;c[m>>2]=c[n>>2];continue}if((d[c[n>>2]>>0]|0|0)==9){if((c[m>>2]|0)!=(c[n>>2]|0))cz(c[h>>2]|0,c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0)|0;cz(c[h>>2]|0,200656,4)|0;c[n>>2]=(c[n>>2]|0)+1;c[m>>2]=c[n>>2];continue}if((d[c[n>>2]>>0]|0|0)==34){if((c[m>>2]|0)!=(c[n>>2]|0))cz(c[h>>2]|0,c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0)|0;cz(c[h>>2]|0,200664,6)|0;c[n>>2]=(c[n>>2]|0)+1;c[m>>2]=c[n>>2];continue}if((d[c[n>>2]>>0]|0|0)==60){if((c[m>>2]|0)!=(c[n>>2]|0))cz(c[h>>2]|0,c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0)|0;cz(c[h>>2]|0,200672,4)|0;c[n>>2]=(c[n>>2]|0)+1;c[m>>2]=c[n>>2];continue}if((d[c[n>>2]>>0]|0|0)==62){if((c[m>>2]|0)!=(c[n>>2]|0))cz(c[h>>2]|0,c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0)|0;cz(c[h>>2]|0,200680,4)|0;c[n>>2]=(c[n>>2]|0)+1;c[m>>2]=c[n>>2];continue}if((d[c[n>>2]>>0]|0|0)==38){if((c[m>>2]|0)!=(c[n>>2]|0))cz(c[h>>2]|0,c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0)|0;cz(c[h>>2]|0,200688,5)|0;c[n>>2]=(c[n>>2]|0)+1;c[m>>2]=c[n>>2];continue}do if((d[c[n>>2]>>0]|0|0)>=128){if((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+60>>2]|0)!=0:0)break;c[p>>2]=0;c[q>>2]=1;if((c[m>>2]|0)!=(c[n>>2]|0))cz(c[h>>2]|0,c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0)|0;if((d[c[n>>2]>>0]|0|0)<192){PR(1400,c[k>>2]|0,0);if(c[j>>2]|0){f=my(200696)|0;c[(c[j>>2]|0)+60>>2]=f}QR(o,d[c[n>>2]>>0]|0)|0;cz(c[h>>2]|0,o,-1)|0;c[n>>2]=(c[n>>2]|0)+1;c[m>>2]=c[n>>2];continue a}f=c[n>>2]|0;do if((d[c[n>>2]>>0]|0|0)>=224){l=c[n>>2]|0;if((d[f>>0]|0|0)<240){c[p>>2]=(d[l>>0]|0)&15;c[p>>2]=c[p>>2]<<6;c[p>>2]=c[p>>2]|(d[(c[n>>2]|0)+1>>0]|0)&63;c[p>>2]=c[p>>2]<<6;c[p>>2]=c[p>>2]|(d[(c[n>>2]|0)+2>>0]|0)&63;c[q>>2]=3;break}if((d[l>>0]|0|0)<248){c[p>>2]=(d[c[n>>2]>>0]|0)&7;c[p>>2]=c[p>>2]<<6;c[p>>2]=c[p>>2]|(d[(c[n>>2]|0)+1>>0]|0)&63;c[p>>2]=c[p>>2]<<6;c[p>>2]=c[p>>2]|(d[(c[n>>2]|0)+2>>0]|0)&63;c[p>>2]=c[p>>2]<<6;c[p>>2]=c[p>>2]|(d[(c[n>>2]|0)+3>>0]|0)&63;c[q>>2]=4}}else{c[p>>2]=(d[f>>0]|0)&31;c[p>>2]=c[p>>2]<<6;c[p>>2]=c[p>>2]|(d[(c[n>>2]|0)+1>>0]|0)&63;c[q>>2]=2}while(0);b:do if((c[q>>2]|0)!=1){f=c[p>>2]|0;do if((c[p>>2]|0)<256){if(!(9<=(f|0)&(c[p>>2]|0)<=10|(c[p>>2]|0)==13|32<=(c[p>>2]|0)))break b}else{if(256<=(f|0)&(c[p>>2]|0)<=55295)break;if(57344<=(c[p>>2]|0)&(c[p>>2]|0)<=65533)break;if(!(65536<=(c[p>>2]|0)&(c[p>>2]|0)<=1114111))break b}while(0);QR(o,c[p>>2]|0)|0;cz(c[h>>2]|0,o,-1)|0;c[n>>2]=(c[n>>2]|0)+(c[q>>2]|0);c[m>>2]=c[n>>2];continue a}while(0);PR(1401,c[k>>2]|0,0);if(c[j>>2]|0){f=my(200696)|0;c[(c[j>>2]|0)+60>>2]=f}QR(o,d[c[n>>2]>>0]|0)|0;cz(c[h>>2]|0,o,-1)|0;c[n>>2]=(c[n>>2]|0)+1;c[m>>2]=c[n>>2];continue a}while(0);c[n>>2]=(c[n>>2]|0)+1}if((c[m>>2]|0)==(c[n>>2]|0)){i=g;return}cz(c[h>>2]|0,c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0)|0;i=g;return}function yR(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+160|0;j=h+152|0;k=h+148|0;l=h+144|0;m=h+140|0;n=h+136|0;o=h+132|0;p=h+8|0;q=h+4|0;r=h;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[r>>2]=0;Rf();if((c[j>>2]|0)==0|(c[l>>2]|0)==0){i=h;return}if(!(c[o>>2]|0))c[o>>2]=200728;g=p+0|0;f=g+124|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(f|0));c[p+28>>2]=c[k>>2];c[p+24>>2]=c[j>>2];c[p+36>>2]=c[m>>2];c[p+40>>2]=(c[n>>2]|0)!=0?1:0;c[p+16>>2]=c[o>>2];SR(p);o=p+32|0;c[o>>2]=c[o>>2]|32;c[q>>2]=Nh(c[k>>2]|0)|0;if(c[q>>2]|0){k=lR(c[(c[q>>2]|0)+56>>2]|0,c[(c[q>>2]|0)+52>>2]|0)|0;c[r>>2]=k;c[r>>2]=(c[r>>2]|0)<0?0:k}k=c[l>>2]|0;if(c[r>>2]|0){TR(p,k);i=h;return}else{OR(p,k);i=h;return}}function zR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;Rf();if(!(c[h>>2]|0)){i=e;return}c[j>>2]=Fk(c[f>>2]|0,0)|0;if(!(c[j>>2]|0)){i=e;return}if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+4>>2]|0)==13:0)yp(c[j>>2]|0,c[g>>2]|0,c[h>>2]|0,0);else yR(c[j>>2]|0,c[g>>2]|0,c[h>>2]|0,0,1,0);zk(c[j>>2]|0)|0;i=e;return}function AR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+160|0;h=g+152|0;j=g+148|0;k=g+144|0;l=g+140|0;m=g+136|0;n=g+12|0;o=g+8|0;p=g+4|0;q=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[o>>2]=0;c[p>>2]=0;c[q>>2]=0;if(!(c[k>>2]|0))c[k>>2]=o;if(!(c[j>>2]|0)){c[c[k>>2]>>2]=0;i=g;return}c[c[j>>2]>>2]=0;c[c[k>>2]>>2]=0;if(!(c[h>>2]|0)){i=g;return}if(!(c[l>>2]|0))c[l>>2]=c[(c[h>>2]|0)+60>>2];if((c[l>>2]|0)!=0?(c[q>>2]=Dd(c[l>>2]|0)|0,(c[q>>2]|0)==0):0){PR(1403,c[h>>2]|0,c[l>>2]|0);i=g;return}o=wk(c[q>>2]|0)|0;c[p>>2]=o;if(!o){RR(200712);i=g;return}o=n+0|0;q=o+124|0;do{c[o>>2]=0;o=o+4|0}while((o|0)<(q|0));c[n+28>>2]=c[h>>2];c[n+24>>2]=c[p>>2];c[n+36>>2]=0;c[n+40>>2]=(c[m>>2]|0)!=0?1:0;c[n+16>>2]=c[l>>2];SR(n);l=n+32|0;c[l>>2]=c[l>>2]|32;NR(n,c[h>>2]|0)|0;Ak(c[p>>2]|0)|0;h=c[p>>2]|0;if(c[(c[p>>2]|0)+20>>2]|0){n=_y(c[h+20>>2]|0)|0;c[c[k>>2]>>2]=n;n=Vy(c[(c[p>>2]|0)+20>>2]|0)|0;l=ly(n,c[c[k>>2]>>2]|0)|0;c[c[j>>2]>>2]=l}else{l=_y(c[h+16>>2]|0)|0;c[c[k>>2]>>2]=l;l=Vy(c[(c[p>>2]|0)+16>>2]|0)|0;h=ly(l,c[c[k>>2]>>2]|0)|0;c[c[j>>2]>>2]=h}zk(c[p>>2]|0)|0;if(c[c[j>>2]>>2]|0){i=g;return}if((c[c[k>>2]>>2]|0)<=0){i=g;return}c[c[k>>2]>>2]=0;RR(200736);i=g;return}function BR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;AR(c[f>>2]|0,c[g>>2]|0,c[h>>2]|0,0,0);i=e;return}function CR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;AR(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0,0,c[k>>2]|0);i=f;return}function DR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;AR(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,0);i=f;return}function ER(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+160|0;f=e+152|0;g=e+148|0;h=e+144|0;j=e+140|0;k=e+16|0;l=e+12|0;m=e+8|0;n=e+4|0;o=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[n>>2]=0;if(!(c[h>>2]|0)){c[f>>2]=-1;p=c[f>>2]|0;i=e;return p|0}c[m>>2]=c[(c[h>>2]|0)+60>>2];if((c[m>>2]|0)!=0?(c[n>>2]=Dd(c[m>>2]|0)|0,(c[n>>2]|0)==0):0){zb[c[135736>>2]&511](c[(c[h>>2]|0)+60>>2]|0);c[(c[h>>2]|0)+60>>2]=0;c[m>>2]=0}c[l>>2]=Fk(c[g>>2]|0,c[n>>2]|0)|0;if(!(c[l>>2]|0)){c[f>>2]=-1;p=c[f>>2]|0;i=e;return p|0}else{n=k+0|0;g=n+124|0;do{c[n>>2]=0;n=n+4|0}while((n|0)<(g|0));c[k+28>>2]=c[h>>2];c[k+24>>2]=c[l>>2];c[k+36>>2]=0;c[k+40>>2]=(c[j>>2]|0)!=0?1:0;c[k+16>>2]=c[m>>2];SR(k);m=k+32|0;c[m>>2]=c[m>>2]|32;NR(k,c[h>>2]|0)|0;c[o>>2]=zk(c[l>>2]|0)|0;c[f>>2]=c[o>>2];p=c[f>>2]|0;i=e;return p|0}return 0}function FR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=ER(c[e>>2]|0,c[f>>2]|0,0)|0;i=d;return b|0}function GR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+160|0;g=f+152|0;h=f+148|0;j=f+144|0;k=f+140|0;l=f+136|0;m=f+12|0;n=f+8|0;o=f+4|0;p=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[o>>2]=0;if(!(c[j>>2]|0)){c[g>>2]=-1;q=c[g>>2]|0;i=f;return q|0}if(!(c[k>>2]|0))c[k>>2]=c[(c[j>>2]|0)+60>>2];if((c[k>>2]|0)!=0?(c[o>>2]=Dd(c[k>>2]|0)|0,(c[o>>2]|0)==0):0){c[g>>2]=-1;q=c[g>>2]|0;i=f;return q|0}c[n>>2]=Ek(c[h>>2]|0,c[o>>2]|0,c[(c[j>>2]|0)+36>>2]|0)|0;if(!(c[n>>2]|0)){c[g>>2]=-1;q=c[g>>2]|0;i=f;return q|0}else{o=m+0|0;h=o+124|0;do{c[o>>2]=0;o=o+4|0}while((o|0)<(h|0));c[m+28>>2]=c[j>>2];c[m+24>>2]=c[n>>2];c[m+36>>2]=0;c[m+40>>2]=(c[l>>2]|0)!=0?1:0;c[m+16>>2]=c[k>>2];SR(m);k=m+32|0;c[k>>2]=c[k>>2]|32;NR(m,c[j>>2]|0)|0;c[p>>2]=zk(c[n>>2]|0)|0;c[g>>2]=c[p>>2];q=c[g>>2]|0;i=f;return q|0}return 0}function HR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=GR(c[f>>2]|0,c[g>>2]|0,c[h>>2]|0,0)|0;i=e;return d|0}function IR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=GR(c[f>>2]|0,c[g>>2]|0,0,c[h>>2]|0)|0;i=e;return d|0}function JR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=GR(c[e>>2]|0,c[f>>2]|0,0,0)|0;i=d;return b|0}function KR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if((c[g>>2]|0)==0|(c[f>>2]|0)==0){i=e;return}if((c[(c[g>>2]|0)+4>>2]|0)!=18){i=e;return}if(!(c[(c[g>>2]|0)+8>>2]|0)){i=e;return}if(qy(c[(c[g>>2]|0)+12>>2]|0,201224)|0){i=e;return}if((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+40>>2]|0)==2:0)UR(c[h>>2]|0,2);else Ok(c[f>>2]|0,1,200760)|0;h=c[f>>2]|0;if(c[(c[g>>2]|0)+12>>2]|0){Ok(h,6,201752)|0;Qk(c[f>>2]|0,c[(c[g>>2]|0)+12>>2]|0)|0}else Ok(h,5,201760)|0;Ok(c[f>>2]|0,1,201768)|0;gz(c[(c[f>>2]|0)+16>>2]|0,c[(c[g>>2]|0)+8>>2]|0)|0;i=e;return}function LR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=Cb[c[135744>>2]&511](124)|0;if(!(c[h>>2]|0)){RR(201728);c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}b=(c[h>>2]|0)+0|0;a=b+124|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(a|0));do if(c[f>>2]|0){b=Dd(c[f>>2]|0)|0;c[(c[h>>2]|0)+20>>2]=b;b=c[f>>2]|0;if(c[(c[h>>2]|0)+20>>2]|0){a=my(b)|0;c[(c[h>>2]|0)+16>>2]=a;c[(c[h>>2]|0)+116>>2]=0;break}PR(1403,0,b);MR(c[h>>2]|0);c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}while(0);SR(c[h>>2]|0);if((c[(c[h>>2]|0)+32>>2]&4|0)!=0?(c[g>>2]&4|0)==0:0)c[g>>2]=c[g>>2]|4;c[(c[h>>2]|0)+32>>2]=c[g>>2];if(!(c[g>>2]&1)){if(c[g>>2]&128)c[(c[h>>2]|0)+40>>2]=2}else c[(c[h>>2]|0)+40>>2]=1;c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}function MR(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+16>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+16>>2]|0);if(c[(c[d>>2]|0)+24>>2]|0)zk(c[(c[d>>2]|0)+24>>2]|0)|0;zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function NR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+64|0;e=d+52|0;f=d+48|0;g=d+44|0;h=d+40|0;j=d+36|0;k=d+32|0;l=d+28|0;m=d+24|0;n=d+20|0;o=d+16|0;p=d+12|0;q=d+8|0;r=d+4|0;s=d;c[f>>2]=a;c[g>>2]=b;c[j>>2]=0;c[k>>2]=c[(c[g>>2]|0)+60>>2];c[l>>2]=c[(c[f>>2]|0)+16>>2];c[m>>2]=c[(c[f>>2]|0)+16>>2];c[n>>2]=c[(c[f>>2]|0)+116>>2];c[o>>2]=c[(c[f>>2]|0)+120>>2];c[p>>2]=c[(c[f>>2]|0)+24>>2];c[r>>2]=0;Rf();if((c[(c[g>>2]|0)+4>>2]|0)!=13?(c[(c[g>>2]|0)+4>>2]|0)!=9:0){c[e>>2]=-1;t=c[e>>2]|0;i=d;return t|0}do if(!(c[(c[f>>2]|0)+16>>2]|0)){b=c[g>>2]|0;if(c[(c[g>>2]|0)+60>>2]|0){c[m>>2]=c[b+60>>2];break}if((c[b+76>>2]|0)!=1)c[m>>2]=xd(c[(c[g>>2]|0)+76>>2]|0)|0}else c[(c[g>>2]|0)+60>>2]=c[(c[f>>2]|0)+16>>2];while(0);if(!(((c[(c[g>>2]|0)+4>>2]|0)==13?(c[(c[f>>2]|0)+32>>2]&32|0)==0:0)?(c[(c[f>>2]|0)+32>>2]&16|0)==0:0))u=13;if((u|0)==13?(c[(c[f>>2]|0)+32>>2]&64|0)==0:0){if(!(((c[(c[g>>2]|0)+4>>2]|0)!=9?(c[(c[f>>2]|0)+32>>2]&32|0)==0:0)?(c[(c[f>>2]|0)+32>>2]&16|0)==0:0))u=34;a:do if((u|0)==34){c[q>>2]=wd(c[m>>2]|0)|0;if((((c[m>>2]|0)!=0&(c[l>>2]|0)==0?(c[(c[p>>2]|0)+12>>2]|0)==0:0)?(c[(c[p>>2]|0)+20>>2]|0)==0:0)?(c[(c[f>>2]|0)+32>>2]&2|0)==0:0){do if((c[q>>2]|0)!=1&(c[q>>2]|0)!=0&(c[q>>2]|0)!=22){if((VR(c[f>>2]|0,c[m>>2]|0)|0)>=0){c[r>>2]=1;break}c[(c[g>>2]|0)+60>>2]=c[k>>2];c[e>>2]=-1;t=c[e>>2]|0;i=d;return t|0}while(0);if((c[(c[f>>2]|0)+116>>2]|0)==389)c[(c[f>>2]|0)+116>>2]=0;if((c[(c[f>>2]|0)+120>>2]|0)==389)c[(c[f>>2]|0)+120>>2]=0}if(!(c[(c[f>>2]|0)+32>>2]&2)){Ok(c[p>>2]|0,14,201632)|0;b=c[p>>2]|0;if(c[(c[g>>2]|0)+56>>2]|0)gz(c[b+16>>2]|0,c[(c[g>>2]|0)+56>>2]|0)|0;else Ok(b,5,201648)|0;if(c[m>>2]|0){Ok(c[p>>2]|0,10,201656)|0;gz(c[(c[p>>2]|0)+16>>2]|0,c[m>>2]|0)|0}b=c[(c[g>>2]|0)+40>>2]|0;if((b|0)==1)Ok(c[p>>2]|0,17,201696)|0;else if(!b)Ok(c[p>>2]|0,16,201672)|0;Ok(c[p>>2]|0,3,201720)|0}if(c[(c[f>>2]|0)+32>>2]&16)c[j>>2]=1;if((c[(c[f>>2]|0)+32>>2]&8|0)==0?(c[h>>2]=Nh(c[g>>2]|0)|0,(c[h>>2]|0)!=0):0){b=lR(c[(c[h>>2]|0)+56>>2]|0,c[(c[h>>2]|0)+52>>2]|0)|0;c[j>>2]=b;c[j>>2]=(c[j>>2]|0)<0?0:b}if(c[(c[g>>2]|0)+12>>2]|0){c[s>>2]=c[(c[g>>2]|0)+12>>2];while(1){if(!(c[s>>2]|0))break a;c[(c[f>>2]|0)+36>>2]=0;b=c[f>>2]|0;a=c[s>>2]|0;if(c[j>>2]|0)TR(b,a);else OR(b,a);Ok(c[p>>2]|0,1,200976)|0;c[s>>2]=c[(c[s>>2]|0)+24>>2]}}}while(0);if((c[r>>2]|0)!=0&(c[l>>2]|0)==0){XR(c[f>>2]|0)|0;c[(c[f>>2]|0)+116>>2]=c[n>>2];c[(c[f>>2]|0)+120>>2]=c[o>>2]}c[(c[g>>2]|0)+60>>2]=c[k>>2];c[e>>2]=0;t=c[e>>2]|0;i=d;return t|0}if(c[m>>2]|0)rp(c[g>>2]|0,c[m>>2]|0)|0;if(!(c[m>>2]|0))c[m>>2]=qp(c[g>>2]|0)|0;if(!(c[m>>2]|0))c[m>>2]=201592;if((((c[m>>2]|0)!=0&(c[l>>2]|0)==0?(c[(c[p>>2]|0)+12>>2]|0)==0:0)?(c[(c[p>>2]|0)+20>>2]|0)==0:0)?(VR(c[f>>2]|0,c[m>>2]|0)|0)<0:0){c[(c[g>>2]|0)+60>>2]=c[k>>2];c[e>>2]=-1;t=c[e>>2]|0;i=d;return t|0}l=c[p>>2]|0;p=c[g>>2]|0;o=c[m>>2]|0;if(c[(c[f>>2]|0)+32>>2]&1)wp(l,p,o,1);else wp(l,p,o,0);if(c[(c[f>>2]|0)+16>>2]|0)c[(c[g>>2]|0)+60>>2]=c[k>>2];c[e>>2]=0;t=c[e>>2]|0;i=d;return t|0}function OR(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[f>>2]=a;c[g>>2]=b;if(!(c[g>>2]|0)){i=e;return}c[m>>2]=c[(c[f>>2]|0)+24>>2];if((c[(c[g>>2]|0)+4>>2]|0)==19){i=e;return}if((c[(c[g>>2]|0)+4>>2]|0)==20){i=e;return}if((c[(c[g>>2]|0)+4>>2]|0)!=9?(c[(c[g>>2]|0)+4>>2]|0)!=13:0){if(c[(c[f>>2]|0)+32>>2]&16){TR(c[f>>2]|0,c[g>>2]|0);i=e;return}if(!((((c[(c[g>>2]|0)+4>>2]|0)!=18?(c[(c[g>>2]|0)+32>>2]|0)!=0:0)?(c[(c[(c[g>>2]|0)+32>>2]|0)+4>>2]|0)==13:0)?(c[(c[f>>2]|0)+32>>2]&32|0)==0:0))n=13;if((n|0)==13?(c[(c[f>>2]|0)+32>>2]&64|0)==0:0){if((c[(c[g>>2]|0)+4>>2]|0)==14){ZR(c[f>>2]|0,c[g>>2]|0);i=e;return}if((c[(c[g>>2]|0)+4>>2]|0)==11){_R(c[f>>2]|0,c[(c[g>>2]|0)+12>>2]|0);i=e;return}if((c[(c[g>>2]|0)+4>>2]|0)==15){nR(c[(c[m>>2]|0)+16>>2]|0,c[g>>2]|0);i=e;return}if((c[(c[g>>2]|0)+4>>2]|0)==16){oR(c[(c[m>>2]|0)+16>>2]|0,c[g>>2]|0);i=e;return}if((c[(c[g>>2]|0)+4>>2]|0)==17){pR(c[(c[m>>2]|0)+16>>2]|0,c[g>>2]|0);i=e;return}b=c[g>>2]|0;if((c[(c[g>>2]|0)+4>>2]|0)==3){if(!(c[b+40>>2]|0)){i=e;return}a=c[m>>2]|0;o=c[(c[g>>2]|0)+40>>2]|0;if((c[(c[g>>2]|0)+8>>2]|0)!=75112){Pk(a,o,c[(c[f>>2]|0)+116>>2]|0)|0;i=e;return}else{Qk(a,o)|0;i=e;return}}o=c[g>>2]|0;if((c[b+4>>2]|0)==7){b=(c[o+40>>2]|0)!=0;Ok(c[m>>2]|0,2,200752)|0;Qk(c[m>>2]|0,c[(c[g>>2]|0)+8>>2]|0)|0;if(!b){if((c[(c[f>>2]|0)+40>>2]|0)==2)UR(c[f>>2]|0,0);Ok(c[m>>2]|0,2,200768)|0;i=e;return}if(c[(c[g>>2]|0)+40>>2]|0){if((c[(c[f>>2]|0)+40>>2]|0)==2)UR(c[f>>2]|0,0);else Ok(c[m>>2]|0,1,200760)|0;Qk(c[m>>2]|0,c[(c[g>>2]|0)+40>>2]|0)|0}Ok(c[m>>2]|0,2,200768)|0;i=e;return}b=c[g>>2]|0;if((c[o+4>>2]|0)==8){if(!(c[b+40>>2]|0)){i=e;return}Ok(c[m>>2]|0,4,200776)|0;Qk(c[m>>2]|0,c[(c[g>>2]|0)+40>>2]|0)|0;Ok(c[m>>2]|0,3,200784)|0;i=e;return}if((c[b+4>>2]|0)==5){Ok(c[m>>2]|0,1,200792)|0;Qk(c[m>>2]|0,c[(c[g>>2]|0)+8>>2]|0)|0;Ok(c[m>>2]|0,1,200800)|0;i=e;return}b=c[g>>2]|0;if((c[(c[g>>2]|0)+4>>2]|0)==4){do if(c[b+40>>2]|0){if(!(d[c[(c[g>>2]|0)+40>>2]>>0]|0))break;o=c[(c[g>>2]|0)+40>>2]|0;c[l>>2]=o;c[k>>2]=o;while(1){if(!(d[c[l>>2]>>0]|0))break;do if((d[c[l>>2]>>0]|0|0)==93){if((d[(c[l>>2]|0)+1>>0]|0|0)!=93)break;if((d[(c[l>>2]|0)+2>>0]|0|0)!=62)break;c[l>>2]=(c[l>>2]|0)+2;Ok(c[m>>2]|0,9,200824)|0;Ok(c[m>>2]|0,(c[l>>2]|0)-(c[k>>2]|0)|0,c[k>>2]|0)|0;Ok(c[m>>2]|0,3,200840)|0;c[k>>2]=c[l>>2]}while(0);c[l>>2]=(c[l>>2]|0)+1}if((c[k>>2]|0)==(c[l>>2]|0)){i=e;return}Ok(c[m>>2]|0,9,200824)|0;Qk(c[m>>2]|0,c[k>>2]|0)|0;Ok(c[m>>2]|0,3,200840)|0;i=e;return}while(0);Ok(c[m>>2]|0,12,200808)|0;i=e;return}if((c[b+4>>2]|0)==2){$R(c[f>>2]|0,c[g>>2]|0);i=e;return}b=c[f>>2]|0;if((c[(c[g>>2]|0)+4>>2]|0)==18){aS(b,c[g>>2]|0);i=e;return}c[h>>2]=c[b+40>>2];a:do if((c[h>>2]|0)==1){c[j>>2]=c[(c[g>>2]|0)+12>>2];while(1){if(!(c[j>>2]|0))break a;if((c[(c[j>>2]|0)+4>>2]|0)==3)break;if((c[(c[j>>2]|0)+4>>2]|0)==4)break;if((c[(c[j>>2]|0)+4>>2]|0)==5)break;c[j>>2]=c[(c[j>>2]|0)+24>>2]}c[(c[f>>2]|0)+40>>2]=0}while(0);Ok(c[m>>2]|0,1,200848)|0;do if(c[(c[g>>2]|0)+36>>2]|0){if(!(c[(c[(c[g>>2]|0)+36>>2]|0)+12>>2]|0))break;Qk(c[m>>2]|0,c[(c[(c[g>>2]|0)+36>>2]|0)+12>>2]|0)|0;Ok(c[m>>2]|0,1,200856)|0}while(0);Qk(c[m>>2]|0,c[(c[g>>2]|0)+8>>2]|0)|0;if(c[(c[g>>2]|0)+48>>2]|0)bS(c[f>>2]|0,c[(c[g>>2]|0)+48>>2]|0);if(c[(c[g>>2]|0)+44>>2]|0)cS(c[f>>2]|0,c[(c[g>>2]|0)+44>>2]|0);if(!((c[(c[g>>2]|0)+4>>2]|0)!=1?(c[(c[g>>2]|0)+40>>2]|0)!=0:0))n=80;do if((n|0)==80){if(c[(c[g>>2]|0)+12>>2]|0)break;if(c[(c[f>>2]|0)+32>>2]&4)break;if((c[(c[f>>2]|0)+40>>2]|0)==2)UR(c[f>>2]|0,0);Ok(c[m>>2]|0,2,201584)|0;c[(c[f>>2]|0)+40>>2]=c[h>>2];i=e;return}while(0);if((c[(c[f>>2]|0)+40>>2]|0)==2)UR(c[f>>2]|0,1);Ok(c[m>>2]|0,1,200968)|0;do if((c[(c[g>>2]|0)+4>>2]|0)!=1){if(!(c[(c[g>>2]|0)+40>>2]|0))break;Pk(c[m>>2]|0,c[(c[g>>2]|0)+40>>2]|0,c[(c[f>>2]|0)+116>>2]|0)|0}while(0);do if(c[(c[g>>2]|0)+12>>2]|0){if((c[(c[f>>2]|0)+40>>2]|0)==1)Ok(c[m>>2]|0,1,200976)|0;if((c[(c[f>>2]|0)+36>>2]|0)>=0){n=(c[f>>2]|0)+36|0;c[n>>2]=(c[n>>2]|0)+1}_R(c[f>>2]|0,c[(c[g>>2]|0)+12>>2]|0);if((c[(c[f>>2]|0)+36>>2]|0)>0){n=(c[f>>2]|0)+36|0;c[n>>2]=(c[n>>2]|0)+-1}if(!(c[33984]|0))break;if((c[(c[f>>2]|0)+40>>2]|0)!=1)break;n=c[f>>2]|0;if((c[(c[f>>2]|0)+36>>2]|0)>(c[(c[f>>2]|0)+108>>2]|0))p=c[n+108>>2]|0;else p=c[n+36>>2]|0;n=ca(c[(c[f>>2]|0)+112>>2]|0,p)|0;Ok(c[m>>2]|0,n,(c[f>>2]|0)+44|0)|0}while(0);Ok(c[m>>2]|0,2,201056)|0;do if(c[(c[g>>2]|0)+36>>2]|0){if(!(c[(c[(c[g>>2]|0)+36>>2]|0)+12>>2]|0))break;Qk(c[m>>2]|0,c[(c[(c[g>>2]|0)+36>>2]|0)+12>>2]|0)|0;Ok(c[m>>2]|0,1,200856)|0}while(0);Qk(c[m>>2]|0,c[(c[g>>2]|0)+8>>2]|0)|0;if((c[(c[f>>2]|0)+40>>2]|0)==2)UR(c[f>>2]|0,0);Ok(c[m>>2]|0,1,200968)|0;c[(c[f>>2]|0)+40>>2]=c[h>>2];i=e;return}YR(c[f>>2]|0,c[g>>2]|0)|0;i=e;return}NR(c[f>>2]|0,c[g>>2]|0)|0;i=e;return}function PR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=0;d=c[f>>2]|0;if((d|0)==1400)c[j>>2]=201440;else if((d|0)==1403)c[j>>2]=201496;else if((d|0)==1401)c[j>>2]=201464;else if((d|0)==1402)c[j>>2]=201520;else c[j>>2]=201552;ce(7,c[f>>2]|0,c[g>>2]|0,c[j>>2]|0,c[h>>2]|0);i=e;return}function QR(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=b;c[g>>2]=d;d=c[f>>2]|0;c[f>>2]=d+1;a[d>>0]=38;d=c[f>>2]|0;c[f>>2]=d+1;a[d>>0]=35;d=c[f>>2]|0;c[f>>2]=d+1;a[d>>0]=120;do if((c[g>>2]|0)>=16){if((c[g>>2]|0)<256){c[h>>2]=(c[f>>2]|0)+1;break}if((c[g>>2]|0)<4096){c[h>>2]=(c[f>>2]|0)+2;break}if((c[g>>2]|0)<65536){c[h>>2]=(c[f>>2]|0)+3;break}d=c[f>>2]|0;if((c[g>>2]|0)<1048576){c[h>>2]=d+4;break}else{c[h>>2]=d+5;break}}else c[h>>2]=c[f>>2];while(0);c[f>>2]=(c[h>>2]|0)+1;while(1){if((c[g>>2]|0)<=0)break;do switch(c[g>>2]&15|0){case 14:{d=c[h>>2]|0;c[h>>2]=d+-1;a[d>>0]=69;break}case 10:{d=c[h>>2]|0;c[h>>2]=d+-1;a[d>>0]=65;break}case 2:{d=c[h>>2]|0;c[h>>2]=d+-1;a[d>>0]=50;break}case 7:{d=c[h>>2]|0;c[h>>2]=d+-1;a[d>>0]=55;break}case 9:{d=c[h>>2]|0;c[h>>2]=d+-1;a[d>>0]=57;break}case 5:{d=c[h>>2]|0;c[h>>2]=d+-1;a[d>>0]=53;break}case 12:{d=c[h>>2]|0;c[h>>2]=d+-1;a[d>>0]=67;break}case 0:{d=c[h>>2]|0;c[h>>2]=d+-1;a[d>>0]=48;break}case 3:{d=c[h>>2]|0;c[h>>2]=d+-1;a[d>>0]=51;break}case 11:{d=c[h>>2]|0;c[h>>2]=d+-1;a[d>>0]=66;break}case 15:{d=c[h>>2]|0;c[h>>2]=d+-1;a[d>>0]=70;break}case 13:{d=c[h>>2]|0;c[h>>2]=d+-1;a[d>>0]=68;break}case 6:{d=c[h>>2]|0;c[h>>2]=d+-1;a[d>>0]=54;break}case 8:{d=c[h>>2]|0;c[h>>2]=d+-1;a[d>>0]=56;break}case 4:{d=c[h>>2]|0;c[h>>2]=d+-1;a[d>>0]=52;break}case 1:{d=c[h>>2]|0;c[h>>2]=d+-1;a[d>>0]=49;break}default:{d=c[h>>2]|0;c[h>>2]=d+-1;a[d>>0]=48}}while(0);c[g>>2]=c[g>>2]>>4}g=c[f>>2]|0;c[f>>2]=g+1;a[g>>0]=59;a[c[f>>2]>>0]=0;i=e;return c[f>>2]|0}function RR(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;ce(7,2,0,0,c[d>>2]|0);i=b;return}function SR(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=b;if(!(c[e>>2]|0)){i=d;return}if((c[(c[e>>2]|0)+16>>2]|0)==0?(c[(c[e>>2]|0)+116>>2]|0)==0:0)c[(c[e>>2]|0)+116>>2]=389;c[g>>2]=xy(c[33988]|0)|0;if((c[33988]|0)==0|(c[g>>2]|0)==0){b=(c[e>>2]|0)+44|0;h=b+61|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(h|0))}else{c[(c[e>>2]|0)+112>>2]=c[g>>2];c[(c[e>>2]|0)+108>>2]=60/(c[(c[e>>2]|0)+112>>2]|0)|0;c[f>>2]=0;while(1){if((c[f>>2]|0)>=(c[(c[e>>2]|0)+108>>2]|0))break;g=ca(c[f>>2]|0,c[(c[e>>2]|0)+112>>2]|0)|0;eU((c[e>>2]|0)+44+g|0,c[33988]|0,c[(c[e>>2]|0)+112>>2]|0)|0;c[f>>2]=(c[f>>2]|0)+1}f=ca(c[(c[e>>2]|0)+108>>2]|0,c[(c[e>>2]|0)+112>>2]|0)|0;a[(c[e>>2]|0)+44+f>>0]=0}if(!(c[33990]|0)){i=d;return}f=(c[e>>2]|0)+32|0;c[f>>2]=c[f>>2]|4;i=d;return}function TR(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+48|0;f=e+36|0;g=e+32|0;h=e+28|0;j=e+24|0;k=e+20|0;l=e+16|0;m=e+12|0;n=e+8|0;o=e+4|0;p=e;c[f>>2]=a;c[g>>2]=b;c[j>>2]=0;if(!(c[g>>2]|0)){i=e;return}if((c[(c[g>>2]|0)+4>>2]|0)!=9?(c[(c[g>>2]|0)+4>>2]|0)!=13:0){if((c[(c[g>>2]|0)+4>>2]|0)==19){i=e;return}if((c[(c[g>>2]|0)+4>>2]|0)==20){i=e;return}if((c[(c[g>>2]|0)+4>>2]|0)==18){aS(c[f>>2]|0,c[g>>2]|0);i=e;return}if((c[(c[g>>2]|0)+4>>2]|0)==14){ZR(c[f>>2]|0,c[g>>2]|0);i=e;return}b=c[f>>2]|0;if((c[(c[g>>2]|0)+4>>2]|0)==11){dS(b,c[(c[g>>2]|0)+12>>2]|0);i=e;return}c[n>>2]=c[b+24>>2];if((c[(c[g>>2]|0)+4>>2]|0)==15){nR(c[(c[n>>2]|0)+16>>2]|0,c[g>>2]|0);i=e;return}if((c[(c[g>>2]|0)+4>>2]|0)==16){oR(c[(c[n>>2]|0)+16>>2]|0,c[g>>2]|0);i=e;return}if((c[(c[g>>2]|0)+4>>2]|0)==17){pR(c[(c[n>>2]|0)+16>>2]|0,c[g>>2]|0);i=e;return}b=c[g>>2]|0;if((c[(c[g>>2]|0)+4>>2]|0)==3){if(!(c[b+40>>2]|0)){i=e;return}if((c[(c[g>>2]|0)+8>>2]|0)!=75104?(c[(c[g>>2]|0)+8>>2]|0)==75112:0){Qk(c[n>>2]|0,c[(c[g>>2]|0)+40>>2]|0)|0;i=e;return}Pk(c[n>>2]|0,c[(c[g>>2]|0)+40>>2]|0,c[(c[f>>2]|0)+116>>2]|0)|0;i=e;return}a=c[g>>2]|0;if((c[b+4>>2]|0)==7){b=(c[a+40>>2]|0)!=0;Ok(c[n>>2]|0,2,200752)|0;Qk(c[n>>2]|0,c[(c[g>>2]|0)+8>>2]|0)|0;if(!b){Ok(c[n>>2]|0,2,200768)|0;i=e;return}if(c[(c[g>>2]|0)+40>>2]|0){Ok(c[n>>2]|0,1,200760)|0;Qk(c[n>>2]|0,c[(c[g>>2]|0)+40>>2]|0)|0}Ok(c[n>>2]|0,2,200768)|0;i=e;return}b=c[g>>2]|0;if((c[a+4>>2]|0)==8){if(!(c[b+40>>2]|0)){i=e;return}Ok(c[n>>2]|0,4,200776)|0;Qk(c[n>>2]|0,c[(c[g>>2]|0)+40>>2]|0)|0;Ok(c[n>>2]|0,3,200784)|0;i=e;return}if((c[b+4>>2]|0)==5){Ok(c[n>>2]|0,1,200792)|0;Qk(c[n>>2]|0,c[(c[g>>2]|0)+8>>2]|0)|0;Ok(c[n>>2]|0,1,200800)|0;i=e;return}b=c[g>>2]|0;if((c[(c[g>>2]|0)+4>>2]|0)==4){do if(c[b+40>>2]|0){if(!(d[c[(c[g>>2]|0)+40>>2]>>0]|0))break;a=c[(c[g>>2]|0)+40>>2]|0;c[m>>2]=a;c[l>>2]=a;while(1){if(!(d[c[m>>2]>>0]|0))break;do if((d[c[m>>2]>>0]|0|0)==93){if((d[(c[m>>2]|0)+1>>0]|0|0)!=93)break;if((d[(c[m>>2]|0)+2>>0]|0|0)!=62)break;c[m>>2]=(c[m>>2]|0)+2;Ok(c[n>>2]|0,9,200824)|0;Ok(c[n>>2]|0,(c[m>>2]|0)-(c[l>>2]|0)|0,c[l>>2]|0)|0;Ok(c[n>>2]|0,3,200840)|0;c[l>>2]=c[m>>2]}while(0);c[m>>2]=(c[m>>2]|0)+1}if((c[l>>2]|0)==(c[m>>2]|0)){i=e;return}Ok(c[n>>2]|0,9,200824)|0;Qk(c[n>>2]|0,c[l>>2]|0)|0;Ok(c[n>>2]|0,3,200840)|0;i=e;return}while(0);Ok(c[n>>2]|0,12,200808)|0;i=e;return}l=c[f>>2]|0;if((c[b+4>>2]|0)==2){$R(l,c[g>>2]|0);i=e;return}c[h>>2]=c[l+40>>2];a:do if((c[h>>2]|0)==1){c[k>>2]=c[(c[g>>2]|0)+12>>2];while(1){if(!(c[k>>2]|0))break a;if((c[(c[k>>2]|0)+4>>2]|0)==3)break;if((c[(c[k>>2]|0)+4>>2]|0)==5)break;c[k>>2]=c[(c[k>>2]|0)+24>>2]}c[h>>2]=0}while(0);Ok(c[n>>2]|0,1,200848)|0;do if(c[(c[g>>2]|0)+36>>2]|0){if(!(c[(c[(c[g>>2]|0)+36>>2]|0)+12>>2]|0))break;Qk(c[n>>2]|0,c[(c[(c[g>>2]|0)+36>>2]|0)+12>>2]|0)|0;Ok(c[n>>2]|0,1,200856)|0}while(0);Qk(c[n>>2]|0,c[(c[g>>2]|0)+8>>2]|0)|0;if(c[(c[g>>2]|0)+48>>2]|0)bS(c[f>>2]|0,c[(c[g>>2]|0)+48>>2]|0);do if(qy(c[(c[g>>2]|0)+8>>2]|0,200864)|0){if(c[(c[g>>2]|0)+36>>2]|0)break;if(c[(c[g>>2]|0)+48>>2]|0)break;Qk(c[n>>2]|0,200872)|0}while(0);if(c[(c[g>>2]|0)+44>>2]|0)eS(c[f>>2]|0,c[(c[g>>2]|0)+44>>2]|0);do if((c[(c[g>>2]|0)+4>>2]|0)==1){if(!(c[(c[g>>2]|0)+20>>2]|0))break;if((c[(c[(c[g>>2]|0)+20>>2]|0)+20>>2]|0)!=(c[(c[g>>2]|0)+32>>2]|0))break;if(!(qy(c[(c[g>>2]|0)+8>>2]|0,200912)|0))break;if(!(qy(c[(c[(c[g>>2]|0)+20>>2]|0)+8>>2]|0,200864)|0))break;c[k>>2]=c[(c[g>>2]|0)+12>>2];b:while(1){if(!(c[k>>2]|0))break;do if(qy(c[(c[k>>2]|0)+8>>2]|0,200920)|0){c[o>>2]=Yi(c[k>>2]|0,200928)|0;if(!(c[o>>2]|0))break;l=(ty(c[o>>2]|0,200944)|0)==0;zb[c[135736>>2]&511](c[o>>2]|0);if(l)break b}while(0);c[k>>2]=c[(c[k>>2]|0)+24>>2]}if(c[k>>2]|0)break;c[j>>2]=1}while(0);do if((c[(c[g>>2]|0)+4>>2]|0)==1){if(c[(c[g>>2]|0)+12>>2]|0)break;if(!((c[(c[g>>2]|0)+36>>2]|0)!=0?(c[(c[(c[g>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0))q=86;do if((q|0)==86){k=(fS(c[g>>2]|0)|0)==1;if(!(k&(c[j>>2]|0)==0))break;Ok(c[n>>2]|0,3,200960)|0;i=e;return}while(0);k=(c[j>>2]|0)==1;Ok(c[n>>2]|0,1,200968)|0;do if(k){do if((c[(c[f>>2]|0)+40>>2]|0)==1){Ok(c[n>>2]|0,1,200976)|0;if(!(c[33984]|0))break;o=c[f>>2]|0;if(((c[(c[f>>2]|0)+36>>2]|0)+1|0)>(c[(c[f>>2]|0)+108>>2]|0))r=c[o+108>>2]|0;else r=(c[o+36>>2]|0)+1|0;o=ca(c[(c[f>>2]|0)+112>>2]|0,r)|0;Ok(c[n>>2]|0,o,(c[f>>2]|0)+44|0)|0}while(0);Qk(c[n>>2]|0,200984)|0;o=c[n>>2]|0;if(c[(c[f>>2]|0)+16>>2]|0)Qk(o,c[(c[f>>2]|0)+16>>2]|0)|0;else Ok(o,5,200728)|0;Ok(c[n>>2]|0,4,201048)|0;if((c[(c[f>>2]|0)+40>>2]|0)!=1)break;Ok(c[n>>2]|0,1,200976)|0}while(0);Ok(c[n>>2]|0,2,201056)|0;do if(c[(c[g>>2]|0)+36>>2]|0){if(!(c[(c[(c[g>>2]|0)+36>>2]|0)+12>>2]|0))break;Qk(c[n>>2]|0,c[(c[(c[g>>2]|0)+36>>2]|0)+12>>2]|0)|0;Ok(c[n>>2]|0,1,200856)|0}while(0);Qk(c[n>>2]|0,c[(c[g>>2]|0)+8>>2]|0)|0;Ok(c[n>>2]|0,1,200968)|0;i=e;return}while(0);Ok(c[n>>2]|0,1,200968)|0;if((c[j>>2]|0)==1){do if((c[(c[f>>2]|0)+40>>2]|0)==1){Ok(c[n>>2]|0,1,200976)|0;if(!(c[33984]|0))break;j=c[f>>2]|0;if(((c[(c[f>>2]|0)+36>>2]|0)+1|0)>(c[(c[f>>2]|0)+108>>2]|0))s=c[j+108>>2]|0;else s=(c[j+36>>2]|0)+1|0;j=ca(c[(c[f>>2]|0)+112>>2]|0,s)|0;Ok(c[n>>2]|0,j,(c[f>>2]|0)+44|0)|0}while(0);Qk(c[n>>2]|0,200984)|0;s=c[n>>2]|0;if(c[(c[f>>2]|0)+16>>2]|0)Qk(s,c[(c[f>>2]|0)+16>>2]|0)|0;else Ok(s,5,200728)|0;Ok(c[n>>2]|0,4,201048)|0}do if((c[(c[g>>2]|0)+4>>2]|0)!=1){if(!(c[(c[g>>2]|0)+40>>2]|0))break;Pk(c[n>>2]|0,c[(c[g>>2]|0)+40>>2]|0,c[(c[f>>2]|0)+116>>2]|0)|0}while(0);do if(c[(c[g>>2]|0)+12>>2]|0){c[p>>2]=c[(c[f>>2]|0)+40>>2];if((c[h>>2]|0)==1)Ok(c[n>>2]|0,1,200976)|0;if((c[(c[f>>2]|0)+36>>2]|0)>=0){s=(c[f>>2]|0)+36|0;c[s>>2]=(c[s>>2]|0)+1}c[(c[f>>2]|0)+40>>2]=c[h>>2];dS(c[f>>2]|0,c[(c[g>>2]|0)+12>>2]|0);if((c[(c[f>>2]|0)+36>>2]|0)>0){s=(c[f>>2]|0)+36|0;c[s>>2]=(c[s>>2]|0)+-1}c[(c[f>>2]|0)+40>>2]=c[p>>2];if(!((c[33984]|0)!=0&(c[h>>2]|0)==1))break;s=c[f>>2]|0;if((c[(c[f>>2]|0)+36>>2]|0)>(c[(c[f>>2]|0)+108>>2]|0))t=c[s+108>>2]|0;else t=c[s+36>>2]|0;s=ca(c[(c[f>>2]|0)+112>>2]|0,t)|0;Ok(c[n>>2]|0,s,(c[f>>2]|0)+44|0)|0}while(0);Ok(c[n>>2]|0,2,201056)|0;do if(c[(c[g>>2]|0)+36>>2]|0){if(!(c[(c[(c[g>>2]|0)+36>>2]|0)+12>>2]|0))break;Qk(c[n>>2]|0,c[(c[(c[g>>2]|0)+36>>2]|0)+12>>2]|0)|0;Ok(c[n>>2]|0,1,200856)|0}while(0);Qk(c[n>>2]|0,c[(c[g>>2]|0)+8>>2]|0)|0;Ok(c[n>>2]|0,1,200968)|0;i=e;return}NR(c[f>>2]|0,c[g>>2]|0)|0;i=e;return}function UR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}if(!(c[(c[e>>2]|0)+24>>2]|0)){i=d;return}Ok(c[(c[e>>2]|0)+24>>2]|0,1,200976)|0;c[g>>2]=0;while(1){if((c[g>>2]|0)>=((c[(c[e>>2]|0)+36>>2]|0)+(c[f>>2]|0)|0))break;b=c[e>>2]|0;if(((c[(c[e>>2]|0)+36>>2]|0)+(c[f>>2]|0)-(c[g>>2]|0)|0)>(c[(c[e>>2]|0)+108>>2]|0))h=c[b+108>>2]|0;else h=(c[b+36>>2]|0)+(c[f>>2]|0)-(c[g>>2]|0)|0;b=ca(c[(c[e>>2]|0)+112>>2]|0,h)|0;Ok(c[(c[e>>2]|0)+24>>2]|0,b,(c[e>>2]|0)+44|0)|0;c[g>>2]=(c[g>>2]|0)+(c[(c[e>>2]|0)+108>>2]|0)}i=d;return}function VR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=c[(c[f>>2]|0)+24>>2];do if(((c[g>>2]|0)!=0?(c[(c[h>>2]|0)+12>>2]|0)==0:0)?(c[(c[h>>2]|0)+20>>2]|0)==0:0){f=Dd(c[g>>2]|0)|0;c[(c[h>>2]|0)+12>>2]=f;if(!(c[(c[h>>2]|0)+12>>2]|0)){PR(1403,0,c[g>>2]|0);c[e>>2]=-1;j=c[e>>2]|0;i=d;return j|0}f=Ly()|0;c[(c[h>>2]|0)+20>>2]=f;f=c[h>>2]|0;if(c[(c[h>>2]|0)+20>>2]|0){Gd(f,1)|0;break}Hd(c[f+12>>2]|0)|0;RR(201600);c[e>>2]=-1;j=c[e>>2]|0;i=d;return j|0}while(0);c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}function WR(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;h=i;i=i+48|0;j=h;k=h+40|0;l=h+36|0;m=h+32|0;n=h+28|0;o=h+24|0;p=h+20|0;q=h+16|0;r=h+12|0;s=h+8|0;t=h+4|0;c[l>>2]=b;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[p>>2]=c[l>>2];c[q>>2]=c[n>>2];c[r>>2]=(c[l>>2]|0)+(c[c[m>>2]>>2]|0);c[s>>2]=(c[n>>2]|0)+(c[c[o>>2]>>2]|0);a:while(1){if((c[n>>2]|0)>>>0>=(c[s>>2]|0)>>>0){u=46;break}if((c[l>>2]|0)>>>0>=(c[r>>2]|0)>>>0){u=46;break}if((d[c[n>>2]>>0]|0|0)==60){if(((c[r>>2]|0)-(c[l>>2]|0)|0)<4){u=46;break}g=c[l>>2]|0;c[l>>2]=g+1;a[g>>0]=38;g=c[l>>2]|0;c[l>>2]=g+1;a[g>>0]=108;g=c[l>>2]|0;c[l>>2]=g+1;a[g>>0]=116;g=c[l>>2]|0;c[l>>2]=g+1;a[g>>0]=59;c[n>>2]=(c[n>>2]|0)+1;continue}if((d[c[n>>2]>>0]|0|0)==62){if(((c[r>>2]|0)-(c[l>>2]|0)|0)<4){u=46;break}g=c[l>>2]|0;c[l>>2]=g+1;a[g>>0]=38;g=c[l>>2]|0;c[l>>2]=g+1;a[g>>0]=103;g=c[l>>2]|0;c[l>>2]=g+1;a[g>>0]=116;g=c[l>>2]|0;c[l>>2]=g+1;a[g>>0]=59;c[n>>2]=(c[n>>2]|0)+1;continue}if((d[c[n>>2]>>0]|0|0)==38){if(((c[r>>2]|0)-(c[l>>2]|0)|0)<5){u=46;break}g=c[l>>2]|0;c[l>>2]=g+1;a[g>>0]=38;g=c[l>>2]|0;c[l>>2]=g+1;a[g>>0]=97;g=c[l>>2]|0;c[l>>2]=g+1;a[g>>0]=109;g=c[l>>2]|0;c[l>>2]=g+1;a[g>>0]=112;g=c[l>>2]|0;c[l>>2]=g+1;a[g>>0]=59;c[n>>2]=(c[n>>2]|0)+1;continue}if(!((d[c[n>>2]>>0]|0|0)>=32?(d[c[n>>2]>>0]|0|0)<128:0))u=15;if(((u|0)==15?(u=0,(d[c[n>>2]>>0]|0|0)!=10):0)?(d[c[n>>2]>>0]|0|0)!=9:0){if((d[c[n>>2]>>0]|0|0)<128){if(!(9<=(d[c[n>>2]>>0]|0|0)?(d[c[n>>2]>>0]|0|0)<=10:0))u=41;if(((u|0)==41?(u=0,(d[c[n>>2]>>0]|0|0)!=13):0)?32>(d[c[n>>2]>>0]|0|0):0){u=45;break}if(((c[r>>2]|0)-(c[l>>2]|0)|0)<6){u=46;break}g=c[l>>2]|0;f=c[n>>2]|0;c[n>>2]=f+1;c[l>>2]=QR(g,d[f>>0]|0)|0;continue}if(((c[r>>2]|0)-(c[l>>2]|0)|0)<11){u=46;break}if((d[c[n>>2]>>0]|0|0)<192){u=21;break}do if((d[c[n>>2]>>0]|0|0)<224){if(((c[s>>2]|0)-(c[n>>2]|0)|0)<2){u=46;break a}c[t>>2]=(d[c[n>>2]>>0]|0)&31;c[t>>2]=c[t>>2]<<6;c[t>>2]=c[t>>2]|(d[(c[n>>2]|0)+1>>0]|0)&63;c[n>>2]=(c[n>>2]|0)+2}else{if((d[c[n>>2]>>0]|0|0)<240){if(((c[s>>2]|0)-(c[n>>2]|0)|0)<3){u=46;break a}c[t>>2]=(d[c[n>>2]>>0]|0)&15;c[t>>2]=c[t>>2]<<6;c[t>>2]=c[t>>2]|(d[(c[n>>2]|0)+1>>0]|0)&63;c[t>>2]=c[t>>2]<<6;c[t>>2]=c[t>>2]|(d[(c[n>>2]|0)+2>>0]|0)&63;c[n>>2]=(c[n>>2]|0)+3;break}if((d[c[n>>2]>>0]|0|0)>=248){u=31;break a}if(((c[s>>2]|0)-(c[n>>2]|0)|0)<4){u=46;break a}c[t>>2]=(d[c[n>>2]>>0]|0)&7;c[t>>2]=c[t>>2]<<6;c[t>>2]=c[t>>2]|(d[(c[n>>2]|0)+1>>0]|0)&63;c[t>>2]=c[t>>2]<<6;c[t>>2]=c[t>>2]|(d[(c[n>>2]|0)+2>>0]|0)&63;c[t>>2]=c[t>>2]<<6;c[t>>2]=c[t>>2]|(d[(c[n>>2]|0)+3>>0]|0)&63;c[n>>2]=(c[n>>2]|0)+4}while(0);f=c[t>>2]|0;if((c[t>>2]|0)<256){if(!(9<=(f|0)&(c[t>>2]|0)<=10|(c[t>>2]|0)==13|32<=(c[t>>2]|0))){u=37;break}}else if((!(256<=(f|0)&(c[t>>2]|0)<=55295)?!(57344<=(c[t>>2]|0)&(c[t>>2]|0)<=65533):0)?!(65536<=(c[t>>2]|0)&(c[t>>2]|0)<=1114111):0){u=37;break}c[l>>2]=QR(c[l>>2]|0,c[t>>2]|0)|0;continue}f=c[n>>2]|0;c[n>>2]=f+1;g=a[f>>0]|0;f=c[l>>2]|0;c[l>>2]=f+1;a[f>>0]=g}if((u|0)==21){PR(1400,0,0);c[n>>2]=(c[n>>2]|0)+1}else if((u|0)==31){PR(1401,0,0);c[n>>2]=(c[n>>2]|0)+1}else if((u|0)==37){PR(1401,0,0);c[n>>2]=(c[n>>2]|0)+1}else if((u|0)==45){Db[c[135904>>2]&511](c[33980]|0,201400,j);c[n>>2]=(c[n>>2]|0)+1}else if((u|0)==46){c[c[m>>2]>>2]=(c[l>>2]|0)-(c[p>>2]|0);c[c[o>>2]>>2]=(c[n>>2]|0)-(c[q>>2]|0);c[k>>2]=0;v=c[k>>2]|0;i=h;return v|0}c[c[m>>2]>>2]=(c[l>>2]|0)-(c[p>>2]|0);c[c[o>>2]>>2]=(c[n>>2]|0)-(c[q>>2]|0);
c[k>>2]=-1;v=c[k>>2]|0;i=h;return v|0}function XR(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[(c[d>>2]|0)+24>>2];Ak(c[e>>2]|0)|0;Hd(c[(c[e>>2]|0)+12>>2]|0)|0;Ry(c[(c[e>>2]|0)+20>>2]|0);c[(c[e>>2]|0)+12>>2]=0;c[(c[e>>2]|0)+20>>2]=0;i=b;return 0}function YR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+48|0;e=d+32|0;f=d+28|0;g=d+24|0;h=d+20|0;j=d+16|0;k=d+12|0;l=d+8|0;m=d+4|0;n=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;c[j>>2]=c[(c[f>>2]|0)+16>>2];c[k>>2]=c[(c[f>>2]|0)+16>>2];c[l>>2]=c[(c[f>>2]|0)+24>>2];c[m>>2]=0;Rf();c[n>>2]=c[(c[g>>2]|0)+32>>2];do if(c[n>>2]|0){c[h>>2]=c[(c[n>>2]|0)+60>>2];if(c[(c[f>>2]|0)+16>>2]|0){c[(c[n>>2]|0)+60>>2]=c[(c[f>>2]|0)+16>>2];break}if(c[(c[n>>2]|0)+60>>2]|0)c[k>>2]=c[(c[n>>2]|0)+60>>2]}while(0);if((c[k>>2]|0)!=0&(c[n>>2]|0)!=0)rp(c[n>>2]|0,c[k>>2]|0)|0;if((c[k>>2]|0)==0&(c[n>>2]|0)!=0)c[k>>2]=qp(c[n>>2]|0)|0;if(!(c[k>>2]|0))c[k>>2]=201592;do if(((c[k>>2]|0)!=0&(c[j>>2]|0)==0?(c[(c[l>>2]|0)+12>>2]|0)==0:0)?(c[(c[l>>2]|0)+20>>2]|0)==0:0){if((VR(c[f>>2]|0,c[k>>2]|0)|0)>=0){c[m>>2]=1;break}c[(c[n>>2]|0)+60>>2]=c[h>>2];c[e>>2]=-1;o=c[e>>2]|0;i=d;return o|0}while(0);b=c[l>>2]|0;l=c[n>>2]|0;a=c[g>>2]|0;g=c[k>>2]|0;if(c[(c[f>>2]|0)+32>>2]&1)up(b,l,a,g,1);else up(b,l,a,g,0);if((c[m>>2]|0)!=0&(c[j>>2]|0)==0)XR(c[f>>2]|0)|0;if(c[n>>2]|0)c[(c[n>>2]|0)+60>>2]=c[h>>2];c[e>>2]=0;o=c[e>>2]|0;i=d;return o|0}function ZR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[e>>2]=a;c[f>>2]=b;if((c[f>>2]|0)==0|(c[e>>2]|0)==0){i=d;return}if(!(c[(c[e>>2]|0)+24>>2]|0)){i=d;return}c[g>>2]=c[(c[e>>2]|0)+24>>2];Ok(c[g>>2]|0,10,201336)|0;Qk(c[g>>2]|0,c[(c[f>>2]|0)+8>>2]|0)|0;if(!(c[(c[f>>2]|0)+52>>2]|0)){if(c[(c[f>>2]|0)+56>>2]|0){Ok(c[g>>2]|0,8,201368)|0;gz(c[(c[g>>2]|0)+16>>2]|0,c[(c[f>>2]|0)+56>>2]|0)|0}}else{Ok(c[g>>2]|0,8,201352)|0;gz(c[(c[g>>2]|0)+16>>2]|0,c[(c[f>>2]|0)+52>>2]|0)|0;Ok(c[g>>2]|0,1,200760)|0;gz(c[(c[g>>2]|0)+16>>2]|0,c[(c[f>>2]|0)+56>>2]|0)|0}if(((((c[(c[f>>2]|0)+48>>2]|0)==0?(c[(c[f>>2]|0)+40>>2]|0)==0:0)?(c[(c[f>>2]|0)+44>>2]|0)==0:0)?(c[(c[f>>2]|0)+36>>2]|0)==0:0)?(c[(c[f>>2]|0)+60>>2]|0)==0:0){Ok(c[g>>2]|0,1,200968)|0;i=d;return}Ok(c[g>>2]|0,3,201384)|0;do if(c[(c[f>>2]|0)+36>>2]|0){if((c[(c[f>>2]|0)+32>>2]|0)!=0?(c[(c[(c[f>>2]|0)+32>>2]|0)+44>>2]|0)!=(c[f>>2]|0):0)break;mR(c[(c[g>>2]|0)+16>>2]|0,c[(c[f>>2]|0)+36>>2]|0)}while(0);c[h>>2]=c[(c[e>>2]|0)+40>>2];c[j>>2]=c[(c[e>>2]|0)+36>>2];c[k>>2]=c[(c[e>>2]|0)+28>>2];c[(c[e>>2]|0)+40>>2]=0;c[(c[e>>2]|0)+36>>2]=-1;c[(c[e>>2]|0)+28>>2]=c[(c[f>>2]|0)+32>>2];_R(c[e>>2]|0,c[(c[f>>2]|0)+12>>2]|0);c[(c[e>>2]|0)+40>>2]=c[h>>2];c[(c[e>>2]|0)+36>>2]=c[j>>2];c[(c[e>>2]|0)+28>>2]=c[k>>2];Ok(c[g>>2]|0,2,201392)|0;i=d;return}function _R(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;if(!(c[f>>2]|0)){i=d;return}c[g>>2]=c[(c[e>>2]|0)+24>>2];while(1){if(!(c[f>>2]|0))break;do if((c[33984]|0)!=0?(c[(c[e>>2]|0)+40>>2]|0)==1:0){if(((c[(c[f>>2]|0)+4>>2]|0)!=1?(c[(c[f>>2]|0)+4>>2]|0)!=8:0)?(c[(c[f>>2]|0)+4>>2]|0)!=7:0)break;b=c[e>>2]|0;if((c[(c[e>>2]|0)+36>>2]|0)>(c[(c[e>>2]|0)+108>>2]|0))h=c[b+108>>2]|0;else h=c[b+36>>2]|0;b=ca(c[(c[e>>2]|0)+112>>2]|0,h)|0;Ok(c[g>>2]|0,b,(c[e>>2]|0)+44|0)|0}while(0);OR(c[e>>2]|0,c[f>>2]|0);if((c[(c[e>>2]|0)+40>>2]|0)==1)Ok(c[g>>2]|0,1,200976)|0;c[f>>2]=c[(c[f>>2]|0)+24>>2]}i=d;return}function $R(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;if(!(c[f>>2]|0)){i=d;return}c[g>>2]=c[(c[e>>2]|0)+24>>2];if(!(c[g>>2]|0)){i=d;return}if((c[(c[e>>2]|0)+40>>2]|0)==2)UR(c[e>>2]|0,2);else Ok(c[g>>2]|0,1,200760)|0;if((c[(c[f>>2]|0)+36>>2]|0)!=0?(c[(c[(c[f>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){Qk(c[g>>2]|0,c[(c[(c[f>>2]|0)+36>>2]|0)+12>>2]|0)|0;Ok(c[g>>2]|0,1,200856)|0}Qk(c[g>>2]|0,c[(c[f>>2]|0)+8>>2]|0)|0;Ok(c[g>>2]|0,2,201328)|0;gS(c[g>>2]|0,c[f>>2]|0);Ok(c[g>>2]|0,1,201296)|0;i=d;return}function aS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;KR(c[(c[e>>2]|0)+24>>2]|0,c[f>>2]|0,c[e>>2]|0);i=d;return}function bS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;while(1){if(!(c[f>>2]|0))break;KR(c[(c[e>>2]|0)+24>>2]|0,c[f>>2]|0,c[e>>2]|0);c[f>>2]=c[c[f>>2]>>2]}i=d;return}function cS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if(!((c[f>>2]|0)!=0&(c[f>>2]|0)!=0)){i=d;return}do{$R(c[e>>2]|0,c[f>>2]|0);c[f>>2]=c[(c[f>>2]|0)+24>>2]}while((c[f>>2]|0)!=0);i=d;return}function dS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;if(!(c[f>>2]|0)){i=d;return}c[g>>2]=c[(c[e>>2]|0)+24>>2];while(1){if(!(c[f>>2]|0))break;if(((c[33984]|0)!=0?(c[(c[e>>2]|0)+40>>2]|0)==1:0)?(c[(c[f>>2]|0)+4>>2]|0)==1:0){b=c[e>>2]|0;if((c[(c[e>>2]|0)+36>>2]|0)>(c[(c[e>>2]|0)+108>>2]|0))h=c[b+108>>2]|0;else h=c[b+36>>2]|0;b=ca(c[(c[e>>2]|0)+112>>2]|0,h)|0;Ok(c[g>>2]|0,b,(c[e>>2]|0)+44|0)|0}TR(c[e>>2]|0,c[f>>2]|0);if((c[(c[e>>2]|0)+40>>2]|0)==1)Ok(c[g>>2]|0,1,200976)|0;c[f>>2]=c[(c[f>>2]|0)+24>>2]}i=d;return}function eS(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;n=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=0;c[j>>2]=0;c[k>>2]=0;c[l>>2]=0;if(!(c[g>>2]|0)){i=e;return}c[n>>2]=c[(c[f>>2]|0)+24>>2];c[m>>2]=c[(c[g>>2]|0)+20>>2];while(1){if(!(c[g>>2]|0))break;if((c[(c[g>>2]|0)+36>>2]|0)==0?(qy(c[(c[g>>2]|0)+8>>2]|0,201200)|0)!=0:0)c[l>>2]=c[g>>2];else o=7;do if((o|0)==7){o=0;if((c[(c[g>>2]|0)+36>>2]|0)==0?(qy(c[(c[g>>2]|0)+8>>2]|0,201208)|0)!=0:0){c[k>>2]=c[g>>2];break}if((c[(c[g>>2]|0)+36>>2]|0)==0?(qy(c[(c[g>>2]|0)+8>>2]|0,201216)|0)!=0:0){c[j>>2]=c[g>>2];break}if(((c[(c[g>>2]|0)+36>>2]|0)!=0?(qy(c[(c[g>>2]|0)+8>>2]|0,201216)|0)!=0:0)?(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+12>>2]|0,201224)|0)!=0:0){c[h>>2]=c[g>>2];break}if(!(c[(c[g>>2]|0)+36>>2]|0)){if(((c[(c[g>>2]|0)+12>>2]|0)!=0?(c[(c[(c[g>>2]|0)+12>>2]|0)+40>>2]|0)!=0:0)?(d[c[(c[(c[g>>2]|0)+12>>2]|0)+40>>2]>>0]|0|0)!=0:0)break;if(sp(c[(c[g>>2]|0)+8>>2]|0)|0){if(c[(c[g>>2]|0)+12>>2]|0)Rh(c[(c[g>>2]|0)+12>>2]|0);b=li(c[(c[g>>2]|0)+8>>2]|0)|0;c[(c[g>>2]|0)+12>>2]=b;if(c[(c[g>>2]|0)+12>>2]|0)c[(c[(c[g>>2]|0)+12>>2]|0)+20>>2]=c[g>>2]}}}while(0);$R(c[f>>2]|0,c[g>>2]|0);c[g>>2]=c[(c[g>>2]|0)+24>>2]}do if((c[k>>2]|0)!=0&(c[l>>2]|0)==0&(c[m>>2]|0)!=0?(c[(c[m>>2]|0)+8>>2]|0)!=0:0){if(((((((((qy(c[(c[m>>2]|0)+8>>2]|0,201232)|0)==0?(qy(c[(c[m>>2]|0)+8>>2]|0,201240)|0)==0:0)?(qy(c[(c[m>>2]|0)+8>>2]|0,201248)|0)==0:0)?(qy(c[(c[m>>2]|0)+8>>2]|0,201160)|0)==0:0)?(qy(c[(c[m>>2]|0)+8>>2]|0,201256)|0)==0:0)?(qy(c[(c[m>>2]|0)+8>>2]|0,201264)|0)==0:0)?(qy(c[(c[m>>2]|0)+8>>2]|0,201272)|0)==0:0)?(qy(c[(c[m>>2]|0)+8>>2]|0,201144)|0)==0:0)?(qy(c[(c[m>>2]|0)+8>>2]|0,201280)|0)==0:0)break;Ok(c[n>>2]|0,5,201288)|0;gS(c[n>>2]|0,c[k>>2]|0);Ok(c[n>>2]|0,1,201296)|0}while(0);if((c[j>>2]|0)!=0&(c[h>>2]|0)==0){Ok(c[n>>2]|0,11,201304)|0;gS(c[n>>2]|0,c[j>>2]|0);Ok(c[n>>2]|0,1,201296)|0;i=e;return}if(!((c[h>>2]|0)!=0&(c[j>>2]|0)==0)){i=e;return}Ok(c[n>>2]|0,7,201320)|0;gS(c[n>>2]|0,c[h>>2]|0);Ok(c[n>>2]|0,1,201296)|0;i=e;return}function fS(a){a=a|0;var b=0,e=0,f=0;b=i;i=i+16|0;e=b+4|0;f=b;c[f>>2]=a;a:do if(!(c[f>>2]|0))c[e>>2]=-1;else{if((c[(c[f>>2]|0)+4>>2]|0)!=1){c[e>>2]=0;break}if((c[(c[f>>2]|0)+36>>2]|0)!=0?(qy(c[(c[(c[f>>2]|0)+36>>2]|0)+8>>2]|0,201064)|0)==0:0){c[e>>2]=0;break}if(c[(c[f>>2]|0)+12>>2]|0){c[e>>2]=0;break}do switch(d[c[(c[f>>2]|0)+8>>2]>>0]|0|0){case 98:{if(qy(c[(c[f>>2]|0)+8>>2]|0,201104)|0){c[e>>2]=1;break a}if(qy(c[(c[f>>2]|0)+8>>2]|0,201112)|0){c[e>>2]=1;break a}if(qy(c[(c[f>>2]|0)+8>>2]|0,201120)|0){c[e>>2]=1;break a}else{c[e>>2]=0;break a}break}case 99:{if(qy(c[(c[f>>2]|0)+8>>2]|0,201136)|0){c[e>>2]=1;break a}else{c[e>>2]=0;break a}break}case 97:{if(qy(c[(c[f>>2]|0)+8>>2]|0,201096)|0){c[e>>2]=1;break a}else{c[e>>2]=0;break a}break}case 109:{if(qy(c[(c[f>>2]|0)+8>>2]|0,200920)|0){c[e>>2]=1;break a}else{c[e>>2]=0;break a}break}case 102:{if(qy(c[(c[f>>2]|0)+8>>2]|0,201144)|0){c[e>>2]=1;break a}else{c[e>>2]=0;break a}break}case 105:{if(qy(c[(c[f>>2]|0)+8>>2]|0,201160)|0){c[e>>2]=1;break a}if(qy(c[(c[f>>2]|0)+8>>2]|0,201168)|0){c[e>>2]=1;break a}if(qy(c[(c[f>>2]|0)+8>>2]|0,201176)|0){c[e>>2]=1;break a}else{c[e>>2]=0;break a}break}case 104:{if(qy(c[(c[f>>2]|0)+8>>2]|0,201152)|0){c[e>>2]=1;break a}else{c[e>>2]=0;break a}break}case 112:{if(qy(c[(c[f>>2]|0)+8>>2]|0,201192)|0){c[e>>2]=1;break a}else{c[e>>2]=0;break a}break}case 108:{if(qy(c[(c[f>>2]|0)+8>>2]|0,201184)|0){c[e>>2]=1;break a}else{c[e>>2]=0;break a}break}default:{c[e>>2]=0;break a}}while(0)}while(0);i=b;return c[e>>2]|0}function gS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=c[(c[f>>2]|0)+12>>2];while(1){if(!(c[g>>2]|0))break;b=c[(c[g>>2]|0)+4>>2]|0;if((b|0)==5){cz(c[(c[e>>2]|0)+16>>2]|0,200792,1)|0;a=c[(c[e>>2]|0)+16>>2]|0;h=c[(c[g>>2]|0)+8>>2]|0;cz(a,h,xy(c[(c[g>>2]|0)+8>>2]|0)|0)|0;cz(c[(c[e>>2]|0)+16>>2]|0,200800,1)|0}else if((b|0)==3)xR(c[(c[e>>2]|0)+16>>2]|0,c[(c[f>>2]|0)+32>>2]|0,c[f>>2]|0,c[(c[g>>2]|0)+40>>2]|0);c[g>>2]=c[(c[g>>2]|0)+24>>2]}i=d;return}function hS(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if((c[(c[d>>2]|0)+8>>2]|0)!=0?(c[(c[d>>2]|0)+4>>2]|0)==0:0)Th(c[(c[d>>2]|0)+8>>2]|0);if(c[(c[d>>2]|0)+52>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+52>>2]|0);oS(c[(c[d>>2]|0)+40>>2]|0);pS(c[(c[d>>2]|0)+36>>2]|0);zP(c[(c[d>>2]|0)+20>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function iS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if(!(c[e>>2]|0)){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}c[f>>2]=Cb[c[135744>>2]&511](84)|0;if(!(c[f>>2]|0)){qS(0,201776,0);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}a=(c[f>>2]|0)+0|0;h=a+84|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(h|0));c[c[f>>2]>>2]=1;a=xP()|0;c[(c[f>>2]|0)+24>>2]=a;a=AP(c[(c[f>>2]|0)+24>>2]|0,c[e>>2]|0,-1)|0;c[(c[f>>2]|0)+4>>2]=a;c[(c[f>>2]|0)+64>>2]=0;a=Lr(0)|0;c[(c[f>>2]|0)+36>>2]=a;if(!(c[(c[f>>2]|0)+36>>2]|0)){qS(0,201816,0);jS(c[f>>2]|0);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{c[(c[(c[f>>2]|0)+36>>2]|0)+196>>2]=1;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function jS(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if((c[(c[d>>2]|0)+8>>2]|0)!=0?(c[(c[d>>2]|0)+12>>2]|0)==0:0)Th(c[(c[d>>2]|0)+8>>2]|0);if(c[(c[d>>2]|0)+36>>2]|0)Nr(c[(c[d>>2]|0)+36>>2]|0);if(c[(c[d>>2]|0)+52>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+52>>2]|0);zP(c[(c[d>>2]|0)+24>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function kS(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+48|0;e=b+36|0;f=b+32|0;g=b+28|0;h=b+24|0;j=b+20|0;k=b+16|0;l=b+12|0;m=b+8|0;n=b+4|0;o=b;c[f>>2]=a;c[g>>2]=0;c[l>>2]=0;if(!(c[f>>2]|0)){c[e>>2]=0;p=c[e>>2]|0;i=b;return p|0}c[(c[f>>2]|0)+28>>2]=0;a=c[f>>2]|0;do if(!(c[(c[f>>2]|0)+4>>2]|0)){q=c[f>>2]|0;if(c[a+16>>2]|0){c[h>>2]=hg(c[q+16>>2]|0,c[(c[f>>2]|0)+20>>2]|0,0,0,2)|0;if(c[h>>2]|0){r=my(201944)|0;c[(c[h>>2]|0)+72>>2]=r;r=AP(c[(c[f>>2]|0)+24>>2]|0,201944,-1)|0;c[(c[f>>2]|0)+4>>2]=r;c[(c[f>>2]|0)+12>>2]=0;break}rS(c[f>>2]|0,0,1766,201904,0,0);c[e>>2]=0;p=c[e>>2]|0;i=b;return p|0}else{r=c[f>>2]|0;if(c[q+8>>2]|0){c[h>>2]=c[r+8>>2];c[l>>2]=1;c[(c[f>>2]|0)+12>>2]=1;break}rS(r,0,1758,201904,0,0);c[e>>2]=0;p=c[e>>2]|0;i=b;return p|0}}else{c[h>>2]=gg(c[a+4>>2]|0,0,2)|0;r=c[f>>2]|0;if(c[h>>2]|0){c[r+12>>2]=0;break}rS(r,0,1757,201856,c[(c[f>>2]|0)+4>>2]|0,0);c[e>>2]=0;p=c[e>>2]|0;i=b;return p|0}while(0);c[j>>2]=Pi(c[h>>2]|0)|0;if(!(c[j>>2]|0)){rS(c[f>>2]|0,c[h>>2]|0,1759,201968,0,0);if(!(c[l>>2]|0))Th(c[h>>2]|0);c[e>>2]=0;p=c[e>>2]|0;i=b;return p|0}do if((((c[j>>2]|0)!=0?(c[(c[j>>2]|0)+4>>2]|0)==1:0)?(c[(c[j>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[j>>2]|0)+8>>2]|0,202008)|0)!=0:0){if((qy(c[(c[(c[j>>2]|0)+36>>2]|0)+8>>2]|0,c[50504]|0)|0)==0?(qy(c[(c[(c[j>>2]|0)+36>>2]|0)+8>>2]|0,c[50506]|0)|0)==0:0){s=24;break}c[g>>2]=sS(c[f>>2]|0)|0;if(c[g>>2]|0){c[(c[f>>2]|0)+40>>2]=c[g>>2];c[k>>2]=c[(c[j>>2]|0)+12>>2];while(1){if(!(c[k>>2]|0))break;if((c[(c[k>>2]|0)+4>>2]|0)==1?(c[(c[k>>2]|0)+36>>2]|0)!=0:0){if(qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[50504]|0)|0)break;if(qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[50506]|0)|0)break}c[k>>2]=c[(c[k>>2]|0)+24>>2]}a:do if((((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+4>>2]|0)==1:0)?(c[(c[k>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[k>>2]|0)+8>>2]|0,202088)|0)!=0:0){if((qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[50504]|0)|0)==0?(qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[50506]|0)|0)==0:0)break;c[m>>2]=_i(c[k>>2]|0)|0;if(c[m>>2]|0){a=AP(c[(c[g>>2]|0)+20>>2]|0,c[m>>2]|0,-1)|0;c[(c[g>>2]|0)+24>>2]=a;zb[c[135736>>2]&511](c[m>>2]|0)}c[k>>2]=c[(c[k>>2]|0)+24>>2];while(1){if(!(c[k>>2]|0))break a;do if((c[(c[k>>2]|0)+4>>2]|0)==1){if(!(c[(c[k>>2]|0)+36>>2]|0))break;if(qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[50504]|0)|0)break a;if(qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[50506]|0)|0)break a}while(0);c[k>>2]=c[(c[k>>2]|0)+24>>2]}}while(0);b:while(1){if(!(c[k>>2]|0))break;if((c[(c[k>>2]|0)+4>>2]|0)!=1)break;if(!(c[(c[k>>2]|0)+36>>2]|0))break;if(!(qy(c[(c[k>>2]|0)+8>>2]|0,202096)|0))break;if((qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[50504]|0)|0)==0?(qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[50506]|0)|0)==0:0)break;c[n>>2]=ej(c[k>>2]|0,202104)|0;c[o>>2]=ej(c[k>>2]|0,202112)|0;if(!((c[o>>2]|0)!=0?(d[c[o>>2]>>0]|0|0)!=0:0))rS(c[f>>2]|0,c[k>>2]|0,1759,202120,0,0);if(!((c[n>>2]|0)!=0?(d[c[n>>2]>>0]|0|0)!=0:0))rS(c[f>>2]|0,c[k>>2]|0,1759,202144,0,0);if((c[n>>2]|0)!=0&(c[o>>2]|0)!=0){rr(c[(c[f>>2]|0)+36>>2]|0,c[n>>2]|0,c[o>>2]|0)|0;tS(c[f>>2]|0,c[n>>2]|0,c[o>>2]|0);a=(c[g>>2]|0)+28|0;c[a>>2]=(c[a>>2]|0)+1}if(c[o>>2]|0)zb[c[135736>>2]&511](c[o>>2]|0);if(c[n>>2]|0)zb[c[135736>>2]&511](c[n>>2]|0);c[k>>2]=c[(c[k>>2]|0)+24>>2];while(1){if(!(c[k>>2]|0))continue b;do if((c[(c[k>>2]|0)+4>>2]|0)==1){if(!(c[(c[k>>2]|0)+36>>2]|0))break;if(qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[50504]|0)|0)continue b;if(qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[50506]|0)|0)continue b}while(0);c[k>>2]=c[(c[k>>2]|0)+24>>2]}}c:while(1){if(!(c[k>>2]|0))break;do if((((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+4>>2]|0)==1:0)?(c[(c[k>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[k>>2]|0)+8>>2]|0,202176)|0)!=0:0){if((qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[50504]|0)|0)==0?(qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[50506]|0)|0)==0:0){s=81;break}uS(c[f>>2]|0,c[k>>2]|0);a=(c[g>>2]|0)+32|0;c[a>>2]=(c[a>>2]|0)+1}else s=81;while(0);if((s|0)==81){s=0;rS(c[f>>2]|0,c[k>>2]|0,1759,202184,c[(c[k>>2]|0)+8>>2]|0,0)}c[k>>2]=c[(c[k>>2]|0)+24>>2];while(1){if(!(c[k>>2]|0))continue c;if((c[(c[k>>2]|0)+4>>2]|0)==1?(c[(c[k>>2]|0)+36>>2]|0)!=0:0){if(qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[50504]|0)|0)continue c;if(qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[50506]|0)|0)continue c}c[k>>2]=c[(c[k>>2]|0)+24>>2]}}if(!(c[(c[g>>2]|0)+32>>2]|0)){rS(c[f>>2]|0,c[j>>2]|0,1759,202232,c[(c[f>>2]|0)+4>>2]|0,0);break}c[(c[g>>2]|0)+8>>2]=c[h>>2];if(c[l>>2]|0)c[(c[g>>2]|0)+4>>2]=1;c[l>>2]=1}}else s=24;while(0);if((s|0)==24)rS(c[f>>2]|0,c[j>>2]|0,1759,202032,c[(c[f>>2]|0)+4>>2]|0,0);if(!(c[l>>2]|0))Th(c[h>>2]|0);do if(c[g>>2]|0)if(c[(c[f>>2]|0)+28>>2]|0){hS(c[g>>2]|0);c[g>>2]=0;break}else{c[(c[g>>2]|0)+52>>2]=c[(c[f>>2]|0)+52>>2];c[(c[g>>2]|0)+44>>2]=c[(c[f>>2]|0)+44>>2];c[(c[f>>2]|0)+52>>2]=0;break}while(0);c[e>>2]=c[g>>2];p=c[e>>2]|0;i=b;return p|0}function lS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[f>>2]=a;c[g>>2]=b;c[j>>2]=Cb[c[135744>>2]&511](64)|0;if(!(c[j>>2]|0)){vS(0,202280,0);c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}b=(c[j>>2]|0)+0|0;a=b+64|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(a|0));c[c[j>>2]>>2]=2;c[(c[j>>2]|0)+20>>2]=c[f>>2];b=Lr(0)|0;c[(c[j>>2]|0)+24>>2]=b;c[(c[j>>2]|0)+4>>2]=c[g>>2];if(!(c[(c[j>>2]|0)+24>>2]|0)){qS(0,201816,0);mS(c[j>>2]|0);c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[(c[f>>2]|0)+44>>2]|0))break;if(!(c[(c[(c[f>>2]|0)+52>>2]|0)+(c[h>>2]<<1<<2)>>2]|0))break;if(!(c[(c[(c[f>>2]|0)+52>>2]|0)+((c[h>>2]<<1)+1<<2)>>2]|0))break;rr(c[(c[j>>2]|0)+24>>2]|0,c[(c[(c[f>>2]|0)+52>>2]|0)+((c[h>>2]<<1)+1<<2)>>2]|0,c[(c[(c[f>>2]|0)+52>>2]|0)+(c[h>>2]<<1<<2)>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+1}c[e>>2]=c[j>>2];k=c[e>>2]|0;i=d;return k|0}function mS(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+24>>2]|0)Nr(c[(c[d>>2]|0)+24>>2]|0);if(c[(c[d>>2]|0)+8>>2]|0)zP(c[(c[d>>2]|0)+8>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function nS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+48|0;e=d;f=d+36|0;g=d+32|0;h=d+28|0;j=d+24|0;k=d+20|0;l=d+16|0;m=d+12|0;n=d+8|0;c[g>>2]=a;c[h>>2]=b;if(((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+20>>2]|0)!=0:0)?!((c[h>>2]|0)==0?1:(c[(c[(c[g>>2]|0)+20>>2]|0)+40>>2]|0)==0):0){c[(c[g>>2]|0)+12>>2]=0;c[k>>2]=Pi(c[h>>2]|0)|0;if(!(c[k>>2]|0)){b=c[33976]|0;a=c[33980]|0;c[e>>2]=202344;c[e+4>>2]=1679;Db[b&511](a,202312,e);e=(c[g>>2]|0)+12|0;c[e>>2]=(c[e>>2]|0)+1;c[f>>2]=1;o=c[f>>2]|0;i=d;return o|0}a:do if((c[(c[g>>2]|0)+4>>2]&1|0)==0?(c[(c[g>>2]|0)+4>>2]|0)!=0:0){c[l>>2]=c[(c[(c[g>>2]|0)+20>>2]|0)+36>>2];while(1){if(!(c[l>>2]|0))break a;yS(c[g>>2]|0,c[l>>2]|0);c[j>>2]=c[k>>2];while(1){p=c[l>>2]|0;if(!(c[j>>2]|0))break;c[m>>2]=c[p+4>>2];while(1){if(!(c[m>>2]|0))break;b:do if((NQ(c[(c[m>>2]|0)+20>>2]|0,c[j>>2]|0)|0)==1){c[n>>2]=c[(c[m>>2]|0)+16>>2];while(1){if(!(c[n>>2]|0))break b;wS(c[g>>2]|0,c[n>>2]|0,c[h>>2]|0,c[j>>2]|0,c[l>>2]|0)|0;c[n>>2]=c[c[n>>2]>>2]}}while(0);c[m>>2]=c[(c[m>>2]|0)+4>>2]}c[j>>2]=xS(c[j>>2]|0)|0}c[l>>2]=c[p>>2]}}else q=9;while(0);c:do if((q|0)==9){c[j>>2]=c[k>>2];while(1){if(!(c[j>>2]|0))break c;c[m>>2]=c[(c[(c[g>>2]|0)+20>>2]|0)+40>>2];while(1){if(!(c[m>>2]|0))break;d:do if((NQ(c[(c[m>>2]|0)+20>>2]|0,c[j>>2]|0)|0)==1){c[n>>2]=c[(c[m>>2]|0)+16>>2];while(1){if(!(c[n>>2]|0))break d;wS(c[g>>2]|0,c[n>>2]|0,c[h>>2]|0,c[j>>2]|0,c[(c[m>>2]|0)+20>>2]|0)|0;c[n>>2]=c[c[n>>2]>>2]}}while(0);c[m>>2]=c[c[m>>2]>>2]}c[j>>2]=xS(c[j>>2]|0)|0}}while(0);c[f>>2]=c[(c[g>>2]|0)+12>>2];o=c[f>>2]|0;i=d;return o|0}c[f>>2]=-1;o=c[f>>2]|0;i=d;return o|0}function oS(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;while(1){if(!(c[d>>2]|0))break;c[e>>2]=c[c[d>>2]>>2];if(c[(c[d>>2]|0)+16>>2]|0)zS(c[(c[d>>2]|0)+16>>2]|0);if(c[(c[d>>2]|0)+12>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+12>>2]|0);if(c[(c[d>>2]|0)+20>>2]|0)EQ(c[(c[d>>2]|0)+20>>2]|0);if(c[(c[d>>2]|0)+24>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+24>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);c[d>>2]=c[e>>2]}i=b;return}function pS(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;while(1){if(!(c[d>>2]|0))break;c[e>>2]=c[c[d>>2]>>2];if(c[(c[d>>2]|0)+8>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+8>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);c[d>>2]=c[e>>2]}i=b;return}function qS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if(c[f>>2]|0){d=(c[f>>2]|0)+28|0;c[d>>2]=(c[d>>2]|0)+1}ce(16,2,c[h>>2]|0,0,c[g>>2]|0);i=e;return}function rS(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+48|0;j=h;k=h+40|0;l=h+36|0;m=h+32|0;n=h+28|0;o=h+24|0;p=h+20|0;q=h+16|0;r=h+12|0;s=h+8|0;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=0;c[r>>2]=0;c[s>>2]=0;if(c[k>>2]|0){g=(c[k>>2]|0)+28|0;c[g>>2]=(c[g>>2]|0)+1;c[q>>2]=c[(c[k>>2]|0)+72>>2];c[s>>2]=c[(c[k>>2]|0)+68>>2];c[r>>2]=c[(c[k>>2]|0)+80>>2]}g=c[r>>2]|0;r=c[q>>2]|0;q=c[s>>2]|0;s=c[k>>2]|0;k=c[l>>2]|0;l=c[m>>2]|0;m=c[o>>2]|0;f=c[p>>2]|0;e=c[n>>2]|0;n=c[p>>2]|0;c[j>>2]=c[o>>2];c[j+4>>2]=n;Xd(g,r,q,s,k,16,l,2,0,0,m,f,0,0,0,e,j);i=h;return}function sS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=Cb[c[135744>>2]&511](56)|0;if(!(c[f>>2]|0)){qS(c[e>>2]|0,203040,0);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{a=(c[f>>2]|0)+0|0;h=a+56|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(h|0));c[(c[f>>2]|0)+20>>2]=c[(c[e>>2]|0)+24>>2];yP(c[(c[f>>2]|0)+20>>2]|0)|0;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function tS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=c[f>>2]|0;do if(c[(c[f>>2]|0)+52>>2]|0){if(((c[d+44>>2]|0)+2|0)>=(c[(c[f>>2]|0)+48>>2]|0)){c[j>>2]=Hb[c[135760>>2]&511](c[(c[f>>2]|0)+52>>2]|0,c[(c[f>>2]|0)+48>>2]<<2<<2)|0;if(c[j>>2]|0){c[(c[f>>2]|0)+52>>2]=c[j>>2];b=(c[f>>2]|0)+48|0;c[b>>2]=c[b>>2]<<1;break}qS(0,203008,0);i=e;return}}else{c[d+48>>2]=10;b=Cb[c[135744>>2]&511](c[(c[f>>2]|0)+48>>2]<<1<<2)|0;c[(c[f>>2]|0)+52>>2]=b;if(c[(c[f>>2]|0)+52>>2]|0){c[(c[f>>2]|0)+44>>2]=0;break}qS(0,203008,0);i=e;return}while(0);d=AP(c[(c[f>>2]|0)+24>>2]|0,c[h>>2]|0,-1)|0;c[(c[(c[f>>2]|0)+52>>2]|0)+(c[(c[f>>2]|0)+44>>2]<<1<<2)>>2]=d;d=AP(c[(c[f>>2]|0)+24>>2]|0,c[g>>2]|0,-1)|0;c[(c[(c[f>>2]|0)+52>>2]|0)+((c[(c[f>>2]|0)+44>>2]<<1)+1<<2)>>2]=d;d=(c[f>>2]|0)+44|0;c[d>>2]=(c[d>>2]|0)+1;c[(c[(c[f>>2]|0)+52>>2]|0)+(c[(c[f>>2]|0)+44>>2]<<1<<2)>>2]=0;c[(c[(c[f>>2]|0)+52>>2]|0)+((c[(c[f>>2]|0)+44>>2]<<1)+1<<2)>>2]=0;i=e;return}function uS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[e>>2]=a;c[f>>2]=b;c[j>>2]=0;if((c[e>>2]|0)==0|(c[f>>2]|0)==0){i=d;return}c[k>>2]=ej(c[f>>2]|0,202488)|0;if(!(c[k>>2]|0))c[k>>2]=ej(c[f>>2]|0,202464)|0;c[h>>2]=AS(c[e>>2]|0,c[(c[e>>2]|0)+40>>2]|0,c[f>>2]|0,c[k>>2]|0)|0;if(!(c[h>>2]|0)){if(!(c[k>>2]|0)){i=d;return}zb[c[135736>>2]&511](c[k>>2]|0);i=d;return}c[g>>2]=c[(c[f>>2]|0)+12>>2];while(1){if(!(c[g>>2]|0))break;if((c[(c[g>>2]|0)+4>>2]|0)==1?(c[(c[g>>2]|0)+36>>2]|0)!=0:0){if(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,c[50504]|0)|0)break;if(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,c[50506]|0)|0)break}c[g>>2]=c[(c[g>>2]|0)+24>>2]}a:while(1){if(!(c[g>>2]|0))break;do if((((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+4>>2]|0)==1:0)?(c[(c[g>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[g>>2]|0)+8>>2]|0,202496)|0)!=0:0){if((qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,c[50504]|0)|0)==0?(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,c[50506]|0)|0)==0:0){l=22;break}BS(c[e>>2]|0,c[h>>2]|0,c[g>>2]|0);c[j>>2]=(c[j>>2]|0)+1}else l=22;while(0);if((l|0)==22){l=0;rS(c[e>>2]|0,c[g>>2]|0,1759,202504,c[(c[g>>2]|0)+8>>2]|0,0)}c[g>>2]=c[(c[g>>2]|0)+24>>2];while(1){if(!(c[g>>2]|0))continue a;if((c[(c[g>>2]|0)+4>>2]|0)==1?(c[(c[g>>2]|0)+36>>2]|0)!=0:0){if(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,c[50504]|0)|0)continue a;if(qy(c[(c[(c[g>>2]|0)+36>>2]|0)+8>>2]|0,c[50506]|0)|0)continue a}c[g>>2]=c[(c[g>>2]|0)+24>>2]}}if(c[j>>2]|0){i=d;return}rS(c[e>>2]|0,c[f>>2]|0,1759,202544,0,0);i=d;return}function vS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if(c[f>>2]|0){d=(c[f>>2]|0)+12|0;c[d>>2]=(c[d>>2]|0)+1;c[(c[f>>2]|0)+16>>2]=1818}ce(17,2,c[h>>2]|0,0,c[g>>2]|0);i=e;return}function wS(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+32|0;k=j+24|0;l=j+20|0;m=j+16|0;n=j+12|0;o=j+8|0;p=j+4|0;q=j;c[k>>2]=a;c[l>>2]=b;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[q>>2]=0;c[c[(c[k>>2]|0)+24>>2]>>2]=c[m>>2];c[(c[(c[k>>2]|0)+24>>2]|0)+4>>2]=c[n>>2];c[p>>2]=Ps(c[(c[l>>2]|0)+16>>2]|0,c[(c[k>>2]|0)+24>>2]|0)|0;if(!(c[p>>2]|0))c[q>>2]=1;else{a:do switch(c[c[p>>2]>>2]|0){case 4:{if((c[(c[p>>2]|0)+24>>2]|0)!=0?(d[c[(c[p>>2]|0)+24>>2]>>0]|0|0)!=0:0)break a;c[q>>2]=1;break}case 3:{if((Lq(+h[(c[p>>2]|0)+16>>3])|0)==0?!(+h[(c[p>>2]|0)+16>>3]==0):0)break a;c[q>>2]=1;break}case 8:case 7:case 6:case 5:case 0:{c[q>>2]=1;break}case 2:{c[q>>2]=((c[(c[p>>2]|0)+8>>2]|0)!=0^1)&1;break}case 1:case 9:{if((c[(c[p>>2]|0)+4>>2]|0)!=0?(c[c[(c[p>>2]|0)+4>>2]>>2]|0)!=0:0)break a;c[q>>2]=1;break}default:{}}while(0);Qq(c[p>>2]|0)}if((c[q>>2]|0)!=0?(c[(c[l>>2]|0)+4>>2]|0)==1:0){p=(c[k>>2]|0)+12|0;c[p>>2]=(c[p>>2]|0)+1}else r=19;if(((r|0)==19?(c[q>>2]|0)==0:0)?(c[(c[l>>2]|0)+4>>2]|0)==2:0){r=(c[k>>2]|0)+12|0;c[r>>2]=(c[r>>2]|0)+1}CS(c[k>>2]|0,c[l>>2]|0,c[n>>2]|0,c[o>>2]|0,((c[q>>2]|0)!=0^1)&1);i=j;return((c[q>>2]|0)!=0^1)&1|0}function xS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;if(((c[(c[e>>2]|0)+12>>2]|0)!=0?(c[(c[(c[e>>2]|0)+12>>2]|0)+4>>2]|0)!=17:0)?(c[e>>2]=c[(c[e>>2]|0)+12>>2],(c[(c[e>>2]|0)+4>>2]|0)!=14):0){c[d>>2]=c[e>>2];f=c[d>>2]|0;i=b;return f|0}while(1){if(!(c[(c[e>>2]|0)+24>>2]|0))break;c[e>>2]=c[(c[e>>2]|0)+24>>2];if((c[(c[e>>2]|0)+4>>2]|0)==17)continue;if((c[(c[e>>2]|0)+4>>2]|0)!=14){g=8;break}}if((g|0)==8){c[d>>2]=c[e>>2];f=c[d>>2]|0;i=b;return f|0}while(1){c[e>>2]=c[(c[e>>2]|0)+20>>2];if(!(c[e>>2]|0)){g=15;break}if((c[(c[e>>2]|0)+4>>2]|0)==9){g=11;break}h=c[e>>2]|0;if(c[(c[e>>2]|0)+24>>2]|0){g=13;break}if(!h){g=15;break}}if((g|0)==11){c[d>>2]=0;f=c[d>>2]|0;i=b;return f|0}else if((g|0)==13){c[e>>2]=c[h+24>>2];c[d>>2]=c[e>>2];f=c[d>>2]|0;i=b;return f|0}else if((g|0)==15){c[d>>2]=c[e>>2];f=c[d>>2]|0;i=b;return f|0}return 0}function yS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+1024|0;e=d;f=d+12|0;g=d+8|0;h=d+16|0;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){i=d;return}if(c[(c[f>>2]|0)+4>>2]&1){i=d;return}if(c[(c[f>>2]|0)+4>>2]&8){i=d;return}if(c[(c[f>>2]|0)+4>>2]&4){b=c[33976]|0;a=c[33980]|0;c[e>>2]=202344;c[e+4>>2]=1457;Db[b&511](a,202312,e);i=d;return}if(!(c[(c[g>>2]|0)+8>>2]|0)){i=d;return}c[e>>2]=c[(c[g>>2]|0)+8>>2];JT(h,999,202368,e)|0;DS(c[f>>2]|0,0,h);i=d;return}function zS(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;while(1){if(!(c[d>>2]|0))break;c[e>>2]=c[c[d>>2]>>2];if(c[(c[d>>2]|0)+12>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+12>>2]|0);if(c[(c[d>>2]|0)+16>>2]|0)Pq(c[(c[d>>2]|0)+16>>2]|0);if(c[(c[d>>2]|0)+20>>2]|0)zb[c[135736>>2]&511](c[(c[d>>2]|0)+20>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);c[d>>2]=c[e>>2]}i=b;return}function AS(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if((c[h>>2]|0)==0|(c[j>>2]|0)==0|(c[k>>2]|0)==0|(c[l>>2]|0)==0){c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}c[m>>2]=Cb[c[135744>>2]&511](12)|0;if(!(c[m>>2]|0)){qS(c[h>>2]|0,202976,c[k>>2]|0);c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}k=c[m>>2]|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[(c[m>>2]|0)+8>>2]=c[l>>2];c[c[m>>2]>>2]=0;if(!(c[(c[j>>2]|0)+36>>2]|0))c[(c[j>>2]|0)+36>>2]=c[m>>2];else{c[n>>2]=c[(c[j>>2]|0)+36>>2];while(1){if(!(c[c[n>>2]>>2]|0))break;c[n>>2]=c[c[n>>2]>>2]}c[c[n>>2]>>2]=c[m>>2]}c[g>>2]=c[m>>2];o=c[g>>2]|0;i=f;return o|0}function BS(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+48|0;g=f+36|0;h=f+32|0;j=f+28|0;k=f+24|0;l=f+20|0;m=f+16|0;n=f+12|0;o=f+8|0;p=f+4|0;q=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=e;c[l>>2]=0;if((c[g>>2]|0)==0|(c[j>>2]|0)==0){i=f;return}c[n>>2]=ej(c[j>>2]|0,202576)|0;if(!(c[n>>2]|0)){rS(c[g>>2]|0,c[j>>2]|0,1759,202584,0,0);i=f;return}e=c[g>>2]|0;if(!(d[c[n>>2]>>0]|0)){rS(e,c[j>>2]|0,1759,202616,0,0);zb[c[135736>>2]&511](c[n>>2]|0);i=f;return}c[p>>2]=ES(e,c[(c[g>>2]|0)+40>>2]|0,c[h>>2]|0,c[j>>2]|0,c[n>>2]|0,0)|0;if(!(c[p>>2]|0)){zb[c[135736>>2]&511](c[n>>2]|0);i=f;return}c[k>>2]=c[(c[j>>2]|0)+12>>2];while(1){if(!(c[k>>2]|0))break;if((c[(c[k>>2]|0)+4>>2]|0)==1?(c[(c[k>>2]|0)+36>>2]|0)!=0:0){if(qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[50504]|0)|0)break;if(qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[50506]|0)|0)break}c[k>>2]=c[(c[k>>2]|0)+24>>2]}a:while(1){if(!(c[k>>2]|0))break;do if((((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+4>>2]|0)==1:0)?(c[(c[k>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[k>>2]|0)+8>>2]|0,202656)|0)!=0:0){if((qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[50504]|0)|0)==0?(qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[50506]|0)|0)==0:0){r=28;break}c[l>>2]=(c[l>>2]|0)+1;c[m>>2]=ej(c[k>>2]|0,202664)|0;if(!(c[m>>2]|0)){rS(c[g>>2]|0,c[k>>2]|0,1759,202672,0,0);break}if(!(d[c[m>>2]>>0]|0)){rS(c[g>>2]|0,c[k>>2]|0,1759,202704,0,0);zb[c[135736>>2]&511](c[m>>2]|0);break}c[o>>2]=_i(c[k>>2]|0)|0;c[q>>2]=FS(c[g>>2]|0,1,c[p>>2]|0,c[k>>2]|0,c[m>>2]|0,c[o>>2]|0)|0;if(!(c[q>>2]|0))zb[c[135736>>2]&511](c[m>>2]|0)}else r=28;while(0);b:do if((r|0)==28){r=0;do if((((c[k>>2]|0)!=0?(c[(c[k>>2]|0)+4>>2]|0)==1:0)?(c[(c[k>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[k>>2]|0)+8>>2]|0,202744)|0)!=0:0){if((qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[50504]|0)|0)==0?(qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[50506]|0)|0)==0:0)break;c[l>>2]=(c[l>>2]|0)+1;c[m>>2]=ej(c[k>>2]|0,202664)|0;if(!(c[m>>2]|0)){rS(c[g>>2]|0,c[k>>2]|0,1759,202672,0,0);break b}if(!(d[c[m>>2]>>0]|0)){rS(c[g>>2]|0,c[k>>2]|0,1759,202704,0,0);zb[c[135736>>2]&511](c[m>>2]|0);break b}c[o>>2]=_i(c[k>>2]|0)|0;c[q>>2]=FS(c[g>>2]|0,2,c[p>>2]|0,c[k>>2]|0,c[m>>2]|0,c[o>>2]|0)|0;if(c[q>>2]|0)break b;zb[c[135736>>2]&511](c[m>>2]|0);break b}while(0);rS(c[g>>2]|0,c[k>>2]|0,1759,202752,c[(c[k>>2]|0)+8>>2]|0,0)}while(0);c[k>>2]=c[(c[k>>2]|0)+24>>2];while(1){if(!(c[k>>2]|0))continue a;if((c[(c[k>>2]|0)+4>>2]|0)==1?(c[(c[k>>2]|0)+36>>2]|0)!=0:0){if(qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[50504]|0)|0)continue a;if(qy(c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0,c[50506]|0)|0)continue a}c[k>>2]=c[(c[k>>2]|0)+24>>2]}}if(c[l>>2]|0){i=f;return}rS(c[g>>2]|0,c[j>>2]|0,1759,202808,0,0);i=f;return}function CS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+1056|0;h=g;j=g+52|0;k=g+48|0;l=g+44|0;m=g+40|0;n=g+36|0;o=g+32|0;p=g+56|0;q=g+28|0;r=g+24|0;s=g+20|0;t=g+16|0;u=g+12|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;if((c[j>>2]|0)==0|(c[l>>2]|0)==0|(c[k>>2]|0)==0){i=g;return}if(((c[(c[j>>2]|0)+4>>2]&1|0)!=0?(c[(c[j>>2]|0)+4>>2]&4|0)==0:0)?(c[(c[k>>2]|0)+4>>2]|0)==2:0){i=g;return}if(c[(c[j>>2]|0)+4>>2]&4){f=c[33976]|0;e=c[33980]|0;c[h>>2]=202344;c[h+4>>2]=1380;Db[f&511](e,202312,h);i=g;return}c[r>>2]=0;if((c[(c[k>>2]|0)+4>>2]|0)==2&(((c[n>>2]|0)!=0^1)&1)){i=g;return}if((c[(c[k>>2]|0)+4>>2]|0)==1&c[n>>2]){i=g;return}c[q>>2]=Ni(c[l>>2]|0)|0;c[o>>2]=Oi(c[l>>2]|0)|0;if(!(c[o>>2]|0))c[o>>2]=c[(c[l>>2]|0)+8>>2];if(c[(c[k>>2]|0)+8>>2]|0)c[r>>2]=GS(c[j>>2]|0,c[(c[k>>2]|0)+8>>2]|0,c[l>>2]|0)|0;do if(!(c[r>>2]|0))if((c[(c[k>>2]|0)+4>>2]|0)==1){c[r>>2]=my(202392)|0;break}else{c[r>>2]=my(202416)|0;break}while(0);n=c[q>>2]|0;e=c[r>>2]|0;c[h>>2]=c[o>>2];c[h+4>>2]=n;c[h+8>>2]=e;JT(p,999,202440,h)|0;if(c[(c[j>>2]|0)+4>>2]&8){c[s>>2]=0;c[t>>2]=0;c[u>>2]=0;if(c[j>>2]|0){e=c[j>>2]|0;if(c[(c[j>>2]|0)+60>>2]|0)c[s>>2]=c[e+60>>2];else c[t>>2]=c[e+52>>2];c[u>>2]=c[(c[j>>2]|0)+48>>2]}e=c[s>>2]|0;s=c[t>>2]|0;t=c[u>>2]|0;u=c[l>>2]|0;n=(c[(c[k>>2]|0)+4>>2]|0)==1?4e3:4001;k=c[q>>2]|0;if(!(c[m>>2]|0))v=0;else v=c[(c[m>>2]|0)+8>>2]|0;m=c[o>>2]|0;q=c[r>>2]|0;c[h>>2]=p;Xd(e,s,t,0,u,28,n,2,0,k,v,m,q,0,0,202384,h)}else DS(c[j>>2]|0,c[l>>2]|0,p);zb[c[135736>>2]&511](c[r>>2]|0);if(!(c[o>>2]|0)){i=g;return}if((c[o>>2]|0)==(c[(c[l>>2]|0)+8>>2]|0)){i=g;return}zb[c[135736>>2]&511](c[o>>2]|0);i=g;return}function DS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+4|0;c[e+12>>2]=a;c[e+8>>2]=b;c[g>>2]=d;d=c[o>>2]|0;c[f>>2]=c[g>>2];Ka(d|0,202384,f|0)|0;i=e;return}function ES(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+48|0;j=h+40|0;k=h+36|0;l=h+32|0;m=h+28|0;n=h+24|0;o=h+20|0;p=h+16|0;q=h+12|0;r=h+8|0;s=h+4|0;t=h;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;if((c[k>>2]|0)==0|(c[l>>2]|0)==0|(c[n>>2]|0)==0|(c[o>>2]|0)==0){c[j>>2]=0;u=c[j>>2]|0;i=h;return u|0}c[r>>2]=MQ(c[o>>2]|0,c[(c[k>>2]|0)+24>>2]|0,1,c[(c[k>>2]|0)+52>>2]|0)|0;if(!(c[r>>2]|0))rS(c[k>>2]|0,c[n>>2]|0,1759,202912,c[o>>2]|0,0);c[q>>2]=Cb[c[135744>>2]&511](28)|0;if(!(c[q>>2]|0)){qS(c[k>>2]|0,202952,c[n>>2]|0);c[j>>2]=0;u=c[j>>2]|0;i=h;return u|0}k=c[q>>2]|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[k+24>>2]=0;c[(c[q>>2]|0)+8>>2]=c[n>>2];c[(c[q>>2]|0)+12>>2]=c[o>>2];c[(c[q>>2]|0)+20>>2]=c[r>>2];c[(c[q>>2]|0)+24>>2]=c[p>>2];c[c[q>>2]>>2]=0;if(!(c[(c[l>>2]|0)+40>>2]|0))c[(c[l>>2]|0)+40>>2]=c[q>>2];else{c[s>>2]=c[(c[l>>2]|0)+40>>2];while(1){if(!(c[c[s>>2]>>2]|0))break;c[s>>2]=c[c[s>>2]>>2]}c[c[s>>2]>>2]=c[q>>2]}c[(c[q>>2]|0)+4>>2]=0;if(!(c[(c[m>>2]|0)+4>>2]|0))c[(c[m>>2]|0)+4>>2]=c[q>>2];else{c[t>>2]=c[(c[m>>2]|0)+4>>2];while(1){if(!(c[(c[t>>2]|0)+4>>2]|0))break;c[t>>2]=c[(c[t>>2]|0)+4>>2]}c[(c[t>>2]|0)+4>>2]=c[q>>2]}c[j>>2]=c[q>>2];
u=c[j>>2]|0;i=h;return u|0}function FS(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=h+36|0;k=h+32|0;l=h+28|0;m=h+24|0;n=h+20|0;o=h+16|0;p=h+12|0;q=h+8|0;r=h+4|0;s=h;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;if((c[k>>2]|0)==0|(c[m>>2]|0)==0|(c[n>>2]|0)==0|(c[o>>2]|0)==0){c[j>>2]=0;t=c[j>>2]|0;i=h;return t|0}c[r>>2]=Os(c[(c[k>>2]|0)+36>>2]|0,c[o>>2]|0)|0;if(!(c[r>>2]|0)){rS(c[k>>2]|0,c[n>>2]|0,1759,202848,c[o>>2]|0,0);c[j>>2]=0;t=c[j>>2]|0;i=h;return t|0}c[q>>2]=Cb[c[135744>>2]&511](24)|0;if(!(c[q>>2]|0)){qS(c[k>>2]|0,202888,c[n>>2]|0);c[j>>2]=0;t=c[j>>2]|0;i=h;return t|0}k=c[q>>2]|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[(c[q>>2]|0)+4>>2]=c[l>>2];c[(c[q>>2]|0)+8>>2]=c[n>>2];c[(c[q>>2]|0)+12>>2]=c[o>>2];c[(c[q>>2]|0)+16>>2]=c[r>>2];c[(c[q>>2]|0)+20>>2]=c[p>>2];c[c[q>>2]>>2]=0;if(!(c[(c[m>>2]|0)+16>>2]|0))c[(c[m>>2]|0)+16>>2]=c[q>>2];else{c[s>>2]=c[(c[m>>2]|0)+16>>2];while(1){if(!(c[c[s>>2]>>2]|0))break;c[s>>2]=c[c[s>>2]>>2]}c[c[s>>2]>>2]=c[q>>2]}c[j>>2]=c[q>>2];t=c[j>>2]|0;i=h;return t|0}function GS(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+48|0;h=g+32|0;j=g+28|0;k=g+24|0;l=g+20|0;m=g+16|0;n=g+12|0;o=g+8|0;p=g+4|0;q=g;r=g+36|0;c[j>>2]=b;c[k>>2]=e;c[l>>2]=f;c[m>>2]=0;if((c[k>>2]|0)==0|(c[l>>2]|0)==0){c[h>>2]=c[m>>2];s=c[h>>2]|0;i=g;return s|0}c[n>>2]=c[(c[k>>2]|0)+12>>2];a:while(1){if(!(c[n>>2]|0))break;b:do if((c[(c[n>>2]|0)+4>>2]|0)!=3?(c[(c[n>>2]|0)+4>>2]|0)!=4:0){do if((((c[n>>2]|0)!=0?(c[(c[n>>2]|0)+4>>2]|0)==1:0)?(c[(c[n>>2]|0)+36>>2]|0)!=0:0)?(qy(c[(c[n>>2]|0)+8>>2]|0,202464)|0)!=0:0){if((qy(c[(c[(c[n>>2]|0)+36>>2]|0)+8>>2]|0,c[50504]|0)|0)==0?(qy(c[(c[(c[n>>2]|0)+36>>2]|0)+8>>2]|0,c[50506]|0)|0)==0:0)break;c[p>>2]=ej(c[n>>2]|0,202472)|0;c[o>>2]=c[l>>2];if(c[p>>2]|0){c[o>>2]=HS(c[j>>2]|0,c[l>>2]|0,c[p>>2]|0)|0;if(!(c[o>>2]|0))c[o>>2]=c[l>>2];zb[c[135736>>2]&511](c[p>>2]|0)}if((c[(c[o>>2]|0)+36>>2]|0)!=0?(c[(c[(c[o>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){c[m>>2]=By(c[m>>2]|0,c[(c[(c[o>>2]|0)+36>>2]|0)+12>>2]|0)|0;c[m>>2]=By(c[m>>2]|0,202480)|0;c[m>>2]=By(c[m>>2]|0,c[(c[o>>2]|0)+8>>2]|0)|0;break b}c[m>>2]=By(c[m>>2]|0,c[(c[o>>2]|0)+8>>2]|0)|0;break b}while(0);c[n>>2]=c[(c[n>>2]|0)+24>>2];continue a}else t=7;while(0);if((t|0)==7){t=0;c[m>>2]=By(c[m>>2]|0,c[(c[n>>2]|0)+40>>2]|0)|0}do if((c[m>>2]|0)!=0?(c[q>>2]=xy(c[m>>2]|0)|0,(c[q>>2]|0)>0):0){a[r>>0]=a[(c[m>>2]|0)+((c[q>>2]|0)-1)>>0]|0;if((((d[r>>0]|0|0)!=32?(d[r>>0]|0|0)!=10:0)?(d[r>>0]|0|0)!=13:0)?(d[r>>0]|0|0)!=9:0)break;while(1){if((((d[r>>0]|0|0)!=32?(d[r>>0]|0|0)!=10:0)?(d[r>>0]|0|0)!=13:0)?(d[r>>0]|0|0)!=9:0)break;c[q>>2]=(c[q>>2]|0)+-1;if(!(c[q>>2]|0))break;a[r>>0]=a[(c[m>>2]|0)+((c[q>>2]|0)-1)>>0]|0}a[(c[m>>2]|0)+(c[q>>2]|0)>>0]=32;a[(c[m>>2]|0)+((c[q>>2]|0)+1)>>0]=0}while(0);c[n>>2]=c[(c[n>>2]|0)+24>>2]}c[h>>2]=c[m>>2];s=c[h>>2]|0;i=g;return s|0}function HS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=0;if((c[g>>2]|0)==0|(c[h>>2]|0)==0|(c[j>>2]|0)==0){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}c[c[(c[g>>2]|0)+24>>2]>>2]=c[(c[h>>2]|0)+32>>2];c[(c[(c[g>>2]|0)+24>>2]|0)+4>>2]=c[h>>2];c[l>>2]=Rs(c[j>>2]|0,c[(c[g>>2]|0)+24>>2]|0)|0;if(!(c[l>>2]|0)){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}if(((c[c[l>>2]>>2]|0)==1?(c[(c[l>>2]|0)+4>>2]|0)!=0:0)?(c[c[(c[l>>2]|0)+4>>2]>>2]|0)>0:0)c[k>>2]=c[c[(c[(c[l>>2]|0)+4>>2]|0)+8>>2]>>2];Qq(c[l>>2]|0);c[f>>2]=c[k>>2];m=c[f>>2]|0;i=e;return m|0}function IS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;c[g>>2]=a;c[h>>2]=b;b=Cb[c[135744>>2]&511](12)|0;c[j>>2]=b;if(!b){Db[c[135904>>2]&511](c[33980]|0,203144,e);c[f>>2]=0;k=c[f>>2]|0;i=d;return k|0}b=c[j>>2]|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;b=Cb[c[135744>>2]&511](12)|0;c[c[j>>2]>>2]=b;if(!b){Db[c[135904>>2]&511](c[33980]|0,203184,e);zb[c[135736>>2]&511](c[j>>2]|0);c[f>>2]=0;k=c[f>>2]|0;i=d;return k|0}c[c[c[j>>2]>>2]>>2]=c[c[j>>2]>>2];c[(c[c[j>>2]>>2]|0)+4>>2]=c[c[j>>2]>>2];c[(c[c[j>>2]>>2]|0)+8>>2]=0;if(c[g>>2]|0)c[(c[j>>2]|0)+4>>2]=c[g>>2];if(c[h>>2]|0)c[(c[j>>2]|0)+8>>2]=c[h>>2];else c[(c[j>>2]|0)+8>>2]=390;c[f>>2]=c[j>>2];k=c[f>>2]|0;i=d;return k|0}function JS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;do if(c[f>>2]|0){c[h>>2]=RS(c[f>>2]|0,c[g>>2]|0)|0;if(c[h>>2]|0){c[e>>2]=c[(c[h>>2]|0)+8>>2];break}else{c[e>>2]=0;break}}else c[e>>2]=0;while(0);i=d;return c[e>>2]|0}function KS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;c[f>>2]=a;c[g>>2]=b;if(!(c[f>>2]|0)){c[e>>2]=1;k=c[e>>2]|0;i=d;return k|0}c[h>>2]=SS(c[f>>2]|0,c[g>>2]|0)|0;c[j>>2]=Cb[c[135744>>2]&511](12)|0;if(!(c[j>>2]|0)){Db[c[135904>>2]&511](c[33980]|0,203224,d);c[e>>2]=1;k=c[e>>2]|0;i=d;return k|0}else{c[(c[j>>2]|0)+8>>2]=c[g>>2];c[h>>2]=c[(c[h>>2]|0)+4>>2];c[c[j>>2]>>2]=c[c[h>>2]>>2];c[(c[c[h>>2]>>2]|0)+4>>2]=c[j>>2];c[c[h>>2]>>2]=c[j>>2];c[(c[j>>2]|0)+4>>2]=c[h>>2];c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}return 0}function LS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;c[f>>2]=a;c[g>>2]=b;if(!(c[f>>2]|0)){c[e>>2]=1;k=c[e>>2]|0;i=d;return k|0}c[h>>2]=TS(c[f>>2]|0,c[g>>2]|0)|0;c[j>>2]=Cb[c[135744>>2]&511](12)|0;if(!(c[j>>2]|0)){Db[c[135904>>2]&511](c[33980]|0,203224,d);c[e>>2]=1;k=c[e>>2]|0;i=d;return k|0}else{c[(c[j>>2]|0)+8>>2]=c[g>>2];c[c[j>>2]>>2]=c[c[h>>2]>>2];c[(c[c[h>>2]>>2]|0)+4>>2]=c[j>>2];c[c[h>>2]>>2]=c[j>>2];c[(c[j>>2]|0)+4>>2]=c[h>>2];c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}return 0}function MS(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}NS(c[d>>2]|0);zb[c[135736>>2]&511](c[c[d>>2]>>2]|0);zb[c[135736>>2]&511](c[d>>2]|0);i=b;return}function NS(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}c[e>>2]=c[c[c[d>>2]>>2]>>2];while(1){if((c[e>>2]|0)==(c[c[d>>2]>>2]|0))break;c[f>>2]=c[c[e>>2]>>2];US(c[d>>2]|0,c[e>>2]|0);c[e>>2]=c[f>>2]}i=b;return}function OS(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;if(!(c[e>>2]|0))c[d>>2]=0;else c[d>>2]=c[(c[e>>2]|0)+8>>2];i=b;return c[d>>2]|0}function PS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if((c[f>>2]|0)==0|(c[g>>2]|0)==0){i=e;return}c[j>>2]=c[c[c[f>>2]>>2]>>2];while(1){if((c[j>>2]|0)==(c[c[f>>2]>>2]|0)){k=6;break}if(!(Hb[c[g>>2]&511](c[(c[j>>2]|0)+8>>2]|0,c[h>>2]|0)|0)){k=6;break}c[j>>2]=c[c[j>>2]>>2]}if((k|0)==6){i=e;return}}function QS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;do if((c[f>>2]|0)>>>0>=(c[g>>2]|0)>>>0)if((c[f>>2]|0)==(c[g>>2]|0)){c[e>>2]=0;break}else{c[e>>2]=1;break}else c[e>>2]=-1;while(0);i=d;return c[e>>2]|0}function RS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;do if(c[f>>2]|0){c[h>>2]=SS(c[f>>2]|0,c[g>>2]|0)|0;if((c[h>>2]|0)==(c[c[f>>2]>>2]|0)){c[e>>2]=0;break}if(!(Hb[c[(c[f>>2]|0)+8>>2]&511](c[(c[h>>2]|0)+8>>2]|0,c[g>>2]|0)|0)){c[e>>2]=c[h>>2];break}else{c[e>>2]=0;break}}else c[e>>2]=0;while(0);i=d;return c[e>>2]|0}function SS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if(!(c[f>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}c[h>>2]=c[c[c[f>>2]>>2]>>2];while(1){if((c[h>>2]|0)==(c[c[f>>2]>>2]|0))break;if((Hb[c[(c[f>>2]|0)+8>>2]&511](c[(c[h>>2]|0)+8>>2]|0,c[g>>2]|0)|0)>=0)break;c[h>>2]=c[c[h>>2]>>2]}c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}function TS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if(!(c[f>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}c[h>>2]=c[(c[c[f>>2]>>2]|0)+4>>2];while(1){if((c[h>>2]|0)==(c[c[f>>2]>>2]|0))break;if((Hb[c[(c[f>>2]|0)+8>>2]&511](c[(c[h>>2]|0)+8>>2]|0,c[g>>2]|0)|0)<=0)break;c[h>>2]=c[(c[h>>2]|0)+4>>2]}c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}function US(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;c[c[(c[f>>2]|0)+4>>2]>>2]=c[c[f>>2]>>2];c[(c[c[f>>2]>>2]|0)+4>>2]=c[(c[f>>2]|0)+4>>2];if(!(c[(c[e>>2]|0)+4>>2]|0)){g=c[33934]|0;h=c[f>>2]|0;zb[g&511](h);i=d;return}zb[c[(c[e>>2]|0)+4>>2]&511](c[f>>2]|0);g=c[33934]|0;h=c[f>>2]|0;zb[g&511](h);i=d;return}function VS(a){a=a|0;return(a+-97|0)>>>0<26|0}function WS(a){a=a|0;var b=0,c=0;b=i;c=(VS(a)|0)==0;i=b;return(c?a:a&95)|0}function XS(a,b){a=a|0;b=b|0;var e=0,f=0,g=0;e=i;f=gT(a)|0;if(((f|0)!=-1?(a=gT(b)|0,(a|0)!=-1):0)?(d[203264+f>>0]|0)<=207:0){g=a<<16|f;i=e;return g|0}c[(_a()|0)>>2]=22;g=-1;i=e;return g|0}function YS(a){a=a|0;return 0}function ZS(f,g,h,j,k){f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0;l=i;i=i+32|0;m=l;n=l+16|0;o=l+12|0;p=l+8|0;q=l+20|0;r=f;f=r&65535;s=r>>>16;r=s+1|0;t=f+1|0;u=m;c[u>>2]=0;c[u+4>>2]=0;u=a[203264+s>>0]|0;v=a[203264+f>>0]|0;if(!g){w=0;i=l;return w|0}x=c[g>>2]|0;if(!x){w=0;i=l;return w|0}y=c[h>>2]|0;if(!y){w=0;i=l;return w|0}z=u&255;A=z+128|0;B=s+2|0;s=z&3;C=s^1;D=s^2;E=s^3;F=z&1;G=F^1;H=(z&254|0)==196;I=F|2;J=G|2;K=u<<24>>24==-38;L=u<<24>>24==-40;M=v&255;N=M+-192|0;O=N>>>0>8;P=f;Q=281312+N|0;N=M+128|0;R=128-M|0;S=v<<24>>24==-128;v=f+2|0;f=(u&-2)<<24>>24==-60;u=M&1;T=u^1;U=u|2;V=T|2;W=M&3;X=W^1;Y=W^2;Z=W^3;_=(z+-192|0)>>>0<7;$=x;x=y;y=0;a:while(1){aa=a[$>>0]|0;ba=aa&255;b:do if(aa<<24>>24<0|_){do switch(z|0){case 208:{if(x>>>0<2){ca=22;break a}da=d[$+1>>0]|0;if(aa<<24>>24!=-114){ea=ba+-161|0;fa=da+-161|0;if(ea>>>0>83|fa>>>0>93){ga=84;ha=114;break a}ia=b[207296+(ea*188|0)+(fa<<1)>>1]|0;if(!(ia<<16>>16)){ga=84;ha=114;break a}else{ja=ia&65535;ka=2;ha=89;break b}}else{if((da+-161|0)>>>0>62){ga=84;ha=114;break a}ja=da+65216|0;ka=2;ha=89;break b}break}case 198:{if(x>>>0<4){ca=22;break a}la=c[$>>2]|0;ha=14;break}case 200:{da=_S(n,$,x,m)|0;if(!da)ma=1;else if((da|0)==-1){ga=84;ha=114;break a}else if((da|0)==-2){ca=22;break a}else ma=da;ja=c[n>>2]|0;ka=ma;ha=89;break b;break}case 224:{if(x>>>0<2){ca=22;break a}da=d[$+1>>0]|0;ia=da+-64|0;if(ia>>>0>190|(da+-127|0)>>>0<34){ga=84;ha=114;break a}fa=ia>>>0>62?da+-98|0:ia;ia=ba+-161|0;if(ia>>>0<=88){da=e[281352+(ia*314|0)+(fa<<1)>>1]|0;if((ia|0)==39?(fa|0)==66|(fa|0)==58|(fa|0)==60:0)na=131072;else na=0;ia=na|da;if(!ia){ga=84;ha=114;break a}else{ja=ia;ka=2;ha=89;break b}}ia=ba+-135|0;if(ia>>>0>119){ga=84;ha=114;break a}da=fa+(((aa&255)<161?ia:ba+-224|0)*157|0)|0;ia=e[270968+(da<<1)>>1]|0;fa=ia|(((e[270968+((da>>>4)+4867<<1)>>1]|0)>>>(da&15)|0)%2|0)<<17;if((fa&-65792|0)!=56320)if(!fa){ga=84;ha=114;break a}else{ja=fa;ka=2;ha=89;break b}if(O)oa=2;else oa=a[Q>>0]|0;if(oa>>>0>(c[k>>2]|0)>>>0){ga=7;ha=114;break a}c[o>>2]=281328+(ia&255);c[p>>2]=4;pa=2;qa=(ZS(P,o,p,j,k)|0)+y|0;break b;break}case 218:{if((aa&255)<161){ga=84;ha=114;break a}break}case 216:case 217:break;case 193:case 194:case 197:case 196:{if(x>>>0<2){ca=22;break a}ia=d[$+F>>0]<<8;fa=ia|d[$+G>>0];da=ia&64512;if((da|0)==56320){ga=84;ha=114;break a}else if((da|0)!=55296){ja=fa;ka=2;ha=89;break b}if(H){ga=84;ha=114;break a}if(x>>>0<4){ca=22;break a}da=(d[$+I>>0]<<8|d[$+J>>0])+-56320|0;if(da>>>0>1023){ga=84;ha=114;break a}ja=(fa<<10)+-56557568+da|0;ka=4;ha=89;break b;break}case 195:case 192:{if(x>>>0<4){ca=22;break a}la=d[$+C>>0]<<16|d[$+s>>0]<<24|d[$+D>>0]<<8|d[$+E>>0];ha=14;break}case 232:{if(x>>>0<2){ca=22;break a}da=a[$+1>>0]|0;fa=da&255;ia=ba+-161|0;ea=fa+-161|0;if(!(ia>>>0>92|ea>>>0>93)){ra=b[309304+(ia*188|0)+(ea<<1)>>1]|0;if(!(ra<<16>>16)){ga=84;ha=114;break a}else{ja=ra&65535;ka=2;ha=89;break b}}ra=ba+-129|0;if(ra>>>0>92){ga=84;ha=114;break a}if(ra>>>0>68&(da&255)>82){ga=84;ha=114;break a}da=fa+-65|0;do if(da>>>0<26)sa=da;else{if((fa+-97|0)>>>0<26){sa=fa+-71|0;break}if((fa+-129|0)>>>0>=126){ga=84;ha=114;break a}sa=fa+-77|0}while(0);if(ra>>>0<32)ta=ra*178|0;else ta=(ia*84|0)+5696|0;fa=sa+44032+ta|0;if(fa>>>0<44032){ja=fa;ka=2;ha=89;break b}else{ua=fa;va=44032}while(1){fa=ua-va|0;da=0;ea=0;while(1){wa=0;xa=ea;do{xa=(((e[309304+(da*188|0)+(wa<<1)>>1]|0)-va|0)>>>0<=fa>>>0&1)+xa|0;wa=wa+1|0}while((wa|0)!=94);da=da+1|0;if((da|0)==93)break;else ea=xa}va=ua+1|0;ea=xa+ua|0;if(ea>>>0<va>>>0){ja=ea;ka=2;ha=89;break b}else ua=ea}break}case 209:{if((ba+-161|0)>>>0<63){ja=ba+65216|0;ka=1;ha=89;break b}if(x>>>0<2){ca=22;break a}ia=a[$+1>>0]|0;ra=ia&255;ea=ba+-129|0;if(ea>>>0<31)ya=ea;else{if((ba&240|0)!=224){ga=84;ha=114;break a}ya=ba+-193|0}ea=ya<<1;da=ra+-64|0;if(da>>>0<95){if(ia<<24>>24==127){ga=84;ha=114;break a}za=ea;Aa=da+(ia<<24>>24>>7<<24>>24)|0}else{ia=ra+-159|0;da=ia>>>0<94;za=ea|da&1;Aa=da?ia:ra}ra=b[207296+(za*188|0)+(Aa<<1)>>1]|0;if(!(ra<<16>>16)){ga=84;ha=114;break a}else{ja=ra&65535;ka=2;ha=89;break b}break}case 199:{ga=84;ha=114;break a;break}default:{if(ba>>>0<A>>>0){ja=ba;ka=1;ha=89;break b}ra=ba-A|0;ia=(ra*5|0)>>>2;da=ra<<1&6;ra=d[203264+(B+ia)>>0]<<8-da&1023|(d[203264+(ia+r)>>0]|0)>>>da;da=(ra|0)==0?ba:e[326792+(ra<<1)>>1]|0;if((da|0)==1){ga=84;ha=114;break a}else{ja=da;ka=1;ha=89;break b}}}while(0);if((ha|0)==14){ha=0;if((la&-2048|0)==55296|la>>>0>1114111){ga=84;ha=114;break a}else{ja=la;ka=4;ha=89;break}}da=ba+-129|0;if(da>>>0>125){ga=84;ha=114;break a}if(x>>>0<2){ca=22;break a}ra=a[$+1>>0]|0;ia=ra&255;if((ra&255)<161&K){ga=84;ha=114;break a}ea=ia+-64|0;if(!(ea>>>0>190|ra<<24>>24==127)){ja=e[223088+(da*380|0)+((ea>>>0>63?ia+-65|0:ea)<<1)>>1]|0;ka=2;ha=89;break}if(!((ia+-48|0)>>>0<10&L)){ga=84;ha=114;break a}if(x>>>0<4){ca=22;break a}ea=(d[$+2>>0]|0)+-129|0;if(ea>>>0>126){ga=84;ha=114;break a}ra=(d[$+3>>0]|0)+-48|0;if(ra>>>0>9){ga=84;ha=114;break a}fa=((ia+(da*10|0)|0)*1260|0)+-60352+(ea*10|0)+ra|0;ra=0;while(1){ea=fa-ra|0;da=0;ia=0;while(1){wa=0;Ba=ia;do{Ba=(((e[223088+(da*380|0)+(wa<<1)>>1]|0)-ra|0)>>>0<=ea>>>0&1)+Ba|0;wa=wa+1|0}while((wa|0)!=190);da=da+1|0;if((da|0)==126)break;else ia=Ba}ra=fa+1|0;ia=Ba+fa|0;if(ia>>>0<ra>>>0){ja=ia;ka=4;ha=89;break}else fa=ia}}else{ja=ba;ka=1;ha=89}while(0);c:do if((ha|0)==89){ha=0;switch(M|0){case 195:case 192:{if((c[k>>2]|0)>>>0<4){ga=7;ha=114;break a}ba=c[j>>2]|0;a[ba+W>>0]=ja>>>24;a[ba+X>>0]=ja>>>16;a[ba+Y>>0]=ja>>>8;a[ba+Z>>0]=ja;c[j>>2]=ba+4;c[k>>2]=(c[k>>2]|0)+-4;pa=ka;qa=y;break c;break}case 199:{if(ja>>>0>127){Ca=y;ha=98}else{Da=ja;Ea=y}break}case 200:{if((c[k>>2]|0)>>>0<4){ba=CT(q,ja)|0;if((c[k>>2]|0)>>>0<ba>>>0){ga=7;ha=114;break a}aa=c[j>>2]|0;eU(aa|0,q|0,ba|0)|0;Fa=aa;Ga=ba}else{ba=c[j>>2]|0;Fa=ba;Ga=CT(ba,ja)|0}c[j>>2]=Fa+Ga;c[k>>2]=(c[k>>2]|0)-Ga;pa=ka;qa=y;break c;break}case 193:case 194:case 197:case 196:{if(ja>>>0<65536|f){ba=ja>>>0>65535?65533:ja;if((c[k>>2]|0)>>>0<2){ga=7;ha=114;break a}aa=c[j>>2]|0;a[aa+u>>0]=ba>>>8;a[aa+T>>0]=ba;c[j>>2]=aa+2;c[k>>2]=(c[k>>2]|0)+-2;pa=ka;qa=y;break c}else{if((c[k>>2]|0)>>>0<4){ga=7;ha=114;break a}aa=ja+-65536|0;ba=c[j>>2]|0;a[ba+u>>0]=aa>>>18|216;a[ba+T>>0]=aa>>>10;a[ba+U>>0]=aa>>>8&3|220;a[ba+V>>0]=aa;c[j>>2]=ba+4;c[k>>2]=(c[k>>2]|0)+-4;pa=ka;qa=y;break c}break}case 198:{if((c[k>>2]|0)>>>0<4){ga=7;ha=114;break a}ba=c[j>>2]|0;c[ba>>2]=ja;c[j>>2]=ba+4;c[k>>2]=(c[k>>2]|0)+-4;pa=ka;qa=y;break c;break}default:{Da=ja;Ea=y}}d:while(1){if((ha|0)==98){ha=0;Da=42;Ea=Ca+1|0}if(!(c[k>>2]|0)){ga=7;ha=114;break a}if(Da>>>0<N>>>0){Ha=Da;break}if(S){Ca=Ea;ha=98;continue}else Ia=0;while(1){ba=(Ia*5|0)>>>2;aa=Ia<<1&6;fa=Ia+1|0;if((Da|0)==(e[326792+((d[203264+(v+ba)>>0]<<8-aa&1023|(d[203264+(ba+t)>>0]|0)>>>aa)<<1)>>1]|0)){ha=105;break d}if(fa>>>0<R>>>0)Ia=fa;else{Ca=Ea;ha=98;continue d}}}if((ha|0)==105){ha=0;Ha=Ia+128|0}fa=c[j>>2]|0;c[j>>2]=fa+1;a[fa>>0]=Ha;c[k>>2]=(c[k>>2]|0)+-1;pa=ka;qa=Ea}while(0);$=(c[g>>2]|0)+pa|0;c[g>>2]=$;fa=x;x=x-pa|0;c[h>>2]=x;if((fa|0)==(pa|0)){w=qa;ha=116;break}else y=qa}if((ha|0)==114)ca=ga;else if((ha|0)==116){i=l;return w|0}c[(_a()|0)>>2]=ca;w=-1;i=l;return w|0}function _S(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+16|0;h=g;c[h>>2]=b;j=(f|0)==0?328248:f;f=c[j>>2]|0;a:do if(!d){if(!f){k=0;i=g;return k|0}}else{if(!b){c[h>>2]=h;l=h}else l=b;if(!e){k=-2;i=g;return k|0}do if(!f){m=a[d>>0]|0;n=m&255;if(m<<24>>24>-1){c[l>>2]=n;k=m<<24>>24!=0&1;i=g;return k|0}else{m=n+-194|0;if(m>>>0>50)break a;o=e+-1|0;p=c[328040+(m<<2)>>2]|0;q=d+1|0;break}}else{o=e;p=f;q=d}while(0);b:do if(!o)r=p;else{m=a[q>>0]|0;n=(m&255)>>>3;if((n+-16|n+(p>>26))>>>0>7)break a;else{s=o;t=m;u=p;v=q}while(1){v=v+1|0;u=(t&255)+-128|u<<6;s=s+-1|0;if((u|0)>=0)break;if(!s){r=u;break b}t=a[v>>0]|0;if((t&-64)<<24>>24!=-128)break a}c[j>>2]=0;c[l>>2]=u;k=e-s|0;i=g;return k|0}while(0);c[j>>2]=r;k=-2;i=g;return k|0}while(0);c[j>>2]=0;c[(_a()|0)>>2]=84;k=-1;i=g;return k|0}function $S(a){a=a|0;var b=0;if(!a)b=1;else b=(c[a>>2]|0)==0;return b&1|0}function aT(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=a+84|0;g=c[f>>2]|0;h=d+256|0;j=NT(g,0,h)|0;if(!j)k=h;else k=j-g|0;j=k>>>0<d>>>0?k:d;eU(b|0,g|0,j|0)|0;c[a+4>>2]=g+j;b=g+k|0;c[a+8>>2]=b;c[f>>2]=b;i=e;return j|0}function bT(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;d=dT(a,b,f)|0;i=e;return d|0}function cT(e,f,j){e=e|0;f=f|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0;k=i;i=i+304|0;l=k+16|0;m=k+8|0;n=k+33|0;o=k;p=k+32|0;q=a[f>>0]|0;if(!(q<<24>>24)){r=0;i=k;return r|0}s=e+4|0;t=e+100|0;u=e+108|0;v=e+8|0;w=n+10|0;x=n+33|0;y=m+4|0;z=n+46|0;A=n+94|0;B=q;q=0;C=f;f=0;D=0;E=0;a:while(1){b:do if(!(mT(B&255)|0)){F=(a[C>>0]|0)==37;c:do if(F){H=C+1|0;I=a[H>>0]|0;do if(I<<24>>24==37)break c;else if(I<<24>>24==42){J=0;K=C+2|0}else{L=(I&255)+-48|0;if(L>>>0<10?(a[C+2>>0]|0)==36:0){c[l>>2]=c[j>>2];M=L;while(1){L=c[l>>2]|0;N=c[L>>2]|0;c[l>>2]=L+4;if(M>>>0>1)M=M+-1|0;else break}J=N;K=C+3|0;break}M=c[j>>2]|0;L=c[M>>2]|0;c[j>>2]=M+4;J=L;K=H}while(0);H=a[K>>0]|0;I=H&255;if((I+-48|0)>>>0<10){L=I;I=K;M=0;while(1){O=(M*10|0)+-48+L|0;P=I+1|0;Q=a[P>>0]|0;L=Q&255;if((L+-48|0)>>>0>=10){R=Q;S=P;T=O;break}else{I=P;M=O}}}else{R=H;S=K;T=0}if(R<<24>>24==109){M=S+1|0;U=a[M>>0]|0;V=(J|0)!=0&1;W=M;X=0;Y=0}else{U=R;V=0;W=S;X=D;Y=E}M=W+1|0;switch(U&255|0){case 76:{Z=M;_=2;break}case 110:case 112:case 67:case 83:case 91:case 99:case 115:case 88:case 71:case 70:case 69:case 65:case 103:case 102:case 101:case 97:case 120:case 117:case 111:case 105:case 100:{Z=W;_=0;break}case 108:{I=(a[M>>0]|0)==108;Z=I?W+2|0:M;_=I?3:1;break}case 104:{I=(a[M>>0]|0)==104;Z=I?W+2|0:M;_=I?-2:-1;break}case 116:case 122:{Z=M;_=1;break}case 106:{Z=M;_=3;break}default:{$=V;aa=X;ba=Y;ca=162;break a}}M=d[Z>>0]|0;I=(M&47|0)==3;L=I?M|32:M;M=I?1:_;if((L|0)==91){da=f;ea=T}else if((L|0)==99){da=f;ea=(T|0)<1?1:T}else if((L|0)==110){if(!J){fa=q;ga=Z;ha=f;ia=X;ja=Y;break b}switch(M|0){case-1:{b[J>>1]=f;fa=q;ga=Z;ha=f;ia=X;ja=Y;break b;break}case-2:{a[J>>0]=f;fa=q;ga=Z;ha=f;ia=X;ja=Y;break b;break}case 3:{I=J;c[I>>2]=f;c[I+4>>2]=((f|0)<0)<<31>>31;fa=q;ga=Z;ha=f;ia=X;ja=Y;break b;break}case 0:{c[J>>2]=f;fa=q;ga=Z;ha=f;ia=X;ja=Y;break b;break}case 1:{c[J>>2]=f;fa=q;ga=Z;ha=f;ia=X;ja=Y;break b;break}default:{fa=q;ga=Z;ha=f;ia=X;ja=Y;break b}}}else{pT(e,0);do{I=c[s>>2]|0;if(I>>>0<(c[t>>2]|0)>>>0){c[s>>2]=I+1;ka=d[I>>0]|0}else ka=qT(e)|0}while((mT(ka)|0)!=0);H=c[s>>2]|0;if(!(c[t>>2]|0))la=H;else{I=H+-1|0;c[s>>2]=I;la=I}da=(c[u>>2]|0)+f+la-(c[v>>2]|0)|0;ea=T}pT(e,ea);I=c[s>>2]|0;H=c[t>>2]|0;if(I>>>0<H>>>0){c[s>>2]=I+1;ma=H}else{if((qT(e)|0)<0){$=V;aa=X;ba=Y;ca=162;break a}ma=c[t>>2]|0}if(ma)c[s>>2]=(c[s>>2]|0)+-1;d:do switch(L|0){case 71:case 103:case 70:case 102:case 69:case 101:case 65:case 97:{na=+oT(e,M,0);if((c[u>>2]|0)==((c[v>>2]|0)-(c[s>>2]|0)|0)){oa=V;pa=q;qa=X;ra=Y;break a}if(J)if(!M){g[J>>2]=na;sa=Z;ta=X;ua=Y;break d}else if((M|0)==1){h[J>>3]=na;sa=Z;ta=X;ua=Y;break d}else if((M|0)==2){h[J>>3]=na;sa=Z;ta=X;ua=Y;break d}else{sa=Z;ta=X;ua=Y;break d}else{sa=Z;ta=X;ua=Y}break}case 111:{va=8;ca=144;break}case 117:case 100:{va=10;ca=144;break}case 105:{va=0;ca=144;break}case 91:case 99:case 115:{H=(L|0)==99;e:do if((L&239|0)==99){cU(n|0,-1,257)|0;a[n>>0]=0;if((L|0)==115){a[x>>0]=0;a[w+0>>0]=0;a[w+1>>0]=0;a[w+2>>0]=0;a[w+3>>0]=0;a[w+4>>0]=0;wa=Z}else wa=Z}else{I=Z+1|0;O=(a[I>>0]|0)==94;P=O&1;Q=O?Z+2|0:I;cU(n|0,O&1|0,257)|0;a[n>>0]=0;O=a[Q>>0]|0;if(O<<24>>24==45){I=(P^1)&255;a[z>>0]=I;xa=I;ya=Q+1|0}else if(O<<24>>24==93){O=(P^1)&255;a[A>>0]=O;xa=O;ya=Q+1|0}else{xa=(P^1)&255;ya=Q}Q=ya;while(1){P=a[Q>>0]|0;if(!(P<<24>>24)){$=V;aa=X;ba=Y;ca=162;break a}else if(P<<24>>24==93){wa=Q;break e}else if(P<<24>>24==45){O=Q+1|0;I=a[O>>0]|0;if(!(I<<24>>24==93|I<<24>>24==0)){za=a[Q+-1>>0]|0;if((za&255)<(I&255)){Aa=za&255;do{Aa=Aa+1|0;a[n+Aa>>0]=xa;za=a[O>>0]|0}while((Aa|0)<(za&255|0));Ba=za;Ca=O}else{Ba=I;Ca=O}}else{Ba=45;Ca=Q}}else{Ba=P;Ca=Q}a[n+((Ba&255)+1)>>0]=xa;Q=Ca+1|0}}while(0);Q=H?ea+1|0:31;Aa=(M|0)==1;za=(V|0)!=0;f:do if(Aa){if(za){Da=iT(Q<<2)|0;if(!Da){$=V;aa=0;ba=Da;ca=162;break a}else Ea=Da}else Ea=J;c[m>>2]=0;c[y>>2]=0;Da=0;Fa=Q;Ga=Ea;g:while(1){if(!Ga)while(1){Ha=c[s>>2]|0;if(Ha>>>0<(c[t>>2]|0)>>>0){c[s>>2]=Ha+1;Ia=d[Ha>>0]|0}else Ia=qT(e)|0;if(!(a[n+(Ia+1)>>0]|0)){Ja=Da;Ka=0;break g}a[p>>0]=Ia;Ha=_S(o,p,1,m)|0;if((Ha|0)==-2)continue;else if((Ha|0)==-1){$=V;aa=0;ba=0;ca=162;break a}if(za&(Da|0)==(Fa|0)){La=Da;break}}else{if(za)Ma=Da;else{Na=Da;ca=98;break}while(1){while(1){P=c[s>>2]|0;if(P>>>0<(c[t>>2]|0)>>>0){c[s>>2]=P+1;Oa=d[P>>0]|0}else Oa=qT(e)|0;if(!(a[n+(Oa+1)>>0]|0)){Ja=Ma;Ka=Ga;break g}a[p>>0]=Oa;P=_S(o,p,1,m)|0;if((P|0)==-1){$=V;aa=0;ba=Ga;ca=162;break a}else if((P|0)!=-2)break}c[Ga+(Ma<<2)>>2]=c[o>>2];Ma=Ma+1|0;if((Ma|0)==(Fa|0)){La=Fa;break}}}P=Fa<<1|1;O=kT(Ga,P<<2)|0;if(!O){$=V;aa=0;ba=Ga;ca=162;break a}Da=La;Fa=P;Ga=O}h:do if((ca|0)==98)while(1){ca=0;while(1){Fa=c[s>>2]|0;if(Fa>>>0<(c[t>>2]|0)>>>0){c[s>>2]=Fa+1;Pa=d[Fa>>0]|0}else Pa=qT(e)|0;if(!(a[n+(Pa+1)>>0]|0)){Ja=Na;Ka=Ga;break h}a[p>>0]=Pa;Fa=_S(o,p,1,m)|0;if((Fa|0)==-1){$=0;aa=0;ba=Ga;ca=162;break a}else if((Fa|0)!=-2)break}c[Ga+(Na<<2)>>2]=c[o>>2];Na=Na+1|0;ca=98}while(0);if(!($S(m)|0)){$=V;aa=0;ba=Ka;ca=162;break a}else{Qa=Ja;Ra=0;Sa=Ka}}else{if(za){Ga=iT(Q)|0;if(!Ga){$=V;aa=0;ba=0;ca=162;break a}else{Ta=0;Ua=Q;Va=Ga}while(1){Ga=Ta;do{Fa=c[s>>2]|0;if(Fa>>>0<(c[t>>2]|0)>>>0){c[s>>2]=Fa+1;Wa=d[Fa>>0]|0}else Wa=qT(e)|0;if(!(a[n+(Wa+1)>>0]|0)){Qa=Ga;Ra=Va;Sa=0;break f}a[Va+Ga>>0]=Wa;Ga=Ga+1|0}while((Ga|0)!=(Ua|0));Ga=Ua<<1|1;Fa=kT(Va,Ga)|0;if(!Fa){$=V;aa=Va;ba=0;ca=162;break a}else{Da=Ua;Ua=Ga;Va=Fa;Ta=Da}}}if(!J){Da=ma;while(1){Fa=c[s>>2]|0;if(Fa>>>0<Da>>>0){c[s>>2]=Fa+1;Xa=d[Fa>>0]|0}else Xa=qT(e)|0;if(!(a[n+(Xa+1)>>0]|0)){Qa=0;Ra=0;Sa=0;break f}Da=c[t>>2]|0}}else{Da=ma;Fa=0;while(1){Ga=c[s>>2]|0;if(Ga>>>0<Da>>>0){c[s>>2]=Ga+1;Ya=d[Ga>>0]|0}else Ya=qT(e)|0;if(!(a[n+(Ya+1)>>0]|0)){Qa=Fa;Ra=J;Sa=0;break f}a[J+Fa>>0]=Ya;Da=c[t>>2]|0;Fa=Fa+1|0}}}while(0);Q=c[s>>2]|0;if(!(c[t>>2]|0))Za=Q;else{Fa=Q+-1|0;c[s>>2]=Fa;Za=Fa}Fa=Za-(c[v>>2]|0)+(c[u>>2]|0)|0;if(!Fa){oa=V;pa=q;qa=Ra;ra=Sa;break a}if(!((Fa|0)==(ea|0)|H^1)){oa=V;pa=q;qa=Ra;ra=Sa;break a}do if(za)if(Aa){c[J>>2]=Sa;break}else{c[J>>2]=Ra;break}while(0);if(!H){if(Sa)c[Sa+(Qa<<2)>>2]=0;if(!Ra){sa=wa;ta=0;ua=Sa}else{a[Ra+Qa>>0]=0;sa=wa;ta=Ra;ua=Sa}}else{sa=wa;ta=Ra;ua=Sa}break}case 120:case 88:case 112:{va=16;ca=144;break}default:{sa=Z;ta=X;ua=Y}}while(0);i:do if((ca|0)==144){ca=0;Aa=nT(e,va,0,-1,-1)|0;if((c[u>>2]|0)==((c[v>>2]|0)-(c[s>>2]|0)|0)){oa=V;pa=q;qa=X;ra=Y;break a}if((L|0)==112&(J|0)!=0){c[J>>2]=Aa;sa=Z;ta=X;ua=Y;break}if(!J){sa=Z;ta=X;ua=Y}else switch(M|0){case-2:{a[J>>0]=Aa;sa=Z;ta=X;ua=Y;break i;break}case-1:{b[J>>1]=Aa;sa=Z;ta=X;ua=Y;break i;break}case 0:{c[J>>2]=Aa;sa=Z;ta=X;ua=Y;break i;break}case 1:{c[J>>2]=Aa;sa=Z;ta=X;ua=Y;break i;break}case 3:{za=J;c[za>>2]=Aa;c[za+4>>2]=G;sa=Z;ta=X;ua=Y;break i;break}default:{sa=Z;ta=X;ua=Y;break i}}}while(0);fa=((J|0)!=0&1)+q|0;ga=sa;ha=(c[u>>2]|0)+da+(c[s>>2]|0)-(c[v>>2]|0)|0;ia=ta;ja=ua;break b}while(0);M=C+(F&1)|0;pT(e,0);L=c[s>>2]|0;if(L>>>0<(c[t>>2]|0)>>>0){c[s>>2]=L+1;_a=d[L>>0]|0}else _a=qT(e)|0;if((_a|0)!=(d[M>>0]|0)){ca=19;break a}fa=q;ga=M;ha=f+1|0;ia=D;ja=E}else{M=C;while(1){L=M+1|0;if(!(mT(d[L>>0]|0)|0))break;else M=L}pT(e,0);do{F=c[s>>2]|0;if(F>>>0<(c[t>>2]|0)>>>0){c[s>>2]=F+1;$a=d[F>>0]|0}else $a=qT(e)|0}while((mT($a)|0)!=0);F=c[s>>2]|0;if(!(c[t>>2]|0))ab=F;else{L=F+-1|0;c[s>>2]=L;ab=L}fa=q;ga=M;ha=(c[u>>2]|0)+f+ab-(c[v>>2]|0)|0;ia=D;ja=E}while(0);C=ga+1|0;B=a[C>>0]|0;if(!(B<<24>>24)){r=fa;ca=166;break}else{q=fa;f=ha;D=ia;E=ja}}if((ca|0)==19){if(c[t>>2]|0)c[s>>2]=(c[s>>2]|0)+-1;if((_a|0)>-1|(q|0)!=0){r=q;i=k;return r|0}else{bb=0;cb=D;db=E;ca=163}}else if((ca|0)==162)if(!q){bb=$;cb=aa;db=ba;ca=163}else{oa=$;pa=q;qa=aa;ra=ba}else if((ca|0)==166){i=k;return r|0}if((ca|0)==163){oa=bb;pa=-1;qa=cb;ra=db}if(!oa){r=pa;i=k;return r|0}jT(qa);jT(ra);r=pa;i=k;return r|0}function dT(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+112|0;f=e;g=f+0|0;h=g+112|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(h|0));c[f+32>>2]=391;c[f+44>>2]=a;c[f+76>>2]=-1;c[f+84>>2]=a;a=cT(f,b,d)|0;i=e;return a|0}function eT(b,c){b=b|0;c=c|0;var d=0,e=0;d=i;e=fT(b,c)|0;i=d;return((a[e>>0]|0)==(c&255)<<24>>24?e:0)|0}function fT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=d&255;if(!f){g=b+(ZT(b|0)|0)|0;i=e;return g|0}a:do if(!(b&3))h=b;else{j=d&255;k=b;while(1){l=a[k>>0]|0;m=k+1|0;if(l<<24>>24==0?1:l<<24>>24==j<<24>>24){g=k;break}if(!(m&3)){h=m;break a}else k=m}i=e;return g|0}while(0);b=ca(f,16843009)|0;f=c[h>>2]|0;b:do if(!((f&-2139062144^-2139062144)&f+-16843009)){k=f;j=h;while(1){m=k^b;l=j+4|0;if((m&-2139062144^-2139062144)&m+-16843009){n=j;break b}k=c[l>>2]|0;if((k&-2139062144^-2139062144)&k+-16843009){n=l;break}else j=l}}else n=h;while(0);h=d&255;d=n;while(1){n=a[d>>0]|0;if(n<<24>>24==0?1:n<<24>>24==h<<24>>24){g=d;break}else d=d+1|0}i=e;return g|0}function gT(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;c=i;d=a[b>>0]|0;a:do if(d<<24>>24){e=203264;while(1){f=b;g=e;h=d;while(1){j=a[g>>0]|0;if(!(j<<24>>24)){k=g;l=h;m=16;break}b:do if(!(h<<24>>24)){n=f;o=0}else{p=f;q=h&255;r=h;while(1){s=p+1|0;if(!(((q|32)+-97|0)>>>0>26&(q+-48|0)>>>0>10)){n=p;o=r;break b}t=a[s>>0]|0;if(!(t<<24>>24)){n=s;o=0;break}else{p=s;q=t&255;r=t}}}while(0);if((o&255|32|0)!=(j&255|0))break;f=n+1|0;r=g+1|0;h=a[f>>0]|0;if(!(h<<24>>24)){k=r;l=0;m=16;break}else g=r}if((m|0)==16?(m=0,l<<24>>24==(a[k>>0]|0)):0)break;g=ZT(e|0)|0;h=e+(g+1)|0;do if(!(a[h>>0]|0)){f=a[e+(g+2)>>0]|0;if((f&255)>128){u=e+(g+3)|0;break}else{u=e+(g+3+(((128-(f&255)|0)>>>2)*5|0))|0;break}}else u=h;while(0);if(!(a[u>>0]|0)){v=-1;m=25;break}else e=u}if((m|0)==25){i=c;return v|0}if(!(a[e>>0]|0))w=e;else{h=e;while(1){g=h+((ZT(h|0)|0)+1)|0;if(!(a[g>>0]|0)){w=g;break}else h=g}}}else{h=203264;while(1){if(!(a[h>>0]|0)){w=h;break a}e=ZT(h|0)|0;g=h+(e+1)|0;do if(!(a[g>>0]|0)){f=a[h+(e+2)>>0]|0;if((f&255)>128){x=h+(e+3)|0;break}else{x=h+(e+3+(((128-(f&255)|0)>>>2)*5|0))|0;break}}else x=g;while(0);if(!(a[x>>0]|0)){v=-1;break}else h=x}i=c;return v|0}while(0);v=w+1-203264|0;i=c;return v|0}function hT(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=aT(a,b,c)|0;i=d;return e|0}function iT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0;b=i;do if(a>>>0<245){if(a>>>0<11)d=16;else d=a+11&-8;e=d>>>3;f=c[82064]|0;g=f>>>e;if(g&3){h=(g&1^1)+e|0;j=h<<1;k=328296+(j<<2)|0;l=328296+(j+2<<2)|0;j=c[l>>2]|0;m=j+8|0;n=c[m>>2]|0;do if((k|0)!=(n|0)){if(n>>>0<(c[82068]|0)>>>0)hb();o=n+12|0;if((c[o>>2]|0)==(j|0)){c[o>>2]=k;c[l>>2]=n;break}else hb()}else c[82064]=f&~(1<<h);while(0);n=h<<3;c[j+4>>2]=n|3;l=j+(n|4)|0;c[l>>2]=c[l>>2]|1;p=m;i=b;return p|0}l=c[82066]|0;if(d>>>0>l>>>0){if(g){n=2<<e;k=g<<e&(n|0-n);n=(k&0-k)+-1|0;k=n>>>12&16;o=n>>>k;n=o>>>5&8;q=o>>>n;o=q>>>2&4;r=q>>>o;q=r>>>1&2;s=r>>>q;r=s>>>1&1;t=(n|k|o|q|r)+(s>>>r)|0;r=t<<1;s=328296+(r<<2)|0;q=328296+(r+2<<2)|0;r=c[q>>2]|0;o=r+8|0;k=c[o>>2]|0;do if((s|0)!=(k|0)){if(k>>>0<(c[82068]|0)>>>0)hb();n=k+12|0;if((c[n>>2]|0)==(r|0)){c[n>>2]=s;c[q>>2]=k;u=c[82066]|0;break}else hb()}else{c[82064]=f&~(1<<t);u=l}while(0);l=t<<3;f=l-d|0;c[r+4>>2]=d|3;k=r+d|0;c[r+(d|4)>>2]=f|1;c[r+l>>2]=f;if(u){l=c[82069]|0;q=u>>>3;s=q<<1;e=328296+(s<<2)|0;g=c[82064]|0;m=1<<q;if(g&m){q=328296+(s+2<<2)|0;j=c[q>>2]|0;if(j>>>0<(c[82068]|0)>>>0)hb();else{v=q;w=j}}else{c[82064]=g|m;v=328296+(s+2<<2)|0;w=e}c[v>>2]=l;c[w+12>>2]=l;c[l+8>>2]=w;c[l+12>>2]=e}c[82066]=f;c[82069]=k;p=o;i=b;return p|0}k=c[82065]|0;if(k){f=(k&0-k)+-1|0;k=f>>>12&16;e=f>>>k;f=e>>>5&8;l=e>>>f;e=l>>>2&4;s=l>>>e;l=s>>>1&2;m=s>>>l;s=m>>>1&1;g=c[328560+((f|k|e|l|s)+(m>>>s)<<2)>>2]|0;s=(c[g+4>>2]&-8)-d|0;m=g;l=g;while(1){g=c[m+16>>2]|0;if(!g){e=c[m+20>>2]|0;if(!e)break;else x=e}else x=g;g=(c[x+4>>2]&-8)-d|0;e=g>>>0<s>>>0;s=e?g:s;m=x;l=e?x:l}m=c[82068]|0;if(l>>>0<m>>>0)hb();o=l+d|0;if(l>>>0>=o>>>0)hb();r=c[l+24>>2]|0;t=c[l+12>>2]|0;do if((t|0)==(l|0)){e=l+20|0;g=c[e>>2]|0;if(!g){k=l+16|0;f=c[k>>2]|0;if(!f){y=0;break}else{z=f;A=k}}else{z=g;A=e}while(1){e=z+20|0;g=c[e>>2]|0;if(g){z=g;A=e;continue}e=z+16|0;g=c[e>>2]|0;if(!g)break;else{z=g;A=e}}if(A>>>0<m>>>0)hb();else{c[A>>2]=0;y=z;break}}else{e=c[l+8>>2]|0;if(e>>>0<m>>>0)hb();g=e+12|0;if((c[g>>2]|0)!=(l|0))hb();k=t+8|0;if((c[k>>2]|0)==(l|0)){c[g>>2]=t;c[k>>2]=e;y=t;break}else hb()}while(0);do if(r){t=c[l+28>>2]|0;m=328560+(t<<2)|0;if((l|0)==(c[m>>2]|0)){c[m>>2]=y;if(!y){c[82065]=c[82065]&~(1<<t);break}}else{if(r>>>0<(c[82068]|0)>>>0)hb();t=r+16|0;if((c[t>>2]|0)==(l|0))c[t>>2]=y;else c[r+20>>2]=y;if(!y)break}t=c[82068]|0;if(y>>>0<t>>>0)hb();c[y+24>>2]=r;m=c[l+16>>2]|0;do if(m)if(m>>>0<t>>>0)hb();else{c[y+16>>2]=m;c[m+24>>2]=y;break}while(0);m=c[l+20>>2]|0;if(m)if(m>>>0<(c[82068]|0)>>>0)hb();else{c[y+20>>2]=m;c[m+24>>2]=y;break}}while(0);if(s>>>0<16){r=s+d|0;c[l+4>>2]=r|3;m=l+(r+4)|0;c[m>>2]=c[m>>2]|1}else{c[l+4>>2]=d|3;c[l+(d|4)>>2]=s|1;c[l+(s+d)>>2]=s;m=c[82066]|0;if(m){r=c[82069]|0;t=m>>>3;m=t<<1;e=328296+(m<<2)|0;k=c[82064]|0;g=1<<t;if(k&g){t=328296+(m+2<<2)|0;f=c[t>>2]|0;if(f>>>0<(c[82068]|0)>>>0)hb();else{B=t;C=f}}else{c[82064]=k|g;B=328296+(m+2<<2)|0;C=e}c[B>>2]=r;c[C+12>>2]=r;c[r+8>>2]=C;c[r+12>>2]=e}c[82066]=s;c[82069]=o}p=l+8|0;i=b;return p|0}else D=d}else D=d}else if(a>>>0<=4294967231){e=a+11|0;r=e&-8;m=c[82065]|0;if(m){g=0-r|0;k=e>>>8;if(k)if(r>>>0>16777215)E=31;else{e=(k+1048320|0)>>>16&8;f=k<<e;k=(f+520192|0)>>>16&4;t=f<<k;f=(t+245760|0)>>>16&2;j=14-(k|e|f)+(t<<f>>>15)|0;E=r>>>(j+7|0)&1|j<<1}else E=0;j=c[328560+(E<<2)>>2]|0;a:do if(!j){F=g;G=0;H=0}else{if((E|0)==31)I=0;else I=25-(E>>>1)|0;f=g;t=0;e=r<<I;k=j;q=0;while(1){h=c[k+4>>2]&-8;n=h-r|0;if(n>>>0<f>>>0)if((h|0)==(r|0)){F=n;G=k;H=k;break a}else{J=n;K=k}else{J=f;K=q}n=c[k+20>>2]|0;k=c[k+(e>>>31<<2)+16>>2]|0;h=(n|0)==0|(n|0)==(k|0)?t:n;if(!k){F=J;G=h;H=K;break}else{f=J;t=h;e=e<<1;q=K}}}while(0);if((G|0)==0&(H|0)==0){j=2<<E;g=m&(j|0-j);if(!g){D=r;break}j=(g&0-g)+-1|0;g=j>>>12&16;l=j>>>g;j=l>>>5&8;o=l>>>j;l=o>>>2&4;s=o>>>l;o=s>>>1&2;q=s>>>o;s=q>>>1&1;L=c[328560+((j|g|l|o|s)+(q>>>s)<<2)>>2]|0}else L=G;if(!L){M=F;N=H}else{s=F;q=L;o=H;while(1){l=(c[q+4>>2]&-8)-r|0;g=l>>>0<s>>>0;j=g?l:s;l=g?q:o;g=c[q+16>>2]|0;if(g){s=j;q=g;o=l;continue}q=c[q+20>>2]|0;if(!q){M=j;N=l;break}else{s=j;o=l}}}if((N|0)!=0?M>>>0<((c[82066]|0)-r|0)>>>0:0){o=c[82068]|0;if(N>>>0<o>>>0)hb();
s=N+r|0;if(N>>>0>=s>>>0)hb();q=c[N+24>>2]|0;m=c[N+12>>2]|0;do if((m|0)==(N|0)){l=N+20|0;j=c[l>>2]|0;if(!j){g=N+16|0;e=c[g>>2]|0;if(!e){O=0;break}else{P=e;Q=g}}else{P=j;Q=l}while(1){l=P+20|0;j=c[l>>2]|0;if(j){P=j;Q=l;continue}l=P+16|0;j=c[l>>2]|0;if(!j)break;else{P=j;Q=l}}if(Q>>>0<o>>>0)hb();else{c[Q>>2]=0;O=P;break}}else{l=c[N+8>>2]|0;if(l>>>0<o>>>0)hb();j=l+12|0;if((c[j>>2]|0)!=(N|0))hb();g=m+8|0;if((c[g>>2]|0)==(N|0)){c[j>>2]=m;c[g>>2]=l;O=m;break}else hb()}while(0);do if(q){m=c[N+28>>2]|0;o=328560+(m<<2)|0;if((N|0)==(c[o>>2]|0)){c[o>>2]=O;if(!O){c[82065]=c[82065]&~(1<<m);break}}else{if(q>>>0<(c[82068]|0)>>>0)hb();m=q+16|0;if((c[m>>2]|0)==(N|0))c[m>>2]=O;else c[q+20>>2]=O;if(!O)break}m=c[82068]|0;if(O>>>0<m>>>0)hb();c[O+24>>2]=q;o=c[N+16>>2]|0;do if(o)if(o>>>0<m>>>0)hb();else{c[O+16>>2]=o;c[o+24>>2]=O;break}while(0);o=c[N+20>>2]|0;if(o)if(o>>>0<(c[82068]|0)>>>0)hb();else{c[O+20>>2]=o;c[o+24>>2]=O;break}}while(0);b:do if(M>>>0>=16){c[N+4>>2]=r|3;c[N+(r|4)>>2]=M|1;c[N+(M+r)>>2]=M;q=M>>>3;if(M>>>0<256){o=q<<1;m=328296+(o<<2)|0;l=c[82064]|0;g=1<<q;do if(!(l&g)){c[82064]=l|g;R=328296+(o+2<<2)|0;S=m}else{q=328296+(o+2<<2)|0;j=c[q>>2]|0;if(j>>>0>=(c[82068]|0)>>>0){R=q;S=j;break}hb()}while(0);c[R>>2]=s;c[S+12>>2]=s;c[N+(r+8)>>2]=S;c[N+(r+12)>>2]=m;break}o=M>>>8;if(o)if(M>>>0>16777215)T=31;else{g=(o+1048320|0)>>>16&8;l=o<<g;o=(l+520192|0)>>>16&4;j=l<<o;l=(j+245760|0)>>>16&2;q=14-(o|g|l)+(j<<l>>>15)|0;T=M>>>(q+7|0)&1|q<<1}else T=0;q=328560+(T<<2)|0;c[N+(r+28)>>2]=T;c[N+(r+20)>>2]=0;c[N+(r+16)>>2]=0;l=c[82065]|0;j=1<<T;if(!(l&j)){c[82065]=l|j;c[q>>2]=s;c[N+(r+24)>>2]=q;c[N+(r+12)>>2]=s;c[N+(r+8)>>2]=s;break}j=c[q>>2]|0;if((T|0)==31)U=0;else U=25-(T>>>1)|0;c:do if((c[j+4>>2]&-8|0)!=(M|0)){q=M<<U;l=j;while(1){V=l+(q>>>31<<2)+16|0;g=c[V>>2]|0;if(!g)break;if((c[g+4>>2]&-8|0)==(M|0)){W=g;break c}else{q=q<<1;l=g}}if(V>>>0<(c[82068]|0)>>>0)hb();else{c[V>>2]=s;c[N+(r+24)>>2]=l;c[N+(r+12)>>2]=s;c[N+(r+8)>>2]=s;break b}}else W=j;while(0);j=W+8|0;m=c[j>>2]|0;q=c[82068]|0;if(W>>>0>=q>>>0&m>>>0>=q>>>0){c[m+12>>2]=s;c[j>>2]=s;c[N+(r+8)>>2]=m;c[N+(r+12)>>2]=W;c[N+(r+24)>>2]=0;break}else hb()}else{m=M+r|0;c[N+4>>2]=m|3;j=N+(m+4)|0;c[j>>2]=c[j>>2]|1}while(0);p=N+8|0;i=b;return p|0}else D=r}else D=r}else D=-1;while(0);N=c[82066]|0;if(N>>>0>=D>>>0){M=N-D|0;W=c[82069]|0;if(M>>>0>15){c[82069]=W+D;c[82066]=M;c[W+(D+4)>>2]=M|1;c[W+N>>2]=M;c[W+4>>2]=D|3}else{c[82066]=0;c[82069]=0;c[W+4>>2]=N|3;M=W+(N+4)|0;c[M>>2]=c[M>>2]|1}p=W+8|0;i=b;return p|0}W=c[82067]|0;if(W>>>0>D>>>0){M=W-D|0;c[82067]=M;W=c[82070]|0;c[82070]=W+D;c[W+(D+4)>>2]=M|1;c[W+4>>2]=D|3;p=W+8|0;i=b;return p|0}do if(!(c[82182]|0)){W=db(30)|0;if(!(W+-1&W)){c[82184]=W;c[82183]=W;c[82185]=-1;c[82186]=-1;c[82187]=0;c[82175]=0;c[82182]=(jb(0)|0)&-16^1431655768;break}else hb()}while(0);W=D+48|0;M=c[82184]|0;N=D+47|0;V=M+N|0;U=0-M|0;M=V&U;if(M>>>0<=D>>>0){p=0;i=b;return p|0}T=c[82174]|0;if((T|0)!=0?(S=c[82172]|0,R=S+M|0,R>>>0<=S>>>0|R>>>0>T>>>0):0){p=0;i=b;return p|0}d:do if(!(c[82175]&4)){T=c[82070]|0;e:do if(T){R=328704|0;while(1){S=c[R>>2]|0;if(S>>>0<=T>>>0?(X=R+4|0,(S+(c[X>>2]|0)|0)>>>0>T>>>0):0)break;S=c[R+8>>2]|0;if(!S){Y=181;break e}else R=S}if(R){S=V-(c[82067]|0)&U;if(S>>>0<2147483647){O=Ma(S|0)|0;if((O|0)==((c[R>>2]|0)+(c[X>>2]|0)|0)){Z=O;_=S;Y=190}else{$=O;aa=S;Y=191}}else ba=0}else Y=181}else Y=181;while(0);do if((Y|0)==181){T=Ma(0)|0;if((T|0)!=(-1|0)){r=T;S=c[82183]|0;O=S+-1|0;if(!(O&r))ca=M;else ca=M-r+(O+r&0-S)|0;S=c[82172]|0;r=S+ca|0;if(ca>>>0>D>>>0&ca>>>0<2147483647){O=c[82174]|0;if((O|0)!=0?r>>>0<=S>>>0|r>>>0>O>>>0:0){ba=0;break}O=Ma(ca|0)|0;if((O|0)==(T|0)){Z=T;_=ca;Y=190}else{$=O;aa=ca;Y=191}}else ba=0}else ba=0}while(0);f:do if((Y|0)==190)if((Z|0)==(-1|0))ba=_;else{da=Z;ea=_;Y=201;break d}else if((Y|0)==191){O=0-aa|0;do if(($|0)!=(-1|0)&aa>>>0<2147483647&W>>>0>aa>>>0?(T=c[82184]|0,r=N-aa+T&0-T,r>>>0<2147483647):0)if((Ma(r|0)|0)==(-1|0)){Ma(O|0)|0;ba=0;break f}else{fa=r+aa|0;break}else fa=aa;while(0);if(($|0)==(-1|0))ba=0;else{da=$;ea=fa;Y=201;break d}}while(0);c[82175]=c[82175]|4;ga=ba;Y=198}else{ga=0;Y=198}while(0);if((((Y|0)==198?M>>>0<2147483647:0)?(ba=Ma(M|0)|0,M=Ma(0)|0,(ba|0)!=(-1|0)&(M|0)!=(-1|0)&ba>>>0<M>>>0):0)?(fa=M-ba|0,M=fa>>>0>(D+40|0)>>>0,M):0){da=ba;ea=M?fa:ga;Y=201}if((Y|0)==201){ga=(c[82172]|0)+ea|0;c[82172]=ga;if(ga>>>0>(c[82173]|0)>>>0)c[82173]=ga;ga=c[82070]|0;g:do if(ga){fa=328704|0;while(1){ha=c[fa>>2]|0;ia=fa+4|0;ja=c[ia>>2]|0;if((da|0)==(ha+ja|0)){Y=213;break}M=c[fa+8>>2]|0;if(!M)break;else fa=M}if(((Y|0)==213?(c[fa+12>>2]&8|0)==0:0)?ga>>>0>=ha>>>0&ga>>>0<da>>>0:0){c[ia>>2]=ja+ea;M=(c[82067]|0)+ea|0;ba=ga+8|0;if(!(ba&7))ka=0;else ka=0-ba&7;ba=M-ka|0;c[82070]=ga+ka;c[82067]=ba;c[ga+(ka+4)>>2]=ba|1;c[ga+(M+4)>>2]=40;c[82071]=c[82186];break}M=c[82068]|0;if(da>>>0<M>>>0){c[82068]=da;la=da}else la=M;M=da+ea|0;ba=328704|0;while(1){if((c[ba>>2]|0)==(M|0)){Y=223;break}$=c[ba+8>>2]|0;if(!$)break;else ba=$}if((Y|0)==223?(c[ba+12>>2]&8|0)==0:0){c[ba>>2]=da;M=ba+4|0;c[M>>2]=(c[M>>2]|0)+ea;M=da+8|0;if(!(M&7))ma=0;else ma=0-M&7;M=da+(ea+8)|0;if(!(M&7))na=0;else na=0-M&7;M=da+(na+ea)|0;fa=ma+D|0;$=da+fa|0;aa=M-(da+ma)-D|0;c[da+(ma+4)>>2]=D|3;h:do if((M|0)!=(ga|0)){if((M|0)==(c[82069]|0)){N=(c[82066]|0)+aa|0;c[82066]=N;c[82069]=$;c[da+(fa+4)>>2]=N|1;c[da+(N+fa)>>2]=N;break}N=ea+4|0;W=c[da+(N+na)>>2]|0;if((W&3|0)==1){_=W&-8;Z=W>>>3;i:do if(W>>>0>=256){ca=c[da+((na|24)+ea)>>2]|0;X=c[da+(ea+12+na)>>2]|0;do if((X|0)==(M|0)){U=na|16;V=da+(N+U)|0;O=c[V>>2]|0;if(!O){R=da+(U+ea)|0;U=c[R>>2]|0;if(!U){oa=0;break}else{pa=U;qa=R}}else{pa=O;qa=V}while(1){V=pa+20|0;O=c[V>>2]|0;if(O){pa=O;qa=V;continue}V=pa+16|0;O=c[V>>2]|0;if(!O)break;else{pa=O;qa=V}}if(qa>>>0<la>>>0)hb();else{c[qa>>2]=0;oa=pa;break}}else{V=c[da+((na|8)+ea)>>2]|0;if(V>>>0<la>>>0)hb();O=V+12|0;if((c[O>>2]|0)!=(M|0))hb();R=X+8|0;if((c[R>>2]|0)==(M|0)){c[O>>2]=X;c[R>>2]=V;oa=X;break}else hb()}while(0);if(!ca)break;X=c[da+(ea+28+na)>>2]|0;l=328560+(X<<2)|0;do if((M|0)!=(c[l>>2]|0)){if(ca>>>0<(c[82068]|0)>>>0)hb();V=ca+16|0;if((c[V>>2]|0)==(M|0))c[V>>2]=oa;else c[ca+20>>2]=oa;if(!oa)break i}else{c[l>>2]=oa;if(oa)break;c[82065]=c[82065]&~(1<<X);break i}while(0);X=c[82068]|0;if(oa>>>0<X>>>0)hb();c[oa+24>>2]=ca;l=na|16;V=c[da+(l+ea)>>2]|0;do if(V)if(V>>>0<X>>>0)hb();else{c[oa+16>>2]=V;c[V+24>>2]=oa;break}while(0);V=c[da+(N+l)>>2]|0;if(!V)break;if(V>>>0<(c[82068]|0)>>>0)hb();else{c[oa+20>>2]=V;c[V+24>>2]=oa;break}}else{V=c[da+((na|8)+ea)>>2]|0;X=c[da+(ea+12+na)>>2]|0;ca=328296+(Z<<1<<2)|0;do if((V|0)!=(ca|0)){if(V>>>0<la>>>0)hb();if((c[V+12>>2]|0)==(M|0))break;hb()}while(0);if((X|0)==(V|0)){c[82064]=c[82064]&~(1<<Z);break}do if((X|0)==(ca|0))ra=X+8|0;else{if(X>>>0<la>>>0)hb();l=X+8|0;if((c[l>>2]|0)==(M|0)){ra=l;break}hb()}while(0);c[V+12>>2]=X;c[ra>>2]=V}while(0);sa=da+((_|na)+ea)|0;ta=_+aa|0}else{sa=M;ta=aa}Z=sa+4|0;c[Z>>2]=c[Z>>2]&-2;c[da+(fa+4)>>2]=ta|1;c[da+(ta+fa)>>2]=ta;Z=ta>>>3;if(ta>>>0<256){N=Z<<1;W=328296+(N<<2)|0;ca=c[82064]|0;l=1<<Z;do if(!(ca&l)){c[82064]=ca|l;ua=328296+(N+2<<2)|0;va=W}else{Z=328296+(N+2<<2)|0;R=c[Z>>2]|0;if(R>>>0>=(c[82068]|0)>>>0){ua=Z;va=R;break}hb()}while(0);c[ua>>2]=$;c[va+12>>2]=$;c[da+(fa+8)>>2]=va;c[da+(fa+12)>>2]=W;break}N=ta>>>8;do if(!N)wa=0;else{if(ta>>>0>16777215){wa=31;break}l=(N+1048320|0)>>>16&8;ca=N<<l;_=(ca+520192|0)>>>16&4;R=ca<<_;ca=(R+245760|0)>>>16&2;Z=14-(_|l|ca)+(R<<ca>>>15)|0;wa=ta>>>(Z+7|0)&1|Z<<1}while(0);N=328560+(wa<<2)|0;c[da+(fa+28)>>2]=wa;c[da+(fa+20)>>2]=0;c[da+(fa+16)>>2]=0;W=c[82065]|0;Z=1<<wa;if(!(W&Z)){c[82065]=W|Z;c[N>>2]=$;c[da+(fa+24)>>2]=N;c[da+(fa+12)>>2]=$;c[da+(fa+8)>>2]=$;break}Z=c[N>>2]|0;if((wa|0)==31)xa=0;else xa=25-(wa>>>1)|0;j:do if((c[Z+4>>2]&-8|0)!=(ta|0)){N=ta<<xa;W=Z;while(1){ya=W+(N>>>31<<2)+16|0;ca=c[ya>>2]|0;if(!ca)break;if((c[ca+4>>2]&-8|0)==(ta|0)){za=ca;break j}else{N=N<<1;W=ca}}if(ya>>>0<(c[82068]|0)>>>0)hb();else{c[ya>>2]=$;c[da+(fa+24)>>2]=W;c[da+(fa+12)>>2]=$;c[da+(fa+8)>>2]=$;break h}}else za=Z;while(0);Z=za+8|0;N=c[Z>>2]|0;V=c[82068]|0;if(za>>>0>=V>>>0&N>>>0>=V>>>0){c[N+12>>2]=$;c[Z>>2]=$;c[da+(fa+8)>>2]=N;c[da+(fa+12)>>2]=za;c[da+(fa+24)>>2]=0;break}else hb()}else{N=(c[82067]|0)+aa|0;c[82067]=N;c[82070]=$;c[da+(fa+4)>>2]=N|1}while(0);p=da+(ma|8)|0;i=b;return p|0}fa=328704|0;while(1){Aa=c[fa>>2]|0;if(Aa>>>0<=ga>>>0?(Ba=c[fa+4>>2]|0,Ca=Aa+Ba|0,Ca>>>0>ga>>>0):0)break;fa=c[fa+8>>2]|0}fa=Aa+(Ba+-39)|0;if(!(fa&7))Da=0;else Da=0-fa&7;fa=Aa+(Ba+-47+Da)|0;$=fa>>>0<(ga+16|0)>>>0?ga:fa;fa=$+8|0;aa=da+8|0;if(!(aa&7))Ea=0;else Ea=0-aa&7;aa=ea+-40-Ea|0;c[82070]=da+Ea;c[82067]=aa;c[da+(Ea+4)>>2]=aa|1;c[da+(ea+-36)>>2]=40;c[82071]=c[82186];c[$+4>>2]=27;c[fa+0>>2]=c[82176];c[fa+4>>2]=c[82177];c[fa+8>>2]=c[82178];c[fa+12>>2]=c[82179];c[82176]=da;c[82177]=ea;c[82179]=0;c[82178]=fa;fa=$+28|0;c[fa>>2]=7;if(($+32|0)>>>0<Ca>>>0){aa=fa;do{fa=aa;aa=aa+4|0;c[aa>>2]=7}while((fa+8|0)>>>0<Ca>>>0)}if(($|0)!=(ga|0)){aa=$-ga|0;fa=ga+(aa+4)|0;c[fa>>2]=c[fa>>2]&-2;c[ga+4>>2]=aa|1;c[ga+aa>>2]=aa;fa=aa>>>3;if(aa>>>0<256){M=fa<<1;ba=328296+(M<<2)|0;N=c[82064]|0;Z=1<<fa;do if(!(N&Z)){c[82064]=N|Z;Fa=328296+(M+2<<2)|0;Ga=ba}else{fa=328296+(M+2<<2)|0;V=c[fa>>2]|0;if(V>>>0>=(c[82068]|0)>>>0){Fa=fa;Ga=V;break}hb()}while(0);c[Fa>>2]=ga;c[Ga+12>>2]=ga;c[ga+8>>2]=Ga;c[ga+12>>2]=ba;break}M=aa>>>8;if(M)if(aa>>>0>16777215)Ha=31;else{Z=(M+1048320|0)>>>16&8;N=M<<Z;M=(N+520192|0)>>>16&4;$=N<<M;N=($+245760|0)>>>16&2;V=14-(M|Z|N)+($<<N>>>15)|0;Ha=aa>>>(V+7|0)&1|V<<1}else Ha=0;V=328560+(Ha<<2)|0;c[ga+28>>2]=Ha;c[ga+20>>2]=0;c[ga+16>>2]=0;N=c[82065]|0;$=1<<Ha;if(!(N&$)){c[82065]=N|$;c[V>>2]=ga;c[ga+24>>2]=V;c[ga+12>>2]=ga;c[ga+8>>2]=ga;break}$=c[V>>2]|0;if((Ha|0)==31)Ia=0;else Ia=25-(Ha>>>1)|0;k:do if((c[$+4>>2]&-8|0)!=(aa|0)){V=aa<<Ia;N=$;while(1){Ja=N+(V>>>31<<2)+16|0;Z=c[Ja>>2]|0;if(!Z)break;if((c[Z+4>>2]&-8|0)==(aa|0)){Ka=Z;break k}else{V=V<<1;N=Z}}if(Ja>>>0<(c[82068]|0)>>>0)hb();else{c[Ja>>2]=ga;c[ga+24>>2]=N;c[ga+12>>2]=ga;c[ga+8>>2]=ga;break g}}else Ka=$;while(0);$=Ka+8|0;aa=c[$>>2]|0;ba=c[82068]|0;if(Ka>>>0>=ba>>>0&aa>>>0>=ba>>>0){c[aa+12>>2]=ga;c[$>>2]=ga;c[ga+8>>2]=aa;c[ga+12>>2]=Ka;c[ga+24>>2]=0;break}else hb()}}else{aa=c[82068]|0;if((aa|0)==0|da>>>0<aa>>>0)c[82068]=da;c[82176]=da;c[82177]=ea;c[82179]=0;c[82073]=c[82182];c[82072]=-1;aa=0;do{$=aa<<1;ba=328296+($<<2)|0;c[328296+($+3<<2)>>2]=ba;c[328296+($+2<<2)>>2]=ba;aa=aa+1|0}while((aa|0)!=32);aa=da+8|0;if(!(aa&7))La=0;else La=0-aa&7;aa=ea+-40-La|0;c[82070]=da+La;c[82067]=aa;c[da+(La+4)>>2]=aa|1;c[da+(ea+-36)>>2]=40;c[82071]=c[82186]}while(0);ea=c[82067]|0;if(ea>>>0>D>>>0){da=ea-D|0;c[82067]=da;ea=c[82070]|0;c[82070]=ea+D;c[ea+(D+4)>>2]=da|1;c[ea+4>>2]=D|3;p=ea+8|0;i=b;return p|0}}c[(_a()|0)>>2]=12;p=0;i=b;return p|0}function jT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;b=i;if(!a){i=b;return}d=a+-8|0;e=c[82068]|0;if(d>>>0<e>>>0)hb();f=c[a+-4>>2]|0;g=f&3;if((g|0)==1)hb();h=f&-8;j=a+(h+-8)|0;do if(!(f&1)){k=c[d>>2]|0;if(!g){i=b;return}l=-8-k|0;m=a+l|0;n=k+h|0;if(m>>>0<e>>>0)hb();if((m|0)==(c[82069]|0)){o=a+(h+-4)|0;p=c[o>>2]|0;if((p&3|0)!=3){q=m;r=n;break}c[82066]=n;c[o>>2]=p&-2;c[a+(l+4)>>2]=n|1;c[j>>2]=n;i=b;return}p=k>>>3;if(k>>>0<256){k=c[a+(l+8)>>2]|0;o=c[a+(l+12)>>2]|0;s=328296+(p<<1<<2)|0;if((k|0)!=(s|0)){if(k>>>0<e>>>0)hb();if((c[k+12>>2]|0)!=(m|0))hb()}if((o|0)==(k|0)){c[82064]=c[82064]&~(1<<p);q=m;r=n;break}if((o|0)!=(s|0)){if(o>>>0<e>>>0)hb();s=o+8|0;if((c[s>>2]|0)==(m|0))t=s;else hb()}else t=o+8|0;c[k+12>>2]=o;c[t>>2]=k;q=m;r=n;break}k=c[a+(l+24)>>2]|0;o=c[a+(l+12)>>2]|0;do if((o|0)==(m|0)){s=a+(l+20)|0;p=c[s>>2]|0;if(!p){u=a+(l+16)|0;v=c[u>>2]|0;if(!v){w=0;break}else{x=v;y=u}}else{x=p;y=s}while(1){s=x+20|0;p=c[s>>2]|0;if(p){x=p;y=s;continue}s=x+16|0;p=c[s>>2]|0;if(!p)break;else{x=p;y=s}}if(y>>>0<e>>>0)hb();else{c[y>>2]=0;w=x;break}}else{s=c[a+(l+8)>>2]|0;if(s>>>0<e>>>0)hb();p=s+12|0;if((c[p>>2]|0)!=(m|0))hb();u=o+8|0;if((c[u>>2]|0)==(m|0)){c[p>>2]=o;c[u>>2]=s;w=o;break}else hb()}while(0);if(k){o=c[a+(l+28)>>2]|0;s=328560+(o<<2)|0;if((m|0)==(c[s>>2]|0)){c[s>>2]=w;if(!w){c[82065]=c[82065]&~(1<<o);q=m;r=n;break}}else{if(k>>>0<(c[82068]|0)>>>0)hb();o=k+16|0;if((c[o>>2]|0)==(m|0))c[o>>2]=w;else c[k+20>>2]=w;if(!w){q=m;r=n;break}}o=c[82068]|0;if(w>>>0<o>>>0)hb();c[w+24>>2]=k;s=c[a+(l+16)>>2]|0;do if(s)if(s>>>0<o>>>0)hb();else{c[w+16>>2]=s;c[s+24>>2]=w;break}while(0);s=c[a+(l+20)>>2]|0;if(s)if(s>>>0<(c[82068]|0)>>>0)hb();else{c[w+20>>2]=s;c[s+24>>2]=w;q=m;r=n;break}else{q=m;r=n}}else{q=m;r=n}}else{q=d;r=h}while(0);if(q>>>0>=j>>>0)hb();d=a+(h+-4)|0;w=c[d>>2]|0;if(!(w&1))hb();if(!(w&2)){if((j|0)==(c[82070]|0)){e=(c[82067]|0)+r|0;c[82067]=e;c[82070]=q;c[q+4>>2]=e|1;if((q|0)!=(c[82069]|0)){i=b;return}c[82069]=0;c[82066]=0;i=b;return}if((j|0)==(c[82069]|0)){e=(c[82066]|0)+r|0;c[82066]=e;c[82069]=q;c[q+4>>2]=e|1;c[q+e>>2]=e;i=b;return}e=(w&-8)+r|0;x=w>>>3;do if(w>>>0>=256){y=c[a+(h+16)>>2]|0;t=c[a+(h|4)>>2]|0;do if((t|0)==(j|0)){g=a+(h+12)|0;f=c[g>>2]|0;if(!f){s=a+(h+8)|0;o=c[s>>2]|0;if(!o){z=0;break}else{A=o;B=s}}else{A=f;B=g}while(1){g=A+20|0;f=c[g>>2]|0;if(f){A=f;B=g;continue}g=A+16|0;f=c[g>>2]|0;if(!f)break;else{A=f;B=g}}if(B>>>0<(c[82068]|0)>>>0)hb();else{c[B>>2]=0;z=A;break}}else{g=c[a+h>>2]|0;if(g>>>0<(c[82068]|0)>>>0)hb();f=g+12|0;if((c[f>>2]|0)!=(j|0))hb();s=t+8|0;if((c[s>>2]|0)==(j|0)){c[f>>2]=t;c[s>>2]=g;z=t;break}else hb()}while(0);if(y){t=c[a+(h+20)>>2]|0;n=328560+(t<<2)|0;if((j|0)==(c[n>>2]|0)){c[n>>2]=z;if(!z){c[82065]=c[82065]&~(1<<t);break}}else{if(y>>>0<(c[82068]|0)>>>0)hb();t=y+16|0;if((c[t>>2]|0)==(j|0))c[t>>2]=z;else c[y+20>>2]=z;if(!z)break}t=c[82068]|0;if(z>>>0<t>>>0)hb();c[z+24>>2]=y;n=c[a+(h+8)>>2]|0;do if(n)if(n>>>0<t>>>0)hb();else{c[z+16>>2]=n;c[n+24>>2]=z;break}while(0);n=c[a+(h+12)>>2]|0;if(n)if(n>>>0<(c[82068]|0)>>>0)hb();else{c[z+20>>2]=n;c[n+24>>2]=z;break}}}else{n=c[a+h>>2]|0;t=c[a+(h|4)>>2]|0;y=328296+(x<<1<<2)|0;if((n|0)!=(y|0)){if(n>>>0<(c[82068]|0)>>>0)hb();if((c[n+12>>2]|0)!=(j|0))hb()}if((t|0)==(n|0)){c[82064]=c[82064]&~(1<<x);break}if((t|0)!=(y|0)){if(t>>>0<(c[82068]|0)>>>0)hb();y=t+8|0;if((c[y>>2]|0)==(j|0))C=y;else hb()}else C=t+8|0;c[n+12>>2]=t;c[C>>2]=n}while(0);c[q+4>>2]=e|1;c[q+e>>2]=e;if((q|0)==(c[82069]|0)){c[82066]=e;i=b;return}else D=e}else{c[d>>2]=w&-2;c[q+4>>2]=r|1;c[q+r>>2]=r;D=r}r=D>>>3;if(D>>>0<256){w=r<<1;d=328296+(w<<2)|0;e=c[82064]|0;C=1<<r;if(e&C){r=328296+(w+2<<2)|0;j=c[r>>2]|0;if(j>>>0<(c[82068]|0)>>>0)hb();else{E=r;F=j}}else{c[82064]=e|C;E=328296+(w+2<<2)|0;F=d}c[E>>2]=q;c[F+12>>2]=q;c[q+8>>2]=F;c[q+12>>2]=d;i=b;return}d=D>>>8;if(d)if(D>>>0>16777215)G=31;else{F=(d+1048320|0)>>>16&8;E=d<<F;d=(E+520192|0)>>>16&4;w=E<<d;E=(w+245760|0)>>>16&2;C=14-(d|F|E)+(w<<E>>>15)|0;G=D>>>(C+7|0)&1|C<<1}else G=0;C=328560+(G<<2)|0;c[q+28>>2]=G;c[q+20>>2]=0;c[q+16>>2]=0;E=c[82065]|0;w=1<<G;a:do if(E&w){F=c[C>>2]|0;if((G|0)==31)H=0;else H=25-(G>>>1)|0;b:do if((c[F+4>>2]&-8|0)!=(D|0)){d=D<<H;e=F;while(1){I=e+(d>>>31<<2)+16|0;j=c[I>>2]|0;if(!j)break;if((c[j+4>>2]&-8|0)==(D|0)){J=j;break b}else{d=d<<1;e=j}}if(I>>>0<(c[82068]|0)>>>0)hb();else{c[I>>2]=q;c[q+24>>2]=e;c[q+12>>2]=q;c[q+8>>2]=q;break a}}else J=F;while(0);F=J+8|0;d=c[F>>2]|0;j=c[82068]|0;if(J>>>0>=j>>>0&d>>>0>=j>>>0){c[d+12>>2]=q;c[F>>2]=q;c[q+8>>2]=d;c[q+12>>2]=J;c[q+24>>2]=0;break}else hb()}else{c[82065]=E|w;c[C>>2]=q;c[q+24>>2]=C;c[q+12>>2]=q;c[q+8>>2]=q}while(0);q=(c[82072]|0)+-1|0;c[82072]=q;if(!q)K=328712|0;else{i=b;return}while(1){q=c[K>>2]|0;if(!q)break;else K=q+8|0}c[82072]=-1;i=b;return}function kT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;do if(a){if(b>>>0>4294967231){c[(_a()|0)>>2]=12;e=0;break}if(b>>>0<11)f=16;else f=b+11&-8;g=ST(a+-8|0,f)|0;if(g){e=g+8|0;break}g=iT(b)|0;if(!g)e=0;else{h=c[a+-4>>2]|0;j=(h&-8)-((h&3|0)==0?8:4)|0;eU(g|0,a|0,(j>>>0<b>>>0?j:b)|0)|0;jT(a);e=g}}else e=iT(b)|0;while(0);i=d;return e|0}function lT(a){a=a|0;return(a+-48|0)>>>0<10|0}function mT(a){a=a|0;var b=0;if((a|0)==32)b=1;else b=(a+-9|0)>>>0<5;return b&1|0}function nT(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,da=0,ea=0,fa=0,ga=0;j=i;if(e>>>0>36){c[(_a()|0)>>2]=22;k=0;l=0;G=k;i=j;return l|0}m=b+4|0;n=b+100|0;do{o=c[m>>2]|0;if(o>>>0<(c[n>>2]|0)>>>0){c[m>>2]=o+1;p=d[o>>0]|0}else p=qT(b)|0}while((mT(p)|0)!=0);do if((p|0)==43|(p|0)==45){o=((p|0)==45)<<31>>31;q=c[m>>2]|0;if(q>>>0<(c[n>>2]|0)>>>0){c[m>>2]=q+1;r=d[q>>0]|0;s=o;break}else{r=qT(b)|0;s=o;break}}else{r=p;s=0}while(0);p=(e|0)==0;do if((e&-17|0)==0&(r|0)==48){o=c[m>>2]|0;if(o>>>0<(c[n>>2]|0)>>>0){c[m>>2]=o+1;t=d[o>>0]|0}else t=qT(b)|0;if((t|32|0)!=120)if(p){u=8;v=t;w=46;break}else{x=e;y=t;w=32;break}o=c[m>>2]|0;if(o>>>0<(c[n>>2]|0)>>>0){c[m>>2]=o+1;z=d[o>>0]|0}else z=qT(b)|0;if((d[z+328753>>0]|0)>15){o=(c[n>>2]|0)==0;if(!o)c[m>>2]=(c[m>>2]|0)+-1;if(!f){pT(b,0);k=0;l=0;G=k;i=j;return l|0}if(o){k=0;l=0;G=k;i=j;return l|0}c[m>>2]=(c[m>>2]|0)+-1;k=0;l=0;G=k;i=j;return l|0}else{u=16;v=z;w=46}}else{o=p?10:e;if((d[r+328753>>0]|0)>>>0<o>>>0){x=o;y=r;w=32}else{if(c[n>>2]|0)c[m>>2]=(c[m>>2]|0)+-1;pT(b,0);c[(_a()|0)>>2]=22;k=0;l=0;G=k;i=j;return l|0}}while(0);if((w|0)==32)if((x|0)==10){r=y+-48|0;if(r>>>0<10){e=r;r=0;do{r=(r*10|0)+e|0;p=c[m>>2]|0;if(p>>>0<(c[n>>2]|0)>>>0){c[m>>2]=p+1;A=d[p>>0]|0}else A=qT(b)|0;e=A+-48|0}while(e>>>0<10&r>>>0<429496729);B=r;C=0;D=A}else{B=0;C=0;D=y}A=D+-48|0;if(A>>>0<10){r=B;e=C;p=A;A=D;while(1){D=mU(r|0,e|0,10,0)|0;z=G;f=((p|0)<0)<<31>>31;t=~f;if(z>>>0>t>>>0|(z|0)==(t|0)&D>>>0>~p>>>0){E=p;F=r;H=e;I=A;break}t=bU(D|0,z|0,p|0,f|0)|0;f=G;z=c[m>>2]|0;if(z>>>0<(c[n>>2]|0)>>>0){c[m>>2]=z+1;J=d[z>>0]|0}else J=qT(b)|0;z=J+-48|0;if(z>>>0<10&(f>>>0<429496729|(f|0)==429496729&t>>>0<2576980378)){r=t;e=f;p=z;A=J}else{E=z;F=t;H=f;I=J;break}}if(E>>>0>9){K=H;L=F}else{M=10;N=F;O=H;P=I;w=72}}else{K=C;L=B}}else{u=x;v=y;w=46}a:do if((w|0)==46){if(!(u+-1&u)){y=a[329016+((u*23|0)>>>5&7)>>0]|0;x=a[v+328753>>0]|0;B=x&255;if(B>>>0<u>>>0){C=B;B=0;do{B=C|B<<y;I=c[m>>2]|0;if(I>>>0<(c[n>>2]|0)>>>0){c[m>>2]=I+1;Q=d[I>>0]|0}else Q=qT(b)|0;R=a[Q+328753>>0]|0;C=R&255}while(C>>>0<u>>>0&B>>>0<134217728);S=R;T=0;U=B;V=Q}else{S=x;T=0;U=0;V=v}C=dU(-1,-1,y|0)|0;I=G;if((S&255)>>>0>=u>>>0|(T>>>0>I>>>0|(T|0)==(I|0)&U>>>0>C>>>0)){M=u;N=U;O=T;P=V;w=72;break}else{W=U;X=T;Y=S}while(1){H=$T(W|0,X|0,y|0)|0;F=G;E=Y&255|H;H=c[m>>2]|0;if(H>>>0<(c[n>>2]|0)>>>0){c[m>>2]=H+1;Z=d[H>>0]|0}else Z=qT(b)|0;Y=a[Z+328753>>0]|0;if((Y&255)>>>0>=u>>>0|(F>>>0>I>>>0|(F|0)==(I|0)&E>>>0>C>>>0)){M=u;N=E;O=F;P=Z;w=72;break a}else{W=E;X=F}}}C=a[v+328753>>0]|0;I=C&255;if(I>>>0<u>>>0){y=I;I=0;do{I=y+(ca(I,u)|0)|0;x=c[m>>2]|0;if(x>>>0<(c[n>>2]|0)>>>0){c[m>>2]=x+1;_=d[x>>0]|0}else _=qT(b)|0;$=a[_+328753>>0]|0;y=$&255}while(y>>>0<u>>>0&I>>>0<119304647);aa=$;ba=I;da=0;ea=_}else{aa=C;ba=0;da=0;ea=v}if((aa&255)>>>0<u>>>0){y=nU(-1,-1,u|0,0)|0;x=G;B=da;F=ba;E=aa;H=ea;while(1){if(B>>>0>x>>>0|(B|0)==(x|0)&F>>>0>y>>>0){M=u;N=F;O=B;P=H;w=72;break a}J=mU(F|0,B|0,u|0,0)|0;A=G;p=E&255;if(A>>>0>4294967295|(A|0)==-1&J>>>0>~p>>>0){M=u;N=F;O=B;P=H;w=72;break a}e=bU(p|0,0,J|0,A|0)|0;A=G;J=c[m>>2]|0;if(J>>>0<(c[n>>2]|0)>>>0){c[m>>2]=J+1;fa=d[J>>0]|0}else fa=qT(b)|0;E=a[fa+328753>>0]|0;if((E&255)>>>0>=u>>>0){M=u;N=e;O=A;P=fa;w=72;break}else{B=A;F=e;H=fa}}}else{M=u;N=ba;O=da;P=ea;w=72}}while(0);if((w|0)==72)if((d[P+328753>>0]|0)>>>0<M>>>0){do{P=c[m>>2]|0;if(P>>>0<(c[n>>2]|0)>>>0){c[m>>2]=P+1;ga=d[P>>0]|0}else ga=qT(b)|0}while((d[ga+328753>>0]|0)>>>0<M>>>0);c[(_a()|0)>>2]=34;K=h;L=g}else{K=O;L=N}if(c[n>>2]|0)c[m>>2]=(c[m>>2]|0)+-1;if(!(K>>>0<h>>>0|(K|0)==(h|0)&L>>>0<g>>>0)){if(!((g&1|0)!=0|0!=0|(s|0)!=0)){c[(_a()|0)>>2]=34;m=bU(g|0,h|0,-1,-1)|0;k=G;l=m;G=k;i=j;return l|0}if(K>>>0>h>>>0|(K|0)==(h|0)&L>>>0>g>>>0){c[(_a()|0)>>2]=34;k=h;l=g;G=k;i=j;return l|0}}g=((s|0)<0)<<31>>31;h=XT(L^s|0,K^g|0,s|0,g|0)|0;k=G;l=h;G=k;i=j;return l|0}function oT(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0;g=i;i=i+512|0;h=g;if(!e){j=24;k=-149}else if((e|0)==1){j=53;k=-1074}else if((e|0)==2){j=53;k=-1074}else{l=0;i=g;return+l}e=b+4|0;m=b+100|0;do{n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;o=d[n>>0]|0}else o=qT(b)|0}while((mT(o)|0)!=0);do if((o|0)==43|(o|0)==45){n=1-(((o|0)==45&1)<<1)|0;p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;q=d[p>>0]|0;r=n;break}else{q=qT(b)|0;r=n;break}}else{q=o;r=1}while(0);o=q;q=0;while(1){if((o|32|0)!=(a[329032+q>>0]|0)){s=o;t=q;break}do if(q>>>0<7){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;u=d[n>>0]|0;break}else{u=qT(b)|0;break}}else u=o;while(0);n=q+1|0;if(n>>>0<8){o=u;q=n}else{s=u;t=n;break}}do if((t|0)==3)x=23;else if((t|0)!=8){u=(f|0)!=0;if(t>>>0>3&u)if((t|0)==8)break;else{x=23;break}a:do if(!t){q=s;o=0;while(1){if((q|32|0)!=(a[329048+o>>0]|0)){y=q;z=o;break a}do if(o>>>0<2){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;A=d[n>>0]|0;break}else{A=qT(b)|0;break}}else A=q;while(0);n=o+1|0;if(n>>>0<3){q=A;o=n}else{y=A;z=n;break}}}else{y=s;z=t}while(0);if((z|0)==3){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;B=d[o>>0]|0}else B=qT(b)|0;if((B|0)==40)C=1;else{if(!(c[m>>2]|0)){l=v;i=g;return+l}c[e>>2]=(c[e>>2]|0)+-1;l=v;i=g;return+l}while(1){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o>>0]|0}else D=qT(b)|0;if(!((D+-48|0)>>>0<10|(D+-65|0)>>>0<26)?!((D+-97|0)>>>0<26|(D|0)==95):0)break;C=C+1|0}if((D|0)==41){l=v;i=g;return+l}o=(c[m>>2]|0)==0;if(!o)c[e>>2]=(c[e>>2]|0)+-1;if(!u){c[(_a()|0)>>2]=22;pT(b,0);l=0;i=g;return+l}if((C|0)==0|o){l=v;i=g;return+l}else E=C;do{E=E+-1|0;c[e>>2]=(c[e>>2]|0)+-1}while((E|0)!=0);l=v;i=g;return+l}else if(!z){do if((y|0)==48){u=c[e>>2]|0;if(u>>>0<(c[m>>2]|0)>>>0){c[e>>2]=u+1;F=d[u>>0]|0}else F=qT(b)|0;if((F|32|0)!=120){if(!(c[m>>2]|0)){H=48;break}c[e>>2]=(c[e>>2]|0)+-1;H=48;break}u=c[e>>2]|0;if(u>>>0<(c[m>>2]|0)>>>0){c[e>>2]=u+1;I=d[u>>0]|0;J=0}else{I=qT(b)|0;J=0}while(1){if((I|0)==46){x=70;break}else if((I|0)!=48){K=0;L=0;M=0;N=0;O=I;P=J;Q=0;S=0;T=1;U=0;V=0;break}u=c[e>>2]|0;if(u>>>0<(c[m>>2]|0)>>>0){c[e>>2]=u+1;I=d[u>>0]|0;J=1;continue}else{I=qT(b)|0;J=1;continue}}if((x|0)==70){u=c[e>>2]|0;if(u>>>0<(c[m>>2]|0)>>>0){c[e>>2]=u+1;W=d[u>>0]|0}else W=qT(b)|0;if((W|0)==48){u=0;o=0;while(1){q=c[e>>2]|0;if(q>>>0<(c[m>>2]|0)>>>0){c[e>>2]=q+1;X=d[q>>0]|0}else X=qT(b)|0;q=bU(u|0,o|0,-1,-1)|0;n=G;if((X|0)==48){u=q;o=n}else{K=0;L=0;M=q;N=n;O=X;P=1;Q=1;S=0;T=1;U=0;V=0;break}}}else{K=0;L=0;M=0;N=0;O=W;P=J;Q=1;S=0;T=1;U=0;V=0}}b:while(1){o=O+-48|0;do if(o>>>0>=10){u=O|32;n=(O|0)==46;if(!((u+-97|0)>>>0<6|n)){Y=O;break b}if(n)if(!Q){Z=L;_=K;$=L;aa=K;ba=P;da=1;ea=S;fa=T;ga=U;ha=V;break}else{Y=46;break b}else{ia=(O|0)>57?u+-87|0:o;x=83;break}}else{ia=o;x=83}while(0);if((x|0)==83){x=0;do if(!((K|0)<0|(K|0)==0&L>>>0<8)){if((K|0)<0|(K|0)==0&L>>>0<14){ja=T*.0625;ka=S;la=ja;ma=U;na=V+ja*+(ia|0);break}if((ia|0)==0|(S|0)!=0){ka=S;la=T;ma=U;na=V}else{ka=1;la=T;ma=U;na=V+T*.5}}else{ka=S;la=T;ma=ia+(U<<4)|0;na=V}while(0);o=bU(L|0,K|0,1,0)|0;Z=M;_=N;$=o;aa=G;ba=1;da=Q;ea=ka;fa=la;ga=ma;ha=na}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;K=aa;L=$;M=Z;N=_;O=d[o>>0]|0;P=ba;Q=da;S=ea;T=fa;U=ga;V=ha;continue}else{K=aa;L=$;M=Z;N=_;O=qT(b)|0;P=ba;Q=da;S=ea;T=fa;U=ga;V=ha;continue}}if(!P){o=(c[m>>2]|0)==0;if(!o)c[e>>2]=(c[e>>2]|0)+-1;if(f){if(!o?(o=c[e>>2]|0,c[e>>2]=o+-1,(Q|0)!=0):0)c[e>>2]=o+-2}else pT(b,0);l=+(r|0)*0;i=g;return+l}o=(Q|0)==0;u=o?L:M;n=o?K:N;if((K|0)<0|(K|0)==0&L>>>0<8){o=L;q=K;p=U;while(1){oa=p<<4;o=bU(o|0,q|0,1,0)|0;q=G;if(!((q|0)<0|(q|0)==0&o>>>0<8)){pa=oa;break}else p=oa}}else pa=U;do if((Y|32|0)==112){p=UT(b,f)|0;o=G;if((p|0)==0&(o|0)==-2147483648)if(!f){pT(b,0);l=0;i=g;return+l}else{if(!(c[m>>2]|0)){qa=0;ra=0;break}c[e>>2]=(c[e>>2]|0)+-1;qa=0;ra=0;break}else{qa=p;ra=o}}else if(!(c[m>>2]|0)){qa=0;ra=0}else{c[e>>2]=(c[e>>2]|0)+-1;qa=0;ra=0}while(0);o=$T(u|0,n|0,2)|0;p=bU(o|0,G|0,-32,-1)|0;o=bU(p|0,G|0,qa|0,ra|0)|0;p=G;if(!pa){l=+(r|0)*0;i=g;return+l}if((p|0)>0|(p|0)==0&o>>>0>(0-k|0)>>>0){c[(_a()|0)>>2]=34;l=+(r|0)*1.7976931348623157e308*1.7976931348623157e308;i=g;return+l}q=k+-106|0;oa=((q|0)<0)<<31>>31;if((p|0)<(oa|0)|(p|0)==(oa|0)&o>>>0<q>>>0){c[(_a()|0)>>2]=34;l=+(r|0)*2.2250738585072014e-308*2.2250738585072014e-308;i=g;return+l}if((pa|0)>-1){q=o;oa=p;sa=pa;ja=V;while(1){ta=sa<<1;if(!(ja>=.5)){ua=ja;va=ta}else{ua=ja+-1;va=ta|1}wa=ja+ua;ta=bU(q|0,oa|0,-1,-1)|0;xa=G;if((va|0)>-1){q=ta;oa=xa;sa=va;ja=wa}else{ya=ta;za=xa;Aa=va;Ba=wa;break}}}else{ya=o;za=p;Aa=pa;Ba=V}sa=XT(32,0,k|0,((k|0)<0)<<31>>31|0)|0;oa=bU(ya|0,za|0,sa|0,G|0)|0;sa=G;if(0>(sa|0)|0==(sa|0)&j>>>0>oa>>>0)if((oa|0)<0){Ca=0;x=126}else{Da=oa;x=124}else{Da=j;x=124}if((x|0)==124)if((Da|0)<53){Ca=Da;x=126}else{Ea=Da;Fa=+(r|0);Ga=0}if((x|0)==126){ja=+(r|0);Ea=Ca;Fa=ja;Ga=+tT(+AT(1,84-Ca|0),ja)}oa=(Ea|0)<32&Ba!=0&(Aa&1|0)==0;ja=Fa*(oa?0:Ba)+(Ga+Fa*+(((oa&1)+Aa|0)>>>0))-Ga;if(!(ja!=0))c[(_a()|0)>>2]=34;l=+BT(ja,ya);i=g;return+l}else H=y;while(0);oa=k+j|0;sa=0-oa|0;q=H;n=0;while(1){if((q|0)==46){x=137;break}else if((q|0)!=48){Ha=q;Ia=0;Ja=0;Ka=n;La=0;break}u=c[e>>2]|0;if(u>>>0<(c[m>>2]|0)>>>0){c[e>>2]=u+1;q=d[u>>0]|0;n=1;continue}else{q=qT(b)|0;n=1;continue}}if((x|0)==137){q=c[e>>2]|0;if(q>>>0<(c[m>>2]|0)>>>0){c[e>>2]=q+1;Ma=d[q>>0]|0}else Ma=qT(b)|0;if((Ma|0)==48){q=0;u=0;while(1){xa=bU(q|0,u|0,-1,-1)|0;ta=G;Na=c[e>>2]|0;if(Na>>>0<(c[m>>2]|0)>>>0){c[e>>2]=Na+1;Oa=d[Na>>0]|0}else Oa=qT(b)|0;if((Oa|0)==48){q=xa;u=ta}else{Ha=Oa;Ia=xa;Ja=ta;Ka=1;La=1;break}}}else{Ha=Ma;Ia=0;Ja=0;Ka=n;La=1}}c[h>>2]=0;u=Ha+-48|0;q=(Ha|0)==46;c:do if(u>>>0<10|q){ta=h+496|0;xa=Ha;Na=0;Pa=0;Qa=q;Ra=u;Sa=Ia;Ta=Ja;Ua=Ka;Va=La;Wa=0;Xa=0;Ya=0;d:while(1){do if(Qa)if(!Va){Za=Na;$a=Pa;ab=Na;bb=Pa;cb=Ua;db=1;eb=Wa;fb=Xa;gb=Ya}else break d;else{hb=bU(Na|0,Pa|0,1,0)|0;ib=G;jb=(xa|0)!=48;if((Xa|0)>=125){if(!jb){Za=Sa;$a=Ta;ab=hb;bb=ib;cb=Ua;db=Va;eb=Wa;fb=Xa;gb=Ya;break}c[ta>>2]=c[ta>>2]|1;Za=Sa;$a=Ta;ab=hb;bb=ib;cb=Ua;db=Va;eb=Wa;fb=Xa;gb=Ya;break}kb=h+(Xa<<2)|0;if(!Wa)lb=Ra;else lb=xa+-48+((c[kb>>2]|0)*10|0)|0;c[kb>>2]=lb;kb=Wa+1|0;mb=(kb|0)==9;Za=Sa;$a=Ta;ab=hb;bb=ib;cb=1;db=Va;eb=mb?0:kb;fb=(mb&1)+Xa|0;gb=jb?hb:Ya}while(0);hb=c[e>>2]|0;if(hb>>>0<(c[m>>2]|0)>>>0){c[e>>2]=hb+1;nb=d[hb>>0]|0}else nb=qT(b)|0;Ra=nb+-48|0;Qa=(nb|0)==46;if(!(Ra>>>0<10|Qa)){ob=nb;pb=Za;qb=ab;rb=$a;sb=bb;tb=cb;ub=db;vb=eb;wb=fb;xb=gb;x=160;break c}else{xa=nb;Na=ab;Pa=bb;Sa=Za;Ta=$a;Ua=cb;Va=db;Wa=eb;Xa=fb;Ya=gb}}yb=Na;zb=Pa;Ab=Sa;Bb=Ta;Cb=(Ua|0)!=0;Db=Wa;Eb=Xa;Fb=Ya;x=168}else{ob=Ha;pb=Ia;qb=0;rb=Ja;sb=0;tb=Ka;ub=La;vb=0;wb=0;xb=0;x=160}while(0);do if((x|0)==160){u=(ub|0)==0;q=u?qb:pb;n=u?sb:rb;u=(tb|0)!=0;if(!(u&(ob|32|0)==101))if((ob|0)>-1){yb=qb;zb=sb;Ab=q;Bb=n;Cb=u;Db=vb;Eb=wb;Fb=xb;x=168;break}else{Gb=qb;Hb=sb;Ib=u;Jb=q;Kb=n;Lb=vb;Mb=wb;Nb=xb;x=170;break}u=UT(b,f)|0;Va=G;do if((u|0)==0&(Va|0)==-2147483648)if(!f){pT(b,0);l=0;i=g;return+l}else{if(!(c[m>>2]|0)){Ob=0;Pb=0;break}c[e>>2]=(c[e>>2]|0)+-1;Ob=0;Pb=0;break}else{Ob=u;Pb=Va}while(0);Va=bU(Ob|0,Pb|0,q|0,n|0)|0;Qb=Va;Rb=qb;Sb=G;Tb=sb;Ub=vb;Vb=wb;Wb=xb}while(0);if((x|0)==168)if(c[m>>2]|0){c[e>>2]=(c[e>>2]|0)+-1;if(Cb){Qb=Ab;Rb=yb;Sb=Bb;Tb=zb;Ub=Db;Vb=Eb;Wb=Fb}else x=171}else{Gb=yb;Hb=zb;Ib=Cb;Jb=Ab;Kb=Bb;Lb=Db;Mb=Eb;Nb=Fb;x=170}if((x|0)==170)if(Ib){Qb=Jb;Rb=Gb;Sb=Kb;Tb=Hb;Ub=Lb;Vb=Mb;Wb=Nb}else x=171;if((x|0)==171){c[(_a()|0)>>2]=22;pT(b,0);l=0;i=g;return+l}Va=c[h>>2]|0;if(!Va){l=+(r|0)*0;i=g;return+l}if((Qb|0)==(Rb|0)&(Sb|0)==(Tb|0)&((Tb|0)<0|(Tb|0)==0&Rb>>>0<10)?j>>>0>30|(Va>>>j|0)==0:0){l=+(r|0)*+(Va>>>0);i=g;return+l}Va=(k|0)/-2|0;u=((Va|0)<0)<<31>>31;if((Sb|0)>(u|0)|(Sb|0)==(u|0)&Qb>>>0>Va>>>0){c[(_a()|0)>>2]=34;l=+(r|0)*1.7976931348623157e308*1.7976931348623157e308;i=g;return+l}Va=k+-106|0;u=((Va|0)<0)<<31>>31;if((Sb|0)<(u|0)|(Sb|0)==(u|0)&Qb>>>0<Va>>>0){c[(_a()|0)>>2]=34;l=+(r|0)*2.2250738585072014e-308*2.2250738585072014e-308;i=g;return+l}if(!Ub)Xb=Vb;else{if((Ub|0)<9){Va=h+(Vb<<2)|0;u=c[Va>>2]|0;Ya=Ub;do{u=u*10|0;Ya=Ya+1|0}while((Ya|0)!=9);c[Va>>2]=u}Xb=Vb+1|0}if((Wb|0)<9?(Wb|0)<=(Qb|0)&(Qb|0)<18:0){if((Qb|0)==9){l=+(r|0)*+((c[h>>2]|0)>>>0);i=g;return+l}if((Qb|0)<9){l=+(r|0)*+((c[h>>2]|0)>>>0)/+(c[329064+(8-Qb<<2)>>2]|0);i=g;return+l}Ya=j+27+(ca(Qb,-3)|0)|0;Xa=c[h>>2]|0;if((Ya|0)>30|(Xa>>>Ya|0)==0){l=+(r|0)*+(Xa>>>0)*+(c[329064+(Qb+-10<<2)>>2]|0);i=g;return+l}}Xa=(Qb|0)%9|0;if(!Xa){Yb=0;Zb=0;_b=Qb;$b=Xb}else{Ya=(Qb|0)>-1?Xa:Xa+9|0;Xa=c[329064+(8-Ya<<2)>>2]|0;if(Xb){Wa=1e9/(Xa|0)|0;Ua=0;Ta=0;Sa=0;Pa=Qb;while(1){Na=h+(Sa<<2)|0;xa=c[Na>>2]|0;Qa=((xa>>>0)/(Xa>>>0)|0)+Ta|0;c[Na>>2]=Qa;Ta=ca((xa>>>0)%(Xa>>>0)|0,Wa)|0;xa=Sa;Sa=Sa+1|0;if((xa|0)==(Ua|0)&(Qa|0)==0){ac=Sa&127;bc=Pa+-9|0}else{ac=Ua;bc=Pa}if((Sa|0)==(Xb|0))break;else{Ua=ac;Pa=bc}}if(!Ta){cc=ac;dc=bc;ec=Xb}else{c[h+(Xb<<2)>>2]=Ta;cc=ac;dc=bc;ec=Xb+1|0}}else{cc=0;dc=Qb;ec=0}Yb=cc;Zb=0;_b=9-Ya+dc|0;$b=ec}e:while(1){Pa=h+(Yb<<2)|0;if((_b|0)<18){Ua=Zb;Sa=$b;while(1){Wa=0;Xa=Sa+127|0;u=Sa;while(1){Va=Xa&127;Qa=h+(Va<<2)|0;xa=$T(c[Qa>>2]|0,0,29)|0;Na=bU(xa|0,G|0,Wa|0,0)|0;xa=G;if(xa>>>0>0|(xa|0)==0&Na>>>0>1e9){Ra=nU(Na|0,xa|0,1e9,0)|0;ta=oU(Na|0,xa|0,1e9,0)|0;fc=ta;gc=Ra}else{fc=Na;gc=0}c[Qa>>2]=fc;Qa=(Va|0)==(Yb|0);if((Va|0)!=(u+127&127|0)|Qa)hc=u;else hc=(fc|0)==0?Va:u;if(Qa)break;else{Wa=gc;Xa=Va+-1|0;u=hc}}u=Ua+-29|0;if(!gc){Ua=u;Sa=hc}else{ic=u;jc=gc;kc=hc;break}}}else{if((_b|0)==18){lc=Zb;mc=$b}else{nc=Yb;oc=Zb;pc=_b;qc=$b;break}while(1){if((c[Pa>>2]|0)>>>0>=9007199){nc=Yb;oc=lc;pc=18;qc=mc;break e}Sa=0;Ua=mc+127|0;n=mc;while(1){q=Ua&127;u=h+(q<<2)|0;Xa=$T(c[u>>2]|0,0,29)|0;Wa=bU(Xa|0,G|0,Sa|0,0)|0;Xa=G;if(Xa>>>0>0|(Xa|0)==0&Wa>>>0>1e9){Va=nU(Wa|0,Xa|0,1e9,0)|0;Qa=oU(Wa|0,Xa|0,1e9,0)|0;rc=Qa;sc=Va}else{rc=Wa;sc=0}c[u>>2]=rc;u=(q|0)==(Yb|0);if((q|0)!=(n+127&127|0)|u)tc=n;else tc=(rc|0)==0?q:n;if(u)break;else{Sa=sc;Ua=q+-1|0;n=tc}}n=lc+-29|0;if(!sc){lc=n;mc=tc}else{ic=n;jc=sc;kc=tc;break}}}Pa=Yb+127&127;if((Pa|0)==(kc|0)){n=kc+127&127;Ua=h+((kc+126&127)<<2)|0;c[Ua>>2]=c[Ua>>2]|c[h+(n<<2)>>2];uc=n}else uc=kc;c[h+(Pa<<2)>>2]=jc;Yb=Pa;Zb=ic;_b=_b+9|0;$b=uc}f:while(1){vc=qc+1&127;Ya=h+((qc+127&127)<<2)|0;Ta=nc;Pa=oc;n=pc;while(1){Ua=(n|0)==18;Sa=(n|0)>27?9:1;wc=Ta;xc=Pa;while(1){q=0;while(1){u=q+wc&127;if((u|0)==(qc|0)){yc=2;break}Wa=c[h+(u<<2)>>2]|0;u=c[329056+(q<<2)>>2]|0;if(Wa>>>0<u>>>0){yc=2;break}Va=q+1|0;if(Wa>>>0>u>>>0){yc=q;break}if((Va|0)<2)q=Va;else{yc=Va;break}}if((yc|0)==2&Ua)break f;zc=Sa+xc|0;if((wc|0)==(qc|0)){wc=qc;xc=zc}else break}Ua=(1<<Sa)+-1|0;q=1e9>>>Sa;Ac=wc;Bc=0;Va=wc;Cc=n;do{u=h+(Va<<2)|0;Wa=c[u>>2]|0;Qa=(Wa>>>Sa)+Bc|0;c[u>>2]=Qa;Bc=ca(Wa&Ua,q)|0;Wa=(Va|0)==(Ac|0)&(Qa|0)==0;Va=Va+1&127;Cc=Wa?Cc+-9|0:Cc;Ac=Wa?Va:Ac}while((Va|0)!=(qc|0));if(!Bc){Ta=Ac;Pa=zc;n=Cc;continue}if((vc|0)!=(Ac|0))break;c[Ya>>2]=c[Ya>>2]|1;Ta=Ac;Pa=zc;n=Cc}c[h+(qc<<2)>>2]=Bc;nc=Ac;oc=zc;pc=Cc;qc=vc}n=wc&127;if((n|0)==(qc|0)){c[h+(vc+-1<<2)>>2]=0;Dc=vc}else Dc=qc;ja=+((c[h+(n<<2)>>2]|0)>>>0);n=wc+1&127;if((n|0)==(Dc|0)){Pa=Dc+1&127;c[h+(Pa+-1<<2)>>2]=0;Ec=Pa}else Ec=Dc;wa=+(r|0);Fc=wa*(ja*1e9+ +((c[h+(n<<2)>>2]|0)>>>0));n=xc+53|0;Pa=n-k|0;if((Pa|0)<(j|0))if((Pa|0)<0){Gc=0;Hc=1;x=244}else{Ic=Pa;Jc=1;x=243}else{Ic=j;Jc=0;x=243}if((x|0)==243)if((Ic|0)<53){Gc=Ic;Hc=Jc;x=244}else{Kc=Ic;Lc=0;Mc=Jc;Nc=0;Oc=Fc}if((x|0)==244){ja=+tT(+AT(1,105-Gc|0),Fc);Pc=+vT(Fc,+AT(1,53-Gc|0));Kc=Gc;Lc=ja;Mc=Hc;Nc=Pc;Oc=ja+(Fc-Pc)}Ta=wc+2&127;do if((Ta|0)==(Ec|0))Qc=Nc;else{Ya=c[h+(Ta<<2)>>2]|0;do if(Ya>>>0>=5e8){if(Ya>>>0>5e8){Rc=wa*.75+Nc;break}if((wc+3&127|0)==(Ec|0)){Rc=wa*.5+Nc;break}else{Rc=wa*.75+Nc;break}}else{if((Ya|0)==0?(wc+3&127|0)==(Ec|0):0){Rc=Nc;break}Rc=wa*.25+Nc;
}while(0);if((53-Kc|0)<=1){Qc=Rc;break}if(+vT(Rc,1)!=0){Qc=Rc;break}Qc=Rc+1}while(0);wa=Oc+Qc-Lc;do if((n&2147483647|0)>(-2-oa|0)){if(!(+R(+wa)>=9007199254740992)){Sc=Mc;Tc=xc;Uc=wa}else{Sc=(Mc|0)!=0&(Kc|0)==(Pa|0)?0:Mc;Tc=xc+1|0;Uc=wa*.5}if((Tc+50|0)<=(sa|0)?!((Sc|0)!=0&Qc!=0):0){Vc=Tc;Wc=Uc;break}c[(_a()|0)>>2]=34;Vc=Tc;Wc=Uc}else{Vc=xc;Wc=wa}while(0);l=+BT(Wc,Vc);i=g;return+l}else{if(c[m>>2]|0)c[e>>2]=(c[e>>2]|0)+-1;c[(_a()|0)>>2]=22;pT(b,0);l=0;i=g;return+l}}while(0);if((x|0)==23){x=(c[m>>2]|0)==0;if(!x)c[e>>2]=(c[e>>2]|0)+-1;if(!(t>>>0<4|(f|0)==0|x)){x=t;do{c[e>>2]=(c[e>>2]|0)+-1;x=x+-1|0}while(x>>>0>3)}}l=+(r|0)*w;i=g;return+l}function pT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a+104>>2]=b;e=c[a+8>>2]|0;f=c[a+4>>2]|0;g=e-f|0;c[a+108>>2]=g;if((b|0)!=0&(g|0)>(b|0)){c[a+100>>2]=f+b;i=d;return}else{c[a+100>>2]=e;i=d;return}}function qT(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=b+104|0;g=c[f>>2]|0;if(!((g|0)!=0?(c[b+108>>2]|0)>=(g|0):0))h=3;if((h|0)==3?(h=HT(b)|0,(h|0)>=0):0){g=c[f>>2]|0;f=c[b+8>>2]|0;if((g|0)!=0?(j=c[b+4>>2]|0,k=g-(c[b+108>>2]|0)+-1|0,(f-j|0)>(k|0)):0)c[b+100>>2]=j+k;else c[b+100>>2]=f;k=c[b+4>>2]|0;if(f){j=b+108|0;c[j>>2]=f+1-k+(c[j>>2]|0)}j=k+-1|0;if((d[j>>0]|0|0)==(h|0)){l=h;i=e;return l|0}a[j>>0]=h;l=h;i=e;return l|0}c[b+100>>2]=0;l=-1;i=e;return l|0}function rT(a){a=+a;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;h[k>>3]=a;d=c[k>>2]|0;e=c[k+4>>2]|0;f=dU(d|0,e|0,52)|0;g=f&2047;if((g|0)==2047){j=(d|0)==0&(e&1048575|0)==0&1;i=b;return j|0}else if(!g){j=(d|0)!=0|(e&2147483647|0)!=0?3:2;i=b;return j|0}else{j=4;i=b;return j|0}return 0}function sT(a,b){a=+a;b=+b;var d=0,e=0,f=0,g=0;d=i;h[k>>3]=a;e=c[k>>2]|0;f=c[k+4>>2]|0;h[k>>3]=b;g=c[k+4>>2]&-2147483648|f&2147483647;c[k>>2]=e;c[k+4>>2]=g;b=+h[k>>3];i=d;return+b}function tT(a,b){a=+a;b=+b;var c=0,d=0;c=i;d=+sT(a,b);i=c;return+d}function uT(a,b){a=+a;b=+b;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=i;h[k>>3]=a;e=c[k>>2]|0;f=c[k+4>>2]|0;h[k>>3]=b;g=c[k>>2]|0;j=c[k+4>>2]|0;l=dU(e|0,f|0,52)|0;m=l&2047;l=dU(g|0,j|0,52)|0;n=l&2047;l=f&-2147483648;o=$T(g|0,j|0,1)|0;p=G;if(!((o|0)==0&(p|0)==0)?(q=j&2147483647,!(q>>>0>2146435072|(q|0)==2146435072&g>>>0>0|(m|0)==2047)):0){q=$T(e|0,f|0,1)|0;r=G;if(!(r>>>0>p>>>0|(r|0)==(p|0)&q>>>0>o>>>0)){if(!((q|0)==(o|0)&(r|0)==(p|0))){s=a;i=d;return+s}s=a*0;i=d;return+s}if(!m){p=$T(e|0,f|0,12)|0;r=G;if((r|0)>-1|(r|0)==-1&p>>>0>4294967295){o=p;p=r;r=0;while(1){q=r+-1|0;o=$T(o|0,p|0,1)|0;p=G;if(!((p|0)>-1|(p|0)==-1&o>>>0>4294967295)){t=q;break}else r=q}}else t=0;r=$T(e|0,f|0,1-t|0)|0;u=r;v=G;w=t}else{u=e;v=f&1048575|1048576;w=m}if(!n){m=$T(g|0,j|0,12)|0;f=G;if((f|0)>-1|(f|0)==-1&m>>>0>4294967295){e=m;m=f;f=0;while(1){t=f+-1|0;e=$T(e|0,m|0,1)|0;m=G;if(!((m|0)>-1|(m|0)==-1&e>>>0>4294967295)){x=t;break}else f=t}}else x=0;f=$T(g|0,j|0,1-x|0)|0;y=f;z=G;A=x}else{y=g;z=j&1048575|1048576;A=n}n=XT(u|0,v|0,y|0,z|0)|0;j=G;g=(j|0)>-1|(j|0)==-1&n>>>0>4294967295;a:do if((w|0)>(A|0)){x=g;f=n;e=j;m=u;t=v;r=w;while(1){if(x)if((m|0)==(y|0)&(t|0)==(z|0))break;else{B=f;C=e}else{B=m;C=t}o=$T(B|0,C|0,1)|0;p=G;q=r+-1|0;D=XT(o|0,p|0,y|0,z|0)|0;E=G;F=(E|0)>-1|(E|0)==-1&D>>>0>4294967295;if((q|0)>(A|0)){x=F;f=D;e=E;m=o;t=p;r=q}else{H=F;I=o;J=p;K=D;L=E;M=q;break a}}s=a*0;i=d;return+s}else{H=g;I=u;J=v;K=n;L=j;M=w}while(0);if(H)if((I|0)==(y|0)&(J|0)==(z|0)){s=a*0;i=d;return+s}else{N=L;O=K}else{N=J;O=I}if(N>>>0<1048576|(N|0)==1048576&O>>>0<0){I=O;J=N;K=M;while(1){L=$T(I|0,J|0,1)|0;z=G;y=K+-1|0;if(z>>>0<1048576|(z|0)==1048576&L>>>0<0){I=L;J=z;K=y}else{P=L;Q=z;R=y;break}}}else{P=O;Q=N;R=M}if((R|0)>0){M=bU(P|0,Q|0,0,-1048576)|0;N=G;O=$T(R|0,0,52)|0;S=N|G;T=M|O}else{O=dU(P|0,Q|0,1-R|0)|0;S=G;T=O}c[k>>2]=T;c[k+4>>2]=S|l;s=+h[k>>3];i=d;return+s}U=a*b;s=U/U;i=d;return+s}function vT(a,b){a=+a;b=+b;var c=0,d=0;c=i;d=+uT(a,b);i=c;return+d}function wT(a,b){a=+a;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0;d=i;h[k>>3]=a;e=c[k>>2]|0;f=c[k+4>>2]|0;g=dU(e|0,f|0,52)|0;j=g&2047;if(!j){if(a!=0){l=+wT(a*0x10000000000000000,b);m=l;n=(c[b>>2]|0)+-64|0}else{m=a;n=0}c[b>>2]=n;o=m;i=d;return+o}else if((j|0)==2047){o=a;i=d;return+o}else{c[b>>2]=j+-1022;c[k>>2]=e;c[k+4>>2]=f&-2146435073|1071644672;o=+h[k>>3];i=d;return+o}return+0}function xT(a,b){a=+a;b=b|0;var c=0,d=0;c=i;d=+wT(a,b);i=c;return+d}function yT(a){a=+a;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;b=i;h[k>>3]=a;d=c[k>>2]|0;e=c[k+4>>2]|0;f=(e|0)<0;do if(!(e>>>0<1048576|f)){if(e>>>0>2146435071){g=a;i=b;return+g}if((e|0)==1072693248&((d|0)==0&0==0)){g=0;i=b;return+g}else{j=d;l=e;m=e;n=-1023}}else{if((d|0)==0&(e&2147483647|0)==0){g=-1/(a*a);i=b;return+g}if(!f){h[k>>3]=a*0x40000000000000;o=c[k+4>>2]|0;j=c[k>>2]|0;l=o;m=o;n=-1077;break}g=(a-a)/0;i=b;return+g}while(0);l=m+614242|0;c[k>>2]=j;c[k+4>>2]=(l&1048575)+1072079006;a=+h[k>>3]+-1;p=a*(a*.5);q=a/(a+2);r=q*q;s=r*r;h[k>>3]=a-p;j=c[k+4>>2]|0;c[k>>2]=0;c[k+4>>2]=j;t=+h[k>>3];u=q*(p+(s*(s*(s*.15313837699209373+.22222198432149784)+.3999999999940942)+r*(s*(s*(s*.14798198605116586+.1818357216161805)+.2857142874366239)+.6666666666666735)))+(a-t-p);p=t*.4342944818781689;a=+(n+(l>>>20)|0);s=a*.30102999566361177;r=s+p;g=r+(p+(s-r)+(u*.4342944818781689+(a*3.694239077158931e-13+(t+u)*2.5082946711645275e-11)));i=b;return+g}function zT(a){a=a|0;return+v}function AT(a,b){a=+a;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0;d=i;if((b|0)>1023){e=a*8.98846567431158e307;f=b+-1023|0;if((f|0)>1023){g=b+-2046|0;j=(g|0)>1023?1023:g;l=e*8.98846567431158e307}else{j=f;l=e}}else if((b|0)<-1022){e=a*2.2250738585072014e-308;f=b+1022|0;if((f|0)<-1022){g=b+2044|0;j=(g|0)<-1022?-1022:g;l=e*2.2250738585072014e-308}else{j=f;l=e}}else{j=b;l=a}b=$T(j+1023|0,0,52)|0;j=G;c[k>>2]=b;c[k+4>>2]=j;a=l*+h[k>>3];i=d;return+a}function BT(a,b){a=+a;b=b|0;var c=0,d=0;c=i;d=+AT(a,b);i=c;return+d}function CT(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if(!a)d=0;else d=DT(a,b,0)|0;i=c;return d|0}function DT(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if(!b){f=1;i=e;return f|0}if(d>>>0<128){a[b>>0]=d;f=1;i=e;return f|0}if(d>>>0<2048){a[b>>0]=d>>>6|192;a[b+1>>0]=d&63|128;f=2;i=e;return f|0}if(d>>>0<55296|(d&-8192|0)==57344){a[b>>0]=d>>>12|224;a[b+1>>0]=d>>>6&63|128;a[b+2>>0]=d&63|128;f=3;i=e;return f|0}if((d+-65536|0)>>>0<1048576){a[b>>0]=d>>>18|240;a[b+1>>0]=d>>>12&63|128;a[b+2>>0]=d>>>6&63|128;a[b+3>>0]=d&63|128;f=4;i=e;return f|0}else{c[(_a()|0)>>2]=84;f=-1;i=e;return f|0}return 0}function ET(a){a=a|0;var b=0;b=(ca(c[a>>2]|0,1103515245)|0)+12345|0;c[a>>2]=b;a=b>>>11^b;b=a<<7&-1658038656^a;a=b<<15&-272236544^b;return(a>>>18^a)>>>1|0}function FT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=b+74|0;f=a[e>>0]|0;a[e>>0]=f+255|f;f=b+20|0;e=b+44|0;if((c[f>>2]|0)>>>0>(c[e>>2]|0)>>>0)vb[c[b+36>>2]&511](b,0,0)|0;c[b+16>>2]=0;c[b+28>>2]=0;c[f>>2]=0;f=c[b>>2]|0;if(!(f&20)){g=c[e>>2]|0;c[b+8>>2]=g;c[b+4>>2]=g;h=0;i=d;return h|0}if(!(f&4)){h=-1;i=d;return h|0}c[b>>2]=f|32;h=-1;i=d;return h|0}function GT(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+74|0;f=a[e>>0]|0;a[e>>0]=f+255|f;f=c[b>>2]|0;if(!(f&8)){c[b+8>>2]=0;c[b+4>>2]=0;e=c[b+44>>2]|0;c[b+28>>2]=e;c[b+20>>2]=e;c[b+16>>2]=e+(c[b+48>>2]|0);g=0;i=d;return g|0}else{c[b>>2]=f|32;g=-1;i=d;return g|0}return 0}function HT(a){a=a|0;var b=0,e=0,f=0;b=i;i=i+16|0;e=b;if((c[a+8>>2]|0)==0?(FT(a)|0)!=0:0)f=-1;else if((vb[c[a+32>>2]&511](a,e,1)|0)==1)f=d[e>>0]|0;else f=-1;i=b;return f|0}function IT(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;g=e+16|0;h=c[g>>2]|0;do if(!h)if(!(GT(e)|0)){j=c[g>>2]|0;break}else{k=0;i=f;return k|0}else j=h;while(0);h=e+20|0;g=c[h>>2]|0;if((j-g|0)>>>0<d>>>0){k=vb[c[e+36>>2]&511](e,b,d)|0;i=f;return k|0}a:do if((a[e+75>>0]|0)>-1){j=d;while(1){if(!j){l=d;m=b;n=g;o=0;break a}p=j+-1|0;if((a[b+p>>0]|0)==10)break;else j=p}if((vb[c[e+36>>2]&511](e,b,j)|0)>>>0<j>>>0){k=j;i=f;return k|0}else{l=d-j|0;m=b+j|0;n=c[h>>2]|0;o=j;break}}else{l=d;m=b;n=g;o=0}while(0);eU(n|0,m|0,l|0)|0;c[h>>2]=(c[h>>2]|0)+l;k=o+l|0;i=f;return k|0}function JT(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=LT(a,b,d,g)|0;i=f;return e|0}function KT(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+224|0;f=e+120|0;g=e+80|0;h=e;j=e+136|0;k=g+0|0;l=k+40|0;do{c[k>>2]=0;k=k+4|0}while((k|0)<(l|0));c[f>>2]=c[d>>2];if((VT(0,b,f,h,g)|0)<0){m=-1;i=e;return m|0}d=a+48|0;if(!(c[d>>2]|0)){k=a+44|0;l=c[k>>2]|0;c[k>>2]=j;n=a+28|0;c[n>>2]=j;o=a+20|0;c[o>>2]=j;c[d>>2]=80;p=a+16|0;c[p>>2]=j+80;j=VT(a,b,f,h,g)|0;if(!l)q=j;else{vb[c[a+36>>2]&511](a,0,0)|0;r=(c[o>>2]|0)==0?-1:j;c[k>>2]=l;c[d>>2]=0;c[p>>2]=0;c[n>>2]=0;c[o>>2]=0;q=r}}else q=VT(a,b,f,h,g)|0;m=q;i=e;return m|0}function LT(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+128|0;h=g+112|0;j=g;k=j+0|0;l=329664|0;m=k+112|0;do{c[k>>2]=c[l>>2];k=k+4|0;l=l+4|0}while((k|0)<(m|0));if((d+-1|0)>>>0>2147483646)if(!d){n=h;o=1}else{c[(_a()|0)>>2]=75;p=-1;i=g;return p|0}else{n=b;o=d}d=-2-n|0;b=o>>>0>d>>>0?d:o;c[j+48>>2]=b;o=j+20|0;c[o>>2]=n;c[j+44>>2]=n;d=n+b|0;n=j+16|0;c[n>>2]=d;c[j+28>>2]=d;d=KT(j,e,f)|0;if(!b){p=d;i=g;return p|0}b=c[o>>2]|0;a[b+(((b|0)==(c[n>>2]|0))<<31>>31)>>0]=0;p=d;i=g;return p|0}function MT(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=i;d=b;while(1){e=d+1|0;if(!(mT(a[d>>0]|0)|0))break;else d=e}b=a[d>>0]|0;f=b<<24>>24;if((f|0)==43){g=0;h=5}else if((f|0)==45){g=1;h=5}else{j=d;k=b;l=0}if((h|0)==5){j=e;k=a[e>>0]|0;l=g}if(!(lT(k<<24>>24)|0)){m=0;n=(l|0)!=0;o=0-m|0;p=n?m:o;i=c;return p|0}else{q=j;r=0}while(1){j=(r*10|0)+48-(a[q>>0]|0)|0;q=q+1|0;if(!(lT(a[q>>0]|0)|0)){m=j;break}else r=j}n=(l|0)!=0;o=0-m|0;p=n?m:o;i=c;return p|0}function NT(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=d&255;h=(e|0)!=0;a:do if((b&3|0)!=0&h){j=d&255;k=e;l=b;while(1){if((a[l>>0]|0)==j<<24>>24){m=k;n=l;o=6;break a}p=l+1|0;q=k+-1|0;r=(q|0)!=0;if((p&3|0)!=0&r){k=q;l=p}else{s=q;t=r;u=p;o=5;break}}}else{s=e;t=h;u=b;o=5}while(0);if((o|0)==5)if(t){m=s;n=u;o=6}else{v=0;w=u}b:do if((o|0)==6){u=d&255;if((a[n>>0]|0)!=u<<24>>24){s=ca(g,16843009)|0;c:do if(m>>>0>3){t=m;b=n;while(1){h=c[b>>2]^s;if((h&-2139062144^-2139062144)&h+-16843009){x=t;y=b;break c}h=b+4|0;e=t+-4|0;if(e>>>0>3){t=e;b=h}else{x=e;y=h;break}}}else{x=m;y=n}while(0);if(!x){v=0;w=y}else{s=x;b=y;while(1){if((a[b>>0]|0)==u<<24>>24){v=s;w=b;break b}t=b+1|0;s=s+-1|0;if(!s){v=0;w=t;break}else b=t}}}else{v=m;w=n}}while(0);i=f;return((v|0)!=0?w:0)|0}function OT(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;a:do if(!d)f=0;else{g=d;h=b;j=c;while(1){k=a[h>>0]|0;l=a[j>>0]|0;if(k<<24>>24!=l<<24>>24)break;g=g+-1|0;if(!g){f=0;break a}else{h=h+1|0;j=j+1|0}}f=(k&255)-(l&255)|0}while(0);i=e;return f|0}function PT(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=a[b>>0]|0;f=a[c>>0]|0;if(e<<24>>24==0?1:e<<24>>24!=f<<24>>24){g=e;h=f}else{f=b;b=c;do{f=f+1|0;b=b+1|0;c=a[f>>0]|0;e=a[b>>0]|0}while(!(c<<24>>24==0?1:c<<24>>24!=e<<24>>24));g=c;h=e}i=d;return(g&255)-(h&255)|0}function QT(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;if(!e){g=0;i=f;return g|0}h=a[b>>0]|0;a:do if(!(h<<24>>24)){j=0;k=c}else{l=e;m=h;n=b;o=c;while(1){l=l+-1|0;p=a[o>>0]|0;if(!(p<<24>>24!=0&(l|0)!=0&m<<24>>24==p<<24>>24)){j=m;k=o;break a}n=n+1|0;p=o+1|0;m=a[n>>0]|0;if(!(m<<24>>24)){j=0;k=p;break}else o=p}}while(0);g=(j&255)-(d[k>>0]|0)|0;i=f;return g|0}function RT(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a+20|0;g=c[f>>2]|0;h=(c[a+16>>2]|0)-g|0;a=h>>>0>d>>>0?d:h;eU(g|0,b|0,a|0)|0;c[f>>2]=(c[f>>2]|0)+a;i=e;return d|0}function ST(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=a+4|0;f=c[e>>2]|0;g=f&-8;h=a+g|0;j=c[82068]|0;k=f&3;if(!((k|0)!=1&a>>>0>=j>>>0&a>>>0<h>>>0))hb();l=a+(g|4)|0;m=c[l>>2]|0;if(!(m&1))hb();if(!k){if(b>>>0<256){n=0;i=d;return n|0}if(g>>>0>=(b+4|0)>>>0?(g-b|0)>>>0<=c[82184]<<1>>>0:0){n=a;i=d;return n|0}n=0;i=d;return n|0}if(g>>>0>=b>>>0){k=g-b|0;if(k>>>0<=15){n=a;i=d;return n|0}c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=k|3;c[l>>2]=c[l>>2]|1;TT(a+b|0,k);n=a;i=d;return n|0}if((h|0)==(c[82070]|0)){k=(c[82067]|0)+g|0;if(k>>>0<=b>>>0){n=0;i=d;return n|0}l=k-b|0;c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=l|1;c[82070]=a+b;c[82067]=l;n=a;i=d;return n|0}if((h|0)==(c[82069]|0)){l=(c[82066]|0)+g|0;if(l>>>0<b>>>0){n=0;i=d;return n|0}k=l-b|0;if(k>>>0>15){c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=k|1;c[a+l>>2]=k;o=a+(l+4)|0;c[o>>2]=c[o>>2]&-2;p=a+b|0;q=k}else{c[e>>2]=f&1|l|2;k=a+(l+4)|0;c[k>>2]=c[k>>2]|1;p=0;q=0}c[82066]=q;c[82069]=p;n=a;i=d;return n|0}if(m&2){n=0;i=d;return n|0}p=(m&-8)+g|0;if(p>>>0<b>>>0){n=0;i=d;return n|0}q=p-b|0;k=m>>>3;do if(m>>>0>=256){l=c[a+(g+24)>>2]|0;o=c[a+(g+12)>>2]|0;do if((o|0)==(h|0)){r=a+(g+20)|0;s=c[r>>2]|0;if(!s){t=a+(g+16)|0;u=c[t>>2]|0;if(!u){v=0;break}else{w=u;x=t}}else{w=s;x=r}while(1){r=w+20|0;s=c[r>>2]|0;if(s){w=s;x=r;continue}r=w+16|0;s=c[r>>2]|0;if(!s)break;else{w=s;x=r}}if(x>>>0<j>>>0)hb();else{c[x>>2]=0;v=w;break}}else{r=c[a+(g+8)>>2]|0;if(r>>>0<j>>>0)hb();s=r+12|0;if((c[s>>2]|0)!=(h|0))hb();t=o+8|0;if((c[t>>2]|0)==(h|0)){c[s>>2]=o;c[t>>2]=r;v=o;break}else hb()}while(0);if(l){o=c[a+(g+28)>>2]|0;r=328560+(o<<2)|0;if((h|0)==(c[r>>2]|0)){c[r>>2]=v;if(!v){c[82065]=c[82065]&~(1<<o);break}}else{if(l>>>0<(c[82068]|0)>>>0)hb();o=l+16|0;if((c[o>>2]|0)==(h|0))c[o>>2]=v;else c[l+20>>2]=v;if(!v)break}o=c[82068]|0;if(v>>>0<o>>>0)hb();c[v+24>>2]=l;r=c[a+(g+16)>>2]|0;do if(r)if(r>>>0<o>>>0)hb();else{c[v+16>>2]=r;c[r+24>>2]=v;break}while(0);r=c[a+(g+20)>>2]|0;if(r)if(r>>>0<(c[82068]|0)>>>0)hb();else{c[v+20>>2]=r;c[r+24>>2]=v;break}}}else{r=c[a+(g+8)>>2]|0;o=c[a+(g+12)>>2]|0;l=328296+(k<<1<<2)|0;if((r|0)!=(l|0)){if(r>>>0<j>>>0)hb();if((c[r+12>>2]|0)!=(h|0))hb()}if((o|0)==(r|0)){c[82064]=c[82064]&~(1<<k);break}if((o|0)!=(l|0)){if(o>>>0<j>>>0)hb();l=o+8|0;if((c[l>>2]|0)==(h|0))y=l;else hb()}else y=o+8|0;c[r+12>>2]=o;c[y>>2]=r}while(0);if(q>>>0<16){c[e>>2]=p|f&1|2;y=a+(p|4)|0;c[y>>2]=c[y>>2]|1;n=a;i=d;return n|0}else{c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=q|3;f=a+(p|4)|0;c[f>>2]=c[f>>2]|1;TT(a+b|0,q);n=a;i=d;return n|0}return 0}function TT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=i;e=a+b|0;f=c[a+4>>2]|0;do if(!(f&1)){g=c[a>>2]|0;if(!(f&3)){i=d;return}h=a+(0-g)|0;j=g+b|0;k=c[82068]|0;if(h>>>0<k>>>0)hb();if((h|0)==(c[82069]|0)){l=a+(b+4)|0;m=c[l>>2]|0;if((m&3|0)!=3){n=h;o=j;break}c[82066]=j;c[l>>2]=m&-2;c[a+(4-g)>>2]=j|1;c[e>>2]=j;i=d;return}m=g>>>3;if(g>>>0<256){l=c[a+(8-g)>>2]|0;p=c[a+(12-g)>>2]|0;q=328296+(m<<1<<2)|0;if((l|0)!=(q|0)){if(l>>>0<k>>>0)hb();if((c[l+12>>2]|0)!=(h|0))hb()}if((p|0)==(l|0)){c[82064]=c[82064]&~(1<<m);n=h;o=j;break}if((p|0)!=(q|0)){if(p>>>0<k>>>0)hb();q=p+8|0;if((c[q>>2]|0)==(h|0))r=q;else hb()}else r=p+8|0;c[l+12>>2]=p;c[r>>2]=l;n=h;o=j;break}l=c[a+(24-g)>>2]|0;p=c[a+(12-g)>>2]|0;do if((p|0)==(h|0)){q=16-g|0;m=a+(q+4)|0;s=c[m>>2]|0;if(!s){t=a+q|0;q=c[t>>2]|0;if(!q){u=0;break}else{v=q;w=t}}else{v=s;w=m}while(1){m=v+20|0;s=c[m>>2]|0;if(s){v=s;w=m;continue}m=v+16|0;s=c[m>>2]|0;if(!s)break;else{v=s;w=m}}if(w>>>0<k>>>0)hb();else{c[w>>2]=0;u=v;break}}else{m=c[a+(8-g)>>2]|0;if(m>>>0<k>>>0)hb();s=m+12|0;if((c[s>>2]|0)!=(h|0))hb();t=p+8|0;if((c[t>>2]|0)==(h|0)){c[s>>2]=p;c[t>>2]=m;u=p;break}else hb()}while(0);if(l){p=c[a+(28-g)>>2]|0;k=328560+(p<<2)|0;if((h|0)==(c[k>>2]|0)){c[k>>2]=u;if(!u){c[82065]=c[82065]&~(1<<p);n=h;o=j;break}}else{if(l>>>0<(c[82068]|0)>>>0)hb();p=l+16|0;if((c[p>>2]|0)==(h|0))c[p>>2]=u;else c[l+20>>2]=u;if(!u){n=h;o=j;break}}p=c[82068]|0;if(u>>>0<p>>>0)hb();c[u+24>>2]=l;k=16-g|0;m=c[a+k>>2]|0;do if(m)if(m>>>0<p>>>0)hb();else{c[u+16>>2]=m;c[m+24>>2]=u;break}while(0);m=c[a+(k+4)>>2]|0;if(m)if(m>>>0<(c[82068]|0)>>>0)hb();else{c[u+20>>2]=m;c[m+24>>2]=u;n=h;o=j;break}else{n=h;o=j}}else{n=h;o=j}}else{n=a;o=b}while(0);u=c[82068]|0;if(e>>>0<u>>>0)hb();v=a+(b+4)|0;w=c[v>>2]|0;if(!(w&2)){if((e|0)==(c[82070]|0)){r=(c[82067]|0)+o|0;c[82067]=r;c[82070]=n;c[n+4>>2]=r|1;if((n|0)!=(c[82069]|0)){i=d;return}c[82069]=0;c[82066]=0;i=d;return}if((e|0)==(c[82069]|0)){r=(c[82066]|0)+o|0;c[82066]=r;c[82069]=n;c[n+4>>2]=r|1;c[n+r>>2]=r;i=d;return}r=(w&-8)+o|0;f=w>>>3;do if(w>>>0>=256){m=c[a+(b+24)>>2]|0;p=c[a+(b+12)>>2]|0;do if((p|0)==(e|0)){g=a+(b+20)|0;l=c[g>>2]|0;if(!l){t=a+(b+16)|0;s=c[t>>2]|0;if(!s){x=0;break}else{y=s;z=t}}else{y=l;z=g}while(1){g=y+20|0;l=c[g>>2]|0;if(l){y=l;z=g;continue}g=y+16|0;l=c[g>>2]|0;if(!l)break;else{y=l;z=g}}if(z>>>0<u>>>0)hb();else{c[z>>2]=0;x=y;break}}else{g=c[a+(b+8)>>2]|0;if(g>>>0<u>>>0)hb();l=g+12|0;if((c[l>>2]|0)!=(e|0))hb();t=p+8|0;if((c[t>>2]|0)==(e|0)){c[l>>2]=p;c[t>>2]=g;x=p;break}else hb()}while(0);if(m){p=c[a+(b+28)>>2]|0;j=328560+(p<<2)|0;if((e|0)==(c[j>>2]|0)){c[j>>2]=x;if(!x){c[82065]=c[82065]&~(1<<p);break}}else{if(m>>>0<(c[82068]|0)>>>0)hb();p=m+16|0;if((c[p>>2]|0)==(e|0))c[p>>2]=x;else c[m+20>>2]=x;if(!x)break}p=c[82068]|0;if(x>>>0<p>>>0)hb();c[x+24>>2]=m;j=c[a+(b+16)>>2]|0;do if(j)if(j>>>0<p>>>0)hb();else{c[x+16>>2]=j;c[j+24>>2]=x;break}while(0);j=c[a+(b+20)>>2]|0;if(j)if(j>>>0<(c[82068]|0)>>>0)hb();else{c[x+20>>2]=j;c[j+24>>2]=x;break}}}else{j=c[a+(b+8)>>2]|0;p=c[a+(b+12)>>2]|0;m=328296+(f<<1<<2)|0;if((j|0)!=(m|0)){if(j>>>0<u>>>0)hb();if((c[j+12>>2]|0)!=(e|0))hb()}if((p|0)==(j|0)){c[82064]=c[82064]&~(1<<f);break}if((p|0)!=(m|0)){if(p>>>0<u>>>0)hb();m=p+8|0;if((c[m>>2]|0)==(e|0))A=m;else hb()}else A=p+8|0;c[j+12>>2]=p;c[A>>2]=j}while(0);c[n+4>>2]=r|1;c[n+r>>2]=r;if((n|0)==(c[82069]|0)){c[82066]=r;i=d;return}else B=r}else{c[v>>2]=w&-2;c[n+4>>2]=o|1;c[n+o>>2]=o;B=o}o=B>>>3;if(B>>>0<256){w=o<<1;v=328296+(w<<2)|0;r=c[82064]|0;A=1<<o;if(r&A){o=328296+(w+2<<2)|0;e=c[o>>2]|0;if(e>>>0<(c[82068]|0)>>>0)hb();else{C=o;D=e}}else{c[82064]=r|A;C=328296+(w+2<<2)|0;D=v}c[C>>2]=n;c[D+12>>2]=n;c[n+8>>2]=D;c[n+12>>2]=v;i=d;return}v=B>>>8;if(v)if(B>>>0>16777215)E=31;else{D=(v+1048320|0)>>>16&8;C=v<<D;v=(C+520192|0)>>>16&4;w=C<<v;C=(w+245760|0)>>>16&2;A=14-(v|D|C)+(w<<C>>>15)|0;E=B>>>(A+7|0)&1|A<<1}else E=0;A=328560+(E<<2)|0;c[n+28>>2]=E;c[n+20>>2]=0;c[n+16>>2]=0;C=c[82065]|0;w=1<<E;if(!(C&w)){c[82065]=C|w;c[A>>2]=n;c[n+24>>2]=A;c[n+12>>2]=n;c[n+8>>2]=n;i=d;return}w=c[A>>2]|0;if((E|0)==31)F=0;else F=25-(E>>>1)|0;a:do if((c[w+4>>2]&-8|0)==(B|0))G=w;else{E=B<<F;A=w;while(1){H=A+(E>>>31<<2)+16|0;C=c[H>>2]|0;if(!C)break;if((c[C+4>>2]&-8|0)==(B|0)){G=C;break a}else{E=E<<1;A=C}}if(H>>>0<(c[82068]|0)>>>0)hb();c[H>>2]=n;c[n+24>>2]=A;c[n+12>>2]=n;c[n+8>>2]=n;i=d;return}while(0);H=G+8|0;B=c[H>>2]|0;w=c[82068]|0;if(!(G>>>0>=w>>>0&B>>>0>=w>>>0))hb();c[B+12>>2]=n;c[H>>2]=n;c[n+8>>2]=B;c[n+12>>2]=G;c[n+24>>2]=0;i=d;return}function UT(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=a+4|0;g=c[f>>2]|0;h=a+100|0;if(g>>>0<(c[h>>2]|0)>>>0){c[f>>2]=g+1;j=d[g>>0]|0}else j=qT(a)|0;if((j|0)==43|(j|0)==45){g=c[f>>2]|0;k=(j|0)==45&1;if(g>>>0<(c[h>>2]|0)>>>0){c[f>>2]=g+1;l=d[g>>0]|0}else l=qT(a)|0;if((l+-48|0)>>>0>9&(b|0)!=0?(c[h>>2]|0)!=0:0){c[f>>2]=(c[f>>2]|0)+-1;m=l;n=k}else{m=l;n=k}}else{m=j;n=0}if((m+-48|0)>>>0>9){if(!(c[h>>2]|0)){o=-2147483648;p=0;G=o;i=e;return p|0}c[f>>2]=(c[f>>2]|0)+-1;o=-2147483648;p=0;G=o;i=e;return p|0}else{q=m;r=0}while(1){r=q+-48+(r*10|0)|0;m=c[f>>2]|0;if(m>>>0<(c[h>>2]|0)>>>0){c[f>>2]=m+1;s=d[m>>0]|0}else s=qT(a)|0;if(!((s+-48|0)>>>0<10&(r|0)<214748364))break;else q=s}q=((r|0)<0)<<31>>31;if((s+-48|0)>>>0<10){m=r;j=q;k=s;while(1){l=mU(m|0,j|0,10,0)|0;b=G;g=bU(k|0,((k|0)<0)<<31>>31|0,-48,-1)|0;t=bU(g|0,G|0,l|0,b|0)|0;b=G;l=c[f>>2]|0;if(l>>>0<(c[h>>2]|0)>>>0){c[f>>2]=l+1;u=d[l>>0]|0}else u=qT(a)|0;if((u+-48|0)>>>0<10&((b|0)<21474836|(b|0)==21474836&t>>>0<2061584302)){m=t;j=b;k=u}else{v=t;w=b;x=u;break}}}else{v=r;w=q;x=s}if((x+-48|0)>>>0<10)do{x=c[f>>2]|0;if(x>>>0<(c[h>>2]|0)>>>0){c[f>>2]=x+1;y=d[x>>0]|0}else y=qT(a)|0}while((y+-48|0)>>>0<10);if(c[h>>2]|0)c[f>>2]=(c[f>>2]|0)+-1;f=(n|0)!=0;n=XT(0,0,v|0,w|0)|0;o=f?G:w;p=f?n:v;G=o;i=e;return p|0}function VT(e,f,g,j,l){e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0;m=i;i=i+864|0;n=m+16|0;o=m+8|0;p=m+836|0;q=p;r=m+824|0;s=m+568|0;t=m+528|0;u=m;v=m+520|0;w=(e|0)!=0;x=t+40|0;y=x;z=t+39|0;t=u+4|0;A=u;B=r+12|0;C=r+11|0;r=B;D=r-q|0;E=-2-q|0;F=r+2|0;H=n+288|0;I=p+9|0;J=I;K=p+8|0;L=0;M=0;N=f;f=0;O=0;P=0;a:while(1){do if((f|0)>-1)if((O|0)>(2147483647-f|0)){c[(_a()|0)>>2]=75;Q=-1;break}else{Q=O+f|0;break}else Q=f;while(0);R=a[N>>0]|0;if(!(R<<24>>24)){S=352;break}else{T=R;U=N}while(1){if(T<<24>>24==37){V=U;W=U;S=9;break}else if(!(T<<24>>24)){X=U;Y=U;break}R=U+1|0;T=a[R>>0]|0;U=R}b:do if((S|0)==9)while(1){S=0;if((a[V+1>>0]|0)!=37){X=V;Y=W;break b}R=W+1|0;Z=V+2|0;if((a[Z>>0]|0)==37){V=Z;W=R;S=9}else{X=Z;Y=R;break}}while(0);R=Y-N|0;if(w)IT(N,R,e)|0;if((Y|0)!=(N|0)){N=X;f=Q;O=R;continue}Z=X+1|0;_=a[Z>>0]|0;$=(_<<24>>24)+-48|0;if($>>>0<10?(a[X+2>>0]|0)==36:0){aa=X+3|0;ba=a[aa>>0]|0;da=$;ea=1;fa=aa}else{ba=_;da=-1;ea=P;fa=Z}Z=ba<<24>>24;c:do if((Z&-32|0)==32){_=ba;aa=Z;$=0;ga=fa;while(1){ha=1<<aa+-32;if(!(ha&75913)){ia=_;ja=$;ka=ga;break c}la=ha|$;ha=ga+1|0;ma=a[ha>>0]|0;aa=ma<<24>>24;if((aa&-32|0)!=32){ia=ma;ja=la;ka=ha;break}else{_=ma;$=la;ga=ha}}}else{ia=ba;ja=0;ka=fa}while(0);do if(ia<<24>>24==42){Z=ka+1|0;ga=(a[Z>>0]|0)+-48|0;if(ga>>>0<10?(a[ka+2>>0]|0)==36:0){c[l+(ga<<2)>>2]=10;na=1;oa=ka+3|0;pa=c[j+((a[Z>>0]|0)+-48<<3)>>2]|0}else{if(ea){qa=-1;S=370;break a}if(!w){ra=Z;sa=ja;ta=0;ua=0;break}ga=c[g>>2]|0;$=c[ga>>2]|0;c[g>>2]=ga+4;na=0;oa=Z;pa=$}if((pa|0)<0){ra=oa;sa=ja|8192;ta=na;ua=0-pa|0}else{ra=oa;sa=ja;ta=na;ua=pa}}else{$=ia<<24>>24;if(($+-48|0)>>>0<10){Z=$;$=ka;ga=0;do{ga=Z+-48+(ga*10|0)|0;$=$+1|0;Z=a[$>>0]|0}while((Z+-48|0)>>>0<10);if((ga|0)<0){qa=-1;S=370;break a}else{ra=$;sa=ja;ta=ea;ua=ga}}else{ra=ka;sa=ja;ta=ea;ua=0}}while(0);d:do if((a[ra>>0]|0)==46){Z=ra+1|0;_=a[Z>>0]|0;if(_<<24>>24!=42){aa=_<<24>>24;if((aa+-48|0)>>>0<10){va=aa;wa=Z;xa=0}else{ya=Z;za=0;break}while(1){Z=va+-48+(xa*10|0)|0;aa=wa+1|0;va=a[aa>>0]|0;if((va+-48|0)>>>0>=10){ya=aa;za=Z;break d}else{wa=aa;xa=Z}}}ga=ra+2|0;$=(a[ga>>0]|0)+-48|0;if($>>>0<10?(a[ra+3>>0]|0)==36:0){c[l+($<<2)>>2]=10;ya=ra+4|0;za=c[j+((a[ga>>0]|0)+-48<<3)>>2]|0;break}if(ta){qa=-1;S=370;break a}if(w){$=c[g>>2]|0;Z=c[$>>2]|0;c[g>>2]=$+4;ya=ga;za=Z}else{ya=ga;za=0}}else{ya=ra;za=-1}while(0);ga=ya;Z=0;while(1){Aa=a[ga>>0]|0;$=(Aa<<24>>24)+-65|0;if($>>>0>57){qa=-1;S=370;break a}Ba=ga+1|0;Ca=a[329096+(Z*58|0)+$>>0]|0;Da=Ca&255;if((Da+-1|0)>>>0<8){ga=Ba;Z=Da}else break}if(!(Ca<<24>>24)){qa=-1;S=370;break}$=(da|0)>-1;e:do if(Ca<<24>>24==19)if($){qa=-1;S=370;break a}else{Ea=L;Fa=M;S=63}else{if($){c[l+(da<<2)>>2]=Da;aa=j+(da<<3)|0;Ea=c[aa>>2]|0;Fa=c[aa+4>>2]|0;S=63;break}if(!w){qa=0;S=370;break a}if((Ca&255)>20){Ga=Aa;Ha=L;Ia=M}else do switch(Da|0){case 16:{aa=c[g>>2]|0;_=c[aa>>2]|0;c[g>>2]=aa+4;Ja=0;Ka=_&255;S=64;break e;break}case 11:{_=c[g>>2]|0;aa=c[_>>2]|0;c[g>>2]=_+4;Ja=0;Ka=aa;S=64;break e;break}case 12:{aa=c[g>>2]|0;_=aa;ha=c[_>>2]|0;la=c[_+4>>2]|0;c[g>>2]=aa+8;Ja=la;Ka=ha;S=64;break e;break}case 14:{ha=c[g>>2]|0;la=c[ha>>2]|0;c[g>>2]=ha+4;Ja=0;Ka=la&65535;S=64;break e;break}case 13:{la=c[g>>2]|0;ha=c[la>>2]|0;c[g>>2]=la+4;Ja=(((ha&65535)<<16>>16|0)<0)<<31>>31;Ka=ha<<16>>16;S=64;break e;break}case 17:{ha=c[g>>2]|0;c[k>>2]=c[ha>>2];c[k+4>>2]=c[ha+4>>2];La=+h[k>>3];c[g>>2]=ha+8;h[k>>3]=La;Ja=c[k+4>>2]|0;Ka=c[k>>2]|0;S=64;break e;break}case 10:{ha=c[g>>2]|0;la=c[ha>>2]|0;c[g>>2]=ha+4;Ja=((la|0)<0)<<31>>31;Ka=la;S=64;break e;break}case 15:{la=c[g>>2]|0;ha=c[la>>2]|0;c[g>>2]=la+4;Ja=(((ha&255)<<24>>24|0)<0)<<31>>31;Ka=ha<<24>>24;S=64;break e;break}case 18:{ha=c[g>>2]|0;c[k>>2]=c[ha>>2];c[k+4>>2]=c[ha+4>>2];La=+h[k>>3];c[g>>2]=ha+8;h[k>>3]=La;Ea=c[k>>2]|0;Fa=c[k+4>>2]|0;S=63;break e;break}case 9:{ha=c[g>>2]|0;la=c[ha>>2]|0;c[g>>2]=ha+4;Ja=M;Ka=la;S=64;break e;break}default:{Ja=M;Ka=L;S=64;break e}}while(0)}while(0);if((S|0)==63){S=0;if(w){Ja=Fa;Ka=Ea;S=64}else{L=Ea;M=Fa;N=Ba;f=Q;O=R;P=ta;continue}}if((S|0)==64){S=0;Ga=a[ga>>0]|0;Ha=Ka;Ia=Ja}$=Ga<<24>>24;la=(Z|0)!=0&($&15|0)==3?$&-33:$;$=sa&-65537;ha=(sa&8192|0)==0?sa:$;f:do switch(la|0){case 110:{switch(Z|0){case 7:{aa=Ha;c[aa>>2]=Q;c[aa+4>>2]=((Q|0)<0)<<31>>31;L=Ha;M=Ia;N=Ba;f=Q;O=R;P=ta;continue a;break}case 3:{b[Ha>>1]=Q;L=Ha;M=Ia;N=Ba;f=Q;O=R;P=ta;continue a;break}case 4:{a[Ha>>0]=Q;L=Ha;M=Ia;N=Ba;f=Q;O=R;P=ta;continue a;break}case 6:{c[Ha>>2]=Q;L=Ha;M=Ia;N=Ba;f=Q;O=R;P=ta;continue a;break}case 1:{c[Ha>>2]=Q;L=Ha;M=Ia;N=Ba;f=Q;O=R;P=ta;continue a;break}case 0:{c[Ha>>2]=Q;L=Ha;M=Ia;N=Ba;f=Q;O=R;P=ta;continue a;break}case 2:{aa=Ha;c[aa>>2]=Q;c[aa+4>>2]=((Q|0)<0)<<31>>31;L=Ha;M=Ia;N=Ba;f=Q;O=R;P=ta;continue a;break}default:{L=Ha;M=Ia;N=Ba;f=Q;O=R;P=ta;continue a}}break}case 109:{Ma=lb(c[(_a()|0)>>2]|0)|0;S=96;break}case 105:case 100:{if((Ia|0)<0){aa=XT(0,0,Ha|0,Ia|0)|0;Na=G;Oa=aa;Pa=1;Qa=329560;S=86;break f}if(!(ha&2048)){aa=ha&1;Na=Ia;Oa=Ha;Pa=aa;Qa=(aa|0)==0?329560:329562;S=86}else{Na=Ia;Oa=Ha;Pa=1;Qa=329561;S=86}break}case 65:case 71:case 70:case 69:case 97:case 103:case 102:case 101:{c[k>>2]=Ha;c[k+4>>2]=Ia;La=+h[k>>3];c[o>>2]=0;if((Ia|0)>=0)if(!(ha&2048)){aa=ha&1;Ra=La;Sa=aa;Ta=(aa|0)==0?329585:329590}else{Ra=La;Sa=1;Ta=329587}else{Ra=-La;Sa=1;Ta=329584}h[k>>3]=Ra;aa=c[k+4>>2]&2146435072;if(!(aa>>>0<2146435072|(aa|0)==2146435072&0<0)){aa=(la&32|0)!=0;if(Ra!=Ra|0!=0){Ua=0;Va=aa?329624:329632}else{Ua=Sa;Va=aa?329608:329616}aa=Ua+3|0;_=(ua|0)>(aa|0);if((ha&8192|0)==0&_){ma=ua-aa|0;cU(s|0,32,(ma>>>0>256?256:ma)|0)|0;if(ma>>>0>255){Wa=ma;do{IT(s,256,e)|0;Wa=Wa+-256|0}while(Wa>>>0>255);Xa=ma&255}else Xa=ma;IT(s,Xa,e)|0}IT(Ta,Ua,e)|0;IT(Va,3,e)|0;if((ha&73728|0)==8192&_){Wa=ua-aa|0;cU(s|0,32,(Wa>>>0>256?256:Wa)|0)|0;if(Wa>>>0>255){Ya=Wa;do{IT(s,256,e)|0;Ya=Ya+-256|0}while(Ya>>>0>255);Za=Wa&255}else Za=Wa;IT(s,Za,e)|0}L=Ha;M=Ia;N=Ba;f=Q;O=_?ua:aa;P=ta;continue a}La=+xT(Ra,o)*2;Ya=La!=0;if(Ya)c[o>>2]=(c[o>>2]|0)+-1;ma=la|32;if((ma|0)==97){$a=la&32;ab=($a|0)==0?Ta:Ta+9|0;bb=Sa|2;cb=za>>>0>11?0:12-za|0;do if(cb){db=cb;eb=8;do{db=db+-1|0;eb=eb*16}while((db|0)!=0);if((a[ab>>0]|0)==45){fb=-(eb+(-La-eb));break}else{fb=La+eb-eb;break}}else fb=La;while(0);cb=c[o>>2]|0;aa=(cb|0)<0?0-cb|0:cb;if((aa|0)<0){cb=B;_=aa;Wa=((aa|0)<0)<<31>>31;while(1){db=oU(_|0,Wa|0,10,0)|0;cb=cb+-1|0;a[cb>>0]=db|48;db=_;_=nU(_|0,Wa|0,10,0)|0;if(!(Wa>>>0>9|(Wa|0)==9&db>>>0>4294967295))break;else Wa=G}gb=cb;hb=_}else{gb=B;hb=aa}if(!hb)ib=gb;else{Wa=gb;db=hb;while(1){jb=Wa+-1|0;a[jb>>0]=(db>>>0)%10|0|48;if(db>>>0<10){ib=jb;break}else{Wa=jb;db=(db>>>0)/10|0}}}if((ib|0)==(B|0)){a[C>>0]=48;kb=C}else kb=ib;a[kb+-1>>0]=(c[o>>2]>>31&2)+43;db=kb+-2|0;a[db>>0]=la+15;if((za|0)<1)if(!(ha&8)){mb=fb;Wa=p;while(1){aa=~~mb;_=Wa+1|0;a[Wa>>0]=d[329640+aa>>0]|$a;mb=(mb-+(aa|0))*16;if((_-q|0)!=1|mb==0)nb=_;else{a[_>>0]=46;nb=Wa+2|0}if(!(mb!=0)){ob=nb;break}else Wa=nb}}else{mb=fb;Wa=p;while(1){_=~~mb;aa=Wa+1|0;a[Wa>>0]=d[329640+_>>0]|$a;mb=(mb-+(_|0))*16;if((aa-q|0)==1){a[aa>>0]=46;pb=Wa+2|0}else pb=aa;if(!(mb!=0)){ob=pb;break}else Wa=pb}}else{mb=fb;Wa=p;while(1){aa=~~mb;_=Wa+1|0;a[Wa>>0]=d[329640+aa>>0]|$a;mb=(mb-+(aa|0))*16;if((_-q|0)==1){a[_>>0]=46;qb=Wa+2|0}else qb=_;if(!(mb!=0)){ob=qb;break}else Wa=qb}}Wa=ob;$a=db;if((za|0)!=0&(E+Wa|0)<(za|0))rb=F+za-$a|0;else rb=D-$a+Wa|0;$a=rb+bb|0;_=ha&73728;aa=(ua|0)>($a|0);if((_|0)==0&aa){cb=ua-$a|0;cU(s|0,32,(cb>>>0>256?256:cb)|0)|0;if(cb>>>0>255){jb=cb;do{IT(s,256,e)|0;jb=jb+-256|0}while(jb>>>0>255);sb=cb&255}else sb=cb;IT(s,sb,e)|0}IT(ab,bb,e)|0;if((_|0)==65536&aa){jb=ua-$a|0;cU(s|0,48,(jb>>>0>256?256:jb)|0)|0;if(jb>>>0>255){tb=jb;do{IT(s,256,e)|0;tb=tb+-256|0}while(tb>>>0>255);ub=jb&255}else ub=jb;IT(s,ub,e)|0}tb=Wa-q|0;IT(p,tb,e)|0;bb=r-db|0;ab=rb-bb-tb|0;if((ab|0)>0){cU(s|0,48,(ab>>>0>256?256:ab)|0)|0;if(ab>>>0>255){tb=ab;do{IT(s,256,e)|0;tb=tb+-256|0}while(tb>>>0>255);vb=ab&255}else vb=ab;IT(s,vb,e)|0}IT(db,bb,e)|0;if((_|0)==8192&aa){tb=ua-$a|0;cU(s|0,32,(tb>>>0>256?256:tb)|0)|0;if(tb>>>0>255){Wa=tb;do{IT(s,256,e)|0;Wa=Wa+-256|0}while(Wa>>>0>255);wb=tb&255}else wb=tb;IT(s,wb,e)|0}L=Ha;M=Ia;N=Ba;f=Q;O=aa?ua:$a;P=ta;continue a}Wa=(za|0)<0?6:za;if(Ya){_=(c[o>>2]|0)+-28|0;c[o>>2]=_;xb=La*268435456;yb=_}else{xb=La;yb=c[o>>2]|0}_=(yb|0)<0?n:H;bb=_;mb=xb;db=_;do{ab=~~mb>>>0;c[db>>2]=ab;db=db+4|0;mb=(mb-+(ab>>>0))*1e9}while(mb!=0);Ya=c[o>>2]|0;if((Ya|0)>0){$a=Ya;aa=_;tb=db;while(1){ab=($a|0)>29?29:$a;jb=tb+-4|0;do if(jb>>>0<aa>>>0)zb=aa;else{cb=0;Ab=jb;do{Bb=$T(c[Ab>>2]|0,0,ab|0)|0;Cb=bU(Bb|0,G|0,cb|0,0)|0;Bb=G;Db=oU(Cb|0,Bb|0,1e9,0)|0;c[Ab>>2]=Db;cb=nU(Cb|0,Bb|0,1e9,0)|0;Ab=Ab+-4|0}while(Ab>>>0>=aa>>>0);if(!cb){zb=aa;break}Ab=aa+-4|0;c[Ab>>2]=cb;zb=Ab}while(0);jb=tb;while(1){if(jb>>>0<=zb>>>0)break;Ab=jb+-4|0;if(!(c[Ab>>2]|0))jb=Ab;else break}Ab=(c[o>>2]|0)-ab|0;c[o>>2]=Ab;if((Ab|0)>0){$a=Ab;aa=zb;tb=jb}else{Eb=Ab;Fb=zb;Gb=jb;break}}}else{Eb=Ya;Fb=_;Gb=db}g:do if((Eb|0)<0){tb=((Wa+25|0)/9|0)+1|0;if((ma|0)==102){aa=_+(tb<<2)|0;$a=Eb;Ab=Fb;Bb=Gb;while(1){Cb=0-$a|0;Db=(Cb|0)>9?9:Cb;do if(Ab>>>0<Bb>>>0){Cb=(1<<Db)+-1|0;Hb=1e9>>>Db;Ib=0;Jb=Ab;do{Kb=c[Jb>>2]|0;c[Jb>>2]=(Kb>>>Db)+Ib;Ib=ca(Kb&Cb,Hb)|0;Jb=Jb+4|0}while(Jb>>>0<Bb>>>0);Jb=(c[Ab>>2]|0)==0?Ab+4|0:Ab;if(!Ib){Lb=Jb;Mb=Bb;break}c[Bb>>2]=Ib;Lb=Jb;Mb=Bb+4|0}else{Lb=(c[Ab>>2]|0)==0?Ab+4|0:Ab;Mb=Bb}while(0);cb=(Mb-bb>>2|0)>(tb|0)?aa:Mb;$a=(c[o>>2]|0)+Db|0;c[o>>2]=$a;if(($a|0)>=0){Nb=Lb;Ob=cb;break g}else{Ab=Lb;Bb=cb}}}else{Pb=Eb;Qb=Fb;Rb=Gb}while(1){Bb=0-Pb|0;Ab=(Bb|0)>9?9:Bb;do if(Qb>>>0<Rb>>>0){Bb=(1<<Ab)+-1|0;$a=1e9>>>Ab;aa=0;jb=Qb;do{ab=c[jb>>2]|0;c[jb>>2]=(ab>>>Ab)+aa;aa=ca(ab&Bb,$a)|0;jb=jb+4|0}while(jb>>>0<Rb>>>0);jb=(c[Qb>>2]|0)==0?Qb+4|0:Qb;if(!aa){Sb=jb;Tb=Rb;break}c[Rb>>2]=aa;Sb=jb;Tb=Rb+4|0}else{Sb=(c[Qb>>2]|0)==0?Qb+4|0:Qb;Tb=Rb}while(0);if((Tb-Sb>>2|0)>(tb|0))Ub=Sb+(tb<<2)|0;else Ub=Tb;Pb=(c[o>>2]|0)+Ab|0;c[o>>2]=Pb;if((Pb|0)>=0){Nb=Sb;Ob=Ub;break}else{Qb=Sb;Rb=Ub}}}else{Nb=Fb;Ob=Gb}while(0);do if(Nb>>>0<Ob>>>0){db=(bb-Nb>>2)*9|0;Ya=c[Nb>>2]|0;if(Ya>>>0<10){Vb=db;break}else{Wb=db;Xb=10}while(1){Xb=Xb*10|0;db=Wb+1|0;if(Ya>>>0<Xb>>>0){Vb=db;break}else Wb=db}}else Vb=0;while(0);Ya=(ma|0)==103;db=Wa-((ma|0)!=102?Vb:0)+((Ya&(Wa|0)!=0)<<31>>31)|0;if((db|0)<(((Ob-bb>>2)*9|0)+-9|0)){tb=db+9216|0;db=(tb|0)/9|0;Db=_+(db+-1023<<2)|0;jb=((tb|0)%9|0)+1|0;if((jb|0)<9){tb=10;$a=jb;while(1){jb=tb*10|0;$a=$a+1|0;if(($a|0)==9){Yb=jb;break}else tb=jb}}else Yb=10;tb=c[Db>>2]|0;$a=(tb>>>0)%(Yb>>>0)|0;if(($a|0)==0?(_+(db+-1022<<2)|0)==(Ob|0):0){Zb=Nb;_b=Db;$b=Vb}else S=232;do if((S|0)==232){S=0;eb=(((tb>>>0)/(Yb>>>0)|0)&1|0)==0?9007199254740992:9007199254740994;ma=(Yb|0)/2|0;do if($a>>>0<ma>>>0)ac=.5;else{if(($a|0)==(ma|0)?(_+(db+-1022<<2)|0)==(Ob|0):0){ac=1;break}ac=1.5}while(0);do if(!Sa){bc=eb;cc=ac}else{if((a[Ta>>0]|0)!=45){bc=eb;cc=ac;break}bc=eb*-1;cc=ac*-1}while(0);ma=tb-$a|0;c[Db>>2]=ma;if(!(bc+cc!=bc)){Zb=Nb;_b=Db;$b=Vb;break}jb=ma+Yb|0;c[Db>>2]=jb;if(jb>>>0>999999999){jb=Nb;ma=Db;while(1){Bb=ma+-4|0;c[ma>>2]=0;if(Bb>>>0<jb>>>0){Ib=jb+-4|0;c[Ib>>2]=0;dc=Ib}else dc=jb;Ib=(c[Bb>>2]|0)+1|0;c[Bb>>2]=Ib;if(Ib>>>0>999999999){jb=dc;ma=Bb}else{ec=dc;fc=Bb;break}}}else{ec=Nb;fc=Db}ma=(bb-ec>>2)*9|0;jb=c[ec>>2]|0;if(jb>>>0<10){Zb=ec;_b=fc;$b=ma;break}else{gc=ma;hc=10}while(1){hc=hc*10|0;ma=gc+1|0;if(jb>>>0<hc>>>0){Zb=ec;_b=fc;$b=ma;break}else gc=ma}}while(0);
Db=_b+4|0;ic=Zb;jc=$b;kc=Ob>>>0>Db>>>0?Db:Ob}else{ic=Nb;jc=Vb;kc=Ob}Db=0-jc|0;$a=kc;while(1){if($a>>>0<=ic>>>0){lc=0;break}tb=$a+-4|0;if(!(c[tb>>2]|0))$a=tb;else{lc=1;break}}do if(Ya){tb=((Wa|0)==0&1)+Wa|0;if((tb|0)>(jc|0)&(jc|0)>-5){mc=la+-1|0;nc=tb+-1-jc|0}else{mc=la+-2|0;nc=tb+-1|0}if(ha&8){oc=mc;pc=nc;break}do if(lc){tb=c[$a+-4>>2]|0;if(!tb){qc=9;break}if(!((tb>>>0)%10|0)){rc=10;sc=0}else{qc=0;break}while(1){rc=rc*10|0;db=sc+1|0;if((tb>>>0)%(rc>>>0)|0){qc=db;break}else sc=db}}else qc=9;while(0);tb=(($a-bb>>2)*9|0)+-9|0;if((mc|32|0)==102){Ab=tb-qc|0;db=(Ab|0)<0?0:Ab;oc=mc;pc=(nc|0)<(db|0)?nc:db;break}else{db=tb+jc-qc|0;tb=(db|0)<0?0:db;oc=mc;pc=(nc|0)<(tb|0)?nc:tb;break}}else{oc=la;pc=Wa}while(0);Wa=(pc|0)!=0;if(Wa)tc=1;else tc=(ha&8|0)!=0;bb=tc&1;Ya=(oc|32|0)==102;if(Ya){uc=(jc|0)>0?jc:0;vc=0}else{tb=(jc|0)<0?Db:jc;if((tb|0)<0){db=B;Ab=tb;jb=((tb|0)<0)<<31>>31;while(1){ma=oU(Ab|0,jb|0,10,0)|0;db=db+-1|0;a[db>>0]=ma|48;ma=Ab;Ab=nU(Ab|0,jb|0,10,0)|0;if(!(jb>>>0>9|(jb|0)==9&ma>>>0>4294967295))break;else jb=G}wc=db;xc=Ab}else{wc=B;xc=tb}if(!xc)yc=wc;else{jb=wc;Db=xc;while(1){ma=jb+-1|0;a[ma>>0]=(Db>>>0)%10|0|48;if(Db>>>0<10){yc=ma;break}else{jb=ma;Db=(Db>>>0)/10|0}}}if((r-yc|0)<2){Db=yc;while(1){jb=Db+-1|0;a[jb>>0]=48;if((r-jb|0)<2)Db=jb;else{zc=jb;break}}}else zc=yc;a[zc+-1>>0]=(jc>>31&2)+43;Db=zc+-2|0;a[Db>>0]=oc;uc=r-Db|0;vc=Db}Db=Sa+1+pc+bb+uc|0;jb=ha&73728;tb=(ua|0)>(Db|0);if((jb|0)==0&tb){Ab=ua-Db|0;cU(s|0,32,(Ab>>>0>256?256:Ab)|0)|0;if(Ab>>>0>255){db=Ab;do{IT(s,256,e)|0;db=db+-256|0}while(db>>>0>255);Ac=Ab&255}else Ac=Ab;IT(s,Ac,e)|0}IT(Ta,Sa,e)|0;if((jb|0)==65536&tb){db=ua-Db|0;cU(s|0,48,(db>>>0>256?256:db)|0)|0;if(db>>>0>255){bb=db;do{IT(s,256,e)|0;bb=bb+-256|0}while(bb>>>0>255);Bc=db&255}else Bc=db;IT(s,Bc,e)|0}do if(Ya){bb=ic>>>0>_>>>0?_:ic;Ab=bb;do{ma=c[Ab>>2]|0;if(!ma)Cc=I;else{Bb=I;Ib=ma;while(1){ma=Bb+-1|0;a[ma>>0]=(Ib>>>0)%10|0|48;if(Ib>>>0<10){Cc=ma;break}else{Bb=ma;Ib=(Ib>>>0)/10|0}}}do if((Ab|0)==(bb|0)){if((Cc|0)!=(I|0)){Dc=Cc;break}a[K>>0]=48;Dc=K}else{if(Cc>>>0>p>>>0)Ec=Cc;else{Dc=Cc;break}while(1){Ib=Ec+-1|0;a[Ib>>0]=48;if(Ib>>>0>p>>>0)Ec=Ib;else{Dc=Ib;break}}}while(0);IT(Dc,J-Dc|0,e)|0;Ab=Ab+4|0}while(Ab>>>0<=_>>>0);if(!((ha&8|0)==0&(Wa^1)))IT(329656,1,e)|0;if(Ab>>>0<$a>>>0&(pc|0)>0){bb=pc;aa=Ab;while(1){Ib=c[aa>>2]|0;if(Ib){Bb=I;ma=Ib;while(1){Bb=Bb+-1|0;a[Bb>>0]=(ma>>>0)%10|0|48;if(ma>>>0<10)break;else ma=(ma>>>0)/10|0}if(Bb>>>0>p>>>0){Fc=Bb;S=301}else Gc=Bb}else{Fc=I;S=301}if((S|0)==301)while(1){S=0;ma=Fc+-1|0;a[ma>>0]=48;if(ma>>>0>p>>>0){Fc=ma;S=301}else{Gc=ma;break}}IT(Gc,(bb|0)>9?9:bb,e)|0;aa=aa+4|0;Bb=bb+-9|0;if(!(aa>>>0<$a>>>0&(Bb|0)>0)){Hc=Bb;break}else bb=Bb}}else Hc=pc;if((Hc|0)<=0)break;cU(s|0,48,(Hc>>>0>256?256:Hc)|0)|0;if(Hc>>>0>255){bb=Hc;do{IT(s,256,e)|0;bb=bb+-256|0}while(bb>>>0>255);Ic=Hc&255}else Ic=Hc;IT(s,Ic,e)|0}else{bb=lc?$a:ic+4|0;do if((pc|0)>-1){aa=(ha&8|0)==0;Ab=pc;Bb=ic;do{ma=c[Bb>>2]|0;if(ma){Ib=I;ab=ma;while(1){Ib=Ib+-1|0;a[Ib>>0]=(ab>>>0)%10|0|48;if(ab>>>0<10)break;else ab=(ab>>>0)/10|0}if((Ib|0)!=(I|0))Jc=Ib;else S=313}else S=313;if((S|0)==313){S=0;a[K>>0]=48;Jc=K}do if((Bb|0)==(ic|0)){ab=Jc+1|0;IT(Jc,1,e)|0;if((Ab|0)<1&aa){Kc=ab;break}IT(329656,1,e)|0;Kc=ab}else{if(Jc>>>0>p>>>0)Lc=Jc;else{Kc=Jc;break}while(1){ab=Lc+-1|0;a[ab>>0]=48;if(ab>>>0>p>>>0)Lc=ab;else{Kc=ab;break}}}while(0);Ib=J-Kc|0;IT(Kc,(Ab|0)>(Ib|0)?Ib:Ab,e)|0;Ab=Ab-Ib|0;Bb=Bb+4|0}while(Bb>>>0<bb>>>0&(Ab|0)>-1);if((Ab|0)<=0)break;cU(s|0,48,(Ab>>>0>256?256:Ab)|0)|0;if(Ab>>>0>255){Bb=Ab;do{IT(s,256,e)|0;Bb=Bb+-256|0}while(Bb>>>0>255);Mc=Ab&255}else Mc=Ab;IT(s,Mc,e)|0}while(0);IT(vc,r-vc|0,e)|0}while(0);if((jb|0)==8192&tb){$a=ua-Db|0;cU(s|0,32,($a>>>0>256?256:$a)|0)|0;if($a>>>0>255){Wa=$a;do{IT(s,256,e)|0;Wa=Wa+-256|0}while(Wa>>>0>255);Nc=$a&255}else Nc=$a;IT(s,Nc,e)|0}L=Ha;M=Ia;N=Ba;f=Q;O=tb?ua:Db;P=ta;continue a;break}case 117:{Na=Ia;Oa=Ha;Pa=0;Qa=329560;S=86;break}case 88:case 120:{Oc=ha;Pc=za;Qc=la;S=75;break}case 99:{a[z>>0]=Ha;Rc=Ha;Sc=Ia;Tc=z;Uc=$;Vc=1;Wc=0;Xc=329560;Yc=x;break}case 111:{Wa=(Ha|0)==0&(Ia|0)==0;if(Wa)Zc=x;else{jb=x;_=Ha;Ya=Ia;while(1){db=jb+-1|0;a[db>>0]=_&7|48;_=dU(_|0,Ya|0,3)|0;Ya=G;if((_|0)==0&(Ya|0)==0){Zc=db;break}else jb=db}}jb=(ha&8|0)==0|Wa;_c=Ha;$c=Ia;ad=Zc;bd=ha;cd=za;dd=jb&1^1;ed=jb?329560:329565;S=91;break}case 67:{c[u>>2]=Ha;c[t>>2]=0;fd=u;gd=A;hd=-1;S=101;break}case 83:{jb=Ha;if(!za){id=Ha;jd=jb;kd=0;S=106}else{fd=jb;gd=Ha;hd=za;S=101}break}case 112:{Oc=ha|8;Pc=za>>>0>8?za:8;Qc=120;S=75;break}case 115:{Ma=(Ha|0)==0?329576:Ha;S=96;break}default:{Rc=Ha;Sc=Ia;Tc=N;Uc=ha;Vc=za;Wc=0;Xc=329560;Yc=x}}while(0);do if((S|0)==75){S=0;la=Qc&32;if(!((Ha|0)==0&(Ia|0)==0)){R=x;Z=Ha;ga=Ia;do{R=R+-1|0;a[R>>0]=d[329640+(Z&15)>>0]|la;Z=dU(Z|0,ga|0,4)|0;ga=G}while(!((Z|0)==0&(ga|0)==0));if(!(Oc&8)){_c=Ha;$c=Ia;ad=R;bd=Oc;cd=Pc;dd=0;ed=329560;S=91}else{_c=Ha;$c=Ia;ad=R;bd=Oc;cd=Pc;dd=2;ed=329560+(Qc>>4)|0;S=91}}else{_c=Ha;$c=Ia;ad=x;bd=Oc;cd=Pc;dd=0;ed=329560;S=91}}else if((S|0)==86){S=0;if(Na>>>0>0|(Na|0)==0&Oa>>>0>4294967295){ga=x;Z=Oa;la=Na;while(1){Wa=oU(Z|0,la|0,10,0)|0;ga=ga+-1|0;a[ga>>0]=Wa|48;Wa=Z;Z=nU(Z|0,la|0,10,0)|0;if(!(la>>>0>9|(la|0)==9&Wa>>>0>4294967295))break;else la=G}ld=ga;md=Z}else{ld=x;md=Oa}if(!md){_c=Oa;$c=Na;ad=ld;bd=ha;cd=za;dd=Pa;ed=Qa;S=91}else{la=ld;R=md;while(1){Wa=la+-1|0;a[Wa>>0]=(R>>>0)%10|0|48;if(R>>>0<10){_c=Oa;$c=Na;ad=Wa;bd=ha;cd=za;dd=Pa;ed=Qa;S=91;break}else{la=Wa;R=(R>>>0)/10|0}}}}else if((S|0)==96){S=0;R=NT(Ma,0,za)|0;if(!R){Rc=Ha;Sc=Ia;Tc=Ma;Uc=$;Vc=za;Wc=0;Xc=329560;Yc=Ma+za|0;break}else{Rc=Ha;Sc=Ia;Tc=Ma;Uc=$;Vc=R-Ma|0;Wc=0;Xc=329560;Yc=R;break}}else if((S|0)==101){S=0;R=0;la=0;Z=fd;while(1){ga=c[Z>>2]|0;if(!ga){nd=R;od=la;break}Wa=CT(v,ga)|0;if((Wa|0)<0|Wa>>>0>(hd-R|0)>>>0){nd=R;od=Wa;break}ga=Wa+R|0;if(hd>>>0>ga>>>0){R=ga;la=Wa;Z=Z+4|0}else{nd=ga;od=Wa;break}}if((od|0)<0){qa=-1;S=370;break a}else{id=gd;jd=fd;kd=nd;S=106}}while(0);if((S|0)==91){S=0;$=(cd|0)>-1?bd&-65537:bd;Z=(_c|0)!=0|($c|0)!=0;if(Z|(cd|0)!=0){la=(Z&1^1)+(y-ad)|0;Rc=_c;Sc=$c;Tc=ad;Uc=$;Vc=(cd|0)>(la|0)?cd:la;Wc=dd;Xc=ed;Yc=x}else{Rc=_c;Sc=$c;Tc=x;Uc=$;Vc=0;Wc=dd;Xc=ed;Yc=x}}else if((S|0)==106){S=0;$=ha&73728;la=(ua|0)>(kd|0);if(($|0)==0&la){Z=ua-kd|0;cU(s|0,32,(Z>>>0>256?256:Z)|0)|0;if(Z>>>0>255){R=Z;do{IT(s,256,e)|0;R=R+-256|0}while(R>>>0>255);pd=Z&255}else pd=Z;IT(s,pd,e)|0}h:do if(kd){R=0;ha=jd;while(1){Wa=c[ha>>2]|0;if(!Wa)break h;ga=CT(v,Wa)|0;R=ga+R|0;if((R|0)>(kd|0))break h;IT(v,ga,e)|0;if(R>>>0>=kd>>>0)break;else ha=ha+4|0}}while(0);if(($|0)==8192&la){Z=ua-kd|0;cU(s|0,32,(Z>>>0>256?256:Z)|0)|0;if(Z>>>0>255){ha=Z;do{IT(s,256,e)|0;ha=ha+-256|0}while(ha>>>0>255);qd=Z&255}else qd=Z;IT(s,qd,e)|0}L=id;M=Ia;N=Ba;f=Q;O=la?ua:kd;P=ta;continue}ha=Yc-Tc|0;$=(Vc|0)<(ha|0)?ha:Vc;R=Wc+$|0;ga=(ua|0)<(R|0)?R:ua;Wa=Uc&73728;jb=(ga|0)>(R|0);if((Wa|0)==0&jb){Ya=ga-R|0;cU(s|0,32,(Ya>>>0>256?256:Ya)|0)|0;if(Ya>>>0>255){_=Ya;do{IT(s,256,e)|0;_=_+-256|0}while(_>>>0>255);rd=Ya&255}else rd=Ya;IT(s,rd,e)|0}IT(Xc,Wc,e)|0;if((Wa|0)==65536&jb){_=ga-R|0;cU(s|0,48,(_>>>0>256?256:_)|0)|0;if(_>>>0>255){la=_;do{IT(s,256,e)|0;la=la+-256|0}while(la>>>0>255);sd=_&255}else sd=_;IT(s,sd,e)|0}if(($|0)>(ha|0)){la=$-ha|0;cU(s|0,48,(la>>>0>256?256:la)|0)|0;if(la>>>0>255){Ya=la;do{IT(s,256,e)|0;Ya=Ya+-256|0}while(Ya>>>0>255);td=la&255}else td=la;IT(s,td,e)|0}IT(Tc,ha,e)|0;if(!((Wa|0)==8192&jb)){L=Rc;M=Sc;N=Ba;f=Q;O=ga;P=ta;continue}Ya=ga-R|0;cU(s|0,32,(Ya>>>0>256?256:Ya)|0)|0;if(Ya>>>0>255){$=Ya;do{IT(s,256,e)|0;$=$+-256|0}while($>>>0>255);ud=Ya&255}else ud=Ya;IT(s,ud,e)|0;L=Rc;M=Sc;N=Ba;f=Q;O=ga;P=ta}if((S|0)==352){if(e){qa=Q;i=m;return qa|0}if(!P){qa=0;i=m;return qa|0}else vd=1;while(1){P=c[l+(vd<<2)>>2]|0;if(!P){wd=vd;break}Q=j+(vd<<3)|0;i:do if(P>>>0<=20)do switch(P|0){case 9:{e=c[g>>2]|0;ta=c[e>>2]|0;c[g>>2]=e+4;c[Q>>2]=ta;break i;break}case 10:{ta=c[g>>2]|0;e=c[ta>>2]|0;c[g>>2]=ta+4;ta=Q;c[ta>>2]=e;c[ta+4>>2]=((e|0)<0)<<31>>31;break i;break}case 11:{e=c[g>>2]|0;ta=c[e>>2]|0;c[g>>2]=e+4;e=Q;c[e>>2]=ta;c[e+4>>2]=0;break i;break}case 12:{e=c[g>>2]|0;ta=e;O=c[ta>>2]|0;f=c[ta+4>>2]|0;c[g>>2]=e+8;e=Q;c[e>>2]=O;c[e+4>>2]=f;break i;break}case 13:{f=c[g>>2]|0;e=c[f>>2]|0;c[g>>2]=f+4;f=(e&65535)<<16>>16;e=Q;c[e>>2]=f;c[e+4>>2]=((f|0)<0)<<31>>31;break i;break}case 14:{f=c[g>>2]|0;e=c[f>>2]|0;c[g>>2]=f+4;f=Q;c[f>>2]=e&65535;c[f+4>>2]=0;break i;break}case 15:{f=c[g>>2]|0;e=c[f>>2]|0;c[g>>2]=f+4;f=(e&255)<<24>>24;e=Q;c[e>>2]=f;c[e+4>>2]=((f|0)<0)<<31>>31;break i;break}case 16:{f=c[g>>2]|0;e=c[f>>2]|0;c[g>>2]=f+4;f=Q;c[f>>2]=e&255;c[f+4>>2]=0;break i;break}case 17:{f=c[g>>2]|0;c[k>>2]=c[f>>2];c[k+4>>2]=c[f+4>>2];bc=+h[k>>3];c[g>>2]=f+8;h[Q>>3]=bc;break i;break}case 18:{f=c[g>>2]|0;c[k>>2]=c[f>>2];c[k+4>>2]=c[f+4>>2];bc=+h[k>>3];c[g>>2]=f+8;h[Q>>3]=bc;break i;break}default:break i}while(0);while(0);vd=vd+1|0;if((vd|0)>=10){qa=1;S=370;break}}if((S|0)==370){i=m;return qa|0}while(1){if(c[l+(wd<<2)>>2]|0){qa=-1;S=370;break}wd=wd+1|0;if((wd|0)>=10){qa=1;S=370;break}}if((S|0)==370){i=m;return qa|0}}else if((S|0)==370){i=m;return qa|0}return 0}function WT(){}function XT(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=b-d>>>0;e=b-d-(c>>>0>a>>>0|0)>>>0;return(G=e,a-c>>>0|0)|0}function YT(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){G=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}G=(b|0)<0?-1:0;return b>>c-32|0}function ZT(b){b=b|0;var c=0;c=b;while(a[c>>0]|0)c=c+1|0;return c-b|0}function _T(b,c){b=b|0;c=c|0;var d=0,e=0;d=b+(ZT(b)|0)|0;do{a[d+e>>0]=a[c+e>>0];e=e+1|0}while(a[c+(e-1)>>0]|0);return b|0}function $T(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){G=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}G=a<<c-32;return 0}function aU(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;while((e|0)<(d|0)){a[b+e>>0]=f?0:a[c+e>>0]|0;f=f?1:(a[c+e>>0]|0)==0;e=e+1|0}return b|0}function bU(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=a+c>>>0;return(G=b+d+(e>>>0<a>>>0|0)>>>0,e|0)|0}function cU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b+e|0;if((e|0)>=20){d=d&255;g=b&3;h=d|d<<8|d<<16|d<<24;i=f&~3;if(g){g=b+4-g|0;while((b|0)<(g|0)){a[b>>0]=d;b=b+1|0}}while((b|0)<(i|0)){c[b>>2]=h;b=b+4|0}}while((b|0)<(f|0)){a[b>>0]=d;b=b+1|0}return b-e|0}function dU(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){G=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}G=0;return b>>>c-32|0}function eU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((e|0)>=4096)return Na(b|0,d|0,e|0)|0;f=b|0;if((b&3)==(d&3)){while(b&3){if(!e)return f|0;a[b>>0]=a[d>>0]|0;b=b+1|0;d=d+1|0;e=e-1|0}while((e|0)>=4){c[b>>2]=c[d>>2];b=b+4|0;d=d+4|0;e=e-4|0}}while((e|0)>0){a[b>>0]=a[d>>0]|0;b=b+1|0;d=d+1|0;e=e-1|0}return f|0}function fU(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if((c|0)<(b|0)&(b|0)<(c+d|0)){e=b;c=c+d|0;b=b+d|0;while((d|0)>0){b=b-1|0;c=c-1|0;d=d-1|0;a[b>>0]=a[c>>0]|0}b=e}else eU(b,c,d)|0;return b|0}function gU(b,c){b=b|0;c=c|0;var d=0;do{a[b+d>>0]=a[c+d>>0];d=d+1|0}while(a[c+(d-1)>>0]|0);return b|0}function hU(b){b=b|0;var c=0;c=a[n+(b>>>24)>>0]|0;if((c|0)<8)return c|0;c=a[n+(b>>16&255)>>0]|0;if((c|0)<8)return c+8|0;c=a[n+(b>>8&255)>>0]|0;if((c|0)<8)return c+16|0;return(a[n+(b&255)>>0]|0)+24|0}function iU(b){b=b|0;var c=0;c=a[m+(b&255)>>0]|0;if((c|0)<8)return c|0;c=a[m+(b>>8&255)>>0]|0;if((c|0)<8)return c+8|0;c=a[m+(b>>16&255)>>0]|0;if((c|0)<8)return c+16|0;return(a[m+(b>>>24)>>0]|0)+24|0}function jU(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=a&65535;d=b&65535;e=ca(d,c)|0;f=a>>>16;a=(e>>>16)+(ca(d,f)|0)|0;d=b>>>16;b=ca(d,c)|0;return(G=(a>>>16)+(ca(d,f)|0)+(((a&65535)+b|0)>>>16)|0,a+b<<16|e&65535|0)|0}function kU(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=b>>31|((b|0)<0?-1:0)<<1;f=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;g=d>>31|((d|0)<0?-1:0)<<1;h=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;i=XT(e^a,f^b,e,f)|0;b=G;a=g^e;e=h^f;f=XT((pU(i,b,XT(g^c,h^d,g,h)|0,G,0)|0)^a,G^e,a,e)|0;return f|0}function lU(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+8|0;g=f|0;h=b>>31|((b|0)<0?-1:0)<<1;j=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;k=e>>31|((e|0)<0?-1:0)<<1;l=((e|0)<0?-1:0)>>31|((e|0)<0?-1:0)<<1;m=XT(h^a,j^b,h,j)|0;b=G;pU(m,b,XT(k^d,l^e,k,l)|0,G,g)|0;l=XT(c[g>>2]^h,c[g+4>>2]^j,h,j)|0;j=G;i=f;return(G=j,l)|0}function mU(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;a=c;c=jU(e,a)|0;f=G;return(G=(ca(b,a)|0)+(ca(d,e)|0)+f|f&0,c|0|0)|0}function nU(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=pU(a,b,c,d,0)|0;return e|0}function oU(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=f|0;pU(a,b,d,e,g)|0;i=f;return(G=c[g+4>>2]|0,c[g>>2]|0)|0}function pU(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,H=0;g=a;h=b;i=h;j=d;k=e;l=k;if(!i){m=(f|0)!=0;if(!l){if(m){c[f>>2]=(g>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(g>>>0)/(j>>>0)>>>0;return(G=n,o)|0}else{if(!m){n=0;o=0;return(G=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=b&0;n=0;o=0;return(G=n,o)|0}}m=(l|0)==0;do if(j){if(!m){p=(hU(l|0)|0)-(hU(i|0)|0)|0;if(p>>>0<=31){q=p+1|0;r=31-p|0;s=p-31>>31;t=q;u=g>>>(q>>>0)&s|i<<r;v=i>>>(q>>>0)&s;w=0;x=g<<r;break}if(!f){n=0;o=0;return(G=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(G=n,o)|0}r=j-1|0;if(r&j){s=(hU(j|0)|0)+33-(hU(i|0)|0)|0;q=64-s|0;p=32-s|0;y=p>>31;z=s-32|0;A=z>>31;t=s;u=p-1>>31&i>>>(z>>>0)|(i<<p|g>>>(s>>>0))&A;v=A&i>>>(s>>>0);w=g<<q&y;x=(i<<q|g>>>(z>>>0))&y|g<<p&s-33>>31;break}if(f){c[f>>2]=r&g;c[f+4>>2]=0}if((j|0)==1){n=h|b&0;o=a|0|0;return(G=n,o)|0}else{r=iU(j|0)|0;n=i>>>(r>>>0)|0;o=i<<32-r|g>>>(r>>>0)|0;return(G=n,o)|0}}else{if(m){if(f){c[f>>2]=(i>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(i>>>0)/(j>>>0)>>>0;return(G=n,o)|0}if(!g){if(f){c[f>>2]=0;c[f+4>>2]=(i>>>0)%(l>>>0)}n=0;o=(i>>>0)/(l>>>0)>>>0;return(G=n,o)|0}r=l-1|0;if(!(r&l)){if(f){c[f>>2]=a|0;c[f+4>>2]=r&i|b&0}n=0;o=i>>>((iU(l|0)|0)>>>0);return(G=n,o)|0}r=(hU(l|0)|0)-(hU(i|0)|0)|0;if(r>>>0<=30){s=r+1|0;p=31-r|0;t=s;u=i<<p|g>>>(s>>>0);v=i>>>(s>>>0);w=0;x=g<<p;break}if(!f){n=0;o=0;return(G=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(G=n,o)|0}while(0);if(!t){B=x;C=w;D=v;E=u;F=0;H=0}else{b=d|0|0;d=k|e&0;e=bU(b,d,-1,-1)|0;k=G;h=x;x=w;w=v;v=u;u=t;t=0;do{a=h;h=x>>>31|h<<1;x=t|x<<1;g=v<<1|a>>>31|0;a=v>>>31|w<<1|0;XT(e,k,g,a)|0;i=G;l=i>>31|((i|0)<0?-1:0)<<1;t=l&1;v=XT(g,a,l&b,(((i|0)<0?-1:0)>>31|((i|0)<0?-1:0)<<1)&d)|0;w=G;u=u-1|0}while((u|0)!=0);B=h;C=x;D=w;E=v;F=0;H=t}t=C;C=0;if(f){c[f>>2]=E;c[f+4>>2]=D}n=(t|0)>>>31|(B|C)<<1|(C<<1|t>>>31)&0|F;o=(t<<1|0>>>31)&-2|H;return(G=n,o)|0}function qU(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return ub[a&511](b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function rU(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return vb[a&511](b|0,c|0,d|0)|0}function sU(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;wb[a&511](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function tU(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;xb[a&511](b|0,c|0,d|0,e|0,f|0)}function uU(a){a=a|0;return yb[a&511]()|0}function vU(a,b){a=a|0;b=b|0;zb[a&511](b|0)}function wU(a,b,c){a=a|0;b=b|0;c=c|0;Ab[a&511](b|0,c|0)}function xU(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Bb[a&511](b|0,c|0,d|0,e|0,f|0,g|0)|0}function yU(a,b){a=a|0;b=b|0;return Cb[a&511](b|0)|0}function zU(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Db[a&511](b|0,c|0,d|0)}function AU(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;Eb[a&511](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function BU(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Fb[a&511](b|0,c|0,d|0,e|0)|0}function CU(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Gb[a&511](b|0,c|0,d|0,e|0,f|0,g|0)}function DU(a,b,c){a=a|0;b=b|0;c=c|0;return Hb[a&511](b|0,c|0)|0}function EU(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Ib[a&511](b|0,c|0,d|0,e|0,f|0)|0}function FU(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Jb[a&511](b|0,c|0,d|0,e|0)}function GU(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;da(0);return 0}function HU(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function IU(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return vc(a|0)|0}function JU(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return wc(a|0)|0}function KU(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return xc(a|0)|0}function LU(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return yc(a|0,b|0,c|0)|0}function MU(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return zc(a|0,b|0)|0}function NU(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function OU(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function PU(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function QU(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function RU(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function SU(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function TU(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function UU(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function VU(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function WU(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function XU(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function YU(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function ZU(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function _U(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function $U(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function aV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function bV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function cV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function dV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Qc(a|0,b|0)|0}function eV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function fV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function gV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function hV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function iV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Xk(a|0,b|0,c|0)|0}function jV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function kV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return iT(a|0)|0}function lV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return kT(a|0,b|0)|0}function mV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return my(a|0)|0}function nV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function oV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function pV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return PP(a|0)|0}function qV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return QP(a|0)|0}function rV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return RP(a|0)|0}function sV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return UP(a|0,b|0,c|0)|0}function tV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return VP(a|0,b|0)|0}function uV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function vV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function wV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function xV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function yV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function zV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function AV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function BV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function CV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function DV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function EV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function FV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function GV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function HV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function IV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function JV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function KV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return WP(a|0,b|0)|0}function LV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function MV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function NV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return LP(a|0)|0}function OV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return MP(a|0)|0}function PV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return NP(a|0)|0}function QV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return OP(a|0)|0}function RV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function SV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return NI(a|0)|0}function TV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return OI(a|0)|0}function UV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return PI(a|0)|0}function VV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return QI(a|0)|0}function WV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return RI(a|0)|0}function XV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return SI(a|0)|0}function YV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return TI(a|0)|0}function ZV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return UI(a|0)|0}function _V(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return VI(a|0)|0}function $V(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return WI(a|0)|0}function aW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return XI(a|0)|0}function bW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return YI(a|0)|0}function cW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return ZI(a|0)|0}function dW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return _I(a|0)|0}function eW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return $I(a|0)|0}function fW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return aJ(a|0)|0}function gW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return bJ(a|0)|0}function hW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return cJ(a|0)|0}function iW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return dJ(a|0)|0}function jW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return eJ(a|0)|0}function kW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return fJ(a|0)|0}function lW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return gJ(a|0)|0}function mW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return hJ(a|0)|0}function nW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return iJ(a|0)|0}function oW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return jJ(a|0)|0}function pW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return kJ(a|0)|0}function qW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return lJ(a|0)|0}function rW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return mJ(a|0)|0}function sW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return nJ(a|0)|0}function tW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return oJ(a|0)|0}function uW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return pJ(a|0)|0}function vW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return qJ(a|0)|0}function wW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return rJ(a|0)|0}function xW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return sJ(a|0)|0}function yW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return tJ(a|0)|0}function zW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return uJ(a|0)|0}function AW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return vJ(a|0)|0}function BW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return wJ(a|0)|0}function CW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return xJ(a|0)|0}function DW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return yJ(a|0)|0}function EW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return zJ(a|0)|0}function FW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return AJ(a|0)|0}function GW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return BJ(a|0)|0}function HW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return CJ(a|0)|0}function IW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return DJ(a|0)|0}function JW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return EJ(a|0)|0}function KW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return FJ(a|0)|0}function LW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return GJ(a|0)|0}function MW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return HJ(a|0)|0}function NW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return IJ(a|0)|0}function OW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return JJ(a|0)|0}function PW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return KJ(a|0)|0}function QW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return LJ(a|0)|0}function RW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return MJ(a|0)|0}function SW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return NJ(a|0)|0}function TW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return OJ(a|0)|0}function UW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return PJ(a|0)|0}function VW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return QJ(a|0)|0}function WW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return RJ(a|0)|0}function XW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return SJ(a|0)|0}function YW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return TJ(a|0)|0}function ZW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return UJ(a|0)|0}function _W(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return VJ(a|0)|0}function $W(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return WJ(a|0)|0}function aX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return XJ(a|0)|0}function bX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return YJ(a|0)|0}function cX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return ZJ(a|0)|0}function dX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return _J(a|0)|0}function eX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return $J(a|0)|0}function fX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return aK(a|0)|0}function gX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return bK(a|0)|0}function hX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return cK(a|0)|0}function iX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return dK(a|0)|0}function jX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return eK(a|0)|0}function kX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return fK(a|0)|0}function lX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return gK(a|0)|0}function mX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return hK(a|0)|0}function nX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return iK(a|0)|0}function oX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return jK(a|0)|0}function pX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return kK(a|0)|0}function qX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return lK(a|0)|0}function rX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return mK(a|0)|0}function sX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return nK(a|0)|0}function tX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return oK(a|0)|0}function uX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return pK(a|0)|0}function vX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return qK(a|0)|0}function wX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return rK(a|0)|0}function xX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return sK(a|0)|0}function yX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return tK(a|0)|0}function zX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return uK(a|0)|0}function AX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return vK(a|0)|0}function BX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return wK(a|0)|0}function CX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return xK(a|0)|0}function DX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return yK(a|0)|0}function EX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return zK(a|0)|0}function FX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return AK(a|0)|0}function GX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return BK(a|0)|0}function HX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return CK(a|0)|0}function IX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return DK(a|0)|0}function JX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return EK(a|0)|0}function KX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return FK(a|0)|0}function LX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return GK(a|0)|0}function MX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return HK(a|0)|0}function NX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return IK(a|0)|0}function OX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return JK(a|0)|0}function PX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return KK(a|0)|0}function QX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return LK(a|0)|0}function RX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return MK(a|0)|0}function SX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return NK(a|0)|0}function TX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return OK(a|0)|0}function UX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return PK(a|0)|0}function VX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return QK(a|0)|0}function WX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return RK(a|0)|0}function XX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return SK(a|0)|0}function YX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return TK(a|0)|0}function ZX(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return UK(a|0)|0}function _X(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return VK(a|0)|0}function $X(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return WK(a|0)|0}function aY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return XK(a|0)|0}function bY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return YK(a|0)|0}function cY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return ZK(a|0)|0}function dY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return _K(a|0)|0}function eY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return $K(a|0)|0}function fY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return aL(a|0)|0}function gY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return bL(a|0)|0}function hY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return cL(a|0)|0}function iY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return dL(a|0)|0}function jY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return eL(a|0)|0}function kY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return RT(a|0,b|0,c|0)|0}function lY(a,b,c,d,e,f,g){a=a|0;
b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function mY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Wb(a|0)|0}function nY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Xb(a|0,b|0)|0}function oY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Yb(a|0)|0}function pY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Wk(a|0,b|0,c|0)|0}function qY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function rY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function sY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return ac(a|0,b|0,c|0)|0}function tY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Ka(a|0,b|0,c|0)|0}function uY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return gc(a|0,b|0,c|0)|0}function vY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function wY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function xY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function yY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function zY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function AY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return nc(a|0)|0}function BY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function CY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return nd(a|0)|0}function DY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Kd(a|0,b|0,c|0,d|0)|0}function EY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Ld(a|0,b|0,c|0,d|0)|0}function FY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Md(a|0,b|0,c|0,d|0)|0}function GY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Nd(a|0,b|0,c|0,d|0)|0}function HY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Od(a|0,b|0,c|0,d|0)|0}function IY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Pd(a|0,b|0,c|0,d|0)|0}function JY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return qd(a|0,b|0,c|0,d|0)|0}function KY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return rd(a|0,b|0,c|0,d|0)|0}function LY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Qd(a|0,b|0,c|0,d|0)|0}function MY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Rd(a|0,b|0,c|0,d|0)|0}function NY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return fo(a|0,b|0,c|0,d|0)|0}function OY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function PY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function QY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function RY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return mk()|0}function SY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function TY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function UY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return nk(a|0)|0}function VY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return ok(a|0)|0}function WY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return pk(a|0,b|0,c|0)|0}function XY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return qk(a|0)|0}function YY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return _k(a|0)|0}function ZY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return $k(a|0,b|0,c|0)|0}function _Y(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return bl(a|0)|0}function $Y(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return cl(a|0,b|0,c|0)|0}function aZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return dl(a|0)|0}function bZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return el(a|0,b|0,c|0)|0}function cZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return fl(a|0,b|0,c|0)|0}function dZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return gl(a|0,b|0,c|0,d|0)|0}function eZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function fZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return on(a|0)|0}function gZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function hZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return vn(a|0)|0}function iZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function jZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return yn(a|0)|0}function kZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function lZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function mZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function nZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Cn(a|0,b|0)|0}function oZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function pZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function qZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function rZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function sZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function tZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function uZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return _n(a|0,b|0)|0}function vZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function wZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function xZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function yZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function zZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function AZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function BZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function CZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function DZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function EZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function FZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function GZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function HZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function IZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function JZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function KZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function LZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function MZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function NZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function OZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function PZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function QZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function RZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function SZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function TZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function UZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function VZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function WZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function XZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function YZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function ZZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return uu(a|0,b|0,c|0)|0}function _Z(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return ds(a|0,b|0)|0}function $Z(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return es(a|0,b|0)|0}function a_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return js(a|0,b|0)|0}function b_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return vu(a|0,b|0,c|0)|0}function c_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return wu(a|0,b|0)|0}function d_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return $r(a|0,b|0)|0}function e_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return as(a|0,b|0)|0}function f_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return bs(a|0,b|0)|0}function g_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return hs(a|0,b|0)|0}function h_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return fs(a|0,b|0)|0}function i_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return is(a|0,b|0)|0}function j_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return cs(a|0,b|0)|0}function k_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return xu(a|0,b|0)|0}function l_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return gs(a|0,b|0)|0}function m_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return _r(a|0,b|0)|0}function n_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return dr(a|0,b|0)|0}function o_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function p_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function q_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function r_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function s_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function t_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function u_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function v_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function w_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function x_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function y_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function z_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Kx(a|0,b|0,c|0)|0}function A_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return $x(a|0,b|0)|0}function B_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return dy(a|0,b|0)|0}function C_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return fy(a|0,b|0)|0}function D_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return jy(a|0,b|0)|0}function E_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function F_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function G_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function H_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function I_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function J_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function K_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function L_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return RB(a|0)|0}function M_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return SB(a|0)|0}function N_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return TB(a|0)|0}function O_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return UB(a|0,b|0,c|0)|0}function P_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return VB(a|0,b|0)|0}function Q_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function R_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function S_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function T_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function U_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function V_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function W_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function X_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function Y_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function Z_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function __(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function $_(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function a$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function b$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return hC(a|0,b|0)|0}function c$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function d$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function e$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function f$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function g$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function h$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function i$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function j$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return rC(a|0,b|0,c|0)|0}function k$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function l$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function m$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function n$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function o$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function p$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function q$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function r$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function s$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function t$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function u$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function v$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function w$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function x$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return GM(a|0,b|0,c|0)|0}function y$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function z$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function A$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return nN(a|0,b|0)|0}function B$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return oN(a|0,b|0,c|0,d|0,e|0)|0}function C$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return qN(a|0,b|0,c|0,d|0,e|0,f|0)|0}function D$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function E$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return tN(a|0,b|0)|0}function F$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return uN(a|0,b|0,c|0,d|0,e|0)|0}function G$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function H$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function I$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function J$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function K$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function L$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function M$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function N$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function O$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return 0}function P$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return WR(a|0,b|0,c|0,d|0)|0}function Q$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return QS(a|0,b|0)|0}function R$(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return hT(a|0,b|0,c|0)|0}function S$(a,b,c){a=a|0;b=b|0;c=c|0;da(1);return 0}function T$(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function U$(a,b,c){a=a|0;b=b|0;c=c|0;return vc(a|0)|0}function V$(a,b,c){a=a|0;b=b|0;c=c|0;return wc(a|0)|0}function W$(a,b,c){a=a|0;b=b|0;c=c|0;return xc(a|0)|0}function X$(a,b,c){a=a|0;b=b|0;c=c|0;return zc(a|0,b|0)|0}function Y$(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function Z$(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function _$(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function $$(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function a0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function b0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function c0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function d0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function e0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function f0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function g0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function h0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function i0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function j0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function k0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function l0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function m0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function n0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function o0(a,b,c){a=a|0;b=b|0;c=c|0;return Qc(a|0,b|0)|0}function p0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function q0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function r0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function s0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function t0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function u0(a,b,c){a=a|0;b=b|0;c=c|0;return iT(a|0)|0}function v0(a,b,c){a=a|0;b=b|0;c=c|0;return kT(a|0,b|0)|0}function w0(a,b,c){a=a|0;b=b|0;c=c|0;return my(a|0)|0}function x0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function y0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function z0(a,b,c){a=a|0;b=b|0;c=c|0;return PP(a|0)|0}function A0(a,b,c){a=a|0;b=b|0;c=c|0;return QP(a|0)|0}function B0(a,b,c){a=a|0;b=b|0;c=c|0;return RP(a|0)|0}function C0(a,b,c){a=a|0;b=b|0;c=c|0;return VP(a|0,b|0)|0}function D0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function E0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function F0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function G0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function H0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function I0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function J0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function K0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function L0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function M0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function N0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function O0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function P0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function Q0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function R0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function S0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function T0(a,b,c){a=a|0;b=b|0;c=c|0;return WP(a|0,b|0)|0}function U0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function V0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function W0(a,b,c){a=a|0;b=b|0;c=c|0;return LP(a|0)|0}function X0(a,b,c){a=a|0;b=b|0;c=c|0;return MP(a|0)|0}function Y0(a,b,c){a=a|0;b=b|0;c=c|0;return NP(a|0)|0}function Z0(a,b,c){a=a|0;b=b|0;c=c|0;return OP(a|0)|0}function _0(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function $0(a,b,c){a=a|0;b=b|0;c=c|0;return NI(a|0)|0}function a1(a,b,c){a=a|0;b=b|0;c=c|0;return OI(a|0)|0}function b1(a,b,c){a=a|0;b=b|0;c=c|0;return PI(a|0)|0}function c1(a,b,c){a=a|0;b=b|0;c=c|0;return QI(a|0)|0}function d1(a,b,c){a=a|0;b=b|0;c=c|0;return RI(a|0)|0}function e1(a,b,c){a=a|0;b=b|0;c=c|0;return SI(a|0)|0}function f1(a,b,c){a=a|0;b=b|0;c=c|0;return TI(a|0)|0}function g1(a,b,c){a=a|0;b=b|0;c=c|0;return UI(a|0)|0}function h1(a,b,c){a=a|0;b=b|0;c=c|0;return VI(a|0)|0}function i1(a,b,c){a=a|0;b=b|0;c=c|0;return WI(a|0)|0}function j1(a,b,c){a=a|0;b=b|0;c=c|0;return XI(a|0)|0}function k1(a,b,c){a=a|0;b=b|0;c=c|0;return YI(a|0)|0}function l1(a,b,c){a=a|0;b=b|0;c=c|0;return ZI(a|0)|0}function m1(a,b,c){a=a|0;b=b|0;c=c|0;return _I(a|0)|0}function n1(a,b,c){a=a|0;b=b|0;c=c|0;return $I(a|0)|0}function o1(a,b,c){a=a|0;b=b|0;c=c|0;return aJ(a|0)|0}function p1(a,b,c){a=a|0;b=b|0;c=c|0;return bJ(a|0)|0}function q1(a,b,c){a=a|0;b=b|0;c=c|0;return cJ(a|0)|0}function r1(a,b,c){a=a|0;b=b|0;c=c|0;return dJ(a|0)|0}function s1(a,b,c){a=a|0;b=b|0;c=c|0;return eJ(a|0)|0}function t1(a,b,c){a=a|0;b=b|0;c=c|0;return fJ(a|0)|0}function u1(a,b,c){a=a|0;b=b|0;c=c|0;return gJ(a|0)|0}function v1(a,b,c){a=a|0;b=b|0;c=c|0;return hJ(a|0)|0}function w1(a,b,c){a=a|0;b=b|0;c=c|0;return iJ(a|0)|0}function x1(a,b,c){a=a|0;b=b|0;c=c|0;return jJ(a|0)|0}function y1(a,b,c){a=a|0;b=b|0;c=c|0;return kJ(a|0)|0}function z1(a,b,c){a=a|0;b=b|0;c=c|0;return lJ(a|0)|0}function A1(a,b,c){a=a|0;b=b|0;c=c|0;return mJ(a|0)|0}function B1(a,b,c){a=a|0;b=b|0;c=c|0;return nJ(a|0)|0}function C1(a,b,c){a=a|0;b=b|0;c=c|0;return oJ(a|0)|0}function D1(a,b,c){a=a|0;b=b|0;c=c|0;return pJ(a|0)|0}function E1(a,b,c){a=a|0;b=b|0;c=c|0;return qJ(a|0)|0}function F1(a,b,c){a=a|0;b=b|0;c=c|0;return rJ(a|0)|0}function G1(a,b,c){a=a|0;b=b|0;c=c|0;return sJ(a|0)|0}function H1(a,b,c){a=a|0;b=b|0;c=c|0;return tJ(a|0)|0}function I1(a,b,c){a=a|0;b=b|0;c=c|0;return uJ(a|0)|0}function J1(a,b,c){a=a|0;b=b|0;c=c|0;return vJ(a|0)|0}function K1(a,b,c){a=a|0;b=b|0;c=c|0;return wJ(a|0)|0}function L1(a,b,c){a=a|0;b=b|0;c=c|0;return xJ(a|0)|0}function M1(a,b,c){a=a|0;b=b|0;c=c|0;return yJ(a|0)|0}function N1(a,b,c){a=a|0;b=b|0;c=c|0;return zJ(a|0)|0}function O1(a,b,c){a=a|0;b=b|0;c=c|0;return AJ(a|0)|0}function P1(a,b,c){a=a|0;b=b|0;c=c|0;return BJ(a|0)|0}function Q1(a,b,c){a=a|0;b=b|0;c=c|0;return CJ(a|0)|0}function R1(a,b,c){a=a|0;b=b|0;c=c|0;return DJ(a|0)|0}function S1(a,b,c){a=a|0;b=b|0;c=c|0;return EJ(a|0)|0}function T1(a,b,c){a=a|0;b=b|0;c=c|0;return FJ(a|0)|0}function U1(a,b,c){a=a|0;b=b|0;c=c|0;return GJ(a|0)|0}function V1(a,b,c){a=a|0;b=b|0;c=c|0;return HJ(a|0)|0}function W1(a,b,c){a=a|0;b=b|0;c=c|0;return IJ(a|0)|0}function X1(a,b,c){a=a|0;b=b|0;c=c|0;return JJ(a|0)|0}function Y1(a,b,c){a=a|0;b=b|0;c=c|0;return KJ(a|0)|0}function Z1(a,b,c){a=a|0;b=b|0;c=c|0;return LJ(a|0)|0}function _1(a,b,c){a=a|0;b=b|0;c=c|0;return MJ(a|0)|0}function $1(a,b,c){a=a|0;b=b|0;c=c|0;return NJ(a|0)|0}function a2(a,b,c){a=a|0;b=b|0;c=c|0;return OJ(a|0)|0}function b2(a,b,c){a=a|0;b=b|0;c=c|0;return PJ(a|0)|0}function c2(a,b,c){a=a|0;b=b|0;c=c|0;return QJ(a|0)|0}function d2(a,b,c){a=a|0;b=b|0;c=c|0;return RJ(a|0)|0}function e2(a,b,c){a=a|0;b=b|0;c=c|0;return SJ(a|0)|0}function f2(a,b,c){a=a|0;b=b|0;c=c|0;return TJ(a|0)|0}function g2(a,b,c){a=a|0;b=b|0;c=c|0;return UJ(a|0)|0}function h2(a,b,c){a=a|0;b=b|0;c=c|0;return VJ(a|0)|0}function i2(a,b,c){a=a|0;b=b|0;c=c|0;return WJ(a|0)|0}function j2(a,b,c){a=a|0;b=b|0;c=c|0;return XJ(a|0)|0}function k2(a,b,c){a=a|0;b=b|0;c=c|0;return YJ(a|0)|0}function l2(a,b,c){a=a|0;b=b|0;c=c|0;return ZJ(a|0)|0}function m2(a,b,c){a=a|0;b=b|0;c=c|0;return _J(a|0)|0}function n2(a,b,c){a=a|0;b=b|0;c=c|0;return $J(a|0)|0}function o2(a,b,c){a=a|0;b=b|0;c=c|0;return aK(a|0)|0}function p2(a,b,c){a=a|0;b=b|0;c=c|0;return bK(a|0)|0}function q2(a,b,c){a=a|0;b=b|0;c=c|0;return cK(a|0)|0}function r2(a,b,c){a=a|0;b=b|0;c=c|0;return dK(a|0)|0}function s2(a,b,c){a=a|0;b=b|0;c=c|0;return eK(a|0)|0}function t2(a,b,c){a=a|0;b=b|0;c=c|0;return fK(a|0)|0}function u2(a,b,c){a=a|0;b=b|0;c=c|0;return gK(a|0)|0}function v2(a,b,c){a=a|0;b=b|0;c=c|0;return hK(a|0)|0}function w2(a,b,c){a=a|0;b=b|0;c=c|0;return iK(a|0)|0}function x2(a,b,c){a=a|0;b=b|0;c=c|0;return jK(a|0)|0}function y2(a,b,c){a=a|0;b=b|0;c=c|0;return kK(a|0)|0}function z2(a,b,c){a=a|0;b=b|0;c=c|0;return lK(a|0)|0}function A2(a,b,c){a=a|0;b=b|0;c=c|0;return mK(a|0)|0}function B2(a,b,c){a=a|0;b=b|0;c=c|0;return nK(a|0)|0}function C2(a,b,c){a=a|0;b=b|0;c=c|0;return oK(a|0)|0}function D2(a,b,c){a=a|0;b=b|0;c=c|0;return pK(a|0)|0}function E2(a,b,c){a=a|0;b=b|0;c=c|0;return qK(a|0)|0}function F2(a,b,c){a=a|0;b=b|0;c=c|0;return rK(a|0)|0}function G2(a,b,c){a=a|0;b=b|0;c=c|0;return sK(a|0)|0}function H2(a,b,c){a=a|0;b=b|0;c=c|0;return tK(a|0)|0}function I2(a,b,c){a=a|0;b=b|0;c=c|0;return uK(a|0)|0}function J2(a,b,c){a=a|0;b=b|0;c=c|0;return vK(a|0)|0}function K2(a,b,c){a=a|0;b=b|0;c=c|0;return wK(a|0)|0}function L2(a,b,c){a=a|0;b=b|0;c=c|0;return xK(a|0)|0}function M2(a,b,c){a=a|0;b=b|0;c=c|0;return yK(a|0)|0}function N2(a,b,c){a=a|0;b=b|0;c=c|0;return zK(a|0)|0}function O2(a,b,c){a=a|0;b=b|0;c=c|0;return AK(a|0)|0}function P2(a,b,c){a=a|0;b=b|0;c=c|0;return BK(a|0)|0}function Q2(a,b,c){a=a|0;b=b|0;c=c|0;return CK(a|0)|0}function R2(a,b,c){a=a|0;b=b|0;c=c|0;return DK(a|0)|0}function S2(a,b,c){a=a|0;b=b|0;c=c|0;return EK(a|0)|0}function T2(a,b,c){a=a|0;b=b|0;c=c|0;return FK(a|0)|0}function U2(a,b,c){a=a|0;b=b|0;c=c|0;return GK(a|0)|0}function V2(a,b,c){a=a|0;b=b|0;c=c|0;return HK(a|0)|0}function W2(a,b,c){a=a|0;b=b|0;c=c|0;return IK(a|0)|0}function X2(a,b,c){a=a|0;b=b|0;c=c|0;return JK(a|0)|0}function Y2(a,b,c){a=a|0;b=b|0;c=c|0;return KK(a|0)|0}function Z2(a,b,c){a=a|0;b=b|0;c=c|0;return LK(a|0)|0}function _2(a,b,c){a=a|0;b=b|0;c=c|0;return MK(a|0)|0}function $2(a,b,c){a=a|0;b=b|0;c=c|0;return NK(a|0)|0}function a3(a,b,c){a=a|0;b=b|0;c=c|0;return OK(a|0)|0}function b3(a,b,c){a=a|0;b=b|0;c=c|0;return PK(a|0)|0}function c3(a,b,c){a=a|0;b=b|0;c=c|0;return QK(a|0)|0}function d3(a,b,c){a=a|0;b=b|0;c=c|0;return RK(a|0)|0}function e3(a,b,c){a=a|0;b=b|0;c=c|0;return SK(a|0)|0}function f3(a,b,c){a=a|0;b=b|0;c=c|0;return TK(a|0)|0}function g3(a,b,c){a=a|0;b=b|0;c=c|0;return UK(a|0)|0}function h3(a,b,c){a=a|0;b=b|0;c=c|0;return VK(a|0)|0}function i3(a,b,c){a=a|0;b=b|0;c=c|0;return WK(a|0)|0}function j3(a,b,c){a=a|0;b=b|0;c=c|0;return XK(a|0)|0}function k3(a,b,c){a=a|0;b=b|0;c=c|0;return YK(a|0)|0}function l3(a,b,c){a=a|0;b=b|0;c=c|0;return ZK(a|0)|0}function m3(a,b,c){a=a|0;b=b|0;c=c|0;return _K(a|0)|0}function n3(a,b,c){a=a|0;b=b|0;c=c|0;return $K(a|0)|0}function o3(a,b,c){a=a|0;b=b|0;c=c|0;return aL(a|0)|0}function p3(a,b,c){a=a|0;b=b|0;c=c|0;return bL(a|0)|0}function q3(a,b,c){a=a|0;b=b|0;c=c|0;return cL(a|0)|0}function r3(a,b,c){a=a|0;b=b|0;c=c|0;return dL(a|0)|0}function s3(a,b,c){a=a|0;b=b|0;c=c|0;return eL(a|0)|0}function t3(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function u3(a,b,c){a=a|0;b=b|0;c=c|0;return Wb(a|0)|0}function v3(a,b,c){a=a|0;b=b|0;c=c|0;return Xb(a|0,b|0)|0}function w3(a,b,c){a=a|0;b=b|0;c=c|0;return Yb(a|0)|0}function x3(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function y3(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function z3(a,b,c){a=a|0;b=b|0;c=c|0;return Ka(a|0,b|0,c|0)|0}function A3(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function B3(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function C3(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function D3(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function E3(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function F3(a,b,c){a=a|0;b=b|0;c=c|0;return nc(a|0)|0}function G3(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function H3(a,b,c){a=a|0;b=b|0;c=c|0;return nd(a|0)|0}function I3(a,b,c){a=a|0;b=b|0;c=c|0;return Kd(a|0,b|0,c|0,0)|0}function J3(a,b,c){a=a|0;b=b|0;c=c|0;return Ld(a|0,b|0,c|0,0)|0}function K3(a,b,c){a=a|0;b=b|0;c=c|0;return Md(a|0,b|0,c|0,0)|0}function L3(a,b,c){a=a|0;b=b|0;c=c|0;return Nd(a|0,b|0,c|0,0)|0}function M3(a,b,c){a=a|0;b=b|0;c=c|0;return Od(a|0,b|0,c|0,0)|0}function N3(a,b,c){a=a|0;b=b|0;c=c|0;return Pd(a|0,b|0,c|0,0)|0}function O3(a,b,c){a=a|0;b=b|0;c=c|0;return qd(a|0,b|0,c|0,0)|0}function P3(a,b,c){a=a|0;b=b|0;c=c|0;return rd(a|0,b|0,c|0,0)|0}function Q3(a,b,c){a=a|0;b=b|0;c=c|0;return Qd(a|0,b|0,c|0,0)|0}function R3(a,b,c){a=a|0;b=b|0;c=c|0;return Rd(a|0,b|0,c|0,0)|0}function S3(a,b,c){a=a|0;b=b|0;c=c|0;return fo(a|0,b|0,c|0,0)|0}function T3(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function U3(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function V3(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function W3(a,b,c){a=a|0;b=b|0;c=c|0;return mk()|0}function X3(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function Y3(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function Z3(a,b,c){a=a|0;b=b|0;c=c|0;return nk(a|0)|0}function _3(a,b,c){a=a|0;b=b|0;c=c|0;return ok(a|0)|0}function $3(a,b,c){a=a|0;b=b|0;c=c|0;return qk(a|0)|0}function a4(a,b,c){a=a|0;b=b|0;c=c|0;return _k(a|0)|0}function b4(a,b,c){a=a|0;b=b|0;c=c|0;return bl(a|0)|0}function c4(a,b,c){a=a|0;b=b|0;c=c|0;return dl(a|0)|0}function d4(a,b,c){a=a|0;b=b|0;c=c|0;return gl(a|0,b|0,c|0,0)|0}function e4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function f4(a,b,c){a=a|0;b=b|0;c=c|0;return on(a|0)|0}function g4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function h4(a,b,c){a=a|0;b=b|0;c=c|0;return vn(a|0)|0}function i4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function j4(a,b,c){a=a|0;b=b|0;c=c|0;return yn(a|0)|0}function k4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function l4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function m4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function n4(a,b,c){a=a|0;b=b|0;c=c|0;return Cn(a|0,b|0)|0}function o4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function p4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function q4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function r4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function s4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function t4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function u4(a,b,c){a=a|0;b=b|0;c=c|0;return _n(a|0,b|0)|0}function v4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function w4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function x4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function y4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function z4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function A4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function B4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function C4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function D4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function E4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function F4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function G4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function H4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function I4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function J4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function K4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function L4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function M4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function N4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function O4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function P4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function Q4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function R4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function S4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function T4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function U4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function V4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function W4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function X4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function Y4(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function Z4(a,b,c){a=a|0;b=b|0;c=c|0;return ds(a|0,b|0)|0}function _4(a,b,c){a=a|0;b=b|0;c=c|0;return es(a|0,b|0)|0}function $4(a,b,c){a=a|0;b=b|0;c=c|0;return js(a|0,b|0)|0}function a5(a,b,c){a=a|0;b=b|0;c=c|0;return wu(a|0,b|0)|0}function b5(a,b,c){a=a|0;b=b|0;c=c|0;return $r(a|0,b|0)|0}function c5(a,b,c){a=a|0;b=b|0;c=c|0;return as(a|0,b|0)|0}function d5(a,b,c){a=a|0;b=b|0;c=c|0;return bs(a|0,b|0)|0}function e5(a,b,c){a=a|0;b=b|0;c=c|0;return hs(a|0,b|0)|0}function f5(a,b,c){a=a|0;b=b|0;c=c|0;return fs(a|0,b|0)|0}function g5(a,b,c){a=a|0;b=b|0;c=c|0;return is(a|0,b|0)|0}function h5(a,b,c){a=a|0;b=b|0;c=c|0;return cs(a|0,b|0)|0}function i5(a,b,c){a=a|0;b=b|0;c=c|0;return xu(a|0,b|0)|0}function j5(a,b,c){a=a|0;b=b|0;c=c|0;return gs(a|0,b|0)|0}function k5(a,b,c){a=a|0;b=b|0;c=c|0;return _r(a|0,b|0)|0}function l5(a,b,c){a=a|0;b=b|0;c=c|0;return dr(a|0,b|0)|0}function m5(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function n5(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function o5(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function p5(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function q5(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function r5(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function s5(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function t5(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function u5(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function v5(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function w5(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function x5(a,b,c){a=a|0;b=b|0;c=c|0;return $x(a|0,b|0)|0}function y5(a,b,c){a=a|0;b=b|0;c=c|0;
return dy(a|0,b|0)|0}function z5(a,b,c){a=a|0;b=b|0;c=c|0;return fy(a|0,b|0)|0}function A5(a,b,c){a=a|0;b=b|0;c=c|0;return jy(a|0,b|0)|0}function B5(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function C5(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function D5(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function E5(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function F5(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function G5(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function H5(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function I5(a,b,c){a=a|0;b=b|0;c=c|0;return RB(a|0)|0}function J5(a,b,c){a=a|0;b=b|0;c=c|0;return SB(a|0)|0}function K5(a,b,c){a=a|0;b=b|0;c=c|0;return TB(a|0)|0}function L5(a,b,c){a=a|0;b=b|0;c=c|0;return VB(a|0,b|0)|0}function M5(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function N5(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function O5(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function P5(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function Q5(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function R5(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function S5(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function T5(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function U5(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function V5(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function W5(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function X5(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function Y5(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function Z5(a,b,c){a=a|0;b=b|0;c=c|0;return hC(a|0,b|0)|0}function _5(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function $5(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function a6(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function b6(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function c6(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function d6(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function e6(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function f6(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function g6(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function h6(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function i6(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function j6(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function k6(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function l6(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function m6(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function n6(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function o6(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function p6(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function q6(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function r6(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function s6(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function t6(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function u6(a,b,c){a=a|0;b=b|0;c=c|0;return nN(a|0,b|0)|0}function v6(a,b,c){a=a|0;b=b|0;c=c|0;return oN(a|0,b|0,c|0,0,0)|0}function w6(a,b,c){a=a|0;b=b|0;c=c|0;return pN(a|0,b|0,c|0,0,0,0,0)|0}function x6(a,b,c){a=a|0;b=b|0;c=c|0;return qN(a|0,b|0,c|0,0,0,0)|0}function y6(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function z6(a,b,c){a=a|0;b=b|0;c=c|0;return tN(a|0,b|0)|0}function A6(a,b,c){a=a|0;b=b|0;c=c|0;return uN(a|0,b|0,c|0,0,0)|0}function B6(a,b,c){a=a|0;b=b|0;c=c|0;return vN(a|0,b|0,c|0,0,0,0,0)|0}function C6(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function D6(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function E6(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function F6(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function G6(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function H6(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function I6(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function J6(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function K6(a,b,c){a=a|0;b=b|0;c=c|0;return 0}function L6(a,b,c){a=a|0;b=b|0;c=c|0;return WR(a|0,b|0,c|0,0)|0}function M6(a,b,c){a=a|0;b=b|0;c=c|0;return QS(a|0,b|0)|0}function N6(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;da(2)}function O6(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;uc(a|0,b|0,c|0,d|0)}function P6(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;vc(a|0)|0}function Q6(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;wc(a|0)|0}function R6(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;xc(a|0)|0}function S6(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;yc(a|0,b|0,c|0)|0}function T6(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;zc(a|0,b|0)|0}function U6(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Ac(a|0,b|0,c|0,d|0,e|0,f|0)}function V6(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Bc(a|0,b|0,c|0,d|0)}function W6(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Dc(a|0,b|0,c|0,d|0)}function X6(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Ec(a|0,b|0,c|0,d|0,e|0)}function Y6(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Fc(a|0,b|0)}function Z6(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Gc(a|0)}function _6(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Hc(a|0)}function $6(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Wc(a|0,b|0,c|0)}function a7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Xc(a|0,b|0)}function b7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Ic(a|0,b|0)}function c7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Jc(a|0,b|0,c|0)}function d7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Kc(a|0,b|0,c|0)}function e7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Lc(a|0,b|0,c|0)}function f7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Mc(a|0,b|0)}function g7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Nc(a|0,b|0,c|0)}function h7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Oc(a|0,b|0,c|0)}function i7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Pc(a|0,b|0,c|0)}function j7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Qc(a|0,b|0)|0}function k7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Rc(a|0,b|0,c|0)}function l7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Sc(a|0,b|0,c|0,d|0)}function m7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Tc(a|0,b|0,c|0,d|0,e|0,f|0,g|0,0,0)}function n7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Uc(a|0,b|0,c|0,d|0)}function o7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Xk(a|0,b|0,c|0)|0}function p7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;jT(a|0)}function q7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;iT(a|0)|0}function r7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;kT(a|0,b|0)|0}function s7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;my(a|0)|0}function t7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Td(a|0,b|0,c|0)}function u7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;SP(a|0,b|0,c|0,d|0)}function v7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;PP(a|0)|0}function w7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;QP(a|0)|0}function x7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;RP(a|0)|0}function y7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;UP(a|0,b|0,c|0)|0}function z7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;VP(a|0,b|0)|0}function A7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;XP(a|0,b|0,c|0,d|0,e|0,f|0)}function B7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;_P(a|0,b|0,c|0,d|0)}function C7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ZP(a|0,b|0,c|0,d|0)}function D7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;$P(a|0,b|0,c|0,d|0,e|0)}function E7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;aQ(a|0,b|0)}function F7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;bQ(a|0)}function G7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;cQ(a|0)}function H7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;dQ(a|0,b|0,c|0)}function I7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;eQ(a|0,b|0)}function J7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;hQ(a|0,b|0)}function K7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;iQ(a|0,b|0,c|0)}function L7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;kQ(a|0,b|0,c|0)}function M7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;lQ(a|0,b|0)}function N7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;$d(a|0,b|0,c|0)}function O7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;_d(a|0,b|0,c|0)}function P7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;WP(a|0,b|0)|0}function Q7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;mQ(a|0,b|0,c|0)}function R7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;TP(a|0,b|0,c|0,d|0)}function S7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;LP(a|0)|0}function T7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;MP(a|0)|0}function U7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;NP(a|0)|0}function V7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;OP(a|0)|0}function W7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;jQ(a|0,b|0,c|0)}function X7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;NI(a|0)|0}function Y7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;OI(a|0)|0}function Z7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;PI(a|0)|0}function _7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;QI(a|0)|0}function $7(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;RI(a|0)|0}function a8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;SI(a|0)|0}function b8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;TI(a|0)|0}function c8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;UI(a|0)|0}function d8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;VI(a|0)|0}function e8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;WI(a|0)|0}function f8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;XI(a|0)|0}function g8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;YI(a|0)|0}function h8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ZI(a|0)|0}function i8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;_I(a|0)|0}function j8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;$I(a|0)|0}function k8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;aJ(a|0)|0}function l8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;bJ(a|0)|0}function m8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;cJ(a|0)|0}function n8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;dJ(a|0)|0}function o8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;eJ(a|0)|0}function p8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;fJ(a|0)|0}function q8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;gJ(a|0)|0}function r8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;hJ(a|0)|0}function s8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;iJ(a|0)|0}function t8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;jJ(a|0)|0}function u8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;kJ(a|0)|0}function v8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;lJ(a|0)|0}function w8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;mJ(a|0)|0}function x8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;nJ(a|0)|0}function y8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;oJ(a|0)|0}function z8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;pJ(a|0)|0}function A8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;qJ(a|0)|0}function B8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;rJ(a|0)|0}function C8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;sJ(a|0)|0}function D8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;tJ(a|0)|0}function E8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;uJ(a|0)|0}function F8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;vJ(a|0)|0}function G8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;wJ(a|0)|0}function H8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;xJ(a|0)|0}function I8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;yJ(a|0)|0}function J8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;zJ(a|0)|0}function K8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;AJ(a|0)|0}function L8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;BJ(a|0)|0}function M8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;CJ(a|0)|0}function N8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;DJ(a|0)|0}function O8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;EJ(a|0)|0}function P8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;FJ(a|0)|0}function Q8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;GJ(a|0)|0}function R8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;HJ(a|0)|0}function S8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;IJ(a|0)|0}function T8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;JJ(a|0)|0}function U8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;KJ(a|0)|0}function V8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;LJ(a|0)|0}function W8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;MJ(a|0)|0}function X8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;NJ(a|0)|0}function Y8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;OJ(a|0)|0}function Z8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;PJ(a|0)|0}function _8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;QJ(a|0)|0}function $8(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;RJ(a|0)|0}function a9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;SJ(a|0)|0}function b9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;TJ(a|0)|0}function c9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;UJ(a|0)|0}function d9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;VJ(a|0)|0}function e9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;WJ(a|0)|0}function f9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;XJ(a|0)|0}function g9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;YJ(a|0)|0}function h9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ZJ(a|0)|0}function i9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;_J(a|0)|0}function j9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;$J(a|0)|0}function k9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;aK(a|0)|0}function l9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;bK(a|0)|0}function m9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;cK(a|0)|0}function n9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;dK(a|0)|0}function o9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;eK(a|0)|0}function p9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;fK(a|0)|0}function q9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;gK(a|0)|0}function r9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;hK(a|0)|0}function s9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;iK(a|0)|0}function t9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;jK(a|0)|0}function u9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;kK(a|0)|0}function v9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;lK(a|0)|0}function w9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;mK(a|0)|0}function x9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;nK(a|0)|0}function y9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;oK(a|0)|0}function z9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;pK(a|0)|0}function A9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;qK(a|0)|0}function B9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;rK(a|0)|0}function C9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;sK(a|0)|0}function D9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;tK(a|0)|0}function E9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;uK(a|0)|0}function F9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;vK(a|0)|0}function G9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;wK(a|0)|0}function H9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;xK(a|0)|0}function I9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;yK(a|0)|0}function J9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;zK(a|0)|0}function K9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;AK(a|0)|0}function L9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;BK(a|0)|0}function M9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;CK(a|0)|0}function N9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;DK(a|0)|0}function O9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;EK(a|0)|0}function P9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;FK(a|0)|0}function Q9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;GK(a|0)|0}function R9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;HK(a|0)|0}function S9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;IK(a|0)|0}function T9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;JK(a|0)|0}function U9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;KK(a|0)|0}function V9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;LK(a|0)|0}function W9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;MK(a|0)|0}function X9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;NK(a|0)|0}function Y9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;OK(a|0)|0}function Z9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;PK(a|0)|0}function _9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;QK(a|0)|0}function $9(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;RK(a|0)|0}function aaa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;SK(a|0)|0}function baa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;TK(a|0)|0}function caa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;UK(a|0)|0}function daa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;VK(a|0)|0}function eaa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;WK(a|0)|0}function faa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;XK(a|0)|0}function gaa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;YK(a|0)|0}function haa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ZK(a|0)|0}function iaa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;_K(a|0)|0}function jaa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;$K(a|0)|0}function kaa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;aL(a|0)|0}function laa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;bL(a|0)|0}function maa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;cL(a|0)|0}function naa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;dL(a|0)|0}function oaa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;eL(a|0)|0}function paa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;RT(a|0,b|0,c|0)|0}function qaa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Vb(a|0)}function raa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Wb(a|0)|0}function saa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Xb(a|0,b|0)|0}function taa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Yb(a|0)|0}function uaa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Wk(a|0,b|0,c|0)|0}function vaa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;_b(a|0)}function waa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;$b(a|0)}function xaa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ac(a|0,b|0,c|0)|0}function yaa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Ka(a|0,b|0,c|0)|0}function zaa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;gc(a|0,b|0,c|0)|0}function Aaa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;hc(a|0)}function Baa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ic(a|0,b|0,c|0)}function Caa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;jc(a|0,b|0,c|0)}function Daa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;kc(a|0,b|0,c|0)}function Eaa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;lc(a|0,b|0,c|0)}function Faa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;nc(a|0)|0}function Gaa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;md(a|0,b|0)}function Haa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;nd(a|0)|0}function Iaa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Kd(a|0,b|0,c|0,d|0)|0}function Jaa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Ld(a|0,b|0,c|0,d|0)|0}function Kaa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Md(a|0,b|0,c|0,d|0)|0}function Laa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Nd(a|0,b|0,c|0,d|0)|0}function Maa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Od(a|0,b|0,c|0,d|0)|0}function Naa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Pd(a|0,b|0,c|0,d|0)|0}function Oaa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;qd(a|0,b|0,c|0,d|0)|0}function Paa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;rd(a|0,b|0,c|0,d|0)|0}function Qaa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Qd(a|0,b|0,c|0,d|0)|0}function Raa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Rd(a|0,b|0,c|0,d|0)|0}function Saa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;fo(a|0,b|0,c|0,d|0)|0}function Taa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ae(a|0,b|0,c|0)}function Uaa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;be(a|0,b|0,c|0)}function Vaa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;tg(a|0)}function Waa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;mk()|0}function Xaa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;sh(a|0,b|0,c|0,d|0,e|0)}function Yaa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;gk(a|0,b|0,c|0,d|0,e|0)}function Zaa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;nk(a|0)|0}function _aa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ok(a|0)|0}function $aa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;pk(a|0,b|0,c|0)|0}function aba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;qk(a|0)|0}function bba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;_k(a|0)|0}function cba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;$k(a|0,b|0,c|0)|0}function dba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;bl(a|0)|0}function eba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;cl(a|0,b|0,c|0)|0}function fba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;dl(a|0)|0}function gba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;el(a|0,b|0,c|0)|0}function hba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;fl(a|0,b|0,c|0)|0}function iba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;gl(a|0,b|0,c|0,d|0)|0}function jba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;nn(a|0)}function kba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;on(a|0)|0}function lba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;sn(a|0)}function mba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;vn(a|0)|0}function nba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;xn(a|0)}function oba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;yn(a|0)|0}function pba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;zn(a|0,b|0)}function qba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;An(a|0)}function rba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Bn(a|0)}function sba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Cn(a|0,b|0)|0}function tba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Dn(a|0)}function uba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;In(a|0,b|0,c|0)}function vba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Rn(a|0,b|0,c|0)}function wba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Sn(a|0,b|0,c|0)}function xba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Tn(a|0,b|0,c|0)}function yba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Un(a|0,b|0,c|0)}function zba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;_n(a|0,b|0)|0}function Aba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;tq(a|0,b|0)}function Bba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Qq(a|0)}function Cba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Bs(a|0,b|0)}function Dba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Is(a|0,b|0)}function Eba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ns(a|0,b|0)}function Fba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ts(a|0,b|0)}function Gba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;us(a|0,b|0)}function Hba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;os(a|0,b|0)}function Iba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Es(a|0,b|0)}function Jba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Hs(a|0,b|0)}function Kba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ls(a|0,b|0)}function Lba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Fs(a|0,b|0)}function Mba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ps(a|0,b|0)}function Nba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Cs(a|0,b|0)}function Oba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;nt(a|0,b|0)}function Pba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;qs(a|0,b|0)}function Qba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;zs(a|0,b|0)}function Rba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Tr(a|0,b|0)}function Sba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ms(a|0,b|0)}function Tba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Js(a|0,b|0)}function Uba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;rs(a|0,b|0)}function Vba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ss(a|0,b|0)}function Wba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;vs(a|0,b|0)}function Xba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ws(a|0,b|0)}function Yba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;xs(a|0,b|0)}function Zba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ys(a|0,b|0)}function _ba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Gs(a|0,b|0)}function $ba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Ds(a|0,b|0)}function aca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;As(a|0,b|0)}function bca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ot(a|0,b|0)}function cca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;uu(a|0,b|0,c|0)|0}function dca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ds(a|0,b|0)|0}function eca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;es(a|0,b|0)|0}function fca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;js(a|0,b|0)|0}function gca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;vu(a|0,b|0,c|0)|0}function hca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;wu(a|0,b|0)|0}function ica(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;$r(a|0,b|0)|0}function jca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;as(a|0,b|0)|0}function kca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;bs(a|0,b|0)|0}function lca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;hs(a|0,b|0)|0}function mca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;fs(a|0,b|0)|0}function nca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;is(a|0,b|0)|0}function oca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;cs(a|0,b|0)|0}function pca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;xu(a|0,b|0)|0}function qca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;gs(a|0,b|0)|0}function rca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;_r(a|0,b|0)|0}function sca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;dr(a|0,b|0)|0}function tca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;jv(a|0,b|0)}function uca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;pv(a|0,b|0)}function vca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;qv(a|0,b|0)}function wca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;rv(a|0,b|0)}function xca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;sv(a|0,b|0)}function yca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;tv(a|0,b|0)}function zca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;uv(a|0,b|0)}function Aca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;vv(a|0,b|0)}function Bca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;tw(a|0,b|0,c|0)}function Cca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Mw(a|0)}function Dca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Yw(a|0)}function Eca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Kx(a|0,b|0,c|0)|0}function Fca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;$x(a|0,b|0)|0}function Gca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;dy(a|0,b|0)|0}function Hca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;fy(a|0,b|0)|0}function Ica(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;jy(a|0,b|0)|0}function Jca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;qB(a|0)}function Kca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;LB(a|0,b|0,c|0,d|0,e|0,f|0,g|0,0,0)}function Lca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;MB(a|0,b|0,c|0,d|0)}function Mca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;NB(a|0,b|0,c|0)}function Nca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;OB(a|0,b|0,c|0)}function Oca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;PB(a|0,b|0)}function Pca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;QB(a|0,b|0,c|0,d|0)}function Qca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;RB(a|0)|0}function Rca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;SB(a|0)|0}function Sca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;TB(a|0)|0}function Tca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;UB(a|0,b|0,c|0)|0}function Uca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;VB(a|0,b|0)|0}function Vca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;WB(a|0,b|0,c|0,d|0,e|0,f|0)}function Wca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;XB(a|0,b|0,c|0,d|0)}function Xca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ZB(a|0,b|0,c|0,d|0)}function Yca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;_B(a|0,b|0,c|0,d|0,e|0)}function Zca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;$B(a|0,b|0)}function _ca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;aC(a|0)}function $ca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;bC(a|0)}function ada(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;cC(a|0,b|0,c|0)}function bda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;dC(a|0,b|0)}function cda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;eC(a|0,b|0,c|0)}function dda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;fC(a|0,b|0,c|0)}function eda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;gC(a|0,b|0,c|0)}function fda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;hC(a|0,b|0)|0}function gda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;iC(a|0,b|0,c|0,d|0)}function hda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;jC(a|0,b|0,c|0)}function ida(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;
g=g|0;kC(a|0,b|0,c|0)}function jda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;lC(a|0,b|0,c|0)}function kda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;mC(a|0,b|0)}function lda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;nC(a|0,b|0,c|0,d|0,e|0,f|0,g|0,0,0)}function mda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;oC(a|0,b|0,c|0,d|0)}function nda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;rC(a|0,b|0,c|0)|0}function oda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;uC(a|0)}function pda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;AD(a|0,b|0)}function qda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;lF(a|0,b|0,c|0,d|0)}function rda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;uF(a|0,b|0)}function sda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;VA(a|0)}function tda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;wM(a|0,b|0,c|0)}function uda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;xM(a|0,b|0)}function vda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;yM(a|0,b|0,c|0,d|0,e|0,f|0,g|0,0,0)}function wda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;zM(a|0,b|0,c|0,d|0)}function xda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;AM(a|0,b|0,c|0)}function yda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;BM(a|0,b|0,c|0)}function zda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;DM(a|0,b|0,c|0)}function Ada(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;EM(a|0,b|0,c|0)}function Bda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;GM(a|0,b|0,c|0)|0}function Cda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;FM(a|0,b|0)}function Dda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;UM(a|0)}function Eda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;nN(a|0,b|0)|0}function Fda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;oN(a|0,b|0,c|0,d|0,e|0)|0}function Gda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;pN(a|0,b|0,c|0,d|0,e|0,f|0,g|0)|0}function Hda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;qN(a|0,b|0,c|0,d|0,e|0,f|0)|0}function Ida(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;rN(a|0,b|0)}function Jda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;tN(a|0,b|0)|0}function Kda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;uN(a|0,b|0,c|0,d|0,e|0)|0}function Lda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;vN(a|0,b|0,c|0,d|0,e|0,f|0,g|0)|0}function Mda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;wN(a|0,b|0)}function Nda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;CN(a|0,b|0,c|0)}function Oda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;GN(a|0,b|0,c|0,d|0)}function Pda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;vO(a|0,b|0,c|0)}function Qda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;wO(a|0,b|0,c|0)}function Rda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;fP(a|0,b|0,c|0,d|0)}function Sda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;sP(a|0,b|0,c|0)}function Tda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;fQ(a|0,b|0,c|0,d|0,e|0,f|0,g|0,0,0)}function Uda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;gQ(a|0,b|0,c|0,d|0)}function Vda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;WR(a|0,b|0,c|0,d|0)|0}function Wda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;QS(a|0,b|0)|0}function Xda(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;hT(a|0,b|0,c|0)|0}function Yda(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;da(3)}function Zda(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;uc(a|0,b|0,c|0,d|0)}function _da(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;vc(a|0)|0}function $da(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;wc(a|0)|0}function aea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;xc(a|0)|0}function bea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;yc(a|0,b|0,c|0)|0}function cea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;zc(a|0,b|0)|0}function dea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ac(a|0,b|0,c|0,d|0,e|0,0)}function eea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Bc(a|0,b|0,c|0,d|0)}function fea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Cc(a|0,b|0,c|0,d|0,e|0,0,0)}function gea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Dc(a|0,b|0,c|0,d|0)}function hea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Fc(a|0,b|0)}function iea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Gc(a|0)}function jea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Hc(a|0)}function kea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Wc(a|0,b|0,c|0)}function lea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Xc(a|0,b|0)}function mea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ic(a|0,b|0)}function nea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Jc(a|0,b|0,c|0)}function oea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Kc(a|0,b|0,c|0)}function pea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Lc(a|0,b|0,c|0)}function qea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Mc(a|0,b|0)}function rea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Nc(a|0,b|0,c|0)}function sea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Oc(a|0,b|0,c|0)}function tea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Pc(a|0,b|0,c|0)}function uea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Qc(a|0,b|0)|0}function vea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Rc(a|0,b|0,c|0)}function wea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Sc(a|0,b|0,c|0,d|0)}function xea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Tc(a|0,b|0,c|0,d|0,e|0,0,0,0,0)}function yea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Uc(a|0,b|0,c|0,d|0)}function zea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Xk(a|0,b|0,c|0)|0}function Aea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;jT(a|0)}function Bea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;iT(a|0)|0}function Cea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;kT(a|0,b|0)|0}function Dea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;my(a|0)|0}function Eea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Td(a|0,b|0,c|0)}function Fea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;SP(a|0,b|0,c|0,d|0)}function Gea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;PP(a|0)|0}function Hea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;QP(a|0)|0}function Iea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;RP(a|0)|0}function Jea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;UP(a|0,b|0,c|0)|0}function Kea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;VP(a|0,b|0)|0}function Lea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;XP(a|0,b|0,c|0,d|0,e|0,0)}function Mea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;_P(a|0,b|0,c|0,d|0)}function Nea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;YP(a|0,b|0,c|0,d|0,e|0,0,0)}function Oea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ZP(a|0,b|0,c|0,d|0)}function Pea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;aQ(a|0,b|0)}function Qea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;bQ(a|0)}function Rea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;cQ(a|0)}function Sea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;dQ(a|0,b|0,c|0)}function Tea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;eQ(a|0,b|0)}function Uea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;hQ(a|0,b|0)}function Vea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;iQ(a|0,b|0,c|0)}function Wea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;kQ(a|0,b|0,c|0)}function Xea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;lQ(a|0,b|0)}function Yea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;$d(a|0,b|0,c|0)}function Zea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;_d(a|0,b|0,c|0)}function _ea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;WP(a|0,b|0)|0}function $ea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;mQ(a|0,b|0,c|0)}function afa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;TP(a|0,b|0,c|0,d|0)}function bfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;LP(a|0)|0}function cfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;MP(a|0)|0}function dfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;NP(a|0)|0}function efa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;OP(a|0)|0}function ffa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;jQ(a|0,b|0,c|0)}function gfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;NI(a|0)|0}function hfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;OI(a|0)|0}function ifa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;PI(a|0)|0}function jfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;QI(a|0)|0}function kfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;RI(a|0)|0}function lfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;SI(a|0)|0}function mfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;TI(a|0)|0}function nfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;UI(a|0)|0}function ofa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;VI(a|0)|0}function pfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;WI(a|0)|0}function qfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;XI(a|0)|0}function rfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;YI(a|0)|0}function sfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ZI(a|0)|0}function tfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;_I(a|0)|0}function ufa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;$I(a|0)|0}function vfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;aJ(a|0)|0}function wfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;bJ(a|0)|0}function xfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;cJ(a|0)|0}function yfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;dJ(a|0)|0}function zfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;eJ(a|0)|0}function Afa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;fJ(a|0)|0}function Bfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;gJ(a|0)|0}function Cfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;hJ(a|0)|0}function Dfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;iJ(a|0)|0}function Efa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;jJ(a|0)|0}function Ffa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;kJ(a|0)|0}function Gfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;lJ(a|0)|0}function Hfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;mJ(a|0)|0}function Ifa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;nJ(a|0)|0}function Jfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;oJ(a|0)|0}function Kfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;pJ(a|0)|0}function Lfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;qJ(a|0)|0}function Mfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;rJ(a|0)|0}function Nfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;sJ(a|0)|0}function Ofa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;tJ(a|0)|0}function Pfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;uJ(a|0)|0}function Qfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;vJ(a|0)|0}function Rfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;wJ(a|0)|0}function Sfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;xJ(a|0)|0}function Tfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;yJ(a|0)|0}function Ufa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;zJ(a|0)|0}function Vfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;AJ(a|0)|0}function Wfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;BJ(a|0)|0}function Xfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;CJ(a|0)|0}function Yfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;DJ(a|0)|0}function Zfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;EJ(a|0)|0}function _fa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;FJ(a|0)|0}function $fa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;GJ(a|0)|0}function aga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;HJ(a|0)|0}function bga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;IJ(a|0)|0}function cga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;JJ(a|0)|0}function dga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;KJ(a|0)|0}function ega(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;LJ(a|0)|0}function fga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;MJ(a|0)|0}function gga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;NJ(a|0)|0}function hga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;OJ(a|0)|0}function iga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;PJ(a|0)|0}function jga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;QJ(a|0)|0}function kga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;RJ(a|0)|0}function lga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;SJ(a|0)|0}function mga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;TJ(a|0)|0}function nga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;UJ(a|0)|0}function oga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;VJ(a|0)|0}function pga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;WJ(a|0)|0}function qga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;XJ(a|0)|0}function rga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;YJ(a|0)|0}function sga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ZJ(a|0)|0}function tga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;_J(a|0)|0}function uga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;$J(a|0)|0}function vga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;aK(a|0)|0}function wga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;bK(a|0)|0}function xga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;cK(a|0)|0}function yga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;dK(a|0)|0}function zga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;eK(a|0)|0}function Aga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;fK(a|0)|0}function Bga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;gK(a|0)|0}function Cga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;hK(a|0)|0}function Dga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;iK(a|0)|0}function Ega(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;jK(a|0)|0}function Fga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;kK(a|0)|0}function Gga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;lK(a|0)|0}function Hga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;mK(a|0)|0}function Iga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;nK(a|0)|0}function Jga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;oK(a|0)|0}function Kga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;pK(a|0)|0}function Lga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;qK(a|0)|0}function Mga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;rK(a|0)|0}function Nga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;sK(a|0)|0}function Oga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;tK(a|0)|0}function Pga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;uK(a|0)|0}function Qga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;vK(a|0)|0}function Rga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;wK(a|0)|0}function Sga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;xK(a|0)|0}function Tga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;yK(a|0)|0}function Uga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;zK(a|0)|0}function Vga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;AK(a|0)|0}function Wga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;BK(a|0)|0}function Xga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;CK(a|0)|0}function Yga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;DK(a|0)|0}function Zga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;EK(a|0)|0}function _ga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;FK(a|0)|0}function $ga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;GK(a|0)|0}function aha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;HK(a|0)|0}function bha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;IK(a|0)|0}function cha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;JK(a|0)|0}function dha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;KK(a|0)|0}function eha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;LK(a|0)|0}function fha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;MK(a|0)|0}function gha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;NK(a|0)|0}function hha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;OK(a|0)|0}function iha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;PK(a|0)|0}function jha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;QK(a|0)|0}function kha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;RK(a|0)|0}function lha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;SK(a|0)|0}function mha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;TK(a|0)|0}function nha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;UK(a|0)|0}function oha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;VK(a|0)|0}function pha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;WK(a|0)|0}function qha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;XK(a|0)|0}function rha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;YK(a|0)|0}function sha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ZK(a|0)|0}function tha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;_K(a|0)|0}function uha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;$K(a|0)|0}function vha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;aL(a|0)|0}function wha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;bL(a|0)|0}function xha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;cL(a|0)|0}function yha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;dL(a|0)|0}function zha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;eL(a|0)|0}function Aha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;RT(a|0,b|0,c|0)|0}function Bha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Vb(a|0)}function Cha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Wb(a|0)|0}function Dha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Xb(a|0,b|0)|0}function Eha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Yb(a|0)|0}function Fha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Wk(a|0,b|0,c|0)|0}function Gha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;_b(a|0)}function Hha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;$b(a|0)}function Iha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ac(a|0,b|0,c|0)|0}function Jha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ka(a|0,b|0,c|0)|0}function Kha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;gc(a|0,b|0,c|0)|0}function Lha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;hc(a|0)}function Mha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ic(a|0,b|0,c|0)}function Nha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;jc(a|0,b|0,c|0)}function Oha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;kc(a|0,b|0,c|0)}function Pha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;lc(a|0,b|0,c|0)}function Qha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;nc(a|0)|0}function Rha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;md(a|0,b|0)}function Sha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;nd(a|0)|0}function Tha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Kd(a|0,b|0,c|0,d|0)|0}function Uha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ld(a|0,b|0,c|0,d|0)|0}function Vha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Md(a|0,b|0,c|0,d|0)|0}function Wha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Nd(a|0,b|0,c|0,d|0)|0}function Xha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Od(a|0,b|0,c|0,d|0)|0}function Yha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Pd(a|0,b|0,c|0,d|0)|0}function Zha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;qd(a|0,b|0,c|0,d|0)|0}function _ha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;rd(a|0,b|0,c|0,d|0)|0}function $ha(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Qd(a|0,b|0,c|0,d|0)|0}function aia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Rd(a|0,b|0,c|0,d|0)|0}function bia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;fo(a|0,b|0,c|0,d|0)|0}function cia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ae(a|0,b|0,c|0)}function dia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;be(a|0,b|0,c|0)}function eia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;tg(a|0)}function fia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;mk()|0}function gia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;nk(a|0)|0}function hia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ok(a|0)|0}function iia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;pk(a|0,b|0,c|0)|0}function jia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;qk(a|0)|0}function kia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;_k(a|0)|0}function lia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;$k(a|0,b|0,c|0)|0}function mia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;bl(a|0)|0}function nia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;cl(a|0,b|0,c|0)|0}function oia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;dl(a|0)|0}function pia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;el(a|0,b|0,c|0)|0}function qia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;fl(a|0,b|0,c|0)|0}function ria(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;gl(a|0,b|0,c|0,d|0)|0}function sia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;nn(a|0)}function tia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;on(a|0)|0}function uia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;sn(a|0)}function via(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;vn(a|0)|0}function wia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;xn(a|0)}function xia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;yn(a|0)|0}function yia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;zn(a|0,b|0)}function zia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;An(a|0)}function Aia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Bn(a|0)}function Bia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Cn(a|0,b|0)|0}function Cia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Dn(a|0)}function Dia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;In(a|0,b|0,c|0)}function Eia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Rn(a|0,b|0,c|0)}function Fia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Sn(a|0,b|0,c|0)}function Gia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Tn(a|0,b|0,c|0)}function Hia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Un(a|0,b|0,c|0)}function Iia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;_n(a|0,b|0)|0}function Jia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;tq(a|0,b|0)}function Kia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Qq(a|0)}function Lia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Bs(a|0,b|0)}function Mia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Is(a|0,b|0)}function Nia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ns(a|0,b|0)}function Oia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ts(a|0,b|0)}function Pia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;us(a|0,b|0)}function Qia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;os(a|0,b|0)}function Ria(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Es(a|0,b|0)}function Sia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Hs(a|0,b|0)}function Tia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ls(a|0,b|0)}function Uia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Fs(a|0,b|0)}function Via(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ps(a|0,b|0)}function Wia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Cs(a|0,b|0)}function Xia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;nt(a|0,b|0)}function Yia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;qs(a|0,b|0)}function Zia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;zs(a|0,b|0)}function _ia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Tr(a|0,b|0)}function $ia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ms(a|0,b|0)}function aja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Js(a|0,b|0)}function bja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;rs(a|0,b|0)}function cja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ss(a|0,b|0)}function dja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;vs(a|0,b|0)}function eja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ws(a|0,b|0)}function fja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;xs(a|0,b|0)}function gja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ys(a|0,b|0)}function hja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Gs(a|0,b|0)}function ija(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ds(a|0,b|0)}function jja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;As(a|0,b|0)}function kja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ot(a|0,b|0)}function lja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;uu(a|0,b|0,c|0)|0}function mja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ds(a|0,b|0)|0}function nja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;es(a|0,b|0)|0}function oja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;js(a|0,b|0)|0}function pja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;vu(a|0,b|0,c|0)|0}function qja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;wu(a|0,b|0)|0}function rja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;$r(a|0,b|0)|0}function sja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;as(a|0,b|0)|0}function tja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;bs(a|0,b|0)|0}function uja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;hs(a|0,b|0)|0}function vja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;fs(a|0,b|0)|0}function wja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;is(a|0,b|0)|0}function xja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;cs(a|0,b|0)|0}function yja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;xu(a|0,b|0)|0}function zja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;gs(a|0,b|0)|0}function Aja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;_r(a|0,b|0)|0}function Bja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;dr(a|0,b|0)|0}function Cja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;jv(a|0,b|0)}function Dja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;pv(a|0,b|0)}function Eja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;qv(a|0,b|0)}function Fja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;rv(a|0,b|0)}function Gja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;sv(a|0,b|0)}function Hja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;tv(a|0,b|0)}function Ija(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;uv(a|0,b|0)}function Jja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;vv(a|0,b|0)}function Kja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;tw(a|0,b|0,c|0)}function Lja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Mw(a|0)}function Mja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Yw(a|0)}function Nja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Kx(a|0,b|0,c|0)|0}function Oja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;$x(a|0,b|0)|0}function Pja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;dy(a|0,b|0)|0}function Qja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;fy(a|0,b|0)|0}function Rja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;jy(a|0,b|0)|0}function Sja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;qB(a|0)}function Tja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;LB(a|0,b|0,c|0,d|0,e|0,0,0,0,0)}function Uja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;MB(a|0,b|0,c|0,d|0)}function Vja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;NB(a|0,b|0,c|0)}function Wja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;OB(a|0,b|0,c|0)}function Xja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;PB(a|0,b|0)}function Yja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;QB(a|0,b|0,c|0,d|0)}function Zja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;RB(a|0)|0}function _ja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;SB(a|0)|0}function $ja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;TB(a|0)|0}function aka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;UB(a|0,b|0,c|0)|0}function bka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;VB(a|0,b|0)|0}function cka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;WB(a|0,b|0,c|0,d|0,e|0,0)}function dka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;XB(a|0,b|0,c|0,d|0)}function eka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;YB(a|0,b|0,c|0,d|0,e|0,0,0)}function fka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ZB(a|0,b|0,c|0,d|0)}function gka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;$B(a|0,b|0)}function hka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;aC(a|0)}function ika(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;bC(a|0)}function jka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;cC(a|0,b|0,c|0)}function kka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;dC(a|0,b|0)}function lka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;eC(a|0,b|0,c|0)}function mka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;fC(a|0,b|0,c|0)}function nka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;gC(a|0,b|0,c|0)}function oka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;hC(a|0,b|0)|0}function pka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;iC(a|0,b|0,c|0,d|0)}function qka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;jC(a|0,b|0,c|0)}function rka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;kC(a|0,b|0,c|0)}function ska(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;lC(a|0,b|0,c|0)}function tka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;mC(a|0,b|0)}function uka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;nC(a|0,b|0,c|0,d|0,e|0,0,0,0,0)}function vka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;oC(a|0,b|0,c|0,d|0)}function wka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;rC(a|0,b|0,c|0)|0}function xka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;uC(a|0)}function yka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;AD(a|0,b|0)}function zka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;lF(a|0,b|0,c|0,d|0)}function Aka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;uF(a|0,b|0)}function Bka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;VA(a|0)}function Cka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;wM(a|0,b|0,c|0)}function Dka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;xM(a|0,b|0)}function Eka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;yM(a|0,b|0,c|0,d|0,e|0,0,0,0,0)}function Fka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;zM(a|0,b|0,c|0,d|0)}function Gka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;AM(a|0,b|0,c|0)}function Hka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;BM(a|0,b|0,c|0)}function Ika(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;DM(a|0,b|0,c|0)}function Jka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;EM(a|0,b|0,c|0)}function Kka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;GM(a|0,b|0,c|0)|0}function Lka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;FM(a|0,b|0)}function Mka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;UM(a|0)}function Nka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;nN(a|0,b|0)|0}function Oka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;oN(a|0,b|0,c|0,d|0,e|0)|0}function Pka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;pN(a|0,b|0,c|0,d|0,e|0,0,0)|0}function Qka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;qN(a|0,b|0,c|0,d|0,e|0,0)|0}function Rka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;rN(a|0,b|0)}function Ska(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;tN(a|0,b|0)|0}function Tka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;uN(a|0,b|0,c|0,d|0,e|0)|0}function Uka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;vN(a|0,b|0,c|0,d|0,e|0,0,0)|0}function Vka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;wN(a|0,b|0)}function Wka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;CN(a|0,b|0,c|0)}function Xka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;GN(a|0,b|0,c|0,d|0)}function Yka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;vO(a|0,b|0,c|0)}function Zka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;wO(a|0,b|0,c|0)}function _ka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;fP(a|0,b|0,c|0,d|0)}function $ka(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;sP(a|0,b|0,c|0)}function ala(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;fQ(a|0,b|0,c|0,d|0,e|0,0,0,0,0)}function bla(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;gQ(a|0,b|0,c|0,d|0)}function cla(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;WR(a|0,b|0,c|0,d|0)|0}function dla(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;QS(a|0,b|0)|0}function ela(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;hT(a|0,b|0,c|0)|0}function fla(){da(4);return 0}function gla(){return 0}function hla(){return vc(0)|0}function ila(){return wc(0)|0}function jla(){return xc(0)|0}function kla(){return yc(0,0,0)|0}function lla(){return zc(0,0)|0}function mla(){return 0}function nla(){return 0}function ola(){return 0}function pla(){return 0}function qla(){return 0}function rla(){return 0}function sla(){return 0}function tla(){return 0}function ula(){return 0}function vla(){return 0}function wla(){return 0}function xla(){return 0}function yla(){return 0}function zla(){return 0}function Ala(){return 0}function Bla(){return 0}function Cla(){return 0}function Dla(){return 0}function Ela(){return Qc(0,0)|0}function Fla(){return 0}function Gla(){return 0}function Hla(){return 0}function Ila(){return 0}function Jla(){return Xk(0,0,0)|0}function Kla(){return 0}function Lla(){return iT(0)|0}function Mla(){return kT(0,0)|0}function Nla(){return my(0)|0}function Ola(){return 0}function Pla(){return 0}function Qla(){return PP(0)|0}function Rla(){return QP(0)|0}function Sla(){return RP(0)|0}function Tla(){return UP(0,0,0)|0}function Ula(){return VP(0,0)|0}function Vla(){return 0}function Wla(){return 0}function Xla(){return 0}function Yla(){return 0}function Zla(){return 0}function _la(){return 0}function $la(){return 0}function ama(){return 0}function bma(){return 0}function cma(){return 0}function dma(){return 0}function ema(){return 0}function fma(){return 0}function gma(){return 0}function hma(){return 0}function ima(){return 0}function jma(){return WP(0,0)|0}function kma(){return 0}function lma(){return 0}function mma(){return LP(0)|0}function nma(){return MP(0)|0}function oma(){return NP(0)|0}function pma(){return OP(0)|0}function qma(){return 0}function rma(){return NI(0)|0}function sma(){return OI(0)|0}function tma(){return PI(0)|0}function uma(){return QI(0)|0}function vma(){return RI(0)|0}function wma(){return SI(0)|0}function xma(){return TI(0)|0}function yma(){return UI(0)|0}function zma(){return VI(0)|0}function Ama(){return WI(0)|0}function Bma(){return XI(0)|0}function Cma(){return YI(0)|0}function Dma(){return ZI(0)|0}function Ema(){return _I(0)|0}function Fma(){return $I(0)|0}function Gma(){return aJ(0)|0}function Hma(){return bJ(0)|0}function Ima(){return cJ(0)|0}function Jma(){return dJ(0)|0;
}function Kma(){return eJ(0)|0}function Lma(){return fJ(0)|0}function Mma(){return gJ(0)|0}function Nma(){return hJ(0)|0}function Oma(){return iJ(0)|0}function Pma(){return jJ(0)|0}function Qma(){return kJ(0)|0}function Rma(){return lJ(0)|0}function Sma(){return mJ(0)|0}function Tma(){return nJ(0)|0}function Uma(){return oJ(0)|0}function Vma(){return pJ(0)|0}function Wma(){return qJ(0)|0}function Xma(){return rJ(0)|0}function Yma(){return sJ(0)|0}function Zma(){return tJ(0)|0}function _ma(){return uJ(0)|0}function $ma(){return vJ(0)|0}function ana(){return wJ(0)|0}function bna(){return xJ(0)|0}function cna(){return yJ(0)|0}function dna(){return zJ(0)|0}function ena(){return AJ(0)|0}function fna(){return BJ(0)|0}function gna(){return CJ(0)|0}function hna(){return DJ(0)|0}function ina(){return EJ(0)|0}function jna(){return FJ(0)|0}function kna(){return GJ(0)|0}function lna(){return HJ(0)|0}function mna(){return IJ(0)|0}function nna(){return JJ(0)|0}function ona(){return KJ(0)|0}function pna(){return LJ(0)|0}function qna(){return MJ(0)|0}function rna(){return NJ(0)|0}function sna(){return OJ(0)|0}function tna(){return PJ(0)|0}function una(){return QJ(0)|0}function vna(){return RJ(0)|0}function wna(){return SJ(0)|0}function xna(){return TJ(0)|0}function yna(){return UJ(0)|0}function zna(){return VJ(0)|0}function Ana(){return WJ(0)|0}function Bna(){return XJ(0)|0}function Cna(){return YJ(0)|0}function Dna(){return ZJ(0)|0}function Ena(){return _J(0)|0}function Fna(){return $J(0)|0}function Gna(){return aK(0)|0}function Hna(){return bK(0)|0}function Ina(){return cK(0)|0}function Jna(){return dK(0)|0}function Kna(){return eK(0)|0}function Lna(){return fK(0)|0}function Mna(){return gK(0)|0}function Nna(){return hK(0)|0}function Ona(){return iK(0)|0}function Pna(){return jK(0)|0}function Qna(){return kK(0)|0}function Rna(){return lK(0)|0}function Sna(){return mK(0)|0}function Tna(){return nK(0)|0}function Una(){return oK(0)|0}function Vna(){return pK(0)|0}function Wna(){return qK(0)|0}function Xna(){return rK(0)|0}function Yna(){return sK(0)|0}function Zna(){return tK(0)|0}function _na(){return uK(0)|0}function $na(){return vK(0)|0}function aoa(){return wK(0)|0}function boa(){return xK(0)|0}function coa(){return yK(0)|0}function doa(){return zK(0)|0}function eoa(){return AK(0)|0}function foa(){return BK(0)|0}function goa(){return CK(0)|0}function hoa(){return DK(0)|0}function ioa(){return EK(0)|0}function joa(){return FK(0)|0}function koa(){return GK(0)|0}function loa(){return HK(0)|0}function moa(){return IK(0)|0}function noa(){return JK(0)|0}function ooa(){return KK(0)|0}function poa(){return LK(0)|0}function qoa(){return MK(0)|0}function roa(){return NK(0)|0}function soa(){return OK(0)|0}function toa(){return PK(0)|0}function uoa(){return QK(0)|0}function voa(){return RK(0)|0}function woa(){return SK(0)|0}function xoa(){return TK(0)|0}function yoa(){return UK(0)|0}function zoa(){return VK(0)|0}function Aoa(){return WK(0)|0}function Boa(){return XK(0)|0}function Coa(){return YK(0)|0}function Doa(){return ZK(0)|0}function Eoa(){return _K(0)|0}function Foa(){return $K(0)|0}function Goa(){return aL(0)|0}function Hoa(){return bL(0)|0}function Ioa(){return cL(0)|0}function Joa(){return dL(0)|0}function Koa(){return eL(0)|0}function Loa(){return RT(0,0,0)|0}function Moa(){return 0}function Noa(){return Wb(0)|0}function Ooa(){return Xb(0,0)|0}function Poa(){return Yb(0)|0}function Qoa(){return Wk(0,0,0)|0}function Roa(){return 0}function Soa(){return 0}function Toa(){return ac(0,0,0)|0}function Uoa(){return Ka(0,0,0)|0}function Voa(){return gc(0,0,0)|0}function Woa(){return 0}function Xoa(){return 0}function Yoa(){return 0}function Zoa(){return 0}function _oa(){return 0}function $oa(){return nc(0)|0}function apa(){return 0}function bpa(){return nd(0)|0}function cpa(){return Kd(0,0,0,0)|0}function dpa(){return Ld(0,0,0,0)|0}function epa(){return Md(0,0,0,0)|0}function fpa(){return Nd(0,0,0,0)|0}function gpa(){return Od(0,0,0,0)|0}function hpa(){return Pd(0,0,0,0)|0}function ipa(){return qd(0,0,0,0)|0}function jpa(){return rd(0,0,0,0)|0}function kpa(){return Qd(0,0,0,0)|0}function lpa(){return Rd(0,0,0,0)|0}function mpa(){return fo(0,0,0,0)|0}function npa(){return 0}function opa(){return 0}function ppa(){return 0}function qpa(){return 0}function rpa(){return 0}function spa(){return nk(0)|0}function tpa(){return ok(0)|0}function upa(){return pk(0,0,0)|0}function vpa(){return qk(0)|0}function wpa(){return _k(0)|0}function xpa(){return $k(0,0,0)|0}function ypa(){return bl(0)|0}function zpa(){return cl(0,0,0)|0}function Apa(){return dl(0)|0}function Bpa(){return el(0,0,0)|0}function Cpa(){return fl(0,0,0)|0}function Dpa(){return gl(0,0,0,0)|0}function Epa(){return 0}function Fpa(){return on(0)|0}function Gpa(){return 0}function Hpa(){return vn(0)|0}function Ipa(){return 0}function Jpa(){return yn(0)|0}function Kpa(){return 0}function Lpa(){return 0}function Mpa(){return 0}function Npa(){return Cn(0,0)|0}function Opa(){return 0}function Ppa(){return 0}function Qpa(){return 0}function Rpa(){return 0}function Spa(){return 0}function Tpa(){return 0}function Upa(){return _n(0,0)|0}function Vpa(){return 0}function Wpa(){return 0}function Xpa(){return 0}function Ypa(){return 0}function Zpa(){return 0}function _pa(){return 0}function $pa(){return 0}function aqa(){return 0}function bqa(){return 0}function cqa(){return 0}function dqa(){return 0}function eqa(){return 0}function fqa(){return 0}function gqa(){return 0}function hqa(){return 0}function iqa(){return 0}function jqa(){return 0}function kqa(){return 0}function lqa(){return 0}function mqa(){return 0}function nqa(){return 0}function oqa(){return 0}function pqa(){return 0}function qqa(){return 0}function rqa(){return 0}function sqa(){return 0}function tqa(){return 0}function uqa(){return 0}function vqa(){return 0}function wqa(){return 0}function xqa(){return uu(0,0,0)|0}function yqa(){return ds(0,0)|0}function zqa(){return es(0,0)|0}function Aqa(){return js(0,0)|0}function Bqa(){return vu(0,0,0)|0}function Cqa(){return wu(0,0)|0}function Dqa(){return $r(0,0)|0}function Eqa(){return as(0,0)|0}function Fqa(){return bs(0,0)|0}function Gqa(){return hs(0,0)|0}function Hqa(){return fs(0,0)|0}function Iqa(){return is(0,0)|0}function Jqa(){return cs(0,0)|0}function Kqa(){return xu(0,0)|0}function Lqa(){return gs(0,0)|0}function Mqa(){return _r(0,0)|0}function Nqa(){return dr(0,0)|0}function Oqa(){return 0}function Pqa(){return 0}function Qqa(){return 0}function Rqa(){return 0}function Sqa(){return 0}function Tqa(){return 0}function Uqa(){return 0}function Vqa(){return 0}function Wqa(){return 0}function Xqa(){return 0}function Yqa(){return 0}function Zqa(){return Kx(0,0,0)|0}function _qa(){return $x(0,0)|0}function $qa(){return dy(0,0)|0}function ara(){return fy(0,0)|0}function bra(){return jy(0,0)|0}function cra(){return 0}function dra(){return 0}function era(){return 0}function fra(){return 0}function gra(){return 0}function hra(){return 0}function ira(){return 0}function jra(){return RB(0)|0}function kra(){return SB(0)|0}function lra(){return TB(0)|0}function mra(){return UB(0,0,0)|0}function nra(){return VB(0,0)|0}function ora(){return 0}function pra(){return 0}function qra(){return 0}function rra(){return 0}function sra(){return 0}function tra(){return 0}function ura(){return 0}function vra(){return 0}function wra(){return 0}function xra(){return 0}function yra(){return 0}function zra(){return 0}function Ara(){return 0}function Bra(){return hC(0,0)|0}function Cra(){return 0}function Dra(){return 0}function Era(){return 0}function Fra(){return 0}function Gra(){return 0}function Hra(){return 0}function Ira(){return 0}function Jra(){return rC(0,0,0)|0}function Kra(){return 0}function Lra(){return 0}function Mra(){return 0}function Nra(){return 0}function Ora(){return 0}function Pra(){return 0}function Qra(){return 0}function Rra(){return 0}function Sra(){return 0}function Tra(){return 0}function Ura(){return 0}function Vra(){return 0}function Wra(){return 0}function Xra(){return GM(0,0,0)|0}function Yra(){return 0}function Zra(){return 0}function _ra(){return nN(0,0)|0}function $ra(){return oN(0,0,0,0,0)|0}function asa(){return pN(0,0,0,0,0,0,0)|0}function bsa(){return qN(0,0,0,0,0,0)|0}function csa(){return 0}function dsa(){return tN(0,0)|0}function esa(){return uN(0,0,0,0,0)|0}function fsa(){return vN(0,0,0,0,0,0,0)|0}function gsa(){return 0}function hsa(){return 0}function isa(){return 0}function jsa(){return 0}function ksa(){return 0}function lsa(){return 0}function msa(){return 0}function nsa(){return 0}function osa(){return 0}function psa(){return WR(0,0,0,0)|0}function qsa(){return QS(0,0)|0}function rsa(){return hT(0,0,0)|0}function ssa(a){a=a|0;da(5)}function tsa(a){a=a|0;uc(a|0,0,0,0)}function usa(a){a=a|0;vc(a|0)|0}function vsa(a){a=a|0;wc(a|0)|0}function wsa(a){a=a|0;xc(a|0)|0}function xsa(a){a=a|0;yc(a|0,0,0)|0}function ysa(a){a=a|0;zc(a|0,0)|0}function zsa(a){a=a|0;Ac(a|0,0,0,0,0,0)}function Asa(a){a=a|0;Bc(a|0,0,0,0)}function Bsa(a){a=a|0;Cc(a|0,0,0,0,0,0,0)}function Csa(a){a=a|0;Dc(a|0,0,0,0)}function Dsa(a){a=a|0;Ec(a|0,0,0,0,0)}function Esa(a){a=a|0;Fc(a|0,0)}function Fsa(a){a=a|0;Wc(a|0,0,0)}function Gsa(a){a=a|0;Xc(a|0,0)}function Hsa(a){a=a|0;Ic(a|0,0)}function Isa(a){a=a|0;Jc(a|0,0,0)}function Jsa(a){a=a|0;Kc(a|0,0,0)}function Ksa(a){a=a|0;Lc(a|0,0,0)}function Lsa(a){a=a|0;Mc(a|0,0)}function Msa(a){a=a|0;Nc(a|0,0,0)}function Nsa(a){a=a|0;Oc(a|0,0,0)}function Osa(a){a=a|0;Pc(a|0,0,0)}function Psa(a){a=a|0;Qc(a|0,0)|0}function Qsa(a){a=a|0;Rc(a|0,0,0)}function Rsa(a){a=a|0;Sc(a|0,0,0,0)}function Ssa(a){a=a|0;Tc(a|0,0,0,0,0,0,0,0,0)}function Tsa(a){a=a|0;Uc(a|0,0,0,0)}function Usa(a){a=a|0;Xk(a|0,0,0)|0}function Vsa(a){a=a|0;iT(a|0)|0}function Wsa(a){a=a|0;kT(a|0,0)|0}function Xsa(a){a=a|0;my(a|0)|0}function Ysa(a){a=a|0;Td(a|0,0,0)}function Zsa(a){a=a|0;SP(a|0,0,0,0)}function _sa(a){a=a|0;PP(a|0)|0}function $sa(a){a=a|0;QP(a|0)|0}function ata(a){a=a|0;RP(a|0)|0}function bta(a){a=a|0;UP(a|0,0,0)|0}function cta(a){a=a|0;VP(a|0,0)|0}function dta(a){a=a|0;XP(a|0,0,0,0,0,0)}function eta(a){a=a|0;_P(a|0,0,0,0)}function fta(a){a=a|0;YP(a|0,0,0,0,0,0,0)}function gta(a){a=a|0;ZP(a|0,0,0,0)}function hta(a){a=a|0;$P(a|0,0,0,0,0)}function ita(a){a=a|0;aQ(a|0,0)}function jta(a){a=a|0;dQ(a|0,0,0)}function kta(a){a=a|0;eQ(a|0,0)}function lta(a){a=a|0;hQ(a|0,0)}function mta(a){a=a|0;iQ(a|0,0,0)}function nta(a){a=a|0;kQ(a|0,0,0)}function ota(a){a=a|0;lQ(a|0,0)}function pta(a){a=a|0;$d(a|0,0,0)}function qta(a){a=a|0;_d(a|0,0,0)}function rta(a){a=a|0;WP(a|0,0)|0}function sta(a){a=a|0;mQ(a|0,0,0)}function tta(a){a=a|0;TP(a|0,0,0,0)}function uta(a){a=a|0;LP(a|0)|0}function vta(a){a=a|0;MP(a|0)|0}function wta(a){a=a|0;NP(a|0)|0}function xta(a){a=a|0;OP(a|0)|0}function yta(a){a=a|0;jQ(a|0,0,0)}function zta(a){a=a|0;NI(a|0)|0}function Ata(a){a=a|0;OI(a|0)|0}function Bta(a){a=a|0;PI(a|0)|0}function Cta(a){a=a|0;QI(a|0)|0}function Dta(a){a=a|0;RI(a|0)|0}function Eta(a){a=a|0;SI(a|0)|0}function Fta(a){a=a|0;TI(a|0)|0}function Gta(a){a=a|0;UI(a|0)|0}function Hta(a){a=a|0;VI(a|0)|0}function Ita(a){a=a|0;WI(a|0)|0}function Jta(a){a=a|0;XI(a|0)|0}function Kta(a){a=a|0;YI(a|0)|0}function Lta(a){a=a|0;ZI(a|0)|0}function Mta(a){a=a|0;_I(a|0)|0}function Nta(a){a=a|0;$I(a|0)|0}function Ota(a){a=a|0;aJ(a|0)|0}function Pta(a){a=a|0;bJ(a|0)|0}function Qta(a){a=a|0;cJ(a|0)|0}function Rta(a){a=a|0;dJ(a|0)|0}function Sta(a){a=a|0;eJ(a|0)|0}function Tta(a){a=a|0;fJ(a|0)|0}function Uta(a){a=a|0;gJ(a|0)|0}function Vta(a){a=a|0;hJ(a|0)|0}function Wta(a){a=a|0;iJ(a|0)|0}function Xta(a){a=a|0;jJ(a|0)|0}function Yta(a){a=a|0;kJ(a|0)|0}function Zta(a){a=a|0;lJ(a|0)|0}function _ta(a){a=a|0;mJ(a|0)|0}function $ta(a){a=a|0;nJ(a|0)|0}function aua(a){a=a|0;oJ(a|0)|0}function bua(a){a=a|0;pJ(a|0)|0}function cua(a){a=a|0;qJ(a|0)|0}function dua(a){a=a|0;rJ(a|0)|0}function eua(a){a=a|0;sJ(a|0)|0}function fua(a){a=a|0;tJ(a|0)|0}function gua(a){a=a|0;uJ(a|0)|0}function hua(a){a=a|0;vJ(a|0)|0}function iua(a){a=a|0;wJ(a|0)|0}function jua(a){a=a|0;xJ(a|0)|0}function kua(a){a=a|0;yJ(a|0)|0}function lua(a){a=a|0;zJ(a|0)|0}function mua(a){a=a|0;AJ(a|0)|0}function nua(a){a=a|0;BJ(a|0)|0}function oua(a){a=a|0;CJ(a|0)|0}function pua(a){a=a|0;DJ(a|0)|0}function qua(a){a=a|0;EJ(a|0)|0}function rua(a){a=a|0;FJ(a|0)|0}function sua(a){a=a|0;GJ(a|0)|0}function tua(a){a=a|0;HJ(a|0)|0}function uua(a){a=a|0;IJ(a|0)|0}function vua(a){a=a|0;JJ(a|0)|0}function wua(a){a=a|0;KJ(a|0)|0}function xua(a){a=a|0;LJ(a|0)|0}function yua(a){a=a|0;MJ(a|0)|0}function zua(a){a=a|0;NJ(a|0)|0}function Aua(a){a=a|0;OJ(a|0)|0}function Bua(a){a=a|0;PJ(a|0)|0}function Cua(a){a=a|0;QJ(a|0)|0}function Dua(a){a=a|0;RJ(a|0)|0}function Eua(a){a=a|0;SJ(a|0)|0}function Fua(a){a=a|0;TJ(a|0)|0}function Gua(a){a=a|0;UJ(a|0)|0}function Hua(a){a=a|0;VJ(a|0)|0}function Iua(a){a=a|0;WJ(a|0)|0}function Jua(a){a=a|0;XJ(a|0)|0}function Kua(a){a=a|0;YJ(a|0)|0}function Lua(a){a=a|0;ZJ(a|0)|0}function Mua(a){a=a|0;_J(a|0)|0}function Nua(a){a=a|0;$J(a|0)|0}function Oua(a){a=a|0;aK(a|0)|0}function Pua(a){a=a|0;bK(a|0)|0}function Qua(a){a=a|0;cK(a|0)|0}function Rua(a){a=a|0;dK(a|0)|0}function Sua(a){a=a|0;eK(a|0)|0}function Tua(a){a=a|0;fK(a|0)|0}function Uua(a){a=a|0;gK(a|0)|0}function Vua(a){a=a|0;hK(a|0)|0}function Wua(a){a=a|0;iK(a|0)|0}function Xua(a){a=a|0;jK(a|0)|0}function Yua(a){a=a|0;kK(a|0)|0}function Zua(a){a=a|0;lK(a|0)|0}function _ua(a){a=a|0;mK(a|0)|0}function $ua(a){a=a|0;nK(a|0)|0}function ava(a){a=a|0;oK(a|0)|0}function bva(a){a=a|0;pK(a|0)|0}function cva(a){a=a|0;qK(a|0)|0}function dva(a){a=a|0;rK(a|0)|0}function eva(a){a=a|0;sK(a|0)|0}function fva(a){a=a|0;tK(a|0)|0}function gva(a){a=a|0;uK(a|0)|0}function hva(a){a=a|0;vK(a|0)|0}function iva(a){a=a|0;wK(a|0)|0}function jva(a){a=a|0;xK(a|0)|0}function kva(a){a=a|0;yK(a|0)|0}function lva(a){a=a|0;zK(a|0)|0}function mva(a){a=a|0;AK(a|0)|0}function nva(a){a=a|0;BK(a|0)|0}function ova(a){a=a|0;CK(a|0)|0}function pva(a){a=a|0;DK(a|0)|0}function qva(a){a=a|0;EK(a|0)|0}function rva(a){a=a|0;FK(a|0)|0}function sva(a){a=a|0;GK(a|0)|0}function tva(a){a=a|0;HK(a|0)|0}function uva(a){a=a|0;IK(a|0)|0}function vva(a){a=a|0;JK(a|0)|0}function wva(a){a=a|0;KK(a|0)|0}function xva(a){a=a|0;LK(a|0)|0}function yva(a){a=a|0;MK(a|0)|0}function zva(a){a=a|0;NK(a|0)|0}function Ava(a){a=a|0;OK(a|0)|0}function Bva(a){a=a|0;PK(a|0)|0}function Cva(a){a=a|0;QK(a|0)|0}function Dva(a){a=a|0;RK(a|0)|0}function Eva(a){a=a|0;SK(a|0)|0}function Fva(a){a=a|0;TK(a|0)|0}function Gva(a){a=a|0;UK(a|0)|0}function Hva(a){a=a|0;VK(a|0)|0}function Iva(a){a=a|0;WK(a|0)|0}function Jva(a){a=a|0;XK(a|0)|0}function Kva(a){a=a|0;YK(a|0)|0}function Lva(a){a=a|0;ZK(a|0)|0}function Mva(a){a=a|0;_K(a|0)|0}function Nva(a){a=a|0;$K(a|0)|0}function Ova(a){a=a|0;aL(a|0)|0}function Pva(a){a=a|0;bL(a|0)|0}function Qva(a){a=a|0;cL(a|0)|0}function Rva(a){a=a|0;dL(a|0)|0}function Sva(a){a=a|0;eL(a|0)|0}function Tva(a){a=a|0;RT(a|0,0,0)|0}function Uva(a){a=a|0;Wb(a|0)|0}function Vva(a){a=a|0;Xb(a|0,0)|0}function Wva(a){a=a|0;Yb(a|0)|0}function Xva(a){a=a|0;Wk(a|0,0,0)|0}function Yva(a){a=a|0;ac(a|0,0,0)|0}function Zva(a){a=a|0;Ka(a|0,0,0)|0}function _va(a){a=a|0;gc(a|0,0,0)|0}function $va(a){a=a|0;ic(a|0,0,0)}function awa(a){a=a|0;jc(a|0,0,0)}function bwa(a){a=a|0;kc(a|0,0,0)}function cwa(a){a=a|0;lc(a|0,0,0)}function dwa(a){a=a|0;nc(a|0)|0}function ewa(a){a=a|0;md(a|0,0)}function fwa(a){a=a|0;nd(a|0)|0}function gwa(a){a=a|0;Kd(a|0,0,0,0)|0}function hwa(a){a=a|0;Ld(a|0,0,0,0)|0}function iwa(a){a=a|0;Md(a|0,0,0,0)|0}function jwa(a){a=a|0;Nd(a|0,0,0,0)|0}function kwa(a){a=a|0;Od(a|0,0,0,0)|0}function lwa(a){a=a|0;Pd(a|0,0,0,0)|0}function mwa(a){a=a|0;qd(a|0,0,0,0)|0}function nwa(a){a=a|0;rd(a|0,0,0,0)|0}function owa(a){a=a|0;Qd(a|0,0,0,0)|0}function pwa(a){a=a|0;Rd(a|0,0,0,0)|0}function qwa(a){a=a|0;fo(a|0,0,0,0)|0}function rwa(a){a=a|0;ae(a|0,0,0)}function swa(a){a=a|0;be(a|0,0,0)}function twa(a){a=a|0;mk()|0}function uwa(a){a=a|0;sh(a|0,0,0,0,0)}function vwa(a){a=a|0;gk(a|0,0,0,0,0)}function wwa(a){a=a|0;nk(a|0)|0}function xwa(a){a=a|0;ok(a|0)|0}function ywa(a){a=a|0;pk(a|0,0,0)|0}function zwa(a){a=a|0;qk(a|0)|0}function Awa(a){a=a|0;_k(a|0)|0}function Bwa(a){a=a|0;$k(a|0,0,0)|0}function Cwa(a){a=a|0;bl(a|0)|0}function Dwa(a){a=a|0;cl(a|0,0,0)|0}function Ewa(a){a=a|0;dl(a|0)|0}function Fwa(a){a=a|0;el(a|0,0,0)|0}function Gwa(a){a=a|0;fl(a|0,0,0)|0}function Hwa(a){a=a|0;gl(a|0,0,0,0)|0}function Iwa(a){a=a|0;on(a|0)|0}function Jwa(a){a=a|0;vn(a|0)|0}function Kwa(a){a=a|0;yn(a|0)|0}function Lwa(a){a=a|0;zn(a|0,0)}function Mwa(a){a=a|0;Cn(a|0,0)|0}function Nwa(a){a=a|0;In(a|0,0,0)}function Owa(a){a=a|0;Rn(a|0,0,0)}function Pwa(a){a=a|0;Sn(a|0,0,0)}function Qwa(a){a=a|0;Tn(a|0,0,0)}function Rwa(a){a=a|0;Un(a|0,0,0)}function Swa(a){a=a|0;_n(a|0,0)|0}function Twa(a){a=a|0;tq(a|0,0)}function Uwa(a){a=a|0;Bs(a|0,0)}function Vwa(a){a=a|0;Is(a|0,0)}function Wwa(a){a=a|0;ns(a|0,0)}function Xwa(a){a=a|0;ts(a|0,0)}function Ywa(a){a=a|0;us(a|0,0)}function Zwa(a){a=a|0;os(a|0,0)}function _wa(a){a=a|0;Es(a|0,0)}function $wa(a){a=a|0;Hs(a|0,0)}function axa(a){a=a|0;ls(a|0,0)}function bxa(a){a=a|0;Fs(a|0,0)}function cxa(a){a=a|0;ps(a|0,0)}function dxa(a){a=a|0;Cs(a|0,0)}function exa(a){a=a|0;nt(a|0,0)}function fxa(a){a=a|0;qs(a|0,0)}function gxa(a){a=a|0;zs(a|0,0)}function hxa(a){a=a|0;Tr(a|0,0)}function ixa(a){a=a|0;ms(a|0,0)}function jxa(a){a=a|0;Js(a|0,0)}function kxa(a){a=a|0;rs(a|0,0)}function lxa(a){a=a|0;ss(a|0,0)}function mxa(a){a=a|0;vs(a|0,0)}function nxa(a){a=a|0;ws(a|0,0)}function oxa(a){a=a|0;xs(a|0,0)}function pxa(a){a=a|0;ys(a|0,0)}function qxa(a){a=a|0;Gs(a|0,0)}function rxa(a){a=a|0;Ds(a|0,0)}function sxa(a){a=a|0;As(a|0,0)}function txa(a){a=a|0;ot(a|0,0)}function uxa(a){a=a|0;uu(a|0,0,0)|0}function vxa(a){a=a|0;ds(a|0,0)|0}function wxa(a){a=a|0;es(a|0,0)|0}function xxa(a){a=a|0;js(a|0,0)|0}function yxa(a){a=a|0;vu(a|0,0,0)|0}function zxa(a){a=a|0;wu(a|0,0)|0}function Axa(a){a=a|0;$r(a|0,0)|0}function Bxa(a){a=a|0;as(a|0,0)|0}function Cxa(a){a=a|0;bs(a|0,0)|0}function Dxa(a){a=a|0;hs(a|0,0)|0}function Exa(a){a=a|0;fs(a|0,0)|0}function Fxa(a){a=a|0;is(a|0,0)|0}function Gxa(a){a=a|0;cs(a|0,0)|0}function Hxa(a){a=a|0;xu(a|0,0)|0}function Ixa(a){a=a|0;gs(a|0,0)|0}function Jxa(a){a=a|0;_r(a|0,0)|0}function Kxa(a){a=a|0;dr(a|0,0)|0}function Lxa(a){a=a|0;jv(a|0,0)}function Mxa(a){a=a|0;pv(a|0,0)}function Nxa(a){a=a|0;qv(a|0,0)}function Oxa(a){a=a|0;rv(a|0,0)}function Pxa(a){a=a|0;sv(a|0,0)}function Qxa(a){a=a|0;tv(a|0,0)}function Rxa(a){a=a|0;uv(a|0,0)}function Sxa(a){a=a|0;vv(a|0,0)}function Txa(a){a=a|0;tw(a|0,0,0)}function Uxa(a){a=a|0;Kx(a|0,0,0)|0}function Vxa(a){a=a|0;$x(a|0,0)|0}function Wxa(a){a=a|0;dy(a|0,0)|0}function Xxa(a){a=a|0;fy(a|0,0)|0}function Yxa(a){a=a|0;jy(a|0,0)|0}function Zxa(a){a=a|0;LB(a|0,0,0,0,0,0,0,0,0)}function _xa(a){a=a|0;MB(a|0,0,0,0)}function $xa(a){a=a|0;NB(a|0,0,0)}function aya(a){a=a|0;OB(a|0,0,0)}function bya(a){a=a|0;PB(a|0,0)}function cya(a){a=a|0;QB(a|0,0,0,0)}function dya(a){a=a|0;RB(a|0)|0}function eya(a){a=a|0;SB(a|0)|0}function fya(a){a=a|0;TB(a|0)|0}function gya(a){a=a|0;UB(a|0,0,0)|0}function hya(a){a=a|0;VB(a|0,0)|0}function iya(a){a=a|0;WB(a|0,0,0,0,0,0)}function jya(a){a=a|0;XB(a|0,0,0,0)}function kya(a){a=a|0;YB(a|0,0,0,0,0,0,0)}function lya(a){a=a|0;ZB(a|0,0,0,0)}function mya(a){a=a|0;_B(a|0,0,0,0,0)}function nya(a){a=a|0;$B(a|0,0)}function oya(a){a=a|0;cC(a|0,0,0)}function pya(a){a=a|0;dC(a|0,0)}function qya(a){a=a|0;eC(a|0,0,0)}function rya(a){a=a|0;fC(a|0,0,0)}function sya(a){a=a|0;gC(a|0,0,0)}function tya(a){a=a|0;hC(a|0,0)|0}function uya(a){a=a|0;iC(a|0,0,0,0)}function vya(a){a=a|0;jC(a|0,0,0)}function wya(a){a=a|0;kC(a|0,0,0)}function xya(a){a=a|0;lC(a|0,0,0)}function yya(a){a=a|0;mC(a|0,0)}function zya(a){a=a|0;nC(a|0,0,0,0,0,0,0,0,0)}function Aya(a){a=a|0;oC(a|0,0,0,0)}function Bya(a){a=a|0;rC(a|0,0,0)|0}function Cya(a){a=a|0;AD(a|0,0)}function Dya(a){a=a|0;lF(a|0,0,0,0)}function Eya(a){a=a|0;uF(a|0,0)}function Fya(a){a=a|0;wM(a|0,0,0)}function Gya(a){a=a|0;xM(a|0,0)}function Hya(a){a=a|0;yM(a|0,0,0,0,0,0,0,0,0)}function Iya(a){a=a|0;zM(a|0,0,0,0)}function Jya(a){a=a|0;AM(a|0,0,0)}function Kya(a){a=a|0;BM(a|0,0,0)}function Lya(a){a=a|0;DM(a|0,0,0)}function Mya(a){a=a|0;EM(a|0,0,0)}function Nya(a){a=a|0;GM(a|0,0,0)|0}function Oya(a){a=a|0;FM(a|0,0)}function Pya(a){a=a|0;nN(a|0,0)|0}function Qya(a){a=a|0;oN(a|0,0,0,0,0)|0}function Rya(a){a=a|0;pN(a|0,0,0,0,0,0,0)|0}function Sya(a){a=a|0;qN(a|0,0,0,0,0,0)|0}function Tya(a){a=a|0;rN(a|0,0)}function Uya(a){a=a|0;tN(a|0,0)|0}function Vya(a){a=a|0;uN(a|0,0,0,0,0)|0}function Wya(a){a=a|0;vN(a|0,0,0,0,0,0,0)|0}function Xya(a){a=a|0;wN(a|0,0)}function Yya(a){a=a|0;CN(a|0,0,0)}function Zya(a){a=a|0;GN(a|0,0,0,0)}function _ya(a){a=a|0;vO(a|0,0,0)}function $ya(a){a=a|0;wO(a|0,0,0)}function aza(a){a=a|0;fP(a|0,0,0,0)}function bza(a){a=a|0;sP(a|0,0,0)}function cza(a){a=a|0;fQ(a|0,0,0,0,0,0,0,0,0)}function dza(a){a=a|0;gQ(a|0,0,0,0)}function eza(a){a=a|0;WR(a|0,0,0,0)|0}function fza(a){a=a|0;QS(a|0,0)|0}function gza(a){a=a|0;hT(a|0,0,0)|0}function hza(a,b){a=a|0;b=b|0;da(6)}function iza(a,b){a=a|0;b=b|0;uc(a|0,b|0,0,0)}function jza(a,b){a=a|0;b=b|0;vc(a|0)|0}function kza(a,b){a=a|0;b=b|0;wc(a|0)|0}function lza(a,b){a=a|0;b=b|0;xc(a|0)|0}function mza(a,b){a=a|0;b=b|0;yc(a|0,b|0,0)|0}function nza(a,b){a=a|0;b=b|0;zc(a|0,b|0)|0}function oza(a,b){a=a|0;b=b|0;Ac(a|0,b|0,0,0,0,0)}function pza(a,b){a=a|0;b=b|0;Bc(a|0,b|0,0,0)}function qza(a,b){a=a|0;b=b|0;Cc(a|0,b|0,0,0,0,0,0)}function rza(a,b){a=a|0;b=b|0;Dc(a|0,b|0,0,0)}function sza(a,b){a=a|0;b=b|0;Ec(a|0,b|0,0,0,0)}function tza(a,b){a=a|0;b=b|0;Gc(a|0)}function uza(a,b){a=a|0;b=b|0;Hc(a|0)}function vza(a,b){a=a|0;b=b|0;Wc(a|0,b|0,0)}function wza(a,b){a=a|0;b=b|0;Jc(a|0,b|0,0)}function xza(a,b){a=a|0;b=b|0;Kc(a|0,b|0,0)}function yza(a,b){a=a|0;b=b|0;Lc(a|0,b|0,0)}function zza(a,b){a=a|0;b=b|0;Nc(a|0,b|0,0)}function Aza(a,b){a=a|0;b=b|0;Oc(a|0,b|0,0)}function Bza(a,b){a=a|0;b=b|0;Pc(a|0,b|0,0)}function Cza(a,b){a=a|0;b=b|0;Qc(a|0,b|0)|0}function Dza(a,b){a=a|0;b=b|0;Rc(a|0,b|0,0)}function Eza(a,b){a=a|0;b=b|0;Sc(a|0,b|0,0,0)}function Fza(a,b){a=a|0;b=b|0;Tc(a|0,b|0,0,0,0,0,0,0,0)}function Gza(a,b){a=a|0;b=b|0;Uc(a|0,b|0,0,0)}function Hza(a,b){a=a|0;b=b|0;Xk(a|0,b|0,0)|0}function Iza(a,b){a=a|0;b=b|0;jT(a|0)}function Jza(a,b){a=a|0;b=b|0;iT(a|0)|0}function Kza(a,b){a=a|0;b=b|0;kT(a|0,b|0)|0}function Lza(a,b){a=a|0;b=b|0;my(a|0)|0}function Mza(a,b){a=a|0;b=b|0;Td(a|0,b|0,0)}function Nza(a,b){a=a|0;b=b|0;SP(a|0,b|0,0,0)}function Oza(a,b){a=a|0;b=b|0;PP(a|0)|0}function Pza(a,b){a=a|0;b=b|0;QP(a|0)|0}function Qza(a,b){a=a|0;b=b|0;RP(a|0)|0}function Rza(a,b){a=a|0;b=b|0;UP(a|0,b|0,0)|0}function Sza(a,b){a=a|0;b=b|0;VP(a|0,b|0)|0}function Tza(a,b){a=a|0;b=b|0;XP(a|0,b|0,0,0,0,0)}function Uza(a,b){a=a|0;b=b|0;_P(a|0,b|0,0,0)}function Vza(a,b){a=a|0;b=b|0;YP(a|0,b|0,0,0,0,0,0)}function Wza(a,b){a=a|0;b=b|0;ZP(a|0,b|0,0,0)}function Xza(a,b){a=a|0;b=b|0;$P(a|0,b|0,0,0,0)}function Yza(a,b){a=a|0;b=b|0;bQ(a|0)}function Zza(a,b){a=a|0;b=b|0;cQ(a|0)}function _za(a,b){a=a|0;b=b|0;dQ(a|0,b|0,0)}function $za(a,b){a=a|0;b=b|0;iQ(a|0,b|0,0)}function aAa(a,b){a=a|0;b=b|0;kQ(a|0,b|0,0)}function bAa(a,b){a=a|0;b=b|0;$d(a|0,b|0,0)}function cAa(a,b){a=a|0;b=b|0;_d(a|0,b|0,0)}function dAa(a,b){a=a|0;b=b|0;WP(a|0,b|0)|0}function eAa(a,b){a=a|0;b=b|0;mQ(a|0,b|0,0)}function fAa(a,b){a=a|0;b=b|0;TP(a|0,b|0,0,0)}function gAa(a,b){a=a|0;b=b|0;LP(a|0)|0}function hAa(a,b){a=a|0;b=b|0;MP(a|0)|0}function iAa(a,b){a=a|0;b=b|0;NP(a|0)|0}function jAa(a,b){a=a|0;b=b|0;OP(a|0)|0}function kAa(a,b){a=a|0;b=b|0;jQ(a|0,b|0,0)}function lAa(a,b){a=a|0;b=b|0;NI(a|0)|0}function mAa(a,b){a=a|0;b=b|0;OI(a|0)|0}function nAa(a,b){a=a|0;b=b|0;PI(a|0)|0}function oAa(a,b){a=a|0;b=b|0;QI(a|0)|0}function pAa(a,b){a=a|0;b=b|0;RI(a|0)|0}function qAa(a,b){a=a|0;b=b|0;SI(a|0)|0}function rAa(a,b){a=a|0;b=b|0;TI(a|0)|0}function sAa(a,b){a=a|0;b=b|0;UI(a|0)|0}function tAa(a,b){a=a|0;b=b|0;VI(a|0)|0}function uAa(a,b){a=a|0;b=b|0;WI(a|0)|0}function vAa(a,b){a=a|0;b=b|0;XI(a|0)|0}function wAa(a,b){a=a|0;b=b|0;YI(a|0)|0}function xAa(a,b){a=a|0;b=b|0;ZI(a|0)|0}function yAa(a,b){a=a|0;b=b|0;_I(a|0)|0}function zAa(a,b){a=a|0;b=b|0;$I(a|0)|0}function AAa(a,b){a=a|0;b=b|0;aJ(a|0)|0}function BAa(a,b){a=a|0;b=b|0;bJ(a|0)|0}function CAa(a,b){a=a|0;b=b|0;cJ(a|0)|0}function DAa(a,b){a=a|0;b=b|0;dJ(a|0)|0}function EAa(a,b){a=a|0;b=b|0;eJ(a|0)|0}function FAa(a,b){a=a|0;b=b|0;fJ(a|0)|0}function GAa(a,b){a=a|0;b=b|0;gJ(a|0)|0}function HAa(a,b){a=a|0;b=b|0;hJ(a|0)|0}function IAa(a,b){a=a|0;b=b|0;iJ(a|0)|0}function JAa(a,b){a=a|0;b=b|0;jJ(a|0)|0}function KAa(a,b){a=a|0;b=b|0;kJ(a|0)|0}function LAa(a,b){a=a|0;b=b|0;lJ(a|0)|0}function MAa(a,b){a=a|0;b=b|0;mJ(a|0)|0}function NAa(a,b){a=a|0;b=b|0;nJ(a|0)|0}function OAa(a,b){a=a|0;b=b|0;oJ(a|0)|0}function PAa(a,b){a=a|0;b=b|0;pJ(a|0)|0}function QAa(a,b){a=a|0;b=b|0;qJ(a|0)|0}function RAa(a,b){a=a|0;b=b|0;rJ(a|0)|0}function SAa(a,b){a=a|0;b=b|0;sJ(a|0)|0}function TAa(a,b){a=a|0;b=b|0;tJ(a|0)|0}function UAa(a,b){a=a|0;b=b|0;uJ(a|0)|0}function VAa(a,b){a=a|0;b=b|0;vJ(a|0)|0}function WAa(a,b){a=a|0;b=b|0;wJ(a|0)|0}function XAa(a,b){a=a|0;b=b|0;xJ(a|0)|0}function YAa(a,b){a=a|0;b=b|0;yJ(a|0)|0}function ZAa(a,b){a=a|0;b=b|0;zJ(a|0)|0}function _Aa(a,b){a=a|0;b=b|0;AJ(a|0)|0}function $Aa(a,b){a=a|0;b=b|0;BJ(a|0)|0}function aBa(a,b){a=a|0;b=b|0;CJ(a|0)|0}function bBa(a,b){a=a|0;b=b|0;DJ(a|0)|0}function cBa(a,b){a=a|0;b=b|0;EJ(a|0)|0}function dBa(a,b){a=a|0;b=b|0;FJ(a|0)|0}function eBa(a,b){a=a|0;b=b|0;GJ(a|0)|0}function fBa(a,b){a=a|0;b=b|0;HJ(a|0)|0}function gBa(a,b){a=a|0;b=b|0;IJ(a|0)|0}function hBa(a,b){a=a|0;b=b|0;JJ(a|0)|0}function iBa(a,b){a=a|0;b=b|0;KJ(a|0)|0}function jBa(a,b){a=a|0;b=b|0;LJ(a|0)|0}function kBa(a,b){a=a|0;b=b|0;MJ(a|0)|0}function lBa(a,b){a=a|0;b=b|0;NJ(a|0)|0}function mBa(a,b){a=a|0;b=b|0;OJ(a|0)|0}function nBa(a,b){a=a|0;b=b|0;PJ(a|0)|0}function oBa(a,b){a=a|0;b=b|0;QJ(a|0)|0}function pBa(a,b){a=a|0;b=b|0;RJ(a|0)|0}function qBa(a,b){a=a|0;b=b|0;SJ(a|0)|0}function rBa(a,b){a=a|0;b=b|0;TJ(a|0)|0}function sBa(a,b){a=a|0;b=b|0;UJ(a|0)|0}function tBa(a,b){a=a|0;b=b|0;VJ(a|0)|0}function uBa(a,b){a=a|0;b=b|0;WJ(a|0)|0}function vBa(a,b){a=a|0;b=b|0;XJ(a|0)|0}function wBa(a,b){a=a|0;b=b|0;YJ(a|0)|0}function xBa(a,b){a=a|0;b=b|0;ZJ(a|0)|0}function yBa(a,b){a=a|0;b=b|0;_J(a|0)|0}function zBa(a,b){a=a|0;b=b|0;$J(a|0)|0}function ABa(a,b){a=a|0;b=b|0;aK(a|0)|0}function BBa(a,b){a=a|0;b=b|0;bK(a|0)|0}function CBa(a,b){a=a|0;b=b|0;cK(a|0)|0}function DBa(a,b){a=a|0;b=b|0;dK(a|0)|0}function EBa(a,b){a=a|0;b=b|0;eK(a|0)|0}function FBa(a,b){a=a|0;b=b|0;fK(a|0)|0}function GBa(a,b){a=a|0;b=b|0;gK(a|0)|0}function HBa(a,b){a=a|0;b=b|0;hK(a|0)|0}function IBa(a,b){a=a|0;b=b|0;iK(a|0)|0}function JBa(a,b){a=a|0;b=b|0;jK(a|0)|0}function KBa(a,b){a=a|0;b=b|0;kK(a|0)|0}function LBa(a,b){a=a|0;b=b|0;lK(a|0)|0}function MBa(a,b){a=a|0;b=b|0;mK(a|0)|0}function NBa(a,b){a=a|0;b=b|0;nK(a|0)|0}function OBa(a,b){a=a|0;b=b|0;oK(a|0)|0}function PBa(a,b){a=a|0;b=b|0;pK(a|0)|0}function QBa(a,b){a=a|0;b=b|0;qK(a|0)|0}function RBa(a,b){a=a|0;b=b|0;rK(a|0)|0}function SBa(a,b){a=a|0;b=b|0;sK(a|0)|0}function TBa(a,b){a=a|0;b=b|0;tK(a|0)|0}function UBa(a,b){a=a|0;b=b|0;uK(a|0)|0}function VBa(a,b){a=a|0;b=b|0;vK(a|0)|0}function WBa(a,b){a=a|0;b=b|0;wK(a|0)|0}function XBa(a,b){a=a|0;b=b|0;xK(a|0)|0}function YBa(a,b){a=a|0;b=b|0;yK(a|0)|0}function ZBa(a,b){a=a|0;b=b|0;zK(a|0)|0}function _Ba(a,b){a=a|0;b=b|0;AK(a|0)|0}function $Ba(a,b){a=a|0;b=b|0;BK(a|0)|0}function aCa(a,b){a=a|0;b=b|0;CK(a|0)|0}function bCa(a,b){a=a|0;b=b|0;DK(a|0)|0}function cCa(a,b){a=a|0;b=b|0;EK(a|0)|0}function dCa(a,b){a=a|0;b=b|0;FK(a|0)|0}function eCa(a,b){a=a|0;b=b|0;GK(a|0)|0}function fCa(a,b){a=a|0;b=b|0;HK(a|0)|0}function gCa(a,b){a=a|0;b=b|0;IK(a|0)|0}function hCa(a,b){a=a|0;b=b|0;JK(a|0)|0}function iCa(a,b){a=a|0;b=b|0;KK(a|0)|0}function jCa(a,b){a=a|0;b=b|0;LK(a|0)|0}function kCa(a,b){a=a|0;b=b|0;MK(a|0)|0}function lCa(a,b){a=a|0;b=b|0;NK(a|0)|0}function mCa(a,b){a=a|0;b=b|0;OK(a|0)|0}function nCa(a,b){a=a|0;b=b|0;PK(a|0)|0}function oCa(a,b){a=a|0;b=b|0;QK(a|0)|0}function pCa(a,b){a=a|0;b=b|0;RK(a|0)|0}function qCa(a,b){a=a|0;b=b|0;SK(a|0)|0}function rCa(a,b){a=a|0;b=b|0;TK(a|0)|0}function sCa(a,b){a=a|0;b=b|0;UK(a|0)|0}function tCa(a,b){a=a|0;b=b|0;VK(a|0)|0}function uCa(a,b){a=a|0;b=b|0;WK(a|0)|0}function vCa(a,b){a=a|0;b=b|0;XK(a|0)|0}function wCa(a,b){a=a|0;b=b|0;YK(a|0)|0}function xCa(a,b){a=a|0;b=b|0;ZK(a|0)|0}function yCa(a,b){a=a|0;b=b|0;_K(a|0)|0}function zCa(a,b){a=a|0;b=b|0;$K(a|0)|0}function ACa(a,b){a=a|0;b=b|0;aL(a|0)|0}function BCa(a,b){a=a|0;b=b|0;bL(a|0)|0}function CCa(a,b){a=a|0;b=b|0;cL(a|0)|0}function DCa(a,b){a=a|0;b=b|0;dL(a|0)|0}function ECa(a,b){a=a|0;b=b|0;eL(a|0)|0}function FCa(a,b){a=a|0;b=b|0;RT(a|0,b|0,0)|0}function GCa(a,b){a=a|0;b=b|0;Vb(a|0)}function HCa(a,b){a=a|0;b=b|0;Wb(a|0)|0}function ICa(a,b){a=a|0;b=b|0;Xb(a|0,b|0)|0}function JCa(a,b){a=a|0;b=b|0;Yb(a|0)|0}function KCa(a,b){a=a|0;b=b|0;Wk(a|0,b|0,0)|0}function LCa(a,b){a=a|0;b=b|0;_b(a|0)}function MCa(a,b){a=a|0;b=b|0;$b(a|0)}function NCa(a,b){a=a|0;b=b|0;ac(a|0,b|0,0)|0}function OCa(a,b){a=a|0;b=b|0;Ka(a|0,b|0,0)|0}function PCa(a,b){a=a|0;b=b|0;gc(a|0,b|0,0)|0}function QCa(a,b){a=a|0;b=b|0;hc(a|0)}function RCa(a,b){a=a|0;b=b|0;ic(a|0,b|0,0)}function SCa(a,b){a=a|0;b=b|0;jc(a|0,b|0,0)}function TCa(a,b){a=a|0;b=b|0;kc(a|0,b|0,0)}function UCa(a,b){a=a|0;b=b|0;lc(a|0,b|0,0)}function VCa(a,b){a=a|0;b=b|0;nc(a|0)|0}function WCa(a,b){a=a|0;b=b|0;nd(a|0)|0}function XCa(a,b){a=a|0;b=b|0;Kd(a|0,b|0,0,0)|0}function YCa(a,b){a=a|0;b=b|0;Ld(a|0,b|0,0,0)|0}function ZCa(a,b){a=a|0;b=b|0;Md(a|0,b|0,0,0)|0}function _Ca(a,b){a=a|0;b=b|0;Nd(a|0,b|0,0,0)|0}function $Ca(a,b){a=a|0;b=b|0;Od(a|0,b|0,0,0)|0}function aDa(a,b){a=a|0;b=b|0;Pd(a|0,b|0,0,0)|0}function bDa(a,b){a=a|0;b=b|0;qd(a|0,b|0,0,0)|0}function cDa(a,b){a=a|0;b=b|0;rd(a|0,b|0,0,0)|0}function dDa(a,b){a=a|0;b=b|0;Qd(a|0,b|0,0,0)|0}function eDa(a,b){a=a|0;b=b|0;Rd(a|0,b|0,0,0)|0}function fDa(a,b){a=a|0;b=b|0;fo(a|0,b|0,0,0)|0}function gDa(a,b){a=a|0;b=b|0;ae(a|0,b|0,0)}function hDa(a,b){a=a|0;b=b|0;be(a|0,b|0,0)}function iDa(a,b){a=a|0;b=b|0;tg(a|0)}function jDa(a,b){a=a|0;b=b|0;mk()|0}function kDa(a,b){a=a|0;b=b|0;sh(a|0,b|0,0,0,0)}function lDa(a,b){a=a|0;b=b|0;gk(a|0,b|0,0,0,0)}function mDa(a,b){a=a|0;b=b|0;nk(a|0)|0}function nDa(a,b){a=a|0;b=b|0;ok(a|0)|0}function oDa(a,b){a=a|0;b=b|0;pk(a|0,b|0,0)|0}function pDa(a,b){a=a|0;b=b|0;qk(a|0)|0}function qDa(a,b){a=a|0;b=b|0;_k(a|0)|0}function rDa(a,b){a=a|0;b=b|0;$k(a|0,b|0,0)|0}function sDa(a,b){a=a|0;b=b|0;bl(a|0)|0}function tDa(a,b){a=a|0;b=b|0;cl(a|0,b|0,0)|0}function uDa(a,b){a=a|0;b=b|0;dl(a|0)|0}function vDa(a,b){a=a|0;b=b|0;el(a|0,b|0,0)|0}function wDa(a,b){a=a|0;b=b|0;fl(a|0,b|0,0)|0}function xDa(a,b){a=a|0;b=b|0;gl(a|0,b|0,0,0)|0}function yDa(a,b){a=a|0;b=b|0;nn(a|0)}function zDa(a,b){a=a|0;b=b|0;on(a|0)|0}function ADa(a,b){a=a|0;b=b|0;sn(a|0)}function BDa(a,b){a=a|0;b=b|0;vn(a|0)|0}function CDa(a,b){a=a|0;b=b|0;xn(a|0)}function DDa(a,b){a=a|0;b=b|0;yn(a|0)|0}function EDa(a,b){a=a|0;b=b|0;An(a|0)}function FDa(a,b){a=a|0;b=b|0;Bn(a|0)}function GDa(a,b){a=a|0;b=b|0;Cn(a|0,b|0)|0}function HDa(a,b){a=a|0;b=b|0;Dn(a|0)}function IDa(a,b){a=a|0;b=b|0;In(a|0,b|0,0)}function JDa(a,b){a=a|0;b=b|0;Rn(a|0,b|0,0)}function KDa(a,b){a=a|0;b=b|0;Sn(a|0,b|0,0)}function LDa(a,b){a=a|0;b=b|0;Tn(a|0,b|0,0)}function MDa(a,b){a=a|0;b=b|0;Un(a|0,b|0,0)}function NDa(a,b){a=a|0;b=b|0;_n(a|0,b|0)|0}function ODa(a,b){a=a|0;b=b|0;Qq(a|0)}function PDa(a,b){a=a|0;b=b|0;uu(a|0,b|0,0)|0}function QDa(a,b){a=a|0;b=b|0;ds(a|0,b|0)|0}function RDa(a,b){a=a|0;b=b|0;es(a|0,b|0)|0}function SDa(a,b){a=a|0;b=b|0;js(a|0,b|0)|0}function TDa(a,b){a=a|0;b=b|0;vu(a|0,b|0,0)|0}function UDa(a,b){a=a|0;b=b|0;wu(a|0,b|0)|0}function VDa(a,b){a=a|0;b=b|0;$r(a|0,b|0)|0}function WDa(a,b){a=a|0;b=b|0;as(a|0,b|0)|0}function XDa(a,b){a=a|0;b=b|0;bs(a|0,b|0)|0}function YDa(a,b){a=a|0;b=b|0;hs(a|0,b|0)|0}function ZDa(a,b){a=a|0;b=b|0;fs(a|0,b|0)|0}function _Da(a,b){a=a|0;b=b|0;is(a|0,b|0)|0;
}function $Da(a,b){a=a|0;b=b|0;cs(a|0,b|0)|0}function aEa(a,b){a=a|0;b=b|0;xu(a|0,b|0)|0}function bEa(a,b){a=a|0;b=b|0;gs(a|0,b|0)|0}function cEa(a,b){a=a|0;b=b|0;_r(a|0,b|0)|0}function dEa(a,b){a=a|0;b=b|0;dr(a|0,b|0)|0}function eEa(a,b){a=a|0;b=b|0;tw(a|0,b|0,0)}function fEa(a,b){a=a|0;b=b|0;Mw(a|0)}function gEa(a,b){a=a|0;b=b|0;Yw(a|0)}function hEa(a,b){a=a|0;b=b|0;Kx(a|0,b|0,0)|0}function iEa(a,b){a=a|0;b=b|0;$x(a|0,b|0)|0}function jEa(a,b){a=a|0;b=b|0;dy(a|0,b|0)|0}function kEa(a,b){a=a|0;b=b|0;fy(a|0,b|0)|0}function lEa(a,b){a=a|0;b=b|0;jy(a|0,b|0)|0}function mEa(a,b){a=a|0;b=b|0;qB(a|0)}function nEa(a,b){a=a|0;b=b|0;LB(a|0,b|0,0,0,0,0,0,0,0)}function oEa(a,b){a=a|0;b=b|0;MB(a|0,b|0,0,0)}function pEa(a,b){a=a|0;b=b|0;NB(a|0,b|0,0)}function qEa(a,b){a=a|0;b=b|0;OB(a|0,b|0,0)}function rEa(a,b){a=a|0;b=b|0;QB(a|0,b|0,0,0)}function sEa(a,b){a=a|0;b=b|0;RB(a|0)|0}function tEa(a,b){a=a|0;b=b|0;SB(a|0)|0}function uEa(a,b){a=a|0;b=b|0;TB(a|0)|0}function vEa(a,b){a=a|0;b=b|0;UB(a|0,b|0,0)|0}function wEa(a,b){a=a|0;b=b|0;VB(a|0,b|0)|0}function xEa(a,b){a=a|0;b=b|0;WB(a|0,b|0,0,0,0,0)}function yEa(a,b){a=a|0;b=b|0;XB(a|0,b|0,0,0)}function zEa(a,b){a=a|0;b=b|0;YB(a|0,b|0,0,0,0,0,0)}function AEa(a,b){a=a|0;b=b|0;ZB(a|0,b|0,0,0)}function BEa(a,b){a=a|0;b=b|0;_B(a|0,b|0,0,0,0)}function CEa(a,b){a=a|0;b=b|0;aC(a|0)}function DEa(a,b){a=a|0;b=b|0;bC(a|0)}function EEa(a,b){a=a|0;b=b|0;cC(a|0,b|0,0)}function FEa(a,b){a=a|0;b=b|0;eC(a|0,b|0,0)}function GEa(a,b){a=a|0;b=b|0;fC(a|0,b|0,0)}function HEa(a,b){a=a|0;b=b|0;gC(a|0,b|0,0)}function IEa(a,b){a=a|0;b=b|0;hC(a|0,b|0)|0}function JEa(a,b){a=a|0;b=b|0;iC(a|0,b|0,0,0)}function KEa(a,b){a=a|0;b=b|0;jC(a|0,b|0,0)}function LEa(a,b){a=a|0;b=b|0;kC(a|0,b|0,0)}function MEa(a,b){a=a|0;b=b|0;lC(a|0,b|0,0)}function NEa(a,b){a=a|0;b=b|0;nC(a|0,b|0,0,0,0,0,0,0,0)}function OEa(a,b){a=a|0;b=b|0;oC(a|0,b|0,0,0)}function PEa(a,b){a=a|0;b=b|0;rC(a|0,b|0,0)|0}function QEa(a,b){a=a|0;b=b|0;uC(a|0)}function REa(a,b){a=a|0;b=b|0;lF(a|0,b|0,0,0)}function SEa(a,b){a=a|0;b=b|0;VA(a|0)}function TEa(a,b){a=a|0;b=b|0;wM(a|0,b|0,0)}function UEa(a,b){a=a|0;b=b|0;yM(a|0,b|0,0,0,0,0,0,0,0)}function VEa(a,b){a=a|0;b=b|0;zM(a|0,b|0,0,0)}function WEa(a,b){a=a|0;b=b|0;AM(a|0,b|0,0)}function XEa(a,b){a=a|0;b=b|0;BM(a|0,b|0,0)}function YEa(a,b){a=a|0;b=b|0;DM(a|0,b|0,0)}function ZEa(a,b){a=a|0;b=b|0;EM(a|0,b|0,0)}function _Ea(a,b){a=a|0;b=b|0;GM(a|0,b|0,0)|0}function $Ea(a,b){a=a|0;b=b|0;UM(a|0)}function aFa(a,b){a=a|0;b=b|0;nN(a|0,b|0)|0}function bFa(a,b){a=a|0;b=b|0;oN(a|0,b|0,0,0,0)|0}function cFa(a,b){a=a|0;b=b|0;pN(a|0,b|0,0,0,0,0,0)|0}function dFa(a,b){a=a|0;b=b|0;qN(a|0,b|0,0,0,0,0)|0}function eFa(a,b){a=a|0;b=b|0;tN(a|0,b|0)|0}function fFa(a,b){a=a|0;b=b|0;uN(a|0,b|0,0,0,0)|0}function gFa(a,b){a=a|0;b=b|0;vN(a|0,b|0,0,0,0,0,0)|0}function hFa(a,b){a=a|0;b=b|0;CN(a|0,b|0,0)}function iFa(a,b){a=a|0;b=b|0;GN(a|0,b|0,0,0)}function jFa(a,b){a=a|0;b=b|0;vO(a|0,b|0,0)}function kFa(a,b){a=a|0;b=b|0;wO(a|0,b|0,0)}function lFa(a,b){a=a|0;b=b|0;fP(a|0,b|0,0,0)}function mFa(a,b){a=a|0;b=b|0;sP(a|0,b|0,0)}function nFa(a,b){a=a|0;b=b|0;fQ(a|0,b|0,0,0,0,0,0,0,0)}function oFa(a,b){a=a|0;b=b|0;gQ(a|0,b|0,0,0)}function pFa(a,b){a=a|0;b=b|0;WR(a|0,b|0,0,0)|0}function qFa(a,b){a=a|0;b=b|0;QS(a|0,b|0)|0}function rFa(a,b){a=a|0;b=b|0;hT(a|0,b|0,0)|0}function sFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;da(7);return 0}function tFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function uFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return vc(a|0)|0}function vFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return wc(a|0)|0}function wFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return xc(a|0)|0}function xFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return yc(a|0,b|0,c|0)|0}function yFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return zc(a|0,b|0)|0}function zFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function AFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function BFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function CFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function DFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function EFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function FFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function GFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function HFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function IFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function JFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function KFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function LFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function MFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function NFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function OFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function PFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function QFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function RFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Qc(a|0,b|0)|0}function SFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function TFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function UFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function VFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function WFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Xk(a|0,b|0,c|0)|0}function XFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function YFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return iT(a|0)|0}function ZFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return kT(a|0,b|0)|0}function _Fa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return my(a|0)|0}function $Fa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function aGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function bGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return PP(a|0)|0}function cGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return QP(a|0)|0}function dGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return RP(a|0)|0}function eGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return UP(a|0,b|0,c|0)|0}function fGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return VP(a|0,b|0)|0}function gGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function hGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function iGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function jGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function kGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function lGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function mGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function nGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function oGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function pGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function qGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function rGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function sGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function tGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function uGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function vGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function wGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return WP(a|0,b|0)|0}function xGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function yGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function zGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return LP(a|0)|0}function AGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return MP(a|0)|0}function BGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return NP(a|0)|0}function CGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return OP(a|0)|0}function DGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function EGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return NI(a|0)|0}function FGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return OI(a|0)|0}function GGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return PI(a|0)|0}function HGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return QI(a|0)|0}function IGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return RI(a|0)|0}function JGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return SI(a|0)|0}function KGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return TI(a|0)|0}function LGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return UI(a|0)|0}function MGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return VI(a|0)|0}function NGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return WI(a|0)|0}function OGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return XI(a|0)|0}function PGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return YI(a|0)|0}function QGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ZI(a|0)|0}function RGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return _I(a|0)|0}function SGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return $I(a|0)|0}function TGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return aJ(a|0)|0}function UGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return bJ(a|0)|0}function VGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return cJ(a|0)|0}function WGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return dJ(a|0)|0}function XGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return eJ(a|0)|0}function YGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return fJ(a|0)|0}function ZGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return gJ(a|0)|0}function _Ga(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return hJ(a|0)|0}function $Ga(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return iJ(a|0)|0}function aHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return jJ(a|0)|0}function bHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return kJ(a|0)|0}function cHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return lJ(a|0)|0}function dHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return mJ(a|0)|0}function eHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return nJ(a|0)|0}function fHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return oJ(a|0)|0}function gHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return pJ(a|0)|0}function hHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return qJ(a|0)|0}function iHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return rJ(a|0)|0}function jHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return sJ(a|0)|0}function kHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return tJ(a|0)|0}function lHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return uJ(a|0)|0}function mHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return vJ(a|0)|0}function nHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return wJ(a|0)|0}function oHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return xJ(a|0)|0}function pHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return yJ(a|0)|0}function qHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return zJ(a|0)|0}function rHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return AJ(a|0)|0}function sHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return BJ(a|0)|0}function tHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return CJ(a|0)|0}function uHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return DJ(a|0)|0}function vHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return EJ(a|0)|0}function wHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return FJ(a|0)|0}function xHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return GJ(a|0)|0}function yHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return HJ(a|0)|0}function zHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return IJ(a|0)|0}function AHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return JJ(a|0)|0}function BHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return KJ(a|0)|0}function CHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return LJ(a|0)|0}function DHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return MJ(a|0)|0}function EHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return NJ(a|0)|0}function FHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return OJ(a|0)|0}function GHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return PJ(a|0)|0}function HHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return QJ(a|0)|0}function IHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return RJ(a|0)|0}function JHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return SJ(a|0)|0}function KHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return TJ(a|0)|0}function LHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return UJ(a|0)|0}function MHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return VJ(a|0)|0}function NHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return WJ(a|0)|0}function OHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return XJ(a|0)|0}function PHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return YJ(a|0)|0}function QHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ZJ(a|0)|0}function RHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return _J(a|0)|0}function SHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return $J(a|0)|0}function THa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return aK(a|0)|0}function UHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return bK(a|0)|0}function VHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return cK(a|0)|0}function WHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return dK(a|0)|0}function XHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return eK(a|0)|0}function YHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return fK(a|0)|0}function ZHa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return gK(a|0)|0}function _Ha(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return hK(a|0)|0}function $Ha(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return iK(a|0)|0}function aIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return jK(a|0)|0}function bIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return kK(a|0)|0}function cIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return lK(a|0)|0}function dIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return mK(a|0)|0}function eIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return nK(a|0)|0}function fIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return oK(a|0)|0}function gIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return pK(a|0)|0}function hIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return qK(a|0)|0}function iIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return rK(a|0)|0}function jIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return sK(a|0)|0}function kIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return tK(a|0)|0}function lIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return uK(a|0)|0}function mIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return vK(a|0)|0}function nIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return wK(a|0)|0}function oIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return xK(a|0)|0}function pIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return yK(a|0)|0}function qIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return zK(a|0)|0}function rIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return AK(a|0)|0}function sIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return BK(a|0)|0}function tIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return CK(a|0)|0}function uIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return DK(a|0)|0}function vIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return EK(a|0)|0}function wIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return FK(a|0)|0}function xIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return GK(a|0)|0}function yIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return HK(a|0)|0}function zIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return IK(a|0)|0}function AIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return JK(a|0)|0}function BIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return KK(a|0)|0}function CIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return LK(a|0)|0}function DIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return MK(a|0)|0}function EIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return NK(a|0)|0}function FIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return OK(a|0)|0}function GIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return PK(a|0)|0}function HIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return QK(a|0)|0}function IIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return RK(a|0)|0}function JIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return SK(a|0)|0}function KIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return TK(a|0)|0}function LIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return UK(a|0)|0}function MIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return VK(a|0)|0}function NIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return WK(a|0)|0}function OIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return XK(a|0)|0}function PIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return YK(a|0)|0}function QIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ZK(a|0)|0}function RIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return _K(a|0)|0}function SIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return $K(a|0)|0}function TIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return aL(a|0)|0}function UIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return bL(a|0)|0}function VIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return cL(a|0)|0}function WIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return dL(a|0)|0}function XIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return eL(a|0)|0}function YIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return RT(a|0,b|0,c|0)|0}function ZIa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function _Ia(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Wb(a|0)|0}function $Ia(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Xb(a|0,b|0)|0}function aJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Yb(a|0)|0}function bJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Wk(a|0,b|0,c|0)|0}function cJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function dJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function eJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ac(a|0,b|0,c|0)|0}function fJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Ka(a|0,b|0,c|0)|0}function gJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return gc(a|0,b|0,c|0)|0}function hJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function iJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function jJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function kJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function lJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function mJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return nc(a|0)|0}function nJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function oJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return nd(a|0)|0}function pJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Kd(a|0,b|0,c|0,d|0)|0}function qJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Ld(a|0,b|0,c|0,d|0)|0}function rJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Md(a|0,b|0,c|0,d|0)|0}function sJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Nd(a|0,b|0,c|0,d|0)|0}function tJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Od(a|0,b|0,c|0,d|0)|0}function uJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Pd(a|0,b|0,c|0,d|0)|0}function vJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return qd(a|0,b|0,c|0,d|0)|0}function wJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return rd(a|0,b|0,c|0,d|0)|0}function xJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Qd(a|0,b|0,c|0,d|0)|0}function yJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Rd(a|0,b|0,c|0,d|0)|0}function zJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return fo(a|0,b|0,c|0,d|0)|0}function AJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function BJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function CJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function DJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return mk()|0}function EJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function FJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function GJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return nk(a|0)|0}function HJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ok(a|0)|0}function IJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return pk(a|0,b|0,c|0)|0}function JJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return qk(a|0)|0}function KJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return _k(a|0)|0}function LJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return $k(a|0,b|0,c|0)|0}function MJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return bl(a|0)|0}function NJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return cl(a|0,b|0,c|0)|0}function OJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return dl(a|0)|0}function PJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return el(a|0,b|0,c|0)|0}function QJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return fl(a|0,b|0,c|0)|0}function RJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return gl(a|0,b|0,c|0,d|0)|0}function SJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function TJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return on(a|0)|0}function UJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function VJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return vn(a|0)|0}function WJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function XJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return yn(a|0)|0}function YJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function ZJa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function _Ja(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function $Ja(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Cn(a|0,b|0)|0}function aKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function bKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function cKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function dKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function eKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function fKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function gKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return _n(a|0,b|0)|0}function hKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function iKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function jKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function kKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function lKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function mKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function nKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function oKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function pKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function qKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function rKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function sKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function tKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function uKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function vKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function wKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function xKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function yKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function zKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function AKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function BKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function CKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function DKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function EKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function FKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function GKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function HKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function IKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function JKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function KKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function LKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return uu(a|0,b|0,c|0)|0}function MKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ds(a|0,b|0)|0}function NKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return es(a|0,b|0)|0}function OKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return js(a|0,b|0)|0}function PKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return vu(a|0,b|0,c|0)|0}function QKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return wu(a|0,b|0)|0}function RKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return $r(a|0,b|0)|0}function SKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return as(a|0,b|0)|0}function TKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return bs(a|0,b|0)|0}function UKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return hs(a|0,b|0)|0}function VKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return fs(a|0,b|0)|0}function WKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return is(a|0,b|0)|0}function XKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return cs(a|0,b|0)|0}function YKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return xu(a|0,b|0)|0}function ZKa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return gs(a|0,b|0)|0}function _Ka(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return _r(a|0,b|0)|0}function $Ka(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return dr(a|0,b|0)|0}function aLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function bLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function cLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function dLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function eLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function fLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function gLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function hLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function iLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function jLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function kLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function lLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Kx(a|0,b|0,c|0)|0}function mLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return $x(a|0,b|0)|0}function nLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return dy(a|0,b|0)|0}function oLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return fy(a|0,b|0)|0}function pLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return jy(a|0,b|0)|0}function qLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function rLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function sLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function tLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function uLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function vLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function wLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function xLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return RB(a|0)|0}function yLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return SB(a|0)|0}function zLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return TB(a|0)|0}function ALa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return UB(a|0,b|0,c|0)|0}function BLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return VB(a|0,b|0)|0}function CLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function DLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function ELa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function FLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function GLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function HLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function ILa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function JLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function KLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function LLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function MLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function NLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function OLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function PLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return hC(a|0,b|0)|0}function QLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function RLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function SLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function TLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function ULa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function VLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function WLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function XLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return rC(a|0,b|0,c|0)|0}function YLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function ZLa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function _La(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function $La(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function aMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function bMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function cMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function dMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function eMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function fMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function gMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function hMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function iMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function jMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return GM(a|0,b|0,c|0)|0}function kMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function lMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function mMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return nN(a|0,b|0)|0}function nMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;
return oN(a|0,b|0,c|0,d|0,e|0)|0}function oMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return pN(a|0,b|0,c|0,d|0,e|0,f|0,0)|0}function pMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function qMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return tN(a|0,b|0)|0}function rMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return uN(a|0,b|0,c|0,d|0,e|0)|0}function sMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return vN(a|0,b|0,c|0,d|0,e|0,f|0,0)|0}function tMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function uMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function vMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function wMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function xMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function yMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function zMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function AMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function BMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return 0}function CMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return WR(a|0,b|0,c|0,d|0)|0}function DMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return QS(a|0,b|0)|0}function EMa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return hT(a|0,b|0,c|0)|0}function FMa(a){a=a|0;da(8);return 0}function GMa(a){a=a|0;return 0}function HMa(a){a=a|0;return yc(a|0,0,0)|0}function IMa(a){a=a|0;return zc(a|0,0)|0}function JMa(a){a=a|0;return 0}function KMa(a){a=a|0;return 0}function LMa(a){a=a|0;return 0}function MMa(a){a=a|0;return 0}function NMa(a){a=a|0;return 0}function OMa(a){a=a|0;return 0}function PMa(a){a=a|0;return 0}function QMa(a){a=a|0;return 0}function RMa(a){a=a|0;return 0}function SMa(a){a=a|0;return 0}function TMa(a){a=a|0;return 0}function UMa(a){a=a|0;return 0}function VMa(a){a=a|0;return 0}function WMa(a){a=a|0;return 0}function XMa(a){a=a|0;return 0}function YMa(a){a=a|0;return 0}function ZMa(a){a=a|0;return 0}function _Ma(a){a=a|0;return 0}function $Ma(a){a=a|0;return Qc(a|0,0)|0}function aNa(a){a=a|0;return 0}function bNa(a){a=a|0;return 0}function cNa(a){a=a|0;return 0}function dNa(a){a=a|0;return 0}function eNa(a){a=a|0;return Xk(a|0,0,0)|0}function fNa(a){a=a|0;return 0}function gNa(a){a=a|0;return kT(a|0,0)|0}function hNa(a){a=a|0;return 0}function iNa(a){a=a|0;return 0}function jNa(a){a=a|0;return UP(a|0,0,0)|0}function kNa(a){a=a|0;return VP(a|0,0)|0}function lNa(a){a=a|0;return 0}function mNa(a){a=a|0;return 0}function nNa(a){a=a|0;return 0}function oNa(a){a=a|0;return 0}function pNa(a){a=a|0;return 0}function qNa(a){a=a|0;return 0}function rNa(a){a=a|0;return 0}function sNa(a){a=a|0;return 0}function tNa(a){a=a|0;return 0}function uNa(a){a=a|0;return 0}function vNa(a){a=a|0;return 0}function wNa(a){a=a|0;return 0}function xNa(a){a=a|0;return 0}function yNa(a){a=a|0;return 0}function zNa(a){a=a|0;return 0}function ANa(a){a=a|0;return 0}function BNa(a){a=a|0;return WP(a|0,0)|0}function CNa(a){a=a|0;return 0}function DNa(a){a=a|0;return 0}function ENa(a){a=a|0;return 0}function FNa(a){a=a|0;return RT(a|0,0,0)|0}function GNa(a){a=a|0;return 0}function HNa(a){a=a|0;return Xb(a|0,0)|0}function INa(a){a=a|0;return Wk(a|0,0,0)|0}function JNa(a){a=a|0;return 0}function KNa(a){a=a|0;return 0}function LNa(a){a=a|0;return ac(a|0,0,0)|0}function MNa(a){a=a|0;return Ka(a|0,0,0)|0}function NNa(a){a=a|0;return gc(a|0,0,0)|0}function ONa(a){a=a|0;return 0}function PNa(a){a=a|0;return 0}function QNa(a){a=a|0;return 0}function RNa(a){a=a|0;return 0}function SNa(a){a=a|0;return 0}function TNa(a){a=a|0;return 0}function UNa(a){a=a|0;return Kd(a|0,0,0,0)|0}function VNa(a){a=a|0;return Ld(a|0,0,0,0)|0}function WNa(a){a=a|0;return Md(a|0,0,0,0)|0}function XNa(a){a=a|0;return Nd(a|0,0,0,0)|0}function YNa(a){a=a|0;return Od(a|0,0,0,0)|0}function ZNa(a){a=a|0;return Pd(a|0,0,0,0)|0}function _Na(a){a=a|0;return qd(a|0,0,0,0)|0}function $Na(a){a=a|0;return rd(a|0,0,0,0)|0}function aOa(a){a=a|0;return Qd(a|0,0,0,0)|0}function bOa(a){a=a|0;return Rd(a|0,0,0,0)|0}function cOa(a){a=a|0;return fo(a|0,0,0,0)|0}function dOa(a){a=a|0;return 0}function eOa(a){a=a|0;return 0}function fOa(a){a=a|0;return 0}function gOa(a){a=a|0;return mk()|0}function hOa(a){a=a|0;return 0}function iOa(a){a=a|0;return 0}function jOa(a){a=a|0;return pk(a|0,0,0)|0}function kOa(a){a=a|0;return $k(a|0,0,0)|0}function lOa(a){a=a|0;return cl(a|0,0,0)|0}function mOa(a){a=a|0;return el(a|0,0,0)|0}function nOa(a){a=a|0;return fl(a|0,0,0)|0}function oOa(a){a=a|0;return gl(a|0,0,0,0)|0}function pOa(a){a=a|0;return 0}function qOa(a){a=a|0;return 0}function rOa(a){a=a|0;return 0}function sOa(a){a=a|0;return 0}function tOa(a){a=a|0;return 0}function uOa(a){a=a|0;return 0}function vOa(a){a=a|0;return Cn(a|0,0)|0}function wOa(a){a=a|0;return 0}function xOa(a){a=a|0;return 0}function yOa(a){a=a|0;return 0}function zOa(a){a=a|0;return 0}function AOa(a){a=a|0;return 0}function BOa(a){a=a|0;return 0}function COa(a){a=a|0;return _n(a|0,0)|0}function DOa(a){a=a|0;return 0}function EOa(a){a=a|0;return 0}function FOa(a){a=a|0;return 0}function GOa(a){a=a|0;return 0}function HOa(a){a=a|0;return 0}function IOa(a){a=a|0;return 0}function JOa(a){a=a|0;return 0}function KOa(a){a=a|0;return 0}function LOa(a){a=a|0;return 0}function MOa(a){a=a|0;return 0}function NOa(a){a=a|0;return 0}function OOa(a){a=a|0;return 0}function POa(a){a=a|0;return 0}function QOa(a){a=a|0;return 0}function ROa(a){a=a|0;return 0}function SOa(a){a=a|0;return 0}function TOa(a){a=a|0;return 0}function UOa(a){a=a|0;return 0}function VOa(a){a=a|0;return 0}function WOa(a){a=a|0;return 0}function XOa(a){a=a|0;return 0}function YOa(a){a=a|0;return 0}function ZOa(a){a=a|0;return 0}function _Oa(a){a=a|0;return 0}function $Oa(a){a=a|0;return 0}function aPa(a){a=a|0;return 0}function bPa(a){a=a|0;return 0}function cPa(a){a=a|0;return 0}function dPa(a){a=a|0;return 0}function ePa(a){a=a|0;return 0}function fPa(a){a=a|0;return uu(a|0,0,0)|0}function gPa(a){a=a|0;return ds(a|0,0)|0}function hPa(a){a=a|0;return es(a|0,0)|0}function iPa(a){a=a|0;return js(a|0,0)|0}function jPa(a){a=a|0;return vu(a|0,0,0)|0}function kPa(a){a=a|0;return wu(a|0,0)|0}function lPa(a){a=a|0;return $r(a|0,0)|0}function mPa(a){a=a|0;return as(a|0,0)|0}function nPa(a){a=a|0;return bs(a|0,0)|0}function oPa(a){a=a|0;return hs(a|0,0)|0}function pPa(a){a=a|0;return fs(a|0,0)|0}function qPa(a){a=a|0;return is(a|0,0)|0}function rPa(a){a=a|0;return cs(a|0,0)|0}function sPa(a){a=a|0;return xu(a|0,0)|0}function tPa(a){a=a|0;return gs(a|0,0)|0}function uPa(a){a=a|0;return _r(a|0,0)|0}function vPa(a){a=a|0;return dr(a|0,0)|0}function wPa(a){a=a|0;return 0}function xPa(a){a=a|0;return 0}function yPa(a){a=a|0;return 0}function zPa(a){a=a|0;return 0}function APa(a){a=a|0;return 0}function BPa(a){a=a|0;return 0}function CPa(a){a=a|0;return 0}function DPa(a){a=a|0;return 0}function EPa(a){a=a|0;return 0}function FPa(a){a=a|0;return 0}function GPa(a){a=a|0;return 0}function HPa(a){a=a|0;return Kx(a|0,0,0)|0}function IPa(a){a=a|0;return $x(a|0,0)|0}function JPa(a){a=a|0;return dy(a|0,0)|0}function KPa(a){a=a|0;return fy(a|0,0)|0}function LPa(a){a=a|0;return jy(a|0,0)|0}function MPa(a){a=a|0;return 0}function NPa(a){a=a|0;return 0}function OPa(a){a=a|0;return 0}function PPa(a){a=a|0;return 0}function QPa(a){a=a|0;return 0}function RPa(a){a=a|0;return 0}function SPa(a){a=a|0;return 0}function TPa(a){a=a|0;return UB(a|0,0,0)|0}function UPa(a){a=a|0;return VB(a|0,0)|0}function VPa(a){a=a|0;return 0}function WPa(a){a=a|0;return 0}function XPa(a){a=a|0;return 0}function YPa(a){a=a|0;return 0}function ZPa(a){a=a|0;return 0}function _Pa(a){a=a|0;return 0}function $Pa(a){a=a|0;return 0}function aQa(a){a=a|0;return 0}function bQa(a){a=a|0;return 0}function cQa(a){a=a|0;return 0}function dQa(a){a=a|0;return 0}function eQa(a){a=a|0;return 0}function fQa(a){a=a|0;return 0}function gQa(a){a=a|0;return hC(a|0,0)|0}function hQa(a){a=a|0;return 0}function iQa(a){a=a|0;return 0}function jQa(a){a=a|0;return 0}function kQa(a){a=a|0;return 0}function lQa(a){a=a|0;return 0}function mQa(a){a=a|0;return 0}function nQa(a){a=a|0;return 0}function oQa(a){a=a|0;return rC(a|0,0,0)|0}function pQa(a){a=a|0;return 0}function qQa(a){a=a|0;return 0}function rQa(a){a=a|0;return 0}function sQa(a){a=a|0;return 0}function tQa(a){a=a|0;return 0}function uQa(a){a=a|0;return 0}function vQa(a){a=a|0;return 0}function wQa(a){a=a|0;return 0}function xQa(a){a=a|0;return 0}function yQa(a){a=a|0;return 0}function zQa(a){a=a|0;return 0}function AQa(a){a=a|0;return 0}function BQa(a){a=a|0;return 0}function CQa(a){a=a|0;return GM(a|0,0,0)|0}function DQa(a){a=a|0;return 0}function EQa(a){a=a|0;return 0}function FQa(a){a=a|0;return nN(a|0,0)|0}function GQa(a){a=a|0;return oN(a|0,0,0,0,0)|0}function HQa(a){a=a|0;return pN(a|0,0,0,0,0,0,0)|0}function IQa(a){a=a|0;return qN(a|0,0,0,0,0,0)|0}function JQa(a){a=a|0;return 0}function KQa(a){a=a|0;return tN(a|0,0)|0}function LQa(a){a=a|0;return uN(a|0,0,0,0,0)|0}function MQa(a){a=a|0;return vN(a|0,0,0,0,0,0,0)|0}function NQa(a){a=a|0;return 0}function OQa(a){a=a|0;return 0}function PQa(a){a=a|0;return 0}function QQa(a){a=a|0;return 0}function RQa(a){a=a|0;return 0}function SQa(a){a=a|0;return 0}function TQa(a){a=a|0;return 0}function UQa(a){a=a|0;return 0}function VQa(a){a=a|0;return 0}function WQa(a){a=a|0;return WR(a|0,0,0,0)|0}function XQa(a){a=a|0;return QS(a|0,0)|0}function YQa(a){a=a|0;return hT(a|0,0,0)|0}function ZQa(a,b,c){a=a|0;b=b|0;c=c|0;da(9)}function _Qa(a,b,c){a=a|0;b=b|0;c=c|0;uc(a|0,b|0,c|0,0)}function $Qa(a,b,c){a=a|0;b=b|0;c=c|0;vc(a|0)|0}function aRa(a,b,c){a=a|0;b=b|0;c=c|0;wc(a|0)|0}function bRa(a,b,c){a=a|0;b=b|0;c=c|0;xc(a|0)|0}function cRa(a,b,c){a=a|0;b=b|0;c=c|0;yc(a|0,b|0,c|0)|0}function dRa(a,b,c){a=a|0;b=b|0;c=c|0;zc(a|0,b|0)|0}function eRa(a,b,c){a=a|0;b=b|0;c=c|0;Ac(a|0,b|0,c|0,0,0,0)}function fRa(a,b,c){a=a|0;b=b|0;c=c|0;Bc(a|0,b|0,c|0,0)}function gRa(a,b,c){a=a|0;b=b|0;c=c|0;Cc(a|0,b|0,c|0,0,0,0,0)}function hRa(a,b,c){a=a|0;b=b|0;c=c|0;Dc(a|0,b|0,c|0,0)}function iRa(a,b,c){a=a|0;b=b|0;c=c|0;Ec(a|0,b|0,c|0,0,0)}function jRa(a,b,c){a=a|0;b=b|0;c=c|0;Fc(a|0,b|0)}function kRa(a,b,c){a=a|0;b=b|0;c=c|0;Gc(a|0)}function lRa(a,b,c){a=a|0;b=b|0;c=c|0;Hc(a|0)}function mRa(a,b,c){a=a|0;b=b|0;c=c|0;Xc(a|0,b|0)}function nRa(a,b,c){a=a|0;b=b|0;c=c|0;Ic(a|0,b|0)}function oRa(a,b,c){a=a|0;b=b|0;c=c|0;Mc(a|0,b|0)}function pRa(a,b,c){a=a|0;b=b|0;c=c|0;Qc(a|0,b|0)|0}function qRa(a,b,c){a=a|0;b=b|0;c=c|0;Sc(a|0,b|0,c|0,0)}function rRa(a,b,c){a=a|0;b=b|0;c=c|0;Tc(a|0,b|0,c|0,0,0,0,0,0,0)}function sRa(a,b,c){a=a|0;b=b|0;c=c|0;Uc(a|0,b|0,c|0,0)}function tRa(a,b,c){a=a|0;b=b|0;c=c|0;Xk(a|0,b|0,c|0)|0}function uRa(a,b,c){a=a|0;b=b|0;c=c|0;jT(a|0)}function vRa(a,b,c){a=a|0;b=b|0;c=c|0;iT(a|0)|0}function wRa(a,b,c){a=a|0;b=b|0;c=c|0;kT(a|0,b|0)|0}function xRa(a,b,c){a=a|0;b=b|0;c=c|0;my(a|0)|0}function yRa(a,b,c){a=a|0;b=b|0;c=c|0;SP(a|0,b|0,c|0,0)}function zRa(a,b,c){a=a|0;b=b|0;c=c|0;PP(a|0)|0}function ARa(a,b,c){a=a|0;b=b|0;c=c|0;QP(a|0)|0}function BRa(a,b,c){a=a|0;b=b|0;c=c|0;RP(a|0)|0}function CRa(a,b,c){a=a|0;b=b|0;c=c|0;UP(a|0,b|0,c|0)|0}function DRa(a,b,c){a=a|0;b=b|0;c=c|0;VP(a|0,b|0)|0}function ERa(a,b,c){a=a|0;b=b|0;c=c|0;XP(a|0,b|0,c|0,0,0,0)}function FRa(a,b,c){a=a|0;b=b|0;c=c|0;_P(a|0,b|0,c|0,0)}function GRa(a,b,c){a=a|0;b=b|0;c=c|0;YP(a|0,b|0,c|0,0,0,0,0)}function HRa(a,b,c){a=a|0;b=b|0;c=c|0;ZP(a|0,b|0,c|0,0)}function IRa(a,b,c){a=a|0;b=b|0;c=c|0;$P(a|0,b|0,c|0,0,0)}function JRa(a,b,c){a=a|0;b=b|0;c=c|0;aQ(a|0,b|0)}function KRa(a,b,c){a=a|0;b=b|0;c=c|0;bQ(a|0)}function LRa(a,b,c){a=a|0;b=b|0;c=c|0;cQ(a|0)}function MRa(a,b,c){a=a|0;b=b|0;c=c|0;eQ(a|0,b|0)}function NRa(a,b,c){a=a|0;b=b|0;c=c|0;hQ(a|0,b|0)}function ORa(a,b,c){a=a|0;b=b|0;c=c|0;lQ(a|0,b|0)}function PRa(a,b,c){a=a|0;b=b|0;c=c|0;WP(a|0,b|0)|0}function QRa(a,b,c){a=a|0;b=b|0;c=c|0;TP(a|0,b|0,c|0,0)}function RRa(a,b,c){a=a|0;b=b|0;c=c|0;LP(a|0)|0}function SRa(a,b,c){a=a|0;b=b|0;c=c|0;MP(a|0)|0}function TRa(a,b,c){a=a|0;b=b|0;c=c|0;NP(a|0)|0}function URa(a,b,c){a=a|0;b=b|0;c=c|0;OP(a|0)|0}function VRa(a,b,c){a=a|0;b=b|0;c=c|0;NI(a|0)|0}function WRa(a,b,c){a=a|0;b=b|0;c=c|0;OI(a|0)|0}function XRa(a,b,c){a=a|0;b=b|0;c=c|0;PI(a|0)|0}function YRa(a,b,c){a=a|0;b=b|0;c=c|0;QI(a|0)|0}function ZRa(a,b,c){a=a|0;b=b|0;c=c|0;RI(a|0)|0}function _Ra(a,b,c){a=a|0;b=b|0;c=c|0;SI(a|0)|0}function $Ra(a,b,c){a=a|0;b=b|0;c=c|0;TI(a|0)|0}function aSa(a,b,c){a=a|0;b=b|0;c=c|0;UI(a|0)|0}function bSa(a,b,c){a=a|0;b=b|0;c=c|0;VI(a|0)|0}function cSa(a,b,c){a=a|0;b=b|0;c=c|0;WI(a|0)|0}function dSa(a,b,c){a=a|0;b=b|0;c=c|0;XI(a|0)|0}function eSa(a,b,c){a=a|0;b=b|0;c=c|0;YI(a|0)|0}function fSa(a,b,c){a=a|0;b=b|0;c=c|0;ZI(a|0)|0}function gSa(a,b,c){a=a|0;b=b|0;c=c|0;_I(a|0)|0}function hSa(a,b,c){a=a|0;b=b|0;c=c|0;$I(a|0)|0}function iSa(a,b,c){a=a|0;b=b|0;c=c|0;aJ(a|0)|0}function jSa(a,b,c){a=a|0;b=b|0;c=c|0;bJ(a|0)|0}function kSa(a,b,c){a=a|0;b=b|0;c=c|0;cJ(a|0)|0}function lSa(a,b,c){a=a|0;b=b|0;c=c|0;dJ(a|0)|0}function mSa(a,b,c){a=a|0;b=b|0;c=c|0;eJ(a|0)|0}function nSa(a,b,c){a=a|0;b=b|0;c=c|0;fJ(a|0)|0}function oSa(a,b,c){a=a|0;b=b|0;c=c|0;gJ(a|0)|0}function pSa(a,b,c){a=a|0;b=b|0;c=c|0;hJ(a|0)|0}function qSa(a,b,c){a=a|0;b=b|0;c=c|0;iJ(a|0)|0}function rSa(a,b,c){a=a|0;b=b|0;c=c|0;jJ(a|0)|0}function sSa(a,b,c){a=a|0;b=b|0;c=c|0;kJ(a|0)|0}function tSa(a,b,c){a=a|0;b=b|0;c=c|0;lJ(a|0)|0}function uSa(a,b,c){a=a|0;b=b|0;c=c|0;mJ(a|0)|0}function vSa(a,b,c){a=a|0;b=b|0;c=c|0;nJ(a|0)|0}function wSa(a,b,c){a=a|0;b=b|0;c=c|0;oJ(a|0)|0}function xSa(a,b,c){a=a|0;b=b|0;c=c|0;pJ(a|0)|0}function ySa(a,b,c){a=a|0;b=b|0;c=c|0;qJ(a|0)|0}function zSa(a,b,c){a=a|0;b=b|0;c=c|0;rJ(a|0)|0}function ASa(a,b,c){a=a|0;b=b|0;c=c|0;sJ(a|0)|0}function BSa(a,b,c){a=a|0;b=b|0;c=c|0;tJ(a|0)|0}function CSa(a,b,c){a=a|0;b=b|0;c=c|0;uJ(a|0)|0}function DSa(a,b,c){a=a|0;b=b|0;c=c|0;vJ(a|0)|0}function ESa(a,b,c){a=a|0;b=b|0;c=c|0;wJ(a|0)|0}function FSa(a,b,c){a=a|0;b=b|0;c=c|0;xJ(a|0)|0}function GSa(a,b,c){a=a|0;b=b|0;c=c|0;yJ(a|0)|0}function HSa(a,b,c){a=a|0;b=b|0;c=c|0;zJ(a|0)|0}function ISa(a,b,c){a=a|0;b=b|0;c=c|0;AJ(a|0)|0}function JSa(a,b,c){a=a|0;b=b|0;c=c|0;BJ(a|0)|0}function KSa(a,b,c){a=a|0;b=b|0;c=c|0;CJ(a|0)|0}function LSa(a,b,c){a=a|0;b=b|0;c=c|0;DJ(a|0)|0}function MSa(a,b,c){a=a|0;b=b|0;c=c|0;EJ(a|0)|0}function NSa(a,b,c){a=a|0;b=b|0;c=c|0;FJ(a|0)|0}function OSa(a,b,c){a=a|0;b=b|0;c=c|0;GJ(a|0)|0}function PSa(a,b,c){a=a|0;b=b|0;c=c|0;HJ(a|0)|0}function QSa(a,b,c){a=a|0;b=b|0;c=c|0;IJ(a|0)|0}function RSa(a,b,c){a=a|0;b=b|0;c=c|0;JJ(a|0)|0}function SSa(a,b,c){a=a|0;b=b|0;c=c|0;KJ(a|0)|0}function TSa(a,b,c){a=a|0;b=b|0;c=c|0;LJ(a|0)|0}function USa(a,b,c){a=a|0;b=b|0;c=c|0;MJ(a|0)|0}function VSa(a,b,c){a=a|0;b=b|0;c=c|0;NJ(a|0)|0}function WSa(a,b,c){a=a|0;b=b|0;c=c|0;OJ(a|0)|0}function XSa(a,b,c){a=a|0;b=b|0;c=c|0;PJ(a|0)|0}function YSa(a,b,c){a=a|0;b=b|0;c=c|0;QJ(a|0)|0}function ZSa(a,b,c){a=a|0;b=b|0;c=c|0;RJ(a|0)|0}function _Sa(a,b,c){a=a|0;b=b|0;c=c|0;SJ(a|0)|0}function $Sa(a,b,c){a=a|0;b=b|0;c=c|0;TJ(a|0)|0}function aTa(a,b,c){a=a|0;b=b|0;c=c|0;UJ(a|0)|0}function bTa(a,b,c){a=a|0;b=b|0;c=c|0;VJ(a|0)|0}function cTa(a,b,c){a=a|0;b=b|0;c=c|0;WJ(a|0)|0}function dTa(a,b,c){a=a|0;b=b|0;c=c|0;XJ(a|0)|0}function eTa(a,b,c){a=a|0;b=b|0;c=c|0;YJ(a|0)|0}function fTa(a,b,c){a=a|0;b=b|0;c=c|0;ZJ(a|0)|0}function gTa(a,b,c){a=a|0;b=b|0;c=c|0;_J(a|0)|0}function hTa(a,b,c){a=a|0;b=b|0;c=c|0;$J(a|0)|0}function iTa(a,b,c){a=a|0;b=b|0;c=c|0;aK(a|0)|0}function jTa(a,b,c){a=a|0;b=b|0;c=c|0;bK(a|0)|0}function kTa(a,b,c){a=a|0;b=b|0;c=c|0;cK(a|0)|0}function lTa(a,b,c){a=a|0;b=b|0;c=c|0;dK(a|0)|0}function mTa(a,b,c){a=a|0;b=b|0;c=c|0;eK(a|0)|0}function nTa(a,b,c){a=a|0;b=b|0;c=c|0;fK(a|0)|0}function oTa(a,b,c){a=a|0;b=b|0;c=c|0;gK(a|0)|0}function pTa(a,b,c){a=a|0;b=b|0;c=c|0;hK(a|0)|0}function qTa(a,b,c){a=a|0;b=b|0;c=c|0;iK(a|0)|0}function rTa(a,b,c){a=a|0;b=b|0;c=c|0;jK(a|0)|0}function sTa(a,b,c){a=a|0;b=b|0;c=c|0;kK(a|0)|0}function tTa(a,b,c){a=a|0;b=b|0;c=c|0;lK(a|0)|0}function uTa(a,b,c){a=a|0;b=b|0;c=c|0;mK(a|0)|0}function vTa(a,b,c){a=a|0;b=b|0;c=c|0;nK(a|0)|0}function wTa(a,b,c){a=a|0;b=b|0;c=c|0;oK(a|0)|0}function xTa(a,b,c){a=a|0;b=b|0;c=c|0;pK(a|0)|0}function yTa(a,b,c){a=a|0;b=b|0;c=c|0;qK(a|0)|0}function zTa(a,b,c){a=a|0;b=b|0;c=c|0;rK(a|0)|0}function ATa(a,b,c){a=a|0;b=b|0;c=c|0;sK(a|0)|0}function BTa(a,b,c){a=a|0;b=b|0;c=c|0;tK(a|0)|0}function CTa(a,b,c){a=a|0;b=b|0;c=c|0;uK(a|0)|0}function DTa(a,b,c){a=a|0;b=b|0;c=c|0;vK(a|0)|0}function ETa(a,b,c){a=a|0;b=b|0;c=c|0;wK(a|0)|0}function FTa(a,b,c){a=a|0;b=b|0;c=c|0;xK(a|0)|0}function GTa(a,b,c){a=a|0;b=b|0;c=c|0;yK(a|0)|0}function HTa(a,b,c){a=a|0;b=b|0;c=c|0;zK(a|0)|0}function ITa(a,b,c){a=a|0;b=b|0;c=c|0;AK(a|0)|0}function JTa(a,b,c){a=a|0;b=b|0;c=c|0;BK(a|0)|0}function KTa(a,b,c){a=a|0;b=b|0;c=c|0;CK(a|0)|0}function LTa(a,b,c){a=a|0;b=b|0;c=c|0;DK(a|0)|0}function MTa(a,b,c){a=a|0;b=b|0;c=c|0;EK(a|0)|0}function NTa(a,b,c){a=a|0;b=b|0;c=c|0;FK(a|0)|0}function OTa(a,b,c){a=a|0;b=b|0;c=c|0;GK(a|0)|0}function PTa(a,b,c){a=a|0;b=b|0;c=c|0;HK(a|0)|0}function QTa(a,b,c){a=a|0;b=b|0;c=c|0;IK(a|0)|0}function RTa(a,b,c){a=a|0;b=b|0;c=c|0;JK(a|0)|0}function STa(a,b,c){a=a|0;b=b|0;c=c|0;KK(a|0)|0}function TTa(a,b,c){a=a|0;b=b|0;c=c|0;LK(a|0)|0}function UTa(a,b,c){a=a|0;b=b|0;c=c|0;MK(a|0)|0}function VTa(a,b,c){a=a|0;b=b|0;c=c|0;NK(a|0)|0}function WTa(a,b,c){a=a|0;b=b|0;c=c|0;OK(a|0)|0}function XTa(a,b,c){a=a|0;b=b|0;c=c|0;PK(a|0)|0}function YTa(a,b,c){a=a|0;b=b|0;c=c|0;QK(a|0)|0}function ZTa(a,b,c){a=a|0;b=b|0;c=c|0;RK(a|0)|0}function _Ta(a,b,c){a=a|0;b=b|0;c=c|0;SK(a|0)|0}function $Ta(a,b,c){a=a|0;b=b|0;c=c|0;TK(a|0)|0}function aUa(a,b,c){a=a|0;b=b|0;c=c|0;UK(a|0)|0}function bUa(a,b,c){a=a|0;b=b|0;c=c|0;VK(a|0)|0}function cUa(a,b,c){a=a|0;b=b|0;c=c|0;WK(a|0)|0}function dUa(a,b,c){a=a|0;b=b|0;c=c|0;XK(a|0)|0}function eUa(a,b,c){a=a|0;b=b|0;c=c|0;YK(a|0)|0}function fUa(a,b,c){a=a|0;b=b|0;c=c|0;ZK(a|0)|0}function gUa(a,b,c){a=a|0;b=b|0;c=c|0;_K(a|0)|0}function hUa(a,b,c){a=a|0;b=b|0;c=c|0;$K(a|0)|0}function iUa(a,b,c){a=a|0;b=b|0;c=c|0;aL(a|0)|0}function jUa(a,b,c){a=a|0;b=b|0;c=c|0;bL(a|0)|0}function kUa(a,b,c){a=a|0;b=b|0;c=c|0;cL(a|0)|0}function lUa(a,b,c){a=a|0;b=b|0;c=c|0;dL(a|0)|0}function mUa(a,b,c){a=a|0;b=b|0;c=c|0;eL(a|0)|0}function nUa(a,b,c){a=a|0;b=b|0;c=c|0;RT(a|0,b|0,c|0)|0}function oUa(a,b,c){a=a|0;b=b|0;c=c|0;Vb(a|0)}function pUa(a,b,c){a=a|0;b=b|0;c=c|0;Wb(a|0)|0}function qUa(a,b,c){a=a|0;b=b|0;c=c|0;Xb(a|0,b|0)|0}function rUa(a,b,c){a=a|0;b=b|0;c=c|0;Yb(a|0)|0}function sUa(a,b,c){a=a|0;b=b|0;c=c|0;Wk(a|0,b|0,c|0)|0}function tUa(a,b,c){a=a|0;b=b|0;c=c|0;_b(a|0)}function uUa(a,b,c){a=a|0;b=b|0;c=c|0;$b(a|0)}function vUa(a,b,c){a=a|0;b=b|0;c=c|0;ac(a|0,b|0,c|0)|0}function wUa(a,b,c){a=a|0;b=b|0;c=c|0;Ka(a|0,b|0,c|0)|0}function xUa(a,b,c){a=a|0;b=b|0;c=c|0;gc(a|0,b|0,c|0)|0}function yUa(a,b,c){a=a|0;b=b|0;c=c|0;hc(a|0)}function zUa(a,b,c){a=a|0;b=b|0;c=c|0;nc(a|0)|0}function AUa(a,b,c){a=a|0;b=b|0;c=c|0;md(a|0,b|0)}function BUa(a,b,c){a=a|0;b=b|0;c=c|0;nd(a|0)|0}function CUa(a,b,c){a=a|0;b=b|0;c=c|0;Kd(a|0,b|0,c|0,0)|0}function DUa(a,b,c){a=a|0;b=b|0;c=c|0;Ld(a|0,b|0,c|0,0)|0}function EUa(a,b,c){a=a|0;b=b|0;c=c|0;Md(a|0,b|0,c|0,0)|0}function FUa(a,b,c){a=a|0;b=b|0;c=c|0;Nd(a|0,b|0,c|0,0)|0}function GUa(a,b,c){a=a|0;b=b|0;c=c|0;Od(a|0,b|0,c|0,0)|0}function HUa(a,b,c){a=a|0;b=b|0;c=c|0;Pd(a|0,b|0,c|0,0)|0}function IUa(a,b,c){a=a|0;b=b|0;c=c|0;qd(a|0,b|0,c|0,0)|0}function JUa(a,b,c){a=a|0;b=b|0;c=c|0;rd(a|0,b|0,c|0,0)|0}function KUa(a,b,c){a=a|0;b=b|0;c=c|0;Qd(a|0,b|0,c|0,0)|0}function LUa(a,b,c){a=a|0;b=b|0;c=c|0;Rd(a|0,b|0,c|0,0)|0}function MUa(a,b,c){a=a|0;b=b|0;c=c|0;fo(a|0,b|0,c|0,0)|0}function NUa(a,b,c){a=a|0;b=b|0;c=c|0;tg(a|0)}function OUa(a,b,c){a=a|0;b=b|0;c=c|0;mk()|0}function PUa(a,b,c){a=a|0;b=b|0;c=c|0;sh(a|0,b|0,c|0,0,0)}function QUa(a,b,c){a=a|0;b=b|0;c=c|0;gk(a|0,b|0,c|0,0,0)}function RUa(a,b,c){a=a|0;b=b|0;c=c|0;nk(a|0)|0}function SUa(a,b,c){a=a|0;b=b|0;c=c|0;ok(a|0)|0}function TUa(a,b,c){a=a|0;b=b|0;c=c|0;pk(a|0,b|0,c|0)|0}function UUa(a,b,c){a=a|0;b=b|0;c=c|0;qk(a|0)|0}function VUa(a,b,c){a=a|0;b=b|0;c=c|0;_k(a|0)|0}function WUa(a,b,c){a=a|0;b=b|0;c=c|0;$k(a|0,b|0,c|0)|0}function XUa(a,b,c){a=a|0;b=b|0;c=c|0;bl(a|0)|0}function YUa(a,b,c){a=a|0;b=b|0;c=c|0;cl(a|0,b|0,c|0)|0}function ZUa(a,b,c){a=a|0;b=b|0;c=c|0;dl(a|0)|0}function _Ua(a,b,c){a=a|0;b=b|0;c=c|0;el(a|0,b|0,c|0)|0}function $Ua(a,b,c){a=a|0;b=b|0;c=c|0;fl(a|0,b|0,c|0)|0}function aVa(a,b,c){a=a|0;b=b|0;c=c|0;gl(a|0,b|0,c|0,0)|0}function bVa(a,b,c){a=a|0;b=b|0;c=c|0;nn(a|0)}function cVa(a,b,c){a=a|0;b=b|0;c=c|0;on(a|0)|0}function dVa(a,b,c){a=a|0;b=b|0;c=c|0;sn(a|0)}function eVa(a,b,c){a=a|0;b=b|0;c=c|0;vn(a|0)|0}function fVa(a,b,c){a=a|0;b=b|0;c=c|0;xn(a|0)}function gVa(a,b,c){a=a|0;b=b|0;c=c|0;yn(a|0)|0}function hVa(a,b,c){a=a|0;b=b|0;c=c|0;zn(a|0,b|0)}function iVa(a,b,c){a=a|0;b=b|0;c=c|0;An(a|0)}function jVa(a,b,c){a=a|0;b=b|0;c=c|0;Bn(a|0)}function kVa(a,b,c){a=a|0;b=b|0;c=c|0;Cn(a|0,b|0)|0}function lVa(a,b,c){a=a|0;b=b|0;c=c|0;Dn(a|0)}function mVa(a,b,c){a=a|0;b=b|0;c=c|0;_n(a|0,b|0)|0}function nVa(a,b,c){a=a|0;b=b|0;c=c|0;tq(a|0,b|0)}function oVa(a,b,c){a=a|0;b=b|0;c=c|0;Qq(a|0)}function pVa(a,b,c){a=a|0;b=b|0;c=c|0;Bs(a|0,b|0)}function qVa(a,b,c){a=a|0;b=b|0;c=c|0;Is(a|0,b|0)}function rVa(a,b,c){a=a|0;b=b|0;c=c|0;ns(a|0,b|0)}function sVa(a,b,c){a=a|0;b=b|0;c=c|0;ts(a|0,b|0)}function tVa(a,b,c){a=a|0;b=b|0;c=c|0;us(a|0,b|0)}function uVa(a,b,c){a=a|0;b=b|0;c=c|0;os(a|0,b|0)}function vVa(a,b,c){a=a|0;b=b|0;c=c|0;Es(a|0,b|0)}function wVa(a,b,c){a=a|0;b=b|0;c=c|0;Hs(a|0,b|0)}function xVa(a,b,c){a=a|0;b=b|0;c=c|0;ls(a|0,b|0)}function yVa(a,b,c){a=a|0;b=b|0;c=c|0;Fs(a|0,b|0)}function zVa(a,b,c){a=a|0;b=b|0;c=c|0;ps(a|0,b|0)}function AVa(a,b,c){a=a|0;b=b|0;c=c|0;Cs(a|0,b|0)}function BVa(a,b,c){a=a|0;b=b|0;c=c|0;nt(a|0,b|0)}function CVa(a,b,c){a=a|0;b=b|0;c=c|0;qs(a|0,b|0)}function DVa(a,b,c){a=a|0;b=b|0;c=c|0;zs(a|0,b|0)}function EVa(a,b,c){a=a|0;b=b|0;c=c|0;Tr(a|0,b|0)}function FVa(a,b,c){a=a|0;b=b|0;c=c|0;ms(a|0,b|0)}function GVa(a,b,c){a=a|0;b=b|0;c=c|0;Js(a|0,b|0)}function HVa(a,b,c){a=a|0;b=b|0;c=c|0;rs(a|0,b|0)}function IVa(a,b,c){a=a|0;b=b|0;c=c|0;ss(a|0,b|0)}function JVa(a,b,c){a=a|0;b=b|0;c=c|0;vs(a|0,b|0)}function KVa(a,b,c){a=a|0;b=b|0;c=c|0;ws(a|0,b|0)}function LVa(a,b,c){a=a|0;b=b|0;c=c|0;xs(a|0,b|0)}function MVa(a,b,c){a=a|0;b=b|0;c=c|0;ys(a|0,b|0)}function NVa(a,b,c){a=a|0;b=b|0;c=c|0;Gs(a|0,b|0)}function OVa(a,b,c){a=a|0;b=b|0;c=c|0;Ds(a|0,b|0)}function PVa(a,b,c){a=a|0;b=b|0;c=c|0;As(a|0,b|0)}function QVa(a,b,c){a=a|0;b=b|0;c=c|0;ot(a|0,b|0)}function RVa(a,b,c){a=a|0;b=b|0;c=c|0;uu(a|0,b|0,c|0)|0}function SVa(a,b,c){a=a|0;b=b|0;c=c|0;ds(a|0,b|0)|0}function TVa(a,b,c){a=a|0;b=b|0;c=c|0;es(a|0,b|0)|0}function UVa(a,b,c){a=a|0;b=b|0;c=c|0;js(a|0,b|0)|0}function VVa(a,b,c){a=a|0;b=b|0;c=c|0;vu(a|0,b|0,c|0)|0}function WVa(a,b,c){a=a|0;b=b|0;c=c|0;wu(a|0,b|0)|0}function XVa(a,b,c){a=a|0;b=b|0;c=c|0;$r(a|0,b|0)|0}function YVa(a,b,c){a=a|0;b=b|0;c=c|0;as(a|0,b|0)|0}function ZVa(a,b,c){a=a|0;b=b|0;c=c|0;bs(a|0,b|0)|0}function _Va(a,b,c){a=a|0;b=b|0;c=c|0;hs(a|0,b|0)|0}function $Va(a,b,c){a=a|0;b=b|0;c=c|0;fs(a|0,b|0)|0}function aWa(a,b,c){a=a|0;b=b|0;c=c|0;is(a|0,b|0)|0}function bWa(a,b,c){a=a|0;b=b|0;c=c|0;cs(a|0,b|0)|0}function cWa(a,b,c){a=a|0;b=b|0;c=c|0;xu(a|0,b|0)|0}function dWa(a,b,c){a=a|0;b=b|0;c=c|0;gs(a|0,b|0)|0}function eWa(a,b,c){a=a|0;b=b|0;c=c|0;_r(a|0,b|0)|0}function fWa(a,b,c){a=a|0;b=b|0;c=c|0;dr(a|0,b|0)|0}function gWa(a,b,c){a=a|0;b=b|0;c=c|0;jv(a|0,b|0)}function hWa(a,b,c){a=a|0;b=b|0;c=c|0;pv(a|0,b|0)}function iWa(a,b,c){a=a|0;b=b|0;c=c|0;qv(a|0,b|0)}function jWa(a,b,c){a=a|0;b=b|0;c=c|0;rv(a|0,b|0)}function kWa(a,b,c){a=a|0;b=b|0;c=c|0;sv(a|0,b|0)}function lWa(a,b,c){a=a|0;b=b|0;c=c|0;tv(a|0,b|0)}function mWa(a,b,c){a=a|0;b=b|0;c=c|0;uv(a|0,b|0)}function nWa(a,b,c){a=a|0;b=b|0;c=c|0;vv(a|0,b|0)}function oWa(a,b,c){a=a|0;b=b|0;c=c|0;Mw(a|0)}function pWa(a,b,c){a=a|0;b=b|0;c=c|0;Yw(a|0)}function qWa(a,b,c){a=a|0;b=b|0;c=c|0;Kx(a|0,b|0,c|0)|0}function rWa(a,b,c){a=a|0;b=b|0;c=c|0;$x(a|0,b|0)|0}function sWa(a,b,c){a=a|0;b=b|0;c=c|0;dy(a|0,b|0)|0}function tWa(a,b,c){a=a|0;b=b|0;c=c|0;fy(a|0,b|0)|0}function uWa(a,b,c){a=a|0;b=b|0;c=c|0;jy(a|0,b|0)|0}function vWa(a,b,c){a=a|0;b=b|0;c=c|0;qB(a|0)}function wWa(a,b,c){a=a|0;b=b|0;c=c|0;LB(a|0,b|0,c|0,0,0,0,0,0,0)}function xWa(a,b,c){a=a|0;b=b|0;c=c|0;MB(a|0,b|0,c|0,0)}function yWa(a,b,c){a=a|0;b=b|0;c=c|0;PB(a|0,b|0)}function zWa(a,b,c){a=a|0;b=b|0;c=c|0;QB(a|0,b|0,c|0,0)}function AWa(a,b,c){a=a|0;b=b|0;c=c|0;RB(a|0)|0}function BWa(a,b,c){a=a|0;b=b|0;c=c|0;SB(a|0)|0}function CWa(a,b,c){a=a|0;b=b|0;c=c|0;TB(a|0)|0}function DWa(a,b,c){a=a|0;b=b|0;c=c|0;UB(a|0,b|0,c|0)|0}function EWa(a,b,c){a=a|0;b=b|0;c=c|0;VB(a|0,b|0)|0}function FWa(a,b,c){a=a|0;b=b|0;c=c|0;WB(a|0,b|0,c|0,0,0,0)}function GWa(a,b,c){a=a|0;b=b|0;c=c|0;XB(a|0,b|0,c|0,0)}function HWa(a,b,c){a=a|0;b=b|0;c=c|0;YB(a|0,b|0,c|0,0,0,0,0)}function IWa(a,b,c){a=a|0;b=b|0;c=c|0;ZB(a|0,b|0,c|0,0)}function JWa(a,b,c){a=a|0;b=b|0;c=c|0;_B(a|0,b|0,c|0,0,0)}function KWa(a,b,c){a=a|0;b=b|0;c=c|0;$B(a|0,b|0)}function LWa(a,b,c){a=a|0;b=b|0;c=c|0;aC(a|0)}function MWa(a,b,c){a=a|0;b=b|0;c=c|0;bC(a|0)}function NWa(a,b,c){a=a|0;b=b|0;c=c|0;dC(a|0,b|0)}function OWa(a,b,c){a=a|0;b=b|0;c=c|0;hC(a|0,b|0)|0}function PWa(a,b,c){a=a|0;b=b|0;c=c|0;iC(a|0,b|0,c|0,0)}function QWa(a,b,c){a=a|0;b=b|0;c=c|0;mC(a|0,b|0)}function RWa(a,b,c){a=a|0;b=b|0;c=c|0;nC(a|0,b|0,c|0,0,0,0,0,0,0)}function SWa(a,b,c){a=a|0;b=b|0;c=c|0;oC(a|0,b|0,c|0,0)}function TWa(a,b,c){a=a|0;b=b|0;c=c|0;rC(a|0,b|0,c|0)|0}function UWa(a,b,c){a=a|0;b=b|0;c=c|0;uC(a|0)}function VWa(a,b,c){a=a|0;b=b|0;c=c|0;AD(a|0,b|0)}function WWa(a,b,c){a=a|0;b=b|0;c=c|0;lF(a|0,b|0,c|0,0)}function XWa(a,b,c){a=a|0;b=b|0;c=c|0;uF(a|0,b|0)}function YWa(a,b,c){a=a|0;b=b|0;c=c|0;VA(a|0)}function ZWa(a,b,c){a=a|0;b=b|0;c=c|0;xM(a|0,b|0)}function _Wa(a,b,c){a=a|0;b=b|0;c=c|0;yM(a|0,b|0,c|0,0,0,0,0,0,0)}function $Wa(a,b,c){a=a|0;b=b|0;c=c|0;zM(a|0,b|0,c|0,0)}function aXa(a,b,c){a=a|0;b=b|0;c=c|0;GM(a|0,b|0,c|0)|0}function bXa(a,b,c){a=a|0;b=b|0;c=c|0;FM(a|0,b|0)}function cXa(a,b,c){a=a|0;b=b|0;c=c|0;UM(a|0)}function dXa(a,b,c){a=a|0;b=b|0;c=c|0;nN(a|0,b|0)|0}function eXa(a,b,c){a=a|0;b=b|0;c=c|0;oN(a|0,b|0,c|0,0,0)|0}function fXa(a,b,c){a=a|0;b=b|0;c=c|0;pN(a|0,b|0,c|0,0,0,0,0)|0}function gXa(a,b,c){a=a|0;b=b|0;c=c|0;qN(a|0,b|0,c|0,0,0,0)|0}function hXa(a,b,c){a=a|0;b=b|0;c=c|0;rN(a|0,b|0)}function iXa(a,b,c){a=a|0;b=b|0;c=c|0;tN(a|0,b|0)|0}function jXa(a,b,c){a=a|0;b=b|0;c=c|0;uN(a|0,b|0,c|0,0,0)|0}function kXa(a,b,c){a=a|0;b=b|0;c=c|0;vN(a|0,b|0,c|0,0,0,0,0)|0}function lXa(a,b,c){a=a|0;b=b|0;c=c|0;wN(a|0,b|0)}function mXa(a,b,c){a=a|0;b=b|0;c=c|0;GN(a|0,b|0,c|0,0)}function nXa(a,b,c){a=a|0;b=b|0;c=c|0;fP(a|0,b|0,c|0,0)}function oXa(a,b,c){a=a|0;b=b|0;c=c|0;fQ(a|0,b|0,c|0,0,0,0,0,0,0)}function pXa(a,b,c){a=a|0;b=b|0;c=c|0;gQ(a|0,b|0,c|0,0)}function qXa(a,b,c){a=a|0;b=b|0;c=c|0;WR(a|0,b|0,c|0,0)|0}function rXa(a,b,c){a=a|0;b=b|0;c=c|0;QS(a|0,b|0)|0}function sXa(a,b,c){a=a|0;b=b|0;c=c|0;hT(a|0,b|0,c|0)|0}function tXa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;da(10)}function uXa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;uc(a|0,b|0,c|0,d|0)}function vXa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;vc(a|0)|0}function wXa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;wc(a|0)|0}function xXa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;xc(a|0)|0}function yXa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;yc(a|0,b|0,c|0)|0}function zXa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;zc(a|0,b|0)|0}function AXa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Ac(a|0,b|0,c|0,d|0,e|0,f|0)}function BXa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Bc(a|0,b|0,c|0,d|0)}function CXa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Cc(a|0,b|0,c|0,d|0,e|0,f|0,g|0)}function DXa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Dc(a|0,b|0,c|0,d|0)}function EXa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Ec(a|0,b|0,c|0,d|0,e|0)}function FXa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Fc(a|0,b|0)}function GXa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Gc(a|0)}function HXa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Hc(a|0)}function IXa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Wc(a|0,b|0,c|0)}function JXa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Xc(a|0,b|0)}function KXa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Ic(a|0,b|0)}function LXa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Jc(a|0,b|0,c|0)}function MXa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Kc(a|0,b|0,c|0)}function NXa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Lc(a|0,b|0,c|0)}function OXa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Mc(a|0,b|0)}function PXa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Nc(a|0,b|0,c|0)}function QXa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Oc(a|0,b|0,c|0)}function RXa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Pc(a|0,b|0,c|0)}function SXa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Qc(a|0,b|0)|0}function TXa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Rc(a|0,b|0,c|0)}function UXa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Sc(a|0,b|0,c|0,d|0)}function VXa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Uc(a|0,b|0,c|0,d|0)}function WXa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Xk(a|0,b|0,c|0)|0}function XXa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;jT(a|0)}function YXa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;iT(a|0)|0}function ZXa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;kT(a|0,b|0)|0}function _Xa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;my(a|0)|0}function $Xa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Td(a|0,b|0,c|0)}function aYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;SP(a|0,b|0,c|0,d|0)}function bYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;PP(a|0)|0}function cYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;QP(a|0)|0}function dYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;RP(a|0)|0}function eYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;UP(a|0,b|0,c|0)|0}function fYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;VP(a|0,b|0)|0}function gYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;XP(a|0,b|0,c|0,d|0,e|0,f|0)}function hYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;_P(a|0,b|0,c|0,d|0)}function iYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;YP(a|0,b|0,c|0,d|0,e|0,f|0,g|0)}function jYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ZP(a|0,b|0,c|0,d|0)}function kYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;$P(a|0,b|0,c|0,d|0,e|0)}function lYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;aQ(a|0,b|0)}function mYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;bQ(a|0)}function nYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;
c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;cQ(a|0)}function oYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;dQ(a|0,b|0,c|0)}function pYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;eQ(a|0,b|0)}function qYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;hQ(a|0,b|0)}function rYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;iQ(a|0,b|0,c|0)}function sYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;kQ(a|0,b|0,c|0)}function tYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;lQ(a|0,b|0)}function uYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;$d(a|0,b|0,c|0)}function vYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;_d(a|0,b|0,c|0)}function wYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;WP(a|0,b|0)|0}function xYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;mQ(a|0,b|0,c|0)}function yYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;TP(a|0,b|0,c|0,d|0)}function zYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;LP(a|0)|0}function AYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;MP(a|0)|0}function BYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;NP(a|0)|0}function CYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;OP(a|0)|0}function DYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;jQ(a|0,b|0,c|0)}function EYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;NI(a|0)|0}function FYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;OI(a|0)|0}function GYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;PI(a|0)|0}function HYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;QI(a|0)|0}function IYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;RI(a|0)|0}function JYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;SI(a|0)|0}function KYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;TI(a|0)|0}function LYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;UI(a|0)|0}function MYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;VI(a|0)|0}function NYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;WI(a|0)|0}function OYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;XI(a|0)|0}function PYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;YI(a|0)|0}function QYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ZI(a|0)|0}function RYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;_I(a|0)|0}function SYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;$I(a|0)|0}function TYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;aJ(a|0)|0}function UYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;bJ(a|0)|0}function VYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;cJ(a|0)|0}function WYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;dJ(a|0)|0}function XYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;eJ(a|0)|0}function YYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;fJ(a|0)|0}function ZYa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;gJ(a|0)|0}function _Ya(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;hJ(a|0)|0}function $Ya(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;iJ(a|0)|0}function aZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;jJ(a|0)|0}function bZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;kJ(a|0)|0}function cZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;lJ(a|0)|0}function dZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;mJ(a|0)|0}function eZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;nJ(a|0)|0}function fZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;oJ(a|0)|0}function gZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;pJ(a|0)|0}function hZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;qJ(a|0)|0}function iZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;rJ(a|0)|0}function jZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;sJ(a|0)|0}function kZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;tJ(a|0)|0}function lZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;uJ(a|0)|0}function mZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;vJ(a|0)|0}function nZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;wJ(a|0)|0}function oZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;xJ(a|0)|0}function pZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;yJ(a|0)|0}function qZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;zJ(a|0)|0}function rZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;AJ(a|0)|0}function sZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;BJ(a|0)|0}function tZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;CJ(a|0)|0}function uZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;DJ(a|0)|0}function vZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;EJ(a|0)|0}function wZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;FJ(a|0)|0}function xZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;GJ(a|0)|0}function yZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;HJ(a|0)|0}function zZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;IJ(a|0)|0}function AZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;JJ(a|0)|0}function BZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;KJ(a|0)|0}function CZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;LJ(a|0)|0}function DZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;MJ(a|0)|0}function EZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;NJ(a|0)|0}function FZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;OJ(a|0)|0}function GZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;PJ(a|0)|0}function HZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;QJ(a|0)|0}function IZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;RJ(a|0)|0}function JZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;SJ(a|0)|0}function KZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;TJ(a|0)|0}function LZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;UJ(a|0)|0}function MZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;VJ(a|0)|0}function NZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;WJ(a|0)|0}function OZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;XJ(a|0)|0}function PZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;YJ(a|0)|0}function QZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ZJ(a|0)|0}function RZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;_J(a|0)|0}function SZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;$J(a|0)|0}function TZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;aK(a|0)|0}function UZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;bK(a|0)|0}function VZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;cK(a|0)|0}function WZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;dK(a|0)|0}function XZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;eK(a|0)|0}function YZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;fK(a|0)|0}function ZZa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;gK(a|0)|0}function _Za(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;hK(a|0)|0}function $Za(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;iK(a|0)|0}function a_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;jK(a|0)|0}function b_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;kK(a|0)|0}function c_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;lK(a|0)|0}function d_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;mK(a|0)|0}function e_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;nK(a|0)|0}function f_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;oK(a|0)|0}function g_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;pK(a|0)|0}function h_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;qK(a|0)|0}function i_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;rK(a|0)|0}function j_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;sK(a|0)|0}function k_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;tK(a|0)|0}function l_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;uK(a|0)|0}function m_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;vK(a|0)|0}function n_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;wK(a|0)|0}function o_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;xK(a|0)|0}function p_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;yK(a|0)|0}function q_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;zK(a|0)|0}function r_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;AK(a|0)|0}function s_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;BK(a|0)|0}function t_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;CK(a|0)|0}function u_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;DK(a|0)|0}function v_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;EK(a|0)|0}function w_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;FK(a|0)|0}function x_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;GK(a|0)|0}function y_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;HK(a|0)|0}function z_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;IK(a|0)|0}function A_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;JK(a|0)|0}function B_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;KK(a|0)|0}function C_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;LK(a|0)|0}function D_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;MK(a|0)|0}function E_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;NK(a|0)|0}function F_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;OK(a|0)|0}function G_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;PK(a|0)|0}function H_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;QK(a|0)|0}function I_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;RK(a|0)|0}function J_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;SK(a|0)|0}function K_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;TK(a|0)|0}function L_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;UK(a|0)|0}function M_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;VK(a|0)|0}function N_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;WK(a|0)|0}function O_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;XK(a|0)|0}function P_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;YK(a|0)|0}function Q_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ZK(a|0)|0}function R_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;_K(a|0)|0}function S_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;$K(a|0)|0}function T_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;aL(a|0)|0}function U_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;bL(a|0)|0}function V_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;cL(a|0)|0}function W_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;dL(a|0)|0}function X_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;eL(a|0)|0}function Y_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;RT(a|0,b|0,c|0)|0}function Z_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Vb(a|0)}function __a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Wb(a|0)|0}function $_a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Xb(a|0,b|0)|0}function a$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Yb(a|0)|0}function b$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Wk(a|0,b|0,c|0)|0}function c$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;_b(a|0)}function d$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;$b(a|0)}function e$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ac(a|0,b|0,c|0)|0}function f$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Ka(a|0,b|0,c|0)|0}function g$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;gc(a|0,b|0,c|0)|0}function h$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;hc(a|0)}function i$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ic(a|0,b|0,c|0)}function j$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;jc(a|0,b|0,c|0)}function k$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;kc(a|0,b|0,c|0)}function l$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;lc(a|0,b|0,c|0)}function m$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;nc(a|0)|0}function n$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;md(a|0,b|0)}function o$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;nd(a|0)|0}function p$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Kd(a|0,b|0,c|0,d|0)|0}function q$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Ld(a|0,b|0,c|0,d|0)|0}function r$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Md(a|0,b|0,c|0,d|0)|0}function s$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Nd(a|0,b|0,c|0,d|0)|0}function t$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Od(a|0,b|0,c|0,d|0)|0}function u$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Pd(a|0,b|0,c|0,d|0)|0}function v$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;qd(a|0,b|0,c|0,d|0)|0}function w$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;rd(a|0,b|0,c|0,d|0)|0}function x$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Qd(a|0,b|0,c|0,d|0)|0}function y$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Rd(a|0,b|0,c|0,d|0)|0}function z$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;fo(a|0,b|0,c|0,d|0)|0}function A$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ae(a|0,b|0,c|0)}function B$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;be(a|0,b|0,c|0)}function C$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;tg(a|0)}function D$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;mk()|0}function E$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;sh(a|0,b|0,c|0,d|0,e|0)}function F$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;gk(a|0,b|0,c|0,d|0,e|0)}function G$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;nk(a|0)|0}function H$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ok(a|0)|0}function I$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;pk(a|0,b|0,c|0)|0}function J$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;qk(a|0)|0}function K$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;_k(a|0)|0}function L$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;$k(a|0,b|0,c|0)|0}function M$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;bl(a|0)|0}function N$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;cl(a|0,b|0,c|0)|0}function O$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;dl(a|0)|0}function P$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;el(a|0,b|0,c|0)|0}function Q$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;fl(a|0,b|0,c|0)|0}function R$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;gl(a|0,b|0,c|0,d|0)|0}function S$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;nn(a|0)}function T$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;on(a|0)|0}function U$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;sn(a|0)}function V$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;vn(a|0)|0}function W$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;xn(a|0)}function X$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;yn(a|0)|0}function Y$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;zn(a|0,b|0)}function Z$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;An(a|0)}function _$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Bn(a|0)}function $$a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Cn(a|0,b|0)|0}function a0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Dn(a|0)}function b0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;In(a|0,b|0,c|0)}function c0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Rn(a|0,b|0,c|0)}function d0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Sn(a|0,b|0,c|0)}function e0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Tn(a|0,b|0,c|0)}function f0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Un(a|0,b|0,c|0)}function g0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;_n(a|0,b|0)|0}function h0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;tq(a|0,b|0)}function i0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Qq(a|0)}function j0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Bs(a|0,b|0)}function k0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Is(a|0,b|0)}function l0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ns(a|0,b|0)}function m0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ts(a|0,b|0)}function n0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;us(a|0,b|0)}function o0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;os(a|0,b|0)}function p0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Es(a|0,b|0)}function q0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Hs(a|0,b|0)}function r0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ls(a|0,b|0)}function s0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Fs(a|0,b|0)}function t0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ps(a|0,b|0)}function u0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Cs(a|0,b|0)}function v0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;nt(a|0,b|0)}function w0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;qs(a|0,b|0)}function x0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;zs(a|0,b|0)}function y0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Tr(a|0,b|0)}function z0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ms(a|0,b|0)}function A0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Js(a|0,b|0)}function B0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;rs(a|0,b|0)}function C0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ss(a|0,b|0)}function D0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;vs(a|0,b|0)}function E0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ws(a|0,b|0)}function F0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;xs(a|0,b|0)}function G0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ys(a|0,b|0)}function H0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Gs(a|0,b|0)}function I0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Ds(a|0,b|0)}function J0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;As(a|0,b|0)}function K0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ot(a|0,b|0)}function L0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;uu(a|0,b|0,c|0)|0}function M0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ds(a|0,b|0)|0}function N0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;es(a|0,b|0)|0}function O0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;js(a|0,b|0)|0}function P0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;vu(a|0,b|0,c|0)|0}function Q0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;wu(a|0,b|0)|0}function R0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;$r(a|0,b|0)|0}function S0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;as(a|0,b|0)|0}function T0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;bs(a|0,b|0)|0}function U0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;hs(a|0,b|0)|0}function V0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;fs(a|0,b|0)|0}function W0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;is(a|0,b|0)|0}function X0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;cs(a|0,b|0)|0}function Y0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;xu(a|0,b|0)|0}function Z0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;gs(a|0,b|0)|0}function _0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;_r(a|0,b|0)|0}function $0a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;dr(a|0,b|0)|0}function a1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;jv(a|0,b|0)}function b1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;pv(a|0,b|0)}function c1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;qv(a|0,b|0)}function d1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;rv(a|0,b|0)}function e1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;sv(a|0,b|0)}function f1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;tv(a|0,b|0)}function g1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;uv(a|0,b|0)}function h1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;vv(a|0,b|0)}function i1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;tw(a|0,b|0,c|0)}function j1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Mw(a|0)}function k1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Yw(a|0)}function l1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Kx(a|0,b|0,c|0)|0}function m1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;$x(a|0,b|0)|0}function n1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;dy(a|0,b|0)|0}function o1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;fy(a|0,b|0)|0}function p1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;jy(a|0,b|0)|0}function q1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;qB(a|0)}function r1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;MB(a|0,b|0,c|0,d|0)}function s1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;NB(a|0,b|0,c|0)}function t1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;OB(a|0,b|0,c|0)}function u1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;PB(a|0,b|0)}function v1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;QB(a|0,b|0,c|0,d|0)}function w1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;RB(a|0)|0}function x1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;SB(a|0)|0}function y1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;TB(a|0)|0}function z1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;UB(a|0,b|0,c|0)|0}function A1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;VB(a|0,b|0)|0}function B1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;WB(a|0,b|0,c|0,d|0,e|0,f|0)}function C1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;XB(a|0,b|0,c|0,d|0)}function D1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;YB(a|0,b|0,c|0,d|0,e|0,f|0,g|0)}function E1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ZB(a|0,b|0,c|0,d|0)}function F1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;_B(a|0,b|0,c|0,d|0,e|0)}function G1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;$B(a|0,b|0)}function H1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;aC(a|0)}function I1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;bC(a|0)}function J1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;cC(a|0,b|0,c|0)}function K1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;dC(a|0,b|0)}function L1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;eC(a|0,b|0,c|0)}function M1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;fC(a|0,b|0,c|0)}function N1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;gC(a|0,b|0,c|0)}function O1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;hC(a|0,b|0)|0}function P1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;iC(a|0,b|0,c|0,d|0)}function Q1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;jC(a|0,b|0,c|0)}function R1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;kC(a|0,b|0,c|0)}function S1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;lC(a|0,b|0,c|0)}function T1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;mC(a|0,b|0)}function U1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;oC(a|0,b|0,c|0,d|0)}function V1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;rC(a|0,b|0,c|0)|0}function W1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;uC(a|0)}function X1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;AD(a|0,b|0)}function Y1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;lF(a|0,b|0,c|0,d|0)}function Z1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;uF(a|0,b|0)}function _1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;VA(a|0)}function $1a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;wM(a|0,b|0,c|0)}function a2a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;xM(a|0,b|0)}function b2a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;zM(a|0,b|0,c|0,d|0)}function c2a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;AM(a|0,b|0,c|0)}function d2a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;BM(a|0,b|0,c|0)}function e2a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;DM(a|0,b|0,c|0)}function f2a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;EM(a|0,b|0,c|0)}function g2a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;GM(a|0,b|0,c|0)|0}function h2a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;FM(a|0,b|0)}function i2a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;UM(a|0)}function j2a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;nN(a|0,b|0)|0}function k2a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;oN(a|0,b|0,c|0,d|0,e|0)|0}function l2a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;pN(a|0,b|0,c|0,d|0,e|0,f|0,g|0)|0}function m2a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;qN(a|0,b|0,c|0,d|0,e|0,f|0)|0}function n2a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;
rN(a|0,b|0)}function o2a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;tN(a|0,b|0)|0}function p2a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;uN(a|0,b|0,c|0,d|0,e|0)|0}function q2a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;vN(a|0,b|0,c|0,d|0,e|0,f|0,g|0)|0}function r2a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;wN(a|0,b|0)}function s2a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;CN(a|0,b|0,c|0)}function t2a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;GN(a|0,b|0,c|0,d|0)}function u2a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;vO(a|0,b|0,c|0)}function v2a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;wO(a|0,b|0,c|0)}function w2a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;fP(a|0,b|0,c|0,d|0)}function x2a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;sP(a|0,b|0,c|0)}function y2a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;gQ(a|0,b|0,c|0,d|0)}function z2a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;WR(a|0,b|0,c|0,d|0)|0}function A2a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;QS(a|0,b|0)|0}function B2a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;hT(a|0,b|0,c|0)|0}function C2a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;da(11);return 0}function D2a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function E2a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return vc(a|0)|0}function F2a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return wc(a|0)|0}function G2a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return xc(a|0)|0}function H2a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return yc(a|0,b|0,c|0)|0}function I2a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return zc(a|0,b|0)|0}function J2a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function K2a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function L2a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function M2a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function N2a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function O2a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function P2a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function Q2a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function R2a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function S2a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function T2a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function U2a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function V2a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function W2a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function X2a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function Y2a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function Z2a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function _2a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function $2a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Qc(a|0,b|0)|0}function a3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function b3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function c3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function d3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function e3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Xk(a|0,b|0,c|0)|0}function f3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function g3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return iT(a|0)|0}function h3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return kT(a|0,b|0)|0}function i3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return my(a|0)|0}function j3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function k3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function l3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return PP(a|0)|0}function m3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return QP(a|0)|0}function n3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return RP(a|0)|0}function o3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return UP(a|0,b|0,c|0)|0}function p3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return VP(a|0,b|0)|0}function q3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function r3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function s3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function t3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function u3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function v3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function w3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function x3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function y3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function z3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function A3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function B3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function C3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function D3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function E3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function F3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function G3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return WP(a|0,b|0)|0}function H3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function I3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function J3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return LP(a|0)|0}function K3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return MP(a|0)|0}function L3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return NP(a|0)|0}function M3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return OP(a|0)|0}function N3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function O3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return NI(a|0)|0}function P3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return OI(a|0)|0}function Q3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return PI(a|0)|0}function R3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return QI(a|0)|0}function S3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return RI(a|0)|0}function T3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return SI(a|0)|0}function U3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return TI(a|0)|0}function V3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return UI(a|0)|0}function W3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return VI(a|0)|0}function X3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return WI(a|0)|0}function Y3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return XI(a|0)|0}function Z3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return YI(a|0)|0}function _3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ZI(a|0)|0}function $3a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return _I(a|0)|0}function a4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return $I(a|0)|0}function b4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return aJ(a|0)|0}function c4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return bJ(a|0)|0}function d4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return cJ(a|0)|0}function e4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return dJ(a|0)|0}function f4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return eJ(a|0)|0}function g4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return fJ(a|0)|0}function h4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return gJ(a|0)|0}function i4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hJ(a|0)|0}function j4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return iJ(a|0)|0}function k4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return jJ(a|0)|0}function l4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return kJ(a|0)|0}function m4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return lJ(a|0)|0}function n4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return mJ(a|0)|0}function o4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return nJ(a|0)|0}function p4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return oJ(a|0)|0}function q4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return pJ(a|0)|0}function r4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return qJ(a|0)|0}function s4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return rJ(a|0)|0}function t4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return sJ(a|0)|0}function u4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return tJ(a|0)|0}function v4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return uJ(a|0)|0}function w4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return vJ(a|0)|0}function x4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return wJ(a|0)|0}function y4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return xJ(a|0)|0}function z4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return yJ(a|0)|0}function A4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return zJ(a|0)|0}function B4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return AJ(a|0)|0}function C4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return BJ(a|0)|0}function D4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return CJ(a|0)|0}function E4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return DJ(a|0)|0}function F4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return EJ(a|0)|0}function G4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return FJ(a|0)|0}function H4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return GJ(a|0)|0}function I4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return HJ(a|0)|0}function J4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return IJ(a|0)|0}function K4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return JJ(a|0)|0}function L4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return KJ(a|0)|0}function M4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return LJ(a|0)|0}function N4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return MJ(a|0)|0}function O4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return NJ(a|0)|0}function P4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return OJ(a|0)|0}function Q4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return PJ(a|0)|0}function R4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return QJ(a|0)|0}function S4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return RJ(a|0)|0}function T4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return SJ(a|0)|0}function U4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return TJ(a|0)|0}function V4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return UJ(a|0)|0}function W4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return VJ(a|0)|0}function X4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return WJ(a|0)|0}function Y4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return XJ(a|0)|0}function Z4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return YJ(a|0)|0}function _4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ZJ(a|0)|0}function $4a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return _J(a|0)|0}function a5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return $J(a|0)|0}function b5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return aK(a|0)|0}function c5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return bK(a|0)|0}function d5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return cK(a|0)|0}function e5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return dK(a|0)|0}function f5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return eK(a|0)|0}function g5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return fK(a|0)|0}function h5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return gK(a|0)|0}function i5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hK(a|0)|0}function j5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return iK(a|0)|0}function k5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return jK(a|0)|0}function l5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return kK(a|0)|0}function m5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return lK(a|0)|0}function n5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return mK(a|0)|0}function o5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return nK(a|0)|0}function p5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return oK(a|0)|0}function q5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return pK(a|0)|0}function r5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return qK(a|0)|0}function s5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return rK(a|0)|0}function t5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return sK(a|0)|0}function u5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return tK(a|0)|0}function v5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return uK(a|0)|0}function w5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return vK(a|0)|0}function x5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return wK(a|0)|0}function y5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return xK(a|0)|0}function z5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return yK(a|0)|0}function A5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return zK(a|0)|0}function B5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return AK(a|0)|0}function C5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return BK(a|0)|0}function D5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return CK(a|0)|0}function E5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return DK(a|0)|0}function F5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return EK(a|0)|0}function G5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return FK(a|0)|0}function H5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return GK(a|0)|0}function I5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return HK(a|0)|0}function J5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return IK(a|0)|0}function K5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return JK(a|0)|0}function L5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return KK(a|0)|0}function M5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return LK(a|0)|0}function N5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return MK(a|0)|0}function O5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return NK(a|0)|0}function P5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return OK(a|0)|0}function Q5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return PK(a|0)|0}function R5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return QK(a|0)|0}function S5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return RK(a|0)|0}function T5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return SK(a|0)|0}function U5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return TK(a|0)|0}function V5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return UK(a|0)|0}function W5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return VK(a|0)|0}function X5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return WK(a|0)|0}function Y5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return XK(a|0)|0}function Z5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return YK(a|0)|0}function _5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ZK(a|0)|0}function $5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return _K(a|0)|0}function a6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return $K(a|0)|0}function b6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return aL(a|0)|0}function c6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return bL(a|0)|0}function d6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return cL(a|0)|0}function e6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return dL(a|0)|0}function f6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return eL(a|0)|0}function g6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return RT(a|0,b|0,c|0)|0}function h6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function i6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Wb(a|0)|0}function j6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Xb(a|0,b|0)|0}function k6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Yb(a|0)|0}function l6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Wk(a|0,b|0,c|0)|0}function m6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function n6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function o6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ac(a|0,b|0,c|0)|0}function p6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Ka(a|0,b|0,c|0)|0}function q6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return gc(a|0,b|0,c|0)|0}function r6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function s6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function t6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function u6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function v6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function w6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return nc(a|0)|0}function x6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function y6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return nd(a|0)|0}function z6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function A6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function B6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function C6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return mk()|0}function D6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function E6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function F6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return nk(a|0)|0}function G6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ok(a|0)|0}function H6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return pk(a|0,b|0,c|0)|0}function I6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return qk(a|0)|0}function J6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return _k(a|0)|0}function K6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return $k(a|0,b|0,c|0)|0}function L6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return bl(a|0)|0}function M6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return cl(a|0,b|0,c|0)|0}function N6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return dl(a|0)|0}function O6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return el(a|0,b|0,c|0)|0}function P6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return fl(a|0,b|0,c|0)|0}function Q6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function R6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return on(a|0)|0}function S6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function T6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return vn(a|0)|0}function U6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function V6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return yn(a|0)|0}function W6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function X6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function Y6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function Z6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Cn(a|0,b|0)|0}function _6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function $6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function a7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function b7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function c7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function d7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function e7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return _n(a|0,b|0)|0}function f7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function g7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function h7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function i7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function j7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function k7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function l7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function m7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function n7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function o7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function p7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function q7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function r7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function s7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function t7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function u7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function v7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function w7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function x7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function y7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function z7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function A7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function B7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function C7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function D7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function E7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function F7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function G7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function H7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function I7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function J7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return uu(a|0,b|0,c|0)|0}function K7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ds(a|0,b|0)|0}function L7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return es(a|0,b|0)|0}function M7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return js(a|0,b|0)|0}function N7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return vu(a|0,b|0,c|0)|0}function O7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return wu(a|0,b|0)|0}function P7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return $r(a|0,b|0)|0}function Q7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return as(a|0,b|0)|0}function R7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return bs(a|0,b|0)|0}function S7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hs(a|0,b|0)|0}function T7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return fs(a|0,b|0)|0}function U7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return is(a|0,b|0)|0}function V7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return cs(a|0,b|0)|0}function W7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return xu(a|0,b|0)|0}function X7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return gs(a|0,b|0)|0}function Y7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return _r(a|0,b|0)|0}function Z7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return dr(a|0,b|0)|0}function _7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function $7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function a8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function b8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function c8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function d8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function e8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function f8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function g8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function h8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function i8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function j8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Kx(a|0,b|0,c|0)|0}function k8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return $x(a|0,b|0)|0}function l8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return dy(a|0,b|0)|0}function m8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return fy(a|0,b|0)|0}function n8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return jy(a|0,b|0)|0}function o8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function p8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function q8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function r8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function s8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function t8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function u8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function v8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return RB(a|0)|0}function w8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return SB(a|0)|0}function x8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return TB(a|0)|0}function y8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return UB(a|0,b|0,c|0)|0}function z8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return VB(a|0,b|0)|0}function A8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function B8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function C8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function D8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function E8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function F8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function G8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function H8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function I8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function J8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function K8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function L8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function M8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function N8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hC(a|0,b|0)|0}function O8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function P8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function Q8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function R8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function S8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function T8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function U8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function V8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return rC(a|0,b|0,c|0)|0}function W8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function X8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function Y8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function Z8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function _8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function $8a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function a9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function b9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function c9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function d9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function e9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function f9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function g9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function h9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return GM(a|0,b|0,c|0)|0}function i9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function j9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function k9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return nN(a|0,b|0)|0}function l9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return oN(a|0,b|0,c|0,d|0,0)|0}function m9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return pN(a|0,b|0,c|0,d|0,0,0,0)|0}function n9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return qN(a|0,b|0,c|0,d|0,0,0)|0}function o9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function p9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return tN(a|0,b|0)|0}function q9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return uN(a|0,b|0,c|0,d|0,0)|0}function r9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return vN(a|0,b|0,c|0,d|0,0,0,0)|0}function s9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function t9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function u9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function v9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function w9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function x9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function y9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function z9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function A9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return 0}function B9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return QS(a|0,b|0)|0}function C9a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return hT(a|0,b|0,c|0)|0}function D9a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;da(12)}function E9a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;uc(a|0,b|0,c|0,d|0)}function F9a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;vc(a|0)|0}function G9a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;wc(a|0)|0}function H9a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;xc(a|0)|0}function I9a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;yc(a|0,b|0,c|0)|0}function J9a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;zc(a|0,b|0)|0}function K9a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Bc(a|0,b|0,c|0,d|0)}function L9a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Cc(a|0,b|0,c|0,d|0,e|0,f|0,0)}function M9a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Dc(a|0,b|0,c|0,d|0)}function N9a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Ec(a|0,b|0,c|0,d|0,e|0)}function O9a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Fc(a|0,b|0)}function P9a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Gc(a|0)}function Q9a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Hc(a|0)}function R9a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Wc(a|0,b|0,c|0)}function S9a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Xc(a|0,b|0)}function T9a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Ic(a|0,b|0)}function U9a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Jc(a|0,b|0,c|0)}function V9a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Kc(a|0,b|0,c|0)}function W9a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Lc(a|0,b|0,c|0)}function X9a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Mc(a|0,b|0)}function Y9a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Nc(a|0,b|0,c|0)}function Z9a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Oc(a|0,b|0,c|0)}function _9a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Pc(a|0,b|0,c|0)}function $9a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Qc(a|0,b|0)|0}function aab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Rc(a|0,b|0,c|0)}function bab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Sc(a|0,b|0,c|0,d|0)}function cab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Tc(a|0,b|0,c|0,d|0,e|0,f|0,0,0,0)}function dab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Uc(a|0,b|0,c|0,d|0)}function eab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Xk(a|0,b|0,c|0)|0}function fab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;jT(a|0)}function gab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;iT(a|0)|0}function hab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;kT(a|0,b|0)|0}function iab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;my(a|0)|0}function jab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Td(a|0,b|0,c|0)}function kab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;SP(a|0,b|0,c|0,d|0)}function lab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;PP(a|0)|0}function mab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;QP(a|0)|0}function nab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;RP(a|0)|0}function oab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;UP(a|0,b|0,c|0)|0}function pab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;VP(a|0,b|0)|0}function qab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;_P(a|0,b|0,c|0,d|0)}function rab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;YP(a|0,b|0,c|0,d|0,e|0,f|0,0)}function sab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ZP(a|0,b|0,c|0,d|0)}function tab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;$P(a|0,b|0,c|0,d|0,e|0)}function uab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;aQ(a|0,b|0)}function vab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;bQ(a|0)}function wab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;cQ(a|0)}function xab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;dQ(a|0,b|0,c|0)}function yab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;eQ(a|0,b|0)}function zab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;hQ(a|0,b|0)}function Aab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;iQ(a|0,b|0,c|0)}function Bab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;kQ(a|0,b|0,c|0)}function Cab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;lQ(a|0,b|0)}function Dab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;$d(a|0,b|0,c|0)}function Eab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;_d(a|0,b|0,c|0)}function Fab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;WP(a|0,b|0)|0}function Gab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;mQ(a|0,b|0,c|0)}function Hab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;TP(a|0,b|0,c|0,d|0)}function Iab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;LP(a|0)|0}function Jab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;MP(a|0)|0}function Kab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;NP(a|0)|0}function Lab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;OP(a|0)|0}function Mab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;jQ(a|0,b|0,c|0)}function Nab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;NI(a|0)|0}function Oab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;OI(a|0)|0}function Pab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;PI(a|0)|0}function Qab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;QI(a|0)|0}function Rab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;RI(a|0)|0}function Sab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;SI(a|0)|0}function Tab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;TI(a|0)|0}function Uab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;UI(a|0)|0}function Vab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;VI(a|0)|0}function Wab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;WI(a|0)|0}function Xab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;XI(a|0)|0}function Yab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;YI(a|0)|0}function Zab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ZI(a|0)|0}function _ab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;_I(a|0)|0}function $ab(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;$I(a|0)|0}function abb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;aJ(a|0)|0}function bbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;bJ(a|0)|0}function cbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;cJ(a|0)|0}function dbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;dJ(a|0)|0}function ebb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;eJ(a|0)|0}function fbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;fJ(a|0)|0}function gbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;gJ(a|0)|0}function hbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;hJ(a|0)|0}function ibb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;iJ(a|0)|0}function jbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;jJ(a|0)|0}function kbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;kJ(a|0)|0}function lbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;lJ(a|0)|0}function mbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;mJ(a|0)|0}function nbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;nJ(a|0)|0}function obb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;oJ(a|0)|0}function pbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;pJ(a|0)|0}function qbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;qJ(a|0)|0}function rbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;rJ(a|0)|0}function sbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;sJ(a|0)|0}function tbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;tJ(a|0)|0}function ubb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;uJ(a|0)|0}function vbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;vJ(a|0)|0;
}function wbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;wJ(a|0)|0}function xbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;xJ(a|0)|0}function ybb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;yJ(a|0)|0}function zbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;zJ(a|0)|0}function Abb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;AJ(a|0)|0}function Bbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;BJ(a|0)|0}function Cbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;CJ(a|0)|0}function Dbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;DJ(a|0)|0}function Ebb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;EJ(a|0)|0}function Fbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;FJ(a|0)|0}function Gbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;GJ(a|0)|0}function Hbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;HJ(a|0)|0}function Ibb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;IJ(a|0)|0}function Jbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;JJ(a|0)|0}function Kbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;KJ(a|0)|0}function Lbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;LJ(a|0)|0}function Mbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;MJ(a|0)|0}function Nbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;NJ(a|0)|0}function Obb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;OJ(a|0)|0}function Pbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;PJ(a|0)|0}function Qbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;QJ(a|0)|0}function Rbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;RJ(a|0)|0}function Sbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;SJ(a|0)|0}function Tbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;TJ(a|0)|0}function Ubb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;UJ(a|0)|0}function Vbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;VJ(a|0)|0}function Wbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;WJ(a|0)|0}function Xbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;XJ(a|0)|0}function Ybb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;YJ(a|0)|0}function Zbb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ZJ(a|0)|0}function _bb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;_J(a|0)|0}function $bb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;$J(a|0)|0}function acb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;aK(a|0)|0}function bcb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;bK(a|0)|0}function ccb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;cK(a|0)|0}function dcb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;dK(a|0)|0}function ecb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;eK(a|0)|0}function fcb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;fK(a|0)|0}function gcb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;gK(a|0)|0}function hcb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;hK(a|0)|0}function icb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;iK(a|0)|0}function jcb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;jK(a|0)|0}function kcb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;kK(a|0)|0}function lcb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;lK(a|0)|0}function mcb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;mK(a|0)|0}function ncb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;nK(a|0)|0}function ocb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;oK(a|0)|0}function pcb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;pK(a|0)|0}function qcb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;qK(a|0)|0}function rcb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;rK(a|0)|0}function scb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;sK(a|0)|0}function tcb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;tK(a|0)|0}function ucb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;uK(a|0)|0}function vcb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;vK(a|0)|0}function wcb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;wK(a|0)|0}function xcb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;xK(a|0)|0}function ycb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;yK(a|0)|0}function zcb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;zK(a|0)|0}function Acb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;AK(a|0)|0}function Bcb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;BK(a|0)|0}function Ccb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;CK(a|0)|0}function Dcb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;DK(a|0)|0}function Ecb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;EK(a|0)|0}function Fcb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;FK(a|0)|0}function Gcb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;GK(a|0)|0}function Hcb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;HK(a|0)|0}function Icb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;IK(a|0)|0}function Jcb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;JK(a|0)|0}function Kcb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;KK(a|0)|0}function Lcb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;LK(a|0)|0}function Mcb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;MK(a|0)|0}function Ncb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;NK(a|0)|0}function Ocb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;OK(a|0)|0}function Pcb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;PK(a|0)|0}function Qcb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;QK(a|0)|0}function Rcb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;RK(a|0)|0}function Scb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;SK(a|0)|0}function Tcb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;TK(a|0)|0}function Ucb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;UK(a|0)|0}function Vcb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;VK(a|0)|0}function Wcb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;WK(a|0)|0}function Xcb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;XK(a|0)|0}function Ycb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;YK(a|0)|0}function Zcb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ZK(a|0)|0}function _cb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;_K(a|0)|0}function $cb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;$K(a|0)|0}function adb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;aL(a|0)|0}function bdb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;bL(a|0)|0}function cdb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;cL(a|0)|0}function ddb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;dL(a|0)|0}function edb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;eL(a|0)|0}function fdb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;RT(a|0,b|0,c|0)|0}function gdb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Vb(a|0)}function hdb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Wb(a|0)|0}function idb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Xb(a|0,b|0)|0}function jdb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Yb(a|0)|0}function kdb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Wk(a|0,b|0,c|0)|0}function ldb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;_b(a|0)}function mdb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;$b(a|0)}function ndb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ac(a|0,b|0,c|0)|0}function odb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Ka(a|0,b|0,c|0)|0}function pdb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;gc(a|0,b|0,c|0)|0}function qdb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;hc(a|0)}function rdb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ic(a|0,b|0,c|0)}function sdb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;jc(a|0,b|0,c|0)}function tdb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;kc(a|0,b|0,c|0)}function udb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;lc(a|0,b|0,c|0)}function vdb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;nc(a|0)|0}function wdb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;md(a|0,b|0)}function xdb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;nd(a|0)|0}function ydb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Kd(a|0,b|0,c|0,d|0)|0}function zdb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Ld(a|0,b|0,c|0,d|0)|0}function Adb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Md(a|0,b|0,c|0,d|0)|0}function Bdb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Nd(a|0,b|0,c|0,d|0)|0}function Cdb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Od(a|0,b|0,c|0,d|0)|0}function Ddb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Pd(a|0,b|0,c|0,d|0)|0}function Edb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;qd(a|0,b|0,c|0,d|0)|0}function Fdb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;rd(a|0,b|0,c|0,d|0)|0}function Gdb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Qd(a|0,b|0,c|0,d|0)|0}function Hdb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Rd(a|0,b|0,c|0,d|0)|0}function Idb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;fo(a|0,b|0,c|0,d|0)|0}function Jdb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ae(a|0,b|0,c|0)}function Kdb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;be(a|0,b|0,c|0)}function Ldb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;tg(a|0)}function Mdb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;mk()|0}function Ndb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;sh(a|0,b|0,c|0,d|0,e|0)}function Odb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;gk(a|0,b|0,c|0,d|0,e|0)}function Pdb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;nk(a|0)|0}function Qdb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ok(a|0)|0}function Rdb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;pk(a|0,b|0,c|0)|0}function Sdb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;qk(a|0)|0}function Tdb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;_k(a|0)|0}function Udb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;$k(a|0,b|0,c|0)|0}function Vdb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;bl(a|0)|0}function Wdb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;cl(a|0,b|0,c|0)|0}function Xdb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;dl(a|0)|0}function Ydb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;el(a|0,b|0,c|0)|0}function Zdb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;fl(a|0,b|0,c|0)|0}function _db(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;gl(a|0,b|0,c|0,d|0)|0}function $db(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;nn(a|0)}function aeb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;on(a|0)|0}function beb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;sn(a|0)}function ceb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;vn(a|0)|0}function deb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;xn(a|0)}function eeb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;yn(a|0)|0}function feb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;zn(a|0,b|0)}function geb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;An(a|0)}function heb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Bn(a|0)}function ieb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Cn(a|0,b|0)|0}function jeb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Dn(a|0)}function keb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;In(a|0,b|0,c|0)}function leb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Rn(a|0,b|0,c|0)}function meb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Sn(a|0,b|0,c|0)}function neb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Tn(a|0,b|0,c|0)}function oeb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Un(a|0,b|0,c|0)}function peb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;_n(a|0,b|0)|0}function qeb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;tq(a|0,b|0)}function reb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Qq(a|0)}function seb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Bs(a|0,b|0)}function teb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Is(a|0,b|0)}function ueb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ns(a|0,b|0)}function veb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ts(a|0,b|0)}function web(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;us(a|0,b|0)}function xeb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;os(a|0,b|0)}function yeb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Es(a|0,b|0)}function zeb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Hs(a|0,b|0)}function Aeb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ls(a|0,b|0)}function Beb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Fs(a|0,b|0)}function Ceb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ps(a|0,b|0)}function Deb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Cs(a|0,b|0)}function Eeb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;nt(a|0,b|0)}function Feb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;qs(a|0,b|0)}function Geb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;zs(a|0,b|0)}function Heb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Tr(a|0,b|0)}function Ieb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ms(a|0,b|0)}function Jeb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Js(a|0,b|0)}function Keb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;rs(a|0,b|0)}function Leb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ss(a|0,b|0)}function Meb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;vs(a|0,b|0)}function Neb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ws(a|0,b|0)}function Oeb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;xs(a|0,b|0)}function Peb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ys(a|0,b|0)}function Qeb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Gs(a|0,b|0)}function Reb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Ds(a|0,b|0)}function Seb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;As(a|0,b|0)}function Teb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ot(a|0,b|0)}function Ueb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;uu(a|0,b|0,c|0)|0}function Veb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ds(a|0,b|0)|0}function Web(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;es(a|0,b|0)|0}function Xeb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;js(a|0,b|0)|0}function Yeb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;vu(a|0,b|0,c|0)|0}function Zeb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;wu(a|0,b|0)|0}function _eb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;$r(a|0,b|0)|0}function $eb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;as(a|0,b|0)|0}function afb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;bs(a|0,b|0)|0}function bfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;hs(a|0,b|0)|0}function cfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;fs(a|0,b|0)|0}function dfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;is(a|0,b|0)|0}function efb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;cs(a|0,b|0)|0}function ffb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;xu(a|0,b|0)|0}function gfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;gs(a|0,b|0)|0}function hfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;_r(a|0,b|0)|0}function ifb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;dr(a|0,b|0)|0}function jfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;jv(a|0,b|0)}function kfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;pv(a|0,b|0)}function lfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;qv(a|0,b|0)}function mfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;rv(a|0,b|0)}function nfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;sv(a|0,b|0)}function ofb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;tv(a|0,b|0)}function pfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;uv(a|0,b|0)}function qfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;vv(a|0,b|0)}function rfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;tw(a|0,b|0,c|0)}function sfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Mw(a|0)}function tfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Yw(a|0)}function ufb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Kx(a|0,b|0,c|0)|0}function vfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;$x(a|0,b|0)|0}function wfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;dy(a|0,b|0)|0}function xfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;fy(a|0,b|0)|0}function yfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;jy(a|0,b|0)|0}function zfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;qB(a|0)}function Afb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;LB(a|0,b|0,c|0,d|0,e|0,f|0,0,0,0)}function Bfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;MB(a|0,b|0,c|0,d|0)}function Cfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;NB(a|0,b|0,c|0)}function Dfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;OB(a|0,b|0,c|0)}function Efb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;PB(a|0,b|0)}function Ffb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;QB(a|0,b|0,c|0,d|0)}function Gfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;RB(a|0)|0}function Hfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;SB(a|0)|0}function Ifb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;TB(a|0)|0}function Jfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;UB(a|0,b|0,c|0)|0}function Kfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;VB(a|0,b|0)|0}function Lfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;XB(a|0,b|0,c|0,d|0)}function Mfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;YB(a|0,b|0,c|0,d|0,e|0,f|0,0)}function Nfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ZB(a|0,b|0,c|0,d|0)}function Ofb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;_B(a|0,b|0,c|0,d|0,e|0)}function Pfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;$B(a|0,b|0)}function Qfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;aC(a|0)}function Rfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;bC(a|0)}function Sfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;cC(a|0,b|0,c|0)}function Tfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;dC(a|0,b|0)}function Ufb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;eC(a|0,b|0,c|0)}function Vfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;fC(a|0,b|0,c|0)}function Wfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;gC(a|0,b|0,c|0)}function Xfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;hC(a|0,b|0)|0}function Yfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;iC(a|0,b|0,c|0,d|0)}function Zfb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;jC(a|0,b|0,c|0)}function _fb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;kC(a|0,b|0,c|0)}function $fb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;lC(a|0,b|0,c|0)}function agb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;mC(a|0,b|0)}function bgb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;nC(a|0,b|0,c|0,d|0,e|0,f|0,0,0,0)}function cgb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;oC(a|0,b|0,c|0,d|0)}function dgb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;rC(a|0,b|0,c|0)|0}function egb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;uC(a|0)}function fgb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;AD(a|0,b|0)}function ggb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;lF(a|0,b|0,c|0,d|0)}function hgb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;uF(a|0,b|0)}function igb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;VA(a|0)}function jgb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;wM(a|0,b|0,c|0)}function kgb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;xM(a|0,b|0)}function lgb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;yM(a|0,b|0,c|0,d|0,e|0,f|0,0,0,0)}function mgb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;zM(a|0,b|0,c|0,d|0)}function ngb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;AM(a|0,b|0,c|0)}function ogb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;BM(a|0,b|0,c|0)}function pgb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;DM(a|0,b|0,c|0)}function qgb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;EM(a|0,b|0,c|0)}function rgb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;GM(a|0,b|0,c|0)|0}function sgb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;FM(a|0,b|0)}function tgb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;UM(a|0)}function ugb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;nN(a|0,b|0)|0}function vgb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;oN(a|0,b|0,c|0,d|0,e|0)|0}function wgb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;pN(a|0,b|0,c|0,d|0,e|0,f|0,0)|0}function xgb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;qN(a|0,b|0,c|0,d|0,e|0,f|0)|0}function ygb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;rN(a|0,b|0)}function zgb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;tN(a|0,b|0)|0}function Agb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;uN(a|0,b|0,c|0,d|0,e|0)|0}function Bgb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;vN(a|0,b|0,c|0,d|0,e|0,f|0,0)|0}function Cgb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;wN(a|0,b|0)}function Dgb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;CN(a|0,b|0,c|0)}function Egb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;GN(a|0,b|0,c|0,d|0)}function Fgb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;vO(a|0,b|0,c|0)}function Ggb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;wO(a|0,b|0,c|0)}function Hgb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;fP(a|0,b|0,c|0,d|0)}function Igb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;sP(a|0,b|0,c|0)}function Jgb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;fQ(a|0,b|0,c|0,d|0,e|0,f|0,0,0,0)}function Kgb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;gQ(a|0,b|0,c|0,d|0)}function Lgb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;WR(a|0,b|0,c|0,d|0)|0}function Mgb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;QS(a|0,b|0)|0}function Ngb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;hT(a|0,b|0,c|0)|0}function Ogb(a,b){a=a|0;b=b|0;da(13);return 0}function Pgb(a,b){a=a|0;b=b|0;return 0}function Qgb(a,b){a=a|0;b=b|0;return vc(a|0)|0}function Rgb(a,b){a=a|0;b=b|0;return wc(a|0)|0}function Sgb(a,b){a=a|0;b=b|0;return xc(a|0)|0}function Tgb(a,b){a=a|0;b=b|0;return yc(a|0,b|0,0)|0}function Ugb(a,b){a=a|0;b=b|0;return 0}function Vgb(a,b){a=a|0;b=b|0;return 0}function Wgb(a,b){a=a|0;b=b|0;return 0}function Xgb(a,b){a=a|0;b=b|0;return 0}function Ygb(a,b){a=a|0;b=b|0;return 0}function Zgb(a,b){a=a|0;b=b|0;return 0}function _gb(a,b){a=a|0;b=b|0;return 0}function $gb(a,b){a=a|0;b=b|0;return 0}function ahb(a,b){a=a|0;b=b|0;return 0}function bhb(a,b){a=a|0;b=b|0;return 0}function chb(a,b){a=a|0;b=b|0;return 0}function dhb(a,b){a=a|0;b=b|0;return 0}function ehb(a,b){a=a|0;b=b|0;return 0}function fhb(a,b){a=a|0;b=b|0;return 0}function ghb(a,b){a=a|0;b=b|0;return 0}function hhb(a,b){a=a|0;b=b|0;return 0}function ihb(a,b){a=a|0;b=b|0;return 0}function jhb(a,b){a=a|0;b=b|0;return 0}function khb(a,b){a=a|0;b=b|0;return 0}function lhb(a,b){a=a|0;b=b|0;return 0}function mhb(a,b){a=a|0;b=b|0;return 0}function nhb(a,b){a=a|0;b=b|0;return 0}function ohb(a,b){a=a|0;b=b|0;return Xk(a|0,b|0,0)|0}function phb(a,b){a=a|0;b=b|0;return 0}function qhb(a,b){a=a|0;b=b|0;return iT(a|0)|0}function rhb(a,b){a=a|0;b=b|0;return my(a|0)|0}function shb(a,b){a=a|0;b=b|0;return 0}function thb(a,b){a=a|0;b=b|0;return 0}function uhb(a,b){a=a|0;b=b|0;return PP(a|0)|0}function vhb(a,b){a=a|0;b=b|0;return QP(a|0)|0}function whb(a,b){a=a|0;b=b|0;return RP(a|0)|0}function xhb(a,b){a=a|0;b=b|0;return UP(a|0,b|0,0)|0}function yhb(a,b){a=a|0;b=b|0;return 0}function zhb(a,b){a=a|0;b=b|0;return 0}function Ahb(a,b){a=a|0;b=b|0;return 0}function Bhb(a,b){a=a|0;b=b|0;return 0}function Chb(a,b){a=a|0;b=b|0;return 0}function Dhb(a,b){a=a|0;b=b|0;return 0}function Ehb(a,b){a=a|0;b=b|0;return 0}function Fhb(a,b){a=a|0;b=b|0;return 0}function Ghb(a,b){a=a|0;b=b|0;return 0}function Hhb(a,b){a=a|0;b=b|0;return 0}function Ihb(a,b){a=a|0;b=b|0;return 0}function Jhb(a,b){a=a|0;b=b|0;return 0}function Khb(a,b){a=a|0;b=b|0;return 0}function Lhb(a,b){a=a|0;b=b|0;return 0}function Mhb(a,b){a=a|0;b=b|0;return 0}function Nhb(a,b){a=a|0;b=b|0;return 0}function Ohb(a,b){a=a|0;b=b|0;return 0}function Phb(a,b){a=a|0;b=b|0;return 0}function Qhb(a,b){a=a|0;b=b|0;return LP(a|0)|0}function Rhb(a,b){a=a|0;b=b|0;return MP(a|0)|0}function Shb(a,b){a=a|0;b=b|0;return NP(a|0)|0}function Thb(a,b){a=a|0;b=b|0;return OP(a|0)|0}function Uhb(a,b){a=a|0;b=b|0;return 0}function Vhb(a,b){a=a|0;b=b|0;return NI(a|0)|0}function Whb(a,b){a=a|0;b=b|0;return OI(a|0)|0}function Xhb(a,b){a=a|0;b=b|0;return PI(a|0)|0}function Yhb(a,b){a=a|0;b=b|0;return QI(a|0)|0}function Zhb(a,b){a=a|0;b=b|0;return RI(a|0)|0}function _hb(a,b){a=a|0;b=b|0;return SI(a|0)|0}function $hb(a,b){a=a|0;b=b|0;return TI(a|0)|0}function aib(a,b){a=a|0;b=b|0;return UI(a|0)|0}function bib(a,b){a=a|0;b=b|0;return VI(a|0)|0}function cib(a,b){a=a|0;b=b|0;return WI(a|0)|0}function dib(a,b){a=a|0;b=b|0;return XI(a|0)|0}function eib(a,b){a=a|0;b=b|0;return YI(a|0)|0}function fib(a,b){a=a|0;b=b|0;return ZI(a|0)|0}function gib(a,b){a=a|0;b=b|0;return _I(a|0)|0}function hib(a,b){a=a|0;b=b|0;return $I(a|0)|0}function iib(a,b){a=a|0;b=b|0;return aJ(a|0)|0}function jib(a,b){a=a|0;b=b|0;return bJ(a|0)|0}function kib(a,b){a=a|0;b=b|0;return cJ(a|0)|0}function lib(a,b){a=a|0;b=b|0;return dJ(a|0)|0}function mib(a,b){a=a|0;b=b|0;return eJ(a|0)|0}function nib(a,b){a=a|0;b=b|0;return fJ(a|0)|0}function oib(a,b){a=a|0;b=b|0;return gJ(a|0)|0}function pib(a,b){a=a|0;b=b|0;return hJ(a|0)|0}function qib(a,b){a=a|0;b=b|0;return iJ(a|0)|0}function rib(a,b){a=a|0;b=b|0;return jJ(a|0)|0}function sib(a,b){a=a|0;b=b|0;return kJ(a|0)|0}function tib(a,b){a=a|0;b=b|0;return lJ(a|0)|0}function uib(a,b){a=a|0;b=b|0;return mJ(a|0)|0}function vib(a,b){a=a|0;b=b|0;return nJ(a|0)|0}function wib(a,b){a=a|0;b=b|0;return oJ(a|0)|0}function xib(a,b){a=a|0;b=b|0;return pJ(a|0)|0}function yib(a,b){a=a|0;b=b|0;return qJ(a|0)|0}function zib(a,b){a=a|0;b=b|0;return rJ(a|0)|0}function Aib(a,b){a=a|0;b=b|0;return sJ(a|0)|0}function Bib(a,b){a=a|0;b=b|0;return tJ(a|0)|0}function Cib(a,b){a=a|0;b=b|0;return uJ(a|0)|0}function Dib(a,b){a=a|0;b=b|0;return vJ(a|0)|0}function Eib(a,b){a=a|0;b=b|0;return wJ(a|0)|0}function Fib(a,b){a=a|0;b=b|0;return xJ(a|0)|0}function Gib(a,b){a=a|0;b=b|0;return yJ(a|0)|0}function Hib(a,b){a=a|0;b=b|0;return zJ(a|0)|0}function Iib(a,b){a=a|0;b=b|0;return AJ(a|0)|0}function Jib(a,b){a=a|0;b=b|0;return BJ(a|0)|0}function Kib(a,b){a=a|0;b=b|0;return CJ(a|0)|0}function Lib(a,b){a=a|0;b=b|0;return DJ(a|0)|0}function Mib(a,b){a=a|0;b=b|0;return EJ(a|0)|0}function Nib(a,b){a=a|0;b=b|0;return FJ(a|0)|0}function Oib(a,b){a=a|0;b=b|0;return GJ(a|0)|0}function Pib(a,b){a=a|0;b=b|0;return HJ(a|0)|0}function Qib(a,b){a=a|0;b=b|0;return IJ(a|0)|0}function Rib(a,b){a=a|0;b=b|0;return JJ(a|0)|0}function Sib(a,b){a=a|0;b=b|0;return KJ(a|0)|0}function Tib(a,b){a=a|0;b=b|0;return LJ(a|0)|0}function Uib(a,b){a=a|0;b=b|0;return MJ(a|0)|0}function Vib(a,b){a=a|0;b=b|0;return NJ(a|0)|0}function Wib(a,b){a=a|0;b=b|0;return OJ(a|0)|0}function Xib(a,b){a=a|0;b=b|0;return PJ(a|0)|0}function Yib(a,b){a=a|0;b=b|0;return QJ(a|0)|0}function Zib(a,b){a=a|0;b=b|0;return RJ(a|0)|0}function _ib(a,b){a=a|0;b=b|0;return SJ(a|0)|0}function $ib(a,b){a=a|0;b=b|0;return TJ(a|0)|0}function ajb(a,b){a=a|0;b=b|0;return UJ(a|0)|0}function bjb(a,b){a=a|0;b=b|0;return VJ(a|0)|0}function cjb(a,b){a=a|0;b=b|0;return WJ(a|0)|0}function djb(a,b){a=a|0;b=b|0;return XJ(a|0)|0}function ejb(a,b){a=a|0;b=b|0;return YJ(a|0)|0}function fjb(a,b){a=a|0;b=b|0;return ZJ(a|0)|0}function gjb(a,b){a=a|0;b=b|0;return _J(a|0)|0}function hjb(a,b){a=a|0;b=b|0;return $J(a|0)|0}function ijb(a,b){a=a|0;b=b|0;return aK(a|0)|0}function jjb(a,b){a=a|0;b=b|0;return bK(a|0)|0}function kjb(a,b){a=a|0;b=b|0;return cK(a|0)|0}function ljb(a,b){a=a|0;b=b|0;return dK(a|0)|0}function mjb(a,b){a=a|0;b=b|0;return eK(a|0)|0}function njb(a,b){a=a|0;b=b|0;return fK(a|0)|0}function ojb(a,b){a=a|0;b=b|0;return gK(a|0)|0}function pjb(a,b){a=a|0;b=b|0;return hK(a|0)|0}function qjb(a,b){a=a|0;b=b|0;return iK(a|0)|0}function rjb(a,b){a=a|0;b=b|0;return jK(a|0)|0}function sjb(a,b){a=a|0;b=b|0;return kK(a|0)|0}function tjb(a,b){a=a|0;b=b|0;return lK(a|0)|0}function ujb(a,b){a=a|0;b=b|0;return mK(a|0)|0}function vjb(a,b){a=a|0;b=b|0;return nK(a|0)|0}function wjb(a,b){a=a|0;b=b|0;return oK(a|0)|0}function xjb(a,b){a=a|0;b=b|0;return pK(a|0)|0}function yjb(a,b){a=a|0;b=b|0;return qK(a|0)|0}function zjb(a,b){a=a|0;b=b|0;return rK(a|0)|0}function Ajb(a,b){a=a|0;b=b|0;return sK(a|0)|0}function Bjb(a,b){a=a|0;b=b|0;return tK(a|0)|0}function Cjb(a,b){a=a|0;b=b|0;return uK(a|0)|0}function Djb(a,b){a=a|0;b=b|0;return vK(a|0)|0}function Ejb(a,b){a=a|0;b=b|0;return wK(a|0)|0}function Fjb(a,b){a=a|0;b=b|0;return xK(a|0)|0}function Gjb(a,b){a=a|0;b=b|0;return yK(a|0)|0}function Hjb(a,b){a=a|0;b=b|0;return zK(a|0)|0}function Ijb(a,b){a=a|0;b=b|0;return AK(a|0)|0}function Jjb(a,b){a=a|0;b=b|0;return BK(a|0)|0}function Kjb(a,b){a=a|0;b=b|0;return CK(a|0)|0}function Ljb(a,b){a=a|0;b=b|0;return DK(a|0)|0}function Mjb(a,b){a=a|0;b=b|0;return EK(a|0)|0}function Njb(a,b){a=a|0;b=b|0;return FK(a|0)|0}function Ojb(a,b){a=a|0;b=b|0;return GK(a|0)|0}function Pjb(a,b){a=a|0;b=b|0;return HK(a|0)|0}function Qjb(a,b){a=a|0;b=b|0;return IK(a|0)|0}function Rjb(a,b){a=a|0;b=b|0;return JK(a|0)|0}function Sjb(a,b){a=a|0;b=b|0;return KK(a|0)|0}function Tjb(a,b){a=a|0;b=b|0;return LK(a|0)|0}function Ujb(a,b){a=a|0;b=b|0;return MK(a|0)|0}function Vjb(a,b){a=a|0;b=b|0;return NK(a|0)|0}function Wjb(a,b){a=a|0;b=b|0;return OK(a|0)|0}function Xjb(a,b){a=a|0;b=b|0;return PK(a|0)|0}function Yjb(a,b){a=a|0;b=b|0;return QK(a|0)|0}function Zjb(a,b){a=a|0;b=b|0;return RK(a|0)|0}function _jb(a,b){a=a|0;b=b|0;return SK(a|0)|0}function $jb(a,b){a=a|0;b=b|0;return TK(a|0)|0}function akb(a,b){a=a|0;b=b|0;return UK(a|0)|0}function bkb(a,b){a=a|0;b=b|0;return VK(a|0)|0}function ckb(a,b){a=a|0;b=b|0;return WK(a|0)|0}function dkb(a,b){a=a|0;b=b|0;return XK(a|0)|0}function ekb(a,b){a=a|0;b=b|0;return YK(a|0)|0}function fkb(a,b){a=a|0;b=b|0;return ZK(a|0)|0}function gkb(a,b){a=a|0;b=b|0;return _K(a|0)|0}function hkb(a,b){a=a|0;b=b|0;return $K(a|0)|0}function ikb(a,b){a=a|0;b=b|0;return aL(a|0)|0}function jkb(a,b){a=a|0;b=b|0;return bL(a|0)|0}function kkb(a,b){a=a|0;b=b|0;return cL(a|0)|0}function lkb(a,b){a=a|0;b=b|0;return dL(a|0)|0}function mkb(a,b){a=a|0;b=b|0;return eL(a|0)|0}function nkb(a,b){a=a|0;b=b|0;return RT(a|0,b|0,0)|0}function okb(a,b){a=a|0;b=b|0;return 0}function pkb(a,b){a=a|0;b=b|0;return Wb(a|0)|0}function qkb(a,b){a=a|0;b=b|0;return Yb(a|0)|0}function rkb(a,b){a=a|0;b=b|0;return Wk(a|0,b|0,0)|0}function skb(a,b){a=a|0;b=b|0;return 0}function tkb(a,b){a=a|0;b=b|0;return 0}function ukb(a,b){a=a|0;b=b|0;return ac(a|0,b|0,0)|0}function vkb(a,b){a=a|0;b=b|0;return Ka(a|0,b|0,0)|0}function wkb(a,b){a=a|0;b=b|0;return gc(a|0,b|0,0)|0}function xkb(a,b){a=a|0;b=b|0;return 0}function ykb(a,b){a=a|0;b=b|0;return 0}function zkb(a,b){a=a|0;b=b|0;return 0}function Akb(a,b){a=a|0;b=b|0;return 0}function Bkb(a,b){a=a|0;b=b|0;return 0}function Ckb(a,b){a=a|0;b=b|0;return nc(a|0)|0}function Dkb(a,b){a=a|0;b=b|0;return 0}function Ekb(a,b){a=a|0;b=b|0;return nd(a|0)|0}function Fkb(a,b){a=a|0;b=b|0;return Kd(a|0,b|0,0,0)|0}function Gkb(a,b){a=a|0;b=b|0;return Ld(a|0,b|0,0,0)|0}function Hkb(a,b){a=a|0;b=b|0;return Md(a|0,b|0,0,0)|0}function Ikb(a,b){a=a|0;b=b|0;return Nd(a|0,b|0,0,0)|0}function Jkb(a,b){a=a|0;b=b|0;return Od(a|0,b|0,0,0)|0}function Kkb(a,b){a=a|0;b=b|0;return Pd(a|0,b|0,0,0)|0}function Lkb(a,b){a=a|0;b=b|0;return qd(a|0,b|0,0,0)|0}function Mkb(a,b){a=a|0;b=b|0;return rd(a|0,b|0,0,0)|0}function Nkb(a,b){a=a|0;b=b|0;return Qd(a|0,b|0,0,0)|0}function Okb(a,b){a=a|0;b=b|0;return Rd(a|0,b|0,0,0)|0}function Pkb(a,b){a=a|0;b=b|0;return fo(a|0,b|0,0,0)|0}function Qkb(a,b){a=a|0;b=b|0;return 0}function Rkb(a,b){a=a|0;b=b|0;return 0}function Skb(a,b){a=a|0;b=b|0;return 0}function Tkb(a,b){a=a|0;b=b|0;return mk()|0}function Ukb(a,b){a=a|0;b=b|0;return 0}function Vkb(a,b){a=a|0;b=b|0;return 0}function Wkb(a,b){a=a|0;b=b|0;return nk(a|0)|0}function Xkb(a,b){a=a|0;b=b|0;return ok(a|0)|0;
}function Ykb(a,b){a=a|0;b=b|0;return pk(a|0,b|0,0)|0}function Zkb(a,b){a=a|0;b=b|0;return qk(a|0)|0}function _kb(a,b){a=a|0;b=b|0;return _k(a|0)|0}function $kb(a,b){a=a|0;b=b|0;return $k(a|0,b|0,0)|0}function alb(a,b){a=a|0;b=b|0;return bl(a|0)|0}function blb(a,b){a=a|0;b=b|0;return cl(a|0,b|0,0)|0}function clb(a,b){a=a|0;b=b|0;return dl(a|0)|0}function dlb(a,b){a=a|0;b=b|0;return el(a|0,b|0,0)|0}function elb(a,b){a=a|0;b=b|0;return fl(a|0,b|0,0)|0}function flb(a,b){a=a|0;b=b|0;return gl(a|0,b|0,0,0)|0}function glb(a,b){a=a|0;b=b|0;return 0}function hlb(a,b){a=a|0;b=b|0;return on(a|0)|0}function ilb(a,b){a=a|0;b=b|0;return 0}function jlb(a,b){a=a|0;b=b|0;return vn(a|0)|0}function klb(a,b){a=a|0;b=b|0;return 0}function llb(a,b){a=a|0;b=b|0;return yn(a|0)|0}function mlb(a,b){a=a|0;b=b|0;return 0}function nlb(a,b){a=a|0;b=b|0;return 0}function olb(a,b){a=a|0;b=b|0;return 0}function plb(a,b){a=a|0;b=b|0;return 0}function qlb(a,b){a=a|0;b=b|0;return 0}function rlb(a,b){a=a|0;b=b|0;return 0}function slb(a,b){a=a|0;b=b|0;return 0}function tlb(a,b){a=a|0;b=b|0;return 0}function ulb(a,b){a=a|0;b=b|0;return 0}function vlb(a,b){a=a|0;b=b|0;return 0}function wlb(a,b){a=a|0;b=b|0;return 0}function xlb(a,b){a=a|0;b=b|0;return 0}function ylb(a,b){a=a|0;b=b|0;return 0}function zlb(a,b){a=a|0;b=b|0;return 0}function Alb(a,b){a=a|0;b=b|0;return 0}function Blb(a,b){a=a|0;b=b|0;return 0}function Clb(a,b){a=a|0;b=b|0;return 0}function Dlb(a,b){a=a|0;b=b|0;return 0}function Elb(a,b){a=a|0;b=b|0;return 0}function Flb(a,b){a=a|0;b=b|0;return 0}function Glb(a,b){a=a|0;b=b|0;return 0}function Hlb(a,b){a=a|0;b=b|0;return 0}function Ilb(a,b){a=a|0;b=b|0;return 0}function Jlb(a,b){a=a|0;b=b|0;return 0}function Klb(a,b){a=a|0;b=b|0;return 0}function Llb(a,b){a=a|0;b=b|0;return 0}function Mlb(a,b){a=a|0;b=b|0;return 0}function Nlb(a,b){a=a|0;b=b|0;return 0}function Olb(a,b){a=a|0;b=b|0;return 0}function Plb(a,b){a=a|0;b=b|0;return 0}function Qlb(a,b){a=a|0;b=b|0;return 0}function Rlb(a,b){a=a|0;b=b|0;return 0}function Slb(a,b){a=a|0;b=b|0;return 0}function Tlb(a,b){a=a|0;b=b|0;return 0}function Ulb(a,b){a=a|0;b=b|0;return 0}function Vlb(a,b){a=a|0;b=b|0;return 0}function Wlb(a,b){a=a|0;b=b|0;return 0}function Xlb(a,b){a=a|0;b=b|0;return 0}function Ylb(a,b){a=a|0;b=b|0;return 0}function Zlb(a,b){a=a|0;b=b|0;return uu(a|0,b|0,0)|0}function _lb(a,b){a=a|0;b=b|0;return vu(a|0,b|0,0)|0}function $lb(a,b){a=a|0;b=b|0;return 0}function amb(a,b){a=a|0;b=b|0;return 0}function bmb(a,b){a=a|0;b=b|0;return 0}function cmb(a,b){a=a|0;b=b|0;return 0}function dmb(a,b){a=a|0;b=b|0;return 0}function emb(a,b){a=a|0;b=b|0;return 0}function fmb(a,b){a=a|0;b=b|0;return 0}function gmb(a,b){a=a|0;b=b|0;return 0}function hmb(a,b){a=a|0;b=b|0;return 0}function imb(a,b){a=a|0;b=b|0;return 0}function jmb(a,b){a=a|0;b=b|0;return 0}function kmb(a,b){a=a|0;b=b|0;return Kx(a|0,b|0,0)|0}function lmb(a,b){a=a|0;b=b|0;return 0}function mmb(a,b){a=a|0;b=b|0;return 0}function nmb(a,b){a=a|0;b=b|0;return 0}function omb(a,b){a=a|0;b=b|0;return 0}function pmb(a,b){a=a|0;b=b|0;return 0}function qmb(a,b){a=a|0;b=b|0;return 0}function rmb(a,b){a=a|0;b=b|0;return 0}function smb(a,b){a=a|0;b=b|0;return RB(a|0)|0}function tmb(a,b){a=a|0;b=b|0;return SB(a|0)|0}function umb(a,b){a=a|0;b=b|0;return TB(a|0)|0}function vmb(a,b){a=a|0;b=b|0;return UB(a|0,b|0,0)|0}function wmb(a,b){a=a|0;b=b|0;return 0}function xmb(a,b){a=a|0;b=b|0;return 0}function ymb(a,b){a=a|0;b=b|0;return 0}function zmb(a,b){a=a|0;b=b|0;return 0}function Amb(a,b){a=a|0;b=b|0;return 0}function Bmb(a,b){a=a|0;b=b|0;return 0}function Cmb(a,b){a=a|0;b=b|0;return 0}function Dmb(a,b){a=a|0;b=b|0;return 0}function Emb(a,b){a=a|0;b=b|0;return 0}function Fmb(a,b){a=a|0;b=b|0;return 0}function Gmb(a,b){a=a|0;b=b|0;return 0}function Hmb(a,b){a=a|0;b=b|0;return 0}function Imb(a,b){a=a|0;b=b|0;return 0}function Jmb(a,b){a=a|0;b=b|0;return 0}function Kmb(a,b){a=a|0;b=b|0;return 0}function Lmb(a,b){a=a|0;b=b|0;return 0}function Mmb(a,b){a=a|0;b=b|0;return 0}function Nmb(a,b){a=a|0;b=b|0;return 0}function Omb(a,b){a=a|0;b=b|0;return 0}function Pmb(a,b){a=a|0;b=b|0;return 0}function Qmb(a,b){a=a|0;b=b|0;return rC(a|0,b|0,0)|0}function Rmb(a,b){a=a|0;b=b|0;return 0}function Smb(a,b){a=a|0;b=b|0;return 0}function Tmb(a,b){a=a|0;b=b|0;return 0}function Umb(a,b){a=a|0;b=b|0;return 0}function Vmb(a,b){a=a|0;b=b|0;return 0}function Wmb(a,b){a=a|0;b=b|0;return 0}function Xmb(a,b){a=a|0;b=b|0;return 0}function Ymb(a,b){a=a|0;b=b|0;return 0}function Zmb(a,b){a=a|0;b=b|0;return 0}function _mb(a,b){a=a|0;b=b|0;return 0}function $mb(a,b){a=a|0;b=b|0;return 0}function anb(a,b){a=a|0;b=b|0;return 0}function bnb(a,b){a=a|0;b=b|0;return 0}function cnb(a,b){a=a|0;b=b|0;return GM(a|0,b|0,0)|0}function dnb(a,b){a=a|0;b=b|0;return 0}function enb(a,b){a=a|0;b=b|0;return 0}function fnb(a,b){a=a|0;b=b|0;return oN(a|0,b|0,0,0,0)|0}function gnb(a,b){a=a|0;b=b|0;return pN(a|0,b|0,0,0,0,0,0)|0}function hnb(a,b){a=a|0;b=b|0;return qN(a|0,b|0,0,0,0,0)|0}function inb(a,b){a=a|0;b=b|0;return 0}function jnb(a,b){a=a|0;b=b|0;return uN(a|0,b|0,0,0,0)|0}function knb(a,b){a=a|0;b=b|0;return vN(a|0,b|0,0,0,0,0,0)|0}function lnb(a,b){a=a|0;b=b|0;return 0}function mnb(a,b){a=a|0;b=b|0;return 0}function nnb(a,b){a=a|0;b=b|0;return 0}function onb(a,b){a=a|0;b=b|0;return 0}function pnb(a,b){a=a|0;b=b|0;return 0}function qnb(a,b){a=a|0;b=b|0;return 0}function rnb(a,b){a=a|0;b=b|0;return 0}function snb(a,b){a=a|0;b=b|0;return 0}function tnb(a,b){a=a|0;b=b|0;return 0}function unb(a,b){a=a|0;b=b|0;return WR(a|0,b|0,0,0)|0}function vnb(a,b){a=a|0;b=b|0;return hT(a|0,b|0,0)|0}function wnb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;da(14);return 0}function xnb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function ynb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return vc(a|0)|0}function znb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return wc(a|0)|0}function Anb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return xc(a|0)|0}function Bnb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return yc(a|0,b|0,c|0)|0}function Cnb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return zc(a|0,b|0)|0}function Dnb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Enb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Fnb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Gnb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Hnb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Inb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Jnb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Knb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Lnb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Mnb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Nnb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Onb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Pnb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Qnb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Rnb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Snb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Tnb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Unb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Vnb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Qc(a|0,b|0)|0}function Wnb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Xnb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Ynb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Znb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function _nb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Xk(a|0,b|0,c|0)|0}function $nb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function aob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return iT(a|0)|0}function bob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return kT(a|0,b|0)|0}function cob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return my(a|0)|0}function dob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function eob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function fob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return PP(a|0)|0}function gob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return QP(a|0)|0}function hob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return RP(a|0)|0}function iob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return UP(a|0,b|0,c|0)|0}function job(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return VP(a|0,b|0)|0}function kob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function lob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function mob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function nob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function oob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function pob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function qob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function rob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function sob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function tob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function uob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function vob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function wob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function xob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function yob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function zob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Aob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return WP(a|0,b|0)|0}function Bob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Cob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Dob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return LP(a|0)|0}function Eob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return MP(a|0)|0}function Fob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return NP(a|0)|0}function Gob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return OP(a|0)|0}function Hob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Iob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return NI(a|0)|0}function Job(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return OI(a|0)|0}function Kob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return PI(a|0)|0}function Lob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return QI(a|0)|0}function Mob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return RI(a|0)|0}function Nob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return SI(a|0)|0}function Oob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return TI(a|0)|0}function Pob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return UI(a|0)|0}function Qob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return VI(a|0)|0}function Rob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return WI(a|0)|0}function Sob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return XI(a|0)|0}function Tob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return YI(a|0)|0}function Uob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return ZI(a|0)|0}function Vob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return _I(a|0)|0}function Wob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return $I(a|0)|0}function Xob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return aJ(a|0)|0}function Yob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return bJ(a|0)|0}function Zob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return cJ(a|0)|0}function _ob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return dJ(a|0)|0}function $ob(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return eJ(a|0)|0}function apb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return fJ(a|0)|0}function bpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return gJ(a|0)|0}function cpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return hJ(a|0)|0}function dpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return iJ(a|0)|0}function epb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return jJ(a|0)|0}function fpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return kJ(a|0)|0}function gpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return lJ(a|0)|0}function hpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return mJ(a|0)|0}function ipb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return nJ(a|0)|0}function jpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return oJ(a|0)|0}function kpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return pJ(a|0)|0}function lpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return qJ(a|0)|0}function mpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return rJ(a|0)|0}function npb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return sJ(a|0)|0}function opb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return tJ(a|0)|0}function ppb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return uJ(a|0)|0}function qpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return vJ(a|0)|0}function rpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return wJ(a|0)|0}function spb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return xJ(a|0)|0}function tpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return yJ(a|0)|0}function upb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return zJ(a|0)|0}function vpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return AJ(a|0)|0}function wpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return BJ(a|0)|0}function xpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return CJ(a|0)|0}function ypb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return DJ(a|0)|0}function zpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return EJ(a|0)|0}function Apb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return FJ(a|0)|0}function Bpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return GJ(a|0)|0}function Cpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return HJ(a|0)|0}function Dpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return IJ(a|0)|0}function Epb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return JJ(a|0)|0}function Fpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return KJ(a|0)|0}function Gpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return LJ(a|0)|0}function Hpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return MJ(a|0)|0}function Ipb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return NJ(a|0)|0}function Jpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return OJ(a|0)|0}function Kpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return PJ(a|0)|0}function Lpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return QJ(a|0)|0}function Mpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return RJ(a|0)|0}function Npb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return SJ(a|0)|0}function Opb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return TJ(a|0)|0}function Ppb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return UJ(a|0)|0}function Qpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return VJ(a|0)|0}function Rpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return WJ(a|0)|0}function Spb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return XJ(a|0)|0}function Tpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return YJ(a|0)|0}function Upb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return ZJ(a|0)|0}function Vpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return _J(a|0)|0}function Wpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return $J(a|0)|0}function Xpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return aK(a|0)|0}function Ypb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return bK(a|0)|0}function Zpb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return cK(a|0)|0}function _pb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return dK(a|0)|0}function $pb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return eK(a|0)|0}function aqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return fK(a|0)|0}function bqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return gK(a|0)|0}function cqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return hK(a|0)|0}function dqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return iK(a|0)|0}function eqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return jK(a|0)|0}function fqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return kK(a|0)|0}function gqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return lK(a|0)|0}function hqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return mK(a|0)|0}function iqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return nK(a|0)|0}function jqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return oK(a|0)|0}function kqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return pK(a|0)|0}function lqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return qK(a|0)|0}function mqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return rK(a|0)|0}function nqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return sK(a|0)|0}function oqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return tK(a|0)|0}function pqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return uK(a|0)|0}function qqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return vK(a|0)|0}function rqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return wK(a|0)|0}function sqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return xK(a|0)|0}function tqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return yK(a|0)|0}function uqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return zK(a|0)|0}function vqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return AK(a|0)|0}function wqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return BK(a|0)|0}function xqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return CK(a|0)|0}function yqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return DK(a|0)|0}function zqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return EK(a|0)|0}function Aqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return FK(a|0)|0}function Bqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return GK(a|0)|0}function Cqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return HK(a|0)|0}function Dqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return IK(a|0)|0}function Eqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return JK(a|0)|0}function Fqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return KK(a|0)|0}function Gqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return LK(a|0)|0}function Hqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return MK(a|0)|0}function Iqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return NK(a|0)|0}function Jqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return OK(a|0)|0}function Kqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return PK(a|0)|0}function Lqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return QK(a|0)|0}function Mqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return RK(a|0)|0}function Nqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return SK(a|0)|0}function Oqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return TK(a|0)|0}function Pqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return UK(a|0)|0}function Qqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return VK(a|0)|0}function Rqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return WK(a|0)|0}function Sqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return XK(a|0)|0}function Tqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return YK(a|0)|0}function Uqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return ZK(a|0)|0}function Vqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return _K(a|0)|0}function Wqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return $K(a|0)|0}function Xqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return aL(a|0)|0}function Yqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return bL(a|0)|0}function Zqb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return cL(a|0)|0}function _qb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return dL(a|0)|0}function $qb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return eL(a|0)|0}function arb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return RT(a|0,b|0,c|0)|0}function brb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function crb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Wb(a|0)|0}function drb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Xb(a|0,b|0)|0}function erb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Yb(a|0)|0}function frb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Wk(a|0,b|0,c|0)|0}function grb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function hrb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function irb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return ac(a|0,b|0,c|0)|0}function jrb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Ka(a|0,b|0,c|0)|0}function krb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return gc(a|0,b|0,c|0)|0}function lrb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function mrb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function nrb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function orb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function prb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function qrb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return nc(a|0)|0}function rrb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function srb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return nd(a|0)|0}function trb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Kd(a|0,b|0,c|0,d|0)|0}function urb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Ld(a|0,b|0,c|0,d|0)|0}function vrb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Md(a|0,b|0,c|0,d|0)|0}function wrb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Nd(a|0,b|0,c|0,d|0)|0}function xrb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Od(a|0,b|0,c|0,d|0)|0}function yrb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Pd(a|0,b|0,c|0,d|0)|0}function zrb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return qd(a|0,b|0,c|0,d|0)|0}function Arb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return rd(a|0,b|0,c|0,d|0)|0}function Brb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Qd(a|0,b|0,c|0,d|0)|0}function Crb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Rd(a|0,b|0,c|0,d|0)|0}function Drb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return fo(a|0,b|0,c|0,d|0)|0}function Erb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Frb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Grb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Hrb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return mk()|0}function Irb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Jrb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Krb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return nk(a|0)|0}function Lrb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return ok(a|0)|0}function Mrb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return pk(a|0,b|0,c|0)|0}function Nrb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return qk(a|0)|0}function Orb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return _k(a|0)|0}function Prb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return $k(a|0,b|0,c|0)|0}function Qrb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return bl(a|0)|0}function Rrb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return cl(a|0,b|0,c|0)|0}function Srb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return dl(a|0)|0}function Trb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return el(a|0,b|0,c|0)|0}function Urb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return fl(a|0,b|0,c|0)|0}function Vrb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return gl(a|0,b|0,c|0,d|0)|0}function Wrb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Xrb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return on(a|0)|0}function Yrb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Zrb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return vn(a|0)|0}function _rb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function $rb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return yn(a|0)|0}function asb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function bsb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function csb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function dsb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Cn(a|0,b|0)|0}function esb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function fsb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function gsb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function hsb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function isb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function jsb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function ksb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return _n(a|0,b|0)|0}function lsb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function msb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function nsb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function osb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function psb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function qsb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function rsb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function ssb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function tsb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function usb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function vsb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function wsb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function xsb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function ysb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function zsb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Asb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Bsb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Csb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Dsb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Esb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Fsb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Gsb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Hsb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Isb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Jsb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Ksb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Lsb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Msb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Nsb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Osb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Psb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return uu(a|0,b|0,c|0)|0}function Qsb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return ds(a|0,b|0)|0}function Rsb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return es(a|0,b|0)|0}function Ssb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return js(a|0,b|0)|0}function Tsb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return vu(a|0,b|0,c|0)|0}function Usb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return wu(a|0,b|0)|0}function Vsb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return $r(a|0,b|0)|0}function Wsb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return as(a|0,b|0)|0}function Xsb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return bs(a|0,b|0)|0}function Ysb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return hs(a|0,b|0)|0}function Zsb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return fs(a|0,b|0)|0}function _sb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return is(a|0,b|0)|0}function $sb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return cs(a|0,b|0)|0}function atb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return xu(a|0,b|0)|0}function btb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return gs(a|0,b|0)|0}function ctb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return _r(a|0,b|0)|0}function dtb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return dr(a|0,b|0)|0}function etb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function ftb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function gtb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function htb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function itb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function jtb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function ktb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function ltb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function mtb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function ntb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function otb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function ptb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Kx(a|0,b|0,c|0)|0}function qtb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return $x(a|0,b|0)|0}function rtb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return dy(a|0,b|0)|0}function stb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return fy(a|0,b|0)|0}function ttb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return jy(a|0,b|0)|0}function utb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function vtb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function wtb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function xtb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function ytb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function ztb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Atb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Btb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return RB(a|0)|0}function Ctb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return SB(a|0)|0}function Dtb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return TB(a|0)|0}function Etb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return UB(a|0,b|0,c|0)|0}function Ftb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return VB(a|0,b|0)|0}function Gtb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Htb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Itb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Jtb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Ktb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Ltb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Mtb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Ntb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Otb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Ptb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Qtb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Rtb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Stb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Ttb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return hC(a|0,b|0)|0}function Utb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Vtb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Wtb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Xtb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Ytb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Ztb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function _tb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function $tb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return rC(a|0,b|0,c|0)|0}function aub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function bub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function cub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function dub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function eub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function fub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function gub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function hub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function iub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function jub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function kub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function lub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function mub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function nub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return GM(a|0,b|0,c|0)|0}function oub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function pub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function qub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return nN(a|0,b|0)|0}function rub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return pN(a|0,b|0,c|0,d|0,e|0,0,0)|0}function sub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return qN(a|0,b|0,c|0,d|0,e|0,0)|0}function tub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function uub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return tN(a|0,b|0)|0}function vub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return vN(a|0,b|0,c|0,d|0,e|0,0,0)|0}function wub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function xub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function yub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function zub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Aub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Bub(a,b,c,d,e){
a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Cub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Dub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Eub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return 0}function Fub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return WR(a|0,b|0,c|0,d|0)|0}function Gub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return QS(a|0,b|0)|0}function Hub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return hT(a|0,b|0,c|0)|0}function Iub(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;da(15)}function Jub(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;vc(a|0)|0}function Kub(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;wc(a|0)|0}function Lub(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;xc(a|0)|0}function Mub(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;yc(a|0,b|0,c|0)|0}function Nub(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;zc(a|0,b|0)|0}function Oub(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ac(a|0,b|0,c|0,d|0,0,0)}function Pub(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Cc(a|0,b|0,c|0,d|0,0,0,0)}function Qub(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ec(a|0,b|0,c|0,d|0,0)}function Rub(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Fc(a|0,b|0)}function Sub(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Gc(a|0)}function Tub(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Hc(a|0)}function Uub(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Wc(a|0,b|0,c|0)}function Vub(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Xc(a|0,b|0)}function Wub(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ic(a|0,b|0)}function Xub(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Jc(a|0,b|0,c|0)}function Yub(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Kc(a|0,b|0,c|0)}function Zub(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Lc(a|0,b|0,c|0)}function _ub(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Mc(a|0,b|0)}function $ub(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Nc(a|0,b|0,c|0)}function avb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Oc(a|0,b|0,c|0)}function bvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Pc(a|0,b|0,c|0)}function cvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Qc(a|0,b|0)|0}function dvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Rc(a|0,b|0,c|0)}function evb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Tc(a|0,b|0,c|0,d|0,0,0,0,0,0)}function fvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Xk(a|0,b|0,c|0)|0}function gvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;jT(a|0)}function hvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;iT(a|0)|0}function ivb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;kT(a|0,b|0)|0}function jvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;my(a|0)|0}function kvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Td(a|0,b|0,c|0)}function lvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;PP(a|0)|0}function mvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;QP(a|0)|0}function nvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;RP(a|0)|0}function ovb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;UP(a|0,b|0,c|0)|0}function pvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;VP(a|0,b|0)|0}function qvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;XP(a|0,b|0,c|0,d|0,0,0)}function rvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;YP(a|0,b|0,c|0,d|0,0,0,0)}function svb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;$P(a|0,b|0,c|0,d|0,0)}function tvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;aQ(a|0,b|0)}function uvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;bQ(a|0)}function vvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;cQ(a|0)}function wvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;dQ(a|0,b|0,c|0)}function xvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;eQ(a|0,b|0)}function yvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;hQ(a|0,b|0)}function zvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;iQ(a|0,b|0,c|0)}function Avb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;kQ(a|0,b|0,c|0)}function Bvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;lQ(a|0,b|0)}function Cvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;$d(a|0,b|0,c|0)}function Dvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;_d(a|0,b|0,c|0)}function Evb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;WP(a|0,b|0)|0}function Fvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;mQ(a|0,b|0,c|0)}function Gvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;LP(a|0)|0}function Hvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;MP(a|0)|0}function Ivb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;NP(a|0)|0}function Jvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;OP(a|0)|0}function Kvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;jQ(a|0,b|0,c|0)}function Lvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;NI(a|0)|0}function Mvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;OI(a|0)|0}function Nvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;PI(a|0)|0}function Ovb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;QI(a|0)|0}function Pvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;RI(a|0)|0}function Qvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;SI(a|0)|0}function Rvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;TI(a|0)|0}function Svb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;UI(a|0)|0}function Tvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;VI(a|0)|0}function Uvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;WI(a|0)|0}function Vvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;XI(a|0)|0}function Wvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;YI(a|0)|0}function Xvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ZI(a|0)|0}function Yvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;_I(a|0)|0}function Zvb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;$I(a|0)|0}function _vb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;aJ(a|0)|0}function $vb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;bJ(a|0)|0}function awb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;cJ(a|0)|0}function bwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;dJ(a|0)|0}function cwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;eJ(a|0)|0}function dwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;fJ(a|0)|0}function ewb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;gJ(a|0)|0}function fwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;hJ(a|0)|0}function gwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;iJ(a|0)|0}function hwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;jJ(a|0)|0}function iwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;kJ(a|0)|0}function jwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;lJ(a|0)|0}function kwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;mJ(a|0)|0}function lwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;nJ(a|0)|0}function mwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;oJ(a|0)|0}function nwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;pJ(a|0)|0}function owb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;qJ(a|0)|0}function pwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;rJ(a|0)|0}function qwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;sJ(a|0)|0}function rwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;tJ(a|0)|0}function swb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;uJ(a|0)|0}function twb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;vJ(a|0)|0}function uwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;wJ(a|0)|0}function vwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;xJ(a|0)|0}function wwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;yJ(a|0)|0}function xwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;zJ(a|0)|0}function ywb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;AJ(a|0)|0}function zwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;BJ(a|0)|0}function Awb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;CJ(a|0)|0}function Bwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;DJ(a|0)|0}function Cwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;EJ(a|0)|0}function Dwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;FJ(a|0)|0}function Ewb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;GJ(a|0)|0}function Fwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;HJ(a|0)|0}function Gwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;IJ(a|0)|0}function Hwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;JJ(a|0)|0}function Iwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;KJ(a|0)|0}function Jwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;LJ(a|0)|0}function Kwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;MJ(a|0)|0}function Lwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;NJ(a|0)|0}function Mwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;OJ(a|0)|0}function Nwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;PJ(a|0)|0}function Owb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;QJ(a|0)|0}function Pwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;RJ(a|0)|0}function Qwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;SJ(a|0)|0}function Rwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;TJ(a|0)|0}function Swb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;UJ(a|0)|0}function Twb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;VJ(a|0)|0}function Uwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;WJ(a|0)|0}function Vwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;XJ(a|0)|0}function Wwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;YJ(a|0)|0}function Xwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ZJ(a|0)|0}function Ywb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;_J(a|0)|0}function Zwb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;$J(a|0)|0}function _wb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;aK(a|0)|0}function $wb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;bK(a|0)|0}function axb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;cK(a|0)|0}function bxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;dK(a|0)|0}function cxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;eK(a|0)|0}function dxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;fK(a|0)|0}function exb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;gK(a|0)|0}function fxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;hK(a|0)|0}function gxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;iK(a|0)|0}function hxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;jK(a|0)|0}function ixb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;kK(a|0)|0}function jxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;lK(a|0)|0}function kxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;mK(a|0)|0}function lxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;nK(a|0)|0}function mxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;oK(a|0)|0}function nxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;pK(a|0)|0}function oxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;qK(a|0)|0}function pxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;rK(a|0)|0}function qxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;sK(a|0)|0}function rxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;tK(a|0)|0}function sxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;uK(a|0)|0}function txb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;vK(a|0)|0}function uxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;wK(a|0)|0}function vxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;xK(a|0)|0}function wxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;yK(a|0)|0}function xxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;zK(a|0)|0}function yxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;AK(a|0)|0}function zxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;BK(a|0)|0}function Axb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;CK(a|0)|0}function Bxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;DK(a|0)|0}function Cxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;EK(a|0)|0}function Dxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;FK(a|0)|0}function Exb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;GK(a|0)|0}function Fxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;HK(a|0)|0}function Gxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;IK(a|0)|0}function Hxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;JK(a|0)|0}function Ixb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;KK(a|0)|0}function Jxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;LK(a|0)|0}function Kxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;MK(a|0)|0}function Lxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;NK(a|0)|0}function Mxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;OK(a|0)|0}function Nxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;PK(a|0)|0}function Oxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;QK(a|0)|0}function Pxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;RK(a|0)|0}function Qxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;SK(a|0)|0}function Rxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;TK(a|0)|0}function Sxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;UK(a|0)|0}function Txb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;VK(a|0)|0}function Uxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;WK(a|0)|0}function Vxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;XK(a|0)|0}function Wxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;YK(a|0)|0}function Xxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ZK(a|0)|0}function Yxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;_K(a|0)|0}function Zxb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;$K(a|0)|0}function _xb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;aL(a|0)|0}function $xb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;bL(a|0)|0}function ayb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;cL(a|0)|0}function byb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;dL(a|0)|0}function cyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;eL(a|0)|0}function dyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;RT(a|0,b|0,c|0)|0}function eyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Vb(a|0)}function fyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Wb(a|0)|0}function gyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Xb(a|0,b|0)|0}function hyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Yb(a|0)|0}function iyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Wk(a|0,b|0,c|0)|0}function jyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;_b(a|0)}function kyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;$b(a|0)}function lyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ac(a|0,b|0,c|0)|0}function myb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ka(a|0,b|0,c|0)|0}function nyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;gc(a|0,b|0,c|0)|0}function oyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;hc(a|0)}function pyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ic(a|0,b|0,c|0)}function qyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;jc(a|0,b|0,c|0)}function ryb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;kc(a|0,b|0,c|0)}function syb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;lc(a|0,b|0,c|0)}function tyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;nc(a|0)|0}function uyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;md(a|0,b|0)}function vyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;nd(a|0)|0}function wyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Kd(a|0,b|0,c|0,d|0)|0}function xyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ld(a|0,b|0,c|0,d|0)|0}function yyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Md(a|0,b|0,c|0,d|0)|0}function zyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Nd(a|0,b|0,c|0,d|0)|0}function Ayb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Od(a|0,b|0,c|0,d|0)|0}function Byb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Pd(a|0,b|0,c|0,d|0)|0}function Cyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;qd(a|0,b|0,c|0,d|0)|0}function Dyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;rd(a|0,b|0,c|0,d|0)|0}function Eyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Qd(a|0,b|0,c|0,d|0)|0}function Fyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Rd(a|0,b|0,c|0,d|0)|0}function Gyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;fo(a|0,b|0,c|0,d|0)|0}function Hyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ae(a|0,b|0,c|0)}function Iyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;be(a|0,b|0,c|0)}function Jyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;tg(a|0)}function Kyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;mk()|0}function Lyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;sh(a|0,b|0,c|0,d|0,0)}function Myb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;gk(a|0,b|0,c|0,d|0,0)}function Nyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;nk(a|0)|0}function Oyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ok(a|0)|0}function Pyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;pk(a|0,b|0,c|0)|0}function Qyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;qk(a|0)|0}function Ryb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;_k(a|0)|0}function Syb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;$k(a|0,b|0,c|0)|0}function Tyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;bl(a|0)|0}function Uyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;cl(a|0,b|0,c|0)|0}function Vyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;dl(a|0)|0}function Wyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;el(a|0,b|0,c|0)|0}function Xyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;fl(a|0,b|0,c|0)|0}function Yyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;gl(a|0,b|0,c|0,d|0)|0}function Zyb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;nn(a|0)}function _yb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;on(a|0)|0}function $yb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;sn(a|0)}function azb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;vn(a|0)|0}function bzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;xn(a|0)}function czb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;yn(a|0)|0}function dzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;zn(a|0,b|0)}function ezb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;An(a|0)}function fzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Bn(a|0)}function gzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Cn(a|0,b|0)|0}function hzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Dn(a|0)}function izb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;In(a|0,b|0,c|0)}function jzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Rn(a|0,b|0,c|0)}function kzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Sn(a|0,b|0,c|0)}function lzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Tn(a|0,b|0,c|0)}function mzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Un(a|0,b|0,c|0)}function nzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;_n(a|0,b|0)|0}function ozb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;tq(a|0,b|0)}function pzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Qq(a|0)}function qzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Bs(a|0,b|0)}function rzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Is(a|0,b|0)}function szb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ns(a|0,b|0)}function tzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ts(a|0,b|0)}function uzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;us(a|0,b|0)}function vzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;os(a|0,b|0)}function wzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Es(a|0,b|0)}function xzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Hs(a|0,b|0)}function yzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ls(a|0,b|0)}function zzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Fs(a|0,b|0)}function Azb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ps(a|0,b|0)}function Bzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Cs(a|0,b|0)}function Czb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;nt(a|0,b|0)}function Dzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;qs(a|0,b|0)}function Ezb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;zs(a|0,b|0)}function Fzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Tr(a|0,b|0)}function Gzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ms(a|0,b|0)}function Hzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Js(a|0,b|0)}function Izb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;rs(a|0,b|0)}function Jzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ss(a|0,b|0)}function Kzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;vs(a|0,b|0)}function Lzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ws(a|0,b|0)}function Mzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;xs(a|0,b|0)}function Nzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ys(a|0,b|0)}function Ozb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Gs(a|0,b|0)}function Pzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ds(a|0,b|0)}function Qzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;As(a|0,b|0)}function Rzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ot(a|0,b|0)}function Szb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;uu(a|0,b|0,c|0)|0}function Tzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ds(a|0,b|0)|0}function Uzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;es(a|0,b|0)|0}function Vzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;js(a|0,b|0)|0}function Wzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;vu(a|0,b|0,c|0)|0}function Xzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;wu(a|0,b|0)|0}function Yzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;$r(a|0,b|0)|0}function Zzb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;as(a|0,b|0)|0}function _zb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;bs(a|0,b|0)|0}function $zb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;hs(a|0,b|0)|0}function aAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;fs(a|0,b|0)|0}function bAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;is(a|0,b|0)|0}function cAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;cs(a|0,b|0)|0}function dAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;xu(a|0,b|0)|0}function eAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;gs(a|0,b|0)|0}function fAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;_r(a|0,b|0)|0}function gAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;dr(a|0,b|0)|0}function hAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;jv(a|0,b|0)}function iAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;pv(a|0,b|0)}function jAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;qv(a|0,b|0)}function kAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;rv(a|0,b|0)}function lAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;sv(a|0,b|0)}function mAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;tv(a|0,b|0)}function nAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;uv(a|0,b|0)}function oAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;vv(a|0,b|0)}function pAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;tw(a|0,b|0,c|0)}function qAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Mw(a|0)}function rAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Yw(a|0)}function sAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Kx(a|0,b|0,c|0)|0}function tAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;$x(a|0,b|0)|0}function uAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;dy(a|0,b|0)|0}function vAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;fy(a|0,b|0)|0}function wAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;jy(a|0,b|0)|0}function xAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;qB(a|0)}function yAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;LB(a|0,b|0,c|0,d|0,0,0,0,0,0)}function zAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;NB(a|0,b|0,c|0)}function AAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;OB(a|0,b|0,c|0)}function BAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;PB(a|0,b|0)}function CAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;RB(a|0)|0}function DAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;SB(a|0)|0}function EAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;TB(a|0)|0}function FAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;UB(a|0,b|0,c|0)|0}function GAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;VB(a|0,b|0)|0}function HAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;WB(a|0,b|0,c|0,d|0,0,0)}function IAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;YB(a|0,b|0,c|0,d|0,0,0,0)}function JAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;_B(a|0,b|0,c|0,d|0,0)}function KAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;$B(a|0,b|0)}function LAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;aC(a|0)}function MAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;bC(a|0)}function NAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;cC(a|0,b|0,c|0)}function OAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;dC(a|0,b|0)}function PAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;eC(a|0,b|0,c|0)}function QAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;fC(a|0,b|0,c|0)}function RAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;gC(a|0,b|0,c|0)}function SAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;hC(a|0,b|0)|0}function TAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;jC(a|0,b|0,c|0)}function UAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;kC(a|0,b|0,c|0)}function VAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;lC(a|0,b|0,c|0)}function WAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;mC(a|0,b|0)}function XAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;nC(a|0,b|0,c|0,d|0,0,0,0,0,0)}function YAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;rC(a|0,b|0,c|0)|0}function ZAb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;uC(a|0)}function _Ab(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;AD(a|0,b|0)}function $Ab(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;uF(a|0,b|0)}function aBb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;VA(a|0)}function bBb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;wM(a|0,b|0,c|0)}function cBb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;xM(a|0,b|0)}function dBb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;yM(a|0,b|0,c|0,d|0,0,0,0,0,0)}function eBb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;AM(a|0,b|0,c|0)}function fBb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;BM(a|0,b|0,c|0)}function gBb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;DM(a|0,b|0,c|0)}function hBb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;EM(a|0,b|0,c|0)}function iBb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;GM(a|0,b|0,c|0)|0}function jBb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;FM(a|0,b|0)}function kBb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;UM(a|0)}function lBb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;nN(a|0,b|0)|0}function mBb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;oN(a|0,b|0,c|0,d|0,0)|0}function nBb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;pN(a|0,b|0,c|0,d|0,0,0,0)|0}function oBb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;qN(a|0,b|0,c|0,d|0,0,0)|0}function pBb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;rN(a|0,b|0)}function qBb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;tN(a|0,b|0)|0}function rBb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;uN(a|0,b|0,c|0,d|0,0)|0}function sBb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;vN(a|0,b|0,c|0,d|0,0,0,0)|0}function tBb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;wN(a|0,b|0)}function uBb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;CN(a|0,b|0,c|0)}function vBb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;vO(a|0,b|0,c|0)}function wBb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;wO(a|0,b|0,c|0)}function xBb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;sP(a|0,b|0,c|0)}function yBb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;fQ(a|0,b|0,c|0,d|0,0,0,0,0,0)}function zBb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;WR(a|0,b|0,c|0,d|0)|0}function ABb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;QS(a|0,b|0)|0}function BBb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;hT(a|0,b|0,c|0)|0}var ub=[GU,HU,IU,JU,KU,LU,MU,NU,OU,PU,QU,RU,SU,TU,UU,VU,WU,XU,YU,ZU,_U,$U,aV,bV,cV,dV,eV,fV,gV,hV,iV,jV,kV,lV,mV,nV,oV,pV,qV,rV,sV,tV,uV,vV,wV,xV,yV,zV,AV,BV,CV,DV,EV,FV,GV,HV,IV,JV,KV,LV,MV,NV,OV,PV,QV,RV,SV,TV,UV,VV,WV,XV,YV,ZV,_V,$V,aW,bW,cW,dW,eW,fW,gW,hW,iW,jW,kW,lW,mW,nW,oW,pW,qW,rW,sW,tW,uW,vW,wW,xW,yW,zW,AW,BW,CW,DW,EW,FW,GW,HW,IW,JW,KW,LW,MW,NW,OW,PW,QW,RW,SW,TW,UW,VW,WW,XW,YW,ZW,_W,$W,aX,bX,cX,dX,eX,fX,gX,hX,iX,jX,kX,lX,mX,nX,oX,pX,qX,rX,sX,tX,uX,vX,wX,xX,yX,zX,AX,BX,CX,DX,EX,FX,GX,HX,IX,JX,KX,LX,MX,NX,OX,PX,QX,RX,SX,TX,UX,VX,WX,XX,YX,ZX,_X,$X,aY,bY,cY,dY,eY,fY,gY,hY,iY,jY,kY,lY,mY,nY,oY,pY,qY,rY,sY,tY,uY,vY,wY,xY,yY,zY,AY,BY,CY,DY,EY,FY,GY,HY,IY,JY,KY,LY,MY,NY,OY,PY,QY,RY,SY,TY,UY,VY,WY,XY,YY,ZY,_Y,$Y,aZ,bZ,cZ,dZ,eZ,fZ,gZ,hZ,iZ,jZ,kZ,lZ,mZ,nZ,oZ,pZ,qZ,rZ,sZ,tZ,uZ,vZ,wZ,xZ,yZ,zZ,AZ,BZ,CZ,DZ,EZ,FZ,GZ,HZ,IZ,JZ,KZ,LZ,MZ,NZ,OZ,PZ,QZ,RZ,SZ,TZ,UZ,VZ,WZ,XZ,YZ,ZZ,_Z,$Z,a_,b_,c_,d_,e_,f_,g_,h_,i_,j_,k_,l_,m_,n_,o_,p_,q_,r_,s_,t_,u_,v_,w_,x_,y_,z_,A_,B_,C_,D_,E_,F_,G_,H_,I_,J_,K_,L_,M_,N_,O_,P_,Q_,R_,S_,T_,U_,V_,W_,X_,Y_,Z_,__,$_,a$,b$,c$,d$,e$,f$,g$,h$,i$,j$,k$,l$,m$,n$,o$,p$,q$,r$,s$,t$,u$,v$,w$,x$,y$,z$,A$,B$,pN,C$,D$,E$,F$,vN,G$,H$,I$,J$,K$,L$,M$,N$,O$,P$,Q$,R$,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU,GU];var vb=[S$,T$,U$,V$,W$,yc,X$,Y$,Z$,_$,$$,a0,b0,c0,d0,e0,f0,g0,h0,i0,j0,k0,l0,m0,n0,o0,p0,q0,r0,s0,Xk,t0,u0,v0,w0,x0,y0,z0,A0,B0,UP,C0,D0,E0,F0,G0,H0,I0,J0,K0,L0,M0,N0,O0,P0,Q0,R0,S0,T0,U0,V0,W0,X0,Y0,Z0,_0,$0,a1,b1,c1,d1,e1,f1,g1,h1,i1,j1,k1,l1,m1,n1,o1,p1,q1,r1,s1,t1,u1,v1,w1,x1,y1,z1,A1,B1,C1,D1,E1,F1,G1,H1,I1,J1,K1,L1,M1,N1,O1,P1,Q1,R1,S1,T1,U1,V1,W1,X1,Y1,Z1,_1,$1,a2,b2,c2,d2,e2,f2,g2,h2,i2,j2,k2,l2,m2,n2,o2,p2,q2,r2,s2,t2,u2,v2,w2,x2,y2,z2,A2,B2,C2,D2,E2,F2,G2,H2,I2,J2,K2,L2,M2,N2,O2,P2,Q2,R2,S2,T2,U2,V2,W2,X2,Y2,Z2,_2,$2,a3,b3,c3,d3,e3,f3,g3,h3,i3,j3,k3,l3,m3,n3,o3,p3,q3,r3,s3,RT,t3,u3,v3,w3,Wk,x3,y3,ac,z3,gc,A3,B3,C3,D3,E3,F3,G3,H3,I3,J3,K3,L3,M3,N3,O3,P3,Q3,R3,S3,T3,U3,V3,W3,X3,Y3,Z3,_3,pk,$3,a4,$k,b4,cl,c4,el,fl,d4,e4,f4,g4,h4,i4,j4,k4,l4,m4,n4,o4,p4,q4,r4,s4,t4,u4,v4,w4,x4,y4,z4,A4,B4,C4,D4,E4,F4,G4,H4,I4,J4,K4,L4,M4,N4,O4,P4,Q4,R4,S4,T4,U4,V4,W4,X4,Y4,uu,Z4,_4,$4,vu,a5,b5,c5,d5,e5,f5,g5,h5,i5,j5,k5,l5,m5,n5,o5,p5,q5,r5,s5,t5,u5,v5,w5,Kx,x5,y5,z5,A5,B5,C5,D5,E5,F5,G5,H5,I5,J5,K5,UB,L5,M5,N5,O5,P5,Q5,R5,S5,T5,U5,V5,W5,X5,Y5,Z5,_5,$5,a6,b6,c6,d6,e6,rC,f6,g6,h6,i6,j6,k6,l6,m6,n6,o6,p6,q6,r6,GM,s6,t6,u6,v6,w6,x6,y6,z6,A6,B6,C6,D6,E6,F6,G6,H6,I6,J6,K6,L6,M6,hT,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$,S$];var wb=[N6,O6,P6,Q6,R6,S6,T6,U6,V6,Cc,W6,X6,Y6,Z6,_6,$6,a7,b7,c7,d7,e7,f7,g7,h7,i7,j7,k7,l7,m7,n7,o7,p7,q7,r7,s7,t7,u7,v7,w7,x7,y7,z7,A7,B7,YP,C7,D7,E7,F7,G7,H7,I7,J7,K7,L7,M7,N7,O7,P7,Q7,R7,S7,T7,U7,V7,W7,X7,Y7,Z7,_7,$7,a8,b8,c8,d8,e8,f8,g8,h8,i8,j8,k8,l8,m8,n8,o8,p8,q8,r8,s8,t8,u8,v8,w8,x8,y8,z8,A8,B8,C8,D8,E8,F8,G8,H8,I8,J8,K8,L8,M8,N8,O8,P8,Q8,R8,S8,T8,U8,V8,W8,X8,Y8,Z8,_8,$8,a9,b9,c9,d9,e9,f9,g9,h9,i9,j9,k9,l9,m9,n9,o9,p9,q9,r9,s9,t9,u9,v9,w9,x9,y9,z9,A9,B9,C9,D9,E9,F9,G9,H9,I9,J9,K9,L9,M9,N9,O9,P9,Q9,R9,S9,T9,U9,V9,W9,X9,Y9,Z9,_9,$9,aaa,baa,caa,daa,eaa,faa,gaa,haa,iaa,jaa,kaa,laa,maa,naa,oaa,paa,qaa,raa,saa,taa,uaa,vaa,waa,xaa,yaa,zaa,Aaa,Baa,Caa,Daa,Eaa,Faa,Gaa,Haa,Iaa,Jaa,Kaa,Laa,Maa,Naa,Oaa,Paa,Qaa,Raa,Saa,Taa,Uaa,Vaa,Waa,Xaa,Yaa,Zaa,_aa,$aa,aba,bba,cba,dba,eba,fba,gba,hba,iba,jba,kba,lba,mba,nba,oba,pba,qba,rba,sba,tba,uba,vba,wba,xba,yba,zba,Aba,Bba,Cba,Dba,Eba,Fba,Gba,Hba,Iba,Jba,Kba,Lba,Mba,Nba,Oba,Pba,Qba,Rba,Sba,Tba,Uba,Vba,Wba,Xba,Yba,Zba,_ba,$ba,aca,bca,cca,dca,eca,fca,gca,hca,ica,jca,kca,lca,mca,nca,oca,pca,qca,rca,sca,tca,uca,vca,wca,xca,yca,zca,Aca,Bca,Cca,Dca,Eca,Fca,Gca,Hca,Ica,Jca,Kca,Lca,Mca,Nca,Oca,Pca,Qca,Rca,Sca,Tca,Uca,Vca,Wca,YB,Xca,Yca,Zca,_ca,$ca,ada,bda,cda,dda,eda,fda,gda,hda,ida,jda,kda,lda,mda,nda,oda,pda,qda,rda,sda,tda,uda,vda,wda,xda,yda,zda,Ada,Bda,Cda,Dda,Eda,Fda,Gda,Hda,Ida,Jda,Kda,Lda,Mda,Nda,Oda,Pda,Qda,Rda,Sda,Tda,Uda,Vda,Wda,Xda,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6,N6];var xb=[Yda,Zda,_da,$da,aea,bea,cea,dea,eea,fea,gea,Ec,hea,iea,jea,kea,lea,mea,nea,oea,pea,qea,rea,sea,tea,uea,vea,wea,xea,yea,zea,Aea,Bea,Cea,Dea,Eea,Fea,Gea,Hea,Iea,Jea,Kea,Lea,Mea,Nea,Oea,$P,Pea,Qea,Rea,Sea,Tea,Uea,Vea,Wea,Xea,Yea,Zea,_ea,$ea,afa,bfa,cfa,dfa,efa,ffa,gfa,hfa,ifa,jfa,kfa,lfa,mfa,nfa,ofa,pfa,qfa,rfa,sfa,tfa,ufa,vfa,wfa,xfa,yfa,zfa,Afa,Bfa,Cfa,Dfa,Efa,Ffa,Gfa,Hfa,Ifa,Jfa,Kfa,Lfa,Mfa,Nfa,Ofa,Pfa,Qfa,Rfa,Sfa,Tfa,Ufa,Vfa,Wfa,Xfa,Yfa,Zfa,_fa,$fa,aga,bga,cga,dga,ega,fga,gga,hga,iga,jga,kga,lga,mga,nga,oga,pga,qga,rga,sga,tga,uga,vga,wga,xga,yga,zga,Aga,Bga,Cga,Dga,Ega,Fga,Gga,Hga,Iga,Jga,Kga,Lga,Mga,Nga,Oga,Pga,Qga,Rga,Sga,Tga,Uga,Vga,Wga,Xga,Yga,Zga,_ga,$ga,aha,bha,cha,dha,eha,fha,gha,hha,iha,jha,kha,lha,mha,nha,oha,pha,qha,rha,sha,tha,uha,vha,wha,xha,yha,zha,Aha,Bha,Cha,Dha,Eha,Fha,Gha,Hha,Iha,Jha,Kha,Lha,Mha,Nha,Oha,Pha,Qha,Rha,Sha,Tha,Uha,Vha,Wha,Xha,Yha,Zha,_ha,$ha,aia,bia,cia,dia,eia,fia,sh,gk,gia,hia,iia,jia,kia,lia,mia,nia,oia,pia,qia,ria,sia,tia,uia,via,wia,xia,yia,zia,Aia,Bia,Cia,Dia,Eia,Fia,Gia,Hia,Iia,Jia,Kia,Lia,Mia,Nia,Oia,Pia,Qia,Ria,Sia,Tia,Uia,Via,Wia,Xia,Yia,Zia,_ia,$ia,aja,bja,cja,dja,eja,fja,gja,hja,ija,jja,kja,lja,mja,nja,oja,pja,qja,rja,sja,tja,uja,vja,wja,xja,yja,zja,Aja,Bja,Cja,Dja,Eja,Fja,Gja,Hja,Ija,Jja,Kja,Lja,Mja,Nja,Oja,Pja,Qja,Rja,Sja,Tja,Uja,Vja,Wja,Xja,Yja,Zja,_ja,$ja,aka,bka,cka,dka,eka,fka,_B,gka,hka,ika,jka,kka,lka,mka,nka,oka,pka,qka,rka,ska,tka,uka,vka,wka,xka,yka,zka,Aka,Bka,Cka,Dka,Eka,Fka,Gka,Hka,Ika,Jka,Kka,Lka,Mka,Nka,Oka,Pka,Qka,Rka,Ska,Tka,Uka,Vka,Wka,Xka,Yka,Zka,_ka,$ka,ala,bla,cla,dla,ela,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda,Yda];var yb=[fla,gla,hla,ila,jla,kla,lla,mla,nla,ola,pla,qla,rla,sla,tla,ula,vla,wla,xla,yla,zla,Ala,Bla,Cla,Dla,Ela,Fla,Gla,Hla,Ila,Jla,Kla,Lla,Mla,Nla,Ola,Pla,Qla,Rla,Sla,Tla,Ula,Vla,Wla,Xla,Yla,Zla,_la,$la,ama,bma,cma,dma,ema,fma,gma,hma,ima,jma,kma,lma,mma,nma,oma,pma,qma,rma,sma,tma,uma,vma,wma,xma,yma,zma,Ama,Bma,Cma,Dma,Ema,Fma,Gma,Hma,Ima,Jma,Kma,Lma,Mma,Nma,Oma,Pma,Qma,Rma,Sma,Tma,Uma,Vma,Wma,Xma,Yma,Zma,_ma,$ma,ana,bna,cna,dna,ena,fna,gna,hna,ina,jna,kna,lna,mna,nna,ona,pna,qna,rna,sna,tna,una,vna,wna,xna,yna,zna,Ana,Bna,Cna,Dna,Ena,Fna,Gna,Hna,Ina,Jna,Kna,Lna,Mna,Nna,Ona,Pna,Qna,Rna,Sna,Tna,Una,Vna,Wna,Xna,Yna,Zna,_na,$na,aoa,boa,coa,doa,eoa,foa,goa,hoa,ioa,joa,koa,loa,moa,noa,ooa,poa,qoa,roa,soa,toa,uoa,voa,woa,xoa,yoa,zoa,Aoa,Boa,Coa,Doa,Eoa,Foa,Goa,Hoa,Ioa,Joa,Koa,Loa,Moa,Noa,Ooa,Poa,Qoa,Roa,Soa,Toa,Uoa,Voa,Woa,Xoa,Yoa,Zoa,_oa,$oa,apa,bpa,cpa,dpa,epa,fpa,gpa,hpa,ipa,jpa,kpa,lpa,mpa,npa,opa,ppa,mk,qpa,rpa,spa,tpa,upa,vpa,wpa,xpa,ypa,zpa,Apa,Bpa,Cpa,Dpa,Epa,Fpa,Gpa,Hpa,Ipa,Jpa,Kpa,Lpa,Mpa,Npa,Opa,Ppa,Qpa,Rpa,Spa,Tpa,Upa,Vpa,Wpa,Xpa,Ypa,Zpa,_pa,$pa,aqa,bqa,cqa,dqa,eqa,fqa,gqa,hqa,iqa,jqa,kqa,lqa,mqa,nqa,oqa,pqa,qqa,rqa,sqa,tqa,uqa,vqa,wqa,xqa,yqa,zqa,Aqa,Bqa,Cqa,Dqa,Eqa,Fqa,Gqa,Hqa,Iqa,Jqa,Kqa,Lqa,Mqa,Nqa,Oqa,Pqa,Qqa,Rqa,Sqa,Tqa,Uqa,Vqa,Wqa,Xqa,Yqa,Zqa,_qa,$qa,ara,bra,cra,dra,era,fra,gra,hra,ira,jra,kra,lra,mra,nra,ora,pra,qra,rra,sra,tra,ura,vra,wra,xra,yra,zra,Ara,Bra,Cra,Dra,Era,Fra,Gra,Hra,Ira,Jra,Kra,Lra,Mra,Nra,Ora,Pra,Qra,Rra,Sra,Tra,Ura,Vra,Wra,Xra,Yra,Zra,_ra,$ra,asa,bsa,csa,dsa,esa,fsa,gsa,hsa,isa,jsa,ksa,lsa,msa,nsa,osa,psa,qsa,rsa,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla,fla];var zb=[ssa,tsa,usa,vsa,wsa,xsa,ysa,zsa,Asa,Bsa,Csa,Dsa,Esa,Gc,Hc,Fsa,Gsa,Hsa,Isa,Jsa,Ksa,Lsa,Msa,Nsa,Osa,Psa,Qsa,Rsa,Ssa,Tsa,Usa,jT,Vsa,Wsa,Xsa,Ysa,Zsa,_sa,$sa,ata,bta,cta,dta,eta,fta,gta,hta,ita,bQ,cQ,jta,kta,lta,mta,nta,ota,pta,qta,rta,sta,tta,uta,vta,wta,xta,yta,zta,Ata,Bta,Cta,Dta,Eta,Fta,Gta,Hta,Ita,Jta,Kta,Lta,Mta,Nta,Ota,Pta,Qta,Rta,Sta,Tta,Uta,Vta,Wta,Xta,Yta,Zta,_ta,$ta,aua,bua,cua,dua,eua,fua,gua,hua,iua,jua,kua,lua,mua,nua,oua,pua,qua,rua,sua,tua,uua,vua,wua,xua,yua,zua,Aua,Bua,Cua,Dua,Eua,Fua,Gua,Hua,Iua,Jua,Kua,Lua,Mua,Nua,Oua,Pua,Qua,Rua,Sua,Tua,Uua,Vua,Wua,Xua,Yua,Zua,_ua,$ua,ava,bva,cva,dva,eva,fva,gva,hva,iva,jva,kva,lva,mva,nva,ova,pva,qva,rva,sva,tva,uva,vva,wva,xva,yva,zva,Ava,Bva,Cva,Dva,Eva,Fva,Gva,Hva,Iva,Jva,Kva,Lva,Mva,Nva,Ova,Pva,Qva,Rva,Sva,Tva,Vb,Uva,Vva,Wva,Xva,_b,$b,Yva,Zva,_va,hc,$va,awa,bwa,cwa,dwa,ewa,fwa,gwa,hwa,iwa,jwa,kwa,lwa,mwa,nwa,owa,pwa,qwa,rwa,swa,tg,twa,uwa,vwa,wwa,xwa,ywa,zwa,Awa,Bwa,Cwa,Dwa,Ewa,Fwa,Gwa,Hwa,nn,Iwa,sn,Jwa,xn,Kwa,Lwa,An,Bn,Mwa,Dn,Nwa,Owa,Pwa,Qwa,Rwa,Swa,Twa,Qq,Uwa,Vwa,Wwa,Xwa,Ywa,Zwa,_wa,$wa,axa,bxa,cxa,dxa,exa,fxa,gxa,hxa,ixa,jxa,kxa,lxa,mxa,nxa,oxa,pxa,qxa,rxa,sxa,txa,uxa,vxa,wxa,xxa,yxa,zxa,Axa,Bxa,Cxa,Dxa,Exa,Fxa,Gxa,Hxa,Ixa,Jxa,Kxa,Lxa,Mxa,Nxa,Oxa,Pxa,Qxa,Rxa,Sxa,Txa,Mw,Yw,Uxa,Vxa,Wxa,Xxa,Yxa,qB,Zxa,_xa,$xa,aya,bya,cya,dya,eya,fya,gya,hya,iya,jya,kya,lya,mya,nya,aC,bC,oya,pya,qya,rya,sya,tya,uya,vya,wya,xya,yya,zya,Aya,Bya,uC,Cya,Dya,Eya,VA,Fya,Gya,Hya,Iya,Jya,Kya,Lya,Mya,Nya,Oya,UM,Pya,Qya,Rya,Sya,Tya,Uya,Vya,Wya,Xya,Yya,Zya,_ya,$ya,aza,bza,cza,dza,eza,fza,gza,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa,ssa];
var Ab=[hza,iza,jza,kza,lza,mza,nza,oza,pza,qza,rza,sza,Fc,tza,uza,vza,Xc,Ic,wza,xza,yza,Mc,zza,Aza,Bza,Cza,Dza,Eza,Fza,Gza,Hza,Iza,Jza,Kza,Lza,Mza,Nza,Oza,Pza,Qza,Rza,Sza,Tza,Uza,Vza,Wza,Xza,aQ,Yza,Zza,_za,eQ,hQ,$za,aAa,lQ,bAa,cAa,dAa,eAa,fAa,gAa,hAa,iAa,jAa,kAa,lAa,mAa,nAa,oAa,pAa,qAa,rAa,sAa,tAa,uAa,vAa,wAa,xAa,yAa,zAa,AAa,BAa,CAa,DAa,EAa,FAa,GAa,HAa,IAa,JAa,KAa,LAa,MAa,NAa,OAa,PAa,QAa,RAa,SAa,TAa,UAa,VAa,WAa,XAa,YAa,ZAa,_Aa,$Aa,aBa,bBa,cBa,dBa,eBa,fBa,gBa,hBa,iBa,jBa,kBa,lBa,mBa,nBa,oBa,pBa,qBa,rBa,sBa,tBa,uBa,vBa,wBa,xBa,yBa,zBa,ABa,BBa,CBa,DBa,EBa,FBa,GBa,HBa,IBa,JBa,KBa,LBa,MBa,NBa,OBa,PBa,QBa,RBa,SBa,TBa,UBa,VBa,WBa,XBa,YBa,ZBa,_Ba,$Ba,aCa,bCa,cCa,dCa,eCa,fCa,gCa,hCa,iCa,jCa,kCa,lCa,mCa,nCa,oCa,pCa,qCa,rCa,sCa,tCa,uCa,vCa,wCa,xCa,yCa,zCa,ACa,BCa,CCa,DCa,ECa,FCa,GCa,HCa,ICa,JCa,KCa,LCa,MCa,NCa,OCa,PCa,QCa,RCa,SCa,TCa,UCa,VCa,md,WCa,XCa,YCa,ZCa,_Ca,$Ca,aDa,bDa,cDa,dDa,eDa,fDa,gDa,hDa,iDa,jDa,kDa,lDa,mDa,nDa,oDa,pDa,qDa,rDa,sDa,tDa,uDa,vDa,wDa,xDa,yDa,zDa,ADa,BDa,CDa,DDa,zn,EDa,FDa,GDa,HDa,IDa,JDa,KDa,LDa,MDa,NDa,tq,ODa,Bs,Is,ns,ts,us,os,Es,Hs,ls,Fs,ps,Cs,nt,qs,zs,Tr,ms,Js,rs,ss,vs,ws,xs,ys,Gs,Ds,As,ot,PDa,QDa,RDa,SDa,TDa,UDa,VDa,WDa,XDa,YDa,ZDa,_Da,$Da,aEa,bEa,cEa,dEa,jv,pv,qv,rv,sv,tv,uv,vv,eEa,fEa,gEa,hEa,iEa,jEa,kEa,lEa,mEa,nEa,oEa,pEa,qEa,PB,rEa,sEa,tEa,uEa,vEa,wEa,xEa,yEa,zEa,AEa,BEa,$B,CEa,DEa,EEa,dC,FEa,GEa,HEa,IEa,JEa,KEa,LEa,MEa,mC,NEa,OEa,PEa,QEa,AD,REa,uF,SEa,TEa,xM,UEa,VEa,WEa,XEa,YEa,ZEa,_Ea,FM,$Ea,aFa,bFa,cFa,dFa,rN,eFa,fFa,gFa,wN,hFa,iFa,jFa,kFa,lFa,mFa,nFa,oFa,pFa,qFa,rFa,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza,hza];var Bb=[sFa,tFa,uFa,vFa,wFa,xFa,yFa,zFa,AFa,BFa,CFa,DFa,EFa,FFa,GFa,HFa,IFa,JFa,KFa,LFa,MFa,NFa,OFa,PFa,QFa,RFa,SFa,TFa,UFa,VFa,WFa,XFa,YFa,ZFa,_Fa,$Fa,aGa,bGa,cGa,dGa,eGa,fGa,gGa,hGa,iGa,jGa,kGa,lGa,mGa,nGa,oGa,pGa,qGa,rGa,sGa,tGa,uGa,vGa,wGa,xGa,yGa,zGa,AGa,BGa,CGa,DGa,EGa,FGa,GGa,HGa,IGa,JGa,KGa,LGa,MGa,NGa,OGa,PGa,QGa,RGa,SGa,TGa,UGa,VGa,WGa,XGa,YGa,ZGa,_Ga,$Ga,aHa,bHa,cHa,dHa,eHa,fHa,gHa,hHa,iHa,jHa,kHa,lHa,mHa,nHa,oHa,pHa,qHa,rHa,sHa,tHa,uHa,vHa,wHa,xHa,yHa,zHa,AHa,BHa,CHa,DHa,EHa,FHa,GHa,HHa,IHa,JHa,KHa,LHa,MHa,NHa,OHa,PHa,QHa,RHa,SHa,THa,UHa,VHa,WHa,XHa,YHa,ZHa,_Ha,$Ha,aIa,bIa,cIa,dIa,eIa,fIa,gIa,hIa,iIa,jIa,kIa,lIa,mIa,nIa,oIa,pIa,qIa,rIa,sIa,tIa,uIa,vIa,wIa,xIa,yIa,zIa,AIa,BIa,CIa,DIa,EIa,FIa,GIa,HIa,IIa,JIa,KIa,LIa,MIa,NIa,OIa,PIa,QIa,RIa,SIa,TIa,UIa,VIa,WIa,XIa,YIa,ZIa,_Ia,$Ia,aJa,bJa,cJa,dJa,eJa,fJa,gJa,hJa,iJa,jJa,kJa,lJa,mJa,nJa,oJa,pJa,qJa,rJa,sJa,tJa,uJa,vJa,wJa,xJa,yJa,zJa,AJa,BJa,CJa,DJa,EJa,FJa,GJa,HJa,IJa,JJa,KJa,LJa,MJa,NJa,OJa,PJa,QJa,RJa,SJa,TJa,UJa,VJa,WJa,XJa,YJa,ZJa,_Ja,$Ja,aKa,bKa,cKa,dKa,eKa,fKa,gKa,hKa,iKa,jKa,kKa,lKa,mKa,nKa,oKa,pKa,qKa,rKa,sKa,tKa,uKa,vKa,wKa,xKa,yKa,zKa,AKa,BKa,CKa,DKa,EKa,FKa,GKa,HKa,IKa,JKa,KKa,LKa,MKa,NKa,OKa,PKa,QKa,RKa,SKa,TKa,UKa,VKa,WKa,XKa,YKa,ZKa,_Ka,$Ka,aLa,bLa,cLa,dLa,eLa,fLa,gLa,hLa,iLa,jLa,kLa,lLa,mLa,nLa,oLa,pLa,qLa,rLa,sLa,tLa,uLa,vLa,wLa,xLa,yLa,zLa,ALa,BLa,CLa,DLa,ELa,FLa,GLa,HLa,ILa,JLa,KLa,LLa,MLa,NLa,OLa,PLa,QLa,RLa,SLa,TLa,ULa,VLa,WLa,XLa,YLa,ZLa,_La,$La,aMa,bMa,cMa,dMa,eMa,fMa,gMa,hMa,iMa,jMa,kMa,lMa,mMa,nMa,oMa,qN,pMa,qMa,rMa,sMa,tMa,uMa,vMa,wMa,xMa,yMa,zMa,AMa,BMa,CMa,DMa,EMa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa,sFa];var Cb=[FMa,GMa,vc,wc,xc,HMa,IMa,JMa,KMa,LMa,MMa,NMa,OMa,PMa,QMa,RMa,SMa,TMa,UMa,VMa,WMa,XMa,YMa,ZMa,_Ma,$Ma,aNa,bNa,cNa,dNa,eNa,fNa,iT,gNa,my,hNa,iNa,PP,QP,RP,jNa,kNa,lNa,mNa,nNa,oNa,pNa,qNa,rNa,sNa,tNa,uNa,vNa,wNa,xNa,yNa,zNa,ANa,BNa,CNa,DNa,LP,MP,NP,OP,ENa,NI,OI,PI,QI,RI,SI,TI,UI,VI,WI,XI,YI,ZI,_I,$I,aJ,bJ,cJ,dJ,eJ,fJ,gJ,hJ,iJ,jJ,kJ,lJ,mJ,nJ,oJ,pJ,qJ,rJ,sJ,tJ,uJ,vJ,wJ,xJ,yJ,zJ,AJ,BJ,CJ,DJ,EJ,FJ,GJ,HJ,IJ,JJ,KJ,LJ,MJ,NJ,OJ,PJ,QJ,RJ,SJ,TJ,UJ,VJ,WJ,XJ,YJ,ZJ,_J,$J,aK,bK,cK,dK,eK,fK,gK,hK,iK,jK,kK,lK,mK,nK,oK,pK,qK,rK,sK,tK,uK,vK,wK,xK,yK,zK,AK,BK,CK,DK,EK,FK,GK,HK,IK,JK,KK,LK,MK,NK,OK,PK,QK,RK,SK,TK,UK,VK,WK,XK,YK,ZK,_K,$K,aL,bL,cL,dL,eL,FNa,GNa,Wb,HNa,Yb,INa,JNa,KNa,LNa,MNa,NNa,ONa,PNa,QNa,RNa,SNa,nc,TNa,nd,UNa,VNa,WNa,XNa,YNa,ZNa,_Na,$Na,aOa,bOa,cOa,dOa,eOa,fOa,gOa,hOa,iOa,nk,ok,jOa,qk,_k,kOa,bl,lOa,dl,mOa,nOa,oOa,pOa,on,qOa,vn,rOa,yn,sOa,tOa,uOa,vOa,wOa,xOa,yOa,zOa,AOa,BOa,COa,DOa,EOa,FOa,GOa,HOa,IOa,JOa,KOa,LOa,MOa,NOa,OOa,POa,QOa,ROa,SOa,TOa,UOa,VOa,WOa,XOa,YOa,ZOa,_Oa,$Oa,aPa,bPa,cPa,dPa,ePa,fPa,gPa,hPa,iPa,jPa,kPa,lPa,mPa,nPa,oPa,pPa,qPa,rPa,sPa,tPa,uPa,vPa,wPa,xPa,yPa,zPa,APa,BPa,CPa,DPa,EPa,FPa,GPa,HPa,IPa,JPa,KPa,LPa,MPa,NPa,OPa,PPa,QPa,RPa,SPa,RB,SB,TB,TPa,UPa,VPa,WPa,XPa,YPa,ZPa,_Pa,$Pa,aQa,bQa,cQa,dQa,eQa,fQa,gQa,hQa,iQa,jQa,kQa,lQa,mQa,nQa,oQa,pQa,qQa,rQa,sQa,tQa,uQa,vQa,wQa,xQa,yQa,zQa,AQa,BQa,CQa,DQa,EQa,FQa,GQa,HQa,IQa,JQa,KQa,LQa,MQa,NQa,OQa,PQa,QQa,RQa,SQa,TQa,UQa,VQa,WQa,XQa,YQa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa,FMa];var Db=[ZQa,_Qa,$Qa,aRa,bRa,cRa,dRa,eRa,fRa,gRa,hRa,iRa,jRa,kRa,lRa,Wc,mRa,nRa,Jc,Kc,Lc,oRa,Nc,Oc,Pc,pRa,Rc,qRa,rRa,sRa,tRa,uRa,vRa,wRa,xRa,Td,yRa,zRa,ARa,BRa,CRa,DRa,ERa,FRa,GRa,HRa,IRa,JRa,KRa,LRa,dQ,MRa,NRa,iQ,kQ,ORa,$d,_d,PRa,mQ,QRa,RRa,SRa,TRa,URa,jQ,VRa,WRa,XRa,YRa,ZRa,_Ra,$Ra,aSa,bSa,cSa,dSa,eSa,fSa,gSa,hSa,iSa,jSa,kSa,lSa,mSa,nSa,oSa,pSa,qSa,rSa,sSa,tSa,uSa,vSa,wSa,xSa,ySa,zSa,ASa,BSa,CSa,DSa,ESa,FSa,GSa,HSa,ISa,JSa,KSa,LSa,MSa,NSa,OSa,PSa,QSa,RSa,SSa,TSa,USa,VSa,WSa,XSa,YSa,ZSa,_Sa,$Sa,aTa,bTa,cTa,dTa,eTa,fTa,gTa,hTa,iTa,jTa,kTa,lTa,mTa,nTa,oTa,pTa,qTa,rTa,sTa,tTa,uTa,vTa,wTa,xTa,yTa,zTa,ATa,BTa,CTa,DTa,ETa,FTa,GTa,HTa,ITa,JTa,KTa,LTa,MTa,NTa,OTa,PTa,QTa,RTa,STa,TTa,UTa,VTa,WTa,XTa,YTa,ZTa,_Ta,$Ta,aUa,bUa,cUa,dUa,eUa,fUa,gUa,hUa,iUa,jUa,kUa,lUa,mUa,nUa,oUa,pUa,qUa,rUa,sUa,tUa,uUa,vUa,wUa,xUa,yUa,ic,jc,kc,lc,zUa,AUa,BUa,CUa,DUa,EUa,FUa,GUa,HUa,IUa,JUa,KUa,LUa,MUa,ae,be,NUa,OUa,PUa,QUa,RUa,SUa,TUa,UUa,VUa,WUa,XUa,YUa,ZUa,_Ua,$Ua,aVa,bVa,cVa,dVa,eVa,fVa,gVa,hVa,iVa,jVa,kVa,lVa,In,Rn,Sn,Tn,Un,mVa,nVa,oVa,pVa,qVa,rVa,sVa,tVa,uVa,vVa,wVa,xVa,yVa,zVa,AVa,BVa,CVa,DVa,EVa,FVa,GVa,HVa,IVa,JVa,KVa,LVa,MVa,NVa,OVa,PVa,QVa,RVa,SVa,TVa,UVa,VVa,WVa,XVa,YVa,ZVa,_Va,$Va,aWa,bWa,cWa,dWa,eWa,fWa,gWa,hWa,iWa,jWa,kWa,lWa,mWa,nWa,tw,oWa,pWa,qWa,rWa,sWa,tWa,uWa,vWa,wWa,xWa,NB,OB,yWa,zWa,AWa,BWa,CWa,DWa,EWa,FWa,GWa,HWa,IWa,JWa,KWa,LWa,MWa,cC,NWa,eC,fC,gC,OWa,PWa,jC,kC,lC,QWa,RWa,SWa,TWa,UWa,VWa,WWa,XWa,YWa,wM,ZWa,_Wa,$Wa,AM,BM,DM,EM,aXa,bXa,cXa,dXa,eXa,fXa,gXa,hXa,iXa,jXa,kXa,lXa,CN,mXa,vO,wO,nXa,sP,oXa,pXa,qXa,rXa,sXa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa,ZQa];var Eb=[tXa,uXa,vXa,wXa,xXa,yXa,zXa,AXa,BXa,CXa,DXa,EXa,FXa,GXa,HXa,IXa,JXa,KXa,LXa,MXa,NXa,OXa,PXa,QXa,RXa,SXa,TXa,UXa,Tc,VXa,WXa,XXa,YXa,ZXa,_Xa,$Xa,aYa,bYa,cYa,dYa,eYa,fYa,gYa,hYa,iYa,jYa,kYa,lYa,mYa,nYa,oYa,pYa,qYa,rYa,sYa,tYa,uYa,vYa,wYa,xYa,yYa,zYa,AYa,BYa,CYa,DYa,EYa,FYa,GYa,HYa,IYa,JYa,KYa,LYa,MYa,NYa,OYa,PYa,QYa,RYa,SYa,TYa,UYa,VYa,WYa,XYa,YYa,ZYa,_Ya,$Ya,aZa,bZa,cZa,dZa,eZa,fZa,gZa,hZa,iZa,jZa,kZa,lZa,mZa,nZa,oZa,pZa,qZa,rZa,sZa,tZa,uZa,vZa,wZa,xZa,yZa,zZa,AZa,BZa,CZa,DZa,EZa,FZa,GZa,HZa,IZa,JZa,KZa,LZa,MZa,NZa,OZa,PZa,QZa,RZa,SZa,TZa,UZa,VZa,WZa,XZa,YZa,ZZa,_Za,$Za,a_a,b_a,c_a,d_a,e_a,f_a,g_a,h_a,i_a,j_a,k_a,l_a,m_a,n_a,o_a,p_a,q_a,r_a,s_a,t_a,u_a,v_a,w_a,x_a,y_a,z_a,A_a,B_a,C_a,D_a,E_a,F_a,G_a,H_a,I_a,J_a,K_a,L_a,M_a,N_a,O_a,P_a,Q_a,R_a,S_a,T_a,U_a,V_a,W_a,X_a,Y_a,Z_a,__a,$_a,a$a,b$a,c$a,d$a,e$a,f$a,g$a,h$a,i$a,j$a,k$a,l$a,m$a,n$a,o$a,p$a,q$a,r$a,s$a,t$a,u$a,v$a,w$a,x$a,y$a,z$a,A$a,B$a,C$a,D$a,E$a,F$a,G$a,H$a,I$a,J$a,K$a,L$a,M$a,N$a,O$a,P$a,Q$a,R$a,S$a,T$a,U$a,V$a,W$a,X$a,Y$a,Z$a,_$a,$$a,a0a,b0a,c0a,d0a,e0a,f0a,g0a,h0a,i0a,j0a,k0a,l0a,m0a,n0a,o0a,p0a,q0a,r0a,s0a,t0a,u0a,v0a,w0a,x0a,y0a,z0a,A0a,B0a,C0a,D0a,E0a,F0a,G0a,H0a,I0a,J0a,K0a,L0a,M0a,N0a,O0a,P0a,Q0a,R0a,S0a,T0a,U0a,V0a,W0a,X0a,Y0a,Z0a,_0a,$0a,a1a,b1a,c1a,d1a,e1a,f1a,g1a,h1a,i1a,j1a,k1a,l1a,m1a,n1a,o1a,p1a,q1a,LB,r1a,s1a,t1a,u1a,v1a,w1a,x1a,y1a,z1a,A1a,B1a,C1a,D1a,E1a,F1a,G1a,H1a,I1a,J1a,K1a,L1a,M1a,N1a,O1a,P1a,Q1a,R1a,S1a,T1a,nC,U1a,V1a,W1a,X1a,Y1a,Z1a,_1a,$1a,a2a,yM,b2a,c2a,d2a,e2a,f2a,g2a,h2a,i2a,j2a,k2a,l2a,m2a,n2a,o2a,p2a,q2a,r2a,s2a,t2a,u2a,v2a,w2a,x2a,fQ,y2a,z2a,A2a,B2a,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa,tXa];var Fb=[C2a,D2a,E2a,F2a,G2a,H2a,I2a,J2a,K2a,L2a,M2a,N2a,O2a,P2a,Q2a,R2a,S2a,T2a,U2a,V2a,W2a,X2a,Y2a,Z2a,_2a,$2a,a3a,b3a,c3a,d3a,e3a,f3a,g3a,h3a,i3a,j3a,k3a,l3a,m3a,n3a,o3a,p3a,q3a,r3a,s3a,t3a,u3a,v3a,w3a,x3a,y3a,z3a,A3a,B3a,C3a,D3a,E3a,F3a,G3a,H3a,I3a,J3a,K3a,L3a,M3a,N3a,O3a,P3a,Q3a,R3a,S3a,T3a,U3a,V3a,W3a,X3a,Y3a,Z3a,_3a,$3a,a4a,b4a,c4a,d4a,e4a,f4a,g4a,h4a,i4a,j4a,k4a,l4a,m4a,n4a,o4a,p4a,q4a,r4a,s4a,t4a,u4a,v4a,w4a,x4a,y4a,z4a,A4a,B4a,C4a,D4a,E4a,F4a,G4a,H4a,I4a,J4a,K4a,L4a,M4a,N4a,O4a,P4a,Q4a,R4a,S4a,T4a,U4a,V4a,W4a,X4a,Y4a,Z4a,_4a,$4a,a5a,b5a,c5a,d5a,e5a,f5a,g5a,h5a,i5a,j5a,k5a,l5a,m5a,n5a,o5a,p5a,q5a,r5a,s5a,t5a,u5a,v5a,w5a,x5a,y5a,z5a,A5a,B5a,C5a,D5a,E5a,F5a,G5a,H5a,I5a,J5a,K5a,L5a,M5a,N5a,O5a,P5a,Q5a,R5a,S5a,T5a,U5a,V5a,W5a,X5a,Y5a,Z5a,_5a,$5a,a6a,b6a,c6a,d6a,e6a,f6a,g6a,h6a,i6a,j6a,k6a,l6a,m6a,n6a,o6a,p6a,q6a,r6a,s6a,t6a,u6a,v6a,w6a,x6a,y6a,Kd,Ld,Md,Nd,Od,Pd,qd,rd,Qd,Rd,fo,z6a,A6a,B6a,C6a,D6a,E6a,F6a,G6a,H6a,I6a,J6a,K6a,L6a,M6a,N6a,O6a,P6a,gl,Q6a,R6a,S6a,T6a,U6a,V6a,W6a,X6a,Y6a,Z6a,_6a,$6a,a7a,b7a,c7a,d7a,e7a,f7a,g7a,h7a,i7a,j7a,k7a,l7a,m7a,n7a,o7a,p7a,q7a,r7a,s7a,t7a,u7a,v7a,w7a,x7a,y7a,z7a,A7a,B7a,C7a,D7a,E7a,F7a,G7a,H7a,I7a,J7a,K7a,L7a,M7a,N7a,O7a,P7a,Q7a,R7a,S7a,T7a,U7a,V7a,W7a,X7a,Y7a,Z7a,_7a,$7a,a8a,b8a,c8a,d8a,e8a,f8a,g8a,h8a,i8a,j8a,k8a,l8a,m8a,n8a,o8a,p8a,q8a,r8a,s8a,t8a,u8a,v8a,w8a,x8a,y8a,z8a,A8a,B8a,C8a,D8a,E8a,F8a,G8a,H8a,I8a,J8a,K8a,L8a,M8a,N8a,O8a,P8a,Q8a,R8a,S8a,T8a,U8a,V8a,W8a,X8a,Y8a,Z8a,_8a,$8a,a9a,b9a,c9a,d9a,e9a,f9a,g9a,h9a,i9a,j9a,k9a,l9a,m9a,n9a,o9a,p9a,q9a,r9a,s9a,t9a,u9a,v9a,w9a,x9a,y9a,z9a,A9a,WR,B9a,C9a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a,C2a];var Gb=[D9a,E9a,F9a,G9a,H9a,I9a,J9a,Ac,K9a,L9a,M9a,N9a,O9a,P9a,Q9a,R9a,S9a,T9a,U9a,V9a,W9a,X9a,Y9a,Z9a,_9a,$9a,aab,bab,cab,dab,eab,fab,gab,hab,iab,jab,kab,lab,mab,nab,oab,pab,XP,qab,rab,sab,tab,uab,vab,wab,xab,yab,zab,Aab,Bab,Cab,Dab,Eab,Fab,Gab,Hab,Iab,Jab,Kab,Lab,Mab,Nab,Oab,Pab,Qab,Rab,Sab,Tab,Uab,Vab,Wab,Xab,Yab,Zab,_ab,$ab,abb,bbb,cbb,dbb,ebb,fbb,gbb,hbb,ibb,jbb,kbb,lbb,mbb,nbb,obb,pbb,qbb,rbb,sbb,tbb,ubb,vbb,wbb,xbb,ybb,zbb,Abb,Bbb,Cbb,Dbb,Ebb,Fbb,Gbb,Hbb,Ibb,Jbb,Kbb,Lbb,Mbb,Nbb,Obb,Pbb,Qbb,Rbb,Sbb,Tbb,Ubb,Vbb,Wbb,Xbb,Ybb,Zbb,_bb,$bb,acb,bcb,ccb,dcb,ecb,fcb,gcb,hcb,icb,jcb,kcb,lcb,mcb,ncb,ocb,pcb,qcb,rcb,scb,tcb,ucb,vcb,wcb,xcb,ycb,zcb,Acb,Bcb,Ccb,Dcb,Ecb,Fcb,Gcb,Hcb,Icb,Jcb,Kcb,Lcb,Mcb,Ncb,Ocb,Pcb,Qcb,Rcb,Scb,Tcb,Ucb,Vcb,Wcb,Xcb,Ycb,Zcb,_cb,$cb,adb,bdb,cdb,ddb,edb,fdb,gdb,hdb,idb,jdb,kdb,ldb,mdb,ndb,odb,pdb,qdb,rdb,sdb,tdb,udb,vdb,wdb,xdb,ydb,zdb,Adb,Bdb,Cdb,Ddb,Edb,Fdb,Gdb,Hdb,Idb,Jdb,Kdb,Ldb,Mdb,Ndb,Odb,Pdb,Qdb,Rdb,Sdb,Tdb,Udb,Vdb,Wdb,Xdb,Ydb,Zdb,_db,$db,aeb,beb,ceb,deb,eeb,feb,geb,heb,ieb,jeb,keb,leb,meb,neb,oeb,peb,qeb,reb,seb,teb,ueb,veb,web,xeb,yeb,zeb,Aeb,Beb,Ceb,Deb,Eeb,Feb,Geb,Heb,Ieb,Jeb,Keb,Leb,Meb,Neb,Oeb,Peb,Qeb,Reb,Seb,Teb,Ueb,Veb,Web,Xeb,Yeb,Zeb,_eb,$eb,afb,bfb,cfb,dfb,efb,ffb,gfb,hfb,ifb,jfb,kfb,lfb,mfb,nfb,ofb,pfb,qfb,rfb,sfb,tfb,ufb,vfb,wfb,xfb,yfb,zfb,Afb,Bfb,Cfb,Dfb,Efb,Ffb,Gfb,Hfb,Ifb,Jfb,Kfb,WB,Lfb,Mfb,Nfb,Ofb,Pfb,Qfb,Rfb,Sfb,Tfb,Ufb,Vfb,Wfb,Xfb,Yfb,Zfb,_fb,$fb,agb,bgb,cgb,dgb,egb,fgb,ggb,hgb,igb,jgb,kgb,lgb,mgb,ngb,ogb,pgb,qgb,rgb,sgb,tgb,ugb,vgb,wgb,xgb,ygb,zgb,Agb,Bgb,Cgb,Dgb,Egb,Fgb,Ggb,Hgb,Igb,Jgb,Kgb,Lgb,Mgb,Ngb,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a,D9a];var Hb=[Ogb,Pgb,Qgb,Rgb,Sgb,Tgb,zc,Ugb,Vgb,Wgb,Xgb,Ygb,Zgb,_gb,$gb,ahb,bhb,chb,dhb,ehb,fhb,ghb,hhb,ihb,jhb,Qc,khb,lhb,mhb,nhb,ohb,phb,qhb,kT,rhb,shb,thb,uhb,vhb,whb,xhb,VP,yhb,zhb,Ahb,Bhb,Chb,Dhb,Ehb,Fhb,Ghb,Hhb,Ihb,Jhb,Khb,Lhb,Mhb,Nhb,WP,Ohb,Phb,Qhb,Rhb,Shb,Thb,Uhb,Vhb,Whb,Xhb,Yhb,Zhb,_hb,$hb,aib,bib,cib,dib,eib,fib,gib,hib,iib,jib,kib,lib,mib,nib,oib,pib,qib,rib,sib,tib,uib,vib,wib,xib,yib,zib,Aib,Bib,Cib,Dib,Eib,Fib,Gib,Hib,Iib,Jib,Kib,Lib,Mib,Nib,Oib,Pib,Qib,Rib,Sib,Tib,Uib,Vib,Wib,Xib,Yib,Zib,_ib,$ib,ajb,bjb,cjb,djb,ejb,fjb,gjb,hjb,ijb,jjb,kjb,ljb,mjb,njb,ojb,pjb,qjb,rjb,sjb,tjb,ujb,vjb,wjb,xjb,yjb,zjb,Ajb,Bjb,Cjb,Djb,Ejb,Fjb,Gjb,Hjb,Ijb,Jjb,Kjb,Ljb,Mjb,Njb,Ojb,Pjb,Qjb,Rjb,Sjb,Tjb,Ujb,Vjb,Wjb,Xjb,Yjb,Zjb,_jb,$jb,akb,bkb,ckb,dkb,ekb,fkb,gkb,hkb,ikb,jkb,kkb,lkb,mkb,nkb,okb,pkb,Xb,qkb,rkb,skb,tkb,ukb,vkb,wkb,xkb,ykb,zkb,Akb,Bkb,Ckb,Dkb,Ekb,Fkb,Gkb,Hkb,Ikb,Jkb,Kkb,Lkb,Mkb,Nkb,Okb,Pkb,Qkb,Rkb,Skb,Tkb,Ukb,Vkb,Wkb,Xkb,Ykb,Zkb,_kb,$kb,alb,blb,clb,dlb,elb,flb,glb,hlb,ilb,jlb,klb,llb,mlb,nlb,olb,Cn,plb,qlb,rlb,slb,tlb,ulb,_n,vlb,wlb,xlb,ylb,zlb,Alb,Blb,Clb,Dlb,Elb,Flb,Glb,Hlb,Ilb,Jlb,Klb,Llb,Mlb,Nlb,Olb,Plb,Qlb,Rlb,Slb,Tlb,Ulb,Vlb,Wlb,Xlb,Ylb,Zlb,ds,es,js,_lb,wu,$r,as,bs,hs,fs,is,cs,xu,gs,_r,dr,$lb,amb,bmb,cmb,dmb,emb,fmb,gmb,hmb,imb,jmb,kmb,$x,dy,fy,jy,lmb,mmb,nmb,omb,pmb,qmb,rmb,smb,tmb,umb,vmb,VB,wmb,xmb,ymb,zmb,Amb,Bmb,Cmb,Dmb,Emb,Fmb,Gmb,Hmb,Imb,hC,Jmb,Kmb,Lmb,Mmb,Nmb,Omb,Pmb,Qmb,Rmb,Smb,Tmb,Umb,Vmb,Wmb,Xmb,Ymb,Zmb,_mb,$mb,anb,bnb,cnb,dnb,enb,nN,fnb,gnb,hnb,inb,tN,jnb,knb,lnb,mnb,nnb,onb,pnb,qnb,rnb,snb,tnb,unb,QS,vnb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb,Ogb];var Ib=[wnb,xnb,ynb,znb,Anb,Bnb,Cnb,Dnb,Enb,Fnb,Gnb,Hnb,Inb,Jnb,Knb,Lnb,Mnb,Nnb,Onb,Pnb,Qnb,Rnb,Snb,Tnb,Unb,Vnb,Wnb,Xnb,Ynb,Znb,_nb,$nb,aob,bob,cob,dob,eob,fob,gob,hob,iob,job,kob,lob,mob,nob,oob,pob,qob,rob,sob,tob,uob,vob,wob,xob,yob,zob,Aob,Bob,Cob,Dob,Eob,Fob,Gob,Hob,Iob,Job,Kob,Lob,Mob,Nob,Oob,Pob,Qob,Rob,Sob,Tob,Uob,Vob,Wob,Xob,Yob,Zob,_ob,$ob,apb,bpb,cpb,dpb,epb,fpb,gpb,hpb,ipb,jpb,kpb,lpb,mpb,npb,opb,ppb,qpb,rpb,spb,tpb,upb,vpb,wpb,xpb,ypb,zpb,Apb,Bpb,Cpb,Dpb,Epb,Fpb,Gpb,Hpb,Ipb,Jpb,Kpb,Lpb,Mpb,Npb,Opb,Ppb,Qpb,Rpb,Spb,Tpb,Upb,Vpb,Wpb,Xpb,Ypb,Zpb,_pb,$pb,aqb,bqb,cqb,dqb,eqb,fqb,gqb,hqb,iqb,jqb,kqb,lqb,mqb,nqb,oqb,pqb,qqb,rqb,sqb,tqb,uqb,vqb,wqb,xqb,yqb,zqb,Aqb,Bqb,Cqb,Dqb,Eqb,Fqb,Gqb,Hqb,Iqb,Jqb,Kqb,Lqb,Mqb,Nqb,Oqb,Pqb,Qqb,Rqb,Sqb,Tqb,Uqb,Vqb,Wqb,Xqb,Yqb,Zqb,_qb,$qb,arb,brb,crb,drb,erb,frb,grb,hrb,irb,jrb,krb,lrb,mrb,nrb,orb,prb,qrb,rrb,srb,trb,urb,vrb,wrb,xrb,yrb,zrb,Arb,Brb,Crb,Drb,Erb,Frb,Grb,Hrb,Irb,Jrb,Krb,Lrb,Mrb,Nrb,Orb,Prb,Qrb,Rrb,Srb,Trb,Urb,Vrb,Wrb,Xrb,Yrb,Zrb,_rb,$rb,asb,bsb,csb,dsb,esb,fsb,gsb,hsb,isb,jsb,ksb,lsb,msb,nsb,osb,psb,qsb,rsb,ssb,tsb,usb,vsb,wsb,xsb,ysb,zsb,Asb,Bsb,Csb,Dsb,Esb,Fsb,Gsb,Hsb,Isb,Jsb,Ksb,Lsb,Msb,Nsb,Osb,Psb,Qsb,Rsb,Ssb,Tsb,Usb,Vsb,Wsb,Xsb,Ysb,Zsb,_sb,$sb,atb,btb,ctb,dtb,etb,ftb,gtb,htb,itb,jtb,ktb,ltb,mtb,ntb,otb,ptb,qtb,rtb,stb,ttb,utb,vtb,wtb,xtb,ytb,ztb,Atb,Btb,Ctb,Dtb,Etb,Ftb,Gtb,Htb,Itb,Jtb,Ktb,Ltb,Mtb,Ntb,Otb,Ptb,Qtb,Rtb,Stb,Ttb,Utb,Vtb,Wtb,Xtb,Ytb,Ztb,_tb,$tb,aub,bub,cub,dub,eub,fub,gub,hub,iub,jub,kub,lub,mub,nub,oub,pub,qub,oN,rub,sub,tub,uub,uN,vub,wub,xub,yub,zub,Aub,Bub,Cub,Dub,Eub,Fub,Gub,Hub,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb,wnb];var Jb=[Iub,uc,Jub,Kub,Lub,Mub,Nub,Oub,Bc,Pub,Dc,Qub,Rub,Sub,Tub,Uub,Vub,Wub,Xub,Yub,Zub,_ub,$ub,avb,bvb,cvb,dvb,Sc,evb,Uc,fvb,gvb,hvb,ivb,jvb,kvb,SP,lvb,mvb,nvb,ovb,pvb,qvb,_P,rvb,ZP,svb,tvb,uvb,vvb,wvb,xvb,yvb,zvb,Avb,Bvb,Cvb,Dvb,Evb,Fvb,TP,Gvb,Hvb,Ivb,Jvb,Kvb,Lvb,Mvb,Nvb,Ovb,Pvb,Qvb,Rvb,Svb,Tvb,Uvb,Vvb,Wvb,Xvb,Yvb,Zvb,_vb,$vb,awb,bwb,cwb,dwb,ewb,fwb,gwb,hwb,iwb,jwb,kwb,lwb,mwb,nwb,owb,pwb,qwb,rwb,swb,twb,uwb,vwb,wwb,xwb,ywb,zwb,Awb,Bwb,Cwb,Dwb,Ewb,Fwb,Gwb,Hwb,Iwb,Jwb,Kwb,Lwb,Mwb,Nwb,Owb,Pwb,Qwb,Rwb,Swb,Twb,Uwb,Vwb,Wwb,Xwb,Ywb,Zwb,_wb,$wb,axb,bxb,cxb,dxb,exb,fxb,gxb,hxb,ixb,jxb,kxb,lxb,mxb,nxb,oxb,pxb,qxb,rxb,sxb,txb,uxb,vxb,wxb,xxb,yxb,zxb,Axb,Bxb,Cxb,Dxb,Exb,Fxb,Gxb,Hxb,Ixb,Jxb,Kxb,Lxb,Mxb,Nxb,Oxb,Pxb,Qxb,Rxb,Sxb,Txb,Uxb,Vxb,Wxb,Xxb,Yxb,Zxb,_xb,$xb,ayb,byb,cyb,dyb,eyb,fyb,gyb,hyb,iyb,jyb,kyb,lyb,myb,nyb,oyb,pyb,qyb,ryb,syb,tyb,uyb,vyb,wyb,xyb,yyb,zyb,Ayb,Byb,Cyb,Dyb,Eyb,Fyb,Gyb,Hyb,Iyb,Jyb,Kyb,Lyb,Myb,Nyb,Oyb,Pyb,Qyb,Ryb,Syb,Tyb,Uyb,Vyb,Wyb,Xyb,Yyb,Zyb,_yb,$yb,azb,bzb,czb,dzb,ezb,fzb,gzb,hzb,izb,jzb,kzb,lzb,mzb,nzb,ozb,pzb,qzb,rzb,szb,tzb,uzb,vzb,wzb,xzb,yzb,zzb,Azb,Bzb,Czb,Dzb,Ezb,Fzb,Gzb,Hzb,Izb,Jzb,Kzb,Lzb,Mzb,Nzb,Ozb,Pzb,Qzb,Rzb,Szb,Tzb,Uzb,Vzb,Wzb,Xzb,Yzb,Zzb,_zb,$zb,aAb,bAb,cAb,dAb,eAb,fAb,gAb,hAb,iAb,jAb,kAb,lAb,mAb,nAb,oAb,pAb,qAb,rAb,sAb,tAb,uAb,vAb,wAb,xAb,yAb,MB,zAb,AAb,BAb,QB,CAb,DAb,EAb,FAb,GAb,HAb,XB,IAb,ZB,JAb,KAb,LAb,MAb,NAb,OAb,PAb,QAb,RAb,SAb,iC,TAb,UAb,VAb,WAb,XAb,oC,YAb,ZAb,_Ab,lF,$Ab,aBb,bBb,cBb,dBb,zM,eBb,fBb,gBb,hBb,iBb,jBb,kBb,lBb,mBb,nBb,oBb,pBb,qBb,rBb,sBb,tBb,uBb,GN,vBb,wBb,fP,xBb,yBb,gQ,zBb,ABb,BBb,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub,Iub];return{_i64Subtract:XT,_strcat:_T,_free:jT,_main:Sb,_realloc:kT,_strncpy:aU,_memmove:fU,_bitshift64Ashr:YT,_strlen:ZT,_memset:cU,_malloc:iT,_i64Add:bU,_memcpy:eU,_llvm_ctlz_i32:hU,_bitshift64Lshr:dU,_strcpy:gU,_bitshift64Shl:$T,runPostSets:WT,stackAlloc:Kb,stackSave:Lb,stackRestore:Mb,setThrew:Nb,setTempRet0:Qb,getTempRet0:Rb,dynCall_iiiiiiii:qU,dynCall_iiii:rU,dynCall_viiiiiii:sU,dynCall_viiiii:tU,dynCall_i:uU,dynCall_vi:vU,dynCall_vii:wU,dynCall_iiiiiii:xU,dynCall_ii:yU,dynCall_viii:zU,dynCall_viiiiiiiii:AU,dynCall_iiiii:BU,dynCall_viiiiii:CU,dynCall_iii:DU,dynCall_iiiiii:EU,dynCall_viiii:FU}}(Module.asmGlobalArg,Module.asmLibraryArg,buffer),_i64Subtract=Module._i64Subtract=asm._i64Subtract,_strcat=Module._strcat=asm._strcat,_free=Module._free=asm._free,_main=Module._main=asm._main,_realloc=Module._realloc=asm._realloc,_strncpy=Module._strncpy=asm._strncpy,_memmove=Module._memmove=asm._memmove,_bitshift64Ashr=Module._bitshift64Ashr=asm._bitshift64Ashr,_strlen=Module._strlen=asm._strlen,_memset=Module._memset=asm._memset,_malloc=Module._malloc=asm._malloc,_i64Add=Module._i64Add=asm._i64Add,_memcpy=Module._memcpy=asm._memcpy,_llvm_ctlz_i32=Module._llvm_ctlz_i32=asm._llvm_ctlz_i32,_bitshift64Lshr=Module._bitshift64Lshr=asm._bitshift64Lshr,_strcpy=Module._strcpy=asm._strcpy,_bitshift64Shl=Module._bitshift64Shl=asm._bitshift64Shl,runPostSets=Module.runPostSets=asm.runPostSets,dynCall_iiiiiiii=Module.dynCall_iiiiiiii=asm.dynCall_iiiiiiii,dynCall_iiii=Module.dynCall_iiii=asm.dynCall_iiii,dynCall_viiiiiii=Module.dynCall_viiiiiii=asm.dynCall_viiiiiii,dynCall_viiiii=Module.dynCall_viiiii=asm.dynCall_viiiii,dynCall_i=Module.dynCall_i=asm.dynCall_i,dynCall_vi=Module.dynCall_vi=asm.dynCall_vi,dynCall_vii=Module.dynCall_vii=asm.dynCall_vii,dynCall_iiiiiii=Module.dynCall_iiiiiii=asm.dynCall_iiiiiii,dynCall_ii=Module.dynCall_ii=asm.dynCall_ii,dynCall_viii=Module.dynCall_viii=asm.dynCall_viii,dynCall_viiiiiiiii=Module.dynCall_viiiiiiiii=asm.dynCall_viiiiiiiii,dynCall_iiiii=Module.dynCall_iiiii=asm.dynCall_iiiii,dynCall_viiiiii=Module.dynCall_viiiiii=asm.dynCall_viiiiii,dynCall_iii=Module.dynCall_iii=asm.dynCall_iii,dynCall_iiiiii=Module.dynCall_iiiiii=asm.dynCall_iiiiii,dynCall_viiii=Module.dynCall_viiii=asm.dynCall_viiii;Runtime.stackAlloc=asm.stackAlloc,Runtime.stackSave=asm.stackSave,Runtime.stackRestore=asm.stackRestore,Runtime.setTempRet0=asm.setTempRet0,Runtime.getTempRet0=asm.getTempRet0;var i64Math=function(){function BigInteger(a,b,c){null!=a&&("number"==typeof a?this.fromNumber(a,b,c):null==b&&"string"!=typeof a?this.fromString(a,256):this.fromString(a,b))}function nbi(){return new BigInteger(null)}function am1(i,x,w,j,c,n){for(;--n>=0;){var v=x*this[i++]+w[j]+c;c=Math.floor(v/67108864),w[j++]=67108863&v}return c}function am2(i,x,w,j,c,n){for(var xl=32767&x,xh=x>>15;--n>=0;){var l=32767&this[i],h=this[i++]>>15,m=xh*l+h*xl;l=xl*l+((32767&m)<<15)+w[j]+(1073741823&c),c=(l>>>30)+(m>>>15)+xh*h+(c>>>30),w[j++]=1073741823&l}return c}function am3(i,x,w,j,c,n){for(var xl=16383&x,xh=x>>14;--n>=0;){var l=16383&this[i],h=this[i++]>>14,m=xh*l+h*xl;l=xl*l+((16383&m)<<14)+w[j]+c,c=(l>>28)+(m>>14)+xh*h,w[j++]=268435455&l}return c}function int2char(n){return BI_RM.charAt(n)}function intAt(s,i){var c=BI_RC[s.charCodeAt(i)];return null==c?-1:c}function bnpCopyTo(r){for(var i=this.t-1;i>=0;--i)r[i]=this[i];r.t=this.t,r.s=this.s}function bnpFromInt(x){this.t=1,this.s=x<0?-1:0,x>0?this[0]=x:x<-1?this[0]=x+DV:this.t=0}function nbv(i){var r=nbi();return r.fromInt(i),r}function bnpFromString(s,b){var k;if(16==b)k=4;else if(8==b)k=3;else if(256==b)k=8;else if(2==b)k=1;else if(32==b)k=5;else{if(4!=b)return void this.fromRadix(s,b);k=2}this.t=0,this.s=0;for(var i=s.length,mi=!1,sh=0;--i>=0;){var x=8==k?255&s[i]:intAt(s,i);x<0?"-"==s.charAt(i)&&(mi=!0):(mi=!1,0==sh?this[this.t++]=x:sh+k>this.DB?(this[this.t-1]|=(x&(1<<this.DB-sh)-1)<<sh,this[this.t++]=x>>this.DB-sh):this[this.t-1]|=x<<sh,sh+=k,sh>=this.DB&&(sh-=this.DB))}8==k&&0!=(128&s[0])&&(this.s=-1,sh>0&&(this[this.t-1]|=(1<<this.DB-sh)-1<<sh)),this.clamp(),mi&&BigInteger.ZERO.subTo(this,this)}function bnpClamp(){for(var c=this.s&this.DM;this.t>0&&this[this.t-1]==c;)--this.t}function bnToString(b){if(this.s<0)return"-"+this.negate().toString(b);var k;if(16==b)k=4;else if(8==b)k=3;else if(2==b)k=1;else if(32==b)k=5;else{if(4!=b)return this.toRadix(b);k=2}var d,km=(1<<k)-1,m=!1,r="",i=this.t,p=this.DB-i*this.DB%k;if(i-- >0)for(p<this.DB&&(d=this[i]>>p)>0&&(m=!0,r=int2char(d));i>=0;)p<k?(d=(this[i]&(1<<p)-1)<<k-p,d|=this[--i]>>(p+=this.DB-k)):(d=this[i]>>(p-=k)&km,p<=0&&(p+=this.DB,--i)),d>0&&(m=!0),m&&(r+=int2char(d));return m?r:"0"}function bnNegate(){var r=nbi();return BigInteger.ZERO.subTo(this,r),r}function bnAbs(){return this.s<0?this.negate():this}function bnCompareTo(a){var r=this.s-a.s;if(0!=r)return r;var i=this.t;if(r=i-a.t,0!=r)return this.s<0?-r:r;for(;--i>=0;)if(0!=(r=this[i]-a[i]))return r;return 0}function nbits(x){var t,r=1;return 0!=(t=x>>>16)&&(x=t,r+=16),0!=(t=x>>8)&&(x=t,r+=8),0!=(t=x>>4)&&(x=t,r+=4),0!=(t=x>>2)&&(x=t,r+=2),0!=(t=x>>1)&&(x=t,r+=1),r}function bnBitLength(){return this.t<=0?0:this.DB*(this.t-1)+nbits(this[this.t-1]^this.s&this.DM)}function bnpDLShiftTo(n,r){var i;for(i=this.t-1;i>=0;--i)r[i+n]=this[i];for(i=n-1;i>=0;--i)r[i]=0;r.t=this.t+n,r.s=this.s}function bnpDRShiftTo(n,r){for(var i=n;i<this.t;++i)r[i-n]=this[i];r.t=Math.max(this.t-n,0),r.s=this.s}function bnpLShiftTo(n,r){var i,bs=n%this.DB,cbs=this.DB-bs,bm=(1<<cbs)-1,ds=Math.floor(n/this.DB),c=this.s<<bs&this.DM;for(i=this.t-1;i>=0;--i)r[i+ds+1]=this[i]>>cbs|c,c=(this[i]&bm)<<bs;for(i=ds-1;i>=0;--i)r[i]=0;r[ds]=c,r.t=this.t+ds+1,r.s=this.s,r.clamp()}function bnpRShiftTo(n,r){r.s=this.s;var ds=Math.floor(n/this.DB);if(ds>=this.t)return void(r.t=0);var bs=n%this.DB,cbs=this.DB-bs,bm=(1<<bs)-1;r[0]=this[ds]>>bs;for(var i=ds+1;i<this.t;++i)r[i-ds-1]|=(this[i]&bm)<<cbs,r[i-ds]=this[i]>>bs;bs>0&&(r[this.t-ds-1]|=(this.s&bm)<<cbs),r.t=this.t-ds,r.clamp()}function bnpSubTo(a,r){for(var i=0,c=0,m=Math.min(a.t,this.t);i<m;)c+=this[i]-a[i],r[i++]=c&this.DM,c>>=this.DB;if(a.t<this.t){for(c-=a.s;i<this.t;)c+=this[i],r[i++]=c&this.DM,c>>=this.DB;c+=this.s}else{for(c+=this.s;i<a.t;)c-=a[i],r[i++]=c&this.DM,c>>=this.DB;c-=a.s}r.s=c<0?-1:0,c<-1?r[i++]=this.DV+c:c>0&&(r[i++]=c),r.t=i,r.clamp()}function bnpMultiplyTo(a,r){var x=this.abs(),y=a.abs(),i=x.t;for(r.t=i+y.t;--i>=0;)r[i]=0;for(i=0;i<y.t;++i)r[i+x.t]=x.am(0,y[i],r,i,0,x.t);r.s=0,r.clamp(),this.s!=a.s&&BigInteger.ZERO.subTo(r,r)}function bnpSquareTo(r){for(var x=this.abs(),i=r.t=2*x.t;--i>=0;)r[i]=0;for(i=0;i<x.t-1;++i){var c=x.am(i,x[i],r,2*i,0,1);(r[i+x.t]+=x.am(i+1,2*x[i],r,2*i+1,c,x.t-i-1))>=x.DV&&(r[i+x.t]-=x.DV,r[i+x.t+1]=1)}r.t>0&&(r[r.t-1]+=x.am(i,x[i],r,2*i,0,1)),r.s=0,r.clamp()}function bnpDivRemTo(m,q,r){var pm=m.abs();if(!(pm.t<=0)){var pt=this.abs();if(pt.t<pm.t)return null!=q&&q.fromInt(0),void(null!=r&&this.copyTo(r));null==r&&(r=nbi());var y=nbi(),ts=this.s,ms=m.s,nsh=this.DB-nbits(pm[pm.t-1]);nsh>0?(pm.lShiftTo(nsh,y),pt.lShiftTo(nsh,r)):(pm.copyTo(y),pt.copyTo(r));var ys=y.t,y0=y[ys-1];if(0!=y0){var yt=y0*(1<<this.F1)+(ys>1?y[ys-2]>>this.F2:0),d1=this.FV/yt,d2=(1<<this.F1)/yt,e=1<<this.F2,i=r.t,j=i-ys,t=null==q?nbi():q;for(y.dlShiftTo(j,t),r.compareTo(t)>=0&&(r[r.t++]=1,r.subTo(t,r)),BigInteger.ONE.dlShiftTo(ys,t),t.subTo(y,y);y.t<ys;)y[y.t++]=0;for(;--j>=0;){var qd=r[--i]==y0?this.DM:Math.floor(r[i]*d1+(r[i-1]+e)*d2);if((r[i]+=y.am(0,qd,r,j,0,ys))<qd)for(y.dlShiftTo(j,t),r.subTo(t,r);r[i]<--qd;)r.subTo(t,r)}null!=q&&(r.drShiftTo(ys,q),ts!=ms&&BigInteger.ZERO.subTo(q,q)),r.t=ys,r.clamp(),nsh>0&&r.rShiftTo(nsh,r),ts<0&&BigInteger.ZERO.subTo(r,r)}}}function bnMod(a){var r=nbi();return this.abs().divRemTo(a,null,r),this.s<0&&r.compareTo(BigInteger.ZERO)>0&&a.subTo(r,r),r}function Classic(m){this.m=m}function cConvert(x){return x.s<0||x.compareTo(this.m)>=0?x.mod(this.m):x}function cRevert(x){return x}function cReduce(x){x.divRemTo(this.m,null,x)}function cMulTo(x,y,r){x.multiplyTo(y,r),this.reduce(r)}function cSqrTo(x,r){x.squareTo(r),this.reduce(r)}function bnpInvDigit(){if(this.t<1)return 0;var x=this[0];if(0==(1&x))return 0;var y=3&x;return y=y*(2-(15&x)*y)&15,y=y*(2-(255&x)*y)&255,y=y*(2-((65535&x)*y&65535))&65535,y=y*(2-x*y%this.DV)%this.DV,y>0?this.DV-y:-y}function Montgomery(m){this.m=m,this.mp=m.invDigit(),this.mpl=32767&this.mp,this.mph=this.mp>>15,this.um=(1<<m.DB-15)-1,this.mt2=2*m.t}function montConvert(x){var r=nbi();return x.abs().dlShiftTo(this.m.t,r),r.divRemTo(this.m,null,r),x.s<0&&r.compareTo(BigInteger.ZERO)>0&&this.m.subTo(r,r),r}function montRevert(x){var r=nbi();return x.copyTo(r),this.reduce(r),r}function montReduce(x){for(;x.t<=this.mt2;)x[x.t++]=0;for(var i=0;i<this.m.t;++i){var j=32767&x[i],u0=j*this.mpl+((j*this.mph+(x[i]>>15)*this.mpl&this.um)<<15)&x.DM;for(j=i+this.m.t,x[j]+=this.m.am(0,u0,x,i,0,this.m.t);x[j]>=x.DV;)x[j]-=x.DV,x[++j]++}x.clamp(),x.drShiftTo(this.m.t,x),x.compareTo(this.m)>=0&&x.subTo(this.m,x)}function montSqrTo(x,r){x.squareTo(r),this.reduce(r)}function montMulTo(x,y,r){x.multiplyTo(y,r),this.reduce(r)}function bnpIsEven(){return 0==(this.t>0?1&this[0]:this.s)}function bnpExp(e,z){if(e>4294967295||e<1)return BigInteger.ONE;var r=nbi(),r2=nbi(),g=z.convert(this),i=nbits(e)-1;for(g.copyTo(r);--i>=0;)if(z.sqrTo(r,r2),(e&1<<i)>0)z.mulTo(r2,g,r);else{var t=r;r=r2,r2=t}return z.revert(r)}function bnModPowInt(e,m){var z;return z=e<256||m.isEven()?new Classic(m):new Montgomery(m),this.exp(e,z)}function bnpFromRadix(s,b){this.fromInt(0),null==b&&(b=10);for(var cs=this.chunkSize(b),d=Math.pow(b,cs),mi=!1,j=0,w=0,i=0;i<s.length;++i){var x=intAt(s,i);x<0?"-"==s.charAt(i)&&0==this.signum()&&(mi=!0):(w=b*w+x,++j>=cs&&(this.dMultiply(d),this.dAddOffset(w,0),j=0,w=0))}j>0&&(this.dMultiply(Math.pow(b,j)),this.dAddOffset(w,0)),mi&&BigInteger.ZERO.subTo(this,this)}function bnpChunkSize(r){return Math.floor(Math.LN2*this.DB/Math.log(r))}function bnSigNum(){return this.s<0?-1:this.t<=0||1==this.t&&this[0]<=0?0:1}function bnpDMultiply(n){this[this.t]=this.am(0,n-1,this,0,0,this.t),++this.t,this.clamp()}function bnpDAddOffset(n,w){if(0!=n){for(;this.t<=w;)this[this.t++]=0;for(this[w]+=n;this[w]>=this.DV;)this[w]-=this.DV,++w>=this.t&&(this[this.t++]=0),++this[w]}}function bnpToRadix(b){if(null==b&&(b=10),0==this.signum()||b<2||b>36)return"0";var cs=this.chunkSize(b),a=Math.pow(b,cs),d=nbv(a),y=nbi(),z=nbi(),r="";for(this.divRemTo(d,y,z);y.signum()>0;)r=(a+z.intValue()).toString(b).substr(1)+r,y.divRemTo(d,y,z);return z.intValue().toString(b)+r}function bnIntValue(){if(this.s<0){if(1==this.t)return this[0]-this.DV;if(0==this.t)return-1}else{if(1==this.t)return this[0];if(0==this.t)return 0}return(this[1]&(1<<32-this.DB)-1)<<this.DB|this[0]}function bnpAddTo(a,r){for(var i=0,c=0,m=Math.min(a.t,this.t);i<m;)c+=this[i]+a[i],r[i++]=c&this.DM,c>>=this.DB;if(a.t<this.t){for(c+=a.s;i<this.t;)c+=this[i],r[i++]=c&this.DM,c>>=this.DB;c+=this.s}else{for(c+=this.s;i<a.t;)c+=a[i],r[i++]=c&this.DM,c>>=this.DB;c+=a.s}r.s=c<0?-1:0,c>0?r[i++]=c:c<-1&&(r[i++]=this.DV+c),r.t=i,r.clamp()}var goog={math:{}};goog.math.Long=function(low,high){this.low_=0|low,this.high_=0|high},goog.math.Long.IntCache_={},goog.math.Long.fromInt=function(value){if(-128<=value&&value<128){var cachedObj=goog.math.Long.IntCache_[value];if(cachedObj)return cachedObj}var obj=new goog.math.Long(0|value,value<0?-1:0);return-128<=value&&value<128&&(goog.math.Long.IntCache_[value]=obj),obj},goog.math.Long.fromNumber=function(value){return isNaN(value)||!isFinite(value)?goog.math.Long.ZERO:value<=-goog.math.Long.TWO_PWR_63_DBL_?goog.math.Long.MIN_VALUE:value+1>=goog.math.Long.TWO_PWR_63_DBL_?goog.math.Long.MAX_VALUE:value<0?goog.math.Long.fromNumber(-value).negate():new goog.math.Long(value%goog.math.Long.TWO_PWR_32_DBL_|0,value/goog.math.Long.TWO_PWR_32_DBL_|0);
},goog.math.Long.fromBits=function(lowBits,highBits){return new goog.math.Long(lowBits,highBits)},goog.math.Long.fromString=function(str,opt_radix){if(0==str.length)throw Error("number format error: empty string");var radix=opt_radix||10;if(radix<2||36<radix)throw Error("radix out of range: "+radix);if("-"==str.charAt(0))return goog.math.Long.fromString(str.substring(1),radix).negate();if(str.indexOf("-")>=0)throw Error('number format error: interior "-" character: '+str);for(var radixToPower=goog.math.Long.fromNumber(Math.pow(radix,8)),result=goog.math.Long.ZERO,i=0;i<str.length;i+=8){var size=Math.min(8,str.length-i),value=parseInt(str.substring(i,i+size),radix);if(size<8){var power=goog.math.Long.fromNumber(Math.pow(radix,size));result=result.multiply(power).add(goog.math.Long.fromNumber(value))}else result=result.multiply(radixToPower),result=result.add(goog.math.Long.fromNumber(value))}return result},goog.math.Long.TWO_PWR_16_DBL_=65536,goog.math.Long.TWO_PWR_24_DBL_=1<<24,goog.math.Long.TWO_PWR_32_DBL_=goog.math.Long.TWO_PWR_16_DBL_*goog.math.Long.TWO_PWR_16_DBL_,goog.math.Long.TWO_PWR_31_DBL_=goog.math.Long.TWO_PWR_32_DBL_/2,goog.math.Long.TWO_PWR_48_DBL_=goog.math.Long.TWO_PWR_32_DBL_*goog.math.Long.TWO_PWR_16_DBL_,goog.math.Long.TWO_PWR_64_DBL_=goog.math.Long.TWO_PWR_32_DBL_*goog.math.Long.TWO_PWR_32_DBL_,goog.math.Long.TWO_PWR_63_DBL_=goog.math.Long.TWO_PWR_64_DBL_/2,goog.math.Long.ZERO=goog.math.Long.fromInt(0),goog.math.Long.ONE=goog.math.Long.fromInt(1),goog.math.Long.NEG_ONE=goog.math.Long.fromInt(-1),goog.math.Long.MAX_VALUE=goog.math.Long.fromBits(-1,2147483647),goog.math.Long.MIN_VALUE=goog.math.Long.fromBits(0,-2147483648),goog.math.Long.TWO_PWR_24_=goog.math.Long.fromInt(1<<24),goog.math.Long.prototype.toInt=function(){return this.low_},goog.math.Long.prototype.toNumber=function(){return this.high_*goog.math.Long.TWO_PWR_32_DBL_+this.getLowBitsUnsigned()},goog.math.Long.prototype.toString=function(opt_radix){var radix=opt_radix||10;if(radix<2||36<radix)throw Error("radix out of range: "+radix);if(this.isZero())return"0";if(this.isNegative()){if(this.equals(goog.math.Long.MIN_VALUE)){var radixLong=goog.math.Long.fromNumber(radix),div=this.div(radixLong),rem=div.multiply(radixLong).subtract(this);return div.toString(radix)+rem.toInt().toString(radix)}return"-"+this.negate().toString(radix)}for(var radixToPower=goog.math.Long.fromNumber(Math.pow(radix,6)),rem=this,result="";;){var remDiv=rem.div(radixToPower),intval=rem.subtract(remDiv.multiply(radixToPower)).toInt(),digits=intval.toString(radix);if(rem=remDiv,rem.isZero())return digits+result;for(;digits.length<6;)digits="0"+digits;result=""+digits+result}},goog.math.Long.prototype.getHighBits=function(){return this.high_},goog.math.Long.prototype.getLowBits=function(){return this.low_},goog.math.Long.prototype.getLowBitsUnsigned=function(){return this.low_>=0?this.low_:goog.math.Long.TWO_PWR_32_DBL_+this.low_},goog.math.Long.prototype.getNumBitsAbs=function(){if(this.isNegative())return this.equals(goog.math.Long.MIN_VALUE)?64:this.negate().getNumBitsAbs();for(var val=0!=this.high_?this.high_:this.low_,bit=31;bit>0&&0==(val&1<<bit);bit--);return 0!=this.high_?bit+33:bit+1},goog.math.Long.prototype.isZero=function(){return 0==this.high_&&0==this.low_},goog.math.Long.prototype.isNegative=function(){return this.high_<0},goog.math.Long.prototype.isOdd=function(){return 1==(1&this.low_)},goog.math.Long.prototype.equals=function(other){return this.high_==other.high_&&this.low_==other.low_},goog.math.Long.prototype.notEquals=function(other){return this.high_!=other.high_||this.low_!=other.low_},goog.math.Long.prototype.lessThan=function(other){return this.compare(other)<0},goog.math.Long.prototype.lessThanOrEqual=function(other){return this.compare(other)<=0},goog.math.Long.prototype.greaterThan=function(other){return this.compare(other)>0},goog.math.Long.prototype.greaterThanOrEqual=function(other){return this.compare(other)>=0},goog.math.Long.prototype.compare=function(other){if(this.equals(other))return 0;var thisNeg=this.isNegative(),otherNeg=other.isNegative();return thisNeg&&!otherNeg?-1:!thisNeg&&otherNeg?1:this.subtract(other).isNegative()?-1:1},goog.math.Long.prototype.negate=function(){return this.equals(goog.math.Long.MIN_VALUE)?goog.math.Long.MIN_VALUE:this.not().add(goog.math.Long.ONE)},goog.math.Long.prototype.add=function(other){var a48=this.high_>>>16,a32=65535&this.high_,a16=this.low_>>>16,a00=65535&this.low_,b48=other.high_>>>16,b32=65535&other.high_,b16=other.low_>>>16,b00=65535&other.low_,c48=0,c32=0,c16=0,c00=0;return c00+=a00+b00,c16+=c00>>>16,c00&=65535,c16+=a16+b16,c32+=c16>>>16,c16&=65535,c32+=a32+b32,c48+=c32>>>16,c32&=65535,c48+=a48+b48,c48&=65535,goog.math.Long.fromBits(c16<<16|c00,c48<<16|c32)},goog.math.Long.prototype.subtract=function(other){return this.add(other.negate())},goog.math.Long.prototype.multiply=function(other){if(this.isZero())return goog.math.Long.ZERO;if(other.isZero())return goog.math.Long.ZERO;if(this.equals(goog.math.Long.MIN_VALUE))return other.isOdd()?goog.math.Long.MIN_VALUE:goog.math.Long.ZERO;if(other.equals(goog.math.Long.MIN_VALUE))return this.isOdd()?goog.math.Long.MIN_VALUE:goog.math.Long.ZERO;if(this.isNegative())return other.isNegative()?this.negate().multiply(other.negate()):this.negate().multiply(other).negate();if(other.isNegative())return this.multiply(other.negate()).negate();if(this.lessThan(goog.math.Long.TWO_PWR_24_)&&other.lessThan(goog.math.Long.TWO_PWR_24_))return goog.math.Long.fromNumber(this.toNumber()*other.toNumber());var a48=this.high_>>>16,a32=65535&this.high_,a16=this.low_>>>16,a00=65535&this.low_,b48=other.high_>>>16,b32=65535&other.high_,b16=other.low_>>>16,b00=65535&other.low_,c48=0,c32=0,c16=0,c00=0;return c00+=a00*b00,c16+=c00>>>16,c00&=65535,c16+=a16*b00,c32+=c16>>>16,c16&=65535,c16+=a00*b16,c32+=c16>>>16,c16&=65535,c32+=a32*b00,c48+=c32>>>16,c32&=65535,c32+=a16*b16,c48+=c32>>>16,c32&=65535,c32+=a00*b32,c48+=c32>>>16,c32&=65535,c48+=a48*b00+a32*b16+a16*b32+a00*b48,c48&=65535,goog.math.Long.fromBits(c16<<16|c00,c48<<16|c32)},goog.math.Long.prototype.div=function(other){if(other.isZero())throw Error("division by zero");if(this.isZero())return goog.math.Long.ZERO;if(this.equals(goog.math.Long.MIN_VALUE)){if(other.equals(goog.math.Long.ONE)||other.equals(goog.math.Long.NEG_ONE))return goog.math.Long.MIN_VALUE;if(other.equals(goog.math.Long.MIN_VALUE))return goog.math.Long.ONE;var halfThis=this.shiftRight(1),approx=halfThis.div(other).shiftLeft(1);if(approx.equals(goog.math.Long.ZERO))return other.isNegative()?goog.math.Long.ONE:goog.math.Long.NEG_ONE;var rem=this.subtract(other.multiply(approx)),result=approx.add(rem.div(other));return result}if(other.equals(goog.math.Long.MIN_VALUE))return goog.math.Long.ZERO;if(this.isNegative())return other.isNegative()?this.negate().div(other.negate()):this.negate().div(other).negate();if(other.isNegative())return this.div(other.negate()).negate();for(var res=goog.math.Long.ZERO,rem=this;rem.greaterThanOrEqual(other);){for(var approx=Math.max(1,Math.floor(rem.toNumber()/other.toNumber())),log2=Math.ceil(Math.log(approx)/Math.LN2),delta=log2<=48?1:Math.pow(2,log2-48),approxRes=goog.math.Long.fromNumber(approx),approxRem=approxRes.multiply(other);approxRem.isNegative()||approxRem.greaterThan(rem);)approx-=delta,approxRes=goog.math.Long.fromNumber(approx),approxRem=approxRes.multiply(other);approxRes.isZero()&&(approxRes=goog.math.Long.ONE),res=res.add(approxRes),rem=rem.subtract(approxRem)}return res},goog.math.Long.prototype.modulo=function(other){return this.subtract(this.div(other).multiply(other))},goog.math.Long.prototype.not=function(){return goog.math.Long.fromBits(~this.low_,~this.high_)},goog.math.Long.prototype.and=function(other){return goog.math.Long.fromBits(this.low_&other.low_,this.high_&other.high_)},goog.math.Long.prototype.or=function(other){return goog.math.Long.fromBits(this.low_|other.low_,this.high_|other.high_)},goog.math.Long.prototype.xor=function(other){return goog.math.Long.fromBits(this.low_^other.low_,this.high_^other.high_)},goog.math.Long.prototype.shiftLeft=function(numBits){if(numBits&=63,0==numBits)return this;var low=this.low_;if(numBits<32){var high=this.high_;return goog.math.Long.fromBits(low<<numBits,high<<numBits|low>>>32-numBits)}return goog.math.Long.fromBits(0,low<<numBits-32)},goog.math.Long.prototype.shiftRight=function(numBits){if(numBits&=63,0==numBits)return this;var high=this.high_;if(numBits<32){var low=this.low_;return goog.math.Long.fromBits(low>>>numBits|high<<32-numBits,high>>numBits)}return goog.math.Long.fromBits(high>>numBits-32,high>=0?0:-1)},goog.math.Long.prototype.shiftRightUnsigned=function(numBits){if(numBits&=63,0==numBits)return this;var high=this.high_;if(numBits<32){var low=this.low_;return goog.math.Long.fromBits(low>>>numBits|high<<32-numBits,high>>>numBits)}return 32==numBits?goog.math.Long.fromBits(high,0):goog.math.Long.fromBits(high>>>numBits-32,0)};var dbits,navigator={appName:"Modern Browser"},canary=0xdeadbeefcafe,j_lm=15715070==(16777215&canary);j_lm&&"Microsoft Internet Explorer"==navigator.appName?(BigInteger.prototype.am=am2,dbits=30):j_lm&&"Netscape"!=navigator.appName?(BigInteger.prototype.am=am1,dbits=26):(BigInteger.prototype.am=am3,dbits=28),BigInteger.prototype.DB=dbits,BigInteger.prototype.DM=(1<<dbits)-1,BigInteger.prototype.DV=1<<dbits;var BI_FP=52;BigInteger.prototype.FV=Math.pow(2,BI_FP),BigInteger.prototype.F1=BI_FP-dbits,BigInteger.prototype.F2=2*dbits-BI_FP;var rr,vv,BI_RM="0123456789abcdefghijklmnopqrstuvwxyz",BI_RC=new Array;for(rr="0".charCodeAt(0),vv=0;vv<=9;++vv)BI_RC[rr++]=vv;for(rr="a".charCodeAt(0),vv=10;vv<36;++vv)BI_RC[rr++]=vv;for(rr="A".charCodeAt(0),vv=10;vv<36;++vv)BI_RC[rr++]=vv;Classic.prototype.convert=cConvert,Classic.prototype.revert=cRevert,Classic.prototype.reduce=cReduce,Classic.prototype.mulTo=cMulTo,Classic.prototype.sqrTo=cSqrTo,Montgomery.prototype.convert=montConvert,Montgomery.prototype.revert=montRevert,Montgomery.prototype.reduce=montReduce,Montgomery.prototype.mulTo=montMulTo,Montgomery.prototype.sqrTo=montSqrTo,BigInteger.prototype.copyTo=bnpCopyTo,BigInteger.prototype.fromInt=bnpFromInt,BigInteger.prototype.fromString=bnpFromString,BigInteger.prototype.clamp=bnpClamp,BigInteger.prototype.dlShiftTo=bnpDLShiftTo,BigInteger.prototype.drShiftTo=bnpDRShiftTo,BigInteger.prototype.lShiftTo=bnpLShiftTo,BigInteger.prototype.rShiftTo=bnpRShiftTo,BigInteger.prototype.subTo=bnpSubTo,BigInteger.prototype.multiplyTo=bnpMultiplyTo,BigInteger.prototype.squareTo=bnpSquareTo,BigInteger.prototype.divRemTo=bnpDivRemTo,BigInteger.prototype.invDigit=bnpInvDigit,BigInteger.prototype.isEven=bnpIsEven,BigInteger.prototype.exp=bnpExp,BigInteger.prototype.toString=bnToString,BigInteger.prototype.negate=bnNegate,BigInteger.prototype.abs=bnAbs,BigInteger.prototype.compareTo=bnCompareTo,BigInteger.prototype.bitLength=bnBitLength,BigInteger.prototype.mod=bnMod,BigInteger.prototype.modPowInt=bnModPowInt,BigInteger.ZERO=nbv(0),BigInteger.ONE=nbv(1),BigInteger.prototype.fromRadix=bnpFromRadix,BigInteger.prototype.chunkSize=bnpChunkSize,BigInteger.prototype.signum=bnSigNum,BigInteger.prototype.dMultiply=bnpDMultiply,BigInteger.prototype.dAddOffset=bnpDAddOffset,BigInteger.prototype.toRadix=bnpToRadix,BigInteger.prototype.intValue=bnIntValue,BigInteger.prototype.addTo=bnpAddTo;var Wrapper={abs:function(l,h){var ret,x=new goog.math.Long(l,h);ret=x.isNegative()?x.negate():x,HEAP32[tempDoublePtr>>2]=ret.low_,HEAP32[tempDoublePtr+4>>2]=ret.high_},ensureTemps:function(){Wrapper.ensuredTemps||(Wrapper.ensuredTemps=!0,Wrapper.two32=new BigInteger,Wrapper.two32.fromString("4294967296",10),Wrapper.two64=new BigInteger,Wrapper.two64.fromString("18446744073709551616",10),Wrapper.temp1=new BigInteger,Wrapper.temp2=new BigInteger)},lh2bignum:function(l,h){var a=new BigInteger;a.fromString(h.toString(),10);var b=new BigInteger;a.multiplyTo(Wrapper.two32,b);var c=new BigInteger;c.fromString(l.toString(),10);var d=new BigInteger;return c.addTo(b,d),d},stringify:function(l,h,unsigned){var ret=new goog.math.Long(l,h).toString();if(unsigned&&"-"==ret[0]){Wrapper.ensureTemps();var bignum=new BigInteger;bignum.fromString(ret,10),ret=new BigInteger,Wrapper.two64.addTo(bignum,ret),ret=ret.toString(10)}return ret},fromString:function(str,base,min,max,unsigned){Wrapper.ensureTemps();var bignum=new BigInteger;bignum.fromString(str,base);var bigmin=new BigInteger;bigmin.fromString(min,10);var bigmax=new BigInteger;if(bigmax.fromString(max,10),unsigned&&bignum.compareTo(BigInteger.ZERO)<0){var temp=new BigInteger;bignum.addTo(Wrapper.two64,temp),bignum=temp}var error=!1;bignum.compareTo(bigmin)<0?(bignum=bigmin,error=!0):bignum.compareTo(bigmax)>0&&(bignum=bigmax,error=!0);var ret=goog.math.Long.fromString(bignum.toString());if(HEAP32[tempDoublePtr>>2]=ret.low_,HEAP32[tempDoublePtr+4>>2]=ret.high_,error)throw"range error"}};return Wrapper}();memoryInitializer&&("function"==typeof Module.locateFile?memoryInitializer=Module.locateFile(memoryInitializer):Module.memoryInitializerPrefixURL&&(memoryInitializer=Module.memoryInitializerPrefixURL+memoryInitializer),addRunDependency("memory initializer"),Browser.asyncLoad(memoryInitializer,function(data){HEAPU8.set(data,STATIC_BASE),removeRunDependency("memory initializer")},function(data){throw"could not load memory initializer "+memoryInitializer})),ExitStatus.prototype=new Error,ExitStatus.prototype.constructor=ExitStatus;var initialStackTop,preloadStartTime=null,calledMain=!1;if(dependenciesFulfilled=function runCaller(){!Module.calledRun&&shouldRunNow&&run(),Module.calledRun||(dependenciesFulfilled=runCaller)},Module.callMain=Module.callMain=function(args){function pad(){for(var i=0;i<3;i++)argv.push(0)}assert(0==runDependencies,"cannot call main when async dependencies remain! (listen on __ATMAIN__)"),assert(0==__ATPRERUN__.length,"cannot call main when preRun functions remain to be called"),args=args||[],ensureInitRuntime();var argc=args.length+1,argv=[allocate(intArrayFromString(Module.thisProgram),"i8",ALLOC_NORMAL)];pad();for(var i=0;i<argc-1;i+=1)argv.push(allocate(intArrayFromString(args[i]),"i8",ALLOC_NORMAL)),pad();argv.push(0),argv=allocate(argv,"i32",ALLOC_NORMAL),initialStackTop=STACKTOP;try{var ret=Module._main(argc,argv,0);exit(ret)}catch(e){if(e instanceof ExitStatus)return;if("SimulateInfiniteLoop"==e)return void(Module.noExitRuntime=!0);throw e&&"object"==typeof e&&e.stack&&Module.printErr("exception thrown: "+[e,e.stack]),e}finally{calledMain=!0}},Module.run=Module.run=run,Module.exit=Module.exit=exit,Module.abort=Module.abort=abort,Module.preInit)for("function"==typeof Module.preInit&&(Module.preInit=[Module.preInit]);Module.preInit.length>0;)Module.preInit.pop()();var shouldRunNow=!0;return Module.noInitialRun&&(shouldRunNow=!1),run(),Module.return=Module.return.split("\n").slice(0,-2),{errors:Module.return.length?Module.return:null}}}(),module.exports=xmllint}).call(exports,__webpack_require__(92).Buffer)},function(module,exports,__webpack_require__){"use strict";var Schema=__webpack_require__(147);module.exports=new Schema({explicit:[__webpack_require__(227),__webpack_require__(228),__webpack_require__(229)]})},function(module,exports,__webpack_require__){"use strict";function resolveYamlNull(data){if(null===data)return!0;var max=data.length;return 1===max&&"~"===data||4===max&&("null"===data||"Null"===data||"NULL"===data)}function constructYamlNull(){return null}function isNull(object){return null===object}var Type=__webpack_require__(179);module.exports=new Type("tag:yaml.org,2002:null",{kind:"scalar",resolve:resolveYamlNull,construct:constructYamlNull,predicate:isNull,represent:{canonical:function(){return"~"},lowercase:function(){return"null"},uppercase:function(){return"NULL"},camelcase:function(){return"Null"}},defaultStyle:"lowercase"})},function(module,exports,__webpack_require__){"use strict";function resolveYamlBoolean(data){if(null===data)return!1;var max=data.length;return 4===max&&("true"===data||"True"===data||"TRUE"===data)||5===max&&("false"===data||"False"===data||"FALSE"===data)}function constructYamlBoolean(data){return"true"===data||"True"===data||"TRUE"===data}function isBoolean(object){return"[object Boolean]"===Object.prototype.toString.call(object)}var Type=__webpack_require__(179);module.exports=new Type("tag:yaml.org,2002:bool",{kind:"scalar",resolve:resolveYamlBoolean,construct:constructYamlBoolean,predicate:isBoolean,represent:{lowercase:function(object){return object?"true":"false"},uppercase:function(object){return object?"TRUE":"FALSE"},camelcase:function(object){return object?"True":"False"}},defaultStyle:"lowercase"})},function(module,exports,__webpack_require__){"use strict";function isHexCode(c){return 48<=c&&c<=57||65<=c&&c<=70||97<=c&&c<=102}function isOctCode(c){return 48<=c&&c<=55}function isDecCode(c){return 48<=c&&c<=57}function resolveYamlInteger(data){if(null===data)return!1;var ch,max=data.length,index=0,hasDigits=!1;if(!max)return!1;if(ch=data[index],"-"!==ch&&"+"!==ch||(ch=data[++index]),"0"===ch){if(index+1===max)return!0;if(ch=data[++index],"b"===ch){for(index++;index<max;index++)if(ch=data[index],"_"!==ch){if("0"!==ch&&"1"!==ch)return!1;hasDigits=!0}return hasDigits}if("x"===ch){for(index++;index<max;index++)if(ch=data[index],"_"!==ch){if(!isHexCode(data.charCodeAt(index)))return!1;hasDigits=!0}return hasDigits}for(;index<max;index++)if(ch=data[index],"_"!==ch){if(!isOctCode(data.charCodeAt(index)))return!1;hasDigits=!0}return hasDigits}for(;index<max;index++)if(ch=data[index],"_"!==ch){if(":"===ch)break;if(!isDecCode(data.charCodeAt(index)))return!1;hasDigits=!0}return!!hasDigits&&(":"!==ch||/^(:[0-5]?[0-9])+$/.test(data.slice(index)))}function constructYamlInteger(data){var ch,base,value=data,sign=1,digits=[];return value.indexOf("_")!==-1&&(value=value.replace(/_/g,"")),ch=value[0],"-"!==ch&&"+"!==ch||("-"===ch&&(sign=-1),value=value.slice(1),ch=value[0]),"0"===value?0:"0"===ch?"b"===value[1]?sign*parseInt(value.slice(2),2):"x"===value[1]?sign*parseInt(value,16):sign*parseInt(value,8):value.indexOf(":")!==-1?(value.split(":").forEach(function(v){digits.unshift(parseInt(v,10))}),value=0,base=1,digits.forEach(function(d){value+=d*base,base*=60}),sign*value):sign*parseInt(value,10)}function isInteger(object){return"[object Number]"===Object.prototype.toString.call(object)&&0===object%1&&!common.isNegativeZero(object)}var common=__webpack_require__(97),Type=__webpack_require__(179);module.exports=new Type("tag:yaml.org,2002:int",{kind:"scalar",resolve:resolveYamlInteger,construct:constructYamlInteger,predicate:isInteger,represent:{binary:function(object){return"0b"+object.toString(2)},octal:function(object){return"0"+object.toString(8)},decimal:function(object){return object.toString(10)},hexadecimal:function(object){return"0x"+object.toString(16).toUpperCase()}},defaultStyle:"decimal",styleAliases:{binary:[2,"bin"],octal:[8,"oct"],decimal:[10,"dec"],hexadecimal:[16,"hex"]}})},function(module,exports,__webpack_require__){"use strict";function resolveYamlFloat(data){if(null===data)return!1;return!!YAML_FLOAT_PATTERN.test(data)}function constructYamlFloat(data){var value,sign,base,digits;return value=data.replace(/_/g,"").toLowerCase(),sign="-"===value[0]?-1:1,digits=[],0<="+-".indexOf(value[0])&&(value=value.slice(1)),".inf"===value?1===sign?Number.POSITIVE_INFINITY:Number.NEGATIVE_INFINITY:".nan"===value?NaN:0<=value.indexOf(":")?(value.split(":").forEach(function(v){digits.unshift(parseFloat(v,10))}),value=0,base=1,digits.forEach(function(d){value+=d*base,base*=60}),sign*value):sign*parseFloat(value,10)}function representYamlFloat(object,style){if(isNaN(object))switch(style){case"lowercase":return".nan";case"uppercase":return".NAN";case"camelcase":return".NaN"}else if(Number.POSITIVE_INFINITY===object)switch(style){case"lowercase":return".inf";case"uppercase":return".INF";case"camelcase":return".Inf"}else if(Number.NEGATIVE_INFINITY===object)switch(style){case"lowercase":return"-.inf";case"uppercase":return"-.INF";case"camelcase":return"-.Inf"}else if(common.isNegativeZero(object))return"-0.0";return object.toString(10)}function isFloat(object){return"[object Number]"===Object.prototype.toString.call(object)&&(0!==object%1||common.isNegativeZero(object))}var common=__webpack_require__(97),Type=__webpack_require__(179),YAML_FLOAT_PATTERN=new RegExp("^(?:[-+]?(?:[0-9][0-9_]*)\\.[0-9_]*(?:[eE][-+][0-9]+)?|\\.[0-9_]+(?:[eE][-+][0-9]+)?|[-+]?[0-9][0-9_]*(?::[0-5]?[0-9])+\\.[0-9_]*|[-+]?\\.(?:inf|Inf|INF)|\\.(?:nan|NaN|NAN))$");module.exports=new Type("tag:yaml.org,2002:float",{kind:"scalar",resolve:resolveYamlFloat,construct:constructYamlFloat,predicate:isFloat,represent:representYamlFloat,defaultStyle:"lowercase"})},function(module,exports,__webpack_require__){(function(global){function deprecate(fn,msg){function deprecated(){if(!warned){if(config("throwDeprecation"))throw new Error(msg);config("traceDeprecation")?console.trace(msg):console.warn(msg),warned=!0}return fn.apply(this,arguments)}if(config("noDeprecation"))return fn;var warned=!1;return deprecated}function config(name){try{if(!global.localStorage)return!1}catch(_){return!1}var val=global.localStorage[name];return null!=val&&"true"===String(val).toLowerCase()}module.exports=deprecate}).call(exports,function(){return this}())},function(module,exports,__webpack_require__){(function(){"use strict";var bom,builder,escapeCDATA,events,isEmpty,processName,processors,requiresCDATA,sax,setImmediate,wrapCDATA,extend=function(child,parent){function ctor(){this.constructor=child}for(var key in parent)hasProp.call(parent,key)&&(child[key]=parent[key]);return ctor.prototype=parent.prototype,child.prototype=new ctor,child.__super__=parent.prototype,child},hasProp={}.hasOwnProperty,bind=function(fn,me){return function(){return fn.apply(me,arguments)}};sax=__webpack_require__(259),events=__webpack_require__(196),builder=__webpack_require__(258),bom=__webpack_require__(230),processors=__webpack_require__(231),setImmediate=__webpack_require__(256).setImmediate,isEmpty=function(thing){return"object"==typeof thing&&null!=thing&&0===Object.keys(thing).length},processName=function(processors,processedName){var i,len,process;for(i=0,len=processors.length;i<len;i++)process=processors[i],processedName=process(processedName);return processedName},requiresCDATA=function(entry){return entry.indexOf("&")>=0||entry.indexOf(">")>=0||entry.indexOf("<")>=0},wrapCDATA=function(entry){return"<![CDATA["+escapeCDATA(entry)+"]]>"},escapeCDATA=function(entry){return entry.replace("]]>","]]]]><![CDATA[>")},exports.processors=processors,exports.defaults={.1:{explicitCharkey:!1,trim:!0,normalize:!0,normalizeTags:!1,attrkey:"@",charkey:"#",explicitArray:!1,ignoreAttrs:!1,mergeAttrs:!1,explicitRoot:!1,validator:null,xmlns:!1,explicitChildren:!1,childkey:"@@",charsAsChildren:!1,async:!1,strict:!0,attrNameProcessors:null,attrValueProcessors:null,tagNameProcessors:null,valueProcessors:null,emptyTag:""},.2:{explicitCharkey:!1,trim:!1,normalize:!1,normalizeTags:!1,attrkey:"$",charkey:"_",explicitArray:!0,ignoreAttrs:!1,mergeAttrs:!1,explicitRoot:!0,validator:null,xmlns:!1,explicitChildren:!1,preserveChildrenOrder:!1,childkey:"$$",charsAsChildren:!1,async:!1,strict:!0,attrNameProcessors:null,attrValueProcessors:null,tagNameProcessors:null,valueProcessors:null,rootName:"root",xmldec:{version:"1.0",encoding:"UTF-8",standalone:!0},doctype:null,renderOpts:{pretty:!0,indent:"  ",newline:"\n"},headless:!1,chunkSize:1e4,emptyTag:"",cdata:!1}},exports.ValidationError=function(superClass){function ValidationError(message){this.message=message}return extend(ValidationError,superClass),ValidationError}(Error),exports.Builder=function(){function Builder(opts){var key,ref,value;this.options={},ref=exports.defaults[.2];for(key in ref)hasProp.call(ref,key)&&(value=ref[key],this.options[key]=value);for(key in opts)hasProp.call(opts,key)&&(value=opts[key],this.options[key]=value)}return Builder.prototype.buildObject=function(rootObj){var attrkey,charkey,render,rootElement,rootName;return attrkey=this.options.attrkey,charkey=this.options.charkey,1===Object.keys(rootObj).length&&this.options.rootName===exports.defaults[.2].rootName?(rootName=Object.keys(rootObj)[0],rootObj=rootObj[rootName]):rootName=this.options.rootName,render=function(_this){return function(element,obj){var attr,child,entry,index,key,value;if("object"!=typeof obj)_this.options.cdata&&requiresCDATA(obj)?element.raw(wrapCDATA(obj)):element.txt(obj);else for(key in obj)if(hasProp.call(obj,key))if(child=obj[key],key===attrkey){if("object"==typeof child)for(attr in child)value=child[attr],element=element.att(attr,value)}else if(key===charkey)element=_this.options.cdata&&requiresCDATA(child)?element.raw(wrapCDATA(child)):element.txt(child);else if(Array.isArray(child))for(index in child)hasProp.call(child,index)&&(entry=child[index],element="string"==typeof entry?_this.options.cdata&&requiresCDATA(entry)?element.ele(key).raw(wrapCDATA(entry)).up():element.ele(key,entry).up():render(element.ele(key),entry).up());else"object"==typeof child?element=render(element.ele(key),child).up():"string"==typeof child&&_this.options.cdata&&requiresCDATA(child)?element=element.ele(key).raw(wrapCDATA(child)).up():(null==child&&(child=""),element=element.ele(key,child.toString()).up());return element}}(this),rootElement=builder.create(rootName,this.options.xmldec,this.options.doctype,{headless:this.options.headless,allowSurrogateChars:this.options.allowSurrogateChars}),render(rootElement,rootObj).end(this.options.renderOpts)},Builder}(),exports.Parser=function(superClass){function Parser(opts){this.parseString=bind(this.parseString,this),this.reset=bind(this.reset,this),this.assignOrPush=bind(this.assignOrPush,this),this.processAsync=bind(this.processAsync,this);var key,ref,value;if(!(this instanceof exports.Parser))return new exports.Parser(opts);this.options={},ref=exports.defaults[.2];for(key in ref)hasProp.call(ref,key)&&(value=ref[key],this.options[key]=value);for(key in opts)hasProp.call(opts,key)&&(value=opts[key],this.options[key]=value);this.options.xmlns&&(this.options.xmlnskey=this.options.attrkey+"ns"),this.options.normalizeTags&&(this.options.tagNameProcessors||(this.options.tagNameProcessors=[]),this.options.tagNameProcessors.unshift(processors.normalize)),this.reset()}return extend(Parser,superClass),Parser.prototype.processAsync=function(){var chunk,err,error1;try{return this.remaining.length<=this.options.chunkSize?(chunk=this.remaining,this.remaining="",this.saxParser=this.saxParser.write(chunk),this.saxParser.close()):(chunk=this.remaining.substr(0,this.options.chunkSize),this.remaining=this.remaining.substr(this.options.chunkSize,this.remaining.length),this.saxParser=this.saxParser.write(chunk),setImmediate(this.processAsync))}catch(error1){if(err=error1,!this.saxParser.errThrown)return this.saxParser.errThrown=!0,this.emit(err)}},Parser.prototype.assignOrPush=function(obj,key,newValue){return key in obj?(obj[key]instanceof Array||(obj[key]=[obj[key]]),obj[key].push(newValue)):this.options.explicitArray?obj[key]=[newValue]:obj[key]=newValue},Parser.prototype.reset=function(){var attrkey,charkey,ontext,stack;return this.removeAllListeners(),this.saxParser=sax.parser(this.options.strict,{trim:!1,normalize:!1,xmlns:this.options.xmlns}),this.saxParser.errThrown=!1,this.saxParser.onerror=function(_this){return function(error){if(_this.saxParser.resume(),!_this.saxParser.errThrown)return _this.saxParser.errThrown=!0,_this.emit("error",error)}}(this),this.saxParser.onend=function(_this){return function(){if(!_this.saxParser.ended)return _this.saxParser.ended=!0,_this.emit("end",_this.resultObject)}}(this),this.saxParser.ended=!1,this.EXPLICIT_CHARKEY=this.options.explicitCharkey,this.resultObject=null,stack=[],attrkey=this.options.attrkey,charkey=this.options.charkey,this.saxParser.onopentag=function(_this){return function(node){var key,newValue,obj,processedKey,ref;if(obj={},obj[charkey]="",!_this.options.ignoreAttrs){ref=node.attributes;for(key in ref)hasProp.call(ref,key)&&(attrkey in obj||_this.options.mergeAttrs||(obj[attrkey]={}),newValue=_this.options.attrValueProcessors?processName(_this.options.attrValueProcessors,node.attributes[key]):node.attributes[key],processedKey=_this.options.attrNameProcessors?processName(_this.options.attrNameProcessors,key):key,_this.options.mergeAttrs?_this.assignOrPush(obj,processedKey,newValue):obj[attrkey][processedKey]=newValue)}return obj["#name"]=_this.options.tagNameProcessors?processName(_this.options.tagNameProcessors,node.name):node.name,_this.options.xmlns&&(obj[_this.options.xmlnskey]={uri:node.uri,local:node.local}),stack.push(obj)}}(this),this.saxParser.onclosetag=function(_this){return function(){var cdata,emptyStr,err,error1,key,node,nodeName,obj,objClone,old,s,xpath;if(obj=stack.pop(),nodeName=obj["#name"],_this.options.explicitChildren&&_this.options.preserveChildrenOrder||delete obj["#name"],obj.cdata===!0&&(cdata=obj.cdata,delete obj.cdata),s=stack[stack.length-1],obj[charkey].match(/^\s*$/)&&!cdata?(emptyStr=obj[charkey],delete obj[charkey]):(_this.options.trim&&(obj[charkey]=obj[charkey].trim()),_this.options.normalize&&(obj[charkey]=obj[charkey].replace(/\s{2,}/g," ").trim()),obj[charkey]=_this.options.valueProcessors?processName(_this.options.valueProcessors,obj[charkey]):obj[charkey],1===Object.keys(obj).length&&charkey in obj&&!_this.EXPLICIT_CHARKEY&&(obj=obj[charkey])),isEmpty(obj)&&(obj=""!==_this.options.emptyTag?_this.options.emptyTag:emptyStr),null!=_this.options.validator){xpath="/"+function(){var i,len,results;for(results=[],i=0,len=stack.length;i<len;i++)node=stack[i],results.push(node["#name"]);return results}().concat(nodeName).join("/");try{obj=_this.options.validator(xpath,s&&s[nodeName],obj)}catch(error1){err=error1,_this.emit("error",err)}}if(_this.options.explicitChildren&&!_this.options.mergeAttrs&&"object"==typeof obj)if(_this.options.preserveChildrenOrder){if(s){s[_this.options.childkey]=s[_this.options.childkey]||[],objClone={};for(key in obj)hasProp.call(obj,key)&&(objClone[key]=obj[key]);s[_this.options.childkey].push(objClone),delete obj["#name"],1===Object.keys(obj).length&&charkey in obj&&!_this.EXPLICIT_CHARKEY&&(obj=obj[charkey])}}else node={},_this.options.attrkey in obj&&(node[_this.options.attrkey]=obj[_this.options.attrkey],delete obj[_this.options.attrkey]),!_this.options.charsAsChildren&&_this.options.charkey in obj&&(node[_this.options.charkey]=obj[_this.options.charkey],delete obj[_this.options.charkey]),Object.getOwnPropertyNames(obj).length>0&&(node[_this.options.childkey]=obj),obj=node;return stack.length>0?_this.assignOrPush(s,nodeName,obj):(_this.options.explicitRoot&&(old=obj,obj={},obj[nodeName]=old),_this.resultObject=obj,_this.saxParser.ended=!0,_this.emit("end",_this.resultObject))}}(this),ontext=function(_this){return function(text){var charChild,s;if(s=stack[stack.length-1])return s[charkey]+=text,_this.options.explicitChildren&&_this.options.preserveChildrenOrder&&_this.options.charsAsChildren&&""!==text.replace(/\\n/g,"").trim()&&(s[_this.options.childkey]=s[_this.options.childkey]||[],charChild={"#name":"__text__"},charChild[charkey]=text,s[_this.options.childkey].push(charChild)),s}}(this),this.saxParser.ontext=ontext,this.saxParser.oncdata=function(_this){return function(text){var s;if(s=ontext(text))return s.cdata=!0}}(this)},Parser.prototype.parseString=function(str,cb){var err,error1;null!=cb&&"function"==typeof cb&&(this.on("end",function(result){return this.reset(),cb(null,result)}),this.on("error",function(err){return this.reset(),cb(err)}));try{return str=str.toString(),""===str.trim()?(this.emit("end",null),!0):(str=bom.stripBOM(str),this.options.async?(this.remaining=str,setImmediate(this.processAsync),this.saxParser):this.saxParser.write(str).close())}catch(error1){if(err=error1,!this.saxParser.errThrown&&!this.saxParser.ended)return this.emit("error",err),
this.saxParser.errThrown=!0;if(this.saxParser.ended)throw err}},Parser}(events.EventEmitter),exports.parseString=function(str,a,b){var cb,options,parser;return null!=b?("function"==typeof b&&(cb=b),"object"==typeof a&&(options=a)):("function"==typeof a&&(cb=a),options={}),parser=new exports.Parser(options),parser.parseString(str,cb)}}).call(this)},function(module,exports,__webpack_require__){function XMLReader(){}function parse(source,defaultNSMapCopy,entityMap,domBuilder,errorHandler){function fixedFromCharCode(code){if(code>65535){code-=65536;var surrogate1=55296+(code>>10),surrogate2=56320+(1023&code);return String.fromCharCode(surrogate1,surrogate2)}return String.fromCharCode(code)}function entityReplacer(a){var k=a.slice(1,-1);return k in entityMap?entityMap[k]:"#"===k.charAt(0)?fixedFromCharCode(parseInt(k.substr(1).replace("x","0x"))):(errorHandler.error("entity not found:"+a),a)}function appendText(end){if(end>start){var xt=source.substring(start,end).replace(/&#?\w+;/g,entityReplacer);locator&&position(start),domBuilder.characters(xt,0,end-start),start=end}}function position(p,m){for(;p>=lineEnd&&(m=linePattern.exec(source));)lineStart=m.index,lineEnd=lineStart+m[0].length,locator.lineNumber++;locator.columnNumber=p-lineStart+1}for(var lineStart=0,lineEnd=0,linePattern=/.+(?:\r\n?|\n)|.*$/g,locator=domBuilder.locator,parseStack=[{currentNSMap:defaultNSMapCopy}],closeMap={},start=0;;){try{var tagStart=source.indexOf("<",start);if(tagStart<0){if(!source.substr(start).match(/^\s*$/)){var doc=domBuilder.document,text=doc.createTextNode(source.substr(start));doc.appendChild(text),domBuilder.currentElement=text}return}switch(tagStart>start&&appendText(tagStart),source.charAt(tagStart+1)){case"/":var end=source.indexOf(">",tagStart+3),tagName=source.substring(tagStart+2,end),config=parseStack.pop(),localNSMap=config.localNSMap;if(config.tagName!=tagName&&errorHandler.fatalError("end tag name: "+tagName+" is not match the current start tagName:"+config.tagName),domBuilder.endElement(config.uri,config.localName,tagName),localNSMap)for(var prefix in localNSMap)domBuilder.endPrefixMapping(prefix);end++;break;case"?":locator&&position(tagStart),end=parseInstruction(source,tagStart,domBuilder);break;case"!":locator&&position(tagStart),end=parseDCC(source,tagStart,domBuilder,errorHandler);break;default:locator&&position(tagStart);var el=new ElementAttributes,end=parseElementStartPart(source,tagStart,el,entityReplacer,errorHandler),len=el.length;if(locator){if(len)for(var i=0;i<len;i++){var a=el[i];position(a.offset),a.offset=copyLocator(locator,{})}position(end)}!el.closed&&fixSelfClosed(source,end,el.tagName,closeMap)&&(el.closed=!0,entityMap.nbsp||errorHandler.warning("unclosed xml attribute")),appendElement(el,domBuilder,parseStack),"http://www.w3.org/1999/xhtml"!==el.uri||el.closed?end++:end=parseHtmlSpecialContent(source,end,el.tagName,entityReplacer,domBuilder)}}catch(e){errorHandler.error("element parse error: "+e),end=-1}end>start?start=end:appendText(Math.max(tagStart,start)+1)}}function copyLocator(f,t){return t.lineNumber=f.lineNumber,t.columnNumber=f.columnNumber,t}function parseElementStartPart(source,start,el,entityReplacer,errorHandler){for(var attrName,value,p=++start,s=S_TAG;;){var c=source.charAt(p);switch(c){case"=":if(s===S_ATTR)attrName=source.slice(start,p),s=S_EQ;else{if(s!==S_ATTR_S)throw new Error("attribute equal must after attrName");s=S_EQ}break;case"'":case'"':if(s===S_EQ){if(start=p+1,p=source.indexOf(c,start),!(p>0))throw new Error("attribute value no end '"+c+"' match");value=source.slice(start,p).replace(/&#?\w+;/g,entityReplacer),el.add(attrName,value,start-1),s=S_E}else{if(s!=S_V)throw new Error('attribute value must after "="');value=source.slice(start,p).replace(/&#?\w+;/g,entityReplacer),el.add(attrName,value,start),errorHandler.warning('attribute "'+attrName+'" missed start quot('+c+")!!"),start=p+1,s=S_E}break;case"/":switch(s){case S_TAG:el.setTagName(source.slice(start,p));case S_E:case S_S:case S_C:s=S_C,el.closed=!0;case S_V:case S_ATTR:case S_ATTR_S:break;default:throw new Error("attribute invalid close char('/')")}break;case"":errorHandler.error("unexpected end of input");case">":switch(s){case S_TAG:el.setTagName(source.slice(start,p));case S_E:case S_S:case S_C:break;case S_V:case S_ATTR:value=source.slice(start,p),"/"===value.slice(-1)&&(el.closed=!0,value=value.slice(0,-1));case S_ATTR_S:s===S_ATTR_S&&(value=attrName),s==S_V?(errorHandler.warning('attribute "'+value+'" missed quot(")!!'),el.add(attrName,value.replace(/&#?\w+;/g,entityReplacer),start)):(errorHandler.warning('attribute "'+value+'" missed value!! "'+value+'" instead!!'),el.add(value,value,start));break;case S_EQ:throw new Error("attribute value missed!!")}return p;case"":c=" ";default:if(c<=" ")switch(s){case S_TAG:el.setTagName(source.slice(start,p)),s=S_S;break;case S_ATTR:attrName=source.slice(start,p),s=S_ATTR_S;break;case S_V:var value=source.slice(start,p).replace(/&#?\w+;/g,entityReplacer);errorHandler.warning('attribute "'+value+'" missed quot(")!!'),el.add(attrName,value,start);case S_E:s=S_S}else switch(s){case S_ATTR_S:errorHandler.warning('attribute "'+attrName+'" missed value!! "'+attrName+'" instead!!'),el.add(attrName,attrName,start),start=p,s=S_ATTR;break;case S_E:errorHandler.warning('attribute space is required"'+attrName+'"!!');case S_S:s=S_ATTR,start=p;break;case S_EQ:s=S_V,start=p;break;case S_C:throw new Error("elements closed character '/' and '>' must be connected to")}}p++}}function appendElement(el,domBuilder,parseStack){for(var tagName=el.tagName,localNSMap=null,currentNSMap=parseStack[parseStack.length-1].currentNSMap,i=el.length;i--;){var a=el[i],qName=a.qName,value=a.value,nsp=qName.indexOf(":");if(nsp>0)var prefix=a.prefix=qName.slice(0,nsp),localName=qName.slice(nsp+1),nsPrefix="xmlns"===prefix&&localName;else localName=qName,prefix=null,nsPrefix="xmlns"===qName&&"";a.localName=localName,nsPrefix!==!1&&(null==localNSMap&&(localNSMap={},_copy(currentNSMap,currentNSMap={})),currentNSMap[nsPrefix]=localNSMap[nsPrefix]=value,a.uri="http://www.w3.org/2000/xmlns/",domBuilder.startPrefixMapping(nsPrefix,value))}for(var i=el.length;i--;){a=el[i];var prefix=a.prefix;prefix&&("xml"===prefix&&(a.uri="http://www.w3.org/XML/1998/namespace"),"xmlns"!==prefix&&(a.uri=currentNSMap[prefix]))}var nsp=tagName.indexOf(":");nsp>0?(prefix=el.prefix=tagName.slice(0,nsp),localName=el.localName=tagName.slice(nsp+1)):(prefix=null,localName=el.localName=tagName);var ns=el.uri=currentNSMap[prefix||""];if(domBuilder.startElement(ns,localName,tagName,el),el.closed){if(domBuilder.endElement(ns,localName,tagName),localNSMap)for(prefix in localNSMap)domBuilder.endPrefixMapping(prefix)}else el.currentNSMap=currentNSMap,el.localNSMap=localNSMap,parseStack.push(el)}function parseHtmlSpecialContent(source,elStartEnd,tagName,entityReplacer,domBuilder){if(/^(?:script|textarea)$/i.test(tagName)){var elEndStart=source.indexOf("</"+tagName+">",elStartEnd),text=source.substring(elStartEnd+1,elEndStart);if(/[&<]/.test(text))return/^script$/i.test(tagName)?(domBuilder.characters(text,0,text.length),elEndStart):(text=text.replace(/&#?\w+;/g,entityReplacer),domBuilder.characters(text,0,text.length),elEndStart)}return elStartEnd+1}function fixSelfClosed(source,elStartEnd,tagName,closeMap){var pos=closeMap[tagName];return null==pos&&(pos=closeMap[tagName]=source.lastIndexOf("</"+tagName+">")),pos<elStartEnd}function _copy(source,target){for(var n in source)target[n]=source[n]}function parseDCC(source,start,domBuilder,errorHandler){var next=source.charAt(start+2);switch(next){case"-":if("-"===source.charAt(start+3)){var end=source.indexOf("-->",start+4);return end>start?(domBuilder.comment(source,start+4,end-start-4),end+3):(errorHandler.error("Unclosed comment"),-1)}return-1;default:if("CDATA["==source.substr(start+3,6)){var end=source.indexOf("]]>",start+9);return domBuilder.startCDATA(),domBuilder.characters(source,start+9,end-start-9),domBuilder.endCDATA(),end+3}var matchs=split(source,start),len=matchs.length;if(len>1&&/!doctype/i.test(matchs[0][0])){var name=matchs[1][0],pubid=len>3&&/^public$/i.test(matchs[2][0])&&matchs[3][0],sysid=len>4&&matchs[4][0],lastMatch=matchs[len-1];return domBuilder.startDTD(name,pubid&&pubid.replace(/^(['"])(.*?)\1$/,"$2"),sysid&&sysid.replace(/^(['"])(.*?)\1$/,"$2")),domBuilder.endDTD(),lastMatch.index+lastMatch[0].length}}return-1}function parseInstruction(source,start,domBuilder){var end=source.indexOf("?>",start);if(end){var match=source.substring(start,end).match(/^<\?(\S*)\s*([\s\S]*?)\s*$/);if(match){match[0].length;return domBuilder.processingInstruction(match[1],match[2]),end+2}return-1}return-1}function ElementAttributes(source){}function _set_proto_(thiz,parent){return thiz.__proto__=parent,thiz}function split(source,start){var match,buf=[],reg=/'[^']+'|"[^"]+"|[^\s<>\/=]+=?|(\/?\s*>|<)/g;for(reg.lastIndex=start,reg.exec(source);match=reg.exec(source);)if(buf.push(match),match[1])return buf}var nameStartChar=/[A-Z_a-z\xC0-\xD6\xD8-\xF6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD]/,nameChar=new RegExp("[\\-\\.0-9"+nameStartChar.source.slice(1,-1)+"·̀-ͯ\\u203F-⁀]"),tagNamePattern=new RegExp("^"+nameStartChar.source+nameChar.source+"*(?::"+nameStartChar.source+nameChar.source+"*)?$"),S_TAG=0,S_ATTR=1,S_ATTR_S=2,S_EQ=3,S_V=4,S_E=5,S_S=6,S_C=7;XMLReader.prototype={parse:function(source,defaultNSMap,entityMap){var domBuilder=this.domBuilder;domBuilder.startDocument(),_copy(defaultNSMap,defaultNSMap={}),parse(source,defaultNSMap,entityMap,domBuilder,this.errorHandler),domBuilder.endDocument()}},ElementAttributes.prototype={setTagName:function(tagName){if(!tagNamePattern.test(tagName))throw new Error("invalid tagName:"+tagName);this.tagName=tagName},add:function(qName,value,offset){if(!tagNamePattern.test(qName))throw new Error("invalid attribute:"+qName);this[this.length++]={qName:qName,value:value,offset:offset}},length:0,getLocalName:function(i){return this[i].localName},getOffset:function(i){return this[i].offset},getQName:function(i){return this[i].qName},getURI:function(i){return this[i].uri},getValue:function(i){return this[i].value}},_set_proto_({},_set_proto_.prototype)instanceof _set_proto_||(_set_proto_=function(thiz,parent){function p(){}p.prototype=parent,p=new p;for(parent in thiz)p[parent]=thiz[parent];return p}),exports.XMLReader=XMLReader},function(module,exports,__webpack_require__){function copy(src,dest){for(var p in src)dest[p]=src[p]}function _extends(Class,Super){function t(){}var pt=Class.prototype;if(Object.create){var ppt=Object.create(Super.prototype);pt.__proto__=ppt}pt instanceof Super||(t.prototype=Super.prototype,t=new t,copy(pt,t),Class.prototype=pt=t),pt.constructor!=Class&&("function"!=typeof Class&&console.error("unknow Class:"+Class),pt.constructor=Class)}function DOMException(code,message){if(message instanceof Error)var error=message;else error=this,Error.call(this,ExceptionMessage[code]),this.message=ExceptionMessage[code],Error.captureStackTrace&&Error.captureStackTrace(this,DOMException);return error.code=code,message&&(this.message=this.message+": "+message),error}function NodeList(){}function LiveNodeList(node,refresh){this._node=node,this._refresh=refresh,_updateLiveList(this)}function _updateLiveList(list){var inc=list._node._inc||list._node.ownerDocument._inc;if(list._inc!=inc){var ls=list._refresh(list._node);__set__(list,"length",ls.length),copy(ls,list),list._inc=inc}}function NamedNodeMap(){}function _findNodeIndex(list,node){for(var i=list.length;i--;)if(list[i]===node)return i}function _addNamedNode(el,list,newAttr,oldAttr){if(oldAttr?list[_findNodeIndex(list,oldAttr)]=newAttr:list[list.length++]=newAttr,el){newAttr.ownerElement=el;var doc=el.ownerDocument;doc&&(oldAttr&&_onRemoveAttribute(doc,el,oldAttr),_onAddAttribute(doc,el,newAttr))}}function _removeNamedNode(el,list,attr){var i=_findNodeIndex(list,attr);if(!(i>=0))throw DOMException(NOT_FOUND_ERR,new Error);for(var lastIndex=list.length-1;i<lastIndex;)list[i]=list[++i];if(list.length=lastIndex,el){var doc=el.ownerDocument;doc&&(_onRemoveAttribute(doc,el,attr),attr.ownerElement=null)}}function DOMImplementation(features){if(this._features={},features)for(var feature in features)this._features=features[feature]}function Node(){}function _xmlEncoder(c){return"<"==c&&"&lt;"||">"==c&&"&gt;"||"&"==c&&"&amp;"||'"'==c&&"&quot;"||"&#"+c.charCodeAt()+";"}function _visitNode(node,callback){if(callback(node))return!0;if(node=node.firstChild)do if(_visitNode(node,callback))return!0;while(node=node.nextSibling)}function Document(){}function _onAddAttribute(doc,el,newAttr){doc&&doc._inc++;var ns=newAttr.namespaceURI;"http://www.w3.org/2000/xmlns/"==ns&&(el._nsMap[newAttr.prefix?newAttr.localName:""]=newAttr.value)}function _onRemoveAttribute(doc,el,newAttr,remove){doc&&doc._inc++;var ns=newAttr.namespaceURI;"http://www.w3.org/2000/xmlns/"==ns&&delete el._nsMap[newAttr.prefix?newAttr.localName:""]}function _onUpdateChild(doc,el,newChild){if(doc&&doc._inc){doc._inc++;var cs=el.childNodes;if(newChild)cs[cs.length++]=newChild;else{for(var child=el.firstChild,i=0;child;)cs[i++]=child,child=child.nextSibling;cs.length=i}}}function _removeChild(parentNode,child){var previous=child.previousSibling,next=child.nextSibling;return previous?previous.nextSibling=next:parentNode.firstChild=next,next?next.previousSibling=previous:parentNode.lastChild=previous,_onUpdateChild(parentNode.ownerDocument,parentNode),child}function _insertBefore(parentNode,newChild,nextChild){var cp=newChild.parentNode;if(cp&&cp.removeChild(newChild),newChild.nodeType===DOCUMENT_FRAGMENT_NODE){var newFirst=newChild.firstChild;if(null==newFirst)return newChild;var newLast=newChild.lastChild}else newFirst=newLast=newChild;var pre=nextChild?nextChild.previousSibling:parentNode.lastChild;newFirst.previousSibling=pre,newLast.nextSibling=nextChild,pre?pre.nextSibling=newFirst:parentNode.firstChild=newFirst,null==nextChild?parentNode.lastChild=newLast:nextChild.previousSibling=newLast;do newFirst.parentNode=parentNode;while(newFirst!==newLast&&(newFirst=newFirst.nextSibling));return _onUpdateChild(parentNode.ownerDocument||parentNode,parentNode),newChild.nodeType==DOCUMENT_FRAGMENT_NODE&&(newChild.firstChild=newChild.lastChild=null),newChild}function _appendSingleChild(parentNode,newChild){var cp=newChild.parentNode;if(cp){var pre=parentNode.lastChild;cp.removeChild(newChild);var pre=parentNode.lastChild}var pre=parentNode.lastChild;return newChild.parentNode=parentNode,newChild.previousSibling=pre,newChild.nextSibling=null,pre?pre.nextSibling=newChild:parentNode.firstChild=newChild,parentNode.lastChild=newChild,_onUpdateChild(parentNode.ownerDocument,parentNode,newChild),newChild}function Element(){this._nsMap={}}function Attr(){}function CharacterData(){}function Text(){}function Comment(){}function CDATASection(){}function DocumentType(){}function Notation(){}function Entity(){}function EntityReference(){}function DocumentFragment(){}function ProcessingInstruction(){}function XMLSerializer(){}function serializeToString(node,buf,attributeSorter,isHTML){switch(node.nodeType){case ELEMENT_NODE:var attrs=node.attributes,len=attrs.length,child=node.firstChild,nodeName=node.tagName;isHTML=htmlns===node.namespaceURI||isHTML,buf.push("<",nodeName),attributeSorter&&buf.sort.apply(attrs,attributeSorter);for(var i=0;i<len;i++)serializeToString(attrs.item(i),buf,attributeSorter,isHTML);if(child||isHTML&&!/^(?:meta|link|img|br|hr|input|button)$/i.test(nodeName)){if(buf.push(">"),isHTML&&/^script$/i.test(nodeName))child&&buf.push(child.data);else for(;child;)serializeToString(child,buf,attributeSorter,isHTML),child=child.nextSibling;buf.push("</",nodeName,">")}else buf.push("/>");return;case DOCUMENT_NODE:case DOCUMENT_FRAGMENT_NODE:for(var child=node.firstChild;child;)serializeToString(child,buf,attributeSorter,isHTML),child=child.nextSibling;return;case ATTRIBUTE_NODE:return buf.push(" ",node.name,'="',node.value.replace(/[<&"]/g,_xmlEncoder),'"');case TEXT_NODE:return buf.push(node.data.replace(/[<&]/g,_xmlEncoder));case CDATA_SECTION_NODE:return buf.push("<![CDATA[",node.data,"]]>");case COMMENT_NODE:return buf.push("<!--",node.data,"-->");case DOCUMENT_TYPE_NODE:var pubid=node.publicId,sysid=node.systemId;if(buf.push("<!DOCTYPE ",node.name),pubid)buf.push(' PUBLIC "',pubid),sysid&&"."!=sysid&&buf.push('" "',sysid),buf.push('">');else if(sysid&&"."!=sysid)buf.push(' SYSTEM "',sysid,'">');else{var sub=node.internalSubset;sub&&buf.push(" [",sub,"]"),buf.push(">")}return;case PROCESSING_INSTRUCTION_NODE:return buf.push("<?",node.target," ",node.data,"?>");case ENTITY_REFERENCE_NODE:return buf.push("&",node.nodeName,";");default:buf.push("??",node.nodeName)}}function importNode(doc,node,deep){var node2;switch(node.nodeType){case ELEMENT_NODE:node2=node.cloneNode(!1),node2.ownerDocument=doc;case DOCUMENT_FRAGMENT_NODE:break;case ATTRIBUTE_NODE:deep=!0}if(node2||(node2=node.cloneNode(!1)),node2.ownerDocument=doc,node2.parentNode=null,deep)for(var child=node.firstChild;child;)node2.appendChild(importNode(doc,child,deep)),child=child.nextSibling;return node2}function cloneNode(doc,node,deep){var node2=new node.constructor;for(var n in node){var v=node[n];"object"!=typeof v&&v!=node2[n]&&(node2[n]=v)}switch(node.childNodes&&(node2.childNodes=new NodeList),node2.ownerDocument=doc,node2.nodeType){case ELEMENT_NODE:var attrs=node.attributes,attrs2=node2.attributes=new NamedNodeMap,len=attrs.length;attrs2._ownerElement=node2;for(var i=0;i<len;i++)node2.setAttributeNode(cloneNode(doc,attrs.item(i),!0));break;case ATTRIBUTE_NODE:deep=!0}if(deep)for(var child=node.firstChild;child;)node2.appendChild(cloneNode(doc,child,deep)),child=child.nextSibling;return node2}function __set__(object,key,value){object[key]=value}function getTextContent(node){switch(node.nodeType){case 1:case 11:var buf=[];for(node=node.firstChild;node;)7!==node.nodeType&&8!==node.nodeType&&buf.push(getTextContent(node)),node=node.nextSibling;return buf.join("");default:return node.nodeValue}}var htmlns="http://www.w3.org/1999/xhtml",NodeType={},ELEMENT_NODE=NodeType.ELEMENT_NODE=1,ATTRIBUTE_NODE=NodeType.ATTRIBUTE_NODE=2,TEXT_NODE=NodeType.TEXT_NODE=3,CDATA_SECTION_NODE=NodeType.CDATA_SECTION_NODE=4,ENTITY_REFERENCE_NODE=NodeType.ENTITY_REFERENCE_NODE=5,ENTITY_NODE=NodeType.ENTITY_NODE=6,PROCESSING_INSTRUCTION_NODE=NodeType.PROCESSING_INSTRUCTION_NODE=7,COMMENT_NODE=NodeType.COMMENT_NODE=8,DOCUMENT_NODE=NodeType.DOCUMENT_NODE=9,DOCUMENT_TYPE_NODE=NodeType.DOCUMENT_TYPE_NODE=10,DOCUMENT_FRAGMENT_NODE=NodeType.DOCUMENT_FRAGMENT_NODE=11,NOTATION_NODE=NodeType.NOTATION_NODE=12,ExceptionCode={},ExceptionMessage={},NOT_FOUND_ERR=(ExceptionCode.INDEX_SIZE_ERR=(ExceptionMessage[1]="Index size error",1),ExceptionCode.DOMSTRING_SIZE_ERR=(ExceptionMessage[2]="DOMString size error",2),ExceptionCode.HIERARCHY_REQUEST_ERR=(ExceptionMessage[3]="Hierarchy request error",3),ExceptionCode.WRONG_DOCUMENT_ERR=(ExceptionMessage[4]="Wrong document",4),ExceptionCode.INVALID_CHARACTER_ERR=(ExceptionMessage[5]="Invalid character",5),ExceptionCode.NO_DATA_ALLOWED_ERR=(ExceptionMessage[6]="No data allowed",6),ExceptionCode.NO_MODIFICATION_ALLOWED_ERR=(ExceptionMessage[7]="No modification allowed",7),ExceptionCode.NOT_FOUND_ERR=(ExceptionMessage[8]="Not found",8)),INUSE_ATTRIBUTE_ERR=(ExceptionCode.NOT_SUPPORTED_ERR=(ExceptionMessage[9]="Not supported",9),ExceptionCode.INUSE_ATTRIBUTE_ERR=(ExceptionMessage[10]="Attribute in use",10));ExceptionCode.INVALID_STATE_ERR=(ExceptionMessage[11]="Invalid state",11),ExceptionCode.SYNTAX_ERR=(ExceptionMessage[12]="Syntax error",12),ExceptionCode.INVALID_MODIFICATION_ERR=(ExceptionMessage[13]="Invalid modification",13),ExceptionCode.NAMESPACE_ERR=(ExceptionMessage[14]="Invalid namespace",14),ExceptionCode.INVALID_ACCESS_ERR=(ExceptionMessage[15]="Invalid access",15);DOMException.prototype=Error.prototype,copy(ExceptionCode,DOMException),NodeList.prototype={length:0,item:function(index){return this[index]||null},toString:function(){for(var buf=[],i=0;i<this.length;i++)serializeToString(this[i],buf);return buf.join("")}},LiveNodeList.prototype.item=function(i){return _updateLiveList(this),this[i]},_extends(LiveNodeList,NodeList),NamedNodeMap.prototype={length:0,item:NodeList.prototype.item,getNamedItem:function(key){for(var i=this.length;i--;){var attr=this[i];if(attr.nodeName==key)return attr}},setNamedItem:function(attr){var el=attr.ownerElement;if(el&&el!=this._ownerElement)throw new DOMException(INUSE_ATTRIBUTE_ERR);var oldAttr=this.getNamedItem(attr.nodeName);return _addNamedNode(this._ownerElement,this,attr,oldAttr),oldAttr},setNamedItemNS:function(attr){var oldAttr,el=attr.ownerElement;if(el&&el!=this._ownerElement)throw new DOMException(INUSE_ATTRIBUTE_ERR);return oldAttr=this.getNamedItemNS(attr.namespaceURI,attr.localName),_addNamedNode(this._ownerElement,this,attr,oldAttr),oldAttr},removeNamedItem:function(key){var attr=this.getNamedItem(key);return _removeNamedNode(this._ownerElement,this,attr),attr},removeNamedItemNS:function(namespaceURI,localName){var attr=this.getNamedItemNS(namespaceURI,localName);return _removeNamedNode(this._ownerElement,this,attr),attr},getNamedItemNS:function(namespaceURI,localName){for(var i=this.length;i--;){var node=this[i];if(node.localName==localName&&node.namespaceURI==namespaceURI)return node}return null}},DOMImplementation.prototype={hasFeature:function(feature,version){var versions=this._features[feature.toLowerCase()];return!(!versions||version&&!(version in versions))},createDocument:function(namespaceURI,qualifiedName,doctype){var doc=new Document;if(doc.implementation=this,doc.childNodes=new NodeList,doc.doctype=doctype,doctype&&doc.appendChild(doctype),qualifiedName){var root=doc.createElementNS(namespaceURI,qualifiedName);doc.appendChild(root)}return doc},createDocumentType:function(qualifiedName,publicId,systemId){var node=new DocumentType;return node.name=qualifiedName,node.nodeName=qualifiedName,node.publicId=publicId,node.systemId=systemId,node}},Node.prototype={firstChild:null,lastChild:null,previousSibling:null,nextSibling:null,attributes:null,parentNode:null,childNodes:null,ownerDocument:null,nodeValue:null,namespaceURI:null,prefix:null,localName:null,insertBefore:function(newChild,refChild){return _insertBefore(this,newChild,refChild)},replaceChild:function(newChild,oldChild){this.insertBefore(newChild,oldChild),oldChild&&this.removeChild(oldChild)},removeChild:function(oldChild){return _removeChild(this,oldChild)},appendChild:function(newChild){return this.insertBefore(newChild,null)},hasChildNodes:function(){return null!=this.firstChild},cloneNode:function(deep){return cloneNode(this.ownerDocument||this,this,deep)},normalize:function(){for(var child=this.firstChild;child;){var next=child.nextSibling;next&&next.nodeType==TEXT_NODE&&child.nodeType==TEXT_NODE?(this.removeChild(next),child.appendData(next.data)):(child.normalize(),child=next)}},isSupported:function(feature,version){return this.ownerDocument.implementation.hasFeature(feature,version)},hasAttributes:function(){return this.attributes.length>0},lookupPrefix:function(namespaceURI){for(var el=this;el;){var map=el._nsMap;if(map)for(var n in map)if(map[n]==namespaceURI)return n;el=2==el.nodeType?el.ownerDocument:el.parentNode}return null},lookupNamespaceURI:function(prefix){for(var el=this;el;){var map=el._nsMap;if(map&&prefix in map)return map[prefix];el=2==el.nodeType?el.ownerDocument:el.parentNode}return null},isDefaultNamespace:function(namespaceURI){var prefix=this.lookupPrefix(namespaceURI);return null==prefix}},copy(NodeType,Node),copy(NodeType,Node.prototype),Document.prototype={nodeName:"#document",nodeType:DOCUMENT_NODE,doctype:null,documentElement:null,_inc:1,insertBefore:function(newChild,refChild){if(newChild.nodeType==DOCUMENT_FRAGMENT_NODE){for(var child=newChild.firstChild;child;){var next=child.nextSibling;this.insertBefore(child,refChild),child=next}return newChild}return null==this.documentElement&&1==newChild.nodeType&&(this.documentElement=newChild),_insertBefore(this,newChild,refChild),newChild.ownerDocument=this,newChild},removeChild:function(oldChild){return this.documentElement==oldChild&&(this.documentElement=null),_removeChild(this,oldChild)},importNode:function(importedNode,deep){return importNode(this,importedNode,deep)},getElementById:function(id){var rtv=null;return _visitNode(this.documentElement,function(node){if(1==node.nodeType&&node.getAttribute("id")==id)return rtv=node,!0}),rtv},createElement:function(tagName){var node=new Element;node.ownerDocument=this,node.nodeName=tagName,node.tagName=tagName,node.childNodes=new NodeList;var attrs=node.attributes=new NamedNodeMap;return attrs._ownerElement=node,node},createDocumentFragment:function(){var node=new DocumentFragment;return node.ownerDocument=this,node.childNodes=new NodeList,node},createTextNode:function(data){var node=new Text;return node.ownerDocument=this,node.appendData(data),node},createComment:function(data){var node=new Comment;return node.ownerDocument=this,node.appendData(data),node},createCDATASection:function(data){var node=new CDATASection;return node.ownerDocument=this,node.appendData(data),node},createProcessingInstruction:function(target,data){var node=new ProcessingInstruction;return node.ownerDocument=this,node.tagName=node.target=target,node.nodeValue=node.data=data,node},createAttribute:function(name){var node=new Attr;return node.ownerDocument=this,node.name=name,node.nodeName=name,node.localName=name,node.specified=!0,node},createEntityReference:function(name){var node=new EntityReference;return node.ownerDocument=this,node.nodeName=name,node},createElementNS:function(namespaceURI,qualifiedName){var node=new Element,pl=qualifiedName.split(":"),attrs=node.attributes=new NamedNodeMap;return node.childNodes=new NodeList,node.ownerDocument=this,node.nodeName=qualifiedName,node.tagName=qualifiedName,node.namespaceURI=namespaceURI,2==pl.length?(node.prefix=pl[0],node.localName=pl[1]):node.localName=qualifiedName,attrs._ownerElement=node,node},createAttributeNS:function(namespaceURI,qualifiedName){var node=new Attr,pl=qualifiedName.split(":");return node.ownerDocument=this,node.nodeName=qualifiedName,node.name=qualifiedName,node.namespaceURI=namespaceURI,node.specified=!0,2==pl.length?(node.prefix=pl[0],node.localName=pl[1]):node.localName=qualifiedName,node}},_extends(Document,Node),Element.prototype={nodeType:ELEMENT_NODE,hasAttribute:function(name){return null!=this.getAttributeNode(name)},getAttribute:function(name){var attr=this.getAttributeNode(name);return attr&&attr.value||""},getAttributeNode:function(name){return this.attributes.getNamedItem(name)},setAttribute:function(name,value){var attr=this.ownerDocument.createAttribute(name);attr.value=attr.nodeValue=""+value,this.setAttributeNode(attr)},removeAttribute:function(name){var attr=this.getAttributeNode(name);attr&&this.removeAttributeNode(attr)},appendChild:function(newChild){return newChild.nodeType===DOCUMENT_FRAGMENT_NODE?this.insertBefore(newChild,null):_appendSingleChild(this,newChild)},setAttributeNode:function(newAttr){return this.attributes.setNamedItem(newAttr)},setAttributeNodeNS:function(newAttr){return this.attributes.setNamedItemNS(newAttr)},removeAttributeNode:function(oldAttr){return this.attributes.removeNamedItem(oldAttr.nodeName)},removeAttributeNS:function(namespaceURI,localName){var old=this.getAttributeNodeNS(namespaceURI,localName);old&&this.removeAttributeNode(old)},hasAttributeNS:function(namespaceURI,localName){return null!=this.getAttributeNodeNS(namespaceURI,localName)},getAttributeNS:function(namespaceURI,localName){var attr=this.getAttributeNodeNS(namespaceURI,localName);return attr&&attr.value||""},setAttributeNS:function(namespaceURI,qualifiedName,value){var attr=this.ownerDocument.createAttributeNS(namespaceURI,qualifiedName);attr.value=attr.nodeValue=""+value,this.setAttributeNode(attr)},getAttributeNodeNS:function(namespaceURI,localName){return this.attributes.getNamedItemNS(namespaceURI,localName)},getElementsByTagName:function(tagName){return new LiveNodeList(this,function(base){var ls=[];return _visitNode(base,function(node){node===base||node.nodeType!=ELEMENT_NODE||"*"!==tagName&&node.tagName!=tagName||ls.push(node)}),ls})},getElementsByTagNameNS:function(namespaceURI,localName){return new LiveNodeList(this,function(base){var ls=[];return _visitNode(base,function(node){node===base||node.nodeType!==ELEMENT_NODE||"*"!==namespaceURI&&node.namespaceURI!==namespaceURI||"*"!==localName&&node.localName!=localName||ls.push(node)}),ls})}},Document.prototype.getElementsByTagName=Element.prototype.getElementsByTagName,Document.prototype.getElementsByTagNameNS=Element.prototype.getElementsByTagNameNS,_extends(Element,Node),Attr.prototype.nodeType=ATTRIBUTE_NODE,_extends(Attr,Node),CharacterData.prototype={data:"",substringData:function(offset,count){return this.data.substring(offset,offset+count)},appendData:function(text){text=this.data+text,this.nodeValue=this.data=text,this.length=text.length},insertData:function(offset,text){this.replaceData(offset,0,text)},appendChild:function(newChild){throw new Error(ExceptionMessage[3])},deleteData:function(offset,count){this.replaceData(offset,count,"")},replaceData:function(offset,count,text){var start=this.data.substring(0,offset),end=this.data.substring(offset+count);text=start+text+end,this.nodeValue=this.data=text,this.length=text.length}},_extends(CharacterData,Node),Text.prototype={nodeName:"#text",nodeType:TEXT_NODE,splitText:function(offset){var text=this.data,newText=text.substring(offset);text=text.substring(0,offset),this.data=this.nodeValue=text,this.length=text.length;var newNode=this.ownerDocument.createTextNode(newText);return this.parentNode&&this.parentNode.insertBefore(newNode,this.nextSibling),newNode}},_extends(Text,CharacterData),Comment.prototype={nodeName:"#comment",nodeType:COMMENT_NODE},_extends(Comment,CharacterData),CDATASection.prototype={nodeName:"#cdata-section",nodeType:CDATA_SECTION_NODE},_extends(CDATASection,CharacterData),DocumentType.prototype.nodeType=DOCUMENT_TYPE_NODE,_extends(DocumentType,Node),Notation.prototype.nodeType=NOTATION_NODE,_extends(Notation,Node),Entity.prototype.nodeType=ENTITY_NODE,_extends(Entity,Node),EntityReference.prototype.nodeType=ENTITY_REFERENCE_NODE,_extends(EntityReference,Node),DocumentFragment.prototype.nodeName="#document-fragment",DocumentFragment.prototype.nodeType=DOCUMENT_FRAGMENT_NODE,_extends(DocumentFragment,Node),ProcessingInstruction.prototype.nodeType=PROCESSING_INSTRUCTION_NODE,_extends(ProcessingInstruction,Node),XMLSerializer.prototype.serializeToString=function(node,attributeSorter){return node.toString(attributeSorter)},Node.prototype.toString=function(attributeSorter){var buf=[];return serializeToString(this,buf,attributeSorter),buf.join("")};try{Object.defineProperty&&(Object.defineProperty(LiveNodeList.prototype,"length",{get:function(){return _updateLiveList(this),this.$$length}}),Object.defineProperty(Node.prototype,"textContent",{get:function(){return getTextContent(this)},set:function(data){switch(this.nodeType){case 1:case 11:for(;this.firstChild;)this.removeChild(this.firstChild);(data||String(data))&&this.appendChild(this.ownerDocument.createTextNode(data));break;default:this.data=data,this.value=value,this.nodeValue=data}}}),__set__=function(object,key,value){object["$$"+key]=value})}catch(e){}exports.DOMImplementation=DOMImplementation,exports.XMLSerializer=XMLSerializer},function(module,exports,__webpack_require__){(function(Buffer){function isArray(arg){return Array.isArray?Array.isArray(arg):"[object Array]"===objectToString(arg)}function isBoolean(arg){return"boolean"==typeof arg}function isNull(arg){return null===arg}function isNullOrUndefined(arg){return null==arg}function isNumber(arg){return"number"==typeof arg}function isString(arg){
return"string"==typeof arg}function isSymbol(arg){return"symbol"==typeof arg}function isUndefined(arg){return void 0===arg}function isRegExp(re){return"[object RegExp]"===objectToString(re)}function isObject(arg){return"object"==typeof arg&&null!==arg}function isDate(d){return"[object Date]"===objectToString(d)}function isError(e){return"[object Error]"===objectToString(e)||e instanceof Error}function isFunction(arg){return"function"==typeof arg}function isPrimitive(arg){return null===arg||"boolean"==typeof arg||"number"==typeof arg||"string"==typeof arg||"symbol"==typeof arg||"undefined"==typeof arg}function objectToString(o){return Object.prototype.toString.call(o)}exports.isArray=isArray,exports.isBoolean=isBoolean,exports.isNull=isNull,exports.isNullOrUndefined=isNullOrUndefined,exports.isNumber=isNumber,exports.isString=isString,exports.isSymbol=isSymbol,exports.isUndefined=isUndefined,exports.isRegExp=isRegExp,exports.isObject=isObject,exports.isDate=isDate,exports.isError=isError,exports.isFunction=isFunction,exports.isPrimitive=isPrimitive,exports.isBuffer=Buffer.isBuffer}).call(exports,__webpack_require__(92).Buffer)},function(module,exports,__webpack_require__){"function"!=typeof Number.isFinite&&(Number.isFinite=function(value){return"number"==typeof value&&(value===value&&value!==1/0&&value!==-(1/0))})},function(module,exports,__webpack_require__){(function(process){"use strict";function Report(parentOrOptions,reportOptions){this.parentReport=parentOrOptions instanceof Report?parentOrOptions:void 0,this.options=parentOrOptions instanceof Report?parentOrOptions.options:parentOrOptions||{},this.reportOptions=reportOptions||{},this.errors=[],this.path=[],this.asyncTasks=[]}var get=__webpack_require__(233),Errors=__webpack_require__(232),Utils=__webpack_require__(218);Report.prototype.isValid=function(){if(this.asyncTasks.length>0)throw new Error("Async tasks pending, can't answer isValid");return 0===this.errors.length},Report.prototype.addAsyncTask=function(fn,args,asyncTaskResultProcessFn){this.asyncTasks.push([fn,args,asyncTaskResultProcessFn])},Report.prototype.processAsyncTasks=function(timeout,callback){function finish(){process.nextTick(function(){var valid=0===self.errors.length,err=valid?void 0:self.errors;callback(err,valid)})}function respond(asyncTaskResultProcessFn){return function(asyncTaskResult){timedOut||(asyncTaskResultProcessFn(asyncTaskResult),0===--tasksCount&&finish())}}var validationTimeout=timeout||2e3,tasksCount=this.asyncTasks.length,idx=tasksCount,timedOut=!1,self=this;if(0===tasksCount||this.errors.length>0)return void finish();for(;idx--;){var task=this.asyncTasks[idx];task[0].apply(null,task[1].concat(respond(task[2])))}setTimeout(function(){tasksCount>0&&(timedOut=!0,self.addError("ASYNC_TIMEOUT",[tasksCount,validationTimeout]),callback(self.errors,!1))},validationTimeout)},Report.prototype.getPath=function(returnPathAsString){var path=[];return this.parentReport&&(path=path.concat(this.parentReport.path)),path=path.concat(this.path),returnPathAsString!==!0&&(path="#/"+path.map(function(segment){return Utils.isAbsoluteUri(segment)?"uri("+segment+")":segment.replace(/\~/g,"~0").replace(/\//g,"~1")}).join("/")),path},Report.prototype.getSchemaId=function(){if(!this.rootSchema)return null;var path=[];for(this.parentReport&&(path=path.concat(this.parentReport.path)),path=path.concat(this.path);path.length>0;){var obj=get(this.rootSchema,path);if(obj&&obj.id)return obj.id;path.pop()}return this.rootSchema.id},Report.prototype.hasError=function(errorCode,params){for(var idx=this.errors.length;idx--;)if(this.errors[idx].code===errorCode){for(var match=!0,idx2=this.errors[idx].params.length;idx2--;)this.errors[idx].params[idx2]!==params[idx2]&&(match=!1);if(match)return match}return!1},Report.prototype.addError=function(errorCode,params,subReports,schemaDescription){if(!errorCode)throw new Error("No errorCode passed into addError()");this.addCustomError(errorCode,Errors[errorCode],params,subReports,schemaDescription)},Report.prototype.addCustomError=function(errorCode,errorMessage,params,subReports,schemaDescription){if(!(this.errors.length>=this.reportOptions.maxErrors)){if(!errorMessage)throw new Error("No errorMessage known for code "+errorCode);params=params||[];for(var idx=params.length;idx--;){var whatIs=Utils.whatIs(params[idx]),param="object"===whatIs||"null"===whatIs?JSON.stringify(params[idx]):params[idx];errorMessage=errorMessage.replace("{"+idx+"}",param)}var err={code:errorCode,params:params,message:errorMessage,path:this.getPath(this.options.reportPathAsArray),schemaId:this.getSchemaId()};if(schemaDescription&&(err.description=schemaDescription),null!=subReports){for(Array.isArray(subReports)||(subReports=[subReports]),err.inner=[],idx=subReports.length;idx--;)for(var subReport=subReports[idx],idx2=subReport.errors.length;idx2--;)err.inner.push(subReport.errors[idx2]);0===err.inner.length&&(err.inner=void 0)}this.errors.push(err)}},module.exports=Report}).call(exports,__webpack_require__(59))},function(module,exports,__webpack_require__){var validator=__webpack_require__(257),FormatValidators={date:function(date){if("string"!=typeof date)return!0;var matches=/^([0-9]{4})-([0-9]{2})-([0-9]{2})$/.exec(date);return null!==matches&&!(matches[2]<"01"||matches[2]>"12"||matches[3]<"01"||matches[3]>"31")},"date-time":function(dateTime){if("string"!=typeof dateTime)return!0;var s=dateTime.toLowerCase().split("t");if(!FormatValidators.date(s[0]))return!1;var matches=/^([0-9]{2}):([0-9]{2}):([0-9]{2})(.[0-9]+)?(z|([+-][0-9]{2}:[0-9]{2}))$/.exec(s[1]);return null!==matches&&!(matches[1]>"23"||matches[2]>"59"||matches[3]>"59")},email:function(email){return"string"!=typeof email||validator.isEmail(email,{require_tld:!0})},hostname:function(hostname){if("string"!=typeof hostname)return!0;var valid=/^[a-zA-Z](([-0-9a-zA-Z]+)?[0-9a-zA-Z])?(\.[a-zA-Z](([-0-9a-zA-Z]+)?[0-9a-zA-Z])?)*$/.test(hostname);if(valid){if(hostname.length>255)return!1;for(var labels=hostname.split("."),i=0;i<labels.length;i++)if(labels[i].length>63)return!1}return valid},"host-name":function(hostname){return FormatValidators.hostname.call(this,hostname)},ipv4:function(ipv4){return"string"!=typeof ipv4||validator.isIP(ipv4,4)},ipv6:function(ipv6){return"string"!=typeof ipv6||validator.isIP(ipv6,6)},regex:function(str){try{return RegExp(str),!0}catch(e){return!1}},uri:function(uri){return this.options.strictUris?FormatValidators["strict-uri"].apply(this,arguments):"string"!=typeof uri||RegExp("^(([^:/?#]+):)?(//([^/?#]*))?([^?#]*)(\\?([^#]*))?(#(.*))?").test(uri)},"strict-uri":function(uri){return"string"!=typeof uri||validator.isURL(uri)}};module.exports=FormatValidators},function(module,exports,__webpack_require__){"use strict";var FormatValidators=__webpack_require__(213),Report=__webpack_require__(212),Utils=__webpack_require__(218),JsonValidators={multipleOf:function(report,schema,json){"number"==typeof json&&"integer"!==Utils.whatIs(json/schema.multipleOf)&&report.addError("MULTIPLE_OF",[json,schema.multipleOf],null,schema.description)},maximum:function(report,schema,json){"number"==typeof json&&(schema.exclusiveMaximum!==!0?json>schema.maximum&&report.addError("MAXIMUM",[json,schema.maximum],null,schema.description):json>=schema.maximum&&report.addError("MAXIMUM_EXCLUSIVE",[json,schema.maximum],null,schema.description))},exclusiveMaximum:function(){},minimum:function(report,schema,json){"number"==typeof json&&(schema.exclusiveMinimum!==!0?json<schema.minimum&&report.addError("MINIMUM",[json,schema.minimum],null,schema.description):json<=schema.minimum&&report.addError("MINIMUM_EXCLUSIVE",[json,schema.minimum],null,schema.description))},exclusiveMinimum:function(){},maxLength:function(report,schema,json){"string"==typeof json&&Utils.ucs2decode(json).length>schema.maxLength&&report.addError("MAX_LENGTH",[json.length,schema.maxLength],null,schema.description)},minLength:function(report,schema,json){"string"==typeof json&&Utils.ucs2decode(json).length<schema.minLength&&report.addError("MIN_LENGTH",[json.length,schema.minLength],null,schema.description)},pattern:function(report,schema,json){"string"==typeof json&&RegExp(schema.pattern).test(json)===!1&&report.addError("PATTERN",[schema.pattern,json],null,schema.description)},additionalItems:function(report,schema,json){Array.isArray(json)&&schema.additionalItems===!1&&Array.isArray(schema.items)&&json.length>schema.items.length&&report.addError("ARRAY_ADDITIONAL_ITEMS",null,null,schema.description)},items:function(){},maxItems:function(report,schema,json){Array.isArray(json)&&json.length>schema.maxItems&&report.addError("ARRAY_LENGTH_LONG",[json.length,schema.maxItems],null,schema.description)},minItems:function(report,schema,json){Array.isArray(json)&&json.length<schema.minItems&&report.addError("ARRAY_LENGTH_SHORT",[json.length,schema.minItems],null,schema.description)},uniqueItems:function(report,schema,json){if(Array.isArray(json)&&schema.uniqueItems===!0){var matches=[];Utils.isUniqueArray(json,matches)===!1&&report.addError("ARRAY_UNIQUE",matches,null,schema.description)}},maxProperties:function(report,schema,json){if("object"===Utils.whatIs(json)){var keysCount=Object.keys(json).length;keysCount>schema.maxProperties&&report.addError("OBJECT_PROPERTIES_MAXIMUM",[keysCount,schema.maxProperties],null,schema.description)}},minProperties:function(report,schema,json){if("object"===Utils.whatIs(json)){var keysCount=Object.keys(json).length;keysCount<schema.minProperties&&report.addError("OBJECT_PROPERTIES_MINIMUM",[keysCount,schema.minProperties],null,schema.description)}},required:function(report,schema,json){if("object"===Utils.whatIs(json))for(var idx=schema.required.length;idx--;){var requiredPropertyName=schema.required[idx];void 0===json[requiredPropertyName]&&report.addError("OBJECT_MISSING_REQUIRED_PROPERTY",[requiredPropertyName],null,schema.description)}},additionalProperties:function(report,schema,json){if(void 0===schema.properties&&void 0===schema.patternProperties)return JsonValidators.properties.call(this,report,schema,json)},patternProperties:function(report,schema,json){if(void 0===schema.properties)return JsonValidators.properties.call(this,report,schema,json)},properties:function(report,schema,json){if("object"===Utils.whatIs(json)){var properties=void 0!==schema.properties?schema.properties:{},patternProperties=void 0!==schema.patternProperties?schema.patternProperties:{};if(schema.additionalProperties===!1){var s=Object.keys(json),p=Object.keys(properties),pp=Object.keys(patternProperties);s=Utils.difference(s,p);for(var idx=pp.length;idx--;)for(var regExp=RegExp(pp[idx]),idx2=s.length;idx2--;)regExp.test(s[idx2])===!0&&s.splice(idx2,1);if(s.length>0){var idx3=this.options.assumeAdditional.length;if(idx3)for(;idx3--;){var io=s.indexOf(this.options.assumeAdditional[idx3]);io!==-1&&s.splice(io,1)}s.length>0&&report.addError("OBJECT_ADDITIONAL_PROPERTIES",[s],null,schema.description)}}}},dependencies:function(report,schema,json){if("object"===Utils.whatIs(json))for(var keys=Object.keys(schema.dependencies),idx=keys.length;idx--;){var dependencyName=keys[idx];if(json[dependencyName]){var dependencyDefinition=schema.dependencies[dependencyName];if("object"===Utils.whatIs(dependencyDefinition))exports.validate.call(this,report,dependencyDefinition,json);else for(var idx2=dependencyDefinition.length;idx2--;){var requiredPropertyName=dependencyDefinition[idx2];void 0===json[requiredPropertyName]&&report.addError("OBJECT_DEPENDENCY_KEY",[requiredPropertyName,dependencyName],null,schema.description)}}}},enum:function(report,schema,json){for(var match=!1,idx=schema.enum.length;idx--;)if(Utils.areEqual(json,schema.enum[idx])){match=!0;break}match===!1&&report.addError("ENUM_MISMATCH",[json],null,schema.description)},allOf:function(report,schema,json){for(var idx=schema.allOf.length;idx--;){var validateResult=exports.validate.call(this,report,schema.allOf[idx],json);if(this.options.breakOnFirstError&&validateResult===!1)break}},anyOf:function(report,schema,json){for(var subReports=[],passed=!1,idx=schema.anyOf.length;idx--&&passed===!1;){var subReport=new Report(report);subReports.push(subReport),passed=exports.validate.call(this,subReport,schema.anyOf[idx],json)}passed===!1&&report.addError("ANY_OF_MISSING",void 0,subReports,schema.description)},oneOf:function(report,schema,json){for(var passes=0,subReports=[],idx=schema.oneOf.length;idx--;){var subReport=new Report(report,{maxErrors:1});subReports.push(subReport),exports.validate.call(this,subReport,schema.oneOf[idx],json)===!0&&passes++}0===passes?report.addError("ONE_OF_MISSING",void 0,subReports,schema.description):passes>1&&report.addError("ONE_OF_MULTIPLE",null,null,schema.description)},not:function(report,schema,json){var subReport=new Report(report);exports.validate.call(this,subReport,schema.not,json)===!0&&report.addError("NOT_PASSED",null,null,schema.description)},definitions:function(){},format:function(report,schema,json){var formatValidatorFn=FormatValidators[schema.format];"function"==typeof formatValidatorFn?2===formatValidatorFn.length?report.addAsyncTask(formatValidatorFn,[json],function(result){result!==!0&&report.addError("INVALID_FORMAT",[schema.format,json],null,schema.description)}):formatValidatorFn.call(this,json)!==!0&&report.addError("INVALID_FORMAT",[schema.format,json],null,schema.description):this.options.ignoreUnknownFormats!==!0&&report.addError("UNKNOWN_FORMAT",[schema.format],null,schema.description)}},recurseArray=function(report,schema,json){var idx=json.length;if(Array.isArray(schema.items))for(;idx--;)idx<schema.items.length?(report.path.push(idx.toString()),exports.validate.call(this,report,schema.items[idx],json[idx]),report.path.pop()):"object"==typeof schema.additionalItems&&(report.path.push(idx.toString()),exports.validate.call(this,report,schema.additionalItems,json[idx]),report.path.pop());else if("object"==typeof schema.items)for(;idx--;)report.path.push(idx.toString()),exports.validate.call(this,report,schema.items,json[idx]),report.path.pop()},recurseObject=function(report,schema,json){var additionalProperties=schema.additionalProperties;additionalProperties!==!0&&void 0!==additionalProperties||(additionalProperties={});for(var p=schema.properties?Object.keys(schema.properties):[],pp=schema.patternProperties?Object.keys(schema.patternProperties):[],keys=Object.keys(json),idx=keys.length;idx--;){var m=keys[idx],propertyValue=json[m],s=[];p.indexOf(m)!==-1&&s.push(schema.properties[m]);for(var idx2=pp.length;idx2--;){var regexString=pp[idx2];RegExp(regexString).test(m)===!0&&s.push(schema.patternProperties[regexString])}for(0===s.length&&additionalProperties!==!1&&s.push(additionalProperties),idx2=s.length;idx2--;)report.path.push(m),exports.validate.call(this,report,s[idx2],propertyValue),report.path.pop()}};exports.validate=function(report,schema,json){report.commonErrorMessage="JSON_OBJECT_VALIDATION_FAILED";var to=Utils.whatIs(schema);if("object"!==to)return report.addError("SCHEMA_NOT_AN_OBJECT",[to],null,schema.description),!1;var keys=Object.keys(schema);if(0===keys.length)return!0;var isRoot=!1;if(report.rootSchema||(report.rootSchema=schema,isRoot=!0),void 0!==schema.$ref){for(var maxRefs=99;schema.$ref&&maxRefs>0;){if(!schema.__$refResolved){report.addError("REF_UNRESOLVED",[schema.$ref],null,schema.description);break}if(schema.__$refResolved===schema)break;schema=schema.__$refResolved,keys=Object.keys(schema),maxRefs--}if(0===maxRefs)throw new Error("Circular dependency by $ref references!")}var jsonType=Utils.whatIs(json);if(schema.type)if("string"==typeof schema.type){if(jsonType!==schema.type&&("integer"!==jsonType||"number"!==schema.type)&&(report.addError("INVALID_TYPE",[schema.type,jsonType],null,schema.description),this.options.breakOnFirstError))return!1}else if(schema.type.indexOf(jsonType)===-1&&("integer"!==jsonType||schema.type.indexOf("number")===-1)&&(report.addError("INVALID_TYPE",[schema.type,jsonType],null,schema.description),this.options.breakOnFirstError))return!1;for(var idx=keys.length;idx--&&!(JsonValidators[keys[idx]]&&(JsonValidators[keys[idx]].call(this,report,schema,json),report.errors.length&&this.options.breakOnFirstError)););return 0!==report.errors.length&&this.options.breakOnFirstError!==!1||("array"===jsonType?recurseArray.call(this,report,schema,json):"object"===jsonType&&recurseObject.call(this,report,schema,json)),"function"==typeof this.options.customValidator&&this.options.customValidator(report,schema,json),isRoot&&(report.rootSchema=void 0),0===report.errors.length}},function(module,exports,__webpack_require__){"use strict";function decodeJSONPointer(str){return decodeURIComponent(str).replace(/~[0-1]/g,function(x){return"~1"===x?"/":"~"})}function getRemotePath(uri){var io=uri.indexOf("#");return io===-1?uri:uri.slice(0,io)}function getQueryPath(uri){var io=uri.indexOf("#"),res=io===-1?void 0:uri.slice(io+1);return res}function findId(schema,id){if("object"==typeof schema&&null!==schema){if(!id)return schema;if(schema.id&&(schema.id===id||"#"===schema.id[0]&&schema.id.substring(1)===id))return schema;var idx,result;if(Array.isArray(schema)){for(idx=schema.length;idx--;)if(result=findId(schema[idx],id))return result}else{var keys=Object.keys(schema);for(idx=keys.length;idx--;){var k=keys[idx];if(0!==k.indexOf("__$")&&(result=findId(schema[k],id)))return result}}}}var Report=__webpack_require__(212),SchemaCompilation=__webpack_require__(216),SchemaValidation=__webpack_require__(217),Utils=__webpack_require__(218);exports.cacheSchemaByUri=function(uri,schema){var remotePath=getRemotePath(uri);remotePath&&(this.cache[remotePath]=schema)},exports.removeFromCacheByUri=function(uri){var remotePath=getRemotePath(uri);remotePath&&delete this.cache[remotePath]},exports.checkCacheForUri=function(uri){var remotePath=getRemotePath(uri);return!!remotePath&&null!=this.cache[remotePath]},exports.getSchema=function(report,schema){return"object"==typeof schema&&(schema=exports.getSchemaByReference.call(this,report,schema)),"string"==typeof schema&&(schema=exports.getSchemaByUri.call(this,report,schema)),schema},exports.getSchemaByReference=function(report,key){for(var i=this.referenceCache.length;i--;)if(this.referenceCache[i][0]===key)return this.referenceCache[i][1];var schema=Utils.cloneDeep(key);return this.referenceCache.push([key,schema]),schema},exports.getSchemaByUri=function(report,uri,root){var remotePath=getRemotePath(uri),queryPath=getQueryPath(uri),result=remotePath?this.cache[remotePath]:root;if(result&&remotePath){var compileRemote=result!==root;if(compileRemote){report.path.push(remotePath);var remoteReport=new Report(report);SchemaCompilation.compileSchema.call(this,remoteReport,result)&&SchemaValidation.validateSchema.call(this,remoteReport,result);var remoteReportIsValid=remoteReport.isValid();if(remoteReportIsValid||report.addError("REMOTE_NOT_VALID",[uri],remoteReport),report.path.pop(),!remoteReportIsValid)return}}if(result&&queryPath)for(var parts=queryPath.split("/"),idx=0,lim=parts.length;result&&idx<lim;idx++){var key=decodeJSONPointer(parts[idx]);result=0===idx?findId(result,key):result[key]}return result},exports.getRemotePath=getRemotePath},function(module,exports,__webpack_require__){"use strict";function mergeReference(scope,ref){if(Utils.isAbsoluteUri(ref))return ref;var toRemove,joinedScope=scope.join(""),isScopeAbsolute=Utils.isAbsoluteUri(joinedScope),isScopeRelative=Utils.isRelativeUri(joinedScope),isRefRelative=Utils.isRelativeUri(ref);isScopeAbsolute&&isRefRelative?(toRemove=joinedScope.match(/\/[^\/]*$/),toRemove&&(joinedScope=joinedScope.slice(0,toRemove.index+1))):isScopeRelative&&isRefRelative?joinedScope="":(toRemove=joinedScope.match(/[^#\/]+$/),toRemove&&(joinedScope=joinedScope.slice(0,toRemove.index)));var res=joinedScope+ref;return res=res.replace(/##/,"#")}function collectReferences(obj,results,scope,path){if(results=results||[],scope=scope||[],path=path||[],"object"!=typeof obj||null===obj)return results;"string"==typeof obj.id&&scope.push(obj.id),"string"==typeof obj.$ref&&"undefined"==typeof obj.__$refResolved&&results.push({ref:mergeReference(scope,obj.$ref),key:"$ref",obj:obj,path:path.slice(0)}),"string"==typeof obj.$schema&&"undefined"==typeof obj.__$schemaResolved&&results.push({ref:mergeReference(scope,obj.$schema),key:"$schema",obj:obj,path:path.slice(0)});var idx;if(Array.isArray(obj))for(idx=obj.length;idx--;)path.push(idx.toString()),collectReferences(obj[idx],results,scope,path),path.pop();else{var keys=Object.keys(obj);for(idx=keys.length;idx--;)0!==keys[idx].indexOf("__$")&&(path.push(keys[idx]),collectReferences(obj[keys[idx]],results,scope,path),path.pop())}return"string"==typeof obj.id&&scope.pop(),results}function findId(arr,id){for(var idx=arr.length;idx--;)if(arr[idx].id===id)return arr[idx];return null}var Report=__webpack_require__(212),SchemaCache=__webpack_require__(215),Utils=__webpack_require__(218),compileArrayOfSchemasLoop=function(mainReport,arr){for(var idx=arr.length,compiledCount=0;idx--;){var report=new Report(mainReport),isValid=exports.compileSchema.call(this,report,arr[idx]);isValid&&compiledCount++,mainReport.errors=mainReport.errors.concat(report.errors)}return compiledCount},compileArrayOfSchemas=function(report,arr){var lastLoopCompiled,compiled=0;do{for(var idx=report.errors.length;idx--;)"UNRESOLVABLE_REFERENCE"===report.errors[idx].code&&report.errors.splice(idx,1);for(lastLoopCompiled=compiled,compiled=compileArrayOfSchemasLoop.call(this,report,arr),idx=arr.length;idx--;){var sch=arr[idx];if(sch.__$missingReferences){for(var idx2=sch.__$missingReferences.length;idx2--;){var refObj=sch.__$missingReferences[idx2],response=findId(arr,refObj.ref);response&&(refObj.obj["__"+refObj.key+"Resolved"]=response,sch.__$missingReferences.splice(idx2,1))}0===sch.__$missingReferences.length&&delete sch.__$missingReferences}}}while(compiled!==arr.length&&compiled!==lastLoopCompiled);return report.isValid()};exports.compileSchema=function(report,schema){if(report.commonErrorMessage="SCHEMA_COMPILATION_FAILED","string"==typeof schema){var loadedSchema=SchemaCache.getSchemaByUri.call(this,report,schema);if(!loadedSchema)return report.addError("SCHEMA_NOT_REACHABLE",[schema]),!1;schema=loadedSchema}if(Array.isArray(schema))return compileArrayOfSchemas.call(this,report,schema);if(schema.__$compiled&&schema.id&&SchemaCache.checkCacheForUri.call(this,schema.id)===!1&&(schema.__$compiled=void 0),schema.__$compiled)return!0;schema.id&&"string"==typeof schema.id&&SchemaCache.cacheSchemaByUri.call(this,schema.id,schema);var isRoot=!1;report.rootSchema||(report.rootSchema=schema,isRoot=!0);var isValidExceptReferences=report.isValid();delete schema.__$missingReferences;for(var refs=collectReferences.call(this,schema),idx=refs.length;idx--;){var refObj=refs[idx],response=SchemaCache.getSchemaByUri.call(this,report,refObj.ref,schema);if(!response){var schemaReader=this.getSchemaReader();if(schemaReader){var s=schemaReader(refObj.ref);if(s){s.id=refObj.ref;var subreport=new Report(report);exports.compileSchema.call(this,subreport,s)?response=SchemaCache.getSchemaByUri.call(this,report,refObj.ref,schema):report.errors=report.errors.concat(subreport.errors)}}}if(!response){var hasNotValid=report.hasError("REMOTE_NOT_VALID",[refObj.ref]),isAbsolute=Utils.isAbsoluteUri(refObj.ref),isDownloaded=!1,ignoreUnresolvableRemotes=this.options.ignoreUnresolvableReferences===!0;isAbsolute&&(isDownloaded=SchemaCache.checkCacheForUri.call(this,refObj.ref)),hasNotValid||ignoreUnresolvableRemotes&&isAbsolute||isDownloaded||(Array.prototype.push.apply(report.path,refObj.path),report.addError("UNRESOLVABLE_REFERENCE",[refObj.ref]),report.path=report.path.slice(0,-refObj.path.length),isValidExceptReferences&&(schema.__$missingReferences=schema.__$missingReferences||[],schema.__$missingReferences.push(refObj)))}refObj.obj["__"+refObj.key+"Resolved"]=response}var isValid=report.isValid();return isValid?schema.__$compiled=!0:schema.id&&"string"==typeof schema.id&&SchemaCache.removeFromCacheByUri.call(this,schema.id),isRoot&&(report.rootSchema=void 0),isValid}},function(module,exports,__webpack_require__){"use strict";var FormatValidators=__webpack_require__(213),JsonValidation=__webpack_require__(214),Report=__webpack_require__(212),Utils=__webpack_require__(218),SchemaValidators={$ref:function(report,schema){"string"!=typeof schema.$ref&&report.addError("KEYWORD_TYPE_EXPECTED",["$ref","string"])},$schema:function(report,schema){"string"!=typeof schema.$schema&&report.addError("KEYWORD_TYPE_EXPECTED",["$schema","string"])},multipleOf:function(report,schema){"number"!=typeof schema.multipleOf?report.addError("KEYWORD_TYPE_EXPECTED",["multipleOf","number"]):schema.multipleOf<=0&&report.addError("KEYWORD_MUST_BE",["multipleOf","strictly greater than 0"])},maximum:function(report,schema){"number"!=typeof schema.maximum&&report.addError("KEYWORD_TYPE_EXPECTED",["maximum","number"])},exclusiveMaximum:function(report,schema){"boolean"!=typeof schema.exclusiveMaximum?report.addError("KEYWORD_TYPE_EXPECTED",["exclusiveMaximum","boolean"]):void 0===schema.maximum&&report.addError("KEYWORD_DEPENDENCY",["exclusiveMaximum","maximum"])},minimum:function(report,schema){"number"!=typeof schema.minimum&&report.addError("KEYWORD_TYPE_EXPECTED",["minimum","number"])},exclusiveMinimum:function(report,schema){"boolean"!=typeof schema.exclusiveMinimum?report.addError("KEYWORD_TYPE_EXPECTED",["exclusiveMinimum","boolean"]):void 0===schema.minimum&&report.addError("KEYWORD_DEPENDENCY",["exclusiveMinimum","minimum"])},maxLength:function(report,schema){"integer"!==Utils.whatIs(schema.maxLength)?report.addError("KEYWORD_TYPE_EXPECTED",["maxLength","integer"]):schema.maxLength<0&&report.addError("KEYWORD_MUST_BE",["maxLength","greater than, or equal to 0"])},minLength:function(report,schema){"integer"!==Utils.whatIs(schema.minLength)?report.addError("KEYWORD_TYPE_EXPECTED",["minLength","integer"]):schema.minLength<0&&report.addError("KEYWORD_MUST_BE",["minLength","greater than, or equal to 0"])},pattern:function(report,schema){if("string"!=typeof schema.pattern)report.addError("KEYWORD_TYPE_EXPECTED",["pattern","string"]);else try{RegExp(schema.pattern)}catch(e){report.addError("KEYWORD_PATTERN",["pattern",schema.pattern])}},additionalItems:function(report,schema){var type=Utils.whatIs(schema.additionalItems);"boolean"!==type&&"object"!==type?report.addError("KEYWORD_TYPE_EXPECTED",["additionalItems",["boolean","object"]]):"object"===type&&(report.path.push("additionalItems"),exports.validateSchema.call(this,report,schema.additionalItems),report.path.pop())},items:function(report,schema){var type=Utils.whatIs(schema.items);if("object"===type)report.path.push("items"),exports.validateSchema.call(this,report,schema.items),report.path.pop();else if("array"===type)for(var idx=schema.items.length;idx--;)report.path.push("items"),report.path.push(idx.toString()),exports.validateSchema.call(this,report,schema.items[idx]),report.path.pop(),report.path.pop();else report.addError("KEYWORD_TYPE_EXPECTED",["items",["array","object"]]);this.options.forceAdditional===!0&&void 0===schema.additionalItems&&Array.isArray(schema.items)&&report.addError("KEYWORD_UNDEFINED_STRICT",["additionalItems"]),this.options.assumeAdditional&&void 0===schema.additionalItems&&Array.isArray(schema.items)&&(schema.additionalItems=!1)},maxItems:function(report,schema){"number"!=typeof schema.maxItems?report.addError("KEYWORD_TYPE_EXPECTED",["maxItems","integer"]):schema.maxItems<0&&report.addError("KEYWORD_MUST_BE",["maxItems","greater than, or equal to 0"])},minItems:function(report,schema){"integer"!==Utils.whatIs(schema.minItems)?report.addError("KEYWORD_TYPE_EXPECTED",["minItems","integer"]):schema.minItems<0&&report.addError("KEYWORD_MUST_BE",["minItems","greater than, or equal to 0"])},uniqueItems:function(report,schema){"boolean"!=typeof schema.uniqueItems&&report.addError("KEYWORD_TYPE_EXPECTED",["uniqueItems","boolean"])},maxProperties:function(report,schema){"integer"!==Utils.whatIs(schema.maxProperties)?report.addError("KEYWORD_TYPE_EXPECTED",["maxProperties","integer"]):schema.maxProperties<0&&report.addError("KEYWORD_MUST_BE",["maxProperties","greater than, or equal to 0"])},minProperties:function(report,schema){"integer"!==Utils.whatIs(schema.minProperties)?report.addError("KEYWORD_TYPE_EXPECTED",["minProperties","integer"]):schema.minProperties<0&&report.addError("KEYWORD_MUST_BE",["minProperties","greater than, or equal to 0"])},required:function(report,schema){if("array"!==Utils.whatIs(schema.required))report.addError("KEYWORD_TYPE_EXPECTED",["required","array"]);else if(0===schema.required.length)report.addError("KEYWORD_MUST_BE",["required","an array with at least one element"]);else{for(var idx=schema.required.length;idx--;)"string"!=typeof schema.required[idx]&&report.addError("KEYWORD_VALUE_TYPE",["required","string"]);Utils.isUniqueArray(schema.required)===!1&&report.addError("KEYWORD_MUST_BE",["required","an array with unique items"])}},additionalProperties:function(report,schema){var type=Utils.whatIs(schema.additionalProperties);"boolean"!==type&&"object"!==type?report.addError("KEYWORD_TYPE_EXPECTED",["additionalProperties",["boolean","object"]]):"object"===type&&(report.path.push("additionalProperties"),exports.validateSchema.call(this,report,schema.additionalProperties),report.path.pop())},properties:function(report,schema){if("object"!==Utils.whatIs(schema.properties))return void report.addError("KEYWORD_TYPE_EXPECTED",["properties","object"]);for(var keys=Object.keys(schema.properties),idx=keys.length;idx--;){var key=keys[idx],val=schema.properties[key];report.path.push("properties"),report.path.push(key),exports.validateSchema.call(this,report,val),report.path.pop(),report.path.pop()}this.options.forceAdditional===!0&&void 0===schema.additionalProperties&&report.addError("KEYWORD_UNDEFINED_STRICT",["additionalProperties"]),this.options.assumeAdditional&&void 0===schema.additionalProperties&&(schema.additionalProperties=!1),this.options.forceProperties===!0&&0===keys.length&&report.addError("CUSTOM_MODE_FORCE_PROPERTIES",["properties"])},patternProperties:function(report,schema){if("object"!==Utils.whatIs(schema.patternProperties))return void report.addError("KEYWORD_TYPE_EXPECTED",["patternProperties","object"]);for(var keys=Object.keys(schema.patternProperties),idx=keys.length;idx--;){var key=keys[idx],val=schema.patternProperties[key];try{RegExp(key)}catch(e){report.addError("KEYWORD_PATTERN",["patternProperties",key])}report.path.push("patternProperties"),report.path.push(key.toString()),exports.validateSchema.call(this,report,val),report.path.pop(),report.path.pop()}this.options.forceProperties===!0&&0===keys.length&&report.addError("CUSTOM_MODE_FORCE_PROPERTIES",["patternProperties"])},dependencies:function(report,schema){if("object"!==Utils.whatIs(schema.dependencies))report.addError("KEYWORD_TYPE_EXPECTED",["dependencies","object"]);else for(var keys=Object.keys(schema.dependencies),idx=keys.length;idx--;){var schemaKey=keys[idx],schemaDependency=schema.dependencies[schemaKey],type=Utils.whatIs(schemaDependency);if("object"===type)report.path.push("dependencies"),report.path.push(schemaKey),exports.validateSchema.call(this,report,schemaDependency),report.path.pop(),report.path.pop();else if("array"===type){var idx2=schemaDependency.length;for(0===idx2&&report.addError("KEYWORD_MUST_BE",["dependencies","not empty array"]);idx2--;)"string"!=typeof schemaDependency[idx2]&&report.addError("KEYWORD_VALUE_TYPE",["dependensices","string"]);Utils.isUniqueArray(schemaDependency)===!1&&report.addError("KEYWORD_MUST_BE",["dependencies","an array with unique items"])}else report.addError("KEYWORD_VALUE_TYPE",["dependencies","object or array"])}},enum:function(report,schema){Array.isArray(schema.enum)===!1?report.addError("KEYWORD_TYPE_EXPECTED",["enum","array"]):0===schema.enum.length?report.addError("KEYWORD_MUST_BE",["enum","an array with at least one element"]):Utils.isUniqueArray(schema.enum)===!1&&report.addError("KEYWORD_MUST_BE",["enum","an array with unique elements"]);
},type:function(report,schema){var primitiveTypes=["array","boolean","integer","number","null","object","string"],primitiveTypeStr=primitiveTypes.join(","),isArray=Array.isArray(schema.type);if(isArray){for(var idx=schema.type.length;idx--;)primitiveTypes.indexOf(schema.type[idx])===-1&&report.addError("KEYWORD_TYPE_EXPECTED",["type",primitiveTypeStr]);Utils.isUniqueArray(schema.type)===!1&&report.addError("KEYWORD_MUST_BE",["type","an object with unique properties"])}else"string"==typeof schema.type?primitiveTypes.indexOf(schema.type)===-1&&report.addError("KEYWORD_TYPE_EXPECTED",["type",primitiveTypeStr]):report.addError("KEYWORD_TYPE_EXPECTED",["type",["string","array"]]);this.options.noEmptyStrings===!0&&("string"===schema.type||isArray&&schema.type.indexOf("string")!==-1)&&void 0===schema.minLength&&void 0===schema.enum&&void 0===schema.format&&(schema.minLength=1),this.options.noEmptyArrays===!0&&("array"===schema.type||isArray&&schema.type.indexOf("array")!==-1)&&void 0===schema.minItems&&(schema.minItems=1),this.options.forceProperties===!0&&("object"===schema.type||isArray&&schema.type.indexOf("object")!==-1)&&void 0===schema.properties&&void 0===schema.patternProperties&&report.addError("KEYWORD_UNDEFINED_STRICT",["properties"]),this.options.forceItems===!0&&("array"===schema.type||isArray&&schema.type.indexOf("array")!==-1)&&void 0===schema.items&&report.addError("KEYWORD_UNDEFINED_STRICT",["items"]),this.options.forceMinItems===!0&&("array"===schema.type||isArray&&schema.type.indexOf("array")!==-1)&&void 0===schema.minItems&&report.addError("KEYWORD_UNDEFINED_STRICT",["minItems"]),this.options.forceMaxItems===!0&&("array"===schema.type||isArray&&schema.type.indexOf("array")!==-1)&&void 0===schema.maxItems&&report.addError("KEYWORD_UNDEFINED_STRICT",["maxItems"]),this.options.forceMinLength===!0&&("string"===schema.type||isArray&&schema.type.indexOf("string")!==-1)&&void 0===schema.minLength&&void 0===schema.format&&void 0===schema.enum&&void 0===schema.pattern&&report.addError("KEYWORD_UNDEFINED_STRICT",["minLength"]),this.options.forceMaxLength===!0&&("string"===schema.type||isArray&&schema.type.indexOf("string")!==-1)&&void 0===schema.maxLength&&void 0===schema.format&&void 0===schema.enum&&void 0===schema.pattern&&report.addError("KEYWORD_UNDEFINED_STRICT",["maxLength"])},allOf:function(report,schema){if(Array.isArray(schema.allOf)===!1)report.addError("KEYWORD_TYPE_EXPECTED",["allOf","array"]);else if(0===schema.allOf.length)report.addError("KEYWORD_MUST_BE",["allOf","an array with at least one element"]);else for(var idx=schema.allOf.length;idx--;)report.path.push("allOf"),report.path.push(idx.toString()),exports.validateSchema.call(this,report,schema.allOf[idx]),report.path.pop(),report.path.pop()},anyOf:function(report,schema){if(Array.isArray(schema.anyOf)===!1)report.addError("KEYWORD_TYPE_EXPECTED",["anyOf","array"]);else if(0===schema.anyOf.length)report.addError("KEYWORD_MUST_BE",["anyOf","an array with at least one element"]);else for(var idx=schema.anyOf.length;idx--;)report.path.push("anyOf"),report.path.push(idx.toString()),exports.validateSchema.call(this,report,schema.anyOf[idx]),report.path.pop(),report.path.pop()},oneOf:function(report,schema){if(Array.isArray(schema.oneOf)===!1)report.addError("KEYWORD_TYPE_EXPECTED",["oneOf","array"]);else if(0===schema.oneOf.length)report.addError("KEYWORD_MUST_BE",["oneOf","an array with at least one element"]);else for(var idx=schema.oneOf.length;idx--;)report.path.push("oneOf"),report.path.push(idx.toString()),exports.validateSchema.call(this,report,schema.oneOf[idx]),report.path.pop(),report.path.pop()},not:function(report,schema){"object"!==Utils.whatIs(schema.not)?report.addError("KEYWORD_TYPE_EXPECTED",["not","object"]):(report.path.push("not"),exports.validateSchema.call(this,report,schema.not),report.path.pop())},definitions:function(report,schema){if("object"!==Utils.whatIs(schema.definitions))report.addError("KEYWORD_TYPE_EXPECTED",["definitions","object"]);else for(var keys=Object.keys(schema.definitions),idx=keys.length;idx--;){var key=keys[idx],val=schema.definitions[key];report.path.push("definitions"),report.path.push(key),exports.validateSchema.call(this,report,val),report.path.pop(),report.path.pop()}},format:function(report,schema){"string"!=typeof schema.format?report.addError("KEYWORD_TYPE_EXPECTED",["format","string"]):void 0===FormatValidators[schema.format]&&this.options.ignoreUnknownFormats!==!0&&report.addError("UNKNOWN_FORMAT",[schema.format])},id:function(report,schema){"string"!=typeof schema.id&&report.addError("KEYWORD_TYPE_EXPECTED",["id","string"])},title:function(report,schema){"string"!=typeof schema.title&&report.addError("KEYWORD_TYPE_EXPECTED",["title","string"])},description:function(report,schema){"string"!=typeof schema.description&&report.addError("KEYWORD_TYPE_EXPECTED",["description","string"])},default:function(){}},validateArrayOfSchemas=function(report,arr){for(var idx=arr.length;idx--;)exports.validateSchema.call(this,report,arr[idx]);return report.isValid()};exports.validateSchema=function(report,schema){if(report.commonErrorMessage="SCHEMA_VALIDATION_FAILED",Array.isArray(schema))return validateArrayOfSchemas.call(this,report,schema);if(schema.__$validated)return!0;var hasParentSchema=schema.$schema&&schema.id!==schema.$schema;if(hasParentSchema)if(schema.__$schemaResolved&&schema.__$schemaResolved!==schema){var subReport=new Report(report),valid=JsonValidation.validate.call(this,subReport,schema.__$schemaResolved,schema);valid===!1&&report.addError("PARENT_SCHEMA_VALIDATION_FAILED",null,subReport)}else this.options.ignoreUnresolvableReferences!==!0&&report.addError("REF_UNRESOLVED",[schema.$schema]);if(this.options.noTypeless===!0){if(void 0!==schema.type){var schemas=[];Array.isArray(schema.anyOf)&&(schemas=schemas.concat(schema.anyOf)),Array.isArray(schema.oneOf)&&(schemas=schemas.concat(schema.oneOf)),Array.isArray(schema.allOf)&&(schemas=schemas.concat(schema.allOf)),schemas.forEach(function(sch){sch.type||(sch.type=schema.type)})}void 0===schema.enum&&void 0===schema.type&&void 0===schema.anyOf&&void 0===schema.oneOf&&void 0===schema.not&&void 0===schema.$ref&&report.addError("KEYWORD_UNDEFINED_STRICT",["type"])}for(var keys=Object.keys(schema),idx=keys.length;idx--;){var key=keys[idx];0!==key.indexOf("__")&&(void 0!==SchemaValidators[key]?SchemaValidators[key].call(this,report,schema):hasParentSchema||this.options.noExtraKeywords===!0&&report.addError("KEYWORD_UNEXPECTED",[key]))}if(this.options.pedanticCheck===!0){if(schema.enum){var tmpSchema=Utils.clone(schema);for(delete tmpSchema.enum,delete tmpSchema.default,report.path.push("enum"),idx=schema.enum.length;idx--;)report.path.push(idx.toString()),JsonValidation.validate.call(this,report,tmpSchema,schema.enum[idx]),report.path.pop();report.path.pop()}schema.default&&(report.path.push("default"),JsonValidation.validate.call(this,report,schema,schema.default),report.path.pop())}var isValid=report.isValid();return isValid&&(schema.__$validated=!0),isValid}},function(module,exports,__webpack_require__){"use strict";exports.isAbsoluteUri=function(uri){return/^https?:\/\//.test(uri)},exports.isRelativeUri=function(uri){return/.+#/.test(uri)},exports.whatIs=function(what){var to=typeof what;return"object"===to?null===what?"null":Array.isArray(what)?"array":"object":"number"===to?Number.isFinite(what)?what%1===0?"integer":"number":Number.isNaN(what)?"not-a-number":"unknown-number":to},exports.areEqual=function areEqual(json1,json2){if(json1===json2)return!0;var i,len;if(Array.isArray(json1)&&Array.isArray(json2)){if(json1.length!==json2.length)return!1;for(len=json1.length,i=0;i<len;i++)if(!areEqual(json1[i],json2[i]))return!1;return!0}if("object"===exports.whatIs(json1)&&"object"===exports.whatIs(json2)){var keys1=Object.keys(json1),keys2=Object.keys(json2);if(!areEqual(keys1,keys2))return!1;for(len=keys1.length,i=0;i<len;i++)if(!areEqual(json1[keys1[i]],json2[keys1[i]]))return!1;return!0}return!1},exports.isUniqueArray=function(arr,indexes){var i,j,l=arr.length;for(i=0;i<l;i++)for(j=i+1;j<l;j++)if(exports.areEqual(arr[i],arr[j]))return indexes&&indexes.push(i,j),!1;return!0},exports.difference=function(bigSet,subSet){for(var arr=[],idx=bigSet.length;idx--;)subSet.indexOf(bigSet[idx])===-1&&arr.push(bigSet[idx]);return arr},exports.clone=function(src){if("undefined"!=typeof src){if("object"!=typeof src||null===src)return src;var res,idx;if(Array.isArray(src))for(res=[],idx=src.length;idx--;)res[idx]=src[idx];else{res={};var keys=Object.keys(src);for(idx=keys.length;idx--;){var key=keys[idx];res[key]=src[key]}}return res}},exports.cloneDeep=function(src){function cloneDeep(src){if("object"!=typeof src||null===src)return src;var res,idx,cidx;if(cidx=visited.indexOf(src),cidx!==-1)return cloned[cidx];if(visited.push(src),Array.isArray(src))for(res=[],cloned.push(res),idx=src.length;idx--;)res[idx]=cloneDeep(src[idx]);else{res={},cloned.push(res);var keys=Object.keys(src);for(idx=keys.length;idx--;){var key=keys[idx];res[key]=cloneDeep(src[key])}}return res}var visited=[],cloned=[];return cloneDeep(src)},exports.ucs2decode=function(string){for(var value,extra,output=[],counter=0,length=string.length;counter<length;)value=string.charCodeAt(counter++),value>=55296&&value<=56319&&counter<length?(extra=string.charCodeAt(counter++),56320==(64512&extra)?output.push(((1023&value)<<10)+(1023&extra)+65536):(output.push(value),counter--)):output.push(value);return output}},function(module,exports,__webpack_require__){"use strict";var hexTable=function(){for(var array=new Array(256),i=0;i<256;++i)array[i]="%"+((i<16?"0":"")+i.toString(16)).toUpperCase();return array}();exports.arrayToObject=function(source,options){for(var obj=options.plainObjects?Object.create(null):{},i=0;i<source.length;++i)"undefined"!=typeof source[i]&&(obj[i]=source[i]);return obj},exports.merge=function(target,source,options){if(!source)return target;if("object"!=typeof source){if(Array.isArray(target))target.push(source);else{if("object"!=typeof target)return[target,source];target[source]=!0}return target}if("object"!=typeof target)return[target].concat(source);var mergeTarget=target;return Array.isArray(target)&&!Array.isArray(source)&&(mergeTarget=exports.arrayToObject(target,options)),Object.keys(source).reduce(function(acc,key){var value=source[key];return Object.prototype.hasOwnProperty.call(acc,key)?acc[key]=exports.merge(acc[key],value,options):acc[key]=value,acc},mergeTarget)},exports.decode=function(str){try{return decodeURIComponent(str.replace(/\+/g," "))}catch(e){return str}},exports.encode=function(str){if(0===str.length)return str;for(var string="string"==typeof str?str:String(str),out="",i=0;i<string.length;++i){var c=string.charCodeAt(i);45===c||46===c||95===c||126===c||c>=48&&c<=57||c>=65&&c<=90||c>=97&&c<=122?out+=string.charAt(i):c<128?out+=hexTable[c]:c<2048?out+=hexTable[192|c>>6]+hexTable[128|63&c]:c<55296||c>=57344?out+=hexTable[224|c>>12]+hexTable[128|c>>6&63]+hexTable[128|63&c]:(i+=1,c=65536+((1023&c)<<10|1023&string.charCodeAt(i)),out+=hexTable[240|c>>18]+hexTable[128|c>>12&63]+hexTable[128|c>>6&63]+hexTable[128|63&c])}return out},exports.compact=function(obj,references){if("object"!=typeof obj||null===obj)return obj;var refs=references||[],lookup=refs.indexOf(obj);if(lookup!==-1)return refs[lookup];if(refs.push(obj),Array.isArray(obj)){for(var compacted=[],i=0;i<obj.length;++i)"undefined"!=typeof obj[i]&&compacted.push(obj[i]);return compacted}for(var keys=Object.keys(obj),j=0;j<keys.length;++j){var key=keys[j];obj[key]=exports.compact(obj[key],refs)}return obj},exports.isRegExp=function(obj){return"[object RegExp]"===Object.prototype.toString.call(obj)},exports.isBuffer=function(obj){return null!==obj&&"undefined"!=typeof obj&&!!(obj.constructor&&obj.constructor.isBuffer&&obj.constructor.isBuffer(obj))}},function(module,exports,__webpack_require__){(function(process){exports=module.exports=__webpack_require__(252),exports.Stream=__webpack_require__(169),exports.Readable=exports,exports.Writable=__webpack_require__(251),exports.Duplex=__webpack_require__(253),exports.Transform=__webpack_require__(254),exports.PassThrough=__webpack_require__(255),process.browser||"disable"!==process.env.READABLE_STREAM||(module.exports=__webpack_require__(169))}).call(exports,__webpack_require__(59))},function(module,exports,__webpack_require__){module.exports=__webpack_require__(251)},function(module,exports,__webpack_require__){module.exports=__webpack_require__(253)},function(module,exports,__webpack_require__){module.exports=__webpack_require__(254)},function(module,exports,__webpack_require__){module.exports=__webpack_require__(255)},function(module,exports,__webpack_require__){"function"==typeof Object.create?module.exports=function(ctor,superCtor){ctor.super_=superCtor,ctor.prototype=Object.create(superCtor.prototype,{constructor:{value:ctor,enumerable:!1,writable:!0,configurable:!0}})}:module.exports=function(ctor,superCtor){ctor.super_=superCtor;var TempCtor=function(){};TempCtor.prototype=superCtor.prototype,ctor.prototype=new TempCtor,ctor.prototype.constructor=ctor}},function(module,exports,__webpack_require__){function webpackContext(req){return __webpack_require__(webpackContextResolve(req))}function webpackContextResolve(req){return map[req]||function(){throw new Error("Cannot find module '"+req+"'.")}()}var map={"./ar":237,"./ar.js":237,"./bn":238,"./bn.js":238,"./de":239,"./de.js":239,"./es":240,"./es.js":240,"./fr":241,"./fr.js":241,"./hi":242,"./hi.js":242,"./it":243,"./it.js":243,"./ja":244,"./ja.js":244,"./ko":245,"./ko.js":245,"./pt":246,"./pt.js":246,"./ru":247,"./ru.js":247,"./zh-cn":248,"./zh-cn.js":248,"./zh-tw":249,"./zh-tw.js":249};webpackContext.id=226,webpackContext.keys=function(){return Object.keys(map)},webpackContext.resolve=webpackContextResolve,module.exports=webpackContext},function(module,exports,__webpack_require__){"use strict";var Type=__webpack_require__(179);module.exports=new Type("tag:yaml.org,2002:str",{kind:"scalar",construct:function(data){return null!==data?data:""}})},function(module,exports,__webpack_require__){"use strict";var Type=__webpack_require__(179);module.exports=new Type("tag:yaml.org,2002:seq",{kind:"sequence",construct:function(data){return null!==data?data:[]}})},function(module,exports,__webpack_require__){"use strict";var Type=__webpack_require__(179);module.exports=new Type("tag:yaml.org,2002:map",{kind:"mapping",construct:function(data){return null!==data?data:{}}})},function(module,exports,__webpack_require__){(function(){"use strict";var xml2js;xml2js=__webpack_require__(207),exports.stripBOM=function(str){return"\ufeff"===str[0]?str.substring(1):str}}).call(this)},function(module,exports,__webpack_require__){(function(){"use strict";var prefixMatch;prefixMatch=new RegExp(/(?!xmlns)^.*:/),exports.normalize=function(str){return str.toLowerCase()},exports.firstCharLowerCase=function(str){return str.charAt(0).toLowerCase()+str.slice(1)},exports.stripPrefix=function(str){return str.replace(prefixMatch,"")},exports.parseNumbers=function(str){return isNaN(str)||(str=str%1===0?parseInt(str,10):parseFloat(str)),str},exports.parseBooleans=function(str){return/^(?:true|false)$/i.test(str)&&(str="true"===str.toLowerCase()),str}}).call(this)},function(module,exports,__webpack_require__){"use strict";module.exports={INVALID_TYPE:"Expected type {0} but found type {1}",INVALID_FORMAT:"Object didn't pass validation for format {0}: {1}",ENUM_MISMATCH:"No enum match for: {0}",ANY_OF_MISSING:"Data does not match any schemas from 'anyOf'",ONE_OF_MISSING:"Data does not match any schemas from 'oneOf'",ONE_OF_MULTIPLE:"Data is valid against more than one schema from 'oneOf'",NOT_PASSED:"Data matches schema from 'not'",ARRAY_LENGTH_SHORT:"Array is too short ({0}), minimum {1}",ARRAY_LENGTH_LONG:"Array is too long ({0}), maximum {1}",ARRAY_UNIQUE:"Array items are not unique (indexes {0} and {1})",ARRAY_ADDITIONAL_ITEMS:"Additional items not allowed",MULTIPLE_OF:"Value {0} is not a multiple of {1}",MINIMUM:"Value {0} is less than minimum {1}",MINIMUM_EXCLUSIVE:"Value {0} is equal or less than exclusive minimum {1}",MAXIMUM:"Value {0} is greater than maximum {1}",MAXIMUM_EXCLUSIVE:"Value {0} is equal or greater than exclusive maximum {1}",OBJECT_PROPERTIES_MINIMUM:"Too few properties defined ({0}), minimum {1}",OBJECT_PROPERTIES_MAXIMUM:"Too many properties defined ({0}), maximum {1}",OBJECT_MISSING_REQUIRED_PROPERTY:"Missing required property: {0}",OBJECT_ADDITIONAL_PROPERTIES:"Additional properties not allowed: {0}",OBJECT_DEPENDENCY_KEY:"Dependency failed - key must exist: {0} (due to key: {1})",MIN_LENGTH:"String is too short ({0} chars), minimum {1}",MAX_LENGTH:"String is too long ({0} chars), maximum {1}",PATTERN:"String does not match pattern {0}: {1}",KEYWORD_TYPE_EXPECTED:"Keyword '{0}' is expected to be of type '{1}'",KEYWORD_UNDEFINED_STRICT:"Keyword '{0}' must be defined in strict mode",KEYWORD_UNEXPECTED:"Keyword '{0}' is not expected to appear in the schema",KEYWORD_MUST_BE:"Keyword '{0}' must be {1}",KEYWORD_DEPENDENCY:"Keyword '{0}' requires keyword '{1}'",KEYWORD_PATTERN:"Keyword '{0}' is not a valid RegExp pattern: {1}",KEYWORD_VALUE_TYPE:"Each element of keyword '{0}' array must be a '{1}'",UNKNOWN_FORMAT:"There is no validation function for format '{0}'",CUSTOM_MODE_FORCE_PROPERTIES:"{0} must define at least one property if present",REF_UNRESOLVED:"Reference has not been resolved during compilation: {0}",UNRESOLVABLE_REFERENCE:"Reference could not be resolved: {0}",SCHEMA_NOT_REACHABLE:"Validator was not able to read schema with uri: {0}",SCHEMA_TYPE_EXPECTED:"Schema is expected to be of type 'object'",SCHEMA_NOT_AN_OBJECT:"Schema is not an object: {0}",ASYNC_TIMEOUT:"{0} asynchronous task(s) have timed out after {1} ms",PARENT_SCHEMA_VALIDATION_FAILED:"Schema failed to validate against its parent schema, see inner errors for details.",REMOTE_NOT_VALID:"Remote reference didn't compile successfully: {0}"}},function(module,exports,__webpack_require__){function baseGet(object,path){path=isKey(path,object)?[path]:castPath(path);for(var index=0,length=path.length;null!=object&&index<length;)object=object[path[index++]];return index&&index==length?object:void 0}function castPath(value){return isArray(value)?value:stringToPath(value)}function isKey(value,object){var type=typeof value;return"number"==type||"symbol"==type||!isArray(value)&&(isSymbol(value)||reIsPlainProp.test(value)||!reIsDeepProp.test(value)||null!=object&&value in Object(object))}function isObjectLike(value){return!!value&&"object"==typeof value}function isSymbol(value){return"symbol"==typeof value||isObjectLike(value)&&objectToString.call(value)==symbolTag}function get(object,path,defaultValue){var result=null==object?void 0:baseGet(object,path);return void 0===result?defaultValue:result}var stringToPath=__webpack_require__(262),symbolTag="[object Symbol]",reIsDeepProp=/\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,reIsPlainProp=/^\w*$/,objectProto=Object.prototype,objectToString=objectProto.toString,isArray=Array.isArray;module.exports=get},function(module,exports,__webpack_require__){(function(global){"use strict";function rawAsap(task){queue.length||(requestFlush(),flushing=!0),queue[queue.length]=task}function flush(){for(;index<queue.length;){var currentIndex=index;if(index+=1,queue[currentIndex].call(),index>capacity){for(var scan=0,newLength=queue.length-index;scan<newLength;scan++)queue[scan]=queue[scan+index];queue.length-=index,index=0}}queue.length=0,index=0,flushing=!1}function makeRequestCallFromMutationObserver(callback){var toggle=1,observer=new BrowserMutationObserver(callback),node=document.createTextNode("");return observer.observe(node,{characterData:!0}),function(){toggle=-toggle,node.data=toggle}}function makeRequestCallFromTimer(callback){return function(){function handleTimer(){clearTimeout(timeoutHandle),clearInterval(intervalHandle),callback()}var timeoutHandle=setTimeout(handleTimer,0),intervalHandle=setInterval(handleTimer,50)}}module.exports=rawAsap;var requestFlush,queue=[],flushing=!1,index=0,capacity=1024,BrowserMutationObserver=global.MutationObserver||global.WebKitMutationObserver;requestFlush="function"==typeof BrowserMutationObserver?makeRequestCallFromMutationObserver(flush):makeRequestCallFromTimer(flush),rawAsap.requestFlush=requestFlush,rawAsap.makeRequestCallFromTimer=makeRequestCallFromTimer}).call(exports,function(){return this}())},function(module,exports,__webpack_require__){module.exports={id:"http://json-schema.org/draft-04/schema#",$schema:"http://json-schema.org/draft-04/schema#",description:"Core schema meta-schema",definitions:{schemaArray:{type:"array",minItems:1,items:{$ref:"#"}},positiveInteger:{type:"integer",minimum:0},positiveIntegerDefault0:{allOf:[{$ref:"#/definitions/positiveInteger"},{default:0}]},simpleTypes:{enum:["array","boolean","integer","null","number","object","string"]},stringArray:{type:"array",items:{type:"string"},minItems:1,uniqueItems:!0}},type:"object",properties:{id:{type:"string",format:"uri"},$schema:{type:"string",format:"uri"},title:{type:"string"},description:{type:"string"},default:{},multipleOf:{type:"number",minimum:0,exclusiveMinimum:!0},maximum:{type:"number"},exclusiveMaximum:{type:"boolean",default:!1},minimum:{type:"number"},exclusiveMinimum:{type:"boolean",default:!1},maxLength:{$ref:"#/definitions/positiveInteger"},minLength:{$ref:"#/definitions/positiveIntegerDefault0"},pattern:{type:"string",format:"regex"},additionalItems:{anyOf:[{type:"boolean"},{$ref:"#"}],default:{}},items:{anyOf:[{$ref:"#"},{$ref:"#/definitions/schemaArray"}],default:{}},maxItems:{$ref:"#/definitions/positiveInteger"},minItems:{$ref:"#/definitions/positiveIntegerDefault0"},uniqueItems:{type:"boolean",default:!1},maxProperties:{$ref:"#/definitions/positiveInteger"},minProperties:{$ref:"#/definitions/positiveIntegerDefault0"},required:{$ref:"#/definitions/stringArray"},additionalProperties:{anyOf:[{type:"boolean"},{$ref:"#"}],default:{}},definitions:{type:"object",additionalProperties:{$ref:"#"},default:{}},properties:{type:"object",additionalProperties:{$ref:"#"},default:{}},patternProperties:{type:"object",additionalProperties:{$ref:"#"},default:{}},dependencies:{type:"object",additionalProperties:{anyOf:[{$ref:"#"},{$ref:"#/definitions/stringArray"}]}},enum:{type:"array",minItems:1,uniqueItems:!0},type:{anyOf:[{$ref:"#/definitions/simpleTypes"},{type:"array",items:{$ref:"#/definitions/simpleTypes"},minItems:1,uniqueItems:!0}]},format:{type:"string"},allOf:{$ref:"#/definitions/schemaArray"},anyOf:{$ref:"#/definitions/schemaArray"},oneOf:{$ref:"#/definitions/schemaArray"},not:{$ref:"#"}},dependencies:{exclusiveMaximum:["maximum"],exclusiveMinimum:["minimum"]},default:{}}},function(module,exports,__webpack_require__){module.exports={$schema:"http://json-schema.org/draft-04/hyper-schema#",id:"http://json-schema.org/draft-04/hyper-schema#",title:"JSON Hyper-Schema",allOf:[{$ref:"http://json-schema.org/draft-04/schema#"}],properties:{additionalItems:{anyOf:[{type:"boolean"},{$ref:"#"}]},additionalProperties:{anyOf:[{type:"boolean"},{$ref:"#"}]},dependencies:{additionalProperties:{anyOf:[{$ref:"#"},{type:"array"}]}},items:{anyOf:[{$ref:"#"},{$ref:"#/definitions/schemaArray"}]},definitions:{additionalProperties:{$ref:"#"}},patternProperties:{additionalProperties:{$ref:"#"}},properties:{additionalProperties:{$ref:"#"}},allOf:{$ref:"#/definitions/schemaArray"},anyOf:{$ref:"#/definitions/schemaArray"},oneOf:{$ref:"#/definitions/schemaArray"},not:{$ref:"#"},links:{type:"array",items:{$ref:"#/definitions/linkDescription"}},fragmentResolution:{type:"string"},media:{type:"object",properties:{type:{description:"A media type, as described in RFC 2046",type:"string"},binaryEncoding:{description:"A content encoding scheme, as described in RFC 2045",type:"string"}}},pathStart:{description:"Instances' URIs must start with this value for this schema to apply to them",type:"string",format:"uri"}},definitions:{schemaArray:{type:"array",items:{$ref:"#"}},linkDescription:{title:"Link Description Object",type:"object",required:["href","rel"],properties:{href:{description:"a URI template, as defined by RFC 6570, with the addition of the $, ( and ) characters for pre-processing",type:"string"},rel:{description:"relation to the target resource of the link",type:"string"},title:{description:"a title for the link",type:"string"},targetSchema:{description:"JSON Schema describing the link target",$ref:"#"},mediaType:{description:"media type (as defined by RFC 2046) describing the link target",type:"string"},method:{description:'method for requesting the target of the link (e.g. for HTTP this might be "GET" or "DELETE")',type:"string"},encType:{description:"The media type in which to submit data along with the request",type:"string",default:"application/json"},schema:{description:"Schema describing the data to submit along with the request",$ref:"#"}}}}}},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_FACTORY__,__WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__;!function(global){"use strict";var locale=function(date){var num=["٠","١","٢","٣","٤","٥","٦","٧","٨","٩"],map={"٠":0,"١":1,"٢":2,"٣":3,"٤":4,"٥":5,"٦":6,"٧":7,"٨":8,"٩":9};date.setLocales("ar",{MMMM:["كانون الثاني يناير","شباط فبراير","آذار مارس","نيسان أبريل","أيار مايو","حزيران يونيو","تموز يوليو","آب أغسطس","أيلول سبتمبر","تشرين الأول أكتوبر","تشرين الثاني نوفمبر","كانون الأول ديسمبر"],MMM:["كانون الثاني يناير","شباط فبراير","آذار مارس","نيسان أبريل","أيار مايو","حزيران يونيو","تموز يوليو","آب أغسطس","أيلول سبتمبر","تشرين الأول أكتوبر","تشرين الثاني نوفمبر","كانون الأول ديسمبر"],dddd:["الأحد","الإثنين","الثلاثاء","الأربعاء","الخميس","الجمعة","السبت"],ddd:["أحد","إثنين","ثلاثاء","أربعاء","خميس","جمعة","سبت"],dd:["ح","ن","ث","ر","خ","ج","س"],A:["ص","م"],formats:{post:function(str){return str.replace(/\d/g,function(i){return num[0|i]})}},parsers:{pre:function(str){return str.replace(/[٠١٢٣٤٥٦٧٨٩]/g,function(i){return""+map[i]})}}})};"object"==typeof module&&"object"==typeof module.exports?locale(__webpack_require__(199)):(__WEBPACK_AMD_DEFINE_ARRAY__=[__webpack_require__(199)],__WEBPACK_AMD_DEFINE_FACTORY__=locale,__WEBPACK_AMD_DEFINE_RESULT__="function"==typeof __WEBPACK_AMD_DEFINE_FACTORY__?__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__):__WEBPACK_AMD_DEFINE_FACTORY__,!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__)))}(this)},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_FACTORY__,__WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__;!function(global){"use strict";var locale=function(date){date.setLocales("bn",{MMMM:["জানুয়ারী","ফেবুয়ারী","মার্চ","এপ্রিল","মে","জুন","জুলাই","অগাস্ট","সেপ্টেম্বর","অক্টোবর","নভেম্বর","ডিসেম্বর"],MMM:["জানু","ফেব","মার্চ","এপর","মে","জুন","জুল","অগ","সেপ্ট","অক্টো","নভ","ডিসেম্"],dddd:["রবিবার","সোমবার","মঙ্গলবার","বুধবার","বৃহস্পত্তিবার","শুক্রবার","শনিবার"],ddd:["রবি","সোম","মঙ্গল","বুধ","বৃহস্পত্তি","শুক্র","শনি"],dd:["রব","সম","মঙ্গ","বু","ব্রিহ","শু","শনি"],A:["রাত","সকাল","দুপুর","বিকাল"],formats:{A:function(d){var h=d.getHours();return h<4?this.A[0]:h<10?this.A[1]:h<17?this.A[2]:h<20?this.A[3]:this.A[0]}},parsers:{h:function(h,a){return a<1?h<4||h>11?h:h+12:a<2?h:a<3&&h>9?h:h+12}}})};"object"==typeof module&&"object"==typeof module.exports?locale(__webpack_require__(199)):(__WEBPACK_AMD_DEFINE_ARRAY__=[__webpack_require__(199)],__WEBPACK_AMD_DEFINE_FACTORY__=locale,__WEBPACK_AMD_DEFINE_RESULT__="function"==typeof __WEBPACK_AMD_DEFINE_FACTORY__?__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__):__WEBPACK_AMD_DEFINE_FACTORY__,!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__)))}(this)},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_FACTORY__,__WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__;!function(global){"use strict";var locale=function(date){date.setLocales("de",{MMMM:["Januar","Februar","März","April","Mai","Juni","Juli","August","September","Oktober","November","Dezember"],MMM:["Jan.","Febr.","Mrz.","Apr.","Mai","Jun.","Jul.","Aug.","Sept.","Okt.","Nov.","Dez."],dddd:["Sonntag","Montag","Dienstag","Mittwoch","Donnerstag","Freitag","Samstag"],ddd:["So.","Mo.","Di.","Mi.","Do.","Fr.","Sa."],dd:["So","Mo","Di","Mi","Do","Fr","Sa"],A:["Uhr nachmittags","Uhr morgens"]})};"object"==typeof module&&"object"==typeof module.exports?locale(__webpack_require__(199)):(__WEBPACK_AMD_DEFINE_ARRAY__=[__webpack_require__(199)],__WEBPACK_AMD_DEFINE_FACTORY__=locale,__WEBPACK_AMD_DEFINE_RESULT__="function"==typeof __WEBPACK_AMD_DEFINE_FACTORY__?__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__):__WEBPACK_AMD_DEFINE_FACTORY__,!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__)))}(this)},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_FACTORY__,__WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__;!function(global){"use strict";var locale=function(date){date.setLocales("es",{MMMM:["enero","febrero","marzo","abril","mayo","junio","julio","agosto","septiembre","octubre","noviembre","diciembre"],MMM:["ene.","feb.","mar.","abr.","may.","jun.","jul.","ago.","sep.","oct.","nov.","dic."],dddd:["domingo","lunes","martes","miércoles","jueves","viernes","sábado"],ddd:["dom.","lun.","mar.","mié.","jue.","vie.","sáb."],dd:["do","lu","ma","mi","ju","vi","sá"],A:["de la mañana","de la tarde","de la noche"],formats:{A:function(d){var h=d.getHours();return h<12?this.A[0]:h<19?this.A[1]:this.A[2]}},parsers:{h:function(h,a){return a<1?h:h>11?h:h+12}}})};"object"==typeof module&&"object"==typeof module.exports?locale(__webpack_require__(199)):(__WEBPACK_AMD_DEFINE_ARRAY__=[__webpack_require__(199)],__WEBPACK_AMD_DEFINE_FACTORY__=locale,__WEBPACK_AMD_DEFINE_RESULT__="function"==typeof __WEBPACK_AMD_DEFINE_FACTORY__?__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__):__WEBPACK_AMD_DEFINE_FACTORY__,!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__)))}(this)},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_FACTORY__,__WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__;!function(global){"use strict";var locale=function(date){date.setLocales("fr",{MMMM:["janvier","février","mars","avril","mai","juin","juillet","août","septembre","octobre","novembre","décembre"],MMM:["janv.","févr.","mars","avr.","mai","juin","juil.","août","sept.","oct.","nov.","déc."],dddd:["dimanche","lundi","mardi","mercredi","jeudi","vendredi","samedi"],ddd:["dim.","lun.","mar.","mer.","jeu.","ven.","sam."],dd:["Di","Lu","Ma","Me","Je","Ve","Sa"],A:["matin","l'après-midi"]})};"object"==typeof module&&"object"==typeof module.exports?locale(__webpack_require__(199)):(__WEBPACK_AMD_DEFINE_ARRAY__=[__webpack_require__(199)],__WEBPACK_AMD_DEFINE_FACTORY__=locale,__WEBPACK_AMD_DEFINE_RESULT__="function"==typeof __WEBPACK_AMD_DEFINE_FACTORY__?__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__):__WEBPACK_AMD_DEFINE_FACTORY__,!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__)))}(this)},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_FACTORY__,__WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__;!function(global){"use strict";var locale=function(date){date.setLocales("hi",{MMMM:["जनवरी","फ़रवरी","मार्च","अप्रैल","मई","जून","जुलाई","अगस्त","सितम्बर","अक्टूबर","नवम्बर","दिसम्बर"],MMM:["जन.","फ़र.","मार्च","अप्रै.","मई","जून","जुल.","अग.","सित.","अक्टू.","नव.","दिस."],dddd:["रविवार","सोमवार","मंगलवार","बुधवार","गुरूवार","शुक्रवार","शनिवार"],ddd:["रवि","सोम","मंगल","बुध","गुरू","शुक्र","शनि"],dd:["र","सो","मं","बु","गु","शु","श"],A:["रात","सुबह","दोपहर","शाम"],formats:{A:function(d){var h=d.getHours();
return h<4?this.A[0]:h<10?this.A[1]:h<17?this.A[2]:h<20?this.A[3]:this.A[0]}},parsers:{h:function(h,a){return a<1?h<4||h>11?h:h+12:a<2?h:a<3&&h>9?h:h+12}}})};"object"==typeof module&&"object"==typeof module.exports?locale(__webpack_require__(199)):(__WEBPACK_AMD_DEFINE_ARRAY__=[__webpack_require__(199)],__WEBPACK_AMD_DEFINE_FACTORY__=locale,__WEBPACK_AMD_DEFINE_RESULT__="function"==typeof __WEBPACK_AMD_DEFINE_FACTORY__?__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__):__WEBPACK_AMD_DEFINE_FACTORY__,!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__)))}(this)},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_FACTORY__,__WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__;!function(global){"use strict";var locale=function(date){date.setLocales("it",{MMMM:["gennaio","febbraio","marzo","aprile","maggio","giugno","luglio","agosto","settembre","ottobre","novembre","dicembre"],MMM:["gen","feb","mar","apr","mag","giu","lug","ago","set","ott","nov","dic"],dddd:["Domenica","Lunedì","Martedì","Mercoledì","Giovedì","Venerdì","Sabato"],ddd:["Dom","Lun","Mar","Mer","Gio","Ven","Sab"],dd:["Do","Lu","Ma","Me","Gi","Ve","Sa"],A:["di mattina","di pomerrigio"]})};"object"==typeof module&&"object"==typeof module.exports?locale(__webpack_require__(199)):(__WEBPACK_AMD_DEFINE_ARRAY__=[__webpack_require__(199)],__WEBPACK_AMD_DEFINE_FACTORY__=locale,__WEBPACK_AMD_DEFINE_RESULT__="function"==typeof __WEBPACK_AMD_DEFINE_FACTORY__?__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__):__WEBPACK_AMD_DEFINE_FACTORY__,!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__)))}(this)},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_FACTORY__,__WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__;!function(global){"use strict";var locale=function(date){date.setLocales("ja",{MMMM:["1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"],MMM:["1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"],dddd:["日曜日","月曜日","火曜日","水曜日","木曜日","金曜日","土曜日"],ddd:["日","月","火","水","木","金","土"],dd:["日","月","火","水","木","金","土"],A:["午前","午後"],formats:{hh:function(d){return("0"+d.getHours()%12).slice(-2)},h:function(d){return d.getHours()%12}}})};"object"==typeof module&&"object"==typeof module.exports?locale(__webpack_require__(199)):(__WEBPACK_AMD_DEFINE_ARRAY__=[__webpack_require__(199)],__WEBPACK_AMD_DEFINE_FACTORY__=locale,__WEBPACK_AMD_DEFINE_RESULT__="function"==typeof __WEBPACK_AMD_DEFINE_FACTORY__?__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__):__WEBPACK_AMD_DEFINE_FACTORY__,!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__)))}(this)},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_FACTORY__,__WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__;!function(global){"use strict";var locale=function(date){date.setLocales("ko",{MMMM:["1월","2월","3월","4월","5월","6월","7월","8월","9월","10월","11월","12월"],MMM:["1월","2월","3월","4월","5월","6월","7월","8월","9월","10월","11월","12월"],dddd:["일요일","월요일","화요일","수요일","목요일","금요일","토요일"],ddd:["일","월","화","수","목","금","토"],dd:["일","월","화","수","목","금","토"],A:["오전","오후"]})};"object"==typeof module&&"object"==typeof module.exports?locale(__webpack_require__(199)):(__WEBPACK_AMD_DEFINE_ARRAY__=[__webpack_require__(199)],__WEBPACK_AMD_DEFINE_FACTORY__=locale,__WEBPACK_AMD_DEFINE_RESULT__="function"==typeof __WEBPACK_AMD_DEFINE_FACTORY__?__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__):__WEBPACK_AMD_DEFINE_FACTORY__,!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__)))}(this)},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_FACTORY__,__WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__;!function(global){"use strict";var locale=function(date){date.setLocales("pt",{MMMM:["Janeiro","Fevereiro","Março","Abril","Maio","Junho","Julho","Agosto","Setembro","Outubro","Novembro","Dezembro"],MMM:["Jan","Fev","Mar","Abr","Mai","Jun","Jul","Ago","Set","Out","Nov","Dez"],dddd:["Domingo","Segunda-Feira","Terça-Feira","Quarta-Feira","Quinta-Feira","Sexta-Feira","Sábado"],ddd:["Dom","Seg","Ter","Qua","Qui","Sex","Sáb"],dd:["Dom","2ª","3ª","4ª","5ª","6ª","Sáb"],A:["da madrugada","da manhã","da tarde","da noite"],formats:{A:function(d){var h=d.getHours();return h<5?this.A[0]:h<12?this.A[1]:h<19?this.A[2]:this.A[3]}},parsers:{h:function(h,a){return a<2?h:h>11?h:h+12}}})};"object"==typeof module&&"object"==typeof module.exports?locale(__webpack_require__(199)):(__WEBPACK_AMD_DEFINE_ARRAY__=[__webpack_require__(199)],__WEBPACK_AMD_DEFINE_FACTORY__=locale,__WEBPACK_AMD_DEFINE_RESULT__="function"==typeof __WEBPACK_AMD_DEFINE_FACTORY__?__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__):__WEBPACK_AMD_DEFINE_FACTORY__,!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__)))}(this)},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_FACTORY__,__WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__;!function(global){"use strict";var locale=function(date){date.setLocales("ru",{MMMM:["Января","Февраля","Марта","Апреля","Мая","Июня","Июля","Августа","Сентября","Октября","Ноября","Декабря"],MMM:["янв","фев","мар","апр","мая","июня","июля","авг","сен","окт","ноя","дек"],dddd:["Воскресенье","Понедельник","Вторник","Среду","Четверг","Пятницу","Субботу"],ddd:["Вс","Пн","Вт","Ср","Чт","Пт","Сб"],dd:["Вс","Пн","Вт","Ср","Чт","Пт","Сб"],A:["ночи","утра","дня","вечера"],formats:{A:function(d){var h=d.getHours();return h<4?this.A[0]:h<12?this.A[1]:h<17?this.A[2]:this.A[3]}},parsers:{h:function(h,a){return a<2?h:h>11?h:h+12}}})};"object"==typeof module&&"object"==typeof module.exports?locale(__webpack_require__(199)):(__WEBPACK_AMD_DEFINE_ARRAY__=[__webpack_require__(199)],__WEBPACK_AMD_DEFINE_FACTORY__=locale,__WEBPACK_AMD_DEFINE_RESULT__="function"==typeof __WEBPACK_AMD_DEFINE_FACTORY__?__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__):__WEBPACK_AMD_DEFINE_FACTORY__,!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__)))}(this)},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_FACTORY__,__WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__;!function(global){"use strict";var locale=function(date){date.setLocales("zh-cn",{MMMM:["一月","二月","三月","四月","五月","六月","七月","八月","九月","十月","十一月","十二月"],MMM:["1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"],dddd:["星期日","星期一","星期二","星期三","星期四","星期五","星期六"],ddd:["周日","周一","周二","周三","周四","周五","周六"],dd:["日","一","二","三","四","五","六"],A:["凌晨","早上","上午","中午","下午","晚上"],formats:{A:function(d){var hm=100*d.getHours()+d.getMinutes();return hm<600?this.A[0]:hm<900?this.A[1]:hm<1130?this.A[2]:hm<1230?this.A[3]:hm<1800?this.A[4]:this.A[5]}},parsers:{h:function(h,a){return a<4?h:h>11?h:h+12}}})};"object"==typeof module&&"object"==typeof module.exports?locale(__webpack_require__(199)):(__WEBPACK_AMD_DEFINE_ARRAY__=[__webpack_require__(199)],__WEBPACK_AMD_DEFINE_FACTORY__=locale,__WEBPACK_AMD_DEFINE_RESULT__="function"==typeof __WEBPACK_AMD_DEFINE_FACTORY__?__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__):__WEBPACK_AMD_DEFINE_FACTORY__,!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__)))}(this)},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_FACTORY__,__WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__;!function(global){"use strict";var locale=function(date){date.setLocales("zh-tw",{MMMM:["一月","二月","三月","四月","五月","六月","七月","八月","九月","十月","十一月","十二月"],MMM:["1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"],dddd:["星期日","星期一","星期二","星期三","星期四","星期五","星期六"],ddd:["周日","周一","周二","周三","周四","周五","周六"],dd:["日","一","二","三","四","五","六"],A:["早上","上午","中午","下午","晚上"],formats:{A:function(d){var hm=100*d.getHours()+d.getMinutes();return hm<900?this.A[0]:hm<1130?this.A[1]:hm<1230?this.A[2]:hm<1800?this.A[3]:this.A[4]}},parsers:{h:function(h,a){return a<3?h:h>11?h:h+12}}})};"object"==typeof module&&"object"==typeof module.exports?locale(__webpack_require__(199)):(__WEBPACK_AMD_DEFINE_ARRAY__=[__webpack_require__(199)],__WEBPACK_AMD_DEFINE_FACTORY__=locale,__WEBPACK_AMD_DEFINE_RESULT__="function"==typeof __WEBPACK_AMD_DEFINE_FACTORY__?__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__):__WEBPACK_AMD_DEFINE_FACTORY__,!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__)))}(this)},function(module,exports,__webpack_require__){"use strict";function throwFirstError(){if(pendingErrors.length)throw pendingErrors.shift()}function asap(task){var rawTask;rawTask=freeTasks.length?freeTasks.pop():new RawTask,rawTask.task=task,rawAsap(rawTask)}function RawTask(){this.task=null}var rawAsap=__webpack_require__(234),freeTasks=[],pendingErrors=[],requestErrorThrow=rawAsap.makeRequestCallFromTimer(throwFirstError);module.exports=asap,RawTask.prototype.call=function(){try{this.task.call()}catch(error){asap.onerror?asap.onerror(error):(pendingErrors.push(error),requestErrorThrow())}finally{this.task=null,freeTasks[freeTasks.length]=this}}},function(module,exports,__webpack_require__){(function(process){function WriteReq(chunk,encoding,cb){this.chunk=chunk,this.encoding=encoding,this.callback=cb}function WritableState(options,stream){var Duplex=__webpack_require__(253);options=options||{};var hwm=options.highWaterMark,defaultHwm=options.objectMode?16:16384;this.highWaterMark=hwm||0===hwm?hwm:defaultHwm,this.objectMode=!!options.objectMode,stream instanceof Duplex&&(this.objectMode=this.objectMode||!!options.writableObjectMode),this.highWaterMark=~~this.highWaterMark,this.needDrain=!1,this.ending=!1,this.ended=!1,this.finished=!1;var noDecode=options.decodeStrings===!1;this.decodeStrings=!noDecode,this.defaultEncoding=options.defaultEncoding||"utf8",this.length=0,this.writing=!1,this.corked=0,this.sync=!0,this.bufferProcessing=!1,this.onwrite=function(er){onwrite(stream,er)},this.writecb=null,this.writelen=0,this.buffer=[],this.pendingcb=0,this.prefinished=!1,this.errorEmitted=!1}function Writable(options){var Duplex=__webpack_require__(253);return this instanceof Writable||this instanceof Duplex?(this._writableState=new WritableState(options,this),this.writable=!0,void Stream.call(this)):new Writable(options)}function writeAfterEnd(stream,state,cb){var er=new Error("write after end");stream.emit("error",er),process.nextTick(function(){cb(er)})}function validChunk(stream,state,chunk,cb){var valid=!0;if(!(util.isBuffer(chunk)||util.isString(chunk)||util.isNullOrUndefined(chunk)||state.objectMode)){var er=new TypeError("Invalid non-string/buffer chunk");stream.emit("error",er),process.nextTick(function(){cb(er)}),valid=!1}return valid}function decodeChunk(state,chunk,encoding){return!state.objectMode&&state.decodeStrings!==!1&&util.isString(chunk)&&(chunk=new Buffer(chunk,encoding)),chunk}function writeOrBuffer(stream,state,chunk,encoding,cb){chunk=decodeChunk(state,chunk,encoding),util.isBuffer(chunk)&&(encoding="buffer");var len=state.objectMode?1:chunk.length;state.length+=len;var ret=state.length<state.highWaterMark;return ret||(state.needDrain=!0),state.writing||state.corked?state.buffer.push(new WriteReq(chunk,encoding,cb)):doWrite(stream,state,!1,len,chunk,encoding,cb),ret}function doWrite(stream,state,writev,len,chunk,encoding,cb){state.writelen=len,state.writecb=cb,state.writing=!0,state.sync=!0,writev?stream._writev(chunk,state.onwrite):stream._write(chunk,encoding,state.onwrite),state.sync=!1}function onwriteError(stream,state,sync,er,cb){sync?process.nextTick(function(){state.pendingcb--,cb(er)}):(state.pendingcb--,cb(er)),stream._writableState.errorEmitted=!0,stream.emit("error",er)}function onwriteStateUpdate(state){state.writing=!1,state.writecb=null,state.length-=state.writelen,state.writelen=0}function onwrite(stream,er){var state=stream._writableState,sync=state.sync,cb=state.writecb;if(onwriteStateUpdate(state),er)onwriteError(stream,state,sync,er,cb);else{var finished=needFinish(stream,state);finished||state.corked||state.bufferProcessing||!state.buffer.length||clearBuffer(stream,state),sync?process.nextTick(function(){afterWrite(stream,state,finished,cb)}):afterWrite(stream,state,finished,cb)}}function afterWrite(stream,state,finished,cb){finished||onwriteDrain(stream,state),state.pendingcb--,cb(),finishMaybe(stream,state)}function onwriteDrain(stream,state){0===state.length&&state.needDrain&&(state.needDrain=!1,stream.emit("drain"))}function clearBuffer(stream,state){if(state.bufferProcessing=!0,stream._writev&&state.buffer.length>1){for(var cbs=[],c=0;c<state.buffer.length;c++)cbs.push(state.buffer[c].callback);state.pendingcb++,doWrite(stream,state,!0,state.length,state.buffer,"",function(err){for(var i=0;i<cbs.length;i++)state.pendingcb--,cbs[i](err)}),state.buffer=[]}else{for(var c=0;c<state.buffer.length;c++){var entry=state.buffer[c],chunk=entry.chunk,encoding=entry.encoding,cb=entry.callback,len=state.objectMode?1:chunk.length;if(doWrite(stream,state,!1,len,chunk,encoding,cb),state.writing){c++;break}}c<state.buffer.length?state.buffer=state.buffer.slice(c):state.buffer.length=0}state.bufferProcessing=!1}function needFinish(stream,state){return state.ending&&0===state.length&&!state.finished&&!state.writing}function prefinish(stream,state){state.prefinished||(state.prefinished=!0,stream.emit("prefinish"))}function finishMaybe(stream,state){var need=needFinish(stream,state);return need&&(0===state.pendingcb?(prefinish(stream,state),state.finished=!0,stream.emit("finish")):prefinish(stream,state)),need}function endWritable(stream,state,cb){state.ending=!0,finishMaybe(stream,state),cb&&(state.finished?process.nextTick(cb):stream.once("finish",cb)),state.ended=!0}module.exports=Writable;var Buffer=__webpack_require__(92).Buffer;Writable.WritableState=WritableState;var util=__webpack_require__(325);util.inherits=__webpack_require__(324);var Stream=__webpack_require__(169);util.inherits(Writable,Stream),Writable.prototype.pipe=function(){this.emit("error",new Error("Cannot pipe. Not readable."))},Writable.prototype.write=function(chunk,encoding,cb){var state=this._writableState,ret=!1;return util.isFunction(encoding)&&(cb=encoding,encoding=null),util.isBuffer(chunk)?encoding="buffer":encoding||(encoding=state.defaultEncoding),util.isFunction(cb)||(cb=function(){}),state.ended?writeAfterEnd(this,state,cb):validChunk(this,state,chunk,cb)&&(state.pendingcb++,ret=writeOrBuffer(this,state,chunk,encoding,cb)),ret},Writable.prototype.cork=function(){var state=this._writableState;state.corked++},Writable.prototype.uncork=function(){var state=this._writableState;state.corked&&(state.corked--,state.writing||state.corked||state.finished||state.bufferProcessing||!state.buffer.length||clearBuffer(this,state))},Writable.prototype._write=function(chunk,encoding,cb){cb(new Error("not implemented"))},Writable.prototype._writev=null,Writable.prototype.end=function(chunk,encoding,cb){var state=this._writableState;util.isFunction(chunk)?(cb=chunk,chunk=null,encoding=null):util.isFunction(encoding)&&(cb=encoding,encoding=null),util.isNullOrUndefined(chunk)||this.write(chunk,encoding),state.corked&&(state.corked=1,this.uncork()),state.ending||state.finished||endWritable(this,state,cb)}}).call(exports,__webpack_require__(59))},function(module,exports,__webpack_require__){(function(process){function ReadableState(options,stream){var Duplex=__webpack_require__(253);options=options||{};var hwm=options.highWaterMark,defaultHwm=options.objectMode?16:16384;this.highWaterMark=hwm||0===hwm?hwm:defaultHwm,this.highWaterMark=~~this.highWaterMark,this.buffer=[],this.length=0,this.pipes=null,this.pipesCount=0,this.flowing=null,this.ended=!1,this.endEmitted=!1,this.reading=!1,this.sync=!0,this.needReadable=!1,this.emittedReadable=!1,this.readableListening=!1,this.objectMode=!!options.objectMode,stream instanceof Duplex&&(this.objectMode=this.objectMode||!!options.readableObjectMode),this.defaultEncoding=options.defaultEncoding||"utf8",this.ranOut=!1,this.awaitDrain=0,this.readingMore=!1,this.decoder=null,this.encoding=null,options.encoding&&(StringDecoder||(StringDecoder=__webpack_require__(261).StringDecoder),this.decoder=new StringDecoder(options.encoding),this.encoding=options.encoding)}function Readable(options){__webpack_require__(253);return this instanceof Readable?(this._readableState=new ReadableState(options,this),this.readable=!0,void Stream.call(this)):new Readable(options)}function readableAddChunk(stream,state,chunk,encoding,addToFront){var er=chunkInvalid(state,chunk);if(er)stream.emit("error",er);else if(util.isNullOrUndefined(chunk))state.reading=!1,state.ended||onEofChunk(stream,state);else if(state.objectMode||chunk&&chunk.length>0)if(state.ended&&!addToFront){var e=new Error("stream.push() after EOF");stream.emit("error",e)}else if(state.endEmitted&&addToFront){var e=new Error("stream.unshift() after end event");stream.emit("error",e)}else!state.decoder||addToFront||encoding||(chunk=state.decoder.write(chunk)),addToFront||(state.reading=!1),state.flowing&&0===state.length&&!state.sync?(stream.emit("data",chunk),stream.read(0)):(state.length+=state.objectMode?1:chunk.length,addToFront?state.buffer.unshift(chunk):state.buffer.push(chunk),state.needReadable&&emitReadable(stream)),maybeReadMore(stream,state);else addToFront||(state.reading=!1);return needMoreData(state)}function needMoreData(state){return!state.ended&&(state.needReadable||state.length<state.highWaterMark||0===state.length)}function roundUpToNextPowerOf2(n){if(n>=MAX_HWM)n=MAX_HWM;else{n--;for(var p=1;p<32;p<<=1)n|=n>>p;n++}return n}function howMuchToRead(n,state){return 0===state.length&&state.ended?0:state.objectMode?0===n?0:1:isNaN(n)||util.isNull(n)?state.flowing&&state.buffer.length?state.buffer[0].length:state.length:n<=0?0:(n>state.highWaterMark&&(state.highWaterMark=roundUpToNextPowerOf2(n)),n>state.length?state.ended?state.length:(state.needReadable=!0,0):n)}function chunkInvalid(state,chunk){var er=null;return util.isBuffer(chunk)||util.isString(chunk)||util.isNullOrUndefined(chunk)||state.objectMode||(er=new TypeError("Invalid non-string/buffer chunk")),er}function onEofChunk(stream,state){if(state.decoder&&!state.ended){var chunk=state.decoder.end();chunk&&chunk.length&&(state.buffer.push(chunk),state.length+=state.objectMode?1:chunk.length)}state.ended=!0,emitReadable(stream)}function emitReadable(stream){var state=stream._readableState;state.needReadable=!1,state.emittedReadable||(debug("emitReadable",state.flowing),state.emittedReadable=!0,state.sync?process.nextTick(function(){emitReadable_(stream)}):emitReadable_(stream))}function emitReadable_(stream){debug("emit readable"),stream.emit("readable"),flow(stream)}function maybeReadMore(stream,state){state.readingMore||(state.readingMore=!0,process.nextTick(function(){maybeReadMore_(stream,state)}))}function maybeReadMore_(stream,state){for(var len=state.length;!state.reading&&!state.flowing&&!state.ended&&state.length<state.highWaterMark&&(debug("maybeReadMore read 0"),stream.read(0),len!==state.length);)len=state.length;state.readingMore=!1}function pipeOnDrain(src){return function(){var state=src._readableState;debug("pipeOnDrain",state.awaitDrain),state.awaitDrain&&state.awaitDrain--,0===state.awaitDrain&&EE.listenerCount(src,"data")&&(state.flowing=!0,flow(src))}}function resume(stream,state){state.resumeScheduled||(state.resumeScheduled=!0,process.nextTick(function(){resume_(stream,state)}))}function resume_(stream,state){state.resumeScheduled=!1,stream.emit("resume"),flow(stream),state.flowing&&!state.reading&&stream.read(0)}function flow(stream){var state=stream._readableState;if(debug("flow",state.flowing),state.flowing)do var chunk=stream.read();while(null!==chunk&&state.flowing)}function fromList(n,state){var ret,list=state.buffer,length=state.length,stringMode=!!state.decoder,objectMode=!!state.objectMode;if(0===list.length)return null;if(0===length)ret=null;else if(objectMode)ret=list.shift();else if(!n||n>=length)ret=stringMode?list.join(""):Buffer.concat(list,length),list.length=0;else if(n<list[0].length){var buf=list[0];ret=buf.slice(0,n),list[0]=buf.slice(n)}else if(n===list[0].length)ret=list.shift();else{ret=stringMode?"":new Buffer(n);for(var c=0,i=0,l=list.length;i<l&&c<n;i++){var buf=list[0],cpy=Math.min(n-c,buf.length);stringMode?ret+=buf.slice(0,cpy):buf.copy(ret,c,0,cpy),cpy<buf.length?list[0]=buf.slice(cpy):list.shift(),c+=cpy}}return ret}function endReadable(stream){var state=stream._readableState;if(state.length>0)throw new Error("endReadable called on non-empty stream");state.endEmitted||(state.ended=!0,process.nextTick(function(){state.endEmitted||0!==state.length||(state.endEmitted=!0,stream.readable=!1,stream.emit("end"))}))}function forEach(xs,f){for(var i=0,l=xs.length;i<l;i++)f(xs[i],i)}function indexOf(xs,x){for(var i=0,l=xs.length;i<l;i++)if(xs[i]===x)return i;return-1}module.exports=Readable;var isArray=__webpack_require__(323),Buffer=__webpack_require__(92).Buffer;Readable.ReadableState=ReadableState;var EE=__webpack_require__(196).EventEmitter;EE.listenerCount||(EE.listenerCount=function(emitter,type){return emitter.listeners(type).length});var Stream=__webpack_require__(169),util=__webpack_require__(325);util.inherits=__webpack_require__(324);var StringDecoder,debug=__webpack_require__(260);debug=debug&&debug.debuglog?debug.debuglog("stream"):function(){},util.inherits(Readable,Stream),Readable.prototype.push=function(chunk,encoding){var state=this._readableState;return util.isString(chunk)&&!state.objectMode&&(encoding=encoding||state.defaultEncoding,encoding!==state.encoding&&(chunk=new Buffer(chunk,encoding),encoding="")),readableAddChunk(this,state,chunk,encoding,!1)},Readable.prototype.unshift=function(chunk){var state=this._readableState;return readableAddChunk(this,state,chunk,"",!0)},Readable.prototype.setEncoding=function(enc){return StringDecoder||(StringDecoder=__webpack_require__(261).StringDecoder),this._readableState.decoder=new StringDecoder(enc),this._readableState.encoding=enc,this};var MAX_HWM=8388608;Readable.prototype.read=function(n){debug("read",n);var state=this._readableState,nOrig=n;if((!util.isNumber(n)||n>0)&&(state.emittedReadable=!1),0===n&&state.needReadable&&(state.length>=state.highWaterMark||state.ended))return debug("read: emitReadable",state.length,state.ended),0===state.length&&state.ended?endReadable(this):emitReadable(this),null;if(n=howMuchToRead(n,state),0===n&&state.ended)return 0===state.length&&endReadable(this),null;var doRead=state.needReadable;debug("need readable",doRead),(0===state.length||state.length-n<state.highWaterMark)&&(doRead=!0,debug("length less than watermark",doRead)),(state.ended||state.reading)&&(doRead=!1,debug("reading or ended",doRead)),doRead&&(debug("do read"),state.reading=!0,state.sync=!0,0===state.length&&(state.needReadable=!0),this._read(state.highWaterMark),state.sync=!1),doRead&&!state.reading&&(n=howMuchToRead(nOrig,state));var ret;return ret=n>0?fromList(n,state):null,util.isNull(ret)&&(state.needReadable=!0,n=0),state.length-=n,0!==state.length||state.ended||(state.needReadable=!0),nOrig!==n&&state.ended&&0===state.length&&endReadable(this),util.isNull(ret)||this.emit("data",ret),ret},Readable.prototype._read=function(n){this.emit("error",new Error("not implemented"))},Readable.prototype.pipe=function(dest,pipeOpts){function onunpipe(readable){debug("onunpipe"),readable===src&&cleanup()}function onend(){debug("onend"),dest.end()}function cleanup(){debug("cleanup"),dest.removeListener("close",onclose),dest.removeListener("finish",onfinish),dest.removeListener("drain",ondrain),dest.removeListener("error",onerror),dest.removeListener("unpipe",onunpipe),src.removeListener("end",onend),src.removeListener("end",cleanup),src.removeListener("data",ondata),!state.awaitDrain||dest._writableState&&!dest._writableState.needDrain||ondrain()}function ondata(chunk){debug("ondata");var ret=dest.write(chunk);!1===ret&&(debug("false write response, pause",src._readableState.awaitDrain),src._readableState.awaitDrain++,src.pause())}function onerror(er){debug("onerror",er),unpipe(),dest.removeListener("error",onerror),0===EE.listenerCount(dest,"error")&&dest.emit("error",er)}function onclose(){dest.removeListener("finish",onfinish),unpipe()}function onfinish(){debug("onfinish"),dest.removeListener("close",onclose),unpipe()}function unpipe(){debug("unpipe"),src.unpipe(dest)}var src=this,state=this._readableState;switch(state.pipesCount){case 0:state.pipes=dest;break;case 1:state.pipes=[state.pipes,dest];break;default:state.pipes.push(dest)}state.pipesCount+=1,debug("pipe count=%d opts=%j",state.pipesCount,pipeOpts);var doEnd=(!pipeOpts||pipeOpts.end!==!1)&&dest!==process.stdout&&dest!==process.stderr,endFn=doEnd?onend:cleanup;state.endEmitted?process.nextTick(endFn):src.once("end",endFn),dest.on("unpipe",onunpipe);var ondrain=pipeOnDrain(src);return dest.on("drain",ondrain),src.on("data",ondata),dest._events&&dest._events.error?isArray(dest._events.error)?dest._events.error.unshift(onerror):dest._events.error=[onerror,dest._events.error]:dest.on("error",onerror),dest.once("close",onclose),dest.once("finish",onfinish),dest.emit("pipe",src),state.flowing||(debug("pipe resume"),src.resume()),dest},Readable.prototype.unpipe=function(dest){var state=this._readableState;if(0===state.pipesCount)return this;if(1===state.pipesCount)return dest&&dest!==state.pipes?this:(dest||(dest=state.pipes),state.pipes=null,state.pipesCount=0,state.flowing=!1,dest&&dest.emit("unpipe",this),this);if(!dest){var dests=state.pipes,len=state.pipesCount;state.pipes=null,state.pipesCount=0,state.flowing=!1;for(var i=0;i<len;i++)dests[i].emit("unpipe",this);return this}var i=indexOf(state.pipes,dest);return i===-1?this:(state.pipes.splice(i,1),state.pipesCount-=1,1===state.pipesCount&&(state.pipes=state.pipes[0]),dest.emit("unpipe",this),this)},Readable.prototype.on=function(ev,fn){var res=Stream.prototype.on.call(this,ev,fn);if("data"===ev&&!1!==this._readableState.flowing&&this.resume(),"readable"===ev&&this.readable){var state=this._readableState;if(!state.readableListening)if(state.readableListening=!0,state.emittedReadable=!1,state.needReadable=!0,state.reading)state.length&&emitReadable(this,state);else{var self=this;process.nextTick(function(){debug("readable nexttick read 0"),self.read(0)})}}return res},Readable.prototype.addListener=Readable.prototype.on,Readable.prototype.resume=function(){var state=this._readableState;return state.flowing||(debug("resume"),state.flowing=!0,state.reading||(debug("resume read 0"),this.read(0)),resume(this,state)),this},Readable.prototype.pause=function(){return debug("call pause flowing=%j",this._readableState.flowing),!1!==this._readableState.flowing&&(debug("pause"),this._readableState.flowing=!1,this.emit("pause")),this},Readable.prototype.wrap=function(stream){var state=this._readableState,paused=!1,self=this;stream.on("end",function(){if(debug("wrapped end"),state.decoder&&!state.ended){var chunk=state.decoder.end();chunk&&chunk.length&&self.push(chunk)}self.push(null)}),stream.on("data",function(chunk){if(debug("wrapped data"),state.decoder&&(chunk=state.decoder.write(chunk)),chunk&&(state.objectMode||chunk.length)){var ret=self.push(chunk);ret||(paused=!0,stream.pause())}});for(var i in stream)util.isFunction(stream[i])&&util.isUndefined(this[i])&&(this[i]=function(method){return function(){return stream[method].apply(stream,arguments)}}(i));var events=["error","close","destroy","pause","resume"];return forEach(events,function(ev){stream.on(ev,self.emit.bind(self,ev))}),self._read=function(n){debug("wrapped _read",n),paused&&(paused=!1,stream.resume())},self},Readable._fromList=fromList}).call(exports,__webpack_require__(59))},function(module,exports,__webpack_require__){(function(process){function Duplex(options){return this instanceof Duplex?(Readable.call(this,options),Writable.call(this,options),options&&options.readable===!1&&(this.readable=!1),options&&options.writable===!1&&(this.writable=!1),this.allowHalfOpen=!0,options&&options.allowHalfOpen===!1&&(this.allowHalfOpen=!1),void this.once("end",onend)):new Duplex(options)}function onend(){this.allowHalfOpen||this._writableState.ended||process.nextTick(this.end.bind(this))}function forEach(xs,f){for(var i=0,l=xs.length;i<l;i++)f(xs[i],i)}module.exports=Duplex;var objectKeys=Object.keys||function(obj){var keys=[];for(var key in obj)keys.push(key);return keys},util=__webpack_require__(325);util.inherits=__webpack_require__(324);var Readable=__webpack_require__(252),Writable=__webpack_require__(251);util.inherits(Duplex,Readable),forEach(objectKeys(Writable.prototype),function(method){Duplex.prototype[method]||(Duplex.prototype[method]=Writable.prototype[method])})}).call(exports,__webpack_require__(59))},function(module,exports,__webpack_require__){function TransformState(options,stream){this.afterTransform=function(er,data){return afterTransform(stream,er,data)},this.needTransform=!1,this.transforming=!1,this.writecb=null,this.writechunk=null}function afterTransform(stream,er,data){var ts=stream._transformState;ts.transforming=!1;var cb=ts.writecb;if(!cb)return stream.emit("error",new Error("no writecb in Transform class"));ts.writechunk=null,ts.writecb=null,util.isNullOrUndefined(data)||stream.push(data),cb&&cb(er);var rs=stream._readableState;rs.reading=!1,(rs.needReadable||rs.length<rs.highWaterMark)&&stream._read(rs.highWaterMark)}function Transform(options){if(!(this instanceof Transform))return new Transform(options);Duplex.call(this,options),this._transformState=new TransformState(options,this);var stream=this;this._readableState.needReadable=!0,this._readableState.sync=!1,this.once("prefinish",function(){util.isFunction(this._flush)?this._flush(function(er){done(stream,er)}):done(stream)})}function done(stream,er){if(er)return stream.emit("error",er);var ws=stream._writableState,ts=stream._transformState;if(ws.length)throw new Error("calling transform done when ws.length != 0");if(ts.transforming)throw new Error("calling transform done when still transforming");return stream.push(null)}module.exports=Transform;var Duplex=__webpack_require__(253),util=__webpack_require__(325);util.inherits=__webpack_require__(324),util.inherits(Transform,Duplex),Transform.prototype.push=function(chunk,encoding){return this._transformState.needTransform=!1,Duplex.prototype.push.call(this,chunk,encoding)},Transform.prototype._transform=function(chunk,encoding,cb){throw new Error("not implemented")},Transform.prototype._write=function(chunk,encoding,cb){var ts=this._transformState;if(ts.writecb=cb,ts.writechunk=chunk,ts.writeencoding=encoding,!ts.transforming){var rs=this._readableState;(ts.needTransform||rs.needReadable||rs.length<rs.highWaterMark)&&this._read(rs.highWaterMark)}},Transform.prototype._read=function(n){var ts=this._transformState;util.isNull(ts.writechunk)||!ts.writecb||ts.transforming?ts.needTransform=!0:(ts.transforming=!0,this._transform(ts.writechunk,ts.writeencoding,ts.afterTransform))}},function(module,exports,__webpack_require__){function PassThrough(options){return this instanceof PassThrough?void Transform.call(this,options):new PassThrough(options)}module.exports=PassThrough;var Transform=__webpack_require__(254),util=__webpack_require__(325);util.inherits=__webpack_require__(324),util.inherits(PassThrough,Transform),PassThrough.prototype._transform=function(chunk,encoding,cb){cb(null,chunk)}},function(module,exports,__webpack_require__){function Timeout(id,clearFn){this._id=id,this._clearFn=clearFn}var nextTick=__webpack_require__(326).nextTick,apply=Function.prototype.apply,slice=Array.prototype.slice,immediateIds={},nextImmediateId=0;exports.setTimeout=function(){
return new Timeout(apply.call(setTimeout,window,arguments),clearTimeout)},exports.setInterval=function(){return new Timeout(apply.call(setInterval,window,arguments),clearInterval)},exports.clearTimeout=exports.clearInterval=function(timeout){timeout.close()},Timeout.prototype.unref=Timeout.prototype.ref=function(){},Timeout.prototype.close=function(){this._clearFn.call(window,this._id)},exports.enroll=function(item,msecs){clearTimeout(item._idleTimeoutId),item._idleTimeout=msecs},exports.unenroll=function(item){clearTimeout(item._idleTimeoutId),item._idleTimeout=-1},exports._unrefActive=exports.active=function(item){clearTimeout(item._idleTimeoutId);var msecs=item._idleTimeout;msecs>=0&&(item._idleTimeoutId=setTimeout(function(){item._onTimeout&&item._onTimeout()},msecs))},exports.setImmediate="function"==typeof setImmediate?setImmediate:function(fn){var id=nextImmediateId++,args=!(arguments.length<2)&&slice.call(arguments,1);return immediateIds[id]=!0,nextTick(function(){immediateIds[id]&&(args?fn.apply(null,args):fn.call(null),exports.clearImmediate(id))}),id},exports.clearImmediate="function"==typeof clearImmediate?clearImmediate:function(id){delete immediateIds[id]}},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}Object.defineProperty(exports,"__esModule",{value:!0});var _toDate=__webpack_require__(263),_toDate2=_interopRequireDefault(_toDate),_toFloat=__webpack_require__(264),_toFloat2=_interopRequireDefault(_toFloat),_toInt=__webpack_require__(265),_toInt2=_interopRequireDefault(_toInt),_toBoolean=__webpack_require__(266),_toBoolean2=_interopRequireDefault(_toBoolean),_equals=__webpack_require__(267),_equals2=_interopRequireDefault(_equals),_contains=__webpack_require__(268),_contains2=_interopRequireDefault(_contains),_matches=__webpack_require__(269),_matches2=_interopRequireDefault(_matches),_isEmail=__webpack_require__(270),_isEmail2=_interopRequireDefault(_isEmail),_isURL=__webpack_require__(271),_isURL2=_interopRequireDefault(_isURL),_isMACAddress=__webpack_require__(272),_isMACAddress2=_interopRequireDefault(_isMACAddress),_isIP=__webpack_require__(273),_isIP2=_interopRequireDefault(_isIP),_isFQDN=__webpack_require__(274),_isFQDN2=_interopRequireDefault(_isFQDN),_isBoolean=__webpack_require__(275),_isBoolean2=_interopRequireDefault(_isBoolean),_isAlpha=__webpack_require__(276),_isAlpha2=_interopRequireDefault(_isAlpha),_isAlphanumeric=__webpack_require__(277),_isAlphanumeric2=_interopRequireDefault(_isAlphanumeric),_isNumeric=__webpack_require__(278),_isNumeric2=_interopRequireDefault(_isNumeric),_isLowercase=__webpack_require__(279),_isLowercase2=_interopRequireDefault(_isLowercase),_isUppercase=__webpack_require__(280),_isUppercase2=_interopRequireDefault(_isUppercase),_isAscii=__webpack_require__(281),_isAscii2=_interopRequireDefault(_isAscii),_isFullWidth=__webpack_require__(282),_isFullWidth2=_interopRequireDefault(_isFullWidth),_isHalfWidth=__webpack_require__(283),_isHalfWidth2=_interopRequireDefault(_isHalfWidth),_isVariableWidth=__webpack_require__(284),_isVariableWidth2=_interopRequireDefault(_isVariableWidth),_isMultibyte=__webpack_require__(285),_isMultibyte2=_interopRequireDefault(_isMultibyte),_isSurrogatePair=__webpack_require__(286),_isSurrogatePair2=_interopRequireDefault(_isSurrogatePair),_isInt=__webpack_require__(287),_isInt2=_interopRequireDefault(_isInt),_isFloat=__webpack_require__(288),_isFloat2=_interopRequireDefault(_isFloat),_isDecimal=__webpack_require__(289),_isDecimal2=_interopRequireDefault(_isDecimal),_isHexadecimal=__webpack_require__(290),_isHexadecimal2=_interopRequireDefault(_isHexadecimal),_isDivisibleBy=__webpack_require__(291),_isDivisibleBy2=_interopRequireDefault(_isDivisibleBy),_isHexColor=__webpack_require__(292),_isHexColor2=_interopRequireDefault(_isHexColor),_isJSON=__webpack_require__(293),_isJSON2=_interopRequireDefault(_isJSON),_isNull=__webpack_require__(294),_isNull2=_interopRequireDefault(_isNull),_isLength=__webpack_require__(295),_isLength2=_interopRequireDefault(_isLength),_isByteLength=__webpack_require__(296),_isByteLength2=_interopRequireDefault(_isByteLength),_isUUID=__webpack_require__(297),_isUUID2=_interopRequireDefault(_isUUID),_isMongoId=__webpack_require__(298),_isMongoId2=_interopRequireDefault(_isMongoId),_isDate=__webpack_require__(299),_isDate2=_interopRequireDefault(_isDate),_isAfter=__webpack_require__(300),_isAfter2=_interopRequireDefault(_isAfter),_isBefore=__webpack_require__(301),_isBefore2=_interopRequireDefault(_isBefore),_isIn=__webpack_require__(302),_isIn2=_interopRequireDefault(_isIn),_isCreditCard=__webpack_require__(303),_isCreditCard2=_interopRequireDefault(_isCreditCard),_isISIN=__webpack_require__(304),_isISIN2=_interopRequireDefault(_isISIN),_isISBN=__webpack_require__(305),_isISBN2=_interopRequireDefault(_isISBN),_isMobilePhone=__webpack_require__(306),_isMobilePhone2=_interopRequireDefault(_isMobilePhone),_isCurrency=__webpack_require__(307),_isCurrency2=_interopRequireDefault(_isCurrency),_isISO=__webpack_require__(308),_isISO2=_interopRequireDefault(_isISO),_isBase=__webpack_require__(309),_isBase2=_interopRequireDefault(_isBase),_isDataURI=__webpack_require__(310),_isDataURI2=_interopRequireDefault(_isDataURI),_ltrim=__webpack_require__(311),_ltrim2=_interopRequireDefault(_ltrim),_rtrim=__webpack_require__(312),_rtrim2=_interopRequireDefault(_rtrim),_trim=__webpack_require__(313),_trim2=_interopRequireDefault(_trim),_escape=__webpack_require__(314),_escape2=_interopRequireDefault(_escape),_unescape=__webpack_require__(315),_unescape2=_interopRequireDefault(_unescape),_stripLow=__webpack_require__(316),_stripLow2=_interopRequireDefault(_stripLow),_whitelist=__webpack_require__(317),_whitelist2=_interopRequireDefault(_whitelist),_blacklist=__webpack_require__(318),_blacklist2=_interopRequireDefault(_blacklist),_isWhitelisted=__webpack_require__(319),_isWhitelisted2=_interopRequireDefault(_isWhitelisted),_normalizeEmail=__webpack_require__(320),_normalizeEmail2=_interopRequireDefault(_normalizeEmail),_toString=__webpack_require__(321),_toString2=_interopRequireDefault(_toString),version="5.2.0",validator={version:version,toDate:_toDate2.default,toFloat:_toFloat2.default,toInt:_toInt2.default,toBoolean:_toBoolean2.default,equals:_equals2.default,contains:_contains2.default,matches:_matches2.default,isEmail:_isEmail2.default,isURL:_isURL2.default,isMACAddress:_isMACAddress2.default,isIP:_isIP2.default,isFQDN:_isFQDN2.default,isBoolean:_isBoolean2.default,isAlpha:_isAlpha2.default,isAlphanumeric:_isAlphanumeric2.default,isNumeric:_isNumeric2.default,isLowercase:_isLowercase2.default,isUppercase:_isUppercase2.default,isAscii:_isAscii2.default,isFullWidth:_isFullWidth2.default,isHalfWidth:_isHalfWidth2.default,isVariableWidth:_isVariableWidth2.default,isMultibyte:_isMultibyte2.default,isSurrogatePair:_isSurrogatePair2.default,isInt:_isInt2.default,isFloat:_isFloat2.default,isDecimal:_isDecimal2.default,isHexadecimal:_isHexadecimal2.default,isDivisibleBy:_isDivisibleBy2.default,isHexColor:_isHexColor2.default,isJSON:_isJSON2.default,isNull:_isNull2.default,isLength:_isLength2.default,isByteLength:_isByteLength2.default,isUUID:_isUUID2.default,isMongoId:_isMongoId2.default,isDate:_isDate2.default,isAfter:_isAfter2.default,isBefore:_isBefore2.default,isIn:_isIn2.default,isCreditCard:_isCreditCard2.default,isISIN:_isISIN2.default,isISBN:_isISBN2.default,isMobilePhone:_isMobilePhone2.default,isCurrency:_isCurrency2.default,isISO8601:_isISO2.default,isBase64:_isBase2.default,isDataURI:_isDataURI2.default,ltrim:_ltrim2.default,rtrim:_rtrim2.default,trim:_trim2.default,escape:_escape2.default,unescape:_unescape2.default,stripLow:_stripLow2.default,whitelist:_whitelist2.default,blacklist:_blacklist2.default,isWhitelisted:_isWhitelisted2.default,normalizeEmail:_normalizeEmail2.default,toString:_toString2.default};exports.default=validator,module.exports=exports.default},function(module,exports,__webpack_require__){(function(){var XMLBuilder,assign;assign=__webpack_require__(334),XMLBuilder=__webpack_require__(322),module.exports.create=function(name,xmldec,doctype,options){return options=assign({},xmldec,doctype,options),new XMLBuilder(name,options).root()}}).call(this)},function(module,exports,__webpack_require__){(function(Buffer){!function(sax){function SAXParser(strict,opt){if(!(this instanceof SAXParser))return new SAXParser(strict,opt);var parser=this;clearBuffers(parser),parser.q=parser.c="",parser.bufferCheckPosition=sax.MAX_BUFFER_LENGTH,parser.opt=opt||{},parser.opt.lowercase=parser.opt.lowercase||parser.opt.lowercasetags,parser.looseCase=parser.opt.lowercase?"toLowerCase":"toUpperCase",parser.tags=[],parser.closed=parser.closedRoot=parser.sawRoot=!1,parser.tag=parser.error=null,parser.strict=!!strict,parser.noscript=!(!strict&&!parser.opt.noscript),parser.state=S.BEGIN,parser.strictEntities=parser.opt.strictEntities,parser.ENTITIES=parser.strictEntities?Object.create(sax.XML_ENTITIES):Object.create(sax.ENTITIES),parser.attribList=[],parser.opt.xmlns&&(parser.ns=Object.create(rootNS)),parser.trackPosition=parser.opt.position!==!1,parser.trackPosition&&(parser.position=parser.line=parser.column=0),emit(parser,"onready")}function checkBufferLength(parser){for(var maxAllowed=Math.max(sax.MAX_BUFFER_LENGTH,10),maxActual=0,i=0,l=buffers.length;i<l;i++){var len=parser[buffers[i]].length;if(len>maxAllowed)switch(buffers[i]){case"textNode":closeText(parser);break;case"cdata":emitNode(parser,"oncdata",parser.cdata),parser.cdata="";break;case"script":emitNode(parser,"onscript",parser.script),parser.script="";break;default:error(parser,"Max buffer length exceeded: "+buffers[i])}maxActual=Math.max(maxActual,len)}var m=sax.MAX_BUFFER_LENGTH-maxActual;parser.bufferCheckPosition=m+parser.position}function clearBuffers(parser){for(var i=0,l=buffers.length;i<l;i++)parser[buffers[i]]=""}function flushBuffers(parser){closeText(parser),""!==parser.cdata&&(emitNode(parser,"oncdata",parser.cdata),parser.cdata=""),""!==parser.script&&(emitNode(parser,"onscript",parser.script),parser.script="")}function createStream(strict,opt){return new SAXStream(strict,opt)}function SAXStream(strict,opt){if(!(this instanceof SAXStream))return new SAXStream(strict,opt);Stream.apply(this),this._parser=new SAXParser(strict,opt),this.writable=!0,this.readable=!0;var me=this;this._parser.onend=function(){me.emit("end")},this._parser.onerror=function(er){me.emit("error",er),me._parser.error=null},this._decoder=null,streamWraps.forEach(function(ev){Object.defineProperty(me,"on"+ev,{get:function(){return me._parser["on"+ev]},set:function(h){return h?void me.on(ev,h):(me.removeAllListeners(ev),me._parser["on"+ev]=h,h)},enumerable:!0,configurable:!1})})}function charClass(str){return str.split("").reduce(function(s,c){return s[c]=!0,s},{})}function isRegExp(c){return"[object RegExp]"===Object.prototype.toString.call(c)}function is(charclass,c){return isRegExp(charclass)?!!c.match(charclass):charclass[c]}function not(charclass,c){return!is(charclass,c)}function emit(parser,event,data){parser[event]&&parser[event](data)}function emitNode(parser,nodeType,data){parser.textNode&&closeText(parser),emit(parser,nodeType,data)}function closeText(parser){parser.textNode=textopts(parser.opt,parser.textNode),parser.textNode&&emit(parser,"ontext",parser.textNode),parser.textNode=""}function textopts(opt,text){return opt.trim&&(text=text.trim()),opt.normalize&&(text=text.replace(/\s+/g," ")),text}function error(parser,er){return closeText(parser),parser.trackPosition&&(er+="\nLine: "+parser.line+"\nColumn: "+parser.column+"\nChar: "+parser.c),er=new Error(er),parser.error=er,emit(parser,"onerror",er),parser}function end(parser){return parser.sawRoot&&!parser.closedRoot&&strictFail(parser,"Unclosed root tag"),parser.state!==S.BEGIN&&parser.state!==S.BEGIN_WHITESPACE&&parser.state!==S.TEXT&&error(parser,"Unexpected end"),closeText(parser),parser.c="",parser.closed=!0,emit(parser,"onend"),SAXParser.call(parser,parser.strict,parser.opt),parser}function strictFail(parser,message){if("object"!=typeof parser||!(parser instanceof SAXParser))throw new Error("bad call to strictFail");parser.strict&&error(parser,message)}function newTag(parser){parser.strict||(parser.tagName=parser.tagName[parser.looseCase]());var parent=parser.tags[parser.tags.length-1]||parser,tag=parser.tag={name:parser.tagName,attributes:{}};parser.opt.xmlns&&(tag.ns=parent.ns),parser.attribList.length=0,emitNode(parser,"onopentagstart",tag)}function qname(name,attribute){var i=name.indexOf(":"),qualName=i<0?["",name]:name.split(":"),prefix=qualName[0],local=qualName[1];return attribute&&"xmlns"===name&&(prefix="xmlns",local=""),{prefix:prefix,local:local}}function attrib(parser){if(parser.strict||(parser.attribName=parser.attribName[parser.looseCase]()),parser.attribList.indexOf(parser.attribName)!==-1||parser.tag.attributes.hasOwnProperty(parser.attribName))return void(parser.attribName=parser.attribValue="");if(parser.opt.xmlns){var qn=qname(parser.attribName,!0),prefix=qn.prefix,local=qn.local;if("xmlns"===prefix)if("xml"===local&&parser.attribValue!==XML_NAMESPACE)strictFail(parser,"xml: prefix must be bound to "+XML_NAMESPACE+"\nActual: "+parser.attribValue);else if("xmlns"===local&&parser.attribValue!==XMLNS_NAMESPACE)strictFail(parser,"xmlns: prefix must be bound to "+XMLNS_NAMESPACE+"\nActual: "+parser.attribValue);else{var tag=parser.tag,parent=parser.tags[parser.tags.length-1]||parser;tag.ns===parent.ns&&(tag.ns=Object.create(parent.ns)),tag.ns[local]=parser.attribValue}parser.attribList.push([parser.attribName,parser.attribValue])}else parser.tag.attributes[parser.attribName]=parser.attribValue,emitNode(parser,"onattribute",{name:parser.attribName,value:parser.attribValue});parser.attribName=parser.attribValue=""}function openTag(parser,selfClosing){if(parser.opt.xmlns){var tag=parser.tag,qn=qname(parser.tagName);tag.prefix=qn.prefix,tag.local=qn.local,tag.uri=tag.ns[qn.prefix]||"",tag.prefix&&!tag.uri&&(strictFail(parser,"Unbound namespace prefix: "+JSON.stringify(parser.tagName)),tag.uri=qn.prefix);var parent=parser.tags[parser.tags.length-1]||parser;tag.ns&&parent.ns!==tag.ns&&Object.keys(tag.ns).forEach(function(p){emitNode(parser,"onopennamespace",{prefix:p,uri:tag.ns[p]})});for(var i=0,l=parser.attribList.length;i<l;i++){var nv=parser.attribList[i],name=nv[0],value=nv[1],qualName=qname(name,!0),prefix=qualName.prefix,local=qualName.local,uri=""===prefix?"":tag.ns[prefix]||"",a={name:name,value:value,prefix:prefix,local:local,uri:uri};prefix&&"xmlns"!==prefix&&!uri&&(strictFail(parser,"Unbound namespace prefix: "+JSON.stringify(prefix)),a.uri=prefix),parser.tag.attributes[name]=a,emitNode(parser,"onattribute",a)}parser.attribList.length=0}parser.tag.isSelfClosing=!!selfClosing,parser.sawRoot=!0,parser.tags.push(parser.tag),emitNode(parser,"onopentag",parser.tag),selfClosing||(parser.noscript||"script"!==parser.tagName.toLowerCase()?parser.state=S.TEXT:parser.state=S.SCRIPT,parser.tag=null,parser.tagName=""),parser.attribName=parser.attribValue="",parser.attribList.length=0}function closeTag(parser){if(!parser.tagName)return strictFail(parser,"Weird empty close tag."),parser.textNode+="</>",void(parser.state=S.TEXT);if(parser.script){if("script"!==parser.tagName)return parser.script+="</"+parser.tagName+">",parser.tagName="",void(parser.state=S.SCRIPT);emitNode(parser,"onscript",parser.script),parser.script=""}var t=parser.tags.length,tagName=parser.tagName;parser.strict||(tagName=tagName[parser.looseCase]());for(var closeTo=tagName;t--;){var close=parser.tags[t];if(close.name===closeTo)break;strictFail(parser,"Unexpected close tag")}if(t<0)return strictFail(parser,"Unmatched closing tag: "+parser.tagName),parser.textNode+="</"+parser.tagName+">",void(parser.state=S.TEXT);parser.tagName=tagName;for(var s=parser.tags.length;s-- >t;){var tag=parser.tag=parser.tags.pop();parser.tagName=parser.tag.name,emitNode(parser,"onclosetag",parser.tagName);var x={};for(var i in tag.ns)x[i]=tag.ns[i];var parent=parser.tags[parser.tags.length-1]||parser;parser.opt.xmlns&&tag.ns!==parent.ns&&Object.keys(tag.ns).forEach(function(p){var n=tag.ns[p];emitNode(parser,"onclosenamespace",{prefix:p,uri:n})})}0===t&&(parser.closedRoot=!0),parser.tagName=parser.attribValue=parser.attribName="",parser.attribList.length=0,parser.state=S.TEXT}function parseEntity(parser){var num,entity=parser.entity,entityLC=entity.toLowerCase(),numStr="";return parser.ENTITIES[entity]?parser.ENTITIES[entity]:parser.ENTITIES[entityLC]?parser.ENTITIES[entityLC]:(entity=entityLC,"#"===entity.charAt(0)&&("x"===entity.charAt(1)?(entity=entity.slice(2),num=parseInt(entity,16),numStr=num.toString(16)):(entity=entity.slice(1),num=parseInt(entity,10),numStr=num.toString(10))),entity=entity.replace(/^0+/,""),numStr.toLowerCase()!==entity?(strictFail(parser,"Invalid character entity"),"&"+parser.entity+";"):String.fromCodePoint(num))}function beginWhiteSpace(parser,c){"<"===c?(parser.state=S.OPEN_WAKA,parser.startTagPosition=parser.position):not(whitespace,c)&&(strictFail(parser,"Non-whitespace before first tag."),parser.textNode=c,parser.state=S.TEXT)}function charAt(chunk,i){var result="";return i<chunk.length&&(result=chunk.charAt(i)),result}function write(chunk){var parser=this;if(this.error)throw this.error;if(parser.closed)return error(parser,"Cannot write after close. Assign an onready handler.");if(null===chunk)return end(parser);"object"==typeof chunk&&(chunk=chunk.toString());for(var i=0,c="";;){if(c=charAt(chunk,i++),parser.c=c,!c)break;switch(parser.trackPosition&&(parser.position++,"\n"===c?(parser.line++,parser.column=0):parser.column++),parser.state){case S.BEGIN:if(parser.state=S.BEGIN_WHITESPACE,"\ufeff"===c)continue;beginWhiteSpace(parser,c);continue;case S.BEGIN_WHITESPACE:beginWhiteSpace(parser,c);continue;case S.TEXT:if(parser.sawRoot&&!parser.closedRoot){for(var starti=i-1;c&&"<"!==c&&"&"!==c;)c=charAt(chunk,i++),c&&parser.trackPosition&&(parser.position++,"\n"===c?(parser.line++,parser.column=0):parser.column++);parser.textNode+=chunk.substring(starti,i-1)}"<"!==c||parser.sawRoot&&parser.closedRoot&&!parser.strict?(!not(whitespace,c)||parser.sawRoot&&!parser.closedRoot||strictFail(parser,"Text data outside of root node."),"&"===c?parser.state=S.TEXT_ENTITY:parser.textNode+=c):(parser.state=S.OPEN_WAKA,parser.startTagPosition=parser.position);continue;case S.SCRIPT:"<"===c?parser.state=S.SCRIPT_ENDING:parser.script+=c;continue;case S.SCRIPT_ENDING:"/"===c?parser.state=S.CLOSE_TAG:(parser.script+="<"+c,parser.state=S.SCRIPT);continue;case S.OPEN_WAKA:if("!"===c)parser.state=S.SGML_DECL,parser.sgmlDecl="";else if(is(whitespace,c));else if(is(nameStart,c))parser.state=S.OPEN_TAG,parser.tagName=c;else if("/"===c)parser.state=S.CLOSE_TAG,parser.tagName="";else if("?"===c)parser.state=S.PROC_INST,parser.procInstName=parser.procInstBody="";else{if(strictFail(parser,"Unencoded <"),parser.startTagPosition+1<parser.position){var pad=parser.position-parser.startTagPosition;c=new Array(pad).join(" ")+c}parser.textNode+="<"+c,parser.state=S.TEXT}continue;case S.SGML_DECL:(parser.sgmlDecl+c).toUpperCase()===CDATA?(emitNode(parser,"onopencdata"),parser.state=S.CDATA,parser.sgmlDecl="",parser.cdata=""):parser.sgmlDecl+c==="--"?(parser.state=S.COMMENT,parser.comment="",parser.sgmlDecl=""):(parser.sgmlDecl+c).toUpperCase()===DOCTYPE?(parser.state=S.DOCTYPE,(parser.doctype||parser.sawRoot)&&strictFail(parser,"Inappropriately located doctype declaration"),parser.doctype="",parser.sgmlDecl=""):">"===c?(emitNode(parser,"onsgmldeclaration",parser.sgmlDecl),parser.sgmlDecl="",parser.state=S.TEXT):is(quote,c)?(parser.state=S.SGML_DECL_QUOTED,parser.sgmlDecl+=c):parser.sgmlDecl+=c;continue;case S.SGML_DECL_QUOTED:c===parser.q&&(parser.state=S.SGML_DECL,parser.q=""),parser.sgmlDecl+=c;continue;case S.DOCTYPE:">"===c?(parser.state=S.TEXT,emitNode(parser,"ondoctype",parser.doctype),parser.doctype=!0):(parser.doctype+=c,"["===c?parser.state=S.DOCTYPE_DTD:is(quote,c)&&(parser.state=S.DOCTYPE_QUOTED,parser.q=c));continue;case S.DOCTYPE_QUOTED:parser.doctype+=c,c===parser.q&&(parser.q="",parser.state=S.DOCTYPE);continue;case S.DOCTYPE_DTD:parser.doctype+=c,"]"===c?parser.state=S.DOCTYPE:is(quote,c)&&(parser.state=S.DOCTYPE_DTD_QUOTED,parser.q=c);continue;case S.DOCTYPE_DTD_QUOTED:parser.doctype+=c,c===parser.q&&(parser.state=S.DOCTYPE_DTD,parser.q="");continue;case S.COMMENT:"-"===c?parser.state=S.COMMENT_ENDING:parser.comment+=c;continue;case S.COMMENT_ENDING:"-"===c?(parser.state=S.COMMENT_ENDED,parser.comment=textopts(parser.opt,parser.comment),parser.comment&&emitNode(parser,"oncomment",parser.comment),parser.comment=""):(parser.comment+="-"+c,parser.state=S.COMMENT);continue;case S.COMMENT_ENDED:">"!==c?(strictFail(parser,"Malformed comment"),parser.comment+="--"+c,parser.state=S.COMMENT):parser.state=S.TEXT;continue;case S.CDATA:"]"===c?parser.state=S.CDATA_ENDING:parser.cdata+=c;continue;case S.CDATA_ENDING:"]"===c?parser.state=S.CDATA_ENDING_2:(parser.cdata+="]"+c,parser.state=S.CDATA);continue;case S.CDATA_ENDING_2:">"===c?(parser.cdata&&emitNode(parser,"oncdata",parser.cdata),emitNode(parser,"onclosecdata"),parser.cdata="",parser.state=S.TEXT):"]"===c?parser.cdata+="]":(parser.cdata+="]]"+c,parser.state=S.CDATA);continue;case S.PROC_INST:"?"===c?parser.state=S.PROC_INST_ENDING:is(whitespace,c)?parser.state=S.PROC_INST_BODY:parser.procInstName+=c;continue;case S.PROC_INST_BODY:if(!parser.procInstBody&&is(whitespace,c))continue;"?"===c?parser.state=S.PROC_INST_ENDING:parser.procInstBody+=c;continue;case S.PROC_INST_ENDING:">"===c?(emitNode(parser,"onprocessinginstruction",{name:parser.procInstName,body:parser.procInstBody}),parser.procInstName=parser.procInstBody="",parser.state=S.TEXT):(parser.procInstBody+="?"+c,parser.state=S.PROC_INST_BODY);continue;case S.OPEN_TAG:is(nameBody,c)?parser.tagName+=c:(newTag(parser),">"===c?openTag(parser):"/"===c?parser.state=S.OPEN_TAG_SLASH:(not(whitespace,c)&&strictFail(parser,"Invalid character in tag name"),parser.state=S.ATTRIB));continue;case S.OPEN_TAG_SLASH:">"===c?(openTag(parser,!0),closeTag(parser)):(strictFail(parser,"Forward-slash in opening tag not followed by >"),parser.state=S.ATTRIB);continue;case S.ATTRIB:if(is(whitespace,c))continue;">"===c?openTag(parser):"/"===c?parser.state=S.OPEN_TAG_SLASH:is(nameStart,c)?(parser.attribName=c,parser.attribValue="",parser.state=S.ATTRIB_NAME):strictFail(parser,"Invalid attribute name");continue;case S.ATTRIB_NAME:"="===c?parser.state=S.ATTRIB_VALUE:">"===c?(strictFail(parser,"Attribute without value"),parser.attribValue=parser.attribName,attrib(parser),openTag(parser)):is(whitespace,c)?parser.state=S.ATTRIB_NAME_SAW_WHITE:is(nameBody,c)?parser.attribName+=c:strictFail(parser,"Invalid attribute name");continue;case S.ATTRIB_NAME_SAW_WHITE:if("="===c)parser.state=S.ATTRIB_VALUE;else{if(is(whitespace,c))continue;strictFail(parser,"Attribute without value"),parser.tag.attributes[parser.attribName]="",parser.attribValue="",emitNode(parser,"onattribute",{name:parser.attribName,value:""}),parser.attribName="",">"===c?openTag(parser):is(nameStart,c)?(parser.attribName=c,parser.state=S.ATTRIB_NAME):(strictFail(parser,"Invalid attribute name"),parser.state=S.ATTRIB)}continue;case S.ATTRIB_VALUE:if(is(whitespace,c))continue;is(quote,c)?(parser.q=c,parser.state=S.ATTRIB_VALUE_QUOTED):(strictFail(parser,"Unquoted attribute value"),parser.state=S.ATTRIB_VALUE_UNQUOTED,parser.attribValue=c);continue;case S.ATTRIB_VALUE_QUOTED:if(c!==parser.q){"&"===c?parser.state=S.ATTRIB_VALUE_ENTITY_Q:parser.attribValue+=c;continue}attrib(parser),parser.q="",parser.state=S.ATTRIB_VALUE_CLOSED;continue;case S.ATTRIB_VALUE_CLOSED:is(whitespace,c)?parser.state=S.ATTRIB:">"===c?openTag(parser):"/"===c?parser.state=S.OPEN_TAG_SLASH:is(nameStart,c)?(strictFail(parser,"No whitespace between attributes"),parser.attribName=c,parser.attribValue="",parser.state=S.ATTRIB_NAME):strictFail(parser,"Invalid attribute name");continue;case S.ATTRIB_VALUE_UNQUOTED:if(not(attribEnd,c)){"&"===c?parser.state=S.ATTRIB_VALUE_ENTITY_U:parser.attribValue+=c;continue}attrib(parser),">"===c?openTag(parser):parser.state=S.ATTRIB;continue;case S.CLOSE_TAG:if(parser.tagName)">"===c?closeTag(parser):is(nameBody,c)?parser.tagName+=c:parser.script?(parser.script+="</"+parser.tagName,parser.tagName="",parser.state=S.SCRIPT):(not(whitespace,c)&&strictFail(parser,"Invalid tagname in closing tag"),parser.state=S.CLOSE_TAG_SAW_WHITE);else{if(is(whitespace,c))continue;not(nameStart,c)?parser.script?(parser.script+="</"+c,parser.state=S.SCRIPT):strictFail(parser,"Invalid tagname in closing tag."):parser.tagName=c}continue;case S.CLOSE_TAG_SAW_WHITE:if(is(whitespace,c))continue;">"===c?closeTag(parser):strictFail(parser,"Invalid characters in closing tag");continue;case S.TEXT_ENTITY:case S.ATTRIB_VALUE_ENTITY_Q:case S.ATTRIB_VALUE_ENTITY_U:var returnState,buffer;switch(parser.state){case S.TEXT_ENTITY:returnState=S.TEXT,buffer="textNode";break;case S.ATTRIB_VALUE_ENTITY_Q:returnState=S.ATTRIB_VALUE_QUOTED,buffer="attribValue";break;case S.ATTRIB_VALUE_ENTITY_U:returnState=S.ATTRIB_VALUE_UNQUOTED,buffer="attribValue"}";"===c?(parser[buffer]+=parseEntity(parser),parser.entity="",parser.state=returnState):is(parser.entity.length?entityBody:entityStart,c)?parser.entity+=c:(strictFail(parser,"Invalid character in entity name"),parser[buffer]+="&"+parser.entity+c,parser.entity="",parser.state=returnState);continue;default:throw new Error(parser,"Unknown state: "+parser.state)}}return parser.position>=parser.bufferCheckPosition&&checkBufferLength(parser),parser}sax.parser=function(strict,opt){return new SAXParser(strict,opt)},sax.SAXParser=SAXParser,sax.SAXStream=SAXStream,sax.createStream=createStream,sax.MAX_BUFFER_LENGTH=65536;var buffers=["comment","sgmlDecl","textNode","tagName","doctype","procInstName","procInstBody","entity","attribName","attribValue","cdata","script"];sax.EVENTS=["text","processinginstruction","sgmldeclaration","doctype","comment","opentagstart","attribute","opentag","closetag","opencdata","cdata","closecdata","error","end","ready","script","opennamespace","closenamespace"],Object.create||(Object.create=function(o){function F(){}F.prototype=o;var newf=new F;return newf}),Object.keys||(Object.keys=function(o){var a=[];for(var i in o)o.hasOwnProperty(i)&&a.push(i);return a}),SAXParser.prototype={end:function(){end(this)},write:write,resume:function(){return this.error=null,this},close:function(){return this.write(null)},flush:function(){flushBuffers(this)}};var Stream;try{Stream=__webpack_require__(169).Stream}catch(ex){Stream=function(){}}var streamWraps=sax.EVENTS.filter(function(ev){return"error"!==ev&&"end"!==ev});SAXStream.prototype=Object.create(Stream.prototype,{constructor:{value:SAXStream}}),SAXStream.prototype.write=function(data){if("function"==typeof Buffer&&"function"==typeof Buffer.isBuffer&&Buffer.isBuffer(data)){if(!this._decoder){var SD=__webpack_require__(261).StringDecoder;this._decoder=new SD("utf8")}data=this._decoder.write(data)}return this._parser.write(data.toString()),this.emit("data",data),!0},SAXStream.prototype.end=function(chunk){return chunk&&chunk.length&&this.write(chunk),this._parser.end(),!0},SAXStream.prototype.on=function(ev,handler){var me=this;return me._parser["on"+ev]||streamWraps.indexOf(ev)===-1||(me._parser["on"+ev]=function(){var args=1===arguments.length?[arguments[0]]:Array.apply(null,arguments);args.splice(0,0,ev),me.emit.apply(me,args)}),Stream.prototype.on.call(me,ev,handler)};var whitespace="\r\n\t ",number="0124356789",letter="abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ",quote="'\"",attribEnd=whitespace+">",CDATA="[CDATA[",DOCTYPE="DOCTYPE",XML_NAMESPACE="http://www.w3.org/XML/1998/namespace",XMLNS_NAMESPACE="http://www.w3.org/2000/xmlns/",rootNS={xml:XML_NAMESPACE,xmlns:XMLNS_NAMESPACE};whitespace=charClass(whitespace),number=charClass(number),letter=charClass(letter);var nameStart=/[:_A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD]/,nameBody=/[:_A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD\u00B7\u0300-\u036F\u203F-\u2040\.\d-]/,entityStart=/[#:_A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD]/,entityBody=/[#:_A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD\u00B7\u0300-\u036F\u203F-\u2040\.\d-]/;quote=charClass(quote),attribEnd=charClass(attribEnd);var S=0;sax.STATE={BEGIN:S++,BEGIN_WHITESPACE:S++,TEXT:S++,TEXT_ENTITY:S++,OPEN_WAKA:S++,SGML_DECL:S++,SGML_DECL_QUOTED:S++,DOCTYPE:S++,DOCTYPE_QUOTED:S++,DOCTYPE_DTD:S++,DOCTYPE_DTD_QUOTED:S++,COMMENT_STARTING:S++,COMMENT:S++,COMMENT_ENDING:S++,COMMENT_ENDED:S++,CDATA:S++,CDATA_ENDING:S++,CDATA_ENDING_2:S++,PROC_INST:S++,PROC_INST_BODY:S++,PROC_INST_ENDING:S++,OPEN_TAG:S++,OPEN_TAG_SLASH:S++,ATTRIB:S++,ATTRIB_NAME:S++,ATTRIB_NAME_SAW_WHITE:S++,ATTRIB_VALUE:S++,ATTRIB_VALUE_QUOTED:S++,ATTRIB_VALUE_CLOSED:S++,ATTRIB_VALUE_UNQUOTED:S++,ATTRIB_VALUE_ENTITY_Q:S++,ATTRIB_VALUE_ENTITY_U:S++,CLOSE_TAG:S++,CLOSE_TAG_SAW_WHITE:S++,SCRIPT:S++,SCRIPT_ENDING:S++},sax.XML_ENTITIES={amp:"&",gt:">",lt:"<",quot:'"',apos:"'"},sax.ENTITIES={amp:"&",gt:">",lt:"<",quot:'"',apos:"'",AElig:198,Aacute:193,Acirc:194,Agrave:192,Aring:197,Atilde:195,Auml:196,Ccedil:199,ETH:208,Eacute:201,Ecirc:202,Egrave:200,Euml:203,Iacute:205,Icirc:206,Igrave:204,Iuml:207,Ntilde:209,Oacute:211,Ocirc:212,Ograve:210,Oslash:216,Otilde:213,Ouml:214,THORN:222,Uacute:218,Ucirc:219,Ugrave:217,Uuml:220,Yacute:221,aacute:225,acirc:226,aelig:230,agrave:224,aring:229,atilde:227,auml:228,ccedil:231,eacute:233,ecirc:234,egrave:232,eth:240,euml:235,iacute:237,icirc:238,igrave:236,iuml:239,ntilde:241,oacute:243,ocirc:244,ograve:242,oslash:248,otilde:245,ouml:246,szlig:223,thorn:254,uacute:250,ucirc:251,ugrave:249,uuml:252,yacute:253,yuml:255,copy:169,reg:174,nbsp:160,iexcl:161,cent:162,pound:163,curren:164,yen:165,brvbar:166,sect:167,uml:168,ordf:170,laquo:171,not:172,shy:173,macr:175,deg:176,plusmn:177,sup1:185,sup2:178,sup3:179,acute:180,micro:181,para:182,middot:183,cedil:184,ordm:186,raquo:187,frac14:188,frac12:189,frac34:190,iquest:191,times:215,divide:247,OElig:338,oelig:339,Scaron:352,scaron:353,Yuml:376,fnof:402,circ:710,tilde:732,Alpha:913,Beta:914,Gamma:915,Delta:916,Epsilon:917,Zeta:918,Eta:919,Theta:920,Iota:921,Kappa:922,Lambda:923,Mu:924,Nu:925,Xi:926,Omicron:927,Pi:928,Rho:929,Sigma:931,Tau:932,Upsilon:933,Phi:934,Chi:935,Psi:936,Omega:937,alpha:945,beta:946,gamma:947,delta:948,epsilon:949,zeta:950,eta:951,theta:952,iota:953,kappa:954,lambda:955,mu:956,nu:957,xi:958,omicron:959,pi:960,rho:961,sigmaf:962,sigma:963,tau:964,upsilon:965,phi:966,chi:967,psi:968,omega:969,thetasym:977,upsih:978,piv:982,ensp:8194,emsp:8195,thinsp:8201,zwnj:8204,zwj:8205,lrm:8206,rlm:8207,ndash:8211,mdash:8212,lsquo:8216,rsquo:8217,sbquo:8218,ldquo:8220,rdquo:8221,bdquo:8222,dagger:8224,Dagger:8225,bull:8226,hellip:8230,permil:8240,prime:8242,Prime:8243,lsaquo:8249,rsaquo:8250,oline:8254,frasl:8260,euro:8364,image:8465,weierp:8472,real:8476,trade:8482,alefsym:8501,larr:8592,uarr:8593,rarr:8594,darr:8595,harr:8596,crarr:8629,lArr:8656,uArr:8657,rArr:8658,dArr:8659,hArr:8660,forall:8704,part:8706,exist:8707,empty:8709,nabla:8711,isin:8712,notin:8713,ni:8715,prod:8719,sum:8721,minus:8722,lowast:8727,radic:8730,prop:8733,infin:8734,ang:8736,and:8743,or:8744,cap:8745,cup:8746,int:8747,there4:8756,sim:8764,cong:8773,asymp:8776,ne:8800,equiv:8801,le:8804,ge:8805,sub:8834,sup:8835,nsub:8836,sube:8838,supe:8839,oplus:8853,otimes:8855,perp:8869,sdot:8901,lceil:8968,
rceil:8969,lfloor:8970,rfloor:8971,lang:9001,rang:9002,loz:9674,spades:9824,clubs:9827,hearts:9829,diams:9830},Object.keys(sax.ENTITIES).forEach(function(key){var e=sax.ENTITIES[key],s="number"==typeof e?String.fromCharCode(e):e;sax.ENTITIES[key]=s});for(var s in sax.STATE)sax.STATE[sax.STATE[s]]=s;S=sax.STATE,String.fromCodePoint||!function(){var stringFromCharCode=String.fromCharCode,floor=Math.floor,fromCodePoint=function(){var highSurrogate,lowSurrogate,MAX_SIZE=16384,codeUnits=[],index=-1,length=arguments.length;if(!length)return"";for(var result="";++index<length;){var codePoint=Number(arguments[index]);if(!isFinite(codePoint)||codePoint<0||codePoint>1114111||floor(codePoint)!==codePoint)throw RangeError("Invalid code point: "+codePoint);codePoint<=65535?codeUnits.push(codePoint):(codePoint-=65536,highSurrogate=(codePoint>>10)+55296,lowSurrogate=codePoint%1024+56320,codeUnits.push(highSurrogate,lowSurrogate)),(index+1===length||codeUnits.length>MAX_SIZE)&&(result+=stringFromCharCode.apply(null,codeUnits),codeUnits.length=0)}return result};Object.defineProperty?Object.defineProperty(String,"fromCodePoint",{value:fromCodePoint,configurable:!0,writable:!0}):String.fromCodePoint=fromCodePoint}()}("undefined"==typeof exports?this.sax={}:exports)}).call(exports,__webpack_require__(92).Buffer)},function(module,exports,__webpack_require__){},function(module,exports,__webpack_require__){function assertEncoding(encoding){if(encoding&&!isBufferEncoding(encoding))throw new Error("Unknown encoding: "+encoding)}function passThroughWrite(buffer){return buffer.toString(this.encoding)}function utf16DetectIncompleteChar(buffer){this.charReceived=buffer.length%2,this.charLength=this.charReceived?2:0}function base64DetectIncompleteChar(buffer){this.charReceived=buffer.length%3,this.charLength=this.charReceived?3:0}var Buffer=__webpack_require__(92).Buffer,isBufferEncoding=Buffer.isEncoding||function(encoding){switch(encoding&&encoding.toLowerCase()){case"hex":case"utf8":case"utf-8":case"ascii":case"binary":case"base64":case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":case"raw":return!0;default:return!1}},StringDecoder=exports.StringDecoder=function(encoding){switch(this.encoding=(encoding||"utf8").toLowerCase().replace(/[-_]/,""),assertEncoding(encoding),this.encoding){case"utf8":this.surrogateSize=3;break;case"ucs2":case"utf16le":this.surrogateSize=2,this.detectIncompleteChar=utf16DetectIncompleteChar;break;case"base64":this.surrogateSize=3,this.detectIncompleteChar=base64DetectIncompleteChar;break;default:return void(this.write=passThroughWrite)}this.charBuffer=new Buffer(6),this.charReceived=0,this.charLength=0};StringDecoder.prototype.write=function(buffer){for(var charStr="";this.charLength;){var available=buffer.length>=this.charLength-this.charReceived?this.charLength-this.charReceived:buffer.length;if(buffer.copy(this.charBuffer,this.charReceived,0,available),this.charReceived+=available,this.charReceived<this.charLength)return"";buffer=buffer.slice(available,buffer.length),charStr=this.charBuffer.slice(0,this.charLength).toString(this.encoding);var charCode=charStr.charCodeAt(charStr.length-1);if(!(charCode>=55296&&charCode<=56319)){if(this.charReceived=this.charLength=0,0===buffer.length)return charStr;break}this.charLength+=this.surrogateSize,charStr=""}this.detectIncompleteChar(buffer);var end=buffer.length;this.charLength&&(buffer.copy(this.charBuffer,0,buffer.length-this.charReceived,end),end-=this.charReceived),charStr+=buffer.toString(this.encoding,0,end);var end=charStr.length-1,charCode=charStr.charCodeAt(end);if(charCode>=55296&&charCode<=56319){var size=this.surrogateSize;return this.charLength+=size,this.charReceived+=size,this.charBuffer.copy(this.charBuffer,size,0,size),buffer.copy(this.charBuffer,0,0,size),charStr.substring(0,end)}return charStr},StringDecoder.prototype.detectIncompleteChar=function(buffer){for(var i=buffer.length>=3?3:buffer.length;i>0;i--){var c=buffer[buffer.length-i];if(1==i&&c>>5==6){this.charLength=2;break}if(i<=2&&c>>4==14){this.charLength=3;break}if(i<=3&&c>>3==30){this.charLength=4;break}}this.charReceived=i},StringDecoder.prototype.end=function(buffer){var res="";if(buffer&&buffer.length&&(res=this.write(buffer)),this.charReceived){var cr=this.charReceived,buf=this.charBuffer,enc=this.encoding;res+=buf.slice(0,cr).toString(enc)}return res}},function(module,exports,__webpack_require__){(function(module,global){function checkGlobal(value){return value&&value.Object===Object?value:null}function isHostObject(value){var result=!1;if(null!=value&&"function"!=typeof value.toString)try{result=!!(value+"")}catch(e){}return result}function Hash(){}function hashDelete(hash,key){return hashHas(hash,key)&&delete hash[key]}function hashGet(hash,key){if(nativeCreate){var result=hash[key];return result===HASH_UNDEFINED?void 0:result}return hasOwnProperty.call(hash,key)?hash[key]:void 0}function hashHas(hash,key){return nativeCreate?void 0!==hash[key]:hasOwnProperty.call(hash,key)}function hashSet(hash,key,value){hash[key]=nativeCreate&&void 0===value?HASH_UNDEFINED:value}function MapCache(values){var index=-1,length=values?values.length:0;for(this.clear();++index<length;){var entry=values[index];this.set(entry[0],entry[1])}}function mapClear(){this.__data__={hash:new Hash,map:Map?new Map:[],string:new Hash}}function mapDelete(key){var data=this.__data__;return isKeyable(key)?hashDelete("string"==typeof key?data.string:data.hash,key):Map?data.map.delete(key):assocDelete(data.map,key)}function mapGet(key){var data=this.__data__;return isKeyable(key)?hashGet("string"==typeof key?data.string:data.hash,key):Map?data.map.get(key):assocGet(data.map,key)}function mapHas(key){var data=this.__data__;return isKeyable(key)?hashHas("string"==typeof key?data.string:data.hash,key):Map?data.map.has(key):assocHas(data.map,key)}function mapSet(key,value){var data=this.__data__;return isKeyable(key)?hashSet("string"==typeof key?data.string:data.hash,key,value):Map?data.map.set(key,value):assocSet(data.map,key,value),this}function assocDelete(array,key){var index=assocIndexOf(array,key);if(index<0)return!1;var lastIndex=array.length-1;return index==lastIndex?array.pop():splice.call(array,index,1),!0}function assocGet(array,key){var index=assocIndexOf(array,key);return index<0?void 0:array[index][1]}function assocHas(array,key){return assocIndexOf(array,key)>-1}function assocIndexOf(array,key){for(var length=array.length;length--;)if(eq(array[length][0],key))return length;return-1}function assocSet(array,key,value){var index=assocIndexOf(array,key);index<0?array.push([key,value]):array[index][1]=value}function getNative(object,key){var value=object[key];return isNative(value)?value:void 0}function isKeyable(value){var type=typeof value;return"number"==type||"boolean"==type||"string"==type&&"__proto__"!=value||null==value}function toSource(func){if(null!=func){try{return funcToString.call(func)}catch(e){}try{return func+""}catch(e){}}return""}function memoize(func,resolver){if("function"!=typeof func||resolver&&"function"!=typeof resolver)throw new TypeError(FUNC_ERROR_TEXT);var memoized=function(){var args=arguments,key=resolver?resolver.apply(this,args):args[0],cache=memoized.cache;if(cache.has(key))return cache.get(key);var result=func.apply(this,args);return memoized.cache=cache.set(key,result),result};return memoized.cache=new(memoize.Cache||MapCache),memoized}function eq(value,other){return value===other||value!==value&&other!==other}function isFunction(value){var tag=isObject(value)?objectToString.call(value):"";return tag==funcTag||tag==genTag}function isObject(value){var type=typeof value;return!!value&&("object"==type||"function"==type)}function isObjectLike(value){return!!value&&"object"==typeof value}function isNative(value){if(!isObject(value))return!1;var pattern=isFunction(value)||isHostObject(value)?reIsNative:reIsHostCtor;return pattern.test(toSource(value))}function isSymbol(value){return"symbol"==typeof value||isObjectLike(value)&&objectToString.call(value)==symbolTag}function toString(value){if("string"==typeof value)return value;if(null==value)return"";if(isSymbol(value))return symbolToString?symbolToString.call(value):"";var result=value+"";return"0"==result&&1/value==-INFINITY?"-0":result}var FUNC_ERROR_TEXT="Expected a function",HASH_UNDEFINED="__lodash_hash_undefined__",INFINITY=1/0,funcTag="[object Function]",genTag="[object GeneratorFunction]",symbolTag="[object Symbol]",rePropName=/[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]/g,reRegExpChar=/[\\^$.*+?()[\]{}|]/g,reEscapeChar=/\\(\\)?/g,reIsHostCtor=/^\[object .+?Constructor\]$/,objectTypes={function:!0,object:!0},freeExports=objectTypes[typeof exports]&&exports&&!exports.nodeType?exports:void 0,freeModule=objectTypes[typeof module]&&module&&!module.nodeType?module:void 0,freeGlobal=checkGlobal(freeExports&&freeModule&&"object"==typeof global&&global),freeSelf=checkGlobal(objectTypes[typeof self]&&self),freeWindow=checkGlobal(objectTypes[typeof window]&&window),thisGlobal=checkGlobal(objectTypes[typeof this]&&this),root=freeGlobal||freeWindow!==(thisGlobal&&thisGlobal.window)&&freeWindow||freeSelf||thisGlobal||Function("return this")(),arrayProto=Array.prototype,objectProto=Object.prototype,funcToString=Function.prototype.toString,hasOwnProperty=objectProto.hasOwnProperty,objectToString=objectProto.toString,reIsNative=RegExp("^"+funcToString.call(hasOwnProperty).replace(reRegExpChar,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$"),Symbol=root.Symbol,splice=arrayProto.splice,Map=getNative(root,"Map"),nativeCreate=getNative(Object,"create"),symbolProto=Symbol?Symbol.prototype:void 0,symbolToString=symbolProto?symbolProto.toString:void 0;Hash.prototype=nativeCreate?nativeCreate(null):objectProto,MapCache.prototype.clear=mapClear,MapCache.prototype.delete=mapDelete,MapCache.prototype.get=mapGet,MapCache.prototype.has=mapHas,MapCache.prototype.set=mapSet;var stringToPath=memoize(function(string){var result=[];return toString(string).replace(rePropName,function(match,number,quote,string){result.push(quote?string.replace(reEscapeChar,"$1"):number||match)}),result});memoize.Cache=MapCache,module.exports=stringToPath}).call(exports,__webpack_require__(138)(module),function(){return this}())},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function toDate(date){return(0,_assertString2.default)(date),date=Date.parse(date),isNaN(date)?null:new Date(date)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=toDate;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString);module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function toFloat(str){return(0,_assertString2.default)(str),parseFloat(str)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=toFloat;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString);module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function toInt(str,radix){return(0,_assertString2.default)(str),parseInt(str,radix||10)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=toInt;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString);module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function toBoolean(str,strict){return(0,_assertString2.default)(str),strict?"1"===str||"true"===str:"0"!==str&&"false"!==str&&""!==str}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=toBoolean;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString);module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function equals(str,comparison){return(0,_assertString2.default)(str),str===comparison}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=equals;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString);module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function contains(str,elem){return(0,_assertString2.default)(str),str.indexOf((0,_toString2.default)(elem))>=0}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=contains;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString),_toString=__webpack_require__(321),_toString2=_interopRequireDefault(_toString);module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function matches(str,pattern,modifiers){return(0,_assertString2.default)(str),"[object RegExp]"!==Object.prototype.toString.call(pattern)&&(pattern=new RegExp(pattern,modifiers)),pattern.test(str)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=matches;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString);module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isEmail(str,options){if((0,_assertString2.default)(str),options=(0,_merge2.default)(options,default_email_options),options.allow_display_name){var display_email=str.match(displayName);display_email&&(str=display_email[1])}var parts=str.split("@"),domain=parts.pop(),user=parts.join("@"),lower_domain=domain.toLowerCase();if("gmail.com"!==lower_domain&&"googlemail.com"!==lower_domain||(user=user.replace(/\./g,"").toLowerCase()),!(0,_isByteLength2.default)(user,{max:64})||!(0,_isByteLength2.default)(domain,{max:256}))return!1;if(!(0,_isFQDN2.default)(domain,{require_tld:options.require_tld}))return!1;if('"'===user[0])return user=user.slice(1,user.length-1),options.allow_utf8_local_part?quotedEmailUserUtf8.test(user):quotedEmailUser.test(user);for(var pattern=options.allow_utf8_local_part?emailUserUtf8Part:emailUserPart,user_parts=user.split("."),i=0;i<user_parts.length;i++)if(!pattern.test(user_parts[i]))return!1;return!0}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=isEmail;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString),_merge=__webpack_require__(328),_merge2=_interopRequireDefault(_merge),_isByteLength=__webpack_require__(296),_isByteLength2=_interopRequireDefault(_isByteLength),_isFQDN=__webpack_require__(274),_isFQDN2=_interopRequireDefault(_isFQDN),default_email_options={allow_display_name:!1,allow_utf8_local_part:!0,require_tld:!0},displayName=/^[a-z\d!#\$%&'\*\+\-\/=\?\^_`{\|}~\.\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+[a-z\d!#\$%&'\*\+\-\/=\?\^_`{\|}~\.\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF\s]*<(.+)>$/i,emailUserPart=/^[a-z\d!#\$%&'\*\+\-\/=\?\^_`{\|}~]+$/i,quotedEmailUser=/^([\s\x01-\x08\x0b\x0c\x0e-\x1f\x7f\x21\x23-\x5b\x5d-\x7e]|(\\[\x01-\x09\x0b\x0c\x0d-\x7f]))*$/i,emailUserUtf8Part=/^[a-z\d!#\$%&'\*\+\-\/=\?\^_`{\|}~\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+$/i,quotedEmailUserUtf8=/^([\s\x01-\x08\x0b\x0c\x0e-\x1f\x7f\x21\x23-\x5b\x5d-\x7e\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]|(\\[\x01-\x09\x0b\x0c\x0d-\x7f\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))*$/i;module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isURL(url,options){if((0,_assertString2.default)(url),!url||url.length>=2083||/\s/.test(url))return!1;if(0===url.indexOf("mailto:"))return!1;options=(0,_merge2.default)(options,default_url_options);var protocol=void 0,auth=void 0,host=void 0,hostname=void 0,port=void 0,port_str=void 0,split=void 0;if(split=url.split("#"),url=split.shift(),split=url.split("?"),url=split.shift(),split=url.split("://"),split.length>1){if(protocol=split.shift(),options.require_valid_protocol&&options.protocols.indexOf(protocol)===-1)return!1}else{if(options.require_protocol)return!1;options.allow_protocol_relative_urls&&"//"===url.substr(0,2)&&(split[0]=url.substr(2))}return url=split.join("://"),split=url.split("/"),url=split.shift(),split=url.split("@"),!(split.length>1&&(auth=split.shift(),auth.indexOf(":")>=0&&auth.split(":").length>2))&&(hostname=split.join("@"),split=hostname.split(":"),host=split.shift(),!(split.length&&(port_str=split.join(":"),port=parseInt(port_str,10),!/^[0-9]+$/.test(port_str)||port<=0||port>65535))&&(!(!(0,_isIP2.default)(host)&&!(0,_isFQDN2.default)(host,options)&&"localhost"!==host)&&((!options.host_whitelist||options.host_whitelist.indexOf(host)!==-1)&&(!options.host_blacklist||options.host_blacklist.indexOf(host)===-1))))}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=isURL;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString),_isFQDN=__webpack_require__(274),_isFQDN2=_interopRequireDefault(_isFQDN),_isIP=__webpack_require__(273),_isIP2=_interopRequireDefault(_isIP),_merge=__webpack_require__(328),_merge2=_interopRequireDefault(_merge),default_url_options={protocols:["http","https","ftp"],require_tld:!0,require_protocol:!1,require_valid_protocol:!0,allow_underscores:!1,allow_trailing_dot:!1,allow_protocol_relative_urls:!1};module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isMACAddress(str){return(0,_assertString2.default)(str),macAddress.test(str)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=isMACAddress;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString),macAddress=/^([0-9a-fA-F][0-9a-fA-F]:){5}([0-9a-fA-F][0-9a-fA-F])$/;module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isIP(str){var version=arguments.length<=1||void 0===arguments[1]?"":arguments[1];if((0,_assertString2.default)(str),version=String(version),!version)return isIP(str,4)||isIP(str,6);if("4"===version){if(!ipv4Maybe.test(str))return!1;var parts=str.split(".").sort(function(a,b){return a-b});return parts[3]<=255}if("6"===version){var blocks=str.split(":"),foundOmissionBlock=!1,foundIPv4TransitionBlock=isIP(blocks[blocks.length-1],4),expectedNumberOfBlocks=foundIPv4TransitionBlock?7:8;if(blocks.length>expectedNumberOfBlocks)return!1;if("::"===str)return!0;"::"===str.substr(0,2)?(blocks.shift(),blocks.shift(),foundOmissionBlock=!0):"::"===str.substr(str.length-2)&&(blocks.pop(),blocks.pop(),foundOmissionBlock=!0);for(var i=0;i<blocks.length;++i)if(""===blocks[i]&&i>0&&i<blocks.length-1){if(foundOmissionBlock)return!1;foundOmissionBlock=!0}else if(foundIPv4TransitionBlock&&i===blocks.length-1);else if(!ipv6Block.test(blocks[i]))return!1;return foundOmissionBlock?blocks.length>=1:blocks.length===expectedNumberOfBlocks}return!1}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=isIP;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString),ipv4Maybe=/^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/,ipv6Block=/^[0-9A-F]{1,4}$/i;module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isFDQN(str,options){(0,_assertString2.default)(str),options=(0,_merge2.default)(options,default_fqdn_options),options.allow_trailing_dot&&"."===str[str.length-1]&&(str=str.substring(0,str.length-1));var parts=str.split(".");if(options.require_tld){var tld=parts.pop();if(!parts.length||!/^([a-z\u00a1-\uffff]{2,}|xn[a-z0-9-]{2,})$/i.test(tld))return!1}for(var part,i=0;i<parts.length;i++){if(part=parts[i],options.allow_underscores&&(part=part.replace(/_/g,"")),!/^[a-z\u00a1-\uffff0-9-]+$/i.test(part))return!1;if(/[\uff01-\uff5e]/.test(part))return!1;if("-"===part[0]||"-"===part[part.length-1])return!1}return!0}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=isFDQN;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString),_merge=__webpack_require__(328),_merge2=_interopRequireDefault(_merge),default_fqdn_options={require_tld:!0,allow_underscores:!1,allow_trailing_dot:!1};module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isBoolean(str){return(0,_assertString2.default)(str),["true","false","1","0"].indexOf(str)>=0}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=isBoolean;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString);module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isAlpha(str){var locale=arguments.length<=1||void 0===arguments[1]?"en-US":arguments[1];if((0,_assertString2.default)(str),locale in _alpha.alpha)return _alpha.alpha[locale].test(str);throw new Error("Invalid locale '"+locale+"'")}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=isAlpha;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString),_alpha=__webpack_require__(329);module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isAlphanumeric(str){var locale=arguments.length<=1||void 0===arguments[1]?"en-US":arguments[1];if((0,_assertString2.default)(str),locale in _alpha.alphanumeric)return _alpha.alphanumeric[locale].test(str);throw new Error("Invalid locale '"+locale+"'")}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=isAlphanumeric;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString),_alpha=__webpack_require__(329);module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isNumeric(str){return(0,_assertString2.default)(str),numeric.test(str)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=isNumeric;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString),numeric=/^[-+]?[0-9]+$/;module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isLowercase(str){return(0,_assertString2.default)(str),str===str.toLowerCase()}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=isLowercase;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString);module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isUppercase(str){return(0,_assertString2.default)(str),str===str.toUpperCase()}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=isUppercase;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString);module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isAscii(str){return(0,_assertString2.default)(str),ascii.test(str)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=isAscii;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString),ascii=/^[\x00-\x7F]+$/;module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isFullWidth(str){return(0,_assertString2.default)(str),fullWidth.test(str)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.fullWidth=void 0,exports.default=isFullWidth;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString),fullWidth=exports.fullWidth=/[^\u0020-\u007E\uFF61-\uFF9F\uFFA0-\uFFDC\uFFE8-\uFFEE0-9a-zA-Z]/},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isHalfWidth(str){return(0,_assertString2.default)(str),halfWidth.test(str)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.halfWidth=void 0,exports.default=isHalfWidth;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString),halfWidth=exports.halfWidth=/[\u0020-\u007E\uFF61-\uFF9F\uFFA0-\uFFDC\uFFE8-\uFFEE0-9a-zA-Z]/},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isVariableWidth(str){return(0,_assertString2.default)(str),_isFullWidth.fullWidth.test(str)&&_isHalfWidth.halfWidth.test(str)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=isVariableWidth;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString),_isFullWidth=__webpack_require__(282),_isHalfWidth=__webpack_require__(283);module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isMultibyte(str){return(0,_assertString2.default)(str),multibyte.test(str)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=isMultibyte;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString),multibyte=/[^\x00-\x7F]/;module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isSurrogatePair(str){return(0,_assertString2.default)(str),surrogatePair.test(str)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=isSurrogatePair;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString),surrogatePair=/[\uD800-\uDBFF][\uDC00-\uDFFF]/;module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isInt(str,options){return(0,_assertString2.default)(str),options=options||{},int.test(str)&&(!options.hasOwnProperty("min")||str>=options.min)&&(!options.hasOwnProperty("max")||str<=options.max)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=isInt;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString),int=/^(?:[-+]?(?:0|[1-9][0-9]*))$/;module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isFloat(str,options){return(0,_assertString2.default)(str),options=options||{},""!==str&&"."!==str&&(float.test(str)&&(!options.hasOwnProperty("min")||str>=options.min)&&(!options.hasOwnProperty("max")||str<=options.max))}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=isFloat;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString),float=/^(?:[-+]?(?:[0-9]+))?(?:\.[0-9]*)?(?:[eE][\+\-]?(?:[0-9]+))?$/;module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isDecimal(str){return(0,_assertString2.default)(str),""!==str&&decimal.test(str)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=isDecimal;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString),decimal=/^[-+]?([0-9]+|\.[0-9]+|[0-9]+\.[0-9]+)$/;module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isHexadecimal(str){return(0,_assertString2.default)(str),hexadecimal.test(str)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=isHexadecimal;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString),hexadecimal=/^[0-9A-F]+$/i;module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isDivisibleBy(str,num){return(0,_assertString2.default)(str),(0,_toFloat2.default)(str)%parseInt(num,10)===0}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=isDivisibleBy;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString),_toFloat=__webpack_require__(264),_toFloat2=_interopRequireDefault(_toFloat);module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isHexColor(str){return(0,_assertString2.default)(str),hexcolor.test(str)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=isHexColor;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString),hexcolor=/^#?([0-9A-F]{3}|[0-9A-F]{6})$/i;module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isJSON(str){(0,_assertString2.default)(str);try{var obj=JSON.parse(str);return!!obj&&"object"===("undefined"==typeof obj?"undefined":_typeof(obj))}catch(e){}return!1}Object.defineProperty(exports,"__esModule",{value:!0});var _typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(obj){return typeof obj}:function(obj){return obj&&"function"==typeof Symbol&&obj.constructor===Symbol?"symbol":typeof obj};exports.default=isJSON;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString);module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isNull(str){return(0,_assertString2.default)(str),0===str.length}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=isNull;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString);module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isLength(str,options){(0,_assertString2.default)(str);var min=void 0,max=void 0;"object"===("undefined"==typeof options?"undefined":_typeof(options))?(min=options.min||0,max=options.max):(min=arguments[1],max=arguments[2]);var surrogatePairs=str.match(/[\uD800-\uDBFF][\uDC00-\uDFFF]/g)||[],len=str.length-surrogatePairs.length;return len>=min&&("undefined"==typeof max||len<=max)}Object.defineProperty(exports,"__esModule",{value:!0
});var _typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(obj){return typeof obj}:function(obj){return obj&&"function"==typeof Symbol&&obj.constructor===Symbol?"symbol":typeof obj};exports.default=isLength;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString);module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isByteLength(str,options){(0,_assertString2.default)(str);var min=void 0,max=void 0;"object"===("undefined"==typeof options?"undefined":_typeof(options))?(min=options.min||0,max=options.max):(min=arguments[1],max=arguments[2]);var len=encodeURI(str).split(/%..|./).length-1;return len>=min&&("undefined"==typeof max||len<=max)}Object.defineProperty(exports,"__esModule",{value:!0});var _typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(obj){return typeof obj}:function(obj){return obj&&"function"==typeof Symbol&&obj.constructor===Symbol?"symbol":typeof obj};exports.default=isByteLength;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString);module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isUUID(str){var version=arguments.length<=1||void 0===arguments[1]?"all":arguments[1];(0,_assertString2.default)(str);var pattern=uuid[version];return pattern&&pattern.test(str)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=isUUID;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString),uuid={3:/^[0-9A-F]{8}-[0-9A-F]{4}-3[0-9A-F]{3}-[0-9A-F]{4}-[0-9A-F]{12}$/i,4:/^[0-9A-F]{8}-[0-9A-F]{4}-4[0-9A-F]{3}-[89AB][0-9A-F]{3}-[0-9A-F]{12}$/i,5:/^[0-9A-F]{8}-[0-9A-F]{4}-5[0-9A-F]{3}-[89AB][0-9A-F]{3}-[0-9A-F]{12}$/i,all:/^[0-9A-F]{8}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{12}$/i};module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isMongoId(str){return(0,_assertString2.default)(str),(0,_isHexadecimal2.default)(str)&&24===str.length}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=isMongoId;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString),_isHexadecimal=__webpack_require__(290),_isHexadecimal2=_interopRequireDefault(_isHexadecimal);module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function getTimezoneOffset(str){var iso8601Parts=str.match(_isISO.iso8601),timezone=void 0,sign=void 0,hours=void 0,minutes=void 0;if(iso8601Parts){if(timezone=iso8601Parts[21],!timezone)return iso8601Parts[12]?null:0;if("z"===timezone||"Z"===timezone)return 0;sign=iso8601Parts[22],timezone.indexOf(":")!==-1?(hours=parseInt(iso8601Parts[23],10),minutes=parseInt(iso8601Parts[24],10)):(hours=0,minutes=parseInt(iso8601Parts[23],10))}else{if(str=str.toLowerCase(),timezone=str.match(/(?:\s|gmt\s*)(-|\+)(\d{1,4})(\s|$)/),!timezone)return str.indexOf("gmt")!==-1?0:null;sign=timezone[1];var offset=timezone[2];3===offset.length&&(offset="0"+offset),offset.length<=2?(hours=0,minutes=parseInt(offset,10)):(hours=parseInt(offset.slice(0,2),10),minutes=parseInt(offset.slice(2,4),10))}return(60*hours+minutes)*("-"===sign?1:-1)}function isDate(str){(0,_assertString2.default)(str);var normalizedDate=new Date(Date.parse(str));if(isNaN(normalizedDate))return!1;var timezoneOffset=getTimezoneOffset(str);if(null!==timezoneOffset){var timezoneDifference=normalizedDate.getTimezoneOffset()-timezoneOffset;normalizedDate=new Date(normalizedDate.getTime()+6e4*timezoneDifference)}var day=String(normalizedDate.getDate()),dayOrYear=void 0,dayOrYearMatches=void 0,year=void 0;return!(dayOrYearMatches=str.match(/(^|[^:\d])[23]\d([^:\d]|$)/g))||(dayOrYear=dayOrYearMatches.map(function(digitString){return digitString.match(/\d+/g)[0]}).join("/"),year=String(normalizedDate.getFullYear()).slice(-2),dayOrYear===day||dayOrYear===year||(dayOrYear===""+day/year||dayOrYear===""+year/day))}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=isDate;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString),_isISO=__webpack_require__(308);module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isAfter(str){var date=arguments.length<=1||void 0===arguments[1]?String(new Date):arguments[1];(0,_assertString2.default)(str);var comparison=(0,_toDate2.default)(date),original=(0,_toDate2.default)(str);return!!(original&&comparison&&original>comparison)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=isAfter;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString),_toDate=__webpack_require__(263),_toDate2=_interopRequireDefault(_toDate);module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isBefore(str){var date=arguments.length<=1||void 0===arguments[1]?String(new Date):arguments[1];(0,_assertString2.default)(str);var comparison=(0,_toDate2.default)(date),original=(0,_toDate2.default)(str);return!!(original&&comparison&&original<comparison)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=isBefore;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString),_toDate=__webpack_require__(263),_toDate2=_interopRequireDefault(_toDate);module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isIn(str,options){(0,_assertString2.default)(str);var i=void 0;if("[object Array]"===Object.prototype.toString.call(options)){var array=[];for(i in options)({}).hasOwnProperty.call(options,i)&&(array[i]=(0,_toString2.default)(options[i]));return array.indexOf(str)>=0}return"object"===("undefined"==typeof options?"undefined":_typeof(options))?options.hasOwnProperty(str):!(!options||"function"!=typeof options.indexOf)&&options.indexOf(str)>=0}Object.defineProperty(exports,"__esModule",{value:!0});var _typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(obj){return typeof obj}:function(obj){return obj&&"function"==typeof Symbol&&obj.constructor===Symbol?"symbol":typeof obj};exports.default=isIn;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString),_toString=__webpack_require__(321),_toString2=_interopRequireDefault(_toString);module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isCreditCard(str){(0,_assertString2.default)(str);var sanitized=str.replace(/[^0-9]+/g,"");if(!creditCard.test(sanitized))return!1;for(var sum=0,digit=void 0,tmpNum=void 0,shouldDouble=void 0,i=sanitized.length-1;i>=0;i--)digit=sanitized.substring(i,i+1),tmpNum=parseInt(digit,10),shouldDouble?(tmpNum*=2,sum+=tmpNum>=10?tmpNum%10+1:tmpNum):sum+=tmpNum,shouldDouble=!shouldDouble;return!(sum%10!==0||!sanitized)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=isCreditCard;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString),creditCard=/^(?:4[0-9]{12}(?:[0-9]{3})?|5[1-5][0-9]{14}|6(?:011|5[0-9][0-9])[0-9]{12}|3[47][0-9]{13}|3(?:0[0-5]|[68][0-9])[0-9]{11}|(?:2131|1800|35\d{3})\d{11})$/;module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isISIN(str){if((0,_assertString2.default)(str),!isin.test(str))return!1;for(var checksumStr=str.replace(/[A-Z]/g,function(character){return parseInt(character,36)}),sum=0,digit=void 0,tmpNum=void 0,shouldDouble=!0,i=checksumStr.length-2;i>=0;i--)digit=checksumStr.substring(i,i+1),tmpNum=parseInt(digit,10),shouldDouble?(tmpNum*=2,sum+=tmpNum>=10?tmpNum+1:tmpNum):sum+=tmpNum,shouldDouble=!shouldDouble;return parseInt(str.substr(str.length-1),10)===(1e4-sum)%10}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=isISIN;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString),isin=/^[A-Z]{2}[0-9A-Z]{9}[0-9]$/;module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isISBN(str){var version=arguments.length<=1||void 0===arguments[1]?"":arguments[1];if((0,_assertString2.default)(str),version=String(version),!version)return isISBN(str,10)||isISBN(str,13);var sanitized=str.replace(/[\s-]+/g,""),checksum=0,i=void 0;if("10"===version){if(!isbn10Maybe.test(sanitized))return!1;for(i=0;i<9;i++)checksum+=(i+1)*sanitized.charAt(i);if(checksum+="X"===sanitized.charAt(9)?100:10*sanitized.charAt(9),checksum%11===0)return!!sanitized}else if("13"===version){if(!isbn13Maybe.test(sanitized))return!1;for(i=0;i<12;i++)checksum+=factor[i%2]*sanitized.charAt(i);if(sanitized.charAt(12)-(10-checksum%10)%10===0)return!!sanitized}return!1}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=isISBN;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString),isbn10Maybe=/^(?:[0-9]{9}X|[0-9]{10})$/,isbn13Maybe=/^(?:[0-9]{13})$/,factor=[1,3];module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isMobilePhone(str,locale){return(0,_assertString2.default)(str),locale in phones&&phones[locale].test(str)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=isMobilePhone;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString),phones={"ar-SY":/^(!?(\+?963)|0)?9\d{8}$/,"en-US":/^(\+?1)?[2-9]\d{2}[2-9](?!11)\d{6}$/,"cs-CZ":/^(\+?420)? ?[1-9][0-9]{2} ?[0-9]{3} ?[0-9]{3}$/,"de-DE":/^(\+?49[ \.\-])?([\(]{1}[0-9]{1,6}[\)])?([0-9 \.\-\/]{3,20})((x|ext|extension)[ ]?[0-9]{1,4})?$/,"el-GR":/^(\+?30)?(69\d{8})$/,"en-AU":/^(\+?61|0)4\d{8}$/,"en-GB":/^(\+?44|0)7\d{9}$/,"en-HK":/^(\+?852\-?)?[569]\d{3}\-?\d{4}$/,"en-IN":/^(\+?91|0)?[789]\d{9}$/,"en-NZ":/^(\+?64|0)2\d{7,9}$/,"en-ZA":/^(\+?27|0)\d{9}$/,"en-ZM":/^(\+?26)?09[567]\d{7}$/,"es-ES":/^(\+?34)?(6\d{1}|7[1234])\d{7}$/,"fi-FI":/^(\+?358|0)\s?(4(0|1|2|4|5)?|50)\s?(\d\s?){4,8}\d$/,"fr-FR":/^(\+?33|0)[67]\d{8}$/,"ms-MY":/^(\+?6?01){1}(([145]{1}(\-|\s)?\d{7,8})|([236789]{1}(\s|\-)?\d{7}))$/,"nb-NO":/^(\+?47)?[49]\d{7}$/,"nn-NO":/^(\+?47)?[49]\d{7}$/,"pt-BR":/^(\+?55|0)\-?[1-9]{2}\-?[2-9]{1}\d{3,4}\-?\d{4}$/,"pt-PT":/^(\+?351)?9[1236]\d{7}$/,"ru-RU":/^(\+?7|8)?9\d{9}$/,"tr-TR":/^(\+?90|0)?5\d{9}$/,"vi-VN":/^(\+?84|0)?((1(2([0-9])|6([2-9])|88|99))|(9((?!5)[0-9])))([0-9]{7})$/,"zh-CN":/^(\+?0?86\-?)?((13\d|14[57]|15[^4,\D]|17[678]|18\d)\d{8}|170[059]\d{7})$/,"zh-TW":/^(\+?886\-?|0)?9\d{8}$/};module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function currencyRegex(options){var symbol="(\\"+options.symbol.replace(/\./g,"\\.")+")"+(options.require_symbol?"":"?"),negative="-?",whole_dollar_amount_without_sep="[1-9]\\d*",whole_dollar_amount_with_sep="[1-9]\\d{0,2}(\\"+options.thousands_separator+"\\d{3})*",valid_whole_dollar_amounts=["0",whole_dollar_amount_without_sep,whole_dollar_amount_with_sep],whole_dollar_amount="("+valid_whole_dollar_amounts.join("|")+")?",decimal_amount="(\\"+options.decimal_separator+"\\d{2})?",pattern=whole_dollar_amount+decimal_amount;return options.allow_negatives&&!options.parens_for_negatives&&(options.negative_sign_after_digits?pattern+=negative:options.negative_sign_before_digits&&(pattern=negative+pattern)),options.allow_negative_sign_placeholder?pattern="( (?!\\-))?"+pattern:options.allow_space_after_symbol?pattern=" ?"+pattern:options.allow_space_after_digits&&(pattern+="( (?!$))?"),options.symbol_after_digits?pattern+=symbol:pattern=symbol+pattern,options.allow_negatives&&(options.parens_for_negatives?pattern="(\\("+pattern+"\\)|"+pattern+")":options.negative_sign_before_digits||options.negative_sign_after_digits||(pattern=negative+pattern)),new RegExp("^(?!-? )(?=.*\\d)"+pattern+"$")}function isCurrency(str,options){return(0,_assertString2.default)(str),options=(0,_merge2.default)(options,default_currency_options),currencyRegex(options).test(str)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=isCurrency;var _merge=__webpack_require__(328),_merge2=_interopRequireDefault(_merge),_assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString),default_currency_options={symbol:"$",require_symbol:!1,allow_space_after_symbol:!1,symbol_after_digits:!1,allow_negatives:!0,parens_for_negatives:!1,negative_sign_before_digits:!1,negative_sign_after_digits:!1,allow_negative_sign_placeholder:!1,thousands_separator:",",decimal_separator:".",allow_space_after_digits:!1};module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}Object.defineProperty(exports,"__esModule",{value:!0}),exports.iso8601=void 0,exports.default=function(str){return(0,_assertString2.default)(str),iso8601.test(str)};var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString),iso8601=exports.iso8601=/^([\+-]?\d{4}(?!\d{2}\b))((-?)((0[1-9]|1[0-2])(\3([12]\d|0[1-9]|3[01]))?|W([0-4]\d|5[0-2])(-?[1-7])?|(00[1-9]|0[1-9]\d|[12]\d{2}|3([0-5]\d|6[1-6])))([T\s]((([01]\d|2[0-3])((:?)[0-5]\d)?|24\:?00)([\.,]\d+(?!:))?)?(\17[0-5]\d([\.,]\d+)?)?([zZ]|([\+-])([01]\d|2[0-3]):?([0-5]\d)?)?)?)?$/},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isBase64(str){(0,_assertString2.default)(str);var len=str.length;if(!len||len%4!==0||notBase64.test(str))return!1;var firstPaddingChar=str.indexOf("=");return firstPaddingChar===-1||firstPaddingChar===len-1||firstPaddingChar===len-2&&"="===str[len-1]}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=isBase64;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString),notBase64=/[^A-Z0-9+\/=]/i;module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isDataURI(str){return(0,_assertString2.default)(str),dataURI.test(str)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=isDataURI;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString),dataURI=/^\s*data:([a-z]+\/[a-z0-9\-\+]+(;[a-z\-]+\=[a-z0-9\-]+)?)?(;base64)?,[a-z0-9\!\$\&\'\,\(\)\*\+\,\;\=\-\.\_\~\:\@\/\?\%\s]*\s*$/i;module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function ltrim(str,chars){(0,_assertString2.default)(str);var pattern=chars?new RegExp("^["+chars+"]+","g"):/^\s+/g;return str.replace(pattern,"")}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=ltrim;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString);module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function rtrim(str,chars){(0,_assertString2.default)(str);var pattern=chars?new RegExp("["+chars+"]+$","g"):/\s+$/g;return str.replace(pattern,"")}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=rtrim;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString);module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function trim(str,chars){(0,_assertString2.default)(str);var pattern=chars?new RegExp("^["+chars+"]+|["+chars+"]+$","g"):/^\s+|\s+$/g;return str.replace(pattern,"")}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=trim;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString);module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function escape(str){return(0,_assertString2.default)(str),str.replace(/&/g,"&amp;").replace(/"/g,"&quot;").replace(/'/g,"&#x27;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/\//g,"&#x2F;").replace(/\`/g,"&#96;")}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=escape;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString);module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function unescape(str){return(0,_assertString2.default)(str),str.replace(/&amp;/g,"&").replace(/&quot;/g,'"').replace(/&#x27;/g,"'").replace(/&lt;/g,"<").replace(/&gt;/g,">").replace(/&#x2F;/g,"/").replace(/&#96;/g,"`")}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=unescape;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString);module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function stripLow(str,keep_new_lines){(0,_assertString2.default)(str);var chars=keep_new_lines?"\\x00-\\x09\\x0B\\x0C\\x0E-\\x1F\\x7F":"\\x00-\\x1F\\x7F";return(0,_blacklist2.default)(str,chars)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=stripLow;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString),_blacklist=__webpack_require__(318),_blacklist2=_interopRequireDefault(_blacklist);module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function whitelist(str,chars){return(0,_assertString2.default)(str),str.replace(new RegExp("[^"+chars+"]+","g"),"")}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=whitelist;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString);module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function blacklist(str,chars){return(0,_assertString2.default)(str),str.replace(new RegExp("["+chars+"]+","g"),"")}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=blacklist;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString);module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isWhitelisted(str,chars){(0,_assertString2.default)(str);for(var i=str.length-1;i>=0;i--)if(chars.indexOf(str[i])===-1)return!1;return!0}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=isWhitelisted;var _assertString=__webpack_require__(327),_assertString2=_interopRequireDefault(_assertString);module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function normalizeEmail(email,options){if(options=(0,_merge2.default)(options,default_normalize_email_options),!(0,_isEmail2.default)(email))return!1;var parts=email.split("@",2);if(parts[1]=parts[1].toLowerCase(),"gmail.com"===parts[1]||"googlemail.com"===parts[1]){if(options.remove_extension&&(parts[0]=parts[0].split("+")[0]),options.remove_dots&&(parts[0]=parts[0].replace(/\./g,"")),!parts[0].length)return!1;parts[0]=parts[0].toLowerCase(),parts[1]="gmail.com"}else options.lowercase&&(parts[0]=parts[0].toLowerCase());return parts.join("@")}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=normalizeEmail;var _isEmail=__webpack_require__(270),_isEmail2=_interopRequireDefault(_isEmail),_merge=__webpack_require__(328),_merge2=_interopRequireDefault(_merge),default_normalize_email_options={lowercase:!0,remove_dots:!0,remove_extension:!0};module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function toString(input){return"object"===("undefined"==typeof input?"undefined":_typeof(input))&&null!==input?input="function"==typeof input.toString?input.toString():"[object Object]":(null===input||"undefined"==typeof input||isNaN(input)&&!input.length)&&(input=""),String(input)}Object.defineProperty(exports,"__esModule",{value:!0});var _typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(obj){return typeof obj}:function(obj){return obj&&"function"==typeof Symbol&&obj.constructor===Symbol?"symbol":typeof obj};exports.default=toString,module.exports=exports.default},function(module,exports,__webpack_require__){(function(){var XMLBuilder,XMLDeclaration,XMLDocType,XMLElement,XMLStringifier;XMLStringifier=__webpack_require__(330),XMLDeclaration=__webpack_require__(331),XMLDocType=__webpack_require__(332),XMLElement=__webpack_require__(333),module.exports=XMLBuilder=function(){function XMLBuilder(name,options){var root,temp;if(null==name)throw new Error("Root element needs a name");null==options&&(options={}),this.options=options,this.stringify=new XMLStringifier(options),temp=new XMLElement(this,"doc"),root=temp.element(name),root.isRoot=!0,root.documentObject=this,this.rootObject=root,options.headless||(root.declaration(options),null==options.pubID&&null==options.sysID||root.doctype(options))}return XMLBuilder.prototype.root=function(){return this.rootObject},XMLBuilder.prototype.end=function(options){return this.toString(options)},XMLBuilder.prototype.toString=function(options){var indent,newline,offset,pretty,r,ref,ref1,ref2;return pretty=(null!=options?options.pretty:void 0)||!1,indent=null!=(ref=null!=options?options.indent:void 0)?ref:"  ",offset=null!=(ref1=null!=options?options.offset:void 0)?ref1:0,newline=null!=(ref2=null!=options?options.newline:void 0)?ref2:"\n",r="",null!=this.xmldec&&(r+=this.xmldec.toString(options)),null!=this.doctype&&(r+=this.doctype.toString(options)),r+=this.rootObject.toString(options),pretty&&r.slice(-newline.length)===newline&&(r=r.slice(0,-newline.length)),r},XMLBuilder}()}).call(this)},function(module,exports,__webpack_require__){module.exports=Array.isArray||function(arr){return"[object Array]"==Object.prototype.toString.call(arr)}},function(module,exports,__webpack_require__){"function"==typeof Object.create?module.exports=function(ctor,superCtor){ctor.super_=superCtor,ctor.prototype=Object.create(superCtor.prototype,{constructor:{value:ctor,enumerable:!1,writable:!0,configurable:!0}})}:module.exports=function(ctor,superCtor){ctor.super_=superCtor;var TempCtor=function(){};TempCtor.prototype=superCtor.prototype,ctor.prototype=new TempCtor,ctor.prototype.constructor=ctor}},function(module,exports,__webpack_require__){(function(Buffer){function isArray(arg){return Array.isArray?Array.isArray(arg):"[object Array]"===objectToString(arg)}function isBoolean(arg){return"boolean"==typeof arg}function isNull(arg){return null===arg}function isNullOrUndefined(arg){return null==arg}function isNumber(arg){return"number"==typeof arg}function isString(arg){return"string"==typeof arg}function isSymbol(arg){return"symbol"==typeof arg}function isUndefined(arg){return void 0===arg}function isRegExp(re){return"[object RegExp]"===objectToString(re)}function isObject(arg){return"object"==typeof arg&&null!==arg}function isDate(d){return"[object Date]"===objectToString(d)}function isError(e){return"[object Error]"===objectToString(e)||e instanceof Error}function isFunction(arg){return"function"==typeof arg}function isPrimitive(arg){return null===arg||"boolean"==typeof arg||"number"==typeof arg||"string"==typeof arg||"symbol"==typeof arg||"undefined"==typeof arg}function objectToString(o){return Object.prototype.toString.call(o)}exports.isArray=isArray,exports.isBoolean=isBoolean,exports.isNull=isNull,exports.isNullOrUndefined=isNullOrUndefined,exports.isNumber=isNumber,exports.isString=isString,exports.isSymbol=isSymbol,exports.isUndefined=isUndefined,exports.isRegExp=isRegExp,exports.isObject=isObject,exports.isDate=isDate,exports.isError=isError,exports.isFunction=isFunction,exports.isPrimitive=isPrimitive,exports.isBuffer=Buffer.isBuffer}).call(exports,__webpack_require__(92).Buffer)},function(module,exports,__webpack_require__){function cleanUpNextTick(){draining&&currentQueue&&(draining=!1,currentQueue.length?queue=currentQueue.concat(queue):queueIndex=-1,queue.length&&drainQueue())}function drainQueue(){if(!draining){var timeout=setTimeout(cleanUpNextTick);draining=!0;for(var len=queue.length;len;){for(currentQueue=queue,queue=[];++queueIndex<len;)currentQueue&&currentQueue[queueIndex].run();queueIndex=-1,len=queue.length}currentQueue=null,draining=!1,clearTimeout(timeout)}}function Item(fun,array){this.fun=fun,this.array=array}function noop(){}var currentQueue,process=module.exports={},queue=[],draining=!1,queueIndex=-1;process.nextTick=function(fun){var args=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)args[i-1]=arguments[i];queue.push(new Item(fun,args)),1!==queue.length||draining||setTimeout(drainQueue,0)},Item.prototype.run=function(){this.fun.apply(null,this.array)},process.title="browser",process.browser=!0,process.env={},process.argv=[],process.version="",process.versions={},process.on=noop,process.addListener=noop,process.once=noop,process.off=noop,process.removeListener=noop,process.removeAllListeners=noop,process.emit=noop,process.binding=function(name){throw new Error("process.binding is not supported")},process.cwd=function(){return"/"},process.chdir=function(dir){throw new Error("process.chdir is not supported")},process.umask=function(){return 0}},function(module,exports,__webpack_require__){"use strict";function assertString(input){if("string"!=typeof input)throw new TypeError("This library (validator.js) validates strings only")}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=assertString,module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";function merge(){var obj=arguments.length<=0||void 0===arguments[0]?{}:arguments[0],defaults=arguments[1];for(var key in defaults)"undefined"==typeof obj[key]&&(obj[key]=defaults[key]);return obj}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=merge,module.exports=exports.default},function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:!0});for(var locale,alpha=exports.alpha={"en-US":/^[A-Z]+$/i,"cs-CZ":/^[A-ZÁČĎÉĚÍŇÓŘŠŤÚŮÝŽ]+$/i,"de-DE":/^[A-ZÄÖÜß]+$/i,"es-ES":/^[A-ZÁÉÍÑÓÚÜ]+$/i,"fr-FR":/^[A-ZÀÂÆÇÉÈÊËÏÎÔŒÙÛÜŸ]+$/i,"nl-NL":/^[A-ZÉËÏÓÖÜ]+$/i,"pl-PL":/^[A-ZĄĆĘŚŁŃÓŻŹ]+$/i,"pt-PT":/^[A-ZÃÁÀÂÇÉÊÍÕÓÔÚÜ]+$/i,"ru-RU":/^[А-ЯЁа-яё]+$/i,"tr-TR":/^[A-ZÇĞİıÖŞÜ]+$/i,ar:/^[ءآأؤإئابةتثجحخدذرزسشصضطظعغفقكلمنهوىيًٌٍَُِّْٰ]+$/},alphanumeric=exports.alphanumeric={"en-US":/^[0-9A-Z]+$/i,"cs-CZ":/^[0-9A-ZÁČĎÉĚÍŇÓŘŠŤÚŮÝŽ]+$/i,"de-DE":/^[0-9A-ZÄÖÜß]+$/i,"es-ES":/^[0-9A-ZÁÉÍÑÓÚÜ]+$/i,"fr-FR":/^[0-9A-ZÀÂÆÇÉÈÊËÏÎÔŒÙÛÜŸ]+$/i,"nl-NL":/^[0-9A-ZÉËÏÓÖÜ]+$/i,"pl-PL":/^[0-9A-ZĄĆĘŚŁŃÓŻŹ]+$/i,"pt-PT":/^[0-9A-ZÃÁÀÂÇÉÊÍÕÓÔÚÜ]+$/i,"ru-RU":/^[0-9А-ЯЁа-яё]+$/i,"tr-TR":/^[0-9A-ZÇĞİıÖŞÜ]+$/i,ar:/^[٠١٢٣٤٥٦٧٨٩0-9ءآأؤإئابةتثجحخدذرزسشصضطظعغفقكلمنهوىيًٌٍَُِّْٰ]+$/},englishLocales=exports.englishLocales=["AU","GB","HK","IN","NZ","ZA","ZM"],i=0;i<englishLocales.length;i++)locale="en-"+englishLocales[i],alpha[locale]=alpha["en-US"],alphanumeric[locale]=alphanumeric["en-US"];for(var _locale,arabicLocales=exports.arabicLocales=["AE","BH","DZ","EG","IQ","JO","KW","LB","LY","MA","QM","QA","SA","SD","SY","TN","YE"],_i=0;_i<arabicLocales.length;_i++)_locale="ar-"+arabicLocales[_i],alpha[_locale]=alpha.ar,alphanumeric[_locale]=alphanumeric.ar},function(module,exports,__webpack_require__){(function(){var XMLStringifier,bind=function(fn,me){return function(){return fn.apply(me,arguments)}},hasProp={}.hasOwnProperty;module.exports=XMLStringifier=function(){function XMLStringifier(options){this.assertLegalChar=bind(this.assertLegalChar,this);var key,ref,value;this.allowSurrogateChars=null!=options?options.allowSurrogateChars:void 0,this.noDoubleEncoding=null!=options?options.noDoubleEncoding:void 0,ref=(null!=options?options.stringify:void 0)||{};for(key in ref)hasProp.call(ref,key)&&(value=ref[key],this[key]=value)}return XMLStringifier.prototype.eleName=function(val){return val=""+val||"",this.assertLegalChar(val)},XMLStringifier.prototype.eleText=function(val){return val=""+val||"",this.assertLegalChar(this.elEscape(val))},XMLStringifier.prototype.cdata=function(val){if(val=""+val||"",val.match(/]]>/))throw new Error("Invalid CDATA text: "+val);return this.assertLegalChar(val)},XMLStringifier.prototype.comment=function(val){if(val=""+val||"",val.match(/--/))throw new Error("Comment text cannot contain double-hypen: "+val);return this.assertLegalChar(val)},XMLStringifier.prototype.raw=function(val){return""+val||""},XMLStringifier.prototype.attName=function(val){return""+val||""},XMLStringifier.prototype.attValue=function(val){return val=""+val||"",this.attEscape(val)},XMLStringifier.prototype.insTarget=function(val){return""+val||""},XMLStringifier.prototype.insValue=function(val){if(val=""+val||"",val.match(/\?>/))throw new Error("Invalid processing instruction value: "+val);return val},XMLStringifier.prototype.xmlVersion=function(val){if(val=""+val||"",!val.match(/1\.[0-9]+/))throw new Error("Invalid version number: "+val);return val},XMLStringifier.prototype.xmlEncoding=function(val){if(val=""+val||"",!val.match(/^[A-Za-z](?:[A-Za-z0-9._-]|-)*$/))throw new Error("Invalid encoding: "+val);return val},XMLStringifier.prototype.xmlStandalone=function(val){return val?"yes":"no"},XMLStringifier.prototype.dtdPubID=function(val){return""+val||""},XMLStringifier.prototype.dtdSysID=function(val){return""+val||""},XMLStringifier.prototype.dtdElementValue=function(val){return""+val||""},XMLStringifier.prototype.dtdAttType=function(val){return""+val||""},XMLStringifier.prototype.dtdAttDefault=function(val){return null!=val?""+val||"":val},XMLStringifier.prototype.dtdEntityValue=function(val){return""+val||""},XMLStringifier.prototype.dtdNData=function(val){return""+val||""},XMLStringifier.prototype.convertAttKey="@",XMLStringifier.prototype.convertPIKey="?",XMLStringifier.prototype.convertTextKey="#text",XMLStringifier.prototype.convertCDataKey="#cdata",XMLStringifier.prototype.convertCommentKey="#comment",XMLStringifier.prototype.convertRawKey="#raw",XMLStringifier.prototype.assertLegalChar=function(str){var chars,chr;if(chars=this.allowSurrogateChars?/[\u0000-\u0008\u000B-\u000C\u000E-\u001F\uFFFE-\uFFFF]/:/[\u0000-\u0008\u000B-\u000C\u000E-\u001F\uD800-\uDFFF\uFFFE-\uFFFF]/,
chr=str.match(chars))throw new Error("Invalid character ("+chr+") in string: "+str+" at index "+chr.index);return str},XMLStringifier.prototype.elEscape=function(str){var ampregex;return ampregex=this.noDoubleEncoding?/(?!&\S+;)&/g:/&/g,str.replace(ampregex,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/\r/g,"&#xD;")},XMLStringifier.prototype.attEscape=function(str){var ampregex;return ampregex=this.noDoubleEncoding?/(?!&\S+;)&/g:/&/g,str.replace(ampregex,"&amp;").replace(/</g,"&lt;").replace(/"/g,"&quot;")},XMLStringifier}()}).call(this)},function(module,exports,__webpack_require__){(function(){var XMLDeclaration,XMLNode,create,isObject,extend=function(child,parent){function ctor(){this.constructor=child}for(var key in parent)hasProp.call(parent,key)&&(child[key]=parent[key]);return ctor.prototype=parent.prototype,child.prototype=new ctor,child.__super__=parent.prototype,child},hasProp={}.hasOwnProperty;create=__webpack_require__(335),isObject=__webpack_require__(336),XMLNode=__webpack_require__(344),module.exports=XMLDeclaration=function(superClass){function XMLDeclaration(parent,version,encoding,standalone){var ref;XMLDeclaration.__super__.constructor.call(this,parent),isObject(version)&&(ref=version,version=ref.version,encoding=ref.encoding,standalone=ref.standalone),version||(version="1.0"),this.version=this.stringify.xmlVersion(version),null!=encoding&&(this.encoding=this.stringify.xmlEncoding(encoding)),null!=standalone&&(this.standalone=this.stringify.xmlStandalone(standalone))}return extend(XMLDeclaration,superClass),XMLDeclaration.prototype.toString=function(options,level){var indent,newline,offset,pretty,r,ref,ref1,ref2,space;return pretty=(null!=options?options.pretty:void 0)||!1,indent=null!=(ref=null!=options?options.indent:void 0)?ref:"  ",offset=null!=(ref1=null!=options?options.offset:void 0)?ref1:0,newline=null!=(ref2=null!=options?options.newline:void 0)?ref2:"\n",level||(level=0),space=new Array(level+offset+1).join(indent),r="",pretty&&(r+=space),r+="<?xml",r+=' version="'+this.version+'"',null!=this.encoding&&(r+=' encoding="'+this.encoding+'"'),null!=this.standalone&&(r+=' standalone="'+this.standalone+'"'),r+="?>",pretty&&(r+=newline),r},XMLDeclaration}(XMLNode)}).call(this)},function(module,exports,__webpack_require__){(function(){var XMLCData,XMLComment,XMLDTDAttList,XMLDTDElement,XMLDTDEntity,XMLDTDNotation,XMLDocType,XMLProcessingInstruction,create,isObject;create=__webpack_require__(335),isObject=__webpack_require__(336),XMLCData=__webpack_require__(337),XMLComment=__webpack_require__(338),XMLDTDAttList=__webpack_require__(339),XMLDTDEntity=__webpack_require__(340),XMLDTDElement=__webpack_require__(341),XMLDTDNotation=__webpack_require__(342),XMLProcessingInstruction=__webpack_require__(343),module.exports=XMLDocType=function(){function XMLDocType(parent,pubID,sysID){var ref,ref1;this.documentObject=parent,this.stringify=this.documentObject.stringify,this.children=[],isObject(pubID)&&(ref=pubID,pubID=ref.pubID,sysID=ref.sysID),null==sysID&&(ref1=[pubID,sysID],sysID=ref1[0],pubID=ref1[1]),null!=pubID&&(this.pubID=this.stringify.dtdPubID(pubID)),null!=sysID&&(this.sysID=this.stringify.dtdSysID(sysID))}return XMLDocType.prototype.element=function(name,value){var child;return child=new XMLDTDElement(this,name,value),this.children.push(child),this},XMLDocType.prototype.attList=function(elementName,attributeName,attributeType,defaultValueType,defaultValue){var child;return child=new XMLDTDAttList(this,elementName,attributeName,attributeType,defaultValueType,defaultValue),this.children.push(child),this},XMLDocType.prototype.entity=function(name,value){var child;return child=new XMLDTDEntity(this,(!1),name,value),this.children.push(child),this},XMLDocType.prototype.pEntity=function(name,value){var child;return child=new XMLDTDEntity(this,(!0),name,value),this.children.push(child),this},XMLDocType.prototype.notation=function(name,value){var child;return child=new XMLDTDNotation(this,name,value),this.children.push(child),this},XMLDocType.prototype.cdata=function(value){var child;return child=new XMLCData(this,value),this.children.push(child),this},XMLDocType.prototype.comment=function(value){var child;return child=new XMLComment(this,value),this.children.push(child),this},XMLDocType.prototype.instruction=function(target,value){var child;return child=new XMLProcessingInstruction(this,target,value),this.children.push(child),this},XMLDocType.prototype.root=function(){return this.documentObject.root()},XMLDocType.prototype.document=function(){return this.documentObject},XMLDocType.prototype.toString=function(options,level){var child,i,indent,len,newline,offset,pretty,r,ref,ref1,ref2,ref3,space;if(pretty=(null!=options?options.pretty:void 0)||!1,indent=null!=(ref=null!=options?options.indent:void 0)?ref:"  ",offset=null!=(ref1=null!=options?options.offset:void 0)?ref1:0,newline=null!=(ref2=null!=options?options.newline:void 0)?ref2:"\n",level||(level=0),space=new Array(level+offset+1).join(indent),r="",pretty&&(r+=space),r+="<!DOCTYPE "+this.root().name,this.pubID&&this.sysID?r+=' PUBLIC "'+this.pubID+'" "'+this.sysID+'"':this.sysID&&(r+=' SYSTEM "'+this.sysID+'"'),this.children.length>0){for(r+=" [",pretty&&(r+=newline),ref3=this.children,i=0,len=ref3.length;i<len;i++)child=ref3[i],r+=child.toString(options,level+1);r+="]"}return r+=">",pretty&&(r+=newline),r},XMLDocType.prototype.ele=function(name,value){return this.element(name,value)},XMLDocType.prototype.att=function(elementName,attributeName,attributeType,defaultValueType,defaultValue){return this.attList(elementName,attributeName,attributeType,defaultValueType,defaultValue)},XMLDocType.prototype.ent=function(name,value){return this.entity(name,value)},XMLDocType.prototype.pent=function(name,value){return this.pEntity(name,value)},XMLDocType.prototype.not=function(name,value){return this.notation(name,value)},XMLDocType.prototype.dat=function(value){return this.cdata(value)},XMLDocType.prototype.com=function(value){return this.comment(value)},XMLDocType.prototype.ins=function(target,value){return this.instruction(target,value)},XMLDocType.prototype.up=function(){return this.root()},XMLDocType.prototype.doc=function(){return this.document()},XMLDocType}()}).call(this)},function(module,exports,__webpack_require__){(function(){var XMLAttribute,XMLElement,XMLNode,XMLProcessingInstruction,create,every,isFunction,isObject,extend=function(child,parent){function ctor(){this.constructor=child}for(var key in parent)hasProp.call(parent,key)&&(child[key]=parent[key]);return ctor.prototype=parent.prototype,child.prototype=new ctor,child.__super__=parent.prototype,child},hasProp={}.hasOwnProperty;create=__webpack_require__(335),isObject=__webpack_require__(336),isFunction=__webpack_require__(345),every=__webpack_require__(346),XMLNode=__webpack_require__(344),XMLAttribute=__webpack_require__(347),XMLProcessingInstruction=__webpack_require__(343),module.exports=XMLElement=function(superClass){function XMLElement(parent,name,attributes){if(XMLElement.__super__.constructor.call(this,parent),null==name)throw new Error("Missing element name");this.name=this.stringify.eleName(name),this.children=[],this.instructions=[],this.attributes={},null!=attributes&&this.attribute(attributes)}return extend(XMLElement,superClass),XMLElement.prototype.clone=function(){var att,attName,clonedSelf,i,len,pi,ref,ref1;clonedSelf=create(XMLElement.prototype,this),clonedSelf.isRoot&&(clonedSelf.documentObject=null),clonedSelf.attributes={},ref=this.attributes;for(attName in ref)hasProp.call(ref,attName)&&(att=ref[attName],clonedSelf.attributes[attName]=att.clone());for(clonedSelf.instructions=[],ref1=this.instructions,i=0,len=ref1.length;i<len;i++)pi=ref1[i],clonedSelf.instructions.push(pi.clone());return clonedSelf.children=[],this.children.forEach(function(child){var clonedChild;return clonedChild=child.clone(),clonedChild.parent=clonedSelf,clonedSelf.children.push(clonedChild)}),clonedSelf},XMLElement.prototype.attribute=function(name,value){var attName,attValue;if(null!=name&&(name=name.valueOf()),isObject(name))for(attName in name)hasProp.call(name,attName)&&(attValue=name[attName],this.attribute(attName,attValue));else isFunction(value)&&(value=value.apply()),this.options.skipNullAttributes&&null==value||(this.attributes[name]=new XMLAttribute(this,name,value));return this},XMLElement.prototype.removeAttribute=function(name){var attName,i,len;if(null==name)throw new Error("Missing attribute name");if(name=name.valueOf(),Array.isArray(name))for(i=0,len=name.length;i<len;i++)attName=name[i],delete this.attributes[attName];else delete this.attributes[name];return this},XMLElement.prototype.instruction=function(target,value){var i,insTarget,insValue,instruction,len;if(null!=target&&(target=target.valueOf()),null!=value&&(value=value.valueOf()),Array.isArray(target))for(i=0,len=target.length;i<len;i++)insTarget=target[i],this.instruction(insTarget);else if(isObject(target))for(insTarget in target)hasProp.call(target,insTarget)&&(insValue=target[insTarget],this.instruction(insTarget,insValue));else isFunction(value)&&(value=value.apply()),instruction=new XMLProcessingInstruction(this,target,value),this.instructions.push(instruction);return this},XMLElement.prototype.toString=function(options,level){var att,child,i,indent,instruction,j,len,len1,name,newline,offset,pretty,r,ref,ref1,ref2,ref3,ref4,ref5,space;for(pretty=(null!=options?options.pretty:void 0)||!1,indent=null!=(ref=null!=options?options.indent:void 0)?ref:"  ",offset=null!=(ref1=null!=options?options.offset:void 0)?ref1:0,newline=null!=(ref2=null!=options?options.newline:void 0)?ref2:"\n",level||(level=0),space=new Array(level+offset+1).join(indent),r="",ref3=this.instructions,i=0,len=ref3.length;i<len;i++)instruction=ref3[i],r+=instruction.toString(options,level);pretty&&(r+=space),r+="<"+this.name,ref4=this.attributes;for(name in ref4)hasProp.call(ref4,name)&&(att=ref4[name],r+=att.toString(options));if(0===this.children.length||every(this.children,function(e){return""===e.value}))r+="/>",pretty&&(r+=newline);else if(pretty&&1===this.children.length&&null!=this.children[0].value)r+=">",r+=this.children[0].value,r+="</"+this.name+">",r+=newline;else{for(r+=">",pretty&&(r+=newline),ref5=this.children,j=0,len1=ref5.length;j<len1;j++)child=ref5[j],r+=child.toString(options,level+1);pretty&&(r+=space),r+="</"+this.name+">",pretty&&(r+=newline)}return r},XMLElement.prototype.att=function(name,value){return this.attribute(name,value)},XMLElement.prototype.ins=function(target,value){return this.instruction(target,value)},XMLElement.prototype.a=function(name,value){return this.attribute(name,value)},XMLElement.prototype.i=function(target,value){return this.instruction(target,value)},XMLElement}(XMLNode)}).call(this)},function(module,exports,__webpack_require__){var assignValue=__webpack_require__(348),copyObject=__webpack_require__(349),createAssigner=__webpack_require__(350),isArrayLike=__webpack_require__(351),isPrototype=__webpack_require__(352),keys=__webpack_require__(353),objectProto=Object.prototype,hasOwnProperty=objectProto.hasOwnProperty,propertyIsEnumerable=objectProto.propertyIsEnumerable,nonEnumShadows=!propertyIsEnumerable.call({valueOf:1},"valueOf"),assign=createAssigner(function(object,source){if(nonEnumShadows||isPrototype(source)||isArrayLike(source))return void copyObject(source,keys(source),object);for(var key in source)hasOwnProperty.call(source,key)&&assignValue(object,key,source[key])});module.exports=assign},function(module,exports,__webpack_require__){function create(prototype,properties){var result=baseCreate(prototype);return properties?baseAssign(result,properties):result}var baseAssign=__webpack_require__(354),baseCreate=__webpack_require__(355);module.exports=create},function(module,exports,__webpack_require__){function isObject(value){var type=typeof value;return!!value&&("object"==type||"function"==type)}module.exports=isObject},function(module,exports,__webpack_require__){(function(){var XMLCData,XMLNode,create,extend=function(child,parent){function ctor(){this.constructor=child}for(var key in parent)hasProp.call(parent,key)&&(child[key]=parent[key]);return ctor.prototype=parent.prototype,child.prototype=new ctor,child.__super__=parent.prototype,child},hasProp={}.hasOwnProperty;create=__webpack_require__(335),XMLNode=__webpack_require__(344),module.exports=XMLCData=function(superClass){function XMLCData(parent,text){if(XMLCData.__super__.constructor.call(this,parent),null==text)throw new Error("Missing CDATA text");this.text=this.stringify.cdata(text)}return extend(XMLCData,superClass),XMLCData.prototype.clone=function(){return create(XMLCData.prototype,this)},XMLCData.prototype.toString=function(options,level){var indent,newline,offset,pretty,r,ref,ref1,ref2,space;return pretty=(null!=options?options.pretty:void 0)||!1,indent=null!=(ref=null!=options?options.indent:void 0)?ref:"  ",offset=null!=(ref1=null!=options?options.offset:void 0)?ref1:0,newline=null!=(ref2=null!=options?options.newline:void 0)?ref2:"\n",level||(level=0),space=new Array(level+offset+1).join(indent),r="",pretty&&(r+=space),r+="<![CDATA["+this.text+"]]>",pretty&&(r+=newline),r},XMLCData}(XMLNode)}).call(this)},function(module,exports,__webpack_require__){(function(){var XMLComment,XMLNode,create,extend=function(child,parent){function ctor(){this.constructor=child}for(var key in parent)hasProp.call(parent,key)&&(child[key]=parent[key]);return ctor.prototype=parent.prototype,child.prototype=new ctor,child.__super__=parent.prototype,child},hasProp={}.hasOwnProperty;create=__webpack_require__(335),XMLNode=__webpack_require__(344),module.exports=XMLComment=function(superClass){function XMLComment(parent,text){if(XMLComment.__super__.constructor.call(this,parent),null==text)throw new Error("Missing comment text");this.text=this.stringify.comment(text)}return extend(XMLComment,superClass),XMLComment.prototype.clone=function(){return create(XMLComment.prototype,this)},XMLComment.prototype.toString=function(options,level){var indent,newline,offset,pretty,r,ref,ref1,ref2,space;return pretty=(null!=options?options.pretty:void 0)||!1,indent=null!=(ref=null!=options?options.indent:void 0)?ref:"  ",offset=null!=(ref1=null!=options?options.offset:void 0)?ref1:0,newline=null!=(ref2=null!=options?options.newline:void 0)?ref2:"\n",level||(level=0),space=new Array(level+offset+1).join(indent),r="",pretty&&(r+=space),r+="<!-- "+this.text+" -->",pretty&&(r+=newline),r},XMLComment}(XMLNode)}).call(this)},function(module,exports,__webpack_require__){(function(){var XMLDTDAttList,create;create=__webpack_require__(335),module.exports=XMLDTDAttList=function(){function XMLDTDAttList(parent,elementName,attributeName,attributeType,defaultValueType,defaultValue){if(this.stringify=parent.stringify,null==elementName)throw new Error("Missing DTD element name");if(null==attributeName)throw new Error("Missing DTD attribute name");if(!attributeType)throw new Error("Missing DTD attribute type");if(!defaultValueType)throw new Error("Missing DTD attribute default");if(0!==defaultValueType.indexOf("#")&&(defaultValueType="#"+defaultValueType),!defaultValueType.match(/^(#REQUIRED|#IMPLIED|#FIXED|#DEFAULT)$/))throw new Error("Invalid default value type; expected: #REQUIRED, #IMPLIED, #FIXED or #DEFAULT");if(defaultValue&&!defaultValueType.match(/^(#FIXED|#DEFAULT)$/))throw new Error("Default value only applies to #FIXED or #DEFAULT");this.elementName=this.stringify.eleName(elementName),this.attributeName=this.stringify.attName(attributeName),this.attributeType=this.stringify.dtdAttType(attributeType),this.defaultValue=this.stringify.dtdAttDefault(defaultValue),this.defaultValueType=defaultValueType}return XMLDTDAttList.prototype.toString=function(options,level){var indent,newline,offset,pretty,r,ref,ref1,ref2,space;return pretty=(null!=options?options.pretty:void 0)||!1,indent=null!=(ref=null!=options?options.indent:void 0)?ref:"  ",offset=null!=(ref1=null!=options?options.offset:void 0)?ref1:0,newline=null!=(ref2=null!=options?options.newline:void 0)?ref2:"\n",level||(level=0),space=new Array(level+offset+1).join(indent),r="",pretty&&(r+=space),r+="<!ATTLIST "+this.elementName+" "+this.attributeName+" "+this.attributeType,"#DEFAULT"!==this.defaultValueType&&(r+=" "+this.defaultValueType),this.defaultValue&&(r+=' "'+this.defaultValue+'"'),r+=">",pretty&&(r+=newline),r},XMLDTDAttList}()}).call(this)},function(module,exports,__webpack_require__){(function(){var XMLDTDEntity,create,isObject;create=__webpack_require__(335),isObject=__webpack_require__(336),module.exports=XMLDTDEntity=function(){function XMLDTDEntity(parent,pe,name,value){if(this.stringify=parent.stringify,null==name)throw new Error("Missing entity name");if(null==value)throw new Error("Missing entity value");if(this.pe=!!pe,this.name=this.stringify.eleName(name),isObject(value)){if(!value.pubID&&!value.sysID)throw new Error("Public and/or system identifiers are required for an external entity");if(value.pubID&&!value.sysID)throw new Error("System identifier is required for a public external entity");if(null!=value.pubID&&(this.pubID=this.stringify.dtdPubID(value.pubID)),null!=value.sysID&&(this.sysID=this.stringify.dtdSysID(value.sysID)),null!=value.nData&&(this.nData=this.stringify.dtdNData(value.nData)),this.pe&&this.nData)throw new Error("Notation declaration is not allowed in a parameter entity")}else this.value=this.stringify.dtdEntityValue(value)}return XMLDTDEntity.prototype.toString=function(options,level){var indent,newline,offset,pretty,r,ref,ref1,ref2,space;return pretty=(null!=options?options.pretty:void 0)||!1,indent=null!=(ref=null!=options?options.indent:void 0)?ref:"  ",offset=null!=(ref1=null!=options?options.offset:void 0)?ref1:0,newline=null!=(ref2=null!=options?options.newline:void 0)?ref2:"\n",level||(level=0),space=new Array(level+offset+1).join(indent),r="",pretty&&(r+=space),r+="<!ENTITY",this.pe&&(r+=" %"),r+=" "+this.name,this.value?r+=' "'+this.value+'"':(this.pubID&&this.sysID?r+=' PUBLIC "'+this.pubID+'" "'+this.sysID+'"':this.sysID&&(r+=' SYSTEM "'+this.sysID+'"'),this.nData&&(r+=" NDATA "+this.nData)),r+=">",pretty&&(r+=newline),r},XMLDTDEntity}()}).call(this)},function(module,exports,__webpack_require__){(function(){var XMLDTDElement,create;create=__webpack_require__(335),module.exports=XMLDTDElement=function(){function XMLDTDElement(parent,name,value){if(this.stringify=parent.stringify,null==name)throw new Error("Missing DTD element name");value||(value="(#PCDATA)"),Array.isArray(value)&&(value="("+value.join(",")+")"),this.name=this.stringify.eleName(name),this.value=this.stringify.dtdElementValue(value)}return XMLDTDElement.prototype.toString=function(options,level){var indent,newline,offset,pretty,r,ref,ref1,ref2,space;return pretty=(null!=options?options.pretty:void 0)||!1,indent=null!=(ref=null!=options?options.indent:void 0)?ref:"  ",offset=null!=(ref1=null!=options?options.offset:void 0)?ref1:0,newline=null!=(ref2=null!=options?options.newline:void 0)?ref2:"\n",level||(level=0),space=new Array(level+offset+1).join(indent),r="",pretty&&(r+=space),r+="<!ELEMENT "+this.name+" "+this.value+">",pretty&&(r+=newline),r},XMLDTDElement}()}).call(this)},function(module,exports,__webpack_require__){(function(){var XMLDTDNotation,create;create=__webpack_require__(335),module.exports=XMLDTDNotation=function(){function XMLDTDNotation(parent,name,value){if(this.stringify=parent.stringify,null==name)throw new Error("Missing notation name");if(!value.pubID&&!value.sysID)throw new Error("Public or system identifiers are required for an external entity");this.name=this.stringify.eleName(name),null!=value.pubID&&(this.pubID=this.stringify.dtdPubID(value.pubID)),null!=value.sysID&&(this.sysID=this.stringify.dtdSysID(value.sysID))}return XMLDTDNotation.prototype.toString=function(options,level){var indent,newline,offset,pretty,r,ref,ref1,ref2,space;return pretty=(null!=options?options.pretty:void 0)||!1,indent=null!=(ref=null!=options?options.indent:void 0)?ref:"  ",offset=null!=(ref1=null!=options?options.offset:void 0)?ref1:0,newline=null!=(ref2=null!=options?options.newline:void 0)?ref2:"\n",level||(level=0),space=new Array(level+offset+1).join(indent),r="",pretty&&(r+=space),r+="<!NOTATION "+this.name,this.pubID&&this.sysID?r+=' PUBLIC "'+this.pubID+'" "'+this.sysID+'"':this.pubID?r+=' PUBLIC "'+this.pubID+'"':this.sysID&&(r+=' SYSTEM "'+this.sysID+'"'),r+=">",pretty&&(r+=newline),r},XMLDTDNotation}()}).call(this)},function(module,exports,__webpack_require__){(function(){var XMLProcessingInstruction,create;create=__webpack_require__(335),module.exports=XMLProcessingInstruction=function(){function XMLProcessingInstruction(parent,target,value){if(this.stringify=parent.stringify,null==target)throw new Error("Missing instruction target");this.target=this.stringify.insTarget(target),value&&(this.value=this.stringify.insValue(value))}return XMLProcessingInstruction.prototype.clone=function(){return create(XMLProcessingInstruction.prototype,this)},XMLProcessingInstruction.prototype.toString=function(options,level){var indent,newline,offset,pretty,r,ref,ref1,ref2,space;return pretty=(null!=options?options.pretty:void 0)||!1,indent=null!=(ref=null!=options?options.indent:void 0)?ref:"  ",offset=null!=(ref1=null!=options?options.offset:void 0)?ref1:0,newline=null!=(ref2=null!=options?options.newline:void 0)?ref2:"\n",level||(level=0),space=new Array(level+offset+1).join(indent),r="",pretty&&(r+=space),r+="<?",r+=this.target,this.value&&(r+=" "+this.value),r+="?>",pretty&&(r+=newline),r},XMLProcessingInstruction}()}).call(this)},function(module,exports,__webpack_require__){(function(){var XMLCData,XMLComment,XMLDeclaration,XMLDocType,XMLElement,XMLNode,XMLRaw,XMLText,isEmpty,isFunction,isObject,hasProp={}.hasOwnProperty;isObject=__webpack_require__(336),isFunction=__webpack_require__(345),isEmpty=__webpack_require__(361),XMLElement=null,XMLCData=null,XMLComment=null,XMLDeclaration=null,XMLDocType=null,XMLRaw=null,XMLText=null,module.exports=XMLNode=function(){function XMLNode(parent){this.parent=parent,this.options=this.parent.options,this.stringify=this.parent.stringify,null===XMLElement&&(XMLElement=__webpack_require__(333),XMLCData=__webpack_require__(337),XMLComment=__webpack_require__(338),XMLDeclaration=__webpack_require__(331),XMLDocType=__webpack_require__(332),XMLRaw=__webpack_require__(362),XMLText=__webpack_require__(363))}return XMLNode.prototype.element=function(name,attributes,text){var childNode,item,j,k,key,lastChild,len,len1,ref,val;if(lastChild=null,null==attributes&&(attributes={}),attributes=attributes.valueOf(),isObject(attributes)||(ref=[attributes,text],text=ref[0],attributes=ref[1]),null!=name&&(name=name.valueOf()),Array.isArray(name))for(j=0,len=name.length;j<len;j++)item=name[j],lastChild=this.element(item);else if(isFunction(name))lastChild=this.element(name.apply());else if(isObject(name)){for(key in name)if(hasProp.call(name,key))if(val=name[key],isFunction(val)&&(val=val.apply()),isObject(val)&&isEmpty(val)&&(val=null),!this.options.ignoreDecorators&&this.stringify.convertAttKey&&0===key.indexOf(this.stringify.convertAttKey))lastChild=this.attribute(key.substr(this.stringify.convertAttKey.length),val);else if(!this.options.ignoreDecorators&&this.stringify.convertPIKey&&0===key.indexOf(this.stringify.convertPIKey))lastChild=this.instruction(key.substr(this.stringify.convertPIKey.length),val);else if(!this.options.separateArrayItems&&Array.isArray(val))for(k=0,len1=val.length;k<len1;k++)item=val[k],childNode={},childNode[key]=item,lastChild=this.element(childNode);else isObject(val)?(lastChild=this.element(key),lastChild.element(val)):lastChild=this.element(key,val)}else lastChild=!this.options.ignoreDecorators&&this.stringify.convertTextKey&&0===name.indexOf(this.stringify.convertTextKey)?this.text(text):!this.options.ignoreDecorators&&this.stringify.convertCDataKey&&0===name.indexOf(this.stringify.convertCDataKey)?this.cdata(text):!this.options.ignoreDecorators&&this.stringify.convertCommentKey&&0===name.indexOf(this.stringify.convertCommentKey)?this.comment(text):!this.options.ignoreDecorators&&this.stringify.convertRawKey&&0===name.indexOf(this.stringify.convertRawKey)?this.raw(text):this.node(name,attributes,text);if(null==lastChild)throw new Error("Could not create any elements with: "+name);return lastChild},XMLNode.prototype.insertBefore=function(name,attributes,text){var child,i,removed;if(this.isRoot)throw new Error("Cannot insert elements at root level");return i=this.parent.children.indexOf(this),removed=this.parent.children.splice(i),child=this.parent.element(name,attributes,text),Array.prototype.push.apply(this.parent.children,removed),child},XMLNode.prototype.insertAfter=function(name,attributes,text){var child,i,removed;if(this.isRoot)throw new Error("Cannot insert elements at root level");return i=this.parent.children.indexOf(this),removed=this.parent.children.splice(i+1),child=this.parent.element(name,attributes,text),Array.prototype.push.apply(this.parent.children,removed),child},XMLNode.prototype.remove=function(){var i,ref;if(this.isRoot)throw new Error("Cannot remove the root element");return i=this.parent.children.indexOf(this),[].splice.apply(this.parent.children,[i,i-i+1].concat(ref=[])),ref,this.parent},XMLNode.prototype.node=function(name,attributes,text){var child,ref;return null!=name&&(name=name.valueOf()),null==attributes&&(attributes={}),attributes=attributes.valueOf(),isObject(attributes)||(ref=[attributes,text],text=ref[0],attributes=ref[1]),child=new XMLElement(this,name,attributes),null!=text&&child.text(text),this.children.push(child),child},XMLNode.prototype.text=function(value){var child;return child=new XMLText(this,value),this.children.push(child),this},XMLNode.prototype.cdata=function(value){var child;return child=new XMLCData(this,value),this.children.push(child),this},XMLNode.prototype.comment=function(value){var child;return child=new XMLComment(this,value),this.children.push(child),this},XMLNode.prototype.raw=function(value){var child;return child=new XMLRaw(this,value),this.children.push(child),this},XMLNode.prototype.declaration=function(version,encoding,standalone){var doc,xmldec;return doc=this.document(),xmldec=new XMLDeclaration(doc,version,encoding,standalone),doc.xmldec=xmldec,doc.root()},XMLNode.prototype.doctype=function(pubID,sysID){var doc,doctype;return doc=this.document(),doctype=new XMLDocType(doc,pubID,sysID),doc.doctype=doctype,doctype},XMLNode.prototype.up=function(){if(this.isRoot)throw new Error("The root node has no parent. Use doc() if you need to get the document object.");return this.parent},XMLNode.prototype.root=function(){var child;if(this.isRoot)return this;for(child=this.parent;!child.isRoot;)child=child.parent;return child},XMLNode.prototype.document=function(){return this.root().documentObject},XMLNode.prototype.end=function(options){return this.document().toString(options)},XMLNode.prototype.prev=function(){var i;if(this.isRoot)throw new Error("Root node has no siblings");if(i=this.parent.children.indexOf(this),i<1)throw new Error("Already at the first node");return this.parent.children[i-1]},XMLNode.prototype.next=function(){var i;if(this.isRoot)throw new Error("Root node has no siblings");if(i=this.parent.children.indexOf(this),i===-1||i===this.parent.children.length-1)throw new Error("Already at the last node");return this.parent.children[i+1]},XMLNode.prototype.importXMLBuilder=function(xmlbuilder){var clonedRoot;return clonedRoot=xmlbuilder.root().clone(),clonedRoot.parent=this,clonedRoot.isRoot=!1,this.children.push(clonedRoot),this},XMLNode.prototype.ele=function(name,attributes,text){return this.element(name,attributes,text)},XMLNode.prototype.nod=function(name,attributes,text){return this.node(name,attributes,text)},XMLNode.prototype.txt=function(value){return this.text(value)},XMLNode.prototype.dat=function(value){return this.cdata(value)},XMLNode.prototype.com=function(value){return this.comment(value)},XMLNode.prototype.doc=function(){return this.document()},XMLNode.prototype.dec=function(version,encoding,standalone){return this.declaration(version,encoding,standalone)},XMLNode.prototype.dtd=function(pubID,sysID){return this.doctype(pubID,sysID)},XMLNode.prototype.e=function(name,attributes,text){return this.element(name,attributes,text)},XMLNode.prototype.n=function(name,attributes,text){return this.node(name,attributes,text)},XMLNode.prototype.t=function(value){return this.text(value)},XMLNode.prototype.d=function(value){return this.cdata(value)},XMLNode.prototype.c=function(value){return this.comment(value)},XMLNode.prototype.r=function(value){return this.raw(value)},XMLNode.prototype.u=function(){return this.up()},XMLNode}()}).call(this)},function(module,exports,__webpack_require__){function isFunction(value){var tag=isObject(value)?objectToString.call(value):"";return tag==funcTag||tag==genTag}var isObject=__webpack_require__(336),funcTag="[object Function]",genTag="[object GeneratorFunction]",objectProto=Object.prototype,objectToString=objectProto.toString;module.exports=isFunction},function(module,exports,__webpack_require__){function every(collection,predicate,guard){var func=isArray(collection)?arrayEvery:baseEvery;return guard&&isIterateeCall(collection,predicate,guard)&&(predicate=void 0),func(collection,baseIteratee(predicate,3))}var arrayEvery=__webpack_require__(356),baseEvery=__webpack_require__(357),baseIteratee=__webpack_require__(358),isArray=__webpack_require__(359),isIterateeCall=__webpack_require__(360);module.exports=every},function(module,exports,__webpack_require__){(function(){var XMLAttribute,create;create=__webpack_require__(335),module.exports=XMLAttribute=function(){function XMLAttribute(parent,name,value){if(this.stringify=parent.stringify,null==name)throw new Error("Missing attribute name of element "+parent.name);if(null==value)throw new Error("Missing attribute value for attribute "+name+" of element "+parent.name);this.name=this.stringify.attName(name),this.value=this.stringify.attValue(value)}return XMLAttribute.prototype.clone=function(){return create(XMLAttribute.prototype,this)},XMLAttribute.prototype.toString=function(options,level){return" "+this.name+'="'+this.value+'"'},XMLAttribute}()}).call(this)},function(module,exports,__webpack_require__){function assignValue(object,key,value){var objValue=object[key];hasOwnProperty.call(object,key)&&eq(objValue,value)&&(void 0!==value||key in object)||(object[key]=value)}var eq=__webpack_require__(364),objectProto=Object.prototype,hasOwnProperty=objectProto.hasOwnProperty;module.exports=assignValue},function(module,exports,__webpack_require__){function copyObject(source,props,object,customizer){object||(object={});for(var index=-1,length=props.length;++index<length;){var key=props[index],newValue=customizer?customizer(object[key],source[key],key,object,source):source[key];assignValue(object,key,newValue)}return object}var assignValue=__webpack_require__(348);module.exports=copyObject},function(module,exports,__webpack_require__){function createAssigner(assigner){return rest(function(object,sources){var index=-1,length=sources.length,customizer=length>1?sources[length-1]:void 0,guard=length>2?sources[2]:void 0;for(customizer="function"==typeof customizer?(length--,customizer):void 0,guard&&isIterateeCall(sources[0],sources[1],guard)&&(customizer=length<3?void 0:customizer,length=1),object=Object(object);++index<length;){var source=sources[index];source&&assigner(object,source,index,customizer)}return object})}var isIterateeCall=__webpack_require__(360),rest=__webpack_require__(365);module.exports=createAssigner},function(module,exports,__webpack_require__){function isArrayLike(value){return null!=value&&isLength(getLength(value))&&!isFunction(value)}var getLength=__webpack_require__(366),isFunction=__webpack_require__(345),isLength=__webpack_require__(367);
module.exports=isArrayLike},function(module,exports,__webpack_require__){function isPrototype(value){var Ctor=value&&value.constructor,proto="function"==typeof Ctor&&Ctor.prototype||objectProto;return value===proto}var objectProto=Object.prototype;module.exports=isPrototype},function(module,exports,__webpack_require__){function keys(object){var isProto=isPrototype(object);if(!isProto&&!isArrayLike(object))return baseKeys(object);var indexes=indexKeys(object),skipIndexes=!!indexes,result=indexes||[],length=result.length;for(var key in object)!baseHas(object,key)||skipIndexes&&("length"==key||isIndex(key,length))||isProto&&"constructor"==key||result.push(key);return result}var baseHas=__webpack_require__(368),baseKeys=__webpack_require__(369),indexKeys=__webpack_require__(370),isArrayLike=__webpack_require__(351),isIndex=__webpack_require__(371),isPrototype=__webpack_require__(352);module.exports=keys},function(module,exports,__webpack_require__){function baseAssign(object,source){return object&&copyObject(source,keys(source),object)}var copyObject=__webpack_require__(349),keys=__webpack_require__(353);module.exports=baseAssign},function(module,exports,__webpack_require__){function baseCreate(proto){return isObject(proto)?objectCreate(proto):{}}var isObject=__webpack_require__(336),objectCreate=Object.create;module.exports=baseCreate},function(module,exports,__webpack_require__){function arrayEvery(array,predicate){for(var index=-1,length=array.length;++index<length;)if(!predicate(array[index],index,array))return!1;return!0}module.exports=arrayEvery},function(module,exports,__webpack_require__){function baseEvery(collection,predicate){var result=!0;return baseEach(collection,function(value,index,collection){return result=!!predicate(value,index,collection)}),result}var baseEach=__webpack_require__(372);module.exports=baseEvery},function(module,exports,__webpack_require__){function baseIteratee(value){return"function"==typeof value?value:null==value?identity:"object"==typeof value?isArray(value)?baseMatchesProperty(value[0],value[1]):baseMatches(value):property(value)}var baseMatches=__webpack_require__(378),baseMatchesProperty=__webpack_require__(379),identity=__webpack_require__(380),isArray=__webpack_require__(359),property=__webpack_require__(381);module.exports=baseIteratee},function(module,exports,__webpack_require__){var isArray=Array.isArray;module.exports=isArray},function(module,exports,__webpack_require__){function isIterateeCall(value,index,object){if(!isObject(object))return!1;var type=typeof index;return!!("number"==type?isArrayLike(object)&&isIndex(index,object.length):"string"==type&&index in object)&&eq(object[index],value)}var eq=__webpack_require__(364),isArrayLike=__webpack_require__(351),isIndex=__webpack_require__(371),isObject=__webpack_require__(336);module.exports=isIterateeCall},function(module,exports,__webpack_require__){function isEmpty(value){if(isArrayLike(value)&&(isArray(value)||isString(value)||isFunction(value.splice)||isArguments(value)||isBuffer(value)))return!value.length;if(isObjectLike(value)){var tag=getTag(value);if(tag==mapTag||tag==setTag)return!value.size}for(var key in value)if(hasOwnProperty.call(value,key))return!1;return!(nonEnumShadows&&keys(value).length)}var getTag=__webpack_require__(373),isArguments=__webpack_require__(374),isArray=__webpack_require__(359),isArrayLike=__webpack_require__(351),isBuffer=__webpack_require__(375),isFunction=__webpack_require__(345),isObjectLike=__webpack_require__(376),isString=__webpack_require__(377),keys=__webpack_require__(353),mapTag="[object Map]",setTag="[object Set]",objectProto=Object.prototype,hasOwnProperty=objectProto.hasOwnProperty,propertyIsEnumerable=objectProto.propertyIsEnumerable,nonEnumShadows=!propertyIsEnumerable.call({valueOf:1},"valueOf");module.exports=isEmpty},function(module,exports,__webpack_require__){(function(){var XMLNode,XMLRaw,create,extend=function(child,parent){function ctor(){this.constructor=child}for(var key in parent)hasProp.call(parent,key)&&(child[key]=parent[key]);return ctor.prototype=parent.prototype,child.prototype=new ctor,child.__super__=parent.prototype,child},hasProp={}.hasOwnProperty;create=__webpack_require__(335),XMLNode=__webpack_require__(344),module.exports=XMLRaw=function(superClass){function XMLRaw(parent,text){if(XMLRaw.__super__.constructor.call(this,parent),null==text)throw new Error("Missing raw text");this.value=this.stringify.raw(text)}return extend(XMLRaw,superClass),XMLRaw.prototype.clone=function(){return create(XMLRaw.prototype,this)},XMLRaw.prototype.toString=function(options,level){var indent,newline,offset,pretty,r,ref,ref1,ref2,space;return pretty=(null!=options?options.pretty:void 0)||!1,indent=null!=(ref=null!=options?options.indent:void 0)?ref:"  ",offset=null!=(ref1=null!=options?options.offset:void 0)?ref1:0,newline=null!=(ref2=null!=options?options.newline:void 0)?ref2:"\n",level||(level=0),space=new Array(level+offset+1).join(indent),r="",pretty&&(r+=space),r+=this.value,pretty&&(r+=newline),r},XMLRaw}(XMLNode)}).call(this)},function(module,exports,__webpack_require__){(function(){var XMLNode,XMLText,create,extend=function(child,parent){function ctor(){this.constructor=child}for(var key in parent)hasProp.call(parent,key)&&(child[key]=parent[key]);return ctor.prototype=parent.prototype,child.prototype=new ctor,child.__super__=parent.prototype,child},hasProp={}.hasOwnProperty;create=__webpack_require__(335),XMLNode=__webpack_require__(344),module.exports=XMLText=function(superClass){function XMLText(parent,text){if(XMLText.__super__.constructor.call(this,parent),null==text)throw new Error("Missing element text");this.value=this.stringify.eleText(text)}return extend(XMLText,superClass),XMLText.prototype.clone=function(){return create(XMLText.prototype,this)},XMLText.prototype.toString=function(options,level){var indent,newline,offset,pretty,r,ref,ref1,ref2,space;return pretty=(null!=options?options.pretty:void 0)||!1,indent=null!=(ref=null!=options?options.indent:void 0)?ref:"  ",offset=null!=(ref1=null!=options?options.offset:void 0)?ref1:0,newline=null!=(ref2=null!=options?options.newline:void 0)?ref2:"\n",level||(level=0),space=new Array(level+offset+1).join(indent),r="",pretty&&(r+=space),r+=this.value,pretty&&(r+=newline),r},XMLText}(XMLNode)}).call(this)},function(module,exports,__webpack_require__){function eq(value,other){return value===other||value!==value&&other!==other}module.exports=eq},function(module,exports,__webpack_require__){function rest(func,start){if("function"!=typeof func)throw new TypeError(FUNC_ERROR_TEXT);return start=nativeMax(void 0===start?func.length-1:toInteger(start),0),function(){for(var args=arguments,index=-1,length=nativeMax(args.length-start,0),array=Array(length);++index<length;)array[index]=args[start+index];switch(start){case 0:return func.call(this,array);case 1:return func.call(this,args[0],array);case 2:return func.call(this,args[0],args[1],array)}var otherArgs=Array(start+1);for(index=-1;++index<start;)otherArgs[index]=args[index];return otherArgs[start]=array,apply(func,this,otherArgs)}}var apply=__webpack_require__(382),toInteger=__webpack_require__(383),FUNC_ERROR_TEXT="Expected a function",nativeMax=Math.max;module.exports=rest},function(module,exports,__webpack_require__){var baseProperty=__webpack_require__(384),getLength=baseProperty("length");module.exports=getLength},function(module,exports,__webpack_require__){function isLength(value){return"number"==typeof value&&value>-1&&value%1==0&&value<=MAX_SAFE_INTEGER}var MAX_SAFE_INTEGER=9007199254740991;module.exports=isLength},function(module,exports,__webpack_require__){function baseHas(object,key){return hasOwnProperty.call(object,key)||"object"==typeof object&&key in object&&null===getPrototype(object)}var getPrototype=__webpack_require__(385),objectProto=Object.prototype,hasOwnProperty=objectProto.hasOwnProperty;module.exports=baseHas},function(module,exports,__webpack_require__){function baseKeys(object){return nativeKeys(Object(object))}var nativeKeys=Object.keys;module.exports=baseKeys},function(module,exports,__webpack_require__){function indexKeys(object){var length=object?object.length:void 0;return isLength(length)&&(isArray(object)||isString(object)||isArguments(object))?baseTimes(length,String):null}var baseTimes=__webpack_require__(386),isArguments=__webpack_require__(374),isArray=__webpack_require__(359),isLength=__webpack_require__(367),isString=__webpack_require__(377);module.exports=indexKeys},function(module,exports,__webpack_require__){function isIndex(value,length){return value="number"==typeof value||reIsUint.test(value)?+value:-1,length=null==length?MAX_SAFE_INTEGER:length,value>-1&&value%1==0&&value<length}var MAX_SAFE_INTEGER=9007199254740991,reIsUint=/^(?:0|[1-9]\d*)$/;module.exports=isIndex},function(module,exports,__webpack_require__){var baseForOwn=__webpack_require__(387),createBaseEach=__webpack_require__(388),baseEach=createBaseEach(baseForOwn);module.exports=baseEach},function(module,exports,__webpack_require__){function getTag(value){return objectToString.call(value)}var DataView=__webpack_require__(389),Map=__webpack_require__(390),Promise=__webpack_require__(391),Set=__webpack_require__(392),WeakMap=__webpack_require__(393),toSource=__webpack_require__(394),mapTag="[object Map]",objectTag="[object Object]",promiseTag="[object Promise]",setTag="[object Set]",weakMapTag="[object WeakMap]",dataViewTag="[object DataView]",objectProto=Object.prototype,objectToString=objectProto.toString,dataViewCtorString=toSource(DataView),mapCtorString=toSource(Map),promiseCtorString=toSource(Promise),setCtorString=toSource(Set),weakMapCtorString=toSource(WeakMap);(DataView&&getTag(new DataView(new ArrayBuffer(1)))!=dataViewTag||Map&&getTag(new Map)!=mapTag||Promise&&getTag(Promise.resolve())!=promiseTag||Set&&getTag(new Set)!=setTag||WeakMap&&getTag(new WeakMap)!=weakMapTag)&&(getTag=function(value){var result=objectToString.call(value),Ctor=result==objectTag?value.constructor:void 0,ctorString=Ctor?toSource(Ctor):void 0;if(ctorString)switch(ctorString){case dataViewCtorString:return dataViewTag;case mapCtorString:return mapTag;case promiseCtorString:return promiseTag;case setCtorString:return setTag;case weakMapCtorString:return weakMapTag}return result}),module.exports=getTag},function(module,exports,__webpack_require__){function isArguments(value){return isArrayLikeObject(value)&&hasOwnProperty.call(value,"callee")&&(!propertyIsEnumerable.call(value,"callee")||objectToString.call(value)==argsTag)}var isArrayLikeObject=__webpack_require__(395),argsTag="[object Arguments]",objectProto=Object.prototype,hasOwnProperty=objectProto.hasOwnProperty,objectToString=objectProto.toString,propertyIsEnumerable=objectProto.propertyIsEnumerable;module.exports=isArguments},function(module,exports,__webpack_require__){(function(module){var constant=__webpack_require__(396),root=__webpack_require__(397),objectTypes={function:!0,object:!0},freeExports=objectTypes[typeof exports]&&exports&&!exports.nodeType?exports:void 0,freeModule=objectTypes[typeof module]&&module&&!module.nodeType?module:void 0,moduleExports=freeModule&&freeModule.exports===freeExports?freeExports:void 0,Buffer=moduleExports?root.Buffer:void 0,isBuffer=Buffer?function(value){return value instanceof Buffer}:constant(!1);module.exports=isBuffer}).call(exports,__webpack_require__(138)(module))},function(module,exports,__webpack_require__){function isObjectLike(value){return!!value&&"object"==typeof value}module.exports=isObjectLike},function(module,exports,__webpack_require__){function isString(value){return"string"==typeof value||!isArray(value)&&isObjectLike(value)&&objectToString.call(value)==stringTag}var isArray=__webpack_require__(359),isObjectLike=__webpack_require__(376),stringTag="[object String]",objectProto=Object.prototype,objectToString=objectProto.toString;module.exports=isString},function(module,exports,__webpack_require__){function baseMatches(source){var matchData=getMatchData(source);return 1==matchData.length&&matchData[0][2]?matchesStrictComparable(matchData[0][0],matchData[0][1]):function(object){return object===source||baseIsMatch(object,source,matchData)}}var baseIsMatch=__webpack_require__(404),getMatchData=__webpack_require__(405),matchesStrictComparable=__webpack_require__(403);module.exports=baseMatches},function(module,exports,__webpack_require__){function baseMatchesProperty(path,srcValue){return isKey(path)&&isStrictComparable(srcValue)?matchesStrictComparable(path,srcValue):function(object){var objValue=get(object,path);return void 0===objValue&&objValue===srcValue?hasIn(object,path):baseIsEqual(srcValue,objValue,void 0,UNORDERED_COMPARE_FLAG|PARTIAL_COMPARE_FLAG)}}var baseIsEqual=__webpack_require__(398),get=__webpack_require__(399),hasIn=__webpack_require__(400),isKey=__webpack_require__(401),isStrictComparable=__webpack_require__(402),matchesStrictComparable=__webpack_require__(403),UNORDERED_COMPARE_FLAG=1,PARTIAL_COMPARE_FLAG=2;module.exports=baseMatchesProperty},function(module,exports,__webpack_require__){function identity(value){return value}module.exports=identity},function(module,exports,__webpack_require__){function property(path){return isKey(path)?baseProperty(path):basePropertyDeep(path)}var baseProperty=__webpack_require__(384),basePropertyDeep=__webpack_require__(406),isKey=__webpack_require__(401);module.exports=property},function(module,exports,__webpack_require__){function apply(func,thisArg,args){var length=args.length;switch(length){case 0:return func.call(thisArg);case 1:return func.call(thisArg,args[0]);case 2:return func.call(thisArg,args[0],args[1]);case 3:return func.call(thisArg,args[0],args[1],args[2])}return func.apply(thisArg,args)}module.exports=apply},function(module,exports,__webpack_require__){function toInteger(value){if(!value)return 0===value?value:0;if(value=toNumber(value),value===INFINITY||value===-INFINITY){var sign=value<0?-1:1;return sign*MAX_INTEGER}var remainder=value%1;return value===value?remainder?value-remainder:value:0}var toNumber=__webpack_require__(407),INFINITY=1/0,MAX_INTEGER=1.7976931348623157e308;module.exports=toInteger},function(module,exports,__webpack_require__){function baseProperty(key){return function(object){return null==object?void 0:object[key]}}module.exports=baseProperty},function(module,exports,__webpack_require__){function getPrototype(value){return nativeGetPrototype(Object(value))}var nativeGetPrototype=Object.getPrototypeOf;module.exports=getPrototype},function(module,exports,__webpack_require__){function baseTimes(n,iteratee){for(var index=-1,result=Array(n);++index<n;)result[index]=iteratee(index);return result}module.exports=baseTimes},function(module,exports,__webpack_require__){function baseForOwn(object,iteratee){return object&&baseFor(object,iteratee,keys)}var baseFor=__webpack_require__(409),keys=__webpack_require__(353);module.exports=baseForOwn},function(module,exports,__webpack_require__){function createBaseEach(eachFunc,fromRight){return function(collection,iteratee){if(null==collection)return collection;if(!isArrayLike(collection))return eachFunc(collection,iteratee);for(var length=collection.length,index=fromRight?length:-1,iterable=Object(collection);(fromRight?index--:++index<length)&&iteratee(iterable[index],index,iterable)!==!1;);return collection}}var isArrayLike=__webpack_require__(351);module.exports=createBaseEach},function(module,exports,__webpack_require__){var getNative=__webpack_require__(408),root=__webpack_require__(397),DataView=getNative(root,"DataView");module.exports=DataView},function(module,exports,__webpack_require__){var getNative=__webpack_require__(408),root=__webpack_require__(397),Map=getNative(root,"Map");module.exports=Map},function(module,exports,__webpack_require__){var getNative=__webpack_require__(408),root=__webpack_require__(397),Promise=getNative(root,"Promise");module.exports=Promise},function(module,exports,__webpack_require__){var getNative=__webpack_require__(408),root=__webpack_require__(397),Set=getNative(root,"Set");module.exports=Set},function(module,exports,__webpack_require__){var getNative=__webpack_require__(408),root=__webpack_require__(397),WeakMap=getNative(root,"WeakMap");module.exports=WeakMap},function(module,exports,__webpack_require__){function toSource(func){if(null!=func){try{return funcToString.call(func)}catch(e){}try{return func+""}catch(e){}}return""}var funcToString=Function.prototype.toString;module.exports=toSource},function(module,exports,__webpack_require__){function isArrayLikeObject(value){return isObjectLike(value)&&isArrayLike(value)}var isArrayLike=__webpack_require__(351),isObjectLike=__webpack_require__(376);module.exports=isArrayLikeObject},function(module,exports,__webpack_require__){function constant(value){return function(){return value}}module.exports=constant},function(module,exports,__webpack_require__){(function(module,global){var checkGlobal=__webpack_require__(410),objectTypes={function:!0,object:!0},freeExports=objectTypes[typeof exports]&&exports&&!exports.nodeType?exports:void 0,freeModule=objectTypes[typeof module]&&module&&!module.nodeType?module:void 0,freeGlobal=checkGlobal(freeExports&&freeModule&&"object"==typeof global&&global),freeSelf=checkGlobal(objectTypes[typeof self]&&self),freeWindow=checkGlobal(objectTypes[typeof window]&&window),thisGlobal=checkGlobal(objectTypes[typeof this]&&this),root=freeGlobal||freeWindow!==(thisGlobal&&thisGlobal.window)&&freeWindow||freeSelf||thisGlobal||Function("return this")();module.exports=root}).call(exports,__webpack_require__(138)(module),function(){return this}())},function(module,exports,__webpack_require__){function baseIsEqual(value,other,customizer,bitmask,stack){return value===other||(null==value||null==other||!isObject(value)&&!isObjectLike(other)?value!==value&&other!==other:baseIsEqualDeep(value,other,baseIsEqual,customizer,bitmask,stack))}var baseIsEqualDeep=__webpack_require__(411),isObject=__webpack_require__(336),isObjectLike=__webpack_require__(376);module.exports=baseIsEqual},function(module,exports,__webpack_require__){function get(object,path,defaultValue){var result=null==object?void 0:baseGet(object,path);return void 0===result?defaultValue:result}var baseGet=__webpack_require__(412);module.exports=get},function(module,exports,__webpack_require__){function hasIn(object,path){return null!=object&&hasPath(object,path,baseHasIn)}var baseHasIn=__webpack_require__(413),hasPath=__webpack_require__(414);module.exports=hasIn},function(module,exports,__webpack_require__){function isKey(value,object){var type=typeof value;return"number"==type||"symbol"==type||!isArray(value)&&(isSymbol(value)||reIsPlainProp.test(value)||!reIsDeepProp.test(value)||null!=object&&value in Object(object))}var isArray=__webpack_require__(359),isSymbol=__webpack_require__(415),reIsDeepProp=/\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,reIsPlainProp=/^\w*$/;module.exports=isKey},function(module,exports,__webpack_require__){function isStrictComparable(value){return value===value&&!isObject(value)}var isObject=__webpack_require__(336);module.exports=isStrictComparable},function(module,exports,__webpack_require__){function matchesStrictComparable(key,srcValue){return function(object){return null!=object&&(object[key]===srcValue&&(void 0!==srcValue||key in Object(object)))}}module.exports=matchesStrictComparable},function(module,exports,__webpack_require__){function baseIsMatch(object,source,matchData,customizer){var index=matchData.length,length=index,noCustomizer=!customizer;if(null==object)return!length;for(object=Object(object);index--;){var data=matchData[index];if(noCustomizer&&data[2]?data[1]!==object[data[0]]:!(data[0]in object))return!1}for(;++index<length;){data=matchData[index];var key=data[0],objValue=object[key],srcValue=data[1];if(noCustomizer&&data[2]){if(void 0===objValue&&!(key in object))return!1}else{var stack=new Stack;if(customizer)var result=customizer(objValue,srcValue,key,object,source,stack);if(!(void 0===result?baseIsEqual(srcValue,objValue,customizer,UNORDERED_COMPARE_FLAG|PARTIAL_COMPARE_FLAG,stack):result))return!1}}return!0}var Stack=__webpack_require__(416),baseIsEqual=__webpack_require__(398),UNORDERED_COMPARE_FLAG=1,PARTIAL_COMPARE_FLAG=2;module.exports=baseIsMatch},function(module,exports,__webpack_require__){function getMatchData(object){for(var result=toPairs(object),length=result.length;length--;)result[length][2]=isStrictComparable(result[length][1]);return result}var isStrictComparable=__webpack_require__(402),toPairs=__webpack_require__(417);module.exports=getMatchData},function(module,exports,__webpack_require__){function basePropertyDeep(path){return function(object){return baseGet(object,path)}}var baseGet=__webpack_require__(412);module.exports=basePropertyDeep},function(module,exports,__webpack_require__){function toNumber(value){if("number"==typeof value)return value;if(isSymbol(value))return NAN;if(isObject(value)){var other=isFunction(value.valueOf)?value.valueOf():value;value=isObject(other)?other+"":other}if("string"!=typeof value)return 0===value?value:+value;value=value.replace(reTrim,"");var isBinary=reIsBinary.test(value);return isBinary||reIsOctal.test(value)?freeParseInt(value.slice(2),isBinary?2:8):reIsBadHex.test(value)?NAN:+value}var isFunction=__webpack_require__(345),isObject=__webpack_require__(336),isSymbol=__webpack_require__(415),NAN=NaN,reTrim=/^\s+|\s+$/g,reIsBadHex=/^[-+]0x[0-9a-f]+$/i,reIsBinary=/^0b[01]+$/i,reIsOctal=/^0o[0-7]+$/i,freeParseInt=parseInt;module.exports=toNumber},function(module,exports,__webpack_require__){function getNative(object,key){var value=object[key];return isNative(value)?value:void 0}var isNative=__webpack_require__(423);module.exports=getNative},function(module,exports,__webpack_require__){var createBaseFor=__webpack_require__(424),baseFor=createBaseFor();module.exports=baseFor},function(module,exports,__webpack_require__){function checkGlobal(value){return value&&value.Object===Object?value:null}module.exports=checkGlobal},function(module,exports,__webpack_require__){function baseIsEqualDeep(object,other,equalFunc,customizer,bitmask,stack){var objIsArr=isArray(object),othIsArr=isArray(other),objTag=arrayTag,othTag=arrayTag;objIsArr||(objTag=getTag(object),objTag=objTag==argsTag?objectTag:objTag),othIsArr||(othTag=getTag(other),othTag=othTag==argsTag?objectTag:othTag);var objIsObj=objTag==objectTag&&!isHostObject(object),othIsObj=othTag==objectTag&&!isHostObject(other),isSameTag=objTag==othTag;if(isSameTag&&!objIsObj)return stack||(stack=new Stack),objIsArr||isTypedArray(object)?equalArrays(object,other,equalFunc,customizer,bitmask,stack):equalByTag(object,other,objTag,equalFunc,customizer,bitmask,stack);if(!(bitmask&PARTIAL_COMPARE_FLAG)){var objIsWrapped=objIsObj&&hasOwnProperty.call(object,"__wrapped__"),othIsWrapped=othIsObj&&hasOwnProperty.call(other,"__wrapped__");if(objIsWrapped||othIsWrapped){var objUnwrapped=objIsWrapped?object.value():object,othUnwrapped=othIsWrapped?other.value():other;return stack||(stack=new Stack),equalFunc(objUnwrapped,othUnwrapped,customizer,bitmask,stack)}}return!!isSameTag&&(stack||(stack=new Stack),equalObjects(object,other,equalFunc,customizer,bitmask,stack))}var Stack=__webpack_require__(416),equalArrays=__webpack_require__(418),equalByTag=__webpack_require__(419),equalObjects=__webpack_require__(420),getTag=__webpack_require__(373),isArray=__webpack_require__(359),isHostObject=__webpack_require__(421),isTypedArray=__webpack_require__(422),PARTIAL_COMPARE_FLAG=2,argsTag="[object Arguments]",arrayTag="[object Array]",objectTag="[object Object]",objectProto=Object.prototype,hasOwnProperty=objectProto.hasOwnProperty;module.exports=baseIsEqualDeep},function(module,exports,__webpack_require__){function baseGet(object,path){path=isKey(path,object)?[path]:castPath(path);for(var index=0,length=path.length;null!=object&&index<length;)object=object[path[index++]];return index&&index==length?object:void 0}var castPath=__webpack_require__(425),isKey=__webpack_require__(401);module.exports=baseGet},function(module,exports,__webpack_require__){function baseHasIn(object,key){return key in Object(object)}module.exports=baseHasIn},function(module,exports,__webpack_require__){function hasPath(object,path,hasFunc){path=isKey(path,object)?[path]:castPath(path);for(var result,index=-1,length=path.length;++index<length;){var key=path[index];if(!(result=null!=object&&hasFunc(object,key)))break;object=object[key]}if(result)return result;var length=object?object.length:0;return!!length&&isLength(length)&&isIndex(key,length)&&(isArray(object)||isString(object)||isArguments(object))}var castPath=__webpack_require__(425),isArguments=__webpack_require__(374),isArray=__webpack_require__(359),isIndex=__webpack_require__(371),isKey=__webpack_require__(401),isLength=__webpack_require__(367),isString=__webpack_require__(377);module.exports=hasPath},function(module,exports,__webpack_require__){function isSymbol(value){return"symbol"==typeof value||isObjectLike(value)&&objectToString.call(value)==symbolTag}var isObjectLike=__webpack_require__(376),symbolTag="[object Symbol]",objectProto=Object.prototype,objectToString=objectProto.toString;module.exports=isSymbol},function(module,exports,__webpack_require__){function Stack(values){var index=-1,length=values?values.length:0;for(this.clear();++index<length;){var entry=values[index];this.set(entry[0],entry[1])}}var stackClear=__webpack_require__(426),stackDelete=__webpack_require__(427),stackGet=__webpack_require__(428),stackHas=__webpack_require__(429),stackSet=__webpack_require__(430);Stack.prototype.clear=stackClear,Stack.prototype.delete=stackDelete,Stack.prototype.get=stackGet,Stack.prototype.has=stackHas,Stack.prototype.set=stackSet,module.exports=Stack},function(module,exports,__webpack_require__){function toPairs(object){return baseToPairs(object,keys(object))}var baseToPairs=__webpack_require__(431),keys=__webpack_require__(353);module.exports=toPairs},function(module,exports,__webpack_require__){function equalArrays(array,other,equalFunc,customizer,bitmask,stack){var index=-1,isPartial=bitmask&PARTIAL_COMPARE_FLAG,isUnordered=bitmask&UNORDERED_COMPARE_FLAG,arrLength=array.length,othLength=other.length;if(arrLength!=othLength&&!(isPartial&&othLength>arrLength))return!1;var stacked=stack.get(array);if(stacked)return stacked==other;var result=!0;for(stack.set(array,other);++index<arrLength;){var arrValue=array[index],othValue=other[index];if(customizer)var compared=isPartial?customizer(othValue,arrValue,index,other,array,stack):customizer(arrValue,othValue,index,array,other,stack);if(void 0!==compared){if(compared)continue;result=!1;break}if(isUnordered){if(!arraySome(other,function(othValue){return arrValue===othValue||equalFunc(arrValue,othValue,customizer,bitmask,stack)})){result=!1;break}}else if(arrValue!==othValue&&!equalFunc(arrValue,othValue,customizer,bitmask,stack)){result=!1;break}}return stack.delete(array),result}var arraySome=__webpack_require__(432),UNORDERED_COMPARE_FLAG=1,PARTIAL_COMPARE_FLAG=2;module.exports=equalArrays},function(module,exports,__webpack_require__){function equalByTag(object,other,tag,equalFunc,customizer,bitmask,stack){switch(tag){case dataViewTag:if(object.byteLength!=other.byteLength||object.byteOffset!=other.byteOffset)return!1;object=object.buffer,other=other.buffer;case arrayBufferTag:return!(object.byteLength!=other.byteLength||!equalFunc(new Uint8Array(object),new Uint8Array(other)));case boolTag:case dateTag:return+object==+other;case errorTag:return object.name==other.name&&object.message==other.message;case numberTag:return object!=+object?other!=+other:object==+other;case regexpTag:case stringTag:return object==other+"";case mapTag:var convert=mapToArray;case setTag:var isPartial=bitmask&PARTIAL_COMPARE_FLAG;if(convert||(convert=setToArray),object.size!=other.size&&!isPartial)return!1;var stacked=stack.get(object);return stacked?stacked==other:(bitmask|=UNORDERED_COMPARE_FLAG,stack.set(object,other),equalArrays(convert(object),convert(other),equalFunc,customizer,bitmask,stack));case symbolTag:if(symbolValueOf)return symbolValueOf.call(object)==symbolValueOf.call(other)}return!1}var Symbol=__webpack_require__(433),Uint8Array=__webpack_require__(434),equalArrays=__webpack_require__(418),mapToArray=__webpack_require__(435),setToArray=__webpack_require__(436),UNORDERED_COMPARE_FLAG=1,PARTIAL_COMPARE_FLAG=2,boolTag="[object Boolean]",dateTag="[object Date]",errorTag="[object Error]",mapTag="[object Map]",numberTag="[object Number]",regexpTag="[object RegExp]",setTag="[object Set]",stringTag="[object String]",symbolTag="[object Symbol]",arrayBufferTag="[object ArrayBuffer]",dataViewTag="[object DataView]",symbolProto=Symbol?Symbol.prototype:void 0,symbolValueOf=symbolProto?symbolProto.valueOf:void 0;module.exports=equalByTag},function(module,exports,__webpack_require__){function equalObjects(object,other,equalFunc,customizer,bitmask,stack){var isPartial=bitmask&PARTIAL_COMPARE_FLAG,objProps=keys(object),objLength=objProps.length,othProps=keys(other),othLength=othProps.length;if(objLength!=othLength&&!isPartial)return!1;for(var index=objLength;index--;){var key=objProps[index];if(!(isPartial?key in other:baseHas(other,key)))return!1}var stacked=stack.get(object);if(stacked)return stacked==other;var result=!0;stack.set(object,other);for(var skipCtor=isPartial;++index<objLength;){key=objProps[index];var objValue=object[key],othValue=other[key];if(customizer)var compared=isPartial?customizer(othValue,objValue,key,other,object,stack):customizer(objValue,othValue,key,object,other,stack);if(!(void 0===compared?objValue===othValue||equalFunc(objValue,othValue,customizer,bitmask,stack):compared)){result=!1;break}skipCtor||(skipCtor="constructor"==key)}if(result&&!skipCtor){var objCtor=object.constructor,othCtor=other.constructor;objCtor!=othCtor&&"constructor"in object&&"constructor"in other&&!("function"==typeof objCtor&&objCtor instanceof objCtor&&"function"==typeof othCtor&&othCtor instanceof othCtor)&&(result=!1)}return stack.delete(object),result}var baseHas=__webpack_require__(368),keys=__webpack_require__(353),PARTIAL_COMPARE_FLAG=2;module.exports=equalObjects},function(module,exports,__webpack_require__){function isHostObject(value){var result=!1;if(null!=value&&"function"!=typeof value.toString)try{result=!!(value+"")}catch(e){}return result}module.exports=isHostObject},function(module,exports,__webpack_require__){function isTypedArray(value){return isObjectLike(value)&&isLength(value.length)&&!!typedArrayTags[objectToString.call(value)]}var isLength=__webpack_require__(367),isObjectLike=__webpack_require__(376),argsTag="[object Arguments]",arrayTag="[object Array]",boolTag="[object Boolean]",dateTag="[object Date]",errorTag="[object Error]",funcTag="[object Function]",mapTag="[object Map]",numberTag="[object Number]",objectTag="[object Object]",regexpTag="[object RegExp]",setTag="[object Set]",stringTag="[object String]",weakMapTag="[object WeakMap]",arrayBufferTag="[object ArrayBuffer]",dataViewTag="[object DataView]",float32Tag="[object Float32Array]",float64Tag="[object Float64Array]",int8Tag="[object Int8Array]",int16Tag="[object Int16Array]",int32Tag="[object Int32Array]",uint8Tag="[object Uint8Array]",uint8ClampedTag="[object Uint8ClampedArray]",uint16Tag="[object Uint16Array]",uint32Tag="[object Uint32Array]",typedArrayTags={};typedArrayTags[float32Tag]=typedArrayTags[float64Tag]=typedArrayTags[int8Tag]=typedArrayTags[int16Tag]=typedArrayTags[int32Tag]=typedArrayTags[uint8Tag]=typedArrayTags[uint8ClampedTag]=typedArrayTags[uint16Tag]=typedArrayTags[uint32Tag]=!0,typedArrayTags[argsTag]=typedArrayTags[arrayTag]=typedArrayTags[arrayBufferTag]=typedArrayTags[boolTag]=typedArrayTags[dataViewTag]=typedArrayTags[dateTag]=typedArrayTags[errorTag]=typedArrayTags[funcTag]=typedArrayTags[mapTag]=typedArrayTags[numberTag]=typedArrayTags[objectTag]=typedArrayTags[regexpTag]=typedArrayTags[setTag]=typedArrayTags[stringTag]=typedArrayTags[weakMapTag]=!1;
var objectProto=Object.prototype,objectToString=objectProto.toString;module.exports=isTypedArray},function(module,exports,__webpack_require__){function isNative(value){if(!isObject(value))return!1;var pattern=isFunction(value)||isHostObject(value)?reIsNative:reIsHostCtor;return pattern.test(toSource(value))}var isFunction=__webpack_require__(345),isHostObject=__webpack_require__(421),isObject=__webpack_require__(336),toSource=__webpack_require__(394),reRegExpChar=/[\\^$.*+?()[\]{}|]/g,reIsHostCtor=/^\[object .+?Constructor\]$/,objectProto=Object.prototype,funcToString=Function.prototype.toString,hasOwnProperty=objectProto.hasOwnProperty,reIsNative=RegExp("^"+funcToString.call(hasOwnProperty).replace(reRegExpChar,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$");module.exports=isNative},function(module,exports,__webpack_require__){function createBaseFor(fromRight){return function(object,iteratee,keysFunc){for(var index=-1,iterable=Object(object),props=keysFunc(object),length=props.length;length--;){var key=props[fromRight?length:++index];if(iteratee(iterable[key],key,iterable)===!1)break}return object}}module.exports=createBaseFor},function(module,exports,__webpack_require__){function castPath(value){return isArray(value)?value:stringToPath(value)}var isArray=__webpack_require__(359),stringToPath=__webpack_require__(437);module.exports=castPath},function(module,exports,__webpack_require__){function stackClear(){this.__data__={array:[],map:null}}module.exports=stackClear},function(module,exports,__webpack_require__){function stackDelete(key){var data=this.__data__,array=data.array;return array?assocDelete(array,key):data.map.delete(key)}var assocDelete=__webpack_require__(438);module.exports=stackDelete},function(module,exports,__webpack_require__){function stackGet(key){var data=this.__data__,array=data.array;return array?assocGet(array,key):data.map.get(key)}var assocGet=__webpack_require__(440);module.exports=stackGet},function(module,exports,__webpack_require__){function stackHas(key){var data=this.__data__,array=data.array;return array?assocHas(array,key):data.map.has(key)}var assocHas=__webpack_require__(439);module.exports=stackHas},function(module,exports,__webpack_require__){function stackSet(key,value){var data=this.__data__,array=data.array;array&&(array.length<LARGE_ARRAY_SIZE-1?assocSet(array,key,value):(data.array=null,data.map=new MapCache(array)));var map=data.map;return map&&map.set(key,value),this}var MapCache=__webpack_require__(442),assocSet=__webpack_require__(443),LARGE_ARRAY_SIZE=200;module.exports=stackSet},function(module,exports,__webpack_require__){function baseToPairs(object,props){return arrayMap(props,function(key){return[key,object[key]]})}var arrayMap=__webpack_require__(441);module.exports=baseToPairs},function(module,exports,__webpack_require__){function arraySome(array,predicate){for(var index=-1,length=array.length;++index<length;)if(predicate(array[index],index,array))return!0;return!1}module.exports=arraySome},function(module,exports,__webpack_require__){var root=__webpack_require__(397),Symbol=root.Symbol;module.exports=Symbol},function(module,exports,__webpack_require__){var root=__webpack_require__(397),Uint8Array=root.Uint8Array;module.exports=Uint8Array},function(module,exports,__webpack_require__){function mapToArray(map){var index=-1,result=Array(map.size);return map.forEach(function(value,key){result[++index]=[key,value]}),result}module.exports=mapToArray},function(module,exports,__webpack_require__){function setToArray(set){var index=-1,result=Array(set.size);return set.forEach(function(value){result[++index]=value}),result}module.exports=setToArray},function(module,exports,__webpack_require__){var memoize=__webpack_require__(444),toString=__webpack_require__(445),rePropName=/[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]/g,reEscapeChar=/\\(\\)?/g,stringToPath=memoize(function(string){var result=[];return toString(string).replace(rePropName,function(match,number,quote,string){result.push(quote?string.replace(reEscapeChar,"$1"):number||match)}),result});module.exports=stringToPath},function(module,exports,__webpack_require__){function assocDelete(array,key){var index=assocIndexOf(array,key);if(index<0)return!1;var lastIndex=array.length-1;return index==lastIndex?array.pop():splice.call(array,index,1),!0}var assocIndexOf=__webpack_require__(446),arrayProto=Array.prototype,splice=arrayProto.splice;module.exports=assocDelete},function(module,exports,__webpack_require__){function assocHas(array,key){return assocIndexOf(array,key)>-1}var assocIndexOf=__webpack_require__(446);module.exports=assocHas},function(module,exports,__webpack_require__){function assocGet(array,key){var index=assocIndexOf(array,key);return index<0?void 0:array[index][1]}var assocIndexOf=__webpack_require__(446);module.exports=assocGet},function(module,exports,__webpack_require__){function arrayMap(array,iteratee){for(var index=-1,length=array.length,result=Array(length);++index<length;)result[index]=iteratee(array[index],index,array);return result}module.exports=arrayMap},function(module,exports,__webpack_require__){function MapCache(values){var index=-1,length=values?values.length:0;for(this.clear();++index<length;){var entry=values[index];this.set(entry[0],entry[1])}}var mapClear=__webpack_require__(447),mapDelete=__webpack_require__(448),mapGet=__webpack_require__(449),mapHas=__webpack_require__(450),mapSet=__webpack_require__(451);MapCache.prototype.clear=mapClear,MapCache.prototype.delete=mapDelete,MapCache.prototype.get=mapGet,MapCache.prototype.has=mapHas,MapCache.prototype.set=mapSet,module.exports=MapCache},function(module,exports,__webpack_require__){function assocSet(array,key,value){var index=assocIndexOf(array,key);index<0?array.push([key,value]):array[index][1]=value}var assocIndexOf=__webpack_require__(446);module.exports=assocSet},function(module,exports,__webpack_require__){function memoize(func,resolver){if("function"!=typeof func||resolver&&"function"!=typeof resolver)throw new TypeError(FUNC_ERROR_TEXT);var memoized=function(){var args=arguments,key=resolver?resolver.apply(this,args):args[0],cache=memoized.cache;if(cache.has(key))return cache.get(key);var result=func.apply(this,args);return memoized.cache=cache.set(key,result),result};return memoized.cache=new(memoize.Cache||MapCache),memoized}var MapCache=__webpack_require__(442),FUNC_ERROR_TEXT="Expected a function";memoize.Cache=MapCache,module.exports=memoize},function(module,exports,__webpack_require__){function toString(value){if("string"==typeof value)return value;if(null==value)return"";if(isSymbol(value))return symbolToString?symbolToString.call(value):"";var result=value+"";return"0"==result&&1/value==-INFINITY?"-0":result}var Symbol=__webpack_require__(433),isSymbol=__webpack_require__(415),INFINITY=1/0,symbolProto=Symbol?Symbol.prototype:void 0,symbolToString=symbolProto?symbolProto.toString:void 0;module.exports=toString},function(module,exports,__webpack_require__){function assocIndexOf(array,key){for(var length=array.length;length--;)if(eq(array[length][0],key))return length;return-1}var eq=__webpack_require__(364);module.exports=assocIndexOf},function(module,exports,__webpack_require__){function mapClear(){this.__data__={hash:new Hash,map:Map?new Map:[],string:new Hash}}var Hash=__webpack_require__(452),Map=__webpack_require__(390);module.exports=mapClear},function(module,exports,__webpack_require__){function mapDelete(key){var data=this.__data__;return isKeyable(key)?hashDelete("string"==typeof key?data.string:data.hash,key):Map?data.map.delete(key):assocDelete(data.map,key)}var Map=__webpack_require__(390),assocDelete=__webpack_require__(438),hashDelete=__webpack_require__(453),isKeyable=__webpack_require__(454);module.exports=mapDelete},function(module,exports,__webpack_require__){function mapGet(key){var data=this.__data__;return isKeyable(key)?hashGet("string"==typeof key?data.string:data.hash,key):Map?data.map.get(key):assocGet(data.map,key)}var Map=__webpack_require__(390),assocGet=__webpack_require__(440),hashGet=__webpack_require__(456),isKeyable=__webpack_require__(454);module.exports=mapGet},function(module,exports,__webpack_require__){function mapHas(key){var data=this.__data__;return isKeyable(key)?hashHas("string"==typeof key?data.string:data.hash,key):Map?data.map.has(key):assocHas(data.map,key)}var Map=__webpack_require__(390),assocHas=__webpack_require__(439),hashHas=__webpack_require__(455),isKeyable=__webpack_require__(454);module.exports=mapHas},function(module,exports,__webpack_require__){function mapSet(key,value){var data=this.__data__;return isKeyable(key)?hashSet("string"==typeof key?data.string:data.hash,key,value):Map?data.map.set(key,value):assocSet(data.map,key,value),this}var Map=__webpack_require__(390),assocSet=__webpack_require__(443),hashSet=__webpack_require__(457),isKeyable=__webpack_require__(454);module.exports=mapSet},function(module,exports,__webpack_require__){function Hash(){}var nativeCreate=__webpack_require__(458),objectProto=Object.prototype;Hash.prototype=nativeCreate?nativeCreate(null):objectProto,module.exports=Hash},function(module,exports,__webpack_require__){function hashDelete(hash,key){return hashHas(hash,key)&&delete hash[key]}var hashHas=__webpack_require__(455);module.exports=hashDelete},function(module,exports,__webpack_require__){function isKeyable(value){var type=typeof value;return"number"==type||"boolean"==type||"string"==type&&"__proto__"!=value||null==value}module.exports=isKeyable},function(module,exports,__webpack_require__){function hashHas(hash,key){return nativeCreate?void 0!==hash[key]:hasOwnProperty.call(hash,key)}var nativeCreate=__webpack_require__(458),objectProto=Object.prototype,hasOwnProperty=objectProto.hasOwnProperty;module.exports=hashHas},function(module,exports,__webpack_require__){function hashGet(hash,key){if(nativeCreate){var result=hash[key];return result===HASH_UNDEFINED?void 0:result}return hasOwnProperty.call(hash,key)?hash[key]:void 0}var nativeCreate=__webpack_require__(458),HASH_UNDEFINED="__lodash_hash_undefined__",objectProto=Object.prototype,hasOwnProperty=objectProto.hasOwnProperty;module.exports=hashGet},function(module,exports,__webpack_require__){function hashSet(hash,key,value){hash[key]=nativeCreate&&void 0===value?HASH_UNDEFINED:value}var nativeCreate=__webpack_require__(458),HASH_UNDEFINED="__lodash_hash_undefined__";module.exports=hashSet},function(module,exports,__webpack_require__){var getNative=__webpack_require__(408),nativeCreate=getNative(Object,"create");module.exports=nativeCreate}])}),function(factory){"undefined"!=typeof exports?factory(exports):(window.hljs=factory({}),"function"==typeof define&&define.amd&&define("hljs",[],function(){return window.hljs}))}(function(hljs){function escape(value){return value.replace(/&/gm,"&amp;").replace(/</gm,"&lt;").replace(/>/gm,"&gt;")}function tag(node){return node.nodeName.toLowerCase()}function testRe(re,lexeme){var match=re&&re.exec(lexeme);return match&&0==match.index}function isNotHighlighted(language){return/^(no-?highlight|plain|text)$/i.test(language)}function blockLanguage(block){var i,match,length,classes=block.className+" ";if(classes+=block.parentNode?block.parentNode.className:"",match=/\blang(?:uage)?-([\w-]+)\b/i.exec(classes))return getLanguage(match[1])?match[1]:"no-highlight";for(classes=classes.split(/\s+/),i=0,length=classes.length;i<length;i++)if(getLanguage(classes[i])||isNotHighlighted(classes[i]))return classes[i]}function inherit(parent,obj){var key,result={};for(key in parent)result[key]=parent[key];if(obj)for(key in obj)result[key]=obj[key];return result}function nodeStream(node){var result=[];return function _nodeStream(node,offset){for(var child=node.firstChild;child;child=child.nextSibling)3==child.nodeType?offset+=child.nodeValue.length:1==child.nodeType&&(result.push({event:"start",offset:offset,node:child}),offset=_nodeStream(child,offset),tag(child).match(/br|hr|img|input/)||result.push({event:"stop",offset:offset,node:child}));return offset}(node,0),result}function mergeStreams(original,highlighted,value){function selectStream(){return original.length&&highlighted.length?original[0].offset!=highlighted[0].offset?original[0].offset<highlighted[0].offset?original:highlighted:"start"==highlighted[0].event?original:highlighted:original.length?original:highlighted}function open(node){function attr_str(a){return" "+a.nodeName+'="'+escape(a.value)+'"'}result+="<"+tag(node)+Array.prototype.map.call(node.attributes,attr_str).join("")+">"}function close(node){result+="</"+tag(node)+">"}function render(event){("start"==event.event?open:close)(event.node)}for(var processed=0,result="",nodeStack=[];original.length||highlighted.length;){var stream=selectStream();if(result+=escape(value.substr(processed,stream[0].offset-processed)),processed=stream[0].offset,stream==original){nodeStack.reverse().forEach(close);do render(stream.splice(0,1)[0]),stream=selectStream();while(stream==original&&stream.length&&stream[0].offset==processed);nodeStack.reverse().forEach(open)}else"start"==stream[0].event?nodeStack.push(stream[0].node):nodeStack.pop(),render(stream.splice(0,1)[0])}return result+escape(value.substr(processed))}function compileLanguage(language){function reStr(re){return re&&re.source||re}function langRe(value,global){return new RegExp(reStr(value),"m"+(language.case_insensitive?"i":"")+(global?"g":""))}function compileMode(mode,parent){if(!mode.compiled){if(mode.compiled=!0,mode.keywords=mode.keywords||mode.beginKeywords,mode.keywords){var compiled_keywords={},flatten=function(className,str){language.case_insensitive&&(str=str.toLowerCase()),str.split(" ").forEach(function(kw){var pair=kw.split("|");compiled_keywords[pair[0]]=[className,pair[1]?Number(pair[1]):1]})};"string"==typeof mode.keywords?flatten("keyword",mode.keywords):Object.keys(mode.keywords).forEach(function(className){flatten(className,mode.keywords[className])}),mode.keywords=compiled_keywords}mode.lexemesRe=langRe(mode.lexemes||/\b\w+\b/,!0),parent&&(mode.beginKeywords&&(mode.begin="\\b("+mode.beginKeywords.split(" ").join("|")+")\\b"),mode.begin||(mode.begin=/\B|\b/),mode.beginRe=langRe(mode.begin),mode.end||mode.endsWithParent||(mode.end=/\B|\b/),mode.end&&(mode.endRe=langRe(mode.end)),mode.terminator_end=reStr(mode.end)||"",mode.endsWithParent&&parent.terminator_end&&(mode.terminator_end+=(mode.end?"|":"")+parent.terminator_end)),mode.illegal&&(mode.illegalRe=langRe(mode.illegal)),void 0===mode.relevance&&(mode.relevance=1),mode.contains||(mode.contains=[]);var expanded_contains=[];mode.contains.forEach(function(c){c.variants?c.variants.forEach(function(v){expanded_contains.push(inherit(c,v))}):expanded_contains.push("self"==c?mode:c)}),mode.contains=expanded_contains,mode.contains.forEach(function(c){compileMode(c,mode)}),mode.starts&&compileMode(mode.starts,parent);var terminators=mode.contains.map(function(c){return c.beginKeywords?"\\.?("+c.begin+")\\.?":c.begin}).concat([mode.terminator_end,mode.illegal]).map(reStr).filter(Boolean);mode.terminators=terminators.length?langRe(terminators.join("|"),!0):{exec:function(){return null}}}}compileMode(language)}function highlight(name,value,ignore_illegals,continuation){function subMode(lexeme,mode){for(var i=0;i<mode.contains.length;i++)if(testRe(mode.contains[i].beginRe,lexeme))return mode.contains[i]}function endOfMode(mode,lexeme){if(testRe(mode.endRe,lexeme)){for(;mode.endsParent&&mode.parent;)mode=mode.parent;return mode}if(mode.endsWithParent)return endOfMode(mode.parent,lexeme)}function isIllegal(lexeme,mode){return!ignore_illegals&&testRe(mode.illegalRe,lexeme)}function keywordMatch(mode,match){var match_str=language.case_insensitive?match[0].toLowerCase():match[0];return mode.keywords.hasOwnProperty(match_str)&&mode.keywords[match_str]}function buildSpan(classname,insideSpan,leaveOpen,noPrefix){var classPrefix=noPrefix?"":options.classPrefix,openSpan='<span class="'+classPrefix,closeSpan=leaveOpen?"":"</span>";return openSpan+=classname+'">',openSpan+insideSpan+closeSpan}function processKeywords(){if(!top.keywords)return escape(mode_buffer);var result="",last_index=0;top.lexemesRe.lastIndex=0;for(var match=top.lexemesRe.exec(mode_buffer);match;){result+=escape(mode_buffer.substr(last_index,match.index-last_index));var keyword_match=keywordMatch(top,match);keyword_match?(relevance+=keyword_match[1],result+=buildSpan(keyword_match[0],escape(match[0]))):result+=escape(match[0]),last_index=top.lexemesRe.lastIndex,match=top.lexemesRe.exec(mode_buffer)}return result+escape(mode_buffer.substr(last_index))}function processSubLanguage(){var explicit="string"==typeof top.subLanguage;if(explicit&&!languages[top.subLanguage])return escape(mode_buffer);var result=explicit?highlight(top.subLanguage,mode_buffer,!0,continuations[top.subLanguage]):highlightAuto(mode_buffer,top.subLanguage.length?top.subLanguage:void 0);return top.relevance>0&&(relevance+=result.relevance),explicit&&(continuations[top.subLanguage]=result.top),buildSpan(result.language,result.value,!1,!0)}function processBuffer(){return void 0!==top.subLanguage?processSubLanguage():processKeywords()}function startNewMode(mode,lexeme){var markup=mode.className?buildSpan(mode.className,"",!0):"";mode.returnBegin?(result+=markup,mode_buffer=""):mode.excludeBegin?(result+=escape(lexeme)+markup,mode_buffer=""):(result+=markup,mode_buffer=lexeme),top=Object.create(mode,{parent:{value:top}})}function processLexeme(buffer,lexeme){if(mode_buffer+=buffer,void 0===lexeme)return result+=processBuffer(),0;var new_mode=subMode(lexeme,top);if(new_mode)return result+=processBuffer(),startNewMode(new_mode,lexeme),new_mode.returnBegin?0:lexeme.length;var end_mode=endOfMode(top,lexeme);if(end_mode){var origin=top;origin.returnEnd||origin.excludeEnd||(mode_buffer+=lexeme),result+=processBuffer();do top.className&&(result+="</span>"),relevance+=top.relevance,top=top.parent;while(top!=end_mode.parent);return origin.excludeEnd&&(result+=escape(lexeme)),mode_buffer="",end_mode.starts&&startNewMode(end_mode.starts,""),origin.returnEnd?0:lexeme.length}if(isIllegal(lexeme,top))throw new Error('Illegal lexeme "'+lexeme+'" for mode "'+(top.className||"<unnamed>")+'"');return mode_buffer+=lexeme,lexeme.length||1}var language=getLanguage(name);if(!language)throw new Error('Unknown language: "'+name+'"');compileLanguage(language);var current,top=continuation||language,continuations={},result="";for(current=top;current!=language;current=current.parent)current.className&&(result=buildSpan(current.className,"",!0)+result);var mode_buffer="",relevance=0;try{for(var match,count,index=0;;){if(top.terminators.lastIndex=index,match=top.terminators.exec(value),!match)break;count=processLexeme(value.substr(index,match.index-index),match[0]),index=match.index+count}for(processLexeme(value.substr(index)),current=top;current.parent;current=current.parent)current.className&&(result+="</span>");return{relevance:relevance,value:result,language:name,top:top}}catch(e){if(e.message.indexOf("Illegal")!=-1)return{relevance:0,value:escape(value)};throw e}}function highlightAuto(text,languageSubset){languageSubset=languageSubset||options.languages||Object.keys(languages);var result={relevance:0,value:escape(text)},second_best=result;return languageSubset.forEach(function(name){if(getLanguage(name)){var current=highlight(name,text,!1);current.language=name,current.relevance>second_best.relevance&&(second_best=current),current.relevance>result.relevance&&(second_best=result,result=current)}}),second_best.language&&(result.second_best=second_best),result}function fixMarkup(value){return options.tabReplace&&(value=value.replace(/^((<[^>]+>|\t)+)/gm,function(match,p1){return p1.replace(/\t/g,options.tabReplace)})),options.useBR&&(value=value.replace(/\n/g,"<br>")),value}function buildClassName(prevClassName,currentLang,resultLang){var language=currentLang?aliases[currentLang]:resultLang,result=[prevClassName.trim()];return prevClassName.match(/\bhljs\b/)||result.push("hljs"),prevClassName.indexOf(language)===-1&&result.push(language),result.join(" ").trim()}function highlightBlock(block){var language=blockLanguage(block);if(!isNotHighlighted(language)){var node;options.useBR?(node=document.createElementNS("http://www.w3.org/1999/xhtml","div"),node.innerHTML=block.innerHTML.replace(/\n/g,"").replace(/<br[ \/]*>/g,"\n")):node=block;var text=node.textContent,result=language?highlight(language,text,!0):highlightAuto(text),originalStream=nodeStream(node);if(originalStream.length){var resultNode=document.createElementNS("http://www.w3.org/1999/xhtml","div");resultNode.innerHTML=result.value,result.value=mergeStreams(originalStream,nodeStream(resultNode),text)}result.value=fixMarkup(result.value),block.innerHTML=result.value,block.className=buildClassName(block.className,language,result.language),block.result={language:result.language,re:result.relevance},result.second_best&&(block.second_best={language:result.second_best.language,re:result.second_best.relevance})}}function configure(user_options){options=inherit(options,user_options)}function initHighlighting(){if(!initHighlighting.called){initHighlighting.called=!0;var blocks=document.querySelectorAll("pre code");Array.prototype.forEach.call(blocks,highlightBlock)}}function initHighlightingOnLoad(){addEventListener("DOMContentLoaded",initHighlighting,!1),addEventListener("load",initHighlighting,!1)}function registerLanguage(name,language){var lang=languages[name]=language(hljs);lang.aliases&&lang.aliases.forEach(function(alias){aliases[alias]=name})}function listLanguages(){return Object.keys(languages)}function getLanguage(name){return name=(name||"").toLowerCase(),languages[name]||languages[aliases[name]]}var options={classPrefix:"hljs-",tabReplace:null,useBR:!1,languages:void 0},languages={},aliases={};return hljs.highlight=highlight,hljs.highlightAuto=highlightAuto,hljs.fixMarkup=fixMarkup,hljs.highlightBlock=highlightBlock,hljs.configure=configure,hljs.initHighlighting=initHighlighting,hljs.initHighlightingOnLoad=initHighlightingOnLoad,hljs.registerLanguage=registerLanguage,hljs.listLanguages=listLanguages,hljs.getLanguage=getLanguage,hljs.inherit=inherit,hljs.IDENT_RE="[a-zA-Z]\\w*",hljs.UNDERSCORE_IDENT_RE="[a-zA-Z_]\\w*",hljs.NUMBER_RE="\\b\\d+(\\.\\d+)?",hljs.C_NUMBER_RE="(\\b0[xX][a-fA-F0-9]+|(\\b\\d+(\\.\\d*)?|\\.\\d+)([eE][-+]?\\d+)?)",hljs.BINARY_NUMBER_RE="\\b(0b[01]+)",hljs.RE_STARTERS_RE="!|!=|!==|%|%=|&|&&|&=|\\*|\\*=|\\+|\\+=|,|-|-=|/=|/|:|;|<<|<<=|<=|<|===|==|=|>>>=|>>=|>=|>>>|>>|>|\\?|\\[|\\{|\\(|\\^|\\^=|\\||\\|=|\\|\\||~",hljs.BACKSLASH_ESCAPE={begin:"\\\\[\\s\\S]",relevance:0},hljs.APOS_STRING_MODE={className:"string",begin:"'",end:"'",illegal:"\\n",contains:[hljs.BACKSLASH_ESCAPE]},hljs.QUOTE_STRING_MODE={className:"string",begin:'"',end:'"',illegal:"\\n",contains:[hljs.BACKSLASH_ESCAPE]},hljs.PHRASAL_WORDS_MODE={begin:/\b(a|an|the|are|I|I'm|isn't|don't|doesn't|won't|but|just|should|pretty|simply|enough|gonna|going|wtf|so|such|will|you|your|like)\b/},hljs.COMMENT=function(begin,end,inherits){var mode=hljs.inherit({className:"comment",begin:begin,end:end,contains:[]},inherits||{});return mode.contains.push(hljs.PHRASAL_WORDS_MODE),mode.contains.push({className:"doctag",begin:"(?:TODO|FIXME|NOTE|BUG|XXX):",relevance:0}),mode},hljs.C_LINE_COMMENT_MODE=hljs.COMMENT("//","$"),hljs.C_BLOCK_COMMENT_MODE=hljs.COMMENT("/\\*","\\*/"),hljs.HASH_COMMENT_MODE=hljs.COMMENT("#","$"),hljs.NUMBER_MODE={className:"number",begin:hljs.NUMBER_RE,relevance:0},hljs.C_NUMBER_MODE={className:"number",begin:hljs.C_NUMBER_RE,relevance:0},hljs.BINARY_NUMBER_MODE={className:"number",begin:hljs.BINARY_NUMBER_RE,relevance:0},hljs.CSS_NUMBER_MODE={className:"number",begin:hljs.NUMBER_RE+"(%|em|ex|ch|rem|vw|vh|vmin|vmax|cm|mm|in|pt|pc|px|deg|grad|rad|turn|s|ms|Hz|kHz|dpi|dpcm|dppx)?",relevance:0},hljs.REGEXP_MODE={className:"regexp",begin:/\//,end:/\/[gimuy]*/,illegal:/\n/,contains:[hljs.BACKSLASH_ESCAPE,{begin:/\[/,end:/\]/,relevance:0,contains:[hljs.BACKSLASH_ESCAPE]}]},hljs.TITLE_MODE={className:"title",begin:hljs.IDENT_RE,relevance:0},hljs.UNDERSCORE_TITLE_MODE={className:"title",begin:hljs.UNDERSCORE_IDENT_RE,relevance:0},hljs.registerLanguage("1c",function(hljs){var IDENT_RE_RU="[a-zA-Zа-яА-Я][a-zA-Z0-9_а-яА-Я]*",OneS_KEYWORDS="возврат дата для если и или иначе иначеесли исключение конецесли конецпопытки конецпроцедуры конецфункции конеццикла константа не перейти перем перечисление по пока попытка прервать продолжить процедура строка тогда фс функция цикл число экспорт",OneS_BUILT_IN="ansitooem oemtoansi ввестивидсубконто ввестидату ввестизначение ввестиперечисление ввестипериод ввестиплансчетов ввестистроку ввестичисло вопрос восстановитьзначение врег выбранныйплансчетов вызватьисключение датагод датамесяц датачисло добавитьмесяц завершитьработусистемы заголовоксистемы записьжурналарегистрации запуститьприложение зафиксироватьтранзакцию значениевстроку значениевстрокувнутр значениевфайл значениеизстроки значениеизстрокивнутр значениеизфайла имякомпьютера имяпользователя каталогвременныхфайлов каталогиб каталогпользователя каталогпрограммы кодсимв командасистемы конгода конецпериодаби конецрассчитанногопериодаби конецстандартногоинтервала конквартала конмесяца коннедели лев лог лог10 макс максимальноеколичествосубконто мин монопольныйрежим названиеинтерфейса названиенабораправ назначитьвид назначитьсчет найти найтипомеченныенаудаление найтиссылки началопериодаби началостандартногоинтервала начатьтранзакцию начгода начквартала начмесяца начнедели номерднягода номерднянедели номернеделигода нрег обработкаожидания окр описаниеошибки основнойжурналрасчетов основнойплансчетов основнойязык открытьформу открытьформумодально отменитьтранзакцию очиститьокносообщений периодстр полноеимяпользователя получитьвремята получитьдатута получитьдокументта получитьзначенияотбора получитьпозициюта получитьпустоезначение получитьта прав праводоступа предупреждение префиксавтонумерации пустаястрока пустоезначение рабочаядаттьпустоезначение рабочаядата разделительстраниц разделительстрок разм разобратьпозициюдокумента рассчитатьрегистрына рассчитатьрегистрыпо сигнал симв символтабуляции создатьобъект сокрл сокрлп сокрп сообщить состояние сохранитьзначение сред статусвозврата стрдлина стрзаменить стрколичествострок стрполучитьстроку  стрчисловхождений сформироватьпозициюдокумента счетпокоду текущаядата текущеевремя типзначения типзначениястр удалитьобъекты установитьтана установитьтапо фиксшаблон формат цел шаблон",DQUOTE={className:"dquote",begin:'""'},STR_START={className:"string",begin:'"',end:'"|$',contains:[DQUOTE]},STR_CONT={className:"string",begin:"\\|",end:'"|$',contains:[DQUOTE]};return{case_insensitive:!0,lexemes:IDENT_RE_RU,keywords:{keyword:OneS_KEYWORDS,built_in:OneS_BUILT_IN},contains:[hljs.C_LINE_COMMENT_MODE,hljs.NUMBER_MODE,STR_START,STR_CONT,{className:"function",begin:"(процедура|функция)",end:"$",lexemes:IDENT_RE_RU,keywords:"процедура функция",contains:[hljs.inherit(hljs.TITLE_MODE,{begin:IDENT_RE_RU}),{className:"tail",endsWithParent:!0,contains:[{className:"params",begin:"\\(",end:"\\)",lexemes:IDENT_RE_RU,keywords:"знач",contains:[STR_START,STR_CONT]},{className:"export",begin:"экспорт",endsWithParent:!0,lexemes:IDENT_RE_RU,keywords:"экспорт",contains:[hljs.C_LINE_COMMENT_MODE]}]},hljs.C_LINE_COMMENT_MODE]},{className:"preprocessor",begin:"#",end:"$"},{className:"date",begin:"'\\d{2}\\.\\d{2}\\.(\\d{2}|\\d{4})'"}]}}),hljs.registerLanguage("accesslog",function(hljs){return{contains:[{className:"number",begin:"\\b\\d{1,3}\\.\\d{1,3}\\.\\d{1,3}\\.\\d{1,3}(:\\d{1,5})?\\b"},{className:"number",begin:"\\b\\d+\\b",relevance:0},{className:"string",begin:'"(GET|POST|HEAD|PUT|DELETE|CONNECT|OPTIONS|PATCH|TRACE)',end:'"',keywords:"GET POST HEAD PUT DELETE CONNECT OPTIONS PATCH TRACE",illegal:"\\n",relevance:10},{className:"string",begin:/\[/,end:/\]/,illegal:"\\n"},{className:"string",begin:'"',end:'"',illegal:"\\n"}]}}),hljs.registerLanguage("actionscript",function(hljs){var IDENT_RE="[a-zA-Z_$][a-zA-Z0-9_$]*",IDENT_FUNC_RETURN_TYPE_RE="([*]|[a-zA-Z_$][a-zA-Z0-9_$]*)",AS3_REST_ARG_MODE={className:"rest_arg",begin:"[.]{3}",end:IDENT_RE,relevance:10};return{aliases:["as"],keywords:{keyword:"as break case catch class const continue default delete do dynamic each else extends final finally for function get if implements import in include instanceof interface internal is namespace native new override package private protected public return set static super switch this throw try typeof use var void while with",literal:"true false null undefined"},contains:[hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,hljs.C_NUMBER_MODE,{className:"package",beginKeywords:"package",end:"{",contains:[hljs.TITLE_MODE]},{className:"class",beginKeywords:"class interface",end:"{",excludeEnd:!0,contains:[{beginKeywords:"extends implements"},hljs.TITLE_MODE]},{className:"preprocessor",beginKeywords:"import include",end:";"},{className:"function",beginKeywords:"function",end:"[{;]",excludeEnd:!0,illegal:"\\S",contains:[hljs.TITLE_MODE,{className:"params",begin:"\\(",end:"\\)",contains:[hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,AS3_REST_ARG_MODE]},{className:"type",begin:":",end:IDENT_FUNC_RETURN_TYPE_RE,relevance:10}]}],illegal:/#/}}),hljs.registerLanguage("apache",function(hljs){var NUMBER={className:"number",begin:"[\\$%]\\d+"};return{aliases:["apacheconf"],case_insensitive:!0,contains:[hljs.HASH_COMMENT_MODE,{className:"tag",begin:"</?",end:">"},{className:"keyword",begin:/\w+/,relevance:0,keywords:{common:"order deny allow setenv rewriterule rewriteengine rewritecond documentroot sethandler errordocument loadmodule options header listen serverroot servername"},starts:{end:/$/,relevance:0,keywords:{literal:"on off all"},contains:[{className:"sqbracket",begin:"\\s\\[",end:"\\]$"},{className:"cbracket",begin:"[\\$%]\\{",end:"\\}",contains:["self",NUMBER]},NUMBER,hljs.QUOTE_STRING_MODE]}}],illegal:/\S/}}),hljs.registerLanguage("applescript",function(hljs){var STRING=hljs.inherit(hljs.QUOTE_STRING_MODE,{illegal:""}),PARAMS={className:"params",begin:"\\(",end:"\\)",contains:["self",hljs.C_NUMBER_MODE,STRING]},COMMENT_MODE_1=hljs.COMMENT("--","$"),COMMENT_MODE_2=hljs.COMMENT("\\(\\*","\\*\\)",{contains:["self",COMMENT_MODE_1]}),COMMENTS=[COMMENT_MODE_1,COMMENT_MODE_2,hljs.HASH_COMMENT_MODE];return{aliases:["osascript"],keywords:{keyword:"about above after against and around as at back before beginning behind below beneath beside between but by considering contain contains continue copy div does eighth else end equal equals error every exit fifth first for fourth from front get given global if ignoring in into is it its last local me middle mod my ninth not of on onto or over prop property put ref reference repeat returning script second set seventh since sixth some tell tenth that the|0 then third through thru timeout times to transaction try until where while whose with without",constant:"AppleScript false linefeed return pi quote result space tab true",type:"alias application boolean class constant date file integer list number real record string text",command:"activate beep count delay launch log offset read round run say summarize write",property:"character characters contents day frontmost id item length month name paragraph paragraphs rest reverse running time version weekday word words year"},contains:[STRING,hljs.C_NUMBER_MODE,{className:"type",begin:"\\bPOSIX file\\b"},{className:"command",begin:"\\b(clipboard info|the clipboard|info for|list (disks|folder)|mount volume|path to|(close|open for) access|(get|set) eof|current date|do shell script|get volume settings|random number|set volume|system attribute|system info|time to GMT|(load|run|store) script|scripting components|ASCII (character|number)|localized string|choose (application|color|file|file name|folder|from list|remote application|URL)|display (alert|dialog))\\b|^\\s*return\\b"
},{className:"constant",begin:"\\b(text item delimiters|current application|missing value)\\b"},{className:"keyword",begin:"\\b(apart from|aside from|instead of|out of|greater than|isn't|(doesn't|does not) (equal|come before|come after|contain)|(greater|less) than( or equal)?|(starts?|ends|begins?) with|contained by|comes (before|after)|a (ref|reference))\\b"},{className:"property",begin:"\\b(POSIX path|(date|time) string|quoted form)\\b"},{className:"function_start",beginKeywords:"on",illegal:"[${=;\\n]",contains:[hljs.UNDERSCORE_TITLE_MODE,PARAMS]}].concat(COMMENTS),illegal:"//|->|=>|\\[\\["}}),hljs.registerLanguage("armasm",function(hljs){return{case_insensitive:!0,aliases:["arm"],lexemes:"\\.?"+hljs.IDENT_RE,keywords:{literal:"r0 r1 r2 r3 r4 r5 r6 r7 r8 r9 r10 r11 r12 r13 r14 r15 pc lr sp ip sl sb fp a1 a2 a3 a4 v1 v2 v3 v4 v5 v6 v7 v8 f0 f1 f2 f3 f4 f5 f6 f7 p0 p1 p2 p3 p4 p5 p6 p7 p8 p9 p10 p11 p12 p13 p14 p15 c0 c1 c2 c3 c4 c5 c6 c7 c8 c9 c10 c11 c12 c13 c14 c15 q0 q1 q2 q3 q4 q5 q6 q7 q8 q9 q10 q11 q12 q13 q14 q15 cpsr_c cpsr_x cpsr_s cpsr_f cpsr_cx cpsr_cxs cpsr_xs cpsr_xsf cpsr_sf cpsr_cxsf spsr_c spsr_x spsr_s spsr_f spsr_cx spsr_cxs spsr_xs spsr_xsf spsr_sf spsr_cxsf s0 s1 s2 s3 s4 s5 s6 s7 s8 s9 s10 s11 s12 s13 s14 s15 s16 s17 s18 s19 s20 s21 s22 s23 s24 s25 s26 s27 s28 s29 s30 s31 d0 d1 d2 d3 d4 d5 d6 d7 d8 d9 d10 d11 d12 d13 d14 d15 d16 d17 d18 d19 d20 d21 d22 d23 d24 d25 d26 d27 d28 d29 d30 d31 ",preprocessor:".2byte .4byte .align .ascii .asciz .balign .byte .code .data .else .end .endif .endm .endr .equ .err .exitm .extern .global .hword .if .ifdef .ifndef .include .irp .long .macro .rept .req .section .set .skip .space .text .word .arm .thumb .code16 .code32 .force_thumb .thumb_func .ltorg ALIAS ALIGN ARM AREA ASSERT ATTR CN CODE CODE16 CODE32 COMMON CP DATA DCB DCD DCDU DCDO DCFD DCFDU DCI DCQ DCQU DCW DCWU DN ELIF ELSE END ENDFUNC ENDIF ENDP ENTRY EQU EXPORT EXPORTAS EXTERN FIELD FILL FUNCTION GBLA GBLL GBLS GET GLOBAL IF IMPORT INCBIN INCLUDE INFO KEEP LCLA LCLL LCLS LTORG MACRO MAP MEND MEXIT NOFP OPT PRESERVE8 PROC QN READONLY RELOC REQUIRE REQUIRE8 RLIST FN ROUT SETA SETL SETS SN SPACE SUBT THUMB THUMBX TTL WHILE WEND ",built_in:"{PC} {VAR} {TRUE} {FALSE} {OPT} {CONFIG} {ENDIAN} {CODESIZE} {CPU} {FPU} {ARCHITECTURE} {PCSTOREOFFSET} {ARMASM_VERSION} {INTER} {ROPI} {RWPI} {SWST} {NOSWST} . @ "},contains:[{className:"keyword",begin:"\\b(adc|(qd?|sh?|u[qh]?)?add(8|16)?|usada?8|(q|sh?|u[qh]?)?(as|sa)x|and|adrl?|sbc|rs[bc]|asr|b[lx]?|blx|bxj|cbn?z|tb[bh]|bic|bfc|bfi|[su]bfx|bkpt|cdp2?|clz|clrex|cmp|cmn|cpsi[ed]|cps|setend|dbg|dmb|dsb|eor|isb|it[te]{0,3}|lsl|lsr|ror|rrx|ldm(([id][ab])|f[ds])?|ldr((s|ex)?[bhd])?|movt?|mvn|mra|mar|mul|[us]mull|smul[bwt][bt]|smu[as]d|smmul|smmla|mla|umlaal|smlal?([wbt][bt]|d)|mls|smlsl?[ds]|smc|svc|sev|mia([bt]{2}|ph)?|mrr?c2?|mcrr2?|mrs|msr|orr|orn|pkh(tb|bt)|rbit|rev(16|sh)?|sel|[su]sat(16)?|nop|pop|push|rfe([id][ab])?|stm([id][ab])?|str(ex)?[bhd]?|(qd?)?sub|(sh?|q|u[qh]?)?sub(8|16)|[su]xt(a?h|a?b(16)?)|srs([id][ab])?|swpb?|swi|smi|tst|teq|wfe|wfi|yield)(eq|ne|cs|cc|mi|pl|vs|vc|hi|ls|ge|lt|gt|le|al|hs|lo)?[sptrx]?",end:"\\s"},hljs.COMMENT("[;@]","$",{relevance:0}),hljs.C_BLOCK_COMMENT_MODE,hljs.QUOTE_STRING_MODE,{className:"string",begin:"'",end:"[^\\\\]'",relevance:0},{className:"title",begin:"\\|",end:"\\|",illegal:"\\n",relevance:0},{className:"number",variants:[{begin:"[#$=]?0x[0-9a-f]+"},{begin:"[#$=]?0b[01]+"},{begin:"[#$=]\\d+"},{begin:"\\b\\d+"}],relevance:0},{className:"label",variants:[{begin:"^[a-z_\\.\\$][a-z0-9_\\.\\$]+"},{begin:"^\\s*[a-z_\\.\\$][a-z0-9_\\.\\$]+:"},{begin:"[=#]\\w+"}],relevance:0}]}}),hljs.registerLanguage("xml",function(hljs){var XML_IDENT_RE="[A-Za-z0-9\\._:-]+",PHP={begin:/<\?(php)?(?!\w)/,end:/\?>/,subLanguage:"php"},TAG_INTERNALS={endsWithParent:!0,illegal:/</,relevance:0,contains:[PHP,{className:"attribute",begin:XML_IDENT_RE,relevance:0},{begin:"=",relevance:0,contains:[{className:"value",contains:[PHP],variants:[{begin:/"/,end:/"/},{begin:/'/,end:/'/},{begin:/[^\s\/>]+/}]}]}]};return{aliases:["html","xhtml","rss","atom","xsl","plist"],case_insensitive:!0,contains:[{className:"doctype",begin:"<!DOCTYPE",end:">",relevance:10,contains:[{begin:"\\[",end:"\\]"}]},hljs.COMMENT("<!--","-->",{relevance:10}),{className:"cdata",begin:"<\\!\\[CDATA\\[",end:"\\]\\]>",relevance:10},{className:"tag",begin:"<style(?=\\s|>|$)",end:">",keywords:{title:"style"},contains:[TAG_INTERNALS],starts:{end:"</style>",returnEnd:!0,subLanguage:"css"}},{className:"tag",begin:"<script(?=\\s|>|$)",end:">",keywords:{title:"script"},contains:[TAG_INTERNALS],starts:{end:"</script>",returnEnd:!0,subLanguage:["actionscript","javascript","handlebars"]}},PHP,{className:"pi",begin:/<\?\w+/,end:/\?>/,relevance:10},{className:"tag",begin:"</?",end:"/?>",contains:[{className:"title",begin:/[^ \/><\n\t]+/,relevance:0},TAG_INTERNALS]}]}}),hljs.registerLanguage("asciidoc",function(hljs){return{aliases:["adoc"],contains:[hljs.COMMENT("^/{4,}\\n","\\n/{4,}$",{relevance:10}),hljs.COMMENT("^//","$",{relevance:0}),{className:"title",begin:"^\\.\\w.*$"},{begin:"^[=\\*]{4,}\\n",end:"\\n^[=\\*]{4,}$",relevance:10},{className:"header",begin:"^(={1,5}) .+?( \\1)?$",relevance:10},{className:"header",begin:"^[^\\[\\]\\n]+?\\n[=\\-~\\^\\+]{2,}$",relevance:10},{className:"attribute",begin:"^:.+?:",end:"\\s",excludeEnd:!0,relevance:10},{className:"attribute",begin:"^\\[.+?\\]$",relevance:0},{className:"blockquote",begin:"^_{4,}\\n",end:"\\n_{4,}$",relevance:10},{className:"code",begin:"^[\\-\\.]{4,}\\n",end:"\\n[\\-\\.]{4,}$",relevance:10},{begin:"^\\+{4,}\\n",end:"\\n\\+{4,}$",contains:[{begin:"<",end:">",subLanguage:"xml",relevance:0}],relevance:10},{className:"bullet",begin:"^(\\*+|\\-+|\\.+|[^\\n]+?::)\\s+"},{className:"label",begin:"^(NOTE|TIP|IMPORTANT|WARNING|CAUTION):\\s+",relevance:10},{className:"strong",begin:"\\B\\*(?![\\*\\s])",end:"(\\n{2}|\\*)",contains:[{begin:"\\\\*\\w",relevance:0}]},{className:"emphasis",begin:"\\B'(?!['\\s])",end:"(\\n{2}|')",contains:[{begin:"\\\\'\\w",relevance:0}],relevance:0},{className:"emphasis",begin:"_(?![_\\s])",end:"(\\n{2}|_)",relevance:0},{className:"smartquote",variants:[{begin:"``.+?''"},{begin:"`.+?'"}]},{className:"code",begin:"(`.+?`|\\+.+?\\+)",relevance:0},{className:"code",begin:"^[ \\t]",end:"$",relevance:0},{className:"horizontal_rule",begin:"^'{3,}[ \\t]*$",relevance:10},{begin:"(link:)?(http|https|ftp|file|irc|image:?):\\S+\\[.*?\\]",returnBegin:!0,contains:[{begin:"(link|image:?):",relevance:0},{className:"link_url",begin:"\\w",end:"[^\\[]+",relevance:0},{className:"link_label",begin:"\\[",end:"\\]",excludeBegin:!0,excludeEnd:!0,relevance:0}],relevance:10}]}}),hljs.registerLanguage("aspectj",function(hljs){var KEYWORDS="false synchronized int abstract float private char boolean static null if const for true while long throw strictfp finally protected import native final return void enum else extends implements break transient new catch instanceof byte super volatile case assert short package default double public try this switch continue throws privileged aspectOf adviceexecution proceed cflowbelow cflow initialization preinitialization staticinitialization withincode target within execution getWithinTypeName handler thisJoinPoint thisJoinPointStaticPart thisEnclosingJoinPointStaticPart declare parents warning error soft precedence thisAspectInstance",SHORTKEYS="get set args call";return{keywords:KEYWORDS,illegal:/<\/|#/,contains:[hljs.COMMENT("/\\*\\*","\\*/",{relevance:0,contains:[{className:"doctag",begin:"@[A-Za-z]+"}]}),hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,{className:"aspect",beginKeywords:"aspect",end:/[{;=]/,excludeEnd:!0,illegal:/[:;"\[\]]/,contains:[{beginKeywords:"extends implements pertypewithin perthis pertarget percflowbelow percflow issingleton"},hljs.UNDERSCORE_TITLE_MODE,{begin:/\([^\)]*/,end:/[)]+/,keywords:KEYWORDS+" "+SHORTKEYS,excludeEnd:!1}]},{className:"class",beginKeywords:"class interface",end:/[{;=]/,excludeEnd:!0,relevance:0,keywords:"class interface",illegal:/[:"\[\]]/,contains:[{beginKeywords:"extends implements"},hljs.UNDERSCORE_TITLE_MODE]},{beginKeywords:"pointcut after before around throwing returning",end:/[)]/,excludeEnd:!1,illegal:/["\[\]]/,contains:[{begin:hljs.UNDERSCORE_IDENT_RE+"\\s*\\(",returnBegin:!0,contains:[hljs.UNDERSCORE_TITLE_MODE]}]},{begin:/[:]/,returnBegin:!0,end:/[{;]/,relevance:0,excludeEnd:!1,keywords:KEYWORDS,illegal:/["\[\]]/,contains:[{begin:hljs.UNDERSCORE_IDENT_RE+"\\s*\\(",keywords:KEYWORDS+" "+SHORTKEYS},hljs.QUOTE_STRING_MODE]},{beginKeywords:"new throw",relevance:0},{className:"function",begin:/\w+ +\w+(\.)?\w+\s*\([^\)]*\)\s*((throws)[\w\s,]+)?[\{;]/,returnBegin:!0,end:/[{;=]/,keywords:KEYWORDS,excludeEnd:!0,contains:[{begin:hljs.UNDERSCORE_IDENT_RE+"\\s*\\(",returnBegin:!0,relevance:0,contains:[hljs.UNDERSCORE_TITLE_MODE]},{className:"params",begin:/\(/,end:/\)/,relevance:0,keywords:KEYWORDS,contains:[hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.C_NUMBER_MODE,hljs.C_BLOCK_COMMENT_MODE]},hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE]},hljs.C_NUMBER_MODE,{className:"annotation",begin:"@[A-Za-z]+"}]}}),hljs.registerLanguage("autohotkey",function(hljs){var BACKTICK_ESCAPE={className:"escape",begin:"`[\\s\\S]"},COMMENTS=hljs.COMMENT(";","$",{relevance:0}),BUILT_IN=[{className:"built_in",begin:"A_[a-zA-Z0-9]+"},{className:"built_in",beginKeywords:"ComSpec Clipboard ClipboardAll ErrorLevel"}];return{case_insensitive:!0,keywords:{keyword:"Break Continue Else Gosub If Loop Return While",literal:"A true false NOT AND OR"},contains:BUILT_IN.concat([BACKTICK_ESCAPE,hljs.inherit(hljs.QUOTE_STRING_MODE,{contains:[BACKTICK_ESCAPE]}),COMMENTS,{className:"number",begin:hljs.NUMBER_RE,relevance:0},{className:"var_expand",begin:"%",end:"%",illegal:"\\n",contains:[BACKTICK_ESCAPE]},{className:"label",contains:[BACKTICK_ESCAPE],variants:[{begin:'^[^\\n";]+::(?!=)'},{begin:'^[^\\n";]+:(?!=)',relevance:0}]},{begin:",\\s*,",relevance:10}])}}),hljs.registerLanguage("autoit",function(hljs){var KEYWORDS="ByRef Case Const ContinueCase ContinueLoop Default Dim Do Else ElseIf EndFunc EndIf EndSelect EndSwitch EndWith Enum Exit ExitLoop For Func Global If In Local Next ReDim Return Select Static Step Switch Then To Until Volatile WEnd While With",LITERAL="True False And Null Not Or",BUILT_IN="Abs ACos AdlibRegister AdlibUnRegister Asc AscW ASin Assign ATan AutoItSetOption AutoItWinGetTitle AutoItWinSetTitle Beep Binary BinaryLen BinaryMid BinaryToString BitAND BitNOT BitOR BitRotate BitShift BitXOR BlockInput Break Call CDTray Ceiling Chr ChrW ClipGet ClipPut ConsoleRead ConsoleWrite ConsoleWriteError ControlClick ControlCommand ControlDisable ControlEnable ControlFocus ControlGetFocus ControlGetHandle ControlGetPos ControlGetText ControlHide ControlListView ControlMove ControlSend ControlSetText ControlShow ControlTreeView Cos Dec DirCopy DirCreate DirGetSize DirMove DirRemove DllCall DllCallAddress DllCallbackFree DllCallbackGetPtr DllCallbackRegister DllClose DllOpen DllStructCreate DllStructGetData DllStructGetPtr DllStructGetSize DllStructSetData DriveGetDrive DriveGetFileSystem DriveGetLabel DriveGetSerial DriveGetType DriveMapAdd DriveMapDel DriveMapGet DriveSetLabel DriveSpaceFree DriveSpaceTotal DriveStatus EnvGet EnvSet EnvUpdate Eval Execute Exp FileChangeDir FileClose FileCopy FileCreateNTFSLink FileCreateShortcut FileDelete FileExists FileFindFirstFile FileFindNextFile FileFlush FileGetAttrib FileGetEncoding FileGetLongName FileGetPos FileGetShortcut FileGetShortName FileGetSize FileGetTime FileGetVersion FileInstall FileMove FileOpen FileOpenDialog FileRead FileReadLine FileReadToArray FileRecycle FileRecycleEmpty FileSaveDialog FileSelectFolder FileSetAttrib FileSetEnd FileSetPos FileSetTime FileWrite FileWriteLine Floor FtpSetProxy FuncName GUICreate GUICtrlCreateAvi GUICtrlCreateButton GUICtrlCreateCheckbox GUICtrlCreateCombo GUICtrlCreateContextMenu GUICtrlCreateDate GUICtrlCreateDummy GUICtrlCreateEdit GUICtrlCreateGraphic GUICtrlCreateGroup GUICtrlCreateIcon GUICtrlCreateInput GUICtrlCreateLabel GUICtrlCreateList GUICtrlCreateListView GUICtrlCreateListViewItem GUICtrlCreateMenu GUICtrlCreateMenuItem GUICtrlCreateMonthCal GUICtrlCreateObj GUICtrlCreatePic GUICtrlCreateProgress GUICtrlCreateRadio GUICtrlCreateSlider GUICtrlCreateTab GUICtrlCreateTabItem GUICtrlCreateTreeView GUICtrlCreateTreeViewItem GUICtrlCreateUpdown GUICtrlDelete GUICtrlGetHandle GUICtrlGetState GUICtrlRead GUICtrlRecvMsg GUICtrlRegisterListViewSort GUICtrlSendMsg GUICtrlSendToDummy GUICtrlSetBkColor GUICtrlSetColor GUICtrlSetCursor GUICtrlSetData GUICtrlSetDefBkColor GUICtrlSetDefColor GUICtrlSetFont GUICtrlSetGraphic GUICtrlSetImage GUICtrlSetLimit GUICtrlSetOnEvent GUICtrlSetPos GUICtrlSetResizing GUICtrlSetState GUICtrlSetStyle GUICtrlSetTip GUIDelete GUIGetCursorInfo GUIGetMsg GUIGetStyle GUIRegisterMsg GUISetAccelerators GUISetBkColor GUISetCoord GUISetCursor GUISetFont GUISetHelp GUISetIcon GUISetOnEvent GUISetState GUISetStyle GUIStartGroup GUISwitch Hex HotKeySet HttpSetProxy HttpSetUserAgent HWnd InetClose InetGet InetGetInfo InetGetSize InetRead IniDelete IniRead IniReadSection IniReadSectionNames IniRenameSection IniWrite IniWriteSection InputBox Int IsAdmin IsArray IsBinary IsBool IsDeclared IsDllStruct IsFloat IsFunc IsHWnd IsInt IsKeyword IsNumber IsObj IsPtr IsString Log MemGetStats Mod MouseClick MouseClickDrag MouseDown MouseGetCursor MouseGetPos MouseMove MouseUp MouseWheel MsgBox Number ObjCreate ObjCreateInterface ObjEvent ObjGet ObjName OnAutoItExitRegister OnAutoItExitUnRegister Opt Ping PixelChecksum PixelGetColor PixelSearch ProcessClose ProcessExists ProcessGetStats ProcessList ProcessSetPriority ProcessWait ProcessWaitClose ProgressOff ProgressOn ProgressSet Ptr Random RegDelete RegEnumKey RegEnumVal RegRead RegWrite Round Run RunAs RunAsWait RunWait Send SendKeepActive SetError SetExtended ShellExecute ShellExecuteWait Shutdown Sin Sleep SoundPlay SoundSetWaveVolume SplashImageOn SplashOff SplashTextOn Sqrt SRandom StatusbarGetText StderrRead StdinWrite StdioClose StdoutRead String StringAddCR StringCompare StringFormat StringFromASCIIArray StringInStr StringIsAlNum StringIsAlpha StringIsASCII StringIsDigit StringIsFloat StringIsInt StringIsLower StringIsSpace StringIsUpper StringIsXDigit StringLeft StringLen StringLower StringMid StringRegExp StringRegExpReplace StringReplace StringReverse StringRight StringSplit StringStripCR StringStripWS StringToASCIIArray StringToBinary StringTrimLeft StringTrimRight StringUpper Tan TCPAccept TCPCloseSocket TCPConnect TCPListen TCPNameToIP TCPRecv TCPSend TCPShutdown TCPStartup TimerDiff TimerInit ToolTip TrayCreateItem TrayCreateMenu TrayGetMsg TrayItemDelete TrayItemGetHandle TrayItemGetState TrayItemGetText TrayItemSetOnEvent TrayItemSetState TrayItemSetText TraySetClick TraySetIcon TraySetOnEvent TraySetPauseIcon TraySetState TraySetToolTip TrayTip UBound UDPBind UDPCloseSocket UDPOpen UDPRecv UDPSend UDPShutdown UDPStartup VarGetType WinActivate WinActive WinClose WinExists WinFlash WinGetCaretPos WinGetClassList WinGetClientSize WinGetHandle WinGetPos WinGetProcess WinGetState WinGetText WinGetTitle WinKill WinList WinMenuSelectItem WinMinimizeAll WinMinimizeAllUndo WinMove WinSetOnTop WinSetState WinSetTitle WinSetTrans WinWait WinWaitActive WinWaitClose WinWaitNotActive Array1DToHistogram ArrayAdd ArrayBinarySearch ArrayColDelete ArrayColInsert ArrayCombinations ArrayConcatenate ArrayDelete ArrayDisplay ArrayExtract ArrayFindAll ArrayInsert ArrayMax ArrayMaxIndex ArrayMin ArrayMinIndex ArrayPermute ArrayPop ArrayPush ArrayReverse ArraySearch ArrayShuffle ArraySort ArraySwap ArrayToClip ArrayToString ArrayTranspose ArrayTrim ArrayUnique Assert ChooseColor ChooseFont ClipBoard_ChangeChain ClipBoard_Close ClipBoard_CountFormats ClipBoard_Empty ClipBoard_EnumFormats ClipBoard_FormatStr ClipBoard_GetData ClipBoard_GetDataEx ClipBoard_GetFormatName ClipBoard_GetOpenWindow ClipBoard_GetOwner ClipBoard_GetPriorityFormat ClipBoard_GetSequenceNumber ClipBoard_GetViewer ClipBoard_IsFormatAvailable ClipBoard_Open ClipBoard_RegisterFormat ClipBoard_SetData ClipBoard_SetDataEx ClipBoard_SetViewer ClipPutFile ColorConvertHSLtoRGB ColorConvertRGBtoHSL ColorGetBlue ColorGetCOLORREF ColorGetGreen ColorGetRed ColorGetRGB ColorSetCOLORREF ColorSetRGB Crypt_DecryptData Crypt_DecryptFile Crypt_DeriveKey Crypt_DestroyKey Crypt_EncryptData Crypt_EncryptFile Crypt_GenRandom Crypt_HashData Crypt_HashFile Crypt_Shutdown Crypt_Startup DateAdd DateDayOfWeek DateDaysInMonth DateDiff DateIsLeapYear DateIsValid DateTimeFormat DateTimeSplit DateToDayOfWeek DateToDayOfWeekISO DateToDayValue DateToMonth Date_Time_CompareFileTime Date_Time_DOSDateTimeToArray Date_Time_DOSDateTimeToFileTime Date_Time_DOSDateTimeToStr Date_Time_DOSDateToArray Date_Time_DOSDateToStr Date_Time_DOSTimeToArray Date_Time_DOSTimeToStr Date_Time_EncodeFileTime Date_Time_EncodeSystemTime Date_Time_FileTimeToArray Date_Time_FileTimeToDOSDateTime Date_Time_FileTimeToLocalFileTime Date_Time_FileTimeToStr Date_Time_FileTimeToSystemTime Date_Time_GetFileTime Date_Time_GetLocalTime Date_Time_GetSystemTime Date_Time_GetSystemTimeAdjustment Date_Time_GetSystemTimeAsFileTime Date_Time_GetSystemTimes Date_Time_GetTickCount Date_Time_GetTimeZoneInformation Date_Time_LocalFileTimeToFileTime Date_Time_SetFileTime Date_Time_SetLocalTime Date_Time_SetSystemTime Date_Time_SetSystemTimeAdjustment Date_Time_SetTimeZoneInformation Date_Time_SystemTimeToArray Date_Time_SystemTimeToDateStr Date_Time_SystemTimeToDateTimeStr Date_Time_SystemTimeToFileTime Date_Time_SystemTimeToTimeStr Date_Time_SystemTimeToTzSpecificLocalTime Date_Time_TzSpecificLocalTimeToSystemTime DayValueToDate DebugBugReportEnv DebugCOMError DebugOut DebugReport DebugReportEx DebugReportVar DebugSetup Degree EventLog__Backup EventLog__Clear EventLog__Close EventLog__Count EventLog__DeregisterSource EventLog__Full EventLog__Notify EventLog__Oldest EventLog__Open EventLog__OpenBackup EventLog__Read EventLog__RegisterSource EventLog__Report Excel_BookAttach Excel_BookClose Excel_BookList Excel_BookNew Excel_BookOpen Excel_BookOpenText Excel_BookSave Excel_BookSaveAs Excel_Close Excel_ColumnToLetter Excel_ColumnToNumber Excel_ConvertFormula Excel_Export Excel_FilterGet Excel_FilterSet Excel_Open Excel_PictureAdd Excel_Print Excel_RangeCopyPaste Excel_RangeDelete Excel_RangeFind Excel_RangeInsert Excel_RangeLinkAddRemove Excel_RangeRead Excel_RangeReplace Excel_RangeSort Excel_RangeValidate Excel_RangeWrite Excel_SheetAdd Excel_SheetCopyMove Excel_SheetDelete Excel_SheetList FileCountLines FileCreate FileListToArray FileListToArrayRec FilePrint FileReadToArray FileWriteFromArray FileWriteLog FileWriteToLine FTP_Close FTP_Command FTP_Connect FTP_DecodeInternetStatus FTP_DirCreate FTP_DirDelete FTP_DirGetCurrent FTP_DirPutContents FTP_DirSetCurrent FTP_FileClose FTP_FileDelete FTP_FileGet FTP_FileGetSize FTP_FileOpen FTP_FilePut FTP_FileRead FTP_FileRename FTP_FileTimeLoHiToStr FTP_FindFileClose FTP_FindFileFirst FTP_FindFileNext FTP_GetLastResponseInfo FTP_ListToArray FTP_ListToArray2D FTP_ListToArrayEx FTP_Open FTP_ProgressDownload FTP_ProgressUpload FTP_SetStatusCallback GDIPlus_ArrowCapCreate GDIPlus_ArrowCapDispose GDIPlus_ArrowCapGetFillState GDIPlus_ArrowCapGetHeight GDIPlus_ArrowCapGetMiddleInset GDIPlus_ArrowCapGetWidth GDIPlus_ArrowCapSetFillState GDIPlus_ArrowCapSetHeight GDIPlus_ArrowCapSetMiddleInset GDIPlus_ArrowCapSetWidth GDIPlus_BitmapApplyEffect GDIPlus_BitmapApplyEffectEx GDIPlus_BitmapCloneArea GDIPlus_BitmapConvertFormat GDIPlus_BitmapCreateApplyEffect GDIPlus_BitmapCreateApplyEffectEx GDIPlus_BitmapCreateDIBFromBitmap GDIPlus_BitmapCreateFromFile GDIPlus_BitmapCreateFromGraphics GDIPlus_BitmapCreateFromHBITMAP GDIPlus_BitmapCreateFromHICON GDIPlus_BitmapCreateFromHICON32 GDIPlus_BitmapCreateFromMemory GDIPlus_BitmapCreateFromResource GDIPlus_BitmapCreateFromScan0 GDIPlus_BitmapCreateFromStream GDIPlus_BitmapCreateHBITMAPFromBitmap GDIPlus_BitmapDispose GDIPlus_BitmapGetHistogram GDIPlus_BitmapGetHistogramEx GDIPlus_BitmapGetHistogramSize GDIPlus_BitmapGetPixel GDIPlus_BitmapLockBits GDIPlus_BitmapSetPixel GDIPlus_BitmapUnlockBits GDIPlus_BrushClone GDIPlus_BrushCreateSolid GDIPlus_BrushDispose GDIPlus_BrushGetSolidColor GDIPlus_BrushGetType GDIPlus_BrushSetSolidColor GDIPlus_ColorMatrixCreate GDIPlus_ColorMatrixCreateGrayScale GDIPlus_ColorMatrixCreateNegative GDIPlus_ColorMatrixCreateSaturation GDIPlus_ColorMatrixCreateScale GDIPlus_ColorMatrixCreateTranslate GDIPlus_CustomLineCapClone GDIPlus_CustomLineCapCreate GDIPlus_CustomLineCapDispose GDIPlus_CustomLineCapGetStrokeCaps GDIPlus_CustomLineCapSetStrokeCaps GDIPlus_Decoders GDIPlus_DecodersGetCount GDIPlus_DecodersGetSize GDIPlus_DrawImageFX GDIPlus_DrawImageFXEx GDIPlus_DrawImagePoints GDIPlus_EffectCreate GDIPlus_EffectCreateBlur GDIPlus_EffectCreateBrightnessContrast GDIPlus_EffectCreateColorBalance GDIPlus_EffectCreateColorCurve GDIPlus_EffectCreateColorLUT GDIPlus_EffectCreateColorMatrix GDIPlus_EffectCreateHueSaturationLightness GDIPlus_EffectCreateLevels GDIPlus_EffectCreateRedEyeCorrection GDIPlus_EffectCreateSharpen GDIPlus_EffectCreateTint GDIPlus_EffectDispose GDIPlus_EffectGetParameters GDIPlus_EffectSetParameters GDIPlus_Encoders GDIPlus_EncodersGetCLSID GDIPlus_EncodersGetCount GDIPlus_EncodersGetParamList GDIPlus_EncodersGetParamListSize GDIPlus_EncodersGetSize GDIPlus_FontCreate GDIPlus_FontDispose GDIPlus_FontFamilyCreate GDIPlus_FontFamilyCreateFromCollection GDIPlus_FontFamilyDispose GDIPlus_FontFamilyGetCellAscent GDIPlus_FontFamilyGetCellDescent GDIPlus_FontFamilyGetEmHeight GDIPlus_FontFamilyGetLineSpacing GDIPlus_FontGetHeight GDIPlus_FontPrivateAddFont GDIPlus_FontPrivateAddMemoryFont GDIPlus_FontPrivateCollectionDispose GDIPlus_FontPrivateCreateCollection GDIPlus_GraphicsClear GDIPlus_GraphicsCreateFromHDC GDIPlus_GraphicsCreateFromHWND GDIPlus_GraphicsDispose GDIPlus_GraphicsDrawArc GDIPlus_GraphicsDrawBezier GDIPlus_GraphicsDrawClosedCurve GDIPlus_GraphicsDrawClosedCurve2 GDIPlus_GraphicsDrawCurve GDIPlus_GraphicsDrawCurve2 GDIPlus_GraphicsDrawEllipse GDIPlus_GraphicsDrawImage GDIPlus_GraphicsDrawImagePointsRect GDIPlus_GraphicsDrawImageRect GDIPlus_GraphicsDrawImageRectRect GDIPlus_GraphicsDrawLine GDIPlus_GraphicsDrawPath GDIPlus_GraphicsDrawPie GDIPlus_GraphicsDrawPolygon GDIPlus_GraphicsDrawRect GDIPlus_GraphicsDrawString GDIPlus_GraphicsDrawStringEx GDIPlus_GraphicsFillClosedCurve GDIPlus_GraphicsFillClosedCurve2 GDIPlus_GraphicsFillEllipse GDIPlus_GraphicsFillPath GDIPlus_GraphicsFillPie GDIPlus_GraphicsFillPolygon GDIPlus_GraphicsFillRect GDIPlus_GraphicsFillRegion GDIPlus_GraphicsGetCompositingMode GDIPlus_GraphicsGetCompositingQuality GDIPlus_GraphicsGetDC GDIPlus_GraphicsGetInterpolationMode GDIPlus_GraphicsGetSmoothingMode GDIPlus_GraphicsGetTransform GDIPlus_GraphicsMeasureCharacterRanges GDIPlus_GraphicsMeasureString GDIPlus_GraphicsReleaseDC GDIPlus_GraphicsResetClip GDIPlus_GraphicsResetTransform GDIPlus_GraphicsRestore GDIPlus_GraphicsRotateTransform GDIPlus_GraphicsSave GDIPlus_GraphicsScaleTransform GDIPlus_GraphicsSetClipPath GDIPlus_GraphicsSetClipRect GDIPlus_GraphicsSetClipRegion GDIPlus_GraphicsSetCompositingMode GDIPlus_GraphicsSetCompositingQuality GDIPlus_GraphicsSetInterpolationMode GDIPlus_GraphicsSetPixelOffsetMode GDIPlus_GraphicsSetSmoothingMode GDIPlus_GraphicsSetTextRenderingHint GDIPlus_GraphicsSetTransform GDIPlus_GraphicsTransformPoints GDIPlus_GraphicsTranslateTransform GDIPlus_HatchBrushCreate GDIPlus_HICONCreateFromBitmap GDIPlus_ImageAttributesCreate GDIPlus_ImageAttributesDispose GDIPlus_ImageAttributesSetColorKeys GDIPlus_ImageAttributesSetColorMatrix GDIPlus_ImageDispose GDIPlus_ImageGetDimension GDIPlus_ImageGetFlags GDIPlus_ImageGetGraphicsContext GDIPlus_ImageGetHeight GDIPlus_ImageGetHorizontalResolution GDIPlus_ImageGetPixelFormat GDIPlus_ImageGetRawFormat GDIPlus_ImageGetThumbnail GDIPlus_ImageGetType GDIPlus_ImageGetVerticalResolution GDIPlus_ImageGetWidth GDIPlus_ImageLoadFromFile GDIPlus_ImageLoadFromStream GDIPlus_ImageResize GDIPlus_ImageRotateFlip GDIPlus_ImageSaveToFile GDIPlus_ImageSaveToFileEx GDIPlus_ImageSaveToStream GDIPlus_ImageScale GDIPlus_LineBrushCreate GDIPlus_LineBrushCreateFromRect GDIPlus_LineBrushCreateFromRectWithAngle GDIPlus_LineBrushGetColors GDIPlus_LineBrushGetRect GDIPlus_LineBrushMultiplyTransform GDIPlus_LineBrushResetTransform GDIPlus_LineBrushSetBlend GDIPlus_LineBrushSetColors GDIPlus_LineBrushSetGammaCorrection GDIPlus_LineBrushSetLinearBlend GDIPlus_LineBrushSetPresetBlend GDIPlus_LineBrushSetSigmaBlend GDIPlus_LineBrushSetTransform GDIPlus_MatrixClone GDIPlus_MatrixCreate GDIPlus_MatrixDispose GDIPlus_MatrixGetElements GDIPlus_MatrixInvert GDIPlus_MatrixMultiply GDIPlus_MatrixRotate GDIPlus_MatrixScale GDIPlus_MatrixSetElements GDIPlus_MatrixShear GDIPlus_MatrixTransformPoints GDIPlus_MatrixTranslate GDIPlus_PaletteInitialize GDIPlus_ParamAdd GDIPlus_ParamInit GDIPlus_ParamSize GDIPlus_PathAddArc GDIPlus_PathAddBezier GDIPlus_PathAddClosedCurve GDIPlus_PathAddClosedCurve2 GDIPlus_PathAddCurve GDIPlus_PathAddCurve2 GDIPlus_PathAddCurve3 GDIPlus_PathAddEllipse GDIPlus_PathAddLine GDIPlus_PathAddLine2 GDIPlus_PathAddPath GDIPlus_PathAddPie GDIPlus_PathAddPolygon GDIPlus_PathAddRectangle GDIPlus_PathAddString GDIPlus_PathBrushCreate GDIPlus_PathBrushCreateFromPath GDIPlus_PathBrushGetCenterPoint GDIPlus_PathBrushGetFocusScales GDIPlus_PathBrushGetPointCount GDIPlus_PathBrushGetRect GDIPlus_PathBrushGetWrapMode GDIPlus_PathBrushMultiplyTransform GDIPlus_PathBrushResetTransform GDIPlus_PathBrushSetBlend GDIPlus_PathBrushSetCenterColor GDIPlus_PathBrushSetCenterPoint GDIPlus_PathBrushSetFocusScales GDIPlus_PathBrushSetGammaCorrection GDIPlus_PathBrushSetLinearBlend GDIPlus_PathBrushSetPresetBlend GDIPlus_PathBrushSetSigmaBlend GDIPlus_PathBrushSetSurroundColor GDIPlus_PathBrushSetSurroundColorsWithCount GDIPlus_PathBrushSetTransform GDIPlus_PathBrushSetWrapMode GDIPlus_PathClone GDIPlus_PathCloseFigure GDIPlus_PathCreate GDIPlus_PathCreate2 GDIPlus_PathDispose GDIPlus_PathFlatten GDIPlus_PathGetData GDIPlus_PathGetFillMode GDIPlus_PathGetLastPoint GDIPlus_PathGetPointCount GDIPlus_PathGetPoints GDIPlus_PathGetWorldBounds GDIPlus_PathIsOutlineVisiblePoint GDIPlus_PathIsVisiblePoint GDIPlus_PathIterCreate GDIPlus_PathIterDispose GDIPlus_PathIterGetSubpathCount GDIPlus_PathIterNextMarkerPath GDIPlus_PathIterNextSubpathPath GDIPlus_PathIterRewind GDIPlus_PathReset GDIPlus_PathReverse GDIPlus_PathSetFillMode GDIPlus_PathSetMarker GDIPlus_PathStartFigure GDIPlus_PathTransform GDIPlus_PathWarp GDIPlus_PathWiden GDIPlus_PathWindingModeOutline GDIPlus_PenCreate GDIPlus_PenCreate2 GDIPlus_PenDispose GDIPlus_PenGetAlignment GDIPlus_PenGetColor GDIPlus_PenGetCustomEndCap GDIPlus_PenGetDashCap GDIPlus_PenGetDashStyle GDIPlus_PenGetEndCap GDIPlus_PenGetMiterLimit GDIPlus_PenGetWidth GDIPlus_PenSetAlignment GDIPlus_PenSetColor GDIPlus_PenSetCustomEndCap GDIPlus_PenSetDashCap GDIPlus_PenSetDashStyle GDIPlus_PenSetEndCap GDIPlus_PenSetLineCap GDIPlus_PenSetLineJoin GDIPlus_PenSetMiterLimit GDIPlus_PenSetStartCap GDIPlus_PenSetWidth GDIPlus_RectFCreate GDIPlus_RegionClone GDIPlus_RegionCombinePath GDIPlus_RegionCombineRect GDIPlus_RegionCombineRegion GDIPlus_RegionCreate GDIPlus_RegionCreateFromPath GDIPlus_RegionCreateFromRect GDIPlus_RegionDispose GDIPlus_RegionGetBounds GDIPlus_RegionGetHRgn GDIPlus_RegionTransform GDIPlus_RegionTranslate GDIPlus_Shutdown GDIPlus_Startup GDIPlus_StringFormatCreate GDIPlus_StringFormatDispose GDIPlus_StringFormatGetMeasurableCharacterRangeCount GDIPlus_StringFormatSetAlign GDIPlus_StringFormatSetLineAlign GDIPlus_StringFormatSetMeasurableCharacterRanges GDIPlus_TextureCreate GDIPlus_TextureCreate2 GDIPlus_TextureCreateIA GetIP GUICtrlAVI_Close GUICtrlAVI_Create GUICtrlAVI_Destroy GUICtrlAVI_IsPlaying GUICtrlAVI_Open GUICtrlAVI_OpenEx GUICtrlAVI_Play GUICtrlAVI_Seek GUICtrlAVI_Show GUICtrlAVI_Stop GUICtrlButton_Click GUICtrlButton_Create GUICtrlButton_Destroy GUICtrlButton_Enable GUICtrlButton_GetCheck GUICtrlButton_GetFocus GUICtrlButton_GetIdealSize GUICtrlButton_GetImage GUICtrlButton_GetImageList GUICtrlButton_GetNote GUICtrlButton_GetNoteLength GUICtrlButton_GetSplitInfo GUICtrlButton_GetState GUICtrlButton_GetText GUICtrlButton_GetTextMargin GUICtrlButton_SetCheck GUICtrlButton_SetDontClick GUICtrlButton_SetFocus GUICtrlButton_SetImage GUICtrlButton_SetImageList GUICtrlButton_SetNote GUICtrlButton_SetShield GUICtrlButton_SetSize GUICtrlButton_SetSplitInfo GUICtrlButton_SetState GUICtrlButton_SetStyle GUICtrlButton_SetText GUICtrlButton_SetTextMargin GUICtrlButton_Show GUICtrlComboBoxEx_AddDir GUICtrlComboBoxEx_AddString GUICtrlComboBoxEx_BeginUpdate GUICtrlComboBoxEx_Create GUICtrlComboBoxEx_CreateSolidBitMap GUICtrlComboBoxEx_DeleteString GUICtrlComboBoxEx_Destroy GUICtrlComboBoxEx_EndUpdate GUICtrlComboBoxEx_FindStringExact GUICtrlComboBoxEx_GetComboBoxInfo GUICtrlComboBoxEx_GetComboControl GUICtrlComboBoxEx_GetCount GUICtrlComboBoxEx_GetCurSel GUICtrlComboBoxEx_GetDroppedControlRect GUICtrlComboBoxEx_GetDroppedControlRectEx GUICtrlComboBoxEx_GetDroppedState GUICtrlComboBoxEx_GetDroppedWidth GUICtrlComboBoxEx_GetEditControl GUICtrlComboBoxEx_GetEditSel GUICtrlComboBoxEx_GetEditText GUICtrlComboBoxEx_GetExtendedStyle GUICtrlComboBoxEx_GetExtendedUI GUICtrlComboBoxEx_GetImageList GUICtrlComboBoxEx_GetItem GUICtrlComboBoxEx_GetItemEx GUICtrlComboBoxEx_GetItemHeight GUICtrlComboBoxEx_GetItemImage GUICtrlComboBoxEx_GetItemIndent GUICtrlComboBoxEx_GetItemOverlayImage GUICtrlComboBoxEx_GetItemParam GUICtrlComboBoxEx_GetItemSelectedImage GUICtrlComboBoxEx_GetItemText GUICtrlComboBoxEx_GetItemTextLen GUICtrlComboBoxEx_GetList GUICtrlComboBoxEx_GetListArray GUICtrlComboBoxEx_GetLocale GUICtrlComboBoxEx_GetLocaleCountry GUICtrlComboBoxEx_GetLocaleLang GUICtrlComboBoxEx_GetLocalePrimLang GUICtrlComboBoxEx_GetLocaleSubLang GUICtrlComboBoxEx_GetMinVisible GUICtrlComboBoxEx_GetTopIndex GUICtrlComboBoxEx_GetUnicode GUICtrlComboBoxEx_InitStorage GUICtrlComboBoxEx_InsertString GUICtrlComboBoxEx_LimitText GUICtrlComboBoxEx_ReplaceEditSel GUICtrlComboBoxEx_ResetContent GUICtrlComboBoxEx_SetCurSel GUICtrlComboBoxEx_SetDroppedWidth GUICtrlComboBoxEx_SetEditSel GUICtrlComboBoxEx_SetEditText GUICtrlComboBoxEx_SetExtendedStyle GUICtrlComboBoxEx_SetExtendedUI GUICtrlComboBoxEx_SetImageList GUICtrlComboBoxEx_SetItem GUICtrlComboBoxEx_SetItemEx GUICtrlComboBoxEx_SetItemHeight GUICtrlComboBoxEx_SetItemImage GUICtrlComboBoxEx_SetItemIndent GUICtrlComboBoxEx_SetItemOverlayImage GUICtrlComboBoxEx_SetItemParam GUICtrlComboBoxEx_SetItemSelectedImage GUICtrlComboBoxEx_SetMinVisible GUICtrlComboBoxEx_SetTopIndex GUICtrlComboBoxEx_SetUnicode GUICtrlComboBoxEx_ShowDropDown GUICtrlComboBox_AddDir GUICtrlComboBox_AddString GUICtrlComboBox_AutoComplete GUICtrlComboBox_BeginUpdate GUICtrlComboBox_Create GUICtrlComboBox_DeleteString GUICtrlComboBox_Destroy GUICtrlComboBox_EndUpdate GUICtrlComboBox_FindString GUICtrlComboBox_FindStringExact GUICtrlComboBox_GetComboBoxInfo GUICtrlComboBox_GetCount GUICtrlComboBox_GetCueBanner GUICtrlComboBox_GetCurSel GUICtrlComboBox_GetDroppedControlRect GUICtrlComboBox_GetDroppedControlRectEx GUICtrlComboBox_GetDroppedState GUICtrlComboBox_GetDroppedWidth GUICtrlComboBox_GetEditSel GUICtrlComboBox_GetEditText GUICtrlComboBox_GetExtendedUI GUICtrlComboBox_GetHorizontalExtent GUICtrlComboBox_GetItemHeight GUICtrlComboBox_GetLBText GUICtrlComboBox_GetLBTextLen GUICtrlComboBox_GetList GUICtrlComboBox_GetListArray GUICtrlComboBox_GetLocale GUICtrlComboBox_GetLocaleCountry GUICtrlComboBox_GetLocaleLang GUICtrlComboBox_GetLocalePrimLang GUICtrlComboBox_GetLocaleSubLang GUICtrlComboBox_GetMinVisible GUICtrlComboBox_GetTopIndex GUICtrlComboBox_InitStorage GUICtrlComboBox_InsertString GUICtrlComboBox_LimitText GUICtrlComboBox_ReplaceEditSel GUICtrlComboBox_ResetContent GUICtrlComboBox_SelectString GUICtrlComboBox_SetCueBanner GUICtrlComboBox_SetCurSel GUICtrlComboBox_SetDroppedWidth GUICtrlComboBox_SetEditSel GUICtrlComboBox_SetEditText GUICtrlComboBox_SetExtendedUI GUICtrlComboBox_SetHorizontalExtent GUICtrlComboBox_SetItemHeight GUICtrlComboBox_SetMinVisible GUICtrlComboBox_SetTopIndex GUICtrlComboBox_ShowDropDown GUICtrlDTP_Create GUICtrlDTP_Destroy GUICtrlDTP_GetMCColor GUICtrlDTP_GetMCFont GUICtrlDTP_GetMonthCal GUICtrlDTP_GetRange GUICtrlDTP_GetRangeEx GUICtrlDTP_GetSystemTime GUICtrlDTP_GetSystemTimeEx GUICtrlDTP_SetFormat GUICtrlDTP_SetMCColor GUICtrlDTP_SetMCFont GUICtrlDTP_SetRange GUICtrlDTP_SetRangeEx GUICtrlDTP_SetSystemTime GUICtrlDTP_SetSystemTimeEx GUICtrlEdit_AppendText GUICtrlEdit_BeginUpdate GUICtrlEdit_CanUndo GUICtrlEdit_CharFromPos GUICtrlEdit_Create GUICtrlEdit_Destroy GUICtrlEdit_EmptyUndoBuffer GUICtrlEdit_EndUpdate GUICtrlEdit_Find GUICtrlEdit_FmtLines GUICtrlEdit_GetCueBanner GUICtrlEdit_GetFirstVisibleLine GUICtrlEdit_GetLimitText GUICtrlEdit_GetLine GUICtrlEdit_GetLineCount GUICtrlEdit_GetMargins GUICtrlEdit_GetModify GUICtrlEdit_GetPasswordChar GUICtrlEdit_GetRECT GUICtrlEdit_GetRECTEx GUICtrlEdit_GetSel GUICtrlEdit_GetText GUICtrlEdit_GetTextLen GUICtrlEdit_HideBalloonTip GUICtrlEdit_InsertText GUICtrlEdit_LineFromChar GUICtrlEdit_LineIndex GUICtrlEdit_LineLength GUICtrlEdit_LineScroll GUICtrlEdit_PosFromChar GUICtrlEdit_ReplaceSel GUICtrlEdit_Scroll GUICtrlEdit_SetCueBanner GUICtrlEdit_SetLimitText GUICtrlEdit_SetMargins GUICtrlEdit_SetModify GUICtrlEdit_SetPasswordChar GUICtrlEdit_SetReadOnly GUICtrlEdit_SetRECT GUICtrlEdit_SetRECTEx GUICtrlEdit_SetRECTNP GUICtrlEdit_SetRectNPEx GUICtrlEdit_SetSel GUICtrlEdit_SetTabStops GUICtrlEdit_SetText GUICtrlEdit_ShowBalloonTip GUICtrlEdit_Undo GUICtrlHeader_AddItem GUICtrlHeader_ClearFilter GUICtrlHeader_ClearFilterAll GUICtrlHeader_Create GUICtrlHeader_CreateDragImage GUICtrlHeader_DeleteItem GUICtrlHeader_Destroy GUICtrlHeader_EditFilter GUICtrlHeader_GetBitmapMargin GUICtrlHeader_GetImageList GUICtrlHeader_GetItem GUICtrlHeader_GetItemAlign GUICtrlHeader_GetItemBitmap GUICtrlHeader_GetItemCount GUICtrlHeader_GetItemDisplay GUICtrlHeader_GetItemFlags GUICtrlHeader_GetItemFormat GUICtrlHeader_GetItemImage GUICtrlHeader_GetItemOrder GUICtrlHeader_GetItemParam GUICtrlHeader_GetItemRect GUICtrlHeader_GetItemRectEx GUICtrlHeader_GetItemText GUICtrlHeader_GetItemWidth GUICtrlHeader_GetOrderArray GUICtrlHeader_GetUnicodeFormat GUICtrlHeader_HitTest GUICtrlHeader_InsertItem GUICtrlHeader_Layout GUICtrlHeader_OrderToIndex GUICtrlHeader_SetBitmapMargin GUICtrlHeader_SetFilterChangeTimeout GUICtrlHeader_SetHotDivider GUICtrlHeader_SetImageList GUICtrlHeader_SetItem GUICtrlHeader_SetItemAlign GUICtrlHeader_SetItemBitmap GUICtrlHeader_SetItemDisplay GUICtrlHeader_SetItemFlags GUICtrlHeader_SetItemFormat GUICtrlHeader_SetItemImage GUICtrlHeader_SetItemOrder GUICtrlHeader_SetItemParam GUICtrlHeader_SetItemText GUICtrlHeader_SetItemWidth GUICtrlHeader_SetOrderArray GUICtrlHeader_SetUnicodeFormat GUICtrlIpAddress_ClearAddress GUICtrlIpAddress_Create GUICtrlIpAddress_Destroy GUICtrlIpAddress_Get GUICtrlIpAddress_GetArray GUICtrlIpAddress_GetEx GUICtrlIpAddress_IsBlank GUICtrlIpAddress_Set GUICtrlIpAddress_SetArray GUICtrlIpAddress_SetEx GUICtrlIpAddress_SetFocus GUICtrlIpAddress_SetFont GUICtrlIpAddress_SetRange GUICtrlIpAddress_ShowHide GUICtrlListBox_AddFile GUICtrlListBox_AddString GUICtrlListBox_BeginUpdate GUICtrlListBox_ClickItem GUICtrlListBox_Create GUICtrlListBox_DeleteString GUICtrlListBox_Destroy GUICtrlListBox_Dir GUICtrlListBox_EndUpdate GUICtrlListBox_FindInText GUICtrlListBox_FindString GUICtrlListBox_GetAnchorIndex GUICtrlListBox_GetCaretIndex GUICtrlListBox_GetCount GUICtrlListBox_GetCurSel GUICtrlListBox_GetHorizontalExtent GUICtrlListBox_GetItemData GUICtrlListBox_GetItemHeight GUICtrlListBox_GetItemRect GUICtrlListBox_GetItemRectEx GUICtrlListBox_GetListBoxInfo GUICtrlListBox_GetLocale GUICtrlListBox_GetLocaleCountry GUICtrlListBox_GetLocaleLang GUICtrlListBox_GetLocalePrimLang GUICtrlListBox_GetLocaleSubLang GUICtrlListBox_GetSel GUICtrlListBox_GetSelCount GUICtrlListBox_GetSelItems GUICtrlListBox_GetSelItemsText GUICtrlListBox_GetText GUICtrlListBox_GetTextLen GUICtrlListBox_GetTopIndex GUICtrlListBox_InitStorage GUICtrlListBox_InsertString GUICtrlListBox_ItemFromPoint GUICtrlListBox_ReplaceString GUICtrlListBox_ResetContent GUICtrlListBox_SelectString GUICtrlListBox_SelItemRange GUICtrlListBox_SelItemRangeEx GUICtrlListBox_SetAnchorIndex GUICtrlListBox_SetCaretIndex GUICtrlListBox_SetColumnWidth GUICtrlListBox_SetCurSel GUICtrlListBox_SetHorizontalExtent GUICtrlListBox_SetItemData GUICtrlListBox_SetItemHeight GUICtrlListBox_SetLocale GUICtrlListBox_SetSel GUICtrlListBox_SetTabStops GUICtrlListBox_SetTopIndex GUICtrlListBox_Sort GUICtrlListBox_SwapString GUICtrlListBox_UpdateHScroll GUICtrlListView_AddArray GUICtrlListView_AddColumn GUICtrlListView_AddItem GUICtrlListView_AddSubItem GUICtrlListView_ApproximateViewHeight GUICtrlListView_ApproximateViewRect GUICtrlListView_ApproximateViewWidth GUICtrlListView_Arrange GUICtrlListView_BeginUpdate GUICtrlListView_CancelEditLabel GUICtrlListView_ClickItem GUICtrlListView_CopyItems GUICtrlListView_Create GUICtrlListView_CreateDragImage GUICtrlListView_CreateSolidBitMap GUICtrlListView_DeleteAllItems GUICtrlListView_DeleteColumn GUICtrlListView_DeleteItem GUICtrlListView_DeleteItemsSelected GUICtrlListView_Destroy GUICtrlListView_DrawDragImage GUICtrlListView_EditLabel GUICtrlListView_EnableGroupView GUICtrlListView_EndUpdate GUICtrlListView_EnsureVisible GUICtrlListView_FindInText GUICtrlListView_FindItem GUICtrlListView_FindNearest GUICtrlListView_FindParam GUICtrlListView_FindText GUICtrlListView_GetBkColor GUICtrlListView_GetBkImage GUICtrlListView_GetCallbackMask GUICtrlListView_GetColumn GUICtrlListView_GetColumnCount GUICtrlListView_GetColumnOrder GUICtrlListView_GetColumnOrderArray GUICtrlListView_GetColumnWidth GUICtrlListView_GetCounterPage GUICtrlListView_GetEditControl GUICtrlListView_GetExtendedListViewStyle GUICtrlListView_GetFocusedGroup GUICtrlListView_GetGroupCount GUICtrlListView_GetGroupInfo GUICtrlListView_GetGroupInfoByIndex GUICtrlListView_GetGroupRect GUICtrlListView_GetGroupViewEnabled GUICtrlListView_GetHeader GUICtrlListView_GetHotCursor GUICtrlListView_GetHotItem GUICtrlListView_GetHoverTime GUICtrlListView_GetImageList GUICtrlListView_GetISearchString GUICtrlListView_GetItem GUICtrlListView_GetItemChecked GUICtrlListView_GetItemCount GUICtrlListView_GetItemCut GUICtrlListView_GetItemDropHilited GUICtrlListView_GetItemEx GUICtrlListView_GetItemFocused GUICtrlListView_GetItemGroupID GUICtrlListView_GetItemImage GUICtrlListView_GetItemIndent GUICtrlListView_GetItemParam GUICtrlListView_GetItemPosition GUICtrlListView_GetItemPositionX GUICtrlListView_GetItemPositionY GUICtrlListView_GetItemRect GUICtrlListView_GetItemRectEx GUICtrlListView_GetItemSelected GUICtrlListView_GetItemSpacing GUICtrlListView_GetItemSpacingX GUICtrlListView_GetItemSpacingY GUICtrlListView_GetItemState GUICtrlListView_GetItemStateImage GUICtrlListView_GetItemText GUICtrlListView_GetItemTextArray GUICtrlListView_GetItemTextString GUICtrlListView_GetNextItem GUICtrlListView_GetNumberOfWorkAreas GUICtrlListView_GetOrigin GUICtrlListView_GetOriginX GUICtrlListView_GetOriginY GUICtrlListView_GetOutlineColor GUICtrlListView_GetSelectedColumn GUICtrlListView_GetSelectedCount GUICtrlListView_GetSelectedIndices GUICtrlListView_GetSelectionMark GUICtrlListView_GetStringWidth GUICtrlListView_GetSubItemRect GUICtrlListView_GetTextBkColor GUICtrlListView_GetTextColor GUICtrlListView_GetToolTips GUICtrlListView_GetTopIndex GUICtrlListView_GetUnicodeFormat GUICtrlListView_GetView GUICtrlListView_GetViewDetails GUICtrlListView_GetViewLarge GUICtrlListView_GetViewList GUICtrlListView_GetViewRect GUICtrlListView_GetViewSmall GUICtrlListView_GetViewTile GUICtrlListView_HideColumn GUICtrlListView_HitTest GUICtrlListView_InsertColumn GUICtrlListView_InsertGroup GUICtrlListView_InsertItem GUICtrlListView_JustifyColumn GUICtrlListView_MapIDToIndex GUICtrlListView_MapIndexToID GUICtrlListView_RedrawItems GUICtrlListView_RegisterSortCallBack GUICtrlListView_RemoveAllGroups GUICtrlListView_RemoveGroup GUICtrlListView_Scroll GUICtrlListView_SetBkColor GUICtrlListView_SetBkImage GUICtrlListView_SetCallBackMask GUICtrlListView_SetColumn GUICtrlListView_SetColumnOrder GUICtrlListView_SetColumnOrderArray GUICtrlListView_SetColumnWidth GUICtrlListView_SetExtendedListViewStyle GUICtrlListView_SetGroupInfo GUICtrlListView_SetHotItem GUICtrlListView_SetHoverTime GUICtrlListView_SetIconSpacing GUICtrlListView_SetImageList GUICtrlListView_SetItem GUICtrlListView_SetItemChecked GUICtrlListView_SetItemCount GUICtrlListView_SetItemCut GUICtrlListView_SetItemDropHilited GUICtrlListView_SetItemEx GUICtrlListView_SetItemFocused GUICtrlListView_SetItemGroupID GUICtrlListView_SetItemImage GUICtrlListView_SetItemIndent GUICtrlListView_SetItemParam GUICtrlListView_SetItemPosition GUICtrlListView_SetItemPosition32 GUICtrlListView_SetItemSelected GUICtrlListView_SetItemState GUICtrlListView_SetItemStateImage GUICtrlListView_SetItemText GUICtrlListView_SetOutlineColor GUICtrlListView_SetSelectedColumn GUICtrlListView_SetSelectionMark GUICtrlListView_SetTextBkColor GUICtrlListView_SetTextColor GUICtrlListView_SetToolTips GUICtrlListView_SetUnicodeFormat GUICtrlListView_SetView GUICtrlListView_SetWorkAreas GUICtrlListView_SimpleSort GUICtrlListView_SortItems GUICtrlListView_SubItemHitTest GUICtrlListView_UnRegisterSortCallBack GUICtrlMenu_AddMenuItem GUICtrlMenu_AppendMenu GUICtrlMenu_CalculatePopupWindowPosition GUICtrlMenu_CheckMenuItem GUICtrlMenu_CheckRadioItem GUICtrlMenu_CreateMenu GUICtrlMenu_CreatePopup GUICtrlMenu_DeleteMenu GUICtrlMenu_DestroyMenu GUICtrlMenu_DrawMenuBar GUICtrlMenu_EnableMenuItem GUICtrlMenu_FindItem GUICtrlMenu_FindParent GUICtrlMenu_GetItemBmp GUICtrlMenu_GetItemBmpChecked GUICtrlMenu_GetItemBmpUnchecked GUICtrlMenu_GetItemChecked GUICtrlMenu_GetItemCount GUICtrlMenu_GetItemData GUICtrlMenu_GetItemDefault GUICtrlMenu_GetItemDisabled GUICtrlMenu_GetItemEnabled GUICtrlMenu_GetItemGrayed GUICtrlMenu_GetItemHighlighted GUICtrlMenu_GetItemID GUICtrlMenu_GetItemInfo GUICtrlMenu_GetItemRect GUICtrlMenu_GetItemRectEx GUICtrlMenu_GetItemState GUICtrlMenu_GetItemStateEx GUICtrlMenu_GetItemSubMenu GUICtrlMenu_GetItemText GUICtrlMenu_GetItemType GUICtrlMenu_GetMenu GUICtrlMenu_GetMenuBackground GUICtrlMenu_GetMenuBarInfo GUICtrlMenu_GetMenuContextHelpID GUICtrlMenu_GetMenuData GUICtrlMenu_GetMenuDefaultItem GUICtrlMenu_GetMenuHeight GUICtrlMenu_GetMenuInfo GUICtrlMenu_GetMenuStyle GUICtrlMenu_GetSystemMenu GUICtrlMenu_InsertMenuItem GUICtrlMenu_InsertMenuItemEx GUICtrlMenu_IsMenu GUICtrlMenu_LoadMenu GUICtrlMenu_MapAccelerator GUICtrlMenu_MenuItemFromPoint GUICtrlMenu_RemoveMenu GUICtrlMenu_SetItemBitmaps GUICtrlMenu_SetItemBmp GUICtrlMenu_SetItemBmpChecked GUICtrlMenu_SetItemBmpUnchecked GUICtrlMenu_SetItemChecked GUICtrlMenu_SetItemData GUICtrlMenu_SetItemDefault GUICtrlMenu_SetItemDisabled GUICtrlMenu_SetItemEnabled GUICtrlMenu_SetItemGrayed GUICtrlMenu_SetItemHighlighted GUICtrlMenu_SetItemID GUICtrlMenu_SetItemInfo GUICtrlMenu_SetItemState GUICtrlMenu_SetItemSubMenu GUICtrlMenu_SetItemText GUICtrlMenu_SetItemType GUICtrlMenu_SetMenu GUICtrlMenu_SetMenuBackground GUICtrlMenu_SetMenuContextHelpID GUICtrlMenu_SetMenuData GUICtrlMenu_SetMenuDefaultItem GUICtrlMenu_SetMenuHeight GUICtrlMenu_SetMenuInfo GUICtrlMenu_SetMenuStyle GUICtrlMenu_TrackPopupMenu GUICtrlMonthCal_Create GUICtrlMonthCal_Destroy GUICtrlMonthCal_GetCalendarBorder GUICtrlMonthCal_GetCalendarCount GUICtrlMonthCal_GetColor GUICtrlMonthCal_GetColorArray GUICtrlMonthCal_GetCurSel GUICtrlMonthCal_GetCurSelStr GUICtrlMonthCal_GetFirstDOW GUICtrlMonthCal_GetFirstDOWStr GUICtrlMonthCal_GetMaxSelCount GUICtrlMonthCal_GetMaxTodayWidth GUICtrlMonthCal_GetMinReqHeight GUICtrlMonthCal_GetMinReqRect GUICtrlMonthCal_GetMinReqRectArray GUICtrlMonthCal_GetMinReqWidth GUICtrlMonthCal_GetMonthDelta GUICtrlMonthCal_GetMonthRange GUICtrlMonthCal_GetMonthRangeMax GUICtrlMonthCal_GetMonthRangeMaxStr GUICtrlMonthCal_GetMonthRangeMin GUICtrlMonthCal_GetMonthRangeMinStr GUICtrlMonthCal_GetMonthRangeSpan GUICtrlMonthCal_GetRange GUICtrlMonthCal_GetRangeMax GUICtrlMonthCal_GetRangeMaxStr GUICtrlMonthCal_GetRangeMin GUICtrlMonthCal_GetRangeMinStr GUICtrlMonthCal_GetSelRange GUICtrlMonthCal_GetSelRangeMax GUICtrlMonthCal_GetSelRangeMaxStr GUICtrlMonthCal_GetSelRangeMin GUICtrlMonthCal_GetSelRangeMinStr GUICtrlMonthCal_GetToday GUICtrlMonthCal_GetTodayStr GUICtrlMonthCal_GetUnicodeFormat GUICtrlMonthCal_HitTest GUICtrlMonthCal_SetCalendarBorder GUICtrlMonthCal_SetColor GUICtrlMonthCal_SetCurSel GUICtrlMonthCal_SetDayState GUICtrlMonthCal_SetFirstDOW GUICtrlMonthCal_SetMaxSelCount GUICtrlMonthCal_SetMonthDelta GUICtrlMonthCal_SetRange GUICtrlMonthCal_SetSelRange GUICtrlMonthCal_SetToday GUICtrlMonthCal_SetUnicodeFormat GUICtrlRebar_AddBand GUICtrlRebar_AddToolBarBand GUICtrlRebar_BeginDrag GUICtrlRebar_Create GUICtrlRebar_DeleteBand GUICtrlRebar_Destroy GUICtrlRebar_DragMove GUICtrlRebar_EndDrag GUICtrlRebar_GetBandBackColor GUICtrlRebar_GetBandBorders GUICtrlRebar_GetBandBordersEx GUICtrlRebar_GetBandChildHandle GUICtrlRebar_GetBandChildSize GUICtrlRebar_GetBandCount GUICtrlRebar_GetBandForeColor GUICtrlRebar_GetBandHeaderSize GUICtrlRebar_GetBandID GUICtrlRebar_GetBandIdealSize GUICtrlRebar_GetBandLength GUICtrlRebar_GetBandLParam GUICtrlRebar_GetBandMargins GUICtrlRebar_GetBandMarginsEx GUICtrlRebar_GetBandRect GUICtrlRebar_GetBandRectEx GUICtrlRebar_GetBandStyle GUICtrlRebar_GetBandStyleBreak GUICtrlRebar_GetBandStyleChildEdge GUICtrlRebar_GetBandStyleFixedBMP GUICtrlRebar_GetBandStyleFixedSize GUICtrlRebar_GetBandStyleGripperAlways GUICtrlRebar_GetBandStyleHidden GUICtrlRebar_GetBandStyleHideTitle GUICtrlRebar_GetBandStyleNoGripper GUICtrlRebar_GetBandStyleTopAlign GUICtrlRebar_GetBandStyleUseChevron GUICtrlRebar_GetBandStyleVariableHeight GUICtrlRebar_GetBandText GUICtrlRebar_GetBarHeight GUICtrlRebar_GetBarInfo GUICtrlRebar_GetBKColor GUICtrlRebar_GetColorScheme GUICtrlRebar_GetRowCount GUICtrlRebar_GetRowHeight GUICtrlRebar_GetTextColor GUICtrlRebar_GetToolTips GUICtrlRebar_GetUnicodeFormat GUICtrlRebar_HitTest GUICtrlRebar_IDToIndex GUICtrlRebar_MaximizeBand GUICtrlRebar_MinimizeBand GUICtrlRebar_MoveBand GUICtrlRebar_SetBandBackColor GUICtrlRebar_SetBandForeColor GUICtrlRebar_SetBandHeaderSize GUICtrlRebar_SetBandID GUICtrlRebar_SetBandIdealSize GUICtrlRebar_SetBandLength GUICtrlRebar_SetBandLParam GUICtrlRebar_SetBandStyle GUICtrlRebar_SetBandStyleBreak GUICtrlRebar_SetBandStyleChildEdge GUICtrlRebar_SetBandStyleFixedBMP GUICtrlRebar_SetBandStyleFixedSize GUICtrlRebar_SetBandStyleGripperAlways GUICtrlRebar_SetBandStyleHidden GUICtrlRebar_SetBandStyleHideTitle GUICtrlRebar_SetBandStyleNoGripper GUICtrlRebar_SetBandStyleTopAlign GUICtrlRebar_SetBandStyleUseChevron GUICtrlRebar_SetBandStyleVariableHeight GUICtrlRebar_SetBandText GUICtrlRebar_SetBarInfo GUICtrlRebar_SetBKColor GUICtrlRebar_SetColorScheme GUICtrlRebar_SetTextColor GUICtrlRebar_SetToolTips GUICtrlRebar_SetUnicodeFormat GUICtrlRebar_ShowBand GUICtrlRichEdit_AppendText GUICtrlRichEdit_AutoDetectURL GUICtrlRichEdit_CanPaste GUICtrlRichEdit_CanPasteSpecial GUICtrlRichEdit_CanRedo GUICtrlRichEdit_CanUndo GUICtrlRichEdit_ChangeFontSize GUICtrlRichEdit_Copy GUICtrlRichEdit_Create GUICtrlRichEdit_Cut GUICtrlRichEdit_Deselect GUICtrlRichEdit_Destroy GUICtrlRichEdit_EmptyUndoBuffer GUICtrlRichEdit_FindText GUICtrlRichEdit_FindTextInRange GUICtrlRichEdit_GetBkColor GUICtrlRichEdit_GetCharAttributes GUICtrlRichEdit_GetCharBkColor GUICtrlRichEdit_GetCharColor GUICtrlRichEdit_GetCharPosFromXY GUICtrlRichEdit_GetCharPosOfNextWord GUICtrlRichEdit_GetCharPosOfPreviousWord GUICtrlRichEdit_GetCharWordBreakInfo GUICtrlRichEdit_GetFirstCharPosOnLine GUICtrlRichEdit_GetFont GUICtrlRichEdit_GetLineCount GUICtrlRichEdit_GetLineLength GUICtrlRichEdit_GetLineNumberFromCharPos GUICtrlRichEdit_GetNextRedo GUICtrlRichEdit_GetNextUndo GUICtrlRichEdit_GetNumberOfFirstVisibleLine GUICtrlRichEdit_GetParaAlignment GUICtrlRichEdit_GetParaAttributes GUICtrlRichEdit_GetParaBorder GUICtrlRichEdit_GetParaIndents GUICtrlRichEdit_GetParaNumbering GUICtrlRichEdit_GetParaShading GUICtrlRichEdit_GetParaSpacing GUICtrlRichEdit_GetParaTabStops GUICtrlRichEdit_GetPasswordChar GUICtrlRichEdit_GetRECT GUICtrlRichEdit_GetScrollPos GUICtrlRichEdit_GetSel GUICtrlRichEdit_GetSelAA GUICtrlRichEdit_GetSelText GUICtrlRichEdit_GetSpaceUnit GUICtrlRichEdit_GetText GUICtrlRichEdit_GetTextInLine GUICtrlRichEdit_GetTextInRange GUICtrlRichEdit_GetTextLength GUICtrlRichEdit_GetVersion GUICtrlRichEdit_GetXYFromCharPos GUICtrlRichEdit_GetZoom GUICtrlRichEdit_GotoCharPos GUICtrlRichEdit_HideSelection GUICtrlRichEdit_InsertText GUICtrlRichEdit_IsModified GUICtrlRichEdit_IsTextSelected GUICtrlRichEdit_Paste GUICtrlRichEdit_PasteSpecial GUICtrlRichEdit_PauseRedraw GUICtrlRichEdit_Redo GUICtrlRichEdit_ReplaceText GUICtrlRichEdit_ResumeRedraw GUICtrlRichEdit_ScrollLineOrPage GUICtrlRichEdit_ScrollLines GUICtrlRichEdit_ScrollToCaret GUICtrlRichEdit_SetBkColor GUICtrlRichEdit_SetCharAttributes GUICtrlRichEdit_SetCharBkColor GUICtrlRichEdit_SetCharColor GUICtrlRichEdit_SetEventMask GUICtrlRichEdit_SetFont GUICtrlRichEdit_SetLimitOnText GUICtrlRichEdit_SetModified GUICtrlRichEdit_SetParaAlignment GUICtrlRichEdit_SetParaAttributes GUICtrlRichEdit_SetParaBorder GUICtrlRichEdit_SetParaIndents GUICtrlRichEdit_SetParaNumbering GUICtrlRichEdit_SetParaShading GUICtrlRichEdit_SetParaSpacing GUICtrlRichEdit_SetParaTabStops GUICtrlRichEdit_SetPasswordChar GUICtrlRichEdit_SetReadOnly GUICtrlRichEdit_SetRECT GUICtrlRichEdit_SetScrollPos GUICtrlRichEdit_SetSel GUICtrlRichEdit_SetSpaceUnit GUICtrlRichEdit_SetTabStops GUICtrlRichEdit_SetText GUICtrlRichEdit_SetUndoLimit GUICtrlRichEdit_SetZoom GUICtrlRichEdit_StreamFromFile GUICtrlRichEdit_StreamFromVar GUICtrlRichEdit_StreamToFile GUICtrlRichEdit_StreamToVar GUICtrlRichEdit_Undo GUICtrlSlider_ClearSel GUICtrlSlider_ClearTics GUICtrlSlider_Create GUICtrlSlider_Destroy GUICtrlSlider_GetBuddy GUICtrlSlider_GetChannelRect GUICtrlSlider_GetChannelRectEx GUICtrlSlider_GetLineSize GUICtrlSlider_GetLogicalTics GUICtrlSlider_GetNumTics GUICtrlSlider_GetPageSize GUICtrlSlider_GetPos GUICtrlSlider_GetRange GUICtrlSlider_GetRangeMax GUICtrlSlider_GetRangeMin GUICtrlSlider_GetSel GUICtrlSlider_GetSelEnd GUICtrlSlider_GetSelStart GUICtrlSlider_GetThumbLength GUICtrlSlider_GetThumbRect GUICtrlSlider_GetThumbRectEx GUICtrlSlider_GetTic GUICtrlSlider_GetTicPos GUICtrlSlider_GetToolTips GUICtrlSlider_GetUnicodeFormat GUICtrlSlider_SetBuddy GUICtrlSlider_SetLineSize GUICtrlSlider_SetPageSize GUICtrlSlider_SetPos GUICtrlSlider_SetRange GUICtrlSlider_SetRangeMax GUICtrlSlider_SetRangeMin GUICtrlSlider_SetSel GUICtrlSlider_SetSelEnd GUICtrlSlider_SetSelStart GUICtrlSlider_SetThumbLength GUICtrlSlider_SetTic GUICtrlSlider_SetTicFreq GUICtrlSlider_SetTipSide GUICtrlSlider_SetToolTips GUICtrlSlider_SetUnicodeFormat GUICtrlStatusBar_Create GUICtrlStatusBar_Destroy GUICtrlStatusBar_EmbedControl GUICtrlStatusBar_GetBorders GUICtrlStatusBar_GetBordersHorz GUICtrlStatusBar_GetBordersRect GUICtrlStatusBar_GetBordersVert GUICtrlStatusBar_GetCount GUICtrlStatusBar_GetHeight GUICtrlStatusBar_GetIcon GUICtrlStatusBar_GetParts GUICtrlStatusBar_GetRect GUICtrlStatusBar_GetRectEx GUICtrlStatusBar_GetText GUICtrlStatusBar_GetTextFlags GUICtrlStatusBar_GetTextLength GUICtrlStatusBar_GetTextLengthEx GUICtrlStatusBar_GetTipText GUICtrlStatusBar_GetUnicodeFormat GUICtrlStatusBar_GetWidth GUICtrlStatusBar_IsSimple GUICtrlStatusBar_Resize GUICtrlStatusBar_SetBkColor GUICtrlStatusBar_SetIcon GUICtrlStatusBar_SetMinHeight GUICtrlStatusBar_SetParts GUICtrlStatusBar_SetSimple GUICtrlStatusBar_SetText GUICtrlStatusBar_SetTipText GUICtrlStatusBar_SetUnicodeFormat GUICtrlStatusBar_ShowHide GUICtrlTab_ActivateTab GUICtrlTab_ClickTab GUICtrlTab_Create GUICtrlTab_DeleteAllItems GUICtrlTab_DeleteItem GUICtrlTab_DeselectAll GUICtrlTab_Destroy GUICtrlTab_FindTab GUICtrlTab_GetCurFocus GUICtrlTab_GetCurSel GUICtrlTab_GetDisplayRect GUICtrlTab_GetDisplayRectEx GUICtrlTab_GetExtendedStyle GUICtrlTab_GetImageList GUICtrlTab_GetItem GUICtrlTab_GetItemCount GUICtrlTab_GetItemImage GUICtrlTab_GetItemParam GUICtrlTab_GetItemRect GUICtrlTab_GetItemRectEx GUICtrlTab_GetItemState GUICtrlTab_GetItemText GUICtrlTab_GetRowCount GUICtrlTab_GetToolTips GUICtrlTab_GetUnicodeFormat GUICtrlTab_HighlightItem GUICtrlTab_HitTest GUICtrlTab_InsertItem GUICtrlTab_RemoveImage GUICtrlTab_SetCurFocus GUICtrlTab_SetCurSel GUICtrlTab_SetExtendedStyle GUICtrlTab_SetImageList GUICtrlTab_SetItem GUICtrlTab_SetItemImage GUICtrlTab_SetItemParam GUICtrlTab_SetItemSize GUICtrlTab_SetItemState GUICtrlTab_SetItemText GUICtrlTab_SetMinTabWidth GUICtrlTab_SetPadding GUICtrlTab_SetToolTips GUICtrlTab_SetUnicodeFormat GUICtrlToolbar_AddBitmap GUICtrlToolbar_AddButton GUICtrlToolbar_AddButtonSep GUICtrlToolbar_AddString GUICtrlToolbar_ButtonCount GUICtrlToolbar_CheckButton GUICtrlToolbar_ClickAccel GUICtrlToolbar_ClickButton GUICtrlToolbar_ClickIndex GUICtrlToolbar_CommandToIndex GUICtrlToolbar_Create GUICtrlToolbar_Customize GUICtrlToolbar_DeleteButton GUICtrlToolbar_Destroy GUICtrlToolbar_EnableButton GUICtrlToolbar_FindToolbar GUICtrlToolbar_GetAnchorHighlight GUICtrlToolbar_GetBitmapFlags GUICtrlToolbar_GetButtonBitmap GUICtrlToolbar_GetButtonInfo GUICtrlToolbar_GetButtonInfoEx GUICtrlToolbar_GetButtonParam GUICtrlToolbar_GetButtonRect GUICtrlToolbar_GetButtonRectEx GUICtrlToolbar_GetButtonSize GUICtrlToolbar_GetButtonState GUICtrlToolbar_GetButtonStyle GUICtrlToolbar_GetButtonText GUICtrlToolbar_GetColorScheme GUICtrlToolbar_GetDisabledImageList GUICtrlToolbar_GetExtendedStyle GUICtrlToolbar_GetHotImageList GUICtrlToolbar_GetHotItem GUICtrlToolbar_GetImageList GUICtrlToolbar_GetInsertMark GUICtrlToolbar_GetInsertMarkColor GUICtrlToolbar_GetMaxSize GUICtrlToolbar_GetMetrics GUICtrlToolbar_GetPadding GUICtrlToolbar_GetRows GUICtrlToolbar_GetString GUICtrlToolbar_GetStyle GUICtrlToolbar_GetStyleAltDrag GUICtrlToolbar_GetStyleCustomErase GUICtrlToolbar_GetStyleFlat GUICtrlToolbar_GetStyleList GUICtrlToolbar_GetStyleRegisterDrop GUICtrlToolbar_GetStyleToolTips GUICtrlToolbar_GetStyleTransparent GUICtrlToolbar_GetStyleWrapable GUICtrlToolbar_GetTextRows GUICtrlToolbar_GetToolTips GUICtrlToolbar_GetUnicodeFormat GUICtrlToolbar_HideButton GUICtrlToolbar_HighlightButton GUICtrlToolbar_HitTest GUICtrlToolbar_IndexToCommand GUICtrlToolbar_InsertButton GUICtrlToolbar_InsertMarkHitTest GUICtrlToolbar_IsButtonChecked GUICtrlToolbar_IsButtonEnabled GUICtrlToolbar_IsButtonHidden GUICtrlToolbar_IsButtonHighlighted GUICtrlToolbar_IsButtonIndeterminate GUICtrlToolbar_IsButtonPressed GUICtrlToolbar_LoadBitmap GUICtrlToolbar_LoadImages GUICtrlToolbar_MapAccelerator GUICtrlToolbar_MoveButton GUICtrlToolbar_PressButton GUICtrlToolbar_SetAnchorHighlight GUICtrlToolbar_SetBitmapSize GUICtrlToolbar_SetButtonBitMap GUICtrlToolbar_SetButtonInfo GUICtrlToolbar_SetButtonInfoEx GUICtrlToolbar_SetButtonParam GUICtrlToolbar_SetButtonSize GUICtrlToolbar_SetButtonState GUICtrlToolbar_SetButtonStyle GUICtrlToolbar_SetButtonText GUICtrlToolbar_SetButtonWidth GUICtrlToolbar_SetCmdID GUICtrlToolbar_SetColorScheme GUICtrlToolbar_SetDisabledImageList GUICtrlToolbar_SetDrawTextFlags GUICtrlToolbar_SetExtendedStyle GUICtrlToolbar_SetHotImageList GUICtrlToolbar_SetHotItem GUICtrlToolbar_SetImageList GUICtrlToolbar_SetIndent GUICtrlToolbar_SetIndeterminate GUICtrlToolbar_SetInsertMark GUICtrlToolbar_SetInsertMarkColor GUICtrlToolbar_SetMaxTextRows GUICtrlToolbar_SetMetrics GUICtrlToolbar_SetPadding GUICtrlToolbar_SetParent GUICtrlToolbar_SetRows GUICtrlToolbar_SetStyle GUICtrlToolbar_SetStyleAltDrag GUICtrlToolbar_SetStyleCustomErase GUICtrlToolbar_SetStyleFlat GUICtrlToolbar_SetStyleList GUICtrlToolbar_SetStyleRegisterDrop GUICtrlToolbar_SetStyleToolTips GUICtrlToolbar_SetStyleTransparent GUICtrlToolbar_SetStyleWrapable GUICtrlToolbar_SetToolTips GUICtrlToolbar_SetUnicodeFormat GUICtrlToolbar_SetWindowTheme GUICtrlTreeView_Add GUICtrlTreeView_AddChild GUICtrlTreeView_AddChildFirst GUICtrlTreeView_AddFirst GUICtrlTreeView_BeginUpdate GUICtrlTreeView_ClickItem GUICtrlTreeView_Create GUICtrlTreeView_CreateDragImage GUICtrlTreeView_CreateSolidBitMap GUICtrlTreeView_Delete GUICtrlTreeView_DeleteAll GUICtrlTreeView_DeleteChildren GUICtrlTreeView_Destroy GUICtrlTreeView_DisplayRect GUICtrlTreeView_DisplayRectEx GUICtrlTreeView_EditText GUICtrlTreeView_EndEdit GUICtrlTreeView_EndUpdate GUICtrlTreeView_EnsureVisible GUICtrlTreeView_Expand GUICtrlTreeView_ExpandedOnce GUICtrlTreeView_FindItem GUICtrlTreeView_FindItemEx GUICtrlTreeView_GetBkColor GUICtrlTreeView_GetBold GUICtrlTreeView_GetChecked GUICtrlTreeView_GetChildCount GUICtrlTreeView_GetChildren GUICtrlTreeView_GetCount GUICtrlTreeView_GetCut GUICtrlTreeView_GetDropTarget GUICtrlTreeView_GetEditControl GUICtrlTreeView_GetExpanded GUICtrlTreeView_GetFirstChild GUICtrlTreeView_GetFirstItem GUICtrlTreeView_GetFirstVisible GUICtrlTreeView_GetFocused GUICtrlTreeView_GetHeight GUICtrlTreeView_GetImageIndex GUICtrlTreeView_GetImageListIconHandle GUICtrlTreeView_GetIndent GUICtrlTreeView_GetInsertMarkColor GUICtrlTreeView_GetISearchString GUICtrlTreeView_GetItemByIndex GUICtrlTreeView_GetItemHandle GUICtrlTreeView_GetItemParam GUICtrlTreeView_GetLastChild GUICtrlTreeView_GetLineColor GUICtrlTreeView_GetNext GUICtrlTreeView_GetNextChild GUICtrlTreeView_GetNextSibling GUICtrlTreeView_GetNextVisible GUICtrlTreeView_GetNormalImageList GUICtrlTreeView_GetParentHandle GUICtrlTreeView_GetParentParam GUICtrlTreeView_GetPrev GUICtrlTreeView_GetPrevChild GUICtrlTreeView_GetPrevSibling GUICtrlTreeView_GetPrevVisible GUICtrlTreeView_GetScrollTime GUICtrlTreeView_GetSelected GUICtrlTreeView_GetSelectedImageIndex GUICtrlTreeView_GetSelection GUICtrlTreeView_GetSiblingCount GUICtrlTreeView_GetState GUICtrlTreeView_GetStateImageIndex GUICtrlTreeView_GetStateImageList GUICtrlTreeView_GetText GUICtrlTreeView_GetTextColor GUICtrlTreeView_GetToolTips GUICtrlTreeView_GetTree GUICtrlTreeView_GetUnicodeFormat GUICtrlTreeView_GetVisible GUICtrlTreeView_GetVisibleCount GUICtrlTreeView_HitTest GUICtrlTreeView_HitTestEx GUICtrlTreeView_HitTestItem GUICtrlTreeView_Index GUICtrlTreeView_InsertItem GUICtrlTreeView_IsFirstItem GUICtrlTreeView_IsParent GUICtrlTreeView_Level GUICtrlTreeView_SelectItem GUICtrlTreeView_SelectItemByIndex GUICtrlTreeView_SetBkColor GUICtrlTreeView_SetBold GUICtrlTreeView_SetChecked GUICtrlTreeView_SetCheckedByIndex GUICtrlTreeView_SetChildren GUICtrlTreeView_SetCut GUICtrlTreeView_SetDropTarget GUICtrlTreeView_SetFocused GUICtrlTreeView_SetHeight GUICtrlTreeView_SetIcon GUICtrlTreeView_SetImageIndex GUICtrlTreeView_SetIndent GUICtrlTreeView_SetInsertMark GUICtrlTreeView_SetInsertMarkColor GUICtrlTreeView_SetItemHeight GUICtrlTreeView_SetItemParam GUICtrlTreeView_SetLineColor GUICtrlTreeView_SetNormalImageList GUICtrlTreeView_SetScrollTime GUICtrlTreeView_SetSelected GUICtrlTreeView_SetSelectedImageIndex GUICtrlTreeView_SetState GUICtrlTreeView_SetStateImageIndex GUICtrlTreeView_SetStateImageList GUICtrlTreeView_SetText GUICtrlTreeView_SetTextColor GUICtrlTreeView_SetToolTips GUICtrlTreeView_SetUnicodeFormat GUICtrlTreeView_Sort GUIImageList_Add GUIImageList_AddBitmap GUIImageList_AddIcon GUIImageList_AddMasked GUIImageList_BeginDrag GUIImageList_Copy GUIImageList_Create GUIImageList_Destroy GUIImageList_DestroyIcon GUIImageList_DragEnter GUIImageList_DragLeave GUIImageList_DragMove GUIImageList_Draw GUIImageList_DrawEx GUIImageList_Duplicate GUIImageList_EndDrag GUIImageList_GetBkColor GUIImageList_GetIcon GUIImageList_GetIconHeight GUIImageList_GetIconSize GUIImageList_GetIconSizeEx GUIImageList_GetIconWidth GUIImageList_GetImageCount GUIImageList_GetImageInfoEx GUIImageList_Remove GUIImageList_ReplaceIcon GUIImageList_SetBkColor GUIImageList_SetIconSize GUIImageList_SetImageCount GUIImageList_Swap GUIScrollBars_EnableScrollBar GUIScrollBars_GetScrollBarInfoEx GUIScrollBars_GetScrollBarRect GUIScrollBars_GetScrollBarRGState GUIScrollBars_GetScrollBarXYLineButton GUIScrollBars_GetScrollBarXYThumbBottom GUIScrollBars_GetScrollBarXYThumbTop GUIScrollBars_GetScrollInfo GUIScrollBars_GetScrollInfoEx GUIScrollBars_GetScrollInfoMax GUIScrollBars_GetScrollInfoMin GUIScrollBars_GetScrollInfoPage GUIScrollBars_GetScrollInfoPos GUIScrollBars_GetScrollInfoTrackPos GUIScrollBars_GetScrollPos GUIScrollBars_GetScrollRange GUIScrollBars_Init GUIScrollBars_ScrollWindow GUIScrollBars_SetScrollInfo GUIScrollBars_SetScrollInfoMax GUIScrollBars_SetScrollInfoMin GUIScrollBars_SetScrollInfoPage GUIScrollBars_SetScrollInfoPos GUIScrollBars_SetScrollRange GUIScrollBars_ShowScrollBar GUIToolTip_Activate GUIToolTip_AddTool GUIToolTip_AdjustRect GUIToolTip_BitsToTTF GUIToolTip_Create GUIToolTip_Deactivate GUIToolTip_DelTool GUIToolTip_Destroy GUIToolTip_EnumTools GUIToolTip_GetBubbleHeight GUIToolTip_GetBubbleSize GUIToolTip_GetBubbleWidth GUIToolTip_GetCurrentTool GUIToolTip_GetDelayTime GUIToolTip_GetMargin GUIToolTip_GetMarginEx GUIToolTip_GetMaxTipWidth GUIToolTip_GetText GUIToolTip_GetTipBkColor GUIToolTip_GetTipTextColor GUIToolTip_GetTitleBitMap GUIToolTip_GetTitleText GUIToolTip_GetToolCount GUIToolTip_GetToolInfo GUIToolTip_HitTest GUIToolTip_NewToolRect GUIToolTip_Pop GUIToolTip_PopUp GUIToolTip_SetDelayTime GUIToolTip_SetMargin GUIToolTip_SetMaxTipWidth GUIToolTip_SetTipBkColor GUIToolTip_SetTipTextColor GUIToolTip_SetTitle GUIToolTip_SetToolInfo GUIToolTip_SetWindowTheme GUIToolTip_ToolExists GUIToolTip_ToolToArray GUIToolTip_TrackActivate GUIToolTip_TrackPosition GUIToolTip_Update GUIToolTip_UpdateTipText HexToString IEAction IEAttach IEBodyReadHTML IEBodyReadText IEBodyWriteHTML IECreate IECreateEmbedded IEDocGetObj IEDocInsertHTML IEDocInsertText IEDocReadHTML IEDocWriteHTML IEErrorNotify IEFormElementCheckBoxSelect IEFormElementGetCollection IEFormElementGetObjByName IEFormElementGetValue IEFormElementOptionSelect IEFormElementRadioSelect IEFormElementSetValue IEFormGetCollection IEFormGetObjByName IEFormImageClick IEFormReset IEFormSubmit IEFrameGetCollection IEFrameGetObjByName IEGetObjById IEGetObjByName IEHeadInsertEventScript IEImgClick IEImgGetCollection IEIsFrameSet IELinkClickByIndex IELinkClickByText IELinkGetCollection IELoadWait IELoadWaitTimeout IENavigate IEPropertyGet IEPropertySet IEQuit IETableGetCollection IETableWriteToArray IETagNameAllGetCollection IETagNameGetCollection IE_Example IE_Introduction IE_VersionInfo INetExplorerCapable INetGetSource INetMail INetSmtpMail IsPressed MathCheckDiv Max MemGlobalAlloc MemGlobalFree MemGlobalLock MemGlobalSize MemGlobalUnlock MemMoveMemory MemVirtualAlloc MemVirtualAllocEx MemVirtualFree MemVirtualFreeEx Min MouseTrap NamedPipes_CallNamedPipe NamedPipes_ConnectNamedPipe NamedPipes_CreateNamedPipe NamedPipes_CreatePipe NamedPipes_DisconnectNamedPipe NamedPipes_GetNamedPipeHandleState NamedPipes_GetNamedPipeInfo NamedPipes_PeekNamedPipe NamedPipes_SetNamedPipeHandleState NamedPipes_TransactNamedPipe NamedPipes_WaitNamedPipe Net_Share_ConnectionEnum Net_Share_FileClose Net_Share_FileEnum Net_Share_FileGetInfo Net_Share_PermStr Net_Share_ResourceStr Net_Share_SessionDel Net_Share_SessionEnum Net_Share_SessionGetInfo Net_Share_ShareAdd Net_Share_ShareCheck Net_Share_ShareDel Net_Share_ShareEnum Net_Share_ShareGetInfo Net_Share_ShareSetInfo Net_Share_StatisticsGetSvr Net_Share_StatisticsGetWrk Now NowCalc NowCalcDate NowDate NowTime PathFull PathGetRelative PathMake PathSplit ProcessGetName ProcessGetPriority Radian ReplaceStringInFile RunDos ScreenCapture_Capture ScreenCapture_CaptureWnd ScreenCapture_SaveImage ScreenCapture_SetBMPFormat ScreenCapture_SetJPGQuality ScreenCapture_SetTIFColorDepth ScreenCapture_SetTIFCompression Security__AdjustTokenPrivileges Security__CreateProcessWithToken Security__DuplicateTokenEx Security__GetAccountSid Security__GetLengthSid Security__GetTokenInformation Security__ImpersonateSelf Security__IsValidSid Security__LookupAccountName Security__LookupAccountSid Security__LookupPrivilegeValue Security__OpenProcessToken Security__OpenThreadToken Security__OpenThreadTokenEx Security__SetPrivilege Security__SetTokenInformation Security__SidToStringSid Security__SidTypeStr Security__StringSidToSid SendMessage SendMessageA SetDate SetTime Singleton SoundClose SoundLength SoundOpen SoundPause SoundPlay SoundPos SoundResume SoundSeek SoundStatus SoundStop SQLite_Changes SQLite_Close SQLite_Display2DResult SQLite_Encode SQLite_ErrCode SQLite_ErrMsg SQLite_Escape SQLite_Exec SQLite_FastEncode SQLite_FastEscape SQLite_FetchData SQLite_FetchNames SQLite_GetTable SQLite_GetTable2d SQLite_LastInsertRowID SQLite_LibVersion SQLite_Open SQLite_Query SQLite_QueryFinalize SQLite_QueryReset SQLite_QuerySingleRow SQLite_SafeMode SQLite_SetTimeout SQLite_Shutdown SQLite_SQLiteExe SQLite_Startup SQLite_TotalChanges StringBetween StringExplode StringInsert StringProper StringRepeat StringTitleCase StringToHex TCPIpToName TempFile TicksToTime Timer_Diff Timer_GetIdleTime Timer_GetTimerID Timer_Init Timer_KillAllTimers Timer_KillTimer Timer_SetTimer TimeToTicks VersionCompare viClose viExecCommand viFindGpib viGpibBusReset viGTL viInteractiveControl viOpen viSetAttribute viSetTimeout WeekNumberISO WinAPI_AbortPath WinAPI_ActivateKeyboardLayout WinAPI_AddClipboardFormatListener WinAPI_AddFontMemResourceEx WinAPI_AddFontResourceEx WinAPI_AddIconOverlay WinAPI_AddIconTransparency WinAPI_AddMRUString WinAPI_AdjustBitmap WinAPI_AdjustTokenPrivileges WinAPI_AdjustWindowRectEx WinAPI_AlphaBlend WinAPI_AngleArc WinAPI_AnimateWindow WinAPI_Arc WinAPI_ArcTo WinAPI_ArrayToStruct WinAPI_AssignProcessToJobObject WinAPI_AssocGetPerceivedType WinAPI_AssocQueryString WinAPI_AttachConsole WinAPI_AttachThreadInput WinAPI_BackupRead WinAPI_BackupReadAbort WinAPI_BackupSeek WinAPI_BackupWrite WinAPI_BackupWriteAbort WinAPI_Beep WinAPI_BeginBufferedPaint WinAPI_BeginDeferWindowPos WinAPI_BeginPaint WinAPI_BeginPath WinAPI_BeginUpdateResource WinAPI_BitBlt WinAPI_BringWindowToTop WinAPI_BroadcastSystemMessage WinAPI_BrowseForFolderDlg WinAPI_BufferedPaintClear WinAPI_BufferedPaintInit WinAPI_BufferedPaintSetAlpha WinAPI_BufferedPaintUnInit WinAPI_CallNextHookEx WinAPI_CallWindowProc WinAPI_CallWindowProcW WinAPI_CascadeWindows WinAPI_ChangeWindowMessageFilterEx WinAPI_CharToOem WinAPI_ChildWindowFromPointEx WinAPI_ClientToScreen WinAPI_ClipCursor WinAPI_CloseDesktop WinAPI_CloseEnhMetaFile WinAPI_CloseFigure WinAPI_CloseHandle WinAPI_CloseThemeData WinAPI_CloseWindow WinAPI_CloseWindowStation WinAPI_CLSIDFromProgID WinAPI_CoInitialize WinAPI_ColorAdjustLuma WinAPI_ColorHLSToRGB WinAPI_ColorRGBToHLS WinAPI_CombineRgn WinAPI_CombineTransform WinAPI_CommandLineToArgv WinAPI_CommDlgExtendedError WinAPI_CommDlgExtendedErrorEx WinAPI_CompareString WinAPI_CompressBitmapBits WinAPI_CompressBuffer WinAPI_ComputeCrc32 WinAPI_ConfirmCredentials WinAPI_CopyBitmap WinAPI_CopyCursor WinAPI_CopyEnhMetaFile WinAPI_CopyFileEx WinAPI_CopyIcon WinAPI_CopyImage WinAPI_CopyRect WinAPI_CopyStruct WinAPI_CoTaskMemAlloc WinAPI_CoTaskMemFree WinAPI_CoTaskMemRealloc WinAPI_CoUninitialize WinAPI_Create32BitHBITMAP WinAPI_Create32BitHICON WinAPI_CreateANDBitmap WinAPI_CreateBitmap WinAPI_CreateBitmapIndirect WinAPI_CreateBrushIndirect WinAPI_CreateBuffer WinAPI_CreateBufferFromStruct WinAPI_CreateCaret WinAPI_CreateColorAdjustment WinAPI_CreateCompatibleBitmap WinAPI_CreateCompatibleBitmapEx WinAPI_CreateCompatibleDC WinAPI_CreateDesktop WinAPI_CreateDIB WinAPI_CreateDIBColorTable WinAPI_CreateDIBitmap WinAPI_CreateDIBSection WinAPI_CreateDirectory WinAPI_CreateDirectoryEx WinAPI_CreateEllipticRgn WinAPI_CreateEmptyIcon WinAPI_CreateEnhMetaFile WinAPI_CreateEvent WinAPI_CreateFile WinAPI_CreateFileEx WinAPI_CreateFileMapping WinAPI_CreateFont WinAPI_CreateFontEx WinAPI_CreateFontIndirect WinAPI_CreateGUID WinAPI_CreateHardLink WinAPI_CreateIcon WinAPI_CreateIconFromResourceEx WinAPI_CreateIconIndirect WinAPI_CreateJobObject WinAPI_CreateMargins WinAPI_CreateMRUList WinAPI_CreateMutex WinAPI_CreateNullRgn WinAPI_CreateNumberFormatInfo WinAPI_CreateObjectID WinAPI_CreatePen WinAPI_CreatePoint WinAPI_CreatePolygonRgn WinAPI_CreateProcess WinAPI_CreateProcessWithToken WinAPI_CreateRect WinAPI_CreateRectEx WinAPI_CreateRectRgn WinAPI_CreateRectRgnIndirect WinAPI_CreateRoundRectRgn WinAPI_CreateSemaphore WinAPI_CreateSize WinAPI_CreateSolidBitmap WinAPI_CreateSolidBrush WinAPI_CreateStreamOnHGlobal WinAPI_CreateString WinAPI_CreateSymbolicLink WinAPI_CreateTransform WinAPI_CreateWindowEx WinAPI_CreateWindowStation WinAPI_DecompressBuffer WinAPI_DecryptFile WinAPI_DeferWindowPos WinAPI_DefineDosDevice WinAPI_DefRawInputProc WinAPI_DefSubclassProc WinAPI_DefWindowProc WinAPI_DefWindowProcW WinAPI_DeleteDC WinAPI_DeleteEnhMetaFile WinAPI_DeleteFile WinAPI_DeleteObject WinAPI_DeleteObjectID WinAPI_DeleteVolumeMountPoint WinAPI_DeregisterShellHookWindow WinAPI_DestroyCaret WinAPI_DestroyCursor WinAPI_DestroyIcon WinAPI_DestroyWindow WinAPI_DeviceIoControl WinAPI_DisplayStruct WinAPI_DllGetVersion WinAPI_DllInstall WinAPI_DllUninstall WinAPI_DPtoLP WinAPI_DragAcceptFiles WinAPI_DragFinish WinAPI_DragQueryFileEx WinAPI_DragQueryPoint WinAPI_DrawAnimatedRects WinAPI_DrawBitmap WinAPI_DrawEdge WinAPI_DrawFocusRect WinAPI_DrawFrameControl WinAPI_DrawIcon WinAPI_DrawIconEx WinAPI_DrawLine WinAPI_DrawShadowText WinAPI_DrawText WinAPI_DrawThemeBackground WinAPI_DrawThemeEdge WinAPI_DrawThemeIcon WinAPI_DrawThemeParentBackground WinAPI_DrawThemeText WinAPI_DrawThemeTextEx WinAPI_DuplicateEncryptionInfoFile WinAPI_DuplicateHandle WinAPI_DuplicateTokenEx WinAPI_DwmDefWindowProc WinAPI_DwmEnableBlurBehindWindow WinAPI_DwmEnableComposition WinAPI_DwmExtendFrameIntoClientArea WinAPI_DwmGetColorizationColor WinAPI_DwmGetColorizationParameters WinAPI_DwmGetWindowAttribute WinAPI_DwmInvalidateIconicBitmaps WinAPI_DwmIsCompositionEnabled WinAPI_DwmQueryThumbnailSourceSize WinAPI_DwmRegisterThumbnail WinAPI_DwmSetColorizationParameters WinAPI_DwmSetIconicLivePreviewBitmap WinAPI_DwmSetIconicThumbnail WinAPI_DwmSetWindowAttribute WinAPI_DwmUnregisterThumbnail WinAPI_DwmUpdateThumbnailProperties WinAPI_DWordToFloat WinAPI_DWordToInt WinAPI_EjectMedia WinAPI_Ellipse WinAPI_EmptyWorkingSet WinAPI_EnableWindow WinAPI_EncryptFile WinAPI_EncryptionDisable WinAPI_EndBufferedPaint WinAPI_EndDeferWindowPos WinAPI_EndPaint WinAPI_EndPath WinAPI_EndUpdateResource WinAPI_EnumChildProcess WinAPI_EnumChildWindows WinAPI_EnumDesktops WinAPI_EnumDesktopWindows WinAPI_EnumDeviceDrivers WinAPI_EnumDisplayDevices WinAPI_EnumDisplayMonitors WinAPI_EnumDisplaySettings WinAPI_EnumDllProc WinAPI_EnumFiles WinAPI_EnumFileStreams WinAPI_EnumFontFamilies WinAPI_EnumHardLinks WinAPI_EnumMRUList WinAPI_EnumPageFiles WinAPI_EnumProcessHandles WinAPI_EnumProcessModules WinAPI_EnumProcessThreads WinAPI_EnumProcessWindows WinAPI_EnumRawInputDevices WinAPI_EnumResourceLanguages WinAPI_EnumResourceNames WinAPI_EnumResourceTypes WinAPI_EnumSystemGeoID WinAPI_EnumSystemLocales WinAPI_EnumUILanguages WinAPI_EnumWindows WinAPI_EnumWindowsPopup WinAPI_EnumWindowStations WinAPI_EnumWindowsTop WinAPI_EqualMemory WinAPI_EqualRect WinAPI_EqualRgn WinAPI_ExcludeClipRect WinAPI_ExpandEnvironmentStrings WinAPI_ExtCreatePen WinAPI_ExtCreateRegion WinAPI_ExtFloodFill WinAPI_ExtractIcon WinAPI_ExtractIconEx WinAPI_ExtSelectClipRgn WinAPI_FatalAppExit WinAPI_FatalExit WinAPI_FileEncryptionStatus WinAPI_FileExists WinAPI_FileIconInit WinAPI_FileInUse WinAPI_FillMemory WinAPI_FillPath WinAPI_FillRect WinAPI_FillRgn WinAPI_FindClose WinAPI_FindCloseChangeNotification WinAPI_FindExecutable WinAPI_FindFirstChangeNotification WinAPI_FindFirstFile WinAPI_FindFirstFileName WinAPI_FindFirstStream WinAPI_FindNextChangeNotification WinAPI_FindNextFile WinAPI_FindNextFileName WinAPI_FindNextStream WinAPI_FindResource WinAPI_FindResourceEx WinAPI_FindTextDlg WinAPI_FindWindow WinAPI_FlashWindow WinAPI_FlashWindowEx WinAPI_FlattenPath WinAPI_FloatToDWord WinAPI_FloatToInt WinAPI_FlushFileBuffers WinAPI_FlushFRBuffer WinAPI_FlushViewOfFile WinAPI_FormatDriveDlg WinAPI_FormatMessage WinAPI_FrameRect WinAPI_FrameRgn WinAPI_FreeLibrary WinAPI_FreeMemory WinAPI_FreeMRUList WinAPI_FreeResource WinAPI_GdiComment WinAPI_GetActiveWindow WinAPI_GetAllUsersProfileDirectory WinAPI_GetAncestor WinAPI_GetApplicationRestartSettings WinAPI_GetArcDirection WinAPI_GetAsyncKeyState WinAPI_GetBinaryType WinAPI_GetBitmapBits WinAPI_GetBitmapDimension WinAPI_GetBitmapDimensionEx WinAPI_GetBkColor WinAPI_GetBkMode WinAPI_GetBoundsRect WinAPI_GetBrushOrg WinAPI_GetBufferedPaintBits WinAPI_GetBufferedPaintDC WinAPI_GetBufferedPaintTargetDC WinAPI_GetBufferedPaintTargetRect WinAPI_GetBValue WinAPI_GetCaretBlinkTime WinAPI_GetCaretPos WinAPI_GetCDType WinAPI_GetClassInfoEx WinAPI_GetClassLongEx WinAPI_GetClassName WinAPI_GetClientHeight WinAPI_GetClientRect WinAPI_GetClientWidth WinAPI_GetClipboardSequenceNumber WinAPI_GetClipBox WinAPI_GetClipCursor WinAPI_GetClipRgn WinAPI_GetColorAdjustment WinAPI_GetCompressedFileSize WinAPI_GetCompression WinAPI_GetConnectedDlg WinAPI_GetCurrentDirectory WinAPI_GetCurrentHwProfile WinAPI_GetCurrentObject WinAPI_GetCurrentPosition WinAPI_GetCurrentProcess WinAPI_GetCurrentProcessExplicitAppUserModelID WinAPI_GetCurrentProcessID WinAPI_GetCurrentThemeName WinAPI_GetCurrentThread WinAPI_GetCurrentThreadId WinAPI_GetCursor WinAPI_GetCursorInfo WinAPI_GetDateFormat WinAPI_GetDC WinAPI_GetDCEx WinAPI_GetDefaultPrinter WinAPI_GetDefaultUserProfileDirectory WinAPI_GetDesktopWindow WinAPI_GetDeviceCaps WinAPI_GetDeviceDriverBaseName WinAPI_GetDeviceDriverFileName WinAPI_GetDeviceGammaRamp WinAPI_GetDIBColorTable WinAPI_GetDIBits WinAPI_GetDiskFreeSpaceEx WinAPI_GetDlgCtrlID WinAPI_GetDlgItem WinAPI_GetDllDirectory WinAPI_GetDriveBusType WinAPI_GetDriveGeometryEx WinAPI_GetDriveNumber WinAPI_GetDriveType WinAPI_GetDurationFormat WinAPI_GetEffectiveClientRect WinAPI_GetEnhMetaFile WinAPI_GetEnhMetaFileBits WinAPI_GetEnhMetaFileDescription WinAPI_GetEnhMetaFileDimension WinAPI_GetEnhMetaFileHeader WinAPI_GetErrorMessage WinAPI_GetErrorMode WinAPI_GetExitCodeProcess WinAPI_GetExtended WinAPI_GetFileAttributes WinAPI_GetFileID WinAPI_GetFileInformationByHandle WinAPI_GetFileInformationByHandleEx WinAPI_GetFilePointerEx WinAPI_GetFileSizeEx WinAPI_GetFileSizeOnDisk WinAPI_GetFileTitle WinAPI_GetFileType WinAPI_GetFileVersionInfo WinAPI_GetFinalPathNameByHandle WinAPI_GetFinalPathNameByHandleEx WinAPI_GetFocus WinAPI_GetFontMemoryResourceInfo WinAPI_GetFontName WinAPI_GetFontResourceInfo WinAPI_GetForegroundWindow WinAPI_GetFRBuffer WinAPI_GetFullPathName WinAPI_GetGeoInfo WinAPI_GetGlyphOutline WinAPI_GetGraphicsMode WinAPI_GetGuiResources WinAPI_GetGUIThreadInfo WinAPI_GetGValue WinAPI_GetHandleInformation WinAPI_GetHGlobalFromStream WinAPI_GetIconDimension WinAPI_GetIconInfo WinAPI_GetIconInfoEx WinAPI_GetIdleTime WinAPI_GetKeyboardLayout WinAPI_GetKeyboardLayoutList WinAPI_GetKeyboardState WinAPI_GetKeyboardType WinAPI_GetKeyNameText WinAPI_GetKeyState WinAPI_GetLastActivePopup WinAPI_GetLastError WinAPI_GetLastErrorMessage WinAPI_GetLayeredWindowAttributes WinAPI_GetLocaleInfo WinAPI_GetLogicalDrives WinAPI_GetMapMode WinAPI_GetMemorySize WinAPI_GetMessageExtraInfo WinAPI_GetModuleFileNameEx WinAPI_GetModuleHandle WinAPI_GetModuleHandleEx WinAPI_GetModuleInformation WinAPI_GetMonitorInfo WinAPI_GetMousePos WinAPI_GetMousePosX WinAPI_GetMousePosY WinAPI_GetMUILanguage WinAPI_GetNumberFormat WinAPI_GetObject WinAPI_GetObjectID WinAPI_GetObjectInfoByHandle WinAPI_GetObjectNameByHandle WinAPI_GetObjectType WinAPI_GetOpenFileName WinAPI_GetOutlineTextMetrics WinAPI_GetOverlappedResult WinAPI_GetParent WinAPI_GetParentProcess WinAPI_GetPerformanceInfo WinAPI_GetPEType WinAPI_GetPhysicallyInstalledSystemMemory WinAPI_GetPixel WinAPI_GetPolyFillMode WinAPI_GetPosFromRect WinAPI_GetPriorityClass WinAPI_GetProcAddress WinAPI_GetProcessAffinityMask WinAPI_GetProcessCommandLine WinAPI_GetProcessFileName WinAPI_GetProcessHandleCount WinAPI_GetProcessID WinAPI_GetProcessIoCounters WinAPI_GetProcessMemoryInfo WinAPI_GetProcessName WinAPI_GetProcessShutdownParameters WinAPI_GetProcessTimes WinAPI_GetProcessUser WinAPI_GetProcessWindowStation WinAPI_GetProcessWorkingDirectory WinAPI_GetProfilesDirectory WinAPI_GetPwrCapabilities WinAPI_GetRawInputBuffer WinAPI_GetRawInputBufferLength WinAPI_GetRawInputData WinAPI_GetRawInputDeviceInfo WinAPI_GetRegionData WinAPI_GetRegisteredRawInputDevices WinAPI_GetRegKeyNameByHandle WinAPI_GetRgnBox WinAPI_GetROP2 WinAPI_GetRValue WinAPI_GetSaveFileName WinAPI_GetShellWindow WinAPI_GetStartupInfo WinAPI_GetStdHandle WinAPI_GetStockObject WinAPI_GetStretchBltMode WinAPI_GetString WinAPI_GetSysColor WinAPI_GetSysColorBrush WinAPI_GetSystemDefaultLangID WinAPI_GetSystemDefaultLCID WinAPI_GetSystemDefaultUILanguage WinAPI_GetSystemDEPPolicy WinAPI_GetSystemInfo WinAPI_GetSystemMetrics WinAPI_GetSystemPowerStatus WinAPI_GetSystemTimes WinAPI_GetSystemWow64Directory WinAPI_GetTabbedTextExtent WinAPI_GetTempFileName WinAPI_GetTextAlign WinAPI_GetTextCharacterExtra WinAPI_GetTextColor WinAPI_GetTextExtentPoint32 WinAPI_GetTextFace WinAPI_GetTextMetrics WinAPI_GetThemeAppProperties WinAPI_GetThemeBackgroundContentRect WinAPI_GetThemeBackgroundExtent WinAPI_GetThemeBackgroundRegion WinAPI_GetThemeBitmap WinAPI_GetThemeBool WinAPI_GetThemeColor WinAPI_GetThemeDocumentationProperty WinAPI_GetThemeEnumValue WinAPI_GetThemeFilename WinAPI_GetThemeFont WinAPI_GetThemeInt WinAPI_GetThemeMargins WinAPI_GetThemeMetric WinAPI_GetThemePartSize WinAPI_GetThemePosition WinAPI_GetThemePropertyOrigin WinAPI_GetThemeRect WinAPI_GetThemeString WinAPI_GetThemeSysBool WinAPI_GetThemeSysColor WinAPI_GetThemeSysColorBrush WinAPI_GetThemeSysFont WinAPI_GetThemeSysInt WinAPI_GetThemeSysSize WinAPI_GetThemeSysString WinAPI_GetThemeTextExtent WinAPI_GetThemeTextMetrics WinAPI_GetThemeTransitionDuration WinAPI_GetThreadDesktop WinAPI_GetThreadErrorMode WinAPI_GetThreadLocale WinAPI_GetThreadUILanguage WinAPI_GetTickCount WinAPI_GetTickCount64 WinAPI_GetTimeFormat WinAPI_GetTopWindow WinAPI_GetUDFColorMode WinAPI_GetUpdateRect WinAPI_GetUpdateRgn WinAPI_GetUserDefaultLangID WinAPI_GetUserDefaultLCID WinAPI_GetUserDefaultUILanguage WinAPI_GetUserGeoID WinAPI_GetUserObjectInformation WinAPI_GetVersion WinAPI_GetVersionEx WinAPI_GetVolumeInformation WinAPI_GetVolumeInformationByHandle WinAPI_GetVolumeNameForVolumeMountPoint WinAPI_GetWindow WinAPI_GetWindowDC WinAPI_GetWindowDisplayAffinity WinAPI_GetWindowExt WinAPI_GetWindowFileName WinAPI_GetWindowHeight WinAPI_GetWindowInfo WinAPI_GetWindowLong WinAPI_GetWindowOrg WinAPI_GetWindowPlacement WinAPI_GetWindowRect WinAPI_GetWindowRgn WinAPI_GetWindowRgnBox WinAPI_GetWindowSubclass WinAPI_GetWindowText WinAPI_GetWindowTheme WinAPI_GetWindowThreadProcessId WinAPI_GetWindowWidth WinAPI_GetWorkArea WinAPI_GetWorldTransform WinAPI_GetXYFromPoint WinAPI_GlobalMemoryStatus WinAPI_GradientFill WinAPI_GUIDFromString WinAPI_GUIDFromStringEx WinAPI_HashData WinAPI_HashString WinAPI_HiByte WinAPI_HideCaret WinAPI_HiDWord WinAPI_HiWord WinAPI_InflateRect WinAPI_InitMUILanguage WinAPI_InProcess WinAPI_IntersectClipRect WinAPI_IntersectRect WinAPI_IntToDWord WinAPI_IntToFloat WinAPI_InvalidateRect WinAPI_InvalidateRgn WinAPI_InvertANDBitmap WinAPI_InvertColor WinAPI_InvertRect WinAPI_InvertRgn WinAPI_IOCTL WinAPI_IsAlphaBitmap WinAPI_IsBadCodePtr WinAPI_IsBadReadPtr WinAPI_IsBadStringPtr WinAPI_IsBadWritePtr WinAPI_IsChild WinAPI_IsClassName WinAPI_IsDoorOpen WinAPI_IsElevated WinAPI_IsHungAppWindow WinAPI_IsIconic WinAPI_IsInternetConnected WinAPI_IsLoadKBLayout WinAPI_IsMemory WinAPI_IsNameInExpression WinAPI_IsNetworkAlive WinAPI_IsPathShared WinAPI_IsProcessInJob WinAPI_IsProcessorFeaturePresent WinAPI_IsRectEmpty WinAPI_IsThemeActive WinAPI_IsThemeBackgroundPartiallyTransparent WinAPI_IsThemePartDefined WinAPI_IsValidLocale WinAPI_IsWindow WinAPI_IsWindowEnabled WinAPI_IsWindowUnicode WinAPI_IsWindowVisible WinAPI_IsWow64Process WinAPI_IsWritable WinAPI_IsZoomed WinAPI_Keybd_Event WinAPI_KillTimer WinAPI_LineDDA WinAPI_LineTo WinAPI_LoadBitmap WinAPI_LoadCursor WinAPI_LoadCursorFromFile WinAPI_LoadIcon WinAPI_LoadIconMetric WinAPI_LoadIconWithScaleDown WinAPI_LoadImage WinAPI_LoadIndirectString WinAPI_LoadKeyboardLayout WinAPI_LoadLibrary WinAPI_LoadLibraryEx WinAPI_LoadMedia WinAPI_LoadResource WinAPI_LoadShell32Icon WinAPI_LoadString WinAPI_LoadStringEx WinAPI_LoByte WinAPI_LocalFree WinAPI_LockDevice WinAPI_LockFile WinAPI_LockResource WinAPI_LockWindowUpdate WinAPI_LockWorkStation WinAPI_LoDWord WinAPI_LongMid WinAPI_LookupIconIdFromDirectoryEx WinAPI_LoWord WinAPI_LPtoDP WinAPI_MAKELANGID WinAPI_MAKELCID WinAPI_MakeLong WinAPI_MakeQWord WinAPI_MakeWord WinAPI_MapViewOfFile WinAPI_MapVirtualKey WinAPI_MaskBlt WinAPI_MessageBeep WinAPI_MessageBoxCheck WinAPI_MessageBoxIndirect WinAPI_MirrorIcon WinAPI_ModifyWorldTransform WinAPI_MonitorFromPoint WinAPI_MonitorFromRect WinAPI_MonitorFromWindow WinAPI_Mouse_Event WinAPI_MoveFileEx WinAPI_MoveMemory WinAPI_MoveTo WinAPI_MoveToEx WinAPI_MoveWindow WinAPI_MsgBox WinAPI_MulDiv WinAPI_MultiByteToWideChar WinAPI_MultiByteToWideCharEx WinAPI_NtStatusToDosError WinAPI_OemToChar WinAPI_OffsetClipRgn WinAPI_OffsetPoints WinAPI_OffsetRect WinAPI_OffsetRgn WinAPI_OffsetWindowOrg WinAPI_OpenDesktop WinAPI_OpenFileById WinAPI_OpenFileDlg WinAPI_OpenFileMapping WinAPI_OpenIcon WinAPI_OpenInputDesktop WinAPI_OpenJobObject WinAPI_OpenMutex WinAPI_OpenProcess WinAPI_OpenProcessToken WinAPI_OpenSemaphore WinAPI_OpenThemeData WinAPI_OpenWindowStation WinAPI_PageSetupDlg WinAPI_PaintDesktop WinAPI_PaintRgn WinAPI_ParseURL WinAPI_ParseUserName WinAPI_PatBlt WinAPI_PathAddBackslash WinAPI_PathAddExtension WinAPI_PathAppend WinAPI_PathBuildRoot WinAPI_PathCanonicalize WinAPI_PathCommonPrefix WinAPI_PathCompactPath WinAPI_PathCompactPathEx WinAPI_PathCreateFromUrl WinAPI_PathFindExtension WinAPI_PathFindFileName WinAPI_PathFindNextComponent WinAPI_PathFindOnPath WinAPI_PathGetArgs WinAPI_PathGetCharType WinAPI_PathGetDriveNumber WinAPI_PathIsContentType WinAPI_PathIsDirectory WinAPI_PathIsDirectoryEmpty WinAPI_PathIsExe WinAPI_PathIsFileSpec WinAPI_PathIsLFNFileSpec WinAPI_PathIsRelative WinAPI_PathIsRoot WinAPI_PathIsSameRoot WinAPI_PathIsSystemFolder WinAPI_PathIsUNC WinAPI_PathIsUNCServer WinAPI_PathIsUNCServerShare WinAPI_PathMakeSystemFolder WinAPI_PathMatchSpec WinAPI_PathParseIconLocation WinAPI_PathRelativePathTo WinAPI_PathRemoveArgs WinAPI_PathRemoveBackslash WinAPI_PathRemoveExtension WinAPI_PathRemoveFileSpec WinAPI_PathRenameExtension WinAPI_PathSearchAndQualify WinAPI_PathSkipRoot WinAPI_PathStripPath WinAPI_PathStripToRoot WinAPI_PathToRegion WinAPI_PathUndecorate WinAPI_PathUnExpandEnvStrings WinAPI_PathUnmakeSystemFolder WinAPI_PathUnquoteSpaces WinAPI_PathYetAnotherMakeUniqueName WinAPI_PickIconDlg WinAPI_PlayEnhMetaFile WinAPI_PlaySound WinAPI_PlgBlt WinAPI_PointFromRect WinAPI_PolyBezier WinAPI_PolyBezierTo WinAPI_PolyDraw WinAPI_Polygon WinAPI_PostMessage WinAPI_PrimaryLangId WinAPI_PrintDlg WinAPI_PrintDlgEx WinAPI_PrintWindow WinAPI_ProgIDFromCLSID WinAPI_PtInRect WinAPI_PtInRectEx WinAPI_PtInRegion WinAPI_PtVisible WinAPI_QueryDosDevice WinAPI_QueryInformationJobObject WinAPI_QueryPerformanceCounter WinAPI_QueryPerformanceFrequency WinAPI_RadialGradientFill WinAPI_ReadDirectoryChanges WinAPI_ReadFile WinAPI_ReadProcessMemory WinAPI_Rectangle WinAPI_RectInRegion WinAPI_RectIsEmpty WinAPI_RectVisible WinAPI_RedrawWindow WinAPI_RegCloseKey WinAPI_RegConnectRegistry WinAPI_RegCopyTree WinAPI_RegCopyTreeEx WinAPI_RegCreateKey WinAPI_RegDeleteEmptyKey WinAPI_RegDeleteKey WinAPI_RegDeleteKeyValue WinAPI_RegDeleteTree WinAPI_RegDeleteTreeEx WinAPI_RegDeleteValue WinAPI_RegDisableReflectionKey WinAPI_RegDuplicateHKey WinAPI_RegEnableReflectionKey WinAPI_RegEnumKey WinAPI_RegEnumValue WinAPI_RegFlushKey WinAPI_RegisterApplicationRestart WinAPI_RegisterClass WinAPI_RegisterClassEx WinAPI_RegisterHotKey WinAPI_RegisterPowerSettingNotification WinAPI_RegisterRawInputDevices WinAPI_RegisterShellHookWindow WinAPI_RegisterWindowMessage WinAPI_RegLoadMUIString WinAPI_RegNotifyChangeKeyValue WinAPI_RegOpenKey WinAPI_RegQueryInfoKey WinAPI_RegQueryLastWriteTime WinAPI_RegQueryMultipleValues WinAPI_RegQueryReflectionKey WinAPI_RegQueryValue WinAPI_RegRestoreKey WinAPI_RegSaveKey WinAPI_RegSetValue WinAPI_ReleaseCapture WinAPI_ReleaseDC WinAPI_ReleaseMutex WinAPI_ReleaseSemaphore WinAPI_ReleaseStream WinAPI_RemoveClipboardFormatListener WinAPI_RemoveDirectory WinAPI_RemoveFontMemResourceEx WinAPI_RemoveFontResourceEx WinAPI_RemoveWindowSubclass WinAPI_ReOpenFile WinAPI_ReplaceFile WinAPI_ReplaceTextDlg WinAPI_ResetEvent WinAPI_RestartDlg WinAPI_RestoreDC WinAPI_RGB WinAPI_RotatePoints WinAPI_RoundRect WinAPI_SaveDC WinAPI_SaveFileDlg WinAPI_SaveHBITMAPToFile WinAPI_SaveHICONToFile WinAPI_ScaleWindowExt WinAPI_ScreenToClient WinAPI_SearchPath WinAPI_SelectClipPath WinAPI_SelectClipRgn WinAPI_SelectObject WinAPI_SendMessageTimeout WinAPI_SetActiveWindow WinAPI_SetArcDirection WinAPI_SetBitmapBits WinAPI_SetBitmapDimensionEx WinAPI_SetBkColor WinAPI_SetBkMode WinAPI_SetBoundsRect WinAPI_SetBrushOrg WinAPI_SetCapture WinAPI_SetCaretBlinkTime WinAPI_SetCaretPos WinAPI_SetClassLongEx WinAPI_SetColorAdjustment WinAPI_SetCompression WinAPI_SetCurrentDirectory WinAPI_SetCurrentProcessExplicitAppUserModelID WinAPI_SetCursor WinAPI_SetDCBrushColor WinAPI_SetDCPenColor WinAPI_SetDefaultPrinter WinAPI_SetDeviceGammaRamp WinAPI_SetDIBColorTable WinAPI_SetDIBits WinAPI_SetDIBitsToDevice WinAPI_SetDllDirectory WinAPI_SetEndOfFile WinAPI_SetEnhMetaFileBits WinAPI_SetErrorMode WinAPI_SetEvent WinAPI_SetFileAttributes WinAPI_SetFileInformationByHandleEx WinAPI_SetFilePointer WinAPI_SetFilePointerEx WinAPI_SetFileShortName WinAPI_SetFileValidData WinAPI_SetFocus WinAPI_SetFont WinAPI_SetForegroundWindow WinAPI_SetFRBuffer WinAPI_SetGraphicsMode WinAPI_SetHandleInformation WinAPI_SetInformationJobObject WinAPI_SetKeyboardLayout WinAPI_SetKeyboardState WinAPI_SetLastError WinAPI_SetLayeredWindowAttributes WinAPI_SetLocaleInfo WinAPI_SetMapMode WinAPI_SetMessageExtraInfo WinAPI_SetParent WinAPI_SetPixel WinAPI_SetPolyFillMode WinAPI_SetPriorityClass WinAPI_SetProcessAffinityMask WinAPI_SetProcessShutdownParameters WinAPI_SetProcessWindowStation WinAPI_SetRectRgn WinAPI_SetROP2 WinAPI_SetSearchPathMode WinAPI_SetStretchBltMode WinAPI_SetSysColors WinAPI_SetSystemCursor WinAPI_SetTextAlign WinAPI_SetTextCharacterExtra WinAPI_SetTextColor WinAPI_SetTextJustification WinAPI_SetThemeAppProperties WinAPI_SetThreadDesktop WinAPI_SetThreadErrorMode WinAPI_SetThreadExecutionState WinAPI_SetThreadLocale WinAPI_SetThreadUILanguage WinAPI_SetTimer WinAPI_SetUDFColorMode WinAPI_SetUserGeoID WinAPI_SetUserObjectInformation WinAPI_SetVolumeMountPoint WinAPI_SetWindowDisplayAffinity WinAPI_SetWindowExt WinAPI_SetWindowLong WinAPI_SetWindowOrg WinAPI_SetWindowPlacement WinAPI_SetWindowPos WinAPI_SetWindowRgn WinAPI_SetWindowsHookEx WinAPI_SetWindowSubclass WinAPI_SetWindowText WinAPI_SetWindowTheme WinAPI_SetWinEventHook WinAPI_SetWorldTransform WinAPI_SfcIsFileProtected WinAPI_SfcIsKeyProtected WinAPI_ShellAboutDlg WinAPI_ShellAddToRecentDocs WinAPI_ShellChangeNotify WinAPI_ShellChangeNotifyDeregister WinAPI_ShellChangeNotifyRegister WinAPI_ShellCreateDirectory WinAPI_ShellEmptyRecycleBin WinAPI_ShellExecute WinAPI_ShellExecuteEx WinAPI_ShellExtractAssociatedIcon WinAPI_ShellExtractIcon WinAPI_ShellFileOperation WinAPI_ShellFlushSFCache WinAPI_ShellGetFileInfo WinAPI_ShellGetIconOverlayIndex WinAPI_ShellGetImageList WinAPI_ShellGetKnownFolderIDList WinAPI_ShellGetKnownFolderPath WinAPI_ShellGetLocalizedName WinAPI_ShellGetPathFromIDList WinAPI_ShellGetSetFolderCustomSettings WinAPI_ShellGetSettings WinAPI_ShellGetSpecialFolderLocation WinAPI_ShellGetSpecialFolderPath WinAPI_ShellGetStockIconInfo WinAPI_ShellILCreateFromPath WinAPI_ShellNotifyIcon WinAPI_ShellNotifyIconGetRect WinAPI_ShellObjectProperties WinAPI_ShellOpenFolderAndSelectItems WinAPI_ShellOpenWithDlg WinAPI_ShellQueryRecycleBin WinAPI_ShellQueryUserNotificationState WinAPI_ShellRemoveLocalizedName WinAPI_ShellRestricted WinAPI_ShellSetKnownFolderPath WinAPI_ShellSetLocalizedName WinAPI_ShellSetSettings WinAPI_ShellStartNetConnectionDlg WinAPI_ShellUpdateImage WinAPI_ShellUserAuthenticationDlg WinAPI_ShellUserAuthenticationDlgEx WinAPI_ShortToWord WinAPI_ShowCaret WinAPI_ShowCursor WinAPI_ShowError WinAPI_ShowLastError WinAPI_ShowMsg WinAPI_ShowOwnedPopups WinAPI_ShowWindow WinAPI_ShutdownBlockReasonCreate WinAPI_ShutdownBlockReasonDestroy WinAPI_ShutdownBlockReasonQuery WinAPI_SizeOfResource WinAPI_StretchBlt WinAPI_StretchDIBits WinAPI_StrFormatByteSize WinAPI_StrFormatByteSizeEx WinAPI_StrFormatKBSize WinAPI_StrFromTimeInterval WinAPI_StringFromGUID WinAPI_StringLenA WinAPI_StringLenW WinAPI_StrLen WinAPI_StrokeAndFillPath WinAPI_StrokePath WinAPI_StructToArray WinAPI_SubLangId WinAPI_SubtractRect WinAPI_SwapDWord WinAPI_SwapQWord WinAPI_SwapWord WinAPI_SwitchColor WinAPI_SwitchDesktop WinAPI_SwitchToThisWindow WinAPI_SystemParametersInfo WinAPI_TabbedTextOut WinAPI_TerminateJobObject WinAPI_TerminateProcess WinAPI_TextOut WinAPI_TileWindows WinAPI_TrackMouseEvent WinAPI_TransparentBlt WinAPI_TwipsPerPixelX WinAPI_TwipsPerPixelY WinAPI_UnhookWindowsHookEx WinAPI_UnhookWinEvent WinAPI_UnionRect WinAPI_UnionStruct WinAPI_UniqueHardwareID WinAPI_UnloadKeyboardLayout WinAPI_UnlockFile WinAPI_UnmapViewOfFile WinAPI_UnregisterApplicationRestart WinAPI_UnregisterClass WinAPI_UnregisterHotKey WinAPI_UnregisterPowerSettingNotification WinAPI_UpdateLayeredWindow WinAPI_UpdateLayeredWindowEx WinAPI_UpdateLayeredWindowIndirect WinAPI_UpdateResource WinAPI_UpdateWindow WinAPI_UrlApplyScheme WinAPI_UrlCanonicalize WinAPI_UrlCombine WinAPI_UrlCompare WinAPI_UrlCreateFromPath WinAPI_UrlFixup WinAPI_UrlGetPart WinAPI_UrlHash WinAPI_UrlIs WinAPI_UserHandleGrantAccess WinAPI_ValidateRect WinAPI_ValidateRgn WinAPI_VerQueryRoot WinAPI_VerQueryValue WinAPI_VerQueryValueEx WinAPI_WaitForInputIdle WinAPI_WaitForMultipleObjects WinAPI_WaitForSingleObject WinAPI_WideCharToMultiByte WinAPI_WidenPath WinAPI_WindowFromDC WinAPI_WindowFromPoint WinAPI_WordToShort WinAPI_Wow64EnableWow64FsRedirection WinAPI_WriteConsole WinAPI_WriteFile WinAPI_WriteProcessMemory WinAPI_ZeroMemory WinNet_AddConnection WinNet_AddConnection2 WinNet_AddConnection3 WinNet_CancelConnection WinNet_CancelConnection2 WinNet_CloseEnum WinNet_ConnectionDialog WinNet_ConnectionDialog1 WinNet_DisconnectDialog WinNet_DisconnectDialog1 WinNet_EnumResource WinNet_GetConnection WinNet_GetConnectionPerformance WinNet_GetLastError WinNet_GetNetworkInformation WinNet_GetProviderName WinNet_GetResourceInformation WinNet_GetResourceParent WinNet_GetUniversalName WinNet_GetUser WinNet_OpenEnum WinNet_RestoreConnection WinNet_UseConnection Word_Create Word_DocAdd Word_DocAttach Word_DocClose Word_DocExport Word_DocFind Word_DocFindReplace Word_DocGet Word_DocLinkAdd Word_DocLinkGet Word_DocOpen Word_DocPictureAdd Word_DocPrint Word_DocRangeSet Word_DocSave Word_DocSaveAs Word_DocTableRead Word_DocTableWrite Word_Quit",COMMENT={
variants:[hljs.COMMENT(";","$",{relevance:0}),hljs.COMMENT("#cs","#ce"),hljs.COMMENT("#comments-start","#comments-end")]},VARIABLE={className:"variable",begin:"\\$[A-z0-9_]+"},STRING={className:"string",variants:[{begin:/"/,end:/"/,contains:[{begin:/""/,relevance:0}]},{begin:/'/,end:/'/,contains:[{begin:/''/,relevance:0}]}]},NUMBER={variants:[hljs.BINARY_NUMBER_MODE,hljs.C_NUMBER_MODE]},PREPROCESSOR={className:"preprocessor",begin:"#",end:"$",keywords:"include include-once NoTrayIcon OnAutoItStartRegister RequireAdmin pragma Au3Stripper_Ignore_Funcs Au3Stripper_Ignore_Variables Au3Stripper_Off Au3Stripper_On Au3Stripper_Parameters AutoIt3Wrapper_Add_Constants AutoIt3Wrapper_Au3Check_Parameters AutoIt3Wrapper_Au3Check_Stop_OnWarning AutoIt3Wrapper_Aut2Exe AutoIt3Wrapper_AutoIt3 AutoIt3Wrapper_AutoIt3Dir AutoIt3Wrapper_Change2CUI AutoIt3Wrapper_Compile_Both AutoIt3Wrapper_Compression AutoIt3Wrapper_EndIf AutoIt3Wrapper_Icon AutoIt3Wrapper_If_Compile AutoIt3Wrapper_If_Run AutoIt3Wrapper_Jump_To_First_Error AutoIt3Wrapper_OutFile AutoIt3Wrapper_OutFile_Type AutoIt3Wrapper_OutFile_X64 AutoIt3Wrapper_PlugIn_Funcs AutoIt3Wrapper_Res_Comment Autoit3Wrapper_Res_Compatibility AutoIt3Wrapper_Res_Description AutoIt3Wrapper_Res_Field AutoIt3Wrapper_Res_File_Add AutoIt3Wrapper_Res_FileVersion AutoIt3Wrapper_Res_FileVersion_AutoIncrement AutoIt3Wrapper_Res_Icon_Add AutoIt3Wrapper_Res_Language AutoIt3Wrapper_Res_LegalCopyright AutoIt3Wrapper_Res_ProductVersion AutoIt3Wrapper_Res_requestedExecutionLevel AutoIt3Wrapper_Res_SaveSource AutoIt3Wrapper_Run_After AutoIt3Wrapper_Run_Au3Check AutoIt3Wrapper_Run_Au3Stripper AutoIt3Wrapper_Run_Before AutoIt3Wrapper_Run_Debug_Mode AutoIt3Wrapper_Run_SciTE_Minimized AutoIt3Wrapper_Run_SciTE_OutputPane_Minimized AutoIt3Wrapper_Run_Tidy AutoIt3Wrapper_ShowProgress AutoIt3Wrapper_Testing AutoIt3Wrapper_Tidy_Stop_OnError AutoIt3Wrapper_UPX_Parameters AutoIt3Wrapper_UseUPX AutoIt3Wrapper_UseX64 AutoIt3Wrapper_Version AutoIt3Wrapper_Versioning AutoIt3Wrapper_Versioning_Parameters Tidy_Off Tidy_On Tidy_Parameters EndRegion Region",contains:[{begin:/\\\n/,relevance:0},{beginKeywords:"include",end:"$",contains:[STRING,{className:"string",variants:[{begin:"<",end:">"},{begin:/"/,end:/"/,contains:[{begin:/""/,relevance:0}]},{begin:/'/,end:/'/,contains:[{begin:/''/,relevance:0}]}]}]},STRING,COMMENT]},CONSTANT={className:"constant",begin:"@[A-z0-9_]+"},FUNCTION={className:"function",beginKeywords:"Func",end:"$",excludeEnd:!0,illegal:"\\$|\\[|%",contains:[hljs.UNDERSCORE_TITLE_MODE,{className:"params",begin:"\\(",end:"\\)",contains:[VARIABLE,STRING,NUMBER]}]};return{case_insensitive:!0,illegal:/\/\*/,keywords:{keyword:KEYWORDS,built_in:BUILT_IN,literal:LITERAL},contains:[COMMENT,VARIABLE,STRING,NUMBER,PREPROCESSOR,CONSTANT,FUNCTION]}}),hljs.registerLanguage("avrasm",function(hljs){return{case_insensitive:!0,lexemes:"\\.?"+hljs.IDENT_RE,keywords:{keyword:"adc add adiw and andi asr bclr bld brbc brbs brcc brcs break breq brge brhc brhs brid brie brlo brlt brmi brne brpl brsh brtc brts brvc brvs bset bst call cbi cbr clc clh cli cln clr cls clt clv clz com cp cpc cpi cpse dec eicall eijmp elpm eor fmul fmuls fmulsu icall ijmp in inc jmp ld ldd ldi lds lpm lsl lsr mov movw mul muls mulsu neg nop or ori out pop push rcall ret reti rjmp rol ror sbc sbr sbrc sbrs sec seh sbi sbci sbic sbis sbiw sei sen ser ses set sev sez sleep spm st std sts sub subi swap tst wdr",built_in:"r0 r1 r2 r3 r4 r5 r6 r7 r8 r9 r10 r11 r12 r13 r14 r15 r16 r17 r18 r19 r20 r21 r22 r23 r24 r25 r26 r27 r28 r29 r30 r31 x|0 xh xl y|0 yh yl z|0 zh zl ucsr1c udr1 ucsr1a ucsr1b ubrr1l ubrr1h ucsr0c ubrr0h tccr3c tccr3a tccr3b tcnt3h tcnt3l ocr3ah ocr3al ocr3bh ocr3bl ocr3ch ocr3cl icr3h icr3l etimsk etifr tccr1c ocr1ch ocr1cl twcr twdr twar twsr twbr osccal xmcra xmcrb eicra spmcsr spmcr portg ddrg ping portf ddrf sreg sph spl xdiv rampz eicrb eimsk gimsk gicr eifr gifr timsk tifr mcucr mcucsr tccr0 tcnt0 ocr0 assr tccr1a tccr1b tcnt1h tcnt1l ocr1ah ocr1al ocr1bh ocr1bl icr1h icr1l tccr2 tcnt2 ocr2 ocdr wdtcr sfior eearh eearl eedr eecr porta ddra pina portb ddrb pinb portc ddrc pinc portd ddrd pind spdr spsr spcr udr0 ucsr0a ucsr0b ubrr0l acsr admux adcsr adch adcl porte ddre pine pinf",preprocessor:".byte .cseg .db .def .device .dseg .dw .endmacro .equ .eseg .exit .include .list .listmac .macro .nolist .org .set"},contains:[hljs.C_BLOCK_COMMENT_MODE,hljs.COMMENT(";","$",{relevance:0}),hljs.C_NUMBER_MODE,hljs.BINARY_NUMBER_MODE,{className:"number",begin:"\\b(\\$[a-zA-Z0-9]+|0o[0-7]+)"},hljs.QUOTE_STRING_MODE,{className:"string",begin:"'",end:"[^\\\\]'",illegal:"[^\\\\][^']"},{className:"label",begin:"^[A-Za-z0-9_.$]+:"},{className:"preprocessor",begin:"#",end:"$"},{className:"localvars",begin:"@[0-9]+"}]}}),hljs.registerLanguage("axapta",function(hljs){return{keywords:"false int abstract private char boolean static null if for true while long throw finally protected final return void enum else break new catch byte super case short default double public try this switch continue reverse firstfast firstonly forupdate nofetch sum avg minof maxof count order group by asc desc index hint like dispaly edit client server ttsbegin ttscommit str real date container anytype common div mod",contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.C_NUMBER_MODE,{className:"preprocessor",begin:"#",end:"$"},{className:"class",beginKeywords:"class interface",end:"{",excludeEnd:!0,illegal:":",contains:[{beginKeywords:"extends implements"},hljs.UNDERSCORE_TITLE_MODE]}]}}),hljs.registerLanguage("bash",function(hljs){var VAR={className:"variable",variants:[{begin:/\$[\w\d#@][\w\d_]*/},{begin:/\$\{(.*?)}/}]},QUOTE_STRING={className:"string",begin:/"/,end:/"/,contains:[hljs.BACKSLASH_ESCAPE,VAR,{className:"variable",begin:/\$\(/,end:/\)/,contains:[hljs.BACKSLASH_ESCAPE]}]},APOS_STRING={className:"string",begin:/'/,end:/'/};return{aliases:["sh","zsh"],lexemes:/-?[a-z\.]+/,keywords:{keyword:"if then else elif fi for while in do done case esac function",literal:"true false",built_in:"break cd continue eval exec exit export getopts hash pwd readonly return shift test times trap umask unset alias bind builtin caller command declare echo enable help let local logout mapfile printf read readarray source type typeset ulimit unalias set shopt autoload bg bindkey bye cap chdir clone comparguments compcall compctl compdescribe compfiles compgroups compquote comptags comptry compvalues dirs disable disown echotc echoti emulate fc fg float functions getcap getln history integer jobs kill limit log noglob popd print pushd pushln rehash sched setcap setopt stat suspend ttyctl unfunction unhash unlimit unsetopt vared wait whence where which zcompile zformat zftp zle zmodload zparseopts zprof zpty zregexparse zsocket zstyle ztcp",operator:"-ne -eq -lt -gt -f -d -e -s -l -a"},contains:[{className:"shebang",begin:/^#![^\n]+sh\s*$/,relevance:10},{className:"function",begin:/\w[\w\d_]*\s*\(\s*\)\s*\{/,returnBegin:!0,contains:[hljs.inherit(hljs.TITLE_MODE,{begin:/\w[\w\d_]*/})],relevance:0},hljs.HASH_COMMENT_MODE,hljs.NUMBER_MODE,QUOTE_STRING,APOS_STRING,VAR]}}),hljs.registerLanguage("brainfuck",function(hljs){var LITERAL={className:"literal",begin:"[\\+\\-]",relevance:0};return{aliases:["bf"],contains:[hljs.COMMENT("[^\\[\\]\\.,\\+\\-<> \r\n]","[\\[\\]\\.,\\+\\-<> \r\n]",{returnEnd:!0,relevance:0}),{className:"title",begin:"[\\[\\]]",relevance:0},{className:"string",begin:"[\\.,]",relevance:0},{begin:/\+\+|\-\-/,returnBegin:!0,contains:[LITERAL]},LITERAL]}}),hljs.registerLanguage("cal",function(hljs){var KEYWORDS="div mod in and or not xor asserterror begin case do downto else end exit for if of repeat then to until while with var",LITERALS="false true",COMMENT_MODES=[hljs.C_LINE_COMMENT_MODE,hljs.COMMENT(/\{/,/\}/,{relevance:0}),hljs.COMMENT(/\(\*/,/\*\)/,{relevance:10})],STRING={className:"string",begin:/'/,end:/'/,contains:[{begin:/''/}]},CHAR_STRING={className:"string",begin:/(#\d+)+/},DATE={className:"date",begin:"\\b\\d+(\\.\\d+)?(DT|D|T)",relevance:0},DBL_QUOTED_VARIABLE={className:"variable",begin:'"',end:'"'},PROCEDURE={className:"function",beginKeywords:"procedure",end:/[:;]/,keywords:"procedure|10",contains:[hljs.TITLE_MODE,{className:"params",begin:/\(/,end:/\)/,keywords:KEYWORDS,contains:[STRING,CHAR_STRING]}].concat(COMMENT_MODES)},OBJECT={className:"class",begin:"OBJECT (Table|Form|Report|Dataport|Codeunit|XMLport|MenuSuite|Page|Query) (\\d+) ([^\\r\\n]+)",returnBegin:!0,contains:[hljs.TITLE_MODE,PROCEDURE]};return{case_insensitive:!0,keywords:{keyword:KEYWORDS,literal:LITERALS},illegal:/\/\*/,contains:[STRING,CHAR_STRING,DATE,DBL_QUOTED_VARIABLE,hljs.NUMBER_MODE,OBJECT,PROCEDURE]}}),hljs.registerLanguage("capnproto",function(hljs){return{aliases:["capnp"],keywords:{keyword:"struct enum interface union group import using const annotation extends in of on as with from fixed",built_in:"Void Bool Int8 Int16 Int32 Int64 UInt8 UInt16 UInt32 UInt64 Float32 Float64 Text Data AnyPointer AnyStruct Capability List",literal:"true false"},contains:[hljs.QUOTE_STRING_MODE,hljs.NUMBER_MODE,hljs.HASH_COMMENT_MODE,{className:"shebang",begin:/@0x[\w\d]{16};/,illegal:/\n/},{className:"number",begin:/@\d+\b/},{className:"class",beginKeywords:"struct enum",end:/\{/,illegal:/\n/,contains:[hljs.inherit(hljs.TITLE_MODE,{starts:{endsWithParent:!0,excludeEnd:!0}})]},{className:"class",beginKeywords:"interface",end:/\{/,illegal:/\n/,contains:[hljs.inherit(hljs.TITLE_MODE,{starts:{endsWithParent:!0,excludeEnd:!0}})]}]}}),hljs.registerLanguage("ceylon",function(hljs){var KEYWORDS="assembly module package import alias class interface object given value assign void function new of extends satisfies abstracts in out return break continue throw assert dynamic if else switch case for while try catch finally then let this outer super is exists nonempty",DECLARATION_MODIFIERS="shared abstract formal default actual variable late native deprecatedfinal sealed annotation suppressWarnings small",DOCUMENTATION="doc by license see throws tagged",LANGUAGE_ANNOTATIONS=DECLARATION_MODIFIERS+" "+DOCUMENTATION,SUBST={className:"subst",excludeBegin:!0,excludeEnd:!0,begin:/``/,end:/``/,keywords:KEYWORDS,relevance:10},EXPRESSIONS=[{className:"string",begin:'"""',end:'"""',relevance:10},{className:"string",begin:'"',end:'"',contains:[SUBST]},{className:"string",begin:"'",end:"'"},{className:"number",begin:"#[0-9a-fA-F_]+|\\$[01_]+|[0-9_]+(?:\\.[0-9_](?:[eE][+-]?\\d+)?)?[kMGTPmunpf]?",relevance:0}];return SUBST.contains=EXPRESSIONS,{keywords:{keyword:KEYWORDS,annotation:LANGUAGE_ANNOTATIONS},illegal:"\\$[^01]|#[^0-9a-fA-F]",contains:[hljs.C_LINE_COMMENT_MODE,hljs.COMMENT("/\\*","\\*/",{contains:["self"]}),{className:"annotation",begin:'@[a-z]\\w*(?:\\:"[^"]*")?'}].concat(EXPRESSIONS)}}),hljs.registerLanguage("clojure",function(hljs){var keywords={built_in:"def defonce cond apply if-not if-let if not not= = < > <= >= == + / * - rem quot neg? pos? delay? symbol? keyword? true? false? integer? empty? coll? list? set? ifn? fn? associative? sequential? sorted? counted? reversible? number? decimal? class? distinct? isa? float? rational? reduced? ratio? odd? even? char? seq? vector? string? map? nil? contains? zero? instance? not-every? not-any? libspec? -> ->> .. . inc compare do dotimes mapcat take remove take-while drop letfn drop-last take-last drop-while while intern condp case reduced cycle split-at split-with repeat replicate iterate range merge zipmap declare line-seq sort comparator sort-by dorun doall nthnext nthrest partition eval doseq await await-for let agent atom send send-off release-pending-sends add-watch mapv filterv remove-watch agent-error restart-agent set-error-handler error-handler set-error-mode! error-mode shutdown-agents quote var fn loop recur throw try monitor-enter monitor-exit defmacro defn defn- macroexpand macroexpand-1 for dosync and or when when-not when-let comp juxt partial sequence memoize constantly complement identity assert peek pop doto proxy defstruct first rest cons defprotocol cast coll deftype defrecord last butlast sigs reify second ffirst fnext nfirst nnext defmulti defmethod meta with-meta ns in-ns create-ns import refer keys select-keys vals key val rseq name namespace promise into transient persistent! conj! assoc! dissoc! pop! disj! use class type num float double short byte boolean bigint biginteger bigdec print-method print-dup throw-if printf format load compile get-in update-in pr pr-on newline flush read slurp read-line subvec with-open memfn time re-find re-groups rand-int rand mod locking assert-valid-fdecl alias resolve ref deref refset swap! reset! set-validator! compare-and-set! alter-meta! reset-meta! commute get-validator alter ref-set ref-history-count ref-min-history ref-max-history ensure sync io! new next conj set! to-array future future-call into-array aset gen-class reduce map filter find empty hash-map hash-set sorted-map sorted-map-by sorted-set sorted-set-by vec vector seq flatten reverse assoc dissoc list disj get union difference intersection extend extend-type extend-protocol int nth delay count concat chunk chunk-buffer chunk-append chunk-first chunk-rest max min dec unchecked-inc-int unchecked-inc unchecked-dec-inc unchecked-dec unchecked-negate unchecked-add-int unchecked-add unchecked-subtract-int unchecked-subtract chunk-next chunk-cons chunked-seq? prn vary-meta lazy-seq spread list* str find-keyword keyword symbol gensym force rationalize"},SYMBOLSTART="a-zA-Z_\\-!.?+*=<>&#'",SYMBOL_RE="["+SYMBOLSTART+"]["+SYMBOLSTART+"0-9/;:]*",SIMPLE_NUMBER_RE="[-+]?\\d+(\\.\\d+)?",SYMBOL={begin:SYMBOL_RE,relevance:0},NUMBER={className:"number",begin:SIMPLE_NUMBER_RE,relevance:0},STRING=hljs.inherit(hljs.QUOTE_STRING_MODE,{illegal:null}),COMMENT=hljs.COMMENT(";","$",{relevance:0}),LITERAL={className:"literal",begin:/\b(true|false|nil)\b/},COLLECTION={className:"collection",begin:"[\\[\\{]",end:"[\\]\\}]"},HINT={className:"comment",begin:"\\^"+SYMBOL_RE},HINT_COL=hljs.COMMENT("\\^\\{","\\}"),KEY={className:"attribute",begin:"[:]"+SYMBOL_RE},LIST={className:"list",begin:"\\(",end:"\\)"},BODY={endsWithParent:!0,relevance:0},NAME={keywords:keywords,lexemes:SYMBOL_RE,className:"keyword",begin:SYMBOL_RE,starts:BODY},DEFAULT_CONTAINS=[LIST,STRING,HINT,HINT_COL,COMMENT,KEY,COLLECTION,NUMBER,LITERAL,SYMBOL];return LIST.contains=[hljs.COMMENT("comment",""),NAME,BODY],BODY.contains=DEFAULT_CONTAINS,COLLECTION.contains=DEFAULT_CONTAINS,{aliases:["clj"],illegal:/\S/,contains:[LIST,STRING,HINT,HINT_COL,COMMENT,KEY,COLLECTION,NUMBER,LITERAL]}}),hljs.registerLanguage("clojure-repl",function(hljs){return{contains:[{className:"prompt",begin:/^([\w.-]+|\s*#_)=>/,starts:{end:/$/,subLanguage:"clojure"}}]}}),hljs.registerLanguage("cmake",function(hljs){return{aliases:["cmake.in"],case_insensitive:!0,keywords:{keyword:"add_custom_command add_custom_target add_definitions add_dependencies add_executable add_library add_subdirectory add_test aux_source_directory break build_command cmake_minimum_required cmake_policy configure_file create_test_sourcelist define_property else elseif enable_language enable_testing endforeach endfunction endif endmacro endwhile execute_process export find_file find_library find_package find_path find_program fltk_wrap_ui foreach function get_cmake_property get_directory_property get_filename_component get_property get_source_file_property get_target_property get_test_property if include include_directories include_external_msproject include_regular_expression install link_directories load_cache load_command macro mark_as_advanced message option output_required_files project qt_wrap_cpp qt_wrap_ui remove_definitions return separate_arguments set set_directory_properties set_property set_source_files_properties set_target_properties set_tests_properties site_name source_group string target_link_libraries try_compile try_run unset variable_watch while build_name exec_program export_library_dependencies install_files install_programs install_targets link_libraries make_directory remove subdir_depends subdirs use_mangled_mesa utility_source variable_requires write_file qt5_use_modules qt5_use_package qt5_wrap_cpp on off true false and or",operator:"equal less greater strless strgreater strequal matches"},contains:[{className:"envvar",begin:"\\${",end:"}"},hljs.HASH_COMMENT_MODE,hljs.QUOTE_STRING_MODE,hljs.NUMBER_MODE]}}),hljs.registerLanguage("coffeescript",function(hljs){var KEYWORDS={keyword:"in if for while finally new do return else break catch instanceof throw try this switch continue typeof delete debugger super then unless until loop of by when and or is isnt not",literal:"true false null undefined yes no on off",built_in:"npm require console print module global window document"},JS_IDENT_RE="[A-Za-z$_][0-9A-Za-z$_]*",SUBST={className:"subst",begin:/#\{/,end:/}/,keywords:KEYWORDS},EXPRESSIONS=[hljs.BINARY_NUMBER_MODE,hljs.inherit(hljs.C_NUMBER_MODE,{starts:{end:"(\\s*/)?",relevance:0}}),{className:"string",variants:[{begin:/'''/,end:/'''/,contains:[hljs.BACKSLASH_ESCAPE]},{begin:/'/,end:/'/,contains:[hljs.BACKSLASH_ESCAPE]},{begin:/"""/,end:/"""/,contains:[hljs.BACKSLASH_ESCAPE,SUBST]},{begin:/"/,end:/"/,contains:[hljs.BACKSLASH_ESCAPE,SUBST]}]},{className:"regexp",variants:[{begin:"///",end:"///",contains:[SUBST,hljs.HASH_COMMENT_MODE]},{begin:"//[gim]*",relevance:0},{begin:/\/(?![ *])(\\\/|.)*?\/[gim]*(?=\W|$)/}]},{className:"property",begin:"@"+JS_IDENT_RE},{begin:"`",end:"`",excludeBegin:!0,excludeEnd:!0,subLanguage:"javascript"}];SUBST.contains=EXPRESSIONS;var TITLE=hljs.inherit(hljs.TITLE_MODE,{begin:JS_IDENT_RE}),PARAMS_RE="(\\(.*\\))?\\s*\\B[-=]>",PARAMS={className:"params",begin:"\\([^\\(]",returnBegin:!0,contains:[{begin:/\(/,end:/\)/,keywords:KEYWORDS,contains:["self"].concat(EXPRESSIONS)}]};return{aliases:["coffee","cson","iced"],keywords:KEYWORDS,illegal:/\/\*/,contains:EXPRESSIONS.concat([hljs.COMMENT("###","###"),hljs.HASH_COMMENT_MODE,{className:"function",begin:"^\\s*"+JS_IDENT_RE+"\\s*=\\s*"+PARAMS_RE,end:"[-=]>",returnBegin:!0,contains:[TITLE,PARAMS]},{begin:/[:\(,=]\s*/,relevance:0,contains:[{className:"function",begin:PARAMS_RE,end:"[-=]>",returnBegin:!0,contains:[PARAMS]}]},{className:"class",beginKeywords:"class",end:"$",illegal:/[:="\[\]]/,contains:[{beginKeywords:"extends",endsWithParent:!0,illegal:/[:="\[\]]/,contains:[TITLE]},TITLE]},{className:"attribute",begin:JS_IDENT_RE+":",end:":",returnBegin:!0,returnEnd:!0,relevance:0}])}}),hljs.registerLanguage("cpp",function(hljs){var CPP_PRIMATIVE_TYPES={className:"keyword",begin:"\\b[a-z\\d_]*_t\\b"},STRINGS={className:"string",variants:[hljs.inherit(hljs.QUOTE_STRING_MODE,{begin:'((u8?|U)|L)?"'}),{begin:'(u8?|U)?R"',end:'"',contains:[hljs.BACKSLASH_ESCAPE]},{begin:"'\\\\?.",end:"'",illegal:"."}]},NUMBERS={className:"number",variants:[{begin:"\\b(\\d+(\\.\\d*)?|\\.\\d+)(u|U|l|L|ul|UL|f|F)"},{begin:hljs.C_NUMBER_RE}]},PREPROCESSOR={className:"preprocessor",begin:"#",end:"$",keywords:"if else elif endif define undef warning error line pragma ifdef ifndef",contains:[{begin:/\\\n/,relevance:0},{beginKeywords:"include",end:"$",contains:[STRINGS,{className:"string",begin:"<",end:">",illegal:"\\n"}]},STRINGS,NUMBERS,hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE]},FUNCTION_TITLE=hljs.IDENT_RE+"\\s*\\(",CPP_KEYWORDS={keyword:"int float while private char catch export virtual operator sizeof dynamic_cast|10 typedef const_cast|10 const struct for static_cast|10 union namespace unsigned long volatile static protected bool template mutable if public friend do goto auto void enum else break extern using class asm case typeid short reinterpret_cast|10 default double register explicit signed typename try this switch continue inline delete alignof constexpr decltype noexcept static_assert thread_local restrict _Bool complex _Complex _Imaginary atomic_bool atomic_char atomic_schar atomic_uchar atomic_short atomic_ushort atomic_int atomic_uint atomic_long atomic_ulong atomic_llong atomic_ullong",built_in:"std string cin cout cerr clog stdin stdout stderr stringstream istringstream ostringstream auto_ptr deque list queue stack vector map set bitset multiset multimap unordered_set unordered_map unordered_multiset unordered_multimap array shared_ptr abort abs acos asin atan2 atan calloc ceil cosh cos exit exp fabs floor fmod fprintf fputs free frexp fscanf isalnum isalpha iscntrl isdigit isgraph islower isprint ispunct isspace isupper isxdigit tolower toupper labs ldexp log10 log malloc realloc memchr memcmp memcpy memset modf pow printf putchar puts scanf sinh sin snprintf sprintf sqrt sscanf strcat strchr strcmp strcpy strcspn strlen strncat strncmp strncpy strpbrk strrchr strspn strstr tanh tan vfprintf vprintf vsprintf",literal:"true false nullptr NULL"};return{aliases:["c","cc","h","c++","h++","hpp"],keywords:CPP_KEYWORDS,illegal:"</",contains:[CPP_PRIMATIVE_TYPES,hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,NUMBERS,STRINGS,PREPROCESSOR,{begin:"\\b(deque|list|queue|stack|vector|map|set|bitset|multiset|multimap|unordered_map|unordered_set|unordered_multiset|unordered_multimap|array)\\s*<",end:">",keywords:CPP_KEYWORDS,contains:["self",CPP_PRIMATIVE_TYPES]},{begin:hljs.IDENT_RE+"::",keywords:CPP_KEYWORDS},{beginKeywords:"new throw return else",relevance:0},{className:"function",begin:"("+hljs.IDENT_RE+"[\\*&\\s]+)+"+FUNCTION_TITLE,returnBegin:!0,end:/[{;=]/,excludeEnd:!0,keywords:CPP_KEYWORDS,illegal:/[^\w\s\*&]/,contains:[{begin:FUNCTION_TITLE,returnBegin:!0,contains:[hljs.TITLE_MODE],relevance:0},{className:"params",begin:/\(/,end:/\)/,keywords:CPP_KEYWORDS,relevance:0,contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,STRINGS,NUMBERS]},hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,PREPROCESSOR]}]}}),hljs.registerLanguage("crmsh",function(hljs){var RESOURCES="primitive rsc_template",COMMANDS="group clone ms master location colocation order fencing_topology rsc_ticket acl_target acl_group user role tag xml",PROPERTY_SETS="property rsc_defaults op_defaults",KEYWORDS="params meta operations op rule attributes utilization",OPERATORS="read write deny defined not_defined in_range date spec in ref reference attribute type xpath version and or lt gt tag lte gte eq ne \\",TYPES="number string",LITERALS="Master Started Slave Stopped start promote demote stop monitor true false";return{aliases:["crm","pcmk"],case_insensitive:!0,keywords:{keyword:KEYWORDS,operator:OPERATORS,type:TYPES,literal:LITERALS},contains:[hljs.HASH_COMMENT_MODE,{beginKeywords:"node",starts:{className:"identifier",end:"\\s*([\\w_-]+:)?",starts:{className:"title",end:"\\s*[\\$\\w_][\\w_-]*"}}},{beginKeywords:RESOURCES,starts:{className:"title",end:"\\s*[\\$\\w_][\\w_-]*",starts:{className:"pragma",end:"\\s*@?[\\w_][\\w_\\.:-]*"}}},{begin:"\\b("+COMMANDS.split(" ").join("|")+")\\s+",keywords:COMMANDS,starts:{className:"title",end:"[\\$\\w_][\\w_-]*"}},{beginKeywords:PROPERTY_SETS,starts:{className:"title",end:"\\s*([\\w_-]+:)?"}},hljs.QUOTE_STRING_MODE,{className:"pragma",begin:"(ocf|systemd|service|lsb):[\\w_:-]+",relevance:0},{className:"number",begin:"\\b\\d+(\\.\\d+)?(ms|s|h|m)?",relevance:0},{className:"number",begin:"[-]?(infinity|inf)",relevance:0},{className:"variable",begin:/([A-Za-z\$_\#][\w_-]+)=/,relevance:0},{className:"tag",begin:"</?",end:"/?>",relevance:0}]}}),hljs.registerLanguage("crystal",function(hljs){function recursiveParen(begin,end){var contains=[{begin:begin,end:end}];return contains[0].contains=contains,contains}var NUM_SUFFIX="(_[uif](8|16|32|64))?",CRYSTAL_IDENT_RE="[a-zA-Z_]\\w*[!?=]?",RE_STARTER="!=|!==|%|%=|&|&&|&=|\\*|\\*=|\\+|\\+=|,|-|-=|/=|/|:|;|<<|<<=|<=|<|===|==|=|>>>=|>>=|>=|>>>|>>|>|\\[|\\{|\\(|\\^|\\^=|\\||\\|=|\\|\\||~",CRYSTAL_METHOD_RE="[a-zA-Z_]\\w*[!?=]?|[-+~]\\@|<<|>>|=~|===?|<=>|[<>]=?|\\*\\*|[-/+%^&*~`|]|\\[\\][=?]?",CRYSTAL_KEYWORDS={keyword:"abstract alias as asm begin break case class def do else elsif end ensure enum extend for fun if ifdef include instance_sizeof is_a? lib macro module next of out pointerof private protected rescue responds_to? return require self sizeof struct super then type typeof union unless until when while with yield __DIR__ __FILE__ __LINE__",literal:"false nil true"},SUBST={className:"subst",begin:"#{",end:"}",keywords:CRYSTAL_KEYWORDS},EXPANSION={className:"expansion",variants:[{begin:"\\{\\{",end:"\\}\\}"},{begin:"\\{%",end:"%\\}"}],keywords:CRYSTAL_KEYWORDS,relevance:10},STRING={className:"string",contains:[hljs.BACKSLASH_ESCAPE,SUBST],variants:[{begin:/'/,end:/'/},{begin:/"/,end:/"/},{begin:/`/,end:/`/},{begin:"%w?\\(",end:"\\)",contains:recursiveParen("\\(","\\)")},{begin:"%w?\\[",end:"\\]",contains:recursiveParen("\\[","\\]")},{begin:"%w?{",end:"}",contains:recursiveParen("{","}")},{begin:"%w?<",end:">",contains:recursiveParen("<",">")},{begin:"%w?/",end:"/"},{begin:"%w?%",end:"%"},{begin:"%w?-",end:"-"},{begin:"%w?\\|",end:"\\|"}],relevance:0},REGEXP={begin:"("+RE_STARTER+")\\s*",contains:[{className:"regexp",contains:[hljs.BACKSLASH_ESCAPE,SUBST],variants:[{begin:"/",end:"/[a-z]*"},{begin:"%r\\(",end:"\\)",contains:recursiveParen("\\(","\\)")},{begin:"%r\\[",end:"\\]",contains:recursiveParen("\\[","\\]")},{begin:"%r{",end:"}",contains:recursiveParen("{","}")},{begin:"%r<",end:">",contains:recursiveParen("<",">")},{begin:"%r/",end:"/"},{begin:"%r%",end:"%"},{begin:"%r-",end:"-"},{begin:"%r\\|",end:"\\|"}]}],relevance:0},REGEXP2={className:"regexp",contains:[hljs.BACKSLASH_ESCAPE,SUBST],variants:[{begin:"%r\\(",end:"\\)",contains:recursiveParen("\\(","\\)")},{begin:"%r\\[",end:"\\]",contains:recursiveParen("\\[","\\]")},{begin:"%r{",end:"}",contains:recursiveParen("{","}")},{begin:"%r<",end:">",contains:recursiveParen("<",">")},{begin:"%r/",end:"/"},{begin:"%r%",end:"%"},{begin:"%r-",end:"-"},{begin:"%r\\|",end:"\\|"}],relevance:0},ATTRIBUTE={className:"annotation",begin:"@\\[",end:"\\]",relevance:5},CRYSTAL_DEFAULT_CONTAINS=[EXPANSION,STRING,REGEXP,REGEXP2,ATTRIBUTE,hljs.HASH_COMMENT_MODE,{className:"class",beginKeywords:"class module struct",end:"$|;",illegal:/=/,contains:[hljs.HASH_COMMENT_MODE,hljs.inherit(hljs.TITLE_MODE,{begin:"[A-Za-z_]\\w*(::\\w+)*(\\?|\\!)?"}),{className:"inheritance",begin:"<\\s*",contains:[{className:"parent",begin:"("+hljs.IDENT_RE+"::)?"+hljs.IDENT_RE}]}]},{className:"class",beginKeywords:"lib enum union",end:"$|;",illegal:/=/,contains:[hljs.HASH_COMMENT_MODE,hljs.inherit(hljs.TITLE_MODE,{begin:"[A-Za-z_]\\w*(::\\w+)*(\\?|\\!)?"})],relevance:10},{className:"function",beginKeywords:"def",end:/\B\b/,contains:[hljs.inherit(hljs.TITLE_MODE,{begin:CRYSTAL_METHOD_RE,endsParent:!0})]},{className:"function",beginKeywords:"fun macro",end:/\B\b/,contains:[hljs.inherit(hljs.TITLE_MODE,{begin:CRYSTAL_METHOD_RE,endsParent:!0})],relevance:5},{className:"constant",begin:"(::)?(\\b[A-Z]\\w*(::)?)+",relevance:0},{className:"symbol",begin:hljs.UNDERSCORE_IDENT_RE+"(\\!|\\?)?:",relevance:0},{className:"symbol",begin:":",contains:[STRING,{begin:CRYSTAL_METHOD_RE}],relevance:0},{className:"number",variants:[{begin:"\\b0b([01_]*[01])"+NUM_SUFFIX},{begin:"\\b0o([0-7_]*[0-7])"+NUM_SUFFIX},{begin:"\\b0x([A-Fa-f0-9_]*[A-Fa-f0-9])"+NUM_SUFFIX},{begin:"\\b(([0-9][0-9_]*[0-9]|[0-9])(\\.[0-9_]*[0-9])?([eE][+-]?[0-9_]*[0-9])?)"+NUM_SUFFIX}],relevance:0},{className:"variable",begin:"(\\$\\W)|((\\$|\\@\\@?|%)(\\w+))"}];return SUBST.contains=CRYSTAL_DEFAULT_CONTAINS,ATTRIBUTE.contains=CRYSTAL_DEFAULT_CONTAINS,EXPANSION.contains=CRYSTAL_DEFAULT_CONTAINS.slice(1),{aliases:["cr"],lexemes:CRYSTAL_IDENT_RE,keywords:CRYSTAL_KEYWORDS,contains:CRYSTAL_DEFAULT_CONTAINS}}),hljs.registerLanguage("cs",function(hljs){var KEYWORDS="abstract as base bool break byte case catch char checked const continue decimal dynamic default delegate do double else enum event explicit extern false finally fixed float for foreach goto if implicit in int interface internal is lock long null when object operator out override params private protected public readonly ref sbyte sealed short sizeof stackalloc static string struct switch this true try typeof uint ulong unchecked unsafe ushort using virtual volatile void while async protected public private internal ascending descending from get group into join let orderby partial select set value var where yield",GENERIC_IDENT_RE=hljs.IDENT_RE+"(<"+hljs.IDENT_RE+">)?";return{aliases:["csharp"],keywords:KEYWORDS,illegal:/::/,contains:[hljs.COMMENT("///","$",{returnBegin:!0,contains:[{className:"xmlDocTag",variants:[{begin:"///",relevance:0},{begin:"<!--|-->"},{begin:"</?",end:">"}]}]}),hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,{className:"preprocessor",begin:"#",end:"$",keywords:"if else elif endif define undef warning error line region endregion pragma checksum"},{className:"string",begin:'@"',end:'"',contains:[{begin:'""'}]},hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.C_NUMBER_MODE,{beginKeywords:"class interface",end:/[{;=]/,illegal:/[^\s:]/,contains:[hljs.TITLE_MODE,hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE]},{beginKeywords:"namespace",end:/[{;=]/,illegal:/[^\s:]/,contains:[{className:"title",begin:"[a-zA-Z](\\.?\\w)*",relevance:0},hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE]},{beginKeywords:"new return throw await",relevance:0},{className:"function",begin:"("+GENERIC_IDENT_RE+"\\s+)+"+hljs.IDENT_RE+"\\s*\\(",returnBegin:!0,end:/[{;=]/,excludeEnd:!0,keywords:KEYWORDS,contains:[{begin:hljs.IDENT_RE+"\\s*\\(",returnBegin:!0,contains:[hljs.TITLE_MODE],relevance:0},{className:"params",begin:/\(/,end:/\)/,excludeBegin:!0,excludeEnd:!0,keywords:KEYWORDS,relevance:0,contains:[hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.C_NUMBER_MODE,hljs.C_BLOCK_COMMENT_MODE]},hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE]}]}}),hljs.registerLanguage("css",function(hljs){var IDENT_RE="[a-zA-Z-][a-zA-Z0-9_-]*",FUNCTION={className:"function",begin:IDENT_RE+"\\(",returnBegin:!0,excludeEnd:!0,end:"\\("},RULE={className:"rule",begin:/[A-Z\_\.\-]+\s*:/,returnBegin:!0,end:";",endsWithParent:!0,contains:[{className:"attribute",begin:/\S/,end:":",excludeEnd:!0,starts:{className:"value",endsWithParent:!0,excludeEnd:!0,contains:[FUNCTION,hljs.CSS_NUMBER_MODE,hljs.QUOTE_STRING_MODE,hljs.APOS_STRING_MODE,hljs.C_BLOCK_COMMENT_MODE,{className:"hexcolor",begin:"#[0-9A-Fa-f]+"},{className:"important",begin:"!important"}]}}]};return{case_insensitive:!0,illegal:/[=\/|'\$]/,contains:[hljs.C_BLOCK_COMMENT_MODE,{className:"id",begin:/\#[A-Za-z0-9_-]+/},{className:"class",begin:/\.[A-Za-z0-9_-]+/},{className:"attr_selector",begin:/\[/,end:/\]/,illegal:"$"},{className:"pseudo",begin:/:(:)?[a-zA-Z0-9\_\-\+\(\)"']+/},{className:"at_rule",begin:"@(font-face|page)",lexemes:"[a-z-]+",keywords:"font-face page"},{className:"at_rule",begin:"@",end:"[{;]",contains:[{className:"keyword",begin:/\S+/},{begin:/\s/,endsWithParent:!0,excludeEnd:!0,relevance:0,contains:[FUNCTION,hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.CSS_NUMBER_MODE]}]},{className:"tag",begin:IDENT_RE,relevance:0},{className:"rules",begin:"{",end:"}",illegal:/\S/,contains:[hljs.C_BLOCK_COMMENT_MODE,RULE]}]}}),hljs.registerLanguage("d",function(hljs){var D_KEYWORDS={keyword:"abstract alias align asm assert auto body break byte case cast catch class const continue debug default delete deprecated do else enum export extern final finally for foreach foreach_reverse|10 goto if immutable import in inout int interface invariant is lazy macro mixin module new nothrow out override package pragma private protected public pure ref return scope shared static struct super switch synchronized template this throw try typedef typeid typeof union unittest version void volatile while with __FILE__ __LINE__ __gshared|10 __thread __traits __DATE__ __EOF__ __TIME__ __TIMESTAMP__ __VENDOR__ __VERSION__",built_in:"bool cdouble cent cfloat char creal dchar delegate double dstring float function idouble ifloat ireal long real short string ubyte ucent uint ulong ushort wchar wstring",literal:"false null true"
},decimal_integer_re="(0|[1-9][\\d_]*)",decimal_integer_nosus_re="(0|[1-9][\\d_]*|\\d[\\d_]*|[\\d_]+?\\d)",binary_integer_re="0[bB][01_]+",hexadecimal_digits_re="([\\da-fA-F][\\da-fA-F_]*|_[\\da-fA-F][\\da-fA-F_]*)",hexadecimal_integer_re="0[xX]"+hexadecimal_digits_re,decimal_exponent_re="([eE][+-]?"+decimal_integer_nosus_re+")",decimal_float_re="("+decimal_integer_nosus_re+"(\\.\\d*|"+decimal_exponent_re+")|\\d+\\."+decimal_integer_nosus_re+decimal_integer_nosus_re+"|\\."+decimal_integer_re+decimal_exponent_re+"?)",hexadecimal_float_re="(0[xX]("+hexadecimal_digits_re+"\\."+hexadecimal_digits_re+"|\\.?"+hexadecimal_digits_re+")[pP][+-]?"+decimal_integer_nosus_re+")",integer_re="("+decimal_integer_re+"|"+binary_integer_re+"|"+hexadecimal_integer_re+")",float_re="("+hexadecimal_float_re+"|"+decimal_float_re+")",escape_sequence_re="\\\\(['\"\\?\\\\abfnrtv]|u[\\dA-Fa-f]{4}|[0-7]{1,3}|x[\\dA-Fa-f]{2}|U[\\dA-Fa-f]{8})|&[a-zA-Z\\d]{2,};",D_INTEGER_MODE={className:"number",begin:"\\b"+integer_re+"(L|u|U|Lu|LU|uL|UL)?",relevance:0},D_FLOAT_MODE={className:"number",begin:"\\b("+float_re+"([fF]|L|i|[fF]i|Li)?|"+integer_re+"(i|[fF]i|Li))",relevance:0},D_CHARACTER_MODE={className:"string",begin:"'("+escape_sequence_re+"|.)",end:"'",illegal:"."},D_ESCAPE_SEQUENCE={begin:escape_sequence_re,relevance:0},D_STRING_MODE={className:"string",begin:'"',contains:[D_ESCAPE_SEQUENCE],end:'"[cwd]?'},D_WYSIWYG_DELIMITED_STRING_MODE={className:"string",begin:'[rq]"',end:'"[cwd]?',relevance:5},D_ALTERNATE_WYSIWYG_STRING_MODE={className:"string",begin:"`",end:"`[cwd]?"},D_HEX_STRING_MODE={className:"string",begin:'x"[\\da-fA-F\\s\\n\\r]*"[cwd]?',relevance:10},D_TOKEN_STRING_MODE={className:"string",begin:'q"\\{',end:'\\}"'},D_HASHBANG_MODE={className:"shebang",begin:"^#!",end:"$",relevance:5},D_SPECIAL_TOKEN_SEQUENCE_MODE={className:"preprocessor",begin:"#(line)",end:"$",relevance:5},D_ATTRIBUTE_MODE={className:"keyword",begin:"@[a-zA-Z_][a-zA-Z_\\d]*"},D_NESTING_COMMENT_MODE=hljs.COMMENT("\\/\\+","\\+\\/",{contains:["self"],relevance:10});return{lexemes:hljs.UNDERSCORE_IDENT_RE,keywords:D_KEYWORDS,contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,D_NESTING_COMMENT_MODE,D_HEX_STRING_MODE,D_STRING_MODE,D_WYSIWYG_DELIMITED_STRING_MODE,D_ALTERNATE_WYSIWYG_STRING_MODE,D_TOKEN_STRING_MODE,D_FLOAT_MODE,D_INTEGER_MODE,D_CHARACTER_MODE,D_HASHBANG_MODE,D_SPECIAL_TOKEN_SEQUENCE_MODE,D_ATTRIBUTE_MODE]}}),hljs.registerLanguage("markdown",function(hljs){return{aliases:["md","mkdown","mkd"],contains:[{className:"header",variants:[{begin:"^#{1,6}",end:"$"},{begin:"^.+?\\n[=-]{2,}$"}]},{begin:"<",end:">",subLanguage:"xml",relevance:0},{className:"bullet",begin:"^([*+-]|(\\d+\\.))\\s+"},{className:"strong",begin:"[*_]{2}.+?[*_]{2}"},{className:"emphasis",variants:[{begin:"\\*.+?\\*"},{begin:"_.+?_",relevance:0}]},{className:"blockquote",begin:"^>\\s+",end:"$"},{className:"code",variants:[{begin:"`.+?`"},{begin:"^( {4}|\t)",end:"$",relevance:0}]},{className:"horizontal_rule",begin:"^[-\\*]{3,}",end:"$"},{begin:"\\[.+?\\][\\(\\[].*?[\\)\\]]",returnBegin:!0,contains:[{className:"link_label",begin:"\\[",end:"\\]",excludeBegin:!0,returnEnd:!0,relevance:0},{className:"link_url",begin:"\\]\\(",end:"\\)",excludeBegin:!0,excludeEnd:!0},{className:"link_reference",begin:"\\]\\[",end:"\\]",excludeBegin:!0,excludeEnd:!0}],relevance:10},{begin:"^\\[.+\\]:",returnBegin:!0,contains:[{className:"link_reference",begin:"\\[",end:"\\]:",excludeBegin:!0,excludeEnd:!0,starts:{className:"link_url",end:"$"}}]}]}}),hljs.registerLanguage("dart",function(hljs){var SUBST={className:"subst",begin:"\\$\\{",end:"}",keywords:"true false null this is new super"},STRING={className:"string",variants:[{begin:"r'''",end:"'''"},{begin:'r"""',end:'"""'},{begin:"r'",end:"'",illegal:"\\n"},{begin:'r"',end:'"',illegal:"\\n"},{begin:"'''",end:"'''",contains:[hljs.BACKSLASH_ESCAPE,SUBST]},{begin:'"""',end:'"""',contains:[hljs.BACKSLASH_ESCAPE,SUBST]},{begin:"'",end:"'",illegal:"\\n",contains:[hljs.BACKSLASH_ESCAPE,SUBST]},{begin:'"',end:'"',illegal:"\\n",contains:[hljs.BACKSLASH_ESCAPE,SUBST]}]};SUBST.contains=[hljs.C_NUMBER_MODE,STRING];var KEYWORDS={keyword:"assert break case catch class const continue default do else enum extends false final finally for if in is new null rethrow return super switch this throw true try var void while with",literal:"abstract as dynamic export external factory get implements import library operator part set static typedef",built_in:"print Comparable DateTime Duration Function Iterable Iterator List Map Match Null Object Pattern RegExp Set Stopwatch String StringBuffer StringSink Symbol Type Uri bool double int num document window querySelector querySelectorAll Element ElementList"};return{keywords:KEYWORDS,contains:[STRING,hljs.COMMENT("/\\*\\*","\\*/",{subLanguage:"markdown"}),hljs.COMMENT("///","$",{subLanguage:"markdown"}),hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,{className:"class",beginKeywords:"class interface",end:"{",excludeEnd:!0,contains:[{beginKeywords:"extends implements"},hljs.UNDERSCORE_TITLE_MODE]},hljs.C_NUMBER_MODE,{className:"annotation",begin:"@[A-Za-z]+"},{begin:"=>"}]}}),hljs.registerLanguage("delphi",function(hljs){var KEYWORDS="exports register file shl array record property for mod while set ally label uses raise not stored class safecall var interface or private static exit index inherited to else stdcall override shr asm far resourcestring finalization packed virtual out and protected library do xorwrite goto near function end div overload object unit begin string on inline repeat until destructor write message program with read initialization except default nil if case cdecl in downto threadvar of try pascal const external constructor type public then implementation finally published procedure",COMMENT_MODES=[hljs.C_LINE_COMMENT_MODE,hljs.COMMENT(/\{/,/\}/,{relevance:0}),hljs.COMMENT(/\(\*/,/\*\)/,{relevance:10})],STRING={className:"string",begin:/'/,end:/'/,contains:[{begin:/''/}]},CHAR_STRING={className:"string",begin:/(#\d+)+/},CLASS={begin:hljs.IDENT_RE+"\\s*=\\s*class\\s*\\(",returnBegin:!0,contains:[hljs.TITLE_MODE]},FUNCTION={className:"function",beginKeywords:"function constructor destructor procedure",end:/[:;]/,keywords:"function constructor|10 destructor|10 procedure|10",contains:[hljs.TITLE_MODE,{className:"params",begin:/\(/,end:/\)/,keywords:KEYWORDS,contains:[STRING,CHAR_STRING]}].concat(COMMENT_MODES)};return{case_insensitive:!0,keywords:KEYWORDS,illegal:/"|\$[G-Zg-z]|\/\*|<\/|\|/,contains:[STRING,CHAR_STRING,hljs.NUMBER_MODE,CLASS,FUNCTION].concat(COMMENT_MODES)}}),hljs.registerLanguage("diff",function(hljs){return{aliases:["patch"],contains:[{className:"chunk",relevance:10,variants:[{begin:/^@@ +\-\d+,\d+ +\+\d+,\d+ +@@$/},{begin:/^\*\*\* +\d+,\d+ +\*\*\*\*$/},{begin:/^\-\-\- +\d+,\d+ +\-\-\-\-$/}]},{className:"header",variants:[{begin:/Index: /,end:/$/},{begin:/=====/,end:/=====$/},{begin:/^\-\-\-/,end:/$/},{begin:/^\*{3} /,end:/$/},{begin:/^\+\+\+/,end:/$/},{begin:/\*{5}/,end:/\*{5}$/}]},{className:"addition",begin:"^\\+",end:"$"},{className:"deletion",begin:"^\\-",end:"$"},{className:"change",begin:"^\\!",end:"$"}]}}),hljs.registerLanguage("django",function(hljs){var FILTER={className:"filter",begin:/\|[A-Za-z]+:?/,keywords:"truncatewords removetags linebreaksbr yesno get_digit timesince random striptags filesizeformat escape linebreaks length_is ljust rjust cut urlize fix_ampersands title floatformat capfirst pprint divisibleby add make_list unordered_list urlencode timeuntil urlizetrunc wordcount stringformat linenumbers slice date dictsort dictsortreversed default_if_none pluralize lower join center default truncatewords_html upper length phone2numeric wordwrap time addslashes slugify first escapejs force_escape iriencode last safe safeseq truncatechars localize unlocalize localtime utc timezone",contains:[{className:"argument",begin:/"/,end:/"/},{className:"argument",begin:/'/,end:/'/}]};return{aliases:["jinja"],case_insensitive:!0,subLanguage:"xml",contains:[hljs.COMMENT(/\{%\s*comment\s*%}/,/\{%\s*endcomment\s*%}/),hljs.COMMENT(/\{#/,/#}/),{className:"template_tag",begin:/\{%/,end:/%}/,keywords:"comment endcomment load templatetag ifchanged endifchanged if endif firstof for endfor in ifnotequal endifnotequal widthratio extends include spaceless endspaceless regroup by as ifequal endifequal ssi now with cycle url filter endfilter debug block endblock else autoescape endautoescape csrf_token empty elif endwith static trans blocktrans endblocktrans get_static_prefix get_media_prefix plural get_current_language language get_available_languages get_current_language_bidi get_language_info get_language_info_list localize endlocalize localtime endlocaltime timezone endtimezone get_current_timezone verbatim",contains:[FILTER]},{className:"variable",begin:/\{\{/,end:/}}/,contains:[FILTER]}]}}),hljs.registerLanguage("dns",function(hljs){return{aliases:["bind","zone"],keywords:{keyword:"IN A AAAA AFSDB APL CAA CDNSKEY CDS CERT CNAME DHCID DLV DNAME DNSKEY DS HIP IPSECKEY KEY KX LOC MX NAPTR NS NSEC NSEC3 NSEC3PARAM PTR RRSIG RP SIG SOA SRV SSHFP TA TKEY TLSA TSIG TXT"},contains:[hljs.COMMENT(";","$"),{className:"operator",beginKeywords:"$TTL $GENERATE $INCLUDE $ORIGIN"},{className:"number",begin:"((([0-9A-Fa-f]{1,4}:){7}([0-9A-Fa-f]{1,4}|:))|(([0-9A-Fa-f]{1,4}:){6}(:[0-9A-Fa-f]{1,4}|((25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)(\\.(25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){5}(((:[0-9A-Fa-f]{1,4}){1,2})|:((25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)(\\.(25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){4}(((:[0-9A-Fa-f]{1,4}){1,3})|((:[0-9A-Fa-f]{1,4})?:((25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)(\\.(25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){3}(((:[0-9A-Fa-f]{1,4}){1,4})|((:[0-9A-Fa-f]{1,4}){0,2}:((25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)(\\.(25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){2}(((:[0-9A-Fa-f]{1,4}){1,5})|((:[0-9A-Fa-f]{1,4}){0,3}:((25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)(\\.(25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){1}(((:[0-9A-Fa-f]{1,4}){1,6})|((:[0-9A-Fa-f]{1,4}){0,4}:((25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)(\\.(25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3}))|:))|(:(((:[0-9A-Fa-f]{1,4}){1,7})|((:[0-9A-Fa-f]{1,4}){0,5}:((25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)(\\.(25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3}))|:)))"},{className:"number",begin:"((25[0-5]|(2[0-4]|1{0,1}[0-9]){0,1}[0-9]).){3,3}(25[0-5]|(2[0-4]|1{0,1}[0-9]){0,1}[0-9])"}]}}),hljs.registerLanguage("dockerfile",function(hljs){return{aliases:["docker"],case_insensitive:!0,keywords:{built_ins:"from maintainer cmd expose add copy entrypoint volume user workdir onbuild run env label"},contains:[hljs.HASH_COMMENT_MODE,{keywords:{built_in:"run cmd entrypoint volume add copy workdir onbuild label"},begin:/^ *(onbuild +)?(run|cmd|entrypoint|volume|add|copy|workdir|label) +/,starts:{end:/[^\\]\n/,subLanguage:"bash"}},{keywords:{built_in:"from maintainer expose env user onbuild"},begin:/^ *(onbuild +)?(from|maintainer|expose|env|user|onbuild) +/,end:/[^\\]\n/,contains:[hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.NUMBER_MODE,hljs.HASH_COMMENT_MODE]}]}}),hljs.registerLanguage("dos",function(hljs){var COMMENT=hljs.COMMENT(/@?rem\b/,/$/,{relevance:10}),LABEL={className:"label",begin:"^\\s*[A-Za-z._?][A-Za-z0-9_$#@~.?]*(:|\\s+label)",relevance:0};return{aliases:["bat","cmd"],case_insensitive:!0,illegal:/\/\*/,keywords:{flow:"if else goto for in do call exit not exist errorlevel defined",operator:"equ neq lss leq gtr geq",keyword:"shift cd dir echo setlocal endlocal set pause copy",stream:"prn nul lpt3 lpt2 lpt1 con com4 com3 com2 com1 aux",winutils:"ping net ipconfig taskkill xcopy ren del",built_in:"append assoc at attrib break cacls cd chcp chdir chkdsk chkntfs cls cmd color comp compact convert date dir diskcomp diskcopy doskey erase fs find findstr format ftype graftabl help keyb label md mkdir mode more move path pause print popd pushd promt rd recover rem rename replace restore rmdir shiftsort start subst time title tree type ver verify vol"},contains:[{className:"envvar",begin:/%%[^ ]|%[^ ]+?%|![^ ]+?!/},{className:"function",begin:LABEL.begin,end:"goto:eof",contains:[hljs.inherit(hljs.TITLE_MODE,{begin:"([_a-zA-Z]\\w*\\.)*([_a-zA-Z]\\w*:)?[_a-zA-Z]\\w*"}),COMMENT]},{className:"number",begin:"\\b\\d+",relevance:0},COMMENT]}}),hljs.registerLanguage("dust",function(hljs){var EXPRESSION_KEYWORDS="if eq ne lt lte gt gte select default math sep";return{aliases:["dst"],case_insensitive:!0,subLanguage:"xml",contains:[{className:"expression",begin:"{",end:"}",relevance:0,contains:[{className:"begin-block",begin:"#[a-zA-Z- .]+",keywords:EXPRESSION_KEYWORDS},{className:"string",begin:'"',end:'"'},{className:"end-block",begin:"\\/[a-zA-Z- .]+",keywords:EXPRESSION_KEYWORDS},{className:"variable",begin:"[a-zA-Z-.]+",keywords:EXPRESSION_KEYWORDS,relevance:0}]}]}}),hljs.registerLanguage("elixir",function(hljs){var ELIXIR_IDENT_RE="[a-zA-Z_][a-zA-Z0-9_]*(\\!|\\?)?",ELIXIR_METHOD_RE="[a-zA-Z_]\\w*[!?=]?|[-+~]\\@|<<|>>|=~|===?|<=>|[<>]=?|\\*\\*|[-/+%^&*~`|]|\\[\\]=?",ELIXIR_KEYWORDS="and false then defined module in return redo retry end for true self when next until do begin unless nil break not case cond alias while ensure or include use alias fn quote",SUBST={className:"subst",begin:"#\\{",end:"}",lexemes:ELIXIR_IDENT_RE,keywords:ELIXIR_KEYWORDS},STRING={className:"string",contains:[hljs.BACKSLASH_ESCAPE,SUBST],variants:[{begin:/'/,end:/'/},{begin:/"/,end:/"/}]},FUNCTION={className:"function",beginKeywords:"def defp defmacro",end:/\B\b/,contains:[hljs.inherit(hljs.TITLE_MODE,{begin:ELIXIR_IDENT_RE,endsParent:!0})]},CLASS=hljs.inherit(FUNCTION,{className:"class",beginKeywords:"defmodule defrecord",end:/\bdo\b|$|;/}),ELIXIR_DEFAULT_CONTAINS=[STRING,hljs.HASH_COMMENT_MODE,CLASS,FUNCTION,{className:"constant",begin:"(\\b[A-Z_]\\w*(.)?)+",relevance:0},{className:"symbol",begin:":",contains:[STRING,{begin:ELIXIR_METHOD_RE}],relevance:0},{className:"symbol",begin:ELIXIR_IDENT_RE+":",relevance:0},{className:"number",begin:"(\\b0[0-7_]+)|(\\b0x[0-9a-fA-F_]+)|(\\b[1-9][0-9_]*(\\.[0-9_]+)?)|[0_]\\b",relevance:0},{className:"variable",begin:"(\\$\\W)|((\\$|\\@\\@?)(\\w+))"},{begin:"->"},{begin:"("+hljs.RE_STARTERS_RE+")\\s*",contains:[hljs.HASH_COMMENT_MODE,{className:"regexp",illegal:"\\n",contains:[hljs.BACKSLASH_ESCAPE,SUBST],variants:[{begin:"/",end:"/[a-z]*"},{begin:"%r\\[",end:"\\][a-z]*"}]}],relevance:0}];return SUBST.contains=ELIXIR_DEFAULT_CONTAINS,{lexemes:ELIXIR_IDENT_RE,keywords:ELIXIR_KEYWORDS,contains:ELIXIR_DEFAULT_CONTAINS}}),hljs.registerLanguage("elm",function(hljs){var COMMENT_MODES=[hljs.COMMENT("--","$"),hljs.COMMENT("{-","-}",{contains:["self"]})],CONSTRUCTOR={className:"type",begin:"\\b[A-Z][\\w']*",relevance:0},LIST={className:"container",begin:"\\(",end:"\\)",illegal:'"',contains:[{className:"type",begin:"\\b[A-Z][\\w]*(\\((\\.\\.|,|\\w+)\\))?"}].concat(COMMENT_MODES)},RECORD={className:"container",begin:"{",end:"}",contains:LIST.contains};return{keywords:"let in if then else case of where module import exposing type alias as infix infixl infixr port",contains:[{className:"module",begin:"\\bmodule\\b",end:"where",keywords:"module where",contains:[LIST].concat(COMMENT_MODES),illegal:"\\W\\.|;"},{className:"import",begin:"\\bimport\\b",end:"$",keywords:"import|0 as exposing",contains:[LIST].concat(COMMENT_MODES),illegal:"\\W\\.|;"},{className:"typedef",begin:"\\btype\\b",end:"$",keywords:"type alias",contains:[CONSTRUCTOR,LIST,RECORD].concat(COMMENT_MODES)},{className:"infix",beginKeywords:"infix infixl infixr",end:"$",contains:[hljs.C_NUMBER_MODE].concat(COMMENT_MODES)},{className:"foreign",begin:"\\bport\\b",end:"$",keywords:"port",contains:COMMENT_MODES},hljs.QUOTE_STRING_MODE,hljs.C_NUMBER_MODE,CONSTRUCTOR,hljs.inherit(hljs.TITLE_MODE,{begin:"^[_a-z][\\w']*"}),{begin:"->|<-"}].concat(COMMENT_MODES)}}),hljs.registerLanguage("ruby",function(hljs){var RUBY_METHOD_RE="[a-zA-Z_]\\w*[!?=]?|[-+~]\\@|<<|>>|=~|===?|<=>|[<>]=?|\\*\\*|[-/+%^&*~`|]|\\[\\]=?",RUBY_KEYWORDS="and false then defined module in return redo if BEGIN retry end for true self when next until do begin unless END rescue nil else break undef not super class case require yield alias while ensure elsif or include attr_reader attr_writer attr_accessor",YARDOCTAG={className:"doctag",begin:"@[A-Za-z]+"},IRB_OBJECT={className:"value",begin:"#<",end:">"},COMMENT_MODES=[hljs.COMMENT("#","$",{contains:[YARDOCTAG]}),hljs.COMMENT("^\\=begin","^\\=end",{contains:[YARDOCTAG],relevance:10}),hljs.COMMENT("^__END__","\\n$")],SUBST={className:"subst",begin:"#\\{",end:"}",keywords:RUBY_KEYWORDS},STRING={className:"string",contains:[hljs.BACKSLASH_ESCAPE,SUBST],variants:[{begin:/'/,end:/'/},{begin:/"/,end:/"/},{begin:/`/,end:/`/},{begin:"%[qQwWx]?\\(",end:"\\)"},{begin:"%[qQwWx]?\\[",end:"\\]"},{begin:"%[qQwWx]?{",end:"}"},{begin:"%[qQwWx]?<",end:">"},{begin:"%[qQwWx]?/",end:"/"},{begin:"%[qQwWx]?%",end:"%"},{begin:"%[qQwWx]?-",end:"-"},{begin:"%[qQwWx]?\\|",end:"\\|"},{begin:/\B\?(\\\d{1,3}|\\x[A-Fa-f0-9]{1,2}|\\u[A-Fa-f0-9]{4}|\\?\S)\b/}]},PARAMS={className:"params",begin:"\\(",end:"\\)",keywords:RUBY_KEYWORDS},RUBY_DEFAULT_CONTAINS=[STRING,IRB_OBJECT,{className:"class",beginKeywords:"class module",end:"$|;",illegal:/=/,contains:[hljs.inherit(hljs.TITLE_MODE,{begin:"[A-Za-z_]\\w*(::\\w+)*(\\?|\\!)?"}),{className:"inheritance",begin:"<\\s*",contains:[{className:"parent",begin:"("+hljs.IDENT_RE+"::)?"+hljs.IDENT_RE}]}].concat(COMMENT_MODES)},{className:"function",beginKeywords:"def",end:"$|;",contains:[hljs.inherit(hljs.TITLE_MODE,{begin:RUBY_METHOD_RE}),PARAMS].concat(COMMENT_MODES)},{className:"constant",begin:"(::)?(\\b[A-Z]\\w*(::)?)+",relevance:0},{className:"symbol",begin:hljs.UNDERSCORE_IDENT_RE+"(\\!|\\?)?:",relevance:0},{className:"symbol",begin:":",contains:[STRING,{begin:RUBY_METHOD_RE}],relevance:0},{className:"number",begin:"(\\b0[0-7_]+)|(\\b0x[0-9a-fA-F_]+)|(\\b[1-9][0-9_]*(\\.[0-9_]+)?)|[0_]\\b",relevance:0},{className:"variable",begin:"(\\$\\W)|((\\$|\\@\\@?)(\\w+))"},{begin:"("+hljs.RE_STARTERS_RE+")\\s*",contains:[IRB_OBJECT,{className:"regexp",contains:[hljs.BACKSLASH_ESCAPE,SUBST],illegal:/\n/,variants:[{begin:"/",end:"/[a-z]*"},{begin:"%r{",end:"}[a-z]*"},{begin:"%r\\(",end:"\\)[a-z]*"},{begin:"%r!",end:"![a-z]*"},{begin:"%r\\[",end:"\\][a-z]*"}]}].concat(COMMENT_MODES),relevance:0}].concat(COMMENT_MODES);SUBST.contains=RUBY_DEFAULT_CONTAINS,PARAMS.contains=RUBY_DEFAULT_CONTAINS;var SIMPLE_PROMPT="[>?]>",DEFAULT_PROMPT="[\\w#]+\\(\\w+\\):\\d+:\\d+>",RVM_PROMPT="(\\w+-)?\\d+\\.\\d+\\.\\d(p\\d+)?[^>]+>",IRB_DEFAULT=[{begin:/^\s*=>/,className:"status",starts:{end:"$",contains:RUBY_DEFAULT_CONTAINS}},{className:"prompt",begin:"^("+SIMPLE_PROMPT+"|"+DEFAULT_PROMPT+"|"+RVM_PROMPT+")",starts:{end:"$",contains:RUBY_DEFAULT_CONTAINS}}];return{aliases:["rb","gemspec","podspec","thor","irb"],keywords:RUBY_KEYWORDS,illegal:/\/\*/,contains:COMMENT_MODES.concat(IRB_DEFAULT).concat(RUBY_DEFAULT_CONTAINS)}}),hljs.registerLanguage("erb",function(hljs){return{subLanguage:"xml",contains:[hljs.COMMENT("<%#","%>"),{begin:"<%[%=-]?",end:"[%-]?%>",subLanguage:"ruby",excludeBegin:!0,excludeEnd:!0}]}}),hljs.registerLanguage("erlang-repl",function(hljs){return{keywords:{special_functions:"spawn spawn_link self",reserved:"after and andalso|10 band begin bnot bor bsl bsr bxor case catch cond div end fun if let not of or orelse|10 query receive rem try when xor"},contains:[{className:"prompt",begin:"^[0-9]+> ",relevance:10},hljs.COMMENT("%","$"),{className:"number",begin:"\\b(\\d+#[a-fA-F0-9]+|\\d+(\\.\\d+)?([eE][-+]?\\d+)?)",relevance:0},hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,{className:"constant",begin:"\\?(::)?([A-Z]\\w*(::)?)+"},{className:"arrow",begin:"->"},{className:"ok",begin:"ok"},{className:"exclamation_mark",begin:"!"},{className:"function_or_atom",begin:"(\\b[a-z'][a-zA-Z0-9_']*:[a-z'][a-zA-Z0-9_']*)|(\\b[a-z'][a-zA-Z0-9_']*)",relevance:0},{className:"variable",begin:"[A-Z][a-zA-Z0-9_']*",relevance:0}]}}),hljs.registerLanguage("erlang",function(hljs){var BASIC_ATOM_RE="[a-z'][a-zA-Z0-9_']*",FUNCTION_NAME_RE="("+BASIC_ATOM_RE+":"+BASIC_ATOM_RE+"|"+BASIC_ATOM_RE+")",ERLANG_RESERVED={keyword:"after and andalso|10 band begin bnot bor bsl bzr bxor case catch cond div end fun if let not of orelse|10 query receive rem try when xor",literal:"false true"},COMMENT=hljs.COMMENT("%","$"),NUMBER={className:"number",begin:"\\b(\\d+#[a-fA-F0-9]+|\\d+(\\.\\d+)?([eE][-+]?\\d+)?)",relevance:0},NAMED_FUN={begin:"fun\\s+"+BASIC_ATOM_RE+"/\\d+"},FUNCTION_CALL={begin:FUNCTION_NAME_RE+"\\(",end:"\\)",returnBegin:!0,relevance:0,contains:[{className:"function_name",begin:FUNCTION_NAME_RE,relevance:0},{begin:"\\(",end:"\\)",endsWithParent:!0,returnEnd:!0,relevance:0}]},TUPLE={className:"tuple",begin:"{",end:"}",relevance:0},VAR1={className:"variable",begin:"\\b_([A-Z][A-Za-z0-9_]*)?",relevance:0},VAR2={className:"variable",begin:"[A-Z][a-zA-Z0-9_]*",relevance:0},RECORD_ACCESS={begin:"#"+hljs.UNDERSCORE_IDENT_RE,relevance:0,returnBegin:!0,contains:[{className:"record_name",begin:"#"+hljs.UNDERSCORE_IDENT_RE,relevance:0},{begin:"{",end:"}",relevance:0}]},BLOCK_STATEMENTS={beginKeywords:"fun receive if try case",end:"end",keywords:ERLANG_RESERVED};BLOCK_STATEMENTS.contains=[COMMENT,NAMED_FUN,hljs.inherit(hljs.APOS_STRING_MODE,{className:""}),BLOCK_STATEMENTS,FUNCTION_CALL,hljs.QUOTE_STRING_MODE,NUMBER,TUPLE,VAR1,VAR2,RECORD_ACCESS];var BASIC_MODES=[COMMENT,NAMED_FUN,BLOCK_STATEMENTS,FUNCTION_CALL,hljs.QUOTE_STRING_MODE,NUMBER,TUPLE,VAR1,VAR2,RECORD_ACCESS];FUNCTION_CALL.contains[1].contains=BASIC_MODES,TUPLE.contains=BASIC_MODES,RECORD_ACCESS.contains[1].contains=BASIC_MODES;var PARAMS={className:"params",begin:"\\(",end:"\\)",contains:BASIC_MODES};return{aliases:["erl"],keywords:ERLANG_RESERVED,illegal:"(</|\\*=|\\+=|-=|/\\*|\\*/|\\(\\*|\\*\\))",contains:[{className:"function",begin:"^"+BASIC_ATOM_RE+"\\s*\\(",end:"->",returnBegin:!0,illegal:"\\(|#|//|/\\*|\\\\|:|;",contains:[PARAMS,hljs.inherit(hljs.TITLE_MODE,{begin:BASIC_ATOM_RE})],starts:{end:";|\\.",keywords:ERLANG_RESERVED,contains:BASIC_MODES}},COMMENT,{className:"pp",begin:"^-",end:"\\.",relevance:0,excludeEnd:!0,returnBegin:!0,lexemes:"-"+hljs.IDENT_RE,keywords:"-module -record -undef -export -ifdef -ifndef -author -copyright -doc -vsn -import -include -include_lib -compile -define -else -endif -file -behaviour -behavior -spec",contains:[PARAMS]},NUMBER,hljs.QUOTE_STRING_MODE,RECORD_ACCESS,VAR1,VAR2,TUPLE,{begin:/\.$/}]}}),hljs.registerLanguage("fix",function(hljs){return{contains:[{begin:/[^\u2401\u0001]+/,end:/[\u2401\u0001]/,excludeEnd:!0,returnBegin:!0,returnEnd:!1,contains:[{begin:/([^\u2401\u0001=]+)/,end:/=([^\u2401\u0001=]+)/,returnEnd:!0,returnBegin:!1,className:"attribute"},{begin:/=/,end:/([\u2401\u0001])/,excludeEnd:!0,excludeBegin:!0,className:"string"}]}],case_insensitive:!0}}),hljs.registerLanguage("fortran",function(hljs){var PARAMS={className:"params",begin:"\\(",end:"\\)"},F_KEYWORDS={constant:".False. .True.",type:"integer real character complex logical dimension allocatable|10 parameter external implicit|10 none double precision assign intent optional pointer target in out common equivalence data",keyword:"kind do while private call intrinsic where elsewhere type endtype endmodule endselect endinterface end enddo endif if forall endforall only contains default return stop then public subroutine|10 function program .and. .or. .not. .le. .eq. .ge. .gt. .lt. goto save else use module select case access blank direct exist file fmt form formatted iostat name named nextrec number opened rec recl sequential status unformatted unit continue format pause cycle exit c_null_char c_alert c_backspace c_form_feed flush wait decimal round iomsg synchronous nopass non_overridable pass protected volatile abstract extends import non_intrinsic value deferred generic final enumerator class associate bind enum c_int c_short c_long c_long_long c_signed_char c_size_t c_int8_t c_int16_t c_int32_t c_int64_t c_int_least8_t c_int_least16_t c_int_least32_t c_int_least64_t c_int_fast8_t c_int_fast16_t c_int_fast32_t c_int_fast64_t c_intmax_t C_intptr_t c_float c_double c_long_double c_float_complex c_double_complex c_long_double_complex c_bool c_char c_null_ptr c_null_funptr c_new_line c_carriage_return c_horizontal_tab c_vertical_tab iso_c_binding c_loc c_funloc c_associated  c_f_pointer c_ptr c_funptr iso_fortran_env character_storage_size error_unit file_storage_size input_unit iostat_end iostat_eor numeric_storage_size output_unit c_f_procpointer ieee_arithmetic ieee_support_underflow_control ieee_get_underflow_mode ieee_set_underflow_mode newunit contiguous recursive pad position action delim readwrite eor advance nml interface procedure namelist include sequence elemental pure",built_in:"alog alog10 amax0 amax1 amin0 amin1 amod cabs ccos cexp clog csin csqrt dabs dacos dasin datan datan2 dcos dcosh ddim dexp dint dlog dlog10 dmax1 dmin1 dmod dnint dsign dsin dsinh dsqrt dtan dtanh float iabs idim idint idnint ifix isign max0 max1 min0 min1 sngl algama cdabs cdcos cdexp cdlog cdsin cdsqrt cqabs cqcos cqexp cqlog cqsin cqsqrt dcmplx dconjg derf derfc dfloat dgamma dimag dlgama iqint qabs qacos qasin qatan qatan2 qcmplx qconjg qcos qcosh qdim qerf qerfc qexp qgamma qimag qlgama qlog qlog10 qmax1 qmin1 qmod qnint qsign qsin qsinh qsqrt qtan qtanh abs acos aimag aint anint asin atan atan2 char cmplx conjg cos cosh exp ichar index int log log10 max min nint sign sin sinh sqrt tan tanh print write dim lge lgt lle llt mod nullify allocate deallocate adjustl adjustr all allocated any associated bit_size btest ceiling count cshift date_and_time digits dot_product eoshift epsilon exponent floor fraction huge iand ibclr ibits ibset ieor ior ishft ishftc lbound len_trim matmul maxexponent maxloc maxval merge minexponent minloc minval modulo mvbits nearest pack present product radix random_number random_seed range repeat reshape rrspacing scale scan selected_int_kind selected_real_kind set_exponent shape size spacing spread sum system_clock tiny transpose trim ubound unpack verify achar iachar transfer dble entry dprod cpu_time command_argument_count get_command get_command_argument get_environment_variable is_iostat_end ieee_arithmetic ieee_support_underflow_control ieee_get_underflow_mode ieee_set_underflow_mode is_iostat_eor move_alloc new_line selected_char_kind same_type_as extends_type_ofacosh asinh atanh bessel_j0 bessel_j1 bessel_jn bessel_y0 bessel_y1 bessel_yn erf erfc erfc_scaled gamma log_gamma hypot norm2 atomic_define atomic_ref execute_command_line leadz trailz storage_size merge_bits bge bgt ble blt dshiftl dshiftr findloc iall iany iparity image_index lcobound ucobound maskl maskr num_images parity popcnt poppar shifta shiftl shiftr this_image"};return{case_insensitive:!0,aliases:["f90","f95"],keywords:F_KEYWORDS,illegal:/\/\*/,contains:[hljs.inherit(hljs.APOS_STRING_MODE,{className:"string",relevance:0}),hljs.inherit(hljs.QUOTE_STRING_MODE,{className:"string",relevance:0}),{className:"function",beginKeywords:"subroutine function program",illegal:"[${=\\n]",contains:[hljs.UNDERSCORE_TITLE_MODE,PARAMS]},hljs.COMMENT("!","$",{relevance:0}),{className:"number",begin:"(?=\\b|\\+|\\-|\\.)(?=\\.\\d|\\d)(?:\\d+)?(?:\\.?\\d*)(?:[de][+-]?\\d+)?\\b\\.?",relevance:0}]}}),hljs.registerLanguage("fsharp",function(hljs){var TYPEPARAM={begin:"<",end:">",contains:[hljs.inherit(hljs.TITLE_MODE,{begin:/'[a-zA-Z0-9_]+/})]};return{aliases:["fs"],keywords:"abstract and as assert base begin class default delegate do done downcast downto elif else end exception extern false finally for fun function global if in inherit inline interface internal lazy let match member module mutable namespace new null of open or override private public rec return sig static struct then to true try type upcast use val void when while with yield",illegal:/\/\*/,contains:[{className:"keyword",begin:/\b(yield|return|let|do)!/},{className:"string",begin:'@"',end:'"',contains:[{begin:'""'}]},{className:"string",begin:'"""',end:'"""'},hljs.COMMENT("\\(\\*","\\*\\)"),{className:"class",beginKeywords:"type",end:"\\(|=|$",excludeEnd:!0,contains:[hljs.UNDERSCORE_TITLE_MODE,TYPEPARAM]},{className:"annotation",begin:"\\[<",end:">\\]",relevance:10},{className:"attribute",begin:"\\B('[A-Za-z])\\b",contains:[hljs.BACKSLASH_ESCAPE]},hljs.C_LINE_COMMENT_MODE,hljs.inherit(hljs.QUOTE_STRING_MODE,{illegal:null}),hljs.C_NUMBER_MODE]}}),hljs.registerLanguage("gams",function(hljs){var KEYWORDS="abort acronym acronyms alias all and assign binary card diag display else1 eps eq equation equations file files for1 free ge gt if inf integer le loop lt maximizing minimizing model models na ne negative no not option options or ord parameter parameters positive prod putpage puttl repeat sameas scalar scalars semicont semiint set1 sets smax smin solve sos1 sos2 sum system table then until using variable variables while1 xor yes";return{aliases:["gms"],case_insensitive:!0,keywords:KEYWORDS,contains:[{className:"section",beginKeywords:"sets parameters variables equations",end:";",contains:[{begin:"/",end:"/",contains:[hljs.NUMBER_MODE]}]},{className:"string",begin:"\\*{3}",end:"\\*{3}"},hljs.NUMBER_MODE,{className:"number",begin:"\\$[a-zA-Z0-9]+"}]}}),hljs.registerLanguage("gcode",function(hljs){var GCODE_IDENT_RE="[A-Z_][A-Z0-9_.]*",GCODE_CLOSE_RE="\\%",GCODE_KEYWORDS={literal:"",built_in:"",keyword:"IF DO WHILE ENDWHILE CALL ENDIF SUB ENDSUB GOTO REPEAT ENDREPEAT EQ LT GT NE GE LE OR XOR"},GCODE_START={className:"preprocessor",begin:"([O])([0-9]+)"},GCODE_CODE=[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,hljs.COMMENT(/\(/,/\)/),hljs.inherit(hljs.C_NUMBER_MODE,{begin:"([-+]?([0-9]*\\.?[0-9]+\\.?))|"+hljs.C_NUMBER_RE}),hljs.inherit(hljs.APOS_STRING_MODE,{illegal:null}),hljs.inherit(hljs.QUOTE_STRING_MODE,{illegal:null}),{className:"keyword",begin:"([G])([0-9]+\\.?[0-9]?)"},{className:"title",begin:"([M])([0-9]+\\.?[0-9]?)"},{className:"title",begin:"(VC|VS|#)",end:"(\\d+)"},{className:"title",begin:"(VZOFX|VZOFY|VZOFZ)"},{className:"built_in",begin:"(ATAN|ABS|ACOS|ASIN|SIN|COS|EXP|FIX|FUP|ROUND|LN|TAN)(\\[)",end:"([-+]?([0-9]*\\.?[0-9]+\\.?))(\\])"},{className:"label",variants:[{begin:"N",end:"\\d+",illegal:"\\W"}]}];return{aliases:["nc"],case_insensitive:!0,lexemes:GCODE_IDENT_RE,keywords:GCODE_KEYWORDS,contains:[{className:"preprocessor",begin:GCODE_CLOSE_RE},GCODE_START].concat(GCODE_CODE)}}),hljs.registerLanguage("gherkin",function(hljs){return{aliases:["feature"],keywords:"Feature Background Ability Business Need Scenario Scenarios Scenario Outline Scenario Template Examples Given And Then But When",contains:[{className:"keyword",begin:"\\*"},hljs.COMMENT("@[^@\r\n\t ]+","$"),{begin:"\\|",end:"\\|\\w*$",contains:[{className:"string",begin:"[^|]+"}]},{className:"variable",begin:"<",end:">"},hljs.HASH_COMMENT_MODE,{className:"string",begin:'"""',end:'"""'},hljs.QUOTE_STRING_MODE]}}),hljs.registerLanguage("glsl",function(hljs){return{keywords:{keyword:"atomic_uint attribute bool break bvec2 bvec3 bvec4 case centroid coherent const continue default discard dmat2 dmat2x2 dmat2x3 dmat2x4 dmat3 dmat3x2 dmat3x3 dmat3x4 dmat4 dmat4x2 dmat4x3 dmat4x4 do double dvec2 dvec3 dvec4 else flat float for highp if iimage1D iimage1DArray iimage2D iimage2DArray iimage2DMS iimage2DMSArray iimage2DRect iimage3D iimageBuffer iimageCube iimageCubeArray image1D image1DArray image2D image2DArray image2DMS image2DMSArray image2DRect image3D imageBuffer imageCube imageCubeArray in inout int invariant isampler1D isampler1DArray isampler2D isampler2DArray isampler2DMS isampler2DMSArray isampler2DRect isampler3D isamplerBuffer isamplerCube isamplerCubeArray ivec2 ivec3 ivec4 layout lowp mat2 mat2x2 mat2x3 mat2x4 mat3 mat3x2 mat3x3 mat3x4 mat4 mat4x2 mat4x3 mat4x4 mediump noperspective out patch precision readonly restrict return sample sampler1D sampler1DArray sampler1DArrayShadow sampler1DShadow sampler2D sampler2DArray sampler2DArrayShadow sampler2DMS sampler2DMSArray sampler2DRect sampler2DRectShadow sampler2DShadow sampler3D samplerBuffer samplerCube samplerCubeArray samplerCubeArrayShadow samplerCubeShadow smooth struct subroutine switch uimage1D uimage1DArray uimage2D uimage2DArray uimage2DMS uimage2DMSArray uimage2DRect uimage3D uimageBuffer uimageCube uimageCubeArray uint uniform usampler1D usampler1DArray usampler2D usampler2DArray usampler2DMS usampler2DMSArray usampler2DRect usampler3D usamplerBuffer usamplerCube usamplerCubeArray uvec2 uvec3 uvec4 varying vec2 vec3 vec4 void volatile while writeonly",
built_in:"gl_BackColor gl_BackLightModelProduct gl_BackLightProduct gl_BackMaterial gl_BackSecondaryColor gl_ClipDistance gl_ClipPlane gl_ClipVertex gl_Color gl_DepthRange gl_EyePlaneQ gl_EyePlaneR gl_EyePlaneS gl_EyePlaneT gl_Fog gl_FogCoord gl_FogFragCoord gl_FragColor gl_FragCoord gl_FragData gl_FragDepth gl_FrontColor gl_FrontFacing gl_FrontLightModelProduct gl_FrontLightProduct gl_FrontMaterial gl_FrontSecondaryColor gl_InstanceID gl_InvocationID gl_Layer gl_LightModel gl_LightSource gl_MaxAtomicCounterBindings gl_MaxAtomicCounterBufferSize gl_MaxClipDistances gl_MaxClipPlanes gl_MaxCombinedAtomicCounterBuffers gl_MaxCombinedAtomicCounters gl_MaxCombinedImageUniforms gl_MaxCombinedImageUnitsAndFragmentOutputs gl_MaxCombinedTextureImageUnits gl_MaxDrawBuffers gl_MaxFragmentAtomicCounterBuffers gl_MaxFragmentAtomicCounters gl_MaxFragmentImageUniforms gl_MaxFragmentInputComponents gl_MaxFragmentUniformComponents gl_MaxFragmentUniformVectors gl_MaxGeometryAtomicCounterBuffers gl_MaxGeometryAtomicCounters gl_MaxGeometryImageUniforms gl_MaxGeometryInputComponents gl_MaxGeometryOutputComponents gl_MaxGeometryOutputVertices gl_MaxGeometryTextureImageUnits gl_MaxGeometryTotalOutputComponents gl_MaxGeometryUniformComponents gl_MaxGeometryVaryingComponents gl_MaxImageSamples gl_MaxImageUnits gl_MaxLights gl_MaxPatchVertices gl_MaxProgramTexelOffset gl_MaxTessControlAtomicCounterBuffers gl_MaxTessControlAtomicCounters gl_MaxTessControlImageUniforms gl_MaxTessControlInputComponents gl_MaxTessControlOutputComponents gl_MaxTessControlTextureImageUnits gl_MaxTessControlTotalOutputComponents gl_MaxTessControlUniformComponents gl_MaxTessEvaluationAtomicCounterBuffers gl_MaxTessEvaluationAtomicCounters gl_MaxTessEvaluationImageUniforms gl_MaxTessEvaluationInputComponents gl_MaxTessEvaluationOutputComponents gl_MaxTessEvaluationTextureImageUnits gl_MaxTessEvaluationUniformComponents gl_MaxTessGenLevel gl_MaxTessPatchComponents gl_MaxTextureCoords gl_MaxTextureImageUnits gl_MaxTextureUnits gl_MaxVaryingComponents gl_MaxVaryingFloats gl_MaxVaryingVectors gl_MaxVertexAtomicCounterBuffers gl_MaxVertexAtomicCounters gl_MaxVertexAttribs gl_MaxVertexImageUniforms gl_MaxVertexOutputComponents gl_MaxVertexTextureImageUnits gl_MaxVertexUniformComponents gl_MaxVertexUniformVectors gl_MaxViewports gl_MinProgramTexelOffsetgl_ModelViewMatrix gl_ModelViewMatrixInverse gl_ModelViewMatrixInverseTranspose gl_ModelViewMatrixTranspose gl_ModelViewProjectionMatrix gl_ModelViewProjectionMatrixInverse gl_ModelViewProjectionMatrixInverseTranspose gl_ModelViewProjectionMatrixTranspose gl_MultiTexCoord0 gl_MultiTexCoord1 gl_MultiTexCoord2 gl_MultiTexCoord3 gl_MultiTexCoord4 gl_MultiTexCoord5 gl_MultiTexCoord6 gl_MultiTexCoord7 gl_Normal gl_NormalMatrix gl_NormalScale gl_ObjectPlaneQ gl_ObjectPlaneR gl_ObjectPlaneS gl_ObjectPlaneT gl_PatchVerticesIn gl_PerVertex gl_Point gl_PointCoord gl_PointSize gl_Position gl_PrimitiveID gl_PrimitiveIDIn gl_ProjectionMatrix gl_ProjectionMatrixInverse gl_ProjectionMatrixInverseTranspose gl_ProjectionMatrixTranspose gl_SampleID gl_SampleMask gl_SampleMaskIn gl_SamplePosition gl_SecondaryColor gl_TessCoord gl_TessLevelInner gl_TessLevelOuter gl_TexCoord gl_TextureEnvColor gl_TextureMatrixInverseTranspose gl_TextureMatrixTranspose gl_Vertex gl_VertexID gl_ViewportIndex gl_in gl_out EmitStreamVertex EmitVertex EndPrimitive EndStreamPrimitive abs acos acosh all any asin asinh atan atanh atomicCounter atomicCounterDecrement atomicCounterIncrement barrier bitCount bitfieldExtract bitfieldInsert bitfieldReverse ceil clamp cos cosh cross dFdx dFdy degrees determinant distance dot equal exp exp2 faceforward findLSB findMSB floatBitsToInt floatBitsToUint floor fma fract frexp ftransform fwidth greaterThan greaterThanEqual imageAtomicAdd imageAtomicAnd imageAtomicCompSwap imageAtomicExchange imageAtomicMax imageAtomicMin imageAtomicOr imageAtomicXor imageLoad imageStore imulExtended intBitsToFloat interpolateAtCentroid interpolateAtOffset interpolateAtSample inverse inversesqrt isinf isnan ldexp length lessThan lessThanEqual log log2 matrixCompMult max memoryBarrier min mix mod modf noise1 noise2 noise3 noise4 normalize not notEqual outerProduct packDouble2x32 packHalf2x16 packSnorm2x16 packSnorm4x8 packUnorm2x16 packUnorm4x8 pow radians reflect refract round roundEven shadow1D shadow1DLod shadow1DProj shadow1DProjLod shadow2D shadow2DLod shadow2DProj shadow2DProjLod sign sin sinh smoothstep sqrt step tan tanh texelFetch texelFetchOffset texture texture1D texture1DLod texture1DProj texture1DProjLod texture2D texture2DLod texture2DProj texture2DProjLod texture3D texture3DLod texture3DProj texture3DProjLod textureCube textureCubeLod textureGather textureGatherOffset textureGatherOffsets textureGrad textureGradOffset textureLod textureLodOffset textureOffset textureProj textureProjGrad textureProjGradOffset textureProjLod textureProjLodOffset textureProjOffset textureQueryLod textureSize transpose trunc uaddCarry uintBitsToFloat umulExtended unpackDouble2x32 unpackHalf2x16 unpackSnorm2x16 unpackSnorm4x8 unpackUnorm2x16 unpackUnorm4x8 usubBorrow gl_TextureMatrix gl_TextureMatrixInverse",literal:"true false"},illegal:'"',contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,hljs.C_NUMBER_MODE,{className:"preprocessor",begin:"#",end:"$"}]}}),hljs.registerLanguage("go",function(hljs){var GO_KEYWORDS={keyword:"break default func interface select case map struct chan else goto package switch const fallthrough if range type continue for import return var go defer",constant:"true false iota nil",typename:"bool byte complex64 complex128 float32 float64 int8 int16 int32 int64 string uint8 uint16 uint32 uint64 int uint uintptr rune",built_in:"append cap close complex copy imag len make new panic print println real recover delete"};return{aliases:["golang"],keywords:GO_KEYWORDS,illegal:"</",contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,hljs.QUOTE_STRING_MODE,{className:"string",begin:"'",end:"[^\\\\]'"},{className:"string",begin:"`",end:"`"},{className:"number",begin:hljs.C_NUMBER_RE+"[dflsi]?",relevance:0},hljs.C_NUMBER_MODE]}}),hljs.registerLanguage("golo",function(hljs){return{keywords:{keyword:"println readln print import module function local return let var while for foreach times in case when match with break continue augment augmentation each find filter reduce if then else otherwise try catch finally raise throw orIfNull",typename:"DynamicObject|10 DynamicVariable struct Observable map set vector list array",literal:"true false null"},contains:[hljs.HASH_COMMENT_MODE,hljs.QUOTE_STRING_MODE,hljs.C_NUMBER_MODE,{className:"annotation",begin:"@[A-Za-z]+"}]}}),hljs.registerLanguage("gradle",function(hljs){return{case_insensitive:!0,keywords:{keyword:"task project allprojects subprojects artifacts buildscript configurations dependencies repositories sourceSets description delete from into include exclude source classpath destinationDir includes options sourceCompatibility targetCompatibility group flatDir doLast doFirst flatten todir fromdir ant def abstract break case catch continue default do else extends final finally for if implements instanceof native new private protected public return static switch synchronized throw throws transient try volatile while strictfp package import false null super this true antlrtask checkstyle codenarc copy boolean byte char class double float int interface long short void compile runTime file fileTree abs any append asList asWritable call collect compareTo count div dump each eachByte eachFile eachLine every find findAll flatten getAt getErr getIn getOut getText grep immutable inject inspect intersect invokeMethods isCase join leftShift minus multiply newInputStream newOutputStream newPrintWriter newReader newWriter next plus pop power previous print println push putAt read readBytes readLines reverse reverseEach round size sort splitEachLine step subMap times toInteger toList tokenize upto waitForOrKill withPrintWriter withReader withStream withWriter withWriterAppend write writeLine"},contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.NUMBER_MODE,hljs.REGEXP_MODE]}}),hljs.registerLanguage("groovy",function(hljs){return{keywords:{typename:"byte short char int long boolean float double void",literal:"true false null",keyword:"def as in assert trait super this abstract static volatile transient public private protected synchronized final class interface enum if else for while switch case break default continue throw throws try catch finally implements extends new import package return instanceof"},contains:[hljs.COMMENT("/\\*\\*","\\*/",{relevance:0,contains:[{className:"doctag",begin:"@[A-Za-z]+"}]}),hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,{className:"string",begin:'"""',end:'"""'},{className:"string",begin:"'''",end:"'''"},{className:"string",begin:"\\$/",end:"/\\$",relevance:10},hljs.APOS_STRING_MODE,{className:"regexp",begin:/~?\/[^\/\n]+\//,contains:[hljs.BACKSLASH_ESCAPE]},hljs.QUOTE_STRING_MODE,{className:"shebang",begin:"^#!/usr/bin/env",end:"$",illegal:"\n"},hljs.BINARY_NUMBER_MODE,{className:"class",beginKeywords:"class interface trait enum",end:"{",illegal:":",contains:[{beginKeywords:"extends implements"},hljs.UNDERSCORE_TITLE_MODE]},hljs.C_NUMBER_MODE,{className:"annotation",begin:"@[A-Za-z]+"},{className:"string",begin:/[^\?]{0}[A-Za-z0-9_$]+ *:/},{begin:/\?/,end:/\:/},{className:"label",begin:"^\\s*[A-Za-z0-9_$]+:",relevance:0}],illegal:/#/}}),hljs.registerLanguage("haml",function(hljs){return{case_insensitive:!0,contains:[{className:"doctype",begin:"^!!!( (5|1\\.1|Strict|Frameset|Basic|Mobile|RDFa|XML\\b.*))?$",relevance:10},hljs.COMMENT("^\\s*(!=#|=#|-#|/).*$",!1,{relevance:0}),{begin:"^\\s*(-|=|!=)(?!#)",starts:{end:"\\n",subLanguage:"ruby"}},{className:"tag",begin:"^\\s*%",contains:[{className:"title",begin:"\\w+"},{className:"value",begin:"[#\\.][\\w-]+"},{begin:"{\\s*",end:"\\s*}",excludeEnd:!0,contains:[{begin:":\\w+\\s*=>",end:",\\s+",returnBegin:!0,endsWithParent:!0,contains:[{className:"symbol",begin:":\\w+"},hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,{begin:"\\w+",relevance:0}]}]},{begin:"\\(\\s*",end:"\\s*\\)",excludeEnd:!0,contains:[{begin:"\\w+\\s*=",end:"\\s+",returnBegin:!0,endsWithParent:!0,contains:[{className:"attribute",begin:"\\w+",relevance:0},hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,{begin:"\\w+",relevance:0}]}]}]},{className:"bullet",begin:"^\\s*[=~]\\s*",relevance:0},{begin:"#{",starts:{end:"}",subLanguage:"ruby"}}]}}),hljs.registerLanguage("handlebars",function(hljs){var EXPRESSION_KEYWORDS="each in with if else unless bindattr action collection debugger log outlet template unbound view yield";return{aliases:["hbs","html.hbs","html.handlebars"],case_insensitive:!0,subLanguage:"xml",contains:[{className:"expression",begin:"{{",end:"}}",contains:[{className:"begin-block",begin:"#[a-zA-Z- .]+",keywords:EXPRESSION_KEYWORDS},{className:"string",begin:'"',end:'"'},{className:"end-block",begin:"\\/[a-zA-Z- .]+",keywords:EXPRESSION_KEYWORDS},{className:"variable",begin:"[a-zA-Z-.]+",keywords:EXPRESSION_KEYWORDS}]}]}}),hljs.registerLanguage("haskell",function(hljs){var COMMENT_MODES=[hljs.COMMENT("--","$"),hljs.COMMENT("{-","-}",{contains:["self"]})],PRAGMA={className:"pragma",begin:"{-#",end:"#-}"},PREPROCESSOR={className:"preprocessor",begin:"^#",end:"$"},CONSTRUCTOR={className:"type",begin:"\\b[A-Z][\\w']*",relevance:0},LIST={className:"container",begin:"\\(",end:"\\)",illegal:'"',contains:[PRAGMA,PREPROCESSOR,{className:"type",begin:"\\b[A-Z][\\w]*(\\((\\.\\.|,|\\w+)\\))?"},hljs.inherit(hljs.TITLE_MODE,{begin:"[_a-z][\\w']*"})].concat(COMMENT_MODES)},RECORD={className:"container",begin:"{",end:"}",contains:LIST.contains};return{aliases:["hs"],keywords:"let in if then else case of where do module import hiding qualified type data newtype deriving class instance as default infix infixl infixr foreign export ccall stdcall cplusplus jvm dotnet safe unsafe family forall mdo proc rec",contains:[{className:"module",begin:"\\bmodule\\b",end:"where",keywords:"module where",contains:[LIST].concat(COMMENT_MODES),illegal:"\\W\\.|;"},{className:"import",begin:"\\bimport\\b",end:"$",keywords:"import|0 qualified as hiding",contains:[LIST].concat(COMMENT_MODES),illegal:"\\W\\.|;"},{className:"class",begin:"^(\\s*)?(class|instance)\\b",end:"where",keywords:"class family instance where",contains:[CONSTRUCTOR,LIST].concat(COMMENT_MODES)},{className:"typedef",begin:"\\b(data|(new)?type)\\b",end:"$",keywords:"data family type newtype deriving",contains:[PRAGMA,CONSTRUCTOR,LIST,RECORD].concat(COMMENT_MODES)},{className:"default",beginKeywords:"default",end:"$",contains:[CONSTRUCTOR,LIST].concat(COMMENT_MODES)},{className:"infix",beginKeywords:"infix infixl infixr",end:"$",contains:[hljs.C_NUMBER_MODE].concat(COMMENT_MODES)},{className:"foreign",begin:"\\bforeign\\b",end:"$",keywords:"foreign import export ccall stdcall cplusplus jvm dotnet safe unsafe",contains:[CONSTRUCTOR,hljs.QUOTE_STRING_MODE].concat(COMMENT_MODES)},{className:"shebang",begin:"#!\\/usr\\/bin\\/env runhaskell",end:"$"},PRAGMA,PREPROCESSOR,hljs.QUOTE_STRING_MODE,hljs.C_NUMBER_MODE,CONSTRUCTOR,hljs.inherit(hljs.TITLE_MODE,{begin:"^[_a-z][\\w']*"}),{begin:"->|<-"}].concat(COMMENT_MODES)}}),hljs.registerLanguage("haxe",function(hljs){var IDENT_FUNC_RETURN_TYPE_RE="([*]|[a-zA-Z_$][a-zA-Z0-9_$]*)";return{aliases:["hx"],keywords:{keyword:"break callback case cast catch class continue default do dynamic else enum extends extern for function here if implements import in inline interface never new override package private public return static super switch this throw trace try typedef untyped using var while",literal:"true false null"},contains:[hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,hljs.C_NUMBER_MODE,{className:"class",beginKeywords:"class interface",end:"{",excludeEnd:!0,contains:[{beginKeywords:"extends implements"},hljs.TITLE_MODE]},{className:"preprocessor",begin:"#",end:"$",keywords:"if else elseif end error"},{className:"function",beginKeywords:"function",end:"[{;]",excludeEnd:!0,illegal:"\\S",contains:[hljs.TITLE_MODE,{className:"params",begin:"\\(",end:"\\)",contains:[hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE]},{className:"type",begin:":",end:IDENT_FUNC_RETURN_TYPE_RE,relevance:10}]}]}}),hljs.registerLanguage("http",function(hljs){return{aliases:["https"],illegal:"\\S",contains:[{className:"status",begin:"^HTTP/[0-9\\.]+",end:"$",contains:[{className:"number",begin:"\\b\\d{3}\\b"}]},{className:"request",begin:"^[A-Z]+ (.*?) HTTP/[0-9\\.]+$",returnBegin:!0,end:"$",contains:[{className:"string",begin:" ",end:" ",excludeBegin:!0,excludeEnd:!0}]},{className:"attribute",begin:"^\\w",end:": ",excludeEnd:!0,illegal:"\\n|\\s|=",starts:{className:"string",end:"$"}},{begin:"\\n\\n",starts:{subLanguage:[],endsWithParent:!0}}]}}),hljs.registerLanguage("inform7",function(hljs){var START_BRACKET="\\[",END_BRACKET="\\]";return{aliases:["i7"],case_insensitive:!0,keywords:{keyword:"thing room person man woman animal container supporter backdrop door scenery open closed locked inside gender is are say understand kind of rule"},contains:[{className:"string",begin:'"',end:'"',relevance:0,contains:[{className:"subst",begin:START_BRACKET,end:END_BRACKET}]},{className:"title",begin:/^(Volume|Book|Part|Chapter|Section|Table)\b/,end:"$"},{begin:/^(Check|Carry out|Report|Instead of|To|Rule|When|Before|After)\b/,end:":",contains:[{begin:"\\b\\(This",end:"\\)"}]},{className:"comment",begin:START_BRACKET,end:END_BRACKET,contains:["self"]}]}}),hljs.registerLanguage("ini",function(hljs){var STRING={className:"string",contains:[hljs.BACKSLASH_ESCAPE],variants:[{begin:"'''",end:"'''",relevance:10},{begin:'"""',end:'"""',relevance:10},{begin:'"',end:'"'},{begin:"'",end:"'"}]};return{aliases:["toml"],case_insensitive:!0,illegal:/\S/,contains:[hljs.COMMENT(";","$"),hljs.HASH_COMMENT_MODE,{className:"title",begin:/^\s*\[+/,end:/\]+/},{className:"setting",begin:/^[a-z0-9\[\]_-]+\s*=\s*/,end:"$",contains:[{className:"value",endsWithParent:!0,keywords:"on off true false yes no",contains:[{className:"variable",variants:[{begin:/\$[\w\d"][\w\d_]*/},{begin:/\$\{(.*?)}/}]},STRING,{className:"number",begin:/([\+\-]+)?[\d]+_[\d_]+/},hljs.NUMBER_MODE],relevance:0}]}]}}),hljs.registerLanguage("irpf90",function(hljs){var PARAMS={className:"params",begin:"\\(",end:"\\)"},F_KEYWORDS={constant:".False. .True.",type:"integer real character complex logical dimension allocatable|10 parameter external implicit|10 none double precision assign intent optional pointer target in out common equivalence data",keyword:"kind do while private call intrinsic where elsewhere type endtype endmodule endselect endinterface end enddo endif if forall endforall only contains default return stop then public subroutine|10 function program .and. .or. .not. .le. .eq. .ge. .gt. .lt. goto save else use module select case access blank direct exist file fmt form formatted iostat name named nextrec number opened rec recl sequential status unformatted unit continue format pause cycle exit c_null_char c_alert c_backspace c_form_feed flush wait decimal round iomsg synchronous nopass non_overridable pass protected volatile abstract extends import non_intrinsic value deferred generic final enumerator class associate bind enum c_int c_short c_long c_long_long c_signed_char c_size_t c_int8_t c_int16_t c_int32_t c_int64_t c_int_least8_t c_int_least16_t c_int_least32_t c_int_least64_t c_int_fast8_t c_int_fast16_t c_int_fast32_t c_int_fast64_t c_intmax_t C_intptr_t c_float c_double c_long_double c_float_complex c_double_complex c_long_double_complex c_bool c_char c_null_ptr c_null_funptr c_new_line c_carriage_return c_horizontal_tab c_vertical_tab iso_c_binding c_loc c_funloc c_associated  c_f_pointer c_ptr c_funptr iso_fortran_env character_storage_size error_unit file_storage_size input_unit iostat_end iostat_eor numeric_storage_size output_unit c_f_procpointer ieee_arithmetic ieee_support_underflow_control ieee_get_underflow_mode ieee_set_underflow_mode newunit contiguous recursive pad position action delim readwrite eor advance nml interface procedure namelist include sequence elemental pure begin_provider &begin_provider end_provider begin_shell end_shell begin_template end_template subst assert touch soft_touch provide no_dep free irp_if irp_else irp_endif irp_write irp_read",built_in:"alog alog10 amax0 amax1 amin0 amin1 amod cabs ccos cexp clog csin csqrt dabs dacos dasin datan datan2 dcos dcosh ddim dexp dint dlog dlog10 dmax1 dmin1 dmod dnint dsign dsin dsinh dsqrt dtan dtanh float iabs idim idint idnint ifix isign max0 max1 min0 min1 sngl algama cdabs cdcos cdexp cdlog cdsin cdsqrt cqabs cqcos cqexp cqlog cqsin cqsqrt dcmplx dconjg derf derfc dfloat dgamma dimag dlgama iqint qabs qacos qasin qatan qatan2 qcmplx qconjg qcos qcosh qdim qerf qerfc qexp qgamma qimag qlgama qlog qlog10 qmax1 qmin1 qmod qnint qsign qsin qsinh qsqrt qtan qtanh abs acos aimag aint anint asin atan atan2 char cmplx conjg cos cosh exp ichar index int log log10 max min nint sign sin sinh sqrt tan tanh print write dim lge lgt lle llt mod nullify allocate deallocate adjustl adjustr all allocated any associated bit_size btest ceiling count cshift date_and_time digits dot_product eoshift epsilon exponent floor fraction huge iand ibclr ibits ibset ieor ior ishft ishftc lbound len_trim matmul maxexponent maxloc maxval merge minexponent minloc minval modulo mvbits nearest pack present product radix random_number random_seed range repeat reshape rrspacing scale scan selected_int_kind selected_real_kind set_exponent shape size spacing spread sum system_clock tiny transpose trim ubound unpack verify achar iachar transfer dble entry dprod cpu_time command_argument_count get_command get_command_argument get_environment_variable is_iostat_end ieee_arithmetic ieee_support_underflow_control ieee_get_underflow_mode ieee_set_underflow_mode is_iostat_eor move_alloc new_line selected_char_kind same_type_as extends_type_ofacosh asinh atanh bessel_j0 bessel_j1 bessel_jn bessel_y0 bessel_y1 bessel_yn erf erfc erfc_scaled gamma log_gamma hypot norm2 atomic_define atomic_ref execute_command_line leadz trailz storage_size merge_bits bge bgt ble blt dshiftl dshiftr findloc iall iany iparity image_index lcobound ucobound maskl maskr num_images parity popcnt poppar shifta shiftl shiftr this_image IRP_ALIGN irp_here"};return{case_insensitive:!0,keywords:F_KEYWORDS,illegal:/\/\*/,contains:[hljs.inherit(hljs.APOS_STRING_MODE,{className:"string",relevance:0}),hljs.inherit(hljs.QUOTE_STRING_MODE,{className:"string",relevance:0}),{className:"function",beginKeywords:"subroutine function program",illegal:"[${=\\n]",contains:[hljs.UNDERSCORE_TITLE_MODE,PARAMS]},hljs.COMMENT("!","$",{relevance:0}),hljs.COMMENT("begin_doc","end_doc",{relevance:10}),{className:"number",begin:"(?=\\b|\\+|\\-|\\.)(?=\\.\\d|\\d)(?:\\d+)?(?:\\.?\\d*)(?:[de][+-]?\\d+)?\\b\\.?",relevance:0}]}}),hljs.registerLanguage("java",function(hljs){var GENERIC_IDENT_RE=hljs.UNDERSCORE_IDENT_RE+"(<"+hljs.UNDERSCORE_IDENT_RE+">)?",KEYWORDS="false synchronized int abstract float private char boolean static null if const for true while long strictfp finally protected import native final void enum else break transient catch instanceof byte super volatile case assert short package default double public try this switch continue throws protected public private",JAVA_NUMBER_RE="\\b(0[bB]([01]+[01_]+[01]+|[01]+)|0[xX]([a-fA-F0-9]+[a-fA-F0-9_]+[a-fA-F0-9]+|[a-fA-F0-9]+)|(([\\d]+[\\d_]+[\\d]+|[\\d]+)(\\.([\\d]+[\\d_]+[\\d]+|[\\d]+))?|\\.([\\d]+[\\d_]+[\\d]+|[\\d]+))([eE][-+]?\\d+)?)[lLfF]?",JAVA_NUMBER_MODE={className:"number",begin:JAVA_NUMBER_RE,relevance:0};return{aliases:["jsp"],keywords:KEYWORDS,illegal:/<\/|#/,contains:[hljs.COMMENT("/\\*\\*","\\*/",{relevance:0,contains:[{className:"doctag",begin:"@[A-Za-z]+"}]}),hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,{className:"class",beginKeywords:"class interface",end:/[{;=]/,excludeEnd:!0,keywords:"class interface",illegal:/[:"\[\]]/,contains:[{beginKeywords:"extends implements"},hljs.UNDERSCORE_TITLE_MODE]},{beginKeywords:"new throw return else",relevance:0},{className:"function",begin:"("+GENERIC_IDENT_RE+"\\s+)+"+hljs.UNDERSCORE_IDENT_RE+"\\s*\\(",returnBegin:!0,end:/[{;=]/,excludeEnd:!0,keywords:KEYWORDS,contains:[{begin:hljs.UNDERSCORE_IDENT_RE+"\\s*\\(",returnBegin:!0,relevance:0,contains:[hljs.UNDERSCORE_TITLE_MODE]},{className:"params",begin:/\(/,end:/\)/,keywords:KEYWORDS,relevance:0,contains:[hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.C_NUMBER_MODE,hljs.C_BLOCK_COMMENT_MODE]},hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE]},JAVA_NUMBER_MODE,{className:"annotation",begin:"@[A-Za-z]+"}]}}),hljs.registerLanguage("javascript",function(hljs){return{aliases:["js"],keywords:{keyword:"in of if for while finally var new function do return void else break catch instanceof with throw case default try this switch continue typeof delete let yield const export super debugger as async await",literal:"true false null undefined NaN Infinity",built_in:"eval isFinite isNaN parseFloat parseInt decodeURI decodeURIComponent encodeURI encodeURIComponent escape unescape Object Function Boolean Error EvalError InternalError RangeError ReferenceError StopIteration SyntaxError TypeError URIError Number Math Date String RegExp Array Float32Array Float64Array Int16Array Int32Array Int8Array Uint16Array Uint32Array Uint8Array Uint8ClampedArray ArrayBuffer DataView JSON Intl arguments require module console window document Symbol Set Map WeakSet WeakMap Proxy Reflect Promise"},contains:[{className:"pi",relevance:10,begin:/^\s*['"]use (strict|asm)['"]/},hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,{className:"string",begin:"`",end:"`",contains:[hljs.BACKSLASH_ESCAPE,{className:"subst",begin:"\\$\\{",end:"\\}"}]},hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,{className:"number",variants:[{begin:"\\b(0[bB][01]+)"},{begin:"\\b(0[oO][0-7]+)"},{begin:hljs.C_NUMBER_RE}],relevance:0},{begin:"("+hljs.RE_STARTERS_RE+"|\\b(case|return|throw)\\b)\\s*",keywords:"return throw case",contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,hljs.REGEXP_MODE,{begin:/</,end:/>\s*[);\]]/,relevance:0,subLanguage:"xml"}],relevance:0},{className:"function",beginKeywords:"function",end:/\{/,excludeEnd:!0,contains:[hljs.inherit(hljs.TITLE_MODE,{begin:/[A-Za-z$_][0-9A-Za-z$_]*/}),{className:"params",begin:/\(/,end:/\)/,excludeBegin:!0,excludeEnd:!0,contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE]}],illegal:/\[|%/},{begin:/\$[(.]/},{begin:"\\."+hljs.IDENT_RE,relevance:0},{beginKeywords:"import",end:"[;$]",keywords:"import from as",contains:[hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE]},{className:"class",beginKeywords:"class",end:/[{;=]/,excludeEnd:!0,illegal:/[:"\[\]]/,contains:[{beginKeywords:"extends"},hljs.UNDERSCORE_TITLE_MODE]}],illegal:/#/}}),hljs.registerLanguage("json",function(hljs){var LITERALS={literal:"true false null"},TYPES=[hljs.QUOTE_STRING_MODE,hljs.C_NUMBER_MODE],VALUE_CONTAINER={className:"value",end:",",endsWithParent:!0,excludeEnd:!0,contains:TYPES,keywords:LITERALS},OBJECT={begin:"{",end:"}",contains:[{className:"attribute",begin:'\\s*"',end:'"\\s*:\\s*',excludeBegin:!0,excludeEnd:!0,contains:[hljs.BACKSLASH_ESCAPE],illegal:"\\n",starts:VALUE_CONTAINER}],illegal:"\\S"},ARRAY={begin:"\\[",end:"\\]",contains:[hljs.inherit(VALUE_CONTAINER,{className:null})],illegal:"\\S"};return TYPES.splice(TYPES.length,0,OBJECT,ARRAY),{contains:TYPES,keywords:LITERALS,illegal:"\\S"}}),hljs.registerLanguage("julia",function(hljs){var KEYWORDS={keyword:"in abstract baremodule begin bitstype break catch ccall const continue do else elseif end export finally for function global if immutable import importall let local macro module quote return try type typealias using while",literal:"true false ANY ARGS CPU_CORES C_NULL DL_LOAD_PATH DevNull ENDIAN_BOM ENV I|0 Inf Inf16 Inf32 InsertionSort JULIA_HOME LOAD_PATH MS_ASYNC MS_INVALIDATE MS_SYNC MergeSort NaN NaN16 NaN32 OS_NAME QuickSort RTLD_DEEPBIND RTLD_FIRST RTLD_GLOBAL RTLD_LAZY RTLD_LOCAL RTLD_NODELETE RTLD_NOLOAD RTLD_NOW RoundDown RoundFromZero RoundNearest RoundToZero RoundUp STDERR STDIN STDOUT VERSION WORD_SIZE catalan cglobal e|0 eu|0 eulergamma golden im nothing pi γ π φ",built_in:"ASCIIString AbstractArray AbstractRNG AbstractSparseArray Any ArgumentError Array Associative Base64Pipe Bidiagonal BigFloat BigInt BitArray BitMatrix BitVector Bool BoundsError Box CFILE Cchar Cdouble Cfloat Char CharString Cint Clong Clonglong ClusterManager Cmd Coff_t Colon Complex Complex128 Complex32 Complex64 Condition Cptrdiff_t Cshort Csize_t Cssize_t Cuchar Cuint Culong Culonglong Cushort Cwchar_t DArray DataType DenseArray Diagonal Dict DimensionMismatch DirectIndexString Display DivideError DomainError EOFError EachLine Enumerate ErrorException Exception Expr Factorization FileMonitor FileOffset Filter Float16 Float32 Float64 FloatRange FloatingPoint Function GetfieldNode GotoNode Hermitian IO IOBuffer IOStream IPv4 IPv6 InexactError Int Int128 Int16 Int32 Int64 Int8 IntSet Integer InterruptException IntrinsicFunction KeyError LabelNode LambdaStaticData LineNumberNode LoadError LocalProcess MIME MathConst MemoryError MersenneTwister Method MethodError MethodTable Module NTuple NewvarNode Nothing Number ObjectIdDict OrdinalRange OverflowError ParseError PollingFileWatcher ProcessExitedException ProcessGroup Ptr QuoteNode Range Range1 Ranges Rational RawFD Real Regex RegexMatch RemoteRef RepString RevString RopeString RoundingMode Set SharedArray Signed SparseMatrixCSC StackOverflowError Stat StatStruct StepRange String SubArray SubString SymTridiagonal Symbol SymbolNode Symmetric SystemError Task TextDisplay Timer TmStruct TopNode Triangular Tridiagonal Type TypeConstructor TypeError TypeName TypeVar UTF16String UTF32String UTF8String UdpSocket Uint Uint128 Uint16 Uint32 Uint64 Uint8 UndefRefError UndefVarError UniformScaling UnionType UnitRange Unsigned Vararg VersionNumber WString WeakKeyDict WeakRef Woodbury Zip"},VARIABLE_NAME_RE="[A-Za-z_\\u00A1-\\uFFFF][A-Za-z_0-9\\u00A1-\\uFFFF]*",DEFAULT={lexemes:VARIABLE_NAME_RE,keywords:KEYWORDS},TYPE_ANNOTATION={className:"type-annotation",begin:/::/},SUBTYPE={className:"subtype",begin:/<:/},NUMBER={className:"number",begin:/(\b0x[\d_]*(\.[\d_]*)?|0x\.\d[\d_]*)p[-+]?\d+|\b0[box][a-fA-F0-9][a-fA-F0-9_]*|(\b\d[\d_]*(\.[\d_]*)?|\.\d[\d_]*)([eEfF][-+]?\d+)?/,relevance:0},CHAR={className:"char",begin:/'(.|\\[xXuU][a-zA-Z0-9]+)'/},INTERPOLATION={className:"subst",begin:/\$\(/,end:/\)/,keywords:KEYWORDS},INTERPOLATED_VARIABLE={className:"variable",begin:"\\$"+VARIABLE_NAME_RE},STRING={className:"string",contains:[hljs.BACKSLASH_ESCAPE,INTERPOLATION,INTERPOLATED_VARIABLE],variants:[{begin:/\w*"/,end:/"\w*/},{begin:/\w*"""/,end:/"""\w*/}]},COMMAND={className:"string",contains:[hljs.BACKSLASH_ESCAPE,INTERPOLATION,INTERPOLATED_VARIABLE],begin:"`",end:"`"},MACROCALL={className:"macrocall",begin:"@"+VARIABLE_NAME_RE},COMMENT={className:"comment",variants:[{begin:"#=",end:"=#",relevance:10},{begin:"#",end:"$"}]};return DEFAULT.contains=[NUMBER,CHAR,TYPE_ANNOTATION,SUBTYPE,STRING,COMMAND,MACROCALL,COMMENT,hljs.HASH_COMMENT_MODE],INTERPOLATION.contains=DEFAULT.contains,DEFAULT}),hljs.registerLanguage("kotlin",function(hljs){var KEYWORDS="val var get set class trait object public open private protected final enum if else do while for when break continue throw try catch finally import package is as in return fun override default companion reified inline volatile transient native";return{keywords:{typename:"Byte Short Char Int Long Boolean Float Double Void Unit Nothing",literal:"true false null",keyword:KEYWORDS},contains:[hljs.COMMENT("/\\*\\*","\\*/",{relevance:0,contains:[{className:"doctag",begin:"@[A-Za-z]+"}]}),hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,{className:"type",begin:/</,end:/>/,returnBegin:!0,excludeEnd:!1,relevance:0},{className:"function",beginKeywords:"fun",end:"[(]|$",returnBegin:!0,excludeEnd:!0,keywords:KEYWORDS,illegal:/fun\s+(<.*>)?[^\s\(]+(\s+[^\s\(]+)\s*=/,relevance:5,contains:[{begin:hljs.UNDERSCORE_IDENT_RE+"\\s*\\(",returnBegin:!0,relevance:0,contains:[hljs.UNDERSCORE_TITLE_MODE]},{className:"type",begin:/</,end:/>/,keywords:"reified",relevance:0},{className:"params",begin:/\(/,end:/\)/,keywords:KEYWORDS,relevance:0,illegal:/\([^\(,\s:]+,/,contains:[{className:"typename",begin:/:\s*/,end:/\s*[=\)]/,excludeBegin:!0,returnEnd:!0,relevance:0}]},hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE]},{className:"class",beginKeywords:"class trait",end:/[:\{(]|$/,excludeEnd:!0,illegal:"extends implements",contains:[hljs.UNDERSCORE_TITLE_MODE,{className:"type",begin:/</,end:/>/,excludeBegin:!0,excludeEnd:!0,relevance:0},{className:"typename",begin:/[,:]\s*/,end:/[<\(,]|$/,excludeBegin:!0,returnEnd:!0}]},{className:"variable",beginKeywords:"var val",end:/\s*[=:$]/,excludeEnd:!0},hljs.QUOTE_STRING_MODE,{className:"shebang",begin:"^#!/usr/bin/env",end:"$",illegal:"\n"},hljs.C_NUMBER_MODE]}}),hljs.registerLanguage("lasso",function(hljs){var LASSO_IDENT_RE="[a-zA-Z_][a-zA-Z0-9_.]*",LASSO_ANGLE_RE="<\\?(lasso(script)?|=)",LASSO_CLOSE_RE="\\]|\\?>",LASSO_KEYWORDS={literal:"true false none minimal full all void bw nbw ew new cn ncn lt lte gt gte eq neq rx nrx ft",built_in:"array date decimal duration integer map pair string tag xml null boolean bytes keyword list locale queue set stack staticarray local var variable global data self inherited currentcapture givenblock",keyword:"error_code error_msg error_pop error_push error_reset cache database_names database_schemanames database_tablenames define_tag define_type email_batch encode_set html_comment handle handle_error header if inline iterate ljax_target link link_currentaction link_currentgroup link_currentrecord link_detail link_firstgroup link_firstrecord link_lastgroup link_lastrecord link_nextgroup link_nextrecord link_prevgroup link_prevrecord log loop namespace_using output_none portal private protect records referer referrer repeating resultset rows search_args search_arguments select sort_args sort_arguments thread_atomic value_list while abort case else if_empty if_false if_null if_true loop_abort loop_continue loop_count params params_up return return_value run_children soap_definetag soap_lastrequest soap_lastresponse tag_name ascending average by define descending do equals frozen group handle_failure import in into join let match max min on order parent protected provide public require returnhome skip split_thread sum take thread to trait type where with yield yieldhome"
},HTML_COMMENT=hljs.COMMENT("<!--","-->",{relevance:0}),LASSO_NOPROCESS={className:"preprocessor",begin:"\\[noprocess\\]",starts:{className:"markup",end:"\\[/noprocess\\]",returnEnd:!0,contains:[HTML_COMMENT]}},LASSO_START={className:"preprocessor",begin:"\\[/noprocess|"+LASSO_ANGLE_RE},LASSO_DATAMEMBER={className:"variable",begin:"'"+LASSO_IDENT_RE+"'"},LASSO_CODE=[hljs.COMMENT("/\\*\\*!","\\*/"),hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,hljs.inherit(hljs.C_NUMBER_MODE,{begin:hljs.C_NUMBER_RE+"|(infinity|nan)\\b"}),hljs.inherit(hljs.APOS_STRING_MODE,{illegal:null}),hljs.inherit(hljs.QUOTE_STRING_MODE,{illegal:null}),{className:"string",begin:"`",end:"`"},{className:"variable",variants:[{begin:"[#$]"+LASSO_IDENT_RE},{begin:"#",end:"\\d+",illegal:"\\W"}]},{className:"tag",begin:"::\\s*",end:LASSO_IDENT_RE,illegal:"\\W"},{className:"attribute",variants:[{begin:"-(?!infinity)"+hljs.UNDERSCORE_IDENT_RE,relevance:0},{begin:"(\\.\\.\\.)"}]},{className:"subst",variants:[{begin:"->\\s*",contains:[LASSO_DATAMEMBER]},{begin:"->|\\\\|&&?|\\|\\||!(?!=|>)|(and|or|not)\\b",relevance:0}]},{className:"built_in",begin:"\\.\\.?\\s*",relevance:0,contains:[LASSO_DATAMEMBER]},{className:"class",beginKeywords:"define",returnEnd:!0,end:"\\(|=>",contains:[hljs.inherit(hljs.TITLE_MODE,{begin:hljs.UNDERSCORE_IDENT_RE+"(=(?!>))?"})]}];return{aliases:["ls","lassoscript"],case_insensitive:!0,lexemes:LASSO_IDENT_RE+"|&[lg]t;",keywords:LASSO_KEYWORDS,contains:[{className:"preprocessor",begin:LASSO_CLOSE_RE,relevance:0,starts:{className:"markup",end:"\\[|"+LASSO_ANGLE_RE,returnEnd:!0,relevance:0,contains:[HTML_COMMENT]}},LASSO_NOPROCESS,LASSO_START,{className:"preprocessor",begin:"\\[no_square_brackets",starts:{end:"\\[/no_square_brackets\\]",lexemes:LASSO_IDENT_RE+"|&[lg]t;",keywords:LASSO_KEYWORDS,contains:[{className:"preprocessor",begin:LASSO_CLOSE_RE,relevance:0,starts:{className:"markup",end:"\\[noprocess\\]|"+LASSO_ANGLE_RE,returnEnd:!0,contains:[HTML_COMMENT]}},LASSO_NOPROCESS,LASSO_START].concat(LASSO_CODE)}},{className:"preprocessor",begin:"\\[",relevance:0},{className:"shebang",begin:"^#!.+lasso9\\b",relevance:10}].concat(LASSO_CODE)}}),hljs.registerLanguage("less",function(hljs){var IDENT_RE="[\\w-]+",INTERP_IDENT_RE="("+IDENT_RE+"|@{"+IDENT_RE+"})",RULES=[],VALUE=[],STRING_MODE=function(c){return{className:"string",begin:"~?"+c+".*?"+c}},IDENT_MODE=function(name,begin,relevance){return{className:name,begin:begin,relevance:relevance}},FUNCT_MODE=function(name,ident,obj){return hljs.inherit({className:name,begin:ident+"\\(",end:"\\(",returnBegin:!0,excludeEnd:!0,relevance:0},obj)},PARENS_MODE={begin:"\\(",end:"\\)",contains:VALUE,relevance:0};VALUE.push(hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,STRING_MODE("'"),STRING_MODE('"'),hljs.CSS_NUMBER_MODE,IDENT_MODE("hexcolor","#[0-9A-Fa-f]+\\b"),FUNCT_MODE("function","(url|data-uri)",{starts:{className:"string",end:"[\\)\\n]",excludeEnd:!0}}),FUNCT_MODE("function",IDENT_RE),PARENS_MODE,IDENT_MODE("variable","@@?"+IDENT_RE,10),IDENT_MODE("variable","@{"+IDENT_RE+"}"),IDENT_MODE("built_in","~?`[^`]*?`"),{className:"attribute",begin:IDENT_RE+"\\s*:",end:":",returnBegin:!0,excludeEnd:!0});var VALUE_WITH_RULESETS=VALUE.concat({begin:"{",end:"}",contains:RULES}),MIXIN_GUARD_MODE={beginKeywords:"when",endsWithParent:!0,contains:[{beginKeywords:"and not"}].concat(VALUE)},RULE_MODE={className:"attribute",begin:INTERP_IDENT_RE,end:":",excludeEnd:!0,contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE],illegal:/\S/,starts:{end:"[;}]",returnEnd:!0,contains:VALUE,illegal:"[<=$]"}},AT_RULE_MODE={className:"at_rule",begin:"@(import|media|charset|font-face|(-[a-z]+-)?keyframes|supports|document|namespace|page|viewport|host)\\b",starts:{end:"[;{}]",returnEnd:!0,contains:VALUE,relevance:0}},VAR_RULE_MODE={className:"variable",variants:[{begin:"@"+IDENT_RE+"\\s*:",relevance:15},{begin:"@"+IDENT_RE}],starts:{end:"[;}]",returnEnd:!0,contains:VALUE_WITH_RULESETS}},SELECTOR_MODE={variants:[{begin:"[\\.#:&\\[]",end:"[;{}]"},{begin:INTERP_IDENT_RE+"[^;]*{",end:"{"}],returnBegin:!0,returnEnd:!0,illegal:"[<='$\"]",contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,MIXIN_GUARD_MODE,IDENT_MODE("keyword","all\\b"),IDENT_MODE("variable","@{"+IDENT_RE+"}"),IDENT_MODE("tag",INTERP_IDENT_RE+"%?",0),IDENT_MODE("id","#"+INTERP_IDENT_RE),IDENT_MODE("class","\\."+INTERP_IDENT_RE,0),IDENT_MODE("keyword","&",0),FUNCT_MODE("pseudo",":not"),FUNCT_MODE("keyword",":extend"),IDENT_MODE("pseudo","::?"+INTERP_IDENT_RE),{className:"attr_selector",begin:"\\[",end:"\\]"},{begin:"\\(",end:"\\)",contains:VALUE_WITH_RULESETS},{begin:"!important"}]};return RULES.push(hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,AT_RULE_MODE,VAR_RULE_MODE,SELECTOR_MODE,RULE_MODE),{case_insensitive:!0,illegal:"[=>'/<($\"]",contains:RULES}}),hljs.registerLanguage("lisp",function(hljs){var LISP_IDENT_RE="[a-zA-Z_\\-\\+\\*\\/\\<\\=\\>\\&\\#][a-zA-Z0-9_\\-\\+\\*\\/\\<\\=\\>\\&\\#!]*",MEC_RE="\\|[^]*?\\|",LISP_SIMPLE_NUMBER_RE="(\\-|\\+)?\\d+(\\.\\d+|\\/\\d+)?((d|e|f|l|s|D|E|F|L|S)(\\+|\\-)?\\d+)?",SHEBANG={className:"shebang",begin:"^#!",end:"$"},LITERAL={className:"literal",begin:"\\b(t{1}|nil)\\b"},NUMBER={className:"number",variants:[{begin:LISP_SIMPLE_NUMBER_RE,relevance:0},{begin:"#(b|B)[0-1]+(/[0-1]+)?"},{begin:"#(o|O)[0-7]+(/[0-7]+)?"},{begin:"#(x|X)[0-9a-fA-F]+(/[0-9a-fA-F]+)?"},{begin:"#(c|C)\\("+LISP_SIMPLE_NUMBER_RE+" +"+LISP_SIMPLE_NUMBER_RE,end:"\\)"}]},STRING=hljs.inherit(hljs.QUOTE_STRING_MODE,{illegal:null}),COMMENT=hljs.COMMENT(";","$",{relevance:0}),VARIABLE={className:"variable",begin:"\\*",end:"\\*"},KEYWORD={className:"keyword",begin:"[:&]"+LISP_IDENT_RE},IDENT={begin:LISP_IDENT_RE,relevance:0},MEC={begin:MEC_RE},QUOTED_LIST={begin:"\\(",end:"\\)",contains:["self",LITERAL,STRING,NUMBER,IDENT]},QUOTED={className:"quoted",contains:[NUMBER,STRING,VARIABLE,KEYWORD,QUOTED_LIST,IDENT],variants:[{begin:"['`]\\(",end:"\\)"},{begin:"\\(quote ",end:"\\)",keywords:"quote"},{begin:"'"+MEC_RE}]},QUOTED_ATOM={className:"quoted",variants:[{begin:"'"+LISP_IDENT_RE},{begin:"#'"+LISP_IDENT_RE+"(::"+LISP_IDENT_RE+")*"}]},LIST={className:"list",begin:"\\(\\s*",end:"\\)"},BODY={endsWithParent:!0,relevance:0};return LIST.contains=[{className:"keyword",variants:[{begin:LISP_IDENT_RE},{begin:MEC_RE}]},BODY],BODY.contains=[QUOTED,QUOTED_ATOM,LIST,LITERAL,NUMBER,STRING,COMMENT,VARIABLE,KEYWORD,MEC,IDENT],{illegal:/\S/,contains:[NUMBER,SHEBANG,LITERAL,STRING,COMMENT,QUOTED,QUOTED_ATOM,LIST,IDENT]}}),hljs.registerLanguage("livecodeserver",function(hljs){var VARIABLE={className:"variable",begin:"\\b[gtps][A-Z]+[A-Za-z0-9_\\-]*\\b|\\$_[A-Z]+",relevance:0},COMMENT_MODES=[hljs.C_BLOCK_COMMENT_MODE,hljs.HASH_COMMENT_MODE,hljs.COMMENT("--","$"),hljs.COMMENT("[^:]//","$")],TITLE1=hljs.inherit(hljs.TITLE_MODE,{variants:[{begin:"\\b_*rig[A-Z]+[A-Za-z0-9_\\-]*"},{begin:"\\b_[a-z0-9\\-]+"}]}),TITLE2=hljs.inherit(hljs.TITLE_MODE,{begin:"\\b([A-Za-z0-9_\\-]+)\\b"});return{case_insensitive:!1,keywords:{keyword:"$_COOKIE $_FILES $_GET $_GET_BINARY $_GET_RAW $_POST $_POST_BINARY $_POST_RAW $_SESSION $_SERVER codepoint codepoints segment segments codeunit codeunits sentence sentences trueWord trueWords paragraph after byte bytes english the until http forever descending using line real8 with seventh for stdout finally element word words fourth before black ninth sixth characters chars stderr uInt1 uInt1s uInt2 uInt2s stdin string lines relative rel any fifth items from middle mid at else of catch then third it file milliseconds seconds second secs sec int1 int1s int4 int4s internet int2 int2s normal text item last long detailed effective uInt4 uInt4s repeat end repeat URL in try into switch to words https token binfile each tenth as ticks tick system real4 by dateItems without char character ascending eighth whole dateTime numeric short first ftp integer abbreviated abbr abbrev private case while if",constant:"SIX TEN FORMFEED NINE ZERO NONE SPACE FOUR FALSE COLON CRLF PI COMMA ENDOFFILE EOF EIGHT FIVE QUOTE EMPTY ONE TRUE RETURN CR LINEFEED RIGHT BACKSLASH NULL SEVEN TAB THREE TWO six ten formfeed nine zero none space four false colon crlf pi comma endoffile eof eight five quote empty one true return cr linefeed right backslash null seven tab three two RIVERSION RISTATE FILE_READ_MODE FILE_WRITE_MODE FILE_WRITE_MODE DIR_WRITE_MODE FILE_READ_UMASK FILE_WRITE_UMASK DIR_READ_UMASK DIR_WRITE_UMASK",operator:"div mod wrap and or bitAnd bitNot bitOr bitXor among not in a an within contains ends with begins the keys of keys",built_in:"put abs acos aliasReference annuity arrayDecode arrayEncode asin atan atan2 average avg avgDev base64Decode base64Encode baseConvert binaryDecode binaryEncode byteOffset byteToNum cachedURL cachedURLs charToNum cipherNames codepointOffset codepointProperty codepointToNum codeunitOffset commandNames compound compress constantNames cos date dateFormat decompress directories diskSpace DNSServers exp exp1 exp2 exp10 extents files flushEvents folders format functionNames geometricMean global globals hasMemory harmonicMean hostAddress hostAddressToName hostName hostNameToAddress isNumber ISOToMac itemOffset keys len length libURLErrorData libUrlFormData libURLftpCommand libURLLastHTTPHeaders libURLLastRHHeaders libUrlMultipartFormAddPart libUrlMultipartFormData libURLVersion lineOffset ln ln1 localNames log log2 log10 longFilePath lower macToISO matchChunk matchText matrixMultiply max md5Digest median merge millisec millisecs millisecond milliseconds min monthNames nativeCharToNum normalizeText num number numToByte numToChar numToCodepoint numToNativeChar offset open openfiles openProcesses openProcessIDs openSockets paragraphOffset paramCount param params peerAddress pendingMessages platform popStdDev populationStandardDeviation populationVariance popVariance processID random randomBytes replaceText result revCreateXMLTree revCreateXMLTreeFromFile revCurrentRecord revCurrentRecordIsFirst revCurrentRecordIsLast revDatabaseColumnCount revDatabaseColumnIsNull revDatabaseColumnLengths revDatabaseColumnNames revDatabaseColumnNamed revDatabaseColumnNumbered revDatabaseColumnTypes revDatabaseConnectResult revDatabaseCursors revDatabaseID revDatabaseTableNames revDatabaseType revDataFromQuery revdb_closeCursor revdb_columnbynumber revdb_columncount revdb_columnisnull revdb_columnlengths revdb_columnnames revdb_columntypes revdb_commit revdb_connect revdb_connections revdb_connectionerr revdb_currentrecord revdb_cursorconnection revdb_cursorerr revdb_cursors revdb_dbtype revdb_disconnect revdb_execute revdb_iseof revdb_isbof revdb_movefirst revdb_movelast revdb_movenext revdb_moveprev revdb_query revdb_querylist revdb_recordcount revdb_rollback revdb_tablenames revGetDatabaseDriverPath revNumberOfRecords revOpenDatabase revOpenDatabases revQueryDatabase revQueryDatabaseBlob revQueryResult revQueryIsAtStart revQueryIsAtEnd revUnixFromMacPath revXMLAttribute revXMLAttributes revXMLAttributeValues revXMLChildContents revXMLChildNames revXMLCreateTreeFromFileWithNamespaces revXMLCreateTreeWithNamespaces revXMLDataFromXPathQuery revXMLEvaluateXPath revXMLFirstChild revXMLMatchingNode revXMLNextSibling revXMLNodeContents revXMLNumberOfChildren revXMLParent revXMLPreviousSibling revXMLRootNode revXMLRPC_CreateRequest revXMLRPC_Documents revXMLRPC_Error revXMLRPC_GetHost revXMLRPC_GetMethod revXMLRPC_GetParam revXMLText revXMLRPC_Execute revXMLRPC_GetParamCount revXMLRPC_GetParamNode revXMLRPC_GetParamType revXMLRPC_GetPath revXMLRPC_GetPort revXMLRPC_GetProtocol revXMLRPC_GetRequest revXMLRPC_GetResponse revXMLRPC_GetSocket revXMLTree revXMLTrees revXMLValidateDTD revZipDescribeItem revZipEnumerateItems revZipOpenArchives round sampVariance sec secs seconds sentenceOffset sha1Digest shell shortFilePath sin specialFolderPath sqrt standardDeviation statRound stdDev sum sysError systemVersion tan tempName textDecode textEncode tick ticks time to tokenOffset toLower toUpper transpose truewordOffset trunc uniDecode uniEncode upper URLDecode URLEncode URLStatus uuid value variableNames variance version waitDepth weekdayNames wordOffset xsltApplyStylesheet xsltApplyStylesheetFromFile xsltLoadStylesheet xsltLoadStylesheetFromFile add breakpoint cancel clear local variable file word line folder directory URL close socket process combine constant convert create new alias folder directory decrypt delete variable word line folder directory URL dispatch divide do encrypt filter get include intersect kill libURLDownloadToFile libURLFollowHttpRedirects libURLftpUpload libURLftpUploadFile libURLresetAll libUrlSetAuthCallback libURLSetCustomHTTPHeaders libUrlSetExpect100 libURLSetFTPListCommand libURLSetFTPMode libURLSetFTPStopTime libURLSetStatusCallback load multiply socket prepare process post seek rel relative read from process rename replace require resetAll resolve revAddXMLNode revAppendXML revCloseCursor revCloseDatabase revCommitDatabase revCopyFile revCopyFolder revCopyXMLNode revDeleteFolder revDeleteXMLNode revDeleteAllXMLTrees revDeleteXMLTree revExecuteSQL revGoURL revInsertXMLNode revMoveFolder revMoveToFirstRecord revMoveToLastRecord revMoveToNextRecord revMoveToPreviousRecord revMoveToRecord revMoveXMLNode revPutIntoXMLNode revRollBackDatabase revSetDatabaseDriverPath revSetXMLAttribute revXMLRPC_AddParam revXMLRPC_DeleteAllDocuments revXMLAddDTD revXMLRPC_Free revXMLRPC_FreeAll revXMLRPC_DeleteDocument revXMLRPC_DeleteParam revXMLRPC_SetHost revXMLRPC_SetMethod revXMLRPC_SetPort revXMLRPC_SetProtocol revXMLRPC_SetSocket revZipAddItemWithData revZipAddItemWithFile revZipAddUncompressedItemWithData revZipAddUncompressedItemWithFile revZipCancel revZipCloseArchive revZipDeleteItem revZipExtractItemToFile revZipExtractItemToVariable revZipSetProgressCallback revZipRenameItem revZipReplaceItemWithData revZipReplaceItemWithFile revZipOpenArchive send set sort split start stop subtract union unload wait write"},contains:[VARIABLE,{className:"keyword",begin:"\\bend\\sif\\b"},{className:"function",beginKeywords:"function",end:"$",contains:[VARIABLE,TITLE2,hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.BINARY_NUMBER_MODE,hljs.C_NUMBER_MODE,TITLE1]},{className:"function",begin:"\\bend\\s+",end:"$",keywords:"end",contains:[TITLE2,TITLE1]},{className:"command",beginKeywords:"command on",end:"$",contains:[VARIABLE,TITLE2,hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.BINARY_NUMBER_MODE,hljs.C_NUMBER_MODE,TITLE1]},{className:"preprocessor",variants:[{begin:"<\\?(rev|lc|livecode)",relevance:10},{begin:"<\\?"},{begin:"\\?>"}]},hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.BINARY_NUMBER_MODE,hljs.C_NUMBER_MODE,TITLE1].concat(COMMENT_MODES),illegal:";$|^\\[|^="}}),hljs.registerLanguage("livescript",function(hljs){var KEYWORDS={keyword:"in if for while finally new do return else break catch instanceof throw try this switch continue typeof delete debugger case default function var with then unless until loop of by when and or is isnt not it that otherwise from to til fallthrough super case default function var void const let enum export import native __hasProp __extends __slice __bind __indexOf",literal:"true false null undefined yes no on off it that void",built_in:"npm require console print module global window document"},JS_IDENT_RE="[A-Za-z$_](?:-[0-9A-Za-z$_]|[0-9A-Za-z$_])*",TITLE=hljs.inherit(hljs.TITLE_MODE,{begin:JS_IDENT_RE}),SUBST={className:"subst",begin:/#\{/,end:/}/,keywords:KEYWORDS},SUBST_SIMPLE={className:"subst",begin:/#[A-Za-z$_]/,end:/(?:\-[0-9A-Za-z$_]|[0-9A-Za-z$_])*/,keywords:KEYWORDS},EXPRESSIONS=[hljs.BINARY_NUMBER_MODE,{className:"number",begin:"(\\b0[xX][a-fA-F0-9_]+)|(\\b\\d(\\d|_\\d)*(\\.(\\d(\\d|_\\d)*)?)?(_*[eE]([-+]\\d(_\\d|\\d)*)?)?[_a-z]*)",relevance:0,starts:{end:"(\\s*/)?",relevance:0}},{className:"string",variants:[{begin:/'''/,end:/'''/,contains:[hljs.BACKSLASH_ESCAPE]},{begin:/'/,end:/'/,contains:[hljs.BACKSLASH_ESCAPE]},{begin:/"""/,end:/"""/,contains:[hljs.BACKSLASH_ESCAPE,SUBST,SUBST_SIMPLE]},{begin:/"/,end:/"/,contains:[hljs.BACKSLASH_ESCAPE,SUBST,SUBST_SIMPLE]},{begin:/\\/,end:/(\s|$)/,excludeEnd:!0}]},{className:"pi",variants:[{begin:"//",end:"//[gim]*",contains:[SUBST,hljs.HASH_COMMENT_MODE]},{begin:/\/(?![ *])(\\\/|.)*?\/[gim]*(?=\W|$)/}]},{className:"property",begin:"@"+JS_IDENT_RE},{begin:"``",end:"``",excludeBegin:!0,excludeEnd:!0,subLanguage:"javascript"}];SUBST.contains=EXPRESSIONS;var PARAMS={className:"params",begin:"\\(",returnBegin:!0,contains:[{begin:/\(/,end:/\)/,keywords:KEYWORDS,contains:["self"].concat(EXPRESSIONS)}]};return{aliases:["ls"],keywords:KEYWORDS,illegal:/\/\*/,contains:EXPRESSIONS.concat([hljs.COMMENT("\\/\\*","\\*\\/"),hljs.HASH_COMMENT_MODE,{className:"function",contains:[TITLE,PARAMS],returnBegin:!0,variants:[{begin:"("+JS_IDENT_RE+"\\s*(?:=|:=)\\s*)?(\\(.*\\))?\\s*\\B\\->\\*?",end:"\\->\\*?"},{begin:"("+JS_IDENT_RE+"\\s*(?:=|:=)\\s*)?!?(\\(.*\\))?\\s*\\B[-~]{1,2}>\\*?",end:"[-~]{1,2}>\\*?"},{begin:"("+JS_IDENT_RE+"\\s*(?:=|:=)\\s*)?(\\(.*\\))?\\s*\\B!?[-~]{1,2}>\\*?",end:"!?[-~]{1,2}>\\*?"}]},{className:"class",beginKeywords:"class",end:"$",illegal:/[:="\[\]]/,contains:[{beginKeywords:"extends",endsWithParent:!0,illegal:/[:="\[\]]/,contains:[TITLE]},TITLE]},{className:"attribute",begin:JS_IDENT_RE+":",end:":",returnBegin:!0,returnEnd:!0,relevance:0}])}}),hljs.registerLanguage("lua",function(hljs){var OPENING_LONG_BRACKET="\\[=*\\[",CLOSING_LONG_BRACKET="\\]=*\\]",LONG_BRACKETS={begin:OPENING_LONG_BRACKET,end:CLOSING_LONG_BRACKET,contains:["self"]},COMMENTS=[hljs.COMMENT("--(?!"+OPENING_LONG_BRACKET+")","$"),hljs.COMMENT("--"+OPENING_LONG_BRACKET,CLOSING_LONG_BRACKET,{contains:[LONG_BRACKETS],relevance:10})];return{lexemes:hljs.UNDERSCORE_IDENT_RE,keywords:{keyword:"and break do else elseif end false for if in local nil not or repeat return then true until while",built_in:"_G _VERSION assert collectgarbage dofile error getfenv getmetatable ipairs load loadfile loadstring module next pairs pcall print rawequal rawget rawset require select setfenv setmetatable tonumber tostring type unpack xpcall coroutine debug io math os package string table"},contains:COMMENTS.concat([{className:"function",beginKeywords:"function",end:"\\)",contains:[hljs.inherit(hljs.TITLE_MODE,{begin:"([_a-zA-Z]\\w*\\.)*([_a-zA-Z]\\w*:)?[_a-zA-Z]\\w*"}),{className:"params",begin:"\\(",endsWithParent:!0,contains:COMMENTS}].concat(COMMENTS)},hljs.C_NUMBER_MODE,hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,{className:"string",begin:OPENING_LONG_BRACKET,end:CLOSING_LONG_BRACKET,contains:[LONG_BRACKETS],relevance:5}])}}),hljs.registerLanguage("makefile",function(hljs){var VARIABLE={className:"variable",begin:/\$\(/,end:/\)/,contains:[hljs.BACKSLASH_ESCAPE]};return{aliases:["mk","mak"],contains:[hljs.HASH_COMMENT_MODE,{begin:/^\w+\s*\W*=/,returnBegin:!0,relevance:0,starts:{className:"constant",end:/\s*\W*=/,excludeEnd:!0,starts:{end:/$/,relevance:0,contains:[VARIABLE]}}},{className:"title",begin:/^[\w]+:\s*$/},{className:"phony",begin:/^\.PHONY:/,end:/$/,keywords:".PHONY",lexemes:/[\.\w]+/},{begin:/^\t+/,end:/$/,relevance:0,contains:[hljs.QUOTE_STRING_MODE,VARIABLE]}]}}),hljs.registerLanguage("mathematica",function(hljs){return{aliases:["mma"],lexemes:"(\\$|\\b)"+hljs.IDENT_RE+"\\b",keywords:"AbelianGroup Abort AbortKernels AbortProtect Above Abs Absolute AbsoluteCorrelation AbsoluteCorrelationFunction AbsoluteCurrentValue AbsoluteDashing AbsoluteFileName AbsoluteOptions AbsolutePointSize AbsoluteThickness AbsoluteTime AbsoluteTiming AccountingForm Accumulate Accuracy AccuracyGoal ActionDelay ActionMenu ActionMenuBox ActionMenuBoxOptions Active ActiveItem ActiveStyle AcyclicGraphQ AddOnHelpPath AddTo AdjacencyGraph AdjacencyList AdjacencyMatrix AdjustmentBox AdjustmentBoxOptions AdjustTimeSeriesForecast AffineTransform After AiryAi AiryAiPrime AiryAiZero AiryBi AiryBiPrime AiryBiZero AlgebraicIntegerQ AlgebraicNumber AlgebraicNumberDenominator AlgebraicNumberNorm AlgebraicNumberPolynomial AlgebraicNumberTrace AlgebraicRules AlgebraicRulesData Algebraics AlgebraicUnitQ Alignment AlignmentMarker AlignmentPoint All AllowedDimensions AllowGroupClose AllowInlineCells AllowKernelInitialization AllowReverseGroupClose AllowScriptLevelChange AlphaChannel AlternatingGroup AlternativeHypothesis Alternatives AmbientLight Analytic AnchoredSearch And AndersonDarlingTest AngerJ AngleBracket AngularGauge Animate AnimationCycleOffset AnimationCycleRepetitions AnimationDirection AnimationDisplayTime AnimationRate AnimationRepetitions AnimationRunning Animator AnimatorBox AnimatorBoxOptions AnimatorElements Annotation Annuity AnnuityDue Antialiasing Antisymmetric Apart ApartSquareFree Appearance AppearanceElements AppellF1 Append AppendTo Apply ArcCos ArcCosh ArcCot ArcCoth ArcCsc ArcCsch ArcSec ArcSech ArcSin ArcSinDistribution ArcSinh ArcTan ArcTanh Arg ArgMax ArgMin ArgumentCountQ ARIMAProcess ArithmeticGeometricMean ARMAProcess ARProcess Array ArrayComponents ArrayDepth ArrayFlatten ArrayPad ArrayPlot ArrayQ ArrayReshape ArrayRules Arrays Arrow Arrow3DBox ArrowBox Arrowheads AspectRatio AspectRatioFixed Assert Assuming Assumptions AstronomicalData Asynchronous AsynchronousTaskObject AsynchronousTasks AtomQ Attributes AugmentedSymmetricPolynomial AutoAction AutoDelete AutoEvaluateEvents AutoGeneratedPackage AutoIndent AutoIndentSpacings AutoItalicWords AutoloadPath AutoMatch Automatic AutomaticImageSize AutoMultiplicationSymbol AutoNumberFormatting AutoOpenNotebooks AutoOpenPalettes AutorunSequencing AutoScaling AutoScroll AutoSpacing AutoStyleOptions AutoStyleWords Axes AxesEdge AxesLabel AxesOrigin AxesStyle Axis BabyMonsterGroupB Back Background BackgroundTasksSettings Backslash Backsubstitution Backward Band BandpassFilter BandstopFilter BarabasiAlbertGraphDistribution BarChart BarChart3D BarLegend BarlowProschanImportance BarnesG BarOrigin BarSpacing BartlettHannWindow BartlettWindow BaseForm Baseline BaselinePosition BaseStyle BatesDistribution BattleLemarieWavelet Because BeckmannDistribution Beep Before Begin BeginDialogPacket BeginFrontEndInteractionPacket BeginPackage BellB BellY Below BenfordDistribution BeniniDistribution BenktanderGibratDistribution BenktanderWeibullDistribution BernoulliB BernoulliDistribution BernoulliGraphDistribution BernoulliProcess BernsteinBasis BesselFilterModel BesselI BesselJ BesselJZero BesselK BesselY BesselYZero Beta BetaBinomialDistribution BetaDistribution BetaNegativeBinomialDistribution BetaPrimeDistribution BetaRegularized BetweennessCentrality BezierCurve BezierCurve3DBox BezierCurve3DBoxOptions BezierCurveBox BezierCurveBoxOptions BezierFunction BilateralFilter Binarize BinaryFormat BinaryImageQ BinaryRead BinaryReadList BinaryWrite BinCounts BinLists Binomial BinomialDistribution BinomialProcess BinormalDistribution BiorthogonalSplineWavelet BipartiteGraphQ BirnbaumImportance BirnbaumSaundersDistribution BitAnd BitClear BitGet BitLength BitNot BitOr BitSet BitShiftLeft BitShiftRight BitXor Black BlackmanHarrisWindow BlackmanNuttallWindow BlackmanWindow Blank BlankForm BlankNullSequence BlankSequence Blend Block BlockRandom BlomqvistBeta BlomqvistBetaTest Blue Blur BodePlot BohmanWindow Bold Bookmarks Boole BooleanConsecutiveFunction BooleanConvert BooleanCountingFunction BooleanFunction BooleanGraph BooleanMaxterms BooleanMinimize BooleanMinterms Booleans BooleanTable BooleanVariables BorderDimensions BorelTannerDistribution Bottom BottomHatTransform BoundaryStyle Bounds Box BoxBaselineShift BoxData BoxDimensions Boxed Boxes BoxForm BoxFormFormatTypes BoxFrame BoxID BoxMargins BoxMatrix BoxRatios BoxRotation BoxRotationPoint BoxStyle BoxWhiskerChart Bra BracketingBar BraKet BrayCurtisDistance BreadthFirstScan Break Brown BrownForsytheTest BrownianBridgeProcess BrowserCategory BSplineBasis BSplineCurve BSplineCurve3DBox BSplineCurveBox BSplineCurveBoxOptions BSplineFunction BSplineSurface BSplineSurface3DBox BubbleChart BubbleChart3D BubbleScale BubbleSizes BulletGauge BusinessDayQ ButterflyGraph ButterworthFilterModel Button ButtonBar ButtonBox ButtonBoxOptions ButtonCell ButtonContents ButtonData ButtonEvaluator ButtonExpandable ButtonFrame ButtonFunction ButtonMargins ButtonMinHeight ButtonNote ButtonNotebook ButtonSource ButtonStyle ButtonStyleMenuListing Byte ByteCount ByteOrdering C CachedValue CacheGraphics CalendarData CalendarType CallPacket CanberraDistance Cancel CancelButton CandlestickChart Cap CapForm CapitalDifferentialD CardinalBSplineBasis CarmichaelLambda Cases Cashflow Casoratian Catalan CatalanNumber Catch CauchyDistribution CauchyWindow CayleyGraph CDF CDFDeploy CDFInformation CDFWavelet Ceiling Cell CellAutoOverwrite CellBaseline CellBoundingBox CellBracketOptions CellChangeTimes CellContents CellContext CellDingbat CellDynamicExpression CellEditDuplicate CellElementsBoundingBox CellElementSpacings CellEpilog CellEvaluationDuplicate CellEvaluationFunction CellEventActions CellFrame CellFrameColor CellFrameLabelMargins CellFrameLabels CellFrameMargins CellGroup CellGroupData CellGrouping CellGroupingRules CellHorizontalScrolling CellID CellLabel CellLabelAutoDelete CellLabelMargins CellLabelPositioning CellMargins CellObject CellOpen CellPrint CellProlog Cells CellSize CellStyle CellTags CellularAutomaton CensoredDistribution Censoring Center CenterDot CentralMoment CentralMomentGeneratingFunction CForm ChampernowneNumber ChanVeseBinarize Character CharacterEncoding CharacterEncodingsPath CharacteristicFunction CharacteristicPolynomial CharacterRange Characters ChartBaseStyle ChartElementData ChartElementDataFunction ChartElementFunction ChartElements ChartLabels ChartLayout ChartLegends ChartStyle Chebyshev1FilterModel Chebyshev2FilterModel ChebyshevDistance ChebyshevT ChebyshevU Check CheckAbort CheckAll Checkbox CheckboxBar CheckboxBox CheckboxBoxOptions ChemicalData ChessboardDistance ChiDistribution ChineseRemainder ChiSquareDistribution ChoiceButtons ChoiceDialog CholeskyDecomposition Chop Circle CircleBox CircleDot CircleMinus CirclePlus CircleTimes CirculantGraph CityData Clear ClearAll ClearAttributes ClearSystemCache ClebschGordan ClickPane Clip ClipboardNotebook ClipFill ClippingStyle ClipPlanes ClipRange Clock ClockGauge ClockwiseContourIntegral Close Closed CloseKernels ClosenessCentrality Closing ClosingAutoSave ClosingEvent ClusteringComponents CMYKColor Coarse Coefficient CoefficientArrays CoefficientDomain CoefficientList CoefficientRules CoifletWavelet Collect Colon ColonForm ColorCombine ColorConvert ColorData ColorDataFunction ColorFunction ColorFunctionScaling Colorize ColorNegate ColorOutput ColorProfileData ColorQuantize ColorReplace ColorRules ColorSelectorSettings ColorSeparate ColorSetter ColorSetterBox ColorSetterBoxOptions ColorSlider ColorSpace Column ColumnAlignments ColumnBackgrounds ColumnForm ColumnLines ColumnsEqual ColumnSpacings ColumnWidths CommonDefaultFormatTypes Commonest CommonestFilter CommonUnits CommunityBoundaryStyle CommunityGraphPlot CommunityLabels CommunityRegionStyle CompatibleUnitQ CompilationOptions CompilationTarget Compile Compiled CompiledFunction Complement CompleteGraph CompleteGraphQ CompleteKaryTree CompletionsListPacket Complex Complexes ComplexExpand ComplexInfinity ComplexityFunction ComponentMeasurements ComponentwiseContextMenu Compose ComposeList ComposeSeries Composition CompoundExpression CompoundPoissonDistribution CompoundPoissonProcess CompoundRenewalProcess Compress CompressedData Condition ConditionalExpression Conditioned Cone ConeBox ConfidenceLevel ConfidenceRange ConfidenceTransform ConfigurationPath Congruent Conjugate ConjugateTranspose Conjunction Connect ConnectedComponents ConnectedGraphQ ConnesWindow ConoverTest ConsoleMessage ConsoleMessagePacket ConsolePrint Constant ConstantArray Constants ConstrainedMax ConstrainedMin ContentPadding ContentsBoundingBox ContentSelectable ContentSize Context ContextMenu Contexts ContextToFilename ContextToFileName Continuation Continue ContinuedFraction ContinuedFractionK ContinuousAction ContinuousMarkovProcess ContinuousTimeModelQ ContinuousWaveletData ContinuousWaveletTransform ContourDetect ContourGraphics ContourIntegral ContourLabels ContourLines ContourPlot ContourPlot3D Contours ContourShading ContourSmoothing ContourStyle ContraharmonicMean Control ControlActive ControlAlignment ControllabilityGramian ControllabilityMatrix ControllableDecomposition ControllableModelQ ControllerDuration ControllerInformation ControllerInformationData ControllerLinking ControllerManipulate ControllerMethod ControllerPath ControllerState ControlPlacement ControlsRendering ControlType Convergents ConversionOptions ConversionRules ConvertToBitmapPacket ConvertToPostScript ConvertToPostScriptPacket Convolve ConwayGroupCo1 ConwayGroupCo2 ConwayGroupCo3 CoordinateChartData CoordinatesToolOptions CoordinateTransform CoordinateTransformData CoprimeQ Coproduct CopulaDistribution Copyable CopyDirectory CopyFile CopyTag CopyToClipboard CornerFilter CornerNeighbors Correlation CorrelationDistance CorrelationFunction CorrelationTest Cos Cosh CoshIntegral CosineDistance CosineWindow CosIntegral Cot Coth Count CounterAssignments CounterBox CounterBoxOptions CounterClockwiseContourIntegral CounterEvaluator CounterFunction CounterIncrements CounterStyle CounterStyleMenuListing CountRoots CountryData Covariance CovarianceEstimatorFunction CovarianceFunction CoxianDistribution CoxIngersollRossProcess CoxModel CoxModelFit CramerVonMisesTest CreateArchive CreateDialog CreateDirectory CreateDocument CreateIntermediateDirectories CreatePalette CreatePalettePacket CreateScheduledTask CreateTemporary CreateWindow CriticalityFailureImportance CriticalitySuccessImportance CriticalSection Cross CrossingDetect CrossMatrix Csc Csch CubeRoot Cubics Cuboid CuboidBox Cumulant CumulantGeneratingFunction Cup CupCap Curl CurlyDoubleQuote CurlyQuote CurrentImage CurrentlySpeakingPacket CurrentValue CurvatureFlowFilter CurveClosed Cyan CycleGraph CycleIndexPolynomial Cycles CyclicGroup Cyclotomic Cylinder CylinderBox CylindricalDecomposition D DagumDistribution DamerauLevenshteinDistance DampingFactor Darker Dashed Dashing DataCompression DataDistribution DataRange DataReversed Date DateDelimiters DateDifference DateFunction DateList DateListLogPlot DateListPlot DatePattern DatePlus DateRange DateString DateTicksFormat DaubechiesWavelet DavisDistribution DawsonF DayCount DayCountConvention DayMatchQ DayName DayPlus DayRange DayRound DeBruijnGraph Debug DebugTag Decimal DeclareKnownSymbols DeclarePackage Decompose Decrement DedekindEta Default DefaultAxesStyle DefaultBaseStyle DefaultBoxStyle DefaultButton DefaultColor DefaultControlPlacement DefaultDuplicateCellStyle DefaultDuration DefaultElement DefaultFaceGridsStyle DefaultFieldHintStyle DefaultFont DefaultFontProperties DefaultFormatType DefaultFormatTypeForStyle DefaultFrameStyle DefaultFrameTicksStyle DefaultGridLinesStyle DefaultInlineFormatType DefaultInputFormatType DefaultLabelStyle DefaultMenuStyle DefaultNaturalLanguage DefaultNewCellStyle DefaultNewInlineCellStyle DefaultNotebook DefaultOptions DefaultOutputFormatType DefaultStyle DefaultStyleDefinitions DefaultTextFormatType DefaultTextInlineFormatType DefaultTicksStyle DefaultTooltipStyle DefaultValues Defer DefineExternal DefineInputStreamMethod DefineOutputStreamMethod Definition Degree DegreeCentrality DegreeGraphDistribution DegreeLexicographic DegreeReverseLexicographic Deinitialization Del Deletable Delete DeleteBorderComponents DeleteCases DeleteContents DeleteDirectory DeleteDuplicates DeleteFile DeleteSmallComponents DeleteWithContents DeletionWarning Delimiter DelimiterFlashTime DelimiterMatching Delimiters Denominator DensityGraphics DensityHistogram DensityPlot DependentVariables Deploy Deployed Depth DepthFirstScan Derivative DerivativeFilter DescriptorStateSpace DesignMatrix Det DGaussianWavelet DiacriticalPositioning Diagonal DiagonalMatrix Dialog DialogIndent DialogInput DialogLevel DialogNotebook DialogProlog DialogReturn DialogSymbols Diamond DiamondMatrix DiceDissimilarity DictionaryLookup DifferenceDelta DifferenceOrder DifferenceRoot DifferenceRootReduce Differences DifferentialD DifferentialRoot DifferentialRootReduce DifferentiatorFilter DigitBlock DigitBlockMinimum DigitCharacter DigitCount DigitQ DihedralGroup Dilation Dimensions DiracComb DiracDelta DirectedEdge DirectedEdges DirectedGraph DirectedGraphQ DirectedInfinity Direction Directive Directory DirectoryName DirectoryQ DirectoryStack DirichletCharacter DirichletConvolve DirichletDistribution DirichletL DirichletTransform DirichletWindow DisableConsolePrintPacket DiscreteChirpZTransform DiscreteConvolve DiscreteDelta DiscreteHadamardTransform DiscreteIndicator DiscreteLQEstimatorGains DiscreteLQRegulatorGains DiscreteLyapunovSolve DiscreteMarkovProcess DiscretePlot DiscretePlot3D DiscreteRatio DiscreteRiccatiSolve DiscreteShift DiscreteTimeModelQ DiscreteUniformDistribution DiscreteVariables DiscreteWaveletData DiscreteWaveletPacketTransform DiscreteWaveletTransform Discriminant Disjunction Disk DiskBox DiskMatrix Dispatch DispersionEstimatorFunction Display DisplayAllSteps DisplayEndPacket DisplayFlushImagePacket DisplayForm DisplayFunction DisplayPacket DisplayRules DisplaySetSizePacket DisplayString DisplayTemporary DisplayWith DisplayWithRef DisplayWithVariable DistanceFunction DistanceTransform Distribute Distributed DistributedContexts DistributeDefinitions DistributionChart DistributionDomain DistributionFitTest DistributionParameterAssumptions DistributionParameterQ Dithering Div Divergence Divide DivideBy Dividers Divisible Divisors DivisorSigma DivisorSum DMSList DMSString Do DockedCells DocumentNotebook DominantColors DOSTextFormat Dot DotDashed DotEqual Dotted DoubleBracketingBar DoubleContourIntegral DoubleDownArrow DoubleLeftArrow DoubleLeftRightArrow DoubleLeftTee DoubleLongLeftArrow DoubleLongLeftRightArrow DoubleLongRightArrow DoubleRightArrow DoubleRightTee DoubleUpArrow DoubleUpDownArrow DoubleVerticalBar DoublyInfinite Down DownArrow DownArrowBar DownArrowUpArrow DownLeftRightVector DownLeftTeeVector DownLeftVector DownLeftVectorBar DownRightTeeVector DownRightVector DownRightVectorBar Downsample DownTee DownTeeArrow DownValues DragAndDrop DrawEdges DrawFrontFaces DrawHighlighted Drop DSolve Dt DualLinearProgramming DualSystemsModel DumpGet DumpSave DuplicateFreeQ Dynamic DynamicBox DynamicBoxOptions DynamicEvaluationTimeout DynamicLocation DynamicModule DynamicModuleBox DynamicModuleBoxOptions DynamicModuleParent DynamicModuleValues DynamicName DynamicNamespace DynamicReference DynamicSetting DynamicUpdating DynamicWrapper DynamicWrapperBox DynamicWrapperBoxOptions E EccentricityCentrality EdgeAdd EdgeBetweennessCentrality EdgeCapacity EdgeCapForm EdgeColor EdgeConnectivity EdgeCost EdgeCount EdgeCoverQ EdgeDashing EdgeDelete EdgeDetect EdgeForm EdgeIndex EdgeJoinForm EdgeLabeling EdgeLabels EdgeLabelStyle EdgeList EdgeOpacity EdgeQ EdgeRenderingFunction EdgeRules EdgeShapeFunction EdgeStyle EdgeThickness EdgeWeight Editable EditButtonSettings EditCellTagsSettings EditDistance EffectiveInterest Eigensystem Eigenvalues EigenvectorCentrality Eigenvectors Element ElementData Eliminate EliminationOrder EllipticE EllipticExp EllipticExpPrime EllipticF EllipticFilterModel EllipticK EllipticLog EllipticNomeQ EllipticPi EllipticReducedHalfPeriods EllipticTheta EllipticThetaPrime EmitSound EmphasizeSyntaxErrors EmpiricalDistribution Empty EmptyGraphQ EnableConsolePrintPacket Enabled Encode End EndAdd EndDialogPacket EndFrontEndInteractionPacket EndOfFile EndOfLine EndOfString EndPackage EngineeringForm Enter EnterExpressionPacket EnterTextPacket Entropy EntropyFilter Environment Epilog Equal EqualColumns EqualRows EqualTilde EquatedTo Equilibrium EquirippleFilterKernel Equivalent Erf Erfc Erfi ErlangB ErlangC ErlangDistribution Erosion ErrorBox ErrorBoxOptions ErrorNorm ErrorPacket ErrorsDialogSettings EstimatedDistribution EstimatedProcess EstimatorGains EstimatorRegulator EuclideanDistance EulerE EulerGamma EulerianGraphQ EulerPhi Evaluatable Evaluate Evaluated EvaluatePacket EvaluationCell EvaluationCompletionAction EvaluationElements EvaluationMode EvaluationMonitor EvaluationNotebook EvaluationObject EvaluationOrder Evaluator EvaluatorNames EvenQ EventData EventEvaluator EventHandler EventHandlerTag EventLabels ExactBlackmanWindow ExactNumberQ ExactRootIsolation ExampleData Except ExcludedForms ExcludePods Exclusions ExclusionsStyle Exists Exit ExitDialog Exp Expand ExpandAll ExpandDenominator ExpandFileName ExpandNumerator Expectation ExpectationE ExpectedValue ExpGammaDistribution ExpIntegralE ExpIntegralEi Exponent ExponentFunction ExponentialDistribution ExponentialFamily ExponentialGeneratingFunction ExponentialMovingAverage ExponentialPowerDistribution ExponentPosition ExponentStep Export ExportAutoReplacements ExportPacket ExportString Expression ExpressionCell ExpressionPacket ExpToTrig ExtendedGCD Extension ExtentElementFunction ExtentMarkers ExtentSize ExternalCall ExternalDataCharacterEncoding Extract ExtractArchive ExtremeValueDistribution FaceForm FaceGrids FaceGridsStyle Factor FactorComplete Factorial Factorial2 FactorialMoment FactorialMomentGeneratingFunction FactorialPower FactorInteger FactorList FactorSquareFree FactorSquareFreeList FactorTerms FactorTermsList Fail FailureDistribution False FARIMAProcess FEDisableConsolePrintPacket FeedbackSector FeedbackSectorStyle FeedbackType FEEnableConsolePrintPacket Fibonacci FieldHint FieldHintStyle FieldMasked FieldSize File FileBaseName FileByteCount FileDate FileExistsQ FileExtension FileFormat FileHash FileInformation FileName FileNameDepth FileNameDialogSettings FileNameDrop FileNameJoin FileNames FileNameSetter FileNameSplit FileNameTake FilePrint FileType FilledCurve FilledCurveBox Filling FillingStyle FillingTransform FilterRules FinancialBond FinancialData FinancialDerivative FinancialIndicator Find FindArgMax FindArgMin FindClique FindClusters FindCurvePath FindDistributionParameters FindDivisions FindEdgeCover FindEdgeCut FindEulerianCycle FindFaces FindFile FindFit FindGeneratingFunction FindGeoLocation FindGeometricTransform FindGraphCommunities FindGraphIsomorphism FindGraphPartition FindHamiltonianCycle FindIndependentEdgeSet FindIndependentVertexSet FindInstance FindIntegerNullVector FindKClan FindKClique FindKClub FindKPlex FindLibrary FindLinearRecurrence FindList FindMaximum FindMaximumFlow FindMaxValue FindMinimum FindMinimumCostFlow FindMinimumCut FindMinValue FindPermutation FindPostmanTour FindProcessParameters FindRoot FindSequenceFunction FindSettings FindShortestPath FindShortestTour FindThreshold FindVertexCover FindVertexCut Fine FinishDynamic FiniteAbelianGroupCount FiniteGroupCount FiniteGroupData First FirstPassageTimeDistribution FischerGroupFi22 FischerGroupFi23 FischerGroupFi24Prime FisherHypergeometricDistribution FisherRatioTest FisherZDistribution Fit FitAll FittedModel FixedPoint FixedPointList FlashSelection Flat Flatten FlattenAt FlatTopWindow FlipView Floor FlushPrintOutputPacket Fold FoldList Font FontColor FontFamily FontForm FontName FontOpacity FontPostScriptName FontProperties FontReencoding FontSize FontSlant FontSubstitutions FontTracking FontVariations FontWeight For ForAll Format FormatRules FormatType FormatTypeAutoConvert FormatValues FormBox FormBoxOptions FortranForm Forward ForwardBackward Fourier FourierCoefficient FourierCosCoefficient FourierCosSeries FourierCosTransform FourierDCT FourierDCTFilter FourierDCTMatrix FourierDST FourierDSTMatrix FourierMatrix FourierParameters FourierSequenceTransform FourierSeries FourierSinCoefficient FourierSinSeries FourierSinTransform FourierTransform FourierTrigSeries FractionalBrownianMotionProcess FractionalPart FractionBox FractionBoxOptions FractionLine Frame FrameBox FrameBoxOptions Framed FrameInset FrameLabel Frameless FrameMargins FrameStyle FrameTicks FrameTicksStyle FRatioDistribution FrechetDistribution FreeQ FrequencySamplingFilterKernel FresnelC FresnelS Friday FrobeniusNumber FrobeniusSolve FromCharacterCode FromCoefficientRules FromContinuedFraction FromDate FromDigits FromDMS Front FrontEndDynamicExpression FrontEndEventActions FrontEndExecute FrontEndObject FrontEndResource FrontEndResourceString FrontEndStackSize FrontEndToken FrontEndTokenExecute FrontEndValueCache FrontEndVersion FrontFaceColor FrontFaceOpacity Full FullAxes FullDefinition FullForm FullGraphics FullOptions FullSimplify Function FunctionExpand FunctionInterpolation FunctionSpace FussellVeselyImportance GaborFilter GaborMatrix GaborWavelet GainMargins GainPhaseMargins Gamma GammaDistribution GammaRegularized GapPenalty Gather GatherBy GaugeFaceElementFunction GaugeFaceStyle GaugeFrameElementFunction GaugeFrameSize GaugeFrameStyle GaugeLabels GaugeMarkers GaugeStyle GaussianFilter GaussianIntegers GaussianMatrix GaussianWindow GCD GegenbauerC General GeneralizedLinearModelFit GenerateConditions GeneratedCell GeneratedParameters GeneratingFunction Generic GenericCylindricalDecomposition GenomeData GenomeLookup GeodesicClosing GeodesicDilation GeodesicErosion GeodesicOpening GeoDestination GeodesyData GeoDirection GeoDistance GeoGridPosition GeometricBrownianMotionProcess GeometricDistribution GeometricMean GeometricMeanFilter GeometricTransformation GeometricTransformation3DBox GeometricTransformation3DBoxOptions GeometricTransformationBox GeometricTransformationBoxOptions GeoPosition GeoPositionENU GeoPositionXYZ GeoProjectionData GestureHandler GestureHandlerTag Get GetBoundingBoxSizePacket GetContext GetEnvironment GetFileName GetFrontEndOptionsDataPacket GetLinebreakInformationPacket GetMenusPacket GetPageBreakInformationPacket Glaisher GlobalClusteringCoefficient GlobalPreferences GlobalSession Glow GoldenRatio GompertzMakehamDistribution GoodmanKruskalGamma GoodmanKruskalGammaTest Goto Grad Gradient GradientFilter GradientOrientationFilter Graph GraphAssortativity GraphCenter GraphComplement GraphData GraphDensity GraphDiameter GraphDifference GraphDisjointUnion GraphDistance GraphDistanceMatrix GraphElementData GraphEmbedding GraphHighlight GraphHighlightStyle GraphHub Graphics Graphics3D Graphics3DBox Graphics3DBoxOptions GraphicsArray GraphicsBaseline GraphicsBox GraphicsBoxOptions GraphicsColor GraphicsColumn GraphicsComplex GraphicsComplex3DBox GraphicsComplex3DBoxOptions GraphicsComplexBox GraphicsComplexBoxOptions GraphicsContents GraphicsData GraphicsGrid GraphicsGridBox GraphicsGroup GraphicsGroup3DBox GraphicsGroup3DBoxOptions GraphicsGroupBox GraphicsGroupBoxOptions GraphicsGrouping GraphicsHighlightColor GraphicsRow GraphicsSpacing GraphicsStyle GraphIntersection GraphLayout GraphLinkEfficiency GraphPeriphery GraphPlot GraphPlot3D GraphPower GraphPropertyDistribution GraphQ GraphRadius GraphReciprocity GraphRoot GraphStyle GraphUnion Gray GrayLevel GreatCircleDistance Greater GreaterEqual GreaterEqualLess GreaterFullEqual GreaterGreater GreaterLess GreaterSlantEqual GreaterTilde Green Grid GridBaseline GridBox GridBoxAlignment GridBoxBackground GridBoxDividers GridBoxFrame GridBoxItemSize GridBoxItemStyle GridBoxOptions GridBoxSpacings GridCreationSettings GridDefaultElement GridElementStyleOptions GridFrame GridFrameMargins GridGraph GridLines GridLinesStyle GroebnerBasis GroupActionBase GroupCentralizer GroupElementFromWord GroupElementPosition GroupElementQ GroupElements GroupElementToWord GroupGenerators GroupMultiplicationTable GroupOrbits GroupOrder GroupPageBreakWithin GroupSetwiseStabilizer GroupStabilizer GroupStabilizerChain Gudermannian GumbelDistribution HaarWavelet HadamardMatrix HalfNormalDistribution HamiltonianGraphQ HammingDistance HammingWindow HankelH1 HankelH2 HankelMatrix HannPoissonWindow HannWindow HaradaNortonGroupHN HararyGraph HarmonicMean HarmonicMeanFilter HarmonicNumber Hash HashTable Haversine HazardFunction Head HeadCompose Heads HeavisideLambda HeavisidePi HeavisideTheta HeldGroupHe HeldPart HelpBrowserLookup HelpBrowserNotebook HelpBrowserSettings HermiteDecomposition HermiteH HermitianMatrixQ HessenbergDecomposition Hessian HexadecimalCharacter Hexahedron HexahedronBox HexahedronBoxOptions HiddenSurface HighlightGraph HighlightImage HighpassFilter HigmanSimsGroupHS HilbertFilter HilbertMatrix Histogram Histogram3D HistogramDistribution HistogramList HistogramTransform HistogramTransformInterpolation HitMissTransform HITSCentrality HodgeDual HoeffdingD HoeffdingDTest Hold HoldAll HoldAllComplete HoldComplete HoldFirst HoldForm HoldPattern HoldRest HolidayCalendar HomeDirectory HomePage Horizontal HorizontalForm HorizontalGauge HorizontalScrollPosition HornerForm HotellingTSquareDistribution HoytDistribution HTMLSave Hue HumpDownHump HumpEqual HurwitzLerchPhi HurwitzZeta HyperbolicDistribution HypercubeGraph HyperexponentialDistribution Hyperfactorial Hypergeometric0F1 Hypergeometric0F1Regularized Hypergeometric1F1 Hypergeometric1F1Regularized Hypergeometric2F1 Hypergeometric2F1Regularized HypergeometricDistribution HypergeometricPFQ HypergeometricPFQRegularized HypergeometricU Hyperlink HyperlinkCreationSettings Hyphenation HyphenationOptions HypoexponentialDistribution HypothesisTestData I Identity IdentityMatrix If IgnoreCase Im Image Image3D Image3DSlices ImageAccumulate ImageAdd ImageAdjust ImageAlign ImageApply ImageAspectRatio ImageAssemble ImageCache ImageCacheValid ImageCapture ImageChannels ImageClip ImageColorSpace ImageCompose ImageConvolve ImageCooccurrence ImageCorners ImageCorrelate ImageCorrespondingPoints ImageCrop ImageData ImageDataPacket ImageDeconvolve ImageDemosaic ImageDifference ImageDimensions ImageDistance ImageEffect ImageFeatureTrack ImageFileApply ImageFileFilter ImageFileScan ImageFilter ImageForestingComponents ImageForwardTransformation ImageHistogram ImageKeypoints ImageLevels ImageLines ImageMargins ImageMarkers ImageMeasurements ImageMultiply ImageOffset ImagePad ImagePadding ImagePartition ImagePeriodogram ImagePerspectiveTransformation ImageQ ImageRangeCache ImageReflect ImageRegion ImageResize ImageResolution ImageRotate ImageRotated ImageScaled ImageScan ImageSize ImageSizeAction ImageSizeCache ImageSizeMultipliers ImageSizeRaw ImageSubtract ImageTake ImageTransformation ImageTrim ImageType ImageValue ImageValuePositions Implies Import ImportAutoReplacements ImportString ImprovementImportance In IncidenceGraph IncidenceList IncidenceMatrix IncludeConstantBasis IncludeFileExtension IncludePods IncludeSingularTerm Increment Indent IndentingNewlineSpacings IndentMaxFraction IndependenceTest IndependentEdgeSetQ IndependentUnit IndependentVertexSetQ Indeterminate IndexCreationOptions Indexed IndexGraph IndexTag Inequality InexactNumberQ InexactNumbers Infinity Infix Information Inherited InheritScope Initialization InitializationCell InitializationCellEvaluation InitializationCellWarning InlineCounterAssignments InlineCounterIncrements InlineRules Inner Inpaint Input InputAliases InputAssumptions InputAutoReplacements InputField InputFieldBox InputFieldBoxOptions InputForm InputGrouping InputNamePacket InputNotebook InputPacket InputSettings InputStream InputString InputStringPacket InputToBoxFormPacket Insert InsertionPointObject InsertResults Inset Inset3DBox Inset3DBoxOptions InsetBox InsetBoxOptions Install InstallService InString Integer IntegerDigits IntegerExponent IntegerLength IntegerPart IntegerPartitions IntegerQ Integers IntegerString Integral Integrate Interactive InteractiveTradingChart Interlaced Interleaving InternallyBalancedDecomposition InterpolatingFunction InterpolatingPolynomial Interpolation InterpolationOrder InterpolationPoints InterpolationPrecision Interpretation InterpretationBox InterpretationBoxOptions InterpretationFunction InterpretTemplate InterquartileRange Interrupt InterruptSettings Intersection Interval IntervalIntersection IntervalMemberQ IntervalUnion Inverse InverseBetaRegularized InverseCDF InverseChiSquareDistribution InverseContinuousWaveletTransform InverseDistanceTransform InverseEllipticNomeQ InverseErf InverseErfc InverseFourier InverseFourierCosTransform InverseFourierSequenceTransform InverseFourierSinTransform InverseFourierTransform InverseFunction InverseFunctions InverseGammaDistribution InverseGammaRegularized InverseGaussianDistribution InverseGudermannian InverseHaversine InverseJacobiCD InverseJacobiCN InverseJacobiCS InverseJacobiDC InverseJacobiDN InverseJacobiDS InverseJacobiNC InverseJacobiND InverseJacobiNS InverseJacobiSC InverseJacobiSD InverseJacobiSN InverseLaplaceTransform InversePermutation InverseRadon InverseSeries InverseSurvivalFunction InverseWaveletTransform InverseWeierstrassP InverseZTransform Invisible InvisibleApplication InvisibleTimes IrreduciblePolynomialQ IsolatingInterval IsomorphicGraphQ IsotopeData Italic Item ItemBox ItemBoxOptions ItemSize ItemStyle ItoProcess JaccardDissimilarity JacobiAmplitude Jacobian JacobiCD JacobiCN JacobiCS JacobiDC JacobiDN JacobiDS JacobiNC JacobiND JacobiNS JacobiP JacobiSC JacobiSD JacobiSN JacobiSymbol JacobiZeta JankoGroupJ1 JankoGroupJ2 JankoGroupJ3 JankoGroupJ4 JarqueBeraALMTest JohnsonDistribution Join Joined JoinedCurve JoinedCurveBox JoinForm JordanDecomposition JordanModelDecomposition K KagiChart KaiserBesselWindow KaiserWindow KalmanEstimator KalmanFilter KarhunenLoeveDecomposition KaryTree KatzCentrality KCoreComponents KDistribution KelvinBei KelvinBer KelvinKei KelvinKer KendallTau KendallTauTest KernelExecute KernelMixtureDistribution KernelObject Kernels Ket Khinchin KirchhoffGraph KirchhoffMatrix KleinInvariantJ KnightTourGraph KnotData KnownUnitQ KolmogorovSmirnovTest KroneckerDelta KroneckerModelDecomposition KroneckerProduct KroneckerSymbol KuiperTest KumaraswamyDistribution Kurtosis KuwaharaFilter Label Labeled LabeledSlider LabelingFunction LabelStyle LaguerreL LambdaComponents LambertW LanczosWindow LandauDistribution Language LanguageCategory LaplaceDistribution LaplaceTransform Laplacian LaplacianFilter LaplacianGaussianFilter Large Larger Last Latitude LatitudeLongitude LatticeData LatticeReduce Launch LaunchKernels LayeredGraphPlot LayerSizeFunction LayoutInformation LCM LeafCount LeapYearQ LeastSquares LeastSquaresFilterKernel Left LeftArrow LeftArrowBar LeftArrowRightArrow LeftDownTeeVector LeftDownVector LeftDownVectorBar LeftRightArrow LeftRightVector LeftTee LeftTeeArrow LeftTeeVector LeftTriangle LeftTriangleBar LeftTriangleEqual LeftUpDownVector LeftUpTeeVector LeftUpVector LeftUpVectorBar LeftVector LeftVectorBar LegendAppearance Legended LegendFunction LegendLabel LegendLayout LegendMargins LegendMarkers LegendMarkerSize LegendreP LegendreQ LegendreType Length LengthWhile LerchPhi Less LessEqual LessEqualGreater LessFullEqual LessGreater LessLess LessSlantEqual LessTilde LetterCharacter LetterQ Level LeveneTest LeviCivitaTensor LevyDistribution Lexicographic LibraryFunction LibraryFunctionError LibraryFunctionInformation LibraryFunctionLoad LibraryFunctionUnload LibraryLoad LibraryUnload LicenseID LiftingFilterData LiftingWaveletTransform LightBlue LightBrown LightCyan Lighter LightGray LightGreen Lighting LightingAngle LightMagenta LightOrange LightPink LightPurple LightRed LightSources LightYellow Likelihood Limit LimitsPositioning LimitsPositioningTokens LindleyDistribution Line Line3DBox LinearFilter LinearFractionalTransform LinearModelFit LinearOffsetFunction LinearProgramming LinearRecurrence LinearSolve LinearSolveFunction LineBox LineBreak LinebreakAdjustments LineBreakChart LineBreakWithin LineColor LineForm LineGraph LineIndent LineIndentMaxFraction LineIntegralConvolutionPlot LineIntegralConvolutionScale LineLegend LineOpacity LineSpacing LineWrapParts LinkActivate LinkClose LinkConnect LinkConnectedQ LinkCreate LinkError LinkFlush LinkFunction LinkHost LinkInterrupt LinkLaunch LinkMode LinkObject LinkOpen LinkOptions LinkPatterns LinkProtocol LinkRead LinkReadHeld LinkReadyQ Links LinkWrite LinkWriteHeld LiouvilleLambda List Listable ListAnimate ListContourPlot ListContourPlot3D ListConvolve ListCorrelate ListCurvePathPlot ListDeconvolve ListDensityPlot Listen ListFourierSequenceTransform ListInterpolation ListLineIntegralConvolutionPlot ListLinePlot ListLogLinearPlot ListLogLogPlot ListLogPlot ListPicker ListPickerBox ListPickerBoxBackground ListPickerBoxOptions ListPlay ListPlot ListPlot3D ListPointPlot3D ListPolarPlot ListQ ListStreamDensityPlot ListStreamPlot ListSurfacePlot3D ListVectorDensityPlot ListVectorPlot ListVectorPlot3D ListZTransform Literal LiteralSearch LocalClusteringCoefficient LocalizeVariables LocationEquivalenceTest LocationTest Locator LocatorAutoCreate LocatorBox LocatorBoxOptions LocatorCentering LocatorPane LocatorPaneBox LocatorPaneBoxOptions LocatorRegion Locked Log Log10 Log2 LogBarnesG LogGamma LogGammaDistribution LogicalExpand LogIntegral LogisticDistribution LogitModelFit LogLikelihood LogLinearPlot LogLogisticDistribution LogLogPlot LogMultinormalDistribution LogNormalDistribution LogPlot LogRankTest LogSeriesDistribution LongEqual Longest LongestAscendingSequence LongestCommonSequence LongestCommonSequencePositions LongestCommonSubsequence LongestCommonSubsequencePositions LongestMatch LongForm Longitude LongLeftArrow LongLeftRightArrow LongRightArrow Loopback LoopFreeGraphQ LowerCaseQ LowerLeftArrow LowerRightArrow LowerTriangularize LowpassFilter LQEstimatorGains LQGRegulator LQOutputRegulatorGains LQRegulatorGains LUBackSubstitution LucasL LuccioSamiComponents LUDecomposition LyapunovSolve LyonsGroupLy MachineID MachineName MachineNumberQ MachinePrecision MacintoshSystemPageSetup Magenta Magnification Magnify MainSolve MaintainDynamicCaches Majority MakeBoxes MakeExpression MakeRules MangoldtLambda ManhattanDistance Manipulate Manipulator MannWhitneyTest MantissaExponent Manual Map MapAll MapAt MapIndexed MAProcess MapThread MarcumQ MardiaCombinedTest MardiaKurtosisTest MardiaSkewnessTest MarginalDistribution MarkovProcessProperties Masking MatchingDissimilarity MatchLocalNameQ MatchLocalNames MatchQ Material MathematicaNotation MathieuC MathieuCharacteristicA MathieuCharacteristicB MathieuCharacteristicExponent MathieuCPrime MathieuGroupM11 MathieuGroupM12 MathieuGroupM22 MathieuGroupM23 MathieuGroupM24 MathieuS MathieuSPrime MathMLForm MathMLText Matrices MatrixExp MatrixForm MatrixFunction MatrixLog MatrixPlot MatrixPower MatrixQ MatrixRank Max MaxBend MaxDetect MaxExtraBandwidths MaxExtraConditions MaxFeatures MaxFilter Maximize MaxIterations MaxMemoryUsed MaxMixtureKernels MaxPlotPoints MaxPoints MaxRecursion MaxStableDistribution MaxStepFraction MaxSteps MaxStepSize MaxValue MaxwellDistribution McLaughlinGroupMcL Mean MeanClusteringCoefficient MeanDegreeConnectivity MeanDeviation MeanFilter MeanGraphDistance MeanNeighborDegree MeanShift MeanShiftFilter Median MedianDeviation MedianFilter Medium MeijerG MeixnerDistribution MemberQ MemoryConstrained MemoryInUse Menu MenuAppearance MenuCommandKey MenuEvaluator MenuItem MenuPacket MenuSortingValue MenuStyle MenuView MergeDifferences Mesh MeshFunctions MeshRange MeshShading MeshStyle Message MessageDialog MessageList MessageName MessageOptions MessagePacket Messages MessagesNotebook MetaCharacters MetaInformation Method MethodOptions MexicanHatWavelet MeyerWavelet Min MinDetect MinFilter MinimalPolynomial MinimalStateSpaceModel Minimize Minors MinRecursion MinSize MinStableDistribution Minus MinusPlus MinValue Missing MissingDataMethod MittagLefflerE MixedRadix MixedRadixQuantity MixtureDistribution Mod Modal Mode Modular ModularLambda Module Modulus MoebiusMu Moment Momentary MomentConvert MomentEvaluate MomentGeneratingFunction Monday Monitor MonomialList MonomialOrder MonsterGroupM MorletWavelet MorphologicalBinarize MorphologicalBranchPoints MorphologicalComponents MorphologicalEulerNumber MorphologicalGraph MorphologicalPerimeter MorphologicalTransform Most MouseAnnotation MouseAppearance MouseAppearanceTag MouseButtons Mouseover MousePointerNote MousePosition MovingAverage MovingMedian MoyalDistribution MultiedgeStyle MultilaunchWarning MultiLetterItalics MultiLetterStyle MultilineFunction Multinomial MultinomialDistribution MultinormalDistribution MultiplicativeOrder Multiplicity Multiselection MultivariateHypergeometricDistribution MultivariatePoissonDistribution MultivariateTDistribution N NakagamiDistribution NameQ Names NamespaceBox Nand NArgMax NArgMin NBernoulliB NCache NDSolve NDSolveValue Nearest NearestFunction NeedCurrentFrontEndPackagePacket NeedCurrentFrontEndSymbolsPacket NeedlemanWunschSimilarity Needs Negative NegativeBinomialDistribution NegativeMultinomialDistribution NeighborhoodGraph Nest NestedGreaterGreater NestedLessLess NestedScriptRules NestList NestWhile NestWhileList NevilleThetaC NevilleThetaD NevilleThetaN NevilleThetaS NewPrimitiveStyle NExpectation Next NextPrime NHoldAll NHoldFirst NHoldRest NicholsGridLines NicholsPlot NIntegrate NMaximize NMaxValue NMinimize NMinValue NominalVariables NonAssociative NoncentralBetaDistribution NoncentralChiSquareDistribution NoncentralFRatioDistribution NoncentralStudentTDistribution NonCommutativeMultiply NonConstants None NonlinearModelFit NonlocalMeansFilter NonNegative NonPositive Nor NorlundB Norm Normal NormalDistribution NormalGrouping Normalize NormalizedSquaredEuclideanDistance NormalsFunction NormFunction Not NotCongruent NotCupCap NotDoubleVerticalBar Notebook NotebookApply NotebookAutoSave NotebookClose NotebookConvertSettings NotebookCreate NotebookCreateReturnObject NotebookDefault NotebookDelete NotebookDirectory NotebookDynamicExpression NotebookEvaluate NotebookEventActions NotebookFileName NotebookFind NotebookFindReturnObject NotebookGet NotebookGetLayoutInformationPacket NotebookGetMisspellingsPacket NotebookInformation NotebookInterfaceObject NotebookLocate NotebookObject NotebookOpen NotebookOpenReturnObject NotebookPath NotebookPrint NotebookPut NotebookPutReturnObject NotebookRead NotebookResetGeneratedCells Notebooks NotebookSave NotebookSaveAs NotebookSelection NotebookSetupLayoutInformationPacket NotebooksMenu NotebookWrite NotElement NotEqualTilde NotExists NotGreater NotGreaterEqual NotGreaterFullEqual NotGreaterGreater NotGreaterLess NotGreaterSlantEqual NotGreaterTilde NotHumpDownHump NotHumpEqual NotLeftTriangle NotLeftTriangleBar NotLeftTriangleEqual NotLess NotLessEqual NotLessFullEqual NotLessGreater NotLessLess NotLessSlantEqual NotLessTilde NotNestedGreaterGreater NotNestedLessLess NotPrecedes NotPrecedesEqual NotPrecedesSlantEqual NotPrecedesTilde NotReverseElement NotRightTriangle NotRightTriangleBar NotRightTriangleEqual NotSquareSubset NotSquareSubsetEqual NotSquareSuperset NotSquareSupersetEqual NotSubset NotSubsetEqual NotSucceeds NotSucceedsEqual NotSucceedsSlantEqual NotSucceedsTilde NotSuperset NotSupersetEqual NotTilde NotTildeEqual NotTildeFullEqual NotTildeTilde NotVerticalBar NProbability NProduct NProductFactors NRoots NSolve NSum NSumTerms Null NullRecords NullSpace NullWords Number NumberFieldClassNumber NumberFieldDiscriminant NumberFieldFundamentalUnits NumberFieldIntegralBasis NumberFieldNormRepresentatives NumberFieldRegulator NumberFieldRootsOfUnity NumberFieldSignature NumberForm NumberFormat NumberMarks NumberMultiplier NumberPadding NumberPoint NumberQ NumberSeparator NumberSigns NumberString Numerator NumericFunction NumericQ NuttallWindow NValues NyquistGridLines NyquistPlot O ObservabilityGramian ObservabilityMatrix ObservableDecomposition ObservableModelQ OddQ Off Offset OLEData On ONanGroupON OneIdentity Opacity Open OpenAppend Opener OpenerBox OpenerBoxOptions OpenerView OpenFunctionInspectorPacket Opening OpenRead OpenSpecialOptions OpenTemporary OpenWrite Operate OperatingSystem OptimumFlowData Optional OptionInspectorSettings OptionQ Options OptionsPacket OptionsPattern OptionValue OptionValueBox OptionValueBoxOptions Or Orange Order OrderDistribution OrderedQ Ordering Orderless OrnsteinUhlenbeckProcess Orthogonalize Out Outer OutputAutoOverwrite OutputControllabilityMatrix OutputControllableModelQ OutputForm OutputFormData OutputGrouping OutputMathEditExpression OutputNamePacket OutputResponse OutputSizeLimit OutputStream Over OverBar OverDot Overflow OverHat Overlaps Overlay OverlayBox OverlayBoxOptions Overscript OverscriptBox OverscriptBoxOptions OverTilde OverVector OwenT OwnValues PackingMethod PaddedForm Padding PadeApproximant PadLeft PadRight PageBreakAbove PageBreakBelow PageBreakWithin PageFooterLines PageFooters PageHeaderLines PageHeaders PageHeight PageRankCentrality PageWidth PairedBarChart PairedHistogram PairedSmoothHistogram PairedTTest PairedZTest PaletteNotebook PalettePath Pane PaneBox PaneBoxOptions Panel PanelBox PanelBoxOptions Paneled PaneSelector PaneSelectorBox PaneSelectorBoxOptions PaperWidth ParabolicCylinderD ParagraphIndent ParagraphSpacing ParallelArray ParallelCombine ParallelDo ParallelEvaluate Parallelization Parallelize ParallelMap ParallelNeeds ParallelProduct ParallelSubmit ParallelSum ParallelTable ParallelTry Parameter ParameterEstimator ParameterMixtureDistribution ParameterVariables ParametricFunction ParametricNDSolve ParametricNDSolveValue ParametricPlot ParametricPlot3D ParentConnect ParentDirectory ParentForm Parenthesize ParentList ParetoDistribution Part PartialCorrelationFunction PartialD ParticleData Partition PartitionsP PartitionsQ ParzenWindow PascalDistribution PassEventsDown PassEventsUp Paste PasteBoxFormInlineCells PasteButton Path PathGraph PathGraphQ Pattern PatternSequence PatternTest PauliMatrix PaulWavelet Pause PausedTime PDF PearsonChiSquareTest PearsonCorrelationTest PearsonDistribution PerformanceGoal PeriodicInterpolation Periodogram PeriodogramArray PermutationCycles PermutationCyclesQ PermutationGroup PermutationLength PermutationList PermutationListQ PermutationMax PermutationMin PermutationOrder PermutationPower PermutationProduct PermutationReplace Permutations PermutationSupport Permute PeronaMalikFilter Perpendicular PERTDistribution PetersenGraph PhaseMargins Pi Pick PIDData PIDDerivativeFilter PIDFeedforward PIDTune Piecewise PiecewiseExpand PieChart PieChart3D PillaiTrace PillaiTraceTest Pink Pivoting PixelConstrained PixelValue PixelValuePositions Placed Placeholder PlaceholderReplace Plain PlanarGraphQ Play PlayRange Plot Plot3D Plot3Matrix PlotDivision PlotJoined PlotLabel PlotLayout PlotLegends PlotMarkers PlotPoints PlotRange PlotRangeClipping PlotRangePadding PlotRegion PlotStyle Plus PlusMinus Pochhammer PodStates PodWidth Point Point3DBox PointBox PointFigureChart PointForm PointLegend PointSize PoissonConsulDistribution PoissonDistribution PoissonProcess PoissonWindow PolarAxes PolarAxesOrigin PolarGridLines PolarPlot PolarTicks PoleZeroMarkers PolyaAeppliDistribution PolyGamma Polygon Polygon3DBox Polygon3DBoxOptions PolygonBox PolygonBoxOptions PolygonHoleScale PolygonIntersections PolygonScale PolyhedronData PolyLog PolynomialExtendedGCD PolynomialForm PolynomialGCD PolynomialLCM PolynomialMod PolynomialQ PolynomialQuotient PolynomialQuotientRemainder PolynomialReduce PolynomialRemainder Polynomials PopupMenu PopupMenuBox PopupMenuBoxOptions PopupView PopupWindow Position Positive PositiveDefiniteMatrixQ PossibleZeroQ Postfix PostScript Power PowerDistribution PowerExpand PowerMod PowerModList PowerSpectralDensity PowersRepresentations PowerSymmetricPolynomial Precedence PrecedenceForm Precedes PrecedesEqual PrecedesSlantEqual PrecedesTilde Precision PrecisionGoal PreDecrement PredictionRoot PreemptProtect PreferencesPath Prefix PreIncrement Prepend PrependTo PreserveImageOptions Previous PriceGraphDistribution PrimaryPlaceholder Prime PrimeNu PrimeOmega PrimePi PrimePowerQ PrimeQ Primes PrimeZetaP PrimitiveRoot PrincipalComponents PrincipalValue Print PrintAction PrintForm PrintingCopies PrintingOptions PrintingPageRange PrintingStartingPageNumber PrintingStyleEnvironment PrintPrecision PrintTemporary Prism PrismBox PrismBoxOptions PrivateCellOptions PrivateEvaluationOptions PrivateFontOptions PrivateFrontEndOptions PrivateNotebookOptions PrivatePaths Probability ProbabilityDistribution ProbabilityPlot ProbabilityPr ProbabilityScalePlot ProbitModelFit ProcessEstimator ProcessParameterAssumptions ProcessParameterQ ProcessStateDomain ProcessTimeDomain Product ProductDistribution ProductLog ProgressIndicator ProgressIndicatorBox ProgressIndicatorBoxOptions Projection Prolog PromptForm Properties Property PropertyList PropertyValue Proportion Proportional Protect Protected ProteinData Pruning PseudoInverse Purple Put PutAppend Pyramid PyramidBox PyramidBoxOptions QBinomial QFactorial QGamma QHypergeometricPFQ QPochhammer QPolyGamma QRDecomposition QuadraticIrrationalQ Quantile QuantilePlot Quantity QuantityForm QuantityMagnitude QuantityQ QuantityUnit Quartics QuartileDeviation Quartiles QuartileSkewness QueueingNetworkProcess QueueingProcess QueueProperties Quiet Quit Quotient QuotientRemainder RadialityCentrality RadicalBox RadicalBoxOptions RadioButton RadioButtonBar RadioButtonBox RadioButtonBoxOptions Radon RamanujanTau RamanujanTauL RamanujanTauTheta RamanujanTauZ Random RandomChoice RandomComplex RandomFunction RandomGraph RandomImage RandomInteger RandomPermutation RandomPrime RandomReal RandomSample RandomSeed RandomVariate RandomWalkProcess Range RangeFilter RangeSpecification RankedMax RankedMin Raster Raster3D Raster3DBox Raster3DBoxOptions RasterArray RasterBox RasterBoxOptions Rasterize RasterSize Rational RationalFunctions Rationalize Rationals Ratios Raw RawArray RawBoxes RawData RawMedium RayleighDistribution Re Read ReadList ReadProtected Real RealBlockDiagonalForm RealDigits RealExponent Reals Reap Record RecordLists RecordSeparators Rectangle RectangleBox RectangleBoxOptions RectangleChart RectangleChart3D RecurrenceFilter RecurrenceTable RecurringDigitsForm Red Reduce RefBox ReferenceLineStyle ReferenceMarkers ReferenceMarkerStyle Refine ReflectionMatrix ReflectionTransform Refresh RefreshRate RegionBinarize RegionFunction RegionPlot RegionPlot3D RegularExpression Regularization Reinstall Release ReleaseHold ReliabilityDistribution ReliefImage ReliefPlot Remove RemoveAlphaChannel RemoveAsynchronousTask Removed RemoveInputStreamMethod RemoveOutputStreamMethod RemoveProperty RemoveScheduledTask RenameDirectory RenameFile RenderAll RenderingOptions RenewalProcess RenkoChart Repeated RepeatedNull RepeatedString Replace ReplaceAll ReplaceHeldPart ReplaceImageValue ReplaceList ReplacePart ReplacePixelValue ReplaceRepeated Resampling Rescale RescalingTransform ResetDirectory ResetMenusPacket ResetScheduledTask Residue Resolve Rest Resultant ResumePacket Return ReturnExpressionPacket ReturnInputFormPacket ReturnPacket ReturnTextPacket Reverse ReverseBiorthogonalSplineWavelet ReverseElement ReverseEquilibrium ReverseGraph ReverseUpEquilibrium RevolutionAxis RevolutionPlot3D RGBColor RiccatiSolve RiceDistribution RidgeFilter RiemannR RiemannSiegelTheta RiemannSiegelZ Riffle Right RightArrow RightArrowBar RightArrowLeftArrow RightCosetRepresentative RightDownTeeVector RightDownVector RightDownVectorBar RightTee RightTeeArrow RightTeeVector RightTriangle RightTriangleBar RightTriangleEqual RightUpDownVector RightUpTeeVector RightUpVector RightUpVectorBar RightVector RightVectorBar RiskAchievementImportance RiskReductionImportance RogersTanimotoDissimilarity Root RootApproximant RootIntervals RootLocusPlot RootMeanSquare RootOfUnityQ RootReduce Roots RootSum Rotate RotateLabel RotateLeft RotateRight RotationAction RotationBox RotationBoxOptions RotationMatrix RotationTransform Round RoundImplies RoundingRadius Row RowAlignments RowBackgrounds RowBox RowHeights RowLines RowMinHeight RowReduce RowsEqual RowSpacings RSolve RudvalisGroupRu Rule RuleCondition RuleDelayed RuleForm RulerUnits Run RunScheduledTask RunThrough RuntimeAttributes RuntimeOptions RussellRaoDissimilarity SameQ SameTest SampleDepth SampledSoundFunction SampledSoundList SampleRate SamplingPeriod SARIMAProcess SARMAProcess SatisfiabilityCount SatisfiabilityInstances SatisfiableQ Saturday Save Saveable SaveAutoDelete SaveDefinitions SawtoothWave Scale Scaled ScaleDivisions ScaledMousePosition ScaleOrigin ScalePadding ScaleRanges ScaleRangeStyle ScalingFunctions ScalingMatrix ScalingTransform Scan ScheduledTaskActiveQ ScheduledTaskData ScheduledTaskObject ScheduledTasks SchurDecomposition ScientificForm ScreenRectangle ScreenStyleEnvironment ScriptBaselineShifts ScriptLevel ScriptMinSize ScriptRules ScriptSizeMultipliers Scrollbars ScrollingOptions ScrollPosition Sec Sech SechDistribution SectionGrouping SectorChart SectorChart3D SectorOrigin SectorSpacing SeedRandom Select Selectable SelectComponents SelectedCells SelectedNotebook Selection SelectionAnimate SelectionCell SelectionCellCreateCell SelectionCellDefaultStyle SelectionCellParentStyle SelectionCreateCell SelectionDebuggerTag SelectionDuplicateCell SelectionEvaluate SelectionEvaluateCreateCell SelectionMove SelectionPlaceholder SelectionSetStyle SelectWithContents SelfLoops SelfLoopStyle SemialgebraicComponentInstances SendMail Sequence SequenceAlignment SequenceForm SequenceHold SequenceLimit Series SeriesCoefficient SeriesData SessionTime Set SetAccuracy SetAlphaChannel SetAttributes Setbacks SetBoxFormNamesPacket SetDelayed SetDirectory SetEnvironment SetEvaluationNotebook SetFileDate SetFileLoadingContext SetNotebookStatusLine SetOptions SetOptionsPacket SetPrecision SetProperty SetSelectedNotebook SetSharedFunction SetSharedVariable SetSpeechParametersPacket SetStreamPosition SetSystemOptions Setter SetterBar SetterBox SetterBoxOptions Setting SetValue Shading Shallow ShannonWavelet ShapiroWilkTest Share Sharpen ShearingMatrix ShearingTransform ShenCastanMatrix Short ShortDownArrow Shortest ShortestMatch ShortestPathFunction ShortLeftArrow ShortRightArrow ShortUpArrow Show ShowAutoStyles ShowCellBracket ShowCellLabel ShowCellTags ShowClosedCellArea ShowContents ShowControls ShowCursorTracker ShowGroupOpenCloseIcon ShowGroupOpener ShowInvisibleCharacters ShowPageBreaks ShowPredictiveInterface ShowSelection ShowShortBoxForm ShowSpecialCharacters ShowStringCharacters ShowSyntaxStyles ShrinkingDelay ShrinkWrapBoundingBox SiegelTheta SiegelTukeyTest Sign Signature SignedRankTest SignificanceLevel SignPadding SignTest SimilarityRules SimpleGraph SimpleGraphQ Simplify Sin Sinc SinghMaddalaDistribution SingleEvaluation SingleLetterItalics SingleLetterStyle SingularValueDecomposition SingularValueList SingularValuePlot SingularValues Sinh SinhIntegral SinIntegral SixJSymbol Skeleton SkeletonTransform SkellamDistribution Skewness SkewNormalDistribution Skip SliceDistribution Slider Slider2D Slider2DBox Slider2DBoxOptions SliderBox SliderBoxOptions SlideView Slot SlotSequence Small SmallCircle Smaller SmithDelayCompensator SmithWatermanSimilarity SmoothDensityHistogram SmoothHistogram SmoothHistogram3D SmoothKernelDistribution SocialMediaData Socket SokalSneathDissimilarity Solve SolveAlways SolveDelayed Sort SortBy Sound SoundAndGraphics SoundNote SoundVolume Sow Space SpaceForm Spacer Spacings Span SpanAdjustments SpanCharacterRounding SpanFromAbove SpanFromBoth SpanFromLeft SpanLineThickness SpanMaxSize SpanMinSize SpanningCharacters SpanSymmetric SparseArray SpatialGraphDistribution Speak SpeakTextPacket SpearmanRankTest SpearmanRho Spectrogram SpectrogramArray Specularity SpellingCorrection SpellingDictionaries SpellingDictionariesPath SpellingOptions SpellingSuggestionsPacket Sphere SphereBox SphericalBesselJ SphericalBesselY SphericalHankelH1 SphericalHankelH2 SphericalHarmonicY SphericalPlot3D SphericalRegion SpheroidalEigenvalue SpheroidalJoiningFactor SpheroidalPS SpheroidalPSPrime SpheroidalQS SpheroidalQSPrime SpheroidalRadialFactor SpheroidalS1 SpheroidalS1Prime SpheroidalS2 SpheroidalS2Prime Splice SplicedDistribution SplineClosed SplineDegree SplineKnots SplineWeights Split SplitBy SpokenString Sqrt SqrtBox SqrtBoxOptions Square SquaredEuclideanDistance SquareFreeQ SquareIntersection SquaresR SquareSubset SquareSubsetEqual SquareSuperset SquareSupersetEqual SquareUnion SquareWave StabilityMargins StabilityMarginsStyle StableDistribution Stack StackBegin StackComplete StackInhibit StandardDeviation StandardDeviationFilter StandardForm Standardize StandbyDistribution Star StarGraph StartAsynchronousTask StartingStepSize StartOfLine StartOfString StartScheduledTask StartupSound StateDimensions StateFeedbackGains StateOutputEstimator StateResponse StateSpaceModel StateSpaceRealization StateSpaceTransform StationaryDistribution StationaryWaveletPacketTransform StationaryWaveletTransform StatusArea StatusCentrality StepMonitor StieltjesGamma StirlingS1 StirlingS2 StopAsynchronousTask StopScheduledTask StrataVariables StratonovichProcess StreamColorFunction StreamColorFunctionScaling StreamDensityPlot StreamPlot StreamPoints StreamPosition Streams StreamScale StreamStyle String StringBreak StringByteCount StringCases StringCount StringDrop StringExpression StringForm StringFormat StringFreeQ StringInsert StringJoin StringLength StringMatchQ StringPosition StringQ StringReplace StringReplaceList StringReplacePart StringReverse StringRotateLeft StringRotateRight StringSkeleton StringSplit StringTake StringToStream StringTrim StripBoxes StripOnInput StripWrapperBoxes StrokeForm StructuralImportance StructuredArray StructuredSelection StruveH StruveL Stub StudentTDistribution Style StyleBox StyleBoxAutoDelete StyleBoxOptions StyleData StyleDefinitions StyleForm StyleKeyMapping StyleMenuListing StyleNameDialogSettings StyleNames StylePrint StyleSheetPath Subfactorial Subgraph SubMinus SubPlus SubresultantPolynomialRemainders SubresultantPolynomials Subresultants Subscript SubscriptBox SubscriptBoxOptions Subscripted Subset SubsetEqual Subsets SubStar Subsuperscript SubsuperscriptBox SubsuperscriptBoxOptions Subtract SubtractFrom SubValues Succeeds SucceedsEqual SucceedsSlantEqual SucceedsTilde SuchThat Sum SumConvergence Sunday SuperDagger SuperMinus SuperPlus Superscript SuperscriptBox SuperscriptBoxOptions Superset SupersetEqual SuperStar Surd SurdForm SurfaceColor SurfaceGraphics SurvivalDistribution SurvivalFunction SurvivalModel SurvivalModelFit SuspendPacket SuzukiDistribution SuzukiGroupSuz SwatchLegend Switch Symbol SymbolName SymletWavelet Symmetric SymmetricGroup SymmetricMatrixQ SymmetricPolynomial SymmetricReduction Symmetrize SymmetrizedArray SymmetrizedArrayRules SymmetrizedDependentComponents SymmetrizedIndependentComponents SymmetrizedReplacePart SynchronousInitialization SynchronousUpdating Syntax SyntaxForm SyntaxInformation SyntaxLength SyntaxPacket SyntaxQ SystemDialogInput SystemException SystemHelpPath SystemInformation SystemInformationData SystemOpen SystemOptions SystemsModelDelay SystemsModelDelayApproximate SystemsModelDelete SystemsModelDimensions SystemsModelExtract SystemsModelFeedbackConnect SystemsModelLabels SystemsModelOrder SystemsModelParallelConnect SystemsModelSeriesConnect SystemsModelStateFeedbackConnect SystemStub Tab TabFilling Table TableAlignments TableDepth TableDirections TableForm TableHeadings TableSpacing TableView TableViewBox TabSpacings TabView TabViewBox TabViewBoxOptions TagBox TagBoxNote TagBoxOptions TaggingRules TagSet TagSetDelayed TagStyle TagUnset Take TakeWhile Tally Tan Tanh TargetFunctions TargetUnits TautologyQ TelegraphProcess TemplateBox TemplateBoxOptions TemplateSlotSequence TemporalData Temporary TemporaryVariable TensorContract TensorDimensions TensorExpand TensorProduct TensorQ TensorRank TensorReduce TensorSymmetry TensorTranspose TensorWedge Tetrahedron TetrahedronBox TetrahedronBoxOptions TeXForm TeXSave Text Text3DBox Text3DBoxOptions TextAlignment TextBand TextBoundingBox TextBox TextCell TextClipboardType TextData TextForm TextJustification TextLine TextPacket TextParagraph TextRecognize TextRendering TextStyle Texture TextureCoordinateFunction TextureCoordinateScaling Therefore ThermometerGauge Thick Thickness Thin Thinning ThisLink ThompsonGroupTh Thread ThreeJSymbol Threshold Through Throw Thumbnail Thursday Ticks TicksStyle Tilde TildeEqual TildeFullEqual TildeTilde TimeConstrained TimeConstraint Times TimesBy TimeSeriesForecast TimeSeriesInvertibility TimeUsed TimeValue TimeZone Timing Tiny TitleGrouping TitsGroupT ToBoxes ToCharacterCode ToColor ToContinuousTimeModel ToDate ToDiscreteTimeModel ToeplitzMatrix ToExpression ToFileName Together Toggle ToggleFalse Toggler TogglerBar TogglerBox TogglerBoxOptions ToHeldExpression ToInvertibleTimeSeries TokenWords Tolerance ToLowerCase ToNumberField TooBig Tooltip TooltipBox TooltipBoxOptions TooltipDelay TooltipStyle Top TopHatTransform TopologicalSort ToRadicals ToRules ToString Total TotalHeight TotalVariationFilter TotalWidth TouchscreenAutoZoom TouchscreenControlPlacement ToUpperCase Tr Trace TraceAbove TraceAction TraceBackward TraceDepth TraceDialog TraceForward TraceInternal TraceLevel TraceOff TraceOn TraceOriginal TracePrint TraceScan TrackedSymbols TradingChart TraditionalForm TraditionalFunctionNotation TraditionalNotation TraditionalOrder TransferFunctionCancel TransferFunctionExpand TransferFunctionFactor TransferFunctionModel TransferFunctionPoles TransferFunctionTransform TransferFunctionZeros TransformationFunction TransformationFunctions TransformationMatrix TransformedDistribution TransformedField Translate TranslationTransform TransparentColor Transpose TreeForm TreeGraph TreeGraphQ TreePlot TrendStyle TriangleWave TriangularDistribution Trig TrigExpand TrigFactor TrigFactorList Trigger TrigReduce TrigToExp TrimmedMean True TrueQ TruncatedDistribution TsallisQExponentialDistribution TsallisQGaussianDistribution TTest Tube TubeBezierCurveBox TubeBezierCurveBoxOptions TubeBox TubeBSplineCurveBox TubeBSplineCurveBoxOptions Tuesday TukeyLambdaDistribution TukeyWindow Tuples TuranGraph TuringMachine Transparent UnateQ Uncompress Undefined UnderBar Underflow Underlined Underoverscript UnderoverscriptBox UnderoverscriptBoxOptions Underscript UnderscriptBox UnderscriptBoxOptions UndirectedEdge UndirectedGraph UndirectedGraphQ UndocumentedTestFEParserPacket UndocumentedTestGetSelectionPacket Unequal Unevaluated UniformDistribution UniformGraphDistribution UniformSumDistribution Uninstall Union UnionPlus Unique UnitBox UnitConvert UnitDimensions Unitize UnitRootTest UnitSimplify UnitStep UnitTriangle UnitVector Unprotect UnsameQ UnsavedVariables Unset UnsetShared UntrackedVariables Up UpArrow UpArrowBar UpArrowDownArrow Update UpdateDynamicObjects UpdateDynamicObjectsSynchronous UpdateInterval UpDownArrow UpEquilibrium UpperCaseQ UpperLeftArrow UpperRightArrow UpperTriangularize Upsample UpSet UpSetDelayed UpTee UpTeeArrow UpValues URL URLFetch URLFetchAsynchronous URLSave URLSaveAsynchronous UseGraphicsRange Using UsingFrontEnd V2Get ValidationLength Value ValueBox ValueBoxOptions ValueForm ValueQ ValuesData Variables Variance VarianceEquivalenceTest VarianceEstimatorFunction VarianceGammaDistribution VarianceTest VectorAngle VectorColorFunction VectorColorFunctionScaling VectorDensityPlot VectorGlyphData VectorPlot VectorPlot3D VectorPoints VectorQ Vectors VectorScale VectorStyle Vee Verbatim Verbose VerboseConvertToPostScriptPacket VerifyConvergence VerifySolutions VerifyTestAssumptions Version VersionNumber VertexAdd VertexCapacity VertexColors VertexComponent VertexConnectivity VertexCoordinateRules VertexCoordinates VertexCorrelationSimilarity VertexCosineSimilarity VertexCount VertexCoverQ VertexDataCoordinates VertexDegree VertexDelete VertexDiceSimilarity VertexEccentricity VertexInComponent VertexInDegree VertexIndex VertexJaccardSimilarity VertexLabeling VertexLabels VertexLabelStyle VertexList VertexNormals VertexOutComponent VertexOutDegree VertexQ VertexRenderingFunction VertexReplace VertexShape VertexShapeFunction VertexSize VertexStyle VertexTextureCoordinates VertexWeight Vertical VerticalBar VerticalForm VerticalGauge VerticalSeparator VerticalSlider VerticalTilde ViewAngle ViewCenter ViewMatrix ViewPoint ViewPointSelectorSettings ViewPort ViewRange ViewVector ViewVertical VirtualGroupData Visible VisibleCell VoigtDistribution VonMisesDistribution WaitAll WaitAsynchronousTask WaitNext WaitUntil WakebyDistribution WalleniusHypergeometricDistribution WaringYuleDistribution WatershedComponents WatsonUSquareTest WattsStrogatzGraphDistribution WaveletBestBasis WaveletFilterCoefficients WaveletImagePlot WaveletListPlot WaveletMapIndexed WaveletMatrixPlot WaveletPhi WaveletPsi WaveletScale WaveletScalogram WaveletThreshold WeaklyConnectedComponents WeaklyConnectedGraphQ WeakStationarity WeatherData WeberE Wedge Wednesday WeibullDistribution WeierstrassHalfPeriods WeierstrassInvariants WeierstrassP WeierstrassPPrime WeierstrassSigma WeierstrassZeta WeightedAdjacencyGraph WeightedAdjacencyMatrix WeightedData WeightedGraphQ Weights WelchWindow WheelGraph WhenEvent Which While White Whitespace WhitespaceCharacter WhittakerM WhittakerW WienerFilter WienerProcess WignerD WignerSemicircleDistribution WilksW WilksWTest WindowClickSelect WindowElements WindowFloating WindowFrame WindowFrameElements WindowMargins WindowMovable WindowOpacity WindowSelected WindowSize WindowStatusArea WindowTitle WindowToolbars WindowWidth With WolframAlpha WolframAlphaDate WolframAlphaQuantity WolframAlphaResult Word WordBoundary WordCharacter WordData WordSearch WordSeparators WorkingPrecision Write WriteString Wronskian XMLElement XMLObject Xnor Xor Yellow YuleDissimilarity ZernikeR ZeroSymmetric ZeroTest ZeroWidthTimes Zeta ZetaZero ZipfDistribution ZTest ZTransform $Aborted $ActivationGroupID $ActivationKey $ActivationUserRegistered $AddOnsDirectory $AssertFunction $Assumptions $AsynchronousTask $BaseDirectory $BatchInput $BatchOutput $BoxForms $ByteOrdering $Canceled $CharacterEncoding $CharacterEncodings $CommandLine $CompilationTarget $ConditionHold $ConfiguredKernels $Context $ContextPath $ControlActiveSetting $CreationDate $CurrentLink $DateStringFormat $DefaultFont $DefaultFrontEnd $DefaultImagingDevice $DefaultPath $Display $DisplayFunction $DistributedContexts $DynamicEvaluation $Echo $Epilog $ExportFormats $Failed $FinancialDataSource $FormatType $FrontEnd $FrontEndSession $GeoLocation $HistoryLength $HomeDirectory $HTTPCookies $IgnoreEOF $ImagingDevices $ImportFormats $InitialDirectory $Input $InputFileName $InputStreamMethods $Inspector $InstallationDate $InstallationDirectory $InterfaceEnvironment $IterationLimit $KernelCount $KernelID $Language $LaunchDirectory $LibraryPath $LicenseExpirationDate $LicenseID $LicenseProcesses $LicenseServer $LicenseSubprocesses $LicenseType $Line $Linked $LinkSupported $LoadedFiles $MachineAddresses $MachineDomain $MachineDomains $MachineEpsilon $MachineID $MachineName $MachinePrecision $MachineType $MaxExtraPrecision $MaxLicenseProcesses $MaxLicenseSubprocesses $MaxMachineNumber $MaxNumber $MaxPiecewiseCases $MaxPrecision $MaxRootDegree $MessageGroups $MessageList $MessagePrePrint $Messages $MinMachineNumber $MinNumber $MinorReleaseNumber $MinPrecision $ModuleNumber $NetworkLicense $NewMessage $NewSymbol $Notebooks $NumberMarks $Off $OperatingSystem $Output $OutputForms $OutputSizeLimit $OutputStreamMethods $Packages $ParentLink $ParentProcessID $PasswordFile $PatchLevelID $Path $PathnameSeparator $PerformanceGoal $PipeSupported $Post $Pre $PreferencesDirectory $PrePrint $PreRead $PrintForms $PrintLiteral $ProcessID $ProcessorCount $ProcessorType $ProductInformation $ProgramName $RandomState $RecursionLimit $ReleaseNumber $RootDirectory $ScheduledTask $ScriptCommandLine $SessionID $SetParentLink $SharedFunctions $SharedVariables $SoundDisplay $SoundDisplayFunction $SuppressInputFormHeads $SynchronousEvaluation $SyntaxHandler $System $SystemCharacterEncoding $SystemID $SystemWordLength $TemporaryDirectory $TemporaryPrefix $TextStyle $TimedOut $TimeUnit $TimeZone $TopDirectory $TraceOff $TraceOn $TracePattern $TracePostAction $TracePreAction $Urgent $UserAddOnsDirectory $UserBaseDirectory $UserDocumentsDirectory $UserName $Version $VersionNumber",
contains:[{className:"comment",begin:/\(\*/,end:/\*\)/},hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.C_NUMBER_MODE,{className:"list",begin:/\{/,end:/\}/,illegal:/:/}]}}),hljs.registerLanguage("matlab",function(hljs){var COMMON_CONTAINS=[hljs.C_NUMBER_MODE,{className:"string",begin:"'",end:"'",contains:[hljs.BACKSLASH_ESCAPE,{begin:"''"}]}],TRANSPOSE={relevance:0,contains:[{className:"operator",begin:/'['\.]*/}]};return{keywords:{keyword:"break case catch classdef continue else elseif end enumerated events for function global if methods otherwise parfor persistent properties return spmd switch try while",built_in:"sin sind sinh asin asind asinh cos cosd cosh acos acosd acosh tan tand tanh atan atand atan2 atanh sec secd sech asec asecd asech csc cscd csch acsc acscd acsch cot cotd coth acot acotd acoth hypot exp expm1 log log1p log10 log2 pow2 realpow reallog realsqrt sqrt nthroot nextpow2 abs angle complex conj imag real unwrap isreal cplxpair fix floor ceil round mod rem sign airy besselj bessely besselh besseli besselk beta betainc betaln ellipj ellipke erf erfc erfcx erfinv expint gamma gammainc gammaln psi legendre cross dot factor isprime primes gcd lcm rat rats perms nchoosek factorial cart2sph cart2pol pol2cart sph2cart hsv2rgb rgb2hsv zeros ones eye repmat rand randn linspace logspace freqspace meshgrid accumarray size length ndims numel disp isempty isequal isequalwithequalnans cat reshape diag blkdiag tril triu fliplr flipud flipdim rot90 find sub2ind ind2sub bsxfun ndgrid permute ipermute shiftdim circshift squeeze isscalar isvector ans eps realmax realmin pi i inf nan isnan isinf isfinite j why compan gallery hadamard hankel hilb invhilb magic pascal rosser toeplitz vander wilkinson"},illegal:'(//|"|#|/\\*|\\s+/\\w+)',contains:[{className:"function",beginKeywords:"function",end:"$",contains:[hljs.UNDERSCORE_TITLE_MODE,{className:"params",begin:"\\(",end:"\\)"},{className:"params",begin:"\\[",end:"\\]"}]},{begin:/[a-zA-Z_][a-zA-Z_0-9]*'['\.]*/,returnBegin:!0,relevance:0,contains:[{begin:/[a-zA-Z_][a-zA-Z_0-9]*/,relevance:0},TRANSPOSE.contains[0]]},{className:"matrix",begin:"\\[",end:"\\]",contains:COMMON_CONTAINS,relevance:0,starts:TRANSPOSE},{className:"cell",begin:"\\{",end:/}/,contains:COMMON_CONTAINS,relevance:0,starts:TRANSPOSE},{begin:/\)/,relevance:0,starts:TRANSPOSE},hljs.COMMENT("^\\s*\\%\\{\\s*$","^\\s*\\%\\}\\s*$"),hljs.COMMENT("\\%","$")].concat(COMMON_CONTAINS)}}),hljs.registerLanguage("mel",function(hljs){return{keywords:"int float string vector matrix if else switch case default while do for in break continue global proc return about abs addAttr addAttributeEditorNodeHelp addDynamic addNewShelfTab addPP addPanelCategory addPrefixToName advanceToNextDrivenKey affectedNet affects aimConstraint air alias aliasAttr align alignCtx alignCurve alignSurface allViewFit ambientLight angle angleBetween animCone animCurveEditor animDisplay animView annotate appendStringArray applicationName applyAttrPreset applyTake arcLenDimContext arcLengthDimension arclen arrayMapper art3dPaintCtx artAttrCtx artAttrPaintVertexCtx artAttrSkinPaintCtx artAttrTool artBuildPaintMenu artFluidAttrCtx artPuttyCtx artSelectCtx artSetPaintCtx artUserPaintCtx assignCommand assignInputDevice assignViewportFactories attachCurve attachDeviceAttr attachSurface attrColorSliderGrp attrCompatibility attrControlGrp attrEnumOptionMenu attrEnumOptionMenuGrp attrFieldGrp attrFieldSliderGrp attrNavigationControlGrp attrPresetEditWin attributeExists attributeInfo attributeMenu attributeQuery autoKeyframe autoPlace bakeClip bakeFluidShading bakePartialHistory bakeResults bakeSimulation basename basenameEx batchRender bessel bevel bevelPlus binMembership bindSkin blend2 blendShape blendShapeEditor blendShapePanel blendTwoAttr blindDataType boneLattice boundary boxDollyCtx boxZoomCtx bufferCurve buildBookmarkMenu buildKeyframeMenu button buttonManip CBG cacheFile cacheFileCombine cacheFileMerge cacheFileTrack camera cameraView canCreateManip canvas capitalizeString catch catchQuiet ceil changeSubdivComponentDisplayLevel changeSubdivRegion channelBox character characterMap characterOutlineEditor characterize chdir checkBox checkBoxGrp checkDefaultRenderGlobals choice circle circularFillet clamp clear clearCache clip clipEditor clipEditorCurrentTimeCtx clipSchedule clipSchedulerOutliner clipTrimBefore closeCurve closeSurface cluster cmdFileOutput cmdScrollFieldExecuter cmdScrollFieldReporter cmdShell coarsenSubdivSelectionList collision color colorAtPoint colorEditor colorIndex colorIndexSliderGrp colorSliderButtonGrp colorSliderGrp columnLayout commandEcho commandLine commandPort compactHairSystem componentEditor compositingInterop computePolysetVolume condition cone confirmDialog connectAttr connectControl connectDynamic connectJoint connectionInfo constrain constrainValue constructionHistory container containsMultibyte contextInfo control convertFromOldLayers convertIffToPsd convertLightmap convertSolidTx convertTessellation convertUnit copyArray copyFlexor copyKey copySkinWeights cos cpButton cpCache cpClothSet cpCollision cpConstraint cpConvClothToMesh cpForces cpGetSolverAttr cpPanel cpProperty cpRigidCollisionFilter cpSeam cpSetEdit cpSetSolverAttr cpSolver cpSolverTypes cpTool cpUpdateClothUVs createDisplayLayer createDrawCtx createEditor createLayeredPsdFile createMotionField createNewShelf createNode createRenderLayer createSubdivRegion cross crossProduct ctxAbort ctxCompletion ctxEditMode ctxTraverse currentCtx currentTime currentTimeCtx currentUnit curve curveAddPtCtx curveCVCtx curveEPCtx curveEditorCtx curveIntersect curveMoveEPCtx curveOnSurface curveSketchCtx cutKey cycleCheck cylinder dagPose date defaultLightListCheckBox defaultNavigation defineDataServer defineVirtualDevice deformer deg_to_rad delete deleteAttr deleteShadingGroupsAndMaterials deleteShelfTab deleteUI deleteUnusedBrushes delrandstr detachCurve detachDeviceAttr detachSurface deviceEditor devicePanel dgInfo dgdirty dgeval dgtimer dimWhen directKeyCtx directionalLight dirmap dirname disable disconnectAttr disconnectJoint diskCache displacementToPoly displayAffected displayColor displayCull displayLevelOfDetail displayPref displayRGBColor displaySmoothness displayStats displayString displaySurface distanceDimContext distanceDimension doBlur dolly dollyCtx dopeSheetEditor dot dotProduct doubleProfileBirailSurface drag dragAttrContext draggerContext dropoffLocator duplicate duplicateCurve duplicateSurface dynCache dynControl dynExport dynExpression dynGlobals dynPaintEditor dynParticleCtx dynPref dynRelEdPanel dynRelEditor dynamicLoad editAttrLimits editDisplayLayerGlobals editDisplayLayerMembers editRenderLayerAdjustment editRenderLayerGlobals editRenderLayerMembers editor editorTemplate effector emit emitter enableDevice encodeString endString endsWith env equivalent equivalentTol erf error eval evalDeferred evalEcho event exactWorldBoundingBox exclusiveLightCheckBox exec executeForEachObject exists exp expression expressionEditorListen extendCurve extendSurface extrude fcheck fclose feof fflush fgetline fgetword file fileBrowserDialog fileDialog fileExtension fileInfo filetest filletCurve filter filterCurve filterExpand filterStudioImport findAllIntersections findAnimCurves findKeyframe findMenuItem findRelatedSkinCluster finder firstParentOf fitBspline flexor floatEq floatField floatFieldGrp floatScrollBar floatSlider floatSlider2 floatSliderButtonGrp floatSliderGrp floor flow fluidCacheInfo fluidEmitter fluidVoxelInfo flushUndo fmod fontDialog fopen formLayout format fprint frameLayout fread freeFormFillet frewind fromNativePath fwrite gamma gauss geometryConstraint getApplicationVersionAsFloat getAttr getClassification getDefaultBrush getFileList getFluidAttr getInputDeviceRange getMayaPanelTypes getModifiers getPanel getParticleAttr getPluginResource getenv getpid glRender glRenderEditor globalStitch gmatch goal gotoBindPose grabColor gradientControl gradientControlNoAttr graphDollyCtx graphSelectContext graphTrackCtx gravity grid gridLayout group groupObjectsByName HfAddAttractorToAS HfAssignAS HfBuildEqualMap HfBuildFurFiles HfBuildFurImages HfCancelAFR HfConnectASToHF HfCreateAttractor HfDeleteAS HfEditAS HfPerformCreateAS HfRemoveAttractorFromAS HfSelectAttached HfSelectAttractors HfUnAssignAS hardenPointCurve hardware hardwareRenderPanel headsUpDisplay headsUpMessage help helpLine hermite hide hilite hitTest hotBox hotkey hotkeyCheck hsv_to_rgb hudButton hudSlider hudSliderButton hwReflectionMap hwRender hwRenderLoad hyperGraph hyperPanel hyperShade hypot iconTextButton iconTextCheckBox iconTextRadioButton iconTextRadioCollection iconTextScrollList iconTextStaticLabel ikHandle ikHandleCtx ikHandleDisplayScale ikSolver ikSplineHandleCtx ikSystem ikSystemInfo ikfkDisplayMethod illustratorCurves image imfPlugins inheritTransform insertJoint insertJointCtx insertKeyCtx insertKnotCurve insertKnotSurface instance instanceable instancer intField intFieldGrp intScrollBar intSlider intSliderGrp interToUI internalVar intersect iprEngine isAnimCurve isConnected isDirty isParentOf isSameObject isTrue isValidObjectName isValidString isValidUiName isolateSelect itemFilter itemFilterAttr itemFilterRender itemFilterType joint jointCluster jointCtx jointDisplayScale jointLattice keyTangent keyframe keyframeOutliner keyframeRegionCurrentTimeCtx keyframeRegionDirectKeyCtx keyframeRegionDollyCtx keyframeRegionInsertKeyCtx keyframeRegionMoveKeyCtx keyframeRegionScaleKeyCtx keyframeRegionSelectKeyCtx keyframeRegionSetKeyCtx keyframeRegionTrackCtx keyframeStats lassoContext lattice latticeDeformKeyCtx launch launchImageEditor layerButton layeredShaderPort layeredTexturePort layout layoutDialog lightList lightListEditor lightListPanel lightlink lineIntersection linearPrecision linstep listAnimatable listAttr listCameras listConnections listDeviceAttachments listHistory listInputDeviceAxes listInputDeviceButtons listInputDevices listMenuAnnotation listNodeTypes listPanelCategories listRelatives listSets listTransforms listUnselected listerEditor loadFluid loadNewShelf loadPlugin loadPluginLanguageResources loadPrefObjects localizedPanelLabel lockNode loft log longNameOf lookThru ls lsThroughFilter lsType lsUI Mayatomr mag makeIdentity makeLive makePaintable makeRoll makeSingleSurface makeTubeOn makebot manipMoveContext manipMoveLimitsCtx manipOptions manipRotateContext manipRotateLimitsCtx manipScaleContext manipScaleLimitsCtx marker match max memory menu menuBarLayout menuEditor menuItem menuItemToShelf menuSet menuSetPref messageLine min minimizeApp mirrorJoint modelCurrentTimeCtx modelEditor modelPanel mouse movIn movOut move moveIKtoFK moveKeyCtx moveVertexAlongDirection multiProfileBirailSurface mute nParticle nameCommand nameField namespace namespaceInfo newPanelItems newton nodeCast nodeIconButton nodeOutliner nodePreset nodeType noise nonLinear normalConstraint normalize nurbsBoolean nurbsCopyUVSet nurbsCube nurbsEditUV nurbsPlane nurbsSelect nurbsSquare nurbsToPoly nurbsToPolygonsPref nurbsToSubdiv nurbsToSubdivPref nurbsUVSet nurbsViewDirectionVector objExists objectCenter objectLayer objectType objectTypeUI obsoleteProc oceanNurbsPreviewPlane offsetCurve offsetCurveOnSurface offsetSurface openGLExtension openMayaPref optionMenu optionMenuGrp optionVar orbit orbitCtx orientConstraint outlinerEditor outlinerPanel overrideModifier paintEffectsDisplay pairBlend palettePort paneLayout panel panelConfiguration panelHistory paramDimContext paramDimension paramLocator parent parentConstraint particle particleExists particleInstancer particleRenderInfo partition pasteKey pathAnimation pause pclose percent performanceOptions pfxstrokes pickWalk picture pixelMove planarSrf plane play playbackOptions playblast plugAttr plugNode pluginInfo pluginResourceUtil pointConstraint pointCurveConstraint pointLight pointMatrixMult pointOnCurve pointOnSurface pointPosition poleVectorConstraint polyAppend polyAppendFacetCtx polyAppendVertex polyAutoProjection polyAverageNormal polyAverageVertex polyBevel polyBlendColor polyBlindData polyBoolOp polyBridgeEdge polyCacheMonitor polyCheck polyChipOff polyClipboard polyCloseBorder polyCollapseEdge polyCollapseFacet polyColorBlindData polyColorDel polyColorPerVertex polyColorSet polyCompare polyCone polyCopyUV polyCrease polyCreaseCtx polyCreateFacet polyCreateFacetCtx polyCube polyCut polyCutCtx polyCylinder polyCylindricalProjection polyDelEdge polyDelFacet polyDelVertex polyDuplicateAndConnect polyDuplicateEdge polyEditUV polyEditUVShell polyEvaluate polyExtrudeEdge polyExtrudeFacet polyExtrudeVertex polyFlipEdge polyFlipUV polyForceUV polyGeoSampler polyHelix polyInfo polyInstallAction polyLayoutUV polyListComponentConversion polyMapCut polyMapDel polyMapSew polyMapSewMove polyMergeEdge polyMergeEdgeCtx polyMergeFacet polyMergeFacetCtx polyMergeUV polyMergeVertex polyMirrorFace polyMoveEdge polyMoveFacet polyMoveFacetUV polyMoveUV polyMoveVertex polyNormal polyNormalPerVertex polyNormalizeUV polyOptUvs polyOptions polyOutput polyPipe polyPlanarProjection polyPlane polyPlatonicSolid polyPoke polyPrimitive polyPrism polyProjection polyPyramid polyQuad polyQueryBlindData polyReduce polySelect polySelectConstraint polySelectConstraintMonitor polySelectCtx polySelectEditCtx polySeparate polySetToFaceNormal polySewEdge polyShortestPathCtx polySmooth polySoftEdge polySphere polySphericalProjection polySplit polySplitCtx polySplitEdge polySplitRing polySplitVertex polyStraightenUVBorder polySubdivideEdge polySubdivideFacet polyToSubdiv polyTorus polyTransfer polyTriangulate polyUVSet polyUnite polyWedgeFace popen popupMenu pose pow preloadRefEd print progressBar progressWindow projFileViewer projectCurve projectTangent projectionContext projectionManip promptDialog propModCtx propMove psdChannelOutliner psdEditTextureFile psdExport psdTextureFile putenv pwd python querySubdiv quit rad_to_deg radial radioButton radioButtonGrp radioCollection radioMenuItemCollection rampColorPort rand randomizeFollicles randstate rangeControl readTake rebuildCurve rebuildSurface recordAttr recordDevice redo reference referenceEdit referenceQuery refineSubdivSelectionList refresh refreshAE registerPluginResource rehash reloadImage removeJoint removeMultiInstance removePanelCategory rename renameAttr renameSelectionList renameUI render renderGlobalsNode renderInfo renderLayerButton renderLayerParent renderLayerPostProcess renderLayerUnparent renderManip renderPartition renderQualityNode renderSettings renderThumbnailUpdate renderWindowEditor renderWindowSelectContext renderer reorder reorderDeformers requires reroot resampleFluid resetAE resetPfxToPolyCamera resetTool resolutionNode retarget reverseCurve reverseSurface revolve rgb_to_hsv rigidBody rigidSolver roll rollCtx rootOf rot rotate rotationInterpolation roundConstantRadius rowColumnLayout rowLayout runTimeCommand runup sampleImage saveAllShelves saveAttrPreset saveFluid saveImage saveInitialState saveMenu savePrefObjects savePrefs saveShelf saveToolSettings scale scaleBrushBrightness scaleComponents scaleConstraint scaleKey scaleKeyCtx sceneEditor sceneUIReplacement scmh scriptCtx scriptEditorInfo scriptJob scriptNode scriptTable scriptToShelf scriptedPanel scriptedPanelType scrollField scrollLayout sculpt searchPathArray seed selLoadSettings select selectContext selectCurveCV selectKey selectKeyCtx selectKeyframeRegionCtx selectMode selectPref selectPriority selectType selectedNodes selectionConnection separator setAttr setAttrEnumResource setAttrMapping setAttrNiceNameResource setConstraintRestPosition setDefaultShadingGroup setDrivenKeyframe setDynamic setEditCtx setEditor setFluidAttr setFocus setInfinity setInputDeviceMapping setKeyCtx setKeyPath setKeyframe setKeyframeBlendshapeTargetWts setMenuMode setNodeNiceNameResource setNodeTypeFlag setParent setParticleAttr setPfxToPolyCamera setPluginResource setProject setStampDensity setStartupMessage setState setToolTo setUITemplate setXformManip sets shadingConnection shadingGeometryRelCtx shadingLightRelCtx shadingNetworkCompare shadingNode shapeCompare shelfButton shelfLayout shelfTabLayout shellField shortNameOf showHelp showHidden showManipCtx showSelectionInTitle showShadingGroupAttrEditor showWindow sign simplify sin singleProfileBirailSurface size sizeBytes skinCluster skinPercent smoothCurve smoothTangentSurface smoothstep snap2to2 snapKey snapMode snapTogetherCtx snapshot soft softMod softModCtx sort sound soundControl source spaceLocator sphere sphrand spotLight spotLightPreviewPort spreadSheetEditor spring sqrt squareSurface srtContext stackTrace startString startsWith stitchAndExplodeShell stitchSurface stitchSurfacePoints strcmp stringArrayCatenate stringArrayContains stringArrayCount stringArrayInsertAtIndex stringArrayIntersector stringArrayRemove stringArrayRemoveAtIndex stringArrayRemoveDuplicates stringArrayRemoveExact stringArrayToString stringToStringArray strip stripPrefixFromName stroke subdAutoProjection subdCleanTopology subdCollapse subdDuplicateAndConnect subdEditUV subdListComponentConversion subdMapCut subdMapSewMove subdMatchTopology subdMirror subdToBlind subdToPoly subdTransferUVsToCache subdiv subdivCrease subdivDisplaySmoothness substitute substituteAllString substituteGeometry substring surface surfaceSampler surfaceShaderList swatchDisplayPort switchTable symbolButton symbolCheckBox sysFile system tabLayout tan tangentConstraint texLatticeDeformContext texManipContext texMoveContext texMoveUVShellContext texRotateContext texScaleContext texSelectContext texSelectShortestPathCtx texSmudgeUVContext texWinToolCtx text textCurves textField textFieldButtonGrp textFieldGrp textManip textScrollList textToShelf textureDisplacePlane textureHairColor texturePlacementContext textureWindow threadCount threePointArcCtx timeControl timePort timerX toNativePath toggle toggleAxis toggleWindowVisibility tokenize tokenizeList tolerance tolower toolButton toolCollection toolDropped toolHasOptions toolPropertyWindow torus toupper trace track trackCtx transferAttributes transformCompare transformLimits translator trim trunc truncateFluidCache truncateHairCache tumble tumbleCtx turbulence twoPointArcCtx uiRes uiTemplate unassignInputDevice undo undoInfo ungroup uniform unit unloadPlugin untangleUV untitledFileName untrim upAxis updateAE userCtx uvLink uvSnapshot validateShelfName vectorize view2dToolCtx viewCamera viewClipPlane viewFit viewHeadOn viewLookAt viewManip viewPlace viewSet visor volumeAxis vortex waitCursor warning webBrowser webBrowserPrefs whatIs window windowPref wire wireContext workspace wrinkle wrinkleContext writeTake xbmLangPathList xform",illegal:"</",contains:[hljs.C_NUMBER_MODE,hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,{className:"string",begin:"`",end:"`",contains:[hljs.BACKSLASH_ESCAPE]},{className:"variable",variants:[{begin:"\\$\\d"},{begin:"[\\$\\%\\@](\\^\\w\\b|#\\w+|[^\\s\\w{]|{\\w+}|\\w+)"},{begin:"\\*(\\^\\w\\b|#\\w+|[^\\s\\w{]|{\\w+}|\\w+)",relevance:0}]},hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE]}}),hljs.registerLanguage("mercury",function(hljs){var KEYWORDS={keyword:"module use_module import_module include_module end_module initialise mutable initialize finalize finalise interface implementation pred mode func type inst solver any_pred any_func is semidet det nondet multi erroneous failure cc_nondet cc_multi typeclass instance where pragma promise external trace atomic or_else require_complete_switch require_det require_semidet require_multi require_nondet require_cc_multi require_cc_nondet require_erroneous require_failure",pragma:"inline no_inline type_spec source_file fact_table obsolete memo loop_check minimal_model terminates does_not_terminate check_termination promise_equivalent_clauses",preprocessor:"foreign_proc foreign_decl foreign_code foreign_type foreign_import_module foreign_export_enum foreign_export foreign_enum may_call_mercury will_not_call_mercury thread_safe not_thread_safe maybe_thread_safe promise_pure promise_semipure tabled_for_io local untrailed trailed attach_to_io_state can_pass_as_mercury_type stable will_not_throw_exception may_modify_trail will_not_modify_trail may_duplicate may_not_duplicate affects_liveness does_not_affect_liveness doesnt_affect_liveness no_sharing unknown_sharing sharing",built_in:"some all not if then else true fail false try catch catch_any semidet_true semidet_false semidet_fail impure_true impure semipure"},TODO={className:"label",begin:"XXX",end:"$",endsWithParent:!0,relevance:0},COMMENT=hljs.inherit(hljs.C_LINE_COMMENT_MODE,{begin:"%"}),CCOMMENT=hljs.inherit(hljs.C_BLOCK_COMMENT_MODE,{relevance:0});COMMENT.contains.push(TODO),CCOMMENT.contains.push(TODO);var NUMCODE={className:"number",begin:"0'.\\|0[box][0-9a-fA-F]*"},ATOM=hljs.inherit(hljs.APOS_STRING_MODE,{relevance:0}),STRING=hljs.inherit(hljs.QUOTE_STRING_MODE,{relevance:0}),STRING_FMT={className:"constant",begin:"\\\\[abfnrtv]\\|\\\\x[0-9a-fA-F]*\\\\\\|%[-+# *.0-9]*[dioxXucsfeEgGp]",relevance:0};STRING.contains.push(STRING_FMT);var IMPLICATION={className:"built_in",variants:[{begin:"<=>"},{begin:"<=",relevance:0},{begin:"=>",relevance:0},{begin:"/\\\\"},{begin:"\\\\/"}]},HEAD_BODY_CONJUNCTION={className:"built_in",variants:[{begin:":-\\|-->"},{begin:"=",relevance:0}]};return{aliases:["m","moo"],keywords:KEYWORDS,contains:[IMPLICATION,HEAD_BODY_CONJUNCTION,COMMENT,CCOMMENT,NUMCODE,hljs.NUMBER_MODE,ATOM,STRING,{begin:/:-/}]}}),hljs.registerLanguage("mizar",function(hljs){return{keywords:"environ vocabularies notations constructors definitions registrations theorems schemes requirements begin end definition registration cluster existence pred func defpred deffunc theorem proof let take assume then thus hence ex for st holds consider reconsider such that and in provided of as from be being by means equals implies iff redefine define now not or attr is mode suppose per cases set thesis contradiction scheme reserve struct correctness compatibility coherence symmetry assymetry reflexivity irreflexivity connectedness uniqueness commutativity idempotence involutiveness projectivity",contains:[hljs.COMMENT("::","$")]}}),hljs.registerLanguage("perl",function(hljs){var PERL_KEYWORDS="getpwent getservent quotemeta msgrcv scalar kill dbmclose undef lc ma syswrite tr send umask sysopen shmwrite vec qx utime local oct semctl localtime readpipe do return format read sprintf dbmopen pop getpgrp not getpwnam rewinddir qqfileno qw endprotoent wait sethostent bless s|0 opendir continue each sleep endgrent shutdown dump chomp connect getsockname die socketpair close flock exists index shmgetsub for endpwent redo lstat msgctl setpgrp abs exit select print ref gethostbyaddr unshift fcntl syscall goto getnetbyaddr join gmtime symlink semget splice x|0 getpeername recv log setsockopt cos last reverse gethostbyname getgrnam study formline endhostent times chop length gethostent getnetent pack getprotoent getservbyname rand mkdir pos chmod y|0 substr endnetent printf next open msgsnd readdir use unlink getsockopt getpriority rindex wantarray hex system getservbyport endservent int chr untie rmdir prototype tell listen fork shmread ucfirst setprotoent else sysseek link getgrgid shmctl waitpid unpack getnetbyname reset chdir grep split require caller lcfirst until warn while values shift telldir getpwuid my getprotobynumber delete and sort uc defined srand accept package seekdir getprotobyname semop our rename seek if q|0 chroot sysread setpwent no crypt getc chown sqrt write setnetent setpriority foreach tie sin msgget map stat getlogin unless elsif truncate exec keys glob tied closedirioctl socket readlink eval xor readline binmode setservent eof ord bind alarm pipe atan2 getgrent exp time push setgrent gt lt or ne m|0 break given say state when",SUBST={className:"subst",begin:"[$@]\\{",end:"\\}",keywords:PERL_KEYWORDS},METHOD={begin:"->{",end:"}"},VAR={className:"variable",variants:[{begin:/\$\d/},{begin:/[\$%@](\^\w\b|#\w+(::\w+)*|{\w+}|\w+(::\w*)*)/},{begin:/[\$%@][^\s\w{]/,relevance:0}]},STRING_CONTAINS=[hljs.BACKSLASH_ESCAPE,SUBST,VAR],PERL_DEFAULT_CONTAINS=[VAR,hljs.HASH_COMMENT_MODE,hljs.COMMENT("^\\=\\w","\\=cut",{endsWithParent:!0}),METHOD,{className:"string",contains:STRING_CONTAINS,variants:[{begin:"q[qwxr]?\\s*\\(",end:"\\)",relevance:5},{begin:"q[qwxr]?\\s*\\[",end:"\\]",relevance:5},{begin:"q[qwxr]?\\s*\\{",end:"\\}",relevance:5},{begin:"q[qwxr]?\\s*\\|",end:"\\|",relevance:5},{begin:"q[qwxr]?\\s*\\<",end:"\\>",relevance:5},{begin:"qw\\s+q",end:"q",relevance:5},{begin:"'",end:"'",contains:[hljs.BACKSLASH_ESCAPE]},{begin:'"',end:'"'},{begin:"`",end:"`",contains:[hljs.BACKSLASH_ESCAPE]},{begin:"{\\w+}",contains:[],relevance:0},{begin:"-?\\w+\\s*\\=\\>",contains:[],relevance:0}]},{className:"number",begin:"(\\b0[0-7_]+)|(\\b0x[0-9a-fA-F_]+)|(\\b[1-9][0-9_]*(\\.[0-9_]+)?)|[0_]\\b",relevance:0},{begin:"(\\/\\/|"+hljs.RE_STARTERS_RE+"|\\b(split|return|print|reverse|grep)\\b)\\s*",keywords:"split return print reverse grep",relevance:0,contains:[hljs.HASH_COMMENT_MODE,{className:"regexp",begin:"(s|tr|y)/(\\\\.|[^/])*/(\\\\.|[^/])*/[a-z]*",relevance:10},{className:"regexp",begin:"(m|qr)?/",end:"/[a-z]*",contains:[hljs.BACKSLASH_ESCAPE],relevance:0}]},{className:"sub",beginKeywords:"sub",end:"(\\s*\\(.*?\\))?[;{]",relevance:5},{className:"operator",begin:"-\\w\\b",relevance:0},{begin:"^__DATA__$",end:"^__END__$",subLanguage:"mojolicious",contains:[{begin:"^@@.*",end:"$",className:"comment"}]}];return SUBST.contains=PERL_DEFAULT_CONTAINS,METHOD.contains=PERL_DEFAULT_CONTAINS,{aliases:["pl"],keywords:PERL_KEYWORDS,contains:PERL_DEFAULT_CONTAINS}}),hljs.registerLanguage("mojolicious",function(hljs){return{subLanguage:"xml",contains:[{className:"preprocessor",begin:"^__(END|DATA)__$"},{begin:"^\\s*%{1,2}={0,2}",end:"$",subLanguage:"perl"},{begin:"<%{1,2}={0,2}",end:"={0,1}%>",subLanguage:"perl",excludeBegin:!0,excludeEnd:!0}]}}),hljs.registerLanguage("monkey",function(hljs){var NUMBER={className:"number",relevance:0,variants:[{begin:"[$][a-fA-F0-9]+"},hljs.NUMBER_MODE]};return{case_insensitive:!0,keywords:{keyword:"public private property continue exit extern new try catch eachin not abstract final select case default const local global field end if then else elseif endif while wend repeat until forever for to step next return module inline throw",built_in:"DebugLog DebugStop Error Print ACos ACosr ASin ASinr ATan ATan2 ATan2r ATanr Abs Abs Ceil Clamp Clamp Cos Cosr Exp Floor Log Max Max Min Min Pow Sgn Sgn Sin Sinr Sqrt Tan Tanr Seed PI HALFPI TWOPI",literal:"true false null and or shl shr mod"},illegal:/\/\*/,contains:[hljs.COMMENT("#rem","#end"),hljs.COMMENT("'","$",{relevance:0}),{className:"function",beginKeywords:"function method",end:"[(=:]|$",illegal:/\n/,contains:[hljs.UNDERSCORE_TITLE_MODE]},{className:"class",beginKeywords:"class interface",end:"$",contains:[{beginKeywords:"extends implements"},hljs.UNDERSCORE_TITLE_MODE]},{className:"variable",begin:"\\b(self|super)\\b"},{className:"preprocessor",beginKeywords:"import",end:"$"},{className:"preprocessor",begin:"\\s*#",end:"$",keywords:"if else elseif endif end then"},{className:"pi",begin:"^\\s*strict\\b"},{beginKeywords:"alias",end:"=",contains:[hljs.UNDERSCORE_TITLE_MODE]},hljs.QUOTE_STRING_MODE,NUMBER]}}),hljs.registerLanguage("nginx",function(hljs){var VAR={className:"variable",variants:[{begin:/\$\d+/},{begin:/\$\{/,end:/}/},{begin:"[\\$\\@]"+hljs.UNDERSCORE_IDENT_RE}]},DEFAULT={endsWithParent:!0,lexemes:"[a-z/_]+",keywords:{built_in:"on off yes no true false none blocked debug info notice warn error crit select break last permanent redirect kqueue rtsig epoll poll /dev/poll"},relevance:0,illegal:"=>",contains:[hljs.HASH_COMMENT_MODE,{className:"string",contains:[hljs.BACKSLASH_ESCAPE,VAR],variants:[{begin:/"/,end:/"/},{begin:/'/,end:/'/}]},{className:"url",begin:"([a-z]+):/",end:"\\s",endsWithParent:!0,excludeEnd:!0,contains:[VAR]},{className:"regexp",contains:[hljs.BACKSLASH_ESCAPE,VAR],variants:[{begin:"\\s\\^",end:"\\s|{|;",returnEnd:!0},{begin:"~\\*?\\s+",end:"\\s|{|;",returnEnd:!0},{begin:"\\*(\\.[a-z\\-]+)+"},{begin:"([a-z\\-]+\\.)+\\*"}]},{className:"number",begin:"\\b\\d{1,3}\\.\\d{1,3}\\.\\d{1,3}\\.\\d{1,3}(:\\d{1,5})?\\b"},{className:"number",begin:"\\b\\d+[kKmMgGdshdwy]*\\b",relevance:0},VAR]};return{aliases:["nginxconf"],contains:[hljs.HASH_COMMENT_MODE,{begin:hljs.UNDERSCORE_IDENT_RE+"\\s",end:";|{",returnBegin:!0,contains:[{className:"title",begin:hljs.UNDERSCORE_IDENT_RE,starts:DEFAULT}],relevance:0}],illegal:"[^\\s\\}]"}}),hljs.registerLanguage("nimrod",function(hljs){return{aliases:["nim"],keywords:{keyword:"addr and as asm bind block break|0 case|0 cast const|0 continue|0 converter discard distinct|10 div do elif else|0 end|0 enum|0 except export finally for from generic if|0 import|0 in include|0 interface is isnot|10 iterator|10 let|0 macro method|10 mixin mod nil not notin|10 object|0 of or out proc|10 ptr raise ref|10 return shl shr static template try|0 tuple type|0 using|0 var|0 when while|0 with without xor yield",literal:"shared guarded stdin stdout stderr result|10 true false"},contains:[{className:"decorator",begin:/{\./,end:/\.}/,relevance:10},{className:"string",begin:/[a-zA-Z]\w*"/,end:/"/,contains:[{begin:/""/}]},{className:"string",begin:/([a-zA-Z]\w*)?"""/,end:/"""/},hljs.QUOTE_STRING_MODE,{className:"type",begin:/\b[A-Z]\w+\b/,relevance:0},{className:"type",begin:/\b(int|int8|int16|int32|int64|uint|uint8|uint16|uint32|uint64|float|float32|float64|bool|char|string|cstring|pointer|expr|stmt|void|auto|any|range|array|openarray|varargs|seq|set|clong|culong|cchar|cschar|cshort|cint|csize|clonglong|cfloat|cdouble|clongdouble|cuchar|cushort|cuint|culonglong|cstringarray|semistatic)\b/},{className:"number",begin:/\b(0[xX][0-9a-fA-F][_0-9a-fA-F]*)('?[iIuU](8|16|32|64))?/,relevance:0},{className:"number",begin:/\b(0o[0-7][_0-7]*)('?[iIuUfF](8|16|32|64))?/,relevance:0},{className:"number",begin:/\b(0(b|B)[01][_01]*)('?[iIuUfF](8|16|32|64))?/,relevance:0},{className:"number",begin:/\b(\d[_\d]*)('?[iIuUfF](8|16|32|64))?/,relevance:0},hljs.HASH_COMMENT_MODE]}}),hljs.registerLanguage("nix",function(hljs){var NIX_KEYWORDS={keyword:"rec with let in inherit assert if else then",constant:"true false or and null",built_in:"import abort baseNameOf dirOf isNull builtins map removeAttrs throw toString derivation"},ANTIQUOTE={className:"subst",begin:/\$\{/,end:/}/,keywords:NIX_KEYWORDS},ATTRS={className:"variable",begin:/[a-zA-Z0-9-_]+(\s*=)/,relevance:0},SINGLE_QUOTE={className:"string",begin:"''",end:"''",contains:[ANTIQUOTE]},DOUBLE_QUOTE={className:"string",begin:'"',end:'"',contains:[ANTIQUOTE]},EXPRESSIONS=[hljs.NUMBER_MODE,hljs.HASH_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,SINGLE_QUOTE,DOUBLE_QUOTE,ATTRS];return ANTIQUOTE.contains=EXPRESSIONS,{aliases:["nixos"],keywords:NIX_KEYWORDS,contains:EXPRESSIONS}}),hljs.registerLanguage("nsis",function(hljs){var CONSTANTS={className:"symbol",begin:"\\$(ADMINTOOLS|APPDATA|CDBURN_AREA|CMDLINE|COMMONFILES32|COMMONFILES64|COMMONFILES|COOKIES|DESKTOP|DOCUMENTS|EXEDIR|EXEFILE|EXEPATH|FAVORITES|FONTS|HISTORY|HWNDPARENT|INSTDIR|INTERNET_CACHE|LANGUAGE|LOCALAPPDATA|MUSIC|NETHOOD|OUTDIR|PICTURES|PLUGINSDIR|PRINTHOOD|PROFILE|PROGRAMFILES32|PROGRAMFILES64|PROGRAMFILES|QUICKLAUNCH|RECENT|RESOURCES_LOCALIZED|RESOURCES|SENDTO|SMPROGRAMS|SMSTARTUP|STARTMENU|SYSDIR|TEMP|TEMPLATES|VIDEOS|WINDIR)"},DEFINES={className:"constant",begin:"\\$+{[a-zA-Z0-9_]+}"},VARIABLES={className:"variable",begin:"\\$+[a-zA-Z0-9_]+",illegal:"\\(\\){}"},LANGUAGES={className:"constant",begin:"\\$+\\([a-zA-Z0-9_]+\\)"},PARAMETERS={className:"params",begin:"(ARCHIVE|FILE_ATTRIBUTE_ARCHIVE|FILE_ATTRIBUTE_NORMAL|FILE_ATTRIBUTE_OFFLINE|FILE_ATTRIBUTE_READONLY|FILE_ATTRIBUTE_SYSTEM|FILE_ATTRIBUTE_TEMPORARY|HKCR|HKCU|HKDD|HKEY_CLASSES_ROOT|HKEY_CURRENT_CONFIG|HKEY_CURRENT_USER|HKEY_DYN_DATA|HKEY_LOCAL_MACHINE|HKEY_PERFORMANCE_DATA|HKEY_USERS|HKLM|HKPD|HKU|IDABORT|IDCANCEL|IDIGNORE|IDNO|IDOK|IDRETRY|IDYES|MB_ABORTRETRYIGNORE|MB_DEFBUTTON1|MB_DEFBUTTON2|MB_DEFBUTTON3|MB_DEFBUTTON4|MB_ICONEXCLAMATION|MB_ICONINFORMATION|MB_ICONQUESTION|MB_ICONSTOP|MB_OK|MB_OKCANCEL|MB_RETRYCANCEL|MB_RIGHT|MB_RTLREADING|MB_SETFOREGROUND|MB_TOPMOST|MB_USERICON|MB_YESNO|NORMAL|OFFLINE|READONLY|SHCTX|SHELL_CONTEXT|SYSTEM|TEMPORARY)"
},COMPILER={className:"constant",begin:"\\!(addincludedir|addplugindir|appendfile|cd|define|delfile|echo|else|endif|error|execute|finalize|getdllversionsystem|ifdef|ifmacrodef|ifmacrondef|ifndef|if|include|insertmacro|macroend|macro|makensis|packhdr|searchparse|searchreplace|tempfile|undef|verbose|warning)"};return{case_insensitive:!1,keywords:{keyword:"Abort AddBrandingImage AddSize AllowRootDirInstall AllowSkipFiles AutoCloseWindow BGFont BGGradient BrandingText BringToFront Call CallInstDLL Caption ChangeUI CheckBitmap ClearErrors CompletedText ComponentText CopyFiles CRCCheck CreateDirectory CreateFont CreateShortCut Delete DeleteINISec DeleteINIStr DeleteRegKey DeleteRegValue DetailPrint DetailsButtonText DirText DirVar DirVerify EnableWindow EnumRegKey EnumRegValue Exch Exec ExecShell ExecWait ExpandEnvStrings File FileBufSize FileClose FileErrorText FileOpen FileRead FileReadByte FileReadUTF16LE FileReadWord FileSeek FileWrite FileWriteByte FileWriteUTF16LE FileWriteWord FindClose FindFirst FindNext FindWindow FlushINI FunctionEnd GetCurInstType GetCurrentAddress GetDlgItem GetDLLVersion GetDLLVersionLocal GetErrorLevel GetFileTime GetFileTimeLocal GetFullPathName GetFunctionAddress GetInstDirError GetLabelAddress GetTempFileName Goto HideWindow Icon IfAbort IfErrors IfFileExists IfRebootFlag IfSilent InitPluginsDir InstallButtonText InstallColors InstallDir InstallDirRegKey InstProgressFlags InstType InstTypeGetText InstTypeSetText IntCmp IntCmpU IntFmt IntOp IsWindow LangString LicenseBkColor LicenseData LicenseForceSelection LicenseLangString LicenseText LoadLanguageFile LockWindow LogSet LogText ManifestDPIAware ManifestSupportedOS MessageBox MiscButtonText Name Nop OutFile Page PageCallbacks PageExEnd Pop Push Quit ReadEnvStr ReadINIStr ReadRegDWORD ReadRegStr Reboot RegDLL Rename RequestExecutionLevel ReserveFile Return RMDir SearchPath SectionEnd SectionGetFlags SectionGetInstTypes SectionGetSize SectionGetText SectionGroupEnd SectionIn SectionSetFlags SectionSetInstTypes SectionSetSize SectionSetText SendMessage SetAutoClose SetBrandingImage SetCompress SetCompressor SetCompressorDictSize SetCtlColors SetCurInstType SetDatablockOptimize SetDateSave SetDetailsPrint SetDetailsView SetErrorLevel SetErrors SetFileAttributes SetFont SetOutPath SetOverwrite SetPluginUnload SetRebootFlag SetRegView SetShellVarContext SetSilent ShowInstDetails ShowUninstDetails ShowWindow SilentInstall SilentUnInstall Sleep SpaceTexts StrCmp StrCmpS StrCpy StrLen SubCaption SubSectionEnd Unicode UninstallButtonText UninstallCaption UninstallIcon UninstallSubCaption UninstallText UninstPage UnRegDLL Var VIAddVersionKey VIFileVersion VIProductVersion WindowIcon WriteINIStr WriteRegBin WriteRegDWORD WriteRegExpandStr WriteRegStr WriteUninstaller XPStyle",literal:"admin all auto both colored current false force hide highest lastused leave listonly none normal notset off on open print show silent silentlog smooth textonly true user "},contains:[hljs.HASH_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,{className:"string",begin:'"',end:'"',illegal:"\\n",contains:[{className:"symbol",begin:"\\$(\\\\(n|r|t)|\\$)"},CONSTANTS,DEFINES,VARIABLES,LANGUAGES]},hljs.COMMENT(";","$",{relevance:0}),{className:"function",beginKeywords:"Function PageEx Section SectionGroup SubSection",end:"$"},COMPILER,DEFINES,VARIABLES,LANGUAGES,PARAMETERS,hljs.NUMBER_MODE,{className:"literal",begin:hljs.IDENT_RE+"::"+hljs.IDENT_RE}]}}),hljs.registerLanguage("objectivec",function(hljs){var API_CLASS={className:"built_in",begin:"(AV|CA|CF|CG|CI|MK|MP|NS|UI)\\w+"},OBJC_KEYWORDS={keyword:"int float while char export sizeof typedef const struct for union unsigned long volatile static bool mutable if do return goto void enum else break extern asm case short default double register explicit signed typename this switch continue wchar_t inline readonly assign readwrite self @synchronized id typeof nonatomic super unichar IBOutlet IBAction strong weak copy in out inout bycopy byref oneway __strong __weak __block __autoreleasing @private @protected @public @try @property @end @throw @catch @finally @autoreleasepool @synthesize @dynamic @selector @optional @required",literal:"false true FALSE TRUE nil YES NO NULL",built_in:"BOOL dispatch_once_t dispatch_queue_t dispatch_sync dispatch_async dispatch_once"},LEXEMES=/[a-zA-Z@][a-zA-Z0-9_]*/,CLASS_KEYWORDS="@interface @class @protocol @implementation";return{aliases:["mm","objc","obj-c"],keywords:OBJC_KEYWORDS,lexemes:LEXEMES,illegal:"</",contains:[API_CLASS,hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,hljs.C_NUMBER_MODE,hljs.QUOTE_STRING_MODE,{className:"string",variants:[{begin:'@"',end:'"',illegal:"\\n",contains:[hljs.BACKSLASH_ESCAPE]},{begin:"'",end:"[^\\\\]'",illegal:"[^\\\\][^']"}]},{className:"preprocessor",begin:"#",end:"$",contains:[{className:"title",variants:[{begin:'"',end:'"'},{begin:"<",end:">"}]}]},{className:"class",begin:"("+CLASS_KEYWORDS.split(" ").join("|")+")\\b",end:"({|$)",excludeEnd:!0,keywords:CLASS_KEYWORDS,lexemes:LEXEMES,contains:[hljs.UNDERSCORE_TITLE_MODE]},{className:"variable",begin:"\\."+hljs.UNDERSCORE_IDENT_RE,relevance:0}]}}),hljs.registerLanguage("ocaml",function(hljs){return{aliases:["ml"],keywords:{keyword:"and as assert asr begin class constraint do done downto else end exception external for fun function functor if in include inherit! inherit initializer land lazy let lor lsl lsr lxor match method!|10 method mod module mutable new object of open! open or private rec sig struct then to try type val! val virtual when while with parser value",built_in:"array bool bytes char exn|5 float int int32 int64 list lazy_t|5 nativeint|5 string unit in_channel out_channel ref",literal:"true false"},illegal:/\/\/|>>/,lexemes:"[a-z_]\\w*!?",contains:[{className:"literal",begin:"\\[(\\|\\|)?\\]|\\(\\)",relevance:0},hljs.COMMENT("\\(\\*","\\*\\)",{contains:["self"]}),{className:"symbol",begin:"'[A-Za-z_](?!')[\\w']*"},{className:"tag",begin:"`[A-Z][\\w']*"},{className:"type",begin:"\\b[A-Z][\\w']*",relevance:0},{begin:"[a-z_]\\w*'[\\w']*"},hljs.inherit(hljs.APOS_STRING_MODE,{className:"char",relevance:0}),hljs.inherit(hljs.QUOTE_STRING_MODE,{illegal:null}),{className:"number",begin:"\\b(0[xX][a-fA-F0-9_]+[Lln]?|0[oO][0-7_]+[Lln]?|0[bB][01_]+[Lln]?|[0-9][0-9_]*([Lln]|(\\.[0-9_]*)?([eE][-+]?[0-9_]+)?)?)",relevance:0},{begin:/[-=]>/}]}}),hljs.registerLanguage("openscad",function(hljs){var SPECIAL_VARS={className:"keyword",begin:"\\$(f[asn]|t|vp[rtd]|children)"},LITERALS={className:"literal",begin:"false|true|PI|undef"},NUMBERS={className:"number",begin:"\\b\\d+(\\.\\d+)?(e-?\\d+)?",relevance:0},STRING=hljs.inherit(hljs.QUOTE_STRING_MODE,{illegal:null}),PREPRO={className:"preprocessor",keywords:"include use",begin:"include|use <",end:">"},PARAMS={className:"params",begin:"\\(",end:"\\)",contains:["self",NUMBERS,STRING,SPECIAL_VARS,LITERALS]},MODIFIERS={className:"built_in",begin:"[*!#%]",relevance:0},FUNCTIONS={className:"function",beginKeywords:"module function",end:"\\=|\\{",contains:[PARAMS,hljs.UNDERSCORE_TITLE_MODE]};return{aliases:["scad"],keywords:{keyword:"function module include use for intersection_for if else \\%",literal:"false true PI undef",built_in:"circle square polygon text sphere cube cylinder polyhedron translate rotate scale resize mirror multmatrix color offset hull minkowski union difference intersection abs sign sin cos tan acos asin atan atan2 floor round ceil ln log pow sqrt exp rands min max concat lookup str chr search version version_num norm cross parent_module echo import import_dxf dxf_linear_extrude linear_extrude rotate_extrude surface projection render children dxf_cross dxf_dim let assign"},contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,NUMBERS,PREPRO,STRING,SPECIAL_VARS,MODIFIERS,FUNCTIONS]}}),hljs.registerLanguage("oxygene",function(hljs){var OXYGENE_KEYWORDS="abstract add and array as asc aspect assembly async begin break block by case class concat const copy constructor continue create default delegate desc distinct div do downto dynamic each else empty end ensure enum equals event except exit extension external false final finalize finalizer finally flags for forward from function future global group has if implementation implements implies in index inherited inline interface into invariants is iterator join locked locking loop matching method mod module namespace nested new nil not notify nullable of old on operator or order out override parallel params partial pinned private procedure property protected public queryable raise read readonly record reintroduce remove repeat require result reverse sealed select self sequence set shl shr skip static step soft take then to true try tuple type union unit unsafe until uses using var virtual raises volatile where while with write xor yield await mapped deprecated stdcall cdecl pascal register safecall overload library platform reference packed strict published autoreleasepool selector strong weak unretained",CURLY_COMMENT=hljs.COMMENT("{","}",{relevance:0}),PAREN_COMMENT=hljs.COMMENT("\\(\\*","\\*\\)",{relevance:10}),STRING={className:"string",begin:"'",end:"'",contains:[{begin:"''"}]},CHAR_STRING={className:"string",begin:"(#\\d+)+"},FUNCTION={className:"function",beginKeywords:"function constructor destructor procedure method",end:"[:;]",keywords:"function constructor|10 destructor|10 procedure|10 method|10",contains:[hljs.TITLE_MODE,{className:"params",begin:"\\(",end:"\\)",keywords:OXYGENE_KEYWORDS,contains:[STRING,CHAR_STRING]},CURLY_COMMENT,PAREN_COMMENT]};return{case_insensitive:!0,keywords:OXYGENE_KEYWORDS,illegal:'("|\\$[G-Zg-z]|\\/\\*|</|=>|->)',contains:[CURLY_COMMENT,PAREN_COMMENT,hljs.C_LINE_COMMENT_MODE,STRING,CHAR_STRING,hljs.NUMBER_MODE,FUNCTION,{className:"class",begin:"=\\bclass\\b",end:"end;",keywords:OXYGENE_KEYWORDS,contains:[STRING,CHAR_STRING,CURLY_COMMENT,PAREN_COMMENT,hljs.C_LINE_COMMENT_MODE,FUNCTION]}]}}),hljs.registerLanguage("parser3",function(hljs){var CURLY_SUBCOMMENT=hljs.COMMENT("{","}",{contains:["self"]});return{subLanguage:"xml",relevance:0,contains:[hljs.COMMENT("^#","$"),hljs.COMMENT("\\^rem{","}",{relevance:10,contains:[CURLY_SUBCOMMENT]}),{className:"preprocessor",begin:"^@(?:BASE|USE|CLASS|OPTIONS)$",relevance:10},{className:"title",begin:"@[\\w\\-]+\\[[\\w^;\\-]*\\](?:\\[[\\w^;\\-]*\\])?(?:.*)$"},{className:"variable",begin:"\\$\\{?[\\w\\-\\.\\:]+\\}?"},{className:"keyword",begin:"\\^[\\w\\-\\.\\:]+"},{className:"number",begin:"\\^#[0-9a-fA-F]+"},hljs.C_NUMBER_MODE]}}),hljs.registerLanguage("pf",function(hljs){var MACRO={className:"variable",begin:/\$[\w\d#@][\w\d_]*/},TABLE={className:"variable",begin:/</,end:/>/};return{aliases:["pf.conf"],lexemes:/[a-z0-9_<>-]+/,keywords:{built_in:"block match pass load anchor|5 antispoof|10 set table",keyword:"in out log quick on rdomain inet inet6 proto from port os to routeallow-opts divert-packet divert-reply divert-to flags group icmp-typeicmp6-type label once probability recieved-on rtable prio queuetos tag tagged user keep fragment for os dropaf-to|10 binat-to|10 nat-to|10 rdr-to|10 bitmask least-stats random round-robinsource-hash static-portdup-to reply-to route-toparent bandwidth default min max qlimitblock-policy debug fingerprints hostid limit loginterface optimizationreassemble ruleset-optimization basic none profile skip state-defaultsstate-policy timeoutconst counters persistno modulate synproxy state|5 floating if-bound no-sync pflow|10 sloppysource-track global rule max-src-nodes max-src-states max-src-connmax-src-conn-rate overload flushscrub|5 max-mss min-ttl no-df|10 random-id",literal:"all any no-route self urpf-failed egress|5 unknown"},contains:[hljs.HASH_COMMENT_MODE,hljs.NUMBER_MODE,hljs.QUOTE_STRING_MODE,MACRO,TABLE]}}),hljs.registerLanguage("php",function(hljs){var VARIABLE={className:"variable",begin:"\\$+[a-zA-Z_-ÿ][a-zA-Z0-9_-ÿ]*"},PREPROCESSOR={className:"preprocessor",begin:/<\?(php)?|\?>/},STRING={className:"string",contains:[hljs.BACKSLASH_ESCAPE,PREPROCESSOR],variants:[{begin:'b"',end:'"'},{begin:"b'",end:"'"},hljs.inherit(hljs.APOS_STRING_MODE,{illegal:null}),hljs.inherit(hljs.QUOTE_STRING_MODE,{illegal:null})]},NUMBER={variants:[hljs.BINARY_NUMBER_MODE,hljs.C_NUMBER_MODE]};return{aliases:["php3","php4","php5","php6"],case_insensitive:!0,keywords:"and include_once list abstract global private echo interface as static endswitch array null if endwhile or const for endforeach self var while isset public protected exit foreach throw elseif include __FILE__ empty require_once do xor return parent clone use __CLASS__ __LINE__ else break print eval new catch __METHOD__ case exception default die require __FUNCTION__ enddeclare final try switch continue endfor endif declare unset true false trait goto instanceof insteadof __DIR__ __NAMESPACE__ yield finally",contains:[hljs.C_LINE_COMMENT_MODE,hljs.HASH_COMMENT_MODE,hljs.COMMENT("/\\*","\\*/",{contains:[{className:"doctag",begin:"@[A-Za-z]+"},PREPROCESSOR]}),hljs.COMMENT("__halt_compiler.+?;",!1,{endsWithParent:!0,keywords:"__halt_compiler",lexemes:hljs.UNDERSCORE_IDENT_RE}),{className:"string",begin:/<<<['"]?\w+['"]?$/,end:/^\w+;?$/,contains:[hljs.BACKSLASH_ESCAPE,{className:"subst",variants:[{begin:/\$\w+/},{begin:/\{\$/,end:/\}/}]}]},PREPROCESSOR,VARIABLE,{begin:/(::|->)+[a-zA-Z_\x7f-\xff][a-zA-Z0-9_\x7f-\xff]*/},{className:"function",beginKeywords:"function",end:/[;{]/,excludeEnd:!0,illegal:"\\$|\\[|%",contains:[hljs.UNDERSCORE_TITLE_MODE,{className:"params",begin:"\\(",end:"\\)",contains:["self",VARIABLE,hljs.C_BLOCK_COMMENT_MODE,STRING,NUMBER]}]},{className:"class",beginKeywords:"class interface",end:"{",excludeEnd:!0,illegal:/[:\(\$"]/,contains:[{beginKeywords:"extends implements"},hljs.UNDERSCORE_TITLE_MODE]},{beginKeywords:"namespace",end:";",illegal:/[\.']/,contains:[hljs.UNDERSCORE_TITLE_MODE]},{beginKeywords:"use",end:";",contains:[hljs.UNDERSCORE_TITLE_MODE]},{begin:"=>"},STRING,NUMBER]}}),hljs.registerLanguage("powershell",function(hljs){var backtickEscape={begin:"`[\\s\\S]",relevance:0},VAR={className:"variable",variants:[{begin:/\$[\w\d][\w\d_:]*/}]},QUOTE_STRING={className:"string",begin:/"/,end:/"/,contains:[backtickEscape,VAR,{className:"variable",begin:/\$[A-z]/,end:/[^A-z]/}]},APOS_STRING={className:"string",begin:/'/,end:/'/};return{aliases:["ps"],lexemes:/-?[A-z\.\-]+/,case_insensitive:!0,keywords:{keyword:"if else foreach return function do while until elseif begin for trap data dynamicparam end break throw param continue finally in switch exit filter try process catch",literal:"$null $true $false",built_in:"Add-Content Add-History Add-Member Add-PSSnapin Clear-Content Clear-Item Clear-Item Property Clear-Variable Compare-Object ConvertFrom-SecureString Convert-Path ConvertTo-Html ConvertTo-SecureString Copy-Item Copy-ItemProperty Export-Alias Export-Clixml Export-Console Export-Csv ForEach-Object Format-Custom Format-List Format-Table Format-Wide Get-Acl Get-Alias Get-AuthenticodeSignature Get-ChildItem Get-Command Get-Content Get-Credential Get-Culture Get-Date Get-EventLog Get-ExecutionPolicy Get-Help Get-History Get-Host Get-Item Get-ItemProperty Get-Location Get-Member Get-PfxCertificate Get-Process Get-PSDrive Get-PSProvider Get-PSSnapin Get-Service Get-TraceSource Get-UICulture Get-Unique Get-Variable Get-WmiObject Group-Object Import-Alias Import-Clixml Import-Csv Invoke-Expression Invoke-History Invoke-Item Join-Path Measure-Command Measure-Object Move-Item Move-ItemProperty New-Alias New-Item New-ItemProperty New-Object New-PSDrive New-Service New-TimeSpan New-Variable Out-Default Out-File Out-Host Out-Null Out-Printer Out-String Pop-Location Push-Location Read-Host Remove-Item Remove-ItemProperty Remove-PSDrive Remove-PSSnapin Remove-Variable Rename-Item Rename-ItemProperty Resolve-Path Restart-Service Resume-Service Select-Object Select-String Set-Acl Set-Alias Set-AuthenticodeSignature Set-Content Set-Date Set-ExecutionPolicy Set-Item Set-ItemProperty Set-Location Set-PSDebug Set-Service Set-TraceSource Set-Variable Sort-Object Split-Path Start-Service Start-Sleep Start-Transcript Stop-Process Stop-Service Stop-Transcript Suspend-Service Tee-Object Test-Path Trace-Command Update-FormatData Update-TypeData Where-Object Write-Debug Write-Error Write-Host Write-Output Write-Progress Write-Verbose Write-Warning",operator:"-ne -eq -lt -gt -ge -le -not -like -notlike -match -notmatch -contains -notcontains -in -notin -replace"},contains:[hljs.HASH_COMMENT_MODE,hljs.NUMBER_MODE,QUOTE_STRING,APOS_STRING,VAR]}}),hljs.registerLanguage("processing",function(hljs){return{keywords:{keyword:"BufferedReader PVector PFont PImage PGraphics HashMap boolean byte char color double float int long String Array FloatDict FloatList IntDict IntList JSONArray JSONObject Object StringDict StringList Table TableRow XML false synchronized int abstract float private char boolean static null if const for true while long throw strictfp finally protected import native final return void enum else break transient new catch instanceof byte super volatile case assert short package default double public try this switch continue throws protected public private",constant:"P2D P3D HALF_PI PI QUARTER_PI TAU TWO_PI",variable:"displayHeight displayWidth mouseY mouseX mousePressed pmouseX pmouseY key keyCode pixels focused frameCount frameRate height width",title:"setup draw",built_in:"size createGraphics beginDraw createShape loadShape PShape arc ellipse line point quad rect triangle bezier bezierDetail bezierPoint bezierTangent curve curveDetail curvePoint curveTangent curveTightness shape shapeMode beginContour beginShape bezierVertex curveVertex endContour endShape quadraticVertex vertex ellipseMode noSmooth rectMode smooth strokeCap strokeJoin strokeWeight mouseClicked mouseDragged mouseMoved mousePressed mouseReleased mouseWheel keyPressed keyPressedkeyReleased keyTyped print println save saveFrame day hour millis minute month second year background clear colorMode fill noFill noStroke stroke alpha blue brightness color green hue lerpColor red saturation modelX modelY modelZ screenX screenY screenZ ambient emissive shininess specular add createImage beginCamera camera endCamera frustum ortho perspective printCamera printProjection cursor frameRate noCursor exit loop noLoop popStyle pushStyle redraw binary boolean byte char float hex int str unbinary unhex join match matchAll nf nfc nfp nfs split splitTokens trim append arrayCopy concat expand reverse shorten sort splice subset box sphere sphereDetail createInput createReader loadBytes loadJSONArray loadJSONObject loadStrings loadTable loadXML open parseXML saveTable selectFolder selectInput beginRaw beginRecord createOutput createWriter endRaw endRecord PrintWritersaveBytes saveJSONArray saveJSONObject saveStream saveStrings saveXML selectOutput popMatrix printMatrix pushMatrix resetMatrix rotate rotateX rotateY rotateZ scale shearX shearY translate ambientLight directionalLight lightFalloff lights lightSpecular noLights normal pointLight spotLight image imageMode loadImage noTint requestImage tint texture textureMode textureWrap blend copy filter get loadPixels set updatePixels blendMode loadShader PShaderresetShader shader createFont loadFont text textFont textAlign textLeading textMode textSize textWidth textAscent textDescent abs ceil constrain dist exp floor lerp log mag map max min norm pow round sq sqrt acos asin atan atan2 cos degrees radians sin tan noise noiseDetail noiseSeed random randomGaussian randomSeed"},contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.C_NUMBER_MODE]}}),hljs.registerLanguage("profile",function(hljs){return{contains:[hljs.C_NUMBER_MODE,{className:"built_in",begin:"{",end:"}$",excludeBegin:!0,excludeEnd:!0,contains:[hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE],relevance:0},{className:"filename",begin:"[a-zA-Z_][\\da-zA-Z_]+\\.[\\da-zA-Z_]{1,3}",end:":",excludeEnd:!0},{className:"header",begin:"(ncalls|tottime|cumtime)",end:"$",keywords:"ncalls tottime|10 cumtime|10 filename",relevance:10},{className:"summary",begin:"function calls",end:"$",contains:[hljs.C_NUMBER_MODE],relevance:10},hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,{className:"function",begin:"\\(",end:"\\)$",contains:[hljs.UNDERSCORE_TITLE_MODE],relevance:0}]}}),hljs.registerLanguage("prolog",function(hljs){var ATOM={className:"atom",begin:/[a-z][A-Za-z0-9_]*/,relevance:0},VAR={className:"name",variants:[{begin:/[A-Z][a-zA-Z0-9_]*/},{begin:/_[A-Za-z0-9_]*/}],relevance:0},PARENTED={begin:/\(/,end:/\)/,relevance:0},LIST={begin:/\[/,end:/\]/},LINE_COMMENT={className:"comment",begin:/%/,end:/$/,contains:[hljs.PHRASAL_WORDS_MODE]},BACKTICK_STRING={className:"string",begin:/`/,end:/`/,contains:[hljs.BACKSLASH_ESCAPE]},CHAR_CODE={className:"string",begin:/0\'(\\\'|.)/},SPACE_CODE={className:"string",begin:/0\'\\s/},PRED_OP={begin:/:-/},inner=[ATOM,VAR,PARENTED,PRED_OP,LIST,LINE_COMMENT,hljs.C_BLOCK_COMMENT_MODE,hljs.QUOTE_STRING_MODE,hljs.APOS_STRING_MODE,BACKTICK_STRING,CHAR_CODE,SPACE_CODE,hljs.C_NUMBER_MODE];return PARENTED.contains=inner,LIST.contains=inner,{contains:inner.concat([{begin:/\.$/}])}}),hljs.registerLanguage("protobuf",function(hljs){return{keywords:{keyword:"package import option optional required repeated group",built_in:"double float int32 int64 uint32 uint64 sint32 sint64 fixed32 fixed64 sfixed32 sfixed64 bool string bytes",literal:"true false"},contains:[hljs.QUOTE_STRING_MODE,hljs.NUMBER_MODE,hljs.C_LINE_COMMENT_MODE,{className:"class",beginKeywords:"message enum service",end:/\{/,illegal:/\n/,contains:[hljs.inherit(hljs.TITLE_MODE,{starts:{endsWithParent:!0,excludeEnd:!0}})]},{className:"function",beginKeywords:"rpc",end:/;/,excludeEnd:!0,keywords:"rpc returns"},{className:"constant",begin:/^\s*[A-Z_]+/,end:/\s*=/,excludeEnd:!0}]}}),hljs.registerLanguage("puppet",function(hljs){var PUPPET_KEYWORDS={keyword:"and case default else elsif false if in import enherits node or true undef unless main settings $string ",literal:"alias audit before loglevel noop require subscribe tag owner ensure group mode name|0 changes context force incl lens load_path onlyif provider returns root show_diff type_check en_address ip_address realname command environment hour monute month monthday special target weekday creates cwd ogoutput refresh refreshonly tries try_sleep umask backup checksum content ctime force ignore links mtime purge recurse recurselimit replace selinux_ignore_defaults selrange selrole seltype seluser source souirce_permissions sourceselect validate_cmd validate_replacement allowdupe attribute_membership auth_membership forcelocal gid ia_load_module members system host_aliases ip allowed_trunk_vlans description device_url duplex encapsulation etherchannel native_vlan speed principals allow_root auth_class auth_type authenticate_user k_of_n mechanisms rule session_owner shared options device fstype enable hasrestart directory present absent link atboot blockdevice device dump pass remounts poller_tag use message withpath adminfile allow_virtual allowcdrom category configfiles flavor install_options instance package_settings platform responsefile status uninstall_options vendor unless_system_user unless_uid binary control flags hasstatus manifest pattern restart running start stop allowdupe auths expiry gid groups home iterations key_membership keys managehome membership password password_max_age password_min_age profile_membership profiles project purge_ssh_keys role_membership roles salt shell uid baseurl cost descr enabled enablegroups exclude failovermethod gpgcheck gpgkey http_caching include includepkgs keepalive metadata_expire metalink mirrorlist priority protect proxy proxy_password proxy_username repo_gpgcheck s3_enabled skip_if_unavailable sslcacert sslclientcert sslclientkey sslverify mounted",built_in:"architecture augeasversion blockdevices boardmanufacturer boardproductname boardserialnumber cfkey dhcp_servers domain ec2_ ec2_userdata facterversion filesystems ldom fqdn gid hardwareisa hardwaremodel hostname id|0 interfaces ipaddress ipaddress_ ipaddress6 ipaddress6_ iphostnumber is_virtual kernel kernelmajversion kernelrelease kernelversion kernelrelease kernelversion lsbdistcodename lsbdistdescription lsbdistid lsbdistrelease lsbmajdistrelease lsbminordistrelease lsbrelease macaddress macaddress_ macosx_buildversion macosx_productname macosx_productversion macosx_productverson_major macosx_productversion_minor manufacturer memoryfree memorysize netmask metmask_ network_ operatingsystem operatingsystemmajrelease operatingsystemrelease osfamily partitions path physicalprocessorcount processor processorcount productname ps puppetversion rubysitedir rubyversion selinux selinux_config_mode selinux_config_policy selinux_current_mode selinux_current_mode selinux_enforced selinux_policyversion serialnumber sp_ sshdsakey sshecdsakey sshrsakey swapencrypted swapfree swapsize timezone type uniqueid uptime uptime_days uptime_hours uptime_seconds uuid virtual vlans xendomains zfs_version zonenae zones zpool_version"},COMMENT=hljs.COMMENT("#","$"),IDENT_RE="([A-Za-z_]|::)(\\w|::)*",TITLE=hljs.inherit(hljs.TITLE_MODE,{begin:IDENT_RE}),VARIABLE={className:"variable",begin:"\\$"+IDENT_RE},STRING={className:"string",contains:[hljs.BACKSLASH_ESCAPE,VARIABLE],variants:[{begin:/'/,end:/'/},{begin:/"/,end:/"/}]};return{aliases:["pp"],contains:[COMMENT,VARIABLE,STRING,{beginKeywords:"class",end:"\\{|;",illegal:/=/,contains:[TITLE,COMMENT]},{beginKeywords:"define",end:/\{/,contains:[{className:"title",begin:hljs.IDENT_RE,endsParent:!0}]},{begin:hljs.IDENT_RE+"\\s+\\{",returnBegin:!0,end:/\S/,contains:[{className:"name",begin:hljs.IDENT_RE},{begin:/\{/,end:/\}/,keywords:PUPPET_KEYWORDS,relevance:0,contains:[STRING,COMMENT,{begin:"[a-zA-Z_]+\\s*=>"},{className:"number",begin:"(\\b0[0-7_]+)|(\\b0x[0-9a-fA-F_]+)|(\\b[1-9][0-9_]*(\\.[0-9_]+)?)|[0_]\\b",relevance:0},VARIABLE]}],relevance:0}]}}),hljs.registerLanguage("python",function(hljs){var PROMPT={className:"prompt",begin:/^(>>>|\.\.\.) /},STRING={className:"string",contains:[hljs.BACKSLASH_ESCAPE],variants:[{begin:/(u|b)?r?'''/,end:/'''/,contains:[PROMPT],relevance:10},{begin:/(u|b)?r?"""/,end:/"""/,contains:[PROMPT],relevance:10},{begin:/(u|r|ur)'/,end:/'/,relevance:10},{begin:/(u|r|ur)"/,end:/"/,relevance:10},{begin:/(b|br)'/,end:/'/},{begin:/(b|br)"/,end:/"/},hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE]},NUMBER={className:"number",relevance:0,variants:[{begin:hljs.BINARY_NUMBER_RE+"[lLjJ]?"},{begin:"\\b(0o[0-7]+)[lLjJ]?"},{begin:hljs.C_NUMBER_RE+"[lLjJ]?"}]},PARAMS={className:"params",begin:/\(/,end:/\)/,contains:["self",PROMPT,NUMBER,STRING]};return{aliases:["py","gyp"],keywords:{keyword:"and elif is global as in if from raise for except finally print import pass return exec else break not with class assert yield try while continue del or def lambda async await nonlocal|10 None True False",built_in:"Ellipsis NotImplemented"},illegal:/(<\/|->|\?)/,contains:[PROMPT,NUMBER,STRING,hljs.HASH_COMMENT_MODE,{variants:[{className:"function",beginKeywords:"def",relevance:10},{className:"class",beginKeywords:"class"}],end:/:/,illegal:/[${=;\n,]/,contains:[hljs.UNDERSCORE_TITLE_MODE,PARAMS]},{className:"decorator",begin:/^[\t ]*@/,end:/$/},{begin:/\b(print|exec)\(/}]}}),hljs.registerLanguage("q",function(hljs){var Q_KEYWORDS={keyword:"do while select delete by update from",constant:"0b 1b",built_in:"neg not null string reciprocal floor ceiling signum mod xbar xlog and or each scan over prior mmu lsq inv md5 ltime gtime count first var dev med cov cor all any rand sums prds mins maxs fills deltas ratios avgs differ prev next rank reverse iasc idesc asc desc msum mcount mavg mdev xrank mmin mmax xprev rotate distinct group where flip type key til get value attr cut set upsert raze union inter except cross sv vs sublist enlist read0 read1 hopen hclose hdel hsym hcount peach system ltrim rtrim trim lower upper ssr view tables views cols xcols keys xkey xcol xasc xdesc fkeys meta lj aj aj0 ij pj asof uj ww wj wj1 fby xgroup ungroup ej save load rsave rload show csv parse eval min max avg wavg wsum sin cos tan sum",typename:"`float `double int `timestamp `timespan `datetime `time `boolean `symbol `char `byte `short `long `real `month `date `minute `second `guid"};return{aliases:["k","kdb"],keywords:Q_KEYWORDS,lexemes:/\b(`?)[A-Za-z0-9_]+\b/,contains:[hljs.C_LINE_COMMENT_MODE,hljs.QUOTE_STRING_MODE,hljs.C_NUMBER_MODE]}}),hljs.registerLanguage("r",function(hljs){var IDENT_RE="([a-zA-Z]|\\.[a-zA-Z.])[a-zA-Z0-9._]*";return{contains:[hljs.HASH_COMMENT_MODE,{begin:IDENT_RE,lexemes:IDENT_RE,keywords:{keyword:"function if in break next repeat else for return switch while try tryCatch stop warning require library attach detach source setMethod setGeneric setGroupGeneric setClass ...",literal:"NULL NA TRUE FALSE T F Inf NaN NA_integer_|10 NA_real_|10 NA_character_|10 NA_complex_|10"},relevance:0},{className:"number",begin:"0[xX][0-9a-fA-F]+[Li]?\\b",relevance:0},{className:"number",begin:"\\d+(?:[eE][+\\-]?\\d*)?L\\b",relevance:0},{className:"number",begin:"\\d+\\.(?!\\d)(?:i\\b)?",relevance:0},{className:"number",begin:"\\d+(?:\\.\\d*)?(?:[eE][+\\-]?\\d*)?i?\\b",relevance:0},{className:"number",begin:"\\.\\d+(?:[eE][+\\-]?\\d*)?i?\\b",relevance:0},{begin:"`",end:"`",relevance:0},{className:"string",contains:[hljs.BACKSLASH_ESCAPE],variants:[{begin:'"',end:'"'},{begin:"'",end:"'"}]}]}}),hljs.registerLanguage("rib",function(hljs){return{keywords:"ArchiveRecord AreaLightSource Atmosphere Attribute AttributeBegin AttributeEnd Basis Begin Blobby Bound Clipping ClippingPlane Color ColorSamples ConcatTransform Cone CoordinateSystem CoordSysTransform CropWindow Curves Cylinder DepthOfField Detail DetailRange Disk Displacement Display End ErrorHandler Exposure Exterior Format FrameAspectRatio FrameBegin FrameEnd GeneralPolygon GeometricApproximation Geometry Hider Hyperboloid Identity Illuminate Imager Interior LightSource MakeCubeFaceEnvironment MakeLatLongEnvironment MakeShadow MakeTexture Matte MotionBegin MotionEnd NuPatch ObjectBegin ObjectEnd ObjectInstance Opacity Option Orientation Paraboloid Patch PatchMesh Perspective PixelFilter PixelSamples PixelVariance Points PointsGeneralPolygons PointsPolygons Polygon Procedural Projection Quantize ReadArchive RelativeDetail ReverseOrientation Rotate Scale ScreenWindow ShadingInterpolation ShadingRate Shutter Sides Skew SolidBegin SolidEnd Sphere SubdivisionMesh Surface TextureCoordinates Torus Transform TransformBegin TransformEnd TransformPoints Translate TrimCurve WorldBegin WorldEnd",illegal:"</",contains:[hljs.HASH_COMMENT_MODE,hljs.C_NUMBER_MODE,hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE]}}),hljs.registerLanguage("roboconf",function(hljs){var IDENTIFIER="[a-zA-Z-_][^\n{\r\n]+\\{";return{aliases:["graph","instances"],case_insensitive:!0,keywords:"import",contains:[{className:"facet",begin:"^facet "+IDENTIFIER,end:"}",keywords:"facet installer exports children extends",contains:[hljs.HASH_COMMENT_MODE]},{className:"instance-of",begin:"^instance of "+IDENTIFIER,end:"}",keywords:"name count channels instance-data instance-state instance of",contains:[{className:"keyword",begin:"[a-zA-Z-_]+( |\t)*:"},hljs.HASH_COMMENT_MODE]},{className:"component",begin:"^"+IDENTIFIER,end:"}",lexemes:"\\(?[a-zA-Z]+\\)?",keywords:"installer exports children extends imports facets alias (optional)",contains:[{className:"string",begin:"\\.[a-zA-Z-_]+",end:"\\s|,|;",excludeEnd:!0},hljs.HASH_COMMENT_MODE]},hljs.HASH_COMMENT_MODE]}}),hljs.registerLanguage("rsl",function(hljs){return{keywords:{keyword:"float color point normal vector matrix while for if do return else break extern continue",built_in:"abs acos ambient area asin atan atmosphere attribute calculatenormal ceil cellnoise clamp comp concat cos degrees depth Deriv diffuse distance Du Dv environment exp faceforward filterstep floor format fresnel incident length lightsource log match max min mod noise normalize ntransform opposite option phong pnoise pow printf ptlined radians random reflect refract renderinfo round setcomp setxcomp setycomp setzcomp shadow sign sin smoothstep specular specularbrdf spline sqrt step tan texture textureinfo trace transform vtransform xcomp ycomp zcomp"
},illegal:"</",contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,hljs.QUOTE_STRING_MODE,hljs.APOS_STRING_MODE,hljs.C_NUMBER_MODE,{className:"preprocessor",begin:"#",end:"$"},{className:"shader",beginKeywords:"surface displacement light volume imager",end:"\\("},{className:"shading",beginKeywords:"illuminate illuminance gather",end:"\\("}]}}),hljs.registerLanguage("ruleslanguage",function(hljs){return{keywords:{keyword:"BILL_PERIOD BILL_START BILL_STOP RS_EFFECTIVE_START RS_EFFECTIVE_STOP RS_JURIS_CODE RS_OPCO_CODE INTDADDATTRIBUTE|5 INTDADDVMSG|5 INTDBLOCKOP|5 INTDBLOCKOPNA|5 INTDCLOSE|5 INTDCOUNT|5 INTDCOUNTSTATUSCODE|5 INTDCREATEMASK|5 INTDCREATEDAYMASK|5 INTDCREATEFACTORMASK|5 INTDCREATEHANDLE|5 INTDCREATEOVERRIDEDAYMASK|5 INTDCREATEOVERRIDEMASK|5 INTDCREATESTATUSCODEMASK|5 INTDCREATETOUPERIOD|5 INTDDELETE|5 INTDDIPTEST|5 INTDEXPORT|5 INTDGETERRORCODE|5 INTDGETERRORMESSAGE|5 INTDISEQUAL|5 INTDJOIN|5 INTDLOAD|5 INTDLOADACTUALCUT|5 INTDLOADDATES|5 INTDLOADHIST|5 INTDLOADLIST|5 INTDLOADLISTDATES|5 INTDLOADLISTENERGY|5 INTDLOADLISTHIST|5 INTDLOADRELATEDCHANNEL|5 INTDLOADSP|5 INTDLOADSTAGING|5 INTDLOADUOM|5 INTDLOADUOMDATES|5 INTDLOADUOMHIST|5 INTDLOADVERSION|5 INTDOPEN|5 INTDREADFIRST|5 INTDREADNEXT|5 INTDRECCOUNT|5 INTDRELEASE|5 INTDREPLACE|5 INTDROLLAVG|5 INTDROLLPEAK|5 INTDSCALAROP|5 INTDSCALE|5 INTDSETATTRIBUTE|5 INTDSETDSTPARTICIPANT|5 INTDSETSTRING|5 INTDSETVALUE|5 INTDSETVALUESTATUS|5 INTDSHIFTSTARTTIME|5 INTDSMOOTH|5 INTDSORT|5 INTDSPIKETEST|5 INTDSUBSET|5 INTDTOU|5 INTDTOURELEASE|5 INTDTOUVALUE|5 INTDUPDATESTATS|5 INTDVALUE|5 STDEV INTDDELETEEX|5 INTDLOADEXACTUAL|5 INTDLOADEXCUT|5 INTDLOADEXDATES|5 INTDLOADEX|5 INTDLOADEXRELATEDCHANNEL|5 INTDSAVEEX|5 MVLOAD|5 MVLOADACCT|5 MVLOADACCTDATES|5 MVLOADACCTHIST|5 MVLOADDATES|5 MVLOADHIST|5 MVLOADLIST|5 MVLOADLISTDATES|5 MVLOADLISTHIST|5 IF FOR NEXT DONE SELECT END CALL ABORT CLEAR CHANNEL FACTOR LIST NUMBER OVERRIDE SET WEEK DISTRIBUTIONNODE ELSE WHEN THEN OTHERWISE IENUM CSV INCLUDE LEAVE RIDER SAVE DELETE NOVALUE SECTION WARN SAVE_UPDATE DETERMINANT LABEL REPORT REVENUE EACH IN FROM TOTAL CHARGE BLOCK AND OR CSV_FILE RATE_CODE AUXILIARY_DEMAND UIDACCOUNT RS BILL_PERIOD_SELECT HOURS_PER_MONTH INTD_ERROR_STOP SEASON_SCHEDULE_NAME ACCOUNTFACTOR ARRAYUPPERBOUND CALLSTOREDPROC GETADOCONNECTION GETCONNECT GETDATASOURCE GETQUALIFIER GETUSERID HASVALUE LISTCOUNT LISTOP LISTUPDATE LISTVALUE PRORATEFACTOR RSPRORATE SETBINPATH SETDBMONITOR WQ_OPEN BILLINGHOURS DATE DATEFROMFLOAT DATETIMEFROMSTRING DATETIMETOSTRING DATETOFLOAT DAY DAYDIFF DAYNAME DBDATETIME HOUR MINUTE MONTH MONTHDIFF MONTHHOURS MONTHNAME ROUNDDATE SAMEWEEKDAYLASTYEAR SECOND WEEKDAY WEEKDIFF YEAR YEARDAY YEARSTR COMPSUM HISTCOUNT HISTMAX HISTMIN HISTMINNZ HISTVALUE MAXNRANGE MAXRANGE MINRANGE COMPIKVA COMPKVA COMPKVARFROMKQKW COMPLF IDATTR FLAG LF2KW LF2KWH MAXKW POWERFACTOR READING2USAGE AVGSEASON MAXSEASON MONTHLYMERGE SEASONVALUE SUMSEASON ACCTREADDATES ACCTTABLELOAD CONFIGADD CONFIGGET CREATEOBJECT CREATEREPORT EMAILCLIENT EXPBLKMDMUSAGE EXPMDMUSAGE EXPORT_USAGE FACTORINEFFECT GETUSERSPECIFIEDSTOP INEFFECT ISHOLIDAY RUNRATE SAVE_PROFILE SETREPORTTITLE USEREXIT WATFORRUNRATE TO TABLE ACOS ASIN ATAN ATAN2 BITAND CEIL COS COSECANT COSH COTANGENT DIVQUOT DIVREM EXP FABS FLOOR FMOD FREPM FREXPN LOG LOG10 MAX MAXN MIN MINNZ MODF POW ROUND ROUND2VALUE ROUNDINT SECANT SIN SINH SQROOT TAN TANH FLOAT2STRING FLOAT2STRINGNC INSTR LEFT LEN LTRIM MID RIGHT RTRIM STRING STRINGNC TOLOWER TOUPPER TRIM NUMDAYS READ_DATE STAGING",built_in:"IDENTIFIER OPTIONS XML_ELEMENT XML_OP XML_ELEMENT_OF DOMDOCCREATE DOMDOCLOADFILE DOMDOCLOADXML DOMDOCSAVEFILE DOMDOCGETROOT DOMDOCADDPI DOMNODEGETNAME DOMNODEGETTYPE DOMNODEGETVALUE DOMNODEGETCHILDCT DOMNODEGETFIRSTCHILD DOMNODEGETSIBLING DOMNODECREATECHILDELEMENT DOMNODESETATTRIBUTE DOMNODEGETCHILDELEMENTCT DOMNODEGETFIRSTCHILDELEMENT DOMNODEGETSIBLINGELEMENT DOMNODEGETATTRIBUTECT DOMNODEGETATTRIBUTEI DOMNODEGETATTRIBUTEBYNAME DOMNODEGETBYNAME"},contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.C_NUMBER_MODE,{className:"array",variants:[{begin:"#\\s+[a-zA-Z\\ \\.]*",relevance:0},{begin:"#[a-zA-Z\\ \\.]+"}]}]}}),hljs.registerLanguage("rust",function(hljs){var NUM_SUFFIX="([uif](8|16|32|64|size))?",BLOCK_COMMENT=hljs.inherit(hljs.C_BLOCK_COMMENT_MODE);return BLOCK_COMMENT.contains.push("self"),{aliases:["rs"],keywords:{keyword:"alignof as be box break const continue crate do else enum extern false fn for if impl in let loop match mod mut offsetof once priv proc pub pure ref return self Self sizeof static struct super trait true type typeof unsafe unsized use virtual while where yield int i8 i16 i32 i64 uint u8 u32 u64 float f32 f64 str char bool",built_in:"Copy Send Sized Sync Drop Fn FnMut FnOnce drop Box ToOwned Clone PartialEq PartialOrd Eq Ord AsRef AsMut Into From Default Iterator Extend IntoIterator DoubleEndedIterator ExactSizeIterator Option Some None Result Ok Err SliceConcatExt String ToString Vec assert! assert_eq! bitflags! bytes! cfg! col! concat! concat_idents! debug_assert! debug_assert_eq! env! panic! file! format! format_args! include_bin! include_str! line! local_data_key! module_path! option_env! print! println! select! stringify! try! unimplemented! unreachable! vec! write! writeln!"},lexemes:hljs.IDENT_RE+"!?",illegal:"</",contains:[hljs.C_LINE_COMMENT_MODE,BLOCK_COMMENT,hljs.inherit(hljs.QUOTE_STRING_MODE,{illegal:null}),{className:"string",variants:[{begin:/r(#*)".*?"\1(?!#)/},{begin:/'\\?(x\w{2}|u\w{4}|U\w{8}|.)'/},{begin:/'[a-zA-Z_][a-zA-Z0-9_]*/}]},{className:"number",variants:[{begin:"\\b0b([01_]+)"+NUM_SUFFIX},{begin:"\\b0o([0-7_]+)"+NUM_SUFFIX},{begin:"\\b0x([A-Fa-f0-9_]+)"+NUM_SUFFIX},{begin:"\\b(\\d[\\d_]*(\\.[0-9_]+)?([eE][+-]?[0-9_]+)?)"+NUM_SUFFIX}],relevance:0},{className:"function",beginKeywords:"fn",end:"(\\(|<)",excludeEnd:!0,contains:[hljs.UNDERSCORE_TITLE_MODE]},{className:"preprocessor",begin:"#\\!?\\[",end:"\\]"},{beginKeywords:"type",end:"(=|<)",contains:[hljs.UNDERSCORE_TITLE_MODE],illegal:"\\S"},{beginKeywords:"trait enum",end:"{",contains:[hljs.inherit(hljs.UNDERSCORE_TITLE_MODE,{endsParent:!0})],illegal:"[\\w\\d]"},{begin:hljs.IDENT_RE+"::"},{begin:"->"}]}}),hljs.registerLanguage("scala",function(hljs){var ANNOTATION={className:"annotation",begin:"@[A-Za-z]+"},STRING={className:"string",begin:'u?r?"""',end:'"""',relevance:10},SYMBOL={className:"symbol",begin:"'\\w[\\w\\d_]*(?!')"},TYPE={className:"type",begin:"\\b[A-Z][A-Za-z0-9_]*",relevance:0},NAME={className:"title",begin:/[^0-9\n\t "'(),.`{}\[\]:;][^\n\t "'(),.`{}\[\]:;]+|[^0-9\n\t "'(),.`{}\[\]:;=]/,relevance:0},CLASS={className:"class",beginKeywords:"class object trait type",end:/[:={\[(\n;]/,contains:[{className:"keyword",beginKeywords:"extends with",relevance:10},NAME]},METHOD={className:"function",beginKeywords:"def",end:/[:={\[(\n;]/,contains:[NAME]};return{keywords:{literal:"true false null",keyword:"type yield lazy override def with val var sealed abstract private trait object if forSome for while throw finally protected extends import final return else break new catch super class case package default try this match continue throws implicit"},contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,STRING,hljs.QUOTE_STRING_MODE,SYMBOL,TYPE,METHOD,CLASS,hljs.C_NUMBER_MODE,ANNOTATION]}}),hljs.registerLanguage("scheme",function(hljs){var SCHEME_IDENT_RE="[^\\(\\)\\[\\]\\{\\}\",'`;#|\\\\\\s]+",SCHEME_SIMPLE_NUMBER_RE="(\\-|\\+)?\\d+([./]\\d+)?",SCHEME_COMPLEX_NUMBER_RE=SCHEME_SIMPLE_NUMBER_RE+"[+\\-]"+SCHEME_SIMPLE_NUMBER_RE+"i",BUILTINS={built_in:"case-lambda call/cc class define-class exit-handler field import inherit init-field interface let*-values let-values let/ec mixin opt-lambda override protect provide public rename require require-for-syntax syntax syntax-case syntax-error unit/sig unless when with-syntax and begin call-with-current-continuation call-with-input-file call-with-output-file case cond define define-syntax delay do dynamic-wind else for-each if lambda let let* let-syntax letrec letrec-syntax map or syntax-rules ' * + , ,@ - ... / ; < <= = => > >= ` abs acos angle append apply asin assoc assq assv atan boolean? caar cadr call-with-input-file call-with-output-file call-with-values car cdddar cddddr cdr ceiling char->integer char-alphabetic? char-ci<=? char-ci<? char-ci=? char-ci>=? char-ci>? char-downcase char-lower-case? char-numeric? char-ready? char-upcase char-upper-case? char-whitespace? char<=? char<? char=? char>=? char>? char? close-input-port close-output-port complex? cons cos current-input-port current-output-port denominator display eof-object? eq? equal? eqv? eval even? exact->inexact exact? exp expt floor force gcd imag-part inexact->exact inexact? input-port? integer->char integer? interaction-environment lcm length list list->string list->vector list-ref list-tail list? load log magnitude make-polar make-rectangular make-string make-vector max member memq memv min modulo negative? newline not null-environment null? number->string number? numerator odd? open-input-file open-output-file output-port? pair? peek-char port? positive? procedure? quasiquote quote quotient rational? rationalize read read-char real-part real? remainder reverse round scheme-report-environment set! set-car! set-cdr! sin sqrt string string->list string->number string->symbol string-append string-ci<=? string-ci<? string-ci=? string-ci>=? string-ci>? string-copy string-fill! string-length string-ref string-set! string<=? string<? string=? string>=? string>? string? substring symbol->string symbol? tan transcript-off transcript-on truncate values vector vector->list vector-fill! vector-length vector-ref vector-set! with-input-from-file with-output-to-file write write-char zero?"},SHEBANG={className:"shebang",begin:"^#!",end:"$"},LITERAL={className:"literal",begin:"(#t|#f|#\\\\"+SCHEME_IDENT_RE+"|#\\\\.)"},NUMBER={className:"number",variants:[{begin:SCHEME_SIMPLE_NUMBER_RE,relevance:0},{begin:SCHEME_COMPLEX_NUMBER_RE,relevance:0},{begin:"#b[0-1]+(/[0-1]+)?"},{begin:"#o[0-7]+(/[0-7]+)?"},{begin:"#x[0-9a-f]+(/[0-9a-f]+)?"}]},STRING=hljs.QUOTE_STRING_MODE,COMMENT_MODES=[hljs.COMMENT(";","$",{relevance:0}),hljs.COMMENT("#\\|","\\|#")],IDENT={begin:SCHEME_IDENT_RE,relevance:0},QUOTED_IDENT={className:"variable",begin:"'"+SCHEME_IDENT_RE},BODY={endsWithParent:!0,relevance:0},LIST={className:"list",variants:[{begin:"\\(",end:"\\)"},{begin:"\\[",end:"\\]"}],contains:[{className:"keyword",begin:SCHEME_IDENT_RE,lexemes:SCHEME_IDENT_RE,keywords:BUILTINS},BODY]};return BODY.contains=[LITERAL,NUMBER,STRING,IDENT,QUOTED_IDENT,LIST].concat(COMMENT_MODES),{illegal:/\S/,contains:[SHEBANG,NUMBER,STRING,QUOTED_IDENT,LIST].concat(COMMENT_MODES)}}),hljs.registerLanguage("scilab",function(hljs){var COMMON_CONTAINS=[hljs.C_NUMBER_MODE,{className:"string",begin:"'|\"",end:"'|\"",contains:[hljs.BACKSLASH_ESCAPE,{begin:"''"}]}];return{aliases:["sci"],keywords:{keyword:"abort break case clear catch continue do elseif else endfunction end for functionglobal if pause return resume select try then while%f %F %t %T %pi %eps %inf %nan %e %i %z %s",built_in:"abs and acos asin atan ceil cd chdir clearglobal cosh cos cumprod deff disp errorexec execstr exists exp eye gettext floor fprintf fread fsolve imag isdef isemptyisinfisnan isvector lasterror length load linspace list listfiles log10 log2 logmax min msprintf mclose mopen ones or pathconvert poly printf prod pwd rand realround sinh sin size gsort sprintf sqrt strcat strcmps tring sum system tanh tantype typename warning zeros matrix"},illegal:'("|#|/\\*|\\s+/\\w+)',contains:[{className:"function",beginKeywords:"function endfunction",end:"$",keywords:"function endfunction|10",contains:[hljs.UNDERSCORE_TITLE_MODE,{className:"params",begin:"\\(",end:"\\)"}]},{className:"transposed_variable",begin:"[a-zA-Z_][a-zA-Z_0-9]*('+[\\.']*|[\\.']+)",end:"",relevance:0},{className:"matrix",begin:"\\[",end:"\\]'*[\\.']*",relevance:0,contains:COMMON_CONTAINS},hljs.COMMENT("//","$")].concat(COMMON_CONTAINS)}}),hljs.registerLanguage("scss",function(hljs){var IDENT_RE="[a-zA-Z-][a-zA-Z0-9_-]*",VARIABLE={className:"variable",begin:"(\\$"+IDENT_RE+")\\b"},FUNCTION={className:"function",begin:IDENT_RE+"\\(",returnBegin:!0,excludeEnd:!0,end:"\\("},HEXCOLOR={className:"hexcolor",begin:"#[0-9A-Fa-f]+"};({className:"attribute",begin:"[A-Z\\_\\.\\-]+",end:":",excludeEnd:!0,illegal:"[^\\s]",starts:{className:"value",endsWithParent:!0,excludeEnd:!0,contains:[FUNCTION,HEXCOLOR,hljs.CSS_NUMBER_MODE,hljs.QUOTE_STRING_MODE,hljs.APOS_STRING_MODE,hljs.C_BLOCK_COMMENT_MODE,{className:"important",begin:"!important"}]}});return{case_insensitive:!0,illegal:"[=/|']",contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,FUNCTION,{className:"id",begin:"\\#[A-Za-z0-9_-]+",relevance:0},{className:"class",begin:"\\.[A-Za-z0-9_-]+",relevance:0},{className:"attr_selector",begin:"\\[",end:"\\]",illegal:"$"},{className:"tag",begin:"\\b(a|abbr|acronym|address|area|article|aside|audio|b|base|big|blockquote|body|br|button|canvas|caption|cite|code|col|colgroup|command|datalist|dd|del|details|dfn|div|dl|dt|em|embed|fieldset|figcaption|figure|footer|form|frame|frameset|(h[1-6])|head|header|hgroup|hr|html|i|iframe|img|input|ins|kbd|keygen|label|legend|li|link|map|mark|meta|meter|nav|noframes|noscript|object|ol|optgroup|option|output|p|param|pre|progress|q|rp|rt|ruby|samp|script|section|select|small|span|strike|strong|style|sub|sup|table|tbody|td|textarea|tfoot|th|thead|time|title|tr|tt|ul|var|video)\\b",relevance:0},{className:"pseudo",begin:":(visited|valid|root|right|required|read-write|read-only|out-range|optional|only-of-type|only-child|nth-of-type|nth-last-of-type|nth-last-child|nth-child|not|link|left|last-of-type|last-child|lang|invalid|indeterminate|in-range|hover|focus|first-of-type|first-line|first-letter|first-child|first|enabled|empty|disabled|default|checked|before|after|active)"},{className:"pseudo",begin:"::(after|before|choices|first-letter|first-line|repeat-index|repeat-item|selection|value)"},VARIABLE,{className:"attribute",begin:"\\b(z-index|word-wrap|word-spacing|word-break|width|widows|white-space|visibility|vertical-align|unicode-bidi|transition-timing-function|transition-property|transition-duration|transition-delay|transition|transform-style|transform-origin|transform|top|text-underline-position|text-transform|text-shadow|text-rendering|text-overflow|text-indent|text-decoration-style|text-decoration-line|text-decoration-color|text-decoration|text-align-last|text-align|tab-size|table-layout|right|resize|quotes|position|pointer-events|perspective-origin|perspective|page-break-inside|page-break-before|page-break-after|padding-top|padding-right|padding-left|padding-bottom|padding|overflow-y|overflow-x|overflow-wrap|overflow|outline-width|outline-style|outline-offset|outline-color|outline|orphans|order|opacity|object-position|object-fit|normal|none|nav-up|nav-right|nav-left|nav-index|nav-down|min-width|min-height|max-width|max-height|mask|marks|margin-top|margin-right|margin-left|margin-bottom|margin|list-style-type|list-style-position|list-style-image|list-style|line-height|letter-spacing|left|justify-content|initial|inherit|ime-mode|image-orientation|image-resolution|image-rendering|icon|hyphens|height|font-weight|font-variant-ligatures|font-variant|font-style|font-stretch|font-size-adjust|font-size|font-language-override|font-kerning|font-feature-settings|font-family|font|float|flex-wrap|flex-shrink|flex-grow|flex-flow|flex-direction|flex-basis|flex|filter|empty-cells|display|direction|cursor|counter-reset|counter-increment|content|column-width|column-span|column-rule-width|column-rule-style|column-rule-color|column-rule|column-gap|column-fill|column-count|columns|color|clip-path|clip|clear|caption-side|break-inside|break-before|break-after|box-sizing|box-shadow|box-decoration-break|bottom|border-width|border-top-width|border-top-style|border-top-right-radius|border-top-left-radius|border-top-color|border-top|border-style|border-spacing|border-right-width|border-right-style|border-right-color|border-right|border-radius|border-left-width|border-left-style|border-left-color|border-left|border-image-width|border-image-source|border-image-slice|border-image-repeat|border-image-outset|border-image|border-color|border-collapse|border-bottom-width|border-bottom-style|border-bottom-right-radius|border-bottom-left-radius|border-bottom-color|border-bottom|border|background-size|background-repeat|background-position|background-origin|background-image|background-color|background-clip|background-attachment|background-blend-mode|background|backface-visibility|auto|animation-timing-function|animation-play-state|animation-name|animation-iteration-count|animation-fill-mode|animation-duration|animation-direction|animation-delay|animation|align-self|align-items|align-content)\\b",illegal:"[^\\s]"},{className:"value",begin:"\\b(whitespace|wait|w-resize|visible|vertical-text|vertical-ideographic|uppercase|upper-roman|upper-alpha|underline|transparent|top|thin|thick|text|text-top|text-bottom|tb-rl|table-header-group|table-footer-group|sw-resize|super|strict|static|square|solid|small-caps|separate|se-resize|scroll|s-resize|rtl|row-resize|ridge|right|repeat|repeat-y|repeat-x|relative|progress|pointer|overline|outside|outset|oblique|nowrap|not-allowed|normal|none|nw-resize|no-repeat|no-drop|newspaper|ne-resize|n-resize|move|middle|medium|ltr|lr-tb|lowercase|lower-roman|lower-alpha|loose|list-item|line|line-through|line-edge|lighter|left|keep-all|justify|italic|inter-word|inter-ideograph|inside|inset|inline|inline-block|inherit|inactive|ideograph-space|ideograph-parenthesis|ideograph-numeric|ideograph-alpha|horizontal|hidden|help|hand|groove|fixed|ellipsis|e-resize|double|dotted|distribute|distribute-space|distribute-letter|distribute-all-lines|disc|disabled|default|decimal|dashed|crosshair|collapse|col-resize|circle|char|center|capitalize|break-word|break-all|bottom|both|bolder|bold|block|bidi-override|below|baseline|auto|always|all-scroll|absolute|table|table-cell)\\b"},{className:"value",begin:":",end:";",contains:[FUNCTION,VARIABLE,HEXCOLOR,hljs.CSS_NUMBER_MODE,hljs.QUOTE_STRING_MODE,hljs.APOS_STRING_MODE,{className:"important",begin:"!important"}]},{className:"at_rule",begin:"@",end:"[{;]",keywords:"mixin include extend for if else each while charset import debug media page content font-face namespace warn",contains:[FUNCTION,VARIABLE,hljs.QUOTE_STRING_MODE,hljs.APOS_STRING_MODE,HEXCOLOR,hljs.CSS_NUMBER_MODE,{className:"preprocessor",begin:"\\s[A-Za-z0-9_.-]+",relevance:0}]}]}}),hljs.registerLanguage("smali",function(hljs){var smali_instr_low_prio=["add","and","cmp","cmpg","cmpl","const","div","double","float","goto","if","int","long","move","mul","neg","new","nop","not","or","rem","return","shl","shr","sput","sub","throw","ushr","xor"],smali_instr_high_prio=["aget","aput","array","check","execute","fill","filled","goto/16","goto/32","iget","instance","invoke","iput","monitor","packed","sget","sparse"],smali_keywords=["transient","constructor","abstract","final","synthetic","public","private","protected","static","bridge","system"];return{aliases:["smali"],contains:[{className:"string",begin:'"',end:'"',relevance:0},hljs.COMMENT("#","$",{relevance:0}),{className:"keyword",begin:"\\s*\\.end\\s[a-zA-Z0-9]*",relevance:1},{className:"keyword",begin:"^[ ]*\\.[a-zA-Z]*",relevance:0},{className:"keyword",begin:"\\s:[a-zA-Z_0-9]*",relevance:0},{className:"keyword",begin:"\\s("+smali_keywords.join("|")+")",relevance:1},{className:"keyword",begin:"\\[",relevance:0},{className:"instruction",begin:"\\s("+smali_instr_low_prio.join("|")+")\\s",relevance:1},{className:"instruction",begin:"\\s("+smali_instr_low_prio.join("|")+")((\\-|/)[a-zA-Z0-9]+)+\\s",relevance:10},{className:"instruction",begin:"\\s("+smali_instr_high_prio.join("|")+")((\\-|/)[a-zA-Z0-9]+)*\\s",relevance:10},{className:"class",begin:"L[^(;:\n]*;",relevance:0},{className:"function",begin:'( |->)[^(\n ;"]*\\(',relevance:0},{className:"function",begin:"\\)",relevance:0},{className:"variable",begin:"[vp][0-9]+",relevance:0}]}}),hljs.registerLanguage("smalltalk",function(hljs){var VAR_IDENT_RE="[a-z][a-zA-Z0-9_]*",CHAR={className:"char",begin:"\\$.{1}"},SYMBOL={className:"symbol",begin:"#"+hljs.UNDERSCORE_IDENT_RE};return{aliases:["st"],keywords:"self super nil true false thisContext",contains:[hljs.COMMENT('"','"'),hljs.APOS_STRING_MODE,{className:"class",begin:"\\b[A-Z][A-Za-z0-9_]*",relevance:0},{className:"method",begin:VAR_IDENT_RE+":",relevance:0},hljs.C_NUMBER_MODE,SYMBOL,CHAR,{className:"localvars",begin:"\\|[ ]*"+VAR_IDENT_RE+"([ ]+"+VAR_IDENT_RE+")*[ ]*\\|",returnBegin:!0,end:/\|/,illegal:/\S/,contains:[{begin:"(\\|[ ]*)?"+VAR_IDENT_RE}]},{className:"array",begin:"\\#\\(",end:"\\)",contains:[hljs.APOS_STRING_MODE,CHAR,hljs.C_NUMBER_MODE,SYMBOL]}]}}),hljs.registerLanguage("sml",function(hljs){return{aliases:["ml"],keywords:{keyword:"abstype and andalso as case datatype do else end eqtype exception fn fun functor handle if in include infix infixr let local nonfix of op open orelse raise rec sharing sig signature struct structure then type val with withtype where while",built_in:"array bool char exn int list option order real ref string substring vector unit word",literal:"true false NONE SOME LESS EQUAL GREATER nil"},illegal:/\/\/|>>/,lexemes:"[a-z_]\\w*!?",contains:[{className:"literal",begin:"\\[(\\|\\|)?\\]|\\(\\)"},hljs.COMMENT("\\(\\*","\\*\\)",{contains:["self"]}),{className:"symbol",begin:"'[A-Za-z_](?!')[\\w']*"},{className:"tag",begin:"`[A-Z][\\w']*"},{className:"type",begin:"\\b[A-Z][\\w']*",relevance:0},{begin:"[a-z_]\\w*'[\\w']*"},hljs.inherit(hljs.APOS_STRING_MODE,{className:"char",relevance:0}),hljs.inherit(hljs.QUOTE_STRING_MODE,{illegal:null}),{className:"number",begin:"\\b(0[xX][a-fA-F0-9_]+[Lln]?|0[oO][0-7_]+[Lln]?|0[bB][01_]+[Lln]?|[0-9][0-9_]*([Lln]|(\\.[0-9_]*)?([eE][-+]?[0-9_]+)?)?)",relevance:0},{begin:/[-=]>/}]}}),hljs.registerLanguage("sqf",function(hljs){var allCommands=["!","-","+","!=","%","&&","*","/","=","==",">",">=","<","<=","or","plus","^",":",">>","abs","accTime","acos","action","actionKeys","actionKeysImages","actionKeysNames","actionKeysNamesArray","actionName","activateAddons","activatedAddons","activateKey","addAction","addBackpack","addBackpackCargo","addBackpackCargoGlobal","addBackpackGlobal","addCamShake","addCuratorAddons","addCuratorCameraArea","addCuratorEditableObjects","addCuratorEditingArea","addCuratorPoints","addEditorObject","addEventHandler","addGoggles","addGroupIcon","addHandgunItem","addHeadgear","addItem","addItemCargo","addItemCargoGlobal","addItemPool","addItemToBackpack","addItemToUniform","addItemToVest","addLiveStats","addMagazine","addMagazine array","addMagazineAmmoCargo","addMagazineCargo","addMagazineCargoGlobal","addMagazineGlobal","addMagazinePool","addMagazines","addMagazineTurret","addMenu","addMenuItem","addMissionEventHandler","addMPEventHandler","addMusicEventHandler","addPrimaryWeaponItem","addPublicVariableEventHandler","addRating","addResources","addScore","addScoreSide","addSecondaryWeaponItem","addSwitchableUnit","addTeamMember","addToRemainsCollector","addUniform","addVehicle","addVest","addWaypoint","addWeapon","addWeaponCargo","addWeaponCargoGlobal","addWeaponGlobal","addWeaponPool","addWeaponTurret","agent","agents","AGLToASL","aimedAtTarget","aimPos","airDensityRTD","airportSide","AISFinishHeal","alive","allControls","allCurators","allDead","allDeadMen","allDisplays","allGroups","allMapMarkers","allMines","allMissionObjects","allow3DMode","allowCrewInImmobile","allowCuratorLogicIgnoreAreas","allowDamage","allowDammage","allowFileOperations","allowFleeing","allowGetIn","allPlayers","allSites","allTurrets","allUnits","allUnitsUAV","allVariables","ammo","and","animate","animateDoor","animationPhase","animationState","append","armoryPoints","arrayIntersect","asin","ASLToAGL","ASLToATL","assert","assignAsCargo","assignAsCargoIndex","assignAsCommander","assignAsDriver","assignAsGunner","assignAsTurret","assignCurator","assignedCargo","assignedCommander","assignedDriver","assignedGunner","assignedItems","assignedTarget","assignedTeam","assignedVehicle","assignedVehicleRole","assignItem","assignTeam","assignToAirport","atan","atan2","atg","ATLToASL","attachedObject","attachedObjects","attachedTo","attachObject","attachTo","attackEnabled","backpack","backpackCargo","backpackContainer","backpackItems","backpackMagazines","backpackSpaceFor","behaviour","benchmark","binocular","blufor","boundingBox","boundingBoxReal","boundingCenter","breakOut","breakTo","briefingName","buildingExit","buildingPos","buttonAction","buttonSetAction","cadetMode","call","callExtension","camCommand","camCommit","camCommitPrepared","camCommitted","camConstuctionSetParams","camCreate","camDestroy","cameraEffect","cameraEffectEnableHUD","cameraInterest","cameraOn","cameraView","campaignConfigFile","camPreload","camPreloaded","camPrepareBank","camPrepareDir","camPrepareDive","camPrepareFocus","camPrepareFov","camPrepareFovRange","camPreparePos","camPrepareRelPos","camPrepareTarget","camSetBank","camSetDir","camSetDive","camSetFocus","camSetFov","camSetFovRange","camSetPos","camSetRelPos","camSetTarget","camTarget","camUseNVG","canAdd","canAddItemToBackpack","canAddItemToUniform","canAddItemToVest","cancelSimpleTaskDestination","canFire","canMove","canSlingLoad","canStand","canUnloadInCombat","captive","captiveNum","case","catch","cbChecked","cbSetChecked","ceil","cheatsEnabled","checkAIFeature","civilian","className","clearAllItemsFromBackpack","clearBackpackCargo","clearBackpackCargoGlobal","clearGroupIcons","clearItemCargo","clearItemCargoGlobal","clearItemPool","clearMagazineCargo","clearMagazineCargoGlobal","clearMagazinePool","clearOverlay","clearRadio","clearWeaponCargo","clearWeaponCargoGlobal","clearWeaponPool","closeDialog","closeDisplay","closeOverlay","collapseObjectTree","combatMode","commandArtilleryFire","commandChat","commander","commandFire","commandFollow","commandFSM","commandGetOut","commandingMenu","commandMove","commandRadio","commandStop","commandTarget","commandWatch","comment","commitOverlay","compile","compileFinal","completedFSM","composeText","configClasses","configFile","configHierarchy","configName","configProperties","configSourceMod","configSourceModList","connectTerminalToUAV","controlNull","controlsGroupCtrl","copyFromClipboard","copyToClipboard","copyWaypoints","cos","count","countEnemy","countFriendly","countSide","countType","countUnknown","createAgent","createCenter","createDialog","createDiaryLink","createDiaryRecord","createDiarySubject","createDisplay","createGearDialog","createGroup","createGuardedPoint","createLocation","createMarker","createMarkerLocal","createMenu","createMine","createMissionDisplay","createSimpleTask","createSite","createSoundSource","createTask","createTeam","createTrigger","createUnit","createUnit array","createVehicle","createVehicle array","createVehicleCrew","createVehicleLocal","crew","ctrlActivate","ctrlAddEventHandler","ctrlAutoScrollDelay","ctrlAutoScrollRewind","ctrlAutoScrollSpeed","ctrlChecked","ctrlClassName","ctrlCommit","ctrlCommitted","ctrlCreate","ctrlDelete","ctrlEnable","ctrlEnabled","ctrlFade","ctrlHTMLLoaded","ctrlIDC","ctrlIDD","ctrlMapAnimAdd","ctrlMapAnimClear","ctrlMapAnimCommit","ctrlMapAnimDone","ctrlMapCursor","ctrlMapMouseOver","ctrlMapScale","ctrlMapScreenToWorld","ctrlMapWorldToScreen","ctrlModel","ctrlModelDirAndUp","ctrlModelScale","ctrlParent","ctrlPosition","ctrlRemoveAllEventHandlers","ctrlRemoveEventHandler","ctrlScale","ctrlSetActiveColor","ctrlSetAutoScrollDelay","ctrlSetAutoScrollRewind","ctrlSetAutoScrollSpeed","ctrlSetBackgroundColor","ctrlSetChecked","ctrlSetEventHandler","ctrlSetFade","ctrlSetFocus","ctrlSetFont","ctrlSetFontH1","ctrlSetFontH1B","ctrlSetFontH2","ctrlSetFontH2B","ctrlSetFontH3","ctrlSetFontH3B","ctrlSetFontH4","ctrlSetFontH4B","ctrlSetFontH5","ctrlSetFontH5B","ctrlSetFontH6","ctrlSetFontH6B","ctrlSetFontHeight","ctrlSetFontHeightH1","ctrlSetFontHeightH2","ctrlSetFontHeightH3","ctrlSetFontHeightH4","ctrlSetFontHeightH5","ctrlSetFontHeightH6","ctrlSetFontP","ctrlSetFontPB","ctrlSetForegroundColor","ctrlSetModel","ctrlSetModelDirAndUp","ctrlSetModelScale","ctrlSetPosition","ctrlSetScale","ctrlSetStructuredText","ctrlSetText","ctrlSetTextColor","ctrlSetTooltip","ctrlSetTooltipColorBox","ctrlSetTooltipColorShade","ctrlSetTooltipColorText","ctrlShow","ctrlShown","ctrlText","ctrlTextHeight","ctrlType","ctrlVisible","curatorAddons","curatorCamera","curatorCameraArea","curatorCameraAreaCeiling","curatorCoef","curatorEditableObjects","curatorEditingArea","curatorEditingAreaType","curatorMouseOver","curatorPoints","curatorRegisteredObjects","curatorSelected","curatorWaypointCost","currentChannel","currentCommand","currentMagazine","currentMagazineDetail","currentMagazineDetailTurret","currentMagazineTurret","currentMuzzle","currentNamespace","currentTask","currentTasks","currentThrowable","currentVisionMode","currentWaypoint","currentWeapon","currentWeaponMode","currentWeaponTurret","currentZeroing","cursorTarget","customChat","customRadio","cutFadeOut","cutObj","cutRsc","cutText","damage","date","dateToNumber","daytime","deActivateKey","debriefingText","debugFSM","debugLog","default","deg","deleteAt","deleteCenter","deleteCollection","deleteEditorObject","deleteGroup","deleteIdentity","deleteLocation","deleteMarker","deleteMarkerLocal","deleteRange","deleteResources","deleteSite","deleteStatus","deleteTeam","deleteVehicle","deleteVehicleCrew","deleteWaypoint","detach","detectedMines","diag activeMissionFSMs","diag activeSQFScripts","diag activeSQSScripts","diag captureFrame","diag captureSlowFrame","diag fps","diag fpsMin","diag frameNo","diag log","diag logSlowFrame","diag tickTime","dialog","diarySubjectExists","didJIP","didJIPOwner","difficulty","difficultyEnabled","difficultyEnabledRTD","direction","directSay","disableAI","disableCollisionWith","disableConversation","disableDebriefingStats","disableSerialization","disableTIEquipment","disableUAVConnectability","disableUserInput","displayAddEventHandler","displayCtrl","displayNull","displayRemoveAllEventHandlers","displayRemoveEventHandler","displaySetEventHandler","dissolveTeam","distance","distance2D","distanceSqr","distributionRegion","do","doArtilleryFire","doFire","doFollow","doFSM","doGetOut","doMove","doorPhase","doStop","doTarget","doWatch","drawArrow","drawEllipse","drawIcon","drawIcon3D","drawLine","drawLine3D","drawLink","drawLocation","drawRectangle","driver","drop","east","echo","editObject","editorSetEventHandler","effectiveCommander","else","emptyPositions","enableAI","enableAIFeature","enableAttack","enableCamShake","enableCaustics","enableCollisionWith","enableCopilot","enableDebriefingStats","enableDiagLegend","enableEndDialog","enableEngineArtillery","enableEnvironment","enableFatigue","enableGunLights","enableIRLasers","enableMimics","enablePersonTurret","enableRadio","enableReload","enableRopeAttach","enableSatNormalOnDetail","enableSaving","enableSentences","enableSimulation","enableSimulationGlobal","enableTeamSwitch","enableUAVConnectability","enableUAVWaypoints","endLoadingScreen","endMission","engineOn","enginesIsOnRTD","enginesRpmRTD","enginesTorqueRTD","entities","estimatedEndServerTime","estimatedTimeLeft","evalObjectArgument","everyBackpack","everyContainer","exec","execEditorScript","execFSM","execVM","exit","exitWith","exp","expectedDestination","eyeDirection","eyePos","face","faction","fadeMusic","fadeRadio","fadeSound","fadeSpeech","failMission","false","fillWeaponsFromPool","find","findCover","findDisplay","findEditorObject","findEmptyPosition","findEmptyPositionReady","findNearestEnemy","finishMissionInit","finite","fire","fireAtTarget","firstBackpack","flag","flagOwner","fleeing","floor","flyInHeight","fog","fogForecast","fogParams","for","forceAddUniform","forceEnd","forceMap","forceRespawn","forceSpeed","forceWalk","forceWeaponFire","forceWeatherChange","forEach","forEachMember","forEachMemberAgent","forEachMemberTeam","format","formation","formationDirection","formationLeader","formationMembers","formationPosition","formationTask","formatText","formLeader","freeLook","from","fromEditor","fuel","fullCrew","gearSlotAmmoCount","gearSlotData","getAllHitPointsDamage","getAmmoCargo","getArray","getArtilleryAmmo","getArtilleryComputerSettings","getArtilleryETA","getAssignedCuratorLogic","getAssignedCuratorUnit","getBackpackCargo","getBleedingRemaining","getBurningValue","getCargoIndex","getCenterOfMass","getClientState","getConnectedUAV","getDammage","getDescription","getDir","getDirVisual","getDLCs","getEditorCamera","getEditorMode","getEditorObjectScope","getElevationOffset","getFatigue","getFriend","getFSMVariable","getFuelCargo","getGroupIcon","getGroupIconParams","getGroupIcons","getHideFrom","getHit","getHitIndex","getHitPointDamage","getItemCargo","getMagazineCargo","getMarkerColor","getMarkerPos","getMarkerSize","getMarkerType","getMass","getModelInfo","getNumber","getObjectArgument","getObjectChildren","getObjectDLC","getObjectMaterials","getObjectProxy","getObjectTextures","getObjectType","getObjectViewDistance","getOxygenRemaining","getPersonUsedDLCs","getPlayerChannel","getPlayerUID","getPos","getPosASL","getPosASLVisual","getPosASLW","getPosATL","getPosATLVisual","getPosVisual","getPosWorld","getRepairCargo","getResolution","getShadowDistance","getSlingLoad","getSpeed","getSuppression","getTerrainHeightASL","getText","getVariable","getWeaponCargo","getWPPos","glanceAt","globalChat","globalRadio","goggles","goto","group","groupChat","groupFromNetId","groupIconSelectable","groupIconsVisible","groupId","groupOwner","groupRadio","groupSelectedUnits","groupSelectUnit","grpNull","gunner","gusts","halt","handgunItems","handgunMagazine","handgunWeapon","handsHit","hasInterface","hasWeapon","hcAllGroups","hcGroupParams","hcLeader","hcRemoveAllGroups","hcRemoveGroup","hcSelected","hcSelectGroup","hcSetGroup","hcShowBar","hcShownBar","headgear","hideBody","hideObject","hideObjectGlobal","hint","hintC","hintCadet","hintSilent","hmd","hostMission","htmlLoad","HUDMovementLevels","humidity","if","image","importAllGroups","importance","in","incapacitatedState","independent","inflame","inflamed","inGameUISetEventHandler","inheritsFrom","initAmbientLife","inputAction","inRangeOfArtillery","insertEditorObject","intersect","isAbleToBreathe","isAgent","isArray","isAutoHoverOn","isAutonomous","isAutotest","isBleeding","isBurning","isClass","isCollisionLightOn","isCopilotEnabled","isDedicated","isDLCAvailable","isEngineOn","isEqualTo","isFlashlightOn","isFlatEmpty","isForcedWalk","isFormationLeader","isHidden","isInRemainsCollector","isInstructorFigureEnabled","isIRLaserOn","isKeyActive","isKindOf","isLightOn","isLocalized","isManualFire","isMarkedForCollection","isMultiplayer","isNil","isNull","isNumber","isObjectHidden","isObjectRTD","isOnRoad","isPipEnabled","isPlayer","isRealTime","isServer","isShowing3DIcons","isSteamMission","isStreamFriendlyUIEnabled","isText","isTouchingGround","isTurnedOut","isTutHintsEnabled","isUAVConnectable","isUAVConnected","isUniformAllowed","isWalking","isWeaponDeployed","isWeaponRested","itemCargo","items","itemsWithMagazines","join","joinAs","joinAsSilent","joinSilent","joinString","kbAddDatabase","kbAddDatabaseTargets","kbAddTopic","kbHasTopic","kbReact","kbRemoveTopic","kbTell","kbWasSaid","keyImage","keyName","knowsAbout","land","landAt","landResult","language","laserTarget","lbAdd","lbClear","lbColor","lbCurSel","lbData","lbDelete","lbIsSelected","lbPicture","lbSelection","lbSetColor","lbSetCurSel","lbSetData","lbSetPicture","lbSetPictureColor","lbSetPictureColorDisabled","lbSetPictureColorSelected","lbSetSelectColor","lbSetSelectColorRight","lbSetSelected","lbSetTooltip","lbSetValue","lbSize","lbSort","lbSortByValue","lbText","lbValue","leader","leaderboardDeInit","leaderboardGetRows","leaderboardInit","leaveVehicle","libraryCredits","libraryDisclaimers","lifeState","lightAttachObject","lightDetachObject","lightIsOn","lightnings","limitSpeed","linearConversion","lineBreak","lineIntersects","lineIntersectsObjs","lineIntersectsSurfaces","lineIntersectsWith","linkItem","list","listObjects","ln","lnbAddArray","lnbAddColumn","lnbAddRow","lnbClear","lnbColor","lnbCurSelRow","lnbData","lnbDeleteColumn","lnbDeleteRow","lnbGetColumnsPosition","lnbPicture","lnbSetColor","lnbSetColumnsPos","lnbSetCurSelRow","lnbSetData","lnbSetPicture","lnbSetText","lnbSetValue","lnbSize","lnbText","lnbValue","load","loadAbs","loadBackpack","loadFile","loadGame","loadIdentity","loadMagazine","loadOverlay","loadStatus","loadUniform","loadVest","local","localize","locationNull","locationPosition","lock","lockCameraTo","lockCargo","lockDriver","locked","lockedCargo","lockedDriver","lockedTurret","lockTurret","lockWP","log","logEntities","lookAt","lookAtPos","magazineCargo","magazines","magazinesAllTurrets","magazinesAmmo","magazinesAmmoCargo","magazinesAmmoFull","magazinesDetail","magazinesDetailBackpack","magazinesDetailUniform","magazinesDetailVest","magazinesTurret","magazineTurretAmmo","mapAnimAdd","mapAnimClear","mapAnimCommit","mapAnimDone","mapCenterOnCamera","mapGridPosition","markAsFinishedOnSteam","markerAlpha","markerBrush","markerColor","markerDir","markerPos","markerShape","markerSize","markerText","markerType","max","members","min","mineActive","mineDetectedBy","missionConfigFile","missionName","missionNamespace","missionStart","mod","modelToWorld","modelToWorldVisual","moonIntensity","morale","move","moveInAny","moveInCargo","moveInCommander","moveInDriver","moveInGunner","moveInTurret","moveObjectToEnd","moveOut","moveTime","moveTo","moveToCompleted","moveToFailed","musicVolume","name","name location","nameSound","nearEntities","nearestBuilding","nearestLocation","nearestLocations","nearestLocationWithDubbing","nearestObject","nearestObjects","nearObjects","nearObjectsReady","nearRoads","nearSupplies","nearTargets","needReload","netId","netObjNull","newOverlay","nextMenuItemIndex","nextWeatherChange","nil","nMenuItems","not","numberToDate","objectCurators","objectFromNetId","objectParent","objNull","objStatus","onBriefingGroup","onBriefingNotes","onBriefingPlan","onBriefingTeamSwitch","onCommandModeChanged","onDoubleClick","onEachFrame","onGroupIconClick","onGroupIconOverEnter","onGroupIconOverLeave","onHCGroupSelectionChanged","onMapSingleClick","onPlayerConnected","onPlayerDisconnected","onPreloadFinished","onPreloadStarted","onShowNewObject","onTeamSwitch","openCuratorInterface","openMap","openYoutubeVideo","opfor","or","orderGetIn","overcast","overcastForecast","owner","param","params","parseNumber","parseText","parsingNamespace","particlesQuality","pi","pickWeaponPool","pitch","playableSlotsNumber","playableUnits","playAction","playActionNow","player","playerRespawnTime","playerSide","playersNumber","playGesture","playMission","playMove","playMoveNow","playMusic","playScriptedMission","playSound","playSound3D","position","positionCameraToWorld","posScreenToWorld","posWorldToScreen","ppEffectAdjust","ppEffectCommit","ppEffectCommitted","ppEffectCreate","ppEffectDestroy","ppEffectEnable","ppEffectForceInNVG","precision","preloadCamera","preloadObject","preloadSound","preloadTitleObj","preloadTitleRsc","preprocessFile","preprocessFileLineNumbers","primaryWeapon","primaryWeaponItems","primaryWeaponMagazine","priority","private","processDiaryLink","productVersion","profileName","profileNamespace","profileNameSteam","progressLoadingScreen","progressPosition","progressSetPosition","publicVariable","publicVariableClient","publicVariableServer","pushBack","putWeaponPool","queryItemsPool","queryMagazinePool","queryWeaponPool","rad","radioChannelAdd","radioChannelCreate","radioChannelRemove","radioChannelSetCallSign","radioChannelSetLabel","radioVolume","rain","rainbow","random","rank","rankId","rating","rectangular","registeredTasks","registerTask","reload","reloadEnabled","remoteControl","remoteExec","remoteExecCall","removeAction","removeAllActions","removeAllAssignedItems","removeAllContainers","removeAllCuratorAddons","removeAllCuratorCameraAreas","removeAllCuratorEditingAreas","removeAllEventHandlers","removeAllHandgunItems","removeAllItems","removeAllItemsWithMagazines","removeAllMissionEventHandlers","removeAllMPEventHandlers","removeAllMusicEventHandlers","removeAllPrimaryWeaponItems","removeAllWeapons","removeBackpack","removeBackpackGlobal","removeCuratorAddons","removeCuratorCameraArea","removeCuratorEditableObjects","removeCuratorEditingArea","removeDrawIcon","removeDrawLinks","removeEventHandler","removeFromRemainsCollector","removeGoggles","removeGroupIcon","removeHandgunItem","removeHeadgear","removeItem","removeItemFromBackpack","removeItemFromUniform","removeItemFromVest","removeItems","removeMagazine","removeMagazineGlobal","removeMagazines","removeMagazinesTurret","removeMagazineTurret","removeMenuItem","removeMissionEventHandler","removeMPEventHandler","removeMusicEventHandler","removePrimaryWeaponItem","removeSecondaryWeaponItem","removeSimpleTask","removeSwitchableUnit","removeTeamMember","removeUniform","removeVest","removeWeapon","removeWeaponGlobal","removeWeaponTurret","requiredVersion","resetCamShake","resetSubgroupDirection","resistance","resize","resources","respawnVehicle","restartEditorCamera","reveal","revealMine","reverse","reversedMouseY","roadsConnectedTo","roleDescription","ropeAttachedObjects","ropeAttachedTo","ropeAttachEnabled","ropeAttachTo","ropeCreate","ropeCut","ropeEndPosition","ropeLength","ropes","ropeUnwind","ropeUnwound","rotorsForcesRTD","rotorsRpmRTD","round","runInitScript","safeZoneH","safeZoneW","safeZoneWAbs","safeZoneX","safeZoneXAbs","safeZoneY","saveGame","saveIdentity","saveJoysticks","saveOverlay","saveProfileNamespace","saveStatus","saveVar","savingEnabled","say","say2D","say3D","scopeName","score","scoreSide","screenToWorld","scriptDone","scriptName","scriptNull","scudState","secondaryWeapon","secondaryWeaponItems","secondaryWeaponMagazine","select","selectBestPlaces","selectDiarySubject","selectedEditorObjects","selectEditorObject","selectionPosition","selectLeader","selectNoPlayer","selectPlayer","selectWeapon","selectWeaponTurret","sendAUMessage","sendSimpleCommand","sendTask","sendTaskResult","sendUDPMessage","serverCommand","serverCommandAvailable","serverCommandExecutable","serverName","serverTime","set","setAccTime","setAirportSide","setAmmo","setAmmoCargo","setAperture","setApertureNew","setArmoryPoints","setAttributes","setAutonomous","setBehaviour","setBleedingRemaining","setCameraInterest","setCamShakeDefParams","setCamShakeParams","setCamUseTi","setCaptive","setCenterOfMass","setCollisionLight","setCombatMode","setCompassOscillation","setCuratorCameraAreaCeiling","setCuratorCoef","setCuratorEditingAreaType","setCuratorWaypointCost","setCurrentChannel","setCurrentTask","setCurrentWaypoint","setDamage","setDammage","setDate","setDebriefingText","setDefaultCamera","setDestination","setDetailMapBlendPars","setDir","setDirection","setDrawIcon","setDropInterval","setEditorMode","setEditorObjectScope","setEffectCondition","setFace","setFaceAnimation","setFatigue","setFlagOwner","setFlagSide","setFlagTexture","setFog","setFog array","setFormation","setFormationTask","setFormDir","setFriend","setFromEditor","setFSMVariable","setFuel","setFuelCargo","setGroupIcon","setGroupIconParams","setGroupIconsSelectable","setGroupIconsVisible","setGroupId","setGroupIdGlobal","setGroupOwner","setGusts","setHideBehind","setHit","setHitIndex","setHitPointDamage","setHorizonParallaxCoef","setHUDMovementLevels","setIdentity","setImportance","setLeader","setLightAmbient","setLightAttenuation","setLightBrightness","setLightColor","setLightDayLight","setLightFlareMaxDistance","setLightFlareSize","setLightIntensity","setLightnings","setLightUseFlare","setLocalWindParams","setMagazineTurretAmmo","setMarkerAlpha","setMarkerAlphaLocal","setMarkerBrush","setMarkerBrushLocal","setMarkerColor","setMarkerColorLocal","setMarkerDir","setMarkerDirLocal","setMarkerPos","setMarkerPosLocal","setMarkerShape","setMarkerShapeLocal","setMarkerSize","setMarkerSizeLocal","setMarkerText","setMarkerTextLocal","setMarkerType","setMarkerTypeLocal","setMass","setMimic","setMousePosition","setMusicEffect","setMusicEventHandler","setName","setNameSound","setObjectArguments","setObjectMaterial","setObjectProxy","setObjectTexture","setObjectTextureGlobal","setObjectViewDistance","setOvercast","setOwner","setOxygenRemaining","setParticleCircle","setParticleClass","setParticleFire","setParticleParams","setParticleRandom","setPilotLight","setPiPEffect","setPitch","setPlayable","setPlayerRespawnTime","setPos","setPosASL","setPosASL2","setPosASLW","setPosATL","setPosition","setPosWorld","setRadioMsg","setRain","setRainbow","setRandomLip","setRank","setRectangular","setRepairCargo","setShadowDistance","setSide","setSimpleTaskDescription","setSimpleTaskDestination","setSimpleTaskTarget","setSimulWeatherLayers","setSize","setSkill","setSkill array","setSlingLoad","setSoundEffect","setSpeaker","setSpeech","setSpeedMode","setStatValue","setSuppression","setSystemOfUnits","setTargetAge","setTaskResult","setTaskState","setTerrainGrid","setText","setTimeMultiplier","setTitleEffect","setTriggerActivation","setTriggerArea","setTriggerStatements","setTriggerText","setTriggerTimeout","setTriggerType","setType","setUnconscious","setUnitAbility","setUnitPos","setUnitPosWeak","setUnitRank","setUnitRecoilCoefficient","setUnloadInCombat","setUserActionText","setVariable","setVectorDir","setVectorDirAndUp","setVectorUp","setVehicleAmmo","setVehicleAmmoDef","setVehicleArmor","setVehicleId","setVehicleLock","setVehiclePosition","setVehicleTiPars","setVehicleVarName","setVelocity","setVelocityTransformation","setViewDistance","setVisibleIfTreeCollapsed","setWaves","setWaypointBehaviour","setWaypointCombatMode","setWaypointCompletionRadius","setWaypointDescription","setWaypointFormation","setWaypointHousePosition","setWaypointLoiterRadius","setWaypointLoiterType","setWaypointName","setWaypointPosition","setWaypointScript","setWaypointSpeed","setWaypointStatements","setWaypointTimeout","setWaypointType","setWaypointVisible","setWeaponReloadingTime","setWind","setWindDir","setWindForce","setWindStr","setWPPos","show3DIcons","showChat","showCinemaBorder","showCommandingMenu","showCompass","showCuratorCompass","showGPS","showHUD","showLegend","showMap","shownArtilleryComputer","shownChat","shownCompass","shownCuratorCompass","showNewEditorObject","shownGPS","shownHUD","shownMap","shownPad","shownRadio","shownUAVFeed","shownWarrant","shownWatch","showPad","showRadio","showSubtitles","showUAVFeed","showWarrant","showWatch","showWaypoint","side","sideChat","sideEnemy","sideFriendly","sideLogic","sideRadio","sideUnknown","simpleTasks","simulationEnabled","simulCloudDensity","simulCloudOcclusion","simulInClouds","simulWeatherSync","sin","size","sizeOf","skill","skillFinal","skipTime","sleep","sliderPosition","sliderRange","sliderSetPosition","sliderSetRange","sliderSetSpeed","sliderSpeed","slingLoadAssistantShown","soldierMagazines","someAmmo","sort","soundVolume","spawn","speaker","speed","speedMode","splitString","sqrt","squadParams","stance","startLoadingScreen","step","stop","stopped","str","sunOrMoon","supportInfo","suppressFor","surfaceIsWater","surfaceNormal","surfaceType","swimInDepth","switch","switchableUnits","switchAction","switchCamera","switchGesture","switchLight","switchMove","synchronizedObjects","synchronizedTriggers","synchronizedWaypoints","synchronizeObjectsAdd","synchronizeObjectsRemove","synchronizeTrigger","synchronizeWaypoint","synchronizeWaypoint trigger","systemChat","systemOfUnits","tan","targetKnowledge","targetsAggregate","targetsQuery","taskChildren","taskCompleted","taskDescription","taskDestination","taskHint","taskNull","taskParent","taskResult","taskState","teamMember","teamMemberNull","teamName","teams","teamSwitch","teamSwitchEnabled","teamType","terminate","terrainIntersect","terrainIntersectASL","text","text location","textLog","textLogFormat","tg","then","throw","time","timeMultiplier","titleCut","titleFadeOut","titleObj","titleRsc","titleText","to","toArray","toLower","toString","toUpper","triggerActivated","triggerActivation","triggerArea","triggerAttachedVehicle","triggerAttachObject","triggerAttachVehicle","triggerStatements","triggerText","triggerTimeout","triggerTimeoutCurrent","triggerType","true","try","turretLocal","turretOwner","turretUnit","tvAdd","tvClear","tvCollapse","tvCount","tvCurSel","tvData","tvDelete","tvExpand","tvPicture","tvSetCurSel","tvSetData","tvSetPicture","tvSetPictureColor","tvSetTooltip","tvSetValue","tvSort","tvSortByValue","tvText","tvValue","type","typeName","typeOf","UAVControl","uiNamespace","uiSleep","unassignCurator","unassignItem","unassignTeam","unassignVehicle","underwater","uniform","uniformContainer","uniformItems","uniformMagazines","unitAddons","unitBackpack","unitPos","unitReady","unitRecoilCoefficient","units","unitsBelowHeight","unlinkItem","unlockAchievement","unregisterTask","updateDrawIcon","updateMenuItem","updateObjectTree","useAudioTimeForMoves","vectorAdd","vectorCos","vectorCrossProduct","vectorDiff","vectorDir","vectorDirVisual","vectorDistance","vectorDistanceSqr","vectorDotProduct","vectorFromTo","vectorMagnitude","vectorMagnitudeSqr","vectorMultiply","vectorNormalized","vectorUp","vectorUpVisual","vehicle","vehicleChat","vehicleRadio","vehicles","vehicleVarName","velocity","velocityModelSpace","verifySignature","vest","vestContainer","vestItems","vestMagazines","viewDistance","visibleCompass","visibleGPS","visibleMap","visiblePosition","visiblePositionASL","visibleWatch","waitUntil","waves","waypointAttachedObject","waypointAttachedVehicle","waypointAttachObject","waypointAttachVehicle","waypointBehaviour","waypointCombatMode","waypointCompletionRadius","waypointDescription","waypointFormation","waypointHousePosition","waypointLoiterRadius","waypointLoiterType","waypointName","waypointPosition","waypoints","waypointScript","waypointsEnabledUAV","waypointShow","waypointSpeed","waypointStatements","waypointTimeout","waypointTimeoutCurrent","waypointType","waypointVisible","weaponAccessories","weaponCargo","weaponDirection","weaponLowered","weapons","weaponsItems","weaponsItemsCargo","weaponState","weaponsTurret","weightRTD","west","WFSideText","while","wind","windDir","windStr","wingsForcesRTD","with","worldName","worldSize","worldToModel","worldToModelVisual","worldToScreen"],control=["case","catch","default","do","else","exit","exitWith|5","for","forEach","from","if","switch","then","throw","to","try","while","with"],operators=["!","-","+","!=","%","&&","*","/","=","==",">",">=","<","<=","^",":",">>"],specials=["_forEachIndex|10","_this|10","_x|10"],literals=["true","false","nil"],builtins=allCommands.filter(function(command){
return control.indexOf(command)==-1&&literals.indexOf(command)==-1&&operators.indexOf(command)==-1});builtins=builtins.concat(specials);var STRINGS={className:"string",relevance:0,variants:[{begin:'"',end:'"',contains:[{begin:'""'}]},{begin:"'",end:"'",contains:[{begin:"''"}]}]},NUMBERS={className:"number",begin:hljs.NUMBER_RE,relevance:0},PREPROCESSOR_STRINGS={className:"string",variants:[hljs.QUOTE_STRING_MODE,{begin:"'\\\\?.",end:"'",illegal:"."}]},PREPROCESSOR={className:"preprocessor",begin:"#",end:"$",keywords:"if else elif endif define undef warning error line pragma ifdef ifndef",contains:[{begin:/\\\n/,relevance:0},{beginKeywords:"include",end:"$",contains:[PREPROCESSOR_STRINGS,{className:"string",begin:"<",end:">",illegal:"\\n"}]},PREPROCESSOR_STRINGS,NUMBERS,hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE]};return{aliases:["sqf"],case_insensitive:!0,keywords:{keyword:control.join(" "),built_in:builtins.join(" "),literal:literals.join(" ")},contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,NUMBERS,STRINGS,PREPROCESSOR]}}),hljs.registerLanguage("sql",function(hljs){var COMMENT_MODE=hljs.COMMENT("--","$");return{case_insensitive:!0,illegal:/[<>{}*]/,contains:[{className:"operator",beginKeywords:"begin end start commit rollback savepoint lock alter create drop rename call delete do handler insert load replace select truncate update set show pragma grant merge describe use explain help declare prepare execute deallocate release unlock purge reset change stop analyze cache flush optimize repair kill install uninstall checksum restore check backup revoke",end:/;/,endsWithParent:!0,keywords:{keyword:"abort abs absolute acc acce accep accept access accessed accessible account acos action activate add addtime admin administer advanced advise aes_decrypt aes_encrypt after agent aggregate ali alia alias allocate allow alter always analyze ancillary and any anydata anydataset anyschema anytype apply archive archived archivelog are as asc ascii asin assembly assertion associate asynchronous at atan atn2 attr attri attrib attribu attribut attribute attributes audit authenticated authentication authid authors auto autoallocate autodblink autoextend automatic availability avg backup badfile basicfile before begin beginning benchmark between bfile bfile_base big bigfile bin binary_double binary_float binlog bit_and bit_count bit_length bit_or bit_xor bitmap blob_base block blocksize body both bound buffer_cache buffer_pool build bulk by byte byteordermark bytes c cache caching call calling cancel capacity cascade cascaded case cast catalog category ceil ceiling chain change changed char_base char_length character_length characters characterset charindex charset charsetform charsetid check checksum checksum_agg child choose chr chunk class cleanup clear client clob clob_base clone close cluster_id cluster_probability cluster_set clustering coalesce coercibility col collate collation collect colu colum column column_value columns columns_updated comment commit compact compatibility compiled complete composite_limit compound compress compute concat concat_ws concurrent confirm conn connec connect connect_by_iscycle connect_by_isleaf connect_by_root connect_time connection consider consistent constant constraint constraints constructor container content contents context contributors controlfile conv convert convert_tz corr corr_k corr_s corresponding corruption cos cost count count_big counted covar_pop covar_samp cpu_per_call cpu_per_session crc32 create creation critical cross cube cume_dist curdate current current_date current_time current_timestamp current_user cursor curtime customdatum cycle d data database databases datafile datafiles datalength date_add date_cache date_format date_sub dateadd datediff datefromparts datename datepart datetime2fromparts day day_to_second dayname dayofmonth dayofweek dayofyear days db_role_change dbtimezone ddl deallocate declare decode decompose decrement decrypt deduplicate def defa defau defaul default defaults deferred defi defin define degrees delayed delegate delete delete_all delimited demand dense_rank depth dequeue des_decrypt des_encrypt des_key_file desc descr descri describ describe descriptor deterministic diagnostics difference dimension direct_load directory disable disable_all disallow disassociate discardfile disconnect diskgroup distinct distinctrow distribute distributed div do document domain dotnet double downgrade drop dumpfile duplicate duration e each edition editionable editions element ellipsis else elsif elt empty enable enable_all enclosed encode encoding encrypt end end-exec endian enforced engine engines enqueue enterprise entityescaping eomonth error errors escaped evalname evaluate event eventdata events except exception exceptions exchange exclude excluding execu execut execute exempt exists exit exp expire explain export export_set extended extent external external_1 external_2 externally extract f failed failed_login_attempts failover failure far fast feature_set feature_value fetch field fields file file_name_convert filesystem_like_logging final finish first first_value fixed flash_cache flashback floor flush following follows for forall force form forma format found found_rows freelist freelists freepools fresh from from_base64 from_days ftp full function g general generated get get_format get_lock getdate getutcdate global global_name globally go goto grant grants greatest group group_concat group_id grouping grouping_id groups gtid_subtract guarantee guard handler hash hashkeys having hea head headi headin heading heap help hex hierarchy high high_priority hosts hour http i id ident_current ident_incr ident_seed identified identity idle_time if ifnull ignore iif ilike ilm immediate import in include including increment index indexes indexing indextype indicator indices inet6_aton inet6_ntoa inet_aton inet_ntoa infile initial initialized initially initrans inmemory inner innodb input insert install instance instantiable instr interface interleaved intersect into invalidate invisible is is_free_lock is_ipv4 is_ipv4_compat is_not is_not_null is_used_lock isdate isnull isolation iterate java join json json_exists k keep keep_duplicates key keys kill l language large last last_day last_insert_id last_value lax lcase lead leading least leaves left len lenght length less level levels library like like2 like4 likec limit lines link list listagg little ln load load_file lob lobs local localtime localtimestamp locate locator lock locked log log10 log2 logfile logfiles logging logical logical_reads_per_call logoff logon logs long loop low low_priority lower lpad lrtrim ltrim m main make_set makedate maketime managed management manual map mapping mask master master_pos_wait match matched materialized max maxextents maximize maxinstances maxlen maxlogfiles maxloghistory maxlogmembers maxsize maxtrans md5 measures median medium member memcompress memory merge microsecond mid migration min minextents minimum mining minus minute minvalue missing mod mode model modification modify module monitoring month months mount move movement multiset mutex n name name_const names nan national native natural nav nchar nclob nested never new newline next nextval no no_write_to_binlog noarchivelog noaudit nobadfile nocheck nocompress nocopy nocycle nodelay nodiscardfile noentityescaping noguarantee nokeep nologfile nomapping nomaxvalue nominimize nominvalue nomonitoring none noneditionable nonschema noorder nopr nopro noprom nopromp noprompt norely noresetlogs noreverse normal norowdependencies noschemacheck noswitch not nothing notice notrim novalidate now nowait nth_value nullif nulls num numb numbe nvarchar nvarchar2 object ocicoll ocidate ocidatetime ociduration ociinterval ociloblocator ocinumber ociref ocirefcursor ocirowid ocistring ocitype oct octet_length of off offline offset oid oidindex old on online only opaque open operations operator optimal optimize option optionally or oracle oracle_date oradata ord ordaudio orddicom orddoc order ordimage ordinality ordvideo organization orlany orlvary out outer outfile outline output over overflow overriding p package pad parallel parallel_enable parameters parent parse partial partition partitions pascal passing password password_grace_time password_lock_time password_reuse_max password_reuse_time password_verify_function patch path patindex pctincrease pctthreshold pctused pctversion percent percent_rank percentile_cont percentile_disc performance period period_add period_diff permanent physical pi pipe pipelined pivot pluggable plugin policy position post_transaction pow power pragma prebuilt precedes preceding precision prediction prediction_cost prediction_details prediction_probability prediction_set prepare present preserve prior priority private private_sga privileges procedural procedure procedure_analyze processlist profiles project prompt protection public publishingservername purge quarter query quick quiesce quota quotename radians raise rand range rank raw read reads readsize rebuild record records recover recovery recursive recycle redo reduced ref reference referenced references referencing refresh regexp_like register regr_avgx regr_avgy regr_count regr_intercept regr_r2 regr_slope regr_sxx regr_sxy reject rekey relational relative relaylog release release_lock relies_on relocate rely rem remainder rename repair repeat replace replicate replication required reset resetlogs resize resource respect restore restricted result result_cache resumable resume retention return returning returns reuse reverse revoke right rlike role roles rollback rolling rollup round row row_count rowdependencies rowid rownum rows rtrim rules safe salt sample save savepoint sb1 sb2 sb4 scan schema schemacheck scn scope scroll sdo_georaster sdo_topo_geometry search sec_to_time second section securefile security seed segment select self sequence sequential serializable server servererror session session_user sessions_per_user set sets settings sha sha1 sha2 share shared shared_pool short show shrink shutdown si_averagecolor si_colorhistogram si_featurelist si_positionalcolor si_stillimage si_texture siblings sid sign sin size size_t sizes skip slave sleep smalldatetimefromparts smallfile snapshot some soname sort soundex source space sparse spfile split sql sql_big_result sql_buffer_result sql_cache sql_calc_found_rows sql_small_result sql_variant_property sqlcode sqldata sqlerror sqlname sqlstate sqrt square standalone standby start starting startup statement static statistics stats_binomial_test stats_crosstab stats_ks_test stats_mode stats_mw_test stats_one_way_anova stats_t_test_ stats_t_test_indep stats_t_test_one stats_t_test_paired stats_wsr_test status std stddev stddev_pop stddev_samp stdev stop storage store stored str str_to_date straight_join strcmp strict string struct stuff style subdate subpartition subpartitions substitutable substr substring subtime subtring_index subtype success sum suspend switch switchoffset switchover sync synchronous synonym sys sys_xmlagg sysasm sysaux sysdate sysdatetimeoffset sysdba sysoper system system_user sysutcdatetime t table tables tablespace tan tdo template temporary terminated tertiary_weights test than then thread through tier ties time time_format time_zone timediff timefromparts timeout timestamp timestampadd timestampdiff timezone_abbr timezone_minute timezone_region to to_base64 to_date to_days to_seconds todatetimeoffset trace tracking transaction transactional translate translation treat trigger trigger_nestlevel triggers trim truncate try_cast try_convert try_parse type ub1 ub2 ub4 ucase unarchived unbounded uncompress under undo unhex unicode uniform uninstall union unique unix_timestamp unknown unlimited unlock unpivot unrecoverable unsafe unsigned until untrusted unusable unused update updated upgrade upped upper upsert url urowid usable usage use use_stored_outlines user user_data user_resources users using utc_date utc_timestamp uuid uuid_short validate validate_password_strength validation valist value values var var_samp varcharc vari varia variab variabl variable variables variance varp varraw varrawc varray verify version versions view virtual visible void wait wallet warning warnings week weekday weekofyear wellformed when whene whenev wheneve whenever where while whitespace with within without work wrapped xdb xml xmlagg xmlattributes xmlcast xmlcolattval xmlelement xmlexists xmlforest xmlindex xmlnamespaces xmlpi xmlquery xmlroot xmlschema xmlserialize xmltable xmltype xor year year_to_month years yearweek",literal:"true false null",built_in:"array bigint binary bit blob boolean char character date dec decimal float int int8 integer interval number numeric real record serial serial8 smallint text varchar varying void"},contains:[{className:"string",begin:"'",end:"'",contains:[hljs.BACKSLASH_ESCAPE,{begin:"''"}]},{className:"string",begin:'"',end:'"',contains:[hljs.BACKSLASH_ESCAPE,{begin:'""'}]},{className:"string",begin:"`",end:"`",contains:[hljs.BACKSLASH_ESCAPE]},hljs.C_NUMBER_MODE,hljs.C_BLOCK_COMMENT_MODE,COMMENT_MODE]},hljs.C_BLOCK_COMMENT_MODE,COMMENT_MODE]}}),hljs.registerLanguage("stata",function(hljs){return{aliases:["do","ado"],case_insensitive:!0,keywords:"if else in foreach for forv forva forval forvalu forvalue forvalues by bys bysort xi quietly qui capture about ac ac_7 acprplot acprplot_7 adjust ado adopath adoupdate alpha ameans an ano anov anova anova_estat anova_terms anovadef aorder ap app appe appen append arch arch_dr arch_estat arch_p archlm areg areg_p args arima arima_dr arima_estat arima_p as asmprobit asmprobit_estat asmprobit_lf asmprobit_mfx__dlg asmprobit_p ass asse asser assert avplot avplot_7 avplots avplots_7 bcskew0 bgodfrey binreg bip0_lf biplot bipp_lf bipr_lf bipr_p biprobit bitest bitesti bitowt blogit bmemsize boot bootsamp bootstrap bootstrap_8 boxco_l boxco_p boxcox boxcox_6 boxcox_p bprobit br break brier bro brow brows browse brr brrstat bs bs_7 bsampl_w bsample bsample_7 bsqreg bstat bstat_7 bstat_8 bstrap bstrap_7 ca ca_estat ca_p cabiplot camat canon canon_8 canon_8_p canon_estat canon_p cap caprojection capt captu captur capture cat cc cchart cchart_7 cci cd censobs_table centile cf char chdir checkdlgfiles checkestimationsample checkhlpfiles checksum chelp ci cii cl class classutil clear cli clis clist clo clog clog_lf clog_p clogi clogi_sw clogit clogit_lf clogit_p clogitp clogl_sw cloglog clonevar clslistarray cluster cluster_measures cluster_stop cluster_tree cluster_tree_8 clustermat cmdlog cnr cnre cnreg cnreg_p cnreg_sw cnsreg codebook collaps4 collapse colormult_nb colormult_nw compare compress conf confi confir confirm conren cons const constr constra constrai constrain constraint continue contract copy copyright copysource cor corc corr corr2data corr_anti corr_kmo corr_smc corre correl correla correlat correlate corrgram cou coun count cox cox_p cox_sw coxbase coxhaz coxvar cprplot cprplot_7 crc cret cretu cretur creturn cross cs cscript cscript_log csi ct ct_is ctset ctst_5 ctst_st cttost cumsp cumsp_7 cumul cusum cusum_7 cutil d datasig datasign datasigna datasignat datasignatu datasignatur datasignature datetof db dbeta de dec deco decod decode deff des desc descr descri describ describe destring dfbeta dfgls dfuller di di_g dir dirstats dis discard disp disp_res disp_s displ displa display distinct do doe doed doedi doedit dotplot dotplot_7 dprobit drawnorm drop ds ds_util dstdize duplicates durbina dwstat dydx e ed edi edit egen eivreg emdef en enc enco encod encode eq erase ereg ereg_lf ereg_p ereg_sw ereghet ereghet_glf ereghet_glf_sh ereghet_gp ereghet_ilf ereghet_ilf_sh ereghet_ip eret eretu eretur ereturn err erro error est est_cfexist est_cfname est_clickable est_expand est_hold est_table est_unhold est_unholdok estat estat_default estat_summ estat_vce_only esti estimates etodow etof etomdy ex exi exit expand expandcl fac fact facto factor factor_estat factor_p factor_pca_rotated factor_rotate factormat fcast fcast_compute fcast_graph fdades fdadesc fdadescr fdadescri fdadescrib fdadescribe fdasav fdasave fdause fh_st file open file read file close file filefilter fillin find_hlp_file findfile findit findit_7 fit fl fli flis flist for5_0 form forma format fpredict frac_154 frac_adj frac_chk frac_cox frac_ddp frac_dis frac_dv frac_in frac_mun frac_pp frac_pq frac_pv frac_wgt frac_xo fracgen fracplot fracplot_7 fracpoly fracpred fron_ex fron_hn fron_p fron_tn fron_tn2 frontier ftodate ftoe ftomdy ftowdate g gamhet_glf gamhet_gp gamhet_ilf gamhet_ip gamma gamma_d2 gamma_p gamma_sw gammahet gdi_hexagon gdi_spokes ge gen gene gener genera generat generate genrank genstd genvmean gettoken gl gladder gladder_7 glim_l01 glim_l02 glim_l03 glim_l04 glim_l05 glim_l06 glim_l07 glim_l08 glim_l09 glim_l10 glim_l11 glim_l12 glim_lf glim_mu glim_nw1 glim_nw2 glim_nw3 glim_p glim_v1 glim_v2 glim_v3 glim_v4 glim_v5 glim_v6 glim_v7 glm glm_6 glm_p glm_sw glmpred glo glob globa global glogit glogit_8 glogit_p gmeans gnbre_lf gnbreg gnbreg_5 gnbreg_p gomp_lf gompe_sw gomper_p gompertz gompertzhet gomphet_glf gomphet_glf_sh gomphet_gp gomphet_ilf gomphet_ilf_sh gomphet_ip gphdot gphpen gphprint gprefs gprobi_p gprobit gprobit_8 gr gr7 gr_copy gr_current gr_db gr_describe gr_dir gr_draw gr_draw_replay gr_drop gr_edit gr_editviewopts gr_example gr_example2 gr_export gr_print gr_qscheme gr_query gr_read gr_rename gr_replay gr_save gr_set gr_setscheme gr_table gr_undo gr_use graph graph7 grebar greigen greigen_7 greigen_8 grmeanby grmeanby_7 gs_fileinfo gs_filetype gs_graphinfo gs_stat gsort gwood h hadimvo hareg hausman haver he heck_d2 heckma_p heckman heckp_lf heckpr_p heckprob hel help hereg hetpr_lf hetpr_p hetprob hettest hexdump hilite hist hist_7 histogram hlogit hlu hmeans hotel hotelling hprobit hreg hsearch icd9 icd9_ff icd9p iis impute imtest inbase include inf infi infil infile infix inp inpu input ins insheet insp inspe inspec inspect integ inten intreg intreg_7 intreg_p intrg2_ll intrg_ll intrg_ll2 ipolate iqreg ir irf irf_create irfm iri is_svy is_svysum isid istdize ivprob_1_lf ivprob_lf ivprobit ivprobit_p ivreg ivreg_footnote ivtob_1_lf ivtob_lf ivtobit ivtobit_p jackknife jacknife jknife jknife_6 jknife_8 jkstat joinby kalarma1 kap kap_3 kapmeier kappa kapwgt kdensity kdensity_7 keep ksm ksmirnov ktau kwallis l la lab labe label labelbook ladder levels levelsof leverage lfit lfit_p li lincom line linktest lis list lloghet_glf lloghet_glf_sh lloghet_gp lloghet_ilf lloghet_ilf_sh lloghet_ip llogi_sw llogis_p llogist llogistic llogistichet lnorm_lf lnorm_sw lnorma_p lnormal lnormalhet lnormhet_glf lnormhet_glf_sh lnormhet_gp lnormhet_ilf lnormhet_ilf_sh lnormhet_ip lnskew0 loadingplot loc loca local log logi logis_lf logistic logistic_p logit logit_estat logit_p loglogs logrank loneway lookfor lookup lowess lowess_7 lpredict lrecomp lroc lroc_7 lrtest ls lsens lsens_7 lsens_x lstat ltable ltable_7 ltriang lv lvr2plot lvr2plot_7 m ma mac macr macro makecns man manova manova_estat manova_p manovatest mantel mark markin markout marksample mat mat_capp mat_order mat_put_rr mat_rapp mata mata_clear mata_describe mata_drop mata_matdescribe mata_matsave mata_matuse mata_memory mata_mlib mata_mosave mata_rename mata_which matalabel matcproc matlist matname matr matri matrix matrix_input__dlg matstrik mcc mcci md0_ md1_ md1debug_ md2_ md2debug_ mds mds_estat mds_p mdsconfig mdslong mdsmat mdsshepard mdytoe mdytof me_derd mean means median memory memsize meqparse mer merg merge mfp mfx mhelp mhodds minbound mixed_ll mixed_ll_reparm mkassert mkdir mkmat mkspline ml ml_5 ml_adjs ml_bhhhs ml_c_d ml_check ml_clear ml_cnt ml_debug ml_defd ml_e0 ml_e0_bfgs ml_e0_cycle ml_e0_dfp ml_e0i ml_e1 ml_e1_bfgs ml_e1_bhhh ml_e1_cycle ml_e1_dfp ml_e2 ml_e2_cycle ml_ebfg0 ml_ebfr0 ml_ebfr1 ml_ebh0q ml_ebhh0 ml_ebhr0 ml_ebr0i ml_ecr0i ml_edfp0 ml_edfr0 ml_edfr1 ml_edr0i ml_eds ml_eer0i ml_egr0i ml_elf ml_elf_bfgs ml_elf_bhhh ml_elf_cycle ml_elf_dfp ml_elfi ml_elfs ml_enr0i ml_enrr0 ml_erdu0 ml_erdu0_bfgs ml_erdu0_bhhh ml_erdu0_bhhhq ml_erdu0_cycle ml_erdu0_dfp ml_erdu0_nrbfgs ml_exde ml_footnote ml_geqnr ml_grad0 ml_graph ml_hbhhh ml_hd0 ml_hold ml_init ml_inv ml_log ml_max ml_mlout ml_mlout_8 ml_model ml_nb0 ml_opt ml_p ml_plot ml_query ml_rdgrd ml_repor ml_s_e ml_score ml_searc ml_technique ml_unhold mleval mlf_ mlmatbysum mlmatsum mlog mlogi mlogit mlogit_footnote mlogit_p mlopts mlsum mlvecsum mnl0_ mor more mov move mprobit mprobit_lf mprobit_p mrdu0_ mrdu1_ mvdecode mvencode mvreg mvreg_estat n nbreg nbreg_al nbreg_lf nbreg_p nbreg_sw nestreg net newey newey_7 newey_p news nl nl_7 nl_9 nl_9_p nl_p nl_p_7 nlcom nlcom_p nlexp2 nlexp2_7 nlexp2a nlexp2a_7 nlexp3 nlexp3_7 nlgom3 nlgom3_7 nlgom4 nlgom4_7 nlinit nllog3 nllog3_7 nllog4 nllog4_7 nlog_rd nlogit nlogit_p nlogitgen nlogittree nlpred no nobreak noi nois noisi noisil noisily note notes notes_dlg nptrend numlabel numlist odbc old_ver olo olog ologi ologi_sw ologit ologit_p ologitp on one onew onewa oneway op_colnm op_comp op_diff op_inv op_str opr opro oprob oprob_sw oprobi oprobi_p oprobit oprobitp opts_exclusive order orthog orthpoly ou out outf outfi outfil outfile outs outsh outshe outshee outsheet ovtest pac pac_7 palette parse parse_dissim pause pca pca_8 pca_display pca_estat pca_p pca_rotate pcamat pchart pchart_7 pchi pchi_7 pcorr pctile pentium pergram pergram_7 permute permute_8 personal peto_st pkcollapse pkcross pkequiv pkexamine pkexamine_7 pkshape pksumm pksumm_7 pl plo plot plugin pnorm pnorm_7 poisgof poiss_lf poiss_sw poisso_p poisson poisson_estat post postclose postfile postutil pperron pr prais prais_e prais_e2 prais_p predict predictnl preserve print pro prob probi probit probit_estat probit_p proc_time procoverlay procrustes procrustes_estat procrustes_p profiler prog progr progra program prop proportion prtest prtesti pwcorr pwd q\\s qby qbys qchi qchi_7 qladder qladder_7 qnorm qnorm_7 qqplot qqplot_7 qreg qreg_c qreg_p qreg_sw qu quadchk quantile quantile_7 que quer query range ranksum ratio rchart rchart_7 rcof recast reclink recode reg reg3 reg3_p regdw regr regre regre_p2 regres regres_p regress regress_estat regriv_p remap ren rena renam rename renpfix repeat replace report reshape restore ret retu retur return rm rmdir robvar roccomp roccomp_7 roccomp_8 rocf_lf rocfit rocfit_8 rocgold rocplot rocplot_7 roctab roctab_7 rolling rologit rologit_p rot rota rotat rotate rotatemat rreg rreg_p ru run runtest rvfplot rvfplot_7 rvpplot rvpplot_7 sa safesum sample sampsi sav save savedresults saveold sc sca scal scala scalar scatter scm_mine sco scob_lf scob_p scobi_sw scobit scor score scoreplot scoreplot_help scree screeplot screeplot_help sdtest sdtesti se search separate seperate serrbar serrbar_7 serset set set_defaults sfrancia sh she shel shell shewhart shewhart_7 signestimationsample signrank signtest simul simul_7 simulate simulate_8 sktest sleep slogit slogit_d2 slogit_p smooth snapspan so sor sort spearman spikeplot spikeplot_7 spikeplt spline_x split sqreg sqreg_p sret sretu sretur sreturn ssc st st_ct st_hc st_hcd st_hcd_sh st_is st_issys st_note st_promo st_set st_show st_smpl st_subid stack statsby statsby_8 stbase stci stci_7 stcox stcox_estat stcox_fr stcox_fr_ll stcox_p stcox_sw stcoxkm stcoxkm_7 stcstat stcurv stcurve stcurve_7 stdes stem stepwise stereg stfill stgen stir stjoin stmc stmh stphplot stphplot_7 stphtest stphtest_7 stptime strate strate_7 streg streg_sw streset sts sts_7 stset stsplit stsum sttocc sttoct stvary stweib su suest suest_8 sum summ summa summar summari summariz summarize sunflower sureg survcurv survsum svar svar_p svmat svy svy_disp svy_dreg svy_est svy_est_7 svy_estat svy_get svy_gnbreg_p svy_head svy_header svy_heckman_p svy_heckprob_p svy_intreg_p svy_ivreg_p svy_logistic_p svy_logit_p svy_mlogit_p svy_nbreg_p svy_ologit_p svy_oprobit_p svy_poisson_p svy_probit_p svy_regress_p svy_sub svy_sub_7 svy_x svy_x_7 svy_x_p svydes svydes_8 svygen svygnbreg svyheckman svyheckprob svyintreg svyintreg_7 svyintrg svyivreg svylc svylog_p svylogit svymarkout svymarkout_8 svymean svymlog svymlogit svynbreg svyolog svyologit svyoprob svyoprobit svyopts svypois svypois_7 svypoisson svyprobit svyprobt svyprop svyprop_7 svyratio svyreg svyreg_p svyregress svyset svyset_7 svyset_8 svytab svytab_7 svytest svytotal sw sw_8 swcnreg swcox swereg swilk swlogis swlogit swologit swoprbt swpois swprobit swqreg swtobit swweib symmetry symmi symplot symplot_7 syntax sysdescribe sysdir sysuse szroeter ta tab tab1 tab2 tab_or tabd tabdi tabdis tabdisp tabi table tabodds tabodds_7 tabstat tabu tabul tabula tabulat tabulate te tempfile tempname tempvar tes test testnl testparm teststd tetrachoric time_it timer tis tob tobi tobit tobit_p tobit_sw token tokeni tokeniz tokenize tostring total translate translator transmap treat_ll treatr_p treatreg trim trnb_cons trnb_mean trpoiss_d2 trunc_ll truncr_p truncreg tsappend tset tsfill tsline tsline_ex tsreport tsrevar tsrline tsset tssmooth tsunab ttest ttesti tut_chk tut_wait tutorial tw tware_st two twoway twoway__fpfit_serset twoway__function_gen twoway__histogram_gen twoway__ipoint_serset twoway__ipoints_serset twoway__kdensity_gen twoway__lfit_serset twoway__normgen_gen twoway__pci_serset twoway__qfit_serset twoway__scatteri_serset twoway__sunflower_gen twoway_ksm_serset ty typ type typeof u unab unabbrev unabcmd update us use uselabel var var_mkcompanion var_p varbasic varfcast vargranger varirf varirf_add varirf_cgraph varirf_create varirf_ctable varirf_describe varirf_dir varirf_drop varirf_erase varirf_graph varirf_ograph varirf_rename varirf_set varirf_table varlist varlmar varnorm varsoc varstable varstable_w varstable_w2 varwle vce vec vec_fevd vec_mkphi vec_p vec_p_w vecirf_create veclmar veclmar_w vecnorm vecnorm_w vecrank vecstable verinst vers versi versio version view viewsource vif vwls wdatetof webdescribe webseek webuse weib1_lf weib2_lf weib_lf weib_lf0 weibhet_glf weibhet_glf_sh weibhet_glfa weibhet_glfa_sh weibhet_gp weibhet_ilf weibhet_ilf_sh weibhet_ilfa weibhet_ilfa_sh weibhet_ip weibu_sw weibul_p weibull weibull_c weibull_s weibullhet wh whelp whi which whil while wilc_st wilcoxon win wind windo window winexec wntestb wntestb_7 wntestq xchart xchart_7 xcorr xcorr_7 xi xi_6 xmlsav xmlsave xmluse xpose xsh xshe xshel xshell xt_iis xt_tis xtab_p xtabond xtbin_p xtclog xtcloglog xtcloglog_8 xtcloglog_d2 xtcloglog_pa_p xtcloglog_re_p xtcnt_p xtcorr xtdata xtdes xtfront_p xtfrontier xtgee xtgee_elink xtgee_estat xtgee_makeivar xtgee_p xtgee_plink xtgls xtgls_p xthaus xthausman xtht_p xthtaylor xtile xtint_p xtintreg xtintreg_8 xtintreg_d2 xtintreg_p xtivp_1 xtivp_2 xtivreg xtline xtline_ex xtlogit xtlogit_8 xtlogit_d2 xtlogit_fe_p xtlogit_pa_p xtlogit_re_p xtmixed xtmixed_estat xtmixed_p xtnb_fe xtnb_lf xtnbreg xtnbreg_pa_p xtnbreg_refe_p xtpcse xtpcse_p xtpois xtpoisson xtpoisson_d2 xtpoisson_pa_p xtpoisson_refe_p xtpred xtprobit xtprobit_8 xtprobit_d2 xtprobit_re_p xtps_fe xtps_lf xtps_ren xtps_ren_8 xtrar_p xtrc xtrc_p xtrchh xtrefe_p xtreg xtreg_be xtreg_fe xtreg_ml xtreg_pa_p xtreg_re xtregar xtrere_p xtset xtsf_ll xtsf_llti xtsum xttab xttest0 xttobit xttobit_8 xttobit_p xttrans yx yxview__barlike_draw yxview_area_draw yxview_bar_draw yxview_dot_draw yxview_dropline_draw yxview_function_draw yxview_iarrow_draw yxview_ilabels_draw yxview_normal_draw yxview_pcarrow_draw yxview_pcbarrow_draw yxview_pccapsym_draw yxview_pcscatter_draw yxview_pcspike_draw yxview_rarea_draw yxview_rbar_draw yxview_rbarm_draw yxview_rcap_draw yxview_rcapsym_draw yxview_rconnected_draw yxview_rline_draw yxview_rscatter_draw yxview_rspike_draw yxview_spike_draw yxview_sunflower_draw zap_s zinb zinb_llf zinb_plf zip zip_llf zip_p zip_plf zt_ct_5 zt_hc_5 zt_hcd_5 zt_is_5 zt_iss_5 zt_sho_5 zt_smp_5 ztbase_5 ztcox_5 ztdes_5 ztereg_5 ztfill_5 ztgen_5 ztir_5 ztjoin_5 ztnb ztnb_p ztp ztp_p zts_5 ztset_5 ztspli_5 ztsum_5 zttoct_5 ztvary_5 ztweib_5",contains:[{className:"label",variants:[{begin:"\\$\\{?[a-zA-Z0-9_]+\\}?"},{begin:"`[a-zA-Z0-9_]+'"}]},{className:"string",variants:[{begin:'`"[^\r\n]*?"\''},{begin:'"[^\r\n"]*"'}]},{className:"literal",variants:[{begin:"\\b(abs|acos|asin|atan|atan2|atanh|ceil|cloglog|comb|cos|digamma|exp|floor|invcloglog|invlogit|ln|lnfact|lnfactorial|lngamma|log|log10|max|min|mod|reldif|round|sign|sin|sqrt|sum|tan|tanh|trigamma|trunc|betaden|Binomial|binorm|binormal|chi2|chi2tail|dgammapda|dgammapdada|dgammapdadx|dgammapdx|dgammapdxdx|F|Fden|Ftail|gammaden|gammap|ibeta|invbinomial|invchi2|invchi2tail|invF|invFtail|invgammap|invibeta|invnchi2|invnFtail|invnibeta|invnorm|invnormal|invttail|nbetaden|nchi2|nFden|nFtail|nibeta|norm|normal|normalden|normd|npnchi2|tden|ttail|uniform|abbrev|char|index|indexnot|length|lower|ltrim|match|plural|proper|real|regexm|regexr|regexs|reverse|rtrim|string|strlen|strlower|strltrim|strmatch|strofreal|strpos|strproper|strreverse|strrtrim|strtrim|strupper|subinstr|subinword|substr|trim|upper|word|wordcount|_caller|autocode|byteorder|chop|clip|cond|e|epsdouble|epsfloat|group|inlist|inrange|irecode|matrix|maxbyte|maxdouble|maxfloat|maxint|maxlong|mi|minbyte|mindouble|minfloat|minint|minlong|missing|r|recode|replay|return|s|scalar|d|date|day|dow|doy|halfyear|mdy|month|quarter|week|year|d|daily|dofd|dofh|dofm|dofq|dofw|dofy|h|halfyearly|hofd|m|mofd|monthly|q|qofd|quarterly|tin|twithin|w|weekly|wofd|y|yearly|yh|ym|yofd|yq|yw|cholesky|colnumb|colsof|corr|det|diag|diag0cnt|el|get|hadamard|I|inv|invsym|issym|issymmetric|J|matmissing|matuniform|mreldif|nullmat|rownumb|rowsof|sweep|syminv|trace|vec|vecdiag)(?=\\(|$)"}]},hljs.COMMENT("^[ \t]*\\*.*$",!1),hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE]}}),hljs.registerLanguage("step21",function(hljs){var STEP21_IDENT_RE="[A-Z_][A-Z0-9_.]*",STEP21_CLOSE_RE="END-ISO-10303-21;",STEP21_KEYWORDS={literal:"",built_in:"",keyword:"HEADER ENDSEC DATA"},STEP21_START={className:"preprocessor",begin:"ISO-10303-21;",relevance:10},STEP21_CODE=[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,hljs.COMMENT("/\\*\\*!","\\*/"),hljs.C_NUMBER_MODE,hljs.inherit(hljs.APOS_STRING_MODE,{illegal:null}),hljs.inherit(hljs.QUOTE_STRING_MODE,{illegal:null}),{className:"string",begin:"'",end:"'"},{className:"label",variants:[{begin:"#",end:"\\d+",illegal:"\\W"}]}];return{aliases:["p21","step","stp"],case_insensitive:!0,lexemes:STEP21_IDENT_RE,keywords:STEP21_KEYWORDS,contains:[{className:"preprocessor",begin:STEP21_CLOSE_RE,relevance:10},STEP21_START].concat(STEP21_CODE)}}),hljs.registerLanguage("stylus",function(hljs){var VARIABLE={className:"variable",begin:"\\$"+hljs.IDENT_RE},HEX_COLOR={className:"hexcolor",begin:"#([a-fA-F0-9]{6}|[a-fA-F0-9]{3})",relevance:10},AT_KEYWORDS=["charset","css","debug","extend","font-face","for","import","include","media","mixin","page","warn","while"],PSEUDO_SELECTORS=["after","before","first-letter","first-line","active","first-child","focus","hover","lang","link","visited"],TAGS=["a","abbr","address","article","aside","audio","b","blockquote","body","button","canvas","caption","cite","code","dd","del","details","dfn","div","dl","dt","em","fieldset","figcaption","figure","footer","form","h1","h2","h3","h4","h5","h6","header","hgroup","html","i","iframe","img","input","ins","kbd","label","legend","li","mark","menu","nav","object","ol","p","q","quote","samp","section","span","strong","summary","sup","table","tbody","td","textarea","tfoot","th","thead","time","tr","ul","var","video"],TAG_END="[\\.\\s\\n\\[\\:,]",ATTRIBUTES=["align-content","align-items","align-self","animation","animation-delay","animation-direction","animation-duration","animation-fill-mode","animation-iteration-count","animation-name","animation-play-state","animation-timing-function","auto","backface-visibility","background","background-attachment","background-clip","background-color","background-image","background-origin","background-position","background-repeat","background-size","border","border-bottom","border-bottom-color","border-bottom-left-radius","border-bottom-right-radius","border-bottom-style","border-bottom-width","border-collapse","border-color","border-image","border-image-outset","border-image-repeat","border-image-slice","border-image-source","border-image-width","border-left","border-left-color","border-left-style","border-left-width","border-radius","border-right","border-right-color","border-right-style","border-right-width","border-spacing","border-style","border-top","border-top-color","border-top-left-radius","border-top-right-radius","border-top-style","border-top-width","border-width","bottom","box-decoration-break","box-shadow","box-sizing","break-after","break-before","break-inside","caption-side","clear","clip","clip-path","color","column-count","column-fill","column-gap","column-rule","column-rule-color","column-rule-style","column-rule-width","column-span","column-width","columns","content","counter-increment","counter-reset","cursor","direction","display","empty-cells","filter","flex","flex-basis","flex-direction","flex-flow","flex-grow","flex-shrink","flex-wrap","float","font","font-family","font-feature-settings","font-kerning","font-language-override","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-variant-ligatures","font-weight","height","hyphens","icon","image-orientation","image-rendering","image-resolution","ime-mode","inherit","initial","justify-content","left","letter-spacing","line-height","list-style","list-style-image","list-style-position","list-style-type","margin","margin-bottom","margin-left","margin-right","margin-top","marks","mask","max-height","max-width","min-height","min-width","nav-down","nav-index","nav-left","nav-right","nav-up","none","normal","object-fit","object-position","opacity","order","orphans","outline","outline-color","outline-offset","outline-style","outline-width","overflow","overflow-wrap","overflow-x","overflow-y","padding","padding-bottom","padding-left","padding-right","padding-top","page-break-after","page-break-before","page-break-inside","perspective","perspective-origin","pointer-events","position","quotes","resize","right","tab-size","table-layout","text-align","text-align-last","text-decoration","text-decoration-color","text-decoration-line","text-decoration-style","text-indent","text-overflow","text-rendering","text-shadow","text-transform","text-underline-position","top","transform","transform-origin","transform-style","transition","transition-delay","transition-duration","transition-property","transition-timing-function","unicode-bidi","vertical-align","visibility","white-space","widows","width","word-break","word-spacing","word-wrap","z-index"],ILLEGAL=["\\{","\\}","\\?","(\\bReturn\\b)","(\\bEnd\\b)","(\\bend\\b)",";","#\\s","\\*\\s","===\\s","\\|","%"];
return{aliases:["styl"],case_insensitive:!1,illegal:"("+ILLEGAL.join("|")+")",keywords:"if else for in",contains:[hljs.QUOTE_STRING_MODE,hljs.APOS_STRING_MODE,hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,HEX_COLOR,{begin:"\\.[a-zA-Z][a-zA-Z0-9_-]*"+TAG_END,returnBegin:!0,contains:[{className:"class",begin:"\\.[a-zA-Z][a-zA-Z0-9_-]*"}]},{begin:"\\#[a-zA-Z][a-zA-Z0-9_-]*"+TAG_END,returnBegin:!0,contains:[{className:"id",begin:"\\#[a-zA-Z][a-zA-Z0-9_-]*"}]},{begin:"\\b("+TAGS.join("|")+")"+TAG_END,returnBegin:!0,contains:[{className:"tag",begin:"\\b[a-zA-Z][a-zA-Z0-9_-]*"}]},{className:"pseudo",begin:"&?:?:\\b("+PSEUDO_SELECTORS.join("|")+")"+TAG_END},{className:"at_rule",begin:"@("+AT_KEYWORDS.join("|")+")\\b"},VARIABLE,hljs.CSS_NUMBER_MODE,hljs.NUMBER_MODE,{className:"function",begin:"\\b[a-zA-Z][a-zA-Z0-9_-]*\\(.*\\)",illegal:"[\\n]",returnBegin:!0,contains:[{className:"title",begin:"\\b[a-zA-Z][a-zA-Z0-9_-]*"},{className:"params",begin:/\(/,end:/\)/,contains:[HEX_COLOR,VARIABLE,hljs.APOS_STRING_MODE,hljs.CSS_NUMBER_MODE,hljs.NUMBER_MODE,hljs.QUOTE_STRING_MODE]}]},{className:"attribute",begin:"\\b("+ATTRIBUTES.reverse().join("|")+")\\b"}]}}),hljs.registerLanguage("swift",function(hljs){var SWIFT_KEYWORDS={keyword:"__COLUMN__ __FILE__ __FUNCTION__ __LINE__ as as! as? associativity break case catch class continue convenience default defer deinit didSet do dynamic dynamicType else enum extension fallthrough false final for func get guard if import in indirect infix init inout internal is lazy left let mutating nil none nonmutating operator optional override postfix precedence prefix private protocol Protocol public repeat required rethrows return right self Self set static struct subscript super switch throw throws true try try! try? Type typealias unowned var weak where while willSet",literal:"true false nil",built_in:"abs advance alignof alignofValue anyGenerator assert assertionFailure bridgeFromObjectiveC bridgeFromObjectiveCUnconditional bridgeToObjectiveC bridgeToObjectiveCUnconditional c contains count countElements countLeadingZeros debugPrint debugPrintln distance dropFirst dropLast dump encodeBitsAsWords enumerate equal fatalError filter find getBridgedObjectiveCType getVaList indices insertionSort isBridgedToObjectiveC isBridgedVerbatimToObjectiveC isUniquelyReferenced isUniquelyReferencedNonObjC join lazy lexicographicalCompare map max maxElement min minElement numericCast overlaps partition posix precondition preconditionFailure print println quickSort readLine reduce reflect reinterpretCast reverse roundUpToAlignment sizeof sizeofValue sort split startsWith stride strideof strideofValue swap toString transcode underestimateCount unsafeAddressOf unsafeBitCast unsafeDowncast unsafeUnwrap unsafeReflect withExtendedLifetime withObjectAtPlusZero withUnsafePointer withUnsafePointerToObject withUnsafeMutablePointer withUnsafeMutablePointers withUnsafePointer withUnsafePointers withVaList zip"},TYPE={className:"type",begin:"\\b[A-Z][\\w']*",relevance:0},BLOCK_COMMENT=hljs.COMMENT("/\\*","\\*/",{contains:["self"]}),SUBST={className:"subst",begin:/\\\(/,end:"\\)",keywords:SWIFT_KEYWORDS,contains:[]},NUMBERS={className:"number",begin:"\\b([\\d_]+(\\.[\\deE_]+)?|0x[a-fA-F0-9_]+(\\.[a-fA-F0-9p_]+)?|0b[01_]+|0o[0-7_]+)\\b",relevance:0},QUOTE_STRING_MODE=hljs.inherit(hljs.QUOTE_STRING_MODE,{contains:[SUBST,hljs.BACKSLASH_ESCAPE]});return SUBST.contains=[NUMBERS],{keywords:SWIFT_KEYWORDS,contains:[QUOTE_STRING_MODE,hljs.C_LINE_COMMENT_MODE,BLOCK_COMMENT,TYPE,NUMBERS,{className:"func",beginKeywords:"func",end:"{",excludeEnd:!0,contains:[hljs.inherit(hljs.TITLE_MODE,{begin:/[A-Za-z$_][0-9A-Za-z$_]*/,illegal:/\(/}),{className:"generics",begin:/</,end:/>/,illegal:/>/},{className:"params",begin:/\(/,end:/\)/,endsParent:!0,keywords:SWIFT_KEYWORDS,contains:["self",NUMBERS,QUOTE_STRING_MODE,hljs.C_BLOCK_COMMENT_MODE,{begin:":"}],illegal:/["']/}],illegal:/\[|%/},{className:"class",beginKeywords:"struct protocol class extension enum",keywords:SWIFT_KEYWORDS,end:"\\{",excludeEnd:!0,contains:[hljs.inherit(hljs.TITLE_MODE,{begin:/[A-Za-z$_][0-9A-Za-z$_]*/})]},{className:"preprocessor",begin:"(@warn_unused_result|@exported|@lazy|@noescape|@NSCopying|@NSManaged|@objc|@convention|@required|@noreturn|@IBAction|@IBDesignable|@IBInspectable|@IBOutlet|@infix|@prefix|@postfix|@autoclosure|@testable|@available|@nonobjc|@NSApplicationMain|@UIApplicationMain)"},{beginKeywords:"import",end:/$/,contains:[hljs.C_LINE_COMMENT_MODE,BLOCK_COMMENT]}]}}),hljs.registerLanguage("tcl",function(hljs){return{aliases:["tk"],keywords:"after append apply array auto_execok auto_import auto_load auto_mkindex auto_mkindex_old auto_qualify auto_reset bgerror binary break catch cd chan clock close concat continue dde dict encoding eof error eval exec exit expr fblocked fconfigure fcopy file fileevent filename flush for foreach format gets glob global history http if incr info interp join lappend|10 lassign|10 lindex|10 linsert|10 list llength|10 load lrange|10 lrepeat|10 lreplace|10 lreverse|10 lsearch|10 lset|10 lsort|10 mathfunc mathop memory msgcat namespace open package parray pid pkg::create pkg_mkIndex platform platform::shell proc puts pwd read refchan regexp registry regsub|10 rename return safe scan seek set socket source split string subst switch tcl_endOfWord tcl_findLibrary tcl_startOfNextWord tcl_startOfPreviousWord tcl_wordBreakAfter tcl_wordBreakBefore tcltest tclvars tell time tm trace unknown unload unset update uplevel upvar variable vwait while",contains:[hljs.COMMENT(";[ \\t]*#","$"),hljs.COMMENT("^[ \\t]*#","$"),{beginKeywords:"proc",end:"[\\{]",excludeEnd:!0,contains:[{className:"symbol",begin:"[ \\t\\n\\r]+(::)?[a-zA-Z_]((::)?[a-zA-Z0-9_])*",end:"[ \\t\\n\\r]",endsWithParent:!0,excludeEnd:!0}]},{className:"variable",excludeEnd:!0,variants:[{begin:"\\$(\\{)?(::)?[a-zA-Z_]((::)?[a-zA-Z0-9_])*\\(([a-zA-Z0-9_])*\\)",end:"[^a-zA-Z0-9_\\}\\$]"},{begin:"\\$(\\{)?(::)?[a-zA-Z_]((::)?[a-zA-Z0-9_])*",end:"(\\))?[^a-zA-Z0-9_\\}\\$]"}]},{className:"string",contains:[hljs.BACKSLASH_ESCAPE],variants:[hljs.inherit(hljs.APOS_STRING_MODE,{illegal:null}),hljs.inherit(hljs.QUOTE_STRING_MODE,{illegal:null})]},{className:"number",variants:[hljs.BINARY_NUMBER_MODE,hljs.C_NUMBER_MODE]}]}}),hljs.registerLanguage("tex",function(hljs){var COMMAND1={className:"command",begin:"\\\\[a-zA-Zа-яА-я]+[\\*]?"},COMMAND2={className:"command",begin:"\\\\[^a-zA-Zа-яА-я0-9]"},SPECIAL={className:"special",begin:"[{}\\[\\]\\&#~]",relevance:0};return{contains:[{begin:"\\\\[a-zA-Zа-яА-я]+[\\*]? *= *-?\\d*\\.?\\d+(pt|pc|mm|cm|in|dd|cc|ex|em)?",returnBegin:!0,contains:[COMMAND1,COMMAND2,{className:"number",begin:" *=",end:"-?\\d*\\.?\\d+(pt|pc|mm|cm|in|dd|cc|ex|em)?",excludeBegin:!0}],relevance:10},COMMAND1,COMMAND2,SPECIAL,{className:"formula",begin:"\\$\\$",end:"\\$\\$",contains:[COMMAND1,COMMAND2,SPECIAL],relevance:0},{className:"formula",begin:"\\$",end:"\\$",contains:[COMMAND1,COMMAND2,SPECIAL],relevance:0},hljs.COMMENT("%","$",{relevance:0})]}}),hljs.registerLanguage("thrift",function(hljs){var BUILT_IN_TYPES="bool byte i16 i32 i64 double string binary";return{keywords:{keyword:"namespace const typedef struct enum service exception void oneway set list map required optional",built_in:BUILT_IN_TYPES,literal:"true false"},contains:[hljs.QUOTE_STRING_MODE,hljs.NUMBER_MODE,hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,{className:"class",beginKeywords:"struct enum service exception",end:/\{/,illegal:/\n/,contains:[hljs.inherit(hljs.TITLE_MODE,{starts:{endsWithParent:!0,excludeEnd:!0}})]},{begin:"\\b(set|list|map)\\s*<",end:">",keywords:BUILT_IN_TYPES,contains:["self"]}]}}),hljs.registerLanguage("tp",function(hljs){var TPID={className:"number",begin:"[1-9][0-9]*",relevance:0},TPLABEL={className:"comment",begin:":[^\\]]+"},TPDATA={className:"built_in",begin:"(AR|P|PAYLOAD|PR|R|SR|RSR|LBL|VR|UALM|MESSAGE|UTOOL|UFRAME|TIMER|    TIMER_OVERFLOW|JOINT_MAX_SPEED|RESUME_PROG|DIAG_REC)\\[",end:"\\]",contains:["self",TPID,TPLABEL]},TPIO={className:"built_in",begin:"(AI|AO|DI|DO|F|RI|RO|UI|UO|GI|GO|SI|SO)\\[",end:"\\]",contains:["self",TPID,hljs.QUOTE_STRING_MODE,TPLABEL]};return{keywords:{keyword:"ABORT ACC ADJUST AND AP_LD BREAK CALL CNT COL CONDITION CONFIG DA DB DIV DETECT ELSE END ENDFOR ERR_NUM ERROR_PROG FINE FOR GP GUARD INC IF JMP LINEAR_MAX_SPEED LOCK MOD MONITOR OFFSET Offset OR OVERRIDE PAUSE PREG PTH RT_LD RUN SELECT SKIP Skip TA TB TO TOOL_OFFSET Tool_Offset UF UT UFRAME_NUM UTOOL_NUM UNLOCK WAIT X Y Z W P R STRLEN SUBSTR FINDSTR VOFFSET",constant:"ON OFF max_speed LPOS JPOS ENABLE DISABLE START STOP RESET"},contains:[TPDATA,TPIO,{className:"keyword",begin:"/(PROG|ATTR|MN|POS|END)\\b"},{className:"keyword",begin:"(CALL|RUN|POINT_LOGIC|LBL)\\b"},{className:"keyword",begin:"\\b(ACC|CNT|Skip|Offset|PSPD|RT_LD|AP_LD|Tool_Offset)"},{className:"number",begin:"\\d+(sec|msec|mm/sec|cm/min|inch/min|deg/sec|mm|in|cm)?\\b",relevance:0},hljs.COMMENT("//","[;$]"),hljs.COMMENT("!","[;$]"),hljs.COMMENT("--eg:","$"),hljs.QUOTE_STRING_MODE,{className:"string",begin:"'",end:"'"},hljs.C_NUMBER_MODE,{className:"variable",begin:"\\$[A-Za-z0-9_]+"}]}}),hljs.registerLanguage("twig",function(hljs){var PARAMS={className:"params",begin:"\\(",end:"\\)"},FUNCTION_NAMES="attribute block constant cycle date dump include max min parent random range source template_from_string",FUNCTIONS={className:"function",beginKeywords:FUNCTION_NAMES,relevance:0,contains:[PARAMS]},FILTER={className:"filter",begin:/\|[A-Za-z_]+:?/,keywords:"abs batch capitalize convert_encoding date date_modify default escape first format join json_encode keys last length lower merge nl2br number_format raw replace reverse round slice sort split striptags title trim upper url_encode",contains:[FUNCTIONS]},TAGS="autoescape block do embed extends filter flush for if import include macro sandbox set spaceless use verbatim";return TAGS=TAGS+" "+TAGS.split(" ").map(function(t){return"end"+t}).join(" "),{aliases:["craftcms"],case_insensitive:!0,subLanguage:"xml",contains:[hljs.COMMENT(/\{#/,/#}/),{className:"template_tag",begin:/\{%/,end:/%}/,keywords:TAGS,contains:[FILTER,FUNCTIONS]},{className:"variable",begin:/\{\{/,end:/}}/,contains:[FILTER,FUNCTIONS]}]}}),hljs.registerLanguage("typescript",function(hljs){var KEYWORDS={keyword:"in if for while finally var new function|0 do return void else break catch instanceof with throw case default try this switch continue typeof delete let yield const class public private protected get set super static implements enum export import declare type namespace abstract",literal:"true false null undefined NaN Infinity",built_in:"eval isFinite isNaN parseFloat parseInt decodeURI decodeURIComponent encodeURI encodeURIComponent escape unescape Object Function Boolean Error EvalError InternalError RangeError ReferenceError StopIteration SyntaxError TypeError URIError Number Math Date String RegExp Array Float32Array Float64Array Int16Array Int32Array Int8Array Uint16Array Uint32Array Uint8Array Uint8ClampedArray ArrayBuffer DataView JSON Intl arguments require module console window document any number boolean string void"};return{aliases:["ts"],keywords:KEYWORDS,contains:[{className:"pi",begin:/^\s*['"]use strict['"]/,relevance:0},hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,{className:"number",variants:[{begin:"\\b(0[bB][01]+)"},{begin:"\\b(0[oO][0-7]+)"},{begin:hljs.C_NUMBER_RE}],relevance:0},{begin:"("+hljs.RE_STARTERS_RE+"|\\b(case|return|throw)\\b)\\s*",keywords:"return throw case",contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,hljs.REGEXP_MODE],relevance:0},{className:"function",begin:"function",end:/[\{;]/,excludeEnd:!0,keywords:KEYWORDS,contains:["self",hljs.inherit(hljs.TITLE_MODE,{begin:/[A-Za-z$_][0-9A-Za-z$_]*/}),{className:"params",begin:/\(/,end:/\)/,excludeBegin:!0,excludeEnd:!0,keywords:KEYWORDS,contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE],illegal:/["'\(]/}],illegal:/\[|%/,relevance:0},{className:"constructor",beginKeywords:"constructor",end:/\{/,excludeEnd:!0,relevance:10},{className:"module",beginKeywords:"module",end:/\{/,excludeEnd:!0},{className:"interface",beginKeywords:"interface",end:/\{/,excludeEnd:!0,keywords:"interface extends"},{begin:/\$[(.]/},{begin:"\\."+hljs.IDENT_RE,relevance:0}]}}),hljs.registerLanguage("vala",function(hljs){return{keywords:{keyword:"char uchar unichar int uint long ulong short ushort int8 int16 int32 int64 uint8 uint16 uint32 uint64 float double bool struct enum string void weak unowned owned async signal static abstract interface override while do for foreach else switch case break default return try catch public private protected internal using new this get set const stdout stdin stderr var",built_in:"DBus GLib CCode Gee Object",literal:"false true null"},contains:[{className:"class",beginKeywords:"class interface delegate namespace",end:"{",excludeEnd:!0,illegal:"[^,:\\n\\s\\.]",contains:[hljs.UNDERSCORE_TITLE_MODE]},hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,{className:"string",begin:'"""',end:'"""',relevance:5},hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.C_NUMBER_MODE,{className:"preprocessor",begin:"^#",end:"$",relevance:2},{className:"constant",begin:" [A-Z_]+ ",relevance:0}]}}),hljs.registerLanguage("vbnet",function(hljs){return{aliases:["vb"],case_insensitive:!0,keywords:{keyword:"addhandler addressof alias and andalso aggregate ansi as assembly auto binary by byref byval call case catch class compare const continue custom declare default delegate dim distinct do each equals else elseif end enum erase error event exit explicit finally for friend from function get global goto group handles if implements imports in inherits interface into is isfalse isnot istrue join key let lib like loop me mid mod module mustinherit mustoverride mybase myclass namespace narrowing new next not notinheritable notoverridable of off on operator option optional or order orelse overloads overridable overrides paramarray partial preserve private property protected public raiseevent readonly redim rem removehandler resume return select set shadows shared skip static step stop structure strict sub synclock take text then throw to try unicode until using when where while widening with withevents writeonly xor",built_in:"boolean byte cbool cbyte cchar cdate cdec cdbl char cint clng cobj csbyte cshort csng cstr ctype date decimal directcast double gettype getxmlnamespace iif integer long object sbyte short single string trycast typeof uinteger ulong ushort",literal:"true false nothing"},illegal:"//|{|}|endif|gosub|variant|wend",contains:[hljs.inherit(hljs.QUOTE_STRING_MODE,{contains:[{begin:'""'}]}),hljs.COMMENT("'","$",{returnBegin:!0,contains:[{className:"xmlDocTag",begin:"'''|<!--|-->",contains:[hljs.PHRASAL_WORDS_MODE]},{className:"xmlDocTag",begin:"</?",end:">",contains:[hljs.PHRASAL_WORDS_MODE]}]}),hljs.C_NUMBER_MODE,{className:"preprocessor",begin:"#",end:"$",keywords:"if else elseif end region externalsource"}]}}),hljs.registerLanguage("vbscript",function(hljs){return{aliases:["vbs"],case_insensitive:!0,keywords:{keyword:"call class const dim do loop erase execute executeglobal exit for each next function if then else on error option explicit new private property let get public randomize redim rem select case set stop sub while wend with end to elseif is or xor and not class_initialize class_terminate default preserve in me byval byref step resume goto",built_in:"lcase month vartype instrrev ubound setlocale getobject rgb getref string weekdayname rnd dateadd monthname now day minute isarray cbool round formatcurrency conversions csng timevalue second year space abs clng timeserial fixs len asc isempty maths dateserial atn timer isobject filter weekday datevalue ccur isdate instr datediff formatdatetime replace isnull right sgn array snumeric log cdbl hex chr lbound msgbox ucase getlocale cos cdate cbyte rtrim join hour oct typename trim strcomp int createobject loadpicture tan formatnumber mid scriptenginebuildversion scriptengine split scriptengineminorversion cint sin datepart ltrim sqr scriptenginemajorversion time derived eval date formatpercent exp inputbox left ascw chrw regexp server response request cstr err",literal:"true false null nothing empty"},illegal:"//",contains:[hljs.inherit(hljs.QUOTE_STRING_MODE,{contains:[{begin:'""'}]}),hljs.COMMENT(/'/,/$/,{relevance:0}),hljs.C_NUMBER_MODE]}}),hljs.registerLanguage("vbscript-html",function(hljs){return{subLanguage:"xml",contains:[{begin:"<%",end:"%>",subLanguage:"vbscript"}]}}),hljs.registerLanguage("verilog",function(hljs){return{aliases:["v"],case_insensitive:!0,keywords:{keyword:"always and assign begin buf bufif0 bufif1 case casex casez cmos deassign default defparam disable edge else end endcase endfunction endmodule endprimitive endspecify endtable endtask event for force forever fork function if ifnone initial inout input join macromodule module nand negedge nmos nor not notif0 notif1 or output parameter pmos posedge primitive pulldown pullup rcmos release repeat rnmos rpmos rtran rtranif0 rtranif1 specify specparam table task timescale tran tranif0 tranif1 wait while xnor xor",typename:"highz0 highz1 integer large medium pull0 pull1 real realtime reg scalared signed small strong0 strong1 supply0 supply0 supply1 supply1 time tri tri0 tri1 triand trior trireg vectored wand weak0 weak1 wire wor"},contains:[hljs.C_BLOCK_COMMENT_MODE,hljs.C_LINE_COMMENT_MODE,hljs.QUOTE_STRING_MODE,{className:"number",begin:"\\b(\\d+'(b|h|o|d|B|H|O|D))?[0-9xzXZ]+",contains:[hljs.BACKSLASH_ESCAPE],relevance:0},{className:"typename",begin:"\\.\\w+",relevance:0},{className:"value",begin:"#\\((?!parameter).+\\)"},{className:"keyword",begin:"\\+|-|\\*|/|%|<|>|=|#|`|\\!|&|\\||@|:|\\^|~|\\{|\\}",relevance:0}]}}),hljs.registerLanguage("vhdl",function(hljs){var INTEGER_RE="\\d(_|\\d)*",EXPONENT_RE="[eE][-+]?"+INTEGER_RE,DECIMAL_LITERAL_RE=INTEGER_RE+"(\\."+INTEGER_RE+")?("+EXPONENT_RE+")?",BASED_INTEGER_RE="\\w+",BASED_LITERAL_RE=INTEGER_RE+"#"+BASED_INTEGER_RE+"(\\."+BASED_INTEGER_RE+")?#("+EXPONENT_RE+")?",NUMBER_RE="\\b("+BASED_LITERAL_RE+"|"+DECIMAL_LITERAL_RE+")";return{case_insensitive:!0,keywords:{keyword:"abs access after alias all and architecture array assert attribute begin block body buffer bus case component configuration constant context cover disconnect downto default else elsif end entity exit fairness file for force function generate generic group guarded if impure in inertial inout is label library linkage literal loop map mod nand new next nor not null of on open or others out package port postponed procedure process property protected pure range record register reject release rem report restrict restrict_guarantee return rol ror select sequence severity shared signal sla sll sra srl strong subtype then to transport type unaffected units until use variable vmode vprop vunit wait when while with xnor xor",typename:"boolean bit character severity_level integer time delay_length natural positive string bit_vector file_open_kind file_open_status std_ulogic std_ulogic_vector std_logic std_logic_vector unsigned signed boolean_vector integer_vector real_vector time_vector"},illegal:"{",contains:[hljs.C_BLOCK_COMMENT_MODE,hljs.COMMENT("--","$"),hljs.QUOTE_STRING_MODE,{className:"number",begin:NUMBER_RE,relevance:0},{className:"literal",begin:"'(U|X|0|1|Z|W|L|H|-)'",contains:[hljs.BACKSLASH_ESCAPE]},{className:"attribute",begin:"'[A-Za-z](_?[A-Za-z0-9])*",contains:[hljs.BACKSLASH_ESCAPE]}]}}),hljs.registerLanguage("vim",function(hljs){return{lexemes:/[!#@\w]+/,keywords:{keyword:"N|0 P|0 X|0 a|0 ab abc abo al am an|0 ar arga argd arge argdo argg argl argu as au aug aun b|0 bN ba bad bd be bel bf bl bm bn bo bp br brea breaka breakd breakl bro bufdo buffers bun bw c|0 cN cNf ca cabc caddb cad caddf cal cat cb cc ccl cd ce cex cf cfir cgetb cgete cg changes chd che checkt cl cla clo cm cmapc cme cn cnew cnf cno cnorea cnoreme co col colo com comc comp con conf cope cp cpf cq cr cs cst cu cuna cunme cw d|0 delm deb debugg delc delf dif diffg diffo diffp diffpu diffs diffthis dig di dl dell dj dli do doautoa dp dr ds dsp e|0 ea ec echoe echoh echom echon el elsei em en endfo endf endt endw ene ex exe exi exu f|0 files filet fin fina fini fir fix fo foldc foldd folddoc foldo for fu g|0 go gr grepa gu gv ha h|0 helpf helpg helpt hi hid his i|0 ia iabc if ij il im imapc ime ino inorea inoreme int is isp iu iuna iunme j|0 ju k|0 keepa kee keepj lN lNf l|0 lad laddb laddf la lan lat lb lc lch lcl lcs le lefta let lex lf lfir lgetb lgete lg lgr lgrepa lh ll lla lli lmak lm lmapc lne lnew lnf ln loadk lo loc lockv lol lope lp lpf lr ls lt lu lua luad luaf lv lvimgrepa lw m|0 ma mak map mapc marks mat me menut mes mk mks mksp mkv mkvie mod mz mzf nbc nb nbs n|0 new nm nmapc nme nn nnoreme noa no noh norea noreme norm nu nun nunme ol o|0 om omapc ome on ono onoreme opt ou ounme ow p|0 profd prof pro promptr pc ped pe perld po popu pp pre prev ps pt ptN ptf ptj ptl ptn ptp ptr pts pu pw py3 python3 py3d py3f py pyd pyf q|0 quita qa r|0 rec red redi redr redraws reg res ret retu rew ri rightb rub rubyd rubyf rund ru rv s|0 sN san sa sal sav sb sbN sba sbf sbl sbm sbn sbp sbr scrip scripte scs se setf setg setl sf sfir sh sim sig sil sl sla sm smap smapc sme sn sni sno snor snoreme sor so spelld spe spelli spellr spellu spellw sp spr sre st sta startg startr star stopi stj sts sun sunm sunme sus sv sw sy synti sync t|0 tN tabN tabc tabdo tabe tabf tabfir tabl tabm tabnew tabn tabo tabp tabr tabs tab ta tags tc tcld tclf te tf th tj tl tm tn to tp tr try ts tu u|0 undoj undol una unh unl unlo unm unme uns up v|0 ve verb vert vim vimgrepa vi viu vie vm vmapc vme vne vn vnoreme vs vu vunme windo w|0 wN wa wh wi winc winp wn wp wq wqa ws wu wv x|0 xa xmapc xm xme xn xnoreme xu xunme y|0 z|0 ~ Next Print append abbreviate abclear aboveleft all amenu anoremenu args argadd argdelete argedit argglobal arglocal argument ascii autocmd augroup aunmenu buffer bNext ball badd bdelete behave belowright bfirst blast bmodified bnext botright bprevious brewind break breakadd breakdel breaklist browse bunload bwipeout change cNext cNfile cabbrev cabclear caddbuffer caddexpr caddfile call catch cbuffer cclose center cexpr cfile cfirst cgetbuffer cgetexpr cgetfile chdir checkpath checktime clist clast close cmap cmapclear cmenu cnext cnewer cnfile cnoremap cnoreabbrev cnoremenu copy colder colorscheme command comclear compiler continue confirm copen cprevious cpfile cquit crewind cscope cstag cunmap cunabbrev cunmenu cwindow delete delmarks debug debuggreedy delcommand delfunction diffupdate diffget diffoff diffpatch diffput diffsplit digraphs display deletel djump dlist doautocmd doautoall deletep drop dsearch dsplit edit earlier echo echoerr echohl echomsg else elseif emenu endif endfor endfunction endtry endwhile enew execute exit exusage file filetype find finally finish first fixdel fold foldclose folddoopen folddoclosed foldopen function global goto grep grepadd gui gvim hardcopy help helpfind helpgrep helptags highlight hide history insert iabbrev iabclear ijump ilist imap imapclear imenu inoremap inoreabbrev inoremenu intro isearch isplit iunmap iunabbrev iunmenu join jumps keepalt keepmarks keepjumps lNext lNfile list laddexpr laddbuffer laddfile last language later lbuffer lcd lchdir lclose lcscope left leftabove lexpr lfile lfirst lgetbuffer lgetexpr lgetfile lgrep lgrepadd lhelpgrep llast llist lmake lmap lmapclear lnext lnewer lnfile lnoremap loadkeymap loadview lockmarks lockvar lolder lopen lprevious lpfile lrewind ltag lunmap luado luafile lvimgrep lvimgrepadd lwindow move mark make mapclear match menu menutranslate messages mkexrc mksession mkspell mkvimrc mkview mode mzscheme mzfile nbclose nbkey nbsart next nmap nmapclear nmenu nnoremap nnoremenu noautocmd noremap nohlsearch noreabbrev noremenu normal number nunmap nunmenu oldfiles open omap omapclear omenu only onoremap onoremenu options ounmap ounmenu ownsyntax print profdel profile promptfind promptrepl pclose pedit perl perldo pop popup ppop preserve previous psearch ptag ptNext ptfirst ptjump ptlast ptnext ptprevious ptrewind ptselect put pwd py3do py3file python pydo pyfile quit quitall qall read recover redo redir redraw redrawstatus registers resize retab return rewind right rightbelow ruby rubydo rubyfile rundo runtime rviminfo substitute sNext sandbox sargument sall saveas sbuffer sbNext sball sbfirst sblast sbmodified sbnext sbprevious sbrewind scriptnames scriptencoding scscope set setfiletype setglobal setlocal sfind sfirst shell simalt sign silent sleep slast smagic smapclear smenu snext sniff snomagic snoremap snoremenu sort source spelldump spellgood spellinfo spellrepall spellundo spellwrong split sprevious srewind stop stag startgreplace startreplace startinsert stopinsert stjump stselect sunhide sunmap sunmenu suspend sview swapname syntax syntime syncbind tNext tabNext tabclose tabedit tabfind tabfirst tablast tabmove tabnext tabonly tabprevious tabrewind tag tcl tcldo tclfile tearoff tfirst throw tjump tlast tmenu tnext topleft tprevious trewind tselect tunmenu undo undojoin undolist unabbreviate unhide unlet unlockvar unmap unmenu unsilent update vglobal version verbose vertical vimgrep vimgrepadd visual viusage view vmap vmapclear vmenu vnew vnoremap vnoremenu vsplit vunmap vunmenu write wNext wall while winsize wincmd winpos wnext wprevious wqall wsverb wundo wviminfo xit xall xmapclear xmap xmenu xnoremap xnoremenu xunmap xunmenu yank",built_in:"abs acos add and append argc argidx argv asin atan atan2 browse browsedir bufexists buflisted bufloaded bufname bufnr bufwinnr byte2line byteidx call ceil changenr char2nr cindent clearmatches col complete complete_add complete_check confirm copy cos cosh count cscope_connection cursor deepcopy delete did_filetype diff_filler diff_hlID empty escape eval eventhandler executable exists exp expand extend feedkeys filereadable filewritable filter finddir findfile float2nr floor fmod fnameescape fnamemodify foldclosed foldclosedend foldlevel foldtext foldtextresult foreground function garbagecollect get getbufline getbufvar getchar getcharmod getcmdline getcmdpos getcmdtype getcwd getfontname getfperm getfsize getftime getftype getline getloclist getmatches getpid getpos getqflist getreg getregtype gettabvar gettabwinvar getwinposx getwinposy getwinvar glob globpath has has_key haslocaldir hasmapto histadd histdel histget histnr hlexists hlID hostname iconv indent index input inputdialog inputlist inputrestore inputsave inputsecret insert invert isdirectory islocked items join keys len libcall libcallnr line line2byte lispindent localtime log log10 luaeval map maparg mapcheck match matchadd matcharg matchdelete matchend matchlist matchstr max min mkdir mode mzeval nextnonblank nr2char or pathshorten pow prevnonblank printf pumvisible py3eval pyeval range readfile reltime reltimestr remote_expr remote_foreground remote_peek remote_read remote_send remove rename repeat resolve reverse round screenattr screenchar screencol screenrow search searchdecl searchpair searchpairpos searchpos server2client serverlist setbufvar setcmdpos setline setloclist setmatches setpos setqflist setreg settabvar settabwinvar setwinvar sha256 shellescape shiftwidth simplify sin sinh sort soundfold spellbadword spellsuggest split sqrt str2float str2nr strchars strdisplaywidth strftime stridx string strlen strpart strridx strtrans strwidth submatch substitute synconcealed synID synIDattr synIDtrans synstack system tabpagebuflist tabpagenr tabpagewinnr tagfiles taglist tan tanh tempname tolower toupper tr trunc type undofile undotree values virtcol visualmode wildmenumode winbufnr wincol winheight winline winnr winrestcmd winrestview winsaveview winwidth writefile xor"},illegal:/[{:]/,contains:[hljs.NUMBER_MODE,hljs.APOS_STRING_MODE,{className:"string",begin:/"((\\")|[^"\n])*("|\n)/},{className:"variable",begin:/[bwtglsav]:[\w\d_]*/},{className:"function",beginKeywords:"function function!",end:"$",relevance:0,contains:[hljs.TITLE_MODE,{className:"params",begin:"\\(",end:"\\)"}]}]}}),hljs.registerLanguage("x86asm",function(hljs){return{case_insensitive:!0,lexemes:"\\.?"+hljs.IDENT_RE,keywords:{keyword:"lock rep repe repz repne repnz xaquire xrelease bnd nobnd aaa aad aam aas adc add and arpl bb0_reset bb1_reset bound bsf bsr bswap bt btc btr bts call cbw cdq cdqe clc cld cli clts cmc cmp cmpsb cmpsd cmpsq cmpsw cmpxchg cmpxchg486 cmpxchg8b cmpxchg16b cpuid cpu_read cpu_write cqo cwd cwde daa das dec div dmint emms enter equ f2xm1 fabs fadd faddp fbld fbstp fchs fclex fcmovb fcmovbe fcmove fcmovnb fcmovnbe fcmovne fcmovnu fcmovu fcom fcomi fcomip fcomp fcompp fcos fdecstp fdisi fdiv fdivp fdivr fdivrp femms feni ffree ffreep fiadd ficom ficomp fidiv fidivr fild fimul fincstp finit fist fistp fisttp fisub fisubr fld fld1 fldcw fldenv fldl2e fldl2t fldlg2 fldln2 fldpi fldz fmul fmulp fnclex fndisi fneni fninit fnop fnsave fnstcw fnstenv fnstsw fpatan fprem fprem1 fptan frndint frstor fsave fscale fsetpm fsin fsincos fsqrt fst fstcw fstenv fstp fstsw fsub fsubp fsubr fsubrp ftst fucom fucomi fucomip fucomp fucompp fxam fxch fxtract fyl2x fyl2xp1 hlt ibts icebp idiv imul in inc incbin insb insd insw int int01 int1 int03 int3 into invd invpcid invlpg invlpga iret iretd iretq iretw jcxz jecxz jrcxz jmp jmpe lahf lar lds lea leave les lfence lfs lgdt lgs lidt lldt lmsw loadall loadall286 lodsb lodsd lodsq lodsw loop loope loopne loopnz loopz lsl lss ltr mfence monitor mov movd movq movsb movsd movsq movsw movsx movsxd movzx mul mwait neg nop not or out outsb outsd outsw packssdw packsswb packuswb paddb paddd paddsb paddsiw paddsw paddusb paddusw paddw pand pandn pause paveb pavgusb pcmpeqb pcmpeqd pcmpeqw pcmpgtb pcmpgtd pcmpgtw pdistib pf2id pfacc pfadd pfcmpeq pfcmpge pfcmpgt pfmax pfmin pfmul pfrcp pfrcpit1 pfrcpit2 pfrsqit1 pfrsqrt pfsub pfsubr pi2fd pmachriw pmaddwd pmagw pmulhriw pmulhrwa pmulhrwc pmulhw pmullw pmvgezb pmvlzb pmvnzb pmvzb pop popa popad popaw popf popfd popfq popfw por prefetch prefetchw pslld psllq psllw psrad psraw psrld psrlq psrlw psubb psubd psubsb psubsiw psubsw psubusb psubusw psubw punpckhbw punpckhdq punpckhwd punpcklbw punpckldq punpcklwd push pusha pushad pushaw pushf pushfd pushfq pushfw pxor rcl rcr rdshr rdmsr rdpmc rdtsc rdtscp ret retf retn rol ror rdm rsdc rsldt rsm rsts sahf sal salc sar sbb scasb scasd scasq scasw sfence sgdt shl shld shr shrd sidt sldt skinit smi smint smintold smsw stc std sti stosb stosd stosq stosw str sub svdc svldt svts swapgs syscall sysenter sysexit sysret test ud0 ud1 ud2b ud2 ud2a umov verr verw fwait wbinvd wrshr wrmsr xadd xbts xchg xlatb xlat xor cmove cmovz cmovne cmovnz cmova cmovnbe cmovae cmovnb cmovb cmovnae cmovbe cmovna cmovg cmovnle cmovge cmovnl cmovl cmovnge cmovle cmovng cmovc cmovnc cmovo cmovno cmovs cmovns cmovp cmovpe cmovnp cmovpo je jz jne jnz ja jnbe jae jnb jb jnae jbe jna jg jnle jge jnl jl jnge jle jng jc jnc jo jno js jns jpo jnp jpe jp sete setz setne setnz seta setnbe setae setnb setnc setb setnae setcset setbe setna setg setnle setge setnl setl setnge setle setng sets setns seto setno setpe setp setpo setnp addps addss andnps andps cmpeqps cmpeqss cmpleps cmpless cmpltps cmpltss cmpneqps cmpneqss cmpnleps cmpnless cmpnltps cmpnltss cmpordps cmpordss cmpunordps cmpunordss cmpps cmpss comiss cvtpi2ps cvtps2pi cvtsi2ss cvtss2si cvttps2pi cvttss2si divps divss ldmxcsr maxps maxss minps minss movaps movhps movlhps movlps movhlps movmskps movntps movss movups mulps mulss orps rcpps rcpss rsqrtps rsqrtss shufps sqrtps sqrtss stmxcsr subps subss ucomiss unpckhps unpcklps xorps fxrstor fxrstor64 fxsave fxsave64 xgetbv xsetbv xsave xsave64 xsaveopt xsaveopt64 xrstor xrstor64 prefetchnta prefetcht0 prefetcht1 prefetcht2 maskmovq movntq pavgb pavgw pextrw pinsrw pmaxsw pmaxub pminsw pminub pmovmskb pmulhuw psadbw pshufw pf2iw pfnacc pfpnacc pi2fw pswapd maskmovdqu clflush movntdq movnti movntpd movdqa movdqu movdq2q movq2dq paddq pmuludq pshufd pshufhw pshuflw pslldq psrldq psubq punpckhqdq punpcklqdq addpd addsd andnpd andpd cmpeqpd cmpeqsd cmplepd cmplesd cmpltpd cmpltsd cmpneqpd cmpneqsd cmpnlepd cmpnlesd cmpnltpd cmpnltsd cmpordpd cmpordsd cmpunordpd cmpunordsd cmppd comisd cvtdq2pd cvtdq2ps cvtpd2dq cvtpd2pi cvtpd2ps cvtpi2pd cvtps2dq cvtps2pd cvtsd2si cvtsd2ss cvtsi2sd cvtss2sd cvttpd2pi cvttpd2dq cvttps2dq cvttsd2si divpd divsd maxpd maxsd minpd minsd movapd movhpd movlpd movmskpd movupd mulpd mulsd orpd shufpd sqrtpd sqrtsd subpd subsd ucomisd unpckhpd unpcklpd xorpd addsubpd addsubps haddpd haddps hsubpd hsubps lddqu movddup movshdup movsldup clgi stgi vmcall vmclear vmfunc vmlaunch vmload vmmcall vmptrld vmptrst vmread vmresume vmrun vmsave vmwrite vmxoff vmxon invept invvpid pabsb pabsw pabsd palignr phaddw phaddd phaddsw phsubw phsubd phsubsw pmaddubsw pmulhrsw pshufb psignb psignw psignd extrq insertq movntsd movntss lzcnt blendpd blendps blendvpd blendvps dppd dpps extractps insertps movntdqa mpsadbw packusdw pblendvb pblendw pcmpeqq pextrb pextrd pextrq phminposuw pinsrb pinsrd pinsrq pmaxsb pmaxsd pmaxud pmaxuw pminsb pminsd pminud pminuw pmovsxbw pmovsxbd pmovsxbq pmovsxwd pmovsxwq pmovsxdq pmovzxbw pmovzxbd pmovzxbq pmovzxwd pmovzxwq pmovzxdq pmuldq pmulld ptest roundpd roundps roundsd roundss crc32 pcmpestri pcmpestrm pcmpistri pcmpistrm pcmpgtq popcnt getsec pfrcpv pfrsqrtv movbe aesenc aesenclast aesdec aesdeclast aesimc aeskeygenassist vaesenc vaesenclast vaesdec vaesdeclast vaesimc vaeskeygenassist vaddpd vaddps vaddsd vaddss vaddsubpd vaddsubps vandpd vandps vandnpd vandnps vblendpd vblendps vblendvpd vblendvps vbroadcastss vbroadcastsd vbroadcastf128 vcmpeq_ospd vcmpeqpd vcmplt_ospd vcmpltpd vcmple_ospd vcmplepd vcmpunord_qpd vcmpunordpd vcmpneq_uqpd vcmpneqpd vcmpnlt_uspd vcmpnltpd vcmpnle_uspd vcmpnlepd vcmpord_qpd vcmpordpd vcmpeq_uqpd vcmpnge_uspd vcmpngepd vcmpngt_uspd vcmpngtpd vcmpfalse_oqpd vcmpfalsepd vcmpneq_oqpd vcmpge_ospd vcmpgepd vcmpgt_ospd vcmpgtpd vcmptrue_uqpd vcmptruepd vcmplt_oqpd vcmple_oqpd vcmpunord_spd vcmpneq_uspd vcmpnlt_uqpd vcmpnle_uqpd vcmpord_spd vcmpeq_uspd vcmpnge_uqpd vcmpngt_uqpd vcmpfalse_ospd vcmpneq_ospd vcmpge_oqpd vcmpgt_oqpd vcmptrue_uspd vcmppd vcmpeq_osps vcmpeqps vcmplt_osps vcmpltps vcmple_osps vcmpleps vcmpunord_qps vcmpunordps vcmpneq_uqps vcmpneqps vcmpnlt_usps vcmpnltps vcmpnle_usps vcmpnleps vcmpord_qps vcmpordps vcmpeq_uqps vcmpnge_usps vcmpngeps vcmpngt_usps vcmpngtps vcmpfalse_oqps vcmpfalseps vcmpneq_oqps vcmpge_osps vcmpgeps vcmpgt_osps vcmpgtps vcmptrue_uqps vcmptrueps vcmplt_oqps vcmple_oqps vcmpunord_sps vcmpneq_usps vcmpnlt_uqps vcmpnle_uqps vcmpord_sps vcmpeq_usps vcmpnge_uqps vcmpngt_uqps vcmpfalse_osps vcmpneq_osps vcmpge_oqps vcmpgt_oqps vcmptrue_usps vcmpps vcmpeq_ossd vcmpeqsd vcmplt_ossd vcmpltsd vcmple_ossd vcmplesd vcmpunord_qsd vcmpunordsd vcmpneq_uqsd vcmpneqsd vcmpnlt_ussd vcmpnltsd vcmpnle_ussd vcmpnlesd vcmpord_qsd vcmpordsd vcmpeq_uqsd vcmpnge_ussd vcmpngesd vcmpngt_ussd vcmpngtsd vcmpfalse_oqsd vcmpfalsesd vcmpneq_oqsd vcmpge_ossd vcmpgesd vcmpgt_ossd vcmpgtsd vcmptrue_uqsd vcmptruesd vcmplt_oqsd vcmple_oqsd vcmpunord_ssd vcmpneq_ussd vcmpnlt_uqsd vcmpnle_uqsd vcmpord_ssd vcmpeq_ussd vcmpnge_uqsd vcmpngt_uqsd vcmpfalse_ossd vcmpneq_ossd vcmpge_oqsd vcmpgt_oqsd vcmptrue_ussd vcmpsd vcmpeq_osss vcmpeqss vcmplt_osss vcmpltss vcmple_osss vcmpless vcmpunord_qss vcmpunordss vcmpneq_uqss vcmpneqss vcmpnlt_usss vcmpnltss vcmpnle_usss vcmpnless vcmpord_qss vcmpordss vcmpeq_uqss vcmpnge_usss vcmpngess vcmpngt_usss vcmpngtss vcmpfalse_oqss vcmpfalsess vcmpneq_oqss vcmpge_osss vcmpgess vcmpgt_osss vcmpgtss vcmptrue_uqss vcmptruess vcmplt_oqss vcmple_oqss vcmpunord_sss vcmpneq_usss vcmpnlt_uqss vcmpnle_uqss vcmpord_sss vcmpeq_usss vcmpnge_uqss vcmpngt_uqss vcmpfalse_osss vcmpneq_osss vcmpge_oqss vcmpgt_oqss vcmptrue_usss vcmpss vcomisd vcomiss vcvtdq2pd vcvtdq2ps vcvtpd2dq vcvtpd2ps vcvtps2dq vcvtps2pd vcvtsd2si vcvtsd2ss vcvtsi2sd vcvtsi2ss vcvtss2sd vcvtss2si vcvttpd2dq vcvttps2dq vcvttsd2si vcvttss2si vdivpd vdivps vdivsd vdivss vdppd vdpps vextractf128 vextractps vhaddpd vhaddps vhsubpd vhsubps vinsertf128 vinsertps vlddqu vldqqu vldmxcsr vmaskmovdqu vmaskmovps vmaskmovpd vmaxpd vmaxps vmaxsd vmaxss vminpd vminps vminsd vminss vmovapd vmovaps vmovd vmovq vmovddup vmovdqa vmovqqa vmovdqu vmovqqu vmovhlps vmovhpd vmovhps vmovlhps vmovlpd vmovlps vmovmskpd vmovmskps vmovntdq vmovntqq vmovntdqa vmovntpd vmovntps vmovsd vmovshdup vmovsldup vmovss vmovupd vmovups vmpsadbw vmulpd vmulps vmulsd vmulss vorpd vorps vpabsb vpabsw vpabsd vpacksswb vpackssdw vpackuswb vpackusdw vpaddb vpaddw vpaddd vpaddq vpaddsb vpaddsw vpaddusb vpaddusw vpalignr vpand vpandn vpavgb vpavgw vpblendvb vpblendw vpcmpestri vpcmpestrm vpcmpistri vpcmpistrm vpcmpeqb vpcmpeqw vpcmpeqd vpcmpeqq vpcmpgtb vpcmpgtw vpcmpgtd vpcmpgtq vpermilpd vpermilps vperm2f128 vpextrb vpextrw vpextrd vpextrq vphaddw vphaddd vphaddsw vphminposuw vphsubw vphsubd vphsubsw vpinsrb vpinsrw vpinsrd vpinsrq vpmaddwd vpmaddubsw vpmaxsb vpmaxsw vpmaxsd vpmaxub vpmaxuw vpmaxud vpminsb vpminsw vpminsd vpminub vpminuw vpminud vpmovmskb vpmovsxbw vpmovsxbd vpmovsxbq vpmovsxwd vpmovsxwq vpmovsxdq vpmovzxbw vpmovzxbd vpmovzxbq vpmovzxwd vpmovzxwq vpmovzxdq vpmulhuw vpmulhrsw vpmulhw vpmullw vpmulld vpmuludq vpmuldq vpor vpsadbw vpshufb vpshufd vpshufhw vpshuflw vpsignb vpsignw vpsignd vpslldq vpsrldq vpsllw vpslld vpsllq vpsraw vpsrad vpsrlw vpsrld vpsrlq vptest vpsubb vpsubw vpsubd vpsubq vpsubsb vpsubsw vpsubusb vpsubusw vpunpckhbw vpunpckhwd vpunpckhdq vpunpckhqdq vpunpcklbw vpunpcklwd vpunpckldq vpunpcklqdq vpxor vrcpps vrcpss vrsqrtps vrsqrtss vroundpd vroundps vroundsd vroundss vshufpd vshufps vsqrtpd vsqrtps vsqrtsd vsqrtss vstmxcsr vsubpd vsubps vsubsd vsubss vtestps vtestpd vucomisd vucomiss vunpckhpd vunpckhps vunpcklpd vunpcklps vxorpd vxorps vzeroall vzeroupper pclmullqlqdq pclmulhqlqdq pclmullqhqdq pclmulhqhqdq pclmulqdq vpclmullqlqdq vpclmulhqlqdq vpclmullqhqdq vpclmulhqhqdq vpclmulqdq vfmadd132ps vfmadd132pd vfmadd312ps vfmadd312pd vfmadd213ps vfmadd213pd vfmadd123ps vfmadd123pd vfmadd231ps vfmadd231pd vfmadd321ps vfmadd321pd vfmaddsub132ps vfmaddsub132pd vfmaddsub312ps vfmaddsub312pd vfmaddsub213ps vfmaddsub213pd vfmaddsub123ps vfmaddsub123pd vfmaddsub231ps vfmaddsub231pd vfmaddsub321ps vfmaddsub321pd vfmsub132ps vfmsub132pd vfmsub312ps vfmsub312pd vfmsub213ps vfmsub213pd vfmsub123ps vfmsub123pd vfmsub231ps vfmsub231pd vfmsub321ps vfmsub321pd vfmsubadd132ps vfmsubadd132pd vfmsubadd312ps vfmsubadd312pd vfmsubadd213ps vfmsubadd213pd vfmsubadd123ps vfmsubadd123pd vfmsubadd231ps vfmsubadd231pd vfmsubadd321ps vfmsubadd321pd vfnmadd132ps vfnmadd132pd vfnmadd312ps vfnmadd312pd vfnmadd213ps vfnmadd213pd vfnmadd123ps vfnmadd123pd vfnmadd231ps vfnmadd231pd vfnmadd321ps vfnmadd321pd vfnmsub132ps vfnmsub132pd vfnmsub312ps vfnmsub312pd vfnmsub213ps vfnmsub213pd vfnmsub123ps vfnmsub123pd vfnmsub231ps vfnmsub231pd vfnmsub321ps vfnmsub321pd vfmadd132ss vfmadd132sd vfmadd312ss vfmadd312sd vfmadd213ss vfmadd213sd vfmadd123ss vfmadd123sd vfmadd231ss vfmadd231sd vfmadd321ss vfmadd321sd vfmsub132ss vfmsub132sd vfmsub312ss vfmsub312sd vfmsub213ss vfmsub213sd vfmsub123ss vfmsub123sd vfmsub231ss vfmsub231sd vfmsub321ss vfmsub321sd vfnmadd132ss vfnmadd132sd vfnmadd312ss vfnmadd312sd vfnmadd213ss vfnmadd213sd vfnmadd123ss vfnmadd123sd vfnmadd231ss vfnmadd231sd vfnmadd321ss vfnmadd321sd vfnmsub132ss vfnmsub132sd vfnmsub312ss vfnmsub312sd vfnmsub213ss vfnmsub213sd vfnmsub123ss vfnmsub123sd vfnmsub231ss vfnmsub231sd vfnmsub321ss vfnmsub321sd rdfsbase rdgsbase rdrand wrfsbase wrgsbase vcvtph2ps vcvtps2ph adcx adox rdseed clac stac xstore xcryptecb xcryptcbc xcryptctr xcryptcfb xcryptofb montmul xsha1 xsha256 llwpcb slwpcb lwpval lwpins vfmaddpd vfmaddps vfmaddsd vfmaddss vfmaddsubpd vfmaddsubps vfmsubaddpd vfmsubaddps vfmsubpd vfmsubps vfmsubsd vfmsubss vfnmaddpd vfnmaddps vfnmaddsd vfnmaddss vfnmsubpd vfnmsubps vfnmsubsd vfnmsubss vfrczpd vfrczps vfrczsd vfrczss vpcmov vpcomb vpcomd vpcomq vpcomub vpcomud vpcomuq vpcomuw vpcomw vphaddbd vphaddbq vphaddbw vphadddq vphaddubd vphaddubq vphaddubw vphaddudq vphadduwd vphadduwq vphaddwd vphaddwq vphsubbw vphsubdq vphsubwd vpmacsdd vpmacsdqh vpmacsdql vpmacssdd vpmacssdqh vpmacssdql vpmacsswd vpmacssww vpmacswd vpmacsww vpmadcsswd vpmadcswd vpperm vprotb vprotd vprotq vprotw vpshab vpshad vpshaq vpshaw vpshlb vpshld vpshlq vpshlw vbroadcasti128 vpblendd vpbroadcastb vpbroadcastw vpbroadcastd vpbroadcastq vpermd vpermpd vpermps vpermq vperm2i128 vextracti128 vinserti128 vpmaskmovd vpmaskmovq vpsllvd vpsllvq vpsravd vpsrlvd vpsrlvq vgatherdpd vgatherqpd vgatherdps vgatherqps vpgatherdd vpgatherqd vpgatherdq vpgatherqq xabort xbegin xend xtest andn bextr blci blcic blsi blsic blcfill blsfill blcmsk blsmsk blsr blcs bzhi mulx pdep pext rorx sarx shlx shrx tzcnt tzmsk t1mskc valignd valignq vblendmpd vblendmps vbroadcastf32x4 vbroadcastf64x4 vbroadcasti32x4 vbroadcasti64x4 vcompresspd vcompressps vcvtpd2udq vcvtps2udq vcvtsd2usi vcvtss2usi vcvttpd2udq vcvttps2udq vcvttsd2usi vcvttss2usi vcvtudq2pd vcvtudq2ps vcvtusi2sd vcvtusi2ss vexpandpd vexpandps vextractf32x4 vextractf64x4 vextracti32x4 vextracti64x4 vfixupimmpd vfixupimmps vfixupimmsd vfixupimmss vgetexppd vgetexpps vgetexpsd vgetexpss vgetmantpd vgetmantps vgetmantsd vgetmantss vinsertf32x4 vinsertf64x4 vinserti32x4 vinserti64x4 vmovdqa32 vmovdqa64 vmovdqu32 vmovdqu64 vpabsq vpandd vpandnd vpandnq vpandq vpblendmd vpblendmq vpcmpltd vpcmpled vpcmpneqd vpcmpnltd vpcmpnled vpcmpd vpcmpltq vpcmpleq vpcmpneqq vpcmpnltq vpcmpnleq vpcmpq vpcmpequd vpcmpltud vpcmpleud vpcmpnequd vpcmpnltud vpcmpnleud vpcmpud vpcmpequq vpcmpltuq vpcmpleuq vpcmpnequq vpcmpnltuq vpcmpnleuq vpcmpuq vpcompressd vpcompressq vpermi2d vpermi2pd vpermi2ps vpermi2q vpermt2d vpermt2pd vpermt2ps vpermt2q vpexpandd vpexpandq vpmaxsq vpmaxuq vpminsq vpminuq vpmovdb vpmovdw vpmovqb vpmovqd vpmovqw vpmovsdb vpmovsdw vpmovsqb vpmovsqd vpmovsqw vpmovusdb vpmovusdw vpmovusqb vpmovusqd vpmovusqw vpord vporq vprold vprolq vprolvd vprolvq vprord vprorq vprorvd vprorvq vpscatterdd vpscatterdq vpscatterqd vpscatterqq vpsraq vpsravq vpternlogd vpternlogq vptestmd vptestmq vptestnmd vptestnmq vpxord vpxorq vrcp14pd vrcp14ps vrcp14sd vrcp14ss vrndscalepd vrndscaleps vrndscalesd vrndscaless vrsqrt14pd vrsqrt14ps vrsqrt14sd vrsqrt14ss vscalefpd vscalefps vscalefsd vscalefss vscatterdpd vscatterdps vscatterqpd vscatterqps vshuff32x4 vshuff64x2 vshufi32x4 vshufi64x2 kandnw kandw kmovw knotw kortestw korw kshiftlw kshiftrw kunpckbw kxnorw kxorw vpbroadcastmb2q vpbroadcastmw2d vpconflictd vpconflictq vplzcntd vplzcntq vexp2pd vexp2ps vrcp28pd vrcp28ps vrcp28sd vrcp28ss vrsqrt28pd vrsqrt28ps vrsqrt28sd vrsqrt28ss vgatherpf0dpd vgatherpf0dps vgatherpf0qpd vgatherpf0qps vgatherpf1dpd vgatherpf1dps vgatherpf1qpd vgatherpf1qps vscatterpf0dpd vscatterpf0dps vscatterpf0qpd vscatterpf0qps vscatterpf1dpd vscatterpf1dps vscatterpf1qpd vscatterpf1qps prefetchwt1 bndmk bndcl bndcu bndcn bndmov bndldx bndstx sha1rnds4 sha1nexte sha1msg1 sha1msg2 sha256rnds2 sha256msg1 sha256msg2 hint_nop0 hint_nop1 hint_nop2 hint_nop3 hint_nop4 hint_nop5 hint_nop6 hint_nop7 hint_nop8 hint_nop9 hint_nop10 hint_nop11 hint_nop12 hint_nop13 hint_nop14 hint_nop15 hint_nop16 hint_nop17 hint_nop18 hint_nop19 hint_nop20 hint_nop21 hint_nop22 hint_nop23 hint_nop24 hint_nop25 hint_nop26 hint_nop27 hint_nop28 hint_nop29 hint_nop30 hint_nop31 hint_nop32 hint_nop33 hint_nop34 hint_nop35 hint_nop36 hint_nop37 hint_nop38 hint_nop39 hint_nop40 hint_nop41 hint_nop42 hint_nop43 hint_nop44 hint_nop45 hint_nop46 hint_nop47 hint_nop48 hint_nop49 hint_nop50 hint_nop51 hint_nop52 hint_nop53 hint_nop54 hint_nop55 hint_nop56 hint_nop57 hint_nop58 hint_nop59 hint_nop60 hint_nop61 hint_nop62 hint_nop63",
literal:"ip eip rip al ah bl bh cl ch dl dh sil dil bpl spl r8b r9b r10b r11b r12b r13b r14b r15b ax bx cx dx si di bp sp r8w r9w r10w r11w r12w r13w r14w r15w eax ebx ecx edx esi edi ebp esp eip r8d r9d r10d r11d r12d r13d r14d r15d rax rbx rcx rdx rsi rdi rbp rsp r8 r9 r10 r11 r12 r13 r14 r15 cs ds es fs gs ss st st0 st1 st2 st3 st4 st5 st6 st7 mm0 mm1 mm2 mm3 mm4 mm5 mm6 mm7 xmm0  xmm1  xmm2  xmm3  xmm4  xmm5  xmm6  xmm7  xmm8  xmm9 xmm10  xmm11 xmm12 xmm13 xmm14 xmm15 xmm16 xmm17 xmm18 xmm19 xmm20 xmm21 xmm22 xmm23 xmm24 xmm25 xmm26 xmm27 xmm28 xmm29 xmm30 xmm31 ymm0  ymm1  ymm2  ymm3  ymm4  ymm5  ymm6  ymm7  ymm8  ymm9 ymm10  ymm11 ymm12 ymm13 ymm14 ymm15 ymm16 ymm17 ymm18 ymm19 ymm20 ymm21 ymm22 ymm23 ymm24 ymm25 ymm26 ymm27 ymm28 ymm29 ymm30 ymm31 zmm0  zmm1  zmm2  zmm3  zmm4  zmm5  zmm6  zmm7  zmm8  zmm9 zmm10  zmm11 zmm12 zmm13 zmm14 zmm15 zmm16 zmm17 zmm18 zmm19 zmm20 zmm21 zmm22 zmm23 zmm24 zmm25 zmm26 zmm27 zmm28 zmm29 zmm30 zmm31 k0 k1 k2 k3 k4 k5 k6 k7 bnd0 bnd1 bnd2 bnd3 cr0 cr1 cr2 cr3 cr4 cr8 dr0 dr1 dr2 dr3 dr8 tr3 tr4 tr5 tr6 tr7 r0 r1 r2 r3 r4 r5 r6 r7 r0b r1b r2b r3b r4b r5b r6b r7b r0w r1w r2w r3w r4w r5w r6w r7w r0d r1d r2d r3d r4d r5d r6d r7d r0h r1h r2h r3h r0l r1l r2l r3l r4l r5l r6l r7l r8l r9l r10l r11l r12l r13l r14l r15l",pseudo:"db dw dd dq dt ddq do dy dz resb resw resd resq rest resdq reso resy resz incbin equ times",preprocessor:"%define %xdefine %+ %undef %defstr %deftok %assign %strcat %strlen %substr %rotate %elif %else %endif %ifmacro %ifctx %ifidn %ifidni %ifid %ifnum %ifstr %iftoken %ifempty %ifenv %error %warning %fatal %rep %endrep %include %push %pop %repl %pathsearch %depend %use %arg %stacksize %local %line %comment %endcomment .nolist byte word dword qword nosplit rel abs seg wrt strict near far a32 ptr __FILE__ __LINE__ __SECT__  __BITS__ __OUTPUT_FORMAT__ __DATE__ __TIME__ __DATE_NUM__ __TIME_NUM__ __UTC_DATE__ __UTC_TIME__ __UTC_DATE_NUM__ __UTC_TIME_NUM__  __PASS__ struc endstruc istruc at iend align alignb sectalign daz nodaz up down zero default option assume public ",built_in:"bits use16 use32 use64 default section segment absolute extern global common cpu float __utf16__ __utf16le__ __utf16be__ __utf32__ __utf32le__ __utf32be__ __float8__ __float16__ __float32__ __float64__ __float80m__ __float80e__ __float128l__ __float128h__ __Infinity__ __QNaN__ __SNaN__ Inf NaN QNaN SNaN float8 float16 float32 float64 float80m float80e float128l float128h __FLOAT_DAZ__ __FLOAT_ROUND__ __FLOAT__"},contains:[hljs.COMMENT(";","$",{relevance:0}),{className:"number",variants:[{begin:"\\b(?:([0-9][0-9_]*)?\\.[0-9_]*(?:[eE][+-]?[0-9_]+)?|(0[Xx])?[0-9][0-9_]*\\.?[0-9_]*(?:[pP](?:[+-]?[0-9_]+)?)?)\\b",relevance:0},{begin:"\\$[0-9][0-9A-Fa-f]*",relevance:0},{begin:"\\b(?:[0-9A-Fa-f][0-9A-Fa-f_]*[Hh]|[0-9][0-9_]*[DdTt]?|[0-7][0-7_]*[QqOo]|[0-1][0-1_]*[BbYy])\\b"},{begin:"\\b(?:0[Xx][0-9A-Fa-f_]+|0[DdTt][0-9_]+|0[QqOo][0-7_]+|0[BbYy][0-1_]+)\\b"}]},hljs.QUOTE_STRING_MODE,{className:"string",variants:[{begin:"'",end:"[^\\\\]'"},{begin:"`",end:"[^\\\\]`"},{begin:"\\.[A-Za-z0-9]+"}],relevance:0},{className:"label",variants:[{begin:"^\\s*[A-Za-z._?][A-Za-z0-9_$#@~.?]*(:|\\s+label)"},{begin:"^\\s*%%[A-Za-z0-9_$#@~.?]*:"}],relevance:0},{className:"argument",begin:"%[0-9]+",relevance:0},{className:"built_in",begin:"%!S+",relevance:0}]}}),hljs.registerLanguage("xl",function(hljs){var BUILTIN_MODULES="ObjectLoader Animate MovieCredits Slides Filters Shading Materials LensFlare Mapping VLCAudioVideo StereoDecoder PointCloud NetworkAccess RemoteControl RegExp ChromaKey Snowfall NodeJS Speech Charts",XL_KEYWORDS={keyword:"if then else do while until for loop import with is as where when by data constant",literal:"true false nil",type:"integer real text name boolean symbol infix prefix postfix block tree",built_in:"in mod rem and or xor not abs sign floor ceil sqrt sin cos tan asin acos atan exp expm1 log log2 log10 log1p pi at",module:BUILTIN_MODULES,id:"text_length text_range text_find text_replace contains page slide basic_slide title_slide title subtitle fade_in fade_out fade_at clear_color color line_color line_width texture_wrap texture_transform texture scale_?x scale_?y scale_?z? translate_?x translate_?y translate_?z? rotate_?x rotate_?y rotate_?z? rectangle circle ellipse sphere path line_to move_to quad_to curve_to theme background contents locally time mouse_?x mouse_?y mouse_buttons"},XL_CONSTANT={className:"constant",begin:"[A-Z][A-Z_0-9]+",relevance:0},XL_VARIABLE={className:"variable",begin:"([A-Z][a-z_0-9]+)+",relevance:0},XL_ID={className:"id",begin:"[a-z][a-z_0-9]+",relevance:0},DOUBLE_QUOTE_TEXT={className:"string",begin:'"',end:'"',illegal:"\\n"},SINGLE_QUOTE_TEXT={className:"string",begin:"'",end:"'",illegal:"\\n"},LONG_TEXT={className:"string",begin:"<<",end:">>"},BASED_NUMBER={className:"number",begin:"[0-9]+#[0-9A-Z_]+(\\.[0-9-A-Z_]+)?#?([Ee][+-]?[0-9]+)?",relevance:10},IMPORT={className:"import",beginKeywords:"import",end:"$",keywords:{keyword:"import",module:BUILTIN_MODULES},relevance:0,contains:[DOUBLE_QUOTE_TEXT]},FUNCTION_DEFINITION={className:"function",begin:"[a-z].*->"};return{aliases:["tao"],lexemes:/[a-zA-Z][a-zA-Z0-9_?]*/,keywords:XL_KEYWORDS,contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,DOUBLE_QUOTE_TEXT,SINGLE_QUOTE_TEXT,LONG_TEXT,FUNCTION_DEFINITION,IMPORT,XL_CONSTANT,XL_VARIABLE,XL_ID,BASED_NUMBER,hljs.NUMBER_MODE]}}),hljs.registerLanguage("xquery",function(hljs){var KEYWORDS="for let if while then else return where group by xquery encoding versionmodule namespace boundary-space preserve strip default collation base-uri orderingcopy-namespaces order declare import schema namespace function option in allowing emptyat tumbling window sliding window start when only end when previous next stable ascendingdescending empty greatest least some every satisfies switch case typeswitch try catch andor to union intersect instance of treat as castable cast map array delete insert intoreplace value rename copy modify update",LITERAL="false true xs:string xs:integer element item xs:date xs:datetime xs:float xs:double xs:decimal QName xs:anyURI xs:long xs:int xs:short xs:byte attribute",VAR={className:"variable",begin:/\$[a-zA-Z0-9\-]+/,relevance:5},NUMBER={className:"number",begin:"(\\b0[0-7_]+)|(\\b0x[0-9a-fA-F_]+)|(\\b[1-9][0-9_]*(\\.[0-9_]+)?)|[0_]\\b",relevance:0},STRING={className:"string",variants:[{begin:/"/,end:/"/,contains:[{begin:/""/,relevance:0}]},{begin:/'/,end:/'/,contains:[{begin:/''/,relevance:0}]}]},ANNOTATION={className:"decorator",begin:"%\\w+"},COMMENT={className:"comment",begin:"\\(:",end:":\\)",relevance:10,contains:[{className:"doc",begin:"@\\w+"}]},METHOD={begin:"{",end:"}"},CONTAINS=[VAR,STRING,NUMBER,COMMENT,ANNOTATION,METHOD];return METHOD.contains=CONTAINS,{aliases:["xpath","xq"],case_insensitive:!1,lexemes:/[a-zA-Z\$][a-zA-Z0-9_:\-]*/,illegal:/(proc)|(abstract)|(extends)|(until)|(#)/,keywords:{keyword:KEYWORDS,literal:LITERAL},contains:CONTAINS}}),hljs.registerLanguage("zephir",function(hljs){var STRING={className:"string",contains:[hljs.BACKSLASH_ESCAPE],variants:[{begin:'b"',end:'"'},{begin:"b'",end:"'"},hljs.inherit(hljs.APOS_STRING_MODE,{illegal:null}),hljs.inherit(hljs.QUOTE_STRING_MODE,{illegal:null})]},NUMBER={variants:[hljs.BINARY_NUMBER_MODE,hljs.C_NUMBER_MODE]};return{aliases:["zep"],case_insensitive:!0,keywords:"and include_once list abstract global private echo interface as static endswitch array null if endwhile or const for endforeach self var let while isset public protected exit foreach throw elseif include __FILE__ empty require_once do xor return parent clone use __CLASS__ __LINE__ else break print eval new catch __METHOD__ case exception default die require __FUNCTION__ enddeclare final try switch continue endfor endif declare unset true false trait goto instanceof insteadof __DIR__ __NAMESPACE__ yield finally int uint long ulong char uchar double float bool boolean stringlikely unlikely",contains:[hljs.C_LINE_COMMENT_MODE,hljs.HASH_COMMENT_MODE,hljs.COMMENT("/\\*","\\*/",{contains:[{className:"doctag",begin:"@[A-Za-z]+"}]}),hljs.COMMENT("__halt_compiler.+?;",!1,{endsWithParent:!0,keywords:"__halt_compiler",lexemes:hljs.UNDERSCORE_IDENT_RE}),{className:"string",begin:"<<<['\"]?\\w+['\"]?$",end:"^\\w+;",contains:[hljs.BACKSLASH_ESCAPE]},{begin:/(::|->)+[a-zA-Z_\x7f-\xff][a-zA-Z0-9_\x7f-\xff]*/},{className:"function",beginKeywords:"function",end:/[;{]/,excludeEnd:!0,illegal:"\\$|\\[|%",contains:[hljs.UNDERSCORE_TITLE_MODE,{className:"params",begin:"\\(",end:"\\)",contains:["self",hljs.C_BLOCK_COMMENT_MODE,STRING,NUMBER]}]},{className:"class",beginKeywords:"class interface",end:"{",excludeEnd:!0,illegal:/[:\(\$"]/,contains:[{beginKeywords:"extends implements"},hljs.UNDERSCORE_TITLE_MODE]},{beginKeywords:"namespace",end:";",illegal:/[\.']/,contains:[hljs.UNDERSCORE_TITLE_MODE]},{beginKeywords:"use",end:";",contains:[hljs.UNDERSCORE_TITLE_MODE]},{begin:"=>"},STRING,NUMBER]}}),hljs}),function(){function createShiftArr(step){var space="    ";if(isNaN(parseInt(step)))space=step;else switch(step){case 1:space=" ";break;case 2:space="  ";break;case 3:space="   ";break;case 4:space="    ";break;case 5:space="     ";break;case 6:space="      ";break;case 7:space="       ";break;case 8:space="        ";break;case 9:space="         ";break;case 10:space="          ";break;case 11:space="           ";break;case 12:space="            "}var shift=["\n"];for(ix=0;ix<100;ix++)shift.push(shift[ix]+space);return shift}function vkbeautify(){this.step="    ",this.shift=createShiftArr(this.step)}function isSubquery(str,parenthesisLevel){return parenthesisLevel-(str.replace(/\(/g,"").length-str.replace(/\)/g,"").length)}function split_sql(str,tab){return str.replace(/\s{1,}/g," ").replace(/ AND /gi,"~::~"+tab+tab+"AND ").replace(/ BETWEEN /gi,"~::~"+tab+"BETWEEN ").replace(/ CASE /gi,"~::~"+tab+"CASE ").replace(/ ELSE /gi,"~::~"+tab+"ELSE ").replace(/ END /gi,"~::~"+tab+"END ").replace(/ FROM /gi,"~::~FROM ").replace(/ GROUP\s{1,}BY/gi,"~::~GROUP BY ").replace(/ HAVING /gi,"~::~HAVING ").replace(/ IN /gi," IN ").replace(/ JOIN /gi,"~::~JOIN ").replace(/ CROSS~::~{1,}JOIN /gi,"~::~CROSS JOIN ").replace(/ INNER~::~{1,}JOIN /gi,"~::~INNER JOIN ").replace(/ LEFT~::~{1,}JOIN /gi,"~::~LEFT JOIN ").replace(/ RIGHT~::~{1,}JOIN /gi,"~::~RIGHT JOIN ").replace(/ ON /gi,"~::~"+tab+"ON ").replace(/ OR /gi,"~::~"+tab+tab+"OR ").replace(/ ORDER\s{1,}BY/gi,"~::~ORDER BY ").replace(/ OVER /gi,"~::~"+tab+"OVER ").replace(/\(\s{0,}SELECT /gi,"~::~(SELECT ").replace(/\)\s{0,}SELECT /gi,")~::~SELECT ").replace(/ THEN /gi," THEN~::~"+tab).replace(/ UNION /gi,"~::~UNION~::~").replace(/ USING /gi,"~::~USING ").replace(/ WHEN /gi,"~::~"+tab+"WHEN ").replace(/ WHERE /gi,"~::~WHERE ").replace(/ WITH /gi,"~::~WITH ").replace(/ ALL /gi," ALL ").replace(/ AS /gi," AS ").replace(/ ASC /gi," ASC ").replace(/ DESC /gi," DESC ").replace(/ DISTINCT /gi," DISTINCT ").replace(/ EXISTS /gi," EXISTS ").replace(/ NOT /gi," NOT ").replace(/ NULL /gi," NULL ").replace(/ LIKE /gi," LIKE ").replace(/\s{0,}SELECT /gi,"SELECT ").replace(/\s{0,}UPDATE /gi,"UPDATE ").replace(/ SET /gi," SET ").replace(/~::~{1,}/g,"~::~").split("~::~")}vkbeautify.prototype.xml=function(text,step){var ar=text.replace(/>\s{0,}</g,"><").replace(/</g,"~::~<").replace(/\s*xmlns\:/g,"~::~xmlns:").replace(/\s*xmlns\=/g,"~::~xmlns=").split("~::~"),len=ar.length,inComment=!1,deep=0,str="",ix=0,shift=step?createShiftArr(step):this.shift;for(ix=0;ix<len;ix++)ar[ix].search(/<!/)>-1?(str+=shift[deep]+ar[ix],inComment=!0,(ar[ix].search(/-->/)>-1||ar[ix].search(/\]>/)>-1||ar[ix].search(/!DOCTYPE/)>-1)&&(inComment=!1)):ar[ix].search(/-->/)>-1||ar[ix].search(/\]>/)>-1?(str+=ar[ix],inComment=!1):/^<\w/.exec(ar[ix-1])&&/^<\/\w/.exec(ar[ix])&&/^<[\w:\-\.\,]+/.exec(ar[ix-1])==/^<\/[\w:\-\.\,]+/.exec(ar[ix])[0].replace("/","")?(str+=ar[ix],inComment||deep--):ar[ix].search(/<\w/)>-1&&ar[ix].search(/<\//)==-1&&ar[ix].search(/\/>/)==-1?str=str+=inComment?ar[ix]:shift[deep++]+ar[ix]:ar[ix].search(/<\w/)>-1&&ar[ix].search(/<\//)>-1?str=str+=inComment?ar[ix]:shift[deep]+ar[ix]:ar[ix].search(/<\//)>-1?str=str+=inComment?ar[ix]:shift[--deep]+ar[ix]:ar[ix].search(/\/>/)>-1?str=str+=inComment?ar[ix]:shift[deep]+ar[ix]:str+=ar[ix].search(/<\?/)>-1?shift[deep]+ar[ix]:ar[ix].search(/xmlns\:/)>-1||ar[ix].search(/xmlns\=/)>-1?shift[deep]+ar[ix]:ar[ix];return"\n"==str[0]?str.slice(1):str},vkbeautify.prototype.json=function(text,step){var step=step?step:this.step;return"undefined"==typeof JSON?text:"string"==typeof text?JSON.stringify(JSON.parse(text),null,step):"object"==typeof text?JSON.stringify(text,null,step):text},vkbeautify.prototype.css=function(text,step){var ar=text.replace(/\s{1,}/g," ").replace(/\{/g,"{~::~").replace(/\}/g,"~::~}~::~").replace(/\;/g,";~::~").replace(/\/\*/g,"~::~/*").replace(/\*\//g,"*/~::~").replace(/~::~\s{0,}~::~/g,"~::~").split("~::~"),len=ar.length,deep=0,str="",ix=0,shift=step?createShiftArr(step):this.shift;for(ix=0;ix<len;ix++)str+=/\{/.exec(ar[ix])?shift[deep++]+ar[ix]:/\}/.exec(ar[ix])?shift[--deep]+ar[ix]:/\*\\/.exec(ar[ix])?shift[deep]+ar[ix]:shift[deep]+ar[ix];return str.replace(/^\n{1,}/,"")},vkbeautify.prototype.sql=function(text,step){var ar_by_quote=text.replace(/\s{1,}/g," ").replace(/\'/gi,"~::~'").split("~::~"),len=ar_by_quote.length,ar=[],deep=0,tab=this.step,parenthesisLevel=0,str="",ix=0,shift=step?createShiftArr(step):this.shift;for(ix=0;ix<len;ix++)ar=ix%2?ar.concat(ar_by_quote[ix]):ar.concat(split_sql(ar_by_quote[ix],tab));for(len=ar.length,ix=0;ix<len;ix++){parenthesisLevel=isSubquery(ar[ix],parenthesisLevel),/\s{0,}\s{0,}SELECT\s{0,}/.exec(ar[ix])&&(ar[ix]=ar[ix].replace(/\,/g,",\n"+tab+tab)),/\s{0,}\s{0,}SET\s{0,}/.exec(ar[ix])&&(ar[ix]=ar[ix].replace(/\,/g,",\n"+tab+tab)),/\s{0,}\(\s{0,}SELECT\s{0,}/.exec(ar[ix])?(deep++,str+=shift[deep]+ar[ix]):/\'/.exec(ar[ix])?(parenthesisLevel<1&&deep&&deep--,str+=ar[ix]):(str+=shift[deep]+ar[ix],parenthesisLevel<1&&deep&&deep--)}return str=str.replace(/^\n{1,}/,"").replace(/\n{1,}/g,"\n")},vkbeautify.prototype.xmlmin=function(text,preserveComments){var str=preserveComments?text:text.replace(/\<![ \r\n\t]*(--([^\-]|[\r\n]|-[^\-])*--[ \r\n\t]*)\>/g,"").replace(/[ \r\n\t]{1,}xmlns/g," xmlns");return str.replace(/>\s{0,}</g,"><")},vkbeautify.prototype.jsonmin=function(text){return"undefined"==typeof JSON?text:JSON.stringify(JSON.parse(text),null,0)},vkbeautify.prototype.cssmin=function(text,preserveComments){var str=preserveComments?text:text.replace(/\/\*([^*]|[\r\n]|(\*+([^*\/]|[\r\n])))*\*+\//g,"");return str.replace(/\s{1,}/g," ").replace(/\{\s{1,}/g,"{").replace(/\}\s{1,}/g,"}").replace(/\;\s{1,}/g,";").replace(/\/\*\s{1,}/g,"/*").replace(/\*\/\s{1,}/g,"*/")},vkbeautify.prototype.sqlmin=function(text){return text.replace(/\s{1,}/g," ").replace(/\s{1,}\(/,"(").replace(/\s{1,}\)/,")")},window.vkbeautify=new vkbeautify}(),function(global,factory){"object"==typeof module&&"object"==typeof module.exports?module.exports=global.document?factory(global,!0):function(w){if(!w.document)throw new Error("jQuery requires a window with a document");return factory(w)}:factory(global)}("undefined"!=typeof window?window:this,function(window,noGlobal){function isArraylike(obj){var length="length"in obj&&obj.length,type=jQuery.type(obj);return"function"!==type&&!jQuery.isWindow(obj)&&(!(1!==obj.nodeType||!length)||("array"===type||0===length||"number"==typeof length&&length>0&&length-1 in obj))}function winnow(elements,qualifier,not){if(jQuery.isFunction(qualifier))return jQuery.grep(elements,function(elem,i){return!!qualifier.call(elem,i,elem)!==not});if(qualifier.nodeType)return jQuery.grep(elements,function(elem){return elem===qualifier!==not});if("string"==typeof qualifier){if(risSimple.test(qualifier))return jQuery.filter(qualifier,elements,not);qualifier=jQuery.filter(qualifier,elements)}return jQuery.grep(elements,function(elem){return indexOf.call(qualifier,elem)>=0!==not})}function sibling(cur,dir){for(;(cur=cur[dir])&&1!==cur.nodeType;);return cur}function createOptions(options){var object=optionsCache[options]={};return jQuery.each(options.match(rnotwhite)||[],function(_,flag){object[flag]=!0}),object}function completed(){document.removeEventListener("DOMContentLoaded",completed,!1),window.removeEventListener("load",completed,!1),jQuery.ready()}function Data(){Object.defineProperty(this.cache={},0,{get:function(){return{}}}),this.expando=jQuery.expando+Data.uid++}function dataAttr(elem,key,data){var name;if(void 0===data&&1===elem.nodeType)if(name="data-"+key.replace(rmultiDash,"-$1").toLowerCase(),data=elem.getAttribute(name),"string"==typeof data){try{data="true"===data||"false"!==data&&("null"===data?null:+data+""===data?+data:rbrace.test(data)?jQuery.parseJSON(data):data)}catch(e){}data_user.set(elem,key,data)}else data=void 0;return data}function returnTrue(){return!0}function returnFalse(){return!1}function safeActiveElement(){try{return document.activeElement}catch(err){}}function manipulationTarget(elem,content){return jQuery.nodeName(elem,"table")&&jQuery.nodeName(11!==content.nodeType?content:content.firstChild,"tr")?elem.getElementsByTagName("tbody")[0]||elem.appendChild(elem.ownerDocument.createElement("tbody")):elem}function disableScript(elem){return elem.type=(null!==elem.getAttribute("type"))+"/"+elem.type,elem}function restoreScript(elem){var match=rscriptTypeMasked.exec(elem.type);return match?elem.type=match[1]:elem.removeAttribute("type"),elem}function setGlobalEval(elems,refElements){for(var i=0,l=elems.length;i<l;i++)data_priv.set(elems[i],"globalEval",!refElements||data_priv.get(refElements[i],"globalEval"))}function cloneCopyEvent(src,dest){var i,l,type,pdataOld,pdataCur,udataOld,udataCur,events;if(1===dest.nodeType){if(data_priv.hasData(src)&&(pdataOld=data_priv.access(src),pdataCur=data_priv.set(dest,pdataOld),events=pdataOld.events)){delete pdataCur.handle,pdataCur.events={};for(type in events)for(i=0,l=events[type].length;i<l;i++)jQuery.event.add(dest,type,events[type][i])}data_user.hasData(src)&&(udataOld=data_user.access(src),udataCur=jQuery.extend({},udataOld),data_user.set(dest,udataCur))}}function getAll(context,tag){var ret=context.getElementsByTagName?context.getElementsByTagName(tag||"*"):context.querySelectorAll?context.querySelectorAll(tag||"*"):[];return void 0===tag||tag&&jQuery.nodeName(context,tag)?jQuery.merge([context],ret):ret}function fixInput(src,dest){var nodeName=dest.nodeName.toLowerCase();"input"===nodeName&&rcheckableType.test(src.type)?dest.checked=src.checked:"input"!==nodeName&&"textarea"!==nodeName||(dest.defaultValue=src.defaultValue)}function actualDisplay(name,doc){var style,elem=jQuery(doc.createElement(name)).appendTo(doc.body),display=window.getDefaultComputedStyle&&(style=window.getDefaultComputedStyle(elem[0]))?style.display:jQuery.css(elem[0],"display");return elem.detach(),display}function defaultDisplay(nodeName){var doc=document,display=elemdisplay[nodeName];return display||(display=actualDisplay(nodeName,doc),"none"!==display&&display||(iframe=(iframe||jQuery("<iframe frameborder='0' width='0' height='0'/>")).appendTo(doc.documentElement),doc=iframe[0].contentDocument,doc.write(),doc.close(),display=actualDisplay(nodeName,doc),iframe.detach()),elemdisplay[nodeName]=display),display}function curCSS(elem,name,computed){var width,minWidth,maxWidth,ret,style=elem.style;return computed=computed||getStyles(elem),computed&&(ret=computed.getPropertyValue(name)||computed[name]),computed&&(""!==ret||jQuery.contains(elem.ownerDocument,elem)||(ret=jQuery.style(elem,name)),rnumnonpx.test(ret)&&rmargin.test(name)&&(width=style.width,minWidth=style.minWidth,maxWidth=style.maxWidth,style.minWidth=style.maxWidth=style.width=ret,ret=computed.width,style.width=width,style.minWidth=minWidth,style.maxWidth=maxWidth)),void 0!==ret?ret+"":ret}function addGetHookIf(conditionFn,hookFn){return{get:function(){return conditionFn()?void delete this.get:(this.get=hookFn).apply(this,arguments)}}}function vendorPropName(style,name){if(name in style)return name;for(var capName=name[0].toUpperCase()+name.slice(1),origName=name,i=cssPrefixes.length;i--;)if(name=cssPrefixes[i]+capName,name in style)return name;return origName}function setPositiveNumber(elem,value,subtract){var matches=rnumsplit.exec(value);return matches?Math.max(0,matches[1]-(subtract||0))+(matches[2]||"px"):value}function augmentWidthOrHeight(elem,name,extra,isBorderBox,styles){for(var i=extra===(isBorderBox?"border":"content")?4:"width"===name?1:0,val=0;i<4;i+=2)"margin"===extra&&(val+=jQuery.css(elem,extra+cssExpand[i],!0,styles)),isBorderBox?("content"===extra&&(val-=jQuery.css(elem,"padding"+cssExpand[i],!0,styles)),"margin"!==extra&&(val-=jQuery.css(elem,"border"+cssExpand[i]+"Width",!0,styles))):(val+=jQuery.css(elem,"padding"+cssExpand[i],!0,styles),"padding"!==extra&&(val+=jQuery.css(elem,"border"+cssExpand[i]+"Width",!0,styles)));return val}function getWidthOrHeight(elem,name,extra){var valueIsBorderBox=!0,val="width"===name?elem.offsetWidth:elem.offsetHeight,styles=getStyles(elem),isBorderBox="border-box"===jQuery.css(elem,"boxSizing",!1,styles);if(val<=0||null==val){if(val=curCSS(elem,name,styles),(val<0||null==val)&&(val=elem.style[name]),rnumnonpx.test(val))return val;valueIsBorderBox=isBorderBox&&(support.boxSizingReliable()||val===elem.style[name]),val=parseFloat(val)||0}return val+augmentWidthOrHeight(elem,name,extra||(isBorderBox?"border":"content"),valueIsBorderBox,styles)+"px"}function showHide(elements,show){for(var display,elem,hidden,values=[],index=0,length=elements.length;index<length;index++)elem=elements[index],elem.style&&(values[index]=data_priv.get(elem,"olddisplay"),display=elem.style.display,show?(values[index]||"none"!==display||(elem.style.display=""),""===elem.style.display&&isHidden(elem)&&(values[index]=data_priv.access(elem,"olddisplay",defaultDisplay(elem.nodeName)))):(hidden=isHidden(elem),"none"===display&&hidden||data_priv.set(elem,"olddisplay",hidden?display:jQuery.css(elem,"display"))));for(index=0;index<length;index++)elem=elements[index],elem.style&&(show&&"none"!==elem.style.display&&""!==elem.style.display||(elem.style.display=show?values[index]||"":"none"));return elements}function Tween(elem,options,prop,end,easing){return new Tween.prototype.init(elem,options,prop,end,easing)}function createFxNow(){return setTimeout(function(){fxNow=void 0}),fxNow=jQuery.now()}function genFx(type,includeWidth){var which,i=0,attrs={height:type};for(includeWidth=includeWidth?1:0;i<4;i+=2-includeWidth)which=cssExpand[i],attrs["margin"+which]=attrs["padding"+which]=type;return includeWidth&&(attrs.opacity=attrs.width=type),attrs}function createTween(value,prop,animation){for(var tween,collection=(tweeners[prop]||[]).concat(tweeners["*"]),index=0,length=collection.length;index<length;index++)if(tween=collection[index].call(animation,prop,value))return tween}function defaultPrefilter(elem,props,opts){var prop,value,toggle,tween,hooks,oldfire,display,checkDisplay,anim=this,orig={},style=elem.style,hidden=elem.nodeType&&isHidden(elem),dataShow=data_priv.get(elem,"fxshow");opts.queue||(hooks=jQuery._queueHooks(elem,"fx"),null==hooks.unqueued&&(hooks.unqueued=0,oldfire=hooks.empty.fire,hooks.empty.fire=function(){hooks.unqueued||oldfire()}),hooks.unqueued++,anim.always(function(){anim.always(function(){hooks.unqueued--,jQuery.queue(elem,"fx").length||hooks.empty.fire()})})),1===elem.nodeType&&("height"in props||"width"in props)&&(opts.overflow=[style.overflow,style.overflowX,style.overflowY],display=jQuery.css(elem,"display"),checkDisplay="none"===display?data_priv.get(elem,"olddisplay")||defaultDisplay(elem.nodeName):display,"inline"===checkDisplay&&"none"===jQuery.css(elem,"float")&&(style.display="inline-block")),opts.overflow&&(style.overflow="hidden",anim.always(function(){style.overflow=opts.overflow[0],style.overflowX=opts.overflow[1],style.overflowY=opts.overflow[2]}));for(prop in props)if(value=props[prop],rfxtypes.exec(value)){if(delete props[prop],toggle=toggle||"toggle"===value,value===(hidden?"hide":"show")){if("show"!==value||!dataShow||void 0===dataShow[prop])continue;hidden=!0}orig[prop]=dataShow&&dataShow[prop]||jQuery.style(elem,prop)}else display=void 0;if(jQuery.isEmptyObject(orig))"inline"===("none"===display?defaultDisplay(elem.nodeName):display)&&(style.display=display);else{dataShow?"hidden"in dataShow&&(hidden=dataShow.hidden):dataShow=data_priv.access(elem,"fxshow",{}),toggle&&(dataShow.hidden=!hidden),hidden?jQuery(elem).show():anim.done(function(){jQuery(elem).hide()}),anim.done(function(){var prop;data_priv.remove(elem,"fxshow");for(prop in orig)jQuery.style(elem,prop,orig[prop])});for(prop in orig)tween=createTween(hidden?dataShow[prop]:0,prop,anim),prop in dataShow||(dataShow[prop]=tween.start,hidden&&(tween.end=tween.start,tween.start="width"===prop||"height"===prop?1:0))}}function propFilter(props,specialEasing){var index,name,easing,value,hooks;for(index in props)if(name=jQuery.camelCase(index),easing=specialEasing[name],value=props[index],jQuery.isArray(value)&&(easing=value[1],value=props[index]=value[0]),index!==name&&(props[name]=value,delete props[index]),hooks=jQuery.cssHooks[name],hooks&&"expand"in hooks){value=hooks.expand(value),delete props[name];for(index in value)index in props||(props[index]=value[index],specialEasing[index]=easing)}else specialEasing[name]=easing}function Animation(elem,properties,options){var result,stopped,index=0,length=animationPrefilters.length,deferred=jQuery.Deferred().always(function(){delete tick.elem}),tick=function(){if(stopped)return!1;for(var currentTime=fxNow||createFxNow(),remaining=Math.max(0,animation.startTime+animation.duration-currentTime),temp=remaining/animation.duration||0,percent=1-temp,index=0,length=animation.tweens.length;index<length;index++)animation.tweens[index].run(percent);return deferred.notifyWith(elem,[animation,percent,remaining]),percent<1&&length?remaining:(deferred.resolveWith(elem,[animation]),!1)},animation=deferred.promise({elem:elem,props:jQuery.extend({},properties),opts:jQuery.extend(!0,{specialEasing:{}},options),originalProperties:properties,originalOptions:options,startTime:fxNow||createFxNow(),duration:options.duration,tweens:[],createTween:function(prop,end){var tween=jQuery.Tween(elem,animation.opts,prop,end,animation.opts.specialEasing[prop]||animation.opts.easing);return animation.tweens.push(tween),tween},stop:function(gotoEnd){var index=0,length=gotoEnd?animation.tweens.length:0;if(stopped)return this;for(stopped=!0;index<length;index++)animation.tweens[index].run(1);return gotoEnd?deferred.resolveWith(elem,[animation,gotoEnd]):deferred.rejectWith(elem,[animation,gotoEnd]),this}}),props=animation.props;for(propFilter(props,animation.opts.specialEasing);index<length;index++)if(result=animationPrefilters[index].call(animation,elem,props,animation.opts))return result;return jQuery.map(props,createTween,animation),jQuery.isFunction(animation.opts.start)&&animation.opts.start.call(elem,animation),jQuery.fx.timer(jQuery.extend(tick,{elem:elem,anim:animation,queue:animation.opts.queue})),animation.progress(animation.opts.progress).done(animation.opts.done,animation.opts.complete).fail(animation.opts.fail).always(animation.opts.always)}function addToPrefiltersOrTransports(structure){return function(dataTypeExpression,func){"string"!=typeof dataTypeExpression&&(func=dataTypeExpression,dataTypeExpression="*");var dataType,i=0,dataTypes=dataTypeExpression.toLowerCase().match(rnotwhite)||[];if(jQuery.isFunction(func))for(;dataType=dataTypes[i++];)"+"===dataType[0]?(dataType=dataType.slice(1)||"*",(structure[dataType]=structure[dataType]||[]).unshift(func)):(structure[dataType]=structure[dataType]||[]).push(func)}}function inspectPrefiltersOrTransports(structure,options,originalOptions,jqXHR){function inspect(dataType){var selected;return inspected[dataType]=!0,jQuery.each(structure[dataType]||[],function(_,prefilterOrFactory){var dataTypeOrTransport=prefilterOrFactory(options,originalOptions,jqXHR);return"string"!=typeof dataTypeOrTransport||seekingTransport||inspected[dataTypeOrTransport]?seekingTransport?!(selected=dataTypeOrTransport):void 0:(options.dataTypes.unshift(dataTypeOrTransport),inspect(dataTypeOrTransport),!1)}),selected}var inspected={},seekingTransport=structure===transports;return inspect(options.dataTypes[0])||!inspected["*"]&&inspect("*")}function ajaxExtend(target,src){var key,deep,flatOptions=jQuery.ajaxSettings.flatOptions||{};for(key in src)void 0!==src[key]&&((flatOptions[key]?target:deep||(deep={}))[key]=src[key]);return deep&&jQuery.extend(!0,target,deep),target}function ajaxHandleResponses(s,jqXHR,responses){for(var ct,type,finalDataType,firstDataType,contents=s.contents,dataTypes=s.dataTypes;"*"===dataTypes[0];)dataTypes.shift(),void 0===ct&&(ct=s.mimeType||jqXHR.getResponseHeader("Content-Type"));if(ct)for(type in contents)if(contents[type]&&contents[type].test(ct)){dataTypes.unshift(type);break}if(dataTypes[0]in responses)finalDataType=dataTypes[0];else{for(type in responses){if(!dataTypes[0]||s.converters[type+" "+dataTypes[0]]){finalDataType=type;break}firstDataType||(firstDataType=type)}finalDataType=finalDataType||firstDataType}if(finalDataType)return finalDataType!==dataTypes[0]&&dataTypes.unshift(finalDataType),responses[finalDataType]}function ajaxConvert(s,response,jqXHR,isSuccess){var conv2,current,conv,tmp,prev,converters={},dataTypes=s.dataTypes.slice();if(dataTypes[1])for(conv in s.converters)converters[conv.toLowerCase()]=s.converters[conv];for(current=dataTypes.shift();current;)if(s.responseFields[current]&&(jqXHR[s.responseFields[current]]=response),!prev&&isSuccess&&s.dataFilter&&(response=s.dataFilter(response,s.dataType)),prev=current,current=dataTypes.shift())if("*"===current)current=prev;else if("*"!==prev&&prev!==current){if(conv=converters[prev+" "+current]||converters["* "+current],!conv)for(conv2 in converters)if(tmp=conv2.split(" "),tmp[1]===current&&(conv=converters[prev+" "+tmp[0]]||converters["* "+tmp[0]])){conv===!0?conv=converters[conv2]:converters[conv2]!==!0&&(current=tmp[0],dataTypes.unshift(tmp[1]));break}if(conv!==!0)if(conv&&s.throws)response=conv(response);else try{response=conv(response)}catch(e){return{state:"parsererror",error:conv?e:"No conversion from "+prev+" to "+current}}}return{state:"success",data:response}}function buildParams(prefix,obj,traditional,add){var name;if(jQuery.isArray(obj))jQuery.each(obj,function(i,v){traditional||rbracket.test(prefix)?add(prefix,v):buildParams(prefix+"["+("object"==typeof v?i:"")+"]",v,traditional,add)});else if(traditional||"object"!==jQuery.type(obj))add(prefix,obj);else for(name in obj)buildParams(prefix+"["+name+"]",obj[name],traditional,add)}function getWindow(elem){return jQuery.isWindow(elem)?elem:9===elem.nodeType&&elem.defaultView}var arr=[],slice=arr.slice,concat=arr.concat,push=arr.push,indexOf=arr.indexOf,class2type={},toString=class2type.toString,hasOwn=class2type.hasOwnProperty,support={},document=window.document,version="2.1.4",jQuery=function(selector,context){return new jQuery.fn.init(selector,context)},rtrim=/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g,rmsPrefix=/^-ms-/,rdashAlpha=/-([\da-z])/gi,fcamelCase=function(all,letter){return letter.toUpperCase()};jQuery.fn=jQuery.prototype={jquery:version,constructor:jQuery,selector:"",length:0,toArray:function(){return slice.call(this)},get:function(num){return null!=num?num<0?this[num+this.length]:this[num]:slice.call(this)},pushStack:function(elems){var ret=jQuery.merge(this.constructor(),elems);return ret.prevObject=this,ret.context=this.context,ret},each:function(callback,args){return jQuery.each(this,callback,args)},map:function(callback){return this.pushStack(jQuery.map(this,function(elem,i){return callback.call(elem,i,elem)}))},slice:function(){return this.pushStack(slice.apply(this,arguments))},first:function(){return this.eq(0)},last:function(){return this.eq(-1)},eq:function(i){var len=this.length,j=+i+(i<0?len:0);return this.pushStack(j>=0&&j<len?[this[j]]:[]);
},end:function(){return this.prevObject||this.constructor(null)},push:push,sort:arr.sort,splice:arr.splice},jQuery.extend=jQuery.fn.extend=function(){var options,name,src,copy,copyIsArray,clone,target=arguments[0]||{},i=1,length=arguments.length,deep=!1;for("boolean"==typeof target&&(deep=target,target=arguments[i]||{},i++),"object"==typeof target||jQuery.isFunction(target)||(target={}),i===length&&(target=this,i--);i<length;i++)if(null!=(options=arguments[i]))for(name in options)src=target[name],copy=options[name],target!==copy&&(deep&&copy&&(jQuery.isPlainObject(copy)||(copyIsArray=jQuery.isArray(copy)))?(copyIsArray?(copyIsArray=!1,clone=src&&jQuery.isArray(src)?src:[]):clone=src&&jQuery.isPlainObject(src)?src:{},target[name]=jQuery.extend(deep,clone,copy)):void 0!==copy&&(target[name]=copy));return target},jQuery.extend({expando:"jQuery"+(version+Math.random()).replace(/\D/g,""),isReady:!0,error:function(msg){throw new Error(msg)},noop:function(){},isFunction:function(obj){return"function"===jQuery.type(obj)},isArray:Array.isArray,isWindow:function(obj){return null!=obj&&obj===obj.window},isNumeric:function(obj){return!jQuery.isArray(obj)&&obj-parseFloat(obj)+1>=0},isPlainObject:function(obj){return"object"===jQuery.type(obj)&&!obj.nodeType&&!jQuery.isWindow(obj)&&!(obj.constructor&&!hasOwn.call(obj.constructor.prototype,"isPrototypeOf"))},isEmptyObject:function(obj){var name;for(name in obj)return!1;return!0},type:function(obj){return null==obj?obj+"":"object"==typeof obj||"function"==typeof obj?class2type[toString.call(obj)]||"object":typeof obj},globalEval:function(code){var script,indirect=eval;code=jQuery.trim(code),code&&(1===code.indexOf("use strict")?(script=document.createElement("script"),script.text=code,document.head.appendChild(script).parentNode.removeChild(script)):indirect(code))},camelCase:function(string){return string.replace(rmsPrefix,"ms-").replace(rdashAlpha,fcamelCase)},nodeName:function(elem,name){return elem.nodeName&&elem.nodeName.toLowerCase()===name.toLowerCase()},each:function(obj,callback,args){var value,i=0,length=obj.length,isArray=isArraylike(obj);if(args){if(isArray)for(;i<length&&(value=callback.apply(obj[i],args),value!==!1);i++);else for(i in obj)if(value=callback.apply(obj[i],args),value===!1)break}else if(isArray)for(;i<length&&(value=callback.call(obj[i],i,obj[i]),value!==!1);i++);else for(i in obj)if(value=callback.call(obj[i],i,obj[i]),value===!1)break;return obj},trim:function(text){return null==text?"":(text+"").replace(rtrim,"")},makeArray:function(arr,results){var ret=results||[];return null!=arr&&(isArraylike(Object(arr))?jQuery.merge(ret,"string"==typeof arr?[arr]:arr):push.call(ret,arr)),ret},inArray:function(elem,arr,i){return null==arr?-1:indexOf.call(arr,elem,i)},merge:function(first,second){for(var len=+second.length,j=0,i=first.length;j<len;j++)first[i++]=second[j];return first.length=i,first},grep:function(elems,callback,invert){for(var callbackInverse,matches=[],i=0,length=elems.length,callbackExpect=!invert;i<length;i++)callbackInverse=!callback(elems[i],i),callbackInverse!==callbackExpect&&matches.push(elems[i]);return matches},map:function(elems,callback,arg){var value,i=0,length=elems.length,isArray=isArraylike(elems),ret=[];if(isArray)for(;i<length;i++)value=callback(elems[i],i,arg),null!=value&&ret.push(value);else for(i in elems)value=callback(elems[i],i,arg),null!=value&&ret.push(value);return concat.apply([],ret)},guid:1,proxy:function(fn,context){var tmp,args,proxy;if("string"==typeof context&&(tmp=fn[context],context=fn,fn=tmp),jQuery.isFunction(fn))return args=slice.call(arguments,2),proxy=function(){return fn.apply(context||this,args.concat(slice.call(arguments)))},proxy.guid=fn.guid=fn.guid||jQuery.guid++,proxy},now:Date.now,support:support}),jQuery.each("Boolean Number String Function Array Date RegExp Object Error".split(" "),function(i,name){class2type["[object "+name+"]"]=name.toLowerCase()});var Sizzle=function(window){function Sizzle(selector,context,results,seed){var match,elem,m,nodeType,i,groups,old,nid,newContext,newSelector;if((context?context.ownerDocument||context:preferredDoc)!==document&&setDocument(context),context=context||document,results=results||[],nodeType=context.nodeType,"string"!=typeof selector||!selector||1!==nodeType&&9!==nodeType&&11!==nodeType)return results;if(!seed&&documentIsHTML){if(11!==nodeType&&(match=rquickExpr.exec(selector)))if(m=match[1]){if(9===nodeType){if(elem=context.getElementById(m),!elem||!elem.parentNode)return results;if(elem.id===m)return results.push(elem),results}else if(context.ownerDocument&&(elem=context.ownerDocument.getElementById(m))&&contains(context,elem)&&elem.id===m)return results.push(elem),results}else{if(match[2])return push.apply(results,context.getElementsByTagName(selector)),results;if((m=match[3])&&support.getElementsByClassName)return push.apply(results,context.getElementsByClassName(m)),results}if(support.qsa&&(!rbuggyQSA||!rbuggyQSA.test(selector))){if(nid=old=expando,newContext=context,newSelector=1!==nodeType&&selector,1===nodeType&&"object"!==context.nodeName.toLowerCase()){for(groups=tokenize(selector),(old=context.getAttribute("id"))?nid=old.replace(rescape,"\\$&"):context.setAttribute("id",nid),nid="[id='"+nid+"'] ",i=groups.length;i--;)groups[i]=nid+toSelector(groups[i]);newContext=rsibling.test(selector)&&testContext(context.parentNode)||context,newSelector=groups.join(",")}if(newSelector)try{return push.apply(results,newContext.querySelectorAll(newSelector)),results}catch(qsaError){}finally{old||context.removeAttribute("id")}}}return select(selector.replace(rtrim,"$1"),context,results,seed)}function createCache(){function cache(key,value){return keys.push(key+" ")>Expr.cacheLength&&delete cache[keys.shift()],cache[key+" "]=value}var keys=[];return cache}function markFunction(fn){return fn[expando]=!0,fn}function assert(fn){var div=document.createElement("div");try{return!!fn(div)}catch(e){return!1}finally{div.parentNode&&div.parentNode.removeChild(div),div=null}}function addHandle(attrs,handler){for(var arr=attrs.split("|"),i=attrs.length;i--;)Expr.attrHandle[arr[i]]=handler}function siblingCheck(a,b){var cur=b&&a,diff=cur&&1===a.nodeType&&1===b.nodeType&&(~b.sourceIndex||MAX_NEGATIVE)-(~a.sourceIndex||MAX_NEGATIVE);if(diff)return diff;if(cur)for(;cur=cur.nextSibling;)if(cur===b)return-1;return a?1:-1}function createInputPseudo(type){return function(elem){var name=elem.nodeName.toLowerCase();return"input"===name&&elem.type===type}}function createButtonPseudo(type){return function(elem){var name=elem.nodeName.toLowerCase();return("input"===name||"button"===name)&&elem.type===type}}function createPositionalPseudo(fn){return markFunction(function(argument){return argument=+argument,markFunction(function(seed,matches){for(var j,matchIndexes=fn([],seed.length,argument),i=matchIndexes.length;i--;)seed[j=matchIndexes[i]]&&(seed[j]=!(matches[j]=seed[j]))})})}function testContext(context){return context&&"undefined"!=typeof context.getElementsByTagName&&context}function setFilters(){}function toSelector(tokens){for(var i=0,len=tokens.length,selector="";i<len;i++)selector+=tokens[i].value;return selector}function addCombinator(matcher,combinator,base){var dir=combinator.dir,checkNonElements=base&&"parentNode"===dir,doneName=done++;return combinator.first?function(elem,context,xml){for(;elem=elem[dir];)if(1===elem.nodeType||checkNonElements)return matcher(elem,context,xml)}:function(elem,context,xml){var oldCache,outerCache,newCache=[dirruns,doneName];if(xml){for(;elem=elem[dir];)if((1===elem.nodeType||checkNonElements)&&matcher(elem,context,xml))return!0}else for(;elem=elem[dir];)if(1===elem.nodeType||checkNonElements){if(outerCache=elem[expando]||(elem[expando]={}),(oldCache=outerCache[dir])&&oldCache[0]===dirruns&&oldCache[1]===doneName)return newCache[2]=oldCache[2];if(outerCache[dir]=newCache,newCache[2]=matcher(elem,context,xml))return!0}}}function elementMatcher(matchers){return matchers.length>1?function(elem,context,xml){for(var i=matchers.length;i--;)if(!matchers[i](elem,context,xml))return!1;return!0}:matchers[0]}function multipleContexts(selector,contexts,results){for(var i=0,len=contexts.length;i<len;i++)Sizzle(selector,contexts[i],results);return results}function condense(unmatched,map,filter,context,xml){for(var elem,newUnmatched=[],i=0,len=unmatched.length,mapped=null!=map;i<len;i++)(elem=unmatched[i])&&(filter&&!filter(elem,context,xml)||(newUnmatched.push(elem),mapped&&map.push(i)));return newUnmatched}function setMatcher(preFilter,selector,matcher,postFilter,postFinder,postSelector){return postFilter&&!postFilter[expando]&&(postFilter=setMatcher(postFilter)),postFinder&&!postFinder[expando]&&(postFinder=setMatcher(postFinder,postSelector)),markFunction(function(seed,results,context,xml){var temp,i,elem,preMap=[],postMap=[],preexisting=results.length,elems=seed||multipleContexts(selector||"*",context.nodeType?[context]:context,[]),matcherIn=!preFilter||!seed&&selector?elems:condense(elems,preMap,preFilter,context,xml),matcherOut=matcher?postFinder||(seed?preFilter:preexisting||postFilter)?[]:results:matcherIn;if(matcher&&matcher(matcherIn,matcherOut,context,xml),postFilter)for(temp=condense(matcherOut,postMap),postFilter(temp,[],context,xml),i=temp.length;i--;)(elem=temp[i])&&(matcherOut[postMap[i]]=!(matcherIn[postMap[i]]=elem));if(seed){if(postFinder||preFilter){if(postFinder){for(temp=[],i=matcherOut.length;i--;)(elem=matcherOut[i])&&temp.push(matcherIn[i]=elem);postFinder(null,matcherOut=[],temp,xml)}for(i=matcherOut.length;i--;)(elem=matcherOut[i])&&(temp=postFinder?indexOf(seed,elem):preMap[i])>-1&&(seed[temp]=!(results[temp]=elem))}}else matcherOut=condense(matcherOut===results?matcherOut.splice(preexisting,matcherOut.length):matcherOut),postFinder?postFinder(null,results,matcherOut,xml):push.apply(results,matcherOut)})}function matcherFromTokens(tokens){for(var checkContext,matcher,j,len=tokens.length,leadingRelative=Expr.relative[tokens[0].type],implicitRelative=leadingRelative||Expr.relative[" "],i=leadingRelative?1:0,matchContext=addCombinator(function(elem){return elem===checkContext},implicitRelative,!0),matchAnyContext=addCombinator(function(elem){return indexOf(checkContext,elem)>-1},implicitRelative,!0),matchers=[function(elem,context,xml){var ret=!leadingRelative&&(xml||context!==outermostContext)||((checkContext=context).nodeType?matchContext(elem,context,xml):matchAnyContext(elem,context,xml));return checkContext=null,ret}];i<len;i++)if(matcher=Expr.relative[tokens[i].type])matchers=[addCombinator(elementMatcher(matchers),matcher)];else{if(matcher=Expr.filter[tokens[i].type].apply(null,tokens[i].matches),matcher[expando]){for(j=++i;j<len&&!Expr.relative[tokens[j].type];j++);return setMatcher(i>1&&elementMatcher(matchers),i>1&&toSelector(tokens.slice(0,i-1).concat({value:" "===tokens[i-2].type?"*":""})).replace(rtrim,"$1"),matcher,i<j&&matcherFromTokens(tokens.slice(i,j)),j<len&&matcherFromTokens(tokens=tokens.slice(j)),j<len&&toSelector(tokens))}matchers.push(matcher)}return elementMatcher(matchers)}function matcherFromGroupMatchers(elementMatchers,setMatchers){var bySet=setMatchers.length>0,byElement=elementMatchers.length>0,superMatcher=function(seed,context,xml,results,outermost){var elem,j,matcher,matchedCount=0,i="0",unmatched=seed&&[],setMatched=[],contextBackup=outermostContext,elems=seed||byElement&&Expr.find.TAG("*",outermost),dirrunsUnique=dirruns+=null==contextBackup?1:Math.random()||.1,len=elems.length;for(outermost&&(outermostContext=context!==document&&context);i!==len&&null!=(elem=elems[i]);i++){if(byElement&&elem){for(j=0;matcher=elementMatchers[j++];)if(matcher(elem,context,xml)){results.push(elem);break}outermost&&(dirruns=dirrunsUnique)}bySet&&((elem=!matcher&&elem)&&matchedCount--,seed&&unmatched.push(elem))}if(matchedCount+=i,bySet&&i!==matchedCount){for(j=0;matcher=setMatchers[j++];)matcher(unmatched,setMatched,context,xml);if(seed){if(matchedCount>0)for(;i--;)unmatched[i]||setMatched[i]||(setMatched[i]=pop.call(results));setMatched=condense(setMatched)}push.apply(results,setMatched),outermost&&!seed&&setMatched.length>0&&matchedCount+setMatchers.length>1&&Sizzle.uniqueSort(results)}return outermost&&(dirruns=dirrunsUnique,outermostContext=contextBackup),unmatched};return bySet?markFunction(superMatcher):superMatcher}var i,support,Expr,getText,isXML,tokenize,compile,select,outermostContext,sortInput,hasDuplicate,setDocument,document,docElem,documentIsHTML,rbuggyQSA,rbuggyMatches,matches,contains,expando="sizzle"+1*new Date,preferredDoc=window.document,dirruns=0,done=0,classCache=createCache(),tokenCache=createCache(),compilerCache=createCache(),sortOrder=function(a,b){return a===b&&(hasDuplicate=!0),0},MAX_NEGATIVE=1<<31,hasOwn={}.hasOwnProperty,arr=[],pop=arr.pop,push_native=arr.push,push=arr.push,slice=arr.slice,indexOf=function(list,elem){for(var i=0,len=list.length;i<len;i++)if(list[i]===elem)return i;return-1},booleans="checked|selected|async|autofocus|autoplay|controls|defer|disabled|hidden|ismap|loop|multiple|open|readonly|required|scoped",whitespace="[\\x20\\t\\r\\n\\f]",characterEncoding="(?:\\\\.|[\\w-]|[^\\x00-\\xa0])+",identifier=characterEncoding.replace("w","w#"),attributes="\\["+whitespace+"*("+characterEncoding+")(?:"+whitespace+"*([*^$|!~]?=)"+whitespace+"*(?:'((?:\\\\.|[^\\\\'])*)'|\"((?:\\\\.|[^\\\\\"])*)\"|("+identifier+"))|)"+whitespace+"*\\]",pseudos=":("+characterEncoding+")(?:\\((('((?:\\\\.|[^\\\\'])*)'|\"((?:\\\\.|[^\\\\\"])*)\")|((?:\\\\.|[^\\\\()[\\]]|"+attributes+")*)|.*)\\)|)",rwhitespace=new RegExp(whitespace+"+","g"),rtrim=new RegExp("^"+whitespace+"+|((?:^|[^\\\\])(?:\\\\.)*)"+whitespace+"+$","g"),rcomma=new RegExp("^"+whitespace+"*,"+whitespace+"*"),rcombinators=new RegExp("^"+whitespace+"*([>+~]|"+whitespace+")"+whitespace+"*"),rattributeQuotes=new RegExp("="+whitespace+"*([^\\]'\"]*?)"+whitespace+"*\\]","g"),rpseudo=new RegExp(pseudos),ridentifier=new RegExp("^"+identifier+"$"),matchExpr={ID:new RegExp("^#("+characterEncoding+")"),CLASS:new RegExp("^\\.("+characterEncoding+")"),TAG:new RegExp("^("+characterEncoding.replace("w","w*")+")"),ATTR:new RegExp("^"+attributes),PSEUDO:new RegExp("^"+pseudos),CHILD:new RegExp("^:(only|first|last|nth|nth-last)-(child|of-type)(?:\\("+whitespace+"*(even|odd|(([+-]|)(\\d*)n|)"+whitespace+"*(?:([+-]|)"+whitespace+"*(\\d+)|))"+whitespace+"*\\)|)","i"),bool:new RegExp("^(?:"+booleans+")$","i"),needsContext:new RegExp("^"+whitespace+"*[>+~]|:(even|odd|eq|gt|lt|nth|first|last)(?:\\("+whitespace+"*((?:-\\d)?\\d*)"+whitespace+"*\\)|)(?=[^-]|$)","i")},rinputs=/^(?:input|select|textarea|button)$/i,rheader=/^h\d$/i,rnative=/^[^{]+\{\s*\[native \w/,rquickExpr=/^(?:#([\w-]+)|(\w+)|\.([\w-]+))$/,rsibling=/[+~]/,rescape=/'|\\/g,runescape=new RegExp("\\\\([\\da-f]{1,6}"+whitespace+"?|("+whitespace+")|.)","ig"),funescape=function(_,escaped,escapedWhitespace){var high="0x"+escaped-65536;return high!==high||escapedWhitespace?escaped:high<0?String.fromCharCode(high+65536):String.fromCharCode(high>>10|55296,1023&high|56320)},unloadHandler=function(){setDocument()};try{push.apply(arr=slice.call(preferredDoc.childNodes),preferredDoc.childNodes),arr[preferredDoc.childNodes.length].nodeType}catch(e){push={apply:arr.length?function(target,els){push_native.apply(target,slice.call(els))}:function(target,els){for(var j=target.length,i=0;target[j++]=els[i++];);target.length=j-1}}}support=Sizzle.support={},isXML=Sizzle.isXML=function(elem){var documentElement=elem&&(elem.ownerDocument||elem).documentElement;return!!documentElement&&"HTML"!==documentElement.nodeName},setDocument=Sizzle.setDocument=function(node){var hasCompare,parent,doc=node?node.ownerDocument||node:preferredDoc;return doc!==document&&9===doc.nodeType&&doc.documentElement?(document=doc,docElem=doc.documentElement,parent=doc.defaultView,parent&&parent!==parent.top&&(parent.addEventListener?parent.addEventListener("unload",unloadHandler,!1):parent.attachEvent&&parent.attachEvent("onunload",unloadHandler)),documentIsHTML=!isXML(doc),support.attributes=assert(function(div){return div.className="i",!div.getAttribute("className")}),support.getElementsByTagName=assert(function(div){return div.appendChild(doc.createComment("")),!div.getElementsByTagName("*").length}),support.getElementsByClassName=rnative.test(doc.getElementsByClassName),support.getById=assert(function(div){return docElem.appendChild(div).id=expando,!doc.getElementsByName||!doc.getElementsByName(expando).length}),support.getById?(Expr.find.ID=function(id,context){if("undefined"!=typeof context.getElementById&&documentIsHTML){var m=context.getElementById(id);return m&&m.parentNode?[m]:[]}},Expr.filter.ID=function(id){var attrId=id.replace(runescape,funescape);return function(elem){return elem.getAttribute("id")===attrId}}):(delete Expr.find.ID,Expr.filter.ID=function(id){var attrId=id.replace(runescape,funescape);return function(elem){var node="undefined"!=typeof elem.getAttributeNode&&elem.getAttributeNode("id");return node&&node.value===attrId}}),Expr.find.TAG=support.getElementsByTagName?function(tag,context){return"undefined"!=typeof context.getElementsByTagName?context.getElementsByTagName(tag):support.qsa?context.querySelectorAll(tag):void 0}:function(tag,context){var elem,tmp=[],i=0,results=context.getElementsByTagName(tag);if("*"===tag){for(;elem=results[i++];)1===elem.nodeType&&tmp.push(elem);return tmp}return results},Expr.find.CLASS=support.getElementsByClassName&&function(className,context){if(documentIsHTML)return context.getElementsByClassName(className)},rbuggyMatches=[],rbuggyQSA=[],(support.qsa=rnative.test(doc.querySelectorAll))&&(assert(function(div){docElem.appendChild(div).innerHTML="<a id='"+expando+"'></a><select id='"+expando+"-\f]' msallowcapture=''><option selected=''></option></select>",div.querySelectorAll("[msallowcapture^='']").length&&rbuggyQSA.push("[*^$]="+whitespace+"*(?:''|\"\")"),div.querySelectorAll("[selected]").length||rbuggyQSA.push("\\["+whitespace+"*(?:value|"+booleans+")"),div.querySelectorAll("[id~="+expando+"-]").length||rbuggyQSA.push("~="),div.querySelectorAll(":checked").length||rbuggyQSA.push(":checked"),div.querySelectorAll("a#"+expando+"+*").length||rbuggyQSA.push(".#.+[+~]")}),assert(function(div){var input=doc.createElement("input");input.setAttribute("type","hidden"),div.appendChild(input).setAttribute("name","D"),div.querySelectorAll("[name=d]").length&&rbuggyQSA.push("name"+whitespace+"*[*^$|!~]?="),div.querySelectorAll(":enabled").length||rbuggyQSA.push(":enabled",":disabled"),div.querySelectorAll("*,:x"),rbuggyQSA.push(",.*:")})),(support.matchesSelector=rnative.test(matches=docElem.matches||docElem.webkitMatchesSelector||docElem.mozMatchesSelector||docElem.oMatchesSelector||docElem.msMatchesSelector))&&assert(function(div){support.disconnectedMatch=matches.call(div,"div"),matches.call(div,"[s!='']:x"),rbuggyMatches.push("!=",pseudos)}),rbuggyQSA=rbuggyQSA.length&&new RegExp(rbuggyQSA.join("|")),rbuggyMatches=rbuggyMatches.length&&new RegExp(rbuggyMatches.join("|")),hasCompare=rnative.test(docElem.compareDocumentPosition),contains=hasCompare||rnative.test(docElem.contains)?function(a,b){var adown=9===a.nodeType?a.documentElement:a,bup=b&&b.parentNode;return a===bup||!(!bup||1!==bup.nodeType||!(adown.contains?adown.contains(bup):a.compareDocumentPosition&&16&a.compareDocumentPosition(bup)))}:function(a,b){if(b)for(;b=b.parentNode;)if(b===a)return!0;return!1},sortOrder=hasCompare?function(a,b){if(a===b)return hasDuplicate=!0,0;var compare=!a.compareDocumentPosition-!b.compareDocumentPosition;return compare?compare:(compare=(a.ownerDocument||a)===(b.ownerDocument||b)?a.compareDocumentPosition(b):1,1&compare||!support.sortDetached&&b.compareDocumentPosition(a)===compare?a===doc||a.ownerDocument===preferredDoc&&contains(preferredDoc,a)?-1:b===doc||b.ownerDocument===preferredDoc&&contains(preferredDoc,b)?1:sortInput?indexOf(sortInput,a)-indexOf(sortInput,b):0:4&compare?-1:1)}:function(a,b){if(a===b)return hasDuplicate=!0,0;var cur,i=0,aup=a.parentNode,bup=b.parentNode,ap=[a],bp=[b];if(!aup||!bup)return a===doc?-1:b===doc?1:aup?-1:bup?1:sortInput?indexOf(sortInput,a)-indexOf(sortInput,b):0;if(aup===bup)return siblingCheck(a,b);for(cur=a;cur=cur.parentNode;)ap.unshift(cur);for(cur=b;cur=cur.parentNode;)bp.unshift(cur);for(;ap[i]===bp[i];)i++;return i?siblingCheck(ap[i],bp[i]):ap[i]===preferredDoc?-1:bp[i]===preferredDoc?1:0},doc):document},Sizzle.matches=function(expr,elements){return Sizzle(expr,null,null,elements)},Sizzle.matchesSelector=function(elem,expr){if((elem.ownerDocument||elem)!==document&&setDocument(elem),expr=expr.replace(rattributeQuotes,"='$1']"),support.matchesSelector&&documentIsHTML&&(!rbuggyMatches||!rbuggyMatches.test(expr))&&(!rbuggyQSA||!rbuggyQSA.test(expr)))try{var ret=matches.call(elem,expr);if(ret||support.disconnectedMatch||elem.document&&11!==elem.document.nodeType)return ret}catch(e){}return Sizzle(expr,document,null,[elem]).length>0},Sizzle.contains=function(context,elem){return(context.ownerDocument||context)!==document&&setDocument(context),contains(context,elem)},Sizzle.attr=function(elem,name){(elem.ownerDocument||elem)!==document&&setDocument(elem);var fn=Expr.attrHandle[name.toLowerCase()],val=fn&&hasOwn.call(Expr.attrHandle,name.toLowerCase())?fn(elem,name,!documentIsHTML):void 0;return void 0!==val?val:support.attributes||!documentIsHTML?elem.getAttribute(name):(val=elem.getAttributeNode(name))&&val.specified?val.value:null},Sizzle.error=function(msg){throw new Error("Syntax error, unrecognized expression: "+msg)},Sizzle.uniqueSort=function(results){var elem,duplicates=[],j=0,i=0;if(hasDuplicate=!support.detectDuplicates,sortInput=!support.sortStable&&results.slice(0),results.sort(sortOrder),hasDuplicate){for(;elem=results[i++];)elem===results[i]&&(j=duplicates.push(i));for(;j--;)results.splice(duplicates[j],1)}return sortInput=null,results},getText=Sizzle.getText=function(elem){var node,ret="",i=0,nodeType=elem.nodeType;if(nodeType){if(1===nodeType||9===nodeType||11===nodeType){if("string"==typeof elem.textContent)return elem.textContent;for(elem=elem.firstChild;elem;elem=elem.nextSibling)ret+=getText(elem)}else if(3===nodeType||4===nodeType)return elem.nodeValue}else for(;node=elem[i++];)ret+=getText(node);return ret},Expr=Sizzle.selectors={cacheLength:50,createPseudo:markFunction,match:matchExpr,attrHandle:{},find:{},relative:{">":{dir:"parentNode",first:!0}," ":{dir:"parentNode"},"+":{dir:"previousSibling",first:!0},"~":{dir:"previousSibling"}},preFilter:{ATTR:function(match){return match[1]=match[1].replace(runescape,funescape),match[3]=(match[3]||match[4]||match[5]||"").replace(runescape,funescape),"~="===match[2]&&(match[3]=" "+match[3]+" "),match.slice(0,4)},CHILD:function(match){return match[1]=match[1].toLowerCase(),"nth"===match[1].slice(0,3)?(match[3]||Sizzle.error(match[0]),match[4]=+(match[4]?match[5]+(match[6]||1):2*("even"===match[3]||"odd"===match[3])),match[5]=+(match[7]+match[8]||"odd"===match[3])):match[3]&&Sizzle.error(match[0]),match},PSEUDO:function(match){var excess,unquoted=!match[6]&&match[2];return matchExpr.CHILD.test(match[0])?null:(match[3]?match[2]=match[4]||match[5]||"":unquoted&&rpseudo.test(unquoted)&&(excess=tokenize(unquoted,!0))&&(excess=unquoted.indexOf(")",unquoted.length-excess)-unquoted.length)&&(match[0]=match[0].slice(0,excess),match[2]=unquoted.slice(0,excess)),match.slice(0,3))}},filter:{TAG:function(nodeNameSelector){var nodeName=nodeNameSelector.replace(runescape,funescape).toLowerCase();return"*"===nodeNameSelector?function(){return!0}:function(elem){return elem.nodeName&&elem.nodeName.toLowerCase()===nodeName}},CLASS:function(className){var pattern=classCache[className+" "];return pattern||(pattern=new RegExp("(^|"+whitespace+")"+className+"("+whitespace+"|$)"))&&classCache(className,function(elem){return pattern.test("string"==typeof elem.className&&elem.className||"undefined"!=typeof elem.getAttribute&&elem.getAttribute("class")||"")})},ATTR:function(name,operator,check){return function(elem){var result=Sizzle.attr(elem,name);return null==result?"!="===operator:!operator||(result+="","="===operator?result===check:"!="===operator?result!==check:"^="===operator?check&&0===result.indexOf(check):"*="===operator?check&&result.indexOf(check)>-1:"$="===operator?check&&result.slice(-check.length)===check:"~="===operator?(" "+result.replace(rwhitespace," ")+" ").indexOf(check)>-1:"|="===operator&&(result===check||result.slice(0,check.length+1)===check+"-"))}},CHILD:function(type,what,argument,first,last){var simple="nth"!==type.slice(0,3),forward="last"!==type.slice(-4),ofType="of-type"===what;return 1===first&&0===last?function(elem){return!!elem.parentNode}:function(elem,context,xml){var cache,outerCache,node,diff,nodeIndex,start,dir=simple!==forward?"nextSibling":"previousSibling",parent=elem.parentNode,name=ofType&&elem.nodeName.toLowerCase(),useCache=!xml&&!ofType;if(parent){if(simple){for(;dir;){for(node=elem;node=node[dir];)if(ofType?node.nodeName.toLowerCase()===name:1===node.nodeType)return!1;start=dir="only"===type&&!start&&"nextSibling"}return!0}if(start=[forward?parent.firstChild:parent.lastChild],forward&&useCache){for(outerCache=parent[expando]||(parent[expando]={}),cache=outerCache[type]||[],nodeIndex=cache[0]===dirruns&&cache[1],diff=cache[0]===dirruns&&cache[2],node=nodeIndex&&parent.childNodes[nodeIndex];node=++nodeIndex&&node&&node[dir]||(diff=nodeIndex=0)||start.pop();)if(1===node.nodeType&&++diff&&node===elem){outerCache[type]=[dirruns,nodeIndex,diff];break}}else if(useCache&&(cache=(elem[expando]||(elem[expando]={}))[type])&&cache[0]===dirruns)diff=cache[1];else for(;(node=++nodeIndex&&node&&node[dir]||(diff=nodeIndex=0)||start.pop())&&((ofType?node.nodeName.toLowerCase()!==name:1!==node.nodeType)||!++diff||(useCache&&((node[expando]||(node[expando]={}))[type]=[dirruns,diff]),node!==elem)););return diff-=last,diff===first||diff%first===0&&diff/first>=0}}},PSEUDO:function(pseudo,argument){var args,fn=Expr.pseudos[pseudo]||Expr.setFilters[pseudo.toLowerCase()]||Sizzle.error("unsupported pseudo: "+pseudo);return fn[expando]?fn(argument):fn.length>1?(args=[pseudo,pseudo,"",argument],Expr.setFilters.hasOwnProperty(pseudo.toLowerCase())?markFunction(function(seed,matches){for(var idx,matched=fn(seed,argument),i=matched.length;i--;)idx=indexOf(seed,matched[i]),seed[idx]=!(matches[idx]=matched[i])}):function(elem){return fn(elem,0,args)}):fn}},pseudos:{not:markFunction(function(selector){var input=[],results=[],matcher=compile(selector.replace(rtrim,"$1"));return matcher[expando]?markFunction(function(seed,matches,context,xml){for(var elem,unmatched=matcher(seed,null,xml,[]),i=seed.length;i--;)(elem=unmatched[i])&&(seed[i]=!(matches[i]=elem))}):function(elem,context,xml){return input[0]=elem,matcher(input,null,xml,results),input[0]=null,!results.pop()}}),has:markFunction(function(selector){return function(elem){return Sizzle(selector,elem).length>0}}),contains:markFunction(function(text){return text=text.replace(runescape,funescape),function(elem){return(elem.textContent||elem.innerText||getText(elem)).indexOf(text)>-1}}),lang:markFunction(function(lang){return ridentifier.test(lang||"")||Sizzle.error("unsupported lang: "+lang),lang=lang.replace(runescape,funescape).toLowerCase(),function(elem){var elemLang;do if(elemLang=documentIsHTML?elem.lang:elem.getAttribute("xml:lang")||elem.getAttribute("lang"))return elemLang=elemLang.toLowerCase(),elemLang===lang||0===elemLang.indexOf(lang+"-");while((elem=elem.parentNode)&&1===elem.nodeType);return!1}}),target:function(elem){var hash=window.location&&window.location.hash;return hash&&hash.slice(1)===elem.id},root:function(elem){return elem===docElem},focus:function(elem){return elem===document.activeElement&&(!document.hasFocus||document.hasFocus())&&!!(elem.type||elem.href||~elem.tabIndex)},enabled:function(elem){return elem.disabled===!1},disabled:function(elem){return elem.disabled===!0},checked:function(elem){var nodeName=elem.nodeName.toLowerCase();return"input"===nodeName&&!!elem.checked||"option"===nodeName&&!!elem.selected},selected:function(elem){return elem.parentNode&&elem.parentNode.selectedIndex,elem.selected===!0},empty:function(elem){for(elem=elem.firstChild;elem;elem=elem.nextSibling)if(elem.nodeType<6)return!1;return!0},parent:function(elem){return!Expr.pseudos.empty(elem)},header:function(elem){return rheader.test(elem.nodeName)},input:function(elem){return rinputs.test(elem.nodeName)},button:function(elem){var name=elem.nodeName.toLowerCase();return"input"===name&&"button"===elem.type||"button"===name},text:function(elem){var attr;return"input"===elem.nodeName.toLowerCase()&&"text"===elem.type&&(null==(attr=elem.getAttribute("type"))||"text"===attr.toLowerCase())},first:createPositionalPseudo(function(){return[0]}),last:createPositionalPseudo(function(matchIndexes,length){return[length-1]}),eq:createPositionalPseudo(function(matchIndexes,length,argument){return[argument<0?argument+length:argument]}),even:createPositionalPseudo(function(matchIndexes,length){for(var i=0;i<length;i+=2)matchIndexes.push(i);return matchIndexes}),odd:createPositionalPseudo(function(matchIndexes,length){for(var i=1;i<length;i+=2)matchIndexes.push(i);return matchIndexes}),lt:createPositionalPseudo(function(matchIndexes,length,argument){for(var i=argument<0?argument+length:argument;--i>=0;)matchIndexes.push(i);return matchIndexes}),gt:createPositionalPseudo(function(matchIndexes,length,argument){for(var i=argument<0?argument+length:argument;++i<length;)matchIndexes.push(i);return matchIndexes})}},Expr.pseudos.nth=Expr.pseudos.eq;for(i in{radio:!0,checkbox:!0,file:!0,password:!0,image:!0})Expr.pseudos[i]=createInputPseudo(i);for(i in{submit:!0,reset:!0})Expr.pseudos[i]=createButtonPseudo(i);return setFilters.prototype=Expr.filters=Expr.pseudos,Expr.setFilters=new setFilters,tokenize=Sizzle.tokenize=function(selector,parseOnly){var matched,match,tokens,type,soFar,groups,preFilters,cached=tokenCache[selector+" "];if(cached)return parseOnly?0:cached.slice(0);for(soFar=selector,groups=[],preFilters=Expr.preFilter;soFar;){matched&&!(match=rcomma.exec(soFar))||(match&&(soFar=soFar.slice(match[0].length)||soFar),groups.push(tokens=[])),matched=!1,(match=rcombinators.exec(soFar))&&(matched=match.shift(),tokens.push({value:matched,type:match[0].replace(rtrim," ")}),soFar=soFar.slice(matched.length));for(type in Expr.filter)!(match=matchExpr[type].exec(soFar))||preFilters[type]&&!(match=preFilters[type](match))||(matched=match.shift(),tokens.push({value:matched,type:type,matches:match}),soFar=soFar.slice(matched.length));if(!matched)break}return parseOnly?soFar.length:soFar?Sizzle.error(selector):tokenCache(selector,groups).slice(0)},compile=Sizzle.compile=function(selector,match){var i,setMatchers=[],elementMatchers=[],cached=compilerCache[selector+" "];if(!cached){for(match||(match=tokenize(selector)),i=match.length;i--;)cached=matcherFromTokens(match[i]),cached[expando]?setMatchers.push(cached):elementMatchers.push(cached);cached=compilerCache(selector,matcherFromGroupMatchers(elementMatchers,setMatchers)),cached.selector=selector}return cached},select=Sizzle.select=function(selector,context,results,seed){var i,tokens,token,type,find,compiled="function"==typeof selector&&selector,match=!seed&&tokenize(selector=compiled.selector||selector);if(results=results||[],1===match.length){if(tokens=match[0]=match[0].slice(0),tokens.length>2&&"ID"===(token=tokens[0]).type&&support.getById&&9===context.nodeType&&documentIsHTML&&Expr.relative[tokens[1].type]){if(context=(Expr.find.ID(token.matches[0].replace(runescape,funescape),context)||[])[0],!context)return results;compiled&&(context=context.parentNode),selector=selector.slice(tokens.shift().value.length)}for(i=matchExpr.needsContext.test(selector)?0:tokens.length;i--&&(token=tokens[i],!Expr.relative[type=token.type]);)if((find=Expr.find[type])&&(seed=find(token.matches[0].replace(runescape,funescape),rsibling.test(tokens[0].type)&&testContext(context.parentNode)||context))){
if(tokens.splice(i,1),selector=seed.length&&toSelector(tokens),!selector)return push.apply(results,seed),results;break}}return(compiled||compile(selector,match))(seed,context,!documentIsHTML,results,rsibling.test(selector)&&testContext(context.parentNode)||context),results},support.sortStable=expando.split("").sort(sortOrder).join("")===expando,support.detectDuplicates=!!hasDuplicate,setDocument(),support.sortDetached=assert(function(div1){return 1&div1.compareDocumentPosition(document.createElement("div"))}),assert(function(div){return div.innerHTML="<a href='#'></a>","#"===div.firstChild.getAttribute("href")})||addHandle("type|href|height|width",function(elem,name,isXML){if(!isXML)return elem.getAttribute(name,"type"===name.toLowerCase()?1:2)}),support.attributes&&assert(function(div){return div.innerHTML="<input/>",div.firstChild.setAttribute("value",""),""===div.firstChild.getAttribute("value")})||addHandle("value",function(elem,name,isXML){if(!isXML&&"input"===elem.nodeName.toLowerCase())return elem.defaultValue}),assert(function(div){return null==div.getAttribute("disabled")})||addHandle(booleans,function(elem,name,isXML){var val;if(!isXML)return elem[name]===!0?name.toLowerCase():(val=elem.getAttributeNode(name))&&val.specified?val.value:null}),Sizzle}(window);jQuery.find=Sizzle,jQuery.expr=Sizzle.selectors,jQuery.expr[":"]=jQuery.expr.pseudos,jQuery.unique=Sizzle.uniqueSort,jQuery.text=Sizzle.getText,jQuery.isXMLDoc=Sizzle.isXML,jQuery.contains=Sizzle.contains;var rneedsContext=jQuery.expr.match.needsContext,rsingleTag=/^<(\w+)\s*\/?>(?:<\/\1>|)$/,risSimple=/^.[^:#\[\.,]*$/;jQuery.filter=function(expr,elems,not){var elem=elems[0];return not&&(expr=":not("+expr+")"),1===elems.length&&1===elem.nodeType?jQuery.find.matchesSelector(elem,expr)?[elem]:[]:jQuery.find.matches(expr,jQuery.grep(elems,function(elem){return 1===elem.nodeType}))},jQuery.fn.extend({find:function(selector){var i,len=this.length,ret=[],self=this;if("string"!=typeof selector)return this.pushStack(jQuery(selector).filter(function(){for(i=0;i<len;i++)if(jQuery.contains(self[i],this))return!0}));for(i=0;i<len;i++)jQuery.find(selector,self[i],ret);return ret=this.pushStack(len>1?jQuery.unique(ret):ret),ret.selector=this.selector?this.selector+" "+selector:selector,ret},filter:function(selector){return this.pushStack(winnow(this,selector||[],!1))},not:function(selector){return this.pushStack(winnow(this,selector||[],!0))},is:function(selector){return!!winnow(this,"string"==typeof selector&&rneedsContext.test(selector)?jQuery(selector):selector||[],!1).length}});var rootjQuery,rquickExpr=/^(?:\s*(<[\w\W]+>)[^>]*|#([\w-]*))$/,init=jQuery.fn.init=function(selector,context){var match,elem;if(!selector)return this;if("string"==typeof selector){if(match="<"===selector[0]&&">"===selector[selector.length-1]&&selector.length>=3?[null,selector,null]:rquickExpr.exec(selector),!match||!match[1]&&context)return!context||context.jquery?(context||rootjQuery).find(selector):this.constructor(context).find(selector);if(match[1]){if(context=context instanceof jQuery?context[0]:context,jQuery.merge(this,jQuery.parseHTML(match[1],context&&context.nodeType?context.ownerDocument||context:document,!0)),rsingleTag.test(match[1])&&jQuery.isPlainObject(context))for(match in context)jQuery.isFunction(this[match])?this[match](context[match]):this.attr(match,context[match]);return this}return elem=document.getElementById(match[2]),elem&&elem.parentNode&&(this.length=1,this[0]=elem),this.context=document,this.selector=selector,this}return selector.nodeType?(this.context=this[0]=selector,this.length=1,this):jQuery.isFunction(selector)?"undefined"!=typeof rootjQuery.ready?rootjQuery.ready(selector):selector(jQuery):(void 0!==selector.selector&&(this.selector=selector.selector,this.context=selector.context),jQuery.makeArray(selector,this))};init.prototype=jQuery.fn,rootjQuery=jQuery(document);var rparentsprev=/^(?:parents|prev(?:Until|All))/,guaranteedUnique={children:!0,contents:!0,next:!0,prev:!0};jQuery.extend({dir:function(elem,dir,until){for(var matched=[],truncate=void 0!==until;(elem=elem[dir])&&9!==elem.nodeType;)if(1===elem.nodeType){if(truncate&&jQuery(elem).is(until))break;matched.push(elem)}return matched},sibling:function(n,elem){for(var matched=[];n;n=n.nextSibling)1===n.nodeType&&n!==elem&&matched.push(n);return matched}}),jQuery.fn.extend({has:function(target){var targets=jQuery(target,this),l=targets.length;return this.filter(function(){for(var i=0;i<l;i++)if(jQuery.contains(this,targets[i]))return!0})},closest:function(selectors,context){for(var cur,i=0,l=this.length,matched=[],pos=rneedsContext.test(selectors)||"string"!=typeof selectors?jQuery(selectors,context||this.context):0;i<l;i++)for(cur=this[i];cur&&cur!==context;cur=cur.parentNode)if(cur.nodeType<11&&(pos?pos.index(cur)>-1:1===cur.nodeType&&jQuery.find.matchesSelector(cur,selectors))){matched.push(cur);break}return this.pushStack(matched.length>1?jQuery.unique(matched):matched)},index:function(elem){return elem?"string"==typeof elem?indexOf.call(jQuery(elem),this[0]):indexOf.call(this,elem.jquery?elem[0]:elem):this[0]&&this[0].parentNode?this.first().prevAll().length:-1},add:function(selector,context){return this.pushStack(jQuery.unique(jQuery.merge(this.get(),jQuery(selector,context))))},addBack:function(selector){return this.add(null==selector?this.prevObject:this.prevObject.filter(selector))}}),jQuery.each({parent:function(elem){var parent=elem.parentNode;return parent&&11!==parent.nodeType?parent:null},parents:function(elem){return jQuery.dir(elem,"parentNode")},parentsUntil:function(elem,i,until){return jQuery.dir(elem,"parentNode",until)},next:function(elem){return sibling(elem,"nextSibling")},prev:function(elem){return sibling(elem,"previousSibling")},nextAll:function(elem){return jQuery.dir(elem,"nextSibling")},prevAll:function(elem){return jQuery.dir(elem,"previousSibling")},nextUntil:function(elem,i,until){return jQuery.dir(elem,"nextSibling",until)},prevUntil:function(elem,i,until){return jQuery.dir(elem,"previousSibling",until)},siblings:function(elem){return jQuery.sibling((elem.parentNode||{}).firstChild,elem)},children:function(elem){return jQuery.sibling(elem.firstChild)},contents:function(elem){return elem.contentDocument||jQuery.merge([],elem.childNodes)}},function(name,fn){jQuery.fn[name]=function(until,selector){var matched=jQuery.map(this,fn,until);return"Until"!==name.slice(-5)&&(selector=until),selector&&"string"==typeof selector&&(matched=jQuery.filter(selector,matched)),this.length>1&&(guaranteedUnique[name]||jQuery.unique(matched),rparentsprev.test(name)&&matched.reverse()),this.pushStack(matched)}});var rnotwhite=/\S+/g,optionsCache={};jQuery.Callbacks=function(options){options="string"==typeof options?optionsCache[options]||createOptions(options):jQuery.extend({},options);var memory,fired,firing,firingStart,firingLength,firingIndex,list=[],stack=!options.once&&[],fire=function(data){for(memory=options.memory&&data,fired=!0,firingIndex=firingStart||0,firingStart=0,firingLength=list.length,firing=!0;list&&firingIndex<firingLength;firingIndex++)if(list[firingIndex].apply(data[0],data[1])===!1&&options.stopOnFalse){memory=!1;break}firing=!1,list&&(stack?stack.length&&fire(stack.shift()):memory?list=[]:self.disable())},self={add:function(){if(list){var start=list.length;!function add(args){jQuery.each(args,function(_,arg){var type=jQuery.type(arg);"function"===type?options.unique&&self.has(arg)||list.push(arg):arg&&arg.length&&"string"!==type&&add(arg)})}(arguments),firing?firingLength=list.length:memory&&(firingStart=start,fire(memory))}return this},remove:function(){return list&&jQuery.each(arguments,function(_,arg){for(var index;(index=jQuery.inArray(arg,list,index))>-1;)list.splice(index,1),firing&&(index<=firingLength&&firingLength--,index<=firingIndex&&firingIndex--)}),this},has:function(fn){return fn?jQuery.inArray(fn,list)>-1:!(!list||!list.length)},empty:function(){return list=[],firingLength=0,this},disable:function(){return list=stack=memory=void 0,this},disabled:function(){return!list},lock:function(){return stack=void 0,memory||self.disable(),this},locked:function(){return!stack},fireWith:function(context,args){return!list||fired&&!stack||(args=args||[],args=[context,args.slice?args.slice():args],firing?stack.push(args):fire(args)),this},fire:function(){return self.fireWith(this,arguments),this},fired:function(){return!!fired}};return self},jQuery.extend({Deferred:function(func){var tuples=[["resolve","done",jQuery.Callbacks("once memory"),"resolved"],["reject","fail",jQuery.Callbacks("once memory"),"rejected"],["notify","progress",jQuery.Callbacks("memory")]],state="pending",promise={state:function(){return state},always:function(){return deferred.done(arguments).fail(arguments),this},then:function(){var fns=arguments;return jQuery.Deferred(function(newDefer){jQuery.each(tuples,function(i,tuple){var fn=jQuery.isFunction(fns[i])&&fns[i];deferred[tuple[1]](function(){var returned=fn&&fn.apply(this,arguments);returned&&jQuery.isFunction(returned.promise)?returned.promise().done(newDefer.resolve).fail(newDefer.reject).progress(newDefer.notify):newDefer[tuple[0]+"With"](this===promise?newDefer.promise():this,fn?[returned]:arguments)})}),fns=null}).promise()},promise:function(obj){return null!=obj?jQuery.extend(obj,promise):promise}},deferred={};return promise.pipe=promise.then,jQuery.each(tuples,function(i,tuple){var list=tuple[2],stateString=tuple[3];promise[tuple[1]]=list.add,stateString&&list.add(function(){state=stateString},tuples[1^i][2].disable,tuples[2][2].lock),deferred[tuple[0]]=function(){return deferred[tuple[0]+"With"](this===deferred?promise:this,arguments),this},deferred[tuple[0]+"With"]=list.fireWith}),promise.promise(deferred),func&&func.call(deferred,deferred),deferred},when:function(subordinate){var progressValues,progressContexts,resolveContexts,i=0,resolveValues=slice.call(arguments),length=resolveValues.length,remaining=1!==length||subordinate&&jQuery.isFunction(subordinate.promise)?length:0,deferred=1===remaining?subordinate:jQuery.Deferred(),updateFunc=function(i,contexts,values){return function(value){contexts[i]=this,values[i]=arguments.length>1?slice.call(arguments):value,values===progressValues?deferred.notifyWith(contexts,values):--remaining||deferred.resolveWith(contexts,values)}};if(length>1)for(progressValues=new Array(length),progressContexts=new Array(length),resolveContexts=new Array(length);i<length;i++)resolveValues[i]&&jQuery.isFunction(resolveValues[i].promise)?resolveValues[i].promise().done(updateFunc(i,resolveContexts,resolveValues)).fail(deferred.reject).progress(updateFunc(i,progressContexts,progressValues)):--remaining;return remaining||deferred.resolveWith(resolveContexts,resolveValues),deferred.promise()}});var readyList;jQuery.fn.ready=function(fn){return jQuery.ready.promise().done(fn),this},jQuery.extend({isReady:!1,readyWait:1,holdReady:function(hold){hold?jQuery.readyWait++:jQuery.ready(!0)},ready:function(wait){(wait===!0?--jQuery.readyWait:jQuery.isReady)||(jQuery.isReady=!0,wait!==!0&&--jQuery.readyWait>0||(readyList.resolveWith(document,[jQuery]),jQuery.fn.triggerHandler&&(jQuery(document).triggerHandler("ready"),jQuery(document).off("ready"))))}}),jQuery.ready.promise=function(obj){return readyList||(readyList=jQuery.Deferred(),"complete"===document.readyState?setTimeout(jQuery.ready):(document.addEventListener("DOMContentLoaded",completed,!1),window.addEventListener("load",completed,!1))),readyList.promise(obj)},jQuery.ready.promise();var access=jQuery.access=function(elems,fn,key,value,chainable,emptyGet,raw){var i=0,len=elems.length,bulk=null==key;if("object"===jQuery.type(key)){chainable=!0;for(i in key)jQuery.access(elems,fn,i,key[i],!0,emptyGet,raw)}else if(void 0!==value&&(chainable=!0,jQuery.isFunction(value)||(raw=!0),bulk&&(raw?(fn.call(elems,value),fn=null):(bulk=fn,fn=function(elem,key,value){return bulk.call(jQuery(elem),value)})),fn))for(;i<len;i++)fn(elems[i],key,raw?value:value.call(elems[i],i,fn(elems[i],key)));return chainable?elems:bulk?fn.call(elems):len?fn(elems[0],key):emptyGet};jQuery.acceptData=function(owner){return 1===owner.nodeType||9===owner.nodeType||!+owner.nodeType},Data.uid=1,Data.accepts=jQuery.acceptData,Data.prototype={key:function(owner){if(!Data.accepts(owner))return 0;var descriptor={},unlock=owner[this.expando];if(!unlock){unlock=Data.uid++;try{descriptor[this.expando]={value:unlock},Object.defineProperties(owner,descriptor)}catch(e){descriptor[this.expando]=unlock,jQuery.extend(owner,descriptor)}}return this.cache[unlock]||(this.cache[unlock]={}),unlock},set:function(owner,data,value){var prop,unlock=this.key(owner),cache=this.cache[unlock];if("string"==typeof data)cache[data]=value;else if(jQuery.isEmptyObject(cache))jQuery.extend(this.cache[unlock],data);else for(prop in data)cache[prop]=data[prop];return cache},get:function(owner,key){var cache=this.cache[this.key(owner)];return void 0===key?cache:cache[key]},access:function(owner,key,value){var stored;return void 0===key||key&&"string"==typeof key&&void 0===value?(stored=this.get(owner,key),void 0!==stored?stored:this.get(owner,jQuery.camelCase(key))):(this.set(owner,key,value),void 0!==value?value:key)},remove:function(owner,key){var i,name,camel,unlock=this.key(owner),cache=this.cache[unlock];if(void 0===key)this.cache[unlock]={};else{jQuery.isArray(key)?name=key.concat(key.map(jQuery.camelCase)):(camel=jQuery.camelCase(key),key in cache?name=[key,camel]:(name=camel,name=name in cache?[name]:name.match(rnotwhite)||[])),i=name.length;for(;i--;)delete cache[name[i]]}},hasData:function(owner){return!jQuery.isEmptyObject(this.cache[owner[this.expando]]||{})},discard:function(owner){owner[this.expando]&&delete this.cache[owner[this.expando]]}};var data_priv=new Data,data_user=new Data,rbrace=/^(?:\{[\w\W]*\}|\[[\w\W]*\])$/,rmultiDash=/([A-Z])/g;jQuery.extend({hasData:function(elem){return data_user.hasData(elem)||data_priv.hasData(elem)},data:function(elem,name,data){return data_user.access(elem,name,data)},removeData:function(elem,name){data_user.remove(elem,name)},_data:function(elem,name,data){return data_priv.access(elem,name,data)},_removeData:function(elem,name){data_priv.remove(elem,name)}}),jQuery.fn.extend({data:function(key,value){var i,name,data,elem=this[0],attrs=elem&&elem.attributes;if(void 0===key){if(this.length&&(data=data_user.get(elem),1===elem.nodeType&&!data_priv.get(elem,"hasDataAttrs"))){for(i=attrs.length;i--;)attrs[i]&&(name=attrs[i].name,0===name.indexOf("data-")&&(name=jQuery.camelCase(name.slice(5)),dataAttr(elem,name,data[name])));data_priv.set(elem,"hasDataAttrs",!0)}return data}return"object"==typeof key?this.each(function(){data_user.set(this,key)}):access(this,function(value){var data,camelKey=jQuery.camelCase(key);if(elem&&void 0===value){if(data=data_user.get(elem,key),void 0!==data)return data;if(data=data_user.get(elem,camelKey),void 0!==data)return data;if(data=dataAttr(elem,camelKey,void 0),void 0!==data)return data}else this.each(function(){var data=data_user.get(this,camelKey);data_user.set(this,camelKey,value),key.indexOf("-")!==-1&&void 0!==data&&data_user.set(this,key,value)})},null,value,arguments.length>1,null,!0)},removeData:function(key){return this.each(function(){data_user.remove(this,key)})}}),jQuery.extend({queue:function(elem,type,data){var queue;if(elem)return type=(type||"fx")+"queue",queue=data_priv.get(elem,type),data&&(!queue||jQuery.isArray(data)?queue=data_priv.access(elem,type,jQuery.makeArray(data)):queue.push(data)),queue||[]},dequeue:function(elem,type){type=type||"fx";var queue=jQuery.queue(elem,type),startLength=queue.length,fn=queue.shift(),hooks=jQuery._queueHooks(elem,type),next=function(){jQuery.dequeue(elem,type)};"inprogress"===fn&&(fn=queue.shift(),startLength--),fn&&("fx"===type&&queue.unshift("inprogress"),delete hooks.stop,fn.call(elem,next,hooks)),!startLength&&hooks&&hooks.empty.fire()},_queueHooks:function(elem,type){var key=type+"queueHooks";return data_priv.get(elem,key)||data_priv.access(elem,key,{empty:jQuery.Callbacks("once memory").add(function(){data_priv.remove(elem,[type+"queue",key])})})}}),jQuery.fn.extend({queue:function(type,data){var setter=2;return"string"!=typeof type&&(data=type,type="fx",setter--),arguments.length<setter?jQuery.queue(this[0],type):void 0===data?this:this.each(function(){var queue=jQuery.queue(this,type,data);jQuery._queueHooks(this,type),"fx"===type&&"inprogress"!==queue[0]&&jQuery.dequeue(this,type)})},dequeue:function(type){return this.each(function(){jQuery.dequeue(this,type)})},clearQueue:function(type){return this.queue(type||"fx",[])},promise:function(type,obj){var tmp,count=1,defer=jQuery.Deferred(),elements=this,i=this.length,resolve=function(){--count||defer.resolveWith(elements,[elements])};for("string"!=typeof type&&(obj=type,type=void 0),type=type||"fx";i--;)tmp=data_priv.get(elements[i],type+"queueHooks"),tmp&&tmp.empty&&(count++,tmp.empty.add(resolve));return resolve(),defer.promise(obj)}});var pnum=/[+-]?(?:\d*\.|)\d+(?:[eE][+-]?\d+|)/.source,cssExpand=["Top","Right","Bottom","Left"],isHidden=function(elem,el){return elem=el||elem,"none"===jQuery.css(elem,"display")||!jQuery.contains(elem.ownerDocument,elem)},rcheckableType=/^(?:checkbox|radio)$/i;!function(){var fragment=document.createDocumentFragment(),div=fragment.appendChild(document.createElement("div")),input=document.createElement("input");input.setAttribute("type","radio"),input.setAttribute("checked","checked"),input.setAttribute("name","t"),div.appendChild(input),support.checkClone=div.cloneNode(!0).cloneNode(!0).lastChild.checked,div.innerHTML="<textarea>x</textarea>",support.noCloneChecked=!!div.cloneNode(!0).lastChild.defaultValue}();var strundefined="undefined";support.focusinBubbles="onfocusin"in window;var rkeyEvent=/^key/,rmouseEvent=/^(?:mouse|pointer|contextmenu)|click/,rfocusMorph=/^(?:focusinfocus|focusoutblur)$/,rtypenamespace=/^([^.]*)(?:\.(.+)|)$/;jQuery.event={global:{},add:function(elem,types,handler,data,selector){var handleObjIn,eventHandle,tmp,events,t,handleObj,special,handlers,type,namespaces,origType,elemData=data_priv.get(elem);if(elemData)for(handler.handler&&(handleObjIn=handler,handler=handleObjIn.handler,selector=handleObjIn.selector),handler.guid||(handler.guid=jQuery.guid++),(events=elemData.events)||(events=elemData.events={}),(eventHandle=elemData.handle)||(eventHandle=elemData.handle=function(e){return typeof jQuery!==strundefined&&jQuery.event.triggered!==e.type?jQuery.event.dispatch.apply(elem,arguments):void 0}),types=(types||"").match(rnotwhite)||[""],t=types.length;t--;)tmp=rtypenamespace.exec(types[t])||[],type=origType=tmp[1],namespaces=(tmp[2]||"").split(".").sort(),type&&(special=jQuery.event.special[type]||{},type=(selector?special.delegateType:special.bindType)||type,special=jQuery.event.special[type]||{},handleObj=jQuery.extend({type:type,origType:origType,data:data,handler:handler,guid:handler.guid,selector:selector,needsContext:selector&&jQuery.expr.match.needsContext.test(selector),namespace:namespaces.join(".")},handleObjIn),(handlers=events[type])||(handlers=events[type]=[],handlers.delegateCount=0,special.setup&&special.setup.call(elem,data,namespaces,eventHandle)!==!1||elem.addEventListener&&elem.addEventListener(type,eventHandle,!1)),special.add&&(special.add.call(elem,handleObj),handleObj.handler.guid||(handleObj.handler.guid=handler.guid)),selector?handlers.splice(handlers.delegateCount++,0,handleObj):handlers.push(handleObj),jQuery.event.global[type]=!0)},remove:function(elem,types,handler,selector,mappedTypes){var j,origCount,tmp,events,t,handleObj,special,handlers,type,namespaces,origType,elemData=data_priv.hasData(elem)&&data_priv.get(elem);if(elemData&&(events=elemData.events)){for(types=(types||"").match(rnotwhite)||[""],t=types.length;t--;)if(tmp=rtypenamespace.exec(types[t])||[],type=origType=tmp[1],namespaces=(tmp[2]||"").split(".").sort(),type){for(special=jQuery.event.special[type]||{},type=(selector?special.delegateType:special.bindType)||type,handlers=events[type]||[],tmp=tmp[2]&&new RegExp("(^|\\.)"+namespaces.join("\\.(?:.*\\.|)")+"(\\.|$)"),origCount=j=handlers.length;j--;)handleObj=handlers[j],!mappedTypes&&origType!==handleObj.origType||handler&&handler.guid!==handleObj.guid||tmp&&!tmp.test(handleObj.namespace)||selector&&selector!==handleObj.selector&&("**"!==selector||!handleObj.selector)||(handlers.splice(j,1),handleObj.selector&&handlers.delegateCount--,special.remove&&special.remove.call(elem,handleObj));origCount&&!handlers.length&&(special.teardown&&special.teardown.call(elem,namespaces,elemData.handle)!==!1||jQuery.removeEvent(elem,type,elemData.handle),delete events[type])}else for(type in events)jQuery.event.remove(elem,type+types[t],handler,selector,!0);jQuery.isEmptyObject(events)&&(delete elemData.handle,data_priv.remove(elem,"events"))}},trigger:function(event,data,elem,onlyHandlers){var i,cur,tmp,bubbleType,ontype,handle,special,eventPath=[elem||document],type=hasOwn.call(event,"type")?event.type:event,namespaces=hasOwn.call(event,"namespace")?event.namespace.split("."):[];if(cur=tmp=elem=elem||document,3!==elem.nodeType&&8!==elem.nodeType&&!rfocusMorph.test(type+jQuery.event.triggered)&&(type.indexOf(".")>=0&&(namespaces=type.split("."),type=namespaces.shift(),namespaces.sort()),ontype=type.indexOf(":")<0&&"on"+type,event=event[jQuery.expando]?event:new jQuery.Event(type,"object"==typeof event&&event),event.isTrigger=onlyHandlers?2:3,event.namespace=namespaces.join("."),event.namespace_re=event.namespace?new RegExp("(^|\\.)"+namespaces.join("\\.(?:.*\\.|)")+"(\\.|$)"):null,event.result=void 0,event.target||(event.target=elem),data=null==data?[event]:jQuery.makeArray(data,[event]),special=jQuery.event.special[type]||{},onlyHandlers||!special.trigger||special.trigger.apply(elem,data)!==!1)){if(!onlyHandlers&&!special.noBubble&&!jQuery.isWindow(elem)){for(bubbleType=special.delegateType||type,rfocusMorph.test(bubbleType+type)||(cur=cur.parentNode);cur;cur=cur.parentNode)eventPath.push(cur),tmp=cur;tmp===(elem.ownerDocument||document)&&eventPath.push(tmp.defaultView||tmp.parentWindow||window)}for(i=0;(cur=eventPath[i++])&&!event.isPropagationStopped();)event.type=i>1?bubbleType:special.bindType||type,handle=(data_priv.get(cur,"events")||{})[event.type]&&data_priv.get(cur,"handle"),handle&&handle.apply(cur,data),handle=ontype&&cur[ontype],handle&&handle.apply&&jQuery.acceptData(cur)&&(event.result=handle.apply(cur,data),event.result===!1&&event.preventDefault());return event.type=type,onlyHandlers||event.isDefaultPrevented()||special._default&&special._default.apply(eventPath.pop(),data)!==!1||!jQuery.acceptData(elem)||ontype&&jQuery.isFunction(elem[type])&&!jQuery.isWindow(elem)&&(tmp=elem[ontype],tmp&&(elem[ontype]=null),jQuery.event.triggered=type,elem[type](),jQuery.event.triggered=void 0,tmp&&(elem[ontype]=tmp)),event.result}},dispatch:function(event){event=jQuery.event.fix(event);var i,j,ret,matched,handleObj,handlerQueue=[],args=slice.call(arguments),handlers=(data_priv.get(this,"events")||{})[event.type]||[],special=jQuery.event.special[event.type]||{};if(args[0]=event,event.delegateTarget=this,!special.preDispatch||special.preDispatch.call(this,event)!==!1){for(handlerQueue=jQuery.event.handlers.call(this,event,handlers),i=0;(matched=handlerQueue[i++])&&!event.isPropagationStopped();)for(event.currentTarget=matched.elem,j=0;(handleObj=matched.handlers[j++])&&!event.isImmediatePropagationStopped();)event.namespace_re&&!event.namespace_re.test(handleObj.namespace)||(event.handleObj=handleObj,event.data=handleObj.data,ret=((jQuery.event.special[handleObj.origType]||{}).handle||handleObj.handler).apply(matched.elem,args),void 0!==ret&&(event.result=ret)===!1&&(event.preventDefault(),event.stopPropagation()));return special.postDispatch&&special.postDispatch.call(this,event),event.result}},handlers:function(event,handlers){var i,matches,sel,handleObj,handlerQueue=[],delegateCount=handlers.delegateCount,cur=event.target;if(delegateCount&&cur.nodeType&&(!event.button||"click"!==event.type))for(;cur!==this;cur=cur.parentNode||this)if(cur.disabled!==!0||"click"!==event.type){for(matches=[],i=0;i<delegateCount;i++)handleObj=handlers[i],sel=handleObj.selector+" ",void 0===matches[sel]&&(matches[sel]=handleObj.needsContext?jQuery(sel,this).index(cur)>=0:jQuery.find(sel,this,null,[cur]).length),matches[sel]&&matches.push(handleObj);matches.length&&handlerQueue.push({elem:cur,handlers:matches})}return delegateCount<handlers.length&&handlerQueue.push({elem:this,handlers:handlers.slice(delegateCount)}),handlerQueue},props:"altKey bubbles cancelable ctrlKey currentTarget eventPhase metaKey relatedTarget shiftKey target timeStamp view which".split(" "),fixHooks:{},keyHooks:{props:"char charCode key keyCode".split(" "),filter:function(event,original){return null==event.which&&(event.which=null!=original.charCode?original.charCode:original.keyCode),event}},mouseHooks:{props:"button buttons clientX clientY offsetX offsetY pageX pageY screenX screenY toElement".split(" "),filter:function(event,original){var eventDoc,doc,body,button=original.button;return null==event.pageX&&null!=original.clientX&&(eventDoc=event.target.ownerDocument||document,doc=eventDoc.documentElement,body=eventDoc.body,event.pageX=original.clientX+(doc&&doc.scrollLeft||body&&body.scrollLeft||0)-(doc&&doc.clientLeft||body&&body.clientLeft||0),event.pageY=original.clientY+(doc&&doc.scrollTop||body&&body.scrollTop||0)-(doc&&doc.clientTop||body&&body.clientTop||0)),event.which||void 0===button||(event.which=1&button?1:2&button?3:4&button?2:0),event}},fix:function(event){if(event[jQuery.expando])return event;var i,prop,copy,type=event.type,originalEvent=event,fixHook=this.fixHooks[type];for(fixHook||(this.fixHooks[type]=fixHook=rmouseEvent.test(type)?this.mouseHooks:rkeyEvent.test(type)?this.keyHooks:{}),copy=fixHook.props?this.props.concat(fixHook.props):this.props,event=new jQuery.Event(originalEvent),i=copy.length;i--;)prop=copy[i],event[prop]=originalEvent[prop];return event.target||(event.target=document),3===event.target.nodeType&&(event.target=event.target.parentNode),fixHook.filter?fixHook.filter(event,originalEvent):event},special:{load:{noBubble:!0},focus:{trigger:function(){if(this!==safeActiveElement()&&this.focus)return this.focus(),!1},delegateType:"focusin"},blur:{trigger:function(){if(this===safeActiveElement()&&this.blur)return this.blur(),!1},delegateType:"focusout"},click:{trigger:function(){if("checkbox"===this.type&&this.click&&jQuery.nodeName(this,"input"))return this.click(),!1},_default:function(event){return jQuery.nodeName(event.target,"a")}},beforeunload:{postDispatch:function(event){void 0!==event.result&&event.originalEvent&&(event.originalEvent.returnValue=event.result)}}},simulate:function(type,elem,event,bubble){var e=jQuery.extend(new jQuery.Event,event,{type:type,isSimulated:!0,originalEvent:{}});bubble?jQuery.event.trigger(e,null,elem):jQuery.event.dispatch.call(elem,e),e.isDefaultPrevented()&&event.preventDefault()}},jQuery.removeEvent=function(elem,type,handle){elem.removeEventListener&&elem.removeEventListener(type,handle,!1)},jQuery.Event=function(src,props){return this instanceof jQuery.Event?(src&&src.type?(this.originalEvent=src,this.type=src.type,this.isDefaultPrevented=src.defaultPrevented||void 0===src.defaultPrevented&&src.returnValue===!1?returnTrue:returnFalse):this.type=src,props&&jQuery.extend(this,props),this.timeStamp=src&&src.timeStamp||jQuery.now(),void(this[jQuery.expando]=!0)):new jQuery.Event(src,props)},jQuery.Event.prototype={isDefaultPrevented:returnFalse,isPropagationStopped:returnFalse,isImmediatePropagationStopped:returnFalse,preventDefault:function(){var e=this.originalEvent;this.isDefaultPrevented=returnTrue,e&&e.preventDefault&&e.preventDefault()},stopPropagation:function(){var e=this.originalEvent;this.isPropagationStopped=returnTrue,e&&e.stopPropagation&&e.stopPropagation()},stopImmediatePropagation:function(){var e=this.originalEvent;this.isImmediatePropagationStopped=returnTrue,e&&e.stopImmediatePropagation&&e.stopImmediatePropagation(),this.stopPropagation()}},jQuery.each({mouseenter:"mouseover",mouseleave:"mouseout",pointerenter:"pointerover",pointerleave:"pointerout"},function(orig,fix){jQuery.event.special[orig]={delegateType:fix,bindType:fix,handle:function(event){var ret,target=this,related=event.relatedTarget,handleObj=event.handleObj;return related&&(related===target||jQuery.contains(target,related))||(event.type=handleObj.origType,ret=handleObj.handler.apply(this,arguments),event.type=fix),ret}}}),support.focusinBubbles||jQuery.each({focus:"focusin",blur:"focusout"},function(orig,fix){var handler=function(event){jQuery.event.simulate(fix,event.target,jQuery.event.fix(event),!0)};jQuery.event.special[fix]={setup:function(){var doc=this.ownerDocument||this,attaches=data_priv.access(doc,fix);attaches||doc.addEventListener(orig,handler,!0),data_priv.access(doc,fix,(attaches||0)+1)},teardown:function(){var doc=this.ownerDocument||this,attaches=data_priv.access(doc,fix)-1;attaches?data_priv.access(doc,fix,attaches):(doc.removeEventListener(orig,handler,!0),data_priv.remove(doc,fix))}}}),jQuery.fn.extend({on:function(types,selector,data,fn,one){var origFn,type;if("object"==typeof types){"string"!=typeof selector&&(data=data||selector,selector=void 0);for(type in types)this.on(type,selector,data,types[type],one);return this}if(null==data&&null==fn?(fn=selector,data=selector=void 0):null==fn&&("string"==typeof selector?(fn=data,data=void 0):(fn=data,data=selector,selector=void 0)),fn===!1)fn=returnFalse;else if(!fn)return this;return 1===one&&(origFn=fn,fn=function(event){return jQuery().off(event),origFn.apply(this,arguments)},fn.guid=origFn.guid||(origFn.guid=jQuery.guid++)),this.each(function(){jQuery.event.add(this,types,fn,data,selector)})},one:function(types,selector,data,fn){return this.on(types,selector,data,fn,1)},off:function(types,selector,fn){var handleObj,type;if(types&&types.preventDefault&&types.handleObj)return handleObj=types.handleObj,jQuery(types.delegateTarget).off(handleObj.namespace?handleObj.origType+"."+handleObj.namespace:handleObj.origType,handleObj.selector,handleObj.handler),this;if("object"==typeof types){for(type in types)this.off(type,selector,types[type]);return this}return selector!==!1&&"function"!=typeof selector||(fn=selector,selector=void 0),fn===!1&&(fn=returnFalse),this.each(function(){jQuery.event.remove(this,types,fn,selector)})},trigger:function(type,data){return this.each(function(){jQuery.event.trigger(type,data,this)})},triggerHandler:function(type,data){var elem=this[0];if(elem)return jQuery.event.trigger(type,data,elem,!0)}});var rxhtmlTag=/<(?!area|br|col|embed|hr|img|input|link|meta|param)(([\w:]+)[^>]*)\/>/gi,rtagName=/<([\w:]+)/,rhtml=/<|&#?\w+;/,rnoInnerhtml=/<(?:script|style|link)/i,rchecked=/checked\s*(?:[^=]|=\s*.checked.)/i,rscriptType=/^$|\/(?:java|ecma)script/i,rscriptTypeMasked=/^true\/(.*)/,rcleanScript=/^\s*<!(?:\[CDATA\[|--)|(?:\]\]|--)>\s*$/g,wrapMap={option:[1,"<select multiple='multiple'>","</select>"],thead:[1,"<table>","</table>"],col:[2,"<table><colgroup>","</colgroup></table>"],tr:[2,"<table><tbody>","</tbody></table>"],td:[3,"<table><tbody><tr>","</tr></tbody></table>"],_default:[0,"",""]};wrapMap.optgroup=wrapMap.option,wrapMap.tbody=wrapMap.tfoot=wrapMap.colgroup=wrapMap.caption=wrapMap.thead,wrapMap.th=wrapMap.td,jQuery.extend({clone:function(elem,dataAndEvents,deepDataAndEvents){var i,l,srcElements,destElements,clone=elem.cloneNode(!0),inPage=jQuery.contains(elem.ownerDocument,elem);if(!(support.noCloneChecked||1!==elem.nodeType&&11!==elem.nodeType||jQuery.isXMLDoc(elem)))for(destElements=getAll(clone),srcElements=getAll(elem),i=0,l=srcElements.length;i<l;i++)fixInput(srcElements[i],destElements[i]);if(dataAndEvents)if(deepDataAndEvents)for(srcElements=srcElements||getAll(elem),destElements=destElements||getAll(clone),i=0,l=srcElements.length;i<l;i++)cloneCopyEvent(srcElements[i],destElements[i]);else cloneCopyEvent(elem,clone);
return destElements=getAll(clone,"script"),destElements.length>0&&setGlobalEval(destElements,!inPage&&getAll(elem,"script")),clone},buildFragment:function(elems,context,scripts,selection){for(var elem,tmp,tag,wrap,contains,j,fragment=context.createDocumentFragment(),nodes=[],i=0,l=elems.length;i<l;i++)if(elem=elems[i],elem||0===elem)if("object"===jQuery.type(elem))jQuery.merge(nodes,elem.nodeType?[elem]:elem);else if(rhtml.test(elem)){for(tmp=tmp||fragment.appendChild(context.createElement("div")),tag=(rtagName.exec(elem)||["",""])[1].toLowerCase(),wrap=wrapMap[tag]||wrapMap._default,tmp.innerHTML=wrap[1]+elem.replace(rxhtmlTag,"<$1></$2>")+wrap[2],j=wrap[0];j--;)tmp=tmp.lastChild;jQuery.merge(nodes,tmp.childNodes),tmp=fragment.firstChild,tmp.textContent=""}else nodes.push(context.createTextNode(elem));for(fragment.textContent="",i=0;elem=nodes[i++];)if((!selection||jQuery.inArray(elem,selection)===-1)&&(contains=jQuery.contains(elem.ownerDocument,elem),tmp=getAll(fragment.appendChild(elem),"script"),contains&&setGlobalEval(tmp),scripts))for(j=0;elem=tmp[j++];)rscriptType.test(elem.type||"")&&scripts.push(elem);return fragment},cleanData:function(elems){for(var data,elem,type,key,special=jQuery.event.special,i=0;void 0!==(elem=elems[i]);i++){if(jQuery.acceptData(elem)&&(key=elem[data_priv.expando],key&&(data=data_priv.cache[key]))){if(data.events)for(type in data.events)special[type]?jQuery.event.remove(elem,type):jQuery.removeEvent(elem,type,data.handle);data_priv.cache[key]&&delete data_priv.cache[key]}delete data_user.cache[elem[data_user.expando]]}}}),jQuery.fn.extend({text:function(value){return access(this,function(value){return void 0===value?jQuery.text(this):this.empty().each(function(){1!==this.nodeType&&11!==this.nodeType&&9!==this.nodeType||(this.textContent=value)})},null,value,arguments.length)},append:function(){return this.domManip(arguments,function(elem){if(1===this.nodeType||11===this.nodeType||9===this.nodeType){var target=manipulationTarget(this,elem);target.appendChild(elem)}})},prepend:function(){return this.domManip(arguments,function(elem){if(1===this.nodeType||11===this.nodeType||9===this.nodeType){var target=manipulationTarget(this,elem);target.insertBefore(elem,target.firstChild)}})},before:function(){return this.domManip(arguments,function(elem){this.parentNode&&this.parentNode.insertBefore(elem,this)})},after:function(){return this.domManip(arguments,function(elem){this.parentNode&&this.parentNode.insertBefore(elem,this.nextSibling)})},remove:function(selector,keepData){for(var elem,elems=selector?jQuery.filter(selector,this):this,i=0;null!=(elem=elems[i]);i++)keepData||1!==elem.nodeType||jQuery.cleanData(getAll(elem)),elem.parentNode&&(keepData&&jQuery.contains(elem.ownerDocument,elem)&&setGlobalEval(getAll(elem,"script")),elem.parentNode.removeChild(elem));return this},empty:function(){for(var elem,i=0;null!=(elem=this[i]);i++)1===elem.nodeType&&(jQuery.cleanData(getAll(elem,!1)),elem.textContent="");return this},clone:function(dataAndEvents,deepDataAndEvents){return dataAndEvents=null!=dataAndEvents&&dataAndEvents,deepDataAndEvents=null==deepDataAndEvents?dataAndEvents:deepDataAndEvents,this.map(function(){return jQuery.clone(this,dataAndEvents,deepDataAndEvents)})},html:function(value){return access(this,function(value){var elem=this[0]||{},i=0,l=this.length;if(void 0===value&&1===elem.nodeType)return elem.innerHTML;if("string"==typeof value&&!rnoInnerhtml.test(value)&&!wrapMap[(rtagName.exec(value)||["",""])[1].toLowerCase()]){value=value.replace(rxhtmlTag,"<$1></$2>");try{for(;i<l;i++)elem=this[i]||{},1===elem.nodeType&&(jQuery.cleanData(getAll(elem,!1)),elem.innerHTML=value);elem=0}catch(e){}}elem&&this.empty().append(value)},null,value,arguments.length)},replaceWith:function(){var arg=arguments[0];return this.domManip(arguments,function(elem){arg=this.parentNode,jQuery.cleanData(getAll(this)),arg&&arg.replaceChild(elem,this)}),arg&&(arg.length||arg.nodeType)?this:this.remove()},detach:function(selector){return this.remove(selector,!0)},domManip:function(args,callback){args=concat.apply([],args);var fragment,first,scripts,hasScripts,node,doc,i=0,l=this.length,set=this,iNoClone=l-1,value=args[0],isFunction=jQuery.isFunction(value);if(isFunction||l>1&&"string"==typeof value&&!support.checkClone&&rchecked.test(value))return this.each(function(index){var self=set.eq(index);isFunction&&(args[0]=value.call(this,index,self.html())),self.domManip(args,callback)});if(l&&(fragment=jQuery.buildFragment(args,this[0].ownerDocument,!1,this),first=fragment.firstChild,1===fragment.childNodes.length&&(fragment=first),first)){for(scripts=jQuery.map(getAll(fragment,"script"),disableScript),hasScripts=scripts.length;i<l;i++)node=fragment,i!==iNoClone&&(node=jQuery.clone(node,!0,!0),hasScripts&&jQuery.merge(scripts,getAll(node,"script"))),callback.call(this[i],node,i);if(hasScripts)for(doc=scripts[scripts.length-1].ownerDocument,jQuery.map(scripts,restoreScript),i=0;i<hasScripts;i++)node=scripts[i],rscriptType.test(node.type||"")&&!data_priv.access(node,"globalEval")&&jQuery.contains(doc,node)&&(node.src?jQuery._evalUrl&&jQuery._evalUrl(node.src):jQuery.globalEval(node.textContent.replace(rcleanScript,"")))}return this}}),jQuery.each({appendTo:"append",prependTo:"prepend",insertBefore:"before",insertAfter:"after",replaceAll:"replaceWith"},function(name,original){jQuery.fn[name]=function(selector){for(var elems,ret=[],insert=jQuery(selector),last=insert.length-1,i=0;i<=last;i++)elems=i===last?this:this.clone(!0),jQuery(insert[i])[original](elems),push.apply(ret,elems.get());return this.pushStack(ret)}});var iframe,elemdisplay={},rmargin=/^margin/,rnumnonpx=new RegExp("^("+pnum+")(?!px)[a-z%]+$","i"),getStyles=function(elem){return elem.ownerDocument.defaultView.opener?elem.ownerDocument.defaultView.getComputedStyle(elem,null):window.getComputedStyle(elem,null)};!function(){function computePixelPositionAndBoxSizingReliable(){div.style.cssText="-webkit-box-sizing:border-box;-moz-box-sizing:border-box;box-sizing:border-box;display:block;margin-top:1%;top:1%;border:1px;padding:1px;width:4px;position:absolute",div.innerHTML="",docElem.appendChild(container);var divStyle=window.getComputedStyle(div,null);pixelPositionVal="1%"!==divStyle.top,boxSizingReliableVal="4px"===divStyle.width,docElem.removeChild(container)}var pixelPositionVal,boxSizingReliableVal,docElem=document.documentElement,container=document.createElement("div"),div=document.createElement("div");div.style&&(div.style.backgroundClip="content-box",div.cloneNode(!0).style.backgroundClip="",support.clearCloneStyle="content-box"===div.style.backgroundClip,container.style.cssText="border:0;width:0;height:0;top:0;left:-9999px;margin-top:1px;position:absolute",container.appendChild(div),window.getComputedStyle&&jQuery.extend(support,{pixelPosition:function(){return computePixelPositionAndBoxSizingReliable(),pixelPositionVal},boxSizingReliable:function(){return null==boxSizingReliableVal&&computePixelPositionAndBoxSizingReliable(),boxSizingReliableVal},reliableMarginRight:function(){var ret,marginDiv=div.appendChild(document.createElement("div"));return marginDiv.style.cssText=div.style.cssText="-webkit-box-sizing:content-box;-moz-box-sizing:content-box;box-sizing:content-box;display:block;margin:0;border:0;padding:0",marginDiv.style.marginRight=marginDiv.style.width="0",div.style.width="1px",docElem.appendChild(container),ret=!parseFloat(window.getComputedStyle(marginDiv,null).marginRight),docElem.removeChild(container),div.removeChild(marginDiv),ret}}))}(),jQuery.swap=function(elem,options,callback,args){var ret,name,old={};for(name in options)old[name]=elem.style[name],elem.style[name]=options[name];ret=callback.apply(elem,args||[]);for(name in options)elem.style[name]=old[name];return ret};var rdisplayswap=/^(none|table(?!-c[ea]).+)/,rnumsplit=new RegExp("^("+pnum+")(.*)$","i"),rrelNum=new RegExp("^([+-])=("+pnum+")","i"),cssShow={position:"absolute",visibility:"hidden",display:"block"},cssNormalTransform={letterSpacing:"0",fontWeight:"400"},cssPrefixes=["Webkit","O","Moz","ms"];jQuery.extend({cssHooks:{opacity:{get:function(elem,computed){if(computed){var ret=curCSS(elem,"opacity");return""===ret?"1":ret}}}},cssNumber:{columnCount:!0,fillOpacity:!0,flexGrow:!0,flexShrink:!0,fontWeight:!0,lineHeight:!0,opacity:!0,order:!0,orphans:!0,widows:!0,zIndex:!0,zoom:!0},cssProps:{float:"cssFloat"},style:function(elem,name,value,extra){if(elem&&3!==elem.nodeType&&8!==elem.nodeType&&elem.style){var ret,type,hooks,origName=jQuery.camelCase(name),style=elem.style;return name=jQuery.cssProps[origName]||(jQuery.cssProps[origName]=vendorPropName(style,origName)),hooks=jQuery.cssHooks[name]||jQuery.cssHooks[origName],void 0===value?hooks&&"get"in hooks&&void 0!==(ret=hooks.get(elem,!1,extra))?ret:style[name]:(type=typeof value,"string"===type&&(ret=rrelNum.exec(value))&&(value=(ret[1]+1)*ret[2]+parseFloat(jQuery.css(elem,name)),type="number"),null!=value&&value===value&&("number"!==type||jQuery.cssNumber[origName]||(value+="px"),support.clearCloneStyle||""!==value||0!==name.indexOf("background")||(style[name]="inherit"),hooks&&"set"in hooks&&void 0===(value=hooks.set(elem,value,extra))||(style[name]=value)),void 0)}},css:function(elem,name,extra,styles){var val,num,hooks,origName=jQuery.camelCase(name);return name=jQuery.cssProps[origName]||(jQuery.cssProps[origName]=vendorPropName(elem.style,origName)),hooks=jQuery.cssHooks[name]||jQuery.cssHooks[origName],hooks&&"get"in hooks&&(val=hooks.get(elem,!0,extra)),void 0===val&&(val=curCSS(elem,name,styles)),"normal"===val&&name in cssNormalTransform&&(val=cssNormalTransform[name]),""===extra||extra?(num=parseFloat(val),extra===!0||jQuery.isNumeric(num)?num||0:val):val}}),jQuery.each(["height","width"],function(i,name){jQuery.cssHooks[name]={get:function(elem,computed,extra){if(computed)return rdisplayswap.test(jQuery.css(elem,"display"))&&0===elem.offsetWidth?jQuery.swap(elem,cssShow,function(){return getWidthOrHeight(elem,name,extra)}):getWidthOrHeight(elem,name,extra)},set:function(elem,value,extra){var styles=extra&&getStyles(elem);return setPositiveNumber(elem,value,extra?augmentWidthOrHeight(elem,name,extra,"border-box"===jQuery.css(elem,"boxSizing",!1,styles),styles):0)}}}),jQuery.cssHooks.marginRight=addGetHookIf(support.reliableMarginRight,function(elem,computed){if(computed)return jQuery.swap(elem,{display:"inline-block"},curCSS,[elem,"marginRight"])}),jQuery.each({margin:"",padding:"",border:"Width"},function(prefix,suffix){jQuery.cssHooks[prefix+suffix]={expand:function(value){for(var i=0,expanded={},parts="string"==typeof value?value.split(" "):[value];i<4;i++)expanded[prefix+cssExpand[i]+suffix]=parts[i]||parts[i-2]||parts[0];return expanded}},rmargin.test(prefix)||(jQuery.cssHooks[prefix+suffix].set=setPositiveNumber)}),jQuery.fn.extend({css:function(name,value){return access(this,function(elem,name,value){var styles,len,map={},i=0;if(jQuery.isArray(name)){for(styles=getStyles(elem),len=name.length;i<len;i++)map[name[i]]=jQuery.css(elem,name[i],!1,styles);return map}return void 0!==value?jQuery.style(elem,name,value):jQuery.css(elem,name)},name,value,arguments.length>1)},show:function(){return showHide(this,!0)},hide:function(){return showHide(this)},toggle:function(state){return"boolean"==typeof state?state?this.show():this.hide():this.each(function(){isHidden(this)?jQuery(this).show():jQuery(this).hide()})}}),jQuery.Tween=Tween,Tween.prototype={constructor:Tween,init:function(elem,options,prop,end,easing,unit){this.elem=elem,this.prop=prop,this.easing=easing||"swing",this.options=options,this.start=this.now=this.cur(),this.end=end,this.unit=unit||(jQuery.cssNumber[prop]?"":"px")},cur:function(){var hooks=Tween.propHooks[this.prop];return hooks&&hooks.get?hooks.get(this):Tween.propHooks._default.get(this)},run:function(percent){var eased,hooks=Tween.propHooks[this.prop];return this.options.duration?this.pos=eased=jQuery.easing[this.easing](percent,this.options.duration*percent,0,1,this.options.duration):this.pos=eased=percent,this.now=(this.end-this.start)*eased+this.start,this.options.step&&this.options.step.call(this.elem,this.now,this),hooks&&hooks.set?hooks.set(this):Tween.propHooks._default.set(this),this}},Tween.prototype.init.prototype=Tween.prototype,Tween.propHooks={_default:{get:function(tween){var result;return null==tween.elem[tween.prop]||tween.elem.style&&null!=tween.elem.style[tween.prop]?(result=jQuery.css(tween.elem,tween.prop,""),result&&"auto"!==result?result:0):tween.elem[tween.prop]},set:function(tween){jQuery.fx.step[tween.prop]?jQuery.fx.step[tween.prop](tween):tween.elem.style&&(null!=tween.elem.style[jQuery.cssProps[tween.prop]]||jQuery.cssHooks[tween.prop])?jQuery.style(tween.elem,tween.prop,tween.now+tween.unit):tween.elem[tween.prop]=tween.now}}},Tween.propHooks.scrollTop=Tween.propHooks.scrollLeft={set:function(tween){tween.elem.nodeType&&tween.elem.parentNode&&(tween.elem[tween.prop]=tween.now)}},jQuery.easing={linear:function(p){return p},swing:function(p){return.5-Math.cos(p*Math.PI)/2}},jQuery.fx=Tween.prototype.init,jQuery.fx.step={};var fxNow,timerId,rfxtypes=/^(?:toggle|show|hide)$/,rfxnum=new RegExp("^(?:([+-])=|)("+pnum+")([a-z%]*)$","i"),rrun=/queueHooks$/,animationPrefilters=[defaultPrefilter],tweeners={"*":[function(prop,value){var tween=this.createTween(prop,value),target=tween.cur(),parts=rfxnum.exec(value),unit=parts&&parts[3]||(jQuery.cssNumber[prop]?"":"px"),start=(jQuery.cssNumber[prop]||"px"!==unit&&+target)&&rfxnum.exec(jQuery.css(tween.elem,prop)),scale=1,maxIterations=20;if(start&&start[3]!==unit){unit=unit||start[3],parts=parts||[],start=+target||1;do scale=scale||".5",start/=scale,jQuery.style(tween.elem,prop,start+unit);while(scale!==(scale=tween.cur()/target)&&1!==scale&&--maxIterations)}return parts&&(start=tween.start=+start||+target||0,tween.unit=unit,tween.end=parts[1]?start+(parts[1]+1)*parts[2]:+parts[2]),tween}]};jQuery.Animation=jQuery.extend(Animation,{tweener:function(props,callback){jQuery.isFunction(props)?(callback=props,props=["*"]):props=props.split(" ");for(var prop,index=0,length=props.length;index<length;index++)prop=props[index],tweeners[prop]=tweeners[prop]||[],tweeners[prop].unshift(callback)},prefilter:function(callback,prepend){prepend?animationPrefilters.unshift(callback):animationPrefilters.push(callback)}}),jQuery.speed=function(speed,easing,fn){var opt=speed&&"object"==typeof speed?jQuery.extend({},speed):{complete:fn||!fn&&easing||jQuery.isFunction(speed)&&speed,duration:speed,easing:fn&&easing||easing&&!jQuery.isFunction(easing)&&easing};return opt.duration=jQuery.fx.off?0:"number"==typeof opt.duration?opt.duration:opt.duration in jQuery.fx.speeds?jQuery.fx.speeds[opt.duration]:jQuery.fx.speeds._default,null!=opt.queue&&opt.queue!==!0||(opt.queue="fx"),opt.old=opt.complete,opt.complete=function(){jQuery.isFunction(opt.old)&&opt.old.call(this),opt.queue&&jQuery.dequeue(this,opt.queue)},opt},jQuery.fn.extend({fadeTo:function(speed,to,easing,callback){return this.filter(isHidden).css("opacity",0).show().end().animate({opacity:to},speed,easing,callback)},animate:function(prop,speed,easing,callback){var empty=jQuery.isEmptyObject(prop),optall=jQuery.speed(speed,easing,callback),doAnimation=function(){var anim=Animation(this,jQuery.extend({},prop),optall);(empty||data_priv.get(this,"finish"))&&anim.stop(!0)};return doAnimation.finish=doAnimation,empty||optall.queue===!1?this.each(doAnimation):this.queue(optall.queue,doAnimation)},stop:function(type,clearQueue,gotoEnd){var stopQueue=function(hooks){var stop=hooks.stop;delete hooks.stop,stop(gotoEnd)};return"string"!=typeof type&&(gotoEnd=clearQueue,clearQueue=type,type=void 0),clearQueue&&type!==!1&&this.queue(type||"fx",[]),this.each(function(){var dequeue=!0,index=null!=type&&type+"queueHooks",timers=jQuery.timers,data=data_priv.get(this);if(index)data[index]&&data[index].stop&&stopQueue(data[index]);else for(index in data)data[index]&&data[index].stop&&rrun.test(index)&&stopQueue(data[index]);for(index=timers.length;index--;)timers[index].elem!==this||null!=type&&timers[index].queue!==type||(timers[index].anim.stop(gotoEnd),dequeue=!1,timers.splice(index,1));!dequeue&&gotoEnd||jQuery.dequeue(this,type)})},finish:function(type){return type!==!1&&(type=type||"fx"),this.each(function(){var index,data=data_priv.get(this),queue=data[type+"queue"],hooks=data[type+"queueHooks"],timers=jQuery.timers,length=queue?queue.length:0;for(data.finish=!0,jQuery.queue(this,type,[]),hooks&&hooks.stop&&hooks.stop.call(this,!0),index=timers.length;index--;)timers[index].elem===this&&timers[index].queue===type&&(timers[index].anim.stop(!0),timers.splice(index,1));for(index=0;index<length;index++)queue[index]&&queue[index].finish&&queue[index].finish.call(this);delete data.finish})}}),jQuery.each(["toggle","show","hide"],function(i,name){var cssFn=jQuery.fn[name];jQuery.fn[name]=function(speed,easing,callback){return null==speed||"boolean"==typeof speed?cssFn.apply(this,arguments):this.animate(genFx(name,!0),speed,easing,callback)}}),jQuery.each({slideDown:genFx("show"),slideUp:genFx("hide"),slideToggle:genFx("toggle"),fadeIn:{opacity:"show"},fadeOut:{opacity:"hide"},fadeToggle:{opacity:"toggle"}},function(name,props){jQuery.fn[name]=function(speed,easing,callback){return this.animate(props,speed,easing,callback)}}),jQuery.timers=[],jQuery.fx.tick=function(){var timer,i=0,timers=jQuery.timers;for(fxNow=jQuery.now();i<timers.length;i++)timer=timers[i],timer()||timers[i]!==timer||timers.splice(i--,1);timers.length||jQuery.fx.stop(),fxNow=void 0},jQuery.fx.timer=function(timer){jQuery.timers.push(timer),timer()?jQuery.fx.start():jQuery.timers.pop()},jQuery.fx.interval=13,jQuery.fx.start=function(){timerId||(timerId=setInterval(jQuery.fx.tick,jQuery.fx.interval))},jQuery.fx.stop=function(){clearInterval(timerId),timerId=null},jQuery.fx.speeds={slow:600,fast:200,_default:400},jQuery.fn.delay=function(time,type){return time=jQuery.fx?jQuery.fx.speeds[time]||time:time,type=type||"fx",this.queue(type,function(next,hooks){var timeout=setTimeout(next,time);hooks.stop=function(){clearTimeout(timeout)}})},function(){var input=document.createElement("input"),select=document.createElement("select"),opt=select.appendChild(document.createElement("option"));input.type="checkbox",support.checkOn=""!==input.value,support.optSelected=opt.selected,select.disabled=!0,support.optDisabled=!opt.disabled,input=document.createElement("input"),input.value="t",input.type="radio",support.radioValue="t"===input.value}();var nodeHook,boolHook,attrHandle=jQuery.expr.attrHandle;jQuery.fn.extend({attr:function(name,value){return access(this,jQuery.attr,name,value,arguments.length>1)},removeAttr:function(name){return this.each(function(){jQuery.removeAttr(this,name)})}}),jQuery.extend({attr:function(elem,name,value){var hooks,ret,nType=elem.nodeType;if(elem&&3!==nType&&8!==nType&&2!==nType)return typeof elem.getAttribute===strundefined?jQuery.prop(elem,name,value):(1===nType&&jQuery.isXMLDoc(elem)||(name=name.toLowerCase(),hooks=jQuery.attrHooks[name]||(jQuery.expr.match.bool.test(name)?boolHook:nodeHook)),void 0===value?hooks&&"get"in hooks&&null!==(ret=hooks.get(elem,name))?ret:(ret=jQuery.find.attr(elem,name),null==ret?void 0:ret):null!==value?hooks&&"set"in hooks&&void 0!==(ret=hooks.set(elem,value,name))?ret:(elem.setAttribute(name,value+""),value):void jQuery.removeAttr(elem,name))},removeAttr:function(elem,value){var name,propName,i=0,attrNames=value&&value.match(rnotwhite);if(attrNames&&1===elem.nodeType)for(;name=attrNames[i++];)propName=jQuery.propFix[name]||name,jQuery.expr.match.bool.test(name)&&(elem[propName]=!1),elem.removeAttribute(name)},attrHooks:{type:{set:function(elem,value){if(!support.radioValue&&"radio"===value&&jQuery.nodeName(elem,"input")){var val=elem.value;return elem.setAttribute("type",value),val&&(elem.value=val),value}}}}}),boolHook={set:function(elem,value,name){return value===!1?jQuery.removeAttr(elem,name):elem.setAttribute(name,name),name}},jQuery.each(jQuery.expr.match.bool.source.match(/\w+/g),function(i,name){var getter=attrHandle[name]||jQuery.find.attr;attrHandle[name]=function(elem,name,isXML){var ret,handle;return isXML||(handle=attrHandle[name],attrHandle[name]=ret,ret=null!=getter(elem,name,isXML)?name.toLowerCase():null,attrHandle[name]=handle),ret}});var rfocusable=/^(?:input|select|textarea|button)$/i;jQuery.fn.extend({prop:function(name,value){return access(this,jQuery.prop,name,value,arguments.length>1)},removeProp:function(name){return this.each(function(){delete this[jQuery.propFix[name]||name]})}}),jQuery.extend({propFix:{for:"htmlFor",class:"className"},prop:function(elem,name,value){var ret,hooks,notxml,nType=elem.nodeType;if(elem&&3!==nType&&8!==nType&&2!==nType)return notxml=1!==nType||!jQuery.isXMLDoc(elem),notxml&&(name=jQuery.propFix[name]||name,hooks=jQuery.propHooks[name]),void 0!==value?hooks&&"set"in hooks&&void 0!==(ret=hooks.set(elem,value,name))?ret:elem[name]=value:hooks&&"get"in hooks&&null!==(ret=hooks.get(elem,name))?ret:elem[name]},propHooks:{tabIndex:{get:function(elem){return elem.hasAttribute("tabindex")||rfocusable.test(elem.nodeName)||elem.href?elem.tabIndex:-1}}}}),support.optSelected||(jQuery.propHooks.selected={get:function(elem){var parent=elem.parentNode;return parent&&parent.parentNode&&parent.parentNode.selectedIndex,null}}),jQuery.each(["tabIndex","readOnly","maxLength","cellSpacing","cellPadding","rowSpan","colSpan","useMap","frameBorder","contentEditable"],function(){jQuery.propFix[this.toLowerCase()]=this});var rclass=/[\t\r\n\f]/g;jQuery.fn.extend({addClass:function(value){var classes,elem,cur,clazz,j,finalValue,proceed="string"==typeof value&&value,i=0,len=this.length;if(jQuery.isFunction(value))return this.each(function(j){jQuery(this).addClass(value.call(this,j,this.className))});if(proceed)for(classes=(value||"").match(rnotwhite)||[];i<len;i++)if(elem=this[i],cur=1===elem.nodeType&&(elem.className?(" "+elem.className+" ").replace(rclass," "):" ")){for(j=0;clazz=classes[j++];)cur.indexOf(" "+clazz+" ")<0&&(cur+=clazz+" ");finalValue=jQuery.trim(cur),elem.className!==finalValue&&(elem.className=finalValue)}return this},removeClass:function(value){var classes,elem,cur,clazz,j,finalValue,proceed=0===arguments.length||"string"==typeof value&&value,i=0,len=this.length;if(jQuery.isFunction(value))return this.each(function(j){jQuery(this).removeClass(value.call(this,j,this.className))});if(proceed)for(classes=(value||"").match(rnotwhite)||[];i<len;i++)if(elem=this[i],cur=1===elem.nodeType&&(elem.className?(" "+elem.className+" ").replace(rclass," "):"")){for(j=0;clazz=classes[j++];)for(;cur.indexOf(" "+clazz+" ")>=0;)cur=cur.replace(" "+clazz+" "," ");finalValue=value?jQuery.trim(cur):"",elem.className!==finalValue&&(elem.className=finalValue)}return this},toggleClass:function(value,stateVal){var type=typeof value;return"boolean"==typeof stateVal&&"string"===type?stateVal?this.addClass(value):this.removeClass(value):jQuery.isFunction(value)?this.each(function(i){jQuery(this).toggleClass(value.call(this,i,this.className,stateVal),stateVal)}):this.each(function(){if("string"===type)for(var className,i=0,self=jQuery(this),classNames=value.match(rnotwhite)||[];className=classNames[i++];)self.hasClass(className)?self.removeClass(className):self.addClass(className);else type!==strundefined&&"boolean"!==type||(this.className&&data_priv.set(this,"__className__",this.className),this.className=this.className||value===!1?"":data_priv.get(this,"__className__")||"")})},hasClass:function(selector){for(var className=" "+selector+" ",i=0,l=this.length;i<l;i++)if(1===this[i].nodeType&&(" "+this[i].className+" ").replace(rclass," ").indexOf(className)>=0)return!0;return!1}});var rreturn=/\r/g;jQuery.fn.extend({val:function(value){var hooks,ret,isFunction,elem=this[0];{if(arguments.length)return isFunction=jQuery.isFunction(value),this.each(function(i){var val;1===this.nodeType&&(val=isFunction?value.call(this,i,jQuery(this).val()):value,null==val?val="":"number"==typeof val?val+="":jQuery.isArray(val)&&(val=jQuery.map(val,function(value){return null==value?"":value+""})),hooks=jQuery.valHooks[this.type]||jQuery.valHooks[this.nodeName.toLowerCase()],hooks&&"set"in hooks&&void 0!==hooks.set(this,val,"value")||(this.value=val))});if(elem)return hooks=jQuery.valHooks[elem.type]||jQuery.valHooks[elem.nodeName.toLowerCase()],hooks&&"get"in hooks&&void 0!==(ret=hooks.get(elem,"value"))?ret:(ret=elem.value,"string"==typeof ret?ret.replace(rreturn,""):null==ret?"":ret)}}}),jQuery.extend({valHooks:{option:{get:function(elem){var val=jQuery.find.attr(elem,"value");return null!=val?val:jQuery.trim(jQuery.text(elem))}},select:{get:function(elem){for(var value,option,options=elem.options,index=elem.selectedIndex,one="select-one"===elem.type||index<0,values=one?null:[],max=one?index+1:options.length,i=index<0?max:one?index:0;i<max;i++)if(option=options[i],(option.selected||i===index)&&(support.optDisabled?!option.disabled:null===option.getAttribute("disabled"))&&(!option.parentNode.disabled||!jQuery.nodeName(option.parentNode,"optgroup"))){if(value=jQuery(option).val(),one)return value;values.push(value)}return values},set:function(elem,value){for(var optionSet,option,options=elem.options,values=jQuery.makeArray(value),i=options.length;i--;)option=options[i],(option.selected=jQuery.inArray(option.value,values)>=0)&&(optionSet=!0);return optionSet||(elem.selectedIndex=-1),values}}}}),jQuery.each(["radio","checkbox"],function(){jQuery.valHooks[this]={set:function(elem,value){if(jQuery.isArray(value))return elem.checked=jQuery.inArray(jQuery(elem).val(),value)>=0}},support.checkOn||(jQuery.valHooks[this].get=function(elem){return null===elem.getAttribute("value")?"on":elem.value})}),jQuery.each("blur focus focusin focusout load resize scroll unload click dblclick mousedown mouseup mousemove mouseover mouseout mouseenter mouseleave change select submit keydown keypress keyup error contextmenu".split(" "),function(i,name){jQuery.fn[name]=function(data,fn){return arguments.length>0?this.on(name,null,data,fn):this.trigger(name)}}),jQuery.fn.extend({hover:function(fnOver,fnOut){return this.mouseenter(fnOver).mouseleave(fnOut||fnOver)},bind:function(types,data,fn){return this.on(types,null,data,fn)},unbind:function(types,fn){return this.off(types,null,fn)},delegate:function(selector,types,data,fn){return this.on(types,selector,data,fn)},undelegate:function(selector,types,fn){return 1===arguments.length?this.off(selector,"**"):this.off(types,selector||"**",fn)}});var nonce=jQuery.now(),rquery=/\?/;jQuery.parseJSON=function(data){return JSON.parse(data+"")},jQuery.parseXML=function(data){var xml,tmp;if(!data||"string"!=typeof data)return null;try{tmp=new DOMParser,xml=tmp.parseFromString(data,"text/xml")}catch(e){xml=void 0}return xml&&!xml.getElementsByTagName("parsererror").length||jQuery.error("Invalid XML: "+data),xml};var rhash=/#.*$/,rts=/([?&])_=[^&]*/,rheaders=/^(.*?):[ \t]*([^\r\n]*)$/gm,rlocalProtocol=/^(?:about|app|app-storage|.+-extension|file|res|widget):$/,rnoContent=/^(?:GET|HEAD)$/,rprotocol=/^\/\//,rurl=/^([\w.+-]+:)(?:\/\/(?:[^\/?#]*@|)([^\/?#:]*)(?::(\d+)|)|)/,prefilters={},transports={},allTypes="*/".concat("*"),ajaxLocation=window.location.href,ajaxLocParts=rurl.exec(ajaxLocation.toLowerCase())||[];jQuery.extend({active:0,lastModified:{},etag:{},ajaxSettings:{url:ajaxLocation,type:"GET",isLocal:rlocalProtocol.test(ajaxLocParts[1]),global:!0,processData:!0,async:!0,contentType:"application/x-www-form-urlencoded; charset=UTF-8",accepts:{"*":allTypes,text:"text/plain",html:"text/html",xml:"application/xml, text/xml",json:"application/json, text/javascript"},contents:{xml:/xml/,html:/html/,json:/json/},responseFields:{xml:"responseXML",text:"responseText",json:"responseJSON"},converters:{"* text":String,"text html":!0,"text json":jQuery.parseJSON,"text xml":jQuery.parseXML},flatOptions:{url:!0,context:!0}},ajaxSetup:function(target,settings){return settings?ajaxExtend(ajaxExtend(target,jQuery.ajaxSettings),settings):ajaxExtend(jQuery.ajaxSettings,target)},ajaxPrefilter:addToPrefiltersOrTransports(prefilters),ajaxTransport:addToPrefiltersOrTransports(transports),ajax:function(url,options){function done(status,nativeStatusText,responses,headers){var isSuccess,success,error,response,modified,statusText=nativeStatusText;2!==state&&(state=2,timeoutTimer&&clearTimeout(timeoutTimer),transport=void 0,responseHeadersString=headers||"",jqXHR.readyState=status>0?4:0,isSuccess=status>=200&&status<300||304===status,responses&&(response=ajaxHandleResponses(s,jqXHR,responses)),response=ajaxConvert(s,response,jqXHR,isSuccess),isSuccess?(s.ifModified&&(modified=jqXHR.getResponseHeader("Last-Modified"),modified&&(jQuery.lastModified[cacheURL]=modified),modified=jqXHR.getResponseHeader("etag"),modified&&(jQuery.etag[cacheURL]=modified)),204===status||"HEAD"===s.type?statusText="nocontent":304===status?statusText="notmodified":(statusText=response.state,success=response.data,error=response.error,isSuccess=!error)):(error=statusText,!status&&statusText||(statusText="error",status<0&&(status=0))),jqXHR.status=status,jqXHR.statusText=(nativeStatusText||statusText)+"",isSuccess?deferred.resolveWith(callbackContext,[success,statusText,jqXHR]):deferred.rejectWith(callbackContext,[jqXHR,statusText,error]),jqXHR.statusCode(statusCode),statusCode=void 0,fireGlobals&&globalEventContext.trigger(isSuccess?"ajaxSuccess":"ajaxError",[jqXHR,s,isSuccess?success:error]),completeDeferred.fireWith(callbackContext,[jqXHR,statusText]),fireGlobals&&(globalEventContext.trigger("ajaxComplete",[jqXHR,s]),--jQuery.active||jQuery.event.trigger("ajaxStop")))}"object"==typeof url&&(options=url,url=void 0),options=options||{};var transport,cacheURL,responseHeadersString,responseHeaders,timeoutTimer,parts,fireGlobals,i,s=jQuery.ajaxSetup({},options),callbackContext=s.context||s,globalEventContext=s.context&&(callbackContext.nodeType||callbackContext.jquery)?jQuery(callbackContext):jQuery.event,deferred=jQuery.Deferred(),completeDeferred=jQuery.Callbacks("once memory"),statusCode=s.statusCode||{},requestHeaders={},requestHeadersNames={},state=0,strAbort="canceled",jqXHR={readyState:0,getResponseHeader:function(key){var match;if(2===state){if(!responseHeaders)for(responseHeaders={};match=rheaders.exec(responseHeadersString);)responseHeaders[match[1].toLowerCase()]=match[2];match=responseHeaders[key.toLowerCase()]}return null==match?null:match},getAllResponseHeaders:function(){return 2===state?responseHeadersString:null},setRequestHeader:function(name,value){var lname=name.toLowerCase();return state||(name=requestHeadersNames[lname]=requestHeadersNames[lname]||name,requestHeaders[name]=value),this},overrideMimeType:function(type){return state||(s.mimeType=type),this},statusCode:function(map){var code;if(map)if(state<2)for(code in map)statusCode[code]=[statusCode[code],map[code]];else jqXHR.always(map[jqXHR.status]);return this},abort:function(statusText){var finalText=statusText||strAbort;return transport&&transport.abort(finalText),done(0,finalText),this}};if(deferred.promise(jqXHR).complete=completeDeferred.add,jqXHR.success=jqXHR.done,jqXHR.error=jqXHR.fail,s.url=((url||s.url||ajaxLocation)+"").replace(rhash,"").replace(rprotocol,ajaxLocParts[1]+"//"),s.type=options.method||options.type||s.method||s.type,s.dataTypes=jQuery.trim(s.dataType||"*").toLowerCase().match(rnotwhite)||[""],null==s.crossDomain&&(parts=rurl.exec(s.url.toLowerCase()),s.crossDomain=!(!parts||parts[1]===ajaxLocParts[1]&&parts[2]===ajaxLocParts[2]&&(parts[3]||("http:"===parts[1]?"80":"443"))===(ajaxLocParts[3]||("http:"===ajaxLocParts[1]?"80":"443")))),s.data&&s.processData&&"string"!=typeof s.data&&(s.data=jQuery.param(s.data,s.traditional)),inspectPrefiltersOrTransports(prefilters,s,options,jqXHR),2===state)return jqXHR;fireGlobals=jQuery.event&&s.global,fireGlobals&&0===jQuery.active++&&jQuery.event.trigger("ajaxStart"),
s.type=s.type.toUpperCase(),s.hasContent=!rnoContent.test(s.type),cacheURL=s.url,s.hasContent||(s.data&&(cacheURL=s.url+=(rquery.test(cacheURL)?"&":"?")+s.data,delete s.data),s.cache===!1&&(s.url=rts.test(cacheURL)?cacheURL.replace(rts,"$1_="+nonce++):cacheURL+(rquery.test(cacheURL)?"&":"?")+"_="+nonce++)),s.ifModified&&(jQuery.lastModified[cacheURL]&&jqXHR.setRequestHeader("If-Modified-Since",jQuery.lastModified[cacheURL]),jQuery.etag[cacheURL]&&jqXHR.setRequestHeader("If-None-Match",jQuery.etag[cacheURL])),(s.data&&s.hasContent&&s.contentType!==!1||options.contentType)&&jqXHR.setRequestHeader("Content-Type",s.contentType),jqXHR.setRequestHeader("Accept",s.dataTypes[0]&&s.accepts[s.dataTypes[0]]?s.accepts[s.dataTypes[0]]+("*"!==s.dataTypes[0]?", "+allTypes+"; q=0.01":""):s.accepts["*"]);for(i in s.headers)jqXHR.setRequestHeader(i,s.headers[i]);if(s.beforeSend&&(s.beforeSend.call(callbackContext,jqXHR,s)===!1||2===state))return jqXHR.abort();strAbort="abort";for(i in{success:1,error:1,complete:1})jqXHR[i](s[i]);if(transport=inspectPrefiltersOrTransports(transports,s,options,jqXHR)){jqXHR.readyState=1,fireGlobals&&globalEventContext.trigger("ajaxSend",[jqXHR,s]),s.async&&s.timeout>0&&(timeoutTimer=setTimeout(function(){jqXHR.abort("timeout")},s.timeout));try{state=1,transport.send(requestHeaders,done)}catch(e){if(!(state<2))throw e;done(-1,e)}}else done(-1,"No Transport");return jqXHR},getJSON:function(url,data,callback){return jQuery.get(url,data,callback,"json")},getScript:function(url,callback){return jQuery.get(url,void 0,callback,"script")}}),jQuery.each(["get","post"],function(i,method){jQuery[method]=function(url,data,callback,type){return jQuery.isFunction(data)&&(type=type||callback,callback=data,data=void 0),jQuery.ajax({url:url,type:method,dataType:type,data:data,success:callback})}}),jQuery._evalUrl=function(url){return jQuery.ajax({url:url,type:"GET",dataType:"script",async:!1,global:!1,throws:!0})},jQuery.fn.extend({wrapAll:function(html){var wrap;return jQuery.isFunction(html)?this.each(function(i){jQuery(this).wrapAll(html.call(this,i))}):(this[0]&&(wrap=jQuery(html,this[0].ownerDocument).eq(0).clone(!0),this[0].parentNode&&wrap.insertBefore(this[0]),wrap.map(function(){for(var elem=this;elem.firstElementChild;)elem=elem.firstElementChild;return elem}).append(this)),this)},wrapInner:function(html){return jQuery.isFunction(html)?this.each(function(i){jQuery(this).wrapInner(html.call(this,i))}):this.each(function(){var self=jQuery(this),contents=self.contents();contents.length?contents.wrapAll(html):self.append(html)})},wrap:function(html){var isFunction=jQuery.isFunction(html);return this.each(function(i){jQuery(this).wrapAll(isFunction?html.call(this,i):html)})},unwrap:function(){return this.parent().each(function(){jQuery.nodeName(this,"body")||jQuery(this).replaceWith(this.childNodes)}).end()}}),jQuery.expr.filters.hidden=function(elem){return elem.offsetWidth<=0&&elem.offsetHeight<=0},jQuery.expr.filters.visible=function(elem){return!jQuery.expr.filters.hidden(elem)};var r20=/%20/g,rbracket=/\[\]$/,rCRLF=/\r?\n/g,rsubmitterTypes=/^(?:submit|button|image|reset|file)$/i,rsubmittable=/^(?:input|select|textarea|keygen)/i;jQuery.param=function(a,traditional){var prefix,s=[],add=function(key,value){value=jQuery.isFunction(value)?value():null==value?"":value,s[s.length]=encodeURIComponent(key)+"="+encodeURIComponent(value)};if(void 0===traditional&&(traditional=jQuery.ajaxSettings&&jQuery.ajaxSettings.traditional),jQuery.isArray(a)||a.jquery&&!jQuery.isPlainObject(a))jQuery.each(a,function(){add(this.name,this.value)});else for(prefix in a)buildParams(prefix,a[prefix],traditional,add);return s.join("&").replace(r20,"+")},jQuery.fn.extend({serialize:function(){return jQuery.param(this.serializeArray())},serializeArray:function(){return this.map(function(){var elements=jQuery.prop(this,"elements");return elements?jQuery.makeArray(elements):this}).filter(function(){var type=this.type;return this.name&&!jQuery(this).is(":disabled")&&rsubmittable.test(this.nodeName)&&!rsubmitterTypes.test(type)&&(this.checked||!rcheckableType.test(type))}).map(function(i,elem){var val=jQuery(this).val();return null==val?null:jQuery.isArray(val)?jQuery.map(val,function(val){return{name:elem.name,value:val.replace(rCRLF,"\r\n")}}):{name:elem.name,value:val.replace(rCRLF,"\r\n")}}).get()}}),jQuery.ajaxSettings.xhr=function(){try{return new XMLHttpRequest}catch(e){}};var xhrId=0,xhrCallbacks={},xhrSuccessStatus={0:200,1223:204},xhrSupported=jQuery.ajaxSettings.xhr();window.attachEvent&&window.attachEvent("onunload",function(){for(var key in xhrCallbacks)xhrCallbacks[key]()}),support.cors=!!xhrSupported&&"withCredentials"in xhrSupported,support.ajax=xhrSupported=!!xhrSupported,jQuery.ajaxTransport(function(options){var callback;if(support.cors||xhrSupported&&!options.crossDomain)return{send:function(headers,complete){var i,xhr=options.xhr(),id=++xhrId;if(xhr.open(options.type,options.url,options.async,options.username,options.password),options.xhrFields)for(i in options.xhrFields)xhr[i]=options.xhrFields[i];options.mimeType&&xhr.overrideMimeType&&xhr.overrideMimeType(options.mimeType),options.crossDomain||headers["X-Requested-With"]||(headers["X-Requested-With"]="XMLHttpRequest");for(i in headers)xhr.setRequestHeader(i,headers[i]);callback=function(type){return function(){callback&&(delete xhrCallbacks[id],callback=xhr.onload=xhr.onerror=null,"abort"===type?xhr.abort():"error"===type?complete(xhr.status,xhr.statusText):complete(xhrSuccessStatus[xhr.status]||xhr.status,xhr.statusText,"string"==typeof xhr.responseText?{text:xhr.responseText}:void 0,xhr.getAllResponseHeaders()))}},xhr.onload=callback(),xhr.onerror=callback("error"),callback=xhrCallbacks[id]=callback("abort");try{xhr.send(options.hasContent&&options.data||null)}catch(e){if(callback)throw e}},abort:function(){callback&&callback()}}}),jQuery.ajaxSetup({accepts:{script:"text/javascript, application/javascript, application/ecmascript, application/x-ecmascript"},contents:{script:/(?:java|ecma)script/},converters:{"text script":function(text){return jQuery.globalEval(text),text}}}),jQuery.ajaxPrefilter("script",function(s){void 0===s.cache&&(s.cache=!1),s.crossDomain&&(s.type="GET")}),jQuery.ajaxTransport("script",function(s){if(s.crossDomain){var script,callback;return{send:function(_,complete){script=jQuery("<script>").prop({async:!0,charset:s.scriptCharset,src:s.url}).on("load error",callback=function(evt){script.remove(),callback=null,evt&&complete("error"===evt.type?404:200,evt.type)}),document.head.appendChild(script[0])},abort:function(){callback&&callback()}}}});var oldCallbacks=[],rjsonp=/(=)\?(?=&|$)|\?\?/;jQuery.ajaxSetup({jsonp:"callback",jsonpCallback:function(){var callback=oldCallbacks.pop()||jQuery.expando+"_"+nonce++;return this[callback]=!0,callback}}),jQuery.ajaxPrefilter("json jsonp",function(s,originalSettings,jqXHR){var callbackName,overwritten,responseContainer,jsonProp=s.jsonp!==!1&&(rjsonp.test(s.url)?"url":"string"==typeof s.data&&!(s.contentType||"").indexOf("application/x-www-form-urlencoded")&&rjsonp.test(s.data)&&"data");if(jsonProp||"jsonp"===s.dataTypes[0])return callbackName=s.jsonpCallback=jQuery.isFunction(s.jsonpCallback)?s.jsonpCallback():s.jsonpCallback,jsonProp?s[jsonProp]=s[jsonProp].replace(rjsonp,"$1"+callbackName):s.jsonp!==!1&&(s.url+=(rquery.test(s.url)?"&":"?")+s.jsonp+"="+callbackName),s.converters["script json"]=function(){return responseContainer||jQuery.error(callbackName+" was not called"),responseContainer[0]},s.dataTypes[0]="json",overwritten=window[callbackName],window[callbackName]=function(){responseContainer=arguments},jqXHR.always(function(){window[callbackName]=overwritten,s[callbackName]&&(s.jsonpCallback=originalSettings.jsonpCallback,oldCallbacks.push(callbackName)),responseContainer&&jQuery.isFunction(overwritten)&&overwritten(responseContainer[0]),responseContainer=overwritten=void 0}),"script"}),jQuery.parseHTML=function(data,context,keepScripts){if(!data||"string"!=typeof data)return null;"boolean"==typeof context&&(keepScripts=context,context=!1),context=context||document;var parsed=rsingleTag.exec(data),scripts=!keepScripts&&[];return parsed?[context.createElement(parsed[1])]:(parsed=jQuery.buildFragment([data],context,scripts),scripts&&scripts.length&&jQuery(scripts).remove(),jQuery.merge([],parsed.childNodes))};var _load=jQuery.fn.load;jQuery.fn.load=function(url,params,callback){if("string"!=typeof url&&_load)return _load.apply(this,arguments);var selector,type,response,self=this,off=url.indexOf(" ");return off>=0&&(selector=jQuery.trim(url.slice(off)),url=url.slice(0,off)),jQuery.isFunction(params)?(callback=params,params=void 0):params&&"object"==typeof params&&(type="POST"),self.length>0&&jQuery.ajax({url:url,type:type,dataType:"html",data:params}).done(function(responseText){response=arguments,self.html(selector?jQuery("<div>").append(jQuery.parseHTML(responseText)).find(selector):responseText)}).complete(callback&&function(jqXHR,status){self.each(callback,response||[jqXHR.responseText,status,jqXHR])}),this},jQuery.each(["ajaxStart","ajaxStop","ajaxComplete","ajaxError","ajaxSuccess","ajaxSend"],function(i,type){jQuery.fn[type]=function(fn){return this.on(type,fn)}}),jQuery.expr.filters.animated=function(elem){return jQuery.grep(jQuery.timers,function(fn){return elem===fn.elem}).length};var docElem=window.document.documentElement;jQuery.offset={setOffset:function(elem,options,i){var curPosition,curLeft,curCSSTop,curTop,curOffset,curCSSLeft,calculatePosition,position=jQuery.css(elem,"position"),curElem=jQuery(elem),props={};"static"===position&&(elem.style.position="relative"),curOffset=curElem.offset(),curCSSTop=jQuery.css(elem,"top"),curCSSLeft=jQuery.css(elem,"left"),calculatePosition=("absolute"===position||"fixed"===position)&&(curCSSTop+curCSSLeft).indexOf("auto")>-1,calculatePosition?(curPosition=curElem.position(),curTop=curPosition.top,curLeft=curPosition.left):(curTop=parseFloat(curCSSTop)||0,curLeft=parseFloat(curCSSLeft)||0),jQuery.isFunction(options)&&(options=options.call(elem,i,curOffset)),null!=options.top&&(props.top=options.top-curOffset.top+curTop),null!=options.left&&(props.left=options.left-curOffset.left+curLeft),"using"in options?options.using.call(elem,props):curElem.css(props)}},jQuery.fn.extend({offset:function(options){if(arguments.length)return void 0===options?this:this.each(function(i){jQuery.offset.setOffset(this,options,i)});var docElem,win,elem=this[0],box={top:0,left:0},doc=elem&&elem.ownerDocument;if(doc)return docElem=doc.documentElement,jQuery.contains(docElem,elem)?(typeof elem.getBoundingClientRect!==strundefined&&(box=elem.getBoundingClientRect()),win=getWindow(doc),{top:box.top+win.pageYOffset-docElem.clientTop,left:box.left+win.pageXOffset-docElem.clientLeft}):box},position:function(){if(this[0]){var offsetParent,offset,elem=this[0],parentOffset={top:0,left:0};return"fixed"===jQuery.css(elem,"position")?offset=elem.getBoundingClientRect():(offsetParent=this.offsetParent(),offset=this.offset(),jQuery.nodeName(offsetParent[0],"html")||(parentOffset=offsetParent.offset()),parentOffset.top+=jQuery.css(offsetParent[0],"borderTopWidth",!0),parentOffset.left+=jQuery.css(offsetParent[0],"borderLeftWidth",!0)),{top:offset.top-parentOffset.top-jQuery.css(elem,"marginTop",!0),left:offset.left-parentOffset.left-jQuery.css(elem,"marginLeft",!0)}}},offsetParent:function(){return this.map(function(){for(var offsetParent=this.offsetParent||docElem;offsetParent&&!jQuery.nodeName(offsetParent,"html")&&"static"===jQuery.css(offsetParent,"position");)offsetParent=offsetParent.offsetParent;return offsetParent||docElem})}}),jQuery.each({scrollLeft:"pageXOffset",scrollTop:"pageYOffset"},function(method,prop){var top="pageYOffset"===prop;jQuery.fn[method]=function(val){return access(this,function(elem,method,val){var win=getWindow(elem);return void 0===val?win?win[prop]:elem[method]:void(win?win.scrollTo(top?window.pageXOffset:val,top?val:window.pageYOffset):elem[method]=val)},method,val,arguments.length,null)}}),jQuery.each(["top","left"],function(i,prop){jQuery.cssHooks[prop]=addGetHookIf(support.pixelPosition,function(elem,computed){if(computed)return computed=curCSS(elem,prop),rnumnonpx.test(computed)?jQuery(elem).position()[prop]+"px":computed})}),jQuery.each({Height:"height",Width:"width"},function(name,type){jQuery.each({padding:"inner"+name,content:type,"":"outer"+name},function(defaultExtra,funcName){jQuery.fn[funcName]=function(margin,value){var chainable=arguments.length&&(defaultExtra||"boolean"!=typeof margin),extra=defaultExtra||(margin===!0||value===!0?"margin":"border");return access(this,function(elem,type,value){var doc;return jQuery.isWindow(elem)?elem.document.documentElement["client"+name]:9===elem.nodeType?(doc=elem.documentElement,Math.max(elem.body["scroll"+name],doc["scroll"+name],elem.body["offset"+name],doc["offset"+name],doc["client"+name])):void 0===value?jQuery.css(elem,type,extra):jQuery.style(elem,type,value,extra)},type,chainable?margin:void 0,chainable,null)}})}),jQuery.fn.size=function(){return this.length},jQuery.fn.andSelf=jQuery.fn.addBack,"function"==typeof define&&define.amd&&define("jquery",[],function(){return jQuery});var _jQuery=window.jQuery,_$=window.$;return jQuery.noConflict=function(deep){return window.$===jQuery&&(window.$=_$),deep&&window.jQuery===jQuery&&(window.jQuery=_jQuery),jQuery},typeof noGlobal===strundefined&&(window.jQuery=window.$=jQuery),jQuery}),function(window){function isArraylike(obj){var length=obj.length,type=$.type(obj);return"function"!==type&&!$.isWindow(obj)&&(!(1!==obj.nodeType||!length)||("array"===type||0===length||"number"==typeof length&&length>0&&length-1 in obj))}if(!window.jQuery){var $=function(selector,context){return new $.fn.init(selector,context)};$.isWindow=function(obj){return null!=obj&&obj==obj.window},$.type=function(obj){return null==obj?obj+"":"object"==typeof obj||"function"==typeof obj?class2type[toString.call(obj)]||"object":typeof obj},$.isArray=Array.isArray||function(obj){return"array"===$.type(obj)},$.isPlainObject=function(obj){var key;if(!obj||"object"!==$.type(obj)||obj.nodeType||$.isWindow(obj))return!1;try{if(obj.constructor&&!hasOwn.call(obj,"constructor")&&!hasOwn.call(obj.constructor.prototype,"isPrototypeOf"))return!1}catch(e){return!1}for(key in obj);return void 0===key||hasOwn.call(obj,key)},$.each=function(obj,callback,args){var value,i=0,length=obj.length,isArray=isArraylike(obj);if(args){if(isArray)for(;i<length&&(value=callback.apply(obj[i],args),value!==!1);i++);else for(i in obj)if(value=callback.apply(obj[i],args),value===!1)break}else if(isArray)for(;i<length&&(value=callback.call(obj[i],i,obj[i]),value!==!1);i++);else for(i in obj)if(value=callback.call(obj[i],i,obj[i]),value===!1)break;return obj},$.data=function(node,key,value){if(void 0===value){var id=node[$.expando],store=id&&cache[id];if(void 0===key)return store;if(store&&key in store)return store[key]}else if(void 0!==key){var id=node[$.expando]||(node[$.expando]=++$.uuid);return cache[id]=cache[id]||{},cache[id][key]=value,value}},$.removeData=function(node,keys){var id=node[$.expando],store=id&&cache[id];store&&$.each(keys,function(_,key){delete store[key]})},$.extend=function(){var src,copyIsArray,copy,name,options,clone,target=arguments[0]||{},i=1,length=arguments.length,deep=!1;for("boolean"==typeof target&&(deep=target,target=arguments[i]||{},i++),"object"!=typeof target&&"function"!==$.type(target)&&(target={}),i===length&&(target=this,i--);i<length;i++)if(null!=(options=arguments[i]))for(name in options)src=target[name],copy=options[name],target!==copy&&(deep&&copy&&($.isPlainObject(copy)||(copyIsArray=$.isArray(copy)))?(copyIsArray?(copyIsArray=!1,clone=src&&$.isArray(src)?src:[]):clone=src&&$.isPlainObject(src)?src:{},target[name]=$.extend(deep,clone,copy)):void 0!==copy&&(target[name]=copy));return target},$.queue=function(elem,type,data){function $makeArray(arr,results){var ret=results||[];return null!=arr&&(isArraylike(Object(arr))?!function(first,second){for(var len=+second.length,j=0,i=first.length;j<len;)first[i++]=second[j++];if(len!==len)for(;void 0!==second[j];)first[i++]=second[j++];return first.length=i,first}(ret,"string"==typeof arr?[arr]:arr):[].push.call(ret,arr)),ret}if(elem){type=(type||"fx")+"queue";var q=$.data(elem,type);return data?(!q||$.isArray(data)?q=$.data(elem,type,$makeArray(data)):q.push(data),q):q||[]}},$.dequeue=function(elems,type){$.each(elems.nodeType?[elems]:elems,function(i,elem){type=type||"fx";var queue=$.queue(elem,type),fn=queue.shift();"inprogress"===fn&&(fn=queue.shift()),fn&&("fx"===type&&queue.unshift("inprogress"),fn.call(elem,function(){$.dequeue(elem,type)}))})},$.fn=$.prototype={init:function(selector){if(selector.nodeType)return this[0]=selector,this;throw new Error("Not a DOM node.")},offset:function(){var box=this[0].getBoundingClientRect?this[0].getBoundingClientRect():{top:0,left:0};return{top:box.top+(window.pageYOffset||document.scrollTop||0)-(document.clientTop||0),left:box.left+(window.pageXOffset||document.scrollLeft||0)-(document.clientLeft||0)}},position:function(){function offsetParent(){for(var offsetParent=this.offsetParent||document;offsetParent&&"html"===!offsetParent.nodeType.toLowerCase&&"static"===offsetParent.style.position;)offsetParent=offsetParent.offsetParent;return offsetParent||document}var elem=this[0],offsetParent=offsetParent.apply(elem),offset=this.offset(),parentOffset=/^(?:body|html)$/i.test(offsetParent.nodeName)?{top:0,left:0}:$(offsetParent).offset();return offset.top-=parseFloat(elem.style.marginTop)||0,offset.left-=parseFloat(elem.style.marginLeft)||0,offsetParent.style&&(parentOffset.top+=parseFloat(offsetParent.style.borderTopWidth)||0,parentOffset.left+=parseFloat(offsetParent.style.borderLeftWidth)||0),{top:offset.top-parentOffset.top,left:offset.left-parentOffset.left}}};var cache={};$.expando="velocity"+(new Date).getTime(),$.uuid=0;for(var class2type={},hasOwn=class2type.hasOwnProperty,toString=class2type.toString,types="Boolean Number String Function Array Date RegExp Object Error".split(" "),i=0;i<types.length;i++)class2type["[object "+types[i]+"]"]=types[i].toLowerCase();$.fn.init.prototype=$.fn,window.Velocity={Utilities:$}}}(window),function(factory){"object"==typeof module&&"object"==typeof module.exports?module.exports=factory():"function"==typeof define&&define.amd?define(factory):factory()}(function(){return function(global,window,document,undefined){function compactSparseArray(array){for(var index=-1,length=array?array.length:0,result=[];++index<length;){var value=array[index];value&&result.push(value)}return result}function sanitizeElements(elements){return Type.isWrapped(elements)?elements=[].slice.call(elements):Type.isNode(elements)&&(elements=[elements]),elements}function Data(element){var response=$.data(element,"velocity");return null===response?undefined:response}function generateStep(steps){return function(p){return Math.round(p*steps)*(1/steps)}}function generateBezier(mX1,mY1,mX2,mY2){function A(aA1,aA2){return 1-3*aA2+3*aA1}function B(aA1,aA2){return 3*aA2-6*aA1}function C(aA1){return 3*aA1}function calcBezier(aT,aA1,aA2){return((A(aA1,aA2)*aT+B(aA1,aA2))*aT+C(aA1))*aT}function getSlope(aT,aA1,aA2){return 3*A(aA1,aA2)*aT*aT+2*B(aA1,aA2)*aT+C(aA1)}function newtonRaphsonIterate(aX,aGuessT){for(var i=0;i<NEWTON_ITERATIONS;++i){var currentSlope=getSlope(aGuessT,mX1,mX2);if(0===currentSlope)return aGuessT;var currentX=calcBezier(aGuessT,mX1,mX2)-aX;aGuessT-=currentX/currentSlope}return aGuessT}function calcSampleValues(){for(var i=0;i<kSplineTableSize;++i)mSampleValues[i]=calcBezier(i*kSampleStepSize,mX1,mX2)}function binarySubdivide(aX,aA,aB){var currentX,currentT,i=0;do currentT=aA+(aB-aA)/2,currentX=calcBezier(currentT,mX1,mX2)-aX,currentX>0?aB=currentT:aA=currentT;while(Math.abs(currentX)>SUBDIVISION_PRECISION&&++i<SUBDIVISION_MAX_ITERATIONS);return currentT}function getTForX(aX){for(var intervalStart=0,currentSample=1,lastSample=kSplineTableSize-1;currentSample!=lastSample&&mSampleValues[currentSample]<=aX;++currentSample)intervalStart+=kSampleStepSize;--currentSample;var dist=(aX-mSampleValues[currentSample])/(mSampleValues[currentSample+1]-mSampleValues[currentSample]),guessForT=intervalStart+dist*kSampleStepSize,initialSlope=getSlope(guessForT,mX1,mX2);return initialSlope>=NEWTON_MIN_SLOPE?newtonRaphsonIterate(aX,guessForT):0==initialSlope?guessForT:binarySubdivide(aX,intervalStart,intervalStart+kSampleStepSize)}function precompute(){_precomputed=!0,mX1==mY1&&mX2==mY2||calcSampleValues()}var NEWTON_ITERATIONS=4,NEWTON_MIN_SLOPE=.001,SUBDIVISION_PRECISION=1e-7,SUBDIVISION_MAX_ITERATIONS=10,kSplineTableSize=11,kSampleStepSize=1/(kSplineTableSize-1),float32ArraySupported="Float32Array"in window;if(4!==arguments.length)return!1;for(var i=0;i<4;++i)if("number"!=typeof arguments[i]||isNaN(arguments[i])||!isFinite(arguments[i]))return!1;mX1=Math.min(mX1,1),mX2=Math.min(mX2,1),mX1=Math.max(mX1,0),mX2=Math.max(mX2,0);var mSampleValues=float32ArraySupported?new Float32Array(kSplineTableSize):new Array(kSplineTableSize),_precomputed=!1,f=function(aX){return _precomputed||precompute(),mX1===mY1&&mX2===mY2?aX:0===aX?0:1===aX?1:calcBezier(getTForX(aX),mY1,mY2)};f.getControlPoints=function(){return[{x:mX1,y:mY1},{x:mX2,y:mY2}]};var str="generateBezier("+[mX1,mY1,mX2,mY2]+")";return f.toString=function(){return str},f}function getEasing(value,duration){var easing=value;return Type.isString(value)?Velocity.Easings[value]||(easing=!1):easing=Type.isArray(value)&&1===value.length?generateStep.apply(null,value):Type.isArray(value)&&2===value.length?generateSpringRK4.apply(null,value.concat([duration])):!(!Type.isArray(value)||4!==value.length)&&generateBezier.apply(null,value),easing===!1&&(easing=Velocity.Easings[Velocity.defaults.easing]?Velocity.defaults.easing:EASING_DEFAULT),easing}function tick(timestamp){if(timestamp)for(var timeCurrent=(new Date).getTime(),i=0,callsLength=Velocity.State.calls.length;i<callsLength;i++)if(Velocity.State.calls[i]){var callContainer=Velocity.State.calls[i],call=callContainer[0],opts=callContainer[2],timeStart=callContainer[3],firstTick=!!timeStart;timeStart||(timeStart=Velocity.State.calls[i][3]=timeCurrent-16);for(var percentComplete=Math.min((timeCurrent-timeStart)/opts.duration,1),j=0,callLength=call.length;j<callLength;j++){var tweensContainer=call[j],element=tweensContainer.element;if(Data(element)){var transformPropertyExists=!1;if(opts.display!==undefined&&null!==opts.display&&"none"!==opts.display){if("flex"===opts.display){var flexValues=["-webkit-box","-moz-box","-ms-flexbox","-webkit-flex"];$.each(flexValues,function(i,flexValue){CSS.setPropertyValue(element,"display",flexValue)})}CSS.setPropertyValue(element,"display",opts.display)}opts.visibility!==undefined&&"hidden"!==opts.visibility&&CSS.setPropertyValue(element,"visibility",opts.visibility);for(var property in tweensContainer)if("element"!==property){var currentValue,tween=tweensContainer[property],easing=Type.isString(tween.easing)?Velocity.Easings[tween.easing]:tween.easing;if(1===percentComplete)currentValue=tween.endValue;else if(currentValue=tween.startValue+(tween.endValue-tween.startValue)*easing(percentComplete),!firstTick&&currentValue===tween.currentValue)continue;if(tween.currentValue=currentValue,CSS.Hooks.registered[property]){var hookRoot=CSS.Hooks.getRoot(property),rootPropertyValueCache=Data(element).rootPropertyValueCache[hookRoot];rootPropertyValueCache&&(tween.rootPropertyValue=rootPropertyValueCache)}var adjustedSetData=CSS.setPropertyValue(element,property,tween.currentValue+(0===parseFloat(currentValue)?"":tween.unitType),tween.rootPropertyValue,tween.scrollData);CSS.Hooks.registered[property]&&(CSS.Normalizations.registered[hookRoot]?Data(element).rootPropertyValueCache[hookRoot]=CSS.Normalizations.registered[hookRoot]("extract",null,adjustedSetData[1]):Data(element).rootPropertyValueCache[hookRoot]=adjustedSetData[1]),"transform"===adjustedSetData[0]&&(transformPropertyExists=!0)}opts.mobileHA&&Data(element).transformCache.translate3d===undefined&&(Data(element).transformCache.translate3d="(0px, 0px, 0px)",transformPropertyExists=!0),transformPropertyExists&&CSS.flushTransformCache(element)}}opts.display!==undefined&&"none"!==opts.display&&(Velocity.State.calls[i][2].display=!1),opts.visibility!==undefined&&"hidden"!==opts.visibility&&(Velocity.State.calls[i][2].visibility=!1),opts.progress&&opts.progress.call(callContainer[1],callContainer[1],percentComplete,Math.max(0,timeStart+opts.duration-timeCurrent),timeStart),1===percentComplete&&completeCall(i)}Velocity.State.isTicking&&ticker(tick)}function completeCall(callIndex,isStopped){if(!Velocity.State.calls[callIndex])return!1;for(var call=Velocity.State.calls[callIndex][0],elements=Velocity.State.calls[callIndex][1],opts=Velocity.State.calls[callIndex][2],resolver=Velocity.State.calls[callIndex][4],remainingCallsExist=!1,i=0,callLength=call.length;i<callLength;i++){var element=call[i].element;if(isStopped||opts.loop||("none"===opts.display&&CSS.setPropertyValue(element,"display",opts.display),"hidden"===opts.visibility&&CSS.setPropertyValue(element,"visibility",opts.visibility)),opts.loop!==!0&&($.queue(element)[1]===undefined||!/\.velocityQueueEntryFlag/i.test($.queue(element)[1]))&&Data(element)){Data(element).isAnimating=!1,Data(element).rootPropertyValueCache={};var transformHAPropertyExists=!1;$.each(CSS.Lists.transforms3D,function(i,transformName){var defaultValue=/^scale/.test(transformName)?1:0,currentValue=Data(element).transformCache[transformName];Data(element).transformCache[transformName]!==undefined&&new RegExp("^\\("+defaultValue+"[^.]").test(currentValue)&&(transformHAPropertyExists=!0,delete Data(element).transformCache[transformName])}),opts.mobileHA&&(transformHAPropertyExists=!0,delete Data(element).transformCache.translate3d),transformHAPropertyExists&&CSS.flushTransformCache(element),CSS.Values.removeClass(element,"velocity-animating")}if(!isStopped&&opts.complete&&!opts.loop&&i===callLength-1)try{opts.complete.call(elements,elements)}catch(error){setTimeout(function(){throw error},1)}resolver&&opts.loop!==!0&&resolver(elements),opts.loop!==!0||isStopped||($.each(Data(element).tweensContainer,function(propertyName,tweenContainer){/^rotate/.test(propertyName)&&360===parseFloat(tweenContainer.endValue)&&(tweenContainer.endValue=0,tweenContainer.startValue=360)}),Velocity(element,"reverse",{loop:!0,delay:opts.delay})),opts.queue!==!1&&$.dequeue(element,opts.queue)}Velocity.State.calls[callIndex]=!1;for(var j=0,callsLength=Velocity.State.calls.length;j<callsLength;j++)if(Velocity.State.calls[j]!==!1){remainingCallsExist=!0;break}remainingCallsExist===!1&&(Velocity.State.isTicking=!1,delete Velocity.State.calls,Velocity.State.calls=[])}var $,IE=function(){if(document.documentMode)return document.documentMode;for(var i=7;i>4;i--){var div=document.createElement("div");if(div.innerHTML="<!--[if IE "+i+"]><span></span><![endif]-->",div.getElementsByTagName("span").length)return div=null,i}return undefined}(),rAFShim=function(){var timeLast=0;return window.webkitRequestAnimationFrame||window.mozRequestAnimationFrame||function(callback){var timeDelta,timeCurrent=(new Date).getTime();return timeDelta=Math.max(0,16-(timeCurrent-timeLast)),timeLast=timeCurrent+timeDelta,setTimeout(function(){callback(timeCurrent+timeDelta)},timeDelta)}}(),Type={isString:function(variable){return"string"==typeof variable},isArray:Array.isArray||function(variable){return"[object Array]"===Object.prototype.toString.call(variable)},isFunction:function(variable){return"[object Function]"===Object.prototype.toString.call(variable)},isNode:function(variable){return variable&&variable.nodeType},isNodeList:function(variable){return"object"==typeof variable&&/^\[object (HTMLCollection|NodeList|Object)\]$/.test(Object.prototype.toString.call(variable))&&variable.length!==undefined&&(0===variable.length||"object"==typeof variable[0]&&variable[0].nodeType>0)},isWrapped:function(variable){return variable&&(variable.jquery||window.Zepto&&window.Zepto.zepto.isZ(variable))},isSVG:function(variable){return window.SVGElement&&variable instanceof window.SVGElement},isEmptyObject:function(variable){for(var name in variable)return!1;return!0}},isJQuery=!1;if(global.fn&&global.fn.jquery?($=global,isJQuery=!0):$=window.Velocity.Utilities,IE<=8&&!isJQuery)throw new Error("Velocity: IE8 and below require jQuery to be loaded before Velocity.");if(IE<=7)return void(jQuery.fn.velocity=jQuery.fn.animate);var DURATION_DEFAULT=400,EASING_DEFAULT="swing",Velocity={State:{isMobile:/Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent),isAndroid:/Android/i.test(navigator.userAgent),isGingerbread:/Android 2\.3\.[3-7]/i.test(navigator.userAgent),isChrome:window.chrome,isFirefox:/Firefox/i.test(navigator.userAgent),prefixElement:document.createElement("div"),prefixMatches:{},scrollAnchor:null,scrollPropertyLeft:null,scrollPropertyTop:null,isTicking:!1,calls:[]},CSS:{},Utilities:$,Redirects:{},Easings:{},Promise:window.Promise,defaults:{queue:"",duration:DURATION_DEFAULT,easing:EASING_DEFAULT,begin:undefined,complete:undefined,progress:undefined,display:undefined,visibility:undefined,loop:!1,delay:!1,mobileHA:!0,_cacheValues:!0},init:function(element){$.data(element,"velocity",{isSVG:Type.isSVG(element),isAnimating:!1,computedStyle:null,tweensContainer:null,rootPropertyValueCache:{},transformCache:{}})},hook:null,mock:!1,version:{major:1,minor:1,patch:0},debug:!1};window.pageYOffset!==undefined?(Velocity.State.scrollAnchor=window,Velocity.State.scrollPropertyLeft="pageXOffset",Velocity.State.scrollPropertyTop="pageYOffset"):(Velocity.State.scrollAnchor=document.documentElement||document.body.parentNode||document.body,Velocity.State.scrollPropertyLeft="scrollLeft",Velocity.State.scrollPropertyTop="scrollTop");var generateSpringRK4=function(){function springAccelerationForState(state){return-state.tension*state.x-state.friction*state.v}function springEvaluateStateWithDerivative(initialState,dt,derivative){var state={x:initialState.x+derivative.dx*dt,v:initialState.v+derivative.dv*dt,tension:initialState.tension,friction:initialState.friction};return{dx:state.v,dv:springAccelerationForState(state)}}function springIntegrateState(state,dt){var a={dx:state.v,dv:springAccelerationForState(state)},b=springEvaluateStateWithDerivative(state,.5*dt,a),c=springEvaluateStateWithDerivative(state,.5*dt,b),d=springEvaluateStateWithDerivative(state,dt,c),dxdt=1/6*(a.dx+2*(b.dx+c.dx)+d.dx),dvdt=1/6*(a.dv+2*(b.dv+c.dv)+d.dv);return state.x=state.x+dxdt*dt,state.v=state.v+dvdt*dt,state}return function springRK4Factory(tension,friction,duration){var have_duration,dt,last_state,initState={x:-1,v:0,tension:null,friction:null},path=[0],time_lapsed=0,tolerance=1e-4,DT=.016;for(tension=parseFloat(tension)||500,friction=parseFloat(friction)||20,duration=duration||null,initState.tension=tension,initState.friction=friction,have_duration=null!==duration,have_duration?(time_lapsed=springRK4Factory(tension,friction),dt=time_lapsed/duration*DT):dt=DT;;)if(last_state=springIntegrateState(last_state||initState,dt),path.push(1+last_state.x),time_lapsed+=16,!(Math.abs(last_state.x)>tolerance&&Math.abs(last_state.v)>tolerance))break;return have_duration?function(percentComplete){return path[percentComplete*(path.length-1)|0]}:time_lapsed}}();Velocity.Easings={linear:function(p){return p},swing:function(p){return.5-Math.cos(p*Math.PI)/2},spring:function(p){return 1-Math.cos(4.5*p*Math.PI)*Math.exp(6*-p)}},$.each([["ease",[.25,.1,.25,1]],["ease-in",[.42,0,1,1]],["ease-out",[0,0,.58,1]],["ease-in-out",[.42,0,.58,1]],["easeInSine",[.47,0,.745,.715]],["easeOutSine",[.39,.575,.565,1]],["easeInOutSine",[.445,.05,.55,.95]],["easeInQuad",[.55,.085,.68,.53]],["easeOutQuad",[.25,.46,.45,.94]],["easeInOutQuad",[.455,.03,.515,.955]],["easeInCubic",[.55,.055,.675,.19]],["easeOutCubic",[.215,.61,.355,1]],["easeInOutCubic",[.645,.045,.355,1]],["easeInQuart",[.895,.03,.685,.22]],["easeOutQuart",[.165,.84,.44,1]],["easeInOutQuart",[.77,0,.175,1]],["easeInQuint",[.755,.05,.855,.06]],["easeOutQuint",[.23,1,.32,1]],["easeInOutQuint",[.86,0,.07,1]],["easeInExpo",[.95,.05,.795,.035]],["easeOutExpo",[.19,1,.22,1]],["easeInOutExpo",[1,0,0,1]],["easeInCirc",[.6,.04,.98,.335]],["easeOutCirc",[.075,.82,.165,1]],["easeInOutCirc",[.785,.135,.15,.86]]],function(i,easingArray){
Velocity.Easings[easingArray[0]]=generateBezier.apply(null,easingArray[1])});var CSS=Velocity.CSS={RegEx:{isHex:/^#([A-f\d]{3}){1,2}$/i,valueUnwrap:/^[A-z]+\((.*)\)$/i,wrappedValueAlreadyExtracted:/[0-9.]+ [0-9.]+ [0-9.]+( [0-9.]+)?/,valueSplit:/([A-z]+\(.+\))|(([A-z0-9#-.]+?)(?=\s|$))/gi},Lists:{colors:["fill","stroke","stopColor","color","backgroundColor","borderColor","borderTopColor","borderRightColor","borderBottomColor","borderLeftColor","outlineColor"],transformsBase:["translateX","translateY","scale","scaleX","scaleY","skewX","skewY","rotateZ"],transforms3D:["transformPerspective","translateZ","scaleZ","rotateX","rotateY"]},Hooks:{templates:{textShadow:["Color X Y Blur","black 0px 0px 0px"],boxShadow:["Color X Y Blur Spread","black 0px 0px 0px 0px"],clip:["Top Right Bottom Left","0px 0px 0px 0px"],backgroundPosition:["X Y","0% 0%"],transformOrigin:["X Y Z","50% 50% 0px"],perspectiveOrigin:["X Y","50% 50%"]},registered:{},register:function(){for(var i=0;i<CSS.Lists.colors.length;i++){var rgbComponents="color"===CSS.Lists.colors[i]?"0 0 0 1":"255 255 255 1";CSS.Hooks.templates[CSS.Lists.colors[i]]=["Red Green Blue Alpha",rgbComponents]}var rootProperty,hookTemplate,hookNames;if(IE)for(rootProperty in CSS.Hooks.templates){hookTemplate=CSS.Hooks.templates[rootProperty],hookNames=hookTemplate[0].split(" ");var defaultValues=hookTemplate[1].match(CSS.RegEx.valueSplit);"Color"===hookNames[0]&&(hookNames.push(hookNames.shift()),defaultValues.push(defaultValues.shift()),CSS.Hooks.templates[rootProperty]=[hookNames.join(" "),defaultValues.join(" ")])}for(rootProperty in CSS.Hooks.templates){hookTemplate=CSS.Hooks.templates[rootProperty],hookNames=hookTemplate[0].split(" ");for(var i in hookNames){var fullHookName=rootProperty+hookNames[i],hookPosition=i;CSS.Hooks.registered[fullHookName]=[rootProperty,hookPosition]}}},getRoot:function(property){var hookData=CSS.Hooks.registered[property];return hookData?hookData[0]:property},cleanRootPropertyValue:function(rootProperty,rootPropertyValue){return CSS.RegEx.valueUnwrap.test(rootPropertyValue)&&(rootPropertyValue=rootPropertyValue.match(CSS.RegEx.valueUnwrap)[1]),CSS.Values.isCSSNullValue(rootPropertyValue)&&(rootPropertyValue=CSS.Hooks.templates[rootProperty][1]),rootPropertyValue},extractValue:function(fullHookName,rootPropertyValue){var hookData=CSS.Hooks.registered[fullHookName];if(hookData){var hookRoot=hookData[0],hookPosition=hookData[1];return rootPropertyValue=CSS.Hooks.cleanRootPropertyValue(hookRoot,rootPropertyValue),rootPropertyValue.toString().match(CSS.RegEx.valueSplit)[hookPosition]}return rootPropertyValue},injectValue:function(fullHookName,hookValue,rootPropertyValue){var hookData=CSS.Hooks.registered[fullHookName];if(hookData){var rootPropertyValueParts,rootPropertyValueUpdated,hookRoot=hookData[0],hookPosition=hookData[1];return rootPropertyValue=CSS.Hooks.cleanRootPropertyValue(hookRoot,rootPropertyValue),rootPropertyValueParts=rootPropertyValue.toString().match(CSS.RegEx.valueSplit),rootPropertyValueParts[hookPosition]=hookValue,rootPropertyValueUpdated=rootPropertyValueParts.join(" ")}return rootPropertyValue}},Normalizations:{registered:{clip:function(type,element,propertyValue){switch(type){case"name":return"clip";case"extract":var extracted;return CSS.RegEx.wrappedValueAlreadyExtracted.test(propertyValue)?extracted=propertyValue:(extracted=propertyValue.toString().match(CSS.RegEx.valueUnwrap),extracted=extracted?extracted[1].replace(/,(\s+)?/g," "):propertyValue),extracted;case"inject":return"rect("+propertyValue+")"}},blur:function(type,element,propertyValue){switch(type){case"name":return"-webkit-filter";case"extract":var extracted=parseFloat(propertyValue);if(!extracted&&0!==extracted){var blurComponent=propertyValue.toString().match(/blur\(([0-9]+[A-z]+)\)/i);extracted=blurComponent?blurComponent[1]:0}return extracted;case"inject":return parseFloat(propertyValue)?"blur("+propertyValue+")":"none"}},opacity:function(type,element,propertyValue){if(IE<=8)switch(type){case"name":return"filter";case"extract":var extracted=propertyValue.toString().match(/alpha\(opacity=(.*)\)/i);return propertyValue=extracted?extracted[1]/100:1;case"inject":return element.style.zoom=1,parseFloat(propertyValue)>=1?"":"alpha(opacity="+parseInt(100*parseFloat(propertyValue),10)+")"}else switch(type){case"name":return"opacity";case"extract":return propertyValue;case"inject":return propertyValue}}},register:function(){IE<=9||Velocity.State.isGingerbread||(CSS.Lists.transformsBase=CSS.Lists.transformsBase.concat(CSS.Lists.transforms3D));for(var i=0;i<CSS.Lists.transformsBase.length;i++)!function(){var transformName=CSS.Lists.transformsBase[i];CSS.Normalizations.registered[transformName]=function(type,element,propertyValue){switch(type){case"name":return"transform";case"extract":return Data(element)===undefined||Data(element).transformCache[transformName]===undefined?/^scale/i.test(transformName)?1:0:Data(element).transformCache[transformName].replace(/[()]/g,"");case"inject":var invalid=!1;switch(transformName.substr(0,transformName.length-1)){case"translate":invalid=!/(%|px|em|rem|vw|vh|\d)$/i.test(propertyValue);break;case"scal":case"scale":Velocity.State.isAndroid&&Data(element).transformCache[transformName]===undefined&&propertyValue<1&&(propertyValue=1),invalid=!/(\d)$/i.test(propertyValue);break;case"skew":invalid=!/(deg|\d)$/i.test(propertyValue);break;case"rotate":invalid=!/(deg|\d)$/i.test(propertyValue)}return invalid||(Data(element).transformCache[transformName]="("+propertyValue+")"),Data(element).transformCache[transformName]}}}();for(var i=0;i<CSS.Lists.colors.length;i++)!function(){var colorName=CSS.Lists.colors[i];CSS.Normalizations.registered[colorName]=function(type,element,propertyValue){switch(type){case"name":return colorName;case"extract":var extracted;if(CSS.RegEx.wrappedValueAlreadyExtracted.test(propertyValue))extracted=propertyValue;else{var converted,colorNames={black:"rgb(0, 0, 0)",blue:"rgb(0, 0, 255)",gray:"rgb(128, 128, 128)",green:"rgb(0, 128, 0)",red:"rgb(255, 0, 0)",white:"rgb(255, 255, 255)"};/^[A-z]+$/i.test(propertyValue)?converted=colorNames[propertyValue]!==undefined?colorNames[propertyValue]:colorNames.black:CSS.RegEx.isHex.test(propertyValue)?converted="rgb("+CSS.Values.hexToRgb(propertyValue).join(" ")+")":/^rgba?\(/i.test(propertyValue)||(converted=colorNames.black),extracted=(converted||propertyValue).toString().match(CSS.RegEx.valueUnwrap)[1].replace(/,(\s+)?/g," ")}return IE<=8||3!==extracted.split(" ").length||(extracted+=" 1"),extracted;case"inject":return IE<=8?4===propertyValue.split(" ").length&&(propertyValue=propertyValue.split(/\s+/).slice(0,3).join(" ")):3===propertyValue.split(" ").length&&(propertyValue+=" 1"),(IE<=8?"rgb":"rgba")+"("+propertyValue.replace(/\s+/g,",").replace(/\.(\d)+(?=,)/g,"")+")"}}}()}},Names:{camelCase:function(property){return property.replace(/-(\w)/g,function(match,subMatch){return subMatch.toUpperCase()})},SVGAttribute:function(property){var SVGAttributes="width|height|x|y|cx|cy|r|rx|ry|x1|x2|y1|y2";return(IE||Velocity.State.isAndroid&&!Velocity.State.isChrome)&&(SVGAttributes+="|transform"),new RegExp("^("+SVGAttributes+")$","i").test(property)},prefixCheck:function(property){if(Velocity.State.prefixMatches[property])return[Velocity.State.prefixMatches[property],!0];for(var vendors=["","Webkit","Moz","ms","O"],i=0,vendorsLength=vendors.length;i<vendorsLength;i++){var propertyPrefixed;if(propertyPrefixed=0===i?property:vendors[i]+property.replace(/^\w/,function(match){return match.toUpperCase()}),Type.isString(Velocity.State.prefixElement.style[propertyPrefixed]))return Velocity.State.prefixMatches[property]=propertyPrefixed,[propertyPrefixed,!0]}return[property,!1]}},Values:{hexToRgb:function(hex){var rgbParts,shortformRegex=/^#?([a-f\d])([a-f\d])([a-f\d])$/i,longformRegex=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i;return hex=hex.replace(shortformRegex,function(m,r,g,b){return r+r+g+g+b+b}),rgbParts=longformRegex.exec(hex),rgbParts?[parseInt(rgbParts[1],16),parseInt(rgbParts[2],16),parseInt(rgbParts[3],16)]:[0,0,0]},isCSSNullValue:function(value){return 0==value||/^(none|auto|transparent|(rgba\(0, ?0, ?0, ?0\)))$/i.test(value)},getUnitType:function(property){return/^(rotate|skew)/i.test(property)?"deg":/(^(scale|scaleX|scaleY|scaleZ|alpha|flexGrow|flexHeight|zIndex|fontWeight)$)|((opacity|red|green|blue|alpha)$)/i.test(property)?"":"px"},getDisplayType:function(element){var tagName=element&&element.tagName.toString().toLowerCase();return/^(b|big|i|small|tt|abbr|acronym|cite|code|dfn|em|kbd|strong|samp|var|a|bdo|br|img|map|object|q|script|span|sub|sup|button|input|label|select|textarea)$/i.test(tagName)?"inline":/^(li)$/i.test(tagName)?"list-item":/^(tr)$/i.test(tagName)?"table-row":"block"},addClass:function(element,className){element.classList?element.classList.add(className):element.className+=(element.className.length?" ":"")+className},removeClass:function(element,className){element.classList?element.classList.remove(className):element.className=element.className.toString().replace(new RegExp("(^|\\s)"+className.split(" ").join("|")+"(\\s|$)","gi")," ")}},getPropertyValue:function(element,property,rootPropertyValue,forceStyleLookup){function computePropertyValue(element,property){function revertDisplay(){toggleDisplay&&CSS.setPropertyValue(element,"display","none")}var computedValue=0;if(IE<=8)computedValue=$.css(element,property);else{var toggleDisplay=!1;if(/^(width|height)$/.test(property)&&0===CSS.getPropertyValue(element,"display")&&(toggleDisplay=!0,CSS.setPropertyValue(element,"display",CSS.Values.getDisplayType(element))),!forceStyleLookup){if("height"===property&&"border-box"!==CSS.getPropertyValue(element,"boxSizing").toString().toLowerCase()){var contentBoxHeight=element.offsetHeight-(parseFloat(CSS.getPropertyValue(element,"borderTopWidth"))||0)-(parseFloat(CSS.getPropertyValue(element,"borderBottomWidth"))||0)-(parseFloat(CSS.getPropertyValue(element,"paddingTop"))||0)-(parseFloat(CSS.getPropertyValue(element,"paddingBottom"))||0);return revertDisplay(),contentBoxHeight}if("width"===property&&"border-box"!==CSS.getPropertyValue(element,"boxSizing").toString().toLowerCase()){var contentBoxWidth=element.offsetWidth-(parseFloat(CSS.getPropertyValue(element,"borderLeftWidth"))||0)-(parseFloat(CSS.getPropertyValue(element,"borderRightWidth"))||0)-(parseFloat(CSS.getPropertyValue(element,"paddingLeft"))||0)-(parseFloat(CSS.getPropertyValue(element,"paddingRight"))||0);return revertDisplay(),contentBoxWidth}}var computedStyle;computedStyle=Data(element)===undefined?window.getComputedStyle(element,null):Data(element).computedStyle?Data(element).computedStyle:Data(element).computedStyle=window.getComputedStyle(element,null),(IE||Velocity.State.isFirefox)&&"borderColor"===property&&(property="borderTopColor"),computedValue=9===IE&&"filter"===property?computedStyle.getPropertyValue(property):computedStyle[property],""!==computedValue&&null!==computedValue||(computedValue=element.style[property]),revertDisplay()}if("auto"===computedValue&&/^(top|right|bottom|left)$/i.test(property)){var position=computePropertyValue(element,"position");("fixed"===position||"absolute"===position&&/top|left/i.test(property))&&(computedValue=$(element).position()[property]+"px")}return computedValue}var propertyValue;if(CSS.Hooks.registered[property]){var hook=property,hookRoot=CSS.Hooks.getRoot(hook);rootPropertyValue===undefined&&(rootPropertyValue=CSS.getPropertyValue(element,CSS.Names.prefixCheck(hookRoot)[0])),CSS.Normalizations.registered[hookRoot]&&(rootPropertyValue=CSS.Normalizations.registered[hookRoot]("extract",element,rootPropertyValue)),propertyValue=CSS.Hooks.extractValue(hook,rootPropertyValue)}else if(CSS.Normalizations.registered[property]){var normalizedPropertyName,normalizedPropertyValue;normalizedPropertyName=CSS.Normalizations.registered[property]("name",element),"transform"!==normalizedPropertyName&&(normalizedPropertyValue=computePropertyValue(element,CSS.Names.prefixCheck(normalizedPropertyName)[0]),CSS.Values.isCSSNullValue(normalizedPropertyValue)&&CSS.Hooks.templates[property]&&(normalizedPropertyValue=CSS.Hooks.templates[property][1])),propertyValue=CSS.Normalizations.registered[property]("extract",element,normalizedPropertyValue)}return/^[\d-]/.test(propertyValue)||(propertyValue=Data(element)&&Data(element).isSVG&&CSS.Names.SVGAttribute(property)?/^(height|width)$/i.test(property)?element.getBBox()[property]:element.getAttribute(property):computePropertyValue(element,CSS.Names.prefixCheck(property)[0])),CSS.Values.isCSSNullValue(propertyValue)&&(propertyValue=0),Velocity.debug>=2&&console.log("Get "+property+": "+propertyValue),propertyValue},setPropertyValue:function(element,property,propertyValue,rootPropertyValue,scrollData){var propertyName=property;if("scroll"===property)scrollData.container?scrollData.container["scroll"+scrollData.direction]=propertyValue:"Left"===scrollData.direction?window.scrollTo(propertyValue,scrollData.alternateValue):window.scrollTo(scrollData.alternateValue,propertyValue);else if(CSS.Normalizations.registered[property]&&"transform"===CSS.Normalizations.registered[property]("name",element))CSS.Normalizations.registered[property]("inject",element,propertyValue),propertyName="transform",propertyValue=Data(element).transformCache[property];else{if(CSS.Hooks.registered[property]){var hookName=property,hookRoot=CSS.Hooks.getRoot(property);rootPropertyValue=rootPropertyValue||CSS.getPropertyValue(element,hookRoot),propertyValue=CSS.Hooks.injectValue(hookName,propertyValue,rootPropertyValue),property=hookRoot}if(CSS.Normalizations.registered[property]&&(propertyValue=CSS.Normalizations.registered[property]("inject",element,propertyValue),property=CSS.Normalizations.registered[property]("name",element)),propertyName=CSS.Names.prefixCheck(property)[0],IE<=8)try{element.style[propertyName]=propertyValue}catch(error){Velocity.debug&&console.log("Browser does not support ["+propertyValue+"] for ["+propertyName+"]")}else Data(element)&&Data(element).isSVG&&CSS.Names.SVGAttribute(property)?element.setAttribute(property,propertyValue):element.style[propertyName]=propertyValue;Velocity.debug>=2&&console.log("Set "+property+" ("+propertyName+"): "+propertyValue)}return[propertyName,propertyValue]},flushTransformCache:function(element){function getTransformFloat(transformProperty){return parseFloat(CSS.getPropertyValue(element,transformProperty))}var transformString="";if((IE||Velocity.State.isAndroid&&!Velocity.State.isChrome)&&Data(element).isSVG){var SVGTransforms={translate:[getTransformFloat("translateX"),getTransformFloat("translateY")],skewX:[getTransformFloat("skewX")],skewY:[getTransformFloat("skewY")],scale:1!==getTransformFloat("scale")?[getTransformFloat("scale"),getTransformFloat("scale")]:[getTransformFloat("scaleX"),getTransformFloat("scaleY")],rotate:[getTransformFloat("rotateZ"),0,0]};$.each(Data(element).transformCache,function(transformName){/^translate/i.test(transformName)?transformName="translate":/^scale/i.test(transformName)?transformName="scale":/^rotate/i.test(transformName)&&(transformName="rotate"),SVGTransforms[transformName]&&(transformString+=transformName+"("+SVGTransforms[transformName].join(" ")+") ",delete SVGTransforms[transformName])})}else{var transformValue,perspective;$.each(Data(element).transformCache,function(transformName){return transformValue=Data(element).transformCache[transformName],"transformPerspective"===transformName?(perspective=transformValue,!0):(9===IE&&"rotateZ"===transformName&&(transformName="rotate"),void(transformString+=transformName+transformValue+" "))}),perspective&&(transformString="perspective"+perspective+" "+transformString)}CSS.setPropertyValue(element,"transform",transformString)}};CSS.Hooks.register(),CSS.Normalizations.register(),Velocity.hook=function(elements,arg2,arg3){var value=undefined;return elements=sanitizeElements(elements),$.each(elements,function(i,element){if(Data(element)===undefined&&Velocity.init(element),arg3===undefined)value===undefined&&(value=Velocity.CSS.getPropertyValue(element,arg2));else{var adjustedSet=Velocity.CSS.setPropertyValue(element,arg2,arg3);"transform"===adjustedSet[0]&&Velocity.CSS.flushTransformCache(element),value=adjustedSet}}),value};var animate=function(){function getChain(){return isUtility?promiseData.promise||null:elementsWrapped}function processElement(){function buildQueue(next){function parsePropertyValue(valueData,skipResolvingEasing){var endValue=undefined,easing=undefined,startValue=undefined;return Type.isArray(valueData)?(endValue=valueData[0],!Type.isArray(valueData[1])&&/^[\d-]/.test(valueData[1])||Type.isFunction(valueData[1])||CSS.RegEx.isHex.test(valueData[1])?startValue=valueData[1]:(Type.isString(valueData[1])&&!CSS.RegEx.isHex.test(valueData[1])||Type.isArray(valueData[1]))&&(easing=skipResolvingEasing?valueData[1]:getEasing(valueData[1],opts.duration),valueData[2]!==undefined&&(startValue=valueData[2]))):endValue=valueData,skipResolvingEasing||(easing=easing||opts.easing),Type.isFunction(endValue)&&(endValue=endValue.call(element,elementsIndex,elementsLength)),Type.isFunction(startValue)&&(startValue=startValue.call(element,elementsIndex,elementsLength)),[endValue||0,easing,startValue]}function separateValue(property,value){var unitType,numericValue;return numericValue=(value||"0").toString().toLowerCase().replace(/[%A-z]+$/,function(match){return unitType=match,""}),unitType||(unitType=CSS.Values.getUnitType(property)),[numericValue,unitType]}function calculateUnitRatios(){var sameRatioIndicators={myParent:element.parentNode||document.body,position:CSS.getPropertyValue(element,"position"),fontSize:CSS.getPropertyValue(element,"fontSize")},samePercentRatio=sameRatioIndicators.position===callUnitConversionData.lastPosition&&sameRatioIndicators.myParent===callUnitConversionData.lastParent,sameEmRatio=sameRatioIndicators.fontSize===callUnitConversionData.lastFontSize;callUnitConversionData.lastParent=sameRatioIndicators.myParent,callUnitConversionData.lastPosition=sameRatioIndicators.position,callUnitConversionData.lastFontSize=sameRatioIndicators.fontSize;var measurement=100,unitRatios={};if(sameEmRatio&&samePercentRatio)unitRatios.emToPx=callUnitConversionData.lastEmToPx,unitRatios.percentToPxWidth=callUnitConversionData.lastPercentToPxWidth,unitRatios.percentToPxHeight=callUnitConversionData.lastPercentToPxHeight;else{var dummy=Data(element).isSVG?document.createElementNS("http://www.w3.org/2000/svg","rect"):document.createElement("div");Velocity.init(dummy),sameRatioIndicators.myParent.appendChild(dummy),$.each(["overflow","overflowX","overflowY"],function(i,property){Velocity.CSS.setPropertyValue(dummy,property,"hidden")}),Velocity.CSS.setPropertyValue(dummy,"position",sameRatioIndicators.position),Velocity.CSS.setPropertyValue(dummy,"fontSize",sameRatioIndicators.fontSize),Velocity.CSS.setPropertyValue(dummy,"boxSizing","content-box"),$.each(["minWidth","maxWidth","width","minHeight","maxHeight","height"],function(i,property){Velocity.CSS.setPropertyValue(dummy,property,measurement+"%")}),Velocity.CSS.setPropertyValue(dummy,"paddingLeft",measurement+"em"),unitRatios.percentToPxWidth=callUnitConversionData.lastPercentToPxWidth=(parseFloat(CSS.getPropertyValue(dummy,"width",null,!0))||1)/measurement,unitRatios.percentToPxHeight=callUnitConversionData.lastPercentToPxHeight=(parseFloat(CSS.getPropertyValue(dummy,"height",null,!0))||1)/measurement,unitRatios.emToPx=callUnitConversionData.lastEmToPx=(parseFloat(CSS.getPropertyValue(dummy,"paddingLeft"))||1)/measurement,sameRatioIndicators.myParent.removeChild(dummy)}return null===callUnitConversionData.remToPx&&(callUnitConversionData.remToPx=parseFloat(CSS.getPropertyValue(document.body,"fontSize"))||16),null===callUnitConversionData.vwToPx&&(callUnitConversionData.vwToPx=parseFloat(window.innerWidth)/100,callUnitConversionData.vhToPx=parseFloat(window.innerHeight)/100),unitRatios.remToPx=callUnitConversionData.remToPx,unitRatios.vwToPx=callUnitConversionData.vwToPx,unitRatios.vhToPx=callUnitConversionData.vhToPx,Velocity.debug>=1&&console.log("Unit ratios: "+JSON.stringify(unitRatios),element),unitRatios}if(opts.begin&&0===elementsIndex)try{opts.begin.call(elements,elements)}catch(error){setTimeout(function(){throw error},1)}if("scroll"===action){var scrollPositionCurrent,scrollPositionCurrentAlternate,scrollPositionEnd,scrollDirection=/^x$/i.test(opts.axis)?"Left":"Top",scrollOffset=parseFloat(opts.offset)||0;opts.container?Type.isWrapped(opts.container)||Type.isNode(opts.container)?(opts.container=opts.container[0]||opts.container,scrollPositionCurrent=opts.container["scroll"+scrollDirection],scrollPositionEnd=scrollPositionCurrent+$(element).position()[scrollDirection.toLowerCase()]+scrollOffset):opts.container=null:(scrollPositionCurrent=Velocity.State.scrollAnchor[Velocity.State["scrollProperty"+scrollDirection]],scrollPositionCurrentAlternate=Velocity.State.scrollAnchor[Velocity.State["scrollProperty"+("Left"===scrollDirection?"Top":"Left")]],scrollPositionEnd=$(element).offset()[scrollDirection.toLowerCase()]+scrollOffset),tweensContainer={scroll:{rootPropertyValue:!1,startValue:scrollPositionCurrent,currentValue:scrollPositionCurrent,endValue:scrollPositionEnd,unitType:"",easing:opts.easing,scrollData:{container:opts.container,direction:scrollDirection,alternateValue:scrollPositionCurrentAlternate}},element:element},Velocity.debug&&console.log("tweensContainer (scroll): ",tweensContainer.scroll,element)}else if("reverse"===action){if(!Data(element).tweensContainer)return void $.dequeue(element,opts.queue);"none"===Data(element).opts.display&&(Data(element).opts.display="auto"),"hidden"===Data(element).opts.visibility&&(Data(element).opts.visibility="visible"),Data(element).opts.loop=!1,Data(element).opts.begin=null,Data(element).opts.complete=null,options.easing||delete opts.easing,options.duration||delete opts.duration,opts=$.extend({},Data(element).opts,opts);var lastTweensContainer=$.extend(!0,{},Data(element).tweensContainer);for(var lastTween in lastTweensContainer)if("element"!==lastTween){var lastStartValue=lastTweensContainer[lastTween].startValue;lastTweensContainer[lastTween].startValue=lastTweensContainer[lastTween].currentValue=lastTweensContainer[lastTween].endValue,lastTweensContainer[lastTween].endValue=lastStartValue,Type.isEmptyObject(options)||(lastTweensContainer[lastTween].easing=opts.easing),Velocity.debug&&console.log("reverse tweensContainer ("+lastTween+"): "+JSON.stringify(lastTweensContainer[lastTween]),element)}tweensContainer=lastTweensContainer}else if("start"===action){var lastTweensContainer;Data(element).tweensContainer&&Data(element).isAnimating===!0&&(lastTweensContainer=Data(element).tweensContainer),$.each(propertiesMap,function(property,value){if(RegExp("^"+CSS.Lists.colors.join("$|^")+"$").test(property)){var valueData=parsePropertyValue(value,!0),endValue=valueData[0],easing=valueData[1],startValue=valueData[2];if(CSS.RegEx.isHex.test(endValue)){for(var colorComponents=["Red","Green","Blue"],endValueRGB=CSS.Values.hexToRgb(endValue),startValueRGB=startValue?CSS.Values.hexToRgb(startValue):undefined,i=0;i<colorComponents.length;i++){var dataArray=[endValueRGB[i]];easing&&dataArray.push(easing),startValueRGB!==undefined&&dataArray.push(startValueRGB[i]),propertiesMap[property+colorComponents[i]]=dataArray}delete propertiesMap[property]}}});for(var property in propertiesMap){var valueData=parsePropertyValue(propertiesMap[property]),endValue=valueData[0],easing=valueData[1],startValue=valueData[2];property=CSS.Names.camelCase(property);var rootProperty=CSS.Hooks.getRoot(property),rootPropertyValue=!1;if(Data(element).isSVG||CSS.Names.prefixCheck(rootProperty)[1]!==!1||CSS.Normalizations.registered[rootProperty]!==undefined){(opts.display!==undefined&&null!==opts.display&&"none"!==opts.display||opts.visibility!==undefined&&"hidden"!==opts.visibility)&&/opacity|filter/.test(property)&&!startValue&&0!==endValue&&(startValue=0),opts._cacheValues&&lastTweensContainer&&lastTweensContainer[property]?(startValue===undefined&&(startValue=lastTweensContainer[property].endValue+lastTweensContainer[property].unitType),rootPropertyValue=Data(element).rootPropertyValueCache[rootProperty]):CSS.Hooks.registered[property]?startValue===undefined?(rootPropertyValue=CSS.getPropertyValue(element,rootProperty),startValue=CSS.getPropertyValue(element,property,rootPropertyValue)):rootPropertyValue=CSS.Hooks.templates[rootProperty][1]:startValue===undefined&&(startValue=CSS.getPropertyValue(element,property));var separatedValue,endValueUnitType,startValueUnitType,operator=!1;if(separatedValue=separateValue(property,startValue),startValue=separatedValue[0],startValueUnitType=separatedValue[1],separatedValue=separateValue(property,endValue),endValue=separatedValue[0].replace(/^([+-\/*])=/,function(match,subMatch){return operator=subMatch,""}),endValueUnitType=separatedValue[1],startValue=parseFloat(startValue)||0,endValue=parseFloat(endValue)||0,"%"===endValueUnitType&&(/^(fontSize|lineHeight)$/.test(property)?(endValue/=100,endValueUnitType="em"):/^scale/.test(property)?(endValue/=100,endValueUnitType=""):/(Red|Green|Blue)$/i.test(property)&&(endValue=endValue/100*255,endValueUnitType="")),/[\/*]/.test(operator))endValueUnitType=startValueUnitType;else if(startValueUnitType!==endValueUnitType&&0!==startValue)if(0===endValue)endValueUnitType=startValueUnitType;else{elementUnitConversionData=elementUnitConversionData||calculateUnitRatios();var axis=/margin|padding|left|right|width|text|word|letter/i.test(property)||/X$/.test(property)||"x"===property?"x":"y";switch(startValueUnitType){case"%":startValue*="x"===axis?elementUnitConversionData.percentToPxWidth:elementUnitConversionData.percentToPxHeight;break;case"px":break;default:startValue*=elementUnitConversionData[startValueUnitType+"ToPx"]}switch(endValueUnitType){case"%":startValue*=1/("x"===axis?elementUnitConversionData.percentToPxWidth:elementUnitConversionData.percentToPxHeight);break;case"px":break;default:startValue*=1/elementUnitConversionData[endValueUnitType+"ToPx"]}}switch(operator){case"+":endValue=startValue+endValue;break;case"-":endValue=startValue-endValue;break;case"*":endValue=startValue*endValue;break;case"/":endValue=startValue/endValue}tweensContainer[property]={rootPropertyValue:rootPropertyValue,startValue:startValue,currentValue:startValue,endValue:endValue,unitType:endValueUnitType,easing:easing},Velocity.debug&&console.log("tweensContainer ("+property+"): "+JSON.stringify(tweensContainer[property]),element)}else Velocity.debug&&console.log("Skipping ["+rootProperty+"] due to a lack of browser support.")}tweensContainer.element=element}tweensContainer.element&&(CSS.Values.addClass(element,"velocity-animating"),call.push(tweensContainer),""===opts.queue&&(Data(element).tweensContainer=tweensContainer,Data(element).opts=opts),Data(element).isAnimating=!0,elementsIndex===elementsLength-1?(Velocity.State.calls.length>1e4&&(Velocity.State.calls=compactSparseArray(Velocity.State.calls)),Velocity.State.calls.push([call,elements,opts,null,promiseData.resolver]),Velocity.State.isTicking===!1&&(Velocity.State.isTicking=!0,tick())):elementsIndex++)}var elementUnitConversionData,element=this,opts=$.extend({},Velocity.defaults,options),tweensContainer={};switch(Data(element)===undefined&&Velocity.init(element),parseFloat(opts.delay)&&opts.queue!==!1&&$.queue(element,opts.queue,function(next){Velocity.velocityQueueEntryFlag=!0,Data(element).delayTimer={setTimeout:setTimeout(next,parseFloat(opts.delay)),next:next}}),opts.duration.toString().toLowerCase()){case"fast":opts.duration=200;break;case"normal":opts.duration=DURATION_DEFAULT;break;case"slow":opts.duration=600;break;default:opts.duration=parseFloat(opts.duration)||1}Velocity.mock!==!1&&(Velocity.mock===!0?opts.duration=opts.delay=1:(opts.duration*=parseFloat(Velocity.mock)||1,opts.delay*=parseFloat(Velocity.mock)||1)),opts.easing=getEasing(opts.easing,opts.duration),opts.begin&&!Type.isFunction(opts.begin)&&(opts.begin=null),opts.progress&&!Type.isFunction(opts.progress)&&(opts.progress=null),opts.complete&&!Type.isFunction(opts.complete)&&(opts.complete=null),opts.display!==undefined&&null!==opts.display&&(opts.display=opts.display.toString().toLowerCase(),"auto"===opts.display&&(opts.display=Velocity.CSS.Values.getDisplayType(element))),opts.visibility!==undefined&&null!==opts.visibility&&(opts.visibility=opts.visibility.toString().toLowerCase()),opts.mobileHA=opts.mobileHA&&Velocity.State.isMobile&&!Velocity.State.isGingerbread,opts.queue===!1?opts.delay?setTimeout(buildQueue,opts.delay):buildQueue():$.queue(element,opts.queue,function(next,clearQueue){return clearQueue===!0?(promiseData.promise&&promiseData.resolver(elements),!0):(Velocity.velocityQueueEntryFlag=!0,void buildQueue(next))}),""!==opts.queue&&"fx"!==opts.queue||"inprogress"===$.queue(element)[0]||$.dequeue(element)}var isUtility,elementsWrapped,argumentIndex,elements,propertiesMap,options,syntacticSugar=arguments[0]&&($.isPlainObject(arguments[0].properties)&&!arguments[0].properties.names||Type.isString(arguments[0].properties));if(Type.isWrapped(this)?(isUtility=!1,argumentIndex=0,elements=this,elementsWrapped=this):(isUtility=!0,argumentIndex=1,elements=syntacticSugar?arguments[0].elements:arguments[0]),elements=sanitizeElements(elements)){syntacticSugar?(propertiesMap=arguments[0].properties,options=arguments[0].options):(propertiesMap=arguments[argumentIndex],options=arguments[argumentIndex+1]);var elementsLength=elements.length,elementsIndex=0;if("stop"!==propertiesMap&&!$.isPlainObject(options)){var startingArgumentPosition=argumentIndex+1;options={};for(var i=startingArgumentPosition;i<arguments.length;i++)Type.isArray(arguments[i])||!/^(fast|normal|slow)$/i.test(arguments[i])&&!/^\d/.test(arguments[i])?Type.isString(arguments[i])||Type.isArray(arguments[i])?options.easing=arguments[i]:Type.isFunction(arguments[i])&&(options.complete=arguments[i]):options.duration=arguments[i]}var promiseData={promise:null,resolver:null,rejecter:null};isUtility&&Velocity.Promise&&(promiseData.promise=new Velocity.Promise(function(resolve,reject){promiseData.resolver=resolve,promiseData.rejecter=reject}));var action;switch(propertiesMap){case"scroll":action="scroll";break;case"reverse":action="reverse";break;case"stop":$.each(elements,function(i,element){Data(element)&&Data(element).delayTimer&&(clearTimeout(Data(element).delayTimer.setTimeout),Data(element).delayTimer.next&&Data(element).delayTimer.next(),delete Data(element).delayTimer)});var callsToStop=[];return $.each(Velocity.State.calls,function(i,activeCall){activeCall&&$.each(activeCall[1],function(k,activeElement){var queueName=Type.isString(options)?options:"";return options!==undefined&&activeCall[2].queue!==queueName||void $.each(elements,function(l,element){element===activeElement&&(options!==undefined&&($.each($.queue(element,queueName),function(_,item){Type.isFunction(item)&&item(null,!0)}),$.queue(element,queueName,[])),Data(element)&&""===queueName&&$.each(Data(element).tweensContainer,function(m,activeTween){activeTween.endValue=activeTween.currentValue}),callsToStop.push(i))})})}),$.each(callsToStop,function(i,j){completeCall(j,!0)}),promiseData.promise&&promiseData.resolver(elements),getChain();default:if(!$.isPlainObject(propertiesMap)||Type.isEmptyObject(propertiesMap)){if(Type.isString(propertiesMap)&&Velocity.Redirects[propertiesMap]){var opts=$.extend({},options),durationOriginal=opts.duration,delayOriginal=opts.delay||0;return opts.backwards===!0&&(elements=$.extend(!0,[],elements).reverse()),$.each(elements,function(elementIndex,element){parseFloat(opts.stagger)?opts.delay=delayOriginal+parseFloat(opts.stagger)*elementIndex:Type.isFunction(opts.stagger)&&(opts.delay=delayOriginal+opts.stagger.call(element,elementIndex,elementsLength)),opts.drag&&(opts.duration=parseFloat(durationOriginal)||(/^(callout|transition)/.test(propertiesMap)?1e3:DURATION_DEFAULT),
opts.duration=Math.max(opts.duration*(opts.backwards?1-elementIndex/elementsLength:(elementIndex+1)/elementsLength),.75*opts.duration,200)),Velocity.Redirects[propertiesMap].call(element,element,opts||{},elementIndex,elementsLength,elements,promiseData.promise?promiseData:undefined)}),getChain()}var abortError="Velocity: First argument ("+propertiesMap+") was not a property map, a known action, or a registered redirect. Aborting.";return promiseData.promise?promiseData.rejecter(new Error(abortError)):console.log(abortError),getChain()}action="start"}var callUnitConversionData={lastParent:null,lastPosition:null,lastFontSize:null,lastPercentToPxWidth:null,lastPercentToPxHeight:null,lastEmToPx:null,remToPx:null,vwToPx:null,vhToPx:null},call=[];$.each(elements,function(i,element){Type.isNode(element)&&processElement.call(element)});var reverseCallsCount,opts=$.extend({},Velocity.defaults,options);if(opts.loop=parseInt(opts.loop),reverseCallsCount=2*opts.loop-1,opts.loop)for(var x=0;x<reverseCallsCount;x++){var reverseOptions={delay:opts.delay,progress:opts.progress};x===reverseCallsCount-1&&(reverseOptions.display=opts.display,reverseOptions.visibility=opts.visibility,reverseOptions.complete=opts.complete),animate(elements,"reverse",reverseOptions)}return getChain()}};Velocity=$.extend(animate,Velocity),Velocity.animate=animate;var ticker=window.requestAnimationFrame||rAFShim;return Velocity.State.isMobile||document.hidden===undefined||document.addEventListener("visibilitychange",function(){document.hidden?(ticker=function(callback){return setTimeout(function(){callback(!0)},16)},tick()):ticker=window.requestAnimationFrame||rAFShim}),global.Velocity=Velocity,global!==window&&(global.fn.velocity=animate,global.fn.velocity.defaults=Velocity.defaults),$.each(["Down","Up"],function(i,direction){Velocity.Redirects["slide"+direction]=function(element,options,elementsIndex,elementsSize,elements,promiseData){var opts=$.extend({},options),begin=opts.begin,complete=opts.complete,computedValues={height:"",marginTop:"",marginBottom:"",paddingTop:"",paddingBottom:""},inlineValues={};opts.display===undefined&&(opts.display="Down"===direction?"inline"===Velocity.CSS.Values.getDisplayType(element)?"inline-block":"block":"none"),opts.begin=function(){begin&&begin.call(elements,elements);for(var property in computedValues){inlineValues[property]=element.style[property];var propertyValue=Velocity.CSS.getPropertyValue(element,property);computedValues[property]="Down"===direction?[propertyValue,0]:[0,propertyValue]}inlineValues.overflow=element.style.overflow,element.style.overflow="hidden"},opts.complete=function(){for(var property in inlineValues)element.style[property]=inlineValues[property];complete&&complete.call(elements,elements),promiseData&&promiseData.resolver(elements)},Velocity(element,computedValues,opts)}}),$.each(["In","Out"],function(i,direction){Velocity.Redirects["fade"+direction]=function(element,options,elementsIndex,elementsSize,elements,promiseData){var opts=$.extend({},options),propertiesMap={opacity:"In"===direction?1:0},originalComplete=opts.complete;elementsIndex!==elementsSize-1?opts.complete=opts.begin=null:opts.complete=function(){originalComplete&&originalComplete.call(elements,elements),promiseData&&promiseData.resolver(elements)},opts.display===undefined&&(opts.display="In"===direction?"auto":"none"),Velocity(this,propertiesMap,opts)}}),Velocity}(window.jQuery||window.Zepto||window,window,document)});var CryptoJS=CryptoJS||function(g,l){var e={},d=e.lib={},m=function(){},k=d.Base={extend:function(a){m.prototype=this;var c=new m;return a&&c.mixIn(a),c.hasOwnProperty("init")||(c.init=function(){c.$super.init.apply(this,arguments)}),c.init.prototype=c,c.$super=this,c},create:function(){var a=this.extend();return a.init.apply(a,arguments),a},init:function(){},mixIn:function(a){for(var c in a)a.hasOwnProperty(c)&&(this[c]=a[c]);a.hasOwnProperty("toString")&&(this.toString=a.toString)},clone:function(){return this.init.prototype.extend(this)}},p=d.WordArray=k.extend({init:function(a,c){a=this.words=a||[],this.sigBytes=c!=l?c:4*a.length},toString:function(a){return(a||n).stringify(this)},concat:function(a){var c=this.words,q=a.words,f=this.sigBytes;if(a=a.sigBytes,this.clamp(),f%4)for(var b=0;b<a;b++)c[f+b>>>2]|=(q[b>>>2]>>>24-8*(b%4)&255)<<24-8*((f+b)%4);else if(65535<q.length)for(b=0;b<a;b+=4)c[f+b>>>2]=q[b>>>2];else c.push.apply(c,q);return this.sigBytes+=a,this},clamp:function(){var a=this.words,c=this.sigBytes;a[c>>>2]&=4294967295<<32-8*(c%4),a.length=g.ceil(c/4)},clone:function(){var a=k.clone.call(this);return a.words=this.words.slice(0),a},random:function(a){for(var c=[],b=0;b<a;b+=4)c.push(4294967296*g.random()|0);return new p.init(c,a)}}),b=e.enc={},n=b.Hex={stringify:function(a){var c=a.words;a=a.sigBytes;for(var b=[],f=0;f<a;f++){var d=c[f>>>2]>>>24-8*(f%4)&255;b.push((d>>>4).toString(16)),b.push((15&d).toString(16))}return b.join("")},parse:function(a){for(var c=a.length,b=[],f=0;f<c;f+=2)b[f>>>3]|=parseInt(a.substr(f,2),16)<<24-4*(f%8);return new p.init(b,c/2)}},j=b.Latin1={stringify:function(a){var c=a.words;a=a.sigBytes;for(var b=[],f=0;f<a;f++)b.push(String.fromCharCode(c[f>>>2]>>>24-8*(f%4)&255));return b.join("")},parse:function(a){for(var c=a.length,b=[],f=0;f<c;f++)b[f>>>2]|=(255&a.charCodeAt(f))<<24-8*(f%4);return new p.init(b,c)}},h=b.Utf8={stringify:function(a){try{return decodeURIComponent(escape(j.stringify(a)))}catch(c){throw Error("Malformed UTF-8 data")}},parse:function(a){return j.parse(unescape(encodeURIComponent(a)))}},r=d.BufferedBlockAlgorithm=k.extend({reset:function(){this._data=new p.init,this._nDataBytes=0},_append:function(a){"string"==typeof a&&(a=h.parse(a)),this._data.concat(a),this._nDataBytes+=a.sigBytes},_process:function(a){var c=this._data,b=c.words,f=c.sigBytes,d=this.blockSize,e=f/(4*d),e=a?g.ceil(e):g.max((0|e)-this._minBufferSize,0);if(a=e*d,f=g.min(4*a,f),a){for(var k=0;k<a;k+=d)this._doProcessBlock(b,k);k=b.splice(0,a),c.sigBytes-=f}return new p.init(k,f)},clone:function(){var a=k.clone.call(this);return a._data=this._data.clone(),a},_minBufferSize:0});d.Hasher=r.extend({cfg:k.extend(),init:function(a){this.cfg=this.cfg.extend(a),this.reset()},reset:function(){r.reset.call(this),this._doReset()},update:function(a){return this._append(a),this._process(),this},finalize:function(a){return a&&this._append(a),this._doFinalize()},blockSize:16,_createHelper:function(a){return function(b,d){return new a.init(d).finalize(b)}},_createHmacHelper:function(a){return function(b,d){return new s.HMAC.init(a,d).finalize(b)}}});var s=e.algo={};return e}(Math);!function(){var g=CryptoJS,l=g.lib,e=l.WordArray,d=l.Hasher,m=[],l=g.algo.SHA1=d.extend({_doReset:function(){this._hash=new e.init([1732584193,4023233417,2562383102,271733878,3285377520])},_doProcessBlock:function(d,e){for(var b=this._hash.words,n=b[0],j=b[1],h=b[2],g=b[3],l=b[4],a=0;80>a;a++){if(16>a)m[a]=0|d[e+a];else{var c=m[a-3]^m[a-8]^m[a-14]^m[a-16];m[a]=c<<1|c>>>31}c=(n<<5|n>>>27)+l+m[a],c=20>a?c+((j&h|~j&g)+1518500249):40>a?c+((j^h^g)+1859775393):60>a?c+((j&h|j&g|h&g)-1894007588):c+((j^h^g)-899497514),l=g,g=h,h=j<<30|j>>>2,j=n,n=c}b[0]=b[0]+n|0,b[1]=b[1]+j|0,b[2]=b[2]+h|0,b[3]=b[3]+g|0,b[4]=b[4]+l|0},_doFinalize:function(){var d=this._data,e=d.words,b=8*this._nDataBytes,g=8*d.sigBytes;return e[g>>>5]|=128<<24-g%32,e[(g+64>>>9<<4)+14]=Math.floor(b/4294967296),e[(g+64>>>9<<4)+15]=b,d.sigBytes=4*e.length,this._process(),this._hash},clone:function(){var e=d.clone.call(this);return e._hash=this._hash.clone(),e}});g.SHA1=d._createHelper(l),g.HmacSHA1=d._createHmacHelper(l)}(),function(){var g=CryptoJS,l=g.enc.Utf8;g.algo.HMAC=g.lib.Base.extend({init:function(e,d){e=this._hasher=new e.init,"string"==typeof d&&(d=l.parse(d));var g=e.blockSize,k=4*g;d.sigBytes>k&&(d=e.finalize(d)),d.clamp();for(var p=this._oKey=d.clone(),b=this._iKey=d.clone(),n=p.words,j=b.words,h=0;h<g;h++)n[h]^=1549556828,j[h]^=909522486;p.sigBytes=b.sigBytes=k,this.reset()},reset:function(){var e=this._hasher;e.reset(),e.update(this._iKey)},update:function(e){return this._hasher.update(e),this},finalize:function(e){var d=this._hasher;return e=d.finalize(e),d.reset(),d.finalize(this._oKey.clone().concat(e))}})}(),function(){var C=CryptoJS,C_lib=C.lib,WordArray=C_lib.WordArray,C_enc=C.enc;C_enc.Base64={stringify:function(wordArray){var words=wordArray.words,sigBytes=wordArray.sigBytes,map=this._map;wordArray.clamp();for(var base64Chars=[],i=0;i<sigBytes;i+=3)for(var byte1=words[i>>>2]>>>24-i%4*8&255,byte2=words[i+1>>>2]>>>24-(i+1)%4*8&255,byte3=words[i+2>>>2]>>>24-(i+2)%4*8&255,triplet=byte1<<16|byte2<<8|byte3,j=0;j<4&&i+.75*j<sigBytes;j++)base64Chars.push(map.charAt(triplet>>>6*(3-j)&63));var paddingChar=map.charAt(64);if(paddingChar)for(;base64Chars.length%4;)base64Chars.push(paddingChar);return base64Chars.join("")},parse:function(base64Str){var base64StrLength=base64Str.length,map=this._map,paddingChar=map.charAt(64);if(paddingChar){var paddingIndex=base64Str.indexOf(paddingChar);paddingIndex!=-1&&(base64StrLength=paddingIndex)}for(var words=[],nBytes=0,i=0;i<base64StrLength;i++)if(i%4){var bits1=map.indexOf(base64Str.charAt(i-1))<<i%4*2,bits2=map.indexOf(base64Str.charAt(i))>>>6-i%4*2;words[nBytes>>>2]|=(bits1|bits2)<<24-nBytes%4*8,nBytes++}return WordArray.create(words,nBytes)},_map:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/="}}(),window.CodeMirror=function(){"use strict";function CodeMirror(place,options){if(!(this instanceof CodeMirror))return new CodeMirror(place,options);this.options=options=options||{};for(var opt in defaults)!options.hasOwnProperty(opt)&&defaults.hasOwnProperty(opt)&&(options[opt]=defaults[opt]);setGuttersForLineNumbers(options);var docStart="string"==typeof options.value?0:options.value.first,display=this.display=makeDisplay(place,docStart);display.wrapper.CodeMirror=this,updateGutters(this),options.autofocus&&!mobile&&focusInput(this),this.state={keyMaps:[],overlays:[],modeGen:0,overwrite:!1,focused:!1,suppressEdits:!1,pasteIncoming:!1,draggingText:!1,highlight:new Delayed},themeChanged(this),options.lineWrapping&&(this.display.wrapper.className+=" CodeMirror-wrap");var doc=options.value;"string"==typeof doc&&(doc=new Doc(options.value,options.mode)),operation(this,attachDoc)(this,doc),ie&&setTimeout(bind(resetInput,this,!0),20),registerEventHandlers(this);var hasFocus;try{hasFocus=document.activeElement==display.input}catch(e){}hasFocus||options.autofocus&&!mobile?setTimeout(bind(onFocus,this),20):onBlur(this),operation(this,function(){for(var opt in optionHandlers)optionHandlers.propertyIsEnumerable(opt)&&optionHandlers[opt](this,options[opt],Init);for(var i=0;i<initHooks.length;++i)initHooks[i](this)})()}function makeDisplay(place,docStart){var d={},input=d.input=elt("textarea",null,null,"position: absolute; padding: 0; width: 1px; height: 1em; outline: none; font-size: 4px;");return webkit?input.style.width="1000px":input.setAttribute("wrap","off"),ios&&(input.style.border="1px solid black"),input.setAttribute("autocorrect","off"),input.setAttribute("autocapitalize","off"),input.setAttribute("spellcheck","false"),d.inputDiv=elt("div",[input],null,"overflow: hidden; position: relative; width: 3px; height: 0px;"),d.scrollbarH=elt("div",[elt("div",null,null,"height: 1px")],"CodeMirror-hscrollbar"),d.scrollbarV=elt("div",[elt("div",null,null,"width: 1px")],"CodeMirror-vscrollbar"),d.scrollbarFiller=elt("div",null,"CodeMirror-scrollbar-filler"),d.gutterFiller=elt("div",null,"CodeMirror-gutter-filler"),d.lineDiv=elt("div",null,"CodeMirror-code"),d.selectionDiv=elt("div",null,null,"position: relative; z-index: 1"),d.cursor=elt("div"," ","CodeMirror-cursor"),d.otherCursor=elt("div"," ","CodeMirror-cursor CodeMirror-secondarycursor"),d.measure=elt("div",null,"CodeMirror-measure"),d.lineSpace=elt("div",[d.measure,d.selectionDiv,d.lineDiv,d.cursor,d.otherCursor],null,"position: relative; outline: none"),d.mover=elt("div",[elt("div",[d.lineSpace],"CodeMirror-lines")],null,"position: relative"),d.sizer=elt("div",[d.mover],"CodeMirror-sizer"),d.heightForcer=elt("div",null,null,"position: absolute; height: "+scrollerCutOff+"px; width: 1px;"),d.gutters=elt("div",null,"CodeMirror-gutters"),d.lineGutter=null,d.scroller=elt("div",[d.sizer,d.heightForcer,d.gutters],"CodeMirror-scroll"),d.scroller.setAttribute("tabIndex","-1"),d.wrapper=elt("div",[d.inputDiv,d.scrollbarH,d.scrollbarV,d.scrollbarFiller,d.gutterFiller,d.scroller],"CodeMirror"),ie_lt8&&(d.gutters.style.zIndex=-1,d.scroller.style.paddingRight=0),place.appendChild?place.appendChild(d.wrapper):place(d.wrapper),ios&&(input.style.width="0px"),webkit||(d.scroller.draggable=!0),khtml?(d.inputDiv.style.height="1px",d.inputDiv.style.position="absolute"):ie_lt8&&(d.scrollbarH.style.minWidth=d.scrollbarV.style.minWidth="18px"),d.viewOffset=d.lastSizeC=0,d.showingFrom=d.showingTo=docStart,d.lineNumWidth=d.lineNumInnerWidth=d.lineNumChars=null,d.prevInput="",d.alignWidgets=!1,d.pollingFast=!1,d.poll=new Delayed,d.cachedCharWidth=d.cachedTextHeight=null,d.measureLineCache=[],d.measureLineCachePos=0,d.inaccurateSelection=!1,d.maxLine=null,d.maxLineLength=0,d.maxLineChanged=!1,d.wheelDX=d.wheelDY=d.wheelStartX=d.wheelStartY=null,d}function loadMode(cm){cm.doc.mode=CodeMirror.getMode(cm.options,cm.doc.modeOption),cm.doc.iter(function(line){line.stateAfter&&(line.stateAfter=null),line.styles&&(line.styles=null)}),cm.doc.frontier=cm.doc.first,startWorker(cm,100),cm.state.modeGen++,cm.curOp&&regChange(cm)}function wrappingChanged(cm){cm.options.lineWrapping?(cm.display.wrapper.className+=" CodeMirror-wrap",cm.display.sizer.style.minWidth=""):(cm.display.wrapper.className=cm.display.wrapper.className.replace(" CodeMirror-wrap",""),computeMaxLength(cm)),estimateLineHeights(cm),regChange(cm),clearCaches(cm),setTimeout(function(){updateScrollbars(cm)},100)}function estimateHeight(cm){var th=textHeight(cm.display),wrapping=cm.options.lineWrapping,perLine=wrapping&&Math.max(5,cm.display.scroller.clientWidth/charWidth(cm.display)-3);return function(line){return lineIsHidden(cm.doc,line)?0:wrapping?(Math.ceil(line.text.length/perLine)||1)*th:th}}function estimateLineHeights(cm){var doc=cm.doc,est=estimateHeight(cm);doc.iter(function(line){var estHeight=est(line);estHeight!=line.height&&updateLineHeight(line,estHeight)})}function keyMapChanged(cm){var map=keyMap[cm.options.keyMap],style=map.style;cm.display.wrapper.className=cm.display.wrapper.className.replace(/\s*cm-keymap-\S+/g,"")+(style?" cm-keymap-"+style:""),cm.state.disableInput=map.disableInput}function themeChanged(cm){cm.display.wrapper.className=cm.display.wrapper.className.replace(/\s*cm-s-\S+/g,"")+cm.options.theme.replace(/(^|\s)\s*/g," cm-s-"),clearCaches(cm)}function guttersChanged(cm){updateGutters(cm),regChange(cm),setTimeout(function(){alignHorizontally(cm)},20)}function updateGutters(cm){var gutters=cm.display.gutters,specs=cm.options.gutters;removeChildren(gutters);for(var i=0;i<specs.length;++i){var gutterClass=specs[i],gElt=gutters.appendChild(elt("div",null,"CodeMirror-gutter "+gutterClass));"CodeMirror-linenumbers"==gutterClass&&(cm.display.lineGutter=gElt,gElt.style.width=(cm.display.lineNumWidth||1)+"px")}gutters.style.display=i?"":"none"}function lineLength(doc,line){if(0==line.height)return 0;for(var merged,len=line.text.length,cur=line;merged=collapsedSpanAtStart(cur);){var found=merged.find();cur=getLine(doc,found.from.line),len+=found.from.ch-found.to.ch}for(cur=line;merged=collapsedSpanAtEnd(cur);){var found=merged.find();len-=cur.text.length-found.from.ch,cur=getLine(doc,found.to.line),len+=cur.text.length-found.to.ch}return len}function computeMaxLength(cm){var d=cm.display,doc=cm.doc;d.maxLine=getLine(doc,doc.first),d.maxLineLength=lineLength(doc,d.maxLine),d.maxLineChanged=!0,doc.iter(function(line){var len=lineLength(doc,line);len>d.maxLineLength&&(d.maxLineLength=len,d.maxLine=line)})}function setGuttersForLineNumbers(options){for(var found=!1,i=0;i<options.gutters.length;++i)"CodeMirror-linenumbers"==options.gutters[i]&&(options.lineNumbers?found=!0:options.gutters.splice(i--,1));!found&&options.lineNumbers&&options.gutters.push("CodeMirror-linenumbers")}function updateScrollbars(cm){var d=cm.display,docHeight=cm.doc.height,totalHeight=docHeight+paddingVert(d);d.sizer.style.minHeight=d.heightForcer.style.top=totalHeight+"px",d.gutters.style.height=Math.max(totalHeight,d.scroller.clientHeight-scrollerCutOff)+"px";var scrollHeight=Math.max(totalHeight,d.scroller.scrollHeight),needsH=d.scroller.scrollWidth>d.scroller.clientWidth+1,needsV=scrollHeight>d.scroller.clientHeight+1;needsV?(d.scrollbarV.style.display="block",d.scrollbarV.style.bottom=needsH?scrollbarWidth(d.measure)+"px":"0",d.scrollbarV.firstChild.style.height=scrollHeight-d.scroller.clientHeight+d.scrollbarV.clientHeight+"px"):d.scrollbarV.style.display="",needsH?(d.scrollbarH.style.display="block",d.scrollbarH.style.right=needsV?scrollbarWidth(d.measure)+"px":"0",d.scrollbarH.firstChild.style.width=d.scroller.scrollWidth-d.scroller.clientWidth+d.scrollbarH.clientWidth+"px"):d.scrollbarH.style.display="",needsH&&needsV?(d.scrollbarFiller.style.display="block",d.scrollbarFiller.style.height=d.scrollbarFiller.style.width=scrollbarWidth(d.measure)+"px"):d.scrollbarFiller.style.display="",needsH&&cm.options.coverGutterNextToScrollbar&&cm.options.fixedGutter?(d.gutterFiller.style.display="block",d.gutterFiller.style.height=scrollbarWidth(d.measure)+"px",d.gutterFiller.style.width=d.gutters.offsetWidth+"px"):d.gutterFiller.style.display="",mac_geLion&&0===scrollbarWidth(d.measure)&&(d.scrollbarV.style.minWidth=d.scrollbarH.style.minHeight=mac_geMountainLion?"18px":"12px")}function visibleLines(display,doc,viewPort){var top=display.scroller.scrollTop,height=display.wrapper.clientHeight;"number"==typeof viewPort?top=viewPort:viewPort&&(top=viewPort.top,height=viewPort.bottom-viewPort.top),top=Math.floor(top-paddingTop(display));var bottom=Math.ceil(top+height);return{from:lineAtHeight(doc,top),to:lineAtHeight(doc,bottom)}}function alignHorizontally(cm){var display=cm.display;if(display.alignWidgets||display.gutters.firstChild&&cm.options.fixedGutter){for(var comp=compensateForHScroll(display)-display.scroller.scrollLeft+cm.doc.scrollLeft,gutterW=display.gutters.offsetWidth,l=comp+"px",n=display.lineDiv.firstChild;n;n=n.nextSibling)if(n.alignable)for(var i=0,a=n.alignable;i<a.length;++i)a[i].style.left=l;cm.options.fixedGutter&&(display.gutters.style.left=comp+gutterW+"px")}}function maybeUpdateLineNumberWidth(cm){if(!cm.options.lineNumbers)return!1;var doc=cm.doc,last=lineNumberFor(cm.options,doc.first+doc.size-1),display=cm.display;if(last.length!=display.lineNumChars){var test=display.measure.appendChild(elt("div",[elt("div",last)],"CodeMirror-linenumber CodeMirror-gutter-elt")),innerW=test.firstChild.offsetWidth,padding=test.offsetWidth-innerW;return display.lineGutter.style.width="",display.lineNumInnerWidth=Math.max(innerW,display.lineGutter.offsetWidth-padding),display.lineNumWidth=display.lineNumInnerWidth+padding,display.lineNumChars=display.lineNumInnerWidth?last.length:-1,display.lineGutter.style.width=display.lineNumWidth+"px",!0}return!1}function lineNumberFor(options,i){return String(options.lineNumberFormatter(i+options.firstLineNumber))}function compensateForHScroll(display){return getRect(display.scroller).left-getRect(display.sizer).left}function updateDisplay(cm,changes,viewPort,forced){for(var updated,oldFrom=cm.display.showingFrom,oldTo=cm.display.showingTo,visible=visibleLines(cm.display,cm.doc,viewPort);updateDisplayInner(cm,changes,visible,forced)&&(forced=!1,updated=!0,updateSelection(cm),updateScrollbars(cm),viewPort&&(viewPort=Math.min(cm.display.scroller.scrollHeight-cm.display.scroller.clientHeight,"number"==typeof viewPort?viewPort:viewPort.top)),visible=visibleLines(cm.display,cm.doc,viewPort),!(visible.from>=cm.display.showingFrom&&visible.to<=cm.display.showingTo));)changes=[];return updated&&(signalLater(cm,"update",cm),cm.display.showingFrom==oldFrom&&cm.display.showingTo==oldTo||signalLater(cm,"viewportChange",cm,cm.display.showingFrom,cm.display.showingTo)),updated}function updateDisplayInner(cm,changes,visible,forced){var display=cm.display,doc=cm.doc;if(!display.wrapper.clientWidth)return display.showingFrom=display.showingTo=doc.first,void(display.viewOffset=0);if(!(!forced&&0==changes.length&&visible.from>display.showingFrom&&visible.to<display.showingTo)){maybeUpdateLineNumberWidth(cm)&&(changes=[{from:doc.first,to:doc.first+doc.size}]);var gutterW=display.sizer.style.marginLeft=display.gutters.offsetWidth+"px";display.scrollbarH.style.left=cm.options.fixedGutter?gutterW:"0";var positionsChangedFrom=1/0;if(cm.options.lineNumbers)for(var i=0;i<changes.length;++i)if(changes[i].diff){positionsChangedFrom=changes[i].from;break}var end=doc.first+doc.size,from=Math.max(visible.from-cm.options.viewportMargin,doc.first),to=Math.min(end,visible.to+cm.options.viewportMargin);if(display.showingFrom<from&&from-display.showingFrom<20&&(from=Math.max(doc.first,display.showingFrom)),display.showingTo>to&&display.showingTo-to<20&&(to=Math.min(end,display.showingTo)),sawCollapsedSpans)for(from=lineNo(visualLine(doc,getLine(doc,from)));to<end&&lineIsHidden(doc,getLine(doc,to));)++to;var intact=[{from:Math.max(display.showingFrom,doc.first),to:Math.min(display.showingTo,end)}];if(intact=intact[0].from>=intact[0].to?[]:computeIntact(intact,changes),sawCollapsedSpans)for(var i=0;i<intact.length;++i)for(var merged,range=intact[i];merged=collapsedSpanAtEnd(getLine(doc,range.to-1));){var newTo=merged.find().from.line;if(!(newTo>range.from)){intact.splice(i--,1);break}range.to=newTo}for(var intactLines=0,i=0;i<intact.length;++i){var range=intact[i];range.from<from&&(range.from=from),range.to>to&&(range.to=to),range.from>=range.to?intact.splice(i--,1):intactLines+=range.to-range.from}if(!forced&&intactLines==to-from&&from==display.showingFrom&&to==display.showingTo)return void updateViewOffset(cm);intact.sort(function(a,b){return a.from-b.from});try{var focused=document.activeElement}catch(e){}intactLines<.7*(to-from)&&(display.lineDiv.style.display="none"),patchDisplay(cm,from,to,intact,positionsChangedFrom),display.lineDiv.style.display="",focused&&document.activeElement!=focused&&focused.offsetHeight&&focused.focus();var different=from!=display.showingFrom||to!=display.showingTo||display.lastSizeC!=display.wrapper.clientHeight;return different&&(display.lastSizeC=display.wrapper.clientHeight,startWorker(cm,400)),display.showingFrom=from,display.showingTo=to,updateHeightsInViewport(cm),updateViewOffset(cm),!0}}function updateHeightsInViewport(cm){for(var height,display=cm.display,prevBottom=display.lineDiv.offsetTop,node=display.lineDiv.firstChild;node;node=node.nextSibling)if(node.lineObj){if(ie_lt8){var bot=node.offsetTop+node.offsetHeight;height=bot-prevBottom,prevBottom=bot}else{var box=getRect(node);height=box.bottom-box.top}var diff=node.lineObj.height-height;if(height<2&&(height=textHeight(display)),diff>.001||diff<-.001){updateLineHeight(node.lineObj,height);var widgets=node.lineObj.widgets;if(widgets)for(var i=0;i<widgets.length;++i)widgets[i].height=widgets[i].node.offsetHeight}}}function updateViewOffset(cm){var off=cm.display.viewOffset=heightAtLine(cm,getLine(cm.doc,cm.display.showingFrom));cm.display.mover.style.top=off+"px"}function computeIntact(intact,changes){for(var i=0,l=changes.length||0;i<l;++i){for(var change=changes[i],intact2=[],diff=change.diff||0,j=0,l2=intact.length;j<l2;++j){var range=intact[j];change.to<=range.from&&change.diff?intact2.push({from:range.from+diff,to:range.to+diff}):change.to<=range.from||change.from>=range.to?intact2.push(range):(change.from>range.from&&intact2.push({from:range.from,to:change.from}),change.to<range.to&&intact2.push({from:change.to+diff,to:range.to+diff}))}intact=intact2}return intact}function getDimensions(cm){for(var d=cm.display,left={},width={},n=d.gutters.firstChild,i=0;n;n=n.nextSibling,++i)left[cm.options.gutters[i]]=n.offsetLeft,width[cm.options.gutters[i]]=n.offsetWidth;return{fixedPos:compensateForHScroll(d),gutterTotalWidth:d.gutters.offsetWidth,gutterLeft:left,gutterWidth:width,wrapperWidth:d.wrapper.clientWidth}}function patchDisplay(cm,from,to,intact,updateNumbersFrom){function rm(node){var next=node.nextSibling;return webkit&&mac&&cm.display.currentWheelTarget==node?(node.style.display="none",node.lineObj=null):node.parentNode.removeChild(node),next}var dims=getDimensions(cm),display=cm.display,lineNumbers=cm.options.lineNumbers;intact.length||webkit&&cm.display.currentWheelTarget||removeChildren(display.lineDiv);var container=display.lineDiv,cur=container.firstChild,nextIntact=intact.shift(),lineN=from;for(cm.doc.iter(from,to,function(line){if(nextIntact&&nextIntact.to==lineN&&(nextIntact=intact.shift()),lineIsHidden(cm.doc,line)){if(0!=line.height&&updateLineHeight(line,0),line.widgets&&cur.previousSibling)for(var i=0;i<line.widgets.length;++i){var w=line.widgets[i];if(w.showIfHidden){var prev=cur.previousSibling;if(/pre/i.test(prev.nodeName)){var wrap=elt("div",null,null,"position: relative");prev.parentNode.replaceChild(wrap,prev),wrap.appendChild(prev),prev=wrap}var wnode=prev.appendChild(elt("div",[w.node],"CodeMirror-linewidget"));w.handleMouseEvents||(wnode.ignoreEvents=!0),positionLineWidget(w,wnode,prev,dims)}}}else if(nextIntact&&nextIntact.from<=lineN&&nextIntact.to>lineN){for(;cur.lineObj!=line;)cur=rm(cur);lineNumbers&&updateNumbersFrom<=lineN&&cur.lineNumber&&setTextContent(cur.lineNumber,lineNumberFor(cm.options,lineN)),cur=cur.nextSibling}else{if(line.widgets)for(var reuse,j=0,search=cur;search&&j<20;++j,search=search.nextSibling)if(search.lineObj==line&&/div/i.test(search.nodeName)){reuse=search;break}var lineNode=buildLineElement(cm,line,lineN,dims,reuse);if(lineNode!=reuse)container.insertBefore(lineNode,cur);else{for(;cur!=reuse;)cur=rm(cur);cur=cur.nextSibling}lineNode.lineObj=line}++lineN});cur;)cur=rm(cur)}function buildLineElement(cm,line,lineNo,dims,reuse){var wrap,lineElement=lineContent(cm,line),markers=line.gutterMarkers,display=cm.display;if(!(cm.options.lineNumbers||markers||line.bgClass||line.wrapClass||line.widgets))return lineElement;if(reuse){reuse.alignable=null;for(var next,isOk=!0,widgetsSeen=0,insertBefore=null,n=reuse.firstChild;n;n=next)if(next=n.nextSibling,/\bCodeMirror-linewidget\b/.test(n.className)){for(var i=0;i<line.widgets.length;++i){var widget=line.widgets[i];if(widget.node==n.firstChild){widget.above||insertBefore||(insertBefore=n),positionLineWidget(widget,n,reuse,dims),++widgetsSeen;break}}if(i==line.widgets.length){isOk=!1;break}}else reuse.removeChild(n);reuse.insertBefore(lineElement,insertBefore),isOk&&widgetsSeen==line.widgets.length&&(wrap=reuse,reuse.className=line.wrapClass||"")}if(wrap||(wrap=elt("div",null,line.wrapClass,"position: relative"),wrap.appendChild(lineElement)),line.bgClass&&wrap.insertBefore(elt("div",null,line.bgClass+" CodeMirror-linebackground"),wrap.firstChild),cm.options.lineNumbers||markers){var gutterWrap=wrap.insertBefore(elt("div",null,null,"position: absolute; left: "+(cm.options.fixedGutter?dims.fixedPos:-dims.gutterTotalWidth)+"px"),wrap.firstChild);if(cm.options.fixedGutter&&(wrap.alignable||(wrap.alignable=[])).push(gutterWrap),!cm.options.lineNumbers||markers&&markers["CodeMirror-linenumbers"]||(wrap.lineNumber=gutterWrap.appendChild(elt("div",lineNumberFor(cm.options,lineNo),"CodeMirror-linenumber CodeMirror-gutter-elt","left: "+dims.gutterLeft["CodeMirror-linenumbers"]+"px; width: "+display.lineNumInnerWidth+"px"))),markers)for(var k=0;k<cm.options.gutters.length;++k){var id=cm.options.gutters[k],found=markers.hasOwnProperty(id)&&markers[id];found&&gutterWrap.appendChild(elt("div",[found],"CodeMirror-gutter-elt","left: "+dims.gutterLeft[id]+"px; width: "+dims.gutterWidth[id]+"px"))}}if(ie_lt8&&(wrap.style.zIndex=2),line.widgets&&wrap!=reuse)for(var i=0,ws=line.widgets;i<ws.length;++i){var widget=ws[i],node=elt("div",[widget.node],"CodeMirror-linewidget");widget.handleMouseEvents||(node.ignoreEvents=!0),positionLineWidget(widget,node,wrap,dims),widget.above?wrap.insertBefore(node,cm.options.lineNumbers&&0!=line.height?gutterWrap:lineElement):wrap.appendChild(node),signalLater(widget,"redraw")}return wrap}function positionLineWidget(widget,node,wrap,dims){if(widget.noHScroll){(wrap.alignable||(wrap.alignable=[])).push(node);var width=dims.wrapperWidth;node.style.left=dims.fixedPos+"px",widget.coverGutter||(width-=dims.gutterTotalWidth,node.style.paddingLeft=dims.gutterTotalWidth+"px"),node.style.width=width+"px"}widget.coverGutter&&(node.style.zIndex=5,node.style.position="relative",widget.noHScroll||(node.style.marginLeft=-dims.gutterTotalWidth+"px"))}function updateSelection(cm){var display=cm.display,collapsed=posEq(cm.doc.sel.from,cm.doc.sel.to);if(collapsed||cm.options.showCursorWhenSelecting?updateSelectionCursor(cm):display.cursor.style.display=display.otherCursor.style.display="none",collapsed?display.selectionDiv.style.display="none":updateSelectionRange(cm),cm.options.moveInputWithCursor){var headPos=cursorCoords(cm,cm.doc.sel.head,"div"),wrapOff=getRect(display.wrapper),lineOff=getRect(display.lineDiv);display.inputDiv.style.top=Math.max(0,Math.min(display.wrapper.clientHeight-10,headPos.top+lineOff.top-wrapOff.top))+"px",display.inputDiv.style.left=Math.max(0,Math.min(display.wrapper.clientWidth-10,headPos.left+lineOff.left-wrapOff.left))+"px"}}function updateSelectionCursor(cm){var display=cm.display,pos=cursorCoords(cm,cm.doc.sel.head,"div");display.cursor.style.left=pos.left+"px",display.cursor.style.top=pos.top+"px",display.cursor.style.height=Math.max(0,pos.bottom-pos.top)*cm.options.cursorHeight+"px",display.cursor.style.display="",pos.other?(display.otherCursor.style.display="",display.otherCursor.style.left=pos.other.left+"px",display.otherCursor.style.top=pos.other.top+"px",display.otherCursor.style.height=.85*(pos.other.bottom-pos.other.top)+"px"):display.otherCursor.style.display="none"}function updateSelectionRange(cm){function add(left,top,width,bottom){top<0&&(top=0),fragment.appendChild(elt("div",null,"CodeMirror-selected","position: absolute; left: "+left+"px; top: "+top+"px; width: "+(null==width?clientWidth-left:width)+"px; height: "+(bottom-top)+"px"))}function drawForLine(line,fromArg,toArg){function coords(ch,bias){return charCoords(cm,Pos(line,ch),"div",lineObj,bias)}var start,end,lineObj=getLine(doc,line),lineLen=lineObj.text.length;return iterateBidiSections(getOrder(lineObj),fromArg||0,null==toArg?lineLen:toArg,function(from,to,dir){var rightPos,left,right,leftPos=coords(from,"left");if(from==to)rightPos=leftPos,left=right=leftPos.left;else{if(rightPos=coords(to-1,"right"),"rtl"==dir){var tmp=leftPos;leftPos=rightPos,rightPos=tmp}left=leftPos.left,right=rightPos.right}null==fromArg&&0==from&&(left=pl),rightPos.top-leftPos.top>3&&(add(left,leftPos.top,null,leftPos.bottom),left=pl,leftPos.bottom<rightPos.top&&add(left,leftPos.bottom,null,rightPos.top)),null==toArg&&to==lineLen&&(right=clientWidth),(!start||leftPos.top<start.top||leftPos.top==start.top&&leftPos.left<start.left)&&(start=leftPos),(!end||rightPos.bottom>end.bottom||rightPos.bottom==end.bottom&&rightPos.right>end.right)&&(end=rightPos),left<pl+1&&(left=pl),add(left,rightPos.top,right-left,rightPos.bottom)}),{start:start,end:end}}var display=cm.display,doc=cm.doc,sel=cm.doc.sel,fragment=document.createDocumentFragment(),clientWidth=display.lineSpace.offsetWidth,pl=paddingLeft(cm.display);if(sel.from.line==sel.to.line)drawForLine(sel.from.line,sel.from.ch,sel.to.ch);else{var fromLine=getLine(doc,sel.from.line),toLine=getLine(doc,sel.to.line),singleVLine=visualLine(doc,fromLine)==visualLine(doc,toLine),leftEnd=drawForLine(sel.from.line,sel.from.ch,singleVLine?fromLine.text.length:null).end,rightStart=drawForLine(sel.to.line,singleVLine?0:null,sel.to.ch).start;singleVLine&&(leftEnd.top<rightStart.top-2?(add(leftEnd.right,leftEnd.top,null,leftEnd.bottom),
add(pl,rightStart.top,rightStart.left,rightStart.bottom)):add(leftEnd.right,leftEnd.top,rightStart.left-leftEnd.right,leftEnd.bottom)),leftEnd.bottom<rightStart.top&&add(pl,leftEnd.bottom,null,rightStart.top)}removeChildrenAndAdd(display.selectionDiv,fragment),display.selectionDiv.style.display=""}function restartBlink(cm){if(cm.state.focused){var display=cm.display;clearInterval(display.blinker);var on=!0;display.cursor.style.visibility=display.otherCursor.style.visibility="",display.blinker=setInterval(function(){display.cursor.style.visibility=display.otherCursor.style.visibility=(on=!on)?"":"hidden"},cm.options.cursorBlinkRate)}}function startWorker(cm,time){cm.doc.mode.startState&&cm.doc.frontier<cm.display.showingTo&&cm.state.highlight.set(time,bind(highlightWorker,cm))}function highlightWorker(cm){var doc=cm.doc;if(doc.frontier<doc.first&&(doc.frontier=doc.first),!(doc.frontier>=cm.display.showingTo)){var prevChange,end=+new Date+cm.options.workTime,state=copyState(doc.mode,getStateBefore(cm,doc.frontier)),changed=[];doc.iter(doc.frontier,Math.min(doc.first+doc.size,cm.display.showingTo+500),function(line){if(doc.frontier>=cm.display.showingFrom){var oldStyles=line.styles;line.styles=highlightLine(cm,line,state);for(var ischange=!oldStyles||oldStyles.length!=line.styles.length,i=0;!ischange&&i<oldStyles.length;++i)ischange=oldStyles[i]!=line.styles[i];ischange&&(prevChange&&prevChange.end==doc.frontier?prevChange.end++:changed.push(prevChange={start:doc.frontier,end:doc.frontier+1})),line.stateAfter=copyState(doc.mode,state)}else processLine(cm,line,state),line.stateAfter=doc.frontier%5==0?copyState(doc.mode,state):null;if(++doc.frontier,+new Date>end)return startWorker(cm,cm.options.workDelay),!0}),changed.length&&operation(cm,function(){for(var i=0;i<changed.length;++i)regChange(this,changed[i].start,changed[i].end)})()}}function findStartLine(cm,n,precise){for(var minindent,minline,doc=cm.doc,search=n,lim=n-100;search>lim;--search){if(search<=doc.first)return doc.first;var line=getLine(doc,search-1);if(line.stateAfter&&(!precise||search<=doc.frontier))return search;var indented=countColumn(line.text,null,cm.options.tabSize);(null==minline||minindent>indented)&&(minline=search-1,minindent=indented)}return minline}function getStateBefore(cm,n,precise){var doc=cm.doc,display=cm.display;if(!doc.mode.startState)return!0;var pos=findStartLine(cm,n,precise),state=pos>doc.first&&getLine(doc,pos-1).stateAfter;return state=state?copyState(doc.mode,state):startState(doc.mode),doc.iter(pos,n,function(line){processLine(cm,line,state);var save=pos==n-1||pos%5==0||pos>=display.showingFrom&&pos<display.showingTo;line.stateAfter=save?copyState(doc.mode,state):null,++pos}),state}function paddingTop(display){return display.lineSpace.offsetTop}function paddingVert(display){return display.mover.offsetHeight-display.lineSpace.offsetHeight}function paddingLeft(display){var e=removeChildrenAndAdd(display.measure,elt("pre",null,null,"text-align: left")).appendChild(elt("span","x"));return e.offsetLeft}function measureChar(cm,line,ch,data,bias){var dir=-1;data=data||measureLine(cm,line);for(var pos=ch;;pos+=dir){var r=data[pos];if(r)break;dir<0&&0==pos&&(dir=1)}return bias=pos>ch?"left":pos<ch?"right":bias,"left"==bias&&r.leftSide?r=r.leftSide:"right"==bias&&r.rightSide&&(r=r.rightSide),{left:pos<ch?r.right:r.left,right:pos>ch?r.left:r.right,top:r.top,bottom:r.bottom}}function findCachedMeasurement(cm,line){for(var cache=cm.display.measureLineCache,i=0;i<cache.length;++i){var memo=cache[i];if(memo.text==line.text&&memo.markedSpans==line.markedSpans&&cm.display.scroller.clientWidth==memo.width&&memo.classes==line.textClass+"|"+line.bgClass+"|"+line.wrapClass)return memo}}function clearCachedMeasurement(cm,line){var exists=findCachedMeasurement(cm,line);exists&&(exists.text=exists.measure=exists.markedSpans=null)}function measureLine(cm,line){var cached=findCachedMeasurement(cm,line);if(cached)return cached.measure;var measure=measureLineInner(cm,line),cache=cm.display.measureLineCache,memo={text:line.text,width:cm.display.scroller.clientWidth,markedSpans:line.markedSpans,measure:measure,classes:line.textClass+"|"+line.bgClass+"|"+line.wrapClass};return 16==cache.length?cache[++cm.display.measureLineCachePos%16]=memo:cache.push(memo),measure}function measureLineInner(cm,line){function measureRect(rect){var top=rect.top-outer.top,bot=rect.bottom-outer.top;bot>maxBot&&(bot=maxBot),top<0&&(top=0);for(var i=vranges.length-2;i>=0;i-=2){var rtop=vranges[i],rbot=vranges[i+1];if(!(rtop>bot||rbot<top)&&(rtop<=top&&rbot>=bot||top<=rtop&&bot>=rbot||Math.min(bot,rbot)-Math.max(top,rtop)>=bot-top>>1)){vranges[i]=Math.min(top,rtop),vranges[i+1]=Math.max(bot,rbot);break}}return i<0&&(i=vranges.length,vranges.push(top,bot)),{left:rect.left-outer.left,right:rect.right-outer.left,top:i,bottom:null}}function finishRect(rect){rect.bottom=vranges[rect.top+1],rect.top=vranges[rect.top]}var display=cm.display,measure=emptyArray(line.text.length),pre=lineContent(cm,line,measure,!0);if(ie&&!ie_lt8&&!cm.options.lineWrapping&&pre.childNodes.length>100){for(var fragment=document.createDocumentFragment(),chunk=10,n=pre.childNodes.length,i=0,chunks=Math.ceil(n/chunk);i<chunks;++i){for(var wrap=elt("div",null,null,"display: inline-block"),j=0;j<chunk&&n;++j)wrap.appendChild(pre.firstChild),--n;fragment.appendChild(wrap)}pre.appendChild(fragment)}removeChildrenAndAdd(display.measure,pre);var outer=getRect(display.lineDiv),vranges=[],data=emptyArray(line.text.length),maxBot=pre.offsetHeight;ie_lt9&&display.measure.first!=pre&&removeChildrenAndAdd(display.measure,pre);for(var cur,i=0;i<measure.length;++i)if(cur=measure[i]){var node=cur,rect=null;if(/\bCodeMirror-widget\b/.test(cur.className)&&cur.getClientRects){1==cur.firstChild.nodeType&&(node=cur.firstChild);var rects=node.getClientRects();rects.length>1&&(rect=data[i]=measureRect(rects[0]),rect.rightSide=measureRect(rects[rects.length-1]))}rect||(rect=data[i]=measureRect(getRect(node))),cur.measureRight&&(rect.right=getRect(cur.measureRight).left),cur.leftSide&&(rect.leftSide=measureRect(getRect(cur.leftSide)))}for(var cur,i=0;i<data.length;++i)(cur=data[i])&&(finishRect(cur),cur.leftSide&&finishRect(cur.leftSide),cur.rightSide&&finishRect(cur.rightSide));return data}function measureLineWidth(cm,line){var hasBadSpan=!1;if(line.markedSpans)for(var i=0;i<line.markedSpans;++i){var sp=line.markedSpans[i];!sp.collapsed||null!=sp.to&&sp.to!=line.text.length||(hasBadSpan=!0)}var cached=!hasBadSpan&&findCachedMeasurement(cm,line);if(cached)return measureChar(cm,line,line.text.length,cached.measure,"right").right;var pre=lineContent(cm,line,null,!0),end=pre.appendChild(zeroWidthElement(cm.display.measure));return removeChildrenAndAdd(cm.display.measure,pre),getRect(end).right-getRect(cm.display.lineDiv).left}function clearCaches(cm){cm.display.measureLineCache.length=cm.display.measureLineCachePos=0,cm.display.cachedCharWidth=cm.display.cachedTextHeight=null,cm.options.lineWrapping||(cm.display.maxLineChanged=!0),cm.display.lineNumChars=null}function pageScrollX(){return window.pageXOffset||(document.documentElement||document.body).scrollLeft}function pageScrollY(){return window.pageYOffset||(document.documentElement||document.body).scrollTop}function intoCoordSystem(cm,lineObj,rect,context){if(lineObj.widgets)for(var i=0;i<lineObj.widgets.length;++i)if(lineObj.widgets[i].above){var size=widgetHeight(lineObj.widgets[i]);rect.top+=size,rect.bottom+=size}if("line"==context)return rect;context||(context="local");var yOff=heightAtLine(cm,lineObj);if("local"==context?yOff+=paddingTop(cm.display):yOff-=cm.display.viewOffset,"page"==context||"window"==context){var lOff=getRect(cm.display.lineSpace);yOff+=lOff.top+("window"==context?0:pageScrollY());var xOff=lOff.left+("window"==context?0:pageScrollX());rect.left+=xOff,rect.right+=xOff}return rect.top+=yOff,rect.bottom+=yOff,rect}function fromCoordSystem(cm,coords,context){if("div"==context)return coords;var left=coords.left,top=coords.top;if("page"==context)left-=pageScrollX(),top-=pageScrollY();else if("local"==context||!context){var localBox=getRect(cm.display.sizer);left+=localBox.left,top+=localBox.top}var lineSpaceBox=getRect(cm.display.lineSpace);return{left:left-lineSpaceBox.left,top:top-lineSpaceBox.top}}function charCoords(cm,pos,context,lineObj,bias){return lineObj||(lineObj=getLine(cm.doc,pos.line)),intoCoordSystem(cm,lineObj,measureChar(cm,lineObj,pos.ch,null,bias),context)}function cursorCoords(cm,pos,context,lineObj,measurement){function get(ch,right){var m=measureChar(cm,lineObj,ch,measurement,right?"right":"left");return right?m.left=m.right:m.right=m.left,intoCoordSystem(cm,lineObj,m,context)}function getBidi(ch,partPos){var part=order[partPos],right=part.level%2;return ch==bidiLeft(part)&&partPos&&part.level<order[partPos-1].level?(part=order[--partPos],ch=bidiRight(part)-(part.level%2?0:1),right=!0):ch==bidiRight(part)&&partPos<order.length-1&&part.level<order[partPos+1].level&&(part=order[++partPos],ch=bidiLeft(part)-part.level%2,right=!1),right&&ch==part.to&&ch>part.from?get(ch-1):get(ch,right)}lineObj=lineObj||getLine(cm.doc,pos.line),measurement||(measurement=measureLine(cm,lineObj));var order=getOrder(lineObj),ch=pos.ch;if(!order)return get(ch);var partPos=getBidiPartAt(order,ch),val=getBidi(ch,partPos);return null!=bidiOther&&(val.other=getBidi(ch,bidiOther)),val}function PosWithInfo(line,ch,outside,xRel){var pos=new Pos(line,ch);return pos.xRel=xRel,outside&&(pos.outside=!0),pos}function coordsChar(cm,x,y){var doc=cm.doc;if(y+=cm.display.viewOffset,y<0)return PosWithInfo(doc.first,0,!0,-1);var lineNo=lineAtHeight(doc,y),last=doc.first+doc.size-1;if(lineNo>last)return PosWithInfo(doc.first+doc.size-1,getLine(doc,last).text.length,!0,1);for(x<0&&(x=0);;){var lineObj=getLine(doc,lineNo),found=coordsCharInner(cm,lineObj,lineNo,x,y),merged=collapsedSpanAtEnd(lineObj),mergedPos=merged&&merged.find();if(!merged||!(found.ch>mergedPos.from.ch||found.ch==mergedPos.from.ch&&found.xRel>0))return found;lineNo=mergedPos.to.line}}function coordsCharInner(cm,lineObj,lineNo,x,y){function getX(ch){var sp=cursorCoords(cm,Pos(lineNo,ch),"line",lineObj,measurement);return wrongLine=!0,innerOff>sp.bottom?sp.left-adjust:innerOff<sp.top?sp.left+adjust:(wrongLine=!1,sp.left)}var innerOff=y-heightAtLine(cm,lineObj),wrongLine=!1,adjust=2*cm.display.wrapper.clientWidth,measurement=measureLine(cm,lineObj),bidi=getOrder(lineObj),dist=lineObj.text.length,from=lineLeft(lineObj),to=lineRight(lineObj),fromX=getX(from),fromOutside=wrongLine,toX=getX(to),toOutside=wrongLine;if(x>toX)return PosWithInfo(lineNo,to,toOutside,1);for(;;){if(bidi?to==from||to==moveVisually(lineObj,from,1):to-from<=1){for(var ch=x<fromX||x-fromX<=toX-x?from:to,xDiff=x-(ch==from?fromX:toX);isExtendingChar.test(lineObj.text.charAt(ch));)++ch;var pos=PosWithInfo(lineNo,ch,ch==from?fromOutside:toOutside,xDiff<0?-1:xDiff?1:0);return pos}var step=Math.ceil(dist/2),middle=from+step;if(bidi){middle=from;for(var i=0;i<step;++i)middle=moveVisually(lineObj,middle,1)}var middleX=getX(middle);middleX>x?(to=middle,toX=middleX,(toOutside=wrongLine)&&(toX+=1e3),dist=step):(from=middle,fromX=middleX,fromOutside=wrongLine,dist-=step)}}function textHeight(display){if(null!=display.cachedTextHeight)return display.cachedTextHeight;if(null==measureText){measureText=elt("pre");for(var i=0;i<49;++i)measureText.appendChild(document.createTextNode("x")),measureText.appendChild(elt("br"));measureText.appendChild(document.createTextNode("x"))}removeChildrenAndAdd(display.measure,measureText);var height=measureText.offsetHeight/50;return height>3&&(display.cachedTextHeight=height),removeChildren(display.measure),height||1}function charWidth(display){if(null!=display.cachedCharWidth)return display.cachedCharWidth;var anchor=elt("span","x"),pre=elt("pre",[anchor]);removeChildrenAndAdd(display.measure,pre);var width=anchor.offsetWidth;return width>2&&(display.cachedCharWidth=width),width||10}function startOperation(cm){cm.curOp={changes:[],forceUpdate:!1,updateInput:null,userSelChange:null,textChanged:null,selectionChanged:!1,cursorActivity:!1,updateMaxLine:!1,updateScrollPos:!1,id:++nextOpId},delayedCallbackDepth++||(delayedCallbacks=[])}function endOperation(cm){var op=cm.curOp,doc=cm.doc,display=cm.display;if(cm.curOp=null,op.updateMaxLine&&computeMaxLength(cm),display.maxLineChanged&&!cm.options.lineWrapping&&display.maxLine){var width=measureLineWidth(cm,display.maxLine);display.sizer.style.minWidth=Math.max(0,width+3+scrollerCutOff)+"px",display.maxLineChanged=!1;var maxScrollLeft=Math.max(0,display.sizer.offsetLeft+display.sizer.offsetWidth-display.scroller.clientWidth);maxScrollLeft<doc.scrollLeft&&!op.updateScrollPos&&setScrollLeft(cm,Math.min(display.scroller.scrollLeft,maxScrollLeft),!0)}var newScrollPos,updated;if(op.updateScrollPos)newScrollPos=op.updateScrollPos;else if(op.selectionChanged&&display.scroller.clientHeight){var coords=cursorCoords(cm,doc.sel.head);newScrollPos=calculateScrollPos(cm,coords.left,coords.top,coords.left,coords.bottom)}(op.changes.length||op.forceUpdate||newScrollPos&&null!=newScrollPos.scrollTop)&&(updated=updateDisplay(cm,op.changes,newScrollPos&&newScrollPos.scrollTop,op.forceUpdate),cm.display.scroller.offsetHeight&&(cm.doc.scrollTop=cm.display.scroller.scrollTop)),!updated&&op.selectionChanged&&updateSelection(cm),op.updateScrollPos?(display.scroller.scrollTop=display.scrollbarV.scrollTop=doc.scrollTop=newScrollPos.scrollTop,display.scroller.scrollLeft=display.scrollbarH.scrollLeft=doc.scrollLeft=newScrollPos.scrollLeft,alignHorizontally(cm),op.scrollToPos&&scrollPosIntoView(cm,clipPos(cm.doc,op.scrollToPos),op.scrollToPosMargin)):newScrollPos&&scrollCursorIntoView(cm),op.selectionChanged&&restartBlink(cm),cm.state.focused&&op.updateInput&&resetInput(cm,op.userSelChange);var hidden=op.maybeHiddenMarkers,unhidden=op.maybeUnhiddenMarkers;if(hidden)for(var i=0;i<hidden.length;++i)hidden[i].lines.length||signal(hidden[i],"hide");if(unhidden)for(var i=0;i<unhidden.length;++i)unhidden[i].lines.length&&signal(unhidden[i],"unhide");var delayed;if(--delayedCallbackDepth||(delayed=delayedCallbacks,delayedCallbacks=null),op.textChanged&&signal(cm,"change",cm,op.textChanged),op.cursorActivity&&signal(cm,"cursorActivity",cm),delayed)for(var i=0;i<delayed.length;++i)delayed[i]()}function operation(cm1,f){return function(){var cm=cm1||this,withOp=!cm.curOp;withOp&&startOperation(cm);try{var result=f.apply(cm,arguments)}finally{withOp&&endOperation(cm)}return result}}function docOperation(f){return function(){var result,withOp=this.cm&&!this.cm.curOp;withOp&&startOperation(this.cm);try{result=f.apply(this,arguments)}finally{withOp&&endOperation(this.cm)}return result}}function runInOp(cm,f){var result,withOp=!cm.curOp;withOp&&startOperation(cm);try{result=f()}finally{withOp&&endOperation(cm)}return result}function regChange(cm,from,to,lendiff){null==from&&(from=cm.doc.first),null==to&&(to=cm.doc.first+cm.doc.size),cm.curOp.changes.push({from:from,to:to,diff:lendiff})}function slowPoll(cm){cm.display.pollingFast||cm.display.poll.set(cm.options.pollInterval,function(){readInput(cm),cm.state.focused&&slowPoll(cm)})}function fastPoll(cm){function p(){var changed=readInput(cm);changed||missed?(cm.display.pollingFast=!1,slowPoll(cm)):(missed=!0,cm.display.poll.set(60,p))}var missed=!1;cm.display.pollingFast=!0,cm.display.poll.set(20,p)}function readInput(cm){var input=cm.display.input,prevInput=cm.display.prevInput,doc=cm.doc,sel=doc.sel;if(!cm.state.focused||hasSelection(input)||isReadOnly(cm)||cm.state.disableInput)return!1;var text=input.value;if(text==prevInput&&posEq(sel.from,sel.to))return!1;if(ie&&!ie_lt9&&cm.display.inputHasSelection===text)return resetInput(cm,!0),!1;var withOp=!cm.curOp;withOp&&startOperation(cm),sel.shift=!1;for(var same=0,l=Math.min(prevInput.length,text.length);same<l&&prevInput.charCodeAt(same)==text.charCodeAt(same);)++same;var from=sel.from,to=sel.to;same<prevInput.length?from=Pos(from.line,from.ch-(prevInput.length-same)):cm.state.overwrite&&posEq(from,to)&&!cm.state.pasteIncoming&&(to=Pos(to.line,Math.min(getLine(doc,to.line).text.length,to.ch+(text.length-same))));var updateInput=cm.curOp.updateInput,changeEvent={from:from,to:to,text:splitLines(text.slice(same)),origin:cm.state.pasteIncoming?"paste":"+input"};return makeChange(cm.doc,changeEvent,"end"),cm.curOp.updateInput=updateInput,signalLater(cm,"inputRead",cm,changeEvent),text.length>1e3||text.indexOf("\n")>-1?input.value=cm.display.prevInput="":cm.display.prevInput=text,withOp&&endOperation(cm),cm.state.pasteIncoming=!1,!0}function resetInput(cm,user){var minimal,selected,doc=cm.doc;if(posEq(doc.sel.from,doc.sel.to))user&&(cm.display.prevInput=cm.display.input.value="",ie&&!ie_lt9&&(cm.display.inputHasSelection=null));else{cm.display.prevInput="",minimal=hasCopyEvent&&(doc.sel.to.line-doc.sel.from.line>100||(selected=cm.getSelection()).length>1e3);var content=minimal?"-":selected||cm.getSelection();cm.display.input.value=content,cm.state.focused&&selectInput(cm.display.input),ie&&!ie_lt9&&(cm.display.inputHasSelection=content)}cm.display.inaccurateSelection=minimal}function focusInput(cm){"nocursor"==cm.options.readOnly||mobile&&document.activeElement==cm.display.input||cm.display.input.focus()}function isReadOnly(cm){return cm.options.readOnly||cm.doc.cantEdit}function registerEventHandlers(cm){function reFocus(){cm.state.focused&&setTimeout(bind(focusInput,cm),0)}function onResize(){null==resizeTimer&&(resizeTimer=setTimeout(function(){resizeTimer=null,d.cachedCharWidth=d.cachedTextHeight=knownScrollbarWidth=null,clearCaches(cm),runInOp(cm,bind(regChange,cm))},100))}function unregister(){for(var p=d.wrapper.parentNode;p&&p!=document.body;p=p.parentNode);p?setTimeout(unregister,5e3):off(window,"resize",onResize)}function drag_(e){signalDOMEvent(cm,e)||cm.options.onDragEvent&&cm.options.onDragEvent(cm,addStop(e))||e_stop(e)}function prepareCopy(){d.inaccurateSelection&&(d.prevInput="",d.inaccurateSelection=!1,d.input.value=cm.getSelection(),selectInput(d.input))}var d=cm.display;on(d.scroller,"mousedown",operation(cm,onMouseDown)),ie?on(d.scroller,"dblclick",operation(cm,function(e){if(!signalDOMEvent(cm,e)){var pos=posFromMouse(cm,e);if(pos&&!clickInGutter(cm,e)&&!eventInWidget(cm.display,e)){e_preventDefault(e);var word=findWordAt(getLine(cm.doc,pos.line).text,pos);extendSelection(cm.doc,word.from,word.to)}}})):on(d.scroller,"dblclick",function(e){signalDOMEvent(cm,e)||e_preventDefault(e)}),on(d.lineSpace,"selectstart",function(e){eventInWidget(d,e)||e_preventDefault(e)}),captureMiddleClick||on(d.scroller,"contextmenu",function(e){onContextMenu(cm,e)}),on(d.scroller,"scroll",function(){d.scroller.clientHeight&&(setScrollTop(cm,d.scroller.scrollTop),setScrollLeft(cm,d.scroller.scrollLeft,!0),signal(cm,"scroll",cm))}),on(d.scrollbarV,"scroll",function(){d.scroller.clientHeight&&setScrollTop(cm,d.scrollbarV.scrollTop)}),on(d.scrollbarH,"scroll",function(){d.scroller.clientHeight&&setScrollLeft(cm,d.scrollbarH.scrollLeft)}),on(d.scroller,"mousewheel",function(e){onScrollWheel(cm,e)}),on(d.scroller,"DOMMouseScroll",function(e){onScrollWheel(cm,e)}),on(d.scrollbarH,"mousedown",reFocus),on(d.scrollbarV,"mousedown",reFocus),on(d.wrapper,"scroll",function(){d.wrapper.scrollTop=d.wrapper.scrollLeft=0});var resizeTimer;on(window,"resize",onResize),setTimeout(unregister,5e3),on(d.input,"keyup",operation(cm,function(e){signalDOMEvent(cm,e)||cm.options.onKeyEvent&&cm.options.onKeyEvent(cm,addStop(e))||16==e.keyCode&&(cm.doc.sel.shift=!1)})),on(d.input,"input",bind(fastPoll,cm)),on(d.input,"keydown",operation(cm,onKeyDown)),on(d.input,"keypress",operation(cm,onKeyPress)),on(d.input,"focus",bind(onFocus,cm)),on(d.input,"blur",bind(onBlur,cm)),cm.options.dragDrop&&(on(d.scroller,"dragstart",function(e){onDragStart(cm,e)}),on(d.scroller,"dragenter",drag_),on(d.scroller,"dragover",drag_),on(d.scroller,"drop",operation(cm,onDrop))),on(d.scroller,"paste",function(e){eventInWidget(d,e)||(focusInput(cm),fastPoll(cm))}),on(d.input,"paste",function(){cm.state.pasteIncoming=!0,fastPoll(cm)}),on(d.input,"cut",prepareCopy),on(d.input,"copy",prepareCopy),khtml&&on(d.sizer,"mouseup",function(){document.activeElement==d.input&&d.input.blur(),focusInput(cm)})}function eventInWidget(display,e){for(var n=e_target(e);n!=display.wrapper;n=n.parentNode)if(!n||n.ignoreEvents||n.parentNode==display.sizer&&n!=display.mover)return!0}function posFromMouse(cm,e,liberal){var display=cm.display;if(!liberal){var target=e_target(e);if(target==display.scrollbarH||target==display.scrollbarH.firstChild||target==display.scrollbarV||target==display.scrollbarV.firstChild||target==display.scrollbarFiller||target==display.gutterFiller)return null}var x,y,space=getRect(display.lineSpace);try{x=e.clientX,y=e.clientY}catch(e){return null}return coordsChar(cm,x-space.left,y-space.top)}function onMouseDown(e){function doSelect(cur){if(!posEq(lastPos,cur)){if(lastPos=cur,"single"==type)return void extendSelection(cm.doc,clipPos(doc,start),cur);if(startstart=clipPos(doc,startstart),startend=clipPos(doc,startend),"double"==type){var word=findWordAt(getLine(doc,cur.line).text,cur);posLess(cur,startstart)?extendSelection(cm.doc,word.from,startend):extendSelection(cm.doc,startstart,word.to)}else"triple"==type&&(posLess(cur,startstart)?extendSelection(cm.doc,startend,clipPos(doc,Pos(cur.line,0))):extendSelection(cm.doc,startstart,clipPos(doc,Pos(cur.line+1,0))))}}function extend(e){var curCount=++counter,cur=posFromMouse(cm,e,!0);if(cur)if(posEq(cur,last)){var outside=e.clientY<editorSize.top?-20:e.clientY>editorSize.bottom?20:0;outside&&setTimeout(operation(cm,function(){counter==curCount&&(display.scroller.scrollTop+=outside,extend(e))}),50)}else{cm.state.focused||onFocus(cm),last=cur,doSelect(cur);var visible=visibleLines(display,doc);(cur.line>=visible.to||cur.line<visible.from)&&setTimeout(operation(cm,function(){counter==curCount&&extend(e)}),150)}}function done(e){counter=1/0,e_preventDefault(e),focusInput(cm),off(document,"mousemove",move),off(document,"mouseup",up)}if(!signalDOMEvent(this,e)){var cm=this,display=cm.display,doc=cm.doc,sel=doc.sel;if(sel.shift=e.shiftKey,eventInWidget(display,e))return void(webkit||(display.scroller.draggable=!1,setTimeout(function(){display.scroller.draggable=!0},100)));if(!clickInGutter(cm,e)){var start=posFromMouse(cm,e);switch(e_button(e)){case 3:return void(captureMiddleClick&&onContextMenu.call(cm,cm,e));case 2:return start&&extendSelection(cm.doc,start),setTimeout(bind(focusInput,cm),20),void e_preventDefault(e)}if(!start)return void(e_target(e)==display.scroller&&e_preventDefault(e));cm.state.focused||onFocus(cm);var now=+new Date,type="single";if(lastDoubleClick&&lastDoubleClick.time>now-400&&posEq(lastDoubleClick.pos,start))type="triple",e_preventDefault(e),setTimeout(bind(focusInput,cm),20),selectLine(cm,start.line);else if(lastClick&&lastClick.time>now-400&&posEq(lastClick.pos,start)){type="double",lastDoubleClick={time:now,pos:start},e_preventDefault(e);var word=findWordAt(getLine(doc,start.line).text,start);extendSelection(cm.doc,word.from,word.to)}else lastClick={time:now,pos:start};var last=start;if(cm.options.dragDrop&&dragAndDrop&&!isReadOnly(cm)&&!posEq(sel.from,sel.to)&&!posLess(start,sel.from)&&!posLess(sel.to,start)&&"single"==type){var dragEnd=operation(cm,function(e2){webkit&&(display.scroller.draggable=!1),cm.state.draggingText=!1,off(document,"mouseup",dragEnd),off(display.scroller,"drop",dragEnd),Math.abs(e.clientX-e2.clientX)+Math.abs(e.clientY-e2.clientY)<10&&(e_preventDefault(e2),extendSelection(cm.doc,start),focusInput(cm))});return webkit&&(display.scroller.draggable=!0),cm.state.draggingText=dragEnd,display.scroller.dragDrop&&display.scroller.dragDrop(),on(document,"mouseup",dragEnd),void on(display.scroller,"drop",dragEnd)}e_preventDefault(e),"single"==type&&extendSelection(cm.doc,clipPos(doc,start));var startstart=sel.from,startend=sel.to,lastPos=start,editorSize=getRect(display.wrapper),counter=0,move=operation(cm,function(e){ie||e_button(e)?extend(e):done(e)}),up=operation(cm,done);on(document,"mousemove",move),on(document,"mouseup",up)}}}function clickInGutter(cm,e){var display=cm.display;try{var mX=e.clientX,mY=e.clientY}catch(e){return!1}if(mX>=Math.floor(getRect(display.gutters).right))return!1;if(e_preventDefault(e),!hasHandler(cm,"gutterClick"))return!0;var lineBox=getRect(display.lineDiv);if(mY>lineBox.bottom)return!0;mY-=lineBox.top-display.viewOffset;for(var i=0;i<cm.options.gutters.length;++i){var g=display.gutters.childNodes[i];if(g&&getRect(g).right>=mX){var line=lineAtHeight(cm.doc,mY),gutter=cm.options.gutters[i];signalLater(cm,"gutterClick",cm,line,gutter,e);break}}return!0}function onDrop(e){var cm=this;if(!(signalDOMEvent(cm,e)||eventInWidget(cm.display,e)||cm.options.onDragEvent&&cm.options.onDragEvent(cm,addStop(e)))){e_preventDefault(e),ie&&(lastDrop=+new Date);var pos=posFromMouse(cm,e,!0),files=e.dataTransfer.files;if(pos&&!isReadOnly(cm))if(files&&files.length&&window.FileReader&&window.File)for(var n=files.length,text=Array(n),read=0,loadFile=function(file,i){var reader=new FileReader;reader.onload=function(){text[i]=reader.result,++read==n&&(pos=clipPos(cm.doc,pos),makeChange(cm.doc,{from:pos,to:pos,text:splitLines(text.join("\n")),origin:"paste"},"around"))},reader.readAsText(file)},i=0;i<n;++i)loadFile(files[i],i);else{if(cm.state.draggingText&&!posLess(pos,cm.doc.sel.from)&&!posLess(cm.doc.sel.to,pos))return cm.state.draggingText(e),void setTimeout(bind(focusInput,cm),20);try{var text=e.dataTransfer.getData("Text");if(text){var curFrom=cm.doc.sel.from,curTo=cm.doc.sel.to;setSelection(cm.doc,pos,pos),cm.state.draggingText&&replaceRange(cm.doc,"",curFrom,curTo,"paste"),cm.replaceSelection(text,null,"paste"),focusInput(cm),onFocus(cm)}}catch(e){}}}}function onDragStart(cm,e){if(ie&&(!cm.state.draggingText||+new Date-lastDrop<100))return void e_stop(e);if(!signalDOMEvent(cm,e)&&!eventInWidget(cm.display,e)){var txt=cm.getSelection();if(e.dataTransfer.setData("Text",txt),e.dataTransfer.setDragImage&&!safari){var img=elt("img",null,null,"position: fixed; left: 0; top: 0;");opera&&(img.width=img.height=1,cm.display.wrapper.appendChild(img),img._top=img.offsetTop),e.dataTransfer.setDragImage(img,0,0),opera&&img.parentNode.removeChild(img)}}}function setScrollTop(cm,val){Math.abs(cm.doc.scrollTop-val)<2||(cm.doc.scrollTop=val,gecko||updateDisplay(cm,[],val),cm.display.scroller.scrollTop!=val&&(cm.display.scroller.scrollTop=val),cm.display.scrollbarV.scrollTop!=val&&(cm.display.scrollbarV.scrollTop=val),gecko&&updateDisplay(cm,[]),startWorker(cm,100))}function setScrollLeft(cm,val,isScroller){(isScroller?val==cm.doc.scrollLeft:Math.abs(cm.doc.scrollLeft-val)<2)||(val=Math.min(val,cm.display.scroller.scrollWidth-cm.display.scroller.clientWidth),cm.doc.scrollLeft=val,alignHorizontally(cm),cm.display.scroller.scrollLeft!=val&&(cm.display.scroller.scrollLeft=val),cm.display.scrollbarH.scrollLeft!=val&&(cm.display.scrollbarH.scrollLeft=val))}function onScrollWheel(cm,e){var dx=e.wheelDeltaX,dy=e.wheelDeltaY;null==dx&&e.detail&&e.axis==e.HORIZONTAL_AXIS&&(dx=e.detail),null==dy&&e.detail&&e.axis==e.VERTICAL_AXIS?dy=e.detail:null==dy&&(dy=e.wheelDelta);var display=cm.display,scroll=display.scroller;if(dx&&scroll.scrollWidth>scroll.clientWidth||dy&&scroll.scrollHeight>scroll.clientHeight){if(dy&&mac&&webkit)for(var cur=e.target;cur!=scroll;cur=cur.parentNode)if(cur.lineObj){cm.display.currentWheelTarget=cur;break}if(dx&&!gecko&&!opera&&null!=wheelPixelsPerUnit)return dy&&setScrollTop(cm,Math.max(0,Math.min(scroll.scrollTop+dy*wheelPixelsPerUnit,scroll.scrollHeight-scroll.clientHeight))),setScrollLeft(cm,Math.max(0,Math.min(scroll.scrollLeft+dx*wheelPixelsPerUnit,scroll.scrollWidth-scroll.clientWidth))),e_preventDefault(e),void(display.wheelStartX=null);if(dy&&null!=wheelPixelsPerUnit){var pixels=dy*wheelPixelsPerUnit,top=cm.doc.scrollTop,bot=top+display.wrapper.clientHeight;pixels<0?top=Math.max(0,top+pixels-50):bot=Math.min(cm.doc.height,bot+pixels+50),updateDisplay(cm,[],{top:top,bottom:bot})}wheelSamples<20&&(null==display.wheelStartX?(display.wheelStartX=scroll.scrollLeft,display.wheelStartY=scroll.scrollTop,display.wheelDX=dx,display.wheelDY=dy,setTimeout(function(){if(null!=display.wheelStartX){var movedX=scroll.scrollLeft-display.wheelStartX,movedY=scroll.scrollTop-display.wheelStartY,sample=movedY&&display.wheelDY&&movedY/display.wheelDY||movedX&&display.wheelDX&&movedX/display.wheelDX;display.wheelStartX=display.wheelStartY=null,sample&&(wheelPixelsPerUnit=(wheelPixelsPerUnit*wheelSamples+sample)/(wheelSamples+1),++wheelSamples)}},200)):(display.wheelDX+=dx,display.wheelDY+=dy))}}function doHandleBinding(cm,bound,dropShift){if("string"==typeof bound&&(bound=commands[bound],!bound))return!1;cm.display.pollingFast&&readInput(cm)&&(cm.display.pollingFast=!1);var doc=cm.doc,prevShift=doc.sel.shift,done=!1;try{isReadOnly(cm)&&(cm.state.suppressEdits=!0),dropShift&&(doc.sel.shift=!1),done=bound(cm)!=Pass}finally{doc.sel.shift=prevShift,cm.state.suppressEdits=!1}return done}function allKeyMaps(cm){var maps=cm.state.keyMaps.slice(0);return cm.options.extraKeys&&maps.push(cm.options.extraKeys),maps.push(cm.options.keyMap),maps}function handleKeyBinding(cm,e){var startMap=getKeyMap(cm.options.keyMap),next=startMap.auto;clearTimeout(maybeTransition),next&&!isModifierKey(e)&&(maybeTransition=setTimeout(function(){getKeyMap(cm.options.keyMap)==startMap&&(cm.options.keyMap=next.call?next.call(null,cm):next,keyMapChanged(cm))},50));var name=keyName(e,!0),handled=!1;if(!name)return!1;var keymaps=allKeyMaps(cm);return handled=e.shiftKey?lookupKey("Shift-"+name,keymaps,function(b){return doHandleBinding(cm,b,!0)})||lookupKey(name,keymaps,function(b){if("string"==typeof b?/^go[A-Z]/.test(b):b.motion)return doHandleBinding(cm,b)}):lookupKey(name,keymaps,function(b){return doHandleBinding(cm,b)}),handled&&(e_preventDefault(e),restartBlink(cm),ie_lt9&&(e.oldKeyCode=e.keyCode,e.keyCode=0),signalLater(cm,"keyHandled",cm,name,e)),handled}function handleCharBinding(cm,e,ch){var handled=lookupKey("'"+ch+"'",allKeyMaps(cm),function(b){return doHandleBinding(cm,b,!0)});return handled&&(e_preventDefault(e),restartBlink(cm),signalLater(cm,"keyHandled",cm,"'"+ch+"'",e)),handled}function onKeyDown(e){var cm=this;if(cm.state.focused||onFocus(cm),ie&&27==e.keyCode&&(e.returnValue=!1),!(signalDOMEvent(cm,e)||cm.options.onKeyEvent&&cm.options.onKeyEvent(cm,addStop(e)))){var code=e.keyCode;cm.doc.sel.shift=16==code||e.shiftKey;var handled=handleKeyBinding(cm,e);opera&&(lastStoppedKey=handled?code:null,!handled&&88==code&&!hasCopyEvent&&(mac?e.metaKey:e.ctrlKey)&&cm.replaceSelection(""))}}function onKeyPress(e){var cm=this;if(!(signalDOMEvent(cm,e)||cm.options.onKeyEvent&&cm.options.onKeyEvent(cm,addStop(e)))){var keyCode=e.keyCode,charCode=e.charCode;if(opera&&keyCode==lastStoppedKey)return lastStoppedKey=null,void e_preventDefault(e);if(!(opera&&(!e.which||e.which<10)||khtml)||!handleKeyBinding(cm,e)){var ch=String.fromCharCode(null==charCode?keyCode:charCode);this.options.electricChars&&this.doc.mode.electricChars&&this.options.smartIndent&&!isReadOnly(this)&&this.doc.mode.electricChars.indexOf(ch)>-1&&setTimeout(operation(cm,function(){indentLine(cm,cm.doc.sel.to.line,"smart")}),75),handleCharBinding(cm,e,ch)||(ie&&!ie_lt9&&(cm.display.inputHasSelection=null),fastPoll(cm))}}}function onFocus(cm){"nocursor"!=cm.options.readOnly&&(cm.state.focused||(signal(cm,"focus",cm),cm.state.focused=!0,cm.display.wrapper.className.search(/\bCodeMirror-focused\b/)==-1&&(cm.display.wrapper.className+=" CodeMirror-focused"),resetInput(cm,!0)),slowPoll(cm),restartBlink(cm))}function onBlur(cm){cm.state.focused&&(signal(cm,"blur",cm),cm.state.focused=!1,cm.display.wrapper.className=cm.display.wrapper.className.replace(" CodeMirror-focused","")),clearInterval(cm.display.blinker),setTimeout(function(){cm.state.focused||(cm.doc.sel.shift=!1);
},150)}function onContextMenu(cm,e){function prepareSelectAllHack(){if(null!=display.input.selectionStart){var extval=display.input.value=" "+(posEq(sel.from,sel.to)?"":display.input.value);display.prevInput=" ",display.input.selectionStart=1,display.input.selectionEnd=extval.length}}function rehide(){if(display.inputDiv.style.position="relative",display.input.style.cssText=oldCSS,ie_lt9&&(display.scrollbarV.scrollTop=display.scroller.scrollTop=scrollPos),slowPoll(cm),null!=display.input.selectionStart){ie&&!ie_lt9||prepareSelectAllHack(),clearTimeout(detectingSelectAll);var i=0,poll=function(){" "==display.prevInput&&0==display.input.selectionStart?operation(cm,commands.selectAll)(cm):i++<10?detectingSelectAll=setTimeout(poll,500):resetInput(cm)};detectingSelectAll=setTimeout(poll,200)}}if(!signalDOMEvent(cm,e,"contextmenu")){var display=cm.display,sel=cm.doc.sel;if(!eventInWidget(display,e)){var pos=posFromMouse(cm,e),scrollPos=display.scroller.scrollTop;if(pos&&!opera){(posEq(sel.from,sel.to)||posLess(pos,sel.from)||!posLess(pos,sel.to))&&operation(cm,setSelection)(cm.doc,pos,pos);var oldCSS=display.input.style.cssText;if(display.inputDiv.style.position="absolute",display.input.style.cssText="position: fixed; width: 30px; height: 30px; top: "+(e.clientY-5)+"px; left: "+(e.clientX-5)+"px; z-index: 1000; background: white; outline: none;border-width: 0; outline: none; overflow: hidden; opacity: .05; -ms-opacity: .05; filter: alpha(opacity=5);",focusInput(cm),resetInput(cm,!0),posEq(sel.from,sel.to)&&(display.input.value=display.prevInput=" "),ie&&!ie_lt9&&prepareSelectAllHack(),captureMiddleClick){e_stop(e);var mouseup=function(){off(window,"mouseup",mouseup),setTimeout(rehide,20)};on(window,"mouseup",mouseup)}else setTimeout(rehide,50)}}}}function clipPostChange(doc,change,pos){if(!posLess(change.from,pos))return clipPos(doc,pos);var diff=change.text.length-1-(change.to.line-change.from.line);if(pos.line>change.to.line+diff){var preLine=pos.line-diff,lastLine=doc.first+doc.size-1;return preLine>lastLine?Pos(lastLine,getLine(doc,lastLine).text.length):clipToLen(pos,getLine(doc,preLine).text.length)}if(pos.line==change.to.line+diff)return clipToLen(pos,lst(change.text).length+(1==change.text.length?change.from.ch:0)+getLine(doc,change.to.line).text.length-change.to.ch);var inside=pos.line-change.from.line;return clipToLen(pos,change.text[inside].length+(inside?0:change.from.ch))}function computeSelAfterChange(doc,change,hint){if(hint&&"object"==typeof hint)return{anchor:clipPostChange(doc,change,hint.anchor),head:clipPostChange(doc,change,hint.head)};if("start"==hint)return{anchor:change.from,head:change.from};var end=changeEnd(change);if("around"==hint)return{anchor:change.from,head:end};if("end"==hint)return{anchor:end,head:end};var adjustPos=function(pos){if(posLess(pos,change.from))return pos;if(!posLess(change.to,pos))return end;var line=pos.line+change.text.length-(change.to.line-change.from.line)-1,ch=pos.ch;return pos.line==change.to.line&&(ch+=end.ch-change.to.ch),Pos(line,ch)};return{anchor:adjustPos(doc.sel.anchor),head:adjustPos(doc.sel.head)}}function filterChange(doc,change,update){var obj={canceled:!1,from:change.from,to:change.to,text:change.text,origin:change.origin,cancel:function(){this.canceled=!0}};return update&&(obj.update=function(from,to,text,origin){from&&(this.from=clipPos(doc,from)),to&&(this.to=clipPos(doc,to)),text&&(this.text=text),void 0!==origin&&(this.origin=origin)}),signal(doc,"beforeChange",doc,obj),doc.cm&&signal(doc.cm,"beforeChange",doc.cm,obj),obj.canceled?null:{from:obj.from,to:obj.to,text:obj.text,origin:obj.origin}}function makeChange(doc,change,selUpdate,ignoreReadOnly){if(doc.cm){if(!doc.cm.curOp)return operation(doc.cm,makeChange)(doc,change,selUpdate,ignoreReadOnly);if(doc.cm.state.suppressEdits)return}if(!(hasHandler(doc,"beforeChange")||doc.cm&&hasHandler(doc.cm,"beforeChange"))||(change=filterChange(doc,change,!0))){var split=sawReadOnlySpans&&!ignoreReadOnly&&removeReadOnlyRanges(doc,change.from,change.to);if(split){for(var i=split.length-1;i>=1;--i)makeChangeNoReadonly(doc,{from:split[i].from,to:split[i].to,text:[""]});split.length&&makeChangeNoReadonly(doc,{from:split[0].from,to:split[0].to,text:change.text},selUpdate)}else makeChangeNoReadonly(doc,change,selUpdate)}}function makeChangeNoReadonly(doc,change,selUpdate){var selAfter=computeSelAfterChange(doc,change,selUpdate);addToHistory(doc,change,selAfter,doc.cm?doc.cm.curOp.id:NaN),makeChangeSingleDoc(doc,change,selAfter,stretchSpansOverChange(doc,change));var rebased=[];linkedDocs(doc,function(doc,sharedHist){sharedHist||indexOf(rebased,doc.history)!=-1||(rebaseHist(doc.history,change),rebased.push(doc.history)),makeChangeSingleDoc(doc,change,null,stretchSpansOverChange(doc,change))})}function makeChangeFromHistory(doc,type){if(!doc.cm||!doc.cm.state.suppressEdits){var hist=doc.history,event=("undo"==type?hist.done:hist.undone).pop();if(event){var anti={changes:[],anchorBefore:event.anchorAfter,headBefore:event.headAfter,anchorAfter:event.anchorBefore,headAfter:event.headBefore,generation:hist.generation};("undo"==type?hist.undone:hist.done).push(anti),hist.generation=event.generation||++hist.maxGeneration;for(var filter=hasHandler(doc,"beforeChange")||doc.cm&&hasHandler(doc.cm,"beforeChange"),i=event.changes.length-1;i>=0;--i){var change=event.changes[i];if(change.origin=type,filter&&!filterChange(doc,change,!1))return void(("undo"==type?hist.done:hist.undone).length=0);anti.changes.push(historyChangeFromChange(doc,change));var after=i?computeSelAfterChange(doc,change,null):{anchor:event.anchorBefore,head:event.headBefore};makeChangeSingleDoc(doc,change,after,mergeOldSpans(doc,change));var rebased=[];linkedDocs(doc,function(doc,sharedHist){sharedHist||indexOf(rebased,doc.history)!=-1||(rebaseHist(doc.history,change),rebased.push(doc.history)),makeChangeSingleDoc(doc,change,null,mergeOldSpans(doc,change))})}}}}function shiftDoc(doc,distance){function shiftPos(pos){return Pos(pos.line+distance,pos.ch)}doc.first+=distance,doc.cm&&regChange(doc.cm,doc.first,doc.first,distance),doc.sel.head=shiftPos(doc.sel.head),doc.sel.anchor=shiftPos(doc.sel.anchor),doc.sel.from=shiftPos(doc.sel.from),doc.sel.to=shiftPos(doc.sel.to)}function makeChangeSingleDoc(doc,change,selAfter,spans){if(doc.cm&&!doc.cm.curOp)return operation(doc.cm,makeChangeSingleDoc)(doc,change,selAfter,spans);if(change.to.line<doc.first)return void shiftDoc(doc,change.text.length-1-(change.to.line-change.from.line));if(!(change.from.line>doc.lastLine())){if(change.from.line<doc.first){var shift=change.text.length-1-(doc.first-change.from.line);shiftDoc(doc,shift),change={from:Pos(doc.first,0),to:Pos(change.to.line+shift,change.to.ch),text:[lst(change.text)],origin:change.origin}}var last=doc.lastLine();change.to.line>last&&(change={from:change.from,to:Pos(last,getLine(doc,last).text.length),text:[change.text[0]],origin:change.origin}),change.removed=getBetween(doc,change.from,change.to),selAfter||(selAfter=computeSelAfterChange(doc,change,null)),doc.cm?makeChangeSingleDocInEditor(doc.cm,change,spans,selAfter):updateDoc(doc,change,spans,selAfter)}}function makeChangeSingleDocInEditor(cm,change,spans,selAfter){var doc=cm.doc,display=cm.display,from=change.from,to=change.to,recomputeMaxLength=!1,checkWidthStart=from.line;cm.options.lineWrapping||(checkWidthStart=lineNo(visualLine(doc,getLine(doc,from.line))),doc.iter(checkWidthStart,to.line+1,function(line){if(line==display.maxLine)return recomputeMaxLength=!0,!0})),posLess(doc.sel.head,change.from)||posLess(change.to,doc.sel.head)||(cm.curOp.cursorActivity=!0),updateDoc(doc,change,spans,selAfter,estimateHeight(cm)),cm.options.lineWrapping||(doc.iter(checkWidthStart,from.line+change.text.length,function(line){var len=lineLength(doc,line);len>display.maxLineLength&&(display.maxLine=line,display.maxLineLength=len,display.maxLineChanged=!0,recomputeMaxLength=!1)}),recomputeMaxLength&&(cm.curOp.updateMaxLine=!0)),doc.frontier=Math.min(doc.frontier,from.line),startWorker(cm,400);var lendiff=change.text.length-(to.line-from.line)-1;if(regChange(cm,from.line,to.line+1,lendiff),hasHandler(cm,"change")){var changeObj={from:from,to:to,text:change.text,removed:change.removed,origin:change.origin};if(cm.curOp.textChanged){for(var cur=cm.curOp.textChanged;cur.next;cur=cur.next);cur.next=changeObj}else cm.curOp.textChanged=changeObj}}function replaceRange(doc,code,from,to,origin){if(to||(to=from),posLess(to,from)){var tmp=to;to=from,from=tmp}"string"==typeof code&&(code=splitLines(code)),makeChange(doc,{from:from,to:to,text:code,origin:origin},null)}function Pos(line,ch){return this instanceof Pos?(this.line=line,void(this.ch=ch)):new Pos(line,ch)}function posEq(a,b){return a.line==b.line&&a.ch==b.ch}function posLess(a,b){return a.line<b.line||a.line==b.line&&a.ch<b.ch}function copyPos(x){return Pos(x.line,x.ch)}function clipLine(doc,n){return Math.max(doc.first,Math.min(n,doc.first+doc.size-1))}function clipPos(doc,pos){if(pos.line<doc.first)return Pos(doc.first,0);var last=doc.first+doc.size-1;return pos.line>last?Pos(last,getLine(doc,last).text.length):clipToLen(pos,getLine(doc,pos.line).text.length)}function clipToLen(pos,linelen){var ch=pos.ch;return null==ch||ch>linelen?Pos(pos.line,linelen):ch<0?Pos(pos.line,0):pos}function isLine(doc,l){return l>=doc.first&&l<doc.first+doc.size}function extendSelection(doc,pos,other,bias){if(doc.sel.shift||doc.sel.extend){var anchor=doc.sel.anchor;if(other){var posBefore=posLess(pos,anchor);posBefore!=posLess(other,anchor)?(anchor=pos,pos=other):posBefore!=posLess(pos,other)&&(pos=other)}setSelection(doc,anchor,pos,bias)}else setSelection(doc,pos,other||pos,bias);doc.cm&&(doc.cm.curOp.userSelChange=!0)}function filterSelectionChange(doc,anchor,head){var obj={anchor:anchor,head:head};return signal(doc,"beforeSelectionChange",doc,obj),doc.cm&&signal(doc.cm,"beforeSelectionChange",doc.cm,obj),obj.anchor=clipPos(doc,obj.anchor),obj.head=clipPos(doc,obj.head),obj}function setSelection(doc,anchor,head,bias,checkAtomic){if(!checkAtomic&&hasHandler(doc,"beforeSelectionChange")||doc.cm&&hasHandler(doc.cm,"beforeSelectionChange")){var filtered=filterSelectionChange(doc,anchor,head);head=filtered.head,anchor=filtered.anchor}var sel=doc.sel;if(sel.goalColumn=null,!checkAtomic&&posEq(anchor,sel.anchor)||(anchor=skipAtomic(doc,anchor,bias,"push"!=checkAtomic)),!checkAtomic&&posEq(head,sel.head)||(head=skipAtomic(doc,head,bias,"push"!=checkAtomic)),!posEq(sel.anchor,anchor)||!posEq(sel.head,head)){sel.anchor=anchor,sel.head=head;var inv=posLess(head,anchor);sel.from=inv?head:anchor,sel.to=inv?anchor:head,doc.cm&&(doc.cm.curOp.updateInput=doc.cm.curOp.selectionChanged=doc.cm.curOp.cursorActivity=!0),signalLater(doc,"cursorActivity",doc)}}function reCheckSelection(cm){setSelection(cm.doc,cm.doc.sel.from,cm.doc.sel.to,null,"push")}function skipAtomic(doc,pos,bias,mayClear){var flipped=!1,curPos=pos,dir=bias||1;doc.cantEdit=!1;search:for(;;){var line=getLine(doc,curPos.line);if(line.markedSpans)for(var i=0;i<line.markedSpans.length;++i){var sp=line.markedSpans[i],m=sp.marker;if((null==sp.from||(m.inclusiveLeft?sp.from<=curPos.ch:sp.from<curPos.ch))&&(null==sp.to||(m.inclusiveRight?sp.to>=curPos.ch:sp.to>curPos.ch))){if(mayClear&&(signal(m,"beforeCursorEnter"),m.explicitlyCleared)){if(line.markedSpans){--i;continue}break}if(!m.atomic)continue;var newPos=m.find()[dir<0?"from":"to"];if(posEq(newPos,curPos)&&(newPos.ch+=dir,newPos.ch<0?newPos=newPos.line>doc.first?clipPos(doc,Pos(newPos.line-1)):null:newPos.ch>line.text.length&&(newPos=newPos.line<doc.first+doc.size-1?Pos(newPos.line+1,0):null),!newPos)){if(flipped)return mayClear?(doc.cantEdit=!0,Pos(doc.first,0)):skipAtomic(doc,pos,bias,!0);flipped=!0,newPos=pos,dir=-dir}curPos=newPos;continue search}}return curPos}}function scrollCursorIntoView(cm){var coords=scrollPosIntoView(cm,cm.doc.sel.head,cm.options.cursorScrollMargin);if(cm.state.focused){var display=cm.display,box=getRect(display.sizer),doScroll=null;if(coords.top+box.top<0?doScroll=!0:coords.bottom+box.top>(window.innerHeight||document.documentElement.clientHeight)&&(doScroll=!1),null!=doScroll&&!phantom){var hidden="none"==display.cursor.style.display;hidden&&(display.cursor.style.display="",display.cursor.style.left=coords.left+"px",display.cursor.style.top=coords.top-display.viewOffset+"px"),display.cursor.scrollIntoView(doScroll),hidden&&(display.cursor.style.display="none")}}}function scrollPosIntoView(cm,pos,margin){for(null==margin&&(margin=0);;){var changed=!1,coords=cursorCoords(cm,pos),scrollPos=calculateScrollPos(cm,coords.left,coords.top-margin,coords.left,coords.bottom+margin),startTop=cm.doc.scrollTop,startLeft=cm.doc.scrollLeft;if(null!=scrollPos.scrollTop&&(setScrollTop(cm,scrollPos.scrollTop),Math.abs(cm.doc.scrollTop-startTop)>1&&(changed=!0)),null!=scrollPos.scrollLeft&&(setScrollLeft(cm,scrollPos.scrollLeft),Math.abs(cm.doc.scrollLeft-startLeft)>1&&(changed=!0)),!changed)return coords}}function scrollIntoView(cm,x1,y1,x2,y2){var scrollPos=calculateScrollPos(cm,x1,y1,x2,y2);null!=scrollPos.scrollTop&&setScrollTop(cm,scrollPos.scrollTop),null!=scrollPos.scrollLeft&&setScrollLeft(cm,scrollPos.scrollLeft)}function calculateScrollPos(cm,x1,y1,x2,y2){var display=cm.display,snapMargin=textHeight(cm.display);y1<0&&(y1=0);var screen=display.scroller.clientHeight-scrollerCutOff,screentop=display.scroller.scrollTop,result={},docBottom=cm.doc.height+paddingVert(display),atTop=y1<snapMargin,atBottom=y2>docBottom-snapMargin;if(y1<screentop)result.scrollTop=atTop?0:y1;else if(y2>screentop+screen){var newTop=Math.min(y1,(atBottom?docBottom:y2)-screen);newTop!=screentop&&(result.scrollTop=newTop)}var screenw=display.scroller.clientWidth-scrollerCutOff,screenleft=display.scroller.scrollLeft;x1+=display.gutters.offsetWidth,x2+=display.gutters.offsetWidth;var gutterw=display.gutters.offsetWidth,atLeft=x1<gutterw+10;return x1<screenleft+gutterw||atLeft?(atLeft&&(x1=0),result.scrollLeft=Math.max(0,x1-10-gutterw)):x2>screenw+screenleft-3&&(result.scrollLeft=x2+10-screenw),result}function updateScrollPos(cm,left,top){cm.curOp.updateScrollPos={scrollLeft:null==left?cm.doc.scrollLeft:left,scrollTop:null==top?cm.doc.scrollTop:top}}function addToScrollPos(cm,left,top){var pos=cm.curOp.updateScrollPos||(cm.curOp.updateScrollPos={scrollLeft:cm.doc.scrollLeft,scrollTop:cm.doc.scrollTop}),scroll=cm.display.scroller;pos.scrollTop=Math.max(0,Math.min(scroll.scrollHeight-scroll.clientHeight,pos.scrollTop+top)),pos.scrollLeft=Math.max(0,Math.min(scroll.scrollWidth-scroll.clientWidth,pos.scrollLeft+left))}function indentLine(cm,n,how,aggressive){var doc=cm.doc;if(null==how&&(how="add"),"smart"==how)if(cm.doc.mode.indent)var state=getStateBefore(cm,n);else how="prev";var indentation,tabSize=cm.options.tabSize,line=getLine(doc,n),curSpace=countColumn(line.text,null,tabSize),curSpaceString=line.text.match(/^\s*/)[0];if("smart"==how&&(indentation=cm.doc.mode.indent(state,line.text.slice(curSpaceString.length),line.text),indentation==Pass)){if(!aggressive)return;how="prev"}"prev"==how?indentation=n>doc.first?countColumn(getLine(doc,n-1).text,null,tabSize):0:"add"==how?indentation=curSpace+cm.options.indentUnit:"subtract"==how?indentation=curSpace-cm.options.indentUnit:"number"==typeof how&&(indentation=curSpace+how),indentation=Math.max(0,indentation);var indentString="",pos=0;if(cm.options.indentWithTabs)for(var i=Math.floor(indentation/tabSize);i;--i)pos+=tabSize,indentString+="\t";pos<indentation&&(indentString+=spaceStr(indentation-pos)),indentString!=curSpaceString&&replaceRange(cm.doc,indentString,Pos(n,0),Pos(n,curSpaceString.length),"+input"),line.stateAfter=null}function changeLine(cm,handle,op){var no=handle,line=handle,doc=cm.doc;return"number"==typeof handle?line=getLine(doc,clipLine(doc,handle)):no=lineNo(handle),null==no?null:op(line,no)?(regChange(cm,no,no+1),line):null}function findPosH(doc,pos,dir,unit,visually){function findNextLine(){var l=line+dir;return l<doc.first||l>=doc.first+doc.size?possible=!1:(line=l,lineObj=getLine(doc,l))}function moveOnce(boundToLine){var next=(visually?moveVisually:moveLogically)(lineObj,ch,dir,!0);if(null==next){if(boundToLine||!findNextLine())return possible=!1;ch=visually?(dir<0?lineRight:lineLeft)(lineObj):dir<0?lineObj.text.length:0}else ch=next;return!0}var line=pos.line,ch=pos.ch,origDir=dir,lineObj=getLine(doc,line),possible=!0;if("char"==unit)moveOnce();else if("column"==unit)moveOnce(!0);else if("word"==unit||"group"==unit)for(var sawType=null,group="group"==unit,first=!0;!(dir<0)||moveOnce(!first);first=!1){var cur=lineObj.text.charAt(ch)||"\n",type=isWordChar(cur)?"w":group?/\s/.test(cur)?null:"p":null;if(sawType&&sawType!=type){dir<0&&(dir=1,moveOnce());break}if(type&&(sawType=type),dir>0&&!moveOnce(!first))break}var result=skipAtomic(doc,Pos(line,ch),origDir,!0);return possible||(result.hitSide=!0),result}function findPosV(cm,pos,dir,unit){var y,doc=cm.doc,x=pos.left;if("page"==unit){var pageSize=Math.min(cm.display.wrapper.clientHeight,window.innerHeight||document.documentElement.clientHeight);y=pos.top+dir*(pageSize-(dir<0?1.5:.5)*textHeight(cm.display))}else"line"==unit&&(y=dir>0?pos.bottom+3:pos.top-3);for(;;){var target=coordsChar(cm,x,y);if(!target.outside)break;if(dir<0?y<=0:y>=doc.height){target.hitSide=!0;break}y+=5*dir}return target}function findWordAt(line,pos){var start=pos.ch,end=pos.ch;if(line){(pos.xRel<0||end==line.length)&&start?--start:++end;for(var startChar=line.charAt(start),check=isWordChar(startChar)?isWordChar:/\s/.test(startChar)?function(ch){return/\s/.test(ch)}:function(ch){return!/\s/.test(ch)&&!isWordChar(ch)};start>0&&check(line.charAt(start-1));)--start;for(;end<line.length&&check(line.charAt(end));)++end}return{from:Pos(pos.line,start),to:Pos(pos.line,end)}}function selectLine(cm,line){extendSelection(cm.doc,Pos(line,0),clipPos(cm.doc,Pos(line+1,0)))}function option(name,deflt,handle,notOnInit){CodeMirror.defaults[name]=deflt,handle&&(optionHandlers[name]=notOnInit?function(cm,val,old){old!=Init&&handle(cm,val,old)}:handle)}function copyState(mode,state){if(state===!0)return state;if(mode.copyState)return mode.copyState(state);var nstate={};for(var n in state){var val=state[n];val instanceof Array&&(val=val.concat([])),nstate[n]=val}return nstate}function startState(mode,a1,a2){return!mode.startState||mode.startState(a1,a2)}function getKeyMap(val){return"string"==typeof val?keyMap[val]:val}function lookupKey(name,maps,handle){function lookup(map){map=getKeyMap(map);var found=map[name];if(found===!1)return"stop";if(null!=found&&handle(found))return!0;if(map.nofallthrough)return"stop";var fallthrough=map.fallthrough;if(null==fallthrough)return!1;if("[object Array]"!=Object.prototype.toString.call(fallthrough))return lookup(fallthrough);for(var i=0,e=fallthrough.length;i<e;++i){var done=lookup(fallthrough[i]);if(done)return done}return!1}for(var i=0;i<maps.length;++i){var done=lookup(maps[i]);if(done)return"stop"!=done}}function isModifierKey(event){var name=keyNames[event.keyCode];return"Ctrl"==name||"Alt"==name||"Shift"==name||"Mod"==name}function keyName(event,noShift){if(opera&&34==event.keyCode&&event.char)return!1;var name=keyNames[event.keyCode];return null!=name&&!event.altGraphKey&&(event.altKey&&(name="Alt-"+name),(flipCtrlCmd?event.metaKey:event.ctrlKey)&&(name="Ctrl-"+name),(flipCtrlCmd?event.ctrlKey:event.metaKey)&&(name="Cmd-"+name),!noShift&&event.shiftKey&&(name="Shift-"+name),name)}function StringStream(string,tabSize){this.pos=this.start=0,this.string=string,this.tabSize=tabSize||8,this.lastColumnPos=this.lastColumnValue=0}function TextMarker(doc,type){this.lines=[],this.type=type,this.doc=doc}function markText(doc,from,to,options,type){if(options&&options.shared)return markTextShared(doc,from,to,options,type);if(doc.cm&&!doc.cm.curOp)return operation(doc.cm,markText)(doc,from,to,options,type);var marker=new TextMarker(doc,type);if("range"==type&&!posLess(from,to))return marker;options&&copyObj(options,marker),marker.replacedWith&&(marker.collapsed=!0,marker.replacedWith=elt("span",[marker.replacedWith],"CodeMirror-widget"),options.handleMouseEvents||(marker.replacedWith.ignoreEvents=!0)),marker.collapsed&&(sawCollapsedSpans=!0),marker.addToHistory&&addToHistory(doc,{from:from,to:to,origin:"markText"},{head:doc.sel.head,anchor:doc.sel.anchor},NaN);var collapsedAtStart,collapsedAtEnd,updateMaxLine,curLine=from.line,size=0,cm=doc.cm;if(doc.iter(curLine,to.line+1,function(line){cm&&marker.collapsed&&!cm.options.lineWrapping&&visualLine(doc,line)==cm.display.maxLine&&(updateMaxLine=!0);var span={from:null,to:null,marker:marker};size+=line.text.length,curLine==from.line&&(span.from=from.ch,size-=from.ch),curLine==to.line&&(span.to=to.ch,size-=line.text.length-to.ch),marker.collapsed&&(curLine==to.line&&(collapsedAtEnd=collapsedSpanAt(line,to.ch)),curLine==from.line?collapsedAtStart=collapsedSpanAt(line,from.ch):updateLineHeight(line,0)),addMarkedSpan(line,span),++curLine}),marker.collapsed&&doc.iter(from.line,to.line+1,function(line){lineIsHidden(doc,line)&&updateLineHeight(line,0)}),marker.clearOnEnter&&on(marker,"beforeCursorEnter",function(){marker.clear()}),marker.readOnly&&(sawReadOnlySpans=!0,(doc.history.done.length||doc.history.undone.length)&&doc.clearHistory()),marker.collapsed){if(collapsedAtStart!=collapsedAtEnd)throw new Error("Inserting collapsed marker overlapping an existing one");marker.size=size,marker.atomic=!0}return cm&&(updateMaxLine&&(cm.curOp.updateMaxLine=!0),(marker.className||marker.title||marker.startStyle||marker.endStyle||marker.collapsed)&&regChange(cm,from.line,to.line+1),marker.atomic&&reCheckSelection(cm)),marker}function SharedTextMarker(markers,primary){this.markers=markers,this.primary=primary;for(var i=0,me=this;i<markers.length;++i)markers[i].parent=this,on(markers[i],"clear",function(){me.clear()})}function markTextShared(doc,from,to,options,type){options=copyObj(options),options.shared=!1;var markers=[markText(doc,from,to,options,type)],primary=markers[0],widget=options.replacedWith;return linkedDocs(doc,function(doc){widget&&(options.replacedWith=widget.cloneNode(!0)),markers.push(markText(doc,clipPos(doc,from),clipPos(doc,to),options,type));for(var i=0;i<doc.linked.length;++i)if(doc.linked[i].isParent)return;primary=lst(markers)}),new SharedTextMarker(markers,primary)}function getMarkedSpanFor(spans,marker){if(spans)for(var i=0;i<spans.length;++i){var span=spans[i];if(span.marker==marker)return span}}function removeMarkedSpan(spans,span){for(var r,i=0;i<spans.length;++i)spans[i]!=span&&(r||(r=[])).push(spans[i]);return r}function addMarkedSpan(line,span){line.markedSpans=line.markedSpans?line.markedSpans.concat([span]):[span],span.marker.attachLine(line)}function markedSpansBefore(old,startCh,isInsert){if(old)for(var nw,i=0;i<old.length;++i){var span=old[i],marker=span.marker,startsBefore=null==span.from||(marker.inclusiveLeft?span.from<=startCh:span.from<startCh);if(startsBefore||"bookmark"==marker.type&&span.from==startCh&&(!isInsert||!span.marker.insertLeft)){var endsAfter=null==span.to||(marker.inclusiveRight?span.to>=startCh:span.to>startCh);(nw||(nw=[])).push({from:span.from,to:endsAfter?null:span.to,marker:marker})}}return nw}function markedSpansAfter(old,endCh,isInsert){if(old)for(var nw,i=0;i<old.length;++i){var span=old[i],marker=span.marker,endsAfter=null==span.to||(marker.inclusiveRight?span.to>=endCh:span.to>endCh);if(endsAfter||"bookmark"==marker.type&&span.from==endCh&&(!isInsert||span.marker.insertLeft)){var startsBefore=null==span.from||(marker.inclusiveLeft?span.from<=endCh:span.from<endCh);(nw||(nw=[])).push({from:startsBefore?null:span.from-endCh,to:null==span.to?null:span.to-endCh,marker:marker})}}return nw}function stretchSpansOverChange(doc,change){var oldFirst=isLine(doc,change.from.line)&&getLine(doc,change.from.line).markedSpans,oldLast=isLine(doc,change.to.line)&&getLine(doc,change.to.line).markedSpans;if(!oldFirst&&!oldLast)return null;var startCh=change.from.ch,endCh=change.to.ch,isInsert=posEq(change.from,change.to),first=markedSpansBefore(oldFirst,startCh,isInsert),last=markedSpansAfter(oldLast,endCh,isInsert),sameLine=1==change.text.length,offset=lst(change.text).length+(sameLine?startCh:0);if(first)for(var i=0;i<first.length;++i){var span=first[i];if(null==span.to){var found=getMarkedSpanFor(last,span.marker);found?sameLine&&(span.to=null==found.to?null:found.to+offset):span.to=startCh}}if(last)for(var i=0;i<last.length;++i){var span=last[i];if(null!=span.to&&(span.to+=offset),null==span.from){var found=getMarkedSpanFor(first,span.marker);found||(span.from=offset,sameLine&&(first||(first=[])).push(span))}else span.from+=offset,sameLine&&(first||(first=[])).push(span)}if(sameLine&&first){for(var i=0;i<first.length;++i)null!=first[i].from&&first[i].from==first[i].to&&"bookmark"!=first[i].marker.type&&first.splice(i--,1);first.length||(first=null)}var newMarkers=[first];if(!sameLine){var gapMarkers,gap=change.text.length-2;if(gap>0&&first)for(var i=0;i<first.length;++i)null==first[i].to&&(gapMarkers||(gapMarkers=[])).push({from:null,to:null,marker:first[i].marker});for(var i=0;i<gap;++i)newMarkers.push(gapMarkers);newMarkers.push(last)}return newMarkers}function mergeOldSpans(doc,change){var old=getOldSpans(doc,change),stretched=stretchSpansOverChange(doc,change);if(!old)return stretched;if(!stretched)return old;for(var i=0;i<old.length;++i){var oldCur=old[i],stretchCur=stretched[i];if(oldCur&&stretchCur)spans:for(var j=0;j<stretchCur.length;++j){for(var span=stretchCur[j],k=0;k<oldCur.length;++k)if(oldCur[k].marker==span.marker)continue spans;oldCur.push(span)}else stretchCur&&(old[i]=stretchCur)}return old}function removeReadOnlyRanges(doc,from,to){var markers=null;if(doc.iter(from.line,to.line+1,function(line){if(line.markedSpans)for(var i=0;i<line.markedSpans.length;++i){var mark=line.markedSpans[i].marker;!mark.readOnly||markers&&indexOf(markers,mark)!=-1||(markers||(markers=[])).push(mark)}}),!markers)return null;for(var parts=[{from:from,to:to}],i=0;i<markers.length;++i)for(var mk=markers[i],m=mk.find(),j=0;j<parts.length;++j){var p=parts[j];if(!posLess(p.to,m.from)&&!posLess(m.to,p.from)){var newParts=[j,1];(posLess(p.from,m.from)||!mk.inclusiveLeft&&posEq(p.from,m.from))&&newParts.push({from:p.from,to:m.from}),(posLess(m.to,p.to)||!mk.inclusiveRight&&posEq(p.to,m.to))&&newParts.push({from:m.to,to:p.to}),parts.splice.apply(parts,newParts),j+=newParts.length-1}}return parts}function collapsedSpanAt(line,ch){var found,sps=sawCollapsedSpans&&line.markedSpans;if(sps)for(var sp,i=0;i<sps.length;++i)sp=sps[i],sp.marker.collapsed&&(null==sp.from||sp.from<ch)&&(null==sp.to||sp.to>ch)&&(!found||found.width<sp.marker.width)&&(found=sp.marker);return found}function collapsedSpanAtStart(line){return collapsedSpanAt(line,-1)}function collapsedSpanAtEnd(line){return collapsedSpanAt(line,line.text.length+1)}function visualLine(doc,line){for(var merged;merged=collapsedSpanAtStart(line);)line=getLine(doc,merged.find().from.line);return line}function lineIsHidden(doc,line){var sps=sawCollapsedSpans&&line.markedSpans;if(sps)for(var sp,i=0;i<sps.length;++i)if(sp=sps[i],sp.marker.collapsed){if(null==sp.from)return!0;if(!sp.marker.replacedWith&&0==sp.from&&sp.marker.inclusiveLeft&&lineIsHiddenInner(doc,line,sp))return!0}}function lineIsHiddenInner(doc,line,span){if(null==span.to){var end=span.marker.find().to,endLine=getLine(doc,end.line);return lineIsHiddenInner(doc,endLine,getMarkedSpanFor(endLine.markedSpans,span.marker))}if(span.marker.inclusiveRight&&span.to==line.text.length)return!0;for(var sp,i=0;i<line.markedSpans.length;++i)if(sp=line.markedSpans[i],sp.marker.collapsed&&!sp.marker.replacedWith&&sp.from==span.to&&(sp.marker.inclusiveLeft||span.marker.inclusiveRight)&&lineIsHiddenInner(doc,line,sp))return!0}function detachMarkedSpans(line){var spans=line.markedSpans;if(spans){for(var i=0;i<spans.length;++i)spans[i].marker.detachLine(line);line.markedSpans=null}}function attachMarkedSpans(line,spans){if(spans){for(var i=0;i<spans.length;++i)spans[i].marker.attachLine(line);line.markedSpans=spans}}function widgetOperation(f){return function(){var withOp=!this.cm.curOp;withOp&&startOperation(this.cm);try{var result=f.apply(this,arguments)}finally{withOp&&endOperation(this.cm)}return result}}function widgetHeight(widget){return null!=widget.height?widget.height:(widget.node.parentNode&&1==widget.node.parentNode.nodeType||removeChildrenAndAdd(widget.cm.display.measure,elt("div",[widget.node],null,"position: relative")),widget.height=widget.node.offsetHeight)}function addLineWidget(cm,handle,node,options){var widget=new LineWidget(cm,node,options);return widget.noHScroll&&(cm.display.alignWidgets=!0),changeLine(cm,handle,function(line){var widgets=line.widgets||(line.widgets=[]);if(null==widget.insertAt?widgets.push(widget):widgets.splice(Math.min(widgets.length-1,Math.max(0,widget.insertAt)),0,widget),widget.line=line,!lineIsHidden(cm.doc,line)||widget.showIfHidden){var aboveVisible=heightAtLine(cm,line)<cm.doc.scrollTop;updateLineHeight(line,line.height+widgetHeight(widget)),aboveVisible&&addToScrollPos(cm,0,widget.height)}return!0}),widget}function updateLine(line,text,markedSpans,estimateHeight){line.text=text,line.stateAfter&&(line.stateAfter=null),line.styles&&(line.styles=null),null!=line.order&&(line.order=null),detachMarkedSpans(line),attachMarkedSpans(line,markedSpans);var estHeight=estimateHeight?estimateHeight(line):1;estHeight!=line.height&&updateLineHeight(line,estHeight)}function cleanUpLine(line){line.parent=null,detachMarkedSpans(line)}function runMode(cm,text,mode,state,f){var flattenSpans=mode.flattenSpans;null==flattenSpans&&(flattenSpans=cm.options.flattenSpans);var style,curStart=0,curStyle=null,stream=new StringStream(text,cm.options.tabSize);for(""==text&&mode.blankLine&&mode.blankLine(state);!stream.eol();)stream.pos>cm.options.maxHighlightLength?(flattenSpans=!1,stream.pos=Math.min(text.length,stream.start+5e4),style=null):style=mode.token(stream,state),flattenSpans&&curStyle==style||(curStart<stream.start&&f(stream.start,curStyle),curStart=stream.start,curStyle=style),stream.start=stream.pos;curStart<stream.pos&&f(stream.pos,curStyle)}function highlightLine(cm,line,state){var st=[cm.state.modeGen];runMode(cm,line.text,cm.doc.mode,state,function(end,style){st.push(end,style)});for(var o=0;o<cm.state.overlays.length;++o){var overlay=cm.state.overlays[o],i=1,at=0;runMode(cm,line.text,overlay.mode,!0,function(end,style){for(var start=i;at<end;){var i_end=st[i];i_end>end&&st.splice(i,1,end,st[i+1],i_end),i+=2,at=Math.min(end,i_end)}if(style)if(overlay.opaque)st.splice(start,i-start,end,style),i=start+2;else for(;start<i;start+=2){var cur=st[start+1];st[start+1]=cur?cur+" "+style:style}})}return st}function getLineStyles(cm,line){return line.styles&&line.styles[0]==cm.state.modeGen||(line.styles=highlightLine(cm,line,line.stateAfter=getStateBefore(cm,lineNo(line)))),line.styles}function processLine(cm,line,state){var mode=cm.doc.mode,stream=new StringStream(line.text,cm.options.tabSize);for(""==line.text&&mode.blankLine&&mode.blankLine(state);!stream.eol()&&stream.pos<=cm.options.maxHighlightLength;)mode.token(stream,state),stream.start=stream.pos}function styleToClass(style){return style?styleToClassCache[style]||(styleToClassCache[style]="cm-"+style.replace(/ +/g," cm-")):null}function lineContent(cm,realLine,measure,copyWidgets){for(var merged,line=realLine,empty=!0;merged=collapsedSpanAtStart(line);)line=getLine(cm.doc,merged.find().from.line);var builder={pre:elt("pre"),col:0,pos:0,measure:null,measuredSomething:!1,cm:cm,copyWidgets:copyWidgets};line.textClass&&(builder.pre.className=line.textClass);do{line.text&&(empty=!1),builder.measure=line==realLine&&measure,builder.pos=0,builder.addToken=builder.measure?buildTokenMeasure:buildToken,(ie||webkit)&&cm.getOption("lineWrapping")&&(builder.addToken=buildTokenSplitSpaces(builder.addToken));var next=insertLineContent(line,builder,getLineStyles(cm,line));
measure&&line==realLine&&!builder.measuredSomething&&(measure[0]=builder.pre.appendChild(zeroWidthElement(cm.display.measure)),builder.measuredSomething=!0),next&&(line=getLine(cm.doc,next.to.line))}while(next);!measure||builder.measuredSomething||measure[0]||(measure[0]=builder.pre.appendChild(empty?elt("span"," "):zeroWidthElement(cm.display.measure))),builder.pre.firstChild||lineIsHidden(cm.doc,realLine)||builder.pre.appendChild(document.createTextNode(" "));var order;if(measure&&ie&&(order=getOrder(line))){var l=order.length-1;order[l].from==order[l].to&&--l;var last=order[l],prev=order[l-1];if(last.from+1==last.to&&prev&&last.level<prev.level){var span=measure[builder.pos-1];span&&span.parentNode.insertBefore(span.measureRight=zeroWidthElement(cm.display.measure),span.nextSibling)}}return signal(cm,"renderLine",cm,realLine,builder.pre),builder.pre}function buildToken(builder,text,style,startStyle,endStyle,title){if(text){if(tokenSpecialChars.test(text))for(var content=document.createDocumentFragment(),pos=0;;){tokenSpecialChars.lastIndex=pos;var m=tokenSpecialChars.exec(text),skipped=m?m.index-pos:text.length-pos;if(skipped&&(content.appendChild(document.createTextNode(text.slice(pos,pos+skipped))),builder.col+=skipped),!m)break;if(pos+=skipped+1,"\t"==m[0]){var tabSize=builder.cm.options.tabSize,tabWidth=tabSize-builder.col%tabSize;content.appendChild(elt("span",spaceStr(tabWidth),"cm-tab")),builder.col+=tabWidth}else{var token=elt("span","•","cm-invalidchar");token.title="\\u"+m[0].charCodeAt(0).toString(16),content.appendChild(token),builder.col+=1}}else{builder.col+=text.length;var content=document.createTextNode(text)}if(style||startStyle||endStyle||builder.measure){var fullStyle=style||"";startStyle&&(fullStyle+=startStyle),endStyle&&(fullStyle+=endStyle);var token=elt("span",[content],fullStyle);return title&&(token.title=title),builder.pre.appendChild(token)}builder.pre.appendChild(content)}}function buildTokenMeasure(builder,text,style,startStyle,endStyle){for(var wrapping=builder.cm.options.lineWrapping,i=0;i<text.length;++i){var ch=text.charAt(i),start=0==i;ch>="�"&&ch<"�"&&i<text.length-1?(ch=text.slice(i,i+2),++i):i&&wrapping&&spanAffectsWrapping(text,i)&&builder.pre.appendChild(elt("wbr"));var old=builder.measure[builder.pos],span=builder.measure[builder.pos]=buildToken(builder,ch,style,start&&startStyle,i==text.length-1&&endStyle);old&&(span.leftSide=old.leftSide||old),ie&&wrapping&&" "==ch&&i&&!/\s/.test(text.charAt(i-1))&&i<text.length-1&&!/\s/.test(text.charAt(i+1))&&(span.style.whiteSpace="normal"),builder.pos+=ch.length}text.length&&(builder.measuredSomething=!0)}function buildTokenSplitSpaces(inner){function split(old){for(var out=" ",i=0;i<old.length-2;++i)out+=i%2?" ":" ";return out+=" "}return function(builder,text,style,startStyle,endStyle,title){return inner(builder,text.replace(/ {3,}/,split),style,startStyle,endStyle,title)}}function buildCollapsedSpan(builder,size,marker,ignoreWidget){var widget=!ignoreWidget&&marker.replacedWith;if(widget&&(builder.copyWidgets&&(widget=widget.cloneNode(!0)),builder.pre.appendChild(widget),builder.measure)){if(size)builder.measure[builder.pos]=widget;else{var elt=builder.measure[builder.pos]=zeroWidthElement(builder.cm.display.measure);"bookmark"!=marker.type||marker.insertLeft?builder.pre.insertBefore(elt,widget):builder.pre.appendChild(elt)}builder.measuredSomething=!0}builder.pos+=size}function insertLineContent(line,builder,styles){var spans=line.markedSpans,allText=line.text,at=0;if(spans)for(var style,spanStyle,spanEndStyle,spanStartStyle,title,collapsed,len=allText.length,pos=0,i=1,text="",nextChange=0;;){if(nextChange==pos){spanStyle=spanEndStyle=spanStartStyle=title="",collapsed=null,nextChange=1/0;for(var foundBookmark=null,j=0;j<spans.length;++j){var sp=spans[j],m=sp.marker;sp.from<=pos&&(null==sp.to||sp.to>pos)?(null!=sp.to&&nextChange>sp.to&&(nextChange=sp.to,spanEndStyle=""),m.className&&(spanStyle+=" "+m.className),m.startStyle&&sp.from==pos&&(spanStartStyle+=" "+m.startStyle),m.endStyle&&sp.to==nextChange&&(spanEndStyle+=" "+m.endStyle),m.title&&!title&&(title=m.title),m.collapsed&&(!collapsed||collapsed.marker.size<m.size)&&(collapsed=sp)):sp.from>pos&&nextChange>sp.from&&(nextChange=sp.from),"bookmark"==m.type&&sp.from==pos&&m.replacedWith&&(foundBookmark=m)}if(collapsed&&(collapsed.from||0)==pos&&(buildCollapsedSpan(builder,(null==collapsed.to?len:collapsed.to)-pos,collapsed.marker,null==collapsed.from),null==collapsed.to))return collapsed.marker.find();foundBookmark&&!collapsed&&buildCollapsedSpan(builder,0,foundBookmark)}if(pos>=len)break;for(var upto=Math.min(len,nextChange);;){if(text){var end=pos+text.length;if(!collapsed){var tokenText=end>upto?text.slice(0,upto-pos):text;builder.addToken(builder,tokenText,style?style+spanStyle:spanStyle,spanStartStyle,pos+tokenText.length==nextChange?spanEndStyle:"",title)}if(end>=upto){text=text.slice(upto-pos),pos=upto;break}pos=end,spanStartStyle=""}text=allText.slice(at,at=styles[i++]),style=styleToClass(styles[i++])}}else for(var i=1;i<styles.length;i+=2)builder.addToken(builder,allText.slice(at,at=styles[i]),styleToClass(styles[i+1]))}function updateDoc(doc,change,markedSpans,selAfter,estimateHeight){function spansFor(n){return markedSpans?markedSpans[n]:null}function update(line,text,spans){updateLine(line,text,spans,estimateHeight),signalLater(line,"change",line,change)}var from=change.from,to=change.to,text=change.text,firstLine=getLine(doc,from.line),lastLine=getLine(doc,to.line),lastText=lst(text),lastSpans=spansFor(text.length-1),nlines=to.line-from.line;if(0==from.ch&&0==to.ch&&""==lastText){for(var i=0,e=text.length-1,added=[];i<e;++i)added.push(new Line(text[i],spansFor(i),estimateHeight));update(lastLine,lastLine.text,lastSpans),nlines&&doc.remove(from.line,nlines),added.length&&doc.insert(from.line,added)}else if(firstLine==lastLine)if(1==text.length)update(firstLine,firstLine.text.slice(0,from.ch)+lastText+firstLine.text.slice(to.ch),lastSpans);else{for(var added=[],i=1,e=text.length-1;i<e;++i)added.push(new Line(text[i],spansFor(i),estimateHeight));added.push(new Line(lastText+firstLine.text.slice(to.ch),lastSpans,estimateHeight)),update(firstLine,firstLine.text.slice(0,from.ch)+text[0],spansFor(0)),doc.insert(from.line+1,added)}else if(1==text.length)update(firstLine,firstLine.text.slice(0,from.ch)+text[0]+lastLine.text.slice(to.ch),spansFor(0)),doc.remove(from.line+1,nlines);else{update(firstLine,firstLine.text.slice(0,from.ch)+text[0],spansFor(0)),update(lastLine,lastText+lastLine.text.slice(to.ch),lastSpans);for(var i=1,e=text.length-1,added=[];i<e;++i)added.push(new Line(text[i],spansFor(i),estimateHeight));nlines>1&&doc.remove(from.line+1,nlines-1),doc.insert(from.line+1,added)}signalLater(doc,"change",doc,change),setSelection(doc,selAfter.anchor,selAfter.head,null,!0)}function LeafChunk(lines){this.lines=lines,this.parent=null;for(var i=0,e=lines.length,height=0;i<e;++i)lines[i].parent=this,height+=lines[i].height;this.height=height}function BranchChunk(children){this.children=children;for(var size=0,height=0,i=0,e=children.length;i<e;++i){var ch=children[i];size+=ch.chunkSize(),height+=ch.height,ch.parent=this}this.size=size,this.height=height,this.parent=null}function linkedDocs(doc,f,sharedHistOnly){function propagate(doc,skip,sharedHist){if(doc.linked)for(var i=0;i<doc.linked.length;++i){var rel=doc.linked[i];if(rel.doc!=skip){var shared=sharedHist&&rel.sharedHist;sharedHistOnly&&!shared||(f(rel.doc,shared),propagate(rel.doc,doc,shared))}}}propagate(doc,null,!0)}function attachDoc(cm,doc){if(doc.cm)throw new Error("This document is already in use.");cm.doc=doc,doc.cm=cm,estimateLineHeights(cm),loadMode(cm),cm.options.lineWrapping||computeMaxLength(cm),cm.options.mode=doc.modeOption,regChange(cm)}function getLine(chunk,n){for(n-=chunk.first;!chunk.lines;)for(var i=0;;++i){var child=chunk.children[i],sz=child.chunkSize();if(n<sz){chunk=child;break}n-=sz}return chunk.lines[n]}function getBetween(doc,start,end){var out=[],n=start.line;return doc.iter(start.line,end.line+1,function(line){var text=line.text;n==end.line&&(text=text.slice(0,end.ch)),n==start.line&&(text=text.slice(start.ch)),out.push(text),++n}),out}function getLines(doc,from,to){var out=[];return doc.iter(from,to,function(line){out.push(line.text)}),out}function updateLineHeight(line,height){for(var diff=height-line.height,n=line;n;n=n.parent)n.height+=diff}function lineNo(line){if(null==line.parent)return null;for(var cur=line.parent,no=indexOf(cur.lines,line),chunk=cur.parent;chunk;cur=chunk,chunk=chunk.parent)for(var i=0;chunk.children[i]!=cur;++i)no+=chunk.children[i].chunkSize();return no+cur.first}function lineAtHeight(chunk,h){var n=chunk.first;outer:do{for(var i=0,e=chunk.children.length;i<e;++i){var child=chunk.children[i],ch=child.height;if(h<ch){chunk=child;continue outer}h-=ch,n+=child.chunkSize()}return n}while(!chunk.lines);for(var i=0,e=chunk.lines.length;i<e;++i){var line=chunk.lines[i],lh=line.height;if(h<lh)break;h-=lh}return n+i}function heightAtLine(cm,lineObj){lineObj=visualLine(cm.doc,lineObj);for(var h=0,chunk=lineObj.parent,i=0;i<chunk.lines.length;++i){var line=chunk.lines[i];if(line==lineObj)break;h+=line.height}for(var p=chunk.parent;p;chunk=p,p=chunk.parent)for(var i=0;i<p.children.length;++i){var cur=p.children[i];if(cur==chunk)break;h+=cur.height}return h}function getOrder(line){var order=line.order;return null==order&&(order=line.order=bidiOrdering(line.text)),order}function makeHistory(startGen){return{done:[],undone:[],undoDepth:1/0,lastTime:0,lastOp:null,lastOrigin:null,generation:startGen||1,maxGeneration:startGen||1}}function attachLocalSpans(doc,change,from,to){var existing=change["spans_"+doc.id],n=0;doc.iter(Math.max(doc.first,from),Math.min(doc.first+doc.size,to),function(line){line.markedSpans&&((existing||(existing=change["spans_"+doc.id]={}))[n]=line.markedSpans),++n})}function historyChangeFromChange(doc,change){var from={line:change.from.line,ch:change.from.ch},histChange={from:from,to:changeEnd(change),text:getBetween(doc,change.from,change.to)};return attachLocalSpans(doc,histChange,change.from.line,change.to.line+1),linkedDocs(doc,function(doc){attachLocalSpans(doc,histChange,change.from.line,change.to.line+1)},!0),histChange}function addToHistory(doc,change,selAfter,opId){var hist=doc.history;hist.undone.length=0;var time=+new Date,cur=lst(hist.done);if(cur&&(hist.lastOp==opId||hist.lastOrigin==change.origin&&change.origin&&("+"==change.origin.charAt(0)&&doc.cm&&hist.lastTime>time-doc.cm.options.historyEventDelay||"*"==change.origin.charAt(0)))){var last=lst(cur.changes);posEq(change.from,change.to)&&posEq(change.from,last.to)?last.to=changeEnd(change):cur.changes.push(historyChangeFromChange(doc,change)),cur.anchorAfter=selAfter.anchor,cur.headAfter=selAfter.head}else for(cur={changes:[historyChangeFromChange(doc,change)],generation:hist.generation,anchorBefore:doc.sel.anchor,headBefore:doc.sel.head,anchorAfter:selAfter.anchor,headAfter:selAfter.head},hist.done.push(cur),hist.generation=++hist.maxGeneration;hist.done.length>hist.undoDepth;)hist.done.shift();hist.lastTime=time,hist.lastOp=opId,hist.lastOrigin=change.origin}function removeClearedSpans(spans){if(!spans)return null;for(var out,i=0;i<spans.length;++i)spans[i].marker.explicitlyCleared?out||(out=spans.slice(0,i)):out&&out.push(spans[i]);return out?out.length?out:null:spans}function getOldSpans(doc,change){var found=change["spans_"+doc.id];if(!found)return null;for(var i=0,nw=[];i<change.text.length;++i)nw.push(removeClearedSpans(found[i]));return nw}function copyHistoryArray(events,newGroup){for(var i=0,copy=[];i<events.length;++i){var event=events[i],changes=event.changes,newChanges=[];copy.push({changes:newChanges,anchorBefore:event.anchorBefore,headBefore:event.headBefore,anchorAfter:event.anchorAfter,headAfter:event.headAfter});for(var j=0;j<changes.length;++j){var m,change=changes[j];if(newChanges.push({from:change.from,to:change.to,text:change.text}),newGroup)for(var prop in change)(m=prop.match(/^spans_(\d+)$/))&&indexOf(newGroup,Number(m[1]))>-1&&(lst(newChanges)[prop]=change[prop],delete change[prop])}}return copy}function rebaseHistSel(pos,from,to,diff){to<pos.line?pos.line+=diff:from<pos.line&&(pos.line=from,pos.ch=0)}function rebaseHistArray(array,from,to,diff){for(var i=0;i<array.length;++i){for(var sub=array[i],ok=!0,j=0;j<sub.changes.length;++j){var cur=sub.changes[j];if(sub.copied||(cur.from=copyPos(cur.from),cur.to=copyPos(cur.to)),to<cur.from.line)cur.from.line+=diff,cur.to.line+=diff;else if(from<=cur.to.line){ok=!1;break}}sub.copied||(sub.anchorBefore=copyPos(sub.anchorBefore),sub.headBefore=copyPos(sub.headBefore),sub.anchorAfter=copyPos(sub.anchorAfter),sub.readAfter=copyPos(sub.headAfter),sub.copied=!0),ok?(rebaseHistSel(sub.anchorBefore),rebaseHistSel(sub.headBefore),rebaseHistSel(sub.anchorAfter),rebaseHistSel(sub.headAfter)):(array.splice(0,i+1),i=0)}}function rebaseHist(hist,change){var from=change.from.line,to=change.to.line,diff=change.text.length-(to-from)-1;rebaseHistArray(hist.done,from,to,diff),rebaseHistArray(hist.undone,from,to,diff)}function stopMethod(){e_stop(this)}function addStop(event){return event.stop||(event.stop=stopMethod),event}function e_preventDefault(e){e.preventDefault?e.preventDefault():e.returnValue=!1}function e_stopPropagation(e){e.stopPropagation?e.stopPropagation():e.cancelBubble=!0}function e_defaultPrevented(e){return null!=e.defaultPrevented?e.defaultPrevented:0==e.returnValue}function e_stop(e){e_preventDefault(e),e_stopPropagation(e)}function e_target(e){return e.target||e.srcElement}function e_button(e){var b=e.which;return null==b&&(1&e.button?b=1:2&e.button?b=3:4&e.button&&(b=2)),mac&&e.ctrlKey&&1==b&&(b=3),b}function on(emitter,type,f){if(emitter.addEventListener)emitter.addEventListener(type,f,!1);else if(emitter.attachEvent)emitter.attachEvent("on"+type,f);else{var map=emitter._handlers||(emitter._handlers={}),arr=map[type]||(map[type]=[]);arr.push(f)}}function off(emitter,type,f){if(emitter.removeEventListener)emitter.removeEventListener(type,f,!1);else if(emitter.detachEvent)emitter.detachEvent("on"+type,f);else{var arr=emitter._handlers&&emitter._handlers[type];if(!arr)return;for(var i=0;i<arr.length;++i)if(arr[i]==f){arr.splice(i,1);break}}}function signal(emitter,type){var arr=emitter._handlers&&emitter._handlers[type];if(arr)for(var args=Array.prototype.slice.call(arguments,2),i=0;i<arr.length;++i)arr[i].apply(null,args)}function signalLater(emitter,type){function bnd(f){return function(){f.apply(null,args)}}var arr=emitter._handlers&&emitter._handlers[type];if(arr){var args=Array.prototype.slice.call(arguments,2);delayedCallbacks||(++delayedCallbackDepth,delayedCallbacks=[],setTimeout(fireDelayed,0));for(var i=0;i<arr.length;++i)delayedCallbacks.push(bnd(arr[i]))}}function signalDOMEvent(cm,e,override){return signal(cm,override||e.type,cm,e),e_defaultPrevented(e)||e.codemirrorIgnore}function fireDelayed(){--delayedCallbackDepth;var delayed=delayedCallbacks;delayedCallbacks=null;for(var i=0;i<delayed.length;++i)delayed[i]()}function hasHandler(emitter,type){var arr=emitter._handlers&&emitter._handlers[type];return arr&&arr.length>0}function eventMixin(ctor){ctor.prototype.on=function(type,f){on(this,type,f)},ctor.prototype.off=function(type,f){off(this,type,f)}}function Delayed(){this.id=null}function countColumn(string,end,tabSize,startIndex,startValue){null==end&&(end=string.search(/[^\s\u00a0]/),end==-1&&(end=string.length));for(var i=startIndex||0,n=startValue||0;i<end;++i)"\t"==string.charAt(i)?n+=tabSize-n%tabSize:++n;return n}function spaceStr(n){for(;spaceStrs.length<=n;)spaceStrs.push(lst(spaceStrs)+" ");return spaceStrs[n]}function lst(arr){return arr[arr.length-1]}function selectInput(node){if(ios)node.selectionStart=0,node.selectionEnd=node.value.length;else try{node.select()}catch(_e){}}function indexOf(collection,elt){if(collection.indexOf)return collection.indexOf(elt);for(var i=0,e=collection.length;i<e;++i)if(collection[i]==elt)return i;return-1}function createObj(base,props){function Obj(){}Obj.prototype=base;var inst=new Obj;return props&&copyObj(props,inst),inst}function copyObj(obj,target){target||(target={});for(var prop in obj)obj.hasOwnProperty(prop)&&(target[prop]=obj[prop]);return target}function emptyArray(size){for(var a=[],i=0;i<size;++i)a.push(void 0);return a}function bind(f){var args=Array.prototype.slice.call(arguments,1);return function(){return f.apply(null,args)}}function isWordChar(ch){return/\w/.test(ch)||ch>""&&(ch.toUpperCase()!=ch.toLowerCase()||nonASCIISingleCaseWordChar.test(ch))}function isEmpty(obj){for(var n in obj)if(obj.hasOwnProperty(n)&&obj[n])return!1;return!0}function elt(tag,content,className,style){var e=document.createElement(tag);if(className&&(e.className=className),style&&(e.style.cssText=style),"string"==typeof content)setTextContent(e,content);else if(content)for(var i=0;i<content.length;++i)e.appendChild(content[i]);return e}function removeChildren(e){for(var count=e.childNodes.length;count>0;--count)e.removeChild(e.firstChild);return e}function removeChildrenAndAdd(parent,e){return removeChildren(parent).appendChild(e)}function setTextContent(e,str){ie_lt9?(e.innerHTML="",e.appendChild(document.createTextNode(str))):e.textContent=str}function getRect(node){return node.getBoundingClientRect()}function spanAffectsWrapping(){return!1}function scrollbarWidth(measure){if(null!=knownScrollbarWidth)return knownScrollbarWidth;var test=elt("div",null,null,"width: 50px; height: 50px; overflow-x: scroll");return removeChildrenAndAdd(measure,test),test.offsetWidth&&(knownScrollbarWidth=test.offsetHeight-test.clientHeight),knownScrollbarWidth||0}function zeroWidthElement(measure){if(null==zwspSupported){var test=elt("span","​");removeChildrenAndAdd(measure,elt("span",[test,document.createTextNode("x")])),0!=measure.firstChild.offsetHeight&&(zwspSupported=test.offsetWidth<=1&&test.offsetHeight>2&&!ie_lt8)}return zwspSupported?elt("span","​"):elt("span"," ",null,"display: inline-block; width: 1px; margin-right: -1px")}function iterateBidiSections(order,from,to,f){if(!order)return f(from,to,"ltr");for(var found=!1,i=0;i<order.length;++i){var part=order[i];(part.from<to&&part.to>from||from==to&&part.to==from)&&(f(Math.max(part.from,from),Math.min(part.to,to),1==part.level?"rtl":"ltr"),found=!0)}found||f(from,to,"ltr")}function bidiLeft(part){return part.level%2?part.to:part.from}function bidiRight(part){return part.level%2?part.from:part.to}function lineLeft(line){var order=getOrder(line);return order?bidiLeft(order[0]):0}function lineRight(line){var order=getOrder(line);return order?bidiRight(lst(order)):line.text.length}function lineStart(cm,lineN){var line=getLine(cm.doc,lineN),visual=visualLine(cm.doc,line);visual!=line&&(lineN=lineNo(visual));var order=getOrder(visual),ch=order?order[0].level%2?lineRight(visual):lineLeft(visual):0;return Pos(lineN,ch)}function lineEnd(cm,lineN){for(var merged,line;merged=collapsedSpanAtEnd(line=getLine(cm.doc,lineN));)lineN=merged.find().to.line;var order=getOrder(line),ch=order?order[0].level%2?lineLeft(line):lineRight(line):line.text.length;return Pos(lineN,ch)}function compareBidiLevel(order,a,b){var linedir=order[0].level;return a==linedir||b!=linedir&&a<b}function getBidiPartAt(order,pos){for(var found,i=0;i<order.length;++i){var cur=order[i];if(cur.from<pos&&cur.to>pos)return bidiOther=null,i;if(cur.from==pos||cur.to==pos){if(null!=found)return compareBidiLevel(order,cur.level,order[found].level)?(bidiOther=found,i):(bidiOther=i,found);found=i}}return bidiOther=null,found}function moveInLine(line,pos,dir,byUnit){if(!byUnit)return pos+dir;do pos+=dir;while(pos>0&&isExtendingChar.test(line.text.charAt(pos)));return pos}function moveVisually(line,start,dir,byUnit){var bidi=getOrder(line);if(!bidi)return moveLogically(line,start,dir,byUnit);for(var pos=getBidiPartAt(bidi,start),part=bidi[pos],target=moveInLine(line,start,part.level%2?-dir:dir,byUnit);;){if(target>part.from&&target<part.to)return target;if(target==part.from||target==part.to)return getBidiPartAt(bidi,target)==pos?target:(part=bidi[pos+=dir],dir>0==part.level%2?part.to:part.from);if(part=bidi[pos+=dir],!part)return null;target=dir>0==part.level%2?moveInLine(line,part.to,-1,byUnit):moveInLine(line,part.from,1,byUnit)}}function moveLogically(line,start,dir,byUnit){var target=start+dir;if(byUnit)for(;target>0&&isExtendingChar.test(line.text.charAt(target));)target+=dir;return target<0||target>line.text.length?null:target}var gecko=/gecko\/\d/i.test(navigator.userAgent),ie=/MSIE \d/.test(navigator.userAgent),ie_lt8=ie&&(null==document.documentMode||document.documentMode<8),ie_lt9=ie&&(null==document.documentMode||document.documentMode<9),webkit=/WebKit\//.test(navigator.userAgent),qtwebkit=webkit&&/Qt\/\d+\.\d+/.test(navigator.userAgent),chrome=/Chrome\//.test(navigator.userAgent),opera=/Opera\//.test(navigator.userAgent),safari=/Apple Computer/.test(navigator.vendor),khtml=/KHTML\//.test(navigator.userAgent),mac_geLion=/Mac OS X 1\d\D([7-9]|\d\d)\D/.test(navigator.userAgent),mac_geMountainLion=/Mac OS X 1\d\D([8-9]|\d\d)\D/.test(navigator.userAgent),phantom=/PhantomJS/.test(navigator.userAgent),ios=/AppleWebKit/.test(navigator.userAgent)&&/Mobile\/\w+/.test(navigator.userAgent),mobile=ios||/Android|webOS|BlackBerry|Opera Mini|Opera Mobi|IEMobile/i.test(navigator.userAgent),mac=ios||/Mac/.test(navigator.platform),windows=/windows/i.test(navigator.platform),opera_version=opera&&navigator.userAgent.match(/Version\/(\d*\.\d*)/);opera_version&&(opera_version=Number(opera_version[1])),opera_version&&opera_version>=15&&(opera=!1,webkit=!0);var measureText,lastClick,lastDoubleClick,flipCtrlCmd=mac&&(qtwebkit||opera&&(null==opera_version||opera_version<12.11)),captureMiddleClick=gecko||ie&&!ie_lt9,sawReadOnlySpans=!1,sawCollapsedSpans=!1,nextOpId=0,lastDrop=0,wheelSamples=0,wheelPixelsPerUnit=null;ie?wheelPixelsPerUnit=-.53:gecko?wheelPixelsPerUnit=15:chrome?wheelPixelsPerUnit=-.7:safari&&(wheelPixelsPerUnit=-1/3);var maybeTransition,detectingSelectAll,lastStoppedKey=null,changeEnd=CodeMirror.changeEnd=function(change){return change.text?Pos(change.from.line+change.text.length-1,lst(change.text).length+(1==change.text.length?change.from.ch:0)):change.to};CodeMirror.Pos=Pos,CodeMirror.prototype={constructor:CodeMirror,focus:function(){window.focus(),focusInput(this),onFocus(this),fastPoll(this)},setOption:function(option,value){var options=this.options,old=options[option];options[option]==value&&"mode"!=option||(options[option]=value,optionHandlers.hasOwnProperty(option)&&operation(this,optionHandlers[option])(this,value,old))},getOption:function(option){return this.options[option]},getDoc:function(){return this.doc},addKeyMap:function(map,bottom){this.state.keyMaps[bottom?"push":"unshift"](map)},removeKeyMap:function(map){for(var maps=this.state.keyMaps,i=0;i<maps.length;++i)if(maps[i]==map||"string"!=typeof maps[i]&&maps[i].name==map)return maps.splice(i,1),!0},addOverlay:operation(null,function(spec,options){var mode=spec.token?spec:CodeMirror.getMode(this.options,spec);if(mode.startState)throw new Error("Overlays may not be stateful.");this.state.overlays.push({mode:mode,modeSpec:spec,opaque:options&&options.opaque}),this.state.modeGen++,regChange(this)}),removeOverlay:operation(null,function(spec){for(var overlays=this.state.overlays,i=0;i<overlays.length;++i){var cur=overlays[i].modeSpec;if(cur==spec||"string"==typeof spec&&cur.name==spec)return overlays.splice(i,1),this.state.modeGen++,void regChange(this)}}),indentLine:operation(null,function(n,dir,aggressive){"string"!=typeof dir&&"number"!=typeof dir&&(dir=null==dir?this.options.smartIndent?"smart":"prev":dir?"add":"subtract"),isLine(this.doc,n)&&indentLine(this,n,dir,aggressive)}),indentSelection:operation(null,function(how){var sel=this.doc.sel;if(posEq(sel.from,sel.to))return indentLine(this,sel.from.line,how);for(var e=sel.to.line-(sel.to.ch?0:1),i=sel.from.line;i<=e;++i)indentLine(this,i,how)}),getTokenAt:function(pos,precise){var doc=this.doc;pos=clipPos(doc,pos);for(var state=getStateBefore(this,pos.line,precise),mode=this.doc.mode,line=getLine(doc,pos.line),stream=new StringStream(line.text,this.options.tabSize);stream.pos<pos.ch&&!stream.eol();){stream.start=stream.pos;var style=mode.token(stream,state)}return{start:stream.start,end:stream.pos,string:stream.current(),className:style||null,type:style||null,state:state}},getTokenTypeAt:function(pos){pos=clipPos(this.doc,pos);var styles=getLineStyles(this,getLine(this.doc,pos.line)),before=0,after=(styles.length-1)/2,ch=pos.ch;if(0==ch)return styles[2];for(;;){var mid=before+after>>1;if((mid?styles[2*mid-1]:0)>=ch)after=mid;else{if(!(styles[2*mid+1]<ch))return styles[2*mid+2];before=mid+1}}},getModeAt:function(pos){var mode=this.doc.mode;return mode.innerMode?CodeMirror.innerMode(mode,this.getTokenAt(pos).state).mode:mode},getHelper:function(pos,type){if(helpers.hasOwnProperty(type)){var help=helpers[type],mode=this.getModeAt(pos);return mode[type]&&help[mode[type]]||mode.helperType&&help[mode.helperType]||help[mode.name]}},getStateAfter:function(line,precise){var doc=this.doc;return line=clipLine(doc,null==line?doc.first+doc.size-1:line),getStateBefore(this,line+1,precise)},cursorCoords:function(start,mode){var pos,sel=this.doc.sel;return pos=null==start?sel.head:"object"==typeof start?clipPos(this.doc,start):start?sel.from:sel.to,cursorCoords(this,pos,mode||"page")},charCoords:function(pos,mode){return charCoords(this,clipPos(this.doc,pos),mode||"page")},coordsChar:function(coords,mode){return coords=fromCoordSystem(this,coords,mode||"page"),coordsChar(this,coords.left,coords.top)},lineAtHeight:function(height,mode){return height=fromCoordSystem(this,{top:height,left:0},mode||"page").top,lineAtHeight(this.doc,height+this.display.viewOffset)},heightAtLine:function(line,mode){var end=!1,last=this.doc.first+this.doc.size-1;line<this.doc.first?line=this.doc.first:line>last&&(line=last,end=!0);var lineObj=getLine(this.doc,line);return intoCoordSystem(this,getLine(this.doc,line),{top:0,left:0},mode||"page").top+(end?lineObj.height:0)},defaultTextHeight:function(){return textHeight(this.display)},defaultCharWidth:function(){return charWidth(this.display)},setGutterMarker:operation(null,function(line,gutterID,value){return changeLine(this,line,function(line){var markers=line.gutterMarkers||(line.gutterMarkers={});return markers[gutterID]=value,!value&&isEmpty(markers)&&(line.gutterMarkers=null),!0})}),clearGutter:operation(null,function(gutterID){var cm=this,doc=cm.doc,i=doc.first;doc.iter(function(line){line.gutterMarkers&&line.gutterMarkers[gutterID]&&(line.gutterMarkers[gutterID]=null,regChange(cm,i,i+1),isEmpty(line.gutterMarkers)&&(line.gutterMarkers=null)),++i})}),addLineClass:operation(null,function(handle,where,cls){return changeLine(this,handle,function(line){var prop="text"==where?"textClass":"background"==where?"bgClass":"wrapClass";if(line[prop]){if(new RegExp("(?:^|\\s)"+cls+"(?:$|\\s)").test(line[prop]))return!1;line[prop]+=" "+cls}else line[prop]=cls;return!0})}),removeLineClass:operation(null,function(handle,where,cls){return changeLine(this,handle,function(line){var prop="text"==where?"textClass":"background"==where?"bgClass":"wrapClass",cur=line[prop];if(!cur)return!1;if(null==cls)line[prop]=null;else{var found=cur.match(new RegExp("(?:^|\\s+)"+cls+"(?:$|\\s+)"));if(!found)return!1;var end=found.index+found[0].length;line[prop]=cur.slice(0,found.index)+(found.index&&end!=cur.length?" ":"")+cur.slice(end)||null}return!0})}),addLineWidget:operation(null,function(handle,node,options){return addLineWidget(this,handle,node,options)}),removeLineWidget:function(widget){widget.clear()},lineInfo:function(line){if("number"==typeof line){if(!isLine(this.doc,line))return null;var n=line;if(line=getLine(this.doc,line),!line)return null}else{var n=lineNo(line);if(null==n)return null}return{line:n,handle:line,text:line.text,gutterMarkers:line.gutterMarkers,textClass:line.textClass,bgClass:line.bgClass,wrapClass:line.wrapClass,widgets:line.widgets}},getViewport:function(){return{from:this.display.showingFrom,to:this.display.showingTo}},addWidget:function(pos,node,scroll,vert,horiz){var display=this.display;pos=cursorCoords(this,clipPos(this.doc,pos));var top=pos.bottom,left=pos.left;if(node.style.position="absolute",display.sizer.appendChild(node),"over"==vert)top=pos.top;else if("above"==vert||"near"==vert){var vspace=Math.max(display.wrapper.clientHeight,this.doc.height),hspace=Math.max(display.sizer.clientWidth,display.lineSpace.clientWidth);("above"==vert||pos.bottom+node.offsetHeight>vspace)&&pos.top>node.offsetHeight?top=pos.top-node.offsetHeight:pos.bottom+node.offsetHeight<=vspace&&(top=pos.bottom),left+node.offsetWidth>hspace&&(left=hspace-node.offsetWidth)}node.style.top=top+"px",node.style.left=node.style.right="","right"==horiz?(left=display.sizer.clientWidth-node.offsetWidth,node.style.right="0px"):("left"==horiz?left=0:"middle"==horiz&&(left=(display.sizer.clientWidth-node.offsetWidth)/2),node.style.left=left+"px"),scroll&&scrollIntoView(this,left,top,left+node.offsetWidth,top+node.offsetHeight)},triggerOnKeyDown:operation(null,onKeyDown),execCommand:function(cmd){return commands[cmd](this)},findPosH:function(from,amount,unit,visually){var dir=1;amount<0&&(dir=-1,amount=-amount);for(var i=0,cur=clipPos(this.doc,from);i<amount&&(cur=findPosH(this.doc,cur,dir,unit,visually),!cur.hitSide);++i);return cur},moveH:operation(null,function(dir,unit){var pos,sel=this.doc.sel;pos=sel.shift||sel.extend||posEq(sel.from,sel.to)?findPosH(this.doc,sel.head,dir,unit,this.options.rtlMoveVisually):dir<0?sel.from:sel.to,extendSelection(this.doc,pos,pos,dir)}),deleteH:operation(null,function(dir,unit){var sel=this.doc.sel;posEq(sel.from,sel.to)?replaceRange(this.doc,"",sel.from,findPosH(this.doc,sel.head,dir,unit,!1),"+delete"):replaceRange(this.doc,"",sel.from,sel.to,"+delete"),this.curOp.userSelChange=!0}),findPosV:function(from,amount,unit,goalColumn){var dir=1,x=goalColumn;amount<0&&(dir=-1,amount=-amount);for(var i=0,cur=clipPos(this.doc,from);i<amount;++i){var coords=cursorCoords(this,cur,"div");if(null==x?x=coords.left:coords.left=x,cur=findPosV(this,coords,dir,unit),cur.hitSide)break}return cur},moveV:operation(null,function(dir,unit){var sel=this.doc.sel,pos=cursorCoords(this,sel.head,"div");null!=sel.goalColumn&&(pos.left=sel.goalColumn);var target=findPosV(this,pos,dir,unit);"page"==unit&&addToScrollPos(this,0,charCoords(this,target,"div").top-pos.top),extendSelection(this.doc,target,target,dir),sel.goalColumn=pos.left}),toggleOverwrite:function(value){null!=value&&value==this.state.overwrite||((this.state.overwrite=!this.state.overwrite)?this.display.cursor.className+=" CodeMirror-overwrite":this.display.cursor.className=this.display.cursor.className.replace(" CodeMirror-overwrite",""))},hasFocus:function(){return this.state.focused},scrollTo:operation(null,function(x,y){updateScrollPos(this,x,y)}),getScrollInfo:function(){var scroller=this.display.scroller,co=scrollerCutOff;return{left:scroller.scrollLeft,top:scroller.scrollTop,height:scroller.scrollHeight-co,width:scroller.scrollWidth-co,clientHeight:scroller.clientHeight-co,clientWidth:scroller.clientWidth-co}},scrollIntoView:operation(null,function(pos,margin){"number"==typeof pos&&(pos=Pos(pos,0)),margin||(margin=0);var coords=pos;pos&&null==pos.line||(this.curOp.scrollToPos=pos?clipPos(this.doc,pos):this.doc.sel.head,this.curOp.scrollToPosMargin=margin,coords=cursorCoords(this,this.curOp.scrollToPos));var sPos=calculateScrollPos(this,coords.left,coords.top-margin,coords.right,coords.bottom+margin);updateScrollPos(this,sPos.scrollLeft,sPos.scrollTop)}),setSize:operation(null,function(width,height){function interpret(val){return"number"==typeof val||/^\d+$/.test(String(val))?val+"px":val}null!=width&&(this.display.wrapper.style.width=interpret(width)),null!=height&&(this.display.wrapper.style.height=interpret(height)),
this.options.lineWrapping&&(this.display.measureLineCache.length=this.display.measureLineCachePos=0),this.curOp.forceUpdate=!0}),operation:function(f){return runInOp(this,f)},refresh:operation(null,function(){clearCaches(this),updateScrollPos(this,this.doc.scrollLeft,this.doc.scrollTop),regChange(this)}),swapDoc:operation(null,function(doc){var old=this.doc;return old.cm=null,attachDoc(this,doc),clearCaches(this),resetInput(this,!0),updateScrollPos(this,doc.scrollLeft,doc.scrollTop),old}),getInputField:function(){return this.display.input},getWrapperElement:function(){return this.display.wrapper},getScrollerElement:function(){return this.display.scroller},getGutterElement:function(){return this.display.gutters}},eventMixin(CodeMirror);var optionHandlers=CodeMirror.optionHandlers={},defaults=CodeMirror.defaults={},Init=CodeMirror.Init={toString:function(){return"CodeMirror.Init"}};option("value","",function(cm,val){cm.setValue(val)},!0),option("mode",null,function(cm,val){cm.doc.modeOption=val,loadMode(cm)},!0),option("indentUnit",2,loadMode,!0),option("indentWithTabs",!1),option("smartIndent",!0),option("tabSize",4,function(cm){loadMode(cm),clearCaches(cm),regChange(cm)},!0),option("electricChars",!0),option("rtlMoveVisually",!windows),option("theme","default",function(cm){themeChanged(cm),guttersChanged(cm)},!0),option("keyMap","default",keyMapChanged),option("extraKeys",null),option("onKeyEvent",null),option("onDragEvent",null),option("lineWrapping",!1,wrappingChanged,!0),option("gutters",[],function(cm){setGuttersForLineNumbers(cm.options),guttersChanged(cm)},!0),option("fixedGutter",!0,function(cm,val){cm.display.gutters.style.left=val?compensateForHScroll(cm.display)+"px":"0",cm.refresh()},!0),option("coverGutterNextToScrollbar",!1,updateScrollbars,!0),option("lineNumbers",!1,function(cm){setGuttersForLineNumbers(cm.options),guttersChanged(cm)},!0),option("firstLineNumber",1,guttersChanged,!0),option("lineNumberFormatter",function(integer){return integer},guttersChanged,!0),option("showCursorWhenSelecting",!1,updateSelection,!0),option("readOnly",!1,function(cm,val){"nocursor"==val?(onBlur(cm),cm.display.input.blur()):val||resetInput(cm,!0)}),option("dragDrop",!0),option("cursorBlinkRate",530),option("cursorScrollMargin",0),option("cursorHeight",1),option("workTime",100),option("workDelay",100),option("flattenSpans",!0),option("pollInterval",100),option("undoDepth",40,function(cm,val){cm.doc.history.undoDepth=val}),option("historyEventDelay",500),option("viewportMargin",10,function(cm){cm.refresh()},!0),option("maxHighlightLength",1e4,function(cm){loadMode(cm),cm.refresh()},!0),option("moveInputWithCursor",!0,function(cm,val){val||(cm.display.inputDiv.style.top=cm.display.inputDiv.style.left=0)}),option("tabindex",null,function(cm,val){cm.display.input.tabIndex=val||""}),option("autofocus",null);var modes=CodeMirror.modes={},mimeModes=CodeMirror.mimeModes={};CodeMirror.defineMode=function(name,mode){if(CodeMirror.defaults.mode||"null"==name||(CodeMirror.defaults.mode=name),arguments.length>2){mode.dependencies=[];for(var i=2;i<arguments.length;++i)mode.dependencies.push(arguments[i])}modes[name]=mode},CodeMirror.defineMIME=function(mime,spec){mimeModes[mime]=spec},CodeMirror.resolveMode=function(spec){if("string"==typeof spec&&mimeModes.hasOwnProperty(spec))spec=mimeModes[spec];else if(spec&&"string"==typeof spec.name&&mimeModes.hasOwnProperty(spec.name)){var found=mimeModes[spec.name];spec=createObj(found,spec),spec.name=found.name}else if("string"==typeof spec&&/^[\w\-]+\/[\w\-]+\+xml$/.test(spec))return CodeMirror.resolveMode("application/xml");return"string"==typeof spec?{name:spec}:spec||{name:"null"}},CodeMirror.getMode=function(options,spec){var spec=CodeMirror.resolveMode(spec),mfactory=modes[spec.name];if(!mfactory)return CodeMirror.getMode(options,"text/plain");var modeObj=mfactory(options,spec);if(modeExtensions.hasOwnProperty(spec.name)){var exts=modeExtensions[spec.name];for(var prop in exts)exts.hasOwnProperty(prop)&&(modeObj.hasOwnProperty(prop)&&(modeObj["_"+prop]=modeObj[prop]),modeObj[prop]=exts[prop])}return modeObj.name=spec.name,modeObj},CodeMirror.defineMode("null",function(){return{token:function(stream){stream.skipToEnd()}}}),CodeMirror.defineMIME("text/plain","null");var modeExtensions=CodeMirror.modeExtensions={};CodeMirror.extendMode=function(mode,properties){var exts=modeExtensions.hasOwnProperty(mode)?modeExtensions[mode]:modeExtensions[mode]={};copyObj(properties,exts)},CodeMirror.defineExtension=function(name,func){CodeMirror.prototype[name]=func},CodeMirror.defineDocExtension=function(name,func){Doc.prototype[name]=func},CodeMirror.defineOption=option;var initHooks=[];CodeMirror.defineInitHook=function(f){initHooks.push(f)};var helpers=CodeMirror.helpers={};CodeMirror.registerHelper=function(type,name,value){helpers.hasOwnProperty(type)||(helpers[type]=CodeMirror[type]={}),helpers[type][name]=value},CodeMirror.isWordChar=isWordChar,CodeMirror.copyState=copyState,CodeMirror.startState=startState,CodeMirror.innerMode=function(mode,state){for(;mode.innerMode;){var info=mode.innerMode(state);if(!info||info.mode==mode)break;state=info.state,mode=info.mode}return info||{mode:mode,state:state}};var commands=CodeMirror.commands={selectAll:function(cm){cm.setSelection(Pos(cm.firstLine(),0),Pos(cm.lastLine()))},killLine:function(cm){var from=cm.getCursor(!0),to=cm.getCursor(!1),sel=!posEq(from,to);sel||cm.getLine(from.line).length!=from.ch?cm.replaceRange("",from,sel?to:Pos(from.line),"+delete"):cm.replaceRange("",from,Pos(from.line+1,0),"+delete")},deleteLine:function(cm){var l=cm.getCursor().line;cm.replaceRange("",Pos(l,0),Pos(l),"+delete")},delLineLeft:function(cm){var cur=cm.getCursor();cm.replaceRange("",Pos(cur.line,0),cur,"+delete")},undo:function(cm){cm.undo()},redo:function(cm){cm.redo()},goDocStart:function(cm){cm.extendSelection(Pos(cm.firstLine(),0))},goDocEnd:function(cm){cm.extendSelection(Pos(cm.lastLine()))},goLineStart:function(cm){cm.extendSelection(lineStart(cm,cm.getCursor().line))},goLineStartSmart:function(cm){var cur=cm.getCursor(),start=lineStart(cm,cur.line),line=cm.getLineHandle(start.line),order=getOrder(line);if(order&&0!=order[0].level)cm.extendSelection(start);else{var firstNonWS=Math.max(0,line.text.search(/\S/)),inWS=cur.line==start.line&&cur.ch<=firstNonWS&&cur.ch;cm.extendSelection(Pos(start.line,inWS?0:firstNonWS))}},goLineEnd:function(cm){cm.extendSelection(lineEnd(cm,cm.getCursor().line))},goLineRight:function(cm){var top=cm.charCoords(cm.getCursor(),"div").top+5;cm.extendSelection(cm.coordsChar({left:cm.display.lineDiv.offsetWidth+100,top:top},"div"))},goLineLeft:function(cm){var top=cm.charCoords(cm.getCursor(),"div").top+5;cm.extendSelection(cm.coordsChar({left:0,top:top},"div"))},goLineUp:function(cm){cm.moveV(-1,"line")},goLineDown:function(cm){cm.moveV(1,"line")},goPageUp:function(cm){cm.moveV(-1,"page")},goPageDown:function(cm){cm.moveV(1,"page")},goCharLeft:function(cm){cm.moveH(-1,"char")},goCharRight:function(cm){cm.moveH(1,"char")},goColumnLeft:function(cm){cm.moveH(-1,"column")},goColumnRight:function(cm){cm.moveH(1,"column")},goWordLeft:function(cm){cm.moveH(-1,"word")},goGroupRight:function(cm){cm.moveH(1,"group")},goGroupLeft:function(cm){cm.moveH(-1,"group")},goWordRight:function(cm){cm.moveH(1,"word")},delCharBefore:function(cm){cm.deleteH(-1,"char")},delCharAfter:function(cm){cm.deleteH(1,"char")},delWordBefore:function(cm){cm.deleteH(-1,"word")},delWordAfter:function(cm){cm.deleteH(1,"word")},delGroupBefore:function(cm){cm.deleteH(-1,"group")},delGroupAfter:function(cm){cm.deleteH(1,"group")},indentAuto:function(cm){cm.indentSelection("smart")},indentMore:function(cm){cm.indentSelection("add")},indentLess:function(cm){cm.indentSelection("subtract")},insertTab:function(cm){cm.replaceSelection("\t","end","+input")},defaultTab:function(cm){cm.somethingSelected()?cm.indentSelection("add"):cm.replaceSelection("\t","end","+input")},transposeChars:function(cm){var cur=cm.getCursor(),line=cm.getLine(cur.line);cur.ch>0&&cur.ch<line.length-1&&cm.replaceRange(line.charAt(cur.ch)+line.charAt(cur.ch-1),Pos(cur.line,cur.ch-1),Pos(cur.line,cur.ch+1))},newlineAndIndent:function(cm){operation(cm,function(){cm.replaceSelection("\n","end","+input"),cm.indentLine(cm.getCursor().line,null,!0)})()},toggleOverwrite:function(cm){cm.toggleOverwrite()}},keyMap=CodeMirror.keyMap={};keyMap.basic={Left:"goCharLeft",Right:"goCharRight",Up:"goLineUp",Down:"goLineDown",End:"goLineEnd",Home:"goLineStartSmart",PageUp:"goPageUp",PageDown:"goPageDown",Delete:"delCharAfter",Backspace:"delCharBefore",Tab:"defaultTab","Shift-Tab":"indentAuto",Enter:"newlineAndIndent",Insert:"toggleOverwrite"},keyMap.pcDefault={"Ctrl-A":"selectAll","Ctrl-D":"deleteLine","Ctrl-Z":"undo","Shift-Ctrl-Z":"redo","Ctrl-Y":"redo","Ctrl-Home":"goDocStart","Alt-Up":"goDocStart","Ctrl-End":"goDocEnd","Ctrl-Down":"goDocEnd","Ctrl-Left":"goGroupLeft","Ctrl-Right":"goGroupRight","Alt-Left":"goLineStart","Alt-Right":"goLineEnd","Ctrl-Backspace":"delGroupBefore","Ctrl-Delete":"delGroupAfter","Ctrl-S":"save","Ctrl-F":"find","Ctrl-G":"findNext","Shift-Ctrl-G":"findPrev","Shift-Ctrl-F":"replace","Shift-Ctrl-R":"replaceAll","Ctrl-[":"indentLess","Ctrl-]":"indentMore",fallthrough:"basic"},keyMap.macDefault={"Cmd-A":"selectAll","Cmd-D":"deleteLine","Cmd-Z":"undo","Shift-Cmd-Z":"redo","Cmd-Y":"redo","Cmd-Up":"goDocStart","Cmd-End":"goDocEnd","Cmd-Down":"goDocEnd","Alt-Left":"goGroupLeft","Alt-Right":"goGroupRight","Cmd-Left":"goLineStart","Cmd-Right":"goLineEnd","Alt-Backspace":"delGroupBefore","Ctrl-Alt-Backspace":"delGroupAfter","Alt-Delete":"delGroupAfter","Cmd-S":"save","Cmd-F":"find","Cmd-G":"findNext","Shift-Cmd-G":"findPrev","Cmd-Alt-F":"replace","Shift-Cmd-Alt-F":"replaceAll","Cmd-[":"indentLess","Cmd-]":"indentMore","Cmd-Backspace":"delLineLeft",fallthrough:["basic","emacsy"]},keyMap.default=mac?keyMap.macDefault:keyMap.pcDefault,keyMap.emacsy={"Ctrl-F":"goCharRight","Ctrl-B":"goCharLeft","Ctrl-P":"goLineUp","Ctrl-N":"goLineDown","Alt-F":"goWordRight","Alt-B":"goWordLeft","Ctrl-A":"goLineStart","Ctrl-E":"goLineEnd","Ctrl-V":"goPageDown","Shift-Ctrl-V":"goPageUp","Ctrl-D":"delCharAfter","Ctrl-H":"delCharBefore","Alt-D":"delWordAfter","Alt-Backspace":"delWordBefore","Ctrl-K":"killLine","Ctrl-T":"transposeChars"},CodeMirror.lookupKey=lookupKey,CodeMirror.isModifierKey=isModifierKey,CodeMirror.keyName=keyName,CodeMirror.fromTextArea=function(textarea,options){function save(){textarea.value=cm.getValue()}if(options||(options={}),options.value=textarea.value,!options.tabindex&&textarea.tabindex&&(options.tabindex=textarea.tabindex),!options.placeholder&&textarea.placeholder&&(options.placeholder=textarea.placeholder),null==options.autofocus){var hasFocus=document.body;try{hasFocus=document.activeElement}catch(e){}options.autofocus=hasFocus==textarea||null!=textarea.getAttribute("autofocus")&&hasFocus==document.body}if(textarea.form&&(on(textarea.form,"submit",save),!options.leaveSubmitMethodAlone)){var form=textarea.form,realSubmit=form.submit;try{var wrappedSubmit=form.submit=function(){save(),form.submit=realSubmit,form.submit(),form.submit=wrappedSubmit}}catch(e){}}textarea.style.display="none";var cm=CodeMirror(function(node){textarea.parentNode.insertBefore(node,textarea.nextSibling)},options);return cm.save=save,cm.getTextArea=function(){return textarea},cm.toTextArea=function(){save(),textarea.parentNode.removeChild(cm.getWrapperElement()),textarea.style.display="",textarea.form&&(off(textarea.form,"submit",save),"function"==typeof textarea.form.submit&&(textarea.form.submit=realSubmit))},cm},StringStream.prototype={eol:function(){return this.pos>=this.string.length},sol:function(){return 0==this.pos},peek:function(){return this.string.charAt(this.pos)||void 0},next:function(){if(this.pos<this.string.length)return this.string.charAt(this.pos++)},eat:function(match){var ch=this.string.charAt(this.pos);if("string"==typeof match)var ok=ch==match;else var ok=ch&&(match.test?match.test(ch):match(ch));if(ok)return++this.pos,ch},eatWhile:function(match){for(var start=this.pos;this.eat(match););return this.pos>start},eatSpace:function(){for(var start=this.pos;/[\s\u00a0]/.test(this.string.charAt(this.pos));)++this.pos;return this.pos>start},skipToEnd:function(){this.pos=this.string.length},skipTo:function(ch){var found=this.string.indexOf(ch,this.pos);if(found>-1)return this.pos=found,!0},backUp:function(n){this.pos-=n},column:function(){return this.lastColumnPos<this.start&&(this.lastColumnValue=countColumn(this.string,this.start,this.tabSize,this.lastColumnPos,this.lastColumnValue),this.lastColumnPos=this.start),this.lastColumnValue},indentation:function(){return countColumn(this.string,null,this.tabSize)},match:function(pattern,consume,caseInsensitive){if("string"!=typeof pattern){var match=this.string.slice(this.pos).match(pattern);return match&&match.index>0?null:(match&&consume!==!1&&(this.pos+=match[0].length),match)}var cased=function(str){return caseInsensitive?str.toLowerCase():str},substr=this.string.substr(this.pos,pattern.length);if(cased(substr)==cased(pattern))return consume!==!1&&(this.pos+=pattern.length),!0},current:function(){return this.string.slice(this.start,this.pos)}},CodeMirror.StringStream=StringStream,CodeMirror.TextMarker=TextMarker,eventMixin(TextMarker),TextMarker.prototype.clear=function(){if(!this.explicitlyCleared){var cm=this.doc.cm,withOp=cm&&!cm.curOp;if(withOp&&startOperation(cm),hasHandler(this,"clear")){var found=this.find();found&&signalLater(this,"clear",found.from,found.to)}for(var min=null,max=null,i=0;i<this.lines.length;++i){var line=this.lines[i],span=getMarkedSpanFor(line.markedSpans,this);null!=span.to&&(max=lineNo(line)),line.markedSpans=removeMarkedSpan(line.markedSpans,span),null!=span.from?min=lineNo(line):this.collapsed&&!lineIsHidden(this.doc,line)&&cm&&updateLineHeight(line,textHeight(cm.display))}if(cm&&this.collapsed&&!cm.options.lineWrapping)for(var i=0;i<this.lines.length;++i){var visual=visualLine(cm.doc,this.lines[i]),len=lineLength(cm.doc,visual);len>cm.display.maxLineLength&&(cm.display.maxLine=visual,cm.display.maxLineLength=len,cm.display.maxLineChanged=!0)}null!=min&&cm&&regChange(cm,min,max+1),this.lines.length=0,this.explicitlyCleared=!0,this.atomic&&this.doc.cantEdit&&(this.doc.cantEdit=!1,cm&&reCheckSelection(cm)),withOp&&endOperation(cm)}},TextMarker.prototype.find=function(){for(var from,to,i=0;i<this.lines.length;++i){var line=this.lines[i],span=getMarkedSpanFor(line.markedSpans,this);if(null!=span.from||null!=span.to){var found=lineNo(line);null!=span.from&&(from=Pos(found,span.from)),null!=span.to&&(to=Pos(found,span.to))}}return"bookmark"==this.type?from:from&&{from:from,to:to}},TextMarker.prototype.changed=function(){var pos=this.find(),cm=this.doc.cm;if(pos&&cm){var line=getLine(this.doc,pos.from.line);if(clearCachedMeasurement(cm,line),pos.from.line>=cm.display.showingFrom&&pos.from.line<cm.display.showingTo){for(var node=cm.display.lineDiv.firstChild;node;node=node.nextSibling)if(node.lineObj==line){node.offsetHeight!=line.height&&updateLineHeight(line,node.offsetHeight);break}runInOp(cm,function(){cm.curOp.selectionChanged=cm.curOp.forceUpdate=cm.curOp.updateMaxLine=!0})}}},TextMarker.prototype.attachLine=function(line){if(!this.lines.length&&this.doc.cm){var op=this.doc.cm.curOp;op.maybeHiddenMarkers&&indexOf(op.maybeHiddenMarkers,this)!=-1||(op.maybeUnhiddenMarkers||(op.maybeUnhiddenMarkers=[])).push(this)}this.lines.push(line)},TextMarker.prototype.detachLine=function(line){if(this.lines.splice(indexOf(this.lines,line),1),!this.lines.length&&this.doc.cm){var op=this.doc.cm.curOp;(op.maybeHiddenMarkers||(op.maybeHiddenMarkers=[])).push(this)}},CodeMirror.SharedTextMarker=SharedTextMarker,eventMixin(SharedTextMarker),SharedTextMarker.prototype.clear=function(){if(!this.explicitlyCleared){this.explicitlyCleared=!0;for(var i=0;i<this.markers.length;++i)this.markers[i].clear();signalLater(this,"clear")}},SharedTextMarker.prototype.find=function(){return this.primary.find()};var LineWidget=CodeMirror.LineWidget=function(cm,node,options){if(options)for(var opt in options)options.hasOwnProperty(opt)&&(this[opt]=options[opt]);this.cm=cm,this.node=node};eventMixin(LineWidget),LineWidget.prototype.clear=widgetOperation(function(){var ws=this.line.widgets,no=lineNo(this.line);if(null!=no&&ws){for(var i=0;i<ws.length;++i)ws[i]==this&&ws.splice(i--,1);ws.length||(this.line.widgets=null);var aboveVisible=heightAtLine(this.cm,this.line)<this.cm.doc.scrollTop;updateLineHeight(this.line,Math.max(0,this.line.height-widgetHeight(this))),aboveVisible&&addToScrollPos(this.cm,0,-this.height),regChange(this.cm,no,no+1)}}),LineWidget.prototype.changed=widgetOperation(function(){var oldH=this.height;this.height=null;var diff=widgetHeight(this)-oldH;if(diff){updateLineHeight(this.line,this.line.height+diff);var no=lineNo(this.line);regChange(this.cm,no,no+1)}});var Line=CodeMirror.Line=function(text,markedSpans,estimateHeight){this.text=text,attachMarkedSpans(this,markedSpans),this.height=estimateHeight?estimateHeight(this):1};eventMixin(Line);var styleToClassCache={},tokenSpecialChars=/[\t\u0000-\u0019\u00ad\u200b\u2028\u2029\uFEFF]/g;LeafChunk.prototype={chunkSize:function(){return this.lines.length},removeInner:function(at,n){for(var i=at,e=at+n;i<e;++i){var line=this.lines[i];this.height-=line.height,cleanUpLine(line),signalLater(line,"delete")}this.lines.splice(at,n)},collapse:function(lines){lines.splice.apply(lines,[lines.length,0].concat(this.lines))},insertInner:function(at,lines,height){this.height+=height,this.lines=this.lines.slice(0,at).concat(lines).concat(this.lines.slice(at));for(var i=0,e=lines.length;i<e;++i)lines[i].parent=this},iterN:function(at,n,op){for(var e=at+n;at<e;++at)if(op(this.lines[at]))return!0}},BranchChunk.prototype={chunkSize:function(){return this.size},removeInner:function(at,n){this.size-=n;for(var i=0;i<this.children.length;++i){var child=this.children[i],sz=child.chunkSize();if(at<sz){var rm=Math.min(n,sz-at),oldHeight=child.height;if(child.removeInner(at,rm),this.height-=oldHeight-child.height,sz==rm&&(this.children.splice(i--,1),child.parent=null),0==(n-=rm))break;at=0}else at-=sz}if(this.size-n<25){var lines=[];this.collapse(lines),this.children=[new LeafChunk(lines)],this.children[0].parent=this}},collapse:function(lines){for(var i=0,e=this.children.length;i<e;++i)this.children[i].collapse(lines)},insertInner:function(at,lines,height){this.size+=lines.length,this.height+=height;for(var i=0,e=this.children.length;i<e;++i){var child=this.children[i],sz=child.chunkSize();if(at<=sz){if(child.insertInner(at,lines,height),child.lines&&child.lines.length>50){for(;child.lines.length>50;){var spilled=child.lines.splice(child.lines.length-25,25),newleaf=new LeafChunk(spilled);child.height-=newleaf.height,this.children.splice(i+1,0,newleaf),newleaf.parent=this}this.maybeSpill()}break}at-=sz}},maybeSpill:function(){if(!(this.children.length<=10)){var me=this;do{var spilled=me.children.splice(me.children.length-5,5),sibling=new BranchChunk(spilled);if(me.parent){me.size-=sibling.size,me.height-=sibling.height;var myIndex=indexOf(me.parent.children,me);me.parent.children.splice(myIndex+1,0,sibling)}else{var copy=new BranchChunk(me.children);copy.parent=me,me.children=[copy,sibling],me=copy}sibling.parent=me.parent}while(me.children.length>10);me.parent.maybeSpill()}},iterN:function(at,n,op){for(var i=0,e=this.children.length;i<e;++i){var child=this.children[i],sz=child.chunkSize();if(at<sz){var used=Math.min(n,sz-at);if(child.iterN(at,used,op))return!0;if(0==(n-=used))break;at=0}else at-=sz}}};var nextDocId=0,Doc=CodeMirror.Doc=function(text,mode,firstLine){if(!(this instanceof Doc))return new Doc(text,mode,firstLine);null==firstLine&&(firstLine=0),BranchChunk.call(this,[new LeafChunk([new Line("",null)])]),this.first=firstLine,this.scrollTop=this.scrollLeft=0,this.cantEdit=!1,this.history=makeHistory(),this.cleanGeneration=1,this.frontier=firstLine;var start=Pos(firstLine,0);this.sel={from:start,to:start,head:start,anchor:start,shift:!1,extend:!1,goalColumn:null},this.id=++nextDocId,this.modeOption=mode,"string"==typeof text&&(text=splitLines(text)),updateDoc(this,{from:start,to:start,text:text},null,{head:start,anchor:start})};Doc.prototype=createObj(BranchChunk.prototype,{constructor:Doc,iter:function(from,to,op){op?this.iterN(from-this.first,to-from,op):this.iterN(this.first,this.first+this.size,from)},insert:function(at,lines){for(var height=0,i=0,e=lines.length;i<e;++i)height+=lines[i].height;this.insertInner(at-this.first,lines,height)},remove:function(at,n){this.removeInner(at-this.first,n)},getValue:function(lineSep){var lines=getLines(this,this.first,this.first+this.size);return lineSep===!1?lines:lines.join(lineSep||"\n")},setValue:function(code){var top=Pos(this.first,0),last=this.first+this.size-1;makeChange(this,{from:top,to:Pos(last,getLine(this,last).text.length),text:splitLines(code),origin:"setValue"},{head:top,anchor:top},!0)},replaceRange:function(code,from,to,origin){from=clipPos(this,from),to=to?clipPos(this,to):from,replaceRange(this,code,from,to,origin)},getRange:function(from,to,lineSep){var lines=getBetween(this,clipPos(this,from),clipPos(this,to));return lineSep===!1?lines:lines.join(lineSep||"\n")},getLine:function(line){var l=this.getLineHandle(line);return l&&l.text},setLine:function(line,text){isLine(this,line)&&replaceRange(this,text,Pos(line,0),clipPos(this,Pos(line)))},removeLine:function(line){line?replaceRange(this,"",clipPos(this,Pos(line-1)),clipPos(this,Pos(line))):replaceRange(this,"",Pos(0,0),clipPos(this,Pos(1,0)))},getLineHandle:function(line){if(isLine(this,line))return getLine(this,line)},getLineNumber:function(line){return lineNo(line)},getLineHandleVisualStart:function(line){return"number"==typeof line&&(line=getLine(this,line)),visualLine(this,line)},lineCount:function(){return this.size},firstLine:function(){return this.first},lastLine:function(){return this.first+this.size-1},clipPos:function(pos){return clipPos(this,pos)},getCursor:function(start){var pos,sel=this.sel;return pos=null==start||"head"==start?sel.head:"anchor"==start?sel.anchor:"end"==start||start===!1?sel.to:sel.from,copyPos(pos)},somethingSelected:function(){return!posEq(this.sel.head,this.sel.anchor)},setCursor:docOperation(function(line,ch,extend){var pos=clipPos(this,"number"==typeof line?Pos(line,ch||0):line);extend?extendSelection(this,pos):setSelection(this,pos,pos)}),setSelection:docOperation(function(anchor,head){setSelection(this,clipPos(this,anchor),clipPos(this,head||anchor))}),extendSelection:docOperation(function(from,to){extendSelection(this,clipPos(this,from),to&&clipPos(this,to))}),getSelection:function(lineSep){return this.getRange(this.sel.from,this.sel.to,lineSep)},replaceSelection:function(code,collapse,origin){makeChange(this,{from:this.sel.from,to:this.sel.to,text:splitLines(code),origin:origin},collapse||"around")},undo:docOperation(function(){makeChangeFromHistory(this,"undo")}),redo:docOperation(function(){makeChangeFromHistory(this,"redo")}),setExtending:function(val){this.sel.extend=val},historySize:function(){var hist=this.history;return{undo:hist.done.length,redo:hist.undone.length}},clearHistory:function(){this.history=makeHistory(this.history.maxGeneration)},markClean:function(){this.cleanGeneration=this.changeGeneration()},changeGeneration:function(){return this.history.lastOp=this.history.lastOrigin=null,this.history.generation},isClean:function(gen){return this.history.generation==(gen||this.cleanGeneration)},getHistory:function(){return{done:copyHistoryArray(this.history.done),undone:copyHistoryArray(this.history.undone)}},setHistory:function(histData){var hist=this.history=makeHistory(this.history.maxGeneration);hist.done=histData.done.slice(0),hist.undone=histData.undone.slice(0)},markText:function(from,to,options){return markText(this,clipPos(this,from),clipPos(this,to),options,"range")},setBookmark:function(pos,options){var realOpts={replacedWith:options&&(null==options.nodeType?options.widget:options),insertLeft:options&&options.insertLeft};return pos=clipPos(this,pos),markText(this,pos,pos,realOpts,"bookmark")},findMarksAt:function(pos){pos=clipPos(this,pos);var markers=[],spans=getLine(this,pos.line).markedSpans;if(spans)for(var i=0;i<spans.length;++i){var span=spans[i];(null==span.from||span.from<=pos.ch)&&(null==span.to||span.to>=pos.ch)&&markers.push(span.marker.parent||span.marker)}return markers},getAllMarks:function(){var markers=[];return this.iter(function(line){var sps=line.markedSpans;if(sps)for(var i=0;i<sps.length;++i)null!=sps[i].from&&markers.push(sps[i].marker)}),markers},posFromIndex:function(off){var ch,lineNo=this.first;return this.iter(function(line){var sz=line.text.length+1;return sz>off?(ch=off,!0):(off-=sz,void++lineNo)}),clipPos(this,Pos(lineNo,ch))},indexFromPos:function(coords){coords=clipPos(this,coords);var index=coords.ch;return coords.line<this.first||coords.ch<0?0:(this.iter(this.first,coords.line,function(line){index+=line.text.length+1}),index)},copy:function(copyHistory){var doc=new Doc(getLines(this,this.first,this.first+this.size),this.modeOption,this.first);return doc.scrollTop=this.scrollTop,doc.scrollLeft=this.scrollLeft,doc.sel={from:this.sel.from,to:this.sel.to,head:this.sel.head,anchor:this.sel.anchor,shift:this.sel.shift,extend:!1,goalColumn:this.sel.goalColumn},copyHistory&&(doc.history.undoDepth=this.history.undoDepth,doc.setHistory(this.getHistory())),doc},linkedDoc:function(options){options||(options={});var from=this.first,to=this.first+this.size;null!=options.from&&options.from>from&&(from=options.from),null!=options.to&&options.to<to&&(to=options.to);var copy=new Doc(getLines(this,from,to),options.mode||this.modeOption,from);return options.sharedHist&&(copy.history=this.history),(this.linked||(this.linked=[])).push({doc:copy,sharedHist:options.sharedHist}),copy.linked=[{doc:this,isParent:!0,sharedHist:options.sharedHist}],copy},unlinkDoc:function(other){if(other instanceof CodeMirror&&(other=other.doc),this.linked)for(var i=0;i<this.linked.length;++i){var link=this.linked[i];if(link.doc==other){this.linked.splice(i,1),other.unlinkDoc(this);break}}if(other.history==this.history){var splitIds=[other.id];linkedDocs(other,function(doc){splitIds.push(doc.id)},!0),other.history=makeHistory(),other.history.done=copyHistoryArray(this.history.done,splitIds),other.history.undone=copyHistoryArray(this.history.undone,splitIds)}},iterLinkedDocs:function(f){linkedDocs(this,f)},getMode:function(){return this.mode},getEditor:function(){return this.cm}}),Doc.prototype.eachLine=Doc.prototype.iter;var dontDelegate="iter insert remove copy getEditor".split(" ");for(var prop in Doc.prototype)Doc.prototype.hasOwnProperty(prop)&&indexOf(dontDelegate,prop)<0&&(CodeMirror.prototype[prop]=function(method){return function(){return method.apply(this.doc,arguments)}}(Doc.prototype[prop]));eventMixin(Doc),CodeMirror.e_stop=e_stop,CodeMirror.e_preventDefault=e_preventDefault,CodeMirror.e_stopPropagation=e_stopPropagation;var delayedCallbacks,delayedCallbackDepth=0;CodeMirror.on=on,CodeMirror.off=off,CodeMirror.signal=signal;var scrollerCutOff=30,Pass=CodeMirror.Pass={toString:function(){return"CodeMirror.Pass"}};Delayed.prototype={set:function(ms,f){clearTimeout(this.id),this.id=setTimeout(f,ms)}},CodeMirror.countColumn=countColumn;var spaceStrs=[""],nonASCIISingleCaseWordChar=/[\u3040-\u309f\u30a0-\u30ff\u3400-\u4db5\u4e00-\u9fcc\uac00-\ud7af]/,isExtendingChar=/[\u0300-\u036F\u0483-\u0487\u0488-\u0489\u0591-\u05BD\u05BF\u05C1-\u05C2\u05C4-\u05C5\u05C7\u0610-\u061A\u064B-\u065F\u0670\u06D6-\u06DC\u06DF-\u06E4\u06E7-\u06E8\u06EA-\u06ED\uA66F\uA670-\uA672\uA674-\uA67D\uA69F\udc00-\udfff]/;CodeMirror.replaceGetRect=function(f){getRect=f};var dragAndDrop=function(){if(ie_lt9)return!1;var div=elt("div");return"draggable"in div||"dragDrop"in div}();gecko?spanAffectsWrapping=function(str,i){return 36==str.charCodeAt(i-1)&&39==str.charCodeAt(i)}:safari&&!/Version\/([6-9]|\d\d)\b/.test(navigator.userAgent)?spanAffectsWrapping=function(str,i){return/\-[^ \-?]|\?[^ !\'\"\),.\-\/:;\?\]\}]/.test(str.slice(i-1,i+1))}:webkit&&!/Chrome\/(?:29|[3-9]\d|\d\d\d)\./.test(navigator.userAgent)&&(spanAffectsWrapping=function(str,i){if(i>1&&45==str.charCodeAt(i-1)){if(/\w/.test(str.charAt(i-2))&&/[^\-?\.]/.test(str.charAt(i)))return!0;if(i>2&&/[\d\.,]/.test(str.charAt(i-2))&&/[\d\.,]/.test(str.charAt(i)))return!1}return/[~!#%&*)=+}\]|\"\.>,:;][({[<]|-[^\-?\.\u2010-\u201f\u2026]|\?[\w~`@#$%\^&*(_=+{[|><]|…[\w~`@#$%\^&*(_=+{[><]/.test(str.slice(i-1,i+1))});var knownScrollbarWidth,zwspSupported,splitLines=3!="\n\nb".split(/\n/).length?function(string){for(var pos=0,result=[],l=string.length;pos<=l;){var nl=string.indexOf("\n",pos);nl==-1&&(nl=string.length);var line=string.slice(pos,"\r"==string.charAt(nl-1)?nl-1:nl),rt=line.indexOf("\r");rt!=-1?(result.push(line.slice(0,rt)),pos+=rt+1):(result.push(line),pos=nl+1)}return result}:function(string){return string.split(/\r\n?|\n/)};CodeMirror.splitLines=splitLines;var hasSelection=window.getSelection?function(te){try{return te.selectionStart!=te.selectionEnd}catch(e){return!1}}:function(te){try{var range=te.ownerDocument.selection.createRange()}catch(e){}return!(!range||range.parentElement()!=te)&&0!=range.compareEndPoints("StartToEnd",range)},hasCopyEvent=function(){var e=elt("div");return"oncopy"in e||(e.setAttribute("oncopy","return;"),"function"==typeof e.oncopy)}(),keyNames={3:"Enter",8:"Backspace",9:"Tab",13:"Enter",16:"Shift",17:"Ctrl",18:"Alt",19:"Pause",20:"CapsLock",27:"Esc",32:"Space",33:"PageUp",34:"PageDown",35:"End",36:"Home",37:"Left",38:"Up",39:"Right",40:"Down",44:"PrintScrn",45:"Insert",46:"Delete",59:";",91:"Mod",92:"Mod",93:"Mod",109:"-",107:"=",127:"Delete",186:";",187:"=",188:",",189:"-",190:".",191:"/",192:"`",219:"[",220:"\\",221:"]",222:"'",63276:"PageUp",63277:"PageDown",63275:"End",63273:"Home",63234:"Left",63232:"Up",63235:"Right",63233:"Down",63302:"Insert",63272:"Delete"};CodeMirror.keyNames=keyNames,function(){for(var i=0;i<10;i++)keyNames[i+48]=String(i);for(var i=65;i<=90;i++)keyNames[i]=String.fromCharCode(i);for(var i=1;i<=12;i++)keyNames[i+111]=keyNames[i+63235]="F"+i}();var bidiOther,bidiOrdering=function(){function charType(code){return code<=255?lowTypes.charAt(code):1424<=code&&code<=1524?"R":1536<=code&&code<=1791?arabicTypes.charAt(code-1536):1792<=code&&code<=2220?"r":"L"}var lowTypes="bbbbbbbbbtstwsbbbbbbbbbbbbbbssstwNN%%%NNNNNN,N,N1111111111NNNNNNNLLLLLLLLLLLLLLLLLLLLLLLLLLNNNNNNLLLLLLLLLLLLLLLLLLLLLLLLLLNNNNbbbbbbsbbbbbbbbbbbbbbbbbbbbbbbbbb,N%%%%NNNNLNNNNN%%11NLNNN1LNNNNNLLLLLLLLLLLLLLLLLLLLLLLNLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLNLLLLLLLL",arabicTypes="rrrrrrrrrrrr,rNNmmmmmmrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrmmmmmmmmmmmmmmrrrrrrrnnnnnnnnnn%nnrrrmrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrmmmmmmmmmmmmmmmmmmmNmmmmrrrrrrrrrrrrrrrrrr",bidiRE=/[\u0590-\u05f4\u0600-\u06ff\u0700-\u08ac]/,isNeutral=/[stwN]/,isStrong=/[LRr]/,countsAsLeft=/[Lb1n]/,countsAsNum=/[1n]/,outerType="L";return function(str){if(!bidiRE.test(str))return!1;for(var type,len=str.length,types=[],i=0;i<len;++i)types.push(type=charType(str.charCodeAt(i)));for(var i=0,prev=outerType;i<len;++i){var type=types[i];"m"==type?types[i]=prev:prev=type}for(var i=0,cur=outerType;i<len;++i){var type=types[i];"1"==type&&"r"==cur?types[i]="n":isStrong.test(type)&&(cur=type,"r"==type&&(types[i]="R"))}for(var i=1,prev=types[0];i<len-1;++i){var type=types[i];"+"==type&&"1"==prev&&"1"==types[i+1]?types[i]="1":","!=type||prev!=types[i+1]||"1"!=prev&&"n"!=prev||(types[i]=prev),prev=type}for(var i=0;i<len;++i){var type=types[i];if(","==type)types[i]="N";else if("%"==type){for(var end=i+1;end<len&&"%"==types[end];++end);for(var replace=i&&"!"==types[i-1]||end<len-1&&"1"==types[end]?"1":"N",j=i;j<end;++j)types[j]=replace;i=end-1}}for(var i=0,cur=outerType;i<len;++i){
var type=types[i];"L"==cur&&"1"==type?types[i]="L":isStrong.test(type)&&(cur=type)}for(var i=0;i<len;++i)if(isNeutral.test(types[i])){for(var end=i+1;end<len&&isNeutral.test(types[end]);++end);for(var before="L"==(i?types[i-1]:outerType),after="L"==(end<len-1?types[end]:outerType),replace=before||after?"L":"R",j=i;j<end;++j)types[j]=replace;i=end-1}for(var m,order=[],i=0;i<len;)if(countsAsLeft.test(types[i])){var start=i;for(++i;i<len&&countsAsLeft.test(types[i]);++i);order.push({from:start,to:i,level:0})}else{var pos=i,at=order.length;for(++i;i<len&&"L"!=types[i];++i);for(var j=pos;j<i;)if(countsAsNum.test(types[j])){pos<j&&order.splice(at,0,{from:pos,to:j,level:1});var nstart=j;for(++j;j<i&&countsAsNum.test(types[j]);++j);order.splice(at,0,{from:nstart,to:j,level:2}),pos=j}else++j;pos<i&&order.splice(at,0,{from:pos,to:i,level:1})}return 1==order[0].level&&(m=str.match(/^\s+/))&&(order[0].from=m[0].length,order.unshift({from:0,to:m[0].length,level:0})),1==lst(order).level&&(m=str.match(/\s+$/))&&(lst(order).to-=m[0].length,order.push({from:len-m[0].length,to:len,level:0})),order[0].level!=lst(order).level&&order.push({from:len,to:len,level:order[0].level}),order}}();return CodeMirror.version="3.15.0",CodeMirror}(),CodeMirror.defineMode("javascript",function(config,parserConfig){function chain(stream,state,f){return state.tokenize=f,f(stream,state)}function nextUntilUnescaped(stream,end){for(var next,escaped=!1;null!=(next=stream.next());){if(next==end&&!escaped)return!1;escaped=!escaped&&"\\"==next}return escaped}function ret(tp,style,cont){return type=tp,content=cont,style}function jsTokenBase(stream,state){var ch=stream.next();if('"'==ch||"'"==ch)return chain(stream,state,jsTokenString(ch));if(/[\[\]{}\(\),;\:\.]/.test(ch))return ret(ch);if("0"==ch&&stream.eat(/x/i))return stream.eatWhile(/[\da-f]/i),ret("number","number");if(/\d/.test(ch)||"-"==ch&&stream.eat(/\d/))return stream.match(/^\d*(?:\.\d*)?(?:[eE][+\-]?\d+)?/),ret("number","number");if("/"==ch)return stream.eat("*")?chain(stream,state,jsTokenComment):stream.eat("/")?(stream.skipToEnd(),ret("comment","comment")):"operator"==state.lastType||"keyword c"==state.lastType||/^[\[{}\(,;:]$/.test(state.lastType)?(nextUntilUnescaped(stream,"/"),stream.eatWhile(/[gimy]/),ret("regexp","string-2")):(stream.eatWhile(isOperatorChar),ret("operator",null,stream.current()));if("#"==ch)return stream.skipToEnd(),ret("error","error");if(isOperatorChar.test(ch))return stream.eatWhile(isOperatorChar),ret("operator",null,stream.current());stream.eatWhile(/[\w\$_]/);var word=stream.current(),known=keywords.propertyIsEnumerable(word)&&keywords[word];return known&&"."!=state.lastType?ret(known.type,known.style,word):ret("variable","variable",word)}function jsTokenString(quote){return function(stream,state){return nextUntilUnescaped(stream,quote)||(state.tokenize=jsTokenBase),ret("string","string")}}function jsTokenComment(stream,state){for(var ch,maybeEnd=!1;ch=stream.next();){if("/"==ch&&maybeEnd){state.tokenize=jsTokenBase;break}maybeEnd="*"==ch}return ret("comment","comment")}function JSLexical(indented,column,type,align,prev,info){this.indented=indented,this.column=column,this.type=type,this.prev=prev,this.info=info,null!=align&&(this.align=align)}function inScope(state,varname){for(var v=state.localVars;v;v=v.next)if(v.name==varname)return!0}function parseJS(state,style,type,content,stream){var cc=state.cc;for(cx.state=state,cx.stream=stream,cx.marked=null,cx.cc=cc,state.lexical.hasOwnProperty("align")||(state.lexical.align=!0);;){var combinator=cc.length?cc.pop():jsonMode?expression:statement;if(combinator(type,content)){for(;cc.length&&cc[cc.length-1].lex;)cc.pop()();return cx.marked?cx.marked:"variable"==type&&inScope(state,content)?"variable-2":style}}}function pass(){for(var i=arguments.length-1;i>=0;i--)cx.cc.push(arguments[i])}function cont(){return pass.apply(null,arguments),!0}function register(varname){function inList(list){for(var v=list;v;v=v.next)if(v.name==varname)return!0;return!1}var state=cx.state;if(state.context){if(cx.marked="def",inList(state.localVars))return;state.localVars={name:varname,next:state.localVars}}else{if(inList(state.globalVars))return;state.globalVars={name:varname,next:state.globalVars}}}function pushcontext(){cx.state.context={prev:cx.state.context,vars:cx.state.localVars},cx.state.localVars=defaultVars}function popcontext(){cx.state.localVars=cx.state.context.vars,cx.state.context=cx.state.context.prev}function pushlex(type,info){var result=function(){var state=cx.state,indent=state.indented;"stat"==state.lexical.type&&(indent=state.lexical.indented),state.lexical=new JSLexical(indent,cx.stream.column(),type,null,state.lexical,info)};return result.lex=!0,result}function poplex(){var state=cx.state;state.lexical.prev&&(")"==state.lexical.type&&(state.indented=state.lexical.indented),state.lexical=state.lexical.prev)}function expect(wanted){return function(type){return type==wanted?cont():";"==wanted?pass():cont(arguments.callee)}}function statement(type){return"var"==type?cont(pushlex("vardef"),vardef1,expect(";"),poplex):"keyword a"==type?cont(pushlex("form"),expression,statement,poplex):"keyword b"==type?cont(pushlex("form"),statement,poplex):"{"==type?cont(pushlex("}"),block,poplex):";"==type?cont():"if"==type?cont(pushlex("form"),expression,statement,poplex,maybeelse):"function"==type?cont(functiondef):"for"==type?cont(pushlex("form"),expect("("),pushlex(")"),forspec1,expect(")"),poplex,statement,poplex):"variable"==type?cont(pushlex("stat"),maybelabel):"switch"==type?cont(pushlex("form"),expression,pushlex("}","switch"),expect("{"),block,poplex,poplex):"case"==type?cont(expression,expect(":")):"default"==type?cont(expect(":")):"catch"==type?cont(pushlex("form"),pushcontext,expect("("),funarg,expect(")"),statement,poplex,popcontext):pass(pushlex("stat"),expression,expect(";"),poplex)}function expression(type){return expressionInner(type,!1)}function expressionNoComma(type){return expressionInner(type,!0)}function expressionInner(type,noComma){var maybeop=noComma?maybeoperatorNoComma:maybeoperatorComma;return atomicTypes.hasOwnProperty(type)?cont(maybeop):"function"==type?cont(functiondef):"keyword c"==type?cont(noComma?maybeexpressionNoComma:maybeexpression):"("==type?cont(pushlex(")"),maybeexpression,expect(")"),poplex,maybeop):"operator"==type?cont(noComma?expressionNoComma:expression):"["==type?cont(pushlex("]"),commasep(expressionNoComma,"]"),poplex,maybeop):"{"==type?cont(pushlex("}"),commasep(objprop,"}"),poplex,maybeop):cont()}function maybeexpression(type){return type.match(/[;\}\)\],]/)?pass():pass(expression)}function maybeexpressionNoComma(type){return type.match(/[;\}\)\],]/)?pass():pass(expressionNoComma)}function maybeoperatorComma(type,value){return","==type?cont(expression):maybeoperatorNoComma(type,value,!1)}function maybeoperatorNoComma(type,value,noComma){var me=0==noComma?maybeoperatorComma:maybeoperatorNoComma,expr=0==noComma?expression:expressionNoComma;return"operator"==type?/\+\+|--/.test(value)?cont(me):"?"==value?cont(expression,expect(":"),expr):cont(expr):";"!=type?"("==type?cont(pushlex(")","call"),commasep(expressionNoComma,")"),poplex,me):"."==type?cont(property,me):"["==type?cont(pushlex("]"),maybeexpression,expect("]"),poplex,me):void 0:void 0}function maybelabel(type){return":"==type?cont(poplex,statement):pass(maybeoperatorComma,expect(";"),poplex)}function property(type){if("variable"==type)return cx.marked="property",cont()}function objprop(type,value){if("variable"==type){if(cx.marked="property","get"==value||"set"==value)return cont(getterSetter)}else"number"!=type&&"string"!=type||(cx.marked=type+" property");if(atomicTypes.hasOwnProperty(type))return cont(expect(":"),expressionNoComma)}function getterSetter(type){return":"==type?cont(expression):"variable"!=type?cont(expect(":"),expression):(cx.marked="property",cont(functiondef))}function commasep(what,end){function proceed(type){if(","==type){var lex=cx.state.lexical;return"call"==lex.info&&(lex.pos=(lex.pos||0)+1),cont(what,proceed)}return type==end?cont():cont(expect(end))}return function(type){return type==end?cont():pass(what,proceed)}}function block(type){return"}"==type?cont():pass(statement,block)}function maybetype(type){return":"==type?cont(typedef):pass()}function typedef(type){return"variable"==type?(cx.marked="variable-3",cont()):pass()}function vardef1(type,value){return"variable"==type?(register(value),isTS?cont(maybetype,vardef2):cont(vardef2)):pass()}function vardef2(type,value){return"="==value?cont(expressionNoComma,vardef2):","==type?cont(vardef1):void 0}function maybeelse(type,value){if("keyword b"==type&&"else"==value)return cont(pushlex("form"),statement,poplex)}function forspec1(type){return"var"==type?cont(vardef1,expect(";"),forspec2):";"==type?cont(forspec2):"variable"==type?cont(formaybein):pass(expression,expect(";"),forspec2)}function formaybein(_type,value){return"in"==value?cont(expression):cont(maybeoperatorComma,forspec2)}function forspec2(type,value){return";"==type?cont(forspec3):"in"==value?cont(expression):pass(expression,expect(";"),forspec3)}function forspec3(type){")"!=type&&cont(expression)}function functiondef(type,value){return"variable"==type?(register(value),cont(functiondef)):"("==type?cont(pushlex(")"),pushcontext,commasep(funarg,")"),poplex,statement,popcontext):void 0}function funarg(type,value){if("variable"==type)return register(value),isTS?cont(maybetype):cont()}var type,content,indentUnit=config.indentUnit,statementIndent=parserConfig.statementIndent,jsonMode=parserConfig.json,isTS=parserConfig.typescript,keywords=function(){function kw(type){return{type:type,style:"keyword"}}var A=kw("keyword a"),B=kw("keyword b"),C=kw("keyword c"),operator=kw("operator"),atom={type:"atom",style:"atom"},jsKeywords={if:kw("if"),while:A,with:A,else:B,do:B,try:B,finally:B,return:C,break:C,continue:C,new:C,delete:C,throw:C,var:kw("var"),const:kw("var"),let:kw("var"),function:kw("function"),catch:kw("catch"),for:kw("for"),switch:kw("switch"),case:kw("case"),default:kw("default"),in:operator,typeof:operator,instanceof:operator,true:atom,false:atom,null:atom,undefined:atom,NaN:atom,Infinity:atom,this:kw("this")};if(isTS){var type={type:"variable",style:"variable-3"},tsKeywords={interface:kw("interface"),class:kw("class"),extends:kw("extends"),constructor:kw("constructor"),public:kw("public"),private:kw("private"),protected:kw("protected"),static:kw("static"),super:kw("super"),string:type,number:type,bool:type,any:type};for(var attr in tsKeywords)jsKeywords[attr]=tsKeywords[attr]}return jsKeywords}(),isOperatorChar=/[+\-*&%=<>!?|~^]/,atomicTypes={atom:!0,number:!0,variable:!0,string:!0,regexp:!0,this:!0},cx={state:null,column:null,marked:null,cc:null},defaultVars={name:"this",next:{name:"arguments"}};return poplex.lex=!0,{startState:function(basecolumn){return{tokenize:jsTokenBase,lastType:null,cc:[],lexical:new JSLexical((basecolumn||0)-indentUnit,0,"block",(!1)),localVars:parserConfig.localVars,globalVars:parserConfig.globalVars,context:parserConfig.localVars&&{vars:parserConfig.localVars},indented:0}},token:function(stream,state){if(stream.sol()&&(state.lexical.hasOwnProperty("align")||(state.lexical.align=!1),state.indented=stream.indentation()),state.tokenize!=jsTokenComment&&stream.eatSpace())return null;var style=state.tokenize(stream,state);return"comment"==type?style:(state.lastType="operator"!=type||"++"!=content&&"--"!=content?type:"incdec",parseJS(state,style,type,content,stream))},indent:function(state,textAfter){if(state.tokenize==jsTokenComment)return CodeMirror.Pass;if(state.tokenize!=jsTokenBase)return 0;for(var firstChar=textAfter&&textAfter.charAt(0),lexical=state.lexical,i=state.cc.length-1;i>=0;--i){var c=state.cc[i];if(c==poplex)lexical=lexical.prev;else if(c!=maybeelse||/^else\b/.test(textAfter))break}"stat"==lexical.type&&"}"==firstChar&&(lexical=lexical.prev),statementIndent&&")"==lexical.type&&"stat"==lexical.prev.type&&(lexical=lexical.prev);var type=lexical.type,closing=firstChar==type;return"vardef"==type?lexical.indented+("operator"==state.lastType||","==state.lastType?4:0):"form"==type&&"{"==firstChar?lexical.indented:"form"==type?lexical.indented+indentUnit:"stat"==type?lexical.indented+("operator"==state.lastType||","==state.lastType?statementIndent||indentUnit:0):"switch"!=lexical.info||closing||0==parserConfig.doubleIndentSwitch?lexical.align?lexical.column+(closing?0:1):lexical.indented+(closing?0:indentUnit):lexical.indented+(/^(?:case|default)\b/.test(textAfter)?indentUnit:2*indentUnit)},electricChars:":{}",blockCommentStart:jsonMode?null:"/*",blockCommentEnd:jsonMode?null:"*/",lineComment:jsonMode?null:"//",fold:"brace",helperType:jsonMode?"json":"javascript",jsonMode:jsonMode}}),CodeMirror.defineMIME("text/javascript","javascript"),CodeMirror.defineMIME("text/ecmascript","javascript"),CodeMirror.defineMIME("application/javascript","javascript"),CodeMirror.defineMIME("application/ecmascript","javascript"),CodeMirror.defineMIME("application/json",{name:"javascript",json:!0}),CodeMirror.defineMIME("application/x-json",{name:"javascript",json:!0}),CodeMirror.defineMIME("text/typescript",{name:"javascript",typescript:!0}),CodeMirror.defineMIME("application/typescript",{name:"javascript",typescript:!0}),CodeMirror.defineMode("xml",function(config,parserConfig){function inText(stream,state){function chain(parser){return state.tokenize=parser,parser(stream,state)}var ch=stream.next();if("<"==ch){if(stream.eat("!"))return stream.eat("[")?stream.match("CDATA[")?chain(inBlock("atom","]]>")):null:stream.match("--")?chain(inBlock("comment","-->")):stream.match("DOCTYPE",!0,!0)?(stream.eatWhile(/[\w\._\-]/),chain(doctype(1))):null;if(stream.eat("?"))return stream.eatWhile(/[\w\._\-]/),state.tokenize=inBlock("meta","?>"),"meta";var isClose=stream.eat("/");tagName="";for(var c;c=stream.eat(/[^\s\u00a0=<>\"\'\/?]/);)tagName+=c;return tagName?(type=isClose?"closeTag":"openTag",state.tokenize=inTag,"tag"):"error"}if("&"==ch){var ok;return ok=stream.eat("#")?stream.eat("x")?stream.eatWhile(/[a-fA-F\d]/)&&stream.eat(";"):stream.eatWhile(/[\d]/)&&stream.eat(";"):stream.eatWhile(/[\w\.\-:]/)&&stream.eat(";"),ok?"atom":"error"}return stream.eatWhile(/[^&<]/),null}function inTag(stream,state){var ch=stream.next();return">"==ch||"/"==ch&&stream.eat(">")?(state.tokenize=inText,type=">"==ch?"endTag":"selfcloseTag","tag"):"="==ch?(type="equals",null):"<"==ch?"error":/[\'\"]/.test(ch)?(state.tokenize=inAttribute(ch),state.stringStartCol=stream.column(),state.tokenize(stream,state)):(stream.eatWhile(/[^\s\u00a0=<>\"\']/),"word")}function inAttribute(quote){var closure=function(stream,state){for(;!stream.eol();)if(stream.next()==quote){state.tokenize=inTag;break}return"string"};return closure.isInAttribute=!0,closure}function inBlock(style,terminator){return function(stream,state){for(;!stream.eol();){if(stream.match(terminator)){state.tokenize=inText;break}stream.next()}return style}}function doctype(depth){return function(stream,state){for(var ch;null!=(ch=stream.next());){if("<"==ch)return state.tokenize=doctype(depth+1),state.tokenize(stream,state);if(">"==ch){if(1==depth){state.tokenize=inText;break}return state.tokenize=doctype(depth-1),state.tokenize(stream,state)}}return"meta"}}function pass(){for(var i=arguments.length-1;i>=0;i--)curState.cc.push(arguments[i])}function cont(){return pass.apply(null,arguments),!0}function pushContext(tagName,startOfLine){var noIndent=Kludges.doNotIndent.hasOwnProperty(tagName)||curState.context&&curState.context.noIndent;curState.context={prev:curState.context,tagName:tagName,indent:curState.indented,startOfLine:startOfLine,noIndent:noIndent}}function popContext(){curState.context&&(curState.context=curState.context.prev)}function element(type){if("openTag"==type)return curState.tagName=tagName,curState.tagStart=curStream.column(),cont(attributes,endtag(curState.startOfLine));if("closeTag"==type){var err=!1;return curState.context?curState.context.tagName!=tagName&&(Kludges.implicitlyClosed.hasOwnProperty(curState.context.tagName.toLowerCase())&&popContext(),err=!curState.context||curState.context.tagName!=tagName):err=!0,err&&(setStyle="error"),cont(endclosetag(err))}return cont()}function endtag(startOfLine){return function(type){var tagName=curState.tagName;return curState.tagName=curState.tagStart=null,"selfcloseTag"==type||"endTag"==type&&Kludges.autoSelfClosers.hasOwnProperty(tagName.toLowerCase())?(maybePopContext(tagName.toLowerCase()),cont()):"endTag"==type?(maybePopContext(tagName.toLowerCase()),pushContext(tagName,startOfLine),cont()):cont()}}function endclosetag(err){return function(type){return err&&(setStyle="error"),"endTag"==type?(popContext(),cont()):(setStyle="error",cont(arguments.callee))}}function maybePopContext(nextTagName){for(var parentTagName;;){if(!curState.context)return;if(parentTagName=curState.context.tagName.toLowerCase(),!Kludges.contextGrabbers.hasOwnProperty(parentTagName)||!Kludges.contextGrabbers[parentTagName].hasOwnProperty(nextTagName))return;popContext()}}function attributes(type){return"word"==type?(setStyle="attribute",cont(attribute,attributes)):"endTag"==type||"selfcloseTag"==type?pass():(setStyle="error",cont(attributes))}function attribute(type){return"equals"==type?cont(attvalue,attributes):(Kludges.allowMissing?"word"==type&&(setStyle="attribute"):setStyle="error","endTag"==type||"selfcloseTag"==type?pass():cont())}function attvalue(type){return"string"==type?cont(attvaluemaybe):"word"==type&&Kludges.allowUnquoted?(setStyle="string",cont()):(setStyle="error","endTag"==type||"selfCloseTag"==type?pass():cont())}function attvaluemaybe(type){return"string"==type?cont(attvaluemaybe):pass()}var tagName,type,curState,curStream,setStyle,indentUnit=config.indentUnit,multilineTagIndentFactor=parserConfig.multilineTagIndentFactor||1,multilineTagIndentPastTag=parserConfig.multilineTagIndentPastTag||!0,Kludges=parserConfig.htmlMode?{autoSelfClosers:{area:!0,base:!0,br:!0,col:!0,command:!0,embed:!0,frame:!0,hr:!0,img:!0,input:!0,keygen:!0,link:!0,meta:!0,param:!0,source:!0,track:!0,wbr:!0},implicitlyClosed:{dd:!0,li:!0,optgroup:!0,option:!0,p:!0,rp:!0,rt:!0,tbody:!0,td:!0,tfoot:!0,th:!0,tr:!0},contextGrabbers:{dd:{dd:!0,dt:!0},dt:{dd:!0,dt:!0},li:{li:!0},option:{option:!0,optgroup:!0},optgroup:{optgroup:!0},p:{address:!0,article:!0,aside:!0,blockquote:!0,dir:!0,div:!0,dl:!0,fieldset:!0,footer:!0,form:!0,h1:!0,h2:!0,h3:!0,h4:!0,h5:!0,h6:!0,header:!0,hgroup:!0,hr:!0,menu:!0,nav:!0,ol:!0,p:!0,pre:!0,section:!0,table:!0,ul:!0},rp:{rp:!0,rt:!0},rt:{rp:!0,rt:!0},tbody:{tbody:!0,tfoot:!0},td:{td:!0,th:!0},tfoot:{tbody:!0},th:{td:!0,th:!0},thead:{tbody:!0,tfoot:!0},tr:{tr:!0}},doNotIndent:{pre:!0},allowUnquoted:!0,allowMissing:!0}:{autoSelfClosers:{},implicitlyClosed:{},contextGrabbers:{},doNotIndent:{},allowUnquoted:!1,allowMissing:!1},alignCDATA=parserConfig.alignCDATA;return{startState:function(){return{tokenize:inText,cc:[],indented:0,startOfLine:!0,tagName:null,tagStart:null,context:null}},token:function(stream,state){if(!state.tagName&&stream.sol()&&(state.startOfLine=!0,state.indented=stream.indentation()),stream.eatSpace())return null;setStyle=type=tagName=null;var style=state.tokenize(stream,state);if(state.type=type,(style||type)&&"comment"!=style)for(curState=state,curStream=stream;;){var comb=state.cc.pop()||element;if(comb(type||style))break}return state.startOfLine=!1,setStyle||style},indent:function(state,textAfter,fullLine){var context=state.context;if(state.tokenize.isInAttribute)return state.stringStartCol+1;if(state.tokenize!=inTag&&state.tokenize!=inText||context&&context.noIndent)return fullLine?fullLine.match(/^(\s*)/)[0].length:0;if(state.tagName)return multilineTagIndentPastTag?state.tagStart+state.tagName.length+2:state.tagStart+indentUnit*multilineTagIndentFactor;if(alignCDATA&&/<!\[CDATA\[/.test(textAfter))return 0;for(context&&/^<\//.test(textAfter)&&(context=context.prev);context&&!context.startOfLine;)context=context.prev;return context?context.indent+indentUnit:0},electricChars:"/",blockCommentStart:"<!--",blockCommentEnd:"-->",configuration:parserConfig.htmlMode?"html":"xml",helperType:parserConfig.htmlMode?"html":"xml"}}),CodeMirror.defineMIME("text/xml","xml"),CodeMirror.defineMIME("application/xml","xml"),CodeMirror.mimeModes.hasOwnProperty("text/html")||CodeMirror.defineMIME("text/html",{name:"xml",htmlMode:!0}),CodeMirror.defineMode("yaml",function(){var cons=["true","false","on","off","yes","no"],keywordRegex=new RegExp("\\b(("+cons.join(")|(")+"))$","i");return{token:function(stream,state){var ch=stream.peek(),esc=state.escaped;if(state.escaped=!1,"#"==ch&&(0==stream.pos||/\s/.test(stream.string.charAt(stream.pos-1))))return stream.skipToEnd(),"comment";if(state.literal&&stream.indentation()>state.keyCol)return stream.skipToEnd(),"string";if(state.literal&&(state.literal=!1),stream.sol()){if(state.keyCol=0,state.pair=!1,state.pairStart=!1,stream.match(/---/))return"def";if(stream.match(/\.\.\./))return"def";if(stream.match(/\s*-\s+/))return"meta"}if(!state.pair&&stream.match(/^\s*([a-z0-9\._-])+(?=\s*:)/i))return state.pair=!0,state.keyCol=stream.indentation(),"atom";if(state.pair&&stream.match(/^:\s*/))return state.pairStart=!0,"meta";if(stream.match(/^(\{|\}|\[|\])/))return"{"==ch?state.inlinePairs++:"}"==ch?state.inlinePairs--:"["==ch?state.inlineList++:state.inlineList--,"meta";if(state.inlineList>0&&!esc&&","==ch)return stream.next(),"meta";if(state.inlinePairs>0&&!esc&&","==ch)return state.keyCol=0,state.pair=!1,state.pairStart=!1,stream.next(),"meta";if(state.pairStart){if(stream.match(/^\s*(\||\>)\s*/))return state.literal=!0,"meta";if(stream.match(/^\s*(\&|\*)[a-z0-9\._-]+\b/i))return"variable-2";if(0==state.inlinePairs&&stream.match(/^\s*-?[0-9\.\,]+\s?$/))return"number";if(state.inlinePairs>0&&stream.match(/^\s*-?[0-9\.\,]+\s?(?=(,|}))/))return"number";if(stream.match(keywordRegex))return"keyword"}return state.pairStart=!1,state.escaped="\\"==ch,stream.next(),null},startState:function(){return{pair:!1,pairStart:!1,keyCol:0,inlinePairs:0,inlineList:0,literal:!1,escaped:!1}}}}),CodeMirror.defineMIME("text/x-yaml","yaml"),function(){function dialogDiv(cm,template,bottom){var dialog,wrap=cm.getWrapperElement();return dialog=wrap.appendChild(document.createElement("div")),bottom?dialog.className="CodeMirror-dialog CodeMirror-dialog-bottom":dialog.className="CodeMirror-dialog CodeMirror-dialog-top",dialog.innerHTML=template,dialog}CodeMirror.defineExtension("openDialog",function(template,callback,options){function close(){closed||(closed=!0,dialog.parentNode.removeChild(dialog))}var button,dialog=dialogDiv(this,template,options&&options.bottom),closed=!1,me=this,inp=dialog.getElementsByTagName("input")[0];return inp?(CodeMirror.on(inp,"keydown",function(e){options&&options.onKeyDown&&options.onKeyDown(e,inp.value,close)||13!=e.keyCode&&27!=e.keyCode||(CodeMirror.e_stop(e),close(),me.focus(),13==e.keyCode&&callback(inp.value))}),options&&options.onKeyUp&&CodeMirror.on(inp,"keyup",function(e){options.onKeyUp(e,inp.value,close)}),options&&options.value&&(inp.value=options.value),inp.focus(),CodeMirror.on(inp,"blur",close)):(button=dialog.getElementsByTagName("button")[0])&&(CodeMirror.on(button,"click",function(){close(),me.focus()}),button.focus(),CodeMirror.on(button,"blur",close)),close}),CodeMirror.defineExtension("openConfirm",function(template,callbacks,options){function close(){closed||(closed=!0,dialog.parentNode.removeChild(dialog),me.focus())}var dialog=dialogDiv(this,template,options&&options.bottom),buttons=dialog.getElementsByTagName("button"),closed=!1,me=this,blurring=1;buttons[0].focus();for(var i=0;i<buttons.length;++i){var b=buttons[i];!function(callback){CodeMirror.on(b,"click",function(e){CodeMirror.e_preventDefault(e),close(),callback&&callback(me)})}(callbacks[i]),CodeMirror.on(b,"blur",function(){--blurring,setTimeout(function(){blurring<=0&&close()},200)}),CodeMirror.on(b,"focus",function(){++blurring})}})}(),function(){function searchOverlay(query){return"string"==typeof query?{token:function(stream){return stream.match(query)?"searching":(stream.next(),void(stream.skipTo(query.charAt(0))||stream.skipToEnd()))}}:{token:function(stream){if(stream.match(query))return"searching";for(;!stream.eol()&&(stream.next(),!stream.match(query,!1)););}}}function SearchState(){this.posFrom=this.posTo=this.query=null,this.overlay=null}function getSearchState(cm){return cm.state.search||(cm.state.search=new SearchState)}function getSearchCursor(cm,query,pos){return cm.getSearchCursor(query,pos,"string"==typeof query&&query==query.toLowerCase())}function dialog(cm,text,shortText,f){cm.openDialog?cm.openDialog(text,f):f(prompt(shortText,""))}function confirmDialog(cm,text,shortText,fs){cm.openConfirm?cm.openConfirm(text,fs):confirm(shortText)&&fs[0]()}function parseQuery(query){var isRE=query.match(/^\/(.*)\/([a-z]*)$/);return isRE?new RegExp(isRE[1],isRE[2].indexOf("i")==-1?"":"i"):query}function doSearch(cm,rev){var state=getSearchState(cm);return state.query?findNext(cm,rev):void dialog(cm,queryDialog,"Search for:",function(query){cm.operation(function(){query&&!state.query&&(state.query=parseQuery(query),cm.removeOverlay(state.overlay),state.overlay=searchOverlay(state.query),cm.addOverlay(state.overlay),state.posFrom=state.posTo=cm.getCursor(),findNext(cm,rev))})})}function findNext(cm,rev){cm.operation(function(){var state=getSearchState(cm),cursor=getSearchCursor(cm,state.query,rev?state.posFrom:state.posTo);(cursor.find(rev)||(cursor=getSearchCursor(cm,state.query,rev?CodeMirror.Pos(cm.lastLine()):CodeMirror.Pos(cm.firstLine(),0)),cursor.find(rev)))&&(cm.setSelection(cursor.from(),cursor.to()),state.posFrom=cursor.from(),state.posTo=cursor.to())})}function clearSearch(cm){cm.operation(function(){var state=getSearchState(cm);state.query&&(state.query=null,cm.removeOverlay(state.overlay))})}function replace(cm,all){dialog(cm,replaceQueryDialog,"Replace:",function(query){query&&(query=parseQuery(query),dialog(cm,replacementQueryDialog,"Replace with:",function(text){if(all)cm.operation(function(){for(var cursor=getSearchCursor(cm,query);cursor.findNext();)if("string"!=typeof query){var match=cm.getRange(cursor.from(),cursor.to()).match(query);cursor.replace(text.replace(/\$(\d)/,function(_,i){return match[i]}))}else cursor.replace(text)});else{clearSearch(cm);var cursor=getSearchCursor(cm,query,cm.getCursor()),advance=function(){var match,start=cursor.from();!(match=cursor.findNext())&&(cursor=getSearchCursor(cm,query),!(match=cursor.findNext())||start&&cursor.from().line==start.line&&cursor.from().ch==start.ch)||(cm.setSelection(cursor.from(),cursor.to()),confirmDialog(cm,doReplaceConfirm,"Replace?",[function(){doReplace(match)},advance]))},doReplace=function(match){cursor.replace("string"==typeof query?text:text.replace(/\$(\d)/,function(_,i){return match[i]})),advance()};advance()}}))})}var queryDialog='Search: <input type="text" style="width: 10em"/> <span style="color: #888">(Use /re/ syntax for regexp search)</span>',replaceQueryDialog='Replace: <input type="text" style="width: 10em"/> <span style="color: #888">(Use /re/ syntax for regexp search)</span>',replacementQueryDialog='With: <input type="text" style="width: 10em"/>',doReplaceConfirm="Replace? <button>Yes</button> <button>No</button> <button>Stop</button>";CodeMirror.commands.find=function(cm){clearSearch(cm),doSearch(cm)},CodeMirror.commands.findNext=doSearch,CodeMirror.commands.findPrev=function(cm){doSearch(cm,!0)},CodeMirror.commands.clearSearch=clearSearch,CodeMirror.commands.replace=replace,CodeMirror.commands.replaceAll=function(cm){replace(cm,!0)}}(),function(){function SearchCursor(doc,query,pos,caseFold){if(this.atOccurrence=!1,this.doc=doc,null==caseFold&&"string"==typeof query&&(caseFold=!1),pos=pos?doc.clipPos(pos):Pos(0,0),this.pos={from:pos,to:pos},"string"!=typeof query)query.global||(query=new RegExp(query.source,query.ignoreCase?"ig":"g")),this.matches=function(reverse,pos){if(reverse){query.lastIndex=0;for(var match,start,line=doc.getLine(pos.line).slice(0,pos.ch),cutOff=0;;){query.lastIndex=cutOff;var newMatch=query.exec(line);if(!newMatch)break;if(match=newMatch,start=match.index,cutOff=match.index+(match[0].length||1),cutOff==line.length)break}var matchLen=match&&match[0].length||0;matchLen||(0==start&&0==line.length?match=void 0:start!=doc.getLine(pos.line).length&&matchLen++)}else{query.lastIndex=pos.ch;var line=doc.getLine(pos.line),match=query.exec(line),matchLen=match&&match[0].length||0,start=match&&match.index;start+matchLen==line.length||matchLen||(matchLen=1)}if(match&&matchLen)return{from:Pos(pos.line,start),to:Pos(pos.line,start+matchLen),match:match}};else{caseFold&&(query=query.toLowerCase());var fold=caseFold?function(str){return str.toLowerCase()}:function(str){return str},target=query.split("\n");1==target.length?query.length?this.matches=function(reverse,pos){var match,line=fold(doc.getLine(pos.line)),len=query.length;if(reverse?pos.ch>=len&&(match=line.lastIndexOf(query,pos.ch-len))!=-1:(match=line.indexOf(query,pos.ch))!=-1)return{from:Pos(pos.line,match),to:Pos(pos.line,match+len)}}:this.matches=function(){}:this.matches=function(reverse,pos){var ln=pos.line,idx=reverse?target.length-1:0,match=target[idx],line=fold(doc.getLine(ln)),offsetA=reverse?line.indexOf(match)+match.length:line.lastIndexOf(match);if(!(reverse?offsetA>=pos.ch||offsetA!=match.length:offsetA<=pos.ch||offsetA!=line.length-match.length))for(;;){if(reverse?!ln:ln==doc.lineCount()-1)return;if(line=fold(doc.getLine(ln+=reverse?-1:1)),match=target[reverse?--idx:++idx],!(idx>0&&idx<target.length-1)){var offsetB=reverse?line.lastIndexOf(match):line.indexOf(match)+match.length;if(reverse?offsetB!=line.length-match.length:offsetB!=match.length)return;var start=Pos(pos.line,offsetA),end=Pos(ln,offsetB);return{from:reverse?end:start,to:reverse?start:end}}if(line!=match)return}}}}var Pos=CodeMirror.Pos;SearchCursor.prototype={findNext:function(){return this.find(!1)},findPrevious:function(){return this.find(!0)},find:function(reverse){function savePosAndFail(line){var pos=Pos(line,0);return self.pos={from:pos,to:pos},self.atOccurrence=!1,!1}for(var self=this,pos=this.doc.clipPos(reverse?this.pos.from:this.pos.to);;){if(this.pos=this.matches(reverse,pos))return this.pos.from&&this.pos.to||console.log(this.matches,this.pos),this.atOccurrence=!0,this.pos.match||!0;if(reverse){if(!pos.line)return savePosAndFail(0);pos=Pos(pos.line-1,this.doc.getLine(pos.line-1).length)}else{var maxLine=this.doc.lineCount();if(pos.line==maxLine-1)return savePosAndFail(maxLine);pos=Pos(pos.line+1,0)}}},from:function(){if(this.atOccurrence)return this.pos.from},to:function(){if(this.atOccurrence)return this.pos.to},replace:function(newText){if(this.atOccurrence){var lines=CodeMirror.splitLines(newText);this.doc.replaceRange(lines,this.pos.from,this.pos.to),this.pos.to=Pos(this.pos.from.line+lines.length-1,lines[lines.length-1].length+(1==lines.length?this.pos.from.ch:0))}}},CodeMirror.defineExtension("getSearchCursor",function(query,pos,caseFold){return new SearchCursor(this.doc,query,pos,caseFold)}),CodeMirror.defineDocExtension("getSearchCursor",function(query,pos,caseFold){return new SearchCursor(this,query,pos,caseFold)})}(),function(){"use strict";function showTooltip(e,content){function position(e){return tt.parentNode?(tt.style.top=Math.max(0,e.clientY-tt.offsetHeight-5)+"px",void(tt.style.left=e.clientX+5+"px")):CodeMirror.off(document,"mousemove",position)}var tt=document.createElement("div");return tt.className="CodeMirror-lint-tooltip",tt.appendChild(content.cloneNode(!0)),document.body.appendChild(tt),CodeMirror.on(document,"mousemove",position),position(e),null!=tt.style.opacity&&(tt.style.opacity=1),tt}function rm(elt){elt.parentNode&&elt.parentNode.removeChild(elt)}function hideTooltip(tt){tt.parentNode&&(null==tt.style.opacity&&rm(tt),tt.style.opacity=0,setTimeout(function(){rm(tt)},600))}function showTooltipFor(e,content,node){
function hide(){CodeMirror.off(node,"mouseout",hide),tooltip&&(hideTooltip(tooltip),tooltip=null)}var tooltip=showTooltip(e,content),poll=setInterval(function(){if(tooltip)for(var n=node;;n=n.parentNode){if(n==document.body)return;if(!n){hide();break}}if(!tooltip)return clearInterval(poll)},400);CodeMirror.on(node,"mouseout",hide)}function LintState(cm,options,hasGutter){this.marked=[],this.options=options,this.timeout=null,this.hasGutter=hasGutter,this.onMouseOver=function(e){onMouseOver(cm,e)}}function parseOptions(cm,options){if(options instanceof Function)return{getAnnotations:options};if(options&&options!==!0||(options={}),options.getAnnotations||(options.getAnnotations=cm.getHelper(CodeMirror.Pos(0,0),"lint")),!options.getAnnotations)throw new Error("Required option 'getAnnotations' missing (lint addon)");return options}function clearMarks(cm){var state=cm.state.lint;state.hasGutter&&cm.clearGutter(GUTTER_ID);for(var i=0;i<state.marked.length;++i)state.marked[i].clear();state.marked.length=0}function makeMarker(labels,severity,multiple,tooltips){var marker=document.createElement("div"),inner=marker;return marker.className="CodeMirror-lint-marker-"+severity,multiple&&(inner=marker.appendChild(document.createElement("div")),inner.className="CodeMirror-lint-marker-multiple"),0!=tooltips&&CodeMirror.on(inner,"mouseover",function(e){showTooltipFor(e,labels,inner)}),marker}function getMaxSeverity(a,b){return"error"==a?a:b}function groupByLine(annotations){for(var lines=[],i=0;i<annotations.length;++i){var ann=annotations[i],line=ann.from.line;(lines[line]||(lines[line]=[])).push(ann)}return lines}function annotationTooltip(ann){var severity=ann.severity;SEVERITIES.test(severity)||(severity="error");var tip=document.createElement("div");return tip.className="CodeMirror-lint-message-"+severity,tip.appendChild(document.createTextNode(ann.message)),tip}function startLinting(cm){var state=cm.state.lint,options=state.options;options.async?options.getAnnotations(cm,updateLinting,options):updateLinting(cm,options.getAnnotations(cm.getValue()))}function updateLinting(cm,annotationsNotSorted){clearMarks(cm);for(var state=cm.state.lint,options=state.options,annotations=groupByLine(annotationsNotSorted),line=0;line<annotations.length;++line){var anns=annotations[line];if(anns){for(var maxSeverity=null,tipLabel=state.hasGutter&&document.createDocumentFragment(),i=0;i<anns.length;++i){var ann=anns[i],severity=ann.severity;SEVERITIES.test(severity)||(severity="error"),maxSeverity=getMaxSeverity(maxSeverity,severity),options.formatAnnotation&&(ann=options.formatAnnotation(ann)),state.hasGutter&&tipLabel.appendChild(annotationTooltip(ann)),ann.to&&state.marked.push(cm.markText(ann.from,ann.to,{className:"CodeMirror-lint-mark-"+severity,__annotation:ann}))}state.hasGutter&&cm.setGutterMarker(line,GUTTER_ID,makeMarker(tipLabel,maxSeverity,anns.length>1,state.options.tooltips))}}options.onUpdateLinting&&options.onUpdateLinting(annotationsNotSorted,annotations,cm)}function onChange(cm){var state=cm.state.lint;clearTimeout(state.timeout),state.timeout=setTimeout(function(){startLinting(cm)},state.options.delay||500)}function popupSpanTooltip(ann,e){var target=e.target||e.srcElement;showTooltipFor(e,annotationTooltip(ann),target)}function onMouseOver(cm,e){if(/\bCodeMirror-lint-mark-/.test((e.target||e.srcElement).className))for(var i=0;i<nearby.length;i+=2)for(var spans=cm.findMarksAt(cm.coordsChar({left:e.clientX+nearby[i],top:e.clientY+nearby[i+1]})),j=0;j<spans.length;++j){var span=spans[j],ann=span.__annotation;if(ann)return popupSpanTooltip(ann,e)}}function optionHandler(cm,val,old){if(old&&old!=CodeMirror.Init&&(clearMarks(cm),cm.off("change",onChange),CodeMirror.off(cm.getWrapperElement(),"mouseover",cm.state.lint.onMouseOver),delete cm.state.lint),val){for(var gutters=cm.getOption("gutters"),hasLintGutter=!1,i=0;i<gutters.length;++i)gutters[i]==GUTTER_ID&&(hasLintGutter=!0);var state=cm.state.lint=new LintState(cm,parseOptions(cm,val),hasLintGutter);cm.on("change",onChange),0!=state.options.tooltips&&CodeMirror.on(cm.getWrapperElement(),"mouseover",state.onMouseOver),startLinting(cm)}}var GUTTER_ID="CodeMirror-lint-markers",SEVERITIES=/^(?:error|warning)$/,nearby=[0,0,0,5,0,-5,5,0,-5,0];CodeMirror.defineOption("lintWith",!1,optionHandler),CodeMirror.defineOption("lint",!1,optionHandler)}(),function(window,document,undefined){"use strict";function minErr(module,ErrorConstructor){return ErrorConstructor=ErrorConstructor||Error,function(){var message,i,code=arguments[0],prefix="["+(module?module+":":"")+code+"] ",template=arguments[1],templateArgs=arguments;for(message=prefix+template.replace(/\{\d+\}/g,function(match){var index=+match.slice(1,-1);return index+2<templateArgs.length?toDebugString(templateArgs[index+2]):match}),message=message+"\nhttp://errors.angularjs.org/1.3.20/"+(module?module+"/":"")+code,i=2;i<arguments.length;i++)message=message+(2==i?"?":"&")+"p"+(i-2)+"="+encodeURIComponent(toDebugString(arguments[i]));return new ErrorConstructor(message)}}function isArrayLike(obj){if(null==obj||isWindow(obj))return!1;var length="length"in Object(obj)&&obj.length;return!(obj.nodeType!==NODE_TYPE_ELEMENT||!length)||(isString(obj)||isArray(obj)||0===length||"number"==typeof length&&length>0&&length-1 in obj)}function forEach(obj,iterator,context){var key,length;if(obj)if(isFunction(obj))for(key in obj)"prototype"==key||"length"==key||"name"==key||obj.hasOwnProperty&&!obj.hasOwnProperty(key)||iterator.call(context,obj[key],key,obj);else if(isArray(obj)||isArrayLike(obj)){var isPrimitive="object"!=typeof obj;for(key=0,length=obj.length;key<length;key++)(isPrimitive||key in obj)&&iterator.call(context,obj[key],key,obj)}else if(obj.forEach&&obj.forEach!==forEach)obj.forEach(iterator,context,obj);else for(key in obj)obj.hasOwnProperty(key)&&iterator.call(context,obj[key],key,obj);return obj}function sortedKeys(obj){return Object.keys(obj).sort()}function forEachSorted(obj,iterator,context){for(var keys=sortedKeys(obj),i=0;i<keys.length;i++)iterator.call(context,obj[keys[i]],keys[i]);return keys}function reverseParams(iteratorFn){return function(value,key){iteratorFn(key,value)}}function nextUid(){return++uid}function setHashKey(obj,h){h?obj.$$hashKey=h:delete obj.$$hashKey}function extend(dst){for(var h=dst.$$hashKey,i=1,ii=arguments.length;i<ii;i++){var obj=arguments[i];if(obj)for(var keys=Object.keys(obj),j=0,jj=keys.length;j<jj;j++){var key=keys[j];dst[key]=obj[key]}}return setHashKey(dst,h),dst}function int(str){return parseInt(str,10)}function inherit(parent,extra){return extend(Object.create(parent),extra)}function noop(){}function identity($){return $}function valueFn(value){return function(){return value}}function isUndefined(value){return"undefined"==typeof value}function isDefined(value){return"undefined"!=typeof value}function isObject(value){return null!==value&&"object"==typeof value}function isString(value){return"string"==typeof value}function isNumber(value){return"number"==typeof value}function isDate(value){return"[object Date]"===toString.call(value)}function isFunction(value){return"function"==typeof value}function isRegExp(value){return"[object RegExp]"===toString.call(value)}function isWindow(obj){return obj&&obj.window===obj}function isScope(obj){return obj&&obj.$evalAsync&&obj.$watch}function isFile(obj){return"[object File]"===toString.call(obj)}function isFormData(obj){return"[object FormData]"===toString.call(obj)}function isBlob(obj){return"[object Blob]"===toString.call(obj)}function isBoolean(value){return"boolean"==typeof value}function isPromiseLike(obj){return obj&&isFunction(obj.then)}function isElement(node){return!(!node||!(node.nodeName||node.prop&&node.attr&&node.find))}function makeMap(str){var i,obj={},items=str.split(",");for(i=0;i<items.length;i++)obj[items[i]]=!0;return obj}function nodeName_(element){return lowercase(element.nodeName||element[0]&&element[0].nodeName)}function arrayRemove(array,value){var index=array.indexOf(value);return index>=0&&array.splice(index,1),value}function copy(source,destination,stackSource,stackDest){if(isWindow(source)||isScope(source))throw ngMinErr("cpws","Can't copy! Making copies of Window or Scope instances is not supported.");if(destination){if(source===destination)throw ngMinErr("cpi","Can't copy! Source and destination are identical.");if(stackSource=stackSource||[],stackDest=stackDest||[],isObject(source)){var index=stackSource.indexOf(source);if(index!==-1)return stackDest[index];stackSource.push(source),stackDest.push(destination)}var result;if(isArray(source)){destination.length=0;for(var i=0;i<source.length;i++)result=copy(source[i],null,stackSource,stackDest),isObject(source[i])&&(stackSource.push(source[i]),stackDest.push(result)),destination.push(result)}else{var h=destination.$$hashKey;isArray(destination)?destination.length=0:forEach(destination,function(value,key){delete destination[key]});for(var key in source)source.hasOwnProperty(key)&&(result=copy(source[key],null,stackSource,stackDest),isObject(source[key])&&(stackSource.push(source[key]),stackDest.push(result)),destination[key]=result);setHashKey(destination,h)}}else if(destination=source,source)if(isArray(source))destination=copy(source,[],stackSource,stackDest);else if(isDate(source))destination=new Date(source.getTime());else if(isRegExp(source))destination=new RegExp(source.source,source.toString().match(/[^\/]*$/)[0]),destination.lastIndex=source.lastIndex;else if(isObject(source)){var emptyObject=Object.create(Object.getPrototypeOf(source));destination=copy(source,emptyObject,stackSource,stackDest)}return destination}function shallowCopy(src,dst){if(isArray(src)){dst=dst||[];for(var i=0,ii=src.length;i<ii;i++)dst[i]=src[i]}else if(isObject(src)){dst=dst||{};for(var key in src)"$"===key.charAt(0)&&"$"===key.charAt(1)||(dst[key]=src[key])}return dst||src}function equals(o1,o2){if(o1===o2)return!0;if(null===o1||null===o2)return!1;if(o1!==o1&&o2!==o2)return!0;var length,key,keySet,t1=typeof o1,t2=typeof o2;if(t1==t2&&"object"==t1){if(!isArray(o1)){if(isDate(o1))return!!isDate(o2)&&equals(o1.getTime(),o2.getTime());if(isRegExp(o1))return!!isRegExp(o2)&&o1.toString()==o2.toString();if(isScope(o1)||isScope(o2)||isWindow(o1)||isWindow(o2)||isArray(o2)||isDate(o2)||isRegExp(o2))return!1;keySet={};for(key in o1)if("$"!==key.charAt(0)&&!isFunction(o1[key])){if(!equals(o1[key],o2[key]))return!1;keySet[key]=!0}for(key in o2)if(!keySet.hasOwnProperty(key)&&"$"!==key.charAt(0)&&o2[key]!==undefined&&!isFunction(o2[key]))return!1;return!0}if(!isArray(o2))return!1;if((length=o1.length)==o2.length){for(key=0;key<length;key++)if(!equals(o1[key],o2[key]))return!1;return!0}}return!1}function concat(array1,array2,index){return array1.concat(slice.call(array2,index))}function sliceArgs(args,startIndex){return slice.call(args,startIndex||0)}function bind(self,fn){var curryArgs=arguments.length>2?sliceArgs(arguments,2):[];return!isFunction(fn)||fn instanceof RegExp?fn:curryArgs.length?function(){return arguments.length?fn.apply(self,concat(curryArgs,arguments,0)):fn.apply(self,curryArgs)}:function(){return arguments.length?fn.apply(self,arguments):fn.call(self)}}function toJsonReplacer(key,value){var val=value;return"string"==typeof key&&"$"===key.charAt(0)&&"$"===key.charAt(1)?val=undefined:isWindow(value)?val="$WINDOW":value&&document===value?val="$DOCUMENT":isScope(value)&&(val="$SCOPE"),val}function toJson(obj,pretty){return"undefined"==typeof obj?undefined:(isNumber(pretty)||(pretty=pretty?2:null),JSON.stringify(obj,toJsonReplacer,pretty))}function fromJson(json){return isString(json)?JSON.parse(json):json}function startingTag(element){element=jqLite(element).clone();try{element.empty()}catch(e){}var elemHtml=jqLite("<div>").append(element).html();try{return element[0].nodeType===NODE_TYPE_TEXT?lowercase(elemHtml):elemHtml.match(/^(<[^>]+>)/)[1].replace(/^<([\w\-]+)/,function(match,nodeName){return"<"+lowercase(nodeName)})}catch(e){return lowercase(elemHtml)}}function tryDecodeURIComponent(value){try{return decodeURIComponent(value)}catch(e){}}function parseKeyValue(keyValue){var key_value,key,obj={};return forEach((keyValue||"").split("&"),function(keyValue){if(keyValue&&(key_value=keyValue.replace(/\+/g,"%20").split("="),key=tryDecodeURIComponent(key_value[0]),isDefined(key))){var val=!isDefined(key_value[1])||tryDecodeURIComponent(key_value[1]);hasOwnProperty.call(obj,key)?isArray(obj[key])?obj[key].push(val):obj[key]=[obj[key],val]:obj[key]=val}}),obj}function toKeyValue(obj){var parts=[];return forEach(obj,function(value,key){isArray(value)?forEach(value,function(arrayValue){parts.push(encodeUriQuery(key,!0)+(arrayValue===!0?"":"="+encodeUriQuery(arrayValue,!0)))}):parts.push(encodeUriQuery(key,!0)+(value===!0?"":"="+encodeUriQuery(value,!0)))}),parts.length?parts.join("&"):""}function encodeUriSegment(val){return encodeUriQuery(val,!0).replace(/%26/gi,"&").replace(/%3D/gi,"=").replace(/%2B/gi,"+")}function encodeUriQuery(val,pctEncodeSpaces){return encodeURIComponent(val).replace(/%40/gi,"@").replace(/%3A/gi,":").replace(/%24/g,"$").replace(/%2C/gi,",").replace(/%3B/gi,";").replace(/%20/g,pctEncodeSpaces?"%20":"+")}function getNgAttribute(element,ngAttr){var attr,i,ii=ngAttrPrefixes.length;for(element=jqLite(element),i=0;i<ii;++i)if(attr=ngAttrPrefixes[i]+ngAttr,isString(attr=element.attr(attr)))return attr;return null}function angularInit(element,bootstrap){var appElement,module,config={};forEach(ngAttrPrefixes,function(prefix){var name=prefix+"app";!appElement&&element.hasAttribute&&element.hasAttribute(name)&&(appElement=element,module=element.getAttribute(name))}),forEach(ngAttrPrefixes,function(prefix){var candidate,name=prefix+"app";!appElement&&(candidate=element.querySelector("["+name.replace(":","\\:")+"]"))&&(appElement=candidate,module=candidate.getAttribute(name))}),appElement&&(config.strictDi=null!==getNgAttribute(appElement,"strict-di"),bootstrap(appElement,module?[module]:[],config))}function bootstrap(element,modules,config){isObject(config)||(config={});var defaultConfig={strictDi:!1};config=extend(defaultConfig,config);var doBootstrap=function(){if(element=jqLite(element),element.injector()){var tag=element[0]===document?"document":startingTag(element);throw ngMinErr("btstrpd","App Already Bootstrapped with this Element '{0}'",tag.replace(/</,"&lt;").replace(/>/,"&gt;"))}modules=modules||[],modules.unshift(["$provide",function($provide){$provide.value("$rootElement",element)}]),config.debugInfoEnabled&&modules.push(["$compileProvider",function($compileProvider){$compileProvider.debugInfoEnabled(!0)}]),modules.unshift("ng");var injector=createInjector(modules,config.strictDi);return injector.invoke(["$rootScope","$rootElement","$compile","$injector",function(scope,element,compile,injector){scope.$apply(function(){element.data("$injector",injector),compile(element)(scope)})}]),injector},NG_ENABLE_DEBUG_INFO=/^NG_ENABLE_DEBUG_INFO!/,NG_DEFER_BOOTSTRAP=/^NG_DEFER_BOOTSTRAP!/;return window&&NG_ENABLE_DEBUG_INFO.test(window.name)&&(config.debugInfoEnabled=!0,window.name=window.name.replace(NG_ENABLE_DEBUG_INFO,"")),window&&!NG_DEFER_BOOTSTRAP.test(window.name)?doBootstrap():(window.name=window.name.replace(NG_DEFER_BOOTSTRAP,""),angular.resumeBootstrap=function(extraModules){return forEach(extraModules,function(module){modules.push(module)}),doBootstrap()},void(isFunction(angular.resumeDeferredBootstrap)&&angular.resumeDeferredBootstrap()))}function reloadWithDebugInfo(){window.name="NG_ENABLE_DEBUG_INFO!"+window.name,window.location.reload()}function getTestability(rootElement){var injector=angular.element(rootElement).injector();if(!injector)throw ngMinErr("test","no injector found for element argument to getTestability");return injector.get("$$testability")}function snake_case(name,separator){return separator=separator||"_",name.replace(SNAKE_CASE_REGEXP,function(letter,pos){return(pos?separator:"")+letter.toLowerCase()})}function bindJQuery(){var originalCleanData;bindJQueryFired||(jQuery=window.jQuery,jQuery&&jQuery.fn.on?(jqLite=jQuery,extend(jQuery.fn,{scope:JQLitePrototype.scope,isolateScope:JQLitePrototype.isolateScope,controller:JQLitePrototype.controller,injector:JQLitePrototype.injector,inheritedData:JQLitePrototype.inheritedData}),originalCleanData=jQuery.cleanData,jQuery.cleanData=function(elems){var events;if(skipDestroyOnNextJQueryCleanData)skipDestroyOnNextJQueryCleanData=!1;else for(var elem,i=0;null!=(elem=elems[i]);i++)events=jQuery._data(elem,"events"),events&&events.$destroy&&jQuery(elem).triggerHandler("$destroy");originalCleanData(elems)}):jqLite=JQLite,angular.element=jqLite,bindJQueryFired=!0)}function assertArg(arg,name,reason){if(!arg)throw ngMinErr("areq","Argument '{0}' is {1}",name||"?",reason||"required");return arg}function assertArgFn(arg,name,acceptArrayAnnotation){return acceptArrayAnnotation&&isArray(arg)&&(arg=arg[arg.length-1]),assertArg(isFunction(arg),name,"not a function, got "+(arg&&"object"==typeof arg?arg.constructor.name||"Object":typeof arg)),arg}function assertNotHasOwnProperty(name,context){if("hasOwnProperty"===name)throw ngMinErr("badname","hasOwnProperty is not a valid {0} name",context)}function getter(obj,path,bindFnToScope){if(!path)return obj;for(var key,keys=path.split("."),lastInstance=obj,len=keys.length,i=0;i<len;i++)key=keys[i],obj&&(obj=(lastInstance=obj)[key]);return!bindFnToScope&&isFunction(obj)?bind(lastInstance,obj):obj}function getBlockNodes(nodes){var node=nodes[0],endNode=nodes[nodes.length-1],blockNodes=[node];do{if(node=node.nextSibling,!node)break;blockNodes.push(node)}while(node!==endNode);return jqLite(blockNodes)}function createMap(){return Object.create(null)}function setupModuleLoader(window){function ensure(obj,name,factory){return obj[name]||(obj[name]=factory())}var $injectorMinErr=minErr("$injector"),ngMinErr=minErr("ng"),angular=ensure(window,"angular",Object);return angular.$$minErr=angular.$$minErr||minErr,ensure(angular,"module",function(){var modules={};return function(name,requires,configFn){var assertNotHasOwnProperty=function(name,context){if("hasOwnProperty"===name)throw ngMinErr("badname","hasOwnProperty is not a valid {0} name",context)};return assertNotHasOwnProperty(name,"module"),requires&&modules.hasOwnProperty(name)&&(modules[name]=null),ensure(modules,name,function(){function invokeLater(provider,method,insertMethod,queue){return queue||(queue=invokeQueue),function(){return queue[insertMethod||"push"]([provider,method,arguments]),moduleInstance}}if(!requires)throw $injectorMinErr("nomod","Module '{0}' is not available! You either misspelled the module name or forgot to load it. If registering a module ensure that you specify the dependencies as the second argument.",name);var invokeQueue=[],configBlocks=[],runBlocks=[],config=invokeLater("$injector","invoke","push",configBlocks),moduleInstance={_invokeQueue:invokeQueue,_configBlocks:configBlocks,_runBlocks:runBlocks,requires:requires,name:name,provider:invokeLater("$provide","provider"),factory:invokeLater("$provide","factory"),service:invokeLater("$provide","service"),value:invokeLater("$provide","value"),constant:invokeLater("$provide","constant","unshift"),animation:invokeLater("$animateProvider","register"),filter:invokeLater("$filterProvider","register"),controller:invokeLater("$controllerProvider","register"),directive:invokeLater("$compileProvider","directive"),config:config,run:function(block){return runBlocks.push(block),this}};return configFn&&config(configFn),moduleInstance})}})}function serializeObject(obj){var seen=[];return JSON.stringify(obj,function(key,val){if(val=toJsonReplacer(key,val),isObject(val)){if(seen.indexOf(val)>=0)return"<<already seen>>";seen.push(val)}return val})}function toDebugString(obj){return"function"==typeof obj?obj.toString().replace(/ \{[\s\S]*$/,""):"undefined"==typeof obj?"undefined":"string"!=typeof obj?serializeObject(obj):obj}function publishExternalAPI(angular){extend(angular,{bootstrap:bootstrap,copy:copy,extend:extend,equals:equals,element:jqLite,forEach:forEach,injector:createInjector,noop:noop,bind:bind,toJson:toJson,fromJson:fromJson,identity:identity,isUndefined:isUndefined,isDefined:isDefined,isString:isString,isFunction:isFunction,isObject:isObject,isNumber:isNumber,isElement:isElement,isArray:isArray,version:version,isDate:isDate,lowercase:lowercase,uppercase:uppercase,callbacks:{counter:0},getTestability:getTestability,$$minErr:minErr,$$csp:csp,reloadWithDebugInfo:reloadWithDebugInfo}),angularModule=setupModuleLoader(window);try{angularModule("ngLocale")}catch(e){angularModule("ngLocale",[]).provider("$locale",$LocaleProvider)}angularModule("ng",["ngLocale"],["$provide",function($provide){$provide.provider({$$sanitizeUri:$$SanitizeUriProvider}),$provide.provider("$compile",$CompileProvider).directive({a:htmlAnchorDirective,input:inputDirective,textarea:inputDirective,form:formDirective,script:scriptDirective,select:selectDirective,style:styleDirective,option:optionDirective,ngBind:ngBindDirective,ngBindHtml:ngBindHtmlDirective,ngBindTemplate:ngBindTemplateDirective,ngClass:ngClassDirective,ngClassEven:ngClassEvenDirective,ngClassOdd:ngClassOddDirective,ngCloak:ngCloakDirective,ngController:ngControllerDirective,ngForm:ngFormDirective,ngHide:ngHideDirective,ngIf:ngIfDirective,ngInclude:ngIncludeDirective,ngInit:ngInitDirective,ngNonBindable:ngNonBindableDirective,ngPluralize:ngPluralizeDirective,ngRepeat:ngRepeatDirective,ngShow:ngShowDirective,ngStyle:ngStyleDirective,ngSwitch:ngSwitchDirective,ngSwitchWhen:ngSwitchWhenDirective,ngSwitchDefault:ngSwitchDefaultDirective,ngOptions:ngOptionsDirective,ngTransclude:ngTranscludeDirective,ngModel:ngModelDirective,ngList:ngListDirective,ngChange:ngChangeDirective,pattern:patternDirective,ngPattern:patternDirective,required:requiredDirective,ngRequired:requiredDirective,minlength:minlengthDirective,ngMinlength:minlengthDirective,maxlength:maxlengthDirective,ngMaxlength:maxlengthDirective,ngValue:ngValueDirective,ngModelOptions:ngModelOptionsDirective}).directive({ngInclude:ngIncludeFillContentDirective}).directive(ngAttributeAliasDirectives).directive(ngEventDirectives),$provide.provider({$anchorScroll:$AnchorScrollProvider,$animate:$AnimateProvider,$browser:$BrowserProvider,$cacheFactory:$CacheFactoryProvider,$controller:$ControllerProvider,$document:$DocumentProvider,$exceptionHandler:$ExceptionHandlerProvider,$filter:$FilterProvider,$interpolate:$InterpolateProvider,$interval:$IntervalProvider,$http:$HttpProvider,$httpBackend:$HttpBackendProvider,$location:$LocationProvider,$log:$LogProvider,$parse:$ParseProvider,$rootScope:$RootScopeProvider,$q:$QProvider,$$q:$$QProvider,$sce:$SceProvider,$sceDelegate:$SceDelegateProvider,$sniffer:$SnifferProvider,$templateCache:$TemplateCacheProvider,$templateRequest:$TemplateRequestProvider,$$testability:$$TestabilityProvider,$timeout:$TimeoutProvider,$window:$WindowProvider,$$rAF:$$RAFProvider,$$asyncCallback:$$AsyncCallbackProvider,$$jqLite:$$jqLiteProvider})}])}function jqNextId(){return++jqId}function camelCase(name){return name.replace(SPECIAL_CHARS_REGEXP,function(_,separator,letter,offset){return offset?letter.toUpperCase():letter}).replace(MOZ_HACK_REGEXP,"Moz$1")}function jqLiteIsTextNode(html){return!HTML_REGEXP.test(html)}function jqLiteAcceptsData(node){var nodeType=node.nodeType;return nodeType===NODE_TYPE_ELEMENT||!nodeType||nodeType===NODE_TYPE_DOCUMENT}function jqLiteBuildFragment(html,context){var tmp,tag,wrap,i,fragment=context.createDocumentFragment(),nodes=[];if(jqLiteIsTextNode(html))nodes.push(context.createTextNode(html));else{for(tmp=tmp||fragment.appendChild(context.createElement("div")),tag=(TAG_NAME_REGEXP.exec(html)||["",""])[1].toLowerCase(),wrap=wrapMap[tag]||wrapMap._default,tmp.innerHTML=wrap[1]+html.replace(XHTML_TAG_REGEXP,"<$1></$2>")+wrap[2],i=wrap[0];i--;)tmp=tmp.lastChild;nodes=concat(nodes,tmp.childNodes),tmp=fragment.firstChild,tmp.textContent=""}return fragment.textContent="",fragment.innerHTML="",forEach(nodes,function(node){fragment.appendChild(node)}),fragment}function jqLiteParseHTML(html,context){context=context||document;var parsed;return(parsed=SINGLE_TAG_REGEXP.exec(html))?[context.createElement(parsed[1])]:(parsed=jqLiteBuildFragment(html,context))?parsed.childNodes:[]}function JQLite(element){if(element instanceof JQLite)return element;var argIsString;if(isString(element)&&(element=trim(element),argIsString=!0),!(this instanceof JQLite)){if(argIsString&&"<"!=element.charAt(0))throw jqLiteMinErr("nosel","Looking up elements via selectors is not supported by jqLite! See: http://docs.angularjs.org/api/angular.element");return new JQLite(element)}argIsString?jqLiteAddNodes(this,jqLiteParseHTML(element)):jqLiteAddNodes(this,element)}function jqLiteClone(element){return element.cloneNode(!0)}function jqLiteDealoc(element,onlyDescendants){if(onlyDescendants||jqLiteRemoveData(element),element.querySelectorAll)for(var descendants=element.querySelectorAll("*"),i=0,l=descendants.length;i<l;i++)jqLiteRemoveData(descendants[i])}function jqLiteOff(element,type,fn,unsupported){if(isDefined(unsupported))throw jqLiteMinErr("offargs","jqLite#off() does not support the `selector` argument");var expandoStore=jqLiteExpandoStore(element),events=expandoStore&&expandoStore.events,handle=expandoStore&&expandoStore.handle;if(handle)if(type)forEach(type.split(" "),function(type){if(isDefined(fn)){var listenerFns=events[type];if(arrayRemove(listenerFns||[],fn),listenerFns&&listenerFns.length>0)return}removeEventListenerFn(element,type,handle),delete events[type]});else for(type in events)"$destroy"!==type&&removeEventListenerFn(element,type,handle),delete events[type]}function jqLiteRemoveData(element,name){var expandoId=element.ng339,expandoStore=expandoId&&jqCache[expandoId];if(expandoStore){if(name)return void delete expandoStore.data[name];expandoStore.handle&&(expandoStore.events.$destroy&&expandoStore.handle({},"$destroy"),jqLiteOff(element)),delete jqCache[expandoId],element.ng339=undefined}}function jqLiteExpandoStore(element,createIfNecessary){var expandoId=element.ng339,expandoStore=expandoId&&jqCache[expandoId];return createIfNecessary&&!expandoStore&&(element.ng339=expandoId=jqNextId(),expandoStore=jqCache[expandoId]={events:{},data:{},handle:undefined}),expandoStore}function jqLiteData(element,key,value){if(jqLiteAcceptsData(element)){var isSimpleSetter=isDefined(value),isSimpleGetter=!isSimpleSetter&&key&&!isObject(key),massGetter=!key,expandoStore=jqLiteExpandoStore(element,!isSimpleGetter),data=expandoStore&&expandoStore.data;if(isSimpleSetter)data[key]=value;else{if(massGetter)return data;if(isSimpleGetter)return data&&data[key];extend(data,key)}}}function jqLiteHasClass(element,selector){return!!element.getAttribute&&(" "+(element.getAttribute("class")||"")+" ").replace(/[\n\t]/g," ").indexOf(" "+selector+" ")>-1}function jqLiteRemoveClass(element,cssClasses){cssClasses&&element.setAttribute&&forEach(cssClasses.split(" "),function(cssClass){element.setAttribute("class",trim((" "+(element.getAttribute("class")||"")+" ").replace(/[\n\t]/g," ").replace(" "+trim(cssClass)+" "," ")))})}function jqLiteAddClass(element,cssClasses){if(cssClasses&&element.setAttribute){var existingClasses=(" "+(element.getAttribute("class")||"")+" ").replace(/[\n\t]/g," ");forEach(cssClasses.split(" "),function(cssClass){cssClass=trim(cssClass),existingClasses.indexOf(" "+cssClass+" ")===-1&&(existingClasses+=cssClass+" ")}),element.setAttribute("class",trim(existingClasses))}}function jqLiteAddNodes(root,elements){if(elements)if(elements.nodeType)root[root.length++]=elements;else{var length=elements.length;if("number"==typeof length&&elements.window!==elements){if(length)for(var i=0;i<length;i++)root[root.length++]=elements[i]}else root[root.length++]=elements}}function jqLiteController(element,name){return jqLiteInheritedData(element,"$"+(name||"ngController")+"Controller")}function jqLiteInheritedData(element,name,value){element.nodeType==NODE_TYPE_DOCUMENT&&(element=element.documentElement);for(var names=isArray(name)?name:[name];element;){for(var i=0,ii=names.length;i<ii;i++)if((value=jqLite.data(element,names[i]))!==undefined)return value;element=element.parentNode||element.nodeType===NODE_TYPE_DOCUMENT_FRAGMENT&&element.host}}function jqLiteEmpty(element){for(jqLiteDealoc(element,!0);element.firstChild;)element.removeChild(element.firstChild)}function jqLiteRemove(element,keepData){keepData||jqLiteDealoc(element);var parent=element.parentNode;parent&&parent.removeChild(element)}function jqLiteDocumentLoaded(action,win){win=win||window,"complete"===win.document.readyState?win.setTimeout(action):jqLite(win).on("load",action)}function getBooleanAttrName(element,name){var booleanAttr=BOOLEAN_ATTR[name.toLowerCase()];return booleanAttr&&BOOLEAN_ELEMENTS[nodeName_(element)]&&booleanAttr}function getAliasedAttrName(element,name){var nodeName=element.nodeName;return("INPUT"===nodeName||"TEXTAREA"===nodeName)&&ALIASED_ATTR[name]}function createEventHandler(element,events){var eventHandler=function(event,type){event.isDefaultPrevented=function(){return event.defaultPrevented};var eventFns=events[type||event.type],eventFnsLength=eventFns?eventFns.length:0;if(eventFnsLength){if(isUndefined(event.immediatePropagationStopped)){var originalStopImmediatePropagation=event.stopImmediatePropagation;event.stopImmediatePropagation=function(){event.immediatePropagationStopped=!0,event.stopPropagation&&event.stopPropagation(),originalStopImmediatePropagation&&originalStopImmediatePropagation.call(event)}}event.isImmediatePropagationStopped=function(){return event.immediatePropagationStopped===!0},eventFnsLength>1&&(eventFns=shallowCopy(eventFns));for(var i=0;i<eventFnsLength;i++)event.isImmediatePropagationStopped()||eventFns[i].call(element,event)}};return eventHandler.elem=element,eventHandler}function $$jqLiteProvider(){this.$get=function(){return extend(JQLite,{hasClass:function(node,classes){return node.attr&&(node=node[0]),jqLiteHasClass(node,classes)},addClass:function(node,classes){return node.attr&&(node=node[0]),jqLiteAddClass(node,classes)},removeClass:function(node,classes){return node.attr&&(node=node[0]),jqLiteRemoveClass(node,classes)}})}}function hashKey(obj,nextUidFn){var key=obj&&obj.$$hashKey;if(key)return"function"==typeof key&&(key=obj.$$hashKey()),key;var objType=typeof obj;return key="function"==objType||"object"==objType&&null!==obj?obj.$$hashKey=objType+":"+(nextUidFn||nextUid)():objType+":"+obj}function HashMap(array,isolatedUid){if(isolatedUid){var uid=0;this.nextUid=function(){return++uid}}forEach(array,this.put,this)}function anonFn(fn){var fnText=fn.toString().replace(STRIP_COMMENTS,""),args=fnText.match(FN_ARGS);return args?"function("+(args[1]||"").replace(/[\s\r\n]+/," ")+")":"fn"}function annotate(fn,strictDi,name){var $inject,fnText,argDecl,last;if("function"==typeof fn){if(!($inject=fn.$inject)){if($inject=[],fn.length){if(strictDi)throw isString(name)&&name||(name=fn.name||anonFn(fn)),$injectorMinErr("strictdi","{0} is not using explicit annotation and cannot be invoked in strict mode",name);fnText=fn.toString().replace(STRIP_COMMENTS,""),argDecl=fnText.match(FN_ARGS),forEach(argDecl[1].split(FN_ARG_SPLIT),function(arg){arg.replace(FN_ARG,function(all,underscore,name){$inject.push(name)})})}fn.$inject=$inject}}else isArray(fn)?(last=fn.length-1,assertArgFn(fn[last],"fn"),$inject=fn.slice(0,last)):assertArgFn(fn,"fn",!0);return $inject}function createInjector(modulesToLoad,strictDi){function supportObject(delegate){return function(key,value){return isObject(key)?void forEach(key,reverseParams(delegate)):delegate(key,value)}}function provider(name,provider_){if(assertNotHasOwnProperty(name,"service"),(isFunction(provider_)||isArray(provider_))&&(provider_=providerInjector.instantiate(provider_)),!provider_.$get)throw $injectorMinErr("pget","Provider '{0}' must define $get factory method.",name);return providerCache[name+providerSuffix]=provider_;
}function enforceReturnValue(name,factory){return function(){var result=instanceInjector.invoke(factory,this);if(isUndefined(result))throw $injectorMinErr("undef","Provider '{0}' must return a value from $get factory method.",name);return result}}function factory(name,factoryFn,enforce){return provider(name,{$get:enforce!==!1?enforceReturnValue(name,factoryFn):factoryFn})}function service(name,constructor){return factory(name,["$injector",function($injector){return $injector.instantiate(constructor)}])}function value(name,val){return factory(name,valueFn(val),!1)}function constant(name,value){assertNotHasOwnProperty(name,"constant"),providerCache[name]=value,instanceCache[name]=value}function decorator(serviceName,decorFn){var origProvider=providerInjector.get(serviceName+providerSuffix),orig$get=origProvider.$get;origProvider.$get=function(){var origInstance=instanceInjector.invoke(orig$get,origProvider);return instanceInjector.invoke(decorFn,null,{$delegate:origInstance})}}function loadModules(modulesToLoad){var moduleFn,runBlocks=[];return forEach(modulesToLoad,function(module){function runInvokeQueue(queue){var i,ii;for(i=0,ii=queue.length;i<ii;i++){var invokeArgs=queue[i],provider=providerInjector.get(invokeArgs[0]);provider[invokeArgs[1]].apply(provider,invokeArgs[2])}}if(!loadedModules.get(module)){loadedModules.put(module,!0);try{isString(module)?(moduleFn=angularModule(module),runBlocks=runBlocks.concat(loadModules(moduleFn.requires)).concat(moduleFn._runBlocks),runInvokeQueue(moduleFn._invokeQueue),runInvokeQueue(moduleFn._configBlocks)):isFunction(module)?runBlocks.push(providerInjector.invoke(module)):isArray(module)?runBlocks.push(providerInjector.invoke(module)):assertArgFn(module,"module")}catch(e){throw isArray(module)&&(module=module[module.length-1]),e.message&&e.stack&&e.stack.indexOf(e.message)==-1&&(e=e.message+"\n"+e.stack),$injectorMinErr("modulerr","Failed to instantiate module {0} due to:\n{1}",module,e.stack||e.message||e)}}}),runBlocks}function createInternalInjector(cache,factory){function getService(serviceName,caller){if(cache.hasOwnProperty(serviceName)){if(cache[serviceName]===INSTANTIATING)throw $injectorMinErr("cdep","Circular dependency found: {0}",serviceName+" <- "+path.join(" <- "));return cache[serviceName]}try{return path.unshift(serviceName),cache[serviceName]=INSTANTIATING,cache[serviceName]=factory(serviceName,caller)}catch(err){throw cache[serviceName]===INSTANTIATING&&delete cache[serviceName],err}finally{path.shift()}}function invoke(fn,self,locals,serviceName){"string"==typeof locals&&(serviceName=locals,locals=null);var length,i,key,args=[],$inject=createInjector.$$annotate(fn,strictDi,serviceName);for(i=0,length=$inject.length;i<length;i++){if(key=$inject[i],"string"!=typeof key)throw $injectorMinErr("itkn","Incorrect injection token! Expected service name as string, got {0}",key);args.push(locals&&locals.hasOwnProperty(key)?locals[key]:getService(key,serviceName))}return isArray(fn)&&(fn=fn[length]),fn.apply(self,args)}function instantiate(Type,locals,serviceName){var instance=Object.create((isArray(Type)?Type[Type.length-1]:Type).prototype||null),returnedValue=invoke(Type,instance,locals,serviceName);return isObject(returnedValue)||isFunction(returnedValue)?returnedValue:instance}return{invoke:invoke,instantiate:instantiate,get:getService,annotate:createInjector.$$annotate,has:function(name){return providerCache.hasOwnProperty(name+providerSuffix)||cache.hasOwnProperty(name)}}}strictDi=strictDi===!0;var INSTANTIATING={},providerSuffix="Provider",path=[],loadedModules=new HashMap([],(!0)),providerCache={$provide:{provider:supportObject(provider),factory:supportObject(factory),service:supportObject(service),value:supportObject(value),constant:supportObject(constant),decorator:decorator}},providerInjector=providerCache.$injector=createInternalInjector(providerCache,function(serviceName,caller){throw angular.isString(caller)&&path.push(caller),$injectorMinErr("unpr","Unknown provider: {0}",path.join(" <- "))}),instanceCache={},instanceInjector=instanceCache.$injector=createInternalInjector(instanceCache,function(serviceName,caller){var provider=providerInjector.get(serviceName+providerSuffix,caller);return instanceInjector.invoke(provider.$get,provider,undefined,serviceName)});return forEach(loadModules(modulesToLoad),function(fn){instanceInjector.invoke(fn||noop)}),instanceInjector}function $AnchorScrollProvider(){var autoScrollingEnabled=!0;this.disableAutoScrolling=function(){autoScrollingEnabled=!1},this.$get=["$window","$location","$rootScope",function($window,$location,$rootScope){function getFirstAnchor(list){var result=null;return Array.prototype.some.call(list,function(element){if("a"===nodeName_(element))return result=element,!0}),result}function getYOffset(){var offset=scroll.yOffset;if(isFunction(offset))offset=offset();else if(isElement(offset)){var elem=offset[0],style=$window.getComputedStyle(elem);offset="fixed"!==style.position?0:elem.getBoundingClientRect().bottom}else isNumber(offset)||(offset=0);return offset}function scrollTo(elem){if(elem){elem.scrollIntoView();var offset=getYOffset();if(offset){var elemTop=elem.getBoundingClientRect().top;$window.scrollBy(0,elemTop-offset)}}else $window.scrollTo(0,0)}function scroll(){var elm,hash=$location.hash();hash?(elm=document.getElementById(hash))?scrollTo(elm):(elm=getFirstAnchor(document.getElementsByName(hash)))?scrollTo(elm):"top"===hash&&scrollTo(null):scrollTo(null)}var document=$window.document;return autoScrollingEnabled&&$rootScope.$watch(function(){return $location.hash()},function(newVal,oldVal){newVal===oldVal&&""===newVal||jqLiteDocumentLoaded(function(){$rootScope.$evalAsync(scroll)})}),scroll}]}function $$AsyncCallbackProvider(){this.$get=["$$rAF","$timeout",function($$rAF,$timeout){return $$rAF.supported?function(fn){return $$rAF(fn)}:function(fn){return $timeout(fn,0,!1)}}]}function Browser(window,document,$log,$sniffer){function completeOutstandingRequest(fn){try{fn.apply(null,sliceArgs(arguments,1))}finally{if(outstandingRequestCount--,0===outstandingRequestCount)for(;outstandingRequestCallbacks.length;)try{outstandingRequestCallbacks.pop()()}catch(e){$log.error(e)}}}function getHash(url){var index=url.indexOf("#");return index===-1?"":url.substr(index)}function startPoller(interval,setTimeout){!function check(){forEach(pollFns,function(pollFn){pollFn()}),pollTimeout=setTimeout(check,interval)}()}function cacheStateAndFireUrlChange(){cacheState(),fireUrlChange()}function getCurrentState(){try{return history.state}catch(e){}}function cacheState(){cachedState=getCurrentState(),cachedState=isUndefined(cachedState)?null:cachedState,equals(cachedState,lastCachedState)&&(cachedState=lastCachedState),lastCachedState=cachedState}function fireUrlChange(){lastBrowserUrl===self.url()&&lastHistoryState===cachedState||(lastBrowserUrl=self.url(),lastHistoryState=cachedState,forEach(urlChangeListeners,function(listener){listener(self.url(),cachedState)}))}function safeDecodeURIComponent(str){try{return decodeURIComponent(str)}catch(e){return str}}var self=this,rawDocument=document[0],location=window.location,history=window.history,setTimeout=window.setTimeout,clearTimeout=window.clearTimeout,pendingDeferIds={};self.isMock=!1;var outstandingRequestCount=0,outstandingRequestCallbacks=[];self.$$completeOutstandingRequest=completeOutstandingRequest,self.$$incOutstandingRequestCount=function(){outstandingRequestCount++},self.notifyWhenNoOutstandingRequests=function(callback){forEach(pollFns,function(pollFn){pollFn()}),0===outstandingRequestCount?callback():outstandingRequestCallbacks.push(callback)};var pollTimeout,pollFns=[];self.addPollFn=function(fn){return isUndefined(pollTimeout)&&startPoller(100,setTimeout),pollFns.push(fn),fn};var cachedState,lastHistoryState,lastBrowserUrl=location.href,baseElement=document.find("base"),reloadLocation=null;cacheState(),lastHistoryState=cachedState,self.url=function(url,replace,state){if(isUndefined(state)&&(state=null),location!==window.location&&(location=window.location),history!==window.history&&(history=window.history),url){var sameState=lastHistoryState===state;if(lastBrowserUrl===url&&(!$sniffer.history||sameState))return self;var sameBase=lastBrowserUrl&&stripHash(lastBrowserUrl)===stripHash(url);return lastBrowserUrl=url,lastHistoryState=state,!$sniffer.history||sameBase&&sameState?(sameBase&&!reloadLocation||(reloadLocation=url),replace?location.replace(url):sameBase?location.hash=getHash(url):location.href=url):(history[replace?"replaceState":"pushState"](state,"",url),cacheState(),lastHistoryState=cachedState),self}return reloadLocation||location.href.replace(/%27/g,"'")},self.state=function(){return cachedState};var urlChangeListeners=[],urlChangeInit=!1,lastCachedState=null;self.onUrlChange=function(callback){return urlChangeInit||($sniffer.history&&jqLite(window).on("popstate",cacheStateAndFireUrlChange),jqLite(window).on("hashchange",cacheStateAndFireUrlChange),urlChangeInit=!0),urlChangeListeners.push(callback),callback},self.$$checkUrlChange=fireUrlChange,self.baseHref=function(){var href=baseElement.attr("href");return href?href.replace(/^(https?\:)?\/\/[^\/]*/,""):""};var lastCookies={},lastCookieString="",cookiePath=self.baseHref();self.cookies=function(name,value){var cookieLength,cookieArray,cookie,i,index;if(!name){if(rawDocument.cookie!==lastCookieString)for(lastCookieString=rawDocument.cookie,cookieArray=lastCookieString.split("; "),lastCookies={},i=0;i<cookieArray.length;i++)cookie=cookieArray[i],index=cookie.indexOf("="),index>0&&(name=safeDecodeURIComponent(cookie.substring(0,index)),lastCookies[name]===undefined&&(lastCookies[name]=safeDecodeURIComponent(cookie.substring(index+1))));return lastCookies}value===undefined?rawDocument.cookie=encodeURIComponent(name)+"=;path="+cookiePath+";expires=Thu, 01 Jan 1970 00:00:00 GMT":isString(value)&&(cookieLength=(rawDocument.cookie=encodeURIComponent(name)+"="+encodeURIComponent(value)+";path="+cookiePath).length+1,cookieLength>4096&&$log.warn("Cookie '"+name+"' possibly not set or overflowed because it was too large ("+cookieLength+" > 4096 bytes)!"))},self.defer=function(fn,delay){var timeoutId;return outstandingRequestCount++,timeoutId=setTimeout(function(){delete pendingDeferIds[timeoutId],completeOutstandingRequest(fn)},delay||0),pendingDeferIds[timeoutId]=!0,timeoutId},self.defer.cancel=function(deferId){return!!pendingDeferIds[deferId]&&(delete pendingDeferIds[deferId],clearTimeout(deferId),completeOutstandingRequest(noop),!0)}}function $BrowserProvider(){this.$get=["$window","$log","$sniffer","$document",function($window,$log,$sniffer,$document){return new Browser($window,$document,$log,$sniffer)}]}function $CacheFactoryProvider(){this.$get=function(){function cacheFactory(cacheId,options){function refresh(entry){entry!=freshEnd&&(staleEnd?staleEnd==entry&&(staleEnd=entry.n):staleEnd=entry,link(entry.n,entry.p),link(entry,freshEnd),freshEnd=entry,freshEnd.n=null)}function link(nextEntry,prevEntry){nextEntry!=prevEntry&&(nextEntry&&(nextEntry.p=prevEntry),prevEntry&&(prevEntry.n=nextEntry))}if(cacheId in caches)throw minErr("$cacheFactory")("iid","CacheId '{0}' is already taken!",cacheId);var size=0,stats=extend({},options,{id:cacheId}),data={},capacity=options&&options.capacity||Number.MAX_VALUE,lruHash={},freshEnd=null,staleEnd=null;return caches[cacheId]={put:function(key,value){if(capacity<Number.MAX_VALUE){var lruEntry=lruHash[key]||(lruHash[key]={key:key});refresh(lruEntry)}if(!isUndefined(value))return key in data||size++,data[key]=value,size>capacity&&this.remove(staleEnd.key),value},get:function(key){if(capacity<Number.MAX_VALUE){var lruEntry=lruHash[key];if(!lruEntry)return;refresh(lruEntry)}return data[key]},remove:function(key){if(capacity<Number.MAX_VALUE){var lruEntry=lruHash[key];if(!lruEntry)return;lruEntry==freshEnd&&(freshEnd=lruEntry.p),lruEntry==staleEnd&&(staleEnd=lruEntry.n),link(lruEntry.n,lruEntry.p),delete lruHash[key]}delete data[key],size--},removeAll:function(){data={},size=0,lruHash={},freshEnd=staleEnd=null},destroy:function(){data=null,stats=null,lruHash=null,delete caches[cacheId]},info:function(){return extend({},stats,{size:size})}}}var caches={};return cacheFactory.info=function(){var info={};return forEach(caches,function(cache,cacheId){info[cacheId]=cache.info()}),info},cacheFactory.get=function(cacheId){return caches[cacheId]},cacheFactory}}function $TemplateCacheProvider(){this.$get=["$cacheFactory",function($cacheFactory){return $cacheFactory("templates")}]}function $CompileProvider($provide,$$sanitizeUriProvider){function parseIsolateBindings(scope,directiveName){var LOCAL_REGEXP=/^\s*([@&]|=(\*?))(\??)\s*(\w*)\s*$/,bindings={};return forEach(scope,function(definition,scopeName){var match=definition.match(LOCAL_REGEXP);if(!match)throw $compileMinErr("iscp","Invalid isolate scope definition for directive '{0}'. Definition: {... {1}: '{2}' ...}",directiveName,scopeName,definition);bindings[scopeName]={mode:match[1][0],collection:"*"===match[2],optional:"?"===match[3],attrName:match[4]||scopeName}}),bindings}var hasDirectives={},Suffix="Directive",COMMENT_DIRECTIVE_REGEXP=/^\s*directive\:\s*([\w\-]+)\s+(.*)$/,CLASS_DIRECTIVE_REGEXP=/(([\w\-]+)(?:\:([^;]+))?;?)/,ALL_OR_NOTHING_ATTRS=makeMap("ngSrc,ngSrcset,src,srcset"),REQUIRE_PREFIX_REGEXP=/^(?:(\^\^?)?(\?)?(\^\^?)?)?/,EVENT_HANDLER_ATTR_REGEXP=/^(on[a-z]+|formaction)$/;this.directive=function registerDirective(name,directiveFactory){return assertNotHasOwnProperty(name,"directive"),isString(name)?(assertArg(directiveFactory,"directiveFactory"),hasDirectives.hasOwnProperty(name)||(hasDirectives[name]=[],$provide.factory(name+Suffix,["$injector","$exceptionHandler",function($injector,$exceptionHandler){var directives=[];return forEach(hasDirectives[name],function(directiveFactory,index){try{var directive=$injector.invoke(directiveFactory);isFunction(directive)?directive={compile:valueFn(directive)}:!directive.compile&&directive.link&&(directive.compile=valueFn(directive.link)),directive.priority=directive.priority||0,directive.index=index,directive.name=directive.name||name,directive.require=directive.require||directive.controller&&directive.name,directive.restrict=directive.restrict||"EA",isObject(directive.scope)&&(directive.$$isolateBindings=parseIsolateBindings(directive.scope,directive.name)),directives.push(directive)}catch(e){$exceptionHandler(e)}}),directives}])),hasDirectives[name].push(directiveFactory)):forEach(name,reverseParams(registerDirective)),this},this.aHrefSanitizationWhitelist=function(regexp){return isDefined(regexp)?($$sanitizeUriProvider.aHrefSanitizationWhitelist(regexp),this):$$sanitizeUriProvider.aHrefSanitizationWhitelist()},this.imgSrcSanitizationWhitelist=function(regexp){return isDefined(regexp)?($$sanitizeUriProvider.imgSrcSanitizationWhitelist(regexp),this):$$sanitizeUriProvider.imgSrcSanitizationWhitelist()};var debugInfoEnabled=!0;this.debugInfoEnabled=function(enabled){return isDefined(enabled)?(debugInfoEnabled=enabled,this):debugInfoEnabled},this.$get=["$injector","$interpolate","$exceptionHandler","$templateRequest","$parse","$controller","$rootScope","$document","$sce","$animate","$$sanitizeUri",function($injector,$interpolate,$exceptionHandler,$templateRequest,$parse,$controller,$rootScope,$document,$sce,$animate,$$sanitizeUri){function safeAddClass($element,className){try{$element.addClass(className)}catch(e){}}function compile($compileNodes,transcludeFn,maxPriority,ignoreDirective,previousCompileContext){$compileNodes instanceof jqLite||($compileNodes=jqLite($compileNodes)),forEach($compileNodes,function(node,index){node.nodeType==NODE_TYPE_TEXT&&node.nodeValue.match(/\S+/)&&($compileNodes[index]=jqLite(node).wrap("<span></span>").parent()[0])});var compositeLinkFn=compileNodes($compileNodes,transcludeFn,$compileNodes,maxPriority,ignoreDirective,previousCompileContext);compile.$$addScopeClass($compileNodes);var namespace=null;return function(scope,cloneConnectFn,options){assertArg(scope,"scope"),options=options||{};var parentBoundTranscludeFn=options.parentBoundTranscludeFn,transcludeControllers=options.transcludeControllers,futureParentElement=options.futureParentElement;parentBoundTranscludeFn&&parentBoundTranscludeFn.$$boundTransclude&&(parentBoundTranscludeFn=parentBoundTranscludeFn.$$boundTransclude),namespace||(namespace=detectNamespaceForChildElements(futureParentElement));var $linkNode;if($linkNode="html"!==namespace?jqLite(wrapTemplate(namespace,jqLite("<div>").append($compileNodes).html())):cloneConnectFn?JQLitePrototype.clone.call($compileNodes):$compileNodes,transcludeControllers)for(var controllerName in transcludeControllers)$linkNode.data("$"+controllerName+"Controller",transcludeControllers[controllerName].instance);return compile.$$addScopeInfo($linkNode,scope),cloneConnectFn&&cloneConnectFn($linkNode,scope),compositeLinkFn&&compositeLinkFn(scope,$linkNode,$linkNode,parentBoundTranscludeFn),$linkNode}}function detectNamespaceForChildElements(parentElement){var node=parentElement&&parentElement[0];return node&&"foreignobject"!==nodeName_(node)&&node.toString().match(/SVG/)?"svg":"html"}function compileNodes(nodeList,transcludeFn,$rootElement,maxPriority,ignoreDirective,previousCompileContext){function compositeLinkFn(scope,nodeList,$rootElement,parentBoundTranscludeFn){var nodeLinkFn,childLinkFn,node,childScope,i,ii,idx,childBoundTranscludeFn,stableNodeList;if(nodeLinkFnFound){var nodeListLength=nodeList.length;for(stableNodeList=new Array(nodeListLength),i=0;i<linkFns.length;i+=3)idx=linkFns[i],stableNodeList[idx]=nodeList[idx]}else stableNodeList=nodeList;for(i=0,ii=linkFns.length;i<ii;)node=stableNodeList[linkFns[i++]],nodeLinkFn=linkFns[i++],childLinkFn=linkFns[i++],nodeLinkFn?(nodeLinkFn.scope?(childScope=scope.$new(),compile.$$addScopeInfo(jqLite(node),childScope)):childScope=scope,childBoundTranscludeFn=nodeLinkFn.transcludeOnThisElement?createBoundTranscludeFn(scope,nodeLinkFn.transclude,parentBoundTranscludeFn,nodeLinkFn.elementTranscludeOnThisElement):!nodeLinkFn.templateOnThisElement&&parentBoundTranscludeFn?parentBoundTranscludeFn:!parentBoundTranscludeFn&&transcludeFn?createBoundTranscludeFn(scope,transcludeFn):null,nodeLinkFn(childLinkFn,childScope,node,$rootElement,childBoundTranscludeFn)):childLinkFn&&childLinkFn(scope,node.childNodes,undefined,parentBoundTranscludeFn)}for(var attrs,directives,nodeLinkFn,childNodes,childLinkFn,linkFnFound,nodeLinkFnFound,linkFns=[],i=0;i<nodeList.length;i++)attrs=new Attributes,directives=collectDirectives(nodeList[i],[],attrs,0===i?maxPriority:undefined,ignoreDirective),nodeLinkFn=directives.length?applyDirectivesToNode(directives,nodeList[i],attrs,transcludeFn,$rootElement,null,[],[],previousCompileContext):null,nodeLinkFn&&nodeLinkFn.scope&&compile.$$addScopeClass(attrs.$$element),childLinkFn=nodeLinkFn&&nodeLinkFn.terminal||!(childNodes=nodeList[i].childNodes)||!childNodes.length?null:compileNodes(childNodes,nodeLinkFn?(nodeLinkFn.transcludeOnThisElement||!nodeLinkFn.templateOnThisElement)&&nodeLinkFn.transclude:transcludeFn),(nodeLinkFn||childLinkFn)&&(linkFns.push(i,nodeLinkFn,childLinkFn),linkFnFound=!0,nodeLinkFnFound=nodeLinkFnFound||nodeLinkFn),previousCompileContext=null;return linkFnFound?compositeLinkFn:null}function createBoundTranscludeFn(scope,transcludeFn,previousBoundTranscludeFn,elementTransclusion){var boundTranscludeFn=function(transcludedScope,cloneFn,controllers,futureParentElement,containingScope){return transcludedScope||(transcludedScope=scope.$new(!1,containingScope),transcludedScope.$$transcluded=!0),transcludeFn(transcludedScope,cloneFn,{parentBoundTranscludeFn:previousBoundTranscludeFn,transcludeControllers:controllers,futureParentElement:futureParentElement})};return boundTranscludeFn}function collectDirectives(node,directives,attrs,maxPriority,ignoreDirective){var match,className,nodeType=node.nodeType,attrsMap=attrs.$attr;switch(nodeType){case NODE_TYPE_ELEMENT:addDirective(directives,directiveNormalize(nodeName_(node)),"E",maxPriority,ignoreDirective);for(var attr,name,nName,ngAttrName,value,isNgAttr,nAttrs=node.attributes,j=0,jj=nAttrs&&nAttrs.length;j<jj;j++){var attrStartName=!1,attrEndName=!1;attr=nAttrs[j],name=attr.name,value=trim(attr.value),ngAttrName=directiveNormalize(name),(isNgAttr=NG_ATTR_BINDING.test(ngAttrName))&&(name=name.replace(PREFIX_REGEXP,"").substr(8).replace(/_(.)/g,function(match,letter){return letter.toUpperCase()}));var directiveNName=ngAttrName.replace(/(Start|End)$/,"");directiveIsMultiElement(directiveNName)&&ngAttrName===directiveNName+"Start"&&(attrStartName=name,attrEndName=name.substr(0,name.length-5)+"end",name=name.substr(0,name.length-6)),nName=directiveNormalize(name.toLowerCase()),attrsMap[nName]=name,!isNgAttr&&attrs.hasOwnProperty(nName)||(attrs[nName]=value,getBooleanAttrName(node,nName)&&(attrs[nName]=!0)),addAttrInterpolateDirective(node,directives,value,nName,isNgAttr),addDirective(directives,nName,"A",maxPriority,ignoreDirective,attrStartName,attrEndName)}if(className=node.className,isObject(className)&&(className=className.animVal),isString(className)&&""!==className)for(;match=CLASS_DIRECTIVE_REGEXP.exec(className);)nName=directiveNormalize(match[2]),addDirective(directives,nName,"C",maxPriority,ignoreDirective)&&(attrs[nName]=trim(match[3])),className=className.substr(match.index+match[0].length);break;case NODE_TYPE_TEXT:addTextInterpolateDirective(directives,node.nodeValue);break;case NODE_TYPE_COMMENT:try{match=COMMENT_DIRECTIVE_REGEXP.exec(node.nodeValue),match&&(nName=directiveNormalize(match[1]),addDirective(directives,nName,"M",maxPriority,ignoreDirective)&&(attrs[nName]=trim(match[2])))}catch(e){}}return directives.sort(byPriority),directives}function groupScan(node,attrStart,attrEnd){var nodes=[],depth=0;if(attrStart&&node.hasAttribute&&node.hasAttribute(attrStart)){do{if(!node)throw $compileMinErr("uterdir","Unterminated attribute, found '{0}' but no matching '{1}' found.",attrStart,attrEnd);node.nodeType==NODE_TYPE_ELEMENT&&(node.hasAttribute(attrStart)&&depth++,node.hasAttribute(attrEnd)&&depth--),nodes.push(node),node=node.nextSibling}while(depth>0)}else nodes.push(node);return jqLite(nodes)}function groupElementsLinkFnWrapper(linkFn,attrStart,attrEnd){return function(scope,element,attrs,controllers,transcludeFn){return element=groupScan(element[0],attrStart,attrEnd),linkFn(scope,element,attrs,controllers,transcludeFn)}}function applyDirectivesToNode(directives,compileNode,templateAttrs,transcludeFn,jqCollection,originalReplaceDirective,preLinkFns,postLinkFns,previousCompileContext){function addLinkFns(pre,post,attrStart,attrEnd){pre&&(attrStart&&(pre=groupElementsLinkFnWrapper(pre,attrStart,attrEnd)),pre.require=directive.require,pre.directiveName=directiveName,(newIsolateScopeDirective===directive||directive.$$isolateScope)&&(pre=cloneAndAnnotateFn(pre,{isolateScope:!0})),preLinkFns.push(pre)),post&&(attrStart&&(post=groupElementsLinkFnWrapper(post,attrStart,attrEnd)),post.require=directive.require,post.directiveName=directiveName,(newIsolateScopeDirective===directive||directive.$$isolateScope)&&(post=cloneAndAnnotateFn(post,{isolateScope:!0})),postLinkFns.push(post))}function getControllers(directiveName,require,$element,elementControllers){var value,match,retrievalMethod="data",optional=!1,$searchElement=$element;if(isString(require)){if(match=require.match(REQUIRE_PREFIX_REGEXP),require=require.substring(match[0].length),match[3]&&(match[1]?match[3]=null:match[1]=match[3]),"^"===match[1]?retrievalMethod="inheritedData":"^^"===match[1]&&(retrievalMethod="inheritedData",$searchElement=$element.parent()),"?"===match[2]&&(optional=!0),value=null,elementControllers&&"data"===retrievalMethod&&(value=elementControllers[require])&&(value=value.instance),value=value||$searchElement[retrievalMethod]("$"+require+"Controller"),!value&&!optional)throw $compileMinErr("ctreq","Controller '{0}', required by directive '{1}', can't be found!",require,directiveName);return value||null}return isArray(require)&&(value=[],forEach(require,function(require){value.push(getControllers(directiveName,require,$element,elementControllers))})),value}function nodeLinkFn(childLinkFn,scope,linkNode,$rootElement,boundTranscludeFn){function controllersBoundTransclude(scope,cloneAttachFn,futureParentElement){var transcludeControllers;return isScope(scope)||(futureParentElement=cloneAttachFn,cloneAttachFn=scope,scope=undefined),hasElementTranscludeDirective&&(transcludeControllers=elementControllers),futureParentElement||(futureParentElement=hasElementTranscludeDirective?$element.parent():$element),boundTranscludeFn(scope,cloneAttachFn,transcludeControllers,futureParentElement,scopeToChild)}var i,ii,linkFn,controller,isolateScope,elementControllers,transcludeFn,$element,attrs;if(compileNode===linkNode?(attrs=templateAttrs,$element=templateAttrs.$$element):($element=jqLite(linkNode),attrs=new Attributes($element,templateAttrs)),newIsolateScopeDirective&&(isolateScope=scope.$new(!0)),boundTranscludeFn&&(transcludeFn=controllersBoundTransclude,transcludeFn.$$boundTransclude=boundTranscludeFn),controllerDirectives&&(controllers={},elementControllers={},forEach(controllerDirectives,function(directive){var controllerInstance,locals={$scope:directive===newIsolateScopeDirective||directive.$$isolateScope?isolateScope:scope,$element:$element,$attrs:attrs,$transclude:transcludeFn};controller=directive.controller,"@"==controller&&(controller=attrs[directive.name]),controllerInstance=$controller(controller,locals,!0,directive.controllerAs),elementControllers[directive.name]=controllerInstance,hasElementTranscludeDirective||$element.data("$"+directive.name+"Controller",controllerInstance.instance),controllers[directive.name]=controllerInstance})),newIsolateScopeDirective){compile.$$addScopeInfo($element,isolateScope,!0,!(templateDirective&&(templateDirective===newIsolateScopeDirective||templateDirective===newIsolateScopeDirective.$$originalDirective))),compile.$$addScopeClass($element,!0);var isolateScopeController=controllers&&controllers[newIsolateScopeDirective.name],isolateBindingContext=isolateScope;isolateScopeController&&isolateScopeController.identifier&&newIsolateScopeDirective.bindToController===!0&&(isolateBindingContext=isolateScopeController.instance),forEach(isolateScope.$$isolateBindings=newIsolateScopeDirective.$$isolateBindings,function(definition,scopeName){var lastValue,parentGet,parentSet,compare,attrName=definition.attrName,optional=definition.optional,mode=definition.mode;switch(mode){case"@":attrs.$observe(attrName,function(value){isolateBindingContext[scopeName]=value}),attrs.$$observers[attrName].$$scope=scope,attrs[attrName]&&(isolateBindingContext[scopeName]=$interpolate(attrs[attrName])(scope));break;case"=":if(optional&&!attrs[attrName])return;parentGet=$parse(attrs[attrName]),compare=parentGet.literal?equals:function(a,b){return a===b||a!==a&&b!==b},parentSet=parentGet.assign||function(){throw lastValue=isolateBindingContext[scopeName]=parentGet(scope),$compileMinErr("nonassign","Expression '{0}' used with directive '{1}' is non-assignable!",attrs[attrName],newIsolateScopeDirective.name)},lastValue=isolateBindingContext[scopeName]=parentGet(scope);var parentValueWatch=function(parentValue){return compare(parentValue,isolateBindingContext[scopeName])||(compare(parentValue,lastValue)?parentSet(scope,parentValue=isolateBindingContext[scopeName]):isolateBindingContext[scopeName]=parentValue),lastValue=parentValue};parentValueWatch.$stateful=!0;var unwatch;unwatch=definition.collection?scope.$watchCollection(attrs[attrName],parentValueWatch):scope.$watch($parse(attrs[attrName],parentValueWatch),null,parentGet.literal),isolateScope.$on("$destroy",unwatch);break;case"&":parentGet=$parse(attrs[attrName]),isolateBindingContext[scopeName]=function(locals){return parentGet(scope,locals)}}})}for(controllers&&(forEach(controllers,function(controller){controller()}),controllers=null),i=0,ii=preLinkFns.length;i<ii;i++)linkFn=preLinkFns[i],invokeLinkFn(linkFn,linkFn.isolateScope?isolateScope:scope,$element,attrs,linkFn.require&&getControllers(linkFn.directiveName,linkFn.require,$element,elementControllers),transcludeFn);var scopeToChild=scope;for(newIsolateScopeDirective&&(newIsolateScopeDirective.template||null===newIsolateScopeDirective.templateUrl)&&(scopeToChild=isolateScope),childLinkFn&&childLinkFn(scopeToChild,linkNode.childNodes,undefined,boundTranscludeFn),i=postLinkFns.length-1;i>=0;i--)linkFn=postLinkFns[i],invokeLinkFn(linkFn,linkFn.isolateScope?isolateScope:scope,$element,attrs,linkFn.require&&getControllers(linkFn.directiveName,linkFn.require,$element,elementControllers),transcludeFn)}previousCompileContext=previousCompileContext||{};for(var newScopeDirective,controllers,directive,directiveName,$template,linkFn,directiveValue,terminalPriority=-Number.MAX_VALUE,controllerDirectives=previousCompileContext.controllerDirectives,newIsolateScopeDirective=previousCompileContext.newIsolateScopeDirective,templateDirective=previousCompileContext.templateDirective,nonTlbTranscludeDirective=previousCompileContext.nonTlbTranscludeDirective,hasTranscludeDirective=!1,hasTemplate=!1,hasElementTranscludeDirective=previousCompileContext.hasElementTranscludeDirective,$compileNode=templateAttrs.$$element=jqLite(compileNode),replaceDirective=originalReplaceDirective,childTranscludeFn=transcludeFn,i=0,ii=directives.length;i<ii;i++){directive=directives[i];var attrStart=directive.$$start,attrEnd=directive.$$end;if(attrStart&&($compileNode=groupScan(compileNode,attrStart,attrEnd)),$template=undefined,terminalPriority>directive.priority)break;if((directiveValue=directive.scope)&&(directive.templateUrl||(isObject(directiveValue)?(assertNoDuplicate("new/isolated scope",newIsolateScopeDirective||newScopeDirective,directive,$compileNode),newIsolateScopeDirective=directive):assertNoDuplicate("new/isolated scope",newIsolateScopeDirective,directive,$compileNode)),newScopeDirective=newScopeDirective||directive),directiveName=directive.name,!directive.templateUrl&&directive.controller&&(directiveValue=directive.controller,controllerDirectives=controllerDirectives||{},assertNoDuplicate("'"+directiveName+"' controller",controllerDirectives[directiveName],directive,$compileNode),controllerDirectives[directiveName]=directive),(directiveValue=directive.transclude)&&(hasTranscludeDirective=!0,directive.$$tlb||(assertNoDuplicate("transclusion",nonTlbTranscludeDirective,directive,$compileNode),nonTlbTranscludeDirective=directive),"element"==directiveValue?(hasElementTranscludeDirective=!0,terminalPriority=directive.priority,$template=$compileNode,$compileNode=templateAttrs.$$element=jqLite(document.createComment(" "+directiveName+": "+templateAttrs[directiveName]+" ")),compileNode=$compileNode[0],replaceWith(jqCollection,sliceArgs($template),compileNode),childTranscludeFn=compile($template,transcludeFn,terminalPriority,replaceDirective&&replaceDirective.name,{nonTlbTranscludeDirective:nonTlbTranscludeDirective})):($template=jqLite(jqLiteClone(compileNode)).contents(),$compileNode.empty(),childTranscludeFn=compile($template,transcludeFn))),directive.template)if(hasTemplate=!0,assertNoDuplicate("template",templateDirective,directive,$compileNode),templateDirective=directive,directiveValue=isFunction(directive.template)?directive.template($compileNode,templateAttrs):directive.template,directiveValue=denormalizeTemplate(directiveValue),directive.replace){if(replaceDirective=directive,$template=jqLiteIsTextNode(directiveValue)?[]:removeComments(wrapTemplate(directive.templateNamespace,trim(directiveValue))),compileNode=$template[0],1!=$template.length||compileNode.nodeType!==NODE_TYPE_ELEMENT)throw $compileMinErr("tplrt","Template for directive '{0}' must have exactly one root element. {1}",directiveName,"");replaceWith(jqCollection,$compileNode,compileNode);var newTemplateAttrs={$attr:{}},templateDirectives=collectDirectives(compileNode,[],newTemplateAttrs),unprocessedDirectives=directives.splice(i+1,directives.length-(i+1));
newIsolateScopeDirective&&markDirectivesAsIsolate(templateDirectives),directives=directives.concat(templateDirectives).concat(unprocessedDirectives),mergeTemplateAttributes(templateAttrs,newTemplateAttrs),ii=directives.length}else $compileNode.html(directiveValue);if(directive.templateUrl)hasTemplate=!0,assertNoDuplicate("template",templateDirective,directive,$compileNode),templateDirective=directive,directive.replace&&(replaceDirective=directive),nodeLinkFn=compileTemplateUrl(directives.splice(i,directives.length-i),$compileNode,templateAttrs,jqCollection,hasTranscludeDirective&&childTranscludeFn,preLinkFns,postLinkFns,{controllerDirectives:controllerDirectives,newIsolateScopeDirective:newIsolateScopeDirective,templateDirective:templateDirective,nonTlbTranscludeDirective:nonTlbTranscludeDirective}),ii=directives.length;else if(directive.compile)try{linkFn=directive.compile($compileNode,templateAttrs,childTranscludeFn),isFunction(linkFn)?addLinkFns(null,linkFn,attrStart,attrEnd):linkFn&&addLinkFns(linkFn.pre,linkFn.post,attrStart,attrEnd)}catch(e){$exceptionHandler(e,startingTag($compileNode))}directive.terminal&&(nodeLinkFn.terminal=!0,terminalPriority=Math.max(terminalPriority,directive.priority))}return nodeLinkFn.scope=newScopeDirective&&newScopeDirective.scope===!0,nodeLinkFn.transcludeOnThisElement=hasTranscludeDirective,nodeLinkFn.elementTranscludeOnThisElement=hasElementTranscludeDirective,nodeLinkFn.templateOnThisElement=hasTemplate,nodeLinkFn.transclude=childTranscludeFn,previousCompileContext.hasElementTranscludeDirective=hasElementTranscludeDirective,nodeLinkFn}function markDirectivesAsIsolate(directives){for(var j=0,jj=directives.length;j<jj;j++)directives[j]=inherit(directives[j],{$$isolateScope:!0})}function addDirective(tDirectives,name,location,maxPriority,ignoreDirective,startAttrName,endAttrName){if(name===ignoreDirective)return null;var match=null;if(hasDirectives.hasOwnProperty(name))for(var directive,directives=$injector.get(name+Suffix),i=0,ii=directives.length;i<ii;i++)try{directive=directives[i],(maxPriority===undefined||maxPriority>directive.priority)&&directive.restrict.indexOf(location)!=-1&&(startAttrName&&(directive=inherit(directive,{$$start:startAttrName,$$end:endAttrName})),tDirectives.push(directive),match=directive)}catch(e){$exceptionHandler(e)}return match}function directiveIsMultiElement(name){if(hasDirectives.hasOwnProperty(name))for(var directive,directives=$injector.get(name+Suffix),i=0,ii=directives.length;i<ii;i++)if(directive=directives[i],directive.multiElement)return!0;return!1}function mergeTemplateAttributes(dst,src){var srcAttr=src.$attr,dstAttr=dst.$attr,$element=dst.$$element;forEach(dst,function(value,key){"$"!=key.charAt(0)&&(src[key]&&src[key]!==value&&(value+=("style"===key?";":" ")+src[key]),dst.$set(key,value,!0,srcAttr[key]))}),forEach(src,function(value,key){"class"==key?(safeAddClass($element,value),dst.class=(dst.class?dst.class+" ":"")+value):"style"==key?($element.attr("style",$element.attr("style")+";"+value),dst.style=(dst.style?dst.style+";":"")+value):"$"==key.charAt(0)||dst.hasOwnProperty(key)||(dst[key]=value,dstAttr[key]=srcAttr[key])})}function compileTemplateUrl(directives,$compileNode,tAttrs,$rootElement,childTranscludeFn,preLinkFns,postLinkFns,previousCompileContext){var afterTemplateNodeLinkFn,afterTemplateChildLinkFn,linkQueue=[],beforeTemplateCompileNode=$compileNode[0],origAsyncDirective=directives.shift(),derivedSyncDirective=inherit(origAsyncDirective,{templateUrl:null,transclude:null,replace:null,$$originalDirective:origAsyncDirective}),templateUrl=isFunction(origAsyncDirective.templateUrl)?origAsyncDirective.templateUrl($compileNode,tAttrs):origAsyncDirective.templateUrl,templateNamespace=origAsyncDirective.templateNamespace;return $compileNode.empty(),$templateRequest(templateUrl).then(function(content){var compileNode,tempTemplateAttrs,$template,childBoundTranscludeFn;if(content=denormalizeTemplate(content),origAsyncDirective.replace){if($template=jqLiteIsTextNode(content)?[]:removeComments(wrapTemplate(templateNamespace,trim(content))),compileNode=$template[0],1!=$template.length||compileNode.nodeType!==NODE_TYPE_ELEMENT)throw $compileMinErr("tplrt","Template for directive '{0}' must have exactly one root element. {1}",origAsyncDirective.name,templateUrl);tempTemplateAttrs={$attr:{}},replaceWith($rootElement,$compileNode,compileNode);var templateDirectives=collectDirectives(compileNode,[],tempTemplateAttrs);isObject(origAsyncDirective.scope)&&markDirectivesAsIsolate(templateDirectives),directives=templateDirectives.concat(directives),mergeTemplateAttributes(tAttrs,tempTemplateAttrs)}else compileNode=beforeTemplateCompileNode,$compileNode.html(content);for(directives.unshift(derivedSyncDirective),afterTemplateNodeLinkFn=applyDirectivesToNode(directives,compileNode,tAttrs,childTranscludeFn,$compileNode,origAsyncDirective,preLinkFns,postLinkFns,previousCompileContext),forEach($rootElement,function(node,i){node==compileNode&&($rootElement[i]=$compileNode[0])}),afterTemplateChildLinkFn=compileNodes($compileNode[0].childNodes,childTranscludeFn);linkQueue.length;){var scope=linkQueue.shift(),beforeTemplateLinkNode=linkQueue.shift(),linkRootElement=linkQueue.shift(),boundTranscludeFn=linkQueue.shift(),linkNode=$compileNode[0];if(!scope.$$destroyed){if(beforeTemplateLinkNode!==beforeTemplateCompileNode){var oldClasses=beforeTemplateLinkNode.className;previousCompileContext.hasElementTranscludeDirective&&origAsyncDirective.replace||(linkNode=jqLiteClone(compileNode)),replaceWith(linkRootElement,jqLite(beforeTemplateLinkNode),linkNode),safeAddClass(jqLite(linkNode),oldClasses)}childBoundTranscludeFn=afterTemplateNodeLinkFn.transcludeOnThisElement?createBoundTranscludeFn(scope,afterTemplateNodeLinkFn.transclude,boundTranscludeFn):boundTranscludeFn,afterTemplateNodeLinkFn(afterTemplateChildLinkFn,scope,linkNode,$rootElement,childBoundTranscludeFn)}}linkQueue=null}),function(ignoreChildLinkFn,scope,node,rootElement,boundTranscludeFn){var childBoundTranscludeFn=boundTranscludeFn;scope.$$destroyed||(linkQueue?linkQueue.push(scope,node,rootElement,childBoundTranscludeFn):(afterTemplateNodeLinkFn.transcludeOnThisElement&&(childBoundTranscludeFn=createBoundTranscludeFn(scope,afterTemplateNodeLinkFn.transclude,boundTranscludeFn)),afterTemplateNodeLinkFn(afterTemplateChildLinkFn,scope,node,rootElement,childBoundTranscludeFn)))}}function byPriority(a,b){var diff=b.priority-a.priority;return 0!==diff?diff:a.name!==b.name?a.name<b.name?-1:1:a.index-b.index}function assertNoDuplicate(what,previousDirective,directive,element){if(previousDirective)throw $compileMinErr("multidir","Multiple directives [{0}, {1}] asking for {2} on: {3}",previousDirective.name,directive.name,what,startingTag(element))}function addTextInterpolateDirective(directives,text){var interpolateFn=$interpolate(text,!0);interpolateFn&&directives.push({priority:0,compile:function(templateNode){var templateNodeParent=templateNode.parent(),hasCompileParent=!!templateNodeParent.length;return hasCompileParent&&compile.$$addBindingClass(templateNodeParent),function(scope,node){var parent=node.parent();hasCompileParent||compile.$$addBindingClass(parent),compile.$$addBindingInfo(parent,interpolateFn.expressions),scope.$watch(interpolateFn,function(value){node[0].nodeValue=value})}}})}function wrapTemplate(type,template){switch(type=lowercase(type||"html")){case"svg":case"math":var wrapper=document.createElement("div");return wrapper.innerHTML="<"+type+">"+template+"</"+type+">",wrapper.childNodes[0].childNodes;default:return template}}function getTrustedContext(node,attrNormalizedName){if("srcdoc"==attrNormalizedName)return $sce.HTML;var tag=nodeName_(node);return"xlinkHref"==attrNormalizedName||"form"==tag&&"action"==attrNormalizedName||"img"!=tag&&("src"==attrNormalizedName||"ngSrc"==attrNormalizedName)?$sce.RESOURCE_URL:void 0}function addAttrInterpolateDirective(node,directives,value,name,allOrNothing){var trustedContext=getTrustedContext(node,name);allOrNothing=ALL_OR_NOTHING_ATTRS[name]||allOrNothing;var interpolateFn=$interpolate(value,!0,trustedContext,allOrNothing);if(interpolateFn){if("multiple"===name&&"select"===nodeName_(node))throw $compileMinErr("selmulti","Binding to the 'multiple' attribute is not supported. Element: {0}",startingTag(node));directives.push({priority:100,compile:function(){return{pre:function(scope,element,attr){var $$observers=attr.$$observers||(attr.$$observers={});if(EVENT_HANDLER_ATTR_REGEXP.test(name))throw $compileMinErr("nodomevents","Interpolations for HTML DOM event attributes are disallowed.  Please use the ng- versions (such as ng-click instead of onclick) instead.");var newValue=attr[name];newValue!==value&&(interpolateFn=newValue&&$interpolate(newValue,!0,trustedContext,allOrNothing),value=newValue),interpolateFn&&(attr[name]=interpolateFn(scope),($$observers[name]||($$observers[name]=[])).$$inter=!0,(attr.$$observers&&attr.$$observers[name].$$scope||scope).$watch(interpolateFn,function(newValue,oldValue){"class"===name&&newValue!=oldValue?attr.$updateClass(newValue,oldValue):attr.$set(name,newValue)}))}}}})}}function replaceWith($rootElement,elementsToRemove,newNode){var i,ii,firstElementToRemove=elementsToRemove[0],removeCount=elementsToRemove.length,parent=firstElementToRemove.parentNode;if($rootElement)for(i=0,ii=$rootElement.length;i<ii;i++)if($rootElement[i]==firstElementToRemove){$rootElement[i++]=newNode;for(var j=i,j2=j+removeCount-1,jj=$rootElement.length;j<jj;j++,j2++)j2<jj?$rootElement[j]=$rootElement[j2]:delete $rootElement[j];$rootElement.length-=removeCount-1,$rootElement.context===firstElementToRemove&&($rootElement.context=newNode);break}parent&&parent.replaceChild(newNode,firstElementToRemove);var fragment=document.createDocumentFragment();fragment.appendChild(firstElementToRemove),jqLite(newNode).data(jqLite(firstElementToRemove).data()),jQuery?(skipDestroyOnNextJQueryCleanData=!0,jQuery.cleanData([firstElementToRemove])):delete jqLite.cache[firstElementToRemove[jqLite.expando]];for(var k=1,kk=elementsToRemove.length;k<kk;k++){var element=elementsToRemove[k];jqLite(element).remove(),fragment.appendChild(element),delete elementsToRemove[k]}elementsToRemove[0]=newNode,elementsToRemove.length=1}function cloneAndAnnotateFn(fn,annotation){return extend(function(){return fn.apply(null,arguments)},fn,annotation)}function invokeLinkFn(linkFn,scope,$element,attrs,controllers,transcludeFn){try{linkFn(scope,$element,attrs,controllers,transcludeFn)}catch(e){$exceptionHandler(e,startingTag($element))}}var Attributes=function(element,attributesToCopy){if(attributesToCopy){var i,l,key,keys=Object.keys(attributesToCopy);for(i=0,l=keys.length;i<l;i++)key=keys[i],this[key]=attributesToCopy[key]}else this.$attr={};this.$$element=element};Attributes.prototype={$normalize:directiveNormalize,$addClass:function(classVal){classVal&&classVal.length>0&&$animate.addClass(this.$$element,classVal)},$removeClass:function(classVal){classVal&&classVal.length>0&&$animate.removeClass(this.$$element,classVal)},$updateClass:function(newClasses,oldClasses){var toAdd=tokenDifference(newClasses,oldClasses);toAdd&&toAdd.length&&$animate.addClass(this.$$element,toAdd);var toRemove=tokenDifference(oldClasses,newClasses);toRemove&&toRemove.length&&$animate.removeClass(this.$$element,toRemove)},$set:function(key,value,writeAttr,attrName){var nodeName,node=this.$$element[0],booleanKey=getBooleanAttrName(node,key),aliasedKey=getAliasedAttrName(node,key),observer=key;if(booleanKey?(this.$$element.prop(key,value),attrName=booleanKey):aliasedKey&&(this[aliasedKey]=value,observer=aliasedKey),this[key]=value,attrName?this.$attr[key]=attrName:(attrName=this.$attr[key],attrName||(this.$attr[key]=attrName=snake_case(key,"-"))),nodeName=nodeName_(this.$$element),"a"===nodeName&&"href"===key||"img"===nodeName&&"src"===key)this[key]=value=$$sanitizeUri(value,"src"===key);else if("img"===nodeName&&"srcset"===key){for(var result="",trimmedSrcset=trim(value),srcPattern=/(\s+\d+x\s*,|\s+\d+w\s*,|\s+,|,\s+)/,pattern=/\s/.test(trimmedSrcset)?srcPattern:/(,)/,rawUris=trimmedSrcset.split(pattern),nbrUrisWith2parts=Math.floor(rawUris.length/2),i=0;i<nbrUrisWith2parts;i++){var innerIdx=2*i;result+=$$sanitizeUri(trim(rawUris[innerIdx]),!0),result+=" "+trim(rawUris[innerIdx+1])}var lastTuple=trim(rawUris[2*i]).split(/\s/);result+=$$sanitizeUri(trim(lastTuple[0]),!0),2===lastTuple.length&&(result+=" "+trim(lastTuple[1])),this[key]=value=result}writeAttr!==!1&&(null===value||value===undefined?this.$$element.removeAttr(attrName):this.$$element.attr(attrName,value));var $$observers=this.$$observers;$$observers&&forEach($$observers[observer],function(fn){try{fn(value)}catch(e){$exceptionHandler(e)}})},$observe:function(key,fn){var attrs=this,$$observers=attrs.$$observers||(attrs.$$observers=createMap()),listeners=$$observers[key]||($$observers[key]=[]);return listeners.push(fn),$rootScope.$evalAsync(function(){!listeners.$$inter&&attrs.hasOwnProperty(key)&&fn(attrs[key])}),function(){arrayRemove(listeners,fn)}}};var startSymbol=$interpolate.startSymbol(),endSymbol=$interpolate.endSymbol(),denormalizeTemplate="{{"==startSymbol||"}}"==endSymbol?identity:function(template){return template.replace(/\{\{/g,startSymbol).replace(/}}/g,endSymbol)},NG_ATTR_BINDING=/^ngAttr[A-Z]/;return compile.$$addBindingInfo=debugInfoEnabled?function($element,binding){var bindings=$element.data("$binding")||[];isArray(binding)?bindings=bindings.concat(binding):bindings.push(binding),$element.data("$binding",bindings)}:noop,compile.$$addBindingClass=debugInfoEnabled?function($element){safeAddClass($element,"ng-binding")}:noop,compile.$$addScopeInfo=debugInfoEnabled?function($element,scope,isolated,noTemplate){var dataName=isolated?noTemplate?"$isolateScopeNoTemplate":"$isolateScope":"$scope";$element.data(dataName,scope)}:noop,compile.$$addScopeClass=debugInfoEnabled?function($element,isolated){safeAddClass($element,isolated?"ng-isolate-scope":"ng-scope")}:noop,compile}]}function directiveNormalize(name){return camelCase(name.replace(PREFIX_REGEXP,""))}function tokenDifference(str1,str2){var values="",tokens1=str1.split(/\s+/),tokens2=str2.split(/\s+/);outer:for(var i=0;i<tokens1.length;i++){for(var token=tokens1[i],j=0;j<tokens2.length;j++)if(token==tokens2[j])continue outer;values+=(values.length>0?" ":"")+token}return values}function removeComments(jqNodes){jqNodes=jqLite(jqNodes);var i=jqNodes.length;if(i<=1)return jqNodes;for(;i--;){var node=jqNodes[i];node.nodeType===NODE_TYPE_COMMENT&&splice.call(jqNodes,i,1)}return jqNodes}function $ControllerProvider(){var controllers={},globals=!1,CNTRL_REG=/^(\S+)(\s+as\s+(\w+))?$/;this.register=function(name,constructor){assertNotHasOwnProperty(name,"controller"),isObject(name)?extend(controllers,name):controllers[name]=constructor},this.allowGlobals=function(){globals=!0},this.$get=["$injector","$window",function($injector,$window){function addIdentifier(locals,identifier,instance,name){if(!locals||!isObject(locals.$scope))throw minErr("$controller")("noscp","Cannot export controller '{0}' as '{1}'! No $scope object provided via `locals`.",name,identifier);locals.$scope[identifier]=instance}return function(expression,locals,later,ident){var instance,match,constructor,identifier;if(later=later===!0,ident&&isString(ident)&&(identifier=ident),isString(expression)){if(match=expression.match(CNTRL_REG),!match)throw $controllerMinErr("ctrlfmt","Badly formed controller string '{0}'. Must match `__name__ as __id__` or `__name__`.",expression);constructor=match[1],identifier=identifier||match[3],expression=controllers.hasOwnProperty(constructor)?controllers[constructor]:getter(locals.$scope,constructor,!0)||(globals?getter($window,constructor,!0):undefined),assertArgFn(expression,constructor,!0)}if(later){var controllerPrototype=(isArray(expression)?expression[expression.length-1]:expression).prototype;return instance=Object.create(controllerPrototype||null),identifier&&addIdentifier(locals,identifier,instance,constructor||expression.name),extend(function(){return $injector.invoke(expression,instance,locals,constructor),instance},{instance:instance,identifier:identifier})}return instance=$injector.instantiate(expression,locals,constructor),identifier&&addIdentifier(locals,identifier,instance,constructor||expression.name),instance}}]}function $DocumentProvider(){this.$get=["$window",function(window){return jqLite(window.document)}]}function $ExceptionHandlerProvider(){this.$get=["$log",function($log){return function(exception,cause){$log.error.apply($log,arguments)}}]}function defaultHttpResponseTransform(data,headers){if(isString(data)){var tempData=data.replace(JSON_PROTECTION_PREFIX,"").trim();if(tempData){var contentType=headers("Content-Type");(contentType&&0===contentType.indexOf(APPLICATION_JSON)||isJsonLike(tempData))&&(data=fromJson(tempData))}}return data}function isJsonLike(str){var jsonStart=str.match(JSON_START);return jsonStart&&JSON_ENDS[jsonStart[0]].test(str)}function parseHeaders(headers){var key,val,i,parsed=createMap();return headers?(forEach(headers.split("\n"),function(line){i=line.indexOf(":"),key=lowercase(trim(line.substr(0,i))),val=trim(line.substr(i+1)),key&&(parsed[key]=parsed[key]?parsed[key]+", "+val:val)}),parsed):parsed}function headersGetter(headers){var headersObj=isObject(headers)?headers:undefined;return function(name){if(headersObj||(headersObj=parseHeaders(headers)),name){var value=headersObj[lowercase(name)];return void 0===value&&(value=null),value}return headersObj}}function transformData(data,headers,status,fns){return isFunction(fns)?fns(data,headers,status):(forEach(fns,function(fn){data=fn(data,headers,status)}),data)}function isSuccess(status){return 200<=status&&status<300}function $HttpProvider(){var defaults=this.defaults={transformResponse:[defaultHttpResponseTransform],transformRequest:[function(d){return!isObject(d)||isFile(d)||isBlob(d)||isFormData(d)?d:toJson(d)}],headers:{common:{Accept:"application/json, text/plain, */*"},post:shallowCopy(CONTENT_TYPE_APPLICATION_JSON),put:shallowCopy(CONTENT_TYPE_APPLICATION_JSON),patch:shallowCopy(CONTENT_TYPE_APPLICATION_JSON)},xsrfCookieName:"XSRF-TOKEN",xsrfHeaderName:"X-XSRF-TOKEN"},useApplyAsync=!1;this.useApplyAsync=function(value){return isDefined(value)?(useApplyAsync=!!value,this):useApplyAsync};var interceptorFactories=this.interceptors=[];this.$get=["$httpBackend","$browser","$cacheFactory","$rootScope","$q","$injector",function($httpBackend,$browser,$cacheFactory,$rootScope,$q,$injector){function $http(requestConfig){function transformResponse(response){var resp=extend({},response);return response.data?resp.data=transformData(response.data,response.headers,response.status,config.transformResponse):resp.data=response.data,isSuccess(response.status)?resp:$q.reject(resp)}function executeHeaderFns(headers){var headerContent,processedHeaders={};return forEach(headers,function(headerFn,header){isFunction(headerFn)?(headerContent=headerFn(),null!=headerContent&&(processedHeaders[header]=headerContent)):processedHeaders[header]=headerFn}),processedHeaders}function mergeHeaders(config){var defHeaderName,lowercaseDefHeaderName,reqHeaderName,defHeaders=defaults.headers,reqHeaders=extend({},config.headers);defHeaders=extend({},defHeaders.common,defHeaders[lowercase(config.method)]);defaultHeadersIteration:for(defHeaderName in defHeaders){lowercaseDefHeaderName=lowercase(defHeaderName);for(reqHeaderName in reqHeaders)if(lowercase(reqHeaderName)===lowercaseDefHeaderName)continue defaultHeadersIteration;reqHeaders[defHeaderName]=defHeaders[defHeaderName]}return executeHeaderFns(reqHeaders)}if(!angular.isObject(requestConfig))throw minErr("$http")("badreq","Http request configuration must be an object.  Received: {0}",requestConfig);var config=extend({method:"get",transformRequest:defaults.transformRequest,transformResponse:defaults.transformResponse},requestConfig);config.headers=mergeHeaders(requestConfig),config.method=uppercase(config.method);var serverRequest=function(config){var headers=config.headers,reqData=transformData(config.data,headersGetter(headers),undefined,config.transformRequest);return isUndefined(reqData)&&forEach(headers,function(value,header){"content-type"===lowercase(header)&&delete headers[header]}),isUndefined(config.withCredentials)&&!isUndefined(defaults.withCredentials)&&(config.withCredentials=defaults.withCredentials),sendReq(config,reqData).then(transformResponse,transformResponse)},chain=[serverRequest,undefined],promise=$q.when(config);for(forEach(reversedInterceptors,function(interceptor){(interceptor.request||interceptor.requestError)&&chain.unshift(interceptor.request,interceptor.requestError),(interceptor.response||interceptor.responseError)&&chain.push(interceptor.response,interceptor.responseError)});chain.length;){var thenFn=chain.shift(),rejectFn=chain.shift();promise=promise.then(thenFn,rejectFn)}return promise.success=function(fn){return assertArgFn(fn,"fn"),promise.then(function(response){fn(response.data,response.status,response.headers,config)}),promise},promise.error=function(fn){return assertArgFn(fn,"fn"),promise.then(null,function(response){fn(response.data,response.status,response.headers,config)}),promise},promise}function createShortMethods(names){forEach(arguments,function(name){$http[name]=function(url,config){return $http(extend(config||{},{method:name,url:url}))}})}function createShortMethodsWithData(name){forEach(arguments,function(name){$http[name]=function(url,data,config){return $http(extend(config||{},{method:name,url:url,data:data}))}})}function sendReq(config,reqData){function done(status,response,headersString,statusText){function resolveHttpPromise(){resolvePromise(response,status,headersString,statusText)}cache&&(isSuccess(status)?cache.put(url,[status,response,parseHeaders(headersString),statusText]):cache.remove(url)),useApplyAsync?$rootScope.$applyAsync(resolveHttpPromise):(resolveHttpPromise(),$rootScope.$$phase||$rootScope.$apply())}function resolvePromise(response,status,headers,statusText){status=status>=-1?status:0,(isSuccess(status)?deferred.resolve:deferred.reject)({data:response,status:status,headers:headersGetter(headers),config:config,statusText:statusText})}function resolvePromiseWithResult(result){resolvePromise(result.data,result.status,shallowCopy(result.headers()),result.statusText)}function removePendingReq(){var idx=$http.pendingRequests.indexOf(config);idx!==-1&&$http.pendingRequests.splice(idx,1)}var cache,cachedResp,deferred=$q.defer(),promise=deferred.promise,reqHeaders=config.headers,url=buildUrl(config.url,config.params);if($http.pendingRequests.push(config),promise.then(removePendingReq,removePendingReq),!config.cache&&!defaults.cache||config.cache===!1||"GET"!==config.method&&"JSONP"!==config.method||(cache=isObject(config.cache)?config.cache:isObject(defaults.cache)?defaults.cache:defaultCache),cache&&(cachedResp=cache.get(url),isDefined(cachedResp)?isPromiseLike(cachedResp)?cachedResp.then(resolvePromiseWithResult,resolvePromiseWithResult):isArray(cachedResp)?resolvePromise(cachedResp[1],cachedResp[0],shallowCopy(cachedResp[2]),cachedResp[3]):resolvePromise(cachedResp,200,{},"OK"):cache.put(url,promise)),isUndefined(cachedResp)){var xsrfValue=urlIsSameOrigin(config.url)?$browser.cookies()[config.xsrfCookieName||defaults.xsrfCookieName]:undefined;xsrfValue&&(reqHeaders[config.xsrfHeaderName||defaults.xsrfHeaderName]=xsrfValue),$httpBackend(config.method,url,reqData,done,reqHeaders,config.timeout,config.withCredentials,config.responseType)}return promise}function buildUrl(url,params){if(!params)return url;var parts=[];return forEachSorted(params,function(value,key){null===value||isUndefined(value)||(isArray(value)||(value=[value]),forEach(value,function(v){isObject(v)&&(v=isDate(v)?v.toISOString():toJson(v)),parts.push(encodeUriQuery(key)+"="+encodeUriQuery(v))}))}),parts.length>0&&(url+=(url.indexOf("?")==-1?"?":"&")+parts.join("&")),url}var defaultCache=$cacheFactory("$http"),reversedInterceptors=[];return forEach(interceptorFactories,function(interceptorFactory){reversedInterceptors.unshift(isString(interceptorFactory)?$injector.get(interceptorFactory):$injector.invoke(interceptorFactory))}),$http.pendingRequests=[],createShortMethods("get","delete","head","jsonp"),createShortMethodsWithData("post","put","patch"),$http.defaults=defaults,$http}]}function createXhr(){return new window.XMLHttpRequest}function $HttpBackendProvider(){this.$get=["$browser","$window","$document",function($browser,$window,$document){return createHttpBackend($browser,createXhr,$browser.defer,$window.angular.callbacks,$document[0])}]}function createHttpBackend($browser,createXhr,$browserDefer,callbacks,rawDocument){function jsonpReq(url,callbackId,done){var script=rawDocument.createElement("script"),callback=null;return script.type="text/javascript",script.src=url,script.async=!0,callback=function(event){removeEventListenerFn(script,"load",callback),removeEventListenerFn(script,"error",callback),rawDocument.body.removeChild(script),script=null;var status=-1,text="unknown";event&&("load"!==event.type||callbacks[callbackId].called||(event={type:"error"}),text=event.type,status="error"===event.type?404:200),done&&done(status,text)},addEventListenerFn(script,"load",callback),addEventListenerFn(script,"error",callback),rawDocument.body.appendChild(script),callback}return function(method,url,post,callback,headers,timeout,withCredentials,responseType){function timeoutRequest(){jsonpDone&&jsonpDone(),xhr&&xhr.abort()}function completeRequest(callback,status,response,headersString,statusText){timeoutId!==undefined&&$browserDefer.cancel(timeoutId),jsonpDone=xhr=null,callback(status,response,headersString,statusText),$browser.$$completeOutstandingRequest(noop)}if($browser.$$incOutstandingRequestCount(),url=url||$browser.url(),"jsonp"==lowercase(method)){var callbackId="_"+(callbacks.counter++).toString(36);callbacks[callbackId]=function(data){callbacks[callbackId].data=data,callbacks[callbackId].called=!0};var jsonpDone=jsonpReq(url.replace("JSON_CALLBACK","angular.callbacks."+callbackId),callbackId,function(status,text){completeRequest(callback,status,callbacks[callbackId].data,"",text),callbacks[callbackId]=noop})}else{var xhr=createXhr();xhr.open(method,url,!0),forEach(headers,function(value,key){isDefined(value)&&xhr.setRequestHeader(key,value)}),xhr.onload=function(){var statusText=xhr.statusText||"",response="response"in xhr?xhr.response:xhr.responseText,status=1223===xhr.status?204:xhr.status;0===status&&(status=response?200:"file"==urlResolve(url).protocol?404:0),completeRequest(callback,status,response,xhr.getAllResponseHeaders(),statusText)};var requestError=function(){completeRequest(callback,-1,null,null,"")};if(xhr.onerror=requestError,xhr.onabort=requestError,withCredentials&&(xhr.withCredentials=!0),responseType)try{xhr.responseType=responseType}catch(e){if("json"!==responseType)throw e}xhr.send(post||null)}if(timeout>0)var timeoutId=$browserDefer(timeoutRequest,timeout);else isPromiseLike(timeout)&&timeout.then(timeoutRequest)}}function $InterpolateProvider(){var startSymbol="{{",endSymbol="}}";this.startSymbol=function(value){return value?(startSymbol=value,this):startSymbol},this.endSymbol=function(value){return value?(endSymbol=value,this):endSymbol},this.$get=["$parse","$exceptionHandler","$sce",function($parse,$exceptionHandler,$sce){function escape(ch){return"\\\\\\"+ch}function $interpolate(text,mustHaveExpression,trustedContext,allOrNothing){function unescapeText(text){return text.replace(escapedStartRegexp,startSymbol).replace(escapedEndRegexp,endSymbol)}function parseStringifyInterceptor(value){try{return value=getValue(value),allOrNothing&&!isDefined(value)?value:stringify(value)}catch(err){var newErr=$interpolateMinErr("interr","Can't interpolate: {0}\n{1}",text,err.toString());$exceptionHandler(newErr)}}allOrNothing=!!allOrNothing;for(var startIndex,endIndex,exp,index=0,expressions=[],parseFns=[],textLength=text.length,concat=[],expressionPositions=[];index<textLength;){if((startIndex=text.indexOf(startSymbol,index))==-1||(endIndex=text.indexOf(endSymbol,startIndex+startSymbolLength))==-1){index!==textLength&&concat.push(unescapeText(text.substring(index)));break}index!==startIndex&&concat.push(unescapeText(text.substring(index,startIndex))),exp=text.substring(startIndex+startSymbolLength,endIndex),expressions.push(exp),parseFns.push($parse(exp,parseStringifyInterceptor)),index=endIndex+endSymbolLength,expressionPositions.push(concat.length),concat.push("")}if(trustedContext&&concat.length>1)throw $interpolateMinErr("noconcat","Error while interpolating: {0}\nStrict Contextual Escaping disallows interpolations that concatenate multiple expressions when a trusted value is required.  See http://docs.angularjs.org/api/ng.$sce",text);if(!mustHaveExpression||expressions.length){var compute=function(values){for(var i=0,ii=expressions.length;i<ii;i++){if(allOrNothing&&isUndefined(values[i]))return;concat[expressionPositions[i]]=values[i]}return concat.join("")},getValue=function(value){return trustedContext?$sce.getTrusted(trustedContext,value):$sce.valueOf(value)},stringify=function(value){if(null==value)return"";switch(typeof value){case"string":break;case"number":value=""+value;break;default:value=toJson(value)}return value};return extend(function(context){var i=0,ii=expressions.length,values=new Array(ii);try{for(;i<ii;i++)values[i]=parseFns[i](context);return compute(values)}catch(err){var newErr=$interpolateMinErr("interr","Can't interpolate: {0}\n{1}",text,err.toString());$exceptionHandler(newErr)}},{exp:text,expressions:expressions,$$watchDelegate:function(scope,listener,objectEquality){var lastValue;return scope.$watchGroup(parseFns,function(values,oldValues){var currValue=compute(values);isFunction(listener)&&listener.call(this,currValue,values!==oldValues?lastValue:currValue,scope),lastValue=currValue},objectEquality)}})}}var startSymbolLength=startSymbol.length,endSymbolLength=endSymbol.length,escapedStartRegexp=new RegExp(startSymbol.replace(/./g,escape),"g"),escapedEndRegexp=new RegExp(endSymbol.replace(/./g,escape),"g");return $interpolate.startSymbol=function(){return startSymbol},$interpolate.endSymbol=function(){return endSymbol},$interpolate}]}function $IntervalProvider(){this.$get=["$rootScope","$window","$q","$$q",function($rootScope,$window,$q,$$q){function interval(fn,delay,count,invokeApply){var setInterval=$window.setInterval,clearInterval=$window.clearInterval,iteration=0,skipApply=isDefined(invokeApply)&&!invokeApply,deferred=(skipApply?$$q:$q).defer(),promise=deferred.promise;return count=isDefined(count)?count:0,promise.then(null,null,fn),promise.$$intervalId=setInterval(function(){deferred.notify(iteration++),count>0&&iteration>=count&&(deferred.resolve(iteration),clearInterval(promise.$$intervalId),delete intervals[promise.$$intervalId]),skipApply||$rootScope.$apply()},delay),intervals[promise.$$intervalId]=deferred,promise}var intervals={};return interval.cancel=function(promise){return!!(promise&&promise.$$intervalId in intervals)&&(intervals[promise.$$intervalId].reject("canceled"),$window.clearInterval(promise.$$intervalId),delete intervals[promise.$$intervalId],!0)},interval}]}function $LocaleProvider(){this.$get=function(){return{id:"en-us",NUMBER_FORMATS:{DECIMAL_SEP:".",GROUP_SEP:",",PATTERNS:[{minInt:1,minFrac:0,maxFrac:3,posPre:"",posSuf:"",negPre:"-",negSuf:"",gSize:3,lgSize:3},{minInt:1,minFrac:2,maxFrac:2,posPre:"¤",posSuf:"",negPre:"(¤",negSuf:")",gSize:3,lgSize:3}],CURRENCY_SYM:"$"},DATETIME_FORMATS:{MONTH:"January,February,March,April,May,June,July,August,September,October,November,December".split(","),SHORTMONTH:"Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec".split(","),DAY:"Sunday,Monday,Tuesday,Wednesday,Thursday,Friday,Saturday".split(","),SHORTDAY:"Sun,Mon,Tue,Wed,Thu,Fri,Sat".split(","),AMPMS:["AM","PM"],medium:"MMM d, y h:mm:ss a",short:"M/d/yy h:mm a",
fullDate:"EEEE, MMMM d, y",longDate:"MMMM d, y",mediumDate:"MMM d, y",shortDate:"M/d/yy",mediumTime:"h:mm:ss a",shortTime:"h:mm a",ERANAMES:["Before Christ","Anno Domini"],ERAS:["BC","AD"]},pluralCat:function(num){return 1===num?"one":"other"}}}}function encodePath(path){for(var segments=path.split("/"),i=segments.length;i--;)segments[i]=encodeUriSegment(segments[i]);return segments.join("/")}function parseAbsoluteUrl(absoluteUrl,locationObj){var parsedUrl=urlResolve(absoluteUrl);locationObj.$$protocol=parsedUrl.protocol,locationObj.$$host=parsedUrl.hostname,locationObj.$$port=int(parsedUrl.port)||DEFAULT_PORTS[parsedUrl.protocol]||null}function parseAppUrl(relativeUrl,locationObj){var prefixed="/"!==relativeUrl.charAt(0);prefixed&&(relativeUrl="/"+relativeUrl);var match=urlResolve(relativeUrl);locationObj.$$path=decodeURIComponent(prefixed&&"/"===match.pathname.charAt(0)?match.pathname.substring(1):match.pathname),locationObj.$$search=parseKeyValue(match.search),locationObj.$$hash=decodeURIComponent(match.hash),locationObj.$$path&&"/"!=locationObj.$$path.charAt(0)&&(locationObj.$$path="/"+locationObj.$$path)}function beginsWith(begin,whole){if(0===whole.indexOf(begin))return whole.substr(begin.length)}function stripHash(url){var index=url.indexOf("#");return index==-1?url:url.substr(0,index)}function trimEmptyHash(url){return url.replace(/(#.+)|#$/,"$1")}function stripFile(url){return url.substr(0,stripHash(url).lastIndexOf("/")+1)}function serverBase(url){return url.substring(0,url.indexOf("/",url.indexOf("//")+2))}function LocationHtml5Url(appBase,appBaseNoFile,basePrefix){this.$$html5=!0,basePrefix=basePrefix||"",parseAbsoluteUrl(appBase,this),this.$$parse=function(url){var pathUrl=beginsWith(appBaseNoFile,url);if(!isString(pathUrl))throw $locationMinErr("ipthprfx",'Invalid url "{0}", missing path prefix "{1}".',url,appBaseNoFile);parseAppUrl(pathUrl,this),this.$$path||(this.$$path="/"),this.$$compose()},this.$$compose=function(){var search=toKeyValue(this.$$search),hash=this.$$hash?"#"+encodeUriSegment(this.$$hash):"";this.$$url=encodePath(this.$$path)+(search?"?"+search:"")+hash,this.$$absUrl=appBaseNoFile+this.$$url.substr(1)},this.$$parseLinkUrl=function(url,relHref){if(relHref&&"#"===relHref[0])return this.hash(relHref.slice(1)),!0;var appUrl,prevAppUrl,rewrittenUrl;return(appUrl=beginsWith(appBase,url))!==undefined?(prevAppUrl=appUrl,rewrittenUrl=(appUrl=beginsWith(basePrefix,appUrl))!==undefined?appBaseNoFile+(beginsWith("/",appUrl)||appUrl):appBase+prevAppUrl):(appUrl=beginsWith(appBaseNoFile,url))!==undefined?rewrittenUrl=appBaseNoFile+appUrl:appBaseNoFile==url+"/"&&(rewrittenUrl=appBaseNoFile),rewrittenUrl&&this.$$parse(rewrittenUrl),!!rewrittenUrl}}function LocationHashbangUrl(appBase,appBaseNoFile,hashPrefix){parseAbsoluteUrl(appBase,this),this.$$parse=function(url){function removeWindowsDriveName(path,url,base){var firstPathSegmentMatch,windowsFilePathExp=/^\/[A-Z]:(\/.*)/;return 0===url.indexOf(base)&&(url=url.replace(base,"")),windowsFilePathExp.exec(url)?path:(firstPathSegmentMatch=windowsFilePathExp.exec(path),firstPathSegmentMatch?firstPathSegmentMatch[1]:path)}var withoutHashUrl,withoutBaseUrl=beginsWith(appBase,url)||beginsWith(appBaseNoFile,url);isUndefined(withoutBaseUrl)||"#"!==withoutBaseUrl.charAt(0)?this.$$html5?withoutHashUrl=withoutBaseUrl:(withoutHashUrl="",isUndefined(withoutBaseUrl)&&(appBase=url,this.replace())):(withoutHashUrl=beginsWith(hashPrefix,withoutBaseUrl),isUndefined(withoutHashUrl)&&(withoutHashUrl=withoutBaseUrl)),parseAppUrl(withoutHashUrl,this),this.$$path=removeWindowsDriveName(this.$$path,withoutHashUrl,appBase),this.$$compose()},this.$$compose=function(){var search=toKeyValue(this.$$search),hash=this.$$hash?"#"+encodeUriSegment(this.$$hash):"";this.$$url=encodePath(this.$$path)+(search?"?"+search:"")+hash,this.$$absUrl=appBase+(this.$$url?hashPrefix+this.$$url:"")},this.$$parseLinkUrl=function(url,relHref){return stripHash(appBase)==stripHash(url)&&(this.$$parse(url),!0)}}function LocationHashbangInHtml5Url(appBase,appBaseNoFile,hashPrefix){this.$$html5=!0,LocationHashbangUrl.apply(this,arguments),this.$$parseLinkUrl=function(url,relHref){if(relHref&&"#"===relHref[0])return this.hash(relHref.slice(1)),!0;var rewrittenUrl,appUrl;return appBase==stripHash(url)?rewrittenUrl=url:(appUrl=beginsWith(appBaseNoFile,url))?rewrittenUrl=appBase+hashPrefix+appUrl:appBaseNoFile===url+"/"&&(rewrittenUrl=appBaseNoFile),rewrittenUrl&&this.$$parse(rewrittenUrl),!!rewrittenUrl},this.$$compose=function(){var search=toKeyValue(this.$$search),hash=this.$$hash?"#"+encodeUriSegment(this.$$hash):"";this.$$url=encodePath(this.$$path)+(search?"?"+search:"")+hash,this.$$absUrl=appBase+hashPrefix+this.$$url}}function locationGetter(property){return function(){return this[property]}}function locationGetterSetter(property,preprocess){return function(value){return isUndefined(value)?this[property]:(this[property]=preprocess(value),this.$$compose(),this)}}function $LocationProvider(){var hashPrefix="",html5Mode={enabled:!1,requireBase:!0,rewriteLinks:!0};this.hashPrefix=function(prefix){return isDefined(prefix)?(hashPrefix=prefix,this):hashPrefix},this.html5Mode=function(mode){return isBoolean(mode)?(html5Mode.enabled=mode,this):isObject(mode)?(isBoolean(mode.enabled)&&(html5Mode.enabled=mode.enabled),isBoolean(mode.requireBase)&&(html5Mode.requireBase=mode.requireBase),isBoolean(mode.rewriteLinks)&&(html5Mode.rewriteLinks=mode.rewriteLinks),this):html5Mode},this.$get=["$rootScope","$browser","$sniffer","$rootElement","$window",function($rootScope,$browser,$sniffer,$rootElement,$window){function setBrowserUrlWithFallback(url,replace,state){var oldUrl=$location.url(),oldState=$location.$$state;try{$browser.url(url,replace,state),$location.$$state=$browser.state()}catch(e){throw $location.url(oldUrl),$location.$$state=oldState,e}}function afterLocationChange(oldUrl,oldState){$rootScope.$broadcast("$locationChangeSuccess",$location.absUrl(),oldUrl,$location.$$state,oldState)}var $location,LocationMode,appBase,baseHref=$browser.baseHref(),initialUrl=$browser.url();if(html5Mode.enabled){if(!baseHref&&html5Mode.requireBase)throw $locationMinErr("nobase","$location in HTML5 mode requires a <base> tag to be present!");appBase=serverBase(initialUrl)+(baseHref||"/"),LocationMode=$sniffer.history?LocationHtml5Url:LocationHashbangInHtml5Url}else appBase=stripHash(initialUrl),LocationMode=LocationHashbangUrl;var appBaseNoFile=stripFile(appBase);$location=new LocationMode(appBase,appBaseNoFile,"#"+hashPrefix),$location.$$parseLinkUrl(initialUrl,initialUrl),$location.$$state=$browser.state();var IGNORE_URI_REGEXP=/^\s*(javascript|mailto):/i;$rootElement.on("click",function(event){if(html5Mode.rewriteLinks&&!event.ctrlKey&&!event.metaKey&&!event.shiftKey&&2!=event.which&&2!=event.button){for(var elm=jqLite(event.target);"a"!==nodeName_(elm[0]);)if(elm[0]===$rootElement[0]||!(elm=elm.parent())[0])return;var absHref=elm.prop("href"),relHref=elm.attr("href")||elm.attr("xlink:href");isObject(absHref)&&"[object SVGAnimatedString]"===absHref.toString()&&(absHref=urlResolve(absHref.animVal).href),IGNORE_URI_REGEXP.test(absHref)||!absHref||elm.attr("target")||event.isDefaultPrevented()||$location.$$parseLinkUrl(absHref,relHref)&&(event.preventDefault(),$location.absUrl()!=$browser.url()&&($rootScope.$apply(),$window.angular["ff-684208-preventDefault"]=!0))}}),trimEmptyHash($location.absUrl())!=trimEmptyHash(initialUrl)&&$browser.url($location.absUrl(),!0);var initializing=!0;return $browser.onUrlChange(function(newUrl,newState){return isUndefined(beginsWith(appBaseNoFile,newUrl))?void($window.location.href=newUrl):($rootScope.$evalAsync(function(){var defaultPrevented,oldUrl=$location.absUrl(),oldState=$location.$$state;$location.$$parse(newUrl),$location.$$state=newState,defaultPrevented=$rootScope.$broadcast("$locationChangeStart",newUrl,oldUrl,newState,oldState).defaultPrevented,$location.absUrl()===newUrl&&(defaultPrevented?($location.$$parse(oldUrl),$location.$$state=oldState,setBrowserUrlWithFallback(oldUrl,!1,oldState)):(initializing=!1,afterLocationChange(oldUrl,oldState)))}),void($rootScope.$$phase||$rootScope.$digest()))}),$rootScope.$watch(function(){var oldUrl=trimEmptyHash($browser.url()),newUrl=trimEmptyHash($location.absUrl()),oldState=$browser.state(),currentReplace=$location.$$replace,urlOrStateChanged=oldUrl!==newUrl||$location.$$html5&&$sniffer.history&&oldState!==$location.$$state;(initializing||urlOrStateChanged)&&(initializing=!1,$rootScope.$evalAsync(function(){var newUrl=$location.absUrl(),defaultPrevented=$rootScope.$broadcast("$locationChangeStart",newUrl,oldUrl,$location.$$state,oldState).defaultPrevented;$location.absUrl()===newUrl&&(defaultPrevented?($location.$$parse(oldUrl),$location.$$state=oldState):(urlOrStateChanged&&setBrowserUrlWithFallback(newUrl,currentReplace,oldState===$location.$$state?null:$location.$$state),afterLocationChange(oldUrl,oldState)))})),$location.$$replace=!1}),$location}]}function $LogProvider(){var debug=!0,self=this;this.debugEnabled=function(flag){return isDefined(flag)?(debug=flag,this):debug},this.$get=["$window",function($window){function formatError(arg){return arg instanceof Error&&(arg.stack?arg=arg.message&&arg.stack.indexOf(arg.message)===-1?"Error: "+arg.message+"\n"+arg.stack:arg.stack:arg.sourceURL&&(arg=arg.message+"\n"+arg.sourceURL+":"+arg.line)),arg}function consoleLog(type){var console=$window.console||{},logFn=console[type]||console.log||noop,hasApply=!1;try{hasApply=!!logFn.apply}catch(e){}return hasApply?function(){var args=[];return forEach(arguments,function(arg){args.push(formatError(arg))}),logFn.apply(console,args)}:function(arg1,arg2){logFn(arg1,null==arg2?"":arg2)}}return{log:consoleLog("log"),info:consoleLog("info"),warn:consoleLog("warn"),error:consoleLog("error"),debug:function(){var fn=consoleLog("debug");return function(){debug&&fn.apply(self,arguments)}}()}}]}function ensureSafeMemberName(name,fullExpression){if("__defineGetter__"===name||"__defineSetter__"===name||"__lookupGetter__"===name||"__lookupSetter__"===name||"__proto__"===name)throw $parseMinErr("isecfld","Attempting to access a disallowed field in Angular expressions! Expression: {0}",fullExpression);return name}function getStringValue(name,fullExpression){if(name+="",!isString(name))throw $parseMinErr("iseccst","Cannot convert object to primitive value! Expression: {0}",fullExpression);return name}function ensureSafeObject(obj,fullExpression){if(obj){if(obj.constructor===obj)throw $parseMinErr("isecfn","Referencing Function in Angular expressions is disallowed! Expression: {0}",fullExpression);if(obj.window===obj)throw $parseMinErr("isecwindow","Referencing the Window in Angular expressions is disallowed! Expression: {0}",fullExpression);if(obj.children&&(obj.nodeName||obj.prop&&obj.attr&&obj.find))throw $parseMinErr("isecdom","Referencing DOM nodes in Angular expressions is disallowed! Expression: {0}",fullExpression);if(obj===Object)throw $parseMinErr("isecobj","Referencing Object in Angular expressions is disallowed! Expression: {0}",fullExpression)}return obj}function ensureSafeFunction(obj,fullExpression){if(obj){if(obj.constructor===obj)throw $parseMinErr("isecfn","Referencing Function in Angular expressions is disallowed! Expression: {0}",fullExpression);if(obj===CALL||obj===APPLY||obj===BIND)throw $parseMinErr("isecff","Referencing call, apply or bind in Angular expressions is disallowed! Expression: {0}",fullExpression)}}function isConstant(exp){return exp.constant}function setter(obj,locals,path,setValue,fullExp){ensureSafeObject(obj,fullExp),ensureSafeObject(locals,fullExp);for(var key,element=path.split("."),i=0;element.length>1;i++){key=ensureSafeMemberName(element.shift(),fullExp);var propertyObj=0===i&&locals&&locals[key]||obj[key];propertyObj||(propertyObj={},obj[key]=propertyObj),obj=ensureSafeObject(propertyObj,fullExp)}return key=ensureSafeMemberName(element.shift(),fullExp),ensureSafeObject(obj[key],fullExp),obj[key]=setValue,setValue}function isPossiblyDangerousMemberName(name){return"constructor"==name}function cspSafeGetterFn(key0,key1,key2,key3,key4,fullExp,expensiveChecks){ensureSafeMemberName(key0,fullExp),ensureSafeMemberName(key1,fullExp),ensureSafeMemberName(key2,fullExp),ensureSafeMemberName(key3,fullExp),ensureSafeMemberName(key4,fullExp);var eso=function(o){return ensureSafeObject(o,fullExp)},eso0=expensiveChecks||isPossiblyDangerousMemberName(key0)?eso:identity,eso1=expensiveChecks||isPossiblyDangerousMemberName(key1)?eso:identity,eso2=expensiveChecks||isPossiblyDangerousMemberName(key2)?eso:identity,eso3=expensiveChecks||isPossiblyDangerousMemberName(key3)?eso:identity,eso4=expensiveChecks||isPossiblyDangerousMemberName(key4)?eso:identity;return function(scope,locals){var pathVal=locals&&locals.hasOwnProperty(key0)?locals:scope;return null==pathVal?pathVal:(pathVal=eso0(pathVal[key0]),key1?null==pathVal?undefined:(pathVal=eso1(pathVal[key1]),key2?null==pathVal?undefined:(pathVal=eso2(pathVal[key2]),key3?null==pathVal?undefined:(pathVal=eso3(pathVal[key3]),key4?null==pathVal?undefined:pathVal=eso4(pathVal[key4]):pathVal):pathVal):pathVal):pathVal)}}function getterFnWithEnsureSafeObject(fn,fullExpression){return function(s,l){return fn(s,l,ensureSafeObject,fullExpression)}}function getterFn(path,options,fullExp){var expensiveChecks=options.expensiveChecks,getterFnCache=expensiveChecks?getterFnCacheExpensive:getterFnCacheDefault,fn=getterFnCache[path];if(fn)return fn;var pathKeys=path.split("."),pathKeysLength=pathKeys.length;if(options.csp)fn=pathKeysLength<6?cspSafeGetterFn(pathKeys[0],pathKeys[1],pathKeys[2],pathKeys[3],pathKeys[4],fullExp,expensiveChecks):function(scope,locals){var val,i=0;do val=cspSafeGetterFn(pathKeys[i++],pathKeys[i++],pathKeys[i++],pathKeys[i++],pathKeys[i++],fullExp,expensiveChecks)(scope,locals),locals=undefined,scope=val;while(i<pathKeysLength);return val};else{var code="";expensiveChecks&&(code+="s = eso(s, fe);\nl = eso(l, fe);\n");var needsEnsureSafeObject=expensiveChecks;forEach(pathKeys,function(key,index){ensureSafeMemberName(key,fullExp);var lookupJs=(index?"s":'((l&&l.hasOwnProperty("'+key+'"))?l:s)')+"."+key;(expensiveChecks||isPossiblyDangerousMemberName(key))&&(lookupJs="eso("+lookupJs+", fe)",needsEnsureSafeObject=!0),code+="if(s == null) return undefined;\ns="+lookupJs+";\n"}),code+="return s;";var evaledFnGetter=new Function("s","l","eso","fe",code);evaledFnGetter.toString=valueFn(code),needsEnsureSafeObject&&(evaledFnGetter=getterFnWithEnsureSafeObject(evaledFnGetter,fullExp)),fn=evaledFnGetter}return fn.sharedGetter=!0,fn.assign=function(self,value,locals){return setter(self,locals,path,value,path)},getterFnCache[path]=fn,fn}function getValueOf(value){return isFunction(value.valueOf)?value.valueOf():objectValueOf.call(value)}function $ParseProvider(){var cacheDefault=createMap(),cacheExpensive=createMap();this.$get=["$filter","$sniffer",function($filter,$sniffer){function wrapSharedExpression(exp){var wrapped=exp;return exp.sharedGetter&&(wrapped=function(self,locals){return exp(self,locals)},wrapped.literal=exp.literal,wrapped.constant=exp.constant,wrapped.assign=exp.assign),wrapped}function collectExpressionInputs(inputs,list){for(var i=0,ii=inputs.length;i<ii;i++){var input=inputs[i];input.constant||(input.inputs?collectExpressionInputs(input.inputs,list):list.indexOf(input)===-1&&list.push(input))}return list}function expressionInputDirtyCheck(newValue,oldValueOfValue){return null==newValue||null==oldValueOfValue?newValue===oldValueOfValue:("object"!=typeof newValue||(newValue=getValueOf(newValue),"object"!=typeof newValue))&&(newValue===oldValueOfValue||newValue!==newValue&&oldValueOfValue!==oldValueOfValue)}function inputsWatchDelegate(scope,listener,objectEquality,parsedExpression){var lastResult,inputExpressions=parsedExpression.$$inputs||(parsedExpression.$$inputs=collectExpressionInputs(parsedExpression.inputs,[]));if(1===inputExpressions.length){var oldInputValue=expressionInputDirtyCheck;return inputExpressions=inputExpressions[0],scope.$watch(function(scope){var newInputValue=inputExpressions(scope);return expressionInputDirtyCheck(newInputValue,oldInputValue)||(lastResult=parsedExpression(scope),oldInputValue=newInputValue&&getValueOf(newInputValue)),lastResult},listener,objectEquality)}for(var oldInputValueOfValues=[],i=0,ii=inputExpressions.length;i<ii;i++)oldInputValueOfValues[i]=expressionInputDirtyCheck;return scope.$watch(function(scope){for(var changed=!1,i=0,ii=inputExpressions.length;i<ii;i++){var newInputValue=inputExpressions[i](scope);(changed||(changed=!expressionInputDirtyCheck(newInputValue,oldInputValueOfValues[i])))&&(oldInputValueOfValues[i]=newInputValue&&getValueOf(newInputValue))}return changed&&(lastResult=parsedExpression(scope)),lastResult},listener,objectEquality)}function oneTimeWatchDelegate(scope,listener,objectEquality,parsedExpression){var unwatch,lastValue;return unwatch=scope.$watch(function(scope){return parsedExpression(scope)},function(value,old,scope){lastValue=value,isFunction(listener)&&listener.apply(this,arguments),isDefined(value)&&scope.$$postDigest(function(){isDefined(lastValue)&&unwatch()})},objectEquality)}function oneTimeLiteralWatchDelegate(scope,listener,objectEquality,parsedExpression){function isAllDefined(value){var allDefined=!0;return forEach(value,function(val){isDefined(val)||(allDefined=!1)}),allDefined}var unwatch,lastValue;return unwatch=scope.$watch(function(scope){return parsedExpression(scope)},function(value,old,scope){lastValue=value,isFunction(listener)&&listener.call(this,value,old,scope),isAllDefined(value)&&scope.$$postDigest(function(){isAllDefined(lastValue)&&unwatch()})},objectEquality)}function constantWatchDelegate(scope,listener,objectEquality,parsedExpression){var unwatch;return unwatch=scope.$watch(function(scope){return parsedExpression(scope)},function(value,old,scope){isFunction(listener)&&listener.apply(this,arguments),unwatch()},objectEquality)}function addInterceptor(parsedExpression,interceptorFn){if(!interceptorFn)return parsedExpression;var watchDelegate=parsedExpression.$$watchDelegate,regularWatch=watchDelegate!==oneTimeLiteralWatchDelegate&&watchDelegate!==oneTimeWatchDelegate,fn=regularWatch?function(scope,locals){var value=parsedExpression(scope,locals);return interceptorFn(value,scope,locals)}:function(scope,locals){var value=parsedExpression(scope,locals),result=interceptorFn(value,scope,locals);return isDefined(value)?result:value};return parsedExpression.$$watchDelegate&&parsedExpression.$$watchDelegate!==inputsWatchDelegate?fn.$$watchDelegate=parsedExpression.$$watchDelegate:interceptorFn.$stateful||(fn.$$watchDelegate=inputsWatchDelegate,fn.inputs=[parsedExpression]),fn}var $parseOptions={csp:$sniffer.csp,expensiveChecks:!1},$parseOptionsExpensive={csp:$sniffer.csp,expensiveChecks:!0};return function(exp,interceptorFn,expensiveChecks){var parsedExpression,oneTime,cacheKey;switch(typeof exp){case"string":cacheKey=exp=exp.trim();var cache=expensiveChecks?cacheExpensive:cacheDefault;if(parsedExpression=cache[cacheKey],!parsedExpression){":"===exp.charAt(0)&&":"===exp.charAt(1)&&(oneTime=!0,exp=exp.substring(2));var parseOptions=expensiveChecks?$parseOptionsExpensive:$parseOptions,lexer=new Lexer(parseOptions),parser=new Parser(lexer,$filter,parseOptions);parsedExpression=parser.parse(exp),parsedExpression.constant?parsedExpression.$$watchDelegate=constantWatchDelegate:oneTime?(parsedExpression=wrapSharedExpression(parsedExpression),parsedExpression.$$watchDelegate=parsedExpression.literal?oneTimeLiteralWatchDelegate:oneTimeWatchDelegate):parsedExpression.inputs&&(parsedExpression.$$watchDelegate=inputsWatchDelegate),cache[cacheKey]=parsedExpression}return addInterceptor(parsedExpression,interceptorFn);case"function":return addInterceptor(exp,interceptorFn);default:return addInterceptor(noop,interceptorFn)}}}]}function $QProvider(){this.$get=["$rootScope","$exceptionHandler",function($rootScope,$exceptionHandler){return qFactory(function(callback){$rootScope.$evalAsync(callback)},$exceptionHandler)}]}function $$QProvider(){this.$get=["$browser","$exceptionHandler",function($browser,$exceptionHandler){return qFactory(function(callback){$browser.defer(callback)},$exceptionHandler)}]}function qFactory(nextTick,exceptionHandler){function callOnce(self,resolveFn,rejectFn){function wrap(fn){return function(value){called||(called=!0,fn.call(self,value))}}var called=!1;return[wrap(resolveFn),wrap(rejectFn)]}function Promise(){this.$$state={status:0}}function simpleBind(context,fn){return function(value){fn.call(context,value)}}function processQueue(state){var fn,promise,pending;pending=state.pending,state.processScheduled=!1,state.pending=undefined;for(var i=0,ii=pending.length;i<ii;++i){promise=pending[i][0],fn=pending[i][state.status];try{isFunction(fn)?promise.resolve(fn(state.value)):1===state.status?promise.resolve(state.value):promise.reject(state.value)}catch(e){promise.reject(e),exceptionHandler(e)}}}function scheduleProcessQueue(state){!state.processScheduled&&state.pending&&(state.processScheduled=!0,nextTick(function(){processQueue(state)}))}function Deferred(){this.promise=new Promise,this.resolve=simpleBind(this,this.resolve),this.reject=simpleBind(this,this.reject),this.notify=simpleBind(this,this.notify)}function all(promises){var deferred=new Deferred,counter=0,results=isArray(promises)?[]:{};return forEach(promises,function(promise,key){counter++,when(promise).then(function(value){results.hasOwnProperty(key)||(results[key]=value,--counter||deferred.resolve(results))},function(reason){results.hasOwnProperty(key)||deferred.reject(reason)})}),0===counter&&deferred.resolve(results),deferred.promise}var $qMinErr=minErr("$q",TypeError),defer=function(){return new Deferred};Promise.prototype={then:function(onFulfilled,onRejected,progressBack){var result=new Deferred;return this.$$state.pending=this.$$state.pending||[],this.$$state.pending.push([result,onFulfilled,onRejected,progressBack]),this.$$state.status>0&&scheduleProcessQueue(this.$$state),result.promise},catch:function(callback){return this.then(null,callback)},finally:function(callback,progressBack){return this.then(function(value){return handleCallback(value,!0,callback)},function(error){return handleCallback(error,!1,callback)},progressBack)}},Deferred.prototype={resolve:function(val){this.promise.$$state.status||(val===this.promise?this.$$reject($qMinErr("qcycle","Expected promise to be resolved with value other than itself '{0}'",val)):this.$$resolve(val))},$$resolve:function(val){var then,fns;fns=callOnce(this,this.$$resolve,this.$$reject);try{(isObject(val)||isFunction(val))&&(then=val&&val.then),isFunction(then)?(this.promise.$$state.status=-1,then.call(val,fns[0],fns[1],this.notify)):(this.promise.$$state.value=val,this.promise.$$state.status=1,scheduleProcessQueue(this.promise.$$state))}catch(e){fns[1](e),exceptionHandler(e)}},reject:function(reason){this.promise.$$state.status||this.$$reject(reason)},$$reject:function(reason){this.promise.$$state.value=reason,this.promise.$$state.status=2,scheduleProcessQueue(this.promise.$$state)},notify:function(progress){var callbacks=this.promise.$$state.pending;this.promise.$$state.status<=0&&callbacks&&callbacks.length&&nextTick(function(){for(var callback,result,i=0,ii=callbacks.length;i<ii;i++){result=callbacks[i][0],callback=callbacks[i][3];try{result.notify(isFunction(callback)?callback(progress):progress)}catch(e){exceptionHandler(e)}}})}};var reject=function(reason){var result=new Deferred;return result.reject(reason),result.promise},makePromise=function(value,resolved){var result=new Deferred;return resolved?result.resolve(value):result.reject(value),result.promise},handleCallback=function(value,isResolved,callback){var callbackOutput=null;try{isFunction(callback)&&(callbackOutput=callback())}catch(e){return makePromise(e,!1)}return isPromiseLike(callbackOutput)?callbackOutput.then(function(){return makePromise(value,isResolved)},function(error){return makePromise(error,!1)}):makePromise(value,isResolved)},when=function(value,callback,errback,progressBack){var result=new Deferred;return result.resolve(value),result.promise.then(callback,errback,progressBack)},$Q=function Q(resolver){function resolveFn(value){deferred.resolve(value)}function rejectFn(reason){deferred.reject(reason)}if(!isFunction(resolver))throw $qMinErr("norslvr","Expected resolverFn, got '{0}'",resolver);if(!(this instanceof Q))return new Q(resolver);var deferred=new Deferred;return resolver(resolveFn,rejectFn),deferred.promise};return $Q.defer=defer,$Q.reject=reject,$Q.when=when,$Q.all=all,$Q}function $$RAFProvider(){this.$get=["$window","$timeout",function($window,$timeout){function flush(){for(var i=0;i<taskQueue.length;i++){var task=taskQueue[i];task&&(taskQueue[i]=null,task())}taskCount=taskQueue.length=0}function queueFn(asyncFn){var index=taskQueue.length;return taskCount++,taskQueue.push(asyncFn),0===index&&(cancelLastRAF=rafFn(flush)),function(){index>=0&&(taskQueue[index]=null,index=null,0===--taskCount&&cancelLastRAF&&(cancelLastRAF(),cancelLastRAF=null,taskQueue.length=0))}}var requestAnimationFrame=$window.requestAnimationFrame||$window.webkitRequestAnimationFrame,cancelAnimationFrame=$window.cancelAnimationFrame||$window.webkitCancelAnimationFrame||$window.webkitCancelRequestAnimationFrame,rafSupported=!!requestAnimationFrame,rafFn=rafSupported?function(fn){var id=requestAnimationFrame(fn);return function(){cancelAnimationFrame(id)}}:function(fn){var timer=$timeout(fn,16.66,!1);return function(){$timeout.cancel(timer)}};queueFn.supported=rafSupported;var cancelLastRAF,taskCount=0,taskQueue=[];return queueFn}]}function $RootScopeProvider(){function createChildScopeClass(parent){function ChildScope(){this.$$watchers=this.$$nextSibling=this.$$childHead=this.$$childTail=null,this.$$listeners={},this.$$listenerCount={},this.$id=nextUid(),this.$$ChildScope=null}return ChildScope.prototype=parent,ChildScope}var TTL=10,$rootScopeMinErr=minErr("$rootScope"),lastDirtyWatch=null,applyAsyncId=null;this.digestTtl=function(value){return arguments.length&&(TTL=value),TTL},this.$get=["$injector","$exceptionHandler","$parse","$browser",function($injector,$exceptionHandler,$parse,$browser){function destroyChildScope($event){$event.currentScope.$$destroyed=!0}function Scope(){this.$id=nextUid(),this.$$phase=this.$parent=this.$$watchers=this.$$nextSibling=this.$$prevSibling=this.$$childHead=this.$$childTail=null,this.$root=this,this.$$destroyed=!1,this.$$listeners={},this.$$listenerCount={},this.$$isolateBindings=null}function beginPhase(phase){if($rootScope.$$phase)throw $rootScopeMinErr("inprog","{0} already in progress",$rootScope.$$phase);$rootScope.$$phase=phase}function clearPhase(){$rootScope.$$phase=null}function decrementListenerCount(current,count,name){do current.$$listenerCount[name]-=count,0===current.$$listenerCount[name]&&delete current.$$listenerCount[name];while(current=current.$parent)}function initWatchVal(){}function flushApplyAsync(){for(;applyAsyncQueue.length;)try{applyAsyncQueue.shift()()}catch(e){$exceptionHandler(e)}applyAsyncId=null}function scheduleApplyAsync(){null===applyAsyncId&&(applyAsyncId=$browser.defer(function(){$rootScope.$apply(flushApplyAsync)}))}Scope.prototype={constructor:Scope,$new:function(isolate,parent){var child;return parent=parent||this,isolate?(child=new Scope,child.$root=this.$root):(this.$$ChildScope||(this.$$ChildScope=createChildScopeClass(this)),child=new this.$$ChildScope),child.$parent=parent,child.$$prevSibling=parent.$$childTail,parent.$$childHead?(parent.$$childTail.$$nextSibling=child,parent.$$childTail=child):parent.$$childHead=parent.$$childTail=child,(isolate||parent!=this)&&child.$on("$destroy",destroyChildScope),child},$watch:function(watchExp,listener,objectEquality){var get=$parse(watchExp);if(get.$$watchDelegate)return get.$$watchDelegate(this,listener,objectEquality,get);var scope=this,array=scope.$$watchers,watcher={fn:listener,last:initWatchVal,get:get,exp:watchExp,eq:!!objectEquality};return lastDirtyWatch=null,isFunction(listener)||(watcher.fn=noop),array||(array=scope.$$watchers=[]),array.unshift(watcher),function(){arrayRemove(array,watcher),lastDirtyWatch=null}},$watchGroup:function(watchExpressions,listener){function watchGroupAction(){changeReactionScheduled=!1,firstRun?(firstRun=!1,listener(newValues,newValues,self)):listener(newValues,oldValues,self)}var oldValues=new Array(watchExpressions.length),newValues=new Array(watchExpressions.length),deregisterFns=[],self=this,changeReactionScheduled=!1,firstRun=!0;if(!watchExpressions.length){var shouldCall=!0;return self.$evalAsync(function(){shouldCall&&listener(newValues,newValues,self)}),function(){shouldCall=!1}}return 1===watchExpressions.length?this.$watch(watchExpressions[0],function(value,oldValue,scope){newValues[0]=value,oldValues[0]=oldValue,listener(newValues,value===oldValue?newValues:oldValues,scope)}):(forEach(watchExpressions,function(expr,i){var unwatchFn=self.$watch(expr,function(value,oldValue){newValues[i]=value,oldValues[i]=oldValue,changeReactionScheduled||(changeReactionScheduled=!0,self.$evalAsync(watchGroupAction))});deregisterFns.push(unwatchFn)}),function(){for(;deregisterFns.length;)deregisterFns.shift()()})},$watchCollection:function(obj,listener){function $watchCollectionInterceptor(_value){newValue=_value;var newLength,key,bothNaN,newItem,oldItem;if(!isUndefined(newValue)){if(isObject(newValue))if(isArrayLike(newValue)){oldValue!==internalArray&&(oldValue=internalArray,oldLength=oldValue.length=0,changeDetected++),newLength=newValue.length,oldLength!==newLength&&(changeDetected++,oldValue.length=oldLength=newLength);for(var i=0;i<newLength;i++)oldItem=oldValue[i],newItem=newValue[i],bothNaN=oldItem!==oldItem&&newItem!==newItem,bothNaN||oldItem===newItem||(changeDetected++,oldValue[i]=newItem)}else{oldValue!==internalObject&&(oldValue=internalObject={},oldLength=0,changeDetected++),newLength=0;for(key in newValue)newValue.hasOwnProperty(key)&&(newLength++,newItem=newValue[key],oldItem=oldValue[key],key in oldValue?(bothNaN=oldItem!==oldItem&&newItem!==newItem,bothNaN||oldItem===newItem||(changeDetected++,oldValue[key]=newItem)):(oldLength++,oldValue[key]=newItem,changeDetected++));if(oldLength>newLength){changeDetected++;for(key in oldValue)newValue.hasOwnProperty(key)||(oldLength--,delete oldValue[key])}}else oldValue!==newValue&&(oldValue=newValue,changeDetected++);return changeDetected}}function $watchCollectionAction(){if(initRun?(initRun=!1,listener(newValue,newValue,self)):listener(newValue,veryOldValue,self),trackVeryOldValue)if(isObject(newValue))if(isArrayLike(newValue)){veryOldValue=new Array(newValue.length);for(var i=0;i<newValue.length;i++)veryOldValue[i]=newValue[i]}else{veryOldValue={};for(var key in newValue)hasOwnProperty.call(newValue,key)&&(veryOldValue[key]=newValue[key])}else veryOldValue=newValue}$watchCollectionInterceptor.$stateful=!0;var newValue,oldValue,veryOldValue,self=this,trackVeryOldValue=listener.length>1,changeDetected=0,changeDetector=$parse(obj,$watchCollectionInterceptor),internalArray=[],internalObject={},initRun=!0,oldLength=0;return this.$watch(changeDetector,$watchCollectionAction)},$digest:function(){var watch,value,last,watchers,length,dirty,next,current,logIdx,asyncTask,ttl=TTL,target=this,watchLog=[];beginPhase("$digest"),$browser.$$checkUrlChange(),this===$rootScope&&null!==applyAsyncId&&($browser.defer.cancel(applyAsyncId),flushApplyAsync()),lastDirtyWatch=null;do{for(dirty=!1,current=target;asyncQueue.length;){try{asyncTask=asyncQueue.shift(),asyncTask.scope.$eval(asyncTask.expression,asyncTask.locals)}catch(e){$exceptionHandler(e)}lastDirtyWatch=null}traverseScopesLoop:do{if(watchers=current.$$watchers)for(length=watchers.length;length--;)try{if(watch=watchers[length])if((value=watch.get(current))===(last=watch.last)||(watch.eq?equals(value,last):"number"==typeof value&&"number"==typeof last&&isNaN(value)&&isNaN(last))){
if(watch===lastDirtyWatch){dirty=!1;break traverseScopesLoop}}else dirty=!0,lastDirtyWatch=watch,watch.last=watch.eq?copy(value,null):value,watch.fn(value,last===initWatchVal?value:last,current),ttl<5&&(logIdx=4-ttl,watchLog[logIdx]||(watchLog[logIdx]=[]),watchLog[logIdx].push({msg:isFunction(watch.exp)?"fn: "+(watch.exp.name||watch.exp.toString()):watch.exp,newVal:value,oldVal:last}))}catch(e){$exceptionHandler(e)}if(!(next=current.$$childHead||current!==target&&current.$$nextSibling))for(;current!==target&&!(next=current.$$nextSibling);)current=current.$parent}while(current=next);if((dirty||asyncQueue.length)&&!ttl--)throw clearPhase(),$rootScopeMinErr("infdig","{0} $digest() iterations reached. Aborting!\nWatchers fired in the last 5 iterations: {1}",TTL,watchLog)}while(dirty||asyncQueue.length);for(clearPhase();postDigestQueue.length;)try{postDigestQueue.shift()()}catch(e){$exceptionHandler(e)}},$destroy:function(){if(!this.$$destroyed){var parent=this.$parent;if(this.$broadcast("$destroy"),this.$$destroyed=!0,this!==$rootScope){for(var eventName in this.$$listenerCount)decrementListenerCount(this,this.$$listenerCount[eventName],eventName);parent.$$childHead==this&&(parent.$$childHead=this.$$nextSibling),parent.$$childTail==this&&(parent.$$childTail=this.$$prevSibling),this.$$prevSibling&&(this.$$prevSibling.$$nextSibling=this.$$nextSibling),this.$$nextSibling&&(this.$$nextSibling.$$prevSibling=this.$$prevSibling),this.$destroy=this.$digest=this.$apply=this.$evalAsync=this.$applyAsync=noop,this.$on=this.$watch=this.$watchGroup=function(){return noop},this.$$listeners={},this.$parent=this.$$nextSibling=this.$$prevSibling=this.$$childHead=this.$$childTail=this.$root=this.$$watchers=null}}},$eval:function(expr,locals){return $parse(expr)(this,locals)},$evalAsync:function(expr,locals){$rootScope.$$phase||asyncQueue.length||$browser.defer(function(){asyncQueue.length&&$rootScope.$digest()}),asyncQueue.push({scope:this,expression:expr,locals:locals})},$$postDigest:function(fn){postDigestQueue.push(fn)},$apply:function(expr){try{return beginPhase("$apply"),this.$eval(expr)}catch(e){$exceptionHandler(e)}finally{clearPhase();try{$rootScope.$digest()}catch(e){throw $exceptionHandler(e),e}}},$applyAsync:function(expr){function $applyAsyncExpression(){scope.$eval(expr)}var scope=this;expr&&applyAsyncQueue.push($applyAsyncExpression),scheduleApplyAsync()},$on:function(name,listener){var namedListeners=this.$$listeners[name];namedListeners||(this.$$listeners[name]=namedListeners=[]),namedListeners.push(listener);var current=this;do current.$$listenerCount[name]||(current.$$listenerCount[name]=0),current.$$listenerCount[name]++;while(current=current.$parent);var self=this;return function(){var indexOfListener=namedListeners.indexOf(listener);indexOfListener!==-1&&(namedListeners[indexOfListener]=null,decrementListenerCount(self,1,name))}},$emit:function(name,args){var namedListeners,i,length,empty=[],scope=this,stopPropagation=!1,event={name:name,targetScope:scope,stopPropagation:function(){stopPropagation=!0},preventDefault:function(){event.defaultPrevented=!0},defaultPrevented:!1},listenerArgs=concat([event],arguments,1);do{for(namedListeners=scope.$$listeners[name]||empty,event.currentScope=scope,i=0,length=namedListeners.length;i<length;i++)if(namedListeners[i])try{namedListeners[i].apply(null,listenerArgs)}catch(e){$exceptionHandler(e)}else namedListeners.splice(i,1),i--,length--;if(stopPropagation)return event.currentScope=null,event;scope=scope.$parent}while(scope);return event.currentScope=null,event},$broadcast:function(name,args){var target=this,current=target,next=target,event={name:name,targetScope:target,preventDefault:function(){event.defaultPrevented=!0},defaultPrevented:!1};if(!target.$$listenerCount[name])return event;for(var listeners,i,length,listenerArgs=concat([event],arguments,1);current=next;){for(event.currentScope=current,listeners=current.$$listeners[name]||[],i=0,length=listeners.length;i<length;i++)if(listeners[i])try{listeners[i].apply(null,listenerArgs)}catch(e){$exceptionHandler(e)}else listeners.splice(i,1),i--,length--;if(!(next=current.$$listenerCount[name]&&current.$$childHead||current!==target&&current.$$nextSibling))for(;current!==target&&!(next=current.$$nextSibling);)current=current.$parent}return event.currentScope=null,event}};var $rootScope=new Scope,asyncQueue=$rootScope.$$asyncQueue=[],postDigestQueue=$rootScope.$$postDigestQueue=[],applyAsyncQueue=$rootScope.$$applyAsyncQueue=[];return $rootScope}]}function $$SanitizeUriProvider(){var aHrefSanitizationWhitelist=/^\s*(https?|ftp|mailto|tel|file):/,imgSrcSanitizationWhitelist=/^\s*((https?|ftp|file|blob):|data:image\/)/;this.aHrefSanitizationWhitelist=function(regexp){return isDefined(regexp)?(aHrefSanitizationWhitelist=regexp,this):aHrefSanitizationWhitelist},this.imgSrcSanitizationWhitelist=function(regexp){return isDefined(regexp)?(imgSrcSanitizationWhitelist=regexp,this):imgSrcSanitizationWhitelist},this.$get=function(){return function(uri,isImage){var normalizedVal,regex=isImage?imgSrcSanitizationWhitelist:aHrefSanitizationWhitelist;return normalizedVal=urlResolve(uri).href,""===normalizedVal||normalizedVal.match(regex)?uri:"unsafe:"+normalizedVal}}}function adjustMatcher(matcher){if("self"===matcher)return matcher;if(isString(matcher)){if(matcher.indexOf("***")>-1)throw $sceMinErr("iwcard","Illegal sequence *** in string matcher.  String: {0}",matcher);return matcher=escapeForRegexp(matcher).replace("\\*\\*",".*").replace("\\*","[^:/.?&;]*"),new RegExp("^"+matcher+"$")}if(isRegExp(matcher))return new RegExp("^"+matcher.source+"$");throw $sceMinErr("imatcher",'Matchers may only be "self", string patterns or RegExp objects')}function adjustMatchers(matchers){var adjustedMatchers=[];return isDefined(matchers)&&forEach(matchers,function(matcher){adjustedMatchers.push(adjustMatcher(matcher))}),adjustedMatchers}function $SceDelegateProvider(){this.SCE_CONTEXTS=SCE_CONTEXTS;var resourceUrlWhitelist=["self"],resourceUrlBlacklist=[];this.resourceUrlWhitelist=function(value){return arguments.length&&(resourceUrlWhitelist=adjustMatchers(value)),resourceUrlWhitelist},this.resourceUrlBlacklist=function(value){return arguments.length&&(resourceUrlBlacklist=adjustMatchers(value)),resourceUrlBlacklist},this.$get=["$injector",function($injector){function matchUrl(matcher,parsedUrl){return"self"===matcher?urlIsSameOrigin(parsedUrl):!!matcher.exec(parsedUrl.href)}function isResourceUrlAllowedByPolicy(url){var i,n,parsedUrl=urlResolve(url.toString()),allowed=!1;for(i=0,n=resourceUrlWhitelist.length;i<n;i++)if(matchUrl(resourceUrlWhitelist[i],parsedUrl)){allowed=!0;break}if(allowed)for(i=0,n=resourceUrlBlacklist.length;i<n;i++)if(matchUrl(resourceUrlBlacklist[i],parsedUrl)){allowed=!1;break}return allowed}function generateHolderType(Base){var holderType=function(trustedValue){this.$$unwrapTrustedValue=function(){return trustedValue}};return Base&&(holderType.prototype=new Base),holderType.prototype.valueOf=function(){return this.$$unwrapTrustedValue()},holderType.prototype.toString=function(){return this.$$unwrapTrustedValue().toString()},holderType}function trustAs(type,trustedValue){var Constructor=byType.hasOwnProperty(type)?byType[type]:null;if(!Constructor)throw $sceMinErr("icontext","Attempted to trust a value in invalid context. Context: {0}; Value: {1}",type,trustedValue);if(null===trustedValue||trustedValue===undefined||""===trustedValue)return trustedValue;if("string"!=typeof trustedValue)throw $sceMinErr("itype","Attempted to trust a non-string value in a content requiring a string: Context: {0}",type);return new Constructor(trustedValue)}function valueOf(maybeTrusted){return maybeTrusted instanceof trustedValueHolderBase?maybeTrusted.$$unwrapTrustedValue():maybeTrusted}function getTrusted(type,maybeTrusted){if(null===maybeTrusted||maybeTrusted===undefined||""===maybeTrusted)return maybeTrusted;var constructor=byType.hasOwnProperty(type)?byType[type]:null;if(constructor&&maybeTrusted instanceof constructor)return maybeTrusted.$$unwrapTrustedValue();if(type===SCE_CONTEXTS.RESOURCE_URL){if(isResourceUrlAllowedByPolicy(maybeTrusted))return maybeTrusted;throw $sceMinErr("insecurl","Blocked loading resource from url not allowed by $sceDelegate policy.  URL: {0}",maybeTrusted.toString())}if(type===SCE_CONTEXTS.HTML)return htmlSanitizer(maybeTrusted);throw $sceMinErr("unsafe","Attempting to use an unsafe value in a safe context.")}var htmlSanitizer=function(html){throw $sceMinErr("unsafe","Attempting to use an unsafe value in a safe context.")};$injector.has("$sanitize")&&(htmlSanitizer=$injector.get("$sanitize"));var trustedValueHolderBase=generateHolderType(),byType={};return byType[SCE_CONTEXTS.HTML]=generateHolderType(trustedValueHolderBase),byType[SCE_CONTEXTS.CSS]=generateHolderType(trustedValueHolderBase),byType[SCE_CONTEXTS.URL]=generateHolderType(trustedValueHolderBase),byType[SCE_CONTEXTS.JS]=generateHolderType(trustedValueHolderBase),byType[SCE_CONTEXTS.RESOURCE_URL]=generateHolderType(byType[SCE_CONTEXTS.URL]),{trustAs:trustAs,getTrusted:getTrusted,valueOf:valueOf}}]}function $SceProvider(){var enabled=!0;this.enabled=function(value){return arguments.length&&(enabled=!!value),enabled},this.$get=["$parse","$sceDelegate",function($parse,$sceDelegate){if(enabled&&msie<8)throw $sceMinErr("iequirks","Strict Contextual Escaping does not support Internet Explorer version < 11 in quirks mode.  You can fix this by adding the text <!doctype html> to the top of your HTML document.  See http://docs.angularjs.org/api/ng.$sce for more information.");var sce=shallowCopy(SCE_CONTEXTS);sce.isEnabled=function(){return enabled},sce.trustAs=$sceDelegate.trustAs,sce.getTrusted=$sceDelegate.getTrusted,sce.valueOf=$sceDelegate.valueOf,enabled||(sce.trustAs=sce.getTrusted=function(type,value){return value},sce.valueOf=identity),sce.parseAs=function(type,expr){var parsed=$parse(expr);return parsed.literal&&parsed.constant?parsed:$parse(expr,function(value){return sce.getTrusted(type,value)})};var parse=sce.parseAs,getTrusted=sce.getTrusted,trustAs=sce.trustAs;return forEach(SCE_CONTEXTS,function(enumValue,name){var lName=lowercase(name);sce[camelCase("parse_as_"+lName)]=function(expr){return parse(enumValue,expr)},sce[camelCase("get_trusted_"+lName)]=function(value){return getTrusted(enumValue,value)},sce[camelCase("trust_as_"+lName)]=function(value){return trustAs(enumValue,value)}}),sce}]}function $SnifferProvider(){this.$get=["$window","$document",function($window,$document){var vendorPrefix,match,eventSupport={},android=int((/android (\d+)/.exec(lowercase(($window.navigator||{}).userAgent))||[])[1]),boxee=/Boxee/i.test(($window.navigator||{}).userAgent),document=$document[0]||{},vendorRegex=/^(Moz|webkit|ms)(?=[A-Z])/,bodyStyle=document.body&&document.body.style,transitions=!1,animations=!1;if(bodyStyle){for(var prop in bodyStyle)if(match=vendorRegex.exec(prop)){vendorPrefix=match[0],vendorPrefix=vendorPrefix.substr(0,1).toUpperCase()+vendorPrefix.substr(1);break}vendorPrefix||(vendorPrefix="WebkitOpacity"in bodyStyle&&"webkit"),transitions=!!("transition"in bodyStyle||vendorPrefix+"Transition"in bodyStyle),animations=!!("animation"in bodyStyle||vendorPrefix+"Animation"in bodyStyle),!android||transitions&&animations||(transitions=isString(document.body.style.webkitTransition),animations=isString(document.body.style.webkitAnimation))}return{history:!(!$window.history||!$window.history.pushState||android<4||boxee),hasEvent:function(event){if("input"===event&&msie<=11)return!1;if(isUndefined(eventSupport[event])){var divElm=document.createElement("div");eventSupport[event]="on"+event in divElm}return eventSupport[event]},csp:csp(),vendorPrefix:vendorPrefix,transitions:transitions,animations:animations,android:android}}]}function $TemplateRequestProvider(){this.$get=["$templateCache","$http","$q","$sce",function($templateCache,$http,$q,$sce){function handleRequestFn(tpl,ignoreRequestError){function handleError(resp){if(!ignoreRequestError)throw $compileMinErr("tpload","Failed to load template: {0}",tpl);return $q.reject(resp)}handleRequestFn.totalPendingRequests++,isString(tpl)&&$templateCache.get(tpl)||(tpl=$sce.getTrustedResourceUrl(tpl));var transformResponse=$http.defaults&&$http.defaults.transformResponse;isArray(transformResponse)?transformResponse=transformResponse.filter(function(transformer){return transformer!==defaultHttpResponseTransform}):transformResponse===defaultHttpResponseTransform&&(transformResponse=null);var httpOptions={cache:$templateCache,transformResponse:transformResponse};return $http.get(tpl,httpOptions).finally(function(){handleRequestFn.totalPendingRequests--}).then(function(response){return response.data},handleError)}return handleRequestFn.totalPendingRequests=0,handleRequestFn}]}function $$TestabilityProvider(){this.$get=["$rootScope","$browser","$location",function($rootScope,$browser,$location){var testability={};return testability.findBindings=function(element,expression,opt_exactMatch){var bindings=element.getElementsByClassName("ng-binding"),matches=[];return forEach(bindings,function(binding){var dataBinding=angular.element(binding).data("$binding");dataBinding&&forEach(dataBinding,function(bindingName){if(opt_exactMatch){var matcher=new RegExp("(^|\\s)"+escapeForRegexp(expression)+"(\\s|\\||$)");matcher.test(bindingName)&&matches.push(binding)}else bindingName.indexOf(expression)!=-1&&matches.push(binding)})}),matches},testability.findModels=function(element,expression,opt_exactMatch){for(var prefixes=["ng-","data-ng-","ng\\:"],p=0;p<prefixes.length;++p){var attributeEquals=opt_exactMatch?"=":"*=",selector="["+prefixes[p]+"model"+attributeEquals+'"'+expression+'"]',elements=element.querySelectorAll(selector);if(elements.length)return elements}},testability.getLocation=function(){return $location.url()},testability.setLocation=function(url){url!==$location.url()&&($location.url(url),$rootScope.$digest())},testability.whenStable=function(callback){$browser.notifyWhenNoOutstandingRequests(callback)},testability}]}function $TimeoutProvider(){this.$get=["$rootScope","$browser","$q","$$q","$exceptionHandler",function($rootScope,$browser,$q,$$q,$exceptionHandler){function timeout(fn,delay,invokeApply){var timeoutId,skipApply=isDefined(invokeApply)&&!invokeApply,deferred=(skipApply?$$q:$q).defer(),promise=deferred.promise;return timeoutId=$browser.defer(function(){try{deferred.resolve(fn())}catch(e){deferred.reject(e),$exceptionHandler(e)}finally{delete deferreds[promise.$$timeoutId]}skipApply||$rootScope.$apply()},delay),promise.$$timeoutId=timeoutId,deferreds[timeoutId]=deferred,promise}var deferreds={};return timeout.cancel=function(promise){return!!(promise&&promise.$$timeoutId in deferreds)&&(deferreds[promise.$$timeoutId].reject("canceled"),delete deferreds[promise.$$timeoutId],$browser.defer.cancel(promise.$$timeoutId))},timeout}]}function urlResolve(url){var href=url;return msie&&(urlParsingNode.setAttribute("href",href),href=urlParsingNode.href),urlParsingNode.setAttribute("href",href),{href:urlParsingNode.href,protocol:urlParsingNode.protocol?urlParsingNode.protocol.replace(/:$/,""):"",host:urlParsingNode.host,search:urlParsingNode.search?urlParsingNode.search.replace(/^\?/,""):"",hash:urlParsingNode.hash?urlParsingNode.hash.replace(/^#/,""):"",hostname:urlParsingNode.hostname,port:urlParsingNode.port,pathname:"/"===urlParsingNode.pathname.charAt(0)?urlParsingNode.pathname:"/"+urlParsingNode.pathname}}function urlIsSameOrigin(requestUrl){var parsed=isString(requestUrl)?urlResolve(requestUrl):requestUrl;return parsed.protocol===originUrl.protocol&&parsed.host===originUrl.host}function $WindowProvider(){this.$get=valueFn(window)}function $FilterProvider($provide){function register(name,factory){if(isObject(name)){var filters={};return forEach(name,function(filter,key){filters[key]=register(key,filter)}),filters}return $provide.factory(name+suffix,factory)}var suffix="Filter";this.register=register,this.$get=["$injector",function($injector){return function(name){return $injector.get(name+suffix)}}],register("currency",currencyFilter),register("date",dateFilter),register("filter",filterFilter),register("json",jsonFilter),register("limitTo",limitToFilter),register("lowercase",lowercaseFilter),register("number",numberFilter),register("orderBy",orderByFilter),register("uppercase",uppercaseFilter)}function filterFilter(){return function(array,expression,comparator){if(!isArray(array))return array;var predicateFn,matchAgainstAnyProp,expressionType=null!==expression?typeof expression:"null";switch(expressionType){case"function":predicateFn=expression;break;case"boolean":case"null":case"number":case"string":matchAgainstAnyProp=!0;case"object":predicateFn=createPredicateFn(expression,comparator,matchAgainstAnyProp);break;default:return array}return array.filter(predicateFn)}}function createPredicateFn(expression,comparator,matchAgainstAnyProp){var predicateFn,shouldMatchPrimitives=isObject(expression)&&"$"in expression;return comparator===!0?comparator=equals:isFunction(comparator)||(comparator=function(actual,expected){return!isUndefined(actual)&&(null===actual||null===expected?actual===expected:!isObject(actual)&&!isObject(expected)&&(actual=lowercase(""+actual),expected=lowercase(""+expected),actual.indexOf(expected)!==-1))}),predicateFn=function(item){return shouldMatchPrimitives&&!isObject(item)?deepCompare(item,expression.$,comparator,!1):deepCompare(item,expression,comparator,matchAgainstAnyProp)}}function deepCompare(actual,expected,comparator,matchAgainstAnyProp,dontMatchWholeObject){var actualType=null!==actual?typeof actual:"null",expectedType=null!==expected?typeof expected:"null";if("string"===expectedType&&"!"===expected.charAt(0))return!deepCompare(actual,expected.substring(1),comparator,matchAgainstAnyProp);if(isArray(actual))return actual.some(function(item){return deepCompare(item,expected,comparator,matchAgainstAnyProp)});switch(actualType){case"object":var key;if(matchAgainstAnyProp){for(key in actual)if("$"!==key.charAt(0)&&deepCompare(actual[key],expected,comparator,!0))return!0;return!dontMatchWholeObject&&deepCompare(actual,expected,comparator,!1)}if("object"===expectedType){for(key in expected){var expectedVal=expected[key];if(!isFunction(expectedVal)&&!isUndefined(expectedVal)){var matchAnyProperty="$"===key,actualVal=matchAnyProperty?actual:actual[key];if(!deepCompare(actualVal,expectedVal,comparator,matchAnyProperty,matchAnyProperty))return!1}}return!0}return comparator(actual,expected);case"function":return!1;default:return comparator(actual,expected)}}function currencyFilter($locale){var formats=$locale.NUMBER_FORMATS;return function(amount,currencySymbol,fractionSize){return isUndefined(currencySymbol)&&(currencySymbol=formats.CURRENCY_SYM),isUndefined(fractionSize)&&(fractionSize=formats.PATTERNS[1].maxFrac),null==amount?amount:formatNumber(amount,formats.PATTERNS[1],formats.GROUP_SEP,formats.DECIMAL_SEP,fractionSize).replace(/\u00A4/g,currencySymbol)}}function numberFilter($locale){var formats=$locale.NUMBER_FORMATS;return function(number,fractionSize){return null==number?number:formatNumber(number,formats.PATTERNS[0],formats.GROUP_SEP,formats.DECIMAL_SEP,fractionSize)}}function formatNumber(number,pattern,groupSep,decimalSep,fractionSize){if(!isFinite(number)||isObject(number))return"";var isNegative=number<0;number=Math.abs(number);var numStr=number+"",formatedText="",parts=[],hasExponent=!1;if(numStr.indexOf("e")!==-1){var match=numStr.match(/([\d\.]+)e(-?)(\d+)/);match&&"-"==match[2]&&match[3]>fractionSize+1?number=0:(formatedText=numStr,hasExponent=!0)}if(hasExponent)fractionSize>0&&number<1&&(formatedText=number.toFixed(fractionSize),number=parseFloat(formatedText));else{var fractionLen=(numStr.split(DECIMAL_SEP)[1]||"").length;isUndefined(fractionSize)&&(fractionSize=Math.min(Math.max(pattern.minFrac,fractionLen),pattern.maxFrac)),number=+(Math.round(+(number.toString()+"e"+fractionSize)).toString()+"e"+-fractionSize);var fraction=(""+number).split(DECIMAL_SEP),whole=fraction[0];fraction=fraction[1]||"";var i,pos=0,lgroup=pattern.lgSize,group=pattern.gSize;if(whole.length>=lgroup+group)for(pos=whole.length-lgroup,i=0;i<pos;i++)(pos-i)%group===0&&0!==i&&(formatedText+=groupSep),formatedText+=whole.charAt(i);for(i=pos;i<whole.length;i++)(whole.length-i)%lgroup===0&&0!==i&&(formatedText+=groupSep),formatedText+=whole.charAt(i);for(;fraction.length<fractionSize;)fraction+="0";fractionSize&&"0"!==fractionSize&&(formatedText+=decimalSep+fraction.substr(0,fractionSize))}return 0===number&&(isNegative=!1),parts.push(isNegative?pattern.negPre:pattern.posPre,formatedText,isNegative?pattern.negSuf:pattern.posSuf),parts.join("")}function padNumber(num,digits,trim){var neg="";for(num<0&&(neg="-",num=-num),num=""+num;num.length<digits;)num="0"+num;return trim&&(num=num.substr(num.length-digits)),neg+num}function dateGetter(name,size,offset,trim){return offset=offset||0,function(date){var value=date["get"+name]();return(offset>0||value>-offset)&&(value+=offset),0===value&&offset==-12&&(value=12),padNumber(value,size,trim)}}function dateStrGetter(name,shortForm){return function(date,formats){var value=date["get"+name](),get=uppercase(shortForm?"SHORT"+name:name);return formats[get][value]}}function timeZoneGetter(date){var zone=-1*date.getTimezoneOffset(),paddedZone=zone>=0?"+":"";return paddedZone+=padNumber(Math[zone>0?"floor":"ceil"](zone/60),2)+padNumber(Math.abs(zone%60),2)}function getFirstThursdayOfYear(year){var dayOfWeekOnFirst=new Date(year,0,1).getDay();return new Date(year,0,(dayOfWeekOnFirst<=4?5:12)-dayOfWeekOnFirst)}function getThursdayThisWeek(datetime){return new Date(datetime.getFullYear(),datetime.getMonth(),datetime.getDate()+(4-datetime.getDay()))}function weekGetter(size){return function(date){var firstThurs=getFirstThursdayOfYear(date.getFullYear()),thisThurs=getThursdayThisWeek(date),diff=+thisThurs-+firstThurs,result=1+Math.round(diff/6048e5);return padNumber(result,size)}}function ampmGetter(date,formats){return date.getHours()<12?formats.AMPMS[0]:formats.AMPMS[1]}function eraGetter(date,formats){return date.getFullYear()<=0?formats.ERAS[0]:formats.ERAS[1]}function longEraGetter(date,formats){return date.getFullYear()<=0?formats.ERANAMES[0]:formats.ERANAMES[1]}function dateFilter($locale){function jsonStringToDate(string){var match;if(match=string.match(R_ISO8601_STR)){var date=new Date(0),tzHour=0,tzMin=0,dateSetter=match[8]?date.setUTCFullYear:date.setFullYear,timeSetter=match[8]?date.setUTCHours:date.setHours;match[9]&&(tzHour=int(match[9]+match[10]),tzMin=int(match[9]+match[11])),dateSetter.call(date,int(match[1]),int(match[2])-1,int(match[3]));var h=int(match[4]||0)-tzHour,m=int(match[5]||0)-tzMin,s=int(match[6]||0),ms=Math.round(1e3*parseFloat("0."+(match[7]||0)));return timeSetter.call(date,h,m,s,ms),date}return string}var R_ISO8601_STR=/^(\d{4})-?(\d\d)-?(\d\d)(?:T(\d\d)(?::?(\d\d)(?::?(\d\d)(?:\.(\d+))?)?)?(Z|([+-])(\d\d):?(\d\d))?)?$/;return function(date,format,timezone){var fn,match,text="",parts=[];if(format=format||"mediumDate",format=$locale.DATETIME_FORMATS[format]||format,isString(date)&&(date=NUMBER_STRING.test(date)?int(date):jsonStringToDate(date)),isNumber(date)&&(date=new Date(date)),!isDate(date))return date;for(;format;)match=DATE_FORMATS_SPLIT.exec(format),match?(parts=concat(parts,match,1),format=parts.pop()):(parts.push(format),format=null);return timezone&&"UTC"===timezone&&(date=new Date(date.getTime()),date.setMinutes(date.getMinutes()+date.getTimezoneOffset())),forEach(parts,function(value){fn=DATE_FORMATS[value],text+=fn?fn(date,$locale.DATETIME_FORMATS):value.replace(/(^'|'$)/g,"").replace(/''/g,"'")}),text}}function jsonFilter(){return function(object,spacing){return isUndefined(spacing)&&(spacing=2),toJson(object,spacing)}}function limitToFilter(){return function(input,limit){return isNumber(input)&&(input=input.toString()),isArray(input)||isString(input)?(limit=Math.abs(Number(limit))===1/0?Number(limit):int(limit),limit?limit>0?input.slice(0,limit):input.slice(limit):isString(input)?"":[]):input}}function orderByFilter($parse){return function(array,sortPredicate,reverseOrder){function comparator(o1,o2){for(var i=0;i<sortPredicate.length;i++){var comp=sortPredicate[i](o1,o2);if(0!==comp)return comp}return 0}function reverseComparator(comp,descending){return descending?function(a,b){return comp(b,a)}:comp}function isPrimitive(value){switch(typeof value){case"number":case"boolean":case"string":return!0;default:return!1}}function objectToString(value){return null===value?"null":"function"==typeof value.valueOf&&(value=value.valueOf(),isPrimitive(value))?value:"function"==typeof value.toString&&(value=value.toString(),isPrimitive(value))?value:""}function compare(v1,v2){var t1=typeof v1,t2=typeof v2;return t1===t2&&"object"===t1&&(v1=objectToString(v1),v2=objectToString(v2)),t1===t2?("string"===t1&&(v1=v1.toLowerCase(),v2=v2.toLowerCase()),v1===v2?0:v1<v2?-1:1):t1<t2?-1:1}return isArrayLike(array)?(sortPredicate=isArray(sortPredicate)?sortPredicate:[sortPredicate],0===sortPredicate.length&&(sortPredicate=["+"]),sortPredicate=sortPredicate.map(function(predicate){var descending=!1,get=predicate||identity;if(isString(predicate)){if("+"!=predicate.charAt(0)&&"-"!=predicate.charAt(0)||(descending="-"==predicate.charAt(0),predicate=predicate.substring(1)),""===predicate)return reverseComparator(compare,descending);if(get=$parse(predicate),get.constant){var key=get();return reverseComparator(function(a,b){return compare(a[key],b[key])},descending)}}return reverseComparator(function(a,b){return compare(get(a),get(b))},descending)}),slice.call(array).sort(reverseComparator(comparator,reverseOrder))):array}}function ngDirective(directive){return isFunction(directive)&&(directive={link:directive}),directive.restrict=directive.restrict||"AC",valueFn(directive)}function nullFormRenameControl(control,name){control.$name=name}function FormController(element,attrs,$scope,$animate,$interpolate){var form=this,controls=[],parentForm=form.$$parentForm=element.parent().controller("form")||nullFormCtrl;form.$error={},form.$$success={},form.$pending=undefined,form.$name=$interpolate(attrs.name||attrs.ngForm||"")($scope),form.$dirty=!1,form.$pristine=!0,form.$valid=!0,form.$invalid=!1,form.$submitted=!1,parentForm.$addControl(form),form.$rollbackViewValue=function(){forEach(controls,function(control){control.$rollbackViewValue()})},form.$commitViewValue=function(){forEach(controls,function(control){control.$commitViewValue()})},form.$addControl=function(control){assertNotHasOwnProperty(control.$name,"input"),controls.push(control),control.$name&&(form[control.$name]=control)},form.$$renameControl=function(control,newName){var oldName=control.$name;form[oldName]===control&&delete form[oldName],form[newName]=control,control.$name=newName},form.$removeControl=function(control){control.$name&&form[control.$name]===control&&delete form[control.$name],forEach(form.$pending,function(value,name){form.$setValidity(name,null,control)}),forEach(form.$error,function(value,name){form.$setValidity(name,null,control)}),forEach(form.$$success,function(value,name){form.$setValidity(name,null,control)}),arrayRemove(controls,control)},addSetValidityMethod({ctrl:this,$element:element,set:function(object,property,controller){var list=object[property];if(list){var index=list.indexOf(controller);index===-1&&list.push(controller)}else object[property]=[controller]},unset:function(object,property,controller){var list=object[property];list&&(arrayRemove(list,controller),0===list.length&&delete object[property])},parentForm:parentForm,$animate:$animate}),form.$setDirty=function(){$animate.removeClass(element,PRISTINE_CLASS),$animate.addClass(element,DIRTY_CLASS),form.$dirty=!0,form.$pristine=!1,parentForm.$setDirty()},form.$setPristine=function(){$animate.setClass(element,PRISTINE_CLASS,DIRTY_CLASS+" "+SUBMITTED_CLASS),form.$dirty=!1,form.$pristine=!0,form.$submitted=!1,forEach(controls,function(control){control.$setPristine()})},form.$setUntouched=function(){forEach(controls,function(control){control.$setUntouched()})},form.$setSubmitted=function(){$animate.addClass(element,SUBMITTED_CLASS),form.$submitted=!0,parentForm.$setSubmitted()}}function stringBasedInputType(ctrl){ctrl.$formatters.push(function(value){return ctrl.$isEmpty(value)?value:value.toString()})}function textInputType(scope,element,attr,ctrl,$sniffer,$browser){baseInputType(scope,element,attr,ctrl,$sniffer,$browser),stringBasedInputType(ctrl)}function baseInputType(scope,element,attr,ctrl,$sniffer,$browser){var type=lowercase(element[0].type);if(!$sniffer.android){var composing=!1;element.on("compositionstart",function(data){composing=!0}),element.on("compositionend",function(){composing=!1,listener()})}var listener=function(ev){if(timeout&&($browser.defer.cancel(timeout),timeout=null),!composing){var value=element.val(),event=ev&&ev.type;"password"===type||attr.ngTrim&&"false"===attr.ngTrim||(value=trim(value)),(ctrl.$viewValue!==value||""===value&&ctrl.$$hasNativeValidators)&&ctrl.$setViewValue(value,event)}};if($sniffer.hasEvent("input"))element.on("input",listener);else{var timeout,deferListener=function(ev,input,origValue){timeout||(timeout=$browser.defer(function(){timeout=null,input&&input.value===origValue||listener(ev)}))};element.on("keydown",function(event){var key=event.keyCode;91===key||15<key&&key<19||37<=key&&key<=40||deferListener(event,this,this.value)}),$sniffer.hasEvent("paste")&&element.on("paste cut",deferListener)}element.on("change",listener),ctrl.$render=function(){element.val(ctrl.$isEmpty(ctrl.$viewValue)?"":ctrl.$viewValue)}}function weekParser(isoWeek,existingDate){if(isDate(isoWeek))return isoWeek;if(isString(isoWeek)){WEEK_REGEXP.lastIndex=0;var parts=WEEK_REGEXP.exec(isoWeek);if(parts){var year=+parts[1],week=+parts[2],hours=0,minutes=0,seconds=0,milliseconds=0,firstThurs=getFirstThursdayOfYear(year),addDays=7*(week-1);return existingDate&&(hours=existingDate.getHours(),minutes=existingDate.getMinutes(),seconds=existingDate.getSeconds(),milliseconds=existingDate.getMilliseconds()),new Date(year,0,firstThurs.getDate()+addDays,hours,minutes,seconds,milliseconds)}}return NaN}function createDateParser(regexp,mapping){return function(iso,date){var parts,map;if(isDate(iso))return iso;if(isString(iso)){if('"'==iso.charAt(0)&&'"'==iso.charAt(iso.length-1)&&(iso=iso.substring(1,iso.length-1)),ISO_DATE_REGEXP.test(iso))return new Date(iso);if(regexp.lastIndex=0,parts=regexp.exec(iso))return parts.shift(),map=date?{yyyy:date.getFullYear(),MM:date.getMonth()+1,dd:date.getDate(),HH:date.getHours(),mm:date.getMinutes(),ss:date.getSeconds(),sss:date.getMilliseconds()/1e3}:{yyyy:1970,MM:1,dd:1,HH:0,mm:0,ss:0,sss:0},forEach(parts,function(part,index){index<mapping.length&&(map[mapping[index]]=+part)}),new Date(map.yyyy,map.MM-1,map.dd,map.HH,map.mm,map.ss||0,1e3*map.sss||0)}return NaN}}function createDateInputType(type,regexp,parseDate,format){return function(scope,element,attr,ctrl,$sniffer,$browser,$filter){function isValidDate(value){return value&&!(value.getTime&&value.getTime()!==value.getTime())}function parseObservedDateValue(val){return isDefined(val)?isDate(val)?val:parseDate(val):undefined}badInputChecker(scope,element,attr,ctrl),baseInputType(scope,element,attr,ctrl,$sniffer,$browser);var previousDate,timezone=ctrl&&ctrl.$options&&ctrl.$options.timezone;if(ctrl.$$parserName=type,ctrl.$parsers.push(function(value){if(ctrl.$isEmpty(value))return null;if(regexp.test(value)){var parsedDate=parseDate(value,previousDate);return"UTC"===timezone&&parsedDate.setMinutes(parsedDate.getMinutes()-parsedDate.getTimezoneOffset()),parsedDate}return undefined}),ctrl.$formatters.push(function(value){if(value&&!isDate(value))throw ngModelMinErr("datefmt","Expected `{0}` to be a date",value);if(isValidDate(value)){if(previousDate=value,previousDate&&"UTC"===timezone){var timezoneOffset=6e4*previousDate.getTimezoneOffset();
previousDate=new Date(previousDate.getTime()+timezoneOffset)}return $filter("date")(value,format,timezone)}return previousDate=null,""}),isDefined(attr.min)||attr.ngMin){var minVal;ctrl.$validators.min=function(value){return!isValidDate(value)||isUndefined(minVal)||parseDate(value)>=minVal},attr.$observe("min",function(val){minVal=parseObservedDateValue(val),ctrl.$validate()})}if(isDefined(attr.max)||attr.ngMax){var maxVal;ctrl.$validators.max=function(value){return!isValidDate(value)||isUndefined(maxVal)||parseDate(value)<=maxVal},attr.$observe("max",function(val){maxVal=parseObservedDateValue(val),ctrl.$validate()})}}}function badInputChecker(scope,element,attr,ctrl){var node=element[0],nativeValidation=ctrl.$$hasNativeValidators=isObject(node.validity);nativeValidation&&ctrl.$parsers.push(function(value){var validity=element.prop(VALIDITY_STATE_PROPERTY)||{};return validity.badInput&&!validity.typeMismatch?undefined:value})}function numberInputType(scope,element,attr,ctrl,$sniffer,$browser){if(badInputChecker(scope,element,attr,ctrl),baseInputType(scope,element,attr,ctrl,$sniffer,$browser),ctrl.$$parserName="number",ctrl.$parsers.push(function(value){return ctrl.$isEmpty(value)?null:NUMBER_REGEXP.test(value)?parseFloat(value):undefined}),ctrl.$formatters.push(function(value){if(!ctrl.$isEmpty(value)){if(!isNumber(value))throw ngModelMinErr("numfmt","Expected `{0}` to be a number",value);value=value.toString()}return value}),isDefined(attr.min)||attr.ngMin){var minVal;ctrl.$validators.min=function(value){return ctrl.$isEmpty(value)||isUndefined(minVal)||value>=minVal},attr.$observe("min",function(val){isDefined(val)&&!isNumber(val)&&(val=parseFloat(val,10)),minVal=isNumber(val)&&!isNaN(val)?val:undefined,ctrl.$validate()})}if(isDefined(attr.max)||attr.ngMax){var maxVal;ctrl.$validators.max=function(value){return ctrl.$isEmpty(value)||isUndefined(maxVal)||value<=maxVal},attr.$observe("max",function(val){isDefined(val)&&!isNumber(val)&&(val=parseFloat(val,10)),maxVal=isNumber(val)&&!isNaN(val)?val:undefined,ctrl.$validate()})}}function urlInputType(scope,element,attr,ctrl,$sniffer,$browser){baseInputType(scope,element,attr,ctrl,$sniffer,$browser),stringBasedInputType(ctrl),ctrl.$$parserName="url",ctrl.$validators.url=function(modelValue,viewValue){var value=modelValue||viewValue;return ctrl.$isEmpty(value)||URL_REGEXP.test(value)}}function emailInputType(scope,element,attr,ctrl,$sniffer,$browser){baseInputType(scope,element,attr,ctrl,$sniffer,$browser),stringBasedInputType(ctrl),ctrl.$$parserName="email",ctrl.$validators.email=function(modelValue,viewValue){var value=modelValue||viewValue;return ctrl.$isEmpty(value)||EMAIL_REGEXP.test(value)}}function radioInputType(scope,element,attr,ctrl){isUndefined(attr.name)&&element.attr("name",nextUid());var listener=function(ev){element[0].checked&&ctrl.$setViewValue(attr.value,ev&&ev.type)};element.on("click",listener),ctrl.$render=function(){var value=attr.value;element[0].checked=value==ctrl.$viewValue},attr.$observe("value",ctrl.$render)}function parseConstantExpr($parse,context,name,expression,fallback){var parseFn;if(isDefined(expression)){if(parseFn=$parse(expression),!parseFn.constant)throw ngModelMinErr("constexpr","Expected constant expression for `{0}`, but saw `{1}`.",name,expression);return parseFn(context)}return fallback}function checkboxInputType(scope,element,attr,ctrl,$sniffer,$browser,$filter,$parse){var trueValue=parseConstantExpr($parse,scope,"ngTrueValue",attr.ngTrueValue,!0),falseValue=parseConstantExpr($parse,scope,"ngFalseValue",attr.ngFalseValue,!1),listener=function(ev){ctrl.$setViewValue(element[0].checked,ev&&ev.type)};element.on("click",listener),ctrl.$render=function(){element[0].checked=ctrl.$viewValue},ctrl.$isEmpty=function(value){return value===!1},ctrl.$formatters.push(function(value){return equals(value,trueValue)}),ctrl.$parsers.push(function(value){return value?trueValue:falseValue})}function classDirective(name,selector){return name="ngClass"+name,["$animate",function($animate){function arrayDifference(tokens1,tokens2){var values=[];outer:for(var i=0;i<tokens1.length;i++){for(var token=tokens1[i],j=0;j<tokens2.length;j++)if(token==tokens2[j])continue outer;values.push(token)}return values}function arrayClasses(classVal){if(isArray(classVal))return classVal;if(isString(classVal))return classVal.split(" ");if(isObject(classVal)){var classes=[];return forEach(classVal,function(v,k){v&&(classes=classes.concat(k.split(" ")))}),classes}return classVal}return{restrict:"AC",link:function(scope,element,attr){function addClasses(classes){var newClasses=digestClassCounts(classes,1);attr.$addClass(newClasses)}function removeClasses(classes){var newClasses=digestClassCounts(classes,-1);attr.$removeClass(newClasses)}function digestClassCounts(classes,count){var classCounts=element.data("$classCounts")||{},classesToUpdate=[];return forEach(classes,function(className){(count>0||classCounts[className])&&(classCounts[className]=(classCounts[className]||0)+count,classCounts[className]===+(count>0)&&classesToUpdate.push(className))}),element.data("$classCounts",classCounts),classesToUpdate.join(" ")}function updateClasses(oldClasses,newClasses){var toAdd=arrayDifference(newClasses,oldClasses),toRemove=arrayDifference(oldClasses,newClasses);toAdd=digestClassCounts(toAdd,1),toRemove=digestClassCounts(toRemove,-1),toAdd&&toAdd.length&&$animate.addClass(element,toAdd),toRemove&&toRemove.length&&$animate.removeClass(element,toRemove)}function ngClassWatchAction(newVal){if(selector===!0||scope.$index%2===selector){var newClasses=arrayClasses(newVal||[]);if(oldVal){if(!equals(newVal,oldVal)){var oldClasses=arrayClasses(oldVal);updateClasses(oldClasses,newClasses)}}else addClasses(newClasses)}oldVal=shallowCopy(newVal)}var oldVal;scope.$watch(attr[name],ngClassWatchAction,!0),attr.$observe("class",function(value){ngClassWatchAction(scope.$eval(attr[name]))}),"ngClass"!==name&&scope.$watch("$index",function($index,old$index){var mod=1&$index;if(mod!==(1&old$index)){var classes=arrayClasses(scope.$eval(attr[name]));mod===selector?addClasses(classes):removeClasses(classes)}})}}}]}function addSetValidityMethod(context){function setValidity(validationErrorKey,state,controller){state===undefined?createAndSet("$pending",validationErrorKey,controller):unsetAndCleanup("$pending",validationErrorKey,controller),isBoolean(state)?state?(unset(ctrl.$error,validationErrorKey,controller),set(ctrl.$$success,validationErrorKey,controller)):(set(ctrl.$error,validationErrorKey,controller),unset(ctrl.$$success,validationErrorKey,controller)):(unset(ctrl.$error,validationErrorKey,controller),unset(ctrl.$$success,validationErrorKey,controller)),ctrl.$pending?(cachedToggleClass(PENDING_CLASS,!0),ctrl.$valid=ctrl.$invalid=undefined,toggleValidationCss("",null)):(cachedToggleClass(PENDING_CLASS,!1),ctrl.$valid=isObjectEmpty(ctrl.$error),ctrl.$invalid=!ctrl.$valid,toggleValidationCss("",ctrl.$valid));var combinedState;combinedState=ctrl.$pending&&ctrl.$pending[validationErrorKey]?undefined:!ctrl.$error[validationErrorKey]&&(!!ctrl.$$success[validationErrorKey]||null),toggleValidationCss(validationErrorKey,combinedState),parentForm.$setValidity(validationErrorKey,combinedState,ctrl)}function createAndSet(name,value,controller){ctrl[name]||(ctrl[name]={}),set(ctrl[name],value,controller)}function unsetAndCleanup(name,value,controller){ctrl[name]&&unset(ctrl[name],value,controller),isObjectEmpty(ctrl[name])&&(ctrl[name]=undefined)}function cachedToggleClass(className,switchValue){switchValue&&!classCache[className]?($animate.addClass($element,className),classCache[className]=!0):!switchValue&&classCache[className]&&($animate.removeClass($element,className),classCache[className]=!1)}function toggleValidationCss(validationErrorKey,isValid){validationErrorKey=validationErrorKey?"-"+snake_case(validationErrorKey,"-"):"",cachedToggleClass(VALID_CLASS+validationErrorKey,isValid===!0),cachedToggleClass(INVALID_CLASS+validationErrorKey,isValid===!1)}var ctrl=context.ctrl,$element=context.$element,classCache={},set=context.set,unset=context.unset,parentForm=context.parentForm,$animate=context.$animate;classCache[INVALID_CLASS]=!(classCache[VALID_CLASS]=$element.hasClass(VALID_CLASS)),ctrl.$setValidity=setValidity}function isObjectEmpty(obj){if(obj)for(var prop in obj)return!1;return!0}var REGEX_STRING_REGEXP=/^\/(.+)\/([a-z]*)$/,VALIDITY_STATE_PROPERTY="validity",lowercase=function(string){return isString(string)?string.toLowerCase():string},hasOwnProperty=Object.prototype.hasOwnProperty,uppercase=function(string){return isString(string)?string.toUpperCase():string},manualLowercase=function(s){return isString(s)?s.replace(/[A-Z]/g,function(ch){return String.fromCharCode(32|ch.charCodeAt(0))}):s},manualUppercase=function(s){return isString(s)?s.replace(/[a-z]/g,function(ch){return String.fromCharCode(ch.charCodeAt(0)&-33)}):s};"i"!=="I".toLowerCase()&&(lowercase=manualLowercase,uppercase=manualUppercase);var msie,jqLite,jQuery,angularModule,slice=[].slice,splice=[].splice,push=[].push,toString=Object.prototype.toString,ngMinErr=minErr("ng"),angular=window.angular||(window.angular={}),uid=0;msie=document.documentMode,noop.$inject=[],identity.$inject=[];var skipDestroyOnNextJQueryCleanData,isArray=Array.isArray,trim=function(value){return isString(value)?value.trim():value},escapeForRegexp=function(s){return s.replace(/([-()\[\]{}+?*.$\^|,:#<!\\])/g,"\\$1").replace(/\x08/g,"\\x08")},csp=function(){if(isDefined(csp.isActive_))return csp.isActive_;var active=!(!document.querySelector("[ng-csp]")&&!document.querySelector("[data-ng-csp]"));if(!active)try{new Function("")}catch(e){active=!0}return csp.isActive_=active},ngAttrPrefixes=["ng-","data-ng-","ng:","x-ng-"],SNAKE_CASE_REGEXP=/[A-Z]/g,bindJQueryFired=!1,NODE_TYPE_ELEMENT=1,NODE_TYPE_ATTRIBUTE=2,NODE_TYPE_TEXT=3,NODE_TYPE_COMMENT=8,NODE_TYPE_DOCUMENT=9,NODE_TYPE_DOCUMENT_FRAGMENT=11,version={full:"1.3.20",major:1,minor:3,dot:20,codeName:"shallow-translucence"};JQLite.expando="ng339";var jqCache=JQLite.cache={},jqId=1,addEventListenerFn=function(element,type,fn){element.addEventListener(type,fn,!1)},removeEventListenerFn=function(element,type,fn){element.removeEventListener(type,fn,!1)};JQLite._data=function(node){return this.cache[node[this.expando]]||{}};var SPECIAL_CHARS_REGEXP=/([\:\-\_]+(.))/g,MOZ_HACK_REGEXP=/^moz([A-Z])/,MOUSE_EVENT_MAP={mouseleave:"mouseout",mouseenter:"mouseover"},jqLiteMinErr=minErr("jqLite"),SINGLE_TAG_REGEXP=/^<(\w+)\s*\/?>(?:<\/\1>|)$/,HTML_REGEXP=/<|&#?\w+;/,TAG_NAME_REGEXP=/<([\w:]+)/,XHTML_TAG_REGEXP=/<(?!area|br|col|embed|hr|img|input|link|meta|param)(([\w:]+)[^>]*)\/>/gi,wrapMap={option:[1,'<select multiple="multiple">',"</select>"],thead:[1,"<table>","</table>"],col:[2,"<table><colgroup>","</colgroup></table>"],tr:[2,"<table><tbody>","</tbody></table>"],td:[3,"<table><tbody><tr>","</tr></tbody></table>"],_default:[0,"",""]};wrapMap.optgroup=wrapMap.option,wrapMap.tbody=wrapMap.tfoot=wrapMap.colgroup=wrapMap.caption=wrapMap.thead,wrapMap.th=wrapMap.td;var JQLitePrototype=JQLite.prototype={ready:function(fn){function trigger(){fired||(fired=!0,fn())}var fired=!1;"complete"===document.readyState?setTimeout(trigger):(this.on("DOMContentLoaded",trigger),JQLite(window).on("load",trigger))},toString:function(){var value=[];return forEach(this,function(e){value.push(""+e)}),"["+value.join(", ")+"]"},eq:function(index){return jqLite(index>=0?this[index]:this[this.length+index])},length:0,push:push,sort:[].sort,splice:[].splice},BOOLEAN_ATTR={};forEach("multiple,selected,checked,disabled,readOnly,required,open".split(","),function(value){BOOLEAN_ATTR[lowercase(value)]=value});var BOOLEAN_ELEMENTS={};forEach("input,select,option,textarea,button,form,details".split(","),function(value){BOOLEAN_ELEMENTS[value]=!0});var ALIASED_ATTR={ngMinlength:"minlength",ngMaxlength:"maxlength",ngMin:"min",ngMax:"max",ngPattern:"pattern"};forEach({data:jqLiteData,removeData:jqLiteRemoveData},function(fn,name){JQLite[name]=fn}),forEach({data:jqLiteData,inheritedData:jqLiteInheritedData,scope:function(element){return jqLite.data(element,"$scope")||jqLiteInheritedData(element.parentNode||element,["$isolateScope","$scope"])},isolateScope:function(element){return jqLite.data(element,"$isolateScope")||jqLite.data(element,"$isolateScopeNoTemplate")},controller:jqLiteController,injector:function(element){return jqLiteInheritedData(element,"$injector")},removeAttr:function(element,name){element.removeAttribute(name)},hasClass:jqLiteHasClass,css:function(element,name,value){return name=camelCase(name),isDefined(value)?void(element.style[name]=value):element.style[name]},attr:function(element,name,value){var nodeType=element.nodeType;if(nodeType!==NODE_TYPE_TEXT&&nodeType!==NODE_TYPE_ATTRIBUTE&&nodeType!==NODE_TYPE_COMMENT){var lowercasedName=lowercase(name);if(BOOLEAN_ATTR[lowercasedName]){if(!isDefined(value))return element[name]||(element.attributes.getNamedItem(name)||noop).specified?lowercasedName:undefined;value?(element[name]=!0,element.setAttribute(name,lowercasedName)):(element[name]=!1,element.removeAttribute(lowercasedName))}else if(isDefined(value))element.setAttribute(name,value);else if(element.getAttribute){var ret=element.getAttribute(name,2);return null===ret?undefined:ret}}},prop:function(element,name,value){return isDefined(value)?void(element[name]=value):element[name]},text:function(){function getText(element,value){if(isUndefined(value)){var nodeType=element.nodeType;return nodeType===NODE_TYPE_ELEMENT||nodeType===NODE_TYPE_TEXT?element.textContent:""}element.textContent=value}return getText.$dv="",getText}(),val:function(element,value){if(isUndefined(value)){if(element.multiple&&"select"===nodeName_(element)){var result=[];return forEach(element.options,function(option){option.selected&&result.push(option.value||option.text)}),0===result.length?null:result}return element.value}element.value=value},html:function(element,value){return isUndefined(value)?element.innerHTML:(jqLiteDealoc(element,!0),void(element.innerHTML=value))},empty:jqLiteEmpty},function(fn,name){JQLite.prototype[name]=function(arg1,arg2){var i,key,nodeCount=this.length;if(fn!==jqLiteEmpty&&(2==fn.length&&fn!==jqLiteHasClass&&fn!==jqLiteController?arg1:arg2)===undefined){if(isObject(arg1)){for(i=0;i<nodeCount;i++)if(fn===jqLiteData)fn(this[i],arg1);else for(key in arg1)fn(this[i],key,arg1[key]);return this}for(var value=fn.$dv,jj=value===undefined?Math.min(nodeCount,1):nodeCount,j=0;j<jj;j++){var nodeValue=fn(this[j],arg1,arg2);value=value?value+nodeValue:nodeValue}return value}for(i=0;i<nodeCount;i++)fn(this[i],arg1,arg2);return this}}),forEach({removeData:jqLiteRemoveData,on:function jqLiteOn(element,type,fn,unsupported){if(isDefined(unsupported))throw jqLiteMinErr("onargs","jqLite#on() does not support the `selector` or `eventData` parameters");if(jqLiteAcceptsData(element)){var expandoStore=jqLiteExpandoStore(element,!0),events=expandoStore.events,handle=expandoStore.handle;handle||(handle=expandoStore.handle=createEventHandler(element,events));for(var types=type.indexOf(" ")>=0?type.split(" "):[type],i=types.length;i--;){type=types[i];var eventFns=events[type];eventFns||(events[type]=[],"mouseenter"===type||"mouseleave"===type?jqLiteOn(element,MOUSE_EVENT_MAP[type],function(event){var target=this,related=event.relatedTarget;related&&(related===target||target.contains(related))||handle(event,type)}):"$destroy"!==type&&addEventListenerFn(element,type,handle),eventFns=events[type]),eventFns.push(fn)}}},off:jqLiteOff,one:function(element,type,fn){element=jqLite(element),element.on(type,function onFn(){element.off(type,fn),element.off(type,onFn)}),element.on(type,fn)},replaceWith:function(element,replaceNode){var index,parent=element.parentNode;jqLiteDealoc(element),forEach(new JQLite(replaceNode),function(node){index?parent.insertBefore(node,index.nextSibling):parent.replaceChild(node,element),index=node})},children:function(element){var children=[];return forEach(element.childNodes,function(element){element.nodeType===NODE_TYPE_ELEMENT&&children.push(element)}),children},contents:function(element){return element.contentDocument||element.childNodes||[]},append:function(element,node){var nodeType=element.nodeType;if(nodeType===NODE_TYPE_ELEMENT||nodeType===NODE_TYPE_DOCUMENT_FRAGMENT){node=new JQLite(node);for(var i=0,ii=node.length;i<ii;i++){var child=node[i];element.appendChild(child)}}},prepend:function(element,node){if(element.nodeType===NODE_TYPE_ELEMENT){var index=element.firstChild;forEach(new JQLite(node),function(child){element.insertBefore(child,index)})}},wrap:function(element,wrapNode){wrapNode=jqLite(wrapNode).eq(0).clone()[0];var parent=element.parentNode;parent&&parent.replaceChild(wrapNode,element),wrapNode.appendChild(element)},remove:jqLiteRemove,detach:function(element){jqLiteRemove(element,!0)},after:function(element,newElement){var index=element,parent=element.parentNode;newElement=new JQLite(newElement);for(var i=0,ii=newElement.length;i<ii;i++){var node=newElement[i];parent.insertBefore(node,index.nextSibling),index=node}},addClass:jqLiteAddClass,removeClass:jqLiteRemoveClass,toggleClass:function(element,selector,condition){selector&&forEach(selector.split(" "),function(className){var classCondition=condition;isUndefined(classCondition)&&(classCondition=!jqLiteHasClass(element,className)),(classCondition?jqLiteAddClass:jqLiteRemoveClass)(element,className)})},parent:function(element){var parent=element.parentNode;return parent&&parent.nodeType!==NODE_TYPE_DOCUMENT_FRAGMENT?parent:null},next:function(element){return element.nextElementSibling},find:function(element,selector){return element.getElementsByTagName?element.getElementsByTagName(selector):[]},clone:jqLiteClone,triggerHandler:function(element,event,extraParameters){var dummyEvent,eventFnsCopy,handlerArgs,eventName=event.type||event,expandoStore=jqLiteExpandoStore(element),events=expandoStore&&expandoStore.events,eventFns=events&&events[eventName];eventFns&&(dummyEvent={preventDefault:function(){this.defaultPrevented=!0},isDefaultPrevented:function(){return this.defaultPrevented===!0},stopImmediatePropagation:function(){this.immediatePropagationStopped=!0},isImmediatePropagationStopped:function(){return this.immediatePropagationStopped===!0},stopPropagation:noop,type:eventName,target:element},event.type&&(dummyEvent=extend(dummyEvent,event)),eventFnsCopy=shallowCopy(eventFns),handlerArgs=extraParameters?[dummyEvent].concat(extraParameters):[dummyEvent],forEach(eventFnsCopy,function(fn){dummyEvent.isImmediatePropagationStopped()||fn.apply(element,handlerArgs)}))}},function(fn,name){JQLite.prototype[name]=function(arg1,arg2,arg3){for(var value,i=0,ii=this.length;i<ii;i++)isUndefined(value)?(value=fn(this[i],arg1,arg2,arg3),isDefined(value)&&(value=jqLite(value))):jqLiteAddNodes(value,fn(this[i],arg1,arg2,arg3));return isDefined(value)?value:this},JQLite.prototype.bind=JQLite.prototype.on,JQLite.prototype.unbind=JQLite.prototype.off}),HashMap.prototype={put:function(key,value){this[hashKey(key,this.nextUid)]=value},get:function(key){return this[hashKey(key,this.nextUid)]},remove:function(key){var value=this[key=hashKey(key,this.nextUid)];return delete this[key],value}};var FN_ARGS=/^function\s*[^\(]*\(\s*([^\)]*)\)/m,FN_ARG_SPLIT=/,/,FN_ARG=/^\s*(_?)(\S+?)\1\s*$/,STRIP_COMMENTS=/((\/\/.*$)|(\/\*[\s\S]*?\*\/))/gm,$injectorMinErr=minErr("$injector");createInjector.$$annotate=annotate;var $animateMinErr=minErr("$animate"),$AnimateProvider=["$provide",function($provide){this.$$selectors={},this.register=function(name,factory){var key=name+"-animation";if(name&&"."!=name.charAt(0))throw $animateMinErr("notcsel","Expecting class selector starting with '.' got '{0}'.",name);this.$$selectors[name.substr(1)]=key,$provide.factory(key,factory)},this.classNameFilter=function(expression){return 1===arguments.length&&(this.$$classNameFilter=expression instanceof RegExp?expression:null),this.$$classNameFilter},this.$get=["$$q","$$asyncCallback","$rootScope",function($$q,$$asyncCallback,$rootScope){function runAnimationPostDigest(fn){var cancelFn,defer=$$q.defer();return defer.promise.$$cancelFn=function(){cancelFn&&cancelFn()},$rootScope.$$postDigest(function(){cancelFn=fn(function(){defer.resolve()})}),defer.promise}function resolveElementClasses(element,classes){var toAdd=[],toRemove=[],hasClasses=createMap();return forEach((element.attr("class")||"").split(/\s+/),function(className){hasClasses[className]=!0}),forEach(classes,function(status,className){var hasClass=hasClasses[className];status===!1&&hasClass?toRemove.push(className):status!==!0||hasClass||toAdd.push(className)}),toAdd.length+toRemove.length>0&&[toAdd.length?toAdd:null,toRemove.length?toRemove:null]}function cachedClassManipulation(cache,classes,op){for(var i=0,ii=classes.length;i<ii;++i){var className=classes[i];cache[className]=op}}function asyncPromise(){return currentDefer||(currentDefer=$$q.defer(),$$asyncCallback(function(){currentDefer.resolve(),currentDefer=null})),currentDefer.promise}function applyStyles(element,options){if(angular.isObject(options)){var styles=extend(options.from||{},options.to||{});element.css(styles)}}var currentDefer;return{animate:function(element,from,to){return applyStyles(element,{from:from,to:to}),asyncPromise()},enter:function(element,parent,after,options){return applyStyles(element,options),after?after.after(element):parent.prepend(element),asyncPromise()},leave:function(element,options){return applyStyles(element,options),element.remove(),asyncPromise()},move:function(element,parent,after,options){return this.enter(element,parent,after,options)},addClass:function(element,className,options){return this.setClass(element,className,[],options)},$$addClassImmediately:function(element,className,options){return element=jqLite(element),className=isString(className)?className:isArray(className)?className.join(" "):"",forEach(element,function(element){jqLiteAddClass(element,className)}),applyStyles(element,options),asyncPromise()},removeClass:function(element,className,options){return this.setClass(element,[],className,options)},$$removeClassImmediately:function(element,className,options){return element=jqLite(element),className=isString(className)?className:isArray(className)?className.join(" "):"",forEach(element,function(element){jqLiteRemoveClass(element,className)}),applyStyles(element,options),asyncPromise()},setClass:function(element,add,remove,options){var self=this,STORAGE_KEY="$$animateClasses",createdCache=!1;element=jqLite(element);var cache=element.data(STORAGE_KEY);cache?options&&cache.options&&(cache.options=angular.extend(cache.options||{},options)):(cache={classes:{},options:options},createdCache=!0);var classes=cache.classes;return add=isArray(add)?add:add.split(" "),remove=isArray(remove)?remove:remove.split(" "),cachedClassManipulation(classes,add,!0),cachedClassManipulation(classes,remove,!1),createdCache&&(cache.promise=runAnimationPostDigest(function(done){var cache=element.data(STORAGE_KEY);if(element.removeData(STORAGE_KEY),cache){var classes=resolveElementClasses(element,cache.classes);classes&&self.$$setClassImmediately(element,classes[0],classes[1],cache.options)}done()}),element.data(STORAGE_KEY,cache)),cache.promise},$$setClassImmediately:function(element,add,remove,options){return add&&this.$$addClassImmediately(element,add),remove&&this.$$removeClassImmediately(element,remove),applyStyles(element,options),asyncPromise()},enabled:noop,cancel:noop}}]}],$compileMinErr=minErr("$compile");$CompileProvider.$inject=["$provide","$$sanitizeUriProvider"];var PREFIX_REGEXP=/^((?:x|data)[\:\-_])/i,$controllerMinErr=minErr("$controller"),APPLICATION_JSON="application/json",CONTENT_TYPE_APPLICATION_JSON={"Content-Type":APPLICATION_JSON+";charset=utf-8"},JSON_START=/^\[|^\{(?!\{)/,JSON_ENDS={"[":/]$/,"{":/}$/},JSON_PROTECTION_PREFIX=/^\)\]\}',?\n/,$interpolateMinErr=minErr("$interpolate"),PATH_MATCH=/^([^\?#]*)(\?([^#]*))?(#(.*))?$/,DEFAULT_PORTS={http:80,https:443,ftp:21},$locationMinErr=minErr("$location"),locationPrototype={$$html5:!1,$$replace:!1,absUrl:locationGetter("$$absUrl"),url:function(url){if(isUndefined(url))return this.$$url;var match=PATH_MATCH.exec(url);return(match[1]||""===url)&&this.path(decodeURIComponent(match[1])),(match[2]||match[1]||""===url)&&this.search(match[3]||""),this.hash(match[5]||""),this},protocol:locationGetter("$$protocol"),host:locationGetter("$$host"),port:locationGetter("$$port"),path:locationGetterSetter("$$path",function(path){return path=null!==path?path.toString():"","/"==path.charAt(0)?path:"/"+path}),search:function(search,paramValue){switch(arguments.length){case 0:return this.$$search;case 1:if(isString(search)||isNumber(search))search=search.toString(),this.$$search=parseKeyValue(search);else{if(!isObject(search))throw $locationMinErr("isrcharg","The first argument of the `$location#search()` call must be a string or an object.");search=copy(search,{}),forEach(search,function(value,key){null==value&&delete search[key]}),this.$$search=search}break;default:isUndefined(paramValue)||null===paramValue?delete this.$$search[search]:this.$$search[search]=paramValue}return this.$$compose(),this},hash:locationGetterSetter("$$hash",function(hash){return null!==hash?hash.toString():""}),replace:function(){return this.$$replace=!0,this}};forEach([LocationHashbangInHtml5Url,LocationHashbangUrl,LocationHtml5Url],function(Location){Location.prototype=Object.create(locationPrototype),Location.prototype.state=function(state){if(!arguments.length)return this.$$state;if(Location!==LocationHtml5Url||!this.$$html5)throw $locationMinErr("nostate","History API state support is available only in HTML5 mode and only in browsers supporting HTML5 History API");return this.$$state=isUndefined(state)?null:state,this}});var $parseMinErr=minErr("$parse"),CALL=Function.prototype.call,APPLY=Function.prototype.apply,BIND=Function.prototype.bind,CONSTANTS=createMap();forEach({null:function(){return null},true:function(){return!0},false:function(){return!1},undefined:function(){}},function(constantGetter,name){constantGetter.constant=constantGetter.literal=constantGetter.sharedGetter=!0,CONSTANTS[name]=constantGetter}),CONSTANTS.this=function(self){return self},CONSTANTS.this.sharedGetter=!0;var OPERATORS=extend(createMap(),{"+":function(self,locals,a,b){return a=a(self,locals),b=b(self,locals),isDefined(a)?isDefined(b)?a+b:a:isDefined(b)?b:undefined},"-":function(self,locals,a,b){return a=a(self,locals),b=b(self,locals),(isDefined(a)?a:0)-(isDefined(b)?b:0)},"*":function(self,locals,a,b){return a(self,locals)*b(self,locals)},"/":function(self,locals,a,b){return a(self,locals)/b(self,locals)},"%":function(self,locals,a,b){return a(self,locals)%b(self,locals)},"===":function(self,locals,a,b){return a(self,locals)===b(self,locals)},"!==":function(self,locals,a,b){return a(self,locals)!==b(self,locals)},"==":function(self,locals,a,b){return a(self,locals)==b(self,locals)},"!=":function(self,locals,a,b){return a(self,locals)!=b(self,locals)},"<":function(self,locals,a,b){return a(self,locals)<b(self,locals)},">":function(self,locals,a,b){return a(self,locals)>b(self,locals)},"<=":function(self,locals,a,b){return a(self,locals)<=b(self,locals)},">=":function(self,locals,a,b){return a(self,locals)>=b(self,locals)},"&&":function(self,locals,a,b){return a(self,locals)&&b(self,locals)},"||":function(self,locals,a,b){return a(self,locals)||b(self,locals)},"!":function(self,locals,a){return!a(self,locals)},"=":!0,"|":!0}),ESCAPE={n:"\n",f:"\f",r:"\r",t:"\t",v:"\v","'":"'",'"':'"'},Lexer=function(options){this.options=options};Lexer.prototype={constructor:Lexer,lex:function(text){for(this.text=text,this.index=0,this.tokens=[];this.index<this.text.length;){var ch=this.text.charAt(this.index);if('"'===ch||"'"===ch)this.readString(ch);else if(this.isNumber(ch)||"."===ch&&this.isNumber(this.peek()))this.readNumber();else if(this.isIdent(ch))this.readIdent();else if(this.is(ch,"(){}[].,;:?"))this.tokens.push({index:this.index,text:ch}),this.index++;else if(this.isWhitespace(ch))this.index++;else{var ch2=ch+this.peek(),ch3=ch2+this.peek(2),op1=OPERATORS[ch],op2=OPERATORS[ch2],op3=OPERATORS[ch3];if(op1||op2||op3){var token=op3?ch3:op2?ch2:ch;this.tokens.push({index:this.index,text:token,operator:!0}),this.index+=token.length}else this.throwError("Unexpected next character ",this.index,this.index+1)}}return this.tokens},is:function(ch,chars){return chars.indexOf(ch)!==-1},peek:function(i){var num=i||1;return this.index+num<this.text.length&&this.text.charAt(this.index+num)},isNumber:function(ch){return"0"<=ch&&ch<="9"&&"string"==typeof ch},isWhitespace:function(ch){return" "===ch||"\r"===ch||"\t"===ch||"\n"===ch||"\v"===ch||" "===ch},isIdent:function(ch){return"a"<=ch&&ch<="z"||"A"<=ch&&ch<="Z"||"_"===ch||"$"===ch},isExpOperator:function(ch){return"-"===ch||"+"===ch||this.isNumber(ch)},throwError:function(error,start,end){end=end||this.index;var colStr=isDefined(start)?"s "+start+"-"+this.index+" ["+this.text.substring(start,end)+"]":" "+end;throw $parseMinErr("lexerr","Lexer Error: {0} at column{1} in expression [{2}].",error,colStr,this.text)},readNumber:function(){for(var number="",start=this.index;this.index<this.text.length;){var ch=lowercase(this.text.charAt(this.index));if("."==ch||this.isNumber(ch))number+=ch;else{var peekCh=this.peek();if("e"==ch&&this.isExpOperator(peekCh))number+=ch;else if(this.isExpOperator(ch)&&peekCh&&this.isNumber(peekCh)&&"e"==number.charAt(number.length-1))number+=ch;else{if(!this.isExpOperator(ch)||peekCh&&this.isNumber(peekCh)||"e"!=number.charAt(number.length-1))break;this.throwError("Invalid exponent")}}this.index++}this.tokens.push({index:start,text:number,constant:!0,value:Number(number)})},readIdent:function(){for(var start=this.index;this.index<this.text.length;){var ch=this.text.charAt(this.index);if(!this.isIdent(ch)&&!this.isNumber(ch))break;this.index++}this.tokens.push({index:start,text:this.text.slice(start,this.index),identifier:!0})},readString:function(quote){var start=this.index;this.index++;for(var string="",rawString=quote,escape=!1;this.index<this.text.length;){var ch=this.text.charAt(this.index);if(rawString+=ch,escape){if("u"===ch){var hex=this.text.substring(this.index+1,this.index+5);hex.match(/[\da-f]{4}/i)||this.throwError("Invalid unicode escape [\\u"+hex+"]"),this.index+=4,string+=String.fromCharCode(parseInt(hex,16))}else{var rep=ESCAPE[ch];string+=rep||ch}escape=!1}else if("\\"===ch)escape=!0;else{if(ch===quote)return this.index++,void this.tokens.push({index:start,text:rawString,constant:!0,value:string});string+=ch}this.index++}this.throwError("Unterminated quote",start)}};var Parser=function(lexer,$filter,options){this.lexer=lexer,this.$filter=$filter,this.options=options};Parser.ZERO=extend(function(){return 0},{sharedGetter:!0,constant:!0}),Parser.prototype={constructor:Parser,parse:function(text){this.text=text,this.tokens=this.lexer.lex(text);var value=this.statements();return 0!==this.tokens.length&&this.throwError("is an unexpected token",this.tokens[0]),value.literal=!!value.literal,value.constant=!!value.constant,value},primary:function(){var primary;this.expect("(")?(primary=this.filterChain(),this.consume(")")):this.expect("[")?primary=this.arrayDeclaration():this.expect("{")?primary=this.object():this.peek().identifier&&this.peek().text in CONSTANTS?primary=CONSTANTS[this.consume().text]:this.peek().identifier?primary=this.identifier():this.peek().constant?primary=this.constant():this.throwError("not a primary expression",this.peek());for(var next,context;next=this.expect("(","[",".");)"("===next.text?(primary=this.functionCall(primary,context),context=null):"["===next.text?(context=primary,primary=this.objectIndex(primary)):"."===next.text?(context=primary,primary=this.fieldAccess(primary)):this.throwError("IMPOSSIBLE");return primary},throwError:function(msg,token){throw $parseMinErr("syntax","Syntax Error: Token '{0}' {1} at column {2} of the expression [{3}] starting at [{4}].",token.text,msg,token.index+1,this.text,this.text.substring(token.index));
},peekToken:function(){if(0===this.tokens.length)throw $parseMinErr("ueoe","Unexpected end of expression: {0}",this.text);return this.tokens[0]},peek:function(e1,e2,e3,e4){return this.peekAhead(0,e1,e2,e3,e4)},peekAhead:function(i,e1,e2,e3,e4){if(this.tokens.length>i){var token=this.tokens[i],t=token.text;if(t===e1||t===e2||t===e3||t===e4||!e1&&!e2&&!e3&&!e4)return token}return!1},expect:function(e1,e2,e3,e4){var token=this.peek(e1,e2,e3,e4);return!!token&&(this.tokens.shift(),token)},consume:function(e1){if(0===this.tokens.length)throw $parseMinErr("ueoe","Unexpected end of expression: {0}",this.text);var token=this.expect(e1);return token||this.throwError("is unexpected, expecting ["+e1+"]",this.peek()),token},unaryFn:function(op,right){var fn=OPERATORS[op];return extend(function(self,locals){return fn(self,locals,right)},{constant:right.constant,inputs:[right]})},binaryFn:function(left,op,right,isBranching){var fn=OPERATORS[op];return extend(function(self,locals){return fn(self,locals,left,right)},{constant:left.constant&&right.constant,inputs:!isBranching&&[left,right]})},identifier:function(){for(var id=this.consume().text;this.peek(".")&&this.peekAhead(1).identifier&&!this.peekAhead(2,"(");)id+=this.consume().text+this.consume().text;return getterFn(id,this.options,this.text)},constant:function(){var value=this.consume().value;return extend(function(){return value},{constant:!0,literal:!0})},statements:function(){for(var statements=[];;)if(this.tokens.length>0&&!this.peek("}",")",";","]")&&statements.push(this.filterChain()),!this.expect(";"))return 1===statements.length?statements[0]:function(self,locals){for(var value,i=0,ii=statements.length;i<ii;i++)value=statements[i](self,locals);return value}},filterChain:function(){for(var token,left=this.expression();token=this.expect("|");)left=this.filter(left);return left},filter:function(inputFn){var argsFn,args,fn=this.$filter(this.consume().text);if(this.peek(":"))for(argsFn=[],args=[];this.expect(":");)argsFn.push(this.expression());var inputs=[inputFn].concat(argsFn||[]);return extend(function(self,locals){var input=inputFn(self,locals);if(args){args[0]=input;for(var i=argsFn.length;i--;)args[i+1]=argsFn[i](self,locals);return fn.apply(undefined,args)}return fn(input)},{constant:!fn.$stateful&&inputs.every(isConstant),inputs:!fn.$stateful&&inputs})},expression:function(){return this.assignment()},assignment:function(){var right,token,left=this.ternary();return(token=this.expect("="))?(left.assign||this.throwError("implies assignment but ["+this.text.substring(0,token.index)+"] can not be assigned to",token),right=this.ternary(),extend(function(scope,locals){return left.assign(scope,right(scope,locals),locals)},{inputs:[left,right]})):left},ternary:function(){var middle,token,left=this.logicalOR();if((token=this.expect("?"))&&(middle=this.assignment(),this.consume(":"))){var right=this.assignment();return extend(function(self,locals){return left(self,locals)?middle(self,locals):right(self,locals)},{constant:left.constant&&middle.constant&&right.constant})}return left},logicalOR:function(){for(var token,left=this.logicalAND();token=this.expect("||");)left=this.binaryFn(left,token.text,this.logicalAND(),!0);return left},logicalAND:function(){for(var token,left=this.equality();token=this.expect("&&");)left=this.binaryFn(left,token.text,this.equality(),!0);return left},equality:function(){for(var token,left=this.relational();token=this.expect("==","!=","===","!==");)left=this.binaryFn(left,token.text,this.relational());return left},relational:function(){for(var token,left=this.additive();token=this.expect("<",">","<=",">=");)left=this.binaryFn(left,token.text,this.additive());return left},additive:function(){for(var token,left=this.multiplicative();token=this.expect("+","-");)left=this.binaryFn(left,token.text,this.multiplicative());return left},multiplicative:function(){for(var token,left=this.unary();token=this.expect("*","/","%");)left=this.binaryFn(left,token.text,this.unary());return left},unary:function(){var token;return this.expect("+")?this.primary():(token=this.expect("-"))?this.binaryFn(Parser.ZERO,token.text,this.unary()):(token=this.expect("!"))?this.unaryFn(token.text,this.unary()):this.primary()},fieldAccess:function(object){var getter=this.identifier();return extend(function(scope,locals,self){var o=self||object(scope,locals);return null==o?undefined:getter(o)},{assign:function(scope,value,locals){var o=object(scope,locals);return o||object.assign(scope,o={},locals),getter.assign(o,value)}})},objectIndex:function(obj){var expression=this.text,indexFn=this.expression();return this.consume("]"),extend(function(self,locals){var v,o=obj(self,locals),i=getStringValue(indexFn(self,locals),expression);return ensureSafeMemberName(i,expression),o?v=ensureSafeObject(o[i],expression):undefined},{assign:function(self,value,locals){var key=ensureSafeMemberName(getStringValue(indexFn(self,locals),expression),expression),o=ensureSafeObject(obj(self,locals),expression);return o||obj.assign(self,o={},locals),o[key]=value}})},functionCall:function(fnGetter,contextGetter){var argsFn=[];if(")"!==this.peekToken().text)do argsFn.push(this.expression());while(this.expect(","));this.consume(")");var expressionText=this.text,args=argsFn.length?[]:null;return function(scope,locals){var context=contextGetter?contextGetter(scope,locals):isDefined(contextGetter)?undefined:scope,fn=fnGetter(scope,locals,context)||noop;if(args)for(var i=argsFn.length;i--;)args[i]=ensureSafeObject(argsFn[i](scope,locals),expressionText);ensureSafeObject(context,expressionText),ensureSafeFunction(fn,expressionText);var v=fn.apply?fn.apply(context,args):fn(args[0],args[1],args[2],args[3],args[4]);return args&&(args.length=0),ensureSafeObject(v,expressionText)}},arrayDeclaration:function(){var elementFns=[];if("]"!==this.peekToken().text)do{if(this.peek("]"))break;elementFns.push(this.expression())}while(this.expect(","));return this.consume("]"),extend(function(self,locals){for(var array=[],i=0,ii=elementFns.length;i<ii;i++)array.push(elementFns[i](self,locals));return array},{literal:!0,constant:elementFns.every(isConstant),inputs:elementFns})},object:function(){var keys=[],valueFns=[];if("}"!==this.peekToken().text)do{if(this.peek("}"))break;var token=this.consume();token.constant?keys.push(token.value):token.identifier?keys.push(token.text):this.throwError("invalid key",token),this.consume(":"),valueFns.push(this.expression())}while(this.expect(","));return this.consume("}"),extend(function(self,locals){for(var object={},i=0,ii=valueFns.length;i<ii;i++)object[keys[i]]=valueFns[i](self,locals);return object},{literal:!0,constant:valueFns.every(isConstant),inputs:valueFns})}};var getterFnCacheDefault=createMap(),getterFnCacheExpensive=createMap(),objectValueOf=Object.prototype.valueOf,$sceMinErr=minErr("$sce"),SCE_CONTEXTS={HTML:"html",CSS:"css",URL:"url",RESOURCE_URL:"resourceUrl",JS:"js"},$compileMinErr=minErr("$compile"),urlParsingNode=document.createElement("a"),originUrl=urlResolve(window.location.href);$FilterProvider.$inject=["$provide"],currencyFilter.$inject=["$locale"],numberFilter.$inject=["$locale"];var DECIMAL_SEP=".",DATE_FORMATS={yyyy:dateGetter("FullYear",4),yy:dateGetter("FullYear",2,0,!0),y:dateGetter("FullYear",1),MMMM:dateStrGetter("Month"),MMM:dateStrGetter("Month",!0),MM:dateGetter("Month",2,1),M:dateGetter("Month",1,1),dd:dateGetter("Date",2),d:dateGetter("Date",1),HH:dateGetter("Hours",2),H:dateGetter("Hours",1),hh:dateGetter("Hours",2,-12),h:dateGetter("Hours",1,-12),mm:dateGetter("Minutes",2),m:dateGetter("Minutes",1),ss:dateGetter("Seconds",2),s:dateGetter("Seconds",1),sss:dateGetter("Milliseconds",3),EEEE:dateStrGetter("Day"),EEE:dateStrGetter("Day",!0),a:ampmGetter,Z:timeZoneGetter,ww:weekGetter(2),w:weekGetter(1),G:eraGetter,GG:eraGetter,GGG:eraGetter,GGGG:longEraGetter},DATE_FORMATS_SPLIT=/((?:[^yMdHhmsaZEwG']+)|(?:'(?:[^']|'')*')|(?:E+|y+|M+|d+|H+|h+|m+|s+|a|Z|G+|w+))(.*)/,NUMBER_STRING=/^\-?\d+$/;dateFilter.$inject=["$locale"];var lowercaseFilter=valueFn(lowercase),uppercaseFilter=valueFn(uppercase);orderByFilter.$inject=["$parse"];var htmlAnchorDirective=valueFn({restrict:"E",compile:function(element,attr){if(!attr.href&&!attr.xlinkHref&&!attr.name)return function(scope,element){if("a"===element[0].nodeName.toLowerCase()){var href="[object SVGAnimatedString]"===toString.call(element.prop("href"))?"xlink:href":"href";element.on("click",function(event){element.attr(href)||event.preventDefault()})}}}}),ngAttributeAliasDirectives={};forEach(BOOLEAN_ATTR,function(propName,attrName){if("multiple"!=propName){var normalized=directiveNormalize("ng-"+attrName);ngAttributeAliasDirectives[normalized]=function(){return{restrict:"A",priority:100,link:function(scope,element,attr){scope.$watch(attr[normalized],function(value){attr.$set(attrName,!!value)})}}}}}),forEach(ALIASED_ATTR,function(htmlAttr,ngAttr){ngAttributeAliasDirectives[ngAttr]=function(){return{priority:100,link:function(scope,element,attr){if("ngPattern"===ngAttr&&"/"==attr.ngPattern.charAt(0)){var match=attr.ngPattern.match(REGEX_STRING_REGEXP);if(match)return void attr.$set("ngPattern",new RegExp(match[1],match[2]))}scope.$watch(attr[ngAttr],function(value){attr.$set(ngAttr,value)})}}}}),forEach(["src","srcset","href"],function(attrName){var normalized=directiveNormalize("ng-"+attrName);ngAttributeAliasDirectives[normalized]=function(){return{priority:99,link:function(scope,element,attr){var propName=attrName,name=attrName;"href"===attrName&&"[object SVGAnimatedString]"===toString.call(element.prop("href"))&&(name="xlinkHref",attr.$attr[name]="xlink:href",propName=null),attr.$observe(normalized,function(value){return value?(attr.$set(name,value),void(msie&&propName&&element.prop(propName,attr[name]))):void("href"===attrName&&attr.$set(name,null))})}}}});var nullFormCtrl={$addControl:noop,$$renameControl:nullFormRenameControl,$removeControl:noop,$setValidity:noop,$setDirty:noop,$setPristine:noop,$setSubmitted:noop},SUBMITTED_CLASS="ng-submitted";FormController.$inject=["$element","$attrs","$scope","$animate","$interpolate"];var formDirectiveFactory=function(isNgForm){return["$timeout",function($timeout){var formDirective={name:"form",restrict:isNgForm?"EAC":"E",controller:FormController,compile:function(formElement,attr){formElement.addClass(PRISTINE_CLASS).addClass(VALID_CLASS);var nameAttr=attr.name?"name":!(!isNgForm||!attr.ngForm)&&"ngForm";return{pre:function(scope,formElement,attr,controller){if(!("action"in attr)){var handleFormSubmission=function(event){scope.$apply(function(){controller.$commitViewValue(),controller.$setSubmitted()}),event.preventDefault()};addEventListenerFn(formElement[0],"submit",handleFormSubmission),formElement.on("$destroy",function(){$timeout(function(){removeEventListenerFn(formElement[0],"submit",handleFormSubmission)},0,!1)})}var parentFormCtrl=controller.$$parentForm;nameAttr&&(setter(scope,null,controller.$name,controller,controller.$name),attr.$observe(nameAttr,function(newValue){controller.$name!==newValue&&(setter(scope,null,controller.$name,undefined,controller.$name),parentFormCtrl.$$renameControl(controller,newValue),setter(scope,null,controller.$name,controller,controller.$name))})),formElement.on("$destroy",function(){parentFormCtrl.$removeControl(controller),nameAttr&&setter(scope,null,attr[nameAttr],undefined,controller.$name),extend(controller,nullFormCtrl)})}}}};return formDirective}]},formDirective=formDirectiveFactory(),ngFormDirective=formDirectiveFactory(!0),ISO_DATE_REGEXP=/\d{4}-[01]\d-[0-3]\dT[0-2]\d:[0-5]\d:[0-5]\d\.\d+([+-][0-2]\d:[0-5]\d|Z)/,URL_REGEXP=/^(ftp|http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?$/,EMAIL_REGEXP=/^[a-z0-9!#$%&'*+\/=?^_`{|}~.-]+@[a-z0-9]([a-z0-9-]*[a-z0-9])?(\.[a-z0-9]([a-z0-9-]*[a-z0-9])?)*$/i,NUMBER_REGEXP=/^\s*(\-|\+)?(\d+|(\d*(\.\d*)))\s*$/,DATE_REGEXP=/^(\d{4})-(\d{2})-(\d{2})$/,DATETIMELOCAL_REGEXP=/^(\d{4})-(\d\d)-(\d\d)T(\d\d):(\d\d)(?::(\d\d)(\.\d{1,3})?)?$/,WEEK_REGEXP=/^(\d{4})-W(\d\d)$/,MONTH_REGEXP=/^(\d{4})-(\d\d)$/,TIME_REGEXP=/^(\d\d):(\d\d)(?::(\d\d)(\.\d{1,3})?)?$/,inputType={text:textInputType,date:createDateInputType("date",DATE_REGEXP,createDateParser(DATE_REGEXP,["yyyy","MM","dd"]),"yyyy-MM-dd"),"datetime-local":createDateInputType("datetimelocal",DATETIMELOCAL_REGEXP,createDateParser(DATETIMELOCAL_REGEXP,["yyyy","MM","dd","HH","mm","ss","sss"]),"yyyy-MM-ddTHH:mm:ss.sss"),time:createDateInputType("time",TIME_REGEXP,createDateParser(TIME_REGEXP,["HH","mm","ss","sss"]),"HH:mm:ss.sss"),week:createDateInputType("week",WEEK_REGEXP,weekParser,"yyyy-Www"),month:createDateInputType("month",MONTH_REGEXP,createDateParser(MONTH_REGEXP,["yyyy","MM"]),"yyyy-MM"),number:numberInputType,url:urlInputType,email:emailInputType,radio:radioInputType,checkbox:checkboxInputType,hidden:noop,button:noop,submit:noop,reset:noop,file:noop},inputDirective=["$browser","$sniffer","$filter","$parse",function($browser,$sniffer,$filter,$parse){return{restrict:"E",require:["?ngModel"],link:{pre:function(scope,element,attr,ctrls){ctrls[0]&&(inputType[lowercase(attr.type)]||inputType.text)(scope,element,attr,ctrls[0],$sniffer,$browser,$filter,$parse)}}}}],CONSTANT_VALUE_REGEXP=/^(true|false|\d+)$/,ngValueDirective=function(){return{restrict:"A",priority:100,compile:function(tpl,tplAttr){return CONSTANT_VALUE_REGEXP.test(tplAttr.ngValue)?function(scope,elm,attr){attr.$set("value",scope.$eval(attr.ngValue))}:function(scope,elm,attr){scope.$watch(attr.ngValue,function(value){attr.$set("value",value)})}}}},ngBindDirective=["$compile",function($compile){return{restrict:"AC",compile:function(templateElement){return $compile.$$addBindingClass(templateElement),function(scope,element,attr){$compile.$$addBindingInfo(element,attr.ngBind),element=element[0],scope.$watch(attr.ngBind,function(value){element.textContent=value===undefined?"":value})}}}}],ngBindTemplateDirective=["$interpolate","$compile",function($interpolate,$compile){return{compile:function(templateElement){return $compile.$$addBindingClass(templateElement),function(scope,element,attr){var interpolateFn=$interpolate(element.attr(attr.$attr.ngBindTemplate));$compile.$$addBindingInfo(element,interpolateFn.expressions),element=element[0],attr.$observe("ngBindTemplate",function(value){element.textContent=value===undefined?"":value})}}}}],ngBindHtmlDirective=["$sce","$parse","$compile",function($sce,$parse,$compile){return{restrict:"A",compile:function(tElement,tAttrs){var ngBindHtmlGetter=$parse(tAttrs.ngBindHtml),ngBindHtmlWatch=$parse(tAttrs.ngBindHtml,function(value){return(value||"").toString()});return $compile.$$addBindingClass(tElement),function(scope,element,attr){$compile.$$addBindingInfo(element,attr.ngBindHtml),scope.$watch(ngBindHtmlWatch,function(){element.html($sce.getTrustedHtml(ngBindHtmlGetter(scope))||"")})}}}}],ngChangeDirective=valueFn({restrict:"A",require:"ngModel",link:function(scope,element,attr,ctrl){ctrl.$viewChangeListeners.push(function(){scope.$eval(attr.ngChange)})}}),ngClassDirective=classDirective("",!0),ngClassOddDirective=classDirective("Odd",0),ngClassEvenDirective=classDirective("Even",1),ngCloakDirective=ngDirective({compile:function(element,attr){attr.$set("ngCloak",undefined),element.removeClass("ng-cloak")}}),ngControllerDirective=[function(){return{restrict:"A",scope:!0,controller:"@",priority:500}}],ngEventDirectives={},forceAsyncEvents={blur:!0,focus:!0};forEach("click dblclick mousedown mouseup mouseover mouseout mousemove mouseenter mouseleave keydown keyup keypress submit focus blur copy cut paste".split(" "),function(eventName){var directiveName=directiveNormalize("ng-"+eventName);ngEventDirectives[directiveName]=["$parse","$rootScope",function($parse,$rootScope){return{restrict:"A",compile:function($element,attr){var fn=$parse(attr[directiveName],null,!0);return function(scope,element){element.on(eventName,function(event){var callback=function(){fn(scope,{$event:event})};forceAsyncEvents[eventName]&&$rootScope.$$phase?scope.$evalAsync(callback):scope.$apply(callback)})}}}}]});var ngIfDirective=["$animate",function($animate){return{multiElement:!0,transclude:"element",priority:600,terminal:!0,restrict:"A",$$tlb:!0,link:function($scope,$element,$attr,ctrl,$transclude){var block,childScope,previousElements;$scope.$watch($attr.ngIf,function(value){value?childScope||$transclude(function(clone,newScope){childScope=newScope,clone[clone.length++]=document.createComment(" end ngIf: "+$attr.ngIf+" "),block={clone:clone},$animate.enter(clone,$element.parent(),$element)}):(previousElements&&(previousElements.remove(),previousElements=null),childScope&&(childScope.$destroy(),childScope=null),block&&(previousElements=getBlockNodes(block.clone),$animate.leave(previousElements).then(function(){previousElements=null}),block=null))})}}}],ngIncludeDirective=["$templateRequest","$anchorScroll","$animate",function($templateRequest,$anchorScroll,$animate){return{restrict:"ECA",priority:400,terminal:!0,transclude:"element",controller:angular.noop,compile:function(element,attr){var srcExp=attr.ngInclude||attr.src,onloadExp=attr.onload||"",autoScrollExp=attr.autoscroll;return function(scope,$element,$attr,ctrl,$transclude){var currentScope,previousElement,currentElement,changeCounter=0,cleanupLastIncludeContent=function(){previousElement&&(previousElement.remove(),previousElement=null),currentScope&&(currentScope.$destroy(),currentScope=null),currentElement&&($animate.leave(currentElement).then(function(){previousElement=null}),previousElement=currentElement,currentElement=null)};scope.$watch(srcExp,function(src){var afterAnimation=function(){!isDefined(autoScrollExp)||autoScrollExp&&!scope.$eval(autoScrollExp)||$anchorScroll()},thisChangeId=++changeCounter;src?($templateRequest(src,!0).then(function(response){if(thisChangeId===changeCounter){var newScope=scope.$new();ctrl.template=response;var clone=$transclude(newScope,function(clone){cleanupLastIncludeContent(),$animate.enter(clone,null,$element).then(afterAnimation)});currentScope=newScope,currentElement=clone,currentScope.$emit("$includeContentLoaded",src),scope.$eval(onloadExp)}},function(){thisChangeId===changeCounter&&(cleanupLastIncludeContent(),scope.$emit("$includeContentError",src))}),scope.$emit("$includeContentRequested",src)):(cleanupLastIncludeContent(),ctrl.template=null)})}}}}],ngIncludeFillContentDirective=["$compile",function($compile){return{restrict:"ECA",priority:-400,require:"ngInclude",link:function(scope,$element,$attr,ctrl){return/SVG/.test($element[0].toString())?($element.empty(),void $compile(jqLiteBuildFragment(ctrl.template,document).childNodes)(scope,function(clone){$element.append(clone)},{futureParentElement:$element})):($element.html(ctrl.template),void $compile($element.contents())(scope))}}}],ngInitDirective=ngDirective({priority:450,compile:function(){return{pre:function(scope,element,attrs){scope.$eval(attrs.ngInit)}}}}),ngListDirective=function(){return{restrict:"A",priority:100,require:"ngModel",link:function(scope,element,attr,ctrl){var ngList=element.attr(attr.$attr.ngList)||", ",trimValues="false"!==attr.ngTrim,separator=trimValues?trim(ngList):ngList,parse=function(viewValue){if(!isUndefined(viewValue)){var list=[];return viewValue&&forEach(viewValue.split(separator),function(value){value&&list.push(trimValues?trim(value):value)}),list}};ctrl.$parsers.push(parse),ctrl.$formatters.push(function(value){return isArray(value)?value.join(ngList):undefined}),ctrl.$isEmpty=function(value){return!value||!value.length}}}},VALID_CLASS="ng-valid",INVALID_CLASS="ng-invalid",PRISTINE_CLASS="ng-pristine",DIRTY_CLASS="ng-dirty",UNTOUCHED_CLASS="ng-untouched",TOUCHED_CLASS="ng-touched",PENDING_CLASS="ng-pending",ngModelMinErr=minErr("ngModel"),NgModelController=["$scope","$exceptionHandler","$attrs","$element","$parse","$animate","$timeout","$rootScope","$q","$interpolate",function($scope,$exceptionHandler,$attr,$element,$parse,$animate,$timeout,$rootScope,$q,$interpolate){this.$viewValue=Number.NaN,this.$modelValue=Number.NaN,this.$$rawModelValue=undefined,this.$validators={},this.$asyncValidators={},this.$parsers=[],this.$formatters=[],this.$viewChangeListeners=[],this.$untouched=!0,this.$touched=!1,this.$pristine=!0,this.$dirty=!1,this.$valid=!0,this.$invalid=!1,this.$error={},this.$$success={},this.$pending=undefined,this.$name=$interpolate($attr.name||"",!1)($scope);var parserValid,parsedNgModel=$parse($attr.ngModel),parsedNgModelAssign=parsedNgModel.assign,ngModelGet=parsedNgModel,ngModelSet=parsedNgModelAssign,pendingDebounce=null,ctrl=this;this.$$setOptions=function(options){if(ctrl.$options=options,options&&options.getterSetter){var invokeModelGetter=$parse($attr.ngModel+"()"),invokeModelSetter=$parse($attr.ngModel+"($$$p)");ngModelGet=function($scope){var modelValue=parsedNgModel($scope);return isFunction(modelValue)&&(modelValue=invokeModelGetter($scope)),modelValue},ngModelSet=function($scope,newValue){isFunction(parsedNgModel($scope))?invokeModelSetter($scope,{$$$p:ctrl.$modelValue}):parsedNgModelAssign($scope,ctrl.$modelValue)}}else if(!parsedNgModel.assign)throw ngModelMinErr("nonassign","Expression '{0}' is non-assignable. Element: {1}",$attr.ngModel,startingTag($element))},this.$render=noop,this.$isEmpty=function(value){return isUndefined(value)||""===value||null===value||value!==value};var parentForm=$element.inheritedData("$formController")||nullFormCtrl,currentValidationRunId=0;addSetValidityMethod({ctrl:this,$element:$element,set:function(object,property){object[property]=!0},unset:function(object,property){delete object[property]},parentForm:parentForm,$animate:$animate}),this.$setPristine=function(){ctrl.$dirty=!1,ctrl.$pristine=!0,$animate.removeClass($element,DIRTY_CLASS),$animate.addClass($element,PRISTINE_CLASS)},this.$setDirty=function(){ctrl.$dirty=!0,ctrl.$pristine=!1,$animate.removeClass($element,PRISTINE_CLASS),$animate.addClass($element,DIRTY_CLASS),parentForm.$setDirty()},this.$setUntouched=function(){ctrl.$touched=!1,ctrl.$untouched=!0,$animate.setClass($element,UNTOUCHED_CLASS,TOUCHED_CLASS)},this.$setTouched=function(){ctrl.$touched=!0,ctrl.$untouched=!1,$animate.setClass($element,TOUCHED_CLASS,UNTOUCHED_CLASS)},this.$rollbackViewValue=function(){$timeout.cancel(pendingDebounce),ctrl.$viewValue=ctrl.$$lastCommittedViewValue,ctrl.$render()},this.$validate=function(){if(!isNumber(ctrl.$modelValue)||!isNaN(ctrl.$modelValue)){var viewValue=ctrl.$$lastCommittedViewValue,modelValue=ctrl.$$rawModelValue,prevValid=ctrl.$valid,prevModelValue=ctrl.$modelValue,allowInvalid=ctrl.$options&&ctrl.$options.allowInvalid;ctrl.$$runValidators(modelValue,viewValue,function(allValid){allowInvalid||prevValid===allValid||(ctrl.$modelValue=allValid?modelValue:undefined,ctrl.$modelValue!==prevModelValue&&ctrl.$$writeModelToScope())})}},this.$$runValidators=function(modelValue,viewValue,doneCallback){function processParseErrors(){var errorKey=ctrl.$$parserName||"parse";return parserValid!==undefined?(parserValid||(forEach(ctrl.$validators,function(v,name){setValidity(name,null)}),forEach(ctrl.$asyncValidators,function(v,name){setValidity(name,null)})),setValidity(errorKey,parserValid),parserValid):(setValidity(errorKey,null),!0)}function processSyncValidators(){var syncValidatorsValid=!0;return forEach(ctrl.$validators,function(validator,name){var result=validator(modelValue,viewValue);syncValidatorsValid=syncValidatorsValid&&result,setValidity(name,result)}),!!syncValidatorsValid||(forEach(ctrl.$asyncValidators,function(v,name){setValidity(name,null)}),!1)}function processAsyncValidators(){var validatorPromises=[],allValid=!0;forEach(ctrl.$asyncValidators,function(validator,name){var promise=validator(modelValue,viewValue);if(!isPromiseLike(promise))throw ngModelMinErr("$asyncValidators","Expected asynchronous validator to return a promise but got '{0}' instead.",promise);setValidity(name,undefined),validatorPromises.push(promise.then(function(){setValidity(name,!0)},function(error){allValid=!1,setValidity(name,!1)}))}),validatorPromises.length?$q.all(validatorPromises).then(function(){validationDone(allValid)},noop):validationDone(!0)}function setValidity(name,isValid){localValidationRunId===currentValidationRunId&&ctrl.$setValidity(name,isValid)}function validationDone(allValid){localValidationRunId===currentValidationRunId&&doneCallback(allValid)}currentValidationRunId++;var localValidationRunId=currentValidationRunId;return processParseErrors()&&processSyncValidators()?void processAsyncValidators():void validationDone(!1)},this.$commitViewValue=function(){var viewValue=ctrl.$viewValue;$timeout.cancel(pendingDebounce),(ctrl.$$lastCommittedViewValue!==viewValue||""===viewValue&&ctrl.$$hasNativeValidators)&&(ctrl.$$lastCommittedViewValue=viewValue,ctrl.$pristine&&this.$setDirty(),this.$$parseAndValidate())},this.$$parseAndValidate=function(){function writeToModelIfNeeded(){ctrl.$modelValue!==prevModelValue&&ctrl.$$writeModelToScope()}var viewValue=ctrl.$$lastCommittedViewValue,modelValue=viewValue;if(parserValid=!isUndefined(modelValue)||undefined)for(var i=0;i<ctrl.$parsers.length;i++)if(modelValue=ctrl.$parsers[i](modelValue),isUndefined(modelValue)){parserValid=!1;break}isNumber(ctrl.$modelValue)&&isNaN(ctrl.$modelValue)&&(ctrl.$modelValue=ngModelGet($scope));var prevModelValue=ctrl.$modelValue,allowInvalid=ctrl.$options&&ctrl.$options.allowInvalid;ctrl.$$rawModelValue=modelValue,allowInvalid&&(ctrl.$modelValue=modelValue,writeToModelIfNeeded()),ctrl.$$runValidators(modelValue,ctrl.$$lastCommittedViewValue,function(allValid){allowInvalid||(ctrl.$modelValue=allValid?modelValue:undefined,writeToModelIfNeeded())})},this.$$writeModelToScope=function(){ngModelSet($scope,ctrl.$modelValue),forEach(ctrl.$viewChangeListeners,function(listener){try{listener()}catch(e){$exceptionHandler(e)}})},this.$setViewValue=function(value,trigger){ctrl.$viewValue=value,ctrl.$options&&!ctrl.$options.updateOnDefault||ctrl.$$debounceViewValueCommit(trigger)},this.$$debounceViewValueCommit=function(trigger){var debounce,debounceDelay=0,options=ctrl.$options;options&&isDefined(options.debounce)&&(debounce=options.debounce,isNumber(debounce)?debounceDelay=debounce:isNumber(debounce[trigger])?debounceDelay=debounce[trigger]:isNumber(debounce.default)&&(debounceDelay=debounce.default)),$timeout.cancel(pendingDebounce),debounceDelay?pendingDebounce=$timeout(function(){ctrl.$commitViewValue()},debounceDelay):$rootScope.$$phase?ctrl.$commitViewValue():$scope.$apply(function(){ctrl.$commitViewValue()})},$scope.$watch(function(){var modelValue=ngModelGet($scope);if(modelValue!==ctrl.$modelValue&&(ctrl.$modelValue===ctrl.$modelValue||modelValue===modelValue)){ctrl.$modelValue=ctrl.$$rawModelValue=modelValue,parserValid=undefined;for(var formatters=ctrl.$formatters,idx=formatters.length,viewValue=modelValue;idx--;)viewValue=formatters[idx](viewValue);ctrl.$viewValue!==viewValue&&(ctrl.$viewValue=ctrl.$$lastCommittedViewValue=viewValue,ctrl.$render(),ctrl.$$runValidators(modelValue,viewValue,noop))}return modelValue})}],ngModelDirective=["$rootScope",function($rootScope){return{restrict:"A",require:["ngModel","^?form","^?ngModelOptions"],controller:NgModelController,priority:1,compile:function(element){return element.addClass(PRISTINE_CLASS).addClass(UNTOUCHED_CLASS).addClass(VALID_CLASS),{pre:function(scope,element,attr,ctrls){var modelCtrl=ctrls[0],formCtrl=ctrls[1]||nullFormCtrl;modelCtrl.$$setOptions(ctrls[2]&&ctrls[2].$options),formCtrl.$addControl(modelCtrl),attr.$observe("name",function(newValue){modelCtrl.$name!==newValue&&formCtrl.$$renameControl(modelCtrl,newValue)}),scope.$on("$destroy",function(){formCtrl.$removeControl(modelCtrl)})},post:function(scope,element,attr,ctrls){var modelCtrl=ctrls[0];modelCtrl.$options&&modelCtrl.$options.updateOn&&element.on(modelCtrl.$options.updateOn,function(ev){modelCtrl.$$debounceViewValueCommit(ev&&ev.type)}),element.on("blur",function(ev){modelCtrl.$touched||($rootScope.$$phase?scope.$evalAsync(modelCtrl.$setTouched):scope.$apply(modelCtrl.$setTouched))})}}}}}],DEFAULT_REGEXP=/(\s+|^)default(\s+|$)/,ngModelOptionsDirective=function(){return{restrict:"A",controller:["$scope","$attrs",function($scope,$attrs){var that=this;this.$options=$scope.$eval($attrs.ngModelOptions),this.$options.updateOn!==undefined?(this.$options.updateOnDefault=!1,this.$options.updateOn=trim(this.$options.updateOn.replace(DEFAULT_REGEXP,function(){return that.$options.updateOnDefault=!0," "}))):this.$options.updateOnDefault=!0}]}},ngNonBindableDirective=ngDirective({terminal:!0,priority:1e3}),ngPluralizeDirective=["$locale","$interpolate",function($locale,$interpolate){var BRACE=/{}/g,IS_WHEN=/^when(Minus)?(.+)$/;return{restrict:"EA",link:function(scope,element,attr){function updateElementText(newText){element.text(newText||"")}var lastCount,numberExp=attr.count,whenExp=attr.$attr.when&&element.attr(attr.$attr.when),offset=attr.offset||0,whens=scope.$eval(whenExp)||{},whensExpFns={},startSymbol=$interpolate.startSymbol(),endSymbol=$interpolate.endSymbol(),braceReplacement=startSymbol+numberExp+"-"+offset+endSymbol,watchRemover=angular.noop;forEach(attr,function(expression,attributeName){var tmpMatch=IS_WHEN.exec(attributeName);if(tmpMatch){var whenKey=(tmpMatch[1]?"-":"")+lowercase(tmpMatch[2]);whens[whenKey]=element.attr(attr.$attr[attributeName])}}),forEach(whens,function(expression,key){whensExpFns[key]=$interpolate(expression.replace(BRACE,braceReplacement))}),scope.$watch(numberExp,function(newVal){var count=parseFloat(newVal),countIsNaN=isNaN(count);countIsNaN||count in whens||(count=$locale.pluralCat(count-offset)),count===lastCount||countIsNaN&&isNaN(lastCount)||(watchRemover(),watchRemover=scope.$watch(whensExpFns[count],updateElementText),lastCount=count)})}}}],ngRepeatDirective=["$parse","$animate",function($parse,$animate){var NG_REMOVED="$$NG_REMOVED",ngRepeatMinErr=minErr("ngRepeat"),updateScope=function(scope,index,valueIdentifier,value,keyIdentifier,key,arrayLength){scope[valueIdentifier]=value,keyIdentifier&&(scope[keyIdentifier]=key),scope.$index=index,scope.$first=0===index,scope.$last=index===arrayLength-1,scope.$middle=!(scope.$first||scope.$last),scope.$odd=!(scope.$even=0===(1&index))},getBlockStart=function(block){return block.clone[0]},getBlockEnd=function(block){return block.clone[block.clone.length-1]};return{restrict:"A",multiElement:!0,transclude:"element",priority:1e3,terminal:!0,$$tlb:!0,compile:function($element,$attr){var expression=$attr.ngRepeat,ngRepeatEndComment=document.createComment(" end ngRepeat: "+expression+" "),match=expression.match(/^\s*([\s\S]+?)\s+in\s+([\s\S]+?)(?:\s+as\s+([\s\S]+?))?(?:\s+track\s+by\s+([\s\S]+?))?\s*$/);if(!match)throw ngRepeatMinErr("iexp","Expected expression in form of '_item_ in _collection_[ track by _id_]' but got '{0}'.",expression);var lhs=match[1],rhs=match[2],aliasAs=match[3],trackByExp=match[4];if(match=lhs.match(/^(?:(\s*[\$\w]+)|\(\s*([\$\w]+)\s*,\s*([\$\w]+)\s*\))$/),!match)throw ngRepeatMinErr("iidexp","'_item_' in '_item_ in _collection_' should be an identifier or '(_key_, _value_)' expression, but got '{0}'.",lhs);var valueIdentifier=match[3]||match[1],keyIdentifier=match[2];if(aliasAs&&(!/^[$a-zA-Z_][$a-zA-Z0-9_]*$/.test(aliasAs)||/^(null|undefined|this|\$index|\$first|\$middle|\$last|\$even|\$odd|\$parent|\$root|\$id)$/.test(aliasAs)))throw ngRepeatMinErr("badident","alias '{0}' is invalid --- must be a valid JS identifier which is not a reserved name.",aliasAs);var trackByExpGetter,trackByIdExpFn,trackByIdArrayFn,trackByIdObjFn,hashFnLocals={$id:hashKey};return trackByExp?trackByExpGetter=$parse(trackByExp):(trackByIdArrayFn=function(key,value){return hashKey(value)},trackByIdObjFn=function(key){return key}),function($scope,$element,$attr,ctrl,$transclude){trackByExpGetter&&(trackByIdExpFn=function(key,value,index){return keyIdentifier&&(hashFnLocals[keyIdentifier]=key),hashFnLocals[valueIdentifier]=value,hashFnLocals.$index=index,trackByExpGetter($scope,hashFnLocals);
});var lastBlockMap=createMap();$scope.$watchCollection(rhs,function(collection){var index,length,nextNode,collectionLength,key,value,trackById,trackByIdFn,collectionKeys,block,nextBlockOrder,elementsToRemove,previousNode=$element[0],nextBlockMap=createMap();if(aliasAs&&($scope[aliasAs]=collection),isArrayLike(collection))collectionKeys=collection,trackByIdFn=trackByIdExpFn||trackByIdArrayFn;else{trackByIdFn=trackByIdExpFn||trackByIdObjFn,collectionKeys=[];for(var itemKey in collection)collection.hasOwnProperty(itemKey)&&"$"!=itemKey.charAt(0)&&collectionKeys.push(itemKey);collectionKeys.sort()}for(collectionLength=collectionKeys.length,nextBlockOrder=new Array(collectionLength),index=0;index<collectionLength;index++)if(key=collection===collectionKeys?index:collectionKeys[index],value=collection[key],trackById=trackByIdFn(key,value,index),lastBlockMap[trackById])block=lastBlockMap[trackById],delete lastBlockMap[trackById],nextBlockMap[trackById]=block,nextBlockOrder[index]=block;else{if(nextBlockMap[trackById])throw forEach(nextBlockOrder,function(block){block&&block.scope&&(lastBlockMap[block.id]=block)}),ngRepeatMinErr("dupes","Duplicates in a repeater are not allowed. Use 'track by' expression to specify unique keys. Repeater: {0}, Duplicate key: {1}, Duplicate value: {2}",expression,trackById,value);nextBlockOrder[index]={id:trackById,scope:undefined,clone:undefined},nextBlockMap[trackById]=!0}for(var blockKey in lastBlockMap){if(block=lastBlockMap[blockKey],elementsToRemove=getBlockNodes(block.clone),$animate.leave(elementsToRemove),elementsToRemove[0].parentNode)for(index=0,length=elementsToRemove.length;index<length;index++)elementsToRemove[index][NG_REMOVED]=!0;block.scope.$destroy()}for(index=0;index<collectionLength;index++)if(key=collection===collectionKeys?index:collectionKeys[index],value=collection[key],block=nextBlockOrder[index],block.scope){nextNode=previousNode;do nextNode=nextNode.nextSibling;while(nextNode&&nextNode[NG_REMOVED]);getBlockStart(block)!=nextNode&&$animate.move(getBlockNodes(block.clone),null,jqLite(previousNode)),previousNode=getBlockEnd(block),updateScope(block.scope,index,valueIdentifier,value,keyIdentifier,key,collectionLength)}else $transclude(function(clone,scope){block.scope=scope;var endNode=ngRepeatEndComment.cloneNode(!1);clone[clone.length++]=endNode,$animate.enter(clone,null,jqLite(previousNode)),previousNode=endNode,block.clone=clone,nextBlockMap[block.id]=block,updateScope(block.scope,index,valueIdentifier,value,keyIdentifier,key,collectionLength)});lastBlockMap=nextBlockMap})}}}}],NG_HIDE_CLASS="ng-hide",NG_HIDE_IN_PROGRESS_CLASS="ng-hide-animate",ngShowDirective=["$animate",function($animate){return{restrict:"A",multiElement:!0,link:function(scope,element,attr){scope.$watch(attr.ngShow,function(value){$animate[value?"removeClass":"addClass"](element,NG_HIDE_CLASS,{tempClasses:NG_HIDE_IN_PROGRESS_CLASS})})}}}],ngHideDirective=["$animate",function($animate){return{restrict:"A",multiElement:!0,link:function(scope,element,attr){scope.$watch(attr.ngHide,function(value){$animate[value?"addClass":"removeClass"](element,NG_HIDE_CLASS,{tempClasses:NG_HIDE_IN_PROGRESS_CLASS})})}}}],ngStyleDirective=ngDirective(function(scope,element,attr){scope.$watch(attr.ngStyle,function(newStyles,oldStyles){oldStyles&&newStyles!==oldStyles&&forEach(oldStyles,function(val,style){element.css(style,"")}),newStyles&&element.css(newStyles)},!0)}),ngSwitchDirective=["$animate",function($animate){return{restrict:"EA",require:"ngSwitch",controller:["$scope",function(){this.cases={}}],link:function(scope,element,attr,ngSwitchController){var watchExpr=attr.ngSwitch||attr.on,selectedTranscludes=[],selectedElements=[],previousLeaveAnimations=[],selectedScopes=[],spliceFactory=function(array,index){return function(){array.splice(index,1)}};scope.$watch(watchExpr,function(value){var i,ii;for(i=0,ii=previousLeaveAnimations.length;i<ii;++i)$animate.cancel(previousLeaveAnimations[i]);for(previousLeaveAnimations.length=0,i=0,ii=selectedScopes.length;i<ii;++i){var selected=getBlockNodes(selectedElements[i].clone);selectedScopes[i].$destroy();var promise=previousLeaveAnimations[i]=$animate.leave(selected);promise.then(spliceFactory(previousLeaveAnimations,i))}selectedElements.length=0,selectedScopes.length=0,(selectedTranscludes=ngSwitchController.cases["!"+value]||ngSwitchController.cases["?"])&&forEach(selectedTranscludes,function(selectedTransclude){selectedTransclude.transclude(function(caseElement,selectedScope){selectedScopes.push(selectedScope);var anchor=selectedTransclude.element;caseElement[caseElement.length++]=document.createComment(" end ngSwitchWhen: ");var block={clone:caseElement};selectedElements.push(block),$animate.enter(caseElement,anchor.parent(),anchor)})})})}}}],ngSwitchWhenDirective=ngDirective({transclude:"element",priority:1200,require:"^ngSwitch",multiElement:!0,link:function(scope,element,attrs,ctrl,$transclude){ctrl.cases["!"+attrs.ngSwitchWhen]=ctrl.cases["!"+attrs.ngSwitchWhen]||[],ctrl.cases["!"+attrs.ngSwitchWhen].push({transclude:$transclude,element:element})}}),ngSwitchDefaultDirective=ngDirective({transclude:"element",priority:1200,require:"^ngSwitch",multiElement:!0,link:function(scope,element,attr,ctrl,$transclude){ctrl.cases["?"]=ctrl.cases["?"]||[],ctrl.cases["?"].push({transclude:$transclude,element:element})}}),ngTranscludeDirective=ngDirective({restrict:"EAC",link:function($scope,$element,$attrs,controller,$transclude){if(!$transclude)throw minErr("ngTransclude")("orphan","Illegal use of ngTransclude directive in the template! No parent directive that requires a transclusion found. Element: {0}",startingTag($element));$transclude(function(clone){$element.empty(),$element.append(clone)})}}),scriptDirective=["$templateCache",function($templateCache){return{restrict:"E",terminal:!0,compile:function(element,attr){if("text/ng-template"==attr.type){var templateUrl=attr.id,text=element[0].text;$templateCache.put(templateUrl,text)}}}}],ngOptionsMinErr=minErr("ngOptions"),ngOptionsDirective=valueFn({restrict:"A",terminal:!0}),selectDirective=["$compile","$parse",function($compile,$parse){var NG_OPTIONS_REGEXP=/^\s*([\s\S]+?)(?:\s+as\s+([\s\S]+?))?(?:\s+group\s+by\s+([\s\S]+?))?\s+for\s+(?:([\$\w][\$\w]*)|(?:\(\s*([\$\w][\$\w]*)\s*,\s*([\$\w][\$\w]*)\s*\)))\s+in\s+([\s\S]+?)(?:\s+track\s+by\s+([\s\S]+?))?$/,nullModelCtrl={$setViewValue:noop};return{restrict:"E",require:["select","?ngModel"],controller:["$element","$scope","$attrs",function($element,$scope,$attrs){var nullOption,unknownOption,self=this,optionsMap={},ngModelCtrl=nullModelCtrl;self.databound=$attrs.ngModel,self.init=function(ngModelCtrl_,nullOption_,unknownOption_){ngModelCtrl=ngModelCtrl_,nullOption=nullOption_,unknownOption=unknownOption_},self.addOption=function(value,element){assertNotHasOwnProperty(value,'"option value"'),optionsMap[value]=!0,ngModelCtrl.$viewValue==value&&($element.val(value),unknownOption.parent()&&unknownOption.remove()),element&&element[0].hasAttribute("selected")&&(element[0].selected=!0)},self.removeOption=function(value){this.hasOption(value)&&(delete optionsMap[value],ngModelCtrl.$viewValue===value&&this.renderUnknownOption(value))},self.renderUnknownOption=function(val){var unknownVal="? "+hashKey(val)+" ?";unknownOption.val(unknownVal),$element.prepend(unknownOption),$element.val(unknownVal),unknownOption.prop("selected",!0)},self.hasOption=function(value){return optionsMap.hasOwnProperty(value)},$scope.$on("$destroy",function(){self.renderUnknownOption=noop})}],link:function(scope,element,attr,ctrls){function setupAsSingle(scope,selectElement,ngModelCtrl,selectCtrl){ngModelCtrl.$render=function(){var viewValue=ngModelCtrl.$viewValue;selectCtrl.hasOption(viewValue)?(unknownOption.parent()&&unknownOption.remove(),selectElement.val(viewValue),""===viewValue&&emptyOption.prop("selected",!0)):null==viewValue&&emptyOption?selectElement.val(""):selectCtrl.renderUnknownOption(viewValue)},selectElement.on("change",function(){scope.$apply(function(){unknownOption.parent()&&unknownOption.remove(),ngModelCtrl.$setViewValue(selectElement.val())})})}function setupAsMultiple(scope,selectElement,ctrl){var lastView;ctrl.$render=function(){var items=new HashMap(ctrl.$viewValue);forEach(selectElement.find("option"),function(option){option.selected=isDefined(items.get(option.value))})},scope.$watch(function(){equals(lastView,ctrl.$viewValue)||(lastView=shallowCopy(ctrl.$viewValue),ctrl.$render())}),selectElement.on("change",function(){scope.$apply(function(){var array=[];forEach(selectElement.find("option"),function(option){option.selected&&array.push(option.value)}),ctrl.$setViewValue(array)})})}function setupAsOptions(scope,selectElement,ctrl){function callExpression(exprFn,key,value){return locals[valueName]=value,keyName&&(locals[keyName]=key),exprFn(scope,locals)}function selectionChanged(){scope.$apply(function(){var viewValue,collection=valuesFn(scope)||[];if(multiple)viewValue=[],forEach(selectElement.val(),function(selectedKey){selectedKey=trackFn?trackKeysCache[selectedKey]:selectedKey,viewValue.push(getViewValue(selectedKey,collection[selectedKey]))});else{var selectedKey=trackFn?trackKeysCache[selectElement.val()]:selectElement.val();viewValue=getViewValue(selectedKey,collection[selectedKey])}ctrl.$setViewValue(viewValue),render()})}function getViewValue(key,value){if("?"===key)return undefined;if(""===key)return null;var viewValueFn=selectAsFn?selectAsFn:valueFn;return callExpression(viewValueFn,key,value)}function getLabels(){var toDisplay,values=valuesFn(scope);if(values&&isArray(values)){toDisplay=new Array(values.length);for(var i=0,ii=values.length;i<ii;i++)toDisplay[i]=callExpression(displayFn,i,values[i]);return toDisplay}if(values){toDisplay={};for(var prop in values)values.hasOwnProperty(prop)&&(toDisplay[prop]=callExpression(displayFn,prop,values[prop]))}return toDisplay}function createIsSelectedFn(viewValue){var selectedSet;if(multiple)if(trackFn&&isArray(viewValue)){selectedSet=new HashMap([]);for(var trackIndex=0;trackIndex<viewValue.length;trackIndex++)selectedSet.put(callExpression(trackFn,null,viewValue[trackIndex]),!0)}else selectedSet=new HashMap(viewValue);else trackFn&&(viewValue=callExpression(trackFn,null,viewValue));return function(key,value){var compareValueFn;return compareValueFn=trackFn?trackFn:selectAsFn?selectAsFn:valueFn,multiple?isDefined(selectedSet.remove(callExpression(compareValueFn,key,value))):viewValue===callExpression(compareValueFn,key,value)}}function scheduleRendering(){renderScheduled||(scope.$$postDigest(render),renderScheduled=!0)}function updateLabelMap(labelMap,label,added){labelMap[label]=labelMap[label]||0,labelMap[label]+=added?1:-1}function render(){renderScheduled=!1;var optionGroupName,optionGroup,option,existingParent,existingOptions,existingOption,key,value,groupLength,length,groupIndex,index,selected,lastElement,element,label,optionId,optionGroups={"":[]},optionGroupNames=[""],viewValue=ctrl.$viewValue,values=valuesFn(scope)||[],keys=keyName?sortedKeys(values):values,labelMap={},isSelected=createIsSelectedFn(viewValue),anySelected=!1;for(trackKeysCache={},index=0;length=keys.length,index<length;index++)key=index,keyName&&(key=keys[index],"$"===key.charAt(0))||(value=values[key],optionGroupName=callExpression(groupByFn,key,value)||"",(optionGroup=optionGroups[optionGroupName])||(optionGroup=optionGroups[optionGroupName]=[],optionGroupNames.push(optionGroupName)),selected=isSelected(key,value),anySelected=anySelected||selected,label=callExpression(displayFn,key,value),label=isDefined(label)?label:"",optionId=trackFn?trackFn(scope,locals):keyName?keys[index]:index,trackFn&&(trackKeysCache[optionId]=key),optionGroup.push({id:optionId,label:label,selected:selected}));for(multiple||(nullOption||null===viewValue?optionGroups[""].unshift({id:"",label:"",selected:!anySelected}):anySelected||optionGroups[""].unshift({id:"?",label:"",selected:!0})),groupIndex=0,groupLength=optionGroupNames.length;groupIndex<groupLength;groupIndex++){for(optionGroupName=optionGroupNames[groupIndex],optionGroup=optionGroups[optionGroupName],optionGroupsCache.length<=groupIndex?(existingParent={element:optGroupTemplate.clone().attr("label",optionGroupName),label:optionGroup.label},existingOptions=[existingParent],optionGroupsCache.push(existingOptions),selectElement.append(existingParent.element)):(existingOptions=optionGroupsCache[groupIndex],existingParent=existingOptions[0],existingParent.label!=optionGroupName&&existingParent.element.attr("label",existingParent.label=optionGroupName)),lastElement=null,index=0,length=optionGroup.length;index<length;index++)option=optionGroup[index],(existingOption=existingOptions[index+1])?(lastElement=existingOption.element,existingOption.label!==option.label&&(updateLabelMap(labelMap,existingOption.label,!1),updateLabelMap(labelMap,option.label,!0),lastElement.text(existingOption.label=option.label),lastElement.prop("label",existingOption.label)),existingOption.id!==option.id&&lastElement.val(existingOption.id=option.id),lastElement[0].selected!==option.selected&&(lastElement.prop("selected",existingOption.selected=option.selected),msie&&lastElement.prop("selected",existingOption.selected))):(""===option.id&&nullOption?element=nullOption:(element=optionTemplate.clone()).val(option.id).prop("selected",option.selected).attr("selected",option.selected).prop("label",option.label).text(option.label),existingOptions.push(existingOption={element:element,label:option.label,id:option.id,selected:option.selected}),updateLabelMap(labelMap,option.label,!0),lastElement?lastElement.after(element):existingParent.element.append(element),lastElement=element);for(index++;existingOptions.length>index;)option=existingOptions.pop(),updateLabelMap(labelMap,option.label,!1),option.element.remove()}for(;optionGroupsCache.length>groupIndex;){for(optionGroup=optionGroupsCache.pop(),index=1;index<optionGroup.length;++index)updateLabelMap(labelMap,optionGroup[index].label,!1);optionGroup[0].element.remove()}forEach(labelMap,function(count,label){count>0?selectCtrl.addOption(label):count<0&&selectCtrl.removeOption(label)})}var match;if(!(match=optionsExp.match(NG_OPTIONS_REGEXP)))throw ngOptionsMinErr("iexp","Expected expression in form of '_select_ (as _label_)? for (_key_,)?_value_ in _collection_' but got '{0}'. Element: {1}",optionsExp,startingTag(selectElement));var displayFn=$parse(match[2]||match[1]),valueName=match[4]||match[6],selectAs=/ as /.test(match[0])&&match[1],selectAsFn=selectAs?$parse(selectAs):null,keyName=match[5],groupByFn=$parse(match[3]||""),valueFn=$parse(match[2]?match[1]:valueName),valuesFn=$parse(match[7]),track=match[8],trackFn=track?$parse(match[8]):null,trackKeysCache={},optionGroupsCache=[[{element:selectElement,label:""}]],locals={};nullOption&&($compile(nullOption)(scope),nullOption.removeClass("ng-scope"),nullOption.remove()),selectElement.empty(),selectElement.on("change",selectionChanged),ctrl.$render=render,scope.$watchCollection(valuesFn,scheduleRendering),scope.$watchCollection(getLabels,scheduleRendering),multiple&&scope.$watchCollection(function(){return ctrl.$modelValue},scheduleRendering)}if(ctrls[1]){for(var emptyOption,selectCtrl=ctrls[0],ngModelCtrl=ctrls[1],multiple=attr.multiple,optionsExp=attr.ngOptions,nullOption=!1,renderScheduled=!1,optionTemplate=jqLite(document.createElement("option")),optGroupTemplate=jqLite(document.createElement("optgroup")),unknownOption=optionTemplate.clone(),i=0,children=element.children(),ii=children.length;i<ii;i++)if(""===children[i].value){emptyOption=nullOption=children.eq(i);break}selectCtrl.init(ngModelCtrl,nullOption,unknownOption),multiple&&(ngModelCtrl.$isEmpty=function(value){return!value||0===value.length}),optionsExp?setupAsOptions(scope,element,ngModelCtrl):multiple?setupAsMultiple(scope,element,ngModelCtrl):setupAsSingle(scope,element,ngModelCtrl,selectCtrl)}}}}],optionDirective=["$interpolate",function($interpolate){var nullSelectCtrl={addOption:noop,removeOption:noop};return{restrict:"E",priority:100,compile:function(element,attr){if(isUndefined(attr.value)){var interpolateFn=$interpolate(element.text(),!0);interpolateFn||attr.$set("value",element.text())}return function(scope,element,attr){var selectCtrlName="$selectController",parent=element.parent(),selectCtrl=parent.data(selectCtrlName)||parent.parent().data(selectCtrlName);selectCtrl&&selectCtrl.databound||(selectCtrl=nullSelectCtrl),interpolateFn?scope.$watch(interpolateFn,function(newVal,oldVal){attr.$set("value",newVal),oldVal!==newVal&&selectCtrl.removeOption(oldVal),selectCtrl.addOption(newVal,element)}):selectCtrl.addOption(attr.value,element),element.on("$destroy",function(){selectCtrl.removeOption(attr.value)})}}}}],styleDirective=valueFn({restrict:"E",terminal:!1}),requiredDirective=function(){return{restrict:"A",require:"?ngModel",link:function(scope,elm,attr,ctrl){ctrl&&(attr.required=!0,ctrl.$validators.required=function(modelValue,viewValue){return!attr.required||!ctrl.$isEmpty(viewValue)},attr.$observe("required",function(){ctrl.$validate()}))}}},patternDirective=function(){return{restrict:"A",require:"?ngModel",link:function(scope,elm,attr,ctrl){if(ctrl){var regexp,patternExp=attr.ngPattern||attr.pattern;attr.$observe("pattern",function(regex){if(isString(regex)&&regex.length>0&&(regex=new RegExp("^"+regex+"$")),regex&&!regex.test)throw minErr("ngPattern")("noregexp","Expected {0} to be a RegExp but was {1}. Element: {2}",patternExp,regex,startingTag(elm));regexp=regex||undefined,ctrl.$validate()}),ctrl.$validators.pattern=function(modelValue,viewValue){return ctrl.$isEmpty(viewValue)||isUndefined(regexp)||regexp.test(viewValue)}}}}},maxlengthDirective=function(){return{restrict:"A",require:"?ngModel",link:function(scope,elm,attr,ctrl){if(ctrl){var maxlength=-1;attr.$observe("maxlength",function(value){var intVal=int(value);maxlength=isNaN(intVal)?-1:intVal,ctrl.$validate()}),ctrl.$validators.maxlength=function(modelValue,viewValue){return maxlength<0||ctrl.$isEmpty(viewValue)||viewValue.length<=maxlength}}}}},minlengthDirective=function(){return{restrict:"A",require:"?ngModel",link:function(scope,elm,attr,ctrl){if(ctrl){var minlength=0;attr.$observe("minlength",function(value){minlength=int(value)||0,ctrl.$validate()}),ctrl.$validators.minlength=function(modelValue,viewValue){return ctrl.$isEmpty(viewValue)||viewValue.length>=minlength}}}}};return window.angular.bootstrap?void console.log("WARNING: Tried to load angular more than once."):(bindJQuery(),publishExternalAPI(angular),void jqLite(document).ready(function(){angularInit(document,bootstrap)}))}(window,document),!window.angular.$$csp()&&window.angular.element(document.head).prepend('<style type="text/css">@charset "UTF-8";[ng\\:cloak],[ng-cloak],[data-ng-cloak],[x-ng-cloak],.ng-cloak,.x-ng-cloak,.ng-hide:not(.ng-hide-animate){display:none !important;}ng\\:form{display:block;}</style>'),angular.module("ui.codemirror",[]).constant("uiCodemirrorConfig",{}).directive("uiCodemirror",["uiCodemirrorConfig",function(uiCodemirrorConfig){return{restrict:"EA",require:"?ngModel",priority:1,compile:function(){if(angular.isUndefined(window.CodeMirror))throw new Error("ui-codemirror need CodeMirror to work... (o rly?)");return function(scope,iElement,iAttrs,ngModel){var options,opts,codeMirror,initialTextValue;if(initialTextValue=iElement.text(),options=uiCodemirrorConfig.codemirror||{},opts=angular.extend({value:initialTextValue},options,scope.$eval(iAttrs.uiCodemirror),scope.$eval(iAttrs.uiCodemirrorOpts)),"TEXTAREA"===iElement[0].tagName?codeMirror=window.CodeMirror.fromTextArea(iElement[0],opts):(iElement.html(""),codeMirror=new window.CodeMirror(function(cm_el){iElement.append(cm_el)},opts)),iAttrs.uiCodemirror||iAttrs.uiCodemirrorOpts){var codemirrorDefaultsKeys=Object.keys(window.CodeMirror.defaults);scope.$watch(iAttrs.uiCodemirror||iAttrs.uiCodemirrorOpts,function(newValues,oldValue){angular.isObject(newValues)&&codemirrorDefaultsKeys.forEach(function(key){if(newValues.hasOwnProperty(key)){if(oldValue&&newValues[key]===oldValue[key])return;codeMirror.setOption(key,newValues[key])}})},!0)}ngModel&&(ngModel.$formatters.push(function(value){if(angular.isUndefined(value)||null===value)return"";if(angular.isObject(value)||angular.isArray(value))throw new Error("ui-codemirror cannot use an object or an array as a model");return value}),ngModel.$render=function(){var safeViewValue=ngModel.$viewValue||"";codeMirror.setValue(safeViewValue)},codeMirror.on("change",function(instance){var newValue=instance.getValue();newValue!==ngModel.$viewValue&&scope.$apply(function(){ngModel.$setViewValue(newValue)})})),iAttrs.uiRefresh&&scope.$watch(iAttrs.uiRefresh,function(newVal,oldVal){newVal!==oldVal&&codeMirror.refresh()}),scope.$on("CodeMirror",function(event,callback){if(!angular.isFunction(callback))throw new Error("the CodeMirror event requires a callback function");callback(codeMirror)}),angular.isFunction(opts.onLoad)&&opts.onLoad(codeMirror)}}}}]),function(){"use strict";"undefined"!=typeof module&&"object"==typeof exports&&(module.exports="hc.marked"),angular.module("hc.marked",[]).provider("marked",function(){var self=this;self.setRenderer=function(opts){this.renderer=opts},self.setOptions=function(opts){this.defaults=opts},self.$get=["$window","$log",function($window,$log){var m=function(){return"undefined"!=typeof module&&"object"==typeof exports?require("marked"):$window.marked||marked}();if(angular.isUndefined(m))return void $log.error("angular-marked Error: marked not loaded.  See installation instructions.");if(self.renderer){for(var r=new m.Renderer,o=Object.keys(self.renderer),l=o.length;l--;)r[o[l]]=self.renderer[o[l]];self.defaults=self.defaults||{},self.defaults.renderer=r}return m.setOptions(self.defaults),m}]}).directive("marked",["marked",function(marked){return{restrict:"AE",replace:!0,scope:{opts:"=",marked:"="},link:function(scope,element,attrs){function unindent(text){if(!text)return text;var i,l,line,lines=text.replace(/\t/g,"  ").split(/\r?\n/),min=null,len=lines.length;for(i=0;i<len;i++)line=lines[i],l=line.match(/^(\s*)/)[0].length,l!==line.length&&(min=l<min||null===min?l:min);if(null!==min&&min>0)for(i=0;i<len;i++)lines[i]=lines[i].substr(min);return lines.join("\n")}function set(text){text=unindent(text||""),element.html(marked(text,scope.opts||null))}set(scope.marked||element.text()||""),attrs.marked&&scope.$watch("marked",set)}}}])}(),function(module){function shouldHighlightStatics(attrs){var should=!0;return angular.forEach(["source","include"],function(name){attrs[name]&&(should=!1)}),should}var dirHljs,dirLanguageFactory,dirSourceFactory,dirIncludeFactory;module.provider("hljsService",function(){var _hljsOptions={};return{setOptions:function(options){angular.extend(_hljsOptions,options)},getOptions:function(){return angular.copy(_hljsOptions)},$get:["$window",function($window){return($window.hljs.configure||angular.noop)(_hljsOptions),$window.hljs}]}}).factory("hljsCache",["$cacheFactory",function($cacheFactory){return $cacheFactory("hljsCache")}]).controller("HljsCtrl",["hljsCache","hljsService",function(hljsCache,hljsService){var ctrl=this,_elm=null,_lang=null,_code=null,_hlCb=null;ctrl.init=function(codeElm){_elm=codeElm},ctrl.setLanguage=function(lang){_lang=lang,_code&&ctrl.highlight(_code)},ctrl.highlightCallback=function(cb){_hlCb=cb},ctrl.highlight=function(code){if(_elm){var res,cacheKey;_code=code,_lang?(cacheKey=ctrl._cacheKey(_lang,_code),res=hljsCache.get(cacheKey),res||(res=hljsService.highlight(_lang,hljsService.fixMarkup(_code),!0),hljsCache.put(cacheKey,res))):(cacheKey=ctrl._cacheKey(_code),res=hljsCache.get(cacheKey),res||(res=hljsService.highlightAuto(hljsService.fixMarkup(_code)),hljsCache.put(cacheKey,res))),_elm.html(res.value),_elm.addClass(res.language),null!==_hlCb&&angular.isFunction(_hlCb)&&_hlCb()}},ctrl.clear=function(){_elm&&(_code=null,_elm.text(""))},ctrl.release=function(){_elm=null},ctrl._cacheKey=function(){var args=Array.prototype.slice.call(arguments),glue="!angular-highlightjs!";return args.join(glue)}}]),dirHljs=["$compile","$parse",function($compile,$parse){return{restrict:"EA",controller:"HljsCtrl",compile:function(tElm,tAttrs,transclude){var staticHTML=tElm[0].innerHTML.replace(/^(\r\n|\r|\n)/m,""),staticText=tElm[0].textContent.replace(/^(\r\n|\r|\n)/m,"");return tElm.html('<pre><code class="hljs"></code></pre>'),function(scope,iElm,iAttrs,ctrl){var compileCheck,escapeCheck;if(angular.isDefined(iAttrs.compile)&&(compileCheck=$parse(iAttrs.compile)),angular.isDefined(iAttrs.escape)?escapeCheck=$parse(iAttrs.escape):angular.isDefined(iAttrs.noEscape)&&(escapeCheck=$parse("false")),ctrl.init(iElm.find("code")),iAttrs.onhighlight&&ctrl.highlightCallback(function(){scope.$eval(iAttrs.onhighlight)}),(staticHTML||staticText)&&shouldHighlightStatics(iAttrs)){var code;code=escapeCheck&&!escapeCheck(scope)?staticText:staticHTML,ctrl.highlight(code),compileCheck&&compileCheck(scope)&&$compile(iElm.find("code").contents())(scope)}scope.$on("$destroy",function(){ctrl.release()})}}}}],dirLanguageFactory=function(dirName){return[function(){return{require:"?hljs",restrict:"A",link:function(scope,iElm,iAttrs,ctrl){ctrl&&iAttrs.$observe(dirName,function(lang){angular.isDefined(lang)&&ctrl.setLanguage(lang)})}}}]},dirSourceFactory=function(dirName){return["$compile","$parse",function($compile,$parse){return{require:"?hljs",restrict:"A",link:function(scope,iElm,iAttrs,ctrl){var compileCheck;ctrl&&(angular.isDefined(iAttrs.compile)&&(compileCheck=$parse(iAttrs.compile)),scope.$watch(iAttrs[dirName],function(newCode,oldCode){newCode?(ctrl.highlight(newCode),compileCheck&&compileCheck(scope)&&$compile(iElm.find("code").contents())(scope)):ctrl.clear()}))}}}]},dirIncludeFactory=function(dirName){return["$http","$templateCache","$q","$compile","$parse",function($http,$templateCache,$q,$compile,$parse){return{require:"?hljs",restrict:"A",compile:function(tElm,tAttrs,transclude){var srcExpr=tAttrs[dirName];return function(scope,iElm,iAttrs,ctrl){var compileCheck,changeCounter=0;ctrl&&(angular.isDefined(iAttrs.compile)&&(compileCheck=$parse(iAttrs.compile)),scope.$watch(srcExpr,function(src){var thisChangeId=++changeCounter;if(src&&angular.isString(src)){var templateCachePromise,dfd;templateCachePromise=$templateCache.get(src),templateCachePromise||(dfd=$q.defer(),$http.get(src,{cache:$templateCache,transformResponse:function(data,headersGetter){return data}}).success(function(code){thisChangeId===changeCounter&&dfd.resolve(code)}).error(function(){thisChangeId===changeCounter&&ctrl.clear(),dfd.resolve()}),templateCachePromise=dfd.promise),$q.when(templateCachePromise).then(function(code){code&&(angular.isArray(code)?code=code[1]:angular.isObject(code)&&(code=code.data),code=code.replace(/^(\r\n|\r|\n)/m,""),ctrl.highlight(code),compileCheck&&compileCheck(scope)&&$compile(iElm.find("code").contents())(scope))})}else ctrl.clear()}))}}}}]},module.directive("hljs",dirHljs).directive("language",dirLanguageFactory("language")).directive("source",dirSourceFactory("source")).directive("include",dirIncludeFactory("include"))}(angular.module("hljs",[])),function(window,angular,undefined){"use strict";function $SanitizeProvider(){this.$get=["$$sanitizeUri",function($$sanitizeUri){return function(html){var buf=[];return htmlParser(html,htmlSanitizeWriter(buf,function(uri,isImage){return!/^unsafe/.test($$sanitizeUri(uri,isImage))})),buf.join("")}}]}function sanitizeText(chars){var buf=[],writer=htmlSanitizeWriter(buf,angular.noop);return writer.chars(chars),buf.join("")}function makeMap(str){var i,obj={},items=str.split(",");for(i=0;i<items.length;i++)obj[items[i]]=!0;return obj}function htmlParser(html,handler){function parseStartTag(tag,tagName,rest,unary){if(tagName=angular.lowercase(tagName),blockElements[tagName])for(;stack.last()&&inlineElements[stack.last()];)parseEndTag("",stack.last());optionalEndTagElements[tagName]&&stack.last()==tagName&&parseEndTag("",tagName),unary=voidElements[tagName]||!!unary,unary||stack.push(tagName);var attrs={};rest.replace(ATTR_REGEXP,function(match,name,doubleQuotedValue,singleQuotedValue,unquotedValue){var value=doubleQuotedValue||singleQuotedValue||unquotedValue||"";attrs[name]=decodeEntities(value)}),handler.start&&handler.start(tagName,attrs,unary)}function parseEndTag(tag,tagName){var i,pos=0;if(tagName=angular.lowercase(tagName))for(pos=stack.length-1;pos>=0&&stack[pos]!=tagName;pos--);if(pos>=0){for(i=stack.length-1;i>=pos;i--)handler.end&&handler.end(stack[i]);stack.length=pos}}"string"!=typeof html&&(html=null===html||"undefined"==typeof html?"":""+html);var index,chars,match,text,stack=[],last=html;for(stack.last=function(){return stack[stack.length-1]};html;){if(text="",chars=!0,stack.last()&&specialElements[stack.last()]?(html=html.replace(new RegExp("([\\W\\w]*)<\\s*\\/\\s*"+stack.last()+"[^>]*>","i"),function(all,text){return text=text.replace(COMMENT_REGEXP,"$1").replace(CDATA_REGEXP,"$1"),handler.chars&&handler.chars(decodeEntities(text)),""}),parseEndTag("",stack.last())):(0===html.indexOf("<!--")?(index=html.indexOf("--",4),index>=0&&html.lastIndexOf("-->",index)===index&&(handler.comment&&handler.comment(html.substring(4,index)),html=html.substring(index+3),chars=!1)):DOCTYPE_REGEXP.test(html)?(match=html.match(DOCTYPE_REGEXP),match&&(html=html.replace(match[0],""),chars=!1)):BEGING_END_TAGE_REGEXP.test(html)?(match=html.match(END_TAG_REGEXP),match&&(html=html.substring(match[0].length),match[0].replace(END_TAG_REGEXP,parseEndTag),chars=!1)):BEGIN_TAG_REGEXP.test(html)&&(match=html.match(START_TAG_REGEXP),match?(match[4]&&(html=html.substring(match[0].length),match[0].replace(START_TAG_REGEXP,parseStartTag)),chars=!1):(text+="<",html=html.substring(1))),chars&&(index=html.indexOf("<"),text+=index<0?html:html.substring(0,index),html=index<0?"":html.substring(index),handler.chars&&handler.chars(decodeEntities(text)))),html==last)throw $sanitizeMinErr("badparse","The sanitizer was unable to parse the following block of html: {0}",html);last=html}parseEndTag()}function decodeEntities(value){return value?(hiddenPre.innerHTML=value.replace(/</g,"&lt;"),hiddenPre.textContent):""}function encodeEntities(value){return value.replace(/&/g,"&amp;").replace(SURROGATE_PAIR_REGEXP,function(value){var hi=value.charCodeAt(0),low=value.charCodeAt(1);return"&#"+(1024*(hi-55296)+(low-56320)+65536)+";"}).replace(NON_ALPHANUMERIC_REGEXP,function(value){return"&#"+value.charCodeAt(0)+";"}).replace(/</g,"&lt;").replace(/>/g,"&gt;")}function htmlSanitizeWriter(buf,uriValidator){var ignore=!1,out=angular.bind(buf,buf.push);return{start:function(tag,attrs,unary){tag=angular.lowercase(tag),!ignore&&specialElements[tag]&&(ignore=tag),ignore||validElements[tag]!==!0||(out("<"),out(tag),angular.forEach(attrs,function(value,key){var lkey=angular.lowercase(key),isImage="img"===tag&&"src"===lkey||"background"===lkey;validAttrs[lkey]!==!0||uriAttrs[lkey]===!0&&!uriValidator(value,isImage)||(out(" "),out(key),out('="'),out(encodeEntities(value)),out('"'))}),out(unary?"/>":">"))},end:function(tag){tag=angular.lowercase(tag),ignore||validElements[tag]!==!0||(out("</"),out(tag),out(">")),tag==ignore&&(ignore=!1)},chars:function(chars){ignore||out(encodeEntities(chars))}}}var $sanitizeMinErr=angular.$$minErr("$sanitize"),START_TAG_REGEXP=/^<((?:[a-zA-Z])[\w:-]*)((?:\s+[\w:-]+(?:\s*=\s*(?:(?:"[^"]*")|(?:'[^']*')|[^>\s]+))?)*)\s*(\/?)\s*(>?)/,END_TAG_REGEXP=/^<\/\s*([\w:-]+)[^>]*>/,ATTR_REGEXP=/([\w:-]+)(?:\s*=\s*(?:(?:"((?:[^"])*)")|(?:'((?:[^'])*)')|([^>\s]+)))?/g,BEGIN_TAG_REGEXP=/^</,BEGING_END_TAGE_REGEXP=/^<\//,COMMENT_REGEXP=/<!--(.*?)-->/g,DOCTYPE_REGEXP=/<!DOCTYPE([^>]*?)>/i,CDATA_REGEXP=/<!\[CDATA\[(.*?)]]>/g,SURROGATE_PAIR_REGEXP=/[\uD800-\uDBFF][\uDC00-\uDFFF]/g,NON_ALPHANUMERIC_REGEXP=/([^\#-~| |!])/g,voidElements=makeMap("area,br,col,hr,img,wbr"),optionalEndTagBlockElements=makeMap("colgroup,dd,dt,li,p,tbody,td,tfoot,th,thead,tr"),optionalEndTagInlineElements=makeMap("rp,rt"),optionalEndTagElements=angular.extend({},optionalEndTagInlineElements,optionalEndTagBlockElements),blockElements=angular.extend({},optionalEndTagBlockElements,makeMap("address,article,aside,blockquote,caption,center,del,dir,div,dl,figure,figcaption,footer,h1,h2,h3,h4,h5,h6,header,hgroup,hr,ins,map,menu,nav,ol,pre,script,section,table,ul")),inlineElements=angular.extend({},optionalEndTagInlineElements,makeMap("a,abbr,acronym,b,bdi,bdo,big,br,cite,code,del,dfn,em,font,i,img,ins,kbd,label,map,mark,q,ruby,rp,rt,s,samp,small,span,strike,strong,sub,sup,time,tt,u,var")),svgElements=makeMap("animate,animateColor,animateMotion,animateTransform,circle,defs,desc,ellipse,font-face,font-face-name,font-face-src,g,glyph,hkern,image,linearGradient,line,marker,metadata,missing-glyph,mpath,path,polygon,polyline,radialGradient,rect,set,stop,svg,switch,text,title,tspan,use"),specialElements=makeMap("script,style"),validElements=angular.extend({},voidElements,blockElements,inlineElements,optionalEndTagElements,svgElements),uriAttrs=makeMap("background,cite,href,longdesc,src,usemap,xlink:href"),htmlAttrs=makeMap("abbr,align,alt,axis,bgcolor,border,cellpadding,cellspacing,class,clear,color,cols,colspan,compact,coords,dir,face,headers,height,hreflang,hspace,ismap,lang,language,nohref,nowrap,rel,rev,rows,rowspan,rules,scope,scrolling,shape,size,span,start,summary,target,title,type,valign,value,vspace,width"),svgAttrs=makeMap("accent-height,accumulate,additive,alphabetic,arabic-form,ascent,attributeName,attributeType,baseProfile,bbox,begin,by,calcMode,cap-height,class,color,color-rendering,content,cx,cy,d,dx,dy,descent,display,dur,end,fill,fill-rule,font-family,font-size,font-stretch,font-style,font-variant,font-weight,from,fx,fy,g1,g2,glyph-name,gradientUnits,hanging,height,horiz-adv-x,horiz-origin-x,ideographic,k,keyPoints,keySplines,keyTimes,lang,marker-end,marker-mid,marker-start,markerHeight,markerUnits,markerWidth,mathematical,max,min,offset,opacity,orient,origin,overline-position,overline-thickness,panose-1,path,pathLength,points,preserveAspectRatio,r,refX,refY,repeatCount,repeatDur,requiredExtensions,requiredFeatures,restart,rotate,rx,ry,slope,stemh,stemv,stop-color,stop-opacity,strikethrough-position,strikethrough-thickness,stroke,stroke-dasharray,stroke-dashoffset,stroke-linecap,stroke-linejoin,stroke-miterlimit,stroke-opacity,stroke-width,systemLanguage,target,text-anchor,to,transform,type,u1,u2,underline-position,underline-thickness,unicode,unicode-range,units-per-em,values,version,viewBox,visibility,width,widths,x,x-height,x1,x2,xlink:actuate,xlink:arcrole,xlink:role,xlink:show,xlink:title,xlink:type,xml:base,xml:lang,xml:space,xmlns,xmlns:xlink,y,y1,y2,zoomAndPan"),validAttrs=angular.extend({},uriAttrs,svgAttrs,htmlAttrs),hiddenPre=document.createElement("pre");
angular.module("ngSanitize",[]).provider("$sanitize",$SanitizeProvider),angular.module("ngSanitize").filter("linky",["$sanitize",function($sanitize){var LINKY_URL_REGEXP=/((ftp|https?):\/\/|(www\.)|(mailto:)?[A-Za-z0-9._%+-]+@)\S*[^\s.;,(){}<>"”’]/i,MAILTO_REGEXP=/^mailto:/i;return function(text,target){function addText(text){text&&html.push(sanitizeText(text))}function addLink(url,text){html.push("<a "),angular.isDefined(target)&&html.push('target="',target,'" '),html.push('href="',url.replace(/"/g,"&quot;"),'">'),addText(text),html.push("</a>")}if(!text)return text;for(var match,url,i,raw=text,html=[];match=raw.match(LINKY_URL_REGEXP);)url=match[0],match[2]||match[4]||(url=(match[3]?"http://":"mailto:")+url),i=match.index,addText(raw.substr(0,i)),addLink(url,match[0].replace(MAILTO_REGEXP,"")),raw=raw.substring(i+match[0].length);return addText(raw),$sanitize(html.join(""))}}])}(window,window.angular);var JSZip=function(data,options){this.files={},this.root="",data&&this.load(data,options)};JSZip.signature={LOCAL_FILE_HEADER:"PK",CENTRAL_FILE_HEADER:"PK",CENTRAL_DIRECTORY_END:"PK",ZIP64_CENTRAL_DIRECTORY_LOCATOR:"PK",ZIP64_CENTRAL_DIRECTORY_END:"PK",DATA_DESCRIPTOR:"PK\b"},JSZip.defaults={base64:!1,binary:!1,dir:!1,date:null,compression:null},JSZip.support={arraybuffer:function(){return"undefined"!=typeof ArrayBuffer&&"undefined"!=typeof Uint8Array}(),nodebuffer:function(){return"undefined"!=typeof Buffer}(),uint8array:function(){return"undefined"!=typeof Uint8Array}(),blob:function(){if("undefined"==typeof ArrayBuffer)return!1;var buffer=new ArrayBuffer(0);try{return 0===new Blob([buffer],{type:"application/zip"}).size}catch(e){}try{var BlobBuilder=window.BlobBuilder||window.WebKitBlobBuilder||window.MozBlobBuilder||window.MSBlobBuilder,builder=new BlobBuilder;return builder.append(buffer),0===builder.getBlob("application/zip").size}catch(e){}return!1}()},JSZip.prototype=function(){var textEncoder,textDecoder;JSZip.support.uint8array&&"function"==typeof TextEncoder&&"function"==typeof TextDecoder&&(textEncoder=new TextEncoder("utf-8"),textDecoder=new TextDecoder("utf-8"));var getRawData=function(file){if(file._data instanceof JSZip.CompressedObject&&(file._data=file._data.getContent(),file.options.binary=!0,file.options.base64=!1,"uint8array"===JSZip.utils.getTypeOf(file._data))){var copy=file._data;file._data=new Uint8Array(copy.length),0!==copy.length&&file._data.set(copy,0)}return file._data},getBinaryData=function(file){var result=getRawData(file),type=JSZip.utils.getTypeOf(result);if("string"===type){if(!file.options.binary){if(textEncoder)return textEncoder.encode(result);if(JSZip.support.nodebuffer)return new Buffer(result,"utf-8")}return file.asBinary()}return result},dataToString=function(asUTF8){var result=getRawData(this);return null===result||"undefined"==typeof result?"":(this.options.base64&&(result=JSZip.base64.decode(result)),result=asUTF8&&this.options.binary?JSZip.prototype.utf8decode(result):JSZip.utils.transformTo("string",result),asUTF8||this.options.binary||(result=JSZip.prototype.utf8encode(result)),result)},ZipObject=function(name,data,options){this.name=name,this._data=data,this.options=options};ZipObject.prototype={asText:function(){return dataToString.call(this,!0)},asBinary:function(){return dataToString.call(this,!1)},asNodeBuffer:function(){var result=getBinaryData(this);return JSZip.utils.transformTo("nodebuffer",result)},asUint8Array:function(){var result=getBinaryData(this);return JSZip.utils.transformTo("uint8array",result)},asArrayBuffer:function(){return this.asUint8Array().buffer}};var decToHex=function(dec,bytes){var i,hex="";for(i=0;i<bytes;i++)hex+=String.fromCharCode(255&dec),dec>>>=8;return hex},extend=function(){var i,attr,result={};for(i=0;i<arguments.length;i++)for(attr in arguments[i])arguments[i].hasOwnProperty(attr)&&"undefined"==typeof result[attr]&&(result[attr]=arguments[i][attr]);return result},prepareFileAttrs=function(o){return o=o||{},o.base64===!0&&null==o.binary&&(o.binary=!0),o=extend(o,JSZip.defaults),o.date=o.date||new Date,null!==o.compression&&(o.compression=o.compression.toUpperCase()),o},fileAdd=function(name,data,o){var parent=parentFolder(name),dataType=JSZip.utils.getTypeOf(data);if(parent&&folderAdd.call(this,parent),o=prepareFileAttrs(o),o.dir||null===data||"undefined"==typeof data)o.base64=!1,o.binary=!1,data=null;else if("string"===dataType)o.binary&&!o.base64&&o.optimizedBinaryString!==!0&&(data=JSZip.utils.string2binary(data));else{if(o.base64=!1,o.binary=!0,!(dataType||data instanceof JSZip.CompressedObject))throw new Error("The data of '"+name+"' is in an unsupported format !");"arraybuffer"===dataType&&(data=JSZip.utils.transformTo("uint8array",data))}var object=new ZipObject(name,data,o);return this.files[name]=object,object},parentFolder=function(path){"/"==path.slice(-1)&&(path=path.substring(0,path.length-1));var lastSlash=path.lastIndexOf("/");return lastSlash>0?path.substring(0,lastSlash):""},folderAdd=function(name){return"/"!=name.slice(-1)&&(name+="/"),this.files[name]||fileAdd.call(this,name,null,{dir:!0}),this.files[name]},generateCompressedObjectFrom=function(file,compression){var content,result=new JSZip.CompressedObject;return file._data instanceof JSZip.CompressedObject?(result.uncompressedSize=file._data.uncompressedSize,result.crc32=file._data.crc32,0===result.uncompressedSize||file.options.dir?(compression=JSZip.compressions.STORE,result.compressedContent="",result.crc32=0):file._data.compressionMethod===compression.magic?result.compressedContent=file._data.getCompressedContent():(content=file._data.getContent(),result.compressedContent=compression.compress(JSZip.utils.transformTo(compression.compressInputType,content)))):(content=getBinaryData(file),content&&0!==content.length&&!file.options.dir||(compression=JSZip.compressions.STORE,content=""),result.uncompressedSize=content.length,result.crc32=this.crc32(content),result.compressedContent=compression.compress(JSZip.utils.transformTo(compression.compressInputType,content))),result.compressedSize=result.compressedContent.length,result.compressionMethod=compression.magic,result},generateZipParts=function(name,file,compressedObject,offset){var dosTime,dosDate,utfEncodedFileName=(compressedObject.compressedContent,this.utf8encode(file.name)),useUTF8=utfEncodedFileName!==file.name,o=file.options;dosTime=o.date.getHours(),dosTime<<=6,dosTime|=o.date.getMinutes(),dosTime<<=5,dosTime|=o.date.getSeconds()/2,dosDate=o.date.getFullYear()-1980,dosDate<<=4,dosDate|=o.date.getMonth()+1,dosDate<<=5,dosDate|=o.date.getDate();var header="";header+="\n\0",header+=useUTF8?"\0\b":"\0\0",header+=compressedObject.compressionMethod,header+=decToHex(dosTime,2),header+=decToHex(dosDate,2),header+=decToHex(compressedObject.crc32,4),header+=decToHex(compressedObject.compressedSize,4),header+=decToHex(compressedObject.uncompressedSize,4),header+=decToHex(utfEncodedFileName.length,2),header+="\0\0";var fileRecord=JSZip.signature.LOCAL_FILE_HEADER+header+utfEncodedFileName,dirRecord=JSZip.signature.CENTRAL_FILE_HEADER+"\0"+header+"\0\0\0\0\0\0"+(file.options.dir===!0?"\0\0\0":"\0\0\0\0")+decToHex(offset,4)+utfEncodedFileName;return{fileRecord:fileRecord,dirRecord:dirRecord,compressedObject:compressedObject}},StringWriter=function(){this.data=[]};StringWriter.prototype={append:function(input){input=JSZip.utils.transformTo("string",input),this.data.push(input)},finalize:function(){return this.data.join("")}};var Uint8ArrayWriter=function(length){this.data=new Uint8Array(length),this.index=0};return Uint8ArrayWriter.prototype={append:function(input){0!==input.length&&(input=JSZip.utils.transformTo("uint8array",input),this.data.set(input,this.index),this.index+=input.length)},finalize:function(){return this.data}},{load:function(stream,options){throw new Error("Load method is not defined. Is the file jszip-load.js included ?")},filter:function(search){var filename,relativePath,file,fileClone,result=[];for(filename in this.files)this.files.hasOwnProperty(filename)&&(file=this.files[filename],fileClone=new ZipObject(file.name,file._data,extend(file.options)),relativePath=filename.slice(this.root.length,filename.length),filename.slice(0,this.root.length)===this.root&&search(relativePath,fileClone)&&result.push(fileClone));return result},file:function(name,data,o){if(1===arguments.length){if(JSZip.utils.isRegExp(name)){var regexp=name;return this.filter(function(relativePath,file){return!file.options.dir&&regexp.test(relativePath)})}return this.filter(function(relativePath,file){return!file.options.dir&&relativePath===name})[0]||null}return name=this.root+name,fileAdd.call(this,name,data,o),this},folder:function(arg){if(!arg)return this;if(JSZip.utils.isRegExp(arg))return this.filter(function(relativePath,file){return file.options.dir&&arg.test(relativePath)});var name=this.root+arg,newFolder=folderAdd.call(this,name),ret=this.clone();return ret.root=newFolder.name,ret},remove:function(name){name=this.root+name;var file=this.files[name];if(file||("/"!=name.slice(-1)&&(name+="/"),file=this.files[name]),file)if(file.options.dir)for(var kids=this.filter(function(relativePath,file){return file.name.slice(0,name.length)===name}),i=0;i<kids.length;i++)delete this.files[kids[i].name];else delete this.files[name];return this},generate:function(options){options=extend(options||{},{base64:!0,compression:"STORE",type:"base64"}),JSZip.utils.checkSupport(options.type);var writer,i,zipData=[],localDirLength=0,centralDirLength=0;for(var name in this.files)if(this.files.hasOwnProperty(name)){var file=this.files[name],compressionName=file.options.compression||options.compression.toUpperCase(),compression=JSZip.compressions[compressionName];if(!compression)throw new Error(compressionName+" is not a valid compression method !");var compressedObject=generateCompressedObjectFrom.call(this,file,compression),zipPart=generateZipParts.call(this,name,file,compressedObject,localDirLength);localDirLength+=zipPart.fileRecord.length+compressedObject.compressedSize,centralDirLength+=zipPart.dirRecord.length,zipData.push(zipPart)}var dirEnd="";switch(dirEnd=JSZip.signature.CENTRAL_DIRECTORY_END+"\0\0\0\0"+decToHex(zipData.length,2)+decToHex(zipData.length,2)+decToHex(centralDirLength,4)+decToHex(localDirLength,4)+"\0\0",options.type.toLowerCase()){case"uint8array":case"arraybuffer":case"blob":case"nodebuffer":writer=new Uint8ArrayWriter(localDirLength+centralDirLength+dirEnd.length);break;default:writer=new StringWriter(localDirLength+centralDirLength+dirEnd.length)}for(i=0;i<zipData.length;i++)writer.append(zipData[i].fileRecord),writer.append(zipData[i].compressedObject.compressedContent);for(i=0;i<zipData.length;i++)writer.append(zipData[i].dirRecord);writer.append(dirEnd);var zip=writer.finalize();switch(options.type.toLowerCase()){case"uint8array":case"arraybuffer":case"nodebuffer":return JSZip.utils.transformTo(options.type.toLowerCase(),zip);case"blob":return JSZip.utils.arrayBuffer2Blob(JSZip.utils.transformTo("arraybuffer",zip));case"base64":return options.base64?JSZip.base64.encode(zip):zip;default:return zip}},crc32:function(input,crc){if("undefined"==typeof input||!input.length)return 0;var isArray="string"!==JSZip.utils.getTypeOf(input),table=[0,1996959894,3993919788,2567524794,124634137,1886057615,3915621685,2657392035,249268274,2044508324,3772115230,2547177864,162941995,2125561021,3887607047,2428444049,498536548,1789927666,4089016648,2227061214,450548861,1843258603,4107580753,2211677639,325883990,1684777152,4251122042,2321926636,335633487,1661365465,4195302755,2366115317,997073096,1281953886,3579855332,2724688242,1006888145,1258607687,3524101629,2768942443,901097722,1119000684,3686517206,2898065728,853044451,1172266101,3705015759,2882616665,651767980,1373503546,3369554304,3218104598,565507253,1454621731,3485111705,3099436303,671266974,1594198024,3322730930,2970347812,795835527,1483230225,3244367275,3060149565,1994146192,31158534,2563907772,4023717930,1907459465,112637215,2680153253,3904427059,2013776290,251722036,2517215374,3775830040,2137656763,141376813,2439277719,3865271297,1802195444,476864866,2238001368,4066508878,1812370925,453092731,2181625025,4111451223,1706088902,314042704,2344532202,4240017532,1658658271,366619977,2362670323,4224994405,1303535960,984961486,2747007092,3569037538,1256170817,1037604311,2765210733,3554079995,1131014506,879679996,2909243462,3663771856,1141124467,855842277,2852801631,3708648649,1342533948,654459306,3188396048,3373015174,1466479909,544179635,3110523913,3462522015,1591671054,702138776,2966460450,3352799412,1504918807,783551873,3082640443,3233442989,3988292384,2596254646,62317068,1957810842,3939845945,2647816111,81470997,1943803523,3814918930,2489596804,225274430,2053790376,3826175755,2466906013,167816743,2097651377,4027552580,2265490386,503444072,1762050814,4150417245,2154129355,426522225,1852507879,4275313526,2312317920,282753626,1742555852,4189708143,2394877945,397917763,1622183637,3604390888,2714866558,953729732,1340076626,3518719985,2797360999,1068828381,1219638859,3624741850,2936675148,906185462,1090812512,3747672003,2825379669,829329135,1181335161,3412177804,3160834842,628085408,1382605366,3423369109,3138078467,570562233,1426400815,3317316542,2998733608,733239954,1555261956,3268935591,3050360625,752459403,1541320221,2607071920,3965973030,1969922972,40735498,2617837225,3943577151,1913087877,83908371,2512341634,3803740692,2075208622,213261112,2463272603,3855990285,2094854071,198958881,2262029012,4057260610,1759359992,534414190,2176718541,4139329115,1873836001,414664567,2282248934,4279200368,1711684554,285281116,2405801727,4167216745,1634467795,376229701,2685067896,3608007406,1308918612,956543938,2808555105,3495958263,1231636301,1047427035,2932959818,3654703836,1088359270,936918e3,2847714899,3736837829,1202900863,817233897,3183342108,3401237130,1404277552,615818150,3134207493,3453421203,1423857449,601450431,3009837614,3294710456,1567103746,711928724,3020668471,3272380065,1510334235,755167117];"undefined"==typeof crc&&(crc=0);var x=0,y=0,byte=0;crc^=-1;for(var i=0,iTop=input.length;i<iTop;i++)byte=isArray?input[i]:input.charCodeAt(i),y=255&(crc^byte),x=table[y],crc=crc>>>8^x;return crc^-1},clone:function(){var newObj=new JSZip;for(var i in this)"function"!=typeof this[i]&&(newObj[i]=this[i]);return newObj},utf8encode:function(string){if(textEncoder){var u8=textEncoder.encode(string);return JSZip.utils.transformTo("string",u8)}if(JSZip.support.nodebuffer)return JSZip.utils.transformTo("string",new Buffer(string,"utf-8"));for(var result=[],resIndex=0,n=0;n<string.length;n++){var c=string.charCodeAt(n);c<128?result[resIndex++]=String.fromCharCode(c):c>127&&c<2048?(result[resIndex++]=String.fromCharCode(c>>6|192),result[resIndex++]=String.fromCharCode(63&c|128)):(result[resIndex++]=String.fromCharCode(c>>12|224),result[resIndex++]=String.fromCharCode(c>>6&63|128),result[resIndex++]=String.fromCharCode(63&c|128))}return result.join("")},utf8decode:function(input){var result=[],resIndex=0,type=JSZip.utils.getTypeOf(input),isArray="string"!==type,i=0,c=0,c2=0,c3=0;if(textDecoder)return textDecoder.decode(JSZip.utils.transformTo("uint8array",input));if(JSZip.support.nodebuffer)return JSZip.utils.transformTo("nodebuffer",input).toString("utf-8");for(;i<input.length;)c=isArray?input[i]:input.charCodeAt(i),c<128?(result[resIndex++]=String.fromCharCode(c),i++):c>191&&c<224?(c2=isArray?input[i+1]:input.charCodeAt(i+1),result[resIndex++]=String.fromCharCode((31&c)<<6|63&c2),i+=2):(c2=isArray?input[i+1]:input.charCodeAt(i+1),c3=isArray?input[i+2]:input.charCodeAt(i+2),result[resIndex++]=String.fromCharCode((15&c)<<12|(63&c2)<<6|63&c3),i+=3);return result.join("")}}}(),JSZip.compressions={STORE:{magic:"\0\0",compress:function(content){return content},uncompress:function(content){return content},compressInputType:null,uncompressInputType:null}},function(){function identity(input){return input}function stringToArrayLike(str,array){for(var i=0;i<str.length;++i)array[i]=255&str.charCodeAt(i);return array}function arrayLikeToString(array){var chunk=65536,result=[],len=array.length,type=JSZip.utils.getTypeOf(array),k=0,canUseApply=!0;try{switch(type){case"uint8array":String.fromCharCode.apply(null,new Uint8Array(0));break;case"nodebuffer":String.fromCharCode.apply(null,new Buffer(0))}}catch(e){canUseApply=!1}if(!canUseApply){for(var resultStr="",i=0;i<array.length;i++)resultStr+=String.fromCharCode(array[i]);return resultStr}for(;k<len&&chunk>1;)try{"array"===type||"nodebuffer"===type?result.push(String.fromCharCode.apply(null,array.slice(k,Math.min(k+chunk,len)))):result.push(String.fromCharCode.apply(null,array.subarray(k,Math.min(k+chunk,len)))),k+=chunk}catch(e){chunk=Math.floor(chunk/2)}return result.join("")}function arrayLikeToArrayLike(arrayFrom,arrayTo){for(var i=0;i<arrayFrom.length;i++)arrayTo[i]=arrayFrom[i];return arrayTo}JSZip.utils={string2binary:function(str){for(var result="",i=0;i<str.length;i++)result+=String.fromCharCode(255&str.charCodeAt(i));return result},string2Uint8Array:function(str){return JSZip.utils.transformTo("uint8array",str)},uint8Array2String:function(array){return JSZip.utils.transformTo("string",array)},arrayBuffer2Blob:function(buffer){JSZip.utils.checkSupport("blob");try{return new Blob([buffer],{type:"application/zip"})}catch(e){}try{var BlobBuilder=window.BlobBuilder||window.WebKitBlobBuilder||window.MozBlobBuilder||window.MSBlobBuilder,builder=new BlobBuilder;return builder.append(buffer),builder.getBlob("application/zip")}catch(e){}throw new Error("Bug : can't construct the Blob.")},string2Blob:function(str){var buffer=JSZip.utils.transformTo("arraybuffer",str);return JSZip.utils.arrayBuffer2Blob(buffer)}};var transform={};transform.string={string:identity,array:function(input){return stringToArrayLike(input,new Array(input.length))},arraybuffer:function(input){return transform.string.uint8array(input).buffer},uint8array:function(input){return stringToArrayLike(input,new Uint8Array(input.length))},nodebuffer:function(input){return stringToArrayLike(input,new Buffer(input.length))}},transform.array={string:arrayLikeToString,array:identity,arraybuffer:function(input){return new Uint8Array(input).buffer},uint8array:function(input){return new Uint8Array(input)},nodebuffer:function(input){return new Buffer(input)}},transform.arraybuffer={string:function(input){return arrayLikeToString(new Uint8Array(input))},array:function(input){return arrayLikeToArrayLike(new Uint8Array(input),new Array(input.byteLength))},arraybuffer:identity,uint8array:function(input){return new Uint8Array(input)},nodebuffer:function(input){return new Buffer(new Uint8Array(input))}},transform.uint8array={string:arrayLikeToString,array:function(input){return arrayLikeToArrayLike(input,new Array(input.length))},arraybuffer:function(input){return input.buffer},uint8array:identity,nodebuffer:function(input){return new Buffer(input)}},transform.nodebuffer={string:arrayLikeToString,array:function(input){return arrayLikeToArrayLike(input,new Array(input.length))},arraybuffer:function(input){return transform.nodebuffer.uint8array(input).buffer},uint8array:function(input){return arrayLikeToArrayLike(input,new Uint8Array(input.length))},nodebuffer:identity},JSZip.utils.transformTo=function(outputType,input){if(input||(input=""),!outputType)return input;JSZip.utils.checkSupport(outputType);var inputType=JSZip.utils.getTypeOf(input),result=transform[inputType][outputType](input);return result},JSZip.utils.getTypeOf=function(input){return"string"==typeof input?"string":"[object Array]"===Object.prototype.toString.call(input)?"array":JSZip.support.nodebuffer&&Buffer.isBuffer(input)?"nodebuffer":JSZip.support.uint8array&&input instanceof Uint8Array?"uint8array":JSZip.support.arraybuffer&&input instanceof ArrayBuffer?"arraybuffer":void 0},JSZip.utils.isRegExp=function(object){return"[object RegExp]"===Object.prototype.toString.call(object)},JSZip.utils.checkSupport=function(type){var supported=!0;switch(type.toLowerCase()){case"uint8array":supported=JSZip.support.uint8array;break;case"arraybuffer":supported=JSZip.support.arraybuffer;break;case"nodebuffer":supported=JSZip.support.nodebuffer;break;case"blob":supported=JSZip.support.blob}if(!supported)throw new Error(type+" is not supported by this browser")}}(),function(){JSZip.CompressedObject=function(){this.compressedSize=0,this.uncompressedSize=0,this.crc32=0,this.compressionMethod=null,this.compressedContent=null},JSZip.CompressedObject.prototype={getContent:function(){return null},getCompressedContent:function(){return null}}}(),JSZip.base64=function(){var _keyStr="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";return{encode:function(input,utf8){for(var chr1,chr2,chr3,enc1,enc2,enc3,enc4,output="",i=0;i<input.length;)chr1=input.charCodeAt(i++),chr2=input.charCodeAt(i++),chr3=input.charCodeAt(i++),enc1=chr1>>2,enc2=(3&chr1)<<4|chr2>>4,enc3=(15&chr2)<<2|chr3>>6,enc4=63&chr3,isNaN(chr2)?enc3=enc4=64:isNaN(chr3)&&(enc4=64),output=output+_keyStr.charAt(enc1)+_keyStr.charAt(enc2)+_keyStr.charAt(enc3)+_keyStr.charAt(enc4);return output},decode:function(input,utf8){var chr1,chr2,chr3,enc1,enc2,enc3,enc4,output="",i=0;for(input=input.replace(/[^A-Za-z0-9\+\/\=]/g,"");i<input.length;)enc1=_keyStr.indexOf(input.charAt(i++)),enc2=_keyStr.indexOf(input.charAt(i++)),enc3=_keyStr.indexOf(input.charAt(i++)),enc4=_keyStr.indexOf(input.charAt(i++)),chr1=enc1<<2|enc2>>4,chr2=(15&enc2)<<4|enc3>>2,chr3=(3&enc3)<<6|enc4,output+=String.fromCharCode(chr1),64!=enc3&&(output+=String.fromCharCode(chr2)),64!=enc4&&(output+=String.fromCharCode(chr3));return output}}}(),function(root){function symbols(code){return _symbols?_symbols[code]:(_symbols=require("unicode/category/So"),removelist=["sign","cross","of","symbol","staff","hand","black","white"].map(function(word){return new RegExp(word,"gi")}),_symbols[code])}function slug(string,opts){opts=opts||{},string=string.toString(),"string"==typeof opts&&(opts={replacement:opts}),opts.mode=opts.mode||slug.defaults.mode;var defaults=slug.defaults.modes[opts.mode];["replacement","multicharmap","charmap","remove"].forEach(function(key){opts[key]=opts[key]||defaults[key]}),"undefined"==typeof opts.symbols&&(opts.symbols=defaults.symbols);var lengths=[];Object.keys(opts.multicharmap).forEach(function(key){var len=key.length;lengths.indexOf(len)===-1&&lengths.push(len)});for(var code,unicode,char,result="",i=0,l=string.length;i<l;i++){if(char=string[i],!lengths.some(function(len){var str=string.substr(i,len);return!!opts.multicharmap[str]&&(i+=len-1,char=opts.multicharmap[str],!0)})&&(opts.charmap[char]?(char=opts.charmap[char],code=char.charCodeAt(0)):code=string.charCodeAt(i),opts.symbols&&(unicode=symbols(code)))){char=unicode.name.toLowerCase();for(var j=0,rl=removelist.length;j<rl;j++)char=char.replace(removelist[j],"");char=char.replace(/^\s+|\s+$/g,"")}char=char.replace(/[^\w\s\-\.\_~]/g,""),opts.remove&&(char=char.replace(opts.remove,"")),result+=char}return result=result.replace(/^\s+|\s+$/g,""),result=result.replace(/[-\s]+/g,opts.replacement),result.replace(opts.replacement+"$","")}var _symbols,removelist;slug.defaults={mode:"pretty"},slug.multicharmap=slug.defaults.multicharmap={"<3":"love","&&":"and","||":"or","w/":"with"},slug.charmap=slug.defaults.charmap={"À":"A","Á":"A","Â":"A","Ã":"A","Ä":"A","Å":"A","Æ":"AE","Ç":"C","È":"E","É":"E","Ê":"E","Ë":"E","Ì":"I","Í":"I","Î":"I","Ï":"I","Ð":"D","Ñ":"N","Ò":"O","Ó":"O","Ô":"O","Õ":"O","Ö":"O","Ő":"O","Ø":"O","Ù":"U","Ú":"U","Û":"U","Ü":"U","Ű":"U","Ý":"Y","Þ":"TH","ß":"ss","à":"a","á":"a","â":"a","ã":"a","ä":"a","å":"a","æ":"ae","ç":"c","è":"e","é":"e","ê":"e","ë":"e","ì":"i","í":"i","î":"i","ï":"i","ð":"d","ñ":"n","ò":"o","ó":"o","ô":"o","õ":"o","ö":"o","ő":"o","ø":"o","ù":"u","ú":"u","û":"u","ü":"u","ű":"u","ý":"y","þ":"th","ÿ":"y","ẞ":"SS","α":"a","β":"b","γ":"g","δ":"d","ε":"e","ζ":"z","η":"h","θ":"8","ι":"i","κ":"k","λ":"l","μ":"m","ν":"n","ξ":"3","ο":"o","π":"p","ρ":"r","σ":"s","τ":"t","υ":"y","φ":"f","χ":"x","ψ":"ps","ω":"w","ά":"a","έ":"e","ί":"i","ό":"o","ύ":"y","ή":"h","ώ":"w","ς":"s","ϊ":"i","ΰ":"y","ϋ":"y","ΐ":"i","Α":"A","Β":"B","Γ":"G","Δ":"D","Ε":"E","Ζ":"Z","Η":"H","Θ":"8","Ι":"I","Κ":"K","Λ":"L","Μ":"M","Ν":"N","Ξ":"3","Ο":"O","Π":"P","Ρ":"R","Σ":"S","Τ":"T","Υ":"Y","Φ":"F","Χ":"X","Ψ":"PS","Ω":"W","Ά":"A","Έ":"E","Ί":"I","Ό":"O","Ύ":"Y","Ή":"H","Ώ":"W","Ϊ":"I","Ϋ":"Y","ş":"s","Ş":"S","ı":"i","İ":"I","ğ":"g","Ğ":"G","а":"a","б":"b","в":"v","г":"g","д":"d","е":"e","ё":"yo","ж":"zh","з":"z","и":"i","й":"j","к":"k","л":"l","м":"m","н":"n","о":"o","п":"p","р":"r","с":"s","т":"t","у":"u","ф":"f","х":"h","ц":"c","ч":"ch","ш":"sh","щ":"sh","ъ":"u","ы":"y","ь":"","э":"e","ю":"yu","я":"ya","А":"A","Б":"B","В":"V","Г":"G","Д":"D","Е":"E","Ё":"Yo","Ж":"Zh","З":"Z","И":"I","Й":"J","К":"K","Л":"L","М":"M","Н":"N","О":"O","П":"P","Р":"R","С":"S","Т":"T","У":"U","Ф":"F","Х":"H","Ц":"C","Ч":"Ch","Ш":"Sh","Щ":"Sh","Ъ":"U","Ы":"Y","Ь":"","Э":"E","Ю":"Yu","Я":"Ya","Є":"Ye","І":"I","Ї":"Yi","Ґ":"G","є":"ye","і":"i","ї":"yi","ґ":"g","č":"c","ď":"d","ě":"e","ň":"n","ř":"r","š":"s","ť":"t","ů":"u","ž":"z","Č":"C","Ď":"D","Ě":"E","Ň":"N","Ř":"R","Š":"S","Ť":"T","Ů":"U","Ž":"Z","ą":"a","ć":"c","ę":"e","ł":"l","ń":"n","ś":"s","ź":"z","ż":"z","Ą":"A","Ć":"C","Ę":"E","Ł":"L","Ń":"N","Ś":"S","Ź":"Z","Ż":"Z","ā":"a","ē":"e","ģ":"g","ī":"i","ķ":"k","ļ":"l","ņ":"n","ū":"u","Ā":"A","Ē":"E","Ģ":"G","Ī":"I","Ķ":"K","Ļ":"L","Ņ":"N","Ū":"U","ė":"e","į":"i","ų":"u","Ė":"E","Į":"I","Ų":"U","ț":"t","Ț":"T","ţ":"t","Ţ":"T","ș":"s","Ș":"S","ă":"a","Ă":"A","€":"euro","₢":"cruzeiro","₣":"french franc","£":"pound","₤":"lira","₥":"mill","₦":"naira","₧":"peseta","₨":"rupee","₩":"won","₪":"new shequel","₫":"dong","₭":"kip","₮":"tugrik","₯":"drachma","₰":"penny","₱":"peso","₲":"guarani","₳":"austral","₴":"hryvnia","₵":"cedi","¢":"cent","¥":"yen","元":"yuan","円":"yen","﷼":"rial","₠":"ecu","¤":"currency","฿":"baht",$:"dollar","₹":"indian rupee","©":"(c)","œ":"oe","Œ":"OE","∑":"sum","®":"(r)","†":"+","“":'"',"”":'"',"‘":"'","’":"'","∂":"d","ƒ":"f","™":"tm","℠":"sm","…":"...","˚":"o","º":"o","ª":"a","•":"*","∆":"delta","∞":"infinity","♥":"love","&":"and","|":"or","<":"less",">":"greater"},slug.defaults.modes={rfc3986:{replacement:"-",symbols:!0,remove:null,charmap:slug.defaults.charmap,multicharmap:slug.defaults.multicharmap},pretty:{replacement:"-",symbols:!0,remove:/[.]/g,charmap:slug.defaults.charmap,multicharmap:slug.defaults.multicharmap}},"undefined"!=typeof define&&define.amd?(Object.keys(slug.defaults.modes).forEach(function(key){slug.defaults.modes[key].symbols=!1}),define([],function(){return slug})):"undefined"!=typeof module&&module.exports?(symbols(),module.exports=slug):(Object.keys(slug.defaults.modes).forEach(function(key){slug.defaults.modes[key].symbols=!1}),root.slug=slug)}(this);var saveAs=saveAs||function(view){"use strict";if("undefined"==typeof navigator||!/MSIE [1-9]\./.test(navigator.userAgent)){var doc=view.document,get_URL=function(){return view.URL||view.webkitURL||view},save_link=doc.createElementNS("http://www.w3.org/1999/xhtml","a"),can_use_save_link="download"in save_link,click=function(node){var event=new MouseEvent("click");node.dispatchEvent(event)},is_safari=/Version\/[\d\.]+.*Safari/.test(navigator.userAgent),webkit_req_fs=view.webkitRequestFileSystem,req_fs=view.requestFileSystem||webkit_req_fs||view.mozRequestFileSystem,throw_outside=function(ex){(view.setImmediate||view.setTimeout)(function(){throw ex},0)},force_saveable_type="application/octet-stream",fs_min_size=0,arbitrary_revoke_timeout=4e4,revoke=function(file){var revoker=function(){"string"==typeof file?get_URL().revokeObjectURL(file):file.remove()};setTimeout(revoker,arbitrary_revoke_timeout)},dispatch=function(filesaver,event_types,event){event_types=[].concat(event_types);for(var i=event_types.length;i--;){var listener=filesaver["on"+event_types[i]];if("function"==typeof listener)try{listener.call(filesaver,event||filesaver)}catch(ex){throw_outside(ex)}}},auto_bom=function(blob){return/^\s*(?:text\/\S*|application\/xml|\S*\/\S*\+xml)\s*;.*charset\s*=\s*utf-8/i.test(blob.type)?new Blob(["\ufeff",blob],{type:blob.type}):blob},FileSaver=function(blob,name,no_auto_bom){no_auto_bom||(blob=auto_bom(blob));var object_url,target_view,slice,filesaver=this,type=blob.type,blob_changed=!1,dispatch_all=function(){dispatch(filesaver,"writestart progress write writeend".split(" "))},fs_error=function(){if(target_view&&is_safari&&"undefined"!=typeof FileReader){var reader=new FileReader;return reader.onloadend=function(){var base64Data=reader.result;target_view.location.href="data:attachment/file"+base64Data.slice(base64Data.search(/[,;]/)),filesaver.readyState=filesaver.DONE,dispatch_all()},reader.readAsDataURL(blob),void(filesaver.readyState=filesaver.INIT)}if(!blob_changed&&object_url||(object_url=get_URL().createObjectURL(blob)),target_view)target_view.location.href=object_url;else{var new_tab=view.open(object_url,"_blank");void 0===new_tab&&is_safari&&(view.location.href=object_url)}filesaver.readyState=filesaver.DONE,dispatch_all(),revoke(object_url)},abortable=function(func){return function(){if(filesaver.readyState!==filesaver.DONE)return func.apply(this,arguments)}},create_if_not_found={create:!0,exclusive:!1};return filesaver.readyState=filesaver.INIT,name||(name="download"),can_use_save_link?(object_url=get_URL().createObjectURL(blob),void setTimeout(function(){save_link.href=object_url,save_link.download=name,click(save_link),dispatch_all(),revoke(object_url),filesaver.readyState=filesaver.DONE})):(view.chrome&&type&&type!==force_saveable_type&&(slice=blob.slice||blob.webkitSlice,blob=slice.call(blob,0,blob.size,force_saveable_type),blob_changed=!0),webkit_req_fs&&"download"!==name&&(name+=".download"),(type===force_saveable_type||webkit_req_fs)&&(target_view=view),req_fs?(fs_min_size+=blob.size,void req_fs(view.TEMPORARY,fs_min_size,abortable(function(fs){fs.root.getDirectory("saved",create_if_not_found,abortable(function(dir){var save=function(){dir.getFile(name,create_if_not_found,abortable(function(file){file.createWriter(abortable(function(writer){writer.onwriteend=function(event){target_view.location.href=file.toURL(),filesaver.readyState=filesaver.DONE,dispatch(filesaver,"writeend",event),revoke(file)},writer.onerror=function(){var error=writer.error;error.code!==error.ABORT_ERR&&fs_error()},"writestart progress write abort".split(" ").forEach(function(event){writer["on"+event]=filesaver["on"+event]}),writer.write(blob),filesaver.abort=function(){writer.abort(),filesaver.readyState=filesaver.DONE},filesaver.readyState=filesaver.WRITING}),fs_error)}),fs_error)};dir.getFile(name,{create:!1},abortable(function(file){file.remove(),save()}),abortable(function(ex){ex.code===ex.NOT_FOUND_ERR?save():fs_error()}))}),fs_error)}),fs_error)):void fs_error())},FS_proto=FileSaver.prototype,saveAs=function(blob,name,no_auto_bom){return new FileSaver(blob,name,no_auto_bom)};return"undefined"!=typeof navigator&&navigator.msSaveOrOpenBlob?function(blob,name,no_auto_bom){return no_auto_bom||(blob=auto_bom(blob)),navigator.msSaveOrOpenBlob(blob,name||"download")}:(FS_proto.abort=function(){var filesaver=this;filesaver.readyState=filesaver.DONE,dispatch(filesaver,"abort")},FS_proto.readyState=FS_proto.INIT=0,FS_proto.WRITING=1,FS_proto.DONE=2,FS_proto.error=FS_proto.onwritestart=FS_proto.onprogress=FS_proto.onwrite=FS_proto.onabort=FS_proto.onerror=FS_proto.onwriteend=null,saveAs)}}("undefined"!=typeof self&&self||"undefined"!=typeof window&&window||this.content);"undefined"!=typeof module&&module.exports?module.exports.saveAs=saveAs:"undefined"!=typeof define&&null!==define&&null!==define.amd&&define([],function(){return saveAs}),!function(e){if("object"==typeof exports&&"undefined"!=typeof module)module.exports=e();else if("function"==typeof define&&define.amd)define([],e);else{var n;"undefined"!=typeof window?n=window:"undefined"!=typeof global?n=global:"undefined"!=typeof self&&(n=self),
n.ramlClientGenerator=e()}}(function(){var define;return function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a="function"==typeof require&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}for(var i="function"==typeof require&&require,o=0;o<r.length;o++)s(r[o]);return s}({1:[function(require,module,exports){function mapDeps(deps,env){return env?deps.map(function(dep){return DEPS_MAP[env][dep]}):deps}var DEPS_MAP={node:{popsicle:"require('popsicle')",ClientOAuth2:"require('client-oauth2')"},amd:{popsicle:"'popsicle'",ClientOAuth2:"'ClientOAuth2'"},browser:{popsicle:"root.popsicle",ClientOAuth2:"root.ClientOAuth2"}};module.exports=function(context,env){var deps=["popsicle"];return context.security["OAuth 2.0"]&&deps.push("ClientOAuth2"),"amd"===env?"["+mapDeps(deps,env).join(", ")+"]":mapDeps(deps,env).join(", ")}},{}],2:[function(require,module,exports){module.exports=function(parameters){return Object.keys(parameters).map(function(key){var parameter=parameters[key],title="* **"+parameter.displayName+"**",options=[];return parameter.type&&options.push(parameter.type),Array.isArray(parameter.enum)&&parameter.enum.length&&options.push("one of ("+parameter.enum.join(", ")+")"),parameter.default&&options.push("default: "+parameter.default),title+(options.length?" _"+options.join(", ")+"_":"")+(parameter.description?"\n\n"+parameter.description:"")}).join("\n\n")}},{}],3:[function(require,module,exports){var params=function(resource){return resource.uriParameters.map(function(param){return param.displayName}).join(", ")};module.exports=function(resource){for(var parts=[],part=resource;part&&part.parent;){var segment=part.key;part.uriParameters.length&&(segment+="("+params(part)+")"),parts.unshift(segment),part=part.parent}return"resources"+(parts.length?"."+parts.join("."):"")}},{}],4:[function(require,module,exports){var generator=require("../../lib/generator");module.exports=generator({templates:{".gitignore":require("./templates/.gitignore.hbs"),"index.js":require("./templates/index.js.hbs"),"README.md":require("./templates/README.md.hbs"),"INSTALL.md":require("./templates/INSTALL.md.hbs"),"package.json":require("./templates/package.json.hbs")},format:{variable:require("camel-case")},partials:{auth:require("./partials/auth.js.hbs"),utils:require("./partials/utils.js.hbs"),client:require("./partials/client.js.hbs"),resources:require("./partials/resources.js.hbs")},helpers:{stringify:require("javascript-stringify"),dependencies:require("./helpers/dependencies"),requestSnippet:require("./helpers/request-snippet"),parametersSnippet:require("./helpers/parameters-snippet")}})},{"../../lib/generator":20,"./helpers/dependencies":1,"./helpers/parameters-snippet":2,"./helpers/request-snippet":3,"./partials/auth.js.hbs":5,"./partials/client.js.hbs":6,"./partials/resources.js.hbs":7,"./partials/utils.js.hbs":8,"./templates/.gitignore.hbs":9,"./templates/INSTALL.md.hbs":10,"./templates/README.md.hbs":11,"./templates/index.js.hbs":12,"./templates/package.json.hbs":13,"camel-case":27,"javascript-stringify":45}],5:[function(require,module,exports){var HandlebarsCompiler=require("hbsfy/runtime");module.exports=HandlebarsCompiler.template({1:function(depth0,helpers,partials,data){var stack1;return"/**\n * @param {Object} options\n */\nfunction OAuth2 (options) {\n  ClientOAuth2.call(this, extend("+(null!=(stack1=(helpers.stringify||depth0&&depth0.stringify||helpers.helperMissing).call(depth0,null!=(stack1=null!=(stack1=null!=depth0?depth0.security:depth0)?stack1["OAuth 2.0"]:stack1)?stack1.settings:stack1,{name:"stringify",hash:{},data:data}))?stack1:"")+", options));\n}\n\nOAuth2.prototype = Object.create(ClientOAuth2.prototype);\nOAuth2.prototype.constructor = OAuth2;\nOAuth2.prototype.request = popsicle;\n\nClient.OAuth2 = OAuth2;\n"},compiler:[6,">= 2.0.0-beta.1"],main:function(depth0,helpers,partials,data){var stack1;return null!=(stack1=helpers.if.call(depth0,null!=(stack1=null!=depth0?depth0.security:depth0)?stack1["OAuth 2.0"]:stack1,{name:"if",hash:{},fn:this.program(1,data,0),inverse:this.noop,data:data}))?stack1:""},useData:!0})},{"hbsfy/runtime":41}],6:[function(require,module,exports){var HandlebarsCompiler=require("hbsfy/runtime");module.exports=HandlebarsCompiler.template({compiler:[6,">= 2.0.0-beta.1"],main:function(depth0,helpers,partials,data){var stack1,alias1=helpers.helperMissing;return"function Client (options) {\n  this.options = extend({\n    baseUri: "+(null!=(stack1=(helpers.stringify||depth0&&depth0.stringify||alias1).call(depth0,null!=depth0?depth0.baseUri:depth0,{name:"stringify",hash:{},data:data}))?stack1:"")+",\n    baseUriParameters: "+(null!=(stack1=(helpers.stringify||depth0&&depth0.stringify||alias1).call(depth0,(helpers.object||depth0&&depth0.object||alias1).call(depth0,(helpers.keys||depth0&&depth0.keys||alias1).call(depth0,null!=depth0?depth0.baseUriParameters:depth0,{name:"keys",hash:{},data:data}),(helpers.pluck||depth0&&depth0.pluck||alias1).call(depth0,null!=depth0?depth0.baseUriParameters:depth0,"default",{name:"pluck",hash:{},data:data}),{name:"object",hash:{},data:data}),{name:"stringify",hash:{},data:data}))?stack1:"")+"\n  }, options);\n\n  this.resources = new "+this.escapeExpression((helpers.pascalCase||depth0&&depth0.pascalCase||alias1).call(depth0,null!=(stack1=null!=depth0?depth0.resources:depth0)?stack1.id:stack1,{name:"pascalCase",hash:{},data:data}))+"('', this);\n};\n\nClient.prototype.resource = function (route, parameters) {\n  var path = '/' + template(route, parameters).replace(/^\\//, '');\n\n  return new CustomResource(path, this);\n};\n\nClient.prototype.request = popsicle;\nClient.prototype.form = Client.form = popsicle.form;\nClient.prototype.version  = "+(null!=(stack1=(helpers.stringify||depth0&&depth0.stringify||alias1).call(depth0,null!=depth0?depth0.version:depth0,{name:"stringify",hash:{},data:data}))?stack1:"")+";\n"},useData:!0})},{"hbsfy/runtime":41}],7:[function(require,module,exports){var HandlebarsCompiler=require("hbsfy/runtime");module.exports=HandlebarsCompiler.template({1:function(depth0,helpers,partials,data,blockParams,depths){var stack1;return"function "+this.escapeExpression((helpers.pascalCase||depth0&&depth0.pascalCase||helpers.helperMissing).call(depth0,null!=depth0?depth0.id:depth0,{name:"pascalCase",hash:{},data:data}))+" (uri, client) {\n  this._uri    = uri;\n  this._client = client;\n\n"+(null!=(stack1=helpers.each.call(depth0,null!=depth0?depth0.children:depth0,{name:"each",hash:{},fn:this.program(2,data,0,blockParams,depths),inverse:this.noop,data:data}))?stack1:"")+"};\n\n"+(null!=(stack1=helpers.each.call(depth0,null!=depth0?depth0.children:depth0,{name:"each",hash:{},fn:this.program(5,data,0,blockParams,depths),inverse:this.noop,data:data}))?stack1:"")+"\n"+(null!=(stack1=helpers.each.call(depth0,null!=depth0?depth0.methods:depth0,{name:"each",hash:{},fn:this.program(8,data,0,blockParams,depths),inverse:this.noop,data:data}))?stack1:"")},2:function(depth0,helpers,partials,data){var stack1;return null!=(stack1=helpers.unless.call(depth0,null!=depth0?depth0.uriParameters:depth0,{name:"unless",hash:{},fn:this.program(3,data,0),inverse:this.noop,data:data}))?stack1:""},3:function(depth0,helpers,partials,data){var stack1,helper,alias1=helpers.helperMissing,alias2=this.escapeExpression;return"  this."+alias2((helper=null!=(helper=helpers.key||data&&data.key)?helper:alias1,"function"==typeof helper?helper.call(depth0,{name:"key",hash:{},data:data}):helper))+" = new "+alias2((helpers.pascalCase||depth0&&depth0.pascalCase||alias1).call(depth0,null!=depth0?depth0.id:depth0,{name:"pascalCase",hash:{},data:data}))+"(uri + "+(null!=(stack1=(helpers.stringify||depth0&&depth0.stringify||alias1).call(depth0,null!=depth0?depth0.relativeUri:depth0,{name:"stringify",hash:{},data:data}))?stack1:"")+", client);\n"},5:function(depth0,helpers,partials,data,blockParams,depths){var stack1;return null!=(stack1=helpers.if.call(depth0,null!=depth0?depth0.uriParameters:depth0,{name:"if",hash:{},fn:this.program(6,data,0,blockParams,depths),inverse:this.noop,data:data}))?stack1:""},6:function(depth0,helpers,partials,data,blockParams,depths){var stack1,helper,alias1=helpers.helperMissing,alias2=this.escapeExpression;return alias2((helpers.pascalCase||depth0&&depth0.pascalCase||alias1).call(depth0,null!=depths[2]?depths[2].id:depths[2],{name:"pascalCase",hash:{},data:data}))+".prototype."+alias2((helper=null!=(helper=helpers.key||data&&data.key)?helper:alias1,"function"==typeof helper?helper.call(depth0,{name:"key",hash:{},data:data}):helper))+" = function (/* ...args */) {\n  var uri = this._uri + template("+(null!=(stack1=(helpers.stringify||depth0&&depth0.stringify||alias1).call(depth0,null!=depth0?depth0.relativeUri:depth0,{name:"stringify",hash:{},data:data}))?stack1:"")+", arguments, "+(null!=(stack1=(helpers.stringify||depth0&&depth0.stringify||alias1).call(depth0,(helpers.pluck||depth0&&depth0.pluck||alias1).call(depth0,null!=depth0?depth0.uriParameters:depth0,"default",{name:"pluck",hash:{},data:data}),{name:"stringify",hash:{},data:data}))?stack1:"")+");\n\n  return new "+alias2((helpers.pascalCase||depth0&&depth0.pascalCase||alias1).call(depth0,null!=depth0?depth0.id:depth0,{name:"pascalCase",hash:{},data:data}))+"(uri, this._client);\n};\n"},8:function(depth0,helpers,partials,data,blockParams,depths){var stack1,helper,alias1=helpers.helperMissing,alias2=this.escapeExpression;return alias2((helpers.pascalCase||depth0&&depth0.pascalCase||alias1).call(depth0,null!=depths[1]?depths[1].id:depths[1],{name:"pascalCase",hash:{},data:data}))+".prototype."+alias2((helper=null!=(helper=helpers.key||data&&data.key)?helper:alias1,"function"==typeof helper?helper.call(depth0,{name:"key",hash:{},data:data}):helper))+" = function (body, options) {\n"+(null!=(stack1=helpers.if.call(depth0,(helpers.keys||depth0&&depth0.keys||alias1).call(depth0,null!=depth0?depth0.headers:depth0,{name:"keys",hash:{},data:data}),{name:"if",hash:{},fn:this.program(9,data,0,blockParams,depths),inverse:this.noop,data:data}))?stack1:"")+"  return handleRequest(this._client, this._uri, "+(null!=(stack1=(helpers.stringify||depth0&&depth0.stringify||alias1).call(depth0,(helpers.upperCase||depth0&&depth0.upperCase||alias1).call(depth0,null!=depth0?depth0.method:depth0,{name:"upperCase",hash:{},data:data}),{name:"stringify",hash:{},data:data}))?stack1:"")+", body, options);\n};\n"},9:function(depth0,helpers,partials,data){var stack1,alias1=helpers.helperMissing;return"  options = extend({}, options);\n  options.headers = extend("+(null!=(stack1=(helpers.stringify||depth0&&depth0.stringify||alias1).call(depth0,(helpers.object||depth0&&depth0.object||alias1).call(depth0,(helpers.keys||depth0&&depth0.keys||alias1).call(depth0,null!=depth0?depth0.headers:depth0,{name:"keys",hash:{},data:data}),(helpers.pluck||depth0&&depth0.pluck||alias1).call(depth0,null!=depth0?depth0.headers:depth0,"default",{name:"pluck",hash:{},data:data}),{name:"object",hash:{},data:data}),{name:"stringify",hash:{},data:data}))?stack1:"")+", options.headers);\n\n"},11:function(depth0,helpers,partials,data){var stack1,alias1=helpers.helperMissing;return"CustomResource.prototype."+this.escapeExpression((helpers.camelCase||depth0&&depth0.camelCase||alias1).call(depth0,depth0,{name:"camelCase",hash:{},data:data}))+" = function (body, options) {\n  return handleRequest(this._client, this._uri, "+(null!=(stack1=(helpers.stringify||depth0&&depth0.stringify||alias1).call(depth0,(helpers.upperCase||depth0&&depth0.upperCase||alias1).call(depth0,depth0,{name:"upperCase",hash:{},data:data}),{name:"stringify",hash:{},data:data}))?stack1:"")+", body, options);\n};\n"},compiler:[6,">= 2.0.0-beta.1"],main:function(depth0,helpers,partials,data,blockParams,depths){var stack1;return"function handleRequest (client, path, method, body, options) {\n  options = extend({}, client.options, options);\n\n  var baseUri = template(options.baseUri, options.baseUriParameters);\n  var hasBody = method !== 'GET' && method !== 'HEAD';\n  var reqOpts = {};\n\n  var reqBody = hasBody && body != null ? body : options.body;\n  var reqQuery = !hasBody && body != null ? body : options.query;\n\n  var reqOpts = {\n    url: baseUri.replace(/\\/$/, '') + path,\n    method: method,\n    headers: extend({}, options.headers),\n    body: reqBody,\n    query: typeof reqQuery === 'object' ? extend({}, reqQuery) : reqQuery\n  };\n\n  if (options.user && typeof options.user.sign === 'function') {\n    options.user.sign(reqOpts);\n  }\n\n  return client.request(reqOpts);\n}\n\n"+(null!=(stack1=helpers.each.call(depth0,null!=depth0?depth0.allResources:depth0,{name:"each",hash:{},fn:this.program(1,data,0,blockParams,depths),inverse:this.noop,data:data}))?stack1:"")+"\nfunction CustomResource (uri, client) {\n  this._uri    = uri;\n  this._client = client;\n}\n\n"+(null!=(stack1=helpers.each.call(depth0,null!=depth0?depth0.supportedMethods:depth0,{name:"each",hash:{},fn:this.program(11,data,0,blockParams,depths),inverse:this.noop,data:data}))?stack1:"")},useData:!0,useDepths:!0})},{"hbsfy/runtime":41}],8:[function(require,module,exports){var HandlebarsCompiler=require("hbsfy/runtime");module.exports=HandlebarsCompiler.template({compiler:[6,">= 2.0.0-beta.1"],main:function(depth0,helpers,partials,data){return"var TEMPLATE_REGEXP = /\\{([^\\{\\}]+)\\}/g;\n\n/**\n * @param  {String} string\n * @param  {Object} interpolate\n * @param  {Object} defaults\n * @return {String}\n */\nfunction template (string, interpolate, defaults) {\n  defaults    = defaults || {};\n  interpolate = interpolate || {};\n\n  return string.replace(TEMPLATE_REGEXP, function (match, key) {\n    if (interpolate[key] != null) {\n      return encodeURIComponent(interpolate[key]);\n    }\n\n    if (defaults[key] != null) {\n      return encodeURIComponent(defaults[key]);\n    }\n\n    return '';\n  });\n}\n\n/**\n * @param  {Object} dest\n * @param  {Object} ...source\n * @return {Object}\n */\nfunction extend (dest /*, ...source */) {\n  for (var i = 1; i < arguments.length; i++) {\n    for (var key in arguments[i]) {\n      dest[key] = arguments[i][key];\n    }\n  }\n\n  return dest;\n}\n"},useData:!0})},{"hbsfy/runtime":41}],9:[function(require,module,exports){var HandlebarsCompiler=require("hbsfy/runtime");module.exports=HandlebarsCompiler.template({compiler:[6,">= 2.0.0-beta.1"],main:function(depth0,helpers,partials,data){return"node_modules\n"},useData:!0})},{"hbsfy/runtime":41}],10:[function(require,module,exports){var HandlebarsCompiler=require("hbsfy/runtime");module.exports=HandlebarsCompiler.template({compiler:[6,">= 2.0.0-beta.1"],main:function(depth0,helpers,partials,data){var alias1=helpers.helperMissing,alias2=this.escapeExpression;return'# Installation\n\nFollow these instructions to publish and subsequently install the module in your project.\n\n## Git\n\n```\n# Initialize with git\ngit init\ngit add .\ngit commit -m "initial commit"\ngit push [git-url]\n\n# Install in project from git\nnpm install [git-url] --save\n```\n\n## Source Directory\n\n```\n# Link module globally\nnpm link\n\n# Link in project to local module\nnpm link '+alias2((helpers.paramCase||depth0&&depth0.paramCase||alias1).call(depth0,null!=depth0?depth0.title:depth0,{name:"paramCase",hash:{},data:data}))+"\n```\n\n**Note:** You should publish it before you use it publicly.\n\n## NPM\n\n```\n# Publish to npm\nnpm publish\n\n# Install from npm\nnpm install "+alias2((helpers.paramCase||depth0&&depth0.paramCase||alias1).call(depth0,null!=depth0?depth0.title:depth0,{name:"paramCase",hash:{},data:data}))+" --save\n```\n\n## Bower\n\n```\n# Register with bower\nbower register "+alias2((helpers.paramCase||depth0&&depth0.paramCase||alias1).call(depth0,null!=depth0?depth0.title:depth0,{name:"paramCase",hash:{},data:data}))+" [git-url]\n\n# Install from bower\nbower install "+alias2((helpers.paramCase||depth0&&depth0.paramCase||alias1).call(depth0,null!=depth0?depth0.title:depth0,{name:"paramCase",hash:{},data:data}))+" --save\n```\n"},useData:!0})},{"hbsfy/runtime":41}],11:[function(require,module,exports){var HandlebarsCompiler=require("hbsfy/runtime");module.exports=HandlebarsCompiler.template({1:function(depth0,helpers,partials,data){var stack1,alias1=helpers.helperMissing,alias2=this.escapeExpression;return"### Authentication\n\n#### OAuth 2.0\n\nThis API supports authentication with [OAuth 2.0](https://github.com/mulesoft/js-client-oauth2). Initialize the `OAuth2` instance with the application client id, client secret and a redirect uri to authenticate with users.\n\n```js\nvar auth = new "+alias2((helpers.pascalCase||depth0&&depth0.pascalCase||alias1).call(depth0,null!=depth0?depth0.title:depth0,{name:"pascalCase",hash:{},data:data}))+".OAuth2({\n  clientId:     '123',\n  clientSecret: 'abc',\n  redirectUri:  'http://example.com/auth/callback'\n});\n```\n\n**All `getToken()` calls are asynchronous and return promise objects which resolve to an access token instance.**\n\n"+(null!=(stack1=helpers.if.call(depth0,(helpers.contains||depth0&&depth0.contains||alias1).call(depth0,null!=(stack1=null!=(stack1=null!=(stack1=null!=depth0?depth0.security:depth0)?stack1["OAuth 2.0"]:stack1)?stack1.settings:stack1)?stack1.authorizationGrants:stack1,"code",{name:"contains",hash:{},data:data}),{name:"if",hash:{},fn:this.program(2,data,0),inverse:this.noop,data:data}))?stack1:"")+(null!=(stack1=helpers.if.call(depth0,(helpers.contains||depth0&&depth0.contains||alias1).call(depth0,null!=(stack1=null!=(stack1=null!=(stack1=null!=depth0?depth0.security:depth0)?stack1["OAuth 2.0"]:stack1)?stack1.settings:stack1)?stack1.authorizationGrants:stack1,"token",{name:"contains",hash:{},data:data}),{name:"if",hash:{},fn:this.program(4,data,0),inverse:this.noop,data:data}))?stack1:"")+(null!=(stack1=helpers.if.call(depth0,(helpers.contains||depth0&&depth0.contains||alias1).call(depth0,null!=(stack1=null!=(stack1=null!=(stack1=null!=depth0?depth0.security:depth0)?stack1["OAuth 2.0"]:stack1)?stack1.settings:stack1)?stack1.authorizationGrants:stack1,"owner",{name:"contains",hash:{},data:data}),{name:"if",hash:{},fn:this.program(6,data,0),inverse:this.noop,data:data}))?stack1:"")+(null!=(stack1=helpers.if.call(depth0,(helpers.contains||depth0&&depth0.contains||alias1).call(depth0,null!=(stack1=null!=(stack1=null!=(stack1=null!=depth0?depth0.security:depth0)?stack1["OAuth 2.0"]:stack1)?stack1.settings:stack1)?stack1.authorizationGrants:stack1,"credentials",{name:"contains",hash:{},data:data}),{name:"if",hash:{},fn:this.program(8,data,0),inverse:this.noop,data:data}))?stack1:"")+"##### Access Tokens\n\nAccess token instances can be manually re-created. This is critical for access token reuse, such as saving credentials to a database for reusing later in the codebase.\n\n```js\nvar token = auth.createToken('access token', 'refresh token');\n```\n\nAn access token instance (manually created or automatically generated by a `getToken()` method) can be passed into any API request. This will sign the API request with the current users access token credentials.\n\n```js\n// Existing API client instance.\nclient.resource('/').get(null, {\n  user: token\n});\n\n// New API client instance.\nvar client = new "+alias2((helpers.pascalCase||depth0&&depth0.pascalCase||alias1).call(depth0,null!=depth0?depth0.title:depth0,{name:"pascalCase",hash:{},data:data}))+"({\n  user: token\n});\n```\n\n"},2:function(depth0,helpers,partials,data){return"##### [Authorization Code Grant](https://github.com/mulesoft/js-client-oauth2#authorization-code-grant)\n\n1. Redirect user to `auth.code.getUri()`.\n2. Parse response uri and get an access token instance using `auth.code.getToken(uri)`.\n\n"},4:function(depth0,helpers,partials,data){return"\n##### [Implicit Grant](https://github.com/mulesoft/js-client-oauth2#implicit-grant)\n\n1. Redirect user to `auth.token.getUri()` in a browser.\n2. Parse response uri and get an access token instance using `auth.token.getToken(uri)`.\n\n"},6:function(depth0,helpers,partials,data){return"\n##### [Resource Owner Password Credentials Grant](https://github.com/mulesoft/js-client-oauth2#resource-owner-password-credentials-grant)\n\n1. Make a direct request for the access token on behalf of the user using `auth.owner.getToken(username, password)`.\n\n"},8:function(depth0,helpers,partials,data){return"\n##### [Client Credentials Grant](https://github.com/mulesoft/js-client-oauth2#client-credentials-grant)\n\n1. Get the access token for the application by using `auth.credentials.getToken()`.\n\n"},10:function(depth0,helpers,partials,data){var helper;return this.escapeExpression((helper=null!=(helper=helpers.version||(null!=depth0?depth0.version:depth0))?helper:helpers.helperMissing,"function"==typeof helper?helper.call(depth0,{name:"version",hash:{},data:data}):helper))},12:function(depth0,helpers,partials,data){return"v3"},14:function(depth0,helpers,partials,data){var stack1;return null!=(stack1=helpers.if.call(depth0,(helpers.keys||depth0&&depth0.keys||helpers.helperMissing).call(depth0,null!=depth0?depth0.methods:depth0,{name:"keys",hash:{},data:data}),{name:"if",hash:{},fn:this.program(15,data,0),inverse:this.noop,data:data}))?stack1:""},15:function(depth0,helpers,partials,data){var stack1,alias1=helpers.helperMissing;return"#### "+(null!=(stack1=(helpers.requestSnippet||depth0&&depth0.requestSnippet||alias1).call(depth0,depth0,{name:"requestSnippet",hash:{},data:data}))?stack1:"")+"\n\n"+(null!=(stack1=helpers.if.call(depth0,null!=depth0?depth0.uriParameters:depth0,{name:"if",hash:{},fn:this.program(16,data,0),inverse:this.noop,data:data}))?stack1:"")+(null!=(stack1=helpers.if.call(depth0,null!=depth0?depth0.description:depth0,{name:"if",hash:{},fn:this.program(18,data,0),inverse:this.noop,data:data}))?stack1:"")+"```js\nvar resource = client."+(null!=(stack1=(helpers.requestSnippet||depth0&&depth0.requestSnippet||alias1).call(depth0,depth0,{name:"requestSnippet",hash:{},data:data}))?stack1:"")+";\n```\n\n"+(null!=(stack1=helpers.each.call(depth0,null!=depth0?depth0.methods:depth0,{name:"each",hash:{},fn:this.program(20,data,0),inverse:this.noop,data:data}))?stack1:"")},16:function(depth0,helpers,partials,data){var stack1;return(null!=(stack1=(helpers.parametersSnippet||depth0&&depth0.parametersSnippet||helpers.helperMissing).call(depth0,null!=depth0?depth0.uriParameters:depth0,{name:"parametersSnippet",hash:{},data:data}))?stack1:"")+"\n\n"},18:function(depth0,helpers,partials,data){var stack1,helper;return(null!=(helper=null!=(helper=helpers.description||(null!=depth0?depth0.description:depth0))?helper:helpers.helperMissing,stack1="function"==typeof helper?helper.call(depth0,{name:"description",hash:{},data:data}):helper)?stack1:"")+"\n\n"},20:function(depth0,helpers,partials,data){var stack1,helper,alias1=helpers.helperMissing,alias2=this.escapeExpression;return"##### "+alias2((helpers.upperCase||depth0&&depth0.upperCase||alias1).call(depth0,null!=depth0?depth0.method:depth0,{name:"upperCase",hash:{},data:data}))+"\n\n"+(null!=(stack1=helpers.if.call(depth0,null!=depth0?depth0.description:depth0,{name:"if",hash:{},fn:this.program(18,data,0),inverse:this.noop,data:data}))?stack1:"")+"```js\nresource."+alias2((helper=null!=(helper=helpers.key||(null!=depth0?depth0.key:depth0))?helper:alias1,"function"==typeof helper?helper.call(depth0,{name:"key",hash:{},data:data}):helper))+"().then(function (res) { ... });\n```\n\n"+(null!=(stack1=helpers.if.call(depth0,(helpers.keys||depth0&&depth0.keys||alias1).call(depth0,null!=depth0?depth0.queryParameters:depth0,{name:"keys",hash:{},data:data}),{name:"if",hash:{},fn:this.program(21,data,0),inverse:this.noop,data:data}))?stack1:"")+(null!=(stack1=helpers.if.call(depth0,(helpers.keys||depth0&&depth0.keys||alias1).call(depth0,null!=depth0?depth0.headers:depth0,{name:"keys",hash:{},data:data}),{name:"if",hash:{},fn:this.program(26,data,0),inverse:this.noop,data:data}))?stack1:"")+(null!=(stack1=helpers.if.call(depth0,(helpers.keys||depth0&&depth0.keys||alias1).call(depth0,null!=depth0?depth0.body:depth0,{name:"keys",hash:{},data:data}),{name:"if",hash:{},fn:this.program(28,data,0),inverse:this.noop,data:data}))?stack1:"")},21:function(depth0,helpers,partials,data){var stack1,alias1=helpers.helperMissing;return"##### Query Parameters\n\n```javascript\n"+(null!=(stack1=helpers.if.call(depth0,(helpers.equal||depth0&&depth0.equal||alias1).call(depth0,null!=depth0?depth0.method:depth0,"get",{name:"equal",hash:{},data:data}),{name:"if",hash:{},fn:this.program(22,data,0),inverse:this.program(24,data,0),data:data}))?stack1:"")+"```\n\n"+(null!=(stack1=(helpers.parametersSnippet||depth0&&depth0.parametersSnippet||alias1).call(depth0,null!=depth0?depth0.queryParameters:depth0,{name:"parametersSnippet",hash:{},data:data}))?stack1:"")+"\n\n"},22:function(depth0,helpers,partials,data){var helper;return"resource."+this.escapeExpression((helper=null!=(helper=helpers.key||(null!=depth0?depth0.key:depth0))?helper:helpers.helperMissing,"function"==typeof helper?helper.call(depth0,{name:"key",hash:{},data:data}):helper))+"({ ... });\n"},24:function(depth0,helpers,partials,data){var helper;return"resource."+this.escapeExpression((helper=null!=(helper=helpers.key||(null!=depth0?depth0.key:depth0))?helper:helpers.helperMissing,"function"==typeof helper?helper.call(depth0,{name:"key",hash:{},data:data}):helper))+"(null, { query: { ... } });\n"},26:function(depth0,helpers,partials,data){var stack1,helper,alias1=helpers.helperMissing;return"##### Headers\n\n```javascript\nresource."+this.escapeExpression((helper=null!=(helper=helpers.key||(null!=depth0?depth0.key:depth0))?helper:alias1,"function"==typeof helper?helper.call(depth0,{name:"key",hash:{},data:data}):helper))+"(null, {\n  headers: { ... }\n});\n```\n\n"+(null!=(stack1=(helpers.parametersSnippet||depth0&&depth0.parametersSnippet||alias1).call(depth0,null!=depth0?depth0.headers:depth0,{name:"parametersSnippet",hash:{},data:data}))?stack1:"")+"\n\n"},28:function(depth0,helpers,partials,data){var stack1;return"##### Body\n\n"+(null!=(stack1=helpers.each.call(depth0,null!=depth0?depth0.body:depth0,{name:"each",hash:{},fn:this.program(29,data,0),inverse:this.noop,data:data}))?stack1:"")},29:function(depth0,helpers,partials,data){var stack1,helper;return"**"+this.escapeExpression((helper=null!=(helper=helpers.key||data&&data.key)?helper:helpers.helperMissing,"function"==typeof helper?helper.call(depth0,{name:"key",hash:{},data:data}):helper))+"**\n\n"+(null!=(stack1=helpers.if.call(depth0,null!=depth0?depth0.schema:depth0,{name:"if",hash:{},fn:this.program(30,data,0),inverse:this.noop,data:data}))?stack1:"")+(null!=(stack1=helpers.if.call(depth0,null!=depth0?depth0.formParameters:depth0,{name:"if",hash:{},fn:this.program(32,data,0),inverse:this.noop,data:data}))?stack1:"")},30:function(depth0,helpers,partials,data){var stack1,helper;return"```\n"+(null!=(helper=null!=(helper=helpers.schema||(null!=depth0?depth0.schema:depth0))?helper:helpers.helperMissing,stack1="function"==typeof helper?helper.call(depth0,{name:"schema",hash:{},data:data}):helper)?stack1:"")+"\n```\n\n"},32:function(depth0,helpers,partials,data){var stack1;return(null!=(stack1=(helpers.json||depth0&&depth0.json||helpers.helperMissing).call(depth0,null!=depth0?depth0.formParameters:depth0,2,{name:"json",hash:{},data:data}))?stack1:"")+"\n\n"},compiler:[6,">= 2.0.0-beta.1"],main:function(depth0,helpers,partials,data){var stack1,helper,alias1=helpers.helperMissing,alias2="function",alias3=this.escapeExpression;return"# "+alias3((helper=null!=(helper=helpers.title||(null!=depth0?depth0.title:depth0))?helper:alias1,typeof helper===alias2?helper.call(depth0,{name:"title",hash:{},data:data}):helper))+"\n\nBrowser and node module for making API requests against ["+alias3((helper=null!=(helper=helpers.title||(null!=depth0?depth0.title:depth0))?helper:alias1,typeof helper===alias2?helper.call(depth0,{name:"title",hash:{},data:data}):helper))+"]("+alias3((helper=null!=(helper=helpers.baseUri||(null!=depth0?depth0.baseUri:depth0))?helper:alias1,typeof helper===alias2?helper.call(depth0,{name:"baseUri",hash:{},data:data}):helper))+").\n\n**Please note: This module uses [Popsicle](https://github.com/blakeembrey/popsicle) to make API requests. Promises must be supported or polyfilled on all target environments.**\n\n## Installation\n\n```\nnpm install "+alias3((helpers.paramCase||depth0&&depth0.paramCase||alias1).call(depth0,null!=depth0?depth0.title:depth0,{name:"paramCase",hash:{},data:data}))+" --save\nbower install "+alias3((helpers.paramCase||depth0&&depth0.paramCase||alias1).call(depth0,null!=depth0?depth0.title:depth0,{name:"paramCase",hash:{},data:data}))+" --save\n```\n\n## Usage\n\n### Node\n\n```javascript\nvar "+alias3((helpers.pascalCase||depth0&&depth0.pascalCase||alias1).call(depth0,null!=depth0?depth0.title:depth0,{name:"pascalCase",hash:{},data:data}))+" = require('"+alias3((helpers.paramCase||depth0&&depth0.paramCase||alias1).call(depth0,null!=depth0?depth0.title:depth0,{name:"paramCase",hash:{},data:data}))+"');\n\nvar client = new "+alias3((helpers.pascalCase||depth0&&depth0.pascalCase||alias1).call(depth0,null!=depth0?depth0.title:depth0,{name:"pascalCase",hash:{},data:data}))+'();\n```\n\n### Browsers\n\n```html\n<script src="'+alias3((helpers.paramCase||depth0&&depth0.paramCase||alias1).call(depth0,null!=depth0?depth0.title:depth0,{name:"paramCase",hash:{},data:data}))+'/index.js">\n\n<script>\n  var client = new window.'+alias3((helpers.pascalCase||depth0&&depth0.pascalCase||alias1).call(depth0,null!=depth0?depth0.title:depth0,{name:"pascalCase",hash:{},data:data}))+"();\n</script>\n```\n\n"+(null!=(stack1=helpers.if.call(depth0,null!=(stack1=null!=depth0?depth0.security:depth0)?stack1["OAuth 2.0"]:stack1,{name:"if",hash:{},fn:this.program(1,data,0),inverse:this.noop,data:data}))?stack1:"")+"### Options\n\nYou can set options when you initialize a client or at any time with the `options` property. You may also override options for a single request by passing an object as the second argument of any request method. For example:\n\n```javascript\nvar client = new "+alias3((helpers.pascalCase||depth0&&depth0.pascalCase||alias1).call(depth0,null!=depth0?depth0.title:depth0,{name:"pascalCase",hash:{},data:data}))+"({ ... });\n\nclient.options = { ... };\n\nclient.resource('/').get(null, {\n  baseUri: 'http://example.com',\n  headers: {\n    'Content-Type': 'application/json'\n  }\n});\n```\n\n#### Base URI\n\nYou can override the base URI by setting the `baseUri` property, or initializing a client with a base URI. For example:\n\n```javascript\nnew "+alias3((helpers.pascalCase||depth0&&depth0.pascalCase||alias1).call(depth0,null!=depth0?depth0.title:depth0,{name:"pascalCase",hash:{},data:data}))+"({\n  baseUri: 'https://example.com'\n});\n```\n\n#### Base URI Parameters\n\nIf the base URI has parameters inline, you can set them by updating the `baseUriParameters` property. For example:\n\n```javascript\nclient.options.baseUriParameters.version = '"+(null!=(stack1=helpers.if.call(depth0,null!=depth0?depth0.version:depth0,{name:"if",hash:{},fn:this.program(10,data,0),inverse:this.program(12,data,0),data:data}))?stack1:"")+"';\n```\n\n### Resources\n\nAll methods return a HTTP request instance of [Popsicle](https://github.com/blakeembrey/popsicle), which allows the use of promises (and streaming in node).\n\n"+(null!=(stack1=helpers.each.call(depth0,null!=depth0?depth0.allResources:depth0,{name:"each",hash:{},fn:this.program(14,data,0),inverse:this.noop,data:data}))?stack1:"")+"\n\n### Custom Resources\n\nYou can make requests to a custom path in the API using the `#resource(path)` method.\n\n```javascript\nclient.resource('/example/path').get();\n```\n\n## License\n\nApache 2.0\n"},
useData:!0})},{"hbsfy/runtime":41}],12:[function(require,module,exports){var HandlebarsCompiler=require("hbsfy/runtime");module.exports=HandlebarsCompiler.template({1:function(depth0,helpers,partials,data){var stack1;return(null!=(stack1=this.invokePartial(partials.utils,depth0,{name:"utils",data:data,helpers:helpers,partials:partials}))?stack1:"")+"\n"+(null!=(stack1=this.invokePartial(partials.resources,depth0,{name:"resources",data:data,helpers:helpers,partials:partials}))?stack1:"")+"\n"+(null!=(stack1=this.invokePartial(partials.client,depth0,{name:"client",data:data,helpers:helpers,partials:partials}))?stack1:"")+"\n"+(null!=(stack1=this.invokePartial(partials.auth,depth0,{name:"auth",data:data,helpers:helpers,partials:partials}))?stack1:"")+"\nreturn Client;\n"},compiler:[6,">= 2.0.0-beta.1"],main:function(depth0,helpers,partials,data){var stack1,alias1=helpers.helperMissing;return"(function (root, client) {\n  if (typeof define === 'function' && define.amd) {\n    // AMD. Register as an anonymous module.\n    define("+(null!=(stack1=(helpers.dependencies||depth0&&depth0.dependencies||alias1).call(depth0,depth0,"amd",{name:"dependencies",hash:{},data:data}))?stack1:"")+", client);\n  } else if (typeof exports === 'object') {\n    // Node. Does not work with strict CommonJS, but only CommonJS-like\n    // environments that support `module.exports`, like Node.\n    module.exports = client("+(null!=(stack1=(helpers.dependencies||depth0&&depth0.dependencies||alias1).call(depth0,depth0,"node",{name:"dependencies",hash:{},data:data}))?stack1:"")+");\n  } else {\n    // Browser globals (root is window).\n    root."+this.escapeExpression((helpers.pascalCase||depth0&&depth0.pascalCase||alias1).call(depth0,null!=depth0?depth0.title:depth0,{name:"pascalCase",hash:{},data:data}))+" = client("+(null!=(stack1=(helpers.dependencies||depth0&&depth0.dependencies||alias1).call(depth0,depth0,"browser",{name:"dependencies",hash:{},data:data}))?stack1:"")+");\n  }\n})(this, function ("+(null!=(stack1=(helpers.dependencies||depth0&&depth0.dependencies||alias1).call(depth0,depth0,!1,{name:"dependencies",hash:{},data:data}))?stack1:"")+") {\n"+(null!=(stack1=(helpers.indent||depth0&&depth0.indent||alias1).call(depth0,2,{name:"indent",hash:{},fn:this.program(1,data,0),inverse:this.noop,data:data}))?stack1:"")+"});\n"},usePartial:!0,useData:!0})},{"hbsfy/runtime":41}],13:[function(require,module,exports){var HandlebarsCompiler=require("hbsfy/runtime");module.exports=HandlebarsCompiler.template({1:function(depth0,helpers,partials,data){return'"client-oauth2": "^0.1.0",\n    '},compiler:[6,">= 2.0.0-beta.1"],main:function(depth0,helpers,partials,data){var stack1,helper,alias1=helpers.helperMissing,alias2=this.escapeExpression;return'{\n  "name": "'+alias2((helpers.paramCase||depth0&&depth0.paramCase||alias1).call(depth0,null!=depth0?depth0.title:depth0,{name:"paramCase",hash:{},data:data}))+'",\n  "version": "0.0.0",\n  "description": "'+alias2((helper=null!=(helper=helpers.description||(null!=depth0?depth0.description:depth0))?helper:alias1,"function"==typeof helper?helper.call(depth0,{name:"description",hash:{},data:data}):helper))+'",\n  "main": "index.js",\n  "files": [\n    "index.js"\n  ],\n  "repository": {\n    "type": "git",\n    "url": "git://github.com/mulesoft/raml-client-generator.git"\n  },\n  "keywords": [\n    "raml-api"\n  ],\n  "author": "MuleSoft, Inc.",\n  "license": "Apache 2.0",\n  "bugs": {\n    "url": "https://github.com/mulesoft/raml-client-generator/issues"\n  },\n  "homepage": "https://github.com/mulesoft/raml-client-generator",\n  "dependencies": {\n    '+(null!=(stack1=helpers.if.call(depth0,null!=(stack1=null!=depth0?depth0.security:depth0)?stack1["OAuth 2.0"]:stack1,{name:"if",hash:{},fn:this.program(1,data,0),inverse:this.noop,data:data}))?stack1:"")+'"popsicle": "^0.3.6"\n  }\n}\n'},useData:!0})},{"hbsfy/runtime":41}],14:[function(require,module,exports){var PARAM_IDS,extend=require("extend"),sanitizeUri=require("./uri"),sanitizeSecurity=require("./security"),sanitizeResources=require("./resources"),sanitizeParameters=require("./parameters"),DEFAULT_FORMAT={uri:function(uri){return uri},variable:function(){throw new Error("No variable format specified")},uniqueId:function(prefix){var id=++PARAM_IDS[prefix]||(PARAM_IDS[prefix]=0);return prefix+id}},validateSpec=function(spec){return PARAM_IDS={},spec.format=extend({},DEFAULT_FORMAT,spec.format),extend({},spec)},flattenResources=function(resources){var array=[];return function recurse(resource){array.push(resource),Object.keys(resource.children).forEach(function(key){recurse(resource.children[key])})}(resources),array},flattenMethods=function(resources){var array=[];return function recurse(resource){resource.methods&&Object.keys(resource.methods).forEach(function(key){array.push(resource.methods[key])}),Object.keys(resource.children).forEach(function(key){recurse(resource.children[key])})}(resources),array};module.exports=function(ast,spec){spec=validateSpec(spec);var context={id:spec.format.uniqueId("client"),title:ast.title||"API Client",version:ast.version,baseUri:sanitizeUri(ast.baseUri,spec),security:sanitizeSecurity(ast.securitySchemes,spec),resources:sanitizeResources(ast.resources,spec),baseUriParameters:sanitizeParameters(ast.baseUriParameters,spec)};return context.allMethods=flattenMethods(context.resources),context.allResources=flattenResources(context.resources),context.supportedMethods=require("methods"),context}},{"./parameters":16,"./resources":17,"./security":18,"./uri":19,extend:33,methods:47}],15:[function(require,module,exports){var pick=require("object.pick"),sanitizeParameters=require("./parameters"),sanitizeMethod=function(method,resource,spec){var obj=pick(method,["method","protocols","responses","body","headers"]);return obj.id=spec.format.uniqueId("method"),obj.resource=resource,obj.queryParameters=sanitizeParameters(method.queryParameters),obj.description=(method.description||"").trim(),obj};module.exports=function(methods,resource,spec){var obj={};return methods?(methods.forEach(function(method){var key=spec.format.variable(method.method),sanitizedMethod=sanitizeMethod(method,resource,spec);obj[key]=sanitizedMethod,sanitizedMethod.key=key}),obj):obj}},{"./parameters":16,"object.pick":48}],16:[function(require,module,exports){var pick=require("object.pick"),sanitizeParameter=function(parameter){var obj=pick(parameter,["displayName","type","enum","pattern","minLength","maxLength","minimum","maximum","example","repeat","required","default"]);return obj.description=(parameter.description||"").trim(),null==obj.default&&Array.isArray(obj.enum)&&(obj.default=obj.enum[0]),obj};module.exports=function(parameters){var obj={};return parameters?(Object.keys(parameters).forEach(function(key){obj[key]=sanitizeParameter(parameters[key])}),obj):obj}},{"object.pick":48}],17:[function(require,module,exports){var sanitizeUri=require("./uri"),sanitizeMethods=require("./methods"),sanitizeParameters=require("./parameters"),TEMPLATE_REGEXP=/\{[^\{\}]+\}/g,toPropertyFormat=function(uri,spec){return uri=uri.replace(/^[\.\/]/,""),/^\{[^\{\}]+\}$/.test(uri)?spec.format.variable(uri.slice(1,-1)):/^[^\{\}]+(?:\{[^\{\}]+\})*$/.test(uri)?spec.format.variable(uri.replace(/\{.+\}$/,"")):void 0},toUriFormat=function(uri,spec){var index=0,indexedUri=uri.replace(/\{[^\{\}]+\}/g,function(){return"{"+index++ +"}"});return sanitizeUri(indexedUri,spec)},attachResource=function(obj,resource,spec){var uriParts=resource.relativeUri.split(/(?=\.|\/|\{mediaTypeExtension\}$)/),parameters=sanitizeParameters(resource.uriParameters),getParamTag=function(param){return parameters[param.slice(1,-1)]};!function recurse(obj,parts){var part=parts[0];if("{mediaTypeExtension}"===part&&1===parts.length&&(Array.isArray(parameters.mediaTypeExtension.enum)&&parameters.mediaTypeExtension.enum.forEach(function(extension){return extension="."+extension.replace(/^\./,""),recurse(obj,[extension])}),delete parameters.mediaTypeExtension.enum,part=".{mediaTypeExtension}"),"/"!==part){var key=toPropertyFormat(part,spec);if(!key||obj.children.hasOwnProperty(key)){if(part!==obj.children[key].relativeUri)return;obj=obj.children[key]}else{var matches=part.match(TEMPLATE_REGEXP)||[],uriParameters=Array.prototype.map.call(matches,getParamTag);obj=obj.children[key]={id:spec.format.uniqueId("resource"),key:key,parent:obj,children:{},relativeUri:toUriFormat(part,spec),uriParameters:uriParameters}}}return parts.length>1?recurse(obj,parts.slice(1)):(obj.methods=sanitizeMethods(resource.methods,obj,spec),obj.description=(resource.description||"").trim(),resource.resources&&resource.resources.forEach(function(resource){attachResource(obj,resource,spec)}),obj)}(obj,uriParts)};module.exports=function(resources,spec){var obj={id:spec.format.uniqueId("resource"),children:{},relativeUri:"",uriParameters:[]};return resources?(resources.forEach(function(resource){return attachResource(obj,resource,spec)}),obj):obj}},{"./methods":15,"./parameters":16,"./uri":19}],18:[function(require,module,exports){module.exports=function(securitySchemes){var obj={};return Array.isArray(securitySchemes)?(securitySchemes.forEach(function(schemes){Object.keys(schemes).forEach(function(key){var scheme=schemes[key];obj[scheme.type]=scheme})}),obj):obj}},{}],19:[function(require,module,exports){module.exports=function(uri,spec){return spec.format.uri(uri||"").replace(/\/+$/,"")}},{}],20:[function(require,module,exports){function generate(ast,spec,data){var options={data:data,helpers:extend({},helpers,spec.helpers),partials:extend({},spec.partials)},createFiles=spec.files||generateFiles,context=createContext(ast,spec),files=createFiles(spec.templates,context,options);return{files:files,context:context,options:options}}function generateFiles(templates,context,options){var files={};return Object.keys(templates).forEach(function(key){files[key]=templates[key](context,options)}),files}var extend=require("extend"),helpers=require("./helpers"),createContext=require("./context");require("handlebars"),module.exports=function(spec){return function(ast,options){return generate(ast,spec,options)}}},{"./context":14,"./helpers":21,extend:33,handlebars:22}],21:[function(require,module,exports){var indent=require("indent-string"),trim=String.prototype.trim,hasOwn=Object.prototype.hasOwnProperty;exports.camelCase=require("camel-case"),exports.pascalCase=require("pascal-case"),exports.constantCase=require("constant-case"),exports.paramCase=require("param-case"),exports.lowerCase=require("lower-case"),exports.upperCase=require("upper-case"),exports.snakeCase=require("snake-case"),exports.indent=function(){var args=Array.prototype.slice.call(arguments),opts=args.pop(),input=opts.fn?opts.fn(this):args[0],count=(opts.fn?args[0]:args[1])||2,character=(opts.fn?args[1]:args[2])||" ";return indent(input,character,count)},exports.or=function(){for(var i=0;i<arguments.length-1;i++)if(arguments[i])return!0;return!1},exports.and=function(){for(var i=0;i<arguments.length-1;i++)if(!arguments[i])return!1;return!0},exports.not=function(condition){return!condition},exports.keys=function(obj){var keys=[];for(var prop in obj)hasOwn.call(obj,prop)&&keys.push(prop);return keys},exports.pluck=function(obj,name){return Object.keys(obj).map(function(key){return obj[key]&&obj[key][name]})},exports.object=function(keys,values){for(var obj={},i=0;i<keys.length;i++)obj[keys[i]]=values[i];return obj},exports.contains=function(array,value){return array.indexOf(value)>-1},exports.log=function(){var opts=arguments[arguments.length-1];opts.fn?console.log(opts.fn(this)):console.log.apply(console,Array.prototype.slice.call(arguments,0,-1))},exports.trim=function(){var opts=arguments[arguments.length-1];return arguments.length>1?trim.call(null==arguments[0]?"":arguments[0]):trim.call(opts.fn(this))},exports.equal=function(){for(var args=Array.prototype.slice.call(arguments,0,-1),opts=arguments[arguments.length-1],i=1;i<args.length;i++)if(args[i-1]!==args[i])return!!opts.fn&&opts.inverse(this);return!opts.fn||opts.fn(this)},exports.json=function(){if(arguments.length>2)return JSON.stringify(arguments[0],null,arguments[1]);if(2===arguments.length)return JSON.stringify(arguments[0]);throw new Error("Unsupported usage of json helper")},exports.join=function(array,value){return Array.isArray(array)?array.join(value):array}},{"camel-case":27,"constant-case":32,"indent-string":42,"lower-case":46,"param-case":53,"pascal-case":55,"snake-case":60,"upper-case":61}],22:[function(require,module,exports){},{}],23:[function(require,module,exports){function Buffer(subject,encoding,noZero){if(!(this instanceof Buffer))return new Buffer(subject,encoding,noZero);var length,type=typeof subject;if("number"===type)length=+subject;else if("string"===type)length=Buffer.byteLength(subject,encoding);else{if("object"!==type||null===subject)throw new TypeError("must start with number, buffer, array or string");"Buffer"===subject.type&&isArray(subject.data)&&(subject=subject.data),length=+subject.length}if(length>kMaxLength)throw new RangeError("Attempt to allocate Buffer larger than maximum size: 0x"+kMaxLength.toString(16)+" bytes");length<0?length=0:length>>>=0;var self=this;Buffer.TYPED_ARRAY_SUPPORT?self=Buffer._augment(new Uint8Array(length)):(self.length=length,self._isBuffer=!0);var i;if(Buffer.TYPED_ARRAY_SUPPORT&&"number"==typeof subject.byteLength)self._set(subject);else if(isArrayish(subject))if(Buffer.isBuffer(subject))for(i=0;i<length;i++)self[i]=subject.readUInt8(i);else for(i=0;i<length;i++)self[i]=(subject[i]%256+256)%256;else if("string"===type)self.write(subject,0,encoding);else if("number"===type&&!Buffer.TYPED_ARRAY_SUPPORT&&!noZero)for(i=0;i<length;i++)self[i]=0;return length>0&&length<=Buffer.poolSize&&(self.parent=rootParent),self}function SlowBuffer(subject,encoding,noZero){if(!(this instanceof SlowBuffer))return new SlowBuffer(subject,encoding,noZero);var buf=new Buffer(subject,encoding,noZero);return delete buf.parent,buf}function hexWrite(buf,string,offset,length){offset=Number(offset)||0;var remaining=buf.length-offset;length?(length=Number(length),length>remaining&&(length=remaining)):length=remaining;var strLen=string.length;if(strLen%2!==0)throw new Error("Invalid hex string");length>strLen/2&&(length=strLen/2);for(var i=0;i<length;i++){var byte=parseInt(string.substr(2*i,2),16);if(isNaN(byte))throw new Error("Invalid hex string");buf[offset+i]=byte}return i}function utf8Write(buf,string,offset,length){var charsWritten=blitBuffer(utf8ToBytes(string,buf.length-offset),buf,offset,length);return charsWritten}function asciiWrite(buf,string,offset,length){var charsWritten=blitBuffer(asciiToBytes(string),buf,offset,length);return charsWritten}function binaryWrite(buf,string,offset,length){return asciiWrite(buf,string,offset,length)}function base64Write(buf,string,offset,length){var charsWritten=blitBuffer(base64ToBytes(string),buf,offset,length);return charsWritten}function utf16leWrite(buf,string,offset,length){var charsWritten=blitBuffer(utf16leToBytes(string,buf.length-offset),buf,offset,length);return charsWritten}function base64Slice(buf,start,end){return 0===start&&end===buf.length?base64.fromByteArray(buf):base64.fromByteArray(buf.slice(start,end))}function utf8Slice(buf,start,end){var res="",tmp="";end=Math.min(buf.length,end);for(var i=start;i<end;i++)buf[i]<=127?(res+=decodeUtf8Char(tmp)+String.fromCharCode(buf[i]),tmp=""):tmp+="%"+buf[i].toString(16);return res+decodeUtf8Char(tmp)}function asciiSlice(buf,start,end){var ret="";end=Math.min(buf.length,end);for(var i=start;i<end;i++)ret+=String.fromCharCode(127&buf[i]);return ret}function binarySlice(buf,start,end){var ret="";end=Math.min(buf.length,end);for(var i=start;i<end;i++)ret+=String.fromCharCode(buf[i]);return ret}function hexSlice(buf,start,end){var len=buf.length;(!start||start<0)&&(start=0),(!end||end<0||end>len)&&(end=len);for(var out="",i=start;i<end;i++)out+=toHex(buf[i]);return out}function utf16leSlice(buf,start,end){for(var bytes=buf.slice(start,end),res="",i=0;i<bytes.length;i+=2)res+=String.fromCharCode(bytes[i]+256*bytes[i+1]);return res}function checkOffset(offset,ext,length){if(offset%1!==0||offset<0)throw new RangeError("offset is not uint");if(offset+ext>length)throw new RangeError("Trying to access beyond buffer length")}function checkInt(buf,value,offset,ext,max,min){if(!Buffer.isBuffer(buf))throw new TypeError("buffer must be a Buffer instance");if(value>max||value<min)throw new RangeError("value is out of bounds");if(offset+ext>buf.length)throw new RangeError("index out of range")}function objectWriteUInt16(buf,value,offset,littleEndian){value<0&&(value=65535+value+1);for(var i=0,j=Math.min(buf.length-offset,2);i<j;i++)buf[offset+i]=(value&255<<8*(littleEndian?i:1-i))>>>8*(littleEndian?i:1-i)}function objectWriteUInt32(buf,value,offset,littleEndian){value<0&&(value=4294967295+value+1);for(var i=0,j=Math.min(buf.length-offset,4);i<j;i++)buf[offset+i]=value>>>8*(littleEndian?i:3-i)&255}function checkIEEE754(buf,value,offset,ext,max,min){if(value>max||value<min)throw new RangeError("value is out of bounds");if(offset+ext>buf.length)throw new RangeError("index out of range");if(offset<0)throw new RangeError("index out of range")}function writeFloat(buf,value,offset,littleEndian,noAssert){return noAssert||checkIEEE754(buf,value,offset,4,3.4028234663852886e38,-3.4028234663852886e38),ieee754.write(buf,value,offset,littleEndian,23,4),offset+4}function writeDouble(buf,value,offset,littleEndian,noAssert){return noAssert||checkIEEE754(buf,value,offset,8,1.7976931348623157e308,-1.7976931348623157e308),ieee754.write(buf,value,offset,littleEndian,52,8),offset+8}function base64clean(str){if(str=stringtrim(str).replace(INVALID_BASE64_RE,""),str.length<2)return"";for(;str.length%4!==0;)str+="=";return str}function stringtrim(str){return str.trim?str.trim():str.replace(/^\s+|\s+$/g,"")}function isArrayish(subject){return isArray(subject)||Buffer.isBuffer(subject)||subject&&"object"==typeof subject&&"number"==typeof subject.length}function toHex(n){return n<16?"0"+n.toString(16):n.toString(16)}function utf8ToBytes(string,units){units=units||1/0;for(var codePoint,length=string.length,leadSurrogate=null,bytes=[],i=0;i<length;i++){if(codePoint=string.charCodeAt(i),codePoint>55295&&codePoint<57344){if(!leadSurrogate){if(codePoint>56319){(units-=3)>-1&&bytes.push(239,191,189);continue}if(i+1===length){(units-=3)>-1&&bytes.push(239,191,189);continue}leadSurrogate=codePoint;continue}if(codePoint<56320){(units-=3)>-1&&bytes.push(239,191,189),leadSurrogate=codePoint;continue}codePoint=leadSurrogate-55296<<10|codePoint-56320|65536,leadSurrogate=null}else leadSurrogate&&((units-=3)>-1&&bytes.push(239,191,189),leadSurrogate=null);if(codePoint<128){if((units-=1)<0)break;bytes.push(codePoint)}else if(codePoint<2048){if((units-=2)<0)break;bytes.push(codePoint>>6|192,63&codePoint|128)}else if(codePoint<65536){if((units-=3)<0)break;bytes.push(codePoint>>12|224,codePoint>>6&63|128,63&codePoint|128)}else{if(!(codePoint<2097152))throw new Error("Invalid code point");if((units-=4)<0)break;bytes.push(codePoint>>18|240,codePoint>>12&63|128,codePoint>>6&63|128,63&codePoint|128)}}return bytes}function asciiToBytes(str){for(var byteArray=[],i=0;i<str.length;i++)byteArray.push(255&str.charCodeAt(i));return byteArray}function utf16leToBytes(str,units){for(var c,hi,lo,byteArray=[],i=0;i<str.length&&!((units-=2)<0);i++)c=str.charCodeAt(i),hi=c>>8,lo=c%256,byteArray.push(lo),byteArray.push(hi);return byteArray}function base64ToBytes(str){return base64.toByteArray(base64clean(str))}function blitBuffer(src,dst,offset,length){for(var i=0;i<length&&!(i+offset>=dst.length||i>=src.length);i++)dst[i+offset]=src[i];return i}function decodeUtf8Char(str){try{return decodeURIComponent(str)}catch(err){return String.fromCharCode(65533)}}var base64=require("base64-js"),ieee754=require("ieee754"),isArray=require("is-array");exports.Buffer=Buffer,exports.SlowBuffer=SlowBuffer,exports.INSPECT_MAX_BYTES=50,Buffer.poolSize=8192;var kMaxLength=1073741823,rootParent={};Buffer.TYPED_ARRAY_SUPPORT=function(){try{var buf=new ArrayBuffer(0),arr=new Uint8Array(buf);return arr.foo=function(){return 42},42===arr.foo()&&"function"==typeof arr.subarray&&0===new Uint8Array(1).subarray(1,1).byteLength}catch(e){return!1}}(),Buffer.isBuffer=function(b){return!(null==b||!b._isBuffer)},Buffer.compare=function(a,b){if(!Buffer.isBuffer(a)||!Buffer.isBuffer(b))throw new TypeError("Arguments must be Buffers");if(a===b)return 0;for(var x=a.length,y=b.length,i=0,len=Math.min(x,y);i<len&&a[i]===b[i];i++);return i!==len&&(x=a[i],y=b[i]),x<y?-1:y<x?1:0},Buffer.isEncoding=function(encoding){switch(String(encoding).toLowerCase()){case"hex":case"utf8":case"utf-8":case"ascii":case"binary":case"base64":case"raw":case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return!0;default:return!1}},Buffer.concat=function(list,totalLength){if(!isArray(list))throw new TypeError("Usage: Buffer.concat(list[, length])");if(0===list.length)return new Buffer(0);if(1===list.length)return list[0];var i;if(void 0===totalLength)for(totalLength=0,i=0;i<list.length;i++)totalLength+=list[i].length;var buf=new Buffer(totalLength),pos=0;for(i=0;i<list.length;i++){var item=list[i];item.copy(buf,pos),pos+=item.length}return buf},Buffer.byteLength=function(str,encoding){var ret;switch(str+="",encoding||"utf8"){case"ascii":case"binary":case"raw":ret=str.length;break;case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":ret=2*str.length;break;case"hex":ret=str.length>>>1;break;case"utf8":case"utf-8":ret=utf8ToBytes(str).length;break;case"base64":ret=base64ToBytes(str).length;break;default:ret=str.length}return ret},Buffer.prototype.length=void 0,Buffer.prototype.parent=void 0,Buffer.prototype.toString=function(encoding,start,end){var loweredCase=!1;if(start>>>=0,end=void 0===end||end===1/0?this.length:end>>>0,encoding||(encoding="utf8"),start<0&&(start=0),end>this.length&&(end=this.length),end<=start)return"";for(;;)switch(encoding){case"hex":return hexSlice(this,start,end);case"utf8":case"utf-8":return utf8Slice(this,start,end);case"ascii":return asciiSlice(this,start,end);case"binary":return binarySlice(this,start,end);case"base64":return base64Slice(this,start,end);case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return utf16leSlice(this,start,end);default:if(loweredCase)throw new TypeError("Unknown encoding: "+encoding);encoding=(encoding+"").toLowerCase(),loweredCase=!0}},Buffer.prototype.equals=function(b){if(!Buffer.isBuffer(b))throw new TypeError("Argument must be a Buffer");return this===b||0===Buffer.compare(this,b)},Buffer.prototype.inspect=function(){var str="",max=exports.INSPECT_MAX_BYTES;return this.length>0&&(str=this.toString("hex",0,max).match(/.{2}/g).join(" "),this.length>max&&(str+=" ... ")),"<Buffer "+str+">"},Buffer.prototype.compare=function(b){if(!Buffer.isBuffer(b))throw new TypeError("Argument must be a Buffer");return this===b?0:Buffer.compare(this,b)},Buffer.prototype.get=function(offset){return console.log(".get() is deprecated. Access using array indexes instead."),this.readUInt8(offset)},Buffer.prototype.set=function(v,offset){return console.log(".set() is deprecated. Access using array indexes instead."),this.writeUInt8(v,offset)},Buffer.prototype.write=function(string,offset,length,encoding){if(isFinite(offset))isFinite(length)||(encoding=length,length=void 0);else{var swap=encoding;encoding=offset,offset=length,length=swap}if(offset=Number(offset)||0,length<0||offset<0||offset>this.length)throw new RangeError("attempt to write outside buffer bounds");var remaining=this.length-offset;length?(length=Number(length),length>remaining&&(length=remaining)):length=remaining,encoding=String(encoding||"utf8").toLowerCase();var ret;switch(encoding){case"hex":ret=hexWrite(this,string,offset,length);break;case"utf8":case"utf-8":ret=utf8Write(this,string,offset,length);break;case"ascii":ret=asciiWrite(this,string,offset,length);break;case"binary":ret=binaryWrite(this,string,offset,length);break;case"base64":ret=base64Write(this,string,offset,length);break;case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":ret=utf16leWrite(this,string,offset,length);break;default:throw new TypeError("Unknown encoding: "+encoding)}return ret},Buffer.prototype.toJSON=function(){return{type:"Buffer",data:Array.prototype.slice.call(this._arr||this,0)}},Buffer.prototype.slice=function(start,end){var len=this.length;start=~~start,end=void 0===end?len:~~end,start<0?(start+=len,start<0&&(start=0)):start>len&&(start=len),end<0?(end+=len,end<0&&(end=0)):end>len&&(end=len),end<start&&(end=start);var newBuf;if(Buffer.TYPED_ARRAY_SUPPORT)newBuf=Buffer._augment(this.subarray(start,end));else{var sliceLen=end-start;newBuf=new Buffer(sliceLen,(void 0),(!0));for(var i=0;i<sliceLen;i++)newBuf[i]=this[i+start]}return newBuf.length&&(newBuf.parent=this.parent||this),newBuf},Buffer.prototype.readUIntLE=function(offset,byteLength,noAssert){offset>>>=0,byteLength>>>=0,noAssert||checkOffset(offset,byteLength,this.length);for(var val=this[offset],mul=1,i=0;++i<byteLength&&(mul*=256);)val+=this[offset+i]*mul;return val},Buffer.prototype.readUIntBE=function(offset,byteLength,noAssert){offset>>>=0,byteLength>>>=0,noAssert||checkOffset(offset,byteLength,this.length);for(var val=this[offset+--byteLength],mul=1;byteLength>0&&(mul*=256);)val+=this[offset+--byteLength]*mul;return val},Buffer.prototype.readUInt8=function(offset,noAssert){return noAssert||checkOffset(offset,1,this.length),this[offset]},Buffer.prototype.readUInt16LE=function(offset,noAssert){return noAssert||checkOffset(offset,2,this.length),this[offset]|this[offset+1]<<8},Buffer.prototype.readUInt16BE=function(offset,noAssert){return noAssert||checkOffset(offset,2,this.length),this[offset]<<8|this[offset+1]},Buffer.prototype.readUInt32LE=function(offset,noAssert){return noAssert||checkOffset(offset,4,this.length),(this[offset]|this[offset+1]<<8|this[offset+2]<<16)+16777216*this[offset+3]},Buffer.prototype.readUInt32BE=function(offset,noAssert){return noAssert||checkOffset(offset,4,this.length),16777216*this[offset]+(this[offset+1]<<16|this[offset+2]<<8|this[offset+3])},Buffer.prototype.readIntLE=function(offset,byteLength,noAssert){offset>>>=0,byteLength>>>=0,noAssert||checkOffset(offset,byteLength,this.length);for(var val=this[offset],mul=1,i=0;++i<byteLength&&(mul*=256);)val+=this[offset+i]*mul;return mul*=128,val>=mul&&(val-=Math.pow(2,8*byteLength)),val},Buffer.prototype.readIntBE=function(offset,byteLength,noAssert){offset>>>=0,byteLength>>>=0,noAssert||checkOffset(offset,byteLength,this.length);for(var i=byteLength,mul=1,val=this[offset+--i];i>0&&(mul*=256);)val+=this[offset+--i]*mul;return mul*=128,val>=mul&&(val-=Math.pow(2,8*byteLength)),val},Buffer.prototype.readInt8=function(offset,noAssert){return noAssert||checkOffset(offset,1,this.length),128&this[offset]?(255-this[offset]+1)*-1:this[offset]},Buffer.prototype.readInt16LE=function(offset,noAssert){noAssert||checkOffset(offset,2,this.length);var val=this[offset]|this[offset+1]<<8;return 32768&val?4294901760|val:val},Buffer.prototype.readInt16BE=function(offset,noAssert){noAssert||checkOffset(offset,2,this.length);var val=this[offset+1]|this[offset]<<8;return 32768&val?4294901760|val:val},Buffer.prototype.readInt32LE=function(offset,noAssert){return noAssert||checkOffset(offset,4,this.length),this[offset]|this[offset+1]<<8|this[offset+2]<<16|this[offset+3]<<24},Buffer.prototype.readInt32BE=function(offset,noAssert){return noAssert||checkOffset(offset,4,this.length),this[offset]<<24|this[offset+1]<<16|this[offset+2]<<8|this[offset+3]},Buffer.prototype.readFloatLE=function(offset,noAssert){return noAssert||checkOffset(offset,4,this.length),ieee754.read(this,offset,!0,23,4)},Buffer.prototype.readFloatBE=function(offset,noAssert){return noAssert||checkOffset(offset,4,this.length),ieee754.read(this,offset,!1,23,4)},Buffer.prototype.readDoubleLE=function(offset,noAssert){return noAssert||checkOffset(offset,8,this.length),ieee754.read(this,offset,!0,52,8)},Buffer.prototype.readDoubleBE=function(offset,noAssert){return noAssert||checkOffset(offset,8,this.length),ieee754.read(this,offset,!1,52,8)},Buffer.prototype.writeUIntLE=function(value,offset,byteLength,noAssert){value=+value,offset>>>=0,byteLength>>>=0,noAssert||checkInt(this,value,offset,byteLength,Math.pow(2,8*byteLength),0);var mul=1,i=0;for(this[offset]=255&value;++i<byteLength&&(mul*=256);)this[offset+i]=value/mul>>>0&255;return offset+byteLength},Buffer.prototype.writeUIntBE=function(value,offset,byteLength,noAssert){value=+value,offset>>>=0,byteLength>>>=0,noAssert||checkInt(this,value,offset,byteLength,Math.pow(2,8*byteLength),0);var i=byteLength-1,mul=1;for(this[offset+i]=255&value;--i>=0&&(mul*=256);)this[offset+i]=value/mul>>>0&255;return offset+byteLength},Buffer.prototype.writeUInt8=function(value,offset,noAssert){return value=+value,offset>>>=0,noAssert||checkInt(this,value,offset,1,255,0),Buffer.TYPED_ARRAY_SUPPORT||(value=Math.floor(value)),this[offset]=value,offset+1},Buffer.prototype.writeUInt16LE=function(value,offset,noAssert){return value=+value,offset>>>=0,noAssert||checkInt(this,value,offset,2,65535,0),Buffer.TYPED_ARRAY_SUPPORT?(this[offset]=value,this[offset+1]=value>>>8):objectWriteUInt16(this,value,offset,!0),offset+2},Buffer.prototype.writeUInt16BE=function(value,offset,noAssert){return value=+value,offset>>>=0,noAssert||checkInt(this,value,offset,2,65535,0),Buffer.TYPED_ARRAY_SUPPORT?(this[offset]=value>>>8,this[offset+1]=value):objectWriteUInt16(this,value,offset,!1),offset+2},Buffer.prototype.writeUInt32LE=function(value,offset,noAssert){return value=+value,offset>>>=0,noAssert||checkInt(this,value,offset,4,4294967295,0),Buffer.TYPED_ARRAY_SUPPORT?(this[offset+3]=value>>>24,this[offset+2]=value>>>16,this[offset+1]=value>>>8,this[offset]=value):objectWriteUInt32(this,value,offset,!0),offset+4},Buffer.prototype.writeUInt32BE=function(value,offset,noAssert){return value=+value,offset>>>=0,noAssert||checkInt(this,value,offset,4,4294967295,0),Buffer.TYPED_ARRAY_SUPPORT?(this[offset]=value>>>24,this[offset+1]=value>>>16,this[offset+2]=value>>>8,this[offset+3]=value):objectWriteUInt32(this,value,offset,!1),offset+4},Buffer.prototype.writeIntLE=function(value,offset,byteLength,noAssert){value=+value,offset>>>=0,noAssert||checkInt(this,value,offset,byteLength,Math.pow(2,8*byteLength-1)-1,-Math.pow(2,8*byteLength-1));var i=0,mul=1,sub=value<0?1:0;for(this[offset]=255&value;++i<byteLength&&(mul*=256);)this[offset+i]=(value/mul>>0)-sub&255;return offset+byteLength},Buffer.prototype.writeIntBE=function(value,offset,byteLength,noAssert){value=+value,offset>>>=0,noAssert||checkInt(this,value,offset,byteLength,Math.pow(2,8*byteLength-1)-1,-Math.pow(2,8*byteLength-1));var i=byteLength-1,mul=1,sub=value<0?1:0;for(this[offset+i]=255&value;--i>=0&&(mul*=256);)this[offset+i]=(value/mul>>0)-sub&255;return offset+byteLength},Buffer.prototype.writeInt8=function(value,offset,noAssert){return value=+value,offset>>>=0,noAssert||checkInt(this,value,offset,1,127,-128),Buffer.TYPED_ARRAY_SUPPORT||(value=Math.floor(value)),value<0&&(value=255+value+1),this[offset]=value,offset+1},Buffer.prototype.writeInt16LE=function(value,offset,noAssert){return value=+value,offset>>>=0,noAssert||checkInt(this,value,offset,2,32767,-32768),Buffer.TYPED_ARRAY_SUPPORT?(this[offset]=value,this[offset+1]=value>>>8):objectWriteUInt16(this,value,offset,!0),offset+2},Buffer.prototype.writeInt16BE=function(value,offset,noAssert){return value=+value,offset>>>=0,noAssert||checkInt(this,value,offset,2,32767,-32768),Buffer.TYPED_ARRAY_SUPPORT?(this[offset]=value>>>8,this[offset+1]=value):objectWriteUInt16(this,value,offset,!1),offset+2},Buffer.prototype.writeInt32LE=function(value,offset,noAssert){return value=+value,offset>>>=0,noAssert||checkInt(this,value,offset,4,2147483647,-2147483648),Buffer.TYPED_ARRAY_SUPPORT?(this[offset]=value,this[offset+1]=value>>>8,this[offset+2]=value>>>16,
this[offset+3]=value>>>24):objectWriteUInt32(this,value,offset,!0),offset+4},Buffer.prototype.writeInt32BE=function(value,offset,noAssert){return value=+value,offset>>>=0,noAssert||checkInt(this,value,offset,4,2147483647,-2147483648),value<0&&(value=4294967295+value+1),Buffer.TYPED_ARRAY_SUPPORT?(this[offset]=value>>>24,this[offset+1]=value>>>16,this[offset+2]=value>>>8,this[offset+3]=value):objectWriteUInt32(this,value,offset,!1),offset+4},Buffer.prototype.writeFloatLE=function(value,offset,noAssert){return writeFloat(this,value,offset,!0,noAssert)},Buffer.prototype.writeFloatBE=function(value,offset,noAssert){return writeFloat(this,value,offset,!1,noAssert)},Buffer.prototype.writeDoubleLE=function(value,offset,noAssert){return writeDouble(this,value,offset,!0,noAssert)},Buffer.prototype.writeDoubleBE=function(value,offset,noAssert){return writeDouble(this,value,offset,!1,noAssert)},Buffer.prototype.copy=function(target,target_start,start,end){var self=this;if(start||(start=0),end||0===end||(end=this.length),target_start>=target.length&&(target_start=target.length),target_start||(target_start=0),end>0&&end<start&&(end=start),end===start)return 0;if(0===target.length||0===self.length)return 0;if(target_start<0)throw new RangeError("targetStart out of bounds");if(start<0||start>=self.length)throw new RangeError("sourceStart out of bounds");if(end<0)throw new RangeError("sourceEnd out of bounds");end>this.length&&(end=this.length),target.length-target_start<end-start&&(end=target.length-target_start+start);var len=end-start;if(len<1e3||!Buffer.TYPED_ARRAY_SUPPORT)for(var i=0;i<len;i++)target[i+target_start]=this[i+start];else target._set(this.subarray(start,start+len),target_start);return len},Buffer.prototype.fill=function(value,start,end){if(value||(value=0),start||(start=0),end||(end=this.length),end<start)throw new RangeError("end < start");if(end!==start&&0!==this.length){if(start<0||start>=this.length)throw new RangeError("start out of bounds");if(end<0||end>this.length)throw new RangeError("end out of bounds");var i;if("number"==typeof value)for(i=start;i<end;i++)this[i]=value;else{var bytes=utf8ToBytes(value.toString()),len=bytes.length;for(i=start;i<end;i++)this[i]=bytes[i%len]}return this}},Buffer.prototype.toArrayBuffer=function(){if("undefined"!=typeof Uint8Array){if(Buffer.TYPED_ARRAY_SUPPORT)return new Buffer(this).buffer;for(var buf=new Uint8Array(this.length),i=0,len=buf.length;i<len;i+=1)buf[i]=this[i];return buf.buffer}throw new TypeError("Buffer.toArrayBuffer not supported in this browser")};var BP=Buffer.prototype;Buffer._augment=function(arr){return arr.constructor=Buffer,arr._isBuffer=!0,arr._get=arr.get,arr._set=arr.set,arr.get=BP.get,arr.set=BP.set,arr.write=BP.write,arr.toString=BP.toString,arr.toLocaleString=BP.toString,arr.toJSON=BP.toJSON,arr.equals=BP.equals,arr.compare=BP.compare,arr.copy=BP.copy,arr.slice=BP.slice,arr.readUIntLE=BP.readUIntLE,arr.readUIntBE=BP.readUIntBE,arr.readUInt8=BP.readUInt8,arr.readUInt16LE=BP.readUInt16LE,arr.readUInt16BE=BP.readUInt16BE,arr.readUInt32LE=BP.readUInt32LE,arr.readUInt32BE=BP.readUInt32BE,arr.readIntLE=BP.readIntLE,arr.readIntBE=BP.readIntBE,arr.readInt8=BP.readInt8,arr.readInt16LE=BP.readInt16LE,arr.readInt16BE=BP.readInt16BE,arr.readInt32LE=BP.readInt32LE,arr.readInt32BE=BP.readInt32BE,arr.readFloatLE=BP.readFloatLE,arr.readFloatBE=BP.readFloatBE,arr.readDoubleLE=BP.readDoubleLE,arr.readDoubleBE=BP.readDoubleBE,arr.writeUInt8=BP.writeUInt8,arr.writeUIntLE=BP.writeUIntLE,arr.writeUIntBE=BP.writeUIntBE,arr.writeUInt16LE=BP.writeUInt16LE,arr.writeUInt16BE=BP.writeUInt16BE,arr.writeUInt32LE=BP.writeUInt32LE,arr.writeUInt32BE=BP.writeUInt32BE,arr.writeIntLE=BP.writeIntLE,arr.writeIntBE=BP.writeIntBE,arr.writeInt8=BP.writeInt8,arr.writeInt16LE=BP.writeInt16LE,arr.writeInt16BE=BP.writeInt16BE,arr.writeInt32LE=BP.writeInt32LE,arr.writeInt32BE=BP.writeInt32BE,arr.writeFloatLE=BP.writeFloatLE,arr.writeFloatBE=BP.writeFloatBE,arr.writeDoubleLE=BP.writeDoubleLE,arr.writeDoubleBE=BP.writeDoubleBE,arr.fill=BP.fill,arr.inspect=BP.inspect,arr.toArrayBuffer=BP.toArrayBuffer,arr};var INVALID_BASE64_RE=/[^+\/0-9A-z\-]/g},{"base64-js":24,ieee754:25,"is-array":26}],24:[function(require,module,exports){var lookup="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";!function(exports){"use strict";function decode(elt){var code=elt.charCodeAt(0);return code===PLUS||code===PLUS_URL_SAFE?62:code===SLASH||code===SLASH_URL_SAFE?63:code<NUMBER?-1:code<NUMBER+10?code-NUMBER+26+26:code<UPPER+26?code-UPPER:code<LOWER+26?code-LOWER+26:void 0}function b64ToByteArray(b64){function push(v){arr[L++]=v}var i,j,l,tmp,placeHolders,arr;if(b64.length%4>0)throw new Error("Invalid string. Length must be a multiple of 4");var len=b64.length;placeHolders="="===b64.charAt(len-2)?2:"="===b64.charAt(len-1)?1:0,arr=new Arr(3*b64.length/4-placeHolders),l=placeHolders>0?b64.length-4:b64.length;var L=0;for(i=0,j=0;i<l;i+=4,j+=3)tmp=decode(b64.charAt(i))<<18|decode(b64.charAt(i+1))<<12|decode(b64.charAt(i+2))<<6|decode(b64.charAt(i+3)),push((16711680&tmp)>>16),push((65280&tmp)>>8),push(255&tmp);return 2===placeHolders?(tmp=decode(b64.charAt(i))<<2|decode(b64.charAt(i+1))>>4,push(255&tmp)):1===placeHolders&&(tmp=decode(b64.charAt(i))<<10|decode(b64.charAt(i+1))<<4|decode(b64.charAt(i+2))>>2,push(tmp>>8&255),push(255&tmp)),arr}function uint8ToBase64(uint8){function encode(num){return lookup.charAt(num)}function tripletToBase64(num){return encode(num>>18&63)+encode(num>>12&63)+encode(num>>6&63)+encode(63&num)}var i,temp,length,extraBytes=uint8.length%3,output="";for(i=0,length=uint8.length-extraBytes;i<length;i+=3)temp=(uint8[i]<<16)+(uint8[i+1]<<8)+uint8[i+2],output+=tripletToBase64(temp);switch(extraBytes){case 1:temp=uint8[uint8.length-1],output+=encode(temp>>2),output+=encode(temp<<4&63),output+="==";break;case 2:temp=(uint8[uint8.length-2]<<8)+uint8[uint8.length-1],output+=encode(temp>>10),output+=encode(temp>>4&63),output+=encode(temp<<2&63),output+="="}return output}var Arr="undefined"!=typeof Uint8Array?Uint8Array:Array,PLUS="+".charCodeAt(0),SLASH="/".charCodeAt(0),NUMBER="0".charCodeAt(0),LOWER="a".charCodeAt(0),UPPER="A".charCodeAt(0),PLUS_URL_SAFE="-".charCodeAt(0),SLASH_URL_SAFE="_".charCodeAt(0);exports.toByteArray=b64ToByteArray,exports.fromByteArray=uint8ToBase64}("undefined"==typeof exports?this.base64js={}:exports)},{}],25:[function(require,module,exports){exports.read=function(buffer,offset,isLE,mLen,nBytes){var e,m,eLen=8*nBytes-mLen-1,eMax=(1<<eLen)-1,eBias=eMax>>1,nBits=-7,i=isLE?nBytes-1:0,d=isLE?-1:1,s=buffer[offset+i];for(i+=d,e=s&(1<<-nBits)-1,s>>=-nBits,nBits+=eLen;nBits>0;e=256*e+buffer[offset+i],i+=d,nBits-=8);for(m=e&(1<<-nBits)-1,e>>=-nBits,nBits+=mLen;nBits>0;m=256*m+buffer[offset+i],i+=d,nBits-=8);if(0===e)e=1-eBias;else{if(e===eMax)return m?NaN:(s?-1:1)*(1/0);m+=Math.pow(2,mLen),e-=eBias}return(s?-1:1)*m*Math.pow(2,e-mLen)},exports.write=function(buffer,value,offset,isLE,mLen,nBytes){var e,m,c,eLen=8*nBytes-mLen-1,eMax=(1<<eLen)-1,eBias=eMax>>1,rt=23===mLen?Math.pow(2,-24)-Math.pow(2,-77):0,i=isLE?0:nBytes-1,d=isLE?1:-1,s=value<0||0===value&&1/value<0?1:0;for(value=Math.abs(value),isNaN(value)||value===1/0?(m=isNaN(value)?1:0,e=eMax):(e=Math.floor(Math.log(value)/Math.LN2),value*(c=Math.pow(2,-e))<1&&(e--,c*=2),value+=e+eBias>=1?rt/c:rt*Math.pow(2,1-eBias),value*c>=2&&(e++,c/=2),e+eBias>=eMax?(m=0,e=eMax):e+eBias>=1?(m=(value*c-1)*Math.pow(2,mLen),e+=eBias):(m=value*Math.pow(2,eBias-1)*Math.pow(2,mLen),e=0));mLen>=8;buffer[offset+i]=255&m,i+=d,m/=256,mLen-=8);for(e=e<<mLen|m,eLen+=mLen;eLen>0;buffer[offset+i]=255&e,i+=d,e/=256,eLen-=8);buffer[offset+i-d]|=128*s}},{}],26:[function(require,module,exports){var isArray=Array.isArray,str=Object.prototype.toString;module.exports=isArray||function(val){return!!val&&"[object Array]"==str.call(val)}},{}],27:[function(require,module,exports){var upperCase=require("upper-case"),sentenceCase=require("sentence-case");module.exports=function(string,locale){return sentenceCase(string,locale).replace(/(\d) (?=\d)/g,"$1_").replace(/ (.)/g,function(m,$1){return upperCase($1,locale)})}},{"sentence-case":28,"upper-case":61}],28:[function(require,module,exports){var lowerCase=require("lower-case"),NON_WORD_REGEXP=require("./vendor/non-word-regexp"),CAMEL_CASE_REGEXP=require("./vendor/camel-case-regexp"),TRAILING_DIGIT_REGEXP=require("./vendor/trailing-digit-regexp");module.exports=function(str,locale,replacement){function replace(match,index,string){return 0===index||index===string.length-match.length?"":replacement}return null==str?"":(replacement=replacement||" ",str=String(str).replace(CAMEL_CASE_REGEXP,"$1 $2").replace(TRAILING_DIGIT_REGEXP,"$1 $2").replace(NON_WORD_REGEXP,replace),lowerCase(str,locale))}},{"./vendor/camel-case-regexp":29,"./vendor/non-word-regexp":30,"./vendor/trailing-digit-regexp":31,"lower-case":46}],29:[function(require,module,exports){module.exports=/([\u0061-\u007A\u00B5\u00DF-\u00F6\u00F8-\u00FF\u0101\u0103\u0105\u0107\u0109\u010B\u010D\u010F\u0111\u0113\u0115\u0117\u0119\u011B\u011D\u011F\u0121\u0123\u0125\u0127\u0129\u012B\u012D\u012F\u0131\u0133\u0135\u0137\u0138\u013A\u013C\u013E\u0140\u0142\u0144\u0146\u0148\u0149\u014B\u014D\u014F\u0151\u0153\u0155\u0157\u0159\u015B\u015D\u015F\u0161\u0163\u0165\u0167\u0169\u016B\u016D\u016F\u0171\u0173\u0175\u0177\u017A\u017C\u017E-\u0180\u0183\u0185\u0188\u018C\u018D\u0192\u0195\u0199-\u019B\u019E\u01A1\u01A3\u01A5\u01A8\u01AA\u01AB\u01AD\u01B0\u01B4\u01B6\u01B9\u01BA\u01BD-\u01BF\u01C6\u01C9\u01CC\u01CE\u01D0\u01D2\u01D4\u01D6\u01D8\u01DA\u01DC\u01DD\u01DF\u01E1\u01E3\u01E5\u01E7\u01E9\u01EB\u01ED\u01EF\u01F0\u01F3\u01F5\u01F9\u01FB\u01FD\u01FF\u0201\u0203\u0205\u0207\u0209\u020B\u020D\u020F\u0211\u0213\u0215\u0217\u0219\u021B\u021D\u021F\u0221\u0223\u0225\u0227\u0229\u022B\u022D\u022F\u0231\u0233-\u0239\u023C\u023F\u0240\u0242\u0247\u0249\u024B\u024D\u024F-\u0293\u0295-\u02AF\u0371\u0373\u0377\u037B-\u037D\u0390\u03AC-\u03CE\u03D0\u03D1\u03D5-\u03D7\u03D9\u03DB\u03DD\u03DF\u03E1\u03E3\u03E5\u03E7\u03E9\u03EB\u03ED\u03EF-\u03F3\u03F5\u03F8\u03FB\u03FC\u0430-\u045F\u0461\u0463\u0465\u0467\u0469\u046B\u046D\u046F\u0471\u0473\u0475\u0477\u0479\u047B\u047D\u047F\u0481\u048B\u048D\u048F\u0491\u0493\u0495\u0497\u0499\u049B\u049D\u049F\u04A1\u04A3\u04A5\u04A7\u04A9\u04AB\u04AD\u04AF\u04B1\u04B3\u04B5\u04B7\u04B9\u04BB\u04BD\u04BF\u04C2\u04C4\u04C6\u04C8\u04CA\u04CC\u04CE\u04CF\u04D1\u04D3\u04D5\u04D7\u04D9\u04DB\u04DD\u04DF\u04E1\u04E3\u04E5\u04E7\u04E9\u04EB\u04ED\u04EF\u04F1\u04F3\u04F5\u04F7\u04F9\u04FB\u04FD\u04FF\u0501\u0503\u0505\u0507\u0509\u050B\u050D\u050F\u0511\u0513\u0515\u0517\u0519\u051B\u051D\u051F\u0521\u0523\u0525\u0527\u0561-\u0587\u1D00-\u1D2B\u1D6B-\u1D77\u1D79-\u1D9A\u1E01\u1E03\u1E05\u1E07\u1E09\u1E0B\u1E0D\u1E0F\u1E11\u1E13\u1E15\u1E17\u1E19\u1E1B\u1E1D\u1E1F\u1E21\u1E23\u1E25\u1E27\u1E29\u1E2B\u1E2D\u1E2F\u1E31\u1E33\u1E35\u1E37\u1E39\u1E3B\u1E3D\u1E3F\u1E41\u1E43\u1E45\u1E47\u1E49\u1E4B\u1E4D\u1E4F\u1E51\u1E53\u1E55\u1E57\u1E59\u1E5B\u1E5D\u1E5F\u1E61\u1E63\u1E65\u1E67\u1E69\u1E6B\u1E6D\u1E6F\u1E71\u1E73\u1E75\u1E77\u1E79\u1E7B\u1E7D\u1E7F\u1E81\u1E83\u1E85\u1E87\u1E89\u1E8B\u1E8D\u1E8F\u1E91\u1E93\u1E95-\u1E9D\u1E9F\u1EA1\u1EA3\u1EA5\u1EA7\u1EA9\u1EAB\u1EAD\u1EAF\u1EB1\u1EB3\u1EB5\u1EB7\u1EB9\u1EBB\u1EBD\u1EBF\u1EC1\u1EC3\u1EC5\u1EC7\u1EC9\u1ECB\u1ECD\u1ECF\u1ED1\u1ED3\u1ED5\u1ED7\u1ED9\u1EDB\u1EDD\u1EDF\u1EE1\u1EE3\u1EE5\u1EE7\u1EE9\u1EEB\u1EED\u1EEF\u1EF1\u1EF3\u1EF5\u1EF7\u1EF9\u1EFB\u1EFD\u1EFF-\u1F07\u1F10-\u1F15\u1F20-\u1F27\u1F30-\u1F37\u1F40-\u1F45\u1F50-\u1F57\u1F60-\u1F67\u1F70-\u1F7D\u1F80-\u1F87\u1F90-\u1F97\u1FA0-\u1FA7\u1FB0-\u1FB4\u1FB6\u1FB7\u1FBE\u1FC2-\u1FC4\u1FC6\u1FC7\u1FD0-\u1FD3\u1FD6\u1FD7\u1FE0-\u1FE7\u1FF2-\u1FF4\u1FF6\u1FF7\u210A\u210E\u210F\u2113\u212F\u2134\u2139\u213C\u213D\u2146-\u2149\u214E\u2184\u2C30-\u2C5E\u2C61\u2C65\u2C66\u2C68\u2C6A\u2C6C\u2C71\u2C73\u2C74\u2C76-\u2C7B\u2C81\u2C83\u2C85\u2C87\u2C89\u2C8B\u2C8D\u2C8F\u2C91\u2C93\u2C95\u2C97\u2C99\u2C9B\u2C9D\u2C9F\u2CA1\u2CA3\u2CA5\u2CA7\u2CA9\u2CAB\u2CAD\u2CAF\u2CB1\u2CB3\u2CB5\u2CB7\u2CB9\u2CBB\u2CBD\u2CBF\u2CC1\u2CC3\u2CC5\u2CC7\u2CC9\u2CCB\u2CCD\u2CCF\u2CD1\u2CD3\u2CD5\u2CD7\u2CD9\u2CDB\u2CDD\u2CDF\u2CE1\u2CE3\u2CE4\u2CEC\u2CEE\u2CF3\u2D00-\u2D25\u2D27\u2D2D\uA641\uA643\uA645\uA647\uA649\uA64B\uA64D\uA64F\uA651\uA653\uA655\uA657\uA659\uA65B\uA65D\uA65F\uA661\uA663\uA665\uA667\uA669\uA66B\uA66D\uA681\uA683\uA685\uA687\uA689\uA68B\uA68D\uA68F\uA691\uA693\uA695\uA697\uA723\uA725\uA727\uA729\uA72B\uA72D\uA72F-\uA731\uA733\uA735\uA737\uA739\uA73B\uA73D\uA73F\uA741\uA743\uA745\uA747\uA749\uA74B\uA74D\uA74F\uA751\uA753\uA755\uA757\uA759\uA75B\uA75D\uA75F\uA761\uA763\uA765\uA767\uA769\uA76B\uA76D\uA76F\uA771-\uA778\uA77A\uA77C\uA77F\uA781\uA783\uA785\uA787\uA78C\uA78E\uA791\uA793\uA7A1\uA7A3\uA7A5\uA7A7\uA7A9\uA7FA\uFB00-\uFB06\uFB13-\uFB17\uFF41-\uFF5A])([\u0041-\u005A\u00C0-\u00D6\u00D8-\u00DE\u0100\u0102\u0104\u0106\u0108\u010A\u010C\u010E\u0110\u0112\u0114\u0116\u0118\u011A\u011C\u011E\u0120\u0122\u0124\u0126\u0128\u012A\u012C\u012E\u0130\u0132\u0134\u0136\u0139\u013B\u013D\u013F\u0141\u0143\u0145\u0147\u014A\u014C\u014E\u0150\u0152\u0154\u0156\u0158\u015A\u015C\u015E\u0160\u0162\u0164\u0166\u0168\u016A\u016C\u016E\u0170\u0172\u0174\u0176\u0178\u0179\u017B\u017D\u0181\u0182\u0184\u0186\u0187\u0189-\u018B\u018E-\u0191\u0193\u0194\u0196-\u0198\u019C\u019D\u019F\u01A0\u01A2\u01A4\u01A6\u01A7\u01A9\u01AC\u01AE\u01AF\u01B1-\u01B3\u01B5\u01B7\u01B8\u01BC\u01C4\u01C7\u01CA\u01CD\u01CF\u01D1\u01D3\u01D5\u01D7\u01D9\u01DB\u01DE\u01E0\u01E2\u01E4\u01E6\u01E8\u01EA\u01EC\u01EE\u01F1\u01F4\u01F6-\u01F8\u01FA\u01FC\u01FE\u0200\u0202\u0204\u0206\u0208\u020A\u020C\u020E\u0210\u0212\u0214\u0216\u0218\u021A\u021C\u021E\u0220\u0222\u0224\u0226\u0228\u022A\u022C\u022E\u0230\u0232\u023A\u023B\u023D\u023E\u0241\u0243-\u0246\u0248\u024A\u024C\u024E\u0370\u0372\u0376\u0386\u0388-\u038A\u038C\u038E\u038F\u0391-\u03A1\u03A3-\u03AB\u03CF\u03D2-\u03D4\u03D8\u03DA\u03DC\u03DE\u03E0\u03E2\u03E4\u03E6\u03E8\u03EA\u03EC\u03EE\u03F4\u03F7\u03F9\u03FA\u03FD-\u042F\u0460\u0462\u0464\u0466\u0468\u046A\u046C\u046E\u0470\u0472\u0474\u0476\u0478\u047A\u047C\u047E\u0480\u048A\u048C\u048E\u0490\u0492\u0494\u0496\u0498\u049A\u049C\u049E\u04A0\u04A2\u04A4\u04A6\u04A8\u04AA\u04AC\u04AE\u04B0\u04B2\u04B4\u04B6\u04B8\u04BA\u04BC\u04BE\u04C0\u04C1\u04C3\u04C5\u04C7\u04C9\u04CB\u04CD\u04D0\u04D2\u04D4\u04D6\u04D8\u04DA\u04DC\u04DE\u04E0\u04E2\u04E4\u04E6\u04E8\u04EA\u04EC\u04EE\u04F0\u04F2\u04F4\u04F6\u04F8\u04FA\u04FC\u04FE\u0500\u0502\u0504\u0506\u0508\u050A\u050C\u050E\u0510\u0512\u0514\u0516\u0518\u051A\u051C\u051E\u0520\u0522\u0524\u0526\u0531-\u0556\u10A0-\u10C5\u10C7\u10CD\u1E00\u1E02\u1E04\u1E06\u1E08\u1E0A\u1E0C\u1E0E\u1E10\u1E12\u1E14\u1E16\u1E18\u1E1A\u1E1C\u1E1E\u1E20\u1E22\u1E24\u1E26\u1E28\u1E2A\u1E2C\u1E2E\u1E30\u1E32\u1E34\u1E36\u1E38\u1E3A\u1E3C\u1E3E\u1E40\u1E42\u1E44\u1E46\u1E48\u1E4A\u1E4C\u1E4E\u1E50\u1E52\u1E54\u1E56\u1E58\u1E5A\u1E5C\u1E5E\u1E60\u1E62\u1E64\u1E66\u1E68\u1E6A\u1E6C\u1E6E\u1E70\u1E72\u1E74\u1E76\u1E78\u1E7A\u1E7C\u1E7E\u1E80\u1E82\u1E84\u1E86\u1E88\u1E8A\u1E8C\u1E8E\u1E90\u1E92\u1E94\u1E9E\u1EA0\u1EA2\u1EA4\u1EA6\u1EA8\u1EAA\u1EAC\u1EAE\u1EB0\u1EB2\u1EB4\u1EB6\u1EB8\u1EBA\u1EBC\u1EBE\u1EC0\u1EC2\u1EC4\u1EC6\u1EC8\u1ECA\u1ECC\u1ECE\u1ED0\u1ED2\u1ED4\u1ED6\u1ED8\u1EDA\u1EDC\u1EDE\u1EE0\u1EE2\u1EE4\u1EE6\u1EE8\u1EEA\u1EEC\u1EEE\u1EF0\u1EF2\u1EF4\u1EF6\u1EF8\u1EFA\u1EFC\u1EFE\u1F08-\u1F0F\u1F18-\u1F1D\u1F28-\u1F2F\u1F38-\u1F3F\u1F48-\u1F4D\u1F59\u1F5B\u1F5D\u1F5F\u1F68-\u1F6F\u1FB8-\u1FBB\u1FC8-\u1FCB\u1FD8-\u1FDB\u1FE8-\u1FEC\u1FF8-\u1FFB\u2102\u2107\u210B-\u210D\u2110-\u2112\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u2130-\u2133\u213E\u213F\u2145\u2183\u2C00-\u2C2E\u2C60\u2C62-\u2C64\u2C67\u2C69\u2C6B\u2C6D-\u2C70\u2C72\u2C75\u2C7E-\u2C80\u2C82\u2C84\u2C86\u2C88\u2C8A\u2C8C\u2C8E\u2C90\u2C92\u2C94\u2C96\u2C98\u2C9A\u2C9C\u2C9E\u2CA0\u2CA2\u2CA4\u2CA6\u2CA8\u2CAA\u2CAC\u2CAE\u2CB0\u2CB2\u2CB4\u2CB6\u2CB8\u2CBA\u2CBC\u2CBE\u2CC0\u2CC2\u2CC4\u2CC6\u2CC8\u2CCA\u2CCC\u2CCE\u2CD0\u2CD2\u2CD4\u2CD6\u2CD8\u2CDA\u2CDC\u2CDE\u2CE0\u2CE2\u2CEB\u2CED\u2CF2\uA640\uA642\uA644\uA646\uA648\uA64A\uA64C\uA64E\uA650\uA652\uA654\uA656\uA658\uA65A\uA65C\uA65E\uA660\uA662\uA664\uA666\uA668\uA66A\uA66C\uA680\uA682\uA684\uA686\uA688\uA68A\uA68C\uA68E\uA690\uA692\uA694\uA696\uA722\uA724\uA726\uA728\uA72A\uA72C\uA72E\uA732\uA734\uA736\uA738\uA73A\uA73C\uA73E\uA740\uA742\uA744\uA746\uA748\uA74A\uA74C\uA74E\uA750\uA752\uA754\uA756\uA758\uA75A\uA75C\uA75E\uA760\uA762\uA764\uA766\uA768\uA76A\uA76C\uA76E\uA779\uA77B\uA77D\uA77E\uA780\uA782\uA784\uA786\uA78B\uA78D\uA790\uA792\uA7A0\uA7A2\uA7A4\uA7A6\uA7A8\uA7AA\uFF21-\uFF3A\u0030-\u0039\u00B2\u00B3\u00B9\u00BC-\u00BE\u0660-\u0669\u06F0-\u06F9\u07C0-\u07C9\u0966-\u096F\u09E6-\u09EF\u09F4-\u09F9\u0A66-\u0A6F\u0AE6-\u0AEF\u0B66-\u0B6F\u0B72-\u0B77\u0BE6-\u0BF2\u0C66-\u0C6F\u0C78-\u0C7E\u0CE6-\u0CEF\u0D66-\u0D75\u0E50-\u0E59\u0ED0-\u0ED9\u0F20-\u0F33\u1040-\u1049\u1090-\u1099\u1369-\u137C\u16EE-\u16F0\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1946-\u194F\u19D0-\u19DA\u1A80-\u1A89\u1A90-\u1A99\u1B50-\u1B59\u1BB0-\u1BB9\u1C40-\u1C49\u1C50-\u1C59\u2070\u2074-\u2079\u2080-\u2089\u2150-\u2182\u2185-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2CFD\u3007\u3021-\u3029\u3038-\u303A\u3192-\u3195\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\uA620-\uA629\uA6E6-\uA6EF\uA830-\uA835\uA8D0-\uA8D9\uA900-\uA909\uA9D0-\uA9D9\uAA50-\uAA59\uABF0-\uABF9\uFF10-\uFF19])/g},{}],30:[function(require,module,exports){module.exports=/[^\u0041-\u005A\u0061-\u007A\u00AA\u00B5\u00BA\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u0527\u0531-\u0556\u0559\u0561-\u0587\u05D0-\u05EA\u05F0-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u08A0\u08A2-\u08AC\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0977\u0979-\u097F\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C33\u0C35-\u0C39\u0C3D\u0C58\u0C59\u0C60\u0C61\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D60\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F4\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1877\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191C\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19C1-\u19C7\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1CE9-\u1CEC\u1CEE-\u1CF1\u1CF5\u1CF6\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2183\u2184\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005\u3006\u3031-\u3035\u303B\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FCC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA697\uA6A0-\uA6E5\uA717-\uA71F\uA722-\uA788\uA78B-\uA78E\uA790-\uA793\uA7A0-\uA7AA\uA7F8-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA80-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uABC0-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC\u0030-\u0039\u00B2\u00B3\u00B9\u00BC-\u00BE\u0660-\u0669\u06F0-\u06F9\u07C0-\u07C9\u0966-\u096F\u09E6-\u09EF\u09F4-\u09F9\u0A66-\u0A6F\u0AE6-\u0AEF\u0B66-\u0B6F\u0B72-\u0B77\u0BE6-\u0BF2\u0C66-\u0C6F\u0C78-\u0C7E\u0CE6-\u0CEF\u0D66-\u0D75\u0E50-\u0E59\u0ED0-\u0ED9\u0F20-\u0F33\u1040-\u1049\u1090-\u1099\u1369-\u137C\u16EE-\u16F0\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1946-\u194F\u19D0-\u19DA\u1A80-\u1A89\u1A90-\u1A99\u1B50-\u1B59\u1BB0-\u1BB9\u1C40-\u1C49\u1C50-\u1C59\u2070\u2074-\u2079\u2080-\u2089\u2150-\u2182\u2185-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2CFD\u3007\u3021-\u3029\u3038-\u303A\u3192-\u3195\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\uA620-\uA629\uA6E6-\uA6EF\uA830-\uA835\uA8D0-\uA8D9\uA900-\uA909\uA9D0-\uA9D9\uAA50-\uAA59\uABF0-\uABF9\uFF10-\uFF19]+/g},{}],31:[function(require,module,exports){module.exports=/([\u0030-\u0039\u00B2\u00B3\u00B9\u00BC-\u00BE\u0660-\u0669\u06F0-\u06F9\u07C0-\u07C9\u0966-\u096F\u09E6-\u09EF\u09F4-\u09F9\u0A66-\u0A6F\u0AE6-\u0AEF\u0B66-\u0B6F\u0B72-\u0B77\u0BE6-\u0BF2\u0C66-\u0C6F\u0C78-\u0C7E\u0CE6-\u0CEF\u0D66-\u0D75\u0E50-\u0E59\u0ED0-\u0ED9\u0F20-\u0F33\u1040-\u1049\u1090-\u1099\u1369-\u137C\u16EE-\u16F0\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1946-\u194F\u19D0-\u19DA\u1A80-\u1A89\u1A90-\u1A99\u1B50-\u1B59\u1BB0-\u1BB9\u1C40-\u1C49\u1C50-\u1C59\u2070\u2074-\u2079\u2080-\u2089\u2150-\u2182\u2185-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2CFD\u3007\u3021-\u3029\u3038-\u303A\u3192-\u3195\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\uA620-\uA629\uA6E6-\uA6EF\uA830-\uA835\uA8D0-\uA8D9\uA900-\uA909\uA9D0-\uA9D9\uAA50-\uAA59\uABF0-\uABF9\uFF10-\uFF19])([^\u0030-\u0039\u00B2\u00B3\u00B9\u00BC-\u00BE\u0660-\u0669\u06F0-\u06F9\u07C0-\u07C9\u0966-\u096F\u09E6-\u09EF\u09F4-\u09F9\u0A66-\u0A6F\u0AE6-\u0AEF\u0B66-\u0B6F\u0B72-\u0B77\u0BE6-\u0BF2\u0C66-\u0C6F\u0C78-\u0C7E\u0CE6-\u0CEF\u0D66-\u0D75\u0E50-\u0E59\u0ED0-\u0ED9\u0F20-\u0F33\u1040-\u1049\u1090-\u1099\u1369-\u137C\u16EE-\u16F0\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1946-\u194F\u19D0-\u19DA\u1A80-\u1A89\u1A90-\u1A99\u1B50-\u1B59\u1BB0-\u1BB9\u1C40-\u1C49\u1C50-\u1C59\u2070\u2074-\u2079\u2080-\u2089\u2150-\u2182\u2185-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2CFD\u3007\u3021-\u3029\u3038-\u303A\u3192-\u3195\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\uA620-\uA629\uA6E6-\uA6EF\uA830-\uA835\uA8D0-\uA8D9\uA900-\uA909\uA9D0-\uA9D9\uAA50-\uAA59\uABF0-\uABF9\uFF10-\uFF19])/g},{}],32:[function(require,module,exports){var upperCase=require("upper-case"),snakeCase=require("snake-case");module.exports=function(string,locale){return upperCase(snakeCase(string,locale),locale)}},{"snake-case":60,"upper-case":61}],33:[function(require,module,exports){var undefined,hasOwn=Object.prototype.hasOwnProperty,toString=Object.prototype.toString,isPlainObject=function(obj){"use strict";if(!obj||"[object Object]"!==toString.call(obj))return!1;var has_own_constructor=hasOwn.call(obj,"constructor"),has_is_property_of_method=obj.constructor&&obj.constructor.prototype&&hasOwn.call(obj.constructor.prototype,"isPrototypeOf");if(obj.constructor&&!has_own_constructor&&!has_is_property_of_method)return!1;var key;for(key in obj);return key===undefined||hasOwn.call(obj,key)};module.exports=function extend(){"use strict";var options,name,src,copy,copyIsArray,clone,target=arguments[0],i=1,length=arguments.length,deep=!1;for("boolean"==typeof target?(deep=target,target=arguments[1]||{},i=2):("object"!=typeof target&&"function"!=typeof target||null==target)&&(target={});i<length;++i)if(options=arguments[i],null!=options)for(name in options)src=target[name],copy=options[name],target!==copy&&(deep&&copy&&(isPlainObject(copy)||(copyIsArray=Array.isArray(copy)))?(copyIsArray?(copyIsArray=!1,clone=src&&Array.isArray(src)?src:[]):clone=src&&isPlainObject(src)?src:{},target[name]=extend(deep,clone,copy)):copy!==undefined&&(target[name]=copy));return target}},{}],34:[function(require,module,exports){(function(global){"use strict";var base=require("./handlebars/base"),SafeString=require("./handlebars/safe-string").default,Exception=require("./handlebars/exception").default,Utils=require("./handlebars/utils"),runtime=require("./handlebars/runtime"),create=function(){var hb=new base.HandlebarsEnvironment;return Utils.extend(hb,base),hb.SafeString=SafeString,hb.Exception=Exception,hb.Utils=Utils,hb.escapeExpression=Utils.escapeExpression,hb.VM=runtime,hb.template=function(spec){return runtime.template(spec,hb)},hb},Handlebars=create();Handlebars.create=create;var root="undefined"!=typeof global?global:window,$Handlebars=root.Handlebars;Handlebars.noConflict=function(){root.Handlebars===Handlebars&&(root.Handlebars=$Handlebars)},Handlebars.default=Handlebars,exports.default=Handlebars}).call(this,"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{})},{"./handlebars/base":35,"./handlebars/exception":36,"./handlebars/runtime":37,"./handlebars/safe-string":38,"./handlebars/utils":39}],35:[function(require,module,exports){"use strict";function HandlebarsEnvironment(helpers,partials){this.helpers=helpers||{},this.partials=partials||{},registerDefaultHelpers(this)}function registerDefaultHelpers(instance){instance.registerHelper("helperMissing",function(){if(1!==arguments.length)throw new Exception("Missing helper: '"+arguments[arguments.length-1].name+"'")}),instance.registerHelper("blockHelperMissing",function(context,options){var inverse=options.inverse,fn=options.fn;if(context===!0)return fn(this);if(context===!1||null==context)return inverse(this);if(isArray(context))return context.length>0?(options.ids&&(options.ids=[options.name]),instance.helpers.each(context,options)):inverse(this);if(options.data&&options.ids){var data=createFrame(options.data);data.contextPath=Utils.appendContextPath(options.data.contextPath,options.name),options={data:data}}return fn(context,options)}),instance.registerHelper("each",function(context,options){function execIteration(key,i,last){data&&(data.key=key,data.index=i,data.first=0===i,data.last=!!last,contextPath&&(data.contextPath=contextPath+key)),ret+=fn(context[key],{data:data,blockParams:Utils.blockParams([context[key],key],[contextPath+key,null])})}if(!options)throw new Exception("Must pass iterator to #each");var data,contextPath,fn=options.fn,inverse=options.inverse,i=0,ret="";if(options.data&&options.ids&&(contextPath=Utils.appendContextPath(options.data.contextPath,options.ids[0])+"."),isFunction(context)&&(context=context.call(this)),options.data&&(data=createFrame(options.data)),context&&"object"==typeof context)if(isArray(context))for(var j=context.length;i<j;i++)execIteration(i,i,i===context.length-1);else{var priorKey;for(var key in context)context.hasOwnProperty(key)&&(priorKey&&execIteration(priorKey,i-1),priorKey=key,i++);priorKey&&execIteration(priorKey,i-1,!0)}return 0===i&&(ret=inverse(this)),ret}),instance.registerHelper("if",function(conditional,options){return isFunction(conditional)&&(conditional=conditional.call(this)),!options.hash.includeZero&&!conditional||Utils.isEmpty(conditional)?options.inverse(this):options.fn(this)}),instance.registerHelper("unless",function(conditional,options){return instance.helpers.if.call(this,conditional,{fn:options.inverse,inverse:options.fn,hash:options.hash})}),instance.registerHelper("with",function(context,options){isFunction(context)&&(context=context.call(this));var fn=options.fn;if(Utils.isEmpty(context))return options.inverse(this);if(options.data&&options.ids){var data=createFrame(options.data);data.contextPath=Utils.appendContextPath(options.data.contextPath,options.ids[0]),options={data:data}}return fn(context,options)}),instance.registerHelper("log",function(message,options){var level=options.data&&null!=options.data.level?parseInt(options.data.level,10):1;instance.log(level,message)}),instance.registerHelper("lookup",function(obj,field){return obj&&obj[field]})}var Utils=require("./utils"),Exception=require("./exception").default,VERSION="3.0.0";exports.VERSION=VERSION;var COMPILER_REVISION=6;exports.COMPILER_REVISION=COMPILER_REVISION;var REVISION_CHANGES={1:"<= 1.0.rc.2",2:"== 1.0.0-rc.3",3:"== 1.0.0-rc.4",4:"== 1.x.x",5:"== 2.0.0-alpha.x",6:">= 2.0.0-beta.1"};exports.REVISION_CHANGES=REVISION_CHANGES;var isArray=Utils.isArray,isFunction=Utils.isFunction,toString=Utils.toString,objectType="[object Object]";exports.HandlebarsEnvironment=HandlebarsEnvironment,HandlebarsEnvironment.prototype={constructor:HandlebarsEnvironment,logger:logger,log:log,registerHelper:function(name,fn){if(toString.call(name)===objectType){if(fn)throw new Exception("Arg not supported with multiple helpers");Utils.extend(this.helpers,name)}else this.helpers[name]=fn},unregisterHelper:function(name){delete this.helpers[name]},registerPartial:function(name,partial){if(toString.call(name)===objectType)Utils.extend(this.partials,name);else{if("undefined"==typeof partial)throw new Exception("Attempting to register a partial as undefined");this.partials[name]=partial}},unregisterPartial:function(name){delete this.partials[name]}};var logger={methodMap:{0:"debug",1:"info",2:"warn",3:"error"},DEBUG:0,INFO:1,WARN:2,ERROR:3,level:1,log:function(level,message){if("undefined"!=typeof console&&logger.level<=level){var method=logger.methodMap[level];(console[method]||console.log).call(console,message)}}};exports.logger=logger;var log=logger.log;exports.log=log;var createFrame=function(object){var frame=Utils.extend({},object);return frame._parent=object,frame};exports.createFrame=createFrame},{"./exception":36,"./utils":39}],36:[function(require,module,exports){"use strict";function Exception(message,node){var line,column,loc=node&&node.loc;loc&&(line=loc.start.line,column=loc.start.column,message+=" - "+line+":"+column);for(var tmp=Error.prototype.constructor.call(this,message),idx=0;idx<errorProps.length;idx++)this[errorProps[idx]]=tmp[errorProps[idx]];loc&&(this.lineNumber=line,this.column=column)}var errorProps=["description","fileName","lineNumber","message","name","number","stack"];Exception.prototype=new Error,exports.default=Exception},{}],37:[function(require,module,exports){"use strict";function checkRevision(compilerInfo){
var compilerRevision=compilerInfo&&compilerInfo[0]||1,currentRevision=COMPILER_REVISION;if(compilerRevision!==currentRevision){if(compilerRevision<currentRevision){var runtimeVersions=REVISION_CHANGES[currentRevision],compilerVersions=REVISION_CHANGES[compilerRevision];throw new Exception("Template was precompiled with an older version of Handlebars than the current runtime. Please update your precompiler to a newer version ("+runtimeVersions+") or downgrade your runtime to an older version ("+compilerVersions+").")}throw new Exception("Template was precompiled with a newer version of Handlebars than the current runtime. Please update your runtime to a newer version ("+compilerInfo[1]+").")}}function template(templateSpec,env){if(!env)throw new Exception("No environment passed to template");if(!templateSpec||!templateSpec.main)throw new Exception("Unknown template object: "+typeof templateSpec);env.VM.checkRevision(templateSpec.compiler);var invokePartialWrapper=function(partial,context,options){options.hash&&(context=Utils.extend({},context,options.hash)),partial=env.VM.resolvePartial.call(this,partial,context,options);var result=env.VM.invokePartial.call(this,partial,context,options);if(null==result&&env.compile&&(options.partials[options.name]=env.compile(partial,templateSpec.compilerOptions,env),result=options.partials[options.name](context,options)),null!=result){if(options.indent){for(var lines=result.split("\n"),i=0,l=lines.length;i<l&&(lines[i]||i+1!==l);i++)lines[i]=options.indent+lines[i];result=lines.join("\n")}return result}throw new Exception("The partial "+options.name+" could not be compiled when running in runtime-only mode")},container={strict:function(obj,name){if(!(name in obj))throw new Exception('"'+name+'" not defined in '+obj);return obj[name]},lookup:function(depths,name){for(var len=depths.length,i=0;i<len;i++)if(depths[i]&&null!=depths[i][name])return depths[i][name]},lambda:function(current,context){return"function"==typeof current?current.call(context):current},escapeExpression:Utils.escapeExpression,invokePartial:invokePartialWrapper,fn:function(i){return templateSpec[i]},programs:[],program:function(i,data,declaredBlockParams,blockParams,depths){var programWrapper=this.programs[i],fn=this.fn(i);return data||depths||blockParams||declaredBlockParams?programWrapper=program(this,i,fn,data,declaredBlockParams,blockParams,depths):programWrapper||(programWrapper=this.programs[i]=program(this,i,fn)),programWrapper},data:function(data,depth){for(;data&&depth--;)data=data._parent;return data},merge:function(param,common){var ret=param||common;return param&&common&&param!==common&&(ret=Utils.extend({},common,param)),ret},noop:env.VM.noop,compilerInfo:templateSpec.compiler},ret=function(context,options){options=options||{};var data=options.data;ret._setup(options),!options.partial&&templateSpec.useData&&(data=initData(context,data));var depths,blockParams=templateSpec.useBlockParams?[]:void 0;return templateSpec.useDepths&&(depths=options.depths?[context].concat(options.depths):[context]),templateSpec.main.call(container,context,container.helpers,container.partials,data,blockParams,depths)};return ret.isTop=!0,ret._setup=function(options){options.partial?(container.helpers=options.helpers,container.partials=options.partials):(container.helpers=container.merge(options.helpers,env.helpers),templateSpec.usePartial&&(container.partials=container.merge(options.partials,env.partials)))},ret._child=function(i,data,blockParams,depths){if(templateSpec.useBlockParams&&!blockParams)throw new Exception("must pass block params");if(templateSpec.useDepths&&!depths)throw new Exception("must pass parent depths");return program(container,i,templateSpec[i],data,0,blockParams,depths)},ret}function program(container,i,fn,data,declaredBlockParams,blockParams,depths){var prog=function(context,options){return options=options||{},fn.call(container,context,container.helpers,container.partials,options.data||data,blockParams&&[options.blockParams].concat(blockParams),depths&&[context].concat(depths))};return prog.program=i,prog.depth=depths?depths.length:0,prog.blockParams=declaredBlockParams||0,prog}function resolvePartial(partial,context,options){return partial?partial.call||options.name||(options.name=partial,partial=options.partials[partial]):partial=options.partials[options.name],partial}function invokePartial(partial,context,options){if(options.partial=!0,void 0===partial)throw new Exception("The partial "+options.name+" could not be found");if(partial instanceof Function)return partial(context,options)}function noop(){return""}function initData(context,data){return data&&"root"in data||(data=data?createFrame(data):{},data.root=context),data}var Utils=require("./utils"),Exception=require("./exception").default,COMPILER_REVISION=require("./base").COMPILER_REVISION,REVISION_CHANGES=require("./base").REVISION_CHANGES,createFrame=require("./base").createFrame;exports.checkRevision=checkRevision,exports.template=template,exports.program=program,exports.resolvePartial=resolvePartial,exports.invokePartial=invokePartial,exports.noop=noop},{"./base":35,"./exception":36,"./utils":39}],38:[function(require,module,exports){"use strict";function SafeString(string){this.string=string}SafeString.prototype.toString=SafeString.prototype.toHTML=function(){return""+this.string},exports.default=SafeString},{}],39:[function(require,module,exports){"use strict";function escapeChar(chr){return escape[chr]}function extend(obj){for(var i=1;i<arguments.length;i++)for(var key in arguments[i])Object.prototype.hasOwnProperty.call(arguments[i],key)&&(obj[key]=arguments[i][key]);return obj}function indexOf(array,value){for(var i=0,len=array.length;i<len;i++)if(array[i]===value)return i;return-1}function escapeExpression(string){return string&&string.toHTML?string.toHTML():null==string?"":string?(string=""+string,possible.test(string)?string.replace(badChars,escapeChar):string):string+""}function isEmpty(value){return!value&&0!==value||!(!isArray(value)||0!==value.length)}function blockParams(params,ids){return params.path=ids,params}function appendContextPath(contextPath,id){return(contextPath?contextPath+".":"")+id}var escape={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#x27;","`":"&#x60;"},badChars=/[&<>"'`]/g,possible=/[&<>"'`]/;exports.extend=extend;var toString=Object.prototype.toString;exports.toString=toString;var isFunction=function(value){return"function"==typeof value};isFunction(/x/)&&(isFunction=function(value){return"function"==typeof value&&"[object Function]"===toString.call(value)});var isFunction;exports.isFunction=isFunction;var isArray=Array.isArray||function(value){return!(!value||"object"!=typeof value)&&"[object Array]"===toString.call(value)};exports.isArray=isArray,exports.indexOf=indexOf,exports.escapeExpression=escapeExpression,exports.isEmpty=isEmpty,exports.blockParams=blockParams,exports.appendContextPath=appendContextPath},{}],40:[function(require,module,exports){module.exports=require("./dist/cjs/handlebars.runtime").default},{"./dist/cjs/handlebars.runtime":34}],41:[function(require,module,exports){module.exports=require("handlebars/runtime").default},{"handlebars/runtime":40}],42:[function(require,module,exports){"use strict";var repeating=require("repeating");module.exports=function(str,indent,count){if("string"!=typeof str||"string"!=typeof indent)throw new TypeError("`string` and `indent` should be strings");if(null!=count&&"number"!=typeof count)throw new TypeError("`count` should be a number");return indent=count>1?repeating(indent,count):indent,str.replace(/^(?!\s*$)/gm,indent)}},{repeating:43}],43:[function(require,module,exports){"use strict";var isFinite=require("is-finite");module.exports=function(str,n){if("string"!=typeof str)throw new TypeError("Expected a string as the first argument");if(n<0||!isFinite(n))throw new TypeError("Expected a finite positive number");var ret="";do 1&n&&(ret+=str),str+=str;while(n>>=1);return ret}},{"is-finite":44}],44:[function(require,module,exports){"use strict";module.exports=Number.isFinite||function(val){return"number"==typeof val&&val===val&&val!==1/0&&val!==-(1/0)}},{}],45:[function(require,module,exports){(function(Buffer){!function(root,stringify){"function"==typeof require&&"object"==typeof exports&&"object"==typeof module?module.exports=stringify():"function"==typeof define&&define.amd?define(function(){return stringify()}):root.javascriptStringify=stringify()}(this,function(){var ESCAPABLE=/[\\\'\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,META_CHARS={"\b":"\\b","\t":"\\t","\n":"\\n","\f":"\\f","\r":"\\r","'":"\\'",'"':'\\"',"\\":"\\\\"},escapeChar=function(char){var meta=META_CHARS[char];return meta||"\\u"+("0000"+char.charCodeAt(0).toString(16)).slice(-4)},RESERVED_WORDS={};"break else new var case finally return void catch for switch while continue function this with default if throw delete in try do instanceof typeof abstract enum int short boolean export interface static byte extends long super char final native synchronized class float package throws const goto private transient debugger implements protected volatile double import public let yield".split(" ").map(function(key){RESERVED_WORDS[key]=!0});var isValidVariableName=function(name){return!RESERVED_WORDS[name]&&/^[a-zA-Z_$][0-9a-zA-Z_$]*$/.test(name)},getGlobalVariable=function(value,indent,stringify){return"Function("+stringify("return this;")+")()"},OBJECT_TYPES={"[object Array]":function(array,indent,stringify){var values=array.map(function(value){return indent+stringify(value).split("\n").join("\n"+indent)}).join(indent?",\n":",");return indent&&values?"[\n"+values+"\n]":"["+values+"]"},"[object Object]":function(object,indent,stringify){if("function"==typeof Buffer&&Buffer.isBuffer(object))return"new Buffer("+stringify(object.toString())+")";var values=Object.keys(object).reduce(function(values,key){var value=stringify(object[key]);return void 0===value?values:(key=isValidVariableName(key)?key:stringify(key),value=String(value).split("\n").join("\n"+indent),values.push(indent+key+":"+(indent?" ":"")+value),values)},[]).join(indent?",\n":",");return indent&&values?"{\n"+values+"\n}":"{"+values+"}"},"[object Date]":function(date,indent,stringify){return"new Date("+date.getTime()+")"},"[object String]":function(string,indent,stringify){return"new String("+stringify(string.toString())+")"},"[object Number]":function(number,indent,stringify){return"new Number("+number+")"},"[object Boolean]":function(boolean,indent,stringify){return"new Boolean("+boolean+")"},"[object RegExp]":String,"[object Function]":String,"[object global]":getGlobalVariable,"[object Window]":getGlobalVariable},PRIMITIVE_TYPES={string:function(string){return"'"+string.replace(ESCAPABLE,escapeChar)+"'"},number:String,object:String,boolean:String,undefined:String},stringify=function(value,indent,stringify){if(Object(value)!==value)return PRIMITIVE_TYPES[typeof value](value,indent,stringify);var toString=OBJECT_TYPES[Object.prototype.toString.call(value)];return toString&&toString(value,indent,stringify)};return function(value,replacer,space){"string"!=typeof space&&(space=new Array(Math.max(0,0|space)+1).join(" "));var recurse=function(value,cache,next){if(!(cache.indexOf(value)>-1))return cache.push(value),next(value,space,function(value){return recurse(value,cache.slice(),next)})};return"function"==typeof replacer?recurse(value,[],function(value,space,next){return replacer(value,space,function(value){return stringify(value,space,next)})}):recurse(value,[],stringify)}})}).call(this,require("buffer").Buffer)},{buffer:23}],46:[function(require,module,exports){var LANGUAGES={tr:{regexp:/\u0130|\u0049|\u0049\u0307/g,map:{"İ":"i",I:"ı","İ":"i"}},az:{regexp:/[\u0130]/g,map:{"İ":"i",I:"ı","İ":"i"}},lt:{regexp:/[\u0049\u004A\u012E\u00CC\u00CD\u0128]/g,map:{I:"i̇",J:"j̇","Į":"į̇","Ì":"i̇̀","Í":"i̇́","Ĩ":"i̇̃"}}};module.exports=function(str,locale){var lang=LANGUAGES[locale];return str=null==str?"":String(str),lang&&(str=str.replace(lang.regexp,function(m){return lang.map[m]})),str.toLowerCase()}},{}],47:[function(require,module,exports){var http=require("http");http.METHODS?module.exports=http.METHODS.map(function(method){return method.toLowerCase()}):module.exports=["get","post","put","head","delete","options","trace","copy","lock","mkcol","move","purge","propfind","proppatch","unlock","report","mkactivity","checkout","merge","m-search","notify","subscribe","unsubscribe","patch","search","connect"]},{http:22}],48:[function(require,module,exports){"use strict";module.exports=function(obj,keys){var res={},i=0;if("object"!=typeof obj)return res;if("string"==typeof keys)return keys in obj&&(res[keys]=obj[keys]),res;for(var len=keys.length;len--;){var key=keys[i++];key in obj&&(res[key]=obj[key])}return res}},{}],49:[function(require,module,exports){arguments[4][28][0].apply(exports,arguments)},{"./vendor/camel-case-regexp":50,"./vendor/non-word-regexp":51,"./vendor/trailing-digit-regexp":52,dup:28,"lower-case":46}],50:[function(require,module,exports){arguments[4][29][0].apply(exports,arguments)},{dup:29}],51:[function(require,module,exports){arguments[4][30][0].apply(exports,arguments)},{dup:30}],52:[function(require,module,exports){arguments[4][31][0].apply(exports,arguments)},{dup:31}],53:[function(require,module,exports){var sentenceCase=require("sentence-case");module.exports=function(string,locale){return sentenceCase(string,locale,"-")}},{"sentence-case":49}],54:[function(require,module,exports){var upperCase=require("upper-case");module.exports=function(str,locale){return null==str?"":(str=String(str),upperCase(str.charAt(0),locale)+str.substr(1))}},{"upper-case":61}],55:[function(require,module,exports){var camelCase=require("camel-case"),upperCaseFirst=require("upper-case-first");module.exports=function(string,locale){return upperCaseFirst(camelCase(string,locale),locale)}},{"camel-case":27,"upper-case-first":54}],56:[function(require,module,exports){arguments[4][28][0].apply(exports,arguments)},{"./vendor/camel-case-regexp":57,"./vendor/non-word-regexp":58,"./vendor/trailing-digit-regexp":59,dup:28,"lower-case":46}],57:[function(require,module,exports){arguments[4][29][0].apply(exports,arguments)},{dup:29}],58:[function(require,module,exports){arguments[4][30][0].apply(exports,arguments)},{dup:30}],59:[function(require,module,exports){arguments[4][31][0].apply(exports,arguments)},{dup:31}],60:[function(require,module,exports){var sentenceCase=require("sentence-case");module.exports=function(str,locale){return sentenceCase(str,locale,"_")}},{"sentence-case":56}],61:[function(require,module,exports){var LANGUAGES={tr:{regexp:/[\u0069]/g,map:{i:"İ"}},az:{regexp:/[\u0069]/g,map:{i:"İ"}},lt:{regexp:/[\u0069\u006A\u012F]\u0307|\u0069\u0307[\u0300\u0301\u0303]/g,map:{"i̇":"I","j̇":"J","į̇":"Į","i̇̀":"Ì","i̇́":"Í","i̇̃":"Ĩ"}}};module.exports=function(str,locale){var lang=LANGUAGES[locale];return str=null==str?"":String(str),lang&&(str=str.replace(lang.regexp,function(m){return lang.map[m]})),str.toUpperCase()}},{}],62:[function(require,module,exports){exports.javascript=require("./javascript")},{"./javascript":4}]},{},[62])(62)}),void function(root,factory){"function"==typeof define&&define.amd?define(factory):"object"==typeof exports?module.exports=factory():root.resolveUrl=factory()}(this,function(){function resolveUrl(){var numUrls=arguments.length;if(0===numUrls)throw new Error("resolveUrl requires at least one argument; got none.");var base=document.createElement("base");if(base.href=arguments[0],1===numUrls)return base.href;var head=document.getElementsByTagName("head")[0];head.insertBefore(base,head.firstChild);for(var resolved,a=document.createElement("a"),index=1;index<numUrls;index++)a.href=arguments[index],resolved=a.href,base.href=resolved;return head.removeChild(base),resolved}return resolveUrl});